--
-- PostgreSQL database dump
--

-- Dumped from database version 12.8 (Ubuntu 12.8-0ubuntu0.20.04.1)
-- Dumped by pg_dump version 12.8 (Ubuntu 12.8-0ubuntu0.20.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: archive; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE archive WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect archive

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: archive; Type: DATABASE PROPERTIES; Schema: -; Owner: -
--

ALTER DATABASE archive SET default_transaction_isolation TO 'serializable';


\connect archive

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: internal_command_type; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.internal_command_type AS ENUM (
    'fee_transfer_via_coinbase',
    'fee_transfer',
    'coinbase'
);


--
-- Name: user_command_status; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.user_command_status AS ENUM (
    'applied',
    'failed'
);


--
-- Name: user_command_type; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.user_command_type AS ENUM (
    'payment',
    'delegation',
    'create_token',
    'create_account',
    'mint_tokens'
);


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: balances; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.balances (
    id integer NOT NULL,
    public_key_id integer NOT NULL,
    balance bigint NOT NULL
);


--
-- Name: balances_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.balances_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: balances_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.balances_id_seq OWNED BY public.balances.id;


--
-- Name: blocks; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks (
    id integer NOT NULL,
    state_hash text NOT NULL,
    parent_id integer,
    parent_hash text NOT NULL,
    creator_id integer NOT NULL,
    block_winner_id integer NOT NULL,
    snarked_ledger_hash_id integer NOT NULL,
    staking_epoch_data_id integer NOT NULL,
    next_epoch_data_id integer NOT NULL,
    ledger_hash text NOT NULL,
    height bigint NOT NULL,
    global_slot bigint NOT NULL,
    global_slot_since_genesis bigint NOT NULL,
    "timestamp" bigint NOT NULL
);


--
-- Name: blocks_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.blocks_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: blocks_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.blocks_id_seq OWNED BY public.blocks.id;


--
-- Name: blocks_internal_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks_internal_commands (
    block_id integer NOT NULL,
    internal_command_id integer NOT NULL,
    sequence_no integer NOT NULL,
    secondary_sequence_no integer NOT NULL,
    receiver_balance integer NOT NULL,
    receiver_account_creation_fee_paid bigint
);


--
-- Name: blocks_user_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks_user_commands (
    block_id integer NOT NULL,
    user_command_id integer NOT NULL,
    sequence_no integer NOT NULL,
    status public.user_command_status NOT NULL,
    failure_reason text,
    fee_payer_account_creation_fee_paid bigint,
    receiver_account_creation_fee_paid bigint,
    created_token bigint,
    fee_payer_balance integer NOT NULL,
    source_balance integer,
    receiver_balance integer
);


--
-- Name: epoch_data; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.epoch_data (
    id integer NOT NULL,
    seed text NOT NULL,
    ledger_hash_id integer NOT NULL
);


--
-- Name: epoch_data_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.epoch_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: epoch_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.epoch_data_id_seq OWNED BY public.epoch_data.id;


--
-- Name: internal_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.internal_commands (
    id integer NOT NULL,
    type public.internal_command_type NOT NULL,
    receiver_id integer NOT NULL,
    fee bigint NOT NULL,
    token bigint NOT NULL,
    hash text NOT NULL
);


--
-- Name: internal_commands_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.internal_commands_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: internal_commands_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.internal_commands_id_seq OWNED BY public.internal_commands.id;


--
-- Name: public_keys; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_keys (
    id integer NOT NULL,
    value text NOT NULL
);


--
-- Name: public_keys_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.public_keys_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: public_keys_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.public_keys_id_seq OWNED BY public.public_keys.id;


--
-- Name: snarked_ledger_hashes; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.snarked_ledger_hashes (
    id integer NOT NULL,
    value text NOT NULL
);


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.snarked_ledger_hashes_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.snarked_ledger_hashes_id_seq OWNED BY public.snarked_ledger_hashes.id;


--
-- Name: timing_info; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.timing_info (
    id integer NOT NULL,
    public_key_id integer NOT NULL,
    token bigint NOT NULL,
    initial_balance bigint NOT NULL,
    initial_minimum_balance bigint NOT NULL,
    cliff_time bigint NOT NULL,
    cliff_amount bigint NOT NULL,
    vesting_period bigint NOT NULL,
    vesting_increment bigint NOT NULL
);


--
-- Name: timing_info_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.timing_info_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: timing_info_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.timing_info_id_seq OWNED BY public.timing_info.id;


--
-- Name: user_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_commands (
    id integer NOT NULL,
    type public.user_command_type NOT NULL,
    fee_payer_id integer NOT NULL,
    source_id integer NOT NULL,
    receiver_id integer NOT NULL,
    fee_token bigint NOT NULL,
    token bigint NOT NULL,
    nonce bigint NOT NULL,
    amount bigint,
    fee bigint NOT NULL,
    valid_until bigint,
    memo text NOT NULL,
    hash text NOT NULL
);


--
-- Name: user_commands_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.user_commands_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_commands_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.user_commands_id_seq OWNED BY public.user_commands.id;


--
-- Name: balances id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances ALTER COLUMN id SET DEFAULT nextval('public.balances_id_seq'::regclass);


--
-- Name: blocks id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks ALTER COLUMN id SET DEFAULT nextval('public.blocks_id_seq'::regclass);


--
-- Name: epoch_data id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data ALTER COLUMN id SET DEFAULT nextval('public.epoch_data_id_seq'::regclass);


--
-- Name: internal_commands id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands ALTER COLUMN id SET DEFAULT nextval('public.internal_commands_id_seq'::regclass);


--
-- Name: public_keys id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys ALTER COLUMN id SET DEFAULT nextval('public.public_keys_id_seq'::regclass);


--
-- Name: snarked_ledger_hashes id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes ALTER COLUMN id SET DEFAULT nextval('public.snarked_ledger_hashes_id_seq'::regclass);


--
-- Name: timing_info id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info ALTER COLUMN id SET DEFAULT nextval('public.timing_info_id_seq'::regclass);


--
-- Name: user_commands id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands ALTER COLUMN id SET DEFAULT nextval('public.user_commands_id_seq'::regclass);


--
-- Data for Name: balances; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.balances (id, public_key_id, balance) FROM stdin;
1	1677	719000000000
2	1397	1439990000000
3	1397	1439940000000
4	1397	1439930000000
5	1397	1439880000000
6	1679	719000000000
7	1679	719120000000
8	1397	1439870000000
9	1397	1439820000000
10	1680	719000000000
11	1680	719060000000
12	1397	1439810000000
13	1397	1439760000000
14	1397	1439750000000
15	1681	719000000000
16	1681	719070000000
17	1397	1439740000000
18	1682	719000000000
19	1682	719010000000
20	1683	1439000000000
21	1683	1439010000000
22	43	66720000000000
23	43	66720010000000
24	1684	719000000000
25	1684	719010000000
26	1397	1439730000000
27	1683	2879010000000
28	1683	2879020000000
29	1637	720000000000
30	1637	720010000000
31	1397	1439720000000
32	1685	719000000000
33	1685	719010000000
34	1656	720000000000
35	1652	720000000000
36	1577	720000000000
37	1397	1438710000000
38	1678	0
39	1397	1438700000000
40	1686	719000000000
41	1686	719020000000
42	1397	1438690000000
43	1680	1439060000000
44	1680	1439070000000
45	1679	1439120000000
46	1679	1439130000000
47	1687	719000000000
48	1687	719010000000
49	1397	1438679999000
50	1678	1000
51	1397	1438669999000
52	1683	4319010000000
53	1683	4319030000000
54	1513	720000000000
55	1513	720020000000
56	1397	1438659999000
57	1397	1438649998000
58	1678	2000
59	1397	1438639997000
60	1678	3000
61	1656	1440000000000
62	1656	1440030000000
63	1397	1438629996000
64	1678	4000
65	1397	1438619995000
66	1678	5000
67	1671	720000000000
68	1671	720020000000
69	632	66720000000000
70	632	66720020000000
71	1397	1438609994000
72	1678	6000
73	1637	1440010000000
74	1637	1440020000000
75	1397	1438599993000
76	1678	7000
77	1397	1438589992000
78	1678	8000
79	1682	719020000000
80	1476	720000000000
81	1476	720020000000
82	1397	1438579991000
83	1678	9000
84	1688	719000000000
85	1688	719010000000
86	1634	720000000000
87	1634	720010000000
88	1397	1438569990000
89	1678	10000
90	1683	5759030000000
91	1683	5759040000000
92	1397	1438559989000
93	1678	11000
94	1683	7199040000000
95	1683	7199050000000
96	1474	720000000000
97	1474	720010000000
98	1397	1438549988000
99	1678	12000
100	1474	1440010000000
101	1474	1440020000000
102	1397	1438539987000
103	1678	13000
104	1397	1438529986000
105	1678	14000
106	1397	1438519985000
107	1678	15000
108	1397	1438509984000
109	1678	16000
110	55	66720000000000
111	55	66720030000000
112	1397	1438499983000
113	1678	17000
114	1397	1438489982000
115	1678	18000
116	1397	1438479981000
117	1678	19000
118	1677	1439000000000
119	1677	1439030000000
120	1397	1438469980000
121	1678	20000
122	1607	720000000000
123	1607	720010000000
124	1689	719000000000
125	1689	719010000000
126	1397	1438459979000
127	1678	21000
128	1680	2159070000000
129	1680	2159080000000
130	1637	2160020000000
131	1637	2160030000000
132	1397	1438449978000
133	1678	22000
134	1677	2159030000000
135	1677	2159040000000
136	1654	720000000000
137	1654	720010000000
138	1690	719000000000
139	1690	719010000000
140	1397	1438439977000
141	1678	23000
142	1447	720000000000
143	1447	720010000000
144	1546	720000000000
145	1546	720010000000
146	1547	720000000000
147	1547	720010000000
148	1397	1438429976000
149	1678	24000
150	1397	1438419975000
151	1678	25000
152	1559	720000000000
153	1559	720010000000
154	1397	1438409974000
155	1678	26000
156	1397	1438399973000
157	1678	27000
158	1688	719020000000
159	1573	720000000000
160	1573	720020000000
161	1397	1438389972000
162	1678	28000
163	1602	720000000000
164	1602	720010000000
165	1397	1438379971000
166	1678	29000
167	1447	1440010000000
168	1447	1440020000000
169	1691	719000000000
170	1691	719010000000
171	1397	1438369970000
172	1678	30000
173	1683	8639050000000
174	1683	8639060000000
175	1397	1438359969000
176	1678	31000
177	1683	10079060000000
178	1683	10079070000000
179	1587	720000000000
180	1587	720010000000
181	1692	719000000000
182	1692	719010000000
183	1397	1438349968000
184	1678	32000
185	1444	720000000000
186	1444	720010000000
196	1693	719000000000
197	1693	719020000000
204	1397	1438289962000
205	1678	38000
206	1596	720000000000
207	1596	720010000000
214	1397	1438269960000
215	1678	40000
216	1694	719000000000
217	1694	719010000000
218	1397	1438259959000
219	1678	41000
220	1397	1438249958000
221	1678	42000
222	1397	1438239957000
223	1678	43000
224	1613	720000000000
225	1613	720020000000
234	1397	1438209954000
235	1678	46000
236	1649	720000000000
237	1649	720010000000
187	1677	2879040000000
188	1677	2879050000000
189	1397	1438339967000
190	1678	33000
191	1397	1438329966000
192	1678	34000
193	1397	1438319965000
194	1678	35000
195	1683	10079080000000
208	311	66720000000000
209	311	66720010000000
226	1397	1438229956000
227	1678	44000
228	1397	1438219955000
229	1678	45000
230	1458	720000000000
231	1458	720020000000
238	1397	1438199953000
239	1678	47000
240	1504	720000000000
241	1504	720010000000
242	1397	1438189952000
243	1678	48000
244	1397	1438179951000
245	1678	49000
246	1695	719000000000
247	1695	719020000000
198	1397	1438309964000
199	1678	36000
200	1693	719010000000
201	1397	1438299963000
202	1678	37000
203	1677	2159050000000
210	1397	1438279961000
211	1678	39000
212	1622	720000000000
213	1622	720010000000
232	1623	720000000000
233	1623	720020000000
248	1397	1438169950000
249	1678	50000
250	1696	719000000000
251	1696	719010000000
252	1397	1438159949000
253	1678	51000
254	1624	720000000000
255	1624	720010000000
256	1397	1438149948000
257	1678	52000
258	1397	1438139947000
259	1678	53000
260	1397	1438129946000
261	1678	54000
262	1677	3599050000000
263	1677	3599080000000
264	311	67440010000000
265	311	67440040000000
266	1397	1438119945000
267	1678	55000
268	1397	1438109944000
269	1678	56000
270	1671	1440020000000
271	1671	1440040000000
272	1397	1438099943000
273	1678	57000
274	1623	720010000000
275	1397	1438089942000
276	1678	58000
277	1422	720000000000
278	1422	720010000000
279	1397	1438079941000
280	1678	59000
281	1397	1438069940000
282	1678	60000
283	470	66720000000000
284	470	66720020000000
285	1504	719000000000
286	1697	0
287	1397	1438059939000
288	1678	61000
289	1683	11519080000000
290	1683	11519100000000
291	1677	3599070000000
292	1698	719000000000
293	1698	719020000000
294	1397	1438049938000
295	1678	62000
296	1489	720000000000
297	1489	720010000000
298	1397	1438039937000
299	1678	63000
300	1397	1438029936000
301	1678	64000
302	1397	1438019935000
303	1678	65000
304	369	66720000000000
305	369	66720030000000
306	1397	1438009934000
307	1678	66000
308	1696	1439010000000
309	1696	1439020000000
310	1699	719000000000
311	1699	719010000000
312	1700	719000000000
313	1700	719010000000
314	1474	2160020000000
315	1474	2160030000000
316	1397	1437999933000
317	1678	67000
318	1440	720000000000
319	1440	720010000000
320	1397	1437989932000
321	1678	68000
322	1397	1437979931000
323	1678	69000
324	1397	1437969930000
325	1678	70000
326	1701	719000000000
327	1701	719030000000
328	1685	1439010000000
329	1685	1439040000000
330	1397	1437959929000
331	1678	71000
332	1397	1437949928000
333	1678	72000
334	1504	717990000000
335	1697	1000000000
336	1688	719030000000
337	1699	1439010000000
338	1699	1439040000000
339	1559	720030000000
340	1397	1437939927000
341	1678	73000
342	1397	1437929926000
343	1678	74000
344	1397	1437919925000
345	1678	75000
346	1679	1439140000000
347	1397	1437909924000
348	1678	76000
349	1397	1437899923000
350	1678	77000
351	1683	12959100000000
352	1683	12959120000000
353	1419	720000000000
354	1419	720020000000
355	1397	1437889922000
356	1678	78000
357	1677	3599060000000
358	1397	1437879921000
359	1678	79000
360	470	67440020000000
361	470	67440030000000
362	1693	1439010000000
363	1693	1439020000000
364	1702	719000000000
365	1702	719010000000
366	1703	719000000000
367	1703	719010000000
368	1397	1437869920000
369	1678	80000
370	1397	1437859919000
371	1678	81000
372	1397	1437849918000
373	1678	82000
374	1397	1437839917000
375	1678	83000
376	369	67440030000000
377	369	67440070000000
378	1397	1437829916000
379	1678	84000
380	1599	720000000000
381	1599	720010000000
382	1685	1439020000000
383	1397	1437819915000
384	1678	85000
385	1683	12959110000000
386	1522	720000000000
387	1522	720010000000
388	1397	1437809914000
389	1678	86000
390	1656	2160030000000
391	1656	2160040000000
392	1397	1437799913000
393	1678	87000
394	1397	1437789912000
395	1678	88000
396	1397	1437779911000
397	1678	89000
398	1571	720000000000
399	1571	720030000000
400	1704	719000000000
401	1704	719030000000
402	1593	720000000000
403	1593	720030000000
404	1397	1437769910000
405	1678	90000
406	1397	1437759909000
407	1678	91000
408	1397	1437749908000
409	1678	92000
410	1657	720000000000
411	1657	720030000000
412	1397	1437739907000
413	1678	93000
414	1571	10000000
415	1571	720010000000
416	1397	1437729906000
417	1678	94000
418	1397	1437719905000
419	1678	95000
420	1694	1439010000000
421	1694	1439030000000
422	1637	2160040000000
423	1397	1437709904000
424	1678	96000
425	1397	1437699903000
426	1678	97000
427	1683	14399110000000
428	1683	14399130000000
429	1397	1437689902000
430	1678	98000
431	1679	2159140000000
432	1679	2159150000000
433	1397	1437679901000
434	1678	99000
435	1705	719000000000
436	1705	719010000000
437	1397	1437669900000
438	1678	100000
439	1397	1437659899000
440	1678	101000
441	1696	1439030000000
442	1692	1439010000000
443	1692	1439030000000
444	1397	1437649898000
445	1678	102000
446	1679	2879150000000
447	1679	2879160000000
448	1695	1439020000000
449	1695	1439030000000
450	1397	1437639897000
451	1678	103000
452	1397	1437629896000
453	1678	104000
454	1474	2880030000000
455	1474	2880050000000
456	1559	1440030000000
457	1559	1440050000000
458	1397	1437619895000
459	1678	105000
460	1397	1437609894000
461	1678	106000
462	1671	2160040000000
463	1671	2160050000000
464	1397	1437599893000
465	1678	107000
466	1546	1440010000000
467	1546	1440020000000
468	1397	1437589892000
469	1678	108000
470	1560	720000000000
471	1560	720010000000
472	1397	1437579891000
473	1678	109000
474	1397	1437569890000
475	1678	110000
476	1683	15839130000000
477	1683	15839140000000
478	1397	1437559889000
479	1678	111000
480	1397	1437549888000
481	1678	112000
482	1546	2160020000000
483	1546	2160040000000
484	1509	720000000000
485	1509	720020000000
486	1690	1439010000000
487	1690	1439030000000
488	1397	1437539887000
489	1678	113000
490	1397	1437529886000
491	1678	114000
492	1679	3599160000000
493	1679	3599170000000
494	1624	1440010000000
495	1624	1440020000000
496	1397	1437519885000
497	1678	115000
498	1683	17279140000000
499	1683	17279150000000
500	1397	1437509884000
501	1678	116000
502	1397	1437499883000
503	1678	117000
504	1637	2880030000000
505	1637	2880050000000
506	1397	1437489882000
507	1678	118000
508	1397	1437479881000
509	1678	119000
510	1397	1437469880000
511	1678	120000
512	1397	1437459879000
513	1678	121000
514	1706	719000000000
515	1706	719040000000
516	1692	2159030000000
517	1692	2159070000000
518	1397	1437449878000
519	1678	122000
520	1397	1437439877000
521	1678	123000
522	1397	1437429876000
523	1678	124000
524	1457	720000000000
525	1457	720030000000
526	1397	1437419875000
527	1678	125000
528	1397	1437409874000
529	1678	126000
530	369	68160070000000
531	369	68160090000000
532	1652	720020000000
533	1518	720000000000
534	1518	720020000000
535	1397	1437399873000
536	1678	127000
537	1397	1437389872000
538	1678	128000
539	1681	1439070000000
540	1681	1439090000000
541	1397	1437379871000
542	1678	129000
543	1683	18719150000000
544	1683	18719160000000
545	1397	1437369870000
546	1678	130000
547	1397	1437359869000
548	1678	131000
549	1397	1437349868000
550	1678	132000
551	1458	1440020000000
552	1458	1440050000000
553	1397	1437339867000
554	1678	133000
555	1677	4319060000000
556	1677	4319070000000
557	1705	716910000000
558	1707	1000000000
559	1397	1437329866000
560	1678	134000
561	1397	1437319865000
562	1678	135000
563	1397	1437309864000
564	1678	136000
565	1708	719000000000
566	1708	719130000000
567	1396	720000000000
568	1396	720130000000
569	1690	1439140000000
570	1397	1437299863000
571	1678	137000
572	1709	719000000000
573	1709	719010000000
574	1397	1437289862000
575	1678	138000
576	1397	1437279861000
577	1678	139000
578	1677	5039070000000
579	1677	5039090000000
580	1701	1439030000000
581	1701	1439050000000
582	1397	1437269860000
583	1678	140000
584	1683	20159160000000
585	1683	20159170000000
586	641	66720000000000
587	641	66720010000000
588	1397	1437259859000
589	1678	141000
590	1679	4319170000000
591	1679	4319180000000
592	1397	1437249858000
593	1678	142000
594	1458	2160050000000
595	1458	2160060000000
596	1397	1437239857000
597	1678	143000
598	1680	2879080000000
599	1680	2879090000000
600	1397	1437229856000
601	1678	144000
602	1467	720000000000
603	1467	720010000000
604	1397	1437219855000
605	1678	145000
606	1681	2159090000000
607	1681	2159100000000
608	1397	1437209854000
609	1678	146000
610	1397	1437199853000
611	1678	147000
612	1695	1439040000000
613	1397	1437189852000
614	1678	148000
615	1683	18719170000000
616	1397	1437179851000
617	1678	149000
618	1397	1437169850000
619	1678	150000
620	1683	20159190000000
621	1701	719040000000
622	1701	1439040000000
623	1701	1439060000000
624	1397	1437159849000
625	1678	151000
626	1397	1437149848000
627	1678	152000
628	1702	719020000000
629	1703	719020000000
630	1397	1437139847000
631	1678	153000
632	1677	5759090000000
633	1677	5759100000000
634	1440	1440010000000
635	1440	1440020000000
636	1489	1440010000000
637	1489	1440020000000
638	1692	2879070000000
639	1397	1437129846000
640	1678	154000
641	1549	720000000000
642	1549	720010000000
643	1710	719000000000
644	1710	719010000000
645	1692	3599070000000
646	1692	3599080000000
647	1397	1437119845000
648	1678	155000
649	1680	3599090000000
650	1680	3599100000000
651	1397	1437109844000
652	1678	156000
653	1668	720000000000
654	1668	720010000000
655	298	66720000000000
656	298	66720010000000
657	1611	720000000000
658	1611	720010000000
659	1397	1437099843000
660	1678	157000
661	1541	720000000000
662	1541	720010000000
663	1397	1437089842000
664	1678	158000
665	1397	1437079841000
666	1678	159000
667	1637	3600050000000
668	1637	3600070000000
669	1397	1437069840000
670	1678	160000
671	1711	719000000000
672	1711	719010000000
673	1506	720000000000
674	1506	720010000000
675	1397	1437059839000
676	1678	161000
677	1649	1440010000000
678	1649	1440020000000
679	1601	720000000000
680	1601	720010000000
681	1397	1437049838000
682	1678	162000
683	1559	2160050000000
684	1559	2160060000000
685	1397	1437039837000
686	1678	163000
687	1397	1437029836000
688	1678	164000
689	1444	1440010000000
690	1444	1440030000000
691	1701	2159060000000
692	1701	2159080000000
693	1397	1437019835000
694	1678	165000
695	1688	1439010000000
696	1688	1439020000000
697	1623	1440010000000
698	1623	1440020000000
699	1397	1437009834000
700	1678	166000
701	1686	1439020000000
702	1686	1439030000000
703	1397	1436999833000
704	1678	167000
705	1397	1436989832000
706	1678	168000
707	1685	2159020000000
708	1685	2159040000000
709	1397	1436979831000
710	1678	169000
711	1397	1436969830000
712	1678	170000
713	1710	719030000000
714	1397	1436959829000
715	1678	171000
716	44	66720000000000
717	44	66720010000000
718	1397	1436949828000
719	1678	172000
720	1677	6479100000000
721	1677	6479110000000
722	1397	1436939827000
723	1678	173000
724	700	66720000000000
725	700	66720010000000
726	1681	2879100000000
727	1681	2879110000000
728	1397	1436929826000
729	1678	174000
730	1668	1440010000000
731	1668	1440020000000
732	1695	2159040000000
733	1695	2159050000000
734	1397	1436919825000
735	1678	175000
736	1699	1439020000000
737	1397	1436909824000
738	1678	176000
739	1610	720000000000
740	1610	720010000000
741	1397	1436899823000
742	1678	177000
743	1677	7199110000000
744	1677	7199120000000
745	1651	0
746	1397	1436889822000
747	1678	178000
748	1560	1440010000000
749	1560	1440030000000
750	1601	720020000000
751	1397	1436879821000
752	1678	179000
753	1682	710010000000
754	1712	7990000000
755	1573	1440020000000
756	1573	1440040000000
757	1397	1436869820000
758	1678	180000
759	484	66720000000000
760	484	66720010000000
761	1397	1436859819000
762	1678	181000
763	484	67440010000000
764	484	67440020000000
765	1541	1440010000000
766	1541	1440020000000
767	1397	1436849818000
768	1678	182000
769	1397	1436839817000
770	1678	183000
771	1693	1439030000000
772	1397	1436829816000
773	1678	184000
774	1397	1436819815000
775	1678	185000
776	1683	20159180000000
777	1397	1436809814000
778	1678	186000
779	1397	1436799813000
780	1678	187000
781	1683	21599180000000
782	1683	21599200000000
783	1672	720000000000
784	1672	720020000000
785	700	66720020000000
786	1397	1436789812000
787	1678	188000
788	1448	720000000000
789	1448	720010000000
790	1397	1436779811000
791	1678	189000
792	1654	1440010000000
793	1654	1440020000000
794	1397	1436769810000
795	1678	190000
796	1683	23039200000000
797	1683	23039210000000
798	1471	720000000000
799	1471	720010000000
825	1555	720000000000
827	1617	0
828	1397	1436679801000
829	1678	199000
830	1397	1436669800000
831	1678	200000
832	1397	1436659799000
833	1678	201000
834	1397	1436649798000
835	1678	202000
836	1694	2159030000000
837	1694	2159080000000
844	1397	1436619795000
845	1678	205000
850	344	66720000000000
851	344	66720010000000
800	1712	7890000000
801	1397	1436759809000
802	1678	191000
803	1397	1436749808000
804	1678	192000
805	1397	1436739807000
806	1678	193000
807	596	66720000000000
808	596	66720130000000
817	1683	23039220000000
818	1397	1436709804000
819	1678	196000
820	1397	1436699803000
821	1678	197000
822	1397	1436689802000
823	1678	198000
824	1677	7199140000000
838	1397	1436639797000
839	1678	203000
840	1683	24479220000000
841	1683	24479230000000
842	1397	1436629796000
843	1678	204000
848	1633	720000000000
849	1633	720010000000
856	369	68160080000000
809	1456	720000000000
810	1456	720130000000
811	1397	1436729806000
812	1678	194000
813	1397	1436719805000
814	1678	195000
815	1679	5039180000000
816	1679	5039200000000
826	1714	719000000000
846	1703	1439010000000
847	1703	1439020000000
852	1397	1436609794000
853	1678	206000
854	1683	25919230000000
855	1683	25919240000000
857	1397	1436599793000
858	1678	207000
859	1397	1436589792000
860	1678	208000
861	1397	1436579791000
862	1678	209000
863	1397	1436569790000
864	1678	210000
865	1694	2158979000000
866	56	66000100000000
867	1694	2878979000000
868	1694	2879000000000
869	1695	2879050000000
870	1695	2879071000000
871	1397	1436559789000
872	1678	211000
873	171	66720000000000
874	171	66720010000000
875	1601	1440020000000
876	1601	1440030000000
877	1397	1436549788000
878	1678	212000
879	1677	7919140000000
880	1677	7919150000000
881	1397	1436539787000
882	1678	213000
883	1571	1440000000000
884	1571	1440010000000
885	1714	719010000000
886	1397	1436529786000
887	1678	214000
888	1677	8639150000000
889	1677	8639160000000
890	1576	720000000000
891	1576	720010000000
892	1397	1436519785000
893	1678	215000
894	1693	2159030000000
895	1693	2159040000000
896	1397	1436509784000
897	1678	216000
898	1445	720000000000
899	1445	720010000000
900	1455	720000000000
901	1397	1436499783000
902	1678	217000
903	1577	720010000000
904	1397	1436489782000
905	1678	218000
906	1637	4320070000000
907	1637	4320080000000
908	1397	1436479781000
909	1678	219000
910	1680	4319100000000
911	1680	4319110000000
912	1683	27359240000000
913	1683	27359250000000
914	1715	719000000000
915	1715	719010000000
916	1549	1440010000000
917	1549	1440020000000
918	1397	1436469780000
919	1678	220000
920	606	66720000000000
921	606	66720010000000
922	1397	1436459779000
923	1678	221000
924	1397	1436449778000
925	1678	222000
926	1594	720000000000
927	1594	720020000000
928	1397	1436439777000
929	1678	223000
930	149	66720000000000
931	149	66720010000000
932	1397	1436429776000
933	1678	224000
934	1716	719000000000
935	1716	719010000000
936	1397	1436419775000
937	1678	225000
938	1594	1440020000000
939	1594	1440030000000
940	1397	1436409774000
941	1678	226000
942	1397	1436399773000
943	1678	227000
944	1637	4320090000000
945	1397	1436389772000
946	1678	228000
947	1397	1436379771000
948	1678	229000
949	1397	1436369770000
950	1678	230000
951	1457	1440030000000
952	1457	1440060000000
953	1677	9359160000000
954	1677	9359190000000
955	1715	1439010000000
956	1715	1439040000000
957	1397	1436359769000
958	1678	231000
959	1397	1436349768000
960	1678	232000
961	311	68160040000000
962	311	68160050000000
963	1504	716980000000
964	1697	2000000000
965	1397	1436339767000
966	1678	233000
967	1397	1436329766000
968	1678	234000
969	1693	2159060000000
970	1397	1436319765000
971	1678	235000
972	1504	616970000000
973	1697	102000000000
974	1397	1436309764000
975	1678	236000
976	1397	1436299763000
977	1678	237000
978	1397	1436289762000
979	1678	238000
980	1717	719000000000
981	1717	719050000000
982	1397	1436279761000
983	1678	239000
984	1504	516969000000
985	1697	202000000000
986	1683	28799250000000
987	1683	28799261000000
988	1710	1439030000000
989	1710	1439041000000
990	1559	2880060000000
991	1559	2880071000000
992	1397	1436269760000
993	1678	240000
994	1685	2879040000000
995	1685	2879050000000
996	1397	1436259759000
997	1678	241000
998	1397	1436249758000
999	1678	242000
1000	1677	9359170000000
1001	1695	2158950000000
1002	152	66000000000000
1003	1397	1436239757000
1004	1678	243000
1005	1682	1430010000000
1006	1682	1430120000000
1007	1397	1436229756000
1008	1678	244000
1009	1397	1436219755000
1010	1678	245000
1011	1683	30239261000000
1012	1683	30239281000000
1013	1718	719000000000
1014	1718	719020000000
1015	1555	1440000000000
1016	1555	1440020000000
1017	1397	1436209754000
1018	1678	246000
1019	1397	1436199753000
1020	1678	247000
1021	1504	416968000000
1022	1697	302000000000
1023	1688	2159020000000
1024	1688	2159031000000
1025	1677	10079170000000
1026	1677	10079181000000
1027	1692	4319080000000
1028	1692	4319091000000
1029	1397	1436189752000
1030	1678	248000
1031	1683	31679281000000
1032	1683	31679291000000
1039	1397	1436159749000
1040	1678	251000
1041	1672	720010000000
1042	1397	1436149748000
1043	1678	252000
1044	1397	1436139747000
1045	1678	253000
1046	1683	33119291000000
1047	1683	33119311000000
1050	1693	2879060000000
1051	1693	2879080000000
1052	1397	1436129746000
1053	1678	254000
1054	1397	1436119745000
1055	1678	255000
1056	1677	10799181000000
1057	1677	10799201000000
1064	1397	1436099743000
1065	1678	257000
1066	1440	2160020000000
1067	1440	2160030000000
1074	1685	3599050000000
1075	1685	3599060000000
1082	1397	1436069740000
1083	1678	260000
1084	1397	1436059739000
1085	1678	261000
1094	1397	1436039737000
1095	1678	263000
1096	1397	1436029736000
1097	1678	264000
1104	1397	1436009734000
1105	1678	266000
1106	1397	1435999733000
1107	1678	267000
1108	1504	316967000000
1109	1697	402000000000
1110	1683	34559301000000
1111	1683	34559322000000
1115	1397	1435989732000
1116	1678	268000
1117	1677	11519201000000
1118	1677	11519211000000
1130	1397	1435959729000
1131	1678	271000
1132	1679	5759201000000
1133	1679	5759211000000
1137	1463	720010000000
1147	1682	1428100000000
1148	622	66002000000000
1149	1397	1435929726000
1150	1678	274000
1151	1397	1435919725000
1152	1678	275000
1153	1684	1439010000000
1154	1684	1439040000000
1033	1719	719000000000
1034	1719	719010000000
1062	1516	720000000000
1063	1516	720010000000
1072	606	67440010000000
1073	606	67440020000000
1080	563	66720000000000
1081	563	66720010000000
1088	1692	4319100000000
1089	1397	1436049738000
1090	1678	262000
1091	1683	33119301000000
1098	1637	5040090000000
1099	1637	5040110000000
1112	1679	5039201000000
1119	1397	1435979731000
1120	1678	269000
1121	1683	34559311000000
1134	1657	1440030000000
1135	1657	1440040000000
1138	1682	1430110000000
1139	1503	0
1140	1397	1435949728000
1141	1678	272000
1142	1397	1435939727000
1143	1678	273000
1144	1677	12239211000000
1145	1677	12239241000000
1035	1397	1436179751000
1036	1678	249000
1037	1397	1436169750000
1038	1678	250000
1048	42	66720000000000
1049	42	66720020000000
1058	1397	1436109744000
1059	1678	256000
1060	1536	720000000000
1061	1536	720010000000
1068	1397	1436089742000
1069	1678	258000
1070	1599	1440010000000
1071	1599	1440020000000
1076	1397	1436079741000
1077	1678	259000
1078	1716	1439010000000
1079	1716	1439020000000
1086	55	67440030000000
1087	55	67440050000000
1092	1692	5039100000000
1093	1692	5039110000000
1100	1397	1436019735000
1101	1678	265000
1102	1699	2159040000000
1103	1699	2159050000000
1113	1448	1440010000000
1114	1448	1440031000000
1122	1397	1435969730000
1123	1678	270000
1124	1613	719010000000
1125	1720	0
1126	1613	718000000000
1127	1721	0
1128	1426	720000000000
1129	1426	720030000000
1136	1463	720000000000
1146	1448	1440040000000
1155	1560	1440040000000
1156	622	66001980000000
1157	1397	1435909724000
1158	1678	276000
1159	1397	1435899723000
1160	1678	277000
1161	1397	1435889722000
1162	1678	278000
1163	1689	1439010000000
1164	1689	1439060000000
1165	1397	1435879721000
1166	1678	279000
1167	1397	1435869720000
1168	1678	280000
1169	1683	35999311000000
1170	1683	35999331000000
1171	1560	2160040000000
1172	1560	2160060000000
1173	1397	1435859719000
1174	1678	281000
1175	1610	1440010000000
1176	1610	1440020000000
1177	1682	1427090000000
1178	622	66002980000000
1179	1397	1435849718000
1180	1678	282000
1181	1683	37439331000000
1182	1683	37439351000000
1183	1455	720010000000
1184	1397	1435839717000
1185	1678	283000
1186	1677	12239221000000
1187	1681	3599110000000
1188	1681	3599120000000
1189	1397	1435829716000
1190	1678	284000
1191	1397	1435819715000
1192	1678	285000
1193	1683	38879351000000
1194	1683	38879371000000
1195	1396	720020000000
1196	641	67440010000000
1197	641	67440030000000
1198	1397	1435809714000
1199	1678	286000
1200	1397	1435799713000
1201	1678	287000
1202	1509	1440020000000
1203	1509	1440040000000
1204	1710	718930000000
1205	1507	0
1206	1397	1435789712000
1207	1678	288000
1208	44	67440010000000
1209	44	67440120000000
1210	1397	1435779711000
1211	1678	289000
1212	1683	38879361000000
1213	1397	1435769710000
1214	1678	290000
1215	1524	720000000000
1216	1524	720010000000
1217	1397	1435759709000
1218	1678	291000
1219	1536	1440010000000
1220	1536	1440020000000
1221	1397	1435749708000
1222	1678	292000
1223	1397	1435739707000
1224	1678	293000
1225	1652	719010000000
1226	1722	0
1227	1652	718500000000
1228	443	66000500000000
1229	1679	5759241000000
1230	1397	1435729706000
1231	1678	294000
1232	1723	719000000000
1233	1723	719010000000
1234	1397	1435719705000
1235	1678	295000
1236	1637	5760110000000
1237	1637	5760120000000
1238	1397	1435709704000
1239	1678	296000
1240	1677	12959221000000
1241	1677	12959231000000
1242	1684	1439020000000
1243	149	67440010000000
1244	149	67440020000000
1245	1397	1435699703000
1246	1678	297000
1247	1716	719020000000
1248	1397	1435689702000
1249	1678	298000
1250	1624	2000000000
1251	1722	718000000000
1252	1577	2000000000
1253	1722	1436000000000
1254	1652	490000000
1255	1722	2154000000000
1256	1716	1439060000000
1257	1397	1435679701000
1258	1678	299000
1259	1677	13679231000000
1260	1677	13679241000000
1261	1397	1435669700000
1262	1678	300000
1263	1722	2153990000000
1264	596	66720020000000
1265	1683	40319361000000
1266	1683	40319381000000
1267	1643	720000000000
1268	1643	720020000000
1269	1397	1435659699000
1270	1678	301000
1271	1673	720000000000
1272	1673	720010000000
1273	1397	1435649698000
1274	1678	302000
1275	1677	14399241000000
1276	1677	14399251000000
1277	1724	719000000000
1278	1724	719010000000
1279	1397	1435639697000
1280	1678	303000
1281	1397	1435629696000
1282	1678	304000
1283	1508	720000000000
1284	1508	720010000000
1285	1685	4319060000000
1286	1685	4319070000000
1287	1397	1435619695000
1288	1678	305000
1289	1397	1435609694000
1290	1678	306000
1291	1688	2159040000000
1292	1607	1440010000000
1293	1607	1440030000000
1294	1476	1440020000000
1295	1476	1440040000000
1296	1397	1435599693000
1297	1678	307000
1298	1397	1435589692000
1299	1678	308000
1300	1397	1435579691000
1301	1678	309000
1302	1689	2159060000000
1303	1689	2159090000000
1304	1601	2160030000000
1305	1601	2160060000000
1322	1683	41759381000000
1323	1683	41759401000000
1324	1723	1439010000000
1325	1723	1439030000000
1306	1397	1435569690000
1307	1678	310000
1308	1397	1435559689000
1309	1678	311000
1310	1637	6480120000000
1311	1637	6480140000000
1312	1397	1435549688000
1313	1678	312000
1314	1397	1435539687000
1315	1678	313000
1316	1571	2160010000000
1317	1571	2160030000000
1318	1397	1435529686000
1319	1678	314000
1320	443	66000490000000
1321	1677	14399261000000
1326	1397	1435519685000
1327	1678	315000
1328	1555	1440010000000
1329	1397	1435509684000
1330	1678	316000
1331	1397	1435499683000
1332	1678	317000
1333	1688	2879040000000
1334	1688	2879050000000
1335	1506	1440010000000
1336	1506	1440020000000
1337	1397	1435489682000
1338	1678	318000
1339	1683	41759391000000
1340	1679	6479241000000
1341	1679	6479251000000
1342	1397	1435479681000
1343	1678	319000
1344	1397	1435469680000
1345	1678	320000
1346	1397	1435459679000
1347	1678	321000
1348	1643	720010000000
1349	1397	1435449678000
1350	1678	322000
1351	1397	1435439677000
1352	1678	323000
1353	1683	43199391000000
1354	1683	43199411000000
1355	1445	720020000000
1356	1397	1435429676000
1357	1678	324000
1358	1397	1435419675000
1359	1678	325000
1360	1677	15119251000000
1361	1677	15119271000000
1362	1693	2877970000000
1363	1725	100000000
1364	1693	2876860000000
1365	1726	100000000
1366	1397	1435409674000
1367	1678	326000
1368	1688	2879070000000
1369	1701	2159050000000
1370	1693	2876750000000
1371	578	66000100000000
1372	1693	2876640000000
1373	394	66000100000000
1374	1397	1435399673000
1375	1678	327000
1376	1588	720000000000
1377	1588	720030000000
1378	1722	2873990000000
1379	1722	2874020000000
1380	1397	1435389672000
1381	1678	328000
1382	632	66720010000000
1383	1397	1435379671000
1384	1678	329000
1385	1715	1439020000000
1386	369	68880070000000
1387	369	68880080000000
1388	1594	2160030000000
1389	1594	2160040000000
1390	1397	1435369670000
1391	1678	330000
1392	1397	1435359669000
1393	1678	331000
1394	1447	2160020000000
1395	1447	2160030000000
1396	1397	1435349668000
1397	1678	332000
1398	1502	720000000000
1399	1502	720010000000
1400	1447	2880030000000
1401	1447	2880040000000
1402	1693	2876530000000
1403	379	66000100000000
1404	1397	1435339667000
1405	1678	333000
1406	1596	720020000000
1407	1685	4319080000000
1408	1397	1435329666000
1409	1678	334000
1410	1613	1438000000000
1411	1613	1438010000000
1412	1397	1435319665000
1413	1678	335000
1414	1616	720000000000
1415	1616	720010000000
1416	1397	1435309664000
1417	1678	336000
1418	1397	1435299663000
1419	1678	337000
1420	1701	2158770000000
1421	281	66000300000000
1422	1588	1440030000000
1423	1588	1440060000000
1424	1683	43199421000000
1425	1457	2160060000000
1426	1457	2160090000000
1427	1428	720000000000
1428	1428	720030000000
1429	1686	2159030000000
1430	1686	2159060000000
1431	700	66720030000000
1432	1397	1435289662000
1433	1678	338000
1434	379	66000090000000
1435	1483	0
1436	1690	2159030000000
1437	1690	2159050000000
1438	1397	1435279661000
1439	1678	339000
1440	1458	2880060000000
1441	1458	2880070000000
1442	1397	1435269660000
1443	1678	340000
1444	1397	1435259659000
1445	1678	341000
1446	1397	1435249658000
1447	1678	342000
1448	1397	1435239657000
1449	1678	343000
1450	1683	43199401000000
1451	1397	1435229656000
1452	1678	344000
1453	1683	44639411000000
1454	1683	44639421000000
1455	1440	2880030000000
1456	1440	2880040000000
1457	1508	1440010000000
1458	1508	1440020000000
1459	1397	1435219655000
1460	1678	345000
1461	1397	1435209654000
1462	1678	346000
1463	1546	2880040000000
1464	1546	2880060000000
1465	1445	1440020000000
1466	1445	1440040000000
1467	1397	1435199653000
1468	1678	347000
1469	1677	15839271000000
1470	1677	15839281000000
1471	1599	2160020000000
1472	1599	2160030000000
1473	1703	2159020000000
1474	1703	2159030000000
1475	1397	1435189652000
1476	1678	348000
1477	1456	1440130000000
1478	1456	1440140000000
1479	1623	2160020000000
1480	1623	2160030000000
1481	1397	1435179651000
1482	1678	349000
1483	1397	1435169650000
1484	1678	350000
1485	1727	719000000000
1486	1727	719010000000
1487	1397	1435159649000
1488	1678	351000
1489	1426	1440030000000
1490	1426	1440040000000
1491	1397	1435149648000
1492	1678	352000
1493	1588	1440040000000
1494	1679	7199251000000
1495	1679	7199261000000
1507	1613	1438040000000
1510	1677	16559281000000
1511	1677	16559291000000
1496	1694	3599000000000
1497	1694	3599010000000
1508	1397	1435099643000
1509	1678	357000
1498	1397	1435139647000
1499	1678	353000
1500	1397	1435129646000
1501	1678	354000
1502	1397	1435119645000
1503	1678	355000
1504	1397	1435109644000
1505	1678	356000
1506	43	66720040000000
1512	1397	1435089642000
1513	1678	358000
1514	1397	1435079641000
1515	1678	359000
1516	1397	1435069640000
1517	1678	360000
1518	1677	17279291000000
1519	1677	17279321000000
1520	1683	44639441000000
1521	1693	3596530000000
1522	1693	3596560000000
1523	1637	7200140000000
1524	1637	7200170000000
1525	1397	1435059639000
1526	1678	361000
1527	1699	2159049000000
1528	1527	0
1529	1692	5759110000000
1530	1692	5759121000000
1531	1686	1437930000000
1532	1728	0
1533	1397	1435049638000
1534	1678	362000
1535	1670	720000000000
1536	1670	720110000000
1537	1729	719000000000
1538	1729	719110000000
1539	1397	1435039637000
1540	1678	363000
1541	1474	2880040000000
1542	1397	1435029636000
1543	1678	364000
1544	1634	1440010000000
1545	1634	1440020000000
1546	1397	1435019635000
1547	1678	365000
1548	1682	2147090000000
1549	1682	2147100000000
1550	1693	4316560000000
1551	1693	4316570000000
1552	1397	1435009634000
1553	1678	366000
1554	1506	2160020000000
1555	1506	2160030000000
1556	1397	1434999633000
1557	1678	367000
1558	1397	1434989632000
1559	1678	368000
1560	1397	1434979631000
1561	1678	369000
1562	1688	3599050000000
1563	1688	3599080000000
1564	1536	2160020000000
1565	1536	2160050000000
1566	1397	1434969630000
1567	1678	370000
1568	633	66720000000000
1569	633	66720010000000
1570	576	66720000000000
1571	576	66720010000000
1572	1397	1434959629000
1573	1678	371000
1574	1571	2880030000000
1575	1571	2880040000000
1576	1397	1434949628000
1577	1678	372000
1578	1397	1434939627000
1579	1678	373000
1580	1397	1434929626000
1581	1678	374000
1582	1701	2878770000000
1583	1701	2878800000000
1584	1397	1434919625000
1585	1678	375000
1586	1687	1439010000000
1587	1687	1439020000000
1588	1397	1434909624000
1589	1678	376000
1590	1397	1434899623000
1591	1678	377000
1592	1444	2160030000000
1593	1444	2160050000000
1594	1397	1434889622000
1595	1678	378000
1596	1712	6789000000
1597	1730	100000000
1598	1656	2160041000000
1599	1397	1434879621000
1600	1678	379000
1601	1397	1434869620000
1602	1678	380000
1603	1699	2879049000000
1604	1699	2879059000000
1605	1672	1440010000000
1606	1672	1440020000000
1607	1397	1434859619000
1608	1678	381000
1609	1397	1434849618000
1610	1678	382000
1611	1482	720000000000
1612	1482	720020000000
1613	1397	1434839617000
1614	1678	383000
1615	1712	5688000000
1616	1731	100000000
1617	1712	4587000000
1618	1732	100000000
1619	1688	3599062000000
1620	1397	1434829616000
1621	1678	384000
1622	1271	1334046000000000
1623	1271	1334046010000000
1624	1397	1434819615000
1625	1678	385000
1626	1397	1434809614000
1627	1678	386000
1628	1397	1434799613000
1629	1678	387000
1630	1623	2160050000000
1631	1685	4319090000000
1632	1397	1434789612000
1633	1678	388000
1634	1458	3600070000000
1635	1458	3600080000000
1636	563	67440010000000
1637	563	67440020000000
1638	1397	1434779611000
1639	1678	389000
1640	1679	7919261000000
1641	1679	7919271000000
1642	1517	720000000000
1643	1517	720010000000
1644	1733	719000000000
1645	1733	719010000000
1646	1397	1434769610000
1647	1678	390000
1648	1397	1434759609000
1649	1678	391000
1650	1397	1434749608000
1651	1678	392000
1652	1397	1434739607000
1653	1678	393000
1654	1637	7200180000000
1655	1397	1434729606000
1656	1678	394000
1657	1684	2159020000000
1658	1397	1434719605000
1659	1678	395000
1660	1397	1434709604000
1661	1678	396000
1662	1397	1434699603000
1663	1678	397000
1664	687	66720000000000
1665	687	66720030000000
1666	1397	1434689602000
1667	1678	398000
1668	1397	1434679601000
1669	1678	399000
1670	1684	2879020000000
1671	1684	2879040000000
1672	1440	2880050000000
1673	1701	2878490000000
1674	885	63455161096354
1675	1701	2878180000000
1676	886	63455161096354
1677	1397	1434669600000
1678	1678	400000
1679	1397	1434659599000
1680	1678	401000
1681	1397	1434649598000
1682	1678	402000
1683	1688	4319062000000
1684	1688	4319112000000
1685	576	66720050000000
1686	1397	1434639597000
1687	1678	403000
1688	1397	1434629596000
1689	1678	404000
1690	1419	1440020000000
1691	1419	1440040000000
1692	1397	1434619595000
1693	1678	405000
1694	1397	1434609594000
1695	1678	406000
1696	1397	1434599593000
1697	1678	407000
1698	1610	2160020000000
1699	1610	2160050000000
1711	1637	7920180000000
1712	1637	7920191000000
1700	1397	1434589592000
1701	1678	408000
1713	1397	1434559589000
1714	1678	411000
1702	1397	1434579591000
1703	1678	409000
1704	1677	17279301000000
1705	1397	1434569590000
1706	1678	410000
1707	1712	3486000000
1708	1734	100000000
1709	1688	5039112000000
1710	1688	5039123000000
1715	1397	1434549588000
1716	1678	412000
1717	1709	1439010000000
1718	1709	1439020000000
1719	1397	1434539587000
1720	1678	413000
1721	1735	719000000000
1722	1735	719010000000
1723	1397	1434529586000
1724	1678	414000
1725	1692	6479121000000
1726	1692	6479131000000
1727	1397	1434519585000
1728	1678	415000
1729	1402	720000000000
1730	1402	720010000000
1731	1397	1434509584000
1732	1678	416000
1733	1677	17999301000000
1734	1677	17999311000000
1735	1397	1434499583000
1736	1678	417000
1737	1657	2160040000000
1738	1657	2160050000000
1739	1637	8640191000000
1740	1637	8640201000000
1741	1397	1434489582000
1742	1678	418000
1743	1725	99000000
1744	1683	46079421000000
1745	1683	46079432000000
1746	1508	2160020000000
1747	1508	2160031000000
1748	1573	2160040000000
1749	1573	2160051000000
1750	1397	1434479581000
1751	1678	419000
1752	1729	719010000000
1753	1397	1434469580000
1754	1678	420000
1755	1683	47519432000000
1756	1683	47519442000000
1757	1457	2160070000000
1758	1397	1434459579000
1759	1678	421000
1760	1397	1434449578000
1761	1678	422000
1762	1397	1434439577000
1763	1678	423000
1764	1397	1434429576000
1765	1678	424000
1766	1691	1439010000000
1767	1691	1439040000000
1768	1683	48959442000000
1769	1683	48959472000000
1770	1397	1434419575000
1771	1678	425000
1772	1683	50399472000000
1773	1683	50399482000000
1774	1397	1434409574000
1775	1678	426000
1776	1683	51839482000000
1777	1683	51839492000000
1778	1706	719010000000
1779	1397	1434399573000
1780	1678	427000
1781	633	67440010000000
1782	633	67440020000000
1783	1397	1434389572000
1784	1678	428000
1785	1695	2878950000000
1786	1695	2878960000000
1787	1689	2159070000000
1788	1692	7199131000000
1789	1692	7199141000000
1790	1397	1434379571000
1791	1678	429000
1792	1476	1440030000000
1793	42	67440020000000
1794	42	67440030000000
1795	1397	1434369570000
1796	1678	430000
1797	1397	1434359569000
1798	1678	431000
1799	1688	5039122000000
1800	1397	1434349568000
1801	1678	432000
1802	1397	1434339567000
1803	1678	433000
1804	1688	5759122000000
1805	1688	5759142000000
1806	1691	1439030000000
1807	470	68160030000000
1808	470	68160050000000
1809	1397	1434329566000
1810	1678	434000
1811	1607	1440020000000
1812	1397	1434319565000
1813	1678	435000
1814	1688	6479142000000
1815	1688	6479152000000
1816	484	68160020000000
1817	484	68160030000000
1818	1397	1434309564000
1819	1678	436000
1820	1683	53279492000000
1821	1683	53279502000000
1822	1555	2160010000000
1823	1555	2160020000000
1824	1397	1434299563000
1825	1678	437000
1826	1397	1434289562000
1827	1678	438000
1828	1685	5039090000000
1829	1685	5039100000000
1830	1397	1434279561000
1831	1678	439000
1832	1451	720000000000
1833	1451	720010000000
1834	1397	1434269560000
1835	1678	440000
1836	1683	54719502000000
1837	1683	54719512000000
1838	1701	3598180000000
1839	1701	3598190000000
1840	1637	9360201000000
1841	1637	9360211000000
1842	1397	1434259559000
1843	1678	441000
1844	1397	1434249558000
1845	1678	442000
1846	1397	1434239557000
1847	1678	443000
1848	1599	2880030000000
1849	1599	2880060000000
1850	149	68160020000000
1851	149	68160050000000
1852	1397	1434229556000
1853	1678	444000
1854	885	63455151096354
1855	1402	720030000000
1856	1402	1440030000000
1857	886	63455151096354
1858	1397	1434219555000
1859	1678	445000
1860	1397	1434209554000
1861	1678	446000
1862	1677	18719311000000
1863	1677	18719341000000
1864	1705	1436910000000
1865	1705	1436940000000
1866	1397	1434199553000
1867	1678	447000
1868	1397	1434189552000
1869	1678	448000
1870	470	68160040000000
1871	1397	1434179551000
1872	1678	449000
1873	1643	1440010000000
1874	1643	1440020000000
1875	1397	1434169550000
1876	1678	450000
1877	563	68160020000000
1878	563	68160030000000
1879	1397	1434159549000
1880	1678	451000
1881	1397	1434149548000
1882	1678	452000
1883	1684	2879030000000
1884	1397	1434139547000
1885	1678	453000
1886	1683	56159512000000
1887	1683	56159522000000
1888	1714	718910000000
1889	1590	0
1890	1706	717910000000
1891	1737	0
1892	1397	1434129546000
1893	1678	454000
1894	1637	9360411000000
1899	1677	19439341000000
1900	1677	19439351000000
1903	1397	1434109544000
1904	1678	456000
1905	1683	57599522000000
1906	1683	57599532000000
1907	1397	1434099543000
1908	1678	457000
1909	1397	1434089542000
1910	1678	458000
1911	1677	19439361000000
1918	1397	1434069540000
1919	1678	460000
1920	1457	2880070000000
1921	1457	2880080000000
1928	641	67440020000000
1933	1722	2874000000000
1934	1601	2880060000000
1935	1601	2880070000000
1940	1690	2879050000000
1941	1690	2879060000000
1895	1397	1434119545000
1896	1678	455000
1897	1709	2159020000000
1898	1709	2159030000000
1901	1649	2160020000000
1902	1649	2160030000000
1912	1397	1434079541000
1913	1678	459000
1914	1476	2160030000000
1915	1476	2160040000000
1922	1397	1434059539000
1923	1678	461000
1924	1677	20159361000000
1925	1677	20159371000000
1929	1397	1434049538000
1930	1678	462000
1931	1516	1440010000000
1932	1516	1440020000000
1936	1397	1434039537000
1937	1678	463000
1938	1683	59039532000000
1939	1683	59039542000000
1916	1716	2159060000000
1917	1716	2159070000000
1926	1637	10080411000000
1927	1637	10080421000000
1942	1397	1434029536000
1943	1678	464000
1944	1607	2160020000000
1945	1607	2160030000000
1946	1397	1434019535000
1947	1678	465000
1948	1717	1439050000000
1949	1717	1439060000000
1950	1397	1434009534000
1951	1678	466000
1952	1608	720000000000
1953	1608	720010000000
1954	1519	720000000000
1955	1519	720010000000
1956	1397	1433999533000
1957	1678	467000
1958	43	67440040000000
1959	43	67440050000000
1960	1656	2880041000000
1961	1656	2880051000000
1962	1397	1433989532000
1963	1678	468000
1964	1722	3594000000000
1965	1397	1433979531000
1966	1678	469000
1967	1397	1433969530000
1968	1678	470000
1969	1722	3594020000000
1970	1397	1433959529000
1971	1678	471000
1972	1397	1433949528000
1973	1678	472000
1974	1397	1433939527000
1975	1678	473000
1976	1402	2160030000000
1977	1402	2160050000000
1978	1677	20879371000000
1979	1677	20879391000000
1980	1637	10800421000000
1981	1637	10800441000000
1982	1397	1433929526000
1983	1678	474000
1984	1397	1433919525000
1985	1678	475000
1986	1458	3600090000000
1987	1397	1433909524000
1988	1678	476000
1989	1397	1433899523000
1990	1678	477000
1991	1402	2880050000000
1992	1402	2880060000000
1993	1677	20879381000000
1994	1397	1433889522000
1995	1678	478000
1996	1683	60479542000000
1997	1683	60479552000000
1998	1397	1433879521000
1999	1678	479000
2000	1457	3600080000000
2001	1457	3600090000000
2002	1683	61919552000000
2003	1683	61919562000000
2004	1397	1433869520000
2005	1678	480000
2006	1738	719000000000
2007	1738	719010000000
2008	1397	1433859519000
2009	1678	481000
2010	1677	21599381000000
2011	1677	21599391000000
2012	1397	1433849518000
2013	1678	482000
2014	1402	3600060000000
2015	1402	3600070000000
2016	1397	1433839517000
2017	1678	483000
2018	1476	2880040000000
2019	1476	2880050000000
2020	1397	1433829516000
2021	1678	484000
2022	1513	720010000000
2023	1397	1433819515000
2024	1678	485000
2025	1397	1433809514000
2026	1678	486000
2027	1715	2159020000000
2028	1715	2159040000000
2029	1677	22319391000000
2030	1677	22319411000000
2031	1397	1433799513000
2032	1678	487000
2033	1397	1433789512000
2034	1678	488000
2035	1683	61919572000000
2036	1397	1433779511000
2037	1678	489000
2038	484	68880030000000
2039	484	68880040000000
2040	1477	0
2041	1397	1433769510000
2042	1678	490000
2043	1694	2879020000000
2044	1397	1433759509000
2045	1678	491000
2046	1397	1433749508000
2047	1678	492000
2048	1694	3599020000000
2049	1694	3599040000000
2050	1677	22319431000000
2051	1677	23039431000000
2052	1677	23039451000000
2053	1695	2158970000000
2054	1695	2878970000000
2055	1695	2878990000000
2056	1681	3599130000000
2057	1681	4319130000000
2058	1681	4319150000000
2059	1397	1433739507000
2060	1678	493000
2061	1397	1433729506000
2062	1678	494000
2063	1729	1439010000000
2064	1729	1439030000000
2065	1692	7199151000000
2066	1397	1433719505000
2067	1678	495000
2068	1681	5039150000000
2069	1681	5039160000000
2070	1397	1433709504000
2071	1678	496000
2072	1397	1433699503000
2073	1678	497000
2074	1397	1433689502000
2075	1678	498000
2076	1397	1433679501000
2077	1678	499000
2078	1516	2160020000000
2079	1516	2160060000000
2080	1677	23039411000000
2081	1699	2879089000000
2082	1397	1433669500000
2083	1678	500000
2084	1683	63359572000000
2085	1683	63359582000000
2086	58	66720000000000
2087	58	66720010000000
2088	1397	1433659499000
2089	1678	501000
2090	1623	2880030000000
2091	1623	2880040000000
2092	1397	1433649498000
2093	1678	502000
2094	1668	2160020000000
2095	1668	2160030000000
2096	1677	23039421000000
2097	1397	1433639497000
2098	1678	503000
2099	1397	1433629496000
2100	1678	504000
2101	1683	63359592000000
2102	1397	1433619495000
2103	1678	505000
2104	1397	1433609494000
2105	1678	506000
2106	1397	1433599493000
2107	1678	507000
2108	1397	1433589492000
2109	1678	508000
2110	1397	1433579491000
2111	1678	509000
2112	1397	1433569490000
2113	1678	510000
2114	1683	64799592000000
2115	1683	64799652000000
2116	1397	1433559489000
2117	1678	511000
2118	1397	1433549488000
2119	1678	512000
2120	1397	1433539487000
2121	1678	513000
2122	1587	1440010000000
2123	1587	1440020000000
2140	1677	23759421000000
2141	1677	23759431000000
2148	1692	7199391000000
2156	1397	1433439477000
2157	1678	523000
2158	1546	3600060000000
2159	1546	3600070000000
2166	1587	2160020000000
2167	1587	2160030000000
2175	1397	1433399473000
2176	1678	720010527000
2177	1683	69119672000000
2178	1683	69119682000000
2181	1739	719000000000
2182	1739	719010000000
2124	1397	1433529486000
2125	1678	514000
2126	1397	1433519485000
2127	1678	515000
2128	1397	1433509484000
2129	1678	516000
2130	1397	1433499483000
2131	1678	517000
2132	1397	1433489482000
2133	1678	518000
2134	632	67440010000000
2135	632	67440060000000
2142	1724	718760000000
2143	532	66000000000000
2144	1397	1433469480000
2145	1678	520000
2146	1448	2160040000000
2147	1448	2160300000000
2160	1683	67679662000000
2161	1683	67679672000000
2168	1397	1433419475000
2169	1678	720010525000
2170	1397	1433409474000
2171	1678	720010526000
2172	43	67440060000000
2179	298	67440010000000
2180	298	67440020000000
2183	1397	1433389472000
2184	1678	720010528000
2185	1692	7919391000000
2186	1692	7919401000000
2136	1397	1433479481000
2137	1678	519000
2138	1683	66239652000000
2139	1683	66239662000000
2149	1724	718510000000
2150	1397	1433459479000
2151	1678	521000
2152	1673	1440010000000
2153	1673	1440270000000
2154	1397	1433449478000
2155	1678	522000
2162	1397	1433429476000
2163	1678	524000
2164	1678	720000524000
2165	1678	720010524000
2173	311	68880050000000
2174	311	68880070000000
2187	1397	1433379471000
2188	1678	720010529000
2189	1698	719010000000
2190	1471	1440010000000
2191	1471	1440020000000
2192	1633	1440010000000
2193	1633	1440020000000
2194	1397	1433369470000
2195	1678	720010530000
2196	1397	1433359469000
2197	1678	720010531000
2198	1402	4320070000000
2199	1402	4320090000000
2200	1677	23759441000000
2201	1397	1433349468000
2202	1678	720010532000
2203	1397	1433339467000
2204	1678	720010533000
2205	1633	1440030000000
2206	1397	1433329466000
2207	1678	720010534000
2208	1402	4320080000000
2209	1656	3600051000000
2210	1656	3600061000000
2211	1397	1433319465000
2212	1678	720010535000
2213	1397	1433309464000
2214	1678	720010536000
2215	1397	1433299463000
2216	1678	720010537000
2217	1448	2160070000000
2218	1685	5759100000000
2219	1685	5759130000000
2220	1397	1433289462000
2221	1678	720010538000
2222	1397	1433279461000
2223	1678	720010539000
2224	1683	69119692000000
2225	1397	1433269460000
2226	1678	720010540000
2227	1637	11520441000000
2228	1637	11520451000000
2229	1397	1433259459000
2230	1678	720010541000
2231	1722	4314020000000
2232	1722	4314030000000
2233	1397	1433249458000
2234	1678	720010542000
2235	1397	1433239457000
2236	1678	720010543000
2237	1397	1433229456000
2238	1678	720010544000
2239	1634	2160020000000
2240	1634	2160050000000
2241	1397	1433219455000
2242	1678	720010545000
2243	1397	1433209454000
2244	1678	720010546000
2245	1596	1440020000000
2246	1596	1440030000000
2247	1397	1433199453000
2248	1678	720010547000
2249	1679	8639271000000
2250	1679	8639281000000
2251	1569	720000000000
2252	1569	720710000000
2253	1569	720510000000
2254	1569	720010000000
2255	1677	24479441000000
2256	1397	1433189452000
2257	1678	720010548000
2258	1397	1433179451000
2259	1678	720010549000
2260	1397	1433169450000
2261	1678	720010550000
2262	1683	70559692000000
2263	1683	70559722000000
2264	1397	1433159449000
2265	1678	720010551000
2266	1397	1433149448000
2267	1678	720010552000
2268	1397	1433139447000
2269	1678	720010553000
2270	1683	71999722000000
2271	1683	71999752000000
2272	886	63455051096354
2273	1397	1433129446000
2274	1678	720010554000
2275	1677	24479551000000
2276	1637	12240451000000
2277	1637	12240561000000
2278	885	63455051096354
2279	1397	1433119445000
2280	1678	720010555000
2281	578	66000090000000
2282	1516	2160140000000
2283	1397	1433109444000
2284	1678	720010556000
2285	44	68160120000000
2286	44	68160130000000
2287	1692	8639401000000
2288	1692	8639411000000
2289	885	63455041096354
2290	1397	1433099443000
2291	1678	720010557000
2292	1397	1433089442000
2293	1678	720010558000
2294	1397	1433079441000
2295	1678	720010559000
2296	1671	2160080000000
2297	1397	1433069440000
2298	1678	720010560000
2299	1650	720000000000
2300	1650	720010000000
2301	1637	12240461000000
2302	1397	1433059439000
2303	1678	720010561000
2304	1397	1433049438000
2305	1678	720010562000
2306	1740	719000000000
2307	1740	719020000000
2308	1397	1433039437000
2309	1678	720010563000
2310	1683	73439752000000
2311	1683	73439762000000
2312	1397	1433029436000
2313	1678	720010564000
2314	1693	5036570000000
2315	1693	5036580000000
2316	1397	1433019435000
2317	1678	720010565000
2318	470	68880040000000
2319	470	68880050000000
2320	1508	2160030000000
2321	1397	1433009434000
2322	1678	720010566000
2323	1675	720000000000
2324	1675	720010000000
2325	1419	2160040000000
2326	1419	2160050000000
2327	1397	1432999433000
2328	1678	720010567000
2329	1426	2160040000000
2330	1426	2160050000000
2331	1397	1432989432000
2332	1678	720010568000
2333	1397	1432979431000
2334	1678	720010569000
2335	1419	2880050000000
2336	1419	2880070000000
2337	1397	1432969430000
2338	1678	720010570000
2339	1536	2880050000000
2340	1536	2880060000000
2341	1723	2159030000000
2342	1723	2159040000000
2343	1686	2157930000000
2344	1686	2157940000000
2345	1397	1432959429000
2346	1678	720010571000
2347	1397	1432949428000
2348	1678	720010572000
2349	1679	8639291000000
2350	1397	1432939427000
2351	1678	720010573000
2352	1685	6479130000000
2353	1685	6479140000000
2354	1397	1432929426000
2355	1678	720010574000
2356	1397	1432919425000
2357	1678	720010575000
2358	1723	2159050000000
2359	1397	1432909424000
2360	1678	720010576000
2361	1668	2880030000000
2362	1668	2880040000000
2367	1397	1432899423000
2368	1678	720010577000
2369	1686	2877940000000
2370	1686	2877950000000
2379	1547	1440010000000
2380	1547	1440020000000
2385	1397	1432859419000
2386	1678	720010581000
2387	1397	1432849418000
2388	1678	720010582000
2389	1711	1439010000000
2390	1711	1439030000000
2397	341	66720000000000
2398	341	66720720000000
2404	298	67439720000000
2405	14	4884200000000
2406	1693	5755580000000
2407	1736	0
2408	1397	1432819415000
2409	1678	720010585000
2410	1587	2160140000000
2414	1397	1432809414000
2415	1678	720010586000
2416	1723	2879050000000
2417	1723	2879060000000
2429	1690	3599060000000
2430	1690	3599190000000
2441	14	4884100000000
2442	1397	1432749408000
2443	1678	720010592000
2444	1434	720000000000
2445	1434	720110000000
2450	1397	1432739407000
2451	1678	720010593000
2453	1397	1432729406000
2454	1678	720010594000
2455	1434	719100000000
2456	209	66001000000000
2457	1397	1432719405000
2458	1678	720010595000
2459	576	67440010000000
2460	576	67440040000000
2363	1683	74879762000000
2364	1683	74879772000000
2365	606	68160020000000
2366	606	68160030000000
2373	1397	1432889422000
2374	1678	720010578000
2375	1677	25199551000000
2376	1677	25199561000000
2377	1397	1432879421000
2378	1678	720010579000
2384	1559	2880070000000
2391	1397	1432839417000
2392	1678	720010583000
2393	1423	720000000000
2394	1423	720010000000
2395	1693	5756580000000
2396	1693	5756590000000
2400	1397	1432829416000
2401	1678	720010584000
2402	1711	2159030000000
2403	1711	2159040000000
2411	1683	74879882000000
2412	1685	7199140000000
2413	1685	7199260000000
2418	1677	25919561000000
2419	1677	25919571000000
2420	298	67439420000000
2421	30	6000200000000
2422	1397	1432799413000
2423	1678	720010587000
2424	1397	1432789412000
2425	1678	720010588000
2426	885	63455031096354
2427	1670	1440110000000
2428	1670	1440240000000
2438	1397	1432759409000
2439	1678	720010591000
2440	1448	2160050000000
2448	1693	6475580000000
2449	1693	6475690000000
2452	1718	719010000000
2462	1690	3599090000000
2371	1446	720000000000
2372	1446	720010000000
2381	1397	1432869420000
2382	1678	720010580000
2383	1715	2159030000000
2399	341	66720010000000
2431	886	63455041096354
2432	1397	1432779411000
2433	1678	720010589000
2434	1397	1432769410000
2435	1678	720010590000
2436	58	67440010000000
2437	58	67440040000000
2446	1679	9359291000000
2447	1679	9359401000000
2461	1637	12240481000000
2463	1397	1432709404000
2464	1678	720010596000
2465	1397	1432699403000
2466	1678	720010597000
2467	1397	1432689402000
2468	1678	720010598000
2469	1654	2160020000000
2470	1654	2160050000000
2471	1677	26639571000000
2472	1677	26639601000000
2473	1690	4319090000000
2474	1690	4319120000000
2475	44	68880130000000
2476	44	68880160000000
2477	1397	1432679401000
2478	1678	720010599000
2479	1706	1437910000000
2480	1706	1437920000000
2481	1573	2160050000000
2482	1397	1432669400000
2483	1678	720010600000
2484	1402	5040080000000
2485	1402	5040090000000
2486	1397	1432659399000
2487	1678	720010601000
2488	1402	5760090000000
2489	1402	5760100000000
2490	1397	1432649398000
2491	1678	720010602000
2492	1670	2160240000000
2493	1670	2160250000000
2494	1397	1432639397000
2495	1678	720010603000
2496	1397	1432629396000
2497	1678	720010604000
2498	1457	3600100000000
2499	1397	1432619395000
2500	1678	720010605000
2501	1668	3600040000000
2502	1668	3600050000000
2503	1683	76319882000000
2504	1683	76319892000000
2505	1397	1432609394000
2506	1678	720010606000
2507	1688	7199142000000
2508	1688	7199152000000
2509	1426	2880050000000
2510	1426	2880060000000
2511	1397	1432599393000
2512	1678	720010607000
2513	1637	12960461000000
2514	1637	12960471000000
2515	1440	3600050000000
2516	1440	3600060000000
2517	1397	1432589392000
2518	1678	720010608000
2519	1397	1432579391000
2520	1678	720010609000
2521	1613	1438020000000
2522	1739	719020000000
2523	1397	1432569390000
2524	1678	720010610000
2525	1607	2880030000000
2526	1607	2880040000000
2527	1397	1432559389000
2528	1678	720010611000
2529	1397	1432549388000
2530	1678	720010612000
2531	1397	1432539387000
2532	1678	720010613000
2533	1722	5034030000000
2534	1722	5034060000000
2535	1690	5039120000000
2536	1690	5039150000000
2537	1397	1432529386000
2538	1678	720010614000
2539	1677	26639581000000
2540	1397	1432519385000
2541	1678	720010615000
2542	1397	1432509384000
2543	1678	720010616000
2544	1681	5039170000000
2545	1692	9359401000000
2546	1692	9359421000000
2547	1397	1432499383000
2548	1678	720010617000
2549	1397	1432489382000
2550	1678	720010618000
2551	1607	3600040000000
2552	1607	3600050000000
2553	1714	1438910000000
2554	1714	1438920000000
2555	1397	1432479381000
2556	1678	720010619000
2557	1690	5039130000000
2558	1397	1432469380000
2559	1678	720010620000
2560	209	66000990000000
2561	1607	3600060000000
2562	1397	1432459379000
2563	1678	720010621000
2564	1729	1439020000000
2565	1692	9359411000000
2566	1397	1432449378000
2567	1678	720010622000
2568	1458	4320090000000
2569	1458	4320100000000
2570	1611	1440010000000
2571	1611	1440020000000
2572	1397	1432439377000
2573	1678	720010623000
2574	1397	1432429376000
2575	1678	720010624000
2576	1683	77759892000000
2577	1683	77759912000000
2578	1677	27359581000000
2579	1677	27359601000000
2580	1649	2160040000000
2581	470	69600050000000
2582	470	69600070000000
2583	1397	1432419375000
2584	1678	720010625000
2585	1683	77759902000000
2586	1677	27359591000000
2587	1397	1432409374000
2588	1678	720010626000
2589	1683	79199902000000
2590	1683	79199912000000
2591	1397	1432399373000
2592	1678	720010627000
2593	1588	2160040000000
2594	1588	2160050000000
2595	1397	1432389372000
2596	1678	720010628000
2597	1573	2880050000000
2598	1573	2880060000000
2599	1741	719000000000
2600	1741	719010000000
2601	1397	1432379371000
2602	1678	720010629000
2603	1685	7199150000000
2604	1397	1432369370000
2605	1678	720010630000
2606	1397	1432359369000
2607	1678	720010631000
2608	1654	2160040000000
2609	1397	1432349368000
2610	1678	720010632000
2611	1397	1432339367000
2612	1678	720010633000
2613	1724	1438510000000
2614	1724	1438530000000
2615	1397	1432329366000
2616	1678	720010634000
2617	1397	1432319365000
2618	1678	720010635000
2619	1722	5754060000000
2620	1722	5754080000000
2621	1693	6475600000000
2622	1397	1432309364000
2623	1678	720010636000
2624	1683	80639912000000
2625	1683	80639922000000
2626	1693	6475590000000
2627	1397	1432299363000
2628	1678	720010637000
2629	1457	4320100000000
2630	1457	4320110000000
2631	1739	1439020000000
2632	1739	1439030000000
2637	1397	1432269360000
2638	1678	720010640000
2639	1397	1432259359000
2640	1678	720010641000
2641	1599	2880050000000
2646	1397	1432229356000
2647	1678	720010644000
2648	1516	2880140000000
2649	1516	2880150000000
2655	1397	1432209354000
2656	1678	720010646000
2657	1397	1432199353000
2658	1678	720010647000
2659	1397	1432189352000
2660	1678	720010648000
2661	1397	1432179351000
2662	1678	720010649000
2663	1559	3600070000000
2664	1559	3600110000000
2690	1397	1432099343000
2691	1678	720010657000
2693	1706	716810000000
2694	1737	1000000000
2695	1397	1432089342000
2696	1678	720010658000
2697	1451	1440010000000
2698	1451	1440120000000
2705	1397	1432069340000
2706	1678	720010660000
2707	1518	720010000000
2730	1397	1431999333000
2731	1678	720010667000
2732	1397	1431989332000
2733	1678	720010668000
2734	1602	2160010000000
2735	1602	2160030000000
2748	1397	1431939327000
2749	1678	720010673000
2750	1397	1431929326000
2751	1678	720010674000
2752	1683	82079942000000
2759	1706	1436810000000
2760	1706	1436820000000
2633	1397	1432289362000
2634	1678	720010638000
2642	1397	1432249358000
2643	1678	720010642000
2650	1397	1432219355000
2651	1678	720010645000
2652	1564	720000000000
2653	1564	720010000000
2665	1541	1440050000000
2673	1476	3600050000000
2674	1476	3600080000000
2675	1397	1432139347000
2676	1678	720010653000
2677	1573	3600060000000
2678	1573	3600070000000
2679	1569	810000000
2680	485	66719000000000
2681	1397	1432129346000
2682	1678	720010654000
2683	1397	1432119345000
2684	1678	720010655000
2685	1397	1432109344000
2686	1678	720010656000
2687	1723	3599060000000
2688	1723	3599290000000
2692	1679	9359301000000
2699	1740	1439020000000
2700	1740	1439130000000
2708	1397	1432059339000
2709	1678	720010661000
2710	1593	1440030000000
2711	1593	1440040000000
2736	1397	1431979331000
2737	1678	720010669000
2738	1397	1431969330000
2739	1678	720010670000
2740	1397	1431959329000
2741	1678	720010671000
2742	1654	2880040000000
2743	1654	2880070000000
2753	1422	1440010000000
2754	1422	1440030000000
2635	1397	1432279361000
2636	1678	720010639000
2644	1397	1432239357000
2645	1678	720010643000
2654	1602	1440010000000
2666	1397	1432169350000
2667	1678	720010650000
2668	1397	1432159349000
2669	1678	720010651000
2670	1397	1432149348000
2671	1678	720010652000
2672	484	68880060000000
2689	641	67440240000000
2701	1397	1432079341000
2702	1678	720010659000
2703	1684	3599030000000
2704	1684	3599040000000
2712	1637	13680471000000
2713	1637	13680481000000
2714	1397	1432049338000
2715	1678	720010662000
2716	1683	82079922000000
2717	1683	82079932000000
2718	1397	1432039337000
2719	1678	720010663000
2720	1397	1432029336000
2721	1678	720010664000
2722	1685	7919150000000
2723	1685	7919170000000
2724	1397	1432019335000
2725	1678	720010665000
2726	1397	1432009334000
2727	1678	720010666000
2728	1677	28079591000000
2729	1677	28079611000000
2744	1397	1431949328000
2745	1678	720010672000
2746	1677	28799611000000
2747	1677	28799621000000
2755	1397	1431919325000
2756	1678	720010675000
2757	1698	1439010000000
2758	1698	1439020000000
2761	1397	1431909324000
2762	1678	720010676000
2763	1397	1431899323000
2764	1678	720010677000
2765	1715	2879030000000
2766	1715	2879040000000
2767	394	66000090000000
2768	1397	1431889322000
2769	1678	720010678000
2770	1694	4319010000000
2771	1694	4319030000000
2772	1637	14400481000000
2773	1637	14400501000000
2774	1516	3600150000000
2775	1516	3600170000000
2776	1513	1440010000000
2777	1513	1440030000000
2778	1397	1431879321000
2779	1678	720010679000
2780	1723	3599070000000
2781	1397	1431869320000
2782	1678	720010680000
2783	1397	1431859319000
2784	1678	720010681000
2785	1712	2385000000
2786	1742	100000000
2787	1402	5760111000000
2788	1536	3600060000000
2789	1536	3600081000000
2790	1715	3599040000000
2791	1715	3599061000000
2792	1397	1431849318000
2793	1678	720010682000
2794	484	69600060000000
2795	484	69600070000000
2796	1677	29519621000000
2797	1677	29519631000000
2798	1397	1431839317000
2799	1678	720010683000
2800	1397	1431829316000
2801	1678	720010684000
2802	1712	1284000000
2803	1743	100000000
2804	1706	2156820000000
2805	1706	2156841000000
2806	1397	1431819315000
2807	1678	720010685000
2808	1397	1431809314000
2809	1678	720010686000
2810	1397	1431799313000
2811	1678	720010687000
2812	1683	83519942000000
2813	1683	83519952000000
2814	1397	1431789312000
2815	1678	720010688000
2816	1683	84959952000000
2817	1683	84959962000000
2818	1637	14400491000000
2819	1397	1431779311000
2820	1678	720010689000
2821	1683	86399962000000
2822	1683	86399972000000
2823	1698	718910000000
2824	1578	0
2825	1397	1431769310000
2826	1678	720010690000
2827	1397	1431759309000
2828	1678	720010691000
2829	1448	2880050000000
2830	1448	2880170000000
2831	1679	9359411000000
2832	1683	87839972000000
2833	1683	87840092000000
2834	1397	1431749308000
2835	1678	720010692000
2836	1397	1431739307000
2837	1678	720010693000
2838	1610	2880050000000
2839	1610	2880070000000
2840	1397	1431729306000
2841	1678	720010694000
2842	1683	87839982000000
2843	1397	1431719305000
2844	1678	720010695000
2845	1397	1431709304000
2846	1678	720010696000
2847	1397	1431699303000
2848	1678	720010697000
2849	1402	5760110000000
2850	1397	1431689302000
2851	1678	720010698000
2852	1397	1431679301000
2853	1678	720010699000
2854	1622	1440010000000
2855	1622	1440030000000
2856	1670	2880250000000
2857	1670	2880270000000
2858	484	70320070000000
2859	484	70320090000000
2860	1397	1431669300000
2861	1678	720010700000
2862	1705	714810000000
2863	1744	1000000000
2864	1397	1431659299000
2865	1678	720010701000
2866	1560	2160150000000
2867	1397	1431649298000
2868	1678	720010702000
2869	1397	1431639297000
2870	1678	720010703000
2871	1397	1431629296000
2872	1678	720010704000
2873	1397	1431619295000
2874	1678	720010705000
2875	1677	30239631000000
2876	1677	30239671000000
2877	1397	1431609294000
2878	1678	720010706000
2879	1694	5039030000000
2880	1694	5039040000000
2881	1397	1431599293000
2882	1678	720010707000
2883	311	69600070000000
2884	311	69600080000000
2885	1397	1431589292000
2886	1678	720010708000
2887	1735	719009000000
2888	1549	2160020000000
2889	1549	2160031000000
2890	1397	1431579291000
2891	1678	720010709000
2892	1709	2879030000000
2893	1709	2879040000000
2894	1397	1431569290000
2895	1678	720010710000
2896	1722	6474080000000
2897	1722	6474090000000
2898	1397	1431559289000
2899	1678	720010711000
2900	69	66720000000000
2901	69	66720010000000
2902	1397	1431549288000
2903	1678	720010712000
2913	1397	1431519285000
2914	1678	720010715000
2915	1397	1431509284000
2916	1678	720010716000
2917	1704	719020000000
2922	1677	31679691000000
2923	1677	31679701000000
2930	1397	1431479281000
2931	1678	720010719000
2934	1689	2879070000000
2935	1689	2879080000000
2958	1397	1431379271000
2959	1678	720010729000
2960	1656	4320061000000
2961	1656	4320071000000
2962	1397	1431369270000
2963	1678	720010730000
2964	1397	1431359269000
2965	1678	720010731000
2966	633	68160020000000
2967	633	68160040000000
2976	1397	1431329266000
2977	1678	720010734000
2980	1397	1431319265000
2981	1678	720010735000
2982	1397	1431309264000
2983	1678	720010736000
2984	1397	1431299263000
2985	1678	720010737000
2986	1509	2160040000000
2987	1509	2160070000000
2993	1397	1431279261000
2994	1678	720010739000
2995	1397	1431269260000
2996	1678	720010740000
2997	1397	1431259259000
2998	1678	720010741000
2999	1397	1431249258000
3000	1678	720010742000
3001	1397	1431239257000
3002	1678	720010743000
3003	1397	1431229256000
3004	1678	720010744000
3005	1688	7919152000000
3006	1688	7919212000000
3015	1689	3599080000000
3016	1689	3599100000000
3021	1397	1431179251000
3022	1678	720010749000
3023	1564	1440010000000
3024	1564	1440020000000
3041	1692	10079411000000
3042	1692	10079421000000
3043	1397	1431139247000
3044	1678	720010753000
3045	1715	4319061000000
3046	1715	4319071000000
3047	1397	1431129246000
3048	1678	720010754000
3049	1688	8639232000000
3050	1688	9359232000000
3051	1397	1431119245000
3052	1678	720010755000
3053	596	66720010000000
3054	1677	32399711000000
3055	1677	32399721000000
3056	641	68160240000000
3057	641	68160250000000
3060	1397	1431099243000
3061	1678	720010757000
3062	298	68159420000000
3063	298	68159430000000
3082	1397	1431059239000
3083	1678	720010761000
3084	1688	10799242000000
3085	1688	10799252000000
2904	1677	30959671000000
2905	1677	30959681000000
2912	1677	30959691000000
2918	1397	1431499283000
2919	1678	720010717000
2920	1683	89279982000000
2921	1683	89279992000000
2926	1397	1431489282000
2927	1678	720010718000
2928	1610	3600070000000
2929	1610	3600080000000
2946	1397	1431419275000
2947	1678	720010725000
2970	1397	1431349268000
2971	1678	720010732000
2972	1397	1431339267000
2973	1678	720010733000
2974	1444	2880050000000
2975	1444	2880070000000
2978	1685	9359200000000
2979	1685	9359210000000
2988	1397	1431289262000
2989	1678	720010738000
2990	633	68160030000000
3007	1677	31679751000000
3008	1397	1431219255000
3009	1678	720010745000
3010	1397	1431209254000
3011	1678	720010746000
3012	1670	3600270000000
3013	1670	3600290000000
3017	1397	1431199253000
3018	1678	720010747000
3019	1397	1431189252000
3020	1678	720010748000
3025	1593	2160040000000
3026	1593	2160050000000
3027	1397	1431169250000
3028	1678	720010750000
3029	1688	8639212000000
3030	1688	8639222000000
3031	1397	1431159249000
3032	1678	720010751000
3033	1640	720000000000
3034	1640	720010000000
3064	1683	93600022000000
3065	1683	93600032000000
3074	1397	1431079241000
3075	1678	720010759000
3076	1688	10079232000000
3077	1688	10079242000000
3080	1708	1439130000000
3081	1708	1439140000000
2906	1397	1431539287000
2907	1678	720010713000
2908	1397	1431529286000
2909	1678	720010714000
2910	1402	6480110000000
2911	1402	6480130000000
2924	1566	720000000000
2925	1566	720010000000
2932	1397	1431469280000
2933	1678	720010720000
2936	1397	1431459279000
2937	1678	720010721000
2938	1397	1431449278000
2939	1678	720010722000
2940	1397	1431439277000
2941	1678	720010723000
2942	1685	8639170000000
2943	1685	8639200000000
2944	1397	1431429276000
2945	1678	720010724000
2948	1397	1431409274000
2949	1678	720010726000
2950	1397	1431399273000
2951	1678	720010727000
2952	1683	90719992000000
2953	1683	90720012000000
2954	1397	1431389272000
2955	1678	720010728000
2956	1671	2880080000000
2957	1671	2880090000000
2968	58	68160040000000
2969	58	68160060000000
2991	1599	3600050000000
2992	1599	3600060000000
3014	1677	31679711000000
3035	1683	92160012000000
3036	1683	92160022000000
3037	1397	1431149248000
3038	1678	720010752000
3039	1709	3599040000000
3040	1709	3599050000000
3058	1397	1431109244000
3059	1678	720010756000
3066	1699	3599089000000
3067	1699	3599099000000
3068	1397	1431089242000
3069	1678	720010758000
3070	1439	720000000000
3071	1439	720010000000
3072	1735	1439009000000
3073	1735	1439019000000
3078	1397	1431069240000
3079	1678	720010760000
3086	1397	1431049238000
3087	1678	720010762000
3088	1656	5040071000000
3089	1656	5040081000000
3090	1397	1431039237000
3091	1678	720010763000
3092	1694	5759040000000
3093	1694	5759050000000
3094	1397	1431029236000
3095	1678	720010764000
3096	1679	10079401000000
3097	1679	10079411000000
3098	1706	2876841000000
3099	1706	2876851000000
3100	1397	1431019235000
3101	1678	720010765000
3102	1397	1431009234000
3103	1678	720010766000
3104	1677	33119721000000
3105	1677	33119731000000
3106	1397	1430999233000
3107	1678	720010767000
3108	1457	5040110000000
3109	1457	5040120000000
3110	1397	1430989232000
3111	1678	720010768000
3112	1678	1440010768000
3113	1678	1440030768000
3114	1397	1430979231000
3115	1678	1440030769000
3116	1397	1430969230000
3117	1678	1440030770000
3118	1397	1430959229000
3119	1678	1440030771000
3120	1397	1430949228000
3121	1678	1440030772000
3122	1397	1430939227000
3123	1678	1440030773000
3124	1671	3600090000000
3125	1671	3600140000000
3126	1397	1430929226000
3127	1678	1440030774000
3128	1602	2880030000000
3129	1602	2880040000000
3130	470	69600060000000
3131	1724	2158530000000
3132	1724	2158540000000
3133	1397	1430919225000
3134	1678	1440030775000
3135	1397	1430909224000
3136	1678	1440030776000
3137	1448	3600170000000
3138	1448	3600180000000
3139	1706	3596851000000
3140	1706	3596861000000
3141	1397	1430899223000
3142	1678	1440030777000
3143	1444	3600070000000
3144	1444	3600080000000
3145	1397	1430889222000
3146	1678	1440030778000
3147	1688	11519252000000
3148	1688	11519262000000
3149	576	67440020000000
3150	1397	1430879221000
3151	1678	1440030779000
3152	1397	1430869220000
3153	1678	1440030780000
3154	171	67440010000000
3155	171	67440020000000
3156	1397	1430859219000
3157	1678	1440030781000
3158	1509	2880070000000
3159	1509	2880080000000
3160	1397	1430849218000
3161	1678	1440030782000
3162	1397	1430839217000
3163	1678	1440030783000
3164	1397	1430829216000
3165	1678	1440030784000
3166	1602	2880050000000
3167	1623	3600040000000
3168	1623	3600060000000
3169	1397	1430819215000
3170	1678	1440030785000
3171	101	66720000000000
3172	101	66720010000000
3173	1397	1430809214000
3174	1678	1440030786000
3175	1571	3600040000000
3176	1571	3600050000000
3177	1397	1430799213000
3178	1678	1440030787000
3179	1686	3597950000000
3180	1686	3597960000000
3181	1729	2159020000000
3182	1729	2159030000000
3183	1397	1430789212000
3184	1678	1440030788000
3185	1516	3600160000000
3186	1397	1430779211000
3187	1678	1440030789000
3188	1723	4319070000000
3189	1723	4319080000000
3190	1397	1430769210000
3191	1678	1440030790000
3192	1397	1430759209000
3193	1678	1440030791000
3194	1683	95040022000000
3195	1683	95040032000000
3196	1397	1430749208000
3197	1678	1440030792000
3198	1681	5759170000000
3199	1681	5759180000000
3200	1397	1430739207000
3201	1678	1440030793000
3202	1397	1430729206000
3203	1678	1440030794000
3204	1397	1430719205000
3205	1678	1440030795000
3206	1683	96480032000000
3207	1683	96480042000000
3208	1402	7200130000000
3209	1402	7200140000000
3210	1687	2159020000000
3211	1687	2159030000000
3212	1397	1430709204000
3213	1678	1440030796000
3214	1677	33839731000000
3215	1677	33839741000000
3216	243	66720000000000
3217	243	66720010000000
3218	1397	1430699203000
3219	1678	1440030797000
3231	1402	8640150000000
3232	1402	8640190000000
3259	1685	10079210000000
3260	1685	10079300000000
3335	1686	4317960000000
3336	1686	4319310000000
3427	1397	1430559189000
3428	1678	1440030811000
3435	1397	1430539187000
3436	1678	1440030813000
3437	1679	10799491000000
3438	1679	10799501000000
3445	1727	1439010000000
3446	1727	1439020000000
3220	1402	7920140000000
3221	1402	7920150000000
3233	1693	6438246190677
3234	127	66037333809323
3235	1397	1430649198000
3236	1678	1440030802000
3237	1683	95040052000000
3238	1449	24000459
3239	1683	96480027999541
3261	1696	1438020000000
3262	1542	0
3263	1693	5629855549868
3264	304	66037333809323
3265	1693	5592511740545
3266	373	66037333809323
3267	1693	5555167931222
3268	402	66037333809323
3269	1693	5517824121899
3270	690	66037333809323
3271	1693	5516682794349
3272	731	2001131327550
3273	1693	5401812973049
3274	877	203168026440745
3275	1693	5364469163726
3276	191	66037333809323
3277	1693	5327125354403
3278	122	66037333809323
3279	1693	5323327104091
3280	5	6700788250312
3281	1693	5285983294768
3282	91	66037333809323
3283	1693	5248639485445
3284	99	66037333809323
3285	1693	5211295676122
3286	339	66037333809323
3287	1693	5173951866799
3288	420	66037333809323
3289	1693	5136608057476
3290	408	66037333809323
3291	1693	5099264248153
3292	206	66037333809323
3293	1693	5061920438830
3294	397	66037333809323
3295	1693	5024576629507
3296	534	66037333809323
3297	1693	4987232820184
3298	570	66037333809323
3299	1693	4813664210109
3300	894	306996475205388
3301	1693	4776320400786
3302	106	66037333809323
3303	1693	4738976591463
3304	146	66037333809323
3305	1693	4701632782140
3306	251	66037333809323
3307	1693	4664288972817
3308	89	66037333809323
3309	1693	4660319326376
3310	29	7003959646441
3311	1693	4622975517053
3312	84	66037333809323
3313	1693	4585631707730
3314	92	66037333809323
3315	1693	4548287898407
3316	395	66037333809323
3317	1693	4510944089084
3318	587	66037333809323
3319	1693	4473600279761
3320	611	66037333809323
3321	1693	4436256470438
3322	438	66037333809323
3323	1693	4433418151552
3324	710	5002828318886
3325	1693	4396074342229
3326	399	66037333809323
3327	1693	4358730532906
3328	322	66037333809323
3329	1397	1430629196000
3330	1678	1440030804000
3331	1397	1430619195000
3332	1678	1440030805000
3333	1467	721350000000
3337	1693	4074327339327
3338	910	503062168193579
3339	1397	1430609194000
3340	1678	1440030806000
3341	1693	4036983530004
3342	105	66037333809323
3343	1693	3999639720681
3344	500	66037333809323
3345	1693	3998498393131
3346	721	2001131327550
3347	1693	3961154583808
3348	560	66037333809323
3349	1693	3923810774485
3350	392	66037333809323
3351	1693	3886466965162
3352	194	66037333809323
3353	1693	3849123155839
3354	678	66037333809323
3355	1693	3811779346516
3356	320	66037333809323
3357	1693	3774435537193
3358	295	66037333809323
3359	1693	3737091727870
3360	78	66037333809323
3361	1693	3699747918547
3362	54	66037333809323
3363	1693	3662404109224
3364	594	66037333809323
3365	1693	3625440425959
3366	37	65364953683265
3367	1693	3281572797708
3368	1150	608248607628251
3369	1693	3244228988385
3370	163	66037333809323
3371	1704	719170000000
3373	1709	3599210000000
3374	1704	370000000
3375	1704	720370000000
3376	1704	720410000000
3411	1397	1430589192000
3412	1678	1440030808000
3413	1693	1621324364109
3414	353	66037333809323
3415	1693	1583980554786
3416	390	66037333809323
3417	1677	33839761000000
3429	1397	1430549188000
3430	1678	1440030812000
3431	1683	99360047999541
3432	1683	99360057999541
3439	1397	1430529186000
3440	1678	1440030814000
3441	1677	34559761000000
3442	1677	34559771000000
3447	1637	15840501000000
3448	1637	15840511000000
3222	1397	1430689202000
3223	1678	1440030798000
3224	1397	1430679201000
3225	1678	1440030799000
3226	1397	1430669200000
3227	1678	1440030800000
3228	1397	1430659199000
3229	1678	1440030801000
3230	1715	4319101000000
3240	1693	6400902381354
3241	309	66037333809323
3242	1693	6363558572031
3243	551	66037333809323
3244	1693	6326214762708
3245	217	66037333809323
3246	1693	5816574596483
3247	1030	901483095166225
3248	1693	5779230787160
3249	205	66037333809323
3250	1693	5741886977837
3251	138	66037333809323
3252	1693	5704543168514
3253	275	66037333809323
3254	1693	5667199359191
3255	225	66037333809323
3256	1397	1430639197000
3257	1678	1440030803000
3258	1679	10079491000000
3334	1622	1441360000000
3372	1677	33839901000000
3377	1397	1430599193000
3378	1678	1440030807000
3379	1693	3206885179062
3380	452	66037333809323
3381	1693	3201218541290
3382	739	10005656637772
3383	1693	3027649931215
3384	893	306996475205388
3385	1693	2990306121892
3386	150	66037333809323
3387	1693	2952962312569
3388	252	66037333809323
3389	1693	2915618503246
3390	450	66037333809323
3391	1693	2878274693923
3392	620	66037333809323
3393	1693	2840930884600
3394	245	66037333809323
3395	1693	2803587075277
3396	421	66037333809323
3397	1693	2766243265954
3398	520	66037333809323
3399	1693	2728899456631
3400	622	66040313809323
3401	1693	2691555647308
3402	652	66037333809323
3403	1693	1733355792078
3404	1276	1694938827606880
3405	1693	1696011982755
3406	108	66037333809323
3407	1693	1658668173432
3408	180	66037333809323
3409	1690	5759130000000
3410	1690	5759290000000
3418	1439	720030000000
3419	171	68160020000000
3420	171	68160050000000
3421	1397	1430579191000
3422	1678	1440030809000
3423	1397	1430569190000
3424	1678	1440030810000
3425	1683	97920027999541
3426	1683	97920047999541
3433	1637	15120491000000
3434	1637	15120501000000
3443	1610	4320080000000
3444	1610	4320090000000
3449	1397	1430519185000
3450	1678	1440030815000
3451	1397	1430509184000
3452	1678	1440030816000
3453	1683	99360067999541
3454	1692	10079431000000
3455	1397	1430499183000
3456	1678	1440030817000
3457	1513	1440020000000
3458	1397	1430489182000
3459	1678	1440030818000
3460	1716	2879070000000
3461	1716	2879080000000
3462	1397	1430479181000
3463	1678	1440030819000
3464	1458	5040100000000
3465	1458	5040110000000
3466	1397	1430469180000
3467	1678	1440030820000
3468	1397	1430459179000
3469	1678	1440030821000
3470	1397	1430449178000
3471	1678	1440030822000
3472	1723	5039080000000
3473	1723	5039110000000
3474	1610	4320110000000
3475	1397	1430439177000
3476	1678	1440030823000
3477	1423	10000000
3478	1397	1430429176000
3479	1678	1440030824000
3480	1474	3600040000000
3481	1474	3600050000000
3482	1397	1430419175000
3483	1678	1440030825000
3484	1536	3600070000000
3485	1602	3600050000000
3486	1602	3600060000000
3487	58	68880060000000
3488	58	68880070000000
3489	1495	720000000000
3490	1495	720010000000
3491	1397	1430409174000
3492	1678	1440030826000
3493	1422	1440020000000
3494	58	69600070000000
3495	58	69600080000000
3496	1693	1546636745463
3497	569	66037333809323
3498	1693	1545495417913
3499	745	2001131327550
3500	1693	1508151608590
3501	41	66037333809323
3502	1693	1470807799267
3503	308	66037333809323
3504	1693	1355937977967
3505	878	203168026440745
3506	1693	1318594168644
3507	186	66037333809323
3508	1397	1430399173000
3509	1678	1440030827000
3510	1397	1430389172000
3511	1678	1440030828000
3512	1693	1281250359321
3513	49	66037333809323
3514	1693	1243906549998
3515	112	66037333809323
3516	1693	1206562740675
3517	383	66037333809323
3518	1693	1169218931352
3519	663	66037333809323
3520	1693	1131875122029
3521	499	66037333809323
3522	1693	1121004377503
3523	35	19210860744526
3524	1693	1083660568180
3525	453	66037333809323
3526	1693	1046316758857
3527	82	66037333809323
3528	1679	11519501000000
3529	1679	11519661000000
3530	1397	1430379171000
3531	1678	1440030829000
3532	1693	1008972949534
3533	201	66037333809323
3534	1693	971629140211
3535	103	66037333809323
3536	1693	934285330888
3537	261	66037333809323
3538	1693	896941521565
3539	361	66037333809323
3540	1693	859597712242
3541	680	66037333809323
3542	1693	822253902919
3543	63	66037333809323
3544	1693	784910093596
3545	377	66037333809323
3546	1693	747566284273
3547	266	66037333809323
3548	1489	1440100000000
3549	1489	1440090000000
3550	1531	720000000000
3551	1531	720090000000
3552	1397	1430369170000
3553	1678	1440030830000
3554	1693	710222474950
3555	600	66037333809323
3556	1693	672878665627
3557	691	66037333809323
3558	1693	635534856304
3559	352	66037333809323
3560	1693	598191046981
3561	601	66037333809323
3562	1693	560847237658
3563	504	66037333809323
3564	1693	523503428335
3565	658	66037333809323
3566	1693	505076547069
3567	6	32576416881266
3568	1693	467732737746
3569	391	66037333809323
3570	1693	430388928423
3571	660	66037333809323
3572	1700	1439010000000
3573	1700	1439110000000
3586	1711	2879040000000
3587	1711	2879080000000
3592	1397	1430339167000
3593	1678	1440030833000
3594	1650	1440010000000
3595	1650	1440020000000
3605	1397	1430299163000
3606	1678	1440030837000
3607	1683	100800067999541
3608	1683	100800077999541
3617	1608	1440010000000
3618	1608	1440020000000
3621	1397	1430279161000
3622	1678	1440030839000
3623	1397	1430269160000
3624	1678	1440030840000
3628	1397	1430259159000
3629	1678	1440030841000
3630	1694	6479050000000
3631	1694	6479060000000
3637	1397	1430239157000
3638	1678	1440030843000
3639	1397	1430229156000
3640	1678	1440030844000
3641	43	68160050000000
3642	43	68160070000000
3670	1705	1434810000000
3671	1705	1434820000000
3680	1397	1430139147000
3681	1678	1440030853000
3682	1397	1430129146000
3683	1678	1440030854000
3684	1397	1430119145000
3685	1678	1440030855000
3686	1685	10079220000000
3694	1397	1430089142000
3695	1678	1440030858000
3696	1444	3600090000000
3697	1444	4320090000000
3701	1698	1438910000000
3702	1698	1438920000000
3709	1714	2158920000000
3710	1714	2158930000000
3723	1700	2159110000000
3724	1700	2159120000000
3731	1397	1430029136000
3732	1678	1440030864000
3733	1397	1430019135000
3734	1678	1440030865000
3735	1705	2154820000000
3736	1705	2154840000000
3747	363	66720000000000
3748	363	66720030000000
3749	1397	1429979131000
3750	1678	1440030869000
3753	1397	1429959129000
3754	1678	1440030871000
3760	1397	1429939127000
3761	1678	1440030873000
3762	1397	1429929126000
3763	1678	1440030874000
3764	1683	106560137999541
3776	1536	3600080000000
3777	1397	1429889122000
3778	1678	1440030878000
3779	1671	4320140000000
3780	1671	4320150000000
3781	1677	38159841000000
3782	1677	38159851000000
3789	1397	1429859119000
3790	1678	1440030881000
3791	1677	38879851000000
3792	1677	38879861000000
3793	1397	1429849118000
3794	1678	1440030882000
3795	1397	1429839117000
3796	1678	1440030883000
3797	1657	2160060000000
3804	1397	1429819115000
3805	1678	1440030885000
3806	1552	720000000000
3807	1552	720010000000
3808	1397	1429809114000
3809	1678	1440030886000
3810	1397	1429799113000
3811	1678	1440030887000
3812	1680	5039130000000
3817	1397	1429779111000
3818	1678	1440030889000
3819	1679	12239671000000
3826	1397	1429759109000
3827	1678	1440030891000
3828	1397	1429749108000
3829	1678	1440030892000
3830	1596	2160030000000
3831	1596	2160050000000
3832	1397	1429739107000
3833	1678	1440030893000
3834	1397	1429729106000
3835	1678	1440030894000
3836	1517	0
3837	1694	6479080000000
3574	1397	1430359169000
3575	1678	1440030831000
3576	1693	393045119100
3577	193	66037333809323
3578	1693	355701309777
3579	593	66037333809323
3580	1693	318357500454
3581	653	66037333809323
3582	1688	12239262000000
3583	1688	12239302000000
3588	1397	1430349168000
3589	1678	1440030832000
3590	1677	35999811000000
3591	1677	35999821000000
3598	1397	1430319165000
3599	1678	1440030835000
3603	1559	4320110000000
3604	1559	4320120000000
3611	1397	1430289162000
3612	1678	1440030838000
3613	1670	4320290000000
3614	1670	4320300000000
3619	1541	2160020000000
3620	1541	2160030000000
3626	1681	6479180000000
3627	1681	6479200000000
3632	1447	3600040000000
3633	1447	3600050000000
3634	1397	1430249158000
3635	1678	1440030842000
3636	1688	12239272000000
3643	1637	15840521000000
3650	1397	1430199153000
3651	1678	1440030847000
3652	1680	5039110000000
3653	1680	5039120000000
3659	30	6000100000000
3660	1397	1430189152000
3661	1678	1440030848000
3662	1688	13679282000000
3663	1688	13679392000000
3664	1397	1430179151000
3665	1678	1440030849000
3666	1693	1038357500454
3667	1693	1038367500454
3672	1397	1430159149000
3673	1678	1440030851000
3674	1683	105120107999541
3675	1683	105120117999541
3693	1476	3600070000000
3703	1693	1758367500454
3704	1693	1758377500454
3711	1397	1430059139000
3712	1678	1440030861000
3713	1402	9360190000000
3714	1402	9360200000000
3717	1397	1430049138000
3718	1678	1440030862000
3719	1688	14399392000000
3720	1688	14399402000000
3725	1513	2160020000000
3726	1513	2160030000000
3737	1397	1430009134000
3738	1678	1440030866000
3739	1397	1429999133000
3740	1678	1440030867000
3741	1397	1429989132000
3742	1678	1440030868000
3743	1683	106560117999541
3744	1683	106560147999541
3751	1397	1429969130000
3752	1678	1440030870000
3759	298	68879440000000
3767	1397	1429919125000
3768	1678	1440030875000
3769	633	68880030000000
3770	633	68880040000000
3787	1397	1429869120000
3788	1678	1440030880000
3798	1685	10799220000000
3799	1685	10799240000000
3815	1397	1429789112000
3816	1678	1440030888000
3824	311	70320080000000
3825	311	70320090000000
3584	1677	35279771000000
3585	1677	35279811000000
3596	1397	1430329166000
3597	1678	1440030834000
3600	1397	1430309164000
3601	1678	1440030836000
3602	1445	1440030000000
3609	1709	4319210000000
3610	1709	4319220000000
3615	1683	102240077999541
3616	1683	102240087999541
3625	1506	2160040000000
3644	1397	1430219155000
3645	1678	1440030845000
3646	1397	1430209154000
3647	1678	1440030846000
3648	1683	103680087999541
3649	1683	103680107999541
3654	1688	12959272000000
3655	1688	12959282000000
3656	1680	4319390000000
3657	1680	5039390000000
3658	1680	5039810000000
3668	1397	1430169150000
3669	1678	1440030850000
3676	1397	1430149148000
3677	1678	1440030852000
3678	1447	4320050000000
3679	1447	4320060000000
3687	1397	1430109144000
3688	1678	1440030856000
3689	1397	1430099143000
3690	1678	1440030857000
3691	298	68879430000000
3692	298	68879450000000
3698	1703	1439030000000
3699	1397	1430079141000
3700	1678	1440030859000
3705	1397	1430069140000
3706	1678	1440030860000
3707	1684	4319040000000
3708	1684	4319050000000
3715	1672	2160020000000
3716	1672	2160030000000
3721	1677	36719821000000
3722	1677	36719831000000
3727	1397	1430039137000
3728	1678	1440030863000
3729	1467	1441350000000
3730	1467	1441360000000
3745	1679	12239661000000
3746	1679	12239691000000
3755	1397	1429949128000
3756	1678	1440030872000
3757	1677	37439831000000
3758	1677	37439841000000
3765	1445	2160030000000
3766	1445	2160050000000
3771	1397	1429909124000
3772	1678	1440030876000
3773	1397	1429899123000
3774	1678	1440030877000
3775	1670	4320310000000
3783	1397	1429879121000
3784	1678	1440030879000
3785	1402	10080200000000
3786	1402	10080210000000
3800	1397	1429829116000
3801	1678	1440030884000
3802	1518	1440010000000
3803	1518	1440020000000
3813	1690	6479290000000
3814	1690	6479310000000
3820	1397	1429769110000
3821	1678	1440030890000
3822	1683	108000137999541
3823	1683	108000147999541
3838	1402	10800210000000
3839	1402	10800240000000
3840	1397	1429719105000
3841	1678	1440030895000
3842	1397	1429709104000
3843	1678	1440030896000
3844	1397	1429699103000
3845	1678	1440030897000
3846	1560	2160070000000
3847	1397	1429689102000
3848	1678	1440030898000
3849	576	68160020000000
3850	576	68160030000000
3851	1397	1429679101000
3852	1678	1440030899000
3853	1397	1429669100000
3854	1678	1440030900000
3855	1608	1440030000000
3856	1693	2478377500454
3857	1693	2478397500454
3858	1650	2160020000000
3859	1650	2160040000000
3860	1685	11519240000000
3861	1685	11519260000000
3862	1397	1429659099000
3863	1678	1440030901000
3864	1397	1429649098000
3865	1678	1440030902000
3866	1402	10800220000000
3867	1739	2159030000000
3868	1739	2159040000000
3869	1397	1429639097000
3870	1678	1440030903000
3871	1622	1440020000000
3872	1397	1429629096000
3873	1678	1440030904000
3874	700	67440010000000
3875	700	67440020000000
3876	1397	1429619095000
3877	1678	1440030905000
3878	1683	109440147999541
3879	1683	109440157999541
3880	1397	1429609094000
3881	1678	1440030906000
3882	1683	110880157999541
3883	1683	110880167999541
3884	1677	39599861000000
3885	1677	39599871000000
3886	44	68880140000000
3887	1573	4320070000000
3888	1573	4320080000000
3889	1397	1429599093000
3890	1678	1440030907000
3891	1397	1429589092000
3892	1678	1440030908000
3893	1397	1429579091000
3894	1678	1440030909000
3895	1634	2160060000000
3896	1634	2880060000000
3897	1716	2879090000000
3898	1716	3599090000000
3899	1740	719030000000
3900	1740	1439030000000
3901	1397	1429569090000
3902	1678	1440030910000
3903	1447	5040060000000
3904	1447	5040070000000
3905	1692	10799421000000
3906	1692	10799431000000
3907	1397	1429559089000
3908	1678	1440030911000
3909	1677	40319871000000
3910	1677	40319881000000
3911	1397	1429549088000
3912	1678	1440030912000
3913	1397	1429539087000
3914	1678	1440030913000
3915	1397	1429529086000
3916	1678	1440030914000
3917	1683	110880187999541
3918	1397	1429519085000
3919	1678	1440030915000
3920	1682	2867100000000
3921	1682	2867110000000
3922	1397	1429509084000
3923	1678	1440030916000
3924	1397	1429499083000
3925	1678	1440030917000
3926	1740	2159030000000
3927	1740	2159040000000
3928	1397	1429489082000
3929	1678	1440030918000
3930	1397	1429479081000
3931	1678	1440030919000
3932	1455	1440010000000
3933	1455	1440030000000
3934	1397	1429469080000
3935	1678	1440030920000
3936	1397	1429459079000
3937	1678	1440030921000
3938	1397	1429449078000
3939	1678	1440030922000
3940	1677	41039881000000
3941	1677	41039911000000
3942	1717	1439080000000
3943	1471	1440040000000
3944	1397	1429439077000
3945	1678	1440030923000
3946	1402	11520220000000
3947	1402	11520230000000
3958	1397	1429399073000
3959	1678	1440030927000
3960	1397	1429389072000
3961	1678	1440030928000
3962	311	71040090000000
3963	311	71040110000000
3969	1397	1429369070000
3970	1678	1440030930000
3971	1691	1439020000000
3972	1397	1429359069000
3973	1678	1440030931000
3974	1397	1429349068000
3975	1678	1440030932000
3976	1602	3600070000000
3987	1634	2880050000000
3996	1397	1429289062000
3997	1678	1440030938000
4025	1701	4318190000000
4026	1701	4318210000000
4029	1643	2160030000000
4030	1643	2160040000000
4031	1397	1429209054000
4032	1678	1440030946000
4033	1677	42479911000000
4034	1677	42479921000000
4073	1602	4320070000000
4074	1602	4320100000000
4083	1704	719010000000
4093	1397	1429039037000
4094	1678	1440030963000
4095	1683	115200207999541
4096	1683	115200217999541
4101	1397	1429019035000
4102	1678	1440030965000
4103	1701	4318200000000
4111	1397	1428989032000
4112	1678	1440030968000
4115	1451	2160120000000
4116	1451	2160130000000
4117	1439	1440010000000
4118	1439	1440020000000
4127	1397	1428939027000
4128	1678	1440030973000
4135	641	68160260000000
4136	1397	1428919025000
4137	1678	1440030975000
4138	1679	12959671000000
4139	1679	12959681000000
4149	1694	7199120000000
4155	1397	1428869020000
4156	1678	1440030980000
4157	1402	12960240000000
4158	1402	12960250000000
4169	1397	1428839017000
4170	1678	1440030983000
4181	1397	1428799013000
4182	1678	1440030987000
4183	1402	13680250000000
4184	1402	13680260000000
4189	1397	1428779011000
4190	1678	1440030989000
4193	1397	1428769010000
4194	1678	1440030990000
4211	1489	1440060000000
4220	1685	12239280000000
4221	1685	12239301000000
4232	1397	1428638997000
4233	1678	1440031003000
4234	1596	2880050000000
4235	1596	2880060000000
4247	1690	7199850000000
4248	1397	1428608994000
4249	1678	1440031006000
4250	1740	2159539000000
4251	1690	7919850000000
4252	1690	7920013000000
4253	1397	1428598993000
4254	1678	1440031007000
4255	1680	6479130000000
4256	1680	6479150000000
4259	1695	3598970000000
4260	1695	3598980000000
4261	1397	1428578991000
4262	1678	1440031009000
4263	1683	118080227999541
4264	1683	118080237999541
4267	1694	7919090000000
4268	1694	7919100000000
4269	1397	1428568990000
4270	1678	1440031010000
4271	1740	5037539000000
4272	1740	5037549000000
4273	1397	1428558989000
4274	1678	1440031011000
4275	1599	4320060000000
4276	1599	4320070000000
4284	1724	2158550000000
4285	1724	2878550000000
3948	1397	1429429076000
3949	1678	1440030924000
3950	1683	112320187999541
3951	1683	112320197999541
3954	1397	1429409074000
3955	1678	1440030926000
3956	1549	2880031000000
3957	1549	2880041000000
3965	1397	1429379071000
3966	1678	1440030929000
3967	1688	15119402000000
3968	1688	15119412000000
3977	1397	1429339067000
3978	1678	1440030933000
3981	1397	1429319065000
3982	1678	1440030935000
3983	1688	15839412000000
3984	1688	15839422000000
3988	1397	1429309064000
3989	1678	1440030936000
3990	1680	5759120000000
3991	1680	5759130000000
3998	1397	1429279061000
3999	1678	1440030939000
4000	1677	41039891000000
4005	1402	12240230000000
4006	1402	12240240000000
4007	1611	2160020000000
4008	1611	2160030000000
4013	1723	5039090000000
4014	1397	1429249058000
4015	1678	1440030942000
4016	1536	4320080000000
4017	1536	4320090000000
4018	1677	41759891000000
4019	1677	41759901000000
4020	1397	1429239057000
4021	1678	1440030943000
4022	1397	1429229056000
4023	1678	1440030944000
4024	1677	41759911000000
4027	1397	1429219055000
4028	1678	1440030945000
4045	1397	1429159049000
4046	1678	1440030951000
4047	596	67440010000000
4048	596	67440020000000
4051	1397	1429149048000
4052	1678	1440030952000
4053	1397	1429139047000
4054	1678	1440030953000
4055	1397	1429129046000
4056	1678	1440030954000
4057	1397	1429119045000
4058	1678	1440030955000
4059	1693	2478417500454
4061	667	66720000000000
4062	667	66720040000000
4063	1397	1429109044000
4064	1678	1440030956000
4065	1690	7199310000000
4066	1690	7199500000000
4067	1397	1429099043000
4068	1678	1440030957000
4069	1397	1429089042000
4070	1678	1440030958000
4071	1637	16560521000000
4072	1637	16560551000000
4077	1397	1429069040000
4078	1678	1440030960000
4079	1746	719000000000
4080	1746	719010000000
4084	1397	1429059039000
4085	1678	1440030961000
4086	1654	3600070000000
4087	1654	3600080000000
4089	632	68160060000000
4090	632	68160070000000
4091	1397	1429049038000
4092	1678	1440030962000
4099	1549	3600041000000
4100	1549	3600051000000
4113	1683	116640217999541
4114	1683	116640227999541
4125	1397	1428949028000
4126	1678	1440030972000
4129	1650	2880040000000
4130	1650	2880050000000
4150	44	68880170000000
4153	1724	2878540000000
4154	1724	2878580000000
4159	1610	5040110000000
4160	1610	5040120000000
4161	1397	1428859019000
4162	1678	1440030981000
4163	1397	1428849018000
4164	1678	1440030982000
4165	563	68158529000000
4166	1740	2160540000000
4167	596	68160020000000
4168	596	68160041000000
4185	1634	3600060000000
4186	1634	3600070000000
4197	1637	17280531000000
4198	1637	17280541000000
4199	1397	1428749008000
4200	1678	1440030992000
4201	1397	1428739007000
4202	1678	1440030993000
4203	1397	1428729006000
4204	1678	1440030994000
4205	1397	1428719005000
4206	1678	1440030995000
4207	1397	1428709004000
4208	1678	1440030996000
4209	1516	4320160000000
4210	1516	4320210000000
4222	1397	1428679001000
4223	1678	1440030999000
4224	1397	1428669000000
4225	1678	1440031000000
4226	1397	1428658999000
4227	1678	1440031001000
4228	1716	3599080000000
4229	1716	3599110000000
4236	1685	12239290000000
4241	1397	1428618995000
4242	1678	1440031005000
4243	1637	18000541000000
4244	1637	18000551000000
4277	1397	1428548988000
4278	1678	1440031012000
4281	1397	1428538987000
4282	1678	1440031013000
4283	1422	720020000000
4286	1448	3600190000000
4287	1448	4320190000000
3952	1397	1429419075000
3953	1678	1440030925000
3964	1643	1440030000000
3979	1397	1429329066000
3980	1678	1440030934000
3985	1683	113760197999541
3986	1683	113760207999541
3992	1397	1429299063000
3993	1678	1440030937000
3994	1608	2160030000000
3995	1608	2160040000000
4001	1397	1429269060000
4002	1678	1440030940000
4003	1722	7194090000000
4004	1722	7194100000000
4009	1397	1429259059000
4010	1678	1440030941000
4011	1694	7199080000000
4012	1694	7199090000000
4035	1397	1429199053000
4036	1678	1440030947000
4037	1397	1429189052000
4038	1678	1440030948000
4039	1397	1429179051000
4040	1678	1440030949000
4041	1397	1429169050000
4042	1678	1440030950000
4043	1684	5039050000000
4044	1684	5039090000000
4049	1677	43199921000000
4050	1677	43199931000000
4060	1685	11519280000000
4075	1397	1429079041000
4076	1678	1440030959000
4081	1747	719000000000
4082	1747	719010000000
4088	311	71040100000000
4097	1397	1429029036000
4098	1678	1440030964000
4104	1397	1429009034000
4105	1678	1440030966000
4106	1549	4320051000000
4107	1549	4320061000000
4108	1397	1428999033000
4109	1678	1440030967000
4110	1637	16560531000000
4119	1397	1428979031000
4120	1678	1440030969000
4121	1397	1428969030000
4122	1678	1440030970000
4123	1397	1428959029000
4124	1678	1440030971000
4131	1397	1428929026000
4132	1678	1440030974000
4133	1693	1758267500454
4134	312	66000100000000
4140	1397	1428909024000
4141	1678	1440030976000
4142	1397	1428899023000
4143	1678	1440030977000
4144	1397	1428889022000
4145	1678	1440030978000
4146	1397	1428879021000
4147	1678	1440030979000
4148	1683	116640257999541
4151	1677	43919931000000
4152	1677	43919971000000
4171	1397	1428829016000
4172	1678	1440030984000
4173	1397	1428819015000
4174	1678	1440030985000
4175	1397	1428809014000
4176	1678	1440030986000
4177	563	66000528000000
4178	1740	4318540000000
4179	1649	2880040000000
4180	1649	2880061000000
4187	1397	1428789012000
4188	1678	1440030988000
4191	1546	4320070000000
4192	1546	4320080000000
4195	1397	1428759009000
4196	1678	1440030991000
4212	1397	1428699003000
4213	1678	1440030997000
4214	1397	1428689002000
4215	1678	1440030998000
4216	1740	4317539000000
4217	1748	0
4218	1696	2158020000000
4219	1696	2158041000000
4230	1397	1428648998000
4231	1678	1440031002000
4237	1397	1428628996000
4238	1678	1440031004000
4239	1699	4319099000000
4240	1699	4319109000000
4245	1685	12959290000000
4246	1685	12959300000000
4257	1397	1428588992000
4258	1678	1440031008000
4265	1690	8640013000000
4266	1690	8640043000000
4279	1690	9360043000000
4280	1690	9360073000000
4288	1397	1428528986000
4289	1678	1440031014000
4290	576	68880030000000
4291	576	68880040000000
4292	1397	1428518985000
4293	1678	1440031015000
4294	1549	5040061000000
4295	1549	5040071000000
4296	1397	1428508984000
4297	1678	1440031016000
4298	1397	1428498983000
4299	1678	1440031017000
4300	1439	2160020000000
4301	1439	2160040000000
4302	1677	44639971000000
4303	1677	44639991000000
4304	1397	1428488982000
4305	1678	1440031018000
4306	1397	1428478981000
4307	1678	1440031019000
4308	1397	1428468980000
4309	1678	1440031020000
4310	1740	5036548000000
4311	1748	1000000000
4312	1402	13680281000000
4313	1397	1428458979000
4314	1678	1440031021000
4315	1677	45359991000000
4316	1677	45360001000000
4317	58	70320080000000
4318	58	70320090000000
4319	1397	1428448978000
4320	1678	1440031022000
4321	1677	46080001000000
4322	1677	46080011000000
4323	1397	1428438977000
4324	1678	1440031023000
4325	1748	999000000
4326	418	66000000000000
4327	1683	118080238999541
4328	633	68880041000000
4329	1693	2478267500454
4330	1693	2478278500454
4331	1397	1428428976000
4332	1678	1440031024000
4333	1397	1428418975000
4334	1678	1440031025000
4335	1683	119520238999541
4336	1683	119520248999541
4337	1397	1428408974000
4338	1678	1440031026000
4339	1683	120960248999541
4340	1683	120960258999541
4341	1397	1428398973000
4342	1678	1440031027000
4343	1711	2879050000000
4344	1397	1428388972000
4345	1678	1440031028000
4346	1701	5038200000000
4347	1701	5038210000000
4348	1397	1428378971000
4349	1678	1440031029000
4350	1397	1428368970000
4351	1678	1440031030000
4352	596	68880041000000
4353	596	68880061000000
4354	1397	1428358969000
4355	1678	1440031031000
4356	1654	4320080000000
4357	1654	4320090000000
4358	1677	46800011000000
4359	1677	46800021000000
4360	1729	2879030000000
4361	1729	2879040000000
4362	1397	1428348968000
4363	1678	1440031032000
4364	576	69600040000000
4365	576	69600050000000
4366	1744	900000000
4367	1397	1428338967000
4368	1678	1440031033000
4369	1397	1428328966000
4370	1678	1440031034000
4371	1724	2878660000000
4380	1714	2878930000000
4381	1714	2878950000000
4400	1397	1428228956000
4401	1678	1440031044000
4402	1675	1440010000000
4403	1675	1440020000000
4404	1397	1428218955000
4405	1678	1440031045000
4406	1397	1428208954000
4407	1678	1440031046000
4408	1397	1428198953000
4409	1678	1440031047000
4410	1397	1428188952000
4411	1678	1440031048000
4412	448	66000000000000
4413	1397	1428178951000
4414	1678	1440031049000
4415	1709	4319270000000
4420	1397	1428168950000
4421	1678	1440031050000
4426	1679	13679681000000
4427	1679	13679691000000
4434	1675	2160020000000
4435	1675	2160030000000
4446	1397	1428128946000
4447	1678	1440031054000
4448	1397	1428118945000
4449	1678	1440031055000
4450	1397	1428108944000
4451	1678	1440031056000
4452	1397	1428098943000
4453	1678	1440031057000
4454	1397	1428088942000
4455	1678	1440031058000
4456	1699	5039159000000
4457	1397	1428078941000
4458	1678	1440031059000
4459	470	70320060000000
4460	470	70320070000000
4465	1656	5760081000000
4466	1656	5760091000000
4479	1397	1428048938000
4480	1678	1440031062000
4483	1397	1428038937000
4484	1678	1440031063000
4485	1397	1428028936000
4486	1678	1440031064000
4487	1657	3600070000000
4488	1657	3600100000000
4489	1397	1428018935000
4490	1678	1440031065000
4493	1699	5759159000000
4494	1699	5759169000000
4499	1735	1438006000000
4500	1745	2000000
4501	470	71040081000000
4507	1397	1427988932000
4508	1678	1440031068000
4509	1397	1427978931000
4510	1678	1440031069000
4511	58	70320100000000
4518	58	70320110000000
4521	1397	1427948928000
4522	1678	1440031072000
4523	1683	129600358999541
4524	1683	129600368999541
4532	1397	1427908924000
4533	1678	1440031076000
4534	1678	2160031076000
4535	1678	2160041076000
4543	1715	4319091000000
4544	1397	1427868920000
4545	1678	2160041080000
4546	576	70320050000000
4547	576	70320060000000
4554	1397	1427838917000
4555	1678	2160041083000
4556	1397	1427828916000
4557	1678	2160041084000
4558	1476	4320070000000
4559	1476	4320090000000
4572	1596	2880070000000
4588	1397	1427788912000
4589	1678	2160041088000
4590	1402	15120291000000
4591	1402	15120301000000
4596	1397	1427768910000
4597	1678	2160041090000
4608	1397	1427728906000
4609	1678	2160041094000
4610	1740	5036523000000
4611	1397	1427718905000
4612	1678	2160041095000
4613	1397	1427708904000
4614	1678	2160041096000
4615	1694	9359205000000
4628	1397	1427678901000
4629	1678	2160041099000
4630	1397	1427668900000
4631	1678	2160041100000
4632	1397	1427658899000
4633	1678	2160041101000
4634	1397	1427648898000
4635	1678	2160041102000
4636	1455	2880040000000
4637	1455	2880080000000
4643	1650	3600050000000
4644	1650	3600060000000
4650	1397	1427618895000
4651	1678	2160041105000
4652	1683	131040368999541
4653	1683	131040378999541
4663	1397	1427578891000
4664	1678	2160041109000
4665	1673	2160270000000
4666	1673	2160280000000
4697	1397	1427558889000
4698	1678	2160041111000
4716	1693	2478317500454
4723	1397	1427468880000
4724	1678	2160041120000
4725	1397	1427458879000
4726	1678	2160041121000
4727	1745	8405000000
4728	1752	100000000
4729	596	69600061000000
4730	596	69600082000000
4738	1637	18720611000000
4739	1637	19440611000000
4759	1729	3599040000000
4760	1729	3599060000000
4761	1397	1427378871000
4762	1678	2160041129000
4763	1752	97000000
4764	1745	8406000000
4765	1687	2159031000000
4372	1397	1428318965000
4373	1678	1440031035000
4374	1397	1428308964000
4375	1678	1440031036000
4376	1740	4316538000000
4377	1690	10080073000000
4378	1690	10080414000000
4382	1397	1428298963000
4383	1678	1440031037000
4384	1397	1428288962000
4385	1678	1440031038000
4386	1397	1428278961000
4387	1678	1440031039000
4388	1397	1428268960000
4389	1678	1440031040000
4390	1397	1428258959000
4391	1678	1440031041000
4392	1397	1428248958000
4393	1678	1440031042000
4394	1683	122400258999541
4395	1683	122400318999541
4396	1397	1428238957000
4397	1678	1440031043000
4398	1683	123840318999541
4399	1683	123840328999541
4418	1694	8639100000000
4419	1694	8639160000000
4424	1471	2160040000000
4425	1471	2160050000000
4428	1694	9359160000000
4429	1694	9359170000000
4436	1699	5039109000000
4437	1699	5039119000000
4444	1688	16559422000000
4445	1688	16559442000000
4467	1688	16559432000000
4474	1700	2879110000000
4475	1700	2879130000000
4476	1677	46800031000000
4481	1704	1439010000000
4482	1704	1439020000000
4491	1402	14400281000000
4492	1402	14400291000000
4506	1683	128160358999541
4514	1397	1427968930000
4515	1678	1440031070000
4516	1467	2161360000000
4517	1467	2161390000000
4525	1397	1427938927000
4526	1678	1440031073000
4527	1397	1427928926000
4528	1678	1440031074000
4529	1397	1427918925000
4530	1678	1440031075000
4531	1688	16559452000000
4548	1722	6476080000000
4549	1722	6476090000000
4550	1397	1427858919000
4551	1678	2160041081000
4552	1397	1427848918000
4553	1678	2160041082000
4560	1693	2478287500454
4561	1397	1427818915000
4562	1678	2160041085000
4563	1700	2879120000000
4586	1486	720000000000
4587	1486	720020000000
4605	1397	1427738907000
4606	1678	2160041093000
4607	1685	13679310000000
4616	1397	1427698903000
4617	1678	2160041097000
4618	1745	9506000000
4619	1750	7500000000
4620	1695	3598981000000
4623	1555	2160021000000
4638	1637	18720591000000
4645	1633	2160030000000
4654	1397	1427608894000
4655	1678	2160041106000
4656	1397	1427598893000
4657	1678	2160041107000
4658	1489	1440030000000
4667	1740	4316513000000
4668	1678	1440031088000
4669	1678	1440031089000
4670	1678	1440031090000
4671	1678	1440031091000
4672	1678	1440031092000
4673	1678	1440031093000
4674	1678	1440031094000
4675	1678	1440031095000
4676	1678	1440031096000
4677	1678	1440031097000
4678	1690	10801080000000
4679	1678	1440031098000
4680	1678	1440031099000
4681	1678	1440031100000
4682	1678	1440031101000
4683	1678	1440031102000
4684	1678	1440031103000
4685	1678	1440031104000
4686	1678	1440031105000
4687	1678	1440031106000
4688	1678	1440031107000
4689	1678	1440031108000
4690	1678	1440031109000
4691	1690	11521080000000
4692	1690	11521201000000
4699	1397	1427548888000
4700	1678	2160041112000
4701	1397	1427538887000
4702	1678	2160041113000
4703	42	67440040000000
4704	1397	1427528886000
4705	1678	2160041114000
4706	1397	1427518885000
4707	1678	2160041115000
4708	1397	1427508884000
4709	1678	2160041116000
4710	1397	1427498883000
4711	1678	2160041117000
4712	1397	1427488882000
4713	1678	2160041118000
4714	1694	10079205000000
4715	1694	10079255000000
4719	1397	1427478881000
4720	1678	2160041119000
4740	1397	1427428876000
4741	1678	2160041124000
4742	1740	5756523000000
4743	1740	5756533000000
4753	1722	7196090000000
4754	1722	7196101000000
4755	1397	1427398873000
4756	1678	2160041127000
4757	1397	1427388872000
4758	1678	2160041128000
4379	1687	2159040000000
4416	1711	3599050000000
4417	1711	3599110000000
4422	1474	4320050000000
4423	1474	4320060000000
4430	1397	1428158949000
4431	1678	1440031051000
4432	1683	125280328999541
4433	1683	125280338999541
4438	1397	1428148948000
4439	1678	1440031052000
4440	1397	1428138947000
4441	1678	1440031053000
4442	1657	2880050000000
4443	1657	2880070000000
4461	1397	1428068940000
4462	1678	1440031060000
4463	1455	2160030000000
4464	1455	2160040000000
4468	1397	1428058939000
4469	1678	1440031061000
4470	1722	5756080000000
4471	1749	717000000000
4472	1683	126720338999541
4473	1683	126720358999541
4477	1623	4320060000000
4478	1623	4320080000000
4495	1397	1428008934000
4496	1678	1440031066000
4497	470	71040070000000
4498	470	71040080000000
4502	1419	3600070000000
4503	1419	3600080000000
4504	1397	1427998933000
4505	1678	1440031067000
4512	1685	13679300000000
4513	1685	13679320000000
4519	1397	1427958929000
4520	1678	1440031071000
4536	1397	1427898923000
4537	1678	2160041077000
4538	1397	1427888922000
4539	1678	2160041078000
4540	1397	1427878921000
4541	1678	2160041079000
4542	1610	5040140000000
4564	1680	7199150000000
4565	1680	7199160000000
4566	1397	1427808914000
4567	1678	2160041086000
4568	1397	1427798913000
4569	1678	2160041087000
4570	1474	5040060000000
4571	1474	5040080000000
4573	1678	1440031077000
4574	1678	1440031078000
4575	1678	1440031079000
4576	1678	1440031080000
4577	1678	1440031081000
4578	1678	1440031082000
4579	1678	1440031083000
4580	1678	1440031084000
4581	1678	1440031085000
4582	1678	1440031086000
4583	1678	1440031087000
4584	1690	10800414000000
4585	1690	10800955000000
4592	1397	1427778911000
4593	1678	2160041089000
4594	1688	17279452000000
4595	1688	17279462000000
4598	1397	1427758909000
4599	1678	2160041091000
4600	1397	1427748908000
4601	1678	2160041092000
4602	1735	1420000000000
4603	1745	18007000000
4604	1623	4320081000000
4621	1637	18720551000000
4622	1637	18720562000000
4624	1397	1427688902000
4625	1678	2160041098000
4626	1685	14399310000000
4627	1685	14399320000000
4639	1397	1427638897000
4640	1678	2160041103000
4641	1402	15840301000000
4642	1402	15840311000000
4646	1397	1427628896000
4647	1678	2160041104000
4648	1698	2158920000000
4649	1698	2158930000000
4659	1397	1427588892000
4660	1678	2160041108000
4661	1751	719000000000
4662	1751	719010000000
4693	1397	1427568890000
4694	1678	2160041110000
4695	1677	47520031000000
4696	1677	47520041000000
4717	1716	4319110000000
4718	1716	4319160000000
4721	1714	3598950000000
4722	1714	3598960000000
4731	1546	4320091000000
4732	1397	1427448878000
4733	1678	2160041122000
4734	1397	1427438877000
4735	1678	2160041123000
4736	1677	47520061000000
4737	1677	48240061000000
4744	1397	1427418875000
4745	1678	2160041125000
4746	1571	4320050000000
4747	1571	4320060000000
4748	1397	1427408874000
4749	1678	2160041126000
4750	1752	99000000
4751	1677	48240041000000
4752	1677	48240052000000
4766	1650	3600061000000
4767	1397	1427368870000
4768	1678	2160041130000
4769	1694	10079215000000
4770	1397	1427358869000
4771	1678	2160041131000
4772	1724	3598660000000
4773	1724	3598670000000
4774	1397	1427348868000
4775	1678	2160041132000
4776	1724	4318670000000
4777	1724	4318680000000
4778	1397	1427338867000
4779	1678	2160041133000
4780	1683	132480378999541
4781	1683	132480388999541
4782	1678	1440031110000
4783	1678	1440031111000
4784	1678	1440031112000
4785	1678	1440031113000
4786	1678	1440031114000
4787	1678	1440031115000
4788	1678	1440031116000
4789	1678	1440031117000
4790	1678	1440031118000
4791	1678	1440031119000
4792	1678	1440031120000
4793	1678	1440031121000
4794	1678	1440031122000
4795	1678	1440031123000
4796	1678	1440031124000
4797	1678	1440031125000
4798	1678	1440031126000
4799	1678	1440031127000
4800	1678	1440031128000
4801	1678	1440031129000
4802	1678	1440031130000
4803	1678	1440031131000
4804	1678	1440031132000
4805	1678	1440031133000
4806	1397	1427328866000
4807	1678	1440031134000
4808	1690	12241201000000
4809	1690	12241451000000
4810	1678	2160041134000
4811	1397	1427318865000
4812	1678	2160041135000
4813	1397	1427308864000
4814	1678	2160041136000
4815	1749	703990000000
4816	1753	12000000000
4817	1689	3599120000000
4818	1679	13679721000000
4819	1601	2880100000000
4820	1397	1427298863000
4821	1678	2160041137000
4822	1683	133920388999541
4823	1683	133920398999541
4824	1397	1427288862000
4825	1678	2160041138000
4826	1722	6096091000000
4827	1753	1112000000000
4828	1683	135360398999541
4829	1683	135360418999541
4830	1397	1427278861000
4831	1678	2160041139000
4832	1397	1427268860000
4833	1678	2160041140000
4834	1445	2880050000000
4835	1445	2880060000000
4844	1397	1427238857000
4845	1678	2160041143000
4850	484	70320080000000
4853	1681	7199200000000
4854	1681	7199210000000
4887	1397	1427128846000
4888	1678	2160041154000
4889	1691	2159020000000
4890	1691	2159030000000
4906	1671	5040160000000
4907	1671	5040180000000
4925	1397	1427028836000
4926	1678	2160041164000
4927	1683	136800428999541
4930	1689	3599090000000
4931	1698	3598940000000
4932	1698	3598950000000
4947	1702	1439010000000
4948	1702	1439020000000
4951	1397	1426968830000
4952	1678	2160041170000
4954	1677	50400111000000
4955	1677	50400121000000
4956	1397	1426958829000
4957	1678	2160041171000
5005	1559	5040130000000
5019	1705	2874870000000
5020	1397	1426908824000
5021	1678	2160041176000
5022	1714	4318960000000
5023	1714	4318970000000
5034	1522	1440010000000
5035	1522	1440030000000
5036	1397	1426868820000
5037	1678	2160041180000
5038	1705	3594870000000
5039	1705	3594880000000
5052	1607	4320060000000
5053	1607	4320070000000
5054	1397	1426838817000
5055	1678	2160041183000
5056	1397	1426828816000
5057	1678	2160041184000
5062	171	69600060000000
5063	171	69600070000000
5068	1397	1426788812000
5069	1678	2160041188000
5080	519	66720000000000
5081	519	66720010000000
5089	1677	53280161000000
5090	1677	53280191000000
5091	1397	1426728806000
5092	1678	2160041194000
5093	1654	5760090000000
5094	1654	5760100000000
5096	1687	2879031000000
5097	1687	2879041000000
5104	576	71040070000000
5105	576	71040080000000
5106	1397	1426708804000
5107	1678	2160041196000
5108	470	71760081000000
5109	470	71760091000000
5115	1397	1426688802000
5116	1678	2160041198000
5117	1397	1426678801000
5118	1678	2160041199000
5119	1677	54720201000000
5120	1677	54720221000000
5129	1522	1440020000000
5130	1668	4320050000000
5131	1668	4320060000000
5132	1476	5040090000000
5133	1476	5040100000000
5134	1560	2160130000000
5135	1440	3600070000000
5136	1560	2880120000000
5141	1447	5040080000000
5154	1678	2161006173000
5155	1678	2161006174000
5156	1678	2161006175000
5157	1678	2161006176000
5158	1678	2161006177000
5159	1678	2161006178000
5160	1678	2161006179000
5161	1678	2161006180000
5162	1678	2161006181000
5163	1678	2161006182000
5164	1678	2161006183000
5165	1678	2161006184000
5166	1678	2161006185000
5167	1678	2161006186000
5168	1678	2161006187000
5169	1678	2161006188000
5170	1678	2161006189000
5171	1678	2161006190000
5172	1678	2161006191000
5173	1678	2161006192000
5174	1678	2161006193000
5175	1678	2161006194000
5176	1678	2161006195000
5177	1678	2161006196000
5178	1678	2161006197000
5179	1678	2161006198000
5180	1678	2161006199000
5181	1678	2161006200000
5182	1678	2161006201000
5183	1678	2161006202000
5184	1678	2161006203000
5185	1678	2881006203000
5186	1678	2881306203000
5198	1397	1426578791000
5199	1678	2160041209000
5200	1397	1426568790000
5201	1678	2160041210000
5202	1397	1426558789000
5203	1678	2160041211000
5204	1397	1426548788000
5205	1678	2160041212000
5206	1422	1440050000000
5207	1681	7199240000000
5221	1677	56160231000000
5222	1677	56160241000000
5227	1705	4314880000000
5228	1705	4314890000000
5229	1678	1440031172000
5230	1678	1440031173000
5231	1678	1440031174000
5232	1678	1440031175000
5233	1678	1440031176000
5234	1678	1440031177000
5235	1678	1440031178000
5236	1678	1440031179000
5237	1678	1440031180000
5238	1678	1440031181000
5239	1678	1440031182000
5240	1678	1440031183000
5241	1678	1440031184000
5242	1678	1440031185000
5243	1678	1440031186000
5244	1678	1440031187000
5245	1678	1440031188000
5246	1678	1440031189000
5247	1678	1440031190000
5248	1678	1440031191000
5249	1678	1440031192000
5250	1678	1440031193000
5251	1678	1440031194000
5252	1678	1440031195000
5253	1678	1440031196000
5254	1678	1440031197000
5255	1678	1440031198000
5256	1678	1440031199000
5257	1678	1440031200000
5258	1678	1440031201000
5259	1678	1440031202000
5260	1678	1440031203000
5261	1678	1440031204000
5262	1678	1440031205000
5263	1678	1440031206000
5264	1678	1440031207000
5265	1678	1440031208000
5266	1678	1440031209000
5267	1678	1440031210000
5268	1678	1440031211000
5269	1678	1440031212000
5270	1678	1440031213000
5271	1678	1440031214000
5272	1690	12962281000000
5273	1678	1440031215000
5274	1678	1440031216000
5275	1690	13682281000000
5276	1690	13682301000000
5283	1397	1426488782000
5284	1678	2160041218000
5291	1458	5760110000000
5292	1458	5760120000000
4836	1397	1427258859000
4837	1678	2160041141000
4838	1694	10799215000000
4839	1694	10799225000000
4846	1397	1427228856000
4847	1678	2160041144000
4848	1693	3198317500454
4849	1693	3198327500454
4851	1637	20160611000000
4852	1637	20160621000000
4861	1560	2880070000000
4862	1560	2880090000000
4863	1445	3600060000000
4864	1445	3600080000000
4871	1671	4320160000000
4872	1397	1427178851000
4873	1678	2160041149000
4874	1698	2878930000000
4875	1698	2878940000000
4876	1397	1427168850000
4877	1678	2160041150000
4878	1722	5773081000000
4879	1753	1435000000000
4880	1397	1427158849000
4881	1678	2160041151000
4882	1397	1427148848000
4883	1678	2160041152000
4884	1397	1427138847000
4885	1678	2160041153000
4886	1686	4318010000000
4893	1397	1427118845000
4894	1678	2160041155000
4895	1397	1427108844000
4896	1678	2160041156000
4897	1705	2874840000000
4898	1705	2874860000000
4923	1559	5040120000000
4924	1559	5040160000000
4937	1397	1426998833000
4938	1678	2160041167000
4943	1397	1426988832000
4944	1678	2160041168000
4945	1683	139680438999541
4946	1683	139680448999541
4949	1397	1426978831000
4950	1678	2160041169000
4960	1678	1440031135000
4961	1678	1440031136000
4962	1678	1440031137000
4963	1678	1440031138000
4964	1678	1440031139000
4965	1678	1440031140000
4966	1678	1440031141000
4967	1722	4656070000000
4968	1722	4333060000000
4969	1678	1440031142000
4970	1678	1440031143000
4971	1678	1440031144000
4972	1678	1440031145000
4973	1678	1440031146000
4974	1678	1440031147000
4975	1678	1440031148000
4976	1678	1440031149000
4977	1678	1440031150000
4978	1678	1440031151000
4979	1678	1440031152000
4980	1678	1440031153000
4981	1678	1440031154000
4982	1678	1440031155000
4983	1678	1440031156000
4984	1678	1440031157000
4985	1678	1440031158000
4986	1678	1440031159000
4987	1678	1440031160000
4988	1678	1440031161000
4989	1678	1440031162000
4990	1678	1440031163000
4991	1678	1440031164000
4992	1678	1440031165000
4993	1678	1440031166000
4994	1678	1440031167000
4995	1678	1440031168000
4996	1678	1440031169000
4997	1678	1440031170000
4998	1678	1440031171000
4999	1690	12961451000000
5000	1690	12961851000000
5007	1587	2880030000000
5008	1667	10000000
5009	369	69600070000000
5018	1711	3599080000000
5024	1397	1426898823000
5025	1678	2160041177000
5026	171	68880050000000
5027	171	68880060000000
5040	1596	3600070000000
5041	1596	3600080000000
5042	1397	1426858819000
5043	1678	2160041181000
5044	1677	52560151000000
5045	1677	52560161000000
5060	1397	1426808814000
5061	1678	2160041186000
5070	1397	1426778811000
5071	1678	2160041189000
5072	632	68880070000000
5073	632	68880080000000
5095	1711	3599060000000
5098	1693	3918327500454
5099	1693	3918337500454
5110	1677	54000191000000
5111	1677	54000201000000
5112	1397	1426698803000
5113	1678	2160041197000
5114	369	69600090000000
5142	1684	5759090000000
5143	1684	5759200000000
5145	1397	1426638797000
5146	1678	2160041203000
5147	1397	1426628796000
5148	1678	2160041204000
5149	1683	144000488999541
5187	1397	1426608794000
5188	1678	2160041206000
5189	1397	1426598793000
5190	1678	2160041207000
5191	1649	3600061000000
5192	1649	3600081000000
5212	298	70319450000000
5213	298	70319460000000
5216	42	68160040000000
5217	42	68160050000000
5223	1397	1426508784000
5224	1678	2160041216000
5225	1489	2160030000000
5226	1489	2160040000000
5293	1597	1440010000000
5294	1597	1440020000000
4840	1397	1427248858000
4841	1678	2160041142000
4842	1677	48960061000000
4843	1677	48960071000000
4855	1397	1427218855000
4856	1678	2160041145000
4857	1397	1427208854000
4858	1678	2160041146000
4859	1688	17999462000000
4860	1688	17999482000000
4865	1397	1427198853000
4866	1678	2160041147000
4867	1397	1427188852000
4868	1678	2160041148000
4869	1402	16560311000000
4870	1402	16560331000000
4891	1722	6493081000000
4892	1722	6493091000000
4899	576	70320070000000
4900	1397	1427098843000
4901	1678	2160041157000
4902	1397	1427088842000
4903	1678	2160041158000
4904	1683	136800418999541
4905	1683	136800438999541
4908	1724	5038680000000
4909	1724	5038700000000
4910	1397	1427078841000
4911	1678	2160041159000
4912	1474	5040070000000
4913	1397	1427068840000
4914	1678	2160041160000
4915	1397	1427058839000
4916	1678	2160041161000
4917	1397	1427048838000
4918	1678	2160041162000
4919	1397	1427038837000
4920	1678	2160041163000
4921	1677	49680071000000
4922	1677	49680111000000
4928	1397	1427018835000
4929	1678	2160041165000
4933	1397	1427008834000
4934	1678	2160041166000
4935	1683	138240428999541
4936	1683	138240438999541
4939	311	71760100000000
4940	311	71760110000000
4941	1685	15119320000000
4942	1685	15119330000000
4953	1560	2880080000000
4958	1677	51120121000000
4959	1677	51120131000000
5001	1397	1426948828000
5002	1678	2160041172000
5003	298	69599440000000
5004	298	69599450000000
5006	1654	5040090000000
5010	1397	1426938827000
5011	1678	2160041173000
5012	1397	1426928826000
5013	1678	2160041174000
5014	1397	1426918825000
5015	1678	2160041175000
5016	369	69600080000000
5017	369	69600110000000
5028	1397	1426888822000
5029	1678	2160041178000
5030	1397	1426878821000
5031	1678	2160041179000
5032	1677	51840131000000
5033	1677	51840151000000
5046	1673	2880280000000
5047	1673	2880290000000
5048	1397	1426848818000
5049	1678	2160041182000
5050	1509	3600080000000
5051	1509	3600090000000
5058	1397	1426818815000
5059	1678	2160041185000
5064	1397	1426798813000
5065	1678	2160041187000
5066	1637	20880621000000
5067	1637	20880631000000
5074	1637	21600631000000
5075	1637	21600641000000
5076	1397	1426768810000
5077	1678	2160041190000
5078	1683	141120448999541
5079	1683	141120458999541
5082	1397	1426758809000
5083	1678	2160041191000
5084	1397	1426748808000
5085	1678	2160041192000
5086	1397	1426738807000
5087	1678	2160041193000
5088	1541	2160050000000
5100	1397	1426718805000
5101	1678	2160041195000
5102	1683	142560458999541
5103	1683	142560468999541
5121	1397	1426668800000
5122	1678	2160041200000
5123	1683	144000468999541
5124	1683	144000478999541
5125	1722	5376080000000
5126	1722	5053070000000
5127	1422	720905000000
5128	1422	1440895000000
5137	1397	1426658799000
5138	1678	2160041201000
5139	1397	1426648798000
5140	1678	2160041202000
5144	1684	5759110000000
5150	1700	3599120000000
5151	1700	3599140000000
5152	1397	1426618795000
5153	1678	2160041205000
5193	1397	1426588792000
5194	1678	2160041208000
5195	1677	55440221000000
5196	1677	55440231000000
5197	1422	2160895000000
5208	1397	1426538787000
5209	1678	2160041213000
5210	1700	4319140000000
5211	1700	4319150000000
5214	1397	1426528786000
5215	1678	2160041214000
5218	1397	1426518785000
5219	1678	2160041215000
5220	1688	17999472000000
5277	1597	720000000000
5278	1597	720010000000
5279	1397	1426498783000
5280	1678	2160041217000
5281	1649	4320081000000
5282	1649	4320091000000
5285	1714	5038970000000
5286	1714	5038980000000
5287	1397	1426478781000
5288	1678	2160041219000
5289	369	70320090000000
5290	369	70320100000000
5295	1397	1426468780000
5296	1678	2160041220000
5297	1397	1426458779000
5298	1678	2160041221000
5299	1610	5040130000000
5300	1692	10799441000000
5301	1397	1426448778000
5302	1678	2160041222000
5303	1397	1426438777000
5304	1678	2160041223000
5305	404	66720000000000
5306	404	66720020000000
5307	1397	1426428776000
5308	1678	2160041224000
5309	1516	5040210000000
5310	1516	5040220000000
5311	1692	11519441000000
5312	1692	11519451000000
5313	1397	1426418775000
5314	1678	2160041225000
5315	1637	20880641000000
5316	1397	1426408774000
5317	1678	2160041226000
5318	1516	5760220000000
5319	1516	5760230000000
5320	1397	1426398773000
5321	1678	2160041227000
5322	1746	1439010000000
5323	1746	1439020000000
5324	1397	1426388772000
5325	1678	2160041228000
5326	1637	22320641000000
5327	1637	22320651000000
5328	1740	6476533000000
5329	1740	6476543000000
5330	1440	3600080000000
5331	1560	3600110000000
5332	1678	1440031217000
5333	1678	1440031218000
5334	1678	1440031219000
5335	1678	1440031220000
5336	1678	1440031221000
5337	1678	1440031222000
5338	1678	1440031223000
5339	1678	1440031224000
5340	1678	1440031225000
5341	1678	1440031226000
5342	1678	1440031227000
5343	1678	1440031228000
5344	1690	14402301000000
5345	1690	14402421000000
5348	1397	1426368770000
5349	1678	2160041230000
5356	1397	1426348768000
5357	1678	2160041232000
5368	1678	2160041233000
5369	1601	3600100000000
5370	1601	3600110000000
5381	1662	720000000000
5382	1662	720010000000
5396	1677	56160271000000
5405	1547	1440030000000
5410	1397	1426218755000
5411	1678	2160041245000
5412	1397	1426208754000
5413	1678	2160041246000
5416	1683	146880508999541
5417	1397	1426188752000
5418	1678	2160041248000
5419	1397	1426178751000
5420	1678	2160041249000
5421	1397	1426168750000
5422	1678	2160041250000
5423	1397	1426158749000
5424	1678	2160041251000
5425	1680	7919160000000
5426	1680	7919200000000
5429	1397	1426148748000
5430	1678	2160041252000
5439	1397	1426118745000
5440	1678	2160041255000
5441	1650	4320060000000
5442	1650	4320070000000
5445	1397	1426098743000
5446	1678	2160041257000
5451	1397	1426078741000
5452	1678	2160041259000
5461	1678	1440031234000
5462	1678	1440031235000
5463	1678	1440031236000
5464	1678	1440031237000
5465	1678	1440031238000
5466	1678	1440031239000
5467	1678	1440031240000
5468	1678	1440031241000
5469	1690	15842471000000
5470	1690	15842551000000
5479	1397	1426018735000
5480	1678	2160041265000
5487	1735	1419990000000
5488	1401	0
5489	1735	1419980000000
5490	1397	1425988732000
5491	1678	2160041268000
5492	1397	1425978731000
5493	1678	2160041269000
5494	1685	17279360000000
5495	1685	17279400000000
5502	1724	5038690000000
5505	1397	1425948728000
5506	1678	2160041272000
5507	1694	11519225000000
5508	1694	11519245000000
5584	1678	2160041273000
5585	1735	1419970000000
5586	1397	1425928726000
5587	1678	2160041274000
5588	1397	1425918725000
5589	1678	2160041275000
5590	1536	5040130000000
5597	1688	19439482000000
5598	1688	19439502000000
5600	1692	12239451000000
5609	1397	1425868720000
5610	1678	2160041280000
5611	1683	148320508999541
5612	1683	148320518999541
5628	1397	1425818715000
5629	1678	2160041285000
5630	1397	1425808714000
5631	1678	2160041286000
5632	1705	4314900000000
5637	1397	1425788712000
5638	1678	2160041288000
5639	1560	4320090000000
5642	1724	7199230000000
5643	1724	7199320000000
5644	1397	1425768710000
5645	1678	2160041290000
5646	1683	149760518999541
5647	1683	149760528999541
5656	1397	1425738707000
5657	1678	2160041293000
5658	1683	151200528999541
5659	1683	151200538999541
5662	1693	4638337500454
5663	1693	4638347500454
5672	1680	8639200000000
5683	1397	1425688702000
5684	1678	2160041298000
5685	1699	6479169000000
5686	1699	6479179000000
5697	1397	1425658699000
5698	1678	2160041301000
5699	1709	5039230000000
5702	44	69600140000000
5703	44	69600150000000
5704	1397	1425648698000
5705	1678	2160041302000
5714	1397	1425608694000
5715	1678	2160041306000
5716	1397	1425598693000
5717	1678	2160041307000
5718	1397	1425588692000
5719	1678	2160041308000
5720	1397	1425578691000
5721	1678	2160041309000
5722	1694	12239245000000
5723	1694	12239275000000
5730	1397	1425548688000
5731	1678	2160041312000
5732	1694	12959275000000
5733	1694	12959285000000
5748	1397	1425488682000
5749	1678	2160041318000
5750	1397	1425478681000
5751	1678	2160041319000
5752	1559	5040140000000
5766	1397	1425438677000
5767	1678	2160041323000
5768	1755	719000000000
5769	1755	719010000000
5772	1722	7213091000000
5773	1722	7213101000000
5796	1397	1425348668000
5797	1678	2160041332000
5798	1541	1440030000000
5803	1397	1425338667000
5804	1678	2160041333000
5805	1397	1425328666000
5806	1678	2160041334000
5807	1683	154080568999541
5819	1397	1425288662000
5820	1678	2160041338000
5828	58	71040110000000
5829	58	71040230000000
5830	1397	1425258659000
5831	1678	2160041341000
5844	1692	12959461000000
5845	1692	12959482000000
5853	1683	155520578999541
5854	1397	1425198653000
5855	1678	2160041347000
5856	1710	1438930000000
5857	1710	1438940000000
5860	1397	1425188652000
5861	1678	2160041348000
5862	1397	1425178651000
5863	1678	2160041349000
5864	1672	2160040000000
5869	1694	13679285000000
5870	1694	13679295000000
5346	1397	1426378771000
5347	1678	2160041229000
5350	1688	18719472000000
5351	1688	18719482000000
5352	1397	1426358769000
5353	1678	2160041231000
5354	1622	2160020000000
5355	1622	2160030000000
5358	1685	15839330000000
5359	1685	15839340000000
5360	1678	1440031229000
5361	1678	1440031230000
5362	1678	1440031231000
5363	1678	1440031232000
5364	1397	1426338767000
5365	1678	1440031233000
5366	1690	15122421000000
5367	1690	15122471000000
5377	1397	1426308764000
5378	1678	2160041236000
5379	1536	5040090000000
5380	1536	5040100000000
5383	1633	2160040000000
5394	1683	146880498999541
5395	1683	146880538999541
5403	1724	5038810000000
5406	1397	1426238757000
5407	1678	2160041243000
5408	1397	1426228756000
5409	1678	2160041244000
5414	1397	1426198753000
5415	1678	2160041247000
5433	1440	3600090000000
5434	1560	4320100000000
5447	1397	1426088742000
5448	1678	2160041258000
5449	1420	720000000000
5450	1420	720010000000
5453	1397	1426068740000
5454	1678	2160041260000
5471	1397	1426038737000
5472	1678	2160041263000
5473	1397	1426028736000
5474	1678	2160041264000
5475	1402	17280331000000
5476	1402	17280351000000
5477	1685	16559340000000
5478	1685	16559360000000
5483	1397	1425998733000
5484	1678	2160041267000
5485	1637	23040651000000
5486	1637	23040661000000
5498	1397	1425958729000
5499	1678	2160041271000
5500	1724	5758810000000
5501	1724	5759120000000
5503	327	66720000000000
5504	327	66720010000000
5509	1611	2880030000000
5510	1611	2880050000000
5591	1397	1425908724000
5592	1678	2160041276000
5593	1268	994990000000
5594	1754	4000000000
5595	1709	5039220000000
5596	1709	5039240000000
5607	1397	1425878721000
5608	1678	2160041279000
5613	1724	6479120000000
5614	1724	6479230000000
5633	1637	23760661000000
5634	1637	23760681000000
5635	1397	1425798713000
5636	1678	2160041287000
5654	1735	2139970000000
5655	1735	2139990000000
5660	1536	5760130000000
5661	1536	5760140000000
5670	1685	18719410000000
5671	1685	18719420000000
5673	1397	1425718705000
5674	1678	2160041295000
5675	1680	8639210000000
5676	1397	1425708704000
5677	1678	2160041296000
5678	1656	5760101000000
5687	1683	152640538999541
5688	1683	152640548999541
5689	1397	1425678701000
5690	1678	2160041299000
5691	1397	1425668700000
5692	1678	2160041300000
5693	1587	2880050000000
5706	1476	5760100000000
5707	1476	5760110000000
5708	1397	1425638697000
5709	1678	2160041303000
5726	1397	1425558689000
5727	1678	2160041311000
5728	311	72480110000000
5729	311	72480120000000
5734	1397	1425538687000
5735	1678	2160041313000
5736	1607	5040080000000
5741	1397	1425518685000
5742	1678	2160041315000
5743	1397	1425508684000
5744	1678	2160041316000
5745	1397	1425498683000
5746	1678	2160041317000
5747	1637	23760691000000
5759	1397	1425448678000
5760	1678	2160041322000
5761	1711	4319060000000
5762	1711	4319070000000
5765	1692	12239461000000
5770	1683	154080548999541
5771	1683	154080558999541
5781	1607	5760080000000
5782	1607	5760090000000
5783	1397	1425398673000
5784	1678	2160041327000
5785	1397	1425388672000
5786	1678	2160041328000
5787	1397	1425378671000
5788	1678	2160041329000
5789	1397	1425368670000
5790	1678	2160041330000
5791	1397	1425358669000
5792	1678	2160041331000
5793	1690	7199360000000
5808	1397	1425318665000
5809	1678	2160041335000
5821	1516	0
5822	1756	6479140000000
5823	1397	1425278661000
5824	1678	2160041339000
5825	1397	1425268660000
5826	1678	2160041340000
5827	1677	56160351000000
5832	1397	1425248658000
5833	1678	2160041342000
5835	1727	2159020000000
5836	1727	2159030000000
5837	1397	1425238657000
5838	1678	2160041343000
5839	1397	1425228656000
5840	1678	2160041344000
5841	1756	6479139000000
5842	1683	155520568999541
5843	1683	155520589999541
5850	1397	1425208654000
5851	1678	2160041346000
5852	1402	17280341000000
5865	1397	1425168650000
5866	1678	2160041350000
5867	1699	7199179000000
5868	1699	7199189000000
5371	1397	1426328766000
5372	1678	2160041234000
5373	1397	1426318765000
5374	1678	2160041235000
5375	1683	145440478999541
5376	1683	145440498999541
5384	1397	1426298763000
5385	1678	2160041237000
5386	1397	1426288762000
5387	1678	2160041238000
5388	1397	1426278761000
5389	1678	2160041239000
5390	1397	1426268760000
5391	1678	2160041240000
5392	1445	4320080000000
5393	1445	4320120000000
5397	1397	1426258759000
5398	1678	2160041241000
5399	1397	1426248758000
5400	1678	2160041242000
5401	1634	4320070000000
5402	1634	4320090000000
5404	1692	11519461000000
5427	1656	5760121000000
5428	1555	2160050000000
5431	1397	1426138747000
5432	1678	2160041253000
5435	1397	1426128746000
5436	1678	2160041254000
5437	1560	3600080000000
5438	1560	3600090000000
5443	1397	1426108744000
5444	1678	2160041256000
5455	1397	1426058739000
5456	1678	2160041261000
5457	1397	1426048738000
5458	1678	2160041262000
5459	1682	3587110000000
5460	1682	3587130000000
5481	1397	1426008734000
5482	1678	2160041266000
5496	1397	1425968730000
5497	1678	2160041270000
5511	1678	2881306204000
5512	1678	2881306205000
5513	1678	2881306206000
5514	1678	2881306207000
5515	1678	2881306208000
5516	1678	2881306209000
5517	1678	2881306210000
5518	1678	2881306211000
5519	1678	2881306212000
5520	1678	2881306213000
5521	1678	2881306214000
5522	1678	2881306215000
5523	1678	2881306216000
5524	1678	2881306217000
5525	1678	2881306218000
5526	1678	2881306219000
5527	1678	2881306220000
5528	1678	2881306221000
5529	1678	2881306222000
5530	1678	2881306223000
5531	1678	2881306224000
5532	1678	2881306225000
5533	1678	2881306226000
5534	1678	2881306227000
5535	1678	2881306228000
5536	1678	2881306229000
5537	1678	2881306230000
5538	1678	2881306231000
5539	1678	2881306232000
5540	1678	2881306233000
5541	1678	2881306234000
5542	1678	2881306235000
5543	1678	2881306236000
5544	1678	2881306237000
5545	1678	2881306238000
5546	1678	2881306239000
5547	1678	2881306240000
5548	1678	2881306241000
5549	1678	2881306242000
5550	1678	2881306243000
5551	1678	2881306244000
5552	1678	2881306245000
5553	1678	2881306246000
5554	1678	2881306247000
5555	1678	2881306248000
5556	1678	2881306249000
5557	1678	2881306250000
5558	1678	2881306251000
5559	1678	2881306252000
5560	1678	2881306253000
5561	1678	2881306254000
5562	1678	2881306255000
5563	1678	2881306256000
5564	1678	2881306257000
5565	1678	2881306258000
5566	1678	2881306259000
5567	1678	2881306260000
5568	1678	2881306261000
5569	1678	2881306262000
5570	1678	2881306263000
5571	1678	2881306264000
5572	1678	2881306265000
5573	1678	2881306266000
5574	1678	2881306267000
5575	1678	2881306268000
5576	1678	2881306269000
5577	1678	2881306270000
5578	1678	2881306271000
5579	1678	2881306272000
5580	1397	1425938727000
5581	1678	2881306273000
5582	1678	3601306273000
5583	1678	3602027273000
5599	1688	20159502000000
5601	1397	1425898723000
5602	1678	2160041277000
5603	1397	1425888722000
5604	1678	2160041278000
5605	1593	2880050000000
5606	1593	2880070000000
5615	1724	5758680000000
5616	1724	5758690000000
5617	1552	1440010000000
5618	1552	1440020000000
5619	1397	1425858719000
5620	1678	2160041281000
5621	1397	1425848718000
5622	1678	2160041282000
5623	1397	1425838717000
5624	1678	2160041283000
5625	1397	1425828716000
5626	1678	2160041284000
5627	1698	3598980000000
5640	1397	1425778711000
5641	1678	2160041289000
5648	1397	1425758709000
5649	1678	2160041291000
5650	1397	1425748708000
5651	1678	2160041292000
5652	1607	5040070000000
5653	1607	5040090000000
5664	1685	17999400000000
5665	1685	17999410000000
5666	1397	1425728706000
5667	1678	2160041294000
5668	1679	14399691000000
5669	1679	14399701000000
5679	1677	56160251000000
5680	1397	1425698703000
5681	1678	2160041297000
5682	1467	2161370000000
5694	1688	20159522000000
5695	1685	19439420000000
5696	1685	19439440000000
5700	1687	3599041000000
5701	1687	3599051000000
5710	1397	1425628696000
5711	1678	2160041304000
5712	1397	1425618695000
5713	1678	2160041305000
5724	1397	1425568690000
5725	1678	2160041310000
5737	1397	1425528686000
5738	1678	2160041314000
5739	1516	6480230000000
5740	1516	6480240000000
5753	1397	1425468680000
5754	1678	2160041320000
5755	1397	1425458679000
5756	1678	2160041321000
5757	1439	2880040000000
5758	1439	2880060000000
5763	1593	3600070000000
5764	1593	3600080000000
5774	1397	1425428676000
5775	1678	2160041324000
5776	1397	1425418675000
5777	1678	2160041325000
5778	1426	2880070000000
5779	1397	1425408674000
5780	1678	2160041326000
5794	1637	24480691000000
5795	1637	24480741000000
5799	1691	2159040000000
5800	1691	2879040000000
5801	1637	24480751000000
5802	1637	25200751000000
5810	1722	6493351000000
5811	1505	50000000
5812	1722	7213301000000
5813	1397	1425308664000
5814	1678	2160041336000
5815	1397	1425298663000
5816	1678	2160041337000
5817	1684	6479110000000
5818	1684	6479140000000
5834	1716	4319120000000
5846	1397	1425218655000
5847	1678	2160041345000
5848	1692	13679482000000
5849	1692	13679492000000
5858	1716	5039120000000
5859	1716	5039130000000
5871	1397	1425158649000
5872	1678	2160041351000
5873	1397	1425148648000
5874	1678	2160041352000
5875	1397	1425138647000
5876	1678	2160041353000
5877	1397	1425128646000
5878	1678	2160041354000
5879	1679	14399731000000
5880	1397	1425118645000
5881	1678	2160041355000
5882	1684	7199140000000
5883	1684	7199150000000
5884	1397	1425108644000
5885	1678	2160041356000
5886	1397	1425098643000
5887	1678	2160041357000
5888	1516	720020000000
5889	1397	1425088642000
5890	1678	2160041358000
5891	618	66720000000000
5892	618	66720010000000
5893	1722	7933091000000
5894	1505	100000000
5895	1722	7933251000000
5896	1685	19439430000000
5897	1722	7933101000000
5898	1397	1425078641000
5899	1678	2160041359000
5900	1397	1425068640000
5901	1678	2160041360000
5902	1397	1425058639000
5903	1678	2160041361000
5904	1560	5040100000000
5905	1560	5040110000000
5906	1426	3600070000000
5907	1426	3600080000000
5908	1397	1425048638000
5909	1678	2160041362000
5910	1516	1440030000000
5911	1677	56880351000000
5912	1677	56880361000000
5913	1613	2158000000000
5914	1613	2158010000000
5915	1397	1425038637000
5916	1678	2160041363000
5917	1683	156960578999541
5918	1683	156960598999541
5919	1397	1425028636000
5920	1678	2160041364000
5921	733	2720000000000
5922	733	2720010000000
5923	1397	1425018635000
5924	1678	2160041365000
5925	1587	3600050000000
5926	1587	3600060000000
5927	1397	1425008634000
5928	1678	2160041366000
5929	1559	5760140000000
5930	1559	5760150000000
5931	1397	1424998633000
5932	1678	2160041367000
5933	1670	5040310000000
5934	1670	5040320000000
5935	1671	5760180000000
5936	1671	5760190000000
5937	1397	1424988632000
5938	1678	2160041368000
5939	43	68880070000000
5940	43	68880080000000
5941	1688	20159512000000
5942	43	68880090000000
5943	1397	1424978631000
5944	1678	2160041369000
5945	1654	6480100000000
5946	1654	6480110000000
5947	641	68880250000000
5948	641	68880260000000
5949	1692	14399492000000
5950	1692	14399502000000
5951	1397	1424968630000
5952	1678	2160041370000
5953	1690	7199320000000
5954	1633	2880040000000
5955	1633	2880050000000
5956	1397	1424958629000
5957	1678	2160041371000
5958	1397	1424948628000
5959	1678	2160041372000
5960	1397	1424938627000
5961	1678	2160041373000
5962	1710	2158940000000
5963	1710	2158950000000
5964	1397	1424928626000
5965	1678	2160041374000
5966	1397	1424918625000
5967	1678	2160041375000
5968	1679	15119731000000
5969	1679	15119751000000
5970	1706	3596871000000
5971	1623	5040081000000
5972	1623	5040101000000
5973	1397	1424908624000
5974	1678	2160041376000
5975	1599	5040070000000
5976	1599	5040080000000
5977	676	66720000000000
5978	676	66720010000000
5979	1397	1424898623000
5980	1678	2160041377000
5981	1683	158400598999541
5982	1683	158400608999541
5983	1397	1424888622000
5984	1678	2160041378000
5985	1634	5040090000000
5986	1634	5040100000000
5987	1677	57600361000000
5988	1677	57600371000000
5989	1397	1424878621000
5990	1678	2160041379000
5991	1622	2160830000000
5992	1449	264005058
5993	1622	2880589995401
5994	1397	1424868620000
5995	1678	2160041380000
5996	1622	2880030000000
5997	1622	2880040000000
5998	1686	5038010000000
5999	1686	5038020000000
6000	1419	4320080000000
6001	1419	4320090000000
6002	1397	1424858619000
6003	1678	2160041381000
6004	1695	3598991000000
6005	1397	1424848618000
6006	1678	2160041382000
6007	1695	4318991000000
6008	1695	4319001000000
6009	1509	2880090000000
6010	1509	3600100000000
6011	1397	1424838617000
6012	1678	2160041383000
6013	1571	5040060000000
6014	1571	5040070000000
6015	58	71040120000000
6016	1637	25920751000000
6017	1637	25920761000000
6018	1397	1424828616000
6019	1678	2160041384000
6020	1397	1424818615000
6021	1678	2160041385000
6022	1688	20879512000000
6023	1688	20879532000000
6024	1397	1424808614000
6025	1678	2160041386000
6026	1688	21599532000000
6027	1688	21599542000000
6028	1397	1424798613000
6029	1678	2160041387000
6030	1397	1424788612000
6031	1678	2160041388000
6032	1682	4307130000000
6033	1682	4307140000000
6034	1683	159840608999541
6035	1683	159840618999541
6049	1397	1424738607000
6050	1678	2160041393000
6051	1710	2878950000000
6052	1710	2878960000000
6061	1397	1424708604000
6062	1678	2160041396000
6073	1594	2880040000000
6074	1594	2880050000000
6088	1429	720000000000
6089	1429	720010000000
6092	1397	1424598593000
6093	1678	2160041407000
6094	1397	1424588592000
6095	1678	2160041408000
6096	1693	4638237500454
6097	165	66000100000000
6098	1397	1424578591000
6099	1678	2160041409000
6100	1723	5759090000000
6101	1723	5759120000000
6110	1397	1424548588000
6111	1678	2160041412000
6112	165	66000090000000
6113	1564	2160020000000
6114	1564	2160040000000
6119	1397	1424528586000
6120	1678	2160041414000
6121	1677	59040401000000
6122	1677	59040411000000
6131	1397	1424498583000
6132	1678	2160041417000
6133	1397	1424488582000
6134	1678	2160041418000
6135	1397	1424478581000
6136	1678	2160041419000
6137	1690	7199340000000
6139	58	71040140000000
6140	1397	1424468580000
6141	1678	2160041420000
6142	1683	161280618999541
6143	1683	161280628999541
6150	1397	1424438577000
6151	1678	2160041423000
6152	1489	2880040000000
6153	1489	2880050000000
6156	484	71040080000000
6157	484	71040090000000
6167	1715	5039091000000
6168	1715	5039101000000
6174	1587	4320060000000
6175	1587	4320080000000
6176	1397	1424388572000
6177	1678	2160041428000
6178	1522	2160020000000
6179	1522	2160030000000
6181	1714	5758990000000
6182	1714	5759000000000
6197	1397	1424348568000
6198	1678	2160041432000
6205	1476	5760120000000
6208	1681	8639250000000
6209	1681	8639260000000
6219	1397	1424288562000
6220	1678	2160041438000
6253	1679	15839761000000
6256	1693	3198217500454
6257	1724	7199740000000
6258	1724	7919740000000
6259	1724	3600070000000
6260	1440	7920560000000
6265	1397	1424168550000
6266	1678	2160041450000
6267	1546	5040080000000
6268	1546	5040090000000
6276	1397	1424128546000
6277	1678	2160041454000
6278	1397	1424118545000
6279	1678	2160041455000
6280	1683	164160638999541
6281	1683	164160648999541
6289	1397	1424088542000
6290	1678	2160041458000
6301	1719	1439030000000
6302	1719	1439040000000
6305	1397	1424058539000
6306	1678	2160041461000
6311	1397	1424038537000
6312	1678	2160041463000
6313	1397	1424028536000
6314	1678	2160041464000
6315	1695	4318981000000
6320	1397	1424008534000
6321	1678	2160041466000
6322	311	73200120000000
6323	311	73200130000000
6337	1546	5040100000000
6352	1397	1423928526000
6353	1678	2160041474000
6359	1643	2880040000000
6360	1643	2880050000000
6367	1677	62640471000000
6368	1677	62640501000000
6412	1397	1423768510000
6413	1678	2160041490000
6414	311	73920130000000
6415	45	73920149999990
6416	311	66000000000010
6421	1397	1423758509000
6422	1678	2160041491000
6423	1637	26640761000000
6424	1637	26640771000000
6425	1397	1423748508000
6426	1678	2160041492000
6427	1397	1423738507000
6428	1678	2160041493000
6429	1445	5760130000000
6430	1445	5760150000000
6454	1623	4320211000000
6455	1623	5040211000000
6456	1623	5040561000000
6471	1397	1423598493000
6472	1678	2160041507000
6473	1722	10093131000000
6474	1722	10093141000000
6487	1727	2159040000000
6494	1757	719000000000
6495	1757	719010000000
6510	1397	1423498483000
6511	1678	2160041517000
6512	1397	1423488482000
6513	1678	2160041518000
6036	1397	1424778611000
6037	1678	2160041389000
6038	1397	1424768610000
6039	1678	2160041390000
6040	1559	6480150000000
6041	1559	6480170000000
6045	1440	4320060000000
6046	1440	4320070000000
6047	1397	1424748608000
6048	1678	2160041392000
6053	1397	1424728606000
6054	1678	2160041394000
6055	1445	5040120000000
6056	1445	5040130000000
6057	1397	1424718605000
6058	1678	2160041395000
6059	1608	2880040000000
6060	1608	2880050000000
6063	1397	1424698603000
6064	1678	2160041397000
6065	1397	1424688602000
6066	1678	2160041398000
6067	1397	1424678601000
6068	1678	2160041399000
6069	1677	58320371000000
6070	1677	58320401000000
6075	1397	1424658599000
6076	1678	2160041401000
6077	1397	1424648598000
6078	1678	2160041402000
6079	1397	1424638597000
6080	1678	2160041403000
6081	1708	1439160000000
6090	1397	1424608594000
6091	1678	2160041406000
6102	1397	1424568590000
6103	1678	2160041410000
6104	1402	18000341000000
6105	1402	18000351000000
6115	1714	5038990000000
6123	1397	1424518585000
6124	1678	2160041415000
6125	1670	5760320000000
6126	1670	5760330000000
6127	1677	59760411000000
6128	1677	59760421000000
6159	1397	1424428576000
6160	1678	2160041424000
6161	1705	5034900000000
6162	1705	5034910000000
6163	1397	1424418575000
6164	1678	2160041425000
6165	1588	2880050000000
6166	1588	2880060000000
6169	1397	1424408574000
6170	1678	2160041426000
6171	1397	1424398573000
6172	1678	2160041427000
6173	1690	7199330000000
6180	1522	2160490000000
6183	1397	1424378571000
6184	1678	2160041429000
6185	1397	1424368570000
6186	1678	2160041430000
6187	111	66720000000000
6188	111	66720020000000
6193	606	69600050000000
6194	606	69600060000000
6206	1397	1424318565000
6207	1678	2160041435000
6210	1685	20159430000000
6211	1685	20159440000000
6212	1397	1424308564000
6213	1678	2160041436000
6214	1397	1424298563000
6215	1678	2160041437000
6216	1683	162720628999541
6217	1683	162720648999541
6223	1397	1424278561000
6224	1678	2160041439000
6225	1397	1424268560000
6226	1678	2160041440000
6227	1397	1424258559000
6228	1678	2160041441000
6229	1397	1424248558000
6230	1678	2160041442000
6231	1397	1424238557000
6232	1678	2160041443000
6233	1397	1424228556000
6234	1678	2160041444000
6235	470	72480091000000
6236	470	72480151000000
6243	1402	18720351000000
6244	1402	18720371000000
6250	1397	1424188552000
6251	1678	2160041448000
6252	1683	162720638999541
6282	1397	1424108544000
6283	1678	2160041456000
6284	1397	1424098543000
6285	1678	2160041457000
6286	1637	25920771000000
6295	1683	165600648999541
6296	1683	165600658999541
6299	1397	1424068540000
6300	1678	2160041460000
6307	1397	1424048538000
6308	1678	2160041462000
6309	1657	4320080000000
6310	1657	4320090000000
6318	1397	1424018535000
6319	1678	2160041465000
6331	1397	1423988532000
6332	1678	2160041468000
6333	1397	1423978531000
6334	1678	2160041469000
6335	1588	3600060000000
6336	1588	3600080000000
6340	1397	1423968530000
6341	1678	2160041470000
6342	1397	1423958529000
6343	1678	2160041471000
6344	1397	1423948528000
6345	1678	2160041472000
6346	1677	61920441000000
6347	1677	61920471000000
6354	1643	2160850000000
6355	1737	1000000100
6356	1643	2880849999900
6361	1397	1423918525000
6362	1678	2160041475000
6363	1397	1423908524000
6364	1678	2160041476000
6365	1397	1423898523000
6366	1678	2160041477000
6373	1397	1423878521000
6374	1678	2160041479000
6375	1588	3600070000000
6376	1695	5039001000000
6377	1695	5039011000000
6380	1397	1423868520000
6381	1678	2160041480000
6382	1397	1423858519000
6383	1678	2160041481000
6384	1654	7200110000000
6385	1654	7200130000000
6398	1508	2880030000000
6399	1508	2880050000000
6410	1397	1423778511000
6411	1678	2160041489000
6418	262	66000100000000
6419	311	73920030000000
6420	311	73920050000000
6431	1397	1423728506000
6432	1678	2160041494000
6433	1397	1423718505000
6434	1678	2160041495000
6435	1677	62640491000000
6446	1637	27360771000000
6447	1637	27360791000000
6457	1397	1423658499000
6458	1678	2160041501000
6459	1397	1423648498000
6460	1678	2160041502000
6461	1397	1423638497000
6462	1678	2160041503000
6463	1397	1423628496000
6464	1678	2160041504000
6465	1397	1423618495000
6466	1678	2160041505000
6467	1397	1423608494000
6468	1678	2160041506000
6469	1506	2880020000000
6470	1506	2880080000000
6475	1397	1423588492000
6476	1678	2160041508000
6477	1397	1423578491000
6478	1678	2160041509000
6479	1698	4318980000000
6480	1698	4318990000000
6490	1397	1423538487000
6491	1678	2160041513000
6492	1683	172800708999541
6493	1683	172800718999541
6500	1683	174240718999541
6042	1397	1424758609000
6043	1678	2160041391000
6044	1729	3599050000000
6071	1397	1424668600000
6072	1678	2160041400000
6082	1397	1424628596000
6083	1678	2160041404000
6084	1397	1424618595000
6085	1678	2160041405000
6086	510	66720000000000
6087	510	66720010000000
6106	1397	1424558589000
6107	1678	2160041411000
6108	1681	7919240000000
6109	1681	7919250000000
6116	1397	1424538587000
6117	1678	2160041413000
6118	1657	3600080000000
6129	1397	1424508584000
6130	1678	2160041416000
6138	1719	719030000000
6144	1397	1424458579000
6145	1678	2160041421000
6146	1397	1424448578000
6147	1678	2160041422000
6148	606	68880030000000
6149	606	68880050000000
6154	1677	60480421000000
6155	1677	60480431000000
6158	1489	2880070000000
6189	1397	1424358569000
6190	1678	2160041431000
6191	1684	7919150000000
6192	1684	7919160000000
6195	1692	15119502000000
6196	1692	15119512000000
6199	1397	1424338567000
6200	1678	2160041433000
6201	1397	1424328566000
6202	1678	2160041434000
6203	1694	14399295000000
6204	1694	14399315000000
6218	1722	7933111000000
6221	1722	8653111000000
6222	1722	8653121000000
6237	1397	1424218555000
6238	1678	2160041445000
6239	1397	1424208554000
6240	1678	2160041446000
6241	1696	2878041000000
6242	1696	2878061000000
6245	1679	15839751000000
6246	1679	15839771000000
6247	1397	1424198553000
6248	1678	2160041447000
6249	1402	18720361000000
6254	1724	6478690000000
6255	1724	6478700000000
6261	1397	1424178551000
6262	1678	2160041449000
6263	596	70320082000000
6264	596	70320092000000
6269	1397	1424158549000
6270	1678	2160041451000
6271	1397	1424148548000
6272	1678	2160041452000
6273	1397	1424138547000
6274	1678	2160041453000
6275	1682	4307160000000
6287	641	69600260000000
6288	641	69600280000000
6291	1397	1424078541000
6292	1678	2160041459000
6293	1705	5754910000000
6294	1705	5754920000000
6297	1573	5040080000000
6298	1573	5040090000000
6303	1683	167040658999541
6304	1683	167040668999541
6316	1476	6480120000000
6317	1476	6480140000000
6324	1724	7920980000000
6325	1724	8640980000000
6326	1724	8641090000000
6327	1397	1423998533000
6328	1678	2160041467000
6329	1677	61200431000000
6330	1677	61200441000000
6338	1683	168480668999541
6339	1683	168480688999541
6348	1397	1423938527000
6349	1678	2160041473000
6350	162	66720000000000
6351	162	66720010000000
6357	1518	2160020000000
6358	1518	2160030000000
6369	1397	1423888522000
6370	1678	2160041478000
6371	1684	8639160000000
6372	1684	8639170000000
6378	1722	9373121000000
6379	1722	9373131000000
6386	1549	5760071000000
6387	1549	5760091000000
6388	1397	1423848518000
6389	1678	2160041482000
6390	1397	1423838517000
6391	1678	2160041483000
6392	1693	5358237500454
6393	1693	5358257500454
6394	1397	1423828516000
6395	1678	2160041484000
6396	1397	1423818515000
6397	1678	2160041485000
6400	1397	1423808514000
6401	1678	2160041486000
6402	1397	1423798513000
6403	1678	2160041487000
6404	1683	169920688999541
6405	1683	169920698999541
6406	1397	1423788512000
6407	1678	2160041488000
6408	1683	171360698999541
6409	1683	171360708999541
6417	311	73920150000000
6436	1397	1423708504000
6437	1678	2160041496000
6438	1451	2880130000000
6439	1451	2880140000000
6440	1397	1423698503000
6441	1678	2160041497000
6442	1397	1423688502000
6443	1678	2160041498000
6444	1677	63360491000000
6445	1677	63360511000000
6448	1397	1423678501000
6449	1678	2160041499000
6450	1656	6480101000000
6451	1656	6480111000000
6452	1397	1423668500000
6453	1678	2160041500000
6481	1397	1423568490000
6482	1678	2160041510000
6483	1397	1423558489000
6484	1678	2160041511000
6485	1677	64080511000000
6486	1677	64080531000000
6488	1397	1423548488000
6489	1678	2160041512000
6496	1397	1423528486000
6497	1678	2160041514000
6498	633	69600040000000
6499	633	69600050000000
6501	1683	174240728999541
6502	1397	1423518485000
6503	1678	2160041515000
6504	1677	64800531000000
6505	1677	64800541000000
6506	1397	1423508484000
6507	1678	2160041516000
6508	1444	5040090000000
6509	1444	5040100000000
6514	1397	1423478481000
6515	1678	2160041519000
6516	1722	10813141000000
6517	1722	10813151000000
6518	1397	1423468480000
6519	1678	2160041520000
6520	1688	22319542000000
6521	1688	22319552000000
6522	1677	65520541000000
6523	1677	65520551000000
6524	1683	175680728999541
6525	1683	175680738999541
6526	1397	1423458479000
6527	1678	2160041521000
6528	1688	23039552000000
6529	1688	23039562000000
6530	1397	1423448478000
6531	1678	2160041522000
6532	1397	1423438477000
6533	1678	2160041523000
6534	1688	23759562000000
6535	1688	23759582000000
6536	1397	1423428476000
6537	1678	2160041524000
6538	1402	19440361000000
6539	1402	19440371000000
6540	1693	6078257500454
6541	1693	6078267500454
6542	1716	5759130000000
6543	1716	5759140000000
6544	1397	1423418475000
6545	1678	2160041525000
6546	1698	5038990000000
6547	1698	5039000000000
6548	1685	20879440000000
6549	1685	20879450000000
6550	1397	1423408474000
6551	1678	2160041526000
6552	1654	7200120000000
6553	336	66720000000000
6554	336	66720010000000
6555	1397	1423398473000
6556	1678	2160041527000
6557	1440	5040070000000
6558	1440	5040080000000
6559	1397	1423388472000
6560	1678	2160041528000
6561	1688	24479582000000
6562	1688	24479592000000
6563	1397	1423378471000
6564	1678	2160041529000
6565	1688	25199592000000
6566	1688	25199602000000
6567	1397	1423368470000
6568	1678	2160041530000
6569	1397	1423358469000
6570	1678	2160041531000
6571	1397	1423348468000
6572	1678	2160041532000
6573	1688	25919602000000
6574	1688	25919632000000
6575	1448	5040190000000
6576	1397	1423338467000
6577	1678	2160041533000
6578	1397	1423328466000
6579	1678	2160041534000
6580	1397	1423318465000
6581	1678	2160041535000
6582	1593	3600100000000
6583	1397	1423308464000
6584	1678	2160041536000
6585	1397	1423298463000
6586	1678	2160041537000
6587	1489	3600050000000
6588	1489	3600060000000
6589	1690	7919330000000
6590	1690	7919340000000
6591	1397	1423288462000
6592	1678	2160041538000
6593	1397	1423278461000
6594	1678	2160041539000
6595	1686	5038030000000
6596	1683	175680748999541
6597	1456	2160140000000
6598	1456	2160160000000
6599	1397	1423268460000
6600	1678	2160041540000
6601	1397	1423258459000
6602	1678	2160041541000
6603	1634	5760100000000
6604	1634	5760120000000
6605	1397	1423248458000
6606	1678	2160041542000
6607	1683	177120748999541
6608	1683	177120758999541
6609	1397	1423238457000
6610	1678	2160041543000
6611	1677	66240551000000
6612	1677	66240561000000
6613	1397	1423228456000
6614	1678	2160041544000
6615	1649	5040091000000
6616	1649	5040101000000
6617	1683	178560758999541
6618	1683	178560768999541
6619	1740	5757543000000
6620	1740	6477543000000
6621	1740	6477783000000
6622	1397	1423218455000
6623	1678	2160041545000
6624	1637	27360781000000
6625	1397	1423208454000
6626	1678	2160041546000
6627	596	71040092000000
6628	596	71040102000000
6629	1397	1423198453000
6630	1678	2160041547000
6631	1466	720000000000
6632	1466	720010000000
6633	1397	1423188452000
6634	1678	2160041548000
6635	1716	6479140000000
6636	1716	6479150000000
6637	1397	1423178451000
6638	1678	2160041549000
6639	1397	1423168450000
6640	1678	2160041550000
6641	1722	10813161000000
6642	1397	1423158449000
6643	1678	2160041551000
6644	1397	1423148448000
6645	1678	2160041552000
6646	1677	66960561000000
6647	1677	66960581000000
6648	1458	6480120000000
6649	1458	6480140000000
6650	1397	1423138447000
6651	1678	2160041553000
6652	1688	26639632000000
6653	1688	26639642000000
6654	1397	1423128446000
6655	1678	2160041554000
6656	298	71039460000000
6657	298	71039470000000
6658	1397	1423118445000
6659	1678	2160041555000
6660	1397	1423108444000
6661	1678	2160041556000
6662	1397	1423098443000
6663	1678	2160041557000
6664	1688	27359642000000
6665	1688	27359662000000
6666	1397	1423088442000
6667	1678	2160041558000
6668	1699	7919189000000
6669	1699	7919199000000
6670	1397	1423078441000
6671	1678	2160041559000
6672	1723	6479120000000
6673	1723	6479130000000
6674	1397	1423068440000
6675	1678	2160041560000
6676	1397	1423058439000
6677	1678	2160041561000
6678	1474	5760070000000
6679	1474	5760080000000
6680	1397	1423048438000
6681	1678	2160041562000
6682	1397	1423038437000
6683	1678	2160041563000
6684	632	69600080000000
6685	632	69600090000000
6686	1397	1423028436000
6687	1678	2160041564000
6688	1717	2159080000000
6689	1717	2159090000000
6690	1458	7200140000000
6691	1458	7200150000000
6695	1397	1423018435000
6696	1678	2160041565000
6697	1706	4316861000000
6698	1706	4316871000000
6708	1397	1422988432000
6709	1678	2160041568000
6712	1397	1422968430000
6713	1678	2160041570000
6714	1397	1422958429000
6715	1678	2160041571000
6716	1690	8639340000000
6717	1690	8639360000000
6727	1397	1422918425000
6728	1678	2160041575000
6729	1521	720000000000
6730	1521	720010000000
6731	1397	1422908424000
6732	1678	2160041576000
6733	1397	1422898423000
6734	1678	2160041577000
6735	1724	6478710000000
6738	1397	1422878421000
6739	1678	2160041579000
6740	1397	1422868420000
6741	1678	2160041580000
6742	1419	5040090000000
6743	1419	5040110000000
6744	1397	1422858419000
6745	1678	2160041581000
6746	1397	1422848418000
6747	1678	2160041582000
6748	1704	1439030000000
6751	1708	2159160000000
6752	1708	2159180000000
6774	1746	1439120000000
6777	1637	28080791000000
6778	1637	28080801000000
6795	1685	21599450000000
6796	1685	21599460000000
6797	1397	1422748408000
6798	1678	2160041592000
6799	1402	20160371000000
6800	1402	20160381000000
6808	1397	1422708404000
6809	1678	2160041596000
6810	1397	1422698403000
6811	1678	2160041597000
6818	1633	3600050000000
6819	1633	3600060000000
6831	1643	2880060000000
6838	1690	9359360000000
6839	1690	9359370000000
6844	641	70320280000000
6845	641	70320290000000
6846	1397	1422628396000
6847	1678	2160041604000
6848	1397	1422618395000
6849	1678	2160041605000
6850	1397	1422608394000
6851	1678	2160041606000
6852	43	68880110000000
6866	1397	1422558389000
6867	1678	2160041611000
6868	311	74640050000000
6869	311	74640060000000
6878	1688	28799672000000
6879	1688	28799692000000
6880	1397	1422528386000
6881	1678	2160041614000
6882	149	69600060000000
6883	149	69600070000000
6890	1687	5039061000000
6891	1687	5039081000000
6902	1397	1422468380000
6903	1678	2160041620000
6904	1692	16559532000000
6905	1692	16559542000000
6908	1426	4320080000000
6909	1426	4320090000000
6910	1397	1422448378000
6911	1678	2160041622000
6912	43	69600100000000
6913	43	69600130000000
6916	43	69600110000000
6917	1397	1422438377000
6918	1678	2160041623000
6939	1397	1422368370000
6940	1678	2160041630000
6941	1397	1422358369000
6942	1678	2160041631000
6943	1715	5039111000000
6951	1397	1422328366000
6952	1678	2160041634000
6953	1419	5760110000000
6954	1419	5760120000000
6958	1397	1422318365000
6959	1678	2160041635000
6960	1397	1422308364000
6961	1678	2160041636000
6962	1683	185760808999541
6963	1683	185760828999541
6988	1714	4308970000000
6989	554	66720000000000
6990	554	66720210000000
6996	1677	67680681000000
6997	1696	3598061000000
7010	1643	4320729994101
7012	1450	30000000
7021	1397	1422188352000
7022	1678	2160041648000
7023	1397	1422178351000
7024	1678	2160041649000
7025	1397	1422168350000
7026	1678	2160041650000
7027	395	66034303809323
7028	1760	2020000000
7029	1675	2880030000000
7030	1675	2880070000000
7073	1705	5754930000000
7079	1397	1422058339000
7080	1678	2160041661000
7092	1397	1422018335000
7093	1678	2160041665000
7095	1397	1422008334000
7096	1678	2160041666000
7097	1397	1421998333000
7098	1678	2160041667000
7099	1683	187200818999541
7100	1683	187200838999541
7103	1455	2880050000000
7104	1677	68400681000000
7107	1397	1421968330000
7108	1678	2160041670000
7109	1397	1421958329000
7110	1678	2160041671000
7111	1397	1421948328000
7112	1678	2160041672000
7113	1684	9359170000000
7114	1684	9359200000000
7119	1397	1421938327000
7120	1678	2160041673000
7121	1397	1421928326000
7122	1678	2160041674000
7123	576	71040090000000
7129	1397	1421908324000
7130	1678	2160041676000
7139	1672	2880050000000
7140	1397	1421888322000
7141	1678	2160041678000
7142	1682	5027160000000
7143	1682	5027170000000
7148	1688	31679722000000
7149	1688	31679732000000
7158	1596	4320080000000
7159	1596	4320110000000
7165	1397	1421828316000
7166	1678	2160041684000
7167	1397	1421818315000
7168	1678	2160041685000
7169	1688	31679742000000
7183	1683	188640848999541
7184	1397	1421768310000
7185	1678	2160041690000
7186	1457	5760120000000
7187	1457	5760130000000
7196	1397	1421738307000
7197	1678	2160041693000
7198	1397	1421728306000
7199	1678	2160041694000
7200	1677	69120701000000
7201	1677	69120721000000
7206	1690	12239410000000
7207	1690	12239430000000
7208	1747	2159130000000
7218	1746	1439040000000
6692	1689	4319090000000
6693	1689	4319100000000
6704	1506	3600080000000
6705	1506	3600090000000
6706	1397	1422998433000
6707	1678	2160041567000
6710	1397	1422978431000
6711	1678	2160041569000
6718	1397	1422948428000
6719	1678	2160041572000
6720	1397	1422938427000
6721	1678	2160041573000
6722	1489	3600070000000
6750	1746	1439030000000
6753	1397	1422838417000
6754	1678	2160041583000
6757	1397	1422828416000
6758	1678	2160041584000
6759	1687	4319051000000
6760	1687	4319061000000
6763	1683	181440778999541
6764	1683	181440788999541
6765	149	68880050000000
6766	149	68880060000000
6772	1747	1439020000000
6773	1747	1439130000000
6779	1397	1422788412000
6780	1678	2160041588000
6781	1397	1422778411000
6782	1678	2160041589000
6783	1397	1422768410000
6784	1678	2160041590000
6785	1423	1440010000000
6786	1423	1440040000000
6789	1397	1422758409000
6790	1678	2160041591000
6791	44	70320150000000
6792	1514	70320159995100
6793	44	4900
6794	44	70320160000000
6812	1692	15839512000000
6813	1692	15839532000000
6816	1451	3600140000000
6817	1451	3600150000000
6832	1397	1422658399000
6833	1678	2160041601000
6834	1683	182880788999541
6835	1683	182880798999541
6840	1397	1422638397000
6841	1678	2160041603000
6842	1637	28800801000000
6843	1637	28800811000000
6854	43	68880780000000
6870	1683	184320798999541
6871	1683	184320808999541
6872	1397	1422548388000
6873	1678	2160041612000
6874	1397	1422538387000
6875	1678	2160041613000
6876	1691	2879030000000
6877	1691	2879050000000
6884	1397	1422518385000
6885	1678	2160041615000
6886	1397	1422508384000
6887	1678	2160041616000
6888	1559	7200170000000
6889	1559	7200190000000
6893	1397	1422498383000
6894	1678	2160041617000
6895	1397	1422488382000
6896	1678	2160041618000
6897	369	70320110000000
6906	1397	1422458379000
6907	1678	2160041621000
6919	1397	1422428376000
6920	1678	2160041624000
6921	1716	7199150000000
6922	1716	7199160000000
6925	1397	1422418375000
6926	1678	2160041625000
6944	1397	1422348368000
6945	1678	2160041632000
6946	1448	5040200000000
6957	1714	6469000000000
6964	1590	6800000000
6965	1758	2000000000
6966	1397	1422298363000
6967	1678	2160041637000
6968	1722	11533161000000
6969	1722	11533271000000
6982	1397	1422258359000
6983	1678	2160041641000
6984	1397	1422248358000
6985	1678	2160041642000
6986	1691	3599040000000
6987	1691	3599060000000
6998	1672	2880040000000
7000	1509	4320100000000
7011	1426	4320110000000
7013	1450	2160040000000
7014	1564	10000000
7020	1687	5039071000000
7037	1737	1000001400
7038	1643	5040729994001
7039	1643	1000001700
7040	1737	5040814993701
7041	1650	3600185000000
7051	1643	3600100000000
7052	1397	1422118345000
7053	1678	2160041655000
7054	1397	1422108344000
7055	1678	2160041656000
7056	1536	6480140000000
7057	1536	6480160000000
7058	1397	1422098343000
7059	1678	2160041657000
7060	1439	3600060000000
7061	1439	3600070000000
7066	1397	1422078341000
7067	1678	2160041659000
7068	1623	5040091000000
7074	1688	30959702000000
7075	1688	30959722000000
7078	1722	11533171000000
7081	1397	1422048338000
7082	1678	2160041662000
7086	1397	1422038337000
7087	1678	2160041663000
7088	1397	1422028336000
7089	1678	2160041664000
7090	1692	17279542000000
7091	1692	17279562000000
7094	1683	185760818999541
7105	1397	1421978331000
7106	1678	2160041669000
7115	1683	188640838999541
7116	1683	188640868999541
7124	1677	68400701000000
7125	1397	1421918325000
7126	1678	2160041675000
7127	1698	5759020000000
7128	1698	5759030000000
7131	1546	5760100000000
7132	1546	5760110000000
7145	1397	1421878321000
7146	1678	2160041679000
7147	1668	5040070000000
7160	596	71760232000000
7176	1622	3600579995401
7177	1397	1421788312000
7178	1678	2160041688000
7192	1397	1421748308000
7193	1678	2160041692000
7194	1419	7200140000000
7195	1419	7200150000000
7202	1668	5760070000000
7203	1668	5760090000000
7216	1677	69840721000000
7217	1677	69840751000000
6694	1458	7200170000000
6699	1683	180000768999541
6700	1683	180000778999541
6701	1397	1423008434000
6702	1678	2160041566000
6703	1677	66960571000000
6723	1397	1422928426000
6724	1678	2160041574000
6725	1740	7196543000000
6726	1740	7196553000000
6736	1397	1422888422000
6737	1678	2160041578000
6749	1747	719020000000
6755	1688	28079662000000
6756	1688	28079672000000
6761	1397	1422818415000
6762	1678	2160041585000
6767	633	69598950000000
6768	120	66001000000000
6769	1397	1422808414000
6770	1678	2160041586000
6771	1704	1439120000000
6775	1397	1422798413000
6776	1678	2160041587000
6787	1537	10000000
6788	44	70320140000000
6801	1397	1422738407000
6802	1678	2160041593000
6803	1397	1422728406000
6804	1678	2160041594000
6805	1397	1422718405000
6806	1678	2160041595000
6807	1698	5039020000000
6814	1397	1422688402000
6815	1678	2160041598000
6820	1397	1422678401000
6821	1678	2160041599000
6822	1397	1422668400000
6823	1678	2160041600000
6824	1693	6078277500454
6825	633	68158930000000
6826	1737	1000000200
6827	1643	3600849999800
6828	1643	1000001300
6829	1737	3600969998700
6830	1650	3600160000000
6836	1397	1422648398000
6837	1678	2160041602000
6853	43	68880100000000
6855	1397	1422598393000
6856	1678	2160041607000
6857	1677	67680571000000
6858	1677	67680581000000
6859	1397	1422588392000
6860	1678	2160041608000
6861	1397	1422578391000
6862	1678	2160041609000
6863	1397	1422568390000
6864	1678	2160041610000
6865	1506	3600110000000
6892	1516	1440040000000
6898	1397	1422478381000
6899	1678	2160041619000
6900	1618	720000000000
6901	1618	720010000000
6914	1471	2880050000000
6915	1471	2880060000000
6923	1688	29519692000000
6924	1688	29519702000000
6927	1714	5749000000000
6928	1590	9900000000
6929	1397	1422408374000
6930	1678	2160041626000
6931	1397	1422398373000
6932	1678	2160041627000
6933	1397	1422388372000
6934	1678	2160041628000
6935	1397	1422378371000
6936	1678	2160041629000
6937	1685	22319460000000
6938	1685	22319600000000
6947	1397	1422338367000
6948	1678	2160041633000
6949	369	71040110000000
6950	369	71040120000000
6955	1513	2880030000000
6956	1513	2880040000000
6970	1607	6480090000000
6971	1607	6480200000000
6972	1397	1422288362000
6973	1678	2160041638000
6974	1608	3600050000000
6975	1608	3600060000000
6976	1397	1422278361000
6977	1678	2160041639000
6978	1397	1422268360000
6979	1678	2160041640000
6980	1444	5760100000000
6981	1444	5760120000000
6991	1758	400000000
6992	1713	500000000
6993	1397	1422238357000
6994	1678	2160041643000
6995	1683	185760918999541
6999	1759	719000000000
7001	1690	10079370000000
7002	1397	1422228356000
7003	1678	2160041644000
7004	1397	1422218355000
7005	1678	2160041645000
7006	1397	1422208354000
7007	1678	2160041646000
7008	1710	3598960000000
7009	1710	3598990000000
7015	1643	3600060000000
7016	1643	3600090000000
7017	1397	1422198353000
7018	1678	2160041647000
7019	1708	2159170000000
7031	1397	1422158349000
7032	1678	2160041651000
7033	1760	1000000000
7034	1761	10000000
7035	1419	6480120000000
7036	1419	6480140000000
7042	1397	1422148348000
7043	1678	2160041652000
7044	1760	990000000
7045	1397	1422138347000
7046	1678	2160041653000
7047	1397	1422128346000
7048	1678	2160041654000
7049	1521	1440010000000
7050	1521	1440050000000
7062	1397	1422088342000
7063	1678	2160041658000
7064	1715	5759111000000
7065	1715	5759131000000
7069	1688	30239702000000
7070	1397	1422068340000
7071	1678	2160041660000
7072	1722	11533181000000
7076	1470	720000000000
7077	1470	720010000000
7083	1506	4320110000000
7084	1506	4320120000000
7085	1555	2160290000000
7101	1397	1421988332000
7102	1678	2160041668000
7117	1690	10799370000000
7118	1690	10799400000000
7133	633	68878940000000
7134	1546	5041130000000
7135	1546	5761130000000
7136	1546	5761530000000
7137	1397	1421898323000
7138	1678	2160041677000
7144	1668	5040060000000
7150	1397	1421868320000
7151	1678	2160041680000
7152	1397	1421858319000
7153	1678	2160041681000
7154	1397	1421848318000
7155	1678	2160041682000
7156	596	71760102000000
7157	596	71760132000000
7161	1397	1421838317000
7162	1678	2160041683000
7163	1682	5747170000000
7164	1682	5747180000000
7170	1397	1421808314000
7171	1678	2160041686000
7172	1397	1421798313000
7173	1678	2160041687000
7174	58	71760120000000
7175	58	71760140000000
7179	1690	11519400000000
7180	1690	11519410000000
7181	1397	1421778311000
7182	1678	2160041689000
7188	1397	1421758309000
7189	1678	2160041691000
7190	1683	190080848999541
7191	1683	190080858999541
7204	1689	5039100000000
7205	1689	5039120000000
7209	1397	1421718305000
7210	1678	2160041695000
7211	1397	1421708304000
7212	1678	2160041696000
7213	1397	1421698303000
7214	1678	2160041697000
7215	1704	1439040000000
7219	1419	7920150000000
7220	1419	7920180000000
7221	1633	3600080000000
7222	1397	1421688302000
7223	1678	2160041698000
7224	1688	31679782000000
7225	1688	32399782000000
7226	1580	10000000
7227	1679	16559751000000
7228	1397	1421678301000
7229	1678	2160041699000
7230	633	70318950000000
7231	633	70318960000000
7232	45	70318959999990
7233	633	66000000000010
7234	1397	1421668300000
7235	1678	2160041700000
7236	1397	1421658299000
7237	1678	2160041701000
7238	1698	6479030000000
7239	1698	6479060000000
7240	1397	1421648298000
7241	1678	2160041702000
7242	1397	1421638297000
7243	1678	2160041703000
7244	337	66720000000000
7245	337	66720020000000
7246	1513	2880050000000
7247	1397	1421628296000
7248	1678	2160041704000
7249	1397	1421618295000
7250	1678	2160041705000
7251	1397	1421608294000
7252	1678	2160041706000
7253	1688	33119782000000
7254	1688	33119812000000
7255	1397	1421598293000
7256	1678	2160041707000
7257	1560	5760110000000
7258	1560	5760120000000
7259	1397	1421588292000
7260	1678	2160041708000
7261	1670	6480330000000
7262	1670	6480340000000
7263	1397	1421578291000
7264	1678	2160041709000
7265	1489	4320070000000
7266	1489	4320080000000
7267	1397	1421568290000
7268	1678	2160041710000
7269	1397	1421558289000
7270	1678	2160041711000
7271	1679	17279751000000
7272	1679	17279771000000
7273	1700	5039150000000
7274	1700	5039170000000
7275	44	71040160000000
7276	44	71040180000000
7277	1440	5760080000000
7278	1440	5760100000000
7279	1397	1421548288000
7280	1678	2160041712000
7281	1397	1421538287000
7282	1678	2160041713000
7283	1397	1421528286000
7284	1678	2160041714000
7285	1445	6480150000000
7286	1445	6480170000000
7287	1643	3600080000000
7288	1397	1421518285000
7289	1678	2160041715000
7290	1587	4320070000000
7291	1397	1421508284000
7292	1678	2160041716000
7293	484	71760090000000
7294	484	71760100000000
7295	1397	1421498283000
7296	1678	2160041717000
7297	1670	7200340000000
7298	1670	7200350000000
7299	1683	191520858999541
7300	1683	191520868999541
7301	441	66720000000000
7302	441	66720010000000
7303	441	66000490000000
7304	441	66720490000000
7305	441	66721430000000
7306	1397	1421488282000
7307	1678	2160041718000
7308	1397	1421478281000
7309	1678	2160041719000
7310	1429	0
7311	1740	7916553000000
7312	1740	7916583000000
7313	641	71040290000000
7314	641	71040320000000
7315	1397	1421468280000
7316	1678	2160041720000
7317	1690	12239420000000
7318	1397	1421458279000
7319	1678	2160041721000
7320	1679	17999771000000
7321	1679	17999781000000
7322	1397	1421448278000
7323	1678	2160041722000
7324	1397	1421438277000
7325	1678	2160041723000
7326	1690	12959420000000
7327	1690	12959440000000
7328	171	70320070000000
7329	171	70320090000000
7330	1397	1421428276000
7331	1678	2160041724000
7332	1688	33839812000000
7333	1688	33839822000000
7334	1397	1421418275000
7335	1678	2160041725000
7336	1688	34559822000000
7337	1688	34559832000000
7338	1397	1421408274000
7339	1678	2160041726000
7340	484	72480100000000
7341	484	72480110000000
7342	1397	1421398273000
7343	1678	2160041727000
7344	1677	69840731000000
7345	1397	1421388272000
7346	1678	2160041728000
7347	1397	1421378271000
7348	1678	2160041729000
7349	1606	720000000000
7350	1606	720010000000
7351	1397	1421368270000
7352	1678	2160041730000
7353	1587	5040070000000
7354	1587	5040080000000
7355	1397	1421358269000
7356	1678	2160041731000
7357	1688	35279832000000
7358	1688	35279842000000
7359	1397	1421348268000
7360	1678	2160041732000
7361	1536	6480150000000
7362	1703	2879030000000
7363	1703	2879040000000
7364	1706	5036871000000
7365	1706	5036881000000
7366	1397	1421338267000
7367	1678	2160041733000
7368	120	66000900000000
7369	1397	1421328266000
7370	1678	2160041734000
7371	1700	5039260000000
7372	1397	1421318265000
7373	1678	2160041735000
7374	606	70320050000000
7375	606	70320060000000
7376	1397	1421308264000
7377	1678	2160041736000
7378	606	70320070000000
7379	1397	1421298263000
7380	1678	2160041737000
7381	1397	1421288262000
7382	1678	2160041738000
7383	1397	1421278261000
7384	1678	2160041739000
7385	1397	1421268260000
7386	1678	2160041740000
7387	149	70320070000000
7388	149	70320110000000
7389	1397	1421258259000
7390	1678	2160041741000
7391	1397	1421248258000
7392	1678	2160041742000
7393	1397	1421238257000
7394	1678	2160041743000
7395	1458	7920150000000
7396	1458	7920170000000
7415	1692	17999562000000
7416	1692	17999572000000
7429	1634	6480120000000
7430	1634	6480130000000
7431	1397	1421148248000
7432	1678	2160041752000
7433	1397	1421138247000
7434	1678	2160041753000
7435	1673	2880300000000
7440	1683	194400888999541
7441	1683	194400898999541
7442	1397	1421118245000
7443	1678	2160041755000
7444	1727	2879030000000
7445	1727	2879040000000
7452	1727	3599040000000
7453	1727	3599060000000
7460	1649	5760101000000
7461	1649	5760131000000
7462	1397	1421068240000
7463	1678	2160041760000
7464	1694	14399305000000
7473	1397	1421038237000
7474	1678	2160041763000
7475	64	66720000000000
7476	64	66720010000000
7480	1397	1421018235000
7481	1678	2160041765000
7500	1397	1420968230000
7501	1678	2160041770000
7502	1397	1420958229000
7503	1678	2160041771000
7504	1397	1420948228000
7505	1678	2160041772000
7506	1657	5040090000000
7507	1657	5040120000000
7511	1397	1420938227000
7512	1678	2160041773000
7513	1397	1420928226000
7514	1678	2160041774000
7519	1397	1420918225000
7520	1678	2160041775000
7521	1683	198720938999541
7522	1683	198720948999541
7523	1397	1420908224000
7524	1678	2160041776000
7525	1717	2879090000000
7526	1717	2879100000000
7535	1397	1420878221000
7536	1678	2160041779000
7537	596	71760112000000
7548	1685	23759610000000
7549	1685	23759620000000
7559	1397	1420798213000
7560	1678	2160041787000
7561	1623	6480101000000
7562	1623	6480111000000
7563	1397	1420788212000
7564	1678	2160041788000
7565	484	73200110000000
7566	484	73200120000000
7569	1397	1420778211000
7570	1678	2160041789000
7571	1571	5760070000000
7572	1571	5760080000000
7575	1397	1420768210000
7576	1678	2160041790000
7577	1397	1420758209000
7578	1678	2160041791000
7579	596	72480112000000
7580	596	72480132000000
7581	1397	1420748208000
7582	1678	2160041792000
7583	1677	71280741000000
7584	1677	71280751000000
7589	1397	1420728206000
7590	1678	2160041794000
7591	1397	1420718205000
7592	1678	2160041795000
7593	1608	4320060000000
7594	1608	4320080000000
7601	1541	2880060000000
7602	1541	2880070000000
7606	1677	72000751000000
7607	1677	72000761000000
7638	1402	20880401000000
7651	606	71040070000000
7652	606	71040080000000
7665	1397	1420528186000
7666	1678	2160041814000
7667	1519	719000000000
7668	1763	0
7669	1677	72000771000000
7683	1683	201600958999541
7684	1683	201600968999541
7685	1397	1420468180000
7686	1678	2160041820000
7687	1690	12959430000000
7688	1397	1420458179000
7689	1678	2160041821000
7690	1397	1420448178000
7691	1678	2160041822000
7692	1397	1420438177000
7693	1678	2160041823000
7694	1397	1420428176000
7695	1678	2160041824000
7696	641	71040330000000
7707	1764	719000000000
7708	1764	719070000000
7709	1397	1420388172000
7710	1678	2160041828000
7711	1671	6480190000000
7712	1671	6480200000000
7715	1397	1420368170000
7716	1678	2160041830000
7729	1601	4320110000000
7730	1601	4320140000000
7735	1397	1420298163000
7736	1678	2160041837000
7737	1397	1420288162000
7738	1678	2160041838000
7739	1458	8640170000000
7740	1458	8640190000000
7741	1397	1420278161000
7742	1678	2160041839000
7743	1677	72720771000000
7744	1677	72720781000000
7751	1397	1420248158000
7752	1678	2160041842000
7753	1397	1420238157000
7754	1678	2160041843000
7755	1397	1420228156000
7756	1678	2160041844000
7757	1677	73440781000000
7758	1677	73440811000000
7763	1397	1420218155000
7764	1678	2160041845000
7765	1397	1420208154000
7766	1678	2160041846000
7767	1397	1420198153000
7768	1678	2160041847000
7769	1693	6077157500454
7770	1765	100000000
7771	1717	2879130000000
7772	1708	2879170000000
7773	1708	2879210000000
7778	1397	1420178151000
7779	1678	2160041849000
7780	1506	5040120000000
7781	1506	5040130000000
7807	1397	1420088142000
7808	1678	2160041858000
7809	1715	7199181000000
7810	1715	7199191000000
7814	1397	1420068140000
7815	1678	2160041860000
7816	1458	1000000200
7817	1737	8640172798540
7818	1515	66000000000660
7819	45	4200600
7820	1492	400400000
7821	1758	12600000
7824	1706	4316771000000
7825	1646	0
7826	1397	1420048138000
7827	1678	2160041862000
7828	1702	2879030000000
7829	1702	2879140000000
7839	1397	1420018135000
7840	1678	2160041865000
7860	1402	20880421000000
7870	1397	1419918125000
7871	1678	2160041875000
7872	1684	9359180000000
7884	1397	1419888122000
7885	1678	2160041878000
7886	1680	10079210000000
7887	1680	10079220000000
7896	1397	1419848118000
7897	1678	2160041882000
7898	1447	5760070000000
7899	1447	5760080000000
7908	1702	2879050000000
7911	1703	3599140000000
7397	1397	1421228256000
7398	1678	2160041744000
7399	1677	70560731000000
7400	1677	70560741000000
7403	1397	1421218255000
7404	1678	2160041745000
7405	1693	6798267500454
7406	1693	6798277500454
7407	1685	23039600000000
7408	1685	23039610000000
7409	1397	1421208254000
7410	1678	2160041746000
7411	1656	7200111000000
7412	1656	7200121000000
7417	1397	1421188252000
7418	1678	2160041748000
7419	1397	1421178251000
7420	1678	2160041749000
7421	1683	192960868999541
7422	1683	192960888999541
7425	1457	6480130000000
7426	1457	6480140000000
7427	1397	1421158249000
7428	1678	2160041751000
7436	1397	1421128246000
7437	1678	2160041754000
7438	1613	2878000000000
7439	1613	2878010000000
7446	1397	1421108244000
7447	1678	2160041756000
7448	1397	1421098243000
7449	1678	2160041757000
7450	1670	7920350000000
7451	1670	7920370000000
7454	1647	0
7455	1397	1421088242000
7456	1678	2160041758000
7457	1397	1421078241000
7458	1678	2160041759000
7459	1560	5760140000000
7477	1397	1421028236000
7478	1678	2160041764000
7479	1689	5039110000000
7487	1696	3598071000000
7488	1397	1420998233000
7489	1678	2160041767000
7490	1683	197280908999541
7491	1683	197280918999541
7494	1397	1420988232000
7495	1678	2160041768000
7496	1397	1420978231000
7497	1678	2160041769000
7498	171	71040090000000
7499	171	71040110000000
7510	1683	197280938999541
7517	1623	5760091000000
7518	1623	5760101000000
7527	1397	1420898223000
7528	1678	2160041777000
7529	1683	200160948999541
7530	1683	200160958999541
7547	55	67440040000000
7550	1397	1420838217000
7551	1678	2160041783000
7552	1397	1420828216000
7553	1678	2160041784000
7554	1397	1420818215000
7555	1678	2160041785000
7556	1397	1420808214000
7557	1678	2160041786000
7558	1541	2160060000000
7567	1613	3598010000000
7568	1613	3598020000000
7585	1602	5040100000000
7586	1602	5040110000000
7595	1397	1420708204000
7596	1678	2160041796000
7597	1680	9359200000000
7598	1680	9359210000000
7603	171	71040100000000
7608	1397	1420678201000
7609	1678	2160041799000
7610	1397	1420668200000
7611	1678	2160041800000
7612	1397	1420658199000
7613	1678	2160041801000
7614	1397	1420648198000
7615	1678	2160041802000
7616	1397	1420638197000
7617	1678	2160041803000
7618	1715	5759181000000
7619	1715	6479181000000
7624	1397	1420618195000
7625	1678	2160041805000
7628	1397	1420608194000
7629	1678	2160041806000
7630	1397	1420598193000
7631	1678	2160041807000
7632	1419	7920170000000
7633	1397	1420588192000
7634	1678	2160041808000
7635	1397	1420578191000
7636	1678	2160041809000
7637	1571	5760090000000
7640	1716	6480220000000
7641	1397	1420568190000
7642	1678	2160041810000
7643	45	66000000000010
7644	1716	7200219999990
7645	1716	66000000000290
7646	45	7200259999710
7647	1397	1420558189000
7648	1678	2160041811000
7649	1739	2879040000000
7650	1739	2879050000000
7653	1397	1420548188000
7654	1678	2160041812000
7655	484	73920120000000
7656	484	73920130000000
7663	1637	30240821000000
7664	1637	30240831000000
7670	1397	1420518185000
7671	1678	2160041815000
7672	1397	1420508184000
7673	1678	2160041816000
7674	1397	1420498183000
7675	1678	2160041817000
7676	1397	1420488182000
7677	1678	2160041818000
7678	1700	5759260000000
7679	1700	5759300000000
7697	641	71040980000000
7698	1756	7919139000000
7699	1397	1420418175000
7700	1678	2160041825000
7701	1397	1420408174000
7702	1678	2160041826000
7703	1397	1420398173000
7704	1678	2160041827000
7705	1719	2159040000000
7706	1719	2159110000000
7717	1397	1420358169000
7718	1678	2160041831000
7719	1397	1420348168000
7720	1678	2160041832000
7721	1541	2880080000000
7722	1397	1420338167000
7723	1678	2160041833000
7724	1397	1420328166000
7725	1678	2160041834000
7726	1397	1420318165000
7727	1678	2160041835000
7728	1402	20880411000000
7731	1397	1420308164000
7732	1678	2160041836000
7733	1668	6480080000000
7734	1668	6480090000000
7745	1397	1420268160000
7746	1678	2160041840000
7747	1683	203040968999541
7748	1683	203040978999541
7749	1397	1420258159000
7750	1678	2160041841000
7759	43	70320110000000
7760	43	70320140000000
7761	1559	7920190000000
7762	1559	7920220000000
7774	1397	1420188152000
7775	1678	2160041848000
7776	1546	6480110000000
7777	1546	6480120000000
7790	1397	1420138147000
7791	1678	2160041853000
7792	1397	1420128146000
7793	1678	2160041854000
7794	1714	7189000000000
7795	1714	7189020000000
7802	1559	7920200000000
7805	1397	1420098143000
7806	1678	2160041857000
7830	1703	2879140000000
7841	1397	1420008134000
7842	1678	2160041866000
7843	1683	205920988999541
7844	1683	205920998999541
7401	1402	20880381000000
7402	1402	20880391000000
7413	1397	1421198253000
7414	1678	2160041747000
7423	1397	1421168250000
7424	1678	2160041750000
7465	1683	195840898999541
7466	1683	195840908999541
7467	1397	1421058239000
7468	1678	2160041761000
7469	1397	1421048238000
7470	1678	2160041762000
7471	1670	8640370000000
7472	1670	8640390000000
7482	1599	5760080000000
7483	1599	5760090000000
7484	1397	1421008234000
7485	1678	2160041766000
7486	1668	5760080000000
7492	1637	29520811000000
7493	1637	29520821000000
7508	1422	2160020000000
7509	1422	2160050000000
7515	633	71038960000000
7516	633	71038970000000
7531	1397	1420888222000
7532	1678	2160041778000
7533	1702	2159020000000
7534	1702	2159030000000
7538	1476	7200140000000
7539	1476	7200150000000
7540	1397	1420868220000
7541	1678	2160041780000
7542	1397	1420858219000
7543	1678	2160041781000
7544	1467	2161380000000
7545	1397	1420848218000
7546	1678	2160041782000
7573	1508	3600050000000
7574	1508	3600060000000
7587	1397	1420738207000
7588	1678	2160041793000
7599	1397	1420698203000
7600	1678	2160041797000
7604	1397	1420688202000
7605	1678	2160041798000
7620	1397	1420628196000
7621	1678	2160041804000
7622	1670	9360390000000
7623	1670	9360400000000
7626	1762	719000000000
7627	1762	719010000000
7639	1555	2880010000000
7657	1397	1420538187000
7658	1678	2160041813000
7659	1560	6480140000000
7660	1560	6480150000000
7661	1692	18719562000000
7662	1692	18719572000000
7680	1397	1420478181000
7681	1678	2160041819000
7682	1422	2160030000000
7713	1397	1420378171000
7714	1678	2160041829000
7782	1397	1420168150000
7783	1678	2160041850000
7784	1397	1420158149000
7785	1678	2160041851000
7786	1397	1420148148000
7787	1678	2160041852000
7788	1692	19439572000000
7789	1692	19439602000000
7796	1397	1420118145000
7797	1678	2160041855000
7798	1693	6797157500454
7799	1693	6797167500454
7800	470	73200151000000
7801	470	73200161000000
7803	1397	1420108144000
7804	1678	2160041856000
7811	1397	1420078141000
7812	1678	2160041859000
7813	576	71040610000000
7822	1397	1420058139000
7823	1678	2160041861000
7831	1397	1420038137000
7832	1678	2160041863000
7833	1679	18719781000000
7834	1679	18719791000000
7835	1683	204480978999541
7836	1683	204480988999541
7837	1397	1420028136000
7838	1678	2160041864000
7845	1397	1419998133000
7846	1678	2160041867000
7847	1711	5039070000000
7848	1711	5039080000000
7851	1397	1419988132000
7852	1678	2160041868000
7853	1397	1419978131000
7854	1678	2160041869000
7855	1397	1419968130000
7856	1678	2160041870000
7857	1397	1419958129000
7858	1678	2160041871000
7859	1686	5038050000000
7865	1397	1419938127000
7866	1678	2160041873000
7867	1397	1419928126000
7868	1678	2160041874000
7869	1687	5039051000000
7882	1706	5036771000000
7883	1706	5036791000000
7894	1397	1419858119000
7895	1678	2160041881000
7905	1698	6479560000000
7906	1698	7199560000000
7907	1698	7199610000000
7931	1445	6480160000000
7932	1397	1419788112000
7933	1678	2160041888000
7934	1397	1419778111000
7935	1678	2160041889000
7936	1677	74880841000000
7949	1397	1419728106000
7950	1678	2160041894000
7951	1397	1419718105000
7952	1678	2160041895000
7953	1555	4320030000000
7954	1555	4320050000000
7963	1691	4319060000000
7964	1691	4319070000000
7973	1613	4318020000000
7974	1613	4318050000000
7979	1397	1419648098000
7980	1678	2160041902000
7981	1677	76320851000000
7982	1677	76320861000000
7987	1766	24
7988	1518	2879409999946
7849	1587	5760080000000
7850	1587	5760090000000
7861	1397	1419948128000
7862	1678	2160041872000
7863	1677	74160811000000
7864	1677	74160821000000
7873	1688	34560632000000
7874	1688	35280632000000
7875	1688	35280752000000
7876	1397	1419908124000
7877	1678	2160041876000
7878	1397	1419898123000
7879	1678	2160041877000
7880	1402	21600421000000
7881	1402	21600441000000
7888	1397	1419878121000
7889	1678	2160041879000
7890	1397	1419868120000
7891	1678	2160041880000
7892	1555	3600010000000
7893	1555	3600030000000
7900	1397	1419838117000
7901	1678	2160041883000
7902	1397	1419828116000
7903	1678	2160041884000
7904	1560	6480160000000
7909	1698	7199060000000
7910	1698	7199080000000
7921	1397	1419798113000
7922	1678	2160041887000
7923	1467	2881380000000
7924	1467	2881390000000
7943	1397	1419748108000
7944	1678	2160041892000
7945	1397	1419738107000
7946	1678	2160041893000
7947	1692	20159602000000
7948	1692	20159622000000
7959	1397	1419698103000
7960	1678	2160041897000
7961	1677	75600841000000
7962	1677	75600851000000
7965	1397	1419688102000
7966	1678	2160041898000
7967	1397	1419678101000
7968	1678	2160041899000
7969	1397	1419668100000
7970	1678	2160041900000
7971	1672	3600050000000
7972	1672	3600080000000
7983	1679	20159801000000
7984	1679	20159811000000
7985	1692	20879622000000
7986	1692	20879632000000
7989	1397	1419638097000
7990	1678	2160041903000
7991	1699	8639199000000
7992	1699	8639209000000
7993	1690	14399440000000
7994	1690	14399450000000
7912	1703	3599160000000
7913	1397	1419818115000
7914	1678	2160041885000
7915	1679	19439791000000
7916	1679	19439801000000
7917	1397	1419808114000
7918	1678	2160041886000
7919	1723	7199130000000
7920	1723	7199140000000
7925	1677	74880821000000
7926	1677	74880831000000
7927	1518	1440400000000
7928	1518	2160399999990
7929	1518	66000000000030
7930	45	2160409999970
7937	1397	1419768110000
7938	1678	2160041890000
7939	1397	1419758109000
7940	1678	2160041891000
7941	1467	3601390000000
7942	1467	3601410000000
7955	1397	1419708104000
7956	1678	2160041896000
7957	1690	13679430000000
7958	1690	13679440000000
7975	1397	1419658099000
7976	1678	2160041901000
7977	1402	22320441000000
7978	1402	22320451000000
7995	1397	1419628096000
7996	1678	2160041904000
7997	1397	1419618095000
7998	1678	2160041905000
7999	1602	5040120000000
8000	1637	30960831000000
8001	1637	30960851000000
8002	1397	1419608094000
8003	1678	2160041906000
8004	1397	1419598093000
8005	1678	2160041907000
8006	1509	4320110000000
8007	1552	2160020000000
8008	1552	2160030000000
8009	1767	719000000000
8010	1767	719010000000
8011	1397	1419588092000
8012	1678	2160041908000
8013	1397	1419578091000
8014	1678	2160041909000
8015	1623	7200111000000
8016	1623	7200131000000
8017	1683	207360998999541
8018	1683	207361018999541
8019	1397	1419568090000
8020	1678	2160041910000
8021	1596	5040110000000
8022	1397	1419558089000
8023	1678	2160041911000
8024	1397	1419548088000
8025	1678	2160041912000
8026	1677	76320871000000
8027	45	1000001100
8028	1737	66000000001040
8029	1492	12603400
8030	1515	21000000
8031	1681	8639253195920
8032	1397	1419538087000
8033	1678	2160041913000
8034	1397	1419528086000
8035	1678	2160041914000
8036	1710	4318990000000
8037	1710	4319010000000
8038	1397	1419518085000
8039	1678	2160041915000
8040	1699	9359209000000
8041	1699	9359219000000
8042	1637	30960841000000
8043	1698	7919610000000
8044	1698	7919920000000
8045	1397	1419508084000
8046	1678	2160041916000
8047	1397	1419498083000
8048	1678	2160041917000
8049	43	70320130000000
8050	1698	7919080000000
8051	1698	7919100000000
8052	1397	1419488082000
8053	1678	2160041918000
8054	1683	207361008999541
8055	1397	1419478081000
8056	1678	2160041919000
8057	1397	1419468080000
8058	1678	2160041920000
8059	1397	1419458079000
8060	1678	2160041921000
8061	1397	1419448078000
8062	1678	2160041922000
8063	1397	1419438077000
8064	1678	2160041923000
8065	1599	6480090000000
8066	1599	6480140000000
8067	44	71040210000000
8068	1397	1419428076000
8069	1678	2160041924000
8070	1613	5038050000000
8071	1613	5038060000000
8072	1397	1419418075000
8073	1678	2160041925000
8074	1397	1419408074000
8075	1678	2160041926000
8076	1683	208801008999541
8077	1683	208801018999541
8078	1685	24479620000000
8079	1685	24479630000000
8080	1397	1419398073000
8081	1678	2160041927000
8082	1397	1419388072000
8083	1678	2160041928000
8084	1610	5760120000000
8085	1610	5760140000000
8086	1397	1419378071000
8087	1678	2160041929000
8088	1397	1419368070000
8089	1678	2160041930000
8090	1699	9359229000000
8091	1397	1419358069000
8092	1678	2160041931000
8093	1397	1419348068000
8094	1678	2160041932000
8095	1397	1419338067000
8096	1678	2160041933000
8097	1692	21599632000000
8098	1692	21599642000000
8099	1397	1419328066000
8100	1678	2160041934000
8101	1397	1419318065000
8102	1678	2160041935000
8103	1474	6480080000000
8104	1474	6480100000000
8105	1397	1419308064000
8106	1678	2160041936000
8107	1474	6480090000000
8108	1397	1419298063000
8109	1678	2160041937000
8110	1634	7200130000000
8111	1634	7200140000000
8112	1397	1419288062000
8113	1678	2160041938000
8114	1608	5040080000000
8115	1608	5040090000000
8116	1637	31680841000000
8117	1637	31680851000000
8118	1397	1419278061000
8119	1678	2160041939000
8120	1677	77040861000000
8121	1677	77040871000000
8122	1699	10079229000000
8123	1699	10079239000000
8124	1681	9359253195920
8125	1681	9359263195920
8126	1611	3600050000000
8127	1611	3600060000000
8128	1397	1419268060000
8129	1678	2160041940000
8130	1397	1419258059000
8131	1678	2160041941000
8132	1397	1419248058000
8133	1678	2160041942000
8134	1694	15119305000000
8135	1694	15119325000000
8136	1397	1419238057000
8137	1678	2160041943000
8138	43	71040130000000
8139	43	71040140000000
8140	1397	1419228056000
8141	1678	2160041944000
8142	1608	5760090000000
8143	1608	5760100000000
8144	525	66720000000000
8145	525	66720010000000
8146	1397	1419218055000
8147	1678	2160041945000
8148	1602	5760120000000
8149	1602	5760130000000
8150	1397	1419208054000
8151	1678	2160041946000
8158	1506	5760130000000
8159	1506	5760150000000
8173	641	71041460000000
8174	641	71761460000000
8175	1420	180000000
8176	1721	94222222
8177	641	71761685777778
8178	1397	1419128046000
8179	1678	2160041954000
8180	1693	7517167500454
8181	1693	7517177500454
8184	1397	1419118045000
8185	1678	2160041955000
8186	1672	3600060000000
8187	1397	1419108044000
8188	1678	2160041956000
8189	1397	1419098043000
8190	1678	2160041957000
8191	1681	10799283195920
8192	1681	10799303195920
8193	1397	1419088042000
8194	1678	2160041958000
8195	1719	2879110000000
8196	1719	2879120000000
8208	1699	10079249000000
8215	1683	210241018999541
8216	1683	210241028999541
8231	1762	1439010000000
8232	1762	1439050000000
8239	1397	1418958029000
8240	1678	2160041971000
8241	1439	4320070000000
8242	1439	4320080000000
8247	1643	4320080000000
8248	1643	4321140000000
8254	1397	1418928026000
8255	1678	2160041974000
8256	1723	7919140000000
8257	1723	7919150000000
8262	1701	5758210000000
8263	1701	5758220000000
8266	1397	1418908024000
8267	1678	2160041976000
8268	1692	22319642000000
8269	1692	22319652000000
8276	1397	1418878021000
8277	1678	2160041979000
8278	1690	15119460000000
8279	1690	15119470000000
8287	1397	1418838017000
8288	1678	2160041983000
8291	1397	1418828016000
8292	1678	2160041984000
8293	1677	77760871000000
8294	1677	77760881000000
8298	369	71040520000000
8299	369	71760520000000
8300	369	66000000000020
8301	45	71761489999980
8312	1397	1418788012000
8313	1678	2160041988000
8314	700	68160020000000
8315	700	68160030000000
8318	1397	1418778011000
8319	1678	2160041989000
8320	1715	7919191000000
8321	1715	7919201000000
8331	1397	1418748008000
8332	1678	2160041992000
8333	1397	1418738007000
8334	1678	2160041993000
8335	1397	1418728006000
8336	1678	2160041994000
8337	1677	79200891000000
8338	1677	79200921000000
8345	1506	6480140000000
8346	1506	6480150000000
8357	1634	7920140000000
8358	1634	7920160000000
8370	1683	213121038999541
8371	1683	213121058999541
8379	1397	1418627996000
8380	1678	2160042004000
8381	1677	79920931000000
8390	1397	1418597993000
8391	1678	2160042007000
8399	1397	1418567990000
8400	1678	2160042010000
8405	1397	1418557989000
8406	1678	2160042011000
8407	1764	719010000000
8414	632	70320090000000
8415	632	70320110000000
8423	1677	80640931000000
8424	1677	80640941000000
8428	1700	6479300000000
8438	1690	15839470000000
8439	1690	15839490000000
8468	1683	214561058999541
8469	1683	214561068999541
8472	1673	3600300000000
8481	1397	1418397973000
8482	1678	2160042027000
8483	1482	1440020000000
8484	1482	1440030000000
8489	1397	1418377971000
8490	1678	2160042029000
8491	1271	1334766010000000
8492	1271	1334766020000000
8497	1397	1418347968000
8498	1678	2160042032000
8511	1637	34560881000000
8512	1637	34560901000000
8517	1397	1418287962000
8518	1678	2160042038000
8527	1683	216001078999541
8528	1683	216001088999541
8533	1474	5758070000000
8534	1673	4320300000000
8535	1673	4321650000000
8536	1397	1418247958000
8537	1678	2160042042000
8538	1715	8639201000000
8539	1715	8639211000000
8546	1397	1418227956000
8547	1678	2160042044000
8550	1397	1418217955000
8551	1678	2160042045000
8552	1677	81360941000000
8553	1677	81360951000000
8558	1397	1418207954000
8559	1678	2160042046000
8560	1397	1418197953000
8561	1678	2160042047000
8562	1397	1418187952000
8563	1678	2160042048000
8564	1397	1418177951000
8565	1678	2160042049000
8566	1715	9359211000000
8567	1715	9359251000000
8571	1397	1418167950000
8572	1678	2160042050000
8573	1397	1418157949000
8574	1678	2160042051000
8575	1397	1418147948000
8576	1678	2160042052000
8577	1701	6478220000000
8578	1701	6478250000000
8583	1541	2881380000000
8584	1541	3601380000000
8585	1541	3601420000000
8592	1397	1418127946000
8593	1678	2160042054000
8594	1397	1418117945000
8595	1678	2160042055000
8596	1587	7200100000000
8597	1587	7200120000000
8601	1397	1418097943000
8602	1678	2160042057000
8609	1598	720000000000
8610	1598	720010000000
8630	1677	83520992000000
8650	1607	7200200000000
8657	1397	1417927926000
8658	1678	2160042074000
8659	369	71760150000000
8687	1397	1417827916000
8688	1678	2160042084000
8689	1397	1417817915000
8690	1678	2160042085000
8691	1623	7920131000000
8692	1623	7920151000000
8701	1397	1417787912000
8702	1678	2160042088000
8703	1679	21599842000000
8704	1679	21599852000000
8710	1677	84960992000000
8719	641	71760290000000
8722	1397	1417737907000
8723	1678	2160042093000
8724	1397	1417727906000
8725	1678	2160042094000
8726	1444	6480120000000
8727	1444	6480140000000
8152	1397	1419198053000
8153	1678	2160041947000
8154	1397	1419188052000
8155	1678	2160041948000
8156	1681	10079263195920
8157	1681	10079283195920
8161	1397	1419178051000
8162	1678	2160041949000
8163	1397	1419168050000
8164	1678	2160041950000
8165	1397	1419158049000
8166	1678	2160041951000
8167	1397	1419148048000
8168	1678	2160041952000
8169	1397	1419138047000
8170	1678	2160041953000
8171	641	71760330000000
8172	641	71760380000000
8182	1675	3600070000000
8183	1675	3600080000000
8199	1397	1419078041000
8200	1678	2160041959000
8201	1506	5760140000000
8221	1397	1419018035000
8222	1678	2160041965000
8223	1397	1419008034000
8224	1678	2160041966000
8225	1397	1418998033000
8226	1678	2160041967000
8227	1397	1418988032000
8228	1678	2160041968000
8229	1710	5039010000000
8230	1710	5039050000000
8233	1397	1418978031000
8234	1678	2160041969000
8235	1397	1418968030000
8236	1678	2160041970000
8237	1671	7200200000000
8238	1671	7200220000000
8253	1643	4320090000000
8260	1397	1418918025000
8261	1678	2160041975000
8275	1690	14399460000000
8285	1397	1418848018000
8286	1678	2160041982000
8290	1703	3599150000000
8297	1708	2879180000000
8308	1397	1418798013000
8309	1678	2160041987000
8310	1677	78480881000000
8311	1677	78480891000000
8326	1706	5036781000000
8327	1397	1418758009000
8328	1678	2160041991000
8329	1555	5040050000000
8330	1555	5040060000000
8341	1397	1418708004000
8342	1678	2160041996000
8343	1509	5760130000000
8344	1509	5760140000000
8353	1397	1418678001000
8354	1678	2160041999000
8355	470	73920161000000
8356	470	73920191000000
8363	1397	1418657999000
8364	1678	2160042001000
8365	1397	1418647998000
8366	1678	2160042002000
8367	1657	5040110000000
8369	1602	5760140000000
8375	1397	1418637997000
8376	1678	2160042003000
8377	1768	719000000000
8378	1768	719010000000
8388	1439	5040080000000
8389	1439	5040100000000
8397	1639	720000000000
8398	1639	720020000000
8403	1637	33840871000000
8404	1637	33840881000000
8410	1397	1418547988000
8411	1678	2160042012000
8412	1397	1418537987000
8413	1678	2160042013000
8419	1397	1418527986000
8420	1678	2160042014000
8421	1649	6480131000000
8422	1649	6480141000000
8426	1692	23039652000000
8427	1692	23039662000000
8432	641	72480380000000
8433	641	72480390000000
8434	1397	1418507984000
8435	1678	2160042016000
8436	1677	80640951000000
8437	1700	6479320000000
8464	1397	1418457979000
8465	1678	2160042021000
8466	1672	4320060000000
8467	1672	4320070000000
8485	1397	1418387972000
8486	1678	2160042028000
8487	1508	4320060000000
8488	1508	4320070000000
8495	1397	1418357969000
8496	1678	2160042031000
8506	1397	1418317965000
8507	1678	2160042035000
8508	1397	1418307964000
8509	1678	2160042036000
8510	1683	214561078999541
8523	1397	1418267960000
8524	1678	2160042040000
8525	1722	12973181000000
8526	1722	12973191000000
8542	1397	1418237957000
8543	1678	2160042043000
8544	1540	720000000000
8545	1540	720010000000
8556	1536	7200160000000
8557	1536	7200170000000
8569	1685	25199630000000
8570	1685	25199670000000
8579	596	73200132000000
8580	596	73200162000000
8581	1541	3600080000000
8582	1541	3600110000000
8586	1692	23759662000000
8587	1692	23759692000000
8588	1397	1418137947000
8589	1678	2160042053000
8590	1768	1439010000000
8591	1768	1439020000000
8599	1397	1418107944000
8600	1678	2160042056000
8607	1397	1418077941000
8608	1678	2160042059000
8611	1397	1418067940000
8612	1678	2160042060000
8622	1716	7198149999976
8629	1677	82800992000000
8648	1656	7920121000000
8649	1656	7920201000000
8651	1397	1417947928000
8652	1678	2160042072000
8653	1397	1417937927000
8654	1678	2160042073000
8655	171	71760100000000
8656	171	71760120000000
8670	1397	1417887922000
8671	1678	2160042078000
8672	1397	1417877921000
8673	1678	2160042079000
8674	1397	1417867920000
8675	1678	2160042080000
8676	1467	4321410000000
8677	1467	4321440000000
8682	1397	1417847918000
8683	1678	2160042082000
8684	1397	1417837917000
8685	1678	2160042083000
8686	1687	5759091000000
8697	1397	1417797913000
8698	1678	2160042087000
8699	1681	11519303195920
8700	1681	11519313195920
8706	1397	1417777911000
8707	1678	2160042089000
8708	1397	1417767910000
8709	1678	2160042090000
8715	1397	1417747908000
8716	1678	2160042092000
8717	1509	6480140000000
8718	1509	6480150000000
8730	1397	1417717905000
8731	1678	2160042095000
8732	1397	1417707904000
8733	1678	2160042096000
8734	1769	2995000000
8735	1474	6474062000000
8736	1455	2880061000000
8739	1271	1335486020000000
8740	1271	1335486041000000
8741	1724	7198691000000
8747	1397	1417687902000
8160	1637	31680861000000
8197	1637	32400851000000
8198	1637	32400861000000
8202	1397	1419068040000
8203	1678	2160041960000
8204	1397	1419058039000
8205	1678	2160041961000
8206	1489	5040080000000
8207	1489	5040100000000
8209	1397	1419048038000
8210	1678	2160041962000
8211	1397	1419038037000
8212	1678	2160041963000
8213	1458	9360172798540
8214	1458	9360182798540
8217	1397	1419028036000
8218	1678	2160041964000
8219	1587	6480090000000
8220	1587	6480100000000
8243	1397	1418948028000
8244	1678	2160041972000
8245	1694	15839325000000
8246	1694	15839335000000
8249	1397	1418938027000
8250	1678	2160041973000
8251	1596	5760110000000
8252	1596	5760120000000
8258	1714	7909020000000
8259	1714	7909030000000
8264	1683	211681028999541
8265	1683	211681038999541
8270	1397	1418898023000
8271	1678	2160041977000
8272	1397	1418888022000
8273	1678	2160041978000
8274	1677	77040881000000
8280	1397	1418868020000
8281	1678	2160041980000
8282	1397	1418858019000
8283	1678	2160041981000
8284	1675	3600090000000
8289	1702	2879040000000
8295	369	71760120000000
8296	369	71760130000000
8302	1397	1418818015000
8303	1678	2160041985000
8304	1397	1418808014000
8305	1678	2160041986000
8306	1509	5040110000000
8307	1509	5040130000000
8316	1723	8639150000000
8317	1723	8639160000000
8322	1397	1418768010000
8323	1678	2160041990000
8324	1474	7200090000000
8325	1474	7200100000000
8339	1397	1418718005000
8340	1678	2160041995000
8347	1397	1418698003000
8348	1678	2160041997000
8349	1397	1418688002000
8350	1678	2160041998000
8351	1677	79920921000000
8352	1677	79920941000000
8359	1397	1418668000000
8360	1678	2160042000000
8361	1637	33120861000000
8362	1637	33120871000000
8368	369	71760140000000
8372	369	71761769999980
8373	369	72481769999980
8374	369	72482409999980
8382	1397	1418617995000
8383	1678	2160042005000
8384	1397	1418607994000
8385	1678	2160042006000
8386	1448	5760200000000
8387	1448	5760220000000
8392	1397	1418587992000
8393	1678	2160042008000
8394	1397	1418577991000
8395	1678	2160042009000
8396	1693	7517187500454
8401	58	72480140000000
8402	58	72480150000000
8408	1722	12253171000000
8409	1722	12253181000000
8416	1686	4318490000000
8417	1686	5038490000000
8418	1686	5038710000000
8425	1623	7200121000000
8429	1397	1418517985000
8430	1678	2160042015000
8431	1700	6479310000000
8440	1693	5357147500454
8441	379	1000000200
8442	1737	66000090023000
8443	1580	66000000000400
8444	45	170000000
8445	1725	7200731396400
8446	1716	124180000
8447	1531	8400000
8448	1492	720390000000
8449	317	66000325000000
8450	45	66000000000410
8451	1716	7920731396390
8452	1716	66000000000460
8453	45	7920771396340
8454	1397	1418497983000
8455	1678	2160042017000
8456	1397	1418487982000
8457	1678	2160042018000
8458	1397	1418477981000
8459	1678	2160042019000
8460	1397	1418467980000
8461	1678	2160042020000
8462	1684	10079200000000
8463	1684	10079220000000
8470	1397	1418447978000
8471	1678	2160042022000
8473	1397	1418437977000
8474	1678	2160042023000
8475	1397	1418427976000
8476	1678	2160042024000
8477	1397	1418417975000
8478	1678	2160042025000
8479	1397	1418407974000
8480	1678	2160042026000
8493	1397	1418367970000
8494	1678	2160042030000
8499	1397	1418337967000
8500	1678	2160042033000
8501	1397	1418327966000
8502	1678	2160042034000
8503	700	68160040000000
8504	1555	5760060000000
8505	1555	5760080000000
8513	1397	1418297963000
8514	1678	2160042037000
8515	1680	10799220000000
8516	1680	10799230000000
8519	1397	1418277961000
8520	1678	2160042039000
8521	1601	5040140000000
8522	1601	5040150000000
8529	1397	1418257959000
8530	1678	2160042041000
8531	1474	6478080000000
8532	528	66002000000000
8540	1687	5759071000000
8541	1687	5759081000000
8548	1675	4320090000000
8549	1675	4320100000000
8554	1689	5759120000000
8555	1689	5759130000000
8568	1677	81360981000000
8598	1691	4319080000000
8603	1397	1418087942000
8604	1678	2160042058000
8605	1571	6480090000000
8606	1571	6480100000000
8613	1397	1418057939000
8614	1678	2160042061000
8615	1397	1418047938000
8616	1678	2160042062000
8617	1474	6476070000000
8618	1769	1000000000
8619	1397	1418037937000
8620	1678	2160042063000
8621	1692	23759682000000
8623	1474	6474060000000
8624	1769	3000000000
8625	1769	2998000000
8626	1474	6474061000000
8627	1677	82080981000000
8628	1677	82080992000000
8631	1397	1418027936000
8632	1678	2160042064000
8633	1397	1418017935000
8634	1678	2160042065000
8635	1397	1418007934000
8636	1678	2160042066000
8637	1397	1417997933000
8638	1678	2160042067000
8639	1397	1417987932000
8640	1678	2160042068000
8641	1397	1417977931000
8642	1678	2160042069000
8643	1397	1417967930000
8644	1678	2160042070000
8645	1397	1417957929000
8646	1678	2160042071000
8647	1649	6480211000000
8660	1397	1417917925000
8661	1678	2160042075000
8662	1397	1417907924000
8663	1678	2160042076000
8664	1397	1417897923000
8665	1678	2160042077000
8666	1769	2997000000
8667	1679	20879811000000
8668	1679	20879842000000
8669	1677	84240992000000
8678	1397	1417857919000
8679	1678	2160042081000
8680	1508	5040070000000
8681	1508	5040080000000
8693	1397	1417807914000
8694	1678	2160042086000
8695	1706	5756781000000
8696	1706	5756791000000
8705	1637	34560891000000
8711	1397	1417757909000
8712	1678	2160042091000
8713	1708	3599180000000
8714	1708	3599190000000
8720	641	73200390000000
8721	641	73200400000000
8728	1692	24479682000000
8729	1692	24479702000000
8742	1692	24479703000000
8743	1397	1417697903000
8744	1678	2160042097000
8745	1699	10799249000000
8746	1699	10799259000000
8766	1677	85680992000000
8771	1397	1417617895000
8772	1678	2160042105000
8773	632	71040110000000
8774	632	71040130000000
8779	1397	1417587892000
8780	1678	2160042108000
8781	1694	16559335000000
8782	1694	16559345000000
8801	1637	35280891000000
8802	1637	35280901000000
8807	1457	7200140000000
8808	1457	7200150000000
8810	1596	6480120000000
8811	1596	6480130000000
8813	1397	1417527886000
8814	1678	2160042114000
8815	1397	1417517885000
8816	1678	2160042115000
8817	1397	1417507884000
8818	1678	2160042116000
8819	1474	7194062000000
8820	1474	7194092000000
8834	1677	86400992000000
8837	1397	1417447878000
8838	1678	2160042122000
8839	1717	3599130000000
8840	1717	3599140000000
8853	1694	17279335000000
8737	1724	7198690000000
8738	1724	7198711000000
8753	1397	1417667900000
8754	1678	2160042100000
8755	1724	7198700000000
8764	1613	5758060000000
8765	1613	5758090000000
8775	1397	1417607894000
8776	1678	2160042106000
8786	1593	4320100000000
8787	1593	4320120000000
8791	1747	2879130000000
8792	1747	2879140000000
8797	1397	1417547888000
8798	1678	2160042112000
8799	1740	8636583000000
8800	1740	8636593000000
8812	1692	24479692000000
8827	1397	1417477881000
8828	1678	2160042119000
8829	1690	15839480000000
8841	1397	1417437877000
8842	1678	2160042123000
8843	1397	1417427876000
8844	1678	2160042124000
8845	1397	1417417875000
8846	1678	2160042125000
8847	1397	1417407874000
8848	1678	2160042126000
8849	1467	4321480000000
8850	1467	5041480000000
8748	1678	2160042098000
8749	1397	1417677901000
8750	1678	2160042099000
8751	596	73920162000000
8752	596	73920182000000
8756	1397	1417657899000
8757	1678	2160042101000
8758	1397	1417647898000
8759	1678	2160042102000
8760	1397	1417637897000
8761	1678	2160042103000
8762	1402	23040451000000
8763	1402	23040481000000
8767	1397	1417627896000
8768	1678	2160042104000
8769	1708	4319190000000
8770	1708	4319200000000
8777	1397	1417597893000
8778	1678	2160042107000
8783	1397	1417577891000
8784	1678	2160042109000
8785	1679	21599862000000
8788	1608	5760110000000
8789	1397	1417567890000
8790	1678	2160042110000
8793	1397	1417557889000
8794	1678	2160042111000
8795	1549	6480091000000
8796	1549	6480101000000
8803	1397	1417537887000
8804	1678	2160042113000
8805	1740	9356593000000
8806	1740	9356603000000
8809	1701	6478230000000
8821	1397	1417497883000
8822	1678	2160042117000
8823	1397	1417487882000
8824	1678	2160042118000
8825	1402	23760481000000
8826	1402	23760501000000
8830	1397	1417467880000
8831	1678	2160042120000
8832	1768	2159020000000
8833	1768	2159030000000
8835	1397	1417457879000
8836	1678	2160042121000
8851	1694	16559375000000
8852	1694	17279375000000
8854	1613	5038100000000
8855	1613	5758100000000
8856	1687	5759131000000
8857	1687	6479131000000
8858	1744	900500000
8859	329	66719999500000
8860	1397	1417397873000
8861	1678	2160042127000
8862	1397	1417387872000
8863	1678	2160042128000
8864	1397	1417377871000
8865	1678	2160042129000
8866	1397	1417367870000
8867	1678	2160042130000
8868	1397	1417357869000
8869	1678	2160042131000
8870	1744	900000500
8871	329	66719999999500
8872	1744	66720048499000
8873	329	901501000
8874	329	66000510000000
8875	262	66000200000000
8876	329	66720410000000
8877	707	9000150000000
8878	329	66719850000000
8879	329	66719900000000
8880	329	66720000000000
8881	329	66720050000000
8882	1397	1417347868000
8883	1678	2160042132000
8884	1509	7200149999500
8885	1509	901001000
8886	1744	7200158999000
8887	1444	7200140000000
8888	1444	7200150000000
8889	1397	1417337867000
8890	1678	2160042133000
8891	1397	1417327866000
8892	1678	2160042134000
8893	1397	1417317865000
8894	1678	2160042135000
8895	1643	5040090000000
8896	1643	5040120000000
8897	1397	1417307864000
8898	1678	2160042136000
8899	1711	5759080000000
8900	1711	5759090000000
8901	1705	5035280000000
8902	1705	5755280000000
8903	1705	5756160000000
8904	1397	1417297863000
8905	1678	2160042137000
8906	1397	1417287862000
8907	1678	2160042138000
8908	1680	11519230000000
8909	1680	11519250000000
8910	1447	6480080000000
8911	1447	6480100000000
8912	1522	2880030000000
8913	1522	2880050000000
8914	1397	1417277861000
8915	1678	2160042139000
8916	1670	10080400000000
8917	1670	10080410000000
8918	1397	1417267860000
8919	1678	2160042140000
8920	1599	7200140000000
8921	1599	7200160000000
8922	1397	1417257859000
8923	1678	2160042141000
8924	1397	1417247858000
8925	1678	2160042142000
8926	1683	217441078999541
8927	1397	1417237857000
8928	1678	2160042143000
8929	1637	36000901000000
8930	1637	36000911000000
8931	1397	1417227856000
8932	1678	2160042144000
8933	470	74640191000000
8934	470	74640211000000
8935	1397	1417217855000
8936	1678	2160042145000
8937	1397	1417207854000
8938	1678	2160042146000
8939	1722	13693191000000
8940	1722	13693201000000
8941	1397	1417197853000
8942	1678	2160042147000
8943	1668	7200090000000
8944	1668	7200100000000
8945	1683	218881078999541
8946	1397	1417187852000
8947	1678	2160042148000
8948	1397	1417177851000
8949	1678	2160042149000
8950	1729	4319050000000
8951	1729	4319060000000
8952	1397	1417167850000
8953	1678	2160042150000
8954	1462	720000000000
8955	1462	720010000000
8956	1637	36720911000000
8957	1637	36720921000000
8958	1397	1417157849000
8959	1678	2160042151000
8960	1397	1417147848000
8961	1678	2160042152000
8962	1397	1417137847000
8963	1678	2160042153000
8964	1397	1417127846000
8965	1678	2160042154000
8966	1692	24479722000000
8967	1397	1417117845000
8968	1678	2160042155000
8969	1397	1417107844000
8970	1678	2160042156000
8971	1397	1417097843000
8972	1678	2160042157000
8973	1397	1417087842000
8974	1678	2160042158000
8975	1677	86401032000000
8976	1397	1417077841000
8977	1678	2160042159000
8978	1690	16559490000000
8979	1690	16559500000000
8980	1397	1417067840000
8981	1678	2160042160000
8982	1593	4320110000000
8983	1710	5759050000000
8984	1710	5759060000000
8985	1762	2159050000000
8986	1762	2159060000000
8987	1397	1417057839000
8988	1678	2160042161000
8989	1715	9359221000000
8990	470	75360211000000
8991	470	75360221000000
8999	1397	1417037837000
9000	1678	2160042163000
9001	1711	6479090000000
9002	1711	6479100000000
9005	1397	1417027836000
9006	1678	2160042164000
9007	596	74640182000000
9008	596	74640192000000
9019	1397	1416977831000
9020	1678	2160042169000
9021	1677	87841042000000
9022	1677	87841052000000
9032	1397	1416937827000
9033	1678	2160042173000
9041	1397	1416907824000
9042	1678	2160042176000
9059	1397	1416867820000
9060	1678	2160042180000
9061	1677	89281082000000
9062	1677	89281092000000
9065	1496	720000000000
9066	1496	720010000000
9083	1397	1416817815000
9084	1678	2160042185000
9085	1501	100000000
9086	1677	89280982000000
9087	1677	89280992000000
9093	1397	1416797813000
9094	1678	2160042187000
9095	1397	1416787812000
9096	1678	2160042188000
9097	1474	7914092000000
9098	1474	7914112000000
9104	1708	4319290000000
9107	1706	4316571000000
9108	1737	1100000200
9109	1474	5756060000000
9110	1474	5754050000000
9111	633	70319390000000
9112	633	71039390000000
9113	1520	71039729999999
9114	633	1
9118	1677	90720992000000
9119	1397	1416777811000
9120	1678	2160042189000
9121	1397	1416767810000
9122	1678	2160042190000
9123	1536	7920170000000
9124	1536	7920190000000
9130	1397	1416747808000
9131	1678	2160042192000
9136	1397	1416737807000
9137	1678	2160042193000
9138	1455	3600061000000
9139	1455	3600071000000
9144	1508	5760080000000
9145	1508	5760090000000
9150	1397	1416707804000
9151	1678	2160042196000
9152	1656	9360231000000
9153	1656	9360241000000
9162	1397	1416677801000
9163	1678	2160042199000
9164	1447	7200100000000
9165	1447	7200110000000
9169	1536	8640190000000
9170	1536	8640200000000
9175	1397	1416647798000
9176	1678	2160042202000
9177	1764	1439020000000
9178	1397	1416637797000
9179	1678	2160042203000
9180	1474	8634112000000
9181	1474	8634122000000
9190	1397	1416607794000
9191	1678	2160042206000
9192	1684	10799220000000
9193	1684	10799230000000
9200	1685	25919640000000
9201	1685	25919650000000
9203	1397	1416587792000
9204	1678	2160042208000
9205	1397	1416577791000
9206	1678	2160042209000
9207	641	73200410000000
9215	1397	1416547788000
9216	1678	2160042212000
9217	576	71760070000000
9218	576	71760080000000
9227	1691	5759090000000
9228	1691	5759110000000
9240	1397	1416477781000
9241	1678	2160042219000
9242	1683	223201098999541
9243	1683	223201108999541
9252	1727	3599050000000
9264	1397	1416417775000
9265	1678	2160042225000
9266	1643	5760130000000
9285	1550	10000000
9286	1688	35279822000000
9296	1397	1416327766000
9297	1678	2160042234000
9298	1680	11519240000000
9301	1690	17279500000000
9302	1690	17279510000000
9311	1397	1416307764000
9312	1678	2160042236000
9313	1471	3600060000000
9314	1471	3600070000000
9317	1683	227521128999541
9318	1683	227521138999541
9321	1703	5039580000000
9322	1703	5039910000000
9327	1397	1416287762000
9328	1678	2160042238000
9329	1397	1416277761000
9330	1678	2160042239000
9331	1560	7200150000000
9332	1560	7200170000000
9337	1397	1416257759000
9338	1678	2160042241000
9366	1559	9360200000000
9367	1559	9360280000000
9378	1397	1416147748000
9379	1678	2160042252000
9380	1677	94321072000000
9381	1677	94321082000000
9384	1687	6479101000000
9393	1397	1416097743000
9394	1678	2160042257000
9395	1689	6479130000000
9396	1689	6479140000000
9397	1397	1416087742000
9398	1678	2160042258000
9407	1683	227521158999541
9408	1397	1416047738000
9409	1678	2160042262000
9410	1397	1416037737000
9411	1678	2160042263000
9412	576	72480080000000
9413	576	72480100000000
9418	1397	1416027736000
9419	1678	2160042264000
9420	1599	8640170000000
9421	1599	8640180000000
9442	1397	1415947728000
9443	1678	2160042272000
9444	1679	23039892000000
9445	1679	23039902000000
9473	1397	1415917725000
9474	1678	2160042275000
9475	1397	1415907724000
9476	1678	2160042276000
9477	1397	1415897723000
9478	1678	2160042277000
9479	1679	23759902000000
9480	1679	23759932000000
9492	1397	1415857719000
9493	1678	2160042281000
9494	1397	1415847718000
9495	1678	2160042282000
9496	1397	1415837717000
9497	1678	2160042283000
9498	1587	7200130000000
9500	1397	1415827716000
9501	1678	2160042284000
9502	1397	1415817715000
9503	1678	2160042285000
9504	1397	1415807714000
9505	1678	2160042286000
9506	1397	1415797713000
9507	1678	2160042287000
9508	1610	7200150000000
9509	1610	7200190000000
9512	1643	6480220000000
9513	1643	6480350000000
9520	1397	1415767710000
9521	1678	2160042290000
9522	1683	228961158999541
9523	1683	228961168999541
9526	44	71040170000000
9527	1601	5760150000000
9528	1601	5760160000000
8992	1588	4320070000000
8993	1588	4320080000000
8997	415	66720000000000
8998	415	66720010000000
9003	1448	6480220000000
9004	1448	6480230000000
9013	1397	1417007834000
9014	1678	2160042166000
9015	1397	1416997833000
9016	1678	2160042167000
9017	1397	1416987832000
9018	1678	2160042168000
9031	1448	6480250000000
9035	1397	1416927826000
9036	1678	2160042174000
9037	1397	1416917825000
9038	1678	2160042175000
9039	1693	8237177500454
9040	1693	8237197500454
9047	484	74640130000000
9048	484	74640140000000
9055	1397	1416877821000
9056	1678	2160042179000
9057	1692	25199722000000
9058	1692	25199732000000
9063	1559	8640200000000
9064	1559	8640210000000
9070	1599	7920160000000
9071	1599	7920170000000
9081	1714	7189030000000
9082	1714	7909050000000
9089	1397	1416807814000
9090	1678	2160042186000
9091	1668	8640110000000
9092	1668	8640120000000
9100	1706	5756591000000
9101	1737	1100001100
9102	1677	90000992000000
9103	1677	90001092000000
9116	1764	1439010000000
9129	1685	25199640000000
9134	1691	5039080000000
9135	1691	5039090000000
9140	1419	8640170000000
9141	1419	8640180000000
9142	1397	1416727806000
9143	1678	2160042194000
9158	1397	1416687802000
9159	1678	2160042198000
9160	1682	6467180000000
9161	1682	6467190000000
9166	1683	221761088999541
9167	1683	221761098999541
9168	1657	5040100000000
9173	1397	1416657799000
9174	1678	2160042201000
9184	1397	1416627796000
9185	1678	2160042204000
9186	1397	1416617795000
9187	1678	2160042205000
9188	1536	9360200000000
9189	1536	9360220000000
9196	1397	1416597793000
9197	1678	2160042207000
9198	1675	5040100000000
9199	1675	5040110000000
9213	596	75360192000000
9214	596	75360212000000
9222	1397	1416537787000
9223	1678	2160042213000
9224	1397	1416527786000
9225	1678	2160042214000
9226	1677	91441012000000
9233	1397	1416507784000
9234	1678	2160042216000
9235	1397	1416497783000
9236	1678	2160042217000
9237	1397	1416487782000
9238	1678	2160042218000
9239	1402	24480531000000
9250	1397	1416447778000
9251	1678	2160042222000
9261	1686	211805500013
9262	1643	5760120000000
9263	1643	5760220000000
9271	1397	1416397773000
9272	1678	2160042227000
9273	1683	224641108999541
9274	1683	224641118999541
9279	1397	1416377771000
9280	1678	2160042229000
9281	1397	1416367770000
9282	1678	2160042230000
9283	700	68880040000000
9284	700	68880060000000
9292	1397	1416337767000
9293	1678	2160042233000
9294	1683	226081118999541
9295	1683	226081128999541
9303	1706	5036581000000
9304	1654	6480530000000
9305	1654	7200530000000
9306	1654	7201540000000
9307	1397	1416317765000
9308	1678	2160042235000
9309	1677	92881032000000
9310	1677	92881042000000
9315	1649	7200141000000
9316	1649	7200151000000
9319	1594	4320170000000
9320	1594	4320180000000
9325	1397	1416297763000
9326	1678	2160042237000
9335	1397	1416267760000
9336	1678	2160042240000
9343	1737	1100000000
9344	1673	5041650000000
9345	1673	5043090000000
9364	1467	5041440000000
9365	1467	5041520000000
9376	1668	9360120000000
9377	1668	9360150000000
9382	1397	1416137747000
9383	1678	2160042253000
9387	1397	1416117745000
9388	1678	2160042255000
9389	1397	1416107744000
9390	1678	2160042256000
9391	1729	5759070000000
9392	1729	5759090000000
9414	1768	2879030000000
9415	1768	2879050000000
9416	1568	720000000000
9417	1568	720020000000
9426	1397	1416007734000
9427	1678	2160042266000
9428	1397	1415997733000
9429	1678	2160042267000
9430	1397	1415987732000
9431	1678	2160042268000
9432	1677	95041082000000
9433	1677	95041112000000
9440	1397	1415957729000
9441	1678	2160042271000
9472	1700	6479420000000
9510	1397	1415787712000
9511	1678	2160042288000
9514	1397	1415777711000
9515	1678	2160042289000
9516	1455	4320071000000
9517	1455	4320081000000
9524	1397	1415757709000
9525	1678	2160042291000
9529	1397	1415747708000
9530	1678	2160042292000
9531	1397	1415737707000
9532	1678	2160042293000
9533	1397	1415727706000
9534	1678	2160042294000
9535	1397	1415717705000
9536	1678	2160042295000
9537	1688	35999822000000
9538	1688	35999862000000
9545	1397	1415687702000
9546	1678	2160042298000
9547	1397	1415677701000
9548	1678	2160042299000
9549	1397	1415667700000
9550	1678	2160042300000
9551	1397	1415657699000
9552	1678	2160042301000
9553	1397	1415647698000
9554	1678	2160042302000
9555	1717	4319190000000
9560	1694	18719385000000
9561	1694	18719395000000
9568	1685	26639650000000
9569	1685	26639660000000
9578	1397	1415597693000
9579	1678	2160042307000
9580	1688	35999832000000
9584	1397	1415587692000
9585	1678	2160042308000
9593	369	72480130000000
9594	369	72480140000000
8994	1397	1417047838000
8995	1678	2160042162000
8996	1607	7200210000000
9009	1397	1417017835000
9010	1678	2160042165000
9011	1677	87121032000000
9012	1677	87121042000000
9023	1397	1416967830000
9024	1678	2160042170000
9025	1397	1416957829000
9026	1678	2160042171000
9027	1397	1416947828000
9028	1678	2160042172000
9029	1677	88561052000000
9030	1677	88561082000000
9034	1555	5760070000000
9043	1397	1416897823000
9044	1678	2160042177000
9045	1607	7920210000000
9046	1607	7920220000000
9049	1668	7920100000000
9050	1668	7920110000000
9051	1397	1416887822000
9052	1678	2160042178000
9053	1693	8957197500454
9054	1693	8957207500454
9067	1397	1416857819000
9068	1678	2160042181000
9069	1683	218881088999541
9072	1397	1416847818000
9073	1678	2160042182000
9074	1656	7920211000000
9075	1397	1416837817000
9076	1678	2160042183000
9077	1397	1416827816000
9078	1678	2160042184000
9079	1656	8640211000000
9080	1656	8640231000000
9088	1634	7920150000000
9099	1714	7909040000000
9105	1706	6476591000000
9106	1706	6476691000000
9115	1683	220321088999541
9117	1509	7200150000000
9125	1397	1416757809000
9126	1678	2160042191000
9127	1402	24480501000000
9128	1402	24480511000000
9132	1623	8640151000000
9133	1623	8640161000000
9146	1397	1416717805000
9147	1678	2160042195000
9148	1677	91440992000000
9149	1677	91441002000000
9154	1397	1416697803000
9155	1678	2160042197000
9156	1729	5039060000000
9157	1729	5039070000000
9171	1397	1416667800000
9172	1678	2160042200000
9182	1637	37440921000000
9183	1637	37440931000000
9194	1549	7200101000000
9195	1549	7200111000000
9202	641	72480290000000
9208	1397	1416567790000
9209	1678	2160042210000
9210	1397	1416557789000
9211	1678	2160042211000
9212	1447	7200120000000
9219	1703	3599310000000
9220	1703	4319310000000
9221	1703	4319580000000
9229	1397	1416517785000
9230	1678	2160042215000
9231	1695	5759001000000
9232	1695	5759011000000
9244	1397	1416467780000
9245	1678	2160042220000
9246	1397	1416457779000
9247	1678	2160042221000
9248	1677	92161012000000
9249	1677	92161032000000
9253	1686	931815500013
9254	1770	4105104499987
9255	1397	1416437777000
9256	1678	2160042223000
9257	1397	1416427776000
9258	1678	2160042224000
9259	1594	3600050000000
9260	1594	3600170000000
9267	1397	1416407774000
9268	1678	2160042226000
9269	1672	5040070000000
9270	1672	5040080000000
9275	1397	1416387772000
9276	1678	2160042228000
9277	1547	2160020000000
9278	1547	2160030000000
9287	1397	1416357769000
9288	1678	2160042231000
9289	1397	1416347768000
9290	1678	2160042232000
9291	1650	4320080000000
9299	1694	17999375000000
9300	1694	17999385000000
9323	1692	25919732000000
9324	1692	25919742000000
9333	1687	6479091000000
9334	1687	6479111000000
9339	1397	1416247758000
9340	1678	2160042242000
9341	1637	38160931000000
9342	1637	38160941000000
9346	1397	1416237757000
9347	1678	2160042243000
9348	1397	1416227756000
9349	1678	2160042244000
9350	1397	1416217755000
9351	1678	2160042245000
9352	1397	1416207754000
9353	1678	2160042246000
9354	1397	1416197753000
9355	1678	2160042247000
9356	1397	1416187752000
9357	1678	2160042248000
9358	1397	1416177751000
9359	1678	2160042249000
9360	1770	4034710760393
9361	1771	69383739594
9362	1686	1651815500013
9363	1686	1651895500013
9368	1397	1416167750000
9369	1678	2160042250000
9370	1397	1416157749000
9371	1678	2160042251000
9372	1770	4034700364453
9373	1771	69384135534
9374	1677	93601042000000
9375	1677	93601072000000
9385	1397	1416127746000
9386	1678	2160042254000
9399	1397	1416077741000
9400	1678	2160042259000
9401	1397	1416067740000
9402	1678	2160042260000
9403	1397	1416057739000
9404	1678	2160042261000
9405	1679	22319862000000
9406	1679	22319892000000
9422	1397	1416017735000
9423	1678	2160042265000
9424	1610	6480140000000
9425	1610	6480150000000
9434	1397	1415977731000
9435	1678	2160042269000
9436	1397	1415967730000
9437	1678	2160042270000
9438	1709	5759230000000
9439	1709	5759250000000
9446	1770	4034690363513
9447	1771	69384136474
9448	1770	4034680362573
9449	1771	69384137414
9450	1397	1415937727000
9451	1678	2160042273000
9452	1397	1415927726000
9453	1678	2160042274000
9454	1770	4034670361633
9455	1771	69384138354
9456	1770	4034660360693
9457	1771	69384139294
9458	1770	3965244611203
9459	195	66069405749490
9460	1770	3895828861713
9461	291	66069405749490
9462	1770	3367360729145
9463	1023	503306233132568
9464	1770	2420358283411
9465	1143	901920457445734
9466	1770	1781393610117
9467	1263	608543704673294
9468	1770	879600299
9469	1389	1695761141761468
9470	1717	4319140000000
9471	1717	4319260000000
9481	1637	38880941000000
9482	1637	38880971000000
9483	1397	1415887722000
9484	1678	2160042278000
9485	1397	1415877721000
9486	1678	2160042279000
9487	1397	1415867720000
9488	1678	2160042280000
9489	1770	0
9490	1771	70253739593
9491	1677	95041122000000
9499	1599	9360180000000
9518	1643	6480130000000
9519	1643	6480140000000
9556	1397	1415637697000
9557	1678	2160042303000
9558	1696	4318071000000
9559	1696	4318081000000
9562	1727	4319050000000
9563	1727	4319060000000
9570	1397	1415617695000
9571	1678	2160042305000
9572	1397	1415607694000
9573	1678	2160042306000
9574	1402	25200531000000
9575	1402	25200551000000
9581	1637	39600971000000
9582	1637	39601001000000
9586	1397	1415577691000
9587	1678	2160042309000
9588	349	66720000000000
9589	349	66720010000000
9603	1397	1415547688000
9604	1678	2160042312000
9605	1683	231841208999541
9606	1683	231841218999541
9622	1397	1415477681000
9623	1678	2160042319000
9624	1683	234721268999541
9625	1683	234721278999541
9631	1679	24479902000000
9632	1679	24479912000000
9636	1573	5760090000000
9637	1573	5760100000000
9648	1599	9360200000000
9653	1683	237601288999541
9654	1683	237601308999541
9672	1599	10080200000000
9673	1599	10080210000000
9683	1397	1415317665000
9684	1678	2160042335000
9694	1397	1415287662000
9695	1678	2160042338000
9696	1397	1415277661000
9697	1678	2160042339000
9698	1683	239041328999541
9701	1397	1415267660000
9702	1678	2160042340000
9706	1397	1415257659000
9707	1678	2160042341000
9708	1397	1415247658000
9709	1678	2160042342000
9710	1397	1415237657000
9711	1678	2160042343000
9712	1397	1415227656000
9713	1678	2160042344000
9714	1397	1415217655000
9715	1678	2160042345000
9716	1397	1415207654000
9717	1678	2160042346000
9718	1397	1415197653000
9719	1678	2160042347000
9720	1694	18719455000000
9725	1397	1415177651000
9726	1678	2160042349000
9734	1397	1415157649000
9735	1678	2160042351000
9736	1397	1415147648000
9737	1678	2160042352000
9738	1727	5039060000000
9739	1727	5039080000000
9752	1397	1415097643000
9753	1678	2160042357000
9754	1471	4320070000000
9755	1471	4320080000000
9756	1397	1415087642000
9757	1678	2160042358000
9758	1397	1415077641000
9759	1678	2160042359000
9760	1673	3600320000000
9763	1397	1415067640000
9764	1678	2160042360000
9765	1688	37439842000000
9766	1688	37439852000000
9769	1397	1415057639000
9770	1678	2160042361000
9771	1677	98641182000000
9774	1747	3599140000000
9775	1747	3599150000000
9539	1683	230401168999541
9540	1683	230401208999541
9541	1397	1415707704000
9542	1678	2160042296000
9543	1397	1415697703000
9544	1678	2160042297000
9564	1397	1415627696000
9565	1678	2160042304000
9566	1677	95761122000000
9567	1677	95761132000000
9576	1690	17999510000000
9577	1690	17999530000000
9583	1637	39600981000000
9590	1397	1415567690000
9591	1678	2160042310000
9592	1673	3600310000000
9597	1688	36719832000000
9598	1688	36719842000000
9599	1690	18719530000000
9600	1690	18719540000000
9607	1397	1415537687000
9608	1678	2160042313000
9609	1559	9360210000000
9626	1698	7919090000000
9633	1397	1415457679000
9634	1678	2160042321000
9640	1611	4320050000000
9641	1611	4320250000000
9642	1397	1415437677000
9643	1678	2160042323000
9644	1397	1415427676000
9645	1678	2160042324000
9646	1677	96481132000000
9647	1677	96481152000000
9649	1397	1415417675000
9650	1678	2160042325000
9651	1397	1415407674000
9652	1678	2160042326000
9659	1677	96481142000000
9670	1397	1415367670000
9671	1678	2160042330000
9691	1402	25200541000000
9692	1397	1415297663000
9693	1678	2160042337000
9723	1397	1415187652000
9724	1678	2160042348000
9729	1587	8640140000000
9730	1587	8640150000000
9772	470	76080221000000
9773	470	76080231000000
9595	1397	1415557689000
9596	1678	2160042311000
9601	1547	2880030000000
9602	1547	2880040000000
9610	1397	1415527686000
9611	1678	2160042314000
9612	1397	1415517685000
9613	1678	2160042315000
9614	1397	1415507684000
9615	1678	2160042316000
9616	1397	1415497683000
9617	1678	2160042317000
9618	1397	1415487682000
9619	1678	2160042318000
9620	1683	233281218999541
9621	1683	233281268999541
9627	1397	1415467680000
9628	1678	2160042320000
9629	1683	236161278999541
9630	1683	236161288999541
9635	1686	1651825500013
9638	1397	1415447678000
9639	1678	2160042322000
9655	1397	1415397673000
9656	1678	2160042327000
9657	1683	239041308999541
9658	1683	239041318999541
9660	1670	10800410000000
9661	1670	10800420000000
9662	1397	1415387672000
9663	1678	2160042328000
9664	405	66720000000000
9665	405	66720010000000
9666	1397	1415377671000
9667	1678	2160042329000
9668	1587	7920130000000
9669	1587	7920140000000
9674	1397	1415357669000
9675	1678	2160042331000
9676	1397	1415347668000
9677	1678	2160042332000
9678	1397	1415337667000
9679	1678	2160042333000
9680	1397	1415327666000
9681	1678	2160042334000
9682	1684	10799260000000
9685	1637	40320981000000
9686	1637	40320991000000
9687	1397	1415307664000
9688	1678	2160042336000
9689	1677	97201142000000
9690	1677	97201152000000
9699	1677	97921152000000
9700	1677	97921172000000
9703	1685	27359660000000
9704	1685	27359670000000
9705	171	72480120000000
9721	1593	5040110000000
9722	1593	5040180000000
9727	1397	1415167650000
9728	1678	2160042350000
9731	1703	5040630000000
9732	1703	5760630000000
9733	1703	5761160000000
9740	1397	1415137647000
9741	1678	2160042353000
9742	1716	7919160000000
9743	1716	7919170000000
9744	1397	1415127646000
9745	1678	2160042354000
9746	1397	1415117645000
9747	1678	2160042355000
9748	1397	1415107644000
9749	1678	2160042356000
9750	1593	5760180000000
9751	1593	5760200000000
9761	1677	98641172000000
9762	1677	98641192000000
9767	1613	6478090000000
9768	1613	6478100000000
9776	1701	7198230000000
9777	1701	7198240000000
9778	1706	6476491000000
9779	1737	1200001100
9780	1397	1415047638000
9781	1678	2160042362000
9782	1397	1415037637000
9783	1678	2160042363000
9784	1693	8907419262733
9785	41	66087112047044
9786	1693	8857631025012
9787	225	66087112047044
9788	1693	8807842787291
9789	304	66087112047044
9790	1693	8758054549570
9791	308	66087112047044
9792	1693	8708266311849
9793	373	66087112047044
9794	1693	8658478074128
9795	191	66087112047044
9796	1693	8505322183241
9797	877	203321172331632
9798	1693	8455533945520
9799	309	66087112047044
9800	1693	8454015514083
9801	731	2002639758987
9802	1693	8404227276362
9803	217	66087112047044
9804	1739	3599050000000
9805	1739	3599270000000
9806	1634	7920360000000
9807	1706	7196491000000
9808	1706	7196711000000
9809	1634	7920270000000
9810	1397	1415027636000
9811	1678	2160042364000
9812	1693	8354439038641
9813	402	66087112047044
9814	1693	7674922150341
9815	1030	902162602054525
9816	1693	7625133912620
9817	205	66087112047044
9818	1693	7575345674899
9819	138	66087112047044
9820	1693	7525557437178
9821	275	66087112047044
9822	1637	41040991000000
9823	1637	41041051000000
9824	1693	7475769199457
9825	397	66087112047044
9826	1693	7425980961736
9827	690	66087112047044
9828	1397	1415017635000
9829	1678	2160042365000
9830	1397	1415007634000
9831	1678	2160042366000
9832	1509	7200190000000
9833	1397	1414997633000
9834	1678	2160042367000
9835	1397	1414987632000
9836	1678	2160042368000
9837	1693	7376192724015
9838	106	66087112047044
9839	1693	7144772056121
9840	894	307227885873282
9841	1693	7139711073433
9842	5	6705839233000
9843	1693	7089922835712
9844	122	66087112047044
9845	1683	240481318999541
9846	1683	240481378999541
9847	1706	5756391000000
9848	1271	1334766390000000
9849	1271	1335486380000000
9850	1693	7040134597991
9851	91	66087112047044
9852	1693	6990346360270
9853	99	66087112047044
9854	1693	6940558122549
9855	339	66087112047044
9856	1397	1414977631000
9857	1678	2160042369000
9858	1397	1414967630000
9859	1678	2160042370000
9860	1693	6890769884828
9861	420	66087112047044
9862	1693	6840981647107
9863	206	66087112047044
9864	1693	6791193409386
9865	408	66087112047044
9866	1402	25200611000000
9867	1397	1414957629000
9868	1678	2160042371000
9869	1693	6741405171665
9870	438	66087112047044
9871	1693	6691616933944
9872	534	66087112047044
9873	1693	6641828696223
9874	399	66087112047044
9875	606	71760080000000
9876	606	71760120000000
9877	1397	1414947628000
9878	1678	2160042372000
9879	1688	38159852000000
9880	1688	38159862000000
9881	596	76080212000000
9882	596	76080222000000
9920	1637	41761051000000
9921	1637	41761231000000
9930	1489	5760100000000
9931	1489	5760130000000
9932	1397	1414897623000
9933	1678	2160042377000
9934	1649	7200161000000
9935	1571	6480100000008
9936	1649	7920160999992
9938	1397	1414887622000
9939	1678	2160042378000
9940	1397	1414877621000
9941	1678	2160042379000
9942	1709	6479250000000
9943	1709	6479270000000
9945	1709	6480000000000
9950	1397	1414857619000
9951	1678	2160042381000
9952	1683	241921378999541
9953	1683	241921388999541
9968	1397	1414797613000
9969	1678	2160042387000
9970	1397	1414787612000
9971	1678	2160042388000
9972	1683	243361398999541
9973	1683	243361418999541
9980	1397	1414767610000
9981	1678	2160042390000
9982	1683	243361408999541
9985	1693	5555003423251
9986	721	2002639758987
9987	1693	5505215185530
9988	295	66087112047044
9989	1397	1414747608000
9990	1678	2160042392000
9991	1397	1414737607000
9992	1678	2160042393000
9993	1397	1414727606000
9994	1678	2160042394000
9995	1683	244801408999541
9996	1683	244801458999541
10001	1448	7200230000000
10002	1448	7200240000000
10030	1693	5455426947809
10031	560	66087112047044
10032	1397	1414637597000
10033	1678	2160042403000
10034	1693	5405638710088
10035	392	66087112047044
10036	1693	5355850472367
10037	194	66087112047044
10038	1683	247681478999541
10039	1683	247681518999541
10070	1397	1414537587000
10071	1678	2160042413000
10072	1693	5306062234646
10073	252	66087112047044
10074	1541	3600100000000
10106	1467	5761520000000
10107	1467	5761570000000
10112	1397	1414497583000
10113	1678	2160042417000
10114	1555	6480190000000
10115	1555	6480210000000
10116	1397	1414487582000
10117	1678	2160042418000
10123	1693	4350199852735
10124	1150	608707084465919
10125	1693	4300411615014
10126	452	66087112047044
10127	1693	4250623377293
10128	594	66087112047044
10129	1397	1414457579000
10130	1678	2160042421000
10131	1678	2880042421000
10132	1678	2880082421000
10141	1735	2859990000000
10162	1397	1414407574000
10163	1678	2880082426000
10164	1677	100801382000000
10165	1677	100801392000000
10183	1677	101521392000000
10184	1677	101521412000000
10187	1397	1414367570000
10188	1678	2880082430000
10189	1693	4200835139572
10190	391	66087112047044
10191	42	68880050000000
10192	42	68880070000000
10214	1397	1414347568000
10215	1678	2880082432000
10216	1397	1414337567000
10217	1678	2880082433000
10218	1693	3777963482302
10219	660	66087112047044
10220	1693	2500367008662
10221	1276	1696216414080520
10222	1693	2450578770941
10223	180	66087112047044
10224	1693	2400790533220
10225	353	66087112047044
10226	1693	2351002295499
10227	108	66087112047044
10228	1693	2301214057778
10229	390	66087112047044
10230	1693	2251425820057
10231	601	66087112047044
10232	1693	2201637582336
10233	266	66087112047044
10234	1693	2151849344615
10235	600	66087112047044
10236	1693	2102061106894
10237	691	66087112047044
10238	1693	2052272869173
10239	352	66087112047044
10240	1693	2002484631452
10241	63	66087112047044
10242	1693	1994932474229
10243	739	10013198794995
10244	1693	1763511806335
10245	893	307227885873282
10246	1693	1713723568614
10247	377	66087112047044
10248	1693	1663935330893
10249	103	66087112047044
10250	1693	1614147093172
10251	361	66087112047044
10252	1698	8639090000000
10253	1698	8639280000000
10267	470	76080271000000
10275	1397	1414297563000
10276	1678	2880082437000
10277	1773	8738330301113
10278	182	66153938198848
10279	1773	8635694835210
10280	702	44102625465903
10281	1773	7464006184587
10282	927	503949453650623
10283	1773	5364358081609
10284	1047	903073103102978
10285	1773	3947680415286
10286	1167	609321417666323
10287	1773	0
10288	1293	1697928308166936
10289	1679	24479972000000
10298	1513	2880350000000
10299	1397	1414267560000
10300	1678	2880082440000
10301	114	66002740000000
10302	1397	1414257559000
10303	1678	2880082441000
10304	10	32558990000000
10305	1711	7199140000000
10315	1397	1414227556000
10316	1678	2880082444000
10317	1683	252001758999541
10318	1683	252001768999541
10327	1397	1414197553000
10328	1678	2880082447000
10329	1750	7499000000
10330	1677	102961502000000
10331	1677	102961513000000
10352	1397	1414127546000
10353	1678	2880082454000
10369	1756	8639189000000
10370	1756	9359189000000
10371	1756	9359209000000
10372	1397	1414107544000
10373	1678	2880082456000
10374	1693	1315417666846
10375	499	66087112047044
10376	1693	1300926724969
10377	35	19225341686403
10378	1693	1251138487248
10379	49	66087112047044
10380	1693	1201350249527
10381	112	66087112047044
10382	1693	1151562011806
10383	127	66087112047044
10384	1693	1101773774085
10385	186	66087112047044
10386	1693	1051985536364
10387	551	66087112047044
9883	1693	6592040458502
9884	570	66087112047044
9885	1693	6212839533730
9886	910	503441359118351
9887	1693	6163051296009
9888	322	66087112047044
9889	1693	6113263058288
9890	500	66087112047044
9891	1693	6063474820567
9892	105	66087112047044
9893	1693	6013686582846
9894	89	66087112047044
9895	1693	5963898345125
9896	146	66087112047044
9897	1693	5914110107404
9898	92	66087112047044
9899	1693	5908820597346
9900	29	7009239156499
9901	1693	5859032359625
9902	251	66087112047044
9903	1693	5809244121904
9904	84	66087112047044
9905	1693	5759455884183
9906	395	66084082047044
9907	1693	5709667646462
9908	587	66087112047044
9909	1397	1414937627000
9910	1678	2160042373000
9911	1397	1414927626000
9912	1678	2160042374000
9913	1397	1414917625000
9914	1678	2160042375000
9915	1693	5659879408741
9916	611	66087112047044
9917	1693	5610091171020
9918	678	66087112047044
9919	1677	98641352000000
9922	1397	1414907624000
9923	1678	2160042376000
9924	1693	5560302933299
9925	320	66087112047044
9926	1693	5556521854688
9927	710	5006599397497
9928	1689	7199140000000
9929	1689	7199170000000
9937	1649	7920161000000
9956	1397	1414847618000
9957	1678	2160042382000
9958	1397	1414837617000
9959	1678	2160042383000
9960	1397	1414827616000
9961	1678	2160042384000
9962	1397	1414817615000
9963	1678	2160042385000
9964	1683	241921398999541
9975	1694	18719405000000
9976	1397	1414777611000
9977	1678	2160042389000
9978	1756	8639139000000
9979	1756	8639149000000
9983	1397	1414757609000
9984	1678	2160042391000
10005	1397	1414697603000
10006	1678	2160042397000
10007	1509	7920190000000
10008	1509	7920200000000
10018	1643	6480150000000
10025	1715	9359231000000
10040	1723	9359160000000
10041	1723	9359200000000
10055	1397	1414587592000
10056	1678	2160042408000
10057	1397	1414577591000
10058	1678	2160042409000
10059	1607	7920230000000
10060	1397	1414567590000
10061	1678	2160042410000
10062	1397	1414557589000
10063	1678	2160042411000
10064	1397	1414547588000
10065	1678	2160042412000
10066	1560	7920170000000
10067	1560	7920200000000
10093	1768	3599130000000
10094	44	71040240000000
10095	1693	4957544570599
10096	78	66087112047044
10097	1693	4908263165845
10098	37	65414225088019
10099	1693	4858474928124
10100	520	66087112047044
10101	1693	4808686690403
10102	163	66087112047044
10103	1397	1414517585000
10104	1678	2160042415000
10105	1555	5760190000000
10108	1397	1414507584000
10109	1678	2160042416000
10110	1727	5759080000000
10111	1727	5759090000000
10135	1397	1414447578000
10136	1678	2880082422000
10137	1702	2874030000000
10138	114	66005000000000
10139	1684	11519260000000
10140	1684	11519280000000
10154	1397	1414417575000
10155	1678	2880082425000
10156	1719	3599120000000
10157	1719	3599130000000
10160	1692	26639742000000
10161	1692	26639752000000
10166	1593	6480200000000
10167	1593	6480210000000
10168	1396	20000000
10169	436	66719700000000
10170	1397	1414397573000
10171	1678	2880082427000
10172	1688	38159962000000
10174	1587	8640250000000
10175	1397	1414387572000
10176	1678	2880082428000
10177	1397	1414377571000
10178	1678	2880082429000
10179	1683	250561748999541
10180	1683	250561768999541
10194	1397	1414357569000
10195	1678	2880082431000
10196	1693	4151046901851
10197	622	66090092047044
10198	1693	4101258664130
10199	653	66087112047044
10200	1693	4051470426409
10201	193	66087112047044
10202	1693	4001682188688
10203	504	66087112047044
10204	1693	3951893950967
10205	593	66087112047044
10206	1693	3902105713246
10207	658	66087112047044
10208	1693	3877539957744
10209	6	32600972636768
10210	1693	3827751720023
10211	652	66087112047044
10212	1677	102241412000000
10213	1677	102241502000000
10256	1397	1414327566000
10257	1678	2880082434000
10258	114	66004490000000
10259	10	32558500000000
10260	114	66003980000000
10261	10	32559000000000
10262	114	66003470000000
10263	283	66000500000000
10264	114	66003260000000
10265	238	66000200000000
10266	1688	38880012000000
10271	114	66002750000000
10272	301	66000500000000
10273	1397	1414307564000
10274	1678	2880082436000
10294	1397	1414277561000
10295	1678	2880082439000
10296	1656	10080241000000
10297	1656	10080261000000
10308	301	66000490000000
10309	1397	1414247558000
10310	1678	2880082442000
10311	1397	1414237557000
10312	1678	2880082443000
10313	1402	25920611000000
10314	1402	25920641000000
10326	1684	12239310000000
10340	1397	1414157549000
10341	1678	2880082451000
10342	1571	7200100000008
10343	1571	7200110000008
10350	1637	43201261000000
10351	1637	43201282000000
10406	1701	7198271000000
10483	1397	1414087542000
10484	1678	2880082458000
10485	878	203062162331632
10486	1772	518000000000
10487	1397	1414077541000
9944	58	72480160000000
9946	1397	1414867620000
9947	1678	2160042380000
9948	1729	6479090000000
9949	1729	6479100000000
9954	606	72480120000000
9955	606	72480130000000
9965	1397	1414807614000
9966	1678	2160042386000
9967	1440	5760090000000
9974	1489	5760120000000
9997	1397	1414717605000
9998	1678	2160042395000
9999	1677	99361352000000
10000	1677	99361362000000
10003	1397	1414707604000
10004	1678	2160042396000
10009	1768	3599050000000
10010	1768	3599060000000
10011	1643	7200350000000
10012	1643	7200940000000
10013	1397	1414687602000
10014	1678	2160042398000
10015	1397	1414677601000
10016	1678	2160042399000
10017	1708	4319210000000
10019	1397	1414667600000
10020	1678	2160042400000
10021	1397	1414657599000
10022	1678	2160042401000
10023	1683	246241458999541
10024	1683	246241478999541
10026	1397	1414647598000
10027	1678	2160042402000
10028	1717	5039190000000
10029	1717	5039200000000
10042	1536	10080220000000
10043	1536	10080260000000
10044	1397	1414627596000
10045	1678	2160042404000
10046	1397	1414617595000
10047	1678	2160042405000
10048	1677	100081362000000
10049	1677	100081382000000
10050	1397	1414607594000
10051	1678	2160042406000
10052	1397	1414597593000
10053	1678	2160042407000
10054	1637	41761071000000
10068	1650	5040080000000
10069	1650	5040110000000
10075	877	203061162331632
10076	1772	259000000000
10077	1693	5256273996925
10078	150	66087112047044
10079	1693	5206485759204
10080	450	66087112047044
10081	1693	5156697521483
10082	620	66087112047044
10083	1693	5106909283762
10084	421	66087112047044
10085	1693	5057121046041
10086	245	66087112047044
10087	1693	5007332808320
10088	54	66087112047044
10089	1397	1414527586000
10090	1678	2160042414000
10091	1711	7199100000000
10092	1711	7199180000000
10118	1397	1414477581000
10119	1678	2160042419000
10120	1397	1414467580000
10121	1678	2160042420000
10122	1688	38159872000000
10133	1768	4319130000000
10134	1768	4319170000000
10142	1396	718420000000
10143	436	66001500000000
10144	1396	716820000000
10145	436	66003000000000
10146	1699	1905970500039
10147	1773	8892278499961
10148	1397	1414437577000
10149	1678	2880082423000
10150	1397	1414427576000
10151	1678	2880082424000
10152	1683	249121518999541
10153	1683	249121748999541
10158	1684	12239280000000
10159	1684	12239290000000
10173	1489	5760210000000
10181	1688	38879962000000
10182	1688	38879982000000
10185	1693	4970623377293
10186	1693	4970643377293
10193	1599	10080220000000
10254	1637	42481071000000
10255	1637	42481261000000
10268	1397	1414317565000
10269	1678	2880082435000
10270	1683	250561758999541
10290	1397	1414287562000
10291	1678	2880082438000
10292	1440	6480090000000
10293	1440	6480210000000
10306	1724	7918700000000
10307	1724	7918740000000
10319	283	66000490000000
10320	1397	1414217555000
10321	1678	2880082445000
10322	1397	1414207554000
10323	1678	2880082446000
10324	1444	7920150000000
10325	1444	7920180000000
10332	1397	1414187552000
10333	1678	2880082448000
10334	1397	1414177551000
10335	1678	2880082449000
10336	1397	1414167550000
10337	1678	2880082450000
10338	1683	253441768999541
10339	1683	253441798999541
10344	1397	1414147548000
10345	1678	2880082452000
10346	1397	1414137547000
10347	1678	2880082453000
10348	1750	7498000000
10349	1522	2880051000000
10354	1397	1414117545000
10355	1678	2880082455000
10356	1693	1564358855451
10357	453	66087112047044
10358	1693	1514570617730
10359	82	66087112047044
10360	1693	1464782380009
10361	261	66087112047044
10362	1457	6480180000000
10363	1693	1414994142288
10364	201	66087112047044
10365	1693	1365205904567
10366	383	66087112047044
10367	1457	7200180000000
10368	1457	7200200000000
10394	1693	799253170035
10395	878	203321172331632
10396	1693	749464932314
10397	569	66087112047044
10398	1693	747946500877
10399	745	2002639758987
10400	1397	1414097543000
10401	1678	2880082457000
10402	1750	6397000000
10403	1774	100000000
10404	1740	10076603000000
10405	1740	10076644000000
10498	1397	1414047538000
10499	1678	2880082462000
10500	1397	1414037537000
10501	1678	2880082463000
10502	1683	254881798999541
10503	1683	254881818999541
10508	1397	1414027536000
10509	1678	2880082464000
10510	1402	26640641000000
10511	1402	26640651000000
10514	1397	1414007534000
10515	1678	2880082466000
10516	1397	1413997533000
10517	1678	2880082467000
10518	1419	8640190000000
10528	1397	1413957529000
10529	1678	2880082471000
10538	1397	1413927526000
10539	1678	2880082474000
10540	149	71040110000000
10541	149	71040120000000
10582	1685	28079680000000
10600	1594	5040180000000
10601	1594	5040200000000
10621	1693	1467946500877
10622	1693	1467956500877
10623	1509	8640200000000
10624	1509	8640210000000
10627	1397	1413767510000
10628	1678	2880082490000
10388	1693	1002197298643
10389	663	66087112047044
10390	1693	952409060922
10391	680	66087112047044
10392	1607	8640230000000
10393	1607	8640330000000
10407	1702	2154020000000
10408	1693	7467389262733
10409	1693	7417601025012
10410	1693	7367812787291
10411	1693	7318024549570
10412	1693	7268236311849
10413	1693	7218448074128
10414	1693	7065292183241
10415	1693	7015503945520
10416	1693	7013985514083
10417	1693	6964197276362
10418	1693	6914409038641
10419	1693	6234892150341
10420	1693	6185103912620
10421	1693	6135315674899
10422	1693	6085527437178
10423	1693	6035739199457
10424	1693	5985950961736
10425	1693	5936162724015
10426	1693	5704742056121
10427	1693	5699681073433
10428	1693	5649892835712
10429	1693	5600104597991
10430	1693	5550316360270
10431	1693	5500528122549
10432	1693	5450739884828
10433	1693	5400951647107
10434	1693	5351163409386
10435	1693	5301375171665
10436	1693	5251586933944
10437	1693	5201798696223
10438	1693	5152010458502
10439	1693	4772809533730
10440	1693	4723021296009
10441	1693	4673233058288
10442	1693	4623444820567
10443	1693	4573656582846
10444	1693	4523868345125
10445	1693	4474080107404
10446	1693	4468790597346
10447	1693	4419002359625
10448	1693	4369214121904
10449	1693	4319425884183
10450	1693	4269637646462
10451	1693	4219849408741
10452	1693	4170061171020
10453	1693	4120272933299
10454	1693	4116491854688
10455	1693	4114973423251
10456	1693	4065185185530
10457	1693	4015396947809
10458	1693	3965608710088
10459	1693	3915820472367
10460	1693	3866032234646
10461	1693	3816243996925
10462	1693	3766455759204
10463	1693	3716667521483
10464	1693	3666879283762
10465	1693	3617091046041
10466	1693	3567302808320
10467	1693	3517514570599
10468	1693	3468233165845
10469	1693	3418444928124
10470	1693	3368656690403
10471	1693	2910169852735
10472	1693	2860381615014
10473	1693	2810593377293
10474	1693	2760805139572
10475	1693	2711016901851
10476	1693	2661228664130
10477	1693	2611440426409
10478	1693	2561652188688
10479	1693	2511863950967
10480	1693	2462075713246
10481	1611	4321400000000
10482	1611	5041399999992
10491	1772	517750000000
10492	1397	1414067540000
10493	1678	2880082460000
10494	1397	1414057539000
10495	1678	2880082461000
10496	1504	1036967000000
10497	1504	1037237000000
10506	1458	8641012798540
10507	1458	9361012798532
10512	1397	1414017535000
10513	1678	2880082465000
10524	1397	1413967530000
10525	1678	2880082470000
10526	1683	256321818999541
10527	1683	256321828999541
10532	1397	1413947528000
10533	1678	2880082472000
10534	1397	1413937527000
10535	1678	2880082473000
10536	1656	10800261000000
10537	1656	10800281000000
10546	1397	1413907524000
10547	1678	2880082476000
10548	1397	1413897523000
10549	1678	2880082477000
10550	1685	28079670000000
10551	1685	28079690000000
10578	1397	1413887522000
10579	1678	2880082478000
10580	1683	257761828999541
10581	1683	257761838999541
10594	1397	1413837517000
10595	1678	2880082483000
10596	1397	1413827516000
10597	1678	2880082484000
10598	1471	5040080000000
10599	1471	5040100000000
10605	1397	1413817515000
10606	1678	2880082485000
10607	1699	2625970500039
10608	1699	2625980500039
10611	1397	1413797513000
10612	1678	2880082487000
10613	1679	25920022000000
10614	1679	25920032000000
10625	1397	1413777511000
10626	1678	2880082489000
10634	1397	1413747508000
10635	1678	2880082492000
10636	1704	1439310000000
10639	1397	1413737507000
10640	1678	2880082493000
10641	1444	7920160000000
10647	1506	7202460000000
10648	1506	7922460000000
10649	1506	7923010000000
10654	1680	11519270000000
10657	1402	28080661000000
10658	1402	28080671000000
10665	1397	1413687502000
10666	1678	2880082498000
10674	1746	2879030000000
10675	1746	2879050000000
10676	1680	12239240000000
10677	1680	12239260000000
10679	1397	1413657499000
10680	1678	2880082501000
10681	1677	103681543000000
10694	43	71760140000000
10695	43	71760150000000
10703	1397	1413597493000
10704	1678	2880082507000
10705	1693	2187946500877
10706	1693	2187956500877
10707	1397	1413587492000
10708	1678	2880082508000
10709	1397	1413577491000
10710	1678	2880082509000
10711	1536	10080250000000
10715	1722	14413201000000
10716	1722	14413231000000
10725	1683	262081848999541
10728	1727	6479090000000
10739	1722	171000000
10740	1749	4315990000000
10741	1688	40319982000000
10742	1688	40319992000000
10743	1762	2879060000000
10744	1762	2879070000000
10747	1687	7199101000000
10748	1693	2907946500877
10749	1709	6480410000000
10750	1678	2160042444000
10751	1678	2160042445000
10752	1678	2160042446000
10753	1678	2160042447000
10754	1678	2160042448000
10755	1678	2160042449000
10756	1678	2160042450000
10757	1678	2160042451000
10758	1678	2160042452000
10759	1678	2160042453000
10760	1678	2160042454000
10488	1678	2880082459000
10489	1637	43921282000000
10490	1637	43921312000000
10504	1670	11520420000000
10505	1670	11520440000000
10519	1397	1413987532000
10520	1678	2880082468000
10521	1397	1413977531000
10522	1678	2880082469000
10523	1613	6478110000000
10530	1637	44641312000000
10531	1637	44641322000000
10542	1397	1413917525000
10543	1678	2880082475000
10544	1653	720000000000
10545	1653	720010000000
10552	1678	2160042422000
10553	1678	2160042423000
10554	1678	2160042424000
10555	1678	2160042425000
10556	1678	2160042426000
10557	1678	2160042427000
10558	1678	2160042428000
10559	1678	2160042429000
10560	1678	2160042430000
10561	1678	2160042431000
10562	1678	2160042432000
10563	1678	2160042433000
10564	1678	2160042434000
10565	1678	2160042435000
10566	1678	2160042436000
10567	1678	2160042437000
10568	1678	2160042438000
10569	1678	2160042439000
10570	1678	2160042440000
10571	1678	2160042441000
10572	1678	2160042442000
10573	1476	6481000000000
10574	1678	2160042443000
10575	1476	7201000000000
10576	1476	7201010000000
10577	1476	7200160000000
10583	1397	1413877521000
10584	1678	2880082479000
10585	1397	1413867520000
10586	1678	2880082480000
10587	1397	1413857519000
10588	1678	2880082481000
10589	1397	1413847518000
10590	1678	2880082482000
10591	436	66719690000000
10592	1679	25199972000000
10593	1679	25200022000000
10602	1506	6481210000000
10603	1506	7201210000000
10604	1506	7201760000000
10609	1397	1413807514000
10610	1678	2880082486000
10615	1451	4320150000000
10616	1451	4320160000000
10617	1397	1413787512000
10618	1678	2880082488000
10619	1588	5040080000000
10620	1588	5040090000000
10630	1397	1413757509000
10631	1678	2880082491000
10632	1402	27360651000000
10633	1402	27360661000000
10637	1746	2159020000000
10638	1746	2159030000000
10646	1522	2880040000000
10652	1685	28799680000000
10653	1685	28799690000000
10661	1397	1413697503000
10662	1678	2880082497000
10663	1419	9360190000000
10664	1419	9360200000000
10686	1397	1413637497000
10687	1678	2880082503000
10688	1683	260641838999541
10689	1683	260641848999541
10701	1559	10080210000000
10702	1559	10080230000000
10712	1764	1439040000000
10717	1397	1413567490000
10718	1678	2880082510000
10719	1422	2880030000000
10720	1422	2880040000000
10729	1677	104401543000000
10730	1677	105121543000000
10733	1722	7932191000000
10734	1759	6480000000000
10735	1722	3612181000000
10736	1764	5039010000000
10737	1677	105841543000000
10738	1677	105841563000000
10767	641	73920410000000
10770	1623	9360161000000
10772	1715	10079231000000
10775	1759	7200000000000
10781	1693	3627946500877
10782	1633	4320060000000
10784	1521	1437049000000
10785	1775	2000000000
10786	1706	7196492000000
10629	1670	11520430000000
10642	1397	1413727506000
10643	1678	2880082494000
10644	1677	103681513000000
10645	1677	103681523000000
10650	1397	1413717505000
10651	1678	2880082495000
10655	1397	1413707504000
10656	1678	2880082496000
10659	1772	258750000000
10660	1426	4320730000000
10667	1683	259201838999541
10668	1397	1413677501000
10669	1678	2880082499000
10670	1397	1413667500000
10671	1678	2880082500000
10672	1704	2159310000000
10673	1704	2159390000000
10678	1747	3599160000000
10682	1397	1413647498000
10683	1678	2880082502000
10684	171	73200120000000
10685	171	73200130000000
10690	1397	1413627496000
10691	1678	2880082504000
10692	1688	39599982000000
10693	1688	39599992000000
10696	1397	1413617495000
10697	1678	2880082505000
10698	1397	1413607494000
10699	1678	2880082506000
10700	1593	6480220000000
10713	1735	3579990000000
10714	1735	3580020000000
10721	1679	26640032000000
10722	1679	26640042000000
10723	1397	1413557489000
10724	1678	2880082511000
10726	1607	9360330000000
10727	1681	12239313195920
10731	1571	6480100000016
10732	1611	5761399999984
10745	1522	3600040000000
10746	470	76800271000000
10766	1683	263521848999541
10769	1729	7199100000000
10774	42	69600070000000
10776	1559	10800230000000
10777	1671	7920220000000
10778	1458	10081012798524
10780	1684	12959310000000
10783	1756	10079209000000
10791	1677	106561563000000
10761	1678	2160042455000
10762	1678	2160042456000
10763	1709	7200410000000
10764	1709	7201520000000
10765	171	73920130000000
10768	1637	45361312000000
10771	632	71760130000000
10773	1683	264961848999541
10779	1402	28800661000000
10787	1706	6477441000000
10788	1706	7197441000000
10789	1571	7197600999992
10790	1706	6480100000016
10792	1419	10080200000000
10793	1722	7212181000000
10794	1722	2892171000000
10795	1678	2160042457000
10796	1678	2160042458000
10797	1678	2160042459000
10798	1678	2160042460000
10799	1678	2160042461000
10800	1678	2160042462000
10801	1678	2160042463000
10802	1678	2160042464000
10803	1678	2160042465000
10804	1678	2160042466000
10805	1678	2160042467000
10806	1678	2160042468000
10807	1678	2160042469000
10808	1678	2160042470000
10809	1678	2160042471000
10810	1678	2160042472000
10811	1678	2160042473000
10812	1678	2160042474000
10813	1678	2160042475000
10814	1678	2160042476000
10815	1678	2160042477000
10816	1678	2160042478000
10817	1678	2160042479000
10818	1506	7923710000000
10819	1678	2160042480000
10820	1678	2160042481000
10821	1678	2160042482000
10822	1678	2160042483000
10823	1678	2160042484000
10824	1678	2160042485000
10825	1678	2160042486000
10826	1678	2160042487000
10827	1678	2160042488000
10828	1678	2160042489000
10829	1678	2160042490000
10830	1678	2160042491000
10831	1678	2160042492000
10832	1678	2160042493000
10833	1678	2160042494000
10834	1678	2160042495000
10835	1678	2160042496000
10836	1678	2160042497000
10837	1678	2160042498000
10838	1678	2160042499000
10839	1678	2160042500000
10840	1678	2160042501000
10841	1678	2160042502000
10842	1678	2160042503000
10843	1678	2160042504000
10844	1506	8643710000000
10845	1506	8643960000000
10846	613	66720000000000
10847	1749	703989000000
10848	1764	8651010000000
10849	1458	10080172798540
10850	1458	10080173798540
10851	1650	5040081000000
10852	1764	5040009000000
10853	1749	4314989000000
10854	1709	6479251000000
10855	1709	7201660000000
10856	1678	2160042505000
10857	1678	2160042506000
10858	1678	2160042507000
10859	1678	2160042508000
10860	1678	2160042509000
10861	1678	2160042510000
10862	1678	2160042511000
10863	1709	7921660000000
10864	1709	12603401
10865	1515	7922074999999
10866	1645	1000000
10867	1471	5760100000000
10868	1677	107281563000000
10869	1700	7199420000000
10870	1775	1989000000
10871	1521	1437059000000
10872	1677	108001563000000
10873	1677	108001564000000
10874	1607	10080330000000
10875	1607	10080331000000
10876	1637	45361313000000
10877	1709	6479241000000
10878	1500	0
10879	1458	10800173798540
10880	1458	10800183798540
10881	1546	7200120000000
10882	1546	7200130000000
10883	1685	29519690000000
10884	1685	29519700000000
10885	1623	10080161000000
10886	1444	8640160000000
10887	1687	7919101000000
10888	1690	19439540000000
10889	1775	1978000000
10890	1605	10000000
10891	1690	19439541000000
10892	1709	6479231000000
10893	1439	5760100000000
10894	1439	5760110000000
10895	1722	70000000
10896	1749	4315089000000
10897	1686	2371825500013
10898	1686	2371826500013
10899	1634	8640160000000
10900	1683	266401848999541
10901	596	76800212000000
10902	1709	5759240000000
10903	1749	704089000000
10904	1634	8640184000000
10905	1775	1967000000
10906	1605	20000000
10907	1679	27360042000000
10908	1679	27360043000000
10909	1677	108721563000000
10910	1677	108721564000000
10911	1727	6479091000000
10912	1439	6480110000000
10913	1439	6480111000000
10914	329	66718800000000
10915	11	4652000000000
10916	1775	1946000000
10917	1521	1437079000000
10918	1682	7187190000000
10919	1682	7187291000000
10920	1768	4319231000000
10921	238	66720200000000
10922	1692	27359752000000
10923	1476	7920160000000
10924	1677	109441564000000
10925	1688	41039982000000
10926	1749	4316090000000
10927	1513	3600350000000
10928	1513	3600503000000
10929	1607	10800331000000
10930	1623	10800161000000
10931	1690	20159541000000
10932	1522	4320040000000
10933	1764	5760009000000
10934	1650	5760080000000
10935	1546	7920130000000
10936	1683	267841848999541
10937	1633	5040060000000
10938	1546	8640130000000
10939	1714	8629030000000
10940	1717	5759200000000
10941	1513	4320503000000
10942	1677	110161564000000
10943	1550	720010000000
10944	1692	28079752000000
10945	1549	7920111000000
10946	1719	4319130000000
10947	1739	4319270000000
10948	1683	269281848999541
10949	1716	8639170000000
10950	1476	8640160000000
10951	1693	4347946500877
10952	1683	270721848999541
10953	1445	7200170000000
10954	1711	7919140000000
10955	1683	272161848999541
10956	1679	28080042000000
10957	1693	5067946500877
10958	1677	110881564000000
10959	1683	273601848999541
10960	1670	12240430000000
10961	1764	6480009000000
10962	1596	7200120000000
10963	1677	111601564000000
10964	1637	46081312000000
10970	1614	720000000000
10974	1541	3599099000000
10975	348	66001000000000
10976	1541	3597098000000
10977	1777	1000000000
10978	1681	12959313195920
10979	1681	12959315195920
10984	1709	6478221000000
10985	1776	0
10986	443	66000388000000
10987	530	66000099000000
10988	1564	2160032000000
10996	1708	5039190000000
10997	1709	6477211000000
10998	1776	1000000000
10999	1668	9360130000000
11002	1684	13679310000000
11004	1544	720000000000
11006	606	73200130000000
11013	1693	6507946500877
11035	1397	1413517485000
11036	1678	2880082515000
11037	1445	7200180000000
11043	1677	113041564000000
11044	1677	113041574000000
11052	1397	1413477481000
11053	1678	2880082519000
11054	1693	7226836500877
11055	1693	7226846500877
11081	1637	46801322000000
11082	1637	46801342000000
11087	1711	8639140000000
11088	1711	8639150000000
11091	1749	5035099000000
11100	1397	1413377471000
11101	1678	2880082529000
11102	1397	1413367470000
11103	1678	2880082530000
11104	1754	798000000
11105	1779	2200000000
11106	1703	4319150000000
11107	1703	4319171000000
11110	1397	1413357469000
11111	1678	2880082531000
11112	1683	275041868999541
11119	1683	276481868999541
11120	1683	276481878999541
11129	1489	5040121000000
11130	1489	5760121000000
11131	1397	1413327466000
11132	1678	2880082534000
11133	1458	11520173298540
11134	1460	11520179398540
11135	1458	3400000
11136	1744	901000000
11157	1397	1413257459000
11158	1678	2880082541000
11159	1397	1413247458000
11160	1678	2880082542000
11161	1571	7920111000008
11162	1571	7920131000008
11177	1271	1336206020000000
11178	1271	1336206030000000
11184	1397	1413207454000
11185	1678	2880082546000
11188	1397	1413197453000
11189	1678	2880082547000
11190	1402	30240681000000
11191	1402	30240691000000
11207	1397	1413157449000
11208	1678	2880082551000
11209	1686	3091826500013
11210	1686	3091836500013
11213	1683	279361888999541
11214	1683	279361898999541
11219	1397	1413137447000
11220	1678	2880082553000
11221	1397	1413127446000
11222	1678	2880082554000
11223	1703	4319170000000
11226	1397	1413117445000
11227	1678	2880082555000
11230	1573	6480090000000
11231	1573	6480100000000
11244	1677	114481595000000
11246	1397	1413087442000
11247	1678	2880082558000
11248	1397	1413077441000
11249	1678	2880082559000
11250	1694	20159415000000
11251	1694	20159435000000
11258	1397	1413057439000
11259	1678	2880082561000
11260	1397	1413047438000
11261	1678	2880082562000
11262	1688	42480012000000
11265	1397	1413037437000
11266	1678	2880082563000
11267	1688	43200012000000
11268	1688	43200022000000
11281	1397	1413007434000
11282	1678	2880082566000
11283	1397	1412997433000
11284	1678	2880082567000
11285	1740	10076623000000
11302	1397	1412957429000
11303	1678	2880082571000
11304	1698	10079101000000
11310	1397	1412937427000
11311	1678	2880082573000
11312	1397	1412927426000
11313	1678	2880082574000
11314	1729	7199120000000
11325	1397	1412897423000
11326	1678	2880082577000
11327	1397	1412887422000
11328	1678	2880082578000
11329	1593	7200200000000
11330	1593	7200220000000
11335	1683	283681918999541
11336	1683	283681928999541
11386	1397	1412727406000
11387	1678	2880082594000
11388	1688	45360052000000
11389	1688	45360062000000
11404	1397	1412687402000
11405	1678	2880082598000
11406	1397	1412677401000
11407	1678	2880082599000
11408	1679	29520052000000
11409	1679	29520072000000
11412	1692	28799782000000
11438	1397	1412597393000
11439	1678	2880082607000
11440	1717	6479200000000
11441	1717	6479210000000
11454	1702	5034091000000
11459	1397	1412557389000
11460	1678	2880082611000
11461	1630	720000000000
11462	1630	720010000000
11491	1765	70000000
11492	871	109739603307813
11493	1397	1412487382000
11494	1678	2880082618000
11495	1756	10799209000000
11496	1756	10799229000000
11518	1397	1412417375000
11519	1678	2880082625000
11520	1397	1412407374000
11521	1678	2880082626000
11531	1397	1412367370000
11532	1678	2880082630000
11533	1397	1412357369000
11534	1678	2880082631000
11535	1549	9360221000000
11536	1549	9360241000000
11545	1643	7200150000000
11546	1643	7200160000000
11553	1397	1412327366000
11554	1678	2880082634000
11555	1677	120241665000000
11556	1677	120241675000000
11561	1683	289441968999541
11562	1683	289441988999541
11575	1451	4320170000000
11598	1677	120961675000000
11599	1677	120961685000000
11600	1397	1412197353000
11601	1678	2880082647000
11602	1687	8639101000000
11603	1687	8639111000000
11608	1397	1412177351000
11609	1678	2880082649000
11610	1397	1412167350000
11611	1678	2880082650000
11612	1397	1412157349000
11613	1678	2880082651000
11614	1677	121681685000000
11615	1677	121681715000000
11618	1691	5759120000000
11627	686	66720000000000
11628	686	66720020000000
11644	1397	1412077341000
10965	1698	9359090000000
10966	1547	3600030000000
10968	1634	9360160000000
10971	1634	9360184000000
10972	1634	9360284000000
10980	443	66000389000000
10981	530	66000100000000
10982	1698	9359091000000
10991	1673	4320320000000
10992	1673	4320332000000
11001	1698	10079091000000
11008	1776	989000000
11009	1571	7200111000008
11011	1722	720070000000
11015	1709	7197211000000
11016	1714	9349030000000
11022	1683	273601858999541
11041	1455	5040081000000
11042	1455	5040091000000
11058	1397	1413467480000
11059	1678	2880082520000
11060	1422	3600030000000
11061	1422	3600040000000
11072	1723	10079160000000
11073	1723	10079190000000
11079	1402	29520661000000
11080	1402	29520681000000
11096	1397	1413387472000
11097	1678	2880082528000
11098	1509	9360210000000
11099	1509	9360220000000
11115	1397	1413347468000
11116	1678	2880082532000
11117	1677	114481584000000
11118	1677	114481594000000
11121	1693	6506726500877
11122	562	66000100000000
11123	1397	1413337467000
11124	1678	2880082533000
11125	1754	673543211
11126	1779	2323456789
11127	1677	113761605000000
11128	1677	114481605000000
11138	1458	11520173798540
11139	1458	11520183798540
11143	1397	1413307464000
11144	1678	2880082536000
11145	1679	28800042000000
11146	1679	28800052000000
11147	1397	1413297463000
11148	1678	2880082537000
11149	1397	1413287462000
11150	1678	2880082538000
11151	1397	1413277461000
11152	1678	2880082539000
11153	1397	1413267460000
11154	1678	2880082540000
11155	1672	6480080000000
11156	1672	6480120000000
11165	1683	277921878999541
11166	1683	277921898999541
11173	1397	1413217455000
11174	1678	2880082545000
11175	1706	7916492000000
11176	1706	7916502000000
11179	1685	31679700000000
11180	1685	31679710000000
11198	1549	8640111000000
11199	1549	8640121000000
11217	1397	1413147448000
11218	1678	2880082552000
11238	1397	1413097443000
11239	1678	2880082557000
11240	1266	606459749000000
11241	1754	5673543211
11242	1560	8640200000000
11243	1560	8640211000000
11245	1691	5759101000000
11254	1397	1413067440000
11255	1678	2880082560000
11256	1422	4320040000000
11257	1422	4320050000000
11271	1397	1413027436000
11272	1678	2880082564000
11273	1693	7226726500877
11274	1693	7226736500877
11277	1397	1413017435000
11278	1678	2880082565000
11279	1688	43920022000000
11280	1688	43920032000000
11292	1650	5760100000000
11309	1677	115201605000000
11321	1458	11520193798540
11331	1397	1412877421000
11332	1678	2880082579000
11333	1698	10799101000000
11334	1698	10799111000000
11343	1397	1412847418000
11344	1678	2880082582000
11345	1633	5760060000000
11346	1633	5760070000000
11348	1702	5034071000000
11349	1702	5034081000000
11362	1397	1412807414000
11363	1678	2880082586000
11364	1397	1412797413000
11365	1678	2880082587000
11366	1546	9360150000000
11367	1397	1412787412000
11368	1678	2880082588000
11369	1397	1412777411000
11370	1678	2880082589000
11371	1397	1412767410000
11372	1678	2880082590000
11373	1397	1412757409000
11374	1678	2880082591000
11375	1444	9360200000000
11390	1397	1412717405000
11391	1678	2880082595000
11392	1677	115921605000000
11393	1677	115921615000000
11417	1397	1412657399000
11418	1678	2880082601000
11419	1397	1412647398000
11420	1678	2880082602000
11421	1397	1412637397000
11422	1678	2880082603000
11423	1602	5760150000000
11425	1714	9349060000000
11434	1397	1412607394000
11435	1678	2880082606000
11436	1677	117361625000000
11437	1677	117361635000000
11452	1703	5039160000000
11453	1703	5039180000000
11455	1397	1412567390000
11456	1678	2880082610000
11472	1397	1412527386000
11473	1678	2880082614000
11474	1397	1412517385000
11475	1678	2880082615000
11497	1397	1412477381000
11498	1678	2880082619000
11499	1716	9359170000000
11500	1716	9359180000000
11547	1693	5786836500877
11548	1693	5786726500877
11549	1643	6481050000000
11550	1643	7201050000000
11551	1744	7201489500000
11552	1643	900500000
11563	1695	7199021000000
11564	1695	7199041000000
11569	1397	1412287362000
11570	1678	2880082638000
11571	1397	1412277361000
11572	1678	2880082639000
11573	369	74640150000000
11574	369	74640170000000
11596	1397	1412207354000
11597	1678	2880082646000
11623	1397	1412137347000
11624	1678	2880082653000
11625	1397	1412127346000
11626	1678	2880082654000
11629	1397	1412117345000
11630	1678	2880082655000
11631	1688	46800072000000
11632	1688	46800082000000
11642	1397	1412087342000
11643	1678	2880082658000
11659	1397	1412047338000
11660	1678	2880082662000
11661	1683	290881988999541
11662	1683	290881998999541
11709	1397	1411927326000
11710	1678	2880082674000
11711	1719	4319140000000
11722	1397	1411887322000
11723	1678	2880082678000
11724	1710	6479070000000
11725	1710	6479080000000
11743	1397	1411827316000
11744	1678	2880082684000
11745	1672	7200120000000
10967	1693	5787946500877
10969	171	74640130000000
10973	1685	30239690000000
10983	369	73200140000000
10989	1682	7907291000000
10990	1682	7907303000000
10993	1709	5758220000000
10994	1513	5040503000000
10995	1513	5040517000000
11000	1596	7920120000000
11003	1546	9360130000000
11005	1672	5760080000000
11007	1596	8640120000000
11010	1623	11520161000000
11012	1749	5035089000000
11014	1709	7199231000000
11017	1564	2880032000000
11018	1693	6506836500877
11019	1778	100000000
11020	1677	112321564000000
11021	1677	112321574000000
11023	1683	275041858999541
11024	1397	1413547488000
11025	1678	2880082512000
11026	1397	1413537487000
11027	1678	2880082513000
11028	1754	999000000
11029	1779	2000000000
11030	1601	6480160000000
11031	1601	6480181000000
11032	1397	1413527486000
11033	1678	2880082514000
11034	1692	28079762000000
11038	1397	1413507484000
11039	1678	2880082516000
11040	1670	12240440000000
11045	1397	1413497483000
11046	1678	2880082517000
11047	1684	14399310000000
11048	1684	14399320000000
11049	1397	1413487482000
11050	1678	2880082518000
11051	1637	46081322000000
11056	1677	113761574000000
11057	1677	113761584000000
11062	1397	1413457479000
11063	1678	2880082521000
11064	1739	5039270000000
11065	1739	5039280000000
11066	1778	90000000
11067	1397	1413447478000
11068	1678	2880082522000
11069	1397	1413437477000
11070	1678	2880082523000
11071	1740	10076633000000
11074	1397	1413427476000
11075	1678	2880082524000
11076	1397	1413417475000
11077	1678	2880082525000
11078	1683	275041878999541
11083	1397	1413407474000
11084	1678	2880082526000
11085	369	73920140000000
11086	369	73920150000000
11089	1722	1440070000000
11090	1722	1440080000000
11092	1397	1413397473000
11093	1678	2880082527000
11094	1685	30959690000000
11095	1685	30959700000000
11108	1702	3594030000000
11109	1702	3594051000000
11113	1690	20879541000000
11114	1690	20879551000000
11137	1440	6480100000000
11140	1397	1413317465000
11141	1678	2880082535000
11142	1419	10080210000000
11163	1724	8638700000000
11164	1724	8638720000000
11167	1397	1413237457000
11168	1678	2880082543000
11169	1397	1413227456000
11170	1678	2880082544000
11171	1688	41759982000000
11172	1688	41759992000000
11181	1706	7196522000000
11182	1706	7916522000000
11183	1706	7916602000000
11186	1694	19439405000000
11187	1694	19439415000000
11192	1397	1413187452000
11193	1678	2880082548000
11194	1695	6479011000000
11195	1695	6479021000000
11196	1508	6480090000000
11197	1508	6480100000000
11200	1397	1413177451000
11201	1678	2880082549000
11202	1601	7200181000000
11203	1601	7200191000000
11204	1397	1413167450000
11205	1678	2880082550000
11206	1683	277921888999541
11211	1688	42479992000000
11212	1688	42480002000000
11215	1668	10080130000000
11216	1668	10080140000000
11224	1702	4314051000000
11225	1702	4314071000000
11228	1428	1440030000000
11229	1428	1440040000000
11232	1397	1413107444000
11233	1678	2880082556000
11234	1683	280801898999541
11235	1683	280801908999541
11236	1723	10799190000000
11237	1723	10799200000000
11252	1599	10800210000000
11253	1599	10800230000000
11263	1677	115201595000000
11264	1677	115201615000000
11269	1754	5999000000
11270	1693	7226837500877
11275	1692	28799762000000
11276	1692	28799772000000
11286	1397	1412987432000
11287	1678	2880082568000
11288	1397	1412977431000
11289	1678	2880082569000
11290	1709	7917211000000
11291	1709	7917231000000
11293	1709	5757210000000
11294	1754	9000000000
11295	1513	5040528000000
11296	1506	6480160000000
11297	1513	5760518000000
11298	1397	1412967430000
11299	1678	2880082570000
11300	42	70320070000000
11301	42	70320080000000
11305	1397	1412947428000
11306	1678	2880082572000
11307	1683	282241908999541
11308	1683	282241918999541
11315	1397	1412917425000
11316	1678	2880082575000
11317	1397	1412907424000
11318	1678	2880082576000
11319	1444	9360160000000
11320	1444	9360180000000
11322	1693	7946736500877
11323	1693	7946756500877
11324	1710	5759070000000
11337	1397	1412867420000
11338	1678	2880082580000
11339	1780	719000000000
11340	1780	719010000000
11341	1397	1412857419000
11342	1678	2880082581000
11347	1703	4319160000000
11350	1397	1412837417000
11351	1678	2880082583000
11352	1397	1412827416000
11353	1678	2880082584000
11354	1684	14399340000000
11355	1684	15119340000000
11356	1688	43920052000000
11357	1688	44640052000000
11358	1623	11520181000000
11359	1623	12240181000000
11360	1397	1412817415000
11361	1678	2880082585000
11376	1440	7200100000000
11377	1440	7200140000000
11378	1640	1440010000000
11379	1397	1412747408000
11380	1678	2880082592000
11381	1640	1440020000000
11382	1397	1412737407000
11383	1678	2880082593000
11384	1705	6474920000000
11385	1705	6474930000000
11394	1397	1412707404000
11395	1678	2880082596000
11396	484	75360130000000
11397	484	75360140000000
11400	1397	1412697403000
11401	1678	2880082597000
11402	1701	7918271000000
11403	1701	7918281000000
11424	1522	4320070000000
11426	1397	1412627396000
11427	1678	2880082604000
11428	1546	10080150000000
11429	1546	10080160000000
11444	1397	1412587392000
11445	1678	2880082608000
11446	1397	1412577391000
11447	1678	2880082609000
11448	1677	118801645000000
11449	1677	118801665000000
11457	1683	286561938999541
11458	1683	286561948999541
11465	1397	1412547388000
11466	1678	2880082612000
11467	1688	46080062000000
11468	1688	46080072000000
11476	562	66000090000000
11477	1397	1412507384000
11478	1678	2880082616000
11479	1683	288001968999541
11485	1693	2186836500877
11486	1693	2186726500877
11487	662	66000900000000
11488	662	66720900000000
11489	662	6478360000000
11490	1613	66720950000000
11501	1397	1412467380000
11502	1678	2880082620000
11508	42	71040080000000
11509	42	71040190000000
11510	871	109739593307813
11511	1397	1412447378000
11512	1678	2880082622000
11513	1397	1412437377000
11514	1678	2880082623000
11515	1397	1412427376000
11516	1678	2880082624000
11517	1690	20879581000000
11527	1397	1412377371000
11528	1678	2880082629000
11529	1739	5759280000000
11530	1739	5759290000000
11541	1397	1412337367000
11542	1678	2880082633000
11543	1677	119521655000000
11544	1677	119521665000000
11565	1397	1412297363000
11566	1678	2880082637000
11567	1610	7920190000000
11568	1610	7920200000000
11577	1397	1412267360000
11578	1678	2880082640000
11581	1397	1412257359000
11582	1678	2880082641000
11583	1601	7920191000000
11584	1601	7920201000000
11585	1397	1412247358000
11586	1678	2880082642000
11587	1397	1412237357000
11588	1678	2880082643000
11589	1397	1412227356000
11590	1678	2880082644000
11591	1397	1412217355000
11592	1678	2880082645000
11593	1695	7919041000000
11594	1695	7919081000000
11633	1397	1412107344000
11634	1678	2880082656000
11635	1467	6481570000000
11636	1467	6481580000000
11647	1397	1412067340000
11648	1678	2880082660000
11649	1656	11520281000000
11650	1656	11520291000000
11653	1402	31680701000000
11654	1402	31680711000000
11673	1683	292321998999541
11674	1683	292322018999541
11680	1397	1411997333000
11681	1678	2880082667000
11682	1397	1411987332000
11683	1678	2880082668000
11684	1605	720020000000
11685	1605	720040000000
11686	1610	8640200000000
11687	1610	8640220000000
11690	1397	1411977331000
11691	1678	2880082669000
11692	1668	10800170000000
11693	1668	10800180000000
11700	1397	1411947328000
11701	1678	2880082672000
11702	1449	720024000459
11703	1449	720034000459
11704	1397	1411937327000
11705	1678	2880082673000
11706	1699	3345970500039
11707	1699	3345980500039
11714	1397	1411907324000
11715	1678	2880082676000
11716	1397	1411897323000
11717	1678	2880082677000
11718	1768	5039130000000
11719	1768	5039150000000
11726	1397	1411877321000
11727	1678	2880082679000
11728	1397	1411867320000
11729	1678	2880082680000
11749	1397	1411807314000
11750	1678	2880082686000
11751	1608	6480100000000
11752	1608	6480110000000
11755	1397	1411797313000
11756	1678	2880082687000
11757	1677	124561745000000
11758	1677	124561755000000
11764	1611	3600070000000
11767	1754	5798000000
11768	1643	7921489500000
11769	1643	7922073500000
11780	1397	1411737307000
11781	1678	2880082693000
11782	1397	1411727306000
11783	1678	2880082694000
11784	1447	7920130000000
11801	1397	1411687302000
11802	1678	2880082698000
11803	1690	21599581000000
11804	1690	21599591000000
11819	1764	6480019000000
11827	1397	1411607294000
11828	1678	2880082706000
11829	1397	1411597293000
11830	1678	2880082707000
11831	1722	79000000
11832	1749	5755089000000
11833	1677	125281755000000
11834	1677	125281776000000
11847	1397	1411567290000
11848	1678	2880082710000
11849	1445	7920180000000
11850	1445	7920190000000
11861	1397	1411517285000
11862	1678	2880082715000
11863	1703	5759180000000
11864	1703	5759190000000
11878	1397	1411477281000
11879	1678	2880082719000
11880	596	76800222000000
11897	1397	1411447278000
11898	1678	2880082722000
11899	1397	1411437277000
11900	1678	2880082723000
11901	1724	10078740000000
11902	1724	10078760000000
11913	1397	1411407274000
11914	1678	2880082726000
11915	1426	5040080000000
11916	1426	5040090000000
11934	1397	1411367270000
11935	1678	2880082730000
11944	1397	1411347268000
11945	1678	2880082732000
11946	1397	1411337267000
11947	1678	2880082733000
11948	1680	12959240000000
11949	1680	12959260000000
11951	1397	1411327266000
11952	1678	2880082734000
11953	1601	9360221000000
11954	1601	9360231000000
11971	1397	1411287262000
11972	1678	2880082738000
11975	1687	9359111000000
11976	1687	9359121000000
11977	1397	1411277261000
11978	1678	2880082739000
11979	1397	1411267260000
11398	1677	116641615000000
11399	1677	116641625000000
11410	1724	9358720000000
11411	1724	9358740000000
11413	1397	1412667400000
11414	1678	2880082600000
11415	1573	7200100000000
11416	1573	7200110000000
11430	1397	1412617395000
11431	1678	2880082605000
11432	1683	285121928999541
11433	1683	285121938999541
11442	1677	118081635000000
11443	1677	118081645000000
11450	1759	7920000000000
11451	1759	7920020000000
11463	1683	288001948999541
11464	1683	288001958999541
11469	1397	1412537387000
11470	1678	2880082613000
11471	1677	118801655000000
11480	1780	718910000000
11481	255	66000000000000
11482	1397	1412497383000
11483	1678	2880082617000
11484	1549	8640221000000
11503	1590	5700000000
11504	1781	0
11505	1397	1412457379000
11506	1678	2880082621000
11507	1682	7907401000000
11522	1397	1412397373000
11523	1678	2880082627000
11524	1397	1412387372000
11525	1678	2880082628000
11526	1696	4318091000000
11537	1397	1412347368000
11538	1678	2880082632000
11539	1599	11520230000000
11540	1599	11520240000000
11557	1397	1412317365000
11558	1678	2880082635000
11559	1397	1412307364000
11560	1678	2880082636000
11576	1587	8640160000000
11579	1402	30960691000000
11580	1402	30960701000000
11595	1668	10080170000000
11604	1397	1412187352000
11605	1678	2880082648000
11606	1447	7920110000000
11607	1447	7920120000000
11616	1596	9360120000000
11617	1596	9360150000000
11619	1397	1412147348000
11620	1678	2880082652000
11621	1759	8640020000000
11622	1759	8640030000000
11637	1677	122401715000000
11638	1677	122401725000000
11639	1397	1412097343000
11640	1678	2880082657000
11641	1536	10080230000000
11646	1596	9360130000000
11655	1397	1412057339000
11656	1678	2880082661000
11657	1709	8637231000000
11658	1709	8637241000000
11667	1397	1412027336000
11668	1678	2880082664000
11669	1397	1412017335000
11670	1678	2880082665000
11671	1444	10080200000000
11672	1444	10080220000000
11678	1677	123121725000000
11679	1677	123121735000000
11688	1603	10000000
11689	1610	7920180000000
11720	1714	10069060000000
11721	1714	10069080000000
11731	1397	1411857319000
11732	1678	2880082681000
11733	1688	47520082000000
11734	1688	47520092000000
11741	1536	10800230000000
11742	1536	10800250000000
11770	1397	1411767310000
11771	1678	2880082690000
11772	1683	293762018999541
11773	1683	293762028999541
11785	1762	3599060000000
11786	1762	3599080000000
11787	1397	1411717305000
11788	1678	2880082695000
11789	1559	11520230000000
11790	1559	11520240000000
11811	1397	1411657299000
11812	1678	2880082701000
11813	1397	1411647298000
11814	1678	2880082702000
11815	1690	22319591000000
11816	1690	22319611000000
11859	1397	1411527286000
11860	1678	2880082714000
11873	1699	4065980500039
11874	1699	4065990500039
11876	1397	1411487282000
11877	1678	2880082718000
11884	1666	720000000000
11885	1666	720010000000
11921	1559	12240240000000
11922	1559	12240250000000
11929	1397	1411387272000
11930	1678	2880082728000
11931	1397	1411377271000
11932	1678	2880082729000
11933	1476	8640180000000
11936	1559	12960250000000
11937	1559	12960260000000
11963	1716	10079180000000
11964	1716	10079190000000
11965	1402	33120731000000
11966	1402	33120741000000
11967	1397	1411297263000
11968	1678	2880082737000
11969	1693	8666746500877
11970	1693	8666756500877
11645	1678	2880082659000
11651	632	72480130000000
11652	632	72480140000000
11663	1397	1412037337000
11664	1678	2880082663000
11665	1684	15119320000000
11666	1684	15119330000000
11675	1397	1412007334000
11676	1678	2880082666000
11677	1683	292322008999541
11694	1397	1411967330000
11695	1678	2880082670000
11696	1397	1411957329000
11697	1678	2880082671000
11698	1677	123841735000000
11699	1677	123841755000000
11708	1677	123841745000000
11712	1397	1411917325000
11713	1678	2880082675000
11730	1695	7919061000000
11735	1397	1411847318000
11736	1678	2880082682000
11737	1397	1411837317000
11738	1678	2880082683000
11739	1717	7199210000000
11740	1717	7199230000000
11747	1397	1411817315000
11748	1678	2880082685000
11753	1684	15839330000000
11754	1684	15839340000000
11759	1397	1411787312000
11760	1678	2880082688000
11761	1397	1411777311000
11762	1678	2880082689000
11765	1547	4320030000000
11766	1547	4320050000000
11795	1681	13679315195920
11796	1681	13679325195920
11805	1397	1411677301000
11806	1678	2880082699000
11807	1397	1411667300000
11808	1678	2880082700000
11809	1714	10789080000000
11810	1714	10789100000000
11817	1397	1411637297000
11818	1678	2880082703000
11820	1397	1411627296000
11821	1678	2880082704000
11822	1397	1411617295000
11823	1678	2880082705000
11824	1402	31680721000000
11835	1397	1411587292000
11836	1678	2880082708000
11837	1749	5755088000000
11838	1759	8640029000000
11839	1764	6480018000000
11840	1722	78000000
11841	1677	126001776000000
11842	1677	126001790000000
11851	1397	1411557289000
11852	1678	2880082711000
11853	1397	1411547288000
11854	1678	2880082712000
11855	1397	1411537287000
11856	1678	2880082713000
11857	1690	23039611000000
11858	1690	23039641000000
11869	1397	1411497283000
11870	1678	2880082717000
11871	1698	11519111000000
11872	1698	11519121000000
11881	1397	1411467280000
11882	1678	2880082720000
11883	1693	7946746500877
11886	1611	4320070000000
11887	1611	4320080000000
11892	1692	30239792000000
11893	1692	30239802000000
11903	1397	1411427276000
11904	1678	2880082724000
11907	1397	1411417275000
11908	1678	2880082725000
11909	1705	7194930000000
11910	1705	7194940000000
11917	1677	128161810000000
11918	1677	128161820000000
11927	1402	32400721000000
11928	1402	32400731000000
11942	1684	16559340000000
11943	1684	16559350000000
11950	1686	3091846500013
11955	1397	1411317265000
11956	1678	2880082735000
11957	1683	298082048999541
11958	1683	298082058999541
11959	1397	1411307264000
11960	1678	2880082736000
11961	633	71758970000000
11962	633	71758980000000
11973	1618	1440010000000
11974	1618	1440020000000
11746	1672	7200130000000
11763	1643	7200170000000
11774	1397	1411757309000
11775	1678	2880082691000
11776	1397	1411747308000
11777	1678	2880082692000
11778	1601	8640201000000
11779	1601	8640221000000
11791	1397	1411707304000
11792	1678	2880082696000
11793	1509	10080220000000
11794	1509	10080230000000
11797	1397	1411697303000
11798	1678	2880082697000
11799	1683	295202028999541
11800	1683	295202038999541
11825	1714	11509100000000
11826	1714	11509120000000
11843	1397	1411577291000
11844	1678	2880082709000
11845	1692	29519782000000
11846	1692	29519792000000
11865	1397	1411507284000
11866	1678	2880082716000
11867	1677	126721790000000
11868	1677	126721800000000
11875	1717	7199220000000
11888	1397	1411457279000
11889	1678	2880082721000
11890	641	74640410000000
11891	641	74640420000000
11894	1759	7199999000000
11895	1764	5760008000000
11896	641	74640515000000
11905	1594	5760200000000
11906	1594	5760210000000
11911	1677	127441800000000
11912	1677	127441810000000
11919	1756	11519229000000
11920	1756	11519239000000
11923	1397	1411397273000
11924	1678	2880082727000
11925	1683	296642038999541
11926	1683	296642048999541
11938	1397	1411357269000
11939	1678	2880082731000
11940	1688	48240092000000
11941	1688	48240102000000
11980	1678	2880082740000
11981	1692	30239812000000
11982	1397	1411257259000
11983	1678	2880082741000
11984	1397	1411247258000
11985	1678	2880082742000
11986	1506	7200150000000
11987	1506	7200160000000
11988	1601	10080231000000
11989	1601	10080241000000
11990	1397	1411237257000
11991	1678	2880082743000
11992	1706	8636502000000
11993	1706	8636512000000
11994	1727	6479100000000
11995	1397	1411227256000
11996	1678	2880082744000
11997	1397	1411217255000
11998	1678	2880082745000
11999	1683	298082068999541
12000	1397	1411207254000
12001	1678	2880082746000
12002	1683	299522068999541
12003	1683	299522078999541
12004	1397	1411197253000
12005	1678	2880082747000
12006	1668	11520180000000
12007	1668	11520190000000
12008	1549	10080241000000
12009	1549	10080251000000
12010	1397	1411187252000
12011	1678	2880082748000
12012	1397	1411177251000
12013	1678	2880082749000
12014	1689	7919170000000
12015	1689	7919190000000
12016	1690	23759641000000
12017	1690	23759661000000
12018	1687	10079121000000
12019	1687	10079141000000
12020	1397	1411167250000
12021	1678	2880082750000
12022	1419	10800210000000
12023	1419	10800220000000
12024	1397	1411157249000
12025	1678	2880082751000
12026	1588	5760080000000
12027	1588	5760090000000
12028	1397	1411147248000
12029	1678	2880082752000
12030	1397	1411137247000
12031	1678	2880082753000
12032	1711	8639160000000
12033	1397	1411127246000
12034	1678	2880082754000
12035	1397	1411117245000
12036	1678	2880082755000
12037	369	75360170000000
12038	369	75360190000000
12039	1738	718910000000
12040	175	66000000000000
12041	1397	1411107244000
12042	1678	2880082756000
12043	1602	5760230000000
12044	1397	1411097243000
12045	1678	2880082757000
12046	1679	29520062000000
12047	1397	1411087242000
12048	1678	2880082758000
12049	1397	1411077241000
12050	1678	2880082759000
12051	1683	300962078999541
12052	1683	300962088999541
12053	1397	1411067240000
12054	1678	2880082760000
12055	1467	7201580000000
12056	1467	7201590000000
12057	1702	5754081000000
12058	1702	5754091000000
12059	1397	1411057239000
12060	1678	2880082761000
12061	1673	4320330000000
12062	1397	1411047238000
12063	1678	2880082762000
12064	1683	302402088999541
12065	1683	302402098999541
12066	1397	1411037237000
12067	1678	2880082763000
12068	1397	1411027236000
12069	1678	2880082764000
12070	1729	7919120000000
12071	1729	7919130000000
12072	1762	3599070000000
12073	1593	7920220000000
12074	1593	7920230000000
12075	1397	1411017235000
12076	1678	2880082765000
12077	1458	12240183798540
12078	1458	12240193798540
12079	1397	1411007234000
12080	1678	2880082766000
12081	1690	24479661000000
12082	1690	24479671000000
12083	1397	1410997233000
12084	1678	2880082767000
12085	1397	1410987232000
12086	1678	2880082768000
12087	1397	1410977231000
12088	1678	2880082769000
12089	1682	7907321000000
12090	1692	30959812000000
12091	1692	30959842000000
12092	1397	1410967230000
12093	1678	2880082770000
12094	1397	1410957229000
12095	1678	2880082771000
12096	1677	128161830000000
12097	1397	1410947228000
12098	1678	2880082772000
12099	1677	128881830000000
12100	1677	128881840000000
12101	1397	1410937227000
12102	1678	2880082773000
12103	1694	20159425000000
12104	1519	1439000000000
12105	1519	1439010000000
12106	1397	1410927226000
12107	1678	2880082774000
12108	1397	1410917225000
12109	1678	2880082775000
12110	1397	1410907224000
12111	1678	2880082776000
12112	58	73200160000000
12113	58	73200190000000
12114	1397	1410897223000
12115	1678	2880082777000
12116	1677	129601840000000
12117	1677	129601850000000
12118	1560	8640210000000
12119	1397	1410887222000
12120	1678	2880082778000
12121	1677	130321850000000
12122	1677	130321860000000
12123	1397	1410877221000
12124	1678	2880082779000
12125	1397	1410867220000
12126	1678	2880082780000
12127	1560	8640220000000
12128	1397	1410857219000
12129	1678	2880082781000
12130	1397	1410847218000
12131	1678	2880082782000
12132	1610	9360220000000
12133	1610	9360240000000
12134	1616	1440010000000
12135	1616	1440030000000
12136	1397	1410837217000
12137	1678	2880082783000
12138	1397	1410827216000
12139	1678	2880082784000
12140	1167	608321416666323
12141	1726	1000100000000
12142	1693	9386756500877
12143	1693	9386777500877
12144	1397	1410817215000
12145	1678	2880082785000
12146	1602	6480230000000
12147	1602	6480240000000
12148	1735	4300020000000
12149	1735	4300030000000
12150	1397	1410807214000
12151	1678	2880082786000
12152	1677	130321870000000
12153	1677	131041870000000
12154	1457	6480150000000
12155	1397	1410797213000
12156	1678	2880082787000
12157	1715	10799231000000
12158	1715	10799241000000
12159	1397	1410787212000
12160	1678	2880082788000
12161	1397	1410777211000
12162	1678	2880082789000
12163	1397	1410767210000
12164	1678	2880082790000
12165	1683	302402118999541
12187	1564	3600032000000
12188	1564	3600042000000
12205	1397	1410667200000
12206	1678	2880082800000
12207	1397	1410657199000
12208	1678	2880082801000
12209	1680	13679260000000
12210	1680	13679280000000
12219	1768	5039140000000
12220	1397	1410637197000
12221	1678	2880082803000
12222	1601	10800241000000
12223	1601	10800251000000
12231	1601	11520251000000
12232	1601	11520261000000
12239	1679	30960082000000
12240	1679	30960192000000
12262	1397	1410537187000
12263	1678	2880082813000
12272	1397	1410507184000
12273	1678	2880082816000
12274	1397	1410497183000
12275	1678	2880082817000
12276	1607	12240341000000
12277	1607	12240361000000
12279	1397	1410487182000
12280	1678	2880082818000
12287	1711	9359160000000
12288	1711	9359270000000
12303	1397	1410447178000
12304	1678	2880082822000
12305	1750	5296000000
12306	1783	100000000
12307	1683	303842109999541
12316	312	66000000000000
12317	1397	1410417175000
12318	1678	2880082825000
12319	632	72480240000000
12329	1397	1410387172000
12330	1678	2880082828000
12331	1397	1410377171000
12332	1678	2880082829000
12333	1536	11520250000000
12334	1536	11520270000000
12337	1397	1410367170000
12338	1678	2880082830000
12339	1623	12240161000000
12340	1623	12240171000000
12351	1724	10798760000000
12352	1724	10798770000000
12355	1397	1410327166000
12356	1678	2880082834000
12376	1397	1410257159000
12377	1678	2880082841000
12378	1688	51840252000000
12379	1688	51840262000000
12416	1688	52560262000000
12417	1688	52560272000000
12420	1397	1410177151000
12421	1678	2880082849000
12422	1397	1410167150000
12423	1678	2880082850000
12424	596	77520222000000
12425	596	77520242000000
12432	1397	1410127146000
12433	1678	2880082854000
12434	1677	133201890000000
12435	1677	133201900000000
12460	1489	6480121000000
12461	1489	6480231000000
12474	329	66714600000000
12475	1789	3000000000
12476	1397	1410057139000
12477	1678	2880082861000
12478	1670	12240540000000
12496	1397	1410007134000
12497	1678	2880082866000
12498	1683	308162149999541
12541	1397	1409907124000
12542	1678	2880082876000
12550	1397	1409897123000
12551	1678	2880082877000
12552	1397	1409887122000
12553	1678	2880082878000
12554	484	76800150000000
12555	484	76800171000000
12583	1458	12960193798540
12584	1458	12960213798540
12585	1726	985800000000
12586	1793	200000000
12587	1769	2981000000
12588	1406	0
12589	1397	1409827116000
12590	1678	2880082884000
12591	1397	1409817115000
12592	1678	2880082885000
12593	1397	1409807114000
12594	1678	2880082886000
12595	1769	2971000000
12596	1688	54720392000000
12597	1688	54720542000000
12620	1688	55440542000000
12621	1688	55440672000000
12624	1689	7919180000000
12643	1397	1409677101000
12644	1678	2880082899000
12657	1687	10079131000000
12658	1397	1409647098000
12659	1678	2880082902000
12660	1683	312482399999541
12661	1683	312482409999541
12672	1685	33840326000000
12673	1685	33840347000000
12674	1643	3666077263000
12675	1299	1696794610488650
12676	1643	2169419021000
12677	1053	902470023242000
12678	1643	1159711651000
12679	1173	608914357370000
12680	1643	324223113700
12681	933	503613163537300
12682	1397	1409607094000
12683	1678	2880082906000
12684	1397	1409597093000
12685	1678	2880082907000
12686	1397	1409587092000
12687	1678	2880082908000
12688	1397	1409577091000
12689	1678	2880082909000
12690	1397	1409567090000
12691	1678	2880082910000
12692	1683	313922409999541
12693	1683	313922859999541
12718	1445	8640190000000
12719	1445	8640330000000
12722	1719	5039140000000
12723	1719	5039150000000
12740	1522	5760160000000
12741	1522	5760170000000
12754	1706	8636302000000
12755	1706	8636432000000
12767	1397	1409377071000
12768	1678	2880082929000
12769	1397	1409367070000
12770	1678	2880082930000
12771	1677	136081960000000
12772	1677	136081980000000
12775	1643	1044213113700
12776	1643	1044233113700
12807	1397	1409287062000
12808	1678	2880082938000
12809	1671	9360850000000
12810	1671	9360860000000
12825	1726	980600000000
12826	1797	200000000
12827	1397	1409237057000
12828	1678	2880082943000
12829	1677	136801970000000
12830	1677	136802080000000
12832	470	76800381000000
12845	1397	1409207054000
12846	1678	2880082946000
12847	1573	8640120000000
12848	1573	8640130000000
12880	1397	1409117045000
12881	1678	2880082955000
12882	1683	319682909999541
12883	1683	319682919999541
12900	1447	8640130000000
12928	1397	1409027036000
12929	1678	2880082964000
12930	1677	138962110000000
12931	1677	138962120000000
12962	1397	1408947028000
12963	1678	2880082972000
12964	1397	1408937027000
12965	1678	2880082973000
12974	1397	1408907024000
12975	1678	2880082976000
12976	1458	13680213798540
12977	1458	13680223798540
12978	1397	1408897023000
12979	1678	2880082977000
12980	1677	139682140000000
12166	1759	9360029000000
12167	1759	9360059000000
12168	1397	1410757209000
12169	1678	2880082791000
12170	1677	131041860000000
12197	1397	1410687202000
12198	1678	2880082798000
12199	1764	7200018000000
12200	1764	7200028000000
12211	1451	5040170000000
12212	1451	5040190000000
12241	1726	997500000000
12242	1782	200000000
12243	1397	1410597193000
12244	1678	2880082807000
12245	1397	1410587192000
12246	1678	2880082808000
12247	1397	1410577191000
12248	1678	2880082809000
12249	1397	1410567190000
12250	1678	2880082810000
12251	1673	5040330000000
12252	1673	5040470000000
12255	1397	1410557189000
12256	1678	2880082811000
12257	1541	4317098000000
12258	1541	4317108000000
12294	348	66000900000000
12295	1397	1410467180000
12296	1678	2880082820000
12297	1688	48960102000000
12298	1688	48960212000000
12308	1397	1410437177000
12309	1678	2880082823000
12314	1657	5760100000000
12315	1657	5760110000000
12357	1397	1410317165000
12358	1678	2880082835000
12359	1397	1410307164000
12360	1678	2880082836000
12361	1670	12240450000000
12368	1397	1410277161000
12369	1678	2880082839000
12370	1688	51120242000000
12371	1688	51120252000000
12404	1671	8640220000000
12405	1671	8640850000000
12428	1397	1410147148000
12429	1678	2880082852000
12430	1397	1410137147000
12431	1678	2880082853000
12454	1726	989700000000
12455	1790	200000000
12456	1397	1410097143000
12457	1678	2880082857000
12458	1522	5040050000000
12459	1522	5040160000000
12462	1397	1410087142000
12463	1678	2880082858000
12473	1714	11509110000000
12481	1683	308162249999541
12482	1397	1410047138000
12483	1678	2880082862000
12484	1677	134641910000000
12485	1677	134641920000000
12486	1397	1410037137000
12487	1678	2880082863000
12488	1397	1410027136000
12489	1678	2880082864000
12490	1397	1410017135000
12491	1678	2880082865000
12492	1775	1944000000
12493	1521	1437080000000
12494	1509	10800230000000
12495	1509	10800261000000
12509	1397	1409977131000
12510	1678	2880082869000
12511	1688	54000382000000
12512	1688	54000392000000
12515	1397	1409967130000
12516	1678	2880082870000
12517	1668	12240190000000
12518	1668	12240200000000
12519	1397	1409957129000
12520	1678	2880082871000
12521	1397	1409947128000
12522	1678	2880082872000
12523	1397	1409937127000
12524	1678	2880082873000
12525	1683	309602149999541
12526	1683	309602179999541
12529	329	66004590000000
12530	1789	713000000000
12531	1397	1409927126000
12532	1678	2880082874000
12533	369	76080210000000
12543	1769	2993000000
12544	1701	9358301000000
12545	1701	9358302000000
12567	1683	309602399999541
12568	1683	311042399999541
12575	632	73920250000000
12576	632	73920261000000
12604	1397	1409787112000
12605	1678	2880082888000
12606	1397	1409777111000
12607	1678	2880082889000
12608	1546	10800160000000
12609	1546	10800180000000
12627	1726	983200000000
12628	1795	200000000
12629	1397	1409727106000
12630	1678	2880082894000
12631	1397	1409717105000
12632	1678	2880082895000
12633	1397	1409707104000
12634	1678	2880082896000
12635	1397	1409697103000
12636	1678	2880082897000
12637	1688	56880682000000
12638	1688	56880822000000
12640	1700	7199440000000
12649	1549	10800251000000
12650	1549	10800261000000
12652	1397	1409657099000
12653	1678	2880082901000
12654	1602	7200240000000
12655	1602	7200250000000
12670	44	71760200000000
12697	1451	5040180000000
12726	1685	34560347000000
12727	1685	34560757000000
12730	1623	13680181000000
12731	1623	13680191000000
12732	1397	1409457079000
12733	1678	2880082921000
12734	1696	5038091000000
12735	1696	5038101000000
12758	1687	10079251000000
12773	369	76800210000000
12774	369	76800230000000
12777	1397	1409357069000
12778	1678	2880082931000
12779	1397	1409347068000
12780	1678	2880082932000
12781	1397	1409337067000
12782	1678	2880082933000
12783	1654	7200140000000
12790	1397	1409317065000
12791	1678	2880082935000
12792	1714	12229120000000
12797	1559	12240260000000
12798	1761	12960268299999
12799	1559	10000001
12800	1460	1700000
12802	1397	1409297063000
12803	1678	2880082937000
12805	1683	316802879999541
12806	1683	316802889999541
12811	1699	5506010500039
12812	1699	5506020500039
12819	1397	1409257059000
12820	1678	2880082941000
12821	1677	136081970000000
12831	1426	5040190000000
12833	1710	7922349000000
12834	1710	8642349000000
12835	1710	8642742000000
12839	1397	1409217055000
12840	1678	2880082945000
12841	1683	318242889999541
12842	1683	318242909999541
12873	1397	1409137047000
12874	1678	2880082953000
12875	1688	57600822000000
12876	1688	57600832000000
12884	1726	979300000000
12885	1798	200000000
12886	1397	1409107044000
12887	1678	2880082956000
12888	1686	3811846500013
12889	1686	3811956500013
12894	576	73200100000000
12895	576	73200110000000
12918	1397	1409047038000
12171	1397	1410747208000
12172	1678	2880082792000
12173	1397	1410737207000
12174	1678	2880082793000
12175	1677	131761870000000
12176	1677	131761880000000
12183	1397	1410707204000
12184	1678	2880082796000
12185	1677	132481880000000
12186	1677	132481890000000
12189	1397	1410697203000
12190	1678	2880082797000
12191	1471	6480100000000
12192	1471	6480110000000
12193	633	72478980000000
12194	633	72478990000000
12195	42	71760190000000
12196	42	71760200000000
12213	1701	8638281000000
12214	1701	8638301000000
12215	1397	1410647198000
12216	1678	2880082802000
12217	1457	7920150000000
12218	1457	7920160000000
12224	1397	1410627196000
12225	1678	2880082804000
12226	1607	11520331000000
12227	1607	11520341000000
12233	1726	998800000000
12234	1758	1600400000
12235	1397	1410607194000
12236	1678	2880082806000
12237	44	71760180000000
12238	44	71760290000000
12253	1615	720000000000
12254	1615	720140000000
12259	1397	1410547188000
12260	1678	2880082812000
12261	1522	4320050000000
12266	1397	1410527186000
12267	1678	2880082814000
12268	1397	1410517185000
12269	1678	2880082815000
12270	1541	5037108000000
12271	1541	5037128000000
12283	11	4651900000000
12284	1397	1410477181000
12285	1678	2880082819000
12286	1683	303842208999541
12291	1685	32399710000000
12292	1685	32399911000000
12310	1397	1410427176000
12311	1678	2880082824000
12312	1684	17279350000000
12313	1684	17279360000000
12323	1397	1410407174000
12324	1678	2880082826000
12325	1397	1410397173000
12326	1678	2880082827000
12327	1607	12960361000000
12328	1607	12960381000000
12335	1688	50400222000000
12336	1688	50400242000000
12341	1397	1410357169000
12342	1678	2880082831000
12343	1397	1410347168000
12344	1678	2880082832000
12345	1683	305282109999541
12346	1683	305282129999541
12362	1690	25919681000000
12363	1690	25919701000000
12372	1397	1410267160000
12373	1678	2880082840000
12374	1683	306722129999541
12375	1683	306722139999541
12380	369	76080190000000
12381	369	76080200000000
12406	1397	1410207154000
12407	1678	2880082846000
12408	1397	1410197153000
12409	1678	2880082847000
12410	1683	308162139999541
12411	1683	308162159999541
12414	1397	1410187152000
12415	1678	2880082848000
12418	1690	26639701000000
12419	1690	26639711000000
12440	1677	133921900000000
12441	1677	133921910000000
12444	1764	7920028000000
12445	1764	7920038000000
12448	1749	6475088000000
12449	1749	6475098000000
12464	1715	11519241000000
12465	1715	11519251000000
12467	1397	1410077141000
12468	1678	2880082859000
12503	1397	1409987132000
12504	1678	2880082868000
12505	1677	135361920000000
12506	1677	135361930000000
12527	1457	9360170000000
12528	1457	9360200000000
12539	1710	7920690000000
12540	1710	7921529000000
12546	1769	2991000000
12547	1474	7914113000000
12548	1685	33119911000000
12549	1685	33120326000000
12557	1726	988400000000
12558	1791	200000000
12559	1726	987100000000
12560	1792	200000000
12561	1397	1409877121000
12562	1678	2880082879000
12563	1397	1409867120000
12564	1678	2880082880000
12565	1688	54000612000000
12566	1688	54720612000000
12569	1397	1409857119000
12570	1678	2880082881000
12571	1779	0
12572	1754	7996000000
12573	1656	12240291000000
12574	1656	12240302000000
12600	1397	1409797113000
12601	1678	2880082887000
12602	1623	12960171000000
12603	1623	12960181000000
12611	1726	984500000000
12612	1794	200000000
12613	1397	1409767110000
12614	1678	2880082890000
12615	1397	1409757109000
12616	1678	2880082891000
12617	1397	1409747108000
12618	1678	2880082892000
12619	1677	135362050000000
12622	1397	1409737107000
12623	1678	2880082893000
12625	1688	56160672000000
12626	1688	56160682000000
12639	1700	7199560000000
12645	1397	1409667100000
12646	1678	2880082900000
12647	1431	720000000000
12648	1431	720010000000
12651	606	73200140000000
12656	1680	13679270000000
12666	1397	1409627096000
12667	1678	2880082904000
12668	1397	1409617095000
12669	1678	2880082905000
12671	1448	7200250000000
12696	1571	7920121000008
12724	1397	1409467080000
12725	1678	2880082920000
12728	1573	7920110000000
12729	1573	7920120000000
12747	1706	7916302000000
12748	1737	1300001100
12749	1397	1409427076000
12750	1678	2880082924000
12751	1397	1409417075000
12752	1678	2880082925000
12753	1444	10800350000000
12756	1716	10799190000000
12757	1716	10799320000000
12765	1397	1409387072000
12766	1678	2880082928000
12788	58	73920190000000
12789	58	73920200000000
12793	1397	1409307064000
12794	1678	2880082936000
12795	1693	11546797500877
12796	1693	11546807500877
12801	1559	12960270000000
12804	1695	7919051000000
12813	1397	1409277061000
12814	1678	2880082939000
12815	1397	1409267060000
12816	1678	2880082940000
12817	1684	18719500000000
12818	1684	18719520000000
12836	1397	1409227056000
12177	1397	1410727206000
12178	1678	2880082794000
12179	1397	1410717205000
12180	1678	2880082795000
12181	1679	30240062000000
12182	1679	30240082000000
12201	1397	1410677201000
12202	1678	2880082799000
12203	1476	9360180000000
12204	1476	9360190000000
12228	1397	1410617195000
12229	1678	2880082805000
12230	1610	9360230000000
12264	1690	25199671000000
12265	1690	25199681000000
12278	1402	33120751000000
12281	1683	303842098999541
12282	1683	303842108999541
12289	1693	10106777500877
12290	1693	10106887500877
12293	1555	5760170000000
12299	1397	1410457179000
12300	1678	2880082821000
12301	1688	49680212000000
12302	1688	49680222000000
12320	1710	6480570000000
12321	1710	7200570000000
12322	1710	7200690000000
12347	1397	1410337167000
12348	1678	2880082833000
12349	1608	7200110000000
12350	1608	7200120000000
12353	149	71760120000000
12354	149	71760130000000
12364	1397	1410297163000
12365	1678	2880082837000
12366	1397	1410287162000
12367	1678	2880082838000
12382	1397	1410247158000
12383	1678	2880082842000
12384	1693	10106787500877
12385	1726	996200000000
12386	1784	200000000
12387	1726	994900000000
12388	1785	200000000
12389	1726	993600000000
12390	1786	200000000
12391	1726	992300000000
12392	1787	200000000
12393	1726	991000000000
12394	1788	200000000
12395	329	66717700000000
12396	1789	0
12397	1397	1410237157000
12398	1678	2880082843000
12399	1397	1410227156000
12400	1678	2880082844000
12401	1397	1410217155000
12402	1678	2880082845000
12403	1729	7919750000000
12412	1699	4785990500039
12413	1699	4786010500039
12426	1397	1410157149000
12427	1678	2880082851000
12436	1397	1410117145000
12437	1678	2880082855000
12438	1423	2160040000000
12439	1423	2160050000000
12442	484	76080140000000
12443	484	76080150000000
12446	1759	10080059000000
12447	1759	10080069000000
12450	1397	1410107144000
12451	1678	2880082856000
12452	1560	9360220000000
12453	1560	9360230000000
12466	44	71760190000000
12469	1397	1410067140000
12470	1678	2880082860000
12471	1681	14399325195920
12472	1681	14399335195920
12479	1688	53280272000000
12480	1688	53280382000000
12499	1397	1409997133000
12500	1678	2880082867000
12501	632	73200240000000
12502	632	73200250000000
12507	1457	8640160000000
12508	1457	8640170000000
12513	1682	8627321000000
12514	1682	8627331000000
12534	1397	1409917125000
12535	1678	2880082875000
12536	1769	2994000000
12537	1607	13680381000000
12538	1607	13680392000000
12556	1690	26639722000000
12577	1397	1409847118000
12578	1678	2880082882000
12579	1397	1409837117000
12580	1678	2880082883000
12581	1422	5040050000000
12582	1422	5040070000000
12598	1594	6480210000000
12599	1594	6480360000000
12610	1594	6480230000000
12641	1397	1409687102000
12642	1678	2880082898000
12662	1397	1409637097000
12663	1678	2880082903000
12664	1693	10826787500877
12665	1693	10826797500877
12694	1397	1409557089000
12695	1678	2880082911000
12698	1397	1409547088000
12699	1678	2880082912000
12700	1397	1409537087000
12701	1678	2880082913000
12702	1397	1409527086000
12703	1678	2880082914000
12704	1643	324213113700
12705	1677	135361960000000
12706	1726	981900000000
12707	1796	200000000
12708	1397	1409517085000
12709	1678	2880082915000
12710	1397	1409507084000
12711	1678	2880082916000
12712	1397	1409497083000
12713	1678	2880082917000
12714	1397	1409487082000
12715	1678	2880082918000
12716	1684	17999360000000
12717	1684	17999500000000
12720	1397	1409477081000
12721	1678	2880082919000
12736	1397	1409447078000
12737	1678	2880082922000
12738	1444	10800220000000
12739	1444	10800230000000
12742	1599	11521340000000
12743	1397	1409437077000
12744	1678	2880082923000
12745	1599	12241340000000
12746	1599	12241445000000
12759	1397	1409407074000
12760	1678	2880082926000
12761	1397	1409397073000
12762	1678	2880082927000
12763	1683	315362859999541
12764	1683	315362879999541
12784	1397	1409327066000
12785	1678	2880082934000
12786	1560	10080230000000
12787	1560	10080240000000
12822	1397	1409247058000
12823	1678	2880082942000
12824	1536	11520260000000
12843	1447	8640120000000
12844	1447	8640140000000
12849	1397	1409197053000
12850	1678	2880082947000
12851	1677	136801980000000
12856	1397	1409177051000
12857	1678	2880082949000
12858	1397	1409167050000
12859	1678	2880082950000
12860	1397	1409157049000
12861	1678	2880082951000
12862	1668	12960200000000
12863	1668	12960230000000
12866	1419	10800240000000
12868	1759	10080089000000
12877	1397	1409127046000
12878	1678	2880082954000
12879	1700	7199430000000
12896	1397	1409087042000
12897	1678	2880082958000
12898	1677	137521980000000
12899	1677	137521990000000
12906	1397	1409067040000
12907	1678	2880082960000
12908	1726	976700000000
12909	1800	200000000
12910	1397	1409057039000
12837	1678	2880082944000
12838	470	76800391000000
12852	1397	1409187052000
12853	1678	2880082948000
12854	1717	7919220000000
12855	1717	7919230000000
12864	1672	7920130000000
12865	1672	7920160000000
12867	1764	7920058000000
12869	1397	1409147048000
12870	1678	2880082952000
12871	1402	33840751000000
12872	1402	33840761000000
12890	1397	1409097043000
12891	1678	2880082957000
12892	1696	5758101000000
12893	1696	5758111000000
12901	1726	978000000000
12902	1799	200000000
12903	1397	1409077041000
12904	1678	2880082959000
12905	1677	137522090000000
12914	171	74640330000000
12915	171	75360330000000
12916	45	75362369999990
12917	171	66000000001050
12922	1397	1409037037000
12923	1678	2880082963000
12924	1693	11546697500877
12925	636	66000100000000
12926	1677	138242090000000
12927	1677	138242110000000
12937	1693	12266697500877
12938	1693	12266717500877
12948	1397	1408967030000
12949	1678	2880082970000
12950	1683	322563029999541
12951	1683	322563039999541
12954	1692	31679812000000
12955	1692	31679822000000
12969	1397	1408927026000
12970	1678	2880082974000
12971	1397	1408917025000
12972	1678	2880082975000
12973	1715	11519261000000
13000	1397	1408847018000
13001	1678	2880082982000
13011	1397	1408807014000
13012	1678	2880082986000
13013	1709	9357241000000
13014	1709	9357251000000
13022	1522	6480170000000
13023	1522	6480180000000
13026	171	75362389999990
13027	171	76082389999990
13028	171	76083619999990
13060	1397	1408687002000
13061	1678	2880082998000
13080	1397	1408636997000
13081	1678	2880083003000
13082	1683	324003039999541
13083	1683	324003049999541
13092	1397	1408606994000
13093	1678	2880083006000
13094	1444	12240360000000
13095	1444	12240370000000
13098	1692	33119832000000
13099	1692	33119842000000
13116	1397	1408556989000
13117	1678	2880083111000
13118	1696	6478111000000
13119	1696	6478121000000
13134	1397	1408516985000
13135	1678	2880083115000
13136	1706	8636312000000
12911	1678	2880082961000
12912	1683	321122919999541
12913	1683	321123029999541
12941	1397	1408997033000
12942	1678	2880082967000
12943	1397	1408987032000
12944	1678	2880082968000
12945	1397	1408977031000
12946	1678	2880082969000
12947	1677	138962140000000
12960	1692	32399822000000
12961	1692	32399832000000
12982	1602	7920250000000
12983	1602	7920260000000
12988	43	72480150000000
12989	43	72480160000000
12994	1397	1408867020000
12995	1678	2880082980000
12996	1397	1408857019000
12997	1678	2880082981000
12998	1633	6480070000000
12999	1633	6480090000000
13037	1397	1408757009000
13038	1678	2880082991000
13039	606	73920140000000
13040	606	73920150000000
13051	1397	1408707004000
13052	1678	2880082996000
13053	1668	13680230000000
13054	1668	13680240000000
13055	1726	975400000000
13056	1802	200000000
13057	1397	1408697003000
13058	1678	2880082997000
13059	576	73200210000000
13066	1564	4320042000000
13067	1564	4320052000000
13070	1654	8640160000000
13090	1560	10800240000000
13091	1560	10800260000000
13122	1397	1408546988000
13123	1678	2880083112000
13124	1677	141842170000000
13125	1677	141842180000000
13126	606	74640150000000
13127	606	74640160000000
13130	1695	8639151000000
13131	1695	8639161000000
13141	1397	1408496983000
13142	1678	2880083117000
13143	1683	326883059999541
13144	1683	326883069999541
13146	1749	7195098000000
13147	1749	7195108000000
13156	1678	2880083052000
13157	1678	2880083053000
13158	1678	2880083054000
13159	1678	2880083055000
13160	1678	2880083056000
13161	1678	2880083057000
13162	1678	2880083058000
13163	1678	2880083059000
13164	1678	2880083060000
13165	1678	2880083061000
13166	1678	2880083062000
13167	1678	2880083063000
13168	1678	2880083064000
13169	1678	2880083065000
13170	1678	2880083066000
13171	1678	2880083067000
13172	1678	2880083068000
13173	1678	2880083069000
13174	1678	2880083070000
13175	1678	2880083071000
13176	1678	2880083072000
13177	1678	2880083073000
13178	1678	2880083074000
13179	1678	2880083075000
13180	1678	2880083076000
13181	1678	2880083077000
13182	1678	2880083078000
13183	1678	2880083079000
13184	1678	2880083080000
13185	1678	2880083081000
13186	1678	2880083082000
13187	1678	2880083083000
13188	1678	2880083084000
13189	1678	2880083085000
13190	1678	2880083086000
13191	1678	2880083087000
13192	1678	2880083088000
13193	1678	2880083089000
13194	1678	2880083090000
13195	1678	2880083091000
13196	1678	2880083092000
13197	1678	2880083093000
13198	1678	2880083094000
13199	1678	2880083095000
13200	1678	2880083096000
13201	1678	2880083097000
13202	1678	2880083098000
13203	1678	2880083099000
13204	1678	2880083100000
13205	1678	2880083101000
13206	1678	2880083102000
13207	1678	2880083103000
13208	1678	2880083104000
13209	1678	2880083105000
13210	1678	2880083106000
13211	1678	2880083107000
13212	1476	10081410000000
13221	1402	34560761000000
13222	1402	34560791000000
13233	576	73920290000000
12919	1678	2880082962000
12920	1654	7920140000000
12921	1654	7920150000000
12932	1397	1409017035000
12933	1678	2880082965000
12934	1397	1409007034000
12935	1678	2880082966000
12936	1672	7920150000000
12939	1739	6479290000000
12940	1739	6479310000000
12952	1607	14400392000000
12953	1607	14400402000000
12956	1397	1408957029000
12957	1678	2880082971000
12958	1434	1439100000000
12959	1434	1439110000000
12966	1693	7226626500877
12967	1685	35280757000000
12968	1685	35280867000000
12984	1397	1408887022000
12985	1678	2880082978000
12986	1474	8634113000000
12987	1474	8634123000000
12990	1397	1408877021000
12991	1678	2880082979000
12992	1444	11520350000000
12993	1444	11520360000000
13017	1422	5040060000000
13018	1397	1408797013000
13019	1678	2880082987000
13020	1688	59040832000000
13021	1688	59040842000000
13024	1693	9386667500877
13025	641	74643266000000
13029	1397	1408787012000
13030	1678	2880082988000
13031	1397	1408777011000
13032	1678	2880082989000
13033	1397	1408767010000
13034	1678	2880082990000
13035	1801	719000000000
13036	1801	719030000000
13042	1397	1408747008000
13043	1678	2880082992000
13044	1397	1408737007000
13045	1678	2880082993000
13046	1397	1408727006000
13047	1678	2880082994000
13048	1397	1408717005000
13049	1678	2880082995000
13050	1762	3599100000000
13062	1397	1408677001000
13063	1678	2880082999000
13064	1677	141122160000000
13065	1677	141122170000000
13076	1397	1408646998000
13077	1678	2880083002000
13078	1571	8640121000008
13079	1571	8640131000008
13096	1683	325443049999541
13097	1683	325443059999541
13112	1397	1408566990000
13113	1678	2880083110000
13114	1509	11520261000000
13115	1509	11520271000000
13120	1701	10078302000000
13121	1701	10078312000000
13132	1397	1408526986000
13133	1678	2880083114000
13148	1397	1408486982000
13149	1678	2880083118000
13150	1680	14399270000000
13151	1680	14399290000000
13152	1397	1408476981000
13153	1678	2880083119000
13154	1476	10080190000000
13155	1476	10080200000000
12981	1677	139682150000000
13002	1688	58320832000000
13003	1397	1408837017000
13004	1678	2880082983000
13005	1397	1408827016000
13006	1678	2880082984000
13007	1397	1408817015000
13008	1678	2880082985000
13009	1654	8640150000000
13010	1654	8640180000000
13015	1677	140402150000000
13016	1677	140402160000000
13041	1685	36000867000000
13068	1397	1408667000000
13069	1678	2880083000000
13071	1726	974100000000
13072	1803	200000000
13073	1397	1408656999000
13074	1678	2880083001000
13075	1695	7919151000000
13084	1397	1408626996000
13085	1678	2880083004000
13086	1397	1408616995000
13087	1678	2880083005000
13088	1536	12240260000000
13089	1536	12240280000000
13100	1397	1408596993000
13101	1678	2880083007000
13102	1397	1408586992000
13103	1678	2880083008000
13104	1769	2960900000
13105	1678	2880083108000
13106	1769	2950900000
13107	1407	0
13108	1397	1408576991000
13109	1678	2880083109000
13110	1426	5760190000000
13111	1426	5760240000000
13128	1397	1408536987000
13129	1678	2880083113000
13137	1397	1408506984000
13138	1678	2880083116000
13139	1419	11520240000000
13140	1419	11520250000000
13145	1489	6480131000000
13213	1601	8393676900000
13214	1388	1697107201851650
13215	1693	12200337731495
13216	569	66153481816426
13217	1397	1408466980000
13218	1678	2880083120000
13219	1677	142562180000000
13220	1677	142562210000000
13223	1693	12198316526375
13224	745	2004650964107
13225	1693	12131936756993
13226	225	66153481816426
13227	1397	1408456979000
13228	1678	2880083121000
13229	1693	12065556987611
13230	191	66153481816426
13231	576	73920210000000
13232	576	73920250000000
13234	1601	6730862800000
13235	1142	902636269100000
13236	1601	5609092700000
13237	1262	609026510100000
13238	1397	1408446978000
13239	1678	2880083122000
13240	1693	11999177218229
13241	304	66153481816426
13242	1693	11932797448847
13243	373	66153481816426
13244	1693	11728596663372
13245	877	203265353117107
13246	1693	11662216893990
13247	217	66153481816426
13248	1693	11595837124608
13249	309	66153481816426
13250	1693	11593815919488
13251	731	2004650964107
13252	1693	11527436150106
13253	275	66153481816426
13254	1693	11461056380724
13255	138	66153481816426
13256	1693	10555037196324
13257	1030	903068611238925
13258	1690	27359711000000
13259	1690	27359831000000
13260	1693	10488657426942
13261	205	66153481816426
13262	1601	4680894600000
13263	1022	503705963100000
13264	1693	10422277657560
13265	402	66153481816426
13266	1397	1408436977000
13267	1678	2880083123000
13268	1693	10355897888178
13269	397	66153481816426
13270	1693	10289518118796
13271	690	66153481816426
13272	1677	141842240000000
13273	1693	9980966206435
13274	894	307536427785643
13275	1693	9914586437053
13276	106	66153481816426
13277	1693	9848206667671
13278	534	66153481816426
13279	1693	9841462147296
13280	5	6712573753375
13281	1693	9775082377914
13282	339	66153481816426
13283	1677	142562240000000
13284	1677	142562290000000
13285	1686	4531956500013
13286	1686	4532006500013
13287	1686	3812016500013
13288	1686	4532016500013
13289	1686	4532066500013
13290	1397	1408426976000
13291	1678	2880083124000
13292	1693	9708702608532
13293	206	66153481816426
13294	1693	9642322839150
13295	122	66153481816426
13296	1693	9575943069768
13297	91	66153481816426
13298	1693	9509563300386
13299	99	66153481816426
13300	1693	9443183531004
13301	399	66153481816426
13302	1693	9376803761622
13303	408	66153481816426
13304	1693	9310423992240
13305	420	66153481816426
13306	1693	9244044222858
13307	438	66153481816426
13308	1693	9177664453476
13309	570	66153481816426
13310	1443	100000000000
13311	632	74540261000000
13312	632	74540361000000
13313	632	74640261000000
13314	632	74640361000000
13315	1397	1408416975000
13316	1678	2880083125000
13317	1693	9111284684094
13318	105	66153481816426
13319	1693	8605686784398
13320	910	503946947018047
13321	1693	8539307015016
13322	322	66153481816426
13323	1693	8532257797056
13324	29	7016278374459
13325	1693	8465878027674
13326	92	66153481816426
13327	1693	8399498258292
13328	89	66153481816426
13329	1693	8333118488910
13330	146	66153481816426
13331	1693	8266738719528
13332	251	66153481816426
13333	1693	8200358950146
13334	500	66153481816426
13335	1677	143282290000000
13336	1677	143282390000000
13337	1471	6480200000000
13338	1683	326883159999541
13339	1693	8133979180764
13340	395	66150451816426
13341	1397	1408406974000
13342	1678	2880083126000
13343	1693	8067599411382
13344	84	66153481816426
13345	1693	8001219642000
13346	320	66153481816426
13347	1693	7934839872618
13348	587	66153481816426
13349	1693	7868460103236
13350	611	66153481816426
13351	1693	7802080333854
13352	678	66153481816426
13353	1693	7797042321028
13354	710	5011627410323
13355	1693	7730662551646
13356	295	66153481816426
13357	1693	7728641346526
13358	721	2004650964107
13359	1672	8640150000000
13360	1672	8640250000000
13362	1397	1408396973000
13363	1678	2880083127000
13364	1693	7662261577144
13365	392	66153481816426
13366	1693	7595881807762
13367	560	66153481816426
13368	1693	7529502038380
13369	194	66153481816426
13370	1693	7463122268998
13371	252	66153481816426
13372	1693	7396742499616
13373	150	66153481816426
13374	1693	7330362730234
13375	450	66153481816426
13376	1693	7263982960852
13377	653	66153481816426
13378	1693	7197603191470
13379	421	66153481816426
13380	1677	144002390000000
13381	1677	144002480000000
13383	1678	2880083038000
13384	1678	2880083039000
13385	1678	2880083040000
13386	1678	2880083041000
13387	1678	2880083042000
13388	1678	2880083043000
13389	1678	2880083044000
13390	1678	2880083045000
13391	1678	2880083046000
13392	1678	2880083047000
13393	1678	2880083048000
13394	1678	2880083049000
13395	1678	2880083050000
13396	1678	2880083051000
13397	1693	10826687500877
13398	1693	10760307731495
13399	1693	10758286526375
13400	1693	10691906756993
13401	1693	10625526987611
13402	1693	10559147218229
13403	1693	10492767448847
13404	1693	10288566663372
13405	1693	10222186893990
13406	1693	10155807124608
13407	1693	10153785919488
13408	1693	10087406150106
13409	1693	10021026380724
13410	1693	9115007196324
13411	1693	9048627426942
13412	1693	8982247657560
13413	1693	8915867888178
13414	1693	8849488118796
13415	1693	8540936206435
13416	1693	8474556437053
13417	1693	8408176667671
13418	1693	8401432147296
13419	1693	8335052377914
13420	1693	8268672608532
13421	1693	8202292839150
13422	1693	8135913069768
13423	1693	8069533300386
13424	1693	8003153531004
13425	1693	7936773761622
13426	1693	7870393992240
13427	1693	7804014222858
13428	1693	7737634453476
13429	1693	7671254684094
13430	1693	7165656784398
13431	1693	7099277015016
13432	1693	7092227797056
13433	1693	7025848027674
13434	369	76081970000000
13435	369	76801970000000
13436	369	76802000000000
13479	1693	5482073762069
13480	658	66153481816426
13481	1693	3778615130549
13482	1276	1697919862712040
13483	1693	3712235361167
13484	180	66153481816426
13485	1397	1408366970000
13486	1678	2880083130000
13487	1693	3645855591785
13488	652	66153481816426
13489	1693	3337303679424
13490	893	307536427785643
13491	1693	3270923910042
13492	390	66153481816426
13493	1693	3204544140660
13494	353	66153481816426
13495	1693	3138164371278
13496	108	66153481816426
13497	1693	3071784601896
13498	601	66153481816426
13588	1560	11520260000000
13589	1560	11520323000000
13590	1726	967600000000
13591	1807	200000000
13592	1693	321411551364
13593	1778	1000090000000
13594	1397	1408276961000
13595	1678	2880083139000
13596	1690	28079831000000
13597	1690	28079951000000
13605	1397	1408246958000
13606	1678	2880083142000
13607	1693	1041411551364
13608	1693	1041421551364
13620	1513	3600040000000
13621	1513	3600050000000
13624	576	74640250000000
13625	576	74640260000000
13636	633	73198990000000
13637	633	73199120000000
13643	1455	5760091000000
13644	1455	5760111000000
13653	1683	328323179999541
13656	1397	1408126946000
13657	1678	2880083154000
13660	1726	963700000000
13661	1810	200000000
13662	1726	962400000000
13663	1804	1400000000
13664	1397	1408116945000
13665	1678	2880083155000
13666	1693	1040311551364
13667	1811	100000000
13668	1677	146882593000000
13669	1677	146882813000000
13680	1688	59760932000000
13681	1688	59760943000000
13695	1397	1408076941000
13696	1678	2880083159000
13697	1811	90000000
13698	1679	31680192000000
13699	1679	31680212000000
13715	1397	1408026936000
13716	1678	2880083164000
13717	1656	12240301000000
13831	1692	33839942000000
13846	1726	957200000000
13847	96	66001200000000
13848	1397	1407956929000
13849	1678	2880083171000
13850	1397	1407946928000
13851	1678	2880083172000
13852	1693	1760311551364
13853	1693	1760431551364
13881	1727	6479200000000
13882	1397	1407866920000
13883	1678	2880083180000
13884	1727	7199200000000
13885	1727	7199220000000
13890	1397	1407856919000
13891	1678	2880083181000
13892	1679	32400212000000
13893	1679	32400222000000
13904	1397	1407826916000
13905	1678	2880083184000
13906	1677	148322633000000
13907	1677	148322643000000
13912	1692	34559942000000
13913	1692	34559952000000
13926	1759	10800169000000
13927	1759	10800199000000
13940	1476	10800200000000
13941	1476	10800340000000
13943	1675	5040120000000
13961	1690	28799951000000
13962	1690	28799971000000
13966	1397	1407706904000
13967	1678	2880083196000
13968	1677	149042643000000
13969	1677	149042653000000
13970	1680	14399280000000
13973	1811	150100000000
13974	1693	1039201551364
13975	1811	303100000000
13976	1811	303090000000
13977	1811	326090000000
13361	58	73920290000000
13382	369	76800300000000
13499	1397	1408356969000
13500	1678	2880083131000
13501	1693	3005404832514
13502	352	66153481816426
13503	1693	2939025063132
13504	266	66153481816426
13505	1693	2872645293750
13506	600	66153481816426
13507	1693	2806265524368
13508	691	66153481816426
13509	1693	2739885754986
13510	377	66153481816426
13511	1693	2673505985604
13512	63	66153481816426
13513	1693	2607126216222
13514	103	66153481816426
13515	1693	2540746446840
13516	361	66153481816426
13517	1693	2474366677458
13518	82	66153481816426
13519	1683	328323159999541
13520	1683	328323259999541
13568	1693	1454291090128
13569	878	203266353117107
13570	1706	8636412000000
13571	1693	1387911320746
13572	41	66153481816426
13573	1693	1321531551364
13574	308	66153481816426
13575	1706	9356412000000
13576	1706	9356432000000
13577	1397	1408296963000
13578	1678	2880083137000
13579	1397	1408286962000
13580	1678	2880083138000
13581	1693	1321421551364
13582	237	66000100000000
13583	1769	2949900000
13584	1769	2948900000
13585	1769	2947900000
13586	1677	144722490000000
13587	1677	144722553000000
13609	1726	966300000000
13610	1808	200000000
13611	1759	10080999000000
13622	1397	1408206954000
13623	1678	2880083146000
13626	576	74641053000000
13638	1397	1408176951000
13639	1678	2880083149000
13640	1397	1408166950000
13641	1678	2880083150000
13642	1634	9360180000000
13645	1692	33839932000000
13646	1692	33839952000000
13658	633	73919120000000
13659	633	73919130000000
13692	1397	1408086942000
13693	1678	2880083158000
13694	1677	146882603000000
13708	1726	961100000000
13709	1813	200000000
13710	1397	1408046938000
13711	1678	2880083162000
13712	1397	1408036937000
13713	1678	2880083163000
13714	1649	8640280999992
13726	1693	10106677500877
13727	1693	10040297731495
13728	1693	10038276526375
13729	1693	9971896756993
13730	1693	9905516987611
13731	1693	9839137218229
13732	1693	9772757448847
13733	1693	9568556663372
13734	1693	9502176893990
13735	1693	9435797124608
13736	1693	9433775919488
13737	1693	9367396150106
13738	1693	9301016380724
13739	1693	8394997196324
13740	1693	8328617426942
13741	1693	8262237657560
13742	1693	8195857888178
13743	1693	8129478118796
13744	1693	7820926206435
13745	1693	7754546437053
13746	1693	7688166667671
13747	1693	7681422147296
13748	1693	7615042377914
13749	1693	7548662608532
13750	1693	7482282839150
13751	1693	7415903069768
13752	1693	7349523300386
13753	1693	7283143531004
13754	1693	7216763761622
13755	1693	7150383992240
13756	1693	7084004222858
13757	1693	7017624453476
13758	1693	6951244684094
13759	1693	6445646784398
13760	1693	6379267015016
13761	1693	6372217797056
13762	1693	6305838027674
13763	1693	6239458258292
13764	1693	6173078488910
13765	1693	6106698719528
13766	1693	6040318950146
13767	1693	5973939180764
13768	1693	5907559411382
13769	1693	5841179642000
13770	1693	5774799872618
13771	1693	5708420103236
13772	1693	5642040333854
13773	1693	5637002321028
13774	1708	5041740000000
13775	1693	5570622551646
13776	1693	5568601346526
13777	1693	5502221577144
13778	1693	5435841807762
13779	1693	5369462038380
13780	1693	5303082268998
13781	1693	5236702499616
13782	1693	5170322730234
13783	1693	5103942960852
13784	1693	5037563191470
13785	1693	4971183422088
13786	1693	4904803652706
13787	1693	4838423883324
13788	1693	4772719878873
13789	1693	4706340109491
13790	1693	4639960340109
13791	1693	4573580570727
13792	1693	4507200801345
13793	1693	4497134775693
13794	1693	4430755006311
13795	1693	3819442556087
13796	1693	3753062786705
13797	1693	3686683017323
13798	1693	3620303247941
13799	1693	3553923478559
13800	1693	3487543709177
13801	1693	3454793300833
13802	1693	3388413531451
13803	1693	3322033762069
13804	1693	1618575130549
13805	1693	1552195361167
13806	1693	1485815591785
13807	1693	1177263679424
13808	1693	1110883910042
13809	1693	1044504140660
13810	1693	978124371278
13811	1693	911744601896
13812	1693	845364832514
13813	1693	778985063132
13814	1693	712605293750
13815	1693	646225524368
13816	1693	579845754986
13817	1693	513465985604
13818	1693	447086216222
13819	1693	380706446840
13820	1693	314326677458
13821	1693	247946908076
13822	1693	181567138694
13823	1693	115187369312
13824	1693	48807599930
13825	1708	5761740000000
13826	1708	5762240000000
13837	1716	10799200000000
13844	1397	1407966930000
13845	1678	2880083170000
13870	1397	1407886922000
13871	1678	2880083178000
13872	1637	46801332000000
13889	1474	8634223000000
13896	1397	1407846918000
13897	1678	2880083182000
13898	1673	5760470000000
13899	1673	5760480000000
13924	1687	10799131000000
13925	1687	10799161000000
13955	1397	1407736907000
13956	1678	2880083193000
13437	1397	1408386972000
13438	1678	2880083128000
13439	1693	7131223422088
13440	245	66153481816426
13441	1693	7064843652706
13442	520	66153481816426
13443	1693	6998463883324
13444	620	66153481816426
13445	1693	6932759878873
13446	37	65479919092470
13447	1693	6866380109491
13448	622	66156461816426
13449	1693	6800000340109
13450	54	66153481816426
13451	1693	6733620570727
13452	78	66153481816426
13453	1693	6667240801345
13454	594	66153481816426
13455	1693	6657174775693
13456	739	10023254820647
13457	1677	144002490000000
13522	1726	972800000000
13523	1804	200000000
13524	1726	971500000000
13525	1805	200000000
13526	1726	970200000000
13527	1806	200000000
13528	1726	968900000000
13529	240	66001200000000
13530	1693	2407986908076
13531	261	66153481816426
13532	1693	2341607138694
13533	201	66153481816426
13534	1397	1408346968000
13535	1678	2880083132000
13536	1693	2275227369312
13537	453	66153481816426
13538	1693	2208847599930
13539	499	66153481816426
13540	1693	2189530030659
13541	35	19244649255674
13542	1693	2123150261277
13543	383	66153481816426
13544	1693	2056770491895
13545	663	66153481816426
13546	1693	1990390722513
13547	127	66153481816426
13548	1756	11519719000000
13549	1693	1924010953131
13550	680	66153481816426
13551	1693	1857631183749
13552	49	66153481816426
13553	1397	1408336967000
13554	1678	2880083133000
13555	1397	1408326966000
13556	1678	2880083134000
13557	1397	1408316965000
13558	1678	2880083135000
13559	1397	1408306964000
13560	1678	2880083136000
13561	1693	1791251414367
13562	112	66153481816426
13563	1693	1724871644985
13564	186	66153481816426
13565	1693	1658491875603
13566	551	66153481816426
13567	1685	32399800000000
13598	1397	1408266960000
13599	1678	2880083140000
13600	1397	1408256959000
13601	1678	2880083141000
13602	1677	145442553000000
13603	1677	145442573000000
13615	1397	1408226956000
13616	1678	2880083144000
13670	1649	8640160999992
13671	1649	8640380999992
13674	1397	1408106944000
13675	1678	2880083156000
13676	1800	199000000
13677	1677	146882604000000
13682	633	74639130000000
13683	633	74639141000000
13686	1601	5400894600000
13687	1601	5400905600000
13688	1397	1408096943000
13689	1678	2880083157000
13690	1800	198000000
13691	1689	7919181000000
13700	1397	1408066940000
13701	1678	2880083160000
13702	1593	8640230000000
13703	1593	8640240000000
13718	1726	959800000000
13719	1814	200000000
13720	1726	958500000000
13721	1815	200000000
13722	1397	1408016935000
13723	1678	2880083165000
13724	237	66000090000000
13725	1440	7200320000000
13838	1397	1407986932000
13839	1678	2880083168000
13840	1397	1407976931000
13841	1678	2880083169000
13842	1677	147602603000000
13843	1677	147602633000000
13856	1693	1759321551364
13857	1816	100000000
13858	1397	1407936927000
13859	1678	2880083173000
13860	1397	1407926926000
13861	1678	2880083174000
13862	1397	1407916925000
13863	1678	2880083175000
13864	1397	1407906924000
13865	1678	2880083176000
13866	1397	1407896923000
13867	1678	2880083177000
13868	1684	19439520000000
13869	1684	19439580000000
13880	1714	12949120000000
13894	1588	6480090000000
13895	1588	6480100000000
13908	1397	1407816915000
13909	1678	2880083185000
13910	596	78240242000000
13911	596	78240252000000
13922	1683	329763169999541
13923	1683	329763199999541
13928	1726	955900000000
13929	1817	200000000
13930	739	10000244820647
13931	1811	251090000000
13932	1397	1407796913000
13933	1678	2880083187000
13934	1397	1407786912000
13935	1678	2880083188000
13936	5	6697563753375
13937	1811	266090000000
13938	1684	20159580000000
13939	1684	20159720000000
13942	1675	5040240000000
13953	1397	1407746908000
13954	1678	2880083192000
13990	1397	1407666900000
13991	1678	2880083200000
13992	1683	332643229999541
13993	1683	332643239999541
14008	1397	1407616895000
14009	1678	2880083205000
14010	1703	6479190000000
14011	1703	6479200000000
14030	1397	1407576891000
14031	1678	2880083209000
14032	1689	8639181000000
14033	1689	8639191000000
14050	1397	1407536887000
14051	1678	2880083213000
14052	1471	7200110000000
14053	1471	7200120000000
14058	1397	1407516885000
14059	1678	2880083215000
14060	1397	1407506884000
14061	1678	2880083216000
14062	1719	5039160000000
14122	1420	2422222
14123	1682	8627318577778
14125	1397	1407406874000
14126	1678	2880083226000
14133	1493	720000000000
14134	1493	720010000000
14153	1397	1407356869000
14154	1678	2880083231000
14155	1683	334083239999541
14156	1683	334083349999541
14168	1397	1407326866000
14169	1678	2880083234000
14170	1397	1407316865000
14171	1678	2880083235000
14172	1683	335523349999541
14173	1683	335523369999541
14191	1611	5040080000000
14192	1611	5040100000000
14219	1811	150090000000
13458	1693	6590795006311
13459	163	66153481816426
13460	1397	1408376971000
13461	1678	2880083129000
13462	1693	5979482556087
13463	1150	609318386916143
13464	1693	5913102786705
13465	452	66153481816426
13466	1693	5846723017323
13467	193	66153481816426
13468	1693	5780343247941
13469	391	66153481816426
13470	1693	5713963478559
13471	593	66153481816426
13472	1693	5647583709177
13473	660	66153481816426
13474	1693	5614833300833
13475	6	32633713045112
13476	1693	5548453531451
13477	504	66153481816426
13478	1688	59040932000000
13521	1692	33119932000000
13604	1701	10078322000000
13612	1397	1408236957000
13613	1678	2880083143000
13614	1759	10080169000000
13617	1397	1408216955000
13618	1678	2880083145000
13619	1683	328323169999541
13627	1726	965000000000
13628	1809	200000000
13629	1397	1408196953000
13630	1678	2880083147000
13631	1397	1408186952000
13632	1678	2880083148000
13633	1801	719020000000
13634	1537	0
13635	1729	7919250000000
13647	1397	1408156949000
13648	1678	2880083151000
13649	1397	1408146948000
13650	1678	2880083152000
13651	1677	146162573000000
13652	1677	146162593000000
13654	1397	1408136947000
13655	1678	2880083153000
13672	1573	9360130000000
13673	1573	9360350000000
13678	369	77520300000000
13679	369	77520311000000
13684	369	77522000000000
13685	369	77523050000000
13704	1397	1408056939000
13705	1678	2880083161000
13706	1541	5757128000000
13707	1541	5757138000000
13827	1397	1408006934000
13828	1678	2880083166000
13829	1522	7200180000000
13830	1522	7200190000000
13832	1739	6479300000000
13833	1397	1407996933000
13834	1678	2880083167000
13835	1608	7920120000000
13836	1608	7920130000000
13854	1599	12240240000000
13855	1599	12240360000000
13873	1715	12239261000000
13874	1715	12239271000000
13875	1816	0
13876	1397	1407876921000
13877	1678	2880083179000
13878	1688	59761053000000
13879	1688	60481053000000
13886	1474	7914213000000
13887	1474	8634213000000
13888	1474	8634233000000
13900	1397	1407836917000
13901	1678	2880083183000
13902	632	75360361000000
13903	632	75360371000000
13914	1397	1407806914000
13915	1678	2880083186000
13916	41	66000471816426
13917	1811	153090000000
13918	6	32558703045112
13919	1811	228090000000
13920	1688	60480943000000
13921	1688	60480973000000
13944	37	65329909092470
13945	1811	416090000000
13946	1397	1407776911000
13947	1678	2880083189000
13948	1397	1407766910000
13949	1678	2880083190000
13950	1397	1407756909000
13951	1678	2880083191000
13952	1683	329763209999541
13971	1613	7198110000000
13972	1613	7198120000000
13980	1397	1407696903000
13981	1678	2880083197000
13982	1397	1407686902000
13983	1678	2880083198000
13984	58	73920210000000
13986	1397	1407676901000
13987	1678	2880083199000
13988	1670	12960440000000
13989	1670	12960450000000
13996	1397	1407656899000
13997	1678	2880083201000
13998	1397	1407646898000
13999	1678	2880083202000
14000	1739	7199300000000
14001	1739	7199320000000
14012	1397	1407606894000
14013	1678	2880083206000
14014	470	76800281000000
14017	1397	1407596893000
14018	1678	2880083207000
14019	596	78960252000000
14020	596	78960262000000
14026	1455	6480111000000
14027	1455	6480121000000
14034	1613	7199141000000
14035	1613	7919141000000
14036	1613	7919221000000
14039	1687	11519161000000
14040	1687	11519171000000
14056	1762	4319100000000
14057	1762	4319110000000
14076	1590	3500000000
14077	542	66001000000000
14078	1397	1407456879000
14079	1678	2880083221000
14080	1623	13680291000000
14085	1726	954600000000
14086	1819	200000000
14087	1726	953300000000
14088	354	66001200000000
14089	1726	952000000000
14090	354	66002400000000
14091	1726	950700000000
14092	458	66001200000000
14093	1726	949400000000
14094	458	66002400000000
14095	1623	13680791000000
14096	1726	948100000000
14097	711	3001200000000
14098	1726	946800000000
14099	711	3002400000000
14100	1726	945500000000
14101	748	2001200000000
14102	1726	944200000000
14103	748	2002400000000
14104	1726	942900000000
14105	1488	1200000000
14106	1726	941600000000
14107	1488	2400000000
14108	1397	1407436877000
14109	1678	2880083223000
14110	1397	1407426876000
14111	1678	2880083224000
14112	1397	1407416875000
14113	1678	2880083225000
14114	1623	14400791000000
14115	1761	101
14116	1567	10000001
14117	1623	200100000
14118	1794	14401420899898
14124	1693	2479321551364
14127	1693	1759821551364
14128	1693	2479821551364
14129	1693	2480451551364
14130	1682	7907821000000
14131	1682	8627821000000
14132	1682	8628451000000
14139	1397	1407386872000
14140	1678	2880083228000
14141	1397	1407376871000
14142	1678	2880083229000
14143	700	69600060000000
14144	700	69600080000000
14165	641	74643980000000
14166	641	75363980000000
13957	1397	1407726906000
13958	1678	2880083194000
13959	1683	331203209999541
13960	1683	331203229999541
13963	1397	1407716905000
13964	1678	2880083195000
13965	1684	20159590000000
13985	606	74640170000000
14002	1397	1407636897000
14003	1678	2880083203000
14004	1513	4320050000000
14005	1513	4320060000000
14015	1692	35279952000000
14016	1692	35279962000000
14021	1690	28799961000000
14037	1397	1407566890000
14038	1678	2880083210000
14041	1397	1407556889000
14042	1678	2880083211000
14043	1677	149762653000000
14044	1677	149762663000000
14054	1397	1407526886000
14055	1678	2880083214000
14081	1397	1407446878000
14082	1678	2880083222000
14083	1711	10079270000000
14084	1711	10079280000000
14145	636	66000000000000
14146	1726	940300000000
14147	281	66001500000000
14148	1397	1407366870000
14149	1678	2880083230000
14150	1610	10080230000000
14151	1610	10080440000000
14161	1397	1407336867000
14162	1678	2880083233000
14163	641	75360420000000
14164	641	75360430000000
14183	1637	47521332000000
14184	1637	47521342000000
14196	1397	1407256859000
14197	1678	2880083241000
14202	1397	1407246858000
14203	1678	2880083242000
14204	1726	937700000000
14205	1820	200000000
14206	1397	1407236857000
14207	1678	2880083243000
14208	1397	1407226856000
14209	1678	2880083244000
14210	1397	1407216855000
14211	1678	2880083245000
14212	1397	1407206854000
14213	1678	2880083246000
14214	1682	8627461000000
14217	1710	7919090000000
14218	1710	7919230000000
14221	1397	1407196853000
14222	1678	2880083247000
14223	1397	1407186852000
14224	1678	2880083248000
14225	1397	1407176851000
14226	1678	2880083249000
14227	1397	1407166850000
14228	1678	2880083250000
14229	1489	6480161000000
14238	1397	1407146848000
14239	1678	2880083252000
14240	1397	1407136847000
14241	1678	2880083253000
14242	1598	720020000000
14254	606	74640180000000
14255	1397	1407096843000
14256	1678	2880083257000
14257	369	77520310000000
14258	1397	1407086842000
14259	1678	2880083258000
14260	1397	1407076841000
14261	1678	2880083259000
14262	1397	1407066840000
14263	1678	2880083260000
14264	1692	35279982000000
14277	1397	1407016835000
14278	1678	2880083265000
14279	1546	10800170000000
14282	1397	1407006834000
14283	1678	2880083266000
14284	1439	6480120000000
14289	1397	1406986832000
14290	1678	2880083268000
14291	1397	1406976831000
14292	1678	2880083269000
14293	1683	338403379999541
14294	1683	338403399999541
14302	1683	339843399999541
14303	1683	339843409999541
14312	576	74640370000000
14317	1397	1406926826000
14318	1678	2880083274000
14319	1665	720000000000
14320	1665	720010000000
14345	1397	1406856819000
14346	1678	2880083281000
14347	1677	151922793000000
14348	1677	151922803000000
14355	1397	1406846818000
14356	1678	2880083282000
14372	43	73200160000000
14373	43	73201960000000
14385	1397	1406786812000
14386	1678	2880083288000
14387	1593	9360240000000
14388	1593	9360250000000
14397	1397	1406746808000
14398	1678	2880083292000
14399	1699	2769912500051
14400	1773	2736097999988
14401	1688	61920973000000
14402	1688	61920993000000
14425	1397	1406716805000
14426	1678	2880083295000
14427	1677	153362813000000
14428	1677	153362823000000
14435	1702	6474091000000
14436	1702	6474101000000
14437	1397	1406676801000
14438	1678	2880083299000
14458	1397	1406626796000
14459	1678	2880083304000
14463	1397	1406616795000
14464	1678	2880083305000
14465	1447	10080140000000
14466	1447	10080150000000
14472	633	74639150000000
14481	1397	1406576791000
14482	1678	2880083309000
14483	1703	7199200000000
14484	1703	7199210000000
14489	1397	1406556789000
14490	1678	2880083311000
14493	1397	1406546788000
14494	1678	2880083312000
14495	1506	7920160000000
14496	1506	7920170000000
14505	1397	1406516785000
14506	1678	2880083315000
14529	1678	2880083319000
14530	1678	2880083320000
14531	1762	4319430000000
14536	1672	9360250000000
14537	1672	9360260000000
14538	1397	1406446778000
14539	1678	3600093322000
14540	1683	342723419999541
14541	1683	342723429999541
14555	1573	10080350000000
14556	1573	10080360000000
14563	1675	5760240000000
14564	1675	5760250000000
14565	1397	1406376771000
14566	1678	3600093329000
14567	1683	344163429999541
14568	1683	344163439999541
14578	1397	1406346768000
14579	1678	3600093332000
14580	1593	10080250000000
14581	1593	10080260000000
14594	1724	11518770000000
14595	1724	11518790000000
14602	1683	344163449999541
14604	1692	36000002000000
14612	1706	10076322000000
14613	1706	10076353110000
13978	1811	401090000000
13979	1613	7199091000000
13994	1474	9354233000000
13995	1474	9354243000000
14006	1397	1407626896000
14007	1678	2880083204000
14022	1397	1407586892000
14023	1678	2880083208000
14024	1694	20879425000000
14025	1694	20879435000000
14028	1710	7199080000000
14029	1710	7199090000000
14045	1448	7920250000000
14046	1448	7920260000000
14047	1397	1407546888000
14048	1678	2880083212000
14049	1688	60480953000000
14063	1590	4600000000
14064	1818	0
14065	1397	1407496883000
14066	1678	2880083217000
14067	1698	11519221000000
14068	1397	1407486882000
14069	1678	2880083218000
14070	1397	1407476881000
14071	1678	2880083219000
14072	1687	11519181000000
14073	1397	1407466880000
14074	1678	2880083220000
14075	1759	10800179000000
14119	1587	7920640000000
14120	1587	8640640000000
14121	1587	8641270000000
14135	1397	1407396873000
14136	1678	2880083227000
14137	1685	33119800000000
14138	1685	33119810000000
14152	1610	10080340000000
14157	1397	1407346868000
14158	1678	2880083232000
14159	1690	29519961000000
14160	1690	29519971000000
14174	1726	939000000000
14175	1781	1200000000
14176	1397	1407306864000
14177	1678	2880083236000
14178	1677	149762763000000
14185	1397	1407286862000
14186	1678	2880083238000
14187	1397	1407276861000
14188	1678	2880083239000
14189	1677	150482763000000
14190	1677	150482783000000
14193	1397	1407266860000
14194	1678	2880083240000
14195	1599	12240250000000
14198	1683	336963369999541
14199	1683	336963379999541
14215	1683	336963509999541
14273	1397	1407026836000
14274	1678	2880083264000
14295	1397	1406966830000
14296	1678	2880083270000
14297	1650	5760090000000
14325	1601	5400904600000
14328	1397	1406906824000
14329	1678	2880083276000
14330	484	77520171000000
14331	484	77520181000000
14341	1677	151202763000000
14342	1677	151202793000000
14349	1683	341283409999541
14350	1683	341283419999541
14353	1671	10080860000000
14354	1671	10080870000000
14357	1397	1406836817000
14358	1678	2880083283000
14359	1397	1406826816000
14360	1678	2880083284000
14361	1698	12959241000000
14362	1698	12959261000000
14381	1419	12240250000000
14382	1419	12240260000000
14389	1397	1406776811000
14390	1678	2880083289000
14391	1397	1406766810000
14392	1678	2880083290000
14393	1397	1406756809000
14394	1678	2880083291000
14395	1690	30239971000000
14396	1690	30240001000000
14404	632	76080371000000
14405	632	76080391000000
14410	1773	2688739938804
14411	182	66201286260032
14412	1773	2657164564680
14413	702	44134190840027
14414	1773	2296638056796
14415	927	504309970158507
14416	1773	1650585563572
14417	1047	903719145596202
14418	1773	1214677820088
14419	1167	608757314409807
14420	1293	1699142975987024
14421	1397	1406726806000
14422	1678	2880083294000
14423	1705	7914940000000
14424	1705	7915010000000
14431	1397	1406696803000
14432	1678	2880083297000
14433	1397	1406686802000
14434	1678	2880083298000
14441	1397	1406656799000
14442	1678	2880083301000
14443	1547	4320040000000
14446	1397	1406646798000
14447	1678	2880083302000
14448	1677	154082823000000
14449	1677	154082833000000
14455	1637	47521442000000
14467	1397	1406606794000
14468	1678	2880083306000
14469	1397	1406596793000
14470	1678	2880083307000
14471	1637	47521352000000
14473	1397	1406586792000
14474	1678	2880083308000
14475	1670	13680450000000
14476	1670	13680460000000
14479	1594	8640250000000
14480	1594	8640260000000
14485	1397	1406566790000
14486	1678	2880083310000
14487	1580	720010000000
14488	1580	720020000000
14502	1397	1406526786000
14503	1678	2880083314000
14504	1716	10799240000000
14510	1397	1406506784000
14511	1678	2880083316000
14512	1397	1406496783000
14513	1678	2880083317000
14514	112	66152471816426
14515	1821	0
14516	1513	5040060000000
14517	1513	5040090000000
14526	1536	12240270000000
14532	1397	1406456779000
14533	1678	3600093321000
14534	1509	12240271000000
14535	1509	12240281000000
14551	1397	1406406774000
14552	1678	3600093326000
14553	1656	12960301000000
14554	1656	12960311000000
14559	1397	1406386772000
14560	1678	3600093328000
14561	42	72480200000000
14562	42	72480210000000
14569	1397	1406366770000
14570	1678	3600093330000
14571	1677	154802833000000
14572	1677	154802853000000
14586	1397	1406326766000
14587	1678	3600093334000
14588	1397	1406316765000
14589	1678	3600093335000
14590	1397	1406306764000
14591	1678	3600093336000
14592	1747	4319150000000
14593	1747	4319170000000
14596	1397	1406296763000
14597	1678	3600093337000
14598	1693	3199111551364
14599	1818	100000000
14600	1693	3919111551364
14601	1693	3919131551364
14167	641	75364370000000
14179	1397	1407296863000
14180	1678	2880083237000
14181	1693	3199321551364
14182	1693	3199331551364
14200	1522	7920190000000
14201	1522	7920200000000
14216	44	71760320000000
14230	1811	149000000000
14231	1811	172000000000
14232	1811	247000000000
14233	1811	262000000000
14234	1708	6482240000000
14235	1708	6484183000000
14243	354	66002390000000
14244	1397	1407126846000
14245	1678	2880083254000
14246	1698	12239221000000
14247	1698	12239241000000
14265	1397	1407056839000
14266	1678	2880083261000
14275	1756	12239719000000
14276	1756	12239729000000
14280	1594	7200230000000
14281	1594	7200240000000
14285	1588	7200100000000
14286	1588	7200110000000
14306	1803	100000000
14307	1397	1406946828000
14308	1678	2880083272000
14309	1397	1406936827000
14310	1678	2880083273000
14311	1541	5757248000000
14313	1811	14000000000
14314	576	74643923000000
14315	576	75363923000000
14316	576	75364373000000
14332	1714	13669120000000
14333	1714	13669130000000
14351	470	77520281000000
14352	470	77520291000000
14363	1397	1406816815000
14364	1678	2880083285000
14366	1685	33839810000000
14367	1685	33839820000000
14368	1397	1406806814000
14369	1678	2880083286000
14370	1610	10800340000000
14371	1610	10800350000000
14374	43	73200170000000
14403	1679	32400232000000
14406	1397	1406736807000
14407	1678	2880083293000
14408	1447	9360130000000
14409	1447	9360140000000
14444	1650	6480090000000
14445	1650	6480100000000
14477	58	74640210000000
14478	58	74640220000000
14491	1564	5040052000000
14492	1564	5040062000000
14497	1397	1406536787000
14498	1678	2880083313000
14499	632	76080381000000
14507	1699	2049902500051
14508	1708	7204183000000
14509	1708	7204413000000
14527	1397	1406466780000
14528	1678	3600093320000
14542	1397	1406436777000
14543	1678	3600093323000
14544	1397	1406426776000
14545	1678	3600093324000
14546	1715	12239281000000
14547	1397	1406416775000
14548	1678	3600093325000
14549	1706	9356312000000
14550	1706	9356322000000
14573	1397	1406356769000
14574	1678	3600093331000
14575	1693	3199221551364
14576	1688	62640993000000
14577	1688	62641013000000
14582	1397	1406336767000
14583	1678	3600093333000
14584	1671	10800870000000
14585	1671	10800880000000
14603	1560	11520280000000
14220	44	71762680000000
14236	1397	1407156849000
14237	1678	2880083251000
14248	1397	1407116845000
14249	1678	2880083255000
14250	748	2002390000000
14251	1397	1407106844000
14252	1678	2880083256000
14253	1677	150482793000000
14267	1397	1407046838000
14268	1678	2880083262000
14269	1397	1407036837000
14270	1678	2880083263000
14271	1688	61200953000000
14272	1688	61200973000000
14287	1397	1406996833000
14288	1678	2880083267000
14298	1397	1406956829000
14299	1678	2880083271000
14300	1682	9347461000000
14301	1682	9347471000000
14304	1623	15121420899898
14305	1623	15121430899898
14321	1397	1406916825000
14322	1678	2880083275000
14323	1594	7920240000000
14324	1594	7920250000000
14326	1633	7200090000000
14327	1633	7200100000000
14334	1397	1406896823000
14335	1678	2880083277000
14336	1397	1406886822000
14337	1678	2880083278000
14338	1397	1406876821000
14339	1678	2880083279000
14340	1587	8640170000000
14343	1397	1406866820000
14344	1678	2880083280000
14365	1746	2879040000000
14375	1397	1406796813000
14376	1678	2880083287000
14377	1677	152642803000000
14378	1677	152642813000000
14379	1759	11520179000000
14380	1759	11520189000000
14383	1692	35999982000000
14384	1692	35999992000000
14429	1397	1406706804000
14430	1678	2880083296000
14439	1397	1406666800000
14440	1678	2880083300000
14450	281	66001000000000
14451	1591	400000000
14452	1397	1406636797000
14453	1678	2880083303000
14454	1444	12240470000000
14456	1740	10796623000000
14457	1740	10796733000000
14460	1607	13683242000000
14461	1607	14403242000000
14462	1607	14403352000000
14500	1637	48241352000000
14501	1637	48241362000000
14518	1397	1406486782000
14519	1678	2880083318000
14520	1678	3600083318000
14521	1678	3600093318000
14522	1649	9360280999992
14523	1649	9360290999992
14524	1397	1406476781000
14525	1678	3600093319000
14557	1397	1406396773000
14558	1678	3600093327000
14605	1818	88890000
14606	1492	21000000
14607	1397	1406286762000
14608	1678	3600093338000
14609	1397	1406276761000
14610	1678	3600093339000
14611	1458	13680244908540
14614	1397	1406266760000
14615	1678	3600093340000
14616	1740	10796633000000
14617	1724	11518780000000
14618	1397	1406256759000
14619	1678	3600093341000
14620	1536	12960270000000
14621	1536	12960280000000
14622	1397	1406246758000
14623	1678	3600093342000
14624	112	66002461816426
14625	1821	150000000000
14626	1601	5400914600000
14627	1397	1406236757000
14628	1678	3600093343000
14629	1397	1406226756000
14630	1678	3600093344000
14631	1402	35280791000000
14632	1402	35280811000000
14633	1397	1406216755000
14634	1678	3600093345000
14635	1739	7919320000000
14636	1739	7919330000000
14637	1397	1406206754000
14638	1678	3600093346000
14639	1397	1406196753000
14640	1678	3600093347000
14641	1489	7200161000000
14642	1489	7200181000000
14643	1440	7920320000000
14644	1440	7920340000000
14645	1489	7200391000000
14646	1397	1406186752000
14647	1678	3600093348000
14648	1397	1406176751000
14649	1678	3600093349000
14650	1700	7919430000000
14651	1700	7919450000000
14652	576	74640270000000
14653	1397	1406166750000
14654	1678	3600093350000
14655	1397	1406156749000
14656	1678	3600093351000
14657	1397	1406146748000
14658	1678	3600093352000
14659	1679	32400242000000
14660	1564	5760062000000
14661	1564	5760092000000
14662	1694	21599435000000
14663	1694	21599465000000
14664	1397	1406136747000
14665	1678	3600093353000
14666	1402	36000811000000
14667	1402	36000821000000
14668	1513	5760090000000
14669	1513	5760100000000
14670	1397	1406126746000
14671	1678	3600093354000
14672	1458	14400244908540
14673	1458	14400254908540
14674	1397	1406116745000
14675	1678	3600093355000
14676	1564	5760072000000
14677	1700	7919440000000
14678	1397	1406106744000
14679	1678	3600093356000
14680	1821	149990000000
14681	1764	7920048000000
14682	606	75360180000000
14683	606	75360190000000
14684	1397	1406096743000
14685	1678	3600093357000
14686	1397	1406086742000
14687	1678	3600093358000
14688	58	74640230000000
14689	1397	1406076741000
14690	1678	3600093359000
14691	1509	12960281000000
14692	1509	12960291000000
14693	1683	345603449999541
14694	1683	345603459999541
14695	632	76800381000000
14696	632	76800391000000
14697	1397	1406066740000
14698	1678	3600093360000
14699	1673	6480480000000
14700	1673	6480490000000
14701	1695	8640441000000
14702	1695	9360441000000
14703	1695	9360531000000
14704	1397	1406056739000
14705	1678	3600093361000
14706	1695	9359161000000
14707	1695	9359171000000
14708	1397	1406046738000
14709	1678	3600093362000
14710	1397	1406036737000
14711	1678	3600093363000
14712	1677	155522853000000
14713	1677	155522863000000
14714	1555	6480070000000
14715	1555	6480080000000
14716	1397	1406026736000
14717	1678	3600093364000
14718	1397	1406016735000
14719	1678	3600093365000
14720	1397	1406006734000
14721	1678	3600093366000
14722	1397	1405996733000
14723	1678	3600093367000
14724	1677	155522893000000
14727	1397	1405986732000
14728	1678	3600093368000
14736	1397	1405956729000
14737	1678	3600093371000
14738	1458	15120254908540
14739	1458	15120264908540
14742	1397	1405946728000
14743	1678	3600093372000
14744	1688	63361013000000
14745	1688	63361023000000
14762	1397	1405876721000
14763	1678	3600093379000
14764	1679	33120242000000
14765	1679	33120252000000
14772	1397	1405846718000
14773	1678	3600093382000
14774	1397	1405836717000
14775	1678	3600093383000
14776	1683	345603469999541
14777	1397	1405826716000
14778	1678	3600093384000
14787	1397	1405796713000
14788	1678	3600093387000
14789	1727	7199100000000
14790	1727	7199110000000
14795	1692	37440032000000
14796	1692	37440042000000
14818	1726	928600000000
14819	1826	1400000000
14820	1397	1405756709000
14821	1678	3600093391000
14822	1650	7200100000000
14823	1650	7200210000000
14842	1397	1405706704000
14843	1678	3600093396000
14844	1768	5759140000000
14845	1768	5759150000000
14848	1678	2880083321000
14849	1678	2880083322000
14850	1678	2880083323000
14851	1678	2880083324000
14852	1678	2880083325000
14853	1678	2880083326000
14854	1678	2880083327000
14855	1678	2880083328000
14856	1678	2880083329000
14857	1678	2880083330000
14858	1678	2880083331000
14859	1678	2880083332000
14860	1678	2880083333000
14861	1678	2880083334000
14862	1678	2880083335000
14863	1678	2880083336000
14864	1678	2880083337000
14865	1678	2880083338000
14866	1678	2880083339000
14867	1678	2880083340000
14868	1678	2880083341000
14869	1678	2880083342000
14870	1678	2880083343000
14871	1678	2880083344000
14872	1678	2880083345000
14873	1678	2880083346000
14874	1678	2880083347000
14875	1678	2880083348000
14876	1678	2880083349000
14877	1678	2880083350000
14878	1678	2880083351000
14879	1678	2880083352000
14880	1678	2880083353000
14881	1678	2880083354000
14882	1678	2880083355000
14883	1678	2880083356000
14884	1678	2880083357000
14885	1678	2880083358000
14886	1678	2880083359000
14887	1678	2880083360000
14888	1678	2880083361000
14889	1678	2880083362000
14890	1678	2880083363000
14891	1678	2880083364000
14892	1678	2880083365000
14893	1678	2880083366000
14894	1678	2880083367000
14895	1678	2880083368000
14896	1678	2880083369000
14897	1678	2880083370000
14898	1678	2880083371000
14899	1678	2880083372000
14900	1678	2880083373000
14901	1768	5760930000000
14906	1826	0
14907	1828	300000000
14908	1397	1405686702000
14909	1678	3600093398000
14910	1685	35279830000000
14911	1685	35279940000000
14918	1828	0
14919	1397	1405656699000
14920	1678	3600093401000
14921	1710	8639110000000
14922	1710	8639220000000
14943	1805	190000000
14944	1397	1405606694000
14945	1678	3600093406000
14946	1719	5759160000000
14947	1719	5759180000000
14975	58	75360230000000
14986	1397	1405556689000
14987	1678	3600093411000
14988	1397	1405546688000
14989	1678	3600093412000
15013	1650	7920210000000
15014	1650	7920230000000
15015	1397	1405536687000
15016	1678	3600093413000
15017	1397	1405526686000
15018	1678	3600093414000
15019	1397	1405516685000
15020	1678	3600093415000
15021	44	71760210000000
15032	1397	1405486682000
15033	1678	3600093418000
15034	1397	1405476681000
15035	1678	3600093419000
15036	641	76080430000000
15037	641	76080450000000
15042	1397	1405466680000
15043	1678	3600093420000
15044	1688	64801043000000
15053	1739	8639330000000
15054	1739	8639340000000
15059	1726	927300000000
15060	1830	200000000
15061	1397	1405426676000
15062	1678	3600093424000
15063	1683	351363489999541
15064	1683	351363599999541
15078	1457	9360180000000
15097	1690	30960001000000
15098	1690	30960041000000
15101	1397	1405346668000
15102	1678	3600093432000
15103	1671	11520880000000
15104	1671	11520890000000
15122	1607	15120402000000
15123	1607	15120412000000
15124	1693	1759211551364
15125	1693	1759101551364
15126	1567	14404851899898
15127	1607	101
15128	1761	8640140000000
15129	1447	10000001
15130	1450	200100000
15131	1794	10000000
15132	1607	15124851899898
15133	1607	15124961899898
15134	1397	1405296663000
15135	1678	3600093437000
15136	1683	354243609999541
15137	1683	354243619999541
15144	1397	1405266660000
15145	1678	3600093440000
15158	1671	12240890000000
15159	1671	12240920000000
15162	1397	1405216655000
15163	1678	3600093445000
15164	1698	13679261000000
15165	1698	13679271000000
15192	641	76087690000000
15193	641	76807690000000
15194	641	76807860000000
15197	1704	2159030000000
15198	1704	2159040000000
15205	1584	500000000
15206	1740	10796123000000
15211	1686	4531966500013
15222	1439	7200120000000
15223	1439	7200150000000
14725	1692	36719992000000
14726	1692	36720032000000
14729	1616	2160030000000
14740	1426	6480240000000
14741	1426	6480250000000
14750	1397	1405916725000
14751	1678	3600093375000
14752	1397	1405906724000
14753	1678	3600093376000
14754	1560	12240280000000
14755	1560	12240300000000
14771	1710	7919110000000
14791	1397	1405786712000
14792	1678	3600093388000
14793	1683	347043469999541
14794	1683	347043479999541
14812	1723	11519200000000
14813	1723	11519810000000
14824	1397	1405746708000
14825	1678	3600093392000
14832	1596	10800140000000
14833	1596	10800150000000
14838	1397	1405716705000
14839	1678	3600093395000
14840	1679	33840252000000
14841	1679	33840262000000
14902	1397	1405696703000
14903	1678	3600093397000
14904	1587	9360150000000
14905	1587	9360160000000
14925	1397	1405646698000
14926	1678	3600093402000
14927	149	72480130000000
14928	149	72480140000000
14939	1397	1405616695000
14940	1678	3600093405000
14941	1764	8640048000000
14942	1764	8640058000000
14971	1397	1405596693000
14972	1678	3600093407000
14973	1632	720000000000
14974	1632	720010000000
14990	1678	2880083392000
14991	1678	2880083393000
14992	1678	2880083394000
14993	1678	2880083395000
14994	1678	2880083396000
14995	1678	2880083397000
14996	1678	2880083398000
14997	1678	2880083399000
14998	1678	2880083400000
14999	1678	2880083401000
15000	1678	2880083402000
15001	1678	2880083403000
15002	1678	2880083404000
15003	1678	2880083405000
15004	1678	2880083406000
15005	1678	2880083407000
15006	1678	2880083408000
15007	1678	2880083409000
15008	1678	2880083410000
15009	1678	2880083411000
15010	1678	2880083412000
15011	1719	6481170000000
15012	1719	6481380000000
15022	1422	5040080000000
15023	1688	64801033000000
15038	112	66086102047044
15039	641	75366260000000
15040	641	76086260000000
15041	641	76086650000000
15045	1397	1405456679000
15046	1678	3600093421000
15047	1685	35999940000000
15048	1685	35999950000000
15065	1726	926000000000
15066	1831	200000000
15067	1397	1405416675000
15068	1678	3600093425000
15069	1693	3919221551364
15079	1759	12240179000000
15080	1759	12240189000000
15083	1608	7922130000000
15084	1608	8642130000000
15085	1608	8642180000000
15095	43	73920170000000
15096	43	73920210000000
15105	1397	1405336667000
15106	1678	3600093433000
15107	1683	352803599999541
15108	1683	352803609999541
15114	1710	9359220000000
15115	1710	9359230000000
15116	1397	1405306664000
15117	1678	3600093436000
15118	1471	7920120000000
15119	1471	7920130000000
15154	1700	8639440000000
15155	1700	8639470000000
15160	1397	1405226656000
15161	1678	3600093444000
15172	1457	10080180000000
15173	1457	10080200000000
15176	1829	990000000
15177	1397	1405186652000
15178	1678	3600093448000
15179	1397	1405176651000
15180	1678	3600093449000
15188	1637	49681372000000
15189	1637	49681382000000
15195	1397	1405146648000
15196	1678	3600093452000
15203	1685	36719950000000
15204	1685	36719960000000
15207	1397	1405126646000
15208	1678	3600093454000
15209	1402	37440831000000
15210	1402	37440841000000
15212	1397	1405116645000
15213	1678	3600093455000
15214	1723	12239810000000
15215	1723	12239820000000
15227	1698	14399301000000
15228	1397	1405086642000
15229	1678	3600093458000
15230	1683	358563639999541
15231	1683	358563649999541
15261	1397	1405006634000
15262	1678	3600093466000
15263	1677	159843003000000
15264	1677	159843013000000
15266	1397	1404996633000
15267	1678	3600093467000
15281	1397	1404936627000
15282	1678	3600093473000
15283	1397	1404926626000
15284	1678	3600093474000
15285	1686	5251966500013
15286	1686	5251986500013
15297	1726	923400000000
15298	1833	200000000
15299	1397	1404886622000
15300	1678	3600093478000
15301	1549	11520281000000
15302	1549	11520391000000
15320	1684	20879590000000
15321	1684	20879600000000
15334	1587	10080170000000
15349	1397	1404736607000
15350	1678	3600093493000
15351	369	78240310000000
15352	369	78240320000000
15358	1679	34560262000000
15359	1679	34560272000000
15364	1397	1404696603000
15365	1678	3600093497000
15366	1519	2159010000000
15367	1519	2159020000000
15372	1726	922100000000
15373	1834	200000000
15374	1397	1404676601000
15375	1678	3600093499000
15376	1397	1404666600000
15377	1678	3600093500000
15378	44	72480190000000
15379	44	72480310000000
15392	1397	1404626596000
15393	1678	3600093504000
15394	1397	1404616595000
15395	1678	3600093505000
15396	1677	161283023000000
15397	1677	161283043000000
15403	1397	1404596593000
15404	1678	3600093507000
15405	1695	9359181000000
15406	1695	10079181000000
15413	1675	6480250000000
15414	1675	6480270000000
15426	1397	1404546588000
15427	1678	3600093512000
15428	1629	720000000000
15429	1629	720010000000
15438	1687	12239181000000
15439	1687	12239211000000
15449	1684	22319650000000
14730	1397	1405976731000
14731	1678	3600093369000
14732	1397	1405966730000
14733	1678	3600093370000
14734	1677	155522873000000
14746	1397	1405936727000
14747	1678	3600093373000
14756	1397	1405896723000
14757	1678	3600093377000
14760	1685	34559820000000
14761	1685	34559830000000
14783	1397	1405806714000
14784	1678	3600093386000
14785	1596	10080130000000
14786	1596	10080140000000
14826	1402	36720821000000
14827	1402	36720831000000
14916	1397	1405666700000
14917	1678	3600093400000
14924	1692	37440142000000
14929	1508	7200100000000
14930	1508	7200110000000
14950	1719	5040940000000
14951	1678	2880083374000
14952	1678	2880083375000
14953	1678	2880083376000
14954	1678	2880083377000
14955	1678	2880083378000
14956	1678	2880083379000
14957	1678	2880083380000
14958	1678	2880083381000
14959	1678	2880083382000
14960	1678	2880083383000
14961	1678	2880083384000
14962	1678	2880083385000
14963	1678	2880083386000
14964	1678	2880083387000
14965	1678	2880083388000
14966	1678	2880083389000
14967	1678	2880083390000
14968	1678	2880083391000
14969	1719	5760940000000
14970	1719	5761170000000
14976	1397	1405586692000
14977	1678	3600093408000
14978	1397	1405576691000
14979	1678	3600093409000
14980	1711	10799280000000
14981	1711	10799300000000
14982	1397	1405566690000
14983	1678	3600093410000
14984	1668	14400240000000
14985	1668	14400250000000
15028	1397	1405496683000
15029	1678	3600093417000
15030	1683	349923479999541
15031	1683	349923489999541
15049	1397	1405446678000
15050	1678	3600093422000
15051	1740	11516633000000
15052	1740	11516643000000
15055	1397	1405436677000
15056	1678	3600093423000
15057	1637	48961362000000
15058	1637	48961372000000
15070	1587	10080160000000
15071	1587	10080270000000
15074	1397	1405406674000
15075	1678	3600093426000
15076	1688	65521043000000
15077	1688	65521053000000
15099	1397	1405356669000
15100	1678	3600093431000
15109	1397	1405326666000
15110	1678	3600093434000
15120	1673	7200490000000
15121	1673	7200500000000
15140	1397	1405276661000
15141	1678	3600093439000
15142	1683	355683619999541
15143	1683	355683629999541
15156	1549	10800281000000
15181	1397	1405166650000
15182	1678	3600093450000
15183	1522	8640200000000
15184	1522	8640210000000
15216	436	66718610000000
15217	1397	1405106644000
15218	1678	3600093456000
15219	1397	1405096643000
15220	1678	3600093457000
15221	1670	13680480000000
15232	1740	12956653000000
15233	1740	12956663000000
15234	1726	924700000000
15235	1832	200000000
15236	1397	1405076641000
15237	1678	3600093459000
15238	1397	1405066640000
15239	1678	3600093460000
15240	1397	1405056639000
15241	1678	3600093461000
15242	633	74639260000000
15251	1397	1405026636000
15252	1678	3600093464000
15253	1509	13680291000000
15254	1509	13680301000000
15265	1688	66241063000000
15270	1397	1404976631000
15271	1678	3600093469000
15307	1397	1404866620000
15308	1678	3600093480000
15335	1397	1404796613000
15336	1678	3600093487000
15337	1397	1404786612000
15338	1678	3600093488000
15339	1397	1404776611000
15340	1678	3600093489000
15341	1397	1404766610000
15342	1678	3600093490000
15343	1397	1404756609000
15344	1678	3600093491000
15345	1447	10800150000000
15346	1447	10800200000000
15353	1397	1404726606000
15354	1678	3600093494000
15355	1690	30960011000000
15368	1397	1404686602000
15369	1678	3600093498000
15370	1709	10077251000000
15371	1709	10077261000000
15380	1397	1404656599000
15381	1678	3600093501000
15382	1397	1404646598000
15383	1678	3600093502000
15384	632	77520391000000
15385	632	77520411000000
15398	1513	5760110000000
15415	1397	1404566590000
15416	1678	3600093510000
15417	1683	361443669999541
15420	1654	9360160000000
15421	1654	9360170000000
15430	1397	1404536587000
15431	1678	3600093513000
15432	1397	1404526586000
15433	1678	3600093514000
15434	1397	1404516585000
15435	1678	3600093515000
15436	1677	162003043000000
15437	1677	162003073000000
15441	1834	90000000
15442	1397	1404506584000
15443	1678	3600093516000
15444	1397	1404496583000
15445	1678	3600093517000
15446	1397	1404486582000
15447	1678	3600093518000
15448	1709	10077291000000
15456	1397	1404466580000
15457	1678	3600093520000
15458	1397	1404456579000
15459	1678	3600093521000
15460	1397	1404446578000
15461	1678	3600093522000
15462	1683	362883799999541
15466	1637	50401382000000
15467	1637	50401412000000
15468	1397	1404436577000
15469	1678	3600093523000
15470	1447	11520200000000
15471	1447	11520210000000
15472	1397	1404426576000
15473	1678	3600093524000
15474	1397	1404416575000
15475	1678	3600093525000
15476	1692	37440052000000
15482	1705	8635010000000
15483	1705	8635020000000
15484	1397	1404396573000
15485	1678	3600093527000
15486	1726	920800000000
15487	1835	200000000
15488	1397	1404386572000
15489	1678	3600093528000
14735	1451	5040200000000
14748	1397	1405926726000
14749	1678	3600093374000
14758	1397	1405886722000
14759	1678	3600093378000
14766	1397	1405866720000
14767	1678	3600093380000
14768	1397	1405856719000
14769	1678	3600093381000
14770	1448	7920270000000
14779	1397	1405816715000
14780	1678	3600093385000
14781	1677	156242873000000
14782	1677	156242883000000
14797	1726	936400000000
14798	1822	200000000
14799	1726	935100000000
14800	1823	200000000
14801	1726	933800000000
14802	1824	200000000
14803	1726	932500000000
14804	1825	200000000
14805	1726	931200000000
14806	1826	200000000
14807	1726	929900000000
14808	1827	200000000
14809	1397	1405776711000
14810	1678	3600093389000
14811	1518	2160630000000
14814	1397	1405766710000
14815	1678	3600093390000
14816	1688	64081023000000
14817	1688	64081033000000
14828	1397	1405736707000
14829	1678	3600093393000
14830	1683	348483479999541
14831	1683	348483489999541
14834	1397	1405726706000
14835	1678	3600093394000
14836	1560	12960300000000
14837	1560	12960310000000
14846	1677	156962883000000
14847	1677	156962893000000
14912	1397	1405676701000
14913	1678	3600093399000
14914	1571	9360131000008
14915	1571	9360141000008
14923	1694	21599545000000
14931	436	66718640000000
14932	1829	0
14933	1397	1405636697000
14934	1678	3600093403000
14935	1397	1405626696000
14936	1678	3600093404000
14937	1677	157682893000000
14938	1677	157682963000000
14948	1677	158402963000000
14949	1677	158402983000000
15024	1397	1405506684000
15025	1678	3600093416000
15026	1555	7200080000000
15027	1555	7200090000000
15072	1711	11519300000000
15073	1711	11519410000000
15081	1608	8640120000000
15082	1608	8640130000000
15086	1397	1405396673000
15087	1678	3600093427000
15088	1397	1405386672000
15089	1678	3600093428000
15090	1397	1405376671000
15091	1678	3600093429000
15092	1397	1405366670000
15093	1678	3600093430000
15094	1688	65521083000000
15111	1397	1405316665000
15112	1678	3600093435000
15113	1693	3919121551364
15138	1397	1405286662000
15139	1678	3600093438000
15146	1397	1405256659000
15147	1678	3600093441000
15148	1397	1405246658000
15149	1678	3600093442000
15150	1397	1405236657000
15151	1678	3600093443000
15152	1683	357123629999541
15153	1683	357123659999541
15157	484	77520201000000
15166	1397	1405206654000
15167	1678	3600093446000
15168	436	66717630000000
15169	1829	1000000000
15170	1657	6480110000000
15171	1657	6480130000000
15174	1397	1405196653000
15175	1678	3600093447000
15185	1397	1405156649000
15186	1678	3600093451000
15187	1683	357123639999541
15190	641	76800450000000
15191	641	76800460000000
15199	1397	1405136647000
15200	1678	3600093453000
15201	1740	12236643000000
15202	1740	12236653000000
15224	1698	14399271000000
15225	1568	14399300900000
15226	1698	100000
15249	1688	66241053000000
15250	1688	66241073000000
15257	1397	1405016635000
15258	1678	3600093465000
15259	1708	5759190000000
15260	1708	5759200000000
15268	1397	1404986632000
15269	1678	3600093468000
15273	1397	1404966630000
15274	1678	3600093470000
15275	1397	1404956629000
15276	1678	3600093471000
15277	1397	1404946628000
15278	1678	3600093472000
15279	1613	7918120000000
15280	1613	7918150000000
15309	1397	1404856619000
15310	1678	3600093481000
15311	1677	160563013000000
15312	1677	160563023000000
15315	1397	1404846618000
15316	1678	3600093482000
15317	1622	3600040000000
15318	1397	1404836617000
15319	1678	3600093483000
15325	1445	8640200000000
15330	1688	66961063000000
15331	1688	66961073000000
15332	1397	1404806614000
15333	1678	3600093486000
15356	1397	1404716605000
15357	1678	3600093495000
15387	1463	720020000000
15388	1397	1404636597000
15389	1678	3600093503000
15390	1683	360003649999541
15391	1683	360003659999541
15399	1397	1404606594000
15400	1678	3600093506000
15401	1440	8640340000000
15402	1440	8640350000000
15422	1834	100000000
15423	1397	1404556589000
15424	1678	3600093511000
15425	1683	361443769999541
15454	1683	362883769999541
15455	1683	362883779999541
15464	1668	15120250000000
15465	1668	15120280000000
15477	1397	1404406574000
15478	1678	3600093526000
15479	1677	162003053000000
15506	1397	1404326566000
15507	1678	3600093534000
15508	1688	67681183000000
15509	1688	67681193000000
15512	1397	1404316565000
15513	1678	3600093535000
15514	44	73200310000000
15515	44	73200320000000
15526	1727	7919110000000
15527	1727	7919120000000
15537	1397	1404286562000
15538	1678	3600093538000
15539	1687	12959211000000
15540	1687	12959221000000
15545	1397	1404266560000
15546	1678	3600093540000
15547	1509	14400301000000
15548	1509	14400311000000
15549	1683	365763909999541
15550	1683	365763919999541
15551	1397	1404256559000
15552	1678	3600093541000
15553	1637	50401392000000
15588	1726	918200000000
15243	1397	1405046638000
15244	1678	3600093462000
15245	1397	1405036637000
15246	1678	3600093463000
15247	1677	159122983000000
15248	1677	159123003000000
15255	1555	7920090000000
15256	1555	7920100000000
15272	1706	10076332000000
15287	1694	22319465000000
15288	1694	22319485000000
15289	1397	1404916625000
15290	1678	3600093475000
15291	1397	1404906624000
15292	1678	3600093476000
15293	1397	1404896623000
15294	1678	3600093477000
15295	1715	12959281000000
15296	1715	12959311000000
15303	542	66000988890000
15304	1397	1404876621000
15305	1678	3600093479000
15306	1768	5759161110000
15313	1622	3600030000000
15314	1622	3601231110000
15322	1397	1404826616000
15323	1678	3600093484000
15324	1489	7200171000000
15326	1397	1404816615000
15327	1678	3600093485000
15328	1684	21599600000000
15329	1684	21599610000000
15347	1397	1404746608000
15348	1678	3600093492000
15360	1397	1404706604000
15361	1678	3600093496000
15362	1679	35280272000000
15363	1679	35280282000000
15386	1729	7919140000000
15407	1397	1404586592000
15408	1678	3600093508000
15409	1397	1404576591000
15410	1678	3600093509000
15411	1683	361443659999541
15412	1683	361443679999541
15418	1684	22319610000000
15419	1684	22319620000000
15440	1688	66961093000000
15450	1457	10800200000000
15451	1457	10800240000000
15452	1397	1404476581000
15453	1678	3600093519000
15463	1457	10800230000000
15496	1684	23039650000000
15497	1684	23039780000000
15500	1803	0
15501	1397	1404346568000
15502	1678	3600093532000
15503	1397	1404336567000
15504	1678	3600093533000
15505	1688	66961183000000
15524	484	78240201000000
15525	484	78240211000000
15536	1637	50401492000000
15541	1397	1404276561000
15542	1678	3600093539000
15543	1623	15841430899898
15544	1623	15841440899898
15562	1397	1404216555000
15563	1678	3600093545000
15564	1397	1404206554000
15565	1678	3600093546000
15566	1692	38160052000000
15567	1692	38160072000000
15572	1397	1404186552000
15573	1678	3600093548000
15574	1397	1404176551000
15575	1678	3600093549000
15576	1683	368643929999541
15577	1683	368643949999541
15578	1397	1404166550000
15579	1678	3600093550000
15580	1670	14400480000000
15581	1670	14400490000000
15582	1397	1404156549000
15583	1678	3600093551000
15584	1397	1404146548000
15585	1678	3600093552000
15586	1683	370083949999541
15587	1683	370083969999541
15599	1679	36720292000000
15600	1679	36720302000000
15605	1397	1404116545000
15606	1678	3600093555000
15607	1489	7920171000000
15608	1489	7920181000000
15623	1397	1404086542000
15624	1678	3600093558000
15625	1397	1404076541000
15626	1678	3600093559000
15627	1711	12239410000000
15628	1711	12239430000000
15629	1397	1404066540000
15630	1678	3600093560000
15631	1397	1404056539000
15632	1678	3600093561000
15633	1711	12959430000000
15634	1711	12959450000000
15635	1613	7918400000000
15636	1711	12959180000000
15637	1711	12959200000000
15677	1397	1403936527000
15678	1678	3600093573000
15691	1397	1403896523000
15692	1678	3600093577000
15693	1588	10080140000000
15694	1588	10080150000000
15695	1397	1403886522000
15696	1678	3600093578000
15697	1547	5040040000000
15698	1547	5040050000000
15705	1397	1403876521000
15706	1678	3600093579000
15707	1397	1403866520000
15708	1678	3600093580000
15709	1709	10077271000000
15716	1601	6120914600000
15717	1601	6120924600000
15736	1397	1403786512000
15737	1678	3600093588000
15738	1397	1403776511000
15739	1678	3600093589000
15740	1683	372963979999541
15741	1683	372963999999541
15754	1601	6120915600000
15755	1688	68401194000000
15756	872	109739593307813
15757	1397	1403746508000
15758	1678	3600093592000
15759	1706	10796352000000
15766	1715	13679311000000
15767	1715	13679331000000
15777	1694	23039505000000
15790	1397	1403646498000
15791	1678	3600093602000
15792	1397	1403636497000
15793	1678	3600093603000
15794	1768	6479161110000
15795	1768	6479181110000
15798	1397	1403626496000
15799	1678	3600093604000
15800	1397	1403616495000
15801	1678	3600093605000
15802	1397	1403606494000
15803	1678	3600093606000
15804	1724	11518800000000
15816	1692	38880072000000
15817	1692	38880082000000
15832	1397	1403536487000
15833	1678	3600093613000
15834	1683	377284019999541
15835	1683	377284029999541
15838	1397	1403526486000
15839	1678	3600093614000
15849	1683	377284039999541
15856	1708	7199210000000
15857	1708	7199230000000
15875	1397	1403426476000
15876	1678	3600093624000
15890	1397	1403376471000
15891	1678	3600093629000
15892	1397	1403366470000
15893	1678	3600093630000
15894	470	77520301000000
15902	1683	378724149999541
15925	1397	1403286462000
15926	1678	3600093638000
15931	1573	10800360000000
15932	1573	10800370000000
15940	1397	1403246458000
15941	1678	3600093642000
15942	1476	10800210000000
15954	1397	1403196453000
15955	1678	3600093647000
15956	1397	1403186452000
15480	1571	10080141000008
15481	1571	10080151000008
15510	1588	7920110000000
15511	1588	7920120000000
15516	1610	11520350000000
15517	1610	11520360000000
15518	1397	1404306564000
15519	1678	3600093536000
15520	1444	12960470000000
15521	1444	12960480000000
15528	1643	1764233113700
15529	1643	1764243113700
15554	1397	1404246558000
15555	1678	3600093542000
15556	1683	367203919999541
15557	1683	367203929999541
15568	1397	1404196553000
15569	1678	3600093547000
15570	1708	6479200000000
15571	1708	6479210000000
15603	1688	68401193000000
15604	1688	68401203000000
15609	1683	371523969999541
15610	1683	371523979999541
15620	1474	9354253000000
15621	1474	10074253000000
15644	1508	7920110000000
15645	1508	7920140000000
15654	1397	1404016535000
15655	1678	3600093565000
15656	1397	1404006534000
15657	1678	3600093566000
15658	1397	1403996533000
15659	1678	3600093567000
15660	1397	1403986532000
15661	1678	3600093568000
15662	1693	3919151551364
15683	1426	7200250000000
15684	1426	7200260000000
15685	1397	1403916525000
15686	1678	3600093575000
15701	641	78240470000000
15702	641	78240480000000
15721	1397	1403836517000
15722	1678	3600093583000
15750	1706	10796332000000
15751	1706	10796343000000
15760	1397	1403736507000
15761	1678	3600093593000
15762	1397	1403726506000
15763	1678	3600093594000
15764	1683	374403999999541
15765	1683	374404019999541
15805	1397	1403596493000
15806	1678	3600093607000
15807	1696	7198121000000
15808	1696	7198131000000
15812	1397	1403576491000
15813	1678	3600093609000
15822	1271	1336926030000000
15823	1271	1336926040000000
15824	1397	1403556489000
15825	1678	3600093611000
15826	1560	13680310000000
15827	1560	13680320000000
15836	1724	12238800000000
15837	1724	12238810000000
15845	1397	1403506484000
15846	1678	3600093616000
15858	1397	1403476481000
15859	1678	3600093619000
15860	1397	1403466480000
15861	1678	3600093620000
15862	1397	1403456479000
15863	1678	3600093621000
15864	1696	7918131000000
15865	1696	7918161000000
15866	1397	1403446478000
15867	1678	3600093622000
15868	1397	1403436477000
15869	1678	3600093623000
15870	1746	3599040000000
15871	1746	3599060000000
15883	1397	1403396473000
15884	1678	3600093627000
15885	1397	1403386472000
15886	1678	3600093628000
15887	1402	38880991000000
15888	1749	7915098000000
15889	1749	7915138000000
15895	1726	916900000000
15896	1838	200000000
15897	1397	1403356469000
15898	1678	3600093631000
15899	1696	8638161000000
15900	1696	8638271000000
15904	641	78960480000000
15905	641	78960590000000
15906	1397	1403346468000
15907	1678	3600093632000
15908	1397	1403336467000
15909	1678	3600093633000
15910	1602	8640260000000
15911	1602	8640280000000
15912	1397	1403326466000
15913	1678	3600093634000
15914	1397	1403316465000
15915	1678	3600093635000
15916	1623	16561440899898
15917	1623	16561460899898
15944	1397	1403236457000
15945	1678	3600093643000
15946	1688	69121203000000
15962	1397	1403166450000
15963	1678	3600093650000
15971	1637	52561412000000
15972	1637	52561422000000
15977	1397	1403136447000
15978	1678	3600093653000
15979	1397	1403126446000
15980	1678	3600093654000
15981	576	75360250000000
15982	576	75360270000000
16003	1656	13680311000000
16020	1397	1403026436000
16021	1678	3600093664000
16022	1397	1403016435000
16023	1678	3600093665000
16024	1675	7200270000000
16025	1675	7200320000000
16032	1397	1403006434000
16033	1678	3600093666000
16044	1397	1402966430000
16045	1678	3600093670000
16046	1749	8635138000000
16047	1749	8635148000000
16064	1397	1402906424000
16065	1678	3600093676000
16066	1397	1402896423000
16067	1678	3600093677000
16068	1681	15839345195920
16069	1681	15839365195920
16099	1397	1402826416000
16100	1678	3600093684000
16101	1397	1402816415000
16102	1678	3600093685000
16103	1683	381604069999541
16104	1683	381604089999541
16107	1739	9359340000000
16108	1739	9359360000000
15490	1397	1404376571000
15491	1678	3600093529000
15492	1397	1404366570000
15493	1678	3600093530000
15494	1608	9360130000000
15495	1608	9360260000000
15498	1397	1404356569000
15499	1678	3600093531000
15522	1679	36000282000000
15523	1679	36000292000000
15530	1726	919500000000
15531	1836	200000000
15532	1397	1404296563000
15533	1678	3600093537000
15534	1683	364323799999541
15535	1683	364323909999541
15558	1397	1404236557000
15559	1678	3600093543000
15560	1397	1404226556000
15561	1678	3600093544000
15593	1402	38160841000000
15594	1402	38160951000000
15595	1397	1404126546000
15596	1678	3600093554000
15597	1455	7200121000000
15598	1455	7200131000000
15611	1397	1404106544000
15612	1678	3600093556000
15613	1608	10080260000000
15614	1608	10080270000000
15622	1622	4320050000000
15643	1671	12240900000000
15663	1397	1403976531000
15664	1678	3600093569000
15665	1397	1403966530000
15666	1678	3600093570000
15667	1588	9360130000000
15668	1588	9360140000000
15687	1397	1403906524000
15688	1678	3600093576000
15703	1549	12240391000000
15704	1549	12240401000000
15714	1522	9360210000000
15715	1522	9360220000000
15727	1397	1403816515000
15728	1678	3600093585000
15729	1765	40000000
15730	872	109739603307813
15731	1397	1403806514000
15732	1678	3600093586000
15733	1397	1403796513000
15734	1678	3600093587000
15735	1451	5040210000000
15742	1397	1403766510000
15743	1678	3600093590000
15744	1684	23039660000000
15752	1402	38880951000000
15753	1402	38880962000000
15768	1397	1403716505000
15769	1678	3600093595000
15770	1683	374404009999541
15771	1397	1403706504000
15772	1678	3600093596000
15773	1397	1403696503000
15774	1678	3600093597000
15775	1683	375844009999541
15776	1683	375844029999541
15786	1397	1403666500000
15787	1678	3600093600000
15788	1397	1403656499000
15789	1678	3600093601000
15814	1646	68401193750000
15815	1688	9250000
15844	1654	10080180000000
15850	1397	1403496483000
15851	1678	3600093617000
15852	1397	1403486482000
15853	1678	3600093618000
15854	1683	378724039999541
15855	1683	378724059999541
15872	1704	2159050000000
15873	1688	68401213000000
15903	1668	15120360000000
15938	1560	14400320000000
15939	1560	14400340000000
15943	1457	10800210000000
15952	1397	1403206454000
15953	1678	3600093646000
15964	1546	11520170000000
15965	1546	11520180000000
15967	1397	1403156449000
15968	1678	3600093651000
15969	1693	4639041551364
15970	1693	4639051551364
15983	1397	1403116445000
15984	1678	3600093655000
15991	1397	1403096443000
15992	1678	3600093657000
15993	1397	1403086442000
15994	1678	3600093658000
15995	1397	1403076441000
15996	1678	3600093659000
15997	1724	12958810000000
15998	1724	12958840000000
15999	1397	1403066440000
16000	1678	3600093660000
16001	1683	380164059999541
16002	1683	380164069999541
16011	1706	200000001
16012	1786	11516353499999
16013	1646	18500000
16016	1397	1403036437000
16017	1678	3600093663000
16018	1673	7920500000000
16019	1673	7920530000000
16052	1397	1402946428000
16053	1678	3600093672000
16054	1681	15119335195920
16055	1681	15119345195920
16061	1397	1402916425000
16062	1678	3600093675000
16063	641	78960490000000
16074	1692	39600092000000
16075	1692	39600102000000
16080	1397	1402866420000
16081	1678	3600093680000
16082	369	78960320000000
16083	369	78960330000000
16088	1724	13678840000000
16089	1724	13678850000000
16094	1397	1402836417000
16095	1678	3600093683000
16096	1800	188000000
16097	576	76080270000000
16098	576	76080290000000
16113	1397	1402796413000
16114	1678	3600093687000
16115	1683	383044089999541
16116	1683	383044099999541
16125	1397	1402766410000
16126	1678	3600093690000
16127	1397	1402756409000
16128	1678	3600093691000
16129	1622	5039049999976
16130	1622	5039069999976
15589	1837	200000000
15590	1397	1404136547000
15591	1678	3600093553000
15592	1657	6480220000000
15601	1694	23039485000000
15602	1694	23039495000000
15615	1397	1404096543000
15616	1678	3600093557000
15617	1622	3600050000000
15618	1791	1200000024
15619	1622	4319049999976
15638	1397	1404046538000
15639	1678	3600093562000
15640	152	66000010000000
15641	1671	12240880000000
15642	152	66000020000000
15646	1397	1404036537000
15647	1678	3600093563000
15648	1690	31680011000000
15649	1690	31680031000000
15650	1397	1404026536000
15651	1678	3600093564000
15652	1588	8640120000000
15653	1588	8640130000000
15669	1693	3919041551364
15670	649	66000100000000
15671	1397	1403956529000
15672	1678	3600093571000
15673	1397	1403946528000
15674	1678	3600093572000
15675	1764	9360058000000
15676	1764	9360088000000
15679	1397	1403926526000
15680	1678	3600093574000
15681	1511	720000000000
15682	1511	720010000000
15689	641	77520460000000
15690	641	77520470000000
15699	1637	51121392000000
15700	1637	51121402000000
15710	1397	1403856519000
15711	1678	3600093581000
15712	1709	10797271000000
15713	1709	10797281000000
15718	1601	6120944600000
15719	1397	1403846518000
15720	1678	3600093582000
15723	1397	1403826516000
15724	1678	3600093584000
15725	1440	9360350000000
15726	1440	9360360000000
15745	1397	1403756509000
15746	1678	3600093591000
15747	1769	2946900000
15748	1593	10800260000000
15749	1593	10800271000000
15778	1705	8635030000000
15779	1397	1403686502000
15780	1678	3600093598000
15781	1683	375844019999541
15782	1397	1403676501000
15783	1678	3600093599000
15784	1679	37440302000000
15785	1679	37440312000000
15796	1444	13680480000000
15797	1444	13680500000000
15809	649	66000090000000
15810	1397	1403586492000
15811	1678	3600093608000
15818	1397	1403566490000
15819	1678	3600093610000
15820	1571	10800151000008
15821	1571	10800161000008
15828	1397	1403546488000
15829	1678	3600093612000
15830	1685	37439960000000
15831	1685	37439970000000
15840	1397	1403516485000
15841	1678	3600093615000
15842	1654	10080170000000
15843	1654	10080190000000
15847	1716	11519200000000
15848	1716	11519220000000
15874	1692	38880092000000
15877	1397	1403416475000
15878	1678	3600093625000
15879	1397	1403406474000
15880	1678	3600093626000
15881	1688	69121213000000
15882	1688	69121243000000
15901	1457	10800310000000
15918	1397	1403306464000
15919	1678	3600093636000
15920	1397	1403296463000
15921	1678	3600093637000
15922	510	66719990000000
15923	1679	38160312000000
15924	1679	38160332000000
15927	1397	1403276461000
15928	1678	3600093639000
15929	1541	6477248000000
15930	1541	6477258000000
15933	1397	1403266460000
15934	1678	3600093640000
15935	1397	1403256459000
15936	1678	3600093641000
15937	618	66720020000000
15947	1397	1403226456000
15948	1678	3600093644000
15949	1397	1403216455000
15950	1678	3600093645000
15951	1700	8639450000000
15985	1397	1403106444000
15986	1678	3600093656000
15987	1711	13679200000000
15988	1711	13679210000000
16004	1587	10800170000000
16014	1527	250000000
16015	1427	719750000000
16026	45	200000010
16027	1837	66000000001050
16028	1675	10000002
16029	1761	7200319999977
16030	1831	200000001
16031	1786	200000001
16034	1397	1402996433000
16035	1678	3600093667000
16036	1684	23759660000000
16037	1684	23759670000000
16048	1397	1402956429000
16049	1678	3600093671000
16050	1693	5359051551364
16051	1693	5359061551364
16076	1397	1402876421000
16077	1678	3600093679000
16078	1623	17281460899898
16079	1623	17281470899898
16105	1679	39600342000000
16106	1679	39600362000000
16117	1397	1402786412000
16118	1678	3600093688000
16119	1688	70561223000000
16120	1688	70561233000000
15957	1678	3600093648000
15958	1397	1403176451000
15959	1678	3600093649000
15960	1637	51841402000000
15961	1637	51841412000000
15966	1698	14399281000000
15973	1397	1403146448000
15974	1678	3600093652000
15975	1271	1337646040000000
15976	1271	1337646050000000
15989	1685	38159970000000
15990	1685	38159980000000
16005	1397	1403056439000
16006	1678	3600093661000
16007	1397	1403046438000
16008	1678	3600093662000
16009	1706	11516352000000
16010	1706	11516372000000
16038	1397	1402986432000
16039	1678	3600093668000
16040	1397	1402976431000
16041	1678	3600093669000
16042	1759	12960189000000
16043	1759	12960209000000
16056	1397	1402936427000
16057	1678	3600093673000
16058	1397	1402926426000
16059	1678	3600093674000
16060	1637	52561432000000
16070	1397	1402886422000
16071	1678	3600093678000
16072	1694	23759505000000
16073	1694	23759515000000
16084	1397	1402856419000
16085	1678	3600093681000
16086	1613	8638400000000
16087	1613	8638410000000
16090	1397	1402846418000
16091	1678	3600093682000
16092	1679	38880332000000
16093	1679	38880342000000
16109	1397	1402806414000
16110	1678	3600093686000
16111	1688	69841213000000
16112	1688	69841223000000
16121	1397	1402776411000
16122	1678	3600093689000
16123	470	78240301000000
16124	470	78240311000000
16131	1656	14400311000000
16132	1726	915600000000
16133	1839	200000000
16134	1397	1402746408000
16135	1678	3600093692000
16136	1397	1402736407000
16137	1678	3600093693000
16138	1560	15120340000000
16139	1560	15120460000000
16140	1397	1402726406000
16141	1678	3600093694000
16142	1397	1402716405000
16143	1678	3600093695000
16144	1611	5760100000000
16145	1611	5760110000000
16146	1397	1402706404000
16147	1678	3600093696000
16148	1397	1402696403000
16149	1678	3600093697000
16150	1509	14400321000000
16151	1474	10074243000000
16152	1474	10074263000000
16153	1740	12956673000000
16154	1683	383044109999541
16155	1397	1402686402000
16156	1678	3600093698000
16157	1594	9360260000000
16158	1594	9360270000000
16159	1637	53281432000000
16160	1637	53281442000000
16161	1397	1402676401000
16162	1678	3600093699000
16163	1683	384484109999541
16164	1683	384484119999541
16165	576	76800290000000
16166	576	76800300000000
16167	1397	1402666400000
16168	1678	3600093700000
16169	1444	14400500000000
16170	1444	14400510000000
16171	1397	1402656399000
16172	1678	3600093701000
16173	1688	71281233000000
16174	1688	71281243000000
16175	1397	1402646398000
16176	1678	3600093702000
16177	1397	1402636397000
16178	1678	3600093703000
16179	1451	5760210000000
16180	1451	5760230000000
16181	1764	10080088000000
16182	1764	10080108000000
16183	1397	1402626396000
16184	1678	3600093704000
16185	1397	1402616395000
16186	1678	3600093705000
16187	1397	1402606394000
16188	1678	3600093706000
16189	1746	3599070000000
16190	1747	4319180000000
16191	1610	11520380000000
16192	1704	2159060000000
16193	1397	1402596393000
16194	1678	3600093707000
16195	1693	6079061551364
16196	1693	6079071551364
16197	1397	1402586392000
16198	1678	3600093708000
16199	1559	13680270000000
16200	1559	13680280000000
16201	1397	1402576391000
16202	1678	3600093709000
16203	1397	1402566390000
16204	1678	3600093710000
16205	1683	385924119999541
16206	1683	385924129999541
16207	1397	1402556389000
16208	1678	3600093711000
16209	1397	1402546388000
16210	1678	3600093712000
16211	1634	10080180000000
16212	1634	10080200000000
16213	1568	10080189899999
16214	1634	100000
16215	1831	1210000024
16216	1791	200000002
16217	1681	16559365195920
16218	379	66000090001000
16219	43	74640209999000
16220	1397	1402536387000
16221	1678	3600093713000
16222	1397	1402526386000
16223	1678	3600093714000
16224	43	74640210000000
16225	43	74640230000000
16226	43	75360230000000
16227	43	75360209999000
16228	1397	1402516385000
16229	1678	3600093715000
16230	1679	39600352000000
16231	1397	1402506384000
16232	1678	3600093716000
16233	1397	1402496383000
16234	1678	3600093717000
16235	1705	9355030000000
16236	1705	9355050000000
16237	1397	1402486382000
16238	1678	3600093718000
16239	1397	1402476381000
16240	1678	3600093719000
16241	1476	11520210000000
16242	1476	11520230000000
16243	1397	1402466380000
16244	1678	3600093720000
16245	458	66002390000000
16246	42	72480220000000
16247	1397	1402456379000
16248	1678	3600093721000
16249	1601	6840915600000
16250	1601	6840925600000
16251	711	3002390000000
16252	1397	1402446378000
16253	1678	3600093722000
16254	1633	7200110000000
16255	1513	6480090000000
16256	1513	6480110000000
16257	1397	1402436377000
16258	1678	3600093723000
16259	1397	1402426376000
16260	1678	3600093724000
16261	1445	9360200000000
16262	1445	9360220000000
16263	1397	1402416375000
16264	1678	3600093725000
16265	1397	1402406374000
16266	1678	3600093726000
16267	1397	1402396373000
16268	1678	3600093727000
16269	1521	2157080000000
16270	1521	2157100000000
16279	1397	1402356369000
16280	1678	3600093731000
16292	1397	1402326366000
16293	1678	3600093734000
16294	1683	387364139999541
16301	1397	1402316365000
16302	1678	3600093735000
16303	1679	40320352000000
16304	1679	40320362000000
16309	1397	1402286362000
16310	1678	3600093738000
16311	1397	1402276361000
16312	1678	3600093739000
16313	1622	5759069999976
16314	1622	5759089999976
16328	1397	1402246358000
16329	1678	3600093742000
16330	1714	14389130000000
16331	1714	14389140000000
16340	1397	1402216355000
16341	1678	3600093745000
16342	1397	1402206354000
16343	1678	3600093746000
16344	1688	72001243000000
16345	1688	72001263000000
16378	1397	1402126346000
16379	1678	3600093754000
16380	1637	54721452000000
16381	1637	54721462000000
16392	1402	38880961000000
16395	1397	1402086342000
16396	1678	3600093758000
16397	1593	10800270000000
16399	1623	18001470899898
16400	1623	18001480899898
16405	1714	14389150000000
16406	1714	15109150000000
16413	1397	1402056339000
16414	1678	3600093761000
16415	1683	390244159999541
16418	1601	7560925600000
16419	1601	7560935600000
16440	1397	1402016335000
16441	1678	3600093765000
16462	1397	1401946328000
16463	1678	3600093772000
16464	1759	13680209000000
16465	1759	13680219000000
16470	1573	12960390000000
16483	1397	1401896323000
16484	1678	3600093777000
16485	1671	12960900000000
16486	1671	12960910000000
16487	1489	8640181000000
16488	1489	8640191000000
16498	1729	8639140000000
16499	1729	8639150000000
16507	1397	1401836317000
16508	1678	3600093783000
16509	1397	1401826316000
16510	1678	3600093784000
16511	1700	9359470000000
16520	1397	1401786312000
16521	1678	3600093788000
16542	1840	899000000
16543	1639	718119000000
16544	1683	396004199999541
16545	1683	396004200999541
16548	1729	9359150000000
16549	1693	7519101551364
16556	1608	10800270000000
16557	1643	3204253113700
16570	1841	899000000
16571	1639	716218000000
16572	1448	8640261000000
16577	1840	8000000
16578	1841	1789000000
16579	1402	39600971000000
16580	1402	39600972000000
16583	1840	898000000
16584	1684	24479672000000
16586	1840	0
16587	1841	1796000000
16588	1716	12239220000000
16589	1716	12239221000000
16590	1683	403204200999541
16593	1840	897000000
16594	1419	12960260000000
16595	1419	12960263000000
16597	1683	404644200999541
16604	596	80400282000000
16605	596	80400283000000
16608	1692	41040102000000
16609	1692	41040103000000
16618	1677	162003433000000
16636	1715	14399331000000
16637	1715	14400031000000
16643	1643	3924253113700
16645	1679	41760363000000
16649	1643	4644253113700
16658	1675	7920319999977
16660	1402	40320971000000
16666	1726	905200000000
16667	1844	1400000000
16668	1693	7519201551364
16672	1672	10800260000000
16680	1426	7921640000000
16691	1679	42480363000000
16697	1637	58321473000000
16698	1637	58321573000000
16700	1519	2879020000000
16701	1714	17989150000000
16704	1694	26639535000000
16707	1711	14399210000000
16711	1690	35280051000000
16714	1762	5759220000000
16724	1489	10080191000000
16733	1703	7919200000000
16734	1541	7917248000000
16736	1683	424804300999541
16739	1690	36720051000000
16750	1683	426244300999541
16754	484	80400222000000
16756	1455	10080141000000
16757	484	81120222000000
16767	1693	8959201551364
16770	1695	10799181000000
16771	1759	14400219000000
16774	1549	12960391000000
16776	1682	8625451000000
16777	1850	1000000000
16778	1716	12959231000000
16785	1623	19441490899898
16789	1690	38160051000000
16796	1723	12959820000000
16797	1723	12959830000000
16798	1683	432004300999541
16806	1715	15840041000000
16816	44	74640330000000
16818	1471	10080150000000
16820	1419	14401074900000
16821	1843	100000000
16822	1546	12240170000000
16823	1546	12240270000000
16826	1402	42480971000000
16828	1688	73441253000000
16830	1688	74161253000000
16833	1397	1401726306000
16834	1678	3600093794000
16835	1637	61921673000000
16836	1637	61921683000000
16841	1397	1401706304000
16842	1678	3600093796000
16843	1397	1401696303000
16844	1678	3600093797000
16845	1700	10079490000000
16888	1397	1401576291000
16889	1678	3600093809000
16890	1397	1401566290000
16891	1678	3600093810000
16892	1671	14400910000000
16893	1671	14400930000000
16897	1397	1401546288000
16898	1678	3600093812000
16899	1397	1401536287000
16900	1678	3600093813000
16918	1397	1401466280000
16919	1678	3600093820000
16920	1397	1401456279000
16921	1678	3600093821000
16922	1560	17280480000000
16923	1560	17280500000000
16924	1397	1401446278000
16925	1678	3600093822000
16926	1764	12240118000000
16927	1764	12240128000000
16932	1739	9359380000000
16933	416	66000010000000
16934	1739	10079370000000
16964	1397	1401326266000
16965	1678	3600093834000
16271	1397	1402386372000
16272	1678	3600093728000
16273	1397	1402376371000
16274	1678	3600093729000
16275	1471	8640130000000
16276	1471	8640150000000
16281	1397	1402346368000
16282	1678	3600093732000
16283	1397	1402336367000
16284	1678	3600093733000
16285	1683	387364129999541
16286	1683	387364149999541
16291	1756	12239739000000
16295	1719	6479180000000
16296	1719	6479190000000
16305	1397	1402306364000
16306	1678	3600093736000
16315	1683	388804139999541
16316	1683	388804159999541
16321	484	78960211000000
16322	484	78960221000000
16346	641	79680490000000
16347	641	79680510000000
16352	1397	1402186352000
16353	1678	3600093748000
16354	1476	12240230000000
16355	1476	12240240000000
16356	1397	1402176351000
16357	1678	3600093749000
16358	1637	54001442000000
16359	1637	54001452000000
16372	1397	1402136347000
16373	1678	3600093753000
16374	1672	10080260000000
16375	1672	10080270000000
16382	1397	1402116345000
16383	1678	3600093755000
16384	1397	1402106344000
16385	1678	3600093756000
16386	1634	10800189899999
16387	1634	10800209899999
16398	1622	5759079999976
16410	1564	6480072000000
16411	1564	6480082000000
16412	1518	2161250000000
16416	1696	9358271000000
16417	1696	9358281000000
16420	1397	1402046338000
16421	1678	3600093762000
16422	1683	391684169999541
16423	1683	391684179999541
16428	1397	1402036337000
16429	1678	3600093763000
16438	1637	55441462000000
16439	1637	55441472000000
16442	1573	12240380000000
16443	1573	12240390000000
16447	1397	1401996333000
16448	1678	3600093767000
16458	1397	1401956329000
16459	1678	3600093771000
16460	1683	393124179999541
16461	1683	393124189999541
16471	1397	1401926326000
16472	1678	3600093774000
16473	470	78960311000000
16474	470	78960321000000
16477	1397	1401916325000
16478	1678	3600093775000
16489	1397	1401886322000
16490	1678	3600093778000
16491	1397	1401876321000
16492	1678	3600093779000
16493	1587	10800190000000
16500	1397	1401856319000
16501	1678	3600093781000
16502	1397	1401846318000
16503	1678	3600093782000
16504	1694	24479515000000
16505	1694	24479535000000
16529	1397	1401756309000
16530	1678	3600093791000
16531	1397	1401746308000
16532	1678	3600093792000
16533	1397	1401736307000
16534	1678	3600093793000
16535	1690	32400031000000
16536	1690	32400051000000
16537	1633	7920110000000
16539	1633	8640110000000
16541	1536	13680280000000
16550	1683	397444200999541
16554	1683	398884200999541
16561	1714	15829140000000
16573	1683	401764200999541
16575	1694	25199735000000
16576	1694	25199847000000
16591	1445	10080200000000
16598	1683	406084200999541
16606	1685	40319970000000
16607	1685	40319971000000
16610	369	79680330000000
16617	1683	408964200999541
16641	1714	16549140000000
16647	1637	57601473000000
16650	369	80400330000000
16653	95	66720000000000
16655	1506	8640170000000
16657	1611	7920110000000
16661	1690	33840051000000
16664	1701	10798312000000
16670	1683	416164200999541
16673	1715	15120031000000
16675	1802	0
16676	1833	390000000
16677	1426	7920260000000
16678	1426	7920270000000
16683	1560	16560480000000
16684	1650	8640220000000
16686	1693	8239201551364
16690	1716	12959221000000
16692	1749	10075168000000
16702	1683	420484300999541
16703	42	73920220000000
16705	1402	41760971000000
16708	1690	34560051000000
16718	1688	72721343000000
16720	1690	36000051000000
16729	576	77520300000000
16735	1567	720000000101
16747	1508	9360110000000
16748	1508	9360120000000
16752	1594	10080270000000
16759	1633	9360110000000
16760	1419	12961174000000
16761	1419	13681174000000
16762	1419	200000
16763	1568	13681174900000
16765	1457	11520210000000
16766	1683	429124300999541
16768	1587	12240190000000
16769	1681	17999365195920
16772	1637	60481473000000
16775	1735	4300933000000
16779	1682	1441000000
16780	1850	8625000000000
16781	1688	72721253000000
16786	1700	10079470000000
16790	1633	10080110000000
16792	1717	10079242000000
16799	1679	43200363000000
16801	43	76080230000000
16802	1726	903900000000
16803	1851	200000000
16804	1509	14400401000000
16807	1727	8640021000000
16808	1727	8640151000000
16812	1637	61201473000000
16813	1637	61201673000000
16817	1613	10078410000000
16829	1571	12240151000008
16837	1692	43200103000000
16838	1692	43200113000000
16854	1397	1401666300000
16855	1678	3600093800000
16856	1683	433444300999541
16857	1683	433444310999541
16867	1397	1401636297000
16868	1678	3600093803000
16869	1764	11520108000000
16870	1764	11520118000000
16883	1397	1401586292000
16884	1678	3600093808000
16885	1683	434884320999541
16901	1397	1401526286000
16902	1678	3600093814000
16903	1397	1401516285000
16904	1678	3600093815000
16905	1397	1401506284000
16906	1678	3600093816000
16907	1683	436324320999541
16908	1683	436324350999541
16948	1397	1401386272000
16949	1678	3600093828000
16950	1397	1401376271000
16277	1397	1402366370000
16278	1678	3600093730000
16287	1560	15840460000000
16288	1560	15840480000000
16297	1740	13676663000000
16298	1740	13676673000000
16299	1692	40320102000000
16300	1692	40320112000000
16327	1513	6480100000000
16332	1397	1402236357000
16333	1678	3600093743000
16338	1670	15120490000000
16339	1670	15120500000000
16360	1397	1402166350000
16361	1678	3600093750000
16362	1397	1402156349000
16363	1678	3600093751000
16364	1749	9355148000000
16365	1749	9355168000000
16376	1654	10800180000000
16377	1654	10800190000000
16401	1397	1402076341000
16402	1678	3600093759000
16403	1683	388804169999541
16404	1683	390244169999541
16424	1467	7921590000000
16425	1467	7921600000000
16426	1455	7920131000000
16427	1455	7920141000000
16430	1397	1402026336000
16431	1678	3600093764000
16432	1649	10080290999992
16433	1649	10080300999992
16436	1705	10075050000000
16437	1705	10075060000000
16444	1397	1402006334000
16445	1678	3600093766000
16446	1650	7920220000000
16449	1397	1401986332000
16450	1678	3600093768000
16451	1397	1401976331000
16452	1678	3600093769000
16453	1688	72001283000000
16466	1397	1401936327000
16467	1678	3600093773000
16468	1762	5039110000000
16469	1762	5039120000000
16475	700	70320080000000
16476	700	70320090000000
16479	1397	1401906324000
16480	1678	3600093776000
16481	44	73920320000000
16482	44	73920330000000
16494	1397	1401866320000
16495	1678	3600093780000
16496	1683	394564189999541
16497	1683	394564199999541
16512	1397	1401816315000
16513	1678	3600093785000
16522	1643	2484243113700
16523	1643	2484253113700
16540	1740	14396673000000
16546	1637	56881472000000
16547	1637	56881473000000
16551	1448	8640260000000
16552	1708	7919230000000
16553	1690	33120051000000
16555	484	79680221000000
16558	1714	15109140000000
16562	1683	400324200999541
16564	1639	716118000000
16565	1841	1000000000
16566	1717	9359241000000
16567	1717	9359242000000
16569	1705	10795060000000
16574	1694	25199535000000
16581	1679	41040362000000
16582	1679	41040363000000
16585	1613	9358410000000
16592	1685	39599970000000
16596	1455	8640141000000
16599	1683	407524200999541
16612	1692	41760103000000
16613	1750	4195000000
16614	1842	100000000
16619	1683	410404200999541
16638	1769	2945900000
16639	484	79680222000000
16642	1611	6480110000000
16651	1683	411844200999541
16652	1691	6479100000000
16654	1688	72721243000000
16659	1689	9359181000000
16671	1571	11520151000008
16674	1683	417604200999541
16682	1702	7194101000000
16685	1643	5364253113700
16687	1402	41040971000000
16694	240	66001100000000
16695	1683	419044200999541
16696	1683	419044300999541
16699	1694	25919535000000
16709	1541	7197248000000
16713	1762	5759120000000
16715	1611	8640110000000
16716	1747	5039150000000
16722	1611	9360110000000
16723	1455	9360141000000
16725	1764	10800108000000
16728	1562	720000000000
16730	1714	18709150000000
16731	1602	9360280000000
16732	1727	7920021000000
16737	171	75360130000000
16738	1623	19441480899898
16741	1690	37440051000000
16742	1694	27359535000000
16744	1637	59041473000000
16745	1562	990000000
16746	492	66719000000000
16749	42	75360220000000
16783	1549	13680391000000
16784	1549	13680401000000
16788	1683	430564300999541
16791	1685	42479970000000
16794	1694	28079535000000
16795	1715	15120041000000
16800	1448	10080261000000
16809	1844	1300000000
16810	1844	1200000000
16811	369	80400530000000
16819	171	76080130000000
16825	1607	16560412000000
16827	1509	15120401000000
16831	1701	11518312000000
16832	1464	720000000000
16839	1397	1401716305000
16840	1678	3600093795000
16850	1397	1401676301000
16851	1678	3600093799000
16852	1398	720000000000
16853	1398	720010000000
16865	1670	15840500000000
16866	1670	15840510000000
16879	1692	43920113000000
16880	1692	43920143000000
16881	1397	1401596293000
16882	1678	3600093807000
16894	1397	1401556289000
16895	1678	3600093811000
16896	1690	38160061000000
16910	1397	1401496283000
16911	1678	3600093817000
16912	1397	1401486282000
16913	1678	3600093818000
16914	1397	1401476281000
16915	1678	3600093819000
16916	1593	11520260000000
16917	1593	11520290000000
16928	1397	1401436277000
16929	1678	3600093823000
16930	1688	74161263000000
16931	1688	74881263000000
16943	1397	1401406274000
16944	1678	3600093826000
16945	1397	1401396273000
16946	1678	3600093827000
16947	1689	9359201000000
16976	1397	1401286262000
16977	1678	3600093838000
16978	1397	1401276261000
16979	1678	3600093839000
16980	1693	9679201551364
16981	1693	9679221551364
16998	1402	42481181000000
17008	1397	1401216255000
17009	1678	3600093845000
17010	1397	1401206254000
17011	1678	3600093846000
17012	1685	43199970000000
17013	1685	43199990000000
17035	1657	6480120000000
17053	1593	12240290000000
17054	1593	12240300000000
17061	470	78960331000000
16289	1508	8640110000000
16290	1508	8640130000000
16307	1397	1402296363000
16308	1678	3600093737000
16317	1397	1402266360000
16318	1678	3600093740000
16319	1422	5760060000000
16320	1422	5760070000000
16323	1397	1402256359000
16324	1678	3600093741000
16325	1684	24479670000000
16326	1684	24479680000000
16334	1397	1402226356000
16335	1678	3600093744000
16336	1700	9359450000000
16337	1700	9359460000000
16348	1397	1402196353000
16349	1678	3600093747000
16350	1573	11520370000000
16351	1573	11520380000000
16366	1397	1402146348000
16367	1678	3600093752000
16368	1639	718019000000
16369	1840	1000000000
16370	1717	8639230000000
16371	1717	8639241000000
16388	1397	1402096343000
16389	1678	3600093757000
16390	1447	12240210000000
16391	1447	12240220000000
16393	641	80400510000000
16394	641	80400520000000
16407	1397	1402066340000
16408	1678	3600093760000
16409	1691	5759100000000
16434	1699	3489912500051
16435	1699	3489922500051
16454	1397	1401966330000
16455	1678	3600093770000
16456	1693	6799071551364
16457	1693	6799101551364
16506	1694	24479735000000
16514	1397	1401806314000
16515	1678	3600093786000
16516	1397	1401796313000
16517	1678	3600093787000
16518	596	79680262000000
16519	596	79680282000000
16524	1397	1401776311000
16525	1678	3600093789000
16526	1397	1401766310000
16527	1678	3600093790000
16528	1402	38880971000000
16538	1637	56161472000000
16559	1623	18721480899898
16560	1634	11520209899999
16563	1685	38879970000000
16568	1680	15119280000000
16600	1639	0
16601	1841	718013000000
16602	633	75359260000000
16603	633	75359261000000
16611	1588	10800150000000
16615	1559	14400280000000
16616	1559	14400281000000
16620	1726	914300000000
16621	1843	200000000
16622	1726	913000000000
16623	1844	200000000
16624	1726	911700000000
16625	1845	200000000
16626	1726	910400000000
16627	1846	200000000
16628	1726	909100000000
16629	1847	200000000
16630	1726	907800000000
16631	1848	200000000
16632	1726	906500000000
16633	1849	200000000
16634	1607	15840412000000
16635	1607	15841112000000
16640	1448	9360261000000
16644	1611	7200110000000
16646	1489	9360191000000
16648	1692	42480103000000
16656	1536	14400280000000
16662	1683	413284200999541
16663	1683	414724200999541
16665	1471	9360150000000
16669	42	73200220000000
16679	1714	16549150000000
16681	1681	17279365195920
16688	1740	15116673000000
16689	1714	17269150000000
16693	1587	11520190000000
16706	1685	41039970000000
16710	149	73200140000000
16712	1719	7199190000000
16717	1719	7919190000000
16719	1685	41759970000000
16721	42	74640220000000
16726	1683	421924300999541
16727	1683	423364300999541
16740	1440	10080360000000
16743	1547	5760040000000
16751	1683	427684300999541
16753	1672	11520260000000
16755	1564	7200072000000
16758	1455	10800141000000
16764	1637	59761473000000
16773	1422	6480060000000
16782	1564	7200082000000
16787	1447	12960210000000
16793	1451	6480210000000
16805	1727	8639110000000
16814	1528	720000000000
16815	1528	720200000000
16824	1675	7920419999977
16846	1397	1401686302000
16847	1678	3600093798000
16848	1671	13680900000000
16849	1671	13680910000000
16858	1397	1401656299000
16859	1678	3600093801000
16860	1587	12240200000000
16861	1397	1401646298000
16862	1678	3600093802000
16863	1680	15839280000000
16864	1680	15839290000000
16871	1397	1401626296000
16872	1678	3600093804000
16873	1397	1401616295000
16874	1678	3600093805000
16875	1397	1401606294000
16876	1678	3600093806000
16877	1683	434884310999541
16878	1683	434884340999541
16886	1439	7920120000000
16887	1439	7920130000000
16909	1739	9359370000000
16935	1397	1401426276000
16936	1678	3600093824000
16937	1397	1401416275000
16938	1678	3600093825000
16939	1470	195000000
16940	1805	4200000
16941	1637	200100003
16942	1794	61921683799997
16958	1397	1401346268000
16959	1678	3600093832000
16960	1397	1401336267000
16961	1678	3600093833000
16962	1688	74881253000000
16963	1688	74881273000000
16972	1397	1401296263000
16973	1678	3600093837000
16974	1610	12240380000000
16975	1610	12240390000000
16987	1724	13678860000000
16996	1688	75601273000000
16997	1688	75601483000000
16999	1690	38880061000000
17000	1690	38880271000000
17003	1710	10079230000000
17004	1710	10079240000000
17025	1683	436324340999541
17032	1397	1401146248000
17033	1678	3600093852000
17034	1688	75601283000000
17052	1768	6479171110000
17055	1397	1401086242000
17056	1678	3600093858000
17057	1397	1401076241000
17058	1678	3600093859000
17059	1683	437764340999541
17060	1683	437764360999541
17062	1397	1401066240000
17063	1678	3600093860000
17064	1850	9345000000000
17065	1850	9345010000000
17080	1705	10795080000000
17089	1423	2880050000000
17090	1423	2880060000000
17091	1397	1400986232000
17092	1678	3600093868000
16951	1678	3600093829000
16952	1397	1401366270000
16953	1678	3600093830000
16954	1397	1401356269000
16955	1678	3600093831000
16956	623	66720000000000
16957	623	66720040000000
16967	1397	1401316265000
16968	1678	3600093835000
16969	1397	1401306264000
16970	1678	3600093836000
16971	1594	10080290000000
17005	1397	1401226256000
17006	1678	3600093844000
17007	1650	8640230000000
17016	1703	7919220000000
17021	1397	1401186252000
17022	1678	3600093848000
17023	1397	1401176251000
17024	1678	3600093849000
17036	1397	1401136247000
17037	1678	3600093853000
17038	43	76080240000000
17049	1397	1401096243000
17050	1678	3600093857000
17051	1711	14399220000000
17074	1397	1401026236000
17075	1678	3600093864000
17076	1397	1401016235000
17077	1678	3600093865000
17078	1684	25199670000000
17079	1684	25199690000000
17081	1397	1401006234000
17082	1678	3600093866000
17083	1634	12240209899999
17084	1634	12240219899999
17088	1684	25199680000000
17097	1397	1400976231000
17098	1678	3600093869000
17141	1683	439204470999541
17142	1683	440644470999541
17143	1683	440644590999541
17145	1397	1400886222000
17146	1678	3600093878000
17147	1422	6480070000000
17148	1397	1400876221000
17149	1678	3600093879000
17150	1397	1400866220000
17151	1678	3600093880000
17152	1397	1400856219000
17153	1678	3600093881000
17154	1649	10080320999992
17156	1397	1400846218000
17157	1678	3600093882000
17158	1547	5760050000000
17182	1397	1400776211000
17183	1678	3600093889000
17184	1768	7199171110000
17185	1768	7199181110000
17201	1724	13680620000000
17202	1724	14400620000000
17203	1724	14400650000000
17216	1397	1400696203000
17217	1678	3600093897000
17218	1397	1400686202000
17219	1678	3600093898000
17220	1467	8641590000000
17221	1467	8641610000000
17237	484	81120242000000
17240	1397	1400616195000
17241	1678	3600093905000
17244	1506	10080190000000
17245	1506	10080200000000
17275	1560	18720580000000
17296	1397	1400466180000
17297	1678	4320143920000
17298	1447	13680210000000
17299	1447	13680220000000
17310	1397	1400436177000
17311	1678	4320143923000
17312	1680	16559290000000
17313	1680	16559300000000
17314	1397	1400426176000
17315	1678	4320143924000
17316	1677	162723343000000
17317	1677	162723353000000
17319	1493	1440010000000
17320	1493	1440020000000
17327	1397	1400396173000
17328	1678	4320143927000
17329	1691	6479110000000
17334	1397	1400376171000
17335	1678	4320143929000
17336	1673	7920510000000
17337	1673	8640510000000
17338	1397	1400366170000
17339	1678	4320143930000
17340	1681	18719375195920
17341	1681	18719385195920
17350	1601	8280925600000
17351	1601	8280955600000
17355	1397	1400326166000
17356	1678	4320143934000
17370	1685	43919990000000
17371	1685	43920000000000
17372	1397	1400296163000
17373	1678	4320143937000
17374	1397	1400286162000
17375	1678	4320143938000
17376	1522	10800230000000
17377	1522	10800250000000
17380	1397	1400276161000
17381	1678	4320143939000
17382	1397	1400266160000
17383	1678	4320143940000
17384	1683	444964620999541
17385	1683	444964640999541
17473	1397	1400086142000
17474	1678	4320143958000
17475	1397	1400076141000
17476	1678	4320143959000
17477	1471	10800150000000
17478	1471	10800170000000
17512	1397	1399986132000
17513	1678	4320143968000
17514	1677	163443393000000
17515	1677	163443403000000
17521	1397	1399966130000
17522	1678	4320143970000
17523	1397	1399956129000
17524	1678	4320143971000
17525	1693	12559261551364
17526	1693	12559281551364
17535	1397	1399926126000
17536	1678	4320143974000
17537	1397	1399916125000
17538	1678	4320143975000
17539	1673	9360510000000
17540	1673	9360530000000
17543	1397	1399906124000
17544	1678	4320143976000
17545	1762	6479130000000
17546	1762	6479140000000
17557	1397	1399866120000
17558	1678	4320143980000
17577	1683	449284660999541
17578	1683	449284680999541
17581	1397	1399806114000
17582	1678	4320143986000
17592	1397	1399776111000
17593	1678	4320143989000
17594	1677	164163403000000
17595	1677	164163413000000
17619	1397	1399696103000
17620	1678	4320143997000
17621	1573	12960400000000
17622	1573	12960410000000
17642	1397	1399646098000
17643	1678	4320144002000
17644	1690	39600191000000
17645	1690	39600201000000
17650	1397	1399616095000
17651	1678	4320144005000
17652	1673	9360520000000
17655	1508	10080760000000
17658	1692	44640143000000
17659	1692	44640153000000
17666	1691	7199110000000
17667	1691	7199120000000
17687	1397	1399536087000
17688	1678	4320144013000
17689	1397	1399526086000
17690	1678	4320144014000
17691	1698	16559301000000
17692	1698	16559321000000
17695	1397	1399516085000
17696	1678	4320144015000
17697	1397	1399506084000
17698	1678	4320144016000
17699	1397	1399496083000
17700	1678	4320144017000
17701	1397	1399486082000
17702	1678	4320144018000
17703	1692	43919113000000
17704	1860	10000000
16966	596	80400292000000
16982	1397	1401266260000
16983	1678	3600093840000
16984	1397	1401256259000
16985	1678	3600093841000
16986	1724	13679740000000
16988	1726	902600000000
16989	1852	200000000
16990	1726	901300000000
16991	1853	200000000
16992	1397	1401246258000
16993	1678	3600093842000
16994	1679	43920363000000
16995	1679	43920573000000
17001	1397	1401236257000
17002	1678	3600093843000
17014	1702	7194091000000
17015	1702	7194111000000
17017	1397	1401196253000
17018	1678	3600093847000
17019	1588	11520150000000
17020	1588	11520160000000
17026	1397	1401166250000
17027	1678	3600093850000
17028	1397	1401156249000
17029	1678	3600093851000
17030	1506	9360170000000
17031	1506	9360190000000
17039	1397	1401126246000
17040	1678	3600093854000
17041	1397	1401116245000
17042	1678	3600093855000
17043	1445	10800200000000
17044	1445	10800220000000
17045	1397	1401106244000
17046	1678	3600093856000
17047	1693	10399221551364
17048	1693	10399231551364
17069	1397	1401046238000
17070	1678	3600093862000
17071	1397	1401036237000
17072	1678	3600093863000
17073	1679	43920383000000
17085	1397	1400996233000
17086	1678	3600093867000
17087	1546	12240180000000
17095	1522	10080220000000
17096	1522	10080230000000
17100	1397	1400966230000
17101	1678	3600093870000
17102	1397	1400956229000
17103	1678	3600093871000
17109	1457	12240210000000
17110	1457	12240220000000
17115	1397	1400916225000
17116	1678	3600093875000
17117	596	81120292000000
17118	596	81120302000000
17135	1474	9354343000000
17136	1474	10074343000000
17137	1568	898700000001
17138	1726	200000
17139	1794	10074462899968
17140	1474	200100034
17159	1397	1400836217000
17160	1678	3600093883000
17161	1536	15120280000000
17162	1536	15120290000000
17172	1402	43201181000000
17173	1402	43201191000000
17176	1397	1400796213000
17177	1678	3600093887000
17178	1397	1400786212000
17179	1678	3600093888000
17180	1637	62641683799997
17181	1637	62641703799997
17192	1397	1400746208000
17193	1678	3600093892000
17194	1397	1400736207000
17195	1678	3600093893000
17196	1690	38880081000000
17231	1397	1400646198000
17232	1678	3600093902000
17233	1397	1400636197000
17234	1678	3600093903000
17235	1571	12960161000008
17236	1571	12960181000008
17238	1397	1400626196000
17239	1678	3600093904000
17263	1397	1400576191000
17264	1678	3600093909000
17265	1397	1400566190000
17266	1678	3600093910000
17267	1397	1400556189000
17268	1678	3600093911000
17269	1397	1400546188000
17270	1678	3600093912000
17271	1397	1400536187000
17272	1678	3600093913000
17273	1708	8639230000000
17274	1708	8639280000000
17282	1637	64081723799997
17283	1637	64081733799997
17306	1559	15120280000000
17307	1559	15120290000000
17308	1397	1400446178000
17309	1678	4320143922000
17321	1397	1400416175000
17322	1678	4320143925000
17323	1397	1400406174000
17324	1678	4320143926000
17325	1717	10799242000000
17326	1717	10799262000000
17342	1397	1400356169000
17343	1678	4320143931000
17344	1397	1400346168000
17345	1678	4320143932000
17346	1397	1400336167000
17347	1678	4320143933000
17348	1445	11520220000000
17349	1445	11520250000000
17354	1757	719030000000
17360	1714	18709160000000
17417	1693	11839241551364
17418	1693	11839251551364
17425	1397	1400226156000
17426	1678	4320143944000
17430	1397	1400206154000
17431	1678	4320143946000
17432	1397	1400196153000
17433	1678	4320143947000
17434	1397	1400186152000
17435	1678	4320143948000
17436	1546	12240200000000
17440	1397	1400176151000
17441	1678	4320143949000
17442	1684	25919680000000
17443	1684	25919690000000
17453	1397	1400136147000
17454	1678	4320143953000
17455	1397	1400126146000
17456	1678	4320143954000
17457	1687	13679221000000
17458	1687	13679241000000
17469	1700	10799490000000
17470	1700	10799500000000
17471	1397	1400096143000
17472	1678	4320143957000
17483	1397	1400056139000
17484	1678	4320143961000
17485	1698	15119281000000
17486	1698	15119291000000
17493	1397	1400026136000
17494	1678	4320143964000
17495	1397	1400016135000
17496	1678	4320143965000
17497	877	203054343117107
17498	1772	728750000000
17499	127	66001471816426
17500	1772	880750000000
17501	878	203055343117107
17502	1772	1091750000000
17503	1677	162723393000000
17519	1397	1399976131000
17520	1678	4320143969000
17529	1397	1399946128000
17530	1678	4320143972000
17531	1397	1399936127000
17532	1678	4320143973000
17533	1688	76321283000000
17534	1688	76321303000000
17551	1601	9000955600000
17552	1601	9000965600000
17562	1397	1399856119000
17563	1678	4320143981000
17564	1397	1399846118000
17565	1678	4320143982000
17566	1439	7920140000000
17571	1397	1399826116000
17572	1678	4320143984000
17573	1397	1399816115000
17574	1678	4320143985000
17575	1467	9361610000000
17576	1467	9361630000000
17579	1701	12238312000000
17066	1397	1401056239000
17067	1678	3600093861000
17068	1681	17999375195920
17094	1746	3599050000000
17106	1397	1400936227000
17107	1678	3600093873000
17108	1451	6480220000000
17111	1397	1400926226000
17112	1678	3600093874000
17113	1683	439204360999541
17114	1683	439204370999541
17119	1726	900000000000
17120	1854	200000000
17121	1688	74881373000000
17122	1726	898700000000
17123	1855	200000000
17124	1397	1400906224000
17125	1678	3600093876000
17126	1397	1400896223000
17127	1678	3600093877000
17128	1688	75601373000000
17129	1688	898700000006
17130	1726	75601401099986
17131	1831	1600600000
17132	1758	201700002
17133	416	200100011
17134	1794	66000100000000
17168	1397	1400816215000
17169	1678	3600093885000
17170	1693	11119231551364
17171	1693	11119241551364
17174	1397	1400806214000
17175	1678	3600093886000
17199	1705	11515080000000
17200	1705	11515100000000
17214	1560	18000500000000
17215	1560	18000530000000
17225	1397	1400666200000
17226	1678	3600093900000
17227	1397	1400656199000
17228	1678	3600093901000
17229	1729	10079150000000
17230	1729	10079170000000
17254	633	76079260000000
17284	1397	1400516185000
17285	1678	3600093915000
17286	1397	1400506184000
17287	1678	3600093916000
17288	1397	1400496183000
17289	1678	3600093917000
17290	1397	1400486182000
17291	1678	3600093918000
17292	1397	1400476181000
17293	1678	3600093919000
17294	1678	4320093919000
17295	1678	4320143919000
17304	1513	7200100000000
17305	1513	7200110000000
17330	1397	1400386172000
17331	1678	4320143928000
17332	1634	12960219899999
17333	1634	12960229899999
17353	1611	10080140000000
17359	576	77520310000000
17361	1397	1400316165000
17362	1678	4320143935000
17363	1654	11520190000000
17364	1654	11520200000000
17379	1448	10080281000000
17390	1678	3600093920000
17391	1678	3600093921000
17392	1678	3600093922000
17393	1678	3600093923000
17394	1678	3600093924000
17395	1678	3600093925000
17396	1678	3600093926000
17397	1678	3600093927000
17398	1678	3600093928000
17399	1678	3600093929000
17400	1678	3600093930000
17401	1678	3600093931000
17402	1678	3600093932000
17403	1678	3600093933000
17404	1678	3600093934000
17405	1678	3600093935000
17406	1678	3600093936000
17407	1678	3600093937000
17408	1678	3600093938000
17409	1678	3600093939000
17410	1678	3600093940000
17411	1678	3600093941000
17412	1451	7200500000000
17421	1397	1400236157000
17422	1678	4320143943000
17423	1683	446404640999541
17424	1683	446404650999541
17437	1509	15840431000000
17448	1397	1400156149000
17449	1678	4320143951000
17450	1397	1400146148000
17451	1678	4320143952000
17452	1693	11839261551364
17461	1397	1400116145000
17462	1678	4320143955000
17463	1717	11519262000000
17464	1717	11519272000000
17465	1397	1400106144000
17466	1678	4320143956000
17467	1607	17280412000000
17468	1607	17280422000000
17479	1397	1400066140000
17480	1678	4320143960000
17481	1623	20161490899898
17482	1623	20161500899898
17488	1397	1400046138000
17489	1678	4320143962000
17490	1397	1400036137000
17491	1678	4320143963000
17492	1573	12240400000000
17508	1397	1399996133000
17509	1678	4320143967000
17510	1670	16560510000000
17511	1670	16560520000000
17516	1729	10799170000000
17517	1729	10799180000000
17541	1448	10800281000000
17542	1448	10800301000000
17555	1397	1399876121000
17556	1678	4320143979000
17559	1722	88000000
17560	1722	720088000000
17567	1397	1399836117000
17568	1678	4320143983000
17569	1698	15839291000000
17570	1698	15839301000000
17587	1683	450724680999541
17588	1683	450724690999541
17596	1397	1399766110000
17597	1678	4320143990000
17598	1397	1399756109000
17599	1678	4320143991000
17600	1677	164883413000000
17601	1677	164883433000000
17606	1397	1399746108000
17607	1678	4320143992000
17608	1397	1399736107000
17609	1678	4320143993000
17610	1397	1399726106000
17611	1678	4320143994000
17612	1397	1399716105000
17613	1678	4320143995000
17614	1397	1399706104000
17615	1678	4320143996000
17616	1688	77041353000000
17623	1397	1399686102000
17624	1678	4320143998000
17625	1665	719900000000
17626	1397	1399676101000
17627	1678	4320143999000
17628	1670	17280520000000
17629	1670	17280650000000
17631	1397	1399666100000
17632	1678	4320144000000
17633	1422	7200080000000
17636	484	81840242000000
17637	484	81840252000000
17660	1397	1399596093000
17661	1678	4320144007000
17662	1677	165603433000000
17663	1677	165603443000000
17706	1397	1399476081000
17707	1678	4320144019000
17708	1688	77761353000000
17709	1688	77761363000000
17722	1692	43819093000000
17723	1860	100020000000
17724	1397	1399436077000
17725	1678	4320144023000
17726	1665	717880000000
17727	1861	1010000000
17728	1685	45360010000000
17729	1685	45360040000000
17744	1397	1399396073000
17745	1678	4320144027000
17762	1861	717990000000
17093	1747	5039160000000
17099	1656	14400321000000
17104	1397	1400946228000
17105	1678	3600093872000
17144	1474	10074463000000
17155	149	73200170000000
17163	1633	10800110000000
17164	1633	10800120000000
17165	1397	1400826216000
17166	1678	3600093884000
17167	1571	12240161000008
17186	1397	1400766210000
17187	1678	3600093890000
17188	1397	1400756209000
17189	1678	3600093891000
17190	1683	442084590999541
17191	1683	442084610999541
17197	1683	443524610999541
17198	1683	443524630999541
17204	1724	14398860000000
17205	1724	14398880000000
17206	1397	1400726206000
17207	1678	3600093894000
17208	1397	1400716205000
17209	1678	3600093895000
17210	1397	1400706204000
17211	1678	3600093896000
17212	1422	7200070000000
17213	1422	7200100000000
17222	1397	1400676201000
17223	1678	3600093899000
17224	1762	5759130000000
17242	1675	8640419999977
17243	1675	8640429999977
17246	1397	1400606194000
17247	1678	3600093906000
17248	1397	1400596193000
17249	1678	3600093907000
17250	1637	63361703799997
17251	1637	63361723799997
17252	1397	1400586192000
17253	1678	3600093908000
17255	1726	897400000000
17256	1856	200000000
17257	1726	896100000000
17258	1857	200000000
17259	1726	894800000000
17260	1858	200000000
17261	1677	162003343000000
17262	1560	18720530000000
17276	1611	10080110000000
17277	1611	10080160000000
17278	1397	1400526186000
17279	1678	3600093914000
17280	1509	15840401000000
17281	1509	15840411000000
17300	1397	1400456179000
17301	1678	4320143921000
17302	1637	64801733799997
17303	1637	64801743799997
17318	1706	11516362000000
17352	1573	12240410000000
17357	1657	7200120000000
17358	1657	7200130000000
17365	1397	1400306164000
17366	1678	4320143936000
17367	1683	443524620999541
17368	1637	65521743799997
17369	1637	65521753799997
17378	1564	7200092000000
17386	1397	1400256159000
17387	1678	4320143941000
17388	1451	7200220000000
17389	1451	7200230000000
17413	1397	1400246158000
17414	1678	4320143942000
17415	633	76799260000000
17416	633	76799270000000
17419	1716	13679231000000
17420	1716	13679241000000
17427	1397	1400216155000
17428	1678	4320143945000
17429	1668	15120260000000
17438	1764	12960128000000
17439	1764	12960158000000
17444	1397	1400166150000
17445	1678	4320143950000
17446	1719	8639190000000
17447	1719	8639200000000
17459	243	67440010000000
17460	243	67440030000000
17487	1764	12960138000000
17504	1397	1400006134000
17505	1678	4320143966000
17506	1685	44640000000000
17507	1685	44640010000000
17518	1560	18720540000000
17527	1402	43921191000000
17528	1402	43921211000000
17547	1397	1399896123000
17548	1678	4320143977000
17549	1683	447844650999541
17550	1683	447844660999541
17553	1397	1399886122000
17554	1678	4320143978000
17561	1457	11520220000000
17583	1397	1399796113000
17584	1678	4320143987000
17585	1688	77041303000000
17586	1688	77041313000000
17589	1397	1399786112000
17590	1678	4320143988000
17591	1724	14398870000000
17604	1563	720000000000
17605	1563	720020000000
17617	1541	8637248000000
17618	1541	8637298000000
17630	1690	38880191000000
17634	1683	452164690999541
17635	1683	452164700999541
17646	1397	1399636097000
17647	1678	4320144003000
17648	1397	1399626096000
17649	1678	4320144004000
17668	1397	1399586092000
17669	1678	4320144008000
17670	1444	15120510000000
17671	1444	15120520000000
17675	1458	16560264908540
17676	1458	16560274908540
17681	1692	43920133000000
17682	1397	1399556089000
17683	1678	4320144011000
17684	1397	1399546088000
17685	1678	4320144012000
17686	632	77520421000000
17693	1613	10798410000000
17694	1613	10798430000000
17710	484	82560252000000
17711	484	82560262000000
17730	1397	1399426076000
17731	1678	4320144024000
17746	1665	870000000
17747	1861	718000000000
17748	1397	1399386072000
17749	1678	4320144028000
17750	1564	7920082000000
17751	1564	7920102000000
17779	1397	1399306064000
17780	1678	4320144036000
17781	1683	455044710999541
17782	1683	455044720999541
17580	1701	12238332000000
17602	1602	10080280000000
17603	1602	10080300000000
17638	1397	1399656099000
17639	1678	4320144001000
17640	1458	15840254908540
17641	1458	15840264908540
17653	1508	10080120000000
17654	1508	10080130000000
17656	1397	1399606094000
17657	1678	4320144006000
17664	1546	12960200000000
17665	1546	12960210000000
17672	1397	1399576091000
17673	1678	4320144009000
17674	1602	10080290000000
17677	1397	1399566090000
17678	1678	4320144010000
17679	1691	7919120000000
17680	1691	7919130000000
17720	1759	14400249000000
17758	1397	1399366070000
17759	1678	4320144030000
17760	58	75360240000000
17761	58	76080240000000
17765	1397	1399346068000
17766	1678	4320144032000
17767	1397	1399336067000
17768	1678	4320144033000
17769	1739	10799370000000
17770	1739	10799390000000
17785	1397	1399296063000
17786	1678	4320144037000
17705	1677	165603483000000
17712	1397	1399466080000
17713	1678	4320144020000
17714	1397	1399456079000
17715	1678	4320144021000
17716	1397	1399446078000
17717	1678	4320144022000
17718	1677	166323483000000
17719	1677	166323513000000
17721	1419	12960290000000
17732	1397	1399416075000
17733	1678	4320144025000
17734	596	81840302000000
17735	596	81840312000000
17736	1860	99000000000
17737	1862	10000000
17738	1397	1399406074000
17739	1678	4320144026000
17740	1861	0
17741	1665	718880000000
17742	1440	10800360000000
17743	1440	10800390000000
17752	1692	19083000000
17753	1860	43899000000000
17754	1397	1399376071000
17755	1678	4320144029000
17756	1447	14400220000000
17757	1447	14400240000000
17771	1397	1399326066000
17772	1678	4320144034000
17773	1596	11520150000000
17774	1596	11520160000000
17787	1722	1440088000000
17788	1722	1440098000000
17763	1397	1399356069000
17764	1678	4320144031000
17775	1397	1399316065000
17776	1678	4320144035000
17777	1683	453604700999541
17778	1683	453604710999541
17783	1685	46080040000000
17784	1685	46080050000000
17789	1397	1399286062000
17790	1678	4320144038000
17791	1397	1399276061000
17792	1678	4320144039000
17793	1662	720020000000
17794	1860	43900020000000
17795	1687	12959381000000
17796	1687	13679381000000
17797	1397	1399266060000
17798	1678	4320144040000
17799	1637	66241753799997
17800	1637	66241763799997
17801	1397	1399256059000
17802	1678	4320144041000
17803	1637	66961763799997
17804	1637	66961773799997
17805	1397	1399246058000
17806	1678	4320144042000
17807	1671	15120930000000
17808	1671	15120940000000
17809	1715	15840051000000
17810	1701	12238322000000
17811	1397	1399236057000
17812	1678	4320144043000
17813	1397	1399226056000
17814	1678	4320144044000
17815	1759	14400239000000
17816	1397	1399216055000
17817	1678	4320144045000
17818	1397	1399206054000
17819	1678	4320144046000
17820	44	74640350000000
17821	1680	17279300000000
17822	1680	17279320000000
17823	1681	19439385195920
17824	1681	19439405195920
17825	1397	1399196053000
17826	1678	4320144047000
17827	1471	11520170000000
17828	1471	11520180000000
17829	1397	1399186052000
17830	1678	4320144048000
17831	1695	11519181000000
17832	1695	11519191000000
17833	1397	1399176051000
17834	1678	4320144049000
17835	1397	1399166050000
17836	1678	4320144050000
17837	1397	1399156049000
17838	1678	4320144051000
17839	1683	455044740999541
17840	1675	8640449999977
17841	1397	1399146048000
17842	1678	4320144052000
17843	1397	1399136047000
17844	1678	4320144053000
17845	1271	1338366050000000
17846	1271	1338366070000000
17847	1397	1399126046000
17848	1678	4320144054000
17849	1451	7920230000000
17850	1451	7920240000000
17851	1455	11520141000000
17852	1455	11520151000000
17853	1691	8639130000000
17854	1691	8639140000000
17855	1397	1399116045000
17856	1678	4320144055000
17857	1677	166323493000000
17858	1397	1399106044000
17859	1678	4320144056000
17860	1397	1399096043000
17861	1678	4320144057000
17862	1397	1399086042000
17863	1678	4320144058000
17864	1426	8640270000000
17865	1426	8640290000000
17866	633	76799280000000
17867	1610	12960390000000
17868	1610	12960410000000
17869	1509	15840421000000
17870	1397	1399076041000
17871	1678	4320144059000
17872	1397	1399066040000
17873	1678	4320144060000
17874	1602	10800290000000
17875	1602	10800310000000
17876	1623	20881500899898
17877	1623	20881510899898
17878	1692	739083000000
17879	1692	739103000000
17880	1696	10078271000000
17881	1696	10078291000000
17882	1693	13279281551364
17883	1397	1399056039000
17884	1678	4320144061000
17885	1710	10799240000000
17886	1710	10799250000000
17887	1397	1399046038000
17888	1678	4320144062000
17889	1402	43921201000000
17890	1677	167043493000000
17891	1677	167043503000000
17892	1397	1399036037000
17893	1678	4320144063000
17894	1683	456484740999541
17895	1683	456484750999541
17896	1397	1399026036000
17897	1678	4320144064000
17898	470	79680331000000
17899	470	79680351000000
17900	1397	1399016035000
17901	1678	4320144065000
17902	1397	1399006034000
17903	1678	4320144066000
17904	1671	15840940000000
17905	1671	15840970000000
17906	1657	7200150000000
17907	1685	46800050000000
17908	1685	46800080000000
17909	1397	1398996033000
17910	1678	4320144067000
17911	1397	1398986032000
17912	1678	4320144068000
17913	1397	1398976031000
17914	1678	4320144069000
17915	1458	17280274908540
17916	1458	17280304908540
17917	1654	12240200000000
17918	1654	12240230000000
17919	1397	1398966030000
17920	1678	4320144070000
17921	1397	1398956029000
17922	1678	4320144071000
17923	1706	12236362000000
17924	1706	12236382000000
17925	1397	1398946028000
17926	1678	4320144072000
17927	1397	1398936027000
17928	1678	4320144073000
17929	1688	78481363000000
17930	1688	78481383000000
17931	1683	457924750999541
17932	1683	457924770999541
17933	1715	15840061000000
17934	1397	1398926026000
17935	1678	4320144074000
17936	1683	457924760999541
17937	1681	19439395195920
17938	1397	1398916025000
17939	1678	4320144075000
17940	1716	14399241000000
17941	1716	14399251000000
17942	1445	11520230000000
17943	1508	10800760000000
17944	1508	10800810000000
17945	1692	1459103000000
17946	1692	1459113000000
17947	42	74639120000000
17948	1863	0
17949	1596	11409150000000
17950	1864	110000000000
17951	1397	1398906024000
17952	1678	4320144076000
17953	1397	1398896023000
17954	1678	4320144077000
17955	1471	12240180000000
17956	1471	12240310000000
17957	1677	167763503000000
17958	1677	167763633000000
17959	1445	11520350000000
17960	1397	1398886022000
17961	1678	4320144078000
17962	43	76800240000000
17963	43	76800250000000
17964	1397	1398876021000
17965	1678	4320144079000
17966	1679	44640383000000
17967	1679	44640393000000
17970	1677	167763513000000
17985	1726	893500000000
17986	1865	200000000
17987	1397	1398806014000
17988	1678	4320144086000
17989	1683	460804770999541
17990	1683	460804880999541
17999	1397	1398766010000
18000	1678	4320144090000
18021	1684	26639690000000
18022	1684	26639700000000
18023	1397	1398716005000
18024	1678	4320144095000
18030	1654	12240210000000
18037	1397	1398686002000
18038	1678	4320144098000
18039	1397	1398676001000
18040	1678	4320144099000
18041	1683	462244900999541
18050	1601	9720965600000
18051	1601	9720975600000
18066	1637	67681773799997
18067	1637	67681783799997
18076	1397	1398585992000
18077	1678	4320144108000
18078	1634	13680229899999
18079	1634	13680239899999
18082	1457	12960220000000
18083	1457	12960230000000
18108	1402	44641201000000
18109	1402	44641241000000
18111	1397	1398505984000
18112	1678	4320144116000
18113	1683	465124940999541
18114	1683	465124950999541
18115	1397	1398495983000
18116	1678	4320144117000
18117	1397	1398485982000
18118	1678	4320144118000
18119	1397	1398475981000
18120	1678	4320144119000
18121	1397	1398465980000
18122	1678	4320144120000
18123	1397	1398455979000
18124	1678	4320144121000
18125	1402	44641251000000
18134	1397	1398435977000
18135	1678	4320144123000
18136	1397	1398425976000
18137	1678	4320144124000
18138	1688	79201403000000
18141	1692	1459123000000
18156	1844	1100000000
18157	1687	805983726450
18158	1866	12152037273550
18159	1397	1398385972000
18160	1678	5040154128000
18161	1703	7919410000000
18164	1397	1398375971000
18165	1678	5040154129000
18177	1397	1398345968000
18178	1678	5040154132000
18179	1402	44641211000000
18182	111	68160030000000
18183	111	68160040000000
18219	1683	469445210999541
18229	1271	1339086070000000
18230	1271	1339086080000000
18239	44	75360350000000
18240	44	75360480000000
18243	1397	1398225956000
18244	1678	5040154144000
18245	1402	45361211000000
18246	1402	45361221000000
18260	1687	1524883726450
18261	1687	1524893726450
18277	1397	1398145948000
18278	1678	5040154152000
18279	1451	8640240000000
18280	1451	8640250000000
18283	1724	15838880000000
18284	1724	15838890000000
18315	1677	169203543000000
18325	1547	6480050000000
18326	1547	6480070000000
18339	1675	9360429999977
18340	1675	9360439999977
18345	1397	1397975931000
18346	1678	5040154169000
18347	1402	46081221000000
18348	1402	46081231000000
18369	1397	1397905924000
18370	1678	5040154176000
18371	1588	12240170000000
18376	1637	69841814799997
18377	1637	69841834799997
18378	1868	6980000000
18379	724	20001000000000
18380	1397	1397885922000
18381	1678	5040154178000
18382	1397	1397875921000
18383	1678	5040154179000
18384	1397	1397865920000
18385	1678	5040154180000
18386	1687	2244893726450
18387	1687	2244933726450
18430	1397	1397735907000
18431	1678	5040154193000
18432	606	76080190000000
18433	606	76080200000000
18434	1397	1397725906000
18435	1678	5040154194000
18436	1397	1397715905000
18437	1678	5040154195000
18438	1397	1397705904000
18439	1678	5040154196000
18440	1715	16560061000000
18441	1715	16560091000000
18442	1397	1397695903000
18443	1678	5040154197000
18444	1397	1397685902000
18445	1678	5040154198000
18446	1397	1397675901000
18447	1678	5040154199000
18448	1397	1397665900000
18449	1678	5040154200000
18450	1688	81361413000000
18451	1688	81361453000000
18461	1613	10798420000000
18477	1685	48240110000000
18478	1685	48240120000000
18489	1397	1397585892000
18490	1678	5040154208000
18491	1397	1397575891000
18492	1678	5040154209000
18493	1699	4209912500051
18494	1699	4209932500051
18507	1739	11519390000000
18508	1739	11519400000000
18509	1397	1397545888000
18510	1678	5040154212000
18511	1672	12240260000000
18512	1672	12240270000000
18515	1703	8639410000000
18516	1703	8639420000000
18531	1397	1397505884000
18532	1678	5040154216000
18533	1705	12235100000000
18534	1705	12235110000000
18576	1397	1397385872000
18577	1678	5040154228000
18578	1402	46801231000000
18579	1402	46801241000000
18582	1687	2964933726450
18583	1687	2964943726450
18586	606	76800200000000
18587	606	76800210000000
18592	1599	12960240000000
18593	1599	12960250000000
18598	1397	1397345868000
18599	1678	5040154232000
18600	1397	1397335867000
18601	1678	5040154233000
18602	1397	1397325866000
18603	1678	5040154234000
18604	1397	1397315865000
18605	1678	5040154235000
18606	1397	1397305864000
18607	1678	5040154236000
18608	1593	12960300000000
18609	1593	12960330000000
18614	1397	1397285862000
18615	1678	5040154238000
18616	1594	10800290000000
18617	1594	10800300000000
18626	1571	12242181000008
18627	1678	3600093942000
18628	1678	3600093943000
18629	1678	3600093944000
18630	1678	3600093945000
18631	1678	3600093946000
18632	1678	3600093947000
18633	1678	3600093948000
17968	1397	1398866020000
17969	1678	4320144080000
17971	1397	1398856019000
17972	1678	4320144081000
17973	1397	1398846018000
17974	1678	4320144082000
17975	1397	1398836017000
17976	1678	4320144083000
17977	1716	14399271000000
17981	1397	1398816015000
17982	1678	4320144085000
17983	1683	459364760999541
17984	1683	459364770999541
17992	1397	1398796013000
17993	1678	4320144087000
17994	1397	1398786012000
17995	1678	4320144088000
17996	1397	1398776011000
17997	1678	4320144089000
17998	1623	20881530899898
18003	43	77520250000000
18004	43	77520260000000
18011	470	79680341000000
18019	1683	462244880999541
18020	1683	462244890999541
18029	1522	10800240000000
18035	1649	10800320999992
18036	1649	10800330999992
18064	1768	7919181110000
18065	1768	7919191110000
18080	1716	15839271000000
18081	1716	15839281000000
18094	1685	46800060000000
18110	1657	7200160000000
18130	1397	1398445978000
18131	1678	4320144122000
18132	1637	68401783799997
18133	1637	68401793799997
18139	1683	466564950999541
18140	1683	466564970999541
18142	1687	12949121000000
18143	1866	9000000000
18144	42	74638020000000
18145	1863	1000000000
18146	1397	1398415975000
18147	1678	4320144125000
18148	1397	1398405974000
18149	1678	4320144126000
18150	1683	468004970999541
18151	1683	468005190999541
18169	1687	804883726450
18170	1866	12153037273550
18171	1397	1398365970000
18172	1678	5040154130000
18173	1397	1398355969000
18174	1678	5040154131000
18175	1573	13680410000000
18176	1573	13680530000000
18184	1673	10080520000000
18185	1673	10080530000000
18186	1866	11996467329355
18187	481	66156469944195
18188	1866	11991625815924
18189	734	2004741513431
18190	1866	10632291957560
18191	845	574692567058364
18192	1866	9272958099196
18193	846	574692567058364
18194	1866	8014764929790
18195	936	504035868169406
18196	1866	5760172749566
18197	1056	903227957180224
18198	1866	4238921951632
18199	1176	609425900797934
18200	1866	0
18201	1302	1698219459703282
18202	1397	1398325966000
18203	1678	5040154134000
18204	1397	1398315965000
18205	1678	5040154135000
18206	1683	469445190999541
18207	696	66000025000000
18208	457	66000025000000
18209	1683	469445960999541
18213	1397	1398295963000
18214	1678	5040154137000
18215	1397	1398285962000
18216	1678	5040154138000
18217	1671	16560970000000
18218	1671	16561000000000
18231	42	74637920000000
18232	1397	1398255959000
18233	1678	5040154141000
18234	1397	1398245958000
18235	1678	5040154142000
18236	1397	1398235957000
18237	1678	5040154143000
18238	1677	169203653000000
18253	1683	470885420999541
18271	1397	1398165950000
18272	1678	5040154150000
18273	1397	1398155949000
18274	1678	5040154151000
18275	1573	14400530000000
18276	1573	14400550000000
18285	1397	1398135947000
18286	1678	5040154153000
18287	1397	1398125946000
18288	1678	5040154154000
18289	1476	12240250000000
18291	1397	1398115945000
18292	1678	5040154155000
18293	1683	472325420999541
18294	1683	472325430999541
18295	1397	1398105944000
18296	1678	5040154156000
18297	1397	1398095943000
18298	1678	5040154157000
18299	1397	1398085942000
18300	1678	5040154158000
18301	1727	9359140000000
18313	1695	12959321000000
18314	1695	12959341000000
18318	1271	1339086090000000
18319	1397	1398045938000
18320	1678	5040154162000
18321	1397	1398035937000
18322	1678	5040154163000
18323	1522	11521050000000
18324	1522	11521070000000
18329	1397	1398015935000
18330	1678	5040154165000
18331	1397	1398005934000
18332	1678	5040154166000
18333	1683	473765430999541
18334	1683	473765450999541
18335	1397	1397995933000
18336	1678	5040154167000
18337	1688	80641403000000
18338	1688	80641413000000
18349	1397	1397965930000
18350	1678	5040154170000
18351	1397	1397955929000
18352	1678	5040154171000
18353	1694	28799535000000
18354	1694	28799555000000
18360	1397	1397935927000
18361	1678	5040154173000
18362	1397	1397925926000
18363	1678	5040154174000
18364	1397	1397915925000
18365	1678	5040154175000
18366	687	66710029000000
18367	1868	9000000000
18368	1637	69121814799997
18392	1397	1397845918000
18393	1678	5040154182000
18394	1677	169923543000000
18395	1677	169923553000000
18406	1397	1397805914000
18407	1678	5040154186000
18408	1684	27359700000000
18409	1684	27359710000000
18454	1747	5039190000000
18459	1596	12849160000000
18460	1596	12849170000000
18462	1397	1397645898000
18463	1678	5040154202000
18464	1513	7920110000000
18465	1513	7920120000000
18483	1397	1397605894000
18484	1678	5040154206000
18485	1489	10080201000000
18488	1740	15116683000000
18498	1397	1397555889000
18499	1678	5040154211000
18500	1683	475205460999541
18505	1622	6479069999976
18506	1622	6479079999976
18513	1724	16558890000000
18514	1724	16558900000000
18522	1508	11520160000000
18523	1508	11520170000000
18526	1397	1397525886000
18527	1678	5040154214000
17978	1397	1398826016000
17979	1678	4320144084000
17980	369	80400340000000
17991	1716	15119271000000
18013	1397	1398736007000
18014	1678	4320144093000
18025	1397	1398706004000
18026	1678	4320144096000
18027	1677	168483513000000
18028	1677	168483523000000
18031	1397	1398696003000
18032	1678	4320144097000
18033	111	67440020000000
18034	111	67440030000000
18042	1397	1398666000000
18043	1678	4320144100000
18044	1683	463684900999541
18045	1683	463684910999541
18046	1397	1398655999000
18047	1678	4320144101000
18048	1677	169203523000000
18049	1677	169203533000000
18060	1397	1398625996000
18061	1678	4320144104000
18062	1762	7199140000000
18063	1762	7199150000000
18084	1397	1398575991000
18085	1678	4320144109000
18086	1448	11520301000000
18087	1448	11520311000000
18126	1656	15840331000000
18127	1656	15840381000000
18168	1519	2879030000000
18180	1397	1398335967000
18181	1678	5040154133000
18211	1397	1398305964000
18212	1678	5040154136000
18225	1397	1398265960000
18226	1678	5040154140000
18227	1502	1440010000000
18228	1502	1440020000000
18241	1683	470885210999541
18242	1683	470885340999541
18247	1863	900000000
18248	42	74637820000000
18249	1397	1398215955000
18250	1678	5040154145000
18251	1588	12240160000000
18252	1588	12240370000000
18258	1637	69121783799997
18259	1637	69121793799997
18262	1726	892200000000
18263	1867	200000000
18264	1397	1398195953000
18265	1678	5040154147000
18266	1397	1398185952000
18267	1678	5040154148000
18268	1397	1398175951000
18269	1678	5040154149000
18270	1695	12239321000000
18304	1596	10689140000000
18305	1508	11520810000000
18306	1508	11521820000000
18309	1397	1398065940000
18310	1678	5040154160000
18311	1397	1398055939000
18312	1678	5040154161000
18316	42	75357820000000
18317	42	75357840000000
18327	1397	1398025936000
18328	1678	5040154164000
18341	1397	1397985932000
18342	1678	5040154168000
18343	1439	8640140000000
18344	1439	8640150000000
18357	1397	1397945928000
18358	1678	5040154172000
18359	1467	9361620000000
18372	1397	1397895923000
18373	1678	5040154177000
18374	1868	7990000000
18375	498	66001000000000
18388	1397	1397855919000
18389	1678	5040154181000
18390	1610	13680410000000
18391	1610	13680420000000
18414	1397	1397785912000
18415	1678	5040154188000
18416	1397	1397775911000
18417	1678	5040154189000
18418	1683	475205450999541
18419	1683	475205470999541
18424	1397	1397755909000
18425	1678	5040154191000
18426	1397	1397745908000
18427	1678	5040154192000
18428	1650	9360230000000
18429	1650	9360250000000
18453	1679	45360433000000
18455	1704	2159070000000
18456	1397	1397655899000
18457	1678	5040154201000
18458	1637	69841824799997
18470	1408	720000000000
18471	1408	720010000000
18473	1397	1397625896000
18474	1678	5040154204000
18475	1623	21601530899898
18476	1623	21601540899898
18479	1397	1397615895000
18480	1678	5040154205000
18481	1685	48960120000000
18482	1685	48960130000000
18503	1549	14400401000000
18504	1549	14400411000000
18518	1397	1397535887000
18519	1678	5040154213000
18520	1719	9359200000000
18521	1719	9359210000000
18524	1508	12241820000000
18525	1508	12241821000000
18549	1397	1397465880000
18550	1678	5040154220000
18551	1695	13679341000000
18552	1695	13679351000000
18574	1677	171363563000000
18575	1677	171363573000000
18584	1397	1397375871000
18585	1678	5040154229000
18610	1397	1397295863000
18611	1678	5040154237000
18622	1397	1397265860000
18623	1678	5040154240000
18624	1397	1397255859000
18625	1678	5040154241000
18693	1397	1397245858000
18694	1678	5040154242000
18831	1688	81361423000000
18846	1397	1397175851000
18847	1678	5040154249000
18848	1397	1397165850000
18849	1678	5040154250000
18850	1397	1397155849000
18851	1678	5040154251000
18852	1756	12959739000000
18853	1756	12959769000000
18862	1397	1397125846000
18863	1678	5040154254000
18864	1683	478085490999541
18875	676	67440010000000
18876	676	67441011000000
18890	1397	1397045838000
18891	1678	5040154262000
18892	1426	8640280000000
18895	1397	1397035837000
18896	1678	5040154263000
18897	1705	12955110000000
18898	1705	12955120000000
18903	1397	1397015835000
18904	1678	5040154265000
18905	1397	1397005834000
18906	1678	5040154266000
18907	1397	1396995833000
18908	1678	5040154267000
18909	1683	480965500999541
18910	1683	480965530999541
18921	1694	28799565000000
18952	96	66721200000000
18953	96	66721210000000
18964	1397	1396845818000
18965	1678	5040154282000
18966	1397	1396835817000
18967	1678	5040154283000
18968	1447	15120240000000
18969	1447	15120260000000
18981	1397	1396805814000
18982	1678	5040154286000
18983	1397	1396795813000
18984	1678	5040154287000
18985	1683	483845540999541
18986	1683	483845560999541
19004	1397	1396755809000
19005	1678	5040154291000
19006	1397	1396745808000
19007	1678	5040154292000
18001	1681	20159395195920
18002	1681	20159405195920
18005	1397	1398756009000
18006	1678	4320144091000
18007	1695	12239191000000
18008	1695	12239201000000
18009	1397	1398746008000
18010	1678	4320144092000
18012	1541	8637258000000
18015	1397	1398726006000
18016	1678	4320144094000
18017	1679	45360393000000
18018	1679	45360403000000
18052	1397	1398645998000
18053	1678	4320144102000
18054	1633	11520120000000
18055	1633	11520130000000
18056	1397	1398635997000
18057	1678	4320144103000
18058	1587	12960200000000
18059	1587	12960210000000
18068	1397	1398615995000
18069	1678	4320144105000
18070	1397	1398605994000
18071	1678	4320144106000
18072	1397	1398595993000
18073	1678	4320144107000
18074	633	77519270000000
18075	633	77519300000000
18088	1656	15120321000000
18089	1656	15120331000000
18090	1397	1398565990000
18091	1678	4320144110000
18092	1688	79201383000000
18093	1688	79201393000000
18095	1397	1398555989000
18096	1678	4320144111000
18097	1724	15118870000000
18098	1724	15118880000000
18099	1397	1398545988000
18100	1678	4320144112000
18101	1397	1398535987000
18102	1678	4320144113000
18103	1397	1398525986000
18104	1678	4320144114000
18105	1397	1398515985000
18106	1678	4320144115000
18107	1683	463684940999541
18128	1685	47520060000000
18129	1685	47520110000000
18152	1397	1398395973000
18153	1678	4320144127000
18154	1678	5040144127000
18155	1678	5040154127000
18162	1702	7914101000000
18163	1702	7914311000000
18166	42	75358020000000
18167	42	75358030000000
18210	1522	10801050000000
18220	1671	16560990000000
18221	1397	1398275961000
18222	1678	5040154139000
18223	1688	79921393000000
18224	1688	79921403000000
18254	1397	1398205954000
18255	1678	5040154146000
18256	1727	9359110000000
18257	1727	9359120000000
18281	1471	12960310000000
18282	1471	12960320000000
18290	1476	12240790000000
18302	1508	10800130000000
18303	1508	10800160000000
18307	1397	1398075941000
18308	1678	5040154159000
18355	1657	7920130000000
18356	1657	7920150000000
18396	1397	1397835917000
18397	1678	5040154183000
18398	1457	12960240000000
18399	1457	13680240000000
18400	1397	1397825916000
18401	1678	5040154184000
18402	1397	1397815915000
18403	1678	5040154185000
18404	1692	2179113000000
18405	1692	2179133000000
18410	1397	1397795913000
18411	1678	5040154187000
18412	1596	12129150000000
18413	1596	12129160000000
18420	1397	1397765910000
18421	1678	5040154190000
18422	1677	170643553000000
18423	1677	170643563000000
18452	1746	3599080000000
18466	1397	1397635897000
18467	1678	5040154203000
18468	58	76800240000000
18469	58	76800250000000
18472	171	76080140000000
18486	1397	1397595893000
18487	1678	5040154207000
18495	1397	1397565890000
18496	1678	5040154210000
18497	1671	16560980000000
18501	1657	8640150000000
18502	1657	8640160000000
18517	1702	7914111000000
18535	1726	890900000000
18536	1869	200000000
18537	1726	889600000000
18538	1870	200000000
18539	1397	1397495883000
18540	1678	5040154217000
18541	1397	1397485882000
18542	1678	5040154218000
18543	1397	1397475881000
18544	1678	5040154219000
18545	1649	10800550999992
18548	1601	9721195600000
18553	1397	1397455879000
18554	1678	5040154221000
18555	1397	1397445878000
18556	1678	5040154222000
18557	1555	8640100000000
18558	1555	8640120000000
18561	1457	14400240000000
18562	1457	14400250000000
18563	1397	1397425876000
18564	1678	5040154224000
18565	1397	1397415875000
18566	1678	5040154225000
18567	1397	1397405874000
18568	1678	5040154226000
18569	1680	17279330000000
18572	1397	1397395873000
18573	1678	5040154227000
18580	1677	172083573000000
18581	1677	172083583000000
18588	1692	2899133000000
18589	1692	2899143000000
18618	1397	1397275861000
18619	1678	5040154239000
18620	1679	46080433000000
18621	1679	46080443000000
18697	1397	1397225856000
18698	1678	5040154244000
18827	1699	4929932500051
18828	1699	4929942500051
18829	1397	1397215855000
18830	1678	5040154245000
18836	1397	1397195853000
18837	1678	5040154247000
18838	1397	1397185852000
18839	1678	5040154248000
18840	1693	13999301551364
18841	1693	13999321551364
18844	1637	70561824799997
18845	1637	70561844799997
18856	1397	1397145848000
18857	1678	5040154252000
18858	1397	1397135847000
18859	1678	5040154253000
18860	1476	12960250000000
18861	1476	12960270000000
18871	1397	1397095843000
18872	1678	5040154257000
18873	1683	479525490999541
18874	1683	479525500999541
18882	1397	1397065840000
18883	1678	5040154260000
18884	1677	172803583000000
18885	1677	172803593000000
18899	1397	1397025836000
18900	1678	5040154264000
18901	1693	14719321551364
18902	1693	14719331551364
18928	1476	13680270000000
18929	1476	13680280000000
18930	1397	1396935827000
18931	1678	5040154273000
18932	1444	15840520000000
18933	1444	15840530000000
18939	1726	887000000000
18528	1397	1397515885000
18529	1678	5040154215000
18530	1693	13279301551364
18546	1610	14400420000000
18547	1610	14400650000000
18559	1397	1397435877000
18560	1678	5040154223000
18570	1559	15840290000000
18571	1559	15840320000000
18590	1397	1397365870000
18591	1678	5040154230000
18594	1397	1397355869000
18595	1678	5040154231000
18596	1685	49680130000000
18597	1685	49680140000000
18612	1508	12961821000000
18613	1508	12962021000000
18699	1694	28799545000000
18842	1458	18000304908540
18843	1458	18000324908540
18854	1683	478085480999541
18855	1683	478085510999541
18865	1397	1397115845000
18866	1678	5040154255000
18867	1397	1397105844000
18868	1678	5040154256000
18869	1696	10798271000000
18870	1696	10798291000000
18877	1397	1397085842000
18878	1678	5040154258000
18879	1397	1397075841000
18880	1678	5040154259000
18881	1692	2899153000000
18886	1397	1397055839000
18887	1678	5040154261000
18893	1677	173523593000000
18894	1677	173523603000000
18911	1397	1396985832000
18912	1678	5040154268000
18922	1397	1396945828000
18923	1678	5040154272000
18924	1706	12956382000000
18925	1706	12956392000000
18946	1397	1396895823000
18947	1678	5040154277000
18960	1397	1396855819000
18961	1678	5040154281000
18962	1688	82081423000000
18963	1688	82081433000000
18970	1448	11520321000000
18975	1397	1396815815000
18976	1678	5040154285000
18977	1419	13680290000000
18978	1419	13680300000000
18989	1759	15120239000000
19015	1677	174963613000000
19016	1677	174963653000000
19026	1677	175683653000000
19027	1677	175683683000000
19066	1747	5039210000000
19075	1708	9359280000000
19076	1708	9359300000000
19079	1678	3600094130000
19080	1678	3600094131000
19081	1678	3600094132000
19082	1678	3600094133000
19083	1678	3600094134000
19084	1678	3600094135000
19085	1678	3600094136000
19086	1678	3600094137000
19087	1678	3600094138000
19088	1678	3600094139000
19089	1678	3600094140000
19090	1678	3600094141000
19091	1678	3600094142000
19092	1678	3600094143000
19093	1678	3600094144000
19094	1678	3600094145000
19095	1678	3600094146000
19096	1678	3600094147000
19097	1678	3600094148000
19098	1678	3600094149000
19099	1678	3600094150000
19100	1678	3600094151000
19101	1678	3600094152000
19102	1678	3600094153000
19103	1678	3600094154000
19104	1678	3600094155000
19105	1678	3600094156000
19106	1678	3600094157000
19107	1678	3600094158000
19108	1678	3600094159000
19109	1678	3600094160000
19110	1678	3600094161000
19111	1678	3600094162000
19112	1678	3600094163000
19113	1678	3600094164000
19114	1678	3600094165000
19115	1678	3600094166000
19116	1678	3600094167000
19117	1678	3600094168000
19118	1678	3600094169000
19119	1678	3600094170000
19120	1678	3600094171000
19121	1678	3600094172000
19122	1678	3600094173000
19123	1678	3600094174000
19124	1678	3600094175000
19125	1678	3600094176000
19126	1678	3600094177000
19127	1678	3600094178000
19128	1678	3600094179000
19129	1571	13684861000008
19130	1678	3600094180000
19131	1678	3600094181000
19132	1678	3600094182000
19133	1678	3600094183000
19134	1678	3600094184000
19135	1678	3600094185000
19136	1678	3600094186000
19137	1678	3600094187000
19138	1678	3600094188000
19139	1678	3600094189000
19140	1678	3600094190000
19141	1678	3600094191000
19142	1678	3600094192000
19143	1678	3600094193000
19144	1678	3600094194000
19145	1678	3600094195000
19146	1678	3600094196000
19147	1678	3600094197000
19148	1678	3600094198000
19149	1678	3600094199000
19150	1678	3600094200000
19151	1678	3600094201000
19152	1678	3600094202000
19153	1678	3600094203000
19154	1678	3600094204000
19155	1678	3600094205000
19156	1678	3600094206000
19157	1678	3600094207000
19158	1678	3600094208000
19159	1678	3600094209000
19160	1678	3600094210000
19161	1571	14404861000008
19162	1571	66000010000000
19163	608	14405161000008
19187	1397	1396515785000
19188	1678	5040154315000
19189	1726	886890000000
19190	1700	10799510000000
19196	1683	485285560999541
19197	1683	485285580999541
19198	1685	50400140000000
19199	1685	50400160000000
19227	1726	886800000000
19228	1397	1396425776000
19229	1678	5040154324000
19245	1397	1396385772000
19246	1678	5040154328000
19247	1726	886760000000
19248	1671	18001000000000
19249	1671	18001020000000
19295	596	82560322000000
19296	596	82560362000000
19298	1726	886650000000
19299	1726	886640000000
19300	1397	1396275761000
19301	1678	5040154339000
19302	1397	1396265760000
19303	1678	5040154340000
19304	1686	5971986500013
19305	1686	5972026500013
19311	1726	885430000000
19312	1397	1396245758000
19313	1678	5040154342000
19314	1397	1396235757000
19315	1678	5040154343000
19316	1740	15836683000000
19317	1740	15837903000000
19357	1768	7919201110000
19364	1549	15120431000000
19390	1656	15840351000000
19407	1397	1396075741000
19408	1678	5040154359000
18634	1678	3600093949000
18635	1678	3600093950000
18636	1678	3600093951000
18637	1678	3600093952000
18638	1678	3600093953000
18639	1678	3600093954000
18640	1678	3600093955000
18641	1678	3600093956000
18642	1678	3600093957000
18643	1678	3600093958000
18644	1678	3600093959000
18645	1678	3600093960000
18646	1678	3600093961000
18647	1678	3600093962000
18648	1678	3600093963000
18649	1678	3600093964000
18650	1678	3600093965000
18651	1678	3600093966000
18652	1678	3600093967000
18653	1678	3600093968000
18654	1678	3600093969000
18655	1678	3600093970000
18656	1678	3600093971000
18657	1678	3600093972000
18658	1678	3600093973000
18659	1678	3600093974000
18660	1678	3600093975000
18661	1678	3600093976000
18662	1678	3600093977000
18663	1678	3600093978000
18664	1678	3600093979000
18665	1678	3600093980000
18666	1678	3600093981000
18667	1678	3600093982000
18668	1678	3600093983000
18669	1678	3600093984000
18670	1678	3600093985000
18671	1678	3600093986000
18672	1678	3600093987000
18673	1678	3600093988000
18674	1678	3600093989000
18675	1678	3600093990000
18676	1678	3600093991000
18677	1678	3600093992000
18678	1678	3600093993000
18679	1678	3600093994000
18680	1678	3600093995000
18681	1678	3600093996000
18682	1678	3600093997000
18683	1678	3600093998000
18684	1678	3600093999000
18685	1678	3600094000000
18686	1678	3600094001000
18687	1678	3600094002000
18688	1678	3600094003000
18689	1678	3600094004000
18690	1678	3600094005000
18691	1571	12962181000008
18692	1571	12962851000008
18695	1397	1397235857000
18696	1678	5040154243000
18700	1678	3600094006000
18701	1678	3600094007000
18702	1678	3600094008000
18703	1678	3600094009000
18704	1678	3600094010000
18705	1678	3600094011000
18706	1678	3600094012000
18707	1678	3600094013000
18708	1678	3600094014000
18709	1678	3600094015000
18710	1678	3600094016000
18711	1678	3600094017000
18712	1678	3600094018000
18713	1678	3600094019000
18714	1678	3600094020000
18715	1678	3600094021000
18716	1678	3600094022000
18717	1678	3600094023000
18718	1678	3600094024000
18719	1678	3600094025000
18720	1678	3600094026000
18721	1678	3600094027000
18722	1678	3600094028000
18723	1678	3600094029000
18724	1678	3600094030000
18725	1678	3600094031000
18726	1678	3600094032000
18727	1678	3600094033000
18728	1678	3600094034000
18729	1678	3600094035000
18730	1678	3600094036000
18731	1678	3600094037000
18732	1678	3600094038000
18733	1678	3600094039000
18734	1678	3600094040000
18735	1678	3600094041000
18736	1678	3600094042000
18737	1678	3600094043000
18738	1678	3600094044000
18739	1678	3600094045000
18740	1678	3600094046000
18741	1678	3600094047000
18742	1678	3600094048000
18743	1678	3600094049000
18744	1678	3600094050000
18745	1678	3600094051000
18746	1678	3600094052000
18747	1678	3600094053000
18748	1678	3600094054000
18749	1678	3600094055000
18750	1678	3600094056000
18751	1678	3600094057000
18752	1678	3600094058000
18753	1678	3600094059000
18754	1678	3600094060000
18755	1678	3600094061000
18756	1678	3600094062000
18757	1571	12963431000008
18758	1678	3600094063000
18759	1678	3600094064000
18760	1678	3600094065000
18761	1678	3600094066000
18762	1678	3600094067000
18763	1678	3600094068000
18764	1678	3600094069000
18765	1678	3600094070000
18766	1678	3600094071000
18767	1678	3600094072000
18768	1678	3600094073000
18769	1678	3600094074000
18770	1678	3600094075000
18771	1678	3600094076000
18772	1678	3600094077000
18773	1678	3600094078000
18774	1678	3600094079000
18775	1678	3600094080000
18776	1678	3600094081000
18777	1678	3600094082000
18778	1678	3600094083000
18779	1678	3600094084000
18780	1678	3600094085000
18781	1678	3600094086000
18782	1678	3600094087000
18783	1678	3600094088000
18784	1678	3600094089000
18785	1678	3600094090000
18786	1678	3600094091000
18787	1678	3600094092000
18788	1678	3600094093000
18789	1678	3600094094000
18790	1678	3600094095000
18791	1678	3600094096000
18792	1678	3600094097000
18793	1678	3600094098000
18794	1678	3600094099000
18795	1678	3600094100000
18796	1678	3600094101000
18797	1678	3600094102000
18798	1678	3600094103000
18799	1678	3600094104000
18800	1678	3600094105000
18801	1678	3600094106000
18802	1678	3600094107000
18803	1678	3600094108000
18804	1678	3600094109000
18805	1678	3600094110000
18806	1678	3600094111000
18807	1678	3600094112000
18808	1678	3600094113000
18809	1678	3600094114000
18810	1678	3600094115000
18811	1678	3600094116000
18812	1678	3600094117000
18813	1678	3600094118000
18814	1678	3600094119000
18815	1678	3600094120000
18816	1678	3600094121000
18817	1678	3600094122000
18818	1678	3600094123000
18819	1678	3600094124000
18820	1678	3600094125000
18821	1678	3600094126000
18822	1678	3600094127000
18823	1678	3600094128000
18824	1678	3600094129000
18825	1571	13683431000008
18826	1571	13684101000008
18832	1397	1397205854000
18833	1678	5040154246000
18834	1683	476645470999541
18835	1683	476645480999541
18888	1871	719000000000
18889	1871	719010000000
18913	1397	1396975831000
18914	1678	5040154269000
18915	1397	1396965830000
18916	1678	5040154270000
18917	1397	1396955829000
18918	1678	5040154271000
18919	44	76080480000000
18920	44	76080510000000
18926	1677	174243603000000
18927	1677	174243613000000
18934	1726	888300000000
18935	1872	200000000
18936	1397	1396925826000
18937	1678	5040154274000
18938	1547	6480160000000
18948	1397	1396885822000
18949	1678	5040154278000
18950	1683	482405530999541
18951	1683	482405540999541
18954	1397	1396875821000
18955	1678	5040154279000
18979	1513	8640120000000
18980	1513	8640130000000
18987	1690	40320201000000
18988	1690	40320221000000
18990	1397	1396785812000
18991	1678	5040154288000
18992	1397	1396775811000
18993	1678	5040154289000
18994	1397	1396765810000
18995	1678	5040154290000
18996	606	77520210000000
18997	606	200001600
18998	1849	77520234898389
18999	1460	200000013
19000	1831	5100000
19002	1692	3619153000000
19003	1692	3619183000000
19028	1397	1396675801000
19029	1678	5040154299000
19030	1397	1396665800000
19031	1678	5040154300000
19032	1397	1396655799000
19033	1678	5040154301000
19034	1397	1396645798000
19035	1678	5040154302000
19036	1679	46800443000000
19037	1679	46800483000000
19047	1397	1396605794000
19048	1678	5040154306000
19049	1726	886980000000
19050	1709	10797291000000
19063	1704	2159090000000
19072	1677	176403683000000
19073	1677	176403703000000
19174	1726	886910000000
19175	1726	886900000000
19176	1397	1396535787000
19177	1678	5040154313000
19178	1397	1396525786000
19179	1678	5040154314000
19180	1688	83521463000000
19181	1688	83521503000000
19185	1555	9360120000000
19186	1555	9360160000000
19200	1397	1396495783000
19201	1678	5040154317000
19202	1726	886870000000
19203	596	81840322000000
19230	1726	886790000000
19231	1397	1396415775000
19232	1678	5040154325000
19233	1683	486725580999541
19234	1683	486725600999541
19237	1726	886780000000
19238	1397	1396405774000
19239	1678	5040154326000
19240	1671	17280980000000
19241	1671	17281000000000
19250	1683	488165600999541
19251	1683	488165620999541
19256	1726	886740000000
19257	1692	4339183000000
19258	1692	4339193000000
19272	1726	886710000000
19273	1726	886700000000
19274	1397	1396335767000
19275	1678	5040154333000
19276	1397	1396325766000
19277	1678	5040154334000
19278	1715	17280091000000
19279	1715	17280131000000
19306	1687	3684943726450
19307	1687	3684983726450
19324	1397	1396215755000
19325	1678	5040154345000
19326	1726	884220000000
19327	1874	200000000
19328	1679	48240543000000
19329	1679	48240563000000
19332	1397	1396205754000
19333	1678	5040154346000
19345	1397	1396165750000
19346	1678	5040154350000
19347	1726	882909999000
19348	1874	200001000
19349	1657	9360160000000
19350	1657	9360180000000
19383	1637	74161914799997
19384	1637	74161934799997
19397	1594	10800310000000
19415	1726	882799988000
19416	1874	200012000
19417	1397	1396055739000
19418	1678	5040154361000
19419	1587	12960220000000
19434	1726	882769985000
19435	1874	200015000
19436	1726	882759984000
19437	1874	200016000
19438	1397	1396025736000
19439	1678	5040154364000
19440	1397	1396015735000
19441	1678	5040154365000
19442	1637	74881934799997
19443	1637	74881974799997
19446	1699	5649942500051
19463	1397	1395975731000
19464	1678	5040154369000
19465	1726	882719980000
19466	1874	200020000
19467	1688	84241583000000
19468	1688	84241603000000
19471	1397	1395965730000
19472	1678	5040154370000
19473	1726	882709979000
19474	1874	200021000
19475	1688	83521603000000
19502	1702	7914121000000
19531	1677	178563743000000
19532	1677	178563763000000
19543	1601	10441195600000
19544	1601	10441215600000
19551	1397	1395845718000
19552	1678	5040154382000
19553	1726	882589967000
19554	1874	200033000
19555	1689	11519231000000
19556	1689	11519251000000
19569	1397	1395815715000
19570	1678	5040154385000
19571	1726	882559964000
19572	1874	200036000
19573	317	66720000000000
19574	317	66720020000000
19604	1726	882509959000
19605	1874	200041000
19606	1397	1395765710000
19607	1678	5040154390000
19608	1688	84961603000000
19609	1688	84961623000000
18940	1873	200000000
18941	1397	1396915825000
18942	1678	5040154275000
18943	1397	1396905824000
18944	1678	5040154276000
18945	1705	12955230000000
18956	1397	1396865820000
18957	1678	5040154280000
18958	1689	10079201000000
18959	1689	10079211000000
18971	1397	1396825816000
18972	1678	5040154284000
18973	1439	9360150000000
18974	1439	9360160000000
19001	606	77520240000000
19017	1623	21601730899898
19038	1397	1396635797000
19039	1678	5040154303000
19040	1724	17278900000000
19041	1724	17278910000000
19051	1419	14400300000000
19052	1419	14400320000000
19064	1756	13679769000000
19065	1756	13679829000000
19074	1706	12956402000000
19077	1440	11520390000000
19078	1440	11520410000000
19164	1726	886930000000
19165	1397	1396555789000
19166	1678	5040154311000
19167	1705	13675230000000
19168	1705	13675250000000
19169	1726	886920000000
19170	1397	1396545788000
19171	1678	5040154312000
19182	1706	12956422000000
19191	1397	1396505784000
19192	1678	5040154316000
19193	1726	886880000000
19194	1850	10065010000000
19195	1850	10065030000000
19204	1679	47520483000000
19205	1679	47520503000000
19207	1726	886860000000
19208	1726	886850000000
19209	1726	886840000000
19210	1397	1396485782000
19211	1678	5040154318000
19212	1397	1396475781000
19213	1678	5040154319000
19214	1397	1396465780000
19215	1678	5040154320000
19216	1679	47520543000000
19217	1726	886830000000
19218	1726	886820000000
19219	1397	1396455779000
19220	1678	5040154321000
19221	1726	886810000000
19222	1397	1396445778000
19223	1678	5040154322000
19224	1397	1396435777000
19225	1678	5040154323000
19226	576	77520360000000
19235	1693	15439331551364
19236	1693	15439351551364
19242	1397	1396395773000
19243	1678	5040154327000
19244	1726	886770000000
19259	1397	1396365770000
19260	1678	5040154330000
19261	1726	886730000000
19262	1397	1396355769000
19263	1678	5040154331000
19264	1637	71281844799997
19265	1637	71281874799997
19266	1397	1396345768000
19267	1678	5040154332000
19268	1726	886720000000
19269	1637	72001874799997
19270	1637	72001894799997
19280	1397	1396315765000
19281	1678	5040154335000
19282	1397	1396305764000
19283	1678	5040154336000
19284	1726	886690000000
19285	1726	886680000000
19286	1506	10800200000000
19287	1506	10800240000000
19297	1727	9359150000000
19318	1397	1396225756000
19319	1678	5040154344000
19320	369	81120340000000
19321	369	81120350000000
19334	1397	1396195753000
19335	1678	5040154347000
19336	171	76800140000000
19337	171	76800150000000
19353	1726	882899998000
19354	1874	200002000
19355	1397	1396155749000
19356	1678	5040154351000
19358	1397	1396145748000
19359	1678	5040154352000
19360	1726	882889997000
19361	1874	200003000
19362	1850	10785030000000
19363	1850	10785050000000
19375	1726	882859994000
19376	1874	200006000
19377	1397	1396115745000
19378	1678	5040154355000
19379	1467	10081620000000
19380	1467	10081640000000
19381	171	77520150000000
19382	171	77520170000000
19385	1397	1396105744000
19386	1678	5040154356000
19387	1726	882849993000
19388	1874	200007000
19389	1444	15840540000000
19403	1726	882819990000
19404	1874	200010000
19405	689	66720000000000
19406	689	66722180000000
19414	1679	48240583000000
19424	1762	7919150000000
19425	1762	7919170000000
19432	576	78240360000000
19433	576	78240380000000
19452	1699	5649962500051
19458	1397	1395985732000
19459	1678	5040154368000
19460	1726	882729981000
19461	1874	200019000
19462	484	82560272000000
19491	1440	12240410000000
19492	1440	12240430000000
19499	1451	9360250000000
19500	1451	9360270000000
19518	1690	41040221000000
19519	1690	41040261000000
19525	1397	1395875721000
19526	1678	5040154379000
19527	1726	882619970000
19528	1874	200030000
19529	1476	14400280000000
19530	1476	14400300000000
19533	641	81120520000000
19534	641	81120540000000
19562	1726	882569965000
19563	1874	200035000
19564	1397	1395825716000
19565	1678	5040154384000
19566	1587	13680220000000
19567	1587	13680240000000
19575	1692	5059193000000
19576	1692	5059213000000
19583	1726	882539962000
19584	1874	200038000
19585	1397	1395795713000
19586	1678	5040154387000
19587	1683	492485680999541
19588	1683	492485700999541
19589	1508	12240170000000
19590	1508	12240190000000
19593	1397	1395785712000
19594	1678	5040154388000
19595	1726	882529961000
19596	1874	200039000
19597	1422	8640100000000
19598	1422	8640120000000
19612	1726	882499958000
19613	1874	200042000
19614	1397	1395755709000
19615	1678	5040154391000
19616	1513	8640140000000
19008	1397	1396735807000
19009	1678	5040154293000
19010	1397	1396725806000
19011	1678	5040154294000
19012	1397	1396715805000
19013	1678	5040154295000
19014	1683	483845580999541
19018	1397	1396705804000
19019	1678	5040154296000
19020	1397	1396695803000
19021	1678	5040154297000
19022	1397	1396685802000
19023	1678	5040154298000
19024	1688	82801433000000
19025	1688	82801463000000
19042	1397	1396625796000
19043	1678	5040154304000
19044	1726	886990000000
19045	1397	1396615795000
19046	1678	5040154305000
19053	1397	1396595793000
19054	1678	5040154307000
19055	1726	886970000000
19056	1397	1396585792000
19057	1678	5040154308000
19058	1397	1396575791000
19059	1678	5040154309000
19060	1726	886960000000
19061	1726	886950000000
19062	1746	3599100000000
19067	1397	1396565790000
19068	1678	5040154310000
19069	1726	886940000000
19070	1689	10799211000000
19071	1689	10799231000000
19172	1623	22321730899898
19173	1623	22321810899898
19183	700	71040090000000
19184	700	71040130000000
19206	700	71040110000000
19252	1726	886750000000
19253	1397	1396375771000
19254	1678	5040154329000
19255	1681	20159415195920
19271	1637	72721894799997
19288	1397	1396295763000
19289	1678	5040154337000
19290	1397	1396285762000
19291	1678	5040154338000
19292	1726	886670000000
19293	1726	886660000000
19294	1693	15439371551364
19308	1397	1396255759000
19309	1678	5040154341000
19310	1726	886630000000
19322	1549	15120411000000
19323	1549	15120421000000
19330	1700	11519510000000
19331	1700	11519530000000
19338	1726	882920000000
19339	1875	200000000
19340	1397	1396185752000
19341	1678	5040154348000
19342	1397	1396175751000
19343	1678	5040154349000
19344	1688	83521583000000
19351	1637	73441894799997
19352	1637	73441914799997
19365	1397	1396135747000
19366	1678	5040154353000
19367	1397	1396125746000
19368	1678	5040154354000
19369	1726	882879996000
19370	1874	200004000
19371	1726	882869995000
19372	1874	200005000
19373	1693	16159371551364
19374	1693	16159411551364
19391	1726	882839992000
19392	1874	200008000
19393	1397	1396095743000
19394	1678	5040154357000
19395	1677	177123703000000
19396	1677	177123723000000
19398	1397	1396085742000
19399	1678	5040154358000
19400	1726	882829991000
19401	1874	200009000
19402	1672	12240280000000
19420	1726	882789987000
19421	1874	200013000
19422	1397	1396045738000
19423	1678	5040154362000
19444	1650	10080250000000
19445	1650	10080290000000
19447	1726	882749983000
19448	1874	200017000
19449	1397	1396005734000
19450	1678	5040154366000
19451	1764	12960148000000
19485	1397	1395935727000
19486	1678	5040154373000
19487	1726	882679976000
19488	1874	200024000
19489	1683	491045660999541
19490	1683	491045680999541
19493	1397	1395925726000
19494	1678	5040154374000
19495	1726	882669975000
19496	1874	200025000
19497	1677	177843723000000
19498	1677	177843743000000
19508	1726	882649973000
19509	1874	200027000
19510	1726	882639972000
19511	1874	200028000
19512	1397	1395905724000
19513	1678	5040154376000
19514	1397	1395895723000
19515	1678	5040154377000
19516	1710	11519250000000
19517	1710	11519290000000
19520	1726	882629971000
19521	1874	200029000
19522	1397	1395885722000
19523	1678	5040154378000
19524	1633	11520140000000
19541	1668	15840260000000
19542	1668	15840280000000
19545	1726	882599968000
19546	1874	200032000
19547	1397	1395855719000
19548	1678	5040154381000
19549	1679	48960583000000
19550	1679	48960603000000
19577	1397	1395805714000
19578	1678	5040154386000
19579	1726	882549963000
19580	1874	200037000
19581	1613	11518420000000
19582	1613	11518440000000
19600	1397	1395775711000
19601	1678	5040154389000
19602	1726	882519960000
19603	1874	200040000
19618	1726	882489957000
19619	1874	200043000
19620	1726	882479956000
19621	1874	200044000
19622	1397	1395745708000
19623	1678	5040154392000
19624	1397	1395735707000
19625	1678	5040154393000
19626	1397	1395725706000
19627	1678	5040154394000
19628	1726	882469955000
19629	1874	200045000
19630	43	77520310000000
19409	1397	1396065740000
19410	1678	5040154360000
19411	1726	882809989000
19412	1874	200011000
19413	1683	488165640999541
19426	1397	1396035737000
19427	1678	5040154363000
19428	1726	882779986000
19429	1874	200014000
19430	1683	489605620999541
19431	1683	489605640999541
19453	1397	1395995733000
19454	1678	5040154367000
19455	1726	882739982000
19456	1874	200018000
19457	1637	74881954799997
19469	1471	13680320000000
19470	1471	13680340000000
19476	1397	1395955729000
19477	1678	5040154371000
19478	1397	1395945728000
19479	1678	5040154372000
19480	1726	882699978000
19481	1874	200022000
19482	1726	882689977000
19483	1874	200023000
19484	1683	489605660999541
19501	1703	8639430000000
19503	1726	882659974000
19504	1874	200026000
19505	1397	1395915725000
19506	1678	5040154375000
19507	1455	11520161000000
19535	1726	882609969000
19536	1874	200031000
19537	1397	1395865720000
19538	1678	5040154380000
19539	1422	7920080000000
19540	1422	7920100000000
19557	1397	1395835717000
19558	1678	5040154383000
19559	1726	882579966000
19560	1874	200034000
19561	1756	13679789000000
19568	1690	41040241000000
19591	1699	6369962500051
19592	1699	6369982500051
19599	1714	18709170000000
19610	369	81840350000000
19611	369	81840370000000
19617	1739	12239400000000
19631	1397	1395715705000
19632	1678	5040154395000
19633	1726	882459954000
19634	1874	200046000
19635	1397	1395705704000
19636	1678	5040154396000
19637	1726	882449953000
19638	1874	200047000
19639	1397	1395695703000
19640	1678	5040154397000
19641	1726	882439952000
19642	1874	200048000
19643	1687	3684963726450
19644	1474	10794263000000
19645	1474	10794283000000
19646	1397	1395685702000
19647	1678	5040154398000
19648	1726	882429951000
19649	1874	200049000
19650	1540	715009000000
19651	1876	4000000000
19652	1458	18000325908540
19653	606	77520231000000
19654	1726	882419950000
19655	1874	200050000
19656	1397	1395675701000
19657	1678	5040154399000
19658	1513	9360140000000
19659	1513	9360160000000
19660	1397	1395665700000
19661	1678	5040154400000
19662	1397	1395655699000
19663	1678	5040154401000
19664	1726	882409949000
19665	1874	200051000
19666	1683	493925700999541
19667	1683	493925720999541
19668	1656	16560351000000
19669	1656	16560371000000
19670	1522	12241070000000
19671	1522	12241090000000
19672	1739	12959400000000
19673	1739	12959401000000
19674	1593	13680330000000
19675	1593	13680350000000
19676	1726	882399948000
19677	1874	200052000
19678	1397	1395645698000
19679	1678	5040154402000
19680	363	67440030000000
19681	363	67440050000000
19682	1397	1395635697000
19683	1678	5040154403000
19684	1726	882389947000
19685	1874	200053000
19686	1668	16560280000000
19687	1668	16560300000000
19688	1397	1395625696000
19689	1678	5040154404000
19690	1726	882379946000
19691	1874	200054000
19692	1451	8640270000000
19693	1397	1395615695000
19694	1678	5040154405000
19695	1397	1395605694000
19696	1678	5040154406000
19697	1726	882369945000
19698	1874	200055000
19699	1726	882359944000
19700	1874	200056000
19701	1683	493925740999541
19702	1560	19440540000000
19703	1560	19440580000000
19704	1509	15840411000010
19705	1692	5059192999990
19706	1509	5059232999970
19707	1692	15840411000030
19708	1726	882349943000
19709	1874	200057000
19710	1397	1395595693000
19711	1678	5040154407000
19712	1877	719000000000
19713	1877	719020000000
19714	1726	882339942000
19715	1874	200058000
19716	1397	1395585692000
19717	1678	5040154408000
19718	1683	495365740999541
19719	1683	495365760999541
19720	1546	13680210000000
19721	1546	13680230000000
19722	1700	12239530000000
19723	1700	12239550000000
19724	1685	50400141000000
19725	1876	3990000000
19726	1726	882329941000
19727	1874	200059000
19728	1397	1395575691000
19729	1678	5040154409000
19730	1506	11520240000000
19731	1506	11520270000000
19732	1876	3980000000
19733	1397	1395565690000
19734	1678	5040154410000
19735	1397	1395555689000
19736	1678	5040154411000
19737	1726	882319940000
19738	1874	200060000
19739	1726	882309939000
19740	1874	200061000
19741	1688	85681623000000
19742	1688	85681673000000
19743	1448	11520351000000
19744	1677	179283763000000
19745	1677	179283813000000
19746	1540	367308000000
19747	1876	351700000000
19748	1685	51120141000000
19749	1685	51120142000000
19750	1726	882299938000
19751	1874	200062000
19752	1726	882289937000
19753	1874	200063000
19754	1397	1395545688000
19755	1678	5040154412000
19756	1876	2970000000
19757	1878	0
19758	1726	882279936000
19759	1874	200064000
19760	1726	882269935000
19761	1874	200065000
19762	1397	1395535687000
19763	1678	5040154413000
19764	1397	1395525686000
19765	1678	5040154414000
19766	1876	350670000000
19767	1506	12240270000000
19768	1506	12240351000000
19770	1726	882259934000
19771	1874	200066000
19772	1397	1395515685000
19773	1678	5040154415000
19786	1677	179283783000000
19788	1397	1395485682000
19789	1678	5040154418000
19790	1726	882229931000
19791	1874	200069000
19792	1560	19440560000000
19860	1489	10800221000000
19866	1726	882099918000
19867	1874	200082000
19868	1397	1395355669000
19869	1678	5040154431000
19870	1683	499685820999541
19871	1683	499685840999541
19884	1397	1395325666000
19885	1678	5040154434000
19886	1726	882069915000
19887	1874	200085000
19888	1693	16879411551364
19889	1693	16879431551364
19924	1726	881999908000
19925	1874	200092000
19926	1588	12240180000000
19927	1397	1395255659000
19928	1678	5040154441000
19929	1397	1395245658000
19930	1678	5040154442000
19931	1726	881989907000
19932	1874	200093000
19933	1588	12960180000000
19934	1588	12960210000000
19937	1397	1395235657000
19938	1678	5040154443000
19939	1726	881979906000
19940	1874	200094000
19941	1696	11518291000000
19942	1696	11518311000000
19953	1726	881959904000
19954	1874	200096000
19955	1397	1395215655000
19956	1678	5040154445000
19957	1397	1395205654000
19958	1678	5040154446000
19959	1397	1395195653000
19960	1678	5040154447000
19961	1726	881949903000
19962	1874	200097000
19963	1726	881939902000
19964	1874	200098000
19965	1564	8640102000000
19966	1564	8640162000000
19991	1397	1395135647000
19992	1678	5040154453000
19993	1397	1395125646000
19994	1678	5040154454000
19995	1726	881879896000
19996	1874	200104000
19997	1726	881869895000
19998	1874	200105000
19999	1699	7089982500051
20000	1699	7090022500051
20021	1726	881829891000
20022	1874	200109000
20023	1726	881819890000
20024	1874	200110000
20025	1397	1395085642000
20026	1678	5040154458000
20027	1397	1395075641000
20028	1678	5040154459000
20029	1654	12240240000000
20062	1704	2879090000000
20063	1704	2879110000000
20064	1726	881749883000
20065	1874	200117000
20066	1397	1395005634000
20067	1678	5040154466000
20068	1678	5760154466000
20069	1678	5760174466000
20080	1687	3684973726450
20087	1683	505445900999541
20088	1683	505445920999541
20104	1613	12238480000000
20119	1685	51840142000000
20120	1685	51840152000000
20167	1397	1394855619000
20168	1678	5040154481000
20169	1397	1394845618000
20170	1678	5040154482000
20171	1726	881619868000
20172	1874	200132000
20173	1726	881609867000
20174	1874	200133000
20175	1673	10080560000000
20212	1726	881574863000
20213	1874	200137000
20214	1726	881564862000
20215	1874	200138000
20216	1397	1394805614000
20217	1678	5040154486000
20218	1397	1394795613000
20219	1678	5040154487000
20380	1397	1394765610000
20381	1678	5040154490000
20382	1726	881534859000
20383	1874	200141000
20384	1397	1394755609000
20385	1678	5040154491000
20386	1397	1394745608000
20387	1678	5040154492000
20388	1397	1394735607000
20389	1678	5040154493000
20390	1726	881524858000
20391	1874	200142000
20392	1726	881514857000
20393	1874	200143000
20394	1726	881504856000
20395	1874	200144000
20396	1714	18709210000000
20407	1683	508325985999541
20408	1683	508326025999541
20420	1397	1394685602000
20421	1678	5040154498000
20422	1726	881454851000
20423	1874	200149000
20424	1508	12960190000000
20425	1508	12960210000000
20430	1724	17998910000000
20431	1724	17998930000000
20489	1726	881324838000
20490	1874	200162000
20491	1397	1394555589000
20492	1678	5040154511000
20495	1727	10079130000000
20496	1727	10079150000000
20521	1726	881264832000
20522	1874	200168000
20523	1397	1394495583000
20524	1678	5040154517000
20525	1397	1394485582000
20526	1678	5040154518000
20527	1726	881254831000
20528	1874	200169000
20529	1677	182883943000000
20530	1677	182883983000000
20549	1397	1394455579000
20550	1678	5040154521000
20551	1726	881224828000
20552	1874	200172000
20553	1726	881214827000
20554	1874	200173000
20555	1397	1394445578000
20556	1678	5040154522000
20557	1677	183603983000000
20558	1677	183604023000000
20561	1726	881204826000
20562	1874	200174000
20563	1397	1394435577000
20564	1678	5040154523000
20577	1623	23764330899593
20582	1726	881164822000
20583	1874	200178000
20584	1397	1394395573000
20585	1678	5040154527000
20586	1458	18720325908540
20587	1458	18720345908540
20600	1692	5059233000000
20622	1397	1394325566000
20623	1678	5040154534000
20624	1726	881094815000
20625	1874	200185000
20668	1679	51120643000000
20669	1679	51120663000000
20725	1726	875744800000
20726	1883	200000000
20727	1397	1394165550000
20728	1678	5040154550000
20729	1726	875734799000
20730	1874	200201000
19769	1759	15120320000000
19806	1622	7199119999976
19815	1397	1395445678000
19816	1678	5040154422000
19817	1397	1395435677000
19818	1678	5040154423000
19819	1726	882189927000
19820	1874	200073000
19821	1726	882179926000
19822	1874	200074000
19855	1726	882109919000
19856	1874	200081000
19857	1397	1395365670000
19858	1678	5040154430000
19859	1686	6692046500013
19863	1613	12238440000000
19864	1613	12238460000000
19890	1397	1395315665000
19891	1678	5040154435000
19892	1726	882059914000
19893	1874	200086000
19894	1637	76321974799997
19895	1637	76321994799997
19935	58	76080250000000
19936	58	76800280000000
19943	697	66720000000000
19944	697	66720020000000
19977	1726	881909899000
19978	1874	200101000
19979	1397	1395165650000
19980	1678	5040154450000
19981	1675	9360449999977
20001	1726	881859894000
20002	1874	200106000
20003	1397	1395115645000
20004	1678	5040154455000
20005	1683	504005880999541
20006	1683	504005900999541
20012	1879	719000000000
20013	1879	719020000000
20020	1749	10075188000000
20041	1715	18000131000000
20042	1715	18000151000000
20070	1455	12240161000000
20071	1455	12240171000000
20074	1726	881739882000
20075	1874	200118000
20076	1397	1394995633000
20077	1678	5040154467000
20078	1467	10801640000000
20079	1467	10801670000000
20093	1397	1394965630000
20094	1678	5040154470000
20095	1397	1394955629000
20096	1678	5040154471000
20097	1726	881709879000
20098	1874	200121000
20099	1726	881699878000
20100	1874	200122000
20101	1688	87841723000000
20117	1667	720000000000
20118	1667	720160000000
20121	1726	881669875000
20122	1874	200125000
20123	1726	881659874000
20124	1874	200126000
20125	1397	1394925626000
20126	1678	5040154474000
20127	1397	1394915625000
20128	1678	5040154475000
20129	171	77520190000000
20139	1798	180000000
20140	1726	881649872000
20141	1726	881639871000
20142	1874	200129000
20143	1687	3684993726450
20144	1726	881629870000
20145	1874	200130000
20146	1397	1394885622000
20147	1678	5040154478000
20148	1397	1394875621000
20149	1678	5040154479000
20150	1867	200100000
20151	1687	4404993626450
20152	1687	201200000
20153	1867	4405022526450
20176	1451	10080270000000
20177	1451	10080310000000
20193	1726	881599866000
20194	1874	200134000
20195	1726	881589865000
20196	1874	200135000
20197	1726	881579864000
20198	1874	200136000
20199	1397	1394835617000
20200	1678	5040154483000
20201	1397	1394825616000
20202	1678	5040154484000
20203	1397	1394815615000
20204	1678	5040154485000
20205	1726	881580864000
20206	1726	881581864000
20207	1726	881582864000
20208	1726	881583864000
20209	1726	881584864000
20210	1683	506885920999541
20211	1683	506885985999541
20378	1565	720000000000
20379	1565	720040000000
20397	1726	881494855000
20398	1874	200145000
20399	1726	881484854000
20400	1874	200146000
20401	1397	1394725606000
20402	1678	5040154494000
20403	1397	1394715605000
20404	1678	5040154495000
20405	484	83280272000000
20406	484	83280312000000
20426	1726	881444850000
20427	1874	200150000
20428	1397	1394675601000
20429	1678	5040154499000
20465	1685	53280177000000
20484	1397	1394565590000
20485	1678	5040154510000
20486	1726	881334839000
20487	1874	200161000
20488	1599	12960260000000
20493	1683	511206045999541
20494	1683	511206065999541
20507	1726	881294835000
20508	1874	200165000
20509	1397	1394525586000
20510	1678	5040154514000
20511	1397	1394515585000
20512	1678	5040154515000
20513	1726	881284834000
20514	1874	200166000
20559	1419	15120320000000
20560	1419	15120360000000
20578	1726	881174823000
20579	1874	200177000
20580	1397	1394405574000
20581	1678	5040154526000
20601	1397	1394365570000
20602	1678	5040154530000
20603	1726	881134819000
20604	1874	200181000
20605	1397	1394355569000
20606	1678	5040154531000
20607	1726	881124818000
20608	1874	200182000
20609	1549	15840431000000
20610	1549	15840451000000
20630	1726	881084814000
20631	1874	200186000
20632	1397	1394315565000
20633	1678	5040154535000
20634	1536	15120300000000
20645	1397	1394285562000
20646	1678	5040154538000
20647	1726	881054811000
20648	1874	200189000
20649	1726	881044810000
20650	1874	200190000
20651	1397	1394275561000
20652	1678	5040154539000
20653	1508	13680210000000
20654	1508	13680250000000
20670	1726	881014807000
20671	1874	200193000
20672	1397	1394245558000
20673	1678	5040154542000
20674	1688	89281723000000
20675	1688	89281743000000
20678	1397	1394235557000
20679	1678	5040154543000
20680	1726	881004806000
20681	1874	200194000
20682	1688	90001743000000
20683	1688	90001763000000
20732	1764	12960248000000
20752	1726	875704796000
20753	1874	200204000
19774	1726	882249933000
19775	1874	200067000
19776	1397	1395505684000
19777	1678	5040154416000
19778	1649	11520330999992
19779	1649	11520350999992
19787	1541	8637268000000
19793	1622	7199079999976
19804	1489	10800201000000
19805	1489	10800241000000
19807	43	78240310000000
19808	43	78240350000000
19810	1397	1395455679000
19811	1678	5040154421000
19812	1726	882199928000
19813	1874	200072000
19814	1762	7919210000000
19825	1397	1395425676000
19826	1678	5040154424000
19827	1726	882169925000
19828	1874	200075000
19829	1397	1395415675000
19830	1678	5040154425000
19831	1397	1395405674000
19832	1678	5040154426000
19833	1397	1395395673000
19834	1678	5040154427000
19835	1726	882159924000
19836	1874	200076000
19837	1397	1395385672000
19838	1678	5040154428000
19839	1726	882149923000
19840	1874	200077000
19841	1726	882139922000
19842	1874	200078000
19843	1726	882129921000
19844	1874	200079000
19845	1686	6692026500013
19846	1686	6692106500013
19849	1726	882119920000
19850	1874	200080000
19851	1397	1395375671000
19852	1678	5040154429000
19853	1679	49680603000000
19854	1679	49680623000000
19861	1717	12239272000000
19862	1717	12239292000000
19865	1489	11520203000000
19872	1726	882089917000
19873	1874	200083000
19874	1397	1395345668000
19875	1678	5040154432000
19876	1637	75601954799997
19877	1637	75601974799997
19916	1726	882029911000
19917	1874	200089000
19918	1726	882019910000
19919	1874	200090000
19920	1726	882009909000
19921	1874	200091000
19922	1444	16560610000000
19947	1726	881969905000
19948	1874	200095000
19949	1397	1395225656000
19950	1678	5040154444000
19951	1683	502565860999541
19952	1683	502565880999541
19967	1397	1395185652000
19968	1678	5040154448000
19969	1397	1395175651000
19970	1678	5040154449000
19971	1726	881929901000
19972	1874	200099000
19973	1726	881919900000
19974	1874	200100000
19975	1681	20879415195920
19976	1681	20879455195920
20014	1726	881839892000
20015	1874	200108000
20016	1397	1395095643000
20017	1678	5040154457000
20018	1688	86401643000000
20019	1688	86401663000000
20030	1397	1395065640000
20031	1678	5040154460000
20032	1726	881809889000
20033	1874	200111000
20035	1397	1395055639000
20036	1678	5040154461000
20037	1726	881799888000
20038	1874	200112000
20039	1688	87121663000000
20040	1688	87121683000000
20057	1397	1395015635000
20058	1678	5040154465000
20059	1726	881759884000
20060	1874	200116000
20089	1726	881719880000
20090	1874	200120000
20091	1397	1394975631000
20092	1678	5040154469000
20111	1726	881679876000
20112	1874	200124000
20113	1397	1394935627000
20114	1678	5040154473000
20115	1679	50400623000000
20116	1679	50400643000000
20134	1397	1394895623000
20135	1678	5040154477000
20136	1726	881639872000
20137	1874	200128000
20138	1716	15839291000000
20157	1687	4404993726450
20158	1687	20000000
20159	1647	4405003726450
20179	1726	882819989000
20180	1726	882829989000
20181	1798	158000000
20182	1726	882830989000
20183	1798	156000000
20184	1726	882831989000
20185	1798	154000000
20186	1726	882832989000
20187	1798	152000000
20188	1726	882833989000
20189	1798	150000000
20190	1726	882834989000
20191	1685	52560152000000
20192	1685	52560177000000
20220	1726	885450000000
20221	1726	884240000000
20222	1726	882940000000
20223	1726	882929999000
20224	1726	882919998000
20225	1726	882909997000
20226	1726	882899996000
20227	1726	882889995000
20228	1726	882879994000
20229	1726	882869993000
20230	1726	882859992000
20231	1726	882849991000
20232	1726	882839990000
20233	1726	882819988000
20234	1726	882809987000
20235	1726	882799986000
20236	1726	882789985000
20237	1726	882779984000
20238	1726	882769983000
20239	1726	882759982000
20240	1726	882749981000
20241	1726	882739980000
20242	1726	882729979000
20243	1726	882719978000
20244	1726	882709977000
20245	1726	882699976000
20246	1726	882689975000
20247	1726	882679974000
20248	1726	882669973000
20249	1726	882659972000
20250	1726	882649971000
20251	1726	882639970000
20252	1726	882629969000
20253	1726	882619968000
20254	1726	882609967000
20255	1726	882599966000
20256	1726	882589965000
20257	1726	882579964000
20258	1726	882569963000
20259	1726	882559962000
20260	1726	882549961000
20261	1726	882539960000
20262	1726	882529959000
20263	1726	882519958000
20264	1726	882509957000
20265	1726	882499956000
20266	1726	882489955000
20267	1726	882479954000
20268	1726	882469953000
20269	1726	882459952000
20270	1726	882449951000
20271	1726	882439950000
20272	1726	882429949000
20273	1726	882419948000
20274	1726	882409947000
20275	1726	882399946000
19780	1397	1395495683000
19781	1678	5040154417000
19782	1726	882239932000
19783	1874	200068000
19784	1683	496805760999541
19785	1683	496805780999541
19794	1397	1395475681000
19795	1678	5040154419000
19796	1397	1395465680000
19797	1678	5040154420000
19798	1726	882219930000
19799	1874	200070000
19800	1726	882209929000
19801	1874	200071000
19802	1683	498245780999541
19803	1683	498245820999541
19809	1489	10800203000000
19823	1607	18000422000000
19824	1607	18000462000000
19847	641	81840540000000
19848	641	81840620000000
19878	1397	1395335667000
19879	1678	5040154433000
19880	1726	882079916000
19881	1874	200084000
19882	1683	501125840999541
19883	1683	501125860999541
19896	1397	1395305664000
19897	1678	5040154436000
19898	1397	1395295663000
19899	1678	5040154437000
19900	1726	882049913000
19901	1874	200087000
19902	1726	882039912000
19903	1874	200088000
19904	1693	17599431551364
19905	1693	17599471551364
19906	1397	1395285662000
19907	1678	5040154438000
19908	1397	1395275661000
19909	1678	5040154439000
19910	1397	1395265660000
19911	1678	5040154440000
19912	606	76800190000000
19913	1295	1693980647751650
19914	1444	16560540000000
19915	1444	16560580000000
19923	1611	10080180000000
19945	1633	12240140000000
19946	1633	12240160000000
19982	1726	881899898000
19983	1874	200102000
19984	1726	881889897000
19985	1874	200103000
19986	1397	1395155649000
19987	1678	5040154451000
19988	1397	1395145648000
19989	1678	5040154452000
19990	1677	179283803000000
20007	1397	1395105644000
20008	1678	5040154456000
20009	1726	881849893000
20010	1874	200107000
20011	1688	85681643000000
20034	1727	9359130000000
20043	1397	1395045638000
20044	1678	5040154462000
20045	1397	1395035637000
20046	1678	5040154463000
20047	1397	1395025636000
20048	1678	5040154464000
20049	1726	881789887000
20050	1874	200113000
20051	1726	881779886000
20052	1874	200114000
20053	1726	881769885000
20054	1874	200115000
20055	1457	15120250000000
20056	1457	15120310000000
20061	1747	5039170000000
20072	1677	180003803000000
20073	1677	180003823000000
20081	1726	881729881000
20082	1874	200119000
20083	1397	1394985632000
20084	1678	5040154468000
20085	1688	87841683000000
20086	1688	87841703000000
20102	1547	7200160000000
20103	1547	7200200000000
20105	1726	881689877000
20106	1874	200123000
20107	1397	1394945628000
20108	1678	5040154472000
20109	1470	720004200000
20110	1470	720024200000
20130	1397	1394905624000
20131	1678	5040154476000
20132	1726	881649873000
20133	1874	200127000
20154	1513	9360180000000
20155	1513	10080180000000
20156	1513	10080210000000
20160	1397	1394865620000
20161	1678	5040154480000
20162	1798	160000000
20163	1726	881639870000
20164	1726	881629869000
20165	1874	200131000
20166	1613	12238470000000
20178	1670	17280560000000
20316	1726	882099917000
20317	1726	882039910000
20318	1726	882029909000
20319	1726	882019908000
20320	1726	882009907000
20321	1726	881999906000
20322	1726	881989905000
20323	1726	881979904000
20324	1726	881969903000
20325	1726	881959902000
20326	1726	881949901000
20327	1726	881939900000
20328	1726	881929899000
20329	1726	881919898000
20330	1726	881909897000
20331	1650	10080690000000
20332	1726	881899896000
20333	1726	881889895000
20334	1726	881879894000
20335	1726	881869893000
20336	1726	881859892000
20337	1726	881849891000
20338	1726	881839890000
20339	1726	881829889000
20340	1726	881819888000
20341	1726	881809887000
20342	1726	881799886000
20343	1726	881789885000
20344	1726	881779884000
20345	1726	881769883000
20346	1726	881759882000
20347	1726	881749881000
20348	1726	881739880000
20349	1726	881729879000
20350	1726	881719878000
20351	1726	881709877000
20352	1726	881699876000
20353	1726	881689875000
20354	1726	881679874000
20355	1726	881669873000
20356	1726	881659872000
20357	1726	881649871000
20358	1726	881569863000
20359	1726	881559862000
20360	1726	881549861000
20361	1874	200139000
20362	1397	1394785612000
20363	1678	5040154488000
20364	1726	881550861000
20365	1726	881551861000
20366	1726	881552861000
20367	1726	881553861000
20368	1650	10800690000000
20369	1854	10801503999990
20370	1650	200000010
20419	1637	76322014799997
20436	1726	881434849000
20437	1874	200151000
20438	1726	881424848000
20439	1874	200152000
20440	1397	1394665600000
20441	1678	5040154500000
20442	1397	1394655599000
20443	1678	5040154501000
20444	1455	12960171000000
20445	1455	12960211000000
20446	1726	881414847000
20447	1874	200153000
20448	1726	881404846000
20449	1874	200154000
20450	1726	881394845000
20451	1874	200155000
20452	1397	1394645598000
20453	1678	5040154502000
20276	1726	882389945000
20277	1726	882379944000
20278	1726	882369943000
20279	1726	882359942000
20280	1726	882349941000
20281	1726	882339940000
20282	1726	882329939000
20283	1726	882319938000
20284	1726	882309937000
20285	1726	882299936000
20286	1726	882289935000
20287	1726	882279934000
20288	1726	882269933000
20289	1726	882259932000
20290	1726	882249931000
20291	1623	22324130899898
20292	1726	882239930000
20293	1726	882229929000
20294	1726	882219928000
20295	1726	882209927000
20296	1726	882199926000
20297	1726	882189925000
20298	1726	882179924000
20299	1726	882169923000
20300	1726	882159922000
20301	1726	882149921000
20302	1726	882139920000
20303	1726	882129919000
20304	1726	882119918000
20305	1726	882109917000
20306	1726	882099916000
20307	1726	882089915000
20308	1726	882079914000
20309	1726	882069913000
20310	1726	882059912000
20311	1726	882049911000
20312	1623	23044130899898
20313	1831	200000300
20314	1849	200000007
20315	1623	23044330899593
20371	1726	881554861000
20372	1726	881544860000
20373	1874	200140000
20374	1397	1394775611000
20375	1678	5040154489000
20376	1560	20160560000000
20377	1560	20160600000000
20409	1726	881474853000
20410	1874	200147000
20411	1726	881464852000
20412	1874	200148000
20413	1397	1394705604000
20414	1678	5040154496000
20415	1397	1394695603000
20416	1678	5040154497000
20417	1677	180723823000000
20418	1677	180723863000000
20432	1726	882399947000
20433	1724	17278930000000
20434	1724	200000
20435	1568	18000159900000
20459	1726	881384844000
20460	1874	200156000
20461	1397	1394615595000
20462	1678	5040154505000
20463	1683	509766025999541
20464	1683	509766045999541
20480	1726	881344840000
20481	1874	200160000
20482	1397	1394575591000
20483	1678	5040154509000
20497	1726	881314837000
20498	1874	200163000
20499	1397	1394545588000
20500	1678	5040154512000
20531	1397	1394475581000
20532	1678	5040154519000
20533	1397	1394465580000
20534	1678	5040154520000
20535	1726	881244830000
20536	1874	200170000
20537	1726	881234829000
20538	1874	200171000
20539	1422	9360120000000
20540	1422	9360160000000
20565	1726	881194825000
20566	1874	200175000
20567	1397	1394425576000
20568	1678	5040154524000
20569	1688	88561703000000
20570	1688	88561723000000
20588	1439	10080160000000
20589	1439	10080180000000
20611	1506	12240290000000
20626	1768	8639201110000
20627	1768	8639221110000
20639	1726	881064812000
20640	1874	200188000
20641	1397	1394295563000
20642	1678	5040154537000
20643	1710	12239290000000
20644	1710	12239310000000
20656	1397	1394265560000
20657	1678	5040154540000
20658	1726	881034809000
20659	1874	200191000
20660	1402	47521231000000
20661	1402	47521251000000
20686	1726	880994805000
20687	1874	200195000
20688	1397	1394225556000
20689	1678	5040154544000
20690	1850	11505050000000
20691	1850	11505070000000
20709	1672	12960280000000
20710	1672	12960360000000
20712	1726	879654801000
20713	1880	200000000
20714	1726	878354801000
20715	1881	200000000
20716	1397	1394175551000
20717	1678	5040154549000
20718	1726	878344800000
20719	1874	200200000
20720	1726	877044800000
20721	1882	200000000
20722	1683	514086085999541
20723	1683	514086405999541
20737	228	66000010000000
20738	1688	90001733000000
20770	1397	1394105544000
20771	1678	5040154556000
20772	1726	875684794000
20773	1874	200206000
20774	1499	720000000000
20775	1499	720020000000
20791	1397	1394065540000
20792	1678	5040154560000
20793	1726	875644790000
20794	1874	200210000
20795	1693	18319471551364
20796	1693	18319491551364
20823	1599	13680260000000
20824	1599	13680300000000
20825	1397	1394015535000
20826	1678	5040154565000
20827	1726	875594785000
20828	1874	200215000
20829	1447	16560300000000
20830	1447	16560320000000
20831	1692	5779233000000
20832	1692	5779253000000
20845	1397	1393985532000
20846	1678	5040154568000
20847	1726	875564782000
20848	1874	200218000
20849	1693	19039491551364
20850	1693	19039511551364
20855	1690	41760241000000
20856	1690	41760261000000
20865	1726	875544780000
20866	1874	200220000
20867	1726	874244780000
20868	1885	200000000
20869	1397	1393945528000
20870	1678	5040154572000
20871	1726	874234779000
20872	1874	200221000
20873	1726	874224778000
20874	1874	200222000
20875	1726	874214777000
20876	1874	200223000
20877	1683	516966145999541
20878	1683	516966295999541
20891	1724	18718930000000
20892	1724	18718950000000
20895	1397	1393915525000
20896	1678	5040154575000
20897	1637	77762034799997
20898	1637	77762044799997
20903	1508	14400250000000
20904	1508	14400270000000
20923	1726	874144770000
20924	1874	200230000
20925	1397	1393875521000
20454	1397	1394635597000
20455	1678	5040154503000
20456	1397	1394625596000
20457	1678	5040154504000
20458	1673	10080580000000
20466	1397	1394605594000
20467	1678	5040154506000
20468	1397	1394595593000
20469	1678	5040154507000
20470	1397	1394585592000
20471	1678	5040154508000
20472	1726	881374843000
20473	1874	200157000
20474	1726	881364842000
20475	1874	200158000
20476	1726	881354841000
20477	1874	200159000
20478	1677	181443863000000
20479	1677	181443923000000
20501	1726	881304836000
20502	1874	200164000
20503	1397	1394535587000
20504	1678	5040154513000
20505	1588	13680210000000
20506	1588	13680230000000
20515	1397	1394505584000
20516	1678	5040154516000
20517	1726	881274833000
20518	1874	200167000
20519	1677	181443943000000
20520	1677	182163943000000
20541	1726	882549962000
20542	1726	882560962000
20543	1726	882561962000
20544	1726	882562962000
20545	1726	882563962000
20546	1726	882564962000
20547	1739	13679401000000
20548	1739	13679467000000
20571	1397	1394415575000
20572	1678	5040154525000
20573	1726	881184824000
20574	1874	200176000
20575	1671	18721020000000
20576	1671	18721040000000
20590	1726	881154821000
20591	1874	200179000
20592	1726	881144820000
20593	1874	200180000
20594	1397	1394385572000
20595	1678	5040154528000
20596	1397	1394375571000
20597	1678	5040154529000
20598	1723	13679830000000
20599	1723	13679870000000
20612	1726	881114817000
20613	1874	200183000
20614	1397	1394345568000
20615	1678	5040154532000
20616	1726	881104816000
20617	1874	200184000
20618	1397	1394335567000
20619	1678	5040154533000
20620	1677	184324023000000
20621	1677	184324043000000
20628	526	66720000000000
20629	526	66720020000000
20635	1397	1394305564000
20636	1678	5040154536000
20637	1726	881074813000
20638	1874	200187000
20655	344	66720040000000
20662	1726	881024808000
20663	1874	200192000
20664	1397	1394255559000
20665	1678	5040154541000
20666	1644	720000000000
20667	1644	720020000000
20676	1695	14399351000000
20677	1695	14399371000000
20684	1683	512646065999541
20685	1683	512646085999541
20692	1726	880984804000
20693	1874	200196000
20694	1397	1394215555000
20695	1678	5040154545000
20696	1726	880974803000
20697	1874	200197000
20698	1726	880964802000
20699	1874	200198000
20700	1726	880954801000
20701	1874	200199000
20702	1397	1394205554000
20703	1678	5040154546000
20704	1397	1394195553000
20705	1678	5040154547000
20706	1397	1394185552000
20707	1678	5040154548000
20708	484	83280352000000
20711	1764	12960208000000
20724	44	76080800000000
20739	1397	1394145548000
20740	1678	5040154552000
20741	1397	1394135547000
20742	1678	5040154553000
20743	1726	875724798000
20744	1874	200202000
20745	1726	875714797000
20746	1874	200203000
20747	1761	10000003
20748	1455	13680210999999
20749	1455	10000008
20750	1761	13680250999994
20764	1677	185044043000000
20765	1677	185044063000000
20768	1573	15120550000000
20769	1573	15120570000000
20776	1726	875674793000
20777	1874	200207000
20778	1397	1394095543000
20779	1678	5040154557000
20780	1683	515526125999541
20781	1683	515526145999541
20790	1739	14399467000000
20797	1726	875634789000
20798	1874	200211000
20799	1397	1394055539000
20800	1678	5040154561000
20801	1688	90721733000000
20802	1688	90721753000000
20811	1884	9000000000
20812	1623	24474330899593
20851	1726	875554781000
20852	1874	200219000
20853	1397	1393975531000
20854	1678	5040154569000
20859	1397	1393965530000
20860	1678	5040154570000
20861	1397	1393955529000
20862	1678	5040154571000
20863	1637	77042014799997
20864	1637	77042034799997
20894	1634	14400249899999
20915	1608	10800310000000
20927	1726	874134769000
20928	1874	200231000
20929	1726	872834769000
20930	1886	200000000
20931	1726	871534769000
20932	1887	200000000
20933	1397	1393865520000
20934	1678	5040154580000
20935	1723	13680050000000
20955	1397	1393825516000
20956	1678	5040154584000
20957	1726	870194765000
20958	1874	200235000
20959	1675	10080449999977
20960	1675	10080469999977
20970	1397	1393805514000
20971	1678	5040154586000
20972	1397	1393795513000
20973	1678	5040154587000
20974	1397	1393785512000
20975	1678	5040154588000
20976	1726	870174763000
20977	1874	200237000
20978	1726	870164762000
20979	1874	200238000
20980	1726	870154761000
20981	1874	200239000
20982	1673	10800580000000
20983	1673	10800640000000
21017	1726	870084754000
21018	1874	200246000
21019	1397	1393715505000
21020	1678	5040154595000
21021	1649	12240350999992
21022	1649	12240370999992
21025	1677	185764063000000
21026	1677	185764083000000
21064	1726	870014747000
21065	1874	200253000
21066	1726	870004746000
21067	1874	200254000
20731	1683	514086205999541
20733	1397	1394155549000
20734	1678	5040154551000
20735	1710	12959310000000
20736	1710	12959320000000
20751	1683	514086125999541
20766	115	66720000000000
20767	115	66720020000000
20782	1726	875664792000
20783	1874	200208000
20784	1397	1394085542000
20785	1678	5040154558000
20803	58	77520280000000
20804	58	77520300000000
20813	1397	1394035537000
20814	1678	5040154563000
20815	1397	1394025536000
20816	1678	5040154564000
20817	1726	875614787000
20818	1874	200213000
20819	1726	875604786000
20820	1874	200214000
20821	1447	15840260000000
20822	1447	15840300000000
20843	1714	19429210000000
20844	1714	19429250000000
20885	1726	874194775000
20886	1874	200225000
20887	1397	1393925526000
20888	1678	5040154574000
20889	1634	14400239899999
20890	1634	14400259899999
20916	1690	42480301000000
20917	1397	1393885522000
20918	1678	5040154578000
20919	1726	874154771000
20920	1874	200229000
20921	1716	16559291000000
20922	1716	16559311000000
20936	1513	10800210000000
20937	1513	10800430000000
20947	1679	51120683000000
20984	1726	870144760000
20985	1874	200240000
20986	1397	1393775511000
20987	1678	5040154589000
20988	1705	14395250000000
20989	1705	14395270000000
20992	1668	17280300000000
20993	1668	17280320000000
20998	1687	4404973726450
20999	1397	1393755509000
21000	1678	5040154591000
21001	1726	870124758000
21002	1874	200242000
21003	1726	870114757000
21004	1874	200243000
21005	1726	870104756000
21006	1874	200244000
21007	1726	870094755000
21008	1874	200245000
21009	1397	1393745508000
21010	1678	5040154592000
21011	1397	1393735507000
21012	1678	5040154593000
21013	1397	1393725506000
21014	1678	5040154594000
21015	1696	11518371000000
21023	1698	17279321000000
21024	1698	17279341000000
21027	1397	1393705504000
21028	1678	5040154596000
21029	1726	870074753000
21030	1874	200247000
21031	1611	10800180000000
21032	1611	10800200000000
21039	1622	7919079999976
21040	1622	7919099999976
21057	1693	19759521551364
21081	43	78240340000000
21084	1397	1393615495000
21085	1678	5040154605000
21086	470	80400411000000
21127	1679	51840863000000
21134	1668	18000320000000
21135	1668	18000340000000
21158	1397	1393485482000
21159	1678	5040154618000
21160	1397	1393475481000
21161	1678	5040154619000
21162	1726	869854731000
21163	1874	200269000
21164	1726	868554731000
21165	1890	200000000
21166	1726	868544730000
21167	1874	200270000
21168	1675	10800469999977
21169	1675	10800609999977
21190	1397	1393425476000
21191	1678	5040154624000
21192	1726	868494725000
21193	1874	200275000
21194	1746	2879060000000
21198	1704	2159110000000
21215	1726	881543860000
21216	1726	881533859000
21217	1726	881523858000
21218	1726	881513857000
21219	1726	881503856000
21220	1726	881493855000
21221	1726	881483854000
21222	1726	881473853000
21223	1726	881463852000
21224	1726	881453851000
21225	1726	881443850000
21226	1726	881433849000
21227	1726	881423848000
21228	1726	881413847000
21229	1726	881403846000
21230	1726	881393845000
21231	1726	881383844000
21232	1726	881373843000
21233	1726	881363842000
21234	1726	881353841000
21235	1726	881343840000
21236	1726	881333839000
21237	1726	881323838000
21238	1726	881313837000
21239	1726	881303836000
21240	1726	881293835000
21241	1726	881283834000
21242	1726	881273833000
21243	1726	881263832000
21244	1726	881253831000
21245	1726	881243830000
21246	1726	881233829000
21247	1726	881223828000
21248	1726	881213827000
21249	1650	10801903999990
21250	1726	881203826000
21251	1726	881193825000
21252	1726	881183824000
21253	1726	881173823000
21254	1726	881163822000
21255	1726	881153821000
21256	1726	881143820000
21257	1726	881133819000
21258	1726	881123818000
21259	1726	881113817000
21260	1726	881103816000
21261	1726	881093815000
21262	1726	881083814000
21263	1726	881073813000
21264	1726	881063812000
21265	1726	881053811000
21266	1726	881043810000
21267	1726	881033809000
21268	1726	881023808000
21269	1726	881013807000
21270	1726	881003806000
21271	1726	880993805000
21272	1726	880983804000
21273	1726	880973803000
21274	1726	880963802000
21275	1726	880953801000
21276	1726	879653801000
21277	1726	878353801000
21278	1726	878343800000
21279	1726	877043800000
21280	1726	875743800000
21281	1726	875733799000
21282	1726	875723798000
21283	1726	875713797000
21284	1726	875703796000
21285	1726	875693795000
21286	1726	875683794000
21287	1726	875673793000
21288	1726	875663792000
21289	1726	875653791000
21290	1726	875643790000
21291	1726	875633789000
21292	1726	875623788000
21293	1726	875613787000
21294	1726	875603786000
21295	1726	875593785000
20754	1397	1394125546000
20755	1678	5040154554000
20756	1489	11520221000000
20757	1489	11520241000000
20758	1726	875694795000
20759	1874	200205000
20760	1397	1394115545000
20761	1678	5040154555000
20762	1729	11519180000000
20763	1729	11519200000000
20786	1726	875654791000
20787	1874	200209000
20788	1397	1394075541000
20789	1678	5040154559000
20805	1397	1394045538000
20806	1678	5040154562000
20807	1726	875624788000
20808	1874	200212000
20809	1455	13680211000000
20810	1455	13680231000000
20833	1397	1394005534000
20834	1678	5040154566000
20835	1397	1393995533000
20836	1678	5040154567000
20837	1726	875584784000
20838	1874	200216000
20839	1726	875574783000
20840	1874	200217000
20841	58	78240300000000
20842	58	78240340000000
20857	171	78240190000000
20858	171	78240210000000
20879	1726	874204776000
20880	1874	200224000
20881	1397	1393935527000
20882	1678	5040154573000
20883	1471	14400340000000
20884	1471	14400360000000
20893	1724	18718940000000
20899	1726	874184774000
20900	1874	200226000
20901	1690	42480261000000
20902	1690	42480281000000
20905	1726	874174773000
20906	1874	200227000
20907	1397	1393905524000
20908	1678	5040154576000
20909	1397	1393895523000
20910	1678	5040154577000
20911	1726	874164772000
20912	1874	200228000
20913	1593	14400350000000
20914	1593	14400390000000
20938	1726	871524768000
20939	1874	200232000
20940	1726	871514767000
20941	1874	200233000
20942	1397	1393855519000
20943	1678	5040154581000
20944	1397	1393845518000
20945	1678	5040154582000
20946	1688	90721773000000
20963	1397	1393815515000
20964	1678	5040154585000
20965	1683	516966305999541
20966	1726	870184764000
20967	1874	200236000
20968	1683	518406305999541
20969	1683	518406315999541
20990	1549	16560451000000
20991	1549	16560471000000
20994	1726	870134759000
20995	1874	200241000
20996	1397	1393765510000
20997	1678	5040154590000
21033	1726	870064752000
21034	1874	200248000
21035	1397	1393695503000
21036	1678	5040154597000
21037	1402	48241251000000
21038	1402	48241271000000
21055	1679	51840683000000
21056	1679	51840703000000
21058	1397	1393655499000
21059	1678	5040154601000
21060	1726	870024748000
21061	1874	200252000
21062	1683	519846315999541
21063	1683	519846345999541
21087	1726	869984744000
21088	1874	200256000
21089	470	80400361000000
21093	1726	869974743000
21094	1874	200257000
21095	1759	15840320000000
21096	1759	15840340000000
21128	1397	1393535487000
21129	1678	5040154613000
21130	1726	869904736000
21131	1874	200264000
21132	58	79680380000000
21133	58	79680400000000
21136	1397	1393525486000
21137	1678	5040154614000
21138	1726	869894735000
21139	1874	200265000
21140	1709	11517291000000
21141	1709	11517311000000
21154	1397	1393495483000
21155	1678	5040154617000
21156	1726	869864732000
21157	1874	200268000
21209	1726	868474723000
21210	1874	200277000
21211	1397	1393405474000
21212	1678	5040154626000
21213	1683	524166405999541
21214	1683	524166425999541
21344	1726	868464722000
21345	1874	200278000
21346	1726	868454721000
21347	1874	200279000
21348	1654	12960281000000
21351	1704	3599110000000
21352	1704	3599151000000
21356	1397	1393375471000
21357	1678	5040154629000
21358	1726	868444720000
21359	1874	200280000
21360	1688	91441753000000
21361	1688	91441773000000
21367	1397	1393365470000
21368	1678	5040154630000
21369	1726	868434719000
21370	1874	200281000
21371	1683	525606425999541
21372	1683	525606455999541
21409	1397	1393295463000
21410	1678	5040154637000
21411	1726	868364712000
21412	1874	200288000
21413	44	76800800000000
21414	44	76800820000000
21437	1397	1393245458000
21438	1678	5040154642000
21439	1726	868314707000
21440	1874	200293000
21450	1726	868294705000
21451	1874	200295000
21455	1762	8639220000000
21456	1726	868284704000
21457	1874	200296000
21458	1397	1393215455000
21459	1678	5040154645000
21460	1683	528486475999541
21461	1683	528486495999541
21464	1726	868274703000
21465	1874	200297000
21466	1397	1393205454000
21467	1678	5040154646000
21468	1746	4319081000000
21469	1746	4319101000000
21484	1693	20479541551364
21491	1397	1393165450000
21492	1678	5040154650000
21493	1726	868234699000
21494	1874	200301000
21495	1696	12238371000000
21496	1696	12238391000000
21499	1759	16560360000000
21506	1726	868214697000
21507	1874	200303000
21508	1726	868204696000
21509	1874	200304000
21510	1397	1393145448000
21511	1678	5040154652000
21512	1397	1393135447000
21513	1678	5040154653000
21514	1688	92161773000000
21515	1688	92161813000000
21518	1726	868194695000
21519	1874	200305000
21520	1397	1393125446000
21521	1678	5040154654000
21522	1419	15840360000000
20926	1678	5040154579000
20948	1397	1393835517000
20949	1678	5040154583000
20950	1726	871504766000
20951	1874	200234000
20952	1726	870204766000
20953	1888	200000000
20954	1714	19429330000000
20961	1633	12960160000000
20962	1633	12960180000000
21016	1419	15120400000000
21041	1397	1393685502000
21042	1678	5040154598000
21043	1397	1393675501000
21044	1678	5040154599000
21045	1726	870054751000
21046	1874	200249000
21047	1726	870044750000
21048	1874	200250000
21049	1397	1393665500000
21050	1678	5040154600000
21051	1726	870034749000
21052	1874	200251000
21053	1693	19759511551364
21054	1693	19759531551364
21078	43	78240370000000
21107	1690	43200281000000
21108	1690	43200321000000
21144	1397	1393515485000
21145	1678	5040154615000
21146	1397	1393505484000
21147	1678	5040154616000
21148	1726	869884734000
21149	1874	200266000
21150	1726	869874733000
21151	1874	200267000
21152	1683	521286345999541
21153	1683	521286385999541
21170	1683	522726385999541
21171	1683	522726525999541
21195	1678	5040174624000
21196	1678	5760174624000
21199	1740	15837923000000
21200	1817	200000010
21201	1740	16557922999990
21203	1397	1393415475000
21204	1678	5040154625000
21205	1726	868484724000
21206	1874	200276000
21207	1684	28079710000000
21208	1684	28079730000000
21353	1746	3599081000000
21354	1749	10075189000000
21364	1769	2934900000
21365	1685	54000177000000
21366	1685	54000188000000
21379	1397	1393345468000
21380	1678	5040154632000
21381	1726	868414717000
21382	1874	200283000
21383	1726	868404716000
21384	1874	200284000
21385	1397	1393335467000
21386	1678	5040154633000
21387	1679	52560743000000
21388	1679	52560783000000
21408	1685	55440188000000
21415	1397	1393285462000
21416	1678	5040154638000
21417	1726	868354711000
21418	1874	200289000
21419	1402	48961271000000
21420	1402	48961291000000
21428	1726	868334709000
21429	1874	200291000
21430	1397	1393265460000
21431	1678	5040154640000
21432	1726	868324708000
21433	1874	200292000
21434	1397	1393255459000
21435	1678	5040154641000
21436	1546	13680250000000
21462	1692	6499253000000
21463	1692	6499273000000
21470	1704	3599130000000
21485	1726	868244700000
21486	1874	200300000
21487	1397	1393175451000
21488	1678	5040154649000
21489	1683	529926495999541
21490	1683	529926515999541
21504	1850	12225070000000
21505	1850	12225090000000
21516	576	78960380000000
21517	576	78960420000000
21533	1397	1393095443000
21534	1678	5040154657000
21535	1726	868164692000
21536	1874	200308000
21537	1637	78482074799997
21538	1637	78482094799997
21555	43	78240320000000
21557	1726	868124688000
21558	1874	200312000
21559	1726	868114687000
21560	1874	200313000
21561	1397	1393055439000
21562	1678	5040154661000
21563	1397	1393045438000
21564	1678	5040154662000
21565	1448	12240351000000
21566	1448	12240391000000
21613	1598	1440020000000
21614	1598	1440040000000
21621	606	77520190000000
21635	641	82560620000000
21636	641	82560640000000
21642	1726	866694675000
21643	1874	200325000
21644	1397	1392925426000
21645	1678	5040154674000
21646	1719	10079210000000
21647	1719	10079230000000
21068	1726	869994745000
21069	1874	200255000
21070	1397	1393645498000
21071	1678	5040154602000
21072	1397	1393635497000
21073	1678	5040154603000
21074	1397	1393625496000
21075	1678	5040154604000
21076	1671	19441040000000
21077	1671	19441100000000
21079	1677	186484083000000
21080	1677	186484143000000
21082	470	80400341000000
21083	470	80400401000000
21090	1397	1393605494000
21091	1678	5040154606000
21092	470	80400371000000
21097	1726	869964742000
21098	1874	200258000
21099	1726	869954741000
21100	1874	200259000
21101	1397	1393595493000
21102	1678	5040154607000
21103	1397	1393585492000
21104	1678	5040154608000
21105	58	78960340000000
21106	58	78960380000000
21109	1885	100000000
21110	1726	869944740000
21111	1874	200260000
21112	1726	869934739000
21113	1874	200261000
21114	1726	869924738000
21115	1874	200262000
21116	1726	869914737000
21117	1874	200263000
21118	1397	1393575491000
21119	1678	5040154609000
21120	1397	1393565490000
21121	1678	5040154610000
21122	1397	1393555489000
21123	1678	5040154611000
21124	1397	1393545488000
21125	1678	5040154612000
21126	1649	12240530999992
21142	1677	187204143000000
21143	1677	187204163000000
21172	1726	868534729000
21173	1874	200271000
21174	1397	1393465480000
21175	1678	5040154620000
21176	1683	522726405999541
21177	1726	868524728000
21178	1874	200272000
21179	1726	868514727000
21180	1874	200273000
21181	1726	868504726000
21182	1874	200274000
21183	1397	1393455479000
21184	1678	5040154621000
21185	1397	1393445478000
21186	1678	5040154622000
21187	1397	1393435477000
21188	1678	5040154623000
21189	1679	51840743000000
21197	1747	5759190000000
21202	1740	16557923000000
21337	1397	1393395473000
21338	1678	5040154627000
21339	1397	1393385472000
21340	1678	5040154628000
21341	1769	2944900000
21342	1654	12960240000000
21343	1654	12960261000000
21349	1747	5759170000000
21350	1747	5759211000000
21355	1749	10075209000000
21362	1723	14400050000000
21363	1723	14400070000000
21389	1564	9360162000000
21390	1564	9360202000000
21392	1726	868394715000
21393	1874	200285000
21394	1726	868384714000
21395	1874	200286000
21396	1397	1393325466000
21397	1678	5040154634000
21398	1397	1393315465000
21399	1678	5040154635000
21400	1457	15840310000000
21401	1457	15840350000000
21421	1637	77762054799997
21422	1726	868344710000
21423	1874	200290000
21424	1397	1393275461000
21425	1678	5040154639000
21442	1726	868304706000
21443	1874	200294000
21444	1397	1393235457000
21445	1678	5040154643000
21446	1397	1393225456000
21447	1678	5040154644000
21448	369	82560370000000
21449	369	82560380000000
21454	369	82560390000000
21471	1764	13680248000000
21472	1764	13680268000000
21483	1637	77762074799997
21550	1726	868134689000
21551	1874	200311000
21552	1397	1393065440000
21553	1678	5040154660000
21554	43	78240330000000
21567	1726	868104686000
21568	1874	200314000
21569	1726	866804686000
21570	1891	200000000
21571	1397	1393035437000
21572	1678	5040154663000
21573	1637	79202094799997
21574	1637	79202214799997
21588	1722	1440118000000
21604	1397	1392985432000
21605	1678	5040154668000
21606	1677	187924223000000
21626	1726	866724678000
21627	1874	200322000
21628	1670	18000580000000
21648	1637	79202114799997
21296	1726	875583784000
21297	1726	875573783000
21298	1726	875563782000
21299	1726	875553781000
21300	1726	875543780000
21301	1726	874243780000
21302	1726	874233779000
21303	1726	874223778000
21304	1726	874213777000
21305	1726	874203776000
21306	1726	874193775000
21307	1726	874183774000
21308	1726	874173773000
21309	1726	874163772000
21310	1726	874153771000
21311	1726	874143770000
21312	1726	874133769000
21313	1726	872833769000
21314	1726	871533769000
21315	1726	871523768000
21316	1726	871513767000
21317	1726	871503766000
21318	1726	870203766000
21319	1726	870193765000
21320	1726	870183764000
21321	1726	870173763000
21322	1726	870163762000
21323	1726	870153761000
21324	1726	870143760000
21325	1726	870133759000
21326	1726	870123758000
21327	1726	870113757000
21328	1726	870103756000
21329	1726	870093755000
21330	1726	870083754000
21331	1726	870073753000
21332	1726	870063752000
21333	1726	870053751000
21334	1726	870043750000
21335	1650	11521903999990
21336	1650	11523473999990
21373	1397	1393355469000
21374	1678	5040154631000
21375	1726	868424718000
21376	1874	200282000
21377	1683	527046455999541
21378	1683	527046475999541
21391	1685	54720188000000
21402	1397	1393305464000
21403	1678	5040154636000
21404	1726	868374713000
21405	1874	200287000
21406	1706	13676402000000
21407	1706	13676422000000
21426	1679	53280783000000
21427	1679	53280803000000
21441	1672	12960300000000
21452	1762	8639210000000
21453	1762	8639230000000
21473	1397	1393195453000
21474	1678	5040154647000
21475	1397	1393185452000
21476	1678	5040154648000
21477	1726	868264702000
21478	1874	200298000
21479	1726	868254701000
21480	1874	200299000
21481	1693	20479521551364
21482	1693	20479561551364
21497	1759	16560340000000
21498	1759	16560350000000
21500	1726	868224698000
21501	1874	200302000
21502	1397	1393155449000
21503	1678	5040154651000
21524	1726	868184694000
21525	1874	200306000
21526	1726	868174693000
21527	1874	200307000
21528	1397	1393115445000
21529	1678	5040154655000
21530	1397	1393105444000
21531	1678	5040154656000
21532	1729	11519220000000
21545	1726	868144690000
21546	1874	200310000
21547	1397	1393075441000
21548	1678	5040154659000
21549	1677	186484163000000
21577	1685	56880188000000
21580	1397	1393015435000
21581	1678	5040154665000
21582	1397	1393005434000
21583	1678	5040154666000
21584	1397	1392995433000
21585	1678	5040154667000
21586	1683	531366515999541
21587	1683	531366545999541
21599	1541	8637318000000
21600	1726	866754681000
21601	1874	200319000
21602	484	84000352000000
21603	484	84001202000000
21622	1397	1392955429000
21623	1678	5040154671000
21624	1670	18000560000000
21625	1670	18000570000000
21523	1419	15840380000000
21539	1397	1393085442000
21540	1678	5040154658000
21541	1726	868154691000
21542	1874	200309000
21543	1622	8639099999976
21544	1622	8639119999976
21556	1685	56160188000000
21575	1402	49681291000000
21576	1402	49681411000000
21578	1397	1393025436000
21579	1678	5040154664000
21589	1726	866794685000
21590	1874	200315000
21591	1726	866784684000
21592	1874	200316000
21593	1726	866774683000
21594	1874	200317000
21595	1726	866764682000
21596	1874	200318000
21597	1677	187924163000000
21598	1677	187924233000000
21607	1726	866744680000
21608	1874	200320000
21609	1397	1392975431000
21610	1678	5040154669000
21611	58	80400400000000
21612	58	80400420000000
21615	1726	866734679000
21616	1874	200321000
21617	1397	1392965430000
21618	1678	5040154670000
21619	42	76077840000000
21620	42	76077860000000
21629	1726	866714677000
21630	1874	200323000
21631	1397	1392945428000
21632	1678	5040154672000
21633	1714	20149330000000
21634	1714	20149350000000
21637	1397	1392935427000
21638	1678	5040154673000
21639	1726	866704676000
21640	1874	200324000
21641	1711	14399230000000
21649	1397	1392915425000
21650	1678	5040154675000
21651	1726	866684674000
21652	1874	200326000
21653	1690	43200301000000
21654	1397	1392905424000
21655	1678	5040154676000
21656	1683	531366525999541
21657	1726	866674673000
21658	1874	200327000
21659	1726	866664672000
21660	1874	200328000
21661	1397	1392895423000
21662	1678	5040154677000
21663	1397	1392885422000
21664	1678	5040154678000
21665	1397	1392875421000
21666	1678	5040154679000
21667	1397	1392865420000
21668	1678	5040154680000
21669	1726	866654671000
21670	1874	200329000
21671	1726	866644670000
21672	1874	200330000
21673	1726	866634669000
21674	1874	200331000
21675	1680	17279390000000
21676	1397	1392855419000
21677	1678	5040154681000
21678	1683	532806525999541
21679	1683	532806535999541
21680	1726	866624668000
21681	1874	200332000
21682	1716	17279311000000
21683	1716	17279331000000
21684	58	81120420000000
21685	58	81120440000000
21686	1677	188644223000000
21687	1677	188644243000000
21688	1701	12958332000000
21689	1701	12958352000000
21690	1397	1392845418000
21691	1678	5040154682000
21692	1726	866614667000
21693	1874	200333000
21694	1716	17279341000000
21695	1639	720030000000
21696	1397	1392835417000
21697	1678	5040154683000
21698	1726	866604666000
21699	1874	200334000
21700	1726	866594665000
21701	1874	200335000
21702	1397	1392825416000
21703	1678	5040154684000
21704	1506	12960290000000
21705	1506	12960310000000
21706	1397	1392815415000
21707	1678	5040154685000
21708	1397	1392805414000
21709	1678	5040154686000
21710	1726	866584664000
21711	1874	200336000
21712	1726	866574663000
21713	1874	200337000
21714	1587	14400240000000
21715	1587	14400280000000
21716	1692	6499293000000
21717	1726	866564662000
21718	1874	200338000
21719	1397	1392795413000
21720	1678	5040154687000
21721	1607	18000442000000
21722	1397	1392785412000
21723	1678	5040154688000
21724	1397	1392775411000
21725	1678	5040154689000
21726	1726	866554661000
21727	1874	200339000
21728	1726	866544660000
21729	1874	200340000
21730	1710	13679320000000
21731	1710	13679360000000
21732	1726	866534659000
21733	1874	200341000
21734	1397	1392765410000
21735	1678	5040154690000
21736	470	81120361000000
21737	470	81120381000000
21738	1397	1392755409000
21739	1678	5040154691000
21740	1726	866524658000
21741	1874	200342000
21742	1688	92161793000000
21743	1726	866514657000
21744	1874	200343000
21745	1397	1392745408000
21746	1678	5040154692000
21747	1683	534246535999541
21748	1683	534246555999541
21749	1690	43920301000000
21750	1690	43920321000000
21751	1397	1392735407000
21752	1678	5040154693000
21753	1726	866504656000
21754	1874	200344000
21755	1726	866494655000
21756	1874	200345000
21757	1397	1392725406000
21758	1678	5040154694000
21759	1726	866484654000
21760	1874	200346000
21761	1397	1392715405000
21762	1678	5040154695000
21763	1673	11520640000000
21764	1673	11520680000000
21765	1675	11520609999977
21766	1675	11520649999977
21767	1726	866474653000
21768	1874	200347000
21769	1726	865174653000
21770	1718	200000000
21771	1397	1392705404000
21772	1678	5040154696000
21773	1726	865164652000
21774	1874	200348000
21775	1397	1392695403000
21776	1678	5040154697000
21777	1397	1392685402000
21778	1678	5040154698000
21779	1397	1392675401000
21780	1678	5040154699000
21781	1726	865154651000
21782	1874	200349000
21783	1726	865144650000
21784	1874	200350000
21785	1644	1440020000000
21786	1644	200100000
21787	1790	1440196300000
21788	1744	1600500000
21789	1758	903500000
21811	1726	865104646000
21812	1874	200354000
21813	1397	1392635397000
21814	1678	5040154703000
21815	1447	17280320000000
21816	1447	17280340000000
21818	1518	2160040000000
21841	1610	14400440000000
21858	1671	19441080000000
21869	1623	22321540899898
21870	1623	22321580899898
21880	1397	1392525386000
21881	1678	5040154714000
21882	1397	1392515385000
21883	1678	5040154715000
21884	1726	864994635000
21885	1874	200365000
21886	1726	864984634000
21887	1874	200366000
21888	1726	864974633000
21889	1874	200367000
21890	1397	1392505384000
21891	1678	5040154716000
21892	1560	20160620000000
21907	1726	864944630000
21908	1874	200370000
21909	1397	1392475381000
21910	1678	5040154719000
21911	1457	16560350000000
21912	1457	16560370000000
21930	1726	864904626000
21931	1874	200374000
21932	1726	864894625000
21933	1874	200375000
21934	1397	1392435377000
21935	1678	5040154723000
21936	1397	1392425376000
21937	1678	5040154724000
21947	1397	1392395373000
21948	1678	5040154727000
21949	1726	864864622000
21950	1874	200378000
21951	1726	864854621000
21952	1874	200379000
21953	1397	1392385372000
21954	1678	5040154728000
21955	1679	54000803000000
21956	1679	54000843000000
21969	1397	1392355369000
21970	1678	5040154731000
21971	1726	864824618000
21972	1874	200382000
21973	1455	15120251000000
21974	1455	15120271000000
21977	1397	1392345368000
21978	1678	5040154732000
21979	1726	864814617000
21980	1874	200383000
21981	1654	12960260000000
21995	1726	863484614000
21996	1874	200386000
21997	1726	863474613000
21998	1874	200387000
21999	1397	1392315365000
22000	1678	5040154735000
22001	1397	1392305364000
22002	1678	5040154736000
22003	1719	10799230000000
22004	1719	10799270000000
22011	1397	1392285362000
22012	1678	5040154738000
22013	1397	1392275361000
22014	1678	5040154739000
22015	1726	863454611000
22016	1874	200389000
22017	1726	863444610000
22018	1874	200390000
22019	1402	51121551000000
22020	1402	51121591000000
22065	1726	863364602000
22066	1874	200398000
22067	1397	1392195353000
22068	1678	5040154747000
22069	1693	21199541551364
22070	1693	21199561551364
22088	1685	57600188000000
22122	1397	1392115345000
22123	1678	5040154755000
22124	1690	45360581000000
22125	1690	45360591000000
22131	1687	5124993726450
22132	1687	5125013726450
22171	1690	46080591000000
22172	1690	46080631000000
22192	1602	10800330000000
22195	1726	860564582000
22196	1874	200418000
22197	1397	1391985332000
22198	1678	5040154768000
22199	1444	16560560000000
22239	1726	860494575000
22240	1874	200425000
22241	1448	12960411000000
22246	1716	17999341000000
22247	1716	17999361000000
22274	1749	10795208000000
22275	1749	10795228000000
22303	1397	1391805314000
22304	1678	5040154786000
22305	1397	1391795313000
22306	1678	5040154787000
22307	1726	860374563000
22308	1874	200437000
22309	1726	860364562000
22310	1874	200438000
22311	1687	5125033726450
22327	1726	860324558000
22328	1874	200442000
22329	1726	859024558000
22330	1895	200000000
22331	1397	1391755309000
22332	1678	5040154791000
22333	700	71040210000000
22384	1397	1391645298000
22385	1678	5040154802000
22386	1397	1391635297000
22387	1678	5040154803000
22388	1726	858914547000
22389	1874	200453000
22390	1726	857614547000
22391	1896	200000000
22392	1726	857604546000
22393	1874	200454000
22394	1513	10800350000000
22395	1726	857594545000
22396	1874	200455000
22397	1726	857584544000
22398	1874	200456000
22399	1397	1391625296000
22400	1678	5040154804000
22401	1397	1391615295000
22402	1678	5040154805000
22403	1397	1391605294000
22404	1678	5040154806000
22405	1726	857574543000
22406	1874	200457000
22407	1599	13680320000000
22410	1397	1391595293000
22411	1678	5040154807000
22412	1726	857564542000
22413	1874	200458000
22414	1688	93601853000000
22446	1397	1391535287000
22447	1678	5040154813000
22448	1726	857504536000
22449	1874	200464000
22450	1726	857494535000
22451	1874	200465000
22452	1850	12225100000000
22462	576	79680420000000
22463	576	79680440000000
22481	1726	857414527000
22482	1874	200473000
22526	1701	12958452000000
22529	470	81840501000000
22530	1726	856024518000
22531	1874	200482000
22532	1688	93601843000000
22554	1726	855974513000
22555	1874	200487000
22556	1726	855964512000
22557	1874	200488000
22558	1726	855954511000
22559	1874	200489000
22560	1726	855944510000
22561	1874	200490000
22562	154	66000090000000
22563	1685	50400190000000
22581	1749	11515228000000
22582	1749	11515238000000
22583	1726	855874503000
22584	1874	200497000
22585	1683	545766715999541
22586	1683	545766725999541
21790	1644	1440200000000
21799	1397	1392655399000
21800	1678	5040154701000
21801	1726	865124648000
21802	1874	200352000
21803	1670	18720580000000
21804	1670	18720600000000
21805	1397	1392645398000
21806	1678	5040154702000
21807	1726	865114647000
21808	1874	200353000
21809	1637	79922114799997
21810	1637	79922134799997
21819	1397	1392625396000
21820	1678	5040154704000
21821	1397	1392615395000
21822	1678	5040154705000
21823	1726	865094645000
21824	1874	200355000
21825	1726	865084644000
21826	1874	200356000
21827	1644	1199000000
21828	544	67439000000000
21829	1649	12960530999992
21830	1649	12960571999992
21832	1419	16560380000000
21833	1419	16560421000000
21835	1726	865074643000
21836	1874	200357000
21837	1397	1392605394000
21838	1678	5040154706000
21871	1723	14400090000000
21904	1695	14399391000000
21924	1677	189364243000000
21925	1677	189364283000000
21938	1726	864884624000
21939	1874	200376000
21940	1397	1392415375000
21941	1678	5040154725000
21957	1397	1392375371000
21958	1678	5040154729000
21959	1726	864844620000
21960	1874	200380000
21961	1673	12240680000000
21962	1673	12240700000000
21975	1677	190084283000000
21976	1677	190084303000000
22005	42	77517880000000
22006	42	77517920000000
22021	1677	190084323000000
22034	1397	1392245358000
22035	1678	5040154742000
22036	1726	863414607000
22037	1874	200393000
22038	1683	540006635999541
22039	1683	540006655999541
22042	1637	80642134799997
22043	1637	80642154799997
22055	1397	1392215355000
22056	1678	5040154745000
22057	1726	863384604000
22058	1874	200396000
22082	1489	12960261000000
22099	1726	863304596000
22100	1874	200404000
22101	1726	862004596000
22102	1893	200000000
22103	1397	1392135347000
22104	1678	5040154753000
22105	1402	51841591000000
22106	1402	51841711000000
22109	641	83280640000000
22110	641	83280760000000
22111	641	82561260000000
22112	641	83281260000000
22113	641	83281540000000
22133	1693	20479431551364
22134	327	66000100000000
22135	1726	860674593000
22136	1874	200407000
22137	1726	860664592000
22138	1874	200408000
22139	1726	860654591000
22140	1874	200409000
22141	1726	860644590000
22142	1874	200410000
22143	1726	860634589000
22144	1874	200411000
22145	1397	1392095343000
22146	1678	5040154757000
22147	1397	1392085342000
22148	1678	5040154758000
22149	1397	1392075341000
22150	1678	5040154759000
22151	1397	1392065340000
22152	1678	5040154760000
22153	1397	1392055339000
22154	1678	5040154761000
22155	1447	17280450000000
22157	1693	19759411551364
22158	1474	10075483000000
22159	1474	10795483000000
22160	1474	10795744000000
22173	1726	860604586000
22174	1874	200414000
22175	1726	860594585000
22176	1874	200415000
22177	1397	1392025336000
22178	1678	5040154764000
22179	1397	1392015335000
22180	1678	5040154765000
22181	1623	23041560899898
22182	1623	23041600899898
22206	1397	1391965330000
22207	1678	5040154770000
22208	1726	860544580000
22209	1874	200420000
22210	1622	9359119999976
22211	1622	9359139999976
22223	1726	860514577000
22224	1874	200423000
22225	1698	17279331000000
22234	1686	6692056500013
22248	1768	9359241110000
22276	1397	1391855319000
22277	1678	5040154781000
22278	1726	860424568000
22279	1874	200432000
22280	633	78239300000000
22281	633	78239320000000
22282	1726	860414567000
22283	1874	200433000
22284	1726	860404566000
22285	1874	200434000
22286	1397	1391845318000
22287	1678	5040154782000
22288	1397	1391835317000
22289	1678	5040154783000
22290	1457	16560390000000
22291	633	78959320000000
22292	633	78959360000000
22312	1681	21599455195920
22313	1681	21599495195920
22334	1726	859014557000
22335	1874	200443000
22336	1726	859004556000
22337	1874	200444000
22338	1397	1391745308000
22339	1678	5040154792000
22340	1397	1391735307000
22341	1678	5040154793000
22352	1726	858974553000
22353	1874	200447000
22354	1726	858964552000
22355	1874	200448000
22356	1726	858954551000
22357	1874	200449000
22358	1726	858944550000
22359	1874	200450000
22360	1397	1391705304000
22361	1678	5040154796000
22362	1397	1391695303000
22363	1678	5040154797000
22364	1397	1391685302000
22365	1678	5040154798000
22366	1397	1391675301000
22367	1678	5040154799000
22368	1726	858934549000
22369	1874	200451000
22370	1397	1391665300000
22371	1678	5040154800000
22372	1693	21199341551364
22373	154	66000100000000
22374	1444	17280560000000
22375	1444	17280670000000
22378	1397	1391655299000
22379	1678	5040154801000
22380	1726	858924548000
22381	1874	200452000
22415	1679	54720843000000
22416	1679	54720863000000
22421	1726	857544540000
22422	1874	200460000
22423	1397	1391575291000
22424	1678	5040154809000
21791	1397	1392665400000
21792	1678	5040154700000
21793	1726	865134649000
21794	1874	200351000
21795	1688	92881793000000
21796	1688	92881813000000
21817	596	82560342000000
21834	1692	6499294000000
21842	1726	865064642000
21843	1874	200358000
21844	1397	1392595393000
21845	1678	5040154707000
21846	1683	535686555999541
21847	1683	535686575999541
21859	1397	1392565390000
21860	1678	5040154710000
21861	1726	865034639000
21862	1874	200361000
21863	1726	865024638000
21864	1874	200362000
21865	1397	1392555389000
21866	1678	5040154711000
21867	1694	29519565000000
21868	1694	29519605000000
21893	1610	14400480000000
21905	470	81840381000000
21906	470	81840421000000
21913	1694	30239605000000
21914	1694	30239625000000
22024	1397	1392265360000
22025	1678	5040154740000
22026	1726	863434609000
22027	1874	200391000
22028	1623	22321560899898
22040	1439	10800180000000
22041	1439	10800200000000
22044	1397	1392235357000
22045	1678	5040154743000
22046	1397	1392225356000
22047	1678	5040154744000
22048	1726	863404606000
22049	1874	200394000
22050	1726	863394605000
22051	1874	200395000
22052	1768	9359221110000
22053	1768	9359261110000
22071	1740	16557903000000
22083	1726	863334599000
22084	1874	200401000
22085	1397	1392165350000
22086	1678	5040154750000
22087	1489	12960281000000
22089	1726	863324598000
22090	1874	200402000
22091	1726	863314597000
22092	1874	200403000
22093	1397	1392155349000
22094	1678	5040154751000
22095	1397	1392145348000
22096	1678	5040154752000
22097	1426	8640310000000
22107	1688	93601833000000
22108	1688	93601953000000
22126	1726	860684594000
22127	1874	200406000
22128	1397	1392105344000
22129	1678	5040154756000
22130	1402	51841611000000
22161	1726	860624588000
22162	1874	200412000
22163	1397	1392045338000
22164	1678	5040154762000
22165	1397	1392035337000
22166	1678	5040154763000
22167	1726	860614587000
22168	1874	200413000
22169	1756	14399789000000
22170	1756	14399829000000
22183	1397	1392005334000
22184	1678	5040154766000
22185	1397	1391995333000
22186	1678	5040154767000
22187	1726	860584584000
22188	1874	200416000
22189	1726	860574583000
22190	1874	200417000
22191	1683	540006675999541
22193	1692	7939313000000
22194	1692	7939353000000
22212	1397	1391955329000
22213	1678	5040154771000
22214	1726	860534579000
22215	1874	200421000
22216	389	66720000000000
22217	389	66720020000000
22235	1397	1391915325000
22236	1678	5040154775000
22237	1448	12960391000000
22238	1448	12960401000000
22242	1397	1391905324000
22243	1678	5040154776000
22244	1726	860484574000
22245	1874	200426000
22253	596	82560332000000
22314	1726	860354561000
22315	1874	200439000
22316	1726	860344560000
22317	1874	200440000
22318	1726	860334559000
22319	1874	200441000
22320	1397	1391785312000
22321	1678	5040154788000
22322	1397	1391775311000
22323	1678	5040154789000
22324	1397	1391765310000
22325	1678	5040154790000
22326	1677	191524383000000
22342	1397	1391725306000
22343	1678	5040154794000
22344	1397	1391715305000
22345	1678	5040154795000
22346	1726	858994555000
22347	1874	200445000
22348	1726	858984554000
22349	1874	200446000
22350	1764	14400268000000
22351	1764	14400308000000
22376	1768	10079241110000
22377	1768	10079351110000
22382	1673	12960700000000
22383	1673	12960720000000
22408	1709	12237311000000
22409	1709	12237371000000
22427	1397	1391565290000
22428	1678	5040154810000
22429	1726	857534539000
22430	1874	200461000
22431	1663	720000000000
22432	1663	720020000000
22433	1397	1391555289000
22434	1678	5040154811000
22435	1726	857524538000
22436	1874	200462000
22437	1607	18720442000000
22438	1607	18720462000000
22455	1637	82082174799997
22456	1637	82082204799997
22486	1726	856114527000
22487	1897	200000000
22488	1726	856104526000
22489	1874	200474000
22490	1656	17280371000000
22491	1656	17280481000000
22493	1693	19759301551364
22494	641	83282780000000
22495	641	84002780000000
22496	641	84003060000000
22501	1726	856074523000
22502	1874	200477000
22503	1726	856064522000
22504	1874	200478000
22505	1683	541446675999541
22506	1683	541446695999541
22513	1677	192244383000000
22514	1677	192244393000000
22517	1522	11519970000000
22518	1898	0
22519	1726	856044520000
22520	1874	200480000
22521	1726	856034519000
22522	1874	200481000
22523	1587	15120280000000
22524	1587	15120400000000
22543	1726	855994515000
22544	1874	200485000
22545	633	79679360000000
22546	633	79679370000000
22549	1726	855984514000
22550	1874	200486000
22551	1546	14400250000000
22552	1546	14400260000000
22569	1740	17277923000000
22570	1740	17277943000000
22587	1726	855864502000
22588	1874	200498000
21797	42	76797860000000
21798	42	76797880000000
21831	1672	12960321000000
21839	1489	12240241000000
21840	1489	12240261000000
21848	1726	865054641000
21849	1874	200359000
21850	1726	865044640000
21851	1874	200360000
21852	1397	1392585392000
21853	1678	5040154708000
21854	1397	1392575391000
21855	1678	5040154709000
21856	1683	537126575999541
21857	1683	537126615999541
21872	1397	1392545388000
21873	1678	5040154712000
21874	1397	1392535387000
21875	1678	5040154713000
21876	1726	865014637000
21877	1874	200363000
21878	1726	865004636000
21879	1874	200364000
21894	1726	864964632000
21895	1874	200368000
21896	1397	1392495383000
21897	1678	5040154717000
21898	1397	1392485382000
21899	1678	5040154718000
21900	1726	864954631000
21901	1874	200369000
21902	1683	538566615999541
21903	1683	538566655999541
21915	1397	1392465380000
21916	1678	5040154720000
21917	1397	1392455379000
21918	1678	5040154721000
21919	1726	864934629000
21920	1874	200371000
21921	1726	864924628000
21922	1874	200372000
21923	1688	92881833000000
21926	1397	1392445378000
21927	1678	5040154722000
21928	1726	864914627000
21929	1874	200373000
21942	1397	1392405374000
21943	1678	5040154726000
21944	1726	864874623000
21945	1874	200377000
21946	1683	538566635999541
21963	1726	864834619000
21964	1874	200381000
21965	1397	1392365370000
21966	1678	5040154730000
21967	1455	14400231000000
21968	1455	14400251000000
21982	1726	863514617000
21983	1892	200000000
21984	1397	1392335367000
21985	1678	5040154733000
21986	1397	1392325366000
21987	1678	5040154734000
21988	1402	49681531000000
21989	1726	863504616000
21990	1874	200384000
21991	1726	863494615000
21992	1874	200385000
21993	1402	50401531000000
21994	1402	50401551000000
22007	1726	863464612000
22008	1874	200388000
22009	1397	1392295363000
22010	1678	5040154737000
22022	1613	12958470000000
22023	1613	12958510000000
22029	1397	1392255359000
22030	1678	5040154741000
22031	1726	863424608000
22032	1874	200392000
22033	149	73200160000000
22054	1749	10075208000000
22059	1397	1392205354000
22060	1678	5040154746000
22061	1726	863374603000
22062	1874	200397000
22063	1694	30959625000000
22064	1694	30959645000000
22072	1397	1392185352000
22073	1678	5040154748000
22074	1397	1392175351000
22075	1678	5040154749000
22076	1726	863354601000
22077	1874	200399000
22078	1726	863344600000
22079	1874	200400000
22080	1692	7219273000000
22081	1692	7219313000000
22098	1690	43920341000000
22114	1726	860704596000
22115	1894	200000000
22116	1726	860694595000
22117	1874	200405000
22118	1397	1392125346000
22119	1678	5040154754000
22120	1690	44640341000000
22121	1690	44640581000000
22156	1474	10794393000000
22200	1726	860554581000
22201	1874	200419000
22202	1397	1391975331000
22203	1678	5040154769000
22204	1693	21199431551364
22205	1693	21199451551364
22218	1726	860524578000
22219	1874	200422000
22220	1397	1391945328000
22221	1678	5040154772000
22222	1692	7939333000000
22226	1397	1391935327000
22227	1678	5040154773000
22228	1726	860504576000
22229	1874	200424000
22230	1397	1391925326000
22231	1678	5040154774000
22232	1670	19440600000000
22233	1670	19440630000000
22249	1726	860474573000
22250	1874	200427000
22251	1397	1391895323000
22252	1678	5040154777000
22254	1397	1391885322000
22255	1678	5040154778000
22256	1726	860464572000
22257	1874	200428000
22258	1677	190804303000000
22259	1677	190804323000000
22260	1726	860454571000
22261	1874	200429000
22262	1726	860444570000
22263	1874	200430000
22264	1397	1391875321000
22265	1678	5040154779000
22266	1755	1439010000000
22267	1755	1439040000000
22268	1397	1391865320000
22269	1678	5040154780000
22270	1726	860434569000
22271	1874	200431000
22272	1677	191524323000000
22273	1677	191524343000000
22293	1726	860394565000
22294	1874	200435000
22295	1726	860384564000
22296	1874	200436000
22297	1397	1391825316000
22298	1678	5040154784000
22299	1397	1391815315000
22300	1678	5040154785000
22301	1689	12239251000000
22302	1689	12239291000000
22417	1397	1391585292000
22418	1678	5040154808000
22419	1726	857554541000
22420	1874	200459000
22439	1675	11520629999977
22453	1602	11520330000000
22454	1602	11520360000000
22457	1726	857484534000
22458	1874	200466000
22459	1726	857474533000
22460	1874	200467000
22461	1467	10801660000000
22468	1726	857454531000
22469	1874	200469000
22470	1693	21919341551364
22471	1693	21919351551364
22483	1549	16560461000000
22497	1726	856094525000
22498	1874	200475000
22499	1726	856084524000
22500	1874	200476000
22509	1726	856054521000
22510	1874	200479000
22511	1607	19440462000000
22425	1637	81362154799997
22426	1637	81362174799997
22440	1397	1391545288000
22441	1678	5040154812000
22442	1726	857514537000
22443	1874	200463000
22444	1673	13680720000000
22445	1673	13680740000000
22464	1726	857464532000
22465	1874	200468000
22466	1610	15120480000000
22467	1610	15120490000000
22472	1896	180000000
22473	1713	510000000
22474	1726	857444530000
22475	1874	200470000
22476	1726	857434529000
22477	1874	200471000
22478	1402	51841621000000
22479	1726	857424528000
22480	1874	200472000
22484	1611	11520200000000
22485	1611	11520210000000
22492	641	83280750000000
22507	1727	10799150000000
22508	1727	10799170000000
22515	350	66720000000000
22516	350	66720010000000
22525	1677	192244503000000
22537	470	81840391000000
22542	1700	12239540000000
22547	1690	46800631000000
22548	1690	46800641000000
22553	1719	10799240000000
22571	1726	855914507000
22572	1874	200493000
22573	1726	855904506000
22574	1874	200494000
22575	1726	855894505000
22576	1874	200495000
22577	1607	20160472000000
22578	1607	20160502000000
22591	1726	855854501000
22592	1874	200499000
22593	1422	10080160000000
22594	1422	10080170000000
22611	1726	855804496000
22612	1874	200504000
22613	1683	547206725999541
22614	1683	547206735999541
22662	1683	548646735999541
22663	1683	548646755999541
22682	1726	855614477000
22683	1874	200523000
22684	44	77520820000000
22685	44	77520830000000
22707	1422	10800170000000
22708	1422	10800200000000
22713	1677	194404423000000
22714	1677	194404433000000
22719	1679	55440863000000
22720	1679	55440873000000
22738	1474	10794273000000
22748	1685	51840200000000
22749	1685	51840220000000
22822	1708	9359290000000
22825	1726	855264442000
22826	1874	200558000
22827	149	73920160000000
22828	149	73920170000000
22840	1726	855224438000
22841	1874	200562000
22842	1684	29519740000000
22843	1684	29519750000000
22844	1677	195844543000000
22845	1677	195844553000000
22848	1726	855214437000
22849	1874	200563000
22850	1467	10801650000000
22875	1726	855144430000
22876	1874	200570000
22877	700	71760210000000
22878	700	71760230000000
22880	1726	855134429000
22881	1874	200571000
22882	1762	9359220000000
22883	1762	9359230000000
22889	1726	855104426000
22890	1874	200574000
22891	1677	197284573000000
22892	1677	197284583000000
22900	1637	84242224799997
22901	1637	84242244799997
22906	1634	15120259899999
22907	1634	15120269899999
22929	1594	11520340000000
22945	1623	23761600899898
22946	1623	23761650899898
22951	1692	10099363000000
22998	1726	854784394000
22999	1874	200606000
23000	1474	11514273000000
23001	1474	11514283000000
23002	1726	854774393000
23003	1874	200607000
23004	1402	53281631000000
23005	1402	53281641000000
23013	1726	854744390000
23014	1874	200610000
23015	1726	854734389000
23016	1874	200611000
23017	1657	10080180000000
23018	1657	10080190000000
23027	1643	3175474999700
23028	1299	1698983378602650
23029	1643	2011330092700
23030	1053	903634158149000
23031	1643	1225855074000
23032	1173	609699822388700
23033	1643	576213113700
23034	933	504262795497600
23035	1726	854704386000
23036	1874	200614000
23037	1671	20161060000000
23038	1671	20161110000000
23068	1726	854624378000
23069	1874	200622000
23070	1693	23359361551364
23071	1693	23359371551364
23138	1693	20530039367730
23139	1811	544686008347
23140	1693	20401433359383
23141	383	66282077824773
23142	1693	20272827351036
23143	308	66282077824773
23144	1693	20145530683866
23145	1811	671972675517
23146	1693	18961122186557
23147	1150	610502785413452
23148	1693	18832516178210
23149	84	66282077824773
23150	1693	18703910169863
23151	678	66282077824773
23152	1726	854574373000
23153	1874	200627000
23154	1426	9360280000000
23155	1426	9360360000000
23208	1693	17795854413990
23209	721	2008547812829
23210	1726	854554371000
23211	1874	200629000
23212	1726	854544370000
23213	1874	200630000
23214	1693	17667248405643
23215	206	66282077824773
23216	1693	17538642397296
23217	304	66282077824773
23218	1693	17410036388949
23219	399	66282077824773
23220	1693	17281430380602
23221	194	66282077824773
23222	1693	13980988657032
23223	1276	1701220294435610
23224	1693	13585344918966
23225	877	203449976855173
23226	1693	13189701180900
23227	878	203450976855173
23228	1693	13061095172553
23229	193	66282077824773
23230	1693	12932489164206
23231	504	66282077824773
23232	1693	12919430566230
23233	1811	685021273493
23234	1693	12790824557883
23235	78	66282077824773
23236	1693	12662218549536
23237	658	66282077824773
23238	1693	12533612541189
23239	205	66282077824773
23240	1693	12405006532842
23241	660	66282077824773
23242	1693	12401099684120
23243	745	2008547812829
23244	1708	10079290000000
23245	1708	10079470000000
22512	1607	19440472000000
22527	1593	15120390000000
22528	1593	15120510000000
22533	1726	856014517000
22534	1874	200483000
22535	1683	542886695999541
22536	1683	542886705999541
22538	1726	856004516000
22539	1874	200484000
22540	1683	544326705999541
22541	1683	544326715999541
22564	1726	855934509000
22565	1874	200491000
22566	1726	855924508000
22567	1874	200492000
22568	1564	9360182000000
22579	1726	855884504000
22580	1874	200496000
22595	1726	855844500000
22596	1874	200500000
22597	1637	83522214799997
22598	1637	83522224799997
22607	1726	855814497000
22608	1874	200503000
22609	1688	94321843000000
22610	1688	94321853000000
22624	1726	855774493000
22625	1874	200507000
22626	1726	855764492000
22627	1874	200508000
22628	58	81840460000000
22636	1677	192244403000000
22637	1677	192964403000000
22638	1677	192964413000000
22651	1451	10080290000000
22652	1726	855694485000
22653	1874	200515000
22654	1588	14400230000000
22655	1588	14400240000000
22664	1677	193684433000000
22680	1594	11520310000000
22681	1594	11520320000000
22686	1726	855604476000
22687	1874	200524000
22688	1689	12959291000000
22689	1689	12959301000000
22715	1726	855534469000
22716	1874	200531000
22717	1683	548646745999541
22722	327	66000000000000
22723	1726	855524468000
22724	1874	200532000
22725	1607	20880502000000
22726	1607	20880612000000
22729	1677	194404533000000
22736	1726	855494465000
22737	1874	200535000
22755	1726	855454461000
22756	1874	200539000
22757	1726	855444460000
22758	1874	200540000
22759	58	83280470000000
22760	58	83280490000000
22767	1518	2880040000000
22768	1518	2880050000000
22773	1685	52560220000000
22783	1726	855384454000
22784	1874	200546000
22785	1726	855374453000
22786	1874	200547000
22794	1726	855344450000
22795	1874	200550000
22796	1726	855334449000
22797	1874	200551000
22798	1694	31679645000000
22799	1694	31679665000000
22806	1680	17999390000000
22807	1680	17999400000000
22811	1726	855304446000
22812	1874	200554000
22814	1726	855294445000
22815	1874	200555000
22816	1696	12958391000000
22817	1696	12958401000000
22846	1715	18720151000000
22847	1715	18720161000000
22857	1726	855184434000
22858	1874	200566000
22859	1677	196564553000000
22860	1677	196564563000000
22874	1709	12957371000000
22908	1726	855064422000
22909	1874	200578000
22910	1668	18000330000000
22918	1683	551526765999541
22919	1683	551526785999541
22922	1726	855034419000
22923	1874	200581000
22924	1726	855024418000
22925	1874	200582000
22926	1726	855014417000
22927	1874	200583000
22928	1756	14399819000000
22947	1726	854944410000
22948	1874	200590000
22949	1683	552966785999541
22950	1683	552966795999541
22952	1726	854934409000
22953	1874	200591000
22958	1726	854914407000
22959	1874	200593000
22960	1726	854904406000
22961	1874	200594000
22962	1726	854894405000
22963	1874	200595000
22964	1678	5760154813000
22965	1678	5760184813000
22966	1740	16557913000000
22967	1726	854884404000
22968	1874	200596000
22969	1726	854874403000
22970	1874	200597000
22971	1726	854864402000
22972	1874	200598000
22973	700	71760250000000
22976	1726	854854401000
22977	1874	200599000
22978	1696	13678411000000
22984	1726	854834399000
22985	1874	200601000
22986	1726	854824398000
22987	1874	200602000
22988	1444	17280580000000
22997	1687	5125023726450
23008	1508	15120280000000
23020	1687	5125003726450
23041	1677	197284623000000
23051	1726	854664382000
23052	1874	200618000
23053	1560	20880570000000
23054	1560	20880580000000
23057	641	83281780000000
23058	641	84001780000000
23059	641	84002180000000
23072	1726	854614377000
23073	1874	200623000
23074	1447	18000450000000
23075	1447	18000460000000
23093	1457	17280360000000
23094	1457	17280421000000
23117	1693	21430281426159
23118	594	66282077824773
23119	1693	21301675417812
23120	601	66282077824773
23121	1693	21173069409465
23122	680	66282077824773
23123	1726	854584374000
23124	1874	200626000
23125	1693	21044463401118
23126	392	66282077824773
23127	1693	20915857392771
23128	690	66282077824773
23129	1693	20787251384424
23130	186	66282077824773
23131	1693	20658645376077
23132	89	66282077824773
23133	1709	13677391000000
23134	1709	13677471000000
23157	1693	22510755543017
23158	1693	22382149534670
23159	1693	22253543526323
23160	1693	22124937517976
23161	1693	21996331509629
23162	1693	21867725501282
23163	1693	21739119492935
23164	1693	21610513484588
23165	1693	21481907476241
23166	1693	21353301467894
23167	1693	21224695459547
23168	1693	21096089451200
23169	1693	20967483442853
23170	1693	20838877434506
23171	1693	20710271426159
23172	1693	20581665417812
23173	1693	20453059409465
22589	1637	82802204799997
22590	1637	82802214799997
22599	1726	855834499000
22600	1874	200501000
22601	1719	11519240000000
22602	1719	11519250000000
22617	1726	855794495000
22618	1874	200505000
22619	1440	12240420000000
22629	1726	855754491000
22630	1874	200509000
22631	1670	18720610000000
22632	1726	855744490000
22633	1874	200510000
22634	1670	19440610000000
22635	1670	19440620000000
22639	1726	855734489000
22640	1874	200511000
22641	1726	855724488000
22642	1874	200512000
22643	1692	8659333000000
22644	1692	8659353000000
22656	1677	193684413000000
22657	1677	193684423000000
22658	1726	855684484000
22659	1874	200516000
22660	1726	855674483000
22661	1874	200517000
22665	1440	12960420000000
22666	1440	12960440000000
22667	1726	855664482000
22668	1874	200518000
22669	1726	855654481000
22670	1874	200519000
22671	1726	855644480000
22672	1874	200520000
22673	1726	855634479000
22674	1874	200521000
22675	1675	11520639999977
22690	1711	15119230000000
22691	1711	15119240000000
22696	1726	855584474000
22697	1874	200526000
22698	58	82560460000000
22699	58	82560470000000
22700	1726	855574473000
22701	1874	200527000
22702	1726	855564472000
22703	1874	200528000
22704	1726	855554471000
22705	1874	200529000
22706	1649	12960560999992
22709	1726	855544470000
22710	1874	200530000
22711	1685	51120190000000
22712	1685	51120200000000
22718	1567	720010000101
22727	1593	15840510000000
22728	1593	15840620000000
22730	1726	855514467000
22731	1874	200533000
22742	1726	855484464000
22743	1874	200536000
22744	1726	855474463000
22745	1874	200537000
22746	1422	11520200000000
22747	1422	11520220000000
22750	1726	855464462000
22751	1874	200538000
22752	1683	550086745999541
22753	1683	550086755999541
22761	1508	15120270000000
22762	1508	15120290000000
22771	1726	855424458000
22772	1874	200542000
22774	1726	855414457000
22775	1874	200543000
22776	1726	855404456000
22777	1874	200544000
22778	1726	855394455000
22779	1874	200545000
22780	1677	195124533000000
22781	1677	195124563000000
22787	1726	855364452000
22788	1874	200548000
22789	1402	51841601000000
22800	1476	15120290000000
22801	1476	15120310000000
22813	1716	17999351000000
22818	1726	855284444000
22819	1874	200556000
22820	1688	95761873000000
22821	1688	95761883000000
22823	1726	855274443000
22824	1874	200557000
22832	1726	855254441000
22833	1874	200559000
22834	1726	855244440000
22835	1874	200560000
22836	1726	855234439000
22837	1874	200561000
22838	1402	52561601000000
22839	1402	52561631000000
22861	1555	10080160000000
22862	1555	10080170000000
22868	1726	855154431000
22869	1874	200569000
22870	1695	15119391000000
22871	1695	15119401000000
22884	1726	855124428000
22885	1874	200572000
22886	1726	855114427000
22887	1874	200573000
22888	1683	550086765999541
22895	1726	855094425000
22896	1874	200575000
22897	1726	855084424000
22898	1874	200576000
22899	1656	17280391000000
22902	1726	855074423000
22903	1874	200577000
22904	1688	96481883000000
22905	1688	96481893000000
22911	1422	11520210000000
22920	1513	12240360000000
22921	1513	12240380000000
22930	1726	855004416000
22931	1874	200584000
22932	1457	16560360000000
22933	1726	854994415000
22934	1874	200585000
22935	1726	854984414000
22936	1874	200586000
22937	1726	854974413000
22938	1874	200587000
22939	1726	854964412000
22940	1874	200588000
22941	1726	854954411000
22942	1874	200589000
22943	1696	13678401000000
22944	1696	13678451000000
22954	1683	552966805999541
22974	1703	9359430000000
22975	1703	9359470000000
22979	1506	12960300000000
23009	1726	854754391000
23010	1874	200609000
23011	1685	53280220000000
23012	1685	53280230000000
23021	1726	854724388000
23022	1874	200612000
23023	1637	84242234799997
23024	1726	854714387000
23025	1874	200613000
23026	1850	12225080000000
23055	641	84000750000000
23056	641	84000900000000
23060	1726	854654381000
23061	1874	200619000
23062	1726	854644380000
23063	1874	200620000
23064	1726	854634379000
23065	1874	200621000
23066	1683	555846835999541
23067	1683	555846865999541
23076	1692	10819363000000
23077	1692	10819373000000
23135	1739	12239480000000
23246	1739	12959480000000
23247	1739	12959660000000
23267	1536	15840300000000
23268	1536	15840390000000
23270	1693	10507622099456
23271	225	66282077824773
23272	1693	10379016091109
23273	377	66282077824773
23274	1693	10250410082762
23275	560	66282077824773
23276	1693	10121804074415
23277	252	66282077824773
23278	1726	854524368000
23279	1874	200632000
23280	1693	9993198066068
23281	390	66282077824773
23282	1693	9864592057721
22603	1726	855824498000
22604	1874	200502000
22605	1522	12239970000000
22606	1522	12239980000000
22615	58	81840440000000
22616	58	81840450000000
22620	1726	855784494000
22621	1874	200506000
22622	1684	28799730000000
22623	1684	28799740000000
22645	1726	855714487000
22646	1874	200513000
22647	1726	855704486000
22648	1874	200514000
22649	1688	95041853000000
22650	1688	95041873000000
22676	1726	855624478000
22677	1874	200522000
22678	1710	14399360000000
22679	1710	14399370000000
22692	1726	855594475000
22693	1874	200525000
22694	1693	22639351551364
22695	1693	22639361551364
22721	1560	20160570000000
22732	1726	855504466000
22733	1874	200534000
22734	633	80399370000000
22735	633	80399380000000
22739	1474	10075283000000
22740	1474	10795283000000
22741	1474	10795683000000
22754	1476	14400290000000
22763	1726	855434459000
22764	1874	200541000
22765	1738	1438910000000
22766	1738	1438920000000
22769	1513	11520350000000
22770	1513	11520360000000
22782	1749	11515258000000
22790	1726	855354451000
22791	1874	200549000
22792	1692	9379353000000
22793	1692	9379363000000
22802	1726	855324448000
22803	1874	200552000
22804	1559	16560320000000
22805	1559	16560330000000
22808	1726	855314447000
22809	1874	200553000
22810	1677	195124543000000
22829	1633	12240860000000
22830	1633	12960860000000
22831	1633	12961770000000
22851	1656	17280381000000
22852	1726	855204436000
22853	1874	200564000
22854	1726	855194435000
22855	1874	200565000
22856	1671	19441060000000
22863	1726	855174433000
22864	1874	200567000
22865	1726	855164432000
22866	1874	200568000
22867	1677	196564573000000
22872	1698	17999331000000
22873	1698	17999341000000
22879	1709	12957391000000
22893	42	78237920000000
22894	42	78237930000000
22912	1726	855054421000
22913	1874	200579000
22914	1726	855044420000
22915	1874	200580000
22916	1675	12240639999977
22917	1675	12240659999977
22955	1726	854924408000
22956	1874	200592000
22957	1694	31679655000000
22980	1726	854844400000
22981	1874	200600000
22982	700	72480250000000
22983	700	72480260000000
22989	1726	854814397000
22990	1874	200603000
22991	1726	854804396000
22992	1874	200604000
22993	1726	854794395000
22994	1874	200605000
22995	1679	56160873000000
22996	1679	56160903000000
23006	1726	854764392000
23007	1874	200608000
23019	1675	12240649999977
23039	1679	56880903000000
23040	1679	56880953000000
23042	1726	854694385000
23043	1874	200615000
23044	1683	552966815999541
23045	1726	854684384000
23046	1874	200616000
23047	1726	854674383000
23048	1874	200617000
23049	1683	554406815999541
23050	1683	554406835999541
23078	1693	23230765543017
23079	309	66282077824773
23080	1726	854604376000
23081	1874	200624000
23082	1693	23102159534670
23083	150	66282077824773
23084	1693	22973553526323
23085	92	66282077824773
23086	1693	22844947517976
23087	63	66282077824773
23088	1693	22716341509629
23089	450	66282077824773
23090	1769	2933900000
23091	1672	13680321000000
23092	1672	13680382000000
23095	1726	854594375000
23096	1874	200625000
23097	1693	22587735501282
23098	452	66282077824773
23099	1693	22459129492935
23100	322	66282077824773
23101	1693	22330523484588
23102	373	66282077824773
23103	1693	22201917476241
23104	408	66282077824773
23105	1693	22073311467894
23106	453	66282077824773
23107	1693	21944705459547
23108	593	66282077824773
23109	1693	21816099451200
23110	91	66282077824773
23111	1693	21687493442853
23112	438	66282077824773
23113	1693	21558887434506
23114	339	66282077824773
23115	1694	32399655000000
23116	1694	32399755000000
23136	1749	12235258000000
23137	1749	12235338000000
23156	1711	15119310000000
23186	1693	18700003321141
23187	731	2008547812829
23188	1726	854564372000
23189	1874	200628000
23190	1693	18571397312794
23191	295	66282077824773
23192	1693	18442791304447
23193	551	66282077824773
23194	1693	18314185296100
23195	520	66282077824773
23196	1693	18185579287753
23197	653	66282077824773
23198	1693	18056973279406
23199	622	66285057824773
23200	1693	17928367271059
23201	105	66282077824773
23202	1693	17799761262712
23203	122	66282077824773
23204	1402	54001641000000
23205	1402	54001731000000
23269	1711	15119320000000
23288	1683	557286865999541
23289	1683	557286945999541
23308	1679	57600953000000
23309	1679	57601023000000
23312	1693	8457705012081
23313	35	19282059003548
23314	1726	854504366000
23315	1874	200634000
23316	1693	8329099003734
23317	320	66282077824773
23318	1693	6573696208959
23319	1030	904824004033700
23320	1693	6445090200612
23321	663	66282077824773
23322	1693	6316484192265
23323	499	66282077824773
23324	1693	6187878183918
23325	54	66282077824773
23326	1683	555846935999541
23174	1693	20324453401118
23175	1693	20195847392771
23176	1693	20067241384424
23177	1693	19938635376077
23178	1693	19810029367730
23179	1693	19681423359383
23180	1693	19552817351036
23181	1693	19425520683866
23182	1693	18241112186557
23183	1426	8640720000000
23184	1426	9360720000000
23185	1426	9360851000000
23206	58	84000490000000
23207	58	84000580000000
23290	1687	5125073726450
23331	1740	16557888000000
23332	1726	854494365000
23333	1874	200635000
23334	1769	1823900000
23335	1900	100000000
23336	1693	6178126062085
23337	710	5021369532156
23338	1693	6158631818414
23339	1811	704505517164
23340	1693	6030025810067
23341	217	66282077824773
23342	1693	5901419801720
23343	103	66282077824773
23344	1693	5772813793373
23345	534	66282077824773
23346	1693	5644207785026
23347	245	66282077824773
23348	1693	5515601776679
23349	421	66282077824773
23350	1693	5386995768332
23351	620	66282077824773
23352	1693	5258389759985
23353	352	66282077824773
23354	1693	5129783751638
23355	691	66282077824773
23356	1693	5001177743291
23357	191	66282077824773
23358	1693	4872571734944
23359	266	66282077824773
23360	1693	4743965726597
23361	353	66282077824773
23362	1693	4615359718250
23363	600	66282077824773
23364	1693	4486753709903
23365	420	66282077824773
23366	1693	3888922462219
23367	893	308134249033327
23368	1693	3760316453872
23369	180	66282077824773
23370	1693	3631710445525
23371	112	66131057824773
23372	1693	3503104437178
23373	106	66282077824773
23374	1693	3439657636593
23375	1811	767942317749
23376	1693	3311051628246
23377	652	66282077824773
23378	1693	3182445619899
23379	397	66282077824773
23380	1693	3053839611552
23381	391	66282077824773
23382	1693	2925233603205
23383	201	66282077824773
23384	1726	854484364000
23385	1874	200636000
23386	1693	2796627594858
23387	261	66282077824773
23388	58	84000805000000
23394	58	84720795000000
23395	58	84720805000000
23405	1726	854444360000
23406	1874	200640000
23407	1637	84962234799997
23408	1637	84962244799997
23429	1726	854374353000
23430	1874	200647000
23431	1693	2668021586511
23432	402	66282077824773
23433	1726	854364352000
23434	1874	200648000
23435	1698	18719361000000
23455	1726	854334349000
23456	1874	200651000
23457	1611	11510200000000
23458	554	66010000000000
23459	1677	198004613000000
23473	1726	854294345000
23474	1874	200655000
23475	1476	15840310000000
23476	1476	15840320000000
23527	1726	851544330000
23528	1874	200670000
23529	1726	851534329000
23530	1874	200671000
23533	1726	851524328000
23534	1874	200672000
23535	1637	87122264799997
23536	1637	87122274799997
23548	1694	32399760000000
23549	1694	33119760000000
23555	1402	54721731000000
23608	1726	851454321000
23609	1874	200679000
23610	1726	851444320000
23611	1874	200680000
23612	1726	851434319000
23613	1874	200681000
23614	1688	96481913000000
23622	1749	12235278000000
23627	470	82560391000000
23628	470	82560401000000
23632	1693	2873597553123
23633	1693	2873607553123
23636	1726	851384314000
23637	1874	200686000
23638	1608	11520310000000
23639	1608	11520320000000
23648	1726	851344310000
23649	1874	200690000
23650	1692	11539373000000
23651	1692	11539383000000
23665	1726	851314307000
23666	1874	200693000
23667	1692	12259383000000
23668	1692	12259393000000
23689	1726	851244300000
23690	1874	200700000
23691	1726	851234299000
23692	1874	200701000
23693	1709	14397401000000
23694	1709	14397421000000
23703	1522	12239940000000
23704	1898	20000000
23705	1726	851204296000
23706	1874	200704000
23707	1726	851194295000
23708	1874	200705000
23709	1701	12958362000000
23733	1698	20159371000000
23734	1698	20159401000000
23741	1726	851104286000
23742	1874	200714000
23743	1706	15116432000000
23744	1706	15116442000000
23753	1677	201604693000000
23754	1677	201604703000000
23755	1726	851084284000
23756	1874	200716000
23757	1726	851074283000
23758	1874	200717000
23772	1726	851034279000
23773	1874	200721000
23774	1900	90000000
23775	1683	564486945999541
23776	1683	564486965999541
23782	1726	851024278000
23783	1874	200722000
23784	1656	18000391000000
23785	1656	18000401000000
23795	1726	850994275000
23796	1874	200725000
23797	1708	10799470000000
23798	1708	10799480000000
23800	1726	850984274000
23801	1874	200726000
23802	1440	13680440000000
23803	1440	13680450000000
23812	1685	55440270000000
23813	1685	55440290000000
23814	1726	850954271000
23815	1874	200729000
23816	1726	850944270000
23817	1874	200730000
23828	1900	69000000
23829	1403	0
23830	1726	850904266000
23831	1874	200734000
23832	44	78240830000000
23833	44	78240850000000
23248	1726	854534369000
23249	1874	200631000
23250	1693	12387450713546
23251	29	7029917345033
23252	1693	12258844705199
23253	138	66282077824773
23254	1693	12130238696852
23255	146	66282077824773
23256	1693	12001632688505
23257	395	66279047824773
23258	1693	11873026680158
23259	587	66282077824773
23260	1693	10893440124497
23261	910	504926523573708
23262	1693	10764834116150
23263	500	66282077824773
23264	1693	10636228107803
23265	611	66282077824773
23266	1684	29519830000000
23310	1573	15840570000000
23311	1573	15840640000000
23328	606	76800260000000
23329	606	77520260000000
23389	58	84000795000000
23396	1726	854464362000
23397	1874	200638000
23409	1726	854434359000
23410	1874	200641000
23411	1746	4319091000000
23425	1726	854384354000
23426	1874	200646000
23436	1726	854354351000
23437	1874	200649000
23438	1693	2539415578164
23439	163	66282077824773
23440	1693	2410809569817
23441	82	66282077824773
23442	1693	2282203561470
23443	275	66282077824773
23444	1693	2153597553123
23445	361	66282077824773
23446	1607	20880552000000
23449	1726	854344350000
23450	1874	200650000
23451	1706	14396422000000
23452	1706	14396432000000
23460	1726	854324348000
23461	1874	200652000
23462	1726	854314347000
23463	1874	200653000
23464	1587	15120300000000
23467	1726	854304346000
23468	1874	200654000
23469	1719	12239250000000
23470	1719	12239260000000
23495	1726	851624338000
23496	1874	200662000
23497	1709	13677401000000
23506	1726	851594335000
23507	1874	200665000
23508	1637	85682244799997
23509	1637	85682254799997
23512	1726	851584334000
23513	1874	200666000
23514	1698	19439361000000
23515	1698	19439371000000
23531	363	68160050000000
23532	363	68160070000000
23540	1694	32399765000000
23541	1596	12651155000000
23542	1903	197000000000
23543	1694	33119765000000
23544	1694	33119770000000
23550	1726	851504326000
23551	1874	200674000
23552	1769	1822900000
23553	1684	29519751000000
23554	1684	29519761000000
23565	1726	851464322000
23566	1874	200678000
23567	1677	199444643000000
23568	1677	199444653000000
23629	1726	851394315000
23630	1874	200685000
23631	470	82560411000000
23634	1716	18719351000000
23635	1716	18719361000000
23640	1726	851374313000
23641	1874	200687000
23642	1726	851364312000
23643	1874	200688000
23644	1756	15119819000000
23645	1756	15119839000000
23652	1726	851334309000
23653	1874	200691000
23654	1716	19439361000000
23655	1716	19439371000000
23671	1445	12240230000000
23672	1445	12240240000000
23675	1726	851284304000
23676	1874	200696000
23677	1699	7810022500051
23678	1699	7810032500051
23695	1677	200164653000000
23696	1677	200164673000000
23715	1726	851174293000
23716	1874	200707000
23717	1683	563046925999541
23718	1683	563046935999541
23737	1726	851124288000
23738	1874	200712000
23745	1726	851094285000
23746	1874	200715000
23747	1466	1440010000000
23748	1466	1440020000000
23763	1623	23761640899898
23764	1673	13680955000000
23765	1673	14400955000000
23766	1673	14400965000000
23777	1710	15119370000000
23778	1710	15119390000000
23786	1480	720000000000
23793	1724	19438950000000
23794	1724	19438971000000
23799	1727	10799160000000
23804	1726	850974273000
23805	1874	200727000
23806	1726	850964272000
23807	1874	200728000
23808	1683	565926966999541
23809	1683	565926986999541
23818	1900	79000000
23819	1726	850934269000
23820	1874	200731000
23821	1623	25201650899898
23822	1623	25201670899898
23834	1726	850894265000
23835	1874	200735000
23849	1726	850844260000
23850	1874	200740000
23851	1439	10800190000000
23860	1726	850814257000
23861	1874	200743000
23862	1726	850804256000
23863	1874	200744000
23864	1573	16560640000000
23865	1573	16560660000000
23283	108	66282077824773
23284	1693	9266760810037
23285	894	308134249033327
23286	1768	10799351110000
23287	1768	10799431110000
23291	1559	17280330000000
23292	1559	17280410000000
23293	1726	854514367000
23294	1874	200633000
23295	1693	9138154801690
23296	569	66282077824773
23297	1693	9009548793343
23298	99	66282077824773
23299	1693	8880942784996
23300	570	66282077824773
23301	1693	8752336776649
23302	49	66282077824773
23303	1693	8623730768302
23304	127	66130067824773
23305	1693	8495124759955
23306	251	66282077824773
23307	1451	10080340000000
23330	606	77520250000000
23398	1683	557286875999541
23401	1726	854454361000
23402	1874	200639000
23403	1685	54000230000000
23404	1685	54000240000000
23412	1747	5759180000000
23414	1726	854424358000
23415	1874	200642000
23416	1726	854414357000
23417	1874	200643000
23418	1677	197284593000000
23427	1698	18719331000000
23428	1698	18719341000000
23447	1677	198004593000000
23448	1677	198004643000000
23453	1555	10800170000000
23454	1555	10800180000000
23465	1683	558726875999541
23466	1683	558726895999541
23471	1623	24481650899898
23472	1623	24481660899898
23498	1726	851614337000
23499	1874	200663000
23500	1726	851604336000
23501	1874	200664000
23502	1683	560166895999541
23503	1683	560166925999541
23510	1677	198724613000000
23511	1677	198724623000000
23516	1726	851574333000
23517	1874	200667000
23518	1637	86402254799997
23519	1637	86402264799997
23537	1726	851514327000
23538	1874	200673000
23539	470	81840401000000
23545	1717	11519282000000
23546	1717	12239282000000
23547	1717	12239287000000
23556	1726	851494325000
23557	1874	200675000
23558	1726	851484324000
23559	1874	200676000
23560	1506	13680300000000
23561	1506	13680320000000
23569	1623	20881520899898
23570	1596	12030150000000
23571	1740	15837893000000
23572	1740	15837868000000
23573	484	84001547000000
23574	1611	10790190000000
23575	1693	19630695543017
23576	1693	19502089534670
23577	1693	19373483526323
23578	1693	19244877517976
23579	1693	19116271509629
23580	1693	18987665501282
23581	1693	18859059492935
23582	1693	18730453484588
23583	1693	18601847476241
23584	1693	18473241467894
23585	1693	18344635459547
23586	1693	18216029451200
23587	1693	18087423442853
23588	1693	17958817434506
23589	1693	17830211426159
23590	1693	17701605417812
23591	1693	17572999409465
23592	1693	17444393401118
23593	1693	17315787392771
23594	1693	17187181384424
23595	1693	17058575376077
23596	1693	16929969367730
23597	1693	16801363359383
23598	1693	16672757351036
23599	1693	16545460683866
23600	1693	15361052186557
23601	1693	15232446178210
23602	1693	15103840169863
23603	1693	15099933321141
23604	1693	14971327312794
23605	1693	14842721304447
23606	484	84721547000000
23607	484	84722647000000
23615	1685	54720240000000
23616	1685	54720270000000
23646	1726	851354311000
23647	1874	200689000
23656	1680	18719400000000
23657	1680	18719410000000
23669	1726	851304306000
23670	1874	200694000
23679	1726	851274303000
23680	1874	200697000
23681	470	83280401000000
23682	470	83280411000000
23710	1726	851184294000
23711	1874	200706000
23712	1455	15840271000000
23713	1455	15840281000000
23719	43	78960330000000
23720	43	78960340000000
23735	1677	200884663000000
23736	1677	200884693000000
23739	1726	851114287000
23740	1874	200713000
23749	679	66720000000000
23750	679	66720010000000
23759	1726	851064282000
23760	1874	200718000
23761	1672	14400382000000
23762	1672	14400392000000
23779	1677	201604713000000
23780	1692	12979393000000
23781	1692	12979413000000
23810	1564	10080182000000
23811	1564	10080202000000
23823	1726	850924268000
23824	1874	200732000
23825	1726	850914267000
23826	1874	200733000
23827	1402	54721751000000
23836	1726	850884264000
23837	1874	200736000
23838	1726	850874263000
23839	1874	200737000
23840	1726	850864262000
23841	1874	200738000
23842	1683	567366986999541
23843	1683	567367016999541
23848	686	66720010000000
23852	1726	850834259000
23853	1874	200741000
23854	1726	850824258000
23855	1874	200742000
23856	1637	89282304799997
23857	1637	89282324799997
23327	1683	557286935999541
23390	1726	854474363000
23391	1874	200637000
23392	1536	16560390000000
23393	1536	16560400000000
23399	606	78240250000000
23400	606	78240260000000
23413	1704	3599120000000
23419	1726	854404356000
23420	1874	200644000
23421	1726	854394355000
23422	1874	200645000
23423	1689	13679301000000
23424	1689	13679321000000
23477	1726	854284344000
23478	1874	200656000
23479	1726	854274343000
23480	1874	200657000
23481	1726	852974343000
23482	1901	200000000
23483	1726	851674343000
23484	1902	200000000
23485	1726	851664342000
23486	1874	200658000
23487	1726	851654341000
23488	1874	200659000
23489	1726	851644340000
23490	1874	200660000
23491	1726	851634339000
23492	1874	200661000
23493	1588	15120240000000
23494	1588	15120500000000
23504	1560	21600580000000
23505	1560	21600610000000
23520	1726	851564332000
23521	1874	200668000
23522	1726	851554331000
23523	1874	200669000
23524	1596	12750160000000
23525	1903	98000000000
23526	1677	198724643000000
23562	1726	851474323000
23563	1874	200677000
23564	1683	560166905999541
23617	1726	851424318000
23618	1874	200682000
23619	1726	851414317000
23620	1874	200683000
23621	1594	11520330000000
23623	1726	851404316000
23624	1874	200684000
23625	1536	17280400000000
23626	1536	17280410000000
23658	1593	15840520000000
23659	1522	12239960000000
23660	1898	10000000
23661	1726	851324308000
23662	1874	200692000
23663	1683	561606905999541
23664	1683	561606925999541
23673	1726	851294305000
23674	1874	200695000
23683	1726	851264302000
23684	1874	200698000
23685	1726	851254301000
23686	1874	200699000
23687	1509	16560411000000
23688	1509	16560431000000
23697	1726	851224298000
23698	1874	200702000
23699	1726	851214297000
23700	1874	200703000
23701	1637	87842274799997
23702	1637	87842294799997
23714	1768	10799361110000
23721	1637	88562294799997
23722	1637	88562304799997
23723	1726	851164292000
23724	1874	200708000
23725	1677	200164663000000
23726	1726	851154291000
23727	1874	200709000
23728	1726	851144290000
23729	1874	200710000
23730	1726	851134289000
23731	1874	200711000
23732	1683	563046955999541
23751	1740	17277888000000
23752	1740	17277898000000
23767	1726	851054281000
23768	1874	200719000
23769	1726	851044280000
23770	1874	200720000
23771	1683	563046945999541
23787	1726	851014277000
23788	1874	200723000
23789	1726	851004276000
23790	1874	200724000
23791	1900	89000000
23792	1683	564486966999541
23844	1726	850854261000
23845	1874	200739000
23846	457	66720000000000
23847	457	66720010000000
23858	1677	202324703000000
23859	1677	202324723000000
23866	1596	12641145000000
23867	321	66010000000000
23868	1726	850794255000
23869	1874	200745000
23870	1423	3600060000000
23871	1423	3600080000000
23872	1726	850784254000
23873	1874	200746000
23874	1611	12230200000000
23875	1611	12230210000000
23876	1726	850774253000
23877	1874	200747000
23878	1637	90002324799997
23879	1637	90002334799997
23880	1726	850764252000
23881	1874	200748000
23882	1726	850754251000
23883	1874	200749000
23884	1726	850744250000
23885	1874	200750000
23886	1596	12419140000000
23887	1864	332000000000
23888	1607	21600552000000
23889	1607	21600587000000
23890	1683	568807016999541
23891	1683	568807051999541
23892	1607	20881302000000
23893	1607	21601302000000
23894	1607	21601864000000
23895	1677	202324738000000
23896	1573	17280660000000
23897	1573	17280695000000
23898	1876	350660000000
23899	1677	203044738000000
23900	1677	203044748000000
23901	1726	850734249000
23902	1874	200751000
23903	1693	3593607553123
23904	1693	3593617553123
23905	1726	850724248000
23906	1874	200752000
23907	1419	16560390000000
23908	1726	850714247000
23909	1874	200753000
23910	1678	6480184813000
23911	1678	6480194813000
23912	1573	17280670000000
23913	1726	850704246000
23914	1874	200754000
23915	1726	850694245000
23916	1874	200755000
23917	1726	850684244000
23918	1874	200756000
23919	1693	4313617553123
23920	1693	4313647553123
23921	1705	14395280000000
23922	1749	12235288000000
23923	1726	850674243000
23924	1874	200757000
23925	1690	47520641000000
23926	1690	47520651000000
23927	1726	850664242000
23928	1874	200758000
23929	1458	18720335908540
23930	1726	850654241000
23931	1874	200759000
23932	1709	15117421000000
23933	1709	15117431000000
23934	1726	850644240000
23935	1874	200760000
23936	1726	850634239000
23937	1874	200761000
23938	641	84000770000000
23939	1522	11519950000000
23940	1522	11519930000000
23941	1693	21070735543017
23942	1693	20942129534670
23943	1693	20813523526323
23944	1693	20684917517976
23945	1623	23041590899898
23946	1633	12962215000000
23947	1693	20556311509629
23948	1693	20427705501282
23949	1693	20299099492935
23950	1693	20170493484588
23951	1693	20041887476241
23952	1693	19913281467894
23953	1693	19784675459547
23954	1693	19656069451200
23955	1693	19527463442853
23956	1693	19398857434506
23957	1693	19270251426159
23958	1693	19141645417812
23959	1693	19013039409465
23960	1693	18884433401118
23961	1693	18755827392771
23962	1693	18627221384424
23963	1693	18498615376077
23964	1693	18370009367730
23965	1693	18241403359383
23966	1693	18112797351036
23967	1693	17985500683866
23968	1693	16801092186557
23969	1693	16672486178210
23970	1693	16543880169863
23971	1693	16539973321141
23972	1693	16411367312794
23973	1693	16282761304447
23974	1633	13682215000000
23975	1633	13683035000000
24041	1726	850624238000
24042	1874	200762000
24043	1900	68000000
24044	1445	12960240000000
24045	1445	12960251000000
24047	1726	850614237000
24048	1874	200763000
24049	1560	22320610000000
24050	1560	22320620000000
24062	1726	850584234000
24063	1874	200766000
24074	1683	571687037999541
24075	1683	571687047999541
24082	1683	573127047999541
24083	1683	573127067999541
24088	1726	850524228000
24089	1874	200772000
24090	1726	850514227000
24091	1874	200773000
24092	1419	17280390000000
24093	1419	17280410000000
24097	1726	850494225000
24098	1874	200775000
24099	1688	97201893000000
24100	1688	97201903000000
24106	1726	850474223000
24107	1874	200777000
24108	1726	850464222000
24109	1874	200778000
24110	1683	574567057999541
24111	1683	574567077999541
24116	43	79680340000000
24117	43	79680350000000
24143	1601	10441205600000
24149	1726	850384214000
24150	1874	200786000
24151	1688	97921903000000
24152	1688	97921913000000
24154	1690	48960661000000
24155	1690	48960671000000
24166	1654	13680260000000
24167	1654	13680777000000
24216	1716	19439611000000
24221	1726	847624198000
24222	1874	200802000
24223	1622	10079139999976
24224	1622	10079149999976
24226	1607	22321864000000
24227	1607	22322596000000
24247	1726	846254191000
24248	1874	200809000
24249	1706	15836442000000
24250	1706	15836452000000
24259	1726	846224188000
24260	1874	200812000
24261	1419	18000410000000
24262	1419	18000420000000
24276	1726	846184184000
24277	1874	200816000
24278	1686	7412056500013
24279	1686	7412086500013
24297	1726	846144180000
24298	1874	200820000
24299	1726	846134179000
24300	1874	200821000
24301	1699	1653829000078
24302	1773	6156202499973
24303	1518	2880061000000
24337	1726	846014167000
24338	1874	200833000
24339	1691	9359140000000
24340	1691	9359150000000
24350	1726	845974163000
24351	1874	200837000
24352	1637	92162364799997
24361	1685	56160280000000
24362	1685	56160290000000
24368	1637	92882364799997
24369	1637	92882374799997
24389	1596	13139140000000
24390	1596	13139150000000
24412	1726	845874153000
24413	1874	200847000
24414	1726	845864152000
24415	1874	200848000
24416	1559	18000410000000
24417	1559	18000430000000
24419	1680	19439410000000
24429	1726	845834149000
24430	1874	200851000
24431	1726	845824148000
24432	1874	200852000
24433	1634	15840269899999
24434	1634	15840289899999
24442	1726	845794145000
24443	1874	200855000
24444	1701	13678362000000
24445	1701	13678372000000
24453	1726	845764142000
24454	1874	200858000
24455	1726	845754141000
24456	1874	200859000
24457	1688	99361973000000
24458	1688	99361993000000
24460	1467	11521660000000
24461	1467	11521680000000
24478	1726	845714137000
24479	1874	200863000
24480	1691	10079150000000
24481	1691	10079160000000
24484	1726	845704136000
24485	1874	200864000
24500	369	83280390000000
24501	369	83280440000000
24513	1726	845634129000
24514	1874	200871000
24515	1683	584647357999541
24516	1683	584647367999541
24526	1726	845604126000
24527	1874	200874000
24528	1726	845594125000
24529	1874	200875000
24530	1705	15835330000000
24531	1705	15835360000000
24558	1850	14385190000000
24571	1726	845474113000
24572	1874	200887000
24575	1726	845464112000
24576	1874	200888000
24577	1717	14399302000000
24578	1717	14399312000000
24584	1747	6479190000000
24588	1668	18000350000000
24599	1692	15139553000000
24600	1692	15139563000000
24605	1726	845384104000
24606	1874	200896000
24607	1723	15120060000000
24608	1723	15120070000000
24619	1701	15118382000000
24620	1701	15118392000000
24634	1726	845314097000
24635	1874	200903000
24636	1657	11520200000000
24637	1657	11520210000000
24690	1690	49680671000000
24691	1690	49680681000000
24707	1726	843814077000
24708	1874	200923000
24709	1637	94322394799997
24710	1637	94322404799997
24721	1689	15119331000000
24722	1689	15119341000000
24725	1702	8634131000000
23976	1693	21790745543017
23977	1693	21662139534670
23978	1693	21533533526323
23979	1693	21404927517976
23980	1693	21276321509629
23981	1693	21147715501282
23982	1693	21019109492935
23983	1693	20890503484588
23984	1693	20761897476241
23985	1693	20633291467894
23986	1693	20504685459547
23987	1693	20376079451200
23988	1693	20247473442853
23989	1693	20118867434506
23990	1693	19990261426159
23991	1693	19861655417812
23992	1693	19733049409465
23993	1693	19604443401118
23994	1693	19475837392771
23995	1693	19347231384424
23996	1693	19218625376077
23997	1693	19090019367730
23998	1693	18961413359383
23999	1693	18832807351036
24000	1693	18705510683866
24001	1693	17521102186557
24002	1693	17392496178210
24003	1693	17263890169863
24004	1693	17259983321141
24005	1693	17131377312794
24006	1693	17002771304447
24007	641	84003045000000
24008	1693	16874165296100
24009	1693	16745559287753
24010	1693	16616953279406
24011	1693	16488347271059
24012	1693	16359741262712
24013	1693	16355834413990
24014	1693	16227228405643
24015	1693	16098622397296
24016	1693	15970016388949
24017	1693	15841410380602
24018	1693	12540968657032
24019	1693	12145324918966
24020	1693	11749681180900
24021	1693	11621075172553
24022	1693	11492469164206
24023	1693	11479410566230
24024	1693	11350804557883
24025	1693	11222198549536
24026	1693	11093592541189
24027	1693	10964986532842
24028	1693	10961079684120
24029	1693	10947430713546
24030	1693	10818824705199
24031	1693	10690218696852
24032	1693	10561612688505
24033	1693	10433006680158
24034	1693	9453420124497
24035	1693	9324814116150
24036	1693	9196208107803
24037	1693	9067602099456
24038	1693	8938996091109
24039	641	84723045000000
24040	641	84723445000000
24046	1683	568807027999541
24066	1692	13699413000000
24067	1692	13699423000000
24068	1726	850574233000
24069	1874	200767000
24070	1445	12960250000000
24076	1726	850554231000
24077	1874	200769000
24078	1726	850544230000
24079	1874	200770000
24094	1726	850504226000
24095	1874	200774000
24096	1649	12960540999992
24104	1440	14400450000000
24105	1440	14400460000000
24112	1726	850454221000
24113	1874	200779000
24114	1683	576007077999541
24115	1683	576007087999541
24128	1726	850424218000
24129	1874	200782000
24130	1684	30239761000000
24131	1684	30239771000000
24132	1726	850414217000
24133	1874	200783000
24134	44	78960850000000
24135	44	78960860000000
24138	1685	55440280000000
24144	1513	12240370000000
24158	1726	850374213000
24159	1874	200787000
24160	1445	13680250000000
24161	1445	13680260000000
24173	1726	850344210000
24174	1874	200790000
24175	1637	91442344799997
24176	1637	91442354799997
24177	1726	850334209000
24178	1874	200791000
24179	1726	850324208000
24180	1874	200792000
24181	1726	850314207000
24182	1874	200793000
24183	1726	850304206000
24184	1874	200794000
24185	1679	57600993000000
24188	1726	850294205000
24189	1874	200795000
24190	1698	20159381000000
24192	470	84000411000000
24193	470	84000421000000
24201	1710	15119380000000
24228	1726	847614197000
24229	1874	200803000
24230	1677	204484758000000
24231	1677	204484768000000
24251	1726	846244190000
24252	1874	200810000
24253	1543	720000000000
24254	1543	720010000000
24268	1426	10080370000000
24269	1480	717980000000
24270	1908	0
24282	1726	846174183000
24283	1874	200817000
24284	1726	846164182000
24285	1874	200818000
24286	1637	92162354799997
24287	1637	92162374799997
24290	1489	14400531000000
24316	1726	846084174000
24317	1874	200826000
24318	1726	846074173000
24319	1874	200827000
24320	1686	7412076500013
24341	1726	846004166000
24342	1874	200834000
24343	1686	7412066500013
24353	1726	845964162000
24354	1874	200838000
24355	1688	98641963000000
24356	1688	98641973000000
24391	1607	22320562000000
24392	1607	22320652000000
24399	1726	845914157000
24400	1874	200843000
24401	1683	580327297999541
24402	1683	580327307999541
24420	1726	845854151000
24421	1874	200849000
24422	1726	845844150000
24423	1874	200850000
24424	1607	23763137000000
24425	1607	23763217000000
24435	1762	9359240000000
24446	1683	581767307999541
24447	1683	581767317999541
24459	1549	17280461000000
24471	1726	845734139000
24472	1874	200861000
24473	1726	845724138000
24474	1874	200862000
24475	1747	6479180000000
24476	1747	6479200000000
24477	1613	12958490000000
24486	1726	845694135000
24487	1874	200865000
24502	1596	13859440000000
24517	1726	845624128000
24518	1874	200872000
24521	1677	205924788000000
24532	1637	92882394799997
24539	1726	845564122000
24540	1874	200878000
24541	1701	14398372000000
24542	1701	14398382000000
24548	1726	845544120000
24549	1874	200880000
24550	1726	845534119000
24551	1874	200881000
24051	1560	22320631000000
24055	1900	67000000
24056	1402	55441751000000
24057	1402	55441762000000
24064	1729	12239220000000
24065	1729	12239230000000
24101	1726	850484224000
24102	1874	200776000
24103	1683	573127057999541
24118	1458	19440335908540
24119	1458	19440345908540
24122	1714	20869330000000
24123	1714	20869340000000
24145	1726	850394215000
24146	1874	200785000
24147	1756	16559849000000
24148	1756	16559859000000
24169	1594	12240330000000
24170	1594	12240340000000
24171	1726	850354211000
24172	1874	200789000
24197	1480	718990000000
24198	1904	0
24199	1672	15120392000000
24200	1672	15120412000000
24225	1607	21600562000000
24232	1726	847604196000
24233	1874	200804000
24234	1726	847594195000
24235	1874	200805000
24236	1593	15840530000000
24237	321	66009960000000
24238	1726	847584194000
24239	1874	200806000
24240	1726	847574193000
24241	1874	200807000
24242	1726	846274193000
24243	1907	200000000
24244	1726	846264192000
24245	1874	200808000
24246	1683	577447257999541
24263	1726	846214187000
24264	1874	200813000
24265	1679	58320993000000
24266	1679	58321003000000
24271	1726	846204186000
24272	1874	200814000
24273	1726	846194185000
24274	1874	200815000
24275	44	78960880000000
24280	1702	7914131000000
24288	1677	205204768000000
24289	1677	205204788000000
24291	1726	846154181000
24292	1874	200819000
24293	1489	14400541000000
24296	1717	13679302000000
24304	1726	846124178000
24305	1874	200822000
24306	1726	846114177000
24307	1874	200823000
24308	1726	846104176000
24309	1874	200824000
24310	1726	846094175000
24311	1874	200825000
24312	1683	578887257999541
24313	1683	578887297999541
24321	1610	15840510000000
24324	1726	846064172000
24325	1874	200828000
24326	1726	846054171000
24327	1874	200829000
24328	1726	846044170000
24329	1874	200830000
24330	1480	716970000000
24331	1909	0
24332	1726	846034169000
24333	1874	200831000
24334	1726	846024168000
24335	1874	200832000
24336	1688	97921963000000
24344	1726	845994165000
24345	1874	200835000
24346	1726	845984164000
24347	1874	200836000
24348	1573	18000670000000
24349	1573	18000690000000
24363	1726	845944160000
24364	1874	200840000
24365	1693	4313627553123
24393	1476	17280330000000
24394	1476	17280420000000
24403	1726	845904156000
24404	1874	200844000
24405	1726	845894155000
24406	1874	200845000
24407	1608	12240340000000
24418	1692	13699433000000
24426	1480	714950000000
24427	1911	0
24428	1607	22320592000000
24448	1726	845784144000
24449	1874	200856000
24462	1480	713940000000
24463	1912	0
24464	1726	845744140000
24465	1874	200860000
24466	1683	581767347999541
24482	1683	583207347999541
24483	1683	583207357999541
24519	1764	15120308000000
24520	1764	15120318000000
24522	1726	845614127000
24523	1874	200873000
24524	1683	586087367999541
24525	1683	586087377999541
24543	1726	845554121000
24544	1874	200879000
24545	1657	10800190000000
24546	1657	10800200000000
24556	1726	845514117000
24557	1874	200883000
24570	171	78240200000000
24573	1573	18720690000000
24574	1573	18720700000000
24586	1726	845434109000
24587	1874	200891000
24595	1637	92882384799997
24601	1726	845394105000
24602	1874	200895000
24603	1467	12241700000000
24604	1467	12241710000000
24615	1747	7199190000000
24616	1747	7199200000000
24621	1726	845354101000
24622	1874	200899000
24623	1679	59041003000000
24624	1679	59041013000000
24644	1681	22319495195920
24653	1726	843964092000
24654	1874	200908000
24655	1680	20159410000000
24656	1680	20159420000000
24659	1726	843944090000
24660	1874	200910000
24661	1726	843934089000
24662	1874	200911000
24663	1726	843924088000
24664	1874	200912000
24665	1709	15117451000000
24675	1726	843894085000
24676	1874	200915000
24677	1726	843884084000
24678	1874	200916000
24679	1687	5845003726450
24680	1687	5845023726450
24692	1677	207364798000000
24700	1451	10080300000000
24705	576	80400440000000
24706	576	80400450000000
24739	1726	843744070000
24740	1874	200930000
24741	1726	843734069000
24742	1874	200931000
24743	1726	843724068000
24744	1874	200932000
24745	1690	50400681000000
24746	1690	50400711000000
24752	1426	10800370000000
24753	1426	10800380000000
24763	1726	843674063000
24764	1874	200937000
24765	1726	843664062000
24766	1874	200938000
24767	1726	843654061000
24768	1874	200939000
24769	1688	100802023000000
24778	1402	57601782000000
24779	1402	57601792000000
24784	1726	843614057000
24785	1874	200943000
24786	1683	591847387999541
24787	1683	591847397999541
24789	1726	843604056000
24790	1874	200944000
24052	1726	850604236000
24053	1874	200764000
24054	1560	22320641000000
24058	1726	850594235000
24059	1874	200765000
24060	1683	570247027999541
24061	1683	570247037999541
24071	1726	850564232000
24072	1874	200768000
24073	1457	17280370000000
24080	1402	56161762000000
24081	1402	56161782000000
24084	1726	850534229000
24085	1874	200771000
24086	1690	48240651000000
24087	1690	48240661000000
24120	1726	850444220000
24121	1874	200780000
24124	1726	850434219000
24125	1874	200781000
24126	1637	90722334799997
24127	1637	90722344799997
24136	1675	12960649999977
24137	1675	12960659999977
24139	1726	850404216000
24140	1874	200784000
24141	1756	15839839000000
24142	1756	15839849000000
24153	596	82560334000000
24156	1677	203764748000000
24157	1677	203764758000000
24162	1726	850364212000
24163	1874	200788000
24164	1768	11519361110000
24165	1768	11519371110000
24168	1654	13680270000000
24186	1683	577447087999541
24187	1683	577447127999541
24191	1683	577447097999541
24194	1726	850284204000
24195	1874	200796000
24196	470	84000431000000
24202	1726	850274203000
24203	1874	200797000
24204	1726	850264202000
24205	1874	200798000
24206	1726	850254201000
24207	1874	200799000
24208	1726	850244200000
24209	1874	200800000
24210	1726	848944200000
24211	1905	200000000
24212	1726	847644200000
24213	1906	200000000
24214	1489	13680281000000
24215	1489	13680531000000
24217	1726	847634199000
24218	1874	200801000
24219	1717	12959292000000
24220	1717	12959302000000
24255	1726	846234189000
24256	1874	200811000
24257	1602	12240360000000
24258	1602	12240370000000
24267	1426	10080360000000
24281	1703	9359460000000
24294	748	2722390000000
24295	748	2722400000000
24314	1610	15840490000000
24315	1610	15840536000000
24322	1560	23040620000000
24323	1560	23040640000000
24357	1726	845954161000
24358	1874	200839000
24359	1476	16560320000000
24360	1476	16560330000000
24366	1608	12240320000000
24367	1608	12240330000000
24370	1773	6049625162309
24371	182	66307853597696
24372	1726	845934159000
24373	1874	200841000
24374	1480	715960000000
24375	1910	0
24376	1726	845924158000
24377	1874	200842000
24378	1773	5978570270530
24379	702	44205235731806
24380	1773	5167398127791
24381	927	505121132301246
24382	1773	3713792518037
24383	1047	905172741205956
24384	1773	2733012595198
24385	1167	609738084332646
24386	1293	1701875978582222
24387	1850	12945080000000
24388	1850	12945170000000
24395	1607	22322786000000
24396	1699	933819000078
24397	1607	23042786000000
24398	1607	23043137000000
24408	1726	845884154000
24409	1874	200846000
24410	149	74640170000000
24411	149	74640180000000
24436	1726	845814147000
24437	1874	200853000
24438	1726	845804146000
24439	1874	200854000
24440	1850	13665170000000
24441	1850	13665190000000
24450	1726	845774143000
24451	1874	200857000
24452	1402	56161772000000
24467	877	203449876855173
24468	878	203450876855173
24469	127	66129967824773
24470	1596	13139440000000
24488	878	203053176619445
24489	1772	1489440235728
24490	127	66000010000000
24491	1772	1619388060501
24492	1480	712930000000
24493	1913	0
24494	1726	845684134000
24495	1874	200866000
24496	877	203053176619445
24497	1772	2016078296229
24498	1705	15115280000000
24499	1705	15115330000000
24503	1726	845674133000
24504	1874	200867000
24505	1726	845664132000
24506	1874	200868000
24507	1726	845654131000
24508	1874	200869000
24509	1726	845644130000
24510	1874	200870000
24511	1467	11521670000000
24512	1467	11521700000000
24533	1726	845584124000
24534	1874	200876000
24535	1726	845574123000
24536	1874	200877000
24537	1447	18720460000000
24538	1447	18720480000000
24547	1739	12959490000000
24562	298	71039170000000
24563	189	66000200000000
24564	1726	845494115000
24565	1874	200885000
24566	1692	14419433000000
24567	1692	14419553000000
24582	1726	845444110000
24583	1874	200890000
24609	1726	845374103000
24610	1874	200897000
24611	1689	14399321000000
24612	1689	14399331000000
24617	1271	1339806090000000
24618	1271	1339806100000000
24625	641	84720770000000
24626	641	84720780000000
24632	1726	845324098000
24633	1874	200902000
24645	1726	843994095000
24646	1914	200000000
24647	1726	843984094000
24648	1874	200906000
24649	1726	843974093000
24650	1874	200907000
24651	1613	13678490000000
24652	1613	13678610000000
24666	1726	843914087000
24667	1874	200913000
24668	1439	11520190000000
24669	1439	11520200000000
24681	1683	587527377999541
24686	1726	843864082000
24687	1874	200918000
24688	1677	206644788000000
24689	1677	206644798000000
24717	1726	843784074000
24718	1874	200926000
24719	1547	7920200000000
24552	1726	845524118000
24553	1874	200882000
24554	1678	7200194813000
24555	1678	7200224813000
24559	1726	845504116000
24560	1874	200884000
24561	1850	14385200000000
24568	1726	845484114000
24569	1874	200886000
24579	1723	14400060000000
24580	1726	845454111000
24581	1874	200889000
24585	1672	15120402000000
24589	1726	845424108000
24590	1874	200892000
24591	1726	845414107000
24592	1874	200893000
24593	1419	18720420000000
24594	1419	18720440000000
24596	1726	845404106000
24597	1874	200894000
24598	1688	99361983000000
24613	1726	845364102000
24614	1874	200898000
24627	1726	845344100000
24628	1874	200900000
24629	1726	845334099000
24630	1874	200901000
24631	1692	15139573000000
24638	1726	845304096000
24639	1874	200904000
24640	1726	845294095000
24641	1874	200905000
24642	1546	15120260000000
24643	1546	15120280000000
24657	1726	843954091000
24658	1874	200909000
24670	1439	11520470000000
24671	1726	843904086000
24672	1874	200914000
24673	1637	93602384799997
24674	1637	93602394799997
24682	1726	843874083000
24683	1874	200917000
24684	1718	720200000000
24685	1718	720210000000
24693	1726	843854081000
24694	1874	200919000
24695	1726	843844080000
24696	1874	200920000
24697	1726	843834079000
24698	1874	200921000
24699	1564	10080212000000
24701	1726	843824078000
24702	1874	200922000
24703	1402	56881772000000
24704	1402	56881782000000
24711	1726	843804076000
24712	1874	200924000
24713	1726	843794075000
24714	1874	200925000
24715	42	78957930000000
24716	42	78957950000000
24723	1613	14398610000000
24724	1613	14398620000000
24727	1703	9359440000000
24730	1726	843764072000
24731	1874	200928000
24754	1683	588967377999541
24755	1726	843704066000
24756	1874	200934000
24757	1726	843694065000
24758	1874	200935000
24759	1726	843684064000
24760	1874	200936000
24761	1692	15859573000000
24762	1692	15859603000000
24774	1726	843634059000
24775	1874	200941000
24776	1683	590407377999541
24777	1683	590407387999541
24794	1726	843594055000
24795	1874	200945000
24796	1679	59761013000000
24797	1679	59761023000000
24800	1471	15120360000000
24801	1471	15120370000000
24810	1726	843554051000
24811	1874	200949000
24812	1726	843544050000
24813	1874	200950000
24814	353	66282067824773
24815	1498	0
24816	1693	5033627553123
24817	1693	5033657553123
24838	1690	51120711000000
24839	1690	51120721000000
24847	1688	102242033000000
24848	1688	102242043000000
24858	1447	19440480000000
24859	1447	19440490000000
24878	1683	593287407999541
24888	1726	840794035000
24889	1874	200965000
24890	1688	102962043000000
24891	1688	102962053000000
24894	1726	840784034000
24895	1874	200966000
24896	1549	18720471000000
24897	1549	18720481000000
24922	44	79680880000000
24935	1764	15840318000000
24936	1764	15840328000000
24944	1677	209524808000000
24945	1677	209524818000000
24950	1726	840644020000
24951	1874	200980000
24952	1677	210244818000000
24953	1677	210244828000000
24956	1726	840634019000
24957	1874	200981000
24958	1724	19438960000000
24977	1703	9359490000000
24980	1726	840564012000
24981	1874	200988000
24982	1726	840554011000
24983	1874	200989000
24984	1677	210244838000000
24990	1726	840534009000
24991	1874	200991000
24992	1726	840524008000
24993	1874	200992000
24998	1726	840504006000
24999	1874	200994000
25000	1726	840494005000
25001	1874	200995000
25002	1726	840484004000
25003	1874	200996000
25004	1683	594727417999541
25005	1683	594727447999541
25018	1726	840444000000
25019	1874	201000000
25022	1726	840433999000
25023	1874	201001000
25024	1467	13681720000000
25025	1467	13681730000000
25039	1726	840403996000
25040	1874	201004000
25041	1474	12234283000000
25042	1474	12234293000000
25056	1726	840363992000
25057	1874	201008000
25058	1726	840353991000
25059	1874	201009000
25082	1623	25921670899898
25083	1623	25921680899898
25086	1726	840273983000
25087	1874	201017000
25088	1749	12235268000000
25095	1726	840243980000
25096	1874	201020000
25097	1426	10080380000000
25103	1726	840233979000
25104	1874	201021000
25108	1559	18000420000000
25109	1726	840213977000
25110	1874	201023000
25111	1726	840203976000
25112	1874	201024000
25113	633	81119380000000
25114	633	81119400000000
25117	1692	18019653000000
25123	1448	14400632000000
25136	1726	840163972000
25137	1874	201028000
25140	1726	840153971000
25141	1874	201029000
25142	1762	10079230000000
25143	1762	10079240000000
25150	1726	840123968000
25151	1874	201032000
25152	1726	840113967000
25153	1874	201033000
25174	1402	58321792000000
25175	1402	58321822000000
24720	1547	7920210000000
24732	1726	843754071000
24733	1874	200929000
24734	1688	100081983000000
24735	1688	100081993000000
24737	58	84720825000000
24747	1726	843714067000
24748	1874	200933000
24749	1688	100801993000000
24750	1688	100802003000000
24770	1726	843644060000
24771	1874	200940000
24772	1692	16579603000000
24773	1692	16579613000000
24780	1726	843624058000
24781	1874	200942000
24782	1688	101522023000000
24783	1688	101522033000000
24788	1599	13680270000000
24798	1726	843584054000
24799	1874	200946000
24808	1685	56880290000000
24809	1685	56880310000000
24820	1657	12240210000000
24821	1657	12240220000000
24830	1726	840914047000
24831	1874	200953000
24832	1699	2373829000078
24833	1699	2373839000078
24834	1726	840904046000
24835	1874	200954000
24840	1419	18720430000000
24849	1726	840874043000
24850	1874	200957000
24851	1726	840864042000
24852	1874	200958000
24853	641	84720790000000
24866	1726	840834039000
24867	1874	200961000
24868	1706	16556452000000
24869	1706	16556462000000
24872	1726	840824038000
24873	1874	200962000
24874	1677	208804798000000
24875	1677	208804808000000
24879	1679	60481023000000
24880	1679	60481033000000
24887	1692	17299633000000
24900	1692	18019633000000
24901	1692	18019643000000
24904	1447	20160490000000
24918	1726	840724028000
24919	1874	200972000
24920	1726	840714027000
24921	1874	200973000
24923	1726	840704026000
24924	1874	200974000
24925	1448	14400621000000
24926	1448	14400631000000
24937	1726	840674023000
24938	1874	200977000
24939	1458	20160345908540
24940	1458	20160355908540
24959	1637	95762414799997
24960	1637	95762424799997
24985	576	80400460000000
24994	1726	840514007000
24995	1874	200993000
24996	1637	96482424799997
24997	1637	96482434799997
25006	1726	840474003000
25007	1874	200997000
25008	1467	12961710000000
25009	1467	12961720000000
25028	1509	17280431000000
25029	1509	17280441000000
25030	877	203054243117107
25031	878	203055243117107
25032	127	66001371816426
25033	353	66153471816426
25034	1696	13678917000000
25048	1457	17280380000000
25070	1726	840323988000
25071	1874	201012000
25084	1726	840283984000
25085	1874	201016000
25100	1679	61921063000000
25101	1679	62641063000000
25118	1726	840193975000
25119	1874	201025000
25120	1918	999000000
25121	1683	599047477999541
25122	1683	599047488999541
25126	171	78960200000000
25127	171	78960211000000
25164	1430	720000000000
25165	1430	720010000000
25176	1726	840053961000
25177	1874	201039000
25178	1726	840043960000
25179	1874	201040000
25180	1688	105122083000000
25181	1688	105122103000000
25188	1726	840013957000
25189	1874	201043000
25190	1726	840003956000
25191	1874	201044000
25192	1456	0
25193	1918	1439137000000
25194	1727	10799171000000
25204	1726	839963952000
25205	1874	201048000
25206	1653	1440010000000
25207	1653	1440020000000
25212	1476	17280340000000
25225	1726	839923948000
25226	1874	201052000
25227	1726	839913947000
25228	1874	201053000
25229	1677	213844888000000
25230	1677	213844898000000
25244	1726	839883944000
25245	1874	201056000
25246	1683	599047487999541
25249	1692	18739653000000
25250	1692	18739663000000
25263	1726	839843940000
25264	1874	201060000
25276	1690	51840721000000
25277	1690	51840731000000
25299	1599	14400270000000
25318	1726	839683924000
25319	1874	201076000
25320	1668	18720330000000
25321	1668	18720340000000
25339	1694	33839760000000
25340	1694	33839770000000
25357	1693	5753547553123
25358	1693	5753577553123
25363	320	66280977824773
25364	1474	12955293000000
25365	1726	839573913000
25366	1874	201087000
25367	1726	839563912000
25368	1874	201088000
25369	1684	30959771000000
25370	1684	30959891000000
25403	1726	839443900000
25404	1874	201100000
25405	1726	839433899000
25406	1874	201101000
25407	1683	604807547999541
25408	1683	604807567999541
25417	1726	839403896000
25418	1874	201104000
25433	1726	839373893000
25434	1874	201107000
25435	1726	839363892000
25436	1874	201108000
25437	1692	20179673000000
25438	1692	20179693000000
25447	1726	839333889000
25448	1874	201111000
25449	1750	4194000000
25450	1673	15120750000000
25451	1673	15120761000000
25456	1440	15120570000000
25457	1440	15120581000000
25465	1726	839293885000
25466	1874	201115000
25467	1560	24480650000000
25468	1560	24480660000000
25475	1726	839263882000
25476	1874	201118000
25477	1726	839253881000
25478	1874	201119000
25479	632	78960431000000
25480	632	78960451000000
25499	1637	99362464799997
25500	1637	99362484799997
25503	1726	839183874000
25504	1874	201126000
25505	1726	839173873000
25506	1874	201127000
25507	1726	839163872000
24726	1702	8634141000000
24728	1726	843774073000
24729	1874	200927000
24736	58	84720815000000
24738	1677	208084798000000
24751	1451	10080280000000
24792	1680	20879420000000
24793	1680	20879430000000
24836	1549	18000461000000
24837	1549	18000471000000
24845	1726	840884044000
24846	1874	200956000
24854	1726	840854041000
24855	1874	200959000
24856	44	79680860000000
24857	44	79680870000000
24860	1692	17299613000000
24861	1692	17299623000000
24870	1698	20879381000000
24871	1698	20879391000000
24876	111	68880040000000
24877	111	68880050000000
24905	1726	840764032000
24906	1874	200968000
24907	1726	840754031000
24908	1874	200969000
24909	1726	840744030000
24910	1874	200970000
24911	1726	840734029000
24912	1874	200971000
24913	1881	17280595496980
24914	1444	200003000
24915	1744	200000020
24916	1817	904500000
24927	1726	840694025000
24928	1874	200975000
24929	1564	10800212000000
24930	1564	10800222000000
24954	632	78240421000000
24955	632	78240431000000
25014	1593	16560530000000
25015	1593	16560540000000
25020	1718	1440210000000
25021	1718	1440220000000
25043	1726	840393995000
25044	1874	201005000
25045	1726	840383994000
25046	1874	201006000
25047	1683	596167467999541
25051	1690	51120731000000
25052	1726	840373993000
25053	1874	201007000
25054	1634	16560289899999
25055	1634	16560299899999
25060	1506	14400320000000
25061	1506	14400340000000
25062	1726	840343990000
25063	1874	201010000
25064	1726	840333989000
25065	1874	201011000
25066	1456	1438139000000
25067	1918	1000000000
25068	1764	16560328000000
25069	1764	16560349000000
25076	1726	840293985000
25077	1874	201015000
25078	1683	597607467999541
25079	1683	597607477999541
25089	1726	840263982000
25090	1874	201018000
25098	1506	13680330000000
25099	1506	14400330000000
25102	1692	17299643000000
25115	1688	104402063000000
25116	1688	104402083000000
25124	1709	15837451000000
25125	1709	15837462000000
25128	1726	840183974000
25129	1874	201026000
25130	1549	19440481000000
25131	1549	19440491000000
25138	1637	97202434799997
25139	1637	97202444799997
25144	1726	840143970000
25145	1874	201030000
25154	1685	57600310000000
25155	1685	57600330000000
25160	1726	840093965000
25161	1874	201035000
25162	1677	211684838000000
25163	1677	211684848000000
25187	1716	19439381000000
25216	1476	17280370000000
25217	1726	839943950000
25218	1874	201050000
25233	1685	57600320000000
25234	1726	839903946000
25235	1874	201054000
25236	1746	5039091000000
25237	1746	5039101000000
25240	1726	839893945000
25241	1874	201055000
25242	1673	14400740000000
25243	1673	14400750000000
25255	1726	839863942000
25256	1874	201058000
25257	1549	20160491000000
25258	1549	20160501000000
25259	1726	839853941000
25260	1874	201059000
25261	497	66720000000000
25262	497	66720010000000
25271	1726	839813937000
25272	1874	201063000
25293	1726	839743930000
25294	1874	201070000
25295	1683	601927517999541
25296	1683	601927527999541
25298	1689	15839341000000
25315	1726	839693925000
25316	1874	201075000
25317	1681	22319505195920
25335	1726	839623918000
25336	1874	201082000
25337	1677	214564898000000
25338	1677	214564908000000
25341	1726	839613917000
25342	1874	201083000
25343	1677	215284908000000
25344	1677	215284918000000
25355	1610	16560510000000
25356	1610	16560540000000
25359	1726	839583914000
25360	1874	201086000
25361	1692	19459663000000
25362	1692	19459673000000
25384	1726	839513907000
25385	1874	201093000
25386	1726	839503906000
25387	1874	201094000
25388	1726	839493905000
25389	1874	201095000
25401	1726	839453901000
25402	1874	201099000
25411	1726	839423898000
25412	1874	201102000
25413	1726	839413897000
25414	1874	201103000
25415	1683	606247567999541
25416	1683	606247587999541
25423	1726	839393895000
25424	1874	201105000
25425	1726	839383894000
25426	1874	201106000
25427	1693	6473577553123
25428	1693	6473597553123
25440	1726	839353891000
25441	1874	201109000
25442	1723	15840070000000
25443	1723	15840080000000
25444	1726	839343890000
25445	1874	201110000
25446	1671	20161070000000
25458	1726	839323888000
25459	1874	201112000
25460	1726	839313887000
25461	1874	201113000
25462	1726	839303886000
25463	1874	201114000
25464	1740	17277918000000
25473	1726	839273883000
25474	1874	201117000
25482	1726	839243880000
25483	1874	201120000
25484	1726	839233879000
25485	1874	201121000
25486	1440	15840581000000
25487	1440	15840601000000
25497	1759	18000350000000
25498	1759	18000370000000
25501	1726	839193875000
25502	1874	201125000
25532	1402	59041802000000
25533	1402	59042462000000
25534	1508	15120930000000
24791	1444	17280570000000
24802	1726	843574053000
24803	1874	200947000
24804	1726	843564052000
24805	1874	200948000
24806	1683	593287397999541
24807	1683	593287417999541
24818	1726	843534049000
24819	1874	200951000
24822	1726	843524048000
24823	1874	200952000
24824	1726	842224048000
24825	1915	200000000
24826	1726	840924048000
24827	1916	200000000
24828	1448	13680411000000
24829	1448	13680621000000
24841	1726	840894045000
24842	1874	200955000
24843	1710	15839380000000
24844	1710	15839390000000
24862	1726	840844040000
24863	1874	200960000
24864	1607	23040592000000
24865	1607	23040602000000
24881	1726	840814037000
24882	1874	200963000
24883	1726	840804036000
24884	1874	200964000
24885	1546	15840280000000
24886	1546	15840300000000
24892	1637	95042404799997
24893	1637	95042414799997
24898	1679	61201033000000
24899	1679	61201043000000
24902	1726	840774033000
24903	1874	200967000
24917	1444	17280600000000
24931	1726	840684024000
24932	1874	200976000
24933	603	66720000000000
24934	603	66720010000000
24941	1726	840664022000
24942	1874	200978000
24943	369	83280400000000
24946	1726	840654021000
24947	1874	200979000
24948	1755	2159040000000
24949	1755	2159050000000
24961	529	66700000000000
24962	1724	18738950000000
24963	1480	711920000000
24964	1917	0
24965	1726	840624018000
24966	1874	200982000
24967	1726	840614017000
24968	1874	200983000
24969	1726	840604016000
24970	1874	200984000
24971	1726	840594015000
24972	1874	200985000
24973	1726	840584014000
24974	1874	200986000
24975	1702	9354141000000
24976	1702	9354201000000
24978	1726	840574013000
24979	1874	200987000
24986	1726	840544010000
24987	1874	200990000
24988	1733	1439000000000
24989	1733	1439010000000
25010	1726	840464002000
25011	1874	200998000
25012	1683	596167447999541
25013	1683	596167457999541
25016	1726	840454001000
25017	1874	200999000
25026	1726	840423998000
25027	1874	201002000
25035	1726	840413997000
25036	1874	201003000
25037	1679	61921043000000
25038	1679	61921053000000
25049	1679	62641053000000
25050	1679	62641073000000
25072	1726	840313987000
25073	1874	201013000
25074	1726	840303986000
25075	1874	201014000
25080	1560	23760640000000
25081	1560	23760650000000
25091	1726	840253981000
25092	1874	201019000
25093	1688	103682053000000
25094	1688	103682063000000
25105	1726	840223978000
25106	1874	201022000
25107	1546	15840290000000
25132	1726	840173973000
25133	1874	201027000
25134	1677	210964828000000
25135	1677	210964838000000
25146	1726	840133969000
25147	1874	201031000
25148	1573	19440700000000
25149	1573	19440710000000
25156	1726	840103966000
25157	1874	201034000
25158	1637	97922444799997
25159	1637	97922454799997
25166	1726	840083964000
25167	1874	201036000
25168	1726	840073963000
25169	1874	201037000
25170	1726	840063962000
25171	1874	201038000
25172	1677	212404848000000
25173	1677	212404878000000
25182	1726	840033959000
25183	1874	201041000
25184	1726	840023958000
25185	1874	201042000
25186	1683	599047497999541
25199	1726	839983954000
25200	1874	201046000
25201	1726	839973953000
25202	1874	201047000
25203	1698	20879401000000
25219	1726	839933949000
25220	1874	201051000
25221	1677	213124878000000
25222	1677	213124888000000
25238	1455	16560281000000
25239	1455	16560291000000
25265	1726	839833939000
25266	1874	201061000
25267	1726	839823938000
25268	1874	201062000
25269	1714	21589340000000
25270	1714	21589360000000
25273	1918	1439138000000
25274	1439	12961900000000
25275	1439	12962192000000
25278	1726	839803936000
25279	1874	201064000
25280	1726	839793935000
25281	1874	201065000
25282	1726	839783934000
25283	1874	201066000
25284	1679	62641083000000
25297	1402	58321802000000
25302	1726	839733929000
25303	1874	201071000
25304	1726	839723928000
25305	1874	201072000
25306	1726	839713927000
25307	1874	201073000
25308	497	66000000000000
25309	1474	12954293000000
25310	1726	839703926000
25311	1874	201074000
25312	1559	18000460000000
25313	1690	52560731000000
25314	1690	52560781000000
25322	1726	839673923000
25323	1874	201077000
25324	1726	839663922000
25325	1874	201078000
25326	1683	601927537999541
25345	1593	17280540000000
25346	1593	17280550000000
25371	320	66000877824773
25372	1474	13235293000000
25373	1726	839553911000
25374	1874	201089000
25375	1726	839543910000
25376	1874	201090000
25377	1756	17279979000000
25390	1749	12955268000000
25391	1749	12955298000000
25397	1726	839463902000
25398	1874	201098000
25399	1683	603367537999541
25400	1683	603367547999541
25409	1455	17280291000000
25195	1726	839993955000
25196	1874	201045000
25197	1471	15840370000000
25198	1471	15840380000000
25208	1726	839953951000
25209	1874	201049000
25210	576	81120460000000
25211	576	81120470000000
25213	1439	11520840000000
25214	1439	12240840000000
25215	1439	12241900000000
25223	1457	18000370000000
25224	1457	18000380000000
25231	1637	98642454799997
25232	1637	98642464799997
25247	1756	17279859000000
25248	1756	17279869000000
25251	1726	839873943000
25252	1874	201057000
25253	1719	12959260000000
25254	1719	12959270000000
25285	1726	839773933000
25286	1874	201067000
25287	1726	839763932000
25288	1874	201068000
25289	1726	839753931000
25290	1874	201069000
25291	1683	600487487999541
25292	1683	600487517999541
25300	366	66720000000000
25301	1759	17280350000000
25327	1726	839653921000
25328	1874	201079000
25329	1726	839643920000
25330	1874	201080000
25331	1726	839633919000
25332	1874	201081000
25333	641	85440790000000
25334	641	85440820000000
25347	1726	839603916000
25348	1874	201084000
25349	1726	839593915000
25350	1874	201085000
25351	1693	5033547553123
25352	366	66000100000000
25353	1677	216004918000000
25354	1677	216004948000000
25378	366	66000000000000
25379	1726	839533909000
25380	1874	201091000
25381	1726	839523908000
25382	1874	201092000
25383	1440	14400570000000
25392	1726	839483904000
25393	1874	201096000
25394	1726	839473903000
25395	1874	201097000
25396	1677	216004938000000
25421	1677	216724938000000
25422	1677	216724948000000
25431	243	68160030000000
25432	243	68160050000000
25439	1608	12960340000000
25454	1733	2159010000000
25455	1733	2159021000000
25469	1726	839283884000
25470	1874	201116000
25471	1680	21599430000000
25472	1680	21599440000000
25481	1675	12960669999977
25491	1726	839213877000
25492	1874	201123000
25493	1726	839203876000
25494	1874	201124000
25495	1509	18000441000000
25496	1509	18000461000000
25512	1704	3599140000000
25535	1726	831323868000
25536	1874	201132000
25578	1726	831203856000
25579	1874	201144000
25580	1688	105842113000000
25592	189	66000100000000
25593	1726	831163852000
25594	1874	201148000
25595	1683	610567607999541
25596	1683	610567717999541
25611	1726	831133849000
25612	1874	201151000
25613	1471	16560380000000
25614	1471	16560390000000
25653	1726	831023838000
25654	1874	201162000
25655	1745	4004000000
25656	1925	1200000000
25657	1677	217444959000000
25679	1726	830973833000
25680	1874	201167000
25681	1471	17280390000000
25682	1471	17280400000000
25690	1402	60482482000000
25691	1402	60482492000000
25702	1692	20899693000000
25703	1692	20899704000000
25711	1726	829633829000
25712	1927	200000000
25713	1726	829623828000
25714	1874	201172000
25715	1726	829613827000
25716	1874	201173000
25717	1750	4185000000
25718	1683	617767749999541
25719	1683	617767870999541
25721	1726	829603826000
25722	1874	201174000
25744	1726	829533819000
25745	1874	201181000
25746	1726	829523818000
25747	1874	201182000
25748	1726	829513817000
25749	1874	201183000
25750	1726	829503816000
25751	1874	201184000
25752	1726	829493815000
25753	1874	201185000
25754	1726	829483814000
25755	1874	201186000
25756	1750	4184000000
25757	1715	19440161000000
25758	1715	19440222000000
25769	1726	829453811000
25770	1874	201189000
25771	1683	619207759999541
25772	1683	619207769999541
25776	1726	829443810000
25777	1874	201190000
25778	1726	829433809000
25779	1874	201191000
25780	1688	107282123000000
25781	1688	107282143000000
25783	1883	100000000
25784	1726	829423808000
25785	1874	201192000
25786	1726	829413807000
25787	1874	201193000
25788	1610	18000540000000
25789	1610	18000680000000
25800	1688	107282133000000
25815	1692	21619834000000
25818	1726	829323798000
25819	1874	201202000
25826	1726	829293795000
25827	1874	201205000
25828	1726	829283794000
25829	1874	201206000
25830	1402	61922512000000
25831	1402	61922532000000
25840	1726	829263792000
25841	1874	201208000
25842	1726	829253791000
25843	1874	201209000
25844	1634	16560309899999
25845	1692	22339834000000
25846	1692	22339854000000
25848	1726	829243790000
25849	1874	201210000
25850	162	67440010000000
25851	162	67440111000000
25870	1726	827883784000
25871	1874	201216000
25872	1683	620647779999541
25885	1689	15839351000000
25894	1726	827833779000
25895	1874	201221000
25896	1693	7193597553123
25905	1729	12959230000000
25906	1729	12959250000000
25915	1726	827793775000
25916	1874	201225000
25917	1683	622087789999541
25918	1683	622087799999541
25926	1432	720000000000
25927	1432	720020000000
25951	1637	100802534799997
25956	1726	827673763000
25410	1455	17280311000000
25419	1683	607687587999541
25420	1683	607687597999541
25429	1780	1438910000000
25430	1780	1438930000000
25452	1684	31679891000000
25453	1684	31679902000000
25488	1726	839223878000
25489	1874	201122000
25490	1693	6473587553123
25510	631	66000500000000
25511	1747	7198690000000
25513	1726	839153871000
25514	1874	201129000
25515	1726	837853871000
25516	603	66001200000000
25517	1726	836553871000
25518	1919	200000000
25519	1726	835253871000
25520	1920	200000000
25521	1726	833953871000
25522	1921	200000000
25523	1726	832653871000
25524	1922	200000000
25525	1726	832643870000
25526	1874	201130000
25527	1726	831343870000
25528	1923	200000000
25529	1726	831333869000
25530	1874	201131000
25531	1677	216725598000000
25539	1679	63361083000000
25540	1679	63361093000000
25545	1680	22319440000000
25546	1680	22319450000000
25549	1455	17280301000000
25554	1685	58320320000000
25555	1685	58320330000000
25560	1402	59762462000000
25561	1402	59762472000000
25570	1559	18000440000000
25588	1690	53280781000000
25589	1690	53280801000000
25598	1726	831153851000
25599	1874	201149000
25600	1683	612007717999541
25601	1683	612007727999541
25608	1693	7193587553123
25609	1693	7193598553123
25626	1688	106562113000000
25627	1688	106562133000000
25641	1657	12960220000000
25642	1657	12960242000000
25649	1726	831033839000
25650	1874	201161000
25651	1677	217444948000000
25652	1677	217444958000000
25665	1919	150000000
25666	1726	831003836000
25667	1874	201164000
25668	1750	4189000000
25669	1752	96000000
25670	369	83280452000000
25686	1726	830953831000
25687	1874	201169000
25688	1683	616327738999541
25689	1683	616327748999541
25694	1727	11519171000000
25695	1727	11519181000000
25700	1699	3093839000078
25701	1699	3093850000078
25707	1685	59040330000000
25708	1685	59040341000000
25709	1750	4186000000
25710	1547	7920202000000
25734	1726	829563822000
25735	1874	201178000
25736	1726	829553821000
25737	1874	201179000
25738	1474	13955293000000
25739	1474	13955313000000
25743	1879	719010000000
25765	1692	21619814000000
25766	1692	21619824000000
25767	1726	829463812000
25768	1874	201188000
25775	1698	21599401000000
25782	1698	21599421000000
25792	632	79680453000000
25793	632	79680463000000
25799	1656	18720411000000
25809	1726	829353801000
25810	1874	201199000
25811	1726	829343800000
25812	1874	201200000
25813	1683	620647769999541
25814	1683	620647789999541
25832	1726	829273793000
25833	1874	201207000
25834	1700	12959550000000
25835	1700	12959560000000
25861	162	67440140000000
25865	1657	12960831000000
25875	1680	23759460000000
25876	1680	23759470000000
25881	1726	827863782000
25882	1874	201218000
25883	1677	218164959000000
25884	1677	218164969000000
25888	1657	13680831000000
25889	1657	13680871000000
25899	1726	827823778000
25900	1874	201222000
25901	1726	827813777000
25902	1874	201223000
25903	1706	17276462000000
25904	1706	17276482000000
25912	1739	13679490000000
25913	1739	13679500000000
25937	1726	827743770000
25938	1874	201230000
25939	1726	827733769000
25940	1874	201231000
25941	632	79680473000000
25942	1726	827723768000
25943	1874	201232000
25944	1726	827713767000
25945	1874	201233000
25946	1726	827703766000
25947	1874	201234000
25948	1726	827693765000
25949	1874	201235000
25950	1699	3093879000078
25975	1726	827623758000
25976	1874	201242000
25977	1726	827613757000
25978	1874	201243000
25979	1422	12240210000000
25980	1422	12240230000000
25985	1759	18000380000000
25993	1726	827583754000
25994	1874	201246000
25995	1671	20881070000000
25996	1671	20881080000000
25999	1726	827573753000
26000	1874	201247000
26011	1764	18000359000000
26012	1764	18000569000000
26017	1726	824943750000
26018	1874	201250000
26021	1684	32399901000000
26022	1684	32399911000000
26038	1726	824893745000
26039	1874	201255000
26040	1677	219604979000000
26041	1677	219604989000000
26052	1677	219605089000000
26058	1726	823553741000
26059	1874	201259000
26060	1683	627847829999541
26061	1683	627847839999541
26074	1726	823523738000
26075	1874	201262000
26076	1683	629287839999541
26077	1683	629287849999541
26087	1675	13680669999977
26088	1675	13680699999977
26102	1686	8852076500013
26103	1686	8852086500013
26108	1726	823443730000
26109	1874	201270000
26110	1683	629287869999541
26111	1726	823433729000
26112	1874	201271000
26113	1683	630727869999541
26114	1683	630727879999541
26131	1726	823403726000
26132	1874	201274000
26133	1683	633607889999541
26134	1683	633607899999541
26139	1509	18000451000000
26140	1726	823393725000
26141	1874	201275000
26142	1521	2877099000000
26143	310	66000010000000
25508	1874	201128000
25509	1746	5039121000000
25537	1726	831313867000
25538	1874	201133000
25552	1726	831283864000
25553	1874	201136000
25562	1726	831263862000
25563	1874	201138000
25564	1726	831253861000
25565	1874	201139000
25566	1726	831243860000
25567	1874	201140000
25568	1688	105842103000000
25569	1688	105842133000000
25575	1726	831213857000
25576	1874	201143000
25577	1610	16560520000000
25586	1458	20880355908540
25587	1458	20880375908540
25590	1726	831173853000
25591	1874	201147000
25607	1711	15119241000000
25610	1683	614887738999541
25621	1726	831103846000
25622	1874	201154000
25623	1726	831093845000
25624	1874	201155000
25625	1402	59762482000000
25633	1726	831073843000
25634	1874	201157000
25635	1726	831063842000
25636	1874	201158000
25637	1750	4191000000
25638	1745	6205000000
25639	1924	1200000000
25640	632	78960453000000
25658	1726	831013837000
25659	1874	201163000
25660	1750	4190000000
25661	1745	1803000000
25662	1926	1200000000
25663	1444	18000600000000
25664	1444	18000612000000
25673	1747	7918690000000
25674	1747	7918700000000
25675	1726	830983834000
25676	1874	201166000
25677	1752	95000000
25678	1593	17280551000000
25692	1471	18000400000000
25693	1471	18000410000000
25696	1726	830943830000
25697	1874	201170000
25698	1750	4188000000
25699	1683	616327749999541
25704	1726	830933829000
25705	1874	201171000
25706	1750	4187000000
25720	1692	20899814000000
25725	1681	23039505195920
25726	1681	23039515195920
25730	1726	829573823000
25731	1874	201177000
25732	1637	100082484799997
25733	1637	100082494799997
25763	1611	12950210000000
25764	1611	12950220000000
25790	1726	829403806000
25791	1874	201194000
25798	1656	18720401000000
25805	1726	829373803000
25806	1874	201197000
25807	1726	829363802000
25808	1874	201198000
25816	1726	829333799000
25817	1874	201201000
25838	1637	100802494799997
25839	1637	100802504799997
25852	1726	829233789000
25853	1874	201211000
25854	1726	829223788000
25855	1874	201212000
25856	1726	827923788000
25857	1928	200000000
25858	1726	827913787000
25859	1874	201213000
25860	1271	1339806220000000
25862	1726	827903786000
25863	1874	201214000
25864	1657	12960230000000
25866	1726	827893785000
25867	1874	201215000
25868	369	84720462000000
25869	369	84720472000000
25873	1455	18000301000000
25874	1455	18000311000000
25886	1657	13680230000000
25887	1657	13680240000000
25911	1402	61922522000000
25924	44	80400880000000
25925	44	80400900000000
25934	1726	827753771000
25935	1874	201229000
25936	1633	12960170000000
25952	1726	827683764000
25953	1874	201236000
25954	1683	623527799999541
25955	1683	623527809999541
25962	1683	624967809999541
25963	1683	624967819999541
25968	1726	827643760000
25969	1874	201240000
25970	1673	15120760000000
25981	1726	827603756000
25982	1874	201244000
25983	1698	22319401000000
25984	1698	22319431000000
26009	1699	3813879000078
26010	1699	3814089000078
26013	1726	824953751000
26014	1874	201249000
26015	1588	15840500000000
26016	1588	15840510000000
26044	1726	824883744000
26045	1874	201256000
26046	1726	824873743000
26047	1874	201257000
26048	1726	823573743000
26049	1930	200000000
26050	1850	15105190000000
26051	1850	15105300000000
26064	1726	823543740000
26065	1874	201260000
26066	1522	12959940000000
26067	1522	12959950000000
26070	1726	823533739000
26071	1874	201261000
26072	1471	18720410000000
26073	1471	18720420000000
26085	1747	8638700000000
26086	1747	8638730000000
26094	1718	2160220000000
26098	1726	823453731000
26099	1874	201269000
26100	1560	25200660000000
26101	1560	25200670000000
26117	1756	17279999000000
26118	1756	17999999000000
26119	1756	18000009000000
26123	1726	823423728000
26124	1874	201272000
26125	1683	632167879999541
26126	1683	632167889999541
26127	1726	823413727000
26128	1874	201273000
26129	1677	220324999000000
26130	1677	220325009000000
26137	1402	63362542000000
26138	1402	63362552000000
26148	1726	823383724000
26149	1874	201276000
26156	1476	17280350000000
26157	1929	1300000000
26158	1726	823353721000
26159	1874	201279000
26160	1726	823343720000
26161	1874	201280000
26162	1726	823333719000
26163	1874	201281000
26164	1726	823323718000
26165	1874	201282000
26166	1726	823313717000
26167	1874	201283000
26168	1684	32400051000000
26171	1726	823303716000
26172	1874	201284000
26173	310	66000009000000
26174	1699	4534089000078
26175	1699	4534100000078
26201	1726	823243710000
26202	1874	201290000
26203	1564	12240242000000
26204	1564	12240252000000
26212	1726	823203706000
26213	1874	201294000
25541	1726	831303866000
25542	1874	201134000
25543	1683	609127597999541
25544	1683	609127607999541
25547	1726	831293865000
25548	1874	201135000
25550	576	81840470000000
25551	576	81840480000000
25556	1726	831273863000
25557	1874	201137000
25558	1467	14401730000000
25559	1467	14401740000000
25571	1726	831233859000
25572	1874	201141000
25573	1726	831223858000
25574	1874	201142000
25581	1726	831193855000
25582	1874	201145000
25583	1726	831183854000
25584	1874	201146000
25585	1549	20160511000000
25597	1695	15119501000000
25602	1726	831143850000
25603	1874	201150000
25604	1750	4193000000
25605	1683	613447727999541
25606	1683	613447738999541
25615	1726	831123848000
25616	1874	201152000
25617	1726	831113847000
25618	1874	201153000
25619	1564	11520222000000
25620	1564	11520242000000
25628	1726	831083844000
25629	1874	201156000
25630	1750	4192000000
25631	1440	16560601000000
25632	1440	16560612000000
25643	1726	831053841000
25644	1874	201159000
25645	1726	831043840000
25646	1874	201160000
25647	1610	17280520000000
25648	1610	17280540000000
25671	1726	830993835000
25672	1874	201165000
25683	1726	830963832000
25684	1874	201168000
25685	1684	31679901000000
25723	1726	829593825000
25724	1874	201175000
25727	1726	829583824000
25728	1874	201176000
25729	1683	617767759999541
25740	1726	829543820000
25741	1874	201180000
25742	1688	106562123000000
25759	1726	829473813000
25760	1874	201187000
25761	1489	15120541000000
25762	1489	15120551000000
25773	1680	23039450000000
25774	1680	23039460000000
25794	1726	829393805000
25795	1874	201195000
25796	369	84000452000000
25797	369	84000462000000
25801	1726	829383804000
25802	1874	201196000
25803	1715	20160222000000
25804	1715	20160232000000
25820	1726	829313797000
25821	1874	201203000
25822	1726	829303796000
25823	1874	201204000
25824	1402	61202492000000
25825	1402	61202512000000
25836	1489	15840551000000
25837	1489	15840561000000
25847	1611	12950230000000
25877	1726	827873783000
25878	1874	201217000
25879	1686	8132066500013
25880	1686	8132076500013
25890	1726	827853781000
25891	1874	201219000
25892	1726	827843780000
25893	1874	201220000
25897	1714	22309360000000
25898	1714	22309370000000
25907	1726	827803776000
25908	1874	201224000
25909	1549	20880501000000
25910	1549	20880511000000
25914	1690	53280791000000
25919	1726	827783774000
25920	1874	201226000
25921	1726	827773773000
25922	1874	201227000
25923	1677	218164979000000
25928	1402	62642522000000
25929	1402	62642542000000
25930	1726	827763772000
25931	1874	201228000
25932	1656	19440411000000
25933	1656	19440421000000
25960	1726	827663762000
25961	1874	201238000
25964	1726	827653761000
25965	1874	201239000
25966	1764	17280349000000
25967	1764	17280359000000
25973	1688	108002133000000
25974	1688	108002143000000
25991	1683	626407819999541
25992	1683	626407829999541
25997	1573	20160710000000
25998	1573	20160720000000
26019	1726	824933749000
26020	1874	201251000
26032	1726	824913747000
26033	1874	201253000
26034	1726	824903746000
26035	1874	201254000
26036	1690	54000791000000
26037	1690	54000811000000
26054	596	82560432000000
26055	1726	823563742000
26056	1874	201258000
26057	1759	18000360000000
26084	1634	16560319899999
26089	1726	823483734000
26090	1874	201266000
26091	1726	823473733000
26092	1874	201267000
26093	1677	219604999000000
26106	1690	55440821000000
26107	1690	55440831000000
26147	1692	22339845000000
26154	1448	15120632000000
26155	1448	15120652000000
26190	1426	11520380000000
26191	1426	11520401000000
26195	1689	15839342000000
26224	1726	823173703000
26225	1874	201297000
26226	1931	9000000
26227	1427	1439750000000
26228	1427	1439761000000
26243	1692	23059844000000
26244	1692	23059854000000
26245	1611	13670230000000
26246	1611	13670240000000
26247	1726	823143700000
26248	1874	201300000
26249	1726	823133699000
26250	1874	201301000
26251	1637	102242515799997
26252	1637	102242535799997
26263	149	75360180000000
26264	149	75360195000000
26273	1601	11161215600000
26274	1601	11161236600000
26282	1602	12960390000000
26287	1726	823063692000
26288	1874	201308000
26289	1933	719011000000
26294	632	80400473000000
26295	632	80400483000000
26301	1688	108002144000000
25957	1874	201237000
25958	1458	21600375908540
25959	1458	21600385908540
25971	1726	827633759000
25972	1874	201241000
25986	1688	108002163000000
25987	1726	827593755000
25988	1874	201245000
25989	1677	218884969000000
25990	1677	218884979000000
26001	1726	826273753000
26002	1929	200000000
26003	1726	824973753000
26004	1929	1400000000
26005	1726	824963752000
26006	1874	201248000
26007	1654	14400270000000
26008	1654	14400480000000
26023	1679	64081093000000
26024	1679	64081103000000
26025	1684	31680731000000
26026	1684	32400731000000
26027	1684	32400751000000
26028	1726	824923748000
26029	1874	201252000
26030	1588	16560510000000
26031	1588	16560520000000
26042	1521	2877100000000
26043	1521	2877110000000
26053	1689	15839451000000
26062	1693	7913597553123
26063	1693	7913607553123
26068	1690	54720811000000
26069	1690	54720821000000
26078	1726	823513737000
26079	1874	201263000
26080	1726	823503736000
26081	1874	201264000
26082	1726	823493735000
26083	1874	201265000
26095	1726	823463732000
26096	1874	201268000
26097	1718	2160230000000
26104	1719	13679270000000
26105	1719	13679280000000
26115	1685	58320350000000
26116	1685	59040350000000
26120	1690	54720841000000
26121	1690	55440841000000
26122	632	79680483000000
26135	1657	14400240000000
26136	1657	14400250000000
26146	1723	15840081000000
26182	1726	823273713000
26183	1874	201287000
26184	1726	823263712000
26185	1874	201288000
26186	1521	2877088000000
26187	305	66000010000000
26188	1683	635047889999541
26189	1683	635047910999541
26200	1692	22339844000000
26233	1726	823163702000
26234	1874	201298000
26235	1419	19440440000000
26236	1419	19440450000000
26241	1633	13680170000000
26242	1633	13680180000000
26257	1726	823113697000
26258	1874	201303000
26259	1596	13837435000000
26260	1932	21000000000
26261	1679	64801103000000
26262	1679	64801118000000
26276	1726	823083694000
26277	1874	201306000
26278	1726	823073693000
26279	1874	201307000
26280	1610	18720680000000
26281	1610	18720700000000
26296	1726	823043690000
26297	1874	201310000
26298	1541	7917237000000
26299	1718	2160240000000
26300	1508	15120281000000
26302	1726	823033689000
26303	1874	201311000
26304	1706	17276472000000
26144	1698	23039431000000
26145	1698	23039442000000
26150	1726	823373723000
26151	1874	201277000
26152	1726	823363722000
26153	1874	201278000
26169	1637	101522504799997
26170	1637	101522654799997
26176	1726	823293715000
26177	1874	201285000
26178	1726	823283714000
26179	1874	201286000
26180	1458	22320385908540
26181	1458	22320405908540
26192	305	66000009000000
26193	1715	20880232000000
26194	1715	20880233000000
26196	1726	823253711000
26197	1874	201289000
26198	1699	5254100000078
26199	1699	5254110000078
26205	1726	823233709000
26206	1874	201291000
26207	1726	823223708000
26208	1874	201292000
26209	1726	823213707000
26210	1874	201293000
26211	484	84000382000000
26220	1726	823183704000
26221	1874	201296000
26222	1683	636487910999541
26223	1683	636487920999541
26230	1474	14675313000000
26231	1474	14675324000000
26232	1637	101522515799997
26265	1726	823103696000
26266	1874	201304000
26267	1726	823093695000
26268	1874	201305000
26269	1521	1599000000
26270	1931	2874486000000
26271	1607	23760602000000
26272	1607	23760623000000
26284	262	66000099000000
26285	1933	719000000000
26286	1933	719001000000
26290	1726	823053691000
26291	1874	201309000
26292	1588	17280520000000
26293	1588	17280530000000
26214	1726	823193705000
26215	1874	201295000
26216	1521	2876077000000
26217	1931	10000000
26218	1717	15119312000000
26219	1717	15119333000000
26229	1536	17280411000000
26237	1726	823153701000
26238	1874	201299000
26239	1677	221045009000000
26240	1677	221045019000000
26253	1726	823123698000
26254	1874	201302000
26255	1419	20160450000000
26256	1419	20160460000000
26275	1602	12960370000000
26283	1719	13679290000000
26305	1427	1439760000000
26306	1587	15120290000000
26307	1726	821733689000
26308	342	66001200000000
26309	1726	821723688000
26310	1874	201312000
26311	1521	1588000000
26312	166	66000010000000
26313	1680	23759571000000
26314	1727	11519282000000
26315	1680	23759560000000
26316	1521	2157089000000
26317	1521	2157078000000
26318	1718	1440230000000
26319	1521	2156067000000
26320	1680	24479560000000
26321	1680	24480730000000
26322	1726	821713687000
26323	1874	201313000
26324	1683	637927920999541
26325	1683	637927930999541
26326	633	81119390000000
26327	1726	821703686000
26328	1874	201314000
26329	1726	821693685000
26330	1874	201315000
26331	1541	36000000
26332	1718	10077440000000
26333	1688	108722144000000
26334	1688	108722165000000
26335	1726	821683684000
26336	1874	201316000
26337	8	10953000000000
26338	8	10953010000000
26339	342	66001100000000
26340	1726	821673683000
26341	1874	201317000
26342	1726	821663682000
26343	1874	201318000
26344	1726	821653681000
26345	1874	201319000
26346	1718	10077439000000
26347	1691	10799160000000
26348	1691	10799291000000
26349	1559	18720440000000
26350	1559	18720571000000
26351	1726	821643680000
26352	1874	201320000
26353	166	66000009000000
26354	1684	33120051000000
26355	1684	33120052000000
26356	1457	18720380000000
26357	1457	18720381000000
26358	1439	11520191000000
26359	1726	821633679000
26360	1874	201321000
26361	1726	821623678000
26362	1874	201322000
26363	1679	64801123000000
26364	1726	821613677000
26365	1874	201323000
26366	1726	821603676000
26367	1874	201324000
26368	1683	637927940999541
26369	1637	102962535799997
26370	1637	102962555799997
26371	1726	821593675000
26372	1874	201325000
26373	1688	109442165000000
26374	1688	109442175000000
26375	1726	821583674000
26376	1874	201326000
26377	1718	10797439000000
26378	1718	10797449000000
26379	1726	821573673000
26380	1874	201327000
26381	1637	103682555799997
26382	1637	103682565799997
26383	1726	821563672000
26384	1874	201328000
26385	1726	821553671000
26386	1874	201329000
26387	1684	33120061000000
26388	1726	821543670000
26389	1874	201330000
26390	1670	20160620000000
26391	1670	20160630000000
26392	1726	821533669000
26393	1874	201331000
26394	1726	821523668000
26395	1874	201332000
26396	1726	821513667000
26397	1874	201333000
26398	1726	821503666000
26399	1874	201334000
26400	1694	34559770000000
26401	1694	34559780000000
26402	1726	821493665000
26403	1874	201335000
26404	1637	104402565799997
26405	1637	104402575799997
26406	1685	59760350000000
26407	1685	59760360000000
26408	1726	821483664000
26409	1874	201336000
26410	1726	820183664000
26411	1930	1400000000
26412	484	84720382000000
26413	484	84720502000000
26414	55	67440150000000
26415	1726	818883664000
26416	1934	200000000
26417	1726	818873663000
26418	1874	201337000
26419	1726	817573663000
26420	1935	200000000
26421	1726	816273663000
26422	1936	200000000
26423	1726	814973663000
26424	1937	200000000
26425	1726	813673663000
26426	1938	200000000
26427	1694	35279780000000
26428	1694	35280290000000
26429	1726	813663662000
26430	1874	201338000
26431	1673	15840760000000
26432	1673	15840770000000
26433	1726	813653661000
26434	1874	201339000
26435	1726	813643660000
26436	1874	201340000
26437	1726	813633659000
26438	1874	201341000
26439	1449	710024000459
26440	1939	9000000000
26441	1683	637927950999541
26442	1654	14400300000000
26443	1688	110162175000000
26444	1688	110162205000000
26445	1726	813623658000
26446	1874	201342000
26447	1726	813613657000
26448	1874	201343000
26449	1769	1821900000
26450	1656	20160421000000
26451	1656	20160442000000
26452	1513	12960370000000
26453	1513	12960391000000
26454	1637	104402586799997
26455	1685	59760371000000
26456	1726	813603656000
26457	1874	201344000
26458	1726	813593655000
26459	1874	201345000
26460	1726	813583654000
26461	1874	201346000
26462	1936	199000000
26463	1677	221765019000000
26464	1677	221765050000000
26465	1726	813573653000
26466	1874	201347000
26467	1726	813563652000
26468	1874	201348000
26469	1440	17280612000000
26470	1440	17280632000000
26471	1726	813553651000
26472	1874	201349000
26473	1769	1720900000
26474	667	66000100000000
26475	1511	720011000000
26483	1726	813523648000
26484	1874	201352000
26485	1726	813513647000
26486	1874	201353000
26487	1587	15840290000000
26488	1587	15840310000000
26497	1726	813473643000
26498	1874	201357000
26499	1726	813463642000
26500	1874	201358000
26501	1677	222485050000000
26502	1677	222485070000000
26517	1688	110882205000000
26518	1688	110882215000000
26527	1726	813393635000
26528	1874	201365000
26529	1511	718501000000
26530	1941	500000000
26531	1698	23039451000000
26539	1934	0
26540	1941	470000000
26541	903	114218769973438
26542	1726	813363632000
26543	1874	201368000
26544	1726	813353631000
26545	1874	201369000
26546	1683	639367930999541
26547	1683	639368159999541
26553	1677	223205299000000
26561	1726	813323628000
26562	1874	201372000
26563	1726	813313627000
26564	1874	201373000
26565	1726	813303626000
26566	1874	201374000
26567	1511	0
26568	1941	718961000000
26569	903	114218749973438
26570	904	114218764973438
26571	1549	21600511000000
26572	1549	21600556000000
26585	1613	15120600000000
26599	470	84720421000000
26600	470	84720431000000
26606	1402	64082552000000
26607	1402	64082567000000
26609	1726	813233619000
26610	1874	201381000
26619	1679	65521133000000
26621	1726	813193615000
26622	1874	201385000
26637	1726	813153611000
26638	1874	201389000
26639	1726	811853611000
26640	1942	200000000
26641	1726	811843610000
26642	1874	201390000
26643	1683	640808279999541
26646	1685	59760470000000
26647	1762	10799240000000
26651	1683	642248159999541
26661	1723	16560081000000
26662	1943	718900000000
26663	210	66000000000000
26664	149	76080195000000
26665	149	76080295000000
26678	1677	224645215000000
26685	1448	15840652000000
26686	1448	15840662000000
26706	1726	810443600000
26707	1874	201400000
26708	1706	17996472000000
26709	1706	17996482000000
26713	1726	810433599000
26714	1874	201401000
26715	1726	810423598000
26716	1874	201402000
26717	1726	810413597000
26718	1874	201403000
26719	1726	810403596000
26720	1874	201404000
26721	1726	810383596000
26722	640	66000010000000
26723	576	81840520000000
26728	1637	105842596799997
26729	1637	105842606799997
26740	1726	810333591000
26741	1874	201409000
26742	1726	809123591000
26743	1945	200000000
26744	1634	17280304899999
26745	1634	17280324899999
26748	1726	809113590000
26749	1874	201410000
26750	1649	13680550999992
26757	1686	8852286500013
26760	1726	809093588000
26761	1874	201412000
26762	1726	809083587000
26763	1874	201413000
26764	1677	225365105000000
26765	1677	225365125000000
26767	1718	11517449000000
26768	1718	11517469000000
26816	1726	808963575000
26817	1874	201425000
26820	1726	808953574000
26821	1874	201426000
26822	1683	648008179999541
26823	1683	648008189999541
26824	1688	111602215000000
26825	1688	111602225000000
26832	1426	11520390000000
26837	1726	808913570000
26838	1874	201430000
26839	1671	21601070000000
26840	1671	21601080000000
26847	1726	808893568000
26848	1874	201432000
26849	1726	808883567000
26850	1874	201433000
26853	1726	808873566000
26854	1874	201434000
26855	1513	12960380000000
26873	1693	8633607553123
26874	1693	8633617553123
26877	1677	226085125000000
26878	1677	226085135000000
26896	1726	808753554000
26897	1874	201446000
26898	1726	808743553000
26899	1874	201447000
26900	1726	808733552000
26901	1874	201448000
26902	1726	808723551000
26903	1874	201449000
26904	1637	105842636799997
26910	1726	808693548000
26911	1874	201452000
26912	1726	808683547000
26913	1874	201453000
26914	1671	22321080000000
26915	1671	22321100000000
26926	1683	650888219999541
26947	1726	808593538000
26948	1874	201462000
26949	632	81840503000000
26950	632	81840513000000
26957	1726	808563535000
26958	1874	201465000
27002	1726	808443523000
27003	1874	201477000
27004	1726	808433522000
27005	1874	201478000
27014	1726	808403519000
27015	1874	201481000
27016	1683	656648269999541
27017	1683	656648279999541
27020	1709	15837461000000
27033	1726	808363515000
27034	1874	201485000
27035	1564	13680262000000
27036	1564	13680272000000
27045	1726	808323511000
27046	1874	201489000
27047	1683	658088279999541
27048	1683	658088289999541
27051	1623	26641680899898
27052	1623	26641690899898
27055	1726	808313510000
27056	1874	201490000
27057	1480	710919000000
27058	1946	0
27059	1643	2016224113700
27060	1643	2016235113700
27124	1726	808153494000
27125	1874	201506000
27126	1683	659528329999541
27133	1726	808123491000
27134	1874	201509000
27135	1726	808113490000
27136	1874	201510000
26476	1513	12960381000000
26489	1726	813503646000
26490	1874	201354000
26491	1726	813493645000
26492	1874	201355000
26493	1694	36000290000000
26494	1694	36000310000000
26503	1726	813453641000
26504	1874	201359000
26505	1678	7920224813000
26506	1678	7920234813000
26509	1726	813443640000
26510	1874	201360000
26511	1592	720000000000
26512	1592	720010000000
26523	1726	813403636000
26524	1874	201364000
26548	1711	15839240000000
26549	1711	15839469000000
26554	1726	813343630000
26555	1874	201370000
26556	1726	813333629000
26557	1874	201371000
26558	1684	33840061000000
26559	1684	33840081000000
26573	1726	813293625000
26574	1874	201375000
26575	1850	16545320000000
26576	1850	16545330000000
26579	1726	813283624000
26580	1874	201376000
26581	633	81839390000000
26582	633	81839400000000
26620	1764	18000369000000
26623	1726	813183614000
26624	1874	201386000
26625	1694	36720310000000
26626	1694	36720320000000
26627	1726	813173613000
26628	1874	201387000
26629	1677	223925085000000
26630	1677	223925095000000
26644	1705	16555360000000
26645	1705	16555480000000
26649	1677	224645095000000
26650	1943	719000000000
26652	1694	37440320000000
26670	1726	811833609000
26671	1874	201391000
26672	1726	810533609000
26673	1944	200000000
26674	1726	810523608000
26675	1874	201392000
26676	1596	14557435000000
26677	1596	14557555000000
26690	1726	810483604000
26691	1874	201396000
26692	1677	224645105000000
26700	1637	105122596799997
26724	1726	810373595000
26725	1874	201405000
26726	603	66721200000000
26727	603	66721210000000
26730	1726	810363594000
26731	1874	201406000
26732	1668	20160340000000
26733	1668	20160350000000
26753	603	66721010000000
26754	1726	809103589000
26755	1874	201411000
26756	1850	16545530000000
26758	1690	56880831000000
26759	1690	56881041000000
26773	171	79680200000000
26774	171	79680210000000
26786	1457	19440381000000
26787	1457	19440411000000
26807	1685	61200350000000
26808	1685	61200360000000
26812	1726	808973576000
26813	1874	201424000
26814	1675	14400679999977
26815	1675	14400689999977
26830	1726	808933572000
26831	1874	201428000
26845	1419	20880460000000
26846	1419	20880470000000
26870	1726	808823561000
26871	1874	201439000
26872	1602	12960380000000
26875	1726	808813560000
26876	1874	201440000
26886	1594	12960340000000
26887	1594	12960360000000
26890	1756	18719989000000
26891	1756	18719999000000
26907	632	81120503000000
26908	1726	808703549000
26909	1874	201451000
26918	1688	112322225000000
26919	1688	112322245000000
26922	1726	808663545000
26923	1874	201455000
26924	1726	808653544000
26925	1874	201456000
26929	1683	652328219999541
26930	1683	652328229999541
26935	1690	57600841000000
26936	1726	808623541000
26937	1874	201459000
26938	576	82560520000000
26939	576	82560530000000
26971	1683	653768229999541
26972	1683	653768249999541
26979	1726	808503529000
26980	1874	201471000
26981	596	83280332000000
26982	596	83280342000000
26988	1471	18720430000000
27010	1726	808413520000
27011	1874	201480000
27012	1440	18000632000000
27013	1440	18000642000000
27021	1726	808383517000
27022	1874	201483000
27023	1522	13679950000000
27024	1522	13679960000000
27029	1726	808373516000
27030	1874	201484000
27031	1564	12960252000000
27032	1564	12960262000000
27040	1467	15121750000000
27041	1726	808343513000
27042	1874	201487000
27043	1726	808333512000
27044	1874	201488000
27065	1509	18720451000000
27066	1509	18720461000000
27071	1643	2736235113700
27072	1643	2736245113700
27115	1740	17998008000000
27131	1726	808133492000
27132	1874	201508000
27142	1726	808103489000
27143	1874	201511000
27144	1677	227525145000000
27145	1677	227525155000000
27148	1726	808093488000
27149	1874	201512000
27150	1696	14398401000000
27151	1696	14398411000000
27160	1726	808063485000
27161	1874	201515000
27162	1471	19440430000000
27163	1471	19440440000000
27164	1726	808053484000
27165	1874	201516000
27166	349	67440010000000
27167	349	67440020000000
27185	641	86160840000000
27192	1729	13679250000000
27193	1729	13679270000000
27197	1706	18716482000000
27214	1402	66242582000000
27215	1402	66242592000000
27216	1726	807973476000
27217	1874	201524000
27218	1726	807963475000
27219	1874	201525000
27241	1726	807873466000
27242	1874	201534000
27243	1726	807863465000
27244	1874	201535000
27245	1726	807853464000
27246	1874	201536000
27247	1726	807843463000
27248	1874	201537000
27249	1688	113762245000000
27250	1688	113762285000000
27266	1679	66241133000000
27267	1679	66241143000000
27300	1726	807733452000
27301	1874	201548000
27302	1726	807723451000
27303	1874	201549000
26477	1726	813543650000
26478	1874	201350000
26479	1726	813533649000
26480	1874	201351000
26481	1850	15825300000000
26482	1850	15825320000000
26495	1726	813483644000
26496	1874	201356000
26507	1727	12239282000000
26508	1727	12239292000000
26519	1726	813423638000
26520	1874	201362000
26521	1726	813413637000
26522	1874	201363000
26534	1726	813373633000
26535	1874	201367000
26536	1934	199000000
26537	1643	1296213113700
26538	1643	1296224113700
26551	1649	13680540999992
26552	1649	13680769999992
26577	1759	18720360000000
26578	1759	18720370000000
26591	1679	65521123000000
26592	1679	65521138000000
26597	1726	813253621000
26598	1874	201379000
26601	1726	813243620000
26602	1874	201380000
26603	1941	718966000000
26604	1683	640808159999541
26605	1683	640808174999541
26608	1677	223205085000000
26614	1726	813213617000
26615	1874	201383000
26616	1654	14400280000000
26617	1726	813203616000
26618	1874	201384000
26635	303	66720000000000
26636	303	66720010000000
26653	1637	105122586799997
26654	1683	643688159999541
26657	1547	8640202000000
26658	1685	60480350000000
26660	632	81120493000000
26666	1592	9000000
26667	592	66720000000000
26668	149	76800295000000
26669	149	76800296000000
26679	1726	810513607000
26680	1874	201393000
26681	1599	14400280000000
26682	1726	810503606000
26683	1874	201394000
26684	1683	645128169999541
26693	1941	718991000000
26694	43	78960400000000
26695	43	79680400000000
26703	1726	810453601000
26704	1874	201399000
26705	1715	20880242000000
26711	1691	11519291000000
26712	1691	11519301000000
26738	1726	810343592000
26739	1874	201408000
26769	1726	809073586000
26770	1874	201414000
26771	1694	38160320000000
26772	1694	38160330000000
26779	1726	809053584000
26780	1874	201416000
26781	1543	0
26782	695	66720000000000
26783	1726	809043583000
26784	1874	201417000
26785	1613	15118650000000
26788	1726	809033582000
26789	1874	201418000
26790	1549	22320556000000
26791	1549	22320566000000
26798	1402	64802562000000
26799	1402	64802572000000
26801	1726	809003579000
26802	1874	201421000
26803	1726	808993578000
26804	1874	201422000
26805	484	85440502000000
26806	484	85440512000000
26833	1726	808923571000
26834	1874	201429000
26835	1756	17999979000000
26836	1756	17999989000000
26851	1467	15121740000000
26852	1467	15121760000000
26879	1727	12959292000000
26880	1727	12959302000000
26881	1726	808803559000
26882	1874	201441000
26883	1726	808793558000
26884	1874	201442000
26885	1522	12959960000000
26894	1726	808763555000
26895	1874	201445000
26905	1726	808713550000
26906	1874	201450000
26916	1513	13680380000000
26917	1513	13680400000000
26920	1726	808673546000
26921	1874	201454000
26927	1726	808643543000
26928	1874	201457000
26931	1726	808633542000
26932	1874	201458000
26933	1673	16560770000000
26934	1673	16560780000000
26944	1726	808603539000
26945	1874	201461000
26946	1688	112322235000000
26965	1726	808533532000
26966	1874	201468000
26967	1726	808523531000
26968	1874	201469000
26969	1426	12240390000000
26970	1426	12240410000000
26973	1726	808513530000
26974	1874	201470000
26975	1677	226805135000000
26976	1677	226805145000000
26983	1726	808493528000
26984	1874	201472000
26985	1726	808483527000
26986	1874	201473000
26987	1677	226805155000000
26995	1607	23760622000000
27000	1700	14399570000000
27001	1700	14399580000000
27018	1726	808393518000
27019	1874	201482000
27037	1726	808353514000
27038	1874	201486000
27039	1426	12240400000000
27049	1688	113042235000000
27050	1688	113042245000000
27069	1726	808283507000
27070	1874	201493000
27073	1726	808273506000
27074	1874	201494000
27075	1726	808263505000
27076	1874	201495000
27077	1726	808253504000
27078	1874	201496000
27079	1726	808243503000
27080	1874	201497000
27081	1726	808233502000
27082	1874	201498000
27083	1726	808223501000
27084	1874	201499000
27085	1726	808213500000
27086	1874	201500000
27087	1726	808203499000
27088	1874	201501000
27089	1740	17277988000000
27090	1726	808193498000
27091	1874	201502000
27092	1480	709918000000
27093	1904	1000000000
27094	1480	708917000000
27095	1904	2000000000
27096	1480	707916000000
27097	1908	1000000000
27098	1480	706915000000
27099	1909	1000000000
27100	1480	705914000000
27101	1910	1000000000
27102	1480	704913000000
27103	1911	1000000000
27104	1480	703912000000
27105	1912	1000000000
27106	1480	702911000000
27107	1913	1000000000
27108	1480	701910000000
27109	1917	1000000000
27110	1480	700909000000
27111	1946	1000000000
27112	1740	17997988000000
26513	1726	813433639000
26514	1874	201361000
26515	1677	223205070000000
26516	1677	223205080000000
26525	1455	18720311000000
26526	1455	18720321000000
26532	1726	813383634000
26533	1874	201366000
26550	1699	5254329000078
26560	632	80400493000000
26583	1613	15118620000000
26584	1613	15118630000000
26586	1726	813273623000
26587	1874	201377000
26588	904	114218749973438
26589	1941	718971000000
26590	1634	16560304899999
26593	1726	813263622000
26594	1874	201378000
26595	1700	13679560000000
26596	1700	13679570000000
26611	1726	813223618000
26612	1874	201382000
26613	1675	13680679999977
26631	1726	813163612000
26632	1874	201388000
26633	1690	56160821000000
26634	1690	56160831000000
26648	102	66720000000000
26655	1668	19440340000000
26656	1698	23759451000000
26659	1683	645128159999541
26687	1726	810493605000
26688	1874	201395000
26689	1698	23759461000000
26696	1726	810473603000
26697	1874	201397000
26698	1683	646568169999541
26699	1683	646568179999541
26701	1726	810463602000
26702	1874	201398000
26710	1402	64082562000000
26734	1726	810353593000
26735	1874	201407000
26736	1489	16560561000000
26737	1489	16560571000000
26746	1689	16559342000000
26747	1689	16559362000000
26751	1719	14399280000000
26752	1719	14399290000000
26766	1691	11519311000000
26775	1726	809063585000
26776	1874	201415000
26777	1749	13675298000000
26778	1749	13675308000000
26792	1726	809023581000
26793	1874	201419000
26794	1656	20880421000000
26795	1656	20880431000000
26796	1726	809013580000
26797	1874	201420000
26800	1690	56880841000000
26809	1726	808983577000
26810	1874	201423000
26811	44	80400890000000
26818	1681	23759515195920
26819	1681	23759525195920
26826	1726	808943573000
26827	1874	201427000
26828	1683	649448189999541
26829	1683	649448199999541
26841	1726	808903569000
26842	1874	201431000
26843	1683	650888199999541
26844	1683	650888209999541
26856	1726	808863565000
26857	1874	201435000
26858	1726	808853564000
26859	1874	201436000
26860	1449	10023000459
26861	1939	709000000000
26862	1587	16560310000000
26863	1587	16560331000000
26864	1726	808843563000
26865	1874	201437000
26866	1726	808833562000
26867	1874	201438000
26868	1749	14395308000000
26869	1749	14395328000000
26888	1726	808783557000
26889	1874	201443000
26892	1726	808773556000
26893	1874	201444000
26940	1726	808613540000
26941	1874	201460000
26942	1850	17265530000000
26943	1850	17265540000000
26951	1726	808583537000
26952	1874	201463000
26953	1685	61920360000000
26954	1685	61920370000000
26955	1726	808573536000
26956	1874	201464000
26959	1726	808553534000
26960	1874	201466000
26961	1726	808543533000
26962	1874	201467000
26963	44	81120890000000
26964	44	81120910000000
26977	1692	23779854000000
26978	1692	23779864000000
26989	1726	808473526000
26990	1874	201474000
26991	1726	808463525000
26992	1874	201475000
26993	1683	655208249999541
26994	1683	655208269999541
26996	1726	808453524000
26997	1874	201476000
26998	1607	24480622000000
26999	1607	24480632000000
27006	1726	808423521000
27007	1874	201479000
27008	1719	15119290000000
27009	1719	15119300000000
27025	603	66001000000000
27026	1708	10800280000000
27027	1708	11520280000000
27028	1708	11520842000000
27053	1749	15115328000000
27054	1749	15115338000000
27061	1726	808303509000
27062	1874	201491000
27063	1683	659528289999541
27064	1683	659528299999541
27067	1726	808293508000
27068	1874	201492000
27127	1726	808143493000
27128	1874	201507000
27129	58	84001215000000
27130	58	84721215000000
27139	1513	14400400000000
27140	1513	14400420000000
27146	1402	65522572000000
27147	1402	65522582000000
27152	1882	720200000000
27153	1882	720210000000
27156	1726	808073486000
27157	1874	201514000
27158	641	86160820000000
27159	641	86160830000000
27168	349	67440030000000
27177	1726	808043483000
27178	1874	201517000
27179	1726	808033482000
27180	1874	201518000
27181	1593	18000551000000
27182	1593	18000571000000
27194	1729	12960290000000
27195	1729	13680290000000
27196	1729	13680560000000
27198	1522	14399960000000
27208	1726	807983477000
27209	1874	201523000
27210	1678	8640234813000
27211	1678	8640244813000
27220	1726	807953474000
27221	1874	201526000
27222	1726	807943473000
27223	1874	201527000
27224	1726	807933472000
27225	1874	201528000
27226	1726	807923471000
27227	1874	201529000
27228	1726	807913470000
27229	1874	201530000
27230	1726	807903469000
27231	1874	201531000
27232	1711	15839300000000
27251	1726	807833462000
27252	1874	201538000
27253	1699	5974110000078
27254	1699	5974120000078
27262	1739	14399500000000
27263	1739	14399520000000
27113	1761	17998007999999
27114	1740	10000003
27116	1726	808183497000
27117	1874	201503000
27118	1726	808173496000
27119	1874	201504000
27120	1726	808163495000
27121	1874	201505000
27122	1708	12240842000000
27123	1708	12241073000000
27186	1726	808023481000
27187	1874	201519000
27188	1726	808013480000
27189	1874	201520000
27190	1693	9353617553123
27191	1693	9353637553123
27199	1419	21600470000000
27200	238	66000190000000
27201	1726	808003479000
27202	1874	201521000
27203	1677	227525165000000
27212	1762	11519240000000
27213	1762	11519250000000
27233	1726	807893468000
27234	1874	201532000
27235	1726	807883467000
27236	1874	201533000
27237	1457	20160411000000
27238	1457	20160431000000
27255	1683	662408349999541
27256	1683	662408359999541
27264	1726	807813460000
27265	1874	201540000
27274	1726	807803459000
27275	1874	201541000
27276	1746	5759121000000
27277	1746	5759131000000
27280	1747	8638710000000
27286	1726	807773456000
27287	1874	201544000
27288	1610	19440700000000
27289	1610	19440710000000
27314	1693	10073637553123
27317	470	85440431000000
27328	1698	24479461000000
27329	1698	24479471000000
27341	1397	1391475281000
27342	1678	8640244819000
27343	58	85440815000000
27344	58	85440825000000
27350	1696	14398421000000
27360	1678	8640244821000
27361	1683	663848369999541
27362	1683	663848379999541
27365	1397	1391435277000
27366	1678	8640244823000
27374	1397	1391405274000
27375	1678	8640244826000
27376	1705	17275480000000
27377	1705	17275490000000
27390	1650	10800290000000
27391	1650	10800300000000
27404	1397	1391325266000
27405	1678	8640244834000
27406	1397	1391315265000
27407	1678	8640244835000
27408	1700	14399590000000
27428	1397	1391235257000
27429	1678	8640244843000
27454	1397	1391165250000
27455	1678	8640244850000
27456	1726	806463446000
27457	1874	201554000
27458	1705	17995490000000
27459	1705	17995510000000
27492	1723	16560121000000
27512	1684	34560041000000
27513	208	66000010000000
27514	1726	806393439000
27515	1874	201561000
27516	1726	806383438000
27517	1874	201562000
27518	1726	806373437000
27519	1874	201563000
27520	1397	1391095243000
27521	1678	8640244857000
27522	1397	1391085242000
27523	1678	8640244858000
27524	1397	1391075241000
27525	1678	8640244859000
27526	1560	26640670000000
27527	1560	26640740000000
27546	1688	113762295000000
27547	1688	114482295000000
27552	1397	1391035237000
27553	1678	8640244863000
27554	1726	806333433000
27555	1874	201567000
27556	1677	228965174999992
27557	1514	228965194998092
27558	1677	1900
27566	1683	666728399999541
27567	1683	666728419999541
27614	1397	1390925226000
27615	1678	8640244874000
27616	1726	806223422000
27617	1874	201578000
27642	1726	806183418000
27643	1874	201582000
27644	1397	1390885222000
27645	1678	8640244878000
27662	1726	806153415000
27663	1874	201585000
27664	1677	229685195000000
27665	1677	229685215000000
27675	1397	1390835217000
27676	1678	8640244883000
27677	1726	806133413000
27678	1874	201587000
27679	1688	115202305000000
27680	1688	115202325000000
27703	1397	1390795213000
27704	1678	8640244887000
27705	1726	806093409000
27706	1874	201591000
27715	1397	1390775211000
27716	1678	8640244889000
27717	1397	1390765210000
27718	1678	8640244890000
27719	1397	1390755209000
27720	1678	8640244891000
27721	1726	806073407000
27722	1874	201593000
27723	1726	806063406000
27724	1874	201594000
27725	1726	806053405000
27726	1874	201595000
27727	1599	14400330000000
27741	1397	1390725206000
27742	1678	8640244894000
27743	1726	806023402000
27744	1874	201598000
27745	576	83280530000000
27746	576	83280550000000
27749	1726	806013401000
27750	1874	201599000
27751	1397	1390715205000
27752	1678	8640244895000
27753	1560	28080760000000
27754	1560	28080780000000
27768	606	78240290000000
27769	606	78960290000000
27785	1718	12237469000000
27786	1718	12237489000000
27787	1726	803563398000
27788	1874	201602000
27789	1397	1390685202000
27790	1678	8640244898000
27795	1397	1390675201000
27796	1678	8640244899000
27797	1397	1390665200000
27798	1678	8640244900000
27799	1726	803553397000
27800	1874	201603000
27801	1726	803543396000
27802	1874	201604000
27803	1677	230405215000000
27804	1677	230405255000000
27809	1709	16557471000000
27810	1709	16557511000000
27811	1726	803533395000
27812	1874	201605000
27813	1726	803523394000
27814	1874	201606000
27815	1397	1390655199000
27816	1678	8640244901000
27817	1397	1390645198000
27818	1678	8640244902000
27819	1714	23029370000000
27820	1714	23029410000000
27833	1633	14400200000000
27845	1726	803473389000
27846	1874	201611000
27847	1397	1390595193000
27848	1678	8640244907000
27137	1683	660968329999541
27138	1683	660968349999541
27141	1688	113042255000000
27154	1726	808083487000
27155	1874	201513000
27169	349	66720290000000
27170	349	67440290000000
27171	1440	200000040
27172	1938	17280642000000
27173	1761	66000000990000
27174	646	10000004
27175	349	200000001
27176	1855	67441599009957
27183	1634	18000324899999
27184	1634	18000344899999
27204	1726	807993478000
27205	1874	201522000
27206	1694	38880330000000
27207	1694	38880340000000
27239	1715	21600242000000
27240	1715	21600262000000
27257	1756	1836499808900
27258	1516	16883489191100
27259	1726	807823461000
27260	1874	201539000
27261	1683	662408369999541
27270	43	80400350000000
27271	43	80400360000000
27272	606	78960250000000
27273	606	78960260000000
27290	1726	807763455000
27291	1874	201545000
27292	1726	807753454000
27293	1874	201546000
27294	1726	807743453000
27295	1874	201547000
27296	238	66000160000000
27297	441	66000020000000
27298	369	85440472000000
27299	369	85440512000000
27332	1678	7920234814000
27333	1678	7920234815000
27334	1678	7920234816000
27335	1678	7920234817000
27336	1768	10799781110000
27337	1768	11519781110000
27338	1768	11520132110000
27367	1397	1391425276000
27368	1678	8640244824000
27369	1397	1391415275000
27370	1678	8640244825000
27371	1684	35280061000000
27372	1684	35280081000000
27388	1397	1391375271000
27389	1678	8640244829000
27392	1397	1391365270000
27393	1678	8640244830000
27394	1397	1391355269000
27395	1678	8640244831000
27396	1397	1391345268000
27397	1678	8640244832000
27398	1397	1391335267000
27399	1678	8640244833000
27400	640	66000009000000
27401	1422	13680220000000
27402	1422	13680261000000
27409	1397	1391305264000
27410	1678	8640244836000
27411	1560	25920660000000
27412	1560	25920670000000
27413	1397	1391295263000
27414	1678	8640244837000
27415	1397	1391285262000
27416	1678	8640244838000
27417	1397	1391275261000
27418	1678	8640244839000
27419	1397	1391265260000
27420	1678	8640244840000
27421	1555	11520180000000
27422	1555	11520220000000
27430	1397	1391225256000
27431	1678	8640244844000
27432	1693	10793637553123
27433	1693	10793647553123
27434	1397	1391215255000
27435	1678	8640244845000
27436	1397	1391205254000
27437	1678	8640244846000
27438	1397	1391195253000
27439	1678	8640244847000
27440	1397	1391185252000
27441	1678	8640244848000
27442	1397	1391175251000
27443	1678	8640244849000
27444	1726	807693448000
27445	1874	201552000
27446	1726	806483448000
27447	1947	200000000
27448	1726	806473447000
27449	1874	201553000
27450	1677	228965175000000
27451	1677	228965255000000
27508	1759	19440370000000
27509	1759	19440410000000
27528	1571	12240161000024
27529	1690	59040952999984
27535	1726	806353435000
27536	1874	201565000
27537	1397	1391055239000
27538	1678	8640244861000
27539	43	81840380000000
27540	43	81840400000000
27548	1726	806343434000
27549	1874	201566000
27550	1546	16560310000000
27551	1546	16560320000000
27588	1726	806273427000
27589	1874	201573000
27590	1397	1390975231000
27591	1678	8640244869000
27592	1683	668168419999541
27593	1683	668168439999541
27626	1397	1390905224000
27627	1678	8640244876000
27628	1726	806203420000
27629	1874	201580000
27630	1451	11520320000000
27631	1451	11520340000000
27656	1692	24499864000000
27657	1692	24499884000000
27666	1683	672488499999541
27667	1683	672488519999541
27681	1726	806123412000
27682	1874	201588000
27683	1397	1390825216000
27684	1678	8640244884000
27685	1670	20880630000000
27686	1670	20880650000000
27687	1726	806113411000
27688	1874	201589000
27689	1397	1390815215000
27690	1678	8640244885000
27691	1709	15837471000000
27728	1689	16559402000000
27747	1650	11520300000000
27748	1650	11520320000000
27755	1726	806003400000
27756	1874	201600000
27757	1726	804793400000
27758	1948	200000000
27759	1397	1390705204000
27760	1678	8640244896000
27761	1726	803583400000
27762	1949	200000000
27763	43	81840440000000
27764	1420	720000110000
27765	43	82560439890000
27770	1397	1390695203000
27771	1678	8640244897000
27772	1726	803573399000
27773	1874	201601000
27774	1718	12237468999992
27775	1894	720000220000
27776	1420	205000000
27777	1571	12237483889008
27778	1718	12240161001000
27838	1683	676808559999541
27839	1683	676808569999541
27877	1397	1390545188000
27878	1678	8640244912000
27879	1727	12959322000000
27880	1397	1390535187000
27881	1678	8640244913000
27882	1726	803413383000
27883	1874	201617000
27884	1683	678248569999541
27885	1683	678248589999541
27914	1685	62640400000000
27915	1726	800953379000
27916	1874	201621000
27917	1397	1390495183000
27918	1678	8640244917000
27919	1616	2160050000000
28001	1726	799613366000
28002	1874	201634000
27268	1633	14400180000000
27269	1633	14400190000000
27278	42	79677950000000
27279	42	79677960000000
27281	1726	807793458000
27282	1874	201542000
27283	1726	807783457000
27284	1874	201543000
27285	1681	23759535195920
27306	1726	807713450000
27307	1874	201550000
27308	1422	12960210000000
27309	1422	12960220000000
27310	1726	807703449000
27311	1874	201551000
27312	1506	15120330000000
27313	1506	15120340000000
27316	1549	23040566000000
27324	1397	1391505284000
27325	1678	8640244816000
27326	1522	15119960000000
27327	1522	15119970000000
27330	1397	1391495283000
27331	1678	8640244817000
27345	1397	1391465280000
27346	1678	8640244820000
27347	441	66000010000000
27348	369	86160512000000
27349	369	86160532000000
27351	1756	1116489808900
27352	1678	7920234818000
27353	1678	7920234819000
27354	1678	7920234820000
27355	1397	1391455279000
27356	1678	7920234821000
27357	1690	57600953000000
27358	1571	12240161000016
27359	1690	58320952999992
27373	1679	66241153000000
27380	1677	228245165000000
27381	1677	228245175000000
27384	1397	1391385272000
27385	1678	8640244828000
27386	1637	106562636799997
27387	1637	106562646799997
27473	1755	2879050000000
27474	1755	2879070000000
27483	1726	806443444000
27484	1874	201556000
27485	1726	806433443000
27486	1874	201557000
27487	1397	1391145248000
27488	1678	8640244852000
27489	1397	1391135247000
27490	1678	8640244853000
27491	1684	35280101000000
27498	1726	806413441000
27499	1874	201559000
27500	1726	806403440000
27501	1874	201560000
27502	1397	1391115245000
27503	1678	8640244855000
27504	1397	1391105244000
27505	1678	8640244856000
27506	1683	665288379999541
27507	1683	665288419999541
27561	1726	806323432000
27562	1874	201568000
27563	1397	1391025236000
27564	1678	8640244864000
27565	1677	228965195000000
27582	1726	806283428000
27583	1874	201572000
27584	1397	1390985232000
27585	1678	8640244868000
27586	1611	14390230000000
27587	1611	14390250000000
27604	1726	806243424000
27605	1874	201576000
27606	1726	806233423000
27607	1874	201577000
27608	1397	1390945228000
27609	1678	8640244872000
27610	1397	1390935227000
27611	1678	8640244873000
27612	1657	15120250000000
27613	1657	15120290000000
27624	1683	671048479999541
27625	1683	671048499999541
27634	1637	107282646799997
27635	1637	107282666799997
27636	1397	1390895223000
27637	1678	8640244877000
27638	1726	806193419000
27639	1874	201581000
27640	1573	21600740000000
27641	1573	21600760000000
27652	1726	806163416000
27653	1874	201584000
27654	1397	1390865220000
27655	1678	8640244880000
27658	1397	1390855219000
27659	1678	8640244881000
27660	1680	24479470000000
27661	1680	24479480000000
27668	1680	24479490000000
27696	1402	67682612000000
27697	1402	67682632000000
27698	1679	66961153000000
27699	1679	66961173000000
27701	1703	10079490000000
27702	1703	10079510000000
27709	1397	1390785212000
27710	1678	8640244888000
27711	1726	806083408000
27712	1874	201592000
27713	1683	673928519999541
27714	1683	673928539999541
27729	1726	806043404000
27730	1874	201596000
27731	1397	1390745208000
27732	1678	8640244892000
27733	1683	675368539999541
27734	1683	675368559999541
27735	1726	806033403000
27736	1874	201597000
27737	1397	1390735207000
27738	1678	8640244893000
27739	1560	27360740000000
27740	1560	27360760000000
27782	1894	14675327999008
27783	1474	205000000
27784	1571	12240161001000
27793	1501	300000000
27794	1690	60480752999984
27807	1718	12957483889008
27808	1718	12957523889008
27827	1397	1390625196000
27828	1678	8640244904000
27829	1726	803503392000
27830	1874	201608000
27831	1685	62640370000000
27832	1685	62640390000000
27834	1726	803493391000
27835	1874	201609000
27836	1397	1390615195000
27837	1678	8640244905000
27850	576	84000550000000
27876	235	66720010000000
27905	1397	1390505184000
27906	1678	8640244916000
27907	1726	800973381000
27908	1949	2600000000
27909	1726	800963380000
27910	1874	201620000
27911	1608	13680340000000
27912	1608	13680370000000
27930	1397	1390465180000
27931	1678	8640244920000
27932	1726	800923376000
27933	1874	201624000
27934	1656	20880441000000
27935	436	66718550000000
27936	806	1222212232776490
27937	1397	1390455179000
27938	1678	8640244921000
27939	1726	800913375000
27940	1874	201625000
27941	641	86160850000000
27942	1397	1390445178000
27943	1678	8640244922000
27944	1726	800903374000
27945	1874	201626000
27946	1726	800893373000
27947	1874	201627000
27948	1397	1390435177000
27949	1678	8640244923000
27950	1726	800883372000
27951	1874	201628000
27952	1397	1390425176000
27953	1678	8640244924000
27954	1447	20880490000000
27955	1447	20880550000000
27960	1679	67681173000000
27961	1679	67681233000000
27304	1699	6694120000078
27305	1699	6694140000078
27315	1684	34560061000000
27318	1397	1391525286000
27319	1678	8640244814000
27320	1397	1391515285000
27321	1678	8640244815000
27322	1573	20880720000000
27323	1573	20880740000000
27339	1397	1391485282000
27340	1678	8640244818000
27363	1397	1391445278000
27364	1678	8640244822000
27378	1397	1391395273000
27379	1678	8640244827000
27382	1701	15838392000000
27383	1701	15838402000000
27403	1547	8640243000000
27423	1397	1391255259000
27424	1678	8640244841000
27425	1397	1391245258000
27426	1678	8640244842000
27427	1686	8852096500013
27452	44	81840910000000
27453	44	81840990000000
27460	1678	7200224814000
27461	1756	396479808900
27462	1678	7200224815000
27463	1678	7200224816000
27464	1678	7200224817000
27465	1678	7200224818000
27466	1678	7200224819000
27467	1678	7200224820000
27468	1678	7200224821000
27469	1678	7200224822000
27470	1755	2159780000000
27471	1755	2879780000000
27472	1755	2880600000000
27475	1726	806453445000
27476	1874	201555000
27477	1397	1391155249000
27478	1678	8640244851000
27479	1476	18000350000000
27480	1476	18000370000000
27481	43	81120360000000
27482	43	81120380000000
27493	1726	806423442000
27494	1874	201558000
27495	1397	1391125246000
27496	1678	8640244854000
27497	1649	13680560999992
27510	1451	10800280000000
27511	1451	10800320000000
27530	1397	1391065240000
27531	1678	8640244860000
27532	1726	806363436000
27533	1874	201564000
27534	1683	665288399999541
27541	1397	1391045238000
27542	1678	8640244862000
27543	1546	15840310000000
27544	1520	100000000
27545	1546	16560210000000
27559	1594	13680360000000
27560	1594	13680380000000
27568	1726	806313431000
27569	1874	201569000
27570	1397	1391015235000
27571	1678	8640244865000
27572	1726	806303430000
27573	1874	201570000
27574	1726	806293429000
27575	1874	201571000
27576	1397	1391005234000
27577	1678	8640244866000
27578	1397	1390995233000
27579	1678	8640244867000
27580	1598	2160020000000
27581	1598	2160080000000
27594	1397	1390965230000
27595	1678	8640244870000
27596	1397	1390955229000
27597	1678	8640244871000
27598	1726	806263426000
27599	1874	201574000
27600	1726	806253425000
27601	1874	201575000
27602	1683	669608439999541
27603	1683	669608479999541
27618	1397	1390915225000
27619	1678	8640244875000
27620	1726	806213421000
27621	1874	201579000
27622	1402	66962592000000
27623	1402	66962612000000
27632	1716	20159381000000
27633	1716	20159401000000
27646	1726	806173417000
27647	1874	201583000
27648	1397	1390875221000
27649	1678	8640244879000
27650	1688	114482285000000
27651	1688	114482305000000
27669	1726	806143414000
27670	1874	201586000
27671	1397	1390845218000
27672	1678	8640244882000
27673	1686	9572096500013
27674	1686	9572116500013
27692	1397	1390805214000
27693	1678	8640244886000
27694	1726	806103410000
27695	1874	201590000
27700	1702	9354161000000
27707	1692	25219884000000
27708	1692	25219904000000
27766	255	66001000000000
27767	43	82559440000000
27779	1474	200000004
27780	1938	14675332999308
27781	1571	12240161000696
27791	1501	200000000
27792	1690	59760852999984
27805	1402	68402632000000
27806	1402	68402672000000
27821	1726	803513393000
27822	1874	201607000
27823	1397	1390635197000
27824	1678	8640244903000
27825	632	82560513000000
27826	632	82560533000000
27840	1726	803483390000
27841	1874	201610000
27842	1397	1390605194000
27843	1678	8640244906000
27844	1698	24479491000000
27860	1397	1390565190000
27861	1678	8640244910000
27862	1726	803443386000
27863	1874	201614000
27864	1422	14400261000000
27865	1422	14400281000000
27872	1726	803423384000
27873	1874	201616000
27874	235	66720000000000
27875	235	66720030000000
27890	1726	803403382000
27891	1874	201618000
27892	1397	1390525186000
27893	1678	8640244914000
27894	1716	20879431000000
27897	1397	1390515185000
27898	1678	8640244915000
27899	1726	802193382000
27900	1949	1400000000
27901	1726	802183381000
27902	1874	201619000
27903	1689	17279402000000
27904	1689	17279432000000
27920	1397	1390485182000
27921	1678	8640244918000
27922	1726	800943378000
27923	1874	201622000
27924	1726	800933377000
27925	1874	201623000
27926	1397	1390475181000
27927	1678	8640244919000
27928	1683	679688599999541
27929	1683	679688639999541
27958	1691	12239301000000
27959	1691	12239361000000
27985	1397	1390385172000
27986	1678	8640244928000
27987	1726	799633368000
27988	1874	201632000
27989	1489	17280571000000
27990	1489	17280591000000
27993	806	1222212187776490
27994	1726	799623367000
27995	1874	201633000
27996	1397	1390375171000
27997	1678	8640244929000
27998	1677	231125255000000
27999	1677	231125540000000
28018	1726	799593364000
27849	171	79680220000000
27851	1726	803463388000
27852	1874	201612000
27853	1397	1390585192000
27854	1678	8640244908000
27855	1397	1390575191000
27856	1678	8640244909000
27857	1726	803453387000
27858	1874	201613000
27859	576	84000590000000
27866	1726	803433385000
27867	1874	201615000
27868	1397	1390555189000
27869	1678	8640244911000
27870	1423	4320080000000
27871	1423	4320100000000
27886	1474	13854303000000
27887	1950	100000000000
27888	1716	20879401000000
27889	1716	20879441000000
27895	1501	400000000
27896	1690	61200652999984
27913	1683	678248599999541
27956	1474	14574303000000
27957	1474	14574363000000
27963	1948	100000000
27964	1713	560000000
27965	1726	800873371000
27966	1874	201629000
27967	1397	1390415175000
27968	1678	8640244925000
27969	632	83280533000000
27970	632	83280603000000
27971	1726	799663371000
27972	1951	200000000
27973	1397	1390405174000
27974	1678	8640244926000
27975	1726	799653370000
27976	1874	201630000
27977	1726	799643369000
27978	1874	201631000
27979	1397	1390395173000
27980	1678	8640244927000
27981	436	66718320000000
27982	806	1222212452776490
27983	1611	15110250000000
27984	1611	15110310000000
28015	1692	25939904000000
28016	1934	25939943999999
28017	1692	1
28033	1633	15120200000000
28034	1633	15120260000000
28042	1397	1390305164000
28043	1678	8640244936000
28044	1726	799553360000
28045	1874	201640000
28046	1607	25200632000000
28047	1607	25200662000000
28054	606	78960270000000
28062	1677	231845540000000
28063	1677	231845560000000
28071	1726	799513356000
28072	1874	201644000
28073	1397	1390265160000
28074	1678	8640244940000
28092	1397	1390225156000
28093	1678	8640244944000
28094	1726	799473352000
28095	1874	201648000
28096	1688	115922325000000
28097	1688	115922345000000
28116	1726	799443349000
28117	1874	201651000
28118	1726	799433348000
28119	1874	201652000
28120	1397	1390195153000
28121	1678	8640244947000
28122	1397	1390185152000
28123	1678	8640244948000
28124	1677	231845580000000
28149	1716	21599431000000
28150	1716	21599481000000
28163	243	68880050000000
28164	243	68880090000000
28184	1397	1390075141000
28185	1678	8640244959000
28186	1726	799323337000
28187	1874	201663000
28188	484	85440522000000
28224	1740	18718008000000
28228	1692	25939924000000
28246	1726	799223327000
28247	1874	201673000
28248	1726	799213326000
28249	1874	201674000
28250	1700	15119670000000
28252	171	79680240000000
28261	1726	797983324000
28262	1874	201676000
28263	1397	1389945128000
28264	1678	8640244972000
28280	1397	1389905124000
28281	1678	8640244976000
28282	1726	797943320000
28283	1874	201680000
28284	1677	233285660000000
28285	1677	233285680000000
28302	1397	1389865120000
28303	1678	8640244980000
28304	1726	797903316000
28305	1874	201684000
28306	1688	116642355000000
28307	1688	116642375000000
28322	1397	1389835117000
28323	1678	8640244983000
28324	1397	1389825116000
28325	1678	8640244984000
28326	1726	797873313000
28327	1874	201687000
28328	1726	797863312000
28329	1874	201688000
28330	485	66717999000000
28331	1569	1810000000
28332	1509	19440461000000
28333	1509	19440502000000
28350	1397	1389795113000
28351	1678	8640244987000
28352	1726	797833309000
28353	1874	201691000
28354	1726	797823308000
28355	1874	201692000
28356	1397	1389785112000
28357	1678	8640244988000
28358	1515	10603400
28359	409	66000001000000
28360	1683	691208839999541
28361	1683	691208880999541
28380	1726	797783304000
28381	1874	201696000
28382	1397	1389745108000
28383	1678	8640244992000
28384	1683	692648880999541
28385	1683	692648900999541
28401	1726	797753301000
28402	1874	201699000
28403	1726	797743300000
28404	1874	201700000
28405	1397	1389715105000
28406	1678	8640244995000
28407	1397	1389705104000
28408	1678	8640244996000
28409	1683	692648920999541
28429	1672	15840402000000
28430	1672	15840422000000
28437	1726	797683294000
28438	1874	201706000
28439	149	76800306000000
28440	1397	1389645098000
28441	1678	8640245002000
28442	1397	1389635097000
28443	1678	8640245003000
28444	1726	797673293000
28445	1874	201707000
28446	149	77520306000000
28447	149	77520336000000
28470	1868	3880000000
28471	724	20003750000000
28472	1726	795213289000
28473	1874	201711000
28474	1397	1389595093000
28475	1678	8640245007000
28476	1724	20878980000000
28477	1724	20879100000000
28539	1726	795113279000
28540	1874	201721000
28541	1397	1389495083000
28542	1678	8640245017000
28543	1397	1389485082000
28544	1678	8640245018000
28545	1726	795103278000
28546	1874	201722000
28547	1718	12857522889008
28548	1474	14674323000000
28549	1677	234005741000000
28561	1726	795073275000
27962	1623	26641740899898
27991	1673	17280780000000
27992	1673	17280800000000
28000	1423	4320365000000
28031	1560	28800780000000
28032	1560	28800840000000
28060	1683	681128639999541
28061	1683	681128659999541
28065	1397	1390275161000
28066	1678	8640244939000
28067	1726	799523357000
28068	1874	201643000
28069	1594	14400380000000
28070	1594	14400400000000
28081	1726	799493354000
28082	1874	201646000
28083	1397	1390245158000
28084	1678	8640244942000
28085	1683	682568659999541
28086	1683	682568679999541
28107	1708	11519480000000
28108	1708	11519500000000
28130	1694	38880350000000
28153	1726	799383343000
28154	1874	201657000
28155	1397	1390125146000
28156	1678	8640244954000
28157	1397	1390115145000
28158	1678	8640244955000
28159	1726	799373342000
28160	1874	201658000
28161	1601	11881236600000
28162	1601	11881276600000
28174	1726	799343339000
28175	1874	201661000
28176	1397	1390095143000
28177	1678	8640244957000
28178	1397	1390085142000
28179	1678	8640244958000
28180	1726	799333338000
28181	1874	201662000
28182	1610	20160710000000
28183	1610	20160750000000
28213	1397	1390015135000
28214	1678	8640244965000
28215	1726	799263331000
28216	1874	201669000
28217	1683	686888719999541
28218	1683	686888739999541
28219	1726	799253330000
28220	1874	201670000
28221	1397	1390005134000
28222	1678	8640244966000
28223	1599	14400290000000
28227	1740	18718028000000
28240	1397	1389975131000
28241	1678	8640244969000
28242	1397	1389965130000
28243	1678	8640244970000
28244	1700	15119590000000
28245	1700	15119610000000
28260	1688	115922355000000
28310	1726	797893315000
28311	1874	201685000
28312	1397	1389855119000
28313	1678	8640244981000
28314	1536	17280420000000
28336	1726	797853311000
28337	1874	201689000
28338	1397	1389815115000
28339	1678	8640244985000
28340	1711	17279320000000
28341	1711	17279340000000
28344	1397	1389805114000
28345	1678	8640244986000
28346	1726	797843310000
28347	1874	201690000
28348	1719	15839300000000
28349	1719	15839320000000
28394	724	20000750000000
28395	1397	1389725106000
28396	1678	8640244994000
28397	1726	797763302000
28398	1874	201698000
28399	1668	20880350000000
28400	1668	20880620000000
28449	1397	1389625096000
28450	1678	8640245004000
28451	1397	1389615095000
28452	1678	8640245005000
28453	1726	797663292000
28454	1874	201708000
28455	1726	797653291000
28456	1874	201709000
28457	1726	796443291000
28458	1954	200000000
28459	1726	795233291000
28460	1955	200000000
28461	1559	18720540000000
28480	1397	1389585092000
28481	1678	8640245008000
28482	1726	795203288000
28483	1874	201712000
28484	1611	15830310000000
28485	1611	15830330000000
28494	1692	27379962020000
28495	1692	27380102020000
28500	724	20002750000000
28501	1726	795173285000
28502	1874	201715000
28503	1397	1389555089000
28504	1678	8640245011000
28505	1683	695529060999541
28506	1683	695530080999541
28522	1677	233285700000000
28525	1726	795133281000
28526	1874	201719000
28527	1726	795123280000
28528	1874	201720000
28529	1397	1389515085000
28530	1678	8640245015000
28531	1397	1389505084000
28532	1678	8640245016000
28533	1677	234005700000000
28534	1677	234005740000000
28552	1397	1389475081000
28553	1678	8640245019000
28554	1726	795093277000
28555	1874	201723000
28556	1677	234005720000000
28557	1726	795083276000
28558	1874	201724000
28559	1397	1389465080000
28560	1678	8640245020000
28577	1718	12137482889008
28578	1474	13954303000000
28579	1623	29523222899898
28580	1623	29523223899898
28593	1397	1389405074000
28594	1678	8640245026000
28595	1397	1389395073000
28596	1678	8640245027000
28597	1726	795023270000
28598	1874	201730000
28599	1726	795013269000
28600	1874	201731000
28601	1941	717951000000
28602	1957	10000000
28603	1683	699850140999541
28604	1683	699850185999541
28606	1397	1389385072000
28607	1678	8640245028000
28608	1726	795003268000
28609	1874	201732000
28610	1439	11520210000000
28611	1397	1389375071000
28612	1678	8640245029000
28613	1397	1389365070000
28614	1678	8640245030000
28615	1397	1389355069000
28616	1678	8640245031000
28617	1726	794993267000
28618	1874	201733000
28619	1726	794983266000
28620	1874	201734000
28621	1726	794973265000
28622	1874	201735000
28623	1688	117362375000000
28624	1688	117362435000000
28643	1677	235445740000000
28644	1677	235445760000000
28651	1726	794933261000
28652	1874	201739000
28653	1397	1389315065000
28654	1678	8640245035000
28670	1850	17265550000000
28671	1397	1389285062000
28672	1678	8640245038000
28673	1726	794903258000
28674	1874	201742000
28675	1726	794893257000
28676	1874	201743000
28677	1397	1389275061000
28678	1678	8640245039000
28679	1560	28800839000000
28003	1726	799603365000
28004	1874	201635000
28005	1397	1390365170000
28006	1678	8640244930000
28007	1397	1390355169000
28008	1678	8640244931000
28009	1938	200000004
28010	641	86880849999996
28011	641	200000040
28012	1938	86880889999960
28013	641	86880850000000
28014	641	86880890000000
28035	1397	1390315165000
28036	1678	8640244935000
28037	1726	799563361000
28038	1874	201639000
28039	1933	1439011000000
28040	1933	1439021000000
28055	1726	799533358000
28056	1874	201642000
28057	1397	1390285162000
28058	1678	8640244938000
28059	1746	5759141000000
28064	1747	8638720000000
28087	1397	1390235157000
28088	1678	8640244943000
28089	1726	799483353000
28090	1874	201647000
28091	415	66720020000000
28098	1683	684008679999541
28099	1683	684008699999541
28109	1397	1390205154000
28110	1678	8640244946000
28111	1726	799453350000
28112	1874	201650000
28113	1474	14574323000000
28131	1397	1390165150000
28132	1678	8640244950000
28133	1726	799413346000
28134	1874	201654000
28135	1689	17999432000000
28136	1689	17999452000000
28137	1623	26641770899898
28225	1756	2556499808900
28226	1756	2556519808900
28229	1726	799243329000
28230	1874	201671000
28231	1397	1389995133000
28232	1678	8640244967000
28233	1397	1389985132000
28234	1678	8640244968000
28235	1726	799233328000
28236	1874	201672000
28237	1692	26659924000000
28238	1692	66000001980000
28239	646	26659962020000
28251	1700	15119630000000
28265	1397	1389935127000
28266	1678	8640244973000
28267	1726	797973323000
28268	1874	201677000
28269	1455	18720331000000
28286	1724	20158960000000
28287	1724	20158980000000
28308	42	80397960000000
28309	42	80397980000000
28315	1726	797883314000
28316	1874	201686000
28317	1397	1389845118000
28318	1678	8640244982000
28319	1711	16559300000000
28320	1711	16559320000000
28334	1689	18719452000000
28335	1689	18719493000000
28342	1616	2880050000000
28343	1616	2880070000000
28362	1397	1389775111000
28363	1678	8640244989000
28364	1726	797813307000
28365	1874	201693000
28368	1397	1389765110000
28369	1678	8640244990000
28370	1726	797803306000
28371	1874	201694000
28372	1656	21600441000000
28373	1656	21600461000000
28386	1634	18720344899999
28387	1634	18720364899999
28389	1397	1389735107000
28390	1678	8640244993000
28391	1726	797773303000
28392	1874	201697000
28393	1419	21600490000000
28410	1726	797733299000
28411	1874	201701000
28412	1397	1389695103000
28413	1678	8640244997000
28414	596	84000342000000
28415	596	84000362000000
28431	1397	1389655099000
28432	1678	8640245001000
28433	1726	797693295000
28434	1874	201705000
28435	1691	12239321000000
28462	1397	1389605094000
28463	1678	8640245006000
28464	1726	795223290000
28465	1874	201710000
28466	1680	25199490000000
28467	1680	25199510000000
28478	1623	28081772899898
28479	1623	28082122899898
28486	1868	780000000
28487	498	66004000000000
28488	1397	1389575091000
28489	1678	8640245009000
28490	1726	795193287000
28491	1874	201713000
28492	1683	694088920999541
28493	1683	694089060999541
28507	1726	795163284000
28508	1874	201716000
28509	1397	1389545088000
28510	1678	8640245012000
28511	1683	696970080999541
28512	1683	696970100999541
28523	1623	28802122899898
28524	1623	28803222899898
28571	1397	1389435077000
28572	1678	8640245023000
28573	1726	795053273000
28574	1874	201727000
28575	1677	234725720000000
28576	1677	234725740000000
28591	1596	15277555000000
28592	1596	15277595000000
28605	1519	2879065000000
28625	1397	1389345068000
28626	1678	8640245032000
28627	1726	794963264000
28628	1874	201736000
28629	1675	15120689999977
28630	1675	15120709999977
28633	1684	33840041000000
28634	1675	14401309999977
28635	1675	15121309999977
28636	1675	15121729999977
28655	1703	10799510000000
28656	1703	10799530000000
28658	1726	794923260000
28659	1874	201740000
28660	1397	1389305064000
28661	1678	8640245036000
28662	1768	12239371110000
28663	1768	12239391110000
28686	1850	17985550000000
28687	1850	17985591000000
28724	1397	1389225056000
28725	1678	8640245044000
28726	1726	794843252000
28727	1874	201748000
28728	1726	794833251000
28729	1874	201749000
28730	1726	794823250000
28731	1874	201750000
28732	1397	1389215055000
28733	1678	8640245045000
28734	1397	1389205054000
28735	1678	8640245046000
28736	1677	236165760000000
28737	1677	236165820000000
28749	1397	1389175051000
28750	1678	8640245049000
28751	1726	794793247000
28752	1874	201753000
28753	1717	15839333000000
28754	1717	15839353000000
28757	1679	69121243000000
28758	1679	69121253000000
28759	1726	794783246000
28760	1874	201754000
28761	1397	1389165050000
28762	1678	8640245050000
28771	1726	794763244000
28772	1874	201756000
28019	1874	201636000
28020	1726	799583363000
28021	1874	201637000
28022	1726	799573362000
28023	1874	201638000
28024	1397	1390345168000
28025	1678	8640244932000
28026	1397	1390335167000
28027	1678	8640244933000
28028	1397	1390325166000
28029	1678	8640244934000
28030	1419	21600530000000
28041	1933	1439031000000
28048	1397	1390295163000
28049	1678	8640244937000
28050	1726	799543359000
28051	1874	201641000
28052	1705	18715510000000
28053	1705	18715530000000
28075	1397	1390255159000
28076	1678	8640244941000
28077	1726	799503355000
28078	1874	201645000
28079	1506	15840340000000
28080	1506	15840360000000
28100	1402	68402652000000
28101	1397	1390215155000
28102	1678	8640244945000
28103	1726	799463351000
28104	1874	201649000
28105	1693	11513647553123
28106	1693	11513667553123
28114	1679	68401233000000
28115	1679	68401253000000
28125	1397	1390175151000
28126	1678	8640244949000
28127	1726	799423347000
28128	1874	201653000
28129	1654	14400290000000
28138	1397	1390155149000
28139	1678	8640244951000
28140	1397	1390145148000
28141	1678	8640244952000
28142	1397	1390135147000
28143	1678	8640244953000
28144	1726	799403345000
28145	1874	201655000
28146	1726	799393344000
28147	1874	201656000
28148	1695	15119441000000
28151	1716	21599441000000
28152	1716	21599461000000
28165	208	66000000000000
28166	1460	0
28167	1726	799363341000
28168	1874	201659000
28169	1726	799353340000
28170	1874	201660000
28171	1397	1390105144000
28172	1678	8640244956000
28173	1684	35280041000000
28189	1726	799313336000
28190	1874	201664000
28191	1397	1390065140000
28192	1678	8640244960000
28193	1683	685448699999541
28194	1683	685448719999541
28195	1397	1390055139000
28196	1678	8640244961000
28197	1397	1390045138000
28198	1678	8640244962000
28199	1726	799303335000
28200	1874	201665000
28201	1397	1390035137000
28202	1678	8640244963000
28203	1397	1390025136000
28204	1678	8640244964000
28205	1726	799293334000
28206	1874	201666000
28207	1726	799283333000
28208	1874	201667000
28209	1726	799273332000
28210	1874	201668000
28211	1677	232565580000000
28212	1677	232565660000000
28253	1397	1389955129000
28254	1678	8640244971000
28255	1726	799203325000
28256	1874	201675000
28257	1726	797993325000
28258	1952	200000000
28259	1746	5759151000000
28270	1726	797963322000
28271	1874	201678000
28272	1726	797953321000
28273	1874	201679000
28274	1397	1389925126000
28275	1678	8640244974000
28276	1397	1389915125000
28277	1678	8640244975000
28278	1683	688328739999541
28279	1683	688328779999541
28288	1397	1389895123000
28289	1678	8640244977000
28290	1726	797933319000
28291	1874	201681000
28292	1397	1389885122000
28293	1678	8640244978000
28294	1397	1389875121000
28295	1678	8640244979000
28296	1726	797923318000
28297	1874	201682000
28298	1726	797913317000
28299	1874	201683000
28300	1683	689768779999541
28301	1683	689768839999541
28321	1679	68401243000000
28366	1623	27361770899898
28367	1623	27361772899898
28374	1726	797793305000
28375	1874	201695000
28376	1397	1389755109000
28377	1678	8640244991000
28378	1549	23760566000000
28379	1549	23760586000000
28388	1643	2736255113700
28416	1726	797723298000
28417	1874	201702000
28418	1726	797713297000
28419	1874	201703000
28420	1397	1389685102000
28421	1678	8640244998000
28422	1397	1389675101000
28423	1678	8640244999000
28424	1602	12960410000000
28425	1397	1389665100000
28426	1678	8640245000000
28427	1726	797703296000
28428	1874	201704000
28436	1549	24480586000000
28448	43	83280439890000
28468	1509	20160502000000
28469	1509	20160522000000
28496	1397	1389565090000
28497	1678	8640245010000
28498	1726	795183286000
28499	1874	201714000
28513	1397	1389535087000
28514	1678	8640245013000
28515	1397	1389525086000
28516	1678	8640245014000
28517	1726	795153283000
28518	1874	201717000
28519	1726	795143282000
28520	1874	201718000
28521	1608	13680380000000
28535	1709	15838601000000
28536	1709	16558601000000
28537	1709	720210070000
28538	1882	16559180930000
28550	1691	12959321000000
28551	1691	12959362000000
28631	1673	18000780000000
28632	1673	18000800000000
28637	1726	794953263000
28638	1874	201737000
28639	1397	1389335067000
28640	1678	8640245033000
28641	1699	7414140000078
28642	1699	7414160000078
28645	1726	794943262000
28646	1874	201738000
28647	1397	1389325066000
28648	1678	8640245034000
28649	64	67440010000000
28650	64	67440030000000
28657	1692	27379982020000
28664	1768	12239381110000
28688	1687	5845033726450
28689	1687	6565033726450
28690	1515	100000005
28691	1948	10703400
28692	1831	66000042570000
28693	646	200000007
28694	1687	6565034036440
28562	1874	201725000
28563	1397	1389455079000
28564	1678	8640245021000
28565	1397	1389445078000
28566	1678	8640245022000
28567	1726	795063274000
28568	1874	201726000
28569	1683	698410100999541
28570	1683	698410140999541
28581	1397	1389425076000
28582	1678	8640245024000
28583	1726	795043272000
28584	1874	201728000
28585	1726	795033271000
28586	1874	201729000
28587	1397	1389415075000
28588	1678	8640245025000
28589	1649	14400560999992
28590	1649	14400600999992
28665	1397	1389295063000
28666	1678	8640245037000
28667	1726	794913259000
28668	1874	201741000
28669	1683	699850160999541
28706	1726	794873255000
28707	1874	201745000
28708	1397	1389255059000
28709	1678	8640245041000
28722	1599	15120290000000
28723	1599	15120335000000
28755	1455	19440331000000
28756	1455	19440351000000
28785	1397	1389125046000
28786	1678	8640245054000
28787	1726	794743242000
28788	1874	201758000
28789	1608	13680360000000
28806	1397	1389085042000
28807	1678	8640245058000
28808	1726	794703238000
28809	1874	201762000
28822	1397	1389055039000
28823	1678	8640245061000
28824	1726	794673235000
28825	1874	201765000
28826	1397	1389045038000
28827	1678	8640245062000
28828	1726	794663234000
28829	1874	201766000
28830	667	66000095000000
28831	1532	720000000000
28832	1532	720045000000
28841	1657	15840300000000
28846	1397	1389015035000
28847	1678	8640245065000
28848	1397	1389005034000
28849	1678	8640245066000
28850	1726	794633231000
28851	1874	201769000
28852	1726	794623230000
28853	1874	201770000
28854	1684	36720126000000
28855	1684	36720166000000
28862	1677	237605840000000
28863	1677	237605860000000
28883	171	80400240000000
28884	171	80400270000000
28893	1397	1388935027000
28894	1678	8640245073000
28895	1726	794553223000
28896	1874	201777000
28897	1489	18000591000000
28898	1489	18000611000000
28901	1726	794543222000
28902	1874	201778000
28903	1467	14401750000000
28904	1397	1388925026000
28905	1678	8640245074000
28906	1893	15121750100000
28907	1467	209900000
28918	1726	794513219000
28919	1874	201781000
28920	1726	794503218000
28921	1874	201782000
28922	1397	1388895023000
28923	1678	8640245077000
28924	1397	1388885022000
28925	1678	8640245078000
28926	687	66700028000000
28927	1958	9000000000
28928	1696	14398442000000
28946	1439	12240210000000
28947	1439	12240250000000
28948	1397	1388855019000
28949	1678	8640245081000
28950	112	66001047824773
28951	1821	279990000000
28952	1397	1388845018000
28953	1678	8640245082000
28954	1397	1388835017000
28955	1678	8640245083000
28956	1397	1388825016000
28957	1678	8640245084000
28958	1397	1388815015000
28959	1678	8640245085000
28960	1726	794473215000
28961	1874	201785000
28962	1726	794463214000
28963	1874	201786000
28964	1726	794453213000
28965	1874	201787000
28966	1726	793243213000
28967	1959	200000000
28968	1726	793233212000
28969	1874	201788000
28970	1726	793223211000
28971	1874	201789000
28972	687	66000029000000
28973	1958	708998000000
28974	1467	15841750100000
28975	1467	15841871100000
28977	1555	12240220000000
28978	1555	12240341000000
28985	1672	16560422000000
28986	1672	16560442000000
28680	1831	200000003
28681	1850	17985549999999
28682	646	10703400
28683	1515	66000007920000
28684	1543	17985559959999
28685	1850	25000000
28695	1685	63360400000000
28696	1685	63360441000000
28698	1726	794883256000
28699	1874	201744000
28700	1397	1389265060000
28701	1678	8640245040000
28702	646	66000002970000
28703	1637	108002665809997
28704	1637	66000003960000
28705	646	108002684819997
28739	1726	794813249000
28740	1874	201751000
28741	1726	794803248000
28742	1874	201752000
28743	1397	1389195053000
28744	1678	8640245047000
28745	1397	1389185052000
28746	1678	8640245048000
28747	1693	12233667553123
28748	1693	12233707553123
28765	1397	1389155049000
28766	1678	8640245051000
28767	1726	794773245000
28768	1874	201755000
28769	1675	15840709999977
28770	1675	15840729999977
28783	1693	12953707553123
28784	1693	12953747553123
28790	1726	794733241000
28791	1874	201759000
28792	1726	794723240000
28793	1874	201760000
28794	1397	1389115045000
28795	1678	8640245055000
28796	1397	1389105044000
28797	1678	8640245056000
28798	1546	17280320000000
28799	1546	17280360000000
28833	1726	794653233000
28834	1874	201767000
28835	1397	1389035037000
28836	1678	8640245063000
28837	1686	10292116500013
28838	1686	10292136500013
28856	1670	20880670000000
28899	1677	238325860000000
28900	1677	238325880000000
28912	1397	1388905024000
28913	1678	8640245076000
28914	1726	794523220000
28915	1874	201780000
28929	1791	2210000048
28930	1690	61919652999960
28932	341	66000000000001
28933	1690	62639652999959
28934	1690	800000000
28935	1501	62639702999959
28976	1677	238325981000000
28697	1687	6565074726450
28710	1397	1389245058000
28711	1678	8640245042000
28712	1726	794863254000
28713	1874	201746000
28714	1726	794853253000
28715	1874	201747000
28716	1397	1389235057000
28717	1678	8640245043000
28718	1957	0
28719	1941	717956000000
28720	1684	36000081000000
28721	1684	36000126000000
28738	1683	699850200999541
28763	1677	236885820000000
28764	1677	236885840000000
28781	1711	17999340000000
28782	1711	17999380000000
28812	1726	794693237000
28813	1874	201763000
28814	1726	794683236000
28815	1874	201764000
28816	1397	1389075041000
28817	1678	8640245059000
28818	1397	1389065040000
28819	1678	8640245060000
28820	1546	18000360000000
28821	1546	18000400000000
28842	1397	1389025036000
28843	1678	8640245064000
28844	1726	794643232000
28845	1874	201768000
28857	1397	1388995033000
28858	1678	8640245067000
28859	1726	794613229000
28860	1874	201771000
28861	1688	118082455000000
28864	1726	794603228000
28865	1874	201772000
28866	1397	1388985032000
28867	1678	8640245068000
28872	1684	37440166000000
28873	1684	37440186000000
28881	1549	25200586000000
28882	1549	25200616000000
28885	1397	1388955029000
28886	1678	8640245071000
28887	1397	1388945028000
28888	1678	8640245072000
28889	1726	794573225000
28890	1874	201775000
28891	1726	794563224000
28892	1874	201776000
28908	1397	1388915025000
28909	1678	8640245075000
28910	1726	794533221000
28911	1874	201779000
28931	1683	699850181999541
28936	1726	794493217000
28937	1874	201783000
28938	1726	794483216000
28939	1874	201784000
28940	1397	1388875021000
28941	1678	8640245079000
28942	1397	1388865020000
28943	1678	8640245080000
28944	1683	701290181999541
28945	1683	701290221999541
28773	1726	794753243000
28774	1874	201757000
28775	1397	1389145048000
28776	1678	8640245052000
28777	1397	1389135047000
28778	1678	8640245053000
28779	1688	118082435000000
28780	1688	118082475000000
28800	1397	1389095043000
28801	1678	8640245057000
28802	1726	794713239000
28803	1874	201761000
28804	411	66720000000000
28805	411	66720020000000
28810	1513	15120420000000
28811	1513	15120440000000
28839	1657	15840290000000
28840	1657	15840310000000
28868	1726	794593227000
28869	1874	201773000
28870	1397	1388975031000
28871	1678	8640245069000
28874	1397	1388965030000
28875	1678	8640245070000
28876	1903	0
28877	1932	217990000000
28878	1726	794583226000
28879	1874	201774000
28880	1762	11519270000000
28916	1685	63360390000000
28917	1685	63360410000000
28979	1726	793213210000
28980	1874	201790000
28981	1397	1388805014000
28982	1678	8640245086000
28983	1705	19435530000000
28984	1705	19435550000000
28987	1726	793203209000
28988	1874	201791000
28989	1397	1388795013000
28990	1678	8640245087000
28991	1489	18720611000000
28992	1489	18720631000000
28993	1402	69122652000000
28994	1402	69122672000000
28995	1397	1388785012000
28996	1678	8640245088000
28997	1726	793193208000
28998	1874	201792000
28999	1726	793183207000
29000	1874	201793000
29001	1397	1388775011000
29002	1678	8640245089000
29003	409	66000000000000
29004	1474	15394323000000
29005	1474	15394364000000
29006	1559	19440540000000
29007	1559	19440581000000
29008	1508	15120311000000
29009	1397	1388765010000
29010	1678	8640245090000
29011	1726	793173206000
29012	1874	201794000
29013	1726	793163205000
29014	1874	201795000
29015	1397	1388755009000
29016	1678	8640245091000
29017	1458	23040405908540
29018	1458	23040425908540
29019	606	79680270000000
29020	606	79680290000000
29021	1397	1388745008000
29022	1678	8640245092000
29023	1397	1388735007000
29024	1678	8640245093000
29025	1726	793153204000
29026	1874	201796000
29027	1726	793143203000
29028	1874	201797000
29029	1671	22321120000000
29030	42	80398000000000
29031	1726	791933203000
29032	1960	200000000
29033	1726	791923202000
29034	1874	201798000
29035	1397	1388725006000
29036	1678	8640245094000
29037	1688	118802455000000
29038	1688	118802485000000
29039	1397	1388715005000
29040	1678	8640245095000
29041	1726	791913201000
29042	1874	201799000
29043	1501	900000000
29044	1690	63359602999959
29045	193	66000067824773
29046	1961	281000000000
29047	1397	1388705004000
29048	1678	8640245096000
29049	1397	1388695003000
29050	1678	8640245097000
29051	1726	791903200000
29052	1874	201800000
29053	1726	791893199000
29054	1874	201801000
29055	1457	20160461000000
29056	1397	1388685002000
29057	1678	8640245098000
29058	1726	791883198000
29059	1874	201802000
29060	1756	1906509808900
29061	1516	17533489191100
29062	1726	791873197000
29063	1874	201803000
29064	1726	791863196000
29065	1874	201804000
29066	1397	1388675001000
29067	1678	8640245099000
29068	1726	791853195000
29069	1874	201805000
29070	1726	791843194000
29071	1874	201806000
29072	1726	791833193000
29073	1874	201807000
29074	1397	1388665000000
29075	1678	8640245100000
29076	1397	1388654999000
29077	1678	8640245101000
29078	1397	1388644998000
29079	1678	8640245102000
29080	1397	1388634997000
29081	1678	8640245103000
29082	1467	16561871100000
29083	1467	16561981100000
29084	1726	791823192000
29085	1874	201808000
29086	1397	1388624996000
29087	1678	8640245104000
29088	55	68160040000000
29089	55	68160060000000
29090	1885	0
29091	1726	791813191000
29092	1874	201809000
29093	1726	791803190000
29094	1874	201810000
29095	1397	1388614995000
29096	1678	8640245105000
29097	1397	1388604994000
29098	1678	8640245106000
29099	1683	701290321999541
29100	1397	1388594993000
29101	1678	8640245107000
29102	1726	791793189000
29103	1874	201811000
29104	1474	16114364000000
29105	1474	16114384000000
29106	1726	791783188000
29107	1874	201812000
29108	1397	1388584992000
29109	1678	8640245108000
29110	1683	702730321999541
29111	1683	702730341999541
29112	1726	791773187000
29113	1874	201813000
29114	1397	1388574991000
29115	1678	8640245109000
29116	1402	69842672000000
29117	1402	69842692000000
29118	1516	15154709112008
29119	928	505156545079092
29120	1397	1388564990000
29121	1678	8640245110000
29122	1397	1388554989000
29123	1678	8640245111000
29124	1764	17280389000000
29125	1516	10891963511560
29126	1048	905236200600448
29127	1516	8015800860938
29128	1168	610780902650622
29129	1726	791763186000
29130	1874	201814000
29131	1726	791753185000
29132	1874	201815000
29133	1764	18000389000000
29134	1764	9900000
29135	1728	18000419100000
29137	1397	1388544988000
29138	1678	8640245112000
29139	1726	791743184000
29140	1874	201816000
29141	1683	704170341999541
29142	1683	704170361999541
29150	1467	17281981100000
29151	1467	17282021100000
29163	1516	1115766709
29164	1294	1701995292845879
29165	1726	791723182000
29166	1874	201818000
29167	1726	791713181000
29168	1874	201819000
29169	1397	1388514985000
29170	1678	8640245115000
29171	1397	1388504984000
29172	1678	8640245116000
29173	1762	11519310000000
29174	55	67439030000000
29175	772	1001000000000
29197	1683	704170433999541
29202	1726	790463177000
29203	1874	201823000
29204	1397	1388464980000
29205	1678	8640245120000
29206	58	86160825000000
29207	58	86160845000000
29220	1726	790433174000
29221	1874	201826000
29222	1397	1388434977000
29223	1678	8640245123000
29224	1448	15840672000000
29227	1724	21599100000000
29228	1724	21599120000000
29229	1397	1388424976000
29230	1678	8640245124000
29231	1726	790423173000
29232	1874	201827000
29233	42	81117980000000
29234	42	81118000000000
29247	606	80400290000000
29248	606	80400310000000
29264	1637	109442704819997
29265	1637	109442744819997
29275	1726	790343165000
29276	1874	201835000
29277	1726	790333164000
29278	1874	201836000
29279	1397	1388344968000
29280	1678	8640245132000
29281	1397	1388334967000
29282	1678	8640245133000
29283	1699	8134160000078
29284	1699	8134200000078
29288	1601	12601276600000
29289	1601	12601316600000
29296	606	81120310000000
29297	606	81120330000000
29298	1397	1388314965000
29299	1678	8640245135000
29300	1397	1388304964000
29301	1678	8640245136000
29302	1726	790313162000
29303	1874	201838000
29304	1726	790303161000
29305	1874	201839000
29306	1489	18720651000000
29314	1489	19440651000000
29315	1489	19440671000000
29320	1726	790283159000
29321	1874	201841000
29322	1726	790273158000
29323	1874	201842000
29324	1397	1388284962000
29325	1678	8640245138000
29326	1397	1388274961000
29327	1678	8640245139000
29332	1726	790263157000
29333	1874	201843000
29334	621	66720020000000
29343	1397	1388244958000
29344	1678	8640245142000
29345	1726	790243155000
29346	1874	201845000
29374	1397	1388194953000
29375	1678	8640245147000
29376	1726	790193150000
29377	1874	201850000
29378	1601	12601296600000
29392	1397	1388164950000
29393	1678	8640245150000
29394	1726	788953147000
29395	1874	201853000
29396	1726	788943146000
29397	1874	201854000
29398	1397	1388154949000
29399	1678	8640245151000
29400	1397	1388144948000
29401	1678	8640245152000
29402	1726	787733146000
29403	1966	200000000
29404	1726	787723145000
29405	1874	201855000
29406	1684	38160186000000
29407	1684	38160256000000
29423	1726	787693142000
29424	1874	201858000
29425	1397	1388114945000
29426	1678	8640245155000
29427	1397	1388104944000
29428	1678	8640245156000
29429	1726	787683141000
29430	1874	201859000
29431	1547	8640242000000
29443	1726	787653138000
29444	1874	201862000
29445	1397	1388074941000
29446	1678	8640245159000
29447	1596	15277575000000
29449	1726	787643137000
29450	1874	201863000
29451	1397	1388064940000
29452	1678	8640245160000
29453	1271	1340526220000000
29454	1271	1340526240000000
29488	1726	787573130000
29489	1874	201870000
29490	1726	787563129000
29491	1874	201871000
29492	1397	1387994933000
29493	1678	8640245167000
29494	1397	1387984932000
29495	1678	8640245168000
29496	596	84720362000000
29497	596	84720402000000
29514	1555	12240240000000
29530	1458	23040426908540
29540	1397	1387914925000
29541	1678	8640245175000
29542	1397	1387904924000
29543	1678	8640245176000
29544	277	66000000000000
29545	425	66000000000000
29546	1726	787493122000
29547	1874	201878000
29548	1726	787483121000
29549	1874	201879000
29550	1690	57600901000000
29561	1397	1387884922000
29562	1678	8640245178000
29563	1726	787463119000
29564	1874	201881000
29565	1726	787453118000
29566	1874	201882000
29567	1726	787443117000
29568	1874	201883000
29569	1723	17280241000000
29570	1397	1387874921000
29571	1678	8640245179000
29572	1397	1387864920000
29573	1678	8640245180000
29574	45	66000000001060
29575	1723	18000240999990
29576	1723	66000000001290
29577	45	18000260999760
29646	1726	787333106000
29647	1874	201894000
29648	55	68143601000000
29649	716	3011571750000
29650	55	67889012500000
29651	517	66254578500000
29652	55	67634424000000
29653	509	66254578500000
29654	55	67379835500000
29655	463	66254578500000
29656	1397	1387744908000
29657	1678	8640245192000
29658	1683	715690643999541
29659	1683	715690703999541
29690	1726	787303103000
29691	1874	201897000
29692	1397	1387714905000
29693	1678	8640245195000
29136	1764	18000429000000
29152	1467	17282011100000
29153	1701	15838412000000
29160	149	77520296000000
29161	149	77520307000000
29198	1654	15120280000000
29199	1654	15120372000000
29210	772	1000900000000
29211	1397	1388454979000
29212	1678	8640245121000
29213	1726	790453176000
29214	1874	201824000
29215	1685	64080530000000
29235	1726	790413172000
29236	1874	201828000
29237	1397	1388414975000
29238	1678	8640245125000
29239	1402	70562692000000
29240	1402	70562712000000
29241	1726	790403171000
29242	1874	201829000
29243	1397	1388404974000
29244	1678	8640245126000
29307	1607	25920662000000
29308	1607	25920702000000
29335	1397	1388254959000
29336	1678	8640245141000
29337	1726	790253156000
29338	1874	201844000
29339	1683	708490513999541
29340	1683	708490533999541
29367	1677	239045900000000
29368	1677	239045920000000
29379	1726	788983150000
29380	1965	200000000
29381	1397	1388184952000
29382	1678	8640245148000
29383	1397	1388174951000
29384	1678	8640245149000
29385	1726	788973149000
29386	1874	201851000
29387	1726	788963148000
29388	1874	201852000
29389	1643	2736285113700
29408	1726	787713144000
29409	1874	201856000
29410	1397	1388134947000
29411	1678	8640245153000
29412	1397	1388124946000
29413	1678	8640245154000
29414	1726	787703143000
29415	1874	201857000
29416	1677	239765920000000
29417	1677	239765960000000
29421	1683	709930533999541
29422	1683	709930573999541
29455	1726	787633136000
29456	1874	201864000
29457	1397	1388054939000
29458	1678	8640245161000
29459	1679	69841261980000
29460	1679	69841281980000
29463	1726	787623135000
29464	1874	201865000
29465	1397	1388044938000
29466	1678	8640245162000
29467	1688	118802475000000
29504	1726	787543127000
29505	1874	201873000
29506	1397	1387964930000
29507	1678	8640245170000
29508	43	84000439890000
29509	43	84000459890000
29551	1397	1387894923000
29552	1678	8640245177000
29553	1726	787473120000
29554	1874	201880000
29555	1560	29520839000000
29556	1560	29520859000000
29559	1685	65520550000000
29560	1685	65520570000000
29584	1726	787433116000
29585	1874	201884000
29586	1397	1387854919000
29587	1678	8640245181000
29604	1726	787393112000
29605	1874	201888000
29606	1397	1387804914000
29607	1678	8640245186000
29608	1705	20155550000000
29609	1705	20155570000000
29634	1690	58320901000000
29635	1690	58320941000000
29660	55	67125247000000
29661	278	66254578500000
29662	1726	787323105000
29663	1874	201895000
29664	55	66870658500000
29665	178	66254578500000
29666	1397	1387734907000
29667	1678	8640245193000
29668	1919	149000000
29669	1451	12240340000000
29670	1451	12240381000000
29673	55	67435162750000
29674	55	67423581000000
29675	55	67168992500000
29676	55	66914404000000
29677	55	66659815500000
29678	55	66405227000000
29679	55	66150638500000
29680	1709	16559940930000
29681	1709	17279940930000
29682	1447	66000050000000
29683	289	20160499000000
29684	1709	17280451930000
29700	1726	787283101000
29701	1874	201899000
29702	1397	1387694903000
29703	1678	8640245197000
29704	1708	12239500000000
29705	1708	12239520000000
29745	1397	1387614895000
29746	1678	8640245205000
29747	1726	787203093000
29748	1874	201907000
29749	1471	20160430000000
29750	1471	20160450000000
29762	1397	1387584892000
29763	1678	8640245208000
29764	1726	787173090000
29765	1874	201910000
29766	1397	1387574891000
29767	1678	8640245209000
29768	1726	787163089000
29769	1874	201911000
29770	1688	120242495000000
29771	1688	120242535000000
29791	1683	717130703999541
29792	1683	717130763999541
29795	1397	1387534887000
29796	1678	8640245213000
29797	1397	1387524886000
29798	1678	8640245214000
29799	1726	787123085000
29800	1874	201915000
29801	1726	787113084000
29802	1874	201916000
29803	1634	19440364899999
29804	1634	19440404899999
29812	1426	12960430000000
29813	1426	12960450000000
29820	1587	17280331000000
29821	1587	17280351000000
29829	1677	241206021000000
29830	1564	14400272000000
29831	1564	14400302000000
29848	1397	1387454879000
29849	1678	8640245221000
29850	1726	785843078000
29851	1874	201922000
29852	1711	18719380000000
29853	1711	18719400000000
29874	1726	785793073000
29875	1874	201927000
29876	1397	1387404874000
29877	1678	8640245226000
29878	1688	120962555000000
29879	1688	120962575000000
29890	1726	785763070000
29891	1874	201930000
29892	1397	1387374871000
29893	1678	8640245229000
29894	1693	11759708897158
29895	910	505400512229673
29896	1679	70561281980000
29897	1679	70561311980000
29900	1690	60481021000000
29901	1690	60481051000000
29926	1397	1387344868000
29927	1678	8640245232000
29928	1726	785733067000
29929	1874	201933000
29930	1726	785723066000
29931	1874	201934000
29143	1397	1388534987000
29144	1678	8640245113000
29145	261	66000067824773
29146	1962	281000000000
29147	1726	791733183000
29148	1874	201817000
29149	1509	20160542000000
29154	1397	1388524986000
29155	1678	8640245114000
29156	1540	365307000000
29157	1963	1000000000
29158	1457	20880461000000
29159	1457	20880472000000
29216	1397	1388444978000
29217	1678	8640245122000
29218	1726	790443175000
29219	1874	201825000
29225	632	84000603000000
29226	632	84000623000000
29254	1397	1388384972000
29255	1678	8640245128000
29256	1397	1388374971000
29257	1678	8640245129000
29258	1726	790383169000
29259	1874	201831000
29260	1726	790373168000
29261	1874	201832000
29262	1683	705610433999541
29263	1683	705610473999541
29287	1677	238325900000000
29290	1397	1388324966000
29291	1678	8640245134000
29292	1726	790323163000
29293	1874	201837000
29294	1440	18720642000000
29295	1440	18720662000000
29309	1397	1388294963000
29310	1678	8640245137000
29311	1726	790293160000
29312	1874	201840000
29313	1447	20880510000000
29353	1692	28099982020000
29354	1692	28100002020000
29362	1726	790213152000
29363	1874	201848000
29364	1397	1388214955000
29365	1678	8640245145000
29366	1637	109442724819997
29369	1397	1388204954000
29370	1678	8640245146000
29371	1726	790203151000
29372	1874	201849000
29373	1536	18000440000000
29419	1687	7285074726450
29420	1687	7285114726450
29432	1726	787673140000
29433	1874	201860000
29434	1397	1388094943000
29435	1678	8640245157000
29436	1699	8134180000078
29437	1726	787663139000
29438	1874	201861000
29439	1397	1388084942000
29440	1678	8640245158000
29441	235	67440030000000
29442	235	67440050000000
29461	641	87600890000000
29462	641	87600910000000
29470	1397	1388034937000
29471	1678	8640245163000
29472	1397	1388024936000
29473	1678	8640245164000
29474	1397	1388014935000
29475	1678	8640245165000
29476	1397	1388004934000
29477	1678	8640245166000
29478	1726	787613134000
29479	1874	201866000
29480	1726	787603133000
29481	1874	201867000
29482	1726	787593132000
29483	1874	201868000
29484	1726	787583131000
29485	1874	201869000
29486	1723	17280121000000
29487	1723	17280201000000
29500	1397	1387974931000
29501	1678	8640245169000
29502	1726	787553128000
29503	1874	201872000
29516	1726	787523125000
29517	1874	201875000
29518	1397	1387944928000
29519	1678	8640245172000
29520	1684	38880276000000
29523	1397	1387934927000
29524	1678	8640245173000
29525	1726	787513124000
29526	1874	201876000
29527	262	66000088000000
29528	277	66000010000000
29529	1677	239765941000000
29531	1397	1387924926000
29532	1678	8640245174000
29533	1726	787503123000
29534	1874	201877000
29535	262	66000077000000
29536	425	66000010000000
29537	262	66000066000000
29538	668	66000010000000
29539	1555	12240242000000
29557	1683	712810593999541
29558	1683	712810613999541
29581	1402	70562752000000
29582	1402	71282752000000
29583	1402	71282772000000
29588	1397	1387844918000
29589	1678	8640245182000
29590	1726	787423115000
29591	1874	201885000
29592	1397	1387834917000
29593	1678	8640245183000
29594	1397	1387824916000
29595	1678	8640245184000
29596	1397	1387814915000
29597	1678	8640245185000
29598	1726	787413114000
29599	1874	201886000
29600	1726	787403113000
29601	1874	201887000
29602	1677	240485941000000
29603	1677	240485991000000
29620	1718	13577522889008
29621	1718	13577562889008
29624	1726	787363109000
29625	1874	201891000
29626	1726	787353108000
29627	1874	201892000
29628	1397	1387774911000
29629	1678	8640245189000
29630	1397	1387764910000
29631	1678	8640245190000
29632	369	86880532000000
29633	369	86880572000000
29636	1623	30963429899898
29637	1623	30963432899898
29671	1709	17277511000000
29672	1709	17277552000000
29685	1726	787313104000
29686	1874	201896000
29687	1397	1387724906000
29688	1678	8640245194000
29689	1434	1439120000000
29698	1688	119522475000000
29699	1688	119522495000000
29706	1726	787273100000
29707	1874	201900000
29708	1397	1387684902000
29709	1678	8640245198000
29710	171	80400260000000
29751	1397	1387604894000
29752	1678	8640245206000
29753	1726	787193092000
29754	1874	201908000
29805	42	81838000000000
29806	42	81838040000000
29822	1726	785883082000
29823	1968	200000000
29824	1726	785873081000
29825	1874	201919000
29826	1397	1387494883000
29827	1678	8640245217000
29828	1696	14398431000000
29854	1397	1387444878000
29855	1678	8640245222000
29856	1726	785833077000
29857	1874	201923000
29858	1677	241206011000000
29868	1397	1387414875000
29869	1678	8640245225000
29870	1726	785803074000
29871	1874	201926000
29872	1690	59761001000000
29873	1690	59761021000000
29985	1726	785693063000
29162	1611	15830750000000
29176	55	68159050000000
29177	1756	1907615575609
29178	1397	1388494983000
29179	1678	8640245117000
29180	1397	1388484982000
29181	1678	8640245118000
29182	1397	1388474981000
29183	1678	8640245119000
29184	1726	791703180000
29185	1874	201820000
29186	1726	791693179000
29187	1874	201821000
29188	1726	791683178000
29189	1874	201822000
29190	1726	790473178000
29191	1964	200000000
29192	1963	999000000
29193	1540	0
29194	1963	366305000000
29195	1536	18000420000000
29196	1536	18000512000000
29200	1637	108722684819997
29201	1637	108722776819997
29208	1685	64080410000000
29209	1685	64080430000000
29245	484	86160522000000
29246	484	86160542000000
29249	1397	1388394973000
29250	1678	8640245127000
29251	1726	790393170000
29252	1874	201830000
29253	1637	108722704819997
29266	1397	1388364970000
29267	1678	8640245130000
29268	1726	790363167000
29269	1874	201833000
29270	1397	1388354969000
29271	1678	8640245131000
29272	1726	790353166000
29273	1874	201834000
29274	1426	12240430000000
29285	1683	707050473999541
29286	1683	707050513999541
29316	1756	1186489808900
29317	1963	366306000000
29318	1623	30243223899898
29319	1623	30243429899898
29328	1397	1388264960000
29329	1678	8640245140000
29330	621	66720000000000
29331	621	66720010000000
29341	1549	25920616000000
29342	1549	25920636000000
29347	1397	1388234957000
29348	1678	8640245143000
29349	1726	790233154000
29350	1874	201846000
29351	1594	15120400000000
29352	1594	15120420000000
29355	1397	1388224956000
29356	1678	8640245144000
29357	1726	790223153000
29358	1874	201847000
29359	1804	69121261980000
29360	1679	1401000000
29361	435	66000000020000
29390	1719	16559320000000
29391	1719	16559370000000
29418	1689	18719492000000
29448	1759	19440390000000
29468	1683	711370573999541
29469	1683	711370593999541
29498	1610	20880750000000
29499	1610	20880790000000
29510	1397	1387954929000
29511	1678	8640245171000
29512	1726	787533126000
29513	1874	201874000
29515	1684	38880256000000
29521	1685	64800530000000
29522	1685	64800550000000
29578	1489	19440711000000
29579	1489	20160711000000
29580	1489	20160731000000
29610	1397	1387794913000
29611	1678	8640245187000
29612	1397	1387784912000
29613	1678	8640245188000
29614	1726	787383111000
29615	1874	201889000
29616	1726	787373110000
29617	1874	201890000
29618	1677	241205991000000
29619	1677	241206031000000
29622	1691	13679362000000
29623	1691	13679402000000
29638	55	68155182750000
29639	761	1003857250000
29640	1397	1387754909000
29641	1678	8640245191000
29642	1726	787343107000
29643	1874	201893000
29644	1683	714250613999541
29645	1683	714250643999541
29694	1397	1387704904000
29695	1678	8640245196000
29696	1726	787293102000
29697	1874	201898000
29734	1650	11520380000000
29772	1451	12960381000000
29773	1451	12960421000000
29776	1594	15840420000000
29777	1594	15840460000000
29793	1601	13321296600000
29794	1601	13321356600000
29814	1726	787093082000
29815	1874	201918000
29816	1397	1387504884000
29817	1678	8640245216000
29818	1675	16560729999977
29819	1675	16560749999977
29832	1474	16834384000000
29833	1474	16834414000000
29838	1397	1387474881000
29839	1678	8640245219000
29840	1726	785863080000
29841	1874	201920000
29842	1518	3600061000000
29843	1518	3600081000000
29859	1726	785823076000
29860	1874	201924000
29861	1397	1387434877000
29862	1678	8640245223000
29863	1397	1387424876000
29864	1678	8640245224000
29865	1726	785813075000
29866	1874	201925000
29867	1508	15120310000000
29880	1397	1387394873000
29881	1678	8640245227000
29882	1726	785783072000
29883	1874	201928000
29898	1683	718570723999541
29899	1683	718570753999541
29902	1681	24479535195920
29903	1681	24479565195920
29968	1726	785703064000
29969	1874	201936000
29970	1397	1387314865000
29971	1678	8640245235000
29972	1693	8482791990159
29973	105	66344300665601
29974	1693	8420559149331
29975	122	66344300665601
29976	1693	8358326308503
29977	622	66347280665601
29978	1693	8296093467675
29979	520	66344300665601
29980	1693	8233860626847
29981	551	66344300665601
29982	1693	8171627786019
29983	295	66344300665601
29984	1683	718570803999541
30070	1683	718570863999541
30071	1683	720010863999541
30072	1683	720011043999541
30073	55	66616070000000
30074	1719	15839750000000
30075	55	66361481500000
30076	1719	16559750000000
30077	1719	16560570000000
30114	1700	15839660000000
30115	1700	15839740000000
30117	1693	5167649865400
30118	652	66344300665601
30119	1693	5165754324779
30120	745	2010433353450
30121	1693	5103521483951
30122	420	66344300665601
30123	1726	785623056000
30124	1874	201944000
30125	1693	5041288643123
30126	353	66344290665601
30127	1693	4979055802295
29711	1397	1387674901000
29712	1678	8640245199000
29713	1726	787263099000
29714	1874	201901000
29715	1670	21600670000000
29716	1670	21600690000000
29717	1726	787253098000
29718	1874	201902000
29719	1726	787243097000
29720	1874	201903000
29721	1726	787233096000
29722	1874	201904000
29723	1726	787223095000
29724	1874	201905000
29725	1397	1387664900000
29726	1678	8640245200000
29727	1397	1387654899000
29728	1678	8640245201000
29729	1397	1387644898000
29730	1678	8640245202000
29731	1397	1387634897000
29732	1678	8640245203000
29733	1467	17282061100000
29735	55	66616060000000
29736	62	66254578500000
29737	55	66361461500000
29738	59	66254578500000
29739	1397	1387624896000
29740	1678	8640245204000
29741	1726	787213094000
29742	1874	201906000
29743	1690	59040941000000
29744	1690	59041001000000
29755	1397	1387594893000
29756	1678	8640245207000
29757	1726	787183091000
29758	1874	201909000
29759	55	66000000000000
29760	1967	360451500000
29761	1637	109442734819997
29774	1715	22320262000000
29775	1715	22320302000000
29778	1397	1387564890000
29779	1678	8640245210000
29780	1397	1387554889000
29781	1678	8640245211000
29782	1397	1387544888000
29783	1678	8640245212000
29784	1726	787153088000
29785	1874	201912000
29786	1726	787143087000
29787	1874	201913000
29788	1726	787133086000
29789	1874	201914000
29790	1688	120242555000000
29807	1726	787103083000
29808	1874	201917000
29809	1397	1387514885000
29810	1678	8640245215000
29811	1683	717130723999541
29834	1397	1387484882000
29835	1678	8640245218000
29836	171	81120260000000
29837	171	81120270000000
29844	1397	1387464880000
29845	1678	8640245220000
29846	1726	785853079000
29847	1874	201921000
29884	1726	785773071000
29885	1874	201929000
29886	1397	1387384872000
29887	1678	8640245228000
29888	641	88320910000000
29889	641	88320930000000
29904	1726	785753069000
29905	1874	201931000
29906	1693	11697476056330
29907	500	66344300665601
29908	1726	785743068000
29909	1874	201932000
29910	1693	11635243215502
29911	587	66344300665601
29912	1693	11573010374674
29913	146	66344300665601
29914	1693	11510777533846
29915	395	66341270665601
29916	1693	11448544693018
29917	611	66344300665601
29918	1693	11441935300813
29919	29	7036516737238
29920	1397	1387364870000
29921	1678	8640245230000
29922	1397	1387354869000
29923	1678	8640245231000
29924	1672	17280442000000
29925	1672	17280542000000
30019	1397	1387284862000
30020	1678	8640245238000
30021	1726	785673061000
30022	1874	201939000
30023	1397	1387274861000
30024	1678	8640245239000
30025	1397	1387264860000
30026	1678	8640245240000
30027	1693	6912064949205
30028	438	66344300665601
30029	1693	6849832108377
30030	593	66344300665601
30031	1608	13680420000000
30032	1693	6787599267549
30033	408	66344300665601
30034	1726	785663060000
30035	1874	201940000
30036	1693	6725366426721
30037	373	66344300665601
30038	1693	6663133585893
30039	322	66344300665601
30040	1693	6600900745065
30041	453	66344300665601
30042	1693	6538667904237
30043	450	66344300665601
30044	1693	6476435063409
30045	63	66344300665601
30046	1726	785653059000
30047	1874	201941000
30048	1693	6414202222581
30049	601	66344300665601
30050	1693	6351969381753
30051	92	66344300665601
30052	1693	6289736540925
30053	150	66344300665601
30054	1693	6227503700097
30055	309	66344300665601
30056	1693	6165270859269
30057	680	66344300665601
30058	1693	6163375318648
30059	731	2010433353450
30060	1693	6101142477820
30061	82	66344300665601
30062	1693	6038909636992
30063	163	66344300665601
30064	1693	5976676796164
30065	275	66344300665601
30066	1693	5914443955336
30067	361	66344300665601
30068	1608	14400420000000
30069	1608	14400600000000
30113	1654	15120360000000
30116	1685	65520630000000
30187	1688	121682575000000
30188	1688	121682725000000
30192	1693	2884060999956
30193	35	19300160193600
30194	1397	1387194853000
30195	1678	8640245247000
30196	1693	2821828159128
30197	49	66344300665601
30198	1693	2759595318300
30199	570	66344300665601
30200	1693	2697362477472
30201	99	66344300665601
30202	1693	2635129636644
30203	569	66344300665601
30204	1693	2345856098725
30205	894	308423512571246
30206	1726	785583052000
30207	1874	201948000
30208	1686	11012136500013
30209	1686	11012226500013
30240	1594	15840450000000
30253	1759	20160390000000
30254	1759	20160410000000
30261	1397	1387114845000
30262	1678	8640245255000
30263	1726	785513045000
30264	1874	201955000
30265	1688	123122755000000
30266	1688	123122775000000
30285	1681	25199565195920
30286	1681	25199575195920
30337	1601	13321316600000
30338	1726	785393033000
30339	1874	201967000
30340	1397	1386994833000
30341	1678	8640245267000
29932	1726	785713065000
29933	1874	201935000
29934	1397	1387334867000
29935	1678	8640245233000
29936	1693	11379702459985
29937	138	66344300665601
29938	1693	11317469619157
29939	205	66344300665601
29940	1397	1387324866000
29941	1678	8640245234000
29942	1693	11255236778329
29943	78	66344300665601
29944	1693	11084978486463
29945	1811	938190609615
29946	1693	11022745645635
29947	504	66344300665601
29948	1693	10960512804807
29949	658	66344300665601
29950	1693	10898279963979
29951	1961	343222840828
29952	1693	10836047123151
29953	660	66344300665601
29954	1693	9239054031101
29955	1276	1702817277527660
29956	1693	9176821190273
29957	194	66344300665601
29958	1693	9114588349445
29959	304	66344300665601
29960	1693	9052355508617
29961	206	66344300665601
29962	1693	8990122667789
29963	399	66344300665601
29964	1693	8545024830987
29965	1772	2461166133031
29966	1677	241926011000000
29967	1677	241926211000000
30190	668	66000000000000
30191	1677	242646221000000
30210	1693	2283623257897
30211	108	66344300665601
30212	1693	2221390417069
30213	390	66344300665601
30214	1397	1387184852000
30215	1678	8640245248000
30216	1397	1387174851000
30217	1678	8640245249000
30218	1693	2159157576241
30219	252	66344300665601
30220	1726	785573051000
30221	1874	201949000
30222	1693	2096924735413
30223	377	66344300665601
30224	1726	785563050000
30225	1874	201950000
30226	1693	2034691894585
30227	225	66344300665601
30228	1693	1972459053757
30229	560	66344300665601
30230	1946	991428570
30231	1685	65520658571430
30274	1726	785493043000
30275	1874	201957000
30276	1397	1387094843000
30277	1678	8640245257000
30278	1689	17999472000000
30279	1689	18719471999999
30298	1397	1387054839000
30299	1678	8640245261000
30300	1726	785453039000
30301	1874	201961000
30302	1686	11732226500013
30303	1686	11732246500013
30309	238	66720160000000
30310	238	66720180000000
30311	238	66000410000000
30312	238	66720410000000
30313	238	66721500000000
30324	1397	1387014835000
30325	1678	8640245265000
30326	1726	785413035000
30327	1874	201965000
30328	1933	1439020000000
30329	1444	18720612000000
30330	1444	18720633000000
30350	1726	785373031000
30351	1874	201969000
30352	1397	1386974831000
30353	1678	8640245269000
30354	1670	22320690000000
30355	1670	22320710000000
30358	1397	1386964830000
30359	1678	8640245270000
30360	1726	785363030000
30361	1874	201970000
30362	1684	39600276000000
30363	1684	39600296000000
30364	1726	785353029000
30365	1874	201971000
30366	1726	785343028000
30367	1874	201972000
30368	1726	785333027000
30369	1874	201973000
30370	1397	1386954829000
30371	1678	8640245271000
30372	1397	1386944828000
30373	1678	8640245272000
30374	1397	1386934827000
30375	1678	8640245273000
30376	1599	15120350000000
30385	1397	1386914825000
30386	1678	8640245275000
30387	1726	785313025000
30388	1874	201975000
30389	1726	785303024000
30390	1874	201976000
30391	1726	785293023000
30392	1874	201977000
30393	1726	785283022000
30394	1874	201978000
30395	1397	1386904824000
30396	1678	8640245276000
30397	1397	1386894823000
30398	1678	8640245277000
30399	1397	1386884822000
30400	1678	8640245278000
30401	1705	20875570000000
30402	1705	20875650000000
30414	1740	19435027000000
30415	1740	19435058000000
30426	1694	38880370000000
30439	1440	19440672000000
30452	1684	40320296000000
30453	1684	40320316000000
30457	1649	15120610999992
30488	1555	13680262000000
30489	1555	13680272000000
30512	1397	1386704804000
30513	1678	8640245296000
30514	1726	785113005000
30515	1874	201995000
30528	1726	785083002000
30529	1874	201998000
30530	1397	1386674801000
30531	1678	8640245299000
30532	1668	21600620000000
30533	1668	21600640000000
30551	1397	1386634797000
30552	1678	8640245303000
30553	1726	785042998000
30554	1874	202002000
30555	1683	724331133999541
30556	1683	724331183999541
30572	1397	1386604794000
30573	1678	8640245306000
30574	1726	785012995000
30575	1874	202005000
30584	1726	784992993000
30585	1874	202007000
30586	1397	1386584792000
30587	1678	8640245308000
30596	1692	28820022020000
30623	1683	730091243999541
30624	1683	730091263999541
30631	1397	1386514785000
30632	1678	8640245315000
30633	1726	784912985000
30634	1874	202015000
30635	1703	11519530000000
30636	1703	11519550000000
30646	1397	1386484782000
30647	1678	8640245318000
30648	1726	784892983000
30649	1874	202017000
30650	1679	71281291980000
30651	1679	71281311980000
30671	1726	784852979000
30672	1874	202021000
30673	1397	1386444778000
30674	1678	8640245322000
30675	1560	30240859000000
30676	1560	30240879000000
30682	1397	1386434777000
30683	1678	8640245323000
30684	1726	784842978000
30685	1874	202022000
29986	1874	201937000
29987	1726	785683062000
29988	1874	201938000
29989	1397	1387304864000
29990	1678	8640245236000
29991	1397	1387294863000
29992	1678	8640245237000
29993	1693	8109394945191
29994	653	66344300665601
29995	1693	8107499404570
29996	721	2010433353450
29997	1693	8045266563742
29998	308	66344300665601
29999	1693	7472160516657
30000	1150	611075881460537
30001	1693	7409927675829
30002	84	66344300665601
30003	1693	7347694835001
30004	89	66344300665601
30005	1693	7285461994173
30006	186	66344300665601
30007	1693	7223229153345
30008	383	66344300665601
30009	1693	7160996312517
30010	392	66344300665601
30011	1693	7098763471689
30012	678	66344300665601
30013	1693	7036530630861
30014	339	66344300665601
30015	1693	6974297790033
30016	91	66344300665601
30017	1729	14399270000000
30018	1729	14399430000000
30078	1719	15839380000000
30079	1719	16559380000000
30080	1719	16559560000000
30081	1397	1387254859000
30082	1678	8640245241000
30083	1726	785643058000
30084	1874	201942000
30085	1693	5852211114508
30086	201	66344300665601
30087	1693	5789978273680
30088	1962	343222840828
30089	1693	5727745432852
30090	391	66344300665601
30091	1693	5665512592024
30092	402	66344300665601
30093	1693	5603279751196
30094	397	66344300665601
30095	1700	15119660000000
30096	1397	1387244858000
30097	1678	8640245242000
30098	1726	785633057000
30099	1874	201943000
30100	1693	5541046910368
30101	452	66344300665601
30102	1693	5478814069540
30103	594	66344300665601
30104	1693	5416581228712
30105	690	66344300665601
30106	1693	5354348387884
30107	112	66063270665601
30108	1693	5292115547056
30109	180	66344300665601
30110	1693	5229882706228
30111	106	66344300665601
30112	1679	70561361980000
30135	1711	19439400000000
30136	1711	19439480000000
30155	1726	785603054000
30156	1874	201946000
30157	1397	1387214855000
30158	1678	8640245245000
30159	1693	4481193075671
30160	217	66344300665601
30161	1726	785593053000
30162	1874	201947000
30163	1397	1387204854000
30164	1678	8640245246000
30165	1693	4418960234843
30166	534	66344300665601
30167	1693	4356727394015
30168	620	66344300665601
30169	1693	4294494553187
30170	54	66344300665601
30171	1693	4289770701614
30172	710	5026083383729
30173	1693	4227537860786
30174	499	66344300665601
30175	1693	4165305019958
30176	663	66344300665601
30177	1693	3315911409583
30178	1030	905673387644075
30179	1693	3253678568755
30180	320	66063100665601
30181	1693	2964405030836
30182	893	308423512571246
30183	1693	2902172190008
30184	251	66344300665601
30185	1683	721451043999541
30186	1683	721451193999541
30238	1688	122402725000000
30239	1688	122402755000000
30247	1726	785533047000
30248	1874	201953000
30249	1397	1387134847000
30250	1678	8640245253000
30251	1445	14400260000000
30252	1445	14400280000000
30255	1397	1387124846000
30256	1678	8640245254000
30257	1726	785523046000
30258	1874	201954000
30259	1547	9360242000000
30260	1547	9360262000000
30272	1555	12960242000000
30273	1555	12960262000000
30281	1397	1387084842000
30282	1678	8640245258000
30283	1726	785483042000
30284	1874	201958000
30294	1726	785463040000
30295	1874	201960000
30296	1397	1387064840000
30297	1678	8640245260000
30304	1397	1387044838000
30305	1678	8640245262000
30306	1726	785443038000
30307	1874	201962000
30308	1679	70561301980000
30314	1397	1387034837000
30315	1678	8640245263000
30316	1397	1387024836000
30317	1678	8640245264000
30318	1726	785433037000
30319	1874	201963000
30320	1726	785423036000
30321	1874	201964000
30322	1650	12240380000000
30323	1650	12240420000000
30331	1397	1387004834000
30332	1678	8640245266000
30333	1726	785403034000
30334	1874	201966000
30335	1768	12959391110000
30336	1768	12959411110000
30344	1397	1386984832000
30345	1678	8640245268000
30346	1726	785383032000
30347	1874	201968000
30348	1714	23749410000000
30349	1714	23749430000000
30383	1476	18720370000000
30384	1476	18720390000000
30405	1397	1386874821000
30406	1678	8640245279000
30407	1726	785273021000
30408	1874	201979000
30409	1397	1386864820000
30410	1678	8640245280000
30411	1740	18715027000000
30412	1899	2000000000
30413	1607	25920693000000
30440	1397	1386824816000
30441	1678	8640245284000
30442	1726	785233017000
30443	1874	201983000
30444	1688	123842775000000
30445	1688	123842806000000
30472	1397	1386774811000
30473	1678	8640245289000
30474	1726	785183012000
30475	1874	201988000
30476	1726	785173011000
30477	1874	201989000
30478	1397	1386764810000
30479	1678	8640245290000
30480	1449	730023000459
30481	1449	730063000459
30490	1726	785153009000
30491	1874	201991000
30492	1961	343212840828
30493	1726	785143008000
30494	1874	201992000
30128	266	66344300665601
30129	1693	4916822961467
30130	191	66344300665601
30131	1397	1387234857000
30132	1678	8640245243000
30133	1723	18720260999760
30134	1723	18720340999760
30137	1726	785613055000
30138	1874	201945000
30139	1693	4854590120639
30140	600	66344300665601
30141	1397	1387224856000
30142	1678	8640245244000
30143	1693	4792357279811
30144	352	66344300665601
30145	1693	4730124438983
30146	691	66344300665601
30147	1693	4667891598155
30148	245	66344300665601
30149	1693	4605658757327
30150	421	66344300665601
30151	1693	4543425916499
30152	103	66344300665601
30153	1698	25199491000000
30154	1698	25199571000000
30189	1677	242646211000000
30232	1397	1387164850000
30233	1678	8640245250000
30234	1397	1387154849000
30235	1678	8640245251000
30236	1726	785553049000
30237	1874	201951000
30241	1694	38880360000000
30242	1397	1387144848000
30243	1678	8640245252000
30244	1726	785543048000
30245	1874	201952000
30246	1690	60481041000000
30267	1397	1387104844000
30268	1678	8640245256000
30269	1726	785503044000
30270	1874	201956000
30271	1564	14400292000000
30280	1689	18719472000000
30287	1726	785473041000
30288	1874	201959000
30289	1397	1387074841000
30290	1678	8640245259000
30291	1693	22449053757
30292	1778	2950090000000
30293	1683	721451073999541
30377	1726	785323026000
30378	1874	201974000
30379	1397	1386924826000
30380	1678	8640245274000
30381	1693	742449053757
30382	1693	742469053757
30416	1726	785263020000
30417	1874	201980000
30418	1726	785253019000
30419	1874	201981000
30420	1397	1386854819000
30421	1678	8640245281000
30422	1397	1386844818000
30423	1678	8640245282000
30424	1727	13679302000000
30425	1727	13679342000000
30433	1402	71282712000000
30434	1402	71282733000000
30437	1692	28820002020000
30438	1692	28820023020000
30448	1397	1386814815000
30449	1678	8640245285000
30450	1726	785223016000
30451	1874	201984000
30455	1649	15120600999992
30456	1649	15120620999992
30458	1397	1386804814000
30459	1678	8640245286000
30460	1726	785213015000
30461	1874	201985000
30462	1726	785203014000
30463	1874	201986000
30464	1726	785193013000
30465	1874	201987000
30466	1397	1386794813000
30467	1678	8640245287000
30468	1397	1386784812000
30469	1678	8640245288000
30470	1683	722891073999541
30471	1683	722891133999541
30482	1397	1386754809000
30483	1678	8640245291000
30484	1726	785163010000
30485	1874	201990000
30486	1686	12452246500013
30487	1686	12452266500013
30500	1726	785133007000
30501	1874	201993000
30502	1726	785123006000
30503	1874	201994000
30504	1690	60481061000000
30505	1962	343212840828
30506	1397	1386724806000
30507	1678	8640245294000
30508	1397	1386714805000
30509	1678	8640245295000
30510	1690	61201061000000
30511	1690	61201091000000
30543	1726	785073001000
30544	1874	201999000
30545	1726	785063000000
30546	1874	202000000
30547	1726	785052999000
30548	1874	202001000
30549	1688	124562795000000
30550	1688	124562856000000
30557	1397	1386624796000
30558	1678	8640245304000
30559	1726	785032997000
30560	1874	202003000
30561	1683	725771183999541
30562	1683	725771203999541
30570	1451	13680421000000
30571	1451	13680441000000
30576	1397	1386594793000
30577	1678	8640245307000
30578	1726	785002994000
30579	1874	202006000
30580	1672	18000542000000
30581	1672	18000562000000
30597	1474	16834314000000
30598	1397	1386564790000
30599	1678	8640245310000
30600	1397	1386554789000
30601	1678	8640245311000
30602	1726	784972991000
30603	1874	202009000
30604	1726	784962990000
30605	1874	202010000
30606	1726	784952989000
30607	1874	202011000
30608	1623	26641830899898
30625	1397	1386524786000
30626	1678	8640245314000
30627	1726	784922986000
30628	1874	202014000
30629	1685	66240658571430
30630	1685	66240678571430
30654	1729	15119430000000
30655	1729	15119450000000
30656	1397	1386474781000
30657	1678	8640245319000
30658	1726	784882982000
30659	1874	202018000
30660	1613	15838630000000
30661	1613	15838650000000
30677	1950	97990000000
30678	1969	1000000000
30679	1900	66000000
30680	1688	125282815000000
30681	1688	125282826000000
30694	1706	18716512000000
30701	1726	784812975000
30702	1874	202025000
30703	1726	784802974000
30704	1874	202026000
30705	1397	1386404774000
30706	1678	8640245326000
30707	369	86160562000000
30708	1397	1386394773000
30709	1678	8640245327000
30710	369	86880562000000
30724	1474	16114284000000
30725	1962	280990000000
30726	1719	16561090000000
30727	1719	17281090000000
30728	1870	17281909999999
30729	1719	200000001
30757	1726	784732967000
30758	1874	202033000
30759	1397	1386324766000
30760	1678	8640245334000
30761	1397	1386314765000
30762	1678	8640245335000
30342	1419	22320490000000
30343	1419	22320510000000
30356	1419	23040510000000
30357	1419	23040530000000
30403	1643	3456285113700
30404	1643	3456365113700
30427	1397	1386834817000
30428	1678	8640245283000
30429	1726	785243018000
30430	1874	201982000
30431	1899	1999000000
30432	1693	742470053757
30435	1440	19440662000000
30436	1440	19440683000000
30446	43	84720459890000
30447	43	84720490890000
30454	1688	123842795000000
30516	1807	20160409999999
30517	1759	200000001
30522	1397	1386684802000
30523	1678	8640245298000
30524	1726	785093003000
30525	1874	201997000
30526	44	82560990000000
30527	44	82561010000000
30563	149	78240307000000
30564	149	78240327000000
30594	1683	727211203999541
30595	1683	727211223999541
30609	1397	1386544788000
30610	1678	8640245312000
30611	1726	784942988000
30612	1874	202012000
30613	1683	728651223999541
30614	1683	728651243999541
30621	1422	15120281000000
30622	1422	15120301000000
30640	1397	1386494783000
30641	1678	8640245317000
30642	1726	784902984000
30643	1874	202016000
30644	1623	27361830899898
30645	1623	27361850899898
30666	1726	784862980000
30667	1874	202020000
30668	1397	1386454779000
30669	1678	8640245321000
30670	1749	15115348000000
30697	1397	1386414775000
30698	1678	8640245325000
30699	1726	784822976000
30700	1874	202024000
30711	1683	728651273999541
30712	1683	730091273999541
30713	1683	730091283999541
30717	1397	1386384772000
30718	1678	8640245328000
30719	1688	125282825000000
30735	1445	15120280000000
30736	1445	15120300000000
30743	1397	1386354769000
30744	1678	8640245331000
30745	1726	784762970000
30746	1874	202030000
30747	1726	784752969000
30748	1874	202031000
30749	1397	1386344768000
30750	1678	8640245332000
30766	1726	784712965000
30767	1874	202035000
30768	1726	784702964000
30769	1874	202036000
30770	1397	1386304764000
30771	1678	8640245336000
30772	1397	1386294763000
30773	1678	8640245337000
30774	1711	19439440000000
30776	1739	15119520000000
30777	1739	15119560000000
30809	1695	15839441000000
30810	1695	15839461000000
30813	1726	782222958000
30814	1874	202042000
30815	1397	1386234757000
30816	1678	8640245343000
30817	1397	1386224756000
30818	1678	8640245344000
30819	1726	782212957000
30820	1874	202043000
30821	1688	125282855000000
30857	1715	22320282000000
30864	1726	782132949000
30865	1874	202051000
30866	1397	1386144748000
30867	1678	8640245352000
30868	1547	10080262000000
30869	1547	10080282000000
30870	1397	1386134747000
30871	1678	8640245353000
30872	1726	782122948000
30873	1874	202052000
30874	1726	782112947000
30875	1874	202053000
30876	1726	782102946000
30877	1874	202054000
30878	1726	782092945000
30879	1874	202055000
30880	1397	1386124746000
30881	1678	8640245354000
30882	1397	1386114745000
30883	1678	8640245355000
30884	1397	1386104744000
30885	1678	8640245356000
30886	1683	732971303999541
30887	1683	732971383999541
30896	1613	16558650000000
30897	1613	16558670000000
30959	1449	30053000459
30960	1939	1409000000000
30961	1625	720000000000
30962	1625	720010000000
30978	1715	23040282000000
30979	1715	23040302000000
31013	1397	1385914725000
31014	1678	8640245375000
31015	1726	779492927000
31016	1874	202073000
31017	1683	735851423999541
31018	1683	735851443999541
31038	1555	13680282000000
31064	1509	20880542000000
31065	1509	20880583000000
31066	1397	1385834717000
31067	1678	8640245383000
31068	1726	779422920000
31069	1874	202080000
31086	1683	737291443999541
31087	1683	737291463999541
31097	1397	1385794713000
31098	1678	8640245387000
31099	1726	779382916000
31100	1874	202084000
31101	1467	18002011100000
31102	1467	18002041100000
31145	1715	23760322000000
31146	1715	23760592000000
31167	1397	1385684702000
31168	1678	8640245398000
31169	1726	779272905000
31170	1874	202095000
31171	1689	19439472000000
31172	1689	19439492000000
31175	1726	778062905000
31176	1974	200000000
31177	1726	776852905000
31178	1975	200000000
31179	1397	1385674701000
31180	1678	8640245399000
31181	1726	776842904000
31182	1874	202096000
31183	1677	247686481000000
31194	1706	19436512000000
31195	1706	19436532000000
31225	1726	775562897000
31226	1976	200000000
31227	1397	1385594693000
31228	1678	8640245407000
31229	1688	126722937000000
31259	1611	15830600000000
31289	1680	25919510000000
31290	1680	25919780000000
31294	1747	8638970000000
31295	1726	775452886000
31296	1874	202114000
31297	1397	1385484682000
31298	1678	8640245418000
31299	1677	249846661000000
31302	1726	775442885000
31303	1874	202115000
31304	1397	1385474681000
31305	1678	8640245419000
31306	1444	19440633000000
31307	1444	19440653000000
31317	1637	113762854819997
31318	1637	113762884819997
30495	1397	1386744808000
30496	1678	8640245292000
30497	1397	1386734807000
30498	1678	8640245293000
30499	1677	242646261000000
30518	1397	1386694803000
30519	1678	8640245297000
30520	1726	785103004000
30521	1874	201996000
30534	1397	1386664800000
30535	1678	8640245300000
30536	1397	1386654799000
30537	1678	8640245301000
30538	1397	1386644798000
30539	1678	8640245302000
30540	1740	18715026000000
30541	1708	12959520000000
30542	1708	12959551000000
30565	1726	785022996000
30566	1874	202004000
30567	1397	1386614795000
30568	1678	8640245305000
30569	1688	124562815000000
30582	1637	110162734819997
30583	1637	110162754819997
30588	1726	784982992000
30589	1874	202008000
30590	1397	1386574791000
30591	1678	8640245309000
30592	1671	23041120000000
30593	1671	23041140000000
30615	1397	1386534787000
30616	1678	8640245313000
30617	1726	784932987000
30618	1874	202013000
30619	1677	243366261000000
30620	1677	243366281000000
30637	1397	1386504784000
30638	1678	8640245316000
30639	1679	70561291980000
30652	1623	28081850899898
30653	1623	28081870899898
30662	1726	784872981000
30663	1874	202019000
30664	1397	1386464780000
30665	1678	8640245320000
30687	1726	784832977000
30688	1874	202023000
30689	238	66000170000000
30690	1474	17554314000000
30691	1397	1386424776000
30692	1678	8640245324000
30693	1623	28081880899898
30714	1549	25920666000000
30715	1549	26640666000000
30716	1549	26640676000000
30720	1726	784792973000
30721	1874	202027000
30722	1677	244086281000000
30723	1677	244086301000000
30730	1397	1386374771000
30731	1678	8640245329000
30732	1726	784782972000
30733	1874	202028000
30734	1457	20880481000000
30751	1397	1386334767000
30752	1678	8640245333000
30753	1726	784742968000
30754	1874	202032000
30755	1864	0
30756	1932	549980000000
30788	1474	16834304000000
30789	1950	817990000000
30790	1726	784672961000
30791	1874	202039000
30792	1726	783462961000
30793	1970	200000000
30794	1726	783452960000
30795	1874	202040000
30796	1726	782242960000
30797	1934	1200000000
30798	1397	1386264760000
30799	1678	8640245340000
30800	1397	1386254759000
30801	1678	8640245341000
30802	1633	15120270000000
30822	1677	245526381000000
30825	1397	1386214755000
30826	1678	8640245345000
30827	1726	782202956000
30828	1874	202044000
30829	1686	13172266500013
30830	1686	13172286500013
30831	1950	617980000000
30832	1971	199000000000
30833	1726	782192955000
30834	1874	202045000
30835	1726	782182954000
30836	1874	202046000
30837	1724	20878090000000
30838	341	66001000000000
30839	1726	782172953000
30840	1874	202047000
30841	1726	782162952000
30842	1874	202048000
30843	1397	1386204754000
30844	1678	8640245346000
30845	1397	1386194753000
30846	1678	8640245347000
30847	1397	1386184752000
30848	1678	8640245348000
30849	1397	1386174751000
30850	1678	8640245349000
30851	1685	66960678571430
30852	1685	66960778571430
30888	1726	782082944000
30889	1874	202056000
30890	1397	1386094743000
30891	1678	8640245357000
30892	1762	12239310000000
30893	1762	12239330000000
30904	1726	782062942000
30905	1874	202058000
30906	1726	782052941000
30907	1874	202059000
30908	1397	1386074741000
30909	1678	8640245359000
30910	1397	1386064740000
30911	1678	8640245360000
30912	1677	246246381000000
30913	1677	246246421000000
30914	1397	1386054739000
30915	1678	8640245361000
30916	1397	1386044738000
30917	1678	8640245362000
30918	1726	782042940000
30919	1874	202060000
30920	1726	782032939000
30921	1874	202061000
30922	1677	246966421000000
30923	1677	246966461000000
30924	1684	40320336000000
30928	1726	782022938000
30929	1874	202062000
30930	1397	1386034737000
30931	1678	8640245363000
30932	1536	18720460000000
30949	1397	1385994733000
30950	1678	8640245367000
30951	1397	1385984732000
30952	1678	8640245368000
30953	1726	781982934000
30954	1874	202066000
30955	1726	781972933000
30956	1874	202067000
30957	1723	20160360999760
30958	1723	20160400999760
30963	1939	708990000000
30964	1939	1408990000000
30965	1603	720000000000
30966	1603	720020000000
30967	1397	1385974731000
30968	1678	8640245369000
30969	1726	781962932000
30970	1874	202068000
30971	1625	720040000000
30987	1474	14674223000000
30988	1474	13954213000000
30989	1932	352990000000
30990	528	66002380000000
30991	1693	11039668897158
30992	1693	10977436056330
30993	528	66722380000000
30994	528	66722430000000
31003	1397	1385934727000
31004	1678	8640245373000
31005	1397	1385924726000
31006	1678	8640245374000
31007	1726	779512929000
31008	1874	202071000
31009	1726	779502928000
31010	1874	202072000
31011	1637	110882754819997
31012	1637	110882794819997
31032	1397	1385884722000
30686	1693	742480053757
30695	618	67440020000000
30696	618	67440050000000
30737	1726	784772971000
30738	1874	202029000
30739	1397	1386364770000
30740	1678	8640245330000
30741	1723	19440340999760
30742	1723	19440360999760
30775	1679	71281331980000
30778	1397	1386284762000
30779	1678	8640245338000
30780	1726	784692963000
30781	1874	202037000
30782	1397	1386274761000
30783	1678	8640245339000
30784	1726	784682962000
30785	1874	202038000
30786	1677	244806301000000
30787	1677	244806341000000
30898	1633	15840270000000
30899	1633	15840290000000
30900	1397	1386084742000
30901	1678	8640245358000
30902	1726	782072943000
30903	1874	202057000
30927	1536	18720440000000
30933	1726	782012937000
30934	1874	202063000
30935	1397	1386024736000
30936	1678	8640245364000
30937	1677	246246441000000
30938	1677	246966441000000
30939	1726	782002936000
30940	1874	202064000
30941	1726	781992935000
30942	1874	202065000
30943	1397	1386014735000
30944	1678	8640245365000
30945	1397	1386004734000
30946	1678	8640245366000
30947	1683	734411383999541
30948	1683	734411423999541
30980	1467	17282001100000
31001	1610	21600790000000
31002	1610	21600810000000
31019	1740	19435026000000
31020	1740	19435046000000
31031	1715	23040322000000
31047	1397	1385864720000
31048	1678	8640245380000
31049	44	82551009000000
31050	27	10010000000000
31051	1547	10800282000000
31052	1547	10800293000000
31072	1685	67680798571430
31079	1637	111602794819997
31080	1637	111602814819997
31103	1726	779372915000
31104	1874	202085000
31105	1726	779362914000
31106	1874	202086000
31107	1397	1385784712000
31108	1678	8640245388000
31109	1397	1385774711000
31110	1678	8640245389000
31111	1683	738731463999541
31112	1683	738731503999541
31120	1726	779342912000
31121	1874	202088000
31122	1397	1385754709000
31123	1678	8640245391000
31124	1397	1385744708000
31125	1678	8640245392000
31126	1397	1385734707000
31127	1678	8640245393000
31128	1726	779332911000
31129	1874	202089000
31130	1726	779322910000
31131	1874	202090000
31132	44	82541008000000
31133	9	32568000000000
31134	1688	126002856000000
31135	1688	126002917000000
31173	1683	740171503999541
31174	1683	740171523999541
31184	1397	1385664700000
31185	1678	8640245400000
31186	1726	776832903000
31187	1874	202097000
31196	528	66001900000000
31197	1726	776812901000
31198	1874	202099000
31199	1726	776802900000
31200	1874	202100000
31201	1726	776792899000
31202	1874	202101000
31203	1397	1385644698000
31204	1678	8640245402000
31205	1397	1385634697000
31206	1678	8640245403000
31207	1397	1385624696000
31208	1678	8640245404000
31209	1688	126722917000000
31210	1688	126723077000000
31213	1726	776782898000
31214	1874	202102000
31215	1397	1385614695000
31216	1678	8640245405000
31217	1422	16560321000000
31218	1422	16560341000000
31230	1726	775552896000
31231	1874	202104000
31232	1397	1385584692000
31233	1678	8640245408000
31234	1729	15839450000000
31235	1729	15839470000000
31237	1726	775542895000
31238	1874	202105000
31239	1397	1385574691000
31240	1678	8640245409000
31266	1683	744491703999541
31267	1683	744491723999541
31291	1677	249846641000000
31292	1677	249846911000000
31308	1726	775432884000
31309	1874	202116000
31310	1397	1385464680000
31311	1678	8640245420000
31312	1397	1385454679000
31313	1678	8640245421000
31314	1444	20160653000000
31315	1444	20160683000000
31332	1726	775402881000
31333	1874	202119000
31334	1397	1385424676000
31335	1678	8640245424000
31336	1700	15839680000000
31337	1397	1385414675000
31338	1678	8640245425000
31339	1726	775392880000
31340	1874	202120000
31341	1673	19440820000000
31342	1673	19440840000000
31361	1397	1385384672000
31362	1678	8640245428000
31363	1397	1385374671000
31364	1678	8640245429000
31365	1726	775362877000
31366	1874	202123000
31367	1726	775352876000
31368	1874	202124000
31369	9	32567999000000
31370	1708	13679551000000
31371	1708	13679592000000
31393	1670	7467910000000
31394	1036	906130465000000
31395	1726	775322873000
31396	1874	202127000
31397	1726	775312872000
31398	1874	202128000
31399	1397	1385344668000
31400	1678	8640245432000
31401	1397	1385334667000
31402	1678	8640245433000
31403	1688	128882977000000
31404	1688	128883117000000
31426	1594	16560450000000
31427	1594	16560470000000
31430	1670	1109710000000
31431	916	505655775000000
31432	1397	1385294663000
31433	1678	8640245437000
31434	1726	775272868000
31435	1874	202132000
31436	43	86160510890000
31437	43	86160630890000
31462	1747	9358970000000
31463	1747	9359010000000
31495	1397	1385184652000
31496	1678	8640245448000
31497	1726	775172858000
31498	1874	202142000
31499	1608	15120360000000
31500	1608	15120380000000
30763	1726	784722966000
30764	1874	202034000
30765	1716	21599471000000
30803	1726	782232959000
30804	1874	202041000
30805	1397	1386244758000
30806	1678	8640245342000
30807	1677	245526341000000
30808	1677	245526361000000
30811	1426	13680450000000
30812	1426	13680470000000
30823	1739	15839560000000
30824	1739	15839600000000
30853	1726	782152951000
30854	1874	202049000
30855	1397	1386164750000
30856	1678	8640245350000
30858	1726	782142950000
30859	1874	202050000
30860	1397	1386154749000
30861	1678	8640245351000
30862	1683	731531283999541
30863	1683	731531303999541
30894	1690	61921091000000
30895	1690	61921111000000
30925	1685	67680778571430
30926	1685	67680818571430
30972	1397	1385964730000
30973	1678	8640245370000
30974	1726	780752932000
30975	1972	200000000
30976	1850	17985540000000
30977	1850	17985560000000
30981	1397	1385954729000
30982	1678	8640245371000
30983	1726	779542932000
30984	1973	200000000
30985	1726	779532931000
30986	1874	202069000
30995	1726	779522930000
30996	1874	202070000
30997	1397	1385944728000
30998	1678	8640245372000
30999	1673	18720800000000
31000	1673	18720820000000
31021	1397	1385904724000
31022	1678	8640245376000
31023	1726	779482926000
31024	1874	202074000
31025	1726	779472925000
31026	1874	202075000
31027	1397	1385894723000
31028	1678	8640245377000
31029	1684	41040336000000
31030	1684	41040376000000
31045	1723	20880400999760
31046	1723	20880420999760
31063	1688	125282856000000
31073	1726	779412919000
31074	1874	202081000
31075	1397	1385824716000
31076	1678	8640245384000
31077	1677	247686441000000
31078	1677	247686461000000
31081	1726	779402918000
31082	1874	202082000
31083	1397	1385814715000
31084	1678	8640245385000
31085	1705	20875590000000
31092	1726	779392917000
31093	1874	202083000
31094	1749	15835368000000
31119	1440	20160924000000
31144	1764	18720679100000
31157	1397	1385704704000
31158	1678	8640245396000
31159	1397	1385694703000
31160	1678	8640245397000
31161	1726	779292907000
31162	1874	202093000
31163	1726	779282906000
31164	1874	202094000
31165	1656	22320461000000
31166	1656	22320501000000
31188	1397	1385654699000
31189	1678	8640245401000
31190	1726	776822902000
31191	1874	202098000
31192	1683	741611523999541
31193	1683	741611543999541
31211	1683	743051543999541
31212	1683	743051703999541
31249	724	20001400000000
31250	1726	775522893000
31251	1874	202107000
31252	1397	1385554689000
31253	1678	8640245411000
31254	1397	1385544688000
31255	1678	8640245412000
31256	1726	775512892000
31257	1874	202108000
31258	1447	20880780000000
31260	1726	775502891000
31261	1874	202109000
31262	1397	1385534687000
31263	1678	8640245413000
31264	1688	127442937000000
31265	1688	127442957000000
31278	1726	775472888000
31279	1874	202112000
31280	1397	1385504684000
31281	1678	8640245416000
31282	498	66001500000000
31283	1726	775462887000
31284	1874	202113000
31285	1397	1385494683000
31286	1678	8640245417000
31287	1746	6479141000000
31288	1746	6479411000000
31325	1727	13679322000000
31330	1683	745931733999541
31331	1683	745931753999541
31357	1474	17554304000000
31358	1474	17554454000000
31392	1608	14400360000000
31420	1726	775282869000
31421	1874	202131000
31422	1397	1385304664000
31423	1678	8640245436000
31424	1677	251286702000000
31425	1677	251286722000000
31452	1726	775252866000
31453	1874	202134000
31454	1726	775242865000
31455	1874	202135000
31456	1397	1385264660000
31457	1678	8640245440000
31458	1397	1385254659000
31459	1678	8640245441000
31460	1746	6479181000000
31472	1397	1385224656000
31473	1678	8640245444000
31474	1726	775212862000
31475	1874	202138000
31476	1716	22319471000000
31477	1716	22319491000000
31501	1560	31680919000000
31502	1560	31680939000000
31504	1654	15840360000000
31519	1726	775142855000
31520	1874	202145000
31521	1726	775132854000
31522	1874	202146000
31523	1397	1385144648000
31524	1678	8640245452000
31525	1397	1385134647000
31526	1678	8640245453000
31527	1594	17280470000000
31528	1594	17280510000000
31537	1397	1385104644000
31538	1678	8640245456000
31539	1726	775102851000
31540	1874	202149000
31541	1726	775092850000
31542	1874	202150000
31543	1397	1385094643000
31544	1678	8640245457000
31555	1656	23040501000000
31556	1656	23040522000000
31590	1397	1385014635000
31591	1678	8640245465000
31592	1726	775012842000
31593	1874	202158000
31594	1688	129603207000000
31595	1688	129603227000000
31604	1726	774992840000
31605	1874	202160000
31606	1397	1384994633000
31607	1678	8640245467000
31612	1397	1384974631000
31613	1678	8640245469000
31614	1726	774972838000
31615	1874	202162000
31616	1559	19440560000000
31626	1685	68400798571430
31033	1678	8640245378000
31034	1726	779462924000
31035	1874	202076000
31036	1439	12960250000000
31037	1439	12960270000000
31039	1397	1385874721000
31040	1678	8640245379000
31041	1726	779452923000
31042	1874	202077000
31043	1422	15840301000000
31044	1422	15840321000000
31053	1397	1385854719000
31054	1678	8640245381000
31055	1726	779442922000
31056	1874	202078000
31057	1726	779432921000
31058	1874	202079000
31059	1397	1385844718000
31060	1678	8640245382000
31061	563	66000527000000
31062	1451	13680462000000
31070	43	85440490890000
31071	43	85440510890000
31088	1397	1385804714000
31089	1678	8640245386000
31090	1749	15835348000000
31091	1749	15835358000000
31095	1467	18002001100000
31096	1467	18002003100000
31113	1726	779352913000
31114	1874	202087000
31115	1397	1385764710000
31116	1678	8640245390000
31117	1440	20160672000000
31118	1440	20160692000000
31136	498	66001750000000
31137	1956	1000000000
31138	1397	1385724706000
31139	1678	8640245394000
31140	1726	779312909000
31141	1874	202091000
31142	1764	18720419100000
31143	1764	18720689100000
31147	1961	280990000000
31148	1474	15394274000000
31149	1513	15121440000000
31150	1513	15841440000000
31151	1513	15842020000000
31152	1726	779302908000
31153	1874	202092000
31154	1397	1385714705000
31155	1678	8640245395000
31156	1718	13577552889008
31219	1397	1385604694000
31220	1678	8640245406000
31221	1726	776772897000
31222	1874	202103000
31223	1637	112322814819997
31224	1637	112322834819997
31236	1715	23760342000000
31241	724	20001650000000
31242	1956	2000000000
31243	1397	1385564690000
31244	1678	8640245410000
31245	1726	775532894000
31246	1874	202106000
31247	1677	248406481000000
31248	1677	248406601000000
31268	1726	775492890000
31269	1874	202110000
31270	1726	775482889000
31271	1874	202111000
31272	1397	1385524686000
31273	1678	8640245414000
31274	1397	1385514685000
31275	1678	8640245415000
31276	1677	249126601000000
31277	1677	249126641000000
31293	1704	3599380000000
31300	1637	113042834819997
31301	1637	113042854819997
31316	1683	744491733999541
31319	1397	1385444678000
31320	1678	8640245422000
31321	1726	775422883000
31322	1874	202117000
31323	1693	1462480053757
31324	1693	1462500053757
31326	1397	1385434677000
31327	1678	8640245423000
31328	1726	775412882000
31329	1874	202118000
31343	1670	22319110000000
31344	1977	500000000
31345	1726	775382879000
31346	1874	202121000
31347	411	66719910000000
31348	1950	618080000000
31349	1397	1385404674000
31350	1678	8640245426000
31351	1397	1385394673000
31352	1678	8640245427000
31353	1726	775372878000
31354	1874	202122000
31355	700	73200260000000
31356	700	73200410000000
31372	1677	250566661000000
31373	1677	250566702000000
31386	1397	1385354669000
31387	1678	8640245431000
31388	1726	775332874000
31389	1874	202126000
31390	1688	128162957000000
31391	1688	128162977000000
31405	1673	20160840000000
31406	1673	20160980000000
31418	1447	21600510000000
31419	1447	21600650000000
31428	1692	29540022020000
31429	1692	29540042020000
31438	1683	745931853999541
31441	1670	610000000
31442	1977	1109500000000
31443	1950	689410000000
31444	1971	427570000000
31445	1397	1385284662000
31446	1678	8640245438000
31447	1397	1385274661000
31448	1678	8640245439000
31449	1726	775262867000
31450	1874	202133000
31451	1688	128883207000000
31468	1397	1385234657000
31469	1678	8640245443000
31470	1726	775222863000
31471	1874	202137000
31480	1397	1385214655000
31481	1678	8640245445000
31482	1397	1385204654000
31483	1678	8640245446000
31484	1726	775202861000
31485	1874	202139000
31486	1726	775192860000
31487	1874	202140000
31488	1560	30960919000000
31510	1397	1385164650000
31511	1678	8640245450000
31512	1397	1385154649000
31513	1678	8640245451000
31514	1726	775162857000
31515	1874	202143000
31516	1726	775152856000
31517	1874	202144000
31518	1677	251286742000000
31533	1726	775112852000
31534	1874	202148000
31535	1397	1385114645000
31536	1678	8640245455000
31547	1726	775082849000
31548	1874	202151000
31549	1397	1385084642000
31550	1678	8640245458000
31551	1764	18520678100000
31552	1950	889410000000
31553	1693	2182500053757
31554	1693	2182521053757
31557	1726	775072848000
31558	1874	202152000
31559	1397	1385074641000
31560	1678	8640245459000
31561	1726	775062847000
31562	1874	202153000
31563	1726	775052846000
31564	1874	202154000
31565	1726	775042845000
31566	1874	202155000
31567	1726	775032844000
31568	1874	202156000
31569	1397	1385064640000
31570	1678	8640245460000
31571	1397	1385054639000
31572	1678	8640245461000
31573	1397	1385044638000
31574	1678	8640245462000
31575	1397	1385034637000
31359	1768	12959541110000
31360	1637	113763004819997
31374	1670	12625010000000
31375	1282	1703674637751650
31376	411	66419900000000
31377	1950	918080000000
31378	1397	1385364670000
31379	1678	8640245430000
31380	1726	775342875000
31381	1874	202125000
31382	9	32565998000000
31383	1474	16836304000000
31384	1672	18720562000000
31385	1672	18720693000000
31407	1670	3987810000000
31408	1156	611384750000000
31409	1397	1385324666000
31410	1678	8640245434000
31411	1397	1385314665000
31412	1678	8640245435000
31413	1726	775302871000
31414	1874	202129000
31415	1726	775292870000
31416	1874	202130000
31417	1451	13680561000000
31439	1637	114483004819997
31440	1637	114483114819997
31461	1704	3599150000000
31464	1726	775232864000
31465	1874	202136000
31466	1397	1385244658000
31467	1678	8640245442000
31478	1560	30960879000000
31479	1560	30960899000000
31489	1397	1385194653000
31490	1678	8640245447000
31491	1726	775182859000
31492	1874	202141000
31493	1426	14400470000000
31494	1426	14400490000000
31529	1397	1385124646000
31530	1678	8640245454000
31531	1726	775122853000
31532	1874	202147000
31581	1611	16550600000000
31582	1611	16550681000000
31617	1559	19440550000000
31640	1950	3689400000000
31641	1726	774932834000
31642	1874	202166000
31643	1397	1384934627000
31644	1678	8640245473000
31645	1397	1384924626000
31646	1678	8640245474000
31647	1699	8854180000078
31648	1699	8854220000078
31651	1726	774922833000
31652	1874	202167000
31653	1397	1384914625000
31654	1678	8640245475000
31655	1680	25919530000000
31673	1726	774892830000
31674	1874	202170000
31675	1397	1384884622000
31676	1678	8640245478000
31677	1747	9358990000000
31695	1726	774852826000
31696	1874	202174000
31697	1397	1384844618000
31698	1678	8640245482000
31699	1726	774842825000
31700	1874	202175000
31701	1397	1384834617000
31702	1678	8640245483000
31703	1596	15997575000000
31704	1596	15997615000000
31737	1596	16717615000000
31738	1596	16717657000000
31749	1685	69120818571430
31750	1685	69120858571430
31768	42	82558040000000
31769	42	82558063000000
31774	1611	16550620000000
31776	1397	1384714605000
31777	1678	8640245495000
31778	1726	774732814000
31779	1874	202186000
31780	1677	253446802000000
31781	1677	253446822000000
31786	44	83261008000000
31787	44	83261028000000
31807	1474	17556304000000
31808	1474	17556394000000
31811	1397	1384654599000
31812	1678	8640245501000
31813	1397	1384644598000
31814	1678	8640245502000
31815	1397	1384634597000
31816	1678	8640245503000
31817	1726	774672808000
31818	1874	202192000
31819	1726	774662807000
31820	1874	202193000
31821	1726	774652806000
31822	1874	202194000
31823	1677	252726862000000
31824	1677	253446862000000
31825	1726	774642805000
31826	1874	202195000
31827	1397	1384624596000
31828	1678	8640245504000
31829	1397	1384614595000
31830	1678	8640245505000
31831	1397	1384604594000
31832	1678	8640245506000
31833	1709	16557501000000
31834	1726	774632804000
31835	1874	202196000
31836	1726	774622803000
31837	1874	202197000
31838	1623	28801890899898
31839	1623	28801960899898
31921	606	81840330000000
31922	606	81840350000000
31503	1560	31680929000000
31505	1397	1385174651000
31506	1678	8640245449000
31507	1657	16560310000000
31508	1657	16560320000000
31509	1654	15840370000000
31545	1683	747371853999541
31546	1683	747371893999541
31583	1974	0
31584	1972	300000000
31585	1397	1385024636000
31586	1678	8640245464000
31587	1726	775022843000
31588	1874	202157000
31589	1683	747371973999541
31596	1683	748811973999541
31597	1683	748811993999541
31608	1726	774982839000
31609	1874	202161000
31610	1397	1384984632000
31611	1678	8640245468000
31649	1677	252006742000000
31650	1677	252006782000000
31656	1547	11520293000000
31657	1547	11520313000000
31662	1685	68400818571430
31665	1726	774902831000
31666	1874	202169000
31667	1397	1384894623000
31668	1678	8640245477000
31669	1683	751692023999541
31670	1683	751692043999541
31678	1746	7199181000000
31679	1746	7199201000000
31680	1726	774882829000
31681	1874	202171000
31682	1726	774872828000
31683	1874	202172000
31684	1397	1384874621000
31685	1678	8640245479000
31686	1397	1384864620000
31687	1678	8640245480000
31688	1719	16559360000000
31714	1613	16558680000000
31716	1397	1384814615000
31717	1678	8640245485000
31718	1950	3389390000000
31719	1971	1027570000000
31751	1397	1384754609000
31752	1678	8640245491000
31753	1726	774772818000
31754	1874	202182000
31755	1397	1384744608000
31756	1678	8640245492000
31757	1726	774762817000
31758	1874	202183000
31759	1623	28081890899898
31809	1749	16555358000000
31810	1749	16555448000000
31853	1726	774592800000
31854	1874	202200000
31855	1397	1384574591000
31856	1678	8640245509000
31857	1694	38426327977032
31858	57	66454027022968
31859	1979	40000000
31860	1694	37972290954064
31861	60	66454027022968
31862	1694	37518253931096
31863	61	66454027022968
31864	1694	37294271024826
31865	21	32781972906270
31866	1694	36840234001858
31867	52	66454027022968
31868	1694	36386196978890
31869	73	66454027022968
31870	1694	35932159955922
31871	68	66454027022968
31872	1694	35478122932954
31873	67	66454027022968
31874	1694	35024085909986
31875	81	66454027022968
31876	1694	34570048887018
31877	156	66454027022968
31878	1694	34116011864050
31879	164	66454027022968
31880	1694	33661974841082
31881	129	66454027022968
31882	1694	33207937818114
31883	428	66454027022968
31884	1694	32753900795146
31885	432	66454027022968
31886	1694	32299863772178
31887	433	66454027022968
31888	1694	31845826749210
31889	628	66454027022968
31890	1694	31391789726242
31891	222	66454027022968
31892	1694	30937752703274
31893	431	66454027022968
31894	1694	30483715680306
31895	574	66454027022968
31896	1694	30029678657338
31897	256	66454027022968
31898	1694	29575641634370
31899	604	66454027022968
31900	1694	29121604611402
31901	220	66454027022968
31902	1694	28667567588434
31903	371	66454027022968
31904	1694	28213530565466
31905	638	66454027022968
31906	1694	24680132202245
31907	951	506311163363221
31908	1694	18348558224952
31909	1071	907305028977293
31910	1694	14076418236419
31911	1191	612176879988533
31912	1694	2172274127629
31913	1317	1705884771860440
31914	1688	130323559000000
31923	1397	1384554589000
31924	1678	8640245511000
31925	1979	20000000
31926	1776	999000000
31927	1397	1384544588000
31928	1678	8640245512000
31929	1397	1384534587000
31930	1678	8640245513000
31931	1726	774572798000
31932	1874	202202000
31933	1726	774562797000
31934	1874	202203000
31935	1726	774552796000
31936	1874	202204000
31937	1690	61921161000000
31576	1678	8640245463000
31577	1764	15720677100000
31578	1950	3689410000000
31579	1422	17280341000000
31580	1422	17280422000000
31598	1397	1385004634000
31599	1678	8640245466000
31600	1726	775002841000
31601	1874	202159000
31602	1679	72001311980000
31603	1679	72001331980000
31618	1958	705988000000
31619	1978	2000000000
31620	1726	774962837000
31621	1874	202163000
31622	1397	1384964630000
31623	1678	8640245470000
31624	1683	750251993999541
31625	1683	750252023999541
31628	1726	774952836000
31629	1874	202164000
31630	1397	1384954629000
31631	1678	8640245471000
31632	1588	18000530000000
31633	1588	18000550000000
31663	1692	30260042020000
31664	1692	30260062020000
31671	1593	18720571000000
31672	1593	18720591000000
31705	1637	114483044819997
31720	1726	774822823000
31721	1874	202177000
31722	1397	1384804614000
31723	1678	8640245486000
31724	1677	252726782000000
31725	1677	252726802000000
31739	1397	1384774611000
31740	1678	8640245489000
31741	1726	774792820000
31742	1874	202180000
31743	1397	1384764610000
31744	1678	8640245490000
31745	1726	774782819000
31746	1874	202181000
31747	1688	130323249000000
31748	1688	130323289000000
31770	1726	774742815000
31771	1874	202185000
31772	1397	1384724606000
31773	1678	8640245494000
31775	1637	114483024819997
31840	1726	774612802000
31841	1874	202198000
31842	1397	1384594593000
31843	1678	8640245507000
31844	1709	16556450000000
31845	1979	50000000
31846	1402	72002752000000
31847	1402	72002773000000
31915	1397	1384564590000
31916	1678	8640245510000
31917	1726	774582799000
31918	1874	202201000
31919	1762	12959330000000
31920	1762	12959350000000
31627	1685	68400828571430
31634	1397	1384944628000
31635	1678	8640245472000
31636	1726	774942835000
31637	1874	202165000
31638	1549	26640636000000
31639	1549	26640656000000
31658	1726	774912832000
31659	1874	202168000
31660	1397	1384904624000
31661	1678	8640245476000
31689	1726	774862827000
31690	1874	202173000
31691	1397	1384854619000
31692	1678	8640245481000
31693	1686	13892286500013
31694	1686	13892306500013
31706	1726	774832824000
31707	1874	202176000
31708	1397	1384824616000
31709	1678	8640245484000
31710	411	66119890000000
31711	1950	3989400000000
31712	1599	15840350000000
31713	1599	15840380000000
31715	1637	114483034819997
31726	1397	1384794613000
31727	1678	8640245487000
31728	1726	774812822000
31729	1874	202178000
31730	1726	774802821000
31731	1874	202179000
31732	1397	1384784612000
31733	1678	8640245488000
31734	1694	38880369000000
31735	1694	38880368000000
31736	1688	129603249000000
31760	1397	1384734607000
31761	1678	8640245493000
31762	1726	774752816000
31763	1874	202184000
31764	1694	38880367000000
31765	1694	38880366000000
31766	1694	38880365000000
31767	1727	13679325000000
31782	1726	774722813000
31783	1874	202187000
31784	1397	1384704604000
31785	1678	8640245496000
31788	1637	115203024819997
31789	1637	115203034819997
31790	1397	1384694603000
31791	1678	8640245497000
31792	1397	1384684602000
31793	1678	8640245498000
31794	1397	1384674601000
31795	1678	8640245499000
31796	1397	1384664600000
31797	1678	8640245500000
31798	1726	774712812000
31799	1874	202188000
31800	1726	774702811000
31801	1874	202189000
31802	1726	774692810000
31803	1874	202190000
31804	1726	774682809000
31805	1874	202191000
31806	1705	20875660000000
31848	1726	774602801000
31849	1874	202199000
31850	1397	1384584592000
31851	1678	8640245508000
31852	700	73200280000000
31938	1650	12960420000000
31939	1650	12960490000000
31940	1397	1384524586000
31941	1678	8640245514000
31942	1726	774542795000
31943	1874	202205000
31944	1726	774532794000
31945	1874	202206000
31946	1692	30260072020000
31947	1397	1384514585000
31948	1678	8640245515000
31949	1622	10799149999976
31950	1622	10799159999976
31951	1508	15840310000000
31952	1508	15840320000000
31953	1397	1384504584000
31954	1678	8640245516000
31955	1397	1384494583000
31956	1678	8640245517000
31957	1397	1384484582000
31958	1678	8640245518000
31959	1726	774522793000
31960	1874	202207000
31961	1726	774512792000
31962	1874	202208000
31963	1726	774502791000
31964	1874	202209000
31965	1601	8318804100000
31966	1388	1702109704351650
31967	1601	5658307600000
31968	1142	905296755600000
31969	1601	3863481500000
31970	1262	610821326200000
31971	1601	2378370600000
31972	1022	505191064000000
31973	1756	2627615575609
31974	1756	2627715575609
31975	1397	1384474581000
31976	1678	8640245519000
31977	1726	774492790000
31978	1874	202210000
31979	1726	774482789000
31980	1874	202211000
31981	1397	1384464580000
31982	1678	8640245520000
31983	1607	26640693000000
31984	1607	26640733000000
31985	1756	3347715575609
31986	1756	3347755575609
31987	1471	20880450000000
31988	1471	20880490000000
31989	1397	1384454579000
31990	1678	8640245521000
31991	1726	774472788000
31992	1874	202212000
31993	1654	15840380000000
31994	1719	17279360000000
31995	1719	17279380000000
31996	1471	20880470000000
31997	1693	2182520053757
31998	1596	16717635000000
31999	1397	1384444578000
32000	1678	8640245522000
32001	1726	774462787000
32002	1874	202213000
32003	1588	18720550000000
32004	1588	18720570000000
32005	1726	774452786000
32006	1874	202214000
32007	1397	1384434577000
32008	1678	8640245523000
32009	1683	753132043999541
32010	1683	753132063999541
32011	1726	774442785000
32012	1874	202215000
32013	1397	1384424576000
32014	1678	8640245524000
32015	1690	62641161000000
32016	1690	62641181000000
32017	1397	1384414575000
32018	1678	8640245525000
32019	1709	0
32020	1979	16556460000000
32021	1726	774432784000
32022	1874	202216000
32023	1649	15120630999992
32024	1688	131043559000000
32025	1688	131043589000000
32026	1726	774422783000
32027	1874	202217000
32028	1397	1384404574000
32029	1678	8640245526000
32030	1679	72721331980000
32031	1679	72721351980000
32032	1759	20880409999999
32033	1759	20880429999999
32034	1397	1384394573000
32035	1678	8640245527000
32036	1726	774412782000
32037	1874	202218000
32038	43	86160530890000
32039	1672	19440693000000
32040	1672	19440713000000
32041	1979	16281874029894
32042	1776	275574970106
32043	1726	774402781000
32044	1874	202219000
32045	1397	1384384572000
32046	1678	8640245528000
32047	1683	754572063999541
32048	1683	754572093999541
32049	1979	16240261610390
32050	1776	317177389610
32051	1397	1384374571000
32052	1678	8640245529000
32053	1673	20161000000000
32054	1726	774392780000
32055	1874	202220000
32056	1673	20881000000000
32057	1673	20881010000000
32080	1726	774362777000
32081	1874	202223000
32082	1397	1384334567000
32083	1678	8640245533000
32084	1677	254166862000000
32085	1677	254166882000000
32103	1402	72722773000000
32104	1402	72722803000000
32107	1726	774332774000
32108	1874	202226000
32109	1726	774322773000
32110	1874	202227000
32111	1397	1384304564000
32112	1678	8640245536000
32113	1397	1384294563000
32114	1678	8640245537000
32115	1594	18000510000000
32116	1594	18000550000000
32133	1397	1384254559000
32134	1678	8640245541000
32135	1397	1384244558000
32136	1678	8640245542000
32137	1726	774282769000
32138	1874	202231000
32139	1726	774272768000
32140	1874	202232000
32141	1900	65000000
32142	1402	73442844000000
32145	1692	31700092020000
32146	1692	31700133020000
32160	1522	15119950000000
32161	1898	30000000
32162	1522	15119930000000
32163	1898	40000000
32164	1397	1384224556000
32165	1678	8640245544000
32166	1633	15120229985638
32167	1024	502777775001948
32172	1749	16555398000000
32180	1397	1384204554000
32181	1678	8640245546000
32182	1726	774242765000
32183	1874	202235000
32186	1683	758892193999541
32194	1397	1384184552000
32195	1678	8640245548000
32196	1397	1384174551000
32197	1678	8640245549000
32198	1726	774222763000
32199	1874	202237000
32200	700	73198270000000
32201	1980	1000000000
32202	1726	774212762000
32203	1874	202238000
32204	1599	15840400000000
32251	1643	4176365113700
32252	1643	4176685113700
32259	1850	10379540000000
32260	1277	1701576637751650
32261	1850	6339530000000
32262	1031	905013465000000
32263	470	86160431000000
32264	470	86160571000000
32303	1689	19439512000000
32314	529	66720000000000
32315	529	66720030000000
32330	1634	20160443899999
32331	1634	20160483899999
32335	1637	115923074819997
32349	470	70274381000000
32350	943	505239775000000
32351	1677	254886892000000
32352	1677	254886943000000
32355	1559	20160611000000
32365	1679	73441351980000
32366	1679	73441382980000
32405	1677	254887054000000
32435	1717	16559353000000
32436	1717	16559753000000
32481	1397	1383894523000
32482	1678	8640245577000
32483	1476	10732380000000
32484	1371	1701968637751650
32485	1726	773952736000
32486	1874	202264000
32487	1476	6483370000000
32488	1125	905222465000000
32489	1476	3616360000000
32490	1245	610771750000000
32491	1476	1245350000000
32492	1005	505148775000000
32493	1689	18717470000000
32494	1984	1000000000
32495	1729	15839511000000
32521	1726	773912732000
32522	1874	202268000
32523	1726	773902731000
32524	1874	202269000
32525	1397	1383854519000
32526	1678	8640245581000
32527	1397	1383844518000
32528	1678	8640245582000
32529	1689	12102015979905
32530	1029	905219478509549
32531	1688	132483650000000
32551	171	81840270000000
32552	171	81840280000000
32563	1726	773872728000
32564	1874	202272000
32565	1397	1383804514000
32566	1678	8640245586000
32567	1689	1253929287614
32568	1275	1701963852521252
32569	1684	41040357000000
32585	1727	11976585000000
32586	908	504480415000000
32587	1726	773842725000
32588	1874	202275000
32589	1397	1383774511000
32590	1678	8640245589000
32591	1689	28287614
32592	1984	1254900000000
32593	1677	255606912000000
32594	1677	255607033000000
32640	484	87600572000000
32641	484	87600602000000
32663	1704	4319130000000
32664	1704	4319195000000
32686	1726	773722713000
32687	1874	202287000
32688	1397	1383644498000
32689	1678	8640245602000
32715	1668	21598630000000
32716	1987	1000000000
32717	1397	1383614495000
32718	1678	8640245605000
32719	1726	773702711000
32720	1874	202289000
32721	1699	8854210000078
32742	1726	773662707000
32743	1874	202293000
32744	1397	1383574491000
32745	1678	8640245609000
32746	1987	490000000
32747	1668	21599130000000
32748	1672	20160713000000
32749	1672	20160743000000
32841	1397	1383454479000
32842	1678	8640245621000
32843	1726	772332695000
32844	1874	202305000
32845	1602	0
32846	1989	860340000000
32847	1688	133923669000000
32848	1688	133923699000000
32850	1685	70560878571430
32851	1685	70560908571430
32901	1656	24480643000000
32902	1656	24480665000000
32920	1726	772262688000
32921	1874	202312000
32922	1522	13833920000000
32923	956	504783775000000
32924	1522	10238910000000
32925	1076	904568465000000
32926	1522	7812900000000
32927	1196	610330750000000
32928	1522	1053890000000
32929	1322	1700739637751650
32930	1972	189000000
32931	1974	100000000
32932	1688	134643699000000
32933	1688	134643750000000
32935	1679	74881412980000
32936	1679	74881463980000
32938	1726	772252687000
32939	1874	202313000
32058	1726	774382779000
32059	1874	202221000
32060	1979	14148574405003
32061	931	504869452205387
32062	1397	1384364570000
32063	1678	8640245530000
32064	1447	22320650000000
32065	1447	22320680000000
32105	1474	18276394000000
32106	1474	18276424000000
32117	1397	1384284562000
32118	1678	8640245538000
32119	1726	774312772000
32120	1874	202228000
32121	1402	73442803000000
32122	1402	73442823000000
32131	58	86880845000000
32132	58	86880865000000
32173	1522	15119910000000
32174	1898	50000000
32175	1397	1384214555000
32176	1678	8640245545000
32177	1726	774252766000
32178	1874	202234000
32179	1677	254166892000000
32187	1637	115923054819997
32205	596	83898262000000
32206	1981	101000000000
32207	700	66001260000000
32208	1980	7198000000000
32209	1726	774202761000
32210	1874	202239000
32211	1633	8553915643102
32212	1390	1700546942100752
32213	1397	1384164550000
32214	1678	8640245550000
32215	1649	15120740999992
32216	1633	5061500922591
32217	1144	904465869724003
32218	1397	1384154549000
32219	1678	8640245551000
32220	1633	2705095866582
32221	1264	610261145058365
32222	1633	756189985638
32223	1024	504726670882892
32224	1726	774192760000
32225	1874	202240000
32226	1726	774182759000
32227	1874	202241000
32228	1726	774172758000
32229	1874	202242000
32230	1397	1384144548000
32231	1678	8640245552000
32232	1397	1384134547000
32233	1678	8640245553000
32234	1980	7197990000000
32235	1708	13679651000000
32237	1397	1384124546000
32238	1678	8640245554000
32239	1623	29521960899898
32240	1623	29521970899898
32274	1726	774142755000
32275	1874	202245000
32276	1610	18236443260000
32277	948	505422111740000
32278	1610	13497804490000
32279	1068	905712093770000
32280	1634	18720444899999
32281	1539	1000000
32282	1634	19440443899999
32304	1690	63361181000000
32305	1690	63361221000000
32307	1397	1384054539000
32308	1678	8640245561000
32309	1726	774102751000
32310	1874	202249000
32311	470	85440411000000
32312	764	1000010000000
32313	1723	20880430999760
32316	1397	1384044538000
32317	1678	8640245562000
32318	1705	20875580000000
32336	1726	774082749000
32337	1874	202251000
32338	470	69760381000000
32339	1183	610880750000000
32340	1726	774072748000
32341	1874	202252000
32342	1397	1384024536000
32343	1678	8640245564000
32344	1397	1384014535000
32345	1678	8640245565000
32346	1701	15575079675069
32347	267	66263331324931
32348	1719	17279411000000
32353	1559	20160560000000
32354	1559	20160601000000
32356	1726	774062747000
32357	1874	202253000
32358	1536	18409250000000
32359	260	66311200000000
32360	1397	1384004534000
32361	1678	8640245566000
32362	1701	13569061438048
32363	922	504783792237021
32364	1402	73442834000000
32471	1564	14400393000000
32514	1683	761772384999541
32532	1683	763212384999541
32533	1683	763212425999541
32553	1594	8040770000000
32554	1326	1701660877751650
32555	1594	5284610000000
32556	1200	610660900000000
32557	1594	1199720000000
32558	1080	905058345000000
32559	1397	1383814515000
32560	1678	8640245585000
32561	1559	20880611000000
32562	1559	20880651000000
32580	1397	1383784512000
32581	1678	8640245588000
32582	1726	773852726000
32583	1874	202274000
32584	42	82558060000000
32595	1397	1383764510000
32596	1678	8640245590000
32597	1726	773832724000
32598	1874	202276000
32599	1677	256327033000000
32600	1677	256327053000000
32617	1727	6866815000000
32618	1148	609963390000000
32619	1727	1130205000000
32620	1274	1699717237751650
32621	1727	906685000000
32622	1986	222510000000
32623	1726	773812722000
32624	1874	202278000
32625	1397	1383734507000
32626	1678	8640245593000
32627	1397	1383724506000
32628	1678	8640245594000
32629	1726	773802721000
32630	1874	202279000
32631	42	83278060000000
32632	42	83278130000000
32642	1726	773782719000
32643	1874	202281000
32644	1726	773772718000
32645	1874	202282000
32646	1397	1383704504000
32647	1678	8640245596000
32648	1397	1383694503000
32649	1678	8640245597000
32650	1397	1383684502000
32651	1678	8640245598000
32652	1726	773762717000
32653	1874	202283000
32654	1711	18719399000000
32655	1711	18719398000000
32656	1711	18719397000000
32657	1711	18719396000000
32658	1711	18719395000000
32659	1608	15840380000000
32660	1608	15840445000000
32678	1726	773732714000
32679	1874	202286000
32680	1397	1383654499000
32681	1678	8640245601000
32682	1522	15839910000000
32683	1522	15839930000000
32684	1500	1000000000
32685	1467	19443117057977
32690	1467	19442203100000
32691	1467	19442223100000
32776	1726	773622703000
32777	1874	202297000
32778	1397	1383534487000
32779	1678	8640245613000
32780	1587	10034104000000
32781	1357	1701226867751650
32782	1587	6180054000000
32783	1111	904827505000000
32784	1587	3579644000000
32066	1726	774372778000
32067	1874	202222000
32068	1397	1384354569000
32069	1678	8640245531000
32070	1397	1384344568000
32071	1678	8640245532000
32072	1979	10400296773674
32073	1051	904721732631329
32074	1979	7871255914697
32075	1171	610433780858977
32076	1979	823876553266
32077	1297	1701028007113081
32078	1683	756012093999541
32079	1683	756012153999541
32088	1685	69840858571430
32089	1685	69840878571430
32096	1397	1384314565000
32097	1678	8640245535000
32098	1726	774342775000
32099	1874	202225000
32100	1979	0
32101	1776	1141043942876
32102	1451	13680451000000
32127	1397	1384264560000
32128	1678	8640245540000
32129	1726	774292770000
32130	1874	202230000
32158	1637	115923034819997
32159	1637	115923064819997
32169	1546	18720400000000
32170	1546	18720440000000
32188	1726	774232764000
32189	1874	202236000
32190	1397	1384194553000
32191	1678	8640245547000
32192	1688	131763589000000
32193	1688	131763609000000
32236	1509	20880642000000
32241	1683	758892183999541
32250	1683	758892203999541
32253	1981	100900000000
32254	1397	1384104544000
32255	1678	8640245556000
32256	1726	774152756000
32257	1874	202244000
32258	1684	41040456000000
32265	1397	1384094543000
32266	1678	8640245557000
32267	1850	3613520000000
32268	1151	610630750000000
32269	1850	1358510000000
32270	911	505032775000000
32271	470	86160601000000
32283	1726	774132754000
32284	1874	202246000
32285	1610	10300547230000
32286	1188	611101997260000
32287	1397	1384084542000
32288	1678	8640245558000
32289	1610	1391123470000
32290	1314	1702890051511650
32291	606	82560350000000
32292	606	82560390000000
32298	1397	1384064540000
32299	1678	8640245560000
32300	1726	774112752000
32301	1874	202248000
32302	1444	20160693000000
32306	1444	20160673000000
32319	1723	21600430999760
32320	1723	21600440999760
32321	470	77147401000000
32322	1309	1702273637751650
32323	1726	774092750000
32324	1874	202250000
32325	470	72736391000000
32326	1063	905384465000000
32327	1397	1384034537000
32328	1678	8640245563000
32329	1451	13680461000000
32332	1982	155000000
32333	1982	720155000000
32334	1982	720196000000
32389	1726	774052746000
32390	1874	202254000
32391	1536	10421740000000
32392	1726	774042745000
32393	1874	202255000
32394	1397	1383994533000
32395	1678	8640245567000
32396	1397	1383984532000
32397	1678	8640245568000
32398	1610	1389113470000
32399	1983	1000000000
32400	1701	9974294736852
32401	1042	904568230701196
32402	1701	7548833687494
32403	1162	610330210049358
32404	1688	132483771000000
32406	1467	18722041100000
32407	1467	18722203100000
32408	596	77533062000000
32409	1060	905058465000000
32410	596	74775962000000
32411	1180	610661750000000
32412	596	67094862000000
32413	1306	1701661637751650
32414	1610	0
32415	1983	1390103470000
32416	1397	1383974531000
32417	1678	8640245569000
32418	1397	1383964530000
32419	1678	8640245570000
32420	1397	1383954529000
32421	1678	8640245571000
32422	1536	6173430000000
32423	1067	905221765000000
32424	1536	3307020000000
32425	1187	610771150000000
32426	1536	936310000000
32427	947	505148475000000
32428	1726	774032744000
32429	1874	202256000
32430	1726	774022743000
32431	1874	202257000
32432	1726	774012742000
32433	1874	202258000
32434	1677	254887292000000
32443	1677	254886912000000
32472	1683	761772323999541
32473	1683	761772444999541
32474	1726	773962737000
32475	1874	202263000
32476	1701	790063600056
32477	1288	1700739397839088
32478	1397	1383904524000
32479	1678	8640245576000
32480	1693	2182530053757
32498	43	86160532890000
32515	1397	1383864520000
32516	1678	8640245580000
32517	1726	773922733000
32518	1874	202267000
32519	1426	15120490000000
32520	1426	15120510000000
32534	1397	1383834517000
32535	1678	8640245583000
32536	1726	773892730000
32537	1874	202270000
32538	1594	15721020000000
32539	960	505057295000000
32542	1726	773882729000
32543	1874	202271000
32544	1397	1383824516000
32545	1678	8640245584000
32546	1440	20160712000000
32547	1689	9237145057216
32548	1149	610769619922689
32549	1440	20880712000000
32550	1440	20880713000000
32572	1397	1383794513000
32573	1678	8640245587000
32574	1726	773862727000
32575	1874	202273000
32576	1673	21601010000000
32577	1673	21601030000000
32601	1683	766092445999541
32602	1683	766092465999541
32603	1594	1710000000
32604	1985	1197000000000
32605	1397	1383754509000
32606	1678	8640245591000
32607	1686	14612306500013
32608	1686	14612326500013
32633	1726	773792720000
32634	1874	202280000
32635	1397	1383714505000
32636	1678	8640245595000
32637	1983	1390093470000
32638	1679	74161382980000
32639	1679	74161412980000
32661	1747	9359035000000
32667	1397	1383674501000
32668	1678	8640245599000
32669	1726	773752716000
32086	1683	757452153999541
32087	1683	757452173999541
32090	1397	1384324566000
32091	1678	8640245534000
32092	1726	774352776000
32093	1874	202224000
32094	1692	30980072020000
32095	1692	30980092020000
32123	1726	774302771000
32124	1874	202229000
32125	1397	1384274561000
32126	1678	8640245539000
32143	1683	758892173999541
32144	1683	758892214999541
32147	1726	774262767000
32148	1874	202233000
32149	1397	1384234557000
32150	1678	8640245543000
32151	1633	15120259993434
32152	1390	1693980637758216
32153	1633	15120249989942
32154	1144	900973465003492
32155	1633	15120239987586
32156	1264	607904750002356
32157	1759	20880459999999
32168	1708	13679611000000
32171	1749	16555418000000
32184	1489	20160671000000
32185	1489	20160691000000
32242	1726	774162757000
32243	1874	202243000
32244	1850	17975550000000
32245	1682	11441000000
32246	1397	1384114545000
32247	1678	8640245555000
32248	1688	132483609000000
32249	1688	132483639000000
32272	1683	760332203999541
32273	1683	760332323999541
32293	1726	774122753000
32294	1874	202247000
32295	1397	1384074541000
32296	1678	8640245559000
32297	1688	132483669000000
32367	1950	389310000000
32368	596	81618162000000
32369	940	505057775000000
32370	1850	17255530000000
32371	1950	389410000000
32372	1536	17689230000000
32373	700	72478250000000
32374	1950	989410000000
32375	1536	9701720000000
32376	1313	1701968137751650
32377	1850	9659520000000
32378	1850	5619510000000
32379	1467	18004113100000
32380	1850	2893500000000
32381	1850	638490000000
32382	1949	2600000001
32383	1467	18724113099999
32384	1467	13042122
32385	1567	18724117057977
32386	1509	2600000002
32387	1949	20160544000000
32388	1681	24479566195920
32437	1594	18720550000000
32438	1594	18720950000000
32439	1397	1383944528000
32440	1678	8640245572000
32441	1726	774002741000
32442	1874	202259000
32444	1536	0
32445	260	67247500000000
32446	470	67298371000000
32447	1671	12797614237287
32448	1365	1703504133514363
32449	1397	1383934527000
32450	1678	8640245573000
32451	1397	1383924526000
32452	1678	8640245574000
32453	1397	1383914525000
32454	1678	8640245575000
32455	1671	7732365128278
32456	1119	906038704109009
32457	1671	4314737369410
32458	1239	611322367758868
32459	1671	1488129530515
32460	999	505604372838895
32461	1726	773992740000
32462	1874	202260000
32463	1726	773982739000
32464	1874	202261000
32465	1726	773972738000
32466	1874	202262000
32467	1689	18718471000000
32468	1984	0
32469	1656	23760522000000
32470	1656	23760643000000
32496	1419	23760530000000
32497	1419	23760591000000
32499	1726	773942735000
32500	1874	202265000
32501	1726	773932734000
32502	1874	202266000
32503	470	66000011000000
32504	764	2298360000000
32505	1397	1383884522000
32506	1678	8640245578000
32507	1397	1383874521000
32508	1678	8640245579000
32509	1476	0
32510	538	67245340000000
32511	1689	16348030489454
32512	909	505147213510546
32513	43	86160571890000
32540	1573	22320760000000
32541	1573	22320790000000
32570	1696	15118421000000
32571	1696	15118442000000
32578	1683	764652425999541
32579	1683	764652445999541
32609	1727	8925465000000
32610	1028	904024575000000
32611	1397	1383744508000
32612	1678	8640245592000
32613	1726	773822723000
32614	1874	202277000
32615	484	86880542000000
32616	484	86880572000000
32662	1746	7199246000000
32665	1637	116643054819997
32666	1637	116643119819997
32672	1726	773742715000
32673	1874	202285000
32674	1397	1383664500000
32675	1678	8640245600000
32676	1696	15838442000000
32677	1696	15838462000000
32705	171	81840310000000
32722	1549	27360656000000
32723	1549	27360686000000
32734	1688	133203629000000
32735	1688	133203669000000
32750	1397	1383564490000
32751	1678	8640245610000
32752	1397	1383554489000
32753	1678	8640245611000
32754	1726	773652706000
32755	1874	202294000
32756	1726	773642705000
32757	1874	202295000
32758	1683	766092485999541
32812	1397	1383504484000
32813	1678	8640245616000
32814	1726	773592700000
32815	1874	202300000
32816	1726	772382700000
32817	1988	200000000
32818	1683	768972565999541
32819	1683	768972595999541
32826	1397	1383484482000
32827	1678	8640245618000
32828	1726	772362698000
32829	1874	202302000
32830	1726	772352697000
32831	1874	202303000
32832	1397	1383474481000
32833	1678	8640245619000
32834	1457	20880501000000
32849	1402	73442833000000
32852	724	20001150000000
32853	498	66001250000000
32854	1672	17561733000000
32855	919	505376775000000
32856	1672	12904723000000
32857	1039	905630465000000
32858	1988	190000000
32859	1397	1383444478000
32860	1678	8640245622000
32861	1397	1383434477000
32862	1678	8640245623000
32863	1726	772322694000
32864	1874	202306000
32865	1726	772312693000
32670	1874	202284000
32671	1688	132483629000000
32692	1726	773712712000
32693	1874	202288000
32694	1397	1383634497000
32695	1678	8640245603000
32696	1711	16348385000000
32697	1001	505148775000000
32698	1711	13481375000000
32699	1241	610771750000000
32700	1711	9232365000000
32701	1121	905222465000000
32702	1711	1244355000000
32703	1367	1701968637751650
32704	1677	256327093000000
32706	1397	1383624496000
32707	1678	8640245604000
32708	1747	8338869000000
32709	581	66300100000000
32710	1747	8038768000000
32711	698	66300100000000
32712	1747	8015667000000
32713	742	5023100000000
32714	1587	17280344000000
32724	1397	1383604494000
32725	1678	8640245606000
32726	1726	773692710000
32727	1874	202290000
32728	1726	773682709000
32729	1874	202291000
32730	1397	1383594493000
32731	1678	8640245607000
32732	1588	19440570000000
32733	1588	19440610000000
32736	1726	773672708000
32737	1874	202292000
32738	1397	1383584492000
32739	1678	8640245608000
32740	1675	17280749999977
32741	1675	17280769999977
32759	1726	773632704000
32760	1874	202296000
32761	1675	15052759999977
32762	976	505005775000000
32763	1675	11060749999977
32764	1096	904965465000000
32765	1933	1439050000000
32766	1602	11318380000000
32767	1003	504419775000000
32768	1397	1383544488000
32769	1678	8640245612000
32770	1675	8366739999977
32771	1216	610598750000000
32772	1675	861729999977
32773	1342	1701485637751650
32774	1933	2159050000000
32775	1933	2159090000000
32794	1726	773612702000
32795	1874	202298000
32796	1587	0
32797	272	67146574000000
32798	1726	773602701000
32799	1874	202299000
32800	1602	8376370000000
32801	1123	903915465000000
32802	1602	6391360000000
32803	1243	609889750000000
32804	1602	861350000000
32805	1369	1699510637751650
32806	1397	1383524486000
32807	1678	8640245614000
32808	1397	1383514485000
32809	1678	8640245615000
32810	1683	767532485999541
32811	1683	767532565999541
32824	1716	23039491000000
32825	1716	23039511000000
32835	1397	1383464480000
32836	1678	8640245620000
32837	1726	772342696000
32838	1874	202304000
32839	42	83998130000000
32840	42	83998150000000
32872	1726	772302692000
32873	1874	202308000
32874	1397	1383424476000
32875	1678	8640245624000
32876	1599	16560400000000
32877	1599	16560420000000
32882	1668	22319140000000
32894	1726	772282690000
32895	1874	202310000
32896	1397	1383394473000
32897	1678	8640245627000
32898	1972	298000000
32899	1972	297000000
32900	1684	41040358000000
32962	1711	1964355000000
32963	1711	1964385000000
33020	1564	7843257000000
33021	1338	1699817637751650
33022	1786	32420148019999
33023	1692	200000002
33082	1397	1383264460000
33083	1678	8640245640000
33084	1397	1383254459000
33085	1678	8640245641000
33086	1397	1383244458000
33087	1678	8640245642000
33088	1668	14669835000000
33089	1124	905883026000000
33090	1726	772142676000
33091	1874	202324000
33092	1726	772132675000
33093	1874	202325000
33094	1726	772122674000
33095	1874	202326000
33096	1692	33140148019999
33097	1692	33140218019999
33132	1397	1383164450000
33133	1678	8640245650000
33134	1726	772052667000
33135	1874	202333000
33136	1683	770412615999541
33166	606	83280390000000
33167	606	83280410000000
33186	1397	1383074441000
33187	1678	8640245659000
33188	470	67440091000000
33209	1444	19439533000000
33210	207	66001110000000
33211	1397	1383034437000
33212	1678	8640245663000
33213	1726	771932655000
33214	1874	202345000
33215	1716	23039521000000
33221	1677	258487164000000
33244	1397	1382974431000
33245	1678	8640245669000
33246	1726	771882650000
33247	1874	202350000
33248	1726	771872649000
33249	1874	202351000
33250	1444	6733195530000
33251	1135	905385124870000
33252	1444	4271309990000
33253	1015	505239650540000
33254	1444	1294665160000
33255	1255	610881384830000
33256	1397	1382964430000
33257	1678	8640245670000
33258	1688	135363848000000
33259	1688	135363918000000
33275	1726	771832645000
33276	1874	202355000
33277	1397	1382924426000
33278	1678	8640245674000
33279	1607	26640713000000
33282	1679	75601452980000
33283	1679	75601472980000
33284	1397	1382914425000
33285	1678	8640245675000
33286	1687	7285084726450
33303	1397	1382884422000
33304	1678	8640245678000
33305	1726	771802642000
33306	1874	202358000
33365	1726	771712633000
33366	1874	202367000
33367	1397	1382784412000
33368	1678	8640245688000
33369	1397	1382774411000
33370	1678	8640245689000
33371	1726	771702632000
33372	1874	202368000
33373	1933	2879090000000
33374	1933	2879130000000
33393	1726	771672629000
33394	1874	202371000
33395	1397	1382734407000
33396	1678	8640245693000
33397	1688	136803928000000
33398	1688	136803948000000
33415	1397	1382704404000
33416	1678	8640245696000
32785	1231	610505150000000
32786	1587	1428934000000
32787	991	504928475000000
32788	1587	1146594000000
32789	272	66282330000000
32790	1587	864254000000
32791	319	66282330000000
32792	149	78960327000000
32793	149	78960407000000
32820	1397	1383494483000
32821	1678	8640245617000
32822	1726	772372699000
32823	1874	202301000
32880	1677	257047093000000
32881	1677	257047103000000
32883	1397	1383414475000
32884	1678	8640245625000
32885	1693	2902530053757
32886	1693	2902550053757
32887	1397	1383404474000
32888	1678	8640245626000
32889	1726	772292691000
32890	1874	202309000
32891	1972	299000000
32892	1672	1725703000000
32893	1672	1725724000000
32903	1668	23039140000000
32904	1668	23039162000000
32918	1692	32420133020000
32919	1692	32420160020000
32960	1683	770412595999541
32961	1683	770412625999541
32979	1683	768972622999541
32980	1972	182000000
32981	1683	770412622999541
32982	1683	770412623999541
33067	1693	4342670053757
33076	1397	1383274461000
33077	1678	8640245639000
33078	1726	772152677000
33079	1874	202323000
33080	1724	21598090000000
33081	1724	21598171000000
33104	1397	1383224456000
33105	1678	8640245644000
33106	470	66720041000000
33107	1726	772102672000
33108	1874	202328000
33109	1726	772092671000
33110	1874	202329000
33111	1726	772082670000
33112	1874	202330000
33113	1726	772072669000
33114	1874	202331000
33115	1726	772062668000
33116	1874	202332000
33117	1397	1383214455000
33118	1678	8640245645000
33119	1397	1383204454000
33120	1678	8640245646000
33121	1397	1383194453000
33122	1678	8640245647000
33123	1397	1383184452000
33124	1678	8640245648000
33125	1397	1383174451000
33126	1678	8640245649000
33127	1668	11357246000000
33128	1244	611217329000000
33129	1668	2126441000000
33130	1370	1703211432751650
33131	1680	25919640000000
33143	1685	70560898571430
33150	1756	4067755575609
33151	1756	4067775575609
33193	1739	15839570000000
33217	1397	1383024436000
33218	1678	8640245664000
33219	1622	11519159999976
33220	1622	11519169999976
33238	1726	771892651000
33239	1874	202349000
33240	1397	1382984432000
33241	1678	8640245668000
33242	1714	24469430000000
33243	1714	24469450000000
33269	1726	771842646000
33270	1874	202354000
33271	1397	1382934427000
33272	1678	8640245673000
33273	1683	771852615999541
33274	1683	771852635999541
33280	149	79680407000000
33281	149	79680427000000
33289	1726	771822644000
33290	1874	202356000
33291	1397	1382904424000
33292	1678	8640245676000
33293	1397	1382894423000
33294	1678	8640245677000
33295	1726	771812643000
33296	1874	202357000
33297	1444	2014665160000
33298	1444	2014705160000
33313	1622	12239169999976
33314	1622	12239189999976
33350	1711	19439395000000
33357	1397	1382794413000
33358	1678	8640245687000
33359	1726	771722634000
33360	1874	202366000
33361	1671	2208129530515
33362	1671	2208149530515
33401	1397	1382724406000
33402	1678	8640245694000
33403	1726	771662628000
33404	1874	202372000
33405	1688	137523948000000
33406	1688	137523968000000
33413	1573	23040790000000
33414	1573	23040810000000
33427	1726	771622624000
33428	1874	202376000
33429	1397	1382684402000
33430	1678	8640245698000
33431	1650	12960440000000
33471	1397	1382604394000
33472	1678	8640245706000
33473	1726	771542616000
33474	1874	202384000
33475	1726	771532615000
33476	1874	202385000
33477	1397	1382594393000
33478	1678	8640245707000
33479	1571	13680181001000
33480	1571	13680221001000
33539	1706	19436522000000
33584	1687	7285094726450
33618	1546	19440440000000
33619	1546	19440510000000
33630	1726	771322594000
33631	1874	202406000
33632	1397	1382364370000
33633	1678	8640245730000
33634	1397	1382354369000
33635	1678	8640245731000
33636	1714	25189450000000
33637	1714	25189480000000
33684	1726	771222584000
33685	1874	202416000
33686	1397	1382254359000
33687	1678	8640245741000
33688	1633	2196209985638
33689	1633	2196229985638
33696	1397	1382244358000
33697	1678	9360265742000
33698	1689	720028287614
33699	1689	720038287614
33718	1397	1382214355000
33719	1678	9360265745000
33720	1685	71280898571430
33721	1685	71280908571430
33746	1593	19440591000000
33747	1593	19440652000000
33765	1726	771152577000
33766	1874	202423000
33767	1397	1382174351000
33768	1678	9360265749000
33769	1508	15840350000000
33795	1718	14297552889008
33796	1718	14297572889008
33815	1397	1382104344000
33816	1678	9360265756000
33817	1700	9780614742484
33818	1059	904400213222506
33819	1726	771092571000
33820	1874	202429000
33821	1397	1382094343000
33822	1678	9360265757000
33823	1726	771082570000
33824	1874	202430000
33825	1601	3098370600000
33826	1601	3098420600000
33856	1693	6502730053757
33857	1693	6502790053757
33868	1397	1382054339000
32866	1874	202307000
32867	1672	9761713000000
32868	1159	611047750000000
32869	1672	1005703000000
32870	1285	1702736637751650
32871	1637	116643644819997
32878	1668	22319130000000
32879	1668	22319150000000
32905	1726	772272689000
32906	1874	202311000
32907	1397	1383384472000
32908	1678	8640245628000
32909	1972	296000000
32910	1972	295000000
32911	1972	294000000
32912	1972	293000000
32913	1972	292000000
32914	1972	291000000
32915	1972	290000000
32916	1440	21600713000000
32917	1440	21600740000000
32934	1402	73442854000000
32937	1677	257047144000000
32944	1397	1383364470000
32945	1678	8640245630000
32946	1726	772242686000
32947	1874	202314000
32948	1974	99000000
32949	1974	98000000
32950	1974	97000000
32951	1974	96000000
32952	1974	95000000
32953	1974	94000000
32954	1974	93000000
32955	1974	92000000
32956	1974	91000000
32957	1974	90000000
32958	1686	15332326500013
32959	1686	15332356500013
32964	1419	24480591000000
32965	1419	24480621000000
32966	1726	772232685000
32967	1874	202315000
32968	1397	1383354469000
32969	1678	8640245631000
32970	1972	188000000
32971	1972	187000000
32972	1972	186000000
32973	1972	185000000
32974	1972	184000000
32975	1974	89000000
32976	1972	183000000
32977	1439	12240277000000
32978	1439	12960277000000
32998	1675	14332739999977
32999	1675	10340729999977
33000	1672	16841703000000
33001	1672	12184693000000
33002	1675	7646719999977
33003	1675	141709999977
33004	1594	15000980000000
33005	1594	7320730000000
33006	1594	4564570000000
33007	1594	479680000000
33008	1587	9314091000000
33009	1587	5460041000000
33010	1587	2859631000000
33011	1587	708921000000
33012	1587	426581000000
33013	1587	144241000000
33014	1672	9041683000000
33015	1672	285673000000
33016	1439	12242007000000
33017	1701	790072600056
33018	1439	12962007000000
33019	1439	12962051000000
33024	1564	4738242000000
33025	1092	904078465000000
33026	1564	2643227000000
33027	1212	609999750000000
33028	1564	548212000000
33029	972	504872775000000
33030	1397	1383344468000
33031	1678	8640245632000
33032	1397	1383334467000
33033	1678	8640245633000
33034	1726	772222684000
33035	1874	202316000
33036	1726	772212683000
33037	1874	202317000
33038	1397	1383324466000
33039	1678	8640245634000
33040	1397	1383314465000
33041	1678	8640245635000
33042	1726	772202682000
33043	1874	202318000
33044	1726	772192681000
33045	1874	202319000
33046	1668	19579406000000
33047	1004	505517499000000
33048	1974	79000000
33049	1688	134643848000000
33050	1564	545112000000
33051	588	66003000000000
33052	1397	1383304464000
33053	1678	8640245636000
33054	1397	1383294463000
33055	1678	8640245637000
33056	1397	1383284462000
33057	1678	8640245638000
33058	1726	772182680000
33059	1874	202320000
33060	1726	772172679000
33061	1874	202321000
33062	1726	772162678000
33063	1874	202322000
33064	1972	178000000
33065	1693	4342570053757
33066	1693	4342731053757
33068	1522	13113900000000
33069	1522	9518890000000
33070	1983	990000000
33071	1522	7092880000000
33072	1522	333870000000
33073	1668	18858896000000
33074	1724	20879376000000
33075	1724	21599376000000
33098	1397	1383234457000
33099	1678	8640245643000
33100	1726	772112673000
33101	1874	202327000
33102	470	66720011000000
33103	470	66720031000000
33137	1397	1383154449000
33138	1678	8640245651000
33139	1726	772042666000
33140	1874	202334000
33141	1715	24480342000000
33142	1715	24480362000000
33156	1471	21600470000000
33157	1471	21600490000000
33160	1726	772012663000
33161	1874	202337000
33162	1397	1383124446000
33163	1678	8640245654000
33164	1677	257767144000000
33165	1677	257767164000000
33174	1726	771992661000
33175	1874	202339000
33176	1726	771982660000
33177	1874	202340000
33178	1397	1383104444000
33179	1678	8640245656000
33180	1397	1383094443000
33181	1678	8640245657000
33182	1397	1383084442000
33183	1678	8640245658000
33184	470	67440031000000
33185	470	67440081000000
33189	1726	771972659000
33190	1874	202341000
33191	1690	64081221000000
33192	1690	64081231000000
33200	1397	1383054439000
33201	1678	8640245661000
33202	1726	771952657000
33203	1874	202343000
33204	1726	771942656000
33205	1874	202344000
33206	1397	1383044438000
33207	1678	8640245662000
33208	1679	74881452980000
33222	1397	1383014435000
33223	1678	8640245665000
33224	1726	771922654000
33225	1874	202346000
33226	1444	11144865400000
33227	1381	1702275295351650
33228	1726	771912653000
33229	1874	202347000
33230	1726	771902652000
33231	1874	202348000
33232	1397	1383004434000
33233	1678	8640245666000
33234	1397	1382994433000
32940	1397	1383374471000
32941	1678	8640245629000
32942	1693	3622550053757
32943	1693	3622570053757
32983	1685	69840905571430
32984	1972	181000000
32985	1972	180000000
32986	1974	88000000
32987	1974	87000000
32988	1974	86000000
32989	1974	85000000
32990	1974	84000000
32991	1974	83000000
32992	1974	82000000
32993	1974	81000000
32994	1974	80000000
32995	1972	179000000
32996	1685	70560905571430
32997	1685	70560918571430
33144	1726	772032665000
33145	1874	202335000
33146	1397	1383144448000
33147	1678	8640245652000
33148	1943	1438900000000
33149	1943	1438920000000
33152	1726	772022664000
33153	1874	202336000
33154	1397	1383134447000
33155	1678	8640245653000
33158	1759	21600459999999
33159	1759	21600479999999
33168	1397	1383114445000
33169	1678	8640245655000
33170	1726	772002662000
33171	1874	202338000
33172	1637	117363644819997
33173	1637	117363664819997
33194	1726	771962658000
33195	1874	202342000
33196	1397	1383064440000
33197	1678	8640245660000
33198	1458	23760425908540
33199	1458	23760445908540
33216	1536	720030000000
33260	1726	771862648000
33261	1874	202352000
33262	1726	771852647000
33263	1874	202353000
33264	1397	1382954429000
33265	1678	8640245671000
33266	1397	1382944428000
33267	1678	8640245672000
33268	1759	21600499999999
33287	1683	773292635999541
33288	1683	773292645999541
33299	1703	12239550000000
33300	1703	12239590000000
33315	1397	1382864420000
33316	1678	8640245680000
33317	1726	771782640000
33318	1874	202360000
33320	1397	1382854419000
33321	1678	8640245681000
33322	1726	771772639000
33323	1874	202361000
33324	1683	774732645999541
33325	1683	774732665999541
33326	1726	771762638000
33327	1874	202362000
33328	1397	1382844418000
33329	1678	8640245682000
33330	1397	1382834417000
33331	1678	8640245683000
33332	1397	1382824416000
33333	1678	8640245684000
33334	1726	771752637000
33335	1874	202363000
33336	1683	776172665999541
33337	1683	776172715999541
33338	1726	771742636000
33339	1874	202364000
33340	1397	1382814415000
33341	1678	8640245685000
33342	1402	74162823000000
33343	1402	74162843000000
33346	1711	2684385000000
33347	1711	2684405000000
33351	1726	771732635000
33352	1874	202365000
33353	1397	1382804414000
33354	1678	8640245686000
33375	1397	1382764410000
33376	1678	8640245690000
33377	1688	136083918000000
33378	1688	136083928000000
33381	1637	118083664819997
33382	1637	118083714819997
33399	1672	2445724000000
33400	1672	2445744000000
33407	1726	771652627000
33408	1874	202373000
33409	1397	1382714405000
33410	1678	8640245695000
33411	1683	779052735999541
33412	1683	779052755999541
33438	1657	17280360000000
33445	633	82559400000000
33491	1397	1382564390000
33492	1678	8640245710000
33493	1397	1382554389000
33494	1678	8640245711000
33495	1726	771512613000
33496	1874	202387000
33497	1726	771502612000
33498	1874	202388000
33499	1547	12240353000000
33535	1397	1382484382000
33536	1678	8640245718000
33537	1726	771432605000
33538	1874	202395000
33540	1397	1382474381000
33541	1678	8640245719000
33542	1726	771422604000
33543	1874	202396000
33544	1677	262087304000000
33545	1677	262087334000000
33568	1397	1382444378000
33569	1678	8640245722000
33570	1547	12960353000000
33571	1547	12960363000000
33572	1397	1382434377000
33573	1678	8640245723000
33574	1726	771392601000
33575	1874	202399000
33576	1440	22320740000000
33577	1440	22320760000000
33585	1726	771372599000
33586	1874	202401000
33587	1726	771362598000
33588	1874	202402000
33589	1397	1382414375000
33590	1678	8640245725000
33591	1397	1382404374000
33592	1678	8640245726000
33593	1688	138243968000000
33594	1688	138244008000000
33596	1397	1382394373000
33597	1678	8640245727000
33598	1726	771352597000
33599	1874	202403000
33600	1693	5782710053757
33601	1693	5782730053757
33644	1726	771302592000
33645	1874	202408000
33646	1397	1382334367000
33647	1678	8640245733000
33648	1397	1382324366000
33649	1678	8640245734000
33650	1397	1382314365000
33651	1678	8640245735000
33652	1726	771292591000
33653	1874	202409000
33654	1726	771282590000
33655	1874	202410000
33656	1726	771272589000
33657	1874	202411000
33658	1726	771262588000
33659	1874	202412000
33660	1549	26640716000000
33661	1549	27360716000000
33690	1449	3043000459
33691	1939	1435990000000
33692	1726	771212583000
33693	1874	202417000
33694	1678	9360245741000
33695	1678	9360265741000
33702	121	66720000000000
33703	121	66720010000000
33716	1623	30241970899898
33717	1623	30242011899898
33751	1710	10238531520848
33752	1710	7813025369394
33753	1710	1054315473290
33754	606	75493560563149
33755	1295	1701047467188501
33235	1678	8640245667000
33236	369	87600572000000
33237	369	87600642000000
33301	1702	10074161000000
33302	1702	10074201000000
33307	1726	771792641000
33308	1874	202359000
33309	1397	1382874421000
33310	1678	8640245679000
33311	1522	1773890000000
33312	1522	1773910000000
33319	1444	2014685160000
33344	1677	259207164000000
33345	1677	259207184000000
33348	1683	777612715999541
33349	1683	777612735999541
33355	1759	22320499999999
33356	1759	22320519999999
33363	1679	76321472980000
33364	1679	76321492980000
33379	1679	77041492980000
33380	1679	77041502980000
33383	1726	771692631000
33384	1874	202369000
33385	1726	771682630000
33386	1874	202370000
33387	1397	1382754409000
33388	1678	8640245691000
33389	1397	1382744408000
33390	1678	8640245692000
33391	1693	5062670053757
33392	1693	5062710053757
33421	1397	1382694403000
33422	1678	8640245697000
33423	1726	771632625000
33424	1874	202375000
33425	1677	260647204000000
33426	1677	260647224000000
33446	1547	12240313000000
33465	1726	771552617000
33466	1874	202383000
33467	1397	1382614395000
33468	1678	8640245705000
33469	1445	15840300000000
33470	1445	15840320000000
33482	1397	1382584392000
33483	1678	8640245708000
33484	1683	779052745999541
33500	1397	1382544388000
33501	1678	8640245712000
33502	1726	771492611000
33503	1874	202389000
33504	1637	118083684819997
33512	1564	1265112000000
33513	1564	1265133000000
33514	1710	13833317340144
33515	914	504783747659856
33516	1397	1382524386000
33517	1678	8640245714000
33518	1726	771472609000
33519	1874	202391000
33520	1397	1382514385000
33521	1678	8640245715000
33522	1397	1382504384000
33523	1678	8640245716000
33524	1726	771462608000
33525	1874	202392000
33526	1726	771452607000
33527	1874	202393000
33528	1762	12959490000000
33546	1397	1382464380000
33547	1678	8640245720000
33548	1726	771412603000
33549	1874	202397000
33550	1683	780492745999541
33551	1683	780492765999541
33554	1710	10958551520848
33555	1034	904568150819296
33556	1710	8533045369394
33557	1154	610330156151454
33558	1710	1774335473290
33559	1280	1700739247647754
33560	1726	771402602000
33561	1874	202398000
33562	1397	1382454379000
33563	1678	8640245721000
33564	1596	17437635000000
33565	1596	17437955000000
33578	1726	771382600000
33579	1874	202400000
33580	1397	1382424376000
33581	1678	8640245724000
33582	1716	23759521000000
33583	1716	23759541000000
33595	1683	780492785999541
33602	1681	24072051210200
33603	531	66407503985720
33604	1726	771342596000
33605	1874	202404000
33606	1681	20971901644968
33607	984	505877914565232
33608	1681	15416468106056
33609	1104	906528888538912
33610	1397	1382384372000
33611	1678	8640245728000
33612	1681	11668103144718
33613	1224	611653104961338
33614	1681	1222968759830
33615	1350	1704425762136538
33616	1670	720610000000
33617	1670	720680000000
33620	1726	771332595000
33621	1874	202405000
33622	1397	1382374371000
33623	1678	8640245729000
33624	1564	1985133000000
33625	1564	1985153000000
33626	1677	262807334000000
33627	1677	262807354000000
33628	1633	1476189985638
33629	1633	1476209985638
33662	1726	771252587000
33663	1874	202413000
33664	1726	771242586000
33665	1874	202414000
33666	1397	1382304364000
33667	1678	8640245736000
33668	1397	1382294363000
33669	1678	8640245737000
33670	1397	1382284362000
33671	1678	8640245738000
33672	1397	1382274361000
33673	1678	8640245739000
33674	1715	25200362000000
33675	1715	25200422000000
33678	1726	771232585000
33679	1874	202415000
33680	1397	1382264360000
33681	1678	8640245740000
33682	1690	64801231000000
33683	1690	64801311000000
33722	1677	254886862000000
33737	1678	9360265746000
33738	1726	771162578000
33739	1874	202422000
33740	1678	9360265747000
33741	1397	1382184352000
33742	1678	9360265748000
33743	1749	14555397000000
33744	1950	5389390000000
33745	1683	780492806999541
33748	1593	19440662000000
33770	700	66721260000000
33771	700	66721300000000
33775	606	69197808048273
33776	1169	610441401885611
33777	1677	262807364000000
33812	1746	7199241000000
33842	1397	1382084342000
33843	1678	9360265758000
33844	606	71734449933884
33845	1049	904732555629265
33846	1397	1382074341000
33847	1678	9360265759000
33848	1700	7468509433968
33849	1179	610216845308516
33850	1700	1025640276737
33851	1305	1700423496908881
33852	1726	771072569000
33853	1874	202431000
33854	1694	2892274127629
33855	1694	2892334127629
33858	1701	1510063600056
33859	1701	1510123600056
33862	1726	771062568000
33863	1874	202432000
33864	1397	1382064340000
33865	1678	9360265760000
33866	1700	1745640276737
33867	1700	1745660276737
33878	1397	1382034337000
33879	1678	9360265763000
33880	1397	1382024336000
33881	1678	9360265764000
33882	606	71734429933884
33417	1726	771642626000
33418	1874	202374000
33419	1677	259927184000000
33420	1677	259927204000000
33432	1397	1382674401000
33433	1678	8640245699000
33434	1726	771612623000
33435	1874	202377000
33436	1657	17280320000000
33437	1657	17280340000000
33439	1726	771602622000
33440	1874	202378000
33441	1397	1382664400000
33442	1678	8640245700000
33443	1571	12960161001000
33444	1571	12960181001000
33447	1397	1382654399000
33448	1678	8640245701000
33449	1726	771592621000
33450	1874	202379000
33451	1726	771582620000
33452	1874	202380000
33453	1726	771572619000
33454	1874	202381000
33455	1726	771562618000
33456	1874	202382000
33457	1397	1382644398000
33458	1678	8640245702000
33459	1397	1382634397000
33460	1678	8640245703000
33461	1397	1382624396000
33462	1678	8640245704000
33463	1677	261367224000000
33464	1677	261367304000000
33481	1683	779052775999541
33485	1726	771522614000
33486	1874	202386000
33487	1397	1382574391000
33488	1678	8640245709000
33489	1571	14400221001000
33490	1571	14400241001000
33505	1397	1382534387000
33506	1678	8640245713000
33507	1726	771482610000
33508	1874	202390000
33509	1759	21599998999999
33510	619	66000500000000
33511	1700	15839681000000
33529	1397	1382494383000
33530	1678	8640245717000
33531	1726	771442606000
33532	1874	202394000
33533	1506	16560360000000
33534	1506	16560380000000
33552	1710	14553317340144
33553	1710	14553337340144
33566	1594	721710000000
33567	1594	722030000000
33638	1397	1382344368000
33639	1678	8640245732000
33640	1726	771312593000
33641	1874	202407000
33642	1594	1442030000000
33643	1594	1442050000000
33676	152	66000100000000
33677	1637	118803584819997
33700	1584	720000000000
33701	1584	720010000000
33704	1397	1382234357000
33705	1678	9360265743000
33706	1397	1382224356000
33707	1678	9360265744000
33708	1726	771202582000
33709	1874	202418000
33710	1726	771192581000
33711	1874	202419000
33712	1749	14835357000000
33713	1950	4389390000000
33714	1749	15555357000000
33715	1749	15555398000000
33723	1678	8640245742000
33724	1678	8640245743000
33725	1678	8640245744000
33726	1726	771182580000
33727	1874	202420000
33728	1726	771172579000
33729	1874	202421000
33730	1678	8640245745000
33731	1397	1382204354000
33732	1678	8640245746000
33733	1397	1382194353000
33734	1678	8640245747000
33735	1637	119523584819997
33736	1637	119523705819997
33749	1714	25909480000000
33750	1714	25909541000000
33779	1397	1382154349000
33780	1678	9360265751000
33781	1726	771142576000
33782	1874	202424000
33783	1726	771132575000
33784	1874	202425000
33785	1397	1382144348000
33786	1678	9360265752000
33787	1749	13555396000000
33788	1950	6389390000000
33797	1726	771112573000
33798	1874	202427000
33799	1700	13207392964990
33800	939	504690032035010
33801	1397	1382124346000
33802	1678	9360265754000
33803	1397	1382114345000
33804	1678	9360265755000
33805	1726	771102572000
33806	1874	202428000
33807	1700	13207372964990
33808	939	504690042035010
33809	1747	8735667000000
33810	1747	8735727000000
33813	1704	5039195000000
33814	1704	5039255000000
33827	1678	8640245748000
33828	1678	8640245749000
33829	1678	8640245750000
33830	1678	8640245751000
33831	1678	8640245752000
33832	1678	8640245753000
33833	1678	8640245754000
33834	1678	8640245755000
33835	1678	8640245756000
33836	1678	8640245757000
33837	606	67099644812964
33838	929	504875928235309
33839	1749	12835355000000
33840	1637	120243705819997
33841	1637	120243967819997
33860	1685	72000908571430
33861	1685	72000968571430
33899	1701	1510083600056
33906	1397	1382004334000
33907	1678	9360265766000
33908	44	66000000000000
33909	1991	16540007000000
33910	1649	15840740999992
33911	1649	15840751999992
33923	1992	719000000000
33924	1992	719020000000
33970	1397	1381934327000
33971	1678	9360265773000
33972	1726	770942556000
33973	1874	202444000
33995	1397	1381894323000
33996	1678	9360265777000
33997	1726	770912553000
33998	1874	202447000
33999	1991	1195085441475
34000	1991	1195084441475
34001	1991	1195083441475
34002	1739	15839583000000
34027	1397	1381844318000
34028	1678	9360265782000
34029	1726	770862548000
34030	1874	202452000
34031	1599	17280420000000
34032	1599	17280440000000
34035	1678	8640245758000
34036	1678	8640245759000
34037	1678	8640245760000
34038	1678	8640245761000
34039	1678	8640245762000
34040	1678	8640245763000
34041	1678	8640245764000
34042	1678	8640245765000
34043	1678	8640245766000
34044	1678	8640245767000
34045	1678	8640245768000
34046	1678	8640245769000
34047	1678	8640245770000
34048	1678	8640245771000
34049	1678	8640245772000
34050	1678	8640245773000
34051	1678	8640245774000
34052	1678	8640245775000
34053	1678	8640245776000
33756	606	71734469933884
33757	1049	904732545629265
33758	1668	18859396000000
33759	1668	13949825000000
33760	1668	10637236000000
33761	1668	1406431000000
33762	1759	20879958999999
33763	1749	13835356000000
33764	1508	15841645000000
33772	1397	1382164350000
33773	1678	9360265750000
33774	1672	2445734000000
33778	1677	262807404000000
33789	1397	1382134347000
33790	1678	9360265753000
33791	1726	771122574000
33792	1874	202426000
33793	1717	17279753000000
33794	1717	17279773000000
33811	1677	262807394000000
33872	1397	1382044338000
33873	1678	9360265762000
33874	1726	771042566000
33875	1874	202434000
33876	1445	16560320000000
33877	1445	16560340000000
33896	1727	1626685000000
33897	1727	1626705000000
33912	55	66720011000000
33915	1397	1381994333000
33916	1678	9360265767000
33917	1726	771002562000
33918	1874	202438000
33925	1726	770982560000
33926	1874	202440000
33927	1397	1381974331000
33928	1678	9360265769000
33929	1397	1381964330000
33930	1678	9360265770000
33931	1397	1381954329000
33932	1678	9360265771000
33933	1726	770972559000
33934	1874	202441000
33935	1656	24480693000000
33961	1656	23760703000000
33962	1656	24480703000000
33963	1656	24480713000000
33974	1726	770932555000
33975	1874	202445000
33976	1397	1381924326000
33977	1678	9360265774000
33978	1397	1381914325000
33979	1678	9360265775000
33980	1422	18000422000000
33981	1422	18000452000000
33984	1726	770922554000
33985	1874	202446000
33986	606	69197768048272
33987	1169	610441411885612
33988	606	67099604812962
33989	929	504875928235310
33990	1397	1381904324000
33991	1678	9360265776000
33992	1768	13679411110000
33993	1768	13679451110000
34003	1397	1381884322000
34004	1678	9360265778000
34005	606	67099584812962
34006	929	504875938235310
34007	1397	1381874321000
34008	1678	9360265779000
34009	1726	770902552000
34010	1874	202448000
34011	1726	770892551000
34012	1874	202449000
34013	1688	138964008000000
34014	1688	138964058000000
34033	1506	17280380000000
34034	1506	17280400000000
34064	1397	1381834317000
34065	1678	9360265783000
34066	1726	770852547000
34067	1874	202453000
34068	1759	12054997999999
34069	1315	1703525637751650
34070	1680	25500227610710
34071	1993	418411389290
34072	1708	14399592000000
34073	1708	14399614000000
34111	641	69989484000000
34112	1336	1704004549751650
34113	1726	770822544000
34114	1874	202456000
34115	1397	1381784312000
34116	1678	9360265788000
34117	641	66391490000000
34118	1210	611502734000000
34119	1680	729149500035
34120	1993	1668411389290
34121	1649	15840781999992
34139	1726	770792541000
34140	1874	202459000
34141	1726	770782540000
34142	1874	202460000
34143	1397	1381754309000
34144	1678	9360265791000
34145	1397	1381744308000
34146	1678	9360265792000
34147	1677	264967405000000
34148	1677	264967445000000
34192	1715	24480385000000
34193	1715	25200385000000
34194	1726	770712533000
34195	1874	202467000
34196	1397	1381674301000
34197	1678	9360265799000
34198	1677	265687445000000
34199	1677	265687465000000
34220	1397	1381624296000
34221	1678	9360265804000
34222	1726	770672529000
34223	1874	202471000
34224	1762	13679490000000
34225	1762	13679510000000
34260	1690	65521311000000
34261	1690	65521331000000
34270	1397	1381594293000
34271	1678	9360265807000
34272	1726	770642526000
34273	1874	202474000
34274	1677	268567545000000
34275	1677	268567565000000
34299	1683	784812876999541
34306	1668	2846451000000
34307	1726	770592521000
34308	1874	202479000
34309	1397	1381534287000
34310	1678	9360265813000
34311	1397	1381524286000
34312	1678	9360265814000
34313	58	86880854999659
34314	149	79680447000341
34315	1703	1753580000000
34316	1651	19840000000000
34317	1726	769382521000
34318	1994	200000000
34319	1726	768172521000
34320	1995	200000000
34321	1726	766962521000
34322	1994	1400000000
34323	1726	765752521000
34324	1996	200000000
34325	1726	764542521000
34326	1997	200000000
34327	1726	764532520000
34328	1874	202480000
34329	1726	764522519000
34330	1874	202481000
34331	1397	1381514285000
34332	1678	9360265815000
34333	1599	18000440000000
34334	1599	18000580000000
34336	149	78240327000341
34337	641	89040930000000
34338	641	89040940000000
34425	1397	1381434277000
34426	1678	9360265823000
34427	1726	762032512000
34428	1874	202488000
34429	58	77783824999659
34430	1281	1702736497751650
34431	58	73126854999659
34432	1035	905630425000000
34433	58	69984694999659
34434	1155	611046900000000
34435	58	67385914999659
34436	915	505376545000000
34437	1722	1320116000000
34438	1764	2542674100000
34439	1683	787692897999541
34440	1683	787692958999541
34441	1607	16508018724978
34442	1348	1704113322026672
34443	1423	296281769217
34444	104	66263082769232
33869	1678	9360265761000
33870	1726	771052567000
33871	1874	202433000
33890	1726	771012563000
33891	1874	202437000
33892	1397	1382014335000
33893	1678	9360265765000
33894	1549	28080716000000
33895	1549	28080736000000
33900	1643	4178395113700
33901	606	74773520563149
33902	606	71014429933884
33903	606	68477768048273
33904	1643	4898395113700
33905	1643	4899425113700
33919	1726	770992561000
33920	1874	202439000
33921	1397	1381984332000
33922	1678	9360265768000
33936	1726	770962558000
33937	1874	202442000
33938	1611	15830660000000
33939	1749	13554395000000
33940	1722	1441118000000
33941	1991	16288916155534
33942	83	66251089844466
33943	1991	16037825311068
33944	348	66251989844466
33945	1991	15786734466602
33946	380	66251089844466
33947	1991	15535643622136
33948	530	66251188844466
33949	1991	15284552777670
33950	675	66251089844466
33951	1991	13372904944501
33952	959	504689421833169
33953	1991	9947249198447
33954	1079	904399119746054
33955	1991	7635890680296
33956	1199	610216107518151
33957	1991	1195086441475
33958	1325	1700421440990471
33959	1611	16550660000000
33960	1611	16550670000000
33964	1397	1381944328000
33965	1678	9360265772000
33966	1726	770952557000
33967	1874	202443000
33968	1547	13680363000000
33969	1547	13680383000000
33982	1683	781932765999541
33983	1683	781932795999541
34074	1692	33860218019999
34075	1692	33860240019999
34104	1397	1381794313000
34105	1678	9360265787000
34106	641	82988672000000
34107	1090	906305713000000
34108	641	80013406000000
34109	970	505753031000000
34110	1677	263527384000000
34158	1726	770752537000
34159	1874	202463000
34160	1397	1381714305000
34161	1678	9360265795000
34216	1397	1381634297000
34217	1678	9360265803000
34218	1677	266407465000000
34219	1677	266407505000000
34228	1683	784812846999541
34229	1683	784812866999541
34258	1677	267127505000000
34259	1677	267127525000000
34276	1397	1381584292000
34277	1678	9360265808000
34278	1440	23040760000000
34279	1440	23040770000000
34291	1397	1381554289000
34292	1678	9360265811000
34293	1726	770612523000
34294	1874	202477000
34295	1702	151000000
34296	1651	9354000000000
34297	1688	139684058000000
34298	1688	139684088000000
34300	1726	770602522000
34301	1874	202478000
34302	1397	1381544288000
34303	1678	9360265812000
34304	1668	2846441000000
34305	1668	2846461000000
34386	149	78960407000341
34387	1678	8640245783000
34388	1678	8640245784000
34389	1678	8640245785000
34390	1678	8640245786000
34391	1678	8640245787000
34392	1651	10486000000000
34393	1637	121684461819997
34394	1637	121684561819997
34469	1515	15603400
34470	1677	269287560000000
34487	1726	760762506000
34488	1874	202494000
34489	1397	1381364270000
34490	1678	9360265830000
34491	1607	4063675326172
34492	271	66411417920446
34493	1607	3652247405726
34494	269	66411417920446
34495	1607	3240819485280
34496	577	66411417920446
34497	1555	14400282000000
34498	1555	14400332000000
34505	1726	760742504000
34506	1874	202496000
34507	1423	33177999985
34508	683	66146585999999
34509	1397	1381344268000
34510	1678	9360265832000
34511	1764	1673100000
34512	968	505318775000000
34513	1673	21601061000000
34593	1679	78481632980000
34594	1679	78481892980000
34698	298	68001070000000
34699	1768	15997411110000
34700	1695	8689341000000
34701	1330	1700410637751650
34702	558	66324884938283
34703	1958	710988000000
34704	1726	759422493000
34705	1874	202507000
34706	1397	1381234257000
34707	1678	9360265843000
34708	1397	1381224256000
34709	1678	9360265844000
34710	1684	22831871236777
34711	681	66335084938283
34712	1696	15838802000000
34713	1684	22821707147738
34714	720	2010154089039
34715	1684	22811543058699
34716	722	2010154089039
34717	1684	22806456014180
34718	760	1005077044519
34719	1684	22801368969661
34720	763	1005077044519
34721	1684	22796281925142
34722	767	1005077044519
34723	1684	22791194880623
34724	769	1005077044519
34725	1684	20183184880623
34726	958	505385775000000
34727	1684	15510174880623
34728	1078	905646465000000
34729	1684	12357164880623
34730	1198	611057750000000
34731	1684	3571154880623
34732	1324	1702766637751650
34733	1729	13924679000000
34734	967	504692575000000
34735	1729	10493378000000
34736	1087	904404765000000
34737	1729	8178207000000
34738	1207	610219920000000
34739	1729	1726706000000
34740	1333	1700432137751650
34741	1696	16558802000000
34742	1696	16558906000000
34756	1594	2162050000000
34757	1594	2162360000000
34790	1397	1381144248000
34791	1678	9360265852000
34792	1683	790573029999541
34812	1759	720493999999
34813	1759	720513999999
34814	1397	1381104244000
34815	1678	9360265856000
34816	1439	11436824998477
34817	913	504301187001523
34818	1727	1626486000000
34819	1148	609963489000000
34820	1677	271447633000000
34903	2003	1384970654821
33883	1169	607904760000000
33884	1726	771032565000
33885	1874	202435000
33886	1726	771022564000
33887	1874	202436000
33888	619	66000499000000
33889	1654	15840411000000
33898	1727	1627006000000
33913	564	66720000000000
33914	564	66720011000000
33994	1683	781932805999541
34015	1726	770882550000
34016	1874	202450000
34017	1397	1381864320000
34018	1678	9360265780000
34019	1726	770872549000
34020	1874	202451000
34021	1397	1381854319000
34022	1678	9360265781000
34023	1749	13553394000000
34024	1722	1442118000000
34025	1683	783372805999541
34026	1683	783372846999541
34102	1447	23040680000000
34103	1447	23040737000000
34122	1397	1381774311000
34123	1678	9360265789000
34124	1726	770812543000
34125	1874	202457000
34126	1933	129000000
34127	1764	18599677100000
34128	1722	1322117000000
34129	1764	18719677100000
34130	1689	720050287614
34149	1397	1381734307000
34150	1678	9360265793000
34151	1726	770772539000
34152	1874	202461000
34153	1726	770762538000
34154	1874	202462000
34155	1397	1381724306000
34156	1678	9360265794000
34157	149	79680447000000
34170	1397	1381704304000
34171	1678	9360265796000
34172	1726	770742536000
34173	1874	202464000
34174	1397	1381694303000
34175	1678	9360265797000
34176	1726	770732535000
34177	1874	202465000
34178	1716	20932940000000
34179	1508	15840351000000
34200	1654	16560411000000
34201	1654	16560431000000
34215	1729	15839480000000
34226	1439	13680277000000
34227	1439	13680297000000
34230	1685	72720968571430
34231	1685	72720988571430
34254	1397	1381614295000
34255	1678	9360265805000
34256	1726	770662528000
34257	1874	202472000
34262	1397	1381604294000
34263	1678	9360265806000
34264	1726	770652527000
34265	1874	202473000
34266	1677	267847525000000
34267	1677	267847545000000
34282	1726	770632525000
34283	1874	202475000
34284	1726	770622524000
34285	1874	202476000
34286	1397	1381574291000
34287	1678	9360265809000
34288	1397	1381564290000
34289	1678	9360265810000
34290	1679	77041532980000
34335	1402	74162963000000
34339	1726	764512518000
34340	1874	202482000
34341	1423	3336987230768
34342	199	66263082769232
34343	1423	3073894461536
34344	214	66263082769232
34345	1397	1381504284000
34346	1678	9360265816000
34347	641	67111490000000
34348	641	67111530000000
34350	1397	1381494283000
34351	1678	9360265817000
34352	1423	2810801692304
34353	234	66263082769232
34354	1423	2547708923072
34355	282	66263082769232
34356	1423	2284616153840
34357	314	66263082769232
34358	1423	2021523384608
34359	323	66263082769232
34360	1423	1758430615376
34361	330	66263082769232
34362	1423	1495337846144
34363	332	66263082769232
34364	1423	1232245076912
34365	334	66263082769232
34366	1423	969152307680
34367	343	66263082769232
34368	1423	706059538448
34369	559	66263082769232
34370	1471	22320490000000
34371	1471	22320590000000
34374	1726	764502517000
34375	1874	202483000
34376	1397	1381484282000
34377	1678	9360265818000
34378	1423	442966769216
34379	561	66263082769232
34380	1593	20160652000000
34381	1593	20160822000000
34384	1683	786252876999541
34385	1683	786252897999541
34479	1423	33188999985
34480	1397	1381374271000
34481	1678	9360265829000
34482	1726	761982507000
34483	1874	202493000
34484	1726	760772507000
34485	2000	200000000
34486	1683	789133019999541
34515	1726	760732503000
34516	1874	202497000
34517	1397	1381334267000
34518	1678	9360265833000
34519	1422	18720452000000
34520	1422	18720472000000
34539	1397	1381304264000
34540	1678	9360265836000
34541	1397	1381294263000
34542	1678	9360265837000
34543	1397	1381284262000
34544	1678	9360265838000
34545	1684	40926997904059
34546	22	22439350095941
34547	1684	40591902965776
34548	190	66335084938283
34549	1684	40256808027493
34550	258	66335084938283
34551	1684	39921713089210
34552	273	66335084938283
34553	1684	39586618150927
34554	292	66335084938283
34555	1684	39251523212644
34556	293	66335084938283
34557	1684	38916428274361
34558	333	66335084938283
34559	1684	38581333336078
34560	376	66335084938283
34561	1684	38246238397795
34562	426	66335084938283
34563	1684	37911143459512
34564	429	66335084938283
34565	1684	37576048521229
34566	430	66335084938283
34567	1684	37240953582946
34568	440	66335084938283
34569	1684	36905858644663
34570	474	66335084938283
34571	1684	36570763706380
34572	475	66335084938283
34573	1684	36235668768097
34574	476	66335084938283
34575	1684	35900573829814
34576	483	66335084938283
34577	1684	35565478891531
34578	486	66335084938283
34579	1684	35230383953248
34580	490	66335084938283
34581	1684	34895289014965
34582	496	66335084938283
34583	1726	760702500000
34584	1874	202500000
34585	1726	760692499000
34586	1874	202501000
34587	1726	759482499000
34054	1678	8640245777000
34055	1678	8640245778000
34056	1678	8640245779000
34057	1678	8640245780000
34058	1678	8640245781000
34059	1678	8640245782000
34060	1749	12834354000000
34061	1749	12833353000000
34062	1637	120963967819997
34063	1637	120964461819997
34076	1397	1381824316000
34077	1678	9360265784000
34078	1397	1381814315000
34079	1678	9360265785000
34080	1397	1381804314000
34081	1678	9360265786000
34082	1726	770842546000
34083	1874	202454000
34084	1726	770832545000
34085	1874	202455000
34086	1759	6978496999999
34087	1069	906049965000000
34088	1759	3553495999999
34089	1189	611329750000000
34090	1759	719494999999
34091	949	505611775000000
34092	1680	22308906470030
34093	907	505969095140680
34094	1680	16590087121150
34095	1027	906692283348880
34096	1680	12731485425655
34097	1147	611763350695495
34098	1680	1979150500035
34099	1273	1704732971677270
34100	1677	263527354000000
34101	1677	263527411000000
34131	1397	1381764310000
34132	1678	9360265790000
34133	1726	770802542000
34134	1874	202458000
34135	1764	10162676100000
34136	1334	1702537637751650
34137	1677	264247384000000
34138	1677	264247405000000
34162	1716	19492890000000
34163	950	505604375000000
34164	1759	11334957999999
34165	1759	6258456999999
34166	1759	2833455999999
34167	1508	15841794000000
34168	1509	20880643000000
34169	1508	16561793000000
34180	1397	1381684302000
34181	1678	9360265798000
34182	1726	770722534000
34183	1874	202466000
34184	1716	15867699000000
34185	1070	906038705000000
34186	1716	12450078000000
34187	1190	611322370000000
34188	1716	2926577000000
34189	1316	1703504137751650
34190	1675	861752999977
34191	1675	1581752999977
34202	1726	770702532000
34203	1874	202468000
34204	1726	770692531000
34205	1874	202469000
34206	1726	770682530000
34207	1874	202470000
34208	1397	1381664300000
34209	1678	9360265800000
34210	1397	1381654299000
34211	1678	9360265801000
34212	1397	1381644298000
34213	1678	9360265802000
34214	1729	15839510000000
34232	606	66379604812964
34233	1668	13949325000000
34234	1668	10636736000000
34235	1668	1405931000000
34236	1759	20159908999999
34237	1759	10614907999999
34238	1759	5538406999999
34239	1716	14427649000000
34240	1759	2113405999999
34241	1716	11010028000000
34242	1716	1486527000000
34243	1680	24780097610710
34244	1680	21588776470030
34245	1680	15869957121150
34246	1680	12011355425655
34247	1680	1259020500035
34248	1680	9019500035
34249	1764	15840677100000
34250	1764	7283676100000
34251	1439	13682051000000
34252	1439	774375367000
34253	1726	13682901410000
34268	1692	34580240019999
34269	1692	34580260019999
34280	1271	1341246240000000
34281	1271	1341246250000000
34349	1692	34580280019999
34372	1679	77761532980000
34373	1679	77761632980000
34382	1750	4183000000
34383	1593	20160673000000
34395	1423	559374538449
34396	683	66146584999999
34397	1397	1381474281000
34398	1678	9360265819000
34399	1397	1381464280000
34400	1678	9360265820000
34401	1726	764492516000
34402	1874	202484000
34403	1726	763282516000
34404	1998	200000000
34405	58	86539694999659
34406	149	80021597000341
34407	1726	763272515000
34408	1874	202485000
34409	1726	762062515000
34410	1999	200000000
34411	1726	762052514000
34412	1874	202486000
34413	1726	762042513000
34414	1874	202487000
34415	1397	1381454279000
34416	1678	9360265821000
34417	1397	1381444278000
34418	1678	9360265822000
34419	1764	5611175100000
34420	1088	905524965000000
34421	1764	2540674100000
34422	1208	610975250000000
34423	1657	18000340000000
34424	1657	18000552000000
34514	1685	72721019571430
34521	1726	760722502000
34522	1874	202498000
34523	1397	1381324266000
34524	1678	9360265834000
34525	1749	8022393000000
34526	1327	1701550637751650
34527	1749	3996392000000
34528	1081	904999465000000
34529	1749	1280391000000
34530	1201	610620750000000
34531	1677	270007560000000
34532	1677	270007583000000
34641	1685	72721179571430
34667	1607	15787998724978
34668	149	79301557000341
34669	1698	25200421000000
34670	1698	25920421000000
34671	1698	25920701000000
34793	1439	12960246998477
34794	913	502777775001523
34795	1397	1381134247000
34796	1678	9360265853000
34797	1397	1381124246000
34798	1678	9360265854000
34799	1651	5843070678379
34800	1055	905710658484311
34801	1651	2646781839253
34802	1175	611101028839126
34803	1651	3236050115
34804	935	505421310789138
34805	1444	2734875160000
34806	1444	2734935160000
34823	1397	1381094243000
34824	1678	9360265857000
34825	1397	1381084242000
34826	1678	9360265858000
34827	1726	759412492000
34828	1874	202508000
34829	1596	9344601022416
34830	1363	1701353666729234
34831	1596	5423120583183
34832	1117	904894940439233
34833	1596	2777217963415
34834	1237	610550647619768
34835	1596	588879152658
34836	997	504966108810757
34445	1397	1381424276000
34446	1678	9360265824000
34447	1397	1381414275000
34448	1678	9360265825000
34449	1397	1381404274000
34450	1678	9360265826000
34451	1397	1381394273000
34452	1678	9360265827000
34453	1726	762022511000
34454	1874	202489000
34455	1726	762012510000
34456	1874	202490000
34457	1726	762002509000
34458	1874	202491000
34459	1607	11118761966447
34460	1102	906362711758531
34461	1607	7482519790139
34462	1222	611540982176308
34463	1607	4475103246618
34464	982	505785181543521
34465	1722	115000000
34466	1749	14873394000000
34467	1398	1440010000000
34468	1398	1440131000000
34471	1397	1381384272000
34472	1678	9360265828000
34473	1726	761992508000
34474	1874	202492000
34475	1759	493999999
34476	1749	15592394000000
34477	1683	789132958999541
34478	1683	789132979999541
34499	1397	1381354269000
34500	1678	9360265831000
34501	1726	760752505000
34502	1874	202495000
34503	1683	790573019999541
34504	1683	790573089999541
34533	1726	760712501000
34534	1874	202499000
34535	1397	1381314265000
34536	1678	9360265835000
34537	1677	270727583000000
34538	1677	270727603000000
34595	1726	759462497000
34596	1874	202503000
34597	1684	34560194076682
34598	511	66335084938283
34599	1684	34225099138399
34600	512	66335084938283
34601	1684	33890004200116
34602	522	66335084938283
34603	1684	33554909261833
34604	523	66335084938283
34605	1684	33219814323550
34606	533	66335084938283
34607	1684	32884719385267
34608	539	66335084938283
34609	1684	32549624446984
34610	541	66335084938283
34611	1684	32214529508701
34612	558	66335084938283
34613	1684	31879434570418
34614	565	66335084938283
34615	1684	31544339632135
34616	572	66335084938283
34617	1684	31209244693852
34618	573	66335084938283
34619	1684	30874149755569
34620	576	84335674938283
34621	1684	30539054817286
34622	584	66335084938283
34623	1397	1381274261000
34624	1678	9360265839000
34625	1397	1381264260000
34626	1678	9360265840000
34627	1726	759452496000
34628	1874	202504000
34629	1684	30203959879003
34630	585	66335084938283
34631	1684	29868864940720
34632	589	66335084938283
34633	1684	29533770002437
34634	595	66335084938283
34635	1684	29198675064154
34636	597	66335084938283
34637	1750	4182000000
34638	1448	15840863000000
34786	1397	1381154249000
34787	1678	9360265851000
34788	1601	3818420600000
34789	1601	3818430600000
34807	1397	1381114245000
34808	1678	9360265855000
34809	1727	1626595000000
34810	1316	1703504237751650
34811	1693	6502750053757
34839	1706	20156522000000
34840	1706	20156572000000
34845	1726	759402491000
34846	1874	202509000
34847	1397	1381074241000
34848	1678	9360265859000
34849	1726	759392490000
34850	1874	202510000
34851	1397	1381064240000
34852	1678	9360265860000
34853	1439	9594868998477
34854	1153	609746696000000
34855	1439	6864917998477
34856	1033	903703406000000
34857	1439	1732162998477
34858	1279	1699113382751650
34859	1719	14462199000000
34860	986	504874935000000
34861	1719	10704108000000
34862	1106	904731555000000
34863	1719	8168447000000
34864	1226	610440410000000
34865	1719	1102626000000
34866	1352	1701046457751650
34867	1593	20160726000000
34910	1397	1381024236000
34911	1678	9360265864000
34912	1726	755722486000
34913	1874	202514000
34914	1726	754512486000
34915	2005	1400000000
34916	1684	4291154880623
34917	1684	4291184880623
34921	1768	10697911110000
34922	1308	1701277837751650
34923	1768	6816111110000
34924	1062	904855165000000
34925	1768	4197311110000
34926	1182	610523450000000
34927	1768	2030611110000
34928	942	504944375000000
34929	1397	1381014235000
34930	1678	9360265865000
34931	1397	1381004234000
34932	1678	9360265866000
34933	1397	1380994233000
34934	1678	9360265867000
34935	1726	754502485000
34936	1874	202515000
34937	1726	754492484000
34938	1874	202516000
34939	1726	754482483000
34940	1874	202517000
34941	1397	1380984232000
34942	1678	9360265868000
34943	1726	754472482000
34944	1874	202518000
34945	1419	23522740649627
34946	139	66237840350373
34947	1764	721673100000
34948	1764	722163100000
34960	1467	20162223100000
34961	1467	20162243100000
34978	1397	1380954229000
34979	1678	9360265871000
34980	1426	15840520000000
34984	329	66724590000000
34985	329	66724610000000
35018	1762	9547480000000
35019	1762	6293310000000
35020	1762	14932310000000
35021	1762	10109360000000
35022	149	72612047000000
35023	1727	906575000000
35024	1316	1693980737751650
35025	1439	12240230000000
35026	1439	12240219998477
35027	1439	10716797998477
35028	1643	4900905113700
35029	149	69618547000000
35030	149	67598767000000
35031	1684	40206975904059
35032	1684	39871880965776
35033	1684	39536786027493
35034	1684	39201691089210
35035	149	67598767000341
35036	1727	906466000000
35037	1703	1033540000000
34588	2001	200000000
34589	1726	759472498000
34590	1874	202502000
34591	1426	15840510000000
34592	1426	15840770000000
34639	1677	271447603000000
34640	1677	271447814000000
34642	558	66329984938283
34643	2002	4000000000
34644	1397	1381254259000
34645	1678	9360265841000
34646	1684	28863580125871
34647	609	66335084938283
34648	1684	28528485187588
34649	612	66335084938283
34650	1726	759442495000
34651	1874	202505000
34652	1684	28193390249305
34653	615	66335084938283
34654	1684	27858295311022
34655	616	66335084938283
34656	1684	27523200372739
34657	617	66335084938283
34658	1684	27188105434456
34659	624	66335084938283
34660	1684	26853010496173
34661	625	66335084938283
34662	1684	26517915557890
34663	626	66335084938283
34664	1684	26182820619607
34665	627	66335084938283
34666	1444	2014875160000
34672	311	66000950000000
34673	1762	22318510000000
34674	1684	25847725681324
34675	629	66335084938283
34676	1726	759432494000
34677	1874	202506000
34678	1397	1381244258000
34679	1678	9360265842000
34680	1684	25512630743041
34681	637	66335084938283
34682	1684	25177535804758
34683	647	66335084938283
34684	1684	24842440866475
34685	656	66335084938283
34686	1684	24507345928192
34687	664	66335084938283
34688	1684	24172250989909
34689	666	66335084938283
34690	1684	23837156051626
34691	670	66335084938283
34692	1684	23502061113343
34693	673	66335084938283
34694	1684	23166966175060
34695	674	66335084938283
34696	1518	4320081000000
34697	1518	4320291000000
34743	1696	100000000
34744	1542	16558806000000
34745	1695	6381241000000
34746	1204	610212750000000
34747	1695	2961141000000
34748	1084	904393465000000
34749	1695	1052041000000
34750	964	504686775000000
34751	1397	1381214255000
34752	1678	9360265845000
34753	1425	97400000000
34754	1594	2064650000000
34755	1594	2064960000000
34758	558	66029784938283
34759	1958	1005988000000
34760	1397	1381204254000
34761	1678	9360265846000
34762	1651	19834721632047
34763	2003	4268367953
34764	1690	65521431000000
34765	298	66000970000000
34766	1768	17997411110000
34767	1397	1381194253000
34768	1678	9360265847000
34769	1397	1381184252000
34770	1678	9360265848000
34771	1607	2829391564834
34772	242	66411417920446
34773	1651	19486999345179
34774	2003	351980654821
34775	1439	12960257000000
34776	482	66000010000000
34777	1651	10580274162690
34778	1301	1702887352934139
34779	1607	2417963644388
34780	372	66411417920446
34781	1397	1381174251000
34782	1678	9360265849000
34783	1397	1381164250000
34784	1678	9360265850000
34785	1622	12239359999976
34821	1683	792013029999541
34822	1683	792013059999541
34841	1762	21598490000000
34842	1706	19438292000000
34843	1706	20158292000000
34844	1706	20158402000000
34868	1683	793453059999541
34869	1683	793453133999541
34882	1768	17996311110000
34883	298	66001970000000
34884	1768	17995211110000
34885	298	66002970000000
34886	149	74393317000341
34887	1283	1699608907751650
34888	1726	755752489000
34889	2006	200000000
34890	1726	755742488000
34891	1874	202512000
34892	149	71399817000341
34893	1037	903966955000000
34894	149	69380037000341
34895	1157	609924520000000
34896	149	67709537000341
34897	917	504448265000000
34898	1397	1381044238000
34899	1678	9360265862000
34900	1719	0
34901	2007	1101625000000
34902	1688	139684329000000
34949	1683	793453549999541
34962	1761	200100000
34963	1790	10000016
34964	2000	20156533899864
34965	1706	200000022
34966	1804	200000100
34967	1935	1409000000
35108	1685	73441179571430
35109	1685	73441329571430
35115	1726	753182474000
35116	1874	202526000
35117	1397	1380914225000
35118	1678	9360265875000
35119	1754	6995000000
35120	1779	1000000000
35121	1690	66961481000000
35122	1690	66961502000000
35123	1397	1380904224000
35124	1678	9360265876000
35125	1397	1380894223000
35126	1678	9360265877000
35127	1397	1380884222000
35128	1678	9360265878000
35129	1726	753172473000
35130	1874	202527000
35131	1726	753162472000
35132	1874	202528000
35133	1726	753152471000
35134	1874	202529000
35135	1447	23760737000000
35136	1447	23760797000000
35150	1705	21595590000000
35151	1705	21595610000000
35160	1397	1380844218000
35161	1678	9360265882000
35162	1726	753112467000
35163	1874	202533000
35164	1447	24480797000000
35165	1447	24480817000000
35184	1402	74882963000000
35185	1402	74882983000000
34837	1695	1772041000000
34838	1695	1772091000000
34870	1397	1381054239000
34871	1678	9360265861000
34872	1703	720570000000
34873	2003	1384980654821
34874	1726	759382489000
34875	1874	202511000
34876	1726	758172489000
34877	2004	200000000
34878	1726	756962489000
34879	2005	200000000
34880	1690	66241431000000
34881	1690	66241481000000
34919	1723	22320440999760
34920	1723	22320470999760
34950	2003	1032000000000
34951	242	66822835840892
34952	372	66822835840892
34953	1397	1380974231000
34954	1678	9360265869000
34955	1706	20160082000000
34956	1726	754462481000
34957	1874	202519000
34958	1706	20880082000000
34959	1706	20880182000000
34968	1419	21720903927387
34969	813	501803460057033
34970	1726	754452480000
34971	1874	202520000
34972	1397	1380964230000
34973	1678	9360265870000
34974	1726	753242480000
34975	2008	200000000
34976	1688	140404329000000
34977	1688	140404369000000
34993	1726	753222478000
34994	1874	202522000
34995	1426	15840640000000
34996	1762	19626660000000
34997	941	505469525000000
34998	1726	753212477000
34999	1874	202523000
35000	1726	753202476000
35001	1874	202524000
35002	1397	1380934227000
35003	1678	9360265873000
35004	1397	1380924226000
35005	1678	9360265874000
35006	1727	2346486000000
35007	1727	2346636000000
35112	1698	25201271000000
35113	1698	25921271000000
35142	1992	1439020000000
35143	1992	1439040000000
35177	1610	720040000000
35188	1429	720020000000
34904	1397	1381034237000
34905	1678	9360265863000
34906	1726	755732487000
34907	1874	202513000
34908	1660	720000000000
34909	1660	720030000000
34918	1683	793453089999541
34981	1726	753232479000
34982	1874	202521000
34983	1426	15840530000000
34986	2008	0
34987	1713	660000000
34988	1419	1900817280064
34989	814	5519833243318203
34990	1397	1380944228000
34991	1678	9360265872000
34992	1426	15840630000000
35008	1762	16372490000000
35009	1181	611158820000000
35010	1762	11549540000000
35011	1061	905796315000000
35012	1762	2481680000000
35013	1307	1703048397751650
35014	1726	753192475000
35015	1874	202525000
35016	58	68105914999659
35017	58	68106224999659
35110	1678	10080265874000
35111	1678	10080575874000
35137	1397	1380874221000
35138	1678	9360265879000
35139	1726	753142470000
35140	1874	202530000
35141	1677	271447623000000
35152	1690	67681502000000
35153	1690	67681522000000
35166	1458	24480445908540
35167	1458	24480465908540
35168	1726	753102466000
35169	1874	202534000
35170	1397	1380834217000
35171	1678	9360265883000
35172	1397	1380824216000
35173	1678	9360265884000
35174	1726	753092465000
35175	1874	202535000
35176	1684	4291194880623
35186	510	67439990000000
35187	510	67440010000000
35038	149	67939917000341
35039	1419	22802679649627
35040	1419	21000842927387
35041	1419	1180756280064
35042	1684	38866596150927
35043	1684	38531501212644
35044	1684	38196406274361
35045	1684	37861311336078
35046	1684	37526216397795
35047	1684	37191121459512
35048	1684	36856026521229
35049	1684	36520931582946
35050	1684	36185836644663
35051	1684	35850741706380
35052	1684	35515646768097
35053	1684	35180551829814
35054	1684	34845456891531
35055	1684	34510361953248
35056	1684	34175267014965
35057	1684	33840172076682
35058	1684	33505077138399
35059	1684	33169982200116
35060	1684	32834887261833
35061	1684	32499792323550
35062	1684	32164697385267
35063	1684	31829602446984
35064	1684	31494507508701
35065	1684	31159412570418
35066	1684	30824317632135
35067	1684	30489222693852
35068	1684	30154127755569
35069	1684	29819032817286
35070	1439	8874841998477
35071	1439	6144890998477
35072	1439	1012135998477
35073	1703	530000000
35074	1607	10398741966447
35075	1607	6762499790139
35076	1607	3755083246618
35077	1607	3343655326172
35078	1607	2932227405726
35079	1607	2520799485280
35080	1607	2109371564834
35081	1607	1697943644388
35082	1423	179873999984
35083	1684	29483937879003
35084	1684	29148842940720
35085	1684	28813748002437
35086	1684	28478653064154
35087	1684	28143558125871
35088	1684	27808463187588
35089	1684	27473368249305
35090	1684	27138273311022
35091	1684	26803178372739
35092	1684	26468083434456
35093	1684	26132988496173
35094	1684	25797893557890
35095	1684	25462798619607
35096	1684	25127703681324
35097	1684	24792608743041
35098	1684	24457513804758
35099	1684	24122418866475
35100	1684	23787323928192
35101	1684	23452228989909
35102	1684	23117134051626
35103	1684	22782039113343
35104	1684	22446944175060
35105	1684	22111849236777
35106	1643	5620905113700
35107	1643	5621935113700
35114	1698	26641271000000
35144	1683	794893549999541
35145	1683	794893569999541
35146	1726	753132469000
35147	1874	202531000
35148	1397	1380864220000
35149	1678	9360265880000
35154	1397	1380854219000
35155	1678	9360265881000
35156	1726	753122468000
35157	1874	202532000
35158	1419	2620817280064
35159	1419	2620837280064
35178	1726	753082464000
35179	1874	202536000
35180	1397	1380814215000
35181	1678	9360265885000
35182	2009	719000000000
35183	2009	719020000000
35189	1397	1380804214000
35190	1678	9360265886000
35191	1726	753072463000
35192	1874	202537000
35193	1593	20880726000000
35194	1593	20880746000000
35195	1683	796333569999541
35196	1683	796333589999541
35197	171	79165121590727
35198	1008	504732913409273
35199	1726	753062462000
35200	1874	202538000
35201	1397	1380794213000
35202	1678	9360265887000
35203	171	75661520312938
35204	1128	904477056277789
35205	1705	20719609242793
35206	148	66155970757207
35207	171	73297567463829
35208	1248	610268692849109
35209	1705	20714872856220
35210	714	2004726386573
35211	1705	19530143600955
35212	994	503962494255265
35213	1705	17407126846190
35214	1114	903096471754765
35215	1705	15974681884856
35216	1234	609337184961334
35217	1705	11983064500065
35218	1360	1697972245136441
35219	171	66710220524688
35220	1374	1700567974690791
35221	1402	75602983000000
35222	1402	75603103000000
35223	1506	17280500000000
35224	1397	1380784212000
35225	1678	9360265888000
35226	1726	753052461000
35227	1874	202539000
35228	1679	79201892980000
35229	1679	79201912980000
35230	1726	753042460000
35231	1874	202540000
35232	1397	1380774211000
35233	1678	9360265889000
35234	1694	2892294127629
35235	42	84718150000000
35236	42	84718170000000
35237	1678	10080265889000
35238	1678	10080285889000
35239	1397	1380764210000
35240	1678	10080285890000
35241	1726	753032459000
35242	1874	202541000
35243	1602	720020000000
35244	1397	1380754209000
35245	1678	10080285891000
35246	1726	753022458000
35247	1874	202542000
35248	1560	30492770553746
35249	135	66468147446254
35250	1560	30024622107492
35251	170	66468147446254
35252	1560	29556473661238
35253	202	66468147446254
35254	1560	29088325214984
35255	264	66468147446254
35256	1560	28620176768730
35257	279	66468147446254
35258	1560	28152028322476
35259	331	66468147446254
35260	1560	27683879876222
35261	382	66468147446254
35262	1560	27215731429968
35263	388	66468147446254
35264	1560	26747582983714
35265	400	66468147446254
35266	1560	26279434537460
35267	505	66468147446254
35268	1560	22892138354864
35269	925	506165070182596
35270	1560	16822133409944
35271	1045	907043468944920
35272	1560	12726579794951
35273	1165	612000302614993
35274	1560	1313957277002
35275	1291	1705393259269599
35276	1690	67681546000000
35277	1397	1380744208000
35278	1678	10080285892000
35279	1726	753012457000
35280	1874	202543000
35281	1688	141124369000000
35282	1688	141124389000000
35283	1397	1380734207000
35284	1678	10080285893000
35285	1726	753002456000
35286	1874	202544000
35308	1608	15840420000000
35311	1397	1380704204000
35312	1678	10080285896000
35313	1726	752972453000
35314	1874	202547000
35315	1422	19440472000000
35316	1422	19440492000000
35332	149	68429537000341
35333	149	68429587000341
35334	1871	718910000000
35335	412	66000000000000
35336	1726	751732450000
35337	1874	202550000
35338	1726	751722449000
35339	1874	202551000
35340	1397	1380674201000
35341	1678	10080285899000
35342	1726	751712448000
35343	1874	202552000
35344	1397	1380664200000
35345	1678	10080285900000
35346	1397	1380654199000
35347	1678	10080285901000
35348	1729	2446706000000
35349	1729	2446866000000
35370	1670	720630000000
35386	1679	80641912980000
35387	1679	80641932980000
35388	1726	751642441000
35389	1874	202559000
35390	1397	1380584192000
35391	1678	10080285908000
35392	1677	272167623000000
35393	1677	272167643000000
35410	1695	2492091000000
35411	1695	2492111000000
35435	1692	34580300019999
35457	1685	73441199571430
35495	1726	750282426000
35496	1874	202574000
35497	1710	2494335473290
35498	1710	2494345473290
35540	1677	272887763000000
35551	1467	20882473100000
35670	1726	747612401000
35671	2013	200000000
35672	1397	1380184152000
35673	1678	10080285948000
35674	1397	1380174151000
35675	1678	10080285949000
35676	1726	747602400000
35677	1874	202600000
35678	1726	747592399000
35679	1874	202601000
35680	1672	3165734000000
35681	1672	3165784000000
35696	1601	4538430600000
35697	1601	4538470600000
35729	1397	1380104144000
35730	1678	10080285956000
35731	1726	747522392000
35732	1874	202608000
35733	1688	143284609000000
35734	1726	747512391000
35735	1874	202609000
35736	1397	1380094143000
35737	1678	10080285957000
35801	1705	747424971000
35802	1726	12703131909945
35803	1571	14400241001120
35847	1397	1379954129000
35848	1678	10080285971000
35849	1714	26629540000000
35850	1714	26629570000000
35862	1677	275767863000000
35863	1677	275767903000000
35892	1718	15017572889008
35893	1718	15017632889008
35894	1685	73441239571430
35925	149	69149617000341
35956	1602	1440070000000
35980	1749	2000391000000
35981	1749	2000412000000
36048	1543	3454950160000
36049	1444	25000000
36076	1714	17794507299806
36077	1054	906181830077410
36078	1714	14280219598078
36079	1174	611418937701728
36080	1714	4487523103056
36081	1300	1703773234246672
36082	1397	1379624096000
36083	1678	10080286004000
36084	1726	745832344000
36085	1874	202656000
36086	1559	23040841000000
36087	1559	23041161000000
36121	1726	745762337000
36122	1874	202663000
36123	1397	1379554089000
36124	1678	10080286011000
36125	1397	1379544088000
36126	1678	10080286012000
36127	1726	745752336000
36128	1874	202664000
36129	1726	745742335000
36130	1874	202665000
36131	1397	1379534087000
36132	1678	10080286013000
36133	1671	2928149530515
36134	1671	2928219530515
36161	1397	1379484082000
36162	1678	10080286018000
36163	1726	745692330000
36164	1874	202670000
36165	470	68160091000000
36166	470	68160111000000
36192	1397	1379434077000
36193	1678	10080286023000
36194	1726	745642325000
36195	1874	202675000
36196	1690	69121586000000
36197	1690	69121606000000
36210	1726	745612322000
36211	1874	202678000
36212	1397	1379404074000
36213	1678	10080286026000
36214	1549	28080756000000
36215	1683	802093799999541
36216	1683	802093839999541
36248	1677	277207913000000
36249	1677	277207953000000
36250	333	66324984938283
36251	2015	9000000000
36252	1397	1379344068000
36253	1678	10080286032000
36254	470	68160221000000
36255	1726	745552316000
36256	1874	202684000
36257	1726	745542315000
36258	1874	202685000
36259	1397	1379334067000
36260	1678	10080286033000
36261	470	68880221000000
36262	470	68880251000000
36273	633	84719890000000
36274	633	84719910000000
36280	1650	12958440000000
36281	535	66001000000000
36282	1726	745522313000
36283	1874	202687000
36284	1726	745512312000
36285	1874	202688000
36286	1397	1379314065000
36287	1678	10080286035000
36288	1397	1379304064000
36289	1678	10080286036000
36290	1564	1986173000000
36325	606	67819584812962
36326	606	67820044812962
36327	1726	745462307000
36328	1874	202693000
36329	1726	745452306000
36330	1874	202694000
36331	1397	1379244058000
36332	1678	10080286042000
36333	1397	1379234057000
36334	1678	10080286043000
36335	1402	76323003000000
36336	1402	76323043000000
36354	1397	1379204054000
36355	1678	10080286046000
36356	1726	745422303000
36357	1874	202697000
36358	1536	720020000000
36387	1607	3858143644388
36388	1607	3858164644388
36389	1726	745402301000
36390	1874	202699000
36391	1726	745392300000
36392	1874	202700000
36393	1397	1379184052000
36394	1678	10080286048000
35287	1419	3340837280064
35288	1419	3340857280064
35289	1679	79921912980000
35350	1688	141844549000000
35351	1397	1380644198000
35352	1678	10080285902000
35353	1397	1380634197000
35354	1678	10080285903000
35355	1726	751702447000
35356	1874	202553000
35357	1726	751692446000
35358	1874	202554000
35359	1688	142564549000000
35360	1688	142564589000000
35394	1694	3612294127629
35395	1694	3612314127629
35412	1726	751612438000
35413	1874	202562000
35414	1397	1380554189000
35415	1678	10080285911000
35416	1726	750402438000
35417	2010	1400000000
35418	1602	1440040000000
35436	1726	750362434000
35437	1874	202566000
35438	1397	1380514185000
35439	1678	10080285915000
35440	1656	25200713000000
35441	1656	25200733000000
35499	1677	272887643000000
35500	1677	272887653000000
35541	149	69149587000341
35542	149	69149707000341
35552	1726	750202418000
35553	1874	202582000
35554	1397	1380364170000
35555	1678	10080285930000
35556	1710	3214345473290
35557	1710	3214365473290
35569	1587	720040000000
35620	1448	15101975996189
35621	741	5018666003811
35622	1448	15083299992378
35623	730	5018666003811
35624	1448	14836898742069
35625	449	66246391250309
35626	1448	14590497491760
35627	489	66246391250309
35628	1448	12713517100219
35629	945	504654745391541
35630	1448	9349992292575
35631	1065	904336979807644
35632	1448	7080551816496
35633	1185	610174180476079
35634	1397	1380254159000
35635	1678	10080285941000
35636	1397	1380244158000
35637	1678	10080285942000
35638	1397	1380234157000
35639	1678	10080285943000
35640	1726	748882407000
35641	1874	202593000
35642	1448	756572000001
35643	1311	1700304607568145
35644	1397	1380224156000
35645	1678	10080285944000
35646	1397	1380214155000
35647	1678	10080285945000
35648	1726	748872406000
35649	1874	202594000
35650	1726	748862405000
35651	1874	202595000
35652	1726	748852404000
35653	1874	202596000
35654	1726	748842403000
35655	1874	202597000
35656	1607	3137963644388
35657	1607	3138143644388
35682	1547	14400383000000
35683	1547	14400433000000
35698	1726	747562396000
35699	1874	202604000
35700	1397	1380144148000
35701	1678	10080285952000
35702	1673	23041081000000
35703	1673	23041101000000
35704	1455	15407131000000
35705	966	505190775000000
35706	1455	11082031000000
35707	1086	905298465000000
35708	1455	8163931000000
35709	1206	610822750000000
35710	1455	33831000000
35711	1332	1702110637751650
35712	1726	747552395000
35713	1874	202605000
35714	1726	747542394000
35715	1874	202606000
35716	1397	1380134147000
35717	1678	10080285953000
35718	1397	1380124146000
35719	1678	10080285954000
35720	633	83279840000000
35738	1726	747502390000
35739	1874	202610000
35740	1397	1380084142000
35741	1678	10080285958000
35742	1688	144004609000000
35743	1688	144004629000000
35744	1726	747492389000
35745	1874	202611000
35746	1397	1380074141000
35747	1678	10080285959000
35748	1700	2465660276737
35749	1700	2465680276737
35798	1458	23760475908540
35799	1458	24480475908540
35800	1458	24480525908540
35813	1397	1379984132000
35814	1678	10080285968000
35815	1726	747402380000
35816	1874	202620000
35817	1677	275047843000000
35818	1677	275047863000000
35842	1726	747372377000
35843	1874	202623000
35844	1693	6502660053757
35845	344	66000100000000
35846	1699	9574230000078
35874	344	66000090000000
35875	1397	1379924126000
35876	1678	10080285974000
35877	1726	747342374000
35878	1874	202626000
35879	1677	275767893000000
35880	1547	2924203000000
35881	1378	1698896637751650
35882	1726	747332373000
35883	1874	202627000
35884	1726	747322372000
35885	1874	202628000
35886	1397	1379914125000
35887	1678	10080285975000
35888	1397	1379904124000
35889	1678	10080285976000
35890	1688	145444669000000
35891	1688	145444729000000
35902	1683	797773689999541
35903	1683	797773709999541
35904	1547	2733183000000
35905	683	66338585999999
35906	1726	747302370000
35907	1874	202630000
35908	1726	747292369000
35909	1874	202631000
35910	1397	1379884122000
35911	1678	10080285978000
35912	1726	747282368000
35913	1874	202632000
35914	1397	1379874121000
35915	1678	10080285979000
35916	1397	1379864120000
35917	1678	10080285980000
35918	1593	21600826000000
35919	1726	747272367000
35920	1874	202633000
35921	1726	746062367000
35922	2014	200000000
35923	1397	1379854119000
35924	1678	10080285981000
35953	1724	2109261000000
35954	1303	1702888985351650
35955	633	83999900000000
35965	1726	745992360000
35966	1874	202640000
35967	1673	22366541000000
35968	100	66337270000000
35969	1397	1379784112000
35970	1678	10080285988000
35971	1422	20160511000000
35972	1458	24480476908540
35973	1726	745982359000
35974	1874	202641000
35975	1397	1379774111000
35976	1678	10080285989000
35290	1726	752992455000
35291	1874	202545000
35292	1726	752982454000
35293	1874	202546000
35294	1397	1380724206000
35295	1678	10080285894000
35296	1397	1380714205000
35297	1678	10080285895000
35298	1435	720000000000
35299	1435	720040000000
35317	1623	30241990899898
35318	1726	752962452000
35319	1874	202548000
35320	1726	752952451000
35321	1874	202549000
35322	1726	751742451000
35323	2010	200000000
35324	1397	1380694203000
35325	1678	10080285897000
35326	1397	1380684202000
35327	1678	10080285898000
35328	1593	21600746000000
35329	1593	21600796000000
35361	1685	73441219571430
35371	1397	1380614195000
35372	1678	10080285905000
35373	1726	751672444000
35374	1874	202556000
35375	1397	1380604194000
35376	1678	10080285906000
35377	1726	751662443000
35378	1874	202557000
35379	1402	75603003000000
35396	1397	1380574191000
35397	1678	10080285909000
35398	1726	751632440000
35399	1874	202560000
35400	171	67430220524688
35401	171	67430240524688
35419	1729	2446736000000
35420	1726	750392437000
35421	1874	202563000
35422	1726	750382436000
35423	1874	202564000
35424	1726	750372435000
35425	1874	202565000
35426	1397	1380544188000
35427	1678	10080285912000
35428	1397	1380534187000
35429	1678	10080285913000
35430	1397	1380524186000
35431	1678	10080285914000
35432	1699	9574210000078
35433	1699	9574270000078
35442	1709	720000000000
35443	1709	720020000000
35501	171	68150240524688
35502	171	68150250524688
35503	1397	1380434177000
35504	1678	10080285923000
35505	1397	1380424176000
35506	1678	10080285924000
35507	1726	750272425000
35508	1874	202575000
35509	1726	750262424000
35510	1874	202576000
35511	411	66839890000000
35512	411	66839930000000
35513	411	66121690000000
35514	1672	16121683000000
35515	1672	11464673000000
35516	149	71892027000000
35517	411	66841690000000
35518	411	66843480000000
35519	1397	1380414175000
35520	1678	10080285925000
35521	1397	1380404174000
35522	1678	10080285926000
35523	1397	1380394173000
35524	1678	10080285927000
35525	1726	750252423000
35526	1874	202577000
35527	1726	750242422000
35528	1874	202578000
35529	1726	750232421000
35530	1874	202579000
35531	1714	25909540000000
35543	1759	1440513999999
35544	1759	1440633999999
35558	1673	22321081000000
35658	1397	1380204154000
35659	1678	10080285946000
35660	1726	748832402000
35661	1874	202598000
35662	1677	274327803000000
35663	1677	274327823000000
35684	1683	796333619999541
35685	1397	1380164150000
35686	1678	10080285950000
35687	1397	1380154149000
35688	1678	10080285951000
35689	1726	747582398000
35690	1874	202602000
35691	1726	747572397000
35692	1874	202603000
35693	1457	21600501000000
35694	1457	21600541000000
35721	1688	143284589000000
35722	1688	143285029000000
35723	1397	1380114145000
35724	1678	10080285955000
35725	1726	747532393000
35726	1874	202607000
35727	1422	20160492000000
35728	1422	20160512000000
35750	1726	747482388000
35751	1874	202612000
35752	1397	1380064140000
35753	1678	10080285960000
35754	1271	1341966250000000
35755	1271	1341966270000000
35756	1397	1380054139000
35757	1678	10080285961000
35758	1726	747472387000
35759	1874	202613000
35760	1724	18954022200000
35761	937	505421913800000
35762	369	88320642000000
35763	369	88320672000000
35764	1547	13679283000000
35765	683	66147585999999
35766	1397	1380044138000
35767	1678	10080285962000
35768	1397	1380034137000
35769	1678	10080285963000
35770	1397	1380024136000
35771	1678	10080285964000
35772	1932	1138849152658
35773	1726	747462386000
35774	1874	202614000
35775	1726	747452385000
35776	1874	202615000
35777	1726	747442384000
35778	1874	202616000
35779	1559	22320671000000
35780	1559	22320841000000
35804	1702	181000000
35805	1702	720181000000
35806	1796	747424971000
35807	1726	200000001
35808	1702	33202999985
35809	1423	720193409879
35851	1699	9574240000078
35864	1690	68401546000000
35865	1690	68401576000000
35866	1547	7840223000000
35867	1132	903588465000000
35868	1397	1379934127000
35869	1678	10080285973000
35870	1726	747352375000
35871	1874	202625000
35872	1688	144724629000000
35873	1688	144724669000000
35895	1726	747312371000
35896	1874	202629000
35897	1397	1379894123000
35898	1678	10080285977000
35899	1677	276487893000000
35900	1677	276487913000000
35926	1726	746052366000
35927	1874	202634000
35928	1397	1379844118000
35929	1678	10080285982000
35930	337	67440020000000
35931	337	67440040000000
35957	1602	1440060000000
35982	1683	799213719999541
35983	1683	799213740999541
35984	1726	745972358000
35985	1874	202642000
35986	1397	1379764110000
35987	1678	10080285990000
35988	1397	1379754109000
35989	1678	10080285991000
35990	1726	745962357000
35300	1508	16560351000000
35301	1796	200300000
35302	1790	200000001
35303	1761	39126164
35304	1567	10000042
35305	1508	16560351573896
35306	1508	66000025000000
35307	696	16560366000000
35309	1508	200100000
35310	1790	16560380900000
35330	1688	141844389000000
35331	1688	141844439000000
35362	1573	23760810000000
35363	1573	23760850000000
35364	1726	751682445000
35365	1874	202555000
35366	1397	1380624196000
35367	1678	10080285904000
35368	1696	17278906000000
35369	1696	17278926000000
35380	1726	751652442000
35381	1874	202558000
35382	1397	1380594193000
35383	1678	10080285907000
35384	633	83279400000000
35385	633	83279420000000
35402	1681	1942968759830
35403	1681	1942988759830
35404	1397	1380564190000
35405	1678	10080285910000
35406	1726	751622439000
35407	1874	202561000
35408	1596	1308879152658
35409	1596	1308899152658
35434	43	86160570890000
35444	1397	1380504184000
35445	1678	10080285916000
35446	1726	750352433000
35447	1874	202567000
35448	1726	750342432000
35449	1874	202568000
35450	1397	1380494183000
35451	1678	10080285917000
35452	1693	6502770053757
35453	1397	1380484182000
35454	1678	10080285918000
35455	1726	750332431000
35456	1874	202569000
35458	1705	19999589242793
35459	1705	19994852856220
35460	1705	18810123600955
35461	1705	16687106846190
35462	1684	22101685147738
35463	1684	22091521058699
35464	1705	15254661884856
35465	1705	11263044500065
35466	1684	22086434014180
35467	1684	22081346969661
35468	1684	22076259925142
35469	1684	22071172880623
35470	1684	19463162880623
35471	1643	5622245113700
35472	1643	6342245113700
35473	696	6342600113700
35474	1643	66000025000000
35475	1726	750322430000
35476	1874	202570000
35477	1726	750312429000
35478	1874	202571000
35479	1726	750302428000
35480	1874	202572000
35481	1397	1380474181000
35482	1678	10080285919000
35483	1397	1380464180000
35484	1678	10080285920000
35485	1397	1380454179000
35486	1678	10080285921000
35487	1673	22321061000000
35488	1673	22321121000000
35489	1726	750292427000
35490	1874	202573000
35491	1397	1380444178000
35492	1678	10080285922000
35493	1679	81361932980000
35494	1679	81362012980000
35532	1455	17820231000000
35533	2011	899000000000
35534	1397	1380384172000
35535	1678	10080285928000
35536	1726	750222420000
35537	1874	202580000
35538	1656	25920733000000
35539	1656	25920853000000
35545	1397	1380374171000
35546	1678	10080285929000
35547	1726	750212419000
35548	1874	202581000
35549	1467	20882243100000
35550	1467	20882263100000
35559	1397	1380354169000
35560	1678	10080285931000
35561	1397	1380344168000
35562	1678	10080285932000
35563	1726	750192417000
35564	1874	202583000
35565	1726	750182416000
35566	1874	202584000
35567	1677	273607763000000
35568	1677	273607803000000
35570	1397	1380334167000
35571	1678	10080285933000
35572	1726	750172415000
35573	1874	202585000
35574	1726	750162414000
35575	1874	202586000
35576	1726	750152413000
35577	1874	202587000
35578	1726	750142412000
35579	1874	202588000
35580	1397	1380324166000
35581	1678	10080285934000
35582	1397	1380314165000
35583	1678	10080285935000
35584	1397	1380304164000
35585	1678	10080285936000
35586	1599	18000500000000
35587	1397	1380294163000
35588	1678	10080285937000
35589	1726	750132411000
35590	1874	202589000
35591	1608	16560420000000
35592	1608	16560440000000
35593	1762	10267640000000
35594	1762	7013470000000
35595	1762	15652470000000
35596	1762	10829520000000
35597	1651	10480721632047
35598	149	73332127000341
35599	1651	10132999345179
35600	1651	1226274162690
35601	149	70338627000341
35602	149	68318847000341
35603	1698	25919571000000
35604	1698	25921291000000
35605	1726	748922411000
35606	2012	200000000
35607	1726	748912410000
35608	1874	202590000
35609	1726	748902409000
35610	1874	202591000
35611	1726	748892408000
35612	1874	202592000
35613	1397	1380284162000
35614	1678	10080285938000
35615	1397	1380274161000
35616	1678	10080285939000
35617	1397	1380264160000
35618	1678	10080285940000
35619	1710	3214415473290
35664	1397	1380194153000
35665	1678	10080285947000
35666	1726	748822401000
35667	1874	202599000
35668	1559	21600651000000
35669	1559	21600671000000
35695	1677	274327843000000
35781	1547	12220263000000
35782	1012	504236775000000
35783	1726	747432383000
35784	1874	202617000
35785	1705	11983094500065
35786	1726	747422382000
35787	1874	202618000
35788	1397	1380014135000
35789	1678	10080285965000
35790	1397	1380004134000
35791	1678	10080285966000
35792	1397	1379994133000
35793	1678	10080285967000
35794	1726	747412381000
35795	1874	202619000
35796	1705	12703094500065
35797	1705	12703144500065
35810	1703	720600000000
35811	1703	1440600000000
35812	1703	1440650000000
35819	1547	10455243000000
35820	1252	609669750000000
35821	1397	1379974131000
35822	1678	10080285969000
35823	1397	1379964130000
35824	1678	10080285970000
35825	1705	12511449945944
35826	148	66347655311328
35827	1705	12505631323105
35828	714	2010535009412
35829	1705	11047505316625
35830	994	505420610261745
35831	1705	8434563926145
35832	1114	905709403145245
35833	1705	6671557050657
35834	1234	611100181836822
35835	1705	1758799500145
35836	1360	1702884992686953
35837	1726	747392379000
35838	1874	202621000
35839	1726	747382378000
35840	1874	202622000
35841	1683	796333689999541
35852	1397	1379944128000
35853	1678	10080285972000
35854	1724	15756449000000
35855	1177	611102313200000
35856	1724	11017618600000
35857	1057	905712285400000
35858	1726	747362376000
35859	1874	202624000
35860	1599	18720500000000
35861	1599	18720540000000
35901	1688	145444689000000
35932	1726	746042365000
35933	1874	202635000
35934	1397	1379834117000
35935	1678	10080285983000
35936	1397	1379824116000
35937	1678	10080285984000
35938	1726	746032364000
35939	1874	202636000
35940	1690	68401586000000
35941	1397	1379814115000
35942	1678	10080285985000
35943	1673	22703821000000
35944	144	66337270000000
35945	1726	746022363000
35946	1874	202637000
35947	1726	746012362000
35948	1874	202638000
35949	1397	1379804114000
35950	1678	10080285986000
35951	633	83999840000000
35952	633	83999890000000
35958	1688	146164689000000
35959	1688	146164739000000
35960	1726	746002361000
35961	1874	202639000
35962	1397	1379794113000
35963	1678	10080285987000
35964	1683	797773719999541
36029	1293	1704912648132442
36030	1700	3185780276737
36031	1726	745902351000
36032	1874	202649000
36033	1397	1379694103000
36034	1678	10080285997000
36035	1726	745892350000
36036	1874	202650000
36037	1726	745882349000
36038	1874	202651000
36039	1397	1379684102000
36040	1678	10080285998000
36041	1397	1379674101000
36042	1678	10080285999000
36043	1444	3454935160000
36044	1444	3454975160000
36056	1397	1379654099000
36057	1678	10080286001000
36058	1397	1379644098000
36059	1678	10080286002000
36060	1726	745862347000
36061	1874	202653000
36062	1726	745852346000
36063	1874	202654000
36064	1706	20156562000000
36143	1688	147604790000000
36144	1688	147604820000000
36145	1397	1379514085000
36146	1678	10080286015000
36147	1726	745722333000
36148	1874	202667000
36149	1422	20880510000000
36150	1422	20880530000000
36174	1509	21600642000000
36175	1509	21600662000000
36200	1397	1379424076000
36201	1678	10080286024000
36202	1726	745632324000
36203	1874	202676000
36204	1637	120243604819997
36205	1637	120243624819997
36222	1747	8735687000000
36277	301	66720500000000
36339	333	66000084938283
36340	2015	333800000000
36341	1726	745442305000
36342	1874	202695000
36343	1397	1379224056000
36344	1678	10080286044000
36345	1690	70561687000000
36346	1690	70561807000000
36378	1726	745412302000
36379	1874	202698000
36380	1397	1379194053000
36381	1678	10080286047000
36382	1422	12651818852698
36383	1337	1701480937522450
36384	1700	4625800276737
36385	1700	4625821276737
36398	1726	745382299000
36399	1874	202701000
36400	1397	1379164050000
36401	1678	10080286050000
36402	1698	25919591000000
36412	1726	745362297000
36413	1874	202703000
36414	1397	1379144048000
36415	1678	10080286052000
36416	1471	22320510000000
36439	1726	745312292000
36440	1874	202708000
36441	1397	1379104044000
36442	1678	10080286056000
36443	1615	720020000000
36444	1726	745302291000
36445	1874	202709000
36446	1397	1379094043000
36447	1678	10080286057000
36448	1397	1379084042000
36449	1678	10080286058000
36450	1397	1379074041000
36451	1678	10080286059000
36452	1726	745292290000
36453	1874	202710000
36454	1726	745282289000
36455	1874	202711000
36456	1440	23760780000000
36457	1440	23760840000000
36458	1397	1379064040000
36459	1678	10080286060000
36460	1726	745272288000
36461	1874	202712000
36462	1634	20160463899999
36501	1718	14297582889008
36502	1718	15017582889008
36503	1718	900000
36504	1604	15017592089008
36520	1397	1378964030000
36521	1678	10080286070000
36522	1688	141756558907000
36523	32	73922280157000
36524	1726	745172278000
36525	1874	202722000
36526	1397	1378954029000
36527	1678	10080286071000
36528	1726	745162277000
36529	1874	202723000
36530	1622	12959359999976
36531	1622	12959409999976
36591	1726	745082269000
36592	1874	202731000
36593	1397	1378874021000
36594	1678	10080286079000
36595	1397	1378864020000
36596	1678	10080286080000
36597	1397	1378854019000
36598	1678	10080286081000
36599	1688	117248002732000
36600	791	55779240794584
36601	1688	117192295630000
36602	799	13943560758181
36603	1688	116579618037000
35977	1422	20160510000000
35978	1693	7222660053757
35979	1693	7222681053757
36045	1560	2033957277002
36046	2000	2033997277001
36047	1560	200000001
36065	1681	1943008759830
36066	1714	23002972377216
36067	934	505684242622784
36068	1397	1379634097000
36069	1678	10080286003000
36070	1726	745842345000
36071	1874	202655000
36072	112	66001269665601
36073	1821	341990000000
36074	1679	82082012980000
36075	1679	82082133980000
36151	1440	23040780000000
36152	1397	1379504084000
36153	1678	10080286016000
36154	1397	1379494083000
36155	1678	10080286017000
36156	1726	745712332000
36157	1874	202668000
36158	1726	745702331000
36159	1874	202669000
36160	1708	14399632000000
36176	1679	82802133980000
36177	1679	82802153980000
36178	1726	745672328000
36179	1874	202672000
36180	1726	745662327000
36181	1874	202673000
36182	1726	745652326000
36183	1874	202674000
36184	1397	1379464080000
36185	1678	10080286020000
36186	1397	1379454079000
36187	1678	10080286021000
36188	1397	1379444078000
36189	1678	10080286022000
36190	1688	147604850000000
36191	1683	800653799999541
36206	1726	745622323000
36207	1874	202677000
36208	1397	1379414075000
36209	1678	10080286025000
36223	1746	7919241000000
36224	1746	7919261000000
36230	1654	17280431000000
36231	1654	17280451000000
36232	1726	745582319000
36233	1874	202681000
36234	1397	1379374071000
36235	1678	10080286029000
36236	1423	753177999985
36237	1423	753197999985
36238	1726	745572318000
36239	1874	202682000
36240	1726	745562317000
36241	1874	202683000
36242	1397	1379364070000
36243	1678	10080286030000
36244	1397	1379354069000
36245	1678	10080286031000
36246	1850	2078510000000
36247	1850	2078550000000
36266	1726	745532314000
36267	1874	202686000
36268	1397	1379324066000
36269	1678	10080286034000
36270	1604	100000
36271	633	84719889900000
36272	633	84719909900000
36278	1685	74161239571430
36279	1685	74161249571430
36291	2002	0
36292	558	66033774938283
36293	1726	745502311000
36294	1874	202689000
36295	1397	1379294063000
36296	1678	10080286037000
36297	1397	1379284062000
36298	1678	10080286038000
36299	1397	1379274061000
36300	1678	10080286039000
36301	1397	1379264060000
36302	1678	10080286040000
36303	1726	745492310000
36304	1874	202690000
36305	1726	745482309000
36306	1874	202691000
36307	1422	20152119623498
36308	715	2008389376502
36309	1690	69841606000000
36310	1690	69841687000000
36311	1650	11400330000000
36312	1009	504335775000000
36313	1650	8608220000000
36314	1129	903765465000000
36315	1650	6724110000000
36316	1249	609788750000000
36317	1650	1474000000000
36318	1375	1699230637751650
36319	1726	745472308000
36320	1874	202692000
36321	1397	1379254059000
36322	1678	10080286041000
36323	1657	18720552000000
36324	1657	18721012000000
36347	1683	802093909999541
36348	1397	1379214055000
36349	1678	10080286045000
36350	1726	745432304000
36351	1874	202696000
36352	1762	3201680000000
36353	1762	3201700000000
36386	1700	4625811276737
36403	1693	8662741053757
36404	1693	8662761053757
36417	1685	74161259571430
36418	1397	1379134047000
36419	1678	10080286053000
36420	1726	745352296000
36421	1874	202704000
36463	1419	4060857280064
36464	1419	4060877280064
36465	1397	1379054039000
36466	1678	10080286061000
36467	1726	745262287000
36468	1874	202713000
36469	1397	1379044038000
36470	1678	10080286062000
36471	1726	745252286000
36472	1874	202714000
36473	1633	2916229985638
36474	1633	2916269985638
36475	1726	745242285000
36476	1874	202715000
36477	1688	147340107830000
36478	40	66264692170000
36479	1726	745232284000
36480	1874	202716000
36481	1397	1379034037000
36482	1678	10080286063000
36483	1397	1379024036000
36484	1678	10080286064000
36485	1677	277207963000000
36532	1402	76323053000000
36533	1726	745152276000
36534	1874	202724000
36535	1397	1378944028000
36536	1678	10080286072000
36537	1688	141645144721000
36538	779	27889620396792
36539	43	86880570890000
36540	43	86880600890000
36632	1397	1378824016000
36633	1678	10080286084000
36634	1445	16559330000000
36635	480	66001000000000
36636	1726	745032264000
36637	1874	202736000
36638	1691	14399402000000
36639	1691	14399432000000
36646	1726	745022263000
36647	1874	202737000
36648	369	89040672000000
36649	369	89040692000000
36650	1683	807853879999541
36651	1683	807853899999541
36671	1683	60912741149541
36672	1393	75746941148850000
36673	1726	744992260000
36674	1874	202740000
36675	1397	1378774011000
36676	1678	10080286089000
36677	1654	18000451000000
36678	1654	18000481000000
36695	1445	2444290000000
36696	924	504692775000000
36697	632	84000633000000
36706	1683	62352741149541
36707	1683	62352771149541
36776	1683	60912751149541
35991	1874	202643000
35992	1726	745952356000
35993	1874	202644000
35994	1397	1379744108000
35995	1678	10080285992000
35996	1688	146164749000000
35997	1726	745942355000
35998	1874	202645000
35999	1726	745932354000
36000	1874	202646000
36001	1397	1379734107000
36002	1678	10080285993000
36003	1397	1379724106000
36004	1678	10080285994000
36005	1699	2733836050108
36006	1773	6840402949970
36007	1699	3453836050108
36008	1699	3453877050108
36009	1773	6721874027010
36010	182	66426372520656
36011	1397	1379714105000
36012	1678	10080285995000
36013	1397	1379704104000
36014	1678	10080285996000
36015	1726	745922353000
36016	1874	202647000
36017	1726	745912352000
36018	1874	202648000
36019	1773	6642851411700
36020	702	44284248347116
36021	1773	5741550141990
36022	927	506022423570956
36023	1773	4126433908930
36024	1047	906787847439016
36025	1773	3036679550220
36026	1167	610827828691356
36027	1700	2465770276737
36028	1700	3185770276737
36050	1560	2033997277002
36051	1397	1379664100000
36052	1678	10080286000000
36053	1726	745872348000
36054	1874	202652000
36055	1683	799213739999541
36088	1683	800653739999541
36089	1683	800654059999541
36090	1397	1379614095000
36091	1678	10080286005000
36092	1397	1379604094000
36093	1678	10080286006000
36094	1726	745822343000
36095	1874	202657000
36096	1726	745812342000
36097	1874	202658000
36098	1958	885987000000
36099	1978	122000000000
36100	1688	146884749000000
36101	1688	146884790000000
36102	1726	745802341000
36103	1874	202659000
36104	1726	745792340000
36105	1874	202660000
36106	1637	119523604819997
36107	1726	745782339000
36108	1874	202661000
36109	1726	745772338000
36110	1874	202662000
36111	1397	1379594093000
36112	1678	10080286007000
36113	1397	1379584092000
36114	1678	10080286008000
36115	1397	1379574091000
36116	1678	10080286009000
36117	1397	1379564090000
36118	1678	10080286010000
36119	1693	7942681053757
36120	1693	7942741053757
36135	1397	1379524086000
36136	1678	10080286014000
36137	1714	4485513103056
36138	1590	5500000000
36139	1726	745732334000
36140	1874	202666000
36141	1700	3905770276737
36142	1700	3905800276737
36167	1397	1379474081000
36168	1678	10080286019000
36169	470	68160121000000
36170	1726	745682329000
36171	1874	202671000
36172	1668	3566451000000
36173	1668	3566471000000
36198	1650	13680440000000
36199	1650	13680460000000
36217	1726	745602321000
36218	1874	202679000
36219	1397	1379394073000
36220	1678	10080286027000
36221	1704	5039215000000
36225	1726	745592320000
36226	1874	202680000
36227	1397	1379384072000
36228	1678	10080286028000
36229	1588	19440590000000
36263	1687	6565184726450
36264	1687	7285184726450
36265	1687	7285214726450
36275	301	66720490000000
36276	301	66720510000000
36337	1571	15120241001000
36338	1571	15120281001000
36359	1467	21602263100000
36360	1467	21602283100000
36361	1714	22282912377216
36362	1467	20884413100000
36363	1714	17074447299806
36364	1714	13560159598078
36365	1714	3767463103056
36366	1714	3765453103056
36367	1673	21263781000000
36368	1673	20926501000000
36369	1705	11791369945944
36370	1705	11785551323105
36371	1705	10327425316625
36372	1705	7714483926145
36373	1705	5951477050657
36374	1705	1038719500145
36375	1467	21604413100000
36376	1786	21606153099999
36377	1467	200000003
36405	1688	147604810000000
36406	1726	745372298000
36407	1874	202702000
36408	1397	1379154049000
36409	1678	10080286051000
36410	1683	802093819999541
36422	149	69149607000341
36486	149	69149637000341
36487	1397	1379014035000
36488	1678	10080286065000
36489	1726	745222283000
36490	1874	202717000
36491	1683	804973839999541
36492	1683	804973859999541
36541	1690	71281807000000
36542	1690	71281837000000
36571	1688	130445092671000
36572	1688	130445212671000
36581	1688	119921721073000
36582	786	2454234815297720
36583	1726	745092270000
36584	1874	202730000
36585	1688	117470821105000
36586	792	613571113264101
36587	1397	1378884022000
36588	1678	10080286078000
36589	641	67831530000000
36590	641	67831570000000
36627	1419	4061007280064
36640	1710	3934415473290
36641	1710	3934445473290
36652	1445	10107320000000
36653	1290	1700432637751650
36654	1397	1378804014000
36655	1678	10080286086000
36656	1726	745012262000
36657	1874	202738000
36658	1445	6675310000000
36659	1044	904405465000000
36660	1679	82802173980000
36679	1726	744982259000
36680	1874	202741000
36681	1726	744972258000
36682	1874	202742000
36683	1677	28008051325000
36684	1395	57867290193533700
36685	1397	1378764010000
36686	1678	10080286090000
36687	1397	1378754009000
36688	1678	10080286091000
36689	1657	19441012000000
36690	1657	19441062000000
36708	295	66000000665601
36709	2017	343200000000
36710	1397	1378724006000
36395	1397	1379174051000
36396	1678	10080286049000
36397	1536	720040000000
36411	1692	34580270019999
36423	1672	2160774000000
36424	2016	1004000000000
36425	1726	745342295000
36426	1874	202705000
36427	1397	1379124046000
36428	1678	10080286054000
36429	1764	721703100000
36430	1726	745332294000
36431	1874	202706000
36432	1476	720010000000
36433	1726	745322293000
36434	1874	202707000
36435	1397	1379114045000
36436	1678	10080286055000
36437	1683	803533819999541
36438	1683	803533839999541
36493	1397	1379004034000
36494	1678	10080286066000
36495	1677	276487923000000
36496	1726	745212282000
36497	1874	202718000
36498	1677	277207923000000
36499	1509	277207932000000
36500	1677	20880643000000
36505	1397	1378994033000
36506	1678	10080286067000
36507	1688	142051849064000
36508	31	1323893248766000
36509	1397	1378984032000
36510	1678	10080286068000
36511	1397	1378974031000
36512	1678	10080286069000
36513	1726	745202281000
36514	1874	202719000
36515	1726	745192280000
36516	1874	202720000
36517	1726	745182279000
36518	1874	202721000
36519	1685	74161309571430
36543	1683	806413859999541
36544	1683	806413879999541
36545	1688	140419689737000
36546	780	306785556632051
36547	1726	745142275000
36548	1874	202725000
36549	1726	745132274000
36550	1874	202726000
36551	1726	745122273000
36552	1874	202727000
36553	1726	745112272000
36554	1874	202728000
36555	1688	130616318139000
36556	782	2454234815297720
36557	1688	129725092671000
36558	785	223112450651807
36559	1397	1378934027000
36560	1678	10080286073000
36561	1397	1378924026000
36562	1678	10080286074000
36563	1397	1378914025000
36564	1678	10080286075000
36565	1397	1378904024000
36566	1678	10080286076000
36567	1426	16560630000000
36568	1426	16560750000000
36569	1706	20876562000000
36570	1706	20876682000000
36573	1397	1378894023000
36574	1678	10080286077000
36575	1726	745102271000
36576	1874	202729000
36577	1677	277927932000000
36578	1677	277927952000000
36579	58	68826224999659
36580	58	68826244999659
36642	1397	1378814015000
36643	1678	10080286085000
36644	470	68880111000000
36645	470	68880151000000
36661	1397	1378794013000
36662	1678	10080286087000
36663	1726	745002261000
36664	1874	202739000
36665	1445	4359300000000
36666	1164	610220750000000
36667	1397	1378784012000
36668	1678	10080286088000
36669	1522	2493910000000
36670	1522	2493950000000
36691	1397	1378744008000
36692	1678	10080286092000
36693	1726	744962257000
36694	1874	202743000
36698	1679	80827780187000
36699	1	374067383793000
36700	1726	744952256000
36701	1874	202744000
36702	1397	1378734007000
36703	1678	10080286093000
36704	1680	1449149500035
36705	1680	1449179500035
36729	1489	20880691000000
36730	1489	20880881000000
36745	1726	744922253000
36746	1874	202747000
36747	1696	16558916000000
36748	1679	59652345518000
36749	855	130585080959125
36750	1726	744912252000
36751	1874	202748000
36752	1679	57914407852000
36753	857	329268330367608
36754	1679	55513914636000
36755	861	454796316444125
36756	1679	53406549734000
36757	865	399260132587417
36758	1679	40572273032000
36759	867	2431584266702000
36760	1679	39199738031000
36761	869	260039024940845
36762	1726	743702252000
36763	2018	200000000
36764	1726	742492252000
36765	2019	200000000
36766	1726	741282252000
36767	2020	200000000
36768	1397	1378704004000
36769	1678	10080286096000
36770	1397	1378694003000
36771	1678	10080286097000
36772	1696	17278916000000
36773	1696	17279036000000
36808	1397	1378674001000
36809	1678	10080286099000
36810	1679	21437706707000
36811	881	585381397403250
36812	1679	20962353496000
36813	883	90058676523500
36814	1726	741262250000
36815	1874	202750000
36816	1677	28728051325000
36817	1677	28728101325000
36822	1726	741252249000
36823	1874	202751000
36824	1679	18347955835000
36825	891	495322720879750
36826	1679	18003074829000
36827	897	65339370990885
36828	1679	17797488397000
36829	899	38948576422990
36830	1397	1378664000000
36831	1678	10080286100000
36832	1726	741242248000
36833	1874	202752000
36834	1397	1378653999000
36835	1678	10080286101000
36836	1675	1581799999977
36837	1679	17179532223000
36838	901	117076279480250
36839	1726	741232247000
36840	1874	202753000
36841	1726	741222246000
36842	1874	202754000
36843	1726	741212245000
36844	1874	202755000
36845	1397	1378643998000
36846	1678	10080286102000
36847	1679	14957292711000
36848	905	421024312747938
36849	1447	24479807000000
36850	2022	0
36851	1397	1378633997000
36852	1678	10080286103000
36853	1397	1378623996000
36854	1678	10080286104000
36855	1701	1510153600056
36898	1397	1378573991000
36899	1678	10080286109000
36900	1726	741162240000
36901	1874	202760000
36902	1706	20876582000000
36604	800	153379034487607
36605	1688	116523900630000
36606	801	13946140510666
36607	1397	1378844018000
36608	1678	10080286082000
36609	1726	745072268000
36610	1874	202732000
36611	1726	745062267000
36612	1874	202733000
36613	1726	745052266000
36614	1874	202734000
36615	1688	115911109685000
36616	802	153407411737275
36617	1688	115479971940000
36618	811	107931214459286
36619	1688	110737560878000
36620	812	1187242322919140
36621	1688	103819452596000
36622	823	1731919963467760
36623	1688	27720427904000
36624	824	19051102971730700
36625	1727	3066636000000
36626	1727	3066786000000
36628	1726	745042265000
36629	1874	202735000
36630	1397	1378834017000
36631	1678	10080286083000
36774	1706	20876572000000
36775	1706	20876692000000
36806	1719	720000000000
36807	1719	720140000000
36818	1683	62352881149541
36821	1675	1581729999977
36856	1686	15332416500013
36858	1726	741202244000
36859	1874	202756000
36860	1397	1378613995000
36861	1678	10080286105000
36862	1397	1378603994000
36863	1678	10080286106000
36864	1726	741192243000
36865	1874	202757000
36866	1677	29448101325000
36867	1677	29448141325000
36903	1509	21600643000000
36904	1509	21600663000000
36910	1397	1378553989000
36911	1678	10080286111000
36912	1726	741142238000
36913	1874	202762000
36914	1690	71281827000000
36929	1698	25197471000000
36930	2023	1000000000
36931	1726	741112235000
36932	1874	202765000
36933	1397	1378523986000
36934	1678	10080286114000
36935	1692	34580380019999
36938	1397	1378513985000
36939	1678	10080286115000
36940	1726	741102234000
36941	1874	202766000
36942	1654	18720501000000
36943	1397	1378503984000
36944	1678	10080286116000
36945	1397	1378493983000
36946	1678	10080286117000
36947	1397	1378483982000
36948	1678	10080286118000
36949	1726	741092233000
36950	1874	202767000
36951	1726	741082232000
36952	1874	202768000
36953	1726	741072231000
36954	1874	202769000
36955	1688	28440427904000
36956	1688	28440487904000
36960	1726	741062230000
36961	1874	202770000
36962	1397	1378473981000
36963	1678	10080286119000
36964	1397	1378463980000
36965	1678	10080286120000
36966	1397	1378453979000
36967	1678	10080286121000
36968	1397	1378443978000
36969	1678	10080286122000
36970	1397	1378433977000
36971	1678	10080286123000
36972	1726	741052229000
36973	1874	202771000
36974	1726	741042228000
36975	1874	202772000
36976	1726	741032227000
36977	1874	202773000
36978	1447	5194270944000
36979	1447	5194360944000
36987	1602	2160200000000
36988	1602	2160220000000
37039	1726	740962220000
37040	1874	202780000
37041	1440	24480840000000
37042	1440	24480850000000
37077	1726	739722217000
37078	1874	202783000
37079	1726	739712216000
37080	1874	202784000
37081	1397	1378333967000
37082	1678	10080286133000
37083	1397	1378323966000
37084	1678	10080286134000
37085	1608	17280440000000
37086	1608	17280480000000
37113	1717	17279843000000
37144	1397	1378213955000
37145	1678	10080286145000
37146	1726	739592204000
37147	1874	202796000
37148	1601	4538450600000
37149	495	66720000000000
37150	495	66720020000000
37167	1705	2478839500145
37192	1726	739512196000
37193	1874	202804000
37194	1726	739502195000
37195	1874	202805000
37196	1678	10080286149000
37197	1678	10080286150000
37198	1678	10080286151000
37199	1678	10080286152000
37200	1397	1378133947000
37201	1678	10080286153000
37202	1397	1378123946000
37203	1678	10080286154000
37204	1587	720390000000
37245	1739	16559603000000
37252	1726	739432188000
37253	1874	202812000
37254	1397	1378043938000
37255	1678	10800326162000
37256	1677	30888221325000
37257	1677	30888241325000
37271	1726	739402185000
37272	1874	202815000
37273	1397	1378013935000
37274	1678	10800326165000
37275	1692	35300380019999
37276	1692	35300400019999
37285	1613	17278680000000
37286	1613	17278700000000
37300	1688	28440468904000
37339	1678	10800326170000
37340	1678	10800326171000
37341	1678	10800326172000
37342	1549	28800756000000
37343	1549	28800826000000
37346	1397	1377933927000
37347	1678	10800326173000
37348	1726	739312176000
37349	1874	202824000
37350	1634	20880463899999
37351	1634	20880483899999
37365	1679	79387619187000
37366	1683	47952411149541
37367	1467	21606433099999
37368	1688	142299886830000
37369	1677	22247742325000
37370	1688	137011628064000
37371	1688	136716337907000
37372	1688	136604923721000
37373	1688	135379468737000
37374	1679	78945673097000
37375	1679	78121734865000
37376	1679	72021512341000
37377	1679	60204470114000
37378	1679	58901442174000
37379	1679	58212184518000
37380	1679	56474246852000
37381	1679	54073753636000
37382	1679	51966388734000
37383	1679	39132112032000
37384	1679	37759577031000
37385	1679	24925300329000
37386	1679	23800311396000
37387	1679	23087286579000
36711	1678	10080286094000
36712	1397	1378714005000
36713	1678	10080286095000
36714	1679	80385834097000
36715	841	83729352737298
36716	1679	79561895865000
36717	843	156101705973667
36718	1679	73461673341000
36719	849	1155748212256640
36720	1679	61644631114000
36721	851	2238858698375750
36722	1679	60341603174000
36723	853	246870194966225
36724	1726	744942255000
36725	1874	202745000
36726	1726	744932254000
36727	1874	202746000
36728	1602	1440200000000
36731	1679	76507499187000
36732	1683	43631871149541
36733	2003	351970654821
36734	1672	1440724000000
36735	1688	138699355830000
36736	1693	5782620053757
36737	1677	20807702325000
36738	1688	133411097064000
36739	1688	133115806907000
36740	1489	20165031000000
36741	1688	133004392721000
36742	1688	131778937737000
36743	1489	20885031000000
36744	1489	20885541000000
36781	1696	200000001
36782	1796	17279026099998
36783	1964	19800000
36784	1728	200000001
36789	1740	19435156000000
36804	1719	20000000000
36805	1719	20140000000
36905	1726	741152239000
36906	1874	202761000
36907	1397	1378563990000
36908	1678	10080286110000
36909	1683	62352861149541
36936	1654	18720481000000
36937	1654	18720582000000
36958	1623	30961990899898
36959	1623	30962050899898
36989	1705	2478799500145
36990	1705	2478819500145
37037	1611	17270620000000
37038	1611	17270840000000
37043	1706	10486856746065
37044	451	66305884206092
37045	1726	740952219000
37046	1874	202781000
37047	1726	739742219000
37048	1937	1400000000
37049	1706	10357440892053
37050	487	66305884206092
37051	1706	10353509502543
37052	744	2009269218353
37053	1706	9368276069745
37054	988	505106484932068
37055	1706	7602754119565
37056	1108	905146493245880
37057	1706	6411518026475
37058	1228	610720375310940
37059	1706	3092050600135
37060	1354	1701826628032090
37061	1397	1378363970000
37062	1678	10080286130000
37063	1397	1378353969000
37064	1678	10080286131000
37065	1850	2798550000000
37066	1850	2798660000000
37087	1397	1378313965000
37088	1678	10080286135000
37089	1726	739702215000
37090	1874	202785000
37091	1656	25920753000000
37114	1690	72001827000000
37115	1690	72001917000000
37119	1397	1378263960000
37120	1678	10080286140000
37121	1670	1440630000000
37122	1670	1440650000000
37123	1693	10102951053757
37124	1693	10102971053757
37125	1726	739632208000
37126	1874	202792000
37127	1397	1378253959000
37128	1678	10080286141000
37129	1688	28440467904000
37151	1397	1378203954000
37152	1678	10080286146000
37153	1726	739582203000
37154	1874	202797000
37155	1402	77043053000000
37156	1402	77043073000000
37170	1678	10800286148000
37171	1678	10800326148000
37205	1678	10800326153000
37206	1678	10800326154000
37219	1726	739482193000
37220	1874	202807000
37221	1397	1378103944000
37222	1678	10800326156000
37223	1397	1378093943000
37224	1678	10800326157000
37225	1740	19435145000000
37226	1696	17998926000000
37227	1696	17998957000000
37246	1726	739442189000
37247	1874	202811000
37248	1397	1378053939000
37249	1678	10800326161000
37250	1683	65232902149541
37251	1683	65232922149541
37277	1397	1378003934000
37278	1678	10800326166000
37279	1726	739392184000
37280	1874	202816000
37281	1677	31608241325000
37282	1677	31608261325000
37298	1678	11520326168000
37299	1678	11520367168000
37301	1397	1377973931000
37302	1678	10800326169000
37303	1726	739362181000
37304	1874	202819000
37305	1650	2914021000000
37306	1650	2914041000000
37307	1678	10080286155000
37308	1678	10080286156000
37309	1678	10080286157000
37310	1678	10080286158000
37311	1678	10080286159000
37312	1678	10080286160000
37313	1678	10080286161000
37314	1678	10080286162000
37315	1678	10080286163000
37316	1678	10080286164000
37317	1678	10080286165000
37318	1678	10080286166000
37319	1678	10080286167000
37320	1678	10080286168000
37321	1678	10080286169000
37322	1397	1377963930000
37323	1678	10080286170000
37324	1397	1377953929000
37325	1678	10080286171000
37326	1397	1377943928000
37327	1678	10080286172000
37328	1587	720710000000
37329	1726	739352180000
37330	1874	202820000
37331	1726	739342179000
37332	1874	202821000
37333	1726	739332178000
37334	1874	202822000
37335	1726	739322177000
37336	1874	202823000
37337	1587	1440710000000
37338	1587	1440756000000
37438	1726	739262171000
37439	1874	202829000
37440	1397	1377883922000
37441	1678	10800326178000
37442	1683	66672922149541
37443	1683	66672942149541
37462	576	85055674938283
37463	576	85055694938283
37466	1692	36020400019999
37467	1692	36020420019999
37470	1726	739222167000
37471	1874	202833000
37472	1397	1377843918000
37473	1678	10800326182000
37474	1444	3454955160000
37477	1726	739212166000
37478	1874	202834000
37479	1397	1377833917000
37480	1678	10800326183000
37481	470	68880131000000
36777	1683	62352751149541
36778	1683	62352871149541
36779	1728	17279026100000
36780	1696	19800000
36785	1740	18715036000000
36786	1740	19435036000000
36787	145	19435146000000
36788	1740	66000010000000
36790	2017	343100000000
36791	1397	1378684002000
36792	1678	10080286098000
36793	1679	26365461329000
36794	873	2431584266702000
36795	1726	741272251000
36796	1874	202749000
36797	1679	25240472396000
36798	875	213138867772583
36799	1679	24527447579000
36800	879	135088014785750
36801	2021	699000000000
36802	1457	21620541000000
36803	1457	21620691000000
36819	1683	63792881149541
36820	1683	63792931149541
36857	1683	62352831149541
36868	2017	342900000000
36869	295	66000100665601
36870	1447	15334560602000
36871	1345	1703125874149650
36872	1447	10470495404000
36873	1099	905837520198000
36874	1397	1378593993000
36875	1678	10080286107000
36876	1397	1378583992000
36877	1678	10080286108000
36878	1447	7188610439000
36879	1219	611186624965000
36880	1447	4474270944000
36881	979	505492104495000
36882	1726	741182242000
36883	1874	202758000
36884	1726	741172241000
36885	1874	202759000
36886	1972	177000000
36887	1972	176000000
36888	1972	175000000
36889	1972	174000000
36890	1972	173000000
36891	1972	172000000
36892	1972	171000000
36893	1972	170000000
36894	1972	169000000
36895	1972	168000000
36896	1693	9382761053757
36897	1693	9382951053757
36915	1726	741132237000
36916	1874	202763000
36917	1397	1378543988000
36918	1678	10080286112000
36919	1445	4359289000000
36920	480	66001010000000
36921	1650	2194000000000
36922	1650	2194021000000
36957	1756	4067815575609
36980	171	68150330524688
36991	1602	2160310000000
37069	1594	2784960000000
37070	1594	2785070000000
37071	1688	28440537904000
37116	1726	739642209000
37117	1874	202791000
37118	1588	19440580000000
37168	1556	720000000000
37169	1556	720040000000
37172	1397	1378173951000
37173	1678	10800326149000
37174	1726	739552200000
37175	1874	202800000
37176	1726	739542199000
37177	1874	202801000
37178	1397	1378163950000
37179	1678	10800326150000
37180	1397	1378153949000
37181	1678	10800326151000
37182	1397	1378143948000
37183	1678	10800326152000
37184	1726	739532198000
37185	1874	202802000
37186	1726	739522197000
37187	1874	202803000
37188	1677	30168141325000
37189	1677	30168221325000
37209	1726	739492194000
37210	1874	202806000
37211	1397	1378113945000
37212	1678	10800326155000
37213	1950	6387389000000
37214	2024	1000000000
37215	1950	6385388000000
37216	2024	3000000000
37217	1451	14400461000000
37218	1451	14400483000000
37229	1726	739472192000
37230	1874	202808000
37231	1397	1378083942000
37232	1678	10800326158000
37233	1397	1378073941000
37234	1678	10800326159000
37235	1726	739462191000
37236	1874	202809000
37237	1683	62352901149541
37238	563	66000526000000
37239	1683	63792901149541
37258	1397	1378033937000
37259	1678	10800326163000
37260	1726	739422187000
37261	1874	202813000
37262	1489	20880711000000
37283	1622	12959379999976
37287	1726	739382183000
37288	1874	202817000
37289	1726	739372182000
37290	1874	202818000
37291	1397	1377993933000
37292	1678	10800326167000
37293	1397	1377983932000
37294	1678	10800326168000
37295	1950	5385386000000
37296	2025	999000000000
37297	1677	31608282325000
37344	1587	1440040000000
37345	1587	1440110000000
37352	1688	29160468904000
37353	1688	29160558904000
37357	1397	1377913925000
37358	1678	10800326175000
37359	1726	739302175000
37360	1874	202825000
37361	1726	739292174000
37362	1874	202826000
37363	1467	22322283100000
37364	1467	22322323100000
37448	1402	77763073000000
37449	1402	77763113000000
37456	1726	739232168000
37457	1874	202832000
37458	1397	1377853919000
37459	1678	10800326181000
37460	1546	20160510000000
37461	1546	20160530000000
37464	1611	17990840000000
37465	1611	17990860000000
37468	1683	68112942149541
37469	1683	68112962149541
37485	1726	739202165000
37486	1874	202835000
37487	1726	739192164000
37488	1874	202836000
37489	1397	1377813915000
37490	1678	10800326185000
37491	1739	16559613000000
37505	1764	1441703100000
37506	1764	1441723100000
37525	1726	739122157000
37526	1874	202843000
37527	1397	1377733907000
37528	1678	10800326193000
37529	1727	3066656000000
37538	1677	30888261325000
37541	1685	74161329571430
37542	1685	74881329571430
37548	1726	739092154000
37549	1874	202846000
37550	1397	1377703904000
37551	1678	10800326196000
37558	1726	739072152000
37559	1874	202848000
37560	1726	739062151000
37561	1874	202849000
37562	1397	1377683902000
37563	1678	10800326198000
37564	1397	1377673901000
37565	1678	10800326199000
37566	1594	2785000000000
37576	1683	72433072149541
36923	1726	741122236000
36924	1874	202764000
36925	1397	1378533987000
36926	1678	10080286113000
36927	1683	63792861149541
36928	1683	63792902149541
36981	1397	1378423976000
36982	1678	10080286124000
36983	1726	741022226000
36984	1874	202774000
36985	633	85439909900000
36986	633	85439929900000
36992	1698	24777896660710
36993	556	66419564339290
36994	1726	741012225000
36995	1874	202775000
36996	1726	741002224000
36997	1874	202776000
36998	1726	740992223000
36999	1874	202777000
37000	1726	740982222000
37001	1874	202778000
37002	1397	1378413975000
37003	1678	10080286125000
37004	1397	1378403974000
37005	1678	10080286126000
37006	1397	1378393973000
37007	1678	10080286127000
37008	1397	1378383972000
37009	1678	10080286128000
37010	1397	1378373971000
37011	1678	10080286129000
37012	1698	21586566520030
37013	930	505969095140680
37014	1698	15867738171150
37015	1050	906692283348880
37016	1698	12009127475655
37017	1170	611763350695495
37018	1698	1256783550035
37019	1296	1704732971677270
37020	1706	20700093647920
37021	451	66176478352080
37022	1706	20523605295840
37023	487	66176478352080
37024	1706	20518247466997
37025	744	2005347828843
37026	1706	19174750967727
37027	988	504121261499270
37028	1706	16767224672027
37029	1108	903380981295700
37030	1706	15142815454177
37031	1228	609529149217850
37032	1706	10616272600077
37033	1354	1698507170605750
37034	1726	740972221000
37035	1874	202779000
37036	369	89040892000000
37067	1684	5011184880623
37068	1684	5011294880623
37072	1726	739732218000
37073	1874	202782000
37074	1397	1378343968000
37075	1678	10080286132000
37076	1508	16560371000000
37092	1675	2301799999977
37093	1675	2301819999977
37094	1726	739692214000
37095	1874	202786000
37096	1726	739682213000
37097	1874	202787000
37098	1726	739672212000
37099	1874	202788000
37100	1726	739662211000
37101	1874	202789000
37102	1726	739652210000
37103	1874	202790000
37104	1397	1378303964000
37105	1678	10080286136000
37106	1397	1378293963000
37107	1678	10080286137000
37108	1397	1378283962000
37109	1678	10080286138000
37110	1397	1378273961000
37111	1678	10080286139000
37112	1691	14399492000000
37130	1397	1378243958000
37131	1678	10080286142000
37132	1397	1378233957000
37133	1678	10080286143000
37134	1726	739622207000
37135	1874	202793000
37136	1726	739612206000
37137	1874	202794000
37138	1749	2000451000000
37139	1726	739602205000
37140	1874	202795000
37141	1397	1378223956000
37142	1678	10080286144000
37143	606	67819604812962
37157	1726	739572202000
37158	1874	202798000
37159	1726	739562201000
37160	1874	202799000
37161	1397	1378193953000
37162	1678	10080286147000
37163	1397	1378183952000
37164	1678	10080286148000
37165	1708	15119632000000
37166	1708	15119672000000
37190	1633	3636269985638
37191	1633	3636349985638
37207	1739	16559583000000
37208	1739	16559623000000
37228	1700	4625831276737
37240	1726	739452190000
37241	1874	202810000
37242	1397	1378063940000
37243	1678	10800326160000
37244	484	87600592000000
37263	1397	1378023936000
37264	1678	10800326164000
37265	1726	739412186000
37266	1874	202814000
37267	1950	6383387000000
37268	2025	1000000000
37269	1610	1440040000000
37270	1610	1440061000000
37284	1622	12959399999976
37354	1397	1377923926000
37355	1678	10800326174000
37356	1688	29160498904000
37426	1397	1377903924000
37427	1678	10800326176000
37428	1726	739282173000
37429	1874	202827000
37430	1607	4578164644388
37431	1607	4578184644388
37450	1397	1377863920000
37451	1678	10800326180000
37452	1726	739242169000
37453	1874	202831000
37454	1850	3518660000000
37455	1850	3518680000000
37475	1690	72721917000000
37476	1690	72721937000000
37482	1397	1377823916000
37483	1678	10800326184000
37484	470	68880141000000
37499	1397	1377783912000
37500	1678	10800326188000
37501	1726	739172162000
37502	1874	202838000
37503	1637	120963624819997
37504	1637	120963644819997
37521	1397	1377743908000
37522	1678	10800326192000
37523	1726	739132158000
37524	1874	202842000
37539	1688	28440488904000
37540	1688	29160488904000
37552	1397	1377693903000
37553	1678	10800326197000
37554	1726	739082153000
37555	1874	202847000
37556	1448	1476572000001
37557	1448	1476592000001
37567	1683	70993072149541
37570	1397	1377663900000
37571	1678	10800326200000
37572	1726	739052150000
37573	1874	202850000
37574	1677	32328261325000
37575	1677	32328281325000
37596	1726	739012146000
37597	1874	202854000
37598	1397	1377623896000
37599	1678	10800326204000
37600	1623	31682050899898
37601	1623	31682070899898
37618	1271	1342686270000000
37619	1271	1342686290000000
37626	1726	738962141000
37627	1874	202859000
37628	1397	1377573891000
37629	1678	10800326209000
37388	1679	19997545707000
37389	1679	19522192496000
37390	1679	18103477902000
37391	887	268788225365154
37392	1679	16912541437000
37393	889	225633308357249
37394	1679	16706955005000
37395	1679	16088998831000
37396	1679	13866759319000
37397	1688	125576097139000
37398	1688	124684871671000
37399	1688	114881500073000
37400	1688	112430600105000
37401	1688	112207781732000
37402	1688	112152074630000
37403	1688	111539397037000
37404	1688	111483679630000
37405	1688	110870888685000
37406	1688	110439750940000
37407	1688	105697339878000
37408	1688	98779231596000
37409	1688	22680206904000
37410	1706	19260033647920
37411	1706	19083545295840
37412	1706	19078187466997
37413	1706	17734690967727
37414	1706	15327164672027
37415	1706	13702755454177
37416	1706	9176212600077
37417	1706	9046796746065
37418	1706	8917380892053
37419	1706	8913449502543
37420	1706	7928216069745
37421	1706	6162694119565
37422	1706	4971458026475
37423	1706	1651990600135
37424	1467	22326433099999
37425	1467	22327583099999
37432	1726	739272172000
37433	1874	202828000
37434	1397	1377893923000
37435	1678	10800326177000
37436	1449	723043000459
37437	1449	723063000459
37444	1726	739252170000
37445	1874	202830000
37446	1397	1377873921000
37447	1678	10800326179000
37532	1397	1377723906000
37533	1678	10800326194000
37534	1726	739112156000
37535	1874	202844000
37536	1451	14400503000000
37537	1451	15120503000000
37543	1726	739102155000
37544	1874	202845000
37545	1397	1377713905000
37546	1678	10800326195000
37547	1402	77763093000000
37568	189	66720100000000
37569	189	66720140000000
37588	1683	73873092149541
37589	1683	73873132149541
37610	1726	738992144000
37611	1874	202856000
37612	1397	1377603894000
37613	1678	10800326206000
37630	1447	5914360944000
37631	1447	5914380944000
37634	1397	1377563890000
37635	1678	10800326210000
37636	1397	1377553889000
37637	1678	10800326211000
37638	1726	738952140000
37639	1874	202860000
37640	1726	738942139000
37641	1874	202861000
37642	1727	3786656000000
37643	1727	3786696000000
37659	1726	738912136000
37660	1874	202864000
37661	1397	1377523886000
37662	1678	10800326214000
37665	1397	1377513885000
37666	1678	10800326215000
37667	1726	738902135000
37668	1874	202865000
37669	1467	23042323100000
37670	1467	23042343100000
37675	1476	1440010000000
37699	1714	5205513103056
37700	1714	5205573103056
37707	1749	2720451000000
37708	1749	2720471000000
37709	1726	738832128000
37710	1874	202872000
37711	1397	1377443878000
37712	1678	10800326222000
37713	1950	4479854000000
37714	2024	832330000000
37715	1710	4654445473290
37716	1710	4654466473290
37725	1726	738812126000
37726	1874	202874000
37727	1688	31320528904000
37728	1688	31320548904000
37744	1681	2662988759830
37745	1681	2663008759830
37747	1726	738782123000
37748	1874	202877000
37749	1397	1377393873000
37750	1678	10800326227000
37751	1560	2753997277001
37752	1560	2754027277001
37753	1726	738772122000
37754	1874	202878000
37755	1726	738762121000
37756	1874	202879000
37757	1726	738752120000
37758	1874	202880000
37759	1637	120963674819997
37760	1397	1377383872000
37761	1678	10800326228000
37762	1397	1377373871000
37763	1678	10800326229000
37764	1397	1377363870000
37765	1678	10800326230000
37766	1740	20874174000000
37767	563	66001526000000
37768	1637	121683674819997
37769	1637	121683705819997
37792	1596	1440040000000
37813	1397	1377323866000
37814	1678	10800326234000
37815	1726	738712116000
37816	1874	202884000
37817	563	75487725000000
37818	1359	1701967437751650
37819	563	71239124000000
37820	1113	905222065000000
37821	1654	19440501000000
37822	1654	19440523000000
37843	1402	79203133000000
37844	1402	79203153000000
37845	1726	738672112000
37846	1874	202888000
37847	1726	738662111000
37848	1874	202889000
37849	1397	1377283862000
37850	1678	10800326238000
37851	1397	1377273861000
37852	1678	10800326239000
37853	1657	20161062000000
37854	1657	20161102000000
37869	1726	738632108000
37870	1874	202892000
37871	1726	738622107000
37872	1874	202893000
37873	1397	1377243858000
37874	1678	10800326242000
37875	1397	1377233857000
37876	1678	10800326243000
37877	1677	34488321325000
37878	1677	34488361325000
37883	1688	31320568904000
37893	1397	1377203854000
37894	1678	10800326246000
37895	1726	738602105000
37896	1874	202895000
37897	1455	753831000000
37898	1455	753851000000
37901	1271	1343406290000000
37902	1271	1343406310000000
37932	1677	34488381325000
37946	1726	738512096000
37947	1874	202904000
37948	1397	1377123846000
37949	1678	10800326254000
37950	1701	2230153600056
37951	1701	2230173600056
37995	1726	738432088000
37996	1874	202912000
37997	1397	1377043838000
37998	1678	10800326262000
37999	1740	3401170000000
37492	1397	1377803914000
37493	1678	10800326186000
37494	1397	1377793913000
37495	1678	10800326187000
37496	1726	739182163000
37497	1874	202837000
37498	1683	68112972149541
37507	1726	739162161000
37508	1874	202839000
37509	1726	739152160000
37510	1874	202840000
37511	1726	739142159000
37512	1874	202841000
37513	1397	1377773911000
37514	1678	10800326189000
37515	1397	1377763910000
37516	1678	10800326190000
37517	1397	1377753909000
37518	1678	10800326191000
37519	1683	69552972149541
37520	1683	69553032149541
37530	1683	70993032149541
37531	1683	70993052149541
37578	1726	739042149000
37579	1874	202851000
37580	1726	739032148000
37581	1874	202852000
37582	1397	1377653899000
37583	1678	10800326201000
37584	1397	1377643898000
37585	1678	10800326202000
37586	1402	78483093000000
37587	1402	78483133000000
37590	1726	739022147000
37591	1874	202853000
37592	1397	1377633897000
37593	1678	10800326203000
37594	1688	29880488904000
37595	1688	29880508904000
37608	1764	2161723100000
37609	1764	2161743100000
37614	1726	738982143000
37615	1874	202857000
37616	1397	1377593893000
37617	1678	10800326207000
37644	1679	15677292711000
37645	1679	15677332711000
37671	1467	22327683099999
37672	1467	23047683099999
37673	1450	23047923099999
37674	1467	10000000
37717	1397	1377433877000
37718	1678	10800326223000
37719	1726	738822127000
37720	1874	202873000
37736	1726	738792124000
37737	1874	202876000
37738	1397	1377413875000
37739	1678	10800326225000
37740	1397	1377403874000
37741	1678	10800326226000
37742	1696	18718957000000
37743	1696	18718987000000
37770	1726	738742119000
37771	1874	202881000
37772	1397	1377353869000
37773	1678	10800326231000
37774	1655	25000000
37775	1457	22320516000000
37776	1457	22320536000000
37793	1706	19980073647920
37794	1706	19803585295840
37795	1706	19798227466997
37796	1706	18454730967727
37797	1706	16047204672027
37798	1706	14422795454177
37799	1706	9896252600077
37800	1706	9766836746065
37801	1706	9637420892053
37802	1706	9633489502543
37803	1706	8648256069745
37804	1706	6882734119565
37805	1706	5691498026475
37806	1706	2372030600135
37807	1740	19434144000000
37808	563	66001527000000
37809	1740	1961142000000
37810	563	83474527000000
37811	1654	19440582000000
37812	1654	19440784000000
37841	1706	3812050600135
37842	1706	3812070600135
37857	1560	3474027277001
37858	1560	3474067277001
37881	1506	18000500000000
37882	1506	18000540000000
37892	1654	20160784000000
37917	1690	72721967000000
37940	1726	738522097000
37941	1874	202903000
37942	1397	1377133847000
37943	1678	10800326253000
37944	1634	21600483899999
37945	1634	21600523899999
37954	1683	79633195149541
37955	1683	79633215149541
37966	1726	738482093000
37967	1874	202907000
37968	1397	1377093843000
37969	1678	10800326257000
37970	1677	35928401325000
37971	1677	35928421325000
37972	1726	738472092000
37973	1874	202908000
37974	1397	1377083842000
37975	1678	10800326258000
37989	1622	12959381999976
38007	1457	22320541000000
38008	1457	22320561000000
38013	1397	1377023836000
38014	1678	10800326264000
38015	1397	1377013835000
38016	1678	10800326265000
38017	1726	738412086000
38018	1874	202914000
38019	1726	738402085000
38020	1874	202915000
38021	563	68372220000000
38022	1233	610771650000000
38023	1683	81073215149541
38024	1683	81073257149541
38025	1397	1377003834000
38026	1678	10800326266000
38027	1397	1376993833000
38028	1678	10800326267000
38029	1397	1376983832000
38030	1678	10800326268000
38031	1683	82513257149541
38032	1683	82513287149541
38051	1508	17280371000000
38052	1508	17280443000000
38115	1690	73441967000000
38116	1690	73441987000000
38119	1726	738242069000
38120	1874	202931000
38121	1397	1376843818000
38122	1678	10800326282000
38145	1690	73442028000000
38152	1686	15332346500013
38158	576	79210244938283
38159	1229	610709990000000
38160	576	75052594938283
38161	1109	905131095000000
38162	1397	1376793813000
38163	1678	10800326287000
38164	1726	738192064000
38165	1874	202936000
38166	2028	8682564860000
38167	1310	1702275295351650
38168	2028	5705929040000
38169	1184	610881384820000
38170	2028	1294268170000
38171	1064	905385124870000
38172	1677	35928464325000
38175	1726	738182063000
38176	1874	202937000
38177	1397	1376783812000
38178	1678	10800326288000
38179	1729	3166736000000
38180	1729	3166756000000
38189	576	75772594938283
38190	576	75772614938283
38203	1683	85393327149541
38223	1726	738102055000
38224	1874	202945000
38225	1397	1376703804000
38226	1678	10800326296000
38227	1677	36648464325000
38228	1677	36648484325000
38274	606	69259646812962
38275	606	69259676812962
38292	1726	735582045000
38293	1874	202955000
38294	1726	735572044000
38295	1874	202956000
37577	1683	72433092149541
37602	1726	739002145000
37603	1874	202855000
37604	1397	1377613895000
37605	1678	10800326205000
37606	1555	15120332000000
37607	1555	15120352000000
37620	1397	1377583892000
37621	1678	10800326208000
37622	1726	738972142000
37623	1874	202858000
37624	1740	20155145000000
37625	1740	20155165000000
37632	1607	5298184644388
37633	1607	5298204644388
37650	1688	30600508904000
37651	1688	30600528904000
37663	1623	32402070899898
37664	1623	32402090899898
37676	1726	738892134000
37677	1874	202866000
37678	1726	738882133000
37679	1874	202867000
37680	1397	1377503884000
37681	1678	10800326216000
37682	1397	1377493883000
37683	1678	10800326217000
37684	1637	121683644819997
37685	1637	121683684819997
37730	1726	738802125000
37731	1874	202875000
37732	1950	3479853000000
37733	2027	999000000000
37734	1683	75313152149541
37735	1683	75313173149541
37746	1696	18718977000000
37778	1397	1377343868000
37779	1678	10800326232000
37780	1726	738732118000
37781	1874	202882000
37782	1740	3401172000000
37783	563	83474526000000
37784	1683	76753173149541
37785	1683	76753195149541
37823	1397	1377313865000
37824	1678	10800326235000
37825	1726	738702115000
37826	1874	202885000
37827	1726	738692114000
37828	1874	202886000
37829	1397	1377303864000
37830	1678	10800326236000
37831	1992	2159040000000
37832	1992	2159080000000
37835	1726	738682113000
37836	1874	202887000
37837	1397	1377293863000
37838	1678	10800326237000
37839	1536	1440040000000
37840	1536	1440060000000
37855	484	88320592000000
37856	484	88320632000000
37879	1637	122403705819997
37880	1637	122403745819997
37887	1397	1377213855000
37888	1678	10800326245000
37889	1726	738612106000
37890	1874	202894000
37891	1599	18720520000000
37899	1654	20160523000000
37900	1654	20160543000000
37915	1739	17279613000000
37916	1739	17279663000000
37933	470	69600141000000
37934	470	69600201000000
37952	1677	35208381325000
37953	1677	35208401325000
37956	1397	1377113845000
37957	1678	10800326255000
37958	1726	738502095000
37959	1874	202905000
37981	1726	738452090000
37982	1874	202910000
37983	1397	1377063840000
37984	1678	10800326260000
37985	563	66000122000000
37986	1740	8640172000000
37987	1637	123123725819997
37988	1637	123123747819997
37990	1397	1377053839000
37991	1678	10800326261000
37992	1726	738442089000
37993	1874	202911000
37994	1594	2784980000000
38003	1397	1377033837000
38004	1678	10800326263000
38005	1726	738422087000
38006	1874	202913000
38057	1397	1376953829000
38058	1678	10800326271000
38059	1726	738342079000
38060	1874	202921000
38061	171	68150260524688
38091	1555	15840352000000
38092	1555	15840433000000
38103	1726	738262071000
38104	1874	202929000
38105	1397	1376863820000
38106	1678	10800326280000
38248	1637	124563817819997
38249	1637	125283817819997
38250	1637	125283827819997
38263	632	84720623000000
38264	632	84720643000000
38273	1622	12959389999976
38276	1397	1376633797000
38277	1678	10800326303000
38278	1726	735622049000
38279	2031	200000000
38280	1726	735612048000
38281	1874	202952000
38282	1726	735602047000
38283	1874	202953000
38284	1726	735592046000
38285	1874	202954000
38286	1397	1376623796000
38287	1678	10800326304000
38288	1397	1376613795000
38289	1678	10800326305000
38290	1690	74882048000000
38291	1690	74882118000000
38333	1690	75602118000000
38334	1690	75602158000000
38347	1726	735482035000
38348	1874	202965000
38349	1726	735472034000
38350	1874	202966000
38351	1397	1376503784000
38352	1678	10800326316000
38353	1397	1376493783000
38354	1678	10800326317000
38355	1678	11520326317000
38356	1678	11520366317000
38376	1422	13371818852698
38377	1422	13371858852698
38378	1397	1376473781000
38379	1678	11520366319000
38380	1726	735442031000
38381	1874	202969000
38382	1726	735432030000
38383	1874	202970000
38384	1397	1376463780000
38385	1678	11520366320000
38386	1668	4286471000000
38387	1668	4286511000000
38388	1726	735422029000
38389	1874	202971000
38390	1559	20398311000000
38391	987	505420615000000
38392	1397	1376453779000
38393	1678	11520366321000
38394	1474	15419858987543
38395	963	504912280012457
38396	1677	38088495325000
38397	1677	38088535325000
38410	1397	1376423776000
38411	1678	11520366324000
38412	1699	4173877050108
38413	1699	4173887050108
38434	1677	38808535325000
38435	1677	38808575325000
38438	576	67235544938283
38439	1355	1701797667751650
38440	1633	2917429985638
38441	1633	3637429985638
38442	1633	3637559985638
38452	1474	1823334000023
38453	1329	1701172304412514
38454	1397	1376373771000
38455	1678	11520366329000
38456	1726	734142022000
38457	1874	202978000
38458	1602	2880240000000
38459	1602	2880270000000
38468	1726	734112019000
37646	1726	738932138000
37647	1874	202862000
37648	1397	1377543888000
37649	1678	10800326212000
37652	1397	1377533887000
37653	1678	10800326213000
37654	1726	738922137000
37655	1874	202863000
37656	1950	5309185000000
37657	2026	75200000000
37658	1656	25920754000000
37686	1726	738872132000
37687	1874	202868000
37688	1726	738862131000
37689	1874	202869000
37690	1726	738852130000
37691	1874	202870000
37692	1397	1377483882000
37693	1678	10800326218000
37694	1397	1377473881000
37695	1678	10800326219000
37696	1397	1377463880000
37697	1678	10800326220000
37698	1683	73873152149541
37701	1397	1377453879000
37702	1678	10800326221000
37703	1726	738842129000
37704	1874	202871000
37705	1677	33048281325000
37706	1677	33048301325000
37721	1397	1377423876000
37722	1678	10800326224000
37723	1740	20875165000000
37724	1740	20875175000000
37729	1740	20875185000000
37777	1549	28800776000000
37786	1726	738722117000
37787	1874	202883000
37788	1397	1377333867000
37789	1678	10800326233000
37790	1677	33768301325000
37791	1677	33768321325000
37833	1683	78193195149541
37834	1683	78193215149541
37859	1397	1377263860000
37860	1678	10800326240000
37861	1397	1377253859000
37862	1678	10800326241000
37863	1726	738652110000
37864	1874	202890000
37865	1726	738642109000
37866	1874	202891000
37867	1715	25920385000000
37868	1715	25920425000000
37884	1397	1377223856000
37885	1678	10800326244000
37886	1691	14399412000000
37903	1726	738592104000
37904	1874	202896000
37905	1397	1377193853000
37906	1678	10800326247000
37907	1397	1377183852000
37908	1678	10800326248000
37909	1726	738582103000
37910	1874	202897000
37911	1726	738572102000
37912	1874	202898000
37913	1471	23040510000000
37914	1471	23040560000000
37918	1397	1377173851000
37919	1678	10800326249000
37920	1397	1377163850000
37921	1678	10800326250000
37922	1397	1377153849000
37923	1678	10800326251000
37924	1726	738562101000
37925	1874	202899000
37926	1726	738552100000
37927	1874	202900000
37928	1726	738542099000
37929	1874	202901000
37930	1599	19440520000000
37931	1599	19440580000000
37935	1397	1377143848000
37936	1678	10800326252000
37937	1726	738532098000
37938	1874	202902000
37939	470	69600221000000
37960	1397	1377103844000
37961	1678	10800326256000
37962	1726	738492094000
37963	1874	202906000
37964	1506	18720540000000
37965	1506	18720560000000
37976	1726	738462091000
37977	1874	202909000
37978	1397	1377073841000
37979	1678	10800326259000
37980	1637	122403725819997
38009	1439	2452162998477
38010	1439	2452182998477
38011	1980	7917990000000
38099	1397	1376873821000
38100	1678	10800326279000
38101	1536	2160060000000
38102	1536	2160070000000
38107	641	68551570000000
38108	641	68551590000000
38123	1746	8639261000000
38124	1746	8639281000000
38125	1726	738232068000
38126	1874	202932000
38127	1397	1376833817000
38128	1678	10800326283000
38129	1637	123843747819997
38130	1637	123843767819997
38181	1726	738172062000
38182	1874	202938000
38183	1397	1376773811000
38184	1678	10800326289000
38185	1472	720000000000
38186	1472	720020000000
38191	1397	1376763810000
38192	1678	10800326290000
38193	1726	738162061000
38194	1874	202939000
38195	1637	124563767819997
38196	1637	124563797819997
38204	1397	1376743808000
38205	1678	10800326292000
38206	1397	1376733807000
38207	1678	10800326293000
38208	1726	738142059000
38209	1874	202941000
38210	1726	738132058000
38211	1874	202942000
38212	1683	85393347149541
38229	43	67440469890000
38230	43	67440489890000
38231	1726	738092054000
38232	1874	202946000
38233	1726	738082053000
38234	1874	202947000
38235	1397	1376693803000
38236	1678	10800326297000
38237	1397	1376683802000
38238	1678	10800326298000
38259	1726	738052050000
38260	1874	202950000
38261	1397	1376653799000
38262	1678	10800326301000
38265	1397	1376643798000
38266	1678	10800326302000
38267	1726	738042049000
38268	1874	202951000
38269	1726	736832049000
38270	2030	200000000
38271	1693	10102981053757
38304	1397	1376573791000
38305	1678	10800326309000
38306	1726	735552042000
38307	1874	202958000
38308	1701	2950173600056
38309	1701	2950193600056
38310	1397	1376563790000
38311	1678	10800326310000
38312	1726	735542041000
38313	1874	202959000
38314	1594	3504960000000
38315	1594	3504980000000
38322	1397	1376543788000
38323	1678	10800326312000
38324	1397	1376533787000
38325	1678	10800326313000
38326	1726	735522039000
38327	1874	202961000
38328	1726	735512038000
38329	1874	202962000
38330	1448	2916664000001
38331	1448	2916704000001
38335	1685	74881309571430
38336	1685	74881349571430
38337	1726	735502037000
38338	1874	202963000
38339	1397	1376523786000
38000	563	71239122000000
38001	606	68539604812962
38002	606	68539646812962
38012	700	67441300000000
38033	1397	1376973831000
38034	1678	10800326269000
38035	1397	1376963830000
38036	1678	10800326270000
38037	1726	738392084000
38038	1874	202916000
38039	1726	738382083000
38040	1874	202917000
38041	1726	738372082000
38042	1874	202918000
38043	1726	738362081000
38044	1874	202919000
38045	1726	738352080000
38046	1874	202920000
38047	563	66001418000000
38048	993	505148575000000
38049	1448	2196592000001
38050	1448	2196664000001
38053	613	20880645000000
38054	1509	66000000500000
38055	1508	66000000030000
38056	435	17280440490000
38062	1397	1376943828000
38063	1678	10800326272000
38064	1726	738332078000
38065	1874	202922000
38066	1726	738322077000
38067	1874	202923000
38068	1397	1376933827000
38069	1678	10800326273000
38070	1673	23086541000000
38071	1673	23086581000000
38072	1726	738312076000
38073	1874	202924000
38074	1726	738302075000
38075	1874	202925000
38076	1726	738292074000
38077	1874	202926000
38078	1726	738282073000
38079	1874	202927000
38080	1397	1376923826000
38081	1678	10800326274000
38082	1397	1376913825000
38083	1678	10800326275000
38084	1397	1376903824000
38085	1678	10800326276000
38086	1397	1376893823000
38087	1678	10800326277000
38088	43	66720469890000
38089	2028	19439100000000
38090	1508	17280452000000
38093	1397	1376883822000
38094	1678	10800326278000
38095	1726	738272072000
38096	1874	202928000
38097	1683	83953287149541
38098	1683	83953307149541
38109	1397	1376853819000
38110	1678	10800326281000
38111	1726	738252070000
38112	1874	202930000
38113	1547	3453183000000
38114	1547	3453203000000
38117	1688	32040548904000
38118	1688	32040568904000
38131	576	82015504938283
38132	989	505097925000000
38133	1397	1376823816000
38134	1678	10800326284000
38135	1726	738222067000
38136	1874	202933000
38137	1726	738212066000
38138	1874	202934000
38139	1397	1376813815000
38140	1678	10800326285000
38141	2028	16977223460000
38142	944	505239650540000
38143	1518	5040291000000
38144	1518	5040352000000
38146	1726	738202065000
38147	1874	202935000
38148	1397	1376803814000
38149	1678	10800326286000
38150	1593	22320826000000
38151	1593	22320846000000
38153	1593	21601066000000
38154	1678	10080286173000
38155	1593	22321066000000
38156	1761	22322085999998
38157	1593	10000004
38173	1683	85393307149541
38174	1683	85393390149541
38187	2029	719000000000
38188	2029	719010000000
38197	1726	738152060000
38198	1874	202940000
38199	1397	1376753809000
38200	1678	10800326291000
38201	1458	25200476908540
38202	1458	25200496908540
38213	1397	1376723806000
38214	1678	10800326294000
38215	1397	1376713805000
38216	1678	10800326295000
38217	1726	738122057000
38218	1874	202943000
38219	1726	738112056000
38220	1874	202944000
38221	1683	86833347149541
38222	1683	86833387149541
38239	1397	1376673801000
38240	1678	10800326299000
38241	1726	738072052000
38242	1874	202948000
38243	42	84718190000000
38244	1449	8053000459
38245	1939	2150990000000
38246	42	85438190000000
38247	42	85438200000000
38251	1726	738062051000
38252	1874	202949000
38253	1397	1376663800000
38254	1678	10800326300000
38255	1690	74162028000000
38256	1690	74162048000000
38257	1419	4781007280064
38258	1419	4781027280064
38272	1657	20161092000000
38332	1543	720040000000
38341	1726	735492036000
38342	1874	202964000
38343	1397	1376513785000
38344	1678	10800326315000
38345	1571	15840281001000
38346	1571	15840301001000
38366	1474	17555384000000
38367	1541	1036000000
38368	1397	1376483782000
38369	1678	11520366318000
38370	1474	17554374000000
38371	1541	2036000000
38372	1726	735452032000
38373	1874	202968000
38374	1680	2169179500035
38375	1680	2169219500035
38422	1622	13679389999976
38423	1622	13679419999976
38425	1397	1376403774000
38426	1678	11520366326000
38427	1397	1376393773000
38428	1678	11520366327000
38429	1726	735382025000
38430	1874	202975000
38431	1726	735372024000
38432	1874	202976000
38433	1602	2160240000000
38460	1726	734132021000
38461	1874	202979000
38462	1397	1376363770000
38463	1678	11520366330000
38464	1397	1376353769000
38465	1678	11520366331000
38466	1726	734122020000
38467	1874	202980000
38500	1683	89713417149541
38501	1683	89713477149541
38513	1564	2706173000000
38514	1564	2706313000000
38720	1546	20880530000000
38721	1546	20880551000000
38723	1726	733932001000
38724	1874	202999000
38725	1397	1376163750000
38726	1678	11520366350000
38727	484	89040632000000
38728	484	89040652000000
38731	1685	75601349571430
38732	1685	75601359571430
38296	1726	735562043000
38297	1874	202957000
38298	1397	1376603794000
38299	1678	10800326306000
38300	1397	1376593793000
38301	1678	10800326307000
38302	1397	1376583792000
38303	1678	10800326308000
38316	1726	735532040000
38317	1874	202960000
38318	1397	1376553789000
38319	1678	10800326311000
38320	1740	4121170000000
38321	1740	4121190000000
38357	1683	88273387149541
38358	1683	88273427149541
38398	1474	11594834293650
38399	1083	904798479693893
38400	1726	735412028000
38401	1874	202972000
38402	1726	735402027000
38403	1874	202973000
38404	1397	1376443778000
38405	1678	11520366322000
38406	1397	1376433777000
38407	1678	11520366323000
38408	1602	2160250000000
38436	1610	2160061000000
38437	1610	2160101000000
38474	1726	734102018000
38475	1874	202982000
38476	1397	1376333767000
38477	1678	11520366333000
38478	1397	1376323766000
38479	1678	11520366334000
38480	1726	734092017000
38481	1874	202983000
38482	1718	15015630889008
38483	1474	1824334000023
38484	1559	21118311000000
38485	1559	21118352000000
38502	1894	105000000
38503	1726	734052013000
38504	1874	202987000
38505	1726	734042012000
38506	1874	202988000
38507	1397	1376283762000
38508	1678	11520366338000
38509	1397	1376273761000
38510	1678	11520366339000
38511	1672	2880774000000
38512	1672	2880914000000
38521	1397	1376253759000
38522	1678	11520366341000
38523	1726	734022010000
38524	1874	202990000
38525	1397	1376243758000
38526	1678	11520366342000
38527	1559	17922902000000
38528	1227	611100190000000
38529	1726	734012009000
38530	1874	202991000
38531	576	75772644938283
38573	1726	733982006000
38574	1874	202994000
38575	1726	733972005000
38576	1874	202995000
38577	1397	1376213755000
38578	1678	11520366345000
38579	1397	1376203754000
38580	1678	11520366346000
38581	1693	10102991053757
38755	589	66335074938283
38756	1726	733891997000
38757	1874	203003000
38758	1397	1376123746000
38759	1678	11520366354000
38760	1402	80643183000000
38761	1402	80643213000000
38340	1678	10800326314000
38359	1692	36020440019999
38360	1726	735462033000
38361	1874	202967000
38362	2031	199000000
38363	95	66000000000000
38364	1677	37368484325000
38365	1677	37368495325000
38409	1457	22320591000000
38414	1474	9014010660887
38415	1203	610485563632763
38416	1397	1376413775000
38417	1678	11520366325000
38418	1726	735392026000
38419	1874	202974000
38420	1402	79923153000000
38421	1402	79923183000000
38424	1683	88273417149541
38443	1726	735362023000
38444	1874	202977000
38445	1726	734152023000
38446	2032	200000000
38447	1397	1376383772000
38448	1678	11520366328000
38449	1718	15016631889008
38450	1474	9015010660887
38451	1690	75602149000000
38486	1726	734082016000
38487	1874	202984000
38488	1726	734072015000
38489	1874	202985000
38490	1726	734062014000
38491	1874	202986000
38492	1397	1376313765000
38493	1678	11520366335000
38494	1397	1376303764000
38495	1678	11520366336000
38496	1397	1376293763000
38497	1678	11520366337000
38498	1679	16397332711000
38499	1679	16397392711000
38515	1397	1376263760000
38516	1678	11520366340000
38517	1726	734032011000
38518	1874	202989000
38519	1850	4238680000000
38520	1850	4238700000000
38532	1397	1376233757000
38533	1678	11520366343000
38534	1397	1376223756000
38535	1678	11520366344000
38536	1726	734002008000
38537	1874	202992000
38538	1726	733992007000
38539	1874	202993000
38540	606	69259686812962
38588	1397	1376183752000
38589	1678	11520366348000
38590	1726	733952003000
38591	1874	202997000
38592	1559	13186952000000
38593	1107	905709405000000
38594	1649	16560781999992
38595	1649	16560811999992
38713	1726	733942002000
38714	1874	202998000
38715	1397	1376173751000
38716	1678	11520366349000
38717	1718	13283148946880
38718	932	504510255942128
38719	1727	3786677000000
38722	1727	3786676000000
38762	1677	38808565325000
38469	1874	202981000
38470	1397	1376343768000
38471	1678	11520366332000
38472	1555	15120372000000
38473	1555	15840372000000
38541	1474	1822334000023
38542	1559	17202861000000
38543	1678	10800326318000
38544	1678	10800326319000
38545	1678	10800326320000
38546	1678	10800326321000
38547	1678	10800326322000
38548	1678	10800326323000
38549	1678	10800326324000
38550	1678	10800326325000
38551	1678	10800326326000
38552	1678	10800326327000
38553	1678	10800326328000
38554	1678	10800326329000
38555	1678	10800326330000
38556	1678	10800326331000
38557	1678	10800326332000
38558	1678	10800326333000
38559	1678	10800326334000
38560	1678	10800326335000
38561	1678	10800326336000
38562	1678	10800326337000
38563	1678	10800326338000
38564	1678	10800326339000
38565	1678	10800326340000
38566	1678	10800326341000
38567	1678	10800326342000
38568	1678	10800326343000
38569	1678	10800326344000
38570	1633	3638769985638
38571	1633	4358769985638
38572	1633	4358899985638
38582	1397	1376193753000
38583	1678	11520366347000
38584	1726	733962004000
38585	1874	202996000
38586	1683	91153477149541
38587	1683	91153497149541
38596	1593	22320856000000
38597	1678	10080286174000
38598	1678	10080286175000
38599	1678	10080286176000
38600	1678	10080286177000
38601	1678	10080286178000
38602	1678	10080286179000
38603	1678	10080286180000
38604	1678	10080286181000
38605	1678	10080286182000
38606	1678	10080286183000
38607	1678	10080286184000
38608	1593	22322435999998
38609	1678	10080286185000
38610	1678	10080286186000
38611	1678	10080286187000
38612	1678	10080286188000
38613	1678	10080286189000
38614	1678	10080286190000
38615	1678	10080286191000
38616	1678	10080286192000
38617	1678	10080286193000
38618	1678	10080286194000
38619	1678	10080286195000
38620	1678	10080286196000
38621	1678	10080286197000
38622	1678	10080286198000
38623	1678	10080286199000
38624	1678	10080286200000
38625	1678	10080286201000
38626	1678	10080286202000
38627	1678	10080286203000
38628	1559	12466911000000
38629	1678	10080286204000
38630	1678	10080286205000
38631	1678	10080286206000
38632	1678	10080286207000
38633	1678	10080286208000
38634	1678	10080286209000
38635	1678	10080286210000
38636	1678	10080286211000
38637	1678	10080286212000
38638	1678	10080286213000
38639	1678	10080286214000
38640	1678	10080286215000
38641	1678	10080286216000
38642	1678	10080286217000
38643	1678	10080286218000
38644	1678	10080286219000
38645	1678	10080286220000
38646	1678	10080286221000
38647	1678	10080286222000
38648	1678	10080286223000
38649	1678	10080286224000
38650	1678	10080286225000
38651	1678	10080286226000
38652	1678	10080286227000
38653	1678	10080286228000
38654	1678	10080286229000
38655	1678	10080286230000
38656	1678	10080286231000
38657	1678	10080286232000
38658	1678	10080286233000
38659	1678	10080286234000
38660	1678	10080286235000
38661	1678	10080286236000
38662	1678	10080286237000
38663	1678	10080286238000
38664	1678	10080286239000
38665	1678	10080286240000
38666	1678	10080286241000
38667	1678	10080286242000
38668	1678	10080286243000
38669	1678	10080286244000
38670	1678	10080286245000
38671	1678	10080286246000
38672	1678	10080286247000
38673	1678	10080286248000
38674	1678	10080286249000
38675	1678	10080286250000
38676	1678	10080286251000
38677	1678	10080286252000
38678	1678	10080286253000
38679	1678	10080286254000
38680	1678	10080286255000
38681	1678	10080286256000
38682	1678	10080286257000
38683	1678	10080286258000
38684	1678	10080286259000
38685	1678	10080286260000
38686	1678	10080286261000
38687	1678	10080286262000
38688	1678	10080286263000
38689	1678	10080286264000
38690	1678	10080286265000
38691	1678	10080286266000
38692	1678	10080286267000
38693	1678	10080286268000
38694	1678	10080286269000
38695	1678	10080286270000
38696	1678	10080286271000
38697	1678	10080286272000
38698	1678	10080286273000
38699	1678	10080286274000
38700	1678	10080286275000
38701	1678	10080286276000
38702	1678	10080286277000
38703	1678	10080286278000
38704	1678	10080286279000
38705	1678	10080286280000
38706	1678	10080286281000
38707	1678	10080286282000
38708	1678	10080286283000
38709	1678	10080286284000
38710	1678	10080286285000
38711	1593	23042435999998
38712	1593	23043455999998
38729	1489	21600711000000
38730	1489	21600731000000
38733	1397	1376153749000
38734	1678	11520366351000
38735	1397	1376143748000
38736	1678	11520366352000
38737	1726	733922000000
38738	1874	203000000
38739	1726	733911999000
38740	1874	203001000
38741	1726	733901998000
38742	1874	203002000
38743	1397	1376133747000
38744	1678	11520366353000
38745	1559	4282582000000
38746	1353	1702884997751650
38747	1718	10178556942475
38748	1052	904078056004405
38749	1718	8083826528460
38750	1172	609999479414015
38751	1718	2246675763340
38752	1298	1699817787516770
38753	1439	3172182998477
38754	1439	3172255998477
38763	1397	1376113745000
38764	1678	11520366355000
38765	1726	733881996000
38766	1874	203004000
38767	1668	5006511000000
38768	1668	5006531000000
38769	1622	13679409999976
38770	1555	16560372000000
38771	1555	16560392000000
38772	1726	733871995000
38773	1874	203005000
38774	1397	1376103744000
38775	1678	11520366356000
38776	1397	1376093743000
38777	1678	11520366357000
38778	1596	1440050000000
38779	1726	732661995000
38780	2034	200000000
38781	1726	731451995000
38782	2035	200000000
38783	1726	731441994000
38784	1874	203006000
38785	1596	2160080000000
38786	1692	36020430019999
38787	1397	1376083742000
38788	1678	11520366358000
38789	1726	730231994000
38790	2036	200000000
38791	1726	730221993000
38792	1874	203007000
38793	1687	8005214726450
38794	1687	8005244726450
38795	1397	1376073741000
38796	1678	11520366359000
38797	1726	730211992000
38798	1874	203008000
38799	1726	730201991000
38800	1874	203009000
38801	1397	1376063740000
38802	1678	11520366360000
38803	1458	25920496908540
38804	1458	25920536908540
38805	1397	1376053739000
38806	1678	11520366361000
38807	1596	2880080000000
38808	1596	2880090000000
38809	1726	730191990000
38810	1874	203010000
38811	1397	1376043738000
38812	1678	11520366362000
38813	1683	92593497149541
38814	1683	92593537149541
38815	1397	1376033737000
38816	1678	11520366363000
38817	1397	1376023736000
38818	1678	11520366364000
38819	1726	730181989000
38820	1874	203011000
38821	1506	17999530000000
38822	2037	0
38823	1726	730171988000
38824	1874	203012000
38825	1726	728961988000
38826	2038	200000000
38827	1850	4958700000000
38828	1850	4958760000000
38829	1726	728951987000
38830	1874	203013000
38831	1726	728941986000
38832	1874	203014000
38833	1397	1376013735000
38834	1678	11520366365000
38835	1397	1376003734000
38836	1678	11520366366000
38837	1850	5678760000000
38838	1850	5678800000000
38839	1677	39528565325000
38840	1506	17137520000000
38841	2037	862000000000
38842	1506	17137509999713
38843	598	66000000000287
38844	1506	17137499997525
38845	1007	502777775002188
38846	1506	17137489994880
38847	1247	607904750002645
38848	1506	17137479990959
38849	1127	900973465003921
38850	1726	728931985000
38851	1874	203015000
38852	1726	728921984000
38853	1874	203016000
38854	1726	728911983000
38855	1874	203017000
38856	1397	1375993733000
38857	1678	11520366367000
38858	1397	1375983732000
38859	1678	11520366368000
38860	1675	3021819999977
38861	1675	3021919999977
38862	1675	3021909999977
38863	1692	36020490019999
38864	1397	1375973731000
38865	1678	11520366369000
38866	1506	17137469983586
38867	1373	1693980637759023
38868	1402	80643203000000
38869	1683	92593517149541
38870	1445	4357189000000
38871	2039	1000000000
38872	1726	728901982000
38873	1874	203018000
38874	1397	1375963730000
38875	1678	11520366370000
38876	1506	17137459983299
38877	598	66000000000574
38878	1397	1375953729000
38879	1678	11520366371000
38880	1726	728891981000
38881	1874	203019000
38882	1726	728881980000
38883	1874	203020000
38884	1402	80643343000000
38885	1506	17137449981111
38886	1007	502777775004376
38887	1506	17137439978466
38888	1247	607904750005290
38889	1506	17137429974545
38890	1127	900973465007842
38891	1506	17137419967172
38892	1373	1693980637766396
38893	1457	23040591000000
38894	1457	23040631000000
38895	1726	728871979000
38896	1874	203021000
38897	1397	1375943728000
38898	1678	11520366372000
38899	1684	5011244880623
38900	1701	3670193600056
38901	1701	3670253600056
38902	1506	16850136967172
38903	598	66287273000574
38904	1506	14661728967172
38905	1007	504966173004376
38906	1726	728861978000
38907	1874	203022000
38908	1397	1375933727000
38909	1678	11520366373000
38910	2039	980000000
38911	480	66001020000000
38912	1711	2684455000000
38913	1397	1375923726000
38914	1678	11520366374000
38915	1726	728851977000
38916	1874	203023000
38917	1677	40248565325000
38918	1677	40248585325000
38919	1506	12015743967172
38920	1247	610550725005290
38921	1506	8094144967172
38922	1127	904895054007842
38923	1397	1375913725000
38924	1678	11520366375000
38925	1726	728841976000
38926	1874	203024000
38927	1506	720891967172
38928	1373	1701353880766396
38929	1402	81363343000000
38930	1402	81363393000000
38931	1603	720050000000
38932	1397	1375903724000
38933	1678	11520366376000
38934	1397	1375893723000
38935	1678	11520366377000
38936	1726	728831975000
38937	1874	203025000
38938	1726	728821974000
38939	1874	203026000
38940	2038	199000000
38941	2038	109000000
38942	1623	33122090899898
38943	1623	33122221899898
38944	1726	728811973000
38945	1874	203027000
38946	1397	1375883722000
38947	1678	11520366378000
38948	1673	23806581000000
38949	1673	23806601000000
39049	1708	15839672000000
39050	1708	15839692000000
39051	1726	728731965000
39052	1874	203035000
39053	1397	1375803714000
39054	1678	11520366386000
39055	1397	1375793713000
39056	1678	11520366387000
39057	1726	728721964000
39058	1874	203036000
39059	1649	16560821999992
39063	1756	4067795575609
39064	1397	1375783712000
39065	1678	11520366388000
39066	1726	728711963000
39067	1874	203037000
39068	1677	41688625325000
39069	1677	41688645325000
39080	1681	3383008759830
39081	1681	3383038759830
39094	1670	2161131000000
39095	1724	2829261000000
39115	1613	17278730000000
39118	1397	1375713705000
39119	1678	11520366395000
39120	1726	728641956000
39121	1874	203044000
39122	484	89760682000000
39123	484	89760702000000
39132	1397	1375703704000
39133	1678	11520366396000
39134	1726	728631955000
39135	1874	203045000
39136	439	66000050000000
39137	439	66720050000000
39156	1726	728601952000
39157	1874	203048000
39158	1445	1002169000000
39159	1726	728591951000
39160	1874	203049000
39161	1397	1375673701000
39162	1678	11520366399000
39163	1397	1375663700000
39164	1678	11520366400000
39165	1451	15120483000000
39166	1451	15120533000000
39174	1397	1375643698000
39175	1678	11520366402000
39176	1397	1375633697000
39177	1678	11520366403000
39178	1397	1375623696000
39179	1678	11520366404000
39180	1723	19521957085979
39181	1000	505559659823781
39182	1726	728571949000
39183	1874	203051000
39184	1726	728561948000
39185	1874	203052000
39186	1726	728551947000
39187	1874	203053000
39188	1980	7918060000000
39242	1656	15782634000000
39243	1343	1704118637751650
39244	1755	2156950000000
39245	406	66002000000000
39246	1723	1798927085979
39247	1366	1703353637751650
39248	1397	1375533687000
39249	1678	11520366413000
39250	1726	728471939000
39251	1874	203061000
39252	1726	728461938000
39253	1874	203062000
39254	1397	1375523686000
39255	1678	11520366414000
39256	1690	76322149000000
39257	1690	76322419000000
39258	1397	1375513685000
39259	1678	11520366415000
39260	1397	1375503684000
39261	1678	11520366416000
39262	1726	728451937000
39263	1874	203063000
39264	1726	728441936000
39265	1874	203064000
39268	1656	10389514000000
39269	1097	906366465000000
39270	1656	6750394000000
39271	1217	611543750000000
39272	1656	3741274000000
39273	977	505786775000000
39274	1726	728431935000
39275	1874	203065000
39276	1397	1375493683000
39277	1678	11520366417000
39278	149	69869637000341
39279	149	69870017000341
39300	1702	720151000000
39301	1702	720171000000
39309	1608	10828470000000
39310	1289	1700432637751650
39311	1608	7396460000000
39312	1043	904405465000000
39313	1608	5080450000000
39314	1163	610220750000000
39315	1726	728381930000
39316	1874	203070000
39317	1608	3165440000000
39318	923	504692775000000
39319	1397	1375443678000
39320	1678	11520366422000
39321	1677	42408645325000
39322	1677	42408725325000
39333	1726	728361928000
39334	1874	203072000
39335	1654	12989640600000
39336	1340	1700431510151650
39337	1726	728351927000
39338	1874	203073000
39339	1726	728341926000
39340	1874	203074000
39341	1397	1375423676000
39342	1678	11520366424000
39343	1397	1375413675000
39344	1678	11520366425000
39345	1397	1375403674000
39346	1678	11520366426000
39347	1513	15840440000000
39348	1513	15840520000000
39355	1476	2160050000000
39380	1726	728301922000
39381	1874	203078000
39382	1397	1375373671000
39383	1678	11520366429000
39384	2014	1440514999998
39385	1509	20880713000000
39391	1509	1440525999999
39392	1759	20880651000000
39396	1397	1375363670000
39397	1678	11520366430000
39398	1726	728291921000
39399	1874	203079000
39409	1726	728271919000
39410	1874	203081000
39411	1397	1375343668000
39412	1678	11520366432000
39413	1440	2879020000000
39414	1440	2879040000000
39453	1571	16560301001000
39454	1571	16560491001000
39460	1458	23002236908540
39461	957	505695775000000
39462	1726	728201912000
39463	1874	203088000
39464	1726	728191911000
39465	1874	203089000
39466	1397	1375273661000
39467	1678	11520366439000
39468	1397	1375263660000
39469	1678	11520366440000
39470	2041	719000000000
39471	2041	719340000000
39489	2015	333700000000
39490	1534	0
39491	1726	728161908000
39492	1874	203092000
39493	1397	1375233657000
39494	1678	11520366443000
39495	1687	8725244726450
39496	1687	8725364726450
39521	633	68043829900000
39522	633	68043849900000
39525	1397	1375193653000
39526	1678	11520366447000
39527	1726	728121904000
39528	1874	203096000
39529	1602	2880260000000
39532	58	69546244999659
39533	58	69546264999659
39576	1677	43128655325000
39577	1677	43128676325000
39586	1723	3238937085979
39587	1723	3238957085979
39594	1726	728031895000
38950	1458	26640536908540
38951	1458	26640556908540
39035	1726	728751967000
39036	1874	203033000
39037	1397	1375823716000
39038	1678	11520366384000
39039	1683	94033517149541
39040	1683	94033537149541
39061	1575	720000000000
39062	1575	720040000000
39072	1723	22303861909760
39073	723	3016599090000
39074	1397	1375773711000
39075	1678	11520366389000
39076	1726	728701962000
39077	1874	203038000
39078	1445	5077189000000
39079	1445	5077219000000
39104	1397	1375733707000
39105	1678	11520366393000
39106	1440	24479840000000
39107	2040	0
39108	1726	728661958000
39109	1874	203042000
39110	1726	728651957000
39111	1874	203043000
39112	1397	1375723706000
39113	1678	11520366394000
39114	484	89040682000000
39116	1683	95473537149541
39117	1683	95473587149541
39139	1440	11852480000000
39140	1131	906129095000000
39141	1397	1375693703000
39142	1678	11520366397000
39143	1726	728621954000
39144	1874	203046000
39145	1445	2917179000000
39146	2039	1440980000000
39147	1700	4625840276737
39153	1440	2159020000000
39154	1377	1703674087751650
39155	1683	95473567149541
39167	1397	1375653699000
39168	1678	11520366401000
39169	1726	728581950000
39170	1874	203050000
39171	1564	2706193000000
39172	1685	76321409571430
39173	1685	76321869571430
39191	1683	96913567149541
39192	1683	96913637149541
39196	1726	728541946000
39197	1874	203054000
39198	1397	1375603694000
39199	1678	11520366406000
39200	1637	125283797819997
39201	1723	16157947085979
39202	1240	611268750000000
39203	1726	728531945000
39204	1874	203055000
39205	1726	728521944000
39206	1874	203056000
39207	1397	1375593693000
39208	1678	11520366407000
39209	1397	1375583692000
39210	1678	11520366408000
39211	1683	98353577149541
39212	1683	98353627149541
39280	406	66001900000000
39281	1546	21600551000000
39282	1546	21600651000000
39302	1685	76322109571430
39303	1397	1375453679000
39304	1678	11520366421000
39305	1726	728391931000
39306	1874	203069000
39307	1685	77042109571430
39308	1685	77042959571430
39331	1683	104113787149541
39332	1683	104113807149541
39351	1726	728331925000
39352	1874	203075000
39353	1991	1915083441475
39354	1991	1915103441475
39371	1559	5002582000000
39372	1559	5002592000000
39373	1726	728311923000
39374	1874	203077000
39375	1654	5327853000000
39376	974	504692496200000
39377	1422	8662651198464
39378	1091	904962631654234
39379	1683	104113828149541
39386	606	69979686812962
39387	606	69979757812962
39393	1703	1440570000000
39394	1703	1440580000000
39418	1726	728261918000
39419	1874	203082000
39420	1397	1375333667000
39421	1678	11520366433000
39422	1451	15840533000000
39423	1451	15840553000000
39432	1637	126003817819997
39433	1637	126003837819997
39452	1677	42408705325000
39459	1677	42408655325000
39513	1679	16397982711000
39523	1683	106993838149541
39524	1683	106993858149541
39530	1689	1440050287614
39531	1689	1440070287614
39547	1726	728091901000
39548	1874	203099000
39549	1397	1375153649000
39550	1678	11520366451000
39551	1698	1976783550035
39552	1698	1976803550035
39553	1458	4413336908540
39554	1323	1703811637751650
39555	1397	1375143648000
39556	1678	11520366452000
39557	1726	728081900000
39558	1874	203100000
39559	1688	32760888904000
39574	1705	3918870500145
39575	1705	3918891500145
39578	1397	1375113645000
39579	1678	11520366455000
39580	1726	728051897000
39581	1874	203103000
39582	1509	21600651000000
39583	1509	21600671000000
39620	1726	727981890000
39621	1874	203110000
39622	1726	727971889000
39623	1874	203111000
39624	1397	1375043638000
39625	1678	11520366462000
39626	1397	1375033637000
39627	1678	11520366463000
39628	1567	713000000101
39629	1762	3208700000000
39630	1762	3208740000000
39652	1726	727931885000
39653	1874	203115000
39654	1397	1374993633000
39655	1678	11520366467000
39656	1471	23040530000000
39662	1677	43848676325000
39663	1677	43848686325000
39664	1637	127443857819997
39665	1637	127443867819997
39720	1726	727851877000
39721	1874	203123000
39722	1397	1374913625000
39723	1678	11520366475000
39731	1683	109874438149541
39732	1683	109874478149541
39741	1726	727821874000
39742	1874	203126000
39743	633	68763849900000
39744	633	68763859900000
39745	1726	727811873000
39746	1874	203127000
39747	411	66008410000000
39748	2042	830490000000
39749	439	66000040000000
39750	2042	1550490000000
39751	1397	1374883622000
39752	1678	11520366478000
39753	1397	1374873621000
39754	1678	11520366479000
39755	1397	1374863620000
39756	1678	11520366480000
39757	1397	1374853619000
39758	1678	11520366481000
39759	1726	727801872000
39760	1874	203128000
39761	1726	727791871000
39762	1874	203129000
39763	1726	727781870000
39764	1874	203130000
39765	1711	3404455000000
38952	1397	1375873721000
38953	1678	11520366379000
38954	1397	1375863720000
38955	1678	11520366380000
38956	1726	728801972000
38957	1874	203028000
38958	1726	728791971000
38959	1874	203029000
38960	1677	40968585325000
38961	1677	40968625325000
38962	1397	1375853719000
38963	1678	11520366381000
38964	1397	1375843718000
38965	1678	11520366382000
38966	1726	728781970000
38967	1874	203030000
38968	1397	1375833717000
38969	1678	11520366383000
38970	1726	728771969000
38971	1874	203031000
38972	1726	728761968000
38973	1874	203032000
38974	1685	75601409571430
39041	1397	1375813715000
39042	1678	11520366385000
39043	1726	728741966000
39044	1874	203034000
39045	1693	10822991053757
39046	1693	10823011053757
39060	369	89040712000000
39096	1726	728671959000
39097	1874	203041000
39098	1397	1375743708000
39099	1678	11520366392000
39100	1594	4224980000000
39101	1594	4225000000000
39103	1714	5205533103056
39138	439	66720040000000
39148	1726	728611953000
39149	1874	203047000
39150	1397	1375683702000
39151	1678	11520366398000
39152	1649	16560801999992
39193	1397	1375613695000
39194	1678	11520366405000
39195	1683	96913577149541
39213	1397	1375573691000
39214	1678	11520366409000
39215	1726	728511943000
39216	1874	203057000
39217	1700	5345840276737
39218	1700	5345860276737
39266	1683	99793627149541
39267	1683	99793667149541
39288	1726	728411933000
39289	1874	203067000
39290	1397	1375473681000
39291	1678	11520366419000
39292	1683	101233667149541
39293	1683	101233707149541
39323	1683	102673707149541
39324	1683	102673787149541
39329	1397	1375433677000
39330	1678	11520366423000
39349	1397	1375393673000
39350	1678	11520366427000
39400	1683	105553828149541
39401	1683	105553868149541
39415	1522	3213950000000
39416	1522	3213970000000
39426	1623	33842221899898
39427	1623	33842241899898
39434	1397	1375313665000
39435	1678	11520366435000
39436	1723	2518927085979
39437	1723	2518937085979
39438	1726	728241916000
39439	1874	203084000
39440	1726	728231915000
39441	1874	203085000
39442	1726	728221914000
39443	1874	203086000
39444	1397	1375303664000
39445	1678	11520366436000
39446	1397	1375293663000
39447	1678	11520366437000
39448	1397	1375283662000
39449	1678	11520366438000
39450	1506	1440891967172
39451	1506	1440951967172
39455	1726	728211913000
39456	1874	203087000
39457	1536	2880070000000
39458	1536	2880080000000
39472	632	85440643000000
39473	632	85440983000000
39477	1726	728181910000
39478	1874	203090000
39479	1726	728171909000
39480	1874	203091000
39481	1397	1375243658000
39482	1678	11520366442000
39483	1422	5971079967091
39484	1211	610596320231373
39485	1705	3198839500145
39486	1705	3198870500145
39497	1458	19473936908540
39498	1197	611432750000000
39499	1458	14244636908540
39500	1077	906202465000000
39501	1397	1375223656000
39502	1678	11520366444000
39503	1397	1375213655000
39504	1678	11520366445000
39505	1726	728151907000
39506	1874	203093000
39507	1726	728141906000
39508	1874	203094000
39509	700	66000290000000
39510	1980	9359060000000
39511	1693	11543011053757
39512	1693	11543661053757
39514	1714	5206163103056
39534	1397	1375183652000
39535	1678	11520366448000
39536	1419	4781017280064
39544	1397	1375163650000
39545	1678	11520366450000
39546	470	69600181000000
39566	1397	1375123646000
39567	1678	11520366454000
39568	1726	728061898000
39569	1874	203102000
39570	2041	719339000000
39571	1437	0
39572	1673	25966631000000
39573	1673	25966652000000
39608	1726	728001892000
39609	1874	203108000
39610	1726	727991891000
39611	1874	203109000
39612	1397	1375063640000
39613	1678	11520366460000
39614	1397	1375053639000
39615	1678	11520366461000
39616	1449	2879080990000
39617	1992	8053010459
39618	1509	21600710000000
39635	1762	3921740000000
39646	1397	1375003634000
39647	1678	11520366466000
39648	1726	727941886000
39649	1874	203114000
39650	1688	33480888904000
39651	1688	33480908904000
39657	1637	126723837819997
39658	1637	126723857819997
39668	1397	1374983632000
39669	1678	11520366468000
39670	1726	727911883000
39671	1874	203117000
39672	1683	106993868149541
39692	58	70266264999659
39693	58	70266414999659
39696	1397	1374943628000
39697	1678	11520366472000
39698	149	70590017000341
39699	149	70590027000341
39729	1637	128163867819997
39730	1637	128163887819997
39733	1397	1374893623000
39734	1678	11520366477000
39735	2042	490000000
39736	411	66838420000000
39737	1726	727831875000
39738	1874	203125000
39739	1649	17280821999992
39740	1649	17280851999992
39769	1723	3239037085979
39775	1726	727761868000
39776	1874	203132000
39777	1397	1374833617000
39778	1678	11520366483000
39808	43	68160489890000
39809	43	68160499890000
38975	1506	17279490000000
38976	1506	16417480000000
38977	1506	16417469999713
38978	1506	16417459997525
38979	1506	16417449994880
38980	1506	16417439990959
38981	1506	16417429983586
38982	1506	16417419983299
38983	1506	16417409981111
38984	1506	16417399978466
38985	1506	16417389974545
38986	1506	16417379967172
38987	1506	16130096967172
38988	1506	13941688967172
38989	1506	11295703967172
38990	1506	7374104967172
38991	1506	851967172
38992	1678	10800326345000
38993	1678	10800326346000
38994	1678	10800326347000
38995	1678	10800326348000
38996	1678	10800326349000
38997	1678	10800326350000
38998	1678	10800326351000
38999	1678	10800326352000
39000	1678	10800326353000
39001	1678	10800326354000
39002	1678	10800326355000
39003	1678	10800326356000
39004	1678	10800326357000
39005	1678	10800326358000
39006	1678	10800326359000
39007	1678	10800326360000
39008	1678	10800326361000
39009	1678	10800326362000
39010	1678	10800326363000
39011	1678	10800326364000
39012	1678	10800326365000
39013	1678	10800326366000
39014	1678	10800326367000
39015	1678	10800326368000
39016	1678	10800326369000
39017	1678	10800326370000
39018	1678	10800326371000
39019	1678	10800326372000
39020	1678	10800326373000
39021	1678	10800326374000
39022	1678	10800326375000
39023	1678	10800326376000
39024	1678	10800326377000
39025	1678	10800326378000
39026	1678	10800326379000
39027	1678	10800326380000
39028	1678	10800326381000
39029	1678	10800326382000
39030	1678	10800326383000
39031	1559	3562541000000
39032	1633	4360109985638
39033	1633	5080109985638
39034	1633	5080139985638
39047	1710	5374466473290
39048	1710	5374486473290
39070	576	76492644938283
39071	576	76492664938283
39082	1723	22303851906979
39083	1000	502777775002781
39084	1397	1375763710000
39085	1678	11520366390000
39086	1397	1375753709000
39087	1678	11520366391000
39088	1726	728691961000
39089	1874	203039000
39090	1726	728681960000
39091	1874	203040000
39092	1670	2160650000000
39093	1670	2160700000000
39102	1724	2829281000000
39124	1440	23363790000000
39125	2040	1116040000000
39126	1440	20486740000000
39127	1011	505654815000000
39128	1440	17008120000000
39129	1251	611383360000000
39130	439	66720000000000
39131	439	66720060000000
39189	1638	720000000000
39190	1638	720070000000
39219	633	77159889900000
39220	1384	1702260637751650
39221	633	72755869900000
39222	1138	905377465000000
39223	633	69781849900000
39224	1258	610878750000000
39225	633	67323829900000
39226	1018	505235775000000
39227	1397	1375563690000
39228	1678	11520366410000
39229	1726	728501942000
39230	1874	203058000
39231	1397	1375553689000
39232	1678	11520366411000
39233	1726	728491941000
39234	1874	203059000
39235	1397	1375543688000
39236	1678	11520366412000
39237	1723	11171937085979
39238	1120	905959465000000
39239	1726	728481940000
39240	1874	203060000
39241	1657	20161212000000
39283	1726	728421934000
39284	1874	203066000
39285	1397	1375483682000
39286	1678	11520366418000
39287	1546	21600671000000
39294	1397	1375463680000
39295	1678	11520366420000
39296	1726	728401932000
39297	1874	203068000
39298	1992	2879080000000
39299	1992	2879100000000
39325	1726	728371929000
39326	1874	203071000
39327	1673	24526601000000
39328	1673	24526611000000
39356	1397	1375383672000
39357	1678	11520366428000
39358	1654	9558071000000
39359	1094	904405024600000
39360	1559	4282602000000
39361	1654	7242584200000
39362	1214	610220226800000
39363	1726	728321924000
39364	1874	203076000
39365	1559	5002602000000
39366	1964	5002621999999
39367	1559	200000001
39368	1690	76322439000000
39369	1690	77042439000000
39370	1690	77042459000000
39388	1702	1440171000000
39389	1702	20880644000000
39390	1509	1440190000000
39395	606	69979706812962
39402	1555	16560412000000
39403	1397	1375353669000
39404	1678	11520366431000
39405	1726	728281920000
39406	1874	203080000
39407	1673	25246611000000
39408	1673	25246631000000
39417	470	69600161000000
39424	1549	29520776000000
39425	1549	29520796000000
39428	1726	728251917000
39429	1874	203083000
39430	1397	1375323666000
39431	1678	11520366434000
39474	1397	1375253659000
39475	1678	11520366441000
39476	1683	105553838149541
39487	1685	77762959571430
39488	1685	77763741571430
39515	1726	728131905000
39516	1874	203095000
39517	1397	1375203654000
39518	1678	11520366446000
39519	1688	32760568904000
39520	1688	32760588904000
39537	1397	1375173651000
39538	1678	11520366449000
39539	1726	728111903000
39540	1874	203097000
39541	1726	728101902000
39542	1874	203098000
39543	470	69600171000000
39560	1726	728071899000
39561	1874	203101000
39562	1397	1375133647000
39563	1678	11520366453000
39564	1474	2544334000023
39565	1474	2544354000023
39584	1594	4945000000000
39585	1594	4945020000000
39588	1397	1375103644000
39589	1678	11520366456000
39590	1726	728041896000
39591	1874	203104000
39592	1650	3634041000000
39593	1650	3634061000000
39619	1992	2879120000000
39636	1726	727961888000
39637	1874	203112000
39638	1726	727951887000
39639	1874	203113000
39640	1397	1375023636000
39641	1678	11520366464000
39642	1397	1375013635000
39643	1678	11520366465000
39644	1508	18000452000000
39645	1508	18000492000000
39673	1397	1374973631000
39674	1678	11520366469000
39675	1726	727901882000
39676	1874	203118000
39677	1677	43848716325000
39694	1458	5133336908540
39695	1458	5133486908540
39700	1509	18956312312008
39701	954	505422011687992
39702	1509	15759086021455
39703	1194	611101876290553
39704	1509	11020536532383
39705	1074	905711914489072
39706	1509	2111359851155
39707	1320	1702889714432878
39708	1726	727871879000
39709	1874	203121000
39710	1397	1374933627000
39711	1678	11520366473000
39712	1536	2880490000000
39713	1683	106994418149541
39724	1726	727841876000
39725	1874	203124000
39726	1397	1374903624000
39727	1678	11520366476000
39728	1684	5011204880623
39767	1506	2160951967172
39768	1506	2161051967172
39779	1397	1374823616000
39780	1678	11520366484000
39781	1726	727751867000
39782	1874	203133000
39783	1513	16560520000000
39784	1513	16560540000000
39810	1678	12240366486000
39811	1678	12240386486000
39813	1397	1374793613000
39814	1678	12240386487000
39815	1726	727721864000
39816	1874	203136000
39819	1397	1374783612000
39820	1678	12240386488000
39821	1726	727711863000
39822	1874	203137000
39823	1992	3599080990000
39824	1992	3599100990000
39831	238	66720170000000
39832	238	66720190000000
39874	576	76492684938283
39875	576	8053017459
39876	1449	76492684937283
39913	1726	727571849000
39914	1874	203151000
39915	1397	1374643598000
39916	1678	12240386502000
39934	1677	43848696325000
39940	1726	727531845000
39941	1874	203155000
39942	1397	1374603594000
39943	1678	12240386506000
39966	1397	1374593593000
39967	1678	12240386507000
39968	1726	727521844000
39969	1874	203156000
39970	1683	108433878149541
39971	1683	108433898149541
39988	1726	727491841000
39989	1874	203159000
39990	1546	16361621000000
39991	1213	610771750000000
39992	1546	12112611000000
39993	1093	905222465000000
39994	1397	1374563590000
39995	1678	12240386510000
39996	1690	79202489000000
39997	1690	79202529000000
40012	1726	727461838000
40013	1874	203162000
40014	1726	727451837000
40015	1874	203163000
40016	1397	1374533587000
40017	1678	12240386513000
40018	1397	1374523586000
40019	1678	12240386514000
40020	1688	34920928904000
40021	1688	34920968904000
40055	1688	35640968904000
40056	1688	35640988904000
40089	1546	20879541000000
40090	1546	18508531000000
40091	1546	15641521000000
40092	1546	11392511000000
40093	1546	3404501000000
40094	1546	2160491000000
40095	1685	78486621570430
40096	1678	11520366506000
40097	1678	11520366507000
40098	1678	11520366508000
40099	1678	11520366509000
40100	1678	11520366510000
40101	1678	11520366511000
40102	1678	11520366512000
40103	1678	11520366513000
40104	1678	11520366514000
40105	1678	11520366515000
40106	1685	79206621570430
40107	1685	79206911570430
40127	1402	81363413000000
40128	1402	82083413000000
40129	1402	82083423000000
40170	42	86158200000000
40171	42	86158240000000
40185	1397	1374333567000
40186	1678	12240386533000
40187	1726	724831817000
40188	1874	203183000
40190	1726	724821816000
40191	1874	203184000
40192	1397	1374323566000
40193	1678	12240386534000
40194	1402	82083403000000
40209	1714	5926873103056
40210	1678	11520366516000
40211	1678	11520366517000
40212	1678	11520366518000
40213	1678	11520366519000
40214	1678	11520366520000
40215	1678	11520366521000
40216	1714	6646873103056
40217	1714	6647473103056
40222	1397	1374283562000
40223	1678	12240386538000
40224	1726	724781812000
40225	1874	203188000
40252	1623	34562261899898
40253	1623	34562281899898
40256	1397	1374223556000
40257	1678	12240386544000
40258	1397	1374213555000
40259	1678	12240386545000
40260	1726	724721806000
40261	1874	203194000
40262	1688	35640998904000
40274	1677	44568696325000
40275	1677	44568736325000
40285	1546	3600591000000
40343	1726	724561790000
40344	1874	203210000
40345	1397	1374063540000
40346	1678	12240386560000
40347	1610	2160081000000
40348	1688	36360998904000
40359	1479	720000000000
40360	1479	720040000000
40363	1756	3351105575609
40364	1756	4071105575609
40365	1756	4071275575609
40374	1759	2160525999999
40375	1759	2160565999999
40386	1560	4194067277001
40387	1560	4194107277001
40395	1762	4641720994000
40423	1397	1373943528000
40424	1678	12240386572000
40425	1726	724431777000
40426	1874	203223000
40456	1871	1438910000000
40457	1871	1438940000000
40471	1746	10079442000000
39595	1874	203105000
39596	1726	728021894000
39597	1874	203106000
39598	1397	1375093643000
39599	1678	11520366457000
39600	1397	1375083642000
39601	1678	11520366458000
39602	1397	1375073641000
39603	1678	11520366459000
39604	1726	728011893000
39605	1874	203107000
39606	1714	5926163103056
39607	1714	5926223103056
39631	1762	3921700000000
39632	1449	3921700994000
39633	1762	8053016459
39634	1509	21600749000000
39659	1726	727921884000
39660	1874	203116000
39661	1693	11543021053757
39666	1690	77042419000000
39667	1690	77042429000000
39678	1706	3812090600135
39679	1509	21600649000000
39680	1397	1374963630000
39681	1678	11520366470000
39682	1726	727891881000
39683	1874	203119000
39684	1726	727881880000
39685	1874	203120000
39686	1397	1374953629000
39687	1678	11520366471000
39688	411	66837920000000
39689	2042	1000000000
39690	1688	34200908904000
39691	1688	34201058904000
39714	1726	727861878000
39715	1874	203122000
39716	1397	1374923626000
39717	1678	11520366474000
39718	1683	108434418149541
39719	1683	108434438149541
39770	1397	1374843618000
39771	1678	11520366482000
39772	1726	727771869000
39773	1874	203131000
39774	1705	3918890500145
39785	1397	1374813615000
39786	1678	11520366485000
39787	1726	727741866000
39788	1874	203134000
39789	1440	3599040000000
39790	1440	3599060000000
39803	1397	1374803614000
39804	1678	11520366486000
39805	1726	727731865000
39806	1874	203135000
39807	1688	34200928904000
39812	43	68160509890000
39825	1672	3600914000000
39826	1672	3600934000000
39839	1397	1374763610000
39840	1678	12240386490000
39841	1726	727691861000
39842	1874	203139000
39843	1451	16560553000000
39844	1451	16560573000000
39896	1397	1374673601000
39897	1678	12240386499000
39898	1726	727601852000
39899	1874	203148000
39900	1726	727591851000
39901	1874	203149000
39902	1397	1374663600000
39903	1678	12240386500000
39904	1683	106993878149541
39905	1397	1374653599000
39906	1678	12240386501000
39907	1726	727581850000
39908	1874	203150000
39909	1444	4174955160000
39910	1444	4174975160000
39917	1729	3886756000000
39918	1729	3886776000000
39982	1690	78482459000000
39983	1690	78482489000000
40003	1397	1374543588000
40004	1678	12240386512000
40005	1546	4124601000000
40006	1339	1701968637751650
40007	1726	727471839000
40008	1874	203161000
40009	1683	108433908149541
40032	1397	1374503584000
40033	1678	12240386516000
40034	1726	727421834000
40035	1874	203166000
40036	1690	79922529000000
40037	1690	79922549000000
40057	1679	16397352711000
40086	1657	20881302000000
40119	1692	36740470019999
40130	1549	28800786000000
40131	1549	29520786000000
40148	1397	1374393573000
40149	1678	12240386527000
40150	1726	724891823000
40151	1874	203177000
40152	1726	724881822000
40153	1874	203178000
40154	1397	1374383572000
40155	1678	12240386528000
40156	1623	33842261899898
40172	1397	1374353569000
40173	1678	12240386531000
40174	1726	724851819000
40175	1874	203181000
40176	1506	2160971967172
40195	42	86878240000000
40196	42	86878260000000
40199	1397	1374313565000
40200	1678	12240386535000
40201	1726	724811815000
40202	1874	203185000
40203	1726	724801814000
40204	1874	203186000
40205	1397	1374303564000
40206	1678	12240386536000
40207	1762	4641740994000
40263	1726	724711805000
40264	1874	203195000
40265	1726	724701804000
40266	1874	203196000
40267	1397	1374203554000
40268	1678	12240386546000
40269	1397	1374193553000
40270	1678	12240386547000
40271	1683	111313978149541
40276	1402	82803423000000
40277	1402	82803463000000
40278	1726	724691803000
40279	1874	203197000
40280	1397	1374183552000
40281	1678	12240386548000
40282	1677	44568716325000
40302	1397	1374143548000
40303	1678	12240386552000
40304	1726	724651799000
40305	1874	203201000
40306	1980	10079060000000
40307	1980	10079080000000
40312	1397	1374123546000
40313	1678	12240386554000
40314	1726	724631797000
40315	1874	203203000
40316	1726	724621796000
40317	1874	203204000
40318	1693	11543041053757
40319	1726	724611795000
40320	1874	203205000
40321	1397	1374113545000
40322	1678	12240386555000
40323	1402	82803443000000
40324	1397	1374103544000
40325	1678	12240386556000
40326	1397	1374093543000
40327	1678	12240386557000
40328	1397	1374083542000
40329	1678	12240386558000
40330	1726	724601794000
40331	1874	203206000
40332	1726	724591793000
40333	1874	203207000
40334	1726	724581792000
40335	1874	203208000
40336	1455	1473911000000
40349	1726	724551789000
40350	1874	203211000
40351	1726	724541788000
40352	1874	203212000
40353	1397	1374053539000
40354	1678	12240386561000
40355	1397	1374043538000
40356	1678	12240386562000
40357	1451	18000583000000
39766	1711	3404555000000
39791	1509	20880543000000
39792	1509	18236206312008
39793	1509	15038980021455
39794	1509	10300430532383
39795	1509	1391253851155
39796	411	66007910000000
39797	2042	831000000000
39798	1685	77765371571430
39799	1980	8638990000000
39800	1685	78485371571430
39801	1685	1000
39802	1485	78486131570430
39829	1522	3933970000000
39830	1522	3933990000000
39833	1726	727701862000
39834	1874	203138000
39835	1397	1374773611000
39836	1678	12240386489000
39855	1726	727661858000
39856	1874	203142000
39857	1726	727651857000
39858	1874	203143000
39859	1397	1374733607000
39860	1678	12240386493000
39861	1397	1374723606000
39862	1678	12240386494000
39863	1447	6634380944000
39864	1447	6634420944000
39895	1402	81363403000000
39911	1717	17999773000000
39912	1717	17999793000000
39929	1726	727551847000
39930	1874	203153000
39931	1397	1374623596000
39932	1678	12240386504000
39933	633	68763869900000
39935	1397	1374613595000
39936	1678	12240386505000
39937	1726	727541846000
39938	1874	203154000
39939	1687	9445384726450
39974	1546	19228631000000
39975	973	505148775000000
39976	1726	727511843000
39977	1874	203157000
39978	1397	1374583592000
39979	1678	12240386508000
39980	1455	1473851000000
39981	1455	1473881000000
39984	1397	1374573591000
39985	1678	12240386509000
39986	1726	727501842000
39987	1874	203158000
40028	1726	727431835000
40029	1874	203165000
40030	1451	17280573000000
40031	1451	17280583000000
40046	1637	128883887819997
40047	1637	128883917819997
40054	1711	3404475000000
40060	1726	727391831000
40061	1874	203169000
40062	1397	1374473581000
40063	1678	12240386519000
40076	1726	727381830000
40077	1874	203170000
40078	1397	1374463580000
40079	1678	12240386520000
40080	1397	1374453579000
40081	1678	12240386521000
40082	1726	727371829000
40083	1874	203171000
40084	1602	3600260000000
40085	1602	3600350000000
40108	1397	1374443578000
40109	1678	12240386522000
40110	1397	1374433577000
40111	1678	12240386523000
40112	1726	727361828000
40113	1874	203172000
40114	1726	727351827000
40115	1874	203173000
40116	1726	726141827000
40117	2043	200000000
40118	1684	5011234880623
40120	1726	726131826000
40121	1874	203174000
40122	1698	1976813550035
40123	1397	1374423576000
40124	1678	12240386524000
40125	1698	2696813550035
40126	1698	2696823550035
40146	1716	3646577000000
40147	1716	3646627000000
40159	1740	4841190000000
40160	1740	4841230000000
40177	1726	724841818000
40178	1874	203182000
40179	1397	1374343568000
40180	1678	12240386532000
40181	1474	3264354000023
40182	1474	3264374000023
40208	1637	128883927819997
40226	1746	10079301000000
40227	1746	10079321000000
40242	1426	17280750000000
40243	1426	17280810000000
40248	1726	724731807000
40249	1874	203193000
40250	1397	1374233557000
40251	1678	12240386543000
40283	1596	3600090000000
40284	1596	3600110000000
40296	1726	724661800000
40297	1874	203200000
40298	1397	1374153549000
40299	1678	12240386551000
40300	1458	5853486908540
40301	1458	5853506908540
40337	1726	724571791000
40338	1874	203209000
40339	1397	1374073541000
40340	1678	12240386559000
40341	1629	1440010000000
40342	1629	1440030000000
40376	1397	1374013535000
40377	1678	12240386565000
40378	1397	1374003534000
40379	1678	12240386566000
40380	1726	724511785000
40381	1874	203215000
40382	1726	724501784000
40383	1874	203216000
40384	1693	12263041053757
40385	1693	12263081053757
40390	1726	724491783000
40391	1874	203217000
40392	1397	1373993533000
40393	1678	12240386567000
40394	1683	111313958149541
40403	1643	4176395113700
40442	1683	112753958149541
40443	1683	112753978149541
40448	1726	724381772000
40449	1874	203228000
40450	1726	723171772000
40451	2045	200000000
40452	1397	1373893523000
40453	1678	12240386577000
40454	1694	4332314127629
40455	1694	4332344127629
40470	1704	5039336000000
40482	1726	723121767000
40483	1874	203233000
40484	1397	1373843518000
40485	1678	12240386582000
40486	1688	37801018904000
40487	1688	37801038904000
40502	1726	723091764000
40503	1874	203236000
40504	1726	723081763000
40505	1874	203237000
40506	1726	723071762000
40507	1874	203238000
40508	1726	723061761000
40509	1874	203239000
40510	1726	723051760000
40511	1874	203240000
40512	1397	1373813515000
40513	1678	12240386585000
40514	1397	1373803514000
40515	1678	12240386586000
40516	1397	1373793513000
40517	1678	12240386587000
40518	1397	1373783512000
40519	1678	12240386588000
40520	1397	1373773511000
40521	1678	12240386589000
40522	1719	740140000000
40523	1719	740240000000
40561	1397	1373693503000
40562	1678	12240386597000
40563	1726	722981753000
40564	1874	203247000
39817	470	70320181000000
39818	470	70320201000000
39827	1656	4461274000000
39828	1656	4461294000000
39837	1746	9359281000000
39838	1746	9359301000000
39845	1726	727681860000
39846	1874	203140000
39847	1726	727671859000
39848	1874	203141000
39849	1397	1374753609000
39850	1678	12240386491000
39851	1397	1374743608000
39852	1678	12240386492000
39853	1509	2831359851155
39854	1509	2831399851155
39865	1678	11520366487000
39866	1678	11520366488000
39867	1678	11520366489000
39868	1678	11520366490000
39869	1678	11520366491000
39870	1678	11520366492000
39871	1678	11520366493000
39872	1678	11520366494000
39873	1447	6634800944000
39877	1726	727641856000
39878	1874	203144000
39879	1397	1374713605000
39880	1678	12240386495000
39881	1726	727631855000
39882	1874	203145000
39883	1726	727621854000
39884	1874	203146000
39885	1726	727611853000
39886	1874	203147000
39887	1397	1374703604000
39888	1678	12240386496000
39889	1397	1374693603000
39890	1678	12240386497000
39891	1397	1374683602000
39892	1678	12240386498000
39893	1687	9445364726450
39894	1687	9445424726450
39919	1675	3741919999977
39920	1675	3741939999977
39921	1546	21599641000000
39922	257	66001000000000
39923	1726	727561848000
39924	1874	203152000
39925	1397	1374633597000
39926	1678	12240386503000
39927	1690	77762429000000
39928	1690	77762459000000
39944	1509	20880551000000
39945	1509	18236214312008
39946	1509	15038988021455
39947	1509	10300438532383
39948	1509	1391261851155
39949	2042	719000000000
39950	2042	721000000000
39951	2042	1551000000000
39952	1695	1773301000000
39953	1678	11520366495000
39954	1678	11520366496000
39955	1678	11520366497000
39956	1678	11520366498000
39957	1678	11520366499000
39958	1678	11520366500000
39959	1678	11520366501000
39960	1678	11520366502000
39961	1678	11520366503000
39962	1678	11520366504000
39963	1678	11520366505000
39964	1695	2493301000000
39965	1695	2494081000000
39972	1508	18720492000000
39973	1508	18720512000000
39998	1397	1374553589000
39999	1678	12240386511000
40000	1726	727481840000
40001	1874	203160000
40002	1599	19440540000000
40010	1762	4641700994000
40011	1762	4641730994000
40022	1726	727441836000
40023	1874	203164000
40024	1397	1374513585000
40025	1678	12240386515000
40026	1536	3600490000000
40027	1536	3600510000000
40038	1726	727411833000
40039	1874	203167000
40040	1397	1374493583000
40041	1678	12240386517000
40042	1546	2880591000000
40043	257	67245000000000
40044	1683	109873908149541
40045	1683	109873938149541
40048	1726	727401832000
40049	1874	203168000
40050	1397	1374483582000
40051	1678	12240386518000
40052	1622	14399409999976
40053	1622	14399429999976
40058	1650	4354061000000
40059	1650	4354081000000
40064	1691	14171602645814
40065	192	66227799354186
40066	1691	12439161712302
40067	918	504510205933512
40068	1691	9334650322910
40069	1038	904077966389392
40070	1691	7239971373927
40071	1158	609999418948983
40072	1691	1402980100019
40073	1284	1699817619025558
40074	1657	20881212000000
40075	1657	20881312000000
40087	1692	36740420019999
40088	1692	36740510019999
40132	1679	15677342711000
40133	1679	16397342711000
40134	1397	1374413575000
40135	1678	12240386525000
40136	1726	724921826000
40137	2044	200000000
40138	1726	724911825000
40139	1874	203175000
40140	1397	1374403574000
40141	1678	12240386526000
40142	1726	724901824000
40143	1874	203176000
40144	1588	20160590000000
40145	1588	20160640000000
40157	1690	80642549000000
40158	1690	80642589000000
40161	1397	1374373571000
40162	1678	12240386529000
40163	1397	1374363570000
40164	1678	12240386530000
40165	1726	724871821000
40166	1874	203179000
40167	1726	724861820000
40168	1874	203180000
40169	1599	19440560000000
40183	1522	4653990000000
40184	1522	4654010000000
40189	55	66720780000000
40197	1419	5501017280064
40198	1419	5501037280064
40218	1397	1374293563000
40219	1678	12240386537000
40220	1726	724791813000
40221	1874	203187000
40228	1726	724771811000
40229	1874	203189000
40230	1726	724761810000
40231	1874	203190000
40232	1397	1374273561000
40233	1678	12240386539000
40234	1397	1374263560000
40235	1678	12240386540000
40236	1397	1374253559000
40237	1678	12240386541000
40238	1726	724751809000
40239	1874	203191000
40240	1683	111313938149541
40241	1683	111313998149541
40244	1397	1374243558000
40245	1678	12240386542000
40246	1726	724741808000
40247	1874	203192000
40254	1706	4532090600135
40255	1706	4532110600135
40272	1680	2889219500035
40273	1680	2889259500035
40286	1397	1374173551000
40287	1678	12240386549000
40288	1726	724681802000
40289	1874	203198000
40290	1726	724671801000
40291	1874	203199000
40292	1397	1374163550000
40293	1678	12240386550000
40294	1536	4320510000000
40295	1536	4320550000000
40308	1397	1374133547000
40309	1678	12240386553000
40310	1726	724641798000
40311	1874	203202000
40366	1726	724531787000
40367	1874	203213000
40368	1726	724521786000
40369	1874	203214000
40370	1397	1374033537000
40371	1678	12240386563000
40372	1397	1374023536000
40373	1678	12240386564000
40388	171	68870260524688
40389	171	68870300524688
40404	1726	724461780000
40405	1874	203220000
40406	1397	1373973531000
40407	1678	12240386569000
40408	1637	129603927819997
40409	1637	129603947819997
40410	1397	1373963530000
40411	1678	12240386570000
40412	1726	724451779000
40413	1874	203221000
40416	1573	23760830000000
40427	1726	724421776000
40428	1874	203224000
40429	1397	1373933527000
40430	1678	12240386573000
40431	1397	1373923526000
40432	1678	12240386574000
40433	1726	724411775000
40434	1874	203225000
40435	1992	3599120990000
40472	1701	3670334600056
40473	1397	1373863520000
40474	1678	12240386580000
40475	1726	723141769000
40476	1874	203231000
40477	1726	723131768000
40478	1874	203232000
40479	1397	1373853519000
40480	1678	12240386581000
40481	632	85440683000000
40539	1726	723021757000
40540	1874	203243000
40541	1397	1373733507000
40542	1678	12240386593000
40543	1397	1373723506000
40544	1678	12240386594000
40545	1726	723011756000
40546	1874	203244000
40547	1698	3416823550035
40548	1698	3416863550035
40560	497	66720020000000
40567	1397	1373683502000
40568	1678	12240386598000
40569	1726	722971752000
40570	1874	203248000
40582	1726	722941749000
40583	1874	203251000
40584	1397	1373653499000
40585	1678	12240386601000
40586	1677	46008746325000
40587	1677	46008766325000
40604	1677	46728766325000
40605	1677	46728807325000
40622	1397	1373593493000
40623	1678	12240386607000
40624	1397	1373583492000
40625	1678	12240386608000
40626	1397	1373573491000
40627	1678	12240386609000
40628	1726	722906741000
40629	1874	203259000
40630	1726	722905740000
40631	1874	203260000
40632	1726	722904739000
40633	1874	203261000
40634	1683	114193978149541
40635	1683	114194011149541
40647	1703	1440581000000
40649	1397	1373553489000
40650	1678	12240386611000
40651	1397	1373543488000
40652	1678	12240386612000
40653	1726	722902737000
40654	1874	203263000
40655	1637	131044067819997
40656	1637	131044088819997
40670	1397	1373503484000
40671	1678	12240386616000
40672	1726	722898733000
40673	1874	203267000
40674	632	86160683000000
40675	632	86160694000000
40698	1693	12192547629428
40699	122	66414824089930
40700	1693	12190400555969
40701	721	2012570426909
40702	1397	1373453479000
40703	1678	12240386621000
40704	1693	12119867131640
40705	217	66414824089930
40706	1726	722893728000
40707	1874	203272000
40708	1447	7354420944000
40709	1447	7354461944000
40760	1397	1373413475000
40761	1678	12240386625000
40762	1693	9330172032593
40763	108	66414824089930
40764	1693	9002310475863
40765	894	308751364127976
40766	1693	8931777051534
40767	569	66414824089930
40768	1693	8861243627205
40769	252	66414824089930
40770	1693	8790710202876
40771	225	66414824089930
40772	1693	8720176778547
40773	377	66414824089930
40774	1726	722889724000
40775	1874	203276000
40776	1688	39241061904000
40777	1688	39241132904000
40796	1677	48168870325000
40848	1564	4146234000000
40849	1564	4146447000000
40981	1693	2866470872005
40982	194	66414824089930
40983	1693	1056546701015
40984	1276	1704627191698650
40985	1693	986013276686
40986	206	66414824089930
40987	1693	915479852357
40988	304	66414824089930
40989	1693	844946428028
40990	399	66414824089930
40991	1693	774413003699
40992	653	66414824089930
40993	1397	1373293463000
40994	1678	12240386637000
40995	1726	722876711000
40996	1874	203289000
40997	1693	1494413003699
40998	1693	1494484003699
41008	1513	17280551000000
41014	1397	1373273461000
41015	1678	12240386639000
41016	1613	11840477800000
41017	1349	1698698829951650
41018	1397	1373263460000
41019	1678	12240386640000
41020	1613	7122275600000
41021	1223	612622942200000
41022	1613	4244978100000
41023	1103	903850752500000
41024	1613	1367680600000
41025	983	505655062500000
41026	1726	722873708000
41027	1874	203292000
41028	1726	722872707000
41029	1874	203293000
41030	1677	48168932325000
41037	606	69979697812962
41047	1693	1423880579370
41048	622	66417804089930
41049	1560	3474077277001
41050	1693	1353347155041
41051	105	66414824089930
41052	1397	1373243458000
41053	1678	12240386642000
41054	1726	722870705000
41055	1874	203295000
41056	1560	4194077277001
41057	1560	4194098277001
41062	1681	3383048759830
41063	1681	4103048759830
41064	1681	4103069759830
41088	1397	1373203454000
41089	1678	12240386646000
41090	1726	722866701000
41091	1874	203299000
40358	1451	18000623000000
40361	1692	37460470019999
40362	1692	37460510019999
40396	1726	724481782000
40397	1874	203218000
40398	1726	724471781000
40399	1874	203219000
40400	1397	1373983532000
40401	1678	12240386568000
40402	1547	3453213000000
40414	1699	4893887050108
40415	1699	4893907050108
40417	1397	1373953529000
40418	1678	12240386571000
40419	1726	724441778000
40420	1874	203222000
40421	1402	83523443000000
40422	1402	83523463000000
40436	1397	1373913525000
40437	1678	12240386575000
40438	1726	724401774000
40439	1874	203226000
40440	1688	37080998904000
40441	1688	37081018904000
40444	1726	724391773000
40445	1874	203227000
40446	1397	1373903524000
40447	1678	12240386576000
40458	1937	0
40459	2046	300000000
40460	1397	1373883522000
40461	1678	12240386578000
40462	1397	1373873521000
40463	1678	12240386579000
40464	1726	723161771000
40465	1874	203229000
40466	1726	723151770000
40467	1874	203230000
40468	2045	199000000
40469	1747	8735808000000
40495	1937	100000000
40496	1397	1373823516000
40497	1678	12240386584000
40498	1726	723101765000
40499	1874	203235000
40500	1683	112754078149541
40531	1594	5665020000000
40532	1594	5665050000000
40549	1726	723001755000
40550	1874	203245000
40551	1397	1373713505000
40552	1678	12240386595000
40553	1690	80642569000000
40571	1726	722961751000
40572	1874	203249000
40573	1726	722951750000
40574	1874	203250000
40575	1397	1373673501000
40576	1678	12240386599000
40577	1397	1373663500000
40578	1678	12240386600000
40579	1588	20160630000000
40606	1397	1373613495000
40607	1678	12240386605000
40608	1397	1373603494000
40609	1678	12240386606000
40610	1726	722909744000
40611	1874	203256000
40612	1726	722908743000
40613	1874	203257000
40614	1726	722907742000
40615	1874	203258000
40616	1688	38521038904000
40617	1688	38521061904000
40619	1429	720023000000
40636	1513	17280540000000
40637	1513	17280573000000
40639	1397	1373563490000
40640	1678	12240386610000
40641	1726	722903738000
40642	1874	203262000
40643	1536	5040550000000
40644	1536	5040561000000
40657	1397	1373533487000
40658	1678	12240386613000
40659	1397	1373523486000
40660	1678	12240386614000
40661	1397	1373513485000
40662	1678	12240386615000
40663	1726	722901736000
40664	1874	203264000
40665	1726	722900735000
40666	1874	203265000
40667	1726	722899734000
40668	1874	203266000
40669	1677	46728799325000
40676	1397	1373493483000
40677	1678	12240386617000
40678	1397	1373483482000
40679	1678	12240386618000
40680	1726	722897732000
40681	1874	203268000
40682	1726	722896731000
40683	1874	203269000
40684	1727	3786678000000
40778	1397	1373403474000
40779	1678	12240386626000
40780	1693	8649643354218
40781	82	66414824089930
40782	1693	8579109929889
40783	361	66414824089930
40784	1693	8508576505560
40785	560	66414824089930
40786	1693	8438043081231
40787	309	66414824089930
40788	1693	8367509656902
40789	1962	413736265157
40790	1693	8296976232573
40791	201	66414824089930
40792	1726	722888723000
40793	1874	203277000
40794	1677	47448799325000
40795	1677	47448870325000
40850	1693	7025227521192
40851	191	66414824089930
40852	1693	6954694096863
40853	266	66414824089930
40854	1693	6884160672534
40855	534	66414824089930
40856	1693	6813627248205
40857	245	66414824089930
40858	1693	6743093823876
40859	421	66414824089930
40860	1693	6672560399547
40861	600	66414824089930
40862	1726	722884719000
40863	1874	203281000
40864	1683	117074191149541
40865	1683	117074252149541
40867	1397	1373363470000
40868	1678	12240386630000
40869	1397	1373353469000
40870	1678	12240386631000
40871	1693	6602026975218
40872	620	66414824089930
40873	1693	6531493550889
40874	2017	413423424329
40875	1693	6460960126560
40876	551	66414824089930
40877	1693	6390426702231
40878	520	66414824089930
40879	1693	6319893277902
40880	84	66414824089930
40881	1693	5670374424539
40882	1150	611725390313900
40883	1726	722883718000
40884	1874	203282000
40885	1726	722882717000
40886	1874	203283000
40887	470	71040201000000
40888	470	71040283000000
41009	1717	18719793000000
41010	1717	18719804000000
41058	1604	720000616000
41059	1420	800000
41060	2000	4194097180988
41061	1560	200000014
41080	1397	1373213455000
41081	1678	12240386645000
41082	1726	722867702000
41083	1874	203298000
41084	1992	5039140990000
41085	1992	5039151990000
41099	1555	16560383000000
41119	1397	1373143448000
41120	1678	12240386652000
41121	1726	722860695000
41122	1874	203305000
41123	1688	40681143904000
41124	1688	40681154904000
41129	1474	3264365000023
41130	1397	1373133447000
41131	1678	12240386653000
41132	1467	23762343100000
41133	1467	23762353100000
40488	2046	0
40489	1726	723111766000
40490	1874	203234000
40491	1397	1373833517000
40492	1678	12240386583000
40493	1637	130323947819997
40494	1637	130324067819997
40501	1729	3886876000000
40524	1397	1373763510000
40525	1678	12240386590000
40526	1397	1373753509000
40527	1678	12240386591000
40528	1726	723041759000
40529	1874	203241000
40530	1677	44568726325000
40533	1726	723031758000
40534	1874	203242000
40535	1397	1373743508000
40536	1678	12240386592000
40537	1992	4319120990000
40538	1992	4319140990000
40554	1726	722991754000
40555	1874	203246000
40556	1397	1373703504000
40557	1678	12240386596000
40558	1687	10165384726450
40559	1687	10165404726450
40592	1397	1373633497000
40593	1678	12240386603000
40594	1726	722921747000
40595	1874	203253000
40596	1726	722911746000
40597	1874	203254000
40598	1397	1373623496000
40599	1678	12240386604000
40600	1726	722910745000
40601	1874	203255000
40602	1564	3426193000000
40603	1564	3426234000000
40620	1419	6221037280064
40621	1419	6221060280064
40695	1455	2193911000000
40696	1455	2193933000000
40712	1693	12049333707311
40713	103	66414824089930
40714	1397	1373443478000
40715	1678	12240386622000
40716	1693	11856364138609
40717	1811	1131150178317
40718	1397	1373433477000
40719	1678	12240386623000
40720	1693	11785830714280
40721	499	66414824089930
40722	1693	11281357755619
40723	1772	2965629091692
40724	1693	11210824331290
40725	54	66414824089930
40726	1693	11205471647635
40727	710	5031426067384
40728	1693	11134938223306
40729	320	66133624089930
40730	1693	10172293464881
40731	1030	906636022402500
40732	1693	10101760040552
40733	663	66414824089930
40734	1693	10081234135297
40735	35	19320676098855
40736	1693	10010700710968
40737	49	66414824089930
40738	1726	722892727000
40739	1874	203273000
40740	1726	722891726000
40741	1874	203274000
40742	1587	2160110000000
40743	1587	2160242000000
40866	1650	4354122000000
40892	1397	1373343468000
40893	1678	12240386632000
40894	1693	5529307575881
40895	678	66414824089930
40896	1693	5458774151552
40897	392	66414824089930
40898	1693	5388240727223
40899	89	66414824089930
40900	1693	5317707302894
40901	186	66414824089930
40902	1397	1373333467000
40903	1678	12240386633000
40904	1397	1373323466000
40905	1678	12240386634000
40906	1397	1373313465000
40907	1678	12240386635000
40908	1693	5247173878565
40909	339	66414824089930
40910	1693	5176640454236
40911	383	66414824089930
40912	1693	5106107029907
40913	408	66414824089930
40914	1693	5103959956448
40915	745	2012570426909
40916	1693	5033426532119
40917	593	66414824089930
40918	1693	4962893107790
40919	91	66414824089930
40920	1693	4892359683461
40921	438	66414824089930
40922	1693	4821826259132
40923	450	66414824089930
40924	1693	4751292834803
40925	322	66414824089930
40926	1693	4680759410474
40927	373	66414824089930
40928	1693	4610225986145
40929	150	66414824089930
40930	1693	4539692561816
40931	92	66414824089930
40932	1693	4469159137487
40933	453	66414824089930
40934	1693	4398625713158
40935	63	66414824089930
40936	1693	4328092288829
40937	146	66414824089930
40938	1693	4257558864500
40939	601	66414824089930
40940	1693	4187025440171
40941	587	66414824089930
40942	1693	3649828296744
40943	910	505937699373100
40944	1693	3579294872415
40945	500	66414824089930
40946	1693	3571805115295
40947	29	7043996494358
40948	1693	3501271690966
40949	138	66414824089930
40950	1693	3430738266637
40951	78	66414824089930
40952	1693	3360204842308
40953	395	66411794089930
40954	1693	3289671417979
40955	205	66414824089930
40956	1726	722881716000
40957	1874	203284000
40958	1726	722880715000
40959	1874	203285000
40960	1726	722879714000
40961	1874	203286000
40962	1726	722878713000
40963	1874	203287000
40964	1509	3551399851155
40965	1509	3551723851155
41001	1611	17990861000000
41011	1726	722874709000
41012	1874	203291000
41013	1693	1494414003699
41071	2000	200000002
41072	1680	3609259500034
41073	1680	3609270500034
41074	1397	1373223456000
41075	1678	12240386644000
41076	1726	722868703000
41077	1874	203297000
41078	1688	39961132904000
41079	1688	39961143904000
41100	1397	1373183452000
41101	1678	12240386648000
41102	1397	1373173451000
41103	1678	12240386649000
41104	1726	722864699000
41105	1874	203301000
41106	1726	722863698000
41107	1874	203302000
41108	1693	2073347155041
41109	1693	2073369155041
41127	1677	48888932325000
41128	1677	48888943325000
41137	1397	1373123446000
41138	1678	12240386654000
41139	1726	722859694000
41140	1874	203306000
41141	1471	23760521000000
41142	1471	23760532000000
41144	1397	1373113445000
41145	1678	12240386655000
41146	1726	722858693000
41147	1874	203307000
40565	1677	44568746325000
40566	1677	45288746325000
40580	484	90480702000000
40581	484	90480742000000
40588	1726	722931748000
40589	1874	203252000
40590	1397	1373643498000
40591	1678	12240386602000
40618	2009	719023000000
40638	1684	5011217880623
40645	1700	6065860276737
40646	1700	6065871276737
40648	1702	1440182000000
40685	1397	1373473481000
40686	1678	12240386619000
40687	1397	1373463480000
40688	1678	12240386620000
40689	1726	722895730000
40690	1874	203270000
40691	1726	722894729000
40692	1874	203271000
40693	1684	5731217880623
40694	1684	5731239880623
40697	1708	15839694000000
40710	1690	81362569000000
40711	1690	81362610000000
40744	1397	1373423476000
40745	1678	12240386624000
40746	1693	9940167286639
40747	251	66414824089930
40748	1693	9869633862310
40749	99	66414824089930
40750	1693	9799100437981
40751	570	66414824089930
40752	1693	9471238881251
40753	893	308751364127976
40754	1693	9400705456922
40755	390	66414824089930
40756	1726	722890725000
40757	1874	203275000
40758	1402	84243463000000
40759	1402	84243524000000
40797	1702	2160182000000
40798	1693	8226442808244
40799	402	66414824089930
40800	1693	8155909383915
40801	275	66414824089930
40802	1693	8085375959586
40803	163	66414824089930
40804	1693	8014842535257
40805	397	66414824089930
40806	1693	7944309110928
40807	391	66414824089930
40808	1693	7873775686599
40809	452	66414824089930
40810	1693	7803242262270
40811	106	66414824089930
40812	1693	7732708837941
40813	594	66414824089930
40814	1693	7662175413612
40815	680	66414824089930
40816	1693	7591641989283
40817	690	66414824089930
40818	1693	7589494915824
40819	731	2012570426909
40820	1693	7518961491495
40821	180	66414824089930
40822	1693	7448428067166
40823	112	66071793089930
40824	1693	7377894642837
40825	353	66414814089930
40826	1693	7307361218508
40827	652	66414824089930
40828	1693	7236827794179
40829	420	66414824089930
40830	1693	7166294369850
40831	352	66414824089930
40832	1693	7095760945521
40833	691	66414824089930
40834	1397	1373393473000
40835	1678	12240386627000
40836	1397	1373383472000
40837	1678	12240386628000
40838	1397	1373373471000
40839	1678	12240386629000
40840	1726	722887722000
40841	1874	203278000
40842	1726	722886721000
40843	1874	203279000
40844	1726	722885720000
40845	1874	203280000
40846	1683	115633978149541
40847	1683	115634191149541
40889	1693	5599841000210
40890	308	66414824089930
40891	470	71040293000000
40966	1397	1373303464000
40967	1678	12240386636000
40968	1693	3219137993650
40969	611	66414824089930
40970	1693	3148604569321
40971	1961	413736265157
40972	1693	3078071144992
40973	504	66414824089930
40974	1693	3007537720663
40975	658	66414824089930
40976	1693	2937004296334
40977	660	66414824089930
40978	1726	722877712000
40979	1874	203288000
40980	1596	4320171000000
40999	1402	84963524000000
41000	1402	84963595000000
41002	1397	1373283462000
41003	1678	12240386638000
41004	1726	722875710000
41005	1874	203290000
41006	1649	18000851999992
41007	1649	18000862999992
41031	1397	1373253459000
41032	1678	12240386641000
41033	1726	722871706000
41034	1874	203294000
41035	1695	3212111000000
41036	1695	3212122000000
41038	1693	10752477629428
41039	1693	10750330555969
41040	1693	10679797131640
41041	1693	10609263707311
41042	1693	10416294138609
41043	1695	1000
41044	1485	2494640999000
41045	1695	3214640999000
41046	1695	3215000999000
41065	1397	1373233457000
41066	1678	12240386643000
41067	1726	722869704000
41068	1874	203296000
41069	1680	3609259500035
41070	1680	3609270500035
41086	1692	38180510019999
41087	1692	38180521019999
41093	1419	6221048280064
41125	1695	3932122000000
41126	1695	3932133000000
41134	1701	3670203600056
41166	1474	3984365000023
41167	1474	3984386000023
41174	1458	6573506908540
41175	1458	6573517908540
41178	1397	1373063440000
41179	1678	12240386660000
41180	1726	722853688000
41181	1874	203312000
41193	1397	1373043438000
41194	1678	12240386662000
41195	1726	722851686000
41196	1874	203314000
41197	1439	3892255998477
41198	1439	3892266998477
41201	1397	1373033437000
41202	1678	12240386663000
41203	1634	22320523899999
41204	1634	22320533899999
41224	1397	1372993433000
41225	1678	12240386667000
41226	1726	722847682000
41227	1874	203318000
41235	1397	1372973431000
41236	1678	12240386669000
41237	1397	1372963430000
41238	1678	12240386670000
41239	1775	1943000000
41240	1726	722845680000
41241	1874	203320000
41242	1726	722844679000
41243	1874	203321000
41244	1683	119954263149541
41245	1683	119954286149541
41262	1692	38900521019999
41263	1692	38900532019999
41265	1397	1372923426000
41266	1678	12240386674000
41267	1397	1372913425000
41268	1678	12240386675000
41092	58	70266275999659
41094	1397	1373193453000
41095	1678	12240386647000
41096	1726	722865700000
41097	1874	203300000
41098	1471	23040521000000
41110	1397	1373163450000
41111	1678	12240386650000
41112	1397	1373153449000
41113	1678	12240386651000
41114	1726	722862697000
41115	1874	203303000
41116	1726	722861696000
41117	1874	203304000
41118	1536	5040572000000
41135	1723	3959037085979
41136	1723	3959047085979
41143	1451	18000594000000
41149	1726	722857692000
41150	1874	203308000
41151	1637	131764088819997
41152	1637	131764089819997
41157	1726	722856691000
41158	1874	203309000
41184	1637	132484089819997
41185	1637	132484090819997
41191	1593	23760867000000
41192	1593	23760878000000
41219	1397	1373003434000
41220	1678	12240386666000
41221	1726	722848683000
41222	1874	203317000
41223	633	69483890900000
41233	1677	49608943325000
41234	1677	49608954325000
41264	1611	17990851000000
41277	1708	16559694000000
41278	1708	16559716000000
41311	1397	1372843418000
41312	1678	12240386682000
41313	1726	722832667000
41314	1874	203333000
41315	1594	5665031000000
41362	1611	18710851000000
41363	1611	18710861000000
41364	1397	1372773411000
41365	1678	12240386689000
41366	1397	1372763410000
41367	1678	12240386690000
41368	1397	1372753409000
41369	1678	12240386691000
41370	1397	1372743408000
41371	1678	12240386692000
41372	1397	1372733407000
41373	1678	12240386693000
41374	1726	722825660000
41375	1874	203340000
41376	1726	722824659000
41377	1874	203341000
41378	1726	722823658000
41379	1874	203342000
41380	1726	722822657000
41381	1874	203343000
41382	1726	722821656000
41383	1874	203344000
41384	1694	5052344127629
41385	1694	5052399127629
41388	1397	1372723406000
41389	1678	12240386694000
41390	1726	722820655000
41391	1874	203345000
41392	1547	4173213000000
41393	1547	4173224000000
41408	1723	4679047085979
41409	1723	4679069085979
41417	1397	1372673401000
41418	1678	12240386699000
41419	1397	1372663400000
41420	1678	12240386700000
41421	1397	1372653399000
41422	1678	12240386701000
41423	1726	722815650000
41424	1874	203350000
41425	1726	722814649000
41426	1874	203351000
41427	1726	722813648000
41428	1874	203352000
41429	1599	19440553000000
41432	1397	1372643398000
41433	1678	12240386702000
41434	1726	722812647000
41435	1874	203353000
41436	1637	132484100819997
41444	1397	1372623396000
41445	1678	12240386704000
41446	1397	1372613395000
41447	1678	12240386705000
41448	1726	722810645000
41449	1874	203355000
41450	1726	722809644000
41451	1874	203356000
41452	1688	41401176904000
41463	1489	22320731000000
41464	1489	22320742000000
41477	1397	1372563390000
41478	1678	12240386710000
41479	1726	722804639000
41480	1874	203361000
41481	1691	2843002100019
41482	1691	2843013100019
41490	1716	4366627000000
41491	1716	4366638000000
41496	2029	1439010000000
41497	2029	1439021000000
41499	1726	722801636000
41500	1874	203364000
41501	1683	122834298149541
41514	1649	17280861999992
41515	1649	18000861999992
41516	1649	18000873999992
41530	1677	51048965325000
41531	1677	51048976325000
41532	1397	1372493383000
41533	1678	12240386717000
41534	1677	51048975325000
41565	1749	2720462000000
41595	1397	1372373371000
41596	1678	12240386729000
41597	1726	722785620000
41598	1874	203380000
41599	1726	721575620000
41600	2048	200000000
41601	43	68160510890000
41613	1688	43561220904000
41614	1688	43561221904000
41616	1397	1372353369000
41617	1678	12240386731000
41618	1726	721572617000
41619	1874	203383000
41620	1681	5543080759830
41621	1681	5543091759830
41626	1683	124274319149541
41627	1683	124274330149541
41635	1397	1372323366000
41636	1678	12240386734000
41637	1397	1372313365000
41638	1678	12240386735000
41639	1726	721569614000
41640	1874	203386000
41641	1726	721568613000
41642	1874	203387000
41643	1677	51768975325000
41644	1677	51768997325000
41647	1397	1372303364000
41648	1678	12240386736000
41649	1726	721567612000
41650	1874	203388000
41658	1693	703879579370
41659	1693	633346155041
41660	1699	4174067050108
41661	1699	4894067050108
41662	1699	66000004950000
41663	646	4894956060108
41664	1397	1372283362000
41665	1678	12240386738000
41666	1397	1372273361000
41667	1678	12240386739000
41668	1397	1372263360000
41669	1678	12240386740000
41670	1726	721565610000
41671	1874	203390000
41672	1726	721564609000
41673	1874	203391000
41674	369	89760712000000
41675	369	89760744000000
41681	1397	1372243358000
41682	1678	12240386742000
41683	1397	1372233357000
41684	1678	12240386743000
41685	1726	721562607000
41686	1874	203393000
41687	1726	721561606000
41688	1874	203394000
41689	1634	23040533899999
41690	1634	23040555899999
41148	1467	23762354100000
41176	1536	5760572000000
41177	1536	5760583000000
41182	1683	118514252149541
41183	1683	118514263149541
41186	1397	1373053439000
41187	1678	12240386661000
41188	1726	722852687000
41189	1874	203313000
41190	1668	5006522000000
41199	1687	10885404726450
41200	1687	10885415726450
41217	1714	6646223103056
41218	1714	6646224103056
41228	1397	1372983432000
41229	1678	12240386668000
41230	1726	722846681000
41231	1874	203319000
41232	1684	5731228880623
41246	1397	1372953429000
41247	1678	12240386671000
41248	1397	1372943428000
41249	1678	12240386672000
41250	1726	722843678000
41251	1874	203322000
41252	1726	722842677000
41253	1874	203323000
41254	1546	4320591000000
41255	1546	4320613000000
41275	1693	2793369155041
41276	1693	2793391155041
41279	1397	1372903424000
41280	1678	12240386676000
41281	1587	2160252000000
41282	1726	722838673000
41283	1874	203327000
41284	1587	2880252000000
41295	1397	1372873421000
41296	1678	12240386679000
41297	1397	1372863420000
41298	1678	12240386680000
41299	1397	1372853419000
41300	1678	12240386681000
41301	1726	722835670000
41302	1874	203330000
41303	1726	722834669000
41304	1874	203331000
41305	1726	722833668000
41306	1874	203332000
41307	1688	41401154904000
41308	1688	41401187904000
41336	1677	50328954325000
41337	1677	50328965325000
41342	1710	6094486473290
41343	1710	6094487473290
41350	1397	1372793413000
41351	1678	12240386687000
41352	1726	722826661000
41353	1874	203339000
41354	1693	2793380155041
41357	1397	1372783412000
41358	1678	12240386688000
41359	1637	132484099819997
41386	1402	85683595000000
41387	1402	85683650000000
41394	1397	1372713405000
41395	1678	12240386695000
41396	1726	722819654000
41397	1874	203346000
41398	1679	16397343711000
41430	1673	26686631000000
41431	1673	26686664000000
41437	1623	35282281899898
41438	1623	35282292899898
41483	1397	1372553389000
41484	1678	12240386711000
41485	1726	722803638000
41486	1874	203362000
41487	1467	24482354100000
41488	1467	24482365100000
41517	1397	1372513385000
41518	1678	12240386715000
41519	1726	722798633000
41520	1874	203367000
41521	1637	133204100819997
41522	1637	133204111819997
41535	1397	1372483382000
41536	1678	12240386718000
41537	1726	722796631000
41538	1874	203369000
41539	1681	4823069759830
41540	1681	4823080759830
41576	1397	1372413375000
41577	1678	12240386725000
41578	1397	1372403374000
41579	1678	12240386726000
41580	1726	722789624000
41581	1874	203376000
41582	1726	722788623000
41583	1874	203377000
41584	1710	6094508473290
41605	1397	1372363370000
41606	1678	12240386730000
41607	1726	721574619000
41608	1874	203381000
41628	1673	27406664000000
41629	1673	27406675000000
41651	1397	1372293363000
41652	1678	12240386737000
41653	1726	721566611000
41654	1874	203389000
41655	1699	4893898050108
41699	1671	3648219530515
41700	1671	3648230530515
41703	1726	721559604000
41704	1874	203396000
41705	1634	23760555899999
41706	1634	23760556899999
41740	1397	1372153349000
41741	1678	12240386751000
41742	1397	1372143348000
41743	1678	12240386752000
41744	1397	1372133347000
41745	1678	12240386753000
41746	1726	721552597000
41747	1874	203403000
41748	1726	721551596000
41749	1874	203404000
41750	1726	721550595000
41751	1874	203405000
41752	606	69979719812962
41759	1677	52489007325000
41773	1397	1372093343000
41774	1678	12240386757000
41775	1397	1372083342000
41776	1678	12240386758000
41777	1726	721546591000
41778	1874	203409000
41779	1726	721545590000
41780	1874	203410000
41781	1679	17837344711000
41782	1679	17837366711000
41796	1397	1372053339000
41797	1678	12240386761000
41798	1726	720332587000
41799	1874	203413000
41800	1768	2750611110000
41801	1768	2750622110000
41805	1397	1372043338000
41806	1678	12240386762000
41807	1726	720331586000
41808	1874	203414000
41809	1683	128594351149541
41810	1683	128594362149541
41827	1397	1372013335000
41828	1678	12240386765000
41829	1726	720328583000
41830	1874	203417000
41831	1679	18557366711000
41832	1679	18557377711000
41898	1637	133924111819997
41899	1637	133924122819997
41900	1397	1371893323000
41901	1678	12240386777000
41902	1726	720316571000
41903	1874	203429000
41904	42	86878251000000
41981	1657	21601931000000
41982	1657	21602409000000
41990	1726	719095560000
41991	2050	1400000000
41992	1397	1371763310000
41993	1678	12240386790000
41994	1775	1917000000
41995	1747	736806000000
41996	1321	1701978637751650
41997	1769	1719900000
41998	1726	719094559000
41999	1874	203441000
42000	1673	28126675000000
42001	1673	28126700000000
42019	1397	1371743308000
42020	1678	12240386792000
42021	1726	719092557000
42022	1874	203443000
41153	1397	1373103444000
41154	1678	12240386656000
41155	1593	23040856000000
41156	1593	23040867000000
41159	1397	1373093443000
41160	1678	12240386657000
41161	1397	1373083442000
41162	1678	12240386658000
41163	1726	722855690000
41164	1874	203310000
41165	1560	4194088277001
41168	1397	1373073441000
41169	1678	12240386659000
41170	1726	722854689000
41171	1874	203311000
41172	633	69483869900000
41173	633	69483880900000
41205	1397	1373023436000
41206	1678	12240386664000
41207	1726	722850685000
41208	1874	203315000
41209	1587	2880242000000
41210	1587	2880253000000
41211	1397	1373013435000
41212	1678	12240386665000
41213	1726	722849684000
41214	1874	203316000
41215	1670	2880700000000
41216	1670	2880711000000
41256	1397	1372933427000
41257	1678	12240386673000
41258	1726	722841676000
41259	1874	203324000
41260	1678	12960386673000
41261	1678	12960397673000
41309	1702	2160215000000
41316	1397	1372833417000
41317	1678	12240386683000
41318	1397	1372823416000
41319	1678	12240386684000
41320	1726	722831666000
41321	1874	203334000
41322	1726	722830665000
41323	1874	203335000
41324	1447	8074461944000
41325	1447	8074483944000
41328	1397	1372813415000
41329	1678	12240386685000
41330	1726	722829664000
41331	1874	203336000
41332	2039	2881002000000
41333	2039	2881013000000
41355	1587	3600253000000
41356	1587	3600264000000
41360	1729	4606876000000
41361	1729	4606886000000
41416	1564	4146245000000
41439	1397	1372633397000
41440	1678	12240386703000
41441	1726	722811646000
41442	1874	203354000
41443	1690	81362580000000
41457	1397	1372593393000
41458	1678	12240386707000
41459	1726	722807642000
41460	1874	203358000
41461	1683	122834297149541
41462	1683	122834308149541
41475	1654	6047853000000
41476	1654	6047875000000
41492	1397	1372543388000
41493	1678	12240386712000
41494	1726	722802637000
41495	1874	203363000
41503	1397	1372533387000
41504	1678	12240386713000
41505	1688	41401186904000
41506	1397	1372523386000
41507	1678	12240386714000
41508	1726	722800635000
41509	1874	203365000
41510	1726	722799634000
41511	1874	203366000
41512	1688	42121186904000
41513	1688	42121198904000
41529	43	68160500890000
41551	1729	5326886000000
41552	1729	5326908000000
41559	1397	1372443378000
41560	1678	12240386722000
41561	1726	722792627000
41562	1874	203373000
41563	1724	3549281000000
41564	1724	3549292000000
41575	1739	17279635000000
41603	1679	17117343711000
41604	1679	17117364711000
41609	1726	721573618000
41610	1874	203382000
41611	1610	2880081000000
41612	1610	2880082000000
41630	1397	1372333367000
41631	1678	12240386733000
41632	1726	721570615000
41633	1874	203385000
41634	1689	1440061287614
41677	1397	1372253359000
41678	1678	12240386741000
41679	1726	721563608000
41680	1874	203392000
41707	1397	1372213355000
41708	1678	12240386745000
41709	1726	721558603000
41710	1874	203397000
41716	1397	1372193353000
41717	1678	12240386747000
41718	1397	1372183352000
41719	1678	12240386748000
41720	1726	721556601000
41721	1874	203399000
41722	1726	721555600000
41723	1874	203400000
41724	149	71310027000341
41725	149	71310049000341
41738	1587	4320264000000
41739	1587	4320286000000
41756	1683	125714340149541
41760	1623	35282291899898
41761	1726	721549594000
41762	1874	203406000
41763	1549	29520777000000
41817	1991	2635103441475
41818	1991	2635114441475
41833	1397	1372003334000
41834	1678	12240386766000
41835	1726	720327582000
41836	1874	203418000
41837	171	68870271524688
41848	1397	1371973331000
41849	1678	12240386769000
41850	1726	720324579000
41851	1874	203421000
41852	1688	45001253904000
41853	1688	45001264904000
41854	1397	1371963330000
41855	1678	12240386770000
41856	1726	720323578000
41857	1874	203422000
41858	1422	3744970860211
41859	971	505003883106880
41860	1991	3355114441475
41861	1991	3355126441475
41863	1714	7366224103056
41864	1714	7366236103056
41865	1775	1932000000
41866	149	71310039000341
41867	1397	1371953329000
41868	1678	12240386771000
41869	1397	1371943328000
41870	1678	12240386772000
41871	1397	1371933327000
41872	1678	12240386773000
41873	1397	1371923326000
41874	1678	12240386774000
41875	1726	720322577000
41876	1874	203423000
41877	1726	720321576000
41878	1874	203424000
41879	1726	720320575000
41880	1874	203425000
41881	1726	720319574000
41882	1874	203426000
41883	1980	10799080000000
41884	1980	10799145000000
41915	1608	4605462000000
41916	1608	4605484000000
41921	1397	1371853319000
41922	1678	12240386781000
41923	1726	720312567000
41924	1874	203433000
41925	1775	1931000000
41926	1656	5181306000000
41927	1656	5181318000000
41929	1397	1371843318000
41930	1678	12240386782000
41269	1726	722840675000
41270	1874	203325000
41271	1726	722839674000
41272	1874	203326000
41273	1762	5361720994000
41274	1762	5361742994000
41285	1397	1372893423000
41286	1678	12240386677000
41287	1397	1372883422000
41288	1678	12240386678000
41289	1726	722837672000
41290	1874	203328000
41291	1726	722836671000
41292	1874	203329000
41293	1691	2122980100019
41294	1691	2123002100019
41310	1703	1440603000000
41326	2039	2160980000000
41327	2039	2161002000000
41334	1683	121394286149541
41335	1683	121394297149541
41338	1726	722828663000
41339	1874	203337000
41340	1698	4136863550035
41341	1698	4136864550035
41344	1397	1372803414000
41345	1678	12240386686000
41346	1726	722827662000
41347	1874	203338000
41348	1426	18000810000000
41349	1426	18000821000000
41399	1397	1372703404000
41400	1678	12240386696000
41401	1397	1372693403000
41402	1678	12240386697000
41403	1726	722818653000
41404	1874	203347000
41405	1726	722817652000
41406	1874	203348000
41407	1683	121394308149541
41410	1397	1372683402000
41411	1678	12240386698000
41412	1726	722816651000
41413	1874	203349000
41414	1402	86403650000000
41415	1402	86403661000000
41453	1397	1372603394000
41454	1678	12240386706000
41455	1726	722808643000
41456	1874	203357000
41465	1397	1372583392000
41466	1678	12240386708000
41467	1397	1372573391000
41468	1678	12240386709000
41469	1726	722806641000
41470	1874	203359000
41471	1726	722805640000
41472	1874	203360000
41473	1850	6398800000000
41474	1850	6398822000000
41489	1694	5052355127629
41498	1472	720011000000
41502	1701	3670194600056
41523	1601	5258450600000
41524	1601	5258461600000
41525	1397	1372503384000
41526	1678	12240386716000
41527	1726	722797632000
41528	1874	203368000
41541	1397	1372473381000
41542	1678	12240386719000
41543	1397	1372463380000
41544	1678	12240386720000
41545	1726	722795630000
41546	1874	203370000
41547	1726	722794629000
41548	1874	203371000
41549	1608	3885440000000
41550	1608	3885462000000
41553	1397	1372453379000
41554	1678	12240386721000
41555	1726	722793628000
41556	1874	203372000
41557	1560	4914088277001
41558	1560	4914099277001
41566	1397	1372433377000
41567	1678	12240386723000
41568	1397	1372423376000
41569	1678	12240386724000
41570	1726	722791626000
41571	1874	203374000
41572	1726	722790625000
41573	1874	203375000
41574	1683	122834319149541
41585	1397	1372393373000
41586	1678	12240386727000
41587	1397	1372383372000
41588	1678	12240386728000
41589	1726	722787622000
41590	1874	203378000
41591	1726	722786621000
41592	1874	203379000
41593	1688	42841198904000
41594	1688	42841220904000
41602	1749	2720472000000
41615	1679	17117344711000
41622	1397	1372343368000
41623	1678	12240386732000
41624	1726	721571616000
41625	1874	203384000
41645	2049	719000000000
41646	2049	719022000000
41656	1677	52488997325000
41657	1677	52489008325000
41676	1656	4461306000000
41691	1397	1372223356000
41692	1678	12240386744000
41693	1726	721560605000
41694	1874	203395000
41695	1683	125714330149541
41696	1683	125714341149541
41701	1692	39620532019999
41702	1692	39620543019999
41733	1726	721554599000
41734	1874	203401000
41735	1726	721553598000
41736	1874	203402000
41737	1657	20881234000000
41753	1397	1372123346000
41754	1678	12240386754000
41755	1688	43561230904000
41783	1397	1372073341000
41784	1678	12240386759000
41785	1726	721544589000
41786	1874	203411000
41787	1683	127154340149541
41788	1683	127154351149541
41802	1768	2031261110000
41803	1994	1650000000
41804	1768	2751011110000
41811	1397	1372033337000
41812	1678	12240386763000
41813	1726	720330585000
41814	1874	203415000
41815	1536	6480583000000
41816	1536	6480594000000
41844	1397	1371983332000
41845	1678	12240386768000
41846	1726	720325580000
41847	1874	203420000
41887	58	70266265999659
41888	1397	1371913325000
41889	1678	12240386775000
41890	1726	720318573000
41891	1874	203427000
41892	1677	53209008325000
41893	1677	53209029325000
41905	1397	1371883322000
41906	1678	12240386778000
41907	1397	1371873321000
41908	1678	12240386779000
41909	1726	720315570000
41910	1874	203430000
41911	1726	720314569000
41912	1874	203431000
41913	1705	4638890500145
41914	1705	4638912500145
41917	1397	1371863320000
41918	1678	12240386780000
41919	1726	720313568000
41920	1874	203432000
41932	1677	53929029325000
41933	1677	53929039325000
41936	1448	2916674000001
41960	1397	1371803314000
41961	1678	12240386786000
41962	1397	1371793313000
41963	1678	12240386787000
41964	1747	8734807000000
41965	1704	4320195000000
41966	1726	720308563000
41967	1874	203437000
41968	1726	720307562000
41969	1874	203438000
41970	1509	4271723851155
41697	1402	87123661000000
41698	1402	87123672000000
41711	1397	1372203354000
41712	1678	12240386746000
41713	1726	721557602000
41714	1874	203398000
41715	369	89760723000000
41726	1397	1372173351000
41727	1678	12240386749000
41728	1397	1372163350000
41729	1678	12240386750000
41730	1657	20161890000000
41731	1657	20881890000000
41732	1657	20881931000000
41757	1684	6451228880623
41758	1684	6451238880623
41764	1397	1372113345000
41765	1678	12240386755000
41766	1397	1372103344000
41767	1678	12240386756000
41768	1726	721548593000
41769	1874	203407000
41770	1726	721547592000
41771	1874	203408000
41772	1688	43561242904000
41789	1726	720334589000
41790	2050	200000000
41791	1397	1372063340000
41792	1678	12240386760000
41793	1726	720333588000
41794	1874	203412000
41795	1435	720021000000
41819	1683	130034362149541
41820	1683	130034373149541
41821	1397	1372023336000
41822	1678	12240386764000
41823	1726	720329584000
41824	1874	203416000
41825	1693	3513380155041
41826	1693	3513391155041
41838	1397	1371993333000
41839	1678	12240386767000
41840	1726	720326581000
41841	1874	203419000
41842	1688	44281242904000
41843	1688	44281253904000
41862	1675	3741931999977
41885	1402	87843672000000
41886	1402	87843737000000
41894	1397	1371903324000
41895	1678	12240386776000
41896	1726	720317572000
41897	1874	203428000
41928	1992	5039152990000
41934	1670	3600711000000
41935	1670	3600721000000
41956	1723	4679090085979
41957	1723	5399090085979
41958	2048	5399113085978
41959	1723	200000001
41972	1681	6263091759830
41973	1681	6263114759830
42037	1397	1371713305000
42038	1678	12240386795000
42039	1726	719089554000
42040	1874	203446000
42046	1549	30240777000000
42047	1549	30240788000000
42054	1448	2916675000001
42057	1397	1371683302000
42058	1678	12240386798000
42059	1726	719086551000
42060	1874	203449000
42114	1397	1371573291000
42115	1678	12240386809000
42116	1397	1371563290000
42117	1678	12240386810000
42118	1726	719075540000
42119	1874	203460000
42120	1726	719074539000
42121	1874	203461000
42122	1457	20487668400000
42123	1025	505330736600000
42124	1688	45001276904000
42143	1397	1371523286000
42144	1678	12240386814000
42145	1726	719070535000
42146	1874	203465000
42147	1690	82082580000000
42148	1690	82082591000000
42171	1749	2720503000000
42172	1749	3440503000000
42193	1518	5040334000000
42201	1397	1371453279000
42202	1678	12240386821000
42203	1726	716643528000
42204	1874	203472000
42205	1727	4506678000000
42206	1727	4506689000000
42208	1397	1371443278000
42209	1678	12240386822000
42210	1726	716642527000
42211	1874	203473000
42222	1726	716639524000
42223	1874	203476000
42224	1670	4320721000000
42225	1670	4320722000000
42232	1726	716637522000
42233	1874	203478000
42234	1726	716636521000
42235	1874	203479000
42236	1683	130034364149541
42238	1726	716635520000
42239	1874	203480000
42240	1688	47161288904000
42241	1688	47161289904000
42257	1726	716629514000
42258	1874	203486000
42259	1726	716628513000
42260	1874	203487000
42261	1683	131474364149541
42262	1683	131474366149541
42278	1518	5040292000000
42281	1726	716623508000
42282	1874	203492000
42283	1695	3932123000000
42293	1726	716620505000
42294	1874	203495000
42295	1708	17279716000000
42296	1708	17279717000000
42310	1726	716615500000
42311	1874	203500000
42312	1525	1000000
42313	1931	3594486000000
42314	1701	5110238600056
42315	1701	5110240600056
42323	1726	716611496000
42324	1874	203504000
42325	43	68160490890000
42328	1688	47881289904000
42337	1726	716608493000
42338	1874	203507000
42339	1701	5830240600056
42340	1701	5830241600056
42351	1726	716605490000
42352	1874	203510000
42353	1684	6451229880623
42367	1726	716601486000
42368	1874	203514000
42369	1726	716600485000
42370	1874	203515000
42371	1599	19440522000000
42382	1637	135364123819997
42428	1726	716583468000
42429	1874	203532000
42430	1726	716582467000
42431	1874	203533000
42432	1555	16560374000000
42435	1726	716581466000
42436	1874	203534000
42437	1677	56809074325000
42438	1677	56809075325000
42482	1726	716567452000
42483	1874	203548000
42484	1726	716566451000
42485	1874	203549000
42486	1678	12960386822000
42487	1678	12960388822000
42492	606	70699719812962
42493	606	70699720812962
42498	1688	48601290904000
42499	1688	48601291904000
42532	1670	5040722000000
42533	1670	5040724000000
42535	1726	716555440000
42536	1874	203560000
42537	1467	24482355100000
42549	1704	786194000000
42550	1704	786196000000
42554	1683	140114377149541
42563	1726	716551436000
42564	1874	203564000
42566	1726	716550435000
42567	1874	203565000
42568	1684	7171229880623
41931	1599	19440530000000
41937	1439	4612266998477
41938	1439	4612276998477
41939	1675	3741929999977
41940	1775	1920000000
41941	1397	1371833317000
41942	1678	12240386783000
41943	1701	3670215600056
41944	1397	1371823316000
41945	1678	12240386784000
41946	1397	1371813315000
41947	1678	12240386785000
41948	1726	720311566000
41949	1874	203434000
41950	1726	720310565000
41951	1874	203435000
41952	1726	720309564000
41953	1874	203436000
41954	1701	4390215600056
41955	1701	4390238600056
41979	1657	21601234000000
41980	1657	21601245000000
41983	1397	1371773311000
41984	1678	12240386789000
41985	1775	1919000000
41986	1726	720305560000
41987	1874	203440000
41988	1440	4319060000000
41989	1440	4319072000000
42004	1692	40340543019999
42005	1692	40340568019999
42014	58	69546254999659
42015	1699	4895137060108
42016	1699	5615137060108
42017	1699	66000100000000
42018	471	5615237060108
42042	1397	1371703304000
42043	1678	12240386796000
42044	1726	719088553000
42045	1874	203447000
42048	1397	1371693303000
42049	1678	12240386797000
42050	1726	719087552000
42051	1874	203448000
42052	1426	18720821000000
42053	1426	18720832000000
42061	1458	6573634908540
42095	1654	6767952000000
42101	1397	1371603294000
42102	1678	12240386806000
42103	1397	1371593293000
42104	1678	12240386807000
42105	1397	1371583292000
42106	1678	12240386808000
42107	1726	719078543000
42108	1874	203457000
42109	1726	719077542000
42110	1874	203458000
42111	1726	719076541000
42112	1874	203459000
42113	1601	5258483600000
42127	1397	1371553289000
42128	1678	12240386811000
42129	1726	719073538000
42130	1874	203462000
42131	1764	2161734100000
42161	1397	1371503284000
42162	1678	12240386816000
42163	1726	719068533000
42164	1874	203467000
42165	1726	717858533000
42166	2051	200000000
42167	1726	716648533000
42168	2052	200000000
42169	1677	54649093325000
42170	1677	55369093325000
42192	1677	55369105325000
42200	1677	55369073325000
42214	1726	716641526000
42215	1874	203474000
42216	1687	10885405726450
42228	1726	716638523000
42229	1874	203477000
42230	1457	4944170040000
42231	1457	4944171040000
42252	1726	716631516000
42253	1874	203484000
42254	1726	716630515000
42255	1874	203485000
42256	1673	28126677000000
42267	1692	40340544019999
42286	1726	716622507000
42287	1874	203493000
42288	1694	5052345127629
42300	1686	16052346500013
42301	1686	16052347500013
42327	1683	134354368149541
42329	1726	716610495000
42330	1874	203505000
42331	1683	135794368149541
42332	1683	135794369149541
42350	1688	47881290904000
42357	1489	23040742000000
42358	1489	23040743000000
42383	1573	23041130000000
42384	1573	23761130000000
42385	1573	66000004950000
42386	646	23762049009999
42387	1807	200000002
42401	1726	716592477000
42402	1874	203523000
42403	1726	716591476000
42404	1874	203524000
42405	1607	6018204644388
42406	1607	6018206644388
42416	1726	716587472000
42417	1874	203528000
42418	1716	5086638000000
42419	1716	5086639000000
42420	1726	716586471000
42421	1874	203529000
42422	1726	716585470000
42423	1874	203530000
42424	1726	716584469000
42425	1874	203531000
42426	1509	4991724851155
42427	1509	4991727851155
42440	1726	716580465000
42441	1874	203535000
42442	1992	5039141990000
42447	1726	716578463000
42448	1874	203537000
42449	1726	716577462000
42450	1874	203538000
42451	1726	716576461000
42452	1874	203539000
42453	633	70203890900000
42454	633	70203893900000
42469	1683	138674372149541
42470	1683	138674375149541
42471	576	67955594938283
42472	1726	716571456000
42473	1874	203544000
42474	1726	716570455000
42475	1874	203545000
42476	1726	716569454000
42477	1874	203546000
42478	1726	716568453000
42479	1874	203547000
42480	1513	18000551000000
42481	1513	18000575000000
42491	1444	4174956160000
42494	1726	716564449000
42495	1874	203551000
42496	1447	8794472944000
42497	1447	8794473944000
42506	1458	6573969908540
42507	1458	7293969908540
42508	1571	7293998908532
42509	1458	15840301001008
42510	1726	716562447000
42511	1874	203553000
42512	1726	716561446000
42513	1874	203554000
42514	1726	716560445000
42515	1874	203555000
42516	1726	716559444000
42517	1874	203556000
42518	1508	19440512000000
42519	1508	19440516000000
42527	1726	716557442000
42528	1874	203558000
42529	1726	716556441000
42530	1874	203559000
42531	1649	18720854999992
42543	1726	716554439000
42544	1874	203561000
42545	1726	716553438000
42546	1874	203562000
42547	1747	1456806000000
42548	1747	1456808000000
42557	1726	716552437000
42558	1874	203563000
42559	1683	141554377149541
42560	1683	141554378149541
41971	1509	4271746851155
41974	1397	1371783312000
41975	1678	12240386788000
41976	1726	720306561000
41977	1874	203439000
41978	1447	8074472944000
42002	1679	19277377711000
42003	1679	19277402711000
42006	1397	1371753309000
42007	1678	12240386791000
42008	1704	66194000000
42009	1075	905227465000000
42010	1726	719093558000
42011	1874	203442000
42012	1699	5613898050108
42013	1699	5613910050108
42026	1397	1371733307000
42027	1678	12240386793000
42028	1397	1371723306000
42029	1678	12240386794000
42030	1726	719091556000
42031	1874	203444000
42032	1746	4114299000000
42033	955	505151775000000
42034	1726	719090555000
42035	1874	203445000
42036	2039	2881025000000
42071	1397	1371653299000
42072	1678	12240386801000
42073	1726	719083548000
42074	1874	203452000
42075	1677	54649051325000
42076	1677	54649062325000
42077	1397	1371643298000
42078	1678	12240386802000
42079	1397	1371633297000
42080	1678	12240386803000
42081	1397	1371623296000
42082	1678	12240386804000
42083	1397	1371613295000
42084	1678	12240386805000
42085	1726	719082547000
42086	1874	203453000
42087	1726	719081546000
42088	1874	203454000
42089	1726	719080545000
42090	1874	203455000
42091	1726	719079544000
42092	1874	203456000
42093	1654	6767875000000
42094	1654	6767919000000
42138	1397	1371533287000
42139	1678	12240386813000
42140	1726	719071536000
42141	1874	203464000
42142	1729	5326897000000
42191	1711	3404498000000
42218	1726	716640525000
42219	1874	203475000
42220	1688	46441287904000
42221	1688	46441288904000
42246	1726	716633518000
42247	1874	203482000
42248	1726	716632517000
42249	1874	203483000
42250	1622	15119429999976
42251	1622	15119431999976
42263	1726	716627512000
42264	1874	203488000
42265	1693	4233391155041
42266	1693	4233392155041
42274	1726	716624509000
42275	1874	203491000
42276	1683	132914366149541
42277	1683	132914367149541
42284	1637	134644122819997
42285	1637	134644123819997
42297	1726	716619504000
42298	1874	203496000
42299	1649	18000852999992
42305	1726	716617502000
42306	1874	203498000
42307	1726	716616501000
42308	1874	203499000
42309	1476	2880052000000
42321	1726	716612497000
42322	1874	203503000
42335	1726	716609494000
42336	1874	203506000
42344	1476	3600052000000
42345	1476	3600053000000
42354	1726	716604489000
42355	1874	203511000
42356	1762	5361721994000
42365	1426	18720834000000
42366	1426	19440834000000
42376	1726	716599484000
42377	1874	203516000
42378	1726	716598483000
42379	1874	203517000
42380	1690	82802591000000
42381	1690	82802593000000
42396	1726	716594479000
42397	1874	203521000
42398	1726	716593478000
42399	1874	203522000
42400	1695	3932124000000
42439	1717	18719794000000
42446	1419	6221039280064
42459	1726	716574459000
42460	1874	203541000
42461	632	86880694000000
42462	632	86880695000000
42500	1611	19430852000000
42501	1611	19430853000000
42502	1726	716563448000
42503	1874	203552000
42504	1458	7293506908540
42505	1458	7293507908540
42520	1718	2966675763340
42521	1718	2966679763340
42538	1451	19440596000000
42541	1729	6046897000000
42542	1729	6046898000000
42551	1746	4834299000000
42552	1746	4834301000000
42555	1677	58969076325000
42556	1677	58969078325000
42561	1596	5040171000000
42562	1596	5040172000000
42565	1536	6480584000000
42570	1594	7105032000000
42571	1594	7105033000000
42594	1704	786195000000
42598	1693	4953392155041
42599	1693	4953393155041
42607	1726	716542427000
42608	1874	203573000
42615	1726	716539424000
42616	1874	203576000
42617	632	87600694000000
42618	632	87600695000000
42654	1705	5358890500145
42655	1705	5359034500145
42666	1726	716527412000
42667	1874	203588000
42674	1608	6045498000000
42675	1608	6045499000000
42686	1726	716523408000
42687	1874	203592000
42688	1726	716522407000
42689	1874	203593000
42690	1683	142994380149541
42023	1746	6488300000000
42024	1195	610775750000000
42025	1623	35282293899898
42041	1439	4612277998477
42055	1710	6814508473290
42056	1710	6814519473290
42062	1397	1371673301000
42063	1678	12240386799000
42064	1397	1371663300000
42065	1678	12240386800000
42066	1726	719085550000
42067	1874	203450000
42068	1726	719084549000
42069	1874	203451000
42070	1677	53929051325000
42096	149	69870007000341
42097	58	68826234999659
42098	1571	16563261001000
42099	1571	17283261001000
42100	1571	17283531001000
42125	1677	55369062325000
42126	1677	55369085325000
42132	1397	1371543288000
42133	1678	12240386812000
42134	1726	719072537000
42135	1874	203463000
42136	1688	45721276904000
42137	1688	45721287904000
42149	1397	1371513285000
42150	1678	12240386815000
42151	1726	719069534000
42152	1874	203466000
42153	1457	17400939560000
42154	1265	610991477840000
42155	1457	12825908800000
42156	1145	905548494760000
42157	1457	4224170040000
42158	1391	1702582375511650
42159	1608	5325484000000
42160	1608	5325498000000
42173	1769	1709900000
42174	1397	1371493283000
42175	1678	12240386817000
42176	1397	1371483282000
42177	1678	12240386818000
42178	1397	1371473281000
42179	1678	12240386819000
42180	1726	716647532000
42181	1874	203468000
42182	1726	716646531000
42183	1874	203469000
42184	1726	716645530000
42185	1874	203470000
42186	2048	200000001
42187	1711	3404454999999
42188	1711	66000004950000
42189	646	3404497009996
42190	2048	200000004
42194	1564	4866245000000
42195	1564	4866288000000
42196	1397	1371463280000
42197	1678	12240386820000
42198	1726	716644529000
42199	1874	203471000
42207	1402	87843683000000
42212	1749	4160503000000
42213	1749	4160514000000
42217	1602	4320350000000
42226	1677	56089073325000
42227	1677	56089074325000
42237	1271	1343406292000000
42242	1726	716634519000
42243	1874	203481000
42244	1451	18720594000000
42245	1451	18720595000000
42268	1726	716626511000
42269	1874	203489000
42270	1726	716625510000
42271	1874	203490000
42272	1525	720000000000
42273	1525	720002000000
42279	1692	41060544019999
42280	1692	41060545019999
42289	1726	716621506000
42290	1874	203494000
42291	1613	2087680600000
42292	1613	2087681600000
42302	1726	716618503000
42303	1874	203497000
42304	1611	18710852000000
42316	1726	716614499000
42317	1874	203501000
42318	1726	716613498000
42319	1874	203502000
42320	1683	132914368149541
42326	1509	4271724851155
42333	1471	24480532000000
42334	1471	24480533000000
42341	1726	716607492000
42342	1874	203508000
42343	1767	719001000000
42346	1726	716606491000
42347	1874	203509000
42348	1649	18720852999992
42349	1649	18720853999992
42359	1726	716603488000
42360	1874	203512000
42361	1726	716602487000
42362	1874	203513000
42363	1683	135794371149541
42364	1683	137234371149541
42372	341	66001000000001
42373	1599	19440519999999
42374	1514	19440521996199
42375	1599	3800
42388	1726	716597482000
42389	1874	203518000
42390	1726	716596481000
42391	1874	203519000
42392	1726	716595480000
42393	1874	203520000
42394	1683	137234369149541
42395	1683	137234372149541
42407	1602	5040350000000
42408	1602	5040352000000
42409	1726	716590475000
42410	1874	203525000
42411	1726	716589474000
42412	1874	203526000
42413	1726	716588473000
42414	1874	203527000
42415	1637	135364126819997
42433	1723	5399069085979
42434	1723	5399205085979
42443	1726	716579464000
42444	1874	203536000
42445	1711	3404456000000
42455	1726	716575460000
42456	1874	203540000
42457	1677	57529075325000
42458	1677	57529076325000
42463	1726	716573458000
42464	1874	203542000
42465	1726	716572457000
42466	1874	203543000
42467	1677	58249076325000
42468	1677	58249079325000
42488	1726	716565450000
42489	1874	203550000
42490	1668	5006512000000
42522	1683	140114375149541
42523	1726	716558443000
42524	1874	203557000
42525	1594	6385031000000
42526	1594	6385032000000
42534	1451	19440595000000
42539	1764	2881734100000
42540	1764	2881735100000
42553	1476	3600054000000
42578	1623	36002293899898
42579	1623	36002294899898
42595	1746	4834300000000
42600	1687	11605405726450
42601	1687	11605406726450
42619	1683	142994378149541
42620	1683	142994379149541
42621	1726	716538423000
42622	1874	203577000
42623	1726	716537422000
42624	1874	203578000
42625	1726	716536421000
42626	1874	203579000
42627	1749	4160506000000
42656	1677	60409079325000
42657	1677	60409223325000
42658	1726	716529414000
42659	1874	203586000
42660	1726	716528413000
42661	1874	203587000
42662	1695	4652124000000
42663	1695	4652126000000
42680	1690	83522593000000
42681	1690	83522594000000
42691	1701	6550241600056
42692	1701	6550243600056
42569	1684	7171230880623
42576	1485	38000000000
42577	1458	7975998908532
42591	1726	716544429000
42592	1874	203571000
42593	1747	1456807000000
42596	2039	3601025000000
42597	2039	3601026000000
42603	1633	3636270985638
42611	1726	716540425000
42612	1874	203575000
42613	1684	7891230880623
42614	1684	7891231880623
42652	1593	24480878000000
42653	1593	24481022000000
42672	1673	28846677000000
42673	1673	28846678000000
42676	1726	716525410000
42677	1874	203590000
42678	1679	19997402711000
42679	1679	19997403711000
42682	1726	716524409000
42683	1874	203591000
42684	1588	20880734000000
42685	1588	20880735000000
42572	1726	716549434000
42573	1874	203566000
42574	1458	8013507908540
42575	1458	8013508908540
42580	411	66006400000000
42581	2053	1000000000
42582	1726	716548433000
42583	1874	203567000
42584	1726	716547432000
42585	1874	203568000
42586	1726	716546431000
42587	1874	203569000
42588	1726	716545430000
42589	1874	203570000
42590	1508	19440526000000
42602	1677	58969077325000
42604	1726	716543428000
42605	1874	203572000
42606	1683	140114378149541
42609	1726	716541426000
42610	1874	203574000
42628	1726	716535420000
42629	1874	203580000
42630	1726	716534419000
42631	1874	203581000
42632	1677	59689077325000
42633	1677	59689079325000
42634	2042	1550390000000
42635	1717	15865277987543
42636	920	504912280012457
42637	1717	12040253293650
42638	1040	904798479693893
42639	1717	9459429660887
42640	1160	610485563632763
42641	1717	2267753000023
42642	1286	1701172304412514
42643	1726	716533418000
42644	1874	203582000
42645	1726	716532417000
42646	1874	203583000
42647	1726	716531416000
42648	1874	203584000
42649	1726	716530415000
42650	1874	203585000
42651	1588	20160734000000
42664	1402	88563683000000
42665	1402	88563685000000
42668	1726	716526411000
42669	1874	203589000
42670	1622	15839431999976
42671	1622	15839432999976
42693	1726	716521406000
42694	1874	203594000
42695	1695	5372126000000
42696	1695	5372127000000
42697	1726	716520405000
42698	1874	203595000
42699	1677	60409080325000
42700	1749	4880506000000
42701	1749	4880507000000
42702	1726	716519404000
42703	1874	203596000
42704	1992	5759141990000
42705	1992	5759142990000
42706	1698	4856864550035
42707	1698	4856865550035
42708	1726	716518403000
42709	1874	203597000
42710	1637	136084126819997
42711	1637	136084127819997
42712	1726	716517402000
42713	1874	203598000
42714	1726	716516401000
42715	1874	203599000
42716	1759	2880565999999
42717	1759	2880566999999
42718	1726	716515400000
42719	1874	203600000
42720	1683	144434380149541
42721	1683	144434381149541
42722	1710	6814509473290
42723	1677	61129080325000
42724	1677	61129081325000
42725	369	90480723000000
42726	369	90480893000000
42727	1726	716514399000
42728	1874	203601000
42729	1726	716513398000
42730	1874	203602000
42731	1637	136804127819997
42732	1637	136804129819997
42733	1726	716512397000
42734	1874	203603000
42735	1668	5726512000000
42736	1668	5726513000000
42737	1656	5901318000000
42738	1726	716511396000
42739	1874	203604000
42740	1693	5673393155041
42741	1693	5673394155041
42742	1656	5901319000000
42743	1726	716510395000
42744	1874	203605000
42745	679	66720001000000
42746	1506	2880971967172
42747	1506	2880972967172
42748	1726	716509394000
42749	1874	203606000
42750	1693	4953532155041
42751	1726	716508393000
42752	1874	203607000
42753	1726	716507392000
42754	1874	203608000
42755	1601	5978483600000
42756	1601	5978485600000
42757	1513	18720575000000
42758	1513	18720577000000
42759	1726	716506391000
42760	1874	203609000
42761	1688	49321291904000
42762	1688	49321292904000
42763	1759	3600566999999
42764	1759	3600567999999
42765	1726	716505390000
42766	1874	203610000
42767	641	68061357200000
42768	1090	906795935800000
42769	641	67787815600000
42770	970	506026562600000
42771	641	66866252400000
42772	1336	1704926102951650
42773	641	66535460000000
42774	1210	611833516400000
42775	1679	20717402711000
42776	1679	20717442711000
42777	1726	716504389000
42778	1874	203611000
42779	1726	716503388000
42780	1874	203612000
42781	1726	716502387000
42782	1874	203613000
42783	1724	4269292000000
42784	1724	4269335000000
42785	1677	61849081325000
42786	1677	61849124325000
42787	532	66720000000000
42788	532	66720043000000
42789	641	67255460000000
42790	1726	716501386000
42791	1874	203614000
42792	1726	715291386000
42793	2054	200000000
42794	641	67255474000000
42795	1726	715290385000
42796	1874	203615000
42797	1677	61849082325000
42798	1726	715289384000
42799	1874	203616000
42800	1593	24480879000000
42801	1726	715288383000
42802	1874	203617000
42803	1727	5226689000000
42804	1727	5226690000000
42805	1726	715287382000
42806	1874	203618000
42807	1726	715286381000
42808	1874	203619000
42809	1706	4532092600135
42810	1448	2916666000001
42811	1726	715285380000
42812	1874	203620000
42813	1549	30960788000000
42814	1549	30960789000000
42815	1726	715284379000
42816	1874	203621000
42817	633	70923893900000
42818	633	70923894900000
42819	1681	6983114759830
42820	1681	6983115759830
42821	1726	715283378000
42822	1874	203622000
42823	1726	715282377000
42824	1874	203623000
42825	1690	84242594000000
42826	1690	84242596000000
42827	1726	715281376000
42828	1874	203624000
42829	1677	62569082325000
42830	1677	62569083325000
42839	1726	715278373000
42840	1874	203627000
42841	1683	145874380149541
42842	1683	145874381149541
42858	1564	5586288000000
42859	1564	5586290000000
42866	1686	15097674705523
42867	1771	304915534083
42868	1686	14866263563482
42869	195	66300806891531
42870	1726	715271366000
42871	1874	203634000
42872	1726	715270365000
42873	1874	203635000
42874	1426	20160834000000
42875	1426	20160856000000
42886	1677	63289083325000
42887	1677	63289094325000
42889	1686	9716663827101
42890	1143	905077098931514
42891	1686	7586804916122
42892	1263	610673553584273
42893	1726	715267362000
42894	1874	203638000
42895	1677	63289104325000
42904	470	71760293000000
42905	470	71760304000000
42909	1726	715265360000
42910	1874	203640000
42911	470	71760305000000
42928	1684	8611231880623
42929	1684	8611232880623
42932	1726	715260355000
42933	1874	203645000
42934	1668	6446513000000
42935	1668	6446514000000
42980	1726	715251346000
42981	1874	203654000
42989	1726	715248343000
42990	1874	203657000
42991	1705	5358891500145
42994	1637	137524129819997
42995	1637	137524130819997
43006	1677	64009084325000
43007	1677	64009085325000
43028	1656	6621322000000
43033	1726	715236331000
43034	1874	203669000
43035	1726	715235330000
43036	1874	203670000
43037	1683	153074416149541
43038	1683	153074418149541
43049	1634	23738831223333
43050	13	4672715676666
43051	1634	23727961050489
43052	19	2336860172844
43053	1634	23419794812544
43054	203	66308156237945
43055	1634	23111628574599
43056	241	66308156237945
43057	1634	22803462336654
43058	313	66308156237945
43059	1634	20517008110328
43060	965	505064219226326
43061	1634	16419709647008
43062	1085	905070753463320
43063	1634	13655177476572
43064	1205	610669272170436
43065	1634	5951580641004
43066	1331	1701684224587218
43067	1726	715232327000
43068	1874	203673000
43069	1726	715231326000
43070	1874	203674000
43071	1610	2880173000000
43080	1594	7105034000000
43100	1467	24482359100000
43113	1726	715216311000
43114	1874	203689000
43115	1716	5806639000000
43116	1716	5806640000000
43133	1726	714002307000
43134	1874	203693000
43135	1726	714001306000
43136	1874	203694000
43137	1688	50761293904000
43138	1688	50761295904000
43164	1726	712786301000
43165	1874	203699000
43166	1992	6479142990000
43167	1992	6479143990000
43178	1726	712782297000
43179	1874	203703000
43180	1607	6018205644388
43196	1726	712779294000
43197	1874	203706000
43198	1683	157394423149541
43199	1683	157394424149541
43201	1726	712778293000
43202	1874	203707000
43203	1649	19440854999992
43204	1649	19440855999992
43240	1726	712770285000
43241	1874	203715000
43242	1683	160274436149541
43253	1593	24480890000000
43254	1593	25200890000000
43286	1726	712759274000
43287	1874	203726000
43288	1689	2160062287614
43302	1726	712756271000
43303	1874	203729000
43304	1726	712755270000
43305	1874	203730000
43306	1546	5040613000000
43307	1546	5040615000000
43318	1726	712751266000
43319	1874	203734000
43320	1573	23760811000000
43343	1726	712743258000
43344	1874	203742000
43345	1588	21600735000000
43346	1588	21600736000000
43355	1726	712740255000
43356	1874	203745000
43357	1692	44660551019999
43358	1692	44660552019999
43361	1726	712738253000
43362	1874	203747000
43363	1689	2880062287614
43364	1689	2880063287614
43372	1726	712736251000
43373	1874	203749000
43374	1444	4894956160000
43375	1444	4894957160000
43378	1726	712735250000
43379	1874	203750000
43394	1726	712730245000
43395	1874	203755000
43406	1726	712726241000
43407	1874	203759000
43408	633	71643894900000
43409	633	71643895900000
43414	1726	712724239000
43415	1874	203761000
43416	1623	37442295899898
43417	1623	37442296899898
43428	1673	28846680000000
43431	1683	167474450149541
43432	1683	167474451149541
43439	171	71030274524688
43440	171	71030275524688
43442	1726	712718233000
43443	1874	203767000
43444	1726	712717232000
43445	1874	203768000
43446	1726	712716231000
43447	1874	203769000
43448	1683	168914451149541
43449	1683	168914454149541
43479	1683	170354454149541
43480	1683	170354455149541
43491	1573	23750809000000
43492	1072	900973465000000
43493	1573	23745808000000
43494	1192	607904750000000
43495	1573	23740807000000
43496	952	502777775000000
43497	1573	13421806000000
43498	1458	8733509908540
43499	1458	8753514908540
43520	1684	8611235880623
43527	1476	4320055000000
43569	1703	1440572000000
43572	1726	712690205000
43573	1874	203795000
43574	1637	138964131819997
43575	1637	138964132819997
43577	1726	712689204000
43578	1874	203796000
43579	1764	3606742100000
42831	1726	715280375000
42832	1874	203625000
42833	1622	16559432999976
42834	1622	16559433999976
42843	1476	4320053000000
42844	1476	4320054000000
42850	1692	42500546019999
42851	1692	42500548019999
42860	1726	715273368000
42861	1874	203632000
42862	1726	715272367000
42863	1874	203633000
42864	1555	17280374000000
42865	1555	17280376000000
42876	1686	14634852421441
42877	291	66300806891531
42878	1726	715269364000
42879	1874	203636000
42880	1670	5040733000000
42921	1726	715262357000
42922	1874	203643000
42923	1474	3984366000023
42936	1622	17279433999976
42937	1622	17279434999976
42944	532	66720002000000
42950	1726	715257352000
42951	1874	203648000
42952	1440	5039072000000
42953	1440	5039073000000
42962	1726	715254349000
42963	1874	203651000
42964	1559	5002583000000
42966	1692	43940550019999
42967	1692	43940551019999
42974	1726	715253348000
42975	1874	203652000
42982	1726	715250345000
42983	1874	203655000
42984	1726	715249344000
42985	1874	203656000
42986	1694	5772347127629
42998	1726	715245340000
42999	1874	203660000
43000	115	66720001000000
43008	532	66720001000000
43039	1726	715234329000
43040	1874	203671000
43041	1402	88563684000000
43043	1726	715233328000
43044	1874	203672000
43045	1422	4464970860211
43046	1422	4464971860211
43072	1726	715230325000
43073	1874	203675000
43081	606	70699721812962
43101	1637	138244130819997
43102	1637	138244135819997
43127	1683	155954422149541
43128	1683	155954423149541
43139	1726	714000305000
43140	1874	203695000
43141	1727	5946690000000
43142	1727	5946691000000
43145	1726	713999304000
43146	1874	203696000
43147	1688	51481295904000
43148	1688	51481296904000
43153	1489	23760743000000
43154	1489	23760744000000
43162	1719	1460240000000
43163	1719	1460251000000
43168	1992	6479232990000
43169	1726	712785300000
43170	1874	203700000
43171	1726	712784299000
43172	1874	203701000
43173	58	70986267999659
43181	1690	84962596000000
43182	1690	84962597000000
43190	1654	7487919000000
43191	1654	7487931000000
43200	1741	719001000000
43205	1688	52201296904000
43206	1688	52201297904000
43209	1555	11724703786361
43210	1101	904077143489721
43211	1726	712777292000
43212	1874	203708000
43213	1683	158834424149541
43214	1683	158834435149541
43225	1555	9630580064175
43226	1221	609998863722186
43227	1726	712773288000
43228	1874	203712000
43229	1726	712772287000
43230	1874	203713000
43231	1657	21601246000000
43243	1555	3795135979096
43244	1347	1699816071836729
43245	1696	18719017000000
43246	2052	200000001
43247	1696	19439016999999
43267	1689	2160061287614
43268	1689	2160065287614
43270	1726	712764279000
43271	1874	203721000
43272	1643	4176366113700
43280	1726	712761276000
43281	1874	203724000
43289	1726	712758273000
43290	1874	203727000
43291	1726	712757272000
43292	1874	203728000
43293	1458	8013509908540
43321	1726	712750265000
43322	1874	203735000
43323	1726	712749264000
43324	1874	203736000
43325	1649	19440856999992
43327	1726	712748263000
43328	1874	203737000
43329	1683	164594448149541
43330	1683	164594449149541
43337	1726	712745260000
43338	1874	203740000
43339	43	69600492890000
43340	43	69600493890000
43365	1637	138244131819997
43366	1726	712737252000
43367	1874	203748000
43368	1608	6765500000000
43369	1608	6765501000000
43384	1726	712733248000
43385	1874	203752000
43386	1726	712732247000
43387	1874	203753000
43388	1709	1440020000000
43389	1709	1440022000000
43396	1726	712729244000
43397	1874	203756000
43398	1683	166034449149541
43399	1683	166034450149541
43410	1726	712725240000
43411	1874	203760000
43412	1599	20160521996199
43413	1599	20160522996199
43420	1726	712723238000
43421	1874	203762000
43422	1726	712722237000
43423	1874	203763000
43424	1726	712721236000
43425	1874	203764000
43426	1506	3600972967172
43427	1506	3600975967172
43429	1726	712720235000
43430	1874	203765000
43475	1726	712709224000
43476	1874	203776000
43477	1689	3600064287614
43478	1689	3600065287614
43481	1726	712708223000
43482	1874	203777000
43483	1729	8206900000000
43484	1729	8206901000000
43500	1726	712706221000
43501	1874	203779000
43502	1726	712705220000
43503	1874	203780000
43512	1726	712704219000
43513	1874	203781000
43514	1593	25920911000000
43515	1593	25940931000000
43521	1726	712702217000
43522	1874	203783000
43523	1726	712701216000
43524	1874	203784000
43525	1610	4320176000000
43526	1610	4320178000000
43528	1726	712700215000
43529	1874	203785000
43530	1688	54361301904000
43539	1726	712697212000
43540	1874	203788000
43541	1726	712696211000
43542	1874	203789000
42835	1726	715279374000
42836	1874	203626000
42837	1692	41780545019999
42838	1692	41780546019999
42852	1726	715275370000
42853	1874	203630000
42854	1726	715274369000
42855	1874	203631000
42856	1679	21437442711000
42857	1679	21437444711000
42888	1513	18720586000000
42896	1683	147314381149541
42897	1683	147314402149541
42930	1729	6766898000000
42931	1729	6766899000000
42938	171	69590271524688
42939	171	69590272524688
42945	1724	4269294000000
42954	1726	715256351000
42955	1874	203649000
42956	1726	715255350000
42957	1874	203650000
42958	2055	719000000000
42959	2055	719002000000
42965	1677	63289084325000
42976	1726	715252347000
42977	1874	203653000
42978	1688	50041292904000
42979	1688	50041293904000
42992	1726	715247342000
42993	1874	203658000
43003	1726	715244339000
43004	1874	203661000
43009	1726	715243338000
43010	1874	203662000
43011	1683	150194413149541
43012	1683	150194414149541
43029	1726	715237332000
43030	1874	203668000
43031	365	66720000000000
43032	365	66720001000000
43047	369	91200723000000
43048	369	91200724000000
43074	1726	715229324000
43075	1874	203676000
43076	1726	715228323000
43077	1874	203677000
43078	1768	3470622110000
43079	1768	3470624110000
43117	1726	714006311000
43118	2056	200000000
43119	1726	714005310000
43120	1874	203690000
43121	1508	20160526000000
43122	1508	20160537000000
43143	1759	4320567999999
43144	1759	4320568999999
43149	1726	713998303000
43150	1874	203697000
43151	1656	7341321999990
43152	1656	7341322999990
43174	1613	2807681600000
43175	1613	2807683600000
43176	1726	712783298000
43177	1874	203702000
43192	1555	14108390276082
43193	1654	6768493000000
43194	1654	7488493000000
43195	1654	7488590000000
43215	1726	712776291000
43216	1874	203709000
43217	1726	712775290000
43218	1874	203710000
43219	1726	712774289000
43220	1874	203711000
43221	1610	3600173000000
43222	1610	3600176000000
43232	1726	712771286000
43233	1874	203714000
43234	1439	5332277998477
43235	1439	5332278998477
43269	1455	2193915000000
43273	1726	712763278000
43274	1874	203722000
43275	1726	712762277000
43276	1874	203723000
43277	1739	17279614000000
43308	1726	712754269000
43309	1874	203731000
43310	1755	2876950000000
43311	1755	2876951000000
43326	1692	43940552019999
43331	1726	712747262000
43332	1874	203738000
43333	1726	712746261000
43334	1874	203739000
43335	1688	52921297904000
43336	1688	52921299904000
43341	1726	712744259000
43342	1874	203741000
43347	1726	712742257000
43348	1874	203743000
43349	1729	7486899000000
43350	1729	7486900000000
43359	1726	712739254000
43360	1874	203746000
43380	1726	712734249000
43381	1874	203751000
43382	1688	53641299904000
43383	1688	53641300904000
43390	1726	712731246000
43391	1874	203754000
43392	1677	64729085325000
43393	1677	64729086325000
43400	1726	712728243000
43401	1874	203757000
43402	1726	712727242000
43403	1874	203758000
43404	1677	65449086325000
43405	1677	65449088325000
43418	1692	45380552019999
43419	1692	45380553019999
43433	1726	712719234000
43434	1874	203766000
43435	1593	25200879000000
43436	1593	25200911000000
43450	1679	23597449711000
43474	1764	2886742100000
43533	1726	712699214000
43534	1874	203786000
43535	1726	712698213000
43536	1874	203787000
43537	1602	5760352000000
43538	1602	5760354000000
43547	1422	5184971860211
43548	1422	5204976860211
43553	1422	5184972860211
43557	1726	712694209000
43558	1874	203791000
43559	1739	17999614000000
43560	1739	17999615000000
43576	1688	55081302904000
43581	1726	712688203000
43582	1874	203797000
43583	1726	712687202000
43584	1874	203798000
43593	1560	5634100277001
43598	1726	712683198000
43599	1874	203802000
43611	1683	174674457149541
43612	1683	174674458149541
43615	1726	712680195000
43616	1874	203805000
43617	1726	712679194000
43618	1874	203806000
43619	1705	6078891500145
43620	1705	6078893500145
43638	1726	712675190000
43639	1874	203810000
43640	1700	6065861276737
43661	1726	712668183000
43662	1874	203817000
43663	1693	7113395155041
43664	1693	7113396155041
43667	360	66720000000000
43668	360	66720001000000
43687	1439	5352547998467
43688	1439	6072547998467
43689	1571	6072598998459
43690	1439	15840301001008
43691	1439	4632310998477
43692	1439	5352310998477
43693	1527	5352355998478
43694	1439	250999999
43705	1726	712657172000
43706	1874	203828000
43707	1471	25200533000000
43708	1471	25200534000000
43717	1726	712656171000
43718	1874	203829000
43719	1726	712655170000
43720	1874	203830000
43721	1656	8061324999990
43722	1656	8061326999990
43723	1726	712654169000
42845	1726	715277372000
42846	1874	203628000
42847	1726	715276371000
42848	1874	203629000
42849	1608	6045500000000
42881	1686	12873315312881
42882	1023	505067760241128
42883	1726	715268363000
42884	1874	203637000
42885	1474	3984376000023
42898	1686	1651781550062
42899	1389	1701696155127528
42900	1726	715266361000
42901	1874	203639000
42902	1683	148754402149541
42903	1683	148754413149541
42906	1723	5399499085979
42907	1723	6119499085979
42908	1723	6119581085979
42912	1737	1299001100
42913	632	88320695000000
42914	632	88320697000000
42915	1726	715264359000
42916	1874	203641000
42917	1726	715263358000
42918	1874	203642000
42919	1692	43220548019999
42920	1692	43220550019999
42924	1726	715261356000
42925	1874	203644000
42926	1694	5772345127629
42927	1694	5772346127629
42940	1726	715259354000
42941	1874	203646000
42942	1726	715258353000
42943	1874	203647000
42946	42	86878557000000
42947	42	87598557000000
42948	42	150000000
42949	1501	87598569000000
42960	1672	4320934000000
42961	1672	4320936000000
42968	1559	4282992000000
42969	1704	65194000000
42970	1559	5002992000000
42971	1559	3599070000000
42972	1440	5003274999976
42973	1571	15840301001024
42987	171	70310272524688
42988	171	70310274524688
42996	1726	715246341000
42997	1874	203659000
43001	1717	2987753000023
43002	1717	2987754000023
43005	1724	4269293000000
43013	1726	715242337000
43014	1874	203663000
43015	1726	715241336000
43016	1874	203664000
43017	1683	151634414149541
43018	1683	151634416149541
43019	1726	715240335000
43020	1874	203665000
43021	1726	715239334000
43022	1874	203666000
43023	1726	715238333000
43024	1874	203667000
43025	1656	5901322000000
43026	1988	190000010
43027	1656	6621321999990
43042	369	91200892000000
43082	1726	715227322000
43083	1874	203678000
43084	1726	715226321000
43085	1874	203679000
43086	43	68880490890000
43087	43	68880492890000
43088	1726	715225320000
43089	1874	203680000
43090	1726	715224319000
43091	1874	203681000
43092	1726	715223318000
43093	1874	203682000
43094	1726	715222317000
43095	1874	203683000
43096	1726	715221316000
43097	1874	203684000
43098	1679	22157444711000
43099	1679	22157449711000
43103	1726	715220315000
43104	1874	203685000
43105	1726	715219314000
43106	1874	203686000
43107	1726	715218313000
43108	1874	203687000
43109	1726	715217312000
43110	1874	203688000
43111	1683	154514418149541
43112	1683	154514422149541
43123	1726	714004309000
43124	1874	203691000
43125	58	70986265999659
43126	58	70986266999659
43129	1726	714003308000
43130	1874	203692000
43131	1457	5664171040000
43132	1457	5664172040000
43155	1691	3563013100019
43156	1691	3563014100019
43157	1726	712788303000
43158	2057	200000000
43159	1726	712787302000
43160	1874	203698000
43161	2039	3601036000000
43183	1555	14828392276082
43184	981	504509746723918
43185	1726	712781296000
43186	1874	203704000
43187	1726	712780295000
43188	1874	203705000
43189	1587	4320276000000
43207	1623	36722294899898
43208	1623	36722295899898
43223	1683	160274435149541
43224	1683	160274438149541
43236	1439	4612377998477
43237	1439	5332377998477
43238	1439	200000012
43239	1786	5332470998467
43248	1726	712769284000
43249	1874	203716000
43250	1696	18718968000000
43251	341	66001000000002
43252	1696	19438967999999
43255	1683	160274447149541
43256	1683	161714447149541
43257	1726	712768283000
43258	1874	203717000
43259	1726	712767282000
43260	1874	203718000
43261	1726	712766281000
43262	1874	203719000
43263	1726	712765280000
43264	1874	203720000
43265	1689	2160061287613
43266	1689	2160065287613
43278	1564	6306290000000
43279	1564	6306291000000
43282	1726	712760275000
43283	1874	203725000
43284	1683	163154447149541
43285	1683	163154448149541
43294	1555	11004701786361
43295	1555	8910578064175
43296	1555	3075133979096
43297	1807	7976452908523
43298	1458	200000002
43299	1571	15840301001016
43300	1458	8696452908523
43301	1458	8696491908523
43312	1726	712753268000
43313	1874	203732000
43314	1726	712752267000
43315	1874	203733000
43316	576	68675594938283
43317	576	68675596938283
43351	1726	712741256000
43352	1874	203744000
43353	1549	31680789000000
43354	1549	31680790000000
43370	1693	6393393155041
43371	1693	6393634155041
43376	1693	6393394155041
43377	1693	6393395155041
43437	1657	22321246000000
43438	1657	22321247000000
43441	1679	22877449711000
43451	1726	712715230000
43452	1874	203770000
43453	1726	712714229000
43454	1874	203771000
43455	1689	2880064287614
43456	1573	23755810000000
43457	1318	1693980637751650
43458	1726	712713228000
43459	1874	203772000
43460	1726	712712227000
43461	1874	203773000
43462	1573	17978809000000
43463	1072	906750465000000
43464	1573	14081808000000
43465	1192	611801750000000
43466	1573	11017807000000
43467	952	505841775000000
43468	1726	712711226000
43469	1874	203774000
43470	1726	712710225000
43471	1874	203775000
43472	1688	54361300904000
43473	1688	54366308904000
43485	1726	712707222000
43486	1874	203778000
43487	1573	698806000000
43488	1318	1704299637751650
43489	1677	66169088325000
43490	1677	66169090325000
43504	1573	23035809000000
43505	1573	23030808000000
43506	1573	23025807000000
43507	1573	23020806000000
43508	1573	12701805000000
43509	1458	9416491908523
43510	1655	9436482908515
43511	1458	25000000
43516	1726	712703218000
43517	1874	203782000
43518	1649	20160856999992
43519	1649	20160860999992
43531	1683	171794455149541
43532	1683	171794456149541
43545	1560	5634099277001
43546	1560	5634101277001
43549	1726	712695210000
43550	1874	203790000
43551	1670	5760733000000
43552	1670	5760734000000
43555	1715	26640425000000
43556	1715	26640426000000
43567	1702	2880215000000
43568	1702	2880217000000
43570	1726	712691206000
43571	1874	203794000
43594	1726	712684199000
43595	1874	203801000
43596	1588	22320736000000
43597	1588	22320737000000
43600	1683	173234456149541
43601	1683	173234457149541
43613	1623	38162296899898
43614	1623	38162297899898
43621	576	69395596938283
43622	576	69395598938283
43630	1726	712676191000
43631	1874	203809000
43632	1678	13680388822000
43633	1678	13680389822000
43636	686	67440010000000
43637	686	67440011000000
43647	58	71706267999659
43648	58	71706269999659
43665	1726	712667182000
43666	1874	203818000
43695	1726	712660175000
43696	1874	203825000
43697	1726	712659174000
43698	1874	203826000
43699	1710	7534509473290
43700	1710	7534511473290
43711	1677	66889090325000
43712	1677	66889091325000
43777	1419	6221038280064
43786	632	89040697000000
43787	632	89040698000000
43795	1726	712638153000
43796	1874	203847000
43801	1690	87122599000000
43802	1690	87122600000000
43803	1726	712637152000
43804	1874	203848000
43805	1622	17999434999976
43806	1622	17999435999976
43816	1726	712634149000
43817	1874	203851000
43818	2039	4321026000000
43819	2039	4321027000000
43823	1726	712633148000
43824	1874	203852000
43838	1726	712630145000
43839	1874	203855000
43840	1726	712629144000
43841	1874	203856000
43842	2058	585000000
43843	1769	1706900000
43844	1402	90723686000000
43845	1402	90723690000000
43850	1601	6698485600000
43851	1601	6698486600000
43874	1726	711411136000
43875	1874	203864000
43876	1699	6333910050108
43877	1699	6333911050108
43892	1683	178994460149541
43893	1683	178994463149541
43902	1573	2138807000000
43903	1573	2138808000000
43923	1675	3741921999977
43966	1726	711388113000
43967	1874	203887000
43968	1419	7661040280064
43969	1419	7661041280064
43996	1726	711380105000
43997	1874	203895000
43998	689	66720001000000
44000	1643	4896366113700
44001	1643	4896367113700
44017	1610	4320177000000
44022	1549	33120792000000
44023	1549	33120793000000
44028	1598	2880080000000
44065	1698	5576865550035
44077	1726	710150085000
44078	1874	203915000
44084	1677	71929103325000
44092	1724	4989292000000
44093	1724	4989294000000
44115	1726	710143078000
44116	1874	203922000
44119	1726	710142077000
44120	1874	203923000
44121	1683	184754470149541
44122	1683	184754471149541
44156	1726	708924069000
44157	1874	203931000
44158	1726	708923068000
44159	1874	203932000
44160	1726	708922067000
44161	1874	203933000
44162	1726	708921066000
44163	1874	203934000
44164	1596	6480173000000
44165	1596	6480177000000
44198	1726	708910055000
44199	1874	203945000
44200	1634	6671580641004
44201	1634	6671581641004
44215	1426	20880856000000
44216	1426	20880860000000
44217	1474	4104357000023
44218	1950	3949852000000
44219	1726	708905050000
44220	1874	203950000
44221	1649	20880870999992
44242	1726	708901046000
44243	1874	203954000
44257	1518	5760329000000
44270	1726	708893038000
44271	1874	203962000
44272	1688	57961315904000
44273	1688	57961316904000
44287	1726	708889034000
44288	1874	203966000
44302	1705	4960451500145
44303	994	505474640261745
44304	1513	18720606000000
44305	1726	708885030000
44306	1874	203970000
44307	1513	19440606000000
44308	1513	19440607000000
44317	1726	708882027000
44318	1874	203973000
44319	1724	5709294000000
44320	1724	5709295000000
44334	301	66720491000000
44345	1536	8640586000000
44346	1536	8640588000000
44350	1726	707665020000
44351	1874	203980000
44352	1726	707664019000
44353	1874	203981000
44354	1457	6384172040000
43543	1549	32400790000000
43544	1549	32400792000000
43554	1672	4320935000000
43561	1726	712693208000
43562	1874	203792000
43563	1726	712692207000
43564	1874	203793000
43565	1688	55081301904000
43566	1688	55081303904000
43585	1703	2160572000000
43586	1703	2160574000000
43587	1726	712686201000
43588	1874	203799000
43589	607	66720000000000
43590	607	66720001000000
43606	1726	712681196000
43607	1874	203804000
43608	1448	2916665000001
43627	1726	712677192000
43628	1874	203808000
43641	1775	916000000
43642	2047	0
43643	1726	712674189000
43644	1874	203811000
43645	1522	5374010000000
43646	1522	5374012000000
43649	1726	712673188000
43650	1874	203812000
43651	1726	712672187000
43652	1874	203813000
43653	470	71760295000000
43669	1726	712666181000
43670	1874	203819000
43671	1726	712665180000
43672	1874	203820000
43673	1775	905000000
43674	2047	10000000
43675	1775	884000000
43676	2047	30000000
43677	1726	712664179000
43678	1874	203821000
43679	1726	712663178000
43680	1874	203822000
43681	1726	712662177000
43682	1874	203823000
43683	641	67975474000000
43684	641	67975480000000
43709	58	72426269999659
43710	58	72426270999659
43737	1422	5924976860211
43738	1422	5924979860211
43743	1683	176114458149541
43744	1683	176114459149541
43749	1726	712648163000
43750	1874	203837000
43751	1690	85682597000000
43752	1690	85682598000000
43762	1726	712645160000
43763	1874	203840000
43764	1726	712644159000
43765	1874	203841000
43766	1637	139684132819997
43767	1637	139684134819997
43782	1726	712640155000
43783	1874	203845000
43784	1588	23040737000000
43785	1588	23040738000000
43825	1440	5039138000000
43826	1440	5759138000000
43827	1440	5759144000000
43832	1440	5059196000000
43833	1440	5779196000000
43834	1440	5779207000000
43846	1623	39602298899898
43847	1623	39602302899898
43866	2058	584000000
43867	1726	711413138000
43868	1874	203862000
43869	1677	66889092325000
43878	1726	711410135000
43879	1874	203865000
43880	1677	66889093325000
43881	1726	711409134000
43882	1874	203866000
43883	1677	67609093325000
43884	1677	67609094325000
43894	1726	711406131000
43895	1874	203869000
43896	1719	2900252000000
43897	1719	2900253000000
43910	1726	711403128000
43911	1874	203872000
43912	1726	711402127000
43913	1874	203873000
43914	1726	711401126000
43915	1874	203874000
43916	1649	20160859999992
43924	1509	5711727851155
43925	1509	5711729851155
43934	1726	711397122000
43935	1874	203878000
43936	1775	873000000
43937	2047	40000000
43938	1727	6666691000000
43939	1727	6666693000000
43942	1419	6941038280064
43943	1419	6941040280064
43951	1556	720052000000
43984	1950	3349852000000
43985	2027	1129000000000
43986	1726	711382107000
43987	1874	203893000
43988	1455	2913915000000
43989	1455	2913917000000
43992	1726	711381106000
43993	1874	203894000
43999	1677	69769099325000
44002	1726	711379104000
44003	1874	203896000
44004	1506	3600973967172
44005	1726	711378103000
44006	1874	203897000
44029	1726	710162097000
44030	1874	203903000
44031	1726	710161096000
44032	1874	203904000
44033	1679	24317451711000
44035	641	68695482000000
44039	1692	46100555019999
44040	1692	46100556019999
44043	1677	70489099325000
44044	1677	70489100325000
44051	1726	710156091000
44052	1874	203909000
44053	1599	20880522996199
44054	1599	20880523996199
44066	1649	20880859999992
44067	1649	20880862999992
44071	1726	710152087000
44072	1874	203913000
44079	1726	710149084000
44080	1874	203916000
44081	1691	4283014100019
44082	1691	4283015100019
44094	435	6526641990000
44095	1716	66000000030000
44111	1726	710144079000
44112	1874	203921000
44113	1683	183314469149541
44114	1683	183314470149541
44117	1419	8381041280064
44118	1419	8381042280064
44128	149	72750040000341
44129	149	72750041000341
44130	1726	708931076000
44131	2062	200000000
44132	1726	708930075000
44133	1874	203925000
44134	1610	4320187000000
44152	1623	39602303899898
44166	43	71040495890000
44188	1726	708913058000
44189	1874	203942000
44190	1726	708912057000
44191	1874	203943000
44192	1726	708911056000
44193	1874	203944000
44194	1622	18719435999976
44195	1622	18719438999976
44222	1726	708904049000
44223	1874	203951000
44224	1668	7166514000000
44225	1668	7166515000000
44228	1474	3384356000023
44229	1950	4079853000000
44230	641	67032818200000
44231	641	66908581600000
44232	641	66490019400000
44233	641	66339780000000
44234	1593	26661120000000
44235	1726	708903048000
44236	1874	203952000
44237	1593	27381120000000
44238	1593	27381165000000
44244	1709	2160022000000
43580	1764	3606743100000
43591	1726	712685200000
43592	1874	203800000
43602	1726	712682197000
43603	1874	203803000
43604	1536	7200584000000
43605	1536	7200585000000
43609	1684	9331235880623
43610	1684	9331236880623
43623	1726	712678193000
43624	1874	203807000
43625	1555	4515135979096
43626	1555	4515136979096
43629	1675	3741920999977
43634	1688	55801302904000
43635	1688	55801303904000
43654	1726	712671186000
43655	1874	203814000
43656	1726	712670185000
43657	1874	203815000
43658	1726	712669184000
43659	1874	203816000
43660	1656	7341324999990
43685	1726	712661176000
43686	1874	203824000
43701	1726	712658173000
43702	1874	203827000
43703	1693	7833396155041
43704	1693	7833397155041
43713	1764	4326743100000
43714	1764	4326744100000
43715	1718	3686679763340
43716	1718	3686680763340
43727	1726	712653168000
43728	1874	203832000
43729	1719	2180251000000
43730	1719	2180252000000
43753	1939	2150980000000
43754	1449	8053016459
43755	1726	712647162000
43756	1874	203838000
43757	1688	55801313904000
43768	1726	712643158000
43769	1874	203842000
43770	1447	10234474944000
43771	1447	10234475944000
43773	1714	8086236103056
43774	1714	8086237103056
43788	1522	5374011000000
43789	1726	712639154000
43790	1874	203846000
43791	1688	56521313904000
43792	1688	56521314904000
43797	1474	4704366000023
43798	1474	4704367000023
43807	1726	712636151000
43808	1874	203849000
43809	1726	712635150000
43810	1874	203850000
43811	1521	1000000
43812	2058	586000000
43813	1769	1708900000
43814	1637	140404134819997
43815	1637	140404138819997
43822	1671	3648220530515
43828	1726	712632147000
43829	1874	203853000
43830	1402	90003685000000
43831	1402	90003686000000
43835	1726	712631146000
43836	1874	203854000
43837	1769	1707900000
43848	1726	712628143000
43849	1874	203857000
43864	1726	711414139000
43865	1874	203861000
43898	1726	711405130000
43899	1874	203870000
43900	1547	4893224000000
43901	1547	4893225000000
43908	1706	5972093600135
43909	1706	5972094600135
43928	1677	68329094325000
43929	1677	68329096325000
43930	1726	711398123000
43931	1874	203877000
43932	1508	20880537000000
43933	1508	20880538000000
43946	1726	711396121000
43947	1874	203879000
43948	1726	711395120000
43949	1874	203880000
43950	1556	720002000000
43959	1726	711391116000
43960	1874	203884000
43961	1726	711390115000
43962	1874	203885000
43963	1726	711389114000
43964	1874	203886000
43965	1677	69049099325000
43972	1726	711386111000
43973	1874	203889000
43974	1726	711385110000
43975	1874	203890000
43982	43	70320493890000
43983	43	70320495890000
43990	1402	91443690000000
43991	1402	91443692000000
44013	1726	710165100000
44014	1874	203900000
44015	1688	57241314904000
44016	1688	57241315904000
44018	1726	710164099000
44019	1874	203901000
44020	1716	6526640000000
44021	1716	6526641000000
44034	641	68695480000000
44036	1726	710160095000
44037	1874	203905000
44038	1637	141124139819997
44045	1726	710158093000
44046	1874	203907000
44047	1726	710157092000
44048	1874	203908000
44049	1402	92163692000000
44050	1402	92163694000000
44057	1726	710155090000
44058	1874	203910000
44059	1726	710154089000
44060	1874	203911000
44061	1726	710153088000
44062	1874	203912000
44063	633	72363895900000
44064	633	72363898900000
44068	1698	5576868550035
44083	1508	21600538000000
44108	1726	710145080000
44109	1874	203920000
44110	1768	3470623110000
44125	1726	710141076000
44126	1874	203924000
44127	1649	20880860999992
44136	606	71419721812962
44137	606	71419732812962
44138	606	71419731812962
44151	1705	6078896500145
44153	1677	73369104325000
44154	1677	73369109325000
44171	43	71040496890000
44172	1726	708919064000
44173	1874	203936000
44174	1536	7920586000000
44187	1677	73369107325000
44213	1729	8926901000000
44214	1729	8926905000000
44226	1623	41042304899898
44227	1623	41042305899898
44253	1518	5760292000000
44254	1518	5760295000000
44313	1726	708883028000
44314	1874	203972000
44315	1679	25037452711000
44316	1679	25037453711000
44322	1726	708881026000
44323	1874	203974000
44324	1726	708880025000
44325	1874	203975000
44326	1726	707670025000
44327	2063	200000000
44328	1683	191954574149541
44329	1683	191954586149541
44339	1726	707667022000
44340	1874	203978000
44341	1726	707666021000
44342	1874	203979000
44343	1423	1473197999985
44344	1423	1473199999985
44377	1726	707658013000
44378	1874	203987000
44379	1677	75529128325000
44380	1677	75529129325000
44388	1715	26640436000000
44407	1719	3620253000000
44408	1719	3620254000000
44409	1726	707653008000
43724	1874	203831000
43725	1447	9514473944000
43726	1447	9514474944000
43731	1726	712652167000
43732	1874	203833000
43733	1726	712651166000
43734	1874	203834000
43735	1555	5235136979096
43736	1555	5235138979096
43739	1726	712650165000
43740	1874	203835000
43741	1680	4329270500035
43742	1680	4329271500035
43745	1726	712649164000
43746	1874	203836000
43747	1706	5252092600135
43748	1706	5252093600135
43758	1726	712646161000
43759	1874	203839000
43760	1690	86402598000000
43761	1690	86402599000000
43772	1723	5399070085979
43775	1726	712642157000
43776	1874	203843000
43778	1726	712641156000
43779	1874	203844000
43780	1683	177554459149541
43781	1683	177554460149541
43793	1402	89283684000000
43794	1402	89283685000000
43799	1596	5760172000000
43800	1596	5760173000000
43820	1623	38882297899898
43821	1623	38882298899898
43852	1593	25940968000000
43853	1726	712627142000
43854	1874	203858000
43855	1726	711417142000
43856	2060	200000000
43857	1726	711416141000
43858	1874	203859000
43859	1593	26660968000000
43860	1593	26661036000000
43861	1726	711415140000
43862	1874	203860000
43863	1690	87122612000000
43870	1726	711412137000
43871	1874	203863000
43872	1573	1418806000000
43873	1573	1418807000000
43885	1726	711408133000
43886	1874	203867000
43887	1726	711407132000
43888	1874	203868000
43889	2058	583000000
43890	1679	24317449711000
43891	1679	24317452711000
43904	1726	711404129000
43905	1874	203871000
43906	1683	180434463149541
43907	1683	180434464149541
43917	1726	711400125000
43918	1874	203875000
43919	1726	711399124000
43920	1874	203876000
43921	1723	6119070085979
43922	1723	6119072085979
43926	1555	5955138979096
43927	1555	5955140979096
43940	1677	69049096325000
43941	1677	69049098325000
43944	1556	20256000000
43945	1556	740255999999
43952	1726	711394119000
43953	1874	203881000
43954	1726	711393118000
43955	1874	203882000
43956	1726	711392117000
43957	1874	203883000
43958	1692	45380555019999
43970	1726	711387112000
43971	1874	203888000
43976	1726	711384109000
43977	1874	203891000
43978	1726	711383108000
43979	1874	203892000
43980	1637	141124138819997
43981	1637	141124140819997
43994	149	72030039000341
43995	149	72030040000341
44007	1726	711377102000
44008	1874	203898000
44009	1726	711376101000
44010	1874	203899000
44011	1726	710166101000
44012	2061	200000000
44024	1726	710163098000
44025	1874	203902000
44026	1654	8207931000000
44027	1654	8207932000000
44041	1726	710159094000
44042	1874	203906000
44055	115	67440001000000
44056	115	67440002000000
44069	1677	71209100325000
44070	1677	71209103325000
44073	1726	710151086000
44074	1874	203914000
44075	1451	20160596000000
44076	1451	20160597000000
44085	1726	710148083000
44086	1874	203917000
44087	1726	710147082000
44088	1874	203918000
44089	1716	720000418000
44090	1420	6526641792000
44091	435	66000000030000
44096	1726	710146081000
44097	1874	203919000
44098	641	68472826200000
44099	1090	907018590600000
44100	641	68348589600000
44101	970	506150798200000
44102	641	67930027400000
44103	1336	1705344664151650
44104	641	67779788000000
44105	1210	611983754800000
44106	1683	181874464149541
44107	1683	181874469149541
44123	1677	72649103325000
44124	1677	72649104325000
44135	1610	4320186000000
44139	1726	708929074000
44140	1874	203926000
44141	1726	708928073000
44142	1874	203927000
44143	1726	708927072000
44144	1874	203928000
44145	1726	708926071000
44146	1874	203929000
44147	1726	708925070000
44148	1874	203930000
44149	1629	2160030000000
44150	1629	2160035000000
44155	1536	7920585000000
44167	1726	708920065000
44168	1874	203935000
44169	1683	186194470149541
44170	1683	186194471149541
44175	1726	708918063000
44176	1874	203937000
44177	1726	708917062000
44178	1874	203938000
44179	1739	18719615000000
44180	1739	18719617000000
44181	1726	708916061000
44182	1874	203939000
44183	1726	708915060000
44184	1874	203940000
44185	1726	708914059000
44186	1874	203941000
44196	1546	5760615000000
44197	1546	5760618000000
44202	1623	40322303899898
44203	1623	40322304899898
44204	1726	708909054000
44205	1874	203946000
44206	1726	708908053000
44207	1874	203947000
44208	1726	708907052000
44209	1874	203948000
44210	1726	708906051000
44211	1874	203949000
44212	1607	6018208644388
44239	1726	708902047000
44240	1874	203953000
44241	1687	11605407726450
44246	1726	708900045000
44247	1874	203955000
44248	1726	708899044000
44249	1874	203956000
44250	1726	708898043000
44251	1874	203957000
44252	1716	6526643000000
44258	1726	708897042000
44245	1709	2160023000000
44255	1683	187634471149541
44256	1683	187634474149541
44261	1726	708896041000
44262	1874	203959000
44263	1426	20880857000000
44274	2060	0
44275	1713	760000000
44276	1726	708892037000
44277	1874	203963000
44278	1683	189074472149541
44279	1683	189074573149541
44289	1726	708888033000
44290	1874	203967000
44291	1683	190514573149541
44292	1683	190514574149541
44309	1726	708884029000
44310	1874	203971000
44311	1710	8254511473290
44312	1710	8254512473290
44321	55	66720190000000
44330	1726	707669024000
44331	1874	203976000
44347	1423	773539999985
44348	1423	1493539999985
44349	1423	1493551999985
44356	1693	8553397155041
44357	1693	8553399155041
44364	1726	707662017000
44365	1874	203983000
44366	1677	74809127325000
44367	1677	74809128325000
44375	1513	20160607000000
44376	1513	20160610000000
44381	1471	15877523000000
44382	1386	1702583637751650
44383	1599	21600523996199
44384	1599	21600533996199
44401	1726	707654009000
44402	1874	203991000
44403	1724	6429295000000
44404	1724	6429296000000
44419	1764	5046744100000
44420	1764	5046745100000
44425	1508	20876716187700
44426	773	1003811812300
44427	1726	707650005000
44428	1874	203995000
44429	1726	707649004000
44430	1874	203996000
44431	484	91200742000000
44432	484	91200754000000
44477	1726	707640996000
44478	1874	204004000
44479	1677	77689131325000
44480	1677	77689132325000
44481	1726	707639995000
44482	1874	204005000
44483	1726	707638994000
44484	1874	204006000
44485	1726	707637993000
44486	1874	204007000
44487	369	91200726000000
44490	641	67752824200000
44491	641	67628587600000
44492	641	67210025400000
44493	641	67059786000000
44494	369	90481035000000
44495	369	91201035000000
44496	1420	210000000
44497	1799	720000319000
44498	435	91201128891000
44499	369	66000000030000
44504	1705	4456760500145
44505	1705	4391390500145
44506	1705	4294500500145
44507	1705	4240450500145
44508	1696	20159016999999
44509	646	190000020
44510	1988	66000004950000
44511	1696	8803473944000
44512	1447	20169495009977
44513	2052	700000000
44514	1996	200000002
44515	341	155000000
44516	1460	66001000000002
44519	1726	707635991000
44520	1874	204009000
44521	1637	142564141819997
44522	1637	142564142819997
44525	1726	707634990000
44526	1874	204010000
44527	1603	1440050000000
44528	1603	1440051000000
44531	1451	20159497000000
44532	759	1001000000000
44533	1426	14428847000000
44534	1364	1700432637751650
44535	1426	10996837000000
44536	1118	904405465000000
44537	1426	8680827000000
44538	1238	610220750000000
44539	1426	6764817000000
44540	998	504693775000000
44541	1726	707633989000
44542	1874	204011000
44543	1726	707632988000
44544	1874	204012000
44545	1692	46820586019999
44546	1692	46820728019999
44547	1726	707631987000
44548	1874	204013000
44556	149	73470041000341
44557	149	73470042000341
44563	1726	707627983000
44564	1874	204017000
44580	1726	707624980000
44581	1874	204020000
44582	1471	6379493000000
44583	1471	6379494000000
44618	1451	20158397000000
44619	1292	1693981637751650
44620	1726	707618974000
44621	1874	204026000
44622	1683	199154599149541
44623	1683	199154700149541
44645	1677	79129133325000
44646	1677	79129335325000
44649	1451	11557297000000
44650	1292	1702582637751650
44651	1726	707614970000
44652	1874	204030000
44653	1690	87842713000000
44687	1451	3892897000000
44688	1166	610992750000000
44689	1726	707607963000
44690	1874	204037000
44691	1596	7200177000000
44692	1596	7200278000000
44715	1726	707601957000
44716	1874	204043000
44717	1700	6785861276737
44718	1700	6785862276737
44721	1726	707600956000
44722	1874	204044000
44723	1683	203474902149541
44724	1683	203474903149541
44738	1687	2152459524804
44739	1686	2372984550062
44740	1686	3092984550062
44741	1686	3092989550062
44768	1768	4190623110000
44769	1768	4190627110000
44775	1726	707585941000
44776	1874	204059000
44777	1426	7484817000000
44778	1426	7484818000000
44785	1726	707583939000
44786	1874	204061000
44787	1560	7074201277001
44788	1560	7074202277001
44793	1726	707581937000
44794	1874	204063000
44795	1726	707580936000
44796	1874	204064000
44797	1422	5904972860211
44798	1422	5904974860211
44799	1677	79849134325000
44800	1677	79849136325000
44801	1696	16669374260000
44802	938	505546858740000
44803	1726	707579935000
44804	1874	204065000
44805	1726	707578934000
44806	1874	204066000
44807	1726	707577933000
44808	1874	204067000
44809	1991	4075115441475
44810	1991	4075618441475
44812	1726	707576932000
44813	1874	204068000
44814	1426	8204818000000
44815	1426	8204819000000
44828	1726	707573929000
44829	1874	204071000
44259	1874	203958000
44260	1683	187634472149541
44264	1726	708895040000
44265	1874	203960000
44266	1726	708894039000
44267	1874	203961000
44268	1637	141844139819997
44269	1637	141844141819997
44280	1705	5176761500145
44281	1360	1703067102686953
44282	1726	708891036000
44283	1874	203964000
44284	1726	708890035000
44285	1874	203965000
44286	1677	73369126325000
44293	1705	5111391500145
44294	1234	611165531836822
44295	1705	5014501500145
44296	1114	905806273145245
44297	1726	708887032000
44298	1874	203968000
44299	1726	708886031000
44300	1874	203969000
44301	1698	5576907550035
44332	1549	33840793000000
44333	1549	33840794000000
44335	1726	707668023000
44336	1874	203977000
44337	1677	74089126325000
44338	1677	74089127325000
44358	1683	193394586149541
44359	1683	193394588149541
44385	1726	707657012000
44386	1874	203988000
44387	1599	21600534996199
44405	1683	194834587149541
44406	1683	194834588149541
44433	1508	18962421650738
44434	1021	504692059536962
44435	1508	15532030162099
44436	1141	904403846488639
44437	1508	13217473416525
44438	1261	610219296745574
44439	1726	707648003000
44440	1874	203997000
44441	1692	46100586019999
44448	1719	3620264000000
44468	1726	707642998000
44469	1874	204002000
44471	1690	87842612000000
44472	1690	87842613000000
44488	1457	7104174040000
44489	1457	7104177040000
44523	1683	196274588149541
44524	1683	196274589149541
44529	1637	143284142819997
44530	1637	143284143819997
44565	1726	707626982000
44566	1874	204018000
44567	1726	707625981000
44568	1874	204019000
44569	1739	19439617000000
44570	1739	19439619000000
44584	1726	707623979000
44585	1874	204021000
44588	1726	707622978000
44589	1874	204022000
44606	1726	707621977000
44607	1874	204023000
44608	1691	5003015100019
44609	1691	5003016100019
44624	1866	9331032615274
44625	481	66278185530567
44626	1866	9327244264194
44627	734	2008429864511
44628	1866	8269816948451
44629	845	575749894374107
44630	1866	7212389632708
44631	846	575749894374107
44632	1866	6233772723170
44633	936	505014385078944
44634	1866	4480178805218
44635	1056	904981451098176
44636	1866	3296961517936
44637	1176	610609018085216
44638	1302	1701516321221218
44639	1726	707617973000
44640	1874	204027000
44641	1726	707616972000
44642	1874	204028000
44643	633	72364697900000
44654	1726	707613969000
44655	1874	204031000
44656	1467	25202355100000
44657	1467	25202356100000
44660	1451	11556197000000
44661	1046	900974465000000
44662	1726	707612968000
44663	1874	204032000
44664	1448	2916765000001
44681	1690	88562713000000
44682	1690	88562825000000
44693	1726	707606962000
44694	1874	204038000
44695	631	66720500000000
44696	631	66720501000000
44719	1402	92883694000000
44720	1402	92883695000000
44725	1719	4340264000000
44726	1719	4340265000000
44729	1726	707599955000
44730	1874	204045000
44731	1726	707598954000
44732	1874	204046000
44733	1705	5680451500145
44734	1705	5680453500145
44742	1726	707596952000
44743	1874	204048000
44744	1726	707595951000
44745	1874	204049000
44746	1980	12239147000000
44747	1980	12239149000000
44770	1637	144004143819997
44771	1637	144004147819997
44779	149	74190042000341
44780	149	74190043000341
44784	1637	144724143819997
44811	1723	6119573085979
44816	1726	707575931000
44817	1874	204069000
44831	1726	707572928000
44832	1874	204072000
44833	1726	707571927000
44834	1874	204073000
44835	1402	93603695000000
44836	1402	93603697000000
44838	1447	10954476944000
44857	1726	707564920000
44858	1874	204080000
44865	1637	144724144819997
44881	1726	707557913000
44882	1874	204087000
44883	1726	707556912000
44884	1874	204088000
44885	1726	707555911000
44886	1874	204089000
44887	1594	7825034000000
44888	1594	7825037000000
44921	1726	707550906000
44922	1874	204094000
44931	1594	8545037000000
44932	1594	8545038000000
44941	1726	707545901000
44942	1874	204099000
44943	470	72480295000000
44944	470	72480296000000
44977	1709	2880023000000
44978	1709	2880025000000
44981	1726	706324890000
44982	1874	204110000
44983	1726	706323889000
44984	1874	204111000
44985	1451	2058697000000
44986	1451	2058699000000
45015	1610	5040187000000
45016	1610	5040188000000
45025	1739	20159619000000
45026	1739	20159620000000
45027	576	70835599938283
45028	576	70835600938283
45033	1709	3600025000000
45034	1709	3600026000000
45046	1677	82729141325000
45048	1726	706312878000
45049	1874	204122000
45050	1726	706311877000
45051	1874	204123000
45052	1402	95043697000000
45053	1402	95043699000000
45058	1692	49702241019999
45060	1402	96483699000000
45061	1402	97203699000000
45064	1657	23041247000000
45065	1677	82729140325000
45072	1402	97923699000000
44355	1457	6384174040000
44360	1692	46100557019999
44361	1726	707663018000
44362	1874	203982000
44363	1683	193394587149541
44368	1726	707661016000
44369	1874	203984000
44370	1726	707660015000
44371	1874	203985000
44372	1726	707659014000
44373	1874	203986000
44374	1549	33840796000000
44389	1471	11301513000000
44390	1140	905549465000000
44391	1471	8213503000000
44392	1260	610992750000000
44393	1471	5659493000000
44394	1020	505331775000000
44395	1726	707656011000
44396	1874	203989000
44397	1726	707655010000
44398	1874	203990000
44399	1992	7199143990000
44400	1992	7199175990000
44413	1607	6738208644388
44414	1607	6738209644388
44415	1726	707652007000
44416	1874	203993000
44417	1711	4124456000000
44418	1711	4124457000000
44421	1726	707651006000
44422	1874	203994000
44423	1677	76249129325000
44424	1677	76249130325000
44442	1508	6767773111964
44443	1387	1700430328056211
44444	1726	707647002000
44445	1874	203998000
44446	1694	6492346127629
44447	1694	6492357127629
44459	1686	2371781550062
44460	1686	2371794550062
44462	1726	707643999000
44463	1874	204001000
44464	1688	58681316904000
44465	1688	58681317904000
44517	1677	78409132325000
44518	1677	78409133325000
44549	1683	197714588149541
44550	1683	197714589149541
44551	1726	707630986000
44552	1874	204014000
44553	1991	3355115441475
44554	1726	707629985000
44555	1874	204015000
44590	1451	18719495000000
44591	1649	17524846999992
44592	1649	15208836999992
44593	1649	11776826999992
44594	1649	5323816999992
44595	1458	8753774908540
44596	1508	20156715187700
44597	1508	18242420650738
44598	1508	14812029162099
44599	1508	12497472416525
44600	1426	13708846000000
44601	1426	10276836000000
44602	1426	7960826000000
44603	1508	6047772111964
44604	1458	9473774908540
44605	1458	9473854908540
44666	1683	200594700149541
44667	1683	200594801149541
44672	1451	6979997000000
44673	1166	607905750000000
44674	2062	180000000
44675	1713	770000000
44676	1726	707610966000
44677	1874	204034000
44678	1726	707609965000
44679	1874	204035000
44680	1522	5374122000000
44697	1451	3891797000000
44698	926	502778775000000
44699	1726	707605961000
44700	1874	204039000
44701	1683	202034801149541
44702	1683	202034902149541
44709	1726	707603959000
44710	1874	204041000
44711	1726	707602958000
44712	1874	204042000
44713	1980	11519145000000
44714	1980	11519147000000
44753	1726	707592948000
44754	1874	204052000
44755	1726	707591947000
44756	1874	204053000
44757	1447	10234476944000
44758	1726	707590946000
44759	1874	204054000
44760	1726	707589945000
44761	1874	204055000
44762	1726	707588944000
44763	1874	204056000
44764	1726	707587943000
44765	1874	204057000
44766	1679	25757453711000
44767	1679	25757457711000
44781	1726	707584940000
44782	1874	204060000
44783	1677	79129134325000
44789	1726	707582938000
44790	1874	204062000
44791	1711	5564458000000
44792	1711	5564459000000
44841	1726	707569925000
44842	1874	204075000
44843	1726	707568924000
44844	1874	204076000
44845	1768	4190625110000
44855	1759	5040569999999
44856	1759	5040570999999
44859	1726	707563919000
44860	1874	204081000
44861	1467	25922356100000
44862	1467	25922357100000
44866	1677	80569136325000
44867	1677	80569137325000
44872	1726	707560916000
44873	1874	204084000
44874	1726	707559915000
44875	1874	204085000
44876	1677	80569138325000
44895	1726	707553909000
44896	1874	204091000
44897	1726	707552908000
44898	1874	204092000
44899	1439	5332279998477
44927	1726	707549905000
44928	1874	204095000
44929	1601	7418487600000
44930	1601	7418488600000
44939	1726	707546902000
44940	1874	204098000
44953	1726	707542898000
44954	1874	204102000
44965	1726	706329895000
44966	131	66001200000000
44967	1726	706328894000
44968	1874	204106000
44969	1692	48982230019999
44970	1692	48982241019999
45000	1726	706320886000
45001	1874	204114000
45002	1684	10051236880623
45003	1684	10051237880623
45017	1683	206354905149541
45018	1683	206354906149541
45019	1726	706316882000
45020	1874	204118000
45021	1467	26642357100000
45022	1467	26642358100000
45029	1726	706315881000
45030	1874	204119000
45031	1729	9646902000000
45032	1729	9646903000000
45043	1688	59401320904000
45047	1677	83449141325000
45055	1654	9647933000000
45066	1649	18244849999992
45067	1649	15928839999992
45068	1649	12496829999992
45069	1649	6043819999992
45070	1518	6480329000000
45071	1518	6483728000000
45075	1681	7703115759830
45085	1455	3633916000000
45101	1698	6296907550035
45109	1268	994986000000
45110	1269	2000000
45111	1688	60121320904000
45112	1688	60121321904000
45135	1726	701468874000
45136	1874	204126000
44410	1874	203992000
44411	1444	5614957160000
44412	1444	5614958160000
44449	1508	6516183500009
44450	478	66251579611955
44451	1897	199000000
44452	1600	0
44453	1726	707646001000
44454	1874	203999000
44455	1726	707645000000
44456	1874	204000000
44457	58	73146270999659
44458	58	73146283999659
44461	1686	2371852550062
44466	1677	76969130325000
44467	1677	76969131325000
44470	1643	5616367113700
44473	1726	707641997000
44474	1874	204003000
44475	1687	12325407726450
44476	1687	12325408726450
44500	1726	707636992000
44501	1874	204008000
44502	1696	19438957000000
44503	1696	19438958000000
44558	301	66010481000000
44559	1474	4814357000023
44560	1726	707628984000
44561	1874	204016000
44562	1683	197714599149541
44571	1649	18964860999992
44572	1017	504693775000000
44573	1649	16648850999992
44574	1257	610220750000000
44575	1649	13216840999992
44576	1137	904405465000000
44577	1649	6763830999992
44578	1383	1700433637751650
44579	1675	3741959999977
44586	1520	720000000000
44587	1520	720001000000
44610	1687	2872460524804
44611	1866	9452848201646
44612	1726	707620976000
44613	1874	204024000
44614	1726	707619975000
44615	1874	204025000
44616	1623	41762305899898
44617	1623	41762407899898
44644	1672	4321736000000
44647	1726	707615971000
44648	1874	204029000
44658	1711	4844457000000
44659	1711	4844458000000
44665	1419	8381142280064
44668	1451	6981097000000
44669	1046	905549465000000
44670	1726	707611967000
44671	1874	204033000
44683	1726	707608964000
44684	1874	204036000
44685	1692	47540728019999
44686	1692	47540729019999
44703	1451	1338697000000
44704	926	505331775000000
44705	1726	707604960000
44706	1874	204040000
44707	1560	6354100277001
44708	1560	6354201277001
44727	576	70115598938283
44728	576	70115599938283
44735	1726	707597953000
44736	1874	204047000
44737	1686	2371782550062
44748	1726	707594950000
44749	1874	204050000
44750	1726	707593949000
44751	1874	204051000
44752	1601	6698487600000
44772	1726	707586942000
44773	1874	204058000
44774	1509	5711728851155
44818	1696	13899790520000
44819	1058	903742548740000
44820	1696	9358519180000
44821	1178	612445521340000
44822	1696	4817247840000
44823	1304	1698521409091650
44824	1726	707574930000
44825	1874	204070000
44826	1692	48260729019999
44827	1692	48262230019999
44837	149	74190044000341
44839	1726	707570926000
44840	1874	204074000
44851	1726	707565921000
44852	1874	204079000
44853	1654	8927932000000
44854	1654	8927933000000
44868	1726	707562918000
44869	1874	204082000
44870	1726	707561917000
44871	1874	204083000
44889	1726	707554910000
44890	1874	204090000
44891	1705	6400453500145
44892	1705	6400454500145
44923	1677	81289138325000
44924	1677	81289139325000
44936	1726	707547903000
44937	1874	204097000
44938	1729	8926902000000
44945	1726	707544900000
44946	1874	204100000
44947	1509	6431728851155
44948	1509	6431729851155
44949	1726	707543899000
44950	1874	204101000
44951	1637	145444144819997
44952	1637	145444145819997
44955	1726	707541897000
44956	1874	204103000
44957	1677	80569139325000
44958	1726	707540896000
44959	1874	204104000
44960	1677	81289140325000
44987	1688	59401317904000
44988	1688	59401319904000
44991	1402	94323697000000
44998	641	68499788000000
44999	641	68499790000000
45006	1726	706319885000
45007	1874	204115000
45008	1726	706318884000
45009	1874	204116000
45010	1708	17999717000000
45011	1708	17999719000000
45035	131	66001199000000
45036	1538	0
45037	1726	706314880000
45038	1874	204120000
45039	1726	706313879000
45040	1874	204121000
45041	1991	4795618441475
45042	1991	4795621441475
45054	1402	95763699000000
45057	75	66720000000000
45073	1637	146164145819997
45076	1611	20150853000000
45077	1458	10193854908540
45078	1447	10195454908540
45079	1458	8795473944000
45103	1656	8781326999990
45105	1546	5760634000000
45106	1546	6480634000000
45107	1546	6480653000000
45115	1683	209234906149541
45140	1726	701466872000
45141	1874	204128000
45142	1611	20870853000000
45143	1611	20870854000000
45160	1683	210674906149541
45161	1683	210674910149541
45166	1740	4841191000000
45168	1726	701459865000
45169	1874	204135000
45170	1671	5088222530515
45176	1703	2880574000000
45177	1703	2880575000000
45179	1397	1371433277000
45180	1678	12960388823000
45181	1726	701458864000
45182	1874	204136000
45183	1637	147604146819997
45184	1637	147604157819997
45201	1689	3600075287614
45215	1700	6785872276737
45266	1397	1371293263000
45267	1678	12960388837000
45268	1397	1371283262000
45269	1678	12960388838000
45270	1726	699024850000
45271	1874	204150000
45272	1726	699023849000
45273	1874	204151000
44830	633	72363896900000
44846	1726	707567923000
44847	1874	204077000
44848	1726	707566922000
44849	1874	204078000
44850	1759	4320569999999
44863	1710	8974512473290
44864	1710	8974513473290
44877	1726	707558914000
44878	1874	204086000
44879	1474	5534357000023
44880	1474	5534358000023
44893	1706	6692094600135
44894	1706	6692095600135
44900	1696	15949373260000
44901	1696	13179789520000
44902	1696	8638518180000
44903	1696	4097246840000
44904	1687	1432457524804
44905	1451	18718395000000
44906	1451	10117295000000
44907	1451	10116195000000
44908	1451	5541095000000
44909	1451	5539995000000
44910	1451	2452895000000
44911	1451	2451795000000
44912	1508	5796182500009
44913	1426	6044816000000
44914	1439	5355577998478
44915	1439	6075577998478
44916	1439	6075641998478
44917	1726	707551907000
44918	1874	204093000
44919	1671	4368220530515
44920	1671	4368221530515
44925	1690	89282825000000
44926	1690	89282826000000
44933	1726	707548904000
44934	1874	204096000
44935	1455	2913916000000
44961	1726	707539895000
44962	1874	204105000
44963	1547	5613225000000
44964	1547	5613226000000
44971	1726	706327893000
44972	1874	204107000
44973	1726	706326892000
44974	1874	204108000
44975	1587	5040276000000
44976	1587	5040278000000
44979	1726	706325891000
44980	1874	204109000
44989	1683	204914903149541
44990	1683	204914905149541
44992	1726	706322888000
44993	1874	204112000
44994	1726	706321887000
44995	1874	204113000
44996	1670	6480734000000
44997	1670	6480736000000
45004	1711	6284459000000
45005	1711	6284460000000
45012	1726	706317883000
45013	1874	204117000
45014	1693	8553398155041
45023	1547	6333226000000
45024	1547	6333227000000
45044	1677	82009140325000
45045	1677	82009141325000
45056	1683	207794906149541
45059	1480	1420909000000
45062	470	73200296000000
45063	1671	5088221530515
45074	1691	5723016100019
45080	1699	2229722750126
45081	1773	4104187299982
45082	1768	4910625110000
45083	1768	4910626110000
45086	1773	4033113028206
45087	182	66497436792432
45088	1773	3985726847020
45089	702	44331624528302
45090	1773	3444942085194
45091	927	506563198332782
45092	1773	2475868345358
45093	1047	907756911178852
45094	1773	1822011730132
45095	1167	611481675306582
45096	1293	1706734649862574
45097	1268	994988000000
45098	1269	1000000
45099	1692	50422241019999
45100	1692	50422302019999
45102	1637	146884145819997
45108	1476	5040055000000
45113	1675	4461959999977
45114	1675	4461960999977
45116	1726	706310876000
45117	1874	204124000
45118	1726	705100876000
45119	2064	200000000
45120	1726	703890876000
45121	2065	200000000
45122	1422	5904993860211
45125	1690	90002825000000
45126	1690	90002846000000
45137	1726	701467873000
45138	1874	204127000
45139	1422	5904973860211
45167	1637	146884146819997
45173	1587	5040277000000
45174	1683	212114910149541
45175	1683	212114911149541
45178	1702	2880216000000
45191	1549	33840807000000
45192	1549	34560807000000
45202	1397	1371403274000
45203	1678	12960388826000
45204	1726	701455861000
45205	1874	204139000
45206	1527	261999988
45207	1688	60121319904001
45208	1527	60121328904003
45209	1688	263999986
45213	1700	6065906276737
45214	1700	6785906276737
45216	1726	701454860000
45217	1874	204140000
45218	1677	84889152325000
45219	1677	84889153325000
45255	1397	1371313265000
45256	1678	12960388835000
45257	1726	700236852000
45258	1874	204148000
45259	1683	212114921149541
45276	1397	1371273261000
45277	1678	12960388839000
45278	1726	699022848000
45279	1874	204152000
45280	1455	3633927000000
45283	1397	1371263260000
45284	1678	12960388840000
45285	1726	699021847000
45286	1874	204153000
45287	1677	86329164325000
45288	1677	86329175325000
45329	1623	42482407899898
45330	1623	42482440899898
45336	1397	1371173251000
45337	1678	12960388849000
45338	1726	699012838000
45339	1874	204162000
45340	1683	214994943149541
45341	1683	214994954149541
45359	1683	214994944149541
45375	1397	1371113245000
45376	1678	12960388855000
45377	1726	699005831000
45378	1874	204169000
45379	1729	10366903000000
45380	1729	10366914000000
45394	2039	4321048000000
45407	1467	26642380100000
45413	1747	1456817000000
45416	1689	4320064287625
45418	748	2722290000000
45433	1726	698997823000
45434	1874	204177000
45435	1613	3527683600000
45436	1613	3527716600000
45477	1683	219315020149541
45490	1397	1370933227000
45491	1678	12960388873000
45492	1726	698987813000
45493	1874	204187000
45494	1489	24480744000000
45495	1489	24480755000000
45504	1397	1370913225000
45505	1678	12960388875000
45506	1397	1370903224000
45507	1678	12960388876000
45508	1397	1370893223000
45509	1678	12960388877000
45510	1397	1370883222000
45511	1678	12960388878000
45084	1677	83449140325000
45104	1546	6480618000000
45123	632	89760698000000
45124	632	89760719000000
45127	1726	702680876000
45128	2066	200000000
45129	1726	701470876000
45130	2067	200000000
45131	1726	701469875000
45132	1874	204125000
45133	1759	5760570999999
45134	1759	5760591999999
45158	1690	90722846000000
45159	1690	90722850000000
45162	1726	701460866000
45163	1874	204134000
45164	58	73866283999659
45165	58	73866284999659
45195	1397	1371413275000
45196	1678	12960388825000
45197	1726	701456862000
45198	1874	204138000
45199	1527	3600064287625
45200	1689	260999989
45210	1895	44200000000
45211	1700	6741861276737
45212	1700	6741872276737
45245	1397	1371333267000
45246	1678	12960388833000
45247	1397	1371323266000
45248	1678	12960388834000
45249	1726	700238854000
45250	1874	204146000
45251	1726	700237853000
45252	1874	204147000
45253	1549	34560796000000
45254	1549	34560818000000
45281	1677	85609153325000
45282	1677	85609164325000
45295	1397	1371243258000
45296	1678	12960388842000
45297	1726	699019845000
45298	1874	204155000
45299	1683	213554921149541
45300	1683	213554932149541
45314	1397	1371213255000
45315	1678	12960388845000
45316	1397	1371203254000
45317	1678	12960388846000
45318	1397	1371193253000
45319	1678	12960388847000
45320	1726	699016842000
45321	1874	204158000
45322	1726	699015841000
45323	1874	204159000
45324	1726	699014840000
45325	1874	204160000
45326	1688	60121353904000
45342	1623	42482418899898
45347	1397	1371163250000
45348	1678	12960388850000
45349	1397	1371153249000
45350	1678	12960388851000
45351	1726	699010836000
45352	1874	204164000
45353	1633	4356269985638
45354	1633	4356290985638
45383	1397	1371103244000
45384	1678	12960388856000
45385	1397	1371093243000
45386	1678	12960388857000
45387	1726	699004830000
45388	1874	204170000
45389	1726	699003829000
45390	1874	204171000
45391	1615	1440020000000
45392	1615	1440042000000
45417	1611	21590854000000
45419	1397	1371053239000
45420	1678	12960388861000
45421	1397	1371043238000
45422	1678	12960388862000
45423	1726	698999825000
45424	1874	204175000
45425	1726	698998824000
45426	1874	204176000
45427	748	2722412000000
45463	1419	9101142280064
45464	1419	9101153280064
45466	1397	1370973231000
45467	1678	12960388869000
45468	1397	1370963230000
45469	1678	12960388870000
45470	1726	698991817000
45471	1874	204183000
45472	1726	698990816000
45473	1874	204184000
45474	1419	9101164280064
45496	1397	1370923226000
45497	1678	12960388874000
45498	1726	698986812000
45499	1874	204188000
45500	1677	88489187325000
45501	1677	88489198325000
45529	1402	98643710000000
45530	1402	98643721000000
45543	1397	1370843218000
45544	1678	12960388882000
45545	1726	698978804000
45546	1874	204196000
45547	1683	222195065149541
45548	1683	222195076149541
45561	1599	18875073052715
45562	921	504783215943484
45563	1599	15281330064617
45564	1041	904567197988098
45565	1397	1370813215000
45566	1678	12960388885000
45567	1599	12856556807349
45568	1161	610329513257268
45569	1599	6099728393047
45570	1287	1700737456165952
45571	1726	698975801000
45572	1874	204199000
45573	1686	3091782550062
45574	1686	3091833550062
45620	1397	1370733207000
45621	1678	12960388893000
45622	1397	1370723206000
45623	1678	12960388894000
45624	1726	698968794000
45625	1874	204206000
45626	1726	698967793000
45627	1874	204207000
45628	1693	8553419155041
45664	1397	1370663200000
45665	1678	12960388900000
45666	1397	1370653199000
45667	1678	12960388901000
45668	1397	1370643198000
45669	1678	12960388902000
45670	1397	1370633197000
45671	1678	12960388903000
45672	1726	698961787000
45673	1874	204213000
45674	1726	698960786000
45675	1874	204214000
45676	1726	698959785000
45677	1874	204215000
45678	1726	698958784000
45679	1874	204216000
45680	1506	3601016967172
45704	1397	1370583192000
45705	1678	13680399908000
45706	1726	698953779000
45707	1874	204221000
45708	1673	29566680000000
45709	1673	29566691000000
45739	1683	227955108149541
45740	1683	227955119149541
45746	1397	1370513185000
45747	1678	13680399915000
45748	1726	698946772000
45749	1874	204228000
45750	1637	149044168819997
45751	1637	149044179819997
45753	1397	1370503184000
45754	1678	13680399916000
45755	1726	698945771000
45756	1874	204229000
45757	1677	91369231325000
45758	1677	91369242325000
45794	1419	9821153280064
45795	1419	9821164280064
45814	1397	1370393173000
45815	1678	13680399927000
45816	1726	698934760000
45817	1874	204240000
45818	1601	7418498600000
45847	1622	19439435999976
45860	1692	51862317019999
45861	1692	51862328019999
45883	1397	1370263160000
45884	1678	13680399940000
45885	1397	1370253159000
45144	1726	701465871000
45145	1874	204129000
45146	1672	5041736000000
45147	1672	5041737000000
45148	1726	701464870000
45149	1874	204130000
45150	1726	701463869000
45151	1874	204131000
45152	1726	701462868000
45153	1874	204132000
45154	1726	701461867000
45155	1874	204133000
45156	1447	11674476944000
45157	1447	11674480944000
45171	1992	7919175990000
45172	1992	7919176990000
45185	1397	1371423276000
45186	1678	12960388824000
45187	1726	701457863000
45188	1874	204137000
45189	1688	59401331904000
45190	1688	60121331904000
45193	1677	83449152325000
45194	1677	84169152325000
45220	1397	1371393273000
45221	1678	12960388827000
45222	1726	700244860000
45223	2067	1400000000
45224	1397	1371383272000
45225	1678	12960388828000
45226	1397	1371373271000
45227	1678	12960388829000
45228	1397	1371363270000
45229	1678	12960388830000
45230	1397	1371353269000
45231	1678	12960388831000
45232	1397	1371343268000
45233	1678	12960388832000
45234	1726	700243859000
45235	1874	204141000
45236	1726	700242858000
45237	1874	204142000
45238	1726	700241857000
45239	1874	204143000
45240	1726	700240856000
45241	1874	204144000
45242	1726	700239855000
45243	1874	204145000
45244	1717	2987828000023
45260	1397	1371303264000
45261	1678	12960388836000
45262	1726	699026852000
45263	2063	1400000000
45264	1726	699025851000
45265	1874	204149000
45289	1397	1371253259000
45290	1678	12960388841000
45291	1726	699020846000
45292	1874	204154000
45301	1677	87049175325000
45302	1677	87049186325000
45304	1397	1371233257000
45305	1678	12960388843000
45306	1397	1371223256000
45307	1678	12960388844000
45308	1726	699018844000
45309	1874	204156000
45310	1726	699017843000
45311	1874	204157000
45312	1683	213554943149541
45327	1476	5760055000000
45328	1476	5760088000000
45331	1397	1371183252000
45332	1678	12960388848000
45333	1726	699013839000
45334	1874	204161000
45335	1402	97923710000000
45355	1726	699009835000
45356	1874	204165000
45357	1605	720021000000
45360	1397	1371143248000
45361	1678	12960388852000
45362	1726	699008834000
45363	1874	204166000
45364	632	90480719000000
45365	632	90480730000000
45414	1704	1506195000000
45415	1704	1506206000000
45457	1397	1370983232000
45458	1678	12960388868000
45459	1726	698992818000
45460	1874	204182000
45461	1683	219314998149541
45462	1683	219315009149541
45483	1671	4368261530515
45484	1671	5088261530515
45485	1671	5088301530515
45524	1397	1370873221000
45525	1678	12960388879000
45526	1726	698981807000
45527	1874	204193000
45528	1727	6666702000000
45551	1397	1370833217000
45552	1678	12960388883000
45553	1397	1370823216000
45554	1678	12960388884000
45555	1726	698977803000
45556	1874	204197000
45557	1726	698976802000
45558	1874	204198000
45559	633	73083896900000
45560	633	73083918900000
45575	1472	1275011000000
45576	1686	3257989550062
45591	1692	51142317019999
45598	1397	1370783212000
45599	1678	12960388888000
45600	1726	698973799000
45601	1874	204201000
45602	1689	4320075287625
45603	1397	1370773211000
45604	1678	12960388889000
45605	1397	1370763210000
45606	1678	12960388890000
45607	1397	1370753209000
45608	1678	12960388891000
45609	1397	1370743208000
45610	1678	12960388892000
45611	1726	698972798000
45612	1874	204202000
45613	1726	698971797000
45614	1874	204203000
45615	1726	698970796000
45616	1874	204204000
45617	1726	698969795000
45618	1874	204205000
45619	1723	6119114085979
45645	1397	1370693203000
45646	1678	12960388897000
45647	1397	1370683202000
45648	1678	12960388898000
45649	1726	698964790000
45650	1874	204210000
45651	1726	698963789000
45652	1874	204211000
45653	1683	226515086149541
45654	1683	226515108149541
45687	1397	1370613195000
45688	1678	12960388905000
45689	1726	698956782000
45690	1874	204218000
45691	1690	90722857000000
45726	1564	6306323000000
45733	1397	1370533187000
45734	1678	13680399913000
45735	1726	698948774000
45736	1874	204226000
45737	1693	9273419155041
45738	1693	9273430155041
45741	1397	1370523186000
45742	1678	13680399914000
45743	1726	698947773000
45744	1874	204227000
45745	1657	23041258000000
45781	1683	229395119149541
45782	1683	229395154149541
45788	1397	1370443178000
45789	1678	13680399922000
45790	1726	698939765000
45791	1874	204235000
45792	1699	2949722750126
45793	1699	2949733750126
45805	1397	1370413175000
45806	1678	13680399925000
45807	1397	1370403174000
45808	1678	13680399926000
45809	1726	698936762000
45810	1874	204238000
45811	1726	698935761000
45812	1874	204239000
45813	1764	5046766100000
45853	1716	7966678000000
45854	1716	7966689000000
45862	1397	1370303164000
45863	1678	13680399936000
45274	1464	1440000000000
45275	1464	1440022000000
45293	1637	148324157819997
45294	1637	148324168819997
45303	1764	5046755100000
45313	1739	20159641000000
45343	1726	699011837000
45344	1874	204163000
45345	1677	87769186325000
45346	1677	87769187325000
45358	1709	3600048000000
45366	1397	1371133247000
45367	1678	12960388853000
45368	1397	1371123246000
45369	1678	12960388854000
45370	1726	699007833000
45371	1874	204167000
45372	1726	699006832000
45373	1874	204168000
45374	1610	5040209000000
45381	1692	51142302019999
45382	1692	51142313019999
45393	1455	3633938000000
45395	1397	1371083242000
45396	1678	12960388858000
45397	1397	1371073241000
45398	1678	12960388859000
45399	1588	23039737000000
45400	2068	0
45401	1726	699002828000
45402	1874	204172000
45403	1726	699001827000
45404	1874	204173000
45405	1588	23759737000000
45406	1588	23759760000000
45408	1397	1371063240000
45409	1678	12960388860000
45410	1726	699000826000
45411	1874	204174000
45412	1746	4834310000000
45428	1613	2809183600000
45429	1397	1371033237000
45430	1678	12960388863000
45431	1613	3529183600000
45432	1613	3530200600000
45437	1397	1371023236000
45438	1678	12960388864000
45439	1726	698996822000
45440	1874	204178000
45441	1683	216434954149541
45442	1683	216434965149541
45443	1397	1371013235000
45444	1678	12960388865000
45445	1397	1371003234000
45446	1678	12960388866000
45447	1397	1370993233000
45448	1678	12960388867000
45449	1726	698995821000
45450	1874	204179000
45451	1726	698994820000
45452	1874	204180000
45453	1726	698993819000
45454	1874	204181000
45455	1683	217874965149541
45456	1683	217874998149541
45465	149	74190053000341
45475	1675	5181960999977
45476	1675	5181982999977
45478	1397	1370953229000
45479	1678	12960388871000
45480	1726	698989815000
45481	1874	204185000
45482	1671	5088232530515
45486	1397	1370943228000
45487	1678	12960388872000
45488	1726	698988814000
45489	1874	204186000
45502	300	66720000000000
45503	300	66720011000000
45531	1677	89209198325000
45532	1677	89209209325000
45533	1397	1370863220000
45534	1678	12960388880000
45535	1726	698980806000
45536	1874	204194000
45537	1668	7166525000000
45592	1397	1370793213000
45593	1678	12960388887000
45596	1683	223635076149541
45597	1683	223635086149541
45629	1643	6336367113700
45630	1643	6336389113700
45631	1397	1370713205000
45632	1678	12960388895000
45633	1726	698966792000
45634	1874	204208000
45635	1672	5761737000000
45636	1672	5761825000000
45655	1719	66000004950000
45656	646	4340285010000
45662	1527	6671590641005
45663	1634	261999988
45692	1397	1370603194000
45693	1678	12960388906000
45694	1726	698955781000
45695	1874	204219000
45696	1678	13680388906000
45697	1678	13680399906000
45710	1708	18719719000000
45711	1708	18719730000000
45752	1740	4841201000000
45759	1397	1370493183000
45760	1678	13680399917000
45761	1726	698944770000
45762	1874	204230000
45763	1650	4354072000000
45783	1397	1370453179000
45784	1678	13680399921000
45785	1726	698940766000
45786	1874	204234000
45787	1536	8640597000000
45819	1397	1370383172000
45820	1678	13680399928000
45821	1397	1370373171000
45822	1678	13680399929000
45823	1397	1370363170000
45824	1678	13680399930000
45825	1726	698933759000
45826	1874	204241000
45827	1726	698932758000
45828	1874	204242000
45829	1726	698931757000
45830	1874	204243000
45831	1681	7703148759830
45842	1397	1370333167000
45843	1678	13680399933000
45844	1726	698928754000
45845	1874	204246000
45846	1683	229395130149541
45848	1397	1370323166000
45849	1678	13680399934000
45850	1726	698927753000
45851	1874	204247000
45852	1622	19439446999976
45949	1397	1370203154000
45950	1678	13680399946000
45951	1726	698915741000
45952	1874	204259000
45953	1683	230835130149541
45954	1683	230835141149541
45955	1397	1370193153000
45956	1678	13680399947000
45957	1397	1370183152000
45958	1678	13680399948000
45959	1397	1370173151000
45960	1678	13680399949000
45961	1750	4180000000
45962	1726	698914740000
45963	1874	204260000
45964	1726	698913739000
45965	1874	204261000
45966	1726	698912738000
45967	1874	204262000
45968	1677	92089276325000
45970	1397	1370163150000
45971	1678	13680399950000
45972	1726	698911737000
45973	1874	204263000
45974	1508	7236183500009
45975	1508	7236194500009
45997	1683	232275141149541
45998	1683	232275175149541
46006	1710	8974524473290
46014	1683	232275153149541
46027	1397	1370083142000
46028	1678	13680399958000
46029	1726	695273729000
46030	1874	204271000
46031	1709	4320026000000
46032	1709	4320037000000
46054	1547	6333238000000
46061	1397	1370033137000
46062	1678	13680399963000
46063	1397	1370023136000
46064	1678	13680399964000
45512	1588	23758759000000
45513	2068	1000000000
45514	1726	698985811000
45515	1874	204189000
45516	1726	698984810000
45517	1874	204190000
45518	1726	698983809000
45519	1874	204191000
45520	1726	698982808000
45521	1874	204192000
45522	1683	220755020149541
45523	1683	220755065149541
45538	1397	1370853219000
45539	1678	12960388881000
45540	1726	698979805000
45541	1874	204195000
45542	1701	6550252600056
45549	1439	6052279998477
45550	1439	6052290998477
45577	1397	1370803214000
45578	1678	12960388886000
45579	1588	15625887000000
45580	1392	1702113508751650
45581	1588	11300275000000
45582	1146	905299076000000
45583	1588	8388612000000
45584	1266	609371411000000
45585	1588	5974754000000
45586	1026	505191632000000
45587	1726	698974800000
45588	1874	204200000
45589	1687	3592460524804
45590	1687	3592475524804
45594	1422	6624973860211
45595	1422	6624983860211
45637	1672	5761748000000
45638	1397	1370703204000
45639	1678	12960388896000
45640	1726	698965791000
45641	1874	204209000
45642	1633	5076290985638
45643	1633	5076301985638
45644	1683	225075086149541
45657	1397	1370673201000
45658	1678	12960388899000
45659	1726	698962788000
45660	1874	204212000
45661	1634	6671591641004
45681	1397	1370623196000
45682	1678	12960388904000
45683	1726	698957783000
45684	1874	204217000
45685	1677	89929209325000
45686	1677	89929220325000
45698	1397	1370593193000
45699	1678	13680399907000
45700	1726	698954780000
45701	1874	204220000
45702	1677	90649220325000
45703	1677	90649231325000
45712	1397	1370573191000
45713	1678	13680399909000
45714	1397	1370563190000
45715	1678	13680399910000
45716	1397	1370553189000
45717	1678	13680399911000
45718	1726	698952778000
45719	1874	204222000
45720	1726	698951777000
45721	1874	204223000
45722	1726	698950776000
45723	1874	204224000
45724	1509	7151729851155
45725	1509	7151762851155
45727	1397	1370543188000
45728	1678	13680399912000
45729	1726	698949775000
45730	1874	204225000
45731	1762	6081721994000
45732	1762	6081732994000
45764	1397	1370483182000
45765	1678	13680399918000
45766	1397	1370473181000
45767	1678	13680399919000
45768	1397	1370463180000
45769	1678	13680399920000
45770	1726	698943769000
45771	1874	204231000
45772	1750	4181000000
45773	1718	3186679763340
45774	1474	6034358000023
45775	1726	698942768000
45776	1874	204232000
45777	1726	698941767000
45778	1874	204233000
45779	1716	7246643000000
45780	1716	7246678000000
45796	1397	1370433177000
45797	1678	13680399923000
45798	1397	1370423176000
45799	1678	13680399924000
45800	1726	698938764000
45801	1874	204236000
45802	1726	698937763000
45803	1874	204237000
45804	1708	18719741000000
45832	1397	1370353169000
45833	1678	13680399931000
45834	1397	1370343168000
45835	1678	13680399932000
45836	1726	698930756000
45837	1874	204244000
45838	1726	698929755000
45839	1874	204245000
45840	1587	5760277000000
45841	1587	5760299000000
45855	1397	1370313165000
45856	1678	13680399935000
45857	1726	698926752000
45858	1874	204248000
45859	58	73866294999659
45868	1509	7151740851155
45896	369	91200756000000
45934	470	73200307000000
45947	1677	92089242325000
45948	1677	92089253325000
45996	1402	98643744000000
45999	1397	1370113145000
46000	1678	13680399955000
46001	1726	698906732000
46002	1874	204268000
46003	1750	4178000000
46004	1510	720000000000
46005	1510	720012000000
46007	1397	1370103144000
46008	1678	13680399956000
46009	1726	698905731000
46010	1874	204269000
46011	1750	4177000000
46012	1508	7956194500009
46013	1508	7956206500009
46052	1471	7099494000000
46053	1471	7099506000000
46055	1397	1370043138000
46056	1678	13680399962000
46057	1726	695269725000
46058	1874	204275000
46059	1426	8924819000000
46060	1426	8924830000000
46120	632	91920763000000
46121	632	91920774000000
46128	1670	6480745000000
46131	1397	1369933127000
46132	1678	13680399973000
46133	1726	695258714000
46134	1874	204286000
46135	1687	3592471524804
46136	1397	1369923126000
46137	1678	13680399974000
46138	1726	695257713000
46139	1874	204287000
46140	1602	6480354000000
46141	1602	6480365000000
46149	1474	6754358000023
46150	1474	6754369000023
46158	1397	1369893123000
46159	1678	13680399977000
46160	1397	1369883122000
46161	1678	13680399978000
46162	1726	695255711000
46163	1874	204289000
46164	1726	695254710000
46165	1874	204290000
46166	1622	20159446999976
46167	1622	20159468999976
46194	1439	6052301998477
46201	1634	7391591641004
46202	1634	7391602641004
46210	1637	150484190819997
46211	1637	150484201819997
46233	1677	94249308323100
46234	1677	94249319323100
46265	1397	1369723106000
46266	1678	13680399994000
46267	1397	1369713105000
45864	1726	698925751000
45865	1874	204249000
45866	1680	5049271500035
45867	1680	5049282500035
45869	1397	1370293163000
45870	1678	13680399937000
45871	1397	1370283162000
45872	1678	13680399938000
45873	1397	1370273161000
45874	1678	13680399939000
45875	1726	698924750000
45876	1874	204250000
45877	1726	698923749000
45878	1874	204251000
45879	1726	698922748000
45880	1874	204252000
45881	632	91200730000000
45882	632	91200763000000
45927	1397	1370233157000
45928	1678	13680399943000
45929	1726	698918744000
45930	1874	204256000
45931	1458	8733520908540
45935	1397	1370223156000
45936	1678	13680399944000
45937	470	73200317000000
45938	1726	698917743000
45939	1874	204257000
45940	1706	6692105600135
45976	1397	1370153149000
45977	1678	13680399951000
45978	1726	698910736000
45979	1874	204264000
45980	1588	6694754000000
45981	1588	6694765000000
46033	1422	6624974860211
46035	1397	1370073141000
46036	1678	13680399959000
46037	1397	1370063140000
46038	1678	13680399960000
46039	1750	4175000000
46040	1726	695272728000
46041	1874	204272000
46042	1726	695271727000
46043	1874	204273000
46044	1693	9273442155041
46072	1703	2880597000000
46074	1397	1370013135000
46075	1678	13680399965000
46076	1726	695266722000
46077	1874	204278000
46078	1768	5630626110000
46079	1768	5630637110000
46098	1683	233715183149541
46099	1683	233715194149541
46102	1397	1369973131000
46103	1678	13680399969000
46104	1397	1369963130000
46105	1678	13680399970000
46106	1677	92089296325000
46107	1726	695262718000
46108	1874	204282000
46109	1726	695261717000
46110	1874	204283000
46111	1677	92809296325000
46112	1514	92809298323100
46113	1677	5700
46151	1677	93529298323100
46152	1677	93529308323100
46156	1689	5040075287625
46157	1689	5040086287625
46172	1683	236595205149541
46173	1683	236595216149541
46180	1397	1369853119000
46181	1678	13680399981000
46182	1726	695251707000
46183	1874	204293000
46203	1397	1369813115000
46204	1678	13680399985000
46205	1726	695247703000
46206	1874	204297000
46207	1402	99363755000000
46223	1601	8138498600000
46224	1601	8138520600000
46249	1675	5181993999977
46253	1692	51862350019999
46287	1397	1369673101000
46288	1678	13680399999000
46289	1726	695233689000
46290	1874	204311000
46291	1588	7414765000000
46292	1588	7414776000000
46305	1683	240915249149541
46306	1683	240915271149541
46335	1675	5902463999977
46336	1675	5902549999977
46339	1397	1369593093000
46340	1678	13680400007000
46341	1850	7118833000000
46342	1850	7118843000000
46346	1650	5074072000000
46347	1650	5074083000000
46348	1683	242355271149541
46364	1700	7505872276737
46365	1700	7505882276737
46374	1397	1369543088000
46375	1678	13680400012000
46376	1726	695220676000
46377	1874	204324000
46378	1608	8205524000000
46379	1608	8205535000000
46388	1688	61561364904000
46389	1688	61561375904000
46392	1397	1369523086000
46393	1678	13680400014000
46394	1397	1369513085000
46395	1678	13680400015000
46396	1549	34560817000000
46397	1726	695218674000
46398	1874	204326000
46399	1726	695217673000
46400	1874	204327000
46401	1729	11086936000000
46402	1729	11086959000000
46404	1729	11086957000000
46405	1397	1369503084000
46406	1678	13680400016000
46407	1397	1369493083000
46408	1678	13680400017000
46409	1397	1369483082000
46410	1678	13680400018000
46411	1690	91442857000000
46412	1690	91442889000000
46495	1397	1369363070000
46496	1678	13680400030000
46497	1397	1369353069000
46498	1678	13680400031000
46499	1714	8086256103056
46515	1397	1369323066000
46516	1678	13680400034000
46517	1397	1369313065000
46518	1678	13680400035000
46519	1397	1369303064000
46520	1678	13680400036000
46521	1726	695198654000
46522	1874	204346000
46523	1726	695197653000
46524	1874	204347000
46525	1726	695196652000
46526	1874	204348000
46527	1451	2058730000000
46537	532	67440001000000
46538	532	67440012000000
46544	1397	1369263060000
46545	1678	13680400040000
46546	1726	695192648000
46547	1874	204352000
46548	1467	26642368100000
46558	1397	1369253059000
46559	1678	13680400041000
46560	1677	94969319323100
46561	1677	94969330323100
46589	1397	1369213055000
46590	1678	13680400045000
46591	1397	1369203054000
46592	1678	13680400046000
46593	1726	695186642000
46594	1874	204358000
46595	1726	695185641000
46596	1874	204359000
46597	1717	3707828000023
46598	1717	3707850000023
46616	1397	1369163050000
46617	1678	13680400050000
46618	1657	20943506000000
46619	978	504865525000000
46620	1726	695181637000
46621	1874	204363000
46622	1677	96409331323100
46623	1677	96409343323100
46628	1397	1369143048000
46629	1678	13680400052000
46630	1397	1369133047000
46631	1678	13680400053000
46632	1397	1369123046000
45886	1678	13680399941000
45887	1397	1370243158000
45888	1678	13680399942000
45889	1726	698921747000
45890	1874	204253000
45891	1726	698920746000
45892	1874	204254000
45893	1726	698919745000
45894	1874	204255000
45895	1850	6398833000000
45897	1451	19439496000000
45898	1451	19438396000000
45899	1451	10837296000000
45900	1451	10836196000000
45901	1451	6261096000000
45902	1451	6259996000000
45903	1451	3172896000000
45904	1451	3171796000000
45905	1451	618696000000
45906	1599	18155072052715
45907	1599	14561329064617
45908	1599	12136555807349
45909	1599	5379727393047
45910	369	91204368891000
45911	1678	12960388907000
45912	1678	12960388908000
45913	1678	12960388909000
45914	1678	12960388910000
45915	1678	12960388911000
45916	1678	12960388912000
45917	1678	12960388913000
45918	1678	12960388914000
45919	1678	12960388915000
45920	1678	12960388916000
45921	1678	12960388917000
45922	1678	12960388918000
45923	1678	12960388919000
45924	1678	12960388920000
45925	369	91924368891000
45926	369	91925238891000
45932	1637	149764179819997
45933	1637	149764190819997
45941	1397	1370213155000
45942	1678	13680399945000
45943	1726	698916742000
45944	1874	204258000
45945	576	71555600938283
45946	576	71555611938283
45969	1692	51862351019999
45982	1397	1370143148000
45983	1678	13680399952000
45984	1397	1370133147000
45985	1678	13680399953000
45986	1397	1370123146000
45987	1678	13680399954000
45988	1726	698909735000
45989	1874	204265000
45990	1726	698908734000
45991	1874	204266000
45992	1726	698907733000
45993	1874	204267000
45994	1750	4179000000
45995	1699	2949756750126
46015	1397	1370093143000
46016	1678	13680399957000
46017	1750	4176000000
46018	1726	698904730000
46019	1874	204270000
46020	1726	697694730000
46021	2069	200000000
46022	1726	696484730000
46023	2070	200000000
46024	1726	695274730000
46025	2071	200000000
46026	1683	232275183149541
46034	1422	6624984860211
46045	1397	1370053139000
46046	1678	13680399961000
46047	1726	695270726000
46048	1874	204274000
46049	1750	4174000000
46050	1671	5808232530515
46051	1671	5808244530515
46080	1560	7794202277001
46081	1560	7794213277001
46092	1611	22310854000000
46093	1611	22310876000000
46100	1677	92809276325000
46101	1677	92809287325000
46114	1397	1369953129000
46115	1678	13680399971000
46116	1726	695260716000
46117	1874	204284000
46118	1426	9644830000000
46119	1426	9644841000000
46122	1397	1369943128000
46123	1678	13680399972000
46124	1726	695259715000
46125	1874	204285000
46126	1672	6481748000000
46127	1672	6481759000000
46144	1397	1369913125000
46145	1678	13680399975000
46146	1726	695256712000
46147	1874	204288000
46148	1654	9647944000000
46184	1397	1369843118000
46185	1678	13680399982000
46186	1397	1369833117000
46187	1678	13680399983000
46188	1726	695250706000
46189	1874	204294000
46190	1726	695249705000
46191	1874	204295000
46192	1402	99363744000000
46193	1402	99363766000000
46195	1397	1369823116000
46196	1678	13680399984000
46197	1726	695248704000
46198	1874	204296000
46199	1458	9453520908540
46200	1458	9453531908540
46208	1688	60841353904000
46209	1688	60841364904000
46212	1623	43202418899898
46213	1623	43202429899898
46225	1701	7270252600056
46226	1701	7270274600056
46227	1397	1369783112000
46228	1678	13680399988000
46229	1726	695244700000
46230	1874	204300000
46231	1693	9993442155041
46232	1693	9993453155041
46250	1675	4462399999977
46251	1675	5182399999977
46252	1675	5182463999977
46254	1397	1369743108000
46255	1678	13680399992000
46256	1397	1369733107000
46257	1678	13680399993000
46258	1750	4172000000
46259	1726	695240696000
46260	1874	204304000
46261	1726	695239695000
46262	1874	204305000
46263	1715	27360436000000
46264	1715	27360459000000
46293	1397	1369663100000
46294	1678	13680400000000
46295	1397	1369653099000
46296	1678	13680400001000
46297	1726	695232688000
46298	1874	204312000
46299	1726	695231687000
46300	1874	204313000
46301	1710	9694524473290
46302	1710	9694546473290
46310	1397	1369643098000
46311	1678	13680400002000
46312	1726	695230686000
46313	1874	204314000
46314	1696	5537247840000
46315	1696	5537258840000
46316	1397	1369633097000
46317	1678	13680400003000
46318	1397	1369623096000
46319	1678	13680400004000
46320	1397	1369613095000
46321	1678	13680400005000
46322	1726	695229685000
46323	1874	204315000
46324	1726	695228684000
46325	1874	204316000
46326	1726	695227683000
46327	1874	204317000
46328	1729	10366936000000
46343	1726	695225681000
46344	1874	204319000
46345	1850	7118844000000
46349	1397	1369583092000
46350	1678	13680400008000
46351	1397	1369573091000
46352	1678	13680400009000
46353	593	66413823089930
46065	1726	695268724000
46066	1874	204276000
46067	1726	695267723000
46068	1874	204277000
46069	1750	4173000000
46070	1608	7485501000000
46071	1608	7485524000000
46073	1702	2880238000000
46082	1397	1370003134000
46083	1678	13680399966000
46084	1397	1369993133000
46085	1678	13680399967000
46086	1726	695265721000
46087	1874	204279000
46088	1726	695264720000
46089	1874	204280000
46090	633	73803918900000
46091	633	73803940900000
46094	1397	1369983132000
46095	1678	13680399968000
46096	1726	695263719000
46097	1874	204281000
46129	1673	30286691000000
46130	1673	30286701000000
46142	1683	235155194149541
46143	1683	235155205149541
46153	1397	1369903124000
46154	1678	13680399976000
46155	1447	11674487944000
46168	1397	1369873121000
46169	1678	13680399979000
46170	1726	695253709000
46171	1874	204291000
46174	1397	1369863120000
46175	1678	13680399980000
46176	1726	695252708000
46177	1874	204292000
46178	1683	238035216149541
46179	1683	238035227149541
46214	1397	1369803114000
46215	1678	13680399986000
46216	1397	1369793113000
46217	1678	13680399987000
46218	1726	695246702000
46219	1874	204298000
46220	1726	695245701000
46221	1874	204299000
46222	171	71030296524688
46235	1397	1369773111000
46236	1678	13680399989000
46237	1397	1369763110000
46238	1678	13680399990000
46239	1397	1369753109000
46240	1678	13680399991000
46241	1726	695243699000
46242	1874	204301000
46243	1726	695242698000
46244	1874	204302000
46245	1726	695241697000
46246	1874	204303000
46247	1762	6801732994000
46248	1762	6801765994000
46307	1696	4817597840000
46308	1539	2000000
46309	1696	5537596840000
46329	1397	1369603094000
46330	1678	13680400006000
46331	1726	695226682000
46332	1874	204318000
46333	1675	5901993999977
46334	1675	5902004999977
46360	1397	1369563090000
46361	1678	13680400010000
46362	1726	695222678000
46363	1874	204322000
46382	1397	1369533087000
46383	1678	13680400013000
46384	1726	695219675000
46385	1874	204325000
46386	1649	7483830999992
46387	1649	7483841999992
46390	1683	243795271149541
46391	1683	243795282149541
46436	1613	4247716600000
46437	1613	4247753600000
46461	1637	151204214819997
46462	1637	151204279819997
46483	1687	3592482524804
46484	1397	1369383072000
46485	1678	13680400028000
46486	1397	1369373071000
46487	1678	13680400029000
46488	1726	695204660000
46489	1874	204340000
46490	106	66413823089930
46491	2073	0
46492	1726	695203659000
46493	1874	204341000
46494	1448	2916687000001
46509	1397	1369333067000
46510	1678	13680400033000
46511	1726	695199655000
46512	1874	204345000
46513	1439	6772301998477
46514	1439	6772312998477
46532	1397	1369283062000
46533	1678	13680400038000
46534	1726	695194650000
46535	1874	204350000
46536	1724	6429306000000
46552	532	68160012000000
46553	532	68160023000000
46554	1726	695191647000
46555	1874	204353000
46556	1683	245235282149541
46557	1683	245235283149541
46562	1692	53302361019999
46563	1692	53302372019999
46601	1397	1369193053000
46602	1678	13680400047000
46603	1397	1369183052000
46604	1678	13680400048000
46605	1726	695184640000
46606	1874	204360000
46607	1726	695183639000
46608	1874	204361000
46609	1740	4841212000000
46610	1397	1369173051000
46611	1678	13680400049000
46612	1726	695182638000
46613	1874	204362000
46614	1596	7920278000000
46615	1596	7920311000000
46624	1397	1369153049000
46625	1678	13680400051000
46626	1726	695180636000
46627	1874	204364000
46651	1397	1369103044000
46652	1678	13680400056000
46653	1726	695175631000
46654	1874	204369000
46655	1715	28080459000000
46656	1715	28080475000000
46659	1397	1369093043000
46660	1678	13680400057000
46661	1657	7643883000000
46662	1344	1701014757751650
46663	1726	695174630000
46664	1874	204370000
46665	1715	28800475000000
46666	1715	28800487000000
46678	1677	97129343323100
46679	1677	97129354323100
46688	1397	1369053039000
46689	1678	13680400061000
46690	1726	695170626000
46691	1874	204374000
46692	1596	8640311000000
46693	1596	8640322000000
46706	1657	7201282000000
46707	1657	7201303000000
46709	1397	1369023036000
46710	1678	13680400064000
46711	1932	638829152658
46712	1958	1385987000000
46713	1513	20160628000000
46717	1397	1369003034000
46718	1678	13680400066000
46719	1397	1368993033000
46720	1678	13680400067000
46721	1397	1368983032000
46722	1678	13680400068000
46723	1458	9453550908540
46736	1675	6622549999977
46740	1397	1368933027000
46741	1678	13680400073000
46742	1710	9694534473290
46752	1397	1368893023000
46753	1678	13680400077000
46754	1622	20879468999976
46755	1622	20879478999976
46779	1717	4427850000023
46780	1717	4427860000023
46799	1726	693959625000
46800	2075	200000000
46268	1678	13680399995000
46269	1726	695238694000
46270	1874	204306000
46271	1726	695237693000
46272	1874	204307000
46273	1683	239475227149541
46274	1683	239475249149541
46275	1397	1369703104000
46276	1678	13680399996000
46277	1397	1369693103000
46278	1678	13680399997000
46279	1397	1369683102000
46280	1678	13680399998000
46281	1726	695236692000
46282	1874	204308000
46283	1726	695235691000
46284	1874	204309000
46285	1726	695234690000
46286	1874	204310000
46303	1508	8676206500009
46304	1508	8676228500009
46337	1692	52582350019999
46338	1692	52582361019999
46367	171	71750296524688
46368	171	71750307524688
46369	1397	1369553089000
46370	1678	13680400011000
46371	1726	695221677000
46372	1874	204323000
46373	1749	4880517000000
46423	1726	695216672000
46424	1874	204328000
46425	1726	695215671000
46426	1874	204329000
46427	1726	695214670000
46428	1874	204330000
46429	1726	695213669000
46430	1874	204331000
46431	1726	695212668000
46432	1874	204332000
46433	1726	695211667000
46434	1874	204333000
46435	1850	7838880000000
46438	1397	1369443078000
46439	1678	13680400022000
46440	1397	1369433077000
46441	1678	13680400023000
46442	1708	16770835119061
46443	1019	504726670880939
46444	1708	13278420398550
46445	1139	904465869720511
46446	1708	10922015342549
46447	1259	610261145056001
46448	1708	4355701000021
46449	1385	1700546942094178
46450	1549	27108040000000
46451	1236	611983843000000
46452	1549	21062431000000
46453	1116	907019073000000
46454	1549	9695676000000
46455	1362	1705347391751650
46456	1726	695210666000
46457	1874	204334000
46458	1726	695209665000
46459	1874	204335000
46460	1677	94249373323100
46473	1397	1369403074000
46474	1678	13680400026000
46475	1397	1369393073000
46476	1678	13680400027000
46477	1726	695206662000
46478	1874	204338000
46479	1726	695205661000
46480	1874	204339000
46481	1588	8134776000000
46482	1588	8134798000000
46500	1397	1369343068000
46501	1678	13680400032000
46502	1726	695202658000
46503	1874	204342000
46504	1726	695201657000
46505	1874	204343000
46506	1726	695200656000
46507	1874	204344000
46508	1688	61561377904000
46539	1397	1369273061000
46540	1678	13680400039000
46541	1726	695193649000
46542	1874	204351000
46543	1877	719011000000
46551	1560	7794214277001
46588	1672	7201793000000
46673	1397	1369073041000
46674	1678	13680400059000
46675	1726	695172628000
46676	1874	204372000
46677	1601	8138509600000
46700	1397	1369033037000
46701	1678	13680400063000
46702	1932	1136839152658
46703	1958	887987000000
46704	1402	100083755000000
46705	1402	100083775000000
46714	1397	1369013035000
46715	1678	13680400065000
46716	1688	62281387904000
46733	1397	1368953029000
46734	1678	13680400071000
46735	1683	245235292149541
46757	1397	1368883022000
46758	1678	13680400078000
46759	1637	152644290819997
46760	1637	152644300819997
46772	1764	5766766100000
46773	1764	5766786100000
46775	1397	1368843018000
46776	1678	13680400082000
46777	1467	27362368100000
46778	1467	27362378100000
46783	470	73200306000000
46810	1397	1368803014000
46811	1678	13680400086000
46812	1726	692747623000
46813	1874	204377000
46814	1683	248115302149541
46815	1683	248115313149541
46840	1397	1368763010000
46841	1678	13680400090000
46842	1726	692743619000
46843	1874	204381000
46844	1672	7921793000000
46845	1672	7921804000000
46848	1397	1368753009000
46849	1678	13680400091000
46850	1726	692742618000
46851	1874	204382000
46852	1683	249555313149541
46853	1683	249555324149541
46860	1397	1368733007000
46861	1678	13680400093000
46862	1397	1368723006000
46863	1678	13680400094000
46864	1726	692740616000
46865	1874	204384000
46866	1726	692739615000
46867	1874	204385000
46868	1683	250995324149541
46869	1683	250995346149541
46872	1397	1368713005000
46873	1678	13680400095000
46874	1726	692738614000
46875	1874	204386000
46876	1719	4340275000000
46879	1397	1368703004000
46880	1678	13680400096000
46881	1397	1368693003000
46882	1678	13680400097000
46883	1397	1368683002000
46884	1678	13680400098000
46885	1653	1438019000000
46886	2077	1000000000
46887	1653	1436009000000
46888	2077	3000000000
46889	1726	692737613000
46890	1874	204387000
46891	1726	692736612000
46892	1874	204388000
46893	1726	692735611000
46894	1874	204389000
46895	1596	9360322000000
46896	1596	9360366000000
46916	1723	6839114085979
46917	1723	6839157085979
46987	632	91920785000000
46997	1397	1368482982000
46998	1678	13680400118000
46999	1726	691505591000
47000	1874	204409000
47001	58	75306305999659
47002	58	75306316999659
47006	1397	1368472981000
47007	1678	13680400119000
47008	1726	691504590000
47009	1874	204410000
47010	1402	100083766000000
46354	2072	0
46355	1726	695224680000
46356	1874	204320000
46357	1726	695223679000
46358	1874	204321000
46359	1637	150484214819997
46366	1700	7505883276737
46380	1611	23030876000000
46381	1611	23030887000000
46403	1677	94249331323100
46413	1397	1369473081000
46414	1678	13680400019000
46415	1397	1369463080000
46416	1678	13680400020000
46417	1397	1369453079000
46418	1678	13680400021000
46419	1549	31187134000000
46420	996	506151457000000
46421	1850	7838843000000
46422	1850	7838874000000
46463	1397	1369423076000
46464	1678	13680400024000
46465	1397	1369413075000
46466	1678	13680400025000
46467	1726	695208664000
46468	1874	204336000
46469	1726	695207663000
46470	1874	204337000
46471	2039	5041048000000
46472	2039	5041070000000
46528	1397	1369293063000
46529	1678	13680400037000
46530	1726	695195651000
46531	1874	204349000
46549	1688	62281377904000
46550	1688	62281388904000
46564	1726	695190646000
46565	1874	204354000
46566	1677	95689330323100
46567	1677	95689331323100
46568	1397	1369243058000
46569	1678	13680400042000
46570	1397	1369233057000
46571	1678	13680400043000
46572	1672	6481779000000
46573	1397	1369223056000
46574	1678	13680400044000
46575	1726	695189645000
46576	1874	204355000
46577	1657	23031257000000
46578	2074	9000000000
46579	1726	695188644000
46580	1874	204356000
46581	1726	695187643000
46582	1874	204357000
46583	1672	7201779000000
46584	1672	200100000
46585	1790	7201792799960
46586	1571	10100002
46587	1761	15840301001040
46599	1679	26477457711000
46600	1679	26477479711000
46637	1726	695179635000
46638	1874	204365000
46639	1726	695178634000
46640	1874	204366000
46641	1726	695177633000
46642	1874	204367000
46643	1762	6801777994000
46657	1690	92162889000000
46658	1690	92162904000000
46680	1397	1369063040000
46681	1678	13680400060000
46682	1726	695171627000
46683	1874	204373000
46684	1657	6481282000000
46685	2074	1171600000000
46686	1588	8854798000000
46687	1588	8854810000000
46697	1726	695169625000
46698	1874	204375000
46699	1850	7838854000000
46708	1690	92162909000000
46725	149	74910053000341
46726	149	74910083000341
46747	1397	1368913025000
46748	1678	13680400075000
46749	1397	1368903024000
46750	1678	13680400076000
46751	1677	97129363323100
46764	1397	1368863020000
46765	1678	13680400080000
46766	1688	63001387904000
46767	1688	63001397904000
46768	1397	1368853019000
46769	1678	13680400081000
46770	1683	246675292149541
46771	1683	246675302149541
46774	1764	5766776100000
46788	1761	10100002
46789	1471	7819505900000
46790	1761	201900000
46791	1790	18200002
46796	1397	1368823016000
46797	1678	13680400084000
46798	1679	26477467711000
46830	58	73866464999659
46831	58	74586464999659
46832	58	74586869999659
46839	1739	20159630000000
46856	1397	1368743008000
46857	1678	13680400092000
46858	1726	692741617000
46859	1874	204383000
46899	1690	93602919000000
46900	1690	93602964000000
46901	1397	1368673001000
46902	1678	13680400099000
46903	1397	1368663000000
46904	1678	13680400100000
46905	1397	1368652999000
46906	1678	13680400101000
46907	1726	692734610000
46908	1874	204390000
46909	1726	691524610000
46910	2078	200000000
46911	1726	691523609000
46912	1874	204391000
46913	1726	691522608000
46914	1874	204392000
46915	1447	11674519944000
46949	1397	1368572991000
46950	1678	13680400109000
46951	1397	1368562990000
46952	1678	13680400110000
46953	1397	1368552989000
46954	1678	13680400111000
46955	1397	1368542988000
46956	1678	13680400112000
46957	1726	691514600000
46958	1874	204400000
46959	2044	199000000
46960	1726	691513599000
46961	1874	204401000
46962	1726	691512598000
46963	1874	204402000
46964	1726	691511597000
46965	1874	204403000
46966	1719	4340309000000
46978	1397	1368512985000
46979	1678	13680400115000
46980	1397	1368502984000
46981	1678	13680400116000
46982	1726	691508594000
46983	1874	204406000
46984	1726	691507593000
46985	1874	204407000
46986	1402	100083777000000
47012	1714	8806256103056
47013	1714	8806267103056
46633	1678	13680400054000
46634	1657	17202285000000
46635	1098	904714685000000
46636	1762	6801773994000
46644	1397	1369113045000
46645	1678	13680400055000
46646	1726	695176632000
46647	1874	204368000
46648	1657	14678004000000
46649	1218	610429030000000
46650	1680	5049287500035
46667	1397	1369083042000
46668	1678	13680400058000
46669	1726	695173629000
46670	1874	204371000
46671	1637	151924279819997
46672	1637	151924290819997
46694	1397	1369043038000
46695	1678	13680400062000
46696	1850	7838853000000
46724	1705	6400483500145
46727	1397	1368973031000
46728	1678	13680400069000
46729	1397	1368963030000
46730	1678	13680400070000
46731	1451	2778730000000
46732	1451	2778750000000
46737	1397	1368943028000
46738	1678	13680400072000
46739	1675	5902003999977
46743	1397	1368923026000
46744	1678	13680400074000
46745	1691	6443016100019
46746	1691	6443026100019
46756	1560	7794212277001
46761	1397	1368873021000
46762	1678	13680400079000
46763	1546	6480628000000
46781	1677	97849363323100
46782	1677	97849373323100
46784	1397	1368833017000
46785	1678	13680400083000
46786	1471	7819506000000
46787	1471	7819516000000
46792	341	7819515899991
46793	1471	66001000000002
46794	1571	66000000100000
46795	613	15840301001008
46809	171	71750327524688
46818	1677	97849374323100
46819	1397	1368793013000
46820	1678	13680400087000
46821	1726	692746622000
46822	1874	204378000
46823	1657	7201293000000
46897	1690	92882909000000
46898	1690	92882919000000
46948	633	73803962900000
46971	1397	1368522986000
46972	1678	13680400114000
46973	1726	691509595000
46974	1874	204405000
46975	1683	250995335149541
46996	1594	8545048000000
46801	1397	1368813015000
46802	1678	13680400085000
46803	1726	692749625000
46804	2076	200000000
46805	1726	692748624000
46806	1874	204376000
46807	1451	3498750000000
46808	1451	3498781000000
46816	1688	63721397904000
46817	1688	63721408904000
46824	1397	1368783012000
46825	1678	13680400088000
46826	1726	692745621000
46827	1874	204379000
46828	58	74586294999659
46829	58	74586305999659
46833	1397	1368773011000
46834	1678	13680400089000
46835	1726	692744620000
46836	1874	204380000
46837	1693	10713453155041
46838	1693	10713464155041
46846	1717	5147860000023
46847	1717	5147871000023
46854	1637	153364300819997
46855	1637	153364311819997
46870	1688	64441408904000
46871	1688	64441430904000
46877	1706	7412105600135
46878	1706	7412116600135
46918	1397	1368642998000
46919	1678	13680400102000
46920	1397	1368632997000
46921	1678	13680400103000
46922	1397	1368622996000
46923	1678	13680400104000
46924	1726	691521607000
46925	1874	204393000
46926	1726	691520606000
46927	1874	204394000
46928	1726	691519605000
46929	1874	204395000
46930	1690	92882942000000
46931	1397	1368612995000
46932	1678	13680400105000
46933	1397	1368602994000
46934	1678	13680400106000
46935	1397	1368592993000
46936	1678	13680400107000
46937	1397	1368582992000
46938	1678	13680400108000
46939	1726	691518604000
46940	1874	204396000
46941	1726	691517603000
46942	1874	204397000
46943	1726	691516602000
46944	1874	204398000
46945	1726	691515601000
46946	1874	204399000
46947	1467	27362412100000
46967	1397	1368532987000
46968	1678	13680400113000
46969	1726	691510596000
46970	1874	204404000
46976	1637	154084311819997
46977	1637	154084322819997
46988	1596	10080366000000
46989	1596	10080388000000
46990	1397	1368492983000
46991	1678	13680400117000
46992	1726	691506592000
46993	1874	204408000
46994	1695	6092127000000
46995	1695	6092138000000
47003	58	74587201999659
47004	58	75307201999659
47005	58	75307210999659
47011	1671	5808243530515
47014	1397	1368462980000
47015	1678	13680400120000
47016	1726	691503589000
47017	1874	204411000
47018	1622	20879479999976
47019	1397	1368452979000
47020	1678	13680400121000
47021	1726	691502588000
47022	1874	204412000
47023	162	67440021000000
47024	1708	5075701000021
47025	1397	1368442978000
47026	1678	13680400122000
47027	1726	691501587000
47028	1874	204413000
47029	1509	7871740851155
47030	1509	7871751851155
47031	1397	1368432977000
47032	1678	13680400123000
47033	1726	691500586000
47034	1874	204414000
47035	1980	12959149000000
47036	1601	8858509600000
47037	1601	8858520600000
47038	1397	1368422976000
47039	1678	13680400124000
47040	1726	691499585000
47041	1874	204415000
47042	1666	720011000000
47043	1397	1368412975000
47044	1678	13680400125000
47045	1726	691498584000
47046	1874	204416000
47047	1672	8641804000000
47048	1672	8641815000000
47049	1677	98569374323100
47050	1677	98569385323100
47051	1397	1368402974000
47052	1678	13680400126000
47053	1726	691497583000
47054	1874	204417000
47055	1684	10051247880623
47056	1397	1368392973000
47057	1678	13680400127000
47058	1397	1368382972000
47059	1678	13680400128000
47060	1726	691496582000
47061	1874	204418000
47062	1726	691495581000
47063	1874	204419000
47064	1850	8558853000000
47065	1850	8558875000000
47066	1509	8591751851155
47067	1509	8591773851155
47068	1673	30286713000000
47069	1397	1368372971000
47070	1678	13680400129000
47071	1726	691494580000
47072	1874	204420000
47073	1668	7886525000000
47074	1668	7886536000000
47075	1397	1368362970000
47076	1678	13680400130000
47077	1397	1368352969000
47078	1678	13680400131000
47079	1726	691493579000
47080	1874	204421000
47081	1726	691492578000
47082	1874	204422000
47083	1718	3906679763340
47084	1718	3906701763340
47085	1555	6675138979096
47086	1555	6675160979096
47087	1397	1368342968000
47088	1678	13680400132000
47089	1726	691491577000
47090	1874	204423000
47091	1656	9501326999990
47092	1656	9501337999990
47093	1701	7270253600056
47094	1726	691490576000
47095	1874	204424000
47096	1458	9453521908540
47097	1397	1368332967000
47098	1678	13680400133000
47099	1397	1368322966000
47100	1678	13680400134000
47101	1397	1368312965000
47102	1678	13680400135000
47103	1397	1368302964000
47104	1678	13680400136000
47105	1726	691489575000
47106	1874	204425000
47107	1726	691488574000
47108	1874	204426000
47109	1726	691487573000
47110	1874	204427000
47111	1726	691486572000
47112	1874	204428000
47113	1546	7200628000000
47114	1546	7200672000000
47115	1677	98569418323100
47116	1690	93602942000000
47117	1690	93602986000000
47118	1397	1368292963000
47119	1678	13680400137000
47120	1726	691485571000
47121	1874	204429000
47124	1560	7794362277001
47125	1560	8514362277001
47126	1560	8514444277001
47127	1397	1368282962000
47128	1678	13680400138000
47129	1397	1368272961000
47130	1678	13680400139000
47131	1726	691484570000
47132	1874	204430000
47133	1726	691483569000
47134	1874	204431000
47135	1536	9360597000000
47136	1536	9360619000000
47139	1397	1368262960000
47140	1678	13680400140000
47141	1726	691482568000
47142	1874	204432000
47186	58	76027210999659
47187	58	76027541999659
47228	1397	1368112945000
47229	1678	13680400155000
47230	1726	691467553000
47231	1874	204447000
47232	1703	2880585000000
47234	1397	1368102944000
47235	1678	13680400156000
47236	1726	691466552000
47237	1874	204448000
47258	1397	1368062940000
47259	1678	13680400160000
47260	1726	691462548000
47261	1874	204452000
47304	1536	10080630000000
47305	1397	1367982932000
47306	1678	13680400168000
47307	1726	691454540000
47308	1874	204460000
47309	1710	10414534473290
47310	1710	10414545473290
47317	1397	1367962930000
47318	1678	13680400170000
47319	1397	1367952929000
47320	1678	13680400171000
47321	1397	1367942928000
47322	1678	13680400172000
47323	1726	691452538000
47324	1874	204462000
47325	1726	691451537000
47326	1874	204463000
47327	1726	691450536000
47328	1874	204464000
47329	1683	255315390149541
47364	1397	1367872921000
47365	1678	13680400179000
47366	1726	691443529000
47367	1874	204471000
47368	1683	256755390149541
47369	1683	256755401149541
47402	1448	3636687000001
47403	1448	3636698000001
47412	1675	7342549999977
47413	1675	7342559999977
47441	1397	1367752909000
47442	1678	13680400191000
47443	1397	1367742908000
47444	1678	13680400192000
47445	1726	691432518000
47446	1874	204482000
47447	1726	691431517000
47448	1874	204483000
47449	1633	5796301985638
47450	1633	5796323985638
47464	1536	10080641000000
47468	1397	1367712905000
47469	1678	13680400195000
47470	1726	691428514000
47471	1874	204486000
47472	1599	6819728393047
47473	1599	6819739393047
47479	1397	1367702904000
47480	1678	13680400196000
47481	2054	180000000
47482	1713	780000000
47483	1397	1367692903000
47484	1678	13680400197000
47485	1397	1367682902000
47486	1678	13680400198000
47487	1726	691426512000
47488	1874	204488000
47489	1726	691425511000
47490	1874	204489000
47491	43	71040537890000
47493	43	71040527890000
47494	1637	155524365819997
47513	1397	1367632897000
47514	1678	13680400203000
47515	1726	691420506000
47516	1874	204494000
47540	2075	100000000
47541	1397	1367592893000
47542	1678	13680400207000
47543	1397	1367582892000
47544	1678	13680400208000
47545	1726	691416502000
47546	1874	204498000
47547	1726	691415501000
47548	1874	204499000
47549	1588	10294821000000
47550	1588	10294943000000
47566	1693	9993443155041
47567	1397	1367552889000
47568	1678	13680400211000
47569	1726	691411497000
47570	1874	204503000
47571	1711	7724460000000
47572	1711	7724481000000
47596	106	66000822089930
47597	2073	413000000000
47598	1726	691407493000
47599	1874	204507000
47600	555	66720000000000
47601	555	66720002000000
47615	1402	101210793608562
47616	34	67288983391438
47617	1397	1367492883000
47618	1678	13680400217000
47619	1397	1367482882000
47620	1678	13680400218000
47621	1397	1367472881000
47622	1678	13680400219000
47623	1726	691404490000
47624	1874	204510000
47625	1726	691403489000
47626	1874	204511000
47627	1726	691402488000
47628	1874	204512000
47629	1467	28082412100000
47630	1467	28082455100000
47686	1397	1367392873000
47687	1678	13680400227000
47688	1726	691389475000
47689	1874	204525000
47690	1726	691388474000
47691	1874	204526000
47692	1991	4795630441475
47775	1683	259635423149541
47776	1683	259635455149541
47903	1768	6350637110000
47904	1768	6350650110000
47905	1420	714900220000
47906	2082	4000000000
47907	1397	1367212855000
47908	1678	14400545245000
47909	1397	1367202854000
47910	1678	14400545246000
47911	1726	688933428000
47912	1874	204572000
47913	1726	688932426000
47914	1874	204574000
47915	1726	688931425000
47916	1874	204575000
47917	1726	688930423000
47918	1874	204577000
47919	1726	688929422000
47920	1874	204578000
47921	1684	10771247880623
47922	1684	10771372880623
47939	1677	102889572323100
47940	1677	103609572323100
47959	1992	8639197990000
47960	1992	8639210990000
47982	1724	6429308000000
48004	1397	1367122846000
48005	1678	14400545254000
48006	1726	687700386000
48007	1874	204614000
48008	1726	687699384000
48009	1874	204616000
48010	1739	20879630000000
48011	1739	20879642000000
48039	1397	1367082842000
48040	1678	14400545258000
48041	1726	687691371000
48042	1874	204629000
47122	1560	8514212277001
47123	1560	8514223277001
47147	1677	99289418323100
47148	1677	99289429323100
47155	1397	1368232957000
47156	1678	13680400143000
47157	1726	691479565000
47158	1874	204435000
47159	1683	253875346149541
47160	1683	253875357149541
47173	641	69219790000000
47174	641	69219812000000
47179	1397	1368192953000
47180	1678	13680400147000
47181	1726	691475561000
47182	1874	204439000
47183	58	76026316999659
47184	58	76026327999659
47188	1397	1368182952000
47189	1678	13680400148000
47190	1726	691474560000
47191	1874	204440000
47192	1608	8925535000000
47193	1608	8925546000000
47233	1702	2880226000000
47238	1602	6480364000000
47253	1397	1368072941000
47254	1678	13680400159000
47255	1726	691463549000
47256	1874	204451000
47257	1850	8558864000000
47277	1634	8111602641004
47278	1634	8111624641004
47285	1397	1368012935000
47286	1678	13680400165000
47287	1726	691457543000
47288	1874	204457000
47289	641	69939801000000
47290	641	69939812000000
47302	1536	10080619000000
47303	1536	10080620000000
47316	1749	5600517000000
47350	1688	65881441904000
47351	1688	65881474904000
47358	1397	1367882922000
47359	1678	13680400178000
47360	1726	691444530000
47361	1874	204470000
47362	1719	5060309000000
47363	1719	5060320000000
47377	1397	1367852919000
47378	1678	13680400181000
47379	1726	691441527000
47380	1874	204473000
47389	1637	155524333819997
47390	1637	155524354819997
47396	1397	1367812915000
47397	1678	13680400185000
47398	1726	691438524000
47399	1874	204476000
47400	1668	8606536000000
47401	1668	8606547000000
47405	1448	3636688000001
47406	1397	1367802914000
47407	1678	13680400186000
47408	1726	691437523000
47409	1874	204477000
47410	1587	6480299000000
47411	1587	6480310000000
47433	1522	6094012000000
47434	1522	6094034000000
47435	1397	1367762910000
47436	1678	13680400190000
47437	1726	691433519000
47438	1874	204481000
47439	1402	100803766000000
47440	1402	100803777000000
47452	1397	1367732907000
47453	1678	13680400193000
47454	1397	1367722906000
47455	1678	13680400194000
47456	1726	691430516000
47457	1874	204484000
47458	1726	691429515000
47459	1874	204485000
47460	1536	10080618999999
47461	1988	10080640999959
47462	1536	190000040
47463	2052	200000011
47518	1564	7026323000000
47519	1564	7026334000000
47520	1397	1367622896000
47521	1678	13680400204000
47522	1402	101523777000000
47523	1402	101523787000000
47538	1508	9396217500009
47539	1508	9396228500009
47576	1397	1367542888000
47577	1678	13680400212000
47578	1726	691410496000
47579	1874	204504000
47580	1536	10800640999959
47581	1536	10800651999959
47595	1992	7919197990000
47613	1681	8423148759830
47614	1681	8423171759830
47637	1677	100729473323100
47638	1677	100729484323100
47679	1397	1367402874000
47680	1678	13680400226000
47681	1726	691390476000
47682	1874	204524000
47683	1402	98095350337136
47684	2052	200000012
47685	1402	98815350337135
47714	1710	10314445473290
47715	1507	100000000000
47716	1397	1367362870000
47717	1678	13680400230000
47718	1397	1367352869000
47719	1678	13680400231000
47720	1726	691384470000
47721	1874	204530000
47722	1726	691383469000
47723	1874	204531000
47724	1726	691382468000
47725	1874	204532000
47726	1688	68761600904000
47727	1688	68761723904000
47754	1397	1367322866000
47755	1678	13680400234000
47756	1726	691377463000
47757	1874	204537000
47758	1726	691376462000
47759	1874	204538000
47760	149	75630064000341
47761	149	75630076000341
47762	1397	1367312865000
47763	1678	13680400235000
47764	1726	690166462000
47765	2080	200000000
47766	1726	688956462000
47767	1636	1200000000
47768	1726	688955461000
47769	1874	204539000
47770	1726	688954460000
47771	1874	204540000
47772	1402	77816175131128
47773	1402	77816207131128
47778	1637	156244333819997
47779	1637	156244365819997
47792	1397	1367292863000
47793	1678	13680400237000
47794	1397	1367282862000
47795	1678	13680400238000
47796	1726	688950456000
47797	1874	204544000
47798	1726	688949455000
47799	1874	204545000
47800	1726	688948454000
47801	1874	204546000
47802	1677	102889539323100
47803	1677	102889562323100
47839	1747	2176941000000
47850	1397	1367242858000
47851	1678	13680400242000
47852	1397	1367232857000
47853	1678	13680400243000
47854	1402	41686411935547
47855	882	585012754989949
47856	1402	41267772941914
47857	884	90001962306133
47858	1402	40018327033785
47859	888	268618956679283
47860	1402	38969482557689
47861	890	225491216368345
47862	1402	36667013092652
47863	892	495010792683787
47864	1402	36363279385211
47865	898	65298223692326
47866	1402	36182220718070
47867	900	38924048658131
47868	1402	35637993026391
47869	902	117002550997929
47870	1402	33680892481120
47137	1679	27197467711000
47138	1679	27197489711000
47143	1397	1368252959000
47144	1678	13680400141000
47145	1726	691481567000
47146	1874	204433000
47149	1397	1368242958000
47150	1678	13680400142000
47151	1726	691480566000
47152	1874	204434000
47153	1683	252435335149541
47154	1683	252435346149541
47163	1397	1368222956000
47164	1678	13680400144000
47165	1397	1368212955000
47166	1678	13680400145000
47167	1726	691478564000
47168	1874	204436000
47169	1726	691477563000
47170	1874	204437000
47171	1613	4967753600000
47172	1613	4967775600000
47175	1397	1368202954000
47176	1678	13680400146000
47177	1726	691476562000
47178	1874	204438000
47196	1397	1368172951000
47197	1678	13680400149000
47198	1726	691473559000
47199	1874	204441000
47200	1588	9574810000000
47201	1588	9574821000000
47202	1397	1368162950000
47203	1678	13680400150000
47204	1397	1368152949000
47205	1678	13680400151000
47206	1397	1368142948000
47207	1678	13680400152000
47208	1397	1368132947000
47209	1678	13680400153000
47210	1726	691472558000
47211	1874	204442000
47212	1726	691471557000
47213	1874	204443000
47214	1726	691470556000
47215	1874	204444000
47216	1726	691469555000
47217	1874	204445000
47218	1688	65161430904000
47219	1688	65161474904000
47221	1692	53302405019999
47246	1623	42482428899898
47247	1623	43202428899898
47248	1623	43202430899898
47267	1397	1368042938000
47268	1678	13680400162000
47269	1397	1368032937000
47270	1678	13680400163000
47271	1726	691460546000
47272	1874	204454000
47273	1726	691459545000
47274	1874	204455000
47275	1683	255315357149541
47276	1683	255315379149541
47279	1397	1368022936000
47280	1678	13680400164000
47281	1726	691458544000
47282	1874	204456000
47283	1613	5687775600000
47284	1613	5687786600000
47296	1397	1367992933000
47297	1678	13680400167000
47298	1726	691455541000
47299	1874	204459000
47300	1680	5769282500035
47301	1680	5769293500035
47336	1397	1367922926000
47337	1678	13680400174000
47338	1397	1367912925000
47339	1678	13680400175000
47340	1397	1367902924000
47341	1678	13680400176000
47342	1726	691448534000
47343	1874	204466000
47344	1726	691447533000
47345	1874	204467000
47346	1726	691446532000
47347	1874	204468000
47348	1671	6528243530515
47349	1671	6528276530515
47371	1397	1367862920000
47372	1678	13680400180000
47373	1726	691442528000
47374	1874	204472000
47375	1747	2176817000000
47376	1747	2176828000000
47382	1397	1367842918000
47383	1678	13680400182000
47384	1397	1367832917000
47385	1678	13680400183000
47386	1726	691440526000
47387	1874	204474000
47388	1476	5760076000000
47391	1397	1367822916000
47392	1678	13680400184000
47393	1726	691439525000
47394	1874	204475000
47395	1559	5002593000000
47420	1675	6622003999977
47421	1675	6622014999977
47432	1693	10713475155041
47467	1692	53302383019999
47474	1596	10080377000000
47475	1726	691427513000
47476	1874	204487000
47477	1673	31006702000000
47478	1673	31006703000000
47509	1397	1367642898000
47510	1678	13680400202000
47511	1726	691421507000
47512	1874	204493000
47524	1397	1367612895000
47525	1678	13680400205000
47526	1726	691419505000
47527	1874	204495000
47528	1726	691418504000
47529	1874	204496000
47530	1476	6480076000000
47531	1476	6480088000000
47553	2075	0
47554	1397	1367572891000
47555	1678	13680400209000
47556	1397	1367562890000
47557	1678	13680400210000
47558	1726	691414500000
47559	1874	204500000
47560	1726	691413499000
47561	1874	204501000
47562	1726	691412498000
47563	1874	204502000
47564	1601	9578520600000
47565	1601	9578643600000
47574	686	68160011000000
47575	686	68160032000000
47582	149	74910064000341
47639	1402	99050761608562
47640	1455	3634047000000
47641	1455	4354047000000
47712	1677	101449484323100
47713	1677	101449537323100
47728	1397	1367342868000
47729	1678	13680400232000
47730	1726	691381467000
47731	1874	204533000
47732	1726	691380466000
47733	1874	204534000
47734	1444	6334958160000
47735	1444	6334970160000
47774	1991	4795650441475
47780	1397	1367302864000
47781	1678	13680400236000
47782	1726	688953459000
47783	1874	204541000
47784	1623	43922430899898
47785	1623	43922441899898
47804	1701	7270275600056
47840	1704	1506319000000
47890	1654	9648078000000
47901	1681	9143171759830
47902	1681	9143184759830
47936	606	71419742812962
47937	606	72139742812962
47938	606	72139745812962
47949	1397	1367172851000
47950	1678	14400545249000
47951	1726	688923410000
47952	1874	204590000
47953	1726	688922407000
47954	1874	204593000
47955	1726	688921405000
47956	1874	204595000
47957	1683	262515563149541
47958	1683	262515576149541
47968	1601	10298643600000
47969	1601	10298655600000
47161	1637	154804322819997
47162	1637	154804333819997
47185	1508	8676217500009
47194	1610	5760209000000
47195	1610	5760220000000
47220	1677	99289462323100
47222	1397	1368122946000
47223	1678	13680400154000
47224	1726	691468554000
47225	1874	204446000
47226	1656	10221337999990
47227	1656	10221348999990
47239	1397	1368092943000
47240	1678	13680400157000
47241	1634	7391612641004
47242	1726	691465551000
47243	1874	204449000
47244	1634	8111612641004
47245	1634	8111614641004
47249	1397	1368082942000
47250	1678	13680400158000
47251	1726	691464550000
47252	1874	204450000
47262	1397	1368052939000
47263	1678	13680400161000
47264	1726	691461547000
47265	1874	204453000
47266	641	69219801000000
47291	1397	1368002934000
47292	1678	13680400166000
47293	1726	691456542000
47294	1874	204458000
47295	1673	30286702000000
47311	1397	1367972931000
47312	1678	13680400169000
47313	1726	691453539000
47314	1874	204461000
47315	1688	65161441904000
47330	1397	1367932927000
47331	1678	13680400173000
47332	1726	691449535000
47333	1874	204465000
47334	1686	3811833550062
47335	1686	3811844550062
47352	1397	1367892923000
47353	1678	13680400177000
47354	1726	691445531000
47355	1874	204469000
47356	1677	100009462323100
47357	1677	100009473323100
47370	1679	27197478711000
47381	1692	53302382019999
47404	1573	2138818000000
47414	1397	1367792913000
47415	1678	13680400187000
47416	1726	691436522000
47417	1874	204478000
47418	1723	7559157085979
47419	1723	7559168085979
47422	1397	1367782912000
47423	1678	13680400188000
47424	1397	1367772911000
47425	1678	13680400189000
47426	1726	691435521000
47427	1874	204479000
47428	1726	691434520000
47429	1874	204480000
47430	1683	258195401149541
47431	1683	258195423149541
47451	1711	7004460000000
47465	632	92640785000000
47466	632	92640807000000
47492	689	66720011000000
47495	1397	1367672901000
47496	1678	13680400199000
47497	1397	1367662900000
47498	1678	13680400200000
47499	1397	1367652899000
47500	1678	13680400201000
47501	1726	691424510000
47502	1874	204490000
47503	1726	691423509000
47504	1874	204491000
47505	1726	691422508000
47506	1874	204492000
47507	1688	66601474904000
47508	1688	66601507904000
47517	1638	720011000000
47532	1397	1367602894000
47533	1678	13680400206000
47534	1726	691417503000
47535	1874	204497000
47536	1622	21599479999976
47537	1622	21599490999976
47551	43	71760527890000
47552	43	71760649890000
47573	1693	10713443155041
47583	1397	1367532887000
47584	1678	13680400213000
47585	1726	691409495000
47586	1874	204505000
47587	1686	4531844550062
47588	1686	4531855550062
47589	1397	1367522886000
47590	1678	13680400214000
47591	1726	691408494000
47592	1874	204506000
47593	1689	5760086287625
47594	1689	5760108287625
47602	1397	1367512885000
47603	1678	13680400215000
47604	1397	1367502884000
47605	1678	13680400216000
47606	1726	691406492000
47607	1874	204508000
47608	2073	412999000000
47609	1726	691405491000
47610	1874	204509000
47611	1688	67321507904000
47612	1688	67321530904000
47631	1397	1367462880000
47632	1678	13680400220000
47633	1726	691401487000
47634	1874	204513000
47635	1633	6516323985638
47636	1633	6516334985638
47642	1397	1367452879000
47643	1678	13680400221000
47644	1397	1367442878000
47645	1678	13680400222000
47646	1402	100951163878266
47647	795	55816213249990
47648	1402	98095339337136
47649	796	613977809914895
47650	1397	1367432877000
47651	1678	13680400223000
47652	1397	1367422876000
47653	1678	13680400224000
47654	1397	1367412875000
47655	1678	13680400225000
47656	1726	691400486000
47657	1874	204514000
47658	1726	691399485000
47659	1874	204515000
47660	1726	691398484000
47661	1874	204516000
47662	1726	691397483000
47663	1874	204517000
47664	1726	691396482000
47665	1874	204518000
47666	1726	691395481000
47667	1874	204519000
47668	1726	691394480000
47669	1874	204520000
47670	1726	691393479000
47671	1874	204521000
47672	1726	691392478000
47673	1874	204522000
47674	106	66000811089930
47675	1483	10000000
47676	1726	691391477000
47677	1874	204523000
47678	1688	67321588904000
47693	1688	68041588904000
47694	1688	68041600904000
47695	1397	1367382872000
47696	1678	13680400228000
47697	1397	1367372871000
47698	1678	13680400229000
47699	1402	98692362570174
47700	807	27901274526808
47701	1402	97339598313884
47702	808	306913751943172
47703	1402	97060502092957
47704	809	60001356617753
47705	1726	691387473000
47706	1874	204527000
47707	1726	691386472000
47708	1874	204528000
47709	1726	691385471000
47710	1874	204529000
47711	1546	7200681000000
47736	1402	93990546341729
47737	810	660014346782974
47738	1397	1367332867000
47739	1678	13680400233000
47740	1402	93601328593782
47741	842	83676624395245
47742	1402	92875695004825
47743	844	156003401330624
47744	1402	87503301913255
47745	850	1155020382824210
47746	1402	77096175131128
47747	852	2237448782930877
47748	1726	691379465000
47749	1874	204535000
47750	1726	691378464000
47751	1874	204536000
47752	1710	11034445473290
47753	1710	11034507473290
47777	1547	6333258000000
47786	1726	688952458000
47787	1874	204542000
47788	1726	688951457000
47789	1874	204543000
47790	1677	102169537323100
47791	1677	102169539323100
47805	1397	1367272861000
47806	1678	13680400239000
47807	1397	1367262860000
47808	1678	13680400240000
47809	1402	75948613054315
47810	854	246714729103038
47811	1402	75341591013563
47812	856	130502845343877
47813	1402	73811009223020
47814	858	329060974492151
47815	1402	71696922805115
47816	862	454509909646030
47817	1402	69840990933336
47818	866	399008699557196
47819	1402	58537998102164
47820	868	2430052982831172
47821	1402	57329222000778
47822	870	259875266041231
47823	1402	46026229169606
47824	874	2430052982831172
47825	1402	45035463884671
47826	876	213004644124518
47827	1402	44407510394246
47828	880	135002943459175
47829	1726	688947453000
47830	1874	204547000
47831	1726	688946452000
47832	1874	204548000
47833	1726	688945451000
47834	1874	204549000
47835	1726	688944450000
47836	1874	204550000
47837	1746	5554310000000
47838	1746	5554434000000
47841	1637	156244457819997
47842	1397	1367252859000
47843	1678	13680400241000
47844	1726	688943447000
47845	1874	204553000
47846	1726	688942446000
47847	1874	204554000
47848	1489	25200755000000
47849	1489	25200767000000
47891	1397	1367222856000
47892	1678	14400545244000
47893	1726	688936434000
47894	1874	204566000
47895	1726	688935432000
47896	1874	204568000
47897	1726	688934431000
47898	1874	204569000
47899	1474	6754371000023
47923	1683	259635548149541
47941	1397	1367182852000
47942	1678	14400545248000
47943	1726	688925413000
47944	1874	204587000
47945	1726	688924411000
47946	1874	204589000
47947	1683	261075548149541
47948	1683	261075563149541
47970	1714	8806268103056
48022	1397	1367102844000
48023	1678	14400545256000
48024	1677	104329572323100
48025	1677	104329582323100
48082	1679	27197480711000
48105	1397	1367012835000
48106	1678	14400545265000
48107	1726	687671332000
48108	1874	204668000
48109	1726	687670330000
48110	1874	204670000
48111	171	71750308524688
48124	2084	499000000000
48125	1455	4574047000000
48171	1677	105049582323100
48172	1677	105049602323100
48176	1397	1366942828000
48177	1678	14400545272000
48178	1726	687653297000
48179	1874	204703000
48180	1726	687652296000
48181	1874	204704000
48182	1726	687651294000
48183	1874	204706000
48184	1790	202900000
48185	1739	21599641000000
48186	1739	21599654000000
48202	1397	1366912825000
48203	1678	14400545275000
48204	1397	1366902824000
48205	1678	14400545276000
48206	1726	687646285000
48207	1874	204715000
48208	1726	687645284000
48209	1874	204716000
48210	1726	687644282000
48211	1874	204718000
48212	1726	687643279000
48213	1874	204721000
48214	1726	687642278000
48215	1874	204722000
48216	1726	687641276000
48217	1874	204724000
48218	389	67440020000000
48219	389	67440046000000
48222	1397	1366892823000
48223	1678	14400545277000
48224	1726	687640273000
48225	1874	204727000
48226	1726	687639272000
48227	1874	204728000
48228	1726	687638270000
48229	1874	204730000
48230	1711	7724473000000
48231	1397	1366882822000
48232	1678	14400545278000
48233	1397	1366872821000
48234	1678	14400545279000
48235	1397	1366862820000
48236	1678	14400545280000
48237	1726	687637267000
48238	1874	204733000
48239	1726	687636266000
48240	1874	204734000
48241	1726	687635264000
48242	1874	204736000
48243	1726	687634261000
48244	1874	204739000
48245	1726	687633260000
48246	1874	204740000
48247	1726	687632258000
48248	1874	204742000
48249	1726	687631255000
48250	1874	204745000
48251	1726	687630254000
48252	1874	204746000
48253	1726	687629252000
48254	1874	204748000
48255	1420	1434900220000
48256	1420	1434939220000
48285	1397	1366822816000
48286	1678	14400545284000
48287	1397	1366812815000
48288	1678	14400545285000
48289	1397	1366802814000
48290	1678	14400545286000
48291	1726	687621239000
48292	1874	204761000
48293	1726	687620236000
48294	1874	204764000
48295	1726	687619234000
48296	1874	204766000
48297	1726	687618233000
48298	1874	204767000
48299	1726	687617230000
48300	1874	204770000
48301	1726	687616228000
48302	1874	204772000
48303	1726	687615227000
48304	1874	204773000
48305	1726	687614224000
47871	906	420759173781209
47872	1402	33243483331619
47873	1267	94037399149501
47874	1402	33238800263830
47875	1268	999659067789
47876	1402	32254005319298
47877	2081	983784944532
47878	1726	688941445000
47879	1874	204555000
47880	1726	688940443000
47881	1874	204557000
47882	1726	688939440000
47883	1874	204560000
47884	1726	688938438000
47885	1874	204562000
47886	1726	688937437000
47887	1874	204563000
47888	1678	14400400243000
47889	1678	14400545243000
47900	1685	76321422571430
47924	1654	9648058000000
47925	1397	1367192853000
47926	1678	14400545247000
47927	1419	9821174280064
47928	1726	688928419000
47929	1874	204581000
47930	1726	688927417000
47931	1874	204583000
47932	1726	688926416000
47933	1874	204584000
47934	1419	10541174280064
47935	1419	10541177280064
47961	1397	1367162850000
47962	1678	14400545250000
47963	1726	688920404000
47964	1874	204596000
47965	1726	688919402000
47966	1874	204598000
47967	1749	5600529000000
47971	1686	4531856550062
47972	1397	1367152849000
47973	1678	14400545251000
47974	1726	688918401000
47975	1874	204599000
47976	1726	688917398000
47977	1874	204602000
47978	1726	688916396000
47979	1874	204604000
47980	1684	10771260880623
47983	532	68160025000000
47984	1718	4626701763340
47985	1718	4626714763340
48012	1397	1367112845000
48013	1678	14400545255000
48014	1726	687698383000
48015	1874	204617000
48016	1726	687697381000
48017	1874	204619000
48018	1895	720200000000
48019	1895	720212000000
48046	1397	1367072841000
48047	1678	14400545259000
48048	1726	687689366000
48049	1874	204634000
48050	1726	687688365000
48051	1874	204635000
48052	1726	687687363000
48053	1874	204637000
48054	1596	10080379000000
48103	1688	70921771904000
48104	1688	70921784904000
48112	1397	1367002834000
48113	1678	14400545266000
48114	1726	687669329000
48115	1874	204671000
48116	1726	687668326000
48117	1874	204674000
48118	1726	687667324000
48119	1874	204676000
48120	1649	7483843999992
48126	1726	687666323000
48127	1874	204677000
48128	1726	687665320000
48129	1874	204680000
48130	1726	687664318000
48131	1874	204682000
48132	1699	2949735750126
48220	1610	6480220000000
48221	1610	6480246000000
48275	1397	1366832817000
48276	1678	14400545283000
48277	1726	687623242000
48278	1874	204758000
48279	1726	687622240000
48280	1874	204760000
48281	1711	8444473000000
48282	1711	8444485000000
48311	1679	27197506711000
48364	1397	1366732807000
48365	1678	14400545293000
48366	1726	687594186000
48367	1874	204814000
48368	1726	687593183000
48369	1874	204817000
48370	1726	687592182000
48371	1874	204818000
48372	1397	1366722806000
48373	1678	14400545294000
48374	1726	687591180000
48375	1874	204820000
48376	1726	687590177000
48377	1874	204823000
48378	1726	687589176000
48379	1874	204824000
48394	1637	156964457819997
48395	1637	156964470819997
48467	1673	16989952000000
48468	1122	905589535000000
48469	1397	1366612795000
48470	1678	14400545305000
48471	1726	687563125000
48472	1874	204875000
48473	1726	687562124000
48474	1874	204876000
48475	1726	687561121000
48476	1874	204879000
48477	1685	77041422571430
48478	1685	77041445571430
48481	1397	1366602794000
48482	1678	14400545306000
48483	1726	687560119000
48484	1874	204881000
48485	1587	7920323000000
48486	1587	7920334000000
48510	1677	105049632323100
48524	1673	13875532000000
48525	1242	611019160000000
48526	1397	1366562790000
48527	1678	14400545310000
48528	1726	687553104000
48529	1874	204896000
48530	1726	687552101000
48531	1874	204899000
48532	1506	4321016967172
48533	1506	4321040967172
48535	1690	95763065000000
48536	1690	95763087000000
48537	1397	1366552789000
48538	1678	14400545311000
48539	1397	1366542788000
48540	1678	14400545312000
48541	1673	11298692000000
48542	1002	505354605000000
48543	1397	1366532787000
48544	1678	14400545313000
48545	1726	687551099000
48546	1874	204901000
48547	1726	687550096000
48548	1874	204904000
48549	1726	687549094000
48550	1874	204906000
48551	1726	687548091000
48552	1874	204909000
48553	1726	687547089000
48554	1874	204911000
48555	1726	687546086000
48556	1874	204914000
48557	1471	8539505900000
48558	1471	8539551900000
48574	1458	10173521908540
48575	1458	10173535908540
48590	1509	8592143851155
48591	1509	9312143851155
48592	1571	9312447851147
48593	1509	15840301001008
48594	1397	1366482782000
48595	1678	14400545318000
48596	1726	687539070000
48597	1874	204930000
48598	1726	687538067000
48599	1874	204933000
48600	632	92640797000000
48636	1593	12260859000000
48637	1100	905216465000000
48638	1397	1366432777000
47981	1657	7201295000000
47986	1397	1367142848000
47987	1678	14400545252000
47988	1397	1367132847000
47989	1678	14400545253000
47990	1726	688915395000
47991	1874	204605000
47992	1726	688914392000
47993	1874	204608000
47994	1726	688913390000
47995	1874	204610000
47996	1726	688912389000
47997	1874	204611000
47998	1726	687702389000
47999	2083	200000000
48000	1726	687701387000
48001	1874	204613000
48002	1688	69481723904000
48003	1688	69481758904000
48020	1683	263955576149541
48021	1683	263955588149541
48026	1397	1367092843000
48027	1678	14400545257000
48028	1726	687696380000
48029	1874	204620000
48030	1726	687695377000
48031	1874	204623000
48032	1726	687694375000
48033	1874	204625000
48034	1726	687693374000
48035	1874	204626000
48036	1726	687692372000
48037	1874	204628000
48038	1654	9647948000000
48055	1397	1367062840000
48056	1678	14400545260000
48057	1397	1367052839000
48058	1678	14400545261000
48059	1726	687686360000
48060	1874	204640000
48061	1726	687685359000
48062	1874	204641000
48063	1726	687684357000
48064	1874	204643000
48065	1726	687683354000
48066	1874	204646000
48067	1726	687682353000
48068	1874	204647000
48069	1726	687681351000
48070	1874	204649000
48071	1768	6350663110000
48093	1397	1367022836000
48094	1678	14400545264000
48095	1726	687674336000
48096	1874	204664000
48097	1726	687673335000
48098	1874	204665000
48099	1726	687672333000
48100	1874	204667000
48101	1670	6480747000000
48133	1508	10116228500009
48134	1508	10116241500009
48135	1397	1366982832000
48136	1678	14400545268000
48137	1397	1366972831000
48138	1678	14400545269000
48139	1726	687663317000
48140	1874	204683000
48141	1726	687662315000
48142	1874	204685000
48143	1726	687661314000
48144	1874	204686000
48145	1726	687660312000
48146	1874	204688000
48147	1740	5561201000000
48148	1740	5561225000000
48187	1397	1366932827000
48188	1678	14400545273000
48189	1726	687650293000
48190	1874	204707000
48191	1726	687649291000
48192	1874	204709000
48193	1689	5759086287601
48194	1689	5759098287601
48257	1397	1366852819000
48258	1678	14400545281000
48259	1726	687628251000
48260	1874	204749000
48261	1726	687627249000
48262	1874	204751000
48263	1683	265395588149541
48264	1683	265395600149541
48283	1623	44642441899898
48284	1623	44642453899898
48313	1397	1366792813000
48314	1678	14400545287000
48315	1726	687612221000
48316	1874	204779000
48317	1726	687611218000
48318	1874	204782000
48319	1726	687610216000
48320	1874	204784000
48321	1726	687609215000
48322	1874	204785000
48323	1726	687608213000
48324	1874	204787000
48325	1726	687607210000
48326	1874	204790000
48327	1690	93602958000000
48380	1587	7200310000000
48381	1587	7200323000000
48383	1397	1366712805000
48384	1678	14400545295000
48385	1726	687588174000
48386	1874	204826000
48387	1726	687587171000
48388	1874	204829000
48389	1726	687586170000
48390	1874	204830000
48391	1683	266835600149541
48392	1683	266835613149541
48422	1673	21606032000000
48423	1368	1702661297751650
48424	1397	1366672801000
48425	1678	14400545299000
48426	1397	1366662800000
48427	1678	14400545300000
48428	1397	1366652799000
48429	1678	14400545301000
48430	1397	1366642798000
48431	1678	14400545302000
48432	1397	1366632797000
48433	1678	14400545303000
48434	1397	1366622796000
48435	1678	14400545304000
48436	1677	105049652323100
48487	1768	7070663110000
48488	1768	7070697110000
48523	1693	11433484155041
48534	1768	7070687110000
48576	1671	6528257530515
48577	1397	1366502784000
48578	1678	14400545316000
48579	1726	687541074000
48580	1874	204926000
48581	1715	29520487000000
48582	1715	29520498000000
48601	1397	1366472781000
48602	1678	14400545319000
48603	1673	11132052000000
48604	23	32724630000000
48605	1726	687537065000
48606	1874	204935000
48607	1726	687536062000
48608	1874	204938000
48609	1602	7200364000000
48610	1602	7200386000000
48663	1622	20879509999976
48664	1622	21599509999976
48665	1622	21599545999976
48669	1397	1366402774000
48670	1678	14400545326000
48671	1397	1366392773000
48672	1678	14400545327000
48673	1397	1366382772000
48674	1678	14400545328000
48675	1726	687524033000
48676	1874	204967000
48677	1726	687523030000
48678	1874	204970000
48679	1726	687522028000
48680	1874	204972000
48681	1726	687521025000
48682	1874	204975000
48683	1726	687520023000
48684	1874	204977000
48685	1726	687519020000
48686	1874	204980000
48687	576	72275611938283
48688	576	72275647938283
48755	1397	1366282762000
48756	1678	14400545338000
48757	1397	1366272761000
48758	1678	14400545339000
48759	1397	1366262760000
48043	1726	687690369000
48044	1874	204631000
48045	1657	7201294000000
48072	1397	1367042838000
48073	1678	14400545262000
48074	1726	687680348000
48075	1874	204652000
48076	1726	687679347000
48077	1874	204653000
48078	1726	687678345000
48079	1874	204655000
48080	1688	70201758904000
48081	1688	70201771904000
48083	1397	1367032837000
48084	1678	14400545263000
48085	1726	687677342000
48086	1874	204658000
48087	1726	687676341000
48088	1874	204659000
48089	1726	687675339000
48090	1874	204661000
48091	1611	23030889000000
48092	1714	8806269103056
48102	1683	263955589149541
48121	1397	1366992833000
48122	1678	14400545267000
48123	1699	2949732750126
48149	1397	1366962830000
48150	1678	14400545270000
48151	1397	1366952829000
48152	1678	14400545271000
48153	1726	687659309000
48154	1874	204691000
48155	1726	687658308000
48156	1874	204692000
48157	1726	687657306000
48158	1874	204694000
48159	1726	687656303000
48160	1874	204697000
48161	1402	32254029319298
48162	1726	687655302000
48163	1874	204698000
48164	1726	687654300000
48165	1874	204700000
48166	1964	200000001
48167	1402	32974029319297
48168	1786	32974031319255
48169	1402	200000042
48170	1964	200000003
48173	303	66000024000000
48174	303	66720024000000
48175	303	66720026000000
48195	1689	5760098287625
48196	1397	1366922826000
48197	1678	14400545274000
48198	1726	687648290000
48199	1874	204710000
48200	1726	687647288000
48201	1874	204712000
48265	1397	1366842818000
48266	1678	14400545282000
48267	1726	687626248000
48268	1874	204752000
48269	1726	687625245000
48270	1874	204755000
48271	1726	687624243000
48272	1874	204757000
48273	1518	6480292000000
48274	1518	6480305000000
48393	632	92640798000000
48396	1397	1366702804000
48397	1678	14400545296000
48398	1759	5760601999999
48399	1397	1366692803000
48400	1678	14400545297000
48401	1726	687585168000
48402	1874	204832000
48403	1726	687584165000
48404	1874	204835000
48405	1726	687583164000
48406	1874	204836000
48407	1726	687582162000
48408	1874	204838000
48409	1726	687581159000
48410	1874	204841000
48411	1726	687580158000
48412	1874	204842000
48413	1759	6480601999999
48414	1759	6480617999999
48415	1397	1366682802000
48416	1678	14400545298000
48417	1726	687579156000
48418	1874	204844000
48419	1726	687578155000
48420	1874	204845000
48421	1679	27197479711000
48437	1726	687577153000
48438	1874	204847000
48439	1726	687576151000
48440	1874	204849000
48441	1726	687575149000
48442	1874	204851000
48443	1726	687574148000
48444	1874	204852000
48445	1726	687573145000
48446	1874	204855000
48447	1726	687572143000
48448	1874	204857000
48449	1726	687571142000
48450	1874	204858000
48451	1726	687570139000
48452	1874	204861000
48453	1726	687569137000
48454	1874	204863000
48455	1726	687568136000
48456	1874	204864000
48457	1726	687567133000
48458	1874	204867000
48459	1726	687566131000
48460	1874	204869000
48461	1726	687565130000
48462	1874	204870000
48463	1726	687564127000
48464	1874	204873000
48465	1690	94322958000000
48466	1690	94323042000000
48479	1690	95043042000000
48480	1690	95043065000000
48489	1768	7070674110000
48511	1489	6383887000000
48512	1380	1702581800951650
48513	1397	1366572791000
48514	1678	14400545309000
48515	1726	687555109000
48516	1874	204891000
48517	1726	687554106000
48518	1874	204894000
48519	1693	11433464155041
48520	1693	11433486155041
48559	1397	1366522786000
48560	1678	14400545314000
48561	1677	105049592323100
48583	1397	1366492783000
48584	1678	14400545317000
48585	1726	687540072000
48586	1874	204928000
48587	1684	10771258880623
48611	1678	15120545319000
48612	1678	15120567319000
48613	1397	1366462780000
48614	1678	14400545320000
48615	1397	1366452779000
48616	1678	14400545321000
48617	1673	11126092000000
48618	756	1005950000000
48619	1593	16503869000000
48620	1346	1701957637751650
48621	1397	1366442778000
48622	1678	14400545322000
48623	1726	687535060000
48624	1874	204940000
48625	1726	687534057000
48626	1874	204943000
48627	1726	687533055000
48628	1874	204945000
48629	1726	687532053000
48630	1874	204947000
48631	1726	687531050000
48632	1874	204950000
48633	1688	71641784904000
48634	1688	71641839904000
48666	633	73083948900000
48667	633	73803948900000
48668	633	73803984900000
48689	1397	1366372771000
48690	1678	14400545329000
48691	1677	105769592323100
48692	1677	105769602323100
48703	1696	5538038840000
48704	1696	6258038840000
48705	1696	6258040840000
48721	1397	1366332767000
48722	1678	14400545333000
48723	1397	1366322766000
48724	1678	14400545334000
48306	1874	204776000
48307	1726	687613222000
48308	1874	204778000
48309	1710	11754507473290
48310	1710	11754546473290
48312	1690	93602970000000
48328	1397	1366782812000
48329	1678	14400545288000
48330	1397	1366772811000
48331	1678	14400545289000
48332	1397	1366762810000
48333	1678	14400545290000
48334	1397	1366752809000
48335	1678	14400545291000
48336	1397	1366742808000
48337	1678	14400545292000
48338	1726	687606209000
48339	1874	204791000
48340	1726	687605207000
48341	1874	204793000
48342	1726	687604206000
48343	1874	204794000
48344	1726	687603204000
48345	1874	204796000
48346	1726	687602201000
48347	1874	204799000
48348	1726	687601200000
48349	1874	204800000
48350	1726	687600198000
48351	1874	204802000
48352	1726	687599195000
48353	1874	204805000
48354	1726	687598194000
48355	1874	204806000
48356	1726	687597192000
48357	1874	204808000
48358	1726	687596189000
48359	1874	204811000
48360	1726	687595188000
48361	1874	204812000
48362	1513	20880628000000
48363	1513	20880690000000
48382	1677	105049594323100
48490	1489	22647795400000
48491	1014	505330736600000
48492	1489	18072372600000
48493	1134	905548877800000
48494	1397	1366592793000
48495	1678	14400545307000
48496	1397	1366582792000
48497	1678	14400545308000
48498	1489	14985060200000
48499	1254	610992052400000
48500	1726	687559117000
48501	1874	204883000
48502	1726	687558116000
48503	1874	204884000
48504	1726	687557114000
48505	1874	204886000
48506	1726	687556111000
48507	1874	204889000
48508	1402	32974005319298
48509	1402	32974059319298
48521	1710	12474546473290
48522	1710	12474568473290
48562	1397	1366512785000
48563	1678	14400545315000
48564	1726	687545084000
48565	1874	204916000
48566	1726	687544081000
48567	1874	204919000
48568	1726	687543079000
48569	1874	204921000
48570	1726	687542076000
48571	1874	204924000
48572	1402	33694059319298
48573	1402	33694073319298
48588	1680	6489293500035
48589	1680	6489304500035
48635	1594	8545092000000
48706	1397	1366352769000
48707	1678	14400545331000
48708	1397	1366342768000
48709	1678	14400545332000
48710	1726	687515010000
48711	1874	204990000
48712	1726	687514008000
48713	1874	204992000
48714	1726	687513005000
48715	1874	204995000
48716	1726	687512003000
48717	1874	204997000
48718	1447	11674500944000
48725	1397	1366312765000
48726	1678	14400545335000
48727	1726	687511001000
48728	1874	204999000
48729	1726	687509998000
48730	1874	205002000
48731	1726	687508996000
48732	1874	205004000
48733	1726	687507993000
48734	1874	205007000
48735	1726	687506991000
48736	1874	205009000
48737	1726	687505988000
48738	1874	205012000
48739	1594	9265092000000
48740	1594	9265108000000
48774	1564	7026353000000
48786	1677	107209622323100
48787	1677	107209628323100
48797	1739	22319654000000
48798	1739	22319678000000
48817	1397	1366202754000
48818	1678	14400545346000
48819	1397	1366192753000
48820	1678	14400545347000
48821	1726	687485938000
48822	1874	205062000
48823	1726	687484936000
48824	1874	205064000
48825	1726	687483933000
48826	1874	205067000
48827	1726	687482931000
48828	1874	205069000
48829	1698	7016907550035
48830	1698	7016931550035
48833	1397	1366182752000
48834	1678	14400545348000
48835	1726	687481928000
48836	1874	205072000
48837	1726	687480926000
48838	1874	205074000
48839	1683	266835612149541
48848	470	73920307000000
48849	470	73920319000000
48865	1397	1366142748000
48866	1678	14400545352000
48867	1726	687473908000
48868	1874	205092000
48869	1726	687472906000
48870	1874	205094000
48871	1768	7070675110000
48891	1397	1366112745000
48892	1678	14400545355000
48893	1726	687467893000
48894	1874	205107000
48895	1726	687466891000
48896	1874	205109000
48897	1688	71641800904000
48925	1696	6258424840000
48926	1696	6978424840000
48927	1696	6978426840000
48953	1397	1366032737000
48954	1678	14400545363000
48955	1726	687452857000
48956	1874	205143000
48957	1726	687451854000
48958	1874	205146000
48959	1670	7200757000000
48960	1670	7200769000000
48981	1573	2858818000000
48982	1573	2858842000000
48986	1726	687445839000
48987	1874	205161000
48988	1696	7697283840000
48989	1696	7697284840000
48993	1696	7698426840000
48994	1696	66000004950000
48995	646	7698526740000
48996	1599	6819748503047
48997	1397	1366002734000
48998	1678	14400545366000
48999	58	76746327999659
49000	58	76746337999659
49008	1764	5766778100000
49044	1759	7200617999999
49045	1759	7200630999999
49046	1397	1365952729000
49047	1678	14400545371000
49048	1726	687435815000
49049	1874	205185000
49050	1444	7054970160000
49051	1444	7054983160000
48639	1678	14400545323000
48640	1593	9397849000000
48641	1220	610767750000000
48642	1588	9574851000000
48643	1593	7029839000000
48644	980	505145775000000
48645	1397	1366422776000
48646	1678	14400545324000
48647	1397	1366412775000
48648	1678	14400545325000
48649	1726	687530048000
48650	1874	204952000
48651	1726	687529045000
48652	1874	204955000
48653	1726	687528043000
48654	1874	204957000
48655	1726	687527040000
48656	1874	204960000
48657	1726	687526038000
48658	1874	204962000
48659	1726	687525035000
48660	1874	204965000
48661	1588	10294851000000
48662	1588	10294887000000
48693	1397	1366362770000
48694	1678	14400545330000
48695	1726	687518018000
48696	1874	204982000
48697	1726	687517015000
48698	1874	204985000
48699	1726	687516013000
48700	1874	204987000
48701	1696	6257258840000
48702	1696	6257271840000
48719	1677	106489602323100
48720	1677	106489622323100
48741	1397	1366302764000
48742	1678	14400545336000
48743	1397	1366292763000
48744	1678	14400545337000
48745	1726	687504986000
48746	1874	205014000
48747	1726	687503983000
48748	1874	205017000
48749	1726	687502981000
48750	1874	205019000
48751	1726	687501978000
48752	1874	205022000
48753	1729	11806957000000
48754	1729	11806981000000
48775	1397	1366252759000
48776	1678	14400545341000
48777	1749	6320529000000
48778	1749	6320545000000
48788	1397	1366242758000
48789	1678	14400545342000
48790	1560	9234223277001
48791	1560	9234243277001
48831	1657	7921294000000
48832	1657	7921318000000
48850	470	73920317000000
48851	1397	1366162750000
48852	1678	14400545350000
48853	1726	687477918000
48854	1874	205082000
48855	1726	687476916000
48856	1874	205084000
48872	1397	1366132747000
48873	1678	14400545353000
48874	1683	266835622149541
48875	1397	1366122746000
48876	1678	14400545354000
48877	1726	687471903000
48878	1874	205097000
48879	1726	687470901000
48880	1874	205099000
48881	1726	687469898000
48882	1874	205102000
48883	1726	687468896000
48884	1874	205104000
48885	1683	268275622149541
48886	1683	268275636149541
48898	1397	1366102744000
48899	1678	14400545356000
48900	1397	1366092743000
48901	1678	14400545357000
48902	1726	687465888000
48903	1874	205112000
48904	1726	687464886000
48905	1874	205114000
48906	1726	687463884000
48907	1874	205116000
48908	1729	12526981000000
48909	1729	12527004000000
48910	1397	1366082742000
48911	1678	14400545358000
48912	1726	687462882000
48913	1874	205118000
48914	1726	687461879000
48915	1874	205121000
48916	1608	8925547000000
48928	1397	1366062740000
48929	1678	14400545360000
48930	1397	1366052739000
48931	1678	14400545361000
48932	1726	687458872000
48933	1874	205128000
48934	1726	687457869000
48935	1874	205131000
48936	1726	687456867000
48937	1874	205133000
48938	1726	687455864000
48939	1874	205136000
48940	1683	268275612149541
48943	1397	1366042738000
48944	1678	14400545362000
48945	1726	687454862000
48946	1874	205138000
48947	1726	687453859000
48948	1874	205141000
48949	1593	7749839000000
48950	1593	7749855000000
48961	1762	7521773994000
48962	1762	7521783994000
48966	1677	109369667324100
48990	1679	27917479711000
48991	1679	27917481711000
49001	1726	687444837000
49002	1874	205163000
49003	1691	7163026100019
49004	1691	7163037100019
49015	1471	9259551900000
49016	1471	9259591900000
49026	1686	5251856550062
49027	1686	5251869550062
49034	1623	44642451899898
49052	1397	1365942728000
49053	1678	14400545372000
49054	1726	687434813000
49055	1874	205187000
49056	1726	687433810000
49057	1874	205190000
49058	1698	7736931550035
49059	1698	7736943550035
49083	1397	1365902724000
49084	1678	14400545376000
49085	1397	1365892723000
49086	1678	14400545377000
49087	1726	687426793000
49088	1874	205207000
49089	1726	687425790000
49090	1874	205210000
49091	1726	687424788000
49092	1874	205212000
49093	1726	687423785000
49094	1874	205215000
49095	1723	8279168085979
49096	1723	8279192085979
49141	1397	1365832717000
49142	1678	14400545383000
49143	1699	2949757750126
49152	1397	1365812715000
49153	1678	14400545385000
49154	1726	687411757000
49155	1874	205243000
49156	1726	687410754000
49157	1874	205246000
49158	1702	3600226000000
49159	1702	3600238000000
49170	1683	269715633149541
49171	1683	269715644149541
49183	1397	1365782712000
49184	1678	14400545388000
49185	1726	687406744000
49186	1874	205256000
49187	1726	687405742000
49188	1874	205258000
49189	1536	10800652999959
49210	1397	1365742708000
49211	1678	14400545392000
49212	1933	720129000000
49213	1933	720139000000
49241	1397	1365702704000
49242	1678	14400545396000
49243	1726	687390704000
48760	1678	14400545340000
48761	1726	687500976000
48762	1874	205024000
48763	1726	687499973000
48764	1874	205027000
48765	1726	687498971000
48766	1874	205029000
48767	1726	687497968000
48768	1874	205032000
48769	1726	687496966000
48770	1874	205034000
48771	1726	687495963000
48772	1874	205037000
48773	1683	266835636149541
48779	1726	687494961000
48780	1874	205039000
48781	1726	687493958000
48782	1874	205042000
48783	1749	6320547000000
48792	1726	687492956000
48793	1874	205044000
48794	1726	687491953000
48795	1874	205047000
48796	1560	9234247277001
48799	1397	1366232757000
48800	1678	14400545343000
48801	1726	687490951000
48802	1874	205049000
48803	1726	687489948000
48804	1874	205052000
48805	1546	7200640000000
48840	484	91920756000000
48857	1397	1366152749000
48858	1678	14400545351000
48859	1726	687475913000
48860	1874	205087000
48861	1726	687474911000
48862	1874	205089000
48863	1739	23039678000000
48864	1739	23039690000000
48887	1677	107209638323100
48888	1677	107929638323100
48889	1677	11674501943000
48890	1447	107929647324100
48917	1397	1366072741000
48918	1678	14400545359000
48919	1726	687460877000
48920	1874	205123000
48921	1726	687459874000
48922	1874	205126000
48923	1696	6977271840000
48924	1696	6977283840000
48963	1610	6480232000000
48992	1696	7697285840000
49005	1726	687443834000
49006	1874	205166000
49007	58	76746339999659
49009	1555	6675150979096
49035	1397	1365962730000
49036	1678	14400545370000
49037	1991	5515650441475
49038	1991	5515661441475
49069	1397	1365922726000
49070	1678	14400545374000
49071	1397	1365912725000
49072	1678	14400545375000
49073	1726	687430803000
49074	1874	205197000
49075	1726	687429800000
49076	1874	205200000
49077	1726	687428798000
49078	1874	205202000
49079	1726	687427795000
49080	1874	205205000
49081	1471	9259575900000
49097	1397	1365882722000
49098	1678	14400545378000
49099	606	71419722812962
49100	1451	4218781000000
49101	1451	4218801000000
49107	1397	1365872721000
49108	1678	14400545379000
49109	1623	45362451899898
49110	1623	45362461899898
49144	2087	719000000000
49145	2087	719025000000
49160	1474	6754370000023
49172	1685	78481457571430
49173	1685	78481468571430
49174	1555	6675149979096
49233	1397	1365712705000
49234	1678	14400545395000
49235	1726	687392709000
49236	1874	205291000
49237	1726	687391707000
49238	1874	205293000
49239	1717	5147872000023
49259	1397	1365682702000
49260	1678	14400545398000
49261	1726	687386694000
49262	1874	205306000
49263	1726	687385692000
49264	1874	205308000
49265	1718	5346714763340
49266	1718	5346726763340
49297	1397	1365632697000
49298	1678	14400545403000
49299	1726	687377673000
49300	1874	205327000
49301	1726	687376670000
49302	1874	205330000
49303	1679	27917491711000
49328	1397	1365592693000
49329	1678	14400545407000
49330	1726	687370655000
49331	1874	205345000
49332	1726	687369653000
49333	1874	205347000
49334	1679	28637491711000
49335	1679	28637503711000
49346	1458	10173605908540
49347	1397	1365572691000
49348	1678	14400545409000
49349	1397	1365562690000
49350	1678	14400545410000
49351	1726	687366645000
49352	1874	205355000
49353	1726	687365643000
49354	1874	205357000
49355	1726	687364640000
49356	1874	205360000
49357	1726	687363638000
49358	1874	205362000
49359	1458	10893605908540
49360	1458	10893944908540
49362	1397	1365552689000
49363	1678	14400545411000
49364	1726	687362635000
49365	1874	205365000
49366	1726	687361633000
49367	1874	205367000
49368	1715	30960509000000
49369	1715	30960545000000
49396	1650	5794072000000
49397	1650	5794083000000
49406	1694	7212357127629
49407	1694	7212369127629
49423	1397	1365482682000
49424	1678	14400545418000
49425	1726	687349603000
49426	1874	205397000
49427	1726	687348600000
49428	1874	205400000
49429	2039	5761070000000
49430	2039	5761082000000
49446	1397	1365452679000
49447	1678	14400545421000
49448	1397	1365442678000
49449	1678	14400545422000
49450	1397	1365432677000
49451	1678	14400545423000
49452	1726	687343588000
49453	1874	205412000
49454	1726	687342585000
49455	1874	205415000
49456	1726	687341583000
49457	1874	205417000
49458	1726	687340580000
49459	1874	205420000
49460	1726	687339578000
49461	1874	205422000
49462	1726	687338575000
49463	1874	205425000
49464	633	73804097900000
49494	1761	66720000100000
49495	75	18300002
49496	1690	95764128800000
49533	1726	684904543000
49534	1874	205457000
49535	1726	684903540000
49536	1874	205460000
49537	1726	684902539000
49538	1874	205461000
49539	1726	683692539000
49540	2091	200000000
48784	484	91920754000000
48785	484	91920762000000
48806	1397	1366222756000
48807	1678	14400545344000
48808	1397	1366212755000
48809	1678	14400545345000
48810	1726	687488946000
48811	1874	205054000
48812	1726	687487943000
48813	1874	205057000
48814	1726	687486941000
48815	1874	205059000
48816	1670	6480757000000
48841	1397	1366172751000
48842	1678	14400545349000
48843	1726	687479923000
48844	1874	205077000
48845	1726	687478921000
48846	1874	205079000
48847	1271	1343406302000000
48941	1677	108649647324100
48942	1677	108649667324100
48951	1549	10415676000000
48952	1549	10415692000000
48964	1762	7521785994000
48965	1610	6480910000000
48967	1397	1366022736000
48968	1678	14400545364000
48969	1397	1366012735000
48970	1678	14400545365000
48971	1726	687450852000
48972	1874	205148000
48973	1726	687449849000
48974	1874	205151000
48975	1726	687448847000
48976	1874	205153000
48977	1726	687447844000
48978	1874	205156000
48979	1457	7824177040000
48980	1457	7824201040000
48983	1726	687446842000
48984	1874	205158000
48985	1573	2858843000000
49010	1397	1365992733000
49011	1678	14400545367000
49012	1726	687442832000
49013	1874	205168000
49014	1457	7824190040000
49017	1397	1365982732000
49018	1678	14400545368000
49019	1726	687441829000
49020	1874	205171000
49021	1726	687440827000
49022	1874	205173000
49023	1726	687439824000
49024	1874	205176000
49025	1471	9259564900000
49028	1397	1365972731000
49029	1678	14400545369000
49030	1726	687438822000
49031	1874	205178000
49032	1506	5041040967172
49033	1506	5041051967172
49039	1726	687437819000
49040	1874	205181000
49041	1726	687436817000
49042	1874	205183000
49043	1991	5515663441475
49060	1397	1365932727000
49061	1678	14400545373000
49062	1726	687432808000
49063	1874	205192000
49064	1726	687431805000
49065	1874	205195000
49066	1685	77761445571430
49067	1685	77761457571430
49082	1677	110089667324100
49102	1726	687422783000
49103	1874	205217000
49104	1726	687421780000
49105	1874	205220000
49106	1451	4218803000000
49111	1397	1365862720000
49112	1678	14400545380000
49113	606	71418712812962
49114	2085	0
49115	1726	687420778000
49116	1874	205222000
49117	1726	687419775000
49118	1874	205225000
49119	1637	156964492819997
49120	1726	687418773000
49121	1874	205227000
49122	1637	157684492819997
49123	1637	157684493819997
49146	1677	110809667324100
49147	1397	1365822716000
49148	1678	14400545384000
49149	1726	687412759000
49150	1874	205241000
49151	1683	268275633149541
49161	1594	9985108000000
49162	1594	9985120000000
49214	1726	687398724000
49215	1874	205276000
49216	1726	687397722000
49217	1874	205278000
49218	1685	78481469571430
49240	1683	269715645149541
49249	1397	1365692703000
49250	1678	14400545397000
49251	1726	687388699000
49252	1874	205301000
49253	1726	687387697000
49254	1874	205303000
49255	1649	8203843999992
49256	1649	8203855999992
49267	1397	1365672701000
49268	1678	14400545399000
49269	1397	1365662700000
49270	1678	14400545400000
49271	1726	687384689000
49272	1874	205311000
49273	1726	687383687000
49274	1874	205313000
49275	1726	687382684000
49276	1874	205316000
49277	1726	687381682000
49278	1874	205318000
49279	2086	1439025000000
49280	2086	1439049000000
49304	1397	1365622696000
49305	1678	14400545404000
49306	606	71417702812962
49307	2085	1000000000
49308	1726	687375668000
49309	1874	205332000
49310	1726	687374665000
49311	1874	205335000
49312	1673	11846092000000
49313	1673	11846114000000
49336	1634	8831624641004
49337	1634	8831636641004
49370	1679	28637527711000
49387	1759	7200629999999
49408	1747	2176829000000
49409	1704	1506207000000
49410	1397	1365502684000
49411	1678	14400545416000
49412	1726	687352610000
49413	1874	205390000
49414	1726	687351608000
49415	1874	205392000
49416	1729	12526993000000
49465	633	73803954900000
49474	1397	1365412675000
49475	1678	14400545425000
49476	1677	112249667324100
49477	1677	112249677324100
49497	1397	1365382672000
49498	1678	14400545428000
49499	1726	687330555000
49500	1874	205445000
49501	1726	687329553000
49502	1874	205447000
49503	1447	12394501943000
49504	1447	12394513943000
49507	1397	1365372671000
49508	1678	14400545429000
49509	1750	4171000000
49510	1726	687328550000
49511	1874	205450000
49512	1726	687327548000
49513	1874	205452000
49514	1740	6281225000000
49515	1740	6281238000000
49548	1699	2949759750126
49552	1397	1365332667000
49553	1678	14400545433000
49554	1750	4169000000
49555	1726	683688531000
49556	1874	205469000
49557	1726	683687528000
49558	1874	205472000
49559	1726	683686527000
49068	1471	9979591900000
49124	1397	1365852719000
49125	1678	14400545381000
49126	1397	1365842718000
49127	1678	14400545382000
49128	1726	687417770000
49129	1874	205230000
49130	1726	687416768000
49131	1874	205232000
49132	1726	687415766000
49133	1874	205234000
49134	1679	27917502711000
49135	1726	687414764000
49136	1874	205236000
49137	1726	687413761000
49138	1874	205239000
49139	2086	719000000000
49140	2086	719025000000
49163	1703	2880586000000
49164	1397	1365802714000
49165	1678	14400545386000
49166	1726	687409752000
49167	1874	205248000
49168	1715	30240498000000
49169	1715	30240509000000
49175	1397	1365792713000
49176	1678	14400545387000
49177	1726	687408749000
49178	1874	205251000
49179	1726	687407747000
49180	1874	205253000
49181	1637	158404493819997
49182	1637	158404505819997
49190	1397	1365772711000
49191	1678	14400545389000
49192	1397	1365762710000
49193	1678	14400545390000
49194	1397	1365752709000
49195	1678	14400545391000
49196	1726	687404739000
49197	1874	205261000
49198	1726	687403737000
49199	1874	205263000
49200	1726	687402734000
49201	1874	205266000
49202	1726	687401732000
49203	1874	205268000
49204	1726	687400729000
49205	1874	205271000
49206	1726	687399727000
49207	1874	205273000
49208	1637	159124505819997
49209	1637	159124541819997
49219	1933	720141000000
49220	1397	1365732707000
49221	1678	14400545393000
49222	1397	1365722706000
49223	1678	14400545394000
49224	1726	687396719000
49225	1874	205281000
49226	1726	687395717000
49227	1874	205283000
49228	1726	687394714000
49229	1874	205286000
49230	1726	687393712000
49231	1874	205288000
49232	1506	5041064967172
49257	1513	21600690000000
49258	1513	21600702000000
49281	2087	719024000000
49283	1397	1365652699000
49284	1678	14400545401000
49285	1397	1365642698000
49286	1678	14400545402000
49287	1749	3465028000000
49288	961	504913275000000
49289	1726	687380680000
49290	1874	205320000
49291	1726	687379678000
49292	1874	205322000
49293	1726	687378675000
49294	1874	205325000
49295	1637	159844541819997
49296	1637	159844565819997
49314	1860	43897977700000
49315	2088	12300000
49316	1397	1365612695000
49317	1678	14400545405000
49318	1397	1365602694000
49319	1678	14400545406000
49320	1726	687373663000
49321	1874	205337000
49322	1726	687372660000
49323	1874	205340000
49324	1726	687371658000
49325	1874	205342000
49326	1688	72361800904000
49327	1688	72361833904000
49361	1677	111529667324100
49388	1397	1365522686000
49389	1678	14400545414000
49390	1726	687356620000
49391	1874	205380000
49392	1726	687355618000
49393	1874	205382000
49394	1711	9164485000000
49395	1711	9164497000000
49398	1397	1365512685000
49399	1678	14400545415000
49400	1726	687354615000
49401	1874	205385000
49402	1726	687353613000
49403	1874	205387000
49404	369	91200735000000
49431	1397	1365472681000
49432	1678	14400545419000
49433	1726	687347598000
49434	1874	205402000
49435	1726	687346595000
49436	1874	205405000
49437	1402	33694071319298
49478	1397	1365402674000
49479	1678	14400545426000
49480	1397	1365392673000
49481	1678	14400545427000
49482	1726	687335568000
49483	1874	205432000
49484	1726	687334565000
49485	1874	205435000
49486	1726	687333563000
49487	1874	205437000
49488	1726	687332560000
49489	1874	205440000
49490	1726	687331558000
49491	1874	205442000
49492	1402	34414071319298
49493	1402	34414096319298
49516	1397	1365362670000
49517	1678	14400545430000
49518	1726	687326546000
49519	1874	205454000
49520	1726	687325545000
49521	1874	205455000
49522	1726	686115545000
49523	2089	200000000
49524	1726	684905545000
49525	2090	200000000
49526	1689	5760118287625
49549	2087	1439024000000
49550	2087	1439061000000
49562	1397	1365322666000
49563	1678	14400545434000
49564	1726	683685525000
49565	1874	205475000
49566	1726	683684522000
49567	1874	205478000
49568	1726	683683521000
49569	1874	205479000
49570	1668	9326547000000
49571	1668	9326560000000
49593	1683	268275643149541
49594	1683	269715643149541
49595	1683	269715659149541
49606	1397	1365282662000
49607	1678	14400545438000
49608	1726	683673501000
49609	1874	205499000
49610	1726	683672498000
49611	1874	205502000
49612	1726	683671497000
49613	1874	205503000
49614	1693	12153497155041
49617	1726	683670495000
49618	1874	205505000
49619	1726	683669492000
49620	1874	205508000
49621	1726	683668491000
49622	1874	205509000
49623	1683	269715636149541
49657	1397	1365242658000
49658	1678	14400545442000
49659	1726	683862471000
49660	1874	529000
49661	1726	683861468000
49662	1874	532000
49244	1874	205296000
49245	1726	687389702000
49246	1874	205298000
49247	1506	5761064967172
49248	1506	5761076967172
49282	1699	2949746750126
49338	1397	1365582692000
49339	1678	14400545408000
49340	1726	687368650000
49341	1874	205350000
49342	1726	687367648000
49343	1874	205352000
49344	1607	7458209644388
49345	1607	7458221644388
49371	1397	1365542688000
49372	1678	14400545412000
49373	1726	687360630000
49374	1874	205370000
49375	1726	687359628000
49376	1874	205372000
49377	1458	11613944908540
49378	1458	11613968908540
49379	1397	1365532687000
49380	1678	14400545413000
49381	1726	687358625000
49382	1874	205375000
49383	1726	687357623000
49384	1874	205377000
49385	1693	12153484155041
49386	1693	12153496155041
49405	1746	5554322000000
49417	1397	1365492683000
49418	1678	14400545417000
49419	1726	687350605000
49420	1874	205395000
49421	1419	10541164280064
49422	1419	10541175280064
49438	1397	1365462680000
49439	1678	14400545420000
49440	1726	687345593000
49441	1874	205407000
49442	1726	687344590000
49443	1874	205410000
49444	2039	6481082000000
49445	2039	6481094000000
49466	1397	1365422676000
49467	1678	14400545424000
49468	1726	687337573000
49469	1874	205427000
49470	1726	687336570000
49471	1874	205430000
49472	1688	73081833904000
49473	1688	73081845904000
49505	1623	46082461899898
49506	1623	46082473899898
49527	1397	1365352669000
49528	1678	14400545431000
49529	1397	1365342668000
49530	1678	14400545432000
49531	1750	4170000000
49532	1602	7200385000000
49551	1602	7200401000000
49572	1719	5780320000000
49573	1719	5780333000000
49615	576	72995647938283
49616	576	72995660938283
49624	1397	1365272661000
49625	1678	14400545439000
49626	1726	683667489000
49627	1874	205511000
49628	1726	683666486000
49629	1874	205514000
49630	1726	683665485000
49631	1874	205515000
49632	1683	271155636149541
49633	1683	271155649149541
49667	1693	12873509155041
49677	1759	7920629999999
49678	1759	7920641999999
49681	1594	10705131000000
49723	1397	1365182652000
49724	1678	14400545448000
49725	1397	1365172651000
49726	1678	14400545449000
49727	1726	683848446000
49728	1874	554000
49729	1726	683847444000
49730	1874	556000
49731	1726	683846443000
49732	1874	557000
49733	1726	683845440000
49734	1874	560000
49735	1726	683844438000
49736	1874	562000
49737	1588	11014887000000
49738	1588	11014912000000
49740	1397	1365162650000
49741	1678	14400545450000
49742	1397	1365152649000
49743	1678	14400545451000
49744	1726	683843437000
49745	1874	563000
49746	1726	683842434000
49747	1874	566000
49748	1726	683841432000
49749	1874	568000
49750	1726	683840431000
49751	1874	569000
49752	1726	683839428000
49753	1874	572000
49754	1726	683838426000
49755	1874	574000
49756	1623	46802473899898
49757	1623	46802499899898
49787	1677	113689687324100
49788	1677	113689717324100
49800	1703	2880587000000
49801	1397	1365102644000
49802	1678	14400545456000
49803	1726	683826404000
49804	1874	596000
49805	1726	683825401000
49806	1874	599000
49807	1726	683824399000
49808	1874	601000
49809	1683	272595649149541
49810	1683	272595662149541
49832	1397	1365072641000
49833	1678	14400545459000
49834	1726	683817386000
49835	1874	614000
49836	1726	683816383000
49837	1874	617000
49838	1726	683815381000
49839	1874	619000
49840	1683	274035662149541
49841	1683	274035675149541
49869	1397	1365032637000
49870	1678	14400545463000
49871	1397	1365022636000
49872	1678	14400545464000
49873	1726	682596365000
49874	1874	635000
49875	1726	682595362000
49876	1874	638000
49877	1726	682594360000
49878	1874	640000
49879	1726	682593359000
49880	1874	641000
49881	1726	682592356000
49882	1874	644000
49883	1726	682591354000
49884	1874	646000
49885	1991	6235661441475
49886	1991	6235687441475
49907	1594	10705132000000
49925	1560	9234235277001
49941	43	72480649890000
49942	43	72480674890000
49945	1397	1364952629000
49946	1678	14400545471000
49947	1397	1364942628000
49948	1678	14400545472000
49949	1726	682577332000
49950	1874	668000
49951	1726	682576329000
49952	1874	671000
49953	1726	682575327000
49954	1874	673000
49955	1726	682574326000
49956	1874	674000
49957	1726	682573324000
49958	1874	676000
49959	1518	7920317000000
49960	1518	7920342000000
49980	1397	1364912625000
49981	1678	14400545475000
49982	1397	1364902624000
49983	1678	14400545476000
49984	1726	682567314000
49985	1874	686000
49986	1726	682566312000
49987	1874	688000
49988	1726	682565311000
49989	1874	689000
49541	1726	683691537000
49542	1874	205463000
49543	1726	683690534000
49544	1874	205466000
49545	1726	683689533000
49546	1874	205467000
49547	2086	1439062000000
49646	1397	1365252659000
49647	1678	14400545441000
49648	1726	683865477000
49649	1874	523000
49650	1726	683864474000
49651	1874	526000
49652	1726	683863473000
49653	1874	527000
49654	1768	7790675110000
49655	1768	7790688110000
49656	1768	7790685110000
49682	1397	1365222656000
49683	1678	14400545444000
49684	1726	683857462000
49685	1874	538000
49686	1726	683856461000
49687	1874	539000
49688	1924	1199000000
49689	1654	10367948000000
49690	1654	10367961000000
49700	1397	1365202654000
49701	1678	14400545446000
49702	1726	683855459000
49703	1874	541000
49704	1726	683854456000
49705	1874	544000
49706	1726	683853455000
49707	1874	545000
49708	1726	683852453000
49709	1874	547000
49710	1726	683851450000
49711	1874	550000
49712	1739	23759690000000
49713	1739	23759705000000
49811	1397	1365092643000
49812	1678	14400545457000
49813	1726	683823398000
49814	1874	602000
49815	1726	683822395000
49816	1874	605000
49817	1726	683821393000
49818	1874	607000
49819	1637	160564565819997
49820	1637	160564578819997
49842	1513	21600700000000
49891	1397	1365012635000
49892	1678	14400545465000
49893	1726	682590353000
49894	1874	647000
49895	1726	682589351000
49896	1874	649000
49897	1518	7200305000000
49898	1518	7200317000000
49961	1419	11261175280064
49962	1419	11261200280064
49966	1397	1364932627000
49967	1678	14400545473000
49968	1397	1364922626000
49969	1678	14400545474000
49970	1726	682571321000
49971	1874	679000
49972	1726	682570320000
49973	1874	680000
49974	1726	682569317000
49975	1874	683000
49976	1726	682568315000
49977	1874	685000
49978	1602	7920385000000
49979	1602	7920410000000
49993	641	70659812000000
49994	641	70659836000000
49999	1397	1364892623000
50000	1678	14400545477000
50001	1687	5032538524804
50099	1397	1364762610000
50100	1678	14400545490000
50101	1726	682535261000
50102	1874	739000
50103	1726	682534260000
50104	1874	740000
50105	1654	11087961000000
50106	1654	11087973000000
50140	1709	5040064000000
50165	1397	1364692603000
50166	1678	14400545497000
50167	1726	682518231000
50168	1874	769000
50169	1726	682517228000
50170	1874	772000
50171	1726	682516226000
50172	1874	774000
50173	1715	30960522000000
50176	1397	1364682602000
50177	1678	14400545498000
50178	1726	682515225000
50179	1874	775000
50180	1726	682514223000
50181	1874	777000
50182	1419	11981188280064
50183	1419	11981200280064
50184	1397	1364672601000
50185	1678	14400545499000
50186	1397	1364662600000
50187	1678	14400545500000
50188	1397	1364652599000
50189	1678	14400545501000
50190	1726	682513222000
50191	1874	778000
50192	1726	682512220000
50193	1874	780000
50194	1726	682511217000
50195	1874	783000
50196	1726	682510216000
50197	1874	784000
50198	1726	682509214000
50199	1874	786000
50200	1726	682508211000
50201	1874	789000
50202	1726	682507210000
50203	1874	790000
50204	1726	682506208000
50205	1874	792000
50206	1726	682505205000
50207	1874	795000
50208	1683	276915710149541
50209	1683	276915749149541
50230	1506	6481076967172
50231	1506	6481089967172
50236	1726	682498192000
50237	1874	808000
50238	1726	682497189000
50239	1874	811000
50240	1726	682496187000
50241	1874	813000
50242	1649	10363883999992
50243	1649	10363896999992
50298	1397	1364552589000
50299	1678	14400545511000
50300	1729	12527005000000
50301	1726	682479154000
50302	1874	846000
50303	1726	682478153000
50304	1874	847000
50305	1726	682477151000
50306	1874	849000
50307	1729	13247005000000
50308	1729	13247011000000
50310	1703	2160577000000
50311	1703	2880577000000
50312	1447	2880580001000
50313	1703	11674502942000
50314	2069	201000000
50323	1397	1364542588000
50324	1678	14400545512000
50325	1768	8510695110000
50371	1397	1364482582000
50372	1678	14400545518000
50373	1726	682460123000
50374	1874	877000
50375	1726	682459121000
50376	1874	879000
50377	1426	10364841000000
50378	1426	10364853000000
50381	1397	1364472581000
50382	1678	14400545519000
50383	1726	682458120000
50384	1874	880000
50385	1726	682457118000
50386	1874	882000
50387	1683	279795800149541
50388	1683	279795812149541
50443	1607	8178231644388
50454	1677	115129717324100
50455	1677	115129727324100
50511	1506	6481112967172
50557	1397	1364262560000
50558	1678	14400545540000
50559	1397	1364252559000
49560	1874	205473000
49561	1687	3592490524804
49574	1397	1365312665000
49575	1678	14400545435000
49576	1587	7920344000000
49577	1397	1365302664000
49578	1678	14400545436000
49579	1726	683682519000
49580	1874	205481000
49581	1726	683681516000
49582	1874	205484000
49583	1726	683680515000
49584	1874	205485000
49585	1726	683679513000
49586	1874	205487000
49587	1726	683678510000
49588	1874	205490000
49589	1726	683677509000
49590	1874	205491000
49591	1587	8640344000000
49592	1587	8640360000000
49596	1397	1365292663000
49597	1678	14400545437000
49598	1726	683676507000
49599	1874	205493000
49600	1726	683675504000
49601	1874	205496000
49602	1726	683674503000
49603	1874	205497000
49604	1698	8456943550035
49605	1698	8456956550035
49634	1397	1365262660000
49635	1678	14400545440000
49636	1726	683664483000
49637	1874	205517000
49638	1874	517000
49639	1726	683868483000
49640	1726	683867480000
49641	1874	520000
49642	1726	683866479000
49643	1874	521000
49644	1724	6429309000000
49645	532	68160026000000
49668	1397	1365232657000
49669	1678	14400545443000
49670	1726	683859465000
49671	1874	535000
49672	1726	683858464000
49673	1874	536000
49674	1717	5867872000023
49675	1717	5867884000023
49691	1688	73801845904000
49692	1688	73801858904000
49714	1397	1365192653000
49715	1678	14400545447000
49716	1726	683850449000
49717	1874	551000
49718	1726	683849447000
49719	1874	553000
49720	1688	73801857904000
49739	1569	721835000000
49758	1690	95764158800000
49759	1690	96484158800000
49760	1690	10954478942000
49761	1447	96484196801992
49762	1571	15840301001008
49789	1397	1365112645000
49790	1678	14400545455000
49791	1726	683829410000
49792	1874	590000
49793	1726	683828407000
49794	1874	593000
49795	1726	683827405000
49796	1874	595000
49797	1649	8923855999992
49798	1649	8923868999992
49887	1693	13593513155041
49888	1693	13593539155041
49908	1397	1364992633000
49909	1678	14400545467000
49910	1726	682586347000
49911	1874	653000
49912	1726	682585345000
49913	1874	655000
49914	1637	162004590819997
49915	1637	162004602819997
49916	1397	1364982632000
49917	1678	14400545468000
49918	1726	682584344000
49919	1874	656000
49920	1726	682583342000
49921	1874	658000
49922	1608	9645547000000
49923	1608	9645559000000
49943	1718	6066726763340
49944	1718	6066751763340
49963	1726	682572323000
49964	1874	677000
49965	470	73920333000000
49995	1687	5032528524804
49996	1687	5032549524804
50002	1726	682563308000
50003	1874	692000
50004	1726	682562305000
50005	1874	695000
50006	1726	682561303000
50007	1874	697000
50008	1419	11261188280064
50010	1397	1364882622000
50011	1678	14400545478000
50012	1397	1364872621000
50013	1678	14400545479000
50014	1726	682560302000
50015	1874	698000
50016	1726	682559300000
50017	1874	700000
50018	1726	682558299000
50019	1874	701000
50020	1726	682557296000
50021	1874	704000
50022	1726	682556294000
50023	1874	706000
50024	1569	834000000
50025	485	67438999000000
50026	1688	74521857904000
50027	1688	74521883904000
50028	1397	1364862620000
50029	1678	14400545480000
50030	1726	682555293000
50031	1874	707000
50032	1726	682554290000
50033	1874	710000
50034	1726	682553288000
50035	1874	712000
50036	1688	75241883904000
50037	1688	75241896904000
50056	1726	682548281000
50057	1874	719000
50058	1726	682547279000
50059	1874	721000
50060	1726	682546278000
50061	1874	722000
50062	1683	274035710149541
50063	1683	275475710149541
50107	1397	1364752609000
50108	1678	14400545491000
50109	1397	1364742608000
50110	1678	14400545492000
50111	1750	4168000000
50112	1726	682533259000
50113	1874	741000
50114	1726	682532258000
50115	1874	742000
50116	1726	682531256000
50117	1874	744000
50118	1711	9884497000000
50119	1711	9884521000000
50151	1397	1364702604000
50152	1678	14400545496000
50153	1726	682521237000
50154	1874	763000
50155	1726	682520234000
50156	1874	766000
50157	1726	682519232000
50158	1874	768000
50159	1670	7920769000000
50160	1670	7920782000000
50163	1677	114409707324100
50164	1677	114409717324100
50174	1679	29357527711000
50175	1679	29357540711000
50244	1746	5554320000000
50282	1397	1364562590000
50283	1678	14400545510000
50284	1726	682484165000
50285	1874	835000
50286	1726	682483163000
50287	1874	837000
50288	1726	682482160000
50289	1874	840000
50290	1726	682481159000
50291	1874	841000
50292	1726	682480157000
50293	1874	843000
50294	1597	1440035000000
49663	1726	683860467000
49664	1874	533000
49665	1693	12873497155041
49666	1693	12873513155041
49676	576	72995659938283
49679	1594	10705120000000
49680	1594	10705133000000
49693	1708	4356611000021
49694	1708	5076611000021
49695	1708	5076951000021
49696	1397	1365212655000
49697	1678	14400545445000
49698	1677	112969677324100
49699	1677	112969687324100
49721	1569	721810000000
49722	1569	721895000000
49763	1397	1365142648000
49764	1678	14400545452000
49765	1397	1365132647000
49766	1678	14400545453000
49767	1397	1365122646000
49768	1678	14400545454000
49769	1726	683837425000
49770	1874	575000
49771	1726	683836422000
49772	1874	578000
49773	1726	683835420000
49774	1874	580000
49775	1726	683834419000
49776	1874	581000
49777	1726	683833417000
49778	1874	583000
49779	1726	683832416000
49780	1874	584000
49781	1726	683831413000
49782	1874	587000
49783	1726	683830411000
49784	1874	589000
49785	1687	4312490524804
49786	1687	4312528524804
49799	1702	3600239000000
49821	1397	1365082642000
49822	1678	14400545458000
49823	1942	198000000
49824	1726	683820392000
49825	1874	608000
49826	1726	683819389000
49827	1874	611000
49828	1726	683818387000
49829	1874	613000
49830	1649	9643868999992
49831	1649	9643883999992
49843	1397	1365062640000
49844	1678	14400545460000
49845	1397	1365052639000
49846	1678	14400545461000
49847	1397	1365042638000
49848	1678	14400545462000
49849	1726	683814380000
49850	1874	620000
49851	1726	683813377000
49852	1874	623000
49853	1726	683812375000
49854	1874	625000
49855	1726	683811374000
49856	1874	626000
49857	1726	683810372000
49858	1874	628000
49859	1726	682600372000
49860	2092	200000000
49861	1726	682599371000
49862	1874	629000
49863	1726	682598368000
49864	1874	632000
49865	1726	682597366000
49866	1874	634000
49867	1457	8544190040000
49868	1457	8544241040000
49889	1439	7492312998477
49890	1439	7492338998477
49899	1397	1365002634000
49900	1678	14400545466000
49901	1726	682588350000
49902	1874	650000
49903	1726	682587348000
49904	1874	652000
49905	1637	161284578819997
49906	1637	161284590819997
49924	1448	3636699000001
49926	1397	1364972631000
49927	1678	14400545469000
49928	1397	1364962630000
49929	1678	14400545470000
49930	1726	682582339000
49931	1874	661000
49932	1726	682581338000
49933	1874	662000
49934	1726	682580336000
49935	1874	664000
49936	1726	682579335000
49937	1874	665000
49938	1726	682578333000
49939	1874	667000
49940	1683	274035687149541
49997	1687	5032552524804
50009	1687	5032541524804
50038	1397	1364852619000
50039	1678	14400545481000
50040	1397	1364842618000
50041	1678	14400545482000
50042	1726	682552287000
50043	1874	713000
50044	1726	682551285000
50045	1874	715000
50046	1726	682550284000
50047	1874	716000
50048	1726	682549282000
50049	1874	718000
50050	1759	7920653999999
50064	1397	1364812615000
50065	1678	14400545485000
50066	1397	1364802614000
50067	1678	14400545486000
50068	1677	113689707324100
50091	1397	1364772611000
50092	1678	14400545489000
50093	1726	682537264000
50094	1874	736000
50095	1726	682536263000
50096	1874	737000
50097	1637	162724602819997
50098	1637	162724614819997
50120	1397	1364732607000
50121	1678	14400545493000
50122	1397	1364722606000
50123	1678	14400545494000
50124	1926	1199000000
50125	1709	5040037000000
50126	1709	5040058000000
50161	506	66720000000000
50162	506	66720010000000
50210	1397	1364642598000
50211	1678	14400545502000
50212	1726	682504204000
50213	1874	796000
50214	1726	682503202000
50215	1874	798000
50216	1726	682502199000
50217	1874	801000
50218	1688	75961896904000
50219	1688	75961909904000
50245	1747	2176830000000
50246	1397	1364612595000
50247	1678	14400545505000
50248	1397	1364602594000
50249	1678	14400545506000
50250	1397	1364592593000
50251	1678	14400545507000
50252	1397	1364582592000
50253	1678	14400545508000
50254	1726	682495186000
50255	1874	814000
50256	1726	682494184000
50257	1874	816000
50258	1726	682493183000
50259	1874	817000
50260	1726	682492181000
50261	1874	819000
50262	1726	682491178000
50263	1874	822000
50264	1726	682490177000
50265	1874	823000
50266	1726	682489175000
50267	1874	825000
50268	1726	682488172000
50269	1874	828000
50270	1726	682487171000
50271	1874	829000
50272	1726	682486169000
50273	1874	831000
50274	1726	682485166000
50275	1874	834000
50276	1683	278355749149541
50277	1683	278355800149541
50296	1688	77401919904000
49990	1726	682564309000
49991	1874	691000
49992	58	76746351999659
49998	641	70659832000000
50051	1397	1364832617000
50052	1678	14400545483000
50053	1397	1364822616000
50054	1678	14400545484000
50055	1708	5075721000021
50069	1397	1364792613000
50070	1678	14400545487000
50071	1397	1364782612000
50072	1678	14400545488000
50073	1726	682545276000
50074	1874	724000
50075	1726	682544275000
50076	1874	725000
50077	1726	682543273000
50078	1874	727000
50079	1726	682542272000
50080	1874	728000
50081	1726	682541270000
50082	1874	730000
50083	1726	682540269000
50084	1874	731000
50085	1726	682539267000
50086	1874	733000
50087	1726	682538266000
50088	1874	734000
50089	43	73200674890000
50090	43	73200702890000
50127	1726	682530255000
50128	1874	745000
50129	1726	682529252000
50130	1874	748000
50131	1726	682528250000
50132	1874	750000
50133	1726	682527249000
50134	1874	751000
50135	1726	682526246000
50136	1874	754000
50137	1726	682525244000
50138	1874	756000
50139	1447	12394528943000
50141	1397	1364712605000
50142	1678	14400545495000
50143	1726	682524243000
50144	1874	757000
50145	1726	682523240000
50146	1874	760000
50147	1726	682522238000
50148	1874	762000
50149	1601	11018655600000
50150	1601	11018674600000
50220	1397	1364632597000
50221	1678	14400545503000
50222	1726	682501198000
50223	1874	802000
50224	1726	682500195000
50225	1874	805000
50226	1726	682499193000
50227	1874	807000
50228	1613	6407786600000
50229	1613	6407799600000
50232	1397	1364622596000
50233	1678	14400545504000
50234	1704	2226207000000
50235	1704	2226217000000
50278	1397	1364572591000
50279	1678	14400545509000
50280	1688	76681909904000
50281	1688	76681919904000
50309	1702	3600244000000
50315	1726	682476148000
50316	1874	852000
50317	1726	682475147000
50318	1874	853000
50319	1726	682474145000
50320	1874	855000
50321	1768	8510685110000
50322	1768	8510688110000
50338	1740	7001251000000
50339	1397	1364522586000
50340	1678	14400545514000
50341	1726	682470138000
50342	1874	862000
50343	1726	682469136000
50344	1874	864000
50364	1397	1364492583000
50365	1678	14400545517000
50366	1726	682462126000
50367	1874	874000
50368	1726	682461124000
50369	1874	876000
50370	1622	21599491999976
50413	1685	79201469571430
50414	1685	79201481571430
50441	1683	281235812149541
50442	1683	281235825149541
50453	1724	6429311000000
50509	1673	12566114000000
50510	1673	12566150000000
50532	1397	1364292563000
50533	1678	14400545537000
50534	1397	1364282562000
50535	1678	14400545538000
50536	1397	1364272561000
50537	1678	14400545539000
50538	1726	682420058000
50539	1874	942000
50540	1726	682419057000
50541	1874	943000
50542	1726	682418055000
50543	1874	945000
50544	1683	279795845149541
50545	1726	682417054000
50546	1874	946000
50547	1726	682416052000
50548	1874	948000
50549	1726	682415051000
50550	1874	949000
50551	1726	681205051000
50552	2093	200000000
50553	1726	679995051000
50554	2094	200000000
50555	1683	281235845149541
50556	1683	281235868149541
50573	1397	1364242558000
50574	1678	14400545542000
50575	2094	199000000
50576	1571	15840301001032
50577	1687	5032528524796
50578	1571	5032539524788
50579	1687	15840301001040
50597	1726	679986037000
50598	1874	963000
50599	1726	679985036000
50600	1874	964000
50601	1726	679984034000
50602	1874	966000
50603	1726	679983033000
50604	1874	967000
50605	606	72137738812962
50607	1397	1364202554000
50608	1678	14400545546000
50609	1726	679982031000
50610	1874	969000
50611	1726	679981030000
50612	1874	970000
50613	1727	6666703000000
50615	1397	1364192553000
50616	1678	14400545547000
50617	1726	679980028000
50618	1874	972000
50619	407	66720000000000
50620	407	66720013000000
50643	1397	1364162550000
50644	1678	14400545550000
50645	1726	678764019000
50646	1874	981000
50647	1726	678763018000
50648	1874	982000
50649	1715	31680522000000
50650	1715	31680534000000
50676	1397	1364122546000
50677	1678	14400545554000
50678	1726	677546007000
50679	1874	993000
50680	1726	677545006000
50681	1874	994000
50682	1634	10271699641004
50683	1634	10271711641004
50692	1768	9231119110000
50702	1397	1364092543000
50703	1678	14400545557000
50704	1397	1364082542000
50705	1678	14400545558000
50706	1726	677539998000
50707	1874	1002000
50708	1726	677538997000
50709	1874	1003000
50710	1726	677537995000
50711	1874	1005000
50712	1726	677536994000
50713	1874	1006000
50295	1597	2160035000000
50326	1397	1364532587000
50327	1678	14400545513000
50328	1726	682473142000
50329	1874	858000
50330	1726	682472141000
50331	1874	859000
50332	1726	682471139000
50333	1874	861000
50334	1762	8241785994000
50335	1762	8241808994000
50345	1397	1364512585000
50346	1678	14400545515000
50347	1397	1364502584000
50348	1678	14400545516000
50349	1726	682468135000
50350	1874	865000
50351	1726	682467133000
50352	1874	867000
50353	1726	682466132000
50354	1874	868000
50355	1726	682465130000
50356	1874	870000
50357	1726	682464129000
50358	1874	871000
50359	1726	682463127000
50360	1874	873000
50361	58	77466351999659
50362	58	77466377999659
50379	1637	163444614819997
50380	1637	163444626819997
50389	576	73715659938283
50390	576	73715671938283
50397	1397	1364462580000
50398	1678	14400545520000
50399	1726	682456117000
50400	1874	883000
50401	1726	682455115000
50402	1874	885000
50403	1573	3578843000000
50404	1573	3578855000000
50415	1397	1364442578000
50416	1678	14400545522000
50417	1397	1364432577000
50418	1678	14400545523000
50419	1726	682452111000
50420	1874	889000
50421	1726	682451109000
50422	1874	891000
50423	1726	682450106000
50424	1874	894000
50425	1726	682449105000
50426	1874	895000
50427	1726	682448103000
50428	1874	897000
50429	1649	11083896999992
50430	1649	11083921999992
50456	532	68880026000000
50457	532	68880039000000
50458	1397	1364402574000
50459	1678	14400545526000
50460	1397	1364392573000
50461	1678	14400545527000
50462	1397	1364382572000
50463	1678	14400545528000
50464	1397	1364372571000
50465	1678	14400545529000
50466	1397	1364362570000
50467	1678	14400545530000
50468	1653	8000000
50469	2077	1439000000000
50470	1726	682441090000
50471	1874	910000
50472	1726	682440088000
50473	1874	912000
50474	1726	682439087000
50475	1874	913000
50476	1726	682438085000
50477	1874	915000
50478	1726	682437084000
50479	1874	916000
50480	1726	682436082000
50481	1874	918000
50482	1726	682435081000
50483	1874	919000
50484	1726	682434079000
50485	1874	921000
50486	1726	682433078000
50487	1874	922000
50488	1634	9551636641004
50489	1634	9551699641004
50571	1709	20000000
50572	1647	5760059999976
50614	1727	6666701000000
50634	1691	7163038100019
50655	1397	1364152549000
50656	1678	14400545551000
50657	1397	1364142548000
50658	1678	14400545552000
50659	1397	1364132547000
50660	1678	14400545553000
50661	1726	678762016000
50662	1874	984000
50663	1726	678761015000
50664	1874	985000
50665	1726	678760013000
50666	1874	987000
50667	1726	678759012000
50668	1874	988000
50669	1726	678758010000
50670	1874	990000
50671	1726	678757009000
50672	1874	991000
50673	1726	677547009000
50674	2096	200000000
50675	1547	6333272000000
50684	1397	1364112545000
50685	1678	14400545555000
50686	1726	677544004000
50687	1874	996000
50688	1726	677543003000
50689	1874	997000
50690	1768	9230688110000
50691	1768	9230758110000
50693	1768	9230700110000
50718	1397	1364072541000
50719	1678	14400545559000
50720	1471	9979585900000
50754	1397	1364032537000
50755	1678	14400545563000
50756	1726	677527980000
50757	1874	1020000
50758	1726	677526979000
50759	1874	1021000
50760	1726	676316979000
50761	2097	200000000
50762	1691	7163048100019
50784	1726	676311971000
50785	1874	1029000
50786	1685	79201470571430
50801	641	70659824000000
50814	1397	1363972531000
50815	1678	14400545569000
50816	1726	676304961000
50817	1874	1039000
50818	1726	676303959000
50819	1874	1041000
50820	1397	1363962530000
50821	1678	14400545570000
50822	1726	676302958000
50823	1874	1042000
50824	1726	676301956000
50825	1874	1044000
50826	2086	1439037000000
50837	1447	12394511943000
50849	1654	13247997000000
50850	1654	13248011000000
50868	1693	15033575155041
50869	1693	15033587155041
50905	1397	1363862520000
50906	1678	14400545580000
50907	1622	22140751904589
50908	169	66178742095387
50909	1622	20773033272869
50910	990	504145483631720
50911	1622	18322101123349
50912	1110	903424387149520
50913	1622	16668405110994
50914	1230	609558436012355
50915	1622	12060252000014
50916	1356	1698588780862630
50917	1726	676283929000
50918	1874	1071000
50919	1726	676282928000
50920	1874	1072000
50921	1683	291315962149541
50922	1683	291316024149541
50941	1717	6587896000023
51014	1397	1363762510000
51015	1678	14400545590000
51016	1397	1363752509000
51017	1678	14400545591000
51018	1397	1363742508000
51019	1678	14400545592000
51020	1726	676262896000
50297	1688	77401929904000
50336	1740	7001238000000
50337	1740	7001261000000
50363	1588	11014908000000
50391	1509	9312817851147
50392	1509	10032817851147
50393	1509	66000050000000
50394	289	10033146851140
50395	1571	261999988
50396	1527	15840301001016
50405	1397	1364452579000
50406	1678	14400545521000
50407	1726	682454114000
50408	1874	886000
50409	1726	682453112000
50410	1874	888000
50411	1654	11807973000000
50412	1654	11807985000000
50431	1397	1364422576000
50432	1678	14400545524000
50433	1726	682447100000
50434	1874	900000
50435	1726	682446099000
50436	1874	901000
50437	1726	682445097000
50438	1874	903000
50439	1607	8178221644388
50440	1607	8178234644388
50444	1397	1364412575000
50445	1678	14400545525000
50446	1726	682444094000
50447	1874	906000
50448	1726	682443093000
50449	1874	907000
50450	1726	682442091000
50451	1874	909000
50452	1448	3636703000001
50490	1397	1364352569000
50491	1678	14400545531000
50492	1397	1364342568000
50493	1678	14400545532000
50494	1397	1364332567000
50495	1678	14400545533000
50496	1726	682432076000
50497	1874	924000
50498	1726	682431075000
50499	1874	925000
50500	1726	682430073000
50501	1874	927000
50502	1726	682429072000
50503	1874	928000
50504	1726	682428070000
50505	1874	930000
50506	1726	682427069000
50507	1874	931000
50508	1447	12394537943000
50512	1397	1364322566000
50513	1678	14400545534000
50514	1397	1364312565000
50515	1678	14400545535000
50516	1397	1364302564000
50517	1678	14400545536000
50518	1726	682426067000
50519	1874	933000
50520	1726	682425066000
50521	1874	934000
50522	1726	682424064000
50523	1874	936000
50524	1726	682423063000
50525	1874	937000
50526	1726	682422061000
50527	1874	939000
50528	1726	682421060000
50529	1874	940000
50530	1693	14313539155041
50531	1693	14313575155041
50585	1397	1364232557000
50586	1678	14400545543000
50587	1397	1364222556000
50588	1678	14400545544000
50589	1397	1364212555000
50590	1678	14400545545000
50591	1726	679988040000
50592	1874	960000
50593	1726	679987039000
50594	1874	961000
50595	606	72137702812962
50596	606	72137734812962
50606	1474	6754394000023
50635	1688	78121929904000
50636	1688	78121939904000
50637	1397	1364172551000
50638	1678	14400545549000
50639	1726	678766022000
50640	1874	978000
50641	1726	678765021000
50642	1874	979000
50653	1683	282675868149541
50654	1683	282675880149541
50694	1397	1364102544000
50695	1678	14400545556000
50696	1726	677542001000
50697	1874	999000
50698	1726	677541000000
50699	1874	1000000
50700	1683	284115880149541
50701	1683	284115892149541
50721	1726	677535992000
50722	1874	1008000
50723	1726	677534991000
50724	1874	1009000
50725	1471	9979587900000
50734	1397	1364052539000
50735	1678	14400545561000
50736	1726	677531986000
50737	1874	1014000
50738	1726	677530985000
50739	1874	1015000
50740	2077	1438998000000
50741	1695	6812138000000
50742	1695	6812151000000
50763	1683	286995916149541
50764	1683	286995938149541
50781	1522	5374035000000
50782	1522	6094035000000
50783	1522	6094036000000
50803	1397	1363982532000
50804	1678	14400545568000
50805	1726	676306964000
50806	1874	1036000
50807	1726	676305962000
50808	1874	1038000
50809	1696	8417284840000
50810	1696	8417298840000
50813	1696	8417296840000
50827	2087	1439036000000
50829	1729	13967011000000
50830	1729	13967023000000
50838	1476	7200088000000
50839	1476	7200098000000
50851	1588	11014897000000
50859	1747	2176833000000
50870	1693	15033586155041
50875	1397	1363902524000
50876	1678	14400545576000
50877	1397	1363892523000
50878	1678	14400545577000
50879	1397	1363882522000
50880	1678	14400545578000
50881	1726	676292943000
50882	1874	1057000
50883	1726	676291941000
50884	1874	1059000
50885	1726	676290940000
50886	1874	1060000
50887	1726	676289938000
50888	1874	1062000
50889	1726	676288937000
50890	1874	1063000
50891	1726	676287935000
50892	1874	1065000
50893	1726	676286934000
50894	1874	1066000
50895	633	74523954900000
50896	633	74523991900000
50923	1695	6812200000000
50942	1622	20700727904589
50943	1622	19333009272869
50944	1622	16882077123349
50945	1622	15228381110994
50946	1622	10620228000014
50947	1768	9951119110000
50948	1768	9951431110000
50969	1397	1363822516000
50970	1678	14400545584000
50971	1397	1363812515000
50972	1678	14400545585000
50973	1397	1363802514000
50974	1678	14400545586000
50975	1726	676275917000
50976	1874	1083000
50977	1726	676274916000
50978	1874	1084000
50979	1726	676273914000
50980	1874	1086000
50560	1678	14400545541000
50561	1726	679994049000
50562	1874	951000
50563	1726	679993048000
50564	1874	952000
50565	1726	679992046000
50566	1874	954000
50567	1726	679991045000
50568	1874	955000
50569	1709	5760058000000
50570	1709	5760082000000
50580	1726	679990043000
50581	1874	957000
50582	1726	679989042000
50583	1874	958000
50584	1687	5032543524804
50621	1726	679979027000
50622	1874	973000
50623	1726	678769027000
50624	2095	200000000
50625	1762	8961808994000
50626	1762	8961832994000
50627	1397	1364182552000
50628	1678	14400545548000
50629	1726	678768025000
50630	1874	975000
50631	1726	678767024000
50632	1874	976000
50633	1992	8639209990000
50651	1440	5759073000000
50652	1440	5759085000000
50726	1397	1364062540000
50727	1678	14400545560000
50728	1726	677533989000
50729	1874	1011000
50730	1726	677532988000
50731	1874	1012000
50732	2077	1438999000000
50733	1448	3636700000001
50745	1633	6516336985638
50765	1685	79201491571430
50766	1397	1364022536000
50767	1678	14400545564000
50768	1397	1364012535000
50769	1678	14400545565000
50770	1726	676315977000
50771	1874	1023000
50772	1726	676314976000
50773	1874	1024000
50774	1726	676313974000
50775	1874	1026000
50776	1991	5515684441475
50777	1726	676312973000
50778	1874	1027000
50779	1991	6235684441475
50780	1991	6235685441475
50795	1397	1363992533000
50796	1678	14400545567000
50797	1726	676308967000
50798	1874	1033000
50799	1726	676307965000
50800	1874	1035000
50828	1699	2949734750126
50831	1397	1363952529000
50832	1678	14400545571000
50833	1726	676300955000
50834	1874	1045000
50835	1726	676299953000
50836	1874	1047000
50841	1397	1363942528000
50842	1678	14400545572000
50843	1726	676298952000
50844	1874	1048000
50845	1726	676297950000
50846	1874	1050000
50847	1698	9176956550035
50848	1698	9176970550035
50852	1397	1363932527000
50853	1678	14400545573000
50854	1726	676296949000
50855	1874	1051000
50856	1726	676295947000
50857	1874	1053000
50858	1704	2226223000000
50860	1397	1363922526000
50861	1678	14400545574000
50862	1726	676294946000
50863	1874	1054000
50864	1726	676293944000
50865	1874	1056000
50866	1467	28802455100000
50867	1467	28802467100000
50871	1397	1363912525000
50872	1678	14400545575000
50873	1705	7120483500145
50874	1705	7120493500145
50926	1622	21420739904589
50927	1622	20053021272869
50928	1622	17602089123349
50929	1622	15948393110994
50930	1622	11340240000014
50931	1564	7746353000000
50932	1564	7746735000000
50933	1397	1363852519000
50934	1678	14400545581000
50935	1726	676281926000
50936	1874	1074000
50937	1726	676280925000
50938	1874	1075000
50939	1457	9264241040000
50940	1457	9264253040000
50951	1397	1363842518000
50952	1678	14400545582000
50953	1726	676279923000
50954	1874	1077000
50955	1726	676278922000
50956	1874	1078000
50957	1689	6480118287625
50958	1689	6480130287625
50967	1587	9360360000000
50968	1587	9360372000000
50998	1397	1363782512000
50999	1678	14400545588000
51000	1397	1363772511000
51001	1678	14400545589000
51002	1726	676267905000
51003	1874	1095000
51004	1726	676266904000
51005	1874	1096000
51006	1726	676265902000
51007	1874	1098000
51008	1726	676264899000
51009	1874	1101000
51010	1726	676263898000
51011	1874	1102000
51012	1764	6486776100000
51013	1764	6486801100000
51051	2058	560500000
51052	1397	1363722506000
51053	1678	14400545594000
51054	1726	676250872000
51055	1874	1128000
51056	1726	676249869000
51057	1874	1131000
51058	1726	676248868000
51059	1874	1132000
51060	369	91200747000000
51085	1593	7749862000000
51086	1397	1363692503000
51087	1678	14400545597000
51088	1726	675031854000
51089	1874	1146000
51090	1726	675030851000
51091	1874	1149000
51092	1402	35134096319298
51093	1402	35134108319298
51095	1397	1363682502000
51096	1678	14400545598000
51097	1726	675029850000
51098	1874	1150000
51099	1726	675028848000
51100	1874	1152000
51101	1726	675027845000
51102	1874	1155000
51103	1694	7212370127629
51114	1608	9645557000000
51115	1397	1363662500000
51116	1678	14400545600000
51117	1726	675024838000
51118	1874	1162000
51119	1726	675023837000
51120	1874	1163000
51121	1726	675022834000
51122	1874	1166000
51123	1397	1363652499000
51124	1678	14400545601000
51125	1397	1363642498000
51126	1678	14400545602000
51127	1397	1363632497000
51128	1678	14400545603000
51129	1397	1363622496000
51130	1678	14400545604000
51131	1397	1363612495000
51132	1678	14400545605000
51133	1397	1363602494000
50714	1683	285555892149541
50715	1683	285555916149541
50716	1471	9979575900000
50717	1471	9979578900000
50743	1717	6587884000023
50744	1717	6587897000023
50746	1397	1364042538000
50747	1678	14400545562000
50748	1726	677529983000
50749	1874	1017000
50750	1726	677528982000
50751	1874	1018000
50752	1622	22319491999976
50753	1622	22319503999976
50787	1397	1364002534000
50788	1678	14400545566000
50789	1726	676310970000
50790	1874	1030000
50791	1726	676309968000
50792	1874	1032000
50793	1683	288435938149541
50794	1683	288435950149541
50802	641	70659822000000
50811	1654	12527985000000
50812	1654	12527997000000
50840	1476	7200100000000
50897	1397	1363872521000
50898	1678	14400545579000
50899	1726	676285932000
50900	1874	1068000
50901	1726	676284931000
50902	1874	1069000
50903	1683	289875950149541
50904	1683	289875962149541
50924	632	93360797000000
50925	632	93360859000000
50949	1768	9950700110000
50950	1768	9950712110000
50959	1397	1363832517000
50960	1678	14400545583000
50961	1726	676277920000
50962	1874	1080000
50963	1726	676276919000
50964	1874	1081000
50965	1683	292756024149541
50966	1683	292756036149541
50989	2058	571500000
50990	2047	40500000
50991	1397	1363792513000
50992	1678	14400545587000
50993	1726	676269908000
50994	1874	1092000
50995	1726	676268907000
50996	1874	1093000
50997	1688	78121952904000
51063	1397	1363712505000
51064	1678	14400545595000
51065	1726	676247866000
51066	1874	1134000
51067	1726	676246863000
51068	1874	1137000
51069	1726	676245862000
51070	1874	1138000
51071	1610	6480233000000
51074	1726	675035862000
51075	2098	200000000
51076	1397	1363702504000
51077	1678	14400545596000
51078	1726	675034860000
51079	1874	1140000
51080	1726	675033857000
51081	1874	1143000
51082	1726	675032856000
51083	1874	1144000
51084	1670	7920792000000
51113	1711	10604533000000
51179	1723	8999192085979
51180	1723	8999282085979
51182	1397	1363582492000
51183	1678	14400545608000
51184	1726	675001791000
51185	1874	1209000
51186	1726	675000788000
51187	1874	1212000
51188	1726	674999787000
51189	1874	1213000
51190	576	74435684938283
51229	1397	1363532487000
51230	1678	14400545613000
51231	1726	674987763000
51232	1874	1237000
51233	1726	674986761000
51234	1874	1239000
51235	1726	674985758000
51236	1874	1242000
51237	1683	292756037149541
51240	1397	1363522486000
51241	1678	14400545614000
51242	1726	674984757000
51243	1874	1243000
51244	1726	674983755000
51245	1874	1245000
51246	1726	674982752000
51247	1874	1248000
51248	1683	294196037149541
51249	1683	294196050149541
51274	1397	1363492483000
51275	1678	14400545617000
51276	1726	674975739000
51277	1874	1261000
51278	1726	674974737000
51279	1874	1263000
51280	1726	674973734000
51281	1874	1266000
51282	1715	31680535000000
51287	1643	6336380113700
51288	1397	1363482482000
51289	1678	14400545618000
51290	1726	674972733000
51291	1874	1267000
51292	1726	674971731000
51293	1874	1269000
51294	1726	674970728000
51295	1874	1272000
51296	1702	4320238000000
51297	1702	4320251000000
51348	1397	1363422476000
51349	1678	14400545624000
51350	1726	674954696000
51351	1874	1304000
51352	1726	674953693000
51353	1874	1307000
51354	1683	295636050149541
51355	1683	295636062149541
51356	1397	1363412475000
51357	1678	14400545625000
51358	1397	1363402474000
51359	1678	14400545626000
51360	1623	47522499899898
51361	1623	47522519899898
51393	1419	12701232280064
51452	1397	1363312465000
51453	1678	14400545635000
51454	1726	674922632000
51455	1874	1368000
51456	1726	674921629000
51457	1874	1371000
51458	1677	116569757324100
51459	1677	116569769324100
51462	1683	298516075149541
51463	1683	298516087149541
51507	1685	80641505571430
51508	1685	81361505571430
51509	1685	81361507571430
51615	1727	7386701000000
51616	1727	7386759000000
51664	1588	11734897000000
51672	1711	10604522000000
51673	1397	1363162450000
51674	1678	14400545650000
51675	1726	674907162000
51676	1874	1428000
51677	1726	674906161000
51678	1874	1429000
51679	1444	7774983160000
51680	1444	7774995160000
51684	1397	1363152449000
51685	1678	14400545651000
51686	1726	674905158000
51687	1874	1432000
51688	1694	8652422127629
51689	1694	8652433127629
51723	1692	53302373019999
51730	1740	7001249000000
51745	1397	1363062440000
51746	1678	14400545660000
51747	1726	674892127000
51748	1874	1463000
51749	149	76350076000341
51750	149	76350087000341
51764	1559	5722593000000
51765	1559	5722604000000
50981	1726	676272913000
50982	1874	1087000
50983	1726	676271911000
50984	1874	1089000
50985	1726	676270910000
50986	1874	1090000
50987	1668	10046560000000
50988	1668	10046596000000
51041	1397	1363732507000
51042	1678	14400545593000
51043	1726	676253878000
51044	1874	1122000
51045	1726	676252875000
51046	1874	1125000
51047	1726	676251874000
51048	1874	1126000
51049	2086	1439038000000
51106	1637	163444627819997
51191	1397	1363572491000
51192	1678	14400545609000
51193	1726	674998785000
51194	1874	1215000
51195	1726	674997782000
51196	1874	1218000
51197	1726	674996781000
51198	1874	1219000
51199	1671	6528269530515
51228	484	91920766000000
51324	1419	12701200280064
51325	1419	12701239280064
51338	1397	1363432477000
51339	1678	14400545623000
51340	1726	674957703000
51341	1874	1297000
51342	1726	674956701000
51343	1874	1299000
51344	1726	674955698000
51345	1874	1302000
51346	1457	9984253040000
51347	1457	9984266040000
51362	1397	1363392473000
51363	1678	14400545627000
51364	1397	1363382472000
51365	1678	14400545628000
51366	1726	674952691000
51367	1874	1309000
51368	1726	674951690000
51369	1874	1310000
51370	1726	674950687000
51371	1874	1313000
51372	1726	674949685000
51373	1874	1315000
51374	1726	674948684000
51375	1874	1316000
51376	1726	674947681000
51377	1874	1319000
51378	1726	674946679000
51379	1874	1321000
51380	1726	674945678000
51381	1874	1322000
51382	1726	674944675000
51383	1874	1325000
51384	1726	674943673000
51385	1874	1327000
51386	1726	674942672000
51387	1874	1328000
51388	1726	674941669000
51389	1874	1331000
51390	1555	6675170979096
51395	1724	7149328000000
51396	1397	1363372471000
51397	1678	14400545629000
51398	1397	1363362470000
51399	1678	14400545630000
51400	1397	1363352469000
51401	1678	14400545631000
51402	1397	1363342468000
51403	1678	14400545632000
51404	1726	674940667000
51405	1874	1333000
51406	1726	674939666000
51407	1874	1334000
51408	1726	674938663000
51409	1874	1337000
51410	1726	674937661000
51411	1874	1339000
51412	1726	674936660000
51413	1874	1340000
51414	1726	674935657000
51415	1874	1343000
51416	1726	674934655000
51417	1874	1345000
51418	1726	674933654000
51419	1874	1346000
51420	1726	674932651000
51421	1874	1349000
51422	1726	674931649000
51423	1874	1351000
51424	1726	674930648000
51425	1874	1352000
51426	1726	674929645000
51427	1874	1355000
51428	1708	5795701000021
51429	1708	5795753000021
51464	1688	78841952904000
51465	1688	78841964904000
51473	1397	1363292463000
51474	1678	14400545637000
51475	1726	674918622000
51476	1874	1378000
51477	1702	5040251000000
51478	1702	5040262000000
51479	1397	1363282462000
51480	1678	14400545638000
51481	1726	674917619000
51482	1874	1381000
51483	1726	674916618000
51484	1874	1382000
51485	633	75243991900000
51486	633	75244003900000
51511	1489	21927783400000
51512	1489	17352360600000
51513	1489	14265048200000
51514	1489	5663875000000
51515	1678	13680400244000
51516	1678	13680400245000
51517	1678	13680400246000
51518	1678	13680400247000
51519	1678	13680400248000
51520	1678	13680400249000
51521	1678	13680400250000
51522	1678	13680400251000
51523	1678	13680400252000
51524	1678	13680400253000
51525	1678	13680400254000
51526	1678	13680400255000
51527	1678	13680400256000
51528	1678	13680400257000
51529	1678	13680400258000
51530	1678	13680400259000
51531	1706	7412888600135
51532	1678	13680400260000
51533	1678	13680400261000
51534	1678	13680400262000
51535	1678	13680400263000
51536	1678	13680400264000
51537	1678	13680400265000
51538	1678	13680400266000
51539	1678	13680400267000
51540	1678	13680400268000
51541	1678	13680400269000
51542	1678	13680400270000
51543	1678	13680400271000
51544	1678	13680400272000
51545	1678	13680400273000
51546	1678	13680400274000
51547	1678	13680400275000
51548	1678	13680400276000
51549	1678	13680400277000
51550	1678	13680400278000
51551	1678	13680400279000
51552	1678	13680400280000
51553	1678	13680400281000
51554	1678	13680400282000
51555	1678	13680400283000
51556	1678	13680400284000
51557	1678	13680400285000
51558	1678	13680400286000
51559	1678	13680400287000
51560	1678	13680400288000
51561	1678	13680400289000
51562	1678	13680400290000
51563	1678	13680400291000
51564	1678	13680400292000
51565	1678	13680400293000
51566	1678	13680400294000
51567	1678	13680400295000
51568	1678	13680400296000
51569	1678	13680400297000
51570	1678	13680400298000
51571	1678	13680400299000
51572	1678	13680400300000
51573	1678	13680400301000
51574	1678	13680400302000
51575	1678	13680400303000
51021	1874	1104000
51022	1726	676261893000
51023	1874	1107000
51024	1649	11083953999992
51025	1726	676260892000
51026	1874	1108000
51027	1726	676259890000
51028	1874	1110000
51029	1726	676258887000
51030	1874	1113000
51031	1726	676257886000
51032	1874	1114000
51033	1726	676256884000
51034	1874	1116000
51035	1726	676255881000
51036	1874	1119000
51037	1726	676254880000
51038	1874	1120000
51039	1649	11803953999992
51040	1649	11803960999992
51050	2087	1439037000000
51061	1508	10836241500009
51062	1508	10836265500009
51072	1601	11738674600000
51073	1601	11738687600000
51094	632	93360809000000
51104	1711	10604521000000
51105	1711	10604534000000
51107	1397	1363672501000
51108	1678	14400545599000
51109	1726	675026843000
51110	1874	1157000
51111	1726	675025840000
51112	1874	1160000
51221	1397	1363542488000
51222	1678	14400545612000
51223	1726	674989767000
51224	1874	1233000
51225	1726	674988764000
51226	1874	1236000
51227	1716	7966690000000
51238	1749	4185028000000
51239	1749	4185041000000
51250	1397	1363512485000
51251	1678	14400545615000
51252	1726	674981751000
51253	1874	1249000
51254	1622	12060263000014
51255	1726	674980749000
51256	1874	1251000
51257	1726	674979746000
51258	1874	1254000
51259	1622	12780263000014
51260	1622	12780265000014
51261	1685	79921481571430
51262	1685	79921483571430
51283	1599	7539739393047
51284	1599	7539752393047
51298	1703	2880584000000
51299	1397	1363472481000
51300	1678	14400545619000
51301	1397	1363462480000
51302	1678	14400545620000
51303	1397	1363452479000
51304	1678	14400545621000
51305	1726	674969727000
51306	1874	1273000
51307	1726	674968725000
51308	1874	1275000
51309	1726	674967722000
51310	1874	1278000
51311	1726	674966721000
51312	1874	1279000
51313	1726	674965719000
51314	1874	1281000
51315	1726	674964716000
51316	1874	1284000
51317	1726	674963715000
51318	1874	1285000
51319	1726	674962713000
51320	1874	1287000
51321	1726	674961710000
51322	1874	1290000
51323	1696	8417323840000
51328	1397	1363442478000
51329	1678	14400545622000
51330	1726	674960709000
51331	1874	1291000
51332	1726	674959707000
51333	1874	1293000
51334	1726	674958704000
51335	1874	1296000
51336	1694	7932370127629
51337	1694	7932422127629
51394	532	68880058000000
51432	1397	1363332467000
51433	1678	14400545633000
51434	1726	674928643000
51435	1874	1357000
51436	1726	674927642000
51437	1874	1358000
51438	1726	674926639000
51439	1874	1361000
51440	1683	297076062149541
51441	1683	297076075149541
51460	1695	6812150000000
51466	1397	1363302464000
51467	1678	14400545636000
51468	1726	674920628000
51469	1874	1372000
51470	1726	674919625000
51471	1874	1375000
51472	1850	9278876000000
51494	1397	1363262460000
51495	1678	14400545640000
51496	1677	115849767324100
51497	1726	674913611000
51498	1874	1389000
51499	1726	674912610000
51500	1874	1390000
51501	2052	200000013
51502	1677	116569767324099
51503	2052	116569769324065
51504	1677	200000038
51505	2004	200000009
51510	1706	8132116600135
51591	1646	720000000000
51655	1726	674917182000
51656	1726	674916181000
51657	1726	674915178000
51658	1726	674914177000
51659	1726	674913174000
51660	1726	674912173000
51661	1726	674911170000
51662	1726	674910169000
51663	1670	8640880000000
51681	1759	8640653999999
51682	1759	8640665999999
51698	1397	1363132447000
51699	1678	14400545653000
51700	1726	674902153000
51701	1874	1437000
51702	1726	674901150000
51703	1874	1440000
51704	1536	11520652999959
51705	1536	11520664999959
51708	1397	1363122446000
51709	1678	14400545654000
51710	1726	674900149000
51711	1874	1441000
51712	1726	674899146000
51713	1874	1444000
51714	1466	2160020000000
51715	1466	2160032000000
51751	1727	7386712000000
51752	1702	5760262000000
51753	1702	5760273000000
51758	532	68880037000000
51134	1678	14400545606000
51135	1397	1363592493000
51136	1678	14400545607000
51137	1726	675021832000
51138	1874	1168000
51139	1726	675020829000
51140	1874	1171000
51141	1726	675019827000
51142	1874	1173000
51143	1726	675018824000
51144	1874	1176000
51145	1726	675017823000
51146	1874	1177000
51147	1726	675016821000
51148	1874	1179000
51149	1726	675015818000
51150	1874	1182000
51151	1726	675014817000
51152	1874	1183000
51153	1726	675013815000
51154	1874	1185000
51155	1726	675012812000
51156	1874	1188000
51157	1726	675011811000
51158	1874	1189000
51159	1726	675010809000
51160	1874	1191000
51161	1726	675009806000
51162	1874	1194000
51163	1726	675008805000
51164	1874	1195000
51165	1726	675007803000
51166	1874	1197000
51167	1726	675006800000
51168	1874	1200000
51169	1726	675005799000
51170	1874	1201000
51171	1726	675004797000
51172	1874	1203000
51173	1726	675003794000
51174	1874	1206000
51175	1726	675002793000
51176	1874	1207000
51177	1426	11084853000000
51178	1426	11084943000000
51181	576	74435671938283
51200	1850	9278864000000
51201	1850	9278890000000
51202	2093	100000000
51203	1397	1363562490000
51204	1678	14400545610000
51205	1397	1363552489000
51206	1678	14400545611000
51207	1726	674995779000
51208	1874	1221000
51209	1726	674994776000
51210	1874	1224000
51211	1726	674993775000
51212	1874	1225000
51213	1726	674992773000
51214	1874	1227000
51215	1726	674991770000
51216	1874	1230000
51217	1726	674990769000
51218	1874	1231000
51219	1656	10941348999990
51220	1656	10941474999990
51263	1397	1363502484000
51264	1678	14400545616000
51265	1726	674978745000
51266	1874	1255000
51267	1726	674977743000
51268	1874	1257000
51269	1726	674976740000
51270	1874	1260000
51271	1423	1473224999985
51272	1677	115129692324100
51273	1677	115129705324100
51285	1692	53302360019999
51286	1692	53302370019999
51326	1685	80641483571430
51327	1685	80641522571430
51391	1724	7149308000000
51392	1724	7149340000000
51430	1677	115849705324100
51431	1677	115849757324100
51442	1397	1363322466000
51443	1678	14400545634000
51444	1726	674925637000
51445	1874	1363000
51446	1726	674924636000
51447	1874	1364000
51448	1726	674923633000
51449	1874	1367000
51450	369	91920747000000
51451	369	91920760000000
51461	1680	6489305500035
51487	1397	1363272461000
51488	1678	14400545639000
51489	1726	674915615000
51490	1874	1385000
51491	1726	674914614000
51492	1874	1386000
51493	1685	80641495571430
51506	1688	79561964904000
51592	1397	1363252459000
51593	1678	14400545641000
51594	1397	1363242458000
51595	1678	14400545642000
51596	1397	1363232457000
51597	1678	14400545643000
51598	1397	1363222456000
51599	1678	14400545644000
51600	1726	674911607000
51601	1874	1393000
51602	1726	674910604000
51603	1874	1396000
51604	1726	674909603000
51605	1874	1397000
51606	1726	674908600000
51607	1874	1400000
51608	1726	674907599000
51609	1874	1401000
51610	1726	674906596000
51611	1874	1404000
51612	1726	674905595000
51613	1874	1405000
51614	1683	298516134149541
51653	1727	8106759000000
51654	1727	8106848000000
51683	1444	7774994160000
51697	1718	6066738763340
51706	1762	9681832994000
51707	1762	9681844994000
51729	1690	95763076000000
51754	1679	26027876652000
51755	1726	674891124000
51756	1874	1466000
51757	1724	7149319000000
51759	1397	1363052439000
51760	1678	14400545661000
51761	1726	674890121000
51762	1874	1469000
51763	1711	10604532000000
51576	1678	13680400304000
51577	1678	13680400305000
51578	1678	13680400306000
51579	1678	13680400307000
51580	1678	13680400308000
51581	1678	13680400309000
51582	1678	13680400310000
51583	1678	13680400311000
51584	1678	13680400312000
51585	1678	13680400313000
51586	1678	13680400314000
51587	1678	13680400315000
51588	1678	13680400316000
51589	1706	8132888600135
51590	1706	8133458600135
51617	1616	674918185000
51618	1726	2880096410000
51619	1601	7986677600000
51620	1388	1705861704351650
51621	1397	1363212455000
51622	1678	14400545645000
51623	1397	1363202454000
51624	1678	14400545646000
51625	1601	5990667600000
51626	1142	907292755600000
51627	1601	4644157600000
51628	1262	612167826200000
51629	1601	3530147600000
51630	1022	506305064000000
51631	1397	1363192453000
51632	1678	14400545647000
51633	1397	1363182452000
51634	1678	14400545648000
51635	1726	674904592000
51636	1874	1408000
51637	1726	674903591000
51638	1874	1409000
51639	1726	674902588000
51640	1874	1412000
51641	1726	674901587000
51642	1874	1413000
51643	1726	674900584000
51644	1874	1416000
51645	1726	674899583000
51646	1874	1417000
51647	1726	674898580000
51648	1874	1420000
51649	1726	674897579000
51650	1874	1421000
51651	1670	8640792000000
51652	1670	8640881000000
51665	1397	1363172451000
51666	1678	14400545649000
51667	1726	674909166000
51668	1874	1424000
51669	1726	674908165000
51670	1874	1425000
51671	1588	11734909000000
51690	1397	1363142448000
51691	1678	14400545652000
51692	1726	674904157000
51693	1874	1433000
51694	1726	674903154000
51695	1874	1436000
51696	1991	6235673441475
51716	1397	1363112445000
51717	1678	14400545655000
51718	1726	674898145000
51719	1874	1445000
51720	1726	674897142000
51721	1874	1448000
51722	1426	11084865000000
51724	1397	1363102444000
51725	1678	14400545656000
51726	1726	674896139000
51727	1874	1451000
51728	1677	116569768324100
51731	1397	1363092443000
51732	1678	14400545657000
51733	1397	1363082442000
51734	1678	14400545658000
51735	1397	1363072441000
51736	1678	14400545659000
51737	1679	27218813117000
51738	1726	674895136000
51739	1874	1454000
51740	1726	674894133000
51741	1874	1457000
51742	1726	674893130000
51743	1874	1460000
51744	1683	298516118149541
51766	1397	1363042438000
51767	1678	14400545662000
51768	1397	1363032437000
51769	1678	14400545663000
51770	1726	674889118000
51771	1874	1472000
51772	1726	674888115000
51773	1874	1475000
51774	1457	10704266040000
51775	1457	10704288040000
51776	1637	164164627819997
51777	1637	164164649819997
51778	1601	7266664600000
51779	1601	5270654600000
51780	1601	3924144600000
51781	1601	2810134600000
51782	1564	7747237000000
51783	1564	8467237000000
51784	1564	8467707000000
51785	1397	1363022436000
51786	1678	14400545664000
51787	1397	1363012435000
51788	1678	14400545665000
51789	1397	1363002434000
51790	1678	14400545666000
51791	1726	674887112000
51792	1874	1478000
51793	1726	674886109000
51794	1874	1481000
51795	1726	674885106000
51796	1874	1484000
51797	1688	80281964904000
51798	1688	80281997904000
51799	1397	1362992433000
51800	1678	14400545667000
51801	1726	674884103000
51802	1874	1487000
51803	1677	117289768324100
51804	1677	117289779324100
51805	1397	1362982432000
51806	1678	14400545668000
51807	1726	674883100000
51808	1874	1490000
51809	1397	1362972431000
51810	1678	14400545669000
51811	1726	674882097000
51812	1874	1493000
51813	1423	2193224999985
51814	1423	2193235999985
51815	1397	1362962430000
51816	1678	14400545670000
51817	1726	674881094000
51818	1874	1496000
51819	1702	6480273000000
51820	1702	6480284000000
51821	1397	1362952429000
51822	1678	14400545671000
51823	1397	1362942428000
51824	1678	14400545672000
51825	1726	674880091000
51826	1874	1499000
51827	1726	674879088000
51828	1874	1502000
51829	1549	10415714000000
51830	1549	11135714000000
51831	1601	6546645600000
51832	1601	4550635600000
51833	1601	3204125600000
51834	1601	2090115600000
51835	1471	10699578900000
51836	1471	10699712900000
51837	1397	1362932427000
51838	1678	14400545673000
51839	1726	674878085000
51840	1874	1505000
51841	1471	10699587900000
51842	1471	10699598900000
51843	1397	1362922426000
51844	1678	14400545674000
51845	1397	1362912425000
51846	1678	14400545675000
51847	1726	674877082000
51848	1874	1508000
51849	1726	674876079000
51850	1874	1511000
51851	1677	118009779324100
51852	1677	118009801324100
51853	1397	1362902424000
51854	1678	14400545676000
51855	1726	674875076000
51856	1874	1514000
51857	1687	5752543524804
51858	1687	5752554524804
51859	1397	1362892423000
51860	1678	14400545677000
51861	1726	674874074000
51862	1874	1516000
51863	1726	674873073000
51864	1874	1517000
51865	1726	674872070000
51866	1874	1520000
51867	1683	299956118149541
51868	1683	299956131149541
51881	1679	26747876652000
51882	1679	26747889652000
51883	631	66718901000000
51884	2099	500000000
51885	1397	1362872421000
51886	1678	14400545679000
51887	1397	1362862420000
51888	1678	14400545680000
51889	1726	674868062000
51890	1874	1528000
51891	1726	674867061000
51892	1874	1529000
51893	1726	674866058000
51894	1874	1532000
51895	1726	674865056000
51896	1874	1534000
51897	1726	674864055000
51898	1874	1535000
51899	1726	674863052000
51900	1874	1538000
51901	1649	12523960999992
51902	1649	12524086999992
51923	1397	1362832417000
51924	1678	14400545683000
51925	1397	1362822416000
51926	1678	14400545684000
51927	1726	674856038000
51928	1874	1552000
51929	1726	674855037000
51930	1874	1553000
51931	1726	674854034000
51932	1874	1556000
51933	1726	674853032000
51934	1874	1558000
51935	1726	674852031000
51936	1874	1559000
51937	1726	674851028000
51938	1874	1562000
51939	2099	718499000000
51940	484	91920781000000
51990	1397	1362762410000
51991	1678	14400545690000
51992	1726	674835998000
51993	1874	1592000
51994	1726	674834996000
51995	1874	1594000
51996	1726	674833995000
51997	1874	1595000
51998	2099	718498000000
51999	1670	9360880000000
52000	1670	9360894000000
52003	1397	1362752409000
52004	1678	14400545691000
52005	1726	674832992000
52006	1874	1598000
52007	1726	674831990000
52008	1874	1600000
52009	1726	674830989000
52010	1874	1601000
52011	2039	7201094000000
52012	2039	7201107000000
52023	1690	95763081000000
52044	1397	1362712405000
52045	1678	14400545695000
52046	1726	674820968000
52047	1874	1622000
52048	1726	674819966000
52049	1874	1624000
52050	1726	674818965000
52051	1874	1625000
52052	1683	304276157149541
52053	1683	304276170149541
52064	1688	80282009904000
52065	1688	81002009904000
52123	1646	720050000000
52168	1596	10800379000000
52169	1596	10800395000000
52170	1397	1362592393000
52171	1678	14400545707000
52172	1726	674783894000
52173	1874	1696000
52174	1726	674782893000
52175	1874	1697000
52176	1726	674781890000
52177	1874	1700000
52178	1685	81361495571430
52179	1685	81361508571430
52201	1397	1362562390000
52202	1678	14400545710000
52203	1397	1362552389000
52204	1678	14400545711000
52205	1726	674774876000
52206	1874	1714000
52207	1726	674773875000
52208	1874	1715000
52209	1726	674772872000
52210	1874	1718000
52211	1726	674771870000
52212	1874	1720000
52213	1726	674770869000
52214	1874	1721000
52215	1726	674769866000
52216	1874	1724000
52217	1587	10080372000000
52218	1587	10080398000000
52221	1688	81722009904000
52222	1688	81722035904000
52230	1726	674768864000
52231	1874	1726000
52232	1726	674767863000
52233	1874	1727000
52234	1726	674766860000
52235	1874	1730000
52236	114	66722753000000
52247	1679	27467889652000
52248	1679	27467902652000
52345	1980	12239919000000
52346	1397	1362422376000
52347	1678	14400545724000
52348	1980	12959919000000
52349	1980	12960111000000
52371	1402	35134120319298
52402	1706	8852142600135
52419	1694	9372446127629
52421	1397	1362352369000
52422	1678	14400545731000
52423	1726	674713752000
52424	1874	1838000
52425	1726	674712749000
52426	1874	1841000
52427	1726	674711748000
52428	1874	1842000
52429	1583	720000000000
52430	1583	720013000000
52447	1719	6500346000000
52481	1397	1362302364000
52482	1678	14400545736000
52483	1726	672278722000
52484	1874	1868000
52485	1726	672277719000
52486	1874	1871000
52487	1726	672276718000
52488	1874	1872000
52489	1677	120169860324100
52490	1677	120169873324100
52504	1726	672272710000
52505	1874	1880000
52506	470	73920331000000
52522	1673	13286150000000
52523	1673	13286166000000
52524	1439	7492322998477
52577	1397	1362192353000
52578	1678	14400545747000
52579	1726	672254674000
52580	1874	1916000
52581	1726	672253671000
52582	1874	1919000
52583	1726	672252670000
52584	1874	1920000
52585	1726	672251668000
52586	1874	1922000
52587	1726	672250665000
52588	1874	1925000
52589	1726	672249664000
52590	1874	1926000
52591	1726	672248662000
52592	1874	1928000
52593	1726	672247659000
52594	1874	1931000
52595	1726	672246658000
52596	1874	1932000
52597	1726	672245656000
52598	1874	1934000
52599	1726	672244653000
52600	1874	1937000
52601	1726	672243652000
51869	1397	1362882422000
51870	1678	14400545678000
51871	1726	674871068000
51872	1874	1522000
51873	1726	674870067000
51874	1874	1523000
51875	1726	674869064000
51876	1874	1526000
51877	1683	301396131149541
51878	1683	301396144149541
51903	1701	7270378600056
51941	1397	1362812415000
51942	1678	14400545685000
51943	1397	1362802414000
51944	1678	14400545686000
51945	1726	674850026000
51946	1874	1564000
51947	1726	674849025000
51948	1874	1565000
51949	1726	674848022000
51950	1874	1568000
51951	1726	674847020000
51952	1874	1570000
51953	1726	674846019000
51954	1874	1571000
51955	1723	9719282085979
51956	1723	9719307085979
51967	1677	118729801324100
51968	1677	118729814324100
52001	1467	29522581100000
52002	1467	29522595100000
52013	2039	7201104000000
52054	1690	95763078000000
52066	1397	1362692403000
52067	1678	14400545697000
52068	1726	674815959000
52069	1874	1631000
52070	1726	674814956000
52071	1874	1634000
52072	1726	674813954000
52073	1874	1636000
52074	1704	2226220000000
52120	1706	8852116600135
52121	1706	8852181600135
52122	1683	304276222149541
52124	1397	1362632397000
52125	1678	14400545703000
52126	1726	674797923000
52127	1874	1667000
52128	1726	674796920000
52129	1874	1670000
52130	1726	674795918000
52131	1874	1672000
52180	1397	1362582392000
52181	1678	14400545708000
52182	1726	674780888000
52183	1874	1702000
52184	1726	674779887000
52185	1874	1703000
52186	1726	674778884000
52187	1874	1706000
52188	1762	10401844994000
52189	1762	10401857994000
52223	1560	9954235277001
52224	1560	9954261277001
52260	1397	1362512385000
52261	1678	14400545715000
52262	1726	674759846000
52263	1874	1744000
52264	1726	674758845000
52265	1874	1745000
52266	1726	674757842000
52267	1874	1748000
52268	1716	8686690000000
52269	1716	8686703000000
52299	1397	1362472381000
52300	1678	14400545719000
52301	1726	674747822000
52302	1874	1768000
52303	1726	674746821000
52304	1874	1769000
52305	1726	674745818000
52306	1874	1772000
52307	1587	10080385000000
52310	1522	6814036000000
52344	1522	6814088000000
52350	1726	674732792000
52351	1874	1798000
52352	1726	674731791000
52353	1874	1799000
52354	1726	674730788000
52355	1874	1802000
52356	1980	12959162000000
52403	1622	12780252000014
52404	1622	12780278000014
52405	1633	7236336985638
52406	1633	7236362985638
52420	1440	5759096000000
52456	1591	1411000000
52457	2100	718000000000
52458	1679	28187902652000
52459	1679	28187943652000
52538	1397	1362252359000
52539	1678	14400545741000
52540	1397	1362242358000
52541	1678	14400545742000
52542	1726	672263692000
52543	1874	1898000
52544	1726	672262689000
52545	1874	1901000
52546	1726	672261688000
52547	1874	1902000
52548	1726	672260686000
52549	1874	1904000
52550	1726	672259683000
52551	1874	1907000
52552	1726	672258682000
52553	1874	1908000
52554	1402	35854146319298
52556	1727	7386721000000
52605	1440	6479096000000
52606	1440	6479148000000
52611	1397	1362172351000
52612	1678	14400545749000
52613	1726	672242650000
52614	1874	1940000
52615	1726	672241647000
52616	1874	1943000
52617	1726	672240646000
52618	1874	1944000
52619	1726	672239644000
52620	1874	1946000
52621	1726	672238641000
52622	1874	1949000
52623	1726	672237640000
52624	1874	1950000
52625	1402	36574146319298
52626	1402	36574162319298
52629	1692	54022373019999
52630	1692	54022389019999
52759	1703	2880625000000
52770	1397	1362002334000
52771	1678	14400545766000
52772	1717	6587894000023
52779	1740	7721277000000
52780	1740	7721289000000
52785	1474	7474432000023
52803	1397	1361972331000
52804	1678	14400545769000
52805	1397	1361962330000
52806	1678	14400545770000
52807	1605	40000000
52808	1726	672181528000
52809	1874	2062000
52810	1726	672180525000
52811	1874	2065000
52812	1726	672179523000
52813	1874	2067000
52814	1726	672178522000
52815	1874	2068000
52816	1726	672177519000
52817	1874	2071000
52818	1726	672176517000
52819	1874	2073000
52820	1605	720046000000
52861	1726	672163492000
52862	1874	2098000
52863	1726	672162489000
52864	1874	2101000
52865	1726	672161487000
52866	1874	2103000
52867	1513	22320700000000
52868	1513	22320725000000
52882	1693	15753597155041
52883	1397	1361892323000
52884	1678	14400545777000
52885	1726	672157480000
52886	1874	2110000
52887	1726	672156477000
52888	1874	2113000
52889	1726	672155475000
52890	1874	2115000
52891	1610	6480239000000
52931	1397	1361842318000
52932	1678	14400545782000
51879	1991	6955673441475
51880	1991	6955686441475
51969	1741	719013000000
52075	1747	2896833000000
52076	1747	2896846000000
52078	1397	1362682402000
52079	1678	14400545698000
52080	1397	1362672401000
52081	1678	14400545699000
52082	1397	1362662400000
52083	1678	14400545700000
52084	1397	1362652399000
52085	1678	14400545701000
52086	1397	1362642398000
52087	1678	14400545702000
52088	1726	674812953000
52089	1874	1637000
52090	1726	674811950000
52091	1874	1640000
52092	1726	674810948000
52093	1874	1642000
52094	1726	674809947000
52095	1874	1643000
52096	1726	674808944000
52097	1874	1646000
52098	1726	674807942000
52099	1874	1648000
52100	1726	674806941000
52101	1874	1649000
52102	1726	674805938000
52103	1874	1652000
52104	1726	674804936000
52105	1874	1654000
52106	1726	674803935000
52107	1874	1655000
52108	1726	674802932000
52109	1874	1658000
52110	1726	674801930000
52111	1874	1660000
52112	1726	674800929000
52113	1874	1661000
52114	1726	674799926000
52115	1874	1664000
52116	1726	674798924000
52117	1874	1666000
52118	1670	10080894000000
52119	1670	10080959000000
52132	1637	164884649819997
52133	1637	164884659819997
52134	1397	1362622396000
52135	1678	14400545704000
52136	1397	1362612395000
52137	1678	14400545705000
52138	1726	674794917000
52139	1874	1673000
52140	1726	674793914000
52141	1874	1676000
52142	1726	674792912000
52143	1874	1678000
52144	1726	674791911000
52145	1874	1679000
52146	1726	674790908000
52147	1874	1682000
52148	1684	11491258880623
52149	1684	11491283880623
52190	1685	82081508571430
52191	1685	82081521571430
52192	1397	1362572391000
52193	1678	14400545709000
52194	1726	674777882000
52195	1874	1708000
52196	1726	674776881000
52197	1874	1709000
52198	1726	674775878000
52199	1874	1712000
52200	1691	7163039100019
52225	1560	9954256277001
52237	1397	1362532387000
52238	1678	14400545713000
52239	1726	674765858000
52240	1874	1732000
52241	1726	674764857000
52242	1874	1733000
52243	1726	674763854000
52244	1874	1736000
52245	1546	7920640000000
52246	1546	7920653000000
52249	1397	1362522386000
52250	1678	14400545714000
52251	1726	674762852000
52252	1874	1738000
52253	1726	674761851000
52254	1874	1739000
52255	1726	674760848000
52256	1874	1742000
52257	1467	29522594100000
52270	1397	1362502384000
52271	1678	14400545716000
52272	1397	1362492383000
52273	1678	14400545717000
52274	1726	674756840000
52275	1874	1750000
52276	1726	674755839000
52277	1874	1751000
52278	1726	674754836000
52279	1874	1754000
52280	1726	674753834000
52281	1874	1756000
52282	1726	674752833000
52283	1874	1757000
52284	1726	674751830000
52285	1874	1760000
52286	1683	307156196149541
52287	1683	307156222149541
52288	1397	1362482382000
52289	1678	14400545718000
52290	1649	13244086999992
52291	1649	13244096999992
52308	1683	308596222149541
52309	1683	308596235149541
52372	1397	1362392373000
52373	1678	14400545727000
52374	1591	718412000000
52375	2100	1000000000
52376	1726	674725776000
52377	1874	1814000
52378	1726	674724773000
52379	1874	1817000
52380	1726	674723772000
52381	1874	1818000
52382	1670	10800959000000
52383	1670	10800973000000
52431	1559	6442604000000
52432	1559	6442614000000
52434	1397	1362342368000
52435	1678	14400545732000
52436	1726	674710746000
52437	1874	1844000
52438	1591	1511000000
52439	2100	717890000000
52440	1726	674709743000
52441	1874	1847000
52442	1726	674708742000
52443	1874	1848000
52444	1719	6500347000000
52460	1397	1362322366000
52461	1678	14400545734000
52462	1397	1362312365000
52463	1678	14400545735000
52464	1726	674704734000
52465	1874	1856000
52466	1726	674703731000
52467	1874	1859000
52468	1726	674702730000
52469	1874	1860000
52470	1726	673492730000
52471	2101	200000000
52472	1726	672282730000
52473	2102	200000000
52474	1726	672281728000
52475	1874	1862000
52476	1726	672280725000
52477	1874	1865000
52478	1726	672279724000
52479	1874	1866000
52480	1677	119449860324100
52491	1668	10766596000000
52492	1668	10766609000000
52507	1397	1362272361000
52508	1678	14400545739000
52509	1649	13964099999992
52510	1649	13964109999992
52525	1397	1362262360000
52526	1678	14400545740000
52527	2100	717880000000
52528	1726	672266698000
52529	1874	1892000
52530	1726	672265695000
52531	1874	1895000
52532	1726	672264694000
52533	1874	1896000
52534	149	77070087000341
52535	149	77070110000341
52555	1727	7386727000000
52557	1397	1362232357000
51904	631	66000801000000
51905	2099	718500000000
51906	1397	1362852419000
51907	1678	14400545681000
51908	1397	1362842418000
51909	1678	14400545682000
51910	1726	674862050000
51911	1874	1540000
51912	1726	674861049000
51913	1874	1541000
51914	1726	674860046000
51915	1874	1544000
51916	1726	674859044000
51917	1874	1546000
51918	1726	674858043000
51919	1874	1547000
51920	1726	674857040000
51921	1874	1550000
51922	1467	28802581100000
51957	1397	1362792413000
51958	1678	14400545687000
51959	1726	674845016000
51960	1874	1574000
51961	1726	674844014000
51962	1874	1576000
51963	1726	674843013000
51964	1874	1577000
51965	1571	16560301001024
51966	1571	16560314001024
51970	1397	1362782412000
51971	1678	14400545688000
51972	1726	674842010000
51973	1874	1580000
51974	1726	674841008000
51975	1874	1582000
51976	1726	674840007000
51977	1874	1583000
51978	1677	119449814324100
51979	1677	119449827324100
51980	1397	1362772411000
51981	1678	14400545689000
51982	1726	674839004000
51983	1874	1586000
51984	1726	674838002000
51985	1874	1588000
51986	1726	674837001000
51987	1874	1589000
51988	1423	2913235999985
51989	1423	2913248999985
52014	1397	1362742408000
52015	1678	14400545692000
52016	1726	674829986000
52017	1874	1604000
52018	1726	674828984000
52019	1874	1606000
52020	1726	674827983000
52021	1874	1607000
52022	1599	7539755393047
52024	1397	1362732407000
52025	1678	14400545693000
52026	1726	674826980000
52027	1874	1610000
52028	1726	674825978000
52029	1874	1612000
52030	1726	674824977000
52031	1874	1613000
52032	1683	302836144149541
52033	1683	302836157149541
52034	1397	1362722406000
52035	1678	14400545694000
52036	1726	674823974000
52037	1874	1616000
52038	1726	674822972000
52039	1874	1618000
52040	1726	674821971000
52041	1874	1619000
52042	1591	720400000000
52043	1591	720413000000
52055	1506	6481088967172
52056	1397	1362702404000
52057	1678	14400545696000
52058	1726	674817962000
52059	1874	1628000
52060	1726	674816960000
52061	1874	1630000
52062	1683	302836169149541
52063	1683	304276169149541
52077	1746	5554323000000
52150	171	72470308524688
52151	171	72470333524688
52152	1397	1362602394000
52153	1678	14400545706000
52154	1726	674789906000
52155	1874	1684000
52156	1726	674788905000
52157	1874	1685000
52158	1726	674787902000
52159	1874	1688000
52160	1726	674786900000
52161	1874	1690000
52162	1726	674785899000
52163	1874	1691000
52164	1726	674784896000
52165	1874	1694000
52166	1696	9137284840000
52167	1696	9137300840000
52219	1683	305716170149541
52220	1683	305716196149541
52226	1397	1362542388000
52227	1678	14400545712000
52228	114	66722740000000
52229	114	66722750000000
52258	1634	10991711641004
52259	1634	10991724641004
52292	1726	674750828000
52293	1874	1762000
52294	1726	674749827000
52295	1874	1763000
52296	1726	674748824000
52297	1874	1766000
52298	1649	13244099999992
52311	1397	1362462380000
52312	1678	14400545720000
52313	1397	1362452379000
52314	1678	14400545721000
52315	1397	1362442378000
52316	1678	14400545722000
52317	1397	1362432377000
52318	1678	14400545723000
52319	1726	674744816000
52320	1874	1774000
52321	1726	674743815000
52322	1874	1775000
52323	1726	674742812000
52324	1874	1778000
52325	1726	674741810000
52326	1874	1780000
52327	1726	674740809000
52328	1874	1781000
52329	1726	674739806000
52330	1874	1784000
52331	1726	674738804000
52332	1874	1786000
52333	1726	674737803000
52334	1874	1787000
52335	1726	674736800000
52336	1874	1790000
52337	1726	674735798000
52338	1874	1792000
52339	1726	674734797000
52340	1874	1793000
52341	1726	674733794000
52342	1874	1796000
52343	1683	308596274149541
52357	1397	1362412375000
52358	1678	14400545725000
52359	1397	1362402374000
52360	1678	14400545726000
52361	1726	674729786000
52362	1874	1804000
52363	1726	674728783000
52364	1874	1807000
52365	1726	674727781000
52366	1874	1809000
52367	1726	674726778000
52368	1874	1812000
52369	1719	6500333000000
52370	1719	6500357000000
52384	1397	1362382372000
52385	1678	14400545728000
52386	1397	1362372371000
52387	1678	14400545729000
52388	1726	674722770000
52389	1874	1820000
52390	1726	674721767000
52391	1874	1823000
52392	1726	674720766000
52393	1874	1824000
52394	1726	674719764000
52395	1874	1826000
52396	1726	674718761000
52397	1874	1829000
52398	1726	674717760000
52399	1874	1830000
52400	1693	15753587155041
52401	1693	15753613155041
52407	1397	1362362370000
52408	1678	14400545730000
52409	2100	890000000
52410	1591	718512000000
52411	1726	674716758000
52412	1874	1832000
52413	1726	674715755000
52414	1874	1835000
52415	1726	674714754000
52416	1874	1836000
52417	1694	9372433127629
52418	1694	9372456127629
52433	1559	6442617000000
52445	1402	35854120319298
52446	1402	35854133319298
52448	1397	1362332367000
52449	1678	14400545733000
52450	1726	674707740000
52451	1874	1850000
52452	1726	674706737000
52453	1874	1853000
52454	1726	674705736000
52455	1874	1854000
52493	1397	1362292363000
52494	1678	14400545737000
52495	1397	1362282362000
52496	1678	14400545738000
52497	1726	672275716000
52498	1874	1874000
52499	1726	672274713000
52500	1874	1877000
52501	1726	672273712000
52502	1874	1878000
52503	470	73920330000000
52511	1726	672271707000
52512	1874	1883000
52513	1726	672270706000
52514	1874	1884000
52515	1726	672269704000
52516	1874	1886000
52517	1726	672268701000
52518	1874	1889000
52519	1726	672267700000
52520	1874	1890000
52521	1649	13964115999992
52536	1633	7956362985638
52537	1633	7956385985638
52568	1688	81002019904000
52569	1397	1362222356000
52570	1678	14400545744000
52571	1397	1362212355000
52572	1678	14400545745000
52573	1397	1362202354000
52574	1678	14400545746000
52575	1688	81722019904000
52576	1688	81722049904000
52647	1397	1362142348000
52648	1678	14400545752000
52649	1397	1362132347000
52650	1678	14400545753000
52651	1397	1362122346000
52652	1678	14400545754000
52653	1683	311476245149541
52654	1683	311476275149541
52655	1726	672231627000
52656	1874	1963000
52657	1726	672230625000
52658	1874	1965000
52659	1726	672229624000
52660	1874	1966000
52661	1726	672228621000
52662	1874	1969000
52663	1726	672227619000
52664	1874	1971000
52665	1726	672226618000
52666	1874	1972000
52667	1726	672225615000
52668	1874	1975000
52669	1726	672224613000
52670	1874	1977000
52671	1726	672223612000
52672	1874	1978000
52673	1740	7001277000000
52674	1397	1362112345000
52675	1678	14400545755000
52676	1397	1362102344000
52677	1678	14400545756000
52678	1397	1362092343000
52679	1678	14400545757000
52680	1397	1362082342000
52681	1678	14400545758000
52682	1726	672222609000
52683	1874	1981000
52684	1726	672221607000
52685	1874	1983000
52686	1726	672220606000
52687	1874	1984000
52688	1726	672219603000
52689	1874	1987000
52690	1726	672218601000
52691	1874	1989000
52692	1726	672217600000
52693	1874	1990000
52694	1726	672216597000
52695	1874	1993000
52696	1726	672215595000
52697	1874	1995000
52698	1726	672214594000
52699	1874	1996000
52700	1726	672213591000
52701	1874	1999000
52702	1726	672212589000
52703	1874	2001000
52704	1726	672211588000
52705	1874	2002000
52706	1690	96483078000000
52707	1690	96483130000000
52760	1397	1362012335000
52761	1678	14400545765000
52762	1726	672192549000
52763	1874	2041000
52764	1726	672191547000
52765	1874	2043000
52766	1726	672190546000
52767	1874	2044000
52768	470	74640330000000
52769	470	74640360000000
52781	1474	7474394000023
52782	1474	7474406000023
52855	1685	82801534571430
52856	1685	82801586571430
52857	1397	1361912325000
52858	1678	14400545775000
52859	1683	312916255149541
52860	1683	312916277149541
52869	1679	28187912652000
52881	1458	10893551908540
52894	1397	1361882322000
52895	1678	14400545778000
52896	1397	1361872321000
52897	1678	14400545779000
52898	1726	672154474000
52899	1874	2116000
52900	1726	672153471000
52901	1874	2119000
52902	1726	672152469000
52903	1874	2121000
52904	1726	672151468000
52905	1874	2122000
52906	1726	672150465000
52907	1874	2125000
52908	1726	672149463000
52909	1874	2127000
52910	1677	120169886324100
52941	1688	82442049904000
52942	1688	82442059904000
52975	1397	1361802314000
52976	1678	14400545786000
52977	1726	672130426000
52978	1874	2164000
52979	1726	672129423000
52980	1874	2167000
52981	1726	672128421000
52982	1874	2169000
52983	1726	672127420000
52984	1874	2170000
52985	1726	672126417000
52986	1874	2173000
52987	1726	672125415000
52988	1874	2175000
52989	1677	121609899324100
52990	1677	121609915324100
53052	1692	55462463019999
53053	1726	672110385000
53054	1874	2205000
53055	1726	672109384000
53056	1874	2206000
53057	1726	672108381000
53058	1874	2209000
53059	1726	672107379000
53060	1874	2211000
53061	1726	672106378000
53062	1874	2212000
53063	1726	672105375000
52558	1678	14400545743000
52559	1714	8806279103056
52560	1726	672257680000
52561	1874	1910000
52562	1726	672256677000
52563	1874	1913000
52564	1726	672255676000
52565	1874	1914000
52566	1714	9526279103056
52567	1714	9526282103056
52627	1549	11855714000000
52628	1549	11855730000000
52631	1397	1362162350000
52632	1678	14400545750000
52633	1397	1362152349000
52634	1678	14400545751000
52635	1726	672236638000
52636	1874	1952000
52637	1726	672235635000
52638	1874	1955000
52639	1726	672234634000
52640	1874	1956000
52641	1726	672233631000
52642	1874	1959000
52643	1726	672232630000
52644	1874	1960000
52645	1419	13421232280064
52646	1419	13421257280064
52773	1726	672189543000
52774	1874	2047000
52775	1726	672188541000
52776	1874	2049000
52777	1678	15120545766000
52778	1678	15120557766000
52854	1560	9954276277001
52870	1397	1361902324000
52871	1678	14400545776000
52872	1458	10893535908540
52873	1458	10893545908540
52911	1397	1361862320000
52912	1678	14400545780000
52913	1726	672148462000
52914	1874	2128000
52915	1726	672147459000
52916	1874	2131000
52917	1726	672146457000
52918	1874	2133000
52919	1588	12454909000000
52920	1588	12454922000000
52940	1685	82801547571430
52943	1397	1361832317000
52944	1678	14400545783000
52945	1726	672139444000
52946	1874	2146000
52947	1726	672138441000
52948	1874	2149000
52949	1726	672137439000
52950	1874	2151000
52951	369	92640760000000
52952	369	92640776000000
52955	1397	1361822316000
52956	1678	14400545784000
52957	1726	672136438000
52958	1874	2152000
52959	1726	672135435000
52960	1874	2155000
52961	1726	672134433000
52962	1874	2157000
52963	1723	10439307085979
52964	1723	10439326085979
53009	1672	9361815000000
53010	1672	9361835000000
53015	1397	1361772311000
53016	1678	14400545789000
53017	1726	672118402000
53018	1874	2188000
53019	1726	672117399000
53020	1874	2191000
53021	1726	672116397000
53022	1874	2193000
53023	1672	10081841000000
53024	1672	10081854000000
53073	1397	1361712305000
53074	1678	14400545795000
53075	1397	1361702304000
53076	1678	14400545796000
53077	1726	672101367000
53078	1874	2223000
53079	1726	672100366000
53080	1874	2224000
53081	1726	672099363000
53082	1874	2227000
53083	1726	672098361000
53084	1874	2229000
53085	1726	672097360000
53086	1874	2230000
53087	1726	672096357000
53088	1874	2233000
53089	1683	314356277149541
53090	1683	314356303149541
53115	1729	14687044000000
53134	1397	1361652299000
53135	1678	14400545801000
53136	1726	672083331000
53137	1874	2259000
53138	1726	672082330000
53139	1874	2260000
53140	1692	56902473019999
53141	1692	56902485019999
53167	1397	1361622296000
53168	1678	14400545804000
53242	1702	7200360000000
53245	1397	1361542288000
53246	1678	14400545812000
53247	1726	672052271000
53248	1874	2319000
53249	1726	672051268000
53250	1874	2322000
53251	1726	672050267000
53252	1874	2323000
53253	1677	122329928324100
53254	1397	1361532287000
53255	1678	14400545813000
53256	1726	672049265000
53257	1874	2325000
53258	1726	672048262000
53259	1874	2328000
53260	1726	672047261000
53261	1874	2329000
53262	1683	314356290149541
53294	1397	1361492283000
53295	1678	14400545817000
53300	1726	672037241000
53301	1874	2349000
53302	1726	672036238000
53303	1874	2352000
53304	1729	14687056000000
53305	1726	672035237000
53306	1874	2353000
53307	1729	15407056000000
53308	1729	15407057000000
53341	1689	6480131287625
53342	1711	10604531000000
53352	632	94800847000000
53387	1397	1361402274000
53388	1678	14400545826000
53389	1726	672012188000
53390	1874	2402000
53391	1726	672011186000
53392	1874	2404000
53393	1726	672010185000
53394	1874	2405000
53395	1588	13174935000000
53397	1419	14141257280064
53398	1419	14141267280064
53402	1397	1361392273000
53403	1678	14400545827000
53404	1726	672009182000
53405	1874	2408000
53406	1726	672008180000
53407	1874	2410000
53408	1726	672007179000
53409	1874	2411000
53410	1672	10801867000000
53412	1397	1361382272000
53413	1678	14400545828000
53414	1726	672006177000
53415	1874	2413000
53416	1749	1965026000000
53417	1950	5449852000000
53418	1726	672005176000
53419	1874	2414000
53420	1397	1361372271000
53421	1678	14400545829000
53422	1726	672004174000
53423	1874	2416000
53424	1726	672003171000
53425	1874	2419000
53426	1726	672002170000
53427	1874	2420000
53428	1613	7127799600000
53429	1613	7127812600000
53451	1397	1361342268000
53452	1678	14400545832000
53453	1726	671995156000
52602	1874	1938000
52603	1673	14006166000000
52604	1673	14006218000000
52607	1397	1362182352000
52608	1678	14400545748000
52609	1683	310036235149541
52610	1683	310036245149541
52708	1397	1362072341000
52709	1678	14400545759000
52710	1683	311476255149541
52711	1397	1362062340000
52712	1678	14400545760000
52713	1397	1362052339000
52714	1678	14400545761000
52715	1397	1362042338000
52716	1678	14400545762000
52717	1397	1362032337000
52718	1678	14400545763000
52719	1397	1362022336000
52720	1678	14400545764000
52721	1726	672210585000
52722	1874	2005000
52723	1726	672209583000
52724	1874	2007000
52725	1726	672208582000
52726	1874	2008000
52727	1726	672207579000
52728	1874	2011000
52729	1726	672206577000
52730	1874	2013000
52731	1726	672205576000
52732	1874	2014000
52733	1726	672204573000
52734	1874	2017000
52735	1726	672203571000
52736	1874	2019000
52737	1726	672202570000
52738	1874	2020000
52739	1726	672201567000
52740	1874	2023000
52741	1726	672200565000
52742	1874	2025000
52743	1726	672199564000
52744	1874	2026000
52745	1726	672198561000
52746	1874	2029000
52747	1726	672197559000
52748	1874	2031000
52749	1726	672196558000
52750	1874	2032000
52751	1726	672195555000
52752	1874	2035000
52753	1726	672194553000
52754	1874	2037000
52755	1726	672193552000
52756	1874	2038000
52757	1702	7200284000000
52758	1702	7200352000000
52783	1740	7721238000000
52784	1740	7721805000000
52786	1397	1361992333000
52787	1678	14400545767000
52788	1397	1361982332000
52789	1678	14400545768000
52790	1726	672187540000
52791	1874	2050000
52792	1726	672186537000
52793	1874	2053000
52794	1726	672185535000
52795	1874	2055000
52796	1726	672184534000
52797	1874	2056000
52798	1726	672183531000
52799	1874	2059000
52800	1726	672182529000
52801	1874	2061000
52802	1685	82081534571430
52821	1397	1361952329000
52822	1678	14400545771000
52823	1397	1361942328000
52824	1678	14400545772000
52825	1397	1361932327000
52826	1678	14400545773000
52827	1397	1361922326000
52828	1678	14400545774000
52829	1726	672175516000
52830	1874	2074000
52831	1726	672174513000
52832	1874	2077000
52833	1726	672173511000
52834	1874	2079000
52835	1726	672172510000
52836	1874	2080000
52837	1726	672171507000
52838	1874	2083000
52839	1726	672170505000
52840	1874	2085000
52841	1726	672169504000
52842	1874	2086000
52843	1726	672168501000
52844	1874	2089000
52845	1726	672167499000
52846	1874	2091000
52847	1726	672166498000
52848	1874	2092000
52849	1726	672165495000
52850	1874	2095000
52851	1726	672164493000
52852	1874	2097000
52853	1560	9954287277001
52874	1726	672160486000
52875	1874	2104000
52876	1726	672159483000
52877	1874	2107000
52878	1726	672158481000
52879	1874	2109000
52880	1693	15753603155041
52892	1692	54742389019999
52893	1692	54742408019999
52921	1397	1361852319000
52922	1678	14400545781000
52923	1726	672145456000
52924	1874	2134000
52925	1726	672144453000
52926	1874	2137000
52927	1726	672143451000
52928	1874	2139000
52929	1677	120889886324100
52930	1677	120889899324100
52953	1688	83162059904000
52954	1688	83162069904000
52965	1397	1361812315000
52966	1678	14400545785000
52967	1726	672133432000
52968	1874	2158000
52969	1726	672132429000
52970	1874	2161000
52971	1726	672131427000
52972	1874	2163000
52973	1522	7534088000000
52974	1522	7534101000000
53011	1672	9361841000000
53014	641	71379844000000
53025	1397	1361762310000
53026	1678	14400545790000
53027	1397	1361752309000
53028	1678	14400545791000
53029	1726	672115396000
53030	1874	2194000
53031	1726	672114393000
53032	1874	2197000
53033	1726	672113391000
53034	1874	2199000
53035	1726	672112390000
53036	1874	2200000
53037	1726	672111387000
53038	1874	2203000
53039	1692	55462408019999
53040	1692	55462433019999
53041	1397	1361742308000
53042	1678	14400545792000
53043	1397	1361732307000
53044	1678	14400545793000
53045	1397	1361722306000
53046	1678	14400545794000
53047	1739	23759735000000
53048	1749	2465027000000
53049	1950	4949852000000
53050	1739	24479735000000
53051	1739	24479736000000
53093	632	94080809000000
53094	632	94080835000000
53142	1397	1361642298000
53143	1678	14400545802000
53144	1726	672081327000
53145	1874	2263000
53146	1726	672080325000
53147	1874	2265000
53148	1726	672079324000
53149	1874	2266000
53152	1692	57622485019999
53153	1692	57622498019999
53155	1397	1361632297000
53156	1678	14400545803000
53157	1726	672078321000
52933	1726	672142450000
52934	1874	2140000
52935	1726	672141447000
52936	1874	2143000
52937	1726	672140445000
52938	1874	2145000
52939	1402	36574159319298
52991	1397	1361792313000
52992	1678	14400545787000
52993	1397	1361782312000
52994	1678	14400545788000
52995	1726	672124414000
52996	1874	2176000
52997	1726	672123411000
52998	1874	2179000
52999	1726	672122409000
53000	1874	2181000
53001	1726	672121408000
53002	1874	2182000
53003	1726	672120405000
53004	1874	2185000
53005	1726	672119403000
53006	1874	2187000
53007	1677	122329915324100
53008	1677	122329941324100
53012	641	71379824000000
53013	641	71379850000000
53097	1397	1361692303000
53098	1678	14400545797000
53099	1397	1361682302000
53100	1678	14400545798000
53101	1726	672095355000
53102	1874	2235000
53103	1726	672094354000
53104	1874	2236000
53105	1726	672093351000
53106	1874	2239000
53107	1726	672092349000
53108	1874	2241000
53109	1726	672091348000
53110	1874	2242000
53111	1726	672090345000
53112	1874	2245000
53113	1729	14687023000000
53114	1729	14687064000000
53154	1634	10991721641004
53195	1719	7220347000000
53196	1719	7220379000000
53240	1684	11491320880623
53243	1703	3600625000000
53244	1703	3600687000000
53309	58	77466389999659
53310	58	78186389999659
53311	58	78186390999659
53313	1623	48242519899898
53347	1726	672025217000
53348	1874	2373000
53349	1726	672024214000
53350	1874	2376000
53351	1513	22320712000000
53353	1397	1361442278000
53354	1678	14400545822000
53355	1726	672023213000
53356	1874	2377000
53357	1726	672022211000
53358	1874	2379000
53359	1726	672021208000
53360	1874	2382000
53361	1643	7056395113700
53386	1588	13174922000000
53396	1508	10836254500009
53401	1714	10246282103056
53444	1726	671998162000
53445	1874	2428000
53446	1726	671997159000
53447	1874	2431000
53448	1726	671996158000
53449	1874	2432000
53450	1670	11520986000000
53469	1991	6955683441475
53472	1637	165604659819997
53473	1637	165604662819997
53504	1397	1361292263000
53505	1678	14400545837000
53506	1726	671978122000
53507	1874	2468000
53508	1726	671977120000
53509	1874	2470000
53510	1726	671976117000
53511	1874	2473000
53512	484	92640781000000
53513	484	92640791000000
53533	1397	1361262260000
53534	1678	14400545840000
53535	114	66672743000000
53536	1950	5499852000000
53537	1397	1361252259000
53538	1678	14400545841000
53539	1397	1361242258000
53540	1678	14400545842000
53541	1397	1361232257000
53542	1678	14400545843000
53543	1397	1361222256000
53544	1678	14400545844000
53545	1397	1361212255000
53546	1678	14400545845000
53547	1397	1361202254000
53548	1678	14400545846000
53549	1726	671969104000
53550	1874	2486000
53551	1726	671968102000
53552	1874	2488000
53553	1726	671967099000
53554	1874	2491000
53555	1726	671966098000
53556	1874	2492000
53557	1726	671965096000
53558	1874	2494000
53559	1726	671964093000
53560	1874	2497000
53561	1726	671963092000
53562	1874	2498000
53563	1726	671962090000
53564	1874	2500000
53565	1726	671961087000
53566	1874	2503000
53567	1726	671960086000
53568	1874	2504000
53569	1726	671959084000
53570	1874	2506000
53571	1726	671958081000
53572	1874	2509000
53573	1726	671957080000
53574	1874	2510000
53575	1726	671956078000
53576	1874	2512000
53577	1726	671955075000
53578	1874	2515000
53579	1726	671954074000
53580	1874	2516000
53581	1726	671953072000
53582	1874	2518000
53583	1726	671952069000
53584	1874	2521000
53585	1726	671951068000
53586	1874	2522000
53587	1726	671950066000
53588	1874	2524000
53589	1726	671949063000
53590	1874	2527000
53591	1991	7675683441475
53592	1991	7675784441475
53614	114	66002733000000
53615	1950	6169852000000
53616	1397	1361172251000
53617	1678	14400545849000
53618	1397	1361162250000
53619	1678	14400545850000
53620	1726	671942049000
53621	1874	2541000
53622	1726	671941048000
53623	1874	2542000
53624	1726	671940045000
53625	1874	2545000
53626	1726	671939043000
53627	1874	2547000
53628	1726	671938042000
53629	1874	2548000
53630	1726	671937039000
53631	1874	2551000
53632	1683	317236358149541
53655	1271	1344126302000000
53656	1271	1344126328000000
53665	1746	6274323000000
53666	1746	6274336000000
53721	1950	4999852000000
53722	1950	5669852000000
53723	58	78906380999659
53724	58	78906401999659
53738	1397	1361052239000
53739	1678	15120584861000
53740	1726	671903973000
53741	1874	2617000
53742	1726	671902971000
53743	1874	2619000
53064	1874	2215000
53065	1726	672104373000
53066	1874	2217000
53067	1726	672103372000
53068	1874	2218000
53069	1726	672102369000
53070	1874	2221000
53071	1692	56182463019999
53072	1692	56182473019999
53091	1656	11661474999990
53092	1656	11661500999990
53095	1681	9863184759830
53096	1681	9863204759830
53116	1397	1361672301000
53117	1678	14400545799000
53118	1397	1361662300000
53119	1678	14400545800000
53120	1726	672089343000
53121	1874	2247000
53122	1726	672088342000
53123	1874	2248000
53124	1726	672087339000
53125	1874	2251000
53126	1726	672086337000
53127	1874	2253000
53128	1726	672085336000
53129	1874	2254000
53130	1726	672084333000
53131	1874	2257000
53132	576	75155671938283
53133	576	75155702938283
53150	576	75875702938283
53151	576	75875715938283
53165	1688	83882069904000
53166	1688	83882079904000
53193	1455	4353927000000
53194	1455	4353959000000
53198	1688	84602079904000
53199	1688	84602099904000
53239	1684	11491334880623
53281	1444	7775009160000
53283	1397	1361502284000
53284	1678	14400545816000
53285	1726	672040247000
53286	1874	2343000
53287	1726	672039244000
53288	1874	2346000
53289	1726	672038243000
53290	1874	2347000
53291	1762	11121857994000
53292	1762	11121870994000
53298	58	78186377999659
53299	58	78186380999659
53331	1397	1361462280000
53332	1678	14400545820000
53333	1726	672028223000
53334	1874	2367000
53335	1726	672027220000
53336	1874	2370000
53337	1726	672026219000
53338	1874	2371000
53339	1747	3616846000000
53340	1747	3616859000000
53343	1397	1361452279000
53344	1678	14400545821000
53345	632	94800835000000
53346	632	94800845000000
53362	1397	1361432277000
53363	1678	14400545823000
53364	1397	1361422276000
53365	1678	14400545824000
53366	1397	1361412275000
53367	1678	14400545825000
53368	1726	672020205000
53369	1874	2385000
53370	1726	672019203000
53371	1874	2387000
53372	1726	672018200000
53373	1874	2390000
53374	1726	672017198000
53375	1874	2392000
53376	1726	672016197000
53377	1874	2393000
53378	1726	672015194000
53379	1874	2396000
53380	1726	672014192000
53381	1874	2398000
53382	1726	672013191000
53383	1874	2399000
53384	149	77790110000341
53385	149	77790148000341
53400	1508	10836251500009
53411	1672	10801870000000
53438	1677	123049928324100
53439	1677	123049941324100
53461	1397	1361332267000
53462	1678	14400545833000
53463	1726	671992150000
53464	1874	2440000
53465	1726	671991147000
53466	1874	2443000
53467	1726	671990146000
53468	1874	2444000
53489	1397	1361312265000
53490	1678	14400545835000
53491	1397	1361302264000
53492	1678	14400545836000
53493	1726	671983132000
53494	1874	2458000
53495	1726	671982129000
53496	1874	2461000
53497	1726	671981128000
53498	1874	2462000
53499	1726	671980126000
53500	1874	2464000
53501	1726	671979123000
53502	1874	2467000
53503	1692	57622510019999
53594	1654	13248082000000
53635	1419	14141287280064
53654	43	73920722890000
53667	1397	1361122246000
53668	1678	15120584854000
53669	1397	1361112245000
53670	1678	15120584855000
53671	1397	1361102244000
53672	1678	15120584856000
53673	1726	671927019000
53674	1874	2571000
53675	1726	671926018000
53676	1874	2572000
53677	1726	671925015000
53678	1874	2575000
53679	1726	671924013000
53680	1874	2577000
53681	1726	671923012000
53682	1874	2578000
53683	1726	671922009000
53684	1874	2581000
53685	1726	671921007000
53686	1874	2583000
53687	1726	671920006000
53688	1874	2584000
53689	1726	671919003000
53690	1874	2587000
53710	1513	22320734000000
53714	1726	671911989000
53715	1874	2601000
53716	1726	671910988000
53717	1874	2602000
53718	1726	671909985000
53719	1874	2605000
53720	641	71379837000000
53790	1506	6481086967172
53802	1688	86042109904000
53803	1688	86042123904000
53867	1397	1360922226000
53868	1678	15120584874000
53869	1637	166324662819997
53870	1637	166324672819997
53928	1688	86762119904000
53929	1688	86762161904000
53960	1397	1360832217000
53961	1678	15120584883000
53962	1924	1197000000
53963	1726	671841847000
53964	1874	2743000
53965	1726	671840844000
53966	1874	2746000
53967	1925	1197000000
53968	149	78510148000341
53969	149	78510162000341
53982	1397	1360812215000
53983	1678	15120584885000
53984	1925	1196000000
53985	613	66000000000000
53986	1726	671836837000
53987	1874	2753000
53988	1726	671835835000
53989	1874	2755000
53990	1726	671834832000
53991	1874	2758000
53992	1677	123049942324100
54002	1634	11710724641004
54032	1444	8495030160000
53158	1874	2269000
53159	1726	672077319000
53160	1874	2271000
53161	1726	672076318000
53162	1874	2272000
53163	1643	7056380113700
53164	1643	7056396113700
53169	1397	1361612295000
53170	1678	14400545805000
53171	1397	1361602294000
53172	1678	14400545806000
53173	1726	672075315000
53174	1874	2275000
53175	1726	672074313000
53176	1874	2277000
53177	1726	672073312000
53178	1874	2278000
53179	1726	672072309000
53180	1874	2281000
53181	1726	672071307000
53182	1874	2283000
53183	1726	672070306000
53184	1874	2284000
53185	1726	672069303000
53186	1874	2287000
53187	1726	672068301000
53188	1874	2289000
53189	1726	672067300000
53190	1874	2290000
53191	1672	10801854000000
53192	1672	10801886000000
53197	1685	82801566571430
53200	1397	1361592293000
53201	1678	14400545807000
53202	1397	1361582292000
53203	1678	14400545808000
53204	1397	1361572291000
53205	1678	14400545809000
53206	1397	1361562290000
53207	1678	14400545810000
53208	1397	1361552289000
53209	1678	14400545811000
53210	1726	672066297000
53211	1874	2293000
53212	1726	672065295000
53213	1874	2295000
53214	1726	672064294000
53215	1874	2296000
53216	1726	672063292000
53217	1874	2298000
53218	1726	672062291000
53219	1874	2299000
53220	1726	672061289000
53221	1874	2301000
53222	1726	672060286000
53223	1874	2304000
53224	1726	672059285000
53225	1874	2305000
53226	1726	672058283000
53227	1874	2307000
53228	1726	672057280000
53229	1874	2310000
53230	1726	672056279000
53231	1874	2311000
53232	1726	672055277000
53233	1874	2313000
53234	1726	672054274000
53235	1874	2316000
53236	1726	672053273000
53237	1874	2317000
53238	1677	122329991324100
53241	1696	9137360840000
53263	1397	1361522286000
53264	1678	14400545814000
53265	1397	1361512285000
53266	1678	14400545815000
53267	1726	672046259000
53268	1874	2331000
53269	1726	672045256000
53270	1874	2334000
53271	1726	672044255000
53272	1874	2335000
53273	1726	672043253000
53274	1874	2337000
53275	1726	672042250000
53276	1874	2340000
53277	1726	672041249000
53278	1874	2341000
53279	1608	10365559000000
53280	1608	10365585000000
53282	1444	7775003160000
53293	1762	11121869994000
53296	1729	15407044000000
53297	1729	15407054000000
53312	1683	315796290149541
53314	1397	1361482282000
53315	1678	14400545818000
53316	1397	1361472281000
53317	1678	14400545819000
53318	1726	672034235000
53319	1874	2355000
53320	1726	672033232000
53321	1874	2358000
53322	1726	672032231000
53323	1874	2359000
53324	1726	672031229000
53325	1874	2361000
53326	1726	672030226000
53327	1874	2364000
53328	1726	672029225000
53329	1874	2365000
53330	1683	315796319149541
53399	1698	9176969550035
53430	1397	1361362270000
53431	1678	14400545830000
53432	1726	672001168000
53433	1874	2422000
53434	1726	672000165000
53435	1874	2425000
53436	1726	671999164000
53437	1874	2426000
53440	1397	1361352269000
53441	1678	14400545831000
53442	1670	11520973000000
53443	1670	11520983000000
53474	1397	1361322266000
53475	1678	14400545834000
53476	1726	671989144000
53477	1874	2446000
53478	1726	671988141000
53479	1874	2449000
53480	1726	671987140000
53481	1874	2450000
53482	1726	671986138000
53483	1874	2452000
53484	1726	671985135000
53485	1874	2455000
53486	1726	671984134000
53487	1874	2456000
53488	1571	16560317001024
53532	1594	10705149000000
53593	1991	7675768441475
53613	1991	8395794441475
53657	1397	1361132247000
53658	1678	15120584853000
53659	1726	671930025000
53660	1874	2565000
53661	1726	671929024000
53662	1874	2566000
53663	1726	671928021000
53664	1874	2569000
53693	1397	1361092243000
53694	1678	15120584857000
53695	1397	1361082242000
53696	1678	15120584858000
53697	1726	671918001000
53698	1874	2589000
53699	1726	671917000000
53700	1874	2590000
53701	1726	671915997000
53702	1874	2593000
53703	1726	671914995000
53704	1874	2595000
53705	1726	671913994000
53706	1874	2596000
53707	1726	671912991000
53708	1874	2599000
53709	1677	123049962324100
53725	1397	1361062240000
53726	1678	15120584860000
53727	1726	671908983000
53728	1874	2607000
53729	1726	671907982000
53730	1874	2608000
53731	1726	671906979000
53732	1874	2611000
53733	1726	671905977000
53734	1874	2613000
53735	1726	671904976000
53736	1874	2614000
53737	58	78186392999659
53757	1672	11521867000000
53758	1672	11521880000000
53777	1397	1361012235000
53778	1678	15120584865000
53454	1874	2434000
53455	1726	671994153000
53456	1874	2437000
53457	1726	671993152000
53458	1874	2438000
53459	1458	11613545908540
53460	1458	11613558908540
53470	1688	85322099904000
53471	1688	85322109904000
53514	1397	1361282262000
53515	1678	14400545838000
53516	1397	1361272261000
53517	1678	14400545839000
53518	1726	671975116000
53519	1874	2474000
53520	1726	671974114000
53521	1874	2476000
53522	1726	671973111000
53523	1874	2479000
53524	1726	671972110000
53525	1874	2480000
53526	1726	671971108000
53527	1874	2482000
53528	1726	671970105000
53529	1874	2485000
53530	1683	317236319149541
53531	1683	317236348149541
53595	1397	1361192253000
53596	1678	14400545847000
53597	1726	671948062000
53598	1874	2528000
53599	1726	671947060000
53600	1874	2530000
53601	1726	671946057000
53602	1874	2533000
53603	1397	1361182252000
53604	1678	14400545848000
53605	1726	671945056000
53606	1874	2534000
53607	1726	671944054000
53608	1874	2536000
53609	1726	671943051000
53610	1874	2539000
53611	1991	8395784441475
53612	1991	8395797441475
53633	1678	15120545850000
53634	1678	15120584850000
53636	1397	1361152249000
53637	1678	15120584851000
53638	1397	1361142248000
53639	1678	15120584852000
53640	1726	671936037000
53641	1874	2553000
53642	1726	671935036000
53643	1874	2554000
53644	1726	671934033000
53645	1874	2557000
53646	1726	671933031000
53647	1874	2559000
53648	1726	671932030000
53649	1874	2560000
53650	1726	671931027000
53651	1874	2563000
53652	43	73920702890000
53653	43	73920728890000
53691	1474	8194406000023
53692	1474	8194437000023
53711	1397	1361072241000
53712	1678	15120584859000
53713	641	71379862000000
53748	1397	1361042238000
53749	1678	15120584862000
53750	1726	671900967000
53751	1874	2623000
53752	1726	671899965000
53753	1874	2625000
53754	1726	671898964000
53755	1874	2626000
53756	1656	11661487999990
53791	1397	1361002234000
53792	1678	15120584866000
53793	1925	1199000000
53794	1726	671889946000
53795	1874	2644000
53796	1726	671888943000
53797	1874	2647000
53798	1726	671887941000
53799	1874	2649000
53800	1607	8898234644388
53801	1607	8898251644388
53901	1775	849210000
53902	2047	41290000
53903	1397	1360892223000
53904	1678	15120584877000
53905	1397	1360882222000
53906	1678	15120584878000
53907	1397	1360872221000
53908	1678	15120584879000
53909	1726	671858882000
53910	1874	2708000
53911	1726	671857879000
53912	1874	2711000
53913	1726	671856878000
53914	1874	2712000
53915	1726	671855876000
53916	1874	2714000
53917	1726	671854873000
53918	1874	2717000
53919	1726	671853872000
53920	1874	2718000
53921	1726	671852870000
53922	1874	2720000
53923	1726	671851867000
53924	1874	2723000
53925	1726	671850866000
53926	1874	2724000
53927	369	92640811000000
53953	1397	1360842218000
53954	1678	15120584882000
53955	1726	671843852000
53956	1874	2738000
53957	1726	671842849000
53958	1874	2741000
53959	1593	7749854000000
54024	1796	200000001
54025	1980	13679161999999
54026	1980	200000004
54027	1796	13679162995023
54028	1527	8053021459
54029	1449	287999962
54036	114	66722761000000
54069	1688	88202172904000
54070	1688	88202192904000
54072	1688	88202182904000
54085	1444	9215047159999
54092	1726	671816792000
54093	1874	2798000
54094	1726	671815789000
54095	1874	2801000
54096	1726	671814788000
54097	1874	2802000
54098	1726	671813786000
54099	1874	2804000
54100	1692	58342510019999
54101	1692	58342536019999
54157	1634	11711754641004
54169	1692	59062536019999
54170	1692	59062550019999
54202	1397	1360622196000
54203	1678	15120584904000
54204	1726	671785729000
54205	1874	2861000
54206	1769	1703900000
54207	1726	671784728000
54208	1874	2862000
54209	1726	671783726000
54210	1874	2864000
54211	1726	671782723000
54212	1874	2867000
54213	1726	671781722000
54214	1874	2868000
54215	1726	671780720000
54216	1874	2870000
54217	1649	13964116999992
54229	1696	9137294840000
54230	1692	59062549019999
54232	1397	1360602194000
54233	1678	15120584906000
54234	1726	671776711000
54235	1874	2879000
54236	1726	671775710000
54237	1874	2880000
54238	1726	671774708000
54239	1874	2882000
54240	1593	8469867000000
54286	1679	28907912652000
54324	1764	7206837100000
54338	633	75964003900000
54339	633	75964016900000
54351	1397	1360502184000
54352	1678	15120584916000
54353	1726	668117653000
54354	1874	2937000
54355	1726	668116651000
54356	1874	2939000
53744	1726	671901970000
53745	1874	2620000
53746	1687	6472554524804
53747	1687	6472567524804
53759	1397	1361032237000
53760	1678	15120584863000
53761	1397	1361022236000
53762	1678	15120584864000
53763	1926	1198000000
53764	1726	671897961000
53765	1874	2629000
53766	1726	671896959000
53767	1874	2631000
53768	1726	671895958000
53769	1874	2632000
53770	1726	671894955000
53771	1874	2635000
53772	1683	315796344149541
53773	1726	671893953000
53774	1874	2637000
53775	1683	317236344149541
53776	1683	317236345149541
53788	1670	12240986000000
53789	1670	12240999000000
53804	1397	1360992233000
53805	1678	15120584867000
53806	1397	1360982232000
53807	1678	15120584868000
53808	1769	1705900000
53809	1925	1198000000
53810	1726	671886938000
53811	1874	2652000
53812	1726	671885936000
53813	1874	2654000
53814	1726	671884933000
53815	1874	2657000
53816	1726	671883932000
53817	1874	2658000
53818	1726	671882930000
53819	1874	2660000
53820	1683	318676345149541
53821	1683	318676372149541
53823	1397	1360972231000
53824	1678	15120584869000
53825	1726	671881927000
53826	1874	2663000
53827	1726	671880926000
53828	1874	2664000
53829	1726	671879924000
53830	1874	2666000
53831	1683	320116372149541
53832	1683	320116385149541
53837	1397	1360962230000
53838	1678	15120584870000
53839	1397	1360952229000
53840	1678	15120584871000
53841	1397	1360942228000
53842	1678	15120584872000
53843	1726	671878921000
53844	1874	2669000
53845	1726	671877920000
53846	1874	2670000
53847	1726	671876918000
53848	1874	2672000
53849	1726	671875915000
53850	1874	2675000
53851	1726	671874914000
53852	1874	2676000
53853	1726	671873912000
53854	1874	2678000
53855	1726	671872909000
53856	1874	2681000
53857	1726	671871908000
53858	1874	2682000
53859	1726	671870906000
53860	1874	2684000
53861	58	78906392999659
53862	58	78906435999659
53871	1775	861300000
53872	2047	41200000
53873	1397	1360912225000
53874	1678	15120584875000
53875	1397	1360902224000
53876	1678	15120584876000
53877	1726	671869903000
53878	1874	2687000
53879	1726	671868902000
53880	1874	2688000
53881	1726	671867900000
53882	1874	2690000
53883	1726	671866897000
53884	1874	2693000
53885	1726	671865896000
53886	1874	2694000
53887	1726	671864894000
53888	1874	2696000
53889	1726	671863891000
53890	1874	2699000
53891	1726	671862890000
53892	1874	2700000
53893	1726	671861888000
53894	1874	2702000
53895	1726	671860885000
53896	1874	2705000
53897	1726	671859884000
53898	1874	2706000
53899	1749	2685026000000
53900	1749	2685068000000
53930	1397	1360862220000
53931	1678	15120584880000
53932	1726	671849864000
53933	1874	2726000
53934	1726	671848861000
53935	1874	2729000
53936	1726	671847860000
53937	1874	2730000
53938	1513	23040734000000
53939	1513	23040756000000
53951	1688	87482161904000
53952	1688	87482172904000
53970	1397	1360822216000
53971	1678	15120584884000
53972	1926	1196000000
53973	1726	671839843000
53974	1874	2747000
53975	1726	671838841000
53976	1874	2749000
53977	1726	671837838000
53978	1874	2752000
53979	1476	7920098000000
53980	1476	7920112000000
53993	1683	320116386149541
53995	1397	1360802214000
53996	1678	15120584886000
53997	1723	11159326085979
53998	1723	11159336085979
54003	1397	1360792213000
54004	1678	15120584887000
54005	1397	1360782212000
54006	1678	15120584888000
54007	1726	671833830000
54008	1874	2760000
54009	1726	671832827000
54010	1874	2763000
54011	1726	671831825000
54012	1874	2765000
54013	1726	671830822000
54014	1874	2768000
54015	1726	671829820000
54016	1874	2770000
54017	1726	671828819000
54018	1874	2771000
54019	1726	671827816000
54020	1874	2774000
54021	1444	8495009160000
54022	2097	8495037159999
54023	1444	200000001
54033	114	66722733000000
54034	114	200000001
54035	1796	66722760999999
54057	1726	671823808000
54058	1874	2782000
54059	1726	671822807000
54060	1874	2783000
54061	1726	671821804000
54062	1874	2786000
54063	1726	671820802000
54064	1874	2788000
54065	1726	671819799000
54066	1874	2791000
54067	43	74640728890000
54068	43	74640743890000
54071	1560	9954250277001
54083	1509	9311773851155
54084	1509	9311785851155
54119	1513	23760756000000
54120	1513	23760782000000
54151	1601	4250147600000
54152	1601	4250177600000
54156	1601	4250168600000
54175	1726	671794747000
54176	1874	2843000
54177	1726	671793746000
54178	1874	2844000
54179	1726	671792744000
53779	1726	671892952000
53780	1874	2638000
53781	1726	671891949000
53782	1874	2641000
53783	1726	671890947000
53784	1874	2643000
53785	42	86878351000000
53786	1670	12240886000000
53787	1670	12240899000000
53822	1685	82801561571430
53833	1688	86042119904000
53834	1924	1198000000
53835	58	79626401999659
53836	58	79626406999659
53863	1397	1360932227000
53864	1678	15120584873000
53865	1769	1704900000
53866	1419	14141268280064
53940	1397	1360852219000
53941	1678	15120584881000
53942	1926	1197000000
53943	1726	671846858000
53944	1874	2732000
53945	1726	671845855000
53946	1874	2735000
53947	1726	671844854000
53948	1874	2736000
53949	1709	6480059999976
53950	1709	6480073999976
53981	1476	7920109000000
53994	1685	82801548571430
53999	1924	1196000000
54000	1650	6514072000000
54001	1650	6514128000000
54030	1980	200000007
54031	1796	13679162995020
54037	1634	11711724641004
54038	1634	11711752641004
54054	1397	1360752209000
54055	1678	15120584891000
54056	1560	9954245277001
54073	1397	1360742208000
54074	1678	15120584892000
54075	1726	671818797000
54076	1874	2793000
54077	1726	671817794000
54078	1874	2796000
54079	1444	9215037159999
54080	1444	9215049159999
54081	1402	37294159319298
54082	1402	37294169319298
54121	1397	1360692203000
54122	1678	15120584897000
54123	1397	1360682202000
54124	1678	15120584898000
54125	1726	671806771000
54126	1874	2819000
54127	1726	671805770000
54128	1874	2820000
54129	1726	671804768000
54130	1874	2822000
54131	1726	671803765000
54132	1874	2825000
54133	1726	671802764000
54134	1874	2826000
54135	1726	671801762000
54136	1874	2828000
54137	1506	7201086967172
54138	1506	7201112967172
54140	2058	549500000
54141	1397	1360672201000
54142	1678	15120584899000
54143	1634	11711751641004
54153	1694	9372453127629
54171	1397	1360652199000
54172	1678	15120584901000
54173	1397	1360642198000
54174	1678	15120584902000
54189	1397	1360632197000
54190	1678	15120584903000
54191	1726	671788735000
54192	1874	2855000
54193	1726	671787734000
54194	1874	2856000
54195	1726	671786732000
54196	1874	2858000
54197	1587	10800385000000
54198	1587	10800398000000
54218	1522	8254101000000
54219	1522	8254118000000
54241	1397	1360592193000
54242	1678	15120584907000
54243	1602	7920395000000
54253	58	79626435999659
54254	58	79626448999659
54267	1637	167764682819997
54302	1726	668129678000
54303	2103	1400000000
54304	1397	1360542188000
54305	1678	15120584912000
54306	1397	1360532187000
54307	1678	15120584913000
54308	1726	668128675000
54309	1874	2915000
54310	1726	668127674000
54311	1874	2916000
54312	1726	668126672000
54313	1874	2918000
54314	1726	668125669000
54315	1874	2921000
54316	1726	668124668000
54317	1874	2922000
54318	1726	668123666000
54319	1874	2924000
54320	607	67440001000000
54321	607	67440037000000
54327	1397	1360522186000
54328	1678	15120584914000
54329	1402	38014169319298
54330	1402	38014179319298
54361	1683	322996429149541
54391	1759	9360665999999
54392	1759	9360675999999
54409	1726	668102623000
54410	1874	2967000
54411	1726	668101621000
54412	1874	2969000
54413	1471	11419598900000
54414	1471	11419611900000
54417	1471	11419608900000
54444	1397	1360412175000
54445	1678	15120584925000
54446	1726	668091602000
54447	1874	2988000
54448	1726	668090599000
54449	1874	2991000
54450	1726	668089597000
54451	1874	2993000
54485	1397	1360372171000
54486	1678	15120584929000
54487	1726	668079576000
54488	1874	3014000
54489	1726	668078575000
54490	1874	3015000
54491	1726	668077573000
54492	1874	3017000
54493	1422	7344973860211
54494	1422	7344986860211
54499	1683	324436424149541
54500	1683	324436530149541
54528	1677	124490026324100
54529	1677	125210026324100
54530	1677	125210030324100
54610	1508	11556254500009
54611	1508	11556278500009
54623	1633	7956374985638
54624	1397	1360292163000
54625	1678	15120584937000
54626	1726	668060537000
54627	1874	3053000
54628	1726	668059534000
54629	1874	3056000
54630	1402	39454192319298
54631	1402	39454204319298
54654	1685	83521560571430
54692	1573	4298855000000
54693	1573	4298867000000
54694	1397	1360212155000
54695	1678	15120584945000
54696	1726	668042492000
54697	1874	3098000
54698	1726	668041489000
54699	1874	3101000
54700	1695	7532151000000
54701	1695	7532163000000
54752	1397	1360142148000
54753	1678	15120584952000
54754	1726	668025454000
54755	1874	3136000
54756	1726	666815454000
54757	2105	200000000
54758	1726	666814453000
54759	1874	3137000
54760	1726	666813450000
54761	1874	3140000
54039	1397	1360772211000
54040	1678	15120584889000
54041	1726	671826814000
54042	1874	2776000
54043	1726	671825813000
54044	1874	2777000
54045	1726	671824810000
54046	1874	2780000
54047	1925	1195000000
54048	1672	12241880000000
54049	1672	12241894000000
54050	1397	1360762210000
54051	1678	15120584890000
54052	1637	167044672819997
54053	1637	167044682819997
54086	1397	1360732207000
54087	1678	15120584893000
54088	1397	1360722206000
54089	1678	15120584894000
54090	1607	9618251644388
54091	1607	9618271644388
54102	1397	1360712205000
54103	1678	15120584895000
54104	1397	1360702204000
54105	1678	15120584896000
54106	1726	671812783000
54107	1874	2807000
54108	1726	671811782000
54109	1874	2808000
54110	1726	671810780000
54111	1874	2810000
54112	1726	671809777000
54113	1874	2813000
54114	1726	671808776000
54115	1874	2814000
54116	1726	671807774000
54117	1874	2816000
54118	1683	320116398149541
54139	1506	7201106967172
54144	1726	671800759000
54145	1874	2831000
54146	1726	671799758000
54147	1874	2832000
54148	1726	671798756000
54149	1874	2834000
54150	1694	9372463127629
54154	1613	7847812600000
54155	1613	7847842600000
54158	1397	1360662200000
54159	1678	15120584900000
54160	1925	1194000000
54161	1726	671797753000
54162	1874	2837000
54163	1726	671796752000
54164	1874	2838000
54165	1726	671795750000
54166	1874	2840000
54167	1691	7883039100019
54168	1691	7883053100019
54199	1719	7220360000000
54231	1593	8469854000000
54244	1726	671773705000
54245	1874	2885000
54246	1726	671772704000
54247	1874	2886000
54248	1726	671771702000
54249	1874	2888000
54250	1602	7920398000000
54255	58	80346406999659
54256	58	80346450999659
54257	1397	1360582192000
54258	1678	15120584908000
54259	1726	671770699000
54260	1874	2891000
54261	1726	671769698000
54262	1874	2892000
54263	1726	671768696000
54264	1874	2894000
54265	43	75360743890000
54266	43	75360756890000
54287	1397	1360552189000
54288	1678	15120584911000
54289	1726	671761681000
54290	1874	2909000
54291	1726	670551681000
54292	2103	200000000
54293	1726	669341681000
54294	2104	200000000
54295	1726	669340680000
54296	1874	2910000
54297	1726	669339678000
54298	1874	2912000
54299	1677	123049961324100
54322	1683	322996411149541
54323	1683	322996447149541
54325	1685	83521548571430
54326	1685	83521584571430
54331	1726	668122663000
54332	1874	2927000
54333	1726	668121662000
54334	1874	2928000
54335	1726	668120660000
54336	1874	2930000
54340	633	75964013900000
54341	1397	1360512185000
54342	1678	15120584915000
54343	1926	1195000000
54344	1549	11855725000000
54349	1692	59782549019999
54350	1692	59782565019999
54372	1397	1360482182000
54373	1678	15120584918000
54374	1726	668111641000
54375	1874	2949000
54376	1726	668110639000
54377	1874	2951000
54378	1594	11425149000000
54379	1594	11425164000000
54393	1759	9360678999999
54394	1397	1360462180000
54395	1678	15120584920000
54396	1726	668106632000
54397	1874	2958000
54398	1726	668105629000
54399	1874	2961000
54400	1726	668104627000
54401	1874	2963000
54406	1726	668103626000
54407	1874	2964000
54408	470	75360384000000
54415	1701	7990252600056
54416	1701	7990265600056
54471	1703	3600638000000
54473	1397	1360382172000
54474	1678	15120584928000
54475	1726	668082584000
54476	1874	3006000
54477	1726	668081581000
54478	1874	3009000
54479	1726	668080579000
54480	1874	3011000
54481	1547	7053272000000
54482	1547	7053285000000
54495	1402	38734179319298
54496	1402	38734192319298
54498	1637	167764694819997
54501	1397	1360362170000
54502	1678	15120584930000
54503	1397	1360352169000
54504	1678	15120584931000
54505	1397	1360342168000
54506	1678	15120584932000
54507	1726	668076570000
54508	1874	3020000
54509	1726	668075568000
54510	1874	3022000
54511	1726	668074565000
54512	1874	3025000
54513	1726	668073564000
54514	1874	3026000
54515	2039	7201138000000
54516	2039	7921138000000
54534	1397	1360332167000
54535	1678	15120584933000
54536	1726	668068553000
54537	1874	3037000
54538	1726	668067552000
54539	1874	3038000
54540	1607	9618263644388
54543	1397	1360322166000
54544	1678	15120584934000
54545	1397	1360312165000
54546	1678	15120584935000
54547	1726	668066550000
54548	1874	3040000
54549	1726	668065549000
54550	1874	3041000
54551	1726	668064547000
54552	1874	3043000
54553	1726	668063544000
54554	1874	3046000
54555	1451	4938803000000
54556	1451	4938827000000
54612	1539	720001000000
54613	1539	720025000000
54180	1874	2846000
54181	1726	671791741000
54182	1874	2849000
54183	1726	671790740000
54184	1874	2850000
54185	1726	671789738000
54186	1874	2852000
54187	1474	8914437000023
54188	1474	8914463000023
54200	1719	7220350000000
54201	1587	10800388000000
54220	1397	1360612195000
54221	1678	15120584905000
54222	1726	671779717000
54223	1874	2873000
54224	1726	671778716000
54225	1874	2874000
54226	1726	671777714000
54227	1874	2876000
54228	1696	9137297840000
54251	1693	16473587155041
54252	1693	16473600155041
54268	1397	1360572191000
54269	1678	15120584909000
54270	1397	1360562190000
54271	1678	15120584910000
54272	1726	671767693000
54273	1874	2897000
54274	1726	671766692000
54275	1874	2898000
54276	1726	671765690000
54277	1874	2900000
54278	1726	671764687000
54279	1874	2903000
54280	1726	671763686000
54281	1874	2904000
54282	1726	671762684000
54283	1874	2906000
54284	1683	321556385149541
54285	1683	321556411149541
54300	1764	7206801100000
54301	1764	7206834100000
54337	1509	9311786851155
54345	1726	668119657000
54346	1874	2933000
54347	1726	668118656000
54348	1874	2934000
54362	1397	1360492183000
54363	1678	15120584917000
54364	1622	12780262000014
54371	639	66720000000000
54452	1397	1360402174000
54453	1678	15120584926000
54454	1726	668088596000
54455	1874	2994000
54456	1726	668087593000
54457	1874	2997000
54458	1726	668086591000
54459	1874	2999000
54460	1677	124489979324100
54461	1677	124489992324100
54472	1702	7200294000000
54497	1422	7344976860211
54517	1693	16473634155041
54518	1726	668072562000
54519	1874	3028000
54520	1726	668071559000
54521	1874	3031000
54522	1726	668070558000
54523	1874	3032000
54524	1726	668069556000
54525	1874	3034000
54526	1693	17193634155041
54527	1693	17193638155041
54531	1749	2685102000000
54532	1749	3405102000000
54533	1749	3405106000000
54541	1683	325876530149541
54542	1683	325876581149541
54557	1950	3999852000000
54558	1950	4669852000000
54559	1678	14400545851000
54560	1678	14400545852000
54561	1678	14400545853000
54562	1678	14400545854000
54563	1678	14400545855000
54564	1451	4219637000000
54565	1678	14400545856000
54566	1678	14400545857000
54567	1678	14400545858000
54568	1678	14400545859000
54569	1678	14400545860000
54570	1678	14400545861000
54571	1678	14400545862000
54572	1678	14400545863000
54573	1678	14400545864000
54574	1678	14400545865000
54575	1678	14400545866000
54576	1678	14400545867000
54577	1678	14400545868000
54578	1678	14400545869000
54579	1678	14400545870000
54580	1678	14400545871000
54581	1678	14400545872000
54582	1678	14400545873000
54583	1678	14400545874000
54584	1678	14400545875000
54585	1678	14400545876000
54586	1678	14400545877000
54587	1678	14400545878000
54588	1678	14400545879000
54589	1678	14400545880000
54590	1678	14400545881000
54591	1678	14400545882000
54592	1678	14400545883000
54593	1678	14400545884000
54594	1678	14400545885000
54595	1678	14400545886000
54596	1678	14400545887000
54597	1678	14400545888000
54598	1678	14400545889000
54599	1678	14400545890000
54600	1678	14400545891000
54601	1678	14400545892000
54602	1678	14400545893000
54603	1678	14400545894000
54604	1678	14400545895000
54605	1678	14400545896000
54606	1678	14400545897000
54607	1451	4939637000000
54608	1451	4940057000000
54622	1444	9215038159999
54632	1637	167764692819997
54655	1397	1360252159000
54656	1678	15120584941000
54657	1726	668052517000
54658	1874	3073000
54659	1726	668051514000
54660	1874	3076000
54661	1673	14726218000000
54662	1673	14726230000000
54663	1397	1360242158000
54664	1678	15120584942000
54665	1726	668050512000
54666	1874	3078000
54667	1726	668049509000
54668	1874	3081000
54669	1991	9115794441475
54670	1991	9115806441475
54683	1397	1360222156000
54684	1678	15120584944000
54685	1726	668044497000
54686	1874	3093000
54687	1726	668043494000
54688	1874	3096000
54689	1546	7920652000000
54716	1397	1360182152000
54717	1678	15120584948000
54718	1637	168484692819997
54719	1637	168484702819997
54751	1524	720013000000
54798	1599	8259755393047
54799	1599	8259775393047
54803	1637	169204702819997
54804	1637	169204722819997
54842	1448	4356700000001
54843	1448	4356713000001
54847	1622	13500275000014
54865	1726	666789401000
54866	1874	3189000
54867	1726	666788399000
54868	1874	3191000
54869	1726	666787398000
54870	1874	3192000
54920	1726	666773373000
54921	1874	3217000
54922	1726	666772371000
54923	1874	3219000
54924	1726	666771368000
54925	1874	3222000
54926	1726	666770367000
54927	1874	3223000
54928	1726	666769365000
54929	1874	3225000
54930	1726	666768362000
54357	1726	668115650000
54358	1874	2940000
54359	1677	123769961324100
54360	1677	123769979324100
54365	1726	668114647000
54366	1874	2943000
54367	1726	668113645000
54368	1874	2945000
54369	1726	668112644000
54370	1874	2946000
54380	1650	7234128000000
54381	1650	7234143000000
54382	1397	1360472181000
54383	1678	15120584919000
54384	1726	668109638000
54385	1874	2952000
54386	1726	668108635000
54387	1874	2955000
54388	1726	668107633000
54389	1874	2957000
54390	1683	322996424149541
54402	1397	1360452179000
54403	1678	15120584921000
54404	470	75360360000000
54405	470	75360383000000
54418	1397	1360442178000
54419	1678	15120584922000
54420	1397	1360432177000
54421	1678	15120584923000
54422	1397	1360422176000
54423	1678	15120584924000
54424	1726	668100620000
54425	1874	2970000
54426	1726	668099617000
54427	1874	2973000
54428	1726	668098615000
54429	1874	2975000
54430	1726	668097614000
54431	1874	2976000
54432	1726	668096611000
54433	1874	2979000
54434	1726	668095609000
54435	1874	2981000
54436	1726	668094608000
54437	1874	2982000
54438	1726	668093605000
54439	1874	2985000
54440	1726	668092603000
54441	1874	2987000
54442	1559	7162617000000
54443	1559	7162659000000
54462	1397	1360392173000
54463	1678	15120584927000
54464	1726	668085590000
54465	1874	3000000
54466	1726	668084587000
54467	1874	3003000
54468	1726	668083585000
54469	1874	3005000
54470	1708	5795714000021
54483	1594	12145164000000
54484	1594	12145177000000
54609	1711	10604545000000
54614	1508	11556290500009
54615	1397	1360302164000
54616	1678	15120584936000
54617	1726	668062542000
54618	1874	3048000
54619	1726	668061539000
54620	1874	3051000
54633	1397	1360282162000
54634	1678	15120584938000
54635	1397	1360272161000
54636	1678	15120584939000
54637	1726	668058532000
54638	1874	3058000
54639	1726	668057529000
54640	1874	3061000
54641	1726	668056527000
54642	1874	3063000
54643	1726	668055524000
54644	1874	3066000
54645	1759	9360691999999
54671	1991	9115795441475
54690	1677	125209992324100
54691	1677	125210004324100
54720	1397	1360172151000
54721	1678	15120584949000
54722	1397	1360162150000
54723	1678	15120584950000
54724	1726	668036477000
54725	1874	3113000
54726	1726	668035474000
54727	1874	3116000
54728	1726	668034472000
54729	1874	3118000
54730	1726	668033471000
54731	1874	3119000
54732	1726	668032468000
54733	1874	3122000
54734	1726	668031466000
54735	1874	3124000
54736	1726	668030465000
54737	1874	3125000
54738	1726	668029462000
54739	1874	3128000
54740	1689	6480146287625
54781	576	75875722938283
54782	1397	1360112145000
54783	1678	15120584955000
54784	1397	1360102144000
54785	1678	15120584956000
54786	1602	7920405000000
54800	42	87598251000000
54801	42	87598275000000
54805	1471	12139628900000
54806	1397	1360092143000
54807	1678	15120584957000
54808	1726	666802429000
54809	1874	3161000
54810	1726	666801427000
54811	1874	3163000
54812	1726	666800426000
54813	1874	3164000
54814	1476	7920129000000
54815	1476	8640129000000
54844	1622	13500262000014
54845	1622	13500272000014
54848	1440	6479106000000
54849	1397	1360052139000
54850	1678	15120584961000
54851	1397	1360042138000
54852	1678	15120584962000
54853	1726	666793410000
54854	1874	3180000
54855	1726	666792409000
54856	1874	3181000
54857	1726	666791406000
54858	1874	3184000
54859	1726	666790404000
54860	1874	3186000
54861	1675	6622027999977
54896	1397	1359992133000
54897	1678	15120584967000
54898	1683	325876434149541
54899	1683	325876444149541
54933	1397	1359952129000
54934	1678	15840599971000
54935	1726	666767361000
54936	1874	3229000
54937	1726	666766358000
54938	1874	3232000
54939	1723	11879336085979
54940	1723	11879354085979
54959	1397	1359922126000
54960	1678	15840599974000
54961	1726	666759345000
54962	1874	3245000
54963	1726	666758342000
54964	1874	3248000
54965	1726	666757340000
54966	1874	3250000
54967	1402	39454205319298
54970	1397	1359912125000
54971	1678	15840599975000
54972	1726	666756339000
54973	1874	3251000
54974	1726	666755336000
54975	1874	3254000
54976	1726	666754334000
54977	1874	3256000
54978	1513	24480782000000
54979	1513	24480795000000
55008	1397	1359882122000
55009	1678	15840599978000
55010	1726	666747321000
55011	1874	3269000
55012	1726	666746319000
55013	1874	3271000
55014	1726	666745316000
55015	1874	3274000
55016	1693	17193600155041
55017	1693	17193613155041
55043	1397	1359842118000
55044	1678	15840599982000
54621	1613	7847824600000
54646	1397	1360262160000
54647	1678	15120584940000
54648	1726	668054522000
54649	1874	3068000
54650	1726	668053519000
54651	1874	3071000
54652	1451	5658827000000
54653	1451	5658839000000
54672	1397	1360232157000
54673	1678	15120584943000
54674	1726	668048507000
54675	1874	3083000
54676	1726	668047504000
54677	1874	3086000
54678	1726	668046502000
54679	1874	3088000
54680	1726	668045499000
54681	1874	3091000
54682	1768	9950725110000
54702	1397	1360202154000
54703	1678	15120584946000
54704	1397	1360192153000
54705	1678	15120584947000
54706	1726	668040487000
54707	1874	3103000
54708	1726	668039484000
54709	1874	3106000
54710	1726	668038482000
54711	1874	3108000
54712	1726	668037479000
54713	1874	3111000
54714	1668	11486609000000
54715	1668	11486633000000
54741	1397	1360152149000
54742	1678	15120584951000
54743	1726	668028460000
54744	1874	3130000
54745	1726	668027459000
54746	1874	3131000
54747	1726	668026456000
54748	1874	3134000
54749	1762	11841870994000
54750	1762	11841883994000
54764	1397	1360132147000
54765	1678	15120584953000
54766	1397	1360122146000
54767	1678	15120584954000
54768	1726	666812448000
54769	1874	3142000
54770	1726	666811447000
54771	1874	3143000
54772	1726	666810444000
54773	1874	3146000
54774	1726	666809442000
54775	1874	3148000
54776	1726	666808441000
54777	1874	3149000
54778	1726	666807438000
54779	1874	3152000
54780	576	75875728938283
54796	1471	12139608900000
54797	1471	12139632900000
54819	1688	87482194904000
54820	1726	666799424000
54821	1874	3166000
54822	1688	88202194904000
54823	1688	88202196904000
54832	1397	1360062140000
54833	1678	15120584960000
54834	1726	666796416000
54835	1874	3174000
54836	1726	666795415000
54837	1874	3175000
54838	1726	666794413000
54839	1874	3177000
54840	2106	719000000000
54841	2106	719013000000
54862	1397	1360032137000
54863	1678	15120584963000
54864	1670	12240996000000
54878	1397	1360012135000
54879	1678	15120584965000
54880	1397	1360002134000
54881	1678	15120584966000
54882	1726	666784394000
54883	1874	3196000
54884	1726	666783391000
54885	1874	3199000
54886	1726	666782389000
54887	1874	3201000
54888	1726	666781388000
54889	1874	3202000
54890	1726	666780385000
54891	1874	3205000
54892	1726	666779383000
54893	1874	3207000
54894	1677	126650017324100
54895	1677	126650043324100
54914	1397	1359972131000
54915	1678	15840599969000
54916	1397	1359962130000
54917	1678	15840599970000
54918	1683	327316444149541
54919	1683	327316464149541
55006	149	79230162000341
55007	149	79230175000341
55059	1726	666733292000
55060	1874	3298000
55061	1726	666732291000
55062	1874	3299000
55063	1688	88202174904000
55087	1688	88922174904000
55088	1688	88922211904000
55141	1683	333076528149541
55142	1683	333076541149541
55161	1506	7921122967172
55163	1397	1359742108000
55164	1678	15840599992000
55165	1397	1359732107000
55166	1678	15840599993000
55167	1726	666703234000
55168	1874	3356000
55169	1726	666702232000
55170	1874	3358000
55171	1726	666701229000
55172	1874	3361000
55173	1726	666700228000
55174	1874	3362000
55175	1726	666699226000
55176	1874	3364000
55177	1726	666698223000
55178	1874	3367000
55179	1402	39454228319298
55238	1397	1359662100000
55239	1678	15840600000000
55240	1726	666680189000
55241	1874	3401000
55242	1726	666679187000
55243	1874	3403000
55244	1726	666678184000
55245	1874	3406000
55246	1685	84241560571430
55247	1685	84241573571430
55275	1613	8567824600000
55276	1613	8567850600000
55278	1397	1359622096000
55279	1678	15840600004000
55280	1673	14006234000000
55281	1726	666669166000
55282	1874	3424000
55283	1726	666668165000
55284	1874	3425000
55285	1726	666667163000
55286	1874	3427000
55287	1673	14726234000000
55288	1673	14726237000000
55313	1508	11556267500009
55334	1678	15120584971000
55335	1678	15120584972000
55336	1678	15120584973000
55337	1678	15120584974000
55338	1678	15120584975000
55339	1678	15120584976000
55340	1678	15120584977000
55341	1678	15120584978000
55342	1678	15120584979000
55343	1678	15120584980000
55344	1678	15120584981000
55345	1678	15120584982000
55346	1678	15120584983000
55347	1678	15120584984000
55348	1678	15120584985000
55349	1678	15120584986000
55350	1678	15120584987000
55351	1678	15120584988000
55352	1678	15120584989000
55353	1678	15120584990000
55354	1678	15120584991000
55355	1678	15120584992000
55356	1678	15120584993000
55357	1678	15120584994000
55358	1678	15120584995000
55359	1678	15120584996000
55360	1678	15120584997000
54762	1549	12575725000000
54763	1549	12575748000000
54787	1726	666806436000
54788	1874	3154000
54789	1726	666805435000
54790	1874	3155000
54791	1726	666804433000
54792	1874	3157000
54793	1726	666803432000
54794	1874	3158000
54795	1602	7920409000000
54802	1599	8259779393047
54816	1397	1360082142000
54817	1678	15120584958000
54818	1683	324436434149541
54824	1397	1360072141000
54825	1678	15120584959000
54826	1726	666798421000
54827	1874	3169000
54828	1726	666797419000
54829	1874	3171000
54830	1677	125930004324100
54831	1677	125930017324100
54846	1440	6479109000000
54871	1397	1360022136000
54872	1678	15120584964000
54873	1726	666786397000
54874	1874	3193000
54875	1726	666785395000
54876	1874	3195000
54877	1654	13248009000000
54900	1397	1359982132000
54901	1678	15120584968000
54902	1726	666778382000
54903	1874	3208000
54904	1726	666777380000
54905	1874	3210000
54906	1726	666776379000
54907	1874	3211000
54908	1726	666775377000
54909	1874	3213000
54910	1726	666774374000
54911	1874	3216000
54912	1678	15840584968000
54913	1678	15840599968000
54941	1397	1359942128000
54942	1678	15840599972000
54943	1726	666765357000
54944	1874	3233000
54945	1726	666764354000
54946	1874	3236000
54947	1726	666763352000
54948	1874	3238000
54968	1683	328756464149541
54969	1683	328756477149541
54980	1397	1359902124000
54981	1678	15840599976000
54982	1726	666753333000
54983	1874	3257000
54984	1726	666752331000
54985	1874	3259000
54986	1726	666751328000
54987	1874	3262000
54988	1444	9215050159999
54997	1397	1359892123000
54998	1678	15840599977000
54999	1726	666750327000
55000	1874	3263000
55001	1726	666749325000
55002	1874	3265000
55003	1726	666748322000
55004	1874	3268000
55005	1700	7505885276737
55018	1683	330196477149541
55019	1683	330196490149541
55054	1623	48962519899898
55099	1397	1359792113000
55100	1678	15840599987000
55101	1726	666721270000
55102	1874	3320000
55103	1726	666720268000
55104	1874	3322000
55105	1726	666719265000
55106	1874	3325000
55107	1513	25200795000000
55108	1513	25200808000000
55119	1702	7200297000000
55130	1683	331636515149541
55131	1683	331636528149541
55159	1506	7921106967172
55160	1506	7921116967172
55162	1593	9189873000000
55202	1397	1359702104000
55203	1678	15840599996000
55204	1726	666691210000
55205	1874	3380000
55206	1726	666690208000
55207	1874	3382000
55208	1689	7200146287625
55209	1689	7200158287625
55248	1397	1359652099000
55249	1678	15840600001000
55250	1726	666677183000
55251	1874	3407000
55252	1726	666676181000
55253	1874	3409000
55254	1692	59782561019999
55273	1687	7192567524804
55274	1687	7192593524804
55314	1397	1359592093000
55315	1678	15840600007000
55316	1726	666660149000
55317	1874	3441000
55318	1726	666659148000
55319	1874	3442000
55320	1726	666658145000
55321	1874	3445000
55322	1680	6489306500035
55325	1397	1359582092000
55326	1678	15840600008000
55327	1726	666657143000
55328	1874	3447000
55329	1726	666656142000
55330	1874	3448000
55331	1726	666655139000
55332	1874	3451000
55333	526	66720013000000
55441	1422	7345012860211
55445	1726	666642113000
55446	1874	3477000
55447	1726	666641112000
55448	1874	3478000
55449	1726	666640109000
55450	1874	3481000
55453	1397	1359522086000
55454	1678	15840600014000
55455	1397	1359512085000
55456	1678	15840600015000
55457	1726	666639107000
55458	1874	3483000
55459	1726	666638106000
55460	1874	3484000
55461	1726	666637103000
55462	1874	3487000
55463	1726	666636101000
55464	1874	3489000
55465	1726	666635100000
55466	1874	3490000
55467	1726	666634097000
55468	1874	3493000
55469	1693	17913613155041
55470	1693	17913639155041
55494	1726	666631091000
55495	1874	3499000
55496	1726	666630089000
55497	1874	3501000
55498	1726	666629088000
55499	1874	3502000
55500	1726	666628085000
55501	1874	3505000
55502	1726	666627083000
55503	1874	3507000
55504	1726	666626082000
55505	1874	3508000
55506	1694	10092463127629
55507	1694	10092529127629
55521	1726	666622073000
55522	1874	3517000
55523	1726	666621071000
55524	1874	3519000
55525	1726	666620070000
55526	1874	3520000
55527	1726	666619067000
55528	1874	3523000
55529	1726	666618065000
55530	1874	3525000
55531	1726	666617064000
55532	1874	3526000
55533	1599	8259781393047
55578	1402	40174228319298
55579	1402	40174241319298
55588	1397	1359412075000
55589	1678	15840600025000
55590	1397	1359402074000
55591	1678	15840600026000
54931	1874	3228000
54932	606	72137728812962
54949	1397	1359932127000
54950	1678	15840599973000
54951	1726	666762351000
54952	1874	3239000
54953	1726	666761348000
54954	1874	3242000
54955	1726	666760346000
54956	1874	3244000
54957	1677	127370043324100
54958	1677	127370056324100
54989	1444	8495077159999
54990	1678	15120584969000
54991	1678	15120584970000
54992	1444	9215077159999
54993	1444	11674511943000
54994	1447	9215167159982
54995	1571	200000001
54996	2004	16560317001040
55020	1397	1359872121000
55021	1678	15840599979000
55022	1397	1359862120000
55023	1678	15840599980000
55024	1397	1359852119000
55025	1678	15840599981000
55026	1726	666744315000
55027	1874	3275000
55028	1726	666743313000
55029	1874	3277000
55030	1726	666742310000
55031	1874	3280000
55032	1726	666741309000
55033	1874	3281000
55034	1726	666740307000
55035	1874	3283000
55036	1726	666739304000
55037	1874	3286000
55038	1726	666738303000
55039	1874	3287000
55040	1726	666737301000
55041	1874	3289000
55042	1683	330196515149541
55055	1637	168484712819997
55056	1637	169204712819997
55057	1637	200000001
55058	1964	169204715819996
55064	1397	1359832117000
55065	1678	15840599983000
55066	1397	1359822116000
55067	1678	15840599984000
55068	1726	666731289000
55069	1874	3301000
55070	1726	666730288000
55071	1874	3302000
55072	1726	666729286000
55073	1874	3304000
55074	1726	666728283000
55075	1874	3307000
55076	1637	169204726819997
55109	1397	1359782112000
55110	1678	15840599988000
55111	1726	666718264000
55112	1874	3326000
55113	1726	666717262000
55114	1874	3328000
55115	1726	666716259000
55116	1874	3331000
55143	1397	1359752109000
55144	1678	15840599991000
55145	1726	666709246000
55146	1874	3344000
55147	1726	666708244000
55148	1874	3346000
55149	1726	666707241000
55150	1874	3349000
55151	1726	666706240000
55152	1874	3350000
55153	1726	666705238000
55154	1874	3352000
55155	1726	666704235000
55156	1874	3355000
55157	1593	9189867000000
55158	1593	9189883000000
55190	1637	169924726819997
55191	1637	169924728819997
55210	1690	97923143000000
55211	1690	97923155000000
55230	1397	1359672101000
55231	1678	15840599999000
55232	1726	666683195000
55233	1874	3395000
55234	1726	666682193000
55235	1874	3397000
55236	1726	666681190000
55237	1874	3400000
55255	1397	1359642098000
55256	1678	15840600002000
55257	1397	1359632097000
55258	1678	15840600003000
55259	1726	666675178000
55260	1874	3412000
55261	1726	666674177000
55262	1874	3413000
55263	1726	666673175000
55264	1874	3415000
55265	1726	666672172000
55266	1874	3418000
55267	1726	666671171000
55268	1874	3419000
55269	1726	666670169000
55270	1874	3421000
55271	1677	129530082324100
55272	1677	129530108324100
55303	1397	1359602094000
55304	1678	15840600006000
55305	1726	666663155000
55306	1874	3435000
55307	1726	666662154000
55308	1874	3436000
55309	1726	666661151000
55310	1874	3439000
55311	1622	14220275000014
55312	1622	14220288000014
55323	1547	7773285000000
55324	1547	7773298000000
55413	1692	60502561019999
55414	1692	60502574019999
55472	1711	10604541000000
55473	1397	1359502084000
55474	1678	15840600016000
55475	1726	666633095000
55476	1874	3495000
55477	1726	666632094000
55478	1874	3496000
55479	1683	333076540149541
55508	1397	1359472081000
55509	1678	15840600019000
55510	1726	666625079000
55511	1874	3511000
55512	1726	666624077000
55513	1874	3513000
55514	1726	666623076000
55515	1874	3514000
55516	149	79230181000341
55582	470	75360373000000
55583	1726	666607043000
55584	1874	3547000
55585	1726	666606041000
55586	1874	3549000
55587	470	75360375000000
55600	1692	60502586019999
55624	1397	1359382072000
55625	1678	15840600028000
55626	1397	1359372071000
55627	1678	15840600029000
55628	1726	666597022000
55629	1874	3568000
55630	1726	666596021000
55631	1874	3569000
55632	1726	666595018000
55633	1874	3572000
55634	849	1155747211256640
55635	2107	0
55636	1726	666594016000
55637	1874	3574000
55638	1726	666593015000
55639	1874	3575000
55640	1726	666592012000
55641	1874	3578000
55642	1673	15446237000000
55643	1673	15446264000000
55672	435	68160051990000
55673	686	66000000030000
55701	526	67440013000000
55702	526	67440052000000
55897	1749	4125106000000
55898	1749	4125131000000
55934	1513	25920808000000
55935	1513	25920821000000
55945	1599	8979775393047
55946	1599	8979787393047
55947	1397	1359232057000
55948	1678	15840600043000
55949	1726	666555938000
55045	1690	96483140000000
55046	1726	666736298000
55047	1874	3292000
55048	1726	666735297000
55049	1874	3293000
55050	1726	666734295000
55051	1874	3295000
55052	1690	97203140000000
55053	1690	97203143000000
55077	1397	1359812115000
55078	1678	15840599985000
55079	1726	666727282000
55080	1874	3308000
55081	1726	666726280000
55082	1874	3310000
55083	1726	666725277000
55084	1874	3313000
55085	1686	5971869550062
55086	1686	5971882550062
55089	1397	1359802114000
55090	1678	15840599986000
55091	1726	666724276000
55092	1874	3314000
55093	1726	666723274000
55094	1874	3316000
55095	1726	666722271000
55096	1874	3319000
55097	1677	128090056324100
55098	1677	128090069324100
55117	1703	4320638000000
55118	1703	4320651000000
55120	1397	1359772111000
55121	1678	15840599989000
55122	1726	666715258000
55123	1874	3332000
55124	1726	666714256000
55125	1874	3334000
55126	1726	666713253000
55127	1874	3337000
55128	1677	128810069324100
55129	1677	128810082324100
55132	1397	1359762110000
55133	1678	15840599990000
55134	1726	666712252000
55135	1874	3338000
55136	1726	666711250000
55137	1874	3340000
55138	1726	666710247000
55139	1874	3343000
55140	1679	28907925652000
55180	1397	1359722106000
55181	1678	15840599994000
55182	1726	666697222000
55183	1874	3368000
55184	1726	666696220000
55185	1874	3370000
55186	1726	666695217000
55187	1874	3373000
55188	1675	7342027999977
55189	1675	7342040999977
55192	1397	1359712105000
55193	1678	15840599995000
55194	1726	666694216000
55195	1874	3374000
55196	1726	666693214000
55197	1874	3376000
55198	1726	666692211000
55199	1874	3379000
55200	632	95520845000000
55201	632	95520858000000
55212	1397	1359692103000
55213	1678	15840599997000
55214	1397	1359682102000
55215	1678	15840599998000
55216	1726	666689207000
55217	1874	3383000
55218	1726	666688205000
55219	1874	3385000
55220	1726	666687202000
55221	1874	3388000
55222	1726	666686201000
55223	1874	3389000
55224	1726	666685199000
55225	1874	3391000
55226	1726	666684196000
55227	1874	3394000
55228	1518	8640342000000
55229	1518	8640368000000
55277	1613	8567844600000
55289	1397	1359612095000
55290	1678	15840600005000
55291	1726	666666161000
55292	1874	3429000
55293	1726	666665160000
55294	1874	3430000
55295	1726	666664157000
55296	1874	3433000
55297	2097	200000011
55298	58	79626435999649
55299	2097	66000110000000
55300	152	200000021
55301	1527	79626436999641
55302	58	262999987
55403	1397	1359572091000
55404	1678	15840600009000
55405	1726	666654137000
55406	1874	3453000
55407	1726	666653136000
55408	1874	3454000
55409	1726	666652133000
55410	1874	3457000
55411	1471	12859628900000
55412	1471	12859641900000
55440	1677	129530121324100
55442	1397	1359532087000
55443	1678	15840600013000
55444	606	72137712812962
55451	1685	84961573571430
55452	1685	84961586571430
55480	1467	25903206035399
55481	1010	506397153064601
55482	1467	19417301554450
55483	1130	907459359480949
55484	1467	15041129307591
55485	1250	612280912246859
55486	1467	2846554100039
55487	1376	1706175202959202
55488	1397	1359492083000
55489	1678	15840600017000
55490	1397	1359482082000
55491	1678	15840600018000
55492	1534	720000000000
55493	1534	720060000000
55517	1397	1359462080000
55518	1678	15840600020000
55519	1397	1359452079000
55520	1678	15840600021000
55535	484	91921731000000
55536	1678	15120585008000
55537	1678	15120585009000
55538	1678	15120585010000
55539	1678	15120585011000
55540	1678	15120585012000
55541	1678	15120585013000
55542	1678	15120585014000
55543	1678	15120585015000
55544	1678	15120585016000
55545	1678	15120585017000
55546	1678	15120585018000
55547	1678	15120585019000
55548	1678	15120585020000
55549	1678	15120585021000
55550	484	92641731000000
55551	484	92641893000000
55569	1397	1359422076000
55570	1678	15840600024000
55571	1726	666610049000
55572	1874	3541000
55573	1726	666609047000
55574	1874	3543000
55575	1726	666608046000
55576	1874	3544000
55577	1677	129530095324100
55602	1397	1359392073000
55603	1678	15840600027000
55604	1694	9372473127629
55605	1726	666602034000
55606	1874	3556000
55607	1726	666601032000
55608	1874	3558000
55609	1726	666600029000
55610	1874	3561000
55611	1694	10092473127629
55612	1694	10092476127629
55644	1397	1359362070000
55645	1678	15840600030000
55646	1726	666591010000
55647	1874	3580000
55648	1726	666590009000
55649	1874	3581000
55650	1726	666589006000
55651	1874	3584000
55652	1762	12561883994000
55653	1762	12561896994000
55674	1397	1359332067000
55361	1678	15120584998000
55362	1678	15120584999000
55363	1678	15120585000000
55364	1678	15120585001000
55365	1678	15120585002000
55366	1678	15120585003000
55367	1678	15120585004000
55368	1678	15120585005000
55369	1678	15120585006000
55370	1678	15120585007000
55371	1726	668118655000
55372	1874	2935000
55373	1474	8915445000023
55374	1726	668117652000
55375	1874	2938000
55376	1726	668116650000
55377	1726	668115649000
55378	1874	2941000
55379	1726	668114646000
55380	1874	2944000
55381	1726	668113644000
55382	1726	668112643000
55383	1874	2947000
55384	1726	668111640000
55385	1874	2950000
55386	1726	668110638000
55387	1726	668109637000
55388	1874	2953000
55389	1726	668108634000
55390	1874	2956000
55391	1726	668107632000
55392	1726	668106631000
55393	1874	2959000
55394	1726	668105628000
55395	1874	2962000
55396	1726	668104626000
55397	1726	668103625000
55398	1874	2965000
55399	1726	668102622000
55400	1874	2968000
55401	1474	9635445000023
55402	1474	9635461000023
55415	1397	1359562090000
55416	1678	15840600010000
55417	1397	1359552089000
55418	1678	15840600011000
55419	1397	1359542088000
55420	1678	15840600012000
55421	1726	666651131000
55422	1874	3459000
55423	1726	666650130000
55424	1874	3460000
55425	1726	666649127000
55426	1874	3463000
55427	1726	666648125000
55428	1874	3465000
55429	1726	666647124000
55430	1874	3466000
55431	1726	666646121000
55432	1874	3469000
55433	1726	666645119000
55434	1874	3471000
55435	1726	666644118000
55436	1874	3472000
55437	1726	666643115000
55438	1874	3475000
55439	1426	11084892000000
55471	1711	10604547000000
55534	1637	169924752819997
55552	1397	1359442078000
55553	1678	15840600022000
55554	1397	1359432077000
55555	1678	15840600023000
55556	1726	666616061000
55557	1874	3529000
55558	1726	666615059000
55559	1874	3531000
55560	1726	666614058000
55561	1874	3532000
55562	1726	666613055000
55563	1874	3535000
55564	1726	666612053000
55565	1874	3537000
55566	1726	666611052000
55567	1874	3538000
55568	1729	15407076000000
55580	1683	334516540149541
55581	1683	334516553149541
55599	1708	5795726000021
55601	1534	1440060000000
55616	1694	9372464127629
55617	1694	10092464127629
55618	1694	10092466127629
55619	1726	666599027000
55620	1874	3563000
55621	1726	666598024000
55622	1874	3566000
55623	1677	129530084324100
55882	1397	1359302064000
55883	1678	15840600036000
55884	1397	1359292063000
55885	1678	15840600037000
55886	1726	666572975000
55887	1874	3615000
55888	1726	666571973000
55889	1874	3617000
55890	1726	666570970000
55891	1874	3620000
55892	1726	666569968000
55893	1874	3622000
55894	1726	666568965000
55895	1874	3625000
55896	1679	28907937652000
55915	1509	9311798851155
55924	1397	1359252059000
55925	1678	15840600041000
55926	1726	666560950000
55927	1874	3640000
55928	1726	666559948000
55929	1874	3642000
55930	1726	666558945000
55931	1874	3645000
55932	1559	7882659000000
55933	1559	7882672000000
55944	1706	8852128600135
55957	1683	338836578149541
55958	1683	338836590149541
55959	1397	1359222056000
55960	1678	15840600044000
55961	1726	666553935000
55962	1874	3655000
55963	1726	666552934000
55964	1874	3656000
55965	1726	666551931000
55966	1874	3659000
55993	1610	7200233000000
55994	1610	7200246000000
56003	1508	11556266500009
56024	1397	1359152049000
56025	1678	15840600051000
56026	1726	666533895000
56027	1874	3695000
56028	1726	666532893000
56029	1874	3697000
56030	1587	11520398000000
56031	1587	11520410000000
56061	1397	1359112045000
56062	1678	15840600055000
56063	1726	665313875000
56064	1874	3715000
56065	1726	665312872000
56066	1874	3718000
56067	1726	665311870000
56068	1874	3720000
56096	1397	1359072041000
56097	1678	15840600059000
56098	1726	665301851000
56099	1874	3739000
56100	1726	665300848000
56101	1874	3742000
56102	1726	665299846000
56103	1874	3744000
56104	1571	17280317001024
56105	1571	17280330001024
56125	1397	1359042038000
56126	1678	15840600062000
56127	1726	665292833000
56128	1874	3757000
56129	1726	665291830000
56130	1874	3760000
56131	1726	665290828000
56132	1874	3762000
56133	1683	340276591149541
56134	1683	340276604149541
56152	1729	16127076000000
56153	1729	16127092000000
56156	1397	1359022036000
56157	1678	15840600064000
56158	1397	1359012035000
56159	1678	15840600065000
56160	1726	665283815000
56161	1874	3775000
56162	1726	665282812000
56163	1874	3778000
56164	1726	665281810000
55592	1726	666605040000
55593	1874	3550000
55594	1726	666604037000
55595	1874	3553000
55596	1726	666603035000
55597	1874	3555000
55598	1677	129530107324100
55613	1683	334516563149541
55614	1683	335956563149541
55615	1683	335956566149541
55654	1397	1359352069000
55655	1678	15840600031000
55656	1397	1359342068000
55657	1678	15840600032000
55658	1726	666588004000
55659	1874	3586000
55660	1726	666587003000
55661	1874	3587000
55662	1726	666586000000
55663	1874	3590000
55664	1726	666584998000
55665	1874	3592000
55666	1726	666583997000
55667	1874	3593000
55668	1726	666582994000
55669	1874	3596000
55670	1677	130250084324100
55671	1677	130250110324100
55682	1726	666581993000
55683	1874	3597000
55684	1726	666580991000
55685	1874	3599000
55686	1726	666579988000
55687	1874	3602000
55688	1726	666578987000
55689	1874	3603000
55690	1726	666577985000
55691	1874	3605000
55692	1726	666576982000
55693	1874	3608000
55694	1726	666575981000
55695	1874	3609000
55696	1726	666574979000
55697	1874	3611000
55698	1726	666573976000
55699	1874	3614000
55700	1716	9406742000000
55899	1397	1359282062000
55900	1678	15840600038000
55901	1397	1359272061000
55902	1678	15840600039000
55903	1726	666567964000
55904	1874	3626000
55905	1726	666566961000
55906	1874	3629000
55907	1726	666565960000
55908	1874	3630000
55909	1726	666564958000
55910	1874	3632000
55911	1726	666563955000
55912	1874	3635000
55913	1686	6691882550062
55914	1686	6691907550062
55936	1397	1359242058000
55937	1678	15840600042000
55938	1726	666557943000
55939	1874	3647000
55940	1726	666556940000
55941	1874	3650000
55942	1677	130970110324100
55943	1677	130970122324100
55955	1747	4336859000000
55956	1747	4336871000000
55984	1397	1359192053000
55985	1678	15840600047000
55986	1726	666545919000
55987	1874	3671000
55988	1726	666544917000
55989	1874	3673000
55990	1726	666543916000
55991	1874	3674000
55992	1716	9406716000000
56033	1397	1359142048000
56034	1678	15840600052000
56035	1726	666531892000
56036	1874	3698000
56037	1726	666530889000
56038	1874	3701000
56039	1726	666529887000
56040	1874	3703000
56041	1683	338836591149541
56107	1397	1359062040000
56108	1678	15840600060000
56109	1397	1359052039000
56110	1678	15840600061000
56111	1726	665298845000
56112	1874	3745000
56113	1726	665297842000
56114	1874	3748000
56115	1726	665296840000
56116	1874	3750000
56117	1726	665295839000
56118	1874	3751000
56119	1726	665294836000
56120	1874	3754000
56121	1726	665293834000
56122	1874	3756000
56123	1402	40894241319298
56124	1402	40894267319298
56137	1397	1359032037000
56138	1678	15840600063000
56139	1726	665289827000
56140	1874	3763000
56141	1726	665288824000
56142	1874	3766000
56143	1726	665287822000
56144	1874	3768000
56145	1726	665286821000
56146	1874	3769000
56147	1726	665285818000
56148	1874	3772000
56149	1726	665284816000
56150	1874	3774000
56151	1719	7220363000000
56187	1397	1358992033000
56188	1678	15840600067000
56189	1726	665274797000
56190	1874	3793000
56191	1726	665273795000
56192	1874	3795000
56193	576	76595728938283
56194	576	76595740938283
56267	1549	13295748000000
56268	1549	13295761000000
56315	341	66721013000001
56340	1703	4320650000000
56361	641	71380997000000
56362	641	72100997000000
56363	641	72101087000000
56368	1397	1358872021000
56369	1678	15840600079000
56370	1397	1358862020000
56371	1678	15840600080000
56372	1397	1358852019000
56373	1678	15840600081000
56374	1394	1440000000000
56375	1394	1440040000000
56412	1397	1358812015000
56413	1678	15840600085000
56414	1726	664022703000
56415	1874	3887000
56416	1726	664021700000
56417	1874	3890000
56418	1672	12961894000000
56419	1672	12961906000000
56448	1397	1358772011000
56449	1678	15840600089000
56450	1397	1358762010000
56451	1678	15840600090000
56452	1397	1358752009000
56453	1678	15840600091000
56454	1397	1358742008000
56455	1678	15840600092000
56456	1397	1358732007000
56457	1678	15840600093000
56458	1726	664014683000
56459	1874	3907000
56460	1726	664013680000
56461	1874	3910000
56462	1726	664012678000
56463	1874	3912000
56464	1726	664011675000
56465	1874	3915000
56466	1726	664010673000
56467	1874	3917000
56468	1726	664009670000
56469	1874	3920000
56470	1726	664008668000
56471	1874	3922000
56472	1726	664007665000
56473	1874	3925000
56474	1726	664006663000
56475	1874	3927000
56476	1673	16166264000000
56477	1673	16166323000000
55675	1678	15840600033000
55676	1397	1359322066000
55677	1678	15840600034000
55678	1397	1359312065000
55679	1678	15840600035000
55680	1716	9406703000000
55681	1716	9406733000000
55703	1678	15120585022000
55704	1678	15120585023000
55705	1678	15120585024000
55706	1678	15120585025000
55707	1678	15120585026000
55708	1678	15120585027000
55709	1678	15120585028000
55710	1678	15120585029000
55711	1678	15120585030000
55712	1678	15120585031000
55713	1678	15120585032000
55714	1678	15120585033000
55715	1678	15120585034000
55716	1678	15120585035000
55717	1726	668101620000
55718	1726	668100619000
55719	1874	2971000
55720	1726	668099616000
55721	1874	2974000
55722	1726	668098614000
55723	1726	668097613000
55724	1874	2977000
55725	1726	668096610000
55726	1874	2980000
55727	1726	668095608000
55728	1726	668094607000
55729	1874	2983000
55730	1726	668093604000
55731	1874	2986000
55732	1726	668092602000
55733	1726	668091601000
55734	1874	2989000
55735	1726	668090598000
55736	1874	2992000
55737	1726	668089596000
55738	1726	668088595000
55739	1874	2995000
55740	1726	668087592000
55741	1874	2998000
55742	1726	668086590000
55743	1726	668085589000
55744	1874	3001000
55745	1726	668084586000
55746	1874	3004000
55747	1726	668083584000
55748	1726	668082583000
55749	1874	3007000
55750	1726	668081580000
55751	1874	3010000
55752	1726	668080578000
55753	1874	3012000
55754	1726	668079575000
55755	1726	668078574000
55756	1874	3016000
55757	1726	668077572000
55758	1874	3018000
55759	1726	668076569000
55760	1874	3021000
55761	1726	668075567000
55762	1874	3023000
55763	1726	668074564000
55764	1726	668073563000
55765	1874	3027000
55766	1726	668072561000
55767	1874	3029000
55768	1726	668071558000
55769	1726	668070557000
55770	1874	3033000
55771	1726	668069555000
55772	1874	3035000
55773	1726	668068552000
55774	1726	668067551000
55775	1874	3039000
55776	1726	668066549000
55777	1726	668065548000
55778	1874	3042000
55779	1726	668064546000
55780	1874	3044000
55781	1726	668063543000
55782	1874	3047000
55783	1726	668062541000
55784	1874	3049000
55785	1726	668061538000
55786	1874	3052000
55787	1726	668060536000
55788	1874	3054000
55789	1726	668059533000
55790	1874	3057000
55791	1726	668058531000
55792	1874	3059000
55793	1726	668057528000
55794	1874	3062000
55795	1726	668056526000
55796	1874	3064000
55797	1726	668055523000
55798	1874	3067000
55799	1726	668054521000
55800	1874	3069000
55801	1726	668053518000
55802	1874	3072000
55803	1726	668052516000
55804	1874	3074000
55805	1726	668051513000
55806	1874	3077000
55807	1726	668050511000
55808	1874	3079000
55809	1726	668049508000
55810	1874	3082000
55811	1726	668048506000
55812	1874	3084000
55813	1726	668047503000
55814	1874	3087000
55815	1726	668046501000
55816	1874	3089000
55817	1726	668045498000
55818	1874	3092000
55819	1726	668044496000
55820	1874	3094000
55821	1726	668043493000
55822	1874	3097000
55823	1726	668042491000
55824	1874	3099000
55825	1726	668041488000
55826	1874	3102000
55827	1726	668040486000
55828	1874	3104000
55829	1726	668039483000
55830	1874	3107000
55831	1726	668038481000
55832	1874	3109000
55833	1726	668037478000
55834	1874	3112000
55835	1726	668036476000
55836	1874	3114000
55837	1726	668035473000
55838	1874	3117000
55839	1726	668034471000
55840	1726	668033470000
55841	1874	3120000
55842	1726	668032467000
55843	1874	3123000
55844	1726	668031465000
55845	1726	668030464000
55846	1874	3126000
55847	1726	668029461000
55848	1874	3129000
55849	1726	668028459000
55850	1726	668027458000
55851	1874	3132000
55852	1726	668026455000
55853	1874	3135000
55854	1474	9635858000023
55855	1726	668025453000
55856	1726	666815453000
55857	1726	666814452000
55858	1874	3138000
55859	1726	666813449000
55860	1874	3141000
55861	1726	666812447000
55862	1726	666811446000
55863	1874	3144000
55864	1726	666810443000
55865	1874	3147000
55866	1726	666809441000
55867	1726	666808440000
55868	1874	3150000
55869	1726	666807437000
55870	1874	3153000
55871	1726	666806435000
55872	1726	666805434000
55873	1874	3156000
55874	1726	666804432000
55875	1726	666803431000
55876	1874	3159000
55877	1726	666802428000
55878	1874	3162000
55879	1726	666801426000
55880	1474	10355858000023
55881	1474	10355883000023
55916	1397	1359262060000
55917	1678	15840600040000
55918	1726	666562954000
55919	1874	3636000
55920	1726	666561951000
55921	1874	3639000
55922	1683	337396566149541
55923	1683	337396578149541
55954	1704	2226219000000
55967	1747	5056871000000
55968	1747	5056884000000
55995	1397	1359182052000
55996	1678	15840600048000
55997	1726	666542913000
55998	1874	3677000
55999	1726	666541911000
56000	1874	3679000
56001	1726	666540910000
56002	1874	3680000
56014	1397	1359162050000
56015	1678	15840600050000
56016	1726	666536901000
56017	1874	3689000
56018	1726	666535899000
56019	1874	3691000
56020	1726	666534898000
56021	1874	3692000
56022	1685	86401599571430
56023	1685	86401612571430
56044	1397	1359132047000
56045	1678	15840600053000
56046	1397	1359122046000
56047	1678	15840600054000
56048	1726	666528884000
56049	1874	3706000
56050	1726	665318884000
56051	2108	200000000
56052	1726	665317882000
56053	1874	3708000
56054	1726	665316881000
56055	1874	3709000
56056	1726	665315878000
56057	1874	3712000
56058	1726	665314876000
56059	1874	3714000
56060	1690	97923178000000
56086	1397	1359082042000
56087	1678	15840600058000
56088	1726	665304857000
56089	1874	3733000
56090	1726	665303854000
56091	1874	3736000
56092	1726	665302852000
56093	1874	3738000
56094	1677	131690135324100
56095	1677	131690148324100
56236	1397	1358932027000
56237	1678	15840600073000
56238	1693	17913529155041
56239	141	66000100000000
56240	1726	665261771000
56241	1874	3819000
56242	1726	665260768000
56243	1874	3822000
56244	1726	665259767000
56245	1874	3823000
56246	1726	665258765000
56247	1874	3825000
56248	1726	665257762000
56249	1874	3828000
56250	1726	665256761000
56251	1874	3829000
56252	1476	8640155000000
56253	1476	9360155000000
56257	1397	1358922026000
56258	1678	15840600074000
56259	1726	665255759000
56260	1874	3831000
56261	1726	665254756000
56262	1874	3834000
56263	1726	665253755000
56264	1874	3835000
56265	1683	341716604149541
56266	1683	341716617149541
56273	1549	12575868000000
56274	1678	15120585036000
56275	1678	15120585037000
56276	1678	15120585038000
56277	1678	15120585039000
56278	1678	15120585040000
56279	1678	15120585041000
56280	1678	15120585042000
56281	1678	15120585043000
56282	1678	15120585044000
56283	1678	15120585045000
56284	1678	15120585046000
56285	1678	15120585047000
56286	1678	15120585048000
56287	1678	15120585049000
56288	1678	15120585050000
56289	1678	15120585051000
56290	1678	15120585052000
56291	1678	15120585053000
56292	1678	15120585054000
56293	1678	15120585055000
56294	1678	15120585056000
56295	1678	15120585057000
56296	1678	15120585058000
56297	1678	15120585059000
56298	1678	15120585060000
56299	1678	15120585061000
56300	1678	15120585062000
56301	1678	15120585063000
56302	1678	15120585064000
56303	1678	15120585065000
56304	1678	15120585066000
56305	1678	15120585067000
56306	1678	15120585068000
56307	1678	15120585069000
56308	1678	15120585070000
56309	1678	15120585071000
56310	1678	15120585072000
56311	1678	15120585073000
56312	1678	15120585074000
56313	1549	13295868000000
56314	1549	13296998000000
56322	1678	15840600075000
56323	1726	665252753000
56324	1874	3837000
56325	1726	665251750000
56326	1874	3840000
56327	1726	664041750000
56328	2109	200000000
56329	369	93360773000000
56330	369	93360795000000
56338	1710	13194568473290
56339	1710	13194580473290
56349	1692	61222586019999
56350	1692	61222598019999
56353	1397	1358882022000
56354	1678	15840600078000
56355	1726	664036738000
56356	1874	3852000
56357	1726	664035735000
56358	1874	3855000
56359	1402	41614267319298
56360	1402	41614279319298
56395	1555	6675148979096
56398	1397	1358832017000
56399	1678	15840600083000
56400	1397	1358822016000
56401	1678	15840600084000
56402	1726	664026713000
56403	1874	3877000
56404	1726	664025710000
56405	1874	3880000
56406	1726	664024708000
56407	1874	3882000
56408	1726	664023705000
56409	1874	3885000
56410	1685	87841632571430
56411	1685	87841656571430
56434	171	73190333524688
56435	171	73190357524688
56443	2110	0
56444	641	72819525000000
56445	1693	15033477155041
56446	1650	7954143000000
56447	1650	7954194000000
56486	149	79950181000341
56487	149	79950193000341
56489	1397	1358712005000
56490	1678	15840600095000
56491	1726	664003655000
56492	1874	3935000
56493	1726	664002653000
56494	1874	3937000
56495	1685	88561656571430
56496	1685	88561668571430
56517	1726	663996638000
56518	1874	3952000
56519	1675	8062040999977
56520	1675	8062052999977
56533	1397	1358662000000
55950	1874	3652000
55951	1726	666554937000
55952	1874	3653000
55953	1746	6274335000000
55969	1397	1359212055000
55970	1678	15840600045000
55971	1397	1359202054000
55972	1678	15840600046000
55973	1726	666550929000
55974	1874	3661000
55975	1726	666549928000
55976	1874	3662000
55977	1726	666548925000
55978	1874	3665000
55979	1726	666547923000
55980	1874	3667000
55981	1726	666546922000
55982	1874	3668000
55983	1677	130970135324100
56004	1397	1359172051000
56005	1678	15840600049000
56006	1726	666539907000
56007	1874	3683000
56008	1726	666538905000
56009	1874	3685000
56010	1726	666537904000
56011	1874	3686000
56012	1685	85681586571430
56013	1685	85681599571430
56032	1587	11520409000000
56042	1739	24479705000000
56043	1739	24479718000000
56069	1397	1359102044000
56070	1678	15840600056000
56071	1397	1359092043000
56072	1678	15840600057000
56073	1726	665310869000
56074	1874	3721000
56075	1726	665309866000
56076	1874	3724000
56077	1726	665308864000
56078	1874	3726000
56079	1726	665307863000
56080	1874	3727000
56081	1726	665306860000
56082	1874	3730000
56083	1726	665305858000
56084	1874	3732000
56085	1573	4298881000000
56106	1560	9954248277001
56135	1690	98643178000000
56136	1690	98643191000000
56154	1587	12240410000000
56155	1587	12240426000000
56173	632	96240858000000
56174	632	96240884000000
56184	369	91921501000000
56185	369	92641501000000
56186	369	92642011000000
56211	1540	720025000000
56222	1397	1358952029000
56223	1678	15840600071000
56224	1726	665264777000
56225	1874	3813000
56226	1726	665263774000
56227	1874	3816000
56228	1726	665262773000
56229	1874	3817000
56230	1670	12960999000000
56231	1670	12961012000000
56232	1397	1358942028000
56233	1678	15840600072000
56234	1679	29627937652000
56235	1679	29627947652000
56270	341	66721000000001
56271	341	11674511943000
56272	1447	66721003000001
56316	1693	15753477155041
56317	1397	1358912025000
56318	1678	15120585075000
56319	369	92642625000000
56320	369	93362625000000
56321	369	93362703000000
56331	1397	1358902024000
56332	1678	15840600076000
56333	1726	664040748000
56334	1874	3842000
56335	1726	664039745000
56336	1874	3845000
56337	1701	7990264600056
56341	1702	7200296000000
56352	1395	57868010193533700
56364	641	71380246000000
56365	641	72100246000000
56366	1919	72100525000000
56367	641	150000000
56376	1397	1358842018000
56377	1678	15840600082000
56378	1726	664034733000
56379	1874	3857000
56380	1726	664033730000
56381	1874	3860000
56382	1726	664032728000
56383	1874	3862000
56384	1726	664031725000
56385	1874	3865000
56386	1726	664030723000
56387	1874	3867000
56388	1726	664029720000
56389	1874	3870000
56390	1726	664028718000
56391	1874	3872000
56392	1726	664027715000
56393	1874	3875000
56394	1522	8254121000000
56396	1685	87121612571430
56397	1685	87121632571430
56478	1397	1358722006000
56479	1678	15840600094000
56480	1726	664005660000
56481	1874	3930000
56482	1726	664004658000
56483	1874	3932000
56484	1593	9909873000000
56485	1593	9909885000000
56488	1611	23030886000000
56505	1397	1358692003000
56506	1678	15840600097000
56507	1726	663999645000
56508	1874	3945000
56509	1726	663998643000
56510	1874	3947000
56511	162	67440022000000
56512	1397	1358682002000
56513	1678	15840600098000
56514	1726	663997640000
56515	1874	3950000
56516	1395	57868010204533700
56553	1457	10704268040000
56555	1650	8674194000000
56556	1650	8674195000000
56557	1397	1358651999000
56558	1678	15840600101000
56559	1419	14141278280064
56560	2111	1000000000
56561	1419	14859278280064
56644	1471	13579641900000
56645	1471	13579653900000
56653	1397	1358541988000
56654	1678	15840600112000
56655	1726	663969581000
56656	1874	4009000
56657	1726	663968578000
56658	1874	4012000
56659	1726	663967576000
56660	1874	4014000
56661	1726	663966573000
56662	1874	4017000
56663	1394	2880040000000
56664	1394	2880054000000
56666	1397	1358531987000
56667	1678	15840600113000
56668	1726	663965571000
56669	1874	4019000
56670	1692	62662610019999
56671	1692	62662621019999
56692	1397	1358501984000
56693	1678	15840600116000
56694	1397	1358491983000
56695	1678	15840600117000
56696	1726	663959557000
56697	1874	4033000
56698	1726	663958555000
56699	1874	4035000
56700	1726	663957554000
56701	1874	4036000
56702	1726	663956551000
56703	1874	4039000
56704	1726	663955549000
56705	1874	4041000
56706	1726	663954548000
56707	1874	4042000
56737	141	66000000000000
56738	1397	1358451979000
56739	1678	15840600121000
56165	1874	3780000
56166	1726	665280809000
56167	1874	3781000
56168	1726	665279806000
56169	1874	3784000
56170	1726	665278804000
56171	1874	3786000
56172	1536	11520678999959
56175	1397	1359002034000
56176	1678	15840600066000
56177	1726	665277803000
56178	1874	3787000
56179	1726	665276800000
56180	1874	3790000
56181	1726	665275798000
56182	1874	3792000
56183	369	92640773000000
56195	1397	1358982032000
56196	1678	15840600068000
56197	1397	1358972031000
56198	1678	15840600069000
56199	1726	665272792000
56200	1874	3798000
56201	1726	665271791000
56202	1874	3799000
56203	1726	665270789000
56204	1874	3801000
56205	1726	665269786000
56206	1874	3804000
56207	1726	665268785000
56208	1874	3805000
56209	1677	132410148324100
56210	1677	132410173324100
56212	1397	1358962030000
56213	1678	15840600070000
56214	1726	665267783000
56215	1874	3807000
56216	1726	665266780000
56217	1874	3810000
56218	1726	665265779000
56219	1874	3811000
56220	1980	13679162000000
56221	1980	13679175000000
56254	1693	16473490155041
56255	1764	7926837100000
56256	1764	7926888100000
56269	1764	7926850100000
56342	1397	1358892023000
56343	1678	15840600077000
56344	1726	664038743000
56345	1874	3847000
56346	1726	664037740000
56347	1874	3850000
56348	1422	7344985860211
56351	1679	30347947652000
56420	1397	1358802014000
56421	1678	15840600086000
56422	1397	1358792013000
56423	1678	15840600087000
56424	1726	664020698000
56425	1874	3892000
56426	1726	664019695000
56427	1874	3895000
56428	1726	664018693000
56429	1874	3897000
56430	1726	664017690000
56431	1874	3900000
56432	1672	13681906000000
56433	1672	13681930000000
56436	1397	1358782012000
56437	1678	15840600088000
56438	1726	664016688000
56439	1874	3902000
56440	1726	664015685000
56441	1874	3905000
56442	1708	5795713000021
56497	1397	1358702004000
56498	1678	15840600096000
56499	1726	664001650000
56500	1874	3940000
56501	1726	664000648000
56502	1874	3942000
56503	1692	61942598019999
56504	1692	61942610019999
56523	1759	10080691999999
56524	1759	10080703999999
56525	1397	1358672001000
56526	1678	15840600099000
56527	1726	663995635000
56528	1874	3955000
56529	1726	663994633000
56530	1874	3957000
56531	1593	10629885000000
56532	1593	10629897000000
56544	43	76080807890000
56551	1690	99363191000000
56552	1690	99363193000000
56598	1726	663983614000
56599	1874	3976000
56600	1726	663982611000
56601	1726	663981609000
56602	1874	3981000
56603	1726	663980606000
56604	1874	3984000
56605	1726	663979604000
56606	1874	3986000
56607	1726	663978601000
56608	1874	3989000
56609	1726	663977599000
56610	1874	3991000
56611	1726	663976596000
56612	1874	3994000
56613	1726	663975594000
56614	1874	3996000
56615	1726	663974591000
56616	1874	3999000
56617	1715	32400535000000
56618	1715	32400566000000
56637	1397	1358561990000
56638	1678	15840600110000
56639	1726	663971586000
56640	1874	4004000
56641	1726	663970583000
56642	1874	4007000
56643	1534	1440072000000
56652	1637	169924736819997
56679	43	76800807890000
56680	43	76800809890000
56709	641	73539525000000
56710	641	73539975000000
56749	1397	1358441978000
56750	1678	15840600122000
56751	1397	1358431977000
56752	1678	15840600123000
56753	1726	663941521000
56754	1874	4069000
56755	1726	663940519000
56756	1874	4071000
56757	1726	663939518000
56758	1874	4072000
56759	1726	663938515000
56760	1874	4075000
56761	1726	663937513000
56762	1874	4077000
56763	1426	11804892000000
56764	1426	11804918000000
56815	1397	1358361970000
56816	1678	15840600130000
56817	1726	663921483000
56818	1874	4107000
56819	1726	663920481000
56820	1874	4109000
56821	1489	7103887000000
56822	1489	7103899000000
56824	1397	1358351969000
56825	1678	15840600131000
56826	1726	663919480000
56827	1874	4110000
56828	1726	663918478000
56829	1874	4112000
56840	1726	663914469000
56841	1874	4121000
56842	1726	663913468000
56843	1874	4122000
56844	1726	663912466000
56845	1874	4124000
56846	1726	663911463000
56847	1874	4127000
56848	1726	663910462000
56849	1874	4128000
56850	1726	663909460000
56851	1874	4130000
56852	1671	7248269530515
56853	1671	7248275530515
56877	1559	7882671000000
56917	1397	1358281962000
56918	1678	15840600138000
56919	1397	1358271961000
56920	1678	15840600139000
56921	1726	663890420000
56922	1874	4170000
56923	1726	663889417000
56924	1874	4173000
56925	1726	663888415000
56926	1874	4175000
56521	1693	18633529155041
56522	1693	18633541155041
56542	1518	9360368000000
56543	1518	9360381000000
56545	1726	663991625000
56546	1874	3965000
56547	1726	663990623000
56548	1874	3967000
56549	1536	12240678999959
56550	1536	12240680999959
56554	1506	7921108967172
56585	1397	1358591993000
56586	1678	15840600107000
56587	1397	1358581992000
56588	1678	15840600108000
56589	1769	1701900000
56590	1726	663983615000
56591	1874	3975000
56592	1726	663982612000
56593	1874	3978000
56594	1726	663981611000
56595	1874	3979000
56596	1395	57868730249533700
56597	1395	57868730273533700
56619	1397	1358571991000
56620	1678	15840600109000
56621	1726	663980608000
56622	1874	3982000
56623	1726	663979606000
56624	1726	663978603000
56625	1874	3987000
56626	1726	663977601000
56627	1726	663976598000
56628	1874	3992000
56629	1726	663975596000
56630	1726	663974593000
56631	1874	3997000
56632	1726	663973591000
56633	1726	663972588000
56634	1874	4002000
56635	1708	6515713000021
56636	1708	6515732000021
56665	1687	7192581524804
56690	1692	63382621019999
56691	1692	63382634019999
56714	1397	1358471981000
56715	1678	15840600119000
56716	1397	1358461980000
56717	1678	15840600120000
56718	1726	663953545000
56719	1874	4045000
56720	1726	663952543000
56721	1874	4047000
56722	1726	663951542000
56723	1874	4048000
56724	1726	663950539000
56725	1874	4051000
56726	1726	663949537000
56727	1874	4053000
56728	1726	663948536000
56729	1874	4054000
56730	1726	663947533000
56731	1874	4057000
56732	1726	663946531000
56733	1874	4059000
56734	1726	663945530000
56735	1874	4060000
56736	1692	63382650019999
56795	1397	1358381972000
56796	1678	15840600128000
56797	1726	663927495000
56798	1874	4095000
56799	1684	11491345880623
56800	1726	663926493000
56801	1874	4097000
56802	1726	663925490000
56803	1874	4100000
56804	1684	12211345880623
56805	1684	12211347880623
56860	1560	9954237277001
56869	1397	1358331967000
56870	1678	15840600133000
56871	1726	663904447000
56872	1874	4143000
56873	1726	663903445000
56874	1874	4145000
56875	1547	8493297000000
56876	1547	8493309000000
56888	1633	7956375985638
56907	1397	1358291963000
56908	1678	15840600137000
56909	1726	663893426000
56910	1874	4164000
56911	1726	663892423000
56912	1874	4167000
56913	1726	663891421000
56914	1874	4169000
56915	1395	57870170283533700
56916	1395	57870170296533700
56954	1715	32400548000000
56956	1740	7721287000000
56975	1397	1358221956000
56976	1678	15840600144000
56977	1726	663873385000
56978	1874	4205000
56979	1726	663872384000
56980	1874	4206000
56981	1726	663871381000
56982	1874	4209000
56983	1688	89642187904000
56986	1613	9287844600000
56987	1613	9287857600000
56989	1397	1358211955000
56990	1678	15840600145000
56991	1726	663870379000
56992	1874	4211000
56993	1726	663869378000
56994	1874	4212000
56995	1689	7920158287625
56996	1689	7920170287625
56534	1678	15840600100000
56535	1769	1702900000
56536	1726	663993630000
56537	1874	3960000
56538	1726	663992628000
56539	1874	3962000
56540	43	76080756890000
56541	43	76080769890000
56562	1397	1358641998000
56563	1678	15840600102000
56564	1397	1358631997000
56565	1678	15840600103000
56566	1397	1358621996000
56567	1678	15840600104000
56568	1397	1358611995000
56569	1678	15840600105000
56570	1397	1358601994000
56571	1678	15840600106000
56572	1726	663989622000
56573	1874	3968000
56574	1726	663988621000
56575	1874	3969000
56576	1726	663987620000
56577	1874	3970000
56578	1726	663986619000
56579	1874	3971000
56580	1726	663985617000
56581	1874	3973000
56582	1726	663984616000
56583	1874	3974000
56584	1395	57868010249533700
56646	1419	15579278280064
56647	1419	15579288280064
56648	1397	1358551989000
56649	1678	15840600111000
56650	1395	57869450273533700
56651	1395	57869450283533700
56672	1397	1358521986000
56673	1678	15840600114000
56674	1726	663964568000
56675	1874	4022000
56676	1726	663963566000
56677	1874	4024000
56678	43	76080768890000
56681	1397	1358511985000
56682	1678	15840600115000
56683	1726	663962563000
56684	1874	4027000
56685	1726	663961561000
56686	1874	4029000
56687	1726	663960560000
56688	1874	4030000
56689	1394	2880053000000
56708	641	72099837000000
56711	1397	1358481982000
56712	1678	15840600118000
56713	641	72099847000000
56773	1547	7773297000000
56782	1397	1358401974000
56783	1678	15840600126000
56784	1397	1358391973000
56785	1678	15840600127000
56786	1726	663931502000
56787	1874	4088000
56788	1726	663930501000
56789	1874	4089000
56790	1726	663929498000
56791	1874	4092000
56792	1726	663928496000
56793	1874	4094000
56794	1717	6587908000023
56823	1455	4353946000000
56838	1622	14940288000014
56839	1622	14940291000014
56854	1726	663908457000
56855	1874	4133000
56856	1726	663907455000
56857	1874	4135000
56858	1688	89642174904000
56859	1688	89642176904000
56878	1397	1358321966000
56879	1678	15840600134000
56880	1726	663902444000
56881	1874	4146000
56882	1726	663901441000
56883	1874	4149000
56884	1726	663900439000
56885	1874	4151000
56886	1691	8603053100019
56887	1691	8603066100019
56941	2039	7921104000000
56942	2039	7921117000000
56953	1522	8254114000000
56957	1397	1358241958000
56958	1678	15840600142000
56959	1397	1358231957000
56960	1678	15840600143000
56961	1726	663879397000
56962	1874	4193000
56963	1726	663878396000
56964	1874	4194000
56965	1726	663877393000
56966	1874	4197000
56967	1726	663876391000
56968	1874	4199000
56969	1726	663875390000
56970	1874	4200000
56971	1726	663874387000
56972	1874	4203000
56973	1695	8252163000000
56974	1695	8252189000000
56740	1726	663944527000
56741	1874	4063000
56742	1726	663943525000
56743	1874	4065000
56744	1726	663942524000
56745	1874	4066000
56746	1687	7912581524804
56747	1687	7912694524804
56748	1687	7912693524804
56765	1397	1358421976000
56766	1678	15840600124000
56767	1726	663936512000
56768	1874	4078000
56769	1726	663935509000
56770	1874	4081000
56771	1394	4320053000000
56772	1394	4320065000000
56774	1397	1358411975000
56775	1678	15840600125000
56776	1726	663934508000
56777	1874	4082000
56778	1726	663933506000
56779	1874	4084000
56780	1726	663932505000
56781	1874	4085000
56806	1397	1358371971000
56807	1678	15840600129000
56808	1726	663924489000
56809	1874	4101000
56810	1726	663923487000
56811	1874	4103000
56812	1726	663922484000
56813	1874	4106000
56814	1447	12394514943000
56830	1726	663917475000
56831	1874	4115000
56832	1726	663916474000
56833	1874	4116000
56834	1726	663915472000
56835	1874	4118000
56836	1711	11324534000000
56837	1711	11324537000000
56861	1397	1358341968000
56862	1678	15840600132000
56863	1726	663906452000
56864	1874	4138000
56865	1726	663905450000
56866	1874	4140000
56867	1560	10674237277001
56868	1560	10674249277001
56889	1397	1358311965000
56890	1678	15840600135000
56891	1397	1358301964000
56892	1678	15840600136000
56893	1726	663899438000
56894	1874	4152000
56895	1726	663898435000
56896	1874	4155000
56897	1726	663897433000
56898	1874	4157000
56899	1726	663896432000
56900	1874	4158000
56901	1726	663895429000
56902	1874	4161000
56903	1726	663894427000
56904	1874	4163000
56905	1394	5760065000000
56906	1394	5760091000000
56933	1397	1358261960000
56934	1678	15840600140000
56935	1726	663885409000
56936	1874	4181000
56937	1726	663884408000
56938	1874	4182000
56939	1726	663883405000
56940	1874	4185000
56943	1397	1358251959000
56944	1678	15840600141000
56945	1726	663882403000
56946	1874	4187000
56947	1726	663881402000
56948	1874	4188000
56949	1726	663880399000
56950	1874	4191000
56951	633	76684016900000
56952	633	76684029900000
56955	1740	7721290000000
56927	1726	663887414000
56928	1874	4176000
56929	1726	663886411000
56930	1874	4179000
56931	1692	64102650019999
56932	1692	64102675019999
56984	1394	7200091000000
56985	1394	7200104000000
56988	1613	9287896600000
56997	1397	1358201954000
56998	1678	15840600146000
56999	1726	663868375000
57000	1874	4215000
57001	1726	663867373000
57002	1874	4217000
57003	1726	663866372000
57004	1874	4218000
57005	1397	1358191953000
57006	1678	15840600147000
57007	1397	1358181952000
57008	1678	15840600148000
57009	1397	1358171951000
57010	1678	15840600149000
57011	1397	1358161950000
57012	1678	15840600150000
57013	1726	663865369000
57014	1874	4221000
57015	1726	663864367000
57016	1874	4223000
57017	1726	663863366000
57018	1874	4224000
57019	1726	663862363000
57020	1874	4227000
57021	1726	663861361000
57022	1874	4229000
57023	1726	663860360000
57024	1874	4230000
57025	1701	7990310600056
57026	1726	663859357000
57027	1874	4233000
57028	1726	663858355000
57029	1874	4235000
57030	1726	663857354000
57031	1874	4236000
57032	1726	663856352000
57033	1874	4238000
57034	1726	663855349000
57035	1874	4241000
57036	1701	8710310600056
57037	1701	8710315600056
57038	641	72819837000000
57039	641	72819937000000
57040	641	72819847000000
57041	641	72819888000000
57042	1397	1358151949000
57043	1678	15840600151000
57044	1397	1358141948000
57045	1678	15840600152000
57046	1726	663854348000
57047	1874	4242000
57048	1726	663853346000
57049	1874	4244000
57050	1726	663852343000
57051	1874	4247000
57052	1726	663851342000
57053	1874	4248000
57054	1726	663850340000
57055	1874	4250000
57056	1726	663849337000
57057	1874	4253000
57058	1671	7968275530515
57059	1671	7968301530515
57060	1692	64822675019999
57061	1692	64822701019999
57062	1397	1358131947000
57063	1678	15840600153000
57064	1397	1358121946000
57065	1678	15840600154000
57066	1397	1358111945000
57067	1678	15840600155000
57068	1726	663848335000
57069	1874	4255000
57070	1726	663847334000
57071	1874	4256000
57072	1726	663846331000
57073	1874	4259000
57074	1726	663845329000
57075	1874	4261000
57076	1726	663844328000
57077	1874	4262000
57078	1726	663843325000
57079	1874	4265000
57080	1726	663842323000
57081	1874	4267000
57082	1726	663841322000
57083	1874	4268000
57084	1726	663840319000
57085	1874	4271000
57086	1688	89642213904000
57087	1397	1358101944000
57088	1678	15840600156000
57089	1726	663839317000
57090	1874	4273000
57091	1726	663838316000
57092	1874	4274000
57093	1726	663837313000
57094	1874	4277000
57095	1679	31067947652000
57096	1679	31067960652000
57097	1729	16127086000000
57098	1506	7921119967172
57099	1397	1358091943000
57100	1678	15840600157000
57101	1698	9176966550035
57102	1726	663836311000
57103	1874	4279000
57104	1726	663835310000
57105	1874	4280000
57106	1726	663834307000
57107	1874	4283000
57108	1688	90362213904000
57109	1688	90362226904000
57110	1395	57870890296533700
57111	1395	57870890309533700
57112	1623	49682519899898
57113	1623	49682572899898
57114	1397	1358081942000
57115	1678	15840600158000
57116	1397	1358071941000
57117	1678	15840600159000
57118	1397	1358061940000
57119	1678	15840600160000
57120	1397	1358051939000
57121	1678	15840600161000
57122	1397	1358041938000
57123	1678	15840600162000
57124	1727	7386753000000
57125	1397	1358031937000
57126	1678	15840600163000
57127	1726	663833306000
57128	1874	4284000
57129	1726	663832304000
57130	1874	4286000
57131	1726	663831301000
57132	1874	4289000
57133	1726	663830299000
57134	1874	4291000
57135	1726	663829298000
57136	1874	4292000
57137	1726	663828295000
57138	1874	4295000
57139	1726	663827293000
57140	1874	4297000
57141	1726	663826292000
57142	1874	4298000
57143	1726	663825289000
57144	1874	4301000
57145	1726	663824287000
57146	1874	4303000
57147	1726	663823286000
57148	1874	4304000
57149	1726	663822283000
57150	1874	4307000
57151	1726	663821281000
57152	1874	4309000
57153	1726	663820280000
57154	1874	4310000
57155	1726	663819277000
57156	1874	4313000
57157	1549	13295774000000
57158	1555	6675164979096
57159	1678	15120585076000
57160	1678	15120585077000
57161	1678	15120585078000
57162	1678	15120585079000
57163	1678	15120585080000
57164	1678	15120585081000
57165	1678	15120585082000
57166	1678	15120585083000
57167	1678	15120585084000
57168	1678	15120585085000
57169	1549	13297208000000
57170	1678	15120585086000
57171	1678	15120585087000
57172	1678	15120585088000
57173	1678	15120585089000
57174	1678	15120585090000
57175	1678	15120585091000
57176	1678	15120585092000
57177	1678	15120585093000
57178	1678	15120585094000
57179	1678	15120585095000
57180	1678	15120585096000
57181	1678	15120585097000
57182	1678	15120585098000
57183	1678	15120585099000
57184	1678	15120585100000
57185	1678	15120585101000
57186	1678	15120585102000
57187	1678	15120585103000
57188	1678	15120585104000
57189	1678	15120585105000
57190	1678	15120585106000
57191	1678	15120585107000
57192	1678	15120585108000
57193	1678	15120585109000
57194	1678	15120585110000
57195	1678	15120585111000
57196	1678	15120585112000
57197	1678	15120585113000
57198	1678	15120585114000
57199	1678	15120585115000
57200	1678	15120585116000
57201	1678	15120585117000
57202	1678	15120585118000
57203	1549	14017208000000
57204	1549	14017538000000
57215	1607	10338263644388
57216	1607	10338276644388
57217	1764	8646888100000
57218	1764	8646990100000
57234	1726	663813265000
57235	1874	4325000
57236	1726	663812263000
57237	1874	4327000
57238	1726	663811262000
57239	1874	4328000
57240	1726	663810259000
57241	1874	4331000
57242	1726	663809258000
57243	1874	4332000
57244	1394	7200126000000
57246	1397	1357981932000
57247	1678	15840600168000
57248	1690	99363201000000
57306	1397	1357911925000
57307	1678	15840600175000
57308	1397	1357901924000
57309	1678	15840600176000
57310	1726	663787214000
57311	1874	4376000
57312	1726	663786211000
57313	1874	4379000
57314	1726	663785210000
57315	1874	4380000
57316	1637	169204749819997
57317	1637	169924749819988
57361	2106	719024000000
57362	1397	1357861920000
57363	1678	15840600180000
57364	1726	663774188000
57365	1874	4402000
57366	1688	90362224904000
57370	1397	1357851919000
57371	1678	15840600181000
57372	1397	1357841918000
57373	1678	15840600182000
57374	1726	663773186000
57375	1874	4404000
57376	1726	663772183000
57377	1874	4407000
57378	1726	663771181000
57379	1874	4409000
57380	1726	663770178000
57381	1874	4412000
57382	606	72137726812962
57391	1397	1357821916000
57392	1678	15840600184000
57393	1726	663767171000
57394	1874	4419000
57423	1397	1357771911000
57424	1678	15840600189000
57425	1726	663758149000
57426	1874	4441000
57427	1394	10080126000000
57428	1394	10080137000000
57433	1692	64822686019999
57447	1509	9311784851155
57472	1397	1357691903000
57473	1678	15840600197000
57474	1397	1357681902000
57475	1678	15840600198000
57476	1726	663750132000
57477	1874	4458000
57478	1726	663749130000
57479	1874	4460000
57480	1726	663748127000
57481	1874	4463000
57482	1726	663747125000
57483	1874	4465000
57484	1693	20073600155041
57505	1708	7235732000021
57506	1708	7235756000021
57509	1397	1357641898000
57510	1678	15840600202000
57511	1726	663740107000
57512	1874	4483000
57513	1395	57873770366533700
57514	1395	57873770377533700
57551	1690	100083201000000
57552	1690	100083249000000
57553	647	66234984938283
57554	2113	99000000000
57555	1397	1357571891000
57556	1678	15840600209000
57557	1397	1357561890000
57558	1678	15840600210000
57559	1397	1357551889000
57560	1678	15840600211000
57561	1726	663729079000
57562	1874	4511000
57563	1726	663728077000
57564	1874	4513000
57565	1726	663727074000
57566	1874	4516000
57567	1726	663726072000
57568	1874	4518000
57569	1726	663725069000
57570	1874	4521000
57571	1726	663724067000
57572	1874	4523000
57573	1546	7920776000000
57596	1397	1357521886000
57597	1678	15840600214000
57598	1726	663720056000
57599	1874	4534000
57600	1726	663719054000
57601	1874	4536000
57602	1549	13295760000000
57603	1397	1357511885000
57604	1678	15840600215000
57605	1726	663718051000
57606	1874	4539000
57607	1613	10007857600000
57608	1613	10007868600000
57609	1613	9288236600000
57610	1613	10008236600000
57611	1613	10008759600000
57617	1703	4320649000000
57645	1588	13174955000000
57657	1397	1357431877000
57658	1678	15840600223000
57659	1726	663710027000
57660	1874	4563000
57661	1649	14684116999992
57662	1649	14684127999992
57669	1395	57874490377533700
57670	1395	57874490388533700
57674	1726	663707018000
57675	1874	4572000
57676	632	96240859000000
57703	1394	10080138000000
57713	1637	171364750819988
57714	1637	171364762819988
57739	1715	33120548000000
57740	1715	33120560000000
57753	497	66720012000000
57762	1692	65542698019999
57770	1397	1357331867000
57771	1678	15840600233000
57772	1726	663685965000
57773	1874	4625000
57774	1726	663684962000
57775	1874	4628000
57827	42	87598263000000
57856	1397	1357211855000
57857	1678	15840600245000
57858	1726	663663910000
57859	1874	4680000
57860	1726	663662907000
57205	1397	1358021936000
57206	1678	15840600164000
57207	1726	663818275000
57208	1874	4315000
57209	1726	663817274000
57210	1874	4316000
57211	1726	663816271000
57212	1874	4319000
57213	2112	719000000000
57214	2112	719013000000
57255	1397	1357971931000
57256	1678	15840600169000
57257	1397	1357961930000
57258	1678	15840600170000
57259	1397	1357951929000
57260	1678	15840600171000
57261	1397	1357941928000
57262	1678	15840600172000
57263	1726	663805249000
57264	1874	4341000
57265	1726	663804247000
57266	1874	4343000
57267	1726	663803246000
57268	1874	4344000
57269	1726	663802243000
57270	1874	4347000
57271	1726	663801241000
57272	1874	4349000
57273	1726	663800240000
57274	1874	4350000
57275	1726	663799237000
57276	1874	4353000
57277	1726	663798235000
57278	1874	4355000
57279	1726	663797234000
57280	1874	4356000
57281	1726	663796231000
57282	1874	4359000
57283	1726	663795229000
57284	1874	4361000
57285	1726	663794228000
57286	1874	4362000
57287	1439	7492367998477
57318	1622	15660266000014
57338	1693	20073592155041
57352	1726	663778196000
57353	1874	4394000
57354	1726	663777194000
57355	1874	4396000
57356	1726	663776191000
57357	1726	663775190000
57358	1874	4400000
57359	1395	57871610309533700
57360	1395	57871610333533700
57368	1549	13295759000000
57369	1594	12145175000000
57409	1397	1357791913000
57410	1678	15840600187000
57411	1397	1357781912000
57412	1678	15840600188000
57413	1726	663762159000
57414	1874	4431000
57415	1726	663761156000
57416	1874	4434000
57417	1726	663760154000
57418	1874	4436000
57419	1726	663759151000
57420	1874	4439000
57421	1394	8640102000000
57422	1394	8640126000000
57431	1700	8225885276737
57432	1700	8225896276737
57434	1397	1357761910000
57435	1678	15840600190000
57436	1726	663757147000
57437	1874	4443000
57438	58	80346436999641
57439	58	80346447999641
57452	1397	1357731907000
57453	1678	15840600193000
57454	1397	1357721906000
57455	1678	15840600194000
57456	1726	663754141000
57457	1874	4449000
57458	1726	663753139000
57459	1874	4451000
57460	1594	12865175000000
57461	1594	12865197000000
57485	1397	1357671901000
57486	1678	15840600199000
57487	1726	663746122000
57488	1874	4468000
57489	1726	663745120000
57490	1874	4470000
57491	1522	8254113000000
57525	1657	7921316000000
57583	1489	7823899000000
57584	1489	7823911000000
57620	1397	1357491883000
57621	1678	15840600217000
57622	1397	1357481882000
57623	1678	15840600218000
57624	2113	333982938283
57625	1726	663716045000
57626	1874	4545000
57627	1726	663715042000
57628	1874	4548000
57629	1506	8641119967172
57630	1506	8641152967172
57647	1692	65542686019999
57648	1692	65542719019999
57649	1397	1357441878000
57650	1678	15840600222000
57651	1726	663711030000
57652	1874	4560000
57653	1706	9572142600135
57654	1706	9572153600135
57656	1646	720011000000
57677	1726	663706015000
57678	1874	4575000
57679	1767	1439001000000
57680	1767	1439002000000
57687	1637	170644749819988
57688	1637	170644750819988
57695	1397	1357411875000
57696	1678	15840600225000
57697	1726	663702005000
57698	1874	4585000
57699	1726	663701002000
57700	1874	4588000
57701	1695	8972189000000
57702	1695	8972201000000
57704	1397	1357401874000
57705	1678	15840600226000
57706	1726	663700000000
57707	1874	4590000
57708	1726	663698997000
57709	1874	4593000
57710	1688	91082224904000
57711	1688	91082236904000
57729	1397	1357371871000
57730	1678	15840600229000
57731	1726	663693985000
57732	1874	4605000
57733	1726	663692982000
57734	1874	4608000
57735	69	67440010000000
57736	69	67440022000000
57743	1397	1357361870000
57744	1678	15840600230000
57745	1726	663691980000
57746	1874	4610000
57747	1726	663690977000
57748	1874	4613000
57749	1768	11390751110000
57750	1768	11390763110000
57761	506	66720012000000
57776	1764	9366990100000
57777	1764	9367091100000
57788	1397	1357311865000
57789	1678	15840600235000
57790	1397	1357301864000
57791	1678	15840600236000
57792	1397	1357291863000
57793	1678	15840600237000
57794	1397	1357281862000
57795	1678	15840600238000
57796	1726	663681955000
57797	1874	4635000
57798	1726	663680952000
57799	1874	4638000
57800	1726	663679950000
57801	1874	4640000
57802	1726	663678947000
57803	1874	4643000
57804	1726	663677945000
57805	1874	4645000
57806	1726	663676942000
57807	1874	4648000
57808	1726	663675940000
57809	1874	4650000
57810	1458	12333558908540
57811	1458	12333605908540
57828	1397	1357251859000
57829	1678	15840600241000
57219	1397	1358011935000
57220	1678	15840600165000
57221	1726	663815269000
57222	1874	4321000
57223	1726	663814268000
57224	1874	4322000
57225	1764	7926849100000
57227	1764	7926839100000
57245	1693	19353576155041
57249	1726	663808255000
57250	1874	4335000
57251	1726	663807253000
57252	1874	4337000
57253	1726	663806252000
57254	1874	4338000
57323	1726	663784208000
57324	1874	4382000
57325	1726	663783207000
57326	1874	4383000
57327	1726	663782204000
57328	1874	4386000
57329	1726	663781202000
57330	1874	4388000
57331	1726	663780201000
57332	1874	4389000
57333	1726	663779198000
57334	1874	4392000
57335	1622	15660291000014
57336	2004	15660307000005
57337	1622	200000018
57339	1397	1357881922000
57340	1678	15840600178000
57341	1397	1357871921000
57342	1678	15840600179000
57343	1726	663778197000
57344	1874	4393000
57345	1726	663777195000
57346	1874	4395000
57347	1726	663776192000
57348	1874	4398000
57349	1726	663775191000
57350	1874	4399000
57351	1448	4356724000001
57367	1394	7200102000000
57395	1397	1357811915000
57396	1678	15840600185000
57397	1397	1357801914000
57398	1678	15840600186000
57399	1726	663766169000
57400	1874	4421000
57401	1726	663765166000
57402	1874	4424000
57403	1726	663764164000
57404	1874	4426000
57405	1726	663763161000
57406	1874	4429000
57407	1717	7307908000023
57408	1717	7307932000023
57429	1395	57872330333533700
57430	1395	57872330344533700
57441	1991	9835795441475
57448	1397	1357741908000
57449	1678	15840600192000
57450	1726	663755143000
57451	1874	4447000
57507	1587	12960426000000
57508	1587	12960450000000
57515	1397	1357631897000
57516	1678	15840600203000
57517	1397	1357621896000
57518	1678	15840600204000
57519	1726	663739104000
57520	1874	4486000
57521	1726	663738102000
57522	1874	4488000
57523	1850	9998876000000
57524	1850	9998898000000
57574	1555	7395164979096
57575	1555	7395300979096
57576	1397	1357541888000
57577	1678	15840600212000
57578	1726	663723064000
57579	1874	4526000
57580	1726	663722062000
57581	1874	4528000
57582	1688	90362225904000
57587	1594	13585197000000
57588	1594	13585209000000
57618	1991	9835796441475
57646	42	87598284000000
57663	1687	8632693524804
57664	1687	8632704524804
57683	1726	663705012000
57684	1874	4578000
57685	1534	2160072000000
57686	1534	2160073000000
57689	1726	663704010000
57690	1874	4580000
57691	1726	663703007000
57692	1874	4583000
57693	1685	89281668571430
57694	1685	89281670571430
57721	1397	1357381872000
57722	1678	15840600228000
57723	1726	663695990000
57724	1874	4600000
57725	1726	663694987000
57726	1874	4603000
57727	1608	11085559000000
57728	1608	11085571000000
57741	1559	8602671000000
57742	1559	8602683000000
57754	1397	1357351869000
57755	1678	15840600231000
57756	1726	663689975000
57757	1874	4615000
57758	1726	663688972000
57759	1874	4618000
57760	633	76684028900000
57786	1764	8646839100000
57787	1764	8646851100000
57813	1397	1357271861000
57814	1678	15840600239000
57815	1726	663674937000
57816	1874	4653000
57817	1693	20793600155041
57818	1693	20793611155041
57862	576	77315740938283
57882	1394	12960150000000
57883	1394	12960162000000
57933	1740	7721313000000
57958	1601	4250149600000
57999	1397	1357061840000
58000	1678	15840600260000
58001	1726	663623810000
58002	1874	4780000
58003	1726	663622807000
58004	1874	4783000
58005	1394	14400174000000
58033	1395	57875930391533700
58034	1395	57875930403533700
58061	1644	721199000000
58062	1644	721222000000
58073	1693	21397475239447
58074	251	66530973005524
58075	1397	1356981832000
58076	1678	15840600268000
58077	1693	21363676464009
58078	35	19354464874293
58079	1693	21247517548415
58080	49	66530973005524
58081	1693	19661991475715
58082	1030	908221538475200
58083	1726	663608773000
58084	1874	4817000
58085	1394	14400213000000
58154	1693	15101426785815
58155	163	66530973005524
58156	1693	14985267870221
58157	275	66530973005524
58158	1693	14869108954627
58159	201	66530973005524
58160	1397	1356931827000
58161	1678	15840600273000
58162	1693	14752950039033
58163	1962	529885180751
58164	1693	14636791123439
58165	309	66530973005524
58166	1693	14520632207845
58167	82	66530973005524
58168	1726	663603758000
58169	1874	4832000
58170	1593	11349897000000
58171	1593	11349968000000
58191	1649	15404127999992
58192	1649	15404199999992
58245	1419	15579491280064
58373	1675	8062253999977
58396	1394	18720497000000
58397	1394	18720569000000
58398	1397	1356821816000
58399	1678	15840600284000
58400	1693	6041766669663
58401	304	66530973005524
58402	1693	5925607754069
57226	1764	7926847100000
57228	1397	1358001934000
57229	1678	15840600166000
57230	1397	1357991933000
57231	1678	15840600167000
57232	1693	19353541155041
57233	1693	19353571155041
57288	1397	1357931927000
57289	1678	15840600173000
57290	1397	1357921926000
57291	1678	15840600174000
57292	1726	663793225000
57293	1874	4365000
57294	1726	663792223000
57295	1874	4367000
57296	1726	663791222000
57297	1874	4368000
57298	1726	663790220000
57299	1874	4370000
57300	1726	663789217000
57301	1874	4373000
57302	1726	663788216000
57303	1874	4374000
57304	1768	10670725110000
57305	1768	10670751110000
57319	1397	1357891923000
57320	1678	15840600177000
57321	1693	20073576155041
57322	1693	20073586155041
57383	1397	1357831917000
57384	1678	15840600183000
57385	1726	663769176000
57386	1874	4414000
57387	1726	663768173000
57388	1874	4417000
57389	1723	12599354085979
57390	1723	12599366085979
57440	149	79950192000341
57442	1397	1357751909000
57443	1678	15840600191000
57444	1726	663756145000
57445	1874	4445000
57446	1402	41614278319298
57462	1397	1357711905000
57463	1678	15840600195000
57464	1397	1357701904000
57465	1678	15840600196000
57466	1726	663752137000
57467	1874	4453000
57468	1726	663751135000
57469	1874	4455000
57470	1395	57873050344533700
57471	1395	57873050366533700
57492	1397	1357661900000
57493	1678	15840600200000
57494	1397	1357651899000
57495	1678	15840600201000
57496	1726	663744117000
57497	1874	4473000
57498	1726	663743115000
57499	1874	4475000
57500	1726	663742112000
57501	1874	4478000
57502	1726	663741110000
57503	1874	4480000
57504	1688	90362237904000
57526	1397	1357611895000
57527	1678	15840600205000
57528	1397	1357601894000
57529	1678	15840600206000
57530	1397	1357591893000
57531	1678	15840600207000
57532	1397	1357581892000
57533	1678	15840600208000
57534	1726	663737099000
57535	1874	4491000
57536	1726	663736097000
57537	1874	4493000
57538	1726	663735094000
57539	1874	4496000
57540	1726	663734092000
57541	1874	4498000
57542	1726	663733089000
57543	1874	4501000
57544	1726	663732087000
57545	1874	4503000
57546	1726	663731084000
57547	1874	4506000
57548	1726	663730082000
57549	1874	4508000
57550	1672	13681954000000
57585	1439	8212367998477
57586	1439	8212379998477
57589	1397	1357531887000
57590	1678	15840600213000
57591	647	66000000000000
57592	2113	333983938283
57593	1726	663721059000
57594	1874	4531000
57595	1536	12240690999959
57612	1397	1357501884000
57613	1678	15840600216000
57614	1726	663717048000
57615	1874	4542000
57616	1489	7823910000000
57619	1702	7200295000000
57631	1397	1357471881000
57632	1678	15840600219000
57633	1397	1357461880000
57634	1678	15840600220000
57635	1397	1357451879000
57636	1678	15840600221000
57637	1726	663714039000
57638	1874	4551000
57639	1726	663713036000
57640	1874	4554000
57641	1726	663712033000
57642	1874	4557000
57643	1671	8688301530515
57644	1671	8688334530515
57655	1594	13585208000000
57665	1397	1357421876000
57666	1678	15840600224000
57667	1726	663709024000
57668	1874	4566000
57671	1726	663708021000
57672	1874	4569000
57673	1700	8225886276737
57681	1508	12276267500009
57682	1508	12276268500009
57712	1711	11324546000000
57715	1397	1357391873000
57716	1678	15840600227000
57717	1726	663697995000
57718	1874	4595000
57719	1726	663696992000
57720	1874	4598000
57737	1684	12931347880623
57738	1684	12931359880623
57751	369	94080795000000
57752	369	94080807000000
57763	1397	1357341868000
57764	1678	15840600232000
57765	1726	663687970000
57766	1874	4620000
57767	1726	663686967000
57768	1874	4623000
57769	1395	57874490389533700
57778	1397	1357321866000
57779	1678	15840600234000
57780	1726	663683960000
57781	1874	4630000
57782	1726	663682957000
57783	1874	4633000
57784	1394	11520138000000
57785	1394	11520150000000
57812	1594	13585244000000
57819	1397	1357261860000
57820	1678	15840600240000
57821	1726	663673935000
57822	1874	4655000
57823	1726	663672932000
57824	1874	4658000
57825	1395	57875210389533700
57826	1395	57875210401533700
57836	1397	1357241858000
57837	1678	15840600242000
57838	1397	1357231857000
57839	1678	15840600243000
57840	1397	1357221856000
57841	1678	15840600244000
57842	1726	663669925000
57843	1874	4665000
57844	1726	663668922000
57845	1874	4668000
57846	1726	663667920000
57847	1874	4670000
57848	1726	663666917000
57849	1874	4673000
57850	1726	663665915000
57851	1874	4675000
57852	1726	663664912000
57853	1874	4678000
57854	1723	13319366085979
57855	1723	13319402085979
57830	1726	663671930000
57831	1874	4660000
57832	1726	663670927000
57833	1874	4663000
57834	1688	91802236904000
57835	1688	91802248904000
57863	576	77315752938283
57864	1685	90001670571430
57865	1685	90001682571430
57866	1397	1357201854000
57867	1678	15840600246000
57868	1726	663661905000
57869	1874	4685000
57870	1726	663660902000
57871	1874	4688000
57897	1397	1357161850000
57898	1678	15840600250000
57899	1726	663653885000
57900	1874	4705000
57901	1726	663652882000
57902	1874	4708000
57903	1716	9406715000000
57934	1397	1357111845000
57935	1678	15840600255000
57936	1397	1357101844000
57937	1678	15840600256000
57938	1726	663643860000
57939	1874	4730000
57940	1726	663642857000
57941	1874	4733000
57942	1726	663641855000
57943	1874	4735000
57944	1726	663640852000
57945	1874	4738000
57946	1457	12144280040000
57947	1457	12144304040000
57967	1397	1357091843000
57968	1678	15840600257000
57969	1397	1357081842000
57970	1678	15840600258000
57971	1726	663635840000
57972	1874	4750000
57973	1726	663634837000
57974	1874	4753000
57975	1726	663633835000
57976	1874	4755000
57977	1726	663632832000
57978	1874	4758000
57979	1726	663631830000
57980	1874	4760000
57981	1726	663630827000
57982	1874	4763000
57983	1726	663629825000
57984	1874	4765000
57985	1726	663628822000
57986	1874	4768000
57987	1726	663627820000
57988	1874	4770000
57989	1726	663626817000
57990	1874	4773000
57991	1402	41614297319298
58006	1601	4250159600000
58010	1397	1357051839000
58011	1678	15840600261000
58012	1397	1357041838000
58013	1678	15840600262000
58014	1726	663621805000
58015	1874	4785000
58016	1726	663620802000
58017	1874	4788000
58018	1726	663619800000
58019	1874	4790000
58020	1691	8603089100019
58021	1726	663618797000
58022	1874	4793000
58023	1691	9323089100019
58024	1691	9323090100019
58035	1420	1434949120000
58036	171	73910347624688
58037	1420	73910349724688
58038	171	1434959020000
58048	1709	6480071999976
58065	1397	1356991833000
58066	1678	15840600267000
58067	1726	663610778000
58068	1874	4812000
58069	1726	663609775000
58070	1874	4815000
58071	1637	172804786819988
58072	1637	172804798819988
58246	1679	31068160652000
58250	1693	11616659317995
58251	691	66530973005524
58252	1397	1356881822000
58253	1678	15840600278000
58254	1693	11613129653899
58255	731	2016090091005
58256	1693	10543340366007
58257	1150	612795169601792
58258	1693	10427181450413
58259	84	66530973005524
58260	1693	10311022534819
58261	520	66530973005524
58262	1693	10194863619225
58263	551	66530973005524
58264	1693	10078704703631
58265	2017	529572339923
58266	1693	9962545788037
58267	63	66530973005524
58268	1397	1356871821000
58269	1678	15840600279000
58270	1693	9846386872443
58271	150	66530973005524
58272	1693	9730227956849
58273	92	66530973005524
58274	1688	91802368904000
58275	1693	9614069041255
58276	322	66530973005524
58277	1693	9497910125661
58278	373	66530973005524
58279	1726	663598743000
58280	1874	4847000
58281	1726	663597740000
58282	1874	4850000
58283	1688	92522368904000
58284	1688	92522390904000
58285	1397	1356861820000
58286	1678	15840600280000
58287	1397	1356851819000
58288	1678	15840600281000
58289	1397	1356841818000
58290	1678	15840600282000
58291	1693	9381751210067
58292	450	66530973005524
58293	1693	9265592294473
58294	453	66530973005524
58295	1693	9149433378879
58296	593	66529972005524
58297	1693	9033274463285
58298	91	66530973005524
58299	1693	8917115547691
58300	408	66530973005524
58301	1693	8800956632097
58302	438	66530973005524
58303	1693	8684797716503
58304	601	66530973005524
58305	1693	8681268052407
58306	745	2016090091005
58307	1693	8565109136813
58308	339	66530973005524
58309	1693	8448950221219
58310	504	66530973005524
58311	1693	8332791305625
58312	1961	529885180751
58313	1693	8216632390031
58314	658	66530973005524
58315	1693	8100473474437
58316	205	66530973005524
58317	1693	7984314558843
58318	660	66530973005524
58319	1693	7868155643249
58320	78	66530973005524
58321	1693	7751996727655
58322	395	66527943005524
58323	1693	7739667903289
58324	29	7056315318724
58325	1693	6854879078821
58326	910	506822478197568
58327	1726	663596737000
58328	1874	4853000
58329	1726	663595734000
58330	1874	4856000
58331	1726	663594731000
58332	1874	4859000
58333	1654	13968009000000
58334	1654	200000002
58335	1796	13968121999798
58336	167	10800495000000
58337	1596	66000000000200
58374	576	77316040938283
58375	1996	450000000
58376	576	78035790938283
58414	1727	8106753000000
58415	1727	8106814000000
58430	1535	720000000000
57861	1874	4683000
57880	1587	13680450000000
57881	1587	13680462000000
57884	1397	1357181852000
57885	1678	15840600248000
57886	1397	1357171851000
57887	1678	15840600249000
57888	1726	663657895000
57889	1874	4695000
57890	1726	663656892000
57891	1874	4698000
57892	1726	663655890000
57893	1874	4700000
57894	1726	663654887000
57895	1874	4703000
57896	58	80346460999641
57911	1457	11424268040000
57912	1457	11424280040000
57913	1397	1357141848000
57914	1678	15840600252000
57915	1397	1357131847000
57916	1678	15840600253000
57917	1397	1357121846000
57918	1678	15840600254000
57919	1726	663649875000
57920	1874	4715000
57921	1726	663648872000
57922	1874	4718000
57923	1726	663647870000
57924	1874	4720000
57925	1726	663646867000
57926	1874	4723000
57927	1726	663645865000
57928	1874	4725000
57929	1726	663644862000
57930	1874	4728000
57931	1439	8932379998477
57932	1439	8932415998477
57950	1394	14400162000000
57951	1394	14400186000000
57957	1768	11390753110000
57959	1601	3530957600000
57960	1601	4250957600000
57961	1601	4251577600000
57992	1397	1357071841000
57993	1678	15840600259000
57994	1726	663625815000
57995	1874	4775000
57996	1726	663624812000
57997	1874	4778000
57998	1690	100083213000000
58007	1601	4251838600000
58008	1601	4971838600000
58009	1601	4971900600000
58025	1397	1357031837000
58026	1678	15840600263000
58027	1726	663617795000
58028	1874	4795000
58029	1726	663616792000
58030	1874	4798000
58031	633	77404028900000
58032	633	77404040900000
58049	1397	1357011835000
58050	1678	15840600265000
58051	1397	1357001834000
58052	1678	15840600266000
58053	1726	663613785000
58054	1874	4805000
58055	1726	663612783000
58056	1874	4807000
58057	1726	663611780000
58058	1874	4810000
58059	1705	7840493500145
58060	1705	7840516500145
58173	1397	1356921826000
58174	1678	15840600274000
58175	1693	14404473292251
58176	361	66530973005524
58177	1693	14288314376657
58178	452	66530973005524
58179	1693	14172155461063
58180	594	66530973005524
58181	1693	14055996545469
58182	534	66530973005524
58183	1693	13939837629875
58184	245	66530973005524
58185	1693	13823678714281
58186	191	66530973005524
58187	1726	663602755000
58188	1874	4835000
58189	606	72857726812962
58190	606	72857798812962
58201	1693	13707519798687
58202	266	66530973005524
58203	1693	13591360883093
58204	352	66530973005524
58205	1693	13475201967499
58206	421	66530973005524
58207	1693	13359043051905
58208	420	66530973005524
58209	1693	13242884136311
58210	600	66530973005524
58211	1693	13126725220717
58212	353	66530963005524
58213	1693	13010566305123
58214	620	66530973005524
58215	1693	12894407389529
58216	180	66530973005524
58217	1693	12778248473935
58218	112	66187942005524
58219	1693	12662089558341
58220	652	66530973005524
58221	1693	12545930642747
58222	680	66530973005524
58223	1693	12429771727153
58224	690	66530973005524
58225	1693	12313612811559
58226	89	66530973005524
58227	1693	12197453895965
58228	186	66530973005524
58229	1693	12081294980371
58230	383	66530973005524
58231	1693	11965136064777
58232	392	66530973005524
58233	1693	11848977149183
58234	308	66530973005524
58235	1693	11732818233589
58236	678	66530973005524
58237	1726	663601752000
58238	1874	4838000
58239	1726	663600749000
58240	1874	4841000
58241	1726	663599746000
58242	1874	4844000
58243	1426	12524918000000
58244	1426	12525131000000
58247	1451	6379052000000
58248	2039	8641117000000
58249	2039	8641330000000
58372	1654	13968222000000
58461	1397	1356761810000
58462	1678	15840600290000
58463	1726	663586707000
58464	1874	4883000
58465	1451	6378850000000
58556	1397	1356721806000
58557	1678	15840600294000
58558	1726	663582695000
58559	1874	4895000
58560	1422	7344984860211
58750	1397	1356561790000
58751	1678	15840600310000
58752	1701	9430315600056
58753	1701	9430325600056
58761	1506	9361152967172
58762	1506	9361163967172
58776	1596	11520495000000
58777	1596	11520517000000
58784	1397	1356511785000
58785	1678	15840600315000
58786	1397	1356501784000
58787	1678	15840600316000
58788	1397	1356491783000
58789	1678	15840600317000
58790	1397	1356481782000
58791	1678	15840600318000
58792	1726	663562635000
58793	1874	4955000
58794	1726	663561632000
58795	1874	4958000
58796	1726	663560629000
58797	1874	4961000
58798	1726	663559626000
58799	1874	4964000
58800	1467	3566554100039
58801	1467	3566598100039
58806	1596	10800495000000
58807	1455	5794046000000
58808	1397	1356471781000
58809	1678	15840600319000
58810	1397	1356461780000
58811	1678	15840600320000
58812	1397	1356451779000
58813	1678	15840600321000
58814	1397	1356441778000
57872	1397	1357191853000
57873	1678	15840600247000
57874	1726	663659900000
57875	1874	4690000
57876	1726	663658897000
57877	1874	4693000
57878	1688	92522248904000
57879	1688	92522260904000
57904	1397	1357151849000
57905	1678	15840600251000
57906	1726	663651880000
57907	1874	4710000
57908	1726	663650877000
57909	1874	4713000
57910	1679	31067959652000
57948	1637	172084762819988
57949	1637	172084786819988
57952	1726	663639850000
57953	1874	4740000
57954	1726	663638847000
57955	1874	4743000
57956	1719	7220349000000
57962	1726	663637845000
57963	1874	4745000
57964	1726	663636842000
57965	1874	4748000
57966	1395	57875210391533700
58039	1739	24479717000000
58040	641	72819837100000
58041	641	72819849100000
58042	1397	1357021836000
58043	1678	15840600264000
58044	1726	663615790000
58045	1874	4800000
58046	1726	663614787000
58047	1874	4803000
58063	1693	21513611155041
58064	1693	21513634155041
58086	1693	18831153617299
58087	1772	3796456950108
58088	1397	1356971831000
58089	1678	15840600269000
58090	1693	18714994701705
58091	663	66530973005524
58092	1693	18598835786111
58093	320	66249773005524
58094	1693	18482676870517
58095	54	66530973005524
58096	1693	18473867710256
58097	710	5040225227645
58098	1693	18357708794662
58099	499	66530973005524
58100	1726	663607770000
58101	1874	4820000
58102	1394	15840213000000
58103	1394	15840284000000
58104	1693	18241549879068
58105	217	66530973005524
58106	1397	1356961830000
58107	1678	15840600270000
58108	1397	1356951829000
58109	1678	15840600271000
58110	1397	1356941828000
58111	1678	15840600272000
58112	1693	18125390963474
58113	103	66530973005524
58114	1693	17807585211605
58115	1811	1448945930186
58116	1693	17267618407868
58117	893	309291320931713
58118	1693	17151459492274
58119	225	66530973005524
58120	1693	17035300576680
58121	377	66530973005524
58122	1693	16919141661086
58123	560	66530973005524
58124	1693	16802982745492
58125	252	66530973005524
58126	1693	16263015941755
58127	894	309291320931713
58128	1693	16146857026161
58129	569	66530973005524
58130	1693	16030698110567
58131	390	66530973005524
58132	1693	15914539194973
58133	108	66530973005524
58134	1693	15798380279379
58135	99	66530973005524
58136	1693	15682221363785
58137	570	66530973005524
58138	1693	15566062448191
58139	2073	529147915594
58140	1693	15449903532597
58141	391	66530973005524
58142	1693	15333744617003
58143	397	66530973005524
58144	1693	15217585701409
58145	402	66530973005524
58146	1726	663606767000
58147	1874	4823000
58148	1726	663605764000
58149	1874	4826000
58150	1726	663604761000
58151	1874	4829000
58152	1394	17280284000000
58153	1394	17280497000000
58172	1593	11349967000000
58193	1397	1356911825000
58194	1678	15840600275000
58195	1397	1356901824000
58196	1678	15840600276000
58197	1397	1356891823000
58198	1678	15840600277000
58199	1451	6378839000000
58200	1451	6378869000000
58338	1693	19957441239447
58339	1693	19923642464009
58340	1693	19807483548415
58341	1693	18221957475715
58342	1693	17391119617299
58343	1693	17274960701705
58344	1693	17158801786111
58345	1693	17042642870517
58346	1693	17033833710256
58347	1693	16917674794662
58348	1693	16801515879068
58349	1693	16685356963474
58350	1693	16367551211605
58351	1693	15827584407868
58352	1693	15711425492274
58353	1693	15595266576680
58354	1693	15479107661086
58355	1693	15362948745492
58356	1693	14822981941755
58357	1693	14706823026161
58358	1693	14590664110567
58359	1693	14474505194973
58360	1693	14358346279379
58361	1693	14242187363785
58362	1693	14126028448191
58363	1693	14009869532597
58364	1693	13893710617003
58365	1693	13777551701409
58366	1693	13661392785815
58367	1693	13545233870221
58368	1693	13429074954627
58369	1693	13312916039033
58370	1693	13196757123439
58371	1675	8062370999977
58377	1693	6738720163227
58378	138	66530973005524
58379	1397	1356831817000
58380	1678	15840600283000
58381	1693	6622561247633
58382	146	66530973005524
58383	1693	6506402332039
58384	122	66530973005524
58385	1693	6390243416445
58386	105	66530973005524
58387	1693	6274084500851
58388	500	66530973005524
58389	1693	6157925585257
58390	587	66530973005524
58391	1749	2405105000000
58392	1950	7169852000000
58393	1726	663593728000
58394	1874	4862000
58395	1729	16127148000000
58432	1739	24479756000000
58439	1395	57876650403533700
58440	1395	57876650414533700
58459	1513	26640821000000
58460	1513	26640832000000
58549	1395	57877370414533700
58550	1395	57877370436533700
58551	1397	1356731807000
58552	1678	15840600293000
58553	1726	663583698000
58554	1874	4892000
58555	1564	7746364000000
58562	2106	719011000000
58587	1634	11711757641004
58661	1693	17797370239447
58662	1693	17763571464009
58663	1693	17647412548415
58403	399	66530973005524
58404	1693	5809448838475
58405	611	66530973005524
58406	1693	5693289922881
58407	206	66530973005524
58408	1693	5577131007287
58409	622	66533953005524
58410	1726	663592725000
58411	1874	4865000
58412	1444	9935050159999
58413	1444	9935111159999
58416	1397	1356811815000
58417	1678	15840600285000
58418	1693	5460972091693
58419	653	66530973005524
58420	1693	5344813176099
58421	194	66530973005524
58422	1693	2363768070939
58423	1276	1707608226803810
58424	1693	2360238406843
58425	721	2016090091005
58426	1726	663591722000
58427	1874	4868000
58428	1727	8826814000000
58429	1727	8826865000000
58441	1397	1356791813000
58442	1678	15840600287000
58443	1397	1356781812000
58444	1678	15840600288000
58445	1726	663589716000
58446	1874	4874000
58447	1726	663588713000
58448	1874	4877000
58449	1608	11805571000000
58450	1608	11805593000000
58453	1397	1356771811000
58454	1678	15840600289000
58455	1726	663587710000
58456	1874	4880000
58457	1716	10126715000000
58458	1716	10126726000000
58466	1764	9366851100000
58467	1764	9366862100000
58539	1397	1356751809000
58540	1678	15840600291000
58541	1397	1356741808000
58542	1678	15840600292000
58543	1726	663585704000
58544	1874	4886000
58545	1726	663584701000
58546	1874	4889000
58547	1670	12961021000000
58561	1448	4356711000001
58563	1397	1356711805000
58564	1678	15840600295000
58565	1397	1356701804000
58566	1678	15840600296000
58567	1693	860228406843
58568	1778	4450090000000
58569	1726	663581692000
58570	1874	4898000
58571	1726	663580689000
58572	1874	4901000
58573	1394	18720529000000
58588	1634	10992044641004
58589	1693	13080598207845
58590	1693	12964439292251
58591	1693	12848280376657
58592	1693	12732121461063
58593	1693	12615962545469
58594	1693	12499803629875
58595	1693	12383644714281
58596	1693	12267485798687
58597	1693	12151326883093
58598	1693	12035167967499
58599	1693	11919009051905
58600	1693	11802850136311
58601	1693	11686691220717
58602	1693	11570532305123
58603	1693	11454373389529
58604	1693	11338214473935
58605	1693	11222055558341
58606	1693	11105896642747
58607	1693	10989737727153
58608	1693	10873578811559
58609	1693	10757419895965
58610	1693	10641260980371
58611	1693	10525102064777
58612	1693	10408943149183
58613	1693	10292784233589
58614	1693	10176625317995
58615	1693	10173095653899
58616	1693	9103306366007
58617	1693	8987147450413
58618	1693	8870988534819
58619	1693	8754829619225
58620	1693	8638670703631
58621	1693	8522511788037
58622	1693	8406352872443
58623	1693	8290193956849
58624	1693	8174035041255
58625	1693	8057876125661
58626	1693	7941717210067
58627	1693	7825558294473
58628	1693	7709399378879
58629	1693	7593240463285
58630	1693	7477081547691
58631	1693	7360922632097
58632	1693	7244763716503
58633	1693	7241234052407
58634	1693	7125075136813
58635	1693	7008916221219
58636	1693	6892757305625
58637	1693	6776598390031
58638	1693	6660439474437
58639	1693	6544280558843
58640	1693	6428121643249
58641	1693	6311962727655
58642	1693	6299633903289
58643	1693	5414845078821
58644	1693	5298686163227
58645	1693	5182527247633
58646	1693	5066368332039
58647	1693	4950209416445
58648	1693	4834050500851
58649	1693	4717891585257
58650	1693	4601732669663
58651	1693	4485573754069
58652	1693	4369414838475
58653	1693	4253255922881
58654	1693	4137097007287
58655	1693	4020938091693
58656	1693	3904779176099
58657	1693	923734070939
58658	1693	920204406843
58659	1634	11712044641004
58660	1634	11713064641004
58698	1397	1356661800000
58699	1678	15840600300000
58700	1397	1356651799000
58701	1678	15840600301000
58702	1397	1356641798000
58703	1678	15840600302000
58704	1397	1356631797000
58705	1678	15840600303000
58706	1397	1356621796000
58707	1678	15840600304000
58708	1726	663576677000
58709	1874	4913000
58710	1726	663575674000
58711	1874	4916000
58712	1726	663574671000
58713	1874	4919000
58714	1726	663573668000
58715	1874	4922000
58716	1726	663572665000
58717	1874	4925000
58718	1675	8062095999977
58721	1397	1356611795000
58722	1678	15840600305000
58723	1726	663571662000
58724	1874	4928000
58725	414	66720000000000
58726	414	66720011000000
58763	1740	8441313000000
58764	1740	8441324000000
58765	1397	1356541788000
58766	1678	15840600312000
58767	1397	1356531787000
58768	1678	15840600313000
58769	1726	663565644000
58770	1874	4946000
58771	1726	663564641000
58772	1874	4949000
58773	1716	10126737000000
58802	1671	9408334530515
58803	1671	9408378530515
58833	1397	1356421776000
58834	1678	15840600324000
58835	1726	663553608000
58836	1874	4982000
58847	1703	5040650000000
58848	1703	5040672000000
58856	1623	49683112899898
58857	1693	4573925041255
58431	1535	720051000000
58433	1397	1356801814000
58434	1678	15840600286000
58435	1726	663590719000
58436	1874	4871000
58437	1980	14399175000000
58438	1980	14399186000000
58451	58	81066460999641
58452	58	81066482999641
58468	1693	16357331239447
58469	1693	16323532464009
58470	1693	16207373548415
58471	1693	14621847475715
58472	1693	13791009617299
58473	1693	13674850701705
58474	1693	13558691786111
58475	1693	13442532870517
58476	1693	13433723710256
58477	1693	13317564794662
58478	1693	13201405879068
58479	1693	13085246963474
58480	1693	12767441211605
58481	1693	12227474407868
58482	1693	12111315492274
58483	1693	11995156576680
58484	1693	11878997661086
58485	1693	11762838745492
58486	1693	11222871941755
58487	1693	11106713026161
58488	1693	10990554110567
58489	1693	10874395194973
58490	1693	10758236279379
58491	1693	10642077363785
58492	1693	10525918448191
58493	1693	10409759532597
58494	1693	10293600617003
58495	1693	10177441701409
58496	1693	10061282785815
58497	1693	9945123870221
58498	1693	9828964954627
58499	1693	9712806039033
58500	1693	9596647123439
58501	1693	9480488207845
58502	1693	9364329292251
58503	1693	9248170376657
58504	1693	9132011461063
58505	1693	9015852545469
58506	1693	8899693629875
58507	1693	8783534714281
58508	1693	8667375798687
58509	1693	8551216883093
58510	1693	8435057967499
58511	1693	8318899051905
58512	1693	8202740136311
58513	1693	8086581220717
58514	1693	7970422305123
58515	1693	7854263389529
58516	1693	7738104473935
58517	1693	7621945558341
58518	1693	7505786642747
58519	1693	7389627727153
58520	1693	7273468811559
58521	1693	7157309895965
58522	1693	7041150980371
58523	1693	6924992064777
58524	1693	6808833149183
58525	1693	6692674233589
58526	1693	6576515317995
58527	1693	6572985653899
58528	1693	5503196366007
58529	1693	5387037450413
58530	1693	5270878534819
58531	1693	5154719619225
58532	1693	5038560703631
58533	1693	4922401788037
58534	1693	4806242872443
58535	1693	4690083956849
58536	1764	9367771100000
58537	1791	1211000024
58538	1764	10087770100000
58548	1394	18720519000000
58574	1397	1356691803000
58575	1678	15840600297000
58576	1397	1356681802000
58577	1678	15840600298000
58578	1397	1356671801000
58579	1678	15840600299000
58580	1726	663579686000
58581	1874	4904000
58582	1726	663578683000
58583	1874	4907000
58584	1726	663577680000
58585	1874	4910000
58586	1684	12931380880623
58719	1547	9213309000000
58720	1547	9213364000000
58727	1397	1356601794000
58728	1678	15840600306000
58729	1726	663570659000
58730	1874	4931000
58731	1710	13194579473290
58734	1397	1356591793000
58735	1678	15840600307000
58736	1726	663569656000
58737	1874	4934000
58738	1657	8641316000000
58739	1657	8641327000000
58754	1397	1356551789000
58755	1678	15840600311000
58756	1726	663566647000
58757	1874	4943000
58758	58	81786482999641
58759	58	81786493999641
58774	1560	11394249277001
58775	1560	11394271277001
58778	1397	1356521786000
58779	1678	15840600314000
58780	1726	663563638000
58781	1874	4952000
58782	1608	11805582000000
58804	1395	57878090436533700
58805	1395	57878090480533700
58826	1397	1356431777000
58827	1678	15840600323000
58828	1726	663554611000
58829	1874	4979000
58830	1991	10555796441475
58831	1991	10555807441475
58849	1702	7200306000000
58850	1397	1356391773000
58851	1678	15840600327000
58852	1726	663550599000
58853	1874	4991000
58854	1394	20160529000000
58855	1394	20160540000000
58906	1397	1356351769000
58907	1678	15840600331000
58908	1726	663546587000
58909	1874	5003000
58910	1471	13579652900000
58928	1397	1356311765000
58929	1678	15840600335000
58930	1726	663542575000
58931	1874	5015000
58932	1656	11661485999990
58980	1394	23040584000000
59010	1397	1356171751000
59011	1678	15840600349000
59012	1726	663527530000
59013	1874	5060000
59014	1395	57878090447533700
59034	641	72819880000000
59063	1714	10246304103056
59119	471	66000100000000
59120	1455	6513946000000
59127	1397	1355961730000
59128	1678	15840600370000
59129	341	66000990000001
59130	1726	663506467000
59131	1874	5123000
59132	1729	16847148000000
59133	1729	16847169000000
59147	1397	1355931727000
59148	1678	15840600373000
59149	1397	1355921726000
59150	1678	15840600374000
59151	1726	663503458000
59152	1874	5132000
59153	1726	663502455000
59154	1874	5135000
59155	641	73539880000000
59156	641	73539902000000
59175	1656	12381485999990
59176	1656	12381496999990
59316	2087	1439046000000
59322	1397	1355651699000
59323	1678	15840600401000
59324	1426	12524929000000
59326	1637	174964829819988
59327	1637	174964840819988
59359	1637	174964873819988
59360	1397	1355581692000
59361	1678	15840600408000
59362	1726	663468353000
59363	1874	5237000
58664	1693	16061886475715
58665	1693	15231048617299
58666	1693	15114889701705
58667	1693	14998730786111
58668	1693	14882571870517
58669	1693	14873762710256
58670	1693	14757603794662
58671	1693	14641444879068
58672	1693	14525285963474
58673	1693	14207480211605
58674	1693	13667513407868
58675	1693	13551354492274
58676	1693	13435195576680
58677	1693	13319036661086
58678	1693	13202877745492
58679	1693	12662910941755
58680	1693	12546752026161
58681	1693	12430593110567
58682	1693	12314434194973
58683	1693	12198275279379
58684	1693	12082116363785
58685	1693	11965957448191
58686	1693	11849798532597
58687	1693	11733639617003
58688	1693	11617480701409
58689	1693	11501321785815
58690	1693	11385162870221
58691	1693	11269003954627
58692	1693	11152845039033
58693	1693	11036686123439
58694	1693	10920527207845
58695	1693	10804368292251
58696	1455	4354396000000
58697	1455	5074146000000
58732	554	66730000000000
58733	554	66730011000000
58740	1397	1356581792000
58741	1678	15840600308000
58742	1397	1356571791000
58743	1678	15840600309000
58744	1726	663568653000
58745	1874	4937000
58746	1726	663567650000
58747	1874	4940000
58748	1992	9359209990000
58749	1992	9359231990000
58760	1727	8826825000000
58783	1560	11394260277001
58837	1685	90001681571430
58891	1397	1356381772000
58892	1678	15840600328000
58893	1726	663549596000
58894	1874	4994000
58895	1637	172804797819988
58911	1397	1356341768000
58912	1678	15840600332000
58913	1726	663545584000
58914	1874	5006000
58915	1679	31067958652000
58933	1397	1356301764000
58934	1678	15840600336000
58935	1726	663541572000
58936	1874	5018000
58937	1684	13651380880623
58938	1684	13651391880623
58939	1397	1356291763000
58940	1678	15840600337000
58941	1726	663540569000
58942	1874	5021000
58943	1394	21600540000000
58944	1394	21600551000000
58960	1397	1356261760000
58961	1678	15840600340000
58962	1726	663536557000
58963	1874	5033000
58964	1394	23040551000000
58965	1394	23040562000000
58999	2087	1439035000000
59019	1679	31787958652000
59041	1759	10080702999999
59047	1397	1356101744000
59048	1678	15840600356000
59049	1726	663520509000
59050	1874	5081000
59051	1571	18000330001024
59052	1571	18000341001024
59064	1397	1356071741000
59065	1678	15840600359000
59066	1726	663517500000
59067	1874	5090000
59068	1610	8640268000000
59069	1610	8640279000000
59072	1397	1356061740000
59073	1678	15840600360000
59074	1726	663516497000
59075	1874	5093000
59076	1509	10031784851155
59077	1509	10031795851155
59093	1397	1356021736000
59094	1678	15840600364000
59095	1726	663512485000
59096	1874	5105000
59097	1394	24480562000000
59098	1394	24480573000000
59134	484	92640802000000
59141	1397	1355941728000
59142	1678	15840600372000
59143	1726	663504461000
59144	1874	5129000
59157	1397	1355911725000
59158	1678	15840600375000
59159	1397	1355901724000
59160	1678	15840600376000
59161	2085	980000000
59162	606	72137736812962
59163	1726	663501452000
59164	1874	5138000
59165	1726	663500449000
59166	1874	5141000
59167	1394	25920573000000
59168	1394	25920605000000
59186	1637	173524818819988
59188	1397	1355871721000
59189	1678	15840600379000
59190	1926	1194000000
59191	1726	663497440000
59192	1874	5150000
59193	1471	14299652900000
59194	1471	14299664900000
59203	1397	1355851719000
59204	1678	15840600381000
59205	1397	1355841718000
59206	1678	15840600382000
59207	1397	1355831717000
59208	1678	15840600383000
59209	1726	663496437000
59210	1874	5153000
59211	1726	663495434000
59212	1874	5156000
59213	1726	663494431000
59214	1874	5159000
59215	1726	663493428000
59216	1874	5162000
59217	1534	2880094000000
59218	1534	2880148000000
59219	1397	1355821716000
59220	1678	15840600384000
59221	1726	663492425000
59222	1874	5165000
59223	1394	27360605000000
59224	1394	27360616000000
59231	1397	1355801714000
59232	1678	15840600386000
59233	1726	663490419000
59234	1874	5171000
59235	1637	174244818819988
59236	1637	174244829819988
59253	1397	1355761710000
59254	1678	15840600390000
59255	1726	663486407000
59256	1874	5183000
59257	1671	10848400530515
59258	1671	10848411530515
59273	1397	1355731707000
59274	1678	15840600393000
59275	1397	1355721706000
59276	1678	15840600394000
59277	1726	663483398000
59278	1874	5192000
59279	1726	663482395000
59280	1874	5195000
59281	1691	10043090100019
59282	1691	10043112100019
59299	1397	1355681702000
59300	1678	15840600398000
59301	1726	663478383000
59302	1874	5207000
59303	1394	28800616000000
59304	1394	28800627000000
59328	1397	1355641698000
59329	1678	15840600402000
59330	1726	663474371000
59331	1874	5219000
59332	1394	30240627000000
59333	1394	30240638000000
58815	1678	15840600322000
58816	1726	663558623000
58817	1874	4967000
58818	1726	663557620000
58819	1874	4970000
58820	1726	663556617000
58821	1874	4973000
58822	1726	663555614000
58823	1874	4976000
58824	1675	8782095999977
58825	1675	8782139999977
58832	1739	24479716000000
58838	1397	1356411775000
58839	1678	15840600325000
58840	1397	1356401774000
58841	1678	15840600326000
58842	1726	663552605000
58843	1874	4985000
58844	1726	663551602000
58845	1874	4988000
58846	1534	2160094000000
58896	1397	1356371771000
58897	1678	15840600329000
58898	1397	1356361770000
58899	1678	15840600330000
58900	1726	663548593000
58901	1874	4997000
58902	1726	663547590000
58903	1874	5000000
58904	1700	8945886276737
58905	1700	8945908276737
58922	1397	1356321766000
58923	1678	15840600334000
58924	1726	663543578000
58925	1874	5012000
58926	633	78124040900000
58927	633	78124051900000
58945	1726	663539566000
58946	1874	5024000
58947	1688	93242390904000
58948	1688	93242391904000
58950	1397	1356281762000
58951	1678	15840600338000
58952	1726	663538563000
58953	1874	5027000
58954	1688	93242401904000
58966	1692	65542697019999
58981	1397	1356221756000
58982	1678	15840600344000
58983	1671	9408388530515
58984	1397	1356211755000
58985	1678	15840600345000
58986	1726	663532545000
58987	1874	5045000
58988	1726	663531542000
58989	1874	5048000
58990	1671	10128388530515
58991	1671	10128400530515
58992	1397	1356201754000
58993	1678	15840600346000
58994	1726	663530539000
58995	1874	5051000
58996	2086	1439036000000
59015	1397	1356161750000
59016	1678	15840600350000
59017	1726	663526527000
59018	1874	5063000
59020	1397	1356151749000
59021	1678	15840600351000
59022	1397	1356141748000
59023	1678	15840600352000
59024	1397	1356131747000
59025	1678	15840600353000
59026	1726	663525524000
59027	1874	5066000
59028	1726	663524521000
59029	1874	5069000
59030	1726	663523518000
59031	1874	5072000
59032	1402	42334297319298
59033	1402	42334330319298
59035	1397	1356121746000
59036	1678	15840600354000
59037	1726	663522515000
59038	1874	5075000
59039	1688	93962401904000
59040	1688	93962412904000
59053	1397	1356091743000
59054	1678	15840600357000
59055	1397	1356081742000
59056	1678	15840600358000
59057	1726	663519506000
59058	1874	5084000
59059	1726	663518503000
59060	1874	5087000
59061	1610	7920246000000
59062	1610	7920268000000
59070	1637	173524797819988
59071	1637	173524808819988
59078	1397	1356051739000
59079	1678	15840600361000
59080	1397	1356041738000
59081	1678	15840600362000
59082	1726	663515494000
59083	1874	5096000
59084	1726	663514491000
59085	1874	5099000
59086	1587	13680472000000
59099	1397	1356011735000
59100	1678	15840600365000
59101	1726	663511482000
59102	1874	5108000
59103	1668	12926655000000
59104	1668	12926666000000
59121	1397	1355971731000
59122	1678	15840600369000
59123	1726	663507470000
59124	1874	5120000
59125	1419	16299289280064
59126	1419	16299300280064
59169	1397	1355891723000
59170	1678	15840600377000
59171	1726	663499446000
59172	1874	5144000
59173	1723	14039402085979
59174	1723	14039413085979
59177	1397	1355881722000
59178	1678	15840600378000
59179	606	71037726812962
59180	2085	1100980000000
59181	1726	663498443000
59182	1874	5147000
59183	1717	8027932000023
59184	1717	8027953000023
59187	1764	9366861100000
59195	470	76080373000000
59225	1397	1355811715000
59226	1678	15840600385000
59227	1726	663491422000
59228	1874	5168000
59229	1693	1580228406843
59230	1693	1580239406843
59243	1397	1355781712000
59244	1678	15840600388000
59245	1397	1355771711000
59246	1678	15840600389000
59247	1726	663488413000
59248	1874	5177000
59249	1726	663487410000
59250	1874	5180000
59251	369	94800807000000
59252	369	94800829000000
59265	149	80670192000341
59266	149	80670203000341
59271	1685	90721681571430
59272	1685	90721682571430
59285	1397	1355711705000
59286	1678	15840600395000
59287	1397	1355701704000
59288	1678	15840600396000
59289	1397	1355691703000
59290	1678	15840600397000
59291	1726	663481392000
59292	1874	5198000
59293	1726	663480389000
59294	1874	5201000
59295	1726	663479386000
59296	1874	5204000
59297	632	96960859000000
59298	632	96960892000000
59315	2086	1439047000000
59317	2085	970000000
59318	1726	663475374000
59319	1874	5216000
59320	1602	8640398000000
59321	1602	8640492000000
59357	1756	4787788575609
59358	1756	4787832575609
59374	1397	1355561690000
59375	1678	15840600410000
59376	1726	663466347000
59377	1874	5243000
59378	42	87598262000000
59382	1397	1355551689000
59383	1678	15840600411000
58858	1693	4457766125661
58859	1693	4341607210067
58860	1693	4225448294473
58861	1693	4109289378879
58862	1693	3993130463285
58863	1693	3876971547691
58864	1693	3760812632097
58865	1693	3644653716503
58866	1693	3641124052407
58867	1693	3524965136813
58868	1693	3408806221219
58869	1693	3292647305625
58870	1693	3176488390031
58871	1693	3060329474437
58872	1693	2944170558843
58873	1693	2828011643249
58874	1693	2711852727655
58875	1693	2699523903289
58876	1693	1814735078821
58877	1693	1698576163227
58878	1693	1582417247633
58879	1693	1466258332039
58880	1693	1350099416445
58881	1693	1233940500851
58882	1693	1117781585257
58883	1693	1001622669663
58884	1693	885463754069
58885	1693	769304838475
58886	1693	653145922881
58887	1693	536987007287
58888	1623	50403112899898
58889	1571	50403662899882
58890	1623	16560317001040
58916	1397	1356331767000
58917	1678	15840600333000
58918	1726	663544581000
58919	1874	5009000
58920	1448	5076711000001
58921	1448	5076722000001
58949	1991	10555797441475
58955	1397	1356271761000
58956	1678	15840600339000
58957	1726	663537560000
58958	1874	5030000
58959	1419	15579289280064
58967	1397	1356251759000
58968	1678	15840600341000
58969	1397	1356241758000
58970	1678	15840600342000
58971	1397	1356231757000
58972	1678	15840600343000
58973	1726	663535554000
58974	1874	5036000
58975	1726	663534551000
58976	1874	5039000
58977	1726	663533548000
58978	1874	5042000
58979	1756	4067788575609
58997	1699	3669735750126
58998	1699	3669746750126
59000	1397	1356191753000
59001	1678	15840600347000
59002	1397	1356181752000
59003	1678	15840600348000
59004	1726	663529536000
59005	1874	5054000
59006	1726	663528533000
59007	1874	5057000
59008	1668	12206633000000
59009	1668	12206655000000
59042	1397	1356111745000
59043	1678	15840600355000
59044	1726	663521512000
59045	1874	5078000
59046	1711	11324545000000
59087	1397	1356031737000
59088	1678	15840600363000
59089	1726	663513488000
59090	1874	5102000
59091	1692	66262697019999
59092	1692	66262708019999
59105	1397	1356001734000
59106	1678	15840600366000
59107	1397	1355991733000
59108	1678	15840600367000
59109	1397	1355981732000
59110	1678	15840600368000
59111	1726	663510479000
59112	1874	5111000
59113	1726	663509476000
59114	1874	5114000
59115	1726	663508473000
59116	1874	5117000
59117	1395	57878810447533700
59118	1395	57878810480533700
59135	1397	1355951729000
59136	1678	15840600371000
59137	1726	663505464000
59138	1874	5126000
59139	1672	14401954000000
59140	1672	14401965000000
59145	1690	100803213000000
59146	1690	100803224000000
59185	1764	9366871100000
59196	2085	1100970000000
59197	1397	1355861720000
59198	1678	15840600380000
59199	1886	200000001
59200	1534	2880093999999
59201	1534	200000004
59202	1886	2880113999996
59237	1397	1355791713000
59238	1678	15840600387000
59239	1726	663489416000
59240	1874	5174000
59241	1587	14400472000000
59242	1587	14400483000000
59259	1397	1355751709000
59260	1678	15840600391000
59261	1726	663485404000
59262	1874	5186000
59263	1643	7776395113700
59264	1643	7776406113700
59267	1397	1355741708000
59268	1678	15840600392000
59269	1726	663484401000
59270	1874	5189000
59283	1395	57879530480533700
59284	1395	57879530502533700
59305	1397	1355671701000
59306	1678	15840600399000
59307	1397	1355661700000
59308	1678	15840600400000
59309	1726	663477380000
59310	1874	5210000
59311	1726	663476377000
59312	1874	5213000
59313	1699	4389746750126
59314	1699	4389768750126
59325	1602	8640409000000
59334	1397	1355631697000
59335	1678	15840600403000
59336	1726	663473368000
59337	1874	5222000
59338	1439	8932390998477
59339	1397	1355621696000
59340	1678	15840600404000
59341	1397	1355611695000
59342	1678	15840600405000
59343	1397	1355601694000
59344	1678	15840600406000
59345	1397	1355591693000
59346	1678	15840600407000
59347	1726	663472365000
59348	1874	5225000
59349	1726	663471362000
59350	1874	5228000
59351	1726	663470359000
59352	1874	5231000
59353	1726	663469356000
59354	1874	5234000
59355	1680	7209306500035
59356	1680	7209350500035
59372	1768	12110753110000
59373	1768	12110764110000
59438	289	66010000000000
59439	1419	17009330280064
59457	1689	9360195287625
59472	1395	57880250491533700
59473	1395	57880250502533700
59494	1633	7956415985638
59525	1397	1355341668000
59526	1678	15840600432000
59527	1726	663440275000
59528	1874	5315000
59529	1726	663439272000
59530	1874	5318000
59531	1394	36000707000000
59532	1394	36000719000000
59553	1727	8826868000000
59565	1397	1355301664000
59566	1678	15840600436000
59567	1726	659801253000
59568	1874	5337000
59569	1726	659800251000
59364	1970	199000000
59365	1991	11275797441475
59366	1991	11275809441475
59379	1508	12277027500009
59395	1394	31680638000000
59396	1394	31680671000000
59401	1397	1355511685000
59402	1678	15840600415000
59403	1726	663461332000
59404	1874	5258000
59405	1689	8640170287625
59406	1689	8640181287625
59409	1397	1355501684000
59410	1678	15840600416000
59411	1726	663460329000
59412	1874	5261000
59413	1395	57879530491533700
59414	1397	1355491683000
59415	1678	15840600417000
59416	1397	1355481682000
59417	1678	15840600418000
59418	1397	1355471681000
59419	1678	15840600419000
59420	1680	7209380500035
59421	1397	1355461680000
59422	1678	15840600420000
59423	1726	663459326000
59424	1874	5264000
59425	1726	663458323000
59426	1874	5267000
59427	1726	663457320000
59428	1874	5270000
59429	1726	663456317000
59430	1874	5273000
59431	1680	7929380500035
59432	1680	1405180000
59433	2067	7929382320042
59434	1527	269999980
59447	1527	263999986
59448	1689	9360180287626
59449	1689	1402590000
59450	2067	9360186697628
59451	1527	265999984
59454	1680	7929391500035
59458	1397	1355441678000
59459	1678	15840600422000
59460	1726	663454311000
59461	1874	5279000
59475	1394	34560682000000
59476	1394	34560693000000
59492	1688	94682412904000
59493	1688	94682465904000
59495	1397	1355381672000
59496	1678	15840600428000
59497	1726	663448293000
59498	1874	5297000
59499	1699	5109768750126
59500	1699	5109779750126
59515	1397	1355351669000
59516	1678	15840600431000
59517	1726	663443281000
59518	1874	5309000
59519	1726	663442280000
59520	1874	5310000
59521	1726	663441278000
59522	1874	5312000
59523	1680	8649391500035
59524	1680	8649404500035
59554	1397	1355311665000
59555	1678	15840600435000
59556	1726	659804261000
59557	1874	5329000
59558	395	66027932005524
59559	1760	501000000000
59560	1726	659803258000
59561	1874	5332000
59562	1726	659802256000
59563	1874	5334000
59564	1695	8972203000000
59574	1726	659799250000
59575	1874	5340000
59576	1726	659798247000
59577	1874	5343000
59578	1726	659797245000
59579	1874	5345000
59580	1726	659796244000
59581	1874	5346000
59582	1726	659795241000
59583	1874	5349000
59584	1726	659794239000
59585	1874	5351000
59586	1726	659793238000
59587	1874	5352000
59588	1726	659792235000
59589	1874	5355000
59590	1726	659791233000
59591	1874	5357000
59592	1726	659790232000
59593	1874	5358000
59594	1726	659789229000
59595	1874	5361000
59596	1726	659788227000
59597	1874	5363000
59598	1455	4353939000000
59633	1397	1355221656000
59634	1678	15840600444000
59635	1726	659778208000
59636	1874	5382000
59637	1726	659777205000
59638	1874	5385000
59639	1726	659776203000
59640	1874	5387000
59641	1395	57880970503533700
59642	1395	57880970516533700
59655	1397	1355201654000
59656	1678	15840600446000
59657	1397	1355191653000
59658	1678	15840600447000
59659	606	71037746812962
59660	1726	659772196000
59661	1874	5394000
59662	1726	659771193000
59663	1874	5397000
59664	1726	659770191000
59665	1874	5399000
59666	1726	659769190000
59667	1874	5400000
59668	1726	659768187000
59669	1874	5403000
59670	1726	659767185000
59671	1874	5405000
59672	606	71757746812962
59673	606	71757752812962
59687	576	1601300000
59688	1758	77315743038283
59689	416	66000020000000
59705	1397	1355151649000
59706	1678	15840600451000
59707	1726	659760173000
59708	1874	5417000
59709	1726	659759171000
59710	1874	5419000
59711	1726	659758168000
59712	1874	5422000
59713	1444	9935063159999
59717	1715	33120561000000
59718	1397	1355141648000
59719	1678	15840600452000
59720	1726	659757167000
59721	1874	5423000
59722	1726	659756165000
59723	1874	5425000
59724	1458	13053605908540
59725	1458	13053617908540
59741	1991	11995809441475
59742	1991	11995822441475
59754	1397	1355101644000
59755	1678	15840600456000
59756	1726	659748150000
59757	1874	5440000
59758	1726	658538150000
59759	2117	200000000
59760	1726	658537148000
59761	1874	5442000
59762	1673	16886323000000
59763	1673	16886345000000
59793	1397	1355031637000
59794	1678	15840600463000
59795	1726	658528127000
59796	1874	5463000
59797	1679	31787969652000
59800	1397	1355021636000
59801	1678	15840600464000
59802	1726	658527124000
59803	1874	5466000
59804	1726	658526121000
59805	1874	5469000
59806	1768	12830764110000
59807	1768	12830776110000
59832	1397	1354981632000
59833	1678	15840600468000
59834	1726	658522112000
59835	1874	5478000
59836	1690	102243246000000
59849	1397	1354951629000
59367	1397	1355571691000
59368	1678	15840600409000
59369	1726	663467350000
59370	1874	5240000
59371	1695	8972200000000
59380	1508	12996268500009
59381	1508	12996279500009
59407	1394	33120671000000
59408	1394	33120682000000
59435	1419	16299330280064
59436	1419	17019330280064
59437	1419	17019344280064
59440	1680	7929394500035
59452	1689	9360181287625
59453	1689	9360192287625
59455	1571	18720341001024
59456	1571	18720355001024
59468	1397	1355421676000
59469	1678	15840600424000
59470	1726	663452305000
59471	1874	5285000
59552	1422	7345027860211
59599	1397	1355291663000
59600	1678	15840600437000
59601	1397	1355281662000
59602	1678	15840600438000
59603	1397	1355271661000
59604	1678	15840600439000
59605	1397	1355261660000
59606	1678	15840600440000
59607	1397	1355251659000
59608	1678	15840600441000
59609	1397	1355241658000
59610	1678	15840600442000
59611	1726	659787226000
59612	1874	5364000
59613	1726	659786223000
59614	1874	5367000
59615	1726	659785221000
59616	1874	5369000
59617	1726	659784220000
59618	1874	5370000
59619	1726	659783217000
59620	1874	5373000
59621	1726	659782215000
59622	1874	5375000
59623	1688	94682478904000
59643	1394	37440719000000
59644	1394	37440732000000
59692	1397	1355171651000
59693	1678	15840600449000
59694	1726	659763178000
59695	1874	5412000
59696	1726	659762176000
59697	1874	5414000
59698	1549	14015760000000
59699	1549	14015772000000
59714	1455	5073939000000
59715	1455	5073952000000
59726	1397	1355131647000
59727	1678	15840600453000
59728	1726	659755163000
59729	1874	5427000
59730	1395	57880970514533700
59753	1679	31787971652000
59798	1394	41760813000000
59799	1394	41760824000000
59808	1637	175684842819988
59809	1637	175684854819988
59811	1397	1355011635000
59812	1678	15840600465000
59813	2114	1399000000
59814	1726	658525119000
59815	1874	5471000
59816	1522	8974113000000
59817	1522	8974125000000
59818	1397	1355001634000
59819	1678	15840600466000
59820	1723	14039412085979
59837	1397	1354971631000
59838	1678	15840600469000
59839	1726	658521109000
59840	1874	5481000
59854	1397	1354941628000
59855	1678	15840600472000
59856	1397	1354931627000
59857	1678	15840600473000
59858	1726	658518102000
59859	1874	5488000
59860	1726	658517099000
59861	1874	5491000
59862	1726	658516097000
59863	1874	5493000
59864	1678	16560600473000
59865	1678	16560623473000
59880	1637	175684853819988
59887	1474	9634463000023
59888	1474	9634474000023
59920	1397	1354841618000
59921	1678	16560623482000
59922	1726	658505077000
59923	1874	5513000
59924	1522	9694125000000
59925	1522	9694136000000
59940	1764	10086862100000
59941	1764	10086885100000
59942	1718	6066749763340
59962	1649	16124199999992
59963	1649	16124211999992
59976	1397	1354761610000
59977	1678	16560623490000
59978	1726	658494061000
59979	1874	5529000
60003	1397	1354721606000
60004	1678	16560623494000
60005	1693	2300249406843
60031	1397	1354681602000
60032	1678	16560623498000
60033	1726	657273045000
60034	1874	5545000
60035	2039	9361330000000
60036	2039	9361341000000
60067	1692	67702720019999
60068	1692	67702732019999
60073	1596	12240517000000
60074	1596	12240528000000
60087	1397	1354601594000
60088	1678	16560623506000
60089	2112	719010000000
60114	1690	102963258000000
60115	1397	1354571591000
60116	1678	16560623509000
60117	1594	13585218000000
60118	1726	657258024000
60119	1874	5566000
60120	1594	14305218000000
60121	1594	14305219000000
60144	1397	1354531587000
60145	1678	16560623513000
60146	1726	656043017000
60147	1874	5573000
60148	1726	656042015000
60149	1874	5575000
60162	1678	15840600474000
60163	1678	15840600475000
60164	1678	15840600476000
60165	1678	15840600477000
60166	1678	15840600478000
60167	1678	15840600479000
60168	1678	15840600480000
60169	1678	15840600481000
60170	1678	15840600482000
60171	1678	15840600483000
60172	1678	15840600484000
60173	1678	15840600485000
60174	1678	15840600486000
60175	1678	15840600487000
60176	1678	15840600488000
60177	1678	15840600489000
60178	1678	15840600490000
60179	1678	15840600491000
60180	1678	15840600492000
60181	1678	15840600493000
60182	1678	15840600494000
60183	1678	15840600495000
60184	1678	15840600496000
60185	1678	15840600497000
60186	1678	15840600498000
60187	1678	15840600499000
60188	1678	15840600500000
60189	1678	15840600501000
60190	1678	15840600502000
60191	1678	15840600503000
60192	1740	8442583000000
60199	369	96240841000000
60200	369	96240852000000
60228	1397	1354451579000
60229	1678	16560623521000
60230	1726	656033002000
60231	1874	5588000
60232	1688	96122502904000
60244	1394	44640835000000
60245	1394	44640847000000
60258	1397	1354401574000
60259	1678	16560623526000
59384	1397	1355541688000
59385	1678	15840600412000
59386	1397	1355531687000
59387	1678	15840600413000
59388	1726	663465344000
59389	1874	5246000
59390	1726	663464341000
59391	1874	5249000
59392	1726	663463338000
59393	1874	5252000
59394	1756	4787821575609
59397	1397	1355521686000
59398	1678	15840600414000
59399	1726	663462335000
59400	1874	5255000
59441	1397	1355451679000
59442	1678	15840600421000
59443	1726	663455314000
59444	1874	5276000
59445	1471	15019664900000
59446	1471	15019675900000
59462	1397	1355431677000
59463	1678	15840600423000
59464	1726	663453308000
59465	1874	5282000
59466	1690	101523224000000
59467	1690	101523235000000
59474	1685	90721692571430
59477	1705	7118473500145
59478	2115	1000000000
59479	1397	1355411675000
59480	1678	15840600425000
59481	1397	1355401674000
59482	1678	15840600426000
59483	1397	1355391673000
59484	1678	15840600427000
59485	1726	663451302000
59486	1874	5288000
59487	1726	663450299000
59488	1874	5291000
59489	1726	663449296000
59490	1874	5294000
59491	1467	3566607100039
59501	1397	1355371671000
59502	1678	15840600429000
59503	1397	1355361670000
59504	1678	15840600430000
59505	1726	663447290000
59506	1874	5300000
59507	1726	663446287000
59508	1874	5303000
59509	1726	663445286000
59510	1874	5304000
59511	1950	7169851000000
59512	1726	663444284000
59513	1874	5306000
59514	1394	34560707000000
59533	1726	662229272000
59534	2114	200000000
59535	1726	661019272000
59536	2116	200000000
59537	1397	1355331667000
59538	1678	15840600433000
59539	1397	1355321666000
59540	1678	15840600434000
59541	1726	661018269000
59542	1874	5321000
59543	1726	659808269000
59544	2114	1400000000
59545	1726	659807267000
59546	1874	5323000
59547	1726	659806264000
59548	1874	5326000
59549	1726	659805262000
59550	1874	5328000
59551	1688	94682466904000
59572	1690	102243235000000
59573	1690	102243247000000
59645	1397	1355211655000
59646	1678	15840600445000
59647	1726	659775202000
59648	1874	5388000
59649	1726	659774199000
59650	1874	5391000
59651	1726	659773197000
59652	1874	5393000
59653	1394	38880732000000
59654	1394	38880745000000
59678	1397	1355181652000
59679	1678	15840600448000
59680	1726	659766184000
59681	1874	5406000
59682	1726	659765181000
59683	1874	5409000
59684	1726	659764179000
59685	1874	5411000
59686	1637	174964842819988
59700	1397	1355161650000
59701	1678	15840600450000
59702	1726	659761174000
59703	1874	5416000
59704	1729	16847159000000
59716	1684	13651393880623
59731	1397	1355121646000
59732	1678	15840600454000
59733	1726	659754162000
59734	1874	5428000
59735	1726	659753160000
59736	1874	5430000
59737	1726	659752157000
59738	1874	5433000
59739	1688	95402478904000
59740	1688	95402491904000
59764	1397	1355091643000
59765	1678	15840600457000
59766	1397	1355081642000
59767	1678	15840600458000
59768	1397	1355071641000
59769	1678	15840600459000
59770	1397	1355061640000
59771	1678	15840600460000
59772	1397	1355051639000
59773	1678	15840600461000
59774	1397	1355041638000
59775	1678	15840600462000
59776	1726	658536147000
59777	1874	5443000
59778	1726	658535145000
59779	1874	5445000
59780	1726	658534144000
59781	1874	5446000
59782	1726	658533142000
59783	1874	5448000
59784	1726	658532139000
59785	1874	5451000
59786	1726	658531136000
59787	1874	5454000
59788	1726	658530133000
59789	1874	5457000
59790	1726	658529130000
59791	1874	5460000
59792	1394	40320813000000
59822	171	73910357524688
59823	171	73910367524688
59841	1397	1354961630000
59842	1678	15840600470000
59843	1726	658520107000
59844	1874	5483000
59845	1726	658519104000
59846	1874	5486000
59847	1395	57881690514533700
59848	1395	57881690526533700
59868	1711	12044545000000
59869	1711	12044568000000
59872	1395	57882410549533700
59873	1397	1354921626000
59874	1678	16560623474000
59875	1726	658515094000
59876	1874	5496000
59877	1719	7940360000000
59878	1719	7940371000000
59893	1397	1354891623000
59894	1678	16560623477000
59895	1397	1354881622000
59896	1678	16560623478000
59897	1397	1354871621000
59898	1678	16560623479000
59899	1397	1354861620000
59900	1678	16560623480000
59901	1397	1354851619000
59902	1678	16560623481000
59903	1726	658513090000
59904	1874	5500000
59905	1726	658512087000
59906	1874	5503000
59907	1726	658511086000
59908	1874	5504000
59909	1726	658510084000
59910	1874	5506000
59911	1726	658509083000
59912	1874	5507000
59913	1726	658508081000
59914	1874	5509000
59915	1726	658507080000
59916	1874	5510000
59570	1874	5339000
59571	1395	57880250503533700
59624	1397	1355231657000
59625	1678	15840600443000
59626	1726	659781214000
59627	1874	5376000
59628	1726	659780211000
59629	1874	5379000
59630	1726	659779209000
59631	1874	5381000
59632	1402	42334310319298
59674	1685	90001701571430
59675	1685	90721701571430
59676	1685	90721707571430
59677	576	77315739938284
59690	1394	40320745000000
59691	1394	40320758000000
59743	1397	1355111645000
59744	1678	15840600455000
59745	1726	659751156000
59746	1874	5434000
59747	1726	659750154000
59748	1874	5436000
59749	1726	659749151000
59750	1874	5439000
59751	1688	96122491904000
59752	1688	96122504904000
59810	1394	41760825000000
59821	1471	15019674900000
59824	1397	1354991633000
59825	1678	15840600467000
59826	1726	658524117000
59827	1874	5473000
59828	1726	658523114000
59829	1874	5476000
59830	1685	91441707571430
59831	1685	91441719571430
59853	1684	13651390880623
59866	1693	2300239406843
59867	1693	2300262406843
59871	1727	8826837000000
59980	1739	25199716000000
59981	1739	25199727000000
59988	1397	1354741608000
59989	1678	16560623492000
59990	1726	658492058000
59991	1874	5532000
59992	1726	658491057000
59993	1874	5533000
59994	1738	1438922000000
60006	1594	13585207000000
60009	1397	1354711605000
60010	1678	16560623495000
60011	1726	658488053000
60012	1874	5537000
60013	1726	658487051000
60014	1874	5539000
60015	1692	66982708019999
60016	1692	66982720019999
60037	1397	1354671601000
60038	1678	16560623499000
60039	1726	657272044000
60040	1874	5546000
60041	1587	15120483000000
60042	1587	15120494000000
60043	1397	1354661600000
60044	1678	16560623500000
60045	1726	657271042000
60046	1874	5548000
60047	1726	657270041000
60048	1874	5549000
60049	1426	12524930000000
60090	42	88318262000000
60091	42	88318272000000
60094	1633	7956372985638
60103	1397	1354581592000
60104	1678	16560623508000
60105	1726	657260027000
60106	1874	5563000
60107	1726	657259025000
60108	1874	5565000
60109	2112	719012000000
60122	1397	1354561590000
60123	1678	16560623510000
60124	1397	1354551589000
60125	1678	16560623511000
60126	1726	657257022000
60127	1874	5568000
60128	1726	657256021000
60129	1874	5569000
60130	1726	656046021000
60131	2119	200000000
60132	1673	17606345000000
60133	1673	17606377000000
60136	1397	1354541588000
60137	1678	16560623512000
60138	1726	656045019000
60139	1874	5571000
60140	1726	656044018000
60141	1874	5572000
60142	369	95520829000000
60143	369	95520841000000
60154	1397	1354511585000
60155	1678	16560623515000
60156	1726	656041014000
60157	1874	5576000
60158	1726	656040012000
60159	1874	5578000
60160	1690	102963268000000
60215	1397	1354471581000
60216	1678	16560623519000
60217	1726	656035005000
60218	1874	5585000
60220	1397	1354461580000
60221	1678	16560623520000
60222	1726	656034003000
60223	1874	5587000
60224	1395	57883850559533700
60225	1395	57883850570533700
60262	1397	1354391573000
60263	1678	16560623527000
60264	1726	656025991000
60265	1874	5599000
60266	1726	656024990000
60267	1874	5600000
60268	58	82506493999641
60269	58	82506505999641
60284	1756	4787799575609
60322	1397	1354301564000
60323	1678	16560623536000
60324	1726	656012973000
60325	1874	5617000
60326	1395	57885290582533700
60327	1395	57885290593533700
60344	1397	1354271561000
60345	1678	16560623539000
60346	1397	1354261560000
60347	1678	16560623540000
60348	1726	656008967000
60349	1874	5623000
60350	1726	656007965000
60351	1874	5625000
60352	1726	656006964000
60353	1874	5626000
60354	1448	5076734000001
60359	2086	2159037000000
60360	2086	2159047000000
60371	1690	102243256000000
60383	1611	23750934000000
60384	1611	23750945000000
60397	1634	11711735641004
60403	1402	43054310319298
60404	1687	9352704524804
60405	1687	9353086524804
60419	1394	48960869000000
60420	1394	48960890000000
60425	1444	9935061159999
60436	1671	11568411530515
60437	1671	11568442530515
60458	1711	12044555000000
60463	1397	1354091543000
60464	1678	16560623557000
60470	1397	1354071541000
60471	1678	16560623559000
60472	1726	655992938000
60473	1874	5652000
60474	1426	13244930000000
60475	1426	13244941000000
60501	1397	1354001534000
60502	1678	16560623566000
60503	1397	1353991533000
60504	1678	16560623567000
60505	1726	655988930000
60506	1874	5660000
60507	1695	9692203000000
60508	1695	9692224000000
60526	1397	1353951529000
60527	1678	16560623571000
60528	1726	655985924000
60529	1874	5666000
60530	1723	14759412085979
60531	1723	14759423085979
60544	1397	1353921526000
60545	1678	16560623574000
60546	1726	655983920000
59850	1678	15840600471000
59851	1395	57882410526533700
59852	1395	57882410536533700
59870	576	77315763938283
59879	1395	57882410537533700
59881	1397	1354911625000
59882	1678	16560623475000
59883	1726	658514092000
59884	1874	5498000
59885	526	68160052000000
59886	526	68160063000000
59889	1397	1354901624000
59890	1678	16560623476000
59891	633	78844051900000
59892	633	78844061900000
59928	1397	1354831617000
59929	1678	16560623483000
59930	1397	1354821616000
59931	1678	16560623484000
59932	1726	658504076000
59933	1874	5514000
59934	1726	658503074000
59935	1874	5516000
59936	1726	658502073000
59937	1874	5517000
59938	1610	9360279000000
59939	1610	9360302000000
59955	1397	1354791613000
59956	1678	16560623487000
59957	1726	658499068000
59958	1874	5522000
59959	1726	658498067000
59960	1874	5523000
59961	1991	11995821441475
59964	1708	7235744000021
59982	1397	1354751609000
59983	1678	16560623491000
59984	1726	658493060000
59985	1874	5530000
59986	1602	9360409000000
59987	1602	9360420000000
60059	1397	1354631597000
60060	1678	16560623503000
60061	1726	657267037000
60062	1874	5553000
60063	1726	657266035000
60064	1874	5555000
60065	1440	7199109000000
60066	1440	7199121000000
60069	1397	1354621596000
60070	1678	16560623504000
60071	1726	657265034000
60072	1874	5556000
60077	2106	1439011000000
60078	2106	1439022000000
60112	1992	10079231990000
60113	1992	10079243990000
60161	1740	8441335000000
60193	1397	1354501584000
60194	1678	16560623516000
60195	1726	656039011000
60196	1874	5579000
60197	1698	9896966550035
60198	1698	9896977550035
60213	1700	9665908276737
60214	1700	9665931276737
60237	1397	1354431577000
60238	1678	16560623523000
60239	1726	656030999000
60240	1874	5591000
60241	1726	656029997000
60242	1874	5593000
60243	1980	14399187000000
60270	1397	1354381572000
60271	1678	16560623528000
60272	1726	656023989000
60273	1874	5601000
60274	1726	656022987000
60275	1874	5603000
60276	1699	5829779750126
60277	1699	5829791750126
60307	1633	8676372985638
60308	1633	8676418985638
60312	1397	1354311565000
60313	1678	16560623535000
60314	1726	656014976000
60315	1874	5614000
60316	1726	656013974000
60317	1874	5616000
60318	1688	96842502904000
60319	1688	96842514904000
60343	1593	12070182000000
60355	2106	1439034000000
60375	1692	66982730019999
60376	1692	67702730019999
60377	1397	1354231557000
60378	1678	16560623543000
60379	1726	656003960000
60380	1874	5630000
60381	1394	47520858000000
60382	1394	47520869000000
60385	1397	1354221556000
60386	1678	16560623544000
60387	1726	656002958000
60388	1874	5632000
60389	43	77520778890000
60390	43	77520789890000
60401	1685	93601788571430
60402	1685	93601798571430
60435	2086	2159068000000
60448	1397	1354111545000
60449	1678	16560623555000
60450	1726	655995944000
60451	1874	5646000
60452	1717	8027943000023
60455	1397	1354101544000
60456	1678	16560623556000
60457	1727	8826824000000
60465	1397	1354081542000
60466	1678	16560623558000
60467	1726	655993940000
60468	1874	5650000
60469	1696	9137295840000
60479	1397	1354051539000
60480	1678	16560623561000
60481	1397	1354041538000
60482	1678	16560623562000
60483	1397	1354031537000
60484	1678	16560623563000
60485	1726	655991936000
60486	1874	5654000
60487	1726	655990934000
60488	1874	5656000
60489	1715	33120580000000
60522	1397	1353961530000
60523	1678	16560623570000
60524	1705	7838473500145
60525	1705	7838483500145
60549	1395	57887450635533700
60555	1654	14688121999798
60556	1654	14688122999798
60563	1397	1353911525000
60564	1678	16560623575000
60565	1726	655980914000
60566	1874	5676000
60567	1455	6513964000000
60568	1455	6513975000000
60578	1397	1353881522000
60579	1678	16560623578000
60580	1402	43054321319298
60581	1402	43774321319298
60621	1397	1353821516000
60622	1678	16560623584000
60623	1726	652342901000
60624	1874	5689000
60625	1726	652341900000
60626	1874	5690000
60627	1764	10086874100000
60651	1397	1353771511000
60652	1678	16560623589000
60653	1726	652336892000
60654	1874	5698000
60655	1681	10583194759830
60656	1681	10583205759830
60679	1397	1353721506000
60680	1678	16560623594000
60681	1726	652333886000
60682	1874	5704000
60683	1692	69142741019999
60684	1692	69142752019999
60702	1397	1353671501000
60703	1678	16560623599000
60704	1726	652330880000
60705	1874	5710000
60706	1649	16844211999992
60707	1649	16844222999992
60721	1467	5006649100039
60739	1397	1353601494000
60740	1678	16560623606000
60741	1696	9857295840000
60742	1696	9857305840000
60745	1394	54720901000000
60746	1394	54720911000000
60753	606	71757726812962
60754	606	71757737812962
59917	1726	658506079000
59918	1874	5511000
59919	1611	23030934000000
59926	171	74630367524688
59927	171	74630378524688
59943	1397	1354811615000
59944	1678	16560623485000
59945	1726	658501071000
59946	1874	5519000
59947	1726	658500070000
59948	1874	5520000
59949	1476	10080155000000
59950	1476	10080167000000
59951	1397	1354801614000
59952	1678	16560623486000
59953	1672	15121965000000
59954	1672	15121975000000
59965	1397	1354781612000
59966	1678	16560623488000
59967	1397	1354771611000
59968	1678	16560623489000
59969	1726	658497066000
59970	1874	5524000
59971	1726	658496064000
59972	1874	5526000
59973	1726	658495063000
59974	1874	5527000
59975	1547	9213332000000
59995	1397	1354731607000
59996	1678	16560623493000
59997	1726	658490055000
59998	1874	5535000
59999	1726	658489054000
60000	1874	5536000
60001	1759	10800702999999
60002	1759	10800714999999
60007	1690	102963246000000
60008	1690	102963256000000
60017	1397	1354701604000
60018	1678	16560623496000
60019	1397	1354691603000
60020	1678	16560623497000
60021	1726	658486050000
60022	1874	5540000
60023	1726	658485048000
60024	1874	5542000
60025	1726	657275048000
60026	2118	200000000
60027	1726	657274047000
60028	1874	5543000
60029	1613	10727868600000
60030	1613	10727901600000
60050	1397	1354651599000
60051	1678	16560623501000
60052	1397	1354641598000
60053	1678	16560623502000
60054	1726	657269040000
60055	1874	5550000
60056	1726	657268038000
60057	1874	5552000
60058	1395	57882410548533700
60075	1395	57883130548533700
60076	1395	57883130559533700
60079	1397	1354611595000
60080	1678	16560623505000
60081	1726	657264032000
60082	1874	5558000
60083	1726	657263031000
60084	1874	5559000
60085	1729	17567159000000
60086	1729	17567171000000
60092	2039	10081341000000
60093	2039	10081351000000
60095	1397	1354591593000
60096	1678	16560623507000
60097	1726	657262029000
60098	1874	5561000
60099	1726	657261028000
60100	1874	5562000
60101	1672	15841975000000
60102	1672	15841987000000
60110	1672	16561987000000
60111	1672	16561999000000
60134	1440	7919121000000
60135	1440	7919153000000
60150	1397	1354521586000
60151	1678	16560623514000
60152	1709	7200071999976
60153	1709	7200081999976
60201	1397	1354491583000
60202	1678	16560623517000
60203	1397	1354481582000
60204	1678	16560623518000
60205	1726	656038009000
60206	1874	5581000
60207	1726	656037008000
60208	1874	5582000
60209	1726	656036006000
60210	1874	5584000
60211	1394	43200824000000
60212	1394	43200847000000
60219	1394	43200835000000
60226	171	75350378524688
60227	171	75350389524688
60233	1397	1354441578000
60234	1678	16560623522000
60235	1726	656032000000
60236	1874	5590000
60246	1397	1354421576000
60247	1678	16560623524000
60248	1397	1354411575000
60249	1678	16560623525000
60250	1726	656028996000
60251	1874	5594000
60252	1726	656027994000
60253	1874	5596000
60254	1726	656026993000
60255	1874	5597000
60256	1685	92161719571430
60257	1685	92161742571430
60285	1397	1354361570000
60286	1678	16560623530000
60287	1397	1354351569000
60288	1678	16560623531000
60289	1397	1354341568000
60290	1678	16560623532000
60291	1397	1354331567000
60292	1678	16560623533000
60293	1726	656020984000
60294	1874	5606000
60295	1726	656019983000
60296	1874	5607000
60297	1726	656018981000
60298	1874	5609000
60299	1726	656017980000
60300	1874	5610000
60301	1726	656016978000
60302	1874	5612000
60303	1726	656015977000
60304	1874	5613000
60305	1685	92881742571430
60306	1685	92881788571430
60309	1397	1354321566000
60310	1678	16560623534000
60311	1681	9863194759830
60320	1395	57884570570533700
60321	1395	57884570582533700
60328	1397	1354291563000
60329	1678	16560623537000
60330	1726	656011971000
60331	1874	5619000
60332	1726	656010970000
60333	1874	5620000
60334	369	96240853000000
60337	1397	1354281562000
60338	1678	16560623538000
60339	1726	656009968000
60340	1874	5622000
60341	1394	46080847000000
60342	1394	46080858000000
60361	2087	1439034000000
60372	1395	57885290603533700
60373	1395	57886010603533700
60374	1395	57886010605533700
60398	1397	1354201554000
60399	1678	16560623546000
60400	1457	12144290040000
60406	1397	1354191553000
60407	1678	16560623547000
60408	1726	656000954000
60409	1874	5636000
60410	1687	9352715524804
60426	1397	1354151549000
60427	1678	16560623551000
60428	1397	1354141548000
60429	1678	16560623552000
60430	1397	1354131547000
60431	1678	16560623553000
60432	1726	655997948000
60433	1874	5642000
60434	1699	5829810750126
60438	632	97680892000000
60439	632	97680923000000
60446	1768	13550776110000
60447	1768	13550787110000
60260	43	76800768890000
60261	43	76800778890000
60278	1397	1354371571000
60279	1678	16560623529000
60280	1726	656021986000
60281	1874	5604000
60282	1679	32507969652000
60283	1679	32507980652000
60335	1593	12069967000000
60336	1593	12069990000000
60356	1397	1354251559000
60357	1678	16560623541000
60358	1699	5829789750126
60362	1397	1354241558000
60363	1678	16560623542000
60364	1455	5073962000000
60365	1726	656005963000
60366	1874	5627000
60367	1726	656004961000
60368	1874	5629000
60369	1455	5793962000000
60370	1455	5793964000000
60391	1397	1354211555000
60392	1678	16560623545000
60393	1726	656001956000
60394	1874	5634000
60395	1675	9502139999977
60396	1675	9502150999977
60411	1397	1354181552000
60412	1678	16560623548000
60413	1397	1354171551000
60414	1678	16560623549000
60415	1726	655999952000
60416	1874	5638000
60417	1395	57886010593533700
60418	1395	57886010614533700
60421	1397	1354161550000
60422	1678	16560623550000
60423	1726	655998950000
60424	1874	5640000
60440	2087	1439055000000
60441	1397	1354121546000
60442	1678	16560623554000
60443	1726	655996946000
60444	1874	5644000
60445	1688	96842513904000
60453	633	79564061900000
60454	633	79564072900000
60460	1726	655994942000
60461	1874	5648000
60462	1402	43054311319298
60490	1756	5507799575609
60491	1756	5507831575609
60493	1397	1354021536000
60494	1678	16560623564000
60495	1397	1354011535000
60496	1678	16560623565000
60497	1726	655989932000
60498	1874	5658000
60499	1467	4286607100039
60500	1467	4286628100039
60511	1397	1353981532000
60512	1678	16560623568000
60513	1726	655987928000
60514	1874	5662000
60515	1394	48960880000000
60533	1397	1353941528000
60534	1678	16560623572000
60535	1467	5006628100039
60536	1467	5006638100039
60539	1397	1353931527000
60540	1678	16560623573000
60541	1726	655984922000
60542	1874	5668000
60543	1610	9360290000000
60550	1526	720000000000
60557	1463	720001000000
60558	1394	51840890000000
60582	1397	1353871521000
60583	1678	16560623579000
60584	1726	655978910000
60585	1874	5680000
60586	1692	68422730019999
60587	1692	68422741019999
60602	1759	11520714999999
60603	1759	11520756999999
60605	1397	1353851519000
60606	1678	16560623581000
60607	1726	652345906000
60608	1874	5684000
60609	1679	33227990652000
60610	1679	33228001652000
60636	1397	1353801514000
60637	1678	16560623586000
60638	1426	13964941000000
60639	1426	13964951000000
60657	1711	12764555000000
60658	1711	12764566000000
60666	1397	1353751509000
60667	1678	16560623591000
60668	2086	2879068000000
60669	2086	2879078000000
60696	1419	17019300280064
60697	1419	17019332280064
60708	1397	1353661500000
60709	1678	16560623600000
60710	1726	652329878000
60711	1874	5712000
60712	1708	7235743000021
60732	1402	44494321319298
60733	1402	44494332319298
60743	1668	13646666000000
60744	1668	13646676000000
60800	526	67440075000000
60801	526	68160075000000
60802	526	68160076000000
60806	1686	7411907550062
60815	1601	4970160600000
60821	171	76070388524688
60822	171	76070399524688
60837	484	93360802000000
60838	484	93360814000000
60849	1602	10080420000000
60850	1602	10080520000000
60854	1675	9502149999977
60878	1688	96842515904000
60883	1509	10751795851155
60884	1509	10751808851155
60887	1397	1353421476000
60888	1678	16560623624000
60889	1698	10616977550035
60890	1698	10616987550035
60926	1271	1344126353000000
60941	1719	8660371000000
60942	1719	8660382000000
60945	1397	1353341468000
60946	1678	16560623632000
60947	1637	177124865819988
60948	1637	177124875819988
60949	1397	1353331467000
60950	1678	16560623633000
60951	1397	1353321466000
60952	1678	16560623634000
60953	1397	1353311465000
60954	1678	16560623635000
60955	2125	190000000
60956	2125	180000000
60957	2125	170000000
60958	1726	647455825000
60959	1874	5765000
60960	1726	647454823000
60961	1874	5767000
60962	1726	647453822000
60963	1874	5768000
60964	1726	647452820000
60965	1874	5770000
60966	1726	647451819000
60967	1874	5771000
60968	1395	57888890731533700
60970	1397	1353301464000
60971	1678	16560623636000
60972	1726	647450817000
60973	1874	5773000
60974	1593	12069978000000
60993	606	71758336812962
60994	606	72478336812962
60995	606	72478395812962
61002	1679	34668013652000
61003	1679	34668024652000
61018	1397	1353231457000
61019	1678	16560623643000
61020	1726	647441804000
61021	1874	5786000
61022	1726	647440803000
61023	1874	5787000
61024	1534	5040181000000
61025	1534	5040193000000
61027	733	2720002000000
61030	641	74259914000000
61053	1397	1353181452000
61054	1678	16560623648000
61055	1726	647434794000
61056	1874	5796000
61057	1547	9933332000000
61058	1547	9933343000000
60459	1489	7823909000000
60476	1397	1354061540000
60477	1678	16560623560000
60478	1710	13194578473290
60492	1685	93601820571430
60509	1395	57886730614533700
60510	1395	57886730635533700
60516	1397	1353971531000
60517	1678	16560623569000
60518	1726	655986926000
60519	1874	5664000
60520	1643	8496406113700
60521	1643	8496417113700
60532	42	88318273000000
60537	1394	50400880000000
60538	1394	50400890000000
60551	1726	655982918000
60552	1874	5672000
60553	1476	10800167000000
60554	1476	10800168000000
60571	1397	1353901524000
60572	1678	16560623576000
60573	1397	1353891523000
60574	1678	16560623577000
60575	1726	655979912000
60576	1874	5678000
60577	1679	32507990652000
60588	1397	1353861520000
60589	1678	16560623580000
60590	1726	655977909000
60591	1874	5681000
60592	1726	654767909000
60593	2120	200000000
60594	1726	653557909000
60595	2121	200000000
60596	1726	652347909000
60597	2122	200000000
60598	1726	652346907000
60599	1874	5683000
60600	1599	9699787393047
60601	1599	9699840393047
60611	1397	1353841518000
60612	1678	16560623582000
60613	1397	1353831517000
60614	1678	16560623583000
60615	1726	652344904000
60616	1874	5686000
60617	1726	652343903000
60618	1874	5687000
60619	1534	3600148000000
60620	1534	3600170000000
60628	1397	1353811515000
60629	1678	16560623585000
60630	1726	652340899000
60631	1874	5691000
60632	1726	652339897000
60633	1874	5693000
60634	1657	9361327000000
60635	1657	9361339000000
60648	1397	1353781512000
60649	1678	16560623588000
60650	1395	57887450645533700
60670	1739	25199726000000
60685	1397	1353711505000
60686	1678	16560623595000
60687	1397	1353701504000
60688	1678	16560623596000
60689	1397	1353691503000
60690	1678	16560623597000
60691	1726	652332884000
60692	1874	5706000
60693	1726	652331882000
60694	1874	5708000
60695	1489	7823931000000
60722	1764	10806862100000
60726	1397	1353621496000
60727	1678	16560623604000
60728	1726	652327874000
60729	1874	5716000
60730	1444	10655061159999
60731	1444	10655072159999
60734	1397	1353611495000
60735	1678	16560623605000
60736	1726	652326872000
60737	1874	5718000
60738	1759	11520725999999
60772	1397	1353551489000
60773	1678	16560623611000
60774	1397	1353541488000
60775	1678	16560623612000
60776	1397	1353531487000
60777	1678	16560623613000
60778	1726	651111864000
60779	1874	5726000
60780	1726	651110862000
60781	1874	5728000
60782	1726	651109861000
60783	1874	5729000
60784	632	97680925000000
60807	1397	1353501484000
60808	1678	16560623616000
60809	1726	651104854000
60810	1874	5736000
60811	1601	4970159600000
60812	1420	4970167620000
60813	1601	1434941200000
60814	2116	201000000
60816	1397	1353491483000
60817	1678	16560623617000
60818	1726	651103852000
60819	1874	5738000
60820	1394	54720912000000
60829	1397	1353471481000
60830	1678	16560623619000
60831	1726	651101849000
60832	1874	5741000
60833	1726	651100848000
60834	1874	5742000
60835	1394	56160912000000
60836	1394	56160924000000
60857	1397	1353441478000
60858	1678	16560623622000
60859	1726	651097844000
60860	1874	5746000
60861	1726	651096842000
60862	1874	5748000
60863	1394	59041036000000
60864	1394	59041048000000
60876	1395	57888890666533700
60877	1395	57888890679533700
60893	1397	1353411475000
60894	1678	16560623625000
60895	1726	651092836000
60896	1874	5754000
60897	1726	651091835000
60898	1874	5755000
60899	1700	10385931276737
60900	1700	10385943276737
60903	1397	1353401474000
60904	1678	16560623626000
60905	1726	651090834000
60906	1874	5756000
60907	1726	651089832000
60908	1874	5758000
60909	1587	15120495000000
60935	1560	11394270277001
60980	1397	1353281462000
60981	1678	16560623638000
60982	1726	647448815000
60983	1874	5775000
60984	1726	647447813000
60985	1874	5777000
60986	369	96960853000000
60987	369	96960865000000
61017	1991	11995820441475
61040	1471	15019686900000
61068	1394	60481047000000
61069	1394	60481058000000
61102	1397	1353111445000
61103	1678	16560623655000
61104	1726	647425781000
61105	1874	5809000
61106	1726	647424780000
61107	1874	5810000
61108	1394	60481059000000
61111	1685	95041863571430
61112	1685	95041875571430
61117	1729	18287181000000
61140	1536	13680702999959
61141	1536	13680713999959
61154	1397	1353041438000
61155	1678	16560623662000
61156	1397	1353031437000
61157	1678	16560623663000
61158	1397	1353021436000
61159	1678	16560623664000
61160	1726	647416768000
61161	1874	5822000
61162	1726	647415767000
61163	1874	5823000
61164	1726	647414765000
61165	1874	5825000
61166	1726	647413764000
61167	1874	5826000
61168	1673	19766399000000
60547	1874	5670000
60548	1709	7200082999976
60559	1726	655981916000
60560	1874	5674000
60561	1656	13101496999990
60562	1656	13101497999990
60569	1394	53280890000000
60570	1394	53280901000000
60604	1599	9699829393047
60640	1397	1353791513000
60641	1678	16560623587000
60642	1726	652338896000
60643	1874	5694000
60644	1726	652337894000
60645	1874	5696000
60646	1679	33948001652000
60647	1679	33948013652000
60659	1559	8602682000000
60660	1397	1353761510000
60661	1678	16560623590000
60662	1726	652335890000
60663	1874	5700000
60664	1637	176404854819988
60665	1637	176404865819988
60671	1397	1353741508000
60672	1678	16560623592000
60673	1397	1353731507000
60674	1678	16560623593000
60675	1726	652334888000
60676	1874	5702000
60677	1716	10846726000000
60678	1716	10846747000000
60698	1397	1353681502000
60699	1678	16560623598000
60700	1673	18326377000000
60701	1673	18326387000000
60713	1397	1353651499000
60714	1678	16560623601000
60715	1397	1353641498000
60716	1678	16560623602000
60717	1726	652328876000
60718	1874	5714000
60719	1395	57888170645533700
60720	1395	57888170666533700
60723	1397	1353631497000
60724	1678	16560623603000
60725	171	75350388524688
60747	1397	1353591493000
60748	1678	16560623607000
60749	1726	652325870000
60750	1874	5720000
60751	1522	10414136000000
60752	1522	10414147000000
60755	606	71757896812962
60756	1397	1353581492000
60757	1678	16560623608000
60758	1397	1353571491000
60759	1678	16560623609000
60760	1397	1353561490000
60761	1678	16560623610000
60762	1726	652324868000
60763	1874	5722000
60764	1726	652323867000
60765	1874	5723000
60766	1726	651113867000
60767	2123	200000000
60768	1726	651112865000
60769	1874	5725000
60770	1685	94321820571430
60771	1685	94321863571430
60823	1397	1353481482000
60824	1678	16560623618000
60825	1726	651102851000
60826	1874	5739000
60827	1534	4320170000000
60828	1534	4320181000000
60865	1749	3125105000000
60866	1749	3125117000000
60901	2039	10801351000000
60902	2039	10801363000000
60910	2112	1439012000000
60911	2112	1439024000000
60927	1397	1353371471000
60928	1678	16560623629000
60929	1397	1353361470000
60930	1678	16560623630000
60931	1726	647457828000
60932	1874	5762000
60933	1693	3020249406843
60934	1693	3020270406843
60936	1394	59041057000000
60975	1397	1353291463000
60976	1678	16560623637000
60977	1726	647449816000
60978	1874	5774000
60979	1395	57888890677533700
60988	1509	10751807851155
61004	1397	1353251459000
61005	1678	16560623641000
61006	1726	647444809000
61007	1874	5781000
61008	1726	647443807000
61009	1874	5783000
61010	1395	57889610677533700
61011	1395	57889610689533700
61012	1397	1353241458000
61013	1678	16560623642000
61014	1726	647442806000
61015	1874	5784000
61016	1395	57889610688533700
61026	733	2720012000000
61031	1397	1353221456000
61032	1678	16560623644000
61033	1397	1353211455000
61034	1678	16560623645000
61035	1726	647439802000
61036	1874	5788000
61037	1726	647438800000
61038	1874	5790000
61039	1395	57889610699533700
61041	1397	1353201454000
61042	1678	16560623646000
61043	1726	647437799000
61044	1874	5791000
61045	1726	647436797000
61046	1874	5793000
61062	1397	1353171451000
61063	1678	16560623649000
61064	1726	647433793000
61065	1874	5797000
61066	1693	3740270406843
61067	1693	3740281406843
61082	1397	1353141448000
61083	1678	16560623652000
61084	1397	1353131447000
61085	1678	16560623653000
61086	1726	647429787000
61087	1874	5803000
61088	1726	647428786000
61089	1874	5804000
61090	1726	647427784000
61091	1874	5806000
61092	2086	2879091000000
61094	2087	1439047000000
61096	1397	1353121446000
61097	1678	16560623654000
61098	1726	647426783000
61099	1874	5807000
61100	1613	11447912600000
61101	1633	8676383985638
61119	1397	1353091443000
61120	1678	16560623657000
61121	1726	647423778000
61122	1874	5812000
61123	1726	647422777000
61124	1874	5813000
61125	1698	10616989550035
61148	1397	1353051439000
61149	1678	16560623661000
61150	1726	647417770000
61151	1874	5820000
61152	1688	98282524904000
61153	1688	98282535904000
61176	1397	1353001434000
61177	1678	16560623666000
61178	1726	647410760000
61179	1874	5830000
61180	1690	102963257000000
61195	1397	1352971431000
61196	1678	16560623669000
61197	1726	647406754000
61198	1874	5836000
61217	1397	1352931427000
61218	1678	16560623673000
61219	1726	647401747000
61220	1874	5843000
61221	1726	647400745000
61222	1874	5845000
61223	1541	722036000000
61224	1541	722048000000
61227	1397	1352921426000
61228	1678	16560623674000
61229	1726	647399744000
61230	1874	5846000
61231	1762	14001930994000
60785	1397	1353521486000
60786	1678	16560623614000
60787	1397	1353511485000
60788	1678	16560623615000
60789	1726	651108860000
60790	1874	5730000
60791	1726	651107858000
60792	1874	5732000
60793	1726	651106857000
60794	1874	5733000
60795	1394	53280924000000
60796	1726	651105855000
60797	1874	5735000
60798	1394	54720924000000
60799	1394	54720925000000
60803	1474	9634497000023
60804	1474	10354497000023
60805	1474	10354498000023
60839	1598	2579980000000
60840	2124	299000000000
60841	1397	1353461480000
60842	1678	16560623620000
60843	1726	651099847000
60844	1874	5743000
60845	1726	651098845000
60846	1874	5745000
60847	1394	57600924000000
60848	1394	57601036000000
60851	1397	1353451479000
60852	1678	16560623621000
60853	1602	10080430000000
60855	1692	69862752019999
60856	1692	69862762019999
60867	1397	1353431477000
60868	1678	16560623623000
60869	1726	651095841000
60870	1874	5749000
60871	1726	651094839000
60872	1874	5751000
60873	1726	651093838000
60874	1874	5752000
60875	1455	6513977000000
60879	1610	10080290000000
60880	1610	10080303000000
60881	1729	18287171000000
60882	1729	18287184000000
60885	632	98400925000000
60886	632	98400938000000
60891	1611	24470945000000
60892	1611	24470955000000
60912	1726	649879832000
60913	2125	200000000
60914	1397	1353391473000
60915	1678	16560623627000
60916	1397	1353381472000
60917	1678	16560623628000
60918	1726	648669832000
60919	2126	200000000
60920	1726	647459832000
60921	2123	1400000000
60922	1726	647458830000
60923	1874	5760000
60924	1613	11447901600000
60925	1613	11447952600000
60937	1397	1353351469000
60938	1678	16560623631000
60939	1726	647456826000
60940	1874	5764000
60943	641	74259902000000
60944	641	74259913000000
60969	1402	44494386319298
60989	1397	1353271461000
60990	1678	16560623639000
60991	1726	647446812000
60992	1874	5778000
60996	1397	1353261460000
60997	1678	16560623640000
60998	1726	647445810000
60999	1874	5780000
61000	1457	12864290040000
61001	1457	12864301040000
61028	1673	19046387000000
61029	1673	19046399000000
61047	1397	1353191453000
61048	1678	16560623647000
61049	1726	647435796000
61050	1874	5794000
61051	1710	13914578473290
61052	1710	13914589473290
61059	1394	59041047000000
61093	1699	5829802750126
61095	1692	69862775019999
61109	1489	8543931000000
61110	1489	8543943000000
61126	1397	1353081442000
61127	1678	16560623658000
61128	1726	647421776000
61129	1874	5814000
61130	1726	647420774000
61131	1874	5816000
61132	1536	12960690999959
61133	1536	12960702999959
61170	1397	1353011435000
61171	1678	16560623665000
61172	1726	647412763000
61173	1874	5827000
61174	1726	647411761000
61175	1874	5829000
61181	1513	27360832000000
61182	1513	27360843000000
61225	1718	6786749763340
61226	1718	6786761763340
61278	1594	15025219000000
61279	1594	15025230000000
61288	1426	14684951000000
61289	1426	14684963000000
61301	1613	12167912600000
61302	1613	12167922600000
61304	1397	1352811415000
61305	1678	16560623685000
61306	1397	1352801414000
61307	1678	16560623686000
61308	1726	647385724000
61309	1874	5866000
61310	1726	647384722000
61311	1874	5868000
61312	1726	647383721000
61313	1874	5869000
61314	1593	12789978000000
61315	1593	12790001000000
61352	1397	1352741408000
61353	1678	16560623692000
61354	1397	1352731407000
61355	1678	16560623693000
61356	1726	646165709000
61357	1874	5881000
61358	1726	646164708000
61359	1874	5882000
61360	1394	61921082000000
61361	1394	61921104000000
61364	1522	11134147000000
61365	1522	11134148000000
61373	1394	63361104000000
61374	1394	63361116000000
61392	1397	1352681402000
61393	1678	16560623698000
61394	1726	646158700000
61395	1874	5890000
61396	1749	3845117000000
61397	1749	3845128000000
61398	1397	1352671401000
61399	1678	16560623699000
61400	1397	1352661400000
61401	1678	16560623700000
61402	1397	1352651399000
61403	1678	16560623701000
61404	1397	1352641398000
61405	1678	16560623702000
61406	1726	646157698000
61407	1874	5892000
61408	1726	646156697000
61409	1874	5893000
61410	1726	646155695000
61411	1874	5895000
61412	1726	646154694000
61413	1874	5896000
61414	1726	646153693000
61415	1874	5897000
61416	1726	646152691000
61417	1874	5899000
61418	1395	57890330735533700
61427	1397	1352621396000
61428	1678	16560623704000
61429	1397	1352611395000
61430	1678	16560623705000
61431	1726	646150688000
61432	1874	5902000
61433	1726	646149687000
61434	1874	5903000
61435	1726	646148685000
61436	1874	5905000
61437	1394	66241128000000
61438	1394	66241151000000
61464	1397	1352561390000
61465	1678	16560623710000
61060	1739	25919726000000
61061	1739	25919737000000
61070	1397	1353161450000
61071	1678	16560623650000
61072	1397	1353151449000
61073	1678	16560623651000
61074	1726	647432791000
61075	1874	5799000
61076	1726	647431790000
61077	1874	5800000
61078	1726	647430789000
61079	1874	5801000
61080	1696	10577305840000
61081	1696	10577328840000
61113	1397	1353101444000
61114	1678	16560623656000
61115	1688	97562514904000
61116	1688	97562524904000
61118	1714	10246292103056
61134	1397	1353071441000
61135	1678	16560623659000
61136	1726	647419773000
61137	1874	5817000
61138	1693	4460281406843
61139	1693	4460292406843
61142	1397	1353061440000
61143	1678	16560623660000
61144	1726	647418771000
61145	1874	5819000
61146	1705	8558483500145
61147	1705	8558494500145
61183	1397	1352991433000
61184	1678	16560623667000
61185	1397	1352981432000
61186	1678	16560623668000
61187	1726	647409758000
61188	1874	5832000
61189	1726	647408757000
61190	1874	5833000
61191	1726	647407755000
61192	1874	5835000
61193	1451	7098850000000
61194	1451	7098873000000
61215	1762	13281896994000
61216	1762	13281930994000
61243	1455	6513986000000
61246	1419	17019322280064
61247	1397	1352891423000
61248	1678	16560623677000
61249	1397	1352881422000
61250	1678	16560623678000
61251	1397	1352871421000
61252	1678	16560623679000
61253	1397	1352861420000
61254	1678	16560623680000
61255	1726	647396740000
61256	1874	5850000
61257	1726	647395738000
61258	1874	5852000
61259	1726	647394737000
61260	1874	5853000
61261	1726	647393735000
61262	1874	5855000
61263	1726	647392734000
61264	1874	5856000
61265	1719	8660427000000
61266	1726	647391732000
61267	1874	5858000
61268	1719	9380427000000
61269	1719	9380428000000
61270	1527	9380427000001
61271	1719	263999986
61290	1397	1352831417000
61291	1678	16560623683000
61292	1726	647387727000
61293	1874	5863000
61294	1726	647386725000
61295	1874	5865000
61296	1656	13821497999990
61297	1656	13821509999990
61316	1671	11568434530515
61318	1397	1352791413000
61319	1678	16560623687000
61320	1726	646173721000
61321	2128	200000000
61322	1726	646172719000
61323	1874	5871000
61324	1726	646171718000
61325	1874	5872000
61326	1692	69862774019999
61328	1397	1352781412000
61329	1678	16560623688000
61330	1726	646170716000
61331	1874	5874000
61332	1716	11566747000000
61333	1716	11566758000000
61334	1397	1352771411000
61335	1678	16560623689000
61336	1397	1352761410000
61337	1678	16560623690000
61338	1397	1352751409000
61339	1678	16560623691000
61340	1726	646169715000
61341	1874	5875000
61342	1534	180000000
61343	1694	13692463127629
61344	1726	646168714000
61345	1874	5876000
61346	1726	646167712000
61347	1874	5878000
61348	1726	646166711000
61349	1874	5879000
61350	1394	60481082000000
61375	1759	12240725999999
61376	1759	12240737999999
61381	1397	1352701404000
61382	1678	16560623696000
61383	1850	9998886000000
61421	1397	1352631397000
61422	1678	16560623703000
61423	1726	646151690000
61424	1874	5900000
61425	1709	7920082999976
61426	1709	7920093999976
61444	1397	1352591393000
61445	1678	16560623707000
61446	1726	646146682000
61447	1874	5908000
61448	1726	646145681000
61449	1874	5909000
61450	1444	11375072159999
61451	1444	11375084159999
61474	1397	1352551389000
61475	1678	16560623711000
61476	1726	646140674000
61477	1874	5916000
61478	1451	7818873000000
61479	1451	7818884000000
61487	1694	14412463127629
61488	1694	14412474127629
61491	1397	1352531387000
61492	1678	16560623713000
61493	1397	1352521386000
61494	1678	16560623714000
61495	1397	1352511385000
61496	1678	16560623715000
61497	1726	646138671000
61498	1874	5919000
61499	1509	200100000
61500	2070	10751826751155
61518	1634	11711734641004
61535	1397	1352471381000
61536	1678	16560623719000
61537	1726	646130659000
61538	1874	5931000
61539	1726	646129658000
61540	1874	5932000
61541	1402	45214386319298
61542	1402	45214398319298
61569	1688	99002546904000
61587	1397	1352391373000
61588	1678	16560623727000
61589	1726	646119643000
61590	1874	5947000
61591	1726	646118642000
61592	1874	5948000
61593	1608	12525582000000
61594	1608	12525594000000
61598	1559	8602681000000
61621	1394	70561175000000
61622	1394	70561186000000
61645	1596	13680539000000
61646	1596	13680551000000
61683	1474	11074498000023
61684	1474	11074532000023
61715	1397	1352191353000
61716	1678	16560623747000
61717	1602	9360430000000
61718	1726	646092604000
61719	1874	5986000
61720	1726	646091603000
61721	1874	5987000
61722	1602	10080432000000
61725	1397	1352181352000
61726	1678	16560623748000
61169	1673	19766433000000
61199	1397	1352961430000
61200	1678	16560623670000
61201	1397	1352951429000
61202	1678	16560623671000
61203	1397	1352941428000
61204	1678	16560623672000
61205	1726	647405753000
61206	1874	5837000
61207	1726	647404751000
61208	1874	5839000
61209	1726	647403750000
61210	1874	5840000
61211	1726	647402748000
61212	1874	5842000
61213	1688	99002535904000
61214	1688	99002569904000
61233	1397	1352911425000
61234	1678	16560623675000
61235	1397	1352901424000
61236	1678	16560623676000
61237	1726	647398742000
61238	1874	5848000
61239	1726	647397741000
61240	1874	5849000
61241	1717	8747943000023
61242	1717	8747965000023
61244	43	78240789890000
61245	43	78240811890000
61298	1397	1352821416000
61299	1678	16560623684000
61300	1693	4460291406843
61317	1395	57890330712533700
61327	1513	27360854000000
61351	1739	25919761000000
61377	1397	1352711405000
61378	1678	16560623695000
61379	1726	646161704000
61380	1874	5886000
61452	1397	1352581392000
61453	1678	16560623708000
61454	2039	11521363000000
61455	2039	11521373000000
61480	1588	13175086000000
61486	1447	12394512943000
61490	1687	10072715524804
61510	1509	10752022851155
61527	1394	69121175000000
61533	1681	11303205759830
61534	1681	11303216759830
61545	1397	1352461380000
61546	1678	16560623720000
61547	1397	1352451379000
61548	1678	16560623721000
61549	1726	646128656000
61550	1874	5934000
61551	1726	646127655000
61552	1874	5935000
61553	1690	103683257000000
61554	1690	103683279000000
61576	1397	1352411375000
61577	1678	16560623725000
61578	1397	1352401374000
61579	1678	16560623726000
61580	1726	646122648000
61581	1874	5942000
61582	1726	646121646000
61583	1874	5944000
61584	1726	646120645000
61585	1874	5945000
61586	1717	8747966000023
61607	1708	7955743000021
61608	1708	7955755000021
61649	1397	1352301364000
61650	1678	16560623736000
61651	1397	1352291363000
61652	1678	16560623737000
61653	1726	646106625000
61654	1874	5965000
61655	1726	646105623000
61656	1874	5967000
61657	1440	7919143000000
61663	1690	104403279000000
61664	1690	104403290000000
61665	1397	1352271361000
61666	1678	16560623739000
61667	1397	1352261360000
61668	1678	16560623740000
61669	1397	1352251359000
61670	1678	16560623741000
61671	1726	646103620000
61672	1874	5970000
61673	1726	646102619000
61674	1874	5971000
61675	1726	646101617000
61676	1874	5973000
61677	1726	646100616000
61678	1874	5974000
61679	1691	11483124100019
61680	1691	11483158100019
61682	526	68160086000000
61700	1397	1352211355000
61701	1678	16560623745000
61702	1726	646095609000
61703	1874	5981000
61704	1726	646094607000
61705	1874	5983000
61706	1622	16380307000005
61707	1622	16380319000005
61709	1397	1352201354000
61710	1678	16560623746000
61711	1726	646093606000
61712	1874	5984000
61713	1395	57891770746533700
61731	1397	1352171351000
61732	1678	16560623749000
61733	1726	646090602000
61734	1874	5988000
61735	1726	646089600000
61736	1874	5990000
61737	1724	7149320000000
61740	1397	1352161350000
61741	1678	16560623750000
61742	1726	646088599000
61743	1874	5991000
61763	1685	95761875571430
61764	1685	95761886571430
61782	1397	1352101344000
61783	1678	16560623756000
61784	1397	1352091343000
61785	1678	16560623757000
61786	1726	646080587000
61787	1874	6003000
61788	1726	646079586000
61789	1874	6004000
61790	1726	646078584000
61791	1874	6006000
61792	2112	1439035000000
61793	1397	1352081342000
61794	1678	16560623758000
61795	1726	646077583000
61796	1874	6007000
61797	1692	69862763019999
61814	1397	1352051339000
61815	1678	16560623761000
61816	1397	1352041338000
61817	1678	16560623762000
61818	1726	646074578000
61819	1874	6012000
61820	1726	646073577000
61821	1874	6013000
61822	1726	646072576000
61823	1874	6014000
61824	1726	646071574000
61825	1874	6016000
61826	1513	28800866000000
61827	1513	28801014000000
61845	1680	9369505500035
61865	1397	1351971331000
61866	1678	16560623769000
61867	1726	646063563000
61868	1874	6027000
61869	1726	646062561000
61870	1874	6029000
61871	1397	1351961330000
61872	1678	16560623770000
61873	1726	646061560000
61874	1874	6030000
61875	1943	2158920000000
61876	1943	2158931000000
61898	1397	1351931327000
61899	1678	16560623773000
61900	1726	646057554000
61901	1874	6036000
61904	1397	1351921326000
61905	1678	16560623774000
61906	1726	646056552000
61907	1874	6038000
61908	1726	646055551000
61909	1874	6039000
61910	1394	73441209000000
61911	1394	73441221000000
61924	1397	1351891323000
61925	1678	16560623777000
61926	1397	1351881322000
61232	1762	14001941994000
61272	1397	1352851419000
61273	1678	16560623681000
61274	1726	647390731000
61275	1874	5859000
61276	1637	177844875819988
61277	1637	177844886819988
61280	1397	1352841418000
61281	1678	16560623682000
61282	1726	647389729000
61283	1874	5861000
61284	1726	647388728000
61285	1874	5862000
61286	1395	57890330689533700
61287	1395	57890330701533700
61303	1394	60481057000000
61362	1439	9652390998477
61363	1439	9652412998477
61366	1397	1352721406000
61367	1678	16560623694000
61368	1726	646163706000
61369	1874	5884000
61370	1726	646162705000
61371	1874	5885000
61372	1522	11134159000000
61384	1397	1352691403000
61385	1678	16560623697000
61386	1726	646160703000
61387	1874	5887000
61388	1726	646159701000
61389	1874	5889000
61390	1394	64801116000000
61391	1394	64801128000000
61419	1716	12286758000000
61420	1716	12286804000000
61439	1397	1352601394000
61440	1678	16560623706000
61441	1726	646147684000
61442	1874	5906000
61443	1395	57890330700533700
61456	1397	1352571391000
61457	1678	16560623709000
61458	1726	646144680000
61459	1874	5910000
61460	1726	646143678000
61461	1874	5912000
61462	1394	67681151000000
61463	1394	67681163000000
61472	1513	28080854000000
61473	1513	28080866000000
61481	1397	1352541388000
61482	1678	16560623712000
61483	1726	646139672000
61484	1874	5918000
61485	1588	13174933000000
61501	1726	646137669000
61502	1874	5921000
61503	1726	646136668000
61504	1874	5922000
61505	1726	646135667000
61506	1874	5923000
61507	1726	646134665000
61508	1874	5925000
61509	1395	57891050735533700
61512	1394	69121163000000
61513	1394	69121198000000
61514	1397	1352501384000
61515	1678	16560623716000
61516	1679	35388024652000
61517	1679	35388034652000
61563	1397	1352431377000
61564	1678	16560623723000
61565	1726	646124651000
61566	1874	5939000
61567	1698	11336989550035
61568	1698	11337000550035
61570	1397	1352421376000
61571	1678	16560623724000
61572	1726	646123649000
61573	1874	5941000
61574	1596	12960528000000
61575	1596	12960539000000
61595	1397	1352381372000
61596	1678	16560623728000
61597	1522	11134157000000
61615	1397	1352351369000
61616	1678	16560623731000
61617	1726	646113635000
61618	1874	5955000
61619	1608	13245594000000
61620	1608	13245605000000
61638	1397	1352311365000
61639	1678	16560623735000
61640	1726	646108628000
61641	1874	5962000
61642	1726	646107626000
61643	1874	5964000
61644	1448	5076723000001
61647	2106	2159034000000
61648	2106	2159046000000
61685	1397	1352241358000
61686	1678	16560623742000
61687	1397	1352231357000
61688	1678	16560623743000
61689	1397	1352221356000
61690	1678	16560623744000
61691	1726	646099615000
61692	1874	5975000
61693	1726	646098613000
61694	1874	5977000
61695	1726	646097612000
61696	1874	5978000
61697	1726	646096610000
61698	1874	5980000
61699	1690	104403313000000
61714	1623	48962530899898
61723	1679	34668034652000
61724	1679	35388036652000
61729	1514	11297338835100
61730	1696	10600
61746	1397	1352151349000
61747	1678	16560623751000
61748	1726	646087597000
61749	1874	5993000
61750	1726	646086596000
61751	1874	5994000
61752	1397	1352141348000
61753	1678	16560623752000
61754	1726	646085594000
61755	1874	5996000
61756	1637	179284920819988
61757	1637	179284931819988
61780	532	70320049000000
61781	532	70320072000000
61805	1749	4565128000000
61806	1749	4565140000000
61811	1991	12715820441475
61812	1991	12715830441475
61879	1397	1351951329000
61880	1678	16560623771000
61881	1726	646060558000
61882	1874	6032000
61883	1726	646059557000
61884	1874	6033000
61885	1546	8640776000000
61886	1546	8640788000000
61893	1541	722047000000
61896	1680	10089505500035
61897	1680	10089506500035
61912	1397	1351911325000
61913	1678	16560623775000
61914	1726	646054550000
61915	1874	6040000
61916	1717	10187989000023
61917	1717	10188000000023
61936	1397	1351871321000
61937	1678	16560623779000
61938	1687	10072725524804
61939	1726	646049542000
61940	1874	6048000
61941	1726	646048541000
61942	1874	6049000
61943	1687	10792725524804
61944	1687	10792727524804
61948	1643	8496427113700
61949	1643	9216427113700
61950	1643	9216429113700
61969	1643	4875888428700
61970	1299	1702603897287650
61971	1643	2950241740700
61972	1053	905559794837000
61973	1397	1351831317000
61974	1678	16560623783000
61975	1726	646043534000
61976	1874	6056000
61977	1476	12240179000000
61978	1476	12240210000000
61984	1397	1351821316000
61985	1678	16560623784000
61986	1726	646042532000
61987	1874	6058000
61988	1395	57893210756533700
61989	1395	57893210767533700
62013	1397	1351791313000
62014	1678	16560623787000
61466	1726	646142677000
61467	1874	5913000
61468	1726	646141675000
61469	1874	5915000
61470	1719	10100428000000
61471	1719	10100440000000
61489	1395	57891050700533700
61511	1509	10751830851155
61519	1397	1352491383000
61520	1678	16560623717000
61521	1726	646133664000
61522	1874	5926000
61523	1726	646132662000
61524	1874	5928000
61525	1395	57891770735533700
61526	1395	57891770747533700
61528	1397	1352481382000
61529	1678	16560623718000
61530	1726	646131661000
61531	1874	5929000
61532	1715	33120559000000
61543	1691	10763112100019
61544	1691	10763124100019
61555	1397	1352441378000
61556	1678	16560623722000
61557	1726	646126654000
61558	1874	5936000
61559	1726	646125652000
61560	1874	5938000
61561	1613	12887922600000
61562	1613	12887934600000
61599	1397	1352371371000
61600	1678	16560623729000
61601	1726	646117641000
61602	1874	5949000
61603	1726	646116639000
61604	1874	5951000
61605	1637	178564886819988
61606	1637	178564898819988
61609	1397	1352361370000
61610	1678	16560623730000
61611	1726	646115638000
61612	1874	5952000
61613	1726	646114636000
61614	1874	5954000
61623	1397	1352341368000
61624	1678	16560623732000
61625	1397	1352331367000
61626	1678	16560623733000
61627	1397	1352321366000
61628	1678	16560623734000
61629	1726	646112633000
61630	1874	5957000
61631	1726	646111632000
61632	1874	5958000
61633	1726	646110630000
61634	1874	5960000
61635	1726	646109629000
61636	1874	5961000
61637	1637	178564920819988
61658	1397	1352281362000
61659	1678	16560623738000
61660	1726	646104622000
61661	1874	5968000
61662	1729	18287182000000
61681	1394	70561209000000
61708	1394	70561187000000
61738	532	69600037000000
61739	532	69600049000000
61744	1715	33840559000000
61745	1715	33840570000000
61758	1397	1352131347000
61759	1678	16560623753000
61760	1726	646084593000
61761	1874	5997000
61762	1670	12961010000000
61765	1402	45934398319298
61778	1724	7149331000000
61828	525	67440010000000
61829	525	67440034000000
61830	1397	1352031337000
61831	1678	16560623763000
61832	1397	1352021336000
61833	1678	16560623764000
61834	1397	1352011335000
61835	1678	16560623765000
61836	2058	548500000
61837	1726	646070573000
61838	1874	6017000
61839	1726	646069571000
61840	1874	6019000
61841	1726	646068570000
61842	1874	6020000
61843	1680	9369404500035
61844	1680	9369438500035
61877	1643	9216417113700
61878	1643	9216428113700
61902	632	99120938000000
61903	632	99120949000000
61945	1394	73441231000000
61946	1394	74881231000000
61947	1394	74881233000000
61979	1668	13646697000000
61982	1675	10222149999977
61983	1675	10222180999977
61990	1397	1351811315000
61991	1678	16560623785000
61992	1643	1650966296700
61993	1173	610999087832700
61994	1643	576377114700
61995	933	505337374679600
61996	1726	646041531000
61997	1874	6059000
61998	1680	10809449500035
61999	1680	10809480500035
62001	1643	4155877428700
62002	1643	2230230740700
62003	1680	10809506500035
62004	1680	10809526500035
62022	1397	1351781312000
62023	1678	16560623788000
62024	1397	1351771311000
62025	1678	16560623789000
62026	1726	646036524000
62027	1874	6066000
62028	1726	646035522000
62029	1874	6068000
62030	1749	5285140000000
62031	1749	5285162000000
62037	1705	9278494500145
62038	1705	9278505500145
62057	1397	1351731307000
62058	1678	16560623793000
62059	1726	646030515000
62060	1874	6075000
62061	1688	101162594904000
62062	1688	101162605904000
62065	1701	10150325600056
62066	1701	10150336600056
62068	1397	1351721306000
62069	1678	16560623794000
62070	1726	646029514000
62071	1874	6076000
62072	1726	646028512000
62073	1874	6078000
62074	1426	15404963000000
62075	1426	15404975000000
62113	1394	77761267000000
62139	1397	1351611295000
62140	1678	16560623805000
62141	1397	1351601294000
62142	1678	16560623806000
62143	1726	646014492000
62144	1874	6098000
62145	1726	646013490000
62146	1874	6100000
62147	1726	646012489000
62148	1874	6101000
62149	1439	9652413998477
62196	1395	57895370812533700
62197	1395	57895370846533700
62218	1397	1351481282000
62219	1678	16560623818000
62220	1726	645997467000
62221	1874	6123000
62222	1726	645996466000
62223	1874	6124000
62224	1395	57896090846533700
62225	1395	57896090858533700
62242	1726	645993462000
62243	1874	6128000
62244	1726	645992460000
62245	1874	6130000
62246	1685	95761887571430
62266	1679	35388035652000
62303	1397	1351361270000
62304	1678	16560623830000
62305	1726	645980443000
62306	1874	6147000
62307	1685	96481887571430
62308	1685	96481898571430
62329	1397	1351331267000
62330	1678	16560623833000
62331	1397	1351321266000
62332	1678	16560623834000
61727	1696	11297328840000
61728	1696	11297338840000
61766	1397	1352121346000
61767	1678	16560623754000
61768	1397	1352111345000
61769	1678	16560623755000
61770	1726	646083591000
61771	1874	5999000
61772	1726	646082590000
61773	1874	6000000
61774	1726	646081589000
61775	1874	6001000
61776	1717	9467966000023
61777	1717	9467989000023
61779	1394	70561198000000
61798	1397	1352071341000
61799	1678	16560623759000
61800	1726	646076581000
61801	1874	6009000
61802	1726	646075580000
61803	1874	6010000
61804	1694	14412475127629
61807	1397	1352061340000
61808	1678	16560623760000
61809	1634	12431734641004
61810	1634	12431744641004
61813	1547	9933342000000
61846	1397	1352001334000
61847	1678	16560623766000
61848	1397	1351991333000
61849	1678	16560623767000
61850	1726	646067568000
61851	1874	6022000
61852	1726	646066567000
61853	1874	6023000
61854	1726	646065565000
61855	1874	6025000
61856	1726	646064564000
61857	1874	6026000
61858	1688	99722546904000
61859	1688	99722570904000
61860	1397	1351981332000
61861	1678	16560623768000
61862	2119	199000000
61863	1394	72001198000000
61864	1394	72001209000000
61887	1397	1351941328000
61888	1678	16560623772000
61889	1726	646058555000
61890	1874	6035000
61891	1680	10089438500035
61892	1680	10089449500035
61894	1718	7506761763340
61895	1718	7506772763340
61918	1397	1351901324000
61919	1678	16560623776000
61920	1726	646053548000
61921	1874	6042000
61922	1476	11520168000000
61923	1476	11520179000000
61951	1397	1351861320000
61952	1678	16560623780000
61953	1395	57892490746533700
61954	1395	57892490756533700
62039	1692	70582763019999
62040	1692	70582774019999
62049	1613	13607934600000
62050	1613	13607946600000
62093	1397	1351681302000
62094	1678	16560623798000
62095	1397	1351671301000
62096	1678	16560623799000
62097	1726	646023505000
62098	1874	6085000
62099	1726	646022503000
62100	1874	6087000
62101	1726	646021502000
62102	1874	6088000
62103	1693	4460304406843
62114	1397	1351641298000
62115	1678	16560623802000
62116	1397	1351631297000
62117	1678	16560623803000
62118	1726	646018498000
62119	1874	6092000
62120	1726	646017496000
62121	1874	6094000
62122	1726	646016495000
62123	1874	6095000
62124	1394	77761268000000
62127	641	74259925000000
62129	1397	1351621296000
62130	1678	16560623804000
62131	1726	646015493000
62132	1874	6097000
62133	1447	13114512943000
62134	1447	13114523943000
62137	1716	13006804000000
62138	1716	13006815000000
62150	1397	1351591293000
62151	1678	16560623807000
62152	1726	646011488000
62153	1874	6102000
62177	1394	79201279000000
62178	1394	79201291000000
62180	1394	80641291000000
62198	1397	1351511285000
62199	1678	16560623815000
62200	1726	646000472000
62201	1874	6118000
62203	1397	1351501284000
62204	1678	16560623816000
62205	1726	645999470000
62206	1874	6120000
62207	1546	9360788000000
62208	1546	9360799000000
62228	1397	1351471281000
62229	1678	16560623819000
62230	1397	1351461280000
62231	1678	16560623820000
62232	1726	645995464000
62233	1874	6126000
62234	1726	645994463000
62235	1874	6127000
62236	1717	10908000000023
62237	1717	10908022000023
62260	1397	1351421276000
62261	1678	16560623824000
62262	1726	645988454000
62263	1874	6136000
62264	1699	5829790750126
62269	1394	82081302000000
62270	1394	82081313000000
62283	1397	1351391273000
62284	1678	16560623827000
62285	1397	1351381272000
62286	1678	16560623828000
62287	1726	645984449000
62288	1874	6141000
62289	1726	645983447000
62290	1874	6143000
62291	1457	12864312040000
62293	641	74979925000000
62294	641	74979947000000
62309	1397	1351351269000
62310	1678	16560623831000
62311	1726	645979441000
62312	1874	6149000
62313	1726	645978440000
62314	1874	6150000
62315	1395	57896810870533700
62320	369	97680865000000
62356	1634	13151744641004
62357	1634	13151777641004
62375	1690	105123313000000
62376	1690	105123325000000
62427	1397	1351191253000
62428	1678	16560623847000
62429	1726	645957410000
62430	1874	6180000
62431	1715	34560569000001
62432	1527	34560589000002
62433	1715	264999985
62450	1397	1351161250000
62451	1678	16560623850000
62452	1726	645952402000
62453	1874	6188000
62454	1726	645951401000
62455	1874	6189000
62456	1395	57897530870533700
62457	1395	57897530882533700
62470	2129	1989000000
62471	1705	8555474500145
62472	1397	1351131247000
62473	1678	16560623853000
62474	1397	1351121246000
62475	1678	16560623854000
62476	1726	645948397000
62477	1874	6193000
62478	1726	645947395000
62479	1874	6195000
62480	1726	645946394000
62481	1874	6196000
62482	1395	57898250882533700
62483	1395	57898250916533700
61927	1678	16560623778000
61928	1726	646052547000
61929	1874	6043000
61930	1726	646051545000
61931	1874	6045000
61932	1726	646050544000
61933	1874	6046000
61934	1602	10800432000000
61935	1602	10800455000000
61955	1397	1351851319000
61956	1678	16560623781000
61957	1397	1351841318000
61958	1678	16560623782000
61959	1726	646047539000
61960	1874	6051000
61961	1726	646046538000
61962	1874	6052000
61963	1726	646045537000
61964	1874	6053000
61965	1726	646044535000
61966	1874	6055000
61967	1688	100442570904000
61968	1688	100442594904000
61980	1723	15479423085979
61981	1723	15479454085979
62000	1992	10079262990000
62005	1397	1351801314000
62006	1678	16560623786000
62007	1726	646040529000
62008	1874	6061000
62009	1726	646039528000
62010	1874	6062000
62011	1394	76321233000000
62012	1394	76321245000000
62032	1397	1351761310000
62033	1678	16560623790000
62034	1726	646034521000
62035	1874	6069000
62036	1654	14688132999798
62063	1448	5796723000001
62064	1448	5796734000001
62067	2106	2159045000000
62076	1397	1351711305000
62077	1678	16560623795000
62078	1397	1351701304000
62079	1678	16560623796000
62080	1397	1351691303000
62081	1678	16560623797000
62082	1726	646027511000
62083	1874	6079000
62084	1726	646026509000
62085	1874	6081000
62086	1726	646025508000
62087	1874	6082000
62088	1726	646024506000
62089	1874	6084000
62090	1395	57893930767533700
62091	1395	57893930801533700
62104	1397	1351661300000
62105	1678	16560623800000
62106	1397	1351651299000
62107	1678	16560623801000
62108	1726	646020501000
62109	1874	6089000
62110	1726	646019499000
62111	1874	6091000
62112	1688	101162616904000
62125	606	72477737812962
62126	606	72477760812962
62154	1397	1351581292000
62155	1678	16560623808000
62156	1397	1351571291000
62157	1678	16560623809000
62158	1397	1351561290000
62159	1678	16560623810000
62160	1726	646010486000
62161	1874	6104000
62162	1726	646009485000
62163	1874	6105000
62164	1726	646008483000
62165	1874	6107000
62166	1726	646007482000
62167	1874	6108000
62168	1394	77761279000000
62181	1397	1351541288000
62182	1678	16560623812000
62183	1397	1351531287000
62184	1678	16560623813000
62185	1397	1351521286000
62186	1678	16560623814000
62187	1726	646004477000
62188	1874	6113000
62189	1726	646003476000
62190	1874	6114000
62191	1726	646002475000
62192	1874	6115000
62193	1726	646001473000
62194	1874	6117000
62195	1668	13646700000000
62209	1397	1351491283000
62210	1678	16560623817000
62211	1726	645998469000
62212	1874	6121000
62213	1509	10751806851155
62215	1509	10752182851155
62216	1509	11472182851155
62217	1509	11473101851155
62226	1573	5018881000000
62227	1573	5018893000000
62238	1397	1351451279000
62239	1678	16560623821000
62240	1395	57896810858533700
62241	1395	57896810868533700
62247	1397	1351441278000
62248	1678	16560623822000
62249	1726	645991459000
62250	1874	6131000
62251	1394	80641302000000
62271	1397	1351411275000
62272	1678	16560623825000
62273	1397	1351401274000
62274	1678	16560623826000
62275	1726	645987453000
62276	1874	6137000
62277	1726	645986451000
62278	1874	6139000
62279	1726	645985450000
62280	1874	6140000
62281	1623	48962542899898
62295	1397	1351371271000
62296	1678	16560623829000
62297	1726	645982446000
62298	1874	6144000
62299	1726	645981444000
62300	1874	6146000
62301	1444	12095084159999
62302	1444	12095096159999
62324	1643	5595899428700
62325	1643	3670252740700
62326	1643	2370977296700
62327	1643	1296388114700
62328	171	76070428524688
62358	1679	35388057652000
62359	1643	1296377114700
62367	1637	180724942819988
62368	1637	180724954819988
62404	1397	1351211255000
62405	1678	16560623845000
62406	1726	645960414000
62407	1874	6176000
62408	1714	10246293103056
62410	1705	8553674500145
62411	2129	3800000000
62412	1693	5180359406843
62413	1397	1351201254000
62414	1678	16560623846000
62415	1726	645959413000
62416	1874	6177000
62417	1726	645958411000
62418	1874	6179000
62419	1693	5900359406843
62420	1693	5900381406843
62424	1633	76800395000000
62425	470	7956392985638
62434	1397	1351181252000
62435	1678	16560623848000
62436	1726	645956408000
62437	1874	6182000
62438	1726	645955407000
62439	1874	6183000
62440	1726	645954405000
62441	1874	6185000
62442	1700	11825943276737
62443	1700	11825956276737
62458	1517	100000000
62459	1670	12960899000000
62527	641	75699947000000
62528	641	75699959000000
62546	1397	1351021236000
62547	1678	16560623864000
62548	1397	1351011235000
62549	1678	16560623865000
62550	1726	645934376000
62551	1874	6214000
62552	1726	645933375000
62015	1726	646038527000
62016	1874	6063000
62017	1726	646037525000
62018	1874	6065000
62019	1394	77761245000000
62020	1394	77761257000000
62021	1739	25919738000000
62041	1397	1351751309000
62042	1678	16560623791000
62043	1726	646033519000
62044	1874	6071000
62045	1726	646032518000
62046	1874	6072000
62047	1602	11520455000000
62048	1602	11520467000000
62051	1397	1351741308000
62052	1678	16560623792000
62053	1726	646031516000
62054	1874	6074000
62055	1637	180004931819988
62056	1637	180004942819988
62092	1685	95761909571430
62128	606	72477873812962
62135	1395	57894650801533700
62136	1395	57894650812533700
62169	1397	1351551289000
62170	1678	16560623811000
62171	1726	646006480000
62172	1874	6110000
62173	1726	646005479000
62174	1874	6111000
62175	1439	10372413998477
62176	1439	10372425998477
62179	1700	11105943276737
62202	1439	10372424998477
62214	1593	12789989000000
62252	1397	1351431277000
62253	1678	16560623823000
62254	1726	645990457000
62255	1874	6133000
62256	1726	645989456000
62257	1874	6134000
62258	1549	14735772000000
62259	1549	14735784000000
62265	2086	2879079000000
62267	2087	2159047000000
62268	2087	2159058000000
62282	1394	82081325000000
62292	1394	82081324000000
62316	58	83226505999641
62317	58	83226517999641
62318	1622	17100319000005
62319	1622	17100331000005
62321	1397	1351341268000
62322	1678	16560623832000
62323	369	97680875000000
62360	1397	1351281262000
62361	1678	16560623838000
62362	1726	645970428000
62363	1874	6162000
62364	1726	645969427000
62365	1874	6163000
62366	1756	5507811575609
62369	1397	1351271261000
62370	1678	16560623839000
62371	1726	645968425000
62372	1874	6165000
62373	1726	645967424000
62374	1874	6166000
62377	1397	1351261260000
62378	1678	16560623840000
62379	1634	13151754641004
62380	1397	1351251259000
62381	1678	16560623841000
62382	1397	1351241258000
62383	1678	16560623842000
62384	1397	1351231257000
62385	1678	16560623843000
62386	1726	645966423000
62387	1874	6167000
62388	1726	645965421000
62389	1874	6169000
62390	1726	645964420000
62391	1874	6170000
62392	1726	645963418000
62393	1874	6172000
62394	1726	645962417000
62395	1874	6173000
62396	1693	5180304406843
62397	1693	5180339406843
62426	1693	5900371406843
62460	1397	1351151249000
62461	1678	16560623851000
62462	1397	1351141248000
62463	1678	16560623852000
62464	1726	645950400000
62465	1874	6190000
62466	1726	645949398000
62467	1874	6192000
62468	1670	13681010000000
62469	1670	13681032000000
62484	1608	13965605000000
62485	1608	13965639000000
62487	1397	1351111245000
62488	1678	16560623855000
62489	1726	645945392000
62490	1874	6198000
62491	1549	15455784000000
62492	1549	15455795000000
62495	1692	71302774019999
62496	1692	71302785019999
62519	1419	17019334280064
62540	1517	200000000
62541	1670	13680799000000
62560	1397	1351001234000
62561	1678	16560623866000
62562	1726	645930371000
62563	1874	6219000
62582	1397	1350961230000
62583	1678	16560623870000
62584	1397	1350951229000
62585	1678	16560623871000
62586	1726	645925364000
62587	1874	6226000
62588	1726	645924362000
62589	1874	6228000
62590	1688	101882616904000
62591	1688	101882638904000
62594	1622	17100341000005
62622	1397	1350891223000
62623	1678	16560623877000
62624	1397	1350881222000
62625	1678	16560623878000
62626	1726	645916351000
62627	1874	6239000
62628	1726	645915349000
62629	1874	6241000
62630	1726	645914348000
62631	1874	6242000
62632	1395	57898970917533700
62634	1397	1350871221000
62635	1678	16560623879000
62636	1726	645913346000
62637	1874	6244000
62638	1709	8640093999976
62639	1709	8640104999976
62661	1397	1350831217000
62662	1678	16560623883000
62663	1711	13484589000000
62664	1711	13484599000000
62678	1685	97201921571430
62692	1685	97201940571430
62703	1397	1350751209000
62704	1678	16560623891000
62705	1726	642273331000
62706	2131	200000000
62707	1726	641063331000
62708	2096	1400000000
62709	1610	10800290000000
62730	1397	1350691203000
62731	1678	16560623897000
62732	1397	1350681202000
62733	1678	16560623898000
62734	1397	1350671201000
62735	1678	16560623899000
62736	1623	49682542899898
62333	1726	645977438000
62334	1874	6152000
62335	1726	645976437000
62336	1874	6153000
62337	1726	645975436000
62338	1874	6154000
62339	1726	645974434000
62340	1874	6156000
62341	1749	6005162000000
62342	1749	6005186000000
62343	1397	1351311265000
62344	1678	16560623835000
62345	1397	1351301264000
62346	1678	16560623836000
62347	1397	1351291263000
62348	1678	16560623837000
62349	1726	645973433000
62350	1874	6157000
62351	1726	645972431000
62352	1874	6159000
62353	1726	645971430000
62354	1874	6160000
62355	1672	16562020000000
62398	1397	1351221256000
62399	1678	16560623844000
62400	1726	645961415000
62401	1874	6175000
62402	1699	6549790750126
62403	1699	6549801750126
62409	1394	82081303000000
62421	470	76080393000000
62422	470	76800393000000
62423	470	76800415000000
62444	1397	1351171251000
62445	1678	16560623849000
62446	1726	645953404000
62447	1874	6186000
62448	1672	17282020000000
62449	1672	17282031000000
62497	1397	1351101244000
62498	1678	16560623856000
62499	1726	645944391000
62500	1874	6199000
62501	1679	36108036652000
62502	1679	36108047652000
62520	1397	1351061240000
62521	1678	16560623860000
62522	1726	645939384000
62523	1874	6206000
62524	1726	645938382000
62525	1874	6208000
62526	1395	57898250894533700
62564	1397	1350991233000
62565	1678	16560623867000
62566	1397	1350981232000
62567	1678	16560623868000
62568	1726	645929369000
62569	1874	6221000
62570	1726	645928368000
62571	1874	6222000
62572	149	81390203000341
62573	149	81390225000341
62713	1397	1350741208000
62714	1678	16560623892000
62715	1693	6620381406843
62716	2039	12241373000000
62717	2039	12241383000000
62742	1397	1350651199000
62743	1678	16560623901000
62744	1874	481000
62745	1726	641068109000
62746	641	75699958000000
62486	1711	12764589000000
62493	1596	14400551000000
62494	1596	14400562000000
62503	1397	1351091243000
62504	1678	16560623857000
62505	1397	1351081242000
62506	1678	16560623858000
62507	1397	1351071241000
62508	1678	16560623859000
62509	1726	645943389000
62510	1874	6201000
62511	1726	645942388000
62512	1874	6202000
62513	1726	645941387000
62514	1874	6203000
62515	1726	645940385000
62516	1874	6205000
62517	1673	20486433000000
62518	1673	20486467000000
62529	1397	1351051239000
62530	1678	16560623861000
62531	1397	1351041238000
62532	1678	16560623862000
62533	1726	645937381000
62534	1874	6209000
62535	1726	645936379000
62536	1874	6211000
62537	1726	645935378000
62538	1874	6212000
62539	1610	10080313000000
62542	1397	1351031237000
62543	1678	16560623863000
62544	1670	14401032000000
62545	1670	14401065000000
62592	1395	57898970894533700
62593	1395	57898970916533700
62633	1714	10246305103056
62640	1397	1350861220000
62641	1678	16560623880000
62642	1395	57898970927533700
62643	1397	1350851219000
62644	1678	16560623881000
62645	1397	1350841218000
62646	1678	16560623882000
62647	1726	645912345000
62648	1874	6245000
62649	1726	645911343000
62650	1874	6247000
62651	1726	645910342000
62652	1874	6248000
62653	1726	645909340000
62654	1874	6250000
62655	1726	645908339000
62656	1874	6251000
62657	1395	57899690927533700
62658	2097	57899690945533706
62659	1395	200000022
62660	1527	271999978
62665	1685	97201898571430
62666	1685	97201908571430
62679	1397	1350801214000
62680	1678	16560623886000
62681	1397	1350791213000
62682	1678	16560623887000
62683	1726	645904333000
62684	1874	6257000
62685	1726	644694333000
62686	2118	1400000000
62687	1726	643484333000
62688	2130	200000000
62689	1726	643483331000
62690	1874	6259000
62691	1684	13651422880623
62693	1555	7395206979096
62694	1710	13914759473290
62695	1397	1350781212000
62696	1678	16560623888000
62697	1397	1350771211000
62698	1678	16560623889000
62699	1397	1350761210000
62700	1678	16560623890000
62701	1710	14634759473290
62702	1710	14635813473290
62710	1394	84961327000000
62711	1394	84961387000000
62718	1397	1350731207000
62719	1678	16560623893000
62720	1397	1350721206000
62721	1678	16560623894000
62722	1634	14591766641004
62723	1634	14591786641004
62737	1594	15025249000000
62553	1874	6215000
62554	1726	645932374000
62555	1874	6216000
62556	1726	645931372000
62557	1874	6218000
62558	1394	83521303000000
62559	1394	83521327000000
62574	1397	1350971231000
62575	1678	16560623869000
62576	1726	645927366000
62577	1874	6224000
62578	1726	645926365000
62579	1874	6225000
62580	1451	8538884000000
62581	1451	8538896000000
62595	1397	1350941228000
62596	1678	16560623872000
62597	1726	645923361000
62598	1874	6229000
62599	1726	645922359000
62600	1874	6231000
62601	1634	13871754641004
62602	1634	13871766641004
62603	1397	1350931227000
62604	1678	16560623873000
62605	1397	1350921226000
62606	1678	16560623874000
62607	1397	1350911225000
62608	1678	16560623875000
62609	1397	1350901224000
62610	1678	16560623876000
62611	1726	645921358000
62612	1874	6232000
62613	1726	645920356000
62614	1874	6234000
62615	1726	645919355000
62616	1874	6235000
62617	1726	645918353000
62618	1874	6237000
62619	1726	645917352000
62620	1874	6238000
62621	1723	15479468085979
62667	1397	1350821216000
62668	1678	16560623884000
62669	1397	1350811215000
62670	1678	16560623885000
62671	1726	645907338000
62672	1874	6252000
62673	1726	645906336000
62674	1874	6254000
62675	1726	645905335000
62676	1874	6255000
62677	1686	7411930550062
62712	1693	6620371406843
62724	1397	1350711205000
62725	1678	16560623895000
62726	1397	1350701204000
62727	1678	16560623896000
62728	1613	14327946600000
62729	1613	14327966600000
62738	1397	1350661200000
62739	1678	16560623900000
62740	470	76800373000000
62741	470	76800383000000
62747	1726	491068109000
62748	1397	1350641198000
62749	1678	16560623902000
62750	369	98400875000000
62751	369	98550885000000
62752	1397	1350631197000
62753	1678	16560623903000
62754	1699	6549800750126
62755	2087	2159057000000
62756	1692	71302784019999
62757	1397	1350621196000
62758	1678	16560623904000
62759	1587	15840495000000
62760	1587	15840505000000
62761	1397	1350611195000
62762	1678	16560623905000
62763	1397	1350601194000
62764	1678	16560623906000
62765	1726	341067109000
62766	2132	149000000000
62767	1688	101882637904000
62768	1397	1350591193000
62769	1678	16560623907000
62770	1397	1350581192000
62771	1678	16560623908000
62772	1397	1350571191000
62773	1678	16560623909000
62774	1397	1350561190000
62775	1678	16560623910000
62776	1397	1350551189000
62777	1678	16560623911000
62778	1726	241066109000
62779	2133	99000000000
62780	1726	141065109000
62781	2134	99000000000
62782	1426	16124975000000
62783	1426	16125027000000
62784	1397	1350541188000
62785	1678	16560623912000
62786	1679	36828047652000
62787	1679	36828057652000
62788	43	78240799890000
62789	1690	105123323000000
62790	1397	1350531187000
62791	1678	16560623913000
62792	2133	98998998000
62793	1874	483000
62794	1759	12240736999999
62795	1440	8639143000000
62796	1440	8639154000000
62797	1397	1350521186000
62798	1678	16560623914000
62799	1397	1350511185000
62800	1678	16560623915000
62801	2133	98997996000
62802	1874	485000
62803	2133	98996994000
62804	1874	487000
62805	1394	86401387000000
62806	1394	86401409000000
62807	1397	1350501184000
62808	1678	16560623916000
62809	2133	98995992000
62810	1874	489000
62811	1394	86401398000000
62812	1397	1350491183000
62813	1678	16560623917000
62814	1397	1350481182000
62815	1678	16560623918000
62816	1397	1350471181000
62817	1678	16560623919000
62818	2133	98994990000
62819	1874	491000
62820	2133	98993988000
62821	1874	493000
62822	2133	98992986000
62823	1874	495000
62824	1476	12240212000000
62825	1457	12864323040000
62826	1673	21206467000000
62827	1673	21206500000000
62828	1397	1350461180000
62829	1678	16560623920000
62830	1397	1350451179000
62831	1678	16560623921000
62832	2133	98991984000
62833	1874	497000
62834	2133	98990982000
62835	1874	499000
62836	1506	10081163967172
62837	1506	10081185967172
62838	2133	98989980000
62839	1874	501000
62840	2133	98988978000
62841	1874	503000
62842	1706	9572144600135
62843	1395	57900410945533706
62844	1395	57900410947533706
62845	1695	9692205000000
62846	1646	1440011000000
62847	1646	1440013000000
62848	2133	98987976000
62849	1874	505000
62850	2133	98986974000
62851	1874	507000
62852	1714	10246284103056
62853	1397	1350441178000
62854	1678	16560623922000
62855	2133	98985972000
62856	1874	509000
62857	1714	10966284103056
62858	1714	10966295103056
62859	1397	1350431177000
62860	1678	16560623923000
62861	1686	7411940550062
62862	2133	98984970000
62863	1874	511000
62864	1686	8131940550062
62865	1686	8131941550062
62866	1397	1350421176000
62867	1678	16560623924000
62868	2133	98983968000
62869	1874	513000
62870	2097	200000023
62871	1395	57900410945533705
62872	2097	57900410956533704
62873	1395	200000024
62916	1397	1350351169000
62917	1678	16560623931000
62918	2133	98976954000
62919	1395	57900410956533706
62925	1695	9692214000000
62941	1394	90721443000000
62942	1394	90721466000000
62958	1397	1350281162000
62959	1678	16560623938000
62960	1397	1350271161000
62961	1678	16560623939000
62962	2133	98969940000
62963	1874	548000
62964	2134	98997994000
62965	2134	98996991000
62966	2133	98968938000
62967	1587	16560505000000
62968	1587	16560529000000
62976	1394	90721456000000
62990	1397	1350231157000
62991	1678	16560623943000
62992	2133	98964930000
62993	2134	98992979000
62994	1874	577000
62995	1610	10800302000000
62998	1672	18002031000000
62999	1672	18002043000000
63001	1397	1350221156000
63002	1678	16560623944000
63003	2133	98963928000
63004	1874	579000
63005	2134	98991976000
63006	1874	582000
63007	2132	148993994000
63010	1694	14412476127629
63013	1555	8115206979096
63014	1555	8115219979096
63047	1395	57901130956533706
63048	1395	57901130969533706
63072	1397	1350151149000
63073	1678	16560623951000
63074	1397	1350141148000
63075	1678	16560623952000
63076	2133	98957916000
63077	1874	615000
63078	2134	98984955000
63079	1874	618000
63080	2134	98983952000
63081	1874	621000
63082	1555	7395229979096
63083	2133	98956914000
63084	1555	8115229979096
63085	1555	8115230979096
63094	1786	200000012
63095	1649	17564222999982
63096	1649	17564234999982
63105	1397	1350111145000
63106	1678	16560623955000
63107	2133	98953908000
63108	1874	636000
63109	2134	98980943000
63110	1874	639000
63111	1549	16175795000000
63112	1549	16175807000000
63128	1759	12240750999999
63135	1397	1350071141000
63136	1678	16560623959000
63137	2133	98949900000
63138	1874	657000
63139	2134	98976931000
63140	1874	660000
63141	1402	45934410319298
63161	1397	1350031137000
63162	1678	16560623963000
63163	2133	98945892000
63164	1874	678000
63165	2134	98972919000
63166	1874	681000
63167	1685	97921910571430
63168	1685	97921922571430
63190	1395	57902570992533706
63191	1395	57902571016533706
63193	42	88318286000000
63230	1402	46654410319298
63231	1402	46654423319298
63232	1397	1349951129000
63233	1678	16560623971000
63234	2133	98937876000
63235	2134	98964895000
63236	1768	14270787110000
63237	1768	14270799110000
63240	1397	1349941128000
63241	1678	16560623972000
63242	2134	98963892000
63243	2133	98936874000
63244	1874	729000
63245	1447	13834523943000
63246	1447	13834535943000
63248	1547	9933344000000
63265	2133	98935872000
63266	1874	738000
63267	2133	98934870000
63268	1709	10080140999976
63270	1593	13509989000000
63276	1397	1349901124000
63277	1678	16560623976000
63278	2134	98959880000
63279	2133	98932866000
63280	1703	5040662000000
63299	1569	845000000
63300	485	68158999000000
63301	2134	98957874000
63302	1874	759000
63303	2134	98956871000
63310	1724	7149333000000
63320	1637	182884990819988
63321	1637	182885005819988
63363	1684	14371392880623
63364	1684	14371404880623
63367	1397	1349791113000
63368	1678	16560623987000
63369	2133	98921844000
63370	2134	98948847000
63371	2132	148980981000
63372	1874	809000
63373	1679	38268068652000
63374	1679	38268081652000
63376	1710	14635973473290
63377	1874	267000
63378	1726	646056323000
63379	1726	646055322000
63380	1874	268000
63381	1726	646054320000
63382	1874	270000
63383	1726	646053319000
63384	1874	271000
63385	1726	646052317000
63386	1874	273000
63387	1726	646051316000
63388	1874	274000
63389	1726	646050315000
63390	1874	275000
63391	1726	646049313000
63392	1874	277000
63393	1726	646048312000
63394	1874	278000
63395	1726	646047310000
63396	1874	280000
63397	1726	646046309000
63398	1874	281000
63399	1726	646045307000
63400	1874	283000
63401	1726	646044306000
63402	1874	284000
63403	1726	646043305000
63404	1874	285000
63405	1726	646042303000
63406	1874	287000
63407	1726	646041302000
63408	1874	288000
63409	1726	646040300000
63410	1874	290000
63411	1726	646039299000
63412	1874	291000
63413	1726	646038297000
63414	1874	293000
63415	1726	646037296000
63416	1874	294000
63417	1726	646036294000
63418	1874	296000
63419	1726	646035293000
63420	1874	297000
63421	1726	646034292000
63422	1874	298000
63423	1726	646033290000
63424	1874	300000
63425	1726	646032289000
63426	1874	301000
63427	1726	646031287000
62874	1394	87841398000000
62875	1394	87841409000000
62913	1698	11337001550035
62914	1508	13716279500009
62915	1508	13716291500009
62920	1397	1350341168000
62921	1678	16560623932000
62922	2133	98975952000
62923	1874	531000
62924	1688	102602648904000
62931	1397	1350321166000
62932	1678	16560623934000
62933	1397	1350311165000
62934	1678	16560623935000
62935	2133	98973948000
62936	2133	98972946000
62937	1874	537000
62938	2132	148996997000
62939	1506	10801185967172
62940	1506	10801208967172
62943	1397	1350301164000
62944	1678	16560623936000
62945	2133	98971944000
62946	1874	540000
62947	1394	90721454000000
62969	1397	1350261160000
62970	1678	16560623940000
62971	2132	148994995000
62972	2134	98995988000
62973	2133	98967936000
62974	1599	10419829393047
62975	1599	10419842393047
63000	1685	97201910571430
63008	1448	6516736000001
63009	1448	6516749000001
63011	641	76419958000000
63012	641	76419971000000
63015	1874	549000
63016	1874	552000
63017	1874	555000
63018	1874	558000
63019	1874	561000
63020	1874	564000
63021	1874	571000
63022	1874	573000
63023	1448	6516798000001
63038	1397	1350191153000
63039	1678	16560623947000
63040	2134	98988967000
63041	1874	594000
63042	2132	148992993000
63043	2133	98961924000
63044	1874	597000
63045	2039	12961383000000
63046	2039	12961396000000
63049	75	67440000000000
63050	75	67440013000000
63142	1397	1350061140000
63143	1678	16560623960000
63144	2134	98975928000
63145	1874	663000
63146	2132	148988989000
63147	2133	98948898000
63148	1874	666000
63149	1440	9359154000000
63150	1440	9359167000000
63169	1397	1350021136000
63170	1678	16560623964000
63171	2132	148987988000
63172	1874	682000
63173	2133	98944890000
63174	1874	684000
63175	2134	98971916000
63176	1874	687000
63177	1719	10100441000000
63196	1397	1349991133000
63197	1678	16560623967000
63198	1397	1349981132000
63199	1678	16560623968000
63200	2133	98941884000
63201	1874	699000
63202	2134	98968907000
63203	1874	702000
63204	2134	98967904000
63205	1874	705000
63206	2133	98940882000
63207	2132	148986987000
63208	1874	708000
63209	1706	9572167600135
63212	1646	2160013000000
63213	1646	2160038000000
63238	633	80284072900000
63239	633	80284084900000
63247	2039	12961394000000
63251	1594	15745249000000
63252	1594	15745261000000
63271	1397	1349911125000
63272	1678	16560623975000
63273	2133	98933868000
63274	2134	98960883000
63275	1593	13510001000000
63290	1708	8675755000021
63291	1708	8675768000021
63292	1397	1349881122000
63293	1678	16560623978000
63294	1724	6429318000000
63295	1397	1349871121000
63296	1678	16560623979000
63297	1724	7149318000000
63298	1450	10000000
63304	532	69600059000000
63305	2133	98930862000
63306	1874	758000
63307	2133	98929860000
63308	532	70320059000000
63309	532	70320074000000
63311	1397	1349861120000
63312	1678	16560623980000
63313	2132	148982983000
63314	1874	765000
63315	2134	98955868000
63316	1874	770000
63317	2133	98928858000
63318	1696	12017338835100
63319	1696	12017353835100
63322	1874	761000
63323	1696	12017356835100
63375	1457	12864303040000
63459	1397	1349741108000
63460	1678	16560623992000
63461	2133	98916834000
63462	1874	832000
63463	2134	98943832000
63464	1394	92161456000000
63465	1394	92161468000000
63474	1402	46654422319298
63486	1397	1349711105000
63487	1678	16560623995000
63488	2133	98913828000
63489	1874	848000
63490	2134	98940823000
63491	1874	851000
63492	1489	9263943000000
63493	1489	9263955000000
63563	1690	106563411000000
63564	1690	107283411000000
63565	1690	107283414000000
63585	1395	57902571017533706
63607	1397	1349551089000
63608	1678	16560624011000
63609	1397	1349541088000
63610	1678	16560624012000
63611	2133	98898798000
63612	2133	98897796000
63613	2134	98924775000
63614	2134	98923772000
63615	1444	12815130159999
63653	1397	1349471081000
63654	1678	16560624019000
63655	1397	1349461080000
63656	1678	16560624020000
63657	2134	98916751000
63658	1874	974000
63659	2134	98915748000
63660	1874	977000
63661	2132	148970971000
63662	2133	98890782000
63663	1874	980000
63664	2133	98889780000
63665	1395	57903291017533706
63666	1395	57903291042533706
63669	1394	96481518000000
63682	1397	1349431077000
63683	1678	16560624023000
63684	2134	98912739000
63685	1874	995000
63686	2133	98886774000
63687	1455	7954024000000
63688	1455	7954036000000
63690	1397	1349421076000
63691	1678	16560624024000
63692	2134	98911736000
63693	2133	98885772000
63694	2132	148969970000
63695	1716	13006817000000
62876	1397	1350411175000
62877	1678	16560623925000
62878	2133	98982966000
62879	1874	515000
62880	1711	14204599000000
62881	1711	14204610000000
62884	1397	1350401174000
62885	1678	16560623926000
62886	2133	98981964000
62887	1602	11520466000000
62890	1394	89281409000000
62891	1394	89281420000000
62892	1397	1350391173000
62893	1678	16560623927000
62894	1397	1350381172000
62895	1678	16560623928000
62896	1397	1350371171000
62897	1678	16560623929000
62898	2132	148998999000
62899	1874	518000
62900	2133	98980962000
62901	2133	98979960000
62902	1874	522000
62903	2133	98978958000
62904	1874	524000
62905	1394	89281443000000
62948	606	72477748812962
62957	1448	5796736000001
62984	1569	720834000000
63024	1397	1350211155000
63025	1678	16560623945000
63026	2133	98962926000
63027	1874	585000
63028	2134	98990973000
63029	1874	588000
63030	1723	16199468085979
63031	1723	16199480085979
63034	1397	1350201154000
63035	1678	16560623946000
63036	2134	98989970000
63037	1874	591000
63051	1397	1350181152000
63052	1678	16560623948000
63053	1397	1350171151000
63054	1678	16560623949000
63055	2134	98987964000
63056	1874	600000
63057	2134	98986961000
63058	1874	603000
63059	2133	98960922000
63060	2133	98959920000
63061	1395	57901130980533706
63070	1714	11686295103056
63071	1714	11686308103056
63092	1395	57901850980533706
63093	1395	57901850992533706
63097	1397	1350121146000
63098	1678	16560623954000
63099	2133	98954910000
63100	1874	630000
63101	2132	148990991000
63102	1874	631000
63103	2134	98981946000
63104	1690	105123326000000
63115	1397	1350101144000
63116	1678	16560623956000
63117	1397	1350091143000
63118	1678	16560623957000
63119	2134	98979940000
63120	1874	642000
63121	2134	98978937000
63122	1874	645000
63123	2133	98952906000
63124	2133	98951904000
63125	2132	148989990000
63126	1715	35280589000002
63127	1715	35280614000002
63129	1397	1350081142000
63130	1678	16560623958000
63131	2134	98977934000
63132	2133	98950902000
63133	1637	181444954819988
63134	1637	181444966819988
63151	1397	1350051139000
63152	1678	16560623961000
63153	1397	1350041138000
63154	1678	16560623962000
63155	2133	98947896000
63156	2134	98974925000
63157	2134	98973922000
63158	2133	98946894000
63159	1637	182164966819988
63160	1637	182164990819988
63178	1397	1350011135000
63179	1678	16560623965000
63180	1397	1350001134000
63181	1678	16560623966000
63182	2134	98970913000
63183	1874	690000
63184	2134	98969910000
63185	1874	693000
63186	2133	98943888000
63187	2133	98942886000
63188	1634	15311786641004
63189	1634	15311810641004
63192	1675	10942204999977
63194	1692	72022784019999
63195	1692	72022797019999
63210	1714	12406308103056
63211	1714	12406333103056
63214	1397	1349971131000
63215	1678	16560623969000
63216	2133	98939880000
63217	2134	98966901000
63218	1634	15311798641004
63221	1397	1349961130000
63222	1678	16560623970000
63223	2132	148985986000
63224	1874	714000
63225	2133	98938878000
63226	2134	98965898000
63227	1746	6994336000000
63228	1746	6994349000000
63254	1397	1349931127000
63255	1678	16560623973000
63256	1397	1349921126000
63257	1678	16560623974000
63258	2134	98962889000
63259	1874	732000
63260	2134	98961886000
63261	1874	735000
63262	2132	148984985000
63263	1709	10080115999976
63264	1709	10080138999976
63269	1573	5018906000000
63281	1397	1349891123000
63282	1678	16560623977000
63283	2134	98958877000
63284	1874	753000
63285	2132	148983984000
63286	2133	98931864000
63287	1688	102602650904000
63324	1397	1349851119000
63325	1678	16560623981000
63326	2133	98927856000
63327	2134	98954865000
63335	1397	1349831117000
63336	1678	16560623983000
63337	1397	1349821116000
63338	1678	16560623984000
63339	1397	1349811115000
63340	1678	16560623985000
63341	2132	148981982000
63342	2133	98925852000
63343	1874	785000
63344	2133	98924850000
63345	1874	787000
63346	2133	98923848000
63347	2134	98952859000
63348	2134	98951856000
63349	2134	98950853000
63350	1690	106563339000000
63351	1690	106563376000000
63356	1397	1349801114000
63357	1678	16560623986000
63358	2133	98922846000
63359	1874	800000
63360	2134	98949850000
63361	1874	803000
63362	1444	12815108159999
63365	1749	6725186000000
63366	1749	6725198000000
63477	1397	1349721106000
63478	1678	16560623994000
63479	2134	98941826000
63480	2133	98914830000
63481	1874	845000
63482	2132	148978979000
63483	1394	93601481000000
63501	1397	1349691103000
63502	1678	16560623997000
63503	1397	1349681102000
63504	1678	16560623998000
63505	2132	148977978000
63506	1874	857000
62882	1679	37548057652000
62883	1679	37548068652000
62888	1729	19007182000000
62889	1729	19007193000000
62906	1397	1350361170000
62907	1678	16560623930000
62908	2132	148997998000
62909	1874	525000
62910	2133	98977956000
62911	1688	102602637904000
62912	1688	102602649904000
62926	1397	1350331167000
62927	1678	16560623933000
62928	2133	98974950000
62929	1709	9360104999976
62930	1709	9360115999976
62949	1397	1350291163000
62950	1678	16560623937000
62951	2134	98998997000
62952	1874	543000
62953	2132	148995996000
62954	2133	98970942000
62955	1874	546000
62956	2106	2159047000000
62977	1397	1350251159000
62978	1678	16560623941000
62979	2134	98994985000
62980	1874	565000
62981	2133	98966934000
62982	1874	567000
62983	1684	13651392880623
62985	1397	1350241158000
62986	1678	16560623942000
62987	2133	98965932000
62988	2134	98993982000
62989	1569	720846000000
62996	1850	10718886000000
62997	1850	10718898000000
63032	1611	25190955000000
63033	1611	25190967000000
63062	1397	1350161150000
63063	1678	16560623950000
63064	2134	98985958000
63065	1874	610000
63066	2132	148991992000
63067	2133	98958918000
63068	1675	10942180999977
63069	1675	10942193999977
63086	1397	1350131147000
63087	1678	16560623953000
63088	2134	98982949000
63089	2133	98955912000
63090	1649	17564222999992
63091	1649	17564234999992
63113	1695	10412214000000
63114	1695	10412226000000
63219	1705	9275474500145
63220	1705	9275486500145
63229	1467	5006641100039
63249	42	89038286000000
63250	42	89038298000000
63253	2039	12961395000000
63288	1690	105843326000000
63289	1690	105843339000000
63328	1397	1349841118000
63329	1678	16560623982000
63330	2133	98926854000
63331	1874	779000
63332	2134	98953862000
63333	1874	782000
63334	1588	13174934000000
63352	1874	420000
63353	1726	645950170000
63354	1444	12815096159999
63355	1444	12815097159999
63435	1397	1349781112000
63436	1678	16560623988000
63437	1397	1349771111000
63438	1678	16560623989000
63439	1397	1349761110000
63440	1678	16560623990000
63441	2132	148979980000
63442	1874	810000
63443	2133	98920842000
63444	1874	812000
63445	2133	98919840000
63446	2133	98918838000
63447	2134	98947844000
63448	2134	98946841000
63449	2134	98945838000
63450	2135	719000000000
63451	2135	719037000000
63468	1397	1349731107000
63469	1678	16560623993000
63470	2134	98942829000
63471	1874	838000
63472	2133	98915832000
63473	1395	57902571004533706
63528	1397	1349651099000
63529	1678	16560624001000
63530	2134	98934805000
63531	1874	881000
63532	2133	98907816000
63533	1394	95041481000000
63534	1394	95041493000000
63539	1564	8466364000000
63540	1564	8466376000000
63541	1397	1349631097000
63542	1678	16560624003000
63543	1397	1349621096000
63544	1678	16560624004000
63545	1397	1349611095000
63546	1678	16560624005000
63547	2132	148975976000
63548	129	66000025022968
63549	2136	453000000000
63550	2134	98932799000
63551	1874	892000
63552	2133	98905812000
63553	2133	98904810000
63554	1874	896000
63555	1455	6514021000000
63556	2133	98903808000
63557	1874	898000
63558	2134	98931796000
63559	2134	98930793000
63560	1874	904000
63561	1455	7234021000000
63562	1455	7234024000000
63566	365	66619901000000
63567	2137	99000000000
63568	1397	1349601094000
63569	1678	16560624006000
63570	2134	98929790000
63571	1711	14204710000000
63592	1394	96481493000000
63593	1394	96481505000000
63638	1696	12017487835100
63641	1397	1349491083000
63642	1678	16560624017000
63643	1397	1349481082000
63644	1678	16560624018000
63645	2132	148971972000
63646	2134	98918757000
63647	2134	98917754000
63648	2133	98892786000
63649	2133	98891784000
63650	1874	971000
63651	1749	7445198000000
63652	1749	7445223000000
63672	1397	1349451079000
63673	1678	16560624021000
63674	1397	1349441078000
63675	1678	16560624022000
63676	2134	98914745000
63677	2134	98913742000
63678	2133	98887776000
63679	1874	992000
63680	1402	47374422319298
63681	1402	47374446319298
63718	1397	1349371071000
63719	1678	16560624029000
63720	2134	98907724000
63721	2133	98880762000
63722	1395	57903291029533706
63745	1397	1349331067000
63746	1678	16560624033000
63747	2133	98876754000
63748	2134	98903712000
63749	1573	5738906000000
63750	1573	5738918000000
63785	1692	72022830019999
63807	1740	9161335000000
63808	1740	9161352000000
63813	2133	98867736000
63814	2134	98894685000
63815	1637	183605005819988
63816	1637	183605017819988
63857	1397	1349181052000
63858	1678	16560624048000
63859	1397	1349171051000
63860	1678	16560624049000
63861	2133	98861724000
63862	1874	1124000
63863	2133	98860722000
63428	1874	303000
63429	1726	646030286000
63430	1874	304000
63431	1726	646029284000
63432	1874	306000
63433	1710	15355973473290
63434	1710	15356811473290
63452	1397	1349751109000
63453	1678	16560623991000
63454	2134	98944835000
63455	2133	98917836000
63456	1874	830000
63457	1451	9258896000000
63458	1451	9258908000000
63466	1611	25910967000000
63467	1611	25910979000000
63475	1394	93601468000000
63476	1394	93601480000000
63484	606	73197748812962
63485	606	73197761812962
63494	1397	1349701104000
63495	1678	16560623996000
63496	2133	98912826000
63497	2134	98939820000
63498	1874	856000
63499	1467	5726641100039
63500	1467	5726653100039
63512	1397	1349671101000
63513	1678	16560623999000
63514	1397	1349661100000
63515	1678	16560624000000
63516	2133	98909820000
63517	1874	869000
63518	2133	98908818000
63519	2132	148976977000
63520	1874	872000
63521	129	66444026022968
63522	2136	9000000000
63523	2134	98936811000
63524	1874	875000
63525	2134	98935808000
63526	1874	878000
63527	1668	13646692000000
63573	1397	1349591093000
63574	1678	16560624007000
63575	1397	1349581092000
63576	1678	16560624008000
63577	2134	98928787000
63578	2133	98902806000
63579	2134	98927784000
63580	2133	98901804000
63581	1874	917000
63582	2132	148974975000
63583	1546	10080799000000
63584	1546	10080824000000
63603	1474	11074422000023
63604	688	66000100000000
63605	1444	13535097159999
63606	1444	13535209159999
63616	1518	10080381000000
63617	1518	10080415000000
63618	688	66000000000000
63619	1397	1349531087000
63620	1678	16560624013000
63621	1397	1349521086000
63622	1678	16560624014000
63623	1397	1349511085000
63624	1678	16560624015000
63625	1397	1349501084000
63626	1678	16560624016000
63627	2132	148972973000
63628	2134	98922769000
63629	2133	98896794000
63630	2133	98895792000
63631	1874	947000
63632	2133	98894790000
63633	2133	98893788000
63634	2134	98921766000
63635	2134	98920763000
63636	2134	98919760000
63637	58	83226654999641
63639	1633	9396397985638
63640	1633	9396546985638
63667	470	77520383000000
63668	470	77520408000000
63670	2133	98888778000
63671	470	77520409000000
63697	1397	1349411075000
63698	1678	16560624025000
63699	1397	1349401074000
63700	1678	16560624026000
63701	1397	1349391073000
63702	1678	16560624027000
63703	2133	98884770000
63704	2132	148968969000
63705	2134	98910733000
63706	2134	98909730000
63707	2133	98883768000
63708	2133	98882766000
63709	1874	1016000
63710	1587	17280529000000
63711	1587	17280565000000
63730	1697	401990000000
63731	1397	1349351069000
63732	1678	16560624031000
63733	1397	1349341068000
63734	1678	16560624032000
63735	2133	98878758000
63736	1874	1034000
63737	2133	98877756000
63738	2134	98905718000
63739	2134	98904715000
63740	1599	10419863393047
63743	1394	97921518000000
63744	1394	97921552000000
63761	1397	1349311065000
63762	1678	16560624035000
63763	2134	98901706000
63764	2133	98874750000
63765	1874	1058000
63766	1560	12834274277001
63767	1560	12834286277001
63768	1397	1349301064000
63769	1678	16560624036000
63770	1397	1349291063000
63771	1678	16560624037000
63772	1397	1349281062000
63773	1678	16560624038000
63774	1397	1349271061000
63775	1678	16560624039000
63776	2132	148965966000
63777	1504	437235000000
63778	1697	1001990000000
63779	2134	98900703000
63780	2134	98899700000
63781	2134	98898697000
63782	2134	98897694000
63783	149	82110225000341
63784	149	82110271000341
63786	1397	1349261060000
63787	1678	16560624040000
63788	2134	98896691000
63789	2132	148964965000
63790	369	99270885000000
63791	369	99270897000000
63824	1395	57904011029533706
63825	1395	57904011041533706
63833	1555	8835230979096
63834	1555	8835243979096
63849	1397	1349191053000
63850	1678	16560624047000
63851	2133	98862726000
63852	1874	1118000
63853	2132	148962963000
63854	2134	98889670000
63855	1395	57904731041533706
63856	1395	57904731054533706
63881	149	82110246000341
63959	1397	1349031037000
63960	1678	16560624063000
63961	2134	98873622000
63962	1874	1204000
63963	2133	98846694000
63964	1691	11483136100019
63967	1397	1349021036000
63968	1678	16560624064000
63969	2132	148957958000
63970	2134	98872619000
63971	1874	1210000
63985	1397	1348991033000
63986	1678	16560624067000
63987	2132	148956957000
63988	2133	98843688000
63989	1874	1220000
63990	2134	98870613000
63991	1874	1223000
63992	2134	98869610000
63993	1874	1226000
63994	1395	57906171082533706
64017	2134	98866601000
64018	1874	1240000
64019	1687	11512739524804
64052	2134	98864595000
64053	1874	1250000
64054	2134	98863592000
63507	2133	98911824000
63508	2134	98938817000
63509	2134	98937814000
63510	2133	98910822000
63511	1633	8676397985638
63535	1397	1349641098000
63536	1678	16560624002000
63537	2133	98906814000
63538	2134	98933802000
63572	1711	14204709000000
63586	1397	1349571091000
63587	1678	16560624009000
63588	2133	98900802000
63589	1874	920000
63590	2134	98926781000
63591	1874	923000
63594	1397	1349561090000
63595	1678	16560624010000
63596	2134	98925778000
63597	1874	926000
63598	2133	98899800000
63599	2132	148973974000
63600	1874	929000
63601	1698	12057001550035
63602	1698	12057014550035
63689	1654	14688133999798
63696	1691	11483137100019
63723	1397	1349361070000
63724	1678	16560624030000
63725	2132	148967968000
63726	2134	98906721000
63727	2133	98879760000
63728	1711	14924710000000
63729	1711	14924723000000
63751	1397	1349321066000
63752	1678	16560624034000
63753	1504	937236000000
63754	1697	501990000000
63755	2133	98875752000
63756	1874	1049000
63757	2132	148966967000
63758	2134	98902709000
63759	1560	12114260277001
63760	1560	12114274277001
63800	1397	1349251059000
63801	1678	16560624041000
63802	2134	98895688000
63803	1874	1082000
63804	1874	1088000
63805	2133	98868738000
63806	111	68880057000000
63809	1397	1349241058000
63810	1678	16560624042000
63811	1710	14634589473290
63812	1710	14634599473290
63837	1397	1349211055000
63838	1678	16560624045000
63839	1397	1349201054000
63840	1678	16560624046000
63841	2134	98891676000
63842	1874	1109000
63843	2134	98890673000
63844	1874	1112000
63845	2133	98864730000
63846	2133	98863728000
63847	1402	48094446319298
63848	1402	48094470319298
63892	1397	1349131047000
63893	1678	16560624053000
63894	2133	98856714000
63895	2134	98883652000
63896	1874	1153000
63897	1671	12288434530515
63898	1671	12288446530515
63908	1668	14366692000000
63909	1668	14366705000000
63931	1397	1349081042000
63932	1678	16560624058000
63933	1397	1349071041000
63934	1678	16560624059000
63935	1397	1349061040000
63936	1678	16560624060000
63937	1397	1349051039000
63938	1678	16560624061000
63939	1397	1349041038000
63940	1678	16560624062000
63941	2132	148958959000
63942	576	76595791938283
63943	2134	98878637000
63944	2133	98851704000
63945	1874	1181000
63946	2133	98850702000
63947	2133	98849700000
63948	2133	98848698000
63949	1874	1187000
63950	2133	98847696000
63951	2134	98877634000
63952	1874	1192000
63953	2134	98876631000
63954	2134	98875628000
63955	1874	1198000
63956	2134	98874625000
63957	576	77315791938283
63958	576	77315801938283
63978	1683	27215449399541
63979	1393	76061442306600000
63980	1397	1349001034000
63981	1678	16560624066000
63982	2133	98844690000
63983	1874	1217000
63984	1710	14634610473290
64001	2134	98868607000
64002	1874	1229000
64011	1397	1348961030000
64012	1678	16560624070000
64013	2132	148955956000
64014	2133	98840682000
64015	1687	11512726524804
64016	1687	11512738524804
64032	1688	100006778076000
64033	31	1327209135594000
64034	1688	99821618771000
64035	32	74107429462000
64036	1688	99655639030000
64037	40	66430661911000
64038	1397	1348941028000
64039	1678	16560624072000
64040	1397	1348931027000
64041	1678	16560624073000
64042	1397	1348921026000
64043	1678	16560624074000
64044	1688	99585775343000
64045	779	27959474083792
64046	2133	98838678000
64047	2133	98837676000
64048	2133	98836674000
64049	1874	1253000
64050	2132	148954955000
64051	1747	5056945000000
64060	1704	2226284000000
64134	1679	36723797703000
64135	1	374891644742000
64136	1679	36539289298000
64137	841	83913851142298
64138	1397	1348841018000
64139	1678	16560624082000
64140	1679	36195307741000
64141	843	156445677530667
64142	1679	33648595836000
64143	849	1158293913161640
64144	1679	28715239930000
64145	851	2243792044281750
64146	1397	1348831017000
64147	1678	16560624083000
64148	1727	8826961000000
64149	1397	1348821016000
64150	1678	16560624084000
64151	1679	28171249166000
64152	853	247414175730225
64153	1679	27883493729000
64154	855	130872826396125
64155	1679	27157937909000
64156	857	329993876187608
64157	1679	26155780008000
64158	861	455798464345125
64159	2133	98828658000
64160	2134	98854565000
64161	1874	1305000
64162	2134	98853562000
64163	1874	1308000
64164	2133	98827656000
64165	2133	98826654000
64166	1874	1312000
64167	2134	98852559000
64168	2132	148951952000
64169	1727	9546961000000
64170	1509	9546973900000
64171	1727	10031839951155
64179	1508	12996349500009
64180	1508	13716349500009
64181	1508	13716406500009
64197	1637	184325017819988
64198	1637	184325049819988
64210	1685	99361945571430
64211	1685	99361977571430
63712	1397	1349381072000
63713	1678	16560624028000
63714	2133	98881764000
63715	2134	98908727000
63716	389	68160046000000
63717	389	68160058000000
63741	1686	8851941550062
63742	1686	8851975550062
63792	2133	98873748000
63793	2133	98872746000
63794	1874	1079000
63795	2133	98871744000
63796	2133	98870742000
63797	2133	98869740000
63798	1874	1085000
63799	369	99270902000000
63817	1397	1349231057000
63818	1678	16560624043000
63819	2134	98893682000
63820	2133	98866734000
63821	1874	1100000
63822	1670	15121065000000
63823	1670	15121077000000
63826	1397	1349221056000
63827	1678	16560624044000
63828	2134	98892679000
63829	1874	1103000
63830	2132	148963964000
63831	2133	98865732000
63832	1874	1106000
63835	1692	72742830019999
63836	1692	72742842019999
63869	1397	1349161050000
63870	1678	16560624050000
63871	1397	1349151049000
63872	1678	16560624051000
63873	2132	148961962000
63874	1874	1133000
63875	2134	98886661000
63876	1874	1136000
63877	2134	98885658000
63878	1874	1139000
63879	1685	98641922571430
63880	1685	98641945571430
63882	1397	1349141048000
63883	1678	16560624052000
63884	2133	98859720000
63885	1874	1141000
63886	2133	98858718000
63887	2134	98884655000
63888	2133	98857716000
63889	1874	1148000
63890	1395	57905451054533706
63891	1395	57905451068533706
63922	1397	1349091043000
63923	1678	16560624057000
63924	2134	98879640000
63925	1874	1172000
63926	2133	98852706000
63927	1874	1174000
63928	2132	148959960000
63929	1874	1175000
63930	1394	97921531000000
63995	1397	1348981032000
63996	1678	16560624068000
63997	2133	98842686000
63998	1874	1228000
63999	1687	10792715524804
64000	1687	10792726524804
64020	1395	58023263863007706
64021	1593	14229989000000
64022	1593	14230133000000
64031	1719	10820441000000
64062	1397	1348911025000
64063	1678	16560624075000
64064	1397	1348901024000
64065	1678	16560624076000
64066	1397	1348891023000
64067	1678	16560624077000
64068	1688	98817375454000
64069	780	307553946521051
64070	1688	92670370668000
64071	782	2460381810083720
64072	1688	92111542473000
64073	785	223671268846807
64074	1688	85964537687000
64075	786	2460381810083720
64076	1688	85824820313000
64077	791	55918948168584
64078	1688	84288030535000
64079	792	615107893042101
64080	1688	84253096821000
64081	799	13978484472181
64082	1688	83868926300000
64083	800	153763195008607
64084	1688	83833986125000
64085	801	13981070685666
64086	2133	98835672000
64087	1874	1265000
64088	2133	98834670000
64089	2134	98861586000
64090	1874	1270000
64091	2134	98860583000
64092	2134	98859580000
64093	1874	1276000
64094	2133	98833668000
64095	2132	148953954000
64096	1980	14399302000000
64108	1692	72742862019999
64109	1397	1348871021000
64110	1678	16560624079000
64111	1397	1348861020000
64112	1678	16560624080000
64113	1397	1348851019000
64114	1678	16560624081000
64115	1688	80205770474000
64116	812	1190215947253140
64117	1688	75867910273000
64118	823	1736257813668760
64119	1688	28151589708000
64120	824	19098819282295700
64121	2133	98831664000
64122	1874	1286000
64123	2133	98830662000
64124	1874	1288000
64125	2134	98857574000
64126	2134	98856571000
64127	1874	1294000
64128	2134	98855568000
64129	2133	98829660000
64130	2132	148952953000
64131	1874	1300000
64132	1395	58030464021007706
64133	1395	58030464088007706
64175	1688	28151659708000
64176	1688	28871659708000
64177	1688	28871716708000
64186	1679	25275996603000
64187	865	400139905992417
64188	1679	19917968120000
64189	867	2436942285185000
64190	1679	19344959717000
64191	869	260612023343845
64192	2133	98825652000
64193	1874	1318000
64194	2134	98851556000
64195	1395	58031184088007706
64196	1395	58031184120007706
64199	1679	13986931234000
64200	873	2436942285185000
64201	1397	1348811015000
64202	1678	16560624085000
64203	1679	13517267762000
64204	875	213608521244583
64205	2133	98824650000
64206	1874	1323000
64207	2134	98850553000
64208	1874	1326000
64209	1623	49682574899898
64275	1397	1348741008000
64276	1678	16560624092000
64277	2133	98817636000
64278	1874	1360000
64279	2134	98843532000
64280	1684	15091404880623
64281	1684	15091416880623
64286	1489	9983967000000
64287	1397	1348731007000
64288	1678	16560624093000
64289	2132	148948949000
64290	2133	98816634000
64291	1874	1366000
64292	2134	98842529000
64293	1874	1369000
64296	58	83226518999641
64306	1395	58031184100007706
64325	1395	58031184125007706
64372	1397	1348630997000
64373	1678	16560624103000
64374	1397	1348620996000
64375	1678	16560624104000
64376	2134	98832499000
64377	2134	98831496000
64378	2133	98807616000
64379	1874	1422000
63864	2134	98888667000
63865	1874	1129000
63866	2134	98887664000
63867	1686	9571975550062
63868	1686	9571999550062
63899	1397	1349121046000
63900	1678	16560624054000
63901	2133	98855712000
63902	2132	148960961000
63903	1874	1156000
63904	2134	98882649000
63905	1874	1159000
63906	1457	13584303040000
63907	1457	13584316040000
63910	1397	1349111045000
63911	1678	16560624055000
63912	1397	1349101044000
63913	1678	16560624056000
63914	2133	98854710000
63915	1874	1161000
63916	2133	98853708000
63917	2134	98881646000
63918	2134	98880643000
63919	1874	1169000
63920	1688	103322650904000
63921	1688	103322674904000
63965	1395	57906171068533706
63966	1395	57906171080533706
63972	1397	1349011035000
63973	1678	16560624065000
63974	2133	98845692000
63975	2134	98871616000
63976	1602	12240466000000
63977	1602	12240478000000
64003	1397	1348971031000
64004	1678	16560624069000
64005	1677	9557256850100
64006	1395	58029023989007706
64007	2133	98841684000
64008	2134	98867604000
64009	1394	99361531000000
64010	1394	99361554000000
64023	1397	1348951029000
64024	1678	16560624071000
64025	2133	98839680000
64026	1874	1244000
64027	2134	98865598000
64028	1874	1247000
64029	1593	14230001000000
64030	1593	14230014000000
64058	1727	8826891000000
64059	1719	10820518000000
64178	1727	9547018000000
64212	1397	1348801014000
64213	1678	16560624086000
64214	1679	13219590069000
64215	879	135385682478750
64216	1679	11929686731000
64217	881	586671290741250
64218	1679	11731231602000
64219	883	90257121652500
64220	2132	148950951000
64221	2133	98823648000
64222	1874	1329000
64223	2134	98849550000
64224	1874	1332000
64225	1688	28871589708000
64226	1688	28871632708000
64229	1397	1348791013000
64230	1678	16560624087000
64231	1679	11138944255000
64232	887	269380502712154
64233	1679	10641749167000
64234	889	226130493445249
64235	1679	9550290958000
64236	891	496414169088750
64237	2133	98822646000
64238	2134	98848547000
64239	1594	16465261000000
64240	1594	16465303000000
64241	1679	9406305048000
64242	897	65483346900885
64243	1397	1348781012000
64244	1678	16560624088000
64245	1397	1348771011000
64246	1678	16560624089000
64247	1397	1348761010000
64248	1678	16560624090000
64249	1397	1348751009000
64250	1678	16560624091000
64251	1679	9320471499000
64252	899	39034399971990
64253	1679	9062482831000
64254	901	117334258148250
64255	1679	8134741853000
64256	905	421952043725938
64257	2132	148949950000
64258	1874	1338000
64259	2134	98847544000
64260	1874	1341000
64261	2134	98846541000
64262	1874	1344000
64263	2134	98845538000
64264	1874	1347000
64265	2134	98844535000
64266	1874	1350000
64267	2133	98821644000
64268	2133	98820642000
64269	1874	1354000
64270	2133	98819640000
64271	1874	1356000
64272	2133	98818638000
64273	1637	185045049819988
64274	1637	185045138819988
64299	1397	1348721006000
64300	1678	16560624094000
64301	2133	98815632000
64302	2134	98841526000
64303	1874	1374000
64304	1715	36000614000002
64305	1715	36000626000002
64327	1394	102241597000000
64328	1394	102241634000000
64339	1703	5760662000000
64340	1703	5760774000000
64353	606	73197772812962
64360	1397	1348640998000
64361	1678	16560624102000
64362	2133	98808618000
64363	1874	1411000
64364	2134	98833502000
64365	1874	1414000
64366	1657	10081339000000
64367	1657	10081351000000
64370	568	66720000000000
64371	568	66720012000000
64415	1397	1348600994000
64416	1678	16560624106000
64417	2133	98804610000
64418	2134	98829490000
64419	1874	1435000
64420	2132	148944945000
64421	1489	9263965000000
64422	1801	1439010000000
64423	1801	1439023000000
64455	1394	102241610000000
64485	470	77520384000000
64486	1397	1348520986000
64487	1678	16560624114000
64488	1394	102241607000000
64509	1397	1348490983000
64510	1678	16560624117000
64511	1397	1348480982000
64512	1678	16560624118000
64513	1397	1348470981000
64514	1678	16560624119000
64515	2133	98794590000
64516	1874	1489000
64517	2133	98793588000
64518	1874	1491000
64519	2133	98792586000
64520	2134	98818457000
64521	2134	98817454000
64522	2134	98816451000
64523	1394	102241633000000
64543	1397	1348440978000
64544	1678	16560624122000
64545	2134	98813442000
64546	2133	98789580000
64547	1874	1518000
64548	1684	15811417880623
64549	1684	15811429880623
64574	1637	186485150819988
64575	1637	186485162819988
64576	1397	1348390973000
64577	1678	16560624127000
64578	2134	98808427000
64579	2133	98784570000
64580	1874	1543000
64598	1402	49534482319298
64599	1402	49534506319298
64620	1419	17739322280064
64621	1419	17739333280064
64642	1397	1348290963000
64643	1678	16560624137000
64055	1874	1259000
64056	2134	98862589000
64057	1746	6994413000000
64061	1719	10820515000000
64097	1688	83449744529000
64098	802	153791643333275
64099	1688	83179404808000
64100	811	108201544180286
64101	1397	1348881022000
64102	1678	16560624078000
64103	2134	98858577000
64104	1874	1282000
64105	2133	98832666000
64106	1395	58029743989007706
64107	1395	58029744021007706
64172	1506	10801278967172
64173	1506	11521278967172
64174	1506	11521335967172
64182	1685	98642015571430
64183	1685	99362015571430
64184	1509	99362028471430
64185	1685	10031839951155
64284	1762	14721941994000
64285	1762	14721953994000
64294	1690	107283376000000
64295	1690	107283389000000
64307	1397	1348711005000
64308	1678	16560624095000
64309	1397	1348701004000
64310	1678	16560624096000
64311	1397	1348691003000
64312	1678	16560624097000
64313	2133	98814630000
64314	1874	1376000
64315	2134	98840523000
64316	1874	1379000
64317	2134	98839520000
64318	2134	98838517000
64319	2132	148947948000
64320	2133	98813628000
64321	1874	1388000
64322	2133	98812626000
64323	1689	10080192287625
64324	1689	10080229287625
64338	1714	12406420103056
64341	1397	1348671001000
64342	1678	16560624099000
64343	1397	1348661000000
64344	1678	16560624100000
64345	2132	148946947000
64346	2134	98836511000
64347	1874	1399000
64348	2134	98835508000
64349	1874	1402000
64350	2133	98810622000
64351	1467	6446653100039
64352	1467	6446677100039
64354	1397	1348650999000
64355	1678	16560624101000
64356	2133	98809620000
64357	1874	1406000
64358	2134	98834505000
64359	1690	107283388000000
64407	1397	1348610995000
64408	1678	16560624105000
64409	2134	98830493000
64410	1685	98641956571430
64411	2133	98805612000
64412	1874	1430000
64413	1685	99361956571430
64414	1685	99361957571430
64426	1623	50402574899898
64427	1623	50402587899898
64435	1397	1348580992000
64436	1678	16560624108000
64437	2133	98802606000
64438	1874	1443000
64439	2134	98827484000
64440	1874	1446000
64441	1637	185765138819988
64442	1637	185765150819988
64462	1397	1348540988000
64463	1678	16560624112000
64464	2134	98823472000
64465	1874	1465000
64466	1893	208900000
64467	2133	98798598000
64468	1874	1467000
64469	1422	8065027860211
64470	1422	8065040860211
64473	1397	1348530987000
64474	1678	16560624113000
64475	2132	148942943000
64476	1874	1468000
64477	2133	98797596000
64478	1874	1470000
64479	2134	98822469000
64480	1874	1473000
64481	1706	10292167600135
64482	1706	10292180600135
64533	1668	15086705000000
64534	1668	15086718000000
64535	1397	1348450979000
64536	1678	16560624121000
64537	2133	98790582000
64538	1874	1510000
64539	2134	98814445000
64540	1874	1513000
64541	554	67450011000000
64542	554	67450023000000
64601	1397	1348350969000
64602	1678	16560624131000
64603	1397	1348340968000
64604	1678	16560624132000
64605	2133	98780562000
64606	1874	1560000
64607	2134	98804415000
64608	1874	1563000
64609	2133	98779560000
64610	2134	98803412000
64611	1700	11825980276737
64612	1700	12545980276737
64615	1397	1348330967000
64616	1678	16560624133000
64617	2133	98778558000
64618	1637	187205174819988
64619	1637	187205185819988
64636	1397	1348300964000
64637	1678	16560624136000
64638	2134	98800403000
64639	2133	98775552000
64640	1874	1585000
64641	1546	10080811000000
64657	1397	1348270961000
64658	1678	16560624139000
64659	1397	1348260960000
64660	1678	16560624140000
64661	2133	98772546000
64662	1874	1597000
64663	2134	98797394000
64664	2134	98796391000
64665	1874	1603000
64666	2135	1439037000000
64667	2135	1439060000000
64675	1637	187205198819988
64676	1397	1348250959000
64677	1678	16560624141000
64678	2134	98795388000
64679	1874	1608000
64680	2133	98770542000
64681	1715	36720626000002
64682	1715	36720638000002
64691	1397	1348230957000
64692	1678	16560624143000
64693	1397	1348220956000
64694	1678	16560624144000
64695	2133	98768538000
64696	1874	1617000
64697	2133	98767536000
64698	2134	98793382000
64699	2134	98792379000
64700	1756	5507823575609
64701	1397	1348210955000
64702	1678	16560624145000
64703	2134	98791376000
64704	2133	98766534000
64705	1690	108003388000000
64706	1690	108003400000000
64716	1397	1348190953000
64717	1678	16560624147000
64718	1397	1348180952000
64719	1678	16560624148000
64720	1397	1348170951000
64721	1678	16560624149000
64722	2134	98789370000
64723	2134	98788367000
64724	1874	1639000
64725	2133	98765532000
64726	1874	1641000
64727	2133	98764530000
64728	2133	98763528000
64729	1874	1645000
64730	2134	98787364000
64731	1694	15132475127629
64732	1694	15132511127629
64227	1394	100801554000000
64228	1394	100801597000000
64282	1489	9983955000000
64283	1489	9983966000000
64297	1560	13554286277001
64298	1560	13554299277001
64326	43	78240826890000
64329	365	66569801000000
64330	2138	49000000000
64331	1397	1348681002000
64332	1678	16560624098000
64333	2133	98811624000
64334	1874	1392000
64335	2134	98837514000
64336	1874	1395000
64337	1702	7200396000000
64368	484	94080814000000
64369	484	94080826000000
64384	1395	58031904125007706
64385	1395	58031904150007706
64424	1801	1439020000000
64425	1801	1439033000000
64428	1397	1348590993000
64429	1678	16560624107000
64430	2133	98803608000
64431	1874	1438000
64432	2134	98828487000
64433	1918	2159137000000
64434	1918	2159149000000
64448	1397	1348560990000
64449	1678	16560624110000
64450	2133	98800602000
64451	1874	1453000
64452	2132	148943944000
64453	2134	98825478000
64454	1684	15091417880623
64456	1397	1348550989000
64457	1678	16560624111000
64458	2134	98824475000
64459	2133	98799600000
64460	1874	1462000
64461	1688	28871601708000
64493	1397	1348510985000
64494	1678	16560624115000
64495	470	77520405000000
64507	1601	5690167620000
64508	1601	5690191620000
64532	1695	10412227000000
64568	1397	1348400974000
64569	1678	16560624126000
64570	2134	98809430000
64571	1874	1536000
64572	2133	98785572000
64573	1402	48814482319298
64587	1397	1348370971000
64588	1678	16560624129000
64589	1397	1348360970000
64590	1678	16560624130000
64591	2133	98782566000
64592	2133	98781564000
64593	2134	98806421000
64594	1874	1555000
64595	2134	98805418000
64596	1693	7340383406843
64597	1693	7340407406843
64600	1637	186485174819988
64622	1397	1348320966000
64623	1678	16560624134000
64624	2133	98777556000
64625	1874	1572000
64626	2134	98802409000
64627	1874	1575000
64628	1679	8854741853000
64629	1679	8854753853000
64630	1397	1348310965000
64631	1678	16560624135000
64632	2133	98776554000
64633	2134	98801406000
64634	1698	12777014550035
64635	1698	12777026550035
64714	606	73917772812962
64715	606	73917783812962
64734	1397	1348160950000
64735	1678	16560624150000
64736	2133	98762526000
64737	1874	1650000
64738	2134	98786361000
64739	1874	1653000
64740	1587	18000565000000
64741	1587	18000577000000
64750	1573	6458918000000
64751	1573	6458930000000
64768	1688	30311614708000
64769	1688	30311626708000
64792	1397	1348080942000
64793	1678	16560624158000
64794	2134	98778337000
64795	2133	98754510000
64796	1874	1693000
64797	1394	105121657000000
64798	1394	105121669000000
64801	1397	1348070941000
64802	1678	16560624159000
64803	2134	98777334000
64804	2133	98753508000
64805	1874	1698000
64806	1716	13726817000000
64807	1716	13726829000000
64820	1397	1348040938000
64821	1678	16560624162000
64822	2133	98750502000
64823	1874	1710000
64824	2134	98774325000
64825	1874	1713000
64826	1637	188645210819988
64827	1637	188645222819988
64857	1637	189365222819988
64858	1637	189365234819988
64872	1623	51122587899898
64873	1623	51122611899898
64882	1397	1347960930000
64883	1678	16560624170000
64884	1397	1347950929000
64885	1678	16560624171000
64886	2133	98742486000
64887	2133	98741484000
64888	1874	1752000
64889	2134	98766301000
64890	1874	1755000
64891	2134	98765298000
64892	1874	1758000
64893	1747	5056895000000
64910	1397	1347920926000
64911	1678	16560624174000
64912	2134	98762289000
64913	1874	1771000
64914	2133	98738478000
64915	1874	1773000
64916	1690	108723400000000
64917	1690	108723412000000
64919	1397	1347910925000
64920	1678	16560624175000
64921	1397	1347900924000
64922	1678	16560624176000
64923	1397	1347890923000
64924	1678	16560624177000
64925	1397	1347880922000
64926	1678	16560624178000
64927	1397	1347870921000
64928	1678	16560624179000
64929	2134	98761286000
64930	1874	1776000
64931	112	66001941005524
64932	1821	527990000000
64933	2134	98760283000
64934	1874	1779000
64935	2134	98759280000
64936	1874	1782000
64937	2134	98758277000
64938	1874	1785000
64939	2134	98757274000
64940	1874	1788000
64941	2133	98737476000
64942	2133	98736474000
64943	2133	98735472000
64944	1874	1794000
64945	2133	98734470000
64946	2133	98733468000
64947	1573	7178930000000
64948	1573	7178991000000
64965	1397	1347840918000
64966	1678	16560624182000
64967	1397	1347830917000
64968	1678	16560624183000
64969	2134	98754265000
64970	1874	1811000
64971	2133	98730462000
64972	1874	1813000
64973	2133	98729460000
64974	1874	1815000
64975	2134	98753262000
64976	1710	15354634473290
64991	1689	10080204287625
64993	1397	1347800914000
64994	1678	16560624186000
64380	2133	98806614000
64381	2132	148945946000
64382	1705	9995486500145
64383	1705	9995511500145
64386	1395	58024703899007706
64387	1688	98566741076000
64388	1688	98381581771000
64389	1688	98215602030000
64390	1688	98145738343000
64391	1688	97377338454000
64392	1688	91230333668000
64393	1688	90671505473000
64394	1688	84524500687000
64395	1688	84384783313000
64396	1688	82847993535000
64397	1688	82813059821000
64398	1688	82428889300000
64399	1688	82393949125000
64400	1688	82009707529000
64401	1688	81739367808000
64402	1688	78765733474000
64403	1688	74427873273000
64404	1688	26711552708000
64405	171	75350988524688
64406	171	76070988524688
64443	1397	1348570991000
64444	1678	16560624109000
64445	2133	98801604000
64446	2134	98826481000
64447	1693	6620383406843
64471	1688	29591601708000
64472	1688	29591614708000
64483	1594	17185303000000
64484	1594	17185316000000
64489	2133	98796594000
64490	2134	98821466000
64491	1685	100081957571430
64492	1685	100081969571430
64496	1397	1348500984000
64497	1678	16560624116000
64498	2132	148941942000
64499	1874	1479000
64500	2134	98820463000
64501	1874	1482000
64502	2134	98819460000
64503	1874	1485000
64504	2133	98795592000
64505	1402	48814470319298
64506	1402	48814494319298
64524	1397	1348460980000
64525	1678	16560624120000
64526	2133	98791584000
64527	1874	1504000
64528	2132	148940941000
64529	2134	98815448000
64530	1710	15354610473290
64531	1710	15354623473290
64550	1397	1348430977000
64551	1678	16560624123000
64552	1397	1348420976000
64553	1678	16560624124000
64554	1397	1348410975000
64555	1678	16560624125000
64556	2134	98812439000
64557	1874	1521000
64558	2134	98811436000
64559	1874	1524000
64560	2134	98810433000
64561	1874	1527000
64562	2133	98788578000
64563	2133	98787576000
64564	1874	1531000
64565	2133	98786574000
64566	1874	1533000
64567	1692	72742866019999
64581	1397	1348380972000
64582	1678	16560624128000
64583	2133	98783568000
64584	1874	1545000
64585	2134	98807424000
64586	1874	1548000
64613	1685	100081993571430
64614	1685	100801993571430
64655	1764	10806874100000
64656	1764	10806898100000
64673	1419	18459333280064
64674	1419	18459357280064
64689	576	78035801938283
64690	576	78035813938283
64707	1692	73462866019999
64708	1692	73462878019999
64766	1654	15408133999798
64767	1654	15408145999798
64781	1397	1348100944000
64782	1678	16560624156000
64783	1397	1348090943000
64784	1678	16560624157000
64785	2134	98780343000
64786	1874	1681000
64787	2134	98779340000
64788	2133	98756514000
64789	1874	1686000
64790	2133	98755512000
64791	1489	9983979000000
64808	1739	26639738000000
64835	1397	1348020936000
64836	1678	16560624164000
64837	2134	98772319000
64838	2133	98748498000
64839	1874	1723000
64840	1701	10870336600056
64841	1701	10870348600056
64849	1699	6549802750126
64859	1397	1347990933000
64860	1678	16560624167000
64861	1397	1347980932000
64862	1678	16560624168000
64863	2133	98745492000
64864	1874	1735000
64865	2134	98769310000
64866	2133	98744490000
64867	1874	1740000
64868	2134	98768307000
64869	1874	1743000
64870	1471	15739686900000
64871	1471	15739710900000
64874	1759	12240749999999
64896	1704	2226231000000
64906	1397	1347930927000
64907	1678	16560624173000
64908	2134	98763292000
64909	2133	98739480000
64918	1596	14400652000000
64957	1397	1347850919000
64958	1678	16560624181000
64959	2134	98755268000
64960	1874	1806000
64961	2133	98731464000
64962	1874	1808000
64963	2039	13681395000000
64964	2039	13681407000000
64983	1397	1347810915000
64984	1678	16560624185000
64985	2133	98727456000
64986	1874	1825000
64987	2134	98751256000
64988	1874	1828000
64989	1458	14493629908540
64990	1458	14493641908540
65012	1397	1347770911000
65013	1678	16560624189000
65014	2134	98747244000
65015	1874	1846000
65016	2133	98723448000
65017	1692	74182890019999
65018	1692	74182902019999
65032	1602	12960478000000
65033	1602	12960490000000
65040	1397	1347730907000
65041	1678	16560624193000
65042	2134	98743232000
65043	2133	98719440000
65044	1675	10942192999977
65069	1397	1347680902000
65070	1678	16560624198000
65071	1397	1347670901000
65072	1678	16560624199000
65073	1397	1347660900000
65074	1678	16560624200000
65075	2132	148938939000
65076	1874	1887000
65077	2134	98739220000
65078	2134	98738217000
65079	1874	1893000
65080	2134	98737214000
65081	2133	98714430000
65082	2133	98713428000
65083	1874	1900000
65084	1451	9978908000000
65085	1451	9978944000000
65168	1680	10809462500035
65176	1687	12232738524804
65177	1687	12232750524804
65184	171	76070400524688
65201	1397	1347490883000
64644	1397	1348280962000
64645	1678	16560624138000
64646	2133	98774550000
64647	1874	1587000
64648	2134	98799400000
64649	1874	1590000
64650	2134	98798397000
64651	1874	1593000
64652	2133	98773548000
64653	1685	101521993571430
64654	1685	101522017571430
64668	2133	98771544000
64669	1874	1599000
64670	1874	1602000
64671	1874	1605000
64672	2135	1439061000000
64683	1397	1348240958000
64684	1678	16560624142000
64685	2134	98794385000
64686	2133	98769540000
64687	1874	1615000
64688	1991	12715832441475
64709	1397	1348200954000
64710	1678	16560624146000
64711	2134	98790373000
64712	1874	1633000
64713	1395	58031904136007706
64733	1723	16199504085979
64743	1649	18284234999992
64744	1649	18284246999992
64745	1397	1348150949000
64746	1678	16560624151000
64747	2134	98785358000
64748	1874	1656000
64749	2133	98761524000
64770	1397	1348120946000
64771	1678	16560624154000
64772	1397	1348110945000
64773	1678	16560624155000
64774	2134	98782349000
64775	1874	1671000
64776	2133	98758518000
64777	2133	98757516000
64778	1874	1675000
64779	2134	98781346000
64780	1394	103681657000000
64799	1637	187925198819988
64800	1637	187925210819988
64819	641	76419982000000
64828	1397	1348030937000
64829	1678	16560624163000
64830	2134	98773322000
64831	1874	1716000
64832	2133	98749500000
64833	1440	10079167000000
64834	1440	10079179000000
64851	1397	1348000934000
64852	1678	16560624166000
64853	2133	98746494000
64854	2134	98770313000
64855	1504	1157235000000
64856	1504	1157247000000
64895	1746	6994360000000
64897	1688	31031626708000
64898	1688	31031650708000
64956	1693	7340395406843
65027	1397	1347750909000
65028	1678	16560624191000
65029	2134	98745238000
65030	2133	98721444000
65031	1874	1858000
65068	1702	7200330000000
65091	1685	101522005571430
65120	1693	7340420406843
65157	1690	110883448000000
65158	1690	110883509000000
65167	1522	11134160000000
65179	1397	1347520886000
65180	1678	16560624214000
65181	2134	98723172000
65182	2133	98699400000
65183	1874	1974000
65234	1679	9574753853000
65235	1679	9574789853000
65243	1397	1347430877000
65244	1678	16560624223000
65245	2133	98690382000
65246	2134	98714145000
65247	1874	2022000
65248	1394	109441767000000
65249	1394	109441779000000
65283	1394	109441792000000
65292	2133	98684370000
65293	1874	2051000
65294	1874	2054000
65295	2133	98683368000
65311	1698	13497026550035
65312	1698	13497039550035
65322	1397	1347320866000
65323	1678	16560624234000
65324	2133	98679360000
65325	2134	98703112000
65326	1394	110881792000000
65327	1394	110881804000000
65350	1688	31031638708000
65359	1397	1347270861000
65360	1678	16560624239000
65361	2133	98674350000
65362	2134	98698097000
65363	1679	10294789853000
65364	1679	10294801853000
65420	2133	98667336000
65421	1874	2141000
65422	1874	2144000
65423	1874	2147000
65424	2133	98666334000
65425	1419	19179381280064
65436	1874	2148000
65437	1874	2150000
65438	1688	31031641708000
65467	526	68160077000000
65471	1637	190085234819988
65472	1637	190085259819988
65481	1397	1347120846000
65482	1678	16560624254000
65483	2134	98683052000
65484	2133	98660322000
65485	1874	2184000
65486	1394	113761829000000
65488	632	100560962000000
65489	632	100560974000000
65504	1727	10267018000000
65505	1727	10267030000000
65557	1397	1347020836000
65558	1678	16560624264000
65559	1397	1347010835000
65560	1678	16560624265000
65561	2133	98649300000
65562	2132	148918919000
65563	1874	2237000
65564	2133	98648298000
65565	2134	98673022000
65566	2134	98672019000
65567	1395	58033344174007706
65577	1688	31751651708000
65578	1688	31751663708000
65586	1397	1346980832000
65587	1678	16560624268000
65588	1397	1346970831000
65589	1678	16560624269000
65590	2134	98669010000
65591	2134	98668007000
65592	1874	2262000
65593	2133	98645292000
65594	1874	2264000
65595	2133	98644290000
65596	1692	75622939019999
65670	1397	1346890823000
65671	1678	16560624277000
65672	2132	148914915000
65673	2134	98659983000
65674	2133	98636274000
65675	1874	2309000
65676	1688	31751664708000
65677	1397	1346880822000
65678	1678	16560624278000
65679	1397	1346870821000
65680	1678	16560624279000
65681	1397	1346860820000
65682	1678	16560624280000
65683	1397	1346850819000
65684	1678	16560624281000
65685	2132	148913914000
65686	2134	98658980000
65687	2133	98635272000
65688	1874	2315000
65689	2133	98634270000
65690	2134	98657977000
65691	1874	2320000
65692	2134	98656974000
65693	2134	98655971000
65694	1874	2326000
65695	2133	98633268000
65696	2133	98632266000
65697	1874	2330000
64742	1395	58031904137007706
64752	1397	1348140948000
64753	1678	16560624152000
64754	2134	98784355000
64755	2133	98760522000
64756	1874	1663000
64757	1394	103681633000000
64758	1394	103681645000000
64759	1397	1348130947000
64760	1678	16560624153000
64761	2134	98783352000
64762	2133	98759520000
64763	1874	1668000
64764	1395	58032624137007706
64765	1395	58032624149007706
64809	1397	1348060940000
64810	1678	16560624160000
64811	1397	1348050939000
64812	1678	16560624161000
64813	2133	98752506000
64814	2133	98751504000
64815	2134	98776331000
64816	1874	1705000
64817	2134	98775328000
64818	1692	73462890019999
64842	1397	1348010935000
64843	1678	16560624165000
64844	2133	98747496000
64845	1874	1725000
64846	2134	98771316000
64847	1874	1728000
64848	2086	2879080000000
64850	2087	2159059000000
64875	1397	1347970931000
64876	1678	16560624169000
64877	2134	98767304000
64878	1874	1746000
64879	2133	98743488000
64880	1426	16845027000000
64881	1426	16845039000000
64894	1395	58032624161007706
64899	1397	1347940928000
64900	1678	16560624172000
64901	2134	98764295000
64902	1874	1761000
64903	2133	98740482000
64904	1458	13773617908540
64905	1458	13773629908540
64949	1397	1347860920000
64950	1678	16560624180000
64951	2133	98732466000
64952	1874	1800000
64953	2134	98756271000
64954	1874	1803000
64955	1422	8065039860211
64977	1397	1347820916000
64978	1678	16560624184000
64979	2133	98728458000
64980	2134	98752259000
64981	96	67441210000000
64982	96	67441222000000
64992	1402	49534494319298
65005	1397	1347780912000
65006	1678	16560624188000
65007	2134	98748247000
65008	2133	98724450000
65009	1874	1843000
65010	2087	2879059000000
65011	2087	2879071000000
65034	1397	1347740908000
65035	1678	16560624192000
65036	2134	98744235000
65037	1874	1861000
65038	2133	98720442000
65039	1874	1863000
65050	1397	1347710905000
65051	1678	16560624195000
65052	1397	1347700904000
65053	1678	16560624196000
65054	1397	1347690903000
65055	1678	16560624197000
65056	1726	139855109000
65057	2139	200000000
65058	2133	98717436000
65059	1874	1875000
65060	2133	98716434000
65061	2133	98715432000
65062	1874	1879000
65063	2134	98741226000
65064	1874	1882000
65065	2132	148939940000
65066	2134	98740223000
65067	1703	5760708000000
65086	1397	1347650899000
65087	1678	16560624201000
65088	2133	98712426000
65089	2134	98736211000
65090	1874	1905000
65101	1397	1347630897000
65102	1678	16560624203000
65103	1397	1347620896000
65104	1678	16560624204000
65105	1397	1347610895000
65106	1678	16560624205000
65107	2132	148936937000
65108	1874	1912000
65109	2134	98734205000
65110	1874	1915000
65111	2134	98733202000
65112	1874	1918000
65113	2133	98710422000
65114	2133	98709420000
65115	2134	98732199000
65116	2133	98708418000
65117	1874	1927000
65118	1394	106561669000000
65119	1394	106561706000000
65155	1451	10698944000000
65156	1451	10699005000000
65159	1397	1347540888000
65160	1678	16560624212000
65161	2134	98725178000
65162	1874	1961000
65163	2133	98701404000
65164	2132	148934935000
65165	1874	1964000
65166	1719	10820454000000
65169	606	74637783812962
65170	606	74637796812962
65171	1397	1347530887000
65172	1678	16560624213000
65173	2134	98724175000
65174	1874	1967000
65175	2133	98700402000
65178	1603	1440062000000
65185	1633	10116546985638
65186	1633	10116558985638
65195	1397	1347500884000
65196	1678	16560624216000
65197	2133	98697396000
65198	1874	1982000
65199	2134	98721166000
65200	1874	1985000
65216	1564	8466387000000
65217	1564	9186387000000
65218	1564	9186389000000
65219	1397	1347470881000
65220	1678	16560624219000
65221	1397	1347460880000
65222	1678	16560624220000
65223	1397	1347450879000
65224	1678	16560624221000
65225	2133	98694390000
65226	1874	1998000
65227	2134	98718157000
65228	2133	98693388000
65229	1874	2003000
65230	2133	98692386000
65231	2134	98717154000
65232	2134	98716151000
65233	1688	31031662708000
65250	1397	1347420876000
65251	1678	16560624224000
65252	1397	1347410875000
65253	1678	16560624225000
65254	2132	148930931000
65255	2133	98689380000
65256	2133	98688378000
65257	1874	2027000
65258	2134	98713142000
65259	1874	2030000
65260	2134	98712139000
65261	1874	2033000
65262	1467	7166677100039
65263	1467	7166702100039
65270	1397	1347390873000
65271	1678	16560624227000
65272	1397	1347380872000
65273	1678	16560624228000
65274	2133	98686374000
65275	1874	2040000
65276	2134	98710133000
65277	2132	148929930000
65278	2133	98685372000
65279	1874	2046000
64995	1397	1347790913000
64996	1678	16560624187000
64997	2134	98750253000
64998	1874	1831000
64999	2134	98749250000
65000	1874	1834000
65001	2133	98726454000
65002	2133	98725452000
65003	1690	109443412000000
65004	1690	109443436000000
65019	1397	1347760910000
65020	1678	16560624190000
65021	1690	109443446000000
65022	2134	98746241000
65023	1874	1851000
65024	2133	98722446000
65025	1690	110163446000000
65026	1690	110163448000000
65045	1397	1347720906000
65046	1678	16560624194000
65047	2134	98742229000
65048	2133	98718438000
65049	1874	1873000
65092	1397	1347640898000
65093	1678	16560624202000
65094	2134	98735208000
65095	2132	148937938000
65096	1874	1909000
65097	2133	98711424000
65098	1874	1911000
65099	1692	74902902019999
65100	1692	74902915019999
65121	1397	1347600894000
65122	1678	16560624206000
65123	2133	98707416000
65124	1874	1929000
65125	2134	98731196000
65126	1397	1347590893000
65127	1678	16560624207000
65128	1397	1347580892000
65129	1678	16560624208000
65130	1397	1347570891000
65131	1678	16560624209000
65132	1397	1347560890000
65133	1678	16560624210000
65134	1397	1347550889000
65135	1678	16560624211000
65136	2134	98730193000
65137	1874	1935000
65138	2134	98729190000
65139	2134	98728187000
65140	1874	1941000
65141	2133	98706414000
65142	2133	98705412000
65143	1874	1945000
65144	2133	98704410000
65145	1874	1947000
65146	2133	98703408000
65147	2133	98702406000
65148	1874	1951000
65149	2132	148935936000
65150	2134	98727184000
65151	2134	98726181000
65152	1874	1958000
65153	1394	108001706000000
65154	1394	108001767000000
65187	1397	1347510885000
65188	1678	16560624215000
65189	2132	148933934000
65190	2134	98722169000
65191	2133	98698398000
65192	1874	1980000
65193	632	99840949000000
65194	632	99840962000000
65207	1397	1347480882000
65208	1678	16560624218000
65209	2133	98695392000
65210	1874	1992000
65211	1992	10079273990000
65212	2132	148932933000
65213	2134	98719160000
65214	1992	10799273990000
65215	1992	10799275990000
65236	1397	1347440878000
65237	1678	16560624222000
65238	2133	98691384000
65239	2134	98715148000
65240	1874	2016000
65241	2132	148931932000
65242	1690	110883461000000
65264	1397	1347400874000
65265	1678	16560624226000
65266	2133	98687376000
65267	2134	98711136000
65268	1588	13894934000000
65269	1588	13894946000000
65284	1397	1347370871000
65285	1678	16560624229000
65286	1397	1347360870000
65287	1678	16560624230000
65288	2134	98708127000
65289	1874	2052000
65290	2134	98707124000
65291	1419	18459355280064
65296	1397	1347350869000
65297	1678	16560624231000
65298	2133	98682366000
65299	2134	98706121000
65300	1874	2064000
65301	1440	10799179000000
65302	1440	10799191000000
65313	1692	75622915019999
65314	1692	75622928019999
65328	1397	1347310865000
65329	1678	16560624235000
65330	2134	98702109000
65331	2133	98678358000
65332	2132	148927928000
65333	1394	112321804000000
65334	1394	112321817000000
65351	1397	1347280862000
65352	1678	16560624238000
65353	2133	98675352000
65354	2134	98699100000
65355	2132	148926927000
65356	1874	2102000
65357	369	99990897000000
65358	369	99990910000000
65375	58	83946518999641
65376	58	83946542999641
65379	1397	1347240858000
65380	1678	16560624242000
65381	2133	98671344000
65382	2132	148925926000
65383	1874	2120000
65384	2134	98695088000
65385	1874	2123000
65386	1394	113761817000000
65387	1394	113761830000000
65401	1680	10809474500035
65409	1693	7340396406843
65411	1397	1347200854000
65412	1678	16560624246000
65413	1397	1347190853000
65414	1678	16560624247000
65415	2134	98691076000
65416	1874	2142000
65417	2134	98690073000
65418	1419	19179357280064
65419	1419	19179379280064
65439	1397	1347170851000
65440	1678	16560624249000
65441	1397	1347160850000
65442	1678	16560624250000
65443	1749	4445221000000
65444	1950	10169851000000
65445	2133	98664330000
65446	2133	98663328000
65447	1874	2159000
65448	2134	98688067000
65449	1874	2162000
65450	2134	98687064000
65451	1874	2165000
65452	1688	31031651708000
65468	1702	7200309000000
65473	1474	11794422000023
65474	1474	11794447000023
65490	1397	1347110845000
65491	1678	16560624255000
65492	2133	98659320000
65493	1874	2186000
65494	2132	148921922000
65555	1980	15119302000000
65556	1980	15119378000000
65568	1397	1347000834000
65569	1678	16560624266000
65570	2133	98647296000
65571	2134	98671016000
65572	1874	2250000
65573	1395	58034064174007706
65574	1395	58034064186007706
65597	1397	1346960830000
65598	1678	16560624270000
65599	2133	98643288000
65600	1874	2268000
65202	1678	16560624217000
65203	2133	98696394000
65204	2134	98720163000
65205	1656	14541509999990
65206	1656	14541521999990
65336	1397	1347300864000
65337	1678	16560624236000
65338	2134	98701106000
65339	2133	98677356000
65340	1559	9322681000000
65341	1559	9322693000000
65365	1397	1347260860000
65366	1678	16560624240000
65367	1397	1347250859000
65368	1678	16560624241000
65369	2134	98697094000
65370	2134	98696091000
65371	2133	98673348000
65372	2133	98672346000
65373	1874	2117000
65374	1599	10419853393047
65377	1874	1579000
65378	1599	10420927393047
65388	1397	1347230857000
65389	1678	16560624243000
65390	1397	1347220856000
65391	1678	16560624244000
65392	1749	5945222000000
65393	1950	8669851000000
65394	2133	98670342000
65395	2133	98669340000
65396	2134	98694085000
65397	1874	2130000
65398	2134	98693082000
65399	1546	10800811000000
65400	1546	10800836000000
65402	1397	1347210855000
65403	1678	16560624245000
65404	2134	98692079000
65405	1874	2136000
65406	2133	98668338000
65407	1874	2138000
65408	2132	148924925000
65426	1397	1347180852000
65427	1678	16560624248000
65428	2134	98689070000
65429	2133	98665332000
65430	1874	2154000
65431	2132	148923924000
65432	1706	11012180600135
65433	1706	11012193600135
65480	58	83946528999641
65487	1680	10809461500035
65497	149	82110227000341
65506	1522	11854160000000
65507	1522	11854172000000
65508	1874	2189000
65509	1727	10267031000000
65514	1397	1347080842000
65515	1678	16560624258000
65516	1397	1347070841000
65517	1678	16560624259000
65518	1397	1347060840000
65519	1678	16560624260000
65520	1397	1347050839000
65521	1678	16560624261000
65522	1397	1347040838000
65523	1678	16560624262000
65524	1397	1347030837000
65525	1678	16560624263000
65526	2133	98656314000
65527	2133	98655312000
65528	1874	2201000
65529	2133	98654310000
65530	2133	98653308000
65531	2133	98652306000
65532	1874	2207000
65533	2134	98680043000
65534	1874	2210000
65535	2134	98679040000
65536	1874	2213000
65537	2134	98678037000
65538	1874	2216000
65539	2134	98677034000
65540	1874	2219000
65541	2134	98676031000
65542	1874	2222000
65543	2134	98675028000
65544	1874	2225000
65545	2134	98674025000
65546	1874	2228000
65547	2133	98651304000
65548	2133	98650302000
65549	1874	2232000
65550	2132	148920921000
65551	2132	148919920000
65552	1874	2234000
65553	1394	115201829000000
65554	1394	115201905000000
65633	1397	1346940828000
65634	1678	16560624272000
65635	2134	98664998000
65636	1874	2280000
65637	1696	11297349835100
65638	2133	98641284000
65639	1874	2282000
65640	1696	12017349835100
65641	1696	12017350835100
65655	1397	1346910825000
65656	1678	16560624275000
65657	2134	98661989000
65658	2133	98638278000
65659	1729	19007194000000
65661	1601	6410191620000
65662	1601	6410203620000
65706	1397	1346830817000
65707	1678	16560624283000
65708	2133	98630262000
65709	2134	98653965000
65710	1623	51122599899898
65733	1397	1346790813000
65734	1678	16560624287000
65735	2133	98626254000
65736	2134	98649953000
65737	2132	148911912000
65738	1874	2362000
65739	1458	14493642908540
65766	1692	76342939019999
65767	1692	76342964019999
65779	1691	12923149100019
65780	1691	12923161100019
65798	1397	1346710805000
65799	1678	17280636295000
65800	2134	98641929000
65801	576	78755813938283
65802	576	78755824938283
65858	1397	1346630797000
65859	1678	17280636303000
65860	2133	98611224000
65861	2134	98634908000
65862	1874	2441000
65863	1394	120961890000000
65883	1684	16531429880623
65884	1684	16531441880623
65921	1637	190805257819988
65928	1395	58036224211007706
65929	1395	58036224223007706
65933	1397	1346550789000
65934	1678	17280636311000
65935	2132	148904905000
65936	1874	2477000
65937	2134	98626884000
65938	2133	98604210000
65939	1395	58036224224007706
65968	1397	1346500784000
65969	1678	17280636316000
65970	2133	98599200000
65971	1874	2505000
65972	2134	98621869000
65973	1874	2508000
65987	1567	720013000101
66041	1397	1346470781000
66042	1678	17280636319000
66043	2133	98597196000
66044	1874	2519000
66045	2134	98618860000
66046	1685	102962066571430
66047	1685	102962078571430
66093	43	78240827890000
66103	1509	10751797851155
66131	1397	1346360770000
66132	1678	17280636330000
66133	2133	98585172000
66134	1874	2582000
66135	2132	148898899000
66136	2134	98606824000
66137	1874	2586000
66138	1679	11734813853000
66139	1679	11734826853000
66176	1596	14400553000000
66188	1395	58037664236007706
66189	1395	58037664269007706
66216	1397	1346280762000
66217	1678	17280636338000
66218	2133	98578158000
65280	2134	98709130000
65281	1656	15261521999990
65282	1656	15261546999990
65303	1397	1347340868000
65304	1678	16560624232000
65305	2134	98705118000
65306	2132	148928929000
65307	2133	98681364000
65308	1874	2070000
65309	1395	58033344149007706
65310	1395	58033344162007706
65315	43	78240802890000
65316	1397	1347330867000
65317	1678	16560624233000
65318	2133	98680362000
65319	1874	2072000
65320	2134	98704115000
65321	1874	2075000
65335	1654	15408146999798
65342	1397	1347290863000
65343	1678	16560624237000
65344	2133	98676354000
65345	1874	2093000
65346	2134	98700103000
65347	1874	2096000
65348	1700	12545956276737
65349	1700	12545968276737
65410	1685	101522006571430
65434	1691	12203136100019
65435	1691	12203149100019
65453	1397	1347150849000
65454	1678	16560624251000
65455	1397	1347140848000
65456	1678	16560624252000
65457	2133	98662326000
65458	2132	148922923000
65459	1874	2168000
65460	2134	98686061000
65461	1874	2171000
65462	2134	98685058000
65463	1874	2174000
65464	2133	98661324000
65465	1701	11590348600056
65466	1701	11590373600056
65469	1703	6480708000000
65470	1703	6480733000000
65475	1397	1347130847000
65476	1678	16560624253000
65477	2134	98684055000
65478	1686	10291999550062
65479	1686	10292010550062
65495	1426	17565039000000
65496	1426	17565051000000
65498	1397	1347100844000
65499	1678	16560624256000
65500	2134	98682049000
65501	1874	2190000
65502	2133	98658318000
65503	1874	2192000
65510	1397	1347090843000
65511	1678	16560624257000
65512	2133	98657316000
65513	2134	98681046000
65575	1690	111603461000000
65576	1690	111603473000000
65579	1397	1346990833000
65580	1678	16560624267000
65581	2132	148917918000
65582	2133	98646294000
65583	2134	98670013000
65584	1874	2256000
65585	1394	115201842000000
65604	1695	11132226000000
65605	1695	11132238000000
65625	1397	1346950829000
65626	1678	16560624271000
65627	2133	98642286000
65628	1874	2273000
65629	2132	148916917000
65630	1874	2274000
65631	2134	98666001000
65632	1402	49534495319298
65654	1688	31751676708000
65663	1397	1346900824000
65664	1678	16560624276000
65665	2134	98660986000
65666	2133	98637276000
65667	1874	2303000
65668	1394	118081854000000
65669	1394	118081866000000
65711	1397	1346820816000
65712	1678	16560624284000
65713	2132	148912913000
65714	2133	98629260000
65715	2134	98652962000
65716	1451	10698957000000
65740	1397	1346780812000
65741	1678	16560624288000
65742	2133	98625252000
65743	2134	98648950000
65744	1467	7886702100039
65745	1467	7886714100039
65752	1397	1346760810000
65753	1678	16560624290000
65754	1397	1346750809000
65755	1678	16560624291000
65756	2132	148910911000
65757	2133	98623248000
65758	1874	2375000
65759	2133	98622246000
65760	2134	98646944000
65761	1874	2380000
65762	2134	98645941000
65763	1874	2383000
65764	1395	58034784186007706
65765	1395	58034784211007706
65768	1397	1346740808000
65769	1678	16560624292000
65770	2133	98621244000
65771	2134	98644938000
65772	1874	2388000
65797	1394	120961891000000
65822	1397	1346680802000
65823	1678	17280636298000
65824	1397	1346670801000
65825	1678	17280636299000
65826	2133	98616234000
65827	1874	2415000
65828	2133	98615232000
65829	1874	2417000
65830	2134	98638920000
65831	2134	98637917000
65832	1874	2423000
65833	1395	58034064210007706
65834	1395	58034784210007706
65837	1271	1344126377000000
65838	1271	1344846377000000
65857	1471	15739698900000
65885	1397	1346590793000
65886	1678	17280636307000
65887	2132	148905906000
65888	2133	98608218000
65889	2134	98630896000
65890	1395	58034784199007706
65893	1397	1346580792000
65894	1678	17280636308000
65895	2134	98629893000
65896	2133	98607216000
65897	1874	2466000
65898	1395	58035504199007706
65899	1395	58035504211007706
65901	1874	2429000
65902	1874	2433000
65903	1874	2435000
65904	1874	2439000
65905	1874	2442000
65906	1874	2445000
65907	1874	2448000
65908	1874	2451000
65909	1874	2454000
65910	1874	2457000
65911	1874	2460000
65912	1874	2463000
65913	149	82110334000341
65940	1397	1346540788000
65941	1678	17280636312000
65942	2133	98603208000
65943	1874	2484000
65944	2134	98625881000
65945	1874	2487000
65946	1764	11526898100000
65947	1764	11526910100000
65962	1397	1346510785000
65963	1678	17280636315000
65964	2133	98600202000
65965	2134	98622872000
65966	1395	58036944224007706
65967	1395	58036944236007706
66048	1397	1346460780000
66049	1678	17280636320000
66050	2133	98596194000
66051	2134	98617857000
66052	2039	14401407000000
66053	2039	14401419000000
66088	1746	7714360000000
65601	2134	98667004000
65602	1394	116641842000000
65603	1394	116641854000000
65606	1695	10412796000000
65607	1874	1933000
65608	1874	1939000
65609	1874	1948000
65610	1874	1954000
65611	1874	1962000
65612	1874	1968000
65613	1874	1970000
65614	1874	1976000
65615	1874	1986000
65616	1874	1988000
65617	1874	1994000
65618	1874	2000000
65619	1874	2004000
65620	1874	2010000
65621	1874	2028000
65622	1874	2034000
65623	1695	11132796000000
65624	1695	11132936000000
65642	1397	1346930827000
65643	1678	16560624273000
65644	1397	1346920826000
65645	1678	16560624274000
65646	2133	98640282000
65647	2133	98639280000
65648	1874	2286000
65649	2132	148915916000
65650	2134	98663995000
65651	2134	98662992000
65652	1564	9186376000000
65653	1564	9186401000000
65660	1637	190085246819988
65699	1397	1346840818000
65700	1678	16560624282000
65701	2134	98654968000
65702	1874	2333000
65703	2133	98631264000
65704	1394	119521866000000
65705	1394	119521878000000
65719	1397	1346810815000
65720	1678	16560624285000
65721	1397	1346800814000
65722	1678	16560624286000
65723	2134	98651959000
65724	2133	98628258000
65725	1874	2351000
65726	2133	98627256000
65727	2134	98650956000
65728	1874	2356000
65729	1394	120961878000000
65730	1394	120961902000000
65746	1397	1346770811000
65747	1678	16560624289000
65748	2134	98647947000
65749	2133	98624250000
65750	1874	2372000
65751	1708	8675767000021
65792	1397	1346720806000
65793	1678	17280636294000
65794	2134	98642932000
65795	2133	98619240000
65796	1709	10080128999976
65803	1637	190085245819988
65818	1689	10800204287625
65819	1689	10800229287625
65850	1397	1346640798000
65851	1678	17280636302000
65852	2134	98635911000
65853	2133	98612226000
65854	1874	2436000
65855	1552	2880030000000
65856	1552	2880042000000
65875	1691	12923173100019
65930	58	83946530999641
65953	1397	1346520786000
65954	1678	17280636314000
65955	2132	148903904000
65956	1874	2493000
65957	2133	98601204000
65958	1874	2495000
65959	2134	98623875000
65960	1549	16895807000000
65961	1549	16895820000000
65974	1749	5165221000000
65975	1749	5165233000000
65976	1397	1346490783000
65977	1678	17280636317000
65978	2134	98620866000
65979	1874	2511000
65980	2132	148902903000
65981	2133	98598198000
65982	1874	2514000
65983	2140	719000000000
65984	2140	719013000000
65988	1749	5165234000000
65989	1397	1346480782000
65990	1678	17280636318000
65991	2134	98619863000
65992	1874	2517000
65993	1695	11132237000000
66056	1397	1346450779000
66057	1678	17280636321000
66058	2133	98595192000
66059	1874	2529000
66060	2134	98616854000
66061	1874	2532000
66062	2132	148901902000
66063	1717	11628022000023
66064	1717	11628035000023
66067	2134	98615851000
66068	2133	98594190000
66069	1874	2538000
66070	1601	7130203620000
66071	1601	7130205620000
66072	1397	1346440778000
66073	1678	17280636322000
66074	1397	1346430777000
66075	1678	17280636323000
66076	1397	1346420776000
66077	1678	17280636324000
66078	2132	148900901000
66079	1684	16531440880623
66080	2133	98593188000
66081	2133	98592186000
66082	1874	2543000
66083	2133	98591184000
66084	2134	98614848000
66085	2134	98613845000
66086	2134	98612842000
66087	1747	5056909000000
66090	1704	2226245000000
66140	1397	1346350769000
66141	1678	17280636331000
66142	1397	1346340768000
66143	1678	17280636332000
66144	2134	98605821000
66145	2134	98604818000
66146	1874	2592000
66147	2133	98584170000
66148	1874	2594000
66149	2133	98583168000
66150	1560	13554310277001
66159	1688	32471664708000
66160	1688	32471677708000
66167	1549	17615820000000
66168	1549	17615832000000
66177	1692	77782989019999
66178	1692	77783001019999
66190	1489	10703979000000
66191	1489	10704012000000
66222	1684	13680424880623
66223	2142	2850004000000
66224	1509	11471797851155
66225	1509	11471852851155
66251	2134	98594788000
66252	1874	2645000
66253	470	77520407000000
66257	1397	1346220756000
66258	1678	17280636344000
66259	2132	148894895000
66260	1874	2648000
66261	2134	98593785000
66262	1874	2651000
66263	2133	98573148000
66264	1874	2653000
66265	2133	98572146000
66266	1874	2655000
66267	633	81004084900000
66268	633	81004108900000
66295	1397	1346170751000
66296	1678	17280636349000
66297	2133	98568138000
66298	2134	98588770000
66299	1874	2679000
66300	470	77520419000000
66301	470	78240419000000
66323	1397	1346140748000
66324	1678	17280636352000
66325	2133	98565132000
66326	1874	2692000
66327	2134	98585761000
66328	1874	2695000
65698	1685	101522042571430
65717	1762	15441953994000
65718	1762	15441966994000
65731	171	76790400524688
65732	171	76790424524688
65773	1397	1346730807000
65774	1678	16560624293000
65775	2133	98620242000
65776	2134	98643935000
65777	1678	17280624293000
65778	1678	17280636293000
65781	1874	1729000
65782	1874	1731000
65783	1874	1734000
65784	1874	1737000
65785	1874	1741000
65786	1874	1747000
65787	1874	1749000
65788	1874	1753000
65789	2132	148909910000
65790	1874	1759000
65791	1709	10080159999976
65804	1397	1346700804000
65805	1678	17280636296000
65806	1397	1346690803000
65807	1678	17280636297000
65808	2134	98640926000
65809	2133	98618238000
65810	1874	2407000
65811	2133	98617236000
65812	1874	2409000
65813	2134	98639923000
65814	1874	2412000
65815	2132	148908909000
65816	1402	50254495319298
65817	1402	50254520319298
65820	1692	77062964019999
65821	1692	77062989019999
65835	1402	49534519319298
65836	1402	50254519319298
65839	1397	1346660800000
65840	1678	17280636300000
65841	1397	1346650799000
65842	1678	17280636301000
65843	2133	98614230000
65844	2133	98613228000
65845	1874	2427000
65846	2132	148907908000
65847	2134	98636914000
65848	1685	102242042571430
65849	1685	102242066571430
65864	1397	1346620796000
65865	1678	17280636304000
65866	1397	1346610795000
65867	1678	17280636305000
65868	2133	98610222000
65869	2132	148906907000
65870	2134	98633905000
65871	1874	2447000
65872	2134	98632902000
65873	1593	14950014000000
65874	1593	14950038000000
65876	1397	1346600794000
65877	1678	17280636306000
65878	2134	98631899000
65879	1874	2453000
65880	2133	98609220000
65881	1394	122401890000000
65882	1394	122401902000000
65891	1637	190805245819988
65892	1637	190805258819988
65900	1476	12240191000000
65914	1397	1346570791000
65915	1678	17280636309000
65916	2133	98606214000
65917	2134	98628890000
65918	1874	2471000
65919	1439	11092424998477
65920	1439	11092436998477
65922	1397	1346560790000
65923	1678	17280636310000
65924	2134	98627887000
65925	2133	98605212000
65926	1672	18722043000000
65927	1672	18722055000000
65931	1679	11014801853000
65932	1679	11014813853000
65948	1397	1346530787000
65949	1678	17280636313000
65950	2133	98602206000
65951	1874	2489000
65952	2134	98624878000
65985	2141	719000000000
65986	2141	719013000000
65994	1678	16560624294000
65995	1678	16560624295000
65996	1678	16560624296000
65997	1678	16560624297000
65998	1678	16560624298000
65999	1678	16560624299000
66000	1678	16560624300000
66001	1678	16560624301000
66002	1678	16560624302000
66003	1678	16560624303000
66004	1678	16560624304000
66005	1678	16560624305000
66006	1678	16560624306000
66007	1678	16560624307000
66008	1678	16560624308000
66009	1678	16560624309000
66010	1678	16560624310000
66011	1678	16560624311000
66012	1678	16560624312000
66013	1678	16560624313000
66014	1678	16560624314000
66015	1678	16560624315000
66016	1678	16560624316000
66017	1678	16560624317000
66018	1874	2048000
66019	1874	2058000
66020	1695	11133416000000
66021	1874	2069000
66022	1874	2081000
66023	1874	2087000
66024	1874	2099000
66025	1874	2105000
66026	1874	2111000
66027	1874	2129000
66028	1874	2135000
66029	1874	2160000
66030	1874	2166000
66031	1874	2172000
66032	1874	2178000
66033	1874	2196000
66034	1874	2202000
66035	1874	2208000
66036	1874	2214000
66037	1874	2220000
66038	1874	2226000
66039	1695	11853416000000
66040	1695	11853484000000
66054	1685	103682078571430
66055	1685	103682090571430
66065	1419	19899381280064
66066	1419	19899394280064
66091	1598	3299980000000
66092	1598	3300018000000
66094	1397	1346410775000
66095	1678	17280636325000
66096	1684	16530438880623
66097	2142	1000000
66098	2133	98590182000
66099	1874	2556000
66100	2134	98611839000
66101	1716	14446829000000
66102	1716	14446842000000
66118	1397	1346380772000
66119	1678	17280636328000
66120	1397	1346370771000
66121	1678	17280636329000
66122	1684	16530434880623
66123	2142	4000000
66124	2134	98608830000
66125	1874	2573000
66126	2133	98587176000
66127	2133	98586174000
66128	2134	98607827000
66129	1874	2580000
66130	1394	122401915000000
66151	1397	1346330767000
66152	1678	17280636333000
66153	2134	98603815000
66154	2132	148897898000
66155	1874	2600000
66156	2133	98582166000
66157	1756	6227811575609
66158	1756	6227824575609
66179	1684	13680425880623
66180	2142	2850002000000
66181	1397	1346300764000
66182	1678	17280636336000
66183	2132	148896897000
66184	2134	98600806000
66185	2133	98580162000
66186	1874	2616000
66089	1746	7714398000000
66104	1397	1346400774000
66105	1678	17280636326000
66106	1397	1346390773000
66107	1678	17280636327000
66108	2132	148899900000
66109	2133	98589180000
66110	1874	2562000
66111	2133	98588178000
66112	1874	2564000
66113	2134	98610836000
66114	1874	2567000
66115	2134	98609833000
66116	1874	2570000
66117	1509	10751820851155
66161	1397	1346320766000
66162	1678	17280636334000
66163	2142	2000000
66164	1684	16530435880623
66165	2134	98602812000
66166	1762	15441965994000
66169	1397	1346310765000
66170	1678	17280636335000
66171	2134	98601809000
66172	2133	98581164000
66173	1874	2610000
66174	1670	15841077000000
66175	1670	15841089000000
66277	1397	1346200754000
66278	1678	17280636346000
66279	2132	148893894000
66280	1874	2661000
66281	2134	98591779000
66282	2133	98570142000
66283	1394	123841928000000
66284	1397	1346190753000
66285	1678	17280636347000
66286	2134	98590776000
66287	2133	98569140000
66288	1874	2671000
66289	1650	5794084000000
66302	1397	1346160750000
66303	1678	17280636350000
66304	2132	148892893000
66305	470	77520428000000
66306	1874	2677000
66307	2133	98567136000
66308	2134	98587767000
66309	1874	2685000
66310	470	78240428000000
66311	470	78240432000000
66341	1447	13834548943000
66369	1941	1437956000000
66370	1941	1437968000000
66372	1724	7148325000000
66373	1303	1702889985351650
66374	1455	7954088000000
66390	1547	9933351000000
66395	1476	12240261000000
66396	1874	2689000
66397	1874	2691000
66398	1476	12960261000000
66399	1476	12960346000000
66414	1397	1346030737000
66415	1678	17280636363000
66416	2134	98574728000
66417	2132	148888889000
66418	1874	2750000
66419	2133	98555112000
66420	149	82110238000341
66437	1397	1346000734000
66438	1678	17280636366000
66439	2134	98571719000
66440	2132	148887888000
66441	1874	2764000
66442	2133	98553108000
66443	1874	2766000
66456	1458	15213642908540
66457	1458	15213654908540
66459	1740	9161892000000
66460	1678	16560624318000
66461	1678	16560624319000
66462	1678	16560624320000
66463	1678	16560624321000
66464	1678	16560624322000
66465	1678	16560624323000
66466	1678	16560624324000
66467	1678	16560624325000
66468	1678	16560624326000
66469	1678	16560624327000
66470	1678	16560624328000
66471	1678	16560624329000
66472	1678	16560624330000
66473	1678	16560624331000
66474	1678	16560624332000
66475	1678	16560624333000
66476	1678	16560624334000
66477	1678	16560624335000
66478	1678	16560624336000
66479	1678	16560624337000
66480	1678	16560624338000
66481	1678	16560624339000
66482	1678	16560624340000
66483	1678	16560624341000
66484	1678	16560624342000
66485	1678	16560624343000
66486	1678	16560624344000
66487	1678	16560624345000
66488	1678	16560624346000
66489	1678	16560624347000
66490	1678	16560624348000
66491	1678	16560624349000
66492	1678	16560624350000
66493	1678	16560624351000
66494	1678	16560624352000
66495	1678	16560624353000
66496	1678	16560624354000
66497	1740	9881892000000
66498	1740	9882602000000
66520	2133	98549100000
66521	1874	2789000
66522	1874	2790000
66523	2133	98548098000
66524	1874	2792000
66525	1547	10653376000000
66548	1685	105122102571430
66549	1685	105122114571430
66550	1559	10762705000000
66589	1397	1345840718000
66590	1678	17280636382000
66591	1397	1345830717000
66592	1678	17280636383000
66593	2132	148882883000
66594	1769	1699900000
66595	2134	98555671000
66596	1874	2847000
66597	2134	98554668000
66598	2133	98538078000
66599	2133	98537076000
66600	1874	2854000
66601	606	74637809812962
66605	1397	1345820716000
66606	1678	17280636384000
66607	2134	98553665000
66608	1874	2857000
66609	2133	98536074000
66610	1874	2859000
66611	1402	50974520319298
66612	1402	50974532319298
66641	1397	1345780712000
66642	1678	17280636388000
66643	2134	98549653000
66644	1874	2878000
66645	1694	15852511127629
66646	1694	15852522127629
66652	1397	1345770711000
66653	1678	17280636389000
66654	2133	98531064000
66655	1768	14270798110000
66720	1397	1345750709000
66721	1678	17280636391000
66722	1397	1345740708000
66723	1678	17280636392000
66724	2134	98547647000
66725	2133	98529060000
66726	1874	2893000
66727	2133	98528058000
66728	1874	2895000
66729	2134	98546644000
66738	1440	11519191000000
66739	1440	11519204000000
66756	1397	1345700704000
66757	1678	17280636396000
66758	2134	98542632000
66759	1874	2917000
66760	2132	148878879000
66761	1601	7850205620000
66762	1601	7850217620000
66779	1613	14328196600000
66780	1874	2809000
66781	1874	2817000
66782	1874	2818000
66783	1874	2830000
66784	1874	2833000
66785	1874	2836000
66187	1727	10267051000000
66192	1874	2612000
66193	1489	10704000000000
66194	1397	1346290763000
66195	1678	17280636337000
66196	1726	138645109000
66197	2143	200000000
66198	1726	137435109000
66199	2144	200000000
66200	1726	136225109000
66201	2145	200000000
66202	1726	135015109000
66203	2146	200000000
66204	2134	98599803000
66205	2133	98579160000
66206	1874	2621000
66207	1729	18203081000000
66208	967	504776675000000
66209	1729	18091975279700
66210	1087	904515869720300
66211	1729	18000749223850
66212	1207	610311145055850
66213	1729	17835943880750
66214	1333	1700596942094750
66215	1719	10820497000000
66226	1397	1346270761000
66227	1678	17280636339000
66228	1397	1346260760000
66229	1678	17280636340000
66230	2132	148895896000
66231	1874	2627000
66232	2134	98597797000
66233	1874	2630000
66234	2134	98596794000
66235	1874	2633000
66236	2133	98577156000
66237	2133	98576154000
66238	1509	11471820851155
66239	1509	11471845851155
66269	1397	1346210755000
66270	1678	17280636345000
66271	2134	98592782000
66272	2133	98571144000
66273	1716	15166842000000
66274	1716	15166854000000
66290	1397	1346180752000
66291	1678	17280636348000
66292	2134	98589773000
66293	1874	2674000
66294	1685	103682089571430
66342	1874	2697000
66343	1874	2703000
66344	1447	13834560943000
66357	1397	1346090743000
66358	1678	17280636357000
66359	2134	98580746000
66360	1395	58037664247007706
66371	1511	720012000000
66429	484	94800826000000
66430	484	94800837000000
66507	1688	33191677708000
66508	1688	33191689708000
66526	1397	1345940728000
66527	1678	17280636372000
66528	1397	1345930727000
66529	1678	17280636373000
66530	2134	98565701000
66531	1874	2795000
66532	2133	98547096000
66533	1874	2797000
66534	2133	98546094000
66535	1874	2799000
66536	2132	148885886000
66537	1874	2800000
66538	2134	98564698000
66539	1874	2803000
66540	1518	10080406000000
66551	1397	1345910725000
66552	1678	17280636375000
66553	1397	1345900724000
66554	1678	17280636376000
66555	2134	98562692000
66556	1874	2811000
66557	2133	98544090000
66558	2133	98543088000
66559	1874	2815000
66560	2132	148884885000
66561	2134	98561689000
66562	1395	58038384272007706
66630	1397	1345790713000
66631	1678	17280636387000
66632	2134	98550656000
66633	1762	15441964994000
66638	1596	15120553000000
66639	1596	15120565000000
66647	2133	98532066000
66648	1874	2877000
66649	1693	8060396406843
66650	1693	8060408406843
66651	1694	15852523127629
66656	1397	1345760710000
66657	1678	17280636390000
66658	2132	148880881000
66659	1874	2883000
66660	2134	98548650000
66661	2133	98530062000
66662	1740	10601364000000
66663	1740	10601377000000
66740	1397	1345720706000
66741	1678	17280636394000
66742	2133	98526054000
66743	2134	98544638000
66744	1623	51842599899898
66745	1623	51842611899898
66752	2148	719000000000
66753	2148	719012000000
66772	1397	1345680702000
66773	1678	17280636398000
66774	2134	98540626000
66775	1874	2926000
66776	2133	98523048000
66812	1690	112323473000000
66813	1690	112323498000000
66819	1397	1345640698000
66820	1678	17280636402000
66821	2133	98519040000
66822	2134	98536614000
66823	1394	128161989000000
66824	1394	128162001000000
66841	2144	100000000
66842	1397	1345600694000
66843	1678	17280636406000
66844	2134	98532602000
66845	2132	148875876000
66846	2133	98515032000
66847	2106	2159147000000
66851	1448	7236749000001
66852	1448	7236862000001
66853	1397	1345590693000
66854	1678	17280636407000
66855	2133	98514030000
66856	2134	98531599000
66857	1394	129602001000000
66858	1394	129602013000000
66870	1397	1345560690000
66871	1678	17280636410000
66872	2134	98528590000
66873	2132	148874875000
66874	2133	98512026000
66875	1874	2990000
66896	1397	1345520686000
66897	1678	17280636414000
66898	1397	1345510685000
66899	1678	17280636415000
66900	2133	98508018000
66901	1874	3008000
66902	2133	98507016000
66903	2134	98524578000
66904	1874	3013000
66905	2134	98523575000
66906	1716	15886854000000
66907	1716	15886878000000
66940	1395	58039824284007706
66941	1395	58039824458007706
66949	1397	1345430677000
66950	1678	17280636423000
66951	2134	98515551000
66952	2132	148870871000
66953	2133	98499000000
66954	1992	11519275990000
66955	1992	11519288990000
66976	1397	1345390673000
66977	1678	17280636427000
66978	2134	98512542000
66979	1874	3075000
66980	2133	98494992000
66981	1649	19004246999992
66982	1649	19004258999992
66995	1397	1345360670000
66996	1678	17280636430000
66997	2134	98509533000
66998	1874	3090000
66999	2132	148868869000
67000	2133	98491986000
67001	1698	14217039550035
66219	2134	98598800000
66220	1444	13535130159999
66221	1444	13535142159999
66240	1397	1346250759000
66241	1678	17280636341000
66242	1397	1346240758000
66243	1678	17280636342000
66244	2134	98595791000
66245	1874	2640000
66246	2133	98575152000
66247	1874	2642000
66248	2133	98574150000
66249	1394	123841915000000
66250	1394	123841938000000
66254	1397	1346230757000
66255	1678	17280636343000
66256	470	77520417000000
66275	1933	1440141000000
66276	1933	1440153000000
66312	1397	1346150749000
66313	1678	17280636351000
66314	1874	2680000
66315	1874	2683000
66316	2134	98586764000
66317	1874	2686000
66318	1729	17280942880750
66319	2147	554000000000
66320	2133	98566134000
66321	1650	6514084000000
66322	1650	6514110000000
66345	1397	1346110745000
66346	1678	17280636355000
66347	2134	98582752000
66348	1874	2709000
66349	2133	98562126000
66361	1397	1346080742000
66362	1678	17280636358000
66363	2133	98560122000
66364	1874	2722000
66365	2134	98579743000
66366	1874	2725000
66367	1715	37440638000002
66368	1715	37440650000002
66375	1397	1346070741000
66376	1678	17280636359000
66377	2133	98559120000
66378	1874	2727000
66379	2134	98578740000
66380	1426	17565057000000
66391	1874	2561000
66392	1874	2568000
66393	1874	2574000
66394	1547	9933763000000
66407	1397	1346040738000
66408	1678	17280636362000
66409	2134	98575731000
66410	1874	2744000
66411	2133	98556114000
66412	1394	125281928000000
66413	1394	125281940000000
66421	1685	104402089571430
66422	1685	104402102571430
66428	1693	7340394406843
66444	1397	1345990733000
66445	1678	17280636367000
66446	2133	98552106000
66447	2134	98570716000
66448	2041	1439339000000
66449	2041	1439351000000
66458	606	74637795812962
66509	1397	1345960730000
66510	1678	17280636370000
66511	1397	1345950729000
66512	1678	17280636371000
66513	2134	98567707000
66514	1874	2784000
66515	2134	98566704000
66516	1874	2787000
66517	2132	148886887000
66518	1547	10653351000000
66519	1547	10653374000000
66541	1397	1345920726000
66542	1678	17280636374000
66543	2133	98545092000
66544	1874	2805000
66545	2134	98563695000
66546	1547	11373376000000
66547	1547	11373388000000
66602	1519	3599065000000
66603	1519	3599091000000
66613	1397	1345810715000
66614	1678	17280636385000
66615	2133	98535072000
66616	2134	98552662000
66617	1673	21926500000000
66618	1673	21926512000000
66627	1746	7714373000000
66634	2133	98533068000
66635	1874	2875000
66636	1560	14274310277001
66637	1560	14274322277001
66730	1397	1345730707000
66731	1678	17280636393000
66732	2133	98527056000
66733	2132	148879880000
66734	1874	2901000
66735	2134	98545641000
66736	1622	17820341000005
66737	1622	17820354000005
66763	1397	1345690703000
66764	1678	17280636397000
66765	2133	98524050000
66766	1874	2920000
66767	2134	98541629000
66768	1874	2923000
66769	1688	33911701708000
66817	1740	11321377000000
66818	1740	11321402000000
66859	1397	1345580692000
66860	1678	17280636408000
66861	2134	98530596000
66862	1684	14400436880623
66888	1397	1345530687000
66889	1678	17280636413000
66890	2132	148873874000
66891	2134	98525581000
66892	2133	98509020000
66893	484	94800839000000
66956	1394	133922199000000
66957	1394	133922212000000
66960	495	66709820000000
66961	2149	9000000000
66962	1397	1345420676000
66963	1678	17280636424000
66964	1397	1345410675000
66965	1678	17280636425000
66966	2133	98497998000
66967	2133	98496996000
66968	2134	98514548000
66969	1394	133922322000000
66983	1397	1345380672000
66984	1678	17280636428000
66985	2133	98493990000
66986	2134	98511539000
67030	1696	12737350835100
67031	1696	12737362835100
67038	1536	14400713999959
67039	1536	14400725999959
67042	1397	1345300664000
67043	1678	17280636436000
67044	2133	98485974000
67045	1874	3121000
67046	2134	98503515000
67083	1397	1345220656000
67084	1678	17280636444000
67085	1397	1345210655000
67086	1678	17280636445000
67087	2133	98477958000
67088	2133	98476956000
67089	2134	98495491000
67090	2134	98494488000
67091	1874	3172000
67092	1440	12239204000000
67093	1440	12239228000000
67112	1397	1345180652000
67113	1678	17280636448000
67114	1397	1345170651000
67115	1678	17280636449000
67116	2134	98491479000
67117	2134	98490476000
67118	2133	98473950000
67119	2133	98472948000
67120	1395	58039824308007706
67139	369	97346510000000
67140	946	505422075000000
67141	1397	1345140648000
67142	1678	17280636452000
67143	2133	98469942000
67144	1874	3206000
67145	2134	98487467000
67146	1874	3209000
67147	1680	10809561500035
67203	1513	28801586000000
67227	1560	14994322277001
67228	1560	14994334277001
66329	1616	3600096410000
66330	1616	3600108410000
66331	1397	1346130747000
66332	1678	17280636353000
66333	1397	1346120746000
66334	1678	17280636354000
66335	2134	98584758000
66336	1874	2698000
66337	2133	98564130000
66338	2133	98563128000
66339	2134	98583755000
66340	2132	148891892000
66350	1397	1346100744000
66351	1678	17280636356000
66352	2134	98581749000
66353	2132	148890891000
66354	1874	2715000
66355	2133	98561124000
66356	1643	1296390114700
66381	1397	1346060740000
66382	1678	17280636360000
66383	1724	7147319000000
66384	937	505422913800000
66385	2133	98558118000
66386	2134	98577737000
66387	2132	148889890000
66388	1476	12960191000000
66389	1476	12960210000000
66400	1397	1346050739000
66401	1678	17280636361000
66402	2134	98576734000
66403	1874	2739000
66404	2133	98557116000
66405	1723	16919480085979
66406	1723	16919492085979
66423	1397	1346020736000
66424	1678	17280636364000
66425	2134	98573725000
66426	1394	126721940000000
66427	1394	126721951000000
66431	1397	1346010735000
66432	1678	17280636365000
66433	2134	98572722000
66434	2133	98554110000
66435	1559	10042693000000
66436	1559	10042705000000
66450	1397	1345980732000
66451	1678	17280636368000
66452	2134	98569713000
66453	2133	98551104000
66454	1740	9881352000000
66455	1740	9881364000000
66499	1397	1345970731000
66500	1678	17280636369000
66501	2134	98568710000
66502	1874	2779000
66503	2133	98550102000
66504	1874	2781000
66505	1395	58038384247007706
66506	1395	58038384259007706
66563	1397	1345890723000
66564	1678	17280636377000
66565	2133	98542086000
66566	1874	2821000
66567	2134	98560686000
66568	1874	2824000
66569	1397	1345880722000
66570	1678	17280636378000
66571	1397	1345870721000
66572	1678	17280636379000
66573	1397	1345860720000
66574	1678	17280636380000
66575	1397	1345850719000
66576	1678	17280636381000
66577	2132	148883884000
66578	2133	98541084000
66579	1874	2827000
66580	2133	98540082000
66581	1874	2829000
66582	2133	98539080000
66583	1769	1700900000
66584	2134	98559683000
66585	2134	98558680000
66586	2134	98557677000
66587	2134	98556674000
66588	1394	126721989000000
66604	1681	11303231759830
66619	1397	1345800714000
66620	1678	17280636386000
66621	2132	148881882000
66622	1874	2865000
66623	2134	98551659000
66624	2133	98534070000
66625	1422	8785039860211
66626	1422	8785052860211
66628	1688	33911689708000
66629	1688	33911702708000
66640	1476	12960203000000
66664	1678	16560624355000
66665	1678	16560624356000
66666	1678	16560624357000
66667	1678	16560624358000
66668	1678	16560624359000
66669	1678	16560624360000
66670	1678	16560624361000
66671	1678	16560624362000
66672	1678	16560624363000
66673	1678	16560624364000
66674	1678	16560624365000
66675	1678	16560624366000
66676	1678	16560624367000
66677	1678	16560624368000
66678	1678	16560624369000
66679	1678	16560624370000
66680	1678	16560624371000
66681	1678	16560624372000
66682	1678	16560624373000
66683	1678	16560624374000
66684	1678	16560624375000
66685	1678	16560624376000
66686	1678	16560624377000
66687	1678	16560624378000
66688	1678	16560624379000
66689	1678	16560624380000
66690	1678	16560624381000
66691	1678	16560624382000
66692	1678	16560624383000
66693	1678	16560624384000
66694	1678	16560624385000
66695	1678	16560624386000
66696	1678	16560624387000
66697	1678	16560624388000
66698	1678	16560624389000
66699	1684	15811428880623
66700	1684	15810426880623
66701	1684	15810422880623
66702	1684	12960412880623
66703	1874	2088000
66704	1874	2090000
66705	1874	2094000
66706	1740	9882990000000
66707	1874	2100000
66708	1874	2106000
66709	1874	2108000
66710	1874	2112000
66711	1874	2114000
66712	1874	2118000
66713	1874	2124000
66714	1874	2126000
66715	1874	2132000
66716	1874	2156000
66717	1874	2238000
66718	1740	10602990000000
66719	1740	10603061000000
66746	1397	1345710705000
66747	1678	17280636395000
66748	2133	98525052000
66749	1874	2911000
66750	2134	98543635000
66751	1874	2914000
66754	1685	105842114571430
66755	1685	105842126571430
66770	1623	52562611899898
66771	1623	52562623899898
66777	1613	15047966600000
66778	1613	15047978600000
66793	1397	1345670701000
66794	1678	17280636399000
66795	2134	98539623000
66796	1874	2931000
66797	2133	98522046000
66798	1395	58039104272007706
66799	1395	58039104284007706
66814	576	78755838938283
66825	1397	1345630697000
66826	1678	17280636403000
66827	2134	98535611000
66828	2132	148876877000
66829	2133	98518038000
66830	1681	11303218759830
66848	1457	14304316040000
66849	1457	14304429040000
66876	1397	1345550689000
66877	1678	17280636411000
66878	2133	98511024000
66786	1874	2842000
66787	1874	2853000
66788	1874	2871000
66789	1874	2889000
66790	1874	2908000
66791	1613	15048196600000
66792	1613	15048322600000
66800	1397	1345660700000
66801	1678	17280636400000
66802	1397	1345650699000
66803	1678	17280636401000
66804	2132	148877878000
66805	2134	98538620000
66806	2134	98537617000
66807	2133	98521044000
66808	1874	2942000
66809	2133	98520042000
66810	1684	14400425880623
66811	1684	14400450880623
66815	1691	13643173100019
66816	1691	13643198100019
66831	1397	1345620696000
66832	1678	17280636404000
66833	1397	1345610695000
66834	1678	17280636405000
66835	2133	98517036000
66836	2133	98516034000
66837	2134	98534608000
66838	2134	98533605000
66839	1980	15839378000000
66840	1980	15839402000000
66850	42	89038399000000
66863	1397	1345570691000
66864	1678	17280636409000
66865	2133	98513028000
66866	2134	98529593000
66867	1874	2984000
66868	1685	106562126571430
66869	1685	106562138571430
66882	1397	1345540688000
66883	1678	17280636412000
66884	2133	98510022000
66885	2134	98526584000
66886	1637	192245269819988
66887	1637	192245281819988
66908	495	66719920000000
66909	1397	1345500684000
66910	1678	17280636416000
66911	1397	1345490683000
66912	1678	17280636417000
66913	1397	1345480682000
66914	1678	17280636418000
66915	1397	1345470681000
66916	1678	17280636419000
66917	1397	1345460680000
66918	1678	17280636420000
66919	1397	1345450679000
66920	1678	17280636421000
66921	2133	98506014000
66922	2134	98522572000
66923	2134	98521569000
66924	1874	3024000
66925	2134	98520566000
66926	2134	98519563000
66927	1874	3030000
66928	2134	98518560000
66929	2134	98517557000
66930	1874	3036000
66931	2133	98505012000
66932	2133	98504010000
66933	2133	98503008000
66934	2133	98502006000
66935	2133	98501004000
66936	2132	148872873000
66937	2132	148871872000
66938	1394	131042013000000
66939	1394	131042187000000
66958	1727	10987051000000
66959	1727	10987064000000
66987	495	66709720000000
66988	1397	1345370671000
66989	1678	17280636429000
66990	2133	98492988000
66991	2134	98510536000
66992	1394	135362322000000
66993	1394	2913273999985
66994	1423	135362409000000
67008	1397	1345340668000
67009	1678	17280636432000
67010	2133	98489982000
67011	1874	3100000
67012	2134	98507527000
67013	1394	136802409000000
67014	1394	136802421000000
67017	1397	1345330667000
67018	1678	17280636433000
67019	2134	98506524000
67020	2132	148867868000
67021	2133	98488980000
67022	1671	13008446530515
67023	1671	13008459530515
67049	1397	1345290663000
67050	1678	17280636437000
67051	1397	1345280662000
67052	1678	17280636438000
67053	1397	1345270661000
67054	1678	17280636439000
67055	1397	1345260660000
67056	1678	17280636440000
67057	2132	148866867000
67058	2132	148865866000
67059	2134	98502512000
67060	2134	98501509000
67061	2134	98500506000
67062	2134	98499503000
67063	2133	98484972000
67064	2133	98483970000
67065	2133	98482968000
67066	2133	98481966000
67067	1701	11590398600056
67137	1688	35351714708000
67138	1688	35351725708000
67148	369	92607910000000
67149	1066	905711965000000
67150	369	89410610000000
67151	1186	611101950000000
67152	1397	1345130647000
67153	1678	17280636453000
67154	563	66000617000000
67155	1359	1701968237751650
67156	2132	148861862000
67157	2133	98468940000
67158	1874	3212000
67159	2134	98486464000
67160	1874	3215000
67161	1688	35352040708000
67176	1397	1345110645000
67177	1678	17280636455000
67178	2133	98465934000
67179	1874	3227000
67180	2134	98483455000
67181	1874	3230000
67182	1675	11662192999977
67183	1675	11662204999977
67185	1397	1345100644000
67186	1678	17280636456000
67187	2132	148860861000
67188	1874	3231000
67189	2134	98482452000
67190	1874	3234000
67191	2133	98464932000
67192	1689	10800217287625
67204	1397	1345070641000
67205	1678	17280636459000
67206	1397	1345060640000
67207	1678	17280636460000
67208	2133	98462928000
67209	1874	3246000
67210	2134	98479443000
67211	1874	3249000
67212	2134	98478440000
67213	1874	3252000
67214	2133	98461926000
67215	2132	148859860000
67216	1874	3255000
67217	1402	51694532319298
67218	1402	51694557319298
67229	1397	1345040638000
67230	1678	17280636462000
67231	1397	1345030637000
67232	1678	17280636463000
67233	2134	98476434000
67234	2133	98459922000
67235	2133	98458920000
67236	1874	3267000
67237	2132	148858859000
67238	1395	58040544308007706
67239	1395	58040544332007706
67253	1394	142562457000000
67254	1394	142562469000000
67311	1657	10801351000000
67312	1657	10801364000000
67320	576	78755815938283
67341	1397	1344880622000
67342	1678	17280636478000
66879	2134	98527587000
66880	1637	191525257819988
66881	1637	191525269819988
66894	1559	11482705000000
66895	1559	11482718000000
66942	1397	1345440678000
66943	1678	17280636422000
66944	2133	98500002000
66945	1874	3050000
66946	2134	98516554000
66947	1394	132482187000000
66948	1394	132482199000000
66970	1397	1345400674000
66971	1678	17280636426000
66972	2133	98495994000
66973	2132	148869870000
66974	2134	98513545000
66975	1508	13716292500009
67003	1397	1345350669000
67004	1678	17280636431000
67005	2133	98490984000
67006	1874	3095000
67007	2134	98508530000
67047	1695	11852237000000
67048	1695	11852249000000
67094	1397	1345200654000
67095	1678	17280636446000
67096	2133	98475954000
67097	2134	98493485000
67098	1394	139682433000000
67099	1394	139682445000000
67108	1768	14990798110000
67109	1768	14990811110000
67121	1397	1345160650000
67122	1678	17280636450000
67123	2133	98471946000
67124	2134	98489473000
67125	1874	3198000
67126	2132	148862863000
67127	1511	720013000000
67130	1397	1345150649000
67131	1678	17280636451000
67132	2134	98488470000
67133	2133	98470944000
67134	1874	3204000
67135	1685	107282138571430
67136	1685	107282150571430
67172	2134	98484458000
67173	2133	98466936000
67174	1700	13265968276737
67175	1700	13265970276737
67247	1397	1345010635000
67248	1678	17280636465000
67249	2133	98456916000
67250	2134	98474428000
67251	1874	3278000
67252	1992	11519287990000
67302	1397	1344930627000
67303	1678	17280636473000
67304	2133	98448900000
67305	1874	3318000
67306	2134	98466404000
67307	1874	3321000
67308	1769	1697900000
67309	1680	12249573500035
67310	1680	12249586500035
67313	1397	1344920626000
67314	1678	17280636474000
67315	2133	98447898000
67316	1874	3323000
67317	2134	98465401000
67318	1708	9395767000021
67319	1708	9395792000021
67331	1611	25911004000000
67339	1685	108002150571430
67340	1685	108002162571430
67397	1397	1344800614000
67398	1678	17280636486000
67399	2132	148851852000
67400	1704	2226218000000
67405	1746	7714372000000
67420	1397	1344770611000
67421	1678	17280636489000
67422	2132	148850851000
67423	1874	3399000
67424	2133	98433870000
67425	2134	98450356000
67426	1874	3404000
67427	1395	58041984344007706
67428	1395	58041984357007706
67431	1419	21339417280064
67432	1419	21339430280064
67435	1397	1344760610000
67436	1678	17280636490000
67437	2134	98449353000
67438	2133	98432868000
67439	1693	8780408406843
67440	1693	8780420406843
67442	1681	12023218759830
67443	1681	12023230759830
67460	1397	1344730607000
67461	1678	17280636493000
67462	1397	1344720606000
67463	1678	17280636494000
67464	2133	98429862000
67465	1874	3422000
67466	2133	98428860000
67467	2134	98446344000
67468	2134	98445341000
67469	1439	11812436998477
67470	1439	11812460998477
67490	1395	58042704366007706
67491	1395	58042704379007706
67530	1397	1344640598000
67531	1678	17280636502000
67532	2132	148846847000
67533	1769	1692900000
67534	2134	98438320000
67535	1874	3468000
67536	1588	14614959000000
67552	1397	1344620596000
67553	1678	17280636504000
67554	2134	98435311000
67555	2133	98418840000
67556	1637	193685318819988
67575	1397	1344590593000
67576	1678	17280636507000
67577	1397	1344580592000
67578	1678	17280636508000
67579	1397	1344570591000
67580	1678	17280636509000
67581	2133	98415834000
67582	2134	98432302000
67583	2132	148844845000
67584	1874	3500000
67585	2133	98414832000
67586	2133	98413830000
67587	1874	3504000
67588	2134	98431299000
67589	2134	98430296000
67590	1874	3510000
67591	1549	17615857000000
67598	1397	1344550589000
67599	1678	18000647511000
67600	1397	1344540588000
67601	1678	18000647512000
67602	2134	98428290000
67603	1874	3516000
67604	2134	98427287000
67605	2133	98412828000
67606	1874	3521000
67607	2133	98411826000
67608	2132	148843844000
67609	1874	3524000
67610	1394	148322507000000
67611	1394	148322532000000
67614	1397	1344530587000
67615	1678	18000647513000
67616	2133	98410824000
67617	2134	98426284000
67618	1395	58042704378007706
67636	1555	8835265979096
67676	1397	1344500584000
67677	1678	18000647516000
67678	2133	98407818000
67679	1874	3542000
67680	2134	98423275000
67681	1874	3545000
67682	1394	151202567000000
67683	1394	151202579000000
67692	1397	1344480582000
67693	1678	18000647518000
67694	1397	1344470581000
67695	1678	18000647519000
67696	1397	1344460580000
67697	1678	18000647520000
67698	2132	148841842000
67699	1874	3551000
67700	2133	98405814000
67701	2133	98404812000
67702	2133	98403810000
67703	1874	3557000
67704	2134	98421269000
67705	1874	3560000
67706	2134	98420266000
67002	1698	14217052550035
67015	1426	18285057000000
67016	1426	18285069000000
67024	1397	1345320666000
67025	1678	17280636434000
67026	2133	98487978000
67027	2134	98505521000
67028	1394	138242421000000
67029	1394	138242433000000
67032	1397	1345310665000
67033	1678	17280636435000
67034	2134	98504518000
67035	2133	98486976000
67036	1716	16606878000000
67037	1716	16606890000000
67040	1650	7234110000000
67041	1650	7234122000000
67068	1397	1345250659000
67069	1678	17280636441000
67070	1397	1345240658000
67071	1678	17280636442000
67072	1397	1345230657000
67073	1678	17280636443000
67074	2133	98480964000
67075	2133	98479962000
67076	2133	98478960000
67077	2132	148864865000
67078	2134	98498500000
67079	2134	98497497000
67080	2134	98496494000
67081	1740	12041402000000
67082	1740	12041439000000
67100	1397	1345190653000
67101	1678	17280636447000
67102	2133	98474952000
67103	1874	3179000
67104	2134	98492482000
67105	1874	3182000
67106	2132	148863864000
67107	1874	3183000
67110	1688	34631701708000
67111	1688	34631714708000
67128	1941	2157968000000
67129	1941	2157981000000
67162	369	80501410000000
67163	1312	1702889737751650
67164	1397	1345120646000
67165	1678	17280636454000
67166	2134	98485461000
67167	1874	3218000
67168	2133	98467938000
67169	1874	3220000
67170	1599	11139853393047
67171	1599	11140179393047
67184	1675	11662203999977
67193	1397	1345090643000
67194	1678	17280636457000
67195	1397	1345080642000
67196	1678	17280636458000
67197	2133	98463930000
67198	2134	98481449000
67199	1874	3241000
67200	2134	98480446000
67201	1419	20619394280064
67202	1419	20619417280064
67219	1397	1345050639000
67220	1678	17280636461000
67221	2134	98477437000
67222	1874	3258000
67223	2133	98460924000
67224	1874	3260000
67225	1599	11860179393047
67226	1599	11860191393047
67257	1397	1345000634000
67258	1678	17280636466000
67259	2133	98455914000
67260	2132	148857858000
67261	2134	98473425000
67262	1874	3284000
67263	1668	15806718000000
67264	1668	15806731000000
67271	1397	1344980632000
67272	1678	17280636468000
67273	1397	1344970631000
67274	1678	17280636469000
67275	2134	98471419000
67276	2134	98470416000
67277	2132	148856857000
67278	1874	3296000
67279	2133	98453910000
67280	2133	98452908000
67281	1874	3300000
67282	1637	192965281819988
67283	1637	192965306819988
67332	1397	1344890623000
67333	1678	17280636477000
67334	2134	98462392000
67335	2133	98444892000
67336	1874	3342000
67337	1395	58041264332007706
67338	1395	58041264344007706
67364	1397	1344850619000
67365	1678	17280636481000
67366	1397	1344840618000
67367	1678	17280636482000
67368	58	83226538999641
67369	2134	98458380000
67370	2134	98457377000
67371	2133	98440884000
67372	1874	3366000
67373	2132	148852853000
67374	2133	98439882000
67375	1874	3369000
67376	58	83946538999641
67377	58	83946543999641
67383	1723	17639492085979
67384	1723	17639504085979
67389	1397	1344810615000
67390	1678	17280636485000
67391	2133	98436876000
67392	1874	3381000
67393	2134	98454368000
67394	1874	3384000
67395	1643	2016390114700
67396	1643	2016402114700
67433	1559	12202718000000
67434	1559	12202731000000
67459	1692	77783002019999
67471	1679	12454826853000
67472	1679	12454850853000
67492	1397	1344690603000
67493	1678	17280636497000
67494	1397	1344680602000
67495	1678	17280636498000
67496	2134	98442332000
67497	1874	3444000
67498	1769	1695900000
67499	2133	98425854000
67500	1874	3446000
67501	1769	1694900000
67502	2133	98424852000
67503	1695	11852262000000
67508	1397	1344670601000
67509	1678	17280636499000
67510	1397	1344660600000
67511	1678	17280636500000
67512	1692	13459946719999
67513	1860	107501010000000
67514	1397	1344650599000
67515	1678	17280636501000
67516	2134	98441329000
67517	2133	98423850000
67518	1769	1693900000
67519	2134	98440326000
67520	1874	3456000
67521	2133	98422848000
67522	1874	3458000
67523	2133	98421846000
67524	2132	148847848000
67525	1874	3461000
67526	2134	98439323000
67527	1874	3464000
67528	1694	16572523127629
67529	1694	16572571127629
67537	1689	11520217287625
67538	1689	11520230287625
67557	1397	1344610595000
67558	1678	17280636505000
67559	2133	98417838000
67560	1874	3485000
67561	2132	148845846000
67562	1874	3486000
67563	2134	98434308000
67564	1685	108722162571430
67565	1685	108722175571430
67634	1402	52414557319298
67635	1402	52414592319298
67637	1708	9396102000021
67638	1678	17280636511000
67639	1678	17280636512000
67640	1678	17280636513000
67641	1678	17280636514000
67642	1678	17280636515000
67643	1874	3333000
67644	1874	3336000
67240	1397	1345020636000
67241	1678	17280636464000
67242	2134	98475431000
67243	2133	98457918000
67244	1874	3273000
67245	1394	141122445000000
67246	1394	141122457000000
67255	171	77510424524688
67256	171	77510436524688
67265	1397	1344990633000
67266	1678	17280636467000
67267	2133	98454912000
67268	2134	98472422000
67269	1680	11529561500035
67270	1680	11529573500035
67284	1397	1344960630000
67285	1678	17280636470000
67286	1397	1344950629000
67287	1678	17280636471000
67288	1397	1344940628000
67289	1678	17280636472000
67290	2132	148855856000
67291	2134	98469413000
67292	2133	98451906000
67293	1874	3306000
67294	1769	1698900000
67295	2134	98468410000
67296	1874	3309000
67297	2134	98467407000
67298	1874	3312000
67299	2133	98450904000
67300	2133	98449902000
67301	1536	14400751999959
67321	1397	1344910625000
67322	1678	17280636475000
67323	1397	1344900624000
67324	1678	17280636476000
67325	2133	98446896000
67326	2132	148854855000
67327	2133	98445894000
67328	2134	98464398000
67329	2134	98463395000
67330	576	78755850938283
67356	1397	1344860620000
67357	1678	17280636480000
67358	2134	98459383000
67359	2133	98441886000
67360	1588	14614946000000
67361	1588	14614958000000
67403	1747	5776884000000
67404	1747	5776896000000
67406	1397	1344790613000
67407	1678	17280636487000
67408	1397	1344780612000
67409	1678	17280636488000
67410	2133	98435874000
67411	1874	3390000
67412	2134	98452362000
67413	1874	3393000
67414	2134	98451359000
67415	1874	3396000
67416	2133	98434872000
67417	1874	3398000
67418	1597	2160020000000
67419	1597	2160044000000
67450	1397	1344740608000
67451	1678	17280636492000
67452	2134	98447347000
67453	1874	3417000
67454	2132	148849850000
67455	2133	98430864000
67456	1874	3420000
67473	1637	193685306819988
67474	1637	193685330819988
67488	1394	145442482000000
67489	1394	145442495000000
67504	1394	146882495000000
67505	1394	146882520000000
67539	1397	1344630597000
67540	1678	17280636503000
67541	2133	98420844000
67542	1874	3470000
67543	2134	98437317000
67544	1874	3473000
67546	2134	98436314000
67547	1874	3476000
67548	2133	98419842000
67549	1727	11707064000000
67550	1727	11707076000000
67551	1727	11707066000000
67566	1397	1344600594000
67567	1678	17280636506000
67568	1394	145442505000000
67569	2134	98433305000
67570	1874	3492000
67571	2133	98416836000
67572	1874	3494000
67573	1394	146882505000000
67574	1394	146882507000000
67593	1397	1344560590000
67594	1678	17280636510000
67595	2134	98429293000
67596	1678	18000636510000
67597	1678	18000647510000
67690	1696	13457352835100
67691	1696	13457364835100
67718	1637	195125355819988
67719	1637	195125368819988
67725	1688	35351726708000
67750	1474	11794435000023
67762	1397	1344390573000
67763	1678	18000647527000
67764	2134	98413245000
67765	1874	3598000
67766	2133	98396796000
67767	1874	3600000
67768	1685	109442187571430
67771	1580	1440032000000
67785	1397	1344360570000
67786	1678	18000647530000
67787	2133	98393790000
67788	1874	3613000
67789	2134	98410236000
67790	1874	3616000
67793	1397	1344350569000
67794	1678	18000647531000
67795	2134	98409233000
67796	1874	3619000
67797	2132	148837838000
67798	2133	98392788000
67799	1515	720015603400
67800	1515	720028603400
67801	1397	1344340568000
67802	1678	18000647532000
67803	1860	107499987700000
67804	2152	12300000
67805	1397	1344330567000
67806	1678	18000647533000
67807	1394	154082633000000
67808	1397	1344320566000
67809	1678	18000647534000
67810	1397	1344310565000
67811	1678	18000647535000
67812	2133	98391786000
67813	1874	3624000
67814	2132	148836837000
67815	2133	98390784000
67816	1874	3627000
67817	2134	98408230000
67818	2134	98407227000
67819	1874	3633000
67820	2134	98406224000
67821	2134	98405221000
67822	2133	98389782000
67823	1874	3641000
67824	2133	98388780000
67825	1874	3643000
67826	1394	155522633000000
67827	1394	155522662000000
67848	1397	1344280562000
67849	1678	18000647538000
67850	2134	98402212000
67851	2132	148835836000
67852	1874	3657000
67853	2133	98385774000
67883	1860	978700000
67884	2152	107499001300000
67885	1397	1344230557000
67886	1678	18000647543000
67887	1397	1344220556000
67888	1678	18000647544000
67889	1397	1344210555000
67890	1678	18000647545000
67891	2133	98380764000
67892	1874	3682000
67893	2132	148833834000
67894	2133	98379762000
67895	2133	98378760000
67896	1874	3687000
67897	2133	98377758000
67898	2134	98397197000
67899	2134	98396194000
67900	2134	98395191000
67901	2134	98394188000
67902	1610	10800339000000
67343	1726	133805109000
67344	2150	200000000
67345	1397	1344870621000
67346	1678	17280636479000
67347	2133	98443890000
67348	2134	98461389000
67349	1874	3347000
67350	2134	98460386000
67351	2132	148853854000
67352	1874	3351000
67353	2133	98442888000
67354	1874	3353000
67355	1447	13834558943000
67362	1564	9906401000000
67363	1564	9906413000000
67378	1397	1344830617000
67379	1678	17280636483000
67380	2133	98438880000
67381	1874	3371000
67382	2134	98456374000
67385	1397	1344820616000
67386	1678	17280636484000
67387	2133	98437878000
67388	2134	98455371000
67401	2134	98453365000
67402	1874	3387000
67429	1394	144002469000000
67430	1394	144002482000000
67441	1693	8780410406843
67444	1397	1344750609000
67445	1678	17280636491000
67446	2134	98448350000
67447	2133	98431866000
67448	1874	3414000
67449	1395	58041984366007706
67457	1601	8570217620000
67458	1601	8570230620000
67475	1397	1344710605000
67476	1678	17280636495000
67477	1769	1696900000
67478	2133	98427858000
67479	1874	3432000
67480	2134	98444338000
67481	1397	1344700604000
67482	1678	17280636496000
67483	2132	148848849000
67484	2134	98443335000
67485	2133	98426856000
67486	1679	13174850853000
67487	1679	13174863853000
67506	1643	2736402114700
67507	1643	2736427114700
67545	1696	12737352835100
67592	1687	12232775524804
67612	1685	109442175571430
67613	1685	109442200571430
67619	1397	1344520586000
67620	1678	18000647514000
67621	1397	1344510585000
67622	1678	18000647515000
67623	1726	132595109000
67624	2151	200000000
67625	2133	98409822000
67626	2134	98425281000
67627	1874	3534000
67628	2134	98424278000
67629	2132	148842843000
67630	2133	98408820000
67631	1874	3540000
67632	1394	149762532000000
67633	1394	149762567000000
67720	1397	1344440578000
67721	1678	18000647522000
67722	2133	98401806000
67723	2134	98417257000
67724	1874	3577000
67726	1397	1344430577000
67727	1678	18000647523000
67728	2133	98400804000
67729	1874	3579000
67730	1724	7867319000000
67731	1724	7867330000000
67751	1397	1344400574000
67752	1678	18000647526000
67753	2134	98414248000
67754	2133	98397798000
67755	1874	3595000
67756	1394	154082591000000
67757	1394	154082603000000
67760	1580	1440020000000
67761	1580	1440057000000
67791	1747	6496896000000
67792	1747	6496908000000
67854	2152	1300000
67855	1860	107499988700000
67856	1397	1344270561000
67857	1678	18000647539000
67858	2134	98401209000
67859	2133	98384772000
67860	1874	3664000
67861	1394	158402674000000
67862	1394	158402696000000
67876	1397	1344240558000
67877	1678	18000647542000
67878	2133	98381766000
67879	1874	3676000
67880	2134	98398200000
67881	2132	148834835000
67903	1397	1344200554000
67904	1678	18000647546000
67905	2134	98393185000
67906	1874	3704000
67907	2133	98376756000
67908	43	78240801890000
67924	1397	1344170551000
67925	1678	18000647549000
67926	2134	98390176000
67927	2133	98373750000
67928	1874	3722000
67929	1684	15120436880623
67930	1684	15120448880623
67948	1397	1344130547000
67949	1678	18000647553000
67950	2134	98387167000
67951	2133	98370744000
67952	1394	162722743000000
67953	1394	162722755000000
67975	1397	1344090543000
67976	1678	18000647557000
67977	1397	1344080542000
67978	1678	18000647558000
67979	2132	148829830000
67980	1874	3755000
67981	2133	98366736000
67982	2133	98365734000
67983	1874	3759000
67984	2134	98383155000
67985	2134	98382152000
67986	1874	3765000
67987	1394	162722768000000
68027	329	67444609999900
68028	329	200000500
68029	1849	67444622999500
68036	1397	1344010535000
68037	1678	18000647565000
68038	2133	98358720000
68039	2134	98375131000
68040	1874	3802000
68041	1668	16526731000000
68042	1668	16526743000000
68045	1874	3800000
68046	1668	16526742000000
68054	1608	13965618000000
68099	1397	1343930527000
68100	1678	18000647573000
68101	2133	98351706000
68102	1874	3836000
68103	2134	98368110000
68104	1874	3839000
68105	1509	12191845851155
68106	1509	12191857851155
68130	1714	13126420103056
68160	1451	11419016000000
68174	2134	98359083000
68175	1637	195845380819988
68176	1637	195845381819988
68218	1688	36071738708000
68219	1397	1343770511000
68220	1678	18000647589000
68221	2133	98336676000
68222	1874	3919000
68223	2134	98352062000
68224	1705	10715511500145
68225	1705	10715523500145
68228	1397	1343760510000
68229	1678	18000647590000
68230	2134	98351059000
68231	2133	98335674000
68247	1397	1343730507000
68248	1678	18000647593000
68249	1874	3849000
68250	1874	3851000
68251	1874	3853000
68252	1874	3859000
68253	1874	3861000
67645	1874	3339000
67646	1874	3345000
67647	1874	3348000
67648	1874	3354000
67649	1874	3360000
67650	1874	3363000
67651	1874	3372000
67652	1874	3375000
67653	1874	3377000
67654	1874	3386000
67655	1874	3392000
67656	1874	3410000
67657	1874	3416000
67658	1874	3428000
67659	1874	3431000
67660	1874	3434000
67661	1874	3437000
67662	1874	3440000
67663	1874	3443000
67664	1874	3449000
67665	1874	3452000
67666	1874	3455000
67667	1874	3467000
67668	1874	3474000
67669	1874	3480000
67670	1874	3482000
67671	1874	3488000
67672	1874	3498000
67673	1874	3506000
67674	1708	10116102000021
67675	1708	10116313000021
67684	1397	1344490583000
67685	1678	18000647517000
67686	2133	98406816000
67687	2134	98422272000
67688	1649	19724258999992
67689	1649	19724270999992
67710	1397	1344450579000
67711	1678	18000647521000
67712	2133	98402808000
67713	2134	98418260000
67714	1874	3571000
67715	2132	148840841000
67716	1613	15767978600000
67717	1613	15767991600000
67732	532	70320060000000
67739	1397	1344410575000
67740	1678	18000647525000
67741	2132	148839840000
67742	1874	3585000
67743	2134	98415251000
67744	1874	3588000
67745	2133	98398800000
67746	1467	8606714100039
67747	1467	8606727100039
67749	1690	112323486000000
67758	1692	14179946719999
67759	1692	14179958719999
67779	1397	1344370571000
67780	1678	18000647529000
67781	2134	98411239000
67782	2133	98394792000
67783	1395	58043424378007706
67784	1395	58043424390007706
67837	1686	11012010550062
67838	1686	11012022550062
67840	1394	156962662000000
67841	1394	156962674000000
67842	1397	1344290563000
67843	1678	18000647537000
67844	2133	98386776000
67845	2134	98403215000
67846	1506	11521208967172
67847	1506	11521220967172
67863	1688	36071726708000
67864	1688	36071748708000
67882	1489	10703992000000
67909	1397	1344190553000
67910	1678	18000647547000
67911	2134	98392182000
67912	2132	148832833000
67913	1874	3710000
67914	2133	98375754000
67915	1618	1440023000000
67945	1394	161282708000000
67946	1394	161282743000000
67988	1613	16487991600000
67989	1613	16488016600000
67990	1397	1344070541000
67991	1678	18000647559000
67992	1397	1344060540000
67993	1678	18000647560000
67994	1397	1344050539000
67995	1678	18000647561000
67996	1397	1344040538000
67997	1678	18000647562000
67998	1394	162722808000000
67999	1397	1344030537000
68000	1678	18000647563000
68001	2132	148828829000
68002	2133	98364732000
68003	2134	98381149000
68004	1874	3771000
68005	2133	98363730000
68006	1874	3773000
68007	2133	98362728000
68008	2134	98380146000
68009	2134	98379143000
68010	2134	98378140000
68011	2134	98377137000
68012	2133	98361726000
68013	1874	3789000
68014	2133	98360724000
68015	1874	3791000
68016	1394	164162808000000
68017	1394	164162829000000
68035	329	67444623000000
68043	1440	12959228000000
68044	1440	12959240000000
68055	1397	1343990533000
68056	1678	18000647567000
68057	2133	98356716000
68058	1874	3809000
68059	2134	98373125000
68060	1874	3812000
68061	2132	148826827000
68068	1397	1343980532000
68069	1678	18000647568000
68070	2133	98355714000
68071	1874	3815000
68072	2134	98372122000
68073	1874	3818000
68074	1419	21339429280064
68107	1397	1343920526000
68108	1678	18000647574000
68109	1397	1343910525000
68110	1678	18000647575000
68111	2134	98367107000
68112	2134	98366104000
68113	2133	98350704000
68114	2132	148824825000
68115	1874	3848000
68116	2133	98349702000
68117	1571	19440355001024
68118	1571	19440380001024
68120	1397	1343900524000
68121	1678	18000647576000
68122	2133	98348700000
68123	2134	98365101000
68124	1448	7236761000001
68131	1397	1343890523000
68132	1678	18000647577000
68133	2152	29748981300000
68134	2088	77750012300000
68135	1397	1343880522000
68136	1678	18000647578000
68137	1397	1343870521000
68138	1678	18000647579000
68139	1397	1343860520000
68140	1678	18000647580000
68141	2132	148823824000
68142	1874	3856000
68143	2133	98347698000
68144	1874	3858000
68145	2133	98346696000
68146	2133	98345694000
68147	2133	98344692000
68148	1874	3864000
68149	2134	98364098000
68150	2134	98363095000
68151	2134	98362092000
68152	1874	3873000
68153	2134	98361089000
68154	1874	3876000
68155	1444	14255142159999
68156	1444	14255201159999
68172	1703	7200733000000
68173	1703	7200746000000
68177	1397	1343840518000
68178	1678	18000647582000
68179	1397	1343830517000
68180	1678	18000647583000
68181	2133	98342688000
68182	2133	98341686000
68183	1874	3889000
67707	2134	98419263000
67708	1637	194405318819988
67709	1637	194405355819988
67733	1397	1344420576000
67734	1678	18000647524000
67735	2133	98399802000
67736	2134	98416254000
67737	1394	152642579000000
67738	1394	152642591000000
67748	526	68160065000000
67769	1549	18335857000000
67770	1549	18335869000000
67772	1397	1344380572000
67773	1678	18000647528000
67774	2133	98395794000
67775	2132	148838839000
67776	2134	98412242000
67777	1874	3606000
67778	1691	13643186100019
67828	1397	1344300564000
67829	1678	18000647536000
67830	2134	98404218000
67831	1874	3646000
67832	2133	98387778000
67833	1874	3648000
67834	1850	11438898000000
67835	1850	200000100
67836	1849	11438909999900
67839	1850	11438910000000
67865	1397	1344260560000
67866	1678	18000647540000
67867	1397	1344250559000
67868	1678	18000647541000
67869	2133	98383770000
67870	1874	3666000
67871	2134	98400206000
67872	1874	3669000
67873	2133	98382768000
67874	2134	98399203000
67875	1686	11012034550062
67916	1726	131385109000
67917	2153	200000000
67918	1397	1344180552000
67919	1678	18000647548000
67920	2133	98374752000
67921	2134	98391179000
67922	1874	3717000
67923	2148	719022000000
67933	1397	1344160550000
67934	1678	18000647550000
67935	1397	1344150549000
67936	1678	18000647551000
67937	1397	1344140548000
67938	1678	18000647552000
67939	2133	98372748000
67940	2134	98389173000
67941	2133	98371746000
67942	1874	3729000
67943	2134	98388170000
67944	2132	148831832000
67954	1397	1344120546000
67955	1678	18000647554000
67956	1397	1344110545000
67957	1678	18000647555000
67958	1397	1344100544000
67959	1678	18000647556000
67960	1726	130175109000
67961	2154	200000000
67962	2134	98386164000
67963	1874	3741000
67964	2134	98385161000
67965	2134	98384158000
67966	1874	3747000
67967	2133	98369742000
67968	1874	3749000
67969	2133	98368740000
67970	2133	98367738000
67971	1874	3753000
67972	2132	148830831000
67973	1633	10836558985638
67974	1633	10836605985638
68018	1397	1344020536000
68019	1678	18000647564000
68020	2132	148827828000
68021	2134	98376134000
68022	2133	98359722000
68023	1874	3797000
68024	1849	200000100
68025	1693	9500410406743
68026	1693	9500423406743
68032	329	67444610000000
68033	329	200000100
68034	1849	67444622999900
68064	1860	43896955400000
68065	1513	29521586000000
68066	1513	29521613000000
68067	1688	36071739708000
68086	1397	1343950529000
68087	1678	18000647571000
68088	1397	1343940528000
68089	1678	18000647572000
68090	2152	107496991300000
68091	2088	2012300000
68092	2133	98353710000
68093	2133	98352708000
68094	1874	3830000
68095	2132	148825826000
68096	2134	98369113000
68097	1693	10940436406843
68098	1693	10940470406843
68119	1637	195125380819988
68127	1686	11732034550062
68128	1686	11732046550062
68129	1440	12959230000000
68158	1394	165602829000000
68159	1394	165602888000000
68163	1611	25911018000000
68211	1397	1343780512000
68212	1678	18000647588000
68213	2134	98353065000
68214	1874	3916000
68215	2132	148820821000
68216	1991	13435832441475
68217	1991	13435844441475
68307	1397	1343680502000
68308	1678	18000647598000
68309	1597	2159004000000
68310	1874	3964000
68311	2134	98343035000
68312	2133	98326656000
68313	1874	3972000
68314	484	94800861000000
68318	1397	1343670501000
68319	1678	18000647599000
68320	2134	98342032000
68321	2133	98325654000
68322	1874	3977000
68323	1688	36791750708000
68324	1688	36791773708000
68356	1692	14899959719999
68357	1692	14899996719999
68367	2134	98337017000
68368	1874	4006000
68369	2134	98336014000
68370	1426	18285081000000
68374	1874	3995000
68375	1727	11707121000000
68376	1397	1343600494000
68377	1678	18000647606000
68378	1397	1343590493000
68379	1678	18000647607000
68380	2132	148814815000
68381	2133	98318640000
68382	2134	98335011000
68383	1874	4015000
68384	2134	98334008000
68385	1874	4018000
68386	238	66720196000000
68414	632	77969934000000
68415	1136	908817465000000
68416	632	72677914000000
68417	1256	613196750000000
68418	1397	1343550489000
68419	1678	18000647611000
68420	2133	98314632000
68421	2134	98329996000
68422	1719	11540497000000
68423	1719	11540549000000
68431	1657	11521364000000
68432	1657	11521376000000
68447	1649	20444270999992
68448	1649	20444303999992
68460	1397	1343510485000
68461	1678	18000647615000
68462	2134	98325984000
68463	1874	4058000
68464	2133	98310624000
68465	1608	14685618000000
68466	1608	14685630000000
68475	1395	58044864424007706
68480	1690	113043486000000
68481	1690	113043498000000
68500	1397	1343480482000
68501	1678	18000647618000
68502	2133	98307618000
67931	1394	159842696000000
67932	1394	159842708000000
67947	1688	36071761708000
68030	1693	9500410406843
68031	1693	9500423406843
68047	1397	1344000534000
68048	1678	18000647566000
68049	2134	98374128000
68050	1874	3803000
68051	2133	98357718000
68052	1693	10220423406843
68053	1693	10220436406843
68062	1395	58044144390007706
68063	1395	58044144403007706
68075	1397	1343970531000
68076	1678	18000647569000
68077	1397	1343960530000
68078	1678	18000647570000
68079	2134	98371119000
68080	1874	3821000
68081	2133	98354712000
68082	2134	98370116000
68083	1874	3826000
68084	1634	16031810641004
68085	1634	16031833641004
68125	1694	17292571127629
68126	1694	17292583127629
68157	1451	11418957000000
68161	58	84666543999641
68162	58	84666602999641
68164	1397	1343850519000
68165	1678	18000647581000
68166	2133	98343690000
68167	1874	3878000
68168	2132	148822823000
68169	1874	3879000
68170	2134	98360086000
68171	1394	165602842000000
68242	1397	1343740508000
68243	1678	18000647592000
68244	2133	98332668000
68245	2134	98349053000
68246	1768	14990810110000
68274	1692	14179959719999
68275	1397	1343720506000
68276	1678	18000647594000
68277	1397	1343710505000
68278	1678	18000647595000
68279	2133	98330664000
68280	1874	3948000
68281	2134	98347047000
68282	1874	3951000
68283	2134	98346044000
68284	1874	3954000
68285	2133	98329662000
68286	1874	3956000
68287	1616	4320108410000
68288	1616	4320132410000
68300	1397	1343690503000
68301	1678	18000647597000
68302	2134	98344038000
68303	2132	148817818000
68304	1874	3963000
68305	2133	98327658000
68306	1688	36071785708000
68317	1688	36071750708000
68325	1397	1343660500000
68326	1678	18000647600000
68327	2134	98341029000
68328	1874	3980000
68329	2133	98324652000
68330	2132	148816817000
68331	1874	3983000
68332	1688	37511773708000
68333	1688	37511786708000
68354	1394	168482876000000
68355	1394	168482913000000
68358	1397	1343620496000
68359	1678	18000647604000
68360	1397	1343610495000
68361	1678	18000647605000
68362	2133	98320644000
68363	1874	4001000
68364	2133	98319642000
68365	1874	4003000
68366	1426	18285079000000
68372	1685	110162187571430
68373	1685	110162211571430
68390	1397	1343580492000
68391	1678	18000647608000
68392	1397	1343570491000
68393	1678	18000647609000
68394	2133	98317638000
68395	1874	4020000
68396	2134	98333005000
68397	1874	4023000
68398	2134	98332002000
68399	1874	4026000
68400	2133	98316636000
68401	1874	4028000
68402	1602	13680490000000
68403	1602	13680514000000
68425	1397	1343540488000
68426	1678	18000647612000
68427	2134	98328993000
68428	2133	98313630000
68429	1874	4044000
68430	1679	13174862853000
68439	632	72677894000000
68440	1397	1343530487000
68441	1678	18000647613000
68442	2132	148812813000
68443	2133	98312628000
68444	2134	98327990000
68445	1874	4050000
68446	1684	15120469880623
68458	1522	11134170000000
68459	1522	11854170000000
68478	1522	12574172000000
68479	1522	12574184000000
68491	1397	1343490483000
68492	1678	18000647617000
68493	2132	148811812000
68494	1874	4064000
68495	2133	98308620000
68496	1874	4068000
68497	2134	98323978000
68498	1394	169922909000000
68499	1394	169922933000000
68512	1397	1343460480000
68513	1678	18000647620000
68514	2134	98320969000
68515	2133	98305614000
68516	1874	4086000
68517	2132	148810811000
68518	1874	4087000
68519	1622	18540390000005
68520	1622	18540403000005
68549	1397	1343410475000
68550	1678	18000647625000
68551	2134	98316957000
68552	2133	98301606000
68553	1874	4108000
68554	1740	12761439000000
68555	1740	12761451000000
68573	1397	1343380472000
68574	1678	18000647628000
68575	2134	98313948000
68576	2133	98298600000
68577	1991	14155844441475
68578	1991	14155856441475
68601	1874	4126000
68602	1688	38231786708000
68603	1688	38231798708000
68638	1397	1343330467000
68639	1678	18000647633000
68640	2133	98293590000
68641	1874	4147000
68642	2134	98308933000
68643	1874	4150000
68659	1397	1343300464000
68660	1678	18000647636000
68661	2133	98290584000
68662	2134	98305924000
68663	1874	4166000
68664	1670	16561089000000
68665	1670	16561101000000
68719	1397	1343220456000
68720	1678	18000647644000
68721	1397	1343210455000
68722	1678	18000647645000
68723	2134	98297900000
68724	1874	4204000
68725	2132	148803804000
68726	2133	98283570000
68727	1874	4207000
68728	2133	98282568000
68729	1685	111602223571430
68730	1685	111602247571430
68750	1397	1343180452000
68751	1678	18000647648000
68752	2133	98279562000
68753	1874	4222000
68754	2134	98294891000
68755	1874	4225000
68184	2134	98358080000
68185	1394	165602852000000
68186	1397	1343820516000
68187	1678	18000647584000
68188	1397	1343810515000
68189	1678	18000647585000
68190	1397	1343800514000
68191	1678	18000647586000
68192	1397	1343790513000
68193	1678	18000647587000
68194	2133	98340684000
68195	1874	3894000
68196	2133	98339682000
68197	1874	3896000
68198	2132	148821822000
68199	2134	98357077000
68200	2134	98356074000
68201	1874	3903000
68202	2134	98355071000
68203	1874	3906000
68204	2134	98354068000
68205	1874	3909000
68206	2133	98338680000
68207	1874	3911000
68208	2133	98337678000
68209	1874	3913000
68210	1622	17820390000005
68226	1701	12310398600056
68227	1701	12310410600056
68232	1397	1343750509000
68233	1678	18000647591000
68234	1597	2160034000000
68235	2134	98350056000
68236	2133	98334672000
68237	2132	148819820000
68238	1874	3933000
68239	2133	98333670000
68240	1394	167042852000000
68241	1394	167042876000000
68298	1703	7920746000000
68299	1703	7920768000000
68315	1395	58044864412007706
68316	1395	58044864447007706
68338	1397	1343650499000
68339	1678	18000647601000
68340	1397	1343640498000
68341	1678	18000647602000
68342	1397	1343630497000
68343	1678	18000647603000
68344	2132	148815816000
68345	2133	98323650000
68346	2134	98340026000
68347	2133	98322648000
68348	2133	98321646000
68349	1874	3993000
68350	2134	98339023000
68351	2134	98338020000
68352	1689	12240230287625
68353	1689	12240267287625
68404	632	85813954000000
68405	1382	1708727637751650
68406	1397	1343560490000
68407	1678	18000647610000
68408	2132	148813814000
68409	2133	98315634000
68410	1874	4031000
68411	2134	98330999000
68412	1874	4034000
68413	1394	168482909000000
68449	1397	1343520486000
68450	1678	18000647614000
68451	1394	168482919000000
68452	2133	98311626000
68453	1874	4052000
68454	2134	98326987000
68455	1874	4055000
68456	1394	169922919000000
68457	1394	169922921000000
68470	1397	1343500484000
68471	1678	18000647616000
68472	2133	98309622000
68473	1874	4062000
68474	1719	12260561000000
68476	2148	1439022000000
68477	2148	1439034000000
68482	1573	7898991000000
68483	1573	7899003000000
68506	1397	1343470481000
68507	1678	18000647619000
68508	2133	98306616000
68509	2134	98321972000
68510	1394	171362933000000
68511	1394	171362945000000
68521	1397	1343450479000
68522	1678	18000647621000
68523	2133	98304612000
68524	2134	98319966000
68531	1397	1343430477000
68532	1678	18000647623000
68533	2134	98317960000
68534	2133	98302608000
68535	1874	4102000
68538	667	66000975000000
68539	1874	3681000
68540	1874	3684000
68541	1874	3688000
68542	667	66720975000000
68543	667	66721055000000
68558	1397	1343400474000
68559	1678	18000647626000
68560	1397	1343390473000
68561	1678	18000647627000
68562	2133	98300604000
68563	2132	148808809000
68564	1874	4111000
68565	2134	98315954000
68566	1874	4114000
68567	2134	98314951000
68568	1874	4117000
68569	2133	98299602000
68570	1874	4119000
68571	1684	15840469880623
68572	1684	15840494880623
68614	606	74637816812962
68623	1395	58044864425007706
68697	1397	1343240458000
68698	1678	18000647642000
68699	2134	98299906000
68700	1874	4190000
68701	1874	4192000
68702	2133	98285574000
68703	1874	4196000
68704	1394	175682970000000
68705	1394	175683030000000
68707	1397	1343230457000
68708	1678	18000647643000
68709	2133	98284572000
68710	1874	4198000
68711	2134	98298903000
68712	1874	4201000
68713	1688	38951798708000
68714	1688	38951810708000
68732	1397	1343200454000
68733	1678	18000647646000
68734	1397	1343190453000
68735	1678	18000647647000
68736	2132	148802803000
68737	1874	4210000
68738	2133	98281566000
68739	2134	98296897000
68740	2133	98280564000
68741	2134	98295894000
68742	1874	4220000
68743	2086	2879067000000
68744	2086	2879092000000
68747	2087	3599070000000
68748	2087	3599095000000
68749	1650	7234135000000
68779	1541	722072000000
68796	1397	1343120446000
68797	1678	18000647654000
68798	2134	98288873000
68799	1874	4252000
68800	2132	148800801000
68801	2133	98274552000
68802	2039	15121419000000
68803	2039	15121432000000
68812	1688	38951823708000
68819	1714	13126432103056
68829	1759	12960749999999
68830	1759	12960773999999
68851	1397	1343040438000
68852	1678	18000647662000
68853	2133	98266536000
68854	2134	98281852000
68855	1874	4294000
68894	1564	9906473000000
68895	1860	977700000
68896	2152	107499012300000
68897	1564	10626473000000
68898	1564	10627743000000
68927	1397	1342920426000
68928	1678	18000647674000
68929	1397	1342910425000
68930	1678	18000647675000
68254	1874	3863000
68255	1874	3869000
68256	1874	3871000
68257	1874	3888000
68258	1874	3891000
68259	1874	3898000
68260	1874	3904000
68261	1874	3908000
68262	2133	98331666000
68263	1874	3928000
68264	1874	3931000
68265	1874	3934000
68266	1508	13716555500009
68267	2134	98348050000
68268	1874	3943000
68269	1874	3944000
68270	2132	148818819000
68271	1874	3946000
68272	1508	14436555500009
68273	1508	14436559500009
68289	1397	1343700504000
68290	1678	18000647596000
68291	1597	2159014000000
68292	2155	10000000
68293	2134	98345041000
68294	1874	3959000
68295	2133	98328660000
68296	1874	3961000
68297	1395	58044144412007706
68334	1597	1438990000000
68335	1597	1438980000000
68336	1455	8674088000000
68337	1455	8674994000000
68371	1727	11707088000000
68387	238	66001520000000
68388	238	66721520000000
68389	238	66722140000000
68424	1719	11540537000000
68433	1700	13985970276737
68434	1700	13985982276737
68435	632	68300894000000
68436	1016	507154775000000
68437	1455	9394994000000
68438	1455	9395074000000
68467	2134	98324981000
68468	1719	12260549000000
68469	1719	12260550000000
68484	1874	3998000
68485	1874	4000000
68486	1874	4008000
68487	1874	4010000
68488	1874	4016000
68489	1727	12427121000000
68490	1727	12427324000000
68544	1397	1343420476000
68545	1678	18000647624000
68546	2132	148809810000
68547	1698	14937052550035
68548	1698	14937063550035
68556	1685	110882211571430
68557	1685	110882223571430
68579	1397	1343370471000
68580	1678	18000647629000
68581	1874	3966000
68582	1874	3985000
68583	1874	3988000
68584	1874	3990000
68585	1874	4032000
68586	1874	4038000
68587	1874	4040000
68588	1874	4056000
68589	1874	4074000
68590	1874	4080000
68591	1874	4083000
68592	1874	4098000
68593	1874	4104000
68594	1874	4113000
68595	2134	98312945000
68596	1874	4125000
68597	2133	98297598000
68598	1874	4129000
68599	1508	14437098500009
68600	1508	15157098500009
68626	484	75725786000000
68627	1073	907346465000000
68628	484	71425766000000
68629	1193	612204750000000
68630	484	67868746000000
68631	953	506334775000000
68632	1397	1343340468000
68633	1678	18000647632000
68634	2133	98294592000
68635	1874	4142000
68636	2134	98309936000
68637	1571	19440427001024
68657	1690	113763518000000
68658	1690	113763543000000
68666	1397	1343290463000
68667	1678	18000647637000
68668	2133	98289582000
68669	1874	4168000
68670	2132	148805806000
68671	2134	98304921000
68672	1874	4172000
68673	1419	22059429280064
68674	1419	22059442280064
68717	1634	16751833641004
68718	1634	16751845641004
68746	1699	6549815750126
68758	1397	1343170451000
68759	1678	18000647649000
68760	2134	98293888000
68761	1874	4228000
68762	2133	98278560000
68763	1402	52414569319298
68764	1397	1343160450000
68765	1678	18000647650000
68766	1397	1343150449000
68767	1678	18000647651000
68768	1397	1343140448000
68769	1678	18000647652000
68770	2132	148801802000
68771	1874	4231000
68772	2134	98292885000
68773	1874	4234000
68774	2133	98277558000
68775	2133	98276556000
68776	2134	98291882000
68777	2134	98290879000
68778	1718	7506797763340
68780	1643	3456427114700
68781	1643	3456463114700
68784	1397	1343130447000
68785	1678	18000647653000
68786	2133	98275554000
68787	1874	4246000
68788	2134	98289876000
68789	1874	4249000
68790	1394	177122982000000
68791	1394	177122994000000
68817	1395	58046304436007706
68818	1395	58046304448007706
68887	1457	13584339040000
68888	1457	14304339040000
68889	1457	14304341040000
69003	1397	1342820416000
69004	1678	18720659684000
69005	2133	98245494000
69006	2134	98258783000
69007	1419	23499467280064
69008	1419	23499479280064
69022	1555	9555257979096
69023	1555	9555270979096
68503	1874	4073000
68504	2134	98322975000
68505	1874	4076000
68525	632	68300874000000
68526	1397	1343440478000
68527	1678	18000647622000
68528	2134	98318963000
68529	2133	98303610000
68530	1690	113043518000000
68536	667	66720095000000
68537	667	66720107000000
68604	484	82098806000000
68605	1319	1705962637751650
68606	1397	1343360470000
68607	1678	18000647630000
68608	2087	2879070000000
68609	2132	148807808000
68610	2133	98296596000
68611	1874	4132000
68612	2134	98311942000
68613	606	74637817812962
68615	1397	1343350469000
68616	1678	18000647631000
68617	2133	98295594000
68618	1874	4137000
68619	2134	98310939000
68620	2086	2159067000000
68621	1546	11520836000000
68622	1546	11520849000000
68624	1549	19055869000000
68625	1549	19055882000000
68644	1397	1343320466000
68645	1678	18000647634000
68646	1397	1343310465000
68647	1678	18000647635000
68648	2132	148806807000
68649	2134	98307930000
68650	1874	4154000
68651	2133	98292588000
68652	1874	4156000
68653	2133	98291586000
68654	2134	98306927000
68655	1394	172802945000000
68656	1394	172802970000000
68675	1394	174242970000000
68676	1397	1343280462000
68677	1678	18000647638000
68678	1397	1343270461000
68679	1678	18000647639000
68680	1397	1343260460000
68681	1678	18000647640000
68682	1397	1343250459000
68683	1678	18000647641000
68684	2132	148804805000
68685	2133	98288580000
68686	2134	98303918000
68687	1874	4178000
68688	2134	98302915000
68689	2134	98301912000
68690	1874	4184000
68691	2134	98300909000
68692	2133	98287578000
68693	1874	4189000
68694	2133	98286576000
68695	1637	196565381819988
68696	1637	196565429819988
68706	1394	175682982000000
68715	1395	58045584424007706
68716	1395	58045584436007706
68731	1690	113763542000000
68745	1588	14614971000000
68794	1635	720000000000
68795	1635	720012000000
68804	1397	1343110445000
68805	1678	18000647655000
68806	2134	98287870000
68807	1874	4258000
68808	2133	98273550000
68809	1874	4260000
68810	1509	12911857851155
68811	1509	12911869851155
68820	1397	1343090443000
68821	1678	18000647657000
68822	1397	1343080442000
68823	1678	18000647658000
68824	2133	98271546000
68825	2134	98285864000
68826	1874	4270000
68827	2132	148799800000
68828	2133	98270544000
68843	1439	11812461998477
68844	1692	14899984719999
68872	1397	1343000434000
68873	1678	18000647666000
68874	1397	1342990433000
68875	1678	18000647667000
68876	2132	148796797000
68877	1874	4311000
68878	2133	98262528000
68879	2133	98261526000
68880	1395	58046304471007706
68881	2134	98277840000
68882	1874	4318000
68883	2134	98276837000
68884	1395	58047024471007706
68885	1527	58047024472007707
68886	1395	272999977
68899	1397	1342970431000
68900	1678	18000647669000
68901	1397	1342960430000
68902	1678	18000647670000
68903	1397	1342950429000
68904	1678	18000647671000
68905	1397	1342940428000
68906	1678	18000647672000
68907	1397	1342930427000
68908	1678	18000647673000
68909	2132	148795796000
68910	2134	98274831000
68911	2134	98273828000
68912	2134	98272825000
68913	1874	4334000
68914	2133	98260524000
68915	1874	4336000
68916	2133	98259522000
68917	2133	98258520000
68918	1874	4340000
68919	2133	98257518000
68920	1874	4342000
68921	2134	98271822000
68922	1874	4345000
68923	2134	98270819000
68924	1874	4348000
68925	2133	98256516000
68926	1933	1440202000000
68956	1698	15657063550035
68957	1698	15657088550035
68959	1397	1342880422000
68960	1678	18000647678000
68961	2134	98265804000
68962	1874	4375000
68963	2133	98251506000
68964	1874	4377000
68965	1678	18720647678000
68966	1678	18720659678000
68972	1688	39671810708000
68973	1688	39671821708000
68974	1397	1342860420000
68975	1678	18720659680000
68976	1397	1342850419000
68977	1678	18720659681000
68978	2134	98263798000
68979	2134	98262795000
68980	2132	148792793000
68981	1874	4387000
68982	2133	98250504000
68983	2133	98249502000
68984	1874	4391000
68985	2133	98248500000
68986	2134	98261792000
68987	1555	8835257979096
69014	1397	1342800414000
69015	1678	18720659686000
69016	2134	98257780000
69017	2133	98243490000
69018	2132	148790791000
69019	1874	4420000
69020	1395	58047744473007706
69021	1395	58047744486007706
69032	1688	40391821708000
69033	1688	40391833708000
68756	1506	12241220967172
68757	1506	12241232967172
68782	576	79475815938283
68783	576	79476072938283
68792	576	79475850938283
68793	576	79475862938283
68813	1397	1343100444000
68814	1678	18000647656000
68815	2133	98272548000
68816	2134	98286867000
68831	1397	1343070441000
68832	1678	18000647659000
68833	1397	1343060440000
68834	1678	18000647660000
68835	2132	148798799000
68836	2134	98284861000
68837	2134	98283858000
68838	2133	98269542000
68839	1874	4282000
68840	2133	98268540000
68841	1668	17246742000000
68842	1668	17246767000000
68845	1397	1343050439000
68846	1678	18000647661000
68847	2133	98267538000
68848	2134	98282855000
68849	1395	58047024448007706
68850	1395	58047024460007706
68856	1397	1343030437000
68857	1678	18000647663000
68858	1397	1343020436000
68859	1678	18000647664000
68860	1397	1343010435000
68861	1678	18000647665000
68862	2132	148797798000
68863	2134	98280849000
68864	2134	98279846000
68865	2134	98278843000
68866	2133	98265534000
68867	1874	4306000
68868	2133	98264532000
68869	1874	4308000
68870	2133	98263530000
68871	1547	11373413000000
68890	1397	1342980432000
68891	1678	18000647668000
68892	2134	98275834000
68893	1874	4324000
68941	1397	1342900424000
68942	1678	18000647676000
68943	1397	1342890423000
68944	1678	18000647677000
68945	2133	98253510000
68946	1874	4363000
68947	2133	98252508000
68948	2132	148793794000
68949	1874	4366000
68950	2134	98267810000
68951	1874	4369000
68952	2134	98266807000
68953	1874	4372000
68954	1422	9505052860211
68955	1422	9505077860211
68958	1395	58047024473007706
68995	1397	1342830417000
68996	1678	18720659683000
68997	2133	98246496000
68998	1874	4403000
68999	2134	98259786000
69000	1874	4406000
69001	2132	148791792000
69002	1394	177122995000000
69024	1397	1342790413000
69025	1678	18720659687000
69026	2133	98242488000
69027	1874	4422000
69028	2134	98256777000
69029	1874	4425000
69030	1571	20160427001024
69031	1571	20160439001024
69034	1397	1342780412000
69035	1678	18720659688000
69036	1397	1342770411000
69037	1678	18720659689000
69038	2134	98255774000
69039	1874	4428000
69040	2134	98254771000
69041	2133	98241486000
69042	1874	4433000
69043	2133	98240484000
69044	1874	4435000
69045	2132	148789790000
69046	1727	11707089000000
69047	1394	178562995000000
69048	1394	178563020000000
68931	2133	98255514000
68932	1874	4352000
68933	2133	98254512000
68934	1874	4354000
68935	2132	148794795000
68936	2134	98269816000
68937	1874	4358000
68938	2134	98268813000
68939	1419	22779442280064
68940	1419	22779467280064
68967	1397	1342870421000
68968	1678	18720659679000
68969	2134	98264801000
68970	1693	11660470406843
68971	1693	11660481406843
68988	1397	1342840418000
68989	1678	18720659682000
68990	2133	98247498000
68991	2134	98260789000
68992	1874	4401000
68993	1675	12382204999977
68994	1675	12382216999977
69009	1397	1342810415000
69010	1678	18720659685000
69011	2133	98244492000
69012	1587	18720577000000
69013	1587	18720588000000
69049	1727	12427554000000
69050	1678	18000647679000
69051	1678	18000647680000
69052	1678	18000647681000
69053	1678	18000647682000
69054	1678	18000647683000
69055	1678	18000647684000
69056	1678	18000647685000
69057	1678	18000647686000
69058	1678	18000647687000
69059	1678	18000647688000
69060	1678	18000647689000
69061	1874	4025000
69062	1874	4037000
69063	1874	4043000
69064	1874	4046000
69065	1874	4049000
69066	1874	4061000
69067	1874	4067000
69068	1874	4079000
69069	1727	13147554000000
69070	1727	200100000
69071	2070	13147997885200
69072	1447	1434942190000
69073	1420	13834563938000
69074	2095	2913298999985
69075	1423	200010000
69076	707	30400
69077	1514	9000300000000
69078	1397	1342760410000
69079	1678	18720659690000
69080	2134	98253768000
69081	2133	98239482000
69082	1471	15020396900000
69083	1678	18000647690000
69084	1874	4005000
69085	1874	4011000
69086	1874	4013000
69087	1874	4021000
69088	1471	15740396900000
69089	1471	15740773900000
69090	1397	1342750409000
69091	1678	18720659691000
69092	1397	1342740408000
69093	1678	18720659692000
69094	1397	1342730407000
69095	1678	18720659693000
69096	2133	98238480000
69097	2133	98237478000
69098	2132	148788789000
69099	1874	4446000
69100	2133	98236476000
69101	1874	4448000
69102	2134	98252765000
69103	2134	98251762000
69104	1874	4454000
69105	2134	98250759000
69106	1874	4457000
69107	1685	112322247571430
69108	1685	112322284571430
69109	1397	1342720406000
69110	1678	18720659694000
69111	2134	98249756000
69112	2133	98235474000
69113	1874	4462000
69114	1397	1342710405000
69115	1678	18720659695000
69116	2133	98234472000
69117	1874	4464000
69118	2134	98248753000
69119	1874	4467000
69120	1709	10800138999976
69121	1709	10800140999976
69122	1560	14994344277001
69123	1886	200999998
69124	1560	15714343277003
69125	1440	12239238000000
69126	1440	12959238000000
69127	1560	15714344277001
69128	1560	15714346277001
69129	1397	1342700404000
69130	1678	18720659696000
69131	1397	1342690403000
69132	1678	18720659697000
69133	2134	98247750000
69134	2134	98246747000
69135	2133	98233470000
69136	2133	98232468000
69137	1874	4477000
69138	2132	148787788000
69139	1654	15408158999798
69140	1678	17280636516000
69141	1678	17280636517000
69142	1678	17280636518000
69143	1678	17280636519000
69144	1678	17280636520000
69145	1678	17280636521000
69146	1678	17280636522000
69147	1678	17280636523000
69148	1678	17280636524000
69149	1678	17280636525000
69150	1678	17280636526000
69151	1678	17280636527000
69152	1678	17280636528000
69153	1678	17280636529000
69154	1678	17280636530000
69155	1678	17280636531000
69156	1678	17280636532000
69157	1678	17280636533000
69158	1678	17280636534000
69159	1678	17280636535000
69160	1678	17280636536000
69161	1678	17280636537000
69162	1654	14688773999798
69163	1678	17280636538000
69164	1678	17280636539000
69165	1678	17280636540000
69166	1678	17280636541000
69167	1678	17280636542000
69168	1678	17280636543000
69169	1678	17280636544000
69170	1678	17280636545000
69171	1678	17280636546000
69172	1678	17280636547000
69173	1678	17280636548000
69174	1678	17280636549000
69175	1678	17280636550000
69176	1678	17280636551000
69177	1678	17280636552000
69178	1678	17280636553000
69179	1678	17280636554000
69180	1678	17280636555000
69181	1678	17280636556000
69182	1678	17280636557000
69183	1678	17280636558000
69184	1678	17280636559000
69185	1678	17280636560000
69186	1678	17280636561000
69187	1678	17280636562000
69188	1678	17280636563000
69189	1678	17280636564000
69190	1678	17280636565000
69191	1678	17280636566000
69192	1678	17280636567000
69193	1678	17280636568000
69194	1678	17280636569000
69195	1678	17280636570000
69196	1678	17280636571000
69197	1678	17280636572000
69198	1678	17280636573000
69199	1678	17280636574000
69200	1678	17280636575000
69201	1678	17280636576000
69202	1678	17280636577000
69203	1678	17280636578000
69204	1678	17280636579000
69205	1678	17280636580000
69206	1678	17280636581000
69207	1678	17280636582000
69208	1678	17280636583000
69209	1678	17280636584000
69210	1678	17280636585000
69211	1678	17280636586000
69212	1678	17280636587000
69213	1678	17280636588000
69214	1678	17280636589000
69215	1678	17280636590000
69216	1678	17280636591000
69217	1678	17280636592000
69218	1678	17280636593000
69219	1678	17280636594000
69220	1678	17280636595000
69221	1678	17280636596000
69222	1678	17280636597000
69223	1678	17280636598000
69224	1678	17280636599000
69225	1678	17280636600000
69226	1678	17280636601000
69227	1678	17280636602000
69228	1678	17280636603000
69229	1678	17280636604000
69230	1654	15408773999798
69231	1654	15409463999798
69252	1397	1342670401000
69253	1678	18720659699000
69254	2133	98230464000
69255	1874	4482000
69256	2132	148786787000
69257	2134	98244741000
69258	1874	4489000
69259	149	82110250000341
69273	1439	11812459998477
69321	1704	2226230000000
69322	1654	15406138999798
69323	974	504693496200000
69324	1397	1342590393000
69325	1678	18720659707000
69326	1397	1342580392000
69327	1678	18720659708000
69328	1769	1690900000
69329	2133	98224452000
69330	2133	98223450000
69331	2134	98237720000
69332	2134	98236717000
69333	1874	4529000
69334	1509	13631869851155
69335	1509	13631904851155
69338	1654	14687123999798
69339	1654	14686113999798
69340	1430	1390000000
69341	1430	721390000000
69342	1430	721960000000
69343	1397	1342570391000
69344	1678	18720659709000
69345	1397	1342560390000
69346	1678	18720659710000
69347	1397	1342550389000
69348	1678	18720659711000
69349	2134	98235714000
69350	1874	4532000
69351	2134	98234711000
69352	1874	4535000
69353	2132	148783784000
69354	2134	98233708000
69355	2133	98222448000
69356	1874	4541000
69357	2133	98221446000
69358	1874	4543000
69359	2133	98220444000
69360	2086	2879104000000
69364	1397	1342540388000
69365	1678	18720659712000
69366	1654	15405128999798
69367	974	504694496200000
69368	2134	98232705000
69369	2133	98219442000
69370	1874	4550000
69371	1439	12532459998477
69372	1439	12532481998477
69388	1395	58048464498007706
69446	1472	1440011000000
69447	1472	1440014000000
69457	1394	184323045000000
69458	1394	184323057000000
69459	1397	1342490383000
69460	1678	18720659717000
69461	2134	98226687000
69462	2133	98214432000
69469	1678	18000647715000
69470	1678	18000647716000
69471	1678	18000647717000
69472	1564	11348582000000
69473	1678	18000647718000
69474	1874	3713000
69475	1874	3719000
69476	1874	3723000
69477	1874	3725000
69478	1874	3731000
69479	1874	3735000
69480	1874	3737000
69481	1874	3743000
69482	1874	3761000
69483	1874	3767000
69484	1874	3777000
69485	1874	3779000
69486	1874	3783000
69487	1874	3785000
69488	1564	12068582000000
69489	1564	12068651000000
69496	1397	1342460380000
69497	1678	18720659720000
69498	2133	98211426000
69499	2134	98224681000
69500	1432	12000000
69501	1432	720012000000
69529	1397	1342430377000
69530	1678	18720659723000
69531	1397	1342420376000
69532	1678	18720659724000
69533	1397	1342410375000
69534	1678	18720659725000
69535	1397	1342400374000
69536	1678	18720659726000
69537	2134	98221672000
69538	1874	4607000
69539	2134	98220669000
69540	2133	98208420000
69541	1874	4612000
69542	2133	98207418000
69543	1874	4614000
69544	2133	98206416000
69545	1874	4616000
69546	2133	98205414000
69547	2132	148778779000
69548	1874	4619000
69549	2134	98219666000
69550	1874	4622000
69551	2134	98218663000
69552	1394	185763057000000
69553	1394	185763106000000
69555	1397	1342390373000
69556	1678	18720659727000
69557	2133	98204412000
69558	1874	4627000
69559	2134	98217660000
69560	1593	14950026000000
69577	1397	1342360370000
69578	1678	18720659730000
69579	2133	98201406000
69580	2134	98214651000
69581	1874	4646000
69582	1686	12452046550062
69583	1686	12452058550062
69584	1397	1342350369000
69585	1678	18720659731000
69586	2133	98200404000
69587	2134	98213648000
69588	1874	4651000
69639	1703	7920758000000
69646	1397	1342300364000
69647	1678	18720659736000
69648	2134	98208633000
69649	2132	148775776000
69650	1874	4676000
69651	1402	53134569319298
69652	1402	53134581319298
69655	1397	1342290363000
69656	1678	18720659737000
69657	2133	98195394000
69658	2134	98207630000
69659	1874	4681000
69660	1685	113042284571430
69661	1685	113042296571430
69671	2156	718800000000
69672	1397	1342270361000
69673	1678	18720659739000
69674	1397	1342260360000
69675	1678	18720659740000
69676	1643	2649064862100
69677	1299	1703411285540250
69678	1643	2219163054300
69679	1053	905989686644800
69680	1643	1928771205300
69232	1397	1342680402000
69233	1678	18720659698000
69234	1874	4427000
69235	1874	4430000
69236	1874	4432000
69237	1874	4437000
69238	1874	4438000
69239	1874	4440000
69240	1874	4444000
69241	1874	4450000
69242	1874	4456000
69243	1874	4459000
69244	2134	98245744000
69245	1874	4469000
69246	1874	4471000
69247	1874	4479000
69248	1874	4481000
69249	2133	98231466000
69250	1717	10908182000023
69251	1717	11628182000023
69262	1397	1342660400000
69263	1678	18720659700000
69264	1397	1342650399000
69265	1678	18720659701000
69266	2133	98229462000
69267	2134	98243738000
69268	1874	4494000
69269	2134	98242735000
69270	1874	4497000
69271	1689	12960267287625
69272	1689	12960290287625
69288	576	79475861938283
69296	1394	178563007000000
69319	1587	19440588000000
69320	1587	19440611000000
69363	1699	6549827750126
69381	1397	1342520386000
69382	1678	18720659714000
69383	2134	98230699000
69384	2133	98218440000
69385	1874	4559000
69386	1426	19005079000000
69387	1426	19005091000000
69439	2132	148781782000
69440	1874	4565000
69441	2133	98216436000
69442	1874	4567000
69443	2134	98228693000
69444	1874	4570000
69445	2029	1439013000000
69455	2112	2159024000000
69456	2112	2159036000000
69490	1397	1342470381000
69491	1678	18720659719000
69492	2133	98212428000
69493	1874	4584000
69494	2132	148780781000
69495	2134	98225684000
69563	1397	1342380372000
69564	1678	18720659728000
69565	1397	1342370371000
69566	1678	18720659729000
69567	2132	148777778000
69568	1874	4631000
69569	2134	98216657000
69570	1874	4634000
69571	2134	98215654000
69572	1874	4637000
69573	2133	98203410000
69574	1874	4639000
69575	2133	98202408000
69576	1874	4641000
69604	1727	12427089000000
69605	1727	12427114000000
69628	1397	1342320366000
69629	1678	18720659734000
69630	2134	98210639000
69631	2133	98197398000
69632	1874	4667000
69633	1698	16377088550035
69634	1698	16377100550035
69635	1513	30241613000000
69636	1513	30241837000000
69637	1633	11556605985638
69638	1633	11556617985638
69640	1397	1342310365000
69641	1678	18720659735000
69642	2133	98196396000
69643	1874	4669000
69644	2134	98209636000
69645	1874	4672000
69663	414	66000011000000
69664	2156	718900000000
69665	1397	1342280362000
69666	1678	18720659738000
69667	2133	98194392000
69668	2134	98206627000
69669	1874	4686000
69670	1693	11660582406843
69692	1690	114483694000000
69700	1397	1342240358000
69701	1678	18720659742000
69702	2133	98191386000
69703	1874	4702000
69704	2134	98202615000
69705	2132	148773774000
69706	1874	4706000
69707	1695	12572262000000
69708	1695	12572275000000
69711	1397	1342230357000
69712	1678	18720659743000
69713	2134	98201612000
69714	1874	4709000
69715	2133	98190384000
69716	1874	4711000
69731	1573	8619003000000
69732	1573	8619014000000
69741	1637	197285429819988
69771	1749	5165259000000
69797	1397	1342130347000
69798	1678	18720659753000
69799	2134	98191582000
69800	1395	58049904512007706
69801	1395	58049904523007706
69816	1397	1342100344000
69817	1678	18720659756000
69818	2134	98189576000
69819	2132	148769770000
69820	1874	4769000
69821	2134	98188573000
69822	1874	4772000
69823	1643	2408423114700
69824	1643	2408436114700
69839	1439	12532471998477
69851	1394	185763070000000
69855	1397	1342060340000
69856	1678	18720659760000
69857	2134	98184561000
69858	1874	4791000
69859	1680	12249584500035
69886	1397	1342020336000
69887	1678	18720659764000
69888	2134	98180549000
69889	2133	98174352000
69890	1613	16488003600000
69891	1397	1342010335000
69892	1678	18720659765000
69893	2133	98173350000
69894	1874	4814000
69895	2134	98179546000
69896	1596	15840565000000
69897	1596	15840577000000
69921	1699	7269827750126
69922	1699	7269839750126
69926	606	74638007812962
69927	1874	4707000
69928	1874	4714000
69929	1874	4731000
69930	1874	4734000
69931	1874	4737000
69932	1874	4764000
69933	1874	4767000
69934	1874	4776000
69935	1874	4797000
69936	1874	4809000
69937	1874	4811000
69938	1874	4813000
69939	1874	4819000
69940	1874	4827000
69941	606	75358007812962
69942	606	75358131812962
70088	1397	1341840318000
70089	1678	18720659782000
70090	2132	148761762000
70091	1874	4900000
70092	2134	98163498000
70093	1874	4903000
70094	2133	98156316000
70095	1874	4905000
70096	1395	58052064570007706
70097	1395	58052064583007706
70118	1397	1341800314000
70119	1678	18720659786000
70120	2134	98158483000
70121	1874	4927000
69260	641	77139971000000
69261	641	77139996000000
69283	576	80196072938283
69284	1397	1342630397000
69285	1678	18720659703000
69286	2132	148785786000
69287	1394	178563006000000
69289	1397	1342620396000
69290	1678	18720659704000
69291	2133	98227458000
69292	1874	4505000
69293	2134	98240729000
69294	1684	16560494880623
69295	1684	16560506880623
69305	1394	180003007000000
69306	1394	180003020000000
69318	1746	7714383000000
69337	1571	20160462001024
69362	2087	3599107000000
69374	1394	181443020000000
69375	1394	181443042000000
69389	1397	1342510385000
69390	1678	18720659715000
69391	2133	98217438000
69392	1874	4561000
69393	2134	98229696000
69394	1874	4564000
69395	369	81221410000000
69396	369	81221422000000
69449	1394	182883042000000
69450	1394	182883045000000
69451	1397	1342500384000
69452	1678	18720659716000
69453	2133	98215434000
69454	2134	98227690000
69468	1602	13680501000000
69515	1508	14436292500009
69516	1508	14436317500009
69517	1678	18000647719000
69518	1678	18000647720000
69519	1678	18000647721000
69520	1678	18000647722000
69521	1874	4131000
69522	1874	4141000
69523	1874	4144000
69524	1874	4148000
69525	1874	4153000
69526	1874	4159000
69527	1508	15158164500009
69528	1508	15878164500009
69603	1395	58048464511007706
69606	1420	13148008075300
69607	1727	1434961990000
69608	707	40300
69609	1514	9000450000000
69610	1678	18000647723000
69611	1678	18000647724000
69612	1678	18000647725000
69613	1678	18000647726000
69614	1678	18000647727000
69615	1678	18000647728000
69616	1678	18000647729000
69617	1678	18000647730000
69618	1678	18000647731000
69619	1678	18000647732000
69620	1678	18000647733000
69621	1874	4091000
69622	1874	4093000
69623	1874	4096000
69624	1874	4099000
69625	1727	13868008075300
69626	1447	13868313077300
69627	1727	13834565936000
69691	1394	185763221000000
69693	1397	1342250359000
69694	1678	18720659741000
69695	2133	98192388000
69696	1874	4697000
69697	2134	98203618000
69698	1670	17281101000000
69699	1670	17281113000000
69719	1397	1342220356000
69720	1678	18720659744000
69721	2133	98189382000
69722	2134	98200609000
69723	1874	4716000
69724	1680	12249585500035
69725	1397	1342210355000
69726	1678	18720659745000
69727	2134	98199606000
69728	1874	4719000
69729	1691	14363186100019
69730	1691	14363197100019
69778	1611	26630979000000
69779	1611	26630990000000
69803	1397	1342120346000
69804	1678	18720659754000
69805	2134	98190579000
69806	1874	4761000
69807	2133	98182368000
69808	1394	185763069000000
69810	1397	1342110345000
69811	1678	18720659755000
69812	2133	98181366000
69813	1587	20160611000000
69814	1587	20160622000000
69830	1708	9395779000021
69833	1397	1342080342000
69834	1678	18720659758000
69835	2133	98179362000
69836	1874	4779000
69837	2134	98186567000
69838	1874	4782000
69843	1397	1342070341000
69844	1678	18720659759000
69845	2133	98178360000
69846	1874	4784000
69847	2134	98185564000
69848	1874	4787000
69849	2132	148768769000
69850	1668	17246755000000
69852	1706	10292610600135
69853	1706	11012610600135
69854	1706	11013040600135
69871	1695	12572274000000
69872	1397	1342040338000
69873	1678	18720659762000
69874	1397	1342030337000
69875	1678	18720659763000
69876	2134	98182555000
69877	1874	4799000
69878	2133	98176356000
69879	1874	4801000
69880	2132	148767768000
69881	1874	4802000
69882	2134	98181552000
69883	2133	98175354000
69884	1670	18001113000000
69885	1670	18001138000000
69898	1397	1342000334000
69899	1678	18720659766000
69900	2134	98178543000
69901	2132	148766767000
69902	1874	4821000
69903	2133	98172348000
69904	1685	113042297571430
69919	1395	58050624523007706
69920	1395	58050624535007706
69962	1762	16161965994000
69963	1762	16161977994000
69964	1397	1341940328000
69965	1678	18720659772000
69966	2132	148764765000
69967	2133	98166336000
69968	1874	4852000
69969	2134	98172525000
69970	1874	4855000
69971	1394	187203069000000
69972	1394	187203082000000
70051	1471	16459698900000
70052	1471	16459747900000
70068	1698	16377101550035
70069	1397	1341870321000
70070	1678	18720659779000
70071	1397	1341860320000
70072	1678	18720659780000
70073	1397	1341850319000
70074	1678	18720659781000
70075	2134	98165504000
70076	2133	98159322000
70077	1874	4891000
70078	2133	98158320000
70079	1874	4893000
70080	2132	148762763000
70081	1874	4894000
70082	2134	98164501000
70083	1874	4897000
70084	2133	98157318000
70085	1874	4899000
70086	1395	58051344534007706
70087	1395	58051344570007706
70135	1397	1341780312000
70136	1678	18720659788000
70137	2132	148759760000
70138	1874	4935000
69274	1395	58048464486007706
69275	1395	58048464509007706
69276	1397	1342640398000
69277	1678	18720659702000
69278	2134	98241732000
69279	1874	4500000
69280	2133	98228460000
69281	1874	4502000
69282	1690	113763530000000
69297	1397	1342610395000
69298	1678	18720659705000
69299	2133	98226456000
69300	1874	4510000
69301	2134	98239726000
69302	1769	1691900000
69303	1447	14554558943000
69304	1447	14554571943000
69307	1397	1342600394000
69308	1678	18720659706000
69309	1654	15407148999798
69310	1340	1700432510151650
69311	2133	98225454000
69312	1874	4515000
69313	2134	98238723000
69314	2132	148784785000
69315	1874	4519000
69316	1747	7216908000000
69317	1747	7216931000000
69336	1715	37440673000002
69361	1395	58048464523007706
69373	1684	16560516880623
69376	1397	1342530387000
69377	1678	18720659713000
69378	2134	98231702000
69379	1874	4553000
69380	2132	148782783000
69397	1564	10627773000000
69398	1654	14685103999798
69399	1678	18000647691000
69400	1678	18000647692000
69401	1678	18000647693000
69402	1678	18000647694000
69403	1678	18000647695000
69404	1678	18000647696000
69405	1678	18000647697000
69406	1678	18000647698000
69407	1678	18000647699000
69408	1678	18000647700000
69409	1678	18000647701000
69410	1678	18000647702000
69411	1678	18000647703000
69412	1678	18000647704000
69413	1678	18000647705000
69414	1678	18000647706000
69415	1678	18000647707000
69416	1678	18000647708000
69417	1678	18000647709000
69418	1678	18000647710000
69419	1678	18000647711000
69420	1678	18000647712000
69421	1678	18000647713000
69422	1678	18000647714000
69423	1874	3628000
69424	1874	3631000
69425	1874	3638000
69426	1874	3644000
69427	1874	3651000
69428	1874	3654000
69429	1874	3660000
69430	1874	3663000
69431	1874	3675000
69432	1874	3693000
69433	1874	3699000
69434	1874	3705000
69435	1874	3707000
69436	1874	3711000
69437	1564	11347773000000
69438	1564	11348552000000
69448	1395	58048464489007706
69463	1397	1342480382000
69464	1678	18720659718000
69465	2133	98213430000
69466	1874	4582000
69467	1509	13631880851155
69502	1397	1342450379000
69503	1678	18720659721000
69504	1397	1342440378000
69505	1678	18720659722000
69506	2134	98223678000
69507	1874	4596000
69508	2133	98210424000
69509	2133	98209422000
69510	2134	98222675000
69511	2132	148779780000
69512	1874	4604000
69513	651	66720000000000
69514	651	66720025000000
69554	1694	17292620127629
69561	1690	114483530000000
69562	1690	114483542000000
69589	1397	1342340368000
69590	1678	18720659732000
69591	1397	1342330367000
69592	1678	18720659733000
69593	2133	98199402000
69594	2132	148776777000
69595	1874	4654000
69596	2134	98212645000
69597	1874	4657000
69598	2134	98211642000
69599	2133	98198400000
69600	1874	4662000
69601	1694	18012620127629
69602	1694	18012645127629
69653	1440	13679240000000
69654	1440	13679252000000
69662	1555	9555269979096
69733	1397	1342200354000
69734	1678	18720659746000
69735	2133	98188380000
69736	1874	4721000
69737	2132	148772773000
69738	1874	4722000
69739	1599	12580191393047
69740	1599	12580203393047
69746	576	80195861938283
69769	1749	66000000070000
69770	248	5165258930000
69786	1397	1342140348000
69787	1678	18720659752000
69788	2132	148770771000
69789	1874	4747000
69790	2133	98183370000
69791	1874	4749000
69792	2134	98193588000
69793	1874	4752000
69794	2134	98192585000
69795	1395	58049184498007706
69796	1395	58049184512007706
69825	1397	1342090343000
69826	1678	18720659757000
69827	2134	98187570000
69828	2133	98180364000
69829	1874	4777000
69862	1601	9290230620000
69863	1601	9290241620000
69864	1397	1342050339000
69865	1678	18720659761000
69866	2133	98177358000
69867	2134	98183558000
69868	1874	4796000
69869	1991	14875856441475
69870	1991	14875868441475
69913	1397	1341980332000
69914	1678	18720659768000
69915	2134	98176537000
69916	1874	4831000
69917	2133	98170344000
69918	1874	4833000
69924	606	75357817812962
69925	606	75357829812962
69943	1397	1341970331000
69944	1678	18720659769000
69945	1397	1341960330000
69946	1678	18720659770000
69947	2133	98169342000
69948	2133	98168340000
69949	1874	4837000
69950	2132	148765766000
69951	2134	98175534000
69952	2134	98174531000
69953	1447	14554583943000
69954	1397	1341950329000
69955	1678	18720659771000
69956	2133	98167338000
69957	1874	4846000
69958	2134	98173528000
69959	1874	4849000
69960	1654	16125128999798
69961	1654	16125140999798
70028	1678	18720659773000
70029	1678	18720659774000
70030	1678	18720659775000
70031	1678	18720659776000
70032	2133	98165334000
69681	1173	611289469681700
69682	1643	1688423114700
69683	933	505577712770200
69684	2133	98193390000
69685	2132	148774775000
69686	1874	4689000
69687	2134	98205624000
69688	1874	4692000
69689	2134	98204621000
69690	1680	12249737500035
69709	1489	11423992000000
69710	1489	11424005000000
69717	1476	13680203000000
69718	1476	13680215000000
69742	1643	488991862100
69743	1643	59090054300
69744	576	80916072938283
69745	576	80916224938283
69747	1397	1342190353000
69748	1678	18720659747000
69749	1397	1342180352000
69750	1678	18720659748000
69751	1397	1342170351000
69752	1678	18720659749000
69753	2132	148771772000
69754	2133	98187378000
69755	2133	98186376000
69756	1874	4727000
69757	2133	98185374000
69758	1874	4729000
69759	2134	98198603000
69760	1874	4732000
69761	2134	98197600000
69762	2134	98196597000
69763	2134	98195594000
69764	1874	4741000
69765	248	66000001500000
69766	212	66000000210000
69767	2143	5165227590000
69768	1749	229700000
69772	1397	1342160350000
69773	1678	18720659750000
69774	2134	98194591000
69775	1874	4744000
69776	1402	53854581319298
69777	1402	53854592319298
69780	1397	1342150349000
69781	1678	18720659751000
69782	2133	98184372000
69783	1874	4746000
69784	1271	1345566377000000
69785	1271	1345566388000000
69802	1440	13679251000000
69809	1692	14899971719999
69815	171	77510435524688
69831	1611	27350990000000
69832	1611	27351002000000
69840	2106	2879046000000
69841	2106	2879058000000
69842	1706	11013394600135
69860	1506	12961232967172
69861	1506	12961243967172
69905	1397	1341990333000
69906	1678	18720659767000
69907	2133	98171346000
69908	1874	4825000
69909	2134	98177540000
69910	1874	4828000
69911	1610	11520339000000
69912	1610	11520351000000
69923	2087	3599082000000
69973	1692	15619971719999
69974	1678	18000647734000
69975	1678	18000647735000
69976	1678	18000647736000
69977	1678	18000647737000
69978	1678	18000647738000
69979	1678	18000647739000
69980	1678	18000647740000
69981	1678	18000647741000
69982	1678	18000647742000
69983	1678	18000647743000
69984	1678	18000647744000
69985	1678	18000647745000
69986	1678	18000647746000
69987	1678	18000647747000
69988	1678	18000647748000
69989	1678	18000647749000
69990	1471	15741493900000
69991	1678	18000647750000
69992	1678	18000647751000
69993	1678	18000647752000
69994	1678	18000647753000
69995	1678	18000647754000
69996	1678	18000647755000
69997	1678	18000647756000
69998	1678	18000647757000
69999	1678	18000647758000
70000	1678	18000647759000
70001	1678	18000647760000
70002	1678	18000647761000
70003	1678	18000647762000
70004	1678	18000647763000
70005	1678	18000647764000
70006	1678	18000647765000
70007	1678	18000647766000
70008	1678	18000647767000
70009	1678	18000647768000
70010	1678	18000647769000
70011	1678	18000647770000
70012	1678	18000647771000
70013	1678	18000647772000
70014	1397	1341930327000
70015	1678	18000647773000
70016	1397	1341920326000
70017	1678	18000647774000
70018	1397	1341910325000
70019	1678	18000647775000
70020	1397	1341900324000
70021	1678	18000647776000
70022	1643	1929028862100
70023	1643	1499127054300
70024	1643	1208735205300
70025	1643	968387114700
70026	1471	16461493900000
70027	1471	16461834900000
70053	1514	16459747890100
70054	1471	20500
70055	1397	1341890323000
70056	1678	18720659777000
70057	2133	98161326000
70058	1874	4878000
70059	1395	58050624534007706
70126	1705	11435523500145
70127	1705	11435535500145
70130	1397	1341790313000
70131	1678	18720659787000
70132	2133	98151306000
70133	2134	98157480000
70134	1694	18012632127629
70175	1419	24219479280064
70176	1419	24219491280064
70179	1397	1341750309000
70180	1678	18720659791000
70181	2134	98153468000
70182	1874	4953000
70183	2133	98147298000
70184	1656	15261533999990
70193	1685	114482346571430
70194	1685	114482359571430
70208	1874	4963000
70209	1874	4965000
70221	1397	1341700304000
70222	1678	18720659796000
70223	2133	98143290000
70224	1874	4977000
70225	2134	98148453000
70226	1874	4980000
70227	1768	15710810110000
70228	1768	15710822110000
70280	1756	6947824575609
70281	1756	6947836575609
70284	1397	1341620296000
70285	1678	18720659804000
70286	2133	98135274000
70287	1874	5019000
70288	2134	98140429000
70289	1874	5022000
70290	1749	5885258930000
70291	1749	5885270930000
70301	1394	188643095000000
70304	1633	11556618985638
70343	1690	115923707000000
70344	1690	115923719000000
70353	2133	98128260000
70354	1601	9290233620000
70372	1397	1341520286000
70373	1678	18720659814000
70374	2132	148751752000
70375	1874	5074000
70376	1451	11418968000000
70403	1397	1341480282000
70404	1678	18720659818000
70405	2133	98122248000
70406	1874	5094000
70033	1874	4857000
70034	2132	148763764000
70035	1874	4858000
70036	2133	98164332000
70037	1874	4860000
70038	2133	98163330000
70039	2133	98162328000
70040	1874	4864000
70041	2134	98171522000
70042	1874	4867000
70043	2134	98170519000
70044	1874	4870000
70045	2134	98169516000
70046	1874	4873000
70047	2134	98168513000
70048	1874	4876000
70049	1685	113762297571430
70050	1685	113762346571430
70060	1397	1341880322000
70061	1678	18720659778000
70062	2134	98167510000
70063	1874	4881000
70064	2133	98160324000
70065	2134	98166507000
70066	1444	14975201159999
70067	1444	14975214159999
70098	1397	1341830317000
70099	1678	18720659783000
70100	1397	1341820316000
70101	1678	18720659784000
70102	1397	1341810315000
70103	1678	18720659785000
70104	2133	98155314000
70105	2133	98154312000
70106	1874	4909000
70107	2134	98162495000
70108	1874	4912000
70109	2134	98161492000
70110	1874	4915000
70111	2132	148760761000
70112	2134	98160489000
70113	2133	98153310000
70114	1874	4921000
70115	2134	98159486000
70116	1874	4924000
70117	1696	13457390835100
70128	1690	115203694000000
70129	1690	115203706000000
70156	1397	1341770311000
70157	1678	18720659789000
70158	2133	98149302000
70159	1874	4942000
70160	2134	98155474000
70161	1874	4945000
70164	1397	1341760310000
70165	1678	18720659790000
70166	2133	98148300000
70167	1874	4947000
70168	2134	98154471000
70169	1874	4950000
70170	1711	15644723000000
70171	1711	15644735000000
70177	1692	16339971719999
70178	1692	16339983719999
70210	1992	11519285990000
70235	1691	14363198100019
70270	58	84666568999641
70292	1685	114482358571430
70305	1397	1341600294000
70306	1678	18720659806000
70307	1397	1341590293000
70308	1678	18720659807000
70309	1397	1341580292000
70310	1678	18720659808000
70311	1397	1341570291000
70312	1678	18720659809000
70313	2134	98138423000
70314	1874	5031000
70315	2134	98137420000
70316	1874	5034000
70317	2133	98133270000
70318	2134	98136417000
70319	2132	148753754000
70320	1874	5040000
70321	2133	98132268000
70322	2133	98131266000
70323	1874	5044000
70324	2134	98135414000
70325	1874	5047000
70326	1513	28800914000000
70329	1397	1341560290000
70330	1678	18720659810000
70331	1726	128965109000
70332	2157	200000000
70333	2133	98130264000
70334	1874	5049000
70335	2134	98134411000
70336	1874	5052000
70337	1610	12240351000000
70338	1610	12240373000000
70355	1397	1341540288000
70356	1678	18720659812000
70357	2134	98131402000
70358	2133	98127258000
70359	1874	5068000
70360	1679	13894862853000
70361	1679	13894874853000
70364	1397	1341530287000
70365	1678	18720659813000
70366	2134	98130399000
70367	1874	5071000
70368	2133	98126256000
70369	1874	5073000
70370	1637	197285441819988
70377	1397	1341510285000
70378	1678	18720659815000
70379	1397	1341500284000
70380	1678	18720659816000
70381	2133	98125254000
70382	1874	5076000
70383	2134	98129396000
70384	1874	5079000
70385	2134	98128393000
70386	1874	5082000
70387	2134	98127390000
70388	1874	5085000
70389	2133	98124252000
70390	1694	18732632127629
70391	1694	18732657127629
70413	1650	7954135000000
70414	1650	7954145000000
70422	1394	190083092000000
70423	1394	190083103000000
70424	1678	18000647777000
70425	1678	18000647778000
70426	1678	18000647779000
70427	1678	18000647780000
70428	1678	18000647781000
70429	1678	18000647782000
70430	1678	18000647783000
70431	1678	18000647784000
70432	1678	18000647785000
70433	1678	18000647786000
70434	1678	18000647787000
70435	1678	18000647788000
70436	1678	18000647789000
70437	1678	18000647790000
70438	1678	18000647791000
70439	1678	18000647792000
70440	1678	18000647793000
70441	1678	18000647794000
70442	1678	18000647795000
70443	1678	18000647796000
70444	1678	18000647797000
70445	1678	18000647798000
70446	1678	18000647799000
70447	1678	18000647800000
70448	1678	18000647801000
70449	1678	18000647802000
70450	1678	18000647803000
70451	1678	18000647804000
70452	1678	18000647805000
70453	1678	18000647806000
70454	1678	18000647807000
70455	1678	18000647808000
70456	1678	18000647809000
70457	1678	18000647810000
70458	1678	18000647811000
70459	1678	18000647812000
70460	1678	18000647813000
70461	1678	18000647814000
70462	1678	18000647815000
70463	1678	18000647816000
70464	1678	18000647817000
70465	1678	18000647818000
70466	1678	18000647819000
70467	1678	18000647820000
70468	1874	4208000
70469	1874	4213000
70470	1874	4216000
70471	1874	4219000
70472	1874	4226000
70473	1874	4232000
70474	1874	4237000
70475	1874	4239000
70122	2133	98152308000
70123	1874	4929000
70124	1549	19775882000000
70125	1549	19775894000000
70143	1874	4485000
70144	1874	4487000
70145	1874	4490000
70146	1874	4499000
70147	1874	4507000
70148	1874	4517000
70149	1874	4520000
70150	1874	4522000
70151	1874	4524000
70152	1874	4525000
70153	1874	4527000
70154	1717	11629280000023
70155	1717	12349280000023
70191	1395	58052784583007706
70192	1395	58052784596007706
70195	1397	1341730307000
70196	1678	18720659793000
70197	1397	1341720306000
70198	1678	18720659794000
70199	238	66000186000000
70200	2134	98151462000
70201	2134	98150459000
70202	2133	98145294000
70203	1874	4969000
70204	2133	98144292000
70205	1874	4971000
70206	1457	15744354040000
70207	1457	15744388040000
70211	1992	11519309990000
70229	1397	1341690303000
70230	1678	18720659797000
70231	2133	98142288000
70232	2134	98147450000
70233	1522	13294184000000
70234	1522	13294196000000
70256	1397	1341650299000
70257	1678	18720659801000
70258	1397	1341640298000
70259	1678	18720659802000
70260	2132	148755756000
70261	1874	5002000
70262	2134	98143438000
70263	1874	5005000
70264	2133	98138280000
70265	1874	5007000
70266	2133	98137278000
70267	2134	98142435000
70268	1686	13172058550062
70269	1686	13172083550062
70293	1397	1341610295000
70294	1678	18720659805000
70295	2133	98134272000
70296	2134	98139426000
70297	2132	148754755000
70298	1874	5028000
70299	1719	12980550000000
70300	1719	12980563000000
70303	1623	52562624899898
70362	641	77859996000000
70363	641	77860008000000
70393	1573	9339014000000
70394	1573	9339039000000
70395	1397	1341490283000
70396	1678	18720659817000
70397	2133	98123250000
70398	1874	5089000
70399	2134	98126387000
70400	1874	5092000
70401	1709	11520165999976
70402	1709	11520177999976
70415	1397	1341460280000
70416	1678	18720659820000
70417	2133	98121246000
70418	1874	5097000
70419	1711	15644734000000
70492	1397	1341450279000
70493	1678	18720659821000
70494	2132	148749750000
70495	1874	5098000
70496	2133	98120244000
70497	1874	5100000
70522	58	84666565999641
70539	1509	14351880851155
70540	1509	14351913851155
70574	526	68160222000000
70579	1474	12514422000023
70580	1474	12514455000023
70592	1397	1341300264000
70593	1678	18720659836000
70594	2133	98106216000
70599	1394	192963136000000
70600	1394	192963147000000
70605	1397	1341280262000
70606	1678	18720659838000
70607	2132	148744745000
70608	1874	5133000
70609	2133	98105214000
70610	1688	41831867708000
70616	1699	7269838750126
70630	1394	192963159000000
70631	1397	1341240258000
70632	1678	18720659842000
70633	2133	98101206000
70648	1397	1341210255000
70649	1678	18720659845000
70650	2133	98098200000
70651	1874	5151000
70652	1690	116643719000000
70653	1690	116643730000000
70680	1397	1341160250000
70681	1678	18720659850000
70682	2132	148740741000
70683	1874	5161000
70684	2133	98093190000
70685	1874	5163000
70710	1397	1341100244000
70711	1678	18720659856000
70712	1397	1341090243000
70713	1678	18720659857000
70714	2132	148738739000
70715	1874	5175000
70716	2133	98087178000
70717	2133	98086176000
70718	1874	5179000
70719	58	85386554999641
70720	58	85386577999641
70723	1397	1341080242000
70724	1678	18720659858000
70725	1726	126545109000
70726	2159	200000000
70727	2133	98085174000
70728	1874	5181000
70729	2134	98125384000
70730	1874	5184000
70731	632	69020874000000
70732	632	69020896000000
70739	1397	1341060240000
70740	1678	18720659860000
70741	1397	1341050239000
70742	1678	18720659861000
70743	2132	148737738000
70744	1874	5188000
70745	2134	98123378000
70746	1874	5191000
70747	2134	98122375000
70748	1874	5194000
70749	2133	98084172000
70750	1874	5196000
70751	2133	98083170000
70752	1610	12960398000000
70789	1637	198005466819988
70790	1623	52562636899898
70798	1489	12144005000000
70799	1489	12144017000000
70820	2133	98077158000
70821	1874	5226000
70822	2132	148735736000
70823	1874	5227000
70824	1593	15670026000000
70825	1593	15670028000000
70830	1649	20444271999992
70840	1397	1340980232000
70841	1678	18720659868000
70842	2134	98115354000
70843	1874	5233000
70844	1874	5235000
70845	1599	14020226393047
70846	1599	14020238393047
70849	1397	1340970231000
70850	1678	18720659869000
70851	2133	98075154000
70852	2134	98114351000
70853	1637	198725466819988
70854	1637	198725478819988
70876	1397	1340930227000
70877	1678	18720659873000
70878	2132	148733734000
70879	1874	5257000
70880	2134	98110339000
70881	1874	5260000
70882	1602	13680502000000
70139	2133	98150304000
70140	2134	98156477000
70141	1457	15024341040000
70142	1457	15024354040000
70162	1708	10115779000021
70163	1708	10115791000021
70172	1711	14925843000000
70173	1711	15645843000000
70174	1711	15646063000000
70185	1397	1341740308000
70186	1678	18720659792000
70187	2132	148758759000
70188	1874	4956000
70189	2133	98146296000
70190	2134	98152465000
70212	1397	1341710305000
70213	1678	18720659795000
70214	2132	148757758000
70215	1874	4966000
70216	1874	4972000
70217	2134	98149456000
70218	1874	4975000
70219	1692	17059983719999
70220	1692	17060017719999
70236	1397	1341680302000
70237	1678	18720659798000
70238	1397	1341670301000
70239	1678	18720659799000
70240	1397	1341660300000
70241	1678	18720659800000
70242	2134	98146447000
70243	2132	148756757000
70244	1874	4989000
70245	2133	98141286000
70246	2133	98140284000
70247	1874	4993000
70248	2133	98139282000
70249	1874	4995000
70250	2134	98145444000
70251	1874	4998000
70252	2134	98144441000
70253	1874	5001000
70254	1709	10800128999976
70255	1709	10800165999976
70271	1555	10275269979096
70272	1555	10275294979096
70273	1397	1341630297000
70274	1678	18720659803000
70275	2134	98141432000
70276	2133	98136276000
70277	1874	5017000
70278	1588	15334959000000
70279	1588	15334971000000
70282	1394	188643082000000
70283	1394	188643094000000
70302	1690	115203707000000
70327	1458	15933654908540
70328	1458	15933702908540
70339	1397	1341550289000
70340	1678	18720659811000
70341	2133	98129262000
70342	2134	98133408000
70345	2132	148752753000
70346	1874	5041000
70347	1874	5043000
70348	1874	5055000
70349	1874	5058000
70350	2134	98132405000
70351	1874	5061000
70352	1601	9290314620000
70371	1467	8606726100039
70392	1394	188643107000000
70501	1397	1341430277000
70502	1678	18720659823000
70503	1397	1341420276000
70504	1678	18720659824000
70505	2133	98118240000
70506	1874	5104000
70507	2133	98117238000
70508	1874	5106000
70509	2132	148748749000
70510	1874	5107000
70511	1560	15714334277001
70512	1560	15714357277001
70513	1397	1341410275000
70514	1678	18720659825000
70515	1397	1341400274000
70516	1678	18720659826000
70517	2133	98116236000
70518	1874	5109000
70519	2133	98115234000
70520	1688	41111833708000
70521	1688	41111855708000
70537	101	67440010000000
70538	101	67440043000000
70549	1397	1341360270000
70550	1678	18720659830000
70551	1695	13292275000000
70552	1695	13292285000000
70561	1397	1341340268000
70562	1678	18720659832000
70563	1397	1341330267000
70564	1678	18720659833000
70565	1397	1341320266000
70566	1678	18720659834000
70567	2133	98110224000
70568	2133	98109222000
70569	1874	5125000
70570	2133	98108220000
70571	1874	5127000
70572	1672	19442055000000
70573	1672	19442088000000
70577	1571	20880462001024
70578	1571	20880495001024
70581	1696	14177352835100
70582	1696	14177382835100
70598	1746	7714371000000
70628	1599	13300203393047
70629	1599	13300226393047
70641	1397	1341220256000
70642	1678	18720659844000
70643	2132	148742743000
70644	2133	98099202000
70645	1874	5149000
70646	42	89758399000000
70647	42	89758411000000
70654	1397	1341200254000
70655	1678	18720659846000
70656	1397	1341190253000
70657	1678	18720659847000
70658	2132	148741742000
70659	1874	5152000
70660	2133	98097198000
70661	1874	5154000
70662	2133	98096196000
70663	1547	12093413000000
70664	1547	12093436000000
70705	1397	1341110245000
70706	1678	18720659855000
70707	2133	98088180000
70708	1559	12922731000000
70709	1559	12922742000000
70761	1395	58052784606007706
70762	1395	58053504607007706
70771	1394	192963148000000
70787	1688	42551867708000
70788	1688	42551892708000
70797	1740	12761441000000
70856	1397	1340960230000
70857	1678	18720659870000
70858	2132	148734735000
70859	1874	5241000
70860	2133	98074152000
70861	2134	98113348000
70905	1608	15405630000000
70906	1608	15405643000000
70912	1611	27350992000000
70921	1397	1340870221000
70922	1678	18720659879000
70923	2134	98104321000
70924	1874	5289000
70925	2133	98066136000
70958	1397	1340840218000
70959	1678	18720659882000
70960	1397	1340830217000
70961	1678	18720659883000
70962	2132	148730731000
70963	2133	98063130000
70964	1874	5305000
70965	2133	98062128000
70966	1874	5307000
70967	2134	98101312000
70968	2134	98100309000
70969	1874	5313000
70970	1740	12761464000000
70981	1397	1340800214000
70982	1678	18720659886000
70983	2133	98059122000
70984	1874	5325000
70985	2134	98097300000
70986	2132	148729730000
70987	1687	12952750524804
70988	1687	12952763524804
70999	1397	1340790213000
71000	1678	18720659887000
70407	2132	148750751000
70408	1874	5095000
70409	1395	58052784595007706
70410	1397	1341470281000
70411	1678	18720659819000
70412	1394	188643092000000
70420	1395	58053504595007706
70421	1395	58053504606007706
70498	1397	1341440278000
70499	1678	18720659822000
70500	2133	98119242000
70541	1394	191523103000000
70542	1394	191523136000000
70553	1397	1341350269000
70554	1678	18720659831000
70555	2132	148746747000
70556	1874	5119000
70557	2133	98111226000
70558	1874	5121000
70583	1397	1341310265000
70584	1678	18720659835000
70585	2132	148745746000
70586	1874	5128000
70587	2133	98107218000
70588	1874	5130000
70589	1696	14177390835100
70590	1696	14177402835100
70595	1610	12960373000000
70596	1610	12960384000000
70601	1397	1341290263000
70602	1678	18720659837000
70603	1685	114482356571430
70611	1397	1341270261000
70612	1678	18720659839000
70613	2133	98104212000
70614	1874	5137000
70634	1746	8434371000000
70635	1746	8434382000000
70636	1397	1341230257000
70637	1678	18720659843000
70638	2133	98100204000
70639	1874	5146000
70640	58	84666554999641
70665	1397	1341180252000
70666	1678	18720659848000
70667	2133	98095194000
70668	1874	5158000
70669	1693	13100615406843
70670	1693	13100626406843
70673	1703	7920757000000
70686	1397	1341150249000
70687	1678	18720659851000
70688	1397	1341140248000
70689	1678	18720659852000
70690	2133	98092188000
70691	2133	98091186000
70692	1874	5167000
70693	1573	9339036000000
70733	1397	1341070241000
70734	1678	18720659859000
70735	2134	98124381000
70736	1874	5187000
70737	1685	114482357571430
70763	1397	1341030237000
70764	1678	18720659863000
70765	2134	98120369000
70766	1874	5206000
70767	2133	98081166000
70768	1874	5208000
70769	1637	198005441819988
70770	1637	198005453819988
70826	1649	20444272999992
70831	1397	1340990233000
70832	1678	18720659867000
70833	2134	98116357000
70834	1874	5230000
70835	2133	98076156000
70836	1874	5232000
70837	1756	7667835575609
70838	1756	7667848575609
70847	1394	194403148000000
70848	1394	194403160000000
70855	1395	58054224619007706
70862	1397	1340950229000
70863	1678	18720659871000
70864	2134	98112345000
70865	2133	98073150000
70866	1874	5251000
70867	1716	17326890000000
70868	1716	17326902000000
70883	1397	1340920226000
70884	1678	18720659874000
70885	1397	1340910225000
70886	1678	18720659875000
70887	2134	98109336000
70888	1874	5263000
70889	2134	98108333000
70890	1874	5266000
70891	2133	98071146000
70892	1874	5268000
70893	2133	98070144000
70894	1672	19442079000000
70913	1397	1340880222000
70914	1678	18720659878000
70915	2134	98105324000
70916	1874	5284000
70917	2133	98067138000
70918	1874	5286000
70919	1394	195843160000000
70920	1394	195843172000000
70926	1980	15839862000000
70927	1874	4951000
70928	1874	4954000
70929	1874	4957000
70930	1874	4959000
70931	1874	4981000
70932	1874	4983000
70933	1874	4987000
70934	1980	16559862000000
70935	1980	16560364000000
70946	2134	98103318000
70947	1874	5296000
70948	1696	14897425835100
70993	58	86106577999641
70994	2132	148728729000
70995	1874	5330000
70996	1440	13679239999999
70997	2052	13679240999995
70998	1440	200000017
71022	329	67444660000000
71055	1546	11520846000000
71056	1397	1340710205000
71057	1678	18720659895000
71058	2134	98088273000
71059	1874	5372000
71060	2133	98051106000
71061	1874	5374000
71062	1668	17966755000000
71063	1668	17966768000000
71072	1397	1340690203000
71073	1678	18720659897000
71074	1397	1340680202000
71075	1678	18720659898000
71076	1726	124125109000
71077	2111	2200000000
71078	2133	98049102000
71079	2134	98086267000
71080	1874	5384000
71081	2134	98085264000
71082	2133	98048100000
71083	1874	5389000
71084	2132	148726727000
71085	1874	5390000
71086	1395	58054944619007706
71087	1395	58054944654007706
71130	1397	1340610195000
71131	1678	18720659905000
71132	1397	1340600194000
71133	1678	18720659906000
71134	2134	98078243000
71135	2133	98041086000
71136	2133	98040084000
71137	1874	5429000
71138	2134	98077240000
71139	1874	5432000
71140	1489	12864017000000
71141	1489	12864041000000
71186	1397	1340570191000
71187	1678	18720659909000
71188	2134	98074231000
71189	1874	5444000
71190	2133	98038080000
71205	1397	1340540188000
71206	1678	18720659912000
71207	2133	98035074000
71208	1874	5453000
71209	1708	10835791000021
71210	1708	10835802000021
71241	1695	14012285000000
71242	1695	14012316000000
71267	1714	13126431103056
71289	1637	201605514819988
71290	1637	201605525819988
71300	1397	1340430177000
71301	1678	18720659923000
70476	1874	4243000
70477	1874	4245000
70478	1874	4251000
70479	1874	4257000
70480	1711	15646724000000
70481	1874	4263000
70482	1874	4269000
70483	1874	4275000
70484	1874	4281000
70485	1874	4285000
70486	1874	4287000
70487	1874	4288000
70488	1874	4290000
70489	1874	4293000
70490	1711	16366724000000
70491	1711	16366746000000
70523	1397	1341390273000
70524	1678	18720659827000
70525	1397	1341380272000
70526	1678	18720659828000
70527	1726	127755109000
70528	2158	200000000
70529	2133	98114232000
70530	1874	5113000
70531	2133	98113230000
70532	1874	5115000
70533	2132	148747748000
70534	1874	5116000
70535	1688	41831855708000
70536	1688	41831888708000
70543	1397	1341370271000
70544	1678	18720659829000
70545	2133	98112228000
70546	1874	5118000
70547	1756	6227835575609
70548	1756	6947835575609
70559	1692	17780017719999
70560	1692	17780029719999
70575	1693	12380582406843
70576	1693	12380615406843
70591	1587	20160623000000
70597	1747	7216919000000
70604	1681	12023228759830
70615	2087	3599081000000
70617	1397	1341260260000
70618	1678	18720659840000
70619	1397	1341250259000
70620	1678	18720659841000
70621	2132	148743744000
70622	2133	98103210000
70623	1874	5140000
70624	2133	98102208000
70625	1874	5142000
70626	1588	16054971000000
70627	1588	16054994000000
70671	1702	7920296000000
70672	1702	7920307000000
70674	1397	1341170251000
70675	1678	18720659849000
70676	2133	98094192000
70677	1874	5160000
70678	1692	18500029719999
70679	1692	18500040719999
70694	1702	7920318000000
70695	1397	1341130247000
70696	1678	18720659853000
70697	1397	1341120246000
70698	1678	18720659854000
70699	2133	98090184000
70700	1874	5169000
70701	2133	98089182000
70702	2132	148739740000
70703	1874	5172000
70704	1587	20160634000000
70721	1692	19220040719999
70722	1692	19220063719999
70738	1692	19220051719999
70753	1397	1341040238000
70754	1678	18720659862000
70755	2134	98121372000
70756	1458	15933713908540
70757	2133	98082168000
70758	1874	5203000
70759	1458	16653713908540
70760	1458	16653714908540
70772	1397	1341020236000
70773	1678	18720659864000
70774	1397	1341010235000
70775	1678	18720659865000
70776	2134	98119366000
70777	1874	5211000
70778	2134	98118363000
70779	1874	5214000
70780	2132	148736737000
70781	1874	5215000
70782	2133	98080164000
70783	1874	5217000
70784	2133	98079162000
70785	1402	54574592319298
70786	1402	54574617319298
70791	1397	1341000234000
70792	1678	18720659866000
70793	2133	98078160000
70794	1874	5221000
70795	2134	98117360000
70796	1874	5224000
70800	1489	11424235000000
70801	1874	5110000
70802	1874	5112000
70803	1874	5155000
70804	1874	5157000
70805	1874	5164000
70806	1874	5166000
70807	1874	5170000
70808	1874	5173000
70809	1874	5176000
70810	1874	5178000
70811	1874	5182000
70812	1874	5190000
70813	1874	5200000
70814	1874	5202000
70815	1874	5212000
70816	1874	5218000
70817	1874	5220000
70818	1489	12144235000000
70819	1489	12144528000000
70827	1874	5223000
70828	1395	58054224607007706
70829	1395	58054224621007706
70839	1633	11556616985638
70869	1397	1340940228000
70870	1678	18720659872000
70871	2134	98111342000
70872	1874	5254000
70873	2133	98072148000
70874	1874	5256000
70875	1692	19220052719999
70895	2039	15841432000000
70896	2039	15841456000000
70897	1397	1340900224000
70898	1678	18720659876000
70899	2134	98107330000
70900	2133	98069142000
70901	1874	5275000
70902	2132	148732733000
70903	1637	199445478819988
70904	1637	199445491819988
70907	1397	1340890223000
70908	1678	18720659877000
70909	2134	98106327000
70910	2133	98068140000
70911	1874	5281000
70936	1726	125335109000
70937	2160	200000000
70938	1696	14897382835100
70939	1696	14897402835100
70949	42	90478411000000
70950	42	90478434000000
70951	1397	1340850219000
70952	1678	18720659881000
70953	2133	98064132000
70954	1874	5299000
70955	2134	98102315000
70956	1874	5302000
70957	2039	15841444000000
70976	1397	1340810215000
70977	1678	18720659885000
70978	2134	98098303000
70979	2133	98060124000
70980	1719	12980562000000
70990	1508	16598164500009
70991	1508	200010000
70992	2095	16598504490009
71035	1397	1340730207000
71036	1678	18720659893000
71037	2133	98052108000
71038	1874	5362000
71039	2134	98090279000
71040	1874	5365000
71041	2132	148727728000
71042	1874	5366000
71043	1688	43271879708000
71044	1688	43271892708000
71064	1634	17471845641004
71065	1634	17471858641004
70940	1397	1340860220000
70941	1678	18720659880000
70942	2133	98065134000
70943	1874	5293000
70944	2132	148731732000
70945	1696	14897424835100
70971	1397	1340820216000
70972	1678	18720659884000
70973	2133	98061126000
70974	2134	98099306000
70975	1688	42551879708000
70989	1508	14436305500009
71029	1397	1340740208000
71030	1678	18720659892000
71031	2133	98053110000
71032	2134	98091282000
71033	1874	5360000
71034	1444	14975213159999
71047	1601	10010233620000
71048	1601	10010245620000
71053	1444	15695213159999
71054	1444	15695224159999
71066	1397	1340700204000
71067	1678	18720659896000
71068	2133	98050104000
71069	2134	98087270000
71070	1637	200165491819988
71071	1637	200165503819988
71115	1536	15120751999959
71116	1536	15120773999959
71123	1397	1340620196000
71124	1678	18720659904000
71125	2134	98079246000
71126	1874	5420000
71127	2133	98042088000
71128	1395	58055664654007706
71129	1395	58055664666007706
71193	1397	1340560190000
71194	1678	18720659910000
71195	2132	148722723000
71196	1874	5447000
71197	2133	98037078000
71198	1874	5449000
71199	641	78580008000000
71200	641	78580020000000
71201	1397	1340550189000
71202	1678	18720659911000
71203	2133	98036076000
71204	1715	37440649000002
71223	1657	12241376000000
71224	1657	12241399000000
71249	1695	14012307000000
71255	1690	117363730000000
71256	1690	117363742000000
71262	1397	1340470181000
71263	1678	18720659919000
71264	2133	98028060000
71265	369	81941422000000
71266	369	81941433000000
71276	1633	12276616985638
71277	1633	12276619985638
71284	1397	1340440178000
71285	1678	18720659922000
71286	2133	98025054000
71287	1610	13680398000000
71288	1610	13680409000000
71311	1740	13481464000000
71312	1740	13481475000000
71317	1397	1340400174000
71318	1678	18720659926000
71319	2133	98021046000
71320	1874	5485000
71321	2132	148717718000
71322	1394	201603207000000
71323	1394	201603219000000
71336	1397	1340370171000
71337	1678	18720659929000
71338	2133	98018040000
71339	1874	5492000
71340	2132	148716717000
71341	1489	13584053000000
71349	1397	1340360170000
71350	1678	18720659930000
71351	1394	203043219000000
71352	1394	203043229000000
71366	111	68880052000000
71369	1397	1340330167000
71370	1678	18720659933000
71371	1397	1340320166000
71372	1678	18720659934000
71373	2133	98015034000
71374	2133	98014032000
71375	1874	5502000
71376	1513	28800888000000
71383	1688	43271890708000
71390	1397	1340290163000
71391	1678	18720659937000
71392	2133	98012028000
71393	1715	38160649000002
71394	1715	38160660000002
71396	1726	122895109000
71397	2161	200000000
71398	1397	1340280162000
71399	1678	18720659938000
71400	2133	98011026000
71401	1689	12960288287625
71437	1397	1340210155000
71438	1678	18720659945000
71439	1397	1340200154000
71440	1678	18720659946000
71441	1726	121685109000
71442	2162	200000000
71443	2132	148712713000
71444	1874	5541000
71445	2133	98004012000
71446	2133	98003010000
71447	2134	98067210000
71448	2134	98066207000
71449	1874	5551000
71450	1394	205923229000000
71451	1394	205923264000000
71475	1397	1340160150000
71476	1678	18720659950000
71477	2134	98062195000
71478	2133	98000004000
71479	1874	5570000
71480	1690	118083742000000
71481	1690	118083754000000
71482	1397	1340150149000
71483	1678	18720659951000
71484	1397	1340140148000
71485	1678	18720659952000
71486	1474	12513412000023
71487	188	66001000000000
71488	2132	148710711000
71489	2134	98061192000
71490	1874	5574000
71491	2133	97999002000
71492	2133	97998000000
71493	2133	97996998000
71494	1874	5580000
71495	2134	98060189000
71496	1874	5583000
71497	2134	98059186000
71498	1874	5586000
71499	1564	11346435000000
71500	1564	11346472000000
71521	2106	2879170000000
71553	1397	1340060140000
71554	1678	18720659960000
71555	2133	97988982000
71556	2134	98051162000
71557	1874	5628000
71558	1395	58056384666007706
71559	1395	58056384678007706
71580	1419	26379540280064
71581	1419	26379577280064
71584	1397	1340020136000
71585	1678	18720659964000
71586	1397	1340010135000
71587	1678	18720659965000
71588	2132	148706707000
71589	1874	5645000
71590	2133	97984974000
71591	1874	5647000
71592	2134	98047150000
71593	2134	98046147000
71594	1874	5653000
71595	2133	97983972000
71596	1874	5655000
71597	1426	19725116000000
71622	1395	58057104678007706
71623	1395	58057104691007706
71668	1440	14399325000000
71676	1397	1339910125000
71677	1678	19440671975000
71678	2134	98035114000
71679	1874	5709000
71680	2133	97973952000
71681	1874	5711000
71682	1394	207363276000000
71701	1685	115202370571430
71724	1657	12961399000000
71725	1657	12961411000000
71741	1397	1339830117000
71001	1397	1340780212000
71002	1678	18720659888000
71003	1397	1340770211000
71004	1678	18720659889000
71005	1397	1340760210000
71006	1678	18720659890000
71007	2133	98058120000
71008	2133	98057118000
71009	2133	98056116000
71010	1874	5336000
71011	2133	98055114000
71012	1874	5338000
71013	2134	98096297000
71014	1874	5341000
71015	2134	98095294000
71016	1874	5344000
71017	2134	98094291000
71018	1874	5347000
71019	2134	98093288000
71020	1874	5350000
71021	1440	13679289000000
71023	1397	1340750209000
71024	1678	18720659891000
71025	2134	98092285000
71026	1874	5353000
71027	2133	98054112000
71028	329	67444622000000
71045	149	82830238000341
71046	149	82830251000341
71049	1397	1340720206000
71050	1678	18720659894000
71051	2134	98089276000
71052	1546	11520847000000
71106	1598	1200008000000
71107	1958	3485987000000
71108	1397	1340640198000
71109	1678	18720659902000
71110	2133	98044092000
71111	1874	5408000
71112	2134	98081252000
71113	1564	10626413000000
71114	1564	10626435000000
71117	1397	1340630197000
71118	1678	18720659903000
71119	2133	98043090000
71120	1874	5413000
71121	2132	148724725000
71122	2134	98080249000
71142	1489	12144918000000
71143	1874	5229000
71144	1874	5236000
71145	1874	5238000
71146	1874	5242000
71147	1874	5245000
71148	1874	5247000
71149	1874	5253000
71150	1874	5259000
71151	1874	5265000
71152	1874	5269000
71153	1874	5271000
71154	1874	5277000
71155	1874	5283000
71156	1874	5287000
71157	1874	5295000
71158	1874	5301000
71159	1874	5324000
71160	1874	5327000
71161	1874	5333000
71162	1874	5342000
71163	1874	5348000
71164	1874	5354000
71165	1874	5356000
71166	1874	5378000
71167	1874	5396000
71168	1874	5402000
71169	1489	12864918000000
71170	1489	12865040000000
71178	1397	1340580192000
71179	1678	18720659908000
71180	2133	98039082000
71181	1874	5438000
71182	2134	98075234000
71183	1874	5441000
71184	1394	198723184000000
71185	1394	198723196000000
71221	1489	13584041000000
71222	1489	13584064000000
71236	1397	1340510185000
71237	1678	18720659915000
71238	2133	98032068000
71239	2097	28800876999999
71240	1513	200000023
71257	1397	1340480182000
71258	1678	18720659918000
71259	2133	98029062000
71260	1874	5467000
71261	1637	200885514819988
71291	1762	16881977994000
71292	1762	16881988994000
71313	1397	1340410175000
71314	1678	18720659925000
71315	2133	98022048000
71316	1476	13680214000000
71328	1670	18721138000000
71329	1670	18721149000000
71335	1687	12952761524804
71411	1397	1340260160000
71412	1678	18720659940000
71413	1397	1340250159000
71414	1678	18720659941000
71415	1397	1340240158000
71416	1678	18720659942000
71417	2133	98009022000
71418	2133	98008020000
71419	2134	98072225000
71420	2133	98007018000
71421	2134	98071222000
71422	2134	98070219000
71423	1608	15405666000000
71430	1458	16653702908540
71470	2148	1439035000000
71504	1455	7954061000000
71505	1474	11793412000023
71506	1448	7956761000001
71507	1448	7956833000001
71520	1448	7956885000001
71549	1397	1340070141000
71550	1678	18720659959000
71551	2133	97989984000
71552	2134	98052165000
71568	1397	1340030137000
71569	1678	18720659963000
71570	2134	98050159000
71571	1874	5631000
71572	2132	148707708000
71573	2134	98049156000
71574	1874	5635000
71575	2134	98048153000
71576	2133	97987980000
71577	2133	97986978000
71578	2133	97985976000
71579	1596	15840602000000
71620	1708	11555802000021
71621	1708	11555815000021
71646	1698	16377103550035
71648	1397	1339950129000
71649	1678	19440671971000
71650	1397	1339940128000
71651	1678	19440671972000
71652	1397	1339930127000
71653	1678	19440671973000
71654	2134	98039126000
71655	1874	5688000
71656	2134	98038123000
71657	2134	98037120000
71658	2133	97977960000
71659	2133	97976958000
71660	2133	97975956000
71661	1440	14399289000000
71662	1440	66000004000000
71663	212	14399289049920
71664	2052	1434962980000
71665	1420	200000092
71666	1489	200170000
71667	2095	13584063000000
71669	1397	1339920126000
71670	1678	19440671974000
71671	2133	97974954000
71672	2132	148703704000
71673	1874	5703000
71674	2134	98036117000
71675	1402	54574605319298
71689	1448	8676833000001
71690	1448	8676834000001
71700	1874	5717000
71719	1397	1339850119000
71720	1678	19440671981000
71721	2134	98029096000
71722	2133	97968942000
71723	1637	201605526819988
71736	1749	3445220000000
71737	526	68880222000000
71738	526	68880305000000
71739	1474	13233412000023
71740	1474	13233424000023
71088	1397	1340670201000
71089	1678	18720659899000
71090	1397	1340660200000
71091	1678	18720659900000
71092	1397	1340650199000
71093	1678	18720659901000
71094	497	66000011000000
71095	2133	98047098000
71096	1874	5392000
71097	2132	148725726000
71098	2133	98046096000
71099	1874	5395000
71100	2133	98045094000
71101	2134	98084261000
71102	2134	98083258000
71103	2134	98082255000
71104	1727	13147114000000
71105	1727	13147152000000
71171	1397	1340590193000
71172	1678	18720659907000
71173	2134	98076237000
71174	1874	5435000
71175	2132	148723724000
71176	1394	197283172000000
71177	1394	197283184000000
71191	1637	200885503819988
71192	1637	200885515819988
71211	1397	1340530187000
71212	1678	18720659913000
71213	1397	1340520186000
71214	1678	18720659914000
71215	2133	98034072000
71216	1874	5455000
71217	2133	98033070000
71218	2132	148721722000
71219	1874	5458000
71220	1596	15840588000000
71225	1874	5407000
71226	1874	5410000
71227	1874	5415000
71228	1874	5418000
71229	1874	5421000
71230	1874	5424000
71231	1874	5426000
71232	1874	5437000
71233	1874	5452000
71234	1489	13585040000000
71235	1489	13585142000000
71243	1397	1340500184000
71244	1678	18720659916000
71245	2133	98031066000
71246	1874	5462000
71247	1719	13700562000000
71248	1719	13700584000000
71250	1397	1340490183000
71251	1678	18720659917000
71252	2132	148720721000
71253	2133	98030064000
71254	1874	5465000
71268	1397	1340460180000
71269	1678	18720659920000
71270	2133	98027058000
71271	2132	148719720000
71272	1874	5472000
71273	1749	4885269930000
71274	1950	11169851000000
71275	1419	24219492280064
71278	1397	1340450179000
71279	1678	18720659921000
71280	2133	98026056000
71281	1874	5474000
71282	1394	200163196000000
71283	1394	200163207000000
71293	1874	5383000
71294	1874	5401000
71295	1874	5450000
71296	1874	5456000
71297	1874	5464000
71298	1874	5470000
71299	1610	13680761000000
71307	1397	1340420176000
71308	1678	18720659924000
71309	2133	98023050000
71310	1679	13894873853000
71360	1397	1340340168000
71361	1678	18720659932000
71362	2132	148715716000
71363	2133	98016036000
71364	1709	12240177999976
71365	1709	12240189999976
71378	1397	1340310165000
71379	1678	18720659935000
71380	2133	98013030000
71381	1716	18046902000000
71382	1716	18046913000000
71384	1397	1340300164000
71385	1678	18720659936000
71386	2132	148714715000
71387	1874	5505000
71388	1419	24939492280064
71389	1419	24939503280064
71424	1397	1340230157000
71425	1678	18720659943000
71426	2133	98006016000
71427	2134	98069216000
71428	1602	14400502000000
71429	1602	14400514000000
71431	1397	1340220156000
71432	1678	18720659944000
71433	2134	98068213000
71434	1874	5538000
71435	2133	98005014000
71436	1687	12952762524804
71452	1397	1340190153000
71453	1678	18720659947000
71454	1397	1340180152000
71455	1678	18720659948000
71456	2134	98065204000
71457	1874	5554000
71458	2134	98064201000
71459	1874	5557000
71460	2133	98002008000
71461	1749	5605269930000
71462	1749	5605292930000
71471	1471	15740708900000
71472	1874	5134000
71473	1471	16460708900000
71474	1471	16460903900000
71501	1688	43271916708000
71508	188	66000900000000
71509	1397	1340130147000
71510	1678	18720659953000
71511	1397	1340120146000
71512	1678	18720659954000
71513	2133	97995996000
71514	2134	98058183000
71515	2134	98057180000
71516	2133	97994994000
71517	1593	15670150000000
71522	1397	1340110145000
71523	1678	18720659955000
71524	2134	98056177000
71525	2133	97993992000
71526	2132	148709710000
71527	1874	5602000
71528	1686	13892083550062
71529	1686	13892096550062
71530	1397	1340100144000
71531	1678	18720659956000
71532	1397	1340090143000
71533	1678	18720659957000
71534	1397	1340080142000
71535	1678	18720659958000
71536	2134	98055174000
71537	1874	5605000
71538	2134	98054171000
71539	1874	5608000
71540	2134	98053168000
71541	1874	5611000
71542	2132	148708709000
71543	2133	97992990000
71544	2133	97991988000
71545	2133	97990986000
71546	1874	5618000
71547	1419	25659503280064
71548	1419	25659540280064
71560	1397	1340050139000
71561	1678	18720659961000
71562	1397	1340040138000
71563	1678	18720659962000
71564	1874	5368000
71565	1874	5431000
71566	1571	21600462001024
71567	1571	21601326001024
71598	1397	1340000134000
71599	1678	18720659966000
71600	2133	97982970000
71601	1874	5657000
71602	2134	98045144000
71605	1397	1339990133000
71606	1678	19440671967000
71607	2134	98044141000
71608	1874	5663000
71609	2133	97981968000
71610	1874	5665000
71302	2133	98024052000
71303	2132	148718719000
71304	1874	5479000
71305	1673	22646512000000
71306	1673	22646524000000
71324	1397	1340390173000
71325	1678	18720659927000
71326	2133	98020044000
71327	1522	13294195000000
71330	1397	1340380172000
71331	1678	18720659928000
71332	2133	98019042000
71333	1874	5490000
71334	1700	13985981276737
71342	1489	13585212000000
71343	1874	5475000
71344	1874	5477000
71345	1874	5487000
71346	1874	5489000
71347	1489	14305212000000
71348	1489	14305312000000
71353	1726	124105109000
71354	693	66000010000000
71355	1397	1340350169000
71356	1678	18720659931000
71357	2133	98017038000
71358	1874	5495000
71359	1850	11438919000000
71367	1394	204483229000000
71368	1394	204483241000000
71377	1633	12276638985638
71395	1611	27351001000000
71402	1397	1340270161000
71403	1678	18720659939000
71404	2132	148713714000
71405	2133	98010024000
71406	1874	5512000
71407	2134	98073228000
71408	1874	5515000
71409	1740	14201475000000
71410	1740	14201488000000
71463	1397	1340170151000
71464	1678	18720659949000
71465	2134	98063198000
71466	2133	98001006000
71467	1874	5564000
71468	2132	148711712000
71469	1471	16459711900000
71502	1394	207363264000000
71503	1394	207363301000000
71518	1711	16364734000000
71519	1711	16364858000000
71582	1426	19725091000000
71583	1426	19725183000000
71603	1678	19440659966000
71604	1678	19440671966000
71611	1397	1339980132000
71612	1678	19440671968000
71613	2134	98043138000
71614	2132	148705706000
71615	1874	5669000
71616	2133	97980966000
71617	1874	5671000
71618	1656	15981533999990
71619	1656	15981546999990
71625	1397	1339970131000
71626	1678	19440671969000
71627	2133	97979964000
71628	1874	5673000
71629	2134	98042135000
71630	1685	115202357571430
71631	1685	115202369571430
71644	1649	21164272999992
71645	1649	21164287999992
71683	1397	1339900124000
71684	1678	19440671976000
71685	2134	98034111000
71686	2133	97972950000
71687	1759	13680773999999
71688	1759	13680785999999
71698	1688	43991916708000
71699	1688	43991929708000
71709	1397	1339870121000
71710	1678	19440671979000
71711	1397	1339860120000
71712	1678	19440671980000
71713	2133	97969944000
71714	2134	98031102000
71715	2134	98030099000
71716	2132	148701702000
71717	1686	14612096550062
71718	1686	14612120550062
71734	1546	12240846000000
71735	1546	12240858000000
71774	1680	12969585500035
71775	1397	1339790113000
71776	1678	19440671987000
71777	1397	1339780112000
71778	1678	19440671988000
71779	2132	148699700000
71780	2134	98023078000
71781	2133	97962930000
71782	2133	97961928000
71783	2134	98022075000
71784	1395	58057104703007706
71789	1397	1339770111000
71790	1678	19440671989000
71791	1397	1339760110000
71792	1678	19440671990000
71793	2133	97960926000
71794	2132	148698699000
71795	2134	98021072000
71796	2134	98020069000
71797	1509	14351904851155
71807	1448	7956773000001
71821	1397	1339720106000
71822	1678	19440671994000
71823	2133	97956918000
71824	2132	148697698000
71825	1874	5805000
71826	2134	98016057000
71827	1874	5808000
71828	1402	55294605319298
71829	1402	55294618319298
71844	1397	1339690103000
71845	1678	19440671997000
71846	1397	1339680102000
71847	1678	19440671998000
71848	1451	11418988000000
71849	2133	97953912000
71850	2133	97952910000
71851	2134	98013048000
71852	2132	148696697000
71853	2134	98012045000
71854	1451	12138988000000
71855	1451	12138993000000
71870	1397	1339650099000
71871	1678	19440672001000
71872	2134	98009036000
71873	2133	97949904000
71874	1634	17471857641004
71877	1397	1339640098000
71878	1678	19440672002000
71879	2134	98008033000
71905	2134	98004021000
71906	1874	5867000
71907	2133	97945896000
71908	633	81724108900000
71909	633	81724110900000
71946	1671	13728459530515
71947	1671	13728471530515
71960	1746	8434395000000
71961	1397	1339550089000
71962	1678	19440672011000
71963	2133	97939884000
71964	2134	97998003000
71965	1476	15120239000000
71966	1476	15120251000000
71968	1476	15120240000000
71978	1397	1339530087000
71979	1678	19440672013000
71980	1397	1339520086000
71981	1678	19440672014000
71982	2133	97937880000
71983	2134	97995997000
71984	2133	97936878000
71985	1874	5911000
71986	2134	97994994000
71987	1874	5914000
71988	632	69740896000000
71989	632	69740921000000
71991	1397	1339510085000
71992	1678	19440672015000
71993	2133	97935876000
71994	2134	97993991000
72007	2133	97932870000
72008	1710	16074634473290
72009	1710	16074635473290
72034	1693	14540637406843
72035	1693	14540649406843
72051	1394	211683333000000
72052	1394	213123333000000
72053	1394	213123334000000
72054	1395	58057104714007706
72055	1395	58057824714007706
71624	171	77510437524688
71632	1397	1339960130000
71633	1678	19440671970000
71634	2142	2850001000000
71635	2132	148704705000
71636	1874	5677000
71637	2133	97978962000
71638	1874	5679000
71639	2134	98041132000
71640	1874	5682000
71641	2134	98040129000
71642	1874	5685000
71643	1599	14020241393047
71647	1599	14020227393047
71691	1397	1339890123000
71692	1678	19440671977000
71693	2134	98033108000
71694	1874	5719000
71695	2132	148702703000
71696	2133	97971948000
71697	1448	7956774000001
71702	1397	1339880122000
71703	1678	19440671978000
71704	2134	98032105000
71705	2133	97970946000
71706	1874	5727000
71707	1394	208803276000000
71708	1394	208803288000000
71726	1506	12961244967172
71727	1397	1339840118000
71728	1678	19440671982000
71729	2134	98028093000
71730	1874	5744000
71731	2133	97967940000
71732	1622	19260403000005
71733	1622	19260415000005
71745	2133	97966938000
71746	1740	14921488000000
71747	1740	14921500000000
71748	1649	21164284999992
71758	1397	1339810115000
71759	1678	19440671985000
71760	2134	98025084000
71761	2133	97964934000
71762	1692	19940052719999
71763	1692	19940064719999
71772	1637	202325526819988
71773	1637	202325538819988
71799	1397	1339750109000
71800	1678	19440671991000
71801	2133	97959924000
71802	1874	5789000
71803	2134	98019066000
71804	1874	5792000
71805	2112	2879036000000
71806	2112	2879048000000
71858	1397	1339670101000
71859	1678	19440671999000
71860	1397	1339660100000
71861	1678	19440672000000
71862	2134	98011042000
71863	2134	98010039000
71864	2132	148695696000
71865	2133	97951908000
71866	1874	5838000
71867	2133	97950906000
71868	1509	15071904851155
71869	1509	15071929851155
71896	1547	12813436000000
71897	1547	12813461000000
71903	1402	56014618319298
71904	1402	56014630319298
71912	633	81005168900000
71913	1678	18720659967000
71914	1678	18720659968000
71915	1678	18720659969000
71916	1678	18720659970000
71917	1678	18720659971000
71918	1678	18720659972000
71919	1678	18720659973000
71920	1678	18720659974000
71921	1678	18720659975000
71922	1678	18720659976000
71923	1678	18720659977000
71924	1678	18720659978000
71925	1678	18720659979000
71926	1678	18720659980000
71927	1678	18720659981000
71928	1678	18720659982000
71929	1678	18720659983000
71930	633	81725168900000
71931	633	81725358900000
71942	1397	1339580092000
71943	1678	19440672008000
71944	2133	97942890000
71945	2134	98001012000
71958	1704	2946218000000
71959	1704	2946242000000
71976	1874	5901000
71977	1394	210243310000000
72028	1397	1339440078000
72029	1678	19440672022000
72030	2134	97987973000
72031	2133	97929864000
72032	1601	10730244620000
72033	1601	10730256620000
72078	1687	13672762524804
72079	1687	13672786524804
72118	1709	12240188999976
72138	1684	18000518880623
72139	1684	18000554880623
72173	1397	1339210055000
72174	1678	19440672045000
72175	1397	1339200054000
72176	1678	19440672046000
72177	2134	97964904000
72178	1874	6060000
72179	2133	97907820000
72180	2133	97906818000
72181	1874	6064000
72182	2134	97963901000
72183	1874	6067000
72184	632	70460921000000
72185	632	70460945000000
72191	1696	14897426835100
72192	1397	1339190053000
72193	1678	19440672047000
72194	2135	719027000000
72195	1505	0
72196	2133	97905816000
72197	2134	97962898000
72198	1549	20495882000000
72199	1549	20495904000000
72229	1690	118803766000000
72233	1397	1339130047000
72234	1678	19440672053000
72235	2134	97956880000
72236	2112	3599060000000
72263	1397	1339080042000
72264	1678	19440672058000
72265	2134	97951865000
72266	1688	45431941708000
72267	1688	45431952708000
72276	1700	15425993276737
72277	1700	15426005276737
72289	1596	16560602000000
72290	1596	16560726000000
72327	1715	39600672000002
72328	1715	39601284000002
72337	2134	97945847000
72338	2134	97944844000
72339	1679	14614898853000
72362	1397	1338970031000
72363	1678	19440672069000
72364	2134	97939829000
72365	2133	97886778000
72396	633	82444110900000
72439	1439	12532570998477
72456	1397	1338830017000
72457	1678	19440672083000
72458	1397	1338820016000
72459	1678	19440672084000
72460	2133	97874754000
72461	2134	97925787000
72462	2134	97924784000
72463	1448	7956784000001
72468	1397	1338810015000
72469	1678	19440672085000
72470	1397	1338800014000
72471	1678	19440672086000
72472	2133	97873752000
72473	2133	97872750000
72474	2134	97923781000
72475	2134	97922778000
72476	1874	6258000
72477	1587	20880634000000
72478	1587	20880668000000
72496	1395	58059264727007706
72497	1395	58059264739007706
72525	1397	1338730007000
72526	1678	19440672093000
72527	1397	1338720006000
72528	1678	19440672094000
72529	1397	1338710005000
72530	1678	19440672095000
71742	1678	19440671983000
71743	2134	98027090000
71744	1649	21164283999992
71749	1397	1339820116000
71750	1678	19440671984000
71751	2133	97965936000
71752	1874	5753000
71753	2132	148700701000
71754	2134	98026087000
71755	1874	5757000
71756	641	79300020000000
71757	641	79300033000000
71770	1678	20160671986000
71771	1678	20160683986000
71787	1690	118803754000000
71788	1690	118803779000000
71814	1397	1339730107000
71815	1678	19440671993000
71816	2134	98017060000
71817	2133	97957920000
71818	1874	5802000
71819	1992	12239287990000
71820	1992	12239299990000
71842	1681	12743228759830
71843	1681	12743252759830
71894	1394	210243288000000
71895	1394	210243313000000
71898	1397	1339610095000
71899	1678	19440672005000
71900	2134	98005024000
71901	2133	97946898000
71902	1874	5864000
71932	1397	1339600094000
71933	1678	19440672006000
71934	1397	1339590093000
71935	1678	19440672007000
71936	2133	97944894000
71937	2133	97943892000
71938	1874	5873000
71939	2134	98003018000
71940	2134	98002015000
71941	2148	1439046000000
71948	1397	1339570091000
71949	1678	19440672009000
71950	1397	1339560090000
71951	1678	19440672010000
71952	2133	97941888000
71953	2134	98000009000
71954	2134	97999006000
71955	2133	97940886000
71956	1874	5894000
71957	1747	7216932000000
71990	526	69600305000000
72010	1397	1339480082000
72011	1678	19440672018000
72012	1397	1339470081000
72013	1678	19440672019000
72014	2134	97990982000
72015	2133	97931868000
72016	1633	12996638985638
72017	1633	12996660985638
72042	1397	1339420076000
72043	1678	19440672024000
72044	2133	97927860000
72045	1874	5956000
72046	1656	15261544999990
72047	2134	97985967000
72048	1874	5959000
72049	1656	15981544999990
72050	1656	15981545999990
72076	1637	203045538819988
72077	1637	203045562819988
72095	1397	1339350069000
72096	1678	19440672031000
72097	1397	1339340068000
72098	1678	19440672032000
72099	2134	97978946000
72100	1874	5992000
72101	2133	97920846000
72102	2133	97919844000
72103	2134	97977943000
72104	1991	15595892441475
72105	1991	15595916441475
72116	2134	97975937000
72117	1458	18093737908540
72166	1397	1339220056000
72167	1678	19440672044000
72168	2134	97965907000
72169	2133	97908822000
72170	1874	6057000
72171	484	69308758000000
72172	484	69308770000000
72223	1397	1339140048000
72224	1678	19440672052000
72225	2133	97901808000
72226	2134	97957883000
72227	1694	19452657127629
72228	1694	19452669127629
72230	2133	97900806000
72231	2112	3599048000000
72232	2112	3599049000000
72250	1991	16315916441475
72251	1991	16315927441475
72256	1397	1339090043000
72257	1678	19440672057000
72258	2134	97952868000
72259	1874	6116000
72260	2133	97897800000
72261	1700	14705981276737
72262	1700	14705993276737
72274	1394	216003394000000
72275	1394	216003406000000
72278	1687	3500031223172
72279	1866	9452631301632
72280	1397	1339060040000
72281	1678	19440672060000
72282	1397	1339050039000
72283	1678	19440672061000
72284	2133	97895796000
72285	2133	97894794000
72286	2134	97949859000
72287	2134	97948856000
72288	1394	216003518000000
72300	1874	6070000
72301	1874	6073000
72302	1874	6080000
72303	1874	6086000
72304	1874	6096000
72305	1874	6106000
72306	1874	6112000
72307	606	75358206812962
72308	606	76078206812962
72309	606	76078211812962
72326	1740	14922300000000
72329	1397	1339020036000
72330	1678	19440672064000
72331	1397	1339010035000
72332	1678	19440672065000
72333	2133	97892790000
72334	2133	97891788000
72335	1874	6148000
72336	42	91198456000000
72342	1672	20162079000000
72343	1672	20162179000000
72355	1397	1338980032000
72356	1678	19440672068000
72357	2134	97940832000
72358	2133	97887780000
72359	1874	6174000
72360	1395	58058544715007706
72361	1395	58058544727007706
72373	1685	115922369571430
72374	1685	115922381571430
72380	1397	1338940028000
72381	1678	19440672072000
72382	2134	97936820000
72383	2133	97883772000
72384	1874	6194000
72385	1593	17110163000000
72386	1593	17110175000000
72394	1688	46871964708000
72395	1688	46871976708000
72405	633	82444122900000
72406	1397	1338910025000
72407	1678	19440672075000
72408	2134	97933811000
72409	1874	6207000
72410	1440	15119289049920
72411	1440	15119312049920
72423	1397	1338880022000
72424	1678	19440672078000
72425	1397	1338870021000
72426	1678	19440672079000
72427	1397	1338860020000
72428	1678	19440672080000
72429	2134	97930802000
72430	2134	97929799000
72431	2134	97928796000
72432	2133	97879764000
72433	2133	97878762000
72434	1764	11526945100000
72435	2133	97877760000
72436	1874	6230000
72437	1764	12246945100000
72438	1764	12246946100000
71764	1397	1339800114000
71765	1678	19440671986000
71766	2133	97963932000
71767	2134	98024081000
71768	1680	12969584500035
71769	1680	12969596500035
71785	1762	17601988994000
71786	1762	17602013994000
71798	1448	9396834000001
71808	1397	1339740108000
71809	1678	19440671992000
71810	2133	97958922000
71811	2134	98018063000
71812	1458	17373714908540
71813	1458	17373726908540
71830	1397	1339710105000
71831	1678	19440671995000
71832	1397	1339700104000
71833	1678	19440671996000
71834	2133	97955916000
71835	2133	97954914000
71836	2134	98015054000
71837	1874	5815000
71838	2134	98014051000
71839	1874	5818000
71840	42	91198434000000
71841	42	91198458000000
71856	1395	58056384698007706
71857	1395	58057104698007706
71875	1693	13820626406843
71876	1693	13820638406843
71880	1693	13820637406843
71881	1397	1339630097000
71882	1678	19440672003000
71883	1397	1339620096000
71884	1678	19440672004000
71885	2134	98007030000
71886	1874	5851000
71887	2132	148694695000
71888	2133	97948902000
71889	1874	5854000
71890	2133	97947900000
71891	2134	98006027000
71892	1476	14400214000000
71893	1476	14400239000000
71910	1739	27359738000000
71911	1739	27359739000000
71967	1711	16364746000000
71969	1397	1339540088000
71970	1678	19440672012000
71971	2134	97997000000
71972	2133	97938882000
71973	1874	5904000
71974	1768	16430822110000
71975	1768	16430845110000
71995	1397	1339500084000
71996	1678	19440672016000
71997	2134	97992988000
71998	2133	97934874000
71999	1874	5924000
72000	1588	16054983000000
72001	1397	1339490083000
72002	1678	19440672017000
72003	2133	97933872000
72004	2134	97991985000
72005	1716	18766913000000
72006	1716	18766925000000
72018	1397	1339460080000
72019	1678	19440672020000
72020	2134	97989979000
72021	1601	10010244620000
72022	1397	1339450079000
72023	1678	19440672021000
72024	2134	97988976000
72025	2133	97930866000
72026	1394	211683310000000
72027	1394	211683322000000
72036	1397	1339430077000
72037	1678	19440672023000
72038	2134	97986970000
72039	2133	97928862000
72040	1684	17280506880623
72041	1684	17280518880623
72057	1633	12996671985638
72058	1633	13716671985638
72059	1633	13716672985638
72066	1397	1339400074000
72067	1678	19440672026000
72068	1397	1339390073000
72069	1678	19440672027000
72070	2134	97983961000
72071	2134	97982958000
72072	2133	97925856000
72073	1874	5972000
72074	2133	97924854000
72075	1649	21164296999992
72080	1397	1339380072000
72081	1678	19440672028000
72082	1397	1339370071000
72083	1678	19440672029000
72084	1397	1339360070000
72085	1678	19440672030000
72086	2134	97981955000
72087	2134	97980952000
72088	2133	97923852000
72089	1874	5982000
72090	2133	97922850000
72091	2134	97979949000
72092	2133	97921848000
72093	1874	5989000
72094	1991	14875892441475
72112	1397	1339320066000
72113	1678	19440672034000
72114	1458	18093726908540
72115	1458	18093736908540
72119	1397	1339310065000
72120	1678	19440672035000
72121	2133	97917840000
72122	2134	97974934000
72123	1593	16390150000000
72124	1593	16390163000000
72125	1397	1339300064000
72126	1678	19440672036000
72127	1397	1339290063000
72128	1678	19440672037000
72129	1397	1339280062000
72130	1678	19440672038000
72131	2133	97916838000
72132	2134	97973931000
72133	2134	97972928000
72134	2134	97971925000
72135	2133	97915836000
72136	2133	97914834000
72137	1455	7954060000000
72140	1397	1339270061000
72141	1678	19440672039000
72142	2134	97970922000
72143	2133	97913832000
72144	1715	38880660000002
72145	1715	38880672000002
72146	1397	1339260060000
72147	1678	19440672040000
72148	1397	1339250059000
72149	1678	19440672041000
72150	1397	1339240058000
72151	1678	19440672042000
72152	1397	1339230057000
72153	1678	19440672043000
72154	2134	97969919000
72155	2133	97912830000
72156	1874	6037000
72157	2134	97968916000
72158	2134	97967913000
72159	2134	97966910000
72160	2133	97911828000
72161	2133	97910826000
72162	1874	6050000
72163	2133	97909824000
72164	1394	213123322000000
72165	1394	213123370000000
72189	1394	214563370000000
72190	1394	214563394000000
72211	1397	1339160050000
72212	1678	19440672050000
72213	2134	97959889000
72214	2133	97902810000
72215	1601	11450256620000
72216	1601	11450268620000
72217	1397	1339150049000
72218	1678	19440672051000
72219	2134	97958886000
72220	1874	6090000
72221	1992	12959299990000
72222	1992	12959310990000
72237	1397	1339120046000
72238	1678	19440672054000
72239	2133	97899804000
72240	1874	6099000
72241	1546	12240880000000
72242	2134	97955877000
72243	1546	12960880000000
72244	1546	12960881000000
72245	1397	1339110045000
72246	1678	19440672055000
72247	2134	97954874000
72056	1395	58057824715007706
72060	1397	1339410075000
72061	1678	19440672025000
72062	2133	97926858000
72063	2134	97984964000
72064	484	68588746000000
72065	484	68588758000000
72106	1397	1339330067000
72107	1678	19440672033000
72108	2133	97918842000
72109	2134	97976940000
72110	1688	44711929708000
72111	1688	44711941708000
72186	1749	4165257930000
72187	1696	15617402835100
72188	1696	15617465835100
72200	1397	1339180052000
72201	1678	19440672048000
72202	1397	1339170051000
72203	1678	19440672049000
72204	2134	97961895000
72205	2133	97904814000
72206	1874	6077000
72207	2133	97903812000
72208	2134	97960892000
72209	1471	17179711900000
72210	1471	17179735900000
72252	1397	1339100044000
72253	1678	19440672056000
72254	2134	97953871000
72255	2133	97898802000
72291	1634	18191857641004
72292	1634	18191981641004
72344	1397	1339000034000
72345	1678	19440672066000
72346	1397	1338990033000
72347	1678	19440672067000
72348	2133	97889784000
72349	1874	6155000
72350	2133	97888782000
72351	2134	97943841000
72352	2134	97942838000
72353	2134	97941835000
72354	1672	20162106000000
72375	1397	1338950029000
72376	1678	19440672071000
72377	2133	97884774000
72378	2134	97937823000
72379	1650	7954147000000
72397	1397	1338920026000
72398	1678	19440672074000
72399	2134	97934814000
72400	2133	97881768000
72401	1874	6204000
72402	1426	20445116000000
72403	1426	20445128000000
72412	1397	1338900024000
72413	1678	19440672076000
72414	2134	97932808000
72415	1874	6210000
72416	2133	97880766000
72417	1444	15695225159999
72448	1637	203045550819988
72449	1397	1338840018000
72450	1678	19440672082000
72451	2134	97926790000
72452	2133	97875756000
72453	1874	6240000
72454	1692	20660064719999
72455	1692	20660076719999
72464	1706	11012203600135
72479	1397	1338790013000
72480	1678	19440672087000
72481	2134	97921775000
72482	1874	6261000
72483	1705	12155535500145
72484	1705	12155546500145
72486	1397	1338780012000
72487	1678	19440672088000
72488	2134	97920772000
72489	1874	6264000
72490	2133	97871748000
72491	1874	6266000
72498	1602	14400504000000
72511	1397	1338750009000
72512	1678	19440672091000
72513	1397	1338740008000
72514	1678	19440672092000
72515	2134	97917763000
72516	1874	6279000
72517	2134	97916760000
72518	1874	6282000
72519	2133	97868742000
72520	1874	6284000
72521	2133	97867740000
72522	1874	6286000
72523	1394	217443430000000
72564	2134	97909739000
72565	1874	6317000
72566	1422	9505053860211
72620	2134	97907733000
72621	1874	6327000
72622	2134	97906730000
72623	1874	6330000
72624	1874	6332000
72625	2134	97905727000
72626	1874	6335000
72627	1874	6337000
72628	1874	6339000
72629	1874	6341000
72630	1675	13822228999977
72631	1675	13822283999977
72656	1397	1338589993000
72657	1678	19440672107000
72658	1397	1338579992000
72659	1678	19440672108000
72660	2133	97853712000
72661	1874	6356000
72662	2133	97852710000
72663	1874	6358000
72664	2134	97901715000
72665	1874	6361000
72666	1419	26379563280064
72674	1397	1338559990000
72675	1678	19440672110000
72676	1397	1338549989000
72677	1678	19440672111000
72678	1397	1338539988000
72679	1678	19440672112000
72680	2133	97851708000
72681	1874	6366000
72682	1678	19440703112000
72683	2134	97899709000
72684	1874	6369000
72685	2134	97898706000
72686	1874	6372000
72687	2134	97897703000
72688	1874	6375000
72689	2133	97850706000
72690	1874	6377000
72691	2133	97849704000
72692	1874	6379000
72693	1678	20160703112000
72694	1678	20160708112000
72695	1397	1338529987000
72696	1678	20160708113000
72697	1397	1338519986000
72698	1678	20160708114000
72699	1397	1338509985000
72700	1678	20160708115000
72701	2133	97848702000
72702	1874	6381000
72703	2133	97847700000
72704	1874	6383000
72705	2134	97896700000
72706	1874	6386000
72707	2134	97895697000
72708	1874	6389000
72709	2134	97894694000
72710	1874	6392000
72711	2133	97846698000
72712	1874	6394000
72713	1727	13867152000000
72714	1727	13867188000000
72740	1397	1338479982000
72741	1678	20160708118000
72742	2133	97842690000
72743	1874	6411000
72744	2134	97890682000
72745	1874	6414000
72761	1395	58061424773007706
72762	1395	58061424797007706
72775	1397	1338429977000
72776	1678	20160708123000
72777	2133	97838682000
72778	1874	6434000
72779	2134	97885667000
72780	1874	6437000
72781	1444	16415225159999
72782	1444	16415237159999
72791	1395	58061424775007706
72808	2133	97834674000
72809	1874	6454000
72810	2134	97881655000
72811	1874	6457000
72248	1679	14614874853000
72249	1679	14614885853000
72268	1397	1339070041000
72269	1678	19440672059000
72270	2134	97950862000
72271	2133	97896798000
72272	1688	46151952708000
72273	1688	46151964708000
72293	1749	6325292930000
72294	1749	6325416930000
72295	1397	1339040038000
72296	1678	19440672062000
72297	2134	97947853000
72298	606	76077829812962
72299	606	76077840812962
72310	1866	9330827500718
72311	481	66399889331481
72312	1866	9327039506772
72313	734	2012117858457
72314	1866	8269714569740
72315	845	576807119311139
72316	846	576807119311139
72317	936	505992901988482
72318	1056	906734945016128
72319	1176	611792135372498
72320	1302	1704813182739154
72321	1397	1339030037000
72322	1678	19440672063000
72323	2133	97893792000
72324	2134	97946850000
72325	1419	26380352280064
72340	2133	97890786000
72341	171	77510425524688
72366	1397	1338960030000
72367	1678	19440672070000
72368	2134	97938826000
72369	2133	97885776000
72370	1874	6184000
72371	1675	13102216999977
72372	1675	13102228999977
72387	1397	1338930027000
72388	1678	19440672073000
72389	2134	97935817000
72390	1874	6197000
72391	2133	97882770000
72392	1992	13679310990000
72393	1992	13679322990000
72404	1426	20445127000000
72418	1397	1338890023000
72419	1678	19440672077000
72420	2134	97931805000
72421	1608	16125666000000
72422	1608	16125677000000
72440	1397	1338850019000
72441	1678	19440672081000
72442	2134	97927793000
72443	1874	6233000
72444	2133	97876758000
72445	1457	15744366040000
72465	1719	14420584000000
72466	1719	14420607000000
72485	1402	56014629319298
72492	1549	21215904000000
72493	1549	21215916000000
72499	1397	1338770011000
72500	1678	19440672089000
72501	2133	97870746000
72502	1874	6268000
72503	2134	97919769000
72504	1874	6271000
72524	1395	58059264751007706
72567	1397	1338670001000
72568	1678	19440672099000
72569	2133	97861728000
72570	1874	6319000
72571	1422	9505064860211
72632	1588	16774983000000
72633	1588	16775038000000
72637	1397	1338609995000
72638	1678	19440672105000
72639	1397	1338599994000
72640	1678	19440672106000
72641	850	1155015381824210
72642	849	1158298913161640
72643	2133	97855716000
72644	1874	6343000
72645	2133	97854714000
72646	1874	6345000
72647	2134	97904724000
72648	1874	6348000
72649	2134	97903721000
72650	1874	6351000
72651	470	78960419000000
72652	470	78960444000000
72667	1395	58059264750007706
72715	1447	13867184004000
72716	1727	14554587939000
72724	1397	1338499984000
72725	1678	20160708116000
72726	2133	97844694000
72727	1874	6401000
72728	2134	97892688000
72729	1874	6404000
72730	1395	58060704761007706
72731	1395	58060704773007706
72746	1637	203765550819988
72747	1637	203765562819988
72792	498	66721250000000
72793	498	66721252000000
72794	2133	97836678000
72795	1874	6444000
72796	2134	97883661000
72797	1874	6447000
72798	1727	14587188000000
72799	1727	14587190000000
72814	1559	13642742000000
72815	1559	13642744000000
72830	1718	8226772763340
72831	1718	8226796763340
72843	1508	15156305500009
72844	1508	15156516500009
72863	1397	1338369971000
72864	1678	20160708129000
72865	2134	97875637000
72866	1874	6483000
72867	1622	19980415000005
72868	1622	19980426000005
72889	1516	1474719030000
72890	1671	13728851530515
72891	1678	19440672113000
72892	1678	19440672114000
72893	1678	19440672115000
72894	1678	19440672116000
72895	1678	19440672117000
72896	1678	19440672118000
72897	1678	19440672119000
72898	1678	19440672120000
72899	1678	19440672121000
72900	1678	19440672122000
72901	1678	19440672123000
72902	1678	19440672124000
72903	1678	19440672125000
72904	1678	19440672126000
72905	1678	19440672127000
72906	1678	19440672128000
72907	1678	19440672129000
72908	1678	19440672130000
72909	1678	19440672131000
72910	1874	6083000
72911	1874	6093000
72912	1874	6122000
72913	1874	6132000
72914	1874	6138000
72915	1874	6142000
72916	1671	14448851530515
72917	1671	14449476530515
72928	1688	47591976708000
72929	1688	47591988708000
72930	1294	1702588557365879
72931	1397	1338329967000
72932	1678	20160708133000
72933	2134	97871625000
72934	1874	6501000
72935	1656	16701545999990
72936	1656	16701656999990
72953	1693	14540694406843
72954	1693	15260694406843
72955	1693	15260696406843
72961	1397	1338299964000
72962	1678	20160708136000
72963	2134	97868616000
72964	1874	6514000
72965	1637	204485562819988
72966	1637	204485573819988
72967	1397	1338289963000
72968	1678	20160708137000
72969	1397	1338279962000
72970	1678	20160708138000
72971	2134	97867613000
72972	1874	6517000
72973	2134	97866610000
72974	1874	6520000
72975	2133	97824654000
72976	1874	6522000
72977	2133	97823652000
72446	1560	16434357277001
72447	1560	16434369277001
72467	2106	2879059000000
72494	1394	217443406000000
72495	1394	217443418000000
72505	1397	1338760010000
72506	1678	19440672090000
72507	2133	97869744000
72508	1874	6273000
72509	2134	97918766000
72510	1874	6276000
72542	1397	1338700004000
72543	1678	19440672096000
72544	1397	1338690003000
72545	1678	19440672097000
72546	2134	97912748000
72547	1874	6302000
72548	2134	97911745000
72549	1874	6305000
72550	2133	97864734000
72551	1874	6307000
72552	2133	97863732000
72553	1874	6309000
72554	1394	218883430000000
72555	1394	218883454000000
72556	1397	1338680002000
72557	1678	19440672098000
72558	2134	97910742000
72559	1874	6312000
72560	2133	97862730000
72561	1874	6314000
72562	1467	9326726100039
72563	1467	9326738100039
72634	1687	3500032223172
72635	1588	16774971000000
72636	1588	16775151000000
72653	2134	97902718000
72654	1874	6354000
72655	470	78960445000000
72668	1397	1338569991000
72669	1678	19440672109000
72670	2134	97900712000
72671	1874	6364000
72672	1395	58059984750007706
72673	1395	58059984761007706
72723	1394	220323456000000
72732	1397	1338489983000
72733	1678	20160708117000
72734	2133	97843692000
72735	1874	6406000
72736	2134	97891685000
72737	1874	6409000
72738	1685	116642381571430
72739	1685	116642393571430
72748	1397	1338469981000
72749	1678	20160708119000
72750	1397	1338459980000
72751	1678	20160708120000
72752	2133	97841688000
72753	1874	6416000
72754	2133	97840686000
72755	1874	6418000
72756	2134	97889679000
72757	1874	6421000
72758	2134	97888676000
72759	1874	6424000
72760	1419	26379564280064
72783	1394	221763456000000
72784	1394	221763468000000
72785	2134	97884664000
72786	1874	6440000
72787	2133	97837680000
72788	1874	6442000
72789	1724	8587330000000
72790	1724	8587332000000
72816	1397	1338419976000
72817	1678	20160708124000
72818	1397	1338409975000
72819	1678	20160708125000
72820	2133	97833672000
72821	1874	6459000
72822	2134	97880652000
72823	1874	6462000
72824	2134	97879649000
72825	1874	6465000
72826	2133	97832670000
72827	1874	6467000
72828	1668	18686768000000
72829	1668	18686792000000
72845	1516	630325800000
72846	1048	905551785610448
72847	1516	417211780000
72848	1168	610993866670622
72849	1397	1338389973000
72850	1678	20160708127000
72851	1397	1338379972000
72852	1678	20160708128000
72853	2134	97877643000
72854	1874	6473000
72855	2134	97876640000
72856	1874	6476000
72857	2133	97831668000
72858	1874	6478000
72859	2133	97830666000
72860	1874	6480000
72861	1489	14304063000000
72862	1489	14304387000000
72887	1671	14448471530515
72888	1671	14448493530515
72937	1395	58061424884007706
72956	1395	58060704795007706
72957	1395	58061424795007706
72989	420	66529373005524
72990	2164	500000000
72991	1693	14457697218470
72992	352	66613938193897
72993	1693	14374722030097
72994	600	66613938193897
72995	1693	14291746841724
72996	620	66613938193897
72997	1693	13527608778944
72998	1150	613559297664572
72999	1693	13300597224236
73000	1811	1675947484894
73001	1693	13217622035863
73002	84	66613938193897
73003	1693	13134646847490
73004	2017	612537528296
73005	1693	13051671659117
73006	520	66613938193897
73007	1693	12968696470744
73008	89	66613938193897
73009	1693	12885721282371
73010	186	66613938193897
73011	1693	12802746093998
73012	383	66613938193897
73013	1397	1338259960000
73014	1678	20160708140000
73015	1397	1338249959000
73016	1678	20160708141000
73017	2134	97864604000
73018	1874	6530000
73019	2133	97822650000
73020	1874	6532000
73021	2133	97821648000
73022	1874	6534000
73023	2134	97863601000
73024	1874	6537000
73025	632	70461155000000
73074	1397	1338219956000
73075	1678	20160708144000
73076	1693	11972994210268
73077	691	66613938193897
73078	1693	11890019021895
73079	339	66613938193897
73080	1693	11887494925287
73081	745	2018604187613
73082	1693	11804519736914
73083	63	66613938193897
73084	1693	11211049269155
73085	1772	4389917417867
73086	2133	97819644000
73087	1874	6544000
73088	2134	97861595000
73089	1874	6547000
73090	1476	16560242000000
73091	1476	16560304000000
73171	1693	6698445311153
73172	122	66613938193897
73173	1693	6615470122780
73174	622	66616918193897
73175	1693	6532494934407
73176	653	66613938193897
73177	1693	6449519746034
73178	304	66613938193897
73179	1693	6366544557661
73180	206	66613938193897
73181	1693	6283569369288
73182	399	66613938193897
73183	1397	1338169951000
73184	1678	20160708149000
73185	2133	97814634000
73186	1874	6569000
73187	2134	97856580000
73188	1874	6572000
72531	2134	97915757000
72532	1874	6289000
72533	2133	97866738000
72534	1874	6291000
72535	2133	97865736000
72536	1874	6293000
72537	2134	97914754000
72538	1874	6296000
72539	2134	97913751000
72540	1874	6299000
72541	1693	14540672406843
72572	1394	220323454000000
72573	1394	220323466000000
72574	1397	1338660000000
72575	1678	19440672100000
72576	2133	97860726000
72577	1874	6321000
72578	2134	97908736000
72579	1874	6324000
72580	1715	39600695000002
72581	1397	1338649999000
72582	1678	19440672101000
72583	1397	1338639998000
72584	1678	19440672102000
72585	1397	1338629997000
72586	1678	19440672103000
72587	1397	1338619996000
72588	1678	19440672104000
72589	1598	0
72590	2163	1199000000000
72591	1874	6109000
72592	1874	6119000
72593	1874	6125000
72594	1874	6129000
72595	1874	6135000
72596	1874	6145000
72597	1874	6151000
72598	1874	6161000
72599	1874	6171000
72600	1874	6181000
72601	2133	97859724000
72602	2133	97858722000
72603	1874	6187000
72604	2133	97857720000
72605	2133	97856718000
72606	1874	6191000
72607	1874	6200000
72608	1874	6227000
72609	1874	6236000
72610	1874	6260000
72611	1874	6263000
72612	1874	6269000
72613	1874	6272000
72614	1874	6275000
72615	1874	6278000
72616	1588	16055663000000
72617	1874	6281000
72618	1588	16775663000000
72619	1588	16775664000000
72717	2133	97845696000
72718	1874	6396000
72719	2134	97893691000
72720	1874	6399000
72721	1672	20882106000000
72722	1672	20882108000000
72763	1397	1338449979000
72764	1678	20160708121000
72765	1397	1338439978000
72766	1678	20160708122000
72767	2134	97887673000
72768	1874	6427000
72769	2134	97886670000
72770	1874	6430000
72771	2133	97839684000
72772	1874	6432000
72773	1471	17899735900000
72774	1471	17899758900000
72800	1756	6369272285609
72801	1516	1298566290000
72802	2134	97882658000
72803	1874	6450000
72804	2133	97835676000
72805	1874	6452000
72806	1616	5040132410000
72807	1616	5040144410000
72832	1541	722060000000
72869	1710	16794635473290
72870	1710	16794646473290
72879	1397	1338349969000
72880	1678	20160708131000
72881	1756	6193109545609
72882	1516	593364520000
72883	2134	97873631000
72884	1874	6491000
72885	2133	97828662000
72886	1874	6493000
72918	1397	1338339968000
72919	1678	20160708132000
72920	2134	97872628000
72921	1874	6496000
72922	2133	97827660000
72923	1874	6498000
72924	1549	21935916000000
72925	1549	21935928000000
72981	1690	118803778000000
72982	1397	1338269961000
72983	1678	20160708139000
72984	2134	97865607000
72985	1874	6527000
72986	1694	20172669127629
72987	1694	20172680127629
73056	1397	1338229957000
73057	1678	20160708143000
73058	1693	12387870152133
73059	91	66613938193897
73060	1693	12304894963760
73061	438	66613938193897
73062	1693	12221919775387
73063	593	66612937193897
73064	1693	12138944587014
73065	408	66613938193897
73066	1693	12055969398641
73067	601	66613938193897
73068	2133	97820646000
73069	1874	6542000
73070	1546	13680881000000
73071	1546	13680942000000
73092	1693	11128074080782
73093	92	66613938193897
73094	1693	11045098892409
73095	150	66613938193897
73096	1397	1338209955000
73097	1678	20160708145000
73098	1397	1338199954000
73099	1678	20160708146000
73100	1693	10962123704036
73101	373	66613938193897
73102	420	66000263005524
73103	2164	529600000000
73104	1693	10879148515663
73105	322	66613938193897
73106	1693	10796173327290
73107	453	66613938193897
73108	1693	10713198138917
73109	450	66613938193897
73110	1693	10630222950544
73111	395	66110897193897
73112	1693	10621413612395
73113	29	7065114656873
73114	1693	10538438424022
73115	138	66613938193897
73116	1693	9906443549402
73117	910	507454463072188
73118	1693	9823468361029
73119	500	66613938193897
73120	1693	9740493172656
73121	146	66613938193897
73122	2133	97818642000
73123	1874	6549000
73124	2133	97817640000
73125	1874	6551000
73126	2134	97860592000
73127	1874	6554000
73128	2134	97859589000
73129	1874	6557000
73130	1494	720000000000
73131	1494	720154000000
73191	1394	221763528000000
73227	1693	13737662218470
73228	1693	13654687030097
73229	1693	13571711841724
73230	1693	12807573778944
73231	1693	12580562224236
73232	1693	12497587035863
73233	1693	12414611847490
73234	1693	12331636659117
73235	1693	12248661470744
73236	1693	12165686282371
73237	1693	12082711093998
73238	1693	11999735905625
73239	1693	11916760717252
73240	1693	11833785528879
73241	1693	11750810340506
73242	1693	11667835152133
73243	1693	11584859963760
72812	1476	15840240000000
72813	1476	15840242000000
72833	1516	1122313550000
72834	928	505332697819092
72835	1516	946060810000
72836	928	505508850559092
72837	1397	1338399974000
72838	1678	20160708126000
72839	2134	97878646000
72840	1874	6470000
72841	1689	13680288287625
72842	1689	13680499287625
72871	1397	1338359970000
72872	1678	20160708130000
72873	2133	97829664000
72874	1874	6485000
72875	2134	97874634000
72876	1874	6488000
72877	1467	10046738100039
72878	1467	10046750100039
72926	1727	15307190000000
72927	1727	15307202000000
72938	1397	1338319966000
72939	1678	20160708134000
72940	1397	1338309965000
72941	1678	20160708135000
72942	2133	97826658000
72943	1874	6503000
72944	2133	97825656000
72945	1874	6505000
72946	1402	56014651319298
72947	2134	97870622000
72948	1874	6508000
72949	2134	97869619000
72950	1874	6511000
72951	1402	56734651319298
72952	1402	56734653319298
72958	1685	116642415571430
72959	1685	117362415571430
72960	1685	117362417571430
72988	1637	205205584819988
73026	1687	2060007223172
73027	1693	11577607218470
73028	1693	11494632030097
73029	1693	11411656841724
73030	1693	10647518778944
73031	1693	10420507224236
73032	1693	10337532035863
73033	1693	10254556847490
73034	1756	4929248285609
73035	1693	10171581659117
73036	1693	10088606470744
73037	1693	10005631282371
73038	1693	9922656093998
73039	1756	4753085545609
73040	1980	16561004000000
73041	1980	17281004000000
73042	1980	17281794000000
73072	2039	16561444000000
73073	2039	16561505000000
73132	1397	1338189953000
73133	1678	20160708147000
73134	1397	1338179952000
73135	1678	20160708148000
73136	1693	9657517984283
73137	504	66613938193897
73138	1693	9574542795910
73139	587	66613938193897
73140	1693	9491567607537
73141	1961	612850369124
73142	1693	9408592419164
73143	611	66613938193897
73144	1693	9325617230791
73145	205	66613938193897
73146	1693	9242642042418
73147	658	66613938193897
73148	1693	9159666854045
73149	78	66613938193897
73150	1693	9076691665672
73151	660	66613938193897
73152	1693	6947370876272
73153	1276	1709737537593210
73154	1693	6864395687899
73155	194	66613938193897
73156	1693	6781420499526
73157	105	66613938193897
73158	2133	97816638000
73159	1874	6553000
73160	1874	6556000
73161	1874	6559000
73162	2133	97815636000
73163	1874	6561000
73164	2134	97858586000
73165	1874	6564000
73166	2134	97857583000
73167	1874	6567000
73168	1711	16365022000000
73170	1711	16364868000000
73192	1874	6563000
73193	1874	6566000
73194	1850	12159105000000
73332	1471	18619798900000
73357	1397	1338099944000
73358	1678	20160708156000
73359	2134	97849559000
73360	1874	6601000
73361	2133	97809624000
73362	1874	6603000
73363	1679	14614886853000
73402	1608	16845677000000
73403	1608	16845739000000
73406	1693	2189325868594
73407	397	66613938193897
73408	1397	1338059940000
73409	1678	20160708160000
73410	1693	2106350680221
73411	402	66613938193897
73412	1693	2023375491848
73413	391	66613938193897
73414	1693	1940400303475
73415	452	66613938193897
73416	1693	1857425115102
73417	2073	612113103967
73418	2134	97845547000
73419	1874	6621000
73420	2133	97805616000
73421	1874	6623000
73422	1746	8434433000000
73446	1394	221763509000000
73468	1397	1338029937000
73469	1678	20160708163000
73470	1693	1191099511510
73471	191	66613938193897
73472	1693	1108124323137
73473	266	66613938193897
73474	1693	1025149134764
73475	534	66613938193897
73476	1693	942173946391
73477	245	66613938193897
73478	1693	859198758018
73479	421	66613938193897
73480	2133	97802610000
73481	1874	6635000
73482	2134	97842538000
73483	1874	6638000
73484	1688	47592038708000
73508	1397	1337989933000
73509	1678	20160708167000
73510	2134	97838526000
73511	1874	6650000
73512	1724	8587341000000
73539	1397	1337959930000
73540	1678	20160708170000
73541	2134	97835517000
73542	1874	6667000
73543	2133	97797600000
73544	1874	6669000
73545	1710	17514646473290
73546	1710	17514658473290
73568	1685	118082417571430
73569	1685	118082441571430
73572	1397	1337919926000
73573	1678	20160708174000
73574	2133	97793592000
73575	1874	6686000
73576	2134	97831505000
73577	1874	6689000
73578	1649	21884296999992
73579	1649	21884308999992
73582	1397	1337909925000
73583	1678	20160708175000
73584	2134	97830502000
73585	1874	6692000
73586	2133	97792590000
73587	1874	6694000
73588	1692	22820102619999
73589	1692	22820125619999
73590	1397	1337899924000
73591	1678	20160708176000
73592	1397	1337889923000
73593	1678	20160708177000
73594	1397	1337879922000
73595	1678	20160708178000
73596	2133	97791588000
73597	1874	6696000
72978	1874	6524000
72979	1637	205205573819988
72980	1637	205205597819988
73043	1397	1338239958000
73044	1678	20160708142000
73045	1693	12719770905625
73046	392	66613938193897
73047	1693	12636795717252
73048	308	66613938193897
73049	1693	12553820528879
73050	551	66613938193897
73051	1693	12470845340506
73052	678	66613938193897
73053	2134	97862598000
73054	1874	6540000
73055	1593	17110214000000
73169	1679	14615162853000
73195	1850	12159115000000
73196	1693	6200594180915
73197	54	66613938193897
73198	1693	6194298939379
73199	710	5046510469181
73200	1693	6111323751006
73201	499	66613938193897
73202	1693	6108799654398
73203	721	2018604187613
73204	1693	6025824466025
73205	103	66613938193897
73206	1693	5942849277652
73207	217	66613938193897
73208	1397	1338159950000
73209	1678	20160708150000
73210	1397	1338149949000
73211	1678	20160708151000
73212	1693	5557148049236
73213	893	309677012160129
73214	1759	13680875999999
73215	1693	5474172860863
73216	251	66613938193897
73217	2133	97813632000
73218	1874	6574000
73219	2134	97855577000
73220	1874	6577000
73221	2134	97854574000
73222	1874	6580000
73223	1759	14400875999999
73224	1759	14400888999999
73364	1693	2770152187205
73365	82	66613938193897
73366	1673	22646014000000
73367	1242	611019660000000
73368	1397	1338089943000
73369	1678	20160708157000
73370	1397	1338079942000
73371	1678	20160708158000
73372	1693	2687176998832
73373	361	66613938193897
73374	2133	97808622000
73375	1874	6605000
73376	2134	97848556000
73377	1874	6608000
73378	2134	97847553000
73379	1874	6611000
73380	2133	97807620000
73381	1874	6613000
73382	1679	15334886853000
73383	1679	15334940853000
73423	1874	6620000
73424	1704	3666242000000
73425	1704	3666303000000
73427	1693	1774449926729
73428	680	66613938193897
73429	1693	1691474738356
73430	690	66613938193897
73431	1397	1338049939000
73432	1678	20160708161000
73433	1693	1688950641748
73434	731	2018604187613
73435	1693	1605975453375
73436	180	66613938193897
73437	2134	97844544000
73438	1874	6626000
73439	2133	97804614000
73440	1874	6628000
73441	1746	8434424000000
73485	1687	4940084223172
73486	1687	4940146223172
73489	1397	1338019936000
73490	1678	20160708164000
73491	2134	97841535000
73492	1874	6641000
73493	58	86826577999641
73494	58	86826588999641
73501	1692	21380076719999
73502	1692	21380087719999
73513	1397	1337979932000
73514	1678	20160708168000
73515	2134	97837523000
73516	1874	6653000
73517	1717	12348035000023
73518	1717	12348046000023
73570	1650	8674147000000
73571	1650	8674171000000
73580	1874	6687000
73581	1649	21884297999992
73610	1874	6695000
73611	1874	6700000
73612	1874	6702000
73613	1850	12879050000000
73643	1419	27099564280064
73644	1419	27099576280064
73662	1397	1337809915000
73663	1678	20160708185000
73664	1397	1337799914000
73665	1678	20160708186000
73666	2133	97787580000
73667	1874	6731000
73668	2133	97786578000
73669	1874	6733000
73670	2134	97820472000
73671	1874	6736000
73672	2134	97819469000
73673	1874	6739000
73674	2133	97785576000
73675	1874	6741000
73676	2133	97784574000
73677	1874	6743000
73678	1686	15332120550062
73679	1686	15332146550062
73719	1395	58064304883007706
73720	1395	58064304897007706
73738	1397	1337719906000
73739	1678	20160708194000
73740	2133	97775556000
73741	1874	6785000
73742	2134	97810442000
73743	1874	6788000
73744	1559	13642754000000
73745	1397	1337709905000
73746	1678	20160708195000
73747	1397	1337699904000
73748	1678	20160708196000
73749	1397	1337689903000
73750	1678	20160708197000
73751	1397	1337679902000
73752	1678	20160708198000
73753	2134	97809439000
73754	1874	6791000
73755	2134	97808436000
73756	1874	6794000
73757	2133	97774554000
73758	1874	6796000
73759	1672	20162149000000
73760	2133	97773552000
73761	1874	6798000
73762	2133	97772550000
73763	1874	6800000
73764	2133	97771548000
73765	1874	6802000
73766	2134	97807433000
73767	1874	6805000
73768	2134	97806430000
73769	1874	6808000
73770	1672	20882149000000
73771	1672	20882154000000
73781	1933	2160202000000
73782	1933	2160214000000
73795	1397	1337649899000
73796	1678	20160708201000
73797	1397	1337639898000
73798	1678	20160708202000
73799	2134	97803421000
73800	1874	6821000
73801	2134	97802418000
73802	1874	6824000
73803	2133	97768542000
73804	1874	6826000
73805	1541	722059000000
73812	1395	58064304906007706
73845	1693	1579198758018
73846	1693	1579210758018
73854	1746	8434383000000
73876	1690	119523790000000
73877	1690	119523802000000
73900	1871	1438922000000
73189	1850	12158919000000
73190	1850	12158991000000
73225	1759	14400785999999
73226	1759	14400808999999
73292	1471	17899778900000
73293	1397	1338139948000
73294	1678	20160708152000
73295	1397	1338129947000
73296	1678	20160708153000
73297	2164	529599000000
73298	2133	97812630000
73299	1874	6582000
73300	1471	18619778900000
73301	1471	18619860900000
73333	1397	1338119946000
73334	1678	20160708154000
73335	1693	3102052940697
73336	225	66613938193897
73337	1693	3019077752324
73338	560	66613938193897
73339	1693	2936102563951
73340	252	66613938193897
73341	1693	2853127375578
73342	163	66613938193897
73343	2133	97811628000
73344	1874	6590000
73345	2134	97851565000
73346	1874	6593000
73347	1508	15156541500009
73348	1594	17185539000000
73404	1573	10059036000000
73405	1573	10059098000000
73426	1747	7216970000000
73442	1874	6622000
73443	1704	4386303000000
73444	1704	4386354000000
73449	1673	22645484000000
73450	1122	905590055000000
73451	1693	1523000265002
73452	112	66084906193897
73453	1397	1338039938000
73454	1678	20160708162000
73455	1693	1440025076629
73456	353	66613928193897
73457	1693	1357049888256
73458	652	66613938193897
73459	1693	1274074699883
73460	420	66083228193897
73461	2133	97803612000
73462	1874	6630000
73463	2134	97843541000
73464	1874	6633000
73465	1926	1193000000
73466	1402	56734629319298
73467	1402	56734692319298
73503	1397	1337999934000
73504	1678	20160708166000
73505	2134	97839529000
73506	1874	6647000
73507	1394	221763467000000
73519	484	70028770000000
73520	484	70028781000000
73547	1397	1337949929000
73548	1678	20160708171000
73549	2133	97796598000
73550	1874	6671000
73551	2134	97834514000
73552	1874	6674000
73553	1394	223203479000000
73614	1509	15791929851155
73615	1509	15791965851155
73616	1397	1337869921000
73617	1678	20160708179000
73618	2134	97826490000
73619	1874	6712000
73620	632	71181155000000
73621	632	71181166000000
73645	2106	3599059000000
73646	2106	3599071000000
73647	1397	1337829917000
73648	1678	20160708183000
73649	2134	97822478000
73650	1874	6726000
73651	1700	16146005276737
73652	1700	16146016276737
73655	1397	1337819916000
73656	1678	20160708184000
73657	2134	97821475000
73658	1874	6729000
73659	1684	18720554880623
73660	1684	18720565880623
73680	1397	1337789913000
73681	1678	20160708187000
73682	1397	1337779912000
73683	1678	20160708188000
73684	1397	1337769911000
73685	1678	20160708189000
73686	2134	97818466000
73687	1874	6746000
73688	2134	97817463000
73689	1874	6749000
73690	2133	97783572000
73691	1874	6751000
73692	2133	97782570000
73693	1874	6753000
73694	2133	97781568000
73695	1874	6755000
73696	2134	97816460000
73697	1874	6758000
73698	1690	118803790000000
73721	1637	205205587819988
73722	1397	1337739908000
73723	1678	20160708192000
73724	2134	97812448000
73725	1874	6776000
73726	2133	97777560000
73727	1874	6778000
73728	1423	4353287999985
73729	1423	4353299999985
73784	1397	1337659900000
73785	1678	20160708200000
73786	2134	97804424000
73787	1874	6816000
73788	2133	97769544000
73789	1874	6818000
73790	1660	1914030000000
73791	1740	15045300000000
73792	1740	15045312000000
73806	2133	97767540000
73807	1874	6828000
73808	1711	17084868000000
73809	1711	17084892000000
73819	1397	1337619896000
73820	1678	20160708204000
73821	2134	97800412000
73822	1874	6834000
73823	2133	97766538000
73824	1874	6836000
73825	1546	14400942000000
73826	1546	14400954000000
73855	1747	7216920000000
73856	1573	10779098000000
73857	1573	10779110000000
73858	1397	1337579892000
73859	1678	20160708208000
73860	2133	97762530000
73861	1874	6853000
73862	2134	97796400000
73863	1874	6856000
73864	1688	48311988708000
73865	1688	48312000708000
73878	1397	1337559890000
73879	1678	20160708210000
73880	1397	1337549889000
73881	1678	20160708211000
73882	2134	97794394000
73883	1874	6864000
73884	2133	97760526000
73885	1874	6866000
73886	2133	97759524000
73887	1874	6868000
73888	2134	97793391000
73889	1874	6871000
73890	1559	14362754000000
73891	1559	14362778000000
73893	1397	1337539888000
73894	1678	20160708212000
73895	2134	97792388000
73896	1874	6874000
73897	2133	97758522000
73898	1874	6876000
73901	1394	226083491000000
73902	1394	226083503000000
73951	1397	1337489883000
73952	1678	20160708217000
73953	1874	6892000
73954	2134	97787373000
73955	1874	6895000
73956	1874	6897000
73957	1874	6899000
73958	2133	97753512000
73959	1874	6901000
73960	1394	227523515000000
73961	1394	227523551000000
73963	1571	21600465001024
73244	1693	11501884775387
73245	1693	11418909587014
73246	1693	11335934398641
73247	1693	11252959210268
73248	1693	11169984021895
73249	1693	11167459925287
73250	1693	11084484736914
73251	1693	10491014269155
73252	1759	13681315999999
73253	1693	10408039080782
73254	1693	10325063892409
73255	1693	10242088704036
73256	1693	10159113515663
73257	1693	10076138327290
73258	1693	9993163138917
73259	1693	9910187950544
73260	1693	9901378612395
73261	1693	9818403424022
73262	1693	9186408549402
73263	1693	9103433361029
73264	1693	9020458172656
73265	1693	8937482984283
73266	1693	8854507795910
73267	1693	8771532607537
73268	1693	8688557419164
73269	1693	8605582230791
73270	1693	8522607042418
73271	1693	8439631854045
73272	1693	8356656665672
73273	1693	6227335876272
73274	1693	6144360687899
73275	1693	6061385499526
73276	1693	5978410311153
73277	1693	5895435122780
73278	1693	5812459934407
73279	1693	5729484746034
73280	1693	5646509557661
73281	1693	5563534369288
73282	1693	5480559180915
73283	1693	5474263939379
73284	1693	5391288751006
73285	1693	5388764654398
73286	1693	5305789466025
73287	1693	5222814277652
73288	1693	4837113049236
73289	1693	4754137860863
73290	1759	14401315999999
73291	1759	14402215999999
73302	1693	5450027533343
73303	35	19378600201813
73304	1693	5367052344970
73305	49	66613938193897
73306	1693	5284077156597
73307	320	66332738193897
73308	1693	4151555676097
73309	1030	909354049955700
73310	1693	4068580487724
73311	569	66613938193897
73312	1693	3985605299351
73313	663	66613938193897
73314	1693	3902630110978
73315	108	66613938193897
73316	1693	3819654922605
73317	390	66613938193897
73318	1693	3433953694189
73319	894	309677012160129
73320	1693	3350978505816
73321	570	66613938193897
73322	1693	3268003317443
73323	99	66613938193897
73324	1693	3185028129070
73325	377	66613938193897
73326	2134	97853571000
73327	1874	6583000
73328	2134	97852568000
73329	1874	6586000
73330	1874	6588000
73331	1471	18619982900000
73349	1397	1338109945000
73350	1678	20160708155000
73351	2134	97850562000
73352	1874	6596000
73353	2133	97810626000
73354	1874	6598000
73355	1395	58062144797007706
73356	1395	58062144809007706
73384	1397	1338069941000
73385	1678	20160708159000
73386	1693	2604201810459
73387	594	66613938193897
73388	1693	2521226622086
73389	309	66613938193897
73390	1693	2438251433713
73391	201	66613938193897
73392	1693	2355276245340
73393	1962	612850369124
73394	1693	2272301056967
73395	275	66613938193897
73396	2133	97806618000
73397	1874	6615000
73398	2134	97846550000
73399	1874	6618000
73400	1678	20880708159000
73401	1678	20880770159000
73445	1747	7216961000000
73447	1687	4220031223172
73448	1687	4220084223172
73487	1395	58062864809007706
73488	1395	58062864871007706
73495	1397	1338009935000
73496	1678	20160708165000
73497	2134	97840532000
73498	1874	6644000
73499	1458	18813736908540
73500	1458	18813747908540
73521	1394	223203467000000
73522	1394	223203478000000
73523	1397	1337969931000
73524	1678	20160708169000
73525	1692	21380097719999
73526	2134	97836520000
73527	1874	6656000
73528	2133	97801608000
73529	1874	6658000
73530	2133	97800606000
73531	1874	6660000
73532	2133	97799604000
73533	1874	6662000
73534	2133	97798602000
73535	1874	6664000
73536	1692	22100097719999
73537	167	22100102619999
73538	1692	66000000100200
73554	1397	1337939928000
73555	1678	20160708172000
73556	1397	1337929927000
73557	1678	20160708173000
73558	2133	97795596000
73559	1874	6676000
73560	2134	97833511000
73561	1874	6679000
73562	2134	97832508000
73563	1874	6682000
73564	2133	97794594000
73565	1874	6684000
73566	1394	224643479000000
73567	1394	224643503000000
73622	1397	1337859920000
73623	1678	20160708180000
73624	2134	97825487000
73625	1874	6715000
73626	2133	97788582000
73627	1874	6717000
73628	1656	17421656999990
73629	1656	17421668999990
73632	1397	1337849919000
73633	1678	20160708181000
73634	2134	97824484000
73635	1874	6720000
73636	1679	16054940853000
73637	1679	16054951853000
73661	1394	224643490000000
73699	1397	1337759910000
73700	1678	20160708190000
73701	2133	97780566000
73702	1874	6760000
73703	2134	97815457000
73704	1874	6763000
73705	1395	58063584871007706
73706	1395	58063584883007706
73730	1397	1337729907000
73731	1678	20160708193000
73732	2134	97811445000
73733	1874	6781000
73734	2133	97776558000
73735	1874	6783000
73736	1686	16052146550062
73737	1686	16052158550062
73793	1740	15642300000000
73794	1740	15642312000000
73810	1718	8946796763340
73811	1718	8946819763340
73828	1397	1337609895000
73829	1678	20160708205000
73830	2133	97765536000
73598	2133	97790586000
73599	1874	6698000
73600	2134	97829499000
73601	1874	6701000
73602	2134	97828496000
73603	1874	6704000
73604	2134	97827493000
73605	1874	6707000
73606	2133	97789584000
73607	1874	6709000
73608	1850	12878991000000
73609	1850	12879027000000
73630	171	78230425524688
73631	171	78230437524688
73638	1397	1337839918000
73639	1678	20160708182000
73640	1924	1195000000
73641	2134	97823481000
73642	1874	6723000
73653	1692	23540125619999
73654	1692	23540136619999
73707	1397	1337749909000
73708	1678	20160708191000
73709	2133	97779564000
73710	1874	6765000
73711	2133	97778562000
73712	1874	6767000
73713	2134	97814454000
73714	1874	6770000
73715	2134	97813451000
73716	1874	6773000
73717	1423	3633273999985
73718	1423	3633287999985
73772	1397	1337669901000
73773	1678	20160708199000
73774	2134	97805427000
73775	1874	6811000
73776	2133	97770546000
73777	1874	6813000
73778	1660	1317030000000
73779	1933	1563202000000
73780	1933	1563214000000
73783	1571	20880465001024
73813	1397	1337629897000
73814	1678	20160708203000
73815	2134	97801415000
73816	1874	6831000
73817	1685	118802441571430
73818	1685	118802452571430
73827	1687	4940096223172
73836	1394	224643491000000
73847	1397	1337589893000
73848	1678	20160708207000
73849	2133	97763532000
73850	1874	6848000
73851	2134	97797403000
73852	1874	6851000
73853	1704	4386315000000
73917	1394	226083515000000
73931	1397	1337509885000
73932	1678	20160708215000
73933	2134	97789379000
73934	1874	6889000
73935	2133	97755516000
73936	1874	6891000
73937	2148	2159046000000
73938	2148	2159058000000
73983	1702	7920332000000
73985	1703	7920782000000
74010	1395	58064304905007706
74013	1650	8674169000000
74026	1397	1337409875000
74027	1678	20160708225000
74028	2134	97779349000
74029	1874	6939000
74030	1992	12959321990000
74031	2133	97745496000
74032	1874	6941000
74033	1992	13679321990000
74037	1397	1337399874000
74038	1678	20160708226000
74039	2134	97778346000
74040	1874	6944000
74041	2133	97744494000
74042	1874	6946000
74110	1874	6957000
74111	2133	97742490000
74112	1874	6959000
74113	2133	97741488000
74114	1874	6961000
74115	2133	97740486000
74116	1874	6963000
74117	1719	14420620000000
74124	1874	6960000
74125	1874	6962000
74126	1874	6964000
74127	1874	6966000
74128	2133	97739484000
74129	1874	6968000
74130	1710	18954670473290
74131	1710	18954716473290
74137	1397	1337329867000
74138	1678	20160708233000
74139	2134	97772328000
74140	1874	6974000
74141	2133	97738482000
74142	1874	6976000
74143	2133	97737480000
74144	1874	6978000
74145	1746	8434384000000
74149	1397	1337319866000
74150	1678	20160708234000
74151	2133	97736478000
74152	1874	6980000
74153	2134	97771325000
74154	1874	6983000
74155	1719	14420596000000
74182	1397	1337289863000
74183	1678	20160708237000
74184	2134	97768316000
74185	1874	6996000
74186	2133	97733472000
74187	1874	6998000
74188	1394	230403516000000
74189	1394	230403528000000
74198	1718	8946808763340
74213	1688	50472071708000
74216	1397	1337249859000
74217	1678	20160708241000
74218	2134	97764304000
74219	1874	7016000
74220	2133	97729464000
74221	1874	7018000
74222	1717	13068046000023
74223	1717	13068058000023
74227	1693	11611625659117
74228	1693	11528650470744
74229	1693	11445675282371
74230	1693	11362700093998
74231	1693	11279724905625
74232	1693	11196749717252
74233	1693	11113774528879
74234	1693	11030799340506
74235	1693	10947824152133
74236	1693	10864848963760
74237	1693	10781873775387
74238	1693	10698898587014
74239	1693	10615923398641
74240	1693	10532948210268
74241	1693	10449973021895
74242	1693	10447448925287
74243	1693	10364473736914
74244	1693	9771003269155
74245	1693	9688028080782
74246	1693	9605052892409
74247	1693	9522077704036
74248	369	81222102000000
74249	1678	18720659984000
74250	1678	18720659985000
74251	1678	18720659986000
74252	1678	18720659987000
74253	1693	9439102515663
74254	1693	9356127327290
74255	1693	9273152138917
74256	1693	9190176950544
74257	1693	9181367612395
74258	1693	9098392424022
74259	1693	8466397549402
74260	1693	8383422361029
74261	1693	8300447172656
74262	1693	8217471984283
74263	1693	8134496795910
74264	1693	8051521607537
74265	1693	7968546419164
74266	1693	7885571230791
74267	1693	7802596042418
74268	1693	7719620854045
74269	1693	7636645665672
74270	1693	5507324876272
74271	1693	5424349687899
74272	1693	5341374499526
74273	1693	5258399311153
74274	1693	5175424122780
74275	1693	5092448934407
74276	1693	5009473746034
73831	1874	6838000
73832	2134	97799409000
73833	1874	6841000
73834	1710	18234658473290
73835	1710	18234670473290
73837	1397	1337599894000
73838	1678	20160708206000
73839	2134	97798406000
73840	1874	6844000
73841	2133	97764534000
73842	1874	6846000
73843	1991	17035927441475
73844	1991	17035939441475
73866	1596	17280726000000
73867	1596	17280738000000
73868	1397	1337569891000
73869	1678	20160708209000
73870	2133	97761528000
73871	1874	6858000
73872	2134	97795397000
73873	1874	6861000
73874	1708	12275815000021
73875	1708	12275827000021
73892	1688	48312012708000
73899	1594	17185315000000
73903	1397	1337529887000
73904	1678	20160708213000
73905	1397	1337519886000
73906	1678	20160708214000
73907	2133	97757520000
73908	1874	6878000
73909	2133	97756518000
73910	1874	6880000
73911	2134	97791385000
73912	1874	6883000
73913	2134	97790382000
73914	1874	6886000
73915	338	66720000000000
73916	338	66720024000000
73941	42	91918456000000
73942	42	91918468000000
73962	1874	6898000
73964	1397	1337479882000
73965	1678	20160708218000
73966	1397	1337469881000
73967	1678	20160708219000
73968	1397	1337459880000
73969	1678	20160708220000
73970	2133	97752510000
73971	1874	6903000
73972	2134	97786370000
73973	1874	6906000
73974	2134	97785367000
73975	1874	6909000
73976	2133	97751508000
73977	1874	6911000
73978	2134	97784364000
73979	1874	6914000
73980	2133	97750506000
73981	1874	6916000
73982	2148	2159082000000
74000	1494	144000000
74001	1950	11889851000000
74002	1397	1337429877000
74003	1678	20160708223000
74004	2133	97747500000
74005	1874	6928000
74006	2134	97781355000
74007	1874	6931000
74008	1764	12966946100000
74009	1764	12966968100000
74016	1397	1337419876000
74017	1678	20160708224000
74018	2133	97746498000
74019	1874	6933000
74020	2134	97780352000
74021	1874	6936000
74022	1402	57454692319298
74023	1402	57454704319298
74051	1687	2780019223172
74052	1693	13017651218470
74053	1693	12934676030097
74054	1693	12851700841724
74055	1693	12087562778944
74056	1693	11860551224236
74057	1695	14012586000000
74058	1693	11777576035863
74059	1693	11694600847490
74060	1756	5649259285609
74061	1695	14732586000000
74062	1695	14732616000000
74103	1397	1337379872000
74104	1678	20160708228000
74105	1397	1337369871000
74106	1678	20160708229000
74107	1397	1337359870000
74108	1678	20160708230000
74109	1719	14420616000000
74118	1397	1337349869000
74119	1678	20160708231000
74120	2134	97774334000
74121	1874	6958000
74122	1394	227523493000000
74123	1394	227523534000000
74132	1397	1337339868000
74133	1678	20160708232000
74134	2134	97773331000
74135	1874	6971000
74136	1394	227523504000000
74178	1679	16774951853000
74179	1679	16774963853000
74180	1643	3128436114700
74181	1643	3128437114700
74199	1397	1337269861000
74200	1678	20160708239000
74201	1397	1337259860000
74202	1678	20160708240000
74203	2134	97766310000
74204	1874	7006000
74205	2133	97731468000
74206	1874	7008000
74207	2133	97730466000
74208	1874	7010000
74209	2134	97765307000
74210	1874	7013000
74211	1654	16845140999798
74212	1654	16845164999798
74340	1692	24260137619999
74341	1692	24260149619999
74345	1397	1337209855000
74346	1678	20160708245000
74347	2133	97725456000
74348	1874	7035000
74349	2134	97760292000
74350	1874	7038000
74351	1394	231843528000000
74352	1394	231843540000000
74355	1397	1337199854000
74356	1678	20160708246000
74357	2134	97759289000
74358	1874	7041000
74359	2133	97724454000
74360	1874	7043000
74361	1451	12138968000000
74362	1451	12138980000000
74389	1426	20445168000000
74392	1549	21935968000000
74415	1692	23540147619999
74416	1692	24260147619999
74417	1692	24260148619999
74550	1397	1337119846000
74551	1678	20160708254000
74552	2134	97751265000
74553	1874	7074000
74561	1657	12961410000000
74569	1397	1337089843000
74570	1678	20160708257000
74571	1397	1337079842000
74572	1678	20160708258000
74573	2134	97748256000
74574	1874	7083000
74575	2134	97747253000
74576	1874	7086000
74577	1471	19339798900000
74578	1471	19339820900000
74591	1397	1337049839000
74592	1678	20160708261000
74593	2134	97744244000
74594	1874	7095000
74600	1397	1337039838000
74601	1678	20160708262000
74602	2134	97743241000
74603	1874	7098000
74604	1395	58065744917007706
74605	1395	58065744928007706
74707	1397	1336929827000
74708	1678	20160708273000
74709	2134	97732208000
74710	1874	7131000
74711	1593	17830214000000
74712	1593	17830225000000
74714	1726	114425109000
74715	2170	200000000
74716	1397	1336919826000
74717	1678	20160708274000
73918	1874	6830000
73919	1874	6832000
73920	1874	6840000
73921	1874	6842000
73922	1874	6847000
73923	1874	6850000
73924	1874	6859000
73925	1874	6862000
73926	1874	6865000
73927	1874	6870000
73928	1874	6872000
73929	1874	6875000
73930	338	66720154000000
73939	43	78960801890000
73940	43	78960813890000
73943	1397	1337499884000
73944	1678	20160708216000
73945	2133	97754514000
73946	1874	6893000
73947	2134	97788376000
73948	1874	6896000
73949	1688	49032012708000
73950	1688	49032024708000
73984	1395	58064304919007706
73986	1397	1337449879000
73987	1678	20160708221000
73988	1397	1337439878000
73989	1678	20160708222000
73990	2133	97749504000
73991	1874	6918000
73992	2133	97748502000
73993	1874	6920000
73994	2134	97783361000
73995	1874	6923000
73996	2134	97782358000
73997	1874	6926000
73998	1601	12170268620000
73999	1601	12170292620000
74011	1874	6929000
74012	1764	12966957100000
74024	1688	49752024708000
74025	1688	49752047708000
74043	1874	6860000
74044	1874	6882000
74045	1874	6884000
74046	1874	6888000
74047	1874	6890000
74048	2133	97743492000
74049	1874	6894000
74050	1439	12532488998477
74063	1397	1337389873000
74064	1678	20160708227000
74065	1874	6904000
74066	1874	6907000
74067	1874	6910000
74068	1874	6913000
74069	1874	6919000
74070	1874	6922000
74071	1874	6925000
74072	2134	97777343000
74073	1673	23365484000000
74074	1673	23365604000000
74095	1874	6949000
74096	1685	119522452571430
74097	1685	119522463571430
74146	1704	4386316000000
74156	1395	58064304895007706
74159	1397	1337309865000
74160	1678	20160708235000
74161	2133	97735476000
74162	1874	6985000
74163	2134	97770322000
74164	1874	6988000
74165	1394	228963504000000
74166	1394	228963516000000
74169	1397	1337299864000
74170	1678	20160708236000
74171	2134	97769319000
74172	1874	6991000
74173	2133	97734474000
74174	1874	6993000
74175	1696	14897414835100
74214	1611	28071002000000
74215	1611	28071026000000
74224	1670	19441149000000
74225	1670	19441161000000
74325	1397	1337229857000
74326	1678	20160708243000
74327	2133	97727460000
74328	1874	7025000
74329	2134	97762298000
74330	1874	7028000
74331	1690	120243802000000
74332	1690	120243814000000
74390	1457	16464366040000
74391	1457	16464418040000
74554	1474	13953424000023
74555	1474	13953446000023
74589	632	71901166000000
74590	632	71901188000000
74597	1594	17185314000000
74663	1395	58066464928007706
74664	1395	58066464939007706
74665	1397	1337009835000
74666	1678	20160708265000
74667	1397	1336999834000
74668	1678	20160708266000
74669	1397	1336989833000
74670	1678	20160708267000
74671	1397	1336979832000
74672	1678	20160708268000
74673	1397	1336969831000
74674	1678	20160708269000
74675	2134	97740232000
74676	1874	7107000
74677	2134	97739229000
74678	1874	7110000
74679	2134	97738226000
74680	1874	7113000
74681	2134	97737223000
74682	1874	7116000
74683	2134	97736220000
74684	1874	7119000
74685	1727	16027202000000
74686	1727	16027257000000
74689	1397	1336959830000
74690	1678	20160708270000
74691	2134	97735217000
74692	1874	7122000
74722	1623	52562632899898
74730	641	80020044000000
74775	1397	1336809815000
74776	1678	20160708285000
74777	1397	1336799814000
74778	1678	20160708286000
74779	2134	97720172000
74780	1874	7167000
74781	2134	97719169000
74782	1874	7170000
74783	1710	19674716473290
74784	1710	19674738473290
74819	45	15120809999889
74820	1759	66000000001300
74833	1689	14400499287625
74834	1689	14400519287625
74838	1397	1336719806000
74839	1678	20160708294000
74840	2134	97711145000
74841	1874	7194000
74842	1394	234723551000000
74843	1394	234723562000000
74873	2087	4319081000000
74874	2087	4319103000000
74876	1397	1336649799000
74877	1678	20160708301000
74878	1397	1336639798000
74879	1678	20160708302000
74880	2134	97704124000
74881	1874	7215000
74882	2134	97703121000
74883	1874	7218000
74905	1397	1336609795000
74906	1678	20160708305000
74907	2133	97719444000
74908	1874	7229000
74909	1394	237603584000000
74910	1394	237603595000000
74925	1397	1336579792000
74926	1678	20160708308000
74927	1397	1336569791000
74928	1678	20160708309000
74929	2134	97698106000
74930	1874	7242000
74931	2133	97716438000
74932	1874	7244000
74933	2133	97715436000
74934	1874	7246000
74935	2134	97697103000
74936	1874	7249000
74937	2132	148691692000
74938	1874	7250000
74939	1535	1440051000000
74940	1535	1440076000000
74966	1397	1336539788000
74967	1678	20160708312000
74014	1513	28081396000000
74015	1513	28801396000000
74034	1992	12960220990000
74035	1992	13680220990000
74036	1992	13680650990000
74075	1695	13292815000000
74076	1693	4729992533343
74077	1693	4647017344970
74078	1693	4564042156597
74079	1693	3431520676097
74080	1693	3348545487724
74081	1693	3265570299351
74082	1693	3182595110978
74083	1693	3099619922605
74084	1693	2713918694189
74085	1693	2630943505816
74086	1693	2547968317443
74087	1693	2464993129070
74088	1693	2382017940697
74089	1693	2299042752324
74090	1693	2216067563951
74091	1693	2133092375578
74092	1693	2050117187205
74093	1695	14012815000000
74094	1695	14013715000000
74098	2134	97776340000
74099	1874	6952000
74100	2134	97775337000
74101	1874	6955000
74102	1394	226083493000000
74147	1747	7216921000000
74148	1506	12961245967172
74157	1688	50472047708000
74158	1688	50472059708000
74167	1685	120242463571430
74168	1685	120242475571430
74176	58	87546588999641
74177	58	87546600999641
74190	1397	1337279862000
74191	1678	20160708238000
74192	2134	97767313000
74193	1874	7001000
74194	2133	97732470000
74195	1874	7003000
74196	2112	4319049000000
74197	2112	4319061000000
74226	369	81941434000000
74333	1692	23540137619999
74373	1726	119265109000
74374	2166	200000000
74375	1397	1337179852000
74376	1678	20160708248000
74377	1726	118055109000
74378	2167	200000000
74379	1726	116845109000
74380	2168	200000000
74381	1726	115635109000
74382	2169	200000000
74383	2133	97722450000
74384	1874	7051000
74385	2134	97757283000
74386	1874	7054000
74387	1394	233283540000000
74388	1394	233283592000000
74408	1397	1337139848000
74409	1678	20160708252000
74410	1395	58064304916007706
74411	2134	97753271000
74412	1874	7068000
74413	1395	58065024916007706
74414	1395	58065024917007706
74541	1397	1337129847000
74542	1678	20160708253000
74543	2134	97752268000
74544	1874	7071000
74545	369	82661434000000
74546	369	82661445000000
74556	1397	1337109845000
74557	1678	20160708255000
74558	2134	97750262000
74559	1874	7077000
74560	1693	1579209758018
74568	1395	58065024906007706
74598	1684	19440565880623
74599	1684	19440576880623
74611	1695	14014065000000
74612	1678	19440672132000
74613	1678	19440672133000
74614	1678	19440672134000
74615	1678	19440672135000
74616	1678	19440672136000
74617	1678	19440672137000
74618	1678	19440672138000
74619	1678	19440672139000
74620	1678	19440672140000
74621	1678	19440672141000
74622	1678	19440672142000
74623	1678	19440672143000
74624	1678	19440672144000
74625	1678	19440672145000
74626	1678	19440672146000
74627	1678	19440672147000
74628	1678	19440672148000
74629	1678	19440672149000
74630	1678	19440672150000
74631	1678	19440672151000
74632	1678	19440672152000
74633	1678	19440672153000
74634	1678	19440672154000
74635	1678	19440672155000
74636	1678	19440672156000
74637	1678	19440672157000
74638	1678	19440672158000
74639	1678	19440672159000
74640	1678	19440672160000
74641	1678	19440672161000
74642	1678	19440672162000
74643	1678	19440672163000
74644	1678	19440672164000
74645	1678	19440672165000
74646	1678	19440672166000
74647	1678	19440672167000
74648	1678	19440672168000
74649	1678	19440672169000
74650	1678	19440672170000
74651	1678	19440672171000
74652	1678	19440672172000
74653	1678	19440672173000
74654	1678	19440672174000
74655	1695	14734065000000
74656	1695	14734965000000
74687	1933	2283214000000
74688	1933	2283269000000
74701	1397	1336939828000
74702	1678	20160708272000
74703	2134	97733211000
74704	1874	7128000
74705	1395	58067184939007706
74706	1395	58067184950007706
74723	1397	1336909825000
74724	1678	20160708275000
74725	2134	97730202000
74726	1874	7137000
74734	1397	1336899824000
74735	1678	20160708276000
74736	1397	1336889823000
74737	1678	20160708277000
74738	1397	1336879822000
74739	1678	20160708278000
74740	1397	1336869821000
74741	1678	20160708279000
74742	1397	1336859820000
74743	1678	20160708280000
74744	1397	1336849819000
74745	1678	20160708281000
74746	1397	1336839818000
74747	1678	20160708282000
74748	1397	1336829817000
74749	1678	20160708283000
74750	2134	97729199000
74751	1874	7140000
74752	2134	97728196000
74753	1874	7143000
74754	2134	97727193000
74755	1874	7146000
74756	2134	97726190000
74757	1874	7149000
74758	2134	97725187000
74759	1874	7152000
74760	2134	97724184000
74761	1874	7155000
74762	2134	97723181000
74763	1874	7158000
74764	2134	97722178000
74765	1874	7161000
74766	1564	11346523000000
74768	1397	1336819816000
74769	1678	20160708284000
74770	2134	97721175000
74771	1874	7164000
74772	1610	14400431000000
74785	632	72621188000000
74786	632	72621210000000
74793	1397	1336779812000
74794	1678	20160708288000
74277	1693	4926498557661
74278	1693	4843523369288
74279	1693	4760548180915
74280	1693	4754252939379
74281	1693	4671277751006
74282	1693	4668753654398
74283	1693	4585778466025
74284	1693	4502803277652
74285	1693	4117102049236
74286	1693	4034126860863
74287	1693	4009981533343
74288	1693	3927006344970
74289	1693	3844031156597
74290	1693	2711509676097
74291	1693	2628534487724
74292	1693	2545559299351
74293	1693	2462584110978
74294	1693	2379608922605
74295	1693	1993907694189
74296	1693	1910932505816
74297	1678	18720659988000
74298	1678	18720659989000
74299	1678	18720659990000
74300	1678	18720659991000
74301	1678	18720659992000
74302	1678	18720659993000
74303	1678	18720659994000
74304	1678	18720659995000
74305	1678	18720659996000
74306	1678	18720659997000
74307	1678	18720659998000
74308	1678	18720659999000
74309	1678	18720660000000
74310	1678	18720660001000
74311	1678	18720660002000
74312	1678	18720660003000
74313	1678	18720660004000
74314	1678	18720660005000
74315	369	81942102000000
74316	369	81942852000000
74317	1397	1337239858000
74318	1678	20160708242000
74319	2134	97763301000
74320	1874	7021000
74321	2133	97728462000
74322	1874	7023000
74323	1719	15140596000000
74324	1719	15140608000000
74334	1397	1337219856000
74335	1678	20160708244000
74336	2133	97726458000
74337	1874	7030000
74338	2134	97761295000
74339	1874	7033000
74342	1613	15768191600000
74343	1613	16488191600000
74344	1613	16489241600000
74353	606	76797840812962
74354	606	76797852812962
74363	1726	120475109000
74364	2165	200000000
74365	1397	1337189853000
74366	1678	20160708247000
74367	2132	148693694000
74368	1874	7044000
74369	2134	97758286000
74370	1874	7047000
74371	2133	97723452000
74372	1874	7049000
74393	1397	1337169851000
74394	1678	20160708249000
74395	1397	1337159850000
74396	1678	20160708250000
74397	1397	1337149849000
74398	1678	20160708251000
74399	2134	97756280000
74400	1874	7057000
74401	2134	97755277000
74402	1874	7060000
74403	2134	97754274000
74404	1874	7063000
74405	2133	97721448000
74406	1874	7065000
74407	2039	16561478000000
74418	1678	18720660006000
74419	1678	18720660007000
74420	1678	18720660008000
74421	1678	18720660009000
74422	1678	18720660010000
74423	1678	18720660011000
74424	1678	18720660012000
74425	1678	18720660013000
74426	1678	18720660014000
74427	1678	18720660015000
74428	1678	18720660016000
74429	1678	18720660017000
74430	1678	18720660018000
74431	1678	18720660019000
74432	1678	18720660020000
74433	1678	18720660021000
74434	1678	18720660022000
74435	1678	18720660023000
74436	1678	18720660024000
74437	1678	18720660025000
74438	1678	18720660026000
74439	1678	18720660027000
74440	1678	18720660028000
74441	1678	18720660029000
74442	1678	18720660030000
74443	1678	18720660031000
74444	1678	18720660032000
74445	1678	18720660033000
74446	1678	18720660034000
74447	1678	18720660035000
74448	1678	18720660036000
74449	1678	18720660037000
74450	1678	18720660038000
74451	1678	18720660039000
74452	1678	18720660040000
74453	1678	18720660041000
74454	1678	18720660042000
74455	1678	18720660043000
74456	1678	18720660044000
74457	1678	18720660045000
74458	1678	18720660046000
74459	1678	18720660047000
74460	1678	18720660048000
74461	1678	18720660049000
74462	1678	18720660050000
74463	369	81943352000000
74464	1678	18720660051000
74465	1678	18720660052000
74466	1678	18720660053000
74467	1678	18720660054000
74468	1678	18720660055000
74469	1678	18720660056000
74470	1678	18720660057000
74471	1678	18720660058000
74472	1678	18720660059000
74473	1678	18720660060000
74474	1678	18720660061000
74475	1678	18720660062000
74476	1678	18720660063000
74477	1678	18720660064000
74478	1678	18720660065000
74479	1678	18720660066000
74480	1678	18720660067000
74481	1678	18720660068000
74482	1678	18720660069000
74483	1678	18720660070000
74484	1678	18720660071000
74485	1678	18720660072000
74486	1678	18720660073000
74487	1678	18720660074000
74488	1678	18720660075000
74489	1678	18720660076000
74490	1678	18720660077000
74491	1678	18720660078000
74492	1678	18720660079000
74493	1678	18720660080000
74494	1678	18720660081000
74495	1678	18720660082000
74496	1678	18720660083000
74497	1678	18720660084000
74498	1678	18720660085000
74499	1678	18720660086000
74500	1678	18720660087000
74501	1678	18720660088000
74502	1678	18720660089000
74503	1678	18720660090000
74504	1678	18720660091000
74505	1678	18720660092000
74506	1678	18720660093000
74507	1678	18720660094000
74508	1678	18720660095000
74509	1678	18720660096000
74510	1678	18720660097000
74511	1678	18720660098000
74512	1678	18720660099000
74513	1678	18720660100000
74514	1678	18720660101000
74515	1678	18720660102000
74516	1678	18720660103000
74517	1678	18720660104000
74518	1678	18720660105000
74519	1678	18720660106000
74520	1678	18720660107000
74521	1678	18720660108000
74522	1678	18720660109000
74523	1678	18720660110000
74524	1678	18720660111000
74525	1678	18720660112000
74526	1678	18720660113000
74527	1678	18720660114000
74528	1678	18720660115000
74529	1678	18720660116000
74530	1678	18720660117000
74531	1678	18720660118000
74532	1678	18720660119000
74533	1678	18720660120000
74534	1678	18720660121000
74535	1678	18720660122000
74536	1678	18720660123000
74537	1678	18720660124000
74538	1678	18720660125000
74539	369	82663352000000
74540	369	82664102000000
74547	1874	6994000
74548	1756	6913109545609
74549	1756	6913160545609
74562	1749	6325303930000
74563	1397	1337099844000
74564	1678	20160708256000
74565	2134	97749259000
74566	1874	7080000
74567	1394	233283551000000
74579	1397	1337069841000
74580	1678	20160708259000
74581	1397	1337059840000
74582	1678	20160708260000
74583	2134	97746250000
74584	1874	7089000
74585	2134	97745247000
74586	1874	7092000
74587	1719	15860608000000
74588	1719	15860630000000
74595	1489	15024387000000
74596	1489	15024398000000
74606	1397	1337029837000
74607	1678	20160708263000
74608	2134	97742238000
74609	1874	7101000
74610	1695	14012296000000
74657	1397	1337019836000
74658	1678	20160708264000
74659	2134	97741235000
74660	1874	7104000
74661	1723	18359504085979
74662	1723	18359515085979
74693	1874	7019000
74694	1709	12240228999976
74695	1397	1336949829000
74696	1678	20160708271000
74697	2134	97734214000
74698	1874	7125000
74699	1471	20059820900000
74700	1471	20059831900000
74713	1560	16434368277001
74787	1397	1336789813000
74788	1678	20160708287000
74789	2134	97718166000
74790	1874	7173000
74791	1601	12890292620000
74792	1601	12890303620000
74812	1397	1336739808000
74813	1678	20160708292000
74814	2134	97713151000
74815	1874	7188000
74816	1759	15120808999999
74817	45	15120819999979
74818	1759	66000000001310
74822	1633	13716660985638
74823	1633	200000100
74824	1849	13716666985538
74825	349	67440035000000
74831	1709	12960228999976
74832	1709	12960238999976
74848	1397	1336699804000
74849	1678	20160708296000
74850	2134	97709139000
74851	1874	7200000
74862	1756	7633160545609
74863	1756	7633170545609
74864	1397	1336669801000
74865	1678	20160708299000
74866	1397	1336659800000
74867	1678	20160708300000
74868	2134	97706130000
74869	1874	7209000
74870	2134	97705127000
74871	1874	7212000
74872	2086	2879089000000
74917	1992	14399322990000
74918	1992	14399334990000
74948	1874	7132000
74949	1874	7136000
74950	1874	7138000
74951	1874	7142000
74952	1874	7144000
74953	1874	7145000
74954	2132	148690691000
74955	1874	7148000
74956	2133	97713432000
74957	1874	7150000
74958	1448	7956772000001
75012	484	70748781000000
75013	484	70748815000000
75054	1874	7310000
75055	1874	7313000
75056	1764	12966980100000
75057	1633	12996670985638
75058	1764	13686970100000
75066	1693	859221758018
75067	1693	1579221758018
75068	1693	1579223758018
75071	1397	1336429777000
75072	1678	20160708323000
75073	1397	1336419776000
75074	1678	20160708324000
75075	2133	97701408000
75076	1874	7321000
75077	2133	97700406000
75078	1874	7323000
75079	2134	97683061000
75080	1874	7326000
75081	2134	97682058000
75082	1874	7329000
75083	1394	239043595000000
75084	1394	239043619000000
75100	1673	23365694000000
75101	1673	24085694000000
75102	1673	67440013050000
75103	75	24086293950000
75110	1451	12858980000000
75111	1451	12858992000000
75119	1397	1336379772000
75120	1678	20160708328000
75121	2134	97678046000
75122	1874	7348000
75123	2133	97696398000
75124	1874	7350000
75125	2132	148685686000
75126	1874	7351000
75127	1509	15791942851155
75128	1397	1336369771000
75129	1678	20160708329000
75130	1397	1336359770000
75131	1678	20160708330000
75132	1397	1336349769000
75133	1678	20160708331000
75134	1397	1336339768000
75135	1678	20160708332000
75136	2133	97695396000
75137	1874	7353000
75138	2133	97694394000
75139	1874	7355000
75140	2133	97693392000
75141	1874	7357000
75142	2134	97677043000
75143	1874	7360000
75144	2134	97676040000
75145	1874	7363000
75146	2134	97675037000
75147	1874	7366000
75148	2134	97674034000
75149	1874	7369000
75150	2132	148684685000
75151	1874	7370000
75152	1394	239043643000000
75172	1559	14362766000000
75203	633	83164110900000
75204	633	83164135900000
75243	1692	26420207619999
75244	1692	26420258619999
75257	1397	1336209755000
75258	1678	20160708345000
75259	1397	1336199754000
75260	1678	20160708346000
75261	1397	1336189753000
75262	1678	20160708347000
74718	2134	97731205000
74719	1874	7134000
74720	1696	15617414835100
74721	1696	15617435835100
74727	1874	6675000
74728	641	80020033000000
74729	641	80020105000000
74731	1874	6624000
74732	1571	22320465001024
74733	1571	22320536001024
74767	1705	12155623500145
74773	1395	58067904950007706
74774	1395	58067904961007706
74821	1759	15120819999999
74826	1397	1336729807000
74827	1678	20160708293000
74828	2134	97712148000
74829	1874	7191000
74830	1709	12240198999976
74836	1691	15083198100019
74837	1691	15083209100019
74852	1397	1336689803000
74853	1678	20160708297000
74854	1397	1336679802000
74855	1678	20160708298000
74856	2134	97708136000
74857	1874	7203000
74858	2134	97707133000
74859	1874	7206000
74860	1394	236163562000000
74861	1394	236163584000000
74900	1685	120242497571430
74903	1271	1346286388000000
74904	1271	1346286422000000
74911	1397	1336599794000
74912	1678	20160708306000
74913	2133	97718442000
74914	1874	7231000
74915	2134	97700112000
74916	1874	7234000
74941	1397	1336559790000
74942	1678	20160708310000
74943	2134	97696100000
74944	1874	7253000
74945	2133	97714434000
74946	1874	7255000
74947	1637	205205585819988
74965	2106	3599072000000
74997	1397	1336499784000
74998	1678	20160708316000
74999	329	67444612000000
75000	1397	1336489783000
75001	1678	20160708317000
75002	2134	97690082000
75003	1874	7285000
75004	2134	97689079000
75005	1874	7288000
75006	2133	97708422000
75007	1874	7290000
75008	2133	97707420000
75009	1874	7292000
75010	1850	13599027000000
75011	1850	13599061000000
75037	1397	1336449779000
75038	1678	20160708321000
75039	1397	1336439778000
75040	1678	20160708322000
75041	2134	97685067000
75042	1874	7311000
75043	2134	97684064000
75044	1874	7314000
75045	2133	97703412000
75046	1874	7316000
75047	1690	119523825000000
75048	2132	148687688000
75049	1874	7317000
75050	2133	97702410000
75051	1874	7319000
75052	1690	120243825000000
75053	1690	120243827000000
75070	1764	13686980100000
75087	1724	9307365000000
75104	1397	1336399774000
75105	1678	20160708326000
75106	2134	97680052000
75107	1874	7338000
75108	2133	97698402000
75109	1874	7340000
75188	1397	1336289763000
75189	1678	20160708337000
75190	1397	1336279762000
75191	1678	20160708338000
75192	2134	97669019000
75193	1874	7394000
75194	2133	97688382000
75195	1874	7396000
75196	2133	97687380000
75197	1874	7398000
75198	2132	148682683000
75199	1874	7399000
75200	2134	97668016000
75201	1874	7402000
75202	1394	240483668000000
75255	1686	16772158550062
75256	1686	16772171550062
75296	1599	14740241393047
75383	1397	1336059740000
75384	1678	20160708360000
75385	2134	97646953000
75386	1874	7513000
75387	2133	97665336000
75388	1874	7515000
75389	1394	244803693000000
75390	1394	244803705000000
75405	1691	15083212100019
75441	2134	97639932000
75442	1874	7550000
75443	2133	97658322000
75444	1874	7552000
75445	1672	21602156000000
75447	2134	97638929000
75448	1874	7555000
75449	2132	148673674000
75450	1874	7556000
75451	2133	97657320000
75452	1874	7558000
75453	1476	17280304000000
75454	1476	17280307000000
75475	1397	1335999734000
75476	1678	20160708366000
75477	2132	148672673000
75478	1874	7569000
75479	2133	97654314000
75480	1874	7571000
75481	2134	97635920000
75482	1874	7574000
75483	1394	244803706000000
75486	1397	1335989733000
75487	1678	20160708367000
75488	2133	97653312000
75489	1874	7576000
75490	2134	97634917000
75491	1874	7579000
75492	1395	58070785045007706
75519	1397	1335949729000
75520	1678	20160708371000
75521	2133	97649304000
75522	1874	7597000
75523	2134	97630905000
75524	1874	7600000
75529	1397	1335939728000
75530	1678	20160708372000
75531	1397	1335929727000
75532	1678	20160708373000
75533	2132	148670671000
75534	1874	7601000
75535	2133	97648302000
75536	1874	7603000
75537	2133	97647300000
75538	1874	7605000
75539	2134	97629902000
75540	1874	7608000
75541	2134	97628899000
75542	1874	7611000
75543	1850	15039073000000
75544	1850	15039098000000
75563	470	80400461000000
75564	470	80400485000000
75570	1685	120962475571430
75571	1685	120962499571430
75572	1397	1335899724000
75573	1678	20160708376000
75574	2132	148669670000
75575	1874	7624000
75576	2134	97625890000
75577	1874	7627000
75578	1546	15120954000000
75579	1546	15120967000000
75587	1688	51192085708000
75604	1397	1335869721000
75605	1678	20160708379000
75606	2118	1398000000
75607	2133	97641288000
75608	1874	7639000
75609	2134	97622881000
74795	2134	97717163000
74796	1874	7176000
74797	1457	16464377040000
74798	1397	1336769811000
74799	1678	20160708289000
74800	1397	1336759810000
74801	1678	20160708290000
74802	1397	1336749809000
74803	1678	20160708291000
74804	2134	97716160000
74805	1874	7179000
74806	2134	97715157000
74807	1874	7182000
74808	2134	97714154000
74809	1874	7185000
74810	1395	58068624961007706
74811	1395	58068624994007706
74835	1689	14400520287625
74844	1397	1336709805000
74845	1678	20160708295000
74846	2134	97710142000
74847	1874	7197000
74875	1701	12310420600056
74884	1726	113215109000
74885	2171	200000000
74886	1397	1336629797000
74887	1678	20160708303000
74888	1397	1336619796000
74889	1678	20160708304000
74890	2132	148692693000
74891	1874	7219000
74892	2134	97702118000
74893	1874	7222000
74894	2133	97720446000
74895	1874	7224000
74896	2134	97701115000
74897	1874	7227000
74898	1672	21602154000000
74899	1672	21602188000000
74901	1759	15840809999889
74902	1759	15840843999889
74919	1397	1336589793000
74920	1678	20160708307000
74921	2133	97717440000
74922	1874	7236000
74923	2134	97699109000
74924	1874	7239000
74959	1397	1336549789000
74960	1678	20160708311000
74961	2134	97695097000
74962	1874	7258000
74963	1874	7260000
74964	1874	7261000
74980	338	66720014000000
74981	1397	1336519786000
74982	1678	20160708314000
74983	1397	1336509785000
74984	1678	20160708315000
74985	2133	97710426000
74986	1874	7273000
74987	2134	97692088000
74988	1874	7276000
74989	2134	97691085000
74990	1874	7279000
74991	2133	97709424000
74992	1874	7281000
74993	2132	148689690000
74994	1874	7282000
74995	1637	205925585819988
74996	1637	205925620819988
75014	1789	712990000000
75015	1397	1336479782000
75016	1678	20160708318000
75017	1397	1336469781000
75018	1678	20160708319000
75019	1397	1336459780000
75020	1678	20160708320000
75021	2134	97688076000
75022	1874	7295000
75023	2134	97687073000
75024	1874	7298000
75025	2132	148688689000
75026	1874	7299000
75027	2133	97706418000
75028	1874	7301000
75029	2133	97705416000
75030	1874	7303000
75031	2133	97704414000
75032	1874	7305000
75033	2134	97686070000
75034	1874	7308000
75035	1692	24980148619999
75036	1692	24980195619999
75062	1724	8587364000000
75063	1724	9307364000000
75064	1724	66000000600200
75065	167	9307365500000
75069	1724	9307366000000
75085	1724	9307341000000
75086	167	9307364500000
75098	1762	18322013994000
75099	1762	18322026994000
75112	1397	1336389773000
75113	1678	20160708327000
75114	2134	97679049000
75115	1874	7343000
75116	2133	97697400000
75117	1874	7345000
75118	1668	18686780000000
75155	1602	14400550000000
75170	1394	240483643000000
75171	1394	240483655000000
75173	1397	1336309765000
75174	1678	20160708335000
75175	1397	1336299764000
75176	1678	20160708336000
75177	2133	97690386000
75178	1874	7382000
75179	2132	148683684000
75180	1874	7383000
75181	2133	97689384000
75182	1874	7385000
75183	2134	97671025000
75184	1874	7388000
75185	2134	97670022000
75186	1874	7391000
75187	1455	7954049000000
75205	1397	1336269761000
75206	1678	20160708339000
75207	2134	97667013000
75208	1874	7405000
75209	2133	97686378000
75210	1874	7407000
75211	1692	25700195619999
75212	1692	25700207619999
75213	1397	1336259760000
75214	1678	20160708340000
75215	1397	1336249759000
75216	1678	20160708341000
75217	1397	1336239758000
75218	1678	20160708342000
75219	1397	1336229757000
75220	1678	20160708343000
75221	2131	199000000
75222	2131	198000000
75223	2134	97666010000
75224	1874	7410000
75225	2133	97685376000
75226	1874	7412000
75227	2133	97684374000
75228	1874	7414000
75229	2134	97665007000
75230	1874	7417000
75231	2134	97664004000
75232	1874	7420000
75233	2134	97663001000
75234	1874	7423000
75235	2132	148681682000
75236	1874	7424000
75237	2133	97683372000
75238	1874	7426000
75239	2133	97682370000
75240	1874	7428000
75241	1395	58069344994007706
75242	1395	58069345045007706
75245	1397	1336219756000
75246	1678	20160708344000
75247	2133	97681368000
75248	1874	7430000
75249	2131	196999000
75250	1726	113215110000
75251	2134	97661998000
75252	1874	7433000
75253	1394	241923668000000
75254	1394	241923681000000
75298	1397	1336159750000
75299	1678	20160708350000
75300	1397	1336149749000
75301	1678	20160708351000
75302	2134	97655980000
75303	1874	7463000
75304	2133	97675356000
75305	1874	7465000
75306	2132	148678679000
75307	1874	7466000
74968	1397	1336529787000
74969	1678	20160708313000
74970	2133	97712430000
74971	1874	7263000
74972	2133	97711428000
74973	1874	7265000
74974	2134	97694094000
74975	1874	7268000
74976	2134	97693091000
74977	1874	7271000
74978	1419	27819576280064
74979	1419	27819600280064
75059	1874	7312000
75060	1764	13686957100000
75061	1764	13686959100000
75088	1397	1336409775000
75089	1678	20160708325000
75090	2134	97681055000
75091	1874	7332000
75092	2132	148686687000
75093	1874	7333000
75094	2133	97699404000
75095	1874	7335000
75096	1593	18550225000000
75097	1593	18550238000000
75153	1649	22604297999992
75154	1649	22604345999992
75156	1397	1336329767000
75157	1678	20160708333000
75158	2134	97673031000
75159	1874	7373000
75160	2133	97692390000
75161	1874	7375000
75162	1850	14319061000000
75163	1850	14319073000000
75164	1397	1336319766000
75165	1678	20160708334000
75166	2134	97672028000
75167	1874	7378000
75168	2133	97691388000
75169	1874	7380000
75279	149	83550251000341
75280	149	83550288000341
75289	1397	1336169751000
75290	1678	20160708349000
75291	2133	97676358000
75292	1874	7457000
75293	2134	97656983000
75294	1874	7460000
75295	1611	28071014000000
75297	576	80915861938283
75319	1397	1336129747000
75320	1678	20160708353000
75321	2134	97653974000
75322	1874	7476000
75323	2133	97672350000
75324	1874	7478000
75325	1394	243363681000000
75326	1394	243363693000000
75336	1690	121683864000000
75337	1690	121683876000000
75355	1593	19270238000000
75356	1593	19270263000000
75358	2134	97649962000
75359	1874	7497000
75360	2133	97668342000
75361	1874	7499000
75362	1395	58069344996007706
75394	2133	97664334000
75395	1874	7517000
75396	2134	97645950000
75397	1874	7520000
75398	470	79680459000000
75456	1690	121683867000000
75484	1395	58070785033007706
75485	1395	58070785046007706
75507	1679	16774975853000
75508	1397	1335959730000
75509	1678	20160708370000
75510	2133	97650306000
75511	1874	7591000
75512	2134	97631908000
75513	1874	7594000
75514	2132	148671672000
75515	1874	7595000
75516	1708	12275828000021
75527	1684	19440577880623
75545	1397	1335919726000
75546	1678	20160708374000
75547	1397	1335909725000
75548	1678	20160708375000
75549	2133	97646298000
75550	1874	7613000
75551	2133	97645296000
75552	1874	7615000
75553	1694	20892680127629
75554	1694	20892702127629
75566	1662	1440020000000
75582	1874	7626000
75583	1546	15120966000000
75594	1762	19042026994000
75595	1762	19042038994000
75620	1704	3666493000000
75621	1726	112005109000
75622	1704	4386493000000
75623	1704	4387553000000
75641	484	70748793000000
75654	1611	28791014000000
75655	1611	28791027000000
75656	1397	1335819716000
75657	1678	20160708384000
75658	2133	97636278000
75659	1874	7663000
75660	2134	97618869000
75661	1874	7666000
75662	369	83381445000000
75663	369	83381457000000
75685	1397	1335809715000
75686	1678	20160708385000
75687	1397	1335799714000
75688	1678	20160708386000
75689	2133	97635276000
75690	1874	7668000
75691	2132	148666667000
75692	1874	7669000
75693	2133	97634274000
75694	1874	7671000
75695	2134	97617866000
75696	1874	7674000
75697	2134	97616863000
75698	1874	7677000
75699	1394	246243732000000
75700	1397	1335789713000
75701	1678	20160708387000
75702	1397	1335779712000
75703	1678	20160708388000
75704	1397	1335769711000
75705	1678	20160708389000
75706	2134	97615860000
75707	1874	7680000
75708	2133	97633272000
75709	1874	7682000
75710	2133	97632270000
75711	1874	7684000
75712	2133	97631268000
75713	1874	7686000
75714	2134	97614857000
75715	1874	7689000
75716	2134	97613854000
75717	1874	7692000
75718	1587	21600668000000
75719	1587	21600704000000
75720	1458	18813737908540
75745	1397	1335729707000
75746	1678	20160708393000
75747	2134	97609842000
75748	1874	7711000
75749	2132	148664665000
75750	1874	7712000
75751	2133	97627260000
75752	1874	7714000
75753	1622	19980428000005
75795	1394	246243743000000
75796	1394	247683743000000
75797	1394	247683744000000
75817	1397	1335649699000
75818	1678	20160708401000
75819	1397	1335639698000
75820	1678	20160708402000
75821	2133	97619244000
75822	1874	7753000
75823	2133	97618242000
75824	1874	7755000
75825	2134	97601818000
75826	1874	7758000
75827	2134	97600815000
75828	1874	7761000
75829	1657	13681412000000
75830	1657	13681436000000
75845	171	78950437524688
75846	171	78950452524688
75861	1874	7489000
75862	1874	7493000
75863	1874	7495000
75864	1874	7496000
75263	2133	97680366000
75264	1874	7435000
75265	2132	148680681000
75266	1874	7436000
75267	2133	97679364000
75268	1874	7438000
75269	2133	97678362000
75270	1874	7440000
75271	2134	97660995000
75272	1874	7443000
75273	2134	97659992000
75274	1874	7446000
75275	2134	97658989000
75276	1874	7449000
75277	1690	120963827000000
75278	1690	120963864000000
75281	1397	1336179752000
75282	1678	20160708348000
75283	2132	148679680000
75284	1874	7450000
75285	2134	97657986000
75286	1874	7453000
75287	2133	97677360000
75288	1874	7455000
75311	1397	1336139748000
75312	1678	20160708352000
75313	2134	97654977000
75314	1874	7471000
75315	2133	97673352000
75316	1874	7473000
75317	1717	13788058000023
75318	1717	13788070000023
75375	1397	1336069741000
75376	1678	20160708359000
75377	2133	97666338000
75378	1874	7507000
75379	2134	97647956000
75380	1874	7510000
75381	1637	206645620819988
75382	1637	206645632819988
75393	1594	17185313000000
75412	1397	1336039738000
75413	1678	20160708362000
75414	1555	10275279979096
75415	1726	112005110000
75416	2174	200000000
75417	1397	1336029737000
75418	1678	20160708363000
75419	2134	97643944000
75420	1874	7529000
75421	2132	148674675000
75422	1874	7530000
75423	2134	97642941000
75424	1874	7533000
75425	2134	97641938000
75426	1874	7536000
75427	2133	97662330000
75428	1874	7538000
75429	2133	97661328000
75430	1874	7540000
75431	2133	97660326000
75432	1874	7542000
75433	1395	58070064996007706
75434	1395	58070065033007706
75446	2148	2159048000000
75455	1708	12275818000021
75467	1506	13681245967172
75468	1506	13681257967172
75493	1397	1335979732000
75494	1678	20160708368000
75495	1397	1335969731000
75496	1678	20160708369000
75497	2133	97652310000
75498	1874	7581000
75499	2133	97651308000
75500	1874	7583000
75501	2134	97633914000
75502	1874	7586000
75503	2134	97632911000
75504	1874	7589000
75505	1717	14508070000023
75506	1717	14508094000023
75525	1688	51192072708000
75526	1688	51192084708000
75565	1694	20892704127629
75580	1518	10800406000000
75581	1518	10800419000000
75588	1397	1335889723000
75589	1678	20160708377000
75590	2133	97643292000
75591	1874	7629000
75592	2134	97624887000
75593	1874	7632000
75613	1657	12961412000000
75614	1397	1335859720000
75615	1678	20160708380000
75616	2133	97640286000
75617	1874	7644000
75618	2132	148668669000
75619	1874	7645000
75625	1397	1335849719000
75626	1678	20160708381000
75627	2134	97621878000
75628	1874	7648000
75629	2133	97639284000
75630	1874	7650000
75631	1455	8674049000000
75632	1455	8674061000000
75633	1397	1335839718000
75634	1678	20160708382000
75635	2134	97620875000
75636	1874	7653000
75637	2133	97638282000
75638	1874	7655000
75639	2055	1439002000000
75640	2055	1439014000000
75652	1573	11499110000000
75653	1573	11499123000000
75664	1874	6625000
75665	2141	719012000000
75666	1567	101
75667	1874	6627000
75668	1874	6629000
75669	1874	6631000
75670	1874	6632000
75671	1874	6634000
75672	1874	6636000
75673	1874	6637000
75674	1874	6639000
75675	1874	6640000
75676	1874	6642000
75677	1874	6643000
75678	1874	6645000
75679	1874	6646000
75680	1874	6648000
75681	1874	6649000
75682	1571	22320608001024
75683	2171	1200000024
75684	1571	23039608001000
75732	1397	1335749709000
75733	1678	20160708391000
75734	2134	97611848000
75735	1874	7701000
75736	2133	97629264000
75737	1874	7703000
75738	641	80020045000000
75739	1397	1335739708000
75740	1678	20160708392000
75741	2133	97628262000
75742	1874	7705000
75743	2134	97610845000
75744	1874	7708000
75764	1397	1335709705000
75765	1678	20160708395000
75766	1397	1335699704000
75767	1678	20160708396000
75768	1397	1335689703000
75769	1678	20160708397000
75770	2133	97625256000
75771	1874	7721000
75772	2132	148663664000
75773	1874	7722000
75774	2134	97607836000
75775	1874	7725000
75776	2134	97606833000
75777	1874	7728000
75778	2134	97605830000
75779	1874	7731000
75780	2133	97624254000
75781	1874	7733000
75782	2133	97623252000
75783	1874	7735000
75784	1715	40320695000002
75785	1715	40320732000002
75786	1397	1335679702000
75787	1678	20160708398000
75788	2133	97622250000
75789	1874	7737000
75790	1467	10046761100039
75791	2134	97604827000
75792	1874	7740000
75793	1467	10766761100039
75794	1467	10766762100039
75843	1670	20881173000000
75844	1670	20881188000000
75308	2133	97674354000
75309	1874	7468000
75310	1608	16845701000000
75327	1395	58069345006007706
75328	1397	1336119746000
75329	1678	20160708354000
75330	2134	97652971000
75331	1874	7481000
75332	2133	97671348000
75333	1874	7483000
75334	1549	22655968000000
75335	1549	22655980000000
75338	1540	720012000000
75339	1397	1336109745000
75340	1678	20160708355000
75341	1397	1336099744000
75342	1678	20160708356000
75343	2133	97670346000
75344	1874	7485000
75345	2133	97669344000
75346	1874	7487000
75347	2132	148677678000
75348	1874	7488000
75349	2134	97651968000
75350	1874	7491000
75351	2134	97650965000
75352	1874	7494000
75353	1716	19486925000000
75354	1716	19486950000000
75357	1688	50472072708000
75363	1397	1336089743000
75364	1678	20160708357000
75365	1397	1336079742000
75366	1678	20160708358000
75367	2132	148676677000
75368	1874	7500000
75369	2133	97667340000
75370	1874	7502000
75371	2134	97648959000
75372	1874	7505000
75373	1714	13846431103056
75374	1714	13846454103056
75391	470	79680445000000
75392	470	79680457000000
75399	1397	1336049739000
75400	1678	20160708361000
75401	2118	1399000000
75402	2132	148675676000
75403	1874	7518000
75404	1874	7521000
75406	2133	97663332000
75407	1874	7519000
75408	1874	7523000
75409	2134	97644947000
75410	1874	7526000
75411	470	79680461000000
75435	2134	97640935000
75436	1874	7545000
75437	2133	97659324000
75438	1874	7547000
75439	1623	53282632899898
75440	1623	53282634899898
75457	1419	28539600280064
75458	1419	28539603280064
75459	1397	1336019736000
75460	1678	20160708364000
75461	2134	97637926000
75462	1874	7561000
75463	2133	97656318000
75464	1874	7563000
75465	1637	207365632819988
75466	1637	207365644819988
75469	1397	1336009735000
75470	1678	20160708365000
75471	2133	97655316000
75472	1874	7565000
75473	2134	97636923000
75474	1874	7568000
75517	1601	13610303620000
75518	1601	13610316620000
75528	1656	18141668999990
75555	2134	97627896000
75556	1874	7614000
75557	2134	97626893000
75558	1874	7617000
75559	1874	7619000
75560	1874	7621000
75561	1654	17565164999798
75562	1654	17565188999798
75567	2133	97644294000
75568	1874	7623000
75569	470	80400486000000
75584	1874	7620000
75585	1874	7622000
75586	1688	51192108708000
75596	1397	1335879722000
75597	1678	20160708378000
75598	2134	97623884000
75599	1874	7635000
75600	2133	97642290000
75601	1874	7637000
75602	1670	20161161000000
75603	1670	20161173000000
75624	1689	14400511287625
75642	632	73341210000000
75643	632	73341222000000
75721	1397	1335759710000
75722	1678	20160708390000
75723	2132	148665666000
75724	1874	7693000
75725	2134	97612851000
75726	1874	7696000
75727	2133	97630266000
75728	1874	7698000
75729	1394	247683732000000
75730	1394	247683745000000
75754	1395	58071505045007706
75755	1395	58071505058007706
75831	1874	7754000
75832	1874	7757000
75833	1657	13681434000000
75847	1874	7762000
75848	1670	20881186000000
75849	1397	1335619696000
75850	1678	20160708404000
75851	2134	97598809000
75852	1874	7770000
75853	2133	97616238000
75854	1874	7772000
75855	1395	58072225058007706
75856	1395	58072225070007706
75956	1397	1335539688000
75957	1678	20160708412000
75958	1397	1335529687000
75959	1678	20160708413000
75960	2133	97608222000
75961	1874	7811000
75962	2133	97607220000
75963	1874	7813000
75964	2132	148658659000
75965	1874	7814000
75966	2134	97590785000
75967	1874	7817000
75968	2134	97589782000
75969	1874	7820000
75970	369	84101457000000
75971	369	84101482000000
75975	1874	7803000
75976	1874	7806000
75977	1874	7812000
75978	470	80400507000000
75979	2133	97606218000
75980	1874	7822000
75981	2134	97588779000
75982	1874	7825000
75983	1394	249123757000000
75984	1394	249123759000000
75993	1402	57454694319298
75994	1397	1335519686000
75995	1678	20160708414000
75996	2133	97604214000
75997	1874	7832000
75998	2132	148657658000
75999	1874	7833000
76000	2133	97603212000
76001	1874	7835000
76002	2134	97586773000
76003	1874	7838000
76004	2134	97585770000
76005	1874	7841000
76006	1395	58072225073007706
76034	1397	1335479682000
76035	1678	20160708418000
76036	2133	97599204000
76037	1874	7859000
76038	2134	97581758000
76039	1874	7862000
76040	1394	250563759000000
76041	1394	250563771000000
75610	1874	7642000
75611	1394	246243706000000
75612	1394	246243719000000
75644	1397	1335829717000
75645	1678	20160708383000
75646	2132	148667668000
75647	1874	7656000
75648	2133	97637280000
75649	1874	7658000
75650	2134	97619872000
75651	1874	7661000
75731	1458	18813749908540
75756	1690	122403876000000
75757	1690	122403889000000
75758	1397	1335719706000
75759	1678	20160708394000
75760	2133	97626258000
75761	1874	7716000
75762	2134	97608839000
75763	1874	7719000
75798	1688	51192095708000
75799	1688	51912095708000
75800	1688	51912096708000
75801	1397	1335669701000
75802	1678	20160708399000
75803	1397	1335659700000
75804	1678	20160708400000
75805	2133	97621248000
75806	1874	7742000
75807	2133	97620246000
75808	1874	7744000
75809	2132	148662663000
75810	1874	7745000
75811	2134	97603824000
75812	1874	7748000
75813	2134	97602821000
75814	1874	7751000
75815	576	81635861938283
75816	576	81635886938283
75834	1397	1335629697000
75835	1678	20160708403000
75836	2132	148661662000
75837	2134	97599812000
75838	1874	7763000
75839	1874	7765000
75840	2133	97617240000
75841	1874	7767000
75842	1634	18191872641004
75857	42	92638468000000
75858	42	92638480000000
75972	1685	121682499571430
75973	1685	121682524571430
75985	1419	29259603280064
75986	1419	29259605280064
76007	1649	22604312999992
76042	1850	15759098000000
76043	1850	15759110000000
75859	1740	15765312000000
75860	1740	15765324000000
75904	1726	110795110000
75905	2175	200000000
75906	1397	1335609695000
75907	1678	20160708405000
75908	1397	1335599694000
75909	1678	20160708406000
75910	1397	1335589693000
75911	1678	20160708407000
75912	1397	1335579692000
75913	1678	20160708408000
75914	1397	1335569691000
75915	1678	20160708409000
75916	2132	148660661000
75917	1874	7773000
75918	2134	97597806000
75919	1874	7776000
75920	2134	97596803000
75921	1874	7779000
75922	2133	97615236000
75923	1874	7781000
75924	2133	97614234000
75925	1874	7783000
75926	2133	97613232000
75927	1874	7785000
75928	2133	97612230000
75929	1874	7787000
75930	2133	97611228000
75931	1874	7789000
75932	2134	97595800000
75933	1874	7792000
75934	2134	97594797000
75935	1874	7795000
75936	2134	97593794000
75937	1874	7798000
75938	1668	19406780000000
75939	1668	19406851000000
75987	1643	3128438114700
76008	2039	17281478000000
76009	2039	17281493000000
75865	1874	7498000
75866	1874	7508000
75867	1874	7511000
75868	1874	7514000
75869	1874	7525000
75870	1874	7527000
75871	1874	7539000
75872	1874	7548000
75873	1874	7551000
75874	1874	7554000
75875	1874	7557000
75876	1874	7560000
75877	1874	7562000
75878	1874	7564000
75879	1874	7566000
75880	1874	7570000
75881	1874	7572000
75882	1874	7578000
75883	1874	7580000
75884	1874	7582000
75885	1874	7584000
75886	1874	7587000
75887	1874	7588000
75888	1874	7590000
75889	1740	15045875000000
75890	1874	7592000
75891	1874	7593000
75892	1874	7596000
75893	1874	7598000
75894	1874	7604000
75895	1874	7607000
75896	1874	7610000
75897	1874	7612000
75898	1874	7616000
75899	1874	7618000
75900	1874	7628000
75901	1874	7630000
75902	1740	15765875000000
75903	1740	15765896000000
75940	1686	16772229550062
75941	1397	1335559690000
75942	1678	20160708410000
75943	1397	1335549689000
75944	1678	20160708411000
75945	2134	97592791000
75946	1874	7801000
75947	2132	148659660000
75948	1874	7802000
75949	2134	97591788000
75950	1874	7805000
75951	2133	97610226000
75952	1874	7807000
75953	2133	97609224000
75954	1874	7809000
75955	1394	247683757000000
75974	1691	15083223100019
75988	2134	97587776000
75989	1874	7828000
75990	2133	97605216000
75991	1874	7830000
75992	633	83164112900000
76010	1623	54002634899898
76011	1623	54002649899898
76012	1397	1335509685000
76013	1678	20160708415000
76014	2134	97584767000
76015	1874	7844000
76016	2133	97602210000
76017	1874	7846000
76018	1397	1335499684000
76019	1678	20160708416000
76020	1397	1335489683000
76021	1678	20160708417000
76022	2133	97601208000
76023	1874	7848000
76024	2132	148656657000
76025	1874	7849000
76026	2134	97583764000
76027	1874	7852000
76028	2134	97582761000
76029	1874	7855000
76030	2133	97600206000
76031	1874	7857000
76032	1714	14566454103056
76033	1714	14566479103056
76044	1460	155000000
76045	1513	29521241000000
76046	1397	1335469681000
76047	1678	20160708419000
76048	2133	97598202000
76049	1874	7864000
76050	1506	13681256967172
76051	1397	1335459680000
76052	1678	20160708420000
76053	2132	148655656000
76054	1874	7865000
76055	2134	97580755000
76056	1874	7868000
76057	2133	97597200000
76058	1874	7870000
76059	1394	250563772000000
76060	1397	1335449679000
76061	1678	20160708421000
76062	2133	97596198000
76063	1874	7872000
76064	2134	97579752000
76065	1874	7875000
76066	1397	1335439678000
76067	1678	20160708422000
76068	2133	97595196000
76069	1874	7877000
76070	2134	97578749000
76071	1874	7880000
76072	1695	14732296000000
76073	1695	14732308000000
76074	1693	2299210758018
76075	1693	2299222758018
76076	1397	1335429677000
76077	1678	20160708423000
76078	1769	1689900000
76079	2133	97594194000
76080	1874	7882000
76081	2134	97577746000
76082	1874	7885000
76083	1395	58071505071007706
76084	1395	58072225071007706
76085	1610	13680433000000
76086	1610	14400433000000
76087	1397	1335419676000
76088	1678	20160708424000
76089	2133	97593192000
76090	1874	7887000
76091	2134	97576743000
76092	1874	7890000
76093	2132	148654655000
76094	1874	7891000
76095	1394	252003772000000
76096	1394	252003785000000
76097	1693	2299223758018
76098	1796	2299223758017
76099	1693	200000003
76100	1397	1335409675000
76101	1678	20160708425000
76102	1397	1335399674000
76103	1678	20160708426000
76104	1769	1688900000
76105	2133	97592190000
76106	1874	7893000
76107	2133	97591188000
76108	1874	7895000
76109	2134	97575740000
76110	1874	7898000
76111	2134	97574737000
76112	1874	7901000
76113	58	87546613999641
76114	1397	1335389673000
76115	1678	20160708427000
76116	2132	148653654000
76117	1874	7902000
76118	2133	97590186000
76119	1874	7904000
76120	2134	97573734000
76121	1874	7907000
76122	1395	58072945071007706
76123	1395	58072945084007706
76124	1397	1335379672000
76125	1678	20160708428000
76126	2133	97589184000
76127	1874	7909000
76128	1686	16772169550062
76129	2134	97572731000
76130	1874	7910000
76131	1874	7912000
76132	1679	17494963853000
76133	1679	17494975853000
76134	1686	16772170550062
76135	1650	8674159000000
76136	1397	1335369671000
76137	1678	20160708429000
76138	2133	97588182000
76139	1874	7914000
76140	2134	97571728000
76141	1874	7917000
76142	632	74061222000000
76143	632	74061234000000
76144	1769	1687900000
76145	632	74061235000000
76168	1397	1335339668000
76169	1678	20160708432000
76170	2134	97568719000
76171	1874	7931000
76172	2133	97585176000
76173	1874	7933000
76174	633	83164122900000
76175	1397	1335329667000
76176	1678	20160708433000
76177	1397	1335319666000
76178	1678	20160708434000
76179	2134	97567716000
76180	1874	7936000
76181	2133	97584174000
76182	1874	7938000
76183	2133	97583172000
76184	1874	7940000
76185	2132	148651652000
76186	1874	7941000
76187	2134	97566713000
76188	1874	7944000
76189	1671	15168493530515
76190	1671	15168518530515
76201	1397	1335299664000
76202	1678	20160708436000
76203	2134	97564707000
76204	1874	7952000
76205	2133	97581168000
76206	1874	7954000
76207	1657	14401434000000
76208	1657	14401446000000
76209	1397	1335289663000
76210	1678	20160708437000
76211	2134	97563704000
76212	1874	7957000
76213	2133	97580166000
76214	1874	7959000
76215	2132	148650651000
76216	1874	7960000
76217	1599	14740254393047
76245	1522	14014196000000
76246	1522	14014208000000
76256	1726	110795109000
76257	1874	6995000
76258	1874	6997000
76259	1874	6999000
76260	1874	7000000
76261	1874	7002000
76262	1874	7004000
76263	1874	7005000
76264	1874	7007000
76265	1874	7009000
76266	1874	7011000
76267	1874	7012000
76268	1874	7014000
76269	1874	7015000
76270	1874	7017000
76271	1874	7020000
76272	1874	7022000
76273	1874	7024000
76274	1874	7026000
76275	1874	7027000
76276	1874	7029000
76277	1874	7031000
76278	1874	7032000
76279	1874	7034000
76280	1874	7036000
76281	1874	7037000
76282	1756	8353170545609
76283	1756	8353283545609
76388	1679	17495000853000
76400	1688	51912084708000
76401	1397	1335159650000
76402	1678	20160708450000
76403	1397	1335149649000
76404	1678	20160708451000
76405	1688	51912104708000
76427	1602	66000000080000
76428	248	14400518990000
76429	1688	43559771908000
76430	2177	8351322800000
76431	1397	1335129647000
76432	1678	20160708453000
76433	2133	97564134000
76434	1874	8038000
76435	2134	97548659000
76436	1874	8041000
76437	369	84821482000000
76438	369	84821504000000
76464	1688	44279771908000
76465	1688	44279795908000
76466	1397	1335089643000
76467	1678	20160708457000
76468	1688	30959385908000
76469	2177	21671722800000
76470	1397	1335079642000
76471	1678	20160708458000
76472	2132	148644645000
76473	1874	8058000
76474	2133	97560126000
76475	1874	8060000
76476	2134	97544647000
76477	1874	8063000
76478	2134	97543644000
76479	1874	8066000
76480	2133	97559124000
76481	1874	8068000
76482	1692	27140258619999
76483	1692	27140293619999
76484	1397	1335069641000
76485	1678	20160708459000
76486	1397	1335059640000
76487	1678	20160708460000
76488	1679	15226896653000
76489	2177	23219780000000
76490	2133	97558122000
76491	1874	8070000
76492	2134	97542641000
76493	1874	8073000
76494	2132	148643644000
76495	1874	8074000
76496	2134	97541638000
76497	1874	8077000
76498	2133	97557120000
76499	1874	8079000
76500	1623	54002669899898
76501	1679	11518786653000
76502	2177	26927880000000
76503	1397	1335049639000
76504	1678	20160708461000
76505	1397	1335039638000
76506	1678	20160708462000
76507	2157	199000000
76508	2134	97540635000
76509	1874	8082000
76510	2134	97539632000
76511	1874	8085000
76512	2133	97556118000
76513	1874	8087000
76514	2133	97555116000
76515	1874	8089000
76516	1394	254883796000000
76517	1394	254883831000000
76518	1397	1335029637000
76519	1678	20160708463000
76520	2133	97554114000
76521	1874	8091000
76522	2134	97538629000
76523	1874	8094000
76524	1715	41040732000002
76525	1715	41040744000002
76545	1397	1334999634000
76546	1678	20160708466000
76547	2134	97535620000
76548	1874	8106000
76549	2133	97552110000
76550	1874	8108000
76551	1703	8640782000000
76552	1703	8640794000000
76553	1702	7920308000000
76661	1397	1334919626000
76662	1678	20160708474000
76663	420	66083218193897
76664	2133	97544094000
76665	1874	8144000
76666	2134	97528599000
76667	1874	8147000
76668	2132	148639640000
76669	1874	8148000
76670	2112	5039061000000
76671	2112	5039084000000
76673	1688	31679385908000
76674	1688	31679408908000
76691	1657	66000001100200
76692	167	15121469500000
76707	1690	123123899000000
76708	1690	123123912000000
76709	1397	1334879622000
76710	1678	20160708478000
76711	2133	97540086000
76712	1874	8166000
76713	2134	97524587000
76714	1874	8169000
76146	1397	1335359670000
76147	1678	20160708430000
76148	2132	148652653000
76149	1874	7918000
76150	2133	97587180000
76151	1874	7920000
76152	43	79680813890000
76153	43	79680825890000
76218	1397	1335279662000
76219	1678	20160708438000
76220	2133	97579164000
76221	1874	7962000
76222	2134	97562701000
76223	1874	7965000
76247	1397	1335259660000
76248	1678	20160708440000
76249	2134	97560695000
76250	1874	7973000
76251	2132	148649650000
76252	1874	7974000
76253	2133	97577160000
76254	1874	7976000
76255	1654	17565177999798
76284	1397	1335249659000
76285	1678	20160708441000
76286	1397	1335239658000
76287	1678	20160708442000
76288	2133	97576158000
76289	1874	7978000
76290	2134	97559692000
76291	1874	7981000
76292	2134	97558689000
76293	1874	7984000
76294	2133	97575156000
76295	1874	7986000
76296	621	67440020000000
76297	621	67440044000000
76389	171	79670452524688
76390	171	79670489524688
76391	1397	1335169651000
76392	1678	20160708449000
76393	2133	97568142000
76394	1874	8020000
76395	1850	16479110000000
76396	1850	16479121000000
76406	2133	97567140000
76407	1874	8022000
76408	2134	97551668000
76409	1874	8025000
76410	2132	148646647000
76411	1874	8026000
76412	2133	97566138000
76413	1874	8028000
76414	2134	97550665000
76415	1874	8031000
76416	1637	208085644819988
76417	1637	208085669819988
76439	1637	208085666819988
76526	1397	1335019636000
76527	1678	20160708464000
76528	1683	0
76529	2177	54143319399541
76530	2133	97553112000
76531	1874	8096000
76532	2132	148642643000
76533	1874	8097000
76534	1555	10275291979096
76535	1397	1335009635000
76536	1678	20160708465000
76537	1677	0
76538	2177	63700566249641
76539	2134	97537626000
76540	1874	8100000
76541	2134	97536623000
76542	1874	8103000
76543	1717	15228094000023
76544	1717	15228116000023
76566	1690	122403899000000
76646	1397	1334939628000
76647	1678	20160708472000
76648	2133	97546098000
76649	1874	8137000
76650	2134	97529602000
76651	1874	8140000
76652	1448	8676774000001
76653	1448	8676786000001
76675	1397	1334909625000
76676	1678	20160708475000
76677	2133	97543092000
76678	1874	8150000
76679	2134	97527596000
76680	1874	8153000
76728	1696	15617439835100
76731	1397	1334859620000
76732	1678	20160708480000
76733	2133	97538082000
76734	1874	8176000
76735	2132	148637638000
76736	1874	8177000
76737	2134	97522581000
76738	1874	8180000
76739	1714	15286479103056
76740	1714	15286492103056
76756	1587	22320704000000
76757	1587	22320716000000
76760	1397	1334829617000
76761	1678	20160708483000
76762	2134	97519572000
76763	1874	8193000
76764	2133	97535076000
76765	1874	8195000
76766	1394	257763888000000
76767	1394	257763901000000
76801	1397	1334779612000
76802	1678	20160708488000
76803	2134	97515560000
76804	1874	8217000
76805	1395	58074385095007706
76806	1395	58074385106007706
76812	1397	1334759610000
76813	1678	20160708490000
76814	2132	148634635000
76815	1874	8221000
76816	2134	97513554000
76817	1874	8224000
76818	1634	18191869641004
76862	1679	12238786653000
76863	1679	12238797653000
76869	1397	1334689603000
76870	1678	20160708497000
76871	2134	97506533000
76872	1874	8246000
76873	2132	148632633000
76874	1874	8247000
76875	1680	13689596500035
76876	1680	13689608500035
76878	1688	33119420908000
76903	1397	1334649599000
76904	1678	20160708501000
76905	1397	1334639598000
76906	1678	20160708502000
76907	2134	97502521000
76908	1874	8260000
76909	2134	97501518000
76910	1874	8263000
76911	1394	260643921000000
76912	1394	260643943000000
76965	1397	1334559590000
76966	1678	20160708510000
76967	2134	97494497000
76968	1874	8286000
76969	2132	148628629000
76970	1874	8287000
76971	599	66720000000000
76972	599	66720012000000
76993	1702	8640308000000
76994	1702	8640330000000
77035	1395	58076545129007706
77036	1395	58076545141007706
77037	1397	1334449579000
77038	1678	20160708521000
77039	2134	97483464000
77040	1874	8323000
77041	1394	262083943000000
77042	1394	262083954000000
77091	1698	17817118550035
77092	1698	17817130550035
77094	1397	1334379572000
77095	1678	20160708528000
77096	2134	97477446000
77097	1874	8343000
77098	1724	10027364500000
77099	1724	10027375500000
77118	1397	1334339568000
77119	1678	20160708532000
77120	2134	97473434000
77121	1874	8356000
77122	1991	19195972441475
77123	1991	19195983441475
77139	1397	1334299564000
77140	1678	20160708536000
77141	2132	148621622000
77142	1874	8366000
77143	1637	210965726819988
77144	2123	2400000000
76154	2134	97570725000
76155	1874	7921000
76156	1874	7923000
76157	43	79680826890000
76158	1397	1335349669000
76159	1678	20160708431000
76160	2133	97586178000
76161	1874	7925000
76162	2134	97569722000
76163	1874	7928000
76164	1991	17755939441475
76165	1991	17755951441475
76191	1672	22322156000000
76192	1672	22322181000000
76224	1687	4220704223172
76225	1874	7531000
76226	1874	7532000
76227	1874	7535000
76228	1874	7541000
76229	1874	7544000
76230	1874	7553000
76231	1874	7599000
76232	1874	7602000
76233	1687	4940704223172
76234	1687	4940911223172
76235	1397	1335269661000
76236	1678	20160708439000
76237	2134	97561698000
76238	1874	7968000
76239	2133	97578162000
76240	1874	7970000
76241	1668	20126851000000
76242	1668	20126863000000
76397	1394	253443785000000
76398	1394	253443796000000
76418	1397	1335139648000
76419	1678	20160708452000
76420	2133	97565136000
76421	1874	8030000
76422	1874	8033000
76423	2134	97549662000
76424	1874	8036000
76425	1602	14400519000000
76440	1397	1335119646000
76441	1678	20160708454000
76442	2134	97547656000
76443	1874	8044000
76444	2132	148645646000
76445	1874	8045000
76446	2133	97563132000
76447	1874	8047000
76448	1599	15460254393047
76449	1599	15460267393047
76656	1397	1334929627000
76657	1678	20160708473000
76658	2133	97545096000
76659	1874	8142000
76660	1395	58073665095007706
76672	1719	15860631000000
76693	1397	1334889623000
76694	1678	20160708477000
76695	2132	148638639000
76696	1874	8149000
76697	1874	8151000
76698	1874	8154000
76699	1874	8156000
76700	1874	8159000
76701	2133	97541088000
76702	1874	8161000
76703	2134	97525590000
76704	1874	8164000
76705	1675	13822265999977
76719	2133	97539084000
76720	1874	8168000
76721	1874	8171000
76722	1637	208805680819988
76729	1688	33119408908000
76730	1688	33119433908000
76741	1397	1334849619000
76742	1678	20160708481000
76743	2133	97537080000
76744	1874	8182000
76745	2134	97521578000
76746	1874	8185000
76747	2112	5039073000000
76758	1874	8188000
76759	1587	22320715000000
76784	1397	1334799614000
76785	1678	20160708486000
76786	2133	97532070000
76787	1874	8205000
76788	2134	97517566000
76789	1874	8208000
76790	1394	257763900000000
76819	1599	16180267393047
76820	1599	16180279393047
76824	1397	1334749609000
76825	1678	20160708491000
76826	2134	97512551000
76827	1874	8227000
76828	1637	210245704819988
76829	1397	1334739608000
76830	1678	20160708492000
76831	1397	1334729607000
76832	1678	20160708493000
76833	2134	97511548000
76834	1874	8230000
76835	2134	97510545000
76836	1874	8233000
76848	1397	1334709605000
76849	1678	20160708495000
76850	2134	97508539000
76851	1874	8240000
76852	1395	58075105107007706
76853	1395	58075105118007706
76854	1708	12995828000021
76855	1708	12995839000021
76877	1694	20892692127629
76893	1419	29259614280064
76896	1397	1334659600000
76897	1678	20160708500000
76898	2134	97503524000
76899	1874	8256000
76900	2132	148631632000
76901	1874	8257000
76920	1462	720021000000
76950	1685	121682532571430
76952	1397	1334579592000
76953	1678	20160708508000
76954	470	80400471000000
76957	2139	190000000
76958	2134	97495500000
76959	1874	8283000
76960	470	80400482000000
76973	1397	1334549589000
76974	1678	20160708511000
76975	2134	97493494000
76976	1874	8290000
76977	1634	18911869641004
76978	1634	18911880641004
76982	1759	16560843999889
76983	1759	16560854999889
76995	1397	1334519586000
76996	1678	20160708514000
76997	1397	1334509585000
76998	1678	20160708515000
76999	1397	1334499584000
77000	1678	20160708516000
77001	2134	97490485000
77002	1874	8299000
77003	2134	97489482000
77004	1874	8302000
77005	2134	97488479000
77006	1874	8305000
77007	2132	148627628000
77008	1874	8306000
77009	686	68160045000000
77043	1397	1334439578000
77044	1678	20160708522000
77045	1397	1334429577000
77046	1678	20160708523000
77047	1397	1334419576000
77048	1678	20160708524000
77049	2132	148624625000
77050	1874	8324000
77051	2134	97482461000
77052	1874	8327000
77053	2134	97481458000
77054	1874	8330000
77055	2134	97480455000
77056	1874	8333000
77057	1547	12813470000000
77073	1688	33119419908000
77079	1397	1334399574000
77080	1678	20160708526000
77081	1395	58077265141007706
77082	1395	58077265151007706
77100	1397	1334369571000
77101	1678	20160708529000
77102	2134	97476443000
77103	1874	8346000
77106	1397	1334359570000
77107	1678	20160708530000
77108	2134	97475440000
77109	1874	8349000
76166	1650	9394159000000
76167	1650	9394171000000
76193	1559	14362779000000
76194	1397	1335309665000
76195	1678	20160708435000
76196	2133	97582170000
76197	1874	7946000
76198	2134	97565710000
76199	1874	7949000
76200	1706	11012192600135
76243	2176	719000000000
76244	2176	719012000000
76298	1874	7213000
76299	1874	7217000
76300	1874	7221000
76301	1874	7223000
76302	1874	7225000
76303	1874	7226000
76304	1874	7228000
76305	1874	7230000
76306	1874	7232000
76307	1874	7238000
76308	1874	7240000
76309	1874	7248000
76310	1874	7252000
76311	1874	7254000
76312	1874	7256000
76313	1874	7262000
76314	1874	7264000
76315	1874	7266000
76316	1874	7270000
76317	1874	7272000
76318	1874	7274000
76319	1874	7278000
76320	1874	7280000
76321	1874	7284000
76322	1874	7286000
76323	1874	7294000
76324	1874	7296000
76325	1874	7300000
76326	1874	7302000
76327	1874	7304000
76328	1874	7306000
76329	1874	7318000
76330	1874	7320000
76331	1874	7322000
76332	1874	7324000
76333	1874	7325000
76334	1874	7327000
76335	1874	7328000
76336	1874	7330000
76337	1874	7331000
76338	1874	7334000
76339	1874	7336000
76340	1874	7337000
76341	1874	7339000
76342	621	66720168000000
76343	621	67440168000000
76344	1397	1335229657000
76345	1678	20160708443000
76346	1397	1335219656000
76347	1678	20160708444000
76348	2133	97574154000
76349	1874	7988000
76350	2133	97573152000
76351	1874	7990000
76352	2134	97557686000
76353	1874	7993000
76354	2134	97556683000
76355	1874	7996000
76356	2132	148648649000
76357	1874	7997000
76358	529	66720025000000
76359	1397	1335209655000
76360	1678	20160708445000
76361	2134	97555680000
76362	1874	8000000
76363	2133	97572150000
76364	1874	8002000
76365	1672	22322168000000
76366	1397	1335199654000
76367	1678	20160708446000
76368	1397	1335189653000
76369	1678	20160708447000
76370	1397	1335179652000
76371	1678	20160708448000
76372	2133	97571148000
76373	1874	8004000
76374	2134	97554677000
76375	1874	8007000
76376	2132	148647648000
76377	1874	8008000
76378	2133	97570146000
76379	1874	8010000
76380	2134	97553674000
76381	1874	8013000
76382	2134	97552671000
76383	1874	8016000
76384	2133	97569144000
76385	1874	8018000
76386	1991	18475951441475
76387	1991	18475988441475
76399	1698	16377099550035
76426	1698	16377105550035
76450	1643	3128448114700
76451	1397	1335109645000
76452	1678	20160708455000
76453	1397	1335099644000
76454	1678	20160708456000
76455	2133	97562130000
76456	1874	8049000
76457	2133	97561128000
76458	1874	8051000
76459	2134	97546653000
76460	1874	8054000
76461	2134	97545650000
76462	1874	8057000
76463	1690	122403900000000
76554	1397	1334989633000
76555	1678	20160708467000
76556	1726	109585110000
76557	2178	200000000
76558	2134	97534617000
76559	1874	8111000
76560	2132	148641642000
76561	1874	8112000
76562	2133	97551108000
76563	1874	8114000
76564	1395	58073665084007706
76565	1395	58073665107007706
76567	1726	108375110000
76568	2179	200000000
76569	1397	1334979632000
76570	1678	20160708468000
76571	1397	1334969631000
76572	1678	20160708469000
76573	1397	1334959630000
76574	1678	20160708470000
76575	1726	107165110000
76576	2180	200000000
76577	2132	148640641000
76578	1874	8115000
76579	2134	97533614000
76580	1874	8118000
76581	2134	97532611000
76582	1874	8121000
76583	2134	97531608000
76584	1874	8124000
76585	2133	97550106000
76586	1874	8126000
76587	2133	97549104000
76588	1874	8128000
76589	2133	97548102000
76590	1874	8130000
76591	1394	256323831000000
76592	1394	256323888000000
76593	1397	1334949629000
76594	1678	20160708471000
76595	2134	97530605000
76596	1874	8133000
76597	2133	97547100000
76598	1874	8135000
76599	1444	17135237159999
76600	1444	17135249159999
76601	2177	9556246850100
76602	2177	36771686249641
76603	1688	42839751908000
76604	2177	45124009049641
76605	1688	29519341908000
76606	2177	58444409049641
76607	2177	59992466249641
76608	1444	16415437159999
76609	1874	8003000
76610	1874	8006000
76611	1874	8019000
76612	1874	8021000
76613	1874	8023000
76614	1874	8027000
76615	1874	8029000
76616	1874	8035000
76617	1874	8037000
76618	1874	8039000
76619	1874	8043000
76620	1874	8053000
76621	1874	8055000
76622	1874	8061000
76623	1874	8062000
76624	1874	8065000
76625	1874	8071000
76626	1874	8080000
76627	1874	8083000
76628	1874	8086000
76629	1874	8092000
76630	1874	8095000
76631	1874	8098000
76632	1874	8101000
76633	1874	8104000
76634	1874	8107000
76635	1874	8110000
76636	1874	8113000
76637	1874	8116000
76638	1874	8119000
76639	1874	8122000
76640	1874	8125000
76641	1874	8127000
76642	1874	8129000
76643	1874	8131000
76644	1444	17135437159999
76645	1444	17135658159999
76654	1623	54722669899898
76655	1623	54722681899898
76681	1688	32399408908000
76682	1397	1334899624000
76683	1678	20160708476000
76684	2133	97542090000
76685	1874	8155000
76686	2134	97526593000
76687	1874	8158000
76688	1657	15121446000000
76689	1514	15121469990100
76690	1657	20500
76706	1675	13822241999977
76723	1397	1334869621000
76724	1678	20160708479000
76725	2134	97523584000
76726	1874	8174000
76727	1696	15617425835100
76768	1637	209525680819988
76769	1637	209525693819988
76791	1397	1334789613000
76792	1678	20160708487000
76793	2132	148635636000
76794	1874	8209000
76795	2133	97531068000
76796	1874	8211000
76797	2134	97516563000
76798	1874	8214000
76799	1698	17097105550035
76800	1698	17097118550035
76807	149	83550262000341
76821	1419	29259615280064
76856	1397	1334699604000
76857	1678	20160708496000
76858	2134	97507536000
76859	1874	8243000
76860	1588	17495038000000
76861	1588	17495049000000
76864	1688	42119739908000
76865	1688	28799329908000
76866	1679	14506884653000
76867	1679	10798774653000
76868	1739	27359856000000
76879	397	66612728193897
76880	2181	200000000
76881	1397	1334679602000
76882	1678	20160708498000
76883	2134	97505530000
76884	1874	8250000
76885	1394	259203900000000
76886	1394	259203921000000
76924	1397	1334619596000
76925	1678	20160708504000
76926	2181	612190000000
76927	1397	1334609595000
76928	1678	20160708505000
76929	2132	148630631000
76930	1874	8267000
76931	2134	97499512000
76932	1874	8270000
76933	2134	97498509000
76934	1874	8273000
76935	1476	17280337000000
76936	1271	1346286421000000
76961	1397	1334569591000
76962	1678	20160708509000
76963	1679	12958819653000
76964	1679	12958829653000
76984	1397	1334539588000
76985	1678	20160708512000
76986	1397	1334529587000
76987	1678	20160708513000
76988	2134	97492491000
76989	1874	8293000
76990	2134	97491488000
76991	1874	8296000
76992	1670	20881195000000
77010	1397	1334489583000
77011	1678	20160708517000
77012	1397	1334479582000
77013	1678	20160708518000
77014	2132	148626627000
77015	1874	8307000
77016	2134	97487476000
77017	1874	8310000
77018	2134	97486473000
77019	1874	8313000
77020	1623	54722692899898
77066	1694	20892714127629
77074	1687	4941531223172
77075	1874	7606000
77076	1874	7609000
77077	1687	5661531223172
77078	1687	5661945223172
77083	1397	1334389573000
77084	1678	20160708527000
77085	2134	97478449000
77086	1874	8339000
77087	2132	148623624000
77088	1874	8340000
77089	1675	14542241999977
77090	1675	14542253999977
77093	1685	121682511571430
77104	1455	9394061000000
77105	1455	9394072000000
77114	1397	1334349569000
77115	1678	20160708531000
77116	2134	97474437000
77117	1874	8353000
77130	1397	1334319566000
77131	1678	20160708534000
77132	1397	1334309565000
77133	1678	20160708535000
77134	2134	97471428000
77135	1874	8362000
77136	2134	97470425000
77137	1874	8365000
77138	1690	123123921000000
77161	1397	1334269561000
77162	1678	20160708539000
77163	1560	16434378277001
77169	1397	1334259560000
77170	1678	20160708540000
77171	2132	148619620000
77172	1874	8377000
77173	2134	97466413000
77174	1874	8380000
77175	1690	123843921000000
77176	1690	123843933000000
77185	1395	58078705163007706
77186	1395	58078705174007706
77254	1395	58078705186007706
77281	43	80400826890000
77282	43	80400860890000
77404	1397	1333989533000
77405	1678	20160708567000
77406	2132	148611612000
77407	1874	8466000
77408	2106	4319071000000
77409	2106	4319082000000
77411	43	80400837890000
77419	2165	190000000
77420	1397	1333969531000
77421	1678	20160708569000
77422	1397	1333959530000
77423	1678	20160708570000
77424	1397	1333949529000
77425	1678	20160708571000
77426	1397	1333939528000
77427	1678	20160708572000
77428	1726	105955110000
77429	2182	200000000
77430	2134	97438329000
77431	1874	8474000
77432	2133	97529064000
77433	1874	8476000
77434	2133	97528062000
77435	1874	8478000
77436	2132	148610611000
77437	1874	8479000
77438	2134	97437326000
76715	420	66000217193897
76716	2164	612599000000
76717	1637	208805666819988
76718	1637	208805679819988
76748	1397	1334839618000
76749	1678	20160708482000
76750	2133	97536078000
76751	1874	8187000
76752	2134	97520575000
76753	1874	8190000
76754	1451	13578992000000
76755	1451	13579004000000
76770	1397	1334819616000
76771	1678	20160708484000
76772	1397	1334809615000
76773	1678	20160708485000
76774	2133	97534074000
76775	1874	8197000
76776	2132	148636637000
76777	1874	8198000
76778	2133	97533072000
76779	1874	8200000
76780	2134	97518569000
76781	1874	8203000
76782	1715	41760744000002
76783	1715	41760768000002
76808	1397	1334769611000
76809	1678	20160708489000
76810	2134	97514557000
76811	1874	8220000
76822	1637	210245693819988
76823	1637	210245705819988
76837	1740	15765417000000
76838	1740	15765334000000
76839	1397	1334719606000
76840	1678	20160708494000
76841	2132	148633634000
76842	1874	8234000
76843	2134	97509542000
76844	1874	8237000
76845	1402	58174694319298
76846	1402	58174706319298
76847	1395	58074385107007706
76887	1397	1334669601000
76888	1678	20160708499000
76889	2134	97504527000
76890	1874	8253000
76891	1395	58075825118007706
76892	1395	58075825129007706
76894	1637	210965704819988
76895	1637	210965715819988
76902	1691	15083210100019
76913	397	66000718193897
76914	2181	612200000000
76915	1397	1334629597000
76916	1678	20160708503000
76917	2134	97500515000
76918	1874	8266000
76919	1991	18475972441475
76921	1756	8353303545609
76922	1756	9073303545609
76923	1756	9073313545609
76937	1397	1334599594000
76938	1678	20160708506000
76939	1397	1334589593000
76940	1678	20160708507000
76941	397	66000708193897
76942	2134	97497506000
76943	1874	8276000
76944	2134	97496503000
76945	1874	8279000
76946	2132	148629630000
76947	1874	8280000
76948	1654	18285177999798
76949	1654	18285210999798
76951	1679	12238819653000
76955	1681	13463252759830
76956	1681	13463262759830
76979	1672	23042168000000
76980	1672	23042179000000
76981	1513	28800877000000
77021	1397	1334469581000
77022	1678	20160708519000
77023	2134	97485470000
77024	1874	8316000
77025	1706	11732192600135
77026	1706	11732203600135
77027	1397	1334459580000
77028	1678	20160708520000
77029	2134	97484467000
77030	1874	8319000
77031	2132	148625626000
77032	1874	8320000
77033	633	83884122900000
77034	633	83884134900000
77058	1874	8165000
77059	1874	8167000
77060	1874	8170000
77061	1874	8172000
77062	1874	8173000
77063	1874	8175000
77064	1874	8178000
77065	1547	12813491000000
77067	1397	1334409575000
77068	1678	20160708525000
77069	2134	97479452000
77070	1874	8336000
77071	1687	5660096223172
77072	1687	5660107223172
77155	1397	1334279562000
77156	1678	20160708538000
77157	2134	97467416000
77158	1874	8376000
77159	1587	23040716000000
77160	1587	23040727000000
77177	1397	1334249559000
77178	1678	20160708541000
77179	2134	97465410000
77180	1874	8383000
77181	1700	16866016276737
77182	1700	16866027276737
77189	1874	8342000
77190	1874	8345000
77191	1874	8352000
77192	1874	8355000
77193	1874	8358000
77194	1874	8363000
77195	1874	8368000
77196	1874	8371000
77197	1874	8374000
77198	1474	13953603000023
77223	1402	58174750319298
77302	1397	1334079542000
77303	1678	20160708558000
77304	2134	97448359000
77305	1874	8439000
77306	1690	125283989000000
77307	1690	125284000000000
77380	1397	1334029537000
77381	1678	20160708563000
77382	2134	97443344000
77383	1874	8455000
77384	1613	16488002600000
77410	1448	8676785000001
77412	1397	1333979532000
77413	1678	20160708568000
77414	2134	97439332000
77415	1874	8469000
77416	2133	97530066000
77417	1874	8471000
77418	1690	125284001000000
77451	1874	8321000
77452	1874	8325000
77453	1874	8329000
77454	1874	8331000
77455	1419	28540161280064
77456	1874	8332000
77457	1874	8335000
77458	1874	8338000
77459	1874	8341000
77460	1874	8344000
77461	1874	8347000
77462	1874	8372000
77463	1874	8375000
77464	1874	8378000
77465	1874	8379000
77466	1874	8381000
77467	1874	8382000
77468	1874	8384000
77469	1874	8387000
77470	1874	8402000
77471	1874	8405000
77472	1874	8408000
77473	1874	8411000
77474	1874	8414000
77475	1874	8438000
77476	1874	8441000
77477	1874	8444000
77478	1874	8447000
77479	1874	8450000
77480	1874	8453000
77481	1874	8456000
77482	1874	8459000
77483	1874	8468000
77484	1874	8477000
77110	2132	148622623000
77111	1874	8350000
77112	1395	58077985151007706
77113	1395	58077985163007706
77124	1397	1334329567000
77125	1678	20160708533000
77126	2134	97472431000
77127	1874	8359000
77128	1546	15840967000000
77129	1546	15840978000000
77146	1397	1334289563000
77147	1678	20160708537000
77148	2132	148620621000
77149	1874	8367000
77150	2134	97469422000
77151	1874	8370000
77152	2134	97468419000
77153	1874	8373000
77154	1671	15168506530515
77187	526	68880063000000
77188	526	68880074000000
77199	1397	1334239558000
77200	1678	20160708542000
77201	1397	1334229557000
77202	1678	20160708543000
77203	1397	1334219556000
77204	1678	20160708544000
77205	1397	1334209555000
77206	1678	20160708545000
77207	1397	1334199554000
77208	1678	20160708546000
77209	2134	97464407000
77210	1874	8386000
77211	2134	97463404000
77212	1874	8389000
77213	2132	148618619000
77214	1874	8390000
77215	2134	97462401000
77216	1874	8393000
77217	2134	97461398000
77218	1874	8396000
77219	2134	97460395000
77220	1874	8399000
77221	1690	124563933000000
77222	1690	124563989000000
77234	1397	1334179552000
77235	1678	20160708548000
77236	1397	1334169551000
77237	1678	20160708549000
77238	2134	97458389000
77239	1874	8406000
77240	2134	97457386000
77241	1874	8409000
77242	1602	14400524000000
77265	1397	1334139548000
77266	1678	20160708552000
77267	1397	1334129547000
77268	1678	20160708553000
77269	1397	1334119546000
77270	1678	20160708554000
77271	2132	148615616000
77272	1874	8417000
77273	2134	97454377000
77274	1874	8420000
77275	2134	97453374000
77276	1874	8423000
77277	2134	97452371000
77278	1874	8426000
77279	1637	212404726819988
77280	1637	212404760819988
77293	1397	1334089543000
77294	1678	20160708557000
77295	2134	97449362000
77296	1874	8435000
77297	2132	148614615000
77298	1874	8436000
77299	369	84821494000000
77300	1489	15744398000000
77301	1489	15744410000000
77310	1726	109585109000
77311	1726	108375109000
77312	1726	107165109000
77313	1688	41399714908000
77314	1688	28079304908000
77315	1709	12960458999976
77316	1874	7039000
77317	1874	7040000
77318	1874	7042000
77319	1874	7045000
77320	1874	7046000
77321	1874	7048000
77322	1874	7050000
77323	1874	7052000
77324	1874	7053000
77325	1874	7055000
77326	1874	7056000
77327	1874	7058000
77328	1874	7059000
77329	1874	7061000
77330	1874	7062000
77331	1874	7064000
77332	1874	7066000
77333	1874	7067000
77334	1874	7069000
77335	1874	7070000
77336	1874	7072000
77337	1874	7073000
77338	1874	7075000
77339	1874	7076000
77340	1874	7078000
77341	1874	7079000
77342	1874	7081000
77343	1874	7082000
77344	1874	7084000
77345	1874	7085000
77346	1874	7087000
77347	1874	7088000
77348	1874	7090000
77349	1874	7091000
77350	1874	7093000
77351	1874	7094000
77352	1874	7096000
77353	1874	7097000
77354	1709	13680458999976
77355	1709	13680529999976
77371	1685	122402511571430
77372	1685	122402545571430
77374	1397	1334039538000
77375	1678	20160708562000
77376	2134	97444347000
77377	1874	8452000
77385	1397	1334019536000
77386	1678	20160708564000
77387	1397	1334009535000
77388	1678	20160708565000
77389	2134	97442341000
77390	1874	8458000
77391	2134	97441338000
77392	1874	8461000
77393	2132	148612613000
77394	1874	8462000
77395	1564	12066523000000
77396	1564	12066546000000
77398	1397	1333999534000
77399	1678	20160708566000
77400	2134	97440335000
77401	1874	8465000
77402	1692	27860293619999
77403	1692	27860304619999
77521	1397	1333889523000
77522	1678	20160708577000
77523	1397	1333879522000
77524	1678	20160708578000
77525	2134	97430305000
77526	1874	8516000
77527	2134	97429302000
77528	1874	8519000
77529	2133	97521048000
77530	1874	8521000
77531	2133	97520046000
77532	1874	8523000
77533	2132	148608609000
77534	1874	8524000
77535	1395	58080145208007706
77536	1395	58080145233007706
77539	1688	33839419908000
77540	1688	33839444908000
77564	1394	264963965000000
77565	1394	264963978000000
77567	1397	1333839518000
77568	1678	20160708582000
77569	2165	80000000
77570	2165	70000000
77571	2165	60000000
77572	2165	50000000
77573	2133	97516038000
77574	1874	8542000
77575	1599	16180318393047
77593	1397	1333809515000
77594	1678	20160708585000
77595	2133	97513032000
77596	1874	8555000
77597	2134	97423284000
77598	1874	8558000
77599	1395	58080145220007706
77145	1637	211684726819988
77164	1874	8360000
77165	1874	8361000
77166	1874	8364000
77167	1560	15714436277001
77168	1560	16434436277001
77183	1394	263523954000000
77184	1394	263523965000000
77224	1397	1334189553000
77225	1678	20160708547000
77226	2132	148617618000
77227	1874	8400000
77228	2134	97459392000
77229	1874	8403000
77230	1762	19762038994000
77231	1762	19762050994000
77232	171	80390489524688
77233	171	80390501524688
77243	1397	1334159550000
77244	1678	20160708550000
77245	1397	1334149549000
77246	1678	20160708551000
77247	2132	148616617000
77248	1874	8410000
77249	2134	97456383000
77250	1874	8413000
77251	2134	97455380000
77252	1874	8416000
77253	1522	14014219000000
77255	1874	8284000
77256	1874	8285000
77257	1874	8288000
77258	1874	8289000
77259	1874	8291000
77260	1874	8292000
77261	1874	8294000
77262	1874	8295000
77263	1555	10995291979096
77264	1555	10995745979096
77283	1397	1334109545000
77284	1678	20160708555000
77285	1397	1334099544000
77286	1678	20160708556000
77287	2134	97451368000
77288	1874	8429000
77289	2134	97450365000
77290	1874	8432000
77291	1395	58079425186007706
77292	1395	58079425208007706
77308	1709	12960198999976
77309	1709	12960209999976
77356	1397	1334069541000
77357	1678	20160708559000
77358	1397	1334059540000
77359	1678	20160708560000
77360	1397	1334049539000
77361	1678	20160708561000
77362	2134	97447356000
77363	1874	8442000
77364	2132	148613614000
77365	1874	8443000
77366	2134	97446353000
77367	1874	8446000
77368	2134	97445350000
77369	1874	8449000
77370	1394	263523988000000
77373	1693	2299244758018
77378	1685	123122545571430
77379	1685	123122556571430
77397	1593	19270261000000
77537	1593	19990261000000
77538	1593	19990286000000
77554	1397	1333849519000
77555	1678	20160708581000
77556	2133	97517040000
77557	1874	8536000
77558	2134	97426293000
77559	1874	8539000
77560	2132	148607608000
77561	1874	8540000
77562	1992	15119334990000
77563	1992	15119347990000
77566	1596	17280739000000
77622	1397	1333769511000
77623	1678	20160708589000
77624	2134	97419272000
77625	1874	8577000
77626	2133	97509024000
77627	1874	8579000
77628	1679	13678829653000
77629	1679	13678841653000
77696	1397	1333659500000
77697	1678	20160708600000
77698	2134	97408239000
77699	1874	8617000
77700	1564	12066534000000
77702	1397	1333649499000
77703	1678	20160708601000
77704	2132	148601602000
77705	1874	8618000
77706	2134	97407236000
77707	1874	8621000
77708	1649	22604309999992
77711	641	81460194000000
77712	641	81460206000000
77728	1688	66720002000000
77729	115	33839441907992
77730	1571	20880486001032
77731	1693	3019221758018
77732	1693	3019244758018
77735	212	201000000
77736	2145	66000007000000
77737	2116	81460207999809
77738	641	206000000
77739	1964	200000029
77740	2097	200000008
77741	1571	20880486001200
77742	1964	3019244758009
77743	1693	200000001
77745	1447	3019243759017
77746	1693	14554584942000
77766	1688	34559441907992
77767	1688	34559474907992
77778	1698	17817136550035
77780	1395	58082305243007706
77781	1395	58082305261007706
77820	1448	8676787000001
77821	1397	1333519486000
77822	1678	20160708614000
77823	2134	97395200000
77824	1874	8661000
77825	2157	196000000
77826	2157	195000000
77827	2157	194000000
77828	1717	15948116000023
77829	1717	15948130000023
77832	1397	1333509485000
77833	1678	20160708615000
77834	2134	97394197000
77835	1874	8664000
77836	1560	17154378277001
77837	1560	17154389277001
77840	1740	15045310000000
77841	1739	27359927000000
77842	1739	28079927000000
77856	1397	1333479482000
77857	1678	20160708618000
77858	2134	97391188000
77859	1874	8674000
77860	2157	191000000
77861	1929	1302000000
77862	1850	17199121000000
77863	1850	17199133000000
77864	1850	16479251000000
77865	1874	8485000
77866	1874	8487000
77867	1874	8491000
77868	1874	8494000
77869	1874	8497000
77870	1874	8500000
77871	1874	8503000
77872	1874	8506000
77873	1874	8512000
77874	1874	8515000
77875	1874	8518000
77876	1874	8527000
77877	1874	8530000
77878	1874	8532000
77879	1874	8538000
77880	1874	8544000
77881	1874	8546000
77882	1874	8549000
77883	1874	8550000
77884	1874	8552000
77885	1874	8554000
77886	1874	8556000
77887	1874	8557000
77888	1874	8560000
77889	1874	8561000
77890	1874	8563000
77891	1874	8565000
77892	1874	8567000
77893	1874	8569000
77894	1874	8573000
77895	1874	8575000
77439	1874	8482000
77440	2133	97527060000
77441	1874	8484000
77442	2133	97526058000
77443	1874	8486000
77444	1675	13822308999977
77445	2134	97436323000
77446	1874	8489000
77447	2134	97435320000
77448	1874	8492000
77449	1675	14542308999977
77450	1675	14542310999977
77489	1419	28539670280064
77490	1419	29259670280064
77491	1419	29259672280064
77492	2165	90000000
77493	1397	1333929527000
77494	1678	20160708573000
77495	1397	1333919526000
77496	1678	20160708574000
77497	1397	1333909525000
77498	1678	20160708575000
77499	1397	1333899524000
77500	1678	20160708576000
77501	2132	148609610000
77502	1874	8493000
77503	2134	97434317000
77504	1874	8496000
77505	2134	97433314000
77506	1874	8499000
77507	2134	97432311000
77508	1874	8502000
77509	2134	97431308000
77510	1874	8505000
77511	2133	97525056000
77512	1874	8507000
77513	2133	97524054000
77514	1874	8509000
77515	2133	97523052000
77516	1874	8511000
77517	2133	97522050000
77518	1874	8513000
77519	641	80740045000000
77520	641	80740194000000
77541	1397	1333869521000
77542	1678	20160708579000
77543	1397	1333859520000
77544	1678	20160708580000
77545	2133	97519044000
77546	1874	8526000
77547	2133	97518042000
77548	1874	8528000
77549	2134	97428299000
77550	1874	8531000
77551	2134	97427296000
77552	1874	8534000
77553	1571	20880486001024
77576	1397	1333829517000
77577	1678	20160708583000
77578	2134	97425290000
77579	1874	8545000
77580	2133	97515036000
77581	1874	8547000
77582	1394	266403978000000
77583	1394	266403990000000
77600	1397	1333799514000
77601	1678	20160708586000
77602	1397	1333789513000
77603	1678	20160708587000
77604	1397	1333779512000
77605	1678	20160708588000
77606	2132	148605606000
77607	1874	8559000
77608	2134	97422281000
77609	1874	8562000
77610	2133	97512030000
77611	1874	8564000
77612	2133	97511028000
77613	1874	8566000
77614	2133	97510026000
77615	1874	8568000
77616	2134	97421278000
77617	1874	8571000
77618	2134	97420275000
77619	1874	8574000
77620	1690	126004001000000
77621	1690	126004038000000
77632	1397	1333759510000
77633	1678	20160708590000
77634	1397	1333749509000
77635	1678	20160708591000
77636	2133	97508022000
77637	1874	8581000
77638	2132	148604605000
77639	1874	8582000
77640	2134	97418269000
77641	1874	8585000
77642	2134	97417266000
77643	1874	8588000
77644	1394	267843990000000
77645	1394	267844014000000
77658	1397	1333719506000
77659	1678	20160708594000
77660	1397	1333709505000
77661	1678	20160708595000
77662	2132	148603604000
77663	1874	8595000
77664	2134	97414257000
77665	1874	8598000
77666	2134	97413254000
77667	1874	8601000
77668	1599	16900318393047
77669	1599	16900341393047
77694	2102	300000000
77695	1756	9793213545609
77701	1693	2299221758018
77727	2148	2159069000000
77747	1397	1333619496000
77748	1678	20160708604000
77749	2134	97404227000
77750	1874	8631000
77751	1546	16560978000000
77752	1546	16560989000000
77753	1397	1333609495000
77754	1678	20160708605000
77755	2134	97403224000
77756	1874	8634000
77757	1690	127444060000000
77758	1690	127444082000000
77782	2134	97400215000
77783	1874	8644000
77784	1764	13686958100000
77790	1688	33839440908000
77791	1397	1333559490000
77792	1678	20160708610000
77793	1397	1333549489000
77794	1678	20160708611000
77795	1397	1333539488000
77796	1678	20160708612000
77797	2132	148598599000
77798	1874	8645000
77799	2134	97399212000
77800	1874	8648000
77801	2134	97398209000
77802	1874	8651000
77803	2134	97397206000
77804	1874	8654000
77805	2157	198000000
77806	1719	15860663000000
77809	1740	16485387000000
77818	1700	17586027276737
77819	1700	17586040276737
77845	1397	1333499484000
77846	1678	20160708616000
77847	1397	1333489483000
77848	1678	20160708617000
77849	2132	148596597000
77850	1874	8665000
77851	2134	97393194000
77852	1874	8668000
77853	2134	97392191000
77854	1874	8671000
77855	1634	18911892641004
77914	1397	1333459480000
77915	1678	20160708620000
77916	2134	97389182000
77917	1874	8680000
77918	2132	148595596000
77919	1874	8681000
77920	1395	58082305255007706
77953	1397	1333409475000
77954	1678	20160708625000
77955	2134	97385170000
77956	1874	8694000
77959	1623	55442692899898
77960	1623	55442703899898
78002	1397	1333329467000
78003	1678	20160708633000
78004	2132	148591592000
78005	1874	8718000
78006	2134	97377146000
78007	1874	8721000
78008	1759	15840855999889
78009	1759	16560855999889
78029	1637	213124760819988
77485	1874	8480000
77486	1874	8483000
77487	1419	29260161280064
77488	1419	29260223280064
77584	1397	1333819516000
77585	1678	20160708584000
77586	2132	148606607000
77587	1874	8548000
77588	2134	97424287000
77589	1874	8551000
77590	2133	97514034000
77591	1874	8553000
77592	1650	9394172000000
77646	1711	17804892000000
77647	1711	17804916000000
77670	1395	58080865220007706
77671	1395	58080865243007706
77672	2165	40000000
77673	2165	30000000
77674	1397	1333699504000
77675	1678	20160708596000
77676	1397	1333689503000
77677	1678	20160708597000
77678	1397	1333679502000
77679	1678	20160708598000
77680	1397	1333669501000
77681	1678	20160708599000
77682	2132	148602603000
77683	1874	8602000
77684	2134	97412251000
77685	1874	8605000
77686	2134	97411248000
77687	1874	8608000
77688	2134	97410245000
77689	1874	8611000
77690	2134	97409242000
77691	1874	8614000
77692	1706	12452203600135
77693	1706	12452268600135
77713	1397	1333639498000
77714	1678	20160708602000
77715	1397	1333629497000
77716	1678	20160708603000
77717	2134	97406233000
77718	1874	8624000
77719	2132	148600601000
77720	1874	8625000
77721	2134	97405230000
77722	1874	8628000
77723	2097	2159068999923
77724	2148	200000023
77725	1571	200000004
77726	1964	20880486001096
77733	1933	3003269000000
77734	1933	3003292000000
77744	641	81460217000000
77759	1601	13610325620000
77779	606	76797858812962
77785	1397	1333579492000
77786	1678	20160708608000
77787	1397	1333569491000
77788	1678	20160708609000
77789	1764	13686978100000
77807	1740	16485332000000
77808	1740	16485353000000
77810	1397	1333529487000
77811	1678	20160708613000
77812	2132	148597598000
77813	1874	8655000
77814	2157	197000000
77815	2134	97396203000
77816	1874	8658000
77817	2106	4319084000000
77830	1394	269284014000000
77831	1394	269284028000000
77838	58	88266613999641
77839	58	88266624999641
77921	1397	1333449479000
77922	1678	20160708621000
77923	2134	97388179000
77924	1874	8684000
77925	1522	14014207000000
77944	2134	97386173000
77945	1874	8691000
77946	1613	17208002600000
77947	1613	17208003600000
77951	1688	34559430908000
77952	1688	34559441908000
77957	1471	20779831900000
77958	1471	20779842900000
77976	1397	1333379472000
77977	1678	20160708628000
77978	2134	97382161000
77979	1874	8704000
77980	1668	20126862000000
77981	1397	1333369471000
77982	1678	20160708629000
77983	2134	97381158000
77984	1874	8707000
77985	1394	270724028000000
77986	1394	270724039000000
77987	1397	1333359470000
77988	1678	20160708630000
77989	1397	1333349469000
77990	1678	20160708631000
77991	1397	1333339468000
77992	1678	20160708632000
77993	2132	148592593000
77994	1874	8708000
77995	2134	97380155000
77996	1874	8711000
77997	2134	97379152000
77998	1874	8714000
77999	2134	97378149000
78000	1874	8717000
78001	1705	12155569500145
78018	1874	8690000
78019	1874	8692000
78020	1874	8693000
78021	1874	8697000
78022	1874	8700000
78023	1874	8703000
78024	1874	8706000
78025	1874	8709000
78026	1874	8712000
78027	1874	8715000
78028	1599	16900453393047
78044	1688	35279441908000
78045	1688	35279463908000
78055	1692	28580316619999
78068	1397	1333259460000
78069	1678	20160708640000
78070	1397	1333249459000
78071	1678	20160708641000
78072	2132	148589590000
78073	1874	8741000
78074	2134	97370125000
78075	1874	8744000
78076	2134	97369122000
78077	1874	8747000
78078	1394	273604050000000
78079	1394	273604073000000
78099	1703	8640793000000
78107	1397	1333189453000
78108	1678	20160708647000
78109	1397	1333179452000
78110	1678	20160708648000
78111	2132	148587588000
78112	1874	8761000
78113	2134	97364107000
78114	1874	8764000
78115	2134	97363104000
78116	1874	8767000
78117	1395	58083025255007706
78118	1395	58083025278007706
78142	1397	1333129447000
78143	1678	20160708653000
78144	2134	97358089000
78145	1874	8783000
78146	2132	148585586000
78147	1874	8784000
78148	1395	58083745278007706
78149	1395	58083745290007706
78150	1397	1333119446000
78151	1678	20160708654000
78152	2134	97357086000
78153	1874	8787000
78154	1762	19762049994000
78179	1397	1333069441000
78180	1678	20160708659000
78181	2134	97352071000
78182	1874	8803000
78183	1654	18285188999798
78222	1643	1783113314700
78223	1299	1704036598340250
78224	1643	1450542514700
78225	1053	906322247444800
78226	1397	1333039438000
78227	1678	20160708662000
78228	1926	1192000000
78229	2134	97350065000
78230	1874	8810000
78231	2134	97349062000
78232	1874	8813000
78233	1710	19674759473290
77630	1508	15876541500009
77631	1508	15876553500009
77648	1397	1333739508000
77649	1678	20160708592000
77650	1397	1333729507000
77651	1678	20160708593000
77652	2134	97416263000
77653	1874	8591000
77654	2134	97415260000
77655	1874	8594000
77656	1690	126724038000000
77657	1690	126724060000000
77709	1395	58081585243007706
77710	1395	58081585255007706
77760	1397	1333599494000
77761	1678	20160708606000
77762	2134	97402221000
77763	1874	8637000
77764	1625	1440040000000
77765	1625	1440051000000
77768	1397	1333589493000
77769	1678	20160708607000
77770	1740	15765332000000
77771	1899	1997000000
77772	563	66000615000000
77773	2134	97401218000
77774	1874	8640000
77775	2132	148599600000
77776	1874	8641000
77777	1564	12066541000000
77843	1560	17154436277001
77844	1560	17155036277001
77905	1397	1333469481000
77906	1678	20160708619000
77907	2157	189960000
77908	1929	1302040000
77909	2157	188957000
77910	1929	1302043000
77911	2134	97390185000
77912	1874	8677000
77913	1698	17817131550035
77926	1397	1333439478000
77927	1678	20160708622000
77928	2134	97387176000
77929	1874	8687000
77930	1588	18215049000000
77931	1588	18215060000000
77933	1874	8535000
77934	1874	8537000
77935	1874	8541000
77936	1874	8543000
77937	1643	3128955114700
77948	1397	1333419476000
77949	1678	20160708624000
77950	1613	17208013600000
77972	1593	20710286000000
77973	1593	20710309000000
78031	1599	16900329393047
78034	1397	1333309465000
78035	1678	20160708635000
78036	2134	97375140000
78037	1874	8727000
78038	1573	12219123000000
78039	1573	12219134000000
78056	1397	1333279462000
78057	1678	20160708638000
78058	2134	97372131000
78059	1874	8737000
78060	1573	12939134000000
78061	1573	12939145000000
78080	1397	1333239458000
78081	1678	20160708642000
78082	2134	97368119000
78083	1874	8750000
78084	1402	58174705319298
78087	1397	1333229457000
78088	1678	20160708643000
78089	2134	97367116000
78090	1874	8753000
78091	2132	148588589000
78092	1874	8754000
78119	1397	1333169451000
78120	1678	20160708649000
78121	1397	1333159450000
78122	1678	20160708650000
78123	2134	97362101000
78124	1874	8770000
78125	2134	97361098000
78126	1874	8773000
78127	2132	148586587000
78128	1874	8774000
78129	1688	35279464908000
78184	1654	17565487999798
78185	1874	8696000
78186	1874	8699000
78187	1874	8710000
78188	1874	8713000
78189	1874	8716000
78190	1874	8719000
78191	1874	8722000
78192	1874	8725000
78193	1874	8728000
78194	1874	8743000
78195	1874	8746000
78196	1874	8749000
78197	1874	8752000
78198	1874	8755000
78199	1874	8758000
78200	1874	8776000
78201	1874	8779000
78202	1874	8782000
78203	1874	8785000
78204	1874	8788000
78205	1874	8791000
78206	1654	18285487999798
78207	1571	18285571999790
78208	1654	20880486001032
78246	1397	1333019436000
78247	1678	20160708664000
78248	2134	97347056000
78249	1874	8820000
78250	1924	1194000000
78260	1747	7936920000000
78261	1747	7936932000000
78262	1397	1332999434000
78263	1678	20160708666000
78264	2134	97345050000
78265	1874	8826000
78266	1522	14734207000000
78267	1522	14734218000000
78271	1546	16560988000000
78297	369	83969132000000
78298	946	505554325000000
78299	369	83732032000000
78300	1066	905948965000000
78301	369	83571932000000
78302	1186	611261950000000
78303	369	83125832000000
78304	1312	1703335737751650
78305	1397	1332959430000
78306	1678	20160708670000
78307	1397	1332949429000
78308	1678	20160708671000
78309	1397	1332939428000
78310	1678	20160708672000
78311	1397	1332929427000
78312	1678	20160708673000
78313	1397	1332919426000
78314	1678	20160708674000
78315	2134	97342041000
78316	1874	8836000
78317	2134	97341038000
78318	1874	8839000
78319	2134	97340035000
78320	1874	8842000
78321	2134	97339032000
78322	1874	8845000
78323	2134	97338029000
78324	1874	8848000
78325	1750	4167000000
78326	2132	148580581000
78327	1874	8849000
78328	2132	148579580000
78329	1874	8850000
78330	2131	195998000
78331	1726	105955111000
78332	2131	194997000
78333	1726	105955112000
78334	1688	35279901908000
78337	1634	19631892641004
78338	1634	19632352641004
78355	1726	105956110000
78356	1874	8805000
78357	1874	8808000
78358	1874	8809000
78359	1874	8812000
78360	1874	8815000
78361	1874	8818000
78362	1874	8821000
78363	1874	8824000
78364	1874	8851000
78365	1874	8854000
78366	1874	8855000
78367	1726	105956111000
78368	1654	19005571999790
77896	1874	8578000
77897	1874	8584000
77898	1874	8587000
77899	1874	8590000
77900	1874	8593000
77901	1874	8596000
77902	1874	8599000
77903	1850	17199251000000
77904	1850	17199717000000
77932	1688	33839430908000
77938	1397	1333429477000
77939	1678	20160708623000
77940	2132	148594595000
77941	1874	8688000
77942	1587	23760716000000
77943	1587	23760727000000
77961	1397	1333399474000
77962	1678	20160708626000
77963	1397	1333389473000
77964	1678	20160708627000
77965	2132	148593594000
77966	1874	8695000
77967	2134	97384167000
77968	1874	8698000
77969	2134	97383164000
77970	1874	8701000
77971	1668	20126874000000
77974	1693	3739244758018
77975	1693	3739267758018
78010	1397	1333319466000
78011	1678	20160708634000
78012	2134	97376143000
78013	1874	8724000
78014	1679	13678829652992
78015	1679	66000005000000
78016	212	13678839652984
78017	1571	20880486001040
78032	1692	28580304619999
78033	1692	28580315619999
78050	1397	1333289463000
78051	1678	20160708637000
78052	2134	97373134000
78053	1874	8734000
78054	576	82355898938283
78062	1397	1333269461000
78063	1678	20160708639000
78064	2134	97371128000
78065	1874	8740000
78066	1394	272164039000000
78067	1394	272164050000000
78085	1394	275044073000000
78086	1394	275044084000000
78103	1397	1333199454000
78104	1678	20160708646000
78105	2134	97365110000
78106	1874	8760000
78155	1397	1333109445000
78156	1678	20160708655000
78157	2134	97356083000
78158	1874	8790000
78159	1457	17184377040000
78160	1457	17184388040000
78161	1397	1333099444000
78162	1678	20160708656000
78163	2134	97355080000
78164	1874	8793000
78165	1671	15888506530515
78166	1671	15888517530515
78167	1397	1333089443000
78168	1678	20160708657000
78169	1397	1333079442000
78170	1678	20160708658000
78171	2132	148584585000
78172	1874	8794000
78173	2134	97354077000
78174	1874	8797000
78175	2134	97353074000
78176	1874	8800000
78177	1705	12875569500145
78178	1705	12875592500145
78217	470	81120482000000
78218	470	81120494000000
78234	1397	1333029437000
78235	1678	20160708663000
78236	1643	1226180514700
78237	1173	611513821681700
78238	1643	1040532914700
78239	933	505763350370200
78240	2132	148582583000
78241	1874	8814000
78242	1925	1193000000
78243	2134	97348059000
78244	1874	8817000
78245	1513	28800899000000
78251	1457	17904388040000
78252	1457	17904400040000
78269	1402	58894705319298
78270	1402	58894716319298
78272	1397	1332989433000
78273	1678	20160708667000
78274	2132	148581582000
78275	1874	8827000
78276	2157	177756999
78277	1929	1311243001
78278	1688	35279453908000
78279	1395	58085185302007706
78280	1395	58085185314007706
78335	149	84270262000341
78336	149	84270722000341
78339	1397	1332909425000
78340	1678	20160708675000
78341	2134	97337026000
78342	1874	8853000
78343	1602	15120524000000
78344	1602	15120535000000
78353	1654	19005188999798
78354	1654	19005200999798
78419	1397	1332829417000
78420	1678	20160708683000
78421	1440	15839324049920
78422	1698	18537131550035
78423	1698	18537143550035
78466	1397	1332749409000
78467	1678	20160708691000
78468	2134	97321981000
78469	1874	8903000
78470	1688	35279452908000
78486	1685	124562567571430
78487	1685	124562590571430
78492	606	77517858812962
78493	1397	1332699404000
78494	1678	20160708696000
78495	1397	1332689403000
78496	1678	20160708697000
78497	1397	1332679402000
78498	1678	20160708698000
78499	2132	148572573000
78500	1874	8914000
78501	2134	97317969000
78502	1874	8917000
78503	2157	171256999
78504	2157	170256999
78505	2134	97316966000
78506	1874	8920000
78507	2134	97315963000
78508	1874	8923000
78509	1715	42480768000002
78510	1715	200000200
78511	1849	42480803990002
78512	1514	30400
78519	1849	4459278757818
78520	1693	200000400
78568	1397	1332599394000
78569	1678	20160708706000
78570	1397	1332589393000
78571	1678	20160708707000
78572	2132	148569570000
78573	1874	8947000
78574	2134	97307939000
78575	1874	8950000
78576	2134	97306936000
78577	1874	8953000
78578	1476	17280327000000
78590	1397	1332559390000
78591	1678	20160708710000
78592	2132	148568569000
78593	1874	8960000
78594	2134	97303927000
78595	1874	8963000
78596	1425	817400000000
78597	1425	817412000000
78621	1587	24480727000000
78622	1587	24480738000000
78663	1724	10747375500000
78664	1724	10747398500000
78689	1397	1332429377000
78690	1678	20160708723000
78691	2134	97291891000
78692	1874	9002000
78693	1394	282244143000000
78694	1394	282244154000000
78717	1633	14436670985638
78770	1599	16900339393047
78771	1599	17620339393047
78784	1447	14998583943000
78030	1637	213124771819988
78040	1397	1333299464000
78041	1678	20160708636000
78042	2134	97374137000
78043	1874	8730000
78046	2132	148590591000
78047	1874	8731000
78048	576	82355886938283
78049	576	82355887938283
78093	1397	1333219456000
78094	1678	20160708644000
78095	2134	97366113000
78096	1874	8757000
78097	1702	9360330000000
78098	1702	9360341000000
78100	1397	1333209455000
78101	1678	20160708645000
78102	1633	13716670985638
78130	1394	276484084000000
78131	1394	276484107000000
78132	1397	1333149449000
78133	1678	20160708651000
78134	1397	1333139448000
78135	1678	20160708652000
78136	2134	97360095000
78137	1874	8777000
78138	2134	97359092000
78139	1874	8780000
78140	1749	7045303930000
78141	1749	7045325930000
78209	1397	1333059440000
78210	1678	20160708660000
78211	2132	148583584000
78212	1874	8804000
78213	2134	97351068000
78214	1874	8807000
78215	1395	58084465290007706
78216	1395	58084465302007706
78219	1397	1333049439000
78220	1678	20160708661000
78221	470	81120504000000
78268	1394	276484095000000
78287	599	67440012000000
78288	599	67440023000000
78290	1397	1332969431000
78291	1678	20160708669000
78292	2134	97343044000
78293	1874	8833000
78294	2157	172256999
78295	1929	1315743001
78296	1622	19980427000005
78389	1397	1332869421000
78390	1678	20160708679000
78391	2134	97333014000
78392	1874	8866000
78401	1685	123842556571430
78402	1685	123842567571430
78424	1397	1332819416000
78425	1678	20160708684000
78426	1397	1332809415000
78427	1678	20160708685000
78428	2134	97329002000
78429	1874	8880000
78430	2134	97327999000
78431	1874	8883000
78432	1394	277924095000000
78433	1394	277924127000000
78448	1397	1332779412000
78449	1678	20160708688000
78450	2134	97324990000
78451	1874	8893000
78452	1623	56162703899898
78453	1623	56162714899898
78471	1397	1332739408000
78472	1678	20160708692000
78473	1688	35999452908000
78474	1688	35999462908000
78521	1397	1332659400000
78522	1678	20160708700000
78523	2134	97313957000
78524	1874	8929000
78525	2132	148571572000
78526	1874	8930000
78527	2157	169256999
78528	2157	168256999
78529	1394	277924109000000
78550	1397	1332619396000
78551	1678	20160708704000
78552	2132	148570571000
78553	1874	8940000
78554	2157	166256999
78555	2157	165256999
78556	2157	164256999
78557	2157	163256999
78558	2134	97309945000
78559	1874	8943000
78560	1447	15274583943000
78561	1447	15274599943000
78579	1397	1332579392000
78580	1678	20160708708000
78581	2134	97305933000
78582	1874	8956000
78583	1673	23365495000000
78609	1397	1332529387000
78610	1678	20160708713000
78611	2134	97300918000
78612	1874	8972000
78613	1593	21430309000000
78614	1593	21430320000000
78628	1397	1332499384000
78629	1678	20160708716000
78630	1397	1332489383000
78631	1678	20160708717000
78632	2132	148566567000
78633	1874	8977000
78634	2134	97298912000
78635	1874	8980000
78636	2134	97297909000
78637	1874	8983000
78638	1394	279364109000000
78639	1394	279364132000000
78646	1555	10996895979096
78647	1555	11716895979096
78648	1555	14554586940000
78649	1447	11717701982097
78650	1527	272999977
78681	1768	17150833110000
78682	1768	17150844110000
78695	1397	1332419376000
78696	1678	20160708724000
78697	2134	97290888000
78698	1874	9005000
78699	2132	148564565000
78700	1874	9006000
78701	632	74781235000000
78702	632	74781247000000
78705	1397	1332409375000
78706	1678	20160708725000
78707	2134	97289885000
78708	1874	9009000
78709	1690	128884104000000
78710	1690	128884115000000
78718	1397	1332389373000
78719	1678	20160708727000
78720	1394	283684175000000
78721	1397	1332379372000
78722	1678	20160708728000
78723	2134	97287879000
78724	1874	9015000
78725	2134	97286876000
78726	1874	9018000
78727	2132	148563564000
78728	1874	9019000
78729	1394	285124175000000
78730	1394	285124188000000
78786	1397	1332349369000
78787	1678	20160708731000
78788	2134	97283867000
78789	1874	9029000
78790	1596	18000749000000
78808	1394	286564187000000
78809	1394	286564199000000
78812	1397	1332309365000
78813	1678	20160708735000
78814	2134	97279855000
78815	1874	9042000
78816	1991	19915983441475
78817	1991	19915994441475
78842	1397	1332269361000
78843	1678	20160708739000
78844	2134	97275843000
78845	1874	9055000
78846	415	66720011000000
78865	1703	9360815000000
78880	1471	22219854900000
78881	1471	22219866900000
78884	1397	1332209355000
78885	1678	20160708745000
78886	1397	1332199354000
78887	1678	20160708746000
78888	2134	97269825000
78889	1874	9075000
78890	1679	13678850653000
78892	1397	1332189353000
78893	1678	20160708747000
78253	1397	1333009435000
78254	1678	20160708665000
78255	2134	97346053000
78256	1874	8823000
78257	2157	182957000
78258	1929	1307043000
78259	1690	127444072000000
78281	1397	1332979432000
78282	1678	20160708668000
78283	2134	97344047000
78284	1874	8830000
78285	1422	10225053860211
78286	1422	10225064860211
78289	1675	14542252999977
78345	1397	1332899424000
78346	1678	20160708676000
78347	2118	1396000000
78348	1726	105956112000
78349	2134	97336023000
78350	1874	8856000
78351	576	83075898938283
78352	576	83075910938283
78393	1703	9360793000000
78394	1703	9360804000000
78409	1397	1332839418000
78410	1678	20160708682000
78411	2134	97331008000
78412	1874	8873000
78434	1690	128164072000000
78435	1690	128164104000000
78447	1694	20892703127629
78545	1596	18000738000000
78546	1596	18000769000000
78549	1746	8434405000000
78562	1397	1332609395000
78563	1678	20160708705000
78564	2134	97308942000
78565	1874	8946000
78566	1395	58085905325007706
78567	1395	58085905336007706
78584	1397	1332569391000
78585	1678	20160708709000
78586	2134	97304930000
78587	1874	8959000
78588	1395	58086625336007706
78589	1395	58086625347007706
78600	1397	1332549389000
78601	1678	20160708711000
78602	1397	1332539388000
78603	1678	20160708712000
78604	2134	97302924000
78605	1874	8966000
78606	2134	97301921000
78607	1874	8969000
78608	1762	19762060994000
78651	1397	1332469381000
78652	1678	20160708719000
78653	1397	1332459380000
78654	1678	20160708720000
78655	2132	148565566000
78656	1874	8987000
78657	2134	97295903000
78658	1874	8990000
78659	2134	97294900000
78660	1874	8993000
78661	1599	17620329393047
78662	1599	17620352393047
78675	1397	1332449379000
78676	1678	20160708721000
78677	2134	97293897000
78678	1874	8996000
78679	1522	15454218000000
78680	1522	15454229000000
78703	1395	58087345347007706
78704	1395	58087345359007706
78801	1397	1332319366000
78802	1678	20160708734000
78803	2134	97280858000
78804	1874	9038000
78805	2132	148561562000
78806	1874	9039000
78807	1756	6913121545609
78828	1688	36719462908000
78829	1688	36719473908000
78836	1397	1332279362000
78837	1678	20160708738000
78838	2134	97276846000
78839	1874	9052000
78840	1693	5179278757818
78841	1693	5179289757818
78855	1397	1332249359000
78856	1678	20160708741000
78857	1397	1332239358000
78858	1678	20160708742000
78859	2134	97273837000
78860	1874	9062000
78861	2134	97272834000
78862	1874	9065000
78863	1693	5899289757818
78864	1693	5899311757818
78866	1397	1332229357000
78867	1678	20160708743000
78868	2134	97271831000
78869	1874	9068000
78870	1522	16174229000000
78871	1522	16174240000000
78882	1608	17565701000000
78883	1608	17565713000000
78916	1397	1332149349000
78917	1678	20160708751000
78918	2133	97507020000
78919	1874	9091000
78920	2134	97264810000
78921	1874	9094000
78923	1397	1332139348000
78924	1678	20160708752000
78925	1397	1332129347000
78926	1678	20160708753000
78927	1397	1332119346000
78928	1678	20160708754000
78929	2132	148555556000
78930	1874	9095000
78931	2134	97263807000
78932	1874	9098000
78933	2133	97506018000
78934	1874	9100000
78935	2133	97505016000
78936	1874	9102000
78937	2134	97262804000
78938	1874	9105000
78939	2133	97504014000
78940	1874	9107000
78941	2134	97261801000
78942	1874	9110000
78943	1688	36719499908000
78945	1874	9097000
78946	1874	9099000
78947	1874	9101000
78948	606	77517892812962
78988	1397	1332079342000
78989	1678	20160708758000
78990	1681	12743262759830
78991	2133	97500006000
78992	1874	9128000
78993	2134	97257789000
78994	1874	9131000
78995	1681	13463264759830
78996	1397	1332069341000
78997	1678	20160708759000
78998	2133	97499004000
78999	1874	9133000
79037	1395	58088785371007706
79038	1395	58088785383007706
79056	1395	58089505383007706
79057	1395	58089505408007706
79063	1397	1332009335000
79064	1678	20160708765000
79065	2134	97251771000
79066	1874	9163000
79067	2133	97492992000
79068	1874	9165000
79069	1489	16464409000000
79070	1489	16464421000000
79072	1476	18000327000000
79073	1476	18000329000000
79075	1476	18000339000000
79095	1548	720000000000
79096	1548	720012000000
79127	1397	1331939328000
79128	1678	20160708772000
79129	2133	97485978000
79130	1874	9196000
79131	2134	97245753000
79132	1874	9199000
79133	1719	16580663000000
79134	1719	16580675000000
79167	1397	1331929327000
79168	1678	20160708773000
79169	2133	97484976000
79170	1874	9201000
79171	2134	97244750000
79172	1874	9204000
79173	1679	14398850653000
79174	1679	14398862653000
79183	2133	97483974000
78369	1654	19006212999790
78370	369	83119112000000
78371	946	505560945000000
78372	369	83107162000000
78373	1066	905960815000000
78374	369	83099062000000
78375	1186	611269950000000
78376	369	83076662000000
78377	1312	1703358037751650
78378	1397	1332889423000
78379	1678	20160708677000
78380	1397	1332879422000
78381	1678	20160708678000
78382	2132	148578579000
78383	1874	8857000
78384	2134	97335020000
78385	1874	8860000
78386	2134	97334017000
78387	1874	8863000
78388	1711	17805315000000
78395	1397	1332859420000
78396	1678	20160708680000
78397	2132	148577578000
78398	1874	8867000
78399	1671	16608517530515
78400	1671	16608528530515
78403	1397	1332849419000
78404	1678	20160708681000
78405	2134	97332011000
78406	1874	8870000
78407	1749	7765325930000
78408	1749	7765336930000
78413	2134	97330005000
78414	1874	8876000
78415	2132	148576577000
78416	1874	8877000
78417	1440	15839312049920
78418	1440	15839314049920
78436	1397	1332799414000
78437	1678	20160708686000
78438	1397	1332789413000
78439	1678	20160708687000
78440	2134	97326996000
78441	1874	8886000
78442	2134	97325993000
78443	1874	8889000
78444	2132	148575576000
78445	1874	8890000
78446	1394	277924118000000
78454	1397	1332769411000
78455	1678	20160708689000
78456	1397	1332759410000
78457	1678	20160708690000
78458	2134	97323987000
78459	1874	8896000
78460	2134	97322984000
78461	1874	8899000
78462	2132	148574575000
78463	1874	8900000
78464	1426	21165128000000
78465	1426	21165151000000
78475	1397	1332729407000
78476	1678	20160708693000
78477	1397	1332719406000
78478	1678	20160708694000
78479	2132	148573574000
78480	1874	8904000
78481	2134	97320978000
78482	1874	8907000
78483	2134	97319975000
78484	1874	8910000
78485	1395	58085185325007706
78488	1397	1332709405000
78489	1678	20160708695000
78490	2134	97318972000
78491	1874	8913000
78513	1397	1332669401000
78514	1678	20160708699000
78515	2134	97314960000
78516	1874	8926000
78517	1693	4459267758018
78518	1693	4459278758018
78530	1397	1332649399000
78531	1678	20160708701000
78532	1397	1332639398000
78533	1678	20160708702000
78534	1397	1332629397000
78535	1678	20160708703000
78536	2134	97312954000
78537	1874	8933000
78538	2157	167256999
78539	2134	97311951000
78540	1874	8936000
78541	2134	97310948000
78542	1874	8939000
78543	1747	8656920000000
78544	1747	8656954000000
78547	1708	13715839000021
78548	1708	13715873000021
78598	1695	15452308000000
78599	1695	15452320000000
78615	1397	1332519386000
78616	1678	20160708714000
78617	2132	148567568000
78618	1874	8973000
78619	1696	16337425835100
78620	1696	16337436835100
78623	1397	1332509385000
78624	1678	20160708715000
78625	2134	97299915000
78626	1874	8976000
78627	1768	16430833110000
78640	1397	1332479382000
78641	1678	20160708718000
78642	2134	97296906000
78643	1874	8986000
78644	1749	8485336930000
78645	1749	8485347930000
78665	1599	16901273393047
78666	1874	8729000
78667	1874	8732000
78668	1874	8733000
78669	1874	8735000
78670	1874	8736000
78671	1874	8738000
78672	1874	8739000
78673	1599	17621273393047
78674	1599	17622180393047
78683	1397	1332439378000
78684	1678	20160708722000
78685	2134	97292894000
78686	1874	8999000
78687	1394	280804132000000
78688	1394	280804143000000
78711	1397	1332399374000
78712	1678	20160708726000
78713	2134	97288882000
78714	1874	9012000
78715	1394	283684154000000
78716	1394	283684165000000
78731	1874	8742000
78732	1599	17622262393047
78733	1874	8745000
78734	1874	8748000
78735	1874	8751000
78736	1874	8806000
78737	1874	8869000
78738	1874	8872000
78739	1874	8875000
78740	1874	8878000
78741	1874	8881000
78742	1874	8884000
78743	1874	8887000
78744	1874	8902000
78745	1874	8905000
78746	1874	8908000
78747	1874	8911000
78748	1874	8932000
78749	1874	8935000
78750	1874	8938000
78751	1874	8941000
78752	1874	8944000
78753	1874	8962000
78754	1874	8965000
78755	1874	8968000
78756	1874	8971000
78757	1874	8974000
78758	1874	8989000
78759	1874	8992000
78760	1874	8995000
78761	1874	8998000
78762	1874	9001000
78763	1874	9004000
78764	1874	9007000
78765	1874	9010000
78766	1874	9013000
78767	1874	9016000
78768	1599	18342262393047
78769	1599	18342369393047
78772	1397	1332369371000
78773	1678	20160708729000
78774	1397	1332359370000
78775	1678	20160708730000
78776	2132	148562563000
78777	1874	9020000
78778	2134	97285873000
78779	1874	9023000
78780	2134	97284870000
78781	1874	9026000
78782	1508	16596553500009
78783	1508	16596576500009
78791	1397	1332339368000
78792	1678	20160708732000
78793	1397	1332329367000
78794	1678	20160708733000
78795	2134	97282864000
78796	1874	9032000
78797	2134	97281861000
78798	1874	9035000
78799	1394	285124165000000
78800	1394	285124187000000
78810	1440	16559314049920
78811	1440	16559326049920
78818	1395	58088065359007706
78819	1395	58088065370007706
78822	1397	1332299364000
78823	1678	20160708736000
78824	2134	97278852000
78825	1874	9045000
78826	1696	17057436835100
78827	1696	17057447835100
78830	1397	1332289363000
78831	1678	20160708737000
78832	2134	97277849000
78833	1874	9048000
78834	2132	148560561000
78835	1874	9049000
78847	1397	1332259360000
78848	1678	20160708740000
78849	2134	97274840000
78850	1874	9058000
78851	2132	148559560000
78852	1874	9059000
78853	1471	21499842900000
78854	1471	21499854900000
78891	1394	288004220000000
78899	1397	1332179352000
78900	1678	20160708748000
78901	2134	97267819000
78902	1874	9082000
78903	1489	15744409000000
78955	1874	9044000
78956	1874	9046000
78957	1874	9050000
78958	2133	97502010000
78959	1874	9054000
78960	1675	15262252999977
78961	1675	15262259999977
78977	1874	9074000
78978	1874	9077000
78979	1874	9080000
78980	1874	9083000
78981	1874	9088000
78982	1874	9090000
78983	1874	9092000
78984	1874	9093000
78985	1874	9104000
78986	1874	9116000
78987	1716	19487067000000
79008	1397	1332049339000
79009	1678	20160708761000
79010	1874	9070000
79011	1874	9081000
79012	1874	9084000
79013	1874	9087000
79014	2132	148553554000
79015	1874	9103000
79016	1874	9106000
79017	1874	9109000
79018	1874	9112000
79019	1874	9121000
79020	1874	9124000
79021	1874	9127000
79022	1874	9129000
79023	1874	9137000
79024	1874	9139000
79025	2133	97497000000
79026	1874	9141000
79027	2134	97255783000
79028	1874	9144000
79029	1740	16485557000000
79055	1549	22655993000000
79058	1419	29979672280064
79059	1419	29979697280064
79103	1397	1331959330000
79104	1678	20160708770000
79105	2133	97487982000
79106	1874	9185000
79107	2134	97247759000
79108	1874	9188000
79109	1678	20880708770000
79110	1678	20880720770000
79113	1397	1331949329000
79114	1678	20160708771000
79115	2132	148550551000
79116	1874	9189000
79117	2134	97246756000
79118	1874	9192000
79119	2133	97486980000
79120	1874	9194000
79121	1394	290884223000000
79122	1394	290884236000000
79125	1703	10080815000000
79126	1703	10080828000000
79177	1397	1331919326000
79178	1678	20160708774000
79179	2134	97243747000
79180	1874	9207000
79181	2132	148549550000
79182	1874	9208000
79188	1395	58090225408007706
79205	632	74781246000000
79280	1708	14435911000021
79281	1708	15155911000021
79284	1724	10747424500000
79285	1724	11467424500000
79286	2087	4319107000000
79328	1397	1331759310000
79329	1678	20160708790000
79330	2132	148544545000
79331	1874	9292000
79332	2133	97466940000
79333	1874	9294000
79334	2134	97227699000
79335	1874	9297000
79336	1650	10114172000000
79337	1650	10114185000000
79362	1656	18861668999990
79363	1656	18861681999990
79411	1850	17200567000000
79412	1726	104745110000
79413	1726	103535110000
79414	1850	17920567000000
79415	1850	17921687000000
79442	42	93358480000000
79443	42	93358492000000
79460	1397	1331619296000
79461	1678	20160708804000
79462	2133	97452912000
79463	1874	9365000
79464	2134	97214660000
79465	1874	9368000
79466	369	83796662000000
79467	369	83796674000000
79502	1397	1331589293000
79503	1678	20160708807000
79504	1397	1331579292000
79505	1678	20160708808000
79506	2185	199000000
79507	2134	97212654000
79508	1874	9379000
79509	2134	97211651000
79510	1874	9382000
79511	2133	97449906000
79512	1874	9384000
79513	2133	97448904000
79514	1874	9386000
79515	1618	2160023000000
79516	1618	2160048000000
79525	1675	16702287999977
79526	1675	16702299999977
79544	1715	43200715990002
79545	1397	1331539288000
79546	1678	20160708812000
79547	2134	97207639000
79548	1874	9405000
79549	2133	97444896000
79550	1874	9407000
79551	1637	213124872819988
79574	1397	1331509285000
79575	1678	20160708815000
79576	2133	97441890000
79577	1874	9420000
79578	2134	97204630000
79579	1874	9423000
79580	1637	213844872819988
79581	1637	213844884819988
79597	1715	43199515990002
79598	2186	100000000
79599	1397	1331479282000
78785	1739	28355927000000
78820	1573	13659145000000
78821	1573	13659156000000
78872	1397	1332219356000
78873	1678	20160708744000
78874	2134	97270828000
78875	1874	9071000
78876	2132	148558559000
78877	1874	9072000
78878	1394	288004199000000
78879	1394	288004211000000
78904	1397	1332169351000
78905	1678	20160708749000
78906	2134	97266816000
78907	1874	9085000
78908	1926	1191000000
78922	2106	4319083000000
78962	1397	1332099344000
78963	1678	20160708756000
78964	2134	97259795000
78965	1874	9118000
78966	1874	9120000
78968	1397	1332089343000
78969	1678	20160708757000
78970	2133	97501008000
78971	1874	9122000
78972	2132	148554555000
78973	1874	9123000
78974	2134	97258792000
78975	1874	9126000
78976	1716	19486938000000
79000	1397	1332059340000
79001	1678	20160708760000
79002	2133	97498002000
79003	1874	9135000
79004	2134	97256786000
79005	1874	9138000
79006	1394	289444211000000
79007	1394	289444223000000
79030	1740	16485345000000
79039	1397	1332029337000
79040	1678	20160708763000
79041	1397	1332019336000
79042	1678	20160708764000
79043	2132	148552553000
79044	1874	9150000
79045	2134	97253777000
79046	1874	9153000
79047	2134	97252774000
79048	1874	9156000
79049	2133	97494996000
79050	1874	9158000
79051	2133	97493994000
79052	1874	9160000
79053	1688	37439473908000
79054	1688	37439498908000
79060	1419	29261663280064
79061	1419	29981663280064
79062	1419	29982283280064
79071	1395	58089505395007706
79076	1397	1331999334000
79077	1678	20160708766000
79078	1397	1331989333000
79079	1678	20160708767000
79080	2133	97491990000
79081	1874	9167000
79082	2134	97250768000
79083	1874	9170000
79084	2132	148551552000
79085	1874	9171000
79086	2133	97490988000
79087	1874	9173000
79088	1688	37439497908000
79111	1715	43200803990002
79112	1715	43200815990002
79123	1702	10080341000000
79124	1702	10080354000000
79135	1395	58090225395007706
79136	1395	58090225407007706
79175	1394	292324236000000
79176	1394	292324248000000
79189	1513	29520899000000
79190	1513	29520912000000
79192	1397	1331909325000
79193	1678	20160708775000
79194	2133	97482972000
79195	1874	9212000
79196	2134	97242744000
79197	1874	9215000
79198	1588	18215061000000
79208	1397	1331889323000
79209	1678	20160708777000
79210	1397	1331879322000
79211	1678	20160708778000
79212	2132	148548549000
79213	1874	9218000
79214	2134	97241741000
79215	1874	9221000
79216	2134	97240738000
79217	1874	9224000
79218	2133	97480968000
79219	1874	9226000
79220	2133	97479966000
79221	1874	9228000
79222	1688	38159497908000
79223	1688	38159522908000
79250	1397	1331839318000
79251	1678	20160708782000
79252	2134	97236726000
79253	1874	9247000
79258	1508	17316576500009
79259	1508	17316588500009
79282	2086	2879115000000
79283	2086	3599115000000
79309	1397	1331769311000
79310	1678	20160708789000
79311	2133	97472952000
79312	1874	9278000
79313	2134	97228702000
79314	1874	9281000
79315	2133	97471950000
79316	1874	9283000
79317	2133	97470948000
79318	1874	9285000
79319	2133	97469946000
79320	1874	9287000
79321	2133	97468944000
79322	1874	9289000
79323	2133	97467942000
79324	1874	9291000
79325	1756	6913126545609
79327	1718	8946813763340
79353	1397	1331729307000
79354	1678	20160708793000
79355	2133	97463934000
79356	1874	9306000
79357	2132	148543544000
79358	1874	9307000
79359	2134	97225693000
79360	1874	9310000
79361	1458	19533762908540
79364	1397	1331719306000
79365	1678	20160708794000
79366	1726	103536112000
79367	2184	200000000
79368	2134	97224690000
79369	1874	9313000
79370	2133	97462932000
79371	1874	9315000
79372	1402	59614716319298
79373	1402	59614738319298
79396	1397	1331689303000
79397	1678	20160708797000
79398	1397	1331679302000
79399	1678	20160708798000
79400	2184	199000000
79401	2133	97459926000
79402	1874	9328000
79403	2133	97458924000
79404	1874	9330000
79405	2134	97221681000
79406	1874	9333000
79407	2134	97220678000
79408	1874	9336000
79409	1850	17919133000000
79410	1850	17919158000000
79416	1397	1331669301000
79417	1678	20160708799000
79418	2134	97219675000
79419	1874	9339000
79420	2133	97457922000
79421	1874	9341000
79422	1622	20700427000005
79423	1622	20700439000005
79424	1397	1331659300000
79425	1678	20160708800000
79426	2133	97456920000
79427	1874	9343000
79428	2134	97218672000
79429	1874	9346000
79430	2132	148541542000
79431	1874	9347000
79432	1723	19079515085979
79433	1723	19079528085979
79444	1397	1331639298000
78894	2134	97268822000
78895	1874	9078000
78896	2132	148557558000
78897	1874	9079000
78898	1573	13659157000000
78909	1397	1332159350000
78910	1678	20160708750000
78911	2132	148556557000
78912	1874	9086000
78913	2134	97265813000
78914	1874	9089000
78915	1395	58088065371007706
78944	606	77517895812962
78949	1397	1332109345000
78950	1678	20160708755000
78951	2134	97260798000
78952	1874	9113000
78953	2133	97503012000
78954	1874	9115000
78967	1675	15262264999977
79031	1397	1332039338000
79032	1678	20160708762000
79033	2133	97495998000
79034	1874	9146000
79035	2134	97254780000
79036	1874	9149000
79074	1489	16464411000000
79089	1397	1331979332000
79090	1678	20160708768000
79091	2133	97489986000
79092	1874	9175000
79093	2134	97249765000
79094	1874	9178000
79097	1397	1331969331000
79098	1678	20160708769000
79099	2134	97248762000
79100	1874	9181000
79101	2133	97488984000
79102	1874	9183000
79137	1708	14435873000021
79138	1708	14435885000021
79139	1874	9022000
79140	1874	9024000
79141	1874	9028000
79142	1874	9031000
79143	1874	9034000
79144	1874	9037000
79145	1874	9040000
79146	1874	9041000
79147	1874	9056000
79148	1874	9060000
79149	1874	9064000
79150	1874	9066000
79151	1874	9076000
79152	1874	9096000
79153	1874	9108000
79154	1874	9111000
79155	1874	9114000
79156	1874	9117000
79157	1874	9132000
79158	1874	9147000
79159	1874	9159000
79160	1874	9162000
79161	1874	9168000
79162	1874	9174000
79163	1874	9177000
79164	1874	9180000
79165	1874	9186000
79166	1719	16581177000000
79191	1718	8946809763340
79199	1397	1331899324000
79200	1678	20160708776000
79201	2133	97481970000
79202	1874	9217000
79203	1458	19533749908540
79204	1458	19533760908540
79224	1708	15155885000021
79225	1708	15155910000021
79254	2133	97475958000
79255	1874	9246000
79256	1874	9249000
79257	1474	13953436000023
79278	1699	7269864750126
79279	1699	7989864750126
79326	1695	15452325000000
79344	1397	1331739308000
79345	1678	20160708792000
79346	2134	97226696000
79347	1874	9302000
79348	2133	97464936000
79349	1874	9304000
79350	1685	124562579571430
79374	1394	292324258000000
79376	1397	1331709305000
79377	1678	20160708795000
79378	2131	193997000
79379	2172	199000000
79380	2134	97223687000
79381	1874	9318000
79382	2133	97461930000
79383	1874	9320000
79384	2039	18001493000000
79385	2039	18001506000000
79434	1397	1331649299000
79435	1678	20160708801000
79436	2134	97217669000
79437	1874	9350000
79438	2133	97455918000
79439	1874	9352000
79440	1691	15803210100019
79441	1691	15803222100019
79469	1467	11486762100039
79470	1467	11486774100039
79477	1395	58090225456007706
79493	1397	1331599294000
79494	1678	20160708806000
79495	1874	9372000
79496	2134	97213657000
79497	1874	9375000
79498	2132	148539540000
79499	1874	9376000
79500	1675	15982264999977
79501	1675	15982287999977
79520	1397	1331569291000
79521	1678	20160708809000
79522	2134	97210648000
79523	1874	9389000
79524	1874	9391000
79566	1397	1331519286000
79567	1678	20160708814000
79568	2133	97442892000
79569	1874	9415000
79570	2134	97205633000
79571	1874	9418000
79572	1680	14409608500035
79573	1680	14409620500035
79590	1397	1331489283000
79591	1678	20160708817000
79592	2132	148536537000
79593	1874	9429000
79594	2133	97439886000
79595	1874	9431000
79596	1394	295204260000000
79629	1397	1331439278000
79630	1678	20160708822000
79631	2133	97434876000
79632	1874	9454000
79633	2134	97198612000
79634	1874	9457000
79637	1489	17184421000000
79638	1489	17184433000000
79658	1397	1331409275000
79659	1678	20160708825000
79660	2133	97431870000
79661	1874	9470000
79662	2134	97195603000
79663	1874	9473000
79664	1394	296644260000000
79665	1394	296644272000000
79708	1715	43395483296216
79709	2186	524057693786
79710	1397	1331359270000
79711	1678	20160708830000
79712	2134	97190588000
79713	1874	9497000
79714	2132	148532533000
79715	1874	9498000
79716	1536	15120863999959
79718	1440	17279438049920
79756	1715	43591425602430
79814	1394	302404409000000
79815	1394	302404421000000
79858	1679	16558997653000
79859	1679	16559112653000
79864	1708	15155896000021
79882	1394	305284545000000
79883	1394	305284657000000
79888	2039	18721506000000
79889	2039	18721516000000
79895	1397	1331129247000
79896	1678	20160708853000
79897	1397	1331119246000
79898	1678	20160708854000
79899	2132	148525526000
79900	1874	9592000
79184	1874	9206000
79185	1874	9209000
79186	1874	9210000
79187	1560	17154391277001
79206	1447	15994599943000
79207	1447	15994610943000
79226	1397	1331869321000
79227	1678	20160708779000
79228	1397	1331859320000
79229	1678	20160708780000
79230	1397	1331849319000
79231	1678	20160708781000
79232	1726	104746112000
79233	2172	200000000
79234	2133	97478964000
79235	1874	9230000
79236	2134	97239735000
79237	1874	9233000
79238	2134	97238732000
79239	1874	9236000
79240	2134	97237729000
79241	1874	9239000
79242	2133	97477962000
79243	1874	9241000
79244	2133	97476960000
79245	1874	9243000
79246	2132	148547548000
79247	1874	9244000
79248	1649	23324309999992
79249	1649	23324356999992
79260	1397	1331829317000
79261	1678	20160708783000
79262	1397	1331819316000
79263	1678	20160708784000
79264	2133	97474956000
79265	1874	9251000
79266	2132	148546547000
79267	1874	9252000
79268	2134	97235723000
79269	1874	9255000
79270	2134	97234720000
79271	1874	9258000
79272	2133	97473954000
79273	1874	9260000
79274	2172	198999000
79275	2131	194998000
79276	1649	23324382999992
79277	1649	24044382999992
79287	1397	1331809315000
79288	1678	20160708785000
79289	1397	1331799314000
79290	1678	20160708786000
79291	1397	1331789313000
79292	1678	20160708787000
79293	1397	1331779312000
79294	1678	20160708788000
79295	2132	148545546000
79296	1874	9261000
79297	2134	97233717000
79298	1874	9264000
79299	2134	97232714000
79300	1874	9267000
79301	2134	97231711000
79302	1874	9270000
79303	2134	97230708000
79304	1874	9273000
79305	2134	97229705000
79306	1874	9276000
79307	2095	14436716975638
79308	1633	200180000
79338	1397	1331749309000
79339	1678	20160708791000
79340	2133	97465938000
79341	1874	9299000
79342	1679	15118862653000
79343	1679	15118873653000
79351	263	66720000000000
79352	263	66720012000000
79375	1637	213124782819988
79386	1397	1331699304000
79387	1678	20160708796000
79388	2133	97460928000
79389	1874	9322000
79390	2132	148542543000
79391	1874	9323000
79392	2134	97222684000
79393	1874	9326000
79394	1571	21600486001024
79395	1571	21600499001024
79468	369	83796664000000
79471	2035	150000000
79472	1397	1331609295000
79473	1678	20160708805000
79474	2133	97451910000
79475	1874	9370000
79476	1670	20881234000000
79478	1726	102326112000
79479	2185	200000000
79480	2131	193996000
79481	2172	200001000
79482	1874	9130000
79483	1874	9134000
79484	1874	9136000
79485	1874	9140000
79486	1874	9142000
79487	1874	9148000
79488	1874	9152000
79489	1874	9154000
79490	2133	97450908000
79491	1675	15982259999977
79492	1675	15982391999977
79517	2133	97447902000
79518	1675	16702391999977
79519	1675	16702395999977
79527	1394	293764248000000
79552	1397	1331529287000
79553	1678	20160708813000
79554	2132	148537538000
79555	1874	9408000
79556	2133	97443894000
79557	1874	9410000
79558	2134	97206636000
79559	1874	9413000
79560	1394	295204248000000
79561	1394	295204261000000
79564	1608	18285713000000
79565	1608	18285726000000
79613	1397	1331459280000
79614	1678	20160708820000
79615	1397	1331449279000
79616	1678	20160708821000
79617	2133	97436880000
79618	1874	9443000
79619	2133	97435878000
79620	1874	9445000
79621	2134	97200618000
79622	1874	9448000
79623	2134	97199615000
79624	1874	9451000
79625	2132	148535536000
79626	1874	9452000
79627	1715	43919515990002
79628	1715	43919540990002
79635	1440	17279326049920
79636	1440	17279338049920
79666	1397	1331399274000
79667	1678	20160708826000
79668	2133	97430868000
79669	1874	9475000
79670	2134	97194600000
79671	1874	9478000
79672	1394	298084272000000
79673	1394	298084284000000
79696	1397	1331369271000
79697	1678	20160708829000
79698	2133	97427862000
79699	1874	9491000
79700	2134	97191591000
79701	1874	9494000
79702	1394	299524284000000
79703	1394	299524296000000
79717	1394	299524396000000
79724	1397	1331339268000
79725	1678	20160708832000
79726	1397	1331329267000
79727	1678	20160708833000
79728	1397	1331319266000
79729	1678	20160708834000
79730	2133	97425858000
79731	1874	9502000
79732	2133	97424856000
79733	1874	9504000
79734	2132	148531532000
79735	1874	9505000
79736	2134	97189585000
79737	1874	9508000
79738	2133	97423854000
79739	1874	9510000
79740	2134	97188582000
79741	1874	9513000
79742	2134	97187579000
79743	1874	9516000
79744	1688	38879522908000
79745	1688	38879559908000
79796	1715	43067367908644
79445	1678	20160708802000
79446	1397	1331629297000
79447	1678	20160708803000
79448	2132	148540541000
79449	1874	9353000
79450	2133	97454916000
79451	1874	9355000
79452	2134	97216666000
79453	1874	9358000
79454	2134	97215663000
79455	1874	9361000
79456	2133	97453914000
79457	1874	9363000
79458	1592	720009000000
79459	1592	720034000000
79528	1397	1331559290000
79529	1678	20160708810000
79530	1397	1331549289000
79531	1678	20160708811000
79532	2134	97209645000
79533	1874	9394000
79534	2132	148538539000
79535	1874	9395000
79536	2133	97446900000
79537	1874	9397000
79538	2133	97445898000
79539	1874	9399000
79540	2134	97208642000
79541	1874	9402000
79542	1710	20394759473290
79543	1710	20394784473290
79562	1673	24085495000000
79563	1673	24085508000000
79582	1397	1331499284000
79583	1678	20160708816000
79584	2133	97440888000
79585	1874	9425000
79586	2134	97203627000
79587	1874	9428000
79588	1685	125282579571430
79589	1685	125282591571430
79643	1397	1331429277000
79644	1678	20160708823000
79645	1397	1331419276000
79646	1678	20160708824000
79647	2133	97433874000
79648	1874	9459000
79649	2134	97197609000
79650	1874	9462000
79651	2134	97196606000
79652	1874	9465000
79653	2133	97432872000
79654	1874	9467000
79655	2132	148534535000
79656	1874	9468000
79657	1395	58090225420007706
79674	1670	21601234000000
79675	1670	21601246000000
79678	1397	1331389273000
79679	1678	20160708827000
79680	2132	148533534000
79681	1874	9479000
79682	2133	97429866000
79683	1874	9481000
79684	2134	97193597000
79685	1874	9484000
79686	1637	214564884819988
79687	1637	214564897819988
79704	1710	21114784473290
79705	1710	21114796473290
79746	1715	42871425602430
79747	50	66523957693786
79748	1397	1331309265000
79749	1678	20160708835000
79750	2134	97186576000
79751	1874	9519000
79752	2133	97422852000
79753	1874	9521000
79754	1623	56882714899898
79755	1623	56882826899898
79785	1395	58090945469007706
79805	1395	58090945532007706
79837	2134	97177549000
79838	1874	9569000
79839	2134	97176546000
79840	1874	9572000
79841	2133	97412832000
79842	1874	9574000
79843	1719	16580686000000
79852	1874	9570000
79853	1874	9573000
79854	2134	97175543000
79855	1874	9576000
79856	1874	9578000
79857	1719	17300798000000
79860	1397	1331179252000
79861	1678	20160708848000
79862	2134	97174540000
79863	1874	9581000
79884	1397	1331149249000
79885	1678	20160708851000
79886	1394	306724657000000
79887	1394	306724667000000
79890	1397	1331139248000
79891	1678	20160708852000
79892	2134	97171531000
79893	1874	9591000
79894	1395	58090945431007706
79911	1726	101116112000
79912	2187	200000000
79913	1397	1331099244000
79914	1678	20160708856000
79915	2134	97167519000
79916	1874	9604000
79917	849	1158280730361640
79918	2152	29767163100000
79919	2148	2159068000000
79920	1397	1331089243000
79921	1678	20160708857000
79922	1397	1331079242000
79923	1678	20160708858000
79924	1397	1331069241000
79925	1678	20160708859000
79926	2134	97166516000
79927	1874	9607000
79928	2134	97165513000
79929	1874	9610000
79930	2134	97164510000
79931	1874	9613000
79932	2132	148524525000
79933	1874	9614000
79934	1679	16559031653000
79980	1397	1330999234000
79981	1678	20160708866000
79982	1397	1330989233000
79983	1678	20160708867000
79984	2132	148521522000
79985	1874	9632000
79986	1622	20700460000005
79987	2134	97158492000
79988	1874	9635000
79989	2134	97157489000
79990	1874	9638000
79991	1622	21420460000005
79992	1622	21420462000005
80009	1397	1330979232000
80010	1678	20160708868000
80011	2134	97156486000
80012	1874	9641000
80013	1637	216005008819988
80014	1637	216005019819988
80035	1397	1330939228000
80036	1678	20160708872000
80037	2134	97153477000
80038	1874	9651000
80039	1394	311044711000000
80040	1394	311044722000000
80049	1710	21114795473290
80106	1397	1330829217000
80107	1678	20160708883000
80108	1419	30699697280064
80109	1419	30699707280064
80112	1397	1330819216000
80113	1678	20160708884000
80114	2132	148516517000
80115	1874	9685000
80116	1980	16559402000000
80117	1980	16559413000000
80134	1397	1330789213000
80135	1678	20160708887000
80136	2134	97139435000
80137	1874	9697000
80138	2132	148515516000
80139	1874	9698000
80140	1463	720012000000
80169	1685	127442614571430
80170	1685	127442637571430
80185	1727	16027225000000
80188	1397	1330709205000
80189	1678	20160708895000
80190	1397	1330699204000
80191	1678	20160708896000
80192	2134	97131411000
80193	1874	9724000
80194	2134	97130408000
79600	1678	20160708818000
79601	1397	1331469281000
79602	1678	20160708819000
79603	2133	97438884000
79604	1874	9433000
79605	2134	97202624000
79606	1874	9436000
79607	2134	97201621000
79608	1874	9439000
79609	2133	97437882000
79610	1874	9441000
79611	1679	15838873653000
79612	1679	15838997653000
79639	1715	42480703990002
79640	1715	42479503990002
79641	1634	20352352641004
79642	1634	20352633641004
79676	1395	58090945420007706
79677	1395	58090945432007706
79688	1397	1331379272000
79689	1678	20160708828000
79690	2134	97192594000
79691	1874	9487000
79692	2133	97428864000
79693	1874	9489000
79694	1709	13680209999976
79695	1709	13680221999976
79706	1749	9205347930000
79707	1749	9205359930000
79719	1397	1331349269000
79720	1678	20160708831000
79721	2133	97426860000
79722	1874	9500000
79723	369	83796673000000
79757	1397	1331299264000
79758	1678	20160708836000
79759	1397	1331289263000
79760	1678	20160708837000
79761	1397	1331279262000
79762	1678	20160708838000
79763	1397	1331269261000
79764	1678	20160708839000
79765	2134	97185573000
79766	1874	9524000
79767	2134	97184570000
79768	1874	9527000
79769	2134	97183567000
79770	1874	9530000
79771	2134	97182564000
79772	1874	9533000
79773	2133	97421850000
79774	1874	9535000
79775	2133	97420848000
79776	1874	9537000
79777	2133	97419846000
79778	1874	9539000
79779	2133	97418844000
79780	1874	9541000
79781	2132	148530531000
79782	1874	9542000
79783	1688	39599559908000
79784	1688	39599608908000
79786	1397	1331259260000
79787	1678	20160708840000
79788	2133	97417842000
79789	1874	9544000
79790	2134	97181561000
79791	1874	9547000
79792	2132	148529530000
79793	1874	9548000
79794	1394	300964396000000
79795	1394	300964409000000
79816	1715	39279082345189
79817	1006	506565960563455
79818	1397	1331229257000
79819	1678	20160708843000
79820	1397	1331219256000
79821	1678	20160708844000
79822	2134	97178552000
79823	1874	9561000
79824	2132	148528529000
79825	1874	9562000
79826	2133	97414836000
79827	1874	9564000
79828	2133	97413834000
79829	1874	9566000
79830	1394	303844421000000
79831	1394	303844545000000
79844	1715	32490586272631
79845	1126	907761861072558
79846	1397	1331189253000
79847	1678	20160708847000
79848	2132	148527528000
79849	1874	9567000
79850	1719	17300683000000
79851	1719	17300794000000
79907	1397	1331109245000
79908	1678	20160708855000
79909	2134	97168522000
79910	1874	9601000
79945	1402	61054761319298
79946	1402	61054783319298
79957	1726	99906112000
79958	2188	200000000
79959	1397	1331029237000
79960	1678	20160708863000
79961	1397	1331019236000
79962	1678	20160708864000
79963	2134	97161501000
79964	1874	9624000
79965	2134	97160498000
79966	1874	9627000
79967	2132	148522523000
79968	1874	9628000
79969	1394	308164667000000
79970	1394	308164700000000
79996	1471	21499875900000
79997	1471	22219875900000
79998	1471	22219877900000
80002	1700	17586061276737
80003	1700	18306061276737
80004	1700	18306063276737
80005	1395	58091665463007706
80006	1395	58092385463007706
80007	1395	58092385465007706
80027	1397	1330949229000
80028	1678	20160708871000
80029	2134	97154480000
80030	1874	9647000
80031	2132	148520521000
80032	1874	9648000
80033	1395	58093105465007706
80034	1395	58093105477007706
80041	1395	58093825477007706
80042	1395	58093825488007706
80050	1690	129604115000000
80051	1690	129604126000000
80110	1395	58094545488007706
80111	1395	58094545498007706
80158	1397	1330749209000
80159	1678	20160708891000
80160	1397	1330739208000
80161	1678	20160708892000
80162	2134	97135423000
80163	1874	9710000
80164	2132	148514515000
80165	1874	9711000
80166	2134	97134420000
80167	1874	9714000
80168	1394	311044734000000
80234	42	85265954400000
80235	1361	1701353063351650
80236	42	81344072000000
80237	1115	904895247400000
80238	1397	1330629197000
80239	1678	20160708903000
80240	2134	97123387000
80241	1874	9750000
80242	1571	22320499001024
80243	1571	22320710001024
80269	1509	16511953851155
80273	1397	1330589193000
80274	1678	20160708907000
80275	1397	1330579192000
80276	1678	20160708908000
80277	2134	97119375000
80278	1874	9763000
80279	2134	97118372000
80280	1874	9766000
80281	2132	148509510000
80282	1874	9767000
80283	1476	18720339000000
80284	1476	18720362000000
80296	1397	1330559190000
80297	1678	20160708910000
80298	2134	97115363000
80299	1874	9776000
80300	2132	148508509000
80301	1874	9777000
80302	1394	312484722000000
80303	1394	312484734000000
80316	1397	1330529187000
80317	1678	20160708913000
80318	1397	1330519186000
80319	1678	20160708914000
79797	694	66523957693786
79798	1397	1331249259000
79799	1678	20160708841000
79800	2133	97416840000
79801	1874	9550000
79802	2134	97180558000
79803	1874	9553000
79804	1610	14400532000000
79806	1397	1331239258000
79807	1678	20160708842000
79808	2134	97179555000
79809	1874	9556000
79810	2133	97415838000
79811	1874	9558000
79812	1547	13533470000000
79813	1547	13533482000000
79832	1397	1331209255000
79833	1678	20160708845000
79834	1397	1331199254000
79835	1678	20160708846000
79836	1719	16580683000000
79865	1715	27910220174139
79866	1246	612485016098492
79867	1397	1331169251000
79868	1678	20160708849000
79869	2134	97173537000
79870	1874	9584000
79871	1637	215284897819988
79872	1637	215285008819988
79873	1715	15146801436096
79874	1372	1706743956489693
79875	1397	1331159250000
79876	1678	20160708850000
79877	2134	97172534000
79878	1874	9587000
79879	2132	148526527000
79880	1874	9588000
79881	1670	21601346000000
79947	1625	2160051000000
79948	1625	2160073000000
79949	1685	126002591571430
79950	1685	126002613571430
79971	1397	1331009235000
79972	1678	20160708865000
79973	2134	97159495000
79974	1874	9631000
79975	1271	1347006421000000
79976	1271	1347006432000000
79979	1701	12310409600056
79999	1596	18000770000000
80000	1596	18720770000000
80001	1596	18720772000000
80008	470	81120483000000
80017	1397	1330969231000
80018	1678	20160708869000
80019	2134	97155483000
80020	1874	9644000
80021	1762	20482060994000
80022	1762	20482071994000
80043	1397	1330929227000
80044	1678	20160708873000
80045	2134	97152474000
80046	1874	9654000
80047	1688	40319608908000
80048	1688	40319619908000
80054	1397	1330919226000
80055	1678	20160708874000
80056	2134	97151471000
80057	1874	9657000
80058	2132	148519520000
80059	1874	9658000
80060	1673	24085507000000
80062	1726	98696112000
80063	2189	200000000
80064	1397	1330909225000
80065	1678	20160708875000
80066	1397	1330899224000
80067	1678	20160708876000
80068	1397	1330889223000
80069	1678	20160708877000
80070	1397	1330879222000
80071	1678	20160708878000
80072	1397	1330869221000
80073	1678	20160708879000
80074	1397	1330859220000
80075	1678	20160708880000
80076	1397	1330849219000
80077	1678	20160708881000
80078	2132	148518519000
80079	1874	9659000
80080	2134	97150468000
80081	1874	9662000
80082	2134	97149465000
80083	1874	9665000
80084	2132	148517518000
80085	1874	9666000
80086	2134	97148462000
80087	1874	9669000
80088	2134	97147459000
80089	1874	9672000
80090	2134	97146456000
80091	1874	9675000
80092	2134	97145453000
80093	1874	9678000
80094	2134	97144450000
80095	1874	9681000
80096	1509	16511942851155
80097	1509	16512031851155
80100	1397	1330839218000
80101	1678	20160708882000
80102	2134	97143447000
80103	1874	9684000
80104	1685	126722603571430
80105	1685	126722614571430
80120	1397	1330809215000
80121	1678	20160708885000
80122	2134	97142444000
80123	1874	9688000
80124	2134	97141441000
80125	1874	9691000
80126	1756	7633126545609
80127	1756	7633138545609
80130	1397	1330799214000
80131	1678	20160708886000
80132	2134	97140438000
80133	1874	9694000
80141	1397	1330779212000
80142	1678	20160708888000
80143	1397	1330769211000
80144	1678	20160708889000
80145	1611	26029312550000
80146	975	504819475450000
80147	2134	97138432000
80148	1874	9701000
80149	2134	97137429000
80150	1874	9704000
80151	1693	5899312757818
80173	1397	1330729207000
80174	1678	20160708893000
80175	1397	1330719206000
80176	1678	20160708894000
80177	2134	97133417000
80178	1874	9717000
80179	2134	97132414000
80180	1874	9720000
80181	2132	148513514000
80182	1874	9721000
80183	1688	41039619908000
80184	1688	41039642908000
80186	1685	128162637571430
80187	1685	128162660571430
80208	1395	58095985509007706
80209	1395	58095985532007706
80262	1650	10834185000000
80263	1650	10834408000000
80270	1705	13595592500145
80271	1705	13595603500145
80272	1474	13953435000023
80293	1740	17205346000000
80304	1397	1330549189000
80305	1678	20160708911000
80306	1397	1330539188000
80307	1678	20160708912000
80308	2134	97114360000
80309	1874	9780000
80310	2134	97113357000
80311	1874	9783000
80312	42	77229360000000
80313	42	77229382000000
80328	1594	17185327000000
80332	1685	128162661571430
80347	1397	1330489183000
80348	1678	20160708917000
80349	2132	148506507000
80350	1874	9797000
80351	2134	97108342000
80352	1874	9800000
80353	1394	313924734000000
80354	1394	313924746000000
80394	576	83795920938283
80395	576	83795931938283
80411	1715	41955446296216
80412	1715	41431388602430
80413	1715	40907330908644
80414	1715	37119045345189
79901	2134	97170528000
79902	1874	9595000
79903	2134	97169525000
79904	1874	9598000
79905	1402	60334738319298
79906	1402	60334761319298
79935	1397	1331059240000
79936	1678	20160708860000
79937	1397	1331049239000
79938	1678	20160708861000
79939	2134	97163507000
79940	1874	9617000
79941	2132	148523524000
79942	1874	9618000
79943	369	84516673000000
79944	369	84516695000000
79951	1397	1331039238000
79952	1678	20160708862000
79953	2134	97162504000
79954	1874	9621000
79955	1395	58091665431007706
79956	1395	58091665442007706
79977	1608	19005726000000
79978	1608	19005737000000
79993	470	80400503000000
79994	470	81120503000000
79995	470	81120505000000
80015	1394	309604700000000
80016	1394	309604711000000
80023	1397	1330959230000
80024	1678	20160708870000
80025	1672	23762179000000
80026	1672	23762189000000
80052	1749	9925359930000
80053	1749	9925370930000
80061	1685	126002603571430
80098	1593	22150320000000
80099	1593	22150409000000
80118	1706	13172268600135
80119	1706	13172279600135
80128	1764	14406958100000
80129	1764	14406970100000
80152	1397	1330759210000
80153	1678	20160708890000
80154	2134	97136426000
80155	1874	9707000
80156	1395	58095265498007706
80157	1395	58095265509007706
80171	1623	57602826899898
80172	1623	57602849899898
80197	1397	1330689203000
80198	1678	20160708897000
80199	1397	1330679202000
80200	1678	20160708898000
80201	2132	148512513000
80202	1874	9728000
80203	2134	97129405000
80204	1874	9731000
80205	2134	97128402000
80206	1874	9734000
80207	1546	16561001000000
80216	1397	1330659200000
80217	1678	20160708900000
80218	1397	1330649199000
80219	1678	20160708901000
80220	1397	1330639198000
80221	1678	20160708902000
80222	2134	97126396000
80223	1874	9740000
80224	2134	97125393000
80225	1874	9743000
80226	2132	148511512000
80227	1874	9744000
80228	1597	2157003000000
80229	2190	1000000000
80230	2134	97124390000
80231	1874	9747000
80232	1549	21936003000000
80233	1549	22656003000000
80246	42	78697712800000
80247	1235	610551009200000
80248	42	76509360000000
80249	995	504966027800000
80250	1397	1330619196000
80251	1678	20160708904000
80252	1397	1330609195000
80253	1678	20160708905000
80254	2134	97122384000
80255	1874	9753000
80256	2134	97121381000
80257	1874	9756000
80258	2132	148510511000
80259	1874	9757000
80260	1596	18720749000000
80261	1596	18720972000000
80264	1397	1330599194000
80265	1678	20160708906000
80266	2134	97120378000
80267	1874	9760000
80268	484	70748792000000
80287	1397	1330569191000
80288	1678	20160708909000
80289	2134	97117369000
80290	1874	9770000
80291	1740	17205345000000
80292	1740	17205356000000
80294	2134	97116366000
80295	1874	9773000
80329	1710	21114808473290
80340	1397	1330499184000
80341	1678	20160708916000
80342	2134	97109345000
80343	1874	9796000
80344	2157	1999
80345	1929	1477998001
80346	2039	18721518000000
80355	1874	9687000
80356	1874	9690000
80357	1874	9693000
80358	1874	9696000
80359	1874	9699000
80360	1874	9702000
80361	1874	9705000
80362	1874	9708000
80363	1874	9723000
80364	1874	9726000
80365	1874	9729000
80366	1874	9732000
80367	1874	9735000
80368	1874	9738000
80369	1874	9741000
80370	1874	9759000
80371	1874	9762000
80372	1874	9765000
80373	1874	9768000
80374	1874	9771000
80375	1874	9774000
80376	1874	9786000
80377	1874	9789000
80378	1692	28580743619999
80397	1397	1330459180000
80398	1678	20880720920000
80399	1474	13231414000023
80400	2191	1000000000
80401	2134	97105333000
80402	1874	9809000
80403	2132	148505506000
80404	1874	9810000
80405	1684	20160577880623
80406	1684	20160599880623
80421	1474	13229404000023
80422	2192	1000000000
80423	1397	1330449179000
80424	1678	20880720921000
80425	2134	97104330000
80426	1874	9813000
80427	1547	13533491000000
80450	1397	1330419176000
80451	1678	20880720924000
80452	1397	1330409175000
80453	1678	20880720925000
80454	1397	1330399174000
80455	1678	20880720926000
80456	1397	1330389173000
80457	1678	20880720927000
80458	1397	1330379172000
80459	1678	20880720928000
80460	2134	97101321000
80461	1874	9823000
80462	2132	148503504000
80463	1874	9824000
80464	2134	97100318000
80465	1874	9827000
80466	2134	97099315000
80467	1874	9830000
80468	2134	97098312000
80469	1874	9833000
80470	2134	97097309000
80471	1874	9836000
80472	606	78237895812962
80473	606	78237951812962
80539	149	84270283000341
80570	1610	15120566000000
80589	1702	10080353000000
80669	1397	1330169151000
80195	1874	9727000
80196	576	83075920938283
80210	1397	1330669201000
80211	1678	20160708899000
80212	2134	97127399000
80213	1874	9737000
80214	1688	41759642908000
80215	1688	41759653908000
80244	1395	58096705532007706
80245	1395	58096705743007706
80285	1714	16006492103056
80286	1714	16006515103056
80314	1686	17492169550062
80315	1686	17492191550062
80333	1397	1330509185000
80334	1678	20160708915000
80335	2134	97110348000
80336	1874	9793000
80337	2190	989000000
80338	1597	2157013000000
80339	1650	10834197000000
80387	1397	1330469181000
80388	1678	20880720919000
80389	2134	97106336000
80390	1874	9806000
80391	1547	13533481000000
80409	1700	18306040276737
80410	1700	18306062276737
80429	1395	58097425743007706
80430	1395	58097425764007706
80431	1397	1330439178000
80432	1678	20880720922000
80433	1474	13227394000023
80434	2193	1000000000
80435	1474	13225384000023
80436	2194	1000000000
80437	1474	13223374000023
80438	2195	1000000000
80439	2134	97103327000
80440	1874	9816000
80441	1700	18306081276737
80517	1397	1330369171000
80518	1678	20880720929000
80519	1932	636819152658
80520	2196	1000000000
80521	1397	1330359170000
80522	1678	20880720930000
80523	2134	97096306000
80524	1874	9839000
80525	2134	97095303000
80526	1874	9842000
80527	2132	148502503000
80528	1874	9843000
80529	1395	58097425776007706
80547	43	80400847890000
80548	43	81120847890000
80549	2052	81120848889900
80550	43	200000192
80554	1397	1330329167000
80555	1678	20880720933000
80556	1397	1330319166000
80557	1678	20880720934000
80558	2132	148501502000
80559	1874	9847000
80560	1874	9850000
80561	2134	97092294000
80562	1874	9853000
80563	2134	97091291000
80564	1874	9856000
80565	1610	15120532000000
80566	1610	66000005940000
80567	646	15120539019950
80568	2052	70028806000000
80569	484	200000142
80591	1476	18720351000000
80603	1397	1330279162000
80604	1678	20880720938000
80605	1397	1330269161000
80606	1678	20880720939000
80607	2134	97087279000
80608	1874	9869000
80609	2134	97086276000
80610	1874	9872000
80611	1444	17855249159999
80612	1444	17855271159999
80626	1397	1330239158000
80627	1678	20880720942000
80628	2134	97083267000
80629	1874	9882000
80630	1596	19440972000000
80631	1596	19440983000000
80638	1727	16027213000000
80675	1397	1330159150000
80676	1678	20880720950000
80677	1397	1330149149000
80678	1678	20880720951000
80679	1397	1330139148000
80680	1678	20880720952000
80681	1397	1330129147000
80682	1678	20880720953000
80683	2132	148496497000
80684	1874	9903000
80685	2134	97076246000
80686	1874	9906000
80687	2190	2150988000000
80688	2134	97075243000
80689	1874	9909000
80690	2134	97074240000
80691	1874	9912000
80692	2134	97073237000
80693	1874	9915000
80694	1610	15840539019950
80695	1610	15840585019950
80698	1397	1330119146000
80699	1678	20880720954000
80700	2134	97072234000
80701	1874	9918000
80702	2132	148495496000
80703	1874	9919000
80704	1714	16726515103056
80705	1714	16726527103056
80717	1694	21612703127629
80718	1694	21612714127629
80727	1397	1330079142000
80728	1678	20880720958000
80729	1397	1330069141000
80730	1678	20880720959000
80731	2134	97068222000
80732	1874	9932000
80733	2134	97067219000
80734	1874	9935000
80735	1522	16894240000000
80736	1522	16894262000000
80781	1397	1329999134000
80782	1678	20880720966000
80783	2134	97060198000
80784	1874	9958000
80785	1394	316804768000000
80825	1768	17150863110000
80841	606	78957963812962
80866	1397	1329879122000
80867	1678	20880720978000
80868	2134	97048162000
80869	1874	9997000
80870	2132	148488489000
80871	1874	9998000
80872	1564	12066535000000
80885	1397	1329849119000
80886	1678	20880720981000
80887	1397	1329839118000
80888	1678	20880720982000
80889	2134	97045153000
80890	1874	10007000
80891	2134	97044150000
80892	1874	10010000
80893	2132	148487488000
80894	1874	10011000
80895	1649	24044356999992
80896	1649	24044379999992
80900	1397	1329829117000
80901	1678	20880720983000
80902	2134	97043147000
80903	1874	10014000
80904	1395	58099585810007706
80922	1397	1329789113000
80923	1678	20880720987000
80924	2134	97039135000
80925	1874	10027000
80943	1397	1329759110000
80944	1678	20880720990000
80945	2134	97036126000
80946	1874	10037000
80947	633	83884133900000
80950	1397	1329749109000
80951	1678	20880720991000
80952	2132	148484485000
80953	1874	10038000
80954	2134	97035123000
80955	1874	10041000
80980	1397	1329719106000
80981	1678	20880720994000
80982	2134	97032114000
80983	1874	10050000
80984	1588	19655083000000
80987	1471	22219865900000
80320	2132	148507508000
80321	1874	9784000
80322	554	67450022000000
80323	2134	97112354000
80324	1874	9787000
80325	2134	97111351000
80326	1874	9790000
80327	1668	20126875000000
80330	1573	14379157000000
80331	1573	14379181000000
80379	1397	1330479182000
80380	1678	20160708918000
80381	2134	97107339000
80382	1874	9803000
80383	1597	7012000000
80384	2190	2150989000000
80385	1678	20880708918000
80386	1678	20880720918000
80392	1688	42479653908000
80393	1688	42479664908000
80396	1685	128162648571430
80407	1506	14401256967172
80408	1506	14401278967172
80442	1397	1330429177000
80443	1678	20880720923000
80444	2132	148504505000
80445	1874	9817000
80446	2134	97102324000
80447	1874	9820000
80448	1688	43199664908000
80449	1688	43199676908000
80530	1932	38809152658
80531	2196	599000000000
80532	2134	97094300000
80533	1874	9846000
80534	1560	17874391277001
80535	1560	17874402277001
80551	43	81120848890000
80613	1688	43919676908000
80614	1688	43919698908000
80632	1397	1330229157000
80633	1678	20880720943000
80634	2134	97082264000
80635	1874	9885000
80636	1709	14400221999976
80637	1709	14400232999976
80639	1395	58098145776007706
80640	1395	58098145787007706
80641	1397	1330219156000
80642	1678	20880720944000
80643	1397	1330209155000
80644	1678	20880720945000
80645	1397	1330199154000
80646	1678	20880720946000
80647	2132	148498499000
80648	1874	9886000
80649	2134	97081261000
80650	1874	9889000
80651	2134	97080258000
80652	1874	9892000
80653	2134	97079255000
80654	1874	9895000
80655	1587	25200738000000
80656	1587	25200772000000
80671	1700	19026081276737
80672	1700	19026091276737
80696	1684	21600599880623
80697	1684	21600645880623
80706	1397	1330109145000
80707	1678	20880720955000
80708	2134	97071231000
80709	1874	9922000
80710	1623	57602837899898
80750	1397	1330039138000
80751	1678	20880720962000
80752	1397	1330029137000
80753	1678	20880720963000
80754	1726	97486112000
80755	2157	1200001999
80756	1726	96276112000
80757	2197	200000000
80758	2134	97064210000
80759	1874	9945000
80760	2134	97063207000
80761	1874	9948000
80762	1559	15082779000000
80763	1559	15082821000000
80780	1684	21600610880623
80800	1397	1329969131000
80801	1678	20880720969000
80802	1397	1329959130000
80803	1678	20880720970000
80804	2134	97057189000
80805	1874	9968000
80806	2134	97056186000
80807	1874	9971000
80808	1593	22870409000000
80809	1593	22870431000000
80830	1397	1329919126000
80831	1678	20880720974000
80832	2132	148489490000
80833	1874	9982000
80834	1821	527489000000
80835	756	1006450000000
80836	2134	97052174000
80837	1874	9985000
80838	1509	16511955851155
80864	171	81110501524688
80865	171	81110514524688
80873	1397	1329869121000
80874	1678	20880720979000
80875	2134	97047159000
80876	1874	10001000
80877	1509	17231955851155
80878	1509	17231966851155
80917	1397	1329799114000
80918	1678	20880720986000
80919	2134	97040138000
80920	1874	10024000
80921	1717	15948127000023
80948	1395	58100305810007706
80949	1395	58100305821007706
80967	1271	1347006433000000
80979	1394	319684902000000
80988	1718	9666808763340
80989	1718	9666819763340
81055	1608	19005738000000
81067	1685	128882648571430
81068	1685	128882671571430
81090	1397	1329569091000
81091	1678	20880721009000
81092	2134	97016066000
81093	1874	10103000
81094	1524	720011000000
81146	1474	13943374000023
81147	1474	13943386000023
81159	1397	1329459080000
81160	1678	20880721020000
81161	1397	1329449079000
81162	1678	20880721021000
81163	2134	97005033000
81164	1874	10139000
81165	2134	97004030000
81166	1874	10142000
81167	2132	148475476000
81168	1874	10143000
81169	1679	17999054653000
81170	1679	17999077653000
81171	1397	1329439078000
81172	1678	20880721022000
81173	2134	97003027000
81174	1874	10146000
81175	1991	20635994441475
81176	1991	20636005441475
81192	1397	1329409075000
81193	1678	20880721025000
81194	2134	97000018000
81195	1874	10156000
81196	1394	321124813000000
81198	1703	10080826000000
81212	1637	218165095819988
81217	1397	1329359070000
81218	1678	20880721030000
81219	1701	13030409600056
81220	1701	13030419600056
81238	1397	1329319066000
81239	1678	20880721034000
81240	2132	148471472000
81241	1874	10162000
81279	1397	1329239058000
81280	1678	20880721042000
81281	1727	16027212000000
81288	1397	1329219056000
81289	1678	20880721044000
81290	1397	1329209055000
81291	1678	20880721045000
81292	2132	148468469000
81293	1874	10165000
81294	1508	18036588500009
81295	1508	18036609500009
81300	1980	17279413000000
81301	1980	17279423000000
81341	1397	1329089043000
81342	1678	20880721057000
81343	2132	148464465000
80415	1715	30330549272631
80416	1715	25750183174139
80417	1715	12986764436096
80418	1506	13683136967172
80419	1506	14403136967172
80420	1506	14403596967172
80428	1637	216005029819988
80474	1874	9649000
80475	1874	9650000
80476	1597	7002000000
80477	2190	2151000000000
80478	1874	9660000
80479	1874	9663000
80480	1874	9667000
80481	1874	9668000
80482	1874	9670000
80483	1874	9671000
80484	1874	9673000
80485	1874	9676000
80486	1874	9679000
80487	1874	9682000
80488	1874	9700000
80489	1874	9703000
80490	1874	9706000
80491	1874	9709000
80492	1874	9712000
80493	1874	9715000
80494	1874	9716000
80495	1874	9718000
80496	1874	9719000
80497	1874	9722000
80498	1874	9725000
80499	1874	9746000
80500	1874	9749000
80501	1874	9752000
80502	1874	9755000
80503	1874	9758000
80504	1874	9761000
80505	1874	9764000
80506	1874	9779000
80507	1874	9782000
80508	1874	9785000
80509	1874	9788000
80510	1874	9791000
80511	1874	9794000
80512	1874	9812000
80513	1874	9815000
80514	1874	9818000
80515	1874	9821000
80516	606	78238437812962
80536	1397	1330349169000
80537	1678	20880720931000
80538	1560	17874412277001
80540	1397	1330339168000
80541	1678	20880720932000
80542	1680	14409630500035
80543	2134	97093297000
80544	1874	9849000
80545	1680	15129630500035
80546	1680	15129631500035
80552	1680	15129620500035
80553	1684	20880599880623
80571	1397	1330309165000
80572	1678	20880720935000
80573	1397	1330299164000
80574	1678	20880720936000
80575	2134	97090288000
80576	1874	9859000
80577	2134	97089285000
80578	1874	9862000
80579	1656	19581681999990
80580	1656	19581703999990
80581	1397	1330289163000
80582	1678	20880720937000
80583	2134	97088282000
80584	1874	9865000
80585	2132	148500501000
80586	1874	9866000
80587	1563	1440020000000
80588	1563	1440032000000
80590	1703	10080827000000
80592	1874	9819000
80593	1874	9845000
80594	1874	9848000
80595	1874	9851000
80596	1476	18000524000000
80597	1874	9854000
80598	1874	9857000
80599	1874	9860000
80600	1874	9863000
80601	1476	18720524000000
80602	1476	18720529000000
80615	1397	1330259160000
80616	1678	20880720940000
80617	1397	1330249159000
80618	1678	20880720941000
80619	2134	97085273000
80620	1874	9875000
80621	2132	148499500000
80622	1874	9876000
80623	2134	97084270000
80624	1874	9879000
80625	1739	27359761000000
80657	1397	1330189153000
80658	1678	20880720947000
80659	1397	1330179152000
80660	1678	20880720948000
80661	2134	97078252000
80662	1874	9898000
80663	2134	97077249000
80664	1874	9901000
80665	2132	148497498000
80666	1874	9902000
80667	1637	216725029819988
80668	1637	216725052819988
80673	1634	21072633641004
80674	1634	21073839641004
80711	1397	1330099144000
80712	1678	20880720956000
80713	2134	97070228000
80714	1874	9925000
80715	1688	44639698908000
80716	1688	44639709908000
80719	1397	1330089143000
80720	1678	20880720957000
80721	2134	97069225000
80722	1874	9928000
80723	2132	148494495000
80724	1874	9929000
80725	1395	58098865787007706
80726	1395	58098865799007706
80743	1397	1330049139000
80744	1678	20880720961000
80745	2132	148493494000
80746	1874	9939000
80747	2134	97065213000
80748	1874	9942000
80749	1513	29520911000000
80764	1397	1330019136000
80765	1678	20880720964000
80766	2134	97062204000
80767	1874	9951000
80768	2132	148492493000
80769	1874	9952000
80770	1671	16608529530515
80773	1700	19026093276737
80786	1397	1329989133000
80787	1678	20880720967000
80788	1397	1329979132000
80789	1678	20880720968000
80790	2132	148491492000
80791	1874	9959000
80792	2134	97059195000
80793	1874	9962000
80794	2134	97058192000
80795	1874	9965000
80796	1588	19655072000000
80797	1588	19655095000000
80810	1397	1329949129000
80811	1678	20880720971000
80812	1397	1329939128000
80813	1678	20880720972000
80814	1397	1329929127000
80815	1678	20880720973000
80816	2132	148490491000
80817	1874	9972000
80818	2134	97055183000
80819	1874	9975000
80820	2134	97054180000
80821	1874	9978000
80822	2134	97053177000
80823	1874	9981000
80824	1768	17150867110000
80826	1601	14330325620000
80827	1601	14330359620000
80839	606	78957951812962
80840	606	78957964812962
80842	1397	1329909125000
80843	1678	20880720975000
80844	1397	1329899124000
80845	1678	20880720976000
80846	266	66000928193897
80847	2196	1212000000000
80848	2134	97051171000
80849	1874	9988000
80670	1678	20880720949000
80737	1397	1330059140000
80738	1678	20880720960000
80739	2134	97066216000
80740	1874	9938000
80741	1394	315364746000000
80742	1394	315364757000000
80771	1394	316804757000000
80772	1394	316804769000000
80774	1397	1330009135000
80775	1678	20880720965000
80776	2134	97061201000
80777	1874	9955000
80778	1588	18935061000000
80779	1588	18935072000000
80798	1394	318244768000000
80799	1394	318244791000000
80828	1395	58099585799007706
80829	1395	58099585833007706
80854	1397	1329889123000
80855	1678	20880720977000
80856	112	66001905193897
80857	1821	610489000000
80858	2134	97049165000
80859	1874	9994000
80860	112	66000000193897
80861	1821	612393000000
80862	1601	15050359620000
80863	1601	15050372620000
80897	1821	610990000000
80898	1874	9956000
80899	1649	24044368999992
80905	1397	1329819116000
80906	1678	20880720984000
80907	1397	1329809115000
80908	1678	20880720985000
80909	2134	97042144000
80910	1874	10017000
80911	2134	97041141000
80912	1874	10020000
80913	2132	148486487000
80914	1874	10021000
80915	369	85236695000000
80916	369	85236718000000
80926	1726	95066112000
80927	2198	200000000
80928	1397	1329779112000
80929	1678	20880720988000
80930	2132	148485486000
80931	1874	10028000
80932	2134	97038132000
80933	1874	10031000
80934	1471	22219876900000
80937	1397	1329769111000
80938	1678	20880720989000
80939	2134	97037129000
80940	1874	10034000
80941	1594	17905313000000
80942	1594	17905324000000
80956	1397	1329739108000
80957	1678	20880720992000
80958	849	1153280729361640
80959	2152	34767163100000
80960	2134	97034120000
80961	1874	10044000
80962	369	85956718000000
80963	369	85956730000000
80965	1394	319684791000000
80966	1394	319684803000000
80972	2198	100000000
80973	1397	1329729107000
80974	1678	20880720993000
80975	2134	97033117000
80976	1874	10047000
80977	1688	45359709908000
80978	1688	45359820908000
80985	1656	20301703999990
80986	1656	20301714999990
80998	1397	1329699104000
80999	1678	20880720996000
81000	2134	97030108000
81001	1874	10057000
81002	1675	16702298999977
81005	1397	1329689103000
81006	1678	20880720997000
81007	1397	1329679102000
81008	1678	20880720998000
81009	1397	1329669101000
81010	1678	20880720999000
81011	1397	1329659100000
81012	1678	20880721000000
81013	850	1149782543924210
81014	2152	40000000000000
81015	1687	5660148223172
81016	2132	148482483000
81017	1874	10058000
81018	2134	97029105000
81019	1874	10061000
81020	2134	97028102000
81021	1874	10064000
81022	2134	97027099000
81023	1874	10067000
81024	2134	97026096000
81025	1874	10070000
81026	1687	6380148223172
81027	1687	6380153223172
81037	1688	46799832908000
81038	1688	46799844908000
81045	69	68160022000000
81046	69	68160033000000
81047	1397	1329629097000
81048	1678	20880721003000
81049	2134	97023087000
81050	1874	10080000
81051	2134	97022084000
81052	1874	10083000
81053	1457	19344410040000
81054	1457	19344422040000
81075	1397	1329589093000
81076	1678	20880721007000
81077	1397	1329579092000
81078	1678	20880721008000
81079	2134	97018072000
81080	1874	10096000
81081	2134	97017069000
81082	1874	10099000
81083	2132	148479480000
81084	1874	10100000
81085	1679	17279031653000
81086	1679	17279054653000
81089	1759	17280858999889
81097	504	66610888193897
81098	266	66003928193897
81099	1397	1329559090000
81100	1678	20880721010000
81101	1397	1329549089000
81102	1678	20880721011000
81103	2134	97015063000
81104	1874	10106000
81105	2134	97014060000
81106	1874	10109000
81107	2132	148478479000
81108	1874	10110000
81109	1637	218165063819988
81110	1637	218165136819988
81144	526	69600074000000
81145	526	69600086000000
81153	1397	1329469081000
81154	1678	20880721019000
81155	2134	97006036000
81156	1874	10136000
81157	1724	11467398500000
81158	1724	11467409500000
81182	1397	1329419076000
81183	1678	20880721024000
81184	2132	148474475000
81185	1874	10150000
81186	2134	97001021000
81187	1874	10153000
81188	1394	321124802000000
81189	1394	321124814000000
81223	1397	1329349069000
81224	1678	20880721031000
81225	2132	148472473000
81226	1874	10161000
81227	1601	16490382620000
81228	1601	16490393620000
81229	1397	1329339068000
81230	1678	20880721032000
81231	1649	24764379999992
81232	1649	24764389999992
81244	1395	58101745833007706
81245	1395	58101745844007706
81249	1397	1329299064000
81250	1678	20880721036000
81251	1681	14183264759830
81252	1681	14183274759830
81257	1706	13172278600135
81266	1397	1329269061000
81267	1678	20880721039000
81268	1394	322564812000000
81269	1394	322564822000000
81286	1643	1760532914700
81287	1643	1760542914700
81313	1397	1329159050000
80850	2134	97050168000
80851	1874	9991000
80852	1691	16523222100019
80853	1691	16523254100019
80879	1397	1329859120000
80880	1678	20880720980000
80881	2134	97046156000
80882	1874	10004000
80883	1756	8353138545609
80884	1756	8353149545609
80935	1457	18624388040000
80936	1457	18624410040000
80964	1992	15119346990000
80968	1395	58101025821007706
80969	1395	58101025833007706
80970	1692	29300316619999
80971	1692	29300328619999
81003	1440	17279337049920
81028	1397	1329649099000
81029	1678	20880721001000
81030	2132	148481482000
81031	1874	10071000
81032	2134	97025093000
81033	1874	10074000
81034	1719	18020798000000
81035	1719	18020810000000
81087	1759	17280855999889
81088	1759	17280878999889
81111	1623	58322837899898
81112	1623	58322910899898
81113	1397	1329539088000
81114	1678	20880721012000
81115	1397	1329529087000
81116	1678	20880721013000
81117	1397	1329519086000
81118	1678	20880721014000
81119	1397	1329509085000
81120	1678	20880721015000
81121	1397	1329499084000
81122	1678	20880721016000
81123	2132	148477478000
81124	1874	10111000
81125	2134	97013057000
81126	1874	10114000
81127	2134	97012054000
81128	1874	10117000
81129	2134	97011051000
81130	1874	10120000
81131	2134	97010048000
81132	1874	10123000
81133	2134	97009045000
81134	1874	10126000
81135	1690	130324126000000
81136	1690	130324182000000
81177	1397	1329429077000
81178	1678	20880721023000
81179	2134	97002024000
81180	1874	10149000
81181	1394	319684802000000
81199	1397	1329399074000
81200	1678	20880721026000
81201	1397	1329389073000
81202	1678	20880721027000
81203	1397	1329379072000
81204	1678	20880721028000
81205	2134	96999015000
81206	1874	10159000
81207	2132	148473474000
81208	1874	10160000
81209	632	75501246000000
81210	632	75501278000000
81233	1602	16560545000000
81234	1602	16560555000000
81246	1397	1329309065000
81247	1678	20880721035000
81248	1394	321124812000000
81253	1689	15120511287625
81254	1689	15120521287625
81270	1397	1329259060000
81271	1678	20880721040000
81272	1685	128882658571430
81282	1397	1329229057000
81283	1678	20880721043000
81284	1657	15841469990100
81285	1657	15841479990100
81302	1397	1329189053000
81303	1678	20880721047000
81304	2132	148467468000
81305	1874	10166000
81306	1690	131044182000000
81307	1690	131044193000000
81320	1397	1329139048000
81321	1678	20880721052000
81322	1685	129602658571430
81323	1685	129602668571430
81333	1397	1329109045000
81334	1678	20880721055000
81335	1723	19799528085979
81336	1723	19799538085979
81356	1715	15866801436096
81357	1715	15866811436096
81386	1397	1328999034000
81387	1678	20880721066000
81388	2132	148461462000
81389	1874	10172000
81390	1689	15120522287625
81405	1397	1328959030000
81406	1678	20880721070000
81407	2132	148460461000
81408	1874	10173000
81409	1688	46799843908000
81422	1694	21612724127629
81425	1397	1328919026000
81426	1678	20880721074000
81427	1719	18740810000000
81428	1719	18740820000000
81433	1560	17874401277001
81452	1397	1328879022000
81453	1678	20880721078000
81454	1685	130322668571430
81455	1685	130322678571430
81483	1397	1328809015000
81484	1678	20880721085000
81485	1397	1328799014000
81486	1678	20880721086000
81487	2132	148455456000
81488	1874	10178000
81489	1444	17855270159999
81513	470	81120513000000
81528	1397	1328719006000
81529	1678	20880721094000
81530	1694	21612713127629
81560	1397	1328628997000
81561	1678	20880721103000
81562	2132	148450451000
81563	1874	10183000
81564	1547	14973522000000
81572	1397	1328598994000
81573	1678	20880721106000
81574	2132	148449450000
81575	1874	10184000
81576	1394	326884854000000
81579	1395	58104625895007706
81580	1395	58104625906007706
81590	1397	1328558990000
81591	1678	20880721110000
81592	2132	148448449000
81593	1874	10185000
81596	1397	1328548989000
81597	1678	20880721111000
81598	235	68160050000000
81599	235	68160060000000
81601	1764	14406968100000
81612	1397	1328518986000
81613	1678	20880721114000
81614	2199	719000000000
81615	2199	719010000000
81617	1471	22939865900000
81618	1471	22939875900000
81619	1397	1328508985000
81620	1678	20880721115000
81621	1402	61054771319298
81633	1397	1328478982000
81634	1678	20880721118000
81635	1513	29520909000000
81638	1397	1328468981000
81639	1678	20880721119000
81640	1740	17925346000000
81641	1740	17925356000000
81673	1397	1328398974000
81674	1678	20880721126000
81675	1397	1328388973000
81676	1678	20880721127000
81677	2132	148443444000
81678	1874	10190000
81679	1394	326884864000000
81683	1602	18000575000000
81684	1602	18000585000000
81692	1397	1328358970000
81693	1678	20880721130000
81694	526	66000065000000
81695	1474	16813364000023
81696	2132	148442443000
81697	1874	10191000
81698	1680	15849641500035
80990	1397	1329709105000
80991	1678	20880720995000
80992	2132	148483484000
80993	1874	10051000
80994	2134	97031111000
80995	1874	10054000
80996	1688	46079820908000
80997	1688	46079832908000
81004	1402	61054772319298
81036	1455	9394073000000
81039	1397	1329639098000
81040	1678	20880721002000
81041	2134	97024090000
81042	1874	10077000
81043	484	70748806000000
81044	484	70748817000000
81056	1397	1329619096000
81057	1678	20880721004000
81058	1397	1329609095000
81059	1678	20880721005000
81060	2132	148480481000
81061	1874	10084000
81062	2134	97021081000
81063	1874	10087000
81064	2134	97020078000
81065	1874	10090000
81066	1419	30699720280064
81069	1397	1329599094000
81070	1678	20880721006000
81071	2134	97019075000
81072	1874	10093000
81073	1637	217445052819988
81074	1637	217445063819988
81095	1457	20064422040000
81096	1457	20064433040000
81137	1397	1329489083000
81138	1678	20880721017000
81139	2134	97008042000
81140	1874	10129000
81141	2132	148476477000
81142	1874	10130000
81143	1705	13595604500145
81148	1397	1329479082000
81149	1678	20880721018000
81150	2134	97007039000
81151	1874	10133000
81152	1686	17492180550062
81190	1692	30020328619999
81191	1692	30020340619999
81197	1702	10080352000000
81211	1656	20301735999990
81213	1397	1329369071000
81214	1678	20880721029000
81215	1601	15770372620000
81216	1601	15770382620000
81221	1602	15840535000000
81222	1602	15840545000000
81235	1397	1329329067000
81236	1678	20880721033000
81237	632	75501256000000
81242	1457	20784433040000
81243	1457	20784444040000
81255	1637	218885095819988
81256	1637	218885105819988
81258	1397	1329289063000
81259	1678	20880721037000
81260	1397	1329279062000
81261	1678	20880721038000
81262	2132	148470471000
81263	1874	10163000
81264	1419	31419720280064
81265	1419	31419741280064
81273	1397	1329249059000
81274	1678	20880721041000
81275	2132	148469470000
81276	1874	10164000
81277	1394	324004822000000
81278	1394	324004833000000
81296	1397	1329199054000
81297	1678	20880721046000
81298	1691	17243254100019
81299	1691	17243264100019
81308	1397	1329179052000
81309	1678	20880721048000
81310	1397	1329169051000
81311	1678	20880721049000
81312	1684	21600619880623
81324	1397	1329129047000
81325	1678	20880721053000
81326	1397	1329119046000
81327	1678	20880721054000
81328	2132	148465466000
81329	1874	10168000
81330	1692	30020349619999
81347	1397	1329079042000
81348	1678	20880721058000
81349	1509	17951966851155
81350	1509	17951976851155
81354	1394	325444833000000
81355	1394	325444843000000
81370	1397	1329039038000
81371	1678	20880721062000
81372	1467	12206774100039
81373	1467	12206784100039
81378	1397	1329019036000
81379	1678	20880721064000
81380	1397	1329009035000
81381	1678	20880721065000
81382	2132	148462463000
81383	1874	10171000
81399	1637	219605105819988
81400	1637	219605125819988
81434	2039	19441518000000
81435	2039	19441528000000
81443	1395	58103905885007706
81444	1395	58103905895007706
81465	1397	1328849019000
81466	1678	20880721081000
81467	415	67440011000000
81468	415	67440021000000
81500	1762	21922092994000
81501	1762	21922112994000
81510	470	81120493000000
81520	1397	1328729007000
81521	1678	20880721093000
81522	2132	148453454000
81523	1874	10180000
81524	1422	10945063860211
81525	1422	10945074860211
81531	1603	2160062000000
81532	1603	2160662000000
81543	1708	15155895000021
81544	1397	1328679002000
81545	1678	20880721098000
81546	1397	1328669001000
81547	1678	20880721099000
81548	1397	1328659000000
81549	1678	20880721100000
81550	1397	1328648999000
81551	1678	20880721101000
81552	2132	148451452000
81553	1874	10182000
81554	1546	16561019000000
81555	1685	131042678571430
81565	1397	1328618996000
81566	1678	20880721104000
81567	1397	1328608995000
81568	1678	20880721105000
81569	1671	16608537530515
81600	1394	326884853000000
81602	1397	1328538988000
81603	1678	20880721112000
81604	1476	19440351000000
81605	1476	19440361000000
81616	1455	9394071000000
81622	1397	1328498984000
81623	1678	20880721116000
81624	2132	148446447000
81625	1874	10187000
81626	1992	15839344990000
81627	1992	15839355990000
81629	1474	13943385000023
81642	1397	1328458980000
81643	1678	20880721120000
81644	2132	148445446000
81645	1874	10188000
81648	1397	1328448979000
81649	1678	20880721121000
81650	1395	58105345915007706
81651	1397	1328438978000
81652	1678	20880721122000
81653	1397	1328428977000
81654	1678	20880721123000
81655	1397	1328418976000
81656	1678	20880721124000
81657	2132	148444445000
81658	1874	10189000
81659	1593	22870462000000
81660	1593	23590462000000
81663	1474	13213364000023
81664	2200	9000000000
81665	1397	1328408975000
81666	1678	20880721125000
81667	1547	15693522000000
81668	1547	15693542000000
81314	1678	20880721050000
81315	1397	1329149049000
81316	1678	20880721051000
81317	2132	148466467000
81318	1874	10167000
81319	1395	58101745854007706
81331	1714	17446527103056
81332	1714	17446548103056
81337	1397	1329099044000
81338	1678	20880721056000
81339	1692	30740349619999
81340	1692	30740359619999
81351	1688	46799842908000
81358	1397	1329069041000
81359	1678	20880721059000
81360	1397	1329059040000
81361	1678	20880721060000
81362	1602	17280555000000
81363	1602	17280575000000
81374	1397	1329029037000
81375	1678	20880721063000
81376	1762	21202071994000
81377	1762	21202081994000
81384	1991	21356005441475
81385	1991	21356026441475
81391	1654	19725200999798
81392	1654	19725211999798
81410	1397	1328949029000
81411	1678	20880721071000
81412	1850	18639158000000
81413	1850	18639168000000
81429	1397	1328909025000
81430	1678	20880721075000
81431	1672	24482189000000
81432	1672	24482199000000
81456	1397	1328869021000
81457	1678	20880721079000
81458	1422	10225063860211
81469	1397	1328839018000
81470	1678	20880721082000
81471	1706	13892278600135
81472	1706	13892288600135
81475	1397	1328829017000
81476	1678	20880721083000
81477	2132	148456457000
81478	1874	10177000
81479	1688	47519843908000
81480	1688	47519854908000
81490	1397	1328789013000
81491	1678	20880721087000
81492	1687	7100153223172
81493	1687	7100163223172
81502	1397	1328759010000
81503	1678	20880721090000
81504	2132	148454455000
81505	1874	10179000
81506	2086	3599089000000
81507	2086	3599100000000
81514	1397	1328749009000
81515	1678	20880721091000
81516	1992	15119344990000
81556	1397	1328638998000
81557	1678	20880721102000
81558	1694	22332713127629
81559	1694	22332723127629
81577	1654	20445211999798
81578	1654	20445222999798
81581	1397	1328588993000
81582	1678	20880721107000
81583	1395	58104625905007706
81594	1560	18594930277001
81595	1560	18595291277001
81628	526	69600085000000
81636	1692	31460359619999
81637	1692	31460369619999
81672	1599	18340362393047
81690	1549	23376003000000
81691	1549	23376023000000
81699	1397	1328348969000
81700	1678	20880721131000
81721	1690	132484213000000
81722	1690	132484223000000
81733	1394	328324853000000
81734	1394	328324864000000
81737	1633	15156716975638
81738	1633	15156727975638
81745	1397	1328268961000
81746	1678	20880721139000
81747	1716	20206938000000
81748	1716	20206948000000
81806	1611	13743010000000
81807	1611	13743021000000
81826	1702	10800352000000
81827	1702	10800362000000
81833	2132	148434435000
81834	1874	10199000
81835	1587	25920783000000
81838	1397	1328088943000
81839	1678	20880721157000
81840	1610	16560585019950
81841	1610	16560595019950
81850	1700	19746093276737
81851	1700	19746104276737
81860	1850	20079178000000
81861	1850	20079189000000
81870	1649	24764368999992
81879	1593	23590431000000
81880	1593	23590453000000
81898	1397	1327968931000
81899	1678	20880721169000
81900	2132	148430431000
81901	1874	10203000
81913	1397	1327928927000
81914	1678	20880721173000
81915	1394	329764864000000
81916	1394	329764874000000
81934	1397	1327878922000
81935	1678	20880721178000
81936	1690	133924233000000
81937	1690	133924243000000
81964	1623	59762930899898
81965	1623	59762972899898
81978	1746	8434381000000
81980	1397	1327768911000
81981	1678	20880721189000
81982	2132	148424425000
81983	1874	10209000
81984	1395	58106785957007706
81985	1397	1327758910000
81986	1678	20880721190000
81987	1397	1327748909000
81988	1678	20880721191000
81989	1397	1327738908000
81990	1678	20880721192000
81991	1397	1327728907000
81992	1678	20880721193000
81993	2132	148423424000
81994	1874	10210000
81995	1717	16668127000023
81996	1717	16668168000023
81998	1397	1327718906000
81999	1678	20880721194000
82000	1394	332644885000000
82001	1394	332644895000000
82024	1397	1327638898000
82025	1678	20880721202000
82026	2132	148420421000
82027	1874	10213000
82028	1704	5106313000000
82029	1704	5106324000000
82033	1623	59762941899898
82068	2207	100000000
82069	1397	1327598894000
82070	1678	20880721206000
82071	1395	58108225968007706
82072	1395	58108226078007706
82082	1397	1327568891000
82083	1678	20880721209000
82084	2132	148418419000
82085	1874	10215000
82090	1397	1327558890000
82091	1678	20880721210000
82092	1692	32180379619999
82103	1601	18650445620000
82104	1601	18650456620000
82109	1397	1327518886000
82110	1678	20880721214000
82119	2204	100000000
82120	1397	1327498884000
82121	1678	20880721216000
82122	1397	1327488883000
82123	1678	20880721217000
82124	662	66720000000000
82125	662	66720120000000
82142	1723	20519600085979
82199	1740	18645479000000
82227	340	66720000000000
82228	340	66720024000000
82235	1397	1327338868000
82236	1678	20880721232000
82237	1397	1327328867000
82238	1678	20880721233000
82239	2133	97404816000
82240	1874	10260000
82241	2134	96989988000
81344	1874	10169000
81345	1724	12187409500000
81346	1724	12187420500000
81352	1680	15849620500035
81353	1680	15849630500035
81364	1397	1329049039000
81365	1678	20880721061000
81366	2132	148463464000
81367	1874	10170000
81368	1684	22320619880623
81369	1684	22320630880623
81393	1397	1328989033000
81394	1678	20880721067000
81395	1397	1328979032000
81396	1678	20880721068000
81397	1547	14253491000000
81398	1547	14253511000000
81401	1397	1328969031000
81402	1678	20880721069000
81403	1395	58102465854007706
81404	1395	58102465864007706
81414	1397	1328939028000
81415	1678	20880721072000
81416	1397	1328929027000
81417	1678	20880721073000
81418	2132	148459460000
81419	1874	10174000
81420	1690	131764193000000
81421	1690	131764214000000
81423	1395	58103185864007706
81424	1395	58103185885007706
81436	1560	17154741277001
81437	1874	10154000
81438	1874	10155000
81439	1874	10157000
81440	1874	10158000
81441	1560	17874741277001
81442	1560	17874930277001
81445	1397	1328899024000
81446	1678	20880721076000
81447	1397	1328889023000
81448	1678	20880721077000
81449	2132	148458459000
81450	1874	10175000
81451	1762	21202092994000
81459	1397	1328859020000
81460	1678	20880721080000
81461	2132	148457458000
81462	1874	10176000
81463	1695	40001000
81464	1765	15452318999000
81473	1564	12786535000000
81474	1564	12786545000000
81481	1397	1328819016000
81482	1678	20880721084000
81494	1397	1328779012000
81495	1678	20880721088000
81496	1397	1328769011000
81497	1678	20880721089000
81498	2112	5759073000000
81499	2112	5759093000000
81508	1699	7989838750126
81509	1699	7989849750126
81511	2087	5039107000000
81512	2087	5039118000000
81517	1397	1328739008000
81518	1678	20880721092000
81519	1637	219605115819988
81526	1601	17210393620000
81527	1601	17210404620000
81533	1397	1328709005000
81534	1678	20880721095000
81535	1397	1328699004000
81536	1678	20880721096000
81537	2132	148452453000
81538	1874	10181000
81539	1397	1328689003000
81540	1678	20880721097000
81541	1547	14973511000000
81542	1547	14973521000000
81570	1394	326884843000000
81571	1394	326884863000000
81584	1397	1328578992000
81585	1678	20880721108000
81586	1397	1328568991000
81587	1678	20880721109000
81588	1451	14299004000000
81589	1451	14299024000000
81606	1397	1328528987000
81607	1678	20880721113000
81608	2132	148447448000
81609	1874	10186000
81610	1705	14315604500145
81611	1705	14315615500145
81630	1397	1328488983000
81631	1678	20880721117000
81632	1718	9666818763340
81646	1395	58105345905007706
81647	1395	58105345916007706
81661	1395	58105345946007706
81662	1395	58106065946007706
81669	1599	18340352393047
81670	1599	18340372393047
81681	1397	1328378972000
81682	1678	20880721128000
81701	1637	220325115819988
81702	1637	220325125819988
81706	1685	131042688571430
81707	1397	1328328967000
81708	1678	20880721133000
81709	2118	1394000000
81710	1726	95067112000
81711	2132	148441442000
81712	1874	10192000
81713	1679	18719077653000
81714	1679	18719089653000
81749	1397	1328258960000
81750	1678	20880721140000
81751	2132	148439440000
81752	1874	10194000
81753	1747	8656931000000
81757	1739	28079761000000
81758	1739	28079772000000
81759	1397	1328248959000
81760	1678	20880721141000
81761	1397	1328238958000
81762	1678	20880721142000
81763	1397	1328228957000
81764	1678	20880721143000
81765	1397	1328218956000
81766	1678	20880721144000
81767	2132	148438439000
81768	1874	10195000
81769	1601	17930404620000
81770	1601	17930445620000
81786	1397	1328178952000
81787	1678	20880721148000
81788	1611	22370601840000
81789	1095	904632174710000
81790	1611	19901996500000
81791	1215	610373354340000
81792	1611	13023010000000
81793	1341	1700859623251650
81794	1668	20126864000000
81795	1714	17446540103056
81800	1690	133204223000000
81801	1690	133204233000000
81812	1397	1328138948000
81813	1678	20880721152000
81814	1419	33579771280064
81815	1419	33579781280064
81821	1708	16595906000021
81822	1708	16595917000021
81842	1850	19359168000000
81843	1850	19359178000000
81852	1692	32180369619999
81853	1692	32180380619999
81862	1650	11554197000000
81863	1650	11554208000000
81881	1397	1328028937000
81882	1678	20880721163000
81883	1992	15119354990000
81884	1992	15839354990000
81926	1397	1327898924000
81927	1678	20880721176000
81928	1694	23052723127629
81929	1694	23052733127629
81938	1397	1327868921000
81939	1678	20880721179000
81940	2132	148427428000
81941	1874	10206000
81942	457	66720011000000
81945	1397	1327858920000
81946	1678	20880721180000
81947	1451	15019024000000
81948	1451	15019034000000
81949	1395	58106785946007706
81966	1397	1327808915000
81967	1678	20880721185000
81968	1397	1327798914000
81969	1678	20880721186000
81970	1397	1327788913000
81971	1678	20880721187000
81972	2132	148425426000
81973	1874	10208000
81671	1690	131764213000000
81680	606	78957972812962
81685	1397	1328368971000
81686	1678	20880721129000
81687	526	69500075000000
81688	1474	13313364000023
81689	1489	17184441000000
81703	1397	1328338968000
81704	1678	20880721132000
81705	1608	19005736000000
81715	1448	9396786000001
81716	1448	9396798000001
81727	1397	1328298964000
81728	1678	20880721136000
81729	2132	148440441000
81730	1874	10193000
81731	1426	21885151000000
81732	1426	21885162000000
81735	1643	2480542914700
81736	1643	2480553914700
81754	1704	4386314000000
81755	1708	15875895000021
81756	1708	15875906000021
81771	1397	1328208955000
81772	1678	20880721145000
81773	1588	19655082000000
81774	1559	15802821000000
81775	1559	15802831000000
81796	1397	1328168951000
81797	1678	20880721149000
81798	1402	61774771319298
81799	1402	61774781319298
81816	1397	1328128947000
81817	1678	20880721153000
81818	2132	148435436000
81819	1874	10198000
81820	1599	18340363393047
81829	1397	1328108945000
81830	1678	20880721155000
81831	1587	25920772000000
81832	1587	25920991000000
81836	1397	1328098944000
81837	1678	20880721156000
81844	1679	18719087653000
81854	1397	1328068941000
81855	1678	20880721159000
81856	2132	148433434000
81857	1874	10200000
81858	1693	6619312757818
81859	1693	6619323757818
81864	1397	1328058940000
81865	1678	20880721160000
81866	1474	15311354000023
81867	2200	1511000000000
81868	1623	59042910899898
81869	1623	59042930899898
81885	1397	1328018936000
81886	1678	20880721164000
81887	1397	1328008935000
81888	1678	20880721165000
81889	1397	1327998934000
81890	1678	20880721166000
81891	1397	1327988933000
81892	1678	20880721167000
81893	1397	1327978932000
81894	1678	20880721168000
81895	2132	148431432000
81896	1874	10202000
81897	1679	18719118653000
81906	1397	1327948929000
81907	1678	20880721171000
81908	1397	1327938928000
81909	1678	20880721172000
81910	2132	148429430000
81911	1874	10204000
81912	2112	5759094000000
81919	1723	20519538085979
81920	1723	20519548085979
81921	1397	1327908925000
81922	1678	20880721175000
81923	2132	148428429000
81924	1874	10205000
81925	43	81120837890000
81943	1394	331204874000000
81944	1394	331204885000000
81950	1397	1327848919000
81951	1678	20880721181000
81952	1397	1327838918000
81953	1678	20880721182000
81954	1397	1327828917000
81955	1678	20880721183000
81956	1397	1327818916000
81957	1678	20880721184000
81958	2132	148426427000
81959	1874	10207000
81960	1769	1586900000
81961	579	66000100000000
81962	1690	134644243000000
81963	1690	134644285000000
81975	1397	1327778912000
81976	1678	20880721188000
81977	1747	8656930000000
82032	1698	18537142550035
82055	1688	48959864908000
82056	1688	48959959908000
82075	1397	1327588893000
82076	1678	20880721207000
82077	1394	334084905000000
82080	1397	1327578892000
82081	1678	20880721208000
82086	1643	3200553914700
82087	1643	3200564914700
82097	1397	1327538888000
82098	1678	20880721212000
82099	2132	148417418000
82100	1874	10216000
82101	1690	135364285000000
82102	1690	135364296000000
82113	1397	1327508885000
82114	1678	20880721215000
82115	2132	148416417000
82116	1874	10217000
82117	1688	50399969908000
82118	1688	50399980908000
82140	1680	16569641500035
82141	1680	16569703500035
82147	1402	62494781319298
82148	1402	62494791319298
82179	1895	1440236000000
82188	1689	15120523287625
82210	1397	1327358870000
82211	1678	20880721230000
82212	1397	1327348869000
82213	1678	20880721231000
82214	2134	96992997000
82215	1874	10246000
82216	2134	96991994000
82217	1874	10249000
82218	2133	97407822000
82219	1874	10251000
82220	2133	97406820000
82221	1874	10253000
82222	1395	58108225992007706
82225	1394	341285000000000
82226	1394	341285024000000
82229	2133	97405818000
82230	1874	10255000
82231	2134	96990991000
82232	1874	10258000
82233	1457	21504444040000
82234	1457	21504446040000
82280	2203	110000000
82281	1397	1327268861000
82282	1678	20880721239000
82283	2134	96983970000
82284	1874	10287000
82285	171	81110532524688
82295	1673	24085496000000
82316	1670	21601245000000
82319	1718	10386818763340
82320	1718	10386829763340
82347	1762	22642112994000
82348	1762	22642134994000
82355	1688	51840013908000
82356	1688	51840024908000
82362	526	66720065000000
82363	526	66720076000000
82366	1474	16031354000023
82367	1474	16031365000023
82444	1397	1327098844000
82445	1678	20880721256000
82446	2134	96965916000
82447	1874	10351000
82448	2133	97396800000
82449	1874	10353000
82450	43	82560958890000
82451	43	82560970890000
82452	1397	1327088843000
82453	1678	20880721257000
82454	2133	97395798000
82455	1874	10355000
82456	2134	96964913000
82457	1874	10358000
82458	1692	32900379619999
82459	1692	32900391619999
81717	1397	1328318966000
81718	1678	20880721134000
81719	1688	48239854908000
81720	1688	48239864908000
81723	1397	1328308965000
81724	1678	20880721135000
81725	1419	32139741280064
81726	1419	32139751280064
81739	1397	1328288963000
81740	1678	20880721137000
81741	1397	1328278962000
81742	1678	20880721138000
81743	1419	32859751280064
81744	1419	32859771280064
81776	1397	1328198954000
81777	1678	20880721146000
81778	2132	148437438000
81779	1874	10196000
81780	1444	18575270159999
81781	1444	18575281159999
81782	1397	1328188953000
81783	1678	20880721147000
81784	1719	19460820000000
81785	1719	19460830000000
81802	1397	1328158950000
81803	1678	20880721150000
81804	2132	148436437000
81805	1874	10197000
81808	1397	1328148949000
81809	1678	20880721151000
81810	1444	19295281159999
81811	1444	19295291159999
81823	1397	1328118946000
81824	1678	20880721154000
81825	1703	10080825000000
81828	2086	4319100000000
81845	1397	1328078942000
81846	1678	20880721158000
81847	2172	197999000
81848	2131	193998000
81849	1547	15693533000000
81871	1397	1328048939000
81872	1678	20880721161000
81873	1397	1328038938000
81874	1678	20880721162000
81875	2131	191998000
81876	2132	148432433000
81877	1874	10201000
81878	1649	24764401999992
81902	1397	1327958930000
81903	1678	20880721170000
81904	1455	10114071000000
81905	1455	10114081000000
81917	1397	1327918926000
81918	1678	20880721174000
81930	1397	1327888923000
81931	1678	20880721177000
81932	1756	9073149545609
81933	1756	9073159545609
81979	1704	4386313000000
81997	1513	29520940000000
82010	1685	131042699571430
82011	1397	1327688903000
82012	1678	20880721197000
82013	1397	1327678902000
82014	1678	20880721198000
82015	1397	1327668901000
82016	1678	20880721199000
82017	1397	1327658900000
82018	1678	20880721200000
82019	1397	1327648899000
82020	1678	20880721201000
82021	2132	148421422000
82022	1874	10212000
82023	1422	10945114860211
82030	1395	58107505957007706
82031	1395	58107505968007706
82060	1397	1327608895000
82061	1678	20880721205000
82062	2205	199000000
82063	2132	148419420000
82064	1874	10214000
82065	2206	199000000
82066	1687	7820163223172
82067	1687	7820176223172
82073	43	81840848890000
82074	43	81840958890000
82088	2086	5039100000000
82089	2086	5039111000000
82105	1397	1327528887000
82106	1678	20880721213000
82107	1688	49679959908000
82108	1688	49679969908000
82111	1394	335524905000000
82112	1394	335524915000000
82143	1397	1327448879000
82144	1678	20880721221000
82145	1394	336964915000000
82146	1394	336964925000000
82163	1397	1327408875000
82164	1678	20880721225000
82165	1397	1327398874000
82166	1678	20880721226000
82167	2133	97411830000
82168	2134	96998012000
82169	1874	10221000
82170	1874	10222000
82171	1874	10223000
82172	1874	10224000
82173	2132	148413414000
82174	1874	10225000
82175	2134	96997009000
82176	1874	10228000
82177	1895	1440212000000
82178	1895	1440520000000
82197	1740	18645356000000
82198	1740	18645368000000
82202	1397	1327368871000
82203	1678	20880721229000
82204	2134	96994000000
82205	1874	10241000
82206	2133	97408824000
82207	1874	10243000
82208	1394	339844988000000
82209	1394	339845000000000
82260	1397	1327298864000
82261	1678	20880721236000
82262	1397	1327288863000
82263	1678	20880721237000
82264	2203	130000000
82265	2134	96986979000
82266	1874	10276000
82267	2134	96985976000
82268	1874	10279000
82269	2133	97401810000
82270	1874	10281000
82271	1395	58108226001007706
82274	1397	1327278862000
82275	1678	20880721238000
82276	2134	96984973000
82277	1874	10284000
82278	2200	801998000000
82279	1395	58108225980007706
82292	2134	96981964000
82293	1874	10293000
82294	1991	21356006441475
82310	1397	1327218856000
82311	1678	20880721244000
82312	2134	96977952000
82313	1874	10305000
82314	1546	17281019000000
82315	1546	17281030000000
82317	349	68160030000000
82318	349	68160041000000
82357	1397	1327178852000
82358	1678	20880721248000
82359	2134	96973940000
82360	1874	10317000
82361	1681	14183275759830
82364	1714	18886584103056
82365	1714	18886595103056
82408	1397	1327148849000
82409	1678	20880721251000
82410	1397	1327138848000
82411	1678	20880721252000
82412	2134	96970931000
82413	1874	10326000
82414	2134	96969928000
82415	1874	10329000
82416	2132	148412413000
82417	1874	10330000
82418	2133	97400808000
82419	1874	10332000
82420	1549	24096013000000
82421	1549	24096037000000
82573	1397	1326948829000
82574	1678	20880721271000
82575	1444	19295301159999
82576	2134	96950871000
82577	1874	10430000
82578	2133	97381770000
82579	1874	10432000
82580	2132	148406407000
82581	1874	10433000
82582	1444	20015301159999
81974	1739	28079792000000
82002	1397	1327708905000
82003	1678	20880721195000
82004	1397	1327698904000
82005	1678	20880721196000
82006	2132	148422423000
82007	1874	10211000
82008	1394	334084895000000
82009	1394	334084916000000
82034	1726	93857112000
82035	2201	200000000
82036	1397	1327628897000
82037	1678	20880721203000
82038	1726	92647112000
82039	2202	200000000
82040	1726	91437112000
82041	2203	200000000
82042	1726	90227112000
82043	2204	200000000
82044	1726	89017112000
82045	2205	200000000
82046	1726	87807112000
82047	2206	200000000
82048	1726	86597112000
82049	2207	200000000
82050	1726	85387112000
82051	2208	200000000
82052	579	66000095000000
82053	2148	2879068000000
82054	2148	2879163000000
82057	1397	1327618896000
82058	1678	20880721204000
82059	1549	23376013000000
82078	1611	14463021000000
82079	1611	14463031000000
82093	1397	1327548889000
82094	1678	20880721211000
82095	1684	23040630880623
82096	1684	23040640880623
82126	1397	1327478882000
82127	1678	20880721218000
82128	1397	1327468881000
82129	1678	20880721219000
82130	1397	1327458880000
82131	1678	20880721220000
82132	2203	190000000
82133	2203	180000000
82134	2203	170000000
82135	2132	148415416000
82136	1874	10218000
82137	2200	801999000000
82138	2209	708000000000
82139	1395	58108226030007706
82149	1726	84177112000
82150	2210	200000000
82151	1726	82967112000
82152	2184	1399000000
82153	1397	1327438878000
82154	1678	20880721222000
82155	1397	1327428877000
82156	1678	20880721223000
82157	1397	1327418876000
82158	1678	20880721224000
82159	2203	160000000
82160	2132	148414415000
82161	1874	10219000
82162	1394	336964976000000
82180	1397	1327388873000
82181	1678	20880721227000
82182	2134	96996006000
82183	1874	10231000
82184	2133	97410828000
82185	1874	10233000
82186	1719	20180830000000
82187	1719	20180842000000
82189	1397	1327378872000
82190	1678	20880721228000
82191	2134	96995003000
82192	1874	10236000
82193	2133	97409826000
82194	1874	10238000
82195	1671	17328537530515
82196	1671	17328549530515
82200	1394	338404976000000
82201	1394	338404988000000
82223	1402	63214791319298
82224	1402	63214815319298
82244	2203	150000000
82245	1397	1327318866000
82246	1678	20880721234000
82247	2203	140000000
82248	1397	1327308865000
82249	1678	20880721235000
82250	2133	97403814000
82251	1874	10265000
82252	2133	97402812000
82253	1874	10267000
82254	2134	96988985000
82255	1874	10270000
82256	2134	96987982000
82257	1874	10273000
82258	1714	18166540103056
82259	1714	18166584103056
82286	1397	1327258860000
82287	1678	20880721240000
82288	2134	96982967000
82289	1874	10290000
82290	1685	131762699571430
82291	1685	131762710571430
82337	1397	1327208855000
82338	1678	20880721245000
82339	1397	1327198854000
82340	1678	20880721246000
82341	2134	96976949000
82342	1874	10308000
82343	2134	96975946000
82344	1874	10311000
82345	1395	58108945980007706
82346	1395	58108946002007706
82349	1397	1327188853000
82350	1678	20880721247000
82351	2134	96974943000
82352	1874	10314000
82353	1710	21834808473290
82354	1710	21834819473290
82399	1397	1327168851000
82400	1678	20880721249000
82401	1397	1327158850000
82402	1678	20880721250000
82403	1874	10320000
82404	2206	1399000000
82405	1874	10323000
82406	1560	18594402277001
82407	1560	18594426277001
82422	1397	1327128847000
82423	1678	20880721253000
82424	1397	1327118846000
82425	1678	20880721254000
82426	1397	1327108845000
82427	1678	20880721255000
82428	2132	148411412000
82429	1874	10333000
82430	2133	97399806000
82431	1874	10335000
82432	2134	96968925000
82433	1874	10338000
82434	2134	96967922000
82435	1874	10341000
82436	2134	96966919000
82437	1874	10344000
82438	2133	97398804000
82439	1874	10346000
82440	2133	97397802000
82441	1874	10348000
82442	1394	342725024000000
82443	1394	342725061000000
82522	1397	1327008835000
82523	1678	20880721265000
82524	2133	97387782000
82525	1874	10397000
82526	2134	96956889000
82527	1874	10400000
82528	2132	148408409000
82529	1874	10401000
82530	1462	720013000000
82584	1710	21834829473290
82585	1710	22554829473290
82586	1710	22554832473290
82590	1397	1326938828000
82591	1678	20880721272000
82592	1729	0
82593	2148	4001506880750
82594	2134	96949868000
82595	1874	10436000
82596	2133	97380768000
82597	1874	10438000
82598	1394	344165061000000
82599	1394	344165074000000
82647	1679	19439118653000
82648	1679	19439130653000
82649	1692	33620391619999
82650	1692	33620403619999
82669	1397	1326858820000
82670	1678	20880721280000
82671	1397	1326848819000
82242	1874	10263000
82243	1426	21885173000000
82272	2211	719000000000
82273	2211	719033000000
82296	1397	1327248859000
82297	1678	20880721241000
82298	1397	1327238858000
82299	1678	20880721242000
82300	1397	1327228857000
82301	1678	20880721243000
82302	2134	96980961000
82303	1874	10296000
82304	2134	96979958000
82305	1874	10299000
82306	2134	96978955000
82307	1874	10302000
82308	1688	51119980908000
82309	1688	51120013908000
82321	1726	93856112000
82322	1474	11711354000023
82323	1726	92646112000
82324	1726	91436112000
82325	1726	90226112000
82326	526	68780064000000
82327	1474	11811354000023
82328	1726	89016112000
82329	1726	87806112000
82330	1726	86596112000
82331	1726	85386112000
82332	1726	84176112000
82333	1726	82966112000
82334	1762	21922256994000
82335	1762	22642256994000
82336	1762	22642257994000
82368	1726	81766112000
82369	2212	200000000
82370	1726	80565112000
82371	2206	1400000000
82372	1874	10220000
82373	1874	10226000
82374	1874	10229000
82375	1874	10232000
82376	1874	10235000
82377	1874	10244000
82378	1874	10247000
82379	1874	10250000
82380	1874	10256000
82381	1874	10259000
82382	1874	10262000
82383	1874	10268000
82384	1874	10271000
82385	1874	10274000
82386	1874	10277000
82387	1874	10280000
82388	1874	10283000
82389	1874	10286000
82390	1874	10289000
82391	1874	10292000
82392	1874	10295000
82393	1874	10298000
82394	2134	96972937000
82395	1874	10301000
82396	2134	96971934000
82397	1874	10304000
82398	1571	22320642001024
82460	1397	1327078842000
82461	1678	20880721258000
82462	2134	96963910000
82463	1874	10361000
82464	2133	97394796000
82465	1874	10363000
82466	2132	148410411000
82467	1874	10364000
82468	1768	17150846110000
82469	1874	10360000
82470	1768	17150845110000
82471	1688	51840026908000
82472	1397	1327068841000
82473	1678	20880721259000
82474	2134	96962907000
82475	1874	10367000
82476	2133	97393794000
82477	1874	10369000
82478	1980	17999423000000
82479	1980	17999435000000
82480	1933	3003281000000
82481	1397	1327058840000
82482	1678	20880721260000
82483	1397	1327048839000
82484	1678	20880721261000
82485	2132	148409410000
82486	1874	10370000
82487	2133	97392792000
82488	1874	10372000
82489	2133	97391790000
82490	1874	10374000
82491	2134	96961904000
82492	1874	10377000
82493	2134	96960901000
82494	1874	10380000
82495	1768	17150858110000
82496	1768	17150856110000
82505	1688	52560026908000
82506	1688	52560038908000
82514	1397	1327018836000
82515	1678	20880721264000
82516	2133	97388784000
82517	1874	10392000
82518	2134	96957892000
82519	1874	10395000
82520	1395	58109666002007706
82521	1395	58109666014007706
82587	1419	33579791280064
82588	1419	34299791280064
82589	1419	34299794280064
82600	1397	1326928827000
82601	1678	20880721273000
82602	2134	96948865000
82603	1874	10441000
82604	2133	97379766000
82605	1874	10443000
82606	1685	132482710571430
82607	1685	132482722571430
82619	1397	1326908825000
82620	1678	20880721275000
82621	1397	1326898824000
82622	1678	20880721276000
82623	2133	97377762000
82624	1874	10450000
82625	2132	148405406000
82626	1874	10451000
82627	2133	97376760000
82628	1874	10453000
82629	2148	4880750
82630	2147	1525800000000
82637	1397	1326888823000
82638	1678	20880721277000
82639	2134	96944853000
82640	1874	10462000
82641	2133	97375758000
82642	1874	10464000
82643	1395	58110386014007706
82644	1395	58110386026007706
82701	1397	1326818816000
82702	1678	21600733284000
82703	2134	96937832000
82704	1874	10499000
82705	2133	97368744000
82706	1874	10501000
82707	1711	18525315000000
82708	1711	18525327000000
82748	1397	1326768811000
82749	1678	21600733289000
82750	2133	97363734000
82751	1874	10525000
82752	2134	96932817000
82753	1874	10528000
82754	1700	20466104276737
82755	1700	20466116276737
82766	1673	25525508000000
82767	1673	25525520000000
82780	1706	13892758600135
82781	1678	20880721284000
82782	1678	20880721285000
82783	1678	20880721286000
82784	1678	20880721287000
82785	1678	20880721288000
82786	1678	20880721289000
82787	1678	20880721290000
82788	1678	20880721291000
82789	1706	14612758600135
82790	1706	14613425600135
82793	1502	1439910000000
82794	1397	1326738808000
82795	1678	21600733292000
82796	2134	96929808000
82797	1874	10542000
82798	2133	97360728000
82799	1874	10544000
82800	1509	17952078851155
82803	1397	1326728807000
82804	1678	21600733293000
82805	2134	96928805000
82806	1874	10547000
82807	2133	97359726000
82497	1397	1327038838000
82498	1678	20880721262000
82499	2133	97390788000
82500	1874	10382000
82501	2134	96959898000
82502	1874	10385000
82503	632	76221256000000
82504	632	76221268000000
82507	1397	1327028837000
82508	1678	20880721263000
82509	2134	96958895000
82510	1874	10388000
82511	2133	97389786000
82512	1874	10390000
82513	1610	16560597019950
82531	1610	17280597019950
82532	1610	17280610019950
82533	1397	1326998834000
82534	1678	20880721266000
82535	1397	1326988833000
82536	1678	20880721267000
82537	1397	1326978832000
82538	1678	20880721268000
82539	1397	1326968831000
82540	1678	20880721269000
82541	1397	1326958830000
82542	1678	20880721270000
82543	2132	148407408000
82544	1874	10402000
82545	1729	14775141880750
82546	967	507282475000000
82547	1729	10284840880750
82548	1087	909006169720300
82549	1729	1842439880750
82550	1333	1709039342094750
82551	2134	96955886000
82552	1874	10405000
82553	2134	96954883000
82554	1874	10408000
82555	2134	96953880000
82556	1874	10411000
82557	2134	96952877000
82558	1874	10414000
82559	2134	96951874000
82560	1874	10417000
82561	2133	97386780000
82562	1874	10419000
82563	2133	97385778000
82564	1874	10421000
82565	2133	97384776000
82566	1874	10423000
82567	2133	97383774000
82568	1874	10425000
82569	2133	97382772000
82570	1874	10427000
82571	1508	18756609500009
82572	1508	18756673500009
82610	1397	1326918826000
82611	1678	20880721274000
82612	2134	96947862000
82613	1874	10446000
82614	2133	97378764000
82615	1874	10448000
82616	2148	971805880750
82617	1207	613340845055850
82618	1623	59762943899898
82651	1397	1326878822000
82652	1678	20880721278000
82653	1397	1326868821000
82654	1678	20880721279000
82655	2133	97374756000
82656	1874	10466000
82657	2134	96943850000
82658	1874	10469000
82659	2132	148404405000
82660	1874	10470000
82661	2134	96942847000
82662	1874	10473000
82663	2133	97373754000
82664	1874	10475000
82665	1716	20926948000000
82666	1716	20926973000000
82685	1397	1326838818000
82686	1678	20880721282000
82687	2134	96939838000
82688	1874	10489000
82689	2133	97370748000
82690	1874	10491000
82758	1397	1326758810000
82759	1678	21600733290000
82760	2134	96931814000
82761	1874	10531000
82762	2133	97362732000
82763	1874	10533000
82764	42	77949382000000
82765	42	77949394000000
82768	1397	1326748809000
82769	1678	21600733291000
82770	470	66000053000000
82771	764	3307760000000
82772	2132	148400401000
82773	1874	10534000
82774	2134	96930811000
82775	1874	10537000
82776	2133	97361730000
82777	1874	10539000
82778	1637	221045115819988
82779	1637	221045138819988
82812	1502	1439810000000
82813	1397	1326718806000
82814	1678	21600733294000
82815	1397	1326708805000
82816	1678	21600733295000
82817	2134	96927802000
82818	1874	10550000
82819	2134	96926799000
82820	1874	10553000
82821	1874	10555000
82822	2132	148399400000
82823	1874	10556000
82824	2133	97358724000
82825	1874	10558000
82826	1395	58109666139007706
82827	2133	97357722000
82828	1874	10560000
82829	1395	58110386139007706
82830	1395	58110386140007706
82841	1394	347045099000000
82842	1394	347045111000000
82851	1397	1326678802000
82852	1678	21600733298000
82853	1397	1326668801000
82854	1678	21600733299000
82855	2133	97354716000
82856	1874	10572000
82857	2134	96923790000
82858	1874	10575000
82859	2132	148398399000
82860	1874	10576000
82861	2134	96922787000
82862	1874	10579000
82863	2133	97353714000
82864	1874	10581000
82865	526	66720090000000
82876	1440	17999337049920
82877	1440	17999349049920
82903	1394	351365135000000
82904	1394	351365160000000
82931	1397	1326598794000
82932	1678	21600733306000
82933	1397	1326588793000
82934	1678	21600733307000
82935	2133	97346700000
82936	1874	10615000
82937	2133	97345698000
82938	1874	10617000
82939	2134	96915766000
82940	1874	10620000
82941	2134	96914763000
82942	1874	10623000
82943	1395	58112546177007706
82944	1395	58112546201007706
82990	1874	10650000
82991	1489	17904452000000
82999	1723	20519550085979
83011	1874	10661000
83070	1688	54000063908000
83071	1688	54000137908000
83098	1724	12187454500000
83099	1724	12907454500000
83100	1724	12907457500000
83138	1874	10728000
83139	1546	17281020000000
83157	1718	11106829763340
83158	1718	11106831763340
83169	1637	221765138819988
83170	1637	221765150819988
83200	1397	1326308765000
83201	1678	21600733335000
83202	2133	97317642000
83203	1874	10765000
83204	2134	96887682000
83205	1874	10768000
83206	2132	148387388000
83207	1874	10769000
82583	1444	20015304159999
82608	302	66720000000000
82609	302	66720012000000
82631	2134	96946859000
82632	2134	96945856000
82633	1874	10456000
82634	1874	10457000
82635	1874	10459000
82636	1668	20126877000000
82645	1564	13506545000000
82646	1564	13506557000000
82667	1688	53280038908000
82668	1688	53280063908000
82691	1397	1326828817000
82692	1678	20880721283000
82693	2134	96938835000
82694	1874	10494000
82695	2133	97369746000
82696	1874	10496000
82697	1447	16714610943000
82698	1447	16714622943000
82709	1397	1326808815000
82710	1678	21600733285000
82711	470	74670493000000
82712	1309	1708723637751650
82713	470	71239483000000
82714	1063	908815465000000
82715	470	68924473000000
82716	1183	613195750000000
82717	1397	1326798814000
82718	1678	21600733286000
82719	1397	1326788813000
82720	1678	21600733287000
82721	470	67009463000000
82722	943	507154775000000
82723	2134	96936829000
82724	1874	10504000
82725	2133	97367742000
82726	1874	10506000
82727	2132	148402403000
82728	1874	10507000
82729	2134	96935826000
82730	1874	10510000
82731	2133	97366740000
82732	1874	10512000
82733	2133	97365738000
82734	1874	10514000
82735	2134	96934823000
82736	1874	10517000
82737	1708	16595983000021
82756	1673	24805496000000
82757	1673	24805508000000
82801	1560	19314426277001
82802	1560	19314538277001
82886	1397	1326638798000
82887	1678	21600733302000
82888	1397	1326628797000
82889	1678	21600733303000
82890	2134	96919778000
82891	1874	10594000
82892	2132	148397398000
82893	1874	10595000
82894	2133	97350708000
82895	1874	10597000
82896	2133	97349706000
82897	1874	10599000
82898	2134	96918775000
82899	1874	10602000
82900	1395	58111826152007706
82901	1395	58111826177007706
82992	1397	1326518786000
82993	1678	21600733314000
82994	2134	96908745000
82995	1874	10655000
82996	2133	97338684000
82997	1874	10657000
82998	1395	58112546189007706
83000	1397	1326508785000
83001	1678	21600733315000
83002	2134	96907742000
83003	1874	10660000
83004	2133	97337682000
83005	1874	10662000
83006	2132	148393394000
83007	1874	10663000
83008	1700	20466117276737
83019	1397	1326488783000
83020	1678	21600733317000
83021	1397	1326478782000
83022	1678	21600733318000
83023	1397	1326468781000
83024	1678	21600733319000
83025	1397	1326458780000
83026	1678	21600733320000
83027	1397	1326448779000
83028	1678	21600733321000
83029	1397	1326438778000
83030	1678	21600733322000
83031	2133	97335678000
83032	1874	10670000
83033	2132	148392393000
83034	1874	10671000
83035	2134	96905736000
83036	1874	10674000
83037	2134	96904733000
83038	1874	10677000
83039	2132	148391392000
83040	1874	10678000
83041	2133	97334676000
83042	1874	10680000
83043	2134	96903730000
83044	1874	10683000
83045	2134	96902727000
83046	1874	10686000
83047	2134	96901724000
83048	1874	10689000
83049	2134	96900721000
83050	1874	10692000
83051	2133	97333674000
83052	1874	10694000
83053	2133	97332672000
83054	1874	10696000
83055	2133	97331670000
83056	1874	10698000
83057	2133	97330668000
83058	1874	10700000
83059	1489	18624453000000
83060	1489	18624527000000
83072	1397	1326428777000
83073	1678	21600733323000
83074	1397	1326418776000
83075	1678	21600733324000
83076	1397	1326408775000
83077	1678	21600733325000
83078	2132	148390391000
83079	1874	10701000
83080	2133	97329666000
83081	1874	10703000
83082	2133	97328664000
83083	1874	10705000
83084	2133	97327662000
83085	1874	10707000
83086	1395	58111826211007706
83087	2134	96899718000
83088	1874	10710000
83089	2134	96898715000
83090	1874	10713000
83091	2134	96897712000
83092	1874	10716000
83093	1395	58112546211007706
83094	1395	58112546214007706
83095	1536	14400785999959
83096	1536	15120785999959
83097	1536	15120788999959
83111	2134	96896709000
83112	1874	10719000
83113	1874	10721000
83114	1874	10723000
83115	2134	96895706000
83116	1874	10726000
83117	1696	17777471835100
83121	1397	1326378772000
83122	1678	21600733328000
83123	2132	148389390000
83124	1874	10727000
83125	2134	96894703000
83126	1874	10730000
83127	2133	97324656000
83128	1874	10732000
83129	1746	8434394000000
83132	58	88986624999641
83133	58	88986647999641
83135	1747	8656943000000
83136	1688	54720137908000
83137	1688	54720160908000
83147	1397	1326358770000
83148	1678	21600733330000
83149	2134	96892697000
83150	1874	10740000
83151	2133	97322652000
83152	1874	10742000
83153	1422	11665114860211
83154	1422	11665126860211
83159	1397	1326348769000
83160	1678	21600733331000
82672	1678	20880721281000
82673	2133	97372752000
82674	1874	10477000
82675	2134	96941844000
82676	1874	10480000
82677	2134	96940841000
82678	1874	10483000
82679	2132	148403404000
82680	1874	10484000
82681	2133	97371750000
82682	1874	10486000
82683	1394	345605074000000
82684	1394	345605099000000
82699	1678	21600721283000
82700	1678	21600733283000
82738	1397	1326778812000
82739	1678	21600733288000
82740	2133	97364736000
82741	1874	10519000
82742	2134	96933820000
82743	1874	10522000
82744	2132	148401402000
82745	1874	10523000
82746	1687	8540176223172
82747	1687	8540189223172
82791	1706	14612288600135
82792	1706	14612311600135
82811	2112	6479105000000
82834	1397	1326698804000
82835	1678	21600733296000
82836	2133	97356720000
82837	1874	10562000
82838	2134	96925796000
82839	1874	10565000
82840	1402	63214803319298
82843	1397	1326688803000
82844	1678	21600733297000
82845	2133	97355718000
82846	1874	10567000
82847	2134	96924793000
82848	1874	10570000
82849	1394	348485111000000
82850	1394	348485123000000
82868	1397	1326658800000
82869	1678	21600733300000
82870	2134	96921784000
82871	1874	10584000
82872	2133	97352712000
82873	1874	10586000
82874	1395	58111106140007706
82875	1395	58111106152007706
82878	1394	349925123000000
82879	1394	349925135000000
82902	369	85956743000000
82928	1874	10605000
82929	1874	10608000
82930	2112	7199128000000
82982	1397	1326528787000
82983	1678	21600733313000
82984	2133	97339686000
82985	1874	10649000
82986	2134	96909748000
82987	1874	10652000
82988	1489	17904441000000
82989	1489	17904453000000
83009	1724	12907420500000
83010	1724	12907433500000
83012	1397	1326498784000
83013	1678	21600733316000
83014	2134	96906739000
83015	1874	10666000
83016	2133	97336680000
83017	1874	10668000
83018	1394	351365147000000
83061	1874	10669000
83062	1874	10672000
83063	1874	10675000
83064	1874	10676000
83065	1874	10679000
83066	1874	10682000
83067	1874	10685000
83068	1874	10688000
83069	1489	18624521000000
83130	1704	5106336000000
83140	1397	1326368771000
83141	1678	21600733329000
83142	2134	96893700000
83143	1874	10735000
83144	2133	97323654000
83145	1874	10737000
83146	599	67440024000000
83155	1717	17388168000023
83156	1717	17388180000023
83167	1756	9793159545609
83168	1756	9793171545609
83217	1982	719000000000
83218	1982	719012000000
83243	1397	1326268761000
83244	1678	21600733339000
83245	2133	97312632000
83246	1874	10792000
83247	2134	96882667000
83248	1874	10795000
83267	1643	3920564914700
83268	1643	3920590914700
83303	1397	1326238758000
83304	1678	21600733342000
83305	1397	1326228757000
83306	1678	21600733343000
83307	1397	1326218756000
83308	1678	21600733344000
83309	2133	97309626000
83310	1874	10808000
83311	2133	97308624000
83312	1874	10810000
83313	2133	97307622000
83314	1874	10812000
83315	2132	148384385000
83316	1874	10813000
83317	2134	96879658000
83318	1874	10816000
83319	2134	96878655000
83320	1874	10819000
83321	2134	96877652000
83322	1874	10822000
83323	1992	16559354990000
83324	1992	16559391990000
83328	1685	133202722571430
83329	1685	133202759571430
83347	1397	1326188753000
83348	1678	21600733347000
83349	2134	96874643000
83350	1874	10835000
83351	2132	148383384000
83352	1874	10836000
83353	2133	97304616000
83354	1874	10838000
83355	1716	20926961000000
83375	1749	9925382930000
83376	1749	10645382930000
83377	1690	135364308000000
83378	1690	136084308000000
83394	1397	1326138748000
83395	1678	21600733352000
83396	2133	97299606000
83397	1874	10861000
83398	2134	96869628000
83399	1874	10864000
83413	1397	1326118746000
83414	1678	21600733354000
83415	1397	1326108745000
83416	1678	21600733355000
83417	2133	97297602000
83418	1874	10871000
83419	2134	96867622000
83420	1874	10874000
83421	2133	97296600000
83422	1874	10876000
83423	2132	148381382000
83424	1874	10877000
83425	1489	18624477000000
83427	1397	1326098744000
83428	1678	21600733356000
83429	2134	96866619000
83430	1874	10880000
83431	2133	97295598000
83432	1874	10882000
83433	484	71468817000000
83434	484	71468829000000
83445	504	66000868193897
83446	266	66613928193897
83447	1397	1326078742000
83448	1678	21600733358000
83449	1397	1326068741000
83450	1678	21600733359000
83451	2134	96864613000
83452	1874	10891000
83453	2134	96863610000
83454	1874	10894000
83455	2133	97293594000
83456	1874	10896000
83457	2133	97292592000
83458	1874	10898000
83459	1688	56160172908000
83460	1688	56160206908000
82808	1874	10549000
82809	2112	6479094000000
82810	2112	6479106000000
82831	1688	53280188908000
82832	1688	54000188908000
82833	1688	54000189908000
82866	1474	16751365000023
82867	1474	16751390000023
82880	1397	1326648799000
82881	1678	21600733301000
82882	2134	96920781000
82883	1874	10589000
82884	2133	97351710000
82885	1874	10591000
82905	470	73950472000000
82906	470	70519462000000
82907	470	68204452000000
82908	470	66289442000000
82909	369	85237478000000
82910	369	85957478000000
82911	369	85958148000000
82912	1397	1326618796000
82913	1678	21600733304000
82914	1397	1326608795000
82915	1678	21600733305000
82916	2133	97348704000
82917	1874	10604000
82918	2133	97347702000
82919	1874	10606000
82920	2134	96917772000
82921	1874	10609000
82922	2134	96916769000
82923	1874	10612000
82924	2132	148396397000
82925	1874	10613000
82926	2112	7199105000000
82927	2112	7199130000000
82945	1455	10834081000000
82946	1455	10834105000000
82947	1397	1326578792000
82948	1678	21600733308000
82949	1397	1326568791000
82950	1678	21600733309000
82951	1397	1326558790000
82952	1678	21600733310000
82953	1397	1326548789000
82954	1678	21600733311000
82955	1397	1326538788000
82956	1678	21600733312000
82957	2133	97344696000
82958	1874	10625000
82959	2132	148395396000
82960	1874	10626000
82961	2133	97343694000
82962	1874	10628000
82963	2132	148394395000
82964	1874	10629000
82965	2163	1198999000000
82966	2134	96913760000
82967	1874	10632000
82968	2134	96912757000
82969	1874	10635000
82970	2134	96911754000
82971	1874	10638000
82972	2134	96910751000
82973	1874	10641000
82974	2133	97342692000
82975	1874	10643000
82976	2133	97341690000
82977	1874	10645000
82978	2133	97340688000
82979	1874	10647000
82980	1587	26640783000000
82981	1587	26640845000000
83101	1397	1326398774000
83102	1678	21600733326000
83103	1397	1326388773000
83104	1678	21600733327000
83105	2133	97326660000
83106	1874	10718000
83107	2133	97325658000
83108	1874	10720000
83109	1696	17777447835100
83110	1696	17777469835100
83118	353	66612718193897
83119	2213	200000000
83120	1991	21356216441475
83131	1546	17281042000000
83134	1991	21356028441475
83171	1394	352805147000000
83172	1394	352805159000000
83173	1397	1326338768000
83174	1678	21600733332000
83175	1993	1668401389290
83176	80	66000000000000
83177	2132	148388389000
83178	1874	10748000
83179	2134	96890691000
83180	1874	10751000
83181	2133	97320648000
83182	1874	10753000
83183	1394	354245159000000
83184	1394	354245182000000
83210	1444	19294281159999
83211	2214	0
83212	2133	97316640000
83213	1874	10771000
83214	2134	96886679000
83215	1874	10774000
83241	1394	357125216000000
83242	1394	357125228000000
83269	1874	10227000
83270	1874	10237000
83271	1874	10239000
83272	1874	10242000
83273	1874	10245000
83274	1874	10248000
83275	1874	10254000
83276	1874	10257000
83277	1874	10266000
83278	1874	10269000
83279	1874	10272000
83280	1874	10275000
83281	1874	10278000
83282	1874	10282000
83283	1874	10288000
83284	1874	10294000
83285	1874	10307000
83286	1874	10310000
83287	1874	10313000
83288	1874	10316000
83289	1874	10319000
83290	1874	10322000
83291	1874	10325000
83292	1874	10328000
83293	1271	1346286859000000
83294	1874	10331000
83295	1874	10334000
83296	1874	10337000
83297	1874	10340000
83298	1874	10343000
83299	1855	200000002
83300	1271	1347006858999998
83301	1271	190000110
83302	1988	1347006864999928
83326	1419	34299781280064
83327	1419	34299818280064
83356	1397	1326178752000
83357	1678	21600733348000
83358	2133	97303614000
83359	1874	10840000
83360	2134	96873640000
83361	1874	10843000
83385	1397	1326148749000
83386	1678	21600733351000
83387	2132	148382383000
83388	1874	10854000
83389	2133	97300608000
83390	1874	10856000
83391	2134	96870631000
83392	1874	10859000
83393	1564	13506558000000
83401	1394	358565253000000
83402	1394	358565265000000
83481	1688	56880206908000
83482	1688	56880268908000
83494	1397	1326038738000
83495	1678	21600733362000
83496	1397	1326028737000
83497	1678	21600733363000
83498	1749	8645381930000
83499	1950	13889851000000
83500	2134	96860601000
83501	1874	10912000
83502	2134	96859598000
83503	1874	10915000
83504	1726	79364112000
83505	2215	200000000
83506	1726	78163112000
83507	2216	200000000
83508	1726	76962112000
83509	2217	200000000
83510	2133	97289586000
83511	1874	10917000
83512	2133	97288584000
83161	2133	97321650000
83162	1874	10744000
83163	2134	96891694000
83164	1874	10747000
83165	1688	55440160908000
83166	1688	55440172908000
83185	2213	190000000
83186	1397	1326328767000
83187	1678	21600733333000
83188	1397	1326318766000
83189	1678	21600733334000
83190	2134	96889688000
83191	1874	10756000
83192	2134	96888685000
83193	1874	10759000
83194	2133	97319646000
83195	1874	10761000
83196	2133	97318644000
83197	1874	10763000
83198	1394	355685182000000
83199	1394	355685216000000
83216	1458	19533761908540
83219	1397	1326298764000
83220	1678	21600733336000
83221	1397	1326288763000
83222	1678	21600733337000
83223	2133	97315638000
83224	1874	10776000
83225	2134	96885676000
83226	1874	10779000
83227	2134	96884673000
83228	1874	10782000
83229	2132	148386387000
83230	1874	10783000
83231	2133	97314636000
83232	1874	10785000
83233	1681	14183289759830
83249	1397	1326258760000
83250	1678	21600733340000
83251	1397	1326248759000
83252	1678	21600733341000
83253	2132	148385386000
83254	1874	10796000
83255	1592	33000000
83256	592	67440000000000
83257	2134	96881664000
83258	1874	10799000
83259	2134	96880661000
83260	1874	10802000
83261	2133	97311630000
83262	1874	10804000
83263	2133	97310628000
83264	1874	10806000
83265	1673	26245520000000
83266	1673	26245546000000
83330	1394	357125253000000
83339	1397	1326198754000
83340	1678	21600733346000
83341	2134	96875646000
83342	1874	10830000
83343	2133	97305618000
83344	1874	10832000
83345	1458	20253761908540
83346	1458	20253773908540
83362	1397	1326168751000
83363	1678	21600733349000
83364	1874	10826000
83365	1874	10833000
83366	1874	10839000
83367	2134	96872637000
83368	1874	10842000
83369	1874	10844000
83370	1874	10846000
83371	2133	97302612000
83372	1874	10848000
83373	1749	10645370930000
83374	1749	10645431930000
83403	1747	8656932000000
83404	504	66301878193897
83405	266	66312928193897
83406	1397	1326128747000
83407	1678	21600733353000
83408	2133	97298604000
83409	1874	10866000
83410	2134	96868625000
83411	1874	10869000
83412	1571	22320521001024
83435	1397	1326088743000
83436	1678	21600733357000
83437	2133	97294596000
83438	1874	10884000
83439	2132	148380381000
83440	1874	10885000
83441	2134	96865616000
83442	1874	10888000
83443	1673	26965546000000
83444	1673	26965559000000
83483	1394	360005265000000
83484	1394	360005327000000
83524	1397	1326018736000
83525	1678	21600733364000
83526	1397	1326008735000
83527	1678	21600733365000
83528	2134	96858595000
83529	1874	10922000
83530	2132	148378379000
83531	1874	10923000
83532	2133	97287582000
83533	1874	10925000
83534	2134	96857592000
83535	1874	10928000
83536	2133	97286580000
83537	1874	10930000
83538	1395	58112546202007706
83540	1643	3920589914700
83551	1444	20014281159999
83552	1444	20014293159999
83568	1397	1325968731000
83569	1678	21600733369000
83570	2134	96853580000
83571	1874	10949000
83572	2133	97282572000
83573	1874	10951000
83574	1397	1325958730000
83575	1678	21600733370000
83576	2133	97281570000
83577	1874	10953000
83578	2134	96852577000
83579	1874	10956000
83580	1571	18252395001031
83581	1571	18252407001031
83600	2100	1437880000000
83645	1397	1325888723000
83646	1678	21600733377000
83647	1397	1325878722000
83648	1678	21600733378000
83649	2132	148374375000
83650	1874	10989000
83651	2134	96845556000
83652	1874	10992000
83653	2133	97274556000
83654	1874	10994000
83655	2133	97273554000
83656	1874	10996000
83657	2134	96844553000
83658	1874	10999000
83659	1681	15623395759830
83660	1681	15623420759830
83208	1588	20375082000000
83209	1588	20375095000000
83234	1397	1326278762000
83235	1678	21600733338000
83236	2133	97313634000
83237	1874	10787000
83238	2134	96883670000
83239	1874	10790000
83240	1536	15120763999959
83325	1439	12532496998477
83331	1397	1326208755000
83332	1678	21600733345000
83333	2133	97306620000
83334	1874	10824000
83335	2134	96876649000
83336	1874	10827000
83337	1679	20159130653000
83338	1679	20159142653000
83379	1397	1326158750000
83380	1678	21600733350000
83381	2134	96871634000
83382	1874	10851000
83383	2133	97301610000
83384	1874	10853000
83400	1704	5106325000000
83426	633	83884146900000
83461	1623	60482943899898
83462	1623	60482977899898
83485	1397	1326048739000
83486	1678	21600733361000
83487	2133	97290588000
83488	1874	10905000
83489	2134	96861604000
83490	1874	10908000
83491	2132	148379380000
83492	1874	10909000
83493	1394	360005278000000
83541	1397	1325998734000
83542	1678	21600733366000
83543	2133	97285578000
83544	1874	10932000
83545	2134	96856589000
83546	1874	10935000
83547	1467	12926784100039
83548	1467	12926796100039
83641	1681	14903289759830
83642	1681	14903395759830
83676	1571	16128454012870
83677	38	66191662385104
83678	1571	15581360560182
83679	969	504236664207168
83680	1571	14600981700374
83681	1089	903587781959488
83682	1397	1325858720000
83683	1678	21600733380000
83684	1571	13939497295432
83685	1209	609668681746512
83686	1571	12096230051040
83687	1335	1698895990403362
83688	2132	148373374000
83689	1874	11010000
83690	1726	70957112000
83691	2220	200000000
83692	1726	69756112000
83693	2221	200000000
83694	2134	96841544000
83695	1874	11013000
83696	2133	97270548000
83697	1874	11015000
83698	606	79677972812962
83699	606	79678037812962
83463	1397	1326058740000
83464	1678	21600733360000
83465	1571	22236649623166
83466	38	66083861377858
83467	1571	21598375595030
83468	969	503416039028136
83469	1571	20454601925254
83470	1089	902117228669776
83471	1571	19682871786155
83472	1209	608676470139099
83473	1571	17532395001031
83474	1335	1696131104536774
83475	2133	97291590000
83476	1874	10900000
83477	2134	96862607000
83478	1874	10903000
83479	1599	19060363393047
83480	1599	19060425393047
83539	1555	10995316979096
83582	1397	1325948729000
83583	1678	21600733371000
83584	2132	148376377000
83585	1874	10957000
83586	2133	97280568000
83587	1874	10959000
83588	2134	96851574000
83589	1874	10962000
83590	1696	18497471835100
83591	1696	18497484835100
83601	1571	18216450031949
83602	38	66119808346940
83603	1397	1325928727000
83604	1678	21600733373000
83605	1397	1325918726000
83606	1678	21600733374000
83607	1571	17942898305605
83608	969	503689580754480
83609	1571	17452703875701
83610	1089	902607413099680
83611	1571	17121956673230
83612	1209	609007207341570
83613	1571	16200318051034
83614	1335	1697052733158970
83615	1397	1325908725000
83616	1678	21600733375000
83617	1397	1325898724000
83618	1678	21600733376000
83619	532	66010043000000
83620	1724	16497457500000
83621	2133	97278564000
83622	1874	10969000
83623	2134	96849568000
83624	1874	10972000
83625	2133	97277562000
83626	1874	10974000
83627	2134	96848565000
83628	1874	10977000
83629	2134	96847562000
83630	1874	10980000
83631	2134	96846559000
83632	1874	10983000
83633	2133	97276560000
83634	1874	10985000
83635	2132	148375376000
83636	1874	10986000
83637	1769	1585900000
83638	2133	97275558000
83639	1874	10988000
83640	1634	20352458641004
83643	1690	136084296000000
83644	1690	136084402000000
83661	1690	136084321000000
83668	1397	1325868721000
83669	1678	21600733379000
83670	2134	96842547000
83671	1874	11007000
83672	2133	97271550000
83673	1874	11009000
83674	1637	223205182819988
83675	1637	223205194819988
83513	1874	10919000
83514	1726	75761112000
83515	2205	1399000000
83516	1726	74560112000
83517	1930	2600000000
83518	1726	73359112000
83519	2218	200000000
83520	1726	72158112000
83521	2219	200000000
83522	1637	222485150819988
83523	1637	222485182819988
83549	1588	21095095000000
83550	1588	21095107000000
83553	1397	1325988733000
83554	1678	21600733367000
83555	1397	1325978732000
83556	1678	21600733368000
83557	2132	148377378000
83558	1874	10936000
83559	2133	97284576000
83560	1874	10938000
83561	2133	97283574000
83562	1874	10940000
83563	2134	96855586000
83564	1874	10943000
83565	2134	96854583000
83566	1874	10946000
83567	1670	21601259000000
83592	1397	1325938728000
83593	1678	21600733372000
83594	2134	96850571000
83595	1874	10965000
83596	2133	97279566000
83597	1874	10967000
83598	1395	58113266202007706
83599	1395	58113266214007706
83662	2134	96843550000
83663	1874	11002000
83664	2133	97272552000
83665	1874	11004000
83666	1394	361445278000000
83667	1394	361445280000000
83700	1397	1325848719000
83701	1678	21600733381000
83702	2134	96840541000
83703	1874	11018000
83704	2133	97269546000
83705	1874	11020000
83706	1746	9154383000000
83707	1746	9154395000000
83708	1555	10995303979096
83709	1397	1325838718000
83710	1678	21600733382000
83711	1397	1325828717000
83712	1678	21600733383000
83713	2132	148372373000
83714	1874	11021000
83715	2133	97268544000
83716	1874	11023000
83717	2133	97267542000
83718	1874	11025000
83719	2134	96839538000
83720	1874	11028000
83721	2134	96838535000
83722	1874	11031000
83723	1394	362885280000000
83724	1394	362885305000000
83725	1397	1325818716000
83726	1678	21600733384000
83727	1571	12084241211346
83728	38	66203641224798
83729	1571	11993050635898
83730	969	504327844782616
83731	1571	11829645825930
83732	1089	903751176769456
83733	1571	11719390091773
83734	1209	609778927480669
83735	1571	11412170551041
83736	1335	1699203199944094
83737	2134	96837532000
83738	1874	11034000
83739	2133	97266540000
83740	1874	11036000
83741	1696	19217484835100
83742	1696	19217546835100
83743	1455	11554105000000
83744	1455	11554167000000
83745	1397	1325808715000
83746	1678	21600733385000
83747	2134	96836529000
83748	1874	11039000
83749	2133	97265538000
83750	1874	11041000
83751	1422	12385126860211
83752	1422	12385138860211
83753	1397	1325798714000
83754	1678	21600733386000
83755	2134	96835526000
83756	1874	11044000
83757	2133	97264536000
83758	1874	11046000
83759	2132	148371372000
83760	1874	11047000
83761	641	81460207000000
83762	1571	21516627623166
83763	1571	20878353595030
83764	1571	19734579925254
83765	1571	18962849786155
83766	1571	16812373001031
83767	1571	16776416031949
83768	1571	16502864305605
83769	1571	16012669875701
83770	1571	15681922673230
83771	1571	14760284051034
83772	1571	14688420012870
83773	1571	14141326560182
83774	1571	13160947700374
83775	1571	12499463295432
83776	1571	10656196051040
83777	1571	10644207211346
83778	1571	10553016635898
83779	1571	10389611825930
83780	1571	10279356091773
83781	1571	9972136551041
83782	1724	15777420500000
83783	1749	7925369930000
83784	641	81460713000000
83785	1397	1325788713000
83786	1678	21600733387000
83787	1397	1325778712000
83788	1678	21600733388000
83789	1397	1325768711000
83790	1678	21600733389000
83791	1613	16489052600000
83792	1874	10585000
83793	1874	10587000
83794	1874	10590000
83795	1874	10593000
83796	1613	17209052600000
83797	1613	17209167600000
83798	2133	97263534000
83799	1874	11049000
83800	2133	97262532000
83801	1874	11051000
83802	2133	97261530000
83803	1874	11053000
83804	2134	96834523000
83805	1874	11056000
83806	2134	96833520000
83807	1874	11059000
83808	2134	96832517000
83809	1874	11062000
83810	1613	17208038600000
83811	1571	11352180852571
83812	38	66263620923268
83813	1571	10896267975331
83814	969	504783747659856
83815	1397	1325758710000
83816	1678	21600733390000
83817	1571	10079283925491
83818	1089	904568150819296
83819	1571	9528045254706
83820	1209	610330156151454
83821	1571	7991987551046
83822	1335	1700739247647754
83823	2133	97260528000
83824	1874	11064000
83825	2134	96831514000
83826	1874	11067000
83827	2132	148370371000
83828	1874	11068000
83829	1637	223925194819988
83830	1637	223925257819988
83831	1394	364325305000000
83832	1394	364325368000000
83833	2216	100000000
83834	1397	1325748709000
83835	1678	21600733391000
83836	1397	1325738708000
83837	1678	21600733392000
83838	1397	1325728707000
83839	1678	21600733393000
83840	2134	96830511000
83841	1874	11071000
83842	2133	97259526000
83843	1874	11073000
83844	2133	97258524000
83845	1874	11075000
83846	2133	97257522000
83847	1874	11077000
83848	2132	148369370000
83849	1874	11078000
83850	2134	96829508000
83851	1874	11081000
83852	2134	96828505000
83853	1874	11084000
83854	1395	58113986214007706
83855	1395	58113986351007706
83883	1573	13659197000000
83884	1573	14379197000000
83885	1573	14379230000000
83897	1394	365765442000000
83898	1394	365765455000000
83929	1397	1325658700000
83930	1678	21600733400000
83931	2132	148367368000
83932	1874	11113000
83933	2133	97250508000
83934	1874	11115000
83935	2134	96822487000
83936	1874	11118000
83937	1991	21356018441475
83940	1397	1325648699000
83941	1678	21600733401000
83942	2134	96821484000
83943	1874	11121000
83944	2133	97249506000
83945	1874	11123000
83946	1769	1583900000
83947	1599	19060376393047
83979	1397	1325608695000
83980	1678	21600733405000
83981	2134	96817472000
83982	1874	11142000
83983	2133	97245498000
83984	1874	11144000
83985	1394	365765454000000
84033	1749	9365381930000
84034	1749	9365393930000
84036	1397	1325568691000
84037	1678	21600733409000
84038	1397	1325558690000
84039	1678	21600733410000
84040	1397	1325548689000
84041	1678	21600733411000
84042	2133	97241490000
84043	1874	11159000
84044	2133	97240488000
84045	1874	11161000
84046	2133	97239486000
84047	1874	11163000
84048	1874	11166000
84049	2134	96813460000
84050	1874	11169000
84051	2134	96812457000
84052	1874	11172000
84053	2134	96811454000
84054	1874	11175000
84055	2132	148364365000
84056	1874	11176000
84057	1688	57600268908000
84058	1688	57600316908000
84059	1397	1325538688000
84060	1678	21600733412000
84061	1397	1325528687000
84062	1678	21600733413000
84063	1397	1325518686000
84064	1678	21600733414000
84065	1601	11989435620000
84066	1388	1711802704351650
84067	1601	8829425620000
84068	1142	910452755600000
84069	1601	6697415620000
84070	1262	614299826200000
84071	1601	4933405620000
84072	1022	508069064000000
84073	2132	148363364000
84074	1874	11177000
84075	1726	68555112000
84076	2222	200000000
84077	2134	96810451000
84078	1874	11180000
84079	2134	96809448000
84080	1874	11183000
84081	2134	96808445000
84082	1874	11186000
84083	2133	97238484000
84084	1874	11188000
84085	2133	97237482000
84086	1874	11190000
84087	2133	97236480000
84088	1874	11192000
84089	1444	20014359159999
84096	606	80398037812962
84097	606	80398115812962
84128	1397	1325468681000
84129	1678	21600733419000
84130	2133	97232472000
84131	1874	11213000
84132	2134	96803430000
84133	1874	11216000
84134	2221	24482190798002
84135	2097	1600500000
84136	1758	200002020
84153	1397	1325438678000
84154	1678	21600733422000
84155	2133	97229466000
84156	1874	11229000
84157	2134	96800421000
84158	1874	11232000
84196	1447	15995610943000
84197	641	82899967500000
84198	641	82900008500000
84200	1397	1325398674000
84201	1678	21600733426000
84202	2133	97225458000
84203	1874	11250000
84204	1706	14612299600135
84205	1397	1325388673000
84206	1678	21600733427000
84207	2132	148359360000
84208	1874	11251000
84209	2134	96796409000
84210	1874	11254000
84211	2133	97224456000
84212	1874	11256000
84213	1850	20079191000000
84267	1688	59040329908000
84268	1688	59040352908000
84279	2224	719053000000
84280	1397	1325318666000
84281	1678	21600733434000
84282	2133	97216440000
84283	1874	11295000
84284	2134	96788385000
84285	1874	11298000
84286	1402	63934825319298
84334	1874	11317000
84345	1694	23053903127629
84346	1678	20880721292000
84347	1678	20880721293000
84348	1678	20880721294000
84349	1678	20880721295000
84350	1678	20880721296000
84351	1678	20880721297000
84352	1678	20880721298000
84353	1678	20880721299000
84354	1678	20880721300000
84355	1678	20880721301000
84356	1678	20880721302000
84357	1678	20880721303000
84358	1678	20880721304000
84359	1678	20880721305000
84360	1678	20880721306000
84361	1678	20880721307000
84362	1678	20880721308000
84363	1678	20880721309000
84364	1678	20880721310000
84365	1678	20880721311000
84366	1678	20880721312000
84367	1678	20880721313000
84368	1694	23773903127629
84369	1694	23774173127629
84376	1694	23772733127629
84377	1694	23772745127629
84394	1397	1325228657000
84395	1678	21600733443000
84396	1397	1325218656000
84397	1678	21600733444000
84398	2134	96779358000
84399	1874	11344000
84400	2134	96778355000
84401	1874	11347000
84402	2133	97207422000
84403	1874	11349000
84404	2133	97206420000
84405	1874	11351000
84406	1395	58114706228007706
84407	1395	58114706252007706
84428	1397	1325188653000
83856	1719	20180967000000
83858	1692	34340403619999
83859	1692	34340540619999
83948	1397	1325638698000
83949	1678	21600733402000
83950	1397	1325628697000
83951	1678	21600733403000
83952	1769	1582900000
83953	2132	148366367000
83954	1874	11124000
83955	1769	1581900000
83956	2133	97248504000
83957	1874	11126000
83958	1769	1580900000
83959	2134	96820481000
83960	1874	11129000
83961	2134	96819478000
83962	1874	11132000
83963	2133	97247502000
83964	1874	11134000
83965	1588	21095123000000
83986	1397	1325598694000
83987	1678	21600733406000
83988	2132	148365366000
83989	1874	11145000
83990	2133	97244496000
83991	1874	11147000
83992	2134	96816469000
83993	1874	11150000
83994	632	76221269000000
84035	1749	9365382930000
84090	1444	19294432159999
84091	1758	1600500000
84092	1444	20014432059999
84115	1698	18537144550035
84137	1672	24482201000000
84138	1397	1325458680000
84139	1678	21600733420000
84140	1397	1325448679000
84141	1678	21600733421000
84142	2134	96802427000
84143	1874	11219000
84144	2134	96801424000
84145	1874	11222000
84146	2133	97231470000
84147	1874	11224000
84148	2133	97230468000
84149	1874	11226000
84150	2132	148361362000
84151	1874	11227000
84152	1992	16559379990000
84172	1397	1325418676000
84173	1678	21600733424000
84174	2134	96798415000
84175	1874	11241000
84176	2133	97227462000
84177	1874	11243000
84178	1679	21599154653000
84179	1679	21599166653000
84182	1397	1325408675000
84183	1678	21600733425000
84184	2133	97226460000
84185	1874	11245000
84186	2134	96797412000
84187	1874	11248000
84188	58	88986636999641
84193	641	82180219000000
84199	641	82180218000000
84214	1688	58320316908000
84215	1688	58320329908000
84218	1397	1325378672000
84219	1678	21600733428000
84220	2133	97223454000
84221	1874	11258000
84222	2134	96795406000
84223	1874	11261000
84224	1650	12274208000000
84225	1650	12274220000000
84226	1397	1325368671000
84227	1678	21600733429000
84228	1397	1325358670000
84229	1678	21600733430000
84230	1397	1325348669000
84231	1678	21600733431000
84232	1397	1325338668000
84233	1678	21600733432000
84234	1726	67354112000
84235	2223	200000000
84236	2134	96794403000
84237	1874	11264000
84238	2134	96793400000
84239	1874	11267000
84240	2134	96792397000
84241	1874	11270000
84242	2133	97222452000
84243	1874	11272000
84244	2133	97221450000
84245	1874	11274000
84246	2133	97220448000
84247	1874	11276000
84248	2133	97219446000
84249	1874	11278000
84250	2134	96791394000
84251	1874	11281000
84252	2132	148358359000
84253	1874	11282000
84254	1601	5653405620000
84255	1601	5653455620000
84269	1686	18212180550062
84270	1686	18212203550062
84287	1397	1325308665000
84288	1678	21600733435000
84289	2134	96787382000
84290	1874	11301000
84291	1504	657246000000
84292	1697	1501990000000
84293	2133	97215438000
84294	1874	11303000
84295	733	3440012000000
84296	733	3440025000000
84301	43	83280970890000
84302	43	83280983890000
84303	1397	1325298664000
84304	1678	21600733436000
84305	2133	97214436000
84306	1874	11305000
84307	2134	96786379000
84308	1874	11308000
84309	2132	148356357000
84310	1874	11309000
84311	641	82180220000000
84315	1397	1325288663000
84316	1678	21600733437000
84317	1504	157245000000
84318	1697	2001990000000
84319	2133	97213434000
84320	1874	11311000
84321	2134	96785376000
84322	1874	11314000
84323	1724	17937484500000
84378	1397	1325248659000
84379	1678	21600733441000
84380	1397	1325238658000
84381	1678	21600733442000
84382	2133	97209426000
84383	1874	11332000
84384	2132	148354355000
84385	1874	11333000
84386	2134	96781364000
84387	1874	11336000
84388	2134	96780361000
84389	1874	11339000
84390	2133	97208424000
84391	1874	11341000
84392	1394	370085478000000
84393	1394	370085503000000
84408	1397	1325208655000
84409	1678	21600733445000
84410	2133	97205418000
84411	1874	11353000
84412	2134	96777352000
84413	1874	11356000
84414	1688	59040341908000
84416	1397	1325198654000
84417	1678	21600733446000
84418	2133	97204416000
84419	1874	11358000
84420	2134	96776349000
84421	1874	11361000
84422	2132	148353354000
84423	1874	11362000
84424	1395	58115426252007706
84425	1395	58115426265007706
84436	2150	200100000
84437	1762	23362257894000
84438	289	23362267894000
84439	1762	66000200000000
84440	1397	1325178652000
84441	1678	21600733448000
84442	1397	1325168651000
84443	1678	21600733449000
84444	2134	96774343000
84445	1874	11370000
84446	2132	148352353000
84447	1874	11371000
83857	1394	364325442000000
83860	1397	1325718706000
83861	1678	21600733394000
83862	1397	1325708705000
83863	1678	21600733395000
83864	1571	7944048892270
83865	38	66311549582044
83866	1571	7579316590478
83867	969	505148469961648
83868	417	66000040000000
83869	1571	6925727350606
83870	1089	905221730059168
83871	1571	6484734413978
83872	1209	610771139088082
83873	1571	5255886251050
83874	1335	1701968085810682
83875	2133	97256520000
83876	1874	11086000
83877	2133	97255518000
83878	1874	11088000
83879	2134	96827502000
83880	1874	11091000
83881	417	66720040000000
83882	417	66720073000000
83896	42	77949395000000
83899	1571	5231835921662
83900	38	66335589911432
83901	1571	5049464770766
83902	969	505330831112544
83903	1571	4722665150830
83904	1089	905548519679104
83905	1571	4502163682516
83906	1209	610991630556396
83907	1571	3887734601052
83908	1335	1702582504892146
83909	1397	1325688703000
83910	1678	21600733397000
83911	1397	1325678702000
83912	1678	21600733398000
83913	1397	1325668701000
83914	1678	21600733399000
83915	2134	96825496000
83916	1874	11100000
83917	2134	96824493000
83918	1874	11103000
83919	2133	97253514000
83920	1874	11105000
83921	2133	97252512000
83922	1874	11107000
83923	2133	97251510000
83924	1874	11109000
83925	2134	96823490000
83926	1874	11112000
83927	1769	1584900000
83928	1692	34340490619999
83968	484	72188829000000
83969	484	72188857000000
83972	1394	365765470000000
83997	641	82180207000000
83998	1571	9912146852571
83999	1571	9456233975331
84000	1571	8639249925491
84001	1571	8088011254706
84002	1571	6551953551046
84003	1571	6504014892270
84004	1571	6139282590478
84005	1571	5485693350606
84006	641	81460893000000
84007	1571	5044700413978
84008	1571	3815852251050
84009	1571	3791801921662
84010	1571	3609430770766
84011	1571	3282631150830
84012	1571	3062129682516
84013	1571	2447700601052
84014	641	82180893000000
84015	167	82180967500000
84016	641	66000001100200
84025	1397	1325578692000
84026	1678	21600733408000
84027	2133	97242492000
84028	1874	11157000
84029	2134	96814463000
84030	1874	11160000
84031	1394	367205454000000
84032	1394	367205466000000
84094	1700	21186117276737
84095	1700	21186195276737
84106	1397	1325498684000
84107	1678	21600733416000
84108	2132	148362363000
84109	1874	11198000
84110	2134	96806439000
84111	1874	11201000
84112	2133	97234476000
84113	1874	11203000
84114	1395	58113986227007706
84170	1402	63934803319298
84171	1402	63934817319298
84191	1522	17614262000000
84192	1522	17614274000000
84256	1397	1325328667000
84257	1678	21600733433000
84258	417	66000000000000
84259	2224	719063000000
84260	2134	96790391000
84261	1874	11285000
84262	2133	97218444000
84263	1874	11287000
84264	2132	148357358000
84265	1874	11288000
84266	1455	11554128000000
84271	1637	224645280819988
84277	1724	17937471500000
84278	1724	17937473500000
84299	1637	225365280819988
84300	1637	225365293819988
84312	641	83620008500000
84313	641	66000006930000
84314	646	83620008510000
84325	1688	59040342908000
84326	1397	1325278662000
84327	1678	21600733438000
84328	2133	97212432000
84329	1874	11313000
84330	1874	11316000
84331	2134	96784373000
84332	1874	11319000
84333	1395	58113986228007706
84456	1874	11374000
84457	1762	22642115994000
84482	1685	133202735571430
84492	1397	1325118646000
84493	1678	21600733454000
84494	2134	96768325000
84495	1874	11402000
84496	2133	97196400000
84497	1874	11404000
84498	1689	15840523287625
84499	1689	15840535287625
84524	1397	1325088643000
84525	1678	21600733457000
84526	2133	97193394000
84527	1874	11417000
84528	2134	96765316000
84529	1874	11420000
84530	1599	19780376393047
84531	1599	19780388393047
84562	1397	1325048639000
84563	1678	21600733461000
84564	1397	1325038638000
84565	1678	21600733462000
84566	1397	1325028637000
84567	1678	21600733463000
84568	1397	1325018636000
84569	1678	21600733464000
84570	1397	1325008635000
84571	1678	21600733465000
84572	2132	148348349000
84573	1874	11437000
84574	2211	920000000
84575	2225	717100000000
84576	2134	96761304000
84577	1874	11440000
84578	1726	66153112000
84579	2227	200000000
84580	2133	97189386000
84581	1874	11442000
84582	2134	96760301000
84583	1874	11445000
84584	2134	96759298000
84585	1874	11448000
84586	2134	96758295000
84587	1874	11451000
84588	2134	96757292000
84589	1874	11454000
84590	2133	97188384000
84591	1874	11456000
84592	2133	97187382000
84593	1874	11458000
84594	2133	97186380000
84595	1874	11460000
84596	2133	97185378000
84597	1874	11462000
84598	1476	20160424000000
83886	1397	1325698704000
83887	1678	21600733396000
83888	2132	148368369000
83889	1874	11092000
83890	2134	96826499000
83891	1874	11095000
83892	2133	97254516000
83893	1874	11097000
83894	1422	13105138860211
83895	1422	13105151860211
83938	1874	11116000
83939	1991	21356017441475
83966	1451	15739034000000
83967	1451	15739062000000
83970	1637	224645257819988
83971	1637	224645285819988
83973	1397	1325618696000
83974	1678	21600733404000
83975	2134	96818475000
83976	1874	11137000
83977	2133	97246500000
83978	1874	11139000
83995	1991	22076018441475
83996	1991	22076031441475
84017	1397	1325588693000
84018	1678	21600733407000
84019	2134	96815466000
84020	1874	11153000
84021	2133	97243494000
84022	1874	11155000
84023	1679	20879142653000
84024	1679	20879154653000
84093	58	88986702999641
84098	1397	1325508685000
84099	1678	21600733415000
84100	2133	97235478000
84101	1874	11194000
84102	2134	96807442000
84103	1874	11197000
84104	1673	27685559000000
84105	1673	27685571000000
84116	1397	1325488683000
84117	1678	21600733417000
84118	1397	1325478682000
84119	1678	21600733418000
84120	2133	97233474000
84121	1874	11205000
84122	2134	96805436000
84123	1874	11208000
84124	2134	96804433000
84125	1874	11211000
84126	1684	23760640880623
84127	1684	23760663880623
84159	1397	1325428677000
84160	1678	21600733423000
84161	2132	148360361000
84162	1874	11233000
84163	2134	96799418000
84164	1874	11236000
84165	2222	199000000
84166	2133	97228464000
84167	1874	11238000
84168	1724	17217457500000
84169	1724	17217471500000
84180	1394	368645466000000
84181	1394	368645478000000
84189	1489	19344477000000
84190	1489	19344489000000
84194	1611	15183031000000
84195	1611	15183043000000
84216	1476	20160361000000
84217	1476	20160374000000
84272	2133	97217442000
84273	1874	11290000
84274	2134	96789388000
84275	1874	11293000
84276	1717	17388170000023
84297	632	76941269000000
84298	632	76941282000000
84324	1724	17937482500000
84335	1397	1325268661000
84336	1678	21600733439000
84337	2133	97211430000
84338	1874	11321000
84339	2132	148355356000
84340	1874	11322000
84341	2134	96783370000
84342	1874	11325000
84343	1457	22224446040000
84344	1457	22224459040000
84370	1397	1325258660000
84371	1678	21600733440000
84372	2134	96782367000
84373	1874	11328000
84374	2133	97210428000
84375	1874	11330000
84415	576	83795932938283
84426	1684	24480663880623
84427	1684	24480676880623
84455	1656	20301728999990
84472	1397	1325138648000
84473	1678	21600733452000
84474	2134	96770331000
84475	1874	11391000
84476	2133	97198404000
84477	1874	11393000
84478	2132	148351352000
84479	1874	11394000
84480	1402	64654825319298
84481	1402	64654838319298
84502	391	66612338193897
84503	2226	500000000
84504	266	66000918193897
84505	1958	4098987000000
84506	1397	1325108645000
84507	1678	21600733455000
84508	1397	1325098644000
84509	1678	21600733456000
84510	2132	148350351000
84511	1874	11405000
84512	2211	717022000000
84513	2225	1000000000
84514	2134	96767322000
84515	1874	11408000
84516	2134	96766319000
84517	1874	11411000
84518	2133	97195398000
84519	1874	11413000
84520	2133	97194396000
84521	1874	11415000
84522	1394	372965515000000
84523	1394	372965651000000
84534	1397	1325078642000
84535	1678	21600733458000
84536	1397	1325068641000
84537	1678	21600733459000
84538	2134	96764313000
84539	1874	11423000
84540	2132	148349350000
84541	1874	11424000
84542	2133	97192392000
84543	1874	11426000
84544	2133	97191390000
84545	1874	11428000
84546	2211	1021000000
84547	2225	717000000000
84548	2134	96763310000
84549	1874	11431000
84550	1522	17614288000000
84620	1397	1324978632000
84621	1678	21600733468000
84622	2134	96754283000
84623	1874	11476000
84624	2133	97182372000
84625	1874	11478000
84647	1727	16747237000000
84650	1397	1324948629000
84651	1678	21600733471000
84652	1874	11487000
84653	2134	96751274000
84654	1874	11492000
84655	2133	97179366000
84656	1874	11494000
84657	1422	13825151860211
84658	1422	13825165860211
84661	1394	375845677000000
84686	1397	1324908625000
84687	1678	21600733475000
84688	2133	97175358000
84689	1874	11512000
84690	2134	96747262000
84691	1874	11515000
84692	1701	13030421600056
84695	1397	1324898624000
84696	1678	21600733476000
84697	2133	97174356000
84698	1874	11517000
84699	2132	148344345000
84700	1874	11518000
84701	2134	96746259000
84702	1874	11521000
84703	1610	18000610019950
84704	1610	18000623019950
84705	1397	1324888623000
84706	1678	21600733477000
84429	1678	21600733447000
84430	2134	96775346000
84431	1874	11365000
84432	2133	97203414000
84433	1874	11367000
84434	1394	371525503000000
84435	1394	371525515000000
84458	1637	225365305819988
84459	1397	1325158650000
84460	1678	21600733450000
84461	1397	1325148649000
84462	1678	21600733451000
84463	2133	97200408000
84464	1874	11380000
84465	2133	97199406000
84466	1874	11382000
84467	2134	96772337000
84468	1874	11385000
84469	2134	96771334000
84470	1874	11388000
84471	58	88986648999641
84500	1395	58116146265007706
84501	1395	58116146277007706
84532	1394	374405651000000
84533	1394	374405663000000
84551	1555	10995317979096
84552	1397	1325058640000
84553	1678	21600733460000
84554	2134	96762307000
84555	1874	11434000
84556	2133	97190388000
84557	1874	11436000
84558	1395	58116866277007706
84559	1395	58116866289007706
84599	1419	34299844280064
84610	1397	1324988633000
84611	1678	21600733467000
84612	2225	717098000000
84613	1645	0
84614	2134	96755286000
84615	1874	11471000
84616	2133	97183374000
84617	1874	11473000
84618	1395	58117586289007706
84619	1395	58117586303007706
84639	2133	97181370000
84640	1874	11481000
84641	2133	97180368000
84642	1874	11483000
84643	1874	11486000
84644	1874	11489000
84645	1672	25202189000000
84646	1672	25202214000000
84648	1394	375845663000000
84649	1394	375845688000000
84727	1397	1324858620000
84728	1678	21600733480000
84729	2133	97170348000
84730	1874	11539000
84731	2134	96742247000
84732	1874	11542000
84733	1402	64654837319298
84756	1397	1324828617000
84757	1678	21600733483000
84758	2134	96740241000
84759	1874	11553000
84760	2133	97167342000
84761	1874	11555000
84792	1397	1324778612000
84793	1678	21600733488000
84794	1522	18334288000000
84795	1522	18334298000000
84818	1397	1324748609000
84819	1678	21600733491000
84820	1444	20012358159999
84821	2214	2000000000
84822	2133	97159326000
84823	1874	11594000
84824	1726	63751112000
84825	2228	200000000
84826	1726	62550112000
84827	2229	200000000
84828	1726	61349112000
84829	2229	1400000000
84830	2134	96732217000
84831	1874	11597000
84832	1489	19344493000000
84848	1394	378725717000000
84886	337	68160040000000
84887	337	68160043000000
84907	1447	15993600943000
84908	2230	0
84909	1397	1324678602000
84910	1678	21600733498000
84911	2132	148337338000
84912	1874	11632000
84913	2134	96725196000
84914	1874	11635000
84915	1684	24480685880623
84923	1457	22944459040000
84924	1457	22944472040000
84925	1397	1324668601000
84926	1678	21600733499000
84927	2134	96724193000
84928	1874	11640000
84929	2133	97150308000
84930	1874	11642000
84931	1686	18212192550062
84932	1397	1324658600000
84933	1678	21600733500000
84934	1397	1324648599000
84935	1678	21600733501000
84936	1397	1324638598000
84937	1678	21600733502000
84938	2133	97149306000
84939	1874	11644000
84940	2134	96723190000
84941	1874	11647000
84942	2134	96722187000
84943	1874	11650000
84944	2134	96721184000
84945	1874	11653000
84946	2133	97148304000
84947	1874	11655000
84948	2133	97147302000
84949	1874	11657000
84950	2132	148336337000
84951	1874	11658000
84952	1637	225365317819988
84980	1746	9874395000000
84981	1746	9874408000000
84986	1397	1324598594000
84987	1678	21600733506000
84988	1397	1324588593000
84989	1678	21600733507000
84990	2133	97143294000
84991	1874	11676000
84992	2133	97142292000
84993	1874	11678000
84994	2134	96717172000
84995	1874	11681000
84996	2134	96716169000
84997	1874	11684000
84998	1509	19392091851155
84999	1509	19392115851155
85015	1610	18720623019950
85016	1610	18720636019950
85019	641	82900220000000
85020	641	82900233000000
85028	1397	1324558590000
85029	1678	21600733510000
85030	2133	97139286000
85031	1874	11697000
85032	2134	96713160000
85033	1874	11700000
85034	1688	60480377908000
85056	1394	380165727000000
85065	1397	1324518586000
85066	1678	21600733514000
85067	2134	96709148000
85068	1874	11719000
85069	1622	21420439000005
85070	1622	21420450000005
85109	1397	1324468581000
85110	1678	21600733519000
85111	1634	19632362641004
85112	2133	97130268000
85113	1874	11745000
85114	2134	96704133000
85115	1874	11748000
85116	1634	20352362641004
85117	1634	20352364641004
85129	1874	11699000
85130	1874	11701000
85131	1874	11703000
85132	1874	11717000
85133	1874	11720000
85134	1874	11726000
85135	1874	11739000
85136	1874	11741000
85137	1874	11747000
85138	1874	11749000
85139	1546	17281154000000
85149	1672	25202201000000
85152	1397	1324438578000
84448	2133	97202412000
84449	1874	11373000
84450	2133	97201410000
84451	1874	11375000
84452	2134	96773340000
84453	1874	11378000
84454	1762	22642137994000
84483	1397	1325128647000
84484	1678	21600733453000
84485	2211	718023000000
84486	2225	0
84487	2134	96769328000
84488	1874	11397000
84489	2133	97197402000
84490	1874	11399000
84491	1671	17328559530515
84560	176	66000100000000
84561	1271	1347726764999928
84678	1397	1324918626000
84679	1678	21600733474000
84680	2134	96748265000
84681	1874	11508000
84682	2133	97176360000
84683	1874	11510000
84684	1708	17315983000021
84685	1708	17315995000021
84736	1397	1324848619000
84737	1678	21600733481000
84738	2133	97169346000
84739	1874	11544000
84740	1395	58118306303007706
84741	1395	58118306314007706
84744	1397	1324838618000
84745	1678	21600733482000
84746	2132	148342343000
84747	1874	11545000
84748	2134	96741244000
84749	1874	11548000
84750	2133	97168344000
84751	1874	11550000
84752	1564	14226558000000
84753	1564	14226571000000
84762	1397	1324818616000
84763	1678	21600733484000
84764	1397	1324808615000
84765	1678	21600733485000
84766	1397	1324798614000
84767	1678	21600733486000
84768	1726	64952112000
84769	1982	200000000
84770	2132	148341342000
84771	1874	11556000
84772	2134	96739238000
84773	1874	11559000
84774	2134	96738235000
84775	1874	11562000
84776	2134	96737232000
84777	1874	11565000
84778	2133	97166340000
84779	1874	11567000
84780	2133	97165338000
84781	1874	11569000
84782	2133	97164336000
84783	1874	11571000
84784	1701	13030447600056
84796	2133	97162332000
84797	1874	11578000
84798	2134	96735226000
84799	1874	11581000
84800	1522	18334300000000
84801	1397	1324768611000
84802	1678	21600733489000
84803	2132	148340341000
84804	1874	11582000
84805	2133	97161330000
84806	1874	11584000
84807	2134	96734223000
84808	1874	11587000
84809	1564	14946571000000
84810	1564	14946584000000
84866	1685	133202760571430
84867	1685	133922760571430
84868	1685	133922761571430
84877	2134	96728205000
84878	1874	11618000
84879	1549	24816037000000
84880	1549	24816049000000
84888	1397	1324698604000
84889	1678	21600733496000
84890	2133	97153314000
84891	1874	11623000
84892	2134	96727202000
84893	1874	11626000
84894	1394	378725715000000
84897	1397	1324688603000
84898	1678	21600733497000
84899	2134	96726199000
84900	1874	11629000
84901	2133	97152312000
84902	1874	11631000
84903	1668	20846877000000
84904	1668	20846899000000
84963	1397	1324618596000
84964	1678	21600733504000
84965	2134	96719178000
84966	1874	11666000
84967	2133	97145298000
84968	1874	11668000
84969	1698	19257144550035
84970	1698	19257156550035
84982	1747	8656933000000
85000	1402	65374837319298
85001	1402	65374861319298
85017	1594	17905326000000
85047	1444	17512357159999
85048	2039	19441535000000
85057	1547	17133546000000
85058	1547	17133558000000
85059	1397	1324528587000
85060	1678	21600733513000
85061	2134	96710151000
85062	1874	11714000
85063	2133	97136280000
85064	1874	11716000
85085	1397	1324498584000
85086	1678	21600733516000
85087	2133	97133274000
85088	1874	11729000
85089	2134	96707142000
85090	1874	11732000
85091	1711	19245327000000
85092	1711	19245339000000
85118	369	85236728000000
85119	369	85956728000000
85120	1397	1324458580000
85121	1678	21600733520000
85122	2134	96703130000
85123	1874	11751000
85124	2133	97129266000
85125	1874	11753000
85126	1546	17281031000000
85150	1394	383045739000000
85151	1394	383045752000000
85159	1397	1324428577000
85160	1678	21600733523000
85161	1397	1324418576000
85162	1678	21600733524000
85163	1397	1324408575000
85164	1678	21600733525000
85165	2132	148329330000
85166	1874	11765000
85167	2134	96700121000
85168	1874	11768000
85169	2134	96699118000
85170	1874	11771000
85171	2134	96698115000
85172	1874	11774000
85173	1672	25922202000000
85174	1672	25922236000000
85186	171	81830532524688
85187	171	81830569524688
85234	2133	97118244000
85235	1874	11809000
85236	1874	11812000
85237	1546	17281032000000
85240	1506	14401269967172
85257	1397	1324338568000
85258	1678	21600733532000
85259	2134	96691094000
85260	1874	11813000
85261	1874	11815000
85262	2133	97117242000
85263	1874	11817000
85265	1397	1324328567000
85266	1678	21600733533000
85267	2134	96690091000
85268	1874	11820000
85269	1679	22319166653000
85270	1679	22319177653000
85289	1397	1324298564000
85290	1678	21600733536000
85291	2133	97113234000
85292	1874	11835000
85293	2134	96687082000
85294	1874	11838000
84600	1397	1324998634000
84601	1678	21600733466000
84602	2134	96756289000
84603	1874	11465000
84604	2132	148347348000
84605	1874	11466000
84606	2133	97184376000
84607	1874	11468000
84608	1509	18672078851155
84609	1509	18672091851155
84626	1397	1324968631000
84627	1678	21600733469000
84628	1397	1324958630000
84629	1678	21600733470000
84630	2132	148346347000
84631	1874	11479000
84632	2134	96753280000
84633	1874	11482000
84634	2134	96752277000
84635	1874	11485000
84636	1727	16747212000000
84637	1520	16747234999999
84638	1727	100000001
84659	1874	11488000
84660	1422	13825162860211
84662	1397	1324938628000
84663	1678	21600733472000
84664	1397	1324928627000
84665	1678	21600733473000
84666	1874	11490000
84667	2133	97178364000
84668	1874	11496000
84669	2134	96750271000
84670	1874	11499000
84671	2134	96749268000
84672	1874	11502000
84673	2132	148345346000
84674	1874	11503000
84675	2133	97177362000
84676	1874	11505000
84677	1394	375845691000000
84693	1394	377285691000000
84694	1394	377285703000000
84754	1692	35780527619999
84755	1692	35780540619999
84811	1397	1324758610000
84812	1678	21600733490000
84813	2133	97160328000
84814	1874	11589000
84815	2134	96733220000
84816	1874	11592000
84817	1547	15693534000000
84845	1874	11600000
84846	1874	11601000
84847	1444	20732371159999
84849	1397	1324728607000
84850	1678	21600733493000
84851	1397	1324718606000
84852	1678	21600733494000
84853	2134	96730211000
84854	1874	11606000
84855	2134	96729208000
84856	1874	11609000
84857	1444	18232370159999
84858	2214	2502000000000
84859	2133	97157322000
84860	1874	11611000
84861	1419	34299869280064
84862	2133	97156320000
84863	1874	11613000
84864	1419	35019869280064
84865	1419	35019870280064
84873	1397	1324708605000
84874	1678	21600733495000
84875	1687	9260189223172
84876	1687	9260200223172
84921	1739	28799792000000
84922	1739	28799815000000
84961	1695	16172318999000
84962	1695	16172330999000
84971	1397	1324608595000
84972	1678	21600733505000
84973	2134	96718175000
84974	1874	11671000
84975	2132	148335336000
84976	1874	11672000
84977	2133	97144296000
84978	1874	11674000
84979	1704	5106326000000
84985	1715	15866814436096
85003	1637	226085317819988
85004	1637	226085341819988
85005	1397	1324578592000
85006	1678	21600733508000
85007	2134	96715166000
85008	1874	11687000
85009	2133	97141290000
85010	1874	11689000
85011	2132	148334335000
85012	1874	11690000
85013	1422	14545162860211
85014	1422	14545175860211
85021	1397	1324568591000
85022	1678	21600733509000
85023	2134	96714163000
85024	1874	11693000
85025	2133	97140288000
85026	1874	11695000
85027	1402	65374849319298
85045	1685	134642761571430
85046	1685	134642774571430
85049	1397	1324538588000
85050	1678	21600733512000
85051	2133	97137282000
85052	1874	11708000
85053	2134	96711154000
85054	1874	11711000
85055	2039	19441530000000
85074	1718	11106841763340
85127	1394	381605727000000
85128	1394	381605739000000
85140	1397	1324448579000
85141	1678	21600733521000
85142	2132	148330331000
85143	1874	11754000
85144	2134	96702127000
85145	1874	11757000
85146	2133	97128264000
85147	1874	11759000
85148	1672	25202202000000
85196	1397	1324388573000
85197	1678	21600733527000
85198	1397	1324378572000
85199	1678	21600733528000
85200	2133	97122252000
85201	1874	11787000
85202	2133	97121250000
85203	1874	11789000
85204	2132	148328329000
85205	1874	11790000
85206	2134	96696109000
85207	1874	11793000
85208	2134	96695106000
85209	1874	11796000
85210	1447	16713600943000
85211	1447	16713625943000
85215	1397	1324368571000
85216	1678	21600733529000
85217	1397	1324358570000
85218	1678	21600733530000
85219	2134	96694103000
85220	1874	11799000
85221	2133	97120248000
85222	1874	11801000
85223	2133	97119246000
85224	1874	11803000
85225	2134	96693100000
85226	1874	11806000
85227	1693	6619336757818
85238	1395	58119746327007706
85239	1395	58119746340007706
85264	1700	21186128276737
85271	1397	1324318566000
85272	1678	21600733534000
85273	2134	96689088000
85274	1874	11823000
85275	2133	97116240000
85276	1874	11825000
85277	2133	97115238000
85278	1874	11827000
85279	1608	19725736000000
85280	1608	19725749000000
85339	1451	15739046000000
85431	1724	18657482500000
85432	1724	18657494500000
85436	1397	1324168551000
85437	1678	21600733549000
85438	2133	97099206000
85439	1874	11906000
85440	2134	96674043000
85441	1874	11909000
85442	1688	62640427908000
85443	1688	62640439908000
85446	1397	1324158550000
85447	1678	21600733550000
84707	1397	1324878622000
84708	1678	21600733478000
84709	1397	1324868621000
84710	1678	21600733479000
84711	2134	96745256000
84712	1874	11524000
84713	2134	96744253000
84714	1874	11527000
84715	2134	96743250000
84716	1874	11530000
84717	2132	148343344000
84718	1874	11531000
84719	2133	97173354000
84720	1874	11533000
84721	2133	97172352000
84722	1874	11535000
84723	2133	97171350000
84724	1874	11537000
84725	1692	35060490619999
84726	1692	35060527619999
84734	1688	59760341908000
84735	1688	59760352908000
84742	1394	378725703000000
84743	1394	378725714000000
84785	1397	1324788613000
84786	1678	21600733487000
84787	2133	97163334000
84788	1874	11573000
84789	2134	96736229000
84790	1874	11576000
84791	1688	59760353908000
84833	1397	1324738608000
84834	1678	21600733492000
84835	2133	97158324000
84836	1874	11599000
84837	2134	96731214000
84838	1874	11602000
84839	2132	148339340000
84840	1874	11603000
84841	1726	60148112000
84842	1982	1400000000
84843	1444	20732358159999
84844	1444	20732372159999
84869	2133	97155318000
84870	1874	11615000
84871	1688	60480353908000
84872	1688	60480354908000
84881	2132	148338339000
84882	1874	11616000
84883	2133	97154316000
84884	1874	11621000
84885	1394	378725706000000
84895	2214	2501990000000
84896	1688	60480375908000
84905	484	72908857000000
84906	484	72908879000000
84916	2133	97151310000
84917	1874	11633000
84918	1874	11634000
84919	1874	11637000
84920	1684	24480686880623
84953	1397	1324628597000
84954	1678	21600733503000
84955	2134	96720181000
84956	1874	11661000
84957	2133	97146300000
84958	1874	11663000
84959	1547	16413534000000
84960	1547	16413546000000
84983	1395	58119026314007706
84984	1395	58119026327007706
85002	1549	24816061000000
85018	1700	21186130276737
85035	1397	1324548589000
85036	1678	21600733511000
85037	2133	97138284000
85038	1874	11702000
85039	2134	96712157000
85040	1874	11705000
85041	2132	148333334000
85042	1874	11706000
85043	1394	380165715000000
85044	1394	380165728000000
85071	2133	97135278000
85072	1874	11721000
85073	1622	21420451000005
85075	1397	1324508585000
85076	1678	21600733515000
85077	2133	97134276000
85078	1874	11723000
85079	2132	148332333000
85080	1874	11724000
85081	2134	96708145000
85082	1874	11727000
85083	1688	61200377908000
85084	1688	61200390908000
85093	1397	1324488583000
85094	1678	21600733517000
85095	1397	1324478582000
85096	1678	21600733518000
85097	2134	96706139000
85098	1874	11735000
85099	2134	96705136000
85100	1874	11738000
85101	2133	97132272000
85102	1874	11740000
85103	2133	97131270000
85104	1874	11742000
85105	2132	148331332000
85106	1874	11743000
85107	1687	9980200223172
85108	1687	9980225223172
85175	2133	97126260000
85176	1874	11766000
85177	1874	11767000
85178	2133	97125258000
85179	1874	11769000
85180	2133	97124256000
85181	1874	11777000
85182	1874	11780000
85183	1672	25922239000000
85212	1444	19292280159999
85213	1444	16792279159999
85214	1693	6619909757818
85228	1397	1324348569000
85229	1678	21600733531000
85230	2132	148327328000
85231	1874	11807000
85232	2134	96692097000
85233	1874	11810000
85241	1546	17281224000000
85242	1874	11760000
85243	1874	11763000
85244	1874	11773000
85245	1874	11775000
85246	1874	11779000
85247	1874	11781000
85248	1874	11783000
85249	1874	11786000
85250	1874	11792000
85251	1874	11795000
85252	1874	11797000
85253	1874	11800000
85254	1546	18001224000000
85255	2221	18001289900000
85256	1546	200100000
85281	1397	1324308565000
85282	1678	21600733535000
85283	2134	96688085000
85284	1874	11830000
85285	2133	97114236000
85286	1874	11832000
85287	2132	148326327000
85288	1874	11833000
85305	1397	1324278562000
85306	1678	21600733538000
85307	2134	96685076000
85308	1874	11846000
85309	2132	148325326000
85310	1874	11847000
85311	1637	226805341819988
85312	1637	226805353819988
85318	1397	1324268561000
85319	1678	21600733539000
85320	2134	96684073000
85321	1874	11852000
85322	2133	97110228000
85323	1874	11854000
85324	1708	18035995000021
85325	1708	18036007000021
85340	1874	11851000
85341	1451	15739035000000
85348	1739	29519815000000
85349	1739	29519837000000
85351	1711	19965340000000
85359	1397	1324238558000
85360	1678	21600733542000
85361	2132	148324325000
85362	1874	11862000
85363	2133	97107222000
85364	1874	11864000
85365	2134	96682067000
85366	1874	11867000
85367	1608	20445749000000
85368	1608	20445762000000
85153	1678	21600733522000
85154	2133	97127262000
85155	1874	11761000
85156	2134	96701124000
85157	1874	11764000
85158	1394	383045751000000
85184	1688	61920390908000
85185	1688	61920427908000
85188	1397	1324398574000
85189	1678	21600733526000
85190	2133	97123254000
85191	1874	11782000
85192	2134	96697112000
85193	1874	11785000
85194	58	89706648999641
85195	58	89706660999641
85297	1397	1324288563000
85298	1678	21600733537000
85299	2134	96686079000
85300	1874	11841000
85301	2133	97112232000
85302	1874	11843000
85303	1394	384485751000000
85304	1394	384485763000000
85342	1397	1324258560000
85343	1678	21600733540000
85344	2133	97109226000
85345	1874	11856000
85346	1711	19965339000000
85347	1711	19965361000000
85350	1457	22944470040000
85352	1397	1324248559000
85353	1678	21600733541000
85354	2133	97108224000
85355	1874	11858000
85356	2134	96683070000
85357	1874	11861000
85358	1759	17280877999889
85378	1397	1324208555000
85379	1678	21600733545000
85380	2134	96679058000
85381	1874	11876000
85382	2132	148323324000
85383	1874	11877000
85384	2133	97106220000
85385	1874	11879000
85386	1439	12532484998477
85387	2133	97105218000
85388	1874	11881000
85389	2133	97104216000
85390	1874	11883000
85391	1439	13252484998477
85392	1439	13252486998477
85410	1397	1324188553000
85411	1678	21600733547000
85412	2132	148322323000
85413	1874	11894000
85414	2133	97101210000
85415	1874	11896000
85416	2134	96676049000
85417	1874	11899000
85418	1708	18036008000021
85433	1394	385925763000000
85434	1394	385925775000000
85444	641	82900232000000
85445	1623	60482955899898
85453	1397	1324148549000
85454	1678	21600733551000
85455	2134	96672037000
85456	1874	11917000
85457	2132	148321322000
85458	1874	11918000
85459	2133	97097202000
85460	1874	11920000
85525	1397	1324058540000
85526	1678	21600733560000
85527	2134	96663010000
85528	1874	11965000
85529	2133	97088184000
85530	1874	11967000
85549	1556	1440156000000
85573	1397	1323998534000
85574	1678	21600733566000
85575	1397	1323988533000
85576	1678	21600733567000
85577	2134	96656992000
85578	1874	11997000
85579	2132	148316317000
85580	1874	11998000
85581	2134	96655989000
85582	1874	12001000
85583	2133	97082172000
85584	1874	12003000
85585	2133	97081170000
85586	1874	12005000
85587	58	89706673999641
85609	1489	20064493000000
85610	1489	20064529000000
85636	1546	17281061000000
85637	1546	18001060999998
85638	1855	18001066995998
85639	1546	200004002
85750	149	84990283000341
85751	149	84990332000341
85754	1397	1323828517000
85755	1678	21600733583000
85756	1397	1323818516000
85757	1678	21600733584000
85758	2132	148311312000
85759	1874	12082000
85760	2134	96640944000
85761	1874	12085000
85762	2133	97065138000
85763	1874	12087000
85764	2133	97064136000
85765	1874	12089000
85766	2134	96639941000
85767	1874	12092000
85768	1394	388805838000000
85783	1397	1323788513000
85784	1678	21600733587000
85785	1397	1323778512000
85786	1678	21600733588000
85787	2134	96636932000
85788	1874	12105000
85789	2134	96635929000
85790	1874	12108000
85791	2133	97061130000
85792	1874	12110000
85793	2133	97060128000
85794	1874	12112000
85795	2132	148310311000
85796	1874	12113000
85797	1699	7989863750126
85799	2086	4319240000000
85800	1874	12019000
85801	1874	12025000
85802	1874	12028000
85803	1874	12034000
85804	1874	12037000
85805	1874	12038000
85806	1874	12050000
85807	1874	12062000
85808	1874	12068000
85809	1874	12070000
85810	1874	12074000
85811	1874	12076000
85812	1874	12080000
85813	1874	12084000
85814	1874	12086000
85815	1874	12088000
85816	1874	12090000
85817	1874	12096000
85818	1874	12098000
85819	1874	12104000
85820	1874	12106000
85821	1874	12109000
85822	1874	12111000
85823	2086	5039240000000
85824	2086	5039357000000
85848	1397	1323738508000
85849	1678	21600733592000
85850	2134	96631917000
85851	1874	12132000
85852	2133	97056120000
85853	1874	12134000
85854	1698	19977156550035
85855	1698	19977168550035
85881	1397	1323708505000
85882	1678	21600733595000
85883	1397	1323698504000
85884	1678	21600733596000
85885	2134	96628908000
85886	1874	12148000
85887	2134	96627905000
85888	1874	12151000
85889	2133	97053114000
85890	1874	12153000
85891	2133	97052112000
85892	1874	12155000
85893	1694	23772757127629
85952	1397	1323658500000
85953	1678	21600733600000
85954	2133	97048104000
85955	1874	12173000
85295	1691	17963264100019
85296	1691	17963276100019
85313	2133	97111230000
85314	1874	11848000
85315	1874	11849000
85316	1610	19440636019950
85317	1610	19440649019950
85326	1451	15019984000000
85327	1874	11395000
85328	1874	11396000
85329	1874	11398000
85330	1874	11410000
85331	1874	11412000
85332	1874	11418000
85333	1874	11421000
85334	1874	11427000
85335	1874	11430000
85336	1874	11432000
85337	1451	15739984000000
85338	1451	15740077000000
85369	1397	1324228557000
85370	1678	21600733543000
85371	1397	1324218556000
85372	1678	21600733544000
85373	2134	96681064000
85374	1874	11870000
85375	2134	96680061000
85376	1874	11873000
85377	1637	226805363819988
85396	2133	97103214000
85397	1874	11885000
85398	1874	11888000
85399	1649	24764381999992
85408	1668	21566899000000
85409	1668	21566911000000
85421	1693	7339336757818
85422	1693	7339349757818
85423	1397	1324178552000
85424	1678	21600733548000
85425	2134	96675046000
85426	1874	11902000
85427	2133	97100208000
85428	1874	11904000
85429	1727	17467234999999
85430	1727	17467246999999
85483	1397	1324108545000
85484	1678	21600733555000
85485	2133	97093194000
85486	1874	11938000
85487	2134	96668025000
85488	1874	11941000
85489	1467	13646796100039
85490	1467	13646808100039
85509	1426	22605173000000
85510	1426	22605198000000
85517	1397	1324068541000
85518	1678	21600733559000
85519	2133	97089186000
85520	1874	11959000
85521	2134	96664013000
85522	1874	11962000
85523	1637	227525363819988
85524	1637	227525375819988
85550	1397	1324028537000
85551	1678	21600733563000
85552	2134	96660001000
85553	1874	11981000
85554	2133	97085178000
85555	1874	11983000
85556	1711	20685340000000
85557	1711	20685352000000
85685	1397	1323918526000
85686	1678	21600733574000
85687	1397	1323908525000
85688	1678	21600733575000
85689	2134	96649971000
85690	1874	12036000
85691	2134	96648968000
85692	1874	12039000
85693	2133	97074156000
85694	1874	12041000
85695	2133	97073154000
85696	1874	12043000
85697	2132	148314315000
85698	1874	12044000
85699	1555	11715327979096
85700	1555	11715352979096
85701	1397	1323898524000
85702	1678	21600733576000
85703	2134	96647965000
85704	1874	12047000
85705	2133	97072152000
85706	1874	12049000
85833	1397	1323758510000
85834	1678	21600733590000
85835	1397	1323748509000
85836	1678	21600733591000
85837	2132	148309310000
85838	1874	12119000
85839	2133	97058124000
85840	1874	12121000
85841	2134	96633923000
85842	1874	12124000
85843	2133	97057122000
85844	1874	12126000
85845	2134	96632920000
85846	1874	12129000
85847	1560	19314451277001
85856	526	67440090000000
85857	526	67440102000000
85861	1599	20500388393047
85862	1599	20500400393047
85894	1692	36500540619999
85895	1692	36500564619999
85946	1397	1323668501000
85947	1678	21600733599000
85948	2133	97049106000
85949	1874	12168000
85950	2134	96624896000
85951	1874	12171000
85974	1397	1323628497000
85975	1678	21600733603000
85976	2133	97045098000
85977	1874	12188000
85978	2134	96620884000
85979	1874	12191000
85980	1622	22140451000005
85981	1622	22140463000005
86014	1685	135362774571430
86015	1685	135362786571430
86045	1740	18645386000000
86062	1693	6769709201471
86063	35	19389460979377
86064	1397	1323548489000
86065	1678	21600733611000
86066	1397	1323538488000
86067	1678	21600733612000
86068	1693	6732365278589
86069	49	66651272116779
86070	1693	6695021355707
86071	251	66651272116779
86072	1693	6521452217703
86073	893	309850571298133
86074	1693	6484108294821
86075	320	66370072116779
86076	1693	5974468128596
86077	1030	909863680121925
86078	2134	96612860000
86079	1874	12231000
86080	2133	97036080000
86081	1874	12233000
86082	1471	22939947900000
86106	1690	137524333000000
86107	1690	137524395000000
86109	1397	1323528487000
86110	1678	21600733613000
86111	1397	1323518486000
86112	1678	21600733614000
86113	1693	5576835453300
86114	570	66651272116779
86115	1693	5539491530418
86116	225	66651272116779
86117	1693	5502147607536
86118	377	66651272116779
86119	1693	5464803684654
86120	560	66651272116779
86121	1693	5427459761772
86122	252	66651272116779
86123	1693	5390115838890
86124	1962	650184292006
86125	1693	5352771916008
86126	201	66651272116779
86127	1693	5315427993126
86128	402	66651272116779
86129	1693	5278084070244
86130	163	66651272116779
86131	1693	5240740147362
86132	82	66651272116779
86133	1693	5203396224480
86134	275	66651272116779
86135	1693	5166052301598
86136	361	66651272116779
86137	2134	96610854000
86138	1874	12241000
86139	2134	96609851000
85393	2134	96678055000
85394	1874	11886000
85395	1649	24764380999992
85400	1397	1324198554000
85401	1678	21600733546000
85402	2133	97102212000
85403	1874	11890000
85404	2134	96677052000
85405	1874	11893000
85406	369	86676730000000
85407	369	86676742000000
85419	1717	18108170000023
85420	1717	18108183000023
85435	171	81830544524688
85461	1397	1324138548000
85462	1678	21600733552000
85463	1397	1324128547000
85464	1678	21600733553000
85465	1397	1324118546000
85466	1678	21600733554000
85467	2133	97096200000
85468	1874	11922000
85469	2132	148320321000
85470	1874	11923000
85471	2134	96671034000
85472	1874	11926000
85473	2134	96670031000
85474	1874	11929000
85475	2134	96669028000
85476	1874	11932000
85477	2133	97095198000
85478	1874	11934000
85479	2133	97094196000
85480	1874	11936000
85481	1508	19476673500009
85482	1508	19476710500009
85493	1397	1324098544000
85494	1678	21600733556000
85495	1397	1324088543000
85496	1678	21600733557000
85497	2132	148319320000
85498	1874	11942000
85499	2134	96667022000
85500	1874	11945000
85501	2134	96666019000
85502	1874	11948000
85503	2133	97092192000
85504	1874	11950000
85505	2133	97091190000
85506	1874	11952000
85507	1688	63360439908000
85508	1688	63360464908000
85511	1397	1324078542000
85512	1678	21600733558000
85513	2134	96665016000
85514	1874	11955000
85515	2133	97090188000
85516	1874	11957000
85531	1395	58119746339007706
85532	1556	1440002000000
85533	1556	1440139000000
85588	1394	387365788000000
85589	1394	387365813000000
85611	1687	10700225223172
85612	1687	10700261223172
85640	1546	18001061000000
85641	1546	18001067000000
85642	1874	11818000
85643	1874	11821000
85644	1874	11824000
85645	1874	11826000
85646	1874	11829000
85647	1874	11845000
85648	1874	11855000
85649	1874	11865000
85650	1874	11866000
85651	1874	11868000
85652	1874	11869000
85653	1874	11871000
85654	1874	11872000
85655	1874	11882000
85656	1874	11891000
85657	1874	11897000
85658	1874	11900000
85659	1874	11903000
85660	1874	11915000
85661	1874	11921000
85662	1874	11924000
85663	1874	11927000
85664	1874	11930000
85665	1874	11933000
85666	1874	11939000
85667	1546	18001762900000
85668	1874	11951000
85669	1874	11954000
85670	1874	11956000
85671	1874	11961000
85672	1874	11963000
85673	1874	11969000
85674	1874	11973000
85675	1874	11975000
85676	1874	11977000
85677	1874	11979000
85678	1874	11985000
85679	1874	11987000
85680	1874	11989000
85681	1874	11995000
85682	1874	11999000
85683	1546	18721762900000
85684	1546	18721792900000
85752	1394	388805813000000
85753	1394	388805862000000
85769	1397	1323808515000
85770	1678	21600733585000
85771	2133	97063134000
85772	1874	12094000
85773	2134	96638938000
85774	1874	12097000
85798	2087	5039132000000
85825	1397	1323768511000
85826	1678	21600733589000
85827	2133	97059126000
85828	1874	12115000
85829	2134	96634926000
85830	1874	12118000
85831	1394	390245838000000
85832	1394	390245850000000
85859	1458	20973773908540
85860	1458	20973785908540
85864	1397	1323728507000
85865	1678	21600733593000
85866	1397	1323718506000
85867	1678	21600733594000
85868	2132	148308309000
85869	1874	12135000
85870	2134	96630914000
85871	1874	12138000
85872	2134	96629911000
85873	1874	12141000
85874	2133	97055118000
85875	1874	12143000
85876	2133	97054116000
85877	1874	12145000
85878	1422	14545187860211
85930	1397	1323688503000
85931	1678	21600733597000
85932	1397	1323678502000
85933	1678	21600733598000
85934	2132	148307308000
85935	1874	12156000
85936	2134	96626902000
85937	1874	12159000
85938	2133	97051110000
85939	1874	12161000
85940	2133	97050108000
85941	1874	12163000
85942	2134	96625899000
85943	1874	12166000
85944	1467	14366808100039
85945	1467	14366833100039
85990	1395	58120466339007706
85991	1395	58120466351007706
86024	1397	1323568491000
86025	1678	21600733609000
86026	2133	97039086000
86027	1874	12218000
86028	2134	96614866000
86029	1874	12221000
86030	1692	37940589619999
86031	1692	37940601619999
86044	1536	15840793999959
86085	1489	20064575000000
86108	555	67440043000000
86148	1693	5128708378716
86149	309	66651272116779
86150	1693	5091364455834
86151	2073	649447026849
86152	1693	5054020532952
86153	452	66651272116779
86154	1693	5016676610070
86155	594	66651272116779
86156	1693	4979332687188
86157	2181	649523922882
86158	1693	4941988764306
86159	680	66651272116779
85448	2134	96673040000
85449	1874	11912000
85450	2133	97098204000
85451	1874	11914000
85452	1684	24480675880623
85491	1680	17289703500035
85492	1680	17289715500035
85534	1397	1324048539000
85535	1678	21600733561000
85536	1397	1324038538000
85537	1678	21600733562000
85538	2132	148318319000
85539	1874	11968000
85540	2134	96662007000
85541	1874	11971000
85542	2134	96661004000
85543	1874	11974000
85544	2133	97087182000
85545	1874	11976000
85546	2133	97086180000
85547	1874	11978000
85548	1556	1440027000000
85558	1397	1324018536000
85559	1678	21600733564000
85560	1397	1324008535000
85561	1678	21600733565000
85562	2134	96658998000
85563	1874	11986000
85564	2133	97084176000
85565	1874	11988000
85566	2134	96657995000
85567	1874	11991000
85568	2133	97083174000
85569	1874	11993000
85570	2132	148317318000
85571	1874	11994000
85572	1394	385925788000000
85590	1397	1323978532000
85591	1678	21600733568000
85592	1397	1323968531000
85593	1678	21600733569000
85594	1397	1323958530000
85595	1678	21600733570000
85596	2133	97080168000
85597	1874	12007000
85598	2134	96654986000
85599	1874	12010000
85600	2134	96653983000
85601	1874	12013000
85602	2134	96652980000
85603	1874	12016000
85604	2133	97079166000
85605	1874	12018000
85606	2133	97078164000
85607	1874	12020000
85608	1555	10995327979096
85613	1397	1323948529000
85614	1678	21600733571000
85615	1397	1323938528000
85616	1678	21600733572000
85617	1397	1323928527000
85618	1678	21600733573000
85619	1688	62640469908000
85620	2133	97077162000
85621	1874	12022000
85622	2133	97076160000
85623	1874	12024000
85624	2134	96651977000
85625	1874	12027000
85626	2134	96650974000
85627	1874	12030000
85628	2132	148315316000
85629	1874	12031000
85630	2133	97075158000
85631	1874	12033000
85632	1855	200000200
85633	1688	63360469907800
85634	1855	63360475905200
85635	1688	200002800
85707	1397	1323888523000
85708	1678	21600733577000
85709	1397	1323878522000
85710	1678	21600733578000
85711	2133	97071150000
85712	1874	12051000
85713	2133	97070148000
85714	1874	12053000
85715	2134	96646962000
85716	1874	12056000
85717	2134	96645959000
85718	1874	12059000
85719	2132	148313314000
85720	1874	12060000
85721	1693	7339361757818
85722	1397	1323868521000
85723	1678	21600733579000
85724	1397	1323858520000
85725	1678	21600733580000
85726	1397	1323848519000
85727	1678	21600733581000
85728	1397	1323838518000
85729	1678	21600733582000
85730	2132	148312313000
85731	1874	12061000
85732	2133	97069146000
85733	1874	12063000
85734	2133	97068144000
85735	1874	12065000
85736	2133	97067142000
85737	1874	12067000
85738	2133	97066140000
85739	1874	12069000
85740	2134	96644956000
85741	1874	12072000
85742	2134	96643953000
85743	1874	12075000
85744	2134	96642950000
85745	1874	12078000
85746	2134	96641947000
85747	1874	12081000
85748	1613	17928038600000
85749	1613	17928087600000
85775	1397	1323798514000
85776	1678	21600733586000
85777	2134	96637935000
85778	1874	12100000
85779	2133	97062132000
85780	1874	12102000
85781	1402	66094849319298
85782	1402	66094861319298
85858	1672	25922214000000
85863	1474	16751377000023
85879	1690	136804308000000
85880	1690	136804333000000
85896	1694	23053053127629
85897	1874	12000000
85898	1874	12002000
85899	1874	12008000
85900	1874	12011000
85901	1874	12014000
85902	1874	12017000
85903	1874	12023000
85904	1874	12026000
85905	1874	12029000
85906	1874	12040000
85907	1874	12046000
85908	1874	12071000
85909	1874	12073000
85910	1874	12077000
85911	1874	12083000
85912	1874	12114000
85913	1874	12116000
85914	1874	12120000
85915	1874	12122000
85916	1874	12128000
85917	1874	12130000
85918	1874	12136000
85919	1874	12140000
85920	1874	12142000
85921	1874	12144000
85922	1874	12146000
85923	1874	12149000
85924	1874	12150000
85925	1874	12152000
85926	1874	12154000
85927	1694	23773053127629
85928	1694	67440013050000
85929	75	23773138077629
85960	1397	1323648499000
85961	1678	21600733601000
85962	1397	1323638498000
85963	1678	21600733602000
85964	2133	97047102000
85965	1874	12178000
85966	2134	96622890000
85967	1874	12181000
85968	2133	97046100000
85969	1874	12183000
85970	2134	96621887000
85971	1874	12186000
85972	1675	17422299999977
85973	1675	17422323999977
85992	1397	1323608495000
85993	1678	21600733605000
85994	1397	1323598494000
85956	2134	96623893000
85957	1874	12176000
85958	1559	15082833000000
85959	1559	15802833000000
85982	1397	1323618496000
85983	1678	21600733604000
85984	2134	96619881000
85985	1874	12194000
85986	2133	97044096000
85987	1874	12196000
85988	1608	21165762000000
85989	1608	21165774000000
86007	1397	1323588493000
86008	1678	21600733607000
86009	2134	96616872000
86010	1874	12209000
86011	2133	97041090000
86012	1874	12211000
86013	1455	11554117000000
86016	1397	1323578492000
86017	1678	21600733608000
86018	2134	96615869000
86019	1874	12214000
86020	2133	97040088000
86021	1874	12216000
86022	1705	15035615500145
86023	1705	15035627500145
86046	1693	6960265724944
86047	54	66651272116779
86048	1693	6957427397456
86049	710	5049338796669
86050	1693	6855267824799
86051	1811	1778097057551
86052	1693	6817923901917
86053	217	66651272116779
86054	1693	6780579979035
86055	103	66651272116779
86056	2133	97037082000
86057	1874	12225000
86058	2134	96613863000
86059	1874	12228000
86060	1394	391685850000000
86061	1394	391685913000000
86104	555	67440002000000
86105	555	67440064000000
86188	1759	18000877999889
86189	1759	18001021999889
86209	1693	4530064281612
86210	352	66651272116779
86211	1693	4492720358730
86212	652	66651272116779
86213	1693	4455376435848
86214	191	66651272116779
86215	1693	4418032512966
86216	266	66038252116779
86217	1693	4074164884715
86218	1150	613903155292823
86219	1693	4036820961833
86220	84	66651272116779
86221	1397	1323478482000
86222	1678	21600733618000
86223	2133	97029066000
86224	1874	12265000
86225	2134	96605839000
86226	1874	12268000
86227	1601	6373455620000
86228	1601	66000004010000
86229	212	6373527610000
86232	1693	3999477038951
86233	600	66651272116779
86234	1397	1323468481000
86235	1678	21600733619000
86236	1693	3962133116069
86237	691	66651272116779
86238	1693	3924789193187
86239	2017	649871451178
86240	1693	3887445270305
86241	551	66651272116779
86242	1693	3850101347423
86243	520	66651272116779
86244	1693	3812757424541
86245	392	66651272116779
86246	2133	97028064000
86247	1874	12270000
86248	2134	96604836000
86249	1874	12273000
86250	2086	5039173000000
86274	58	89706730999641
86279	1680	17289764500035
86299	1564	15666584000000
86300	1564	15666646000000
86301	1693	6581992834936
86302	1693	6544648912054
86303	1693	6277584647826
86304	1693	6240240724944
86305	1693	6237402397456
86306	1693	6135242824799
86307	1693	6097898901917
86308	1693	6060554979035
86309	1693	6049684201471
86310	1693	6012340278589
86311	1693	5974996355707
86312	1693	5801427217703
86313	1693	5764083294821
86314	1693	5254443128596
86315	1693	5217099205714
86316	1693	5179755282832
86317	1693	5142411359950
86318	1693	4968842221946
86319	1693	4931498299064
86320	1693	4894154376182
86321	1693	4856810453300
86322	1693	4819466530418
86323	1693	4782122607536
86324	1693	4744778684654
86325	1693	4707434761772
86326	1693	4670090838890
86327	1693	4632746916008
86328	1693	4595402993126
86329	1693	4558059070244
86330	1693	4520715147362
86331	1693	4483371224480
86332	1693	4446027301598
86333	1693	4408683378716
86334	1693	4371339455834
86335	1693	4333995532952
86336	1693	4296651610070
86337	1693	4259307687188
86338	1693	4221963764306
86339	1693	4184619841424
86340	1693	4147275918542
86341	1693	4109931995660
86342	1693	4108790664668
86343	1693	4071446741786
86344	1693	4034102818904
86345	1693	3996758896022
86346	1693	3959414973140
86347	1693	3922071050258
86348	1693	3884727127376
86349	1694	23773628077629
86350	1693	3847383204494
86351	1693	3810039281612
86352	1693	3772695358730
86353	1693	3735351435848
86354	1693	3698007512966
86355	1693	3354139884715
86356	1693	3316795961833
86357	1693	3279452038951
86358	1693	3242108116069
86359	1693	3204764193187
86360	1693	3167420270305
86361	1693	3130076347423
86362	1693	3092732424541
86363	1693	3055388501659
86364	1693	3018044578777
86365	1693	2980700655895
86366	1693	2943356733013
86367	1693	2906012810131
86368	1693	2868668887249
86369	1693	2831324964367
86370	1693	2793981041485
86371	1874	12165000
86372	1874	12167000
86373	1874	12169000
86374	1874	12175000
86375	1874	12177000
86376	1874	12179000
86377	1874	12185000
86378	1874	12187000
86379	1874	12189000
86380	1874	12193000
86381	1874	12195000
86382	1874	12197000
86383	1874	12199000
86384	1874	12201000
86385	1874	12205000
86386	1874	12207000
86387	1874	12212000
86388	1874	12215000
86389	1694	24493628077629
86390	1694	24494109077629
86413	1693	3176769404555
86414	373	66651272116779
86415	1397	1323428477000
86416	1678	21600733623000
85995	1678	21600733606000
85996	2133	97043094000
85997	1874	12198000
85998	1769	1579900000
85999	2133	97042092000
86000	1874	12200000
86001	2134	96618878000
86002	1874	12203000
86003	2134	96617875000
86004	1874	12206000
86005	1692	37220564619999
86006	1692	37220589619999
86032	1693	7302017834936
86033	399	66651272116779
86034	1693	7264673912054
86035	499	66651272116779
86036	1693	6997609647826
86037	1772	4656971682095
86038	1397	1323558490000
86039	1678	21600733610000
86040	2133	97038084000
86041	1874	12223000
86042	1536	15840763999959
86043	1536	15840804999959
86083	1691	18683276100019
86084	1691	18683358100019
86086	1693	5937124205714
86087	663	66651272116779
86088	1693	5899780282832
86089	390	66651272116779
86090	1693	5862436359950
86091	108	66651272116779
86092	1693	5688867221946
86093	894	309850571298133
86094	1693	5651523299064
86095	569	66651272116779
86096	1693	5614179376182
86097	99	66651272116779
86098	2134	96611857000
86099	1874	12236000
86100	2133	97035078000
86101	1874	12238000
86102	1688	64080475905200
86103	1688	64080537905200
86147	606	80398181812962
86190	1397	1323488483000
86191	1678	21600733617000
86192	1693	4716783896022
86193	112	66037334116779
86194	1693	4679439973140
86195	534	66651272116779
86196	1693	4642096050258
86197	245	66651272116779
86198	1693	4604752127376
86199	421	66651272116779
86200	1693	4567408204494
86201	620	66651272116779
86202	1513	29520971000000
86203	2133	97030068000
86204	1874	12260000
86205	2134	96606842000
86206	1874	12263000
86207	1513	30240971000000
86208	1513	30240973000000
86253	1690	137524405000000
86256	1397	1323458480000
86257	1678	21600733620000
86258	1693	3775413501659
86259	89	66651272116779
86260	1693	3738069578777
86261	186	66651272116779
86262	1693	3700725655895
86263	383	66651272116779
86264	1693	3663381733013
86265	308	66651272116779
86266	1693	3626037810131
86267	408	66651272116779
86268	1693	3588693887249
86269	678	66651272116779
86270	2134	96603833000
86271	1874	12274000
86272	1874	12276000
86273	1680	17289785500035
86298	1694	23772795127629
86487	1397	1323388473000
86488	1678	21600733627000
86489	2133	97021050000
86490	1874	12308000
86491	2134	96596812000
86492	1874	12311000
86493	1426	23325198000000
86494	1426	23325210000000
86501	1448	9397608000001
86502	1693	1219520831514
86503	206	66651272116779
86504	1693	1182176908632
86505	304	66651272116779
86506	1448	10117608000001
86507	1448	10118048000001
86510	1397	1323368471000
86511	1678	21600733629000
86512	1397	1323358470000
86513	1678	21600733630000
86514	2133	97019046000
86515	1874	12318000
86516	2134	96594806000
86517	1874	12321000
86518	2134	96593803000
86519	1874	12324000
86520	2133	97018044000
86521	1874	12326000
86522	1422	14545186860211
86545	1439	13252518998477
86546	1439	13972518998477
86557	149	84990295000341
86565	2134	96588788000
86566	1874	12349000
86567	1874	12351000
86609	1397	1323298464000
86610	1678	21600733636000
86611	1397	1323288463000
86612	1678	21600733637000
86613	1397	1323278462000
86614	1678	21600733638000
86615	1693	182166908632
86616	1778	5450090000000
86617	2134	96587785000
86618	1874	12354000
86619	2134	96586782000
86620	1874	12357000
86621	2133	97012032000
86622	1874	12359000
86623	2133	97011030000
86624	1874	12361000
86625	2133	97010028000
86626	1874	12363000
86627	1706	15332299600135
86628	1706	15332344600135
86645	1397	1323248459000
86646	1678	21600733641000
86647	1397	1323238458000
86648	1678	21600733642000
86649	2134	96583773000
86650	1874	12376000
86651	2134	96582770000
86652	1874	12379000
86653	1727	18187246999999
86654	1727	18187268999999
86662	1397	1323228457000
86663	1678	21600733643000
86664	2133	97005018000
86665	1874	12385000
86666	2134	96581767000
86667	1874	12388000
86749	1692	38660601619999
86750	1692	38660625619999
86767	1705	15755627500145
86768	1705	15755639500145
86789	633	83884124900000
86790	1694	23772735127629
86829	1397	1323148449000
86830	1678	21600733651000
86831	2133	96997002000
86832	1874	12425000
86833	2134	96573743000
86834	1874	12428000
86835	1693	902178908632
86844	1599	21220400393047
86845	1599	21220412393047
86851	1397	1323118446000
86852	1678	21600733654000
86853	1397	1323108445000
86854	1678	21600733655000
86855	2133	96994998000
86856	1874	12438000
86857	2134	96570734000
86858	1874	12441000
86859	2134	96569731000
86860	1874	12444000
86861	2133	96993996000
86862	1874	12446000
86863	2133	96992994000
86864	1874	12448000
86865	1992	17279379990000
86866	1992	17279404990000
86140	1874	12244000
86141	2133	97034076000
86142	1874	12246000
86143	2133	97033074000
86144	1874	12248000
86145	1395	58121186351007706
86146	1395	58121186495007706
86186	1394	393125913000000
86187	1394	393126057000000
86251	1874	12271000
86252	1699	7989910750126
86254	2087	5759132000000
86255	2087	5759194000000
86277	1601	7093526620000
86278	1601	7093608620000
86280	1693	3551349964367
86281	593	66650271116779
86282	1693	3514006041485
86283	91	66651272116779
86284	1397	1323448479000
86285	1678	21600733621000
86286	1693	3476662118603
86287	438	66651272116779
86288	1693	3439318195721
86289	339	66651272116779
86290	1693	3401974272839
86291	601	66651272116779
86292	2134	96602830000
86293	1874	12279000
86294	2133	97027062000
86295	1874	12281000
86296	1768	17870858110000
86297	1768	17870920110000
86411	1394	394566057000000
86412	1394	394566129000000
86537	1397	1323328467000
86538	1678	21600733633000
86539	2133	97015038000
86540	1874	12338000
86541	2134	96590794000
86542	1874	12341000
86543	1458	20253805908540
86544	1458	20973805908540
86560	1397	1323308465000
86561	1678	21600733635000
86562	2133	97013034000
86563	1874	12348000
86564	1719	20180841000000
86637	1397	1323258460000
86638	1678	21600733640000
86639	2133	97008024000
86640	1874	12370000
86641	2134	96584776000
86642	1874	12373000
86643	1394	396006129000000
86644	1394	396006141000000
86668	1693	3464595841424
86669	1693	3427251918542
86670	1693	3389907995660
86671	1693	3388766664668
86672	1693	3351422741786
86673	1693	3314078818904
86674	1693	3276734896022
86675	1693	3239390973140
86676	1693	3202047050258
86677	1693	3164703127376
86678	1693	3127359204494
86679	1693	3090015281612
86680	1693	3052671358730
86681	1693	3015327435848
86682	1693	2977983512966
86683	1693	2634115884715
86684	1693	2596771961833
86685	1693	2559428038951
86686	1693	2522084116069
86687	1693	2484740193187
86688	1693	2447396270305
86689	1693	2410052347423
86690	1693	2372708424541
86691	1693	2335364501659
86692	1693	2298020578777
86693	1693	2260676655895
86694	1693	2223332733013
86695	1693	2185988810131
86696	1693	2148644887249
86697	1693	2111300964367
86698	1693	2073957041485
86699	1693	2036613118603
86700	1693	1999269195721
86701	1693	1961925272839
86702	1693	1960783941847
86703	1693	1923440018965
86704	1693	1886096096083
86705	1693	1848752173201
86706	1693	1811408250319
86707	1693	1774064327437
86708	1693	1736720404555
86709	1693	1699376481673
86710	1693	1695406823191
86711	1693	1658062900309
86712	1693	1620718977427
86713	1693	1583375054545
86714	1693	1546031131663
86715	1693	1261627938084
86716	1693	1224284015202
86717	1693	1186940092320
86718	1693	1149596169438
86719	1693	1112252246556
86720	1693	1074908323674
86721	1693	1037564400792
86722	1693	1000220477910
86723	1693	962876555028
86724	1693	4676699798
86725	641	83620220000000
86726	641	83621171000000
86757	2133	97002012000
86758	1874	12400000
86759	1874	12403000
86760	1271	1347006435000000
86838	1397	1323138448000
86839	1678	21600733652000
86840	2133	96996000000
86841	1874	12430000
86842	2134	96572740000
86843	1874	12433000
86846	1397	1323128447000
86847	1678	21600733653000
86848	2134	96571737000
86849	1874	12436000
86850	1690	137524344000000
86901	1397	1323048439000
86902	1678	21600733661000
86903	2133	96986982000
86904	1874	12475000
86905	2134	96563713000
86906	1874	12478000
86907	1395	58123346663007706
86908	1395	58123346675007706
86948	1397	1323018436000
86949	1678	21600733664000
86950	2134	96560704000
86951	1874	12491000
86952	2133	96983976000
86953	1874	12493000
86954	1536	15840775999959
86956	1397	1323008435000
86957	1678	21600733665000
86958	2133	96982974000
86959	1874	12495000
86960	2134	96559701000
86961	1874	12498000
86962	1395	58124066675007706
86963	1395	58124066687007706
86970	1506	14401268967172
86975	1397	1322978432000
86976	1678	21600733668000
86977	1397	1322968431000
86978	1678	21600733669000
86979	2133	96979968000
86980	1874	12507000
86981	2133	96978966000
86982	1874	12509000
86983	2134	96557695000
86984	1874	12512000
86985	2134	96556692000
86986	1874	12515000
86987	1394	400326225000000
87059	1611	15903043000000
87060	1611	15903055000000
87198	1458	21693805908540
87199	1458	21693830908540
87210	1397	1322738408000
87211	1678	21600733692000
87212	2133	96954918000
87213	1874	12636000
87214	2134	96533623000
87215	1874	12639000
87216	1402	66814861319298
87217	1402	66814873319298
87247	1571	4607734601052
87248	1571	4607746601052
87276	2086	5039513000000
87278	2087	6479194000000
87279	2087	6479607000000
87340	633	84604134900000
86160	1397	1323508485000
86161	1678	21600733615000
86162	1397	1323498484000
86163	1678	21600733616000
86164	1693	4904644841424
86165	391	66649672116779
86166	1693	4867300918542
86167	690	66651272116779
86168	1693	4829956995660
86169	353	66650052116779
86170	1693	4828815664668
86171	731	2019735518605
86172	1693	4791471741786
86173	2164	649932922882
86174	1693	4754127818904
86175	180	66651272116779
86176	2134	96608848000
86177	1874	12251000
86178	2134	96607845000
86179	1874	12254000
86180	2133	97032072000
86181	1874	12256000
86182	2133	97031070000
86183	1874	12258000
86184	1560	20034451277001
86185	1560	20034595277001
86230	1874	12266000
86231	1601	6373526620000
86275	58	89706720999641
86276	1680	17289775500035
86391	1693	3400832941847
86392	745	2019735518605
86393	1397	1323438478000
86394	1678	21600733622000
86395	1693	3363489018965
86396	150	66651272116779
86397	1693	3326145096083
86398	92	66651272116779
86399	1693	3288801173201
86400	63	66651272116779
86401	1693	3251457250319
86402	450	66651272116779
86403	1693	3214113327437
86404	322	66651272116779
86405	2134	96601827000
86406	1874	12284000
86407	2133	97026060000
86408	1874	12286000
86409	1419	35019844280064
86410	1419	35019916280064
86449	1693	2552301246556
86450	78	66651272116779
86451	1693	2514957323674
86452	611	66651272116779
86453	1693	2477613400792
86454	205	66651272116779
86455	1693	2440269477910
86456	658	66651272116779
86457	1693	2402925555028
86458	194	66651272116779
86459	1397	1323408475000
86460	1678	21600733625000
86461	1397	1323398474000
86462	1678	21600733626000
86463	1693	1444725699798
86464	1276	1710695727448440
86465	1693	1407381776916
86466	660	66651272116779
86467	1693	1370037854034
86468	653	66651272116779
86469	1693	1332693931152
86470	622	66654252116779
86471	1693	1295350008270
86472	105	66651272116779
86473	1693	1258006085388
86474	122	66651272116779
86475	1693	1256864754396
86476	721	2019735518605
86477	2134	96598818000
86478	1874	12299000
86479	2133	97023054000
86480	1874	12301000
86481	2134	96597815000
86482	1874	12304000
86483	2133	97022052000
86484	1874	12306000
86485	1395	58121906495007706
86486	1395	58121906639007706
86547	1397	1323318466000
86548	1678	21600733634000
86549	2133	97014036000
86550	1874	12343000
86551	2134	96589791000
86552	1874	12346000
86553	2128	200000001
86554	149	84990283000340
86555	149	66000004010000
86556	212	84990294990340
86629	1397	1323268461000
86630	1678	21600733639000
86631	2134	96585779000
86632	1874	12366000
86633	2133	97009026000
86634	1874	12368000
86635	1711	21405352000000
86636	1711	21405364000000
86731	1874	12386000
86732	1680	17289714500035
86747	1637	228245375819988
86748	1637	228245397819988
86751	1397	1323198454000
86752	1678	21600733646000
86753	2134	96578758000
86754	1874	12397000
86755	1637	228965397819988
86756	1637	228965408819988
86761	1397	1323188453000
86762	1678	21600733647000
86763	2134	96577755000
86764	1874	12406000
86765	2133	97001010000
86766	1874	12408000
86783	1397	1323158450000
86784	1678	21600733650000
86785	2133	96998004000
86786	1874	12420000
86787	2134	96574746000
86788	1874	12423000
86791	1874	12227000
86792	1874	12229000
86793	1874	12232000
86794	1874	12235000
86795	1874	12240000
86796	1874	12242000
86797	1874	12250000
86798	1874	12252000
86799	1874	12259000
86800	1874	12262000
86801	1694	24494419077629
86802	1874	12277000
86803	1874	12280000
86804	1874	12283000
86805	1874	12289000
86806	1874	12292000
86807	1874	12295000
86808	1874	12298000
86809	1874	12307000
86810	1874	12310000
86811	1874	12313000
86812	1874	12319000
86813	1874	12322000
86814	1874	12325000
86815	1874	12337000
86816	1874	12340000
86817	1874	12352000
86818	1874	12355000
86819	1874	12358000
86820	1874	12364000
86821	1874	12367000
86822	1874	12369000
86823	1874	12371000
86824	1874	12381000
86825	1874	12387000
86826	1874	12389000
86827	1694	25214419077629
86828	1694	25214464077629
86911	1397	1323038438000
86912	1678	21600733662000
86913	1874	12393000
86914	1874	12395000
86915	1874	12399000
86916	1874	12401000
86917	1874	12405000
86918	1874	12407000
86919	1874	12409000
86920	1874	12411000
86921	1874	12413000
86922	1874	12417000
86923	1874	12419000
86924	1874	12421000
86925	2133	96985980000
86926	1874	12426000
86927	1874	12429000
86928	1874	12432000
86929	1874	12435000
86417	1397	1323418476000
86418	1678	21600733624000
86419	1693	3139425481673
86420	453	66651272116779
86421	1693	3135455823191
86422	29	7069074315355
86423	1693	3098111900309
86424	138	66651272116779
86425	1693	3060767977427
86426	146	66651272116779
86427	1693	3023424054545
86428	395	66148231116779
86429	1693	2986080131663
86430	587	66651272116779
86431	1693	2701676938084
86432	910	507738856265767
86433	1693	2664333015202
86434	1961	650184292006
86435	1693	2626989092320
86436	500	66651272116779
86437	1693	2589645169438
86438	504	66038202116779
86439	2133	97025058000
86440	1874	12288000
86441	2133	97024056000
86442	1874	12290000
86443	2134	96600824000
86444	1874	12293000
86445	2134	96599821000
86446	1874	12296000
86447	1701	13750447600056
86448	1701	13750581600056
86495	1397	1323378472000
86496	1678	21600733628000
86497	2134	96595809000
86498	1874	12314000
86499	2133	97020048000
86500	1874	12316000
86508	1448	10116798000001
86509	1448	10116810000001
86523	1397	1323348469000
86524	1678	21600733631000
86525	1397	1323338468000
86526	1678	21600733632000
86527	2133	97017042000
86528	1874	12328000
86529	2134	96592800000
86530	1874	12331000
86531	2134	96591797000
86532	1874	12334000
86533	2133	97016040000
86534	1874	12336000
86535	1395	58122626639007706
86536	1395	58122626663007706
86558	1508	20196710500009
86559	1508	20196722500009
86568	1693	5861968834936
86569	1693	5824624912054
86570	1693	5557560647826
86571	1693	5520216724944
86572	1693	5517378397456
86573	1693	5415218824799
86574	1693	5377874901917
86575	1693	5340530979035
86576	1693	5329660201471
86577	1693	5292316278589
86578	1693	5254972355707
86579	1693	5081403217703
86580	1693	5044059294821
86581	1693	4534419128596
86582	1693	4497075205714
86583	1693	4459731282832
86584	1693	4422387359950
86585	1693	4248818221946
86586	1693	4211474299064
86587	1693	4174130376182
86588	1693	4136786453300
86589	1693	4099442530418
86590	1693	4062098607536
86591	1693	4024754684654
86592	1693	3987410761772
86593	1693	3950066838890
86594	1693	3912722916008
86595	1693	3875378993126
86596	1693	3838035070244
86597	1693	3800691147362
86598	1693	3763347224480
86599	1693	3726003301598
86600	1693	3688659378716
86601	1693	3651315455834
86602	1693	3613971532952
86603	1693	3576627610070
86604	1693	3539283687188
86605	1693	3501939764306
86606	1719	19461920000000
86607	1719	20181920000000
86608	1719	20182080000000
86655	2133	97007022000
86656	1874	12375000
86657	2133	97006020000
86658	1874	12377000
86659	1874	12380000
86660	1874	12383000
86661	1727	18187270999999
86727	1874	12372000
86728	1874	12374000
86729	1874	12382000
86730	641	82900268000000
86733	1397	1323218456000
86734	1678	21600733644000
86735	1397	1323208455000
86736	1678	21600733645000
86737	2134	96580764000
86738	1874	12391000
86739	2134	96579761000
86740	1874	12394000
86741	2133	97004016000
86742	1874	12396000
86743	2133	97003014000
86744	1874	12398000
86745	1693	902166908632
86746	1693	902190908632
86769	1397	1323178452000
86770	1678	21600733648000
86771	1397	1323168451000
86772	1678	21600733649000
86773	2133	97000008000
86774	1874	12410000
86775	2133	96999006000
86776	1874	12412000
86777	2134	96576752000
86778	1874	12415000
86779	2134	96575749000
86780	1874	12418000
86781	1715	16586814436096
86782	1715	16586838436096
86836	1394	397446141000000
86837	1394	397446153000000
86893	1397	1323058440000
86894	1678	21600733660000
86895	2133	96987984000
86896	1874	12470000
86897	2134	96564716000
86898	1874	12473000
86899	1679	23039177653000
86900	1679	23039189653000
87001	1397	1322938428000
87002	1678	21600733672000
87003	2133	96975960000
87004	1874	12527000
87005	1726	58947112000
87006	2231	200000000
87007	2134	96553683000
87008	1874	12530000
87009	2132	148306307000
87010	1874	12531000
87011	1726	57746112000
87012	2232	200000000
87013	1726	56545112000
87014	2184	2599000000
87015	1726	55344112000
87016	2206	2599000000
87017	1726	54143112000
87018	2205	2599000000
87019	1726	52942112000
87020	2185	1399000000
87021	1991	22076037441475
87024	641	83620232000000
87025	641	83620251000000
87051	1397	1322928427000
87052	1678	21600733673000
87053	2134	96552680000
87054	1874	12534000
87055	2133	96974958000
87056	1874	12536000
87057	1395	58124786687007706
87058	1395	58124786699007706
87069	1397	1322908425000
87070	1678	21600733675000
87071	2133	96972954000
87072	1874	12543000
87073	2134	96550674000
87074	1874	12546000
87075	2134	96549671000
87076	1874	12549000
86867	1397	1323098444000
86868	1678	21600733656000
86869	1397	1323088443000
86870	1678	21600733657000
86871	1397	1323078442000
86872	1678	21600733658000
86873	1397	1323068441000
86874	1678	21600733659000
86875	2133	96991992000
86876	1874	12450000
86877	2134	96568728000
86878	1874	12453000
86879	2134	96567725000
86880	1874	12456000
86881	2134	96566722000
86882	1874	12459000
86883	2134	96565719000
86884	1874	12462000
86885	2133	96990990000
86886	1874	12464000
86887	2133	96989988000
86888	1874	12466000
86889	2133	96988986000
86890	1874	12468000
86891	1394	398886153000000
86892	1394	398886201000000
86909	1394	400326201000000
86910	1394	400326213000000
86939	1874	12481000
86940	632	76941281000000
86947	1637	228965409819988
86955	1536	15840765999959
86988	1397	1322958430000
86989	1678	21600733670000
86990	2134	96555689000
86991	1874	12518000
86992	2133	96977964000
86993	1874	12520000
86994	1397	1322948429000
86995	1678	21600733671000
86996	2134	96554686000
86997	1874	12523000
86998	2133	96976962000
86999	1874	12525000
87000	1560	20034463277001
87061	1397	1322918426000
87062	1678	21600733674000
87063	2134	96551677000
87064	1874	12539000
87065	2133	96973956000
87066	1874	12541000
87067	1727	18907270999999
87068	1727	18907282999999
87099	1397	1322878422000
87100	1678	21600733678000
87101	2134	96546662000
87102	1874	12566000
87103	2133	96968946000
87104	1874	12568000
87105	111	69600052000000
87106	111	69600064000000
87163	1513	30960973000000
87164	1513	30960985000000
87218	1397	1322728407000
87219	1678	21600733693000
87220	2134	96532620000
87221	1874	12642000
87222	2133	96953916000
87223	1874	12644000
87224	1394	404646250000000
87225	1394	404646262000000
87228	1397	1322718406000
87229	1678	21600733694000
87230	2134	96531617000
87231	1874	12647000
87232	2133	96952914000
87233	1874	12649000
87234	2132	148299300000
87235	1874	12650000
87236	369	87396742000000
87237	369	87396755000000
87387	1397	1322498384000
87388	1678	21600733716000
87389	2134	96510554000
87390	1874	12725000
87391	1637	229685408819988
87392	1637	229685419819988
87404	2233	170000000
87405	2233	160000000
87406	1688	63360495905200
87407	1397	1322478382000
87408	1678	21600733718000
87409	1397	1322468381000
87410	1678	21600733719000
87411	2134	96508548000
87412	1874	12732000
87413	2134	96507545000
87414	1874	12735000
87415	1688	64080495905200
87416	1688	64080517905200
87419	1397	1322458380000
87420	1678	21600733720000
87421	2134	96506542000
87422	1874	12738000
87423	1555	12435363979096
87444	1397	1322428377000
87445	1678	21600733723000
87446	2133	96946902000
87447	1874	12751000
87448	1678	22320733723000
87449	1678	22320744723000
87452	2133	96945900000
87453	1874	12753000
87454	2132	148290291000
87455	1874	12754000
87456	2134	96503533000
87457	1874	12757000
87458	1696	19937546835100
87459	1696	19937549835100
87494	1397	1322388373000
87495	1678	22320744727000
87496	2133	96941892000
87497	1874	12775000
87498	2134	96499521000
87499	1874	12778000
87500	1694	24492745127629
87501	1694	24492757127629
87528	1559	16522833000000
87529	1559	16522846000000
87579	1695	2824930999000
87580	1695	2824945999000
87597	1657	15841493990100
87601	1397	1322288363000
87602	1678	22320744737000
87603	2133	96931872000
87604	1874	12828000
87605	2134	96489491000
87606	1874	12831000
87607	1726	49339112000
87608	2236	200000000
87609	1701	6968078253479
87610	1162	612314712579855
87611	1701	1438084500103
87612	1288	1706269390592464
87613	1688	65520540905200
87614	1688	65520555905200
87654	1440	17279349049920
87655	1440	17999351049920
87717	1759	18000969999889
87720	1397	1322178352000
87721	1678	22320744748000
87722	2133	96920850000
87723	1874	12886000
87724	2134	96478458000
87725	1874	12889000
87726	484	72908869000000
87738	1874	12892000
87739	337	68880043000000
87740	337	68880054000000
87762	1397	1322138348000
87763	1678	22320744752000
87764	2133	96916842000
87765	1874	12904000
87766	2134	96475449000
87767	1874	12907000
87768	1508	20916722500009
87769	1508	20916734500009
87797	1397	1322108345000
87798	1678	22320744755000
87799	2133	96913836000
87800	1874	12920000
87801	2134	96472440000
87802	1874	12923000
87803	1560	20754463277001
87804	1560	20754475277001
87805	1419	35019856280064
87808	1397	1322098344000
87809	1678	22320744756000
87810	1397	1322088343000
87811	1678	22320744757000
87812	2134	96471437000
87813	1874	12926000
87814	2134	96470434000
87815	1874	12929000
87816	2132	148280281000
86930	1874	12447000
86931	1874	12465000
86932	1874	12471000
86933	1874	12474000
86934	1874	12477000
86935	1874	12480000
86936	2134	96562710000
86937	1874	12483000
86938	632	76941614000000
86941	1397	1323028437000
86942	1678	21600733663000
86943	2134	96561707000
86944	1874	12486000
86945	2133	96984978000
86946	1874	12488000
86964	1397	1322998434000
86965	1678	21600733666000
86966	2133	96981972000
86967	1874	12500000
86968	2134	96558698000
86969	1874	12503000
86971	1397	1322988433000
86972	1678	21600733667000
86973	2133	96980970000
86974	1874	12505000
87022	641	84341171000000
87023	641	84341177000000
87026	1874	12392000
87027	1874	12424000
87028	1874	12427000
87029	1874	12431000
87030	1874	12437000
87031	1874	12439000
87032	1874	12443000
87033	1874	12445000
87034	1874	12452000
87035	1874	12454000
87036	1874	12458000
87037	1874	12460000
87038	1874	12489000
87039	1874	12492000
87040	1874	12501000
87041	1874	12504000
87042	1874	12510000
87043	641	82900615000000
87044	1874	12513000
87045	1874	12516000
87046	1874	12519000
87047	1874	12522000
87048	1874	12528000
87049	641	83620615000000
87050	641	83620622000000
87083	1397	1322898424000
87084	1678	21600733676000
87085	1397	1322888423000
87086	1678	21600733677000
87087	2132	148304305000
87088	1874	12553000
87089	2134	96548668000
87090	1874	12556000
87091	2134	96547665000
87092	1874	12559000
87093	2133	96970950000
87094	1874	12561000
87095	2133	96969948000
87096	1874	12563000
87097	1679	23759189653000
87098	1679	23759214653000
87121	1397	1322848419000
87122	1678	21600733681000
87123	1397	1322838418000
87124	1678	21600733682000
87125	2132	148303304000
87126	1874	12579000
87127	2134	96543653000
87128	1874	12582000
87129	2134	96542650000
87130	1874	12585000
87131	2133	96965940000
87132	1874	12587000
87133	2133	96964938000
87134	1874	12589000
87135	1727	19627282999999
87136	1727	19627307999999
87138	1397	1322828417000
87139	1678	21600733683000
87140	1397	1322818416000
87141	1678	21600733684000
87142	1397	1322808415000
87143	1678	21600733685000
87144	2133	96963936000
87145	1874	12591000
87146	2133	96962934000
87147	1874	12593000
87148	2133	96961932000
87149	1874	12595000
87150	2134	96541647000
87151	1874	12598000
87152	2134	96540644000
87153	1874	12601000
87154	2132	148302303000
87155	1874	12602000
87156	1476	20160397000000
87157	1397	1322798414000
87158	1678	21600733686000
87159	2133	96960930000
87160	1874	12604000
87161	2134	96539641000
87162	1874	12607000
87182	1397	1322768411000
87183	1678	21600733689000
87184	1397	1322758410000
87185	1678	21600733690000
87186	2134	96536632000
87187	1874	12621000
87188	1726	51741112000
87189	2233	200000000
87190	2134	96535629000
87191	1874	12624000
87192	2133	96957924000
87193	1874	12626000
87194	2133	96956922000
87195	1874	12628000
87196	1622	22860463000005
87197	1622	22860488000005
87226	1513	31680985000000
87227	1513	31680997000000
87244	2134	96530614000
87245	1874	12655000
87246	1688	64080487905200
87258	1695	9742230999000
87259	1330	1706840637751650
87260	1695	7434130999000
87261	1204	612520750000000
87262	1695	4014030999000
87263	1084	907813465000000
87264	1695	2104930999000
87265	964	506595775000000
87266	1397	1322688403000
87267	1678	21600733697000
87268	2134	96528608000
87269	1874	12663000
87270	2132	148298299000
87271	1874	12664000
87272	2133	96949908000
87273	1874	12666000
87274	1593	24310453000000
87275	1593	24310866000000
87277	1699	7990251750126
87312	1693	1622178908632
87313	1693	1622224908632
87322	1397	1322608395000
87323	1678	21600733705000
87324	1397	1322598394000
87325	1678	21600733706000
87326	2134	96520584000
87327	1874	12692000
87328	2134	96519581000
87329	1874	12695000
87330	1515	1440028603400
87331	1515	1440050603400
87332	1397	1322588393000
87333	1678	21600733707000
87334	2132	148295296000
87335	1874	12696000
87336	2134	96518578000
87337	1874	12699000
87338	1679	24479214653000
87339	1679	24479226653000
87343	1397	1322578392000
87344	1678	21600733708000
87345	1395	58126946746007706
87346	1395	58126946756007706
87347	1397	1322568391000
87348	1678	21600733709000
87349	2134	96517575000
87350	1874	12702000
87351	1681	16343420759830
87352	1681	16343431759830
87353	1397	1322558390000
87354	1678	21600733710000
87355	2134	96516572000
87356	1874	12705000
87357	1716	21646961000000
87358	1716	21646972000000
87077	2133	96971952000
87078	1874	12551000
87079	2132	148305306000
87080	1874	12552000
87081	1599	21940412393047
87082	1599	21940427393047
87107	1397	1322868421000
87108	1678	21600733679000
87109	2134	96545659000
87110	1874	12571000
87111	2133	96967944000
87112	1874	12573000
87113	1397	1322858420000
87114	1678	21600733680000
87115	2134	96544656000
87116	1874	12576000
87117	2133	96966942000
87118	1874	12578000
87119	1394	401766225000000
87120	1394	401766237000000
87137	1395	58124786712007706
87165	1397	1322788413000
87166	1678	21600733687000
87167	1397	1322778412000
87168	1678	21600733688000
87169	2132	148301302000
87170	1874	12608000
87171	2133	96959928000
87172	1874	12610000
87173	2133	96958926000
87174	1874	12612000
87175	2134	96538638000
87176	1874	12615000
87177	1685	134642798571430
87178	2134	96537635000
87179	1874	12618000
87180	1685	135362798571430
87181	1685	135362799571430
87200	1397	1322748409000
87201	1678	21600733691000
87202	2132	148300301000
87203	1874	12629000
87204	2133	96955920000
87205	1874	12631000
87206	2134	96534626000
87207	1874	12634000
87208	1394	403206237000000
87209	1394	403206250000000
87238	1397	1322708405000
87239	1678	21600733695000
87240	2133	96951912000
87241	1874	12652000
87242	1605	1440046000000
87243	1605	1440057000000
87249	1605	1440058000000
87250	1397	1322698404000
87251	1678	21600733696000
87252	2133	96950910000
87253	1874	12657000
87254	2134	96529611000
87255	1874	12660000
87256	1402	67534873319298
87257	1402	67534885319298
87280	1397	1322678402000
87281	1678	21600733698000
87282	1397	1322668401000
87283	1678	21600733699000
87284	2134	96527605000
87285	1874	12669000
87286	2134	96526602000
87287	1874	12672000
87288	1395	58125506712007706
87289	1395	58125506734007706
87290	1397	1322658400000
87291	1678	21600733700000
87292	1397	1322648399000
87293	1678	21600733701000
87294	1397	1322638398000
87295	1678	21600733702000
87296	1397	1322628397000
87297	1678	21600733703000
87298	1605	57000000
87299	1931	5034486000000
87300	2132	148297298000
87301	1874	12673000
87302	2134	96525599000
87303	1874	12676000
87304	2134	96524596000
87305	1874	12679000
87306	2134	96523593000
87307	1874	12682000
87308	2134	96522590000
87309	1874	12685000
87310	1467	15086833100039
87311	1467	15086879100039
87314	1397	1322618396000
87315	1678	21600733704000
87316	2132	148296297000
87317	1874	12686000
87318	2134	96521587000
87319	1874	12689000
87320	1395	58126226734007706
87321	1395	58126226746007706
87342	243	68880062000000
87393	1395	58127666756007706
87394	1395	58127666767007706
87424	1397	1322448379000
87425	1678	21600733721000
87426	2233	149999999
87427	2203	120000001
87428	2133	96948906000
87429	1874	12740000
87430	2132	148291292000
87431	1874	12741000
87432	2134	96505539000
87433	1874	12744000
87434	1688	64800517905200
87435	1688	64800540905200
87460	1423	5073299999985
87461	1423	5073302999985
87466	1749	10085382930000
87467	1749	10085385930000
87468	1397	1322418376000
87469	1678	22320744724000
87470	2134	96502530000
87471	1874	12760000
87472	2133	96944898000
87473	1874	12762000
87474	1637	229685420819988
87483	1457	22944471040000
87502	1397	1322378372000
87503	1678	22320744728000
87504	2134	96498518000
87505	1874	12781000
87506	2133	96940890000
87507	1874	12783000
87508	1656	21021728999990
87509	1656	21021740999990
87510	1397	1322368371000
87511	1678	22320744729000
87512	2134	96497515000
87513	1874	12786000
87514	2133	96939888000
87515	1874	12788000
87516	1447	17433625943000
87517	1447	17433637943000
87538	1397	1322338368000
87539	1678	22320744732000
87540	1397	1322328367000
87541	1678	22320744733000
87542	2134	96494506000
87543	1874	12802000
87544	2134	96493503000
87545	1874	12805000
87546	2133	96936882000
87547	1874	12807000
87548	2133	96935880000
87549	1874	12809000
87550	2132	148287288000
87551	1874	12810000
87552	1724	18657507500000
87559	1397	1322318366000
87560	1678	22320744734000
87561	2133	96934878000
87562	1874	12812000
87563	1701	13535123874296
87564	267	66478788050691
87598	1724	19377507500000
87599	1724	19377531500000
87626	1397	1322268361000
87627	1678	22320744739000
87628	2134	96487485000
87629	1874	12839000
87630	1727	16666881999999
87631	908	506720815000000
87632	1727	12652180999999
87633	1028	908039275000000
87634	2133	96929868000
87635	1874	12841000
87636	1395	58129106879007706
87637	1395	58129106893007706
87656	2097	17999351045924
87657	1440	200004018
87718	1764	15126970100000
87719	1764	15127062100000
87341	633	84604146900000
87359	1422	15265186860211
87360	1422	15265197860211
87361	1397	1322548389000
87362	1678	21600733711000
87363	1397	1322538388000
87364	1678	21600733712000
87365	1397	1322528387000
87366	1678	21600733713000
87367	2134	96515569000
87368	1874	12708000
87369	2132	148294295000
87370	1874	12709000
87371	2134	96514566000
87372	1874	12712000
87373	2134	96513563000
87374	1874	12715000
87375	1698	19977190550035
87395	2233	180000000
87396	2203	120000000
87397	1397	1322488383000
87398	1678	21600733717000
87399	2134	96509551000
87400	1874	12728000
87401	2132	148292293000
87402	1874	12729000
87403	1692	38660623619999
87436	1397	1322438378000
87437	1678	21600733722000
87438	2134	96504536000
87439	1874	12747000
87440	2133	96947904000
87441	1874	12749000
87442	1686	18932192550062
87443	1686	18932204550062
87464	1601	7813608620000
87465	1601	7813611620000
87475	1397	1322408375000
87476	1678	22320744725000
87477	2133	96943896000
87478	1874	12764000
87479	2134	96501527000
87480	1874	12767000
87481	1663	1440020000000
87482	1663	1440032000000
87553	1695	9022218999000
87554	1695	6714118999000
87555	1695	3294018999000
87556	1695	1384918999000
87557	1724	18658092500000
87558	1724	19378092500000
87565	1397	1322308365000
87566	1678	22320744735000
87567	2134	96492500000
87568	1874	12815000
87569	2134	96491497000
87570	1874	12818000
87571	1726	50540112000
87572	2235	200000000
87573	1701	11893806916880
87574	922	506425108194437
87575	2133	96933876000
87576	1874	12820000
87577	1992	18719416990000
87578	1992	18719431990000
87592	2134	96490494000
87593	1874	12824000
87594	1874	12826000
87595	1670	22321259000000
87596	1670	22321283000000
87617	623	66719940000000
87618	1397	1322278362000
87619	1678	22320744738000
87620	2133	96930870000
87621	1874	12833000
87622	2134	96488488000
87623	1874	12836000
87624	1395	58128386767007706
87625	1395	58128386879007706
87651	1688	65520567905200
87652	1688	66240567905200
87653	1688	66240569905200
87665	1397	1322238358000
87666	1678	22320744742000
87667	2233	119999999
87668	2203	140000001
87669	2134	96484476000
87670	1874	12855000
87671	2133	96926862000
87672	1874	12857000
87673	1394	407526274000000
87674	1394	66000001100200
87675	167	407526295500000
87676	1727	2395169999999
87677	1274	1707265437751650
87678	1727	2101059999999
87679	1986	516610000000
87680	2233	89999999
87681	2203	160000001
87682	1397	1322228357000
87683	1678	22320744743000
87684	1397	1322218356000
87685	1678	22320744744000
87686	1397	1322208355000
87687	1678	22320744745000
87688	1397	1322198354000
87689	1678	22320744746000
87690	1397	1322188353000
87691	1678	22320744747000
87692	2132	148284285000
87693	1874	12858000
87694	2134	96483473000
87695	1874	12861000
87696	2132	148283284000
87697	1874	12862000
87698	2133	96925860000
87699	1874	12864000
87700	2133	96924858000
87701	1874	12866000
87702	2133	96923856000
87703	1874	12868000
87704	2133	96922854000
87705	1874	12870000
87706	2133	96921852000
87707	1874	12872000
87708	2134	96482470000
87709	1874	12875000
87710	2134	96481467000
87711	1874	12878000
87712	2134	96480464000
87713	1874	12881000
87714	2134	96479461000
87715	1874	12884000
87716	1471	22939957900000
87755	641	84340264000000
87756	1397	1322148349000
87757	1678	22320744751000
87758	2133	96917844000
87759	1874	12902000
87760	1688	66960567905200
87761	1688	66960578905200
87786	1727	15946869999999
87787	1727	11932168999999
87788	1727	9223367999999
87789	1727	1675166999999
87790	1727	1381065999999
87791	1874	12414000
87792	1874	12416000
87793	1874	12422000
87794	1874	12434000
87795	1560	20754451277001
87796	1560	20755006277001
87806	1874	12921000
87807	1419	35019855280064
87834	1397	1322068341000
87835	1678	22320744759000
87836	2134	96468428000
87837	1874	12942000
87838	2133	96909828000
87839	1874	12944000
87840	1593	24310465000000
87897	1637	230405420819988
87898	1637	230405433819988
87911	1458	20973818908540
87912	1458	21693818908540
87941	1397	1321968331000
87942	1678	23040756769000
87943	1397	1321958330000
87944	1678	23040756770000
87945	1397	1321948329000
87946	1678	23040756771000
87947	2132	148276277000
87948	1874	12993000
87949	2134	96458398000
87950	1874	12996000
87951	2134	96457395000
87952	1874	12999000
87953	2134	96456392000
87954	1874	13002000
87955	2133	96899808000
87956	1874	13004000
87957	2133	96898806000
87958	1874	13006000
87959	2133	96897804000
87960	1874	13008000
87376	1397	1322518386000
87377	1678	21600733714000
87378	1397	1322508385000
87379	1678	21600733715000
87380	2132	148293294000
87381	1874	12716000
87382	2134	96512560000
87383	1874	12719000
87384	2134	96511557000
87385	1874	12722000
87386	606	80398060812962
87417	1555	12435352979096
87418	1555	12435753979096
87450	1692	39380623619999
87451	1692	39380634619999
87462	1476	20880397000000
87463	1476	20880400000000
87484	1397	1322398374000
87485	1678	22320744726000
87486	2134	96500524000
87487	1874	12770000
87488	2133	96942894000
87489	1874	12772000
87490	2132	148289290000
87491	1874	12773000
87492	1402	68254885319298
87493	1402	68254898319298
87518	1397	1322358370000
87519	1678	22320744730000
87520	2132	148288289000
87521	1874	12789000
87522	2133	96938886000
87523	1874	12791000
87524	2134	96496512000
87525	1874	12794000
87526	1402	68974898319298
87527	1402	68974911319298
87530	1397	1322348369000
87531	1678	22320744731000
87532	2133	96937884000
87533	1874	12796000
87534	2134	96495509000
87535	1874	12799000
87536	1992	17999404990000
87537	1992	17999416990000
87581	1397	1322298364000
87582	1678	22320744736000
87583	1985	1196990000000
87584	1701	8952581783976
87585	1042	907509454834100
87586	2132	148286287000
87587	1874	12821000
87588	2133	96932874000
87589	1874	12823000
87590	1394	406086262000000
87591	1394	406086285000000
87600	1724	20098092500000
87615	1650	12994220000000
87616	1650	12994235000000
87638	1397	1322258360000
87639	1678	22320744740000
87640	1727	9943379999999
87641	1148	612672289000000
87642	2133	96928866000
87643	1874	12843000
87644	350	66000012000000
87645	2134	96486482000
87646	1874	12846000
87647	2132	148285286000
87648	1874	12847000
87649	350	66720012000000
87650	350	66720014000000
87658	1397	1322248359000
87659	1678	22320744741000
87660	2134	96485479000
87661	1874	12850000
87662	2133	96927864000
87663	1874	12852000
87664	1394	406086274000000
87729	1690	138244344000000
87730	1690	138244356000000
87731	1397	1322168351000
87732	1678	22320744749000
87733	2133	96919848000
87734	1874	12891000
87735	2134	96477455000
87736	1874	12894000
87737	1688	66240555905200
87751	1727	2395178999999
87752	1727	2101077999999
87753	641	84340251000000
87754	641	84340393000000
87830	2134	96469431000
87831	1874	12937000
87832	1874	12939000
87833	1622	23580500000005
87881	1694	25212757127629
87882	1694	25212822127629
87895	1555	13155363979096
87896	1555	13155376979096
87901	1397	1322008335000
87902	1678	22320744765000
87903	2133	96903816000
87904	1874	12973000
87905	1727	0
87906	2237	2100058999999
87907	2134	96462410000
87908	1874	12976000
87909	369	87396768000000
87910	369	88116768000000
87913	1739	28799828000000
87914	1739	29519828000000
87930	1714	18886609103056
87975	1637	231125445819988
87976	1637	231125557819988
87977	1455	9492917000000
87978	966	506675775000000
87979	1455	6831817000000
87980	1086	907959465000000
87981	1397	1321928327000
87982	1678	23040756773000
87983	2134	96454386000
87984	1874	13016000
87985	2132	148275276000
87986	1874	13017000
87987	2133	96895800000
87988	1874	13019000
87989	1850	20079391000000
88009	1643	2262511437200
88010	1299	1704974641817750
88011	1397	1321898324000
88012	1678	23040756776000
88013	2134	96451377000
88014	1874	13032000
88015	2133	96892794000
88016	1874	13034000
88017	2132	148274275000
88018	1874	13035000
88019	1457	23664471040000
88020	1457	23664494040000
88047	1714	18886618103056
88064	2133	96887784000
88065	1874	13058000
88066	1688	69120675905200
88067	1688	69120676905200
88076	1637	231125457819988
88085	1397	1321828317000
88086	1678	23040756783000
88087	2134	96444356000
88088	1874	13072000
88089	2133	96884778000
88090	1874	13074000
88091	1422	15985197860211
88092	1422	15985209860211
88095	1397	1321818316000
88096	1678	23040756784000
88097	2133	96883776000
88098	1874	13073000
88099	1874	13076000
88100	2134	96443353000
88101	1874	13079000
88102	1467	15806879100039
88103	1467	15806902100039
88136	1717	18828183000023
88137	1717	18828195000023
88217	1397	1321748309000
88218	1678	23040756791000
88219	1397	1321738308000
88220	1678	23040756792000
88221	2133	96877764000
88222	1874	13111000
88223	2134	96436332000
88224	1874	13114000
88225	2134	96435329000
88226	1874	13117000
88227	2133	96876762000
88228	1874	13119000
88229	2132	148269270000
88230	1874	13120000
88231	1637	231845482819988
88232	1397	1321728307000
88233	1678	23040756793000
88234	1397	1321718306000
88235	1678	23040756794000
88236	1571	3839779792276
87727	1611	16623055000000
87728	1611	16623067000000
87741	1397	1322158350000
87742	1678	22320744750000
87743	2133	96918846000
87744	1874	12896000
87745	2132	148282283000
87746	1874	12897000
87747	2134	96476452000
87748	1874	12900000
87749	1706	16052344600135
87750	1706	16052357600135
87770	1397	1322128347000
87771	1678	22320744753000
87772	1397	1322118346000
87773	1678	22320744754000
87774	2132	148281282000
87775	1874	12908000
87776	2133	96915840000
87777	1874	12910000
87778	2133	96914838000
87779	1874	12912000
87780	2134	96474446000
87781	1874	12915000
87782	2134	96473443000
87783	1874	12918000
87784	1685	136082799571430
87785	1685	136082824571430
87824	1397	1322078342000
87825	1678	22320744758000
87826	2133	96910830000
87827	1874	12936000
87828	1622	23580488000005
87829	1622	23580499000005
87857	1397	1322038338000
87858	1678	22320744762000
87859	1711	18851854000000
87860	1001	507702275000000
87861	1711	15764344000000
87862	1241	613859250000000
87863	1711	11188834000000
87864	1121	909797965000000
87865	1397	1322028337000
87866	1678	22320744763000
87867	1711	2586324000000
87868	1367	1710571137751650
87869	2133	96906822000
87870	1874	12957000
87871	2134	96465419000
87872	1874	12960000
87873	2134	96464416000
87874	1874	12963000
87875	2133	96905820000
87876	1874	12965000
87877	2132	148278279000
87878	1874	12966000
87879	1688	67680578905200
87880	1688	67680643905200
87893	1688	68400643905200
87894	1688	68400656905200
87915	1397	1321998334000
87916	1678	22320744766000
87917	1397	1321988333000
87918	1678	22320744767000
87919	2134	96461407000
87920	1874	12979000
87921	2134	96460404000
87922	1874	12982000
87923	2133	96902814000
87924	1874	12984000
87925	2133	96901812000
87926	1874	12986000
87927	2132	148277278000
87928	1874	12987000
87929	1637	230405445819988
87939	1678	23040744768000
87940	1678	23040756768000
87963	58	89706685999641
87973	1536	16560775999959
87974	1536	16560887999959
87992	1455	5035717000000
87993	1206	612618750000000
87994	1397	1321918326000
87995	1678	23040756774000
87996	2133	96894798000
87997	1874	13021000
87998	2134	96453383000
87999	1874	13024000
88000	606	81118060812962
88001	606	81118172812962
88003	1397	1321908325000
88004	1678	23040756775000
88005	2134	96452380000
88006	1874	13027000
88007	2133	96893796000
88008	1874	13029000
88032	1643	1148524914700
88033	933	506041764067500
88034	1397	1321878322000
88035	1678	23040756778000
88036	1397	1321868321000
88037	1678	23040756779000
88038	2134	96449371000
88039	1874	13043000
88040	2134	96448368000
88041	1874	13046000
88042	2133	96890790000
88043	1874	13048000
88044	2133	96889788000
88045	1874	13050000
88046	1670	22321293000000
88058	1455	31617000000
88059	1332	1707114637751650
88060	1727	18000000
88061	641	85060393000000
88062	641	85060975000000
88069	1397	1321848319000
88070	1678	23040756781000
88071	2133	96886782000
88072	1874	13060000
88073	2134	96446362000
88074	1874	13063000
88075	1394	410406320500000
88077	1397	1321838318000
88078	1678	23040756782000
88079	2134	96445359000
88080	1874	13066000
88081	2132	148272273000
88082	1874	13067000
88083	2133	96885780000
88084	1874	13069000
88126	1611	17343067000000
88127	1611	17343078000000
88134	1688	69840676905200
88135	1688	69840688905200
88141	1685	136802824571430
88142	1685	136802836571430
88211	1397	1321758310000
88212	1678	23040756790000
88213	2134	96437335000
88214	1874	13107000
88215	2133	96878766000
88216	1874	13109000
88348	1547	16414666000000
88349	1678	21600733769000
88350	1678	21600733770000
88351	1678	21600733771000
88352	1678	21600733772000
88353	1678	21600733773000
88354	1678	21600733774000
88355	1678	21600733775000
88356	1678	21600733776000
88357	1678	21600733777000
88358	1678	21600733778000
88359	1678	21600733779000
88360	1678	21600733780000
88361	1678	21600733781000
88362	1678	21600733782000
88363	1678	21600733783000
88364	1547	17134666000000
88365	1547	17135696000000
88382	1691	19403358100019
88383	1691	19403370100019
88392	1395	58131266918007706
88393	1395	58131266930007706
88396	1397	1321568291000
88397	1678	23040756809000
88398	2134	96418278000
88399	1874	13207000
88400	2133	96859728000
88401	1874	13209000
88402	2132	148264265000
88403	1874	13210000
88404	1522	18334301000000
88421	1397	1321538288000
88422	1678	23040756812000
88423	1397	1321528287000
88424	1678	23040756813000
88425	2132	148263264000
88426	1874	13221000
88427	2134	96415269000
88428	1874	13224000
88429	2133	96856722000
88430	1874	13226000
88431	2133	96855720000
87817	1874	12930000
87818	2133	96912834000
87819	1874	12932000
87820	2133	96911832000
87821	1874	12934000
87822	1649	25484381999992
87823	1649	25484406999992
87841	1397	1322058340000
87842	1678	22320744760000
87843	1397	1322048339000
87844	1678	22320744761000
87845	2132	148279280000
87846	1874	12945000
87847	2133	96908826000
87848	1874	12947000
87849	2133	96907824000
87850	1874	12949000
87851	2134	96467425000
87852	1874	12952000
87853	2134	96466422000
87854	1874	12955000
87855	1768	18590920110000
87856	1768	18590945110000
87883	1397	1322018336000
87884	1678	22320744764000
87885	2233	88969999
87886	2203	160030001
87887	2133	96904818000
87888	1874	12968000
87889	2134	96463413000
87890	1874	12971000
87891	1394	408966295500000
87892	1394	408966308500000
87899	1395	58129826893007706
87900	1395	58129826906007706
87931	1397	1321978332000
87932	1678	22320744768000
87933	2133	96900810000
87934	1874	12989000
87935	2134	96459401000
87936	1874	12992000
87937	1675	18142323999977
87938	1675	18142335999977
87964	1455	10978017000000
87965	2011	1475000000000
87966	1397	1321938328000
87967	1678	23040756772000
87968	2133	96896802000
87969	1874	13010000
87970	2134	96455389000
87971	1874	13013000
87972	1394	410406420500000
88021	1397	1321888323000
88022	1678	23040756777000
88023	1643	1763586477100
88024	1053	906821162404900
88025	1643	1426948612000
88026	1173	611850449546800
88027	2133	96891792000
88028	1874	13037000
88029	2134	96450374000
88030	1874	13040000
88031	1688	68400675905200
88048	1397	1321858320000
88049	1678	23040756780000
88050	2133	96888786000
88051	1874	13052000
88052	2132	148273274000
88053	1874	13053000
88054	2134	96447365000
88055	1874	13056000
88056	641	85060264000000
88057	641	85060277000000
88105	1402	68974921319298
88116	1637	231845457819988
88117	1637	231845470819988
88124	1395	58130546906007706
88125	1395	58130546917007706
88128	1397	1321788313000
88129	1678	23040756787000
88130	2133	96881772000
88131	1874	13090000
88132	2134	96440344000
88133	1874	13093000
88139	632	77661281000000
88140	632	77661293000000
88143	1711	18131842000000
88144	1711	15044332000000
88145	1711	10468822000000
88146	632	76942864000000
88147	1711	1866312000000
88148	1678	21600733724000
88149	1678	21600733725000
88150	1678	21600733726000
88151	1678	21600733727000
88152	1678	21600733728000
88153	1678	21600733729000
88154	1678	21600733730000
88155	1678	21600733731000
88156	1678	21600733732000
88157	1678	21600733733000
88158	1678	21600733734000
88159	1678	21600733735000
88160	1678	21600733736000
88161	1678	21600733737000
88162	1678	21600733738000
88163	1678	21600733739000
88164	1678	21600733740000
88165	1678	21600733741000
88166	1678	21600733742000
88167	1678	21600733743000
88168	1678	21600733744000
88169	1678	21600733745000
88170	1678	21600733746000
88171	1678	21600733747000
88172	1678	21600733748000
88173	1678	21600733749000
88174	1678	21600733750000
88175	1678	21600733751000
88176	1678	21600733752000
88177	1678	21600733753000
88178	1678	21600733754000
88179	1678	21600733755000
88180	1678	21600733756000
88181	1678	21600733757000
88182	1678	21600733758000
88183	1678	21600733759000
88184	1678	21600733760000
88185	1678	21600733761000
88186	1678	21600733762000
88187	1678	21600733763000
88188	1678	21600733764000
88189	1678	21600733765000
88190	1678	21600733766000
88191	1678	21600733767000
88192	1678	21600733768000
88193	632	77662864000000
88194	632	77663764000000
88264	1690	138244431000000
88274	1764	15126982100000
88324	1874	13158000
88325	606	81838213812962
88374	1397	1321588293000
88375	1678	23040756807000
88376	2133	96861732000
88377	1874	13196000
88378	2134	96420284000
88379	1874	13199000
88380	1547	17853559000000
88381	1547	17853571000000
88384	1397	1321578292000
88385	1678	23040756808000
88386	2134	96419281000
88387	1874	13202000
88388	2133	96860730000
88389	1874	13204000
88390	1622	24300500000005
88391	1622	24300512000005
88407	1397	1321558290000
88408	1678	23040756810000
88409	1397	1321548289000
88410	1678	23040756811000
88411	2133	96858726000
88412	1874	13212000
88413	2133	96857724000
88414	1874	13214000
88415	2134	96417275000
88416	1874	13217000
88417	2134	96416272000
88418	1874	13220000
88419	1394	411846328500000
88420	1394	411846352500000
88445	1394	413286352500000
88446	1394	413286364500000
88463	1471	24380170900000
88464	1471	24380195900000
88467	1690	138964431000000
88468	1690	138964456000000
88518	2134	96405239000
88519	1874	13279000
88520	2119	198000000
88521	2133	96845700000
88522	1874	13281000
88523	1395	58131266921007706
88525	1397	1321428277000
87961	1394	410406308500000
87962	1394	410406345500000
87990	1471	23659957900000
87991	1471	23660170900000
88002	1690	138244456000000
88063	1650	12994233000000
88068	1509	19392092851155
88093	1874	13071000
88094	1422	15985198860211
88104	1668	21566922000000
88106	1397	1321808315000
88107	1678	23040756785000
88108	2134	96442350000
88109	1874	13082000
88110	2132	148271272000
88111	1874	13083000
88112	2133	96882774000
88113	1874	13085000
88114	1602	18720585000000
88115	1602	18720598000000
88118	1397	1321798314000
88119	1678	23040756786000
88120	2134	96441347000
88121	1874	13088000
88122	1439	13972486998477
88123	1439	13972497998477
88138	1395	58130546918007706
88195	1397	1321778312000
88196	1678	23040756788000
88197	1397	1321768311000
88198	1678	23040756789000
88199	2134	96439341000
88200	1874	13096000
88201	2132	148270271000
88202	1874	13097000
88203	2134	96438338000
88204	1874	13100000
88205	2133	96880770000
88206	1874	13102000
88207	2133	96879768000
88208	1874	13104000
88209	1719	20180867000000
88210	1719	20900867000000
88273	1759	18000889999889
88339	1397	1321608295000
88340	1678	23040756805000
88341	2134	96422290000
88342	1874	13186000
88343	2132	148265266000
88344	1874	13187000
88345	2133	96863736000
88346	1874	13189000
88347	1547	17133559000000
88366	1397	1321598294000
88367	1678	23040756806000
88368	2134	96421287000
88369	1874	13192000
88370	2133	96862734000
88371	1874	13194000
88372	1439	14692497998477
88373	1439	14692509998477
88394	1560	20755556277001
88395	1560	21475556277001
88437	1397	1321518286000
88438	1678	23040756814000
88439	2134	96413263000
88440	1874	13234000
88441	2133	96854718000
88442	1874	13236000
88443	1467	16526902100039
88444	1467	16526914100039
88462	1746	9874420000000
88466	1395	58131266943007706
88489	2095	17289739490035
88490	1680	200190000
88504	1397	1321438278000
88505	1678	23040756822000
88506	606	81835203812962
88507	2238	2000000000
88508	2134	96406242000
88509	1874	13273000
88510	1709	9000000
88511	1979	14400211999976
88512	2132	148260261000
88513	1874	13274000
88514	2133	96846702000
88515	1874	13276000
88516	1513	32400997000000
88517	1513	32401021000000
88552	1397	1321408275000
88553	1678	23040756825000
88554	2133	96842694000
88555	1874	13294000
88556	2134	96402230000
88557	1874	13297000
88558	1684	25200675880623
88559	1684	25200687880623
88560	1670	12626193000000
88561	1282	1713369637751650
88562	1397	1321398274000
88563	1678	23040756826000
88564	1397	1321388273000
88565	1678	23040756827000
88566	1397	1321378272000
88567	1678	23040756828000
88568	2132	148258259000
88569	1874	13298000
88570	2238	1001997000000
88571	2134	96401227000
88572	1874	13301000
88573	2133	96841692000
88574	1874	13303000
88575	2133	96840690000
88576	1874	13305000
88577	2133	96839688000
88578	1874	13307000
88579	2134	96400224000
88580	1874	13310000
88581	2134	96399221000
88582	1874	13313000
88583	1768	19310945110000
88584	1768	19311083110000
88587	1397	1321368271000
88588	1678	23040756829000
88589	2134	96398218000
88590	1874	13316000
88591	2133	96838686000
88592	1874	13318000
88593	1394	414726376500000
88598	1681	17063431759830
88599	1681	17063443759830
88611	1513	33121021000000
88612	1513	33121143000000
88624	1594	16082303000000
88625	606	81115162812962
88626	606	80115152812962
88627	2238	1002000000000
88628	1874	13174000
88629	1874	13180000
88630	1874	13182000
88631	1874	13184000
88632	1874	13188000
88633	1874	13190000
88634	1874	13191000
88635	1874	13193000
88636	1874	13195000
88637	1874	13197000
88638	1874	13201000
88639	1874	13203000
88640	1874	13205000
88641	1874	13211000
88642	1874	13213000
88643	1874	13215000
88644	1874	13219000
88645	1874	13223000
88646	1874	13225000
88647	1874	13227000
88648	1874	13229000
88649	1874	13233000
88650	1874	13235000
88651	1675	17422914999977
88652	1874	13237000
88653	1874	13241000
88654	1874	13243000
88655	1874	13249000
88656	1874	13252000
88657	1874	13253000
88658	1874	13259000
88659	1874	13271000
88660	1874	13277000
88661	1874	13280000
88662	1874	13289000
88663	1874	13295000
88664	1874	13319000
88665	1874	13322000
88666	1874	13325000
88667	1675	18142914999977
88668	1675	18142948999977
88670	1397	1321338268000
88671	1678	23040756832000
88672	1594	9122077000000
88673	1326	1709341117751650
88674	1594	6365917000000
88675	1200	613417050000000
88676	2134	96395209000
88237	38	66383534720208
88238	1571	3475047490484
88239	969	505695553414336
88240	1397	1321708305000
88241	1678	23040756795000
88242	1571	2821458250612
88243	1089	906202098918976
88244	1571	2380465313984
88245	1209	611432613493024
88246	1571	1151617151056
88247	1335	1703811343055074
88248	2133	96875760000
88249	1874	13122000
88250	2134	96434326000
88251	1874	13125000
88252	2134	96433323000
88253	1874	13128000
88254	2134	96432320000
88255	1874	13131000
88256	2132	148268269000
88257	1874	13132000
88258	2133	96874758000
88259	1874	13134000
88260	2133	96873756000
88261	1874	13136000
88262	1717	19548195000023
88263	1717	19548282000023
88265	1397	1321698304000
88266	1678	23040756796000
88267	2133	96872754000
88268	1874	13138000
88269	2134	96431317000
88270	1874	13141000
88271	2039	20161530000000
88272	2039	20161542000000
88275	1397	1321688303000
88276	1678	23040756797000
88277	1397	1321678302000
88278	1678	23040756798000
88279	1397	1321668301000
88280	1678	23040756799000
88281	2132	148267268000
88282	1874	13142000
88283	2133	96871752000
88284	1874	13144000
88285	2133	96870750000
88286	1874	13146000
88287	2133	96869748000
88288	1874	13148000
88289	2134	96430314000
88290	1874	13151000
88291	2134	96429311000
88292	1874	13154000
88293	2134	96428308000
88294	1874	13157000
88295	1991	22076055441475
88296	1397	1321658300000
88297	1678	23040756800000
88298	1397	1321648299000
88299	1678	23040756801000
88300	1397	1321638298000
88301	1678	23040756802000
88302	1397	1321628297000
88303	1678	23040756803000
88304	2133	96868746000
88305	1874	13159000
88306	2134	96427305000
88307	1874	13162000
88308	2134	96426302000
88309	1874	13165000
88310	2134	96425299000
88311	1874	13168000
88312	2134	96424296000
88313	1874	13171000
88314	2133	96867744000
88315	1874	13173000
88316	2133	96866742000
88317	1874	13175000
88318	2133	96865740000
88319	1874	13177000
88320	2132	148266267000
88321	1874	13178000
88322	606	81838172812962
88323	606	81838221812962
88326	1397	1321618296000
88327	1678	23040756804000
88328	1874	13160000
88329	1874	13163000
88330	1874	13166000
88331	1874	13169000
88332	1874	13172000
88333	2134	96423293000
88334	1874	13179000
88335	1874	13181000
88336	2133	96864738000
88337	1874	13183000
88338	1394	410406328500000
88405	1560	21474475277001
88406	1560	21474488277001
88447	1397	1321508285000
88448	1678	23040756815000
88449	1397	1321498284000
88450	1678	23040756816000
88451	2133	96853716000
88452	1874	13238000
88453	2132	148262263000
88454	1874	13239000
88455	2134	96412260000
88456	1874	13242000
88457	2134	96411257000
88458	1874	13245000
88459	2133	96852714000
88460	1874	13247000
88461	1747	8656945000000
88470	1397	1321488283000
88471	1678	23040756817000
88472	1397	1321478282000
88473	1678	23040756818000
88474	1397	1321468281000
88475	1678	23040756819000
88476	2132	148261262000
88477	1874	13248000
88478	2134	96410254000
88479	1874	13251000
88480	2134	96409251000
88481	1874	13254000
88482	2133	96851712000
88483	1874	13256000
88484	2133	96850710000
88485	1874	13258000
88486	2133	96849708000
88487	1874	13260000
88488	1680	17289739500035
88528	2133	96844698000
88529	1874	13283000
88530	2238	1998000000
88531	606	81835204812962
88532	2134	96404236000
88533	1874	13286000
88534	1394	414726364500000
88535	1394	414726367500000
88548	1596	20160983000000
88549	1596	20161006000000
88600	1670	7469093000000
88601	1036	911287465000000
88602	1594	16802327000000
88603	1985	2299990000000
88604	1397	1321358270000
88605	1678	23040756830000
88606	2134	96397215000
88607	1874	13321000
88608	2133	96837684000
88609	1874	13323000
88610	1394	414726486500000
88613	1670	3988993000000
88614	1156	614864750000000
88615	1397	1321348269000
88616	1678	23040756831000
88617	2134	96396212000
88618	1874	13326000
88619	2133	96836682000
88620	1874	13328000
88621	2132	148257258000
88622	1874	13329000
88623	1675	18142436999977
88696	641	85060386000000
88734	1397	1321288263000
88735	1678	23040756837000
88736	2134	96391197000
88737	1874	13355000
88738	2133	96830670000
88739	1874	13357000
88744	1637	233285507819988
88745	1637	233285519819988
88757	1395	58131266931007706
88767	1764	15847082100000
88768	1764	15847095100000
88830	1397	1321208255000
88831	1678	23040756845000
88832	2133	96822654000
88833	1874	13397000
88834	2133	96821652000
88835	1874	13399000
88836	2134	96383173000
88837	1874	13402000
88432	1874	13228000
88433	2134	96414266000
88434	1874	13231000
88435	1637	232565482819988
88436	1637	232565507819988
88465	1704	5106338000000
88469	1559	17242846000000
88491	1397	1321458280000
88492	1678	23040756820000
88493	1397	1321448279000
88494	1678	23040756821000
88495	2133	96848706000
88496	1874	13262000
88497	2134	96408248000
88498	1874	13265000
88499	2134	96407245000
88500	1874	13268000
88501	2133	96847704000
88502	1874	13270000
88503	1594	17905337000000
88524	1623	60482946899898
88537	1397	1321418276000
88538	1678	23040756824000
88539	606	80835194812962
88540	2238	1001998000000
88541	2133	96843696000
88542	1874	13288000
88543	2134	96403233000
88544	1874	13291000
88545	2132	148259260000
88546	1874	13292000
88547	1509	19392114851155
88550	1692	40100636619999
88551	1692	40100659619999
88596	1419	35739847280064
88597	1419	35739859280064
88669	1692	40100749619999
88748	1397	1321278262000
88749	1678	23040756838000
88750	2132	148255256000
88751	1874	13358000
88752	2134	96390194000
88753	1874	13361000
88754	2133	96829668000
88755	1874	13363000
88756	1762	22642125994000
88758	1397	1321268261000
88759	1678	23040756839000
88760	1716	0
88761	2239	2780956000000
88762	2133	96828666000
88763	1874	13365000
88764	2134	96389191000
88765	1874	13368000
88766	1394	416166499500000
88779	1397	1321248259000
88780	1678	23040756841000
88781	1397	1321238258000
88782	1678	23040756842000
88783	1726	46937112000
88784	2241	200000000
88785	2133	96826662000
88786	1874	13375000
88787	2133	96825660000
88788	1874	13377000
88789	2134	96387185000
88790	1874	13380000
88791	2134	96386182000
88792	1874	13383000
88793	2132	148254255000
88794	1874	13384000
88795	1726	45736112000
88796	2242	200000000
88797	1726	44535112000
88798	2243	200000000
88799	1457	24384494040000
88800	1457	24384522040000
88842	1397	1321198254000
88843	1678	23040756846000
88844	2133	96820650000
88845	1874	13407000
88846	2134	96381167000
88847	1874	13410000
88848	1726	43334112000
88849	2244	200000000
88850	1719	21620867000000
88851	1719	21620880000000
88870	1397	1321168251000
88871	1678	23040756849000
88872	2133	96817644000
88873	1874	13423000
88874	2134	96378158000
88875	1874	13426000
88876	1679	25199246653000
88877	1679	25199258653000
88889	171	81830754524688
88908	1397	1321128247000
88909	1678	23040756853000
88910	2134	96375149000
88911	1874	13442000
88912	2119	197000000
88913	2133	96813636000
88914	1874	13444000
88915	1688	69840689905200
88955	1397	1321078242000
88956	1678	23040756858000
88957	1694	24364166263738
88958	21	32910553770161
88959	1694	24103503366853
88960	52	66714679919853
88961	1694	23842840469968
88962	57	66714679919853
88963	1694	23582177573083
88964	60	66714679919853
88965	1694	23321514676198
88966	61	66714679919853
88967	1694	23060851779313
88968	67	66714679919853
88969	1694	22800188882428
88970	68	66714679919853
88971	1694	22539525985543
88972	73	66714679919853
88973	1694	22278863088658
88974	81	66714679919853
88975	1694	22018200191773
88976	129	66260677919853
88977	1694	21757537294888
88978	156	66714679919853
88979	1694	21496874398003
88980	164	66714679919853
88981	1694	21236211501118
88982	220	66714679919853
88983	1610	19440789019950
88984	1694	20975548604233
88985	222	66714679919853
88986	1694	20714885707348
88987	256	66714679919853
88988	1694	20454222810463
88989	371	66714679919853
88990	1694	20193559913578
88991	428	66714679919853
88992	1694	19932897016693
88993	431	66714679919853
88994	1694	19672234119808
88995	432	66714679919853
88996	1694	19411571222923
88997	433	66714679919853
88998	1694	19150908326038
88999	574	66714679919853
89000	1694	18890245429153
89001	604	66714679919853
89002	1694	18629582532268
89003	628	66714679919853
89004	1694	18368919635383
89005	638	66714679919853
89006	1694	16340398011715
89007	951	508339674986889
89008	1694	12705467233893
89009	1071	910939949755115
89010	1694	10252840458117
89011	1191	614629496764309
89012	1694	3418747197225
89013	1317	1712718855121332
89014	2134	96370134000
89015	1874	13469000
89016	2133	96808626000
89017	1874	13471000
89018	1610	20160789019950
89019	1610	20160941019950
89036	1681	17063711759830
89051	1397	1321028237000
89052	1678	23040756863000
89053	1397	1321018236000
89054	1678	23040756864000
89055	1397	1321008235000
89056	1678	23040756865000
89057	1397	1320998234000
89058	1678	23040756866000
89059	2133	96803616000
89060	1874	13491000
89061	2134	96366122000
89062	1874	13494000
89063	2134	96365119000
89064	1874	13497000
89065	2134	96364116000
88526	1678	23040756823000
88527	1692	39380636619999
88536	1419	35019847280064
88585	1874	13304000
88586	1768	19311080110000
88594	1440	18719351045924
88595	1440	18719363045924
88681	1684	25920687880623
88682	1684	25920719880623
88695	576	83796042938283
88698	1764	15127092100000
88721	1397	1321298264000
88722	1678	23040756836000
88723	2134	96392200000
88724	1874	13350000
88725	1716	14053359000000
88726	1070	910450405000000
88727	1716	11076658000000
88728	1190	614299070000000
88729	1716	2781957000000
88730	1316	1711798937751650
88731	2133	96831672000
88732	1874	13352000
88733	1717	19548210000023
88742	1587	27360845000000
88743	1587	27360857000000
88746	1508	21636734500009
88747	1508	21636746500009
88769	1397	1321258260000
88770	1678	23040756840000
88771	1726	48138112000
88772	2240	200000000
88773	2133	96827664000
88774	1874	13370000
88775	2134	96388188000
88776	1874	13373000
88777	1698	20697190550035
88778	1698	20697203550035
88820	1397	1321218256000
88821	1678	23040756844000
88822	2134	96384176000
88823	1874	13392000
88824	2132	148253254000
88825	1874	13393000
88826	2133	96823656000
88827	1874	13395000
88828	1650	13714233000000
88829	1650	13714246000000
88841	1689	15840537287625
88862	1397	1321178252000
88863	1678	23040756848000
88864	2133	96818646000
88865	1874	13418000
88866	2134	96379161000
88867	1874	13421000
88868	1395	58131986931007706
88869	1395	58131986943007706
88898	1448	10836810000001
88899	1448	10836822000001
88900	1397	1321138248000
88901	1678	23040756852000
88902	2133	96814638000
88903	1874	13436000
88904	2134	96376152000
88905	1874	13439000
88906	369	88116755000000
88907	369	88116767000000
88936	1607	10284263644388
88937	1560	21529556277001
88946	1740	20085553000000
89028	1397	1321058240000
89029	1678	23040756860000
89030	2132	148248249000
89031	1874	13477000
89032	2134	96368128000
89033	1874	13480000
89034	2133	96806622000
89035	1874	13482000
89050	1564	15666596000000
89117	1489	20064505000000
89169	2112	7919130000000
89170	2112	7919143000000
89179	1394	417606499500000
89180	1394	417606512500000
89191	1397	1320918226000
89192	1678	23040756874000
89193	2133	96792594000
89194	1874	13547000
89195	2134	96355089000
89196	1874	13550000
89197	1426	24045210000000
89198	1426	24045222000000
89276	1850	20799313000000
89415	1587	15469565000000
89416	1357	1712398137751650
89417	1397	1320808215000
89418	1678	23040756885000
89419	1587	9527915000000
89420	1111	910769145000000
89421	1587	5518965000000
89422	1231	614514090000000
89423	1587	2203285000000
89424	991	508244145000000
89425	1587	1768025000000
89426	272	67581824000000
89427	1587	1332765000000
89428	319	66717580000000
89429	1684	15495788571796
89430	637	66544510726895
89431	1684	15286352783184
89432	647	66209425788612
89433	1684	15076916994572
89434	656	66544510726895
89435	1684	14867481205960
89436	664	66544510726895
89437	1684	14658045417348
89438	666	66544510726895
89439	1684	14448609628736
89440	670	66544510726895
89441	1684	14239173840124
89442	673	66544510726895
89443	1684	14029738051512
89444	674	66544510726895
89445	1684	13820302262900
89446	681	66544510726895
89447	2132	148244245000
89448	1874	13598000
89449	2133	96782574000
89450	1874	13600000
89451	2134	96345059000
89452	1874	13603000
89453	1395	58134147131007706
89489	1547	17853739000000
89491	1397	1320778212000
89492	1678	23040756888000
89493	2133	96779568000
89494	1874	13615000
89495	1643	1148535914700
89496	2134	96342050000
89497	1874	13618000
89498	1643	1868535914700
89499	1643	1868536914700
89541	1439	15412509998477
89542	1439	15412856998477
89591	1440	18719414045924
89602	1397	1320688203000
89603	1678	23040756897000
89604	2133	96770550000
89605	1874	13663000
89606	1692	40820689619999
89642	1671	10569939634395
89643	1365	1710262743410483
89644	1671	6975243815095
89645	1119	909633389928309
89646	1671	4549827663645
89647	1239	613747773910318
89648	1397	1320648199000
89649	1678	23040756901000
89650	2132	148239240000
89651	1874	13685000
89652	2134	96329011000
89653	1874	13688000
89654	2133	96765540000
89655	1874	13690000
89656	1395	58135587153007706
89657	1395	58135587196007706
89701	1692	41540689619999
89702	1692	41540733619999
89723	2137	900000000
89724	365	66715801000000
89725	2137	100000000
89726	365	66716501000000
89727	1536	9907860999959
89728	1313	1709341167751650
89729	1536	5986370999959
89730	1067	909143245000000
89731	1536	3340460999959
89732	1187	613417050000000
89733	1536	1152110999959
89734	947	507336815000000
89735	2248	719000000000
89736	2248	719240000000
89778	1759	18720950999889
89779	1759	18720975999889
89827	1397	1320488183000
88677	1874	13332000
88678	2133	96835680000
88679	1874	13334000
88680	1679	24479246653000
88683	1670	1110893000000
88684	916	508533775000000
88685	1594	2281027000000
88686	1080	909143225000000
88687	1397	1321328267000
88688	1678	23040756833000
88689	2134	96394206000
88690	1874	13337000
88691	2133	96834678000
88692	1874	13339000
88693	1394	416166486500000
88694	1394	416166608500000
88697	1764	15127082100000
88699	1670	793000000
88700	1977	2219500000000
88701	1397	1321318266000
88702	1678	23040756834000
88703	1979	14161444550095
88704	1776	1379801392757
88705	1594	1497000000
88706	960	507336815000000
88707	1397	1321308265000
88708	1678	23040756835000
88709	1716	18465060000000
88710	950	508066275000000
88711	2134	96393203000
88712	1874	13342000
88713	2132	148256257000
88714	1874	13343000
88715	2133	96833676000
88716	1874	13345000
88717	2133	96832674000
88718	1874	13347000
88719	1740	19365386000000
88720	1740	19365541000000
88740	1768	20031083110000
88741	1768	20031095110000
88801	1979	14125259179083
88802	1776	1415976763769
88803	1979	12306431912086
88804	931	506688269472384
88805	1979	9047116952589
88806	1051	907981037590826
88807	1979	6847988951379
88808	1171	612632898860187
88809	1979	719941102856
88810	1297	1707156044961604
88811	1979	990000000
88812	1776	2134917866625
88813	1397	1321228257000
88814	1678	23040756843000
88815	2133	96824658000
88816	1874	13386000
88817	2134	96385179000
88818	1874	13389000
88819	1850	20079250000000
88878	1455	31517000000
88879	1397	1321158250000
88880	1678	23040756850000
88881	353	66000000000000
88882	2213	650232116779
88883	2133	96816642000
88884	1874	13428000
88885	2132	148251252000
88886	1874	13429000
88887	1588	21815107000000
88888	1588	21815329000000
88890	1397	1321148249000
88891	1678	23040756851000
88892	2133	96815640000
88893	1874	13431000
88894	2134	96377155000
88895	1874	13434000
88896	1637	234005519819988
88897	1637	234005531819988
88918	1740	20085541000000
88919	1740	20085554000000
88945	1693	1622190908632
88947	1397	1321088243000
88948	1678	23040756857000
88949	2134	96371137000
88950	1874	13463000
88951	2133	96809628000
88952	1874	13465000
88953	2132	148249250000
88954	1874	13466000
89037	1397	1321048239000
89038	1678	23040756861000
89039	2119	196000000
89040	2133	96805620000
89041	1874	13484000
89042	1681	17783443759830
89043	1681	17783455759830
89044	1397	1321038238000
89045	1678	23040756862000
89046	2133	96804618000
89047	1874	13486000
89048	2134	96367125000
89049	1874	13489000
89109	1397	1320958230000
89110	1678	23040756870000
89111	2134	96359101000
89112	1874	13528000
89113	2133	96796602000
89114	1874	13530000
89115	1402	69694911319298
89116	1402	69694923319298
89159	1397	1320948229000
89160	1678	23040756871000
89161	1689	7463337179995
89162	1149	613083553321783
89163	2134	96358098000
89164	1874	13533000
89165	2133	96795600000
89166	1874	13535000
89167	1719	22340880000000
89168	1719	22340893000000
89171	1397	1320938228000
89172	1678	23040756872000
89173	2134	96357095000
89174	1874	13538000
89175	2133	96794598000
89176	1874	13540000
89177	1689	1015355019933
89178	1275	1708411833681314
89201	1397	1320908225000
89202	1678	23040756875000
89203	1607	3707521150625
89204	1348	1710024054520435
89205	2133	96791592000
89206	1874	13552000
89207	1756	10513171545609
89208	1756	10513192545609
89237	1688	70560689905200
89238	1688	70560741905200
89256	1981	100880000000
89257	1607	0
89258	2246	82779133619
89259	1397	1320868221000
89260	1678	23040756879000
89261	1684	25129834847948
89262	22	22510193128616
89263	1684	24920399059336
89264	190	66544510726895
89265	2132	148246247000
89266	1874	13568000
89267	2134	96351077000
89268	1874	13571000
89269	2133	96787584000
89270	1874	13573000
89271	1850	20799250000000
89272	646	66000004060000
89273	212	66000006930000
89274	1807	20799311949999
89275	1850	200000002
89359	2246	2686421101924
89360	1684	19265632766812
89361	572	66544510726895
89362	1684	19056196978200
89363	573	66544510726895
89364	1684	18846761189588
89365	576	83285346726895
89366	1684	18637325400976
89367	584	66544510726895
89368	1684	18427889612364
89369	585	66544510726895
89370	1684	18218453823752
89371	589	66544500726895
89372	1684	18009018035140
89373	595	66544510726895
89374	1684	17799582246528
89375	597	66544510726895
89376	1684	17590146457916
89377	609	66544510726895
89378	1397	1320828217000
89379	1678	23040756883000
89380	2133	96783576000
89381	1874	13591000
89382	2134	96347065000
89383	1874	13594000
89384	1573	14379269000000
88838	2134	96382170000
88839	1874	13405000
88840	1549	24816051000000
88852	1397	1321188253000
88853	1678	23040756847000
88854	2134	96380164000
88855	1874	13413000
88856	2133	96819648000
88857	1874	13415000
88858	2132	148252253000
88859	1874	13416000
88860	1672	26642239000000
88861	1672	26642252000000
88916	1395	58132706943007706
88917	1395	58132706956007706
88920	1397	1321118246000
88921	1678	23040756854000
88922	1397	1321108245000
88923	1678	23040756855000
88924	2133	96812634000
88925	1874	13446000
88926	2133	96811632000
88927	1874	13448000
88928	2134	96374146000
88929	1874	13451000
88930	2134	96373143000
88931	1874	13454000
88932	2132	148250251000
88933	1874	13455000
88934	484	73628869000000
88935	484	73628894000000
88938	1397	1321098244000
88939	1678	23040756856000
88940	2134	96372140000
88941	1874	13458000
88942	2133	96810630000
88943	1874	13460000
88944	1560	21474487277001
89020	1397	1321068241000
89021	1678	23040756859000
89022	2134	96369131000
89023	1874	13474000
89024	2133	96807624000
89025	1874	13476000
89026	1622	25020512000005
89027	1622	25020524000005
89120	1759	18000888999889
89121	1874	13409000
89122	1874	13411000
89123	1874	13417000
89124	1874	13419000
89125	1874	13422000
89126	1874	13425000
89127	1874	13430000
89128	1874	13433000
89129	1874	13438000
89130	1874	13440000
89131	1874	13450000
89132	1874	13452000
89133	1874	13456000
89134	1874	13462000
89135	1874	13464000
89136	1874	13468000
89137	1874	13470000
89138	1874	13472000
89139	1874	13475000
89140	1874	13478000
89141	1874	13481000
89142	1874	13487000
89143	1874	13490000
89144	1690	138244979000000
89145	1874	13493000
89146	1874	13496000
89147	1874	13499000
89148	1874	13502000
89149	1874	13508000
89150	1874	13511000
89151	1874	13514000
89152	1874	13517000
89153	1874	13520000
89154	1874	13526000
89155	1874	13527000
89156	1874	13529000
89157	1690	138964979000000
89158	1690	138964995000000
89183	1685	136802837571430
89184	1397	1320928227000
89185	1678	23040756873000
89186	2134	96356092000
89187	1874	13543000
89188	2133	96793596000
89189	1874	13545000
89190	1394	417606511500000
89221	1607	323786504217
89222	242	66651405291044
89223	2112	5077984563820
89224	1222	613662117612488
89225	2112	3323654080099
89226	982	507539502027242
89227	1397	1320888223000
89228	1678	23040756877000
89229	1607	83789133619
89230	372	66651405291044
89231	2134	96353083000
89232	1874	13560000
89233	2133	96789588000
89234	1874	13562000
89235	1394	419046511500000
89236	1394	419046563500000
89239	2112	3083656709501
89240	271	66651405291044
89241	2112	2843659338903
89242	269	66651405291044
89243	2112	2603661968305
89244	577	66651405291044
89245	1397	1320878222000
89246	1678	23040756878000
89247	2133	96788586000
89248	1874	13564000
89249	1726	42133112000
89250	2245	200000000
89251	1394	417606553500000
89252	2134	96352080000
89253	1874	13567000
89254	1394	419046553500000
89255	1394	419046554500000
89304	271	66651395291044
89305	1397	1320848219000
89306	1678	23040756881000
89307	1397	1320838218000
89308	1678	23040756882000
89309	1684	23035476961828
89310	430	66544510726895
89311	1684	22826041173216
89312	440	66544510726895
89313	1684	22616605384604
89314	474	66544510726895
89315	1684	22407169595992
89316	475	66544510726895
89317	1684	22197733807380
89318	476	66544510726895
89319	1684	21988298018768
89320	483	66544510726895
89321	1684	21778862230156
89322	486	66544510726895
89323	1684	21569426441544
89324	490	66544510726895
89325	1684	21359990652932
89326	496	66544510726895
89327	1684	21150554864320
89328	511	66544510726895
89329	1684	20941119075708
89330	512	66544510726895
89331	1684	20731683287096
89332	522	66544510726895
89333	1684	20522247498484
89334	523	66544510726895
89335	1684	20312811709872
89336	533	66544510726895
89337	1684	20103375921260
89338	539	66544510726895
89339	1684	19893940132648
89340	541	66544510726895
89341	1684	19684504344036
89342	558	66243200726895
89343	1684	19475068555424
89344	565	66544510726895
89345	2134	96349071000
89346	1874	13579000
89347	2134	96348068000
89348	1874	13582000
89349	361	66641271116779
89350	2247	9000000000
89351	2132	148245246000
89352	1874	13583000
89353	1874	13585000
89354	2133	96785580000
89355	1874	13587000
89356	2133	96784578000
89357	1874	13589000
89358	149	84990601000341
89413	1691	20123370100019
89414	1691	20123682100019
89454	1692	40820841619999
89512	1692	40100698619999
89066	1874	13500000
89067	2134	96363113000
89068	1874	13503000
89069	2133	96802614000
89070	1874	13505000
89071	2133	96801612000
89072	1874	13507000
89073	167	66000000100200
89074	2133	96800610000
89075	1874	13509000
89076	2132	148247248000
89077	1874	13510000
89078	1679	25199296653000
89079	1397	1320988233000
89080	1678	23040756867000
89081	1397	1320978232000
89082	1678	23040756868000
89083	1397	1320968231000
89084	1678	23040756869000
89085	1689	13206745029108
89086	909	507060990769063
89087	2134	96362110000
89088	1874	13513000
89089	2134	96361107000
89090	1874	13516000
89091	1704	4068312000000
89092	581	66618100000000
89093	1704	3750311000000
89094	698	66618100000000
89095	2134	96360104000
89096	1874	13519000
89097	1704	3725310000000
89098	742	5048100000000
89099	2133	96799608000
89100	1874	13521000
89101	2133	96798606000
89102	1874	13523000
89103	2133	96797604000
89104	1874	13525000
89105	2119	195000000
89106	1689	9777271579089
89107	1029	908648950959568
89108	1692	40100678619999
89118	1395	58133426956007706
89119	1395	58133426968007706
89181	1395	58134146968007706
89182	1395	58134146981007706
89199	1637	234725531819988
89200	1637	234725543819988
89209	1607	563783874815
89210	1102	909506439034341
89211	1397	1320898224000
89212	1678	23040756876000
89213	2134	96354086000
89214	1874	13555000
89215	1689	23287617
89216	1984	2270230732316
89217	2133	96790590000
89218	1874	13557000
89219	1637	235445543819988
89220	1637	235445566819988
89277	1489	20064556000000
89278	1684	24710963270724
89279	258	66544510726895
89280	1684	24501527482112
89281	273	66544510726895
89282	2112	0
89283	2246	2686431101924
89284	1397	1320858220000
89285	1678	23040756880000
89286	1684	24292091693500
89287	292	66544510726895
89288	1684	24082655904888
89289	293	66544510726895
89290	1684	23873220116276
89291	333	66209510726895
89292	1684	23663784327664
89293	376	66544510726895
89294	1684	23454348539052
89295	426	66544510726895
89296	1684	23244912750440
89297	429	66544510726895
89298	2134	96350074000
89299	1874	13576000
89300	2133	96786582000
89301	1874	13578000
89302	1692	40820678619999
89303	1692	40820780619999
89385	1895	1439936000000
89386	1497	0
89387	1684	17380710669304
89388	612	66544510726895
89389	1684	17171274880692
89390	615	66544510726895
89391	1684	16961839092080
89392	616	66544510726895
89393	1684	16752403303468
89394	617	66544510726895
89395	1397	1320818216000
89396	1678	23040756884000
89397	1684	16542967514856
89398	624	66544510726895
89399	1684	16333531726244
89400	625	66544510726895
89401	1684	16124095937632
89402	626	66544510726895
89403	1684	15914660149020
89404	627	66544510726895
89405	1684	15705224360408
89406	629	66544510726895
89407	2134	96346062000
89408	1874	13597000
89409	361	66001270116779
89410	2247	649000000000
89411	1571	1871617151056
89412	1571	1872019151056
89490	1476	20880531000000
89500	1397	1320768211000
89501	1678	23040756889000
89502	1691	19403390100019
89503	2132	148243244000
89504	1874	13614000
89505	1874	13616000
89506	2133	96778566000
89507	1874	13621000
89508	2134	96341047000
89509	1874	13624000
89510	1691	20123390100019
89511	1691	20123395100019
89568	1476	11558487000000
89569	1371	1710570537751650
89570	1397	1320708205000
89571	1678	23040756895000
89572	1476	6983377000000
89573	1125	909797565000000
89574	1476	3896467000000
89575	1245	613858650000000
89576	1476	1343357000000
89577	1005	507701875000000
89578	1476	1008147000000
89579	538	67580540000000
89580	2133	96772554000
89581	1874	13652000
89582	2134	96335029000
89583	1874	13655000
89584	2132	148241242000
89585	1874	13656000
89586	1991	23516129441475
89587	1991	23516192441475
89592	538	68588677000000
89593	1397	1320698204000
89594	1678	23040756896000
89595	2134	96334026000
89596	1874	13659000
89597	2133	96771552000
89598	1874	13661000
89599	369	88836767000000
89600	369	88836789000000
89627	1397	1320668201000
89628	1678	23040756899000
89629	2134	96331017000
89630	1874	13677000
89631	1419	35739858280064
89658	1886	400200000000
89659	1724	20418092500000
89680	1397	1320628197000
89681	1678	23040756903000
89682	2133	96763536000
89683	1874	13697000
89684	2134	96327005000
89685	1874	13700000
89686	1394	423366642500000
89687	1394	423366654500000
89703	2138	900000000
89704	365	66617801000000
89705	1397	1320598194000
89706	1678	23040756906000
89707	1397	1320588193000
89708	1678	23040756907000
89709	2133	96760530000
89710	1874	13712000
89711	2133	96759528000
89712	1874	13714000
89713	1719	835689000000
89714	1352	1710877257751650
89455	272	68914579000000
89456	1684	13813946026882
89457	720	2016500325057
89458	1684	13807589790864
89459	722	2016500325057
89460	1684	13804406672855
89461	760	1008250162528
89462	1684	13801223554846
89463	763	1008250162528
89464	1684	13798040436837
89465	767	1008250162528
89466	1684	13794857318828
89467	769	1008250162528
89468	1684	12164967517017
89469	958	507015654801811
89470	1684	9244382280923
89471	1078	908567040236094
89472	1684	7273738330602
89473	1198	613028383950321
89474	1397	1320798214000
89475	1678	23040756886000
89476	1397	1320788213000
89477	1678	23040756887000
89478	1684	1782734219748
89479	1324	1708257631862504
89480	2133	96781572000
89481	1874	13605000
89482	2133	96780570000
89483	1874	13607000
89484	2134	96344056000
89485	1874	13610000
89486	2134	96343053000
89487	1874	13613000
89488	1547	17853693000000
89515	1882	719910000000
89516	1484	0
89517	1684	2724219748
89518	2142	4630001000000
89519	1397	1320758210000
89520	1678	23040756890000
89521	1397	1320748209000
89522	1678	23040756891000
89523	1397	1320738208000
89524	1678	23040756892000
89525	2133	96777564000
89526	1874	13626000
89527	2132	148242243000
89528	1874	13627000
89529	2133	96776562000
89530	1874	13629000
89531	2133	96775560000
89532	1874	13631000
89533	2134	96340044000
89534	1874	13634000
89535	2134	96339041000
89536	1874	13637000
89537	2134	96338038000
89538	1874	13640000
89539	1602	19440598000000
89540	1602	19440945000000
89566	1394	420486554500000
89567	1394	420486628500000
89589	1395	58134867131007706
89590	1395	58134867194007706
89612	632	73255261000000
89613	1382	1712413637751650
89614	632	71294241000000
89615	1136	910778465000000
89616	632	69971221000000
89617	1256	614519750000000
89618	1397	1320678202000
89619	1678	23040756898000
89620	2133	96768546000
89621	1874	13670000
89622	2134	96332020000
89623	1874	13673000
89624	2132	148240241000
89625	1874	13674000
89626	1759	18000950999889
89663	1724	19377550500000
89664	1397	1320638198000
89665	1678	23040756902000
89666	1671	2543845003785
89667	999	507610345498755
89668	1719	19423092000000
89669	986	507792735000000
89670	1719	14194391000000
89671	1106	909960255000000
89672	1719	10666490000000
89673	1226	613968310000000
89674	2133	96764538000
89675	1874	13692000
89676	2134	96328008000
89677	1874	13695000
89678	1394	421926617500000
89679	1394	421926642500000
89721	1643	1868524914700
89722	1643	1868649914700
89766	1397	1320548189000
89767	1678	23040756911000
89768	1522	16145291000000
89769	956	506972775000000
89770	2134	96318981000
89771	1874	13734000
89772	1874	13736000
89773	1874	13738000
89774	2133	96755520000
89775	1874	13740000
89776	633	85324146900000
89777	633	85324171900000
89821	1637	236165612819988
89839	1650	12064136000000
89840	1009	505985775000000
89841	1650	9107026000000
89842	1129	906722465000000
89843	1397	1320478182000
89844	1678	23040756918000
89845	2134	96312963000
89846	1874	13770000
89847	2133	96748506000
89848	1874	13772000
89849	1394	427687022500000
89864	1395	58135587285007706
89865	1714	18886716103056
89916	1397	1320438178000
89917	1678	23040756922000
89918	2133	96744498000
89919	1874	13789000
89920	2134	96308951000
89921	1874	13792000
89922	1419	36459858280064
89923	1419	36459870280064
89947	1397	1320398174000
89948	1678	23040756926000
89949	2134	96304939000
89950	1874	13810000
89951	2133	96740490000
89952	1874	13812000
89953	1499	1440020000000
89954	1499	1440032000000
90012	1610	18327886889950
90013	948	507975167870000
90014	1610	13752822189950
90015	1068	910287148470000
90016	1610	10665931609950
90017	1188	614188877840000
90018	1610	2064054449950
90019	1314	1711491918671650
90020	1397	1320318166000
90021	1678	23040756934000
90022	1439	10931217888477
90023	1153	611805340660000
90024	2134	96296915000
90025	1874	13850000
90026	2133	96732474000
90027	1874	13852000
90028	2086	2335254300069
90029	1773	15732844699931
90030	1717	20268210000023
90031	1717	20268264000023
90033	2142	2849991000000
90034	1610	16887582889950
90035	1610	12312518189950
90036	1610	9225627609950
90037	1610	623750449950
90038	271	66411407920446
90039	2246	2602651968305
90040	1690	138967475000000
90041	1690	139687475000000
90042	1690	66000000600200
90043	167	139687624499992
90044	1571	1151617151064
90074	1423	4704939826911
90075	104	66631395942306
90076	1423	4336576653837
90077	199	66631395942306
90078	1423	3968213480763
90079	214	66631395942306
90080	1423	3599850307689
90081	234	66631395942306
90082	1423	3231487134615
90083	282	66631395942306
90084	1423	2863123961541
90085	314	66631395942306
90086	1423	2494760788467
89513	1692	40820698619999
89514	1692	40820703619999
89543	2142	4629991000000
89544	1675	15914426999977
89545	976	507233775000000
89546	1675	11922416999977
89547	1096	908957465000000
89548	1675	9228406999977
89549	1216	613292750000000
89550	1675	1723396999977
89551	1342	1708990637751650
89552	1397	1320728207000
89553	1678	23040756893000
89554	1397	1320718206000
89555	1678	23040756894000
89556	2133	96774558000
89557	1874	13642000
89558	2134	96337035000
89559	1874	13645000
89560	2134	96336032000
89561	1874	13648000
89562	2133	96773556000
89563	1874	13650000
89564	1991	22796055441475
89565	1991	22796129441475
89588	1394	420486617500000
89601	1395	58134867153007706
89607	2133	96769548000
89608	1874	13665000
89609	2134	96333023000
89610	1874	13668000
89611	43	83280972890000
89632	1397	1320658200000
89633	1678	23040756900000
89634	2134	96330014000
89635	1874	13680000
89636	2133	96767544000
89637	1874	13682000
89638	2133	96766542000
89639	1874	13684000
89640	1536	17280887999959
89641	1536	17280900999959
89660	632	68877201000000
89661	1016	508248775000000
89662	1724	18657572500000
89688	1397	1320618196000
89689	1678	23040756904000
89690	1397	1320608195000
89691	1678	23040756905000
89692	2134	96326002000
89693	1874	13703000
89694	2134	96324999000
89695	1874	13706000
89696	2133	96762534000
89697	1874	13708000
89698	2133	96761532000
89699	1874	13710000
89700	1506	14401300967172
89757	2133	96758526000
89758	1874	13725000
89759	2133	96757524000
89760	1874	13727000
89761	2133	96756522000
89762	1874	13732000
89763	1874	13735000
89764	1764	16567095100000
89765	1764	16567232100000
89780	212	85324171870000
89781	633	66000004090000
89796	1637	236165566819988
89797	1637	236165608819988
89819	1394	426246779500000
89820	1394	426246825500000
89822	1397	1320498184000
89823	1678	23040756916000
89824	2133	96750510000
89825	1874	13762000
89826	1394	426246790500000
89837	1688	71280741905200
89838	1688	71280753905200
89863	1440	18719483045924
89901	1397	1320458180000
89902	1678	23040756920000
89903	2133	96746502000
89904	1874	13779000
89905	2134	96310957000
89906	1874	13782000
89907	1701	2158084500103
89908	1701	2158096500103
89934	1397	1320418176000
89935	1678	23040756924000
89936	1397	1320408175000
89937	1678	23040756925000
89938	2133	96742494000
89939	1874	13799000
89940	2134	96306945000
89941	1874	13802000
89942	2134	96305942000
89943	1874	13805000
89944	2133	96741492000
89945	1874	13807000
89946	1719	720024000000
89963	1679	25919296653000
89964	1679	25919308653000
89980	1439	12989863548477
89981	913	506003823451523
89982	1397	1320358170000
89983	1678	23040756930000
89984	1397	1320348169000
89985	1678	23040756931000
89986	1397	1320338168000
89987	1678	23040756932000
89988	1397	1320328167000
89989	1678	23040756933000
89990	1699	250750126
89991	1773	7990000000000
89992	2087	193000000
89993	1773	13749000000000
89994	2134	96300927000
89995	1874	13830000
89996	2134	96299924000
89997	1874	13833000
89998	2134	96298921000
89999	1874	13836000
90000	2133	96736482000
90001	1874	13838000
90002	2133	96735480000
90003	1874	13840000
90004	2133	96734478000
90005	1874	13842000
90006	2133	96733476000
90007	1874	13844000
90008	2134	96297918000
90009	1874	13847000
90010	1549	25536051000000
90011	1549	25536111000000
90072	1602	20160945000000
90073	1602	20161021000000
90141	1547	18573693000000
90142	1547	18573718000000
90186	2134	96284879000
90187	1874	13912000
90188	2133	96720450000
90189	1874	13914000
90190	1447	18153637943000
90191	1447	18153639943000
90212	1397	1320208155000
90213	1678	23040756945000
90214	2133	96717444000
90215	1874	13924000
90216	2133	96716442000
90217	1874	13926000
90218	2134	96282873000
90219	1874	13929000
90220	2134	96281870000
90221	1874	13932000
90222	1395	58137027189007706
90223	1395	58137027203007706
90248	1397	1320168151000
90249	1678	23040756949000
90250	2134	96277858000
90251	1874	13951000
90252	2133	96712434000
90253	1874	13953000
90254	2132	148234235000
90255	1874	13954000
90256	1594	721497000000
90257	1594	721510000000
90260	1397	1320158150000
90261	1678	23040756950000
90262	2133	96711432000
90263	1874	13956000
90264	2134	96276855000
90265	1874	13959000
90266	1700	21906130276737
90267	1700	21906142276737
90352	1397	1320118146000
90353	1678	23040756954000
90354	2133	96707424000
90355	1874	13977000
90356	2134	96272843000
90357	1874	13980000
90434	1397	1320078142000
90435	1678	23040756958000
90436	2133	96703416000
89715	2134	96323996000
89716	1874	13717000
89717	2134	96322993000
89718	1874	13720000
89719	1394	424806654500000
89720	1394	424806779500000
89737	2138	0
89738	365	66717301000000
89739	1397	1320578192000
89740	1678	23040756908000
89741	1397	1320568191000
89742	1678	23040756909000
89743	1397	1320558190000
89744	1678	23040756910000
89745	2134	96321990000
89746	1874	13723000
89747	2007	1937313000000
89748	2134	96320987000
89749	1874	13726000
89750	2134	96319984000
89751	1874	13729000
89752	1659	720000000000
89753	2126	200000003
89754	1796	250000006
89755	1659	200000005
89756	1807	720083999990
89782	1397	1320538188000
89783	1678	23040756912000
89784	1522	12223281000000
89785	1076	908490465000000
89786	1522	9577271000000
89787	1196	612976750000000
89788	1522	2203261000000
89789	1322	1708113637751650
89790	2133	96754518000
89791	1874	13742000
89792	2134	96317978000
89793	1874	13745000
89794	1422	16705198860211
89795	1422	16705240860211
89798	1397	1320528187000
89799	1678	23040756913000
89800	260	68399600999959
89801	1397	1320518186000
89802	1678	23040756914000
89803	1397	1320508185000
89804	1678	23040756915000
89805	2133	96753516000
89806	1874	13747000
89807	2133	96752514000
89808	1874	13749000
89809	2133	96751512000
89810	1874	13751000
89811	2134	96316975000
89812	1874	13754000
89813	2134	96315972000
89814	1874	13757000
89815	2134	96314969000
89816	1874	13760000
89817	1671	3263845003785
89818	1671	3263891003785
89835	1394	427686790500000
89836	1394	427686802500000
89850	1650	7111916000000
89851	1249	611783750000000
89852	1650	1552806000000
89853	1375	1704789637751650
89854	1397	1320468181000
89855	1678	23040756919000
89856	2242	190000000
89857	2133	96747504000
89858	1874	13774000
89859	2134	96311960000
89860	1874	13777000
89861	1394	429127022500000
89862	1394	429127264500000
89866	365	66667801000000
89867	365	66668501000000
89868	1536	9187847999959
89869	1536	5266357999959
89870	1536	2620447999959
89871	1536	432097999959
89872	1536	144817999959
89873	260	67534770000000
89874	1874	13676000
89875	1874	13679000
89876	1874	13686000
89877	1874	13687000
89878	1874	13689000
89879	1874	13691000
89880	1874	13693000
89881	1714	18167884103056
89882	1874	13709000
89883	1874	13715000
89884	1874	13718000
89885	1874	13721000
89886	1874	13724000
89887	1874	13730000
89888	1874	13733000
89889	1874	13739000
89890	1874	13753000
89891	1874	13755000
89892	1874	13759000
89893	1874	13761000
89894	1874	13763000
89895	1874	13769000
89896	1874	13771000
89897	1874	13773000
89898	1874	13775000
89899	1714	18887884103056
89900	1714	18887914103056
89915	1706	16052356600135
89924	1397	1320428177000
89925	1678	23040756923000
89926	1659	82999990
89927	548	66720000000000
89928	2134	96307948000
89929	1874	13795000
89930	2133	96743496000
89931	1874	13797000
89932	1394	430567264500000
89933	1394	430567277500000
89955	1397	1320388173000
89956	1678	23040756927000
89957	2133	96739488000
89958	1874	13814000
89959	2134	96303936000
89960	1874	13817000
89961	1654	21165222999798
89962	1654	21165234999798
89979	1693	1622202908632
90045	1773	15460243628123
90046	182	66770027864240
90047	1397	1320308165000
90048	1678	23040756935000
90049	1773	15278506246910
90050	702	44513351909515
90051	1773	13205526326577
90052	927	508636168253115
90053	1773	9490771990539
90054	1047	911471655514890
90055	1773	6984349965506
90056	1167	613988087331615
90057	1293	1713718989828080
90058	2133	96731472000
90059	1874	13854000
90060	2134	96295912000
90061	1874	13857000
90062	2134	96294909000
90063	1874	13860000
90064	1439	7880106968477
90065	1033	906754515920000
90066	1439	2143509578477
90067	1279	1704849979141650
90068	2133	96730470000
90069	1874	13862000
90070	1693	2342202908632
90071	1693	2342278908632
90128	1668	16428284000000
90129	1124	910301631000000
90130	1397	1320258160000
90131	1678	23040756940000
90132	1540	367206120000
90133	1876	703463880000
90134	2133	96725460000
90135	1874	13884000
90136	2132	148238239000
90137	1874	13885000
90138	2134	96289894000
90139	1874	13888000
90140	1688	71280766905200
90162	1394	432007277500000
90163	1394	432007323500000
90177	1397	1320218156000
90178	1678	23040756944000
90179	2134	96285882000
90180	1874	13907000
90181	2133	96721452000
90182	1874	13909000
90183	1726	39731112000
90184	2250	200000000
90185	1467	16526915100039
90200	2133	96718446000
90201	1874	13918000
90202	1419	33555042482725
89828	1678	23040756917000
89829	2134	96313966000
89830	1874	13765000
89831	2133	96749508000
89832	1874	13767000
89833	1610	20880941019950
89834	1610	20880953019950
89909	1397	1320448179000
89910	1678	23040756921000
89911	2134	96309954000
89912	1874	13785000
89913	2133	96745500000
89914	1874	13787000
89965	1397	1320378172000
89966	1678	23040756928000
89967	1397	1320368171000
89968	1678	23040756929000
89969	2134	96302933000
89970	1874	13820000
89971	2134	96301930000
89972	1874	13823000
89973	2133	96738486000
89974	1874	13825000
89975	2133	96737484000
89976	1874	13827000
89977	1689	720023287617
89978	1689	720047287617
90032	1395	58135587207007706
90143	1423	571750023
90144	104	66915395942306
90145	1668	13446953000000
90146	1244	614198650000000
90147	1397	1320248159000
90148	1678	23040756941000
90149	1397	1320238158000
90150	1678	23040756942000
90151	1963	733509120000
90152	2134	96288891000
90153	1874	13891000
90154	2134	96287888000
90155	1874	13894000
90156	2133	96724458000
90157	1874	13896000
90158	2133	96723456000
90159	1874	13898000
90160	1992	19439431990000
90161	1992	19439477990000
90192	1668	2673466000000
90193	1004	507983250000000
90194	1419	36121144987898
90195	139	66576564642539
90196	2133	96719448000
90197	1874	13916000
90198	1395	58136307177007706
90199	1395	58136307189007706
90268	1650	10624110000000
90269	1650	7667000000000
90270	1455	10258005000000
90271	1455	8772905000000
90272	632	72535249000000
90273	632	70574229000000
90274	632	69251209000000
90275	632	68157189000000
90276	1985	2300000000000
90277	1439	11549840548477
90278	1675	15194313999977
90279	1536	7747723999959
90280	1536	3826233999959
90281	606	79675027812962
90282	1675	11202303999977
90283	1675	8508293999977
90284	1675	1003283999977
90285	1476	10838451000000
90286	1536	1180323999959
90287	1684	24409822847948
90288	1684	24200387059336
90289	1684	23990951270724
90290	1684	23781515482112
90291	1684	23572079693500
90292	1684	23362643904888
90293	1694	22924142263738
90294	1694	22663479366853
90295	1439	9491194888477
90296	1727	15226845999999
90297	1419	33961118987898
90298	1419	31395016482725
90299	1419	3167923560130
90300	361	66603937193897
90301	1719	16543029000000
90302	1727	11212144999999
90303	1727	8503343999999
90304	1727	955142999999
90305	1727	661032999999
90306	1701	12814989874296
90307	1719	11314328000000
90308	1719	7786427000000
90309	1701	11173672916880
90310	1701	8232447783976
90311	1701	6247944253479
90312	1701	717950500103
90313	1874	12202000
90314	1874	12204000
90315	1773	1983844699931
90316	1874	12208000
90317	1700	21907732276737
90330	1397	1320148149000
90331	1678	23040756951000
90332	1397	1320138148000
90333	1678	23040756952000
90334	1397	1320128147000
90335	1678	23040756953000
90336	2133	96710430000
90337	1874	13961000
90338	2134	96275852000
90339	1874	13964000
90340	2134	96274849000
90341	1874	13967000
90342	2134	96273846000
90343	1874	13970000
90344	2132	148233234000
90345	1874	13971000
90346	2133	96709428000
90347	1874	13973000
90348	2133	96708426000
90349	1874	13975000
90350	1395	58137747203007706
90351	1395	58137747240007706
90412	1397	1320108145000
90413	1678	23040756955000
90414	1397	1320098144000
90415	1678	23040756956000
90416	1397	1320088143000
90417	1678	23040756957000
90418	2133	96706422000
90419	1874	13982000
90420	2133	96705420000
90421	1874	13984000
90422	2133	96704418000
90423	1874	13986000
90424	2134	96271840000
90425	1874	13989000
90426	2134	96270837000
90427	1874	13992000
90428	2134	96269834000
90429	1874	13995000
90430	2132	148232233000
90431	1874	13996000
90432	1719	1440024000000
90433	1719	1440061000000
90454	1397	1320058140000
90455	1678	23040756960000
90456	1397	1320048139000
90457	1678	23040756961000
90458	1397	1320038138000
90459	1678	23040756962000
90460	2133	96701412000
90461	1874	14009000
90462	2134	96266825000
90463	1874	14012000
90464	2134	96265822000
90465	1874	14015000
90466	2134	96264819000
90467	1874	14018000
90468	2133	96700410000
90469	1874	14020000
90470	2133	96699408000
90471	1874	14022000
90472	1654	21885234999798
90473	1654	21885270999798
90494	1397	1319998134000
90495	1678	23040756966000
90496	1700	13315653400429
90497	1305	1709013975785189
90498	1700	10232849655741
90499	1179	613299639053204
90500	2132	148229230000
90501	1874	14036000
90502	2133	96695400000
90503	1874	14038000
90504	2134	96261810000
90505	1874	14041000
90506	1672	27362252000000
90507	1672	27362285000000
90523	1700	3114155979053
90524	939	507239718081690
90087	323	66631395942306
90088	1423	2126397615393
90089	330	66631395942306
90090	1423	1758034442319
90091	332	66631395942306
90092	1423	1389671269245
90093	334	66631395942306
90094	1423	1021308096171
90095	343	66631395942306
90096	1423	652944923097
90097	559	66631395942306
90098	1423	284581750023
90099	561	66631395942306
90100	1397	1320298164000
90101	1678	23040756936000
90102	1610	720011999950
90103	1983	2734125920000
90104	1397	1320288163000
90105	1678	23040756937000
90106	1397	1320278162000
90107	1678	23040756938000
90108	1397	1320268161000
90109	1678	23040756939000
90110	2133	96729468000
90111	1874	13864000
90112	2134	96293906000
90113	1874	13867000
90114	2134	96292903000
90115	1874	13870000
90116	2134	96291900000
90117	1874	13873000
90118	2133	96728466000
90119	1874	13875000
90120	2133	96727464000
90121	1874	13877000
90122	2133	96726462000
90123	1874	13879000
90124	2134	96290897000
90125	1874	13882000
90126	1675	2443396999977
90127	1675	2444104999977
90164	1668	5139227000000
90165	1370	1711519148751650
90166	1397	1320228157000
90167	1678	23040756943000
90168	2133	96722454000
90169	1874	13900000
90170	2132	148237238000
90171	1874	13901000
90172	2134	96286885000
90173	1874	13904000
90174	1726	40932112000
90175	2249	200000000
90176	1395	58135587177007706
90224	1692	42260733619999
90225	1692	42260747619999
90258	1439	3583546578477
90259	1439	3583559578477
90318	1874	13531000
90319	1874	13534000
90320	1874	13537000
90321	1874	13539000
90322	1874	13541000
90323	1419	34681121987898
90324	1419	32115019482725
90325	1419	3887926560130
90326	1719	17983066000000
90327	1874	13542000
90328	1690	140407624499992
90329	1690	140408387499992
90358	1650	5671890000000
90359	1650	112780000000
90360	1670	11906159000000
90361	1670	6749059000000
90362	1670	3268959000000
90363	1670	390859000000
90364	1423	3984936826911
90365	1423	3616573653837
90366	1423	3248210480763
90367	1423	2879847307689
90368	1423	2511484134615
90369	1423	2143120961541
90370	1423	1774757788467
90371	1423	1406394615393
90372	1423	1038031442319
90373	1423	669668269245
90374	1423	301305096171
90375	632	73977744000000
90376	632	72016724000000
90377	632	70693704000000
90378	632	69599684000000
90379	632	69602224000000
90380	1594	8402053000000
90381	606	78675017812962
90382	1594	5645893000000
90383	1594	1561003000000
90384	1684	23153208116276
90385	1684	22943772327664
90386	1684	22734336539052
90387	1684	22524900750440
90388	1684	22315464961828
90389	1684	22106029173216
90390	1684	21896593384604
90391	1684	21687157595992
90392	1684	21477721807380
90393	1684	21268286018768
90394	1684	21058850230156
90395	1684	20849414441544
90396	1684	20639978652932
90397	1684	20430542864320
90398	1684	20221107075708
90399	1684	20011671287096
90400	1684	19802235498484
90401	1684	19592799709872
90402	1684	19383363921260
90403	1684	19173928132648
90404	1684	18964492344036
90405	1684	18755056555424
90406	1684	18545620766812
90407	1684	18336184978200
90408	632	70322224000000
90409	632	200000002
90410	2128	70323113999991
90411	1571	2380465313992
90441	1467	17246915100039
90442	1467	17246927100039
90445	1397	1320068141000
90446	1678	23040756959000
90447	2133	96702414000
90448	1874	14003000
90449	2132	148231232000
90450	1874	14004000
90451	2134	96267828000
90452	1874	14007000
90453	1394	432007290500000
90556	1397	1319938128000
90557	1678	23040756972000
90558	2134	96255792000
90559	1874	14070000
90560	2133	96689388000
90561	1874	14072000
90562	1693	2342214908632
90566	1874	13972000
90567	1874	13974000
90568	1874	13979000
90569	1874	13981000
90570	1874	13983000
90571	1874	13985000
90572	1874	13987000
90573	1874	13991000
90574	1874	13993000
90575	1874	13997000
90576	1874	13999000
90577	1874	14005000
90578	1874	14011000
90579	1874	14013000
90580	1874	14021000
90581	1874	14024000
90582	1874	14027000
90583	1874	14033000
90584	1874	14039000
90585	1874	14042000
90586	1874	14045000
90587	1874	14051000
90588	1874	14054000
90589	1874	14060000
90590	1874	14063000
90591	1874	14066000
90592	1874	14069000
90593	1439	4303868578477
90609	1439	5023571578477
90610	1439	5023583578477
90615	1397	1319908125000
90616	1678	23040756975000
90617	1397	1319898124000
90618	1678	23040756976000
90619	2226	9000000
90620	391	66650162116779
90621	2133	96686382000
90622	1874	14082000
90623	2134	96253786000
90624	1874	14085000
90625	2134	96252783000
90626	1874	14088000
90627	2132	148226227000
90203	813	504369561562206
90204	1419	5327949560130
90205	814	5548060335240798
90206	2134	96283876000
90207	1874	13921000
90208	2132	148236237000
90209	1874	13922000
90210	1768	20751095110000
90211	1768	20751100110000
90226	1397	1320198154000
90227	1678	23040756946000
90228	1397	1320188153000
90229	1678	23040756947000
90230	1397	1320178152000
90231	1678	23040756948000
90232	2132	148235236000
90233	1874	13933000
90234	2134	96280867000
90235	1874	13936000
90236	2133	96715440000
90237	1874	13938000
90238	2133	96714438000
90239	1874	13940000
90240	2133	96713436000
90241	1874	13942000
90242	2134	96279864000
90243	1874	13945000
90244	2134	96278861000
90245	1874	13948000
90246	1439	2863509578477
90247	1439	2863546578477
90443	1419	6047949560130
90444	1419	6047961560130
90474	1397	1320028137000
90475	1678	23040756963000
90476	2134	96263816000
90477	1874	14025000
90478	2132	148230231000
90479	1874	14026000
90480	2133	96698406000
90481	1874	14028000
90482	1509	19392104851155
90508	1549	26256111000000
90509	1549	26256144000000
90512	1397	1319988133000
90513	1678	23040756967000
90514	1700	5663842025733
90515	1059	908969210852514
90516	2133	96694398000
90517	1874	14043000
90518	2134	96260807000
90519	1874	14046000
90520	1679	25919318653000
90548	1397	1319948129000
90549	1678	23040756971000
90550	2134	96256795000
90551	1874	14065000
90552	2133	96690390000
90553	1874	14067000
90554	1395	58138467240007706
90555	1395	58138467252007706
90563	1439	4303559578477
90564	1439	4303571578477
90608	1471	24380182900000
90611	1874	14077000
90612	1874	14079000
90613	1439	5023868578477
90614	1439	5023892578477
90633	1397	1319888123000
90634	1678	23040756977000
90635	2133	96684378000
90636	1874	14093000
90637	2134	96251780000
90638	1874	14096000
90639	1394	433447290500000
90640	1394	433447302500000
90664	1749	10085407930000
90686	1395	58140627327007706
90755	1705	15755640500145
90780	1397	1319758110000
90781	1678	23040756990000
90782	2133	96672354000
90783	1874	14157000
90784	2134	96239744000
90785	1874	14160000
90786	1613	18648087600000
90787	1613	18648099600000
90806	1394	437767338500000
90807	1394	437767360500000
90809	1397	1319728107000
90810	1678	23040756993000
90811	606	71199912097546
90812	1049	908328241448562
90813	606	68773495946091
90814	1169	612867818037067
90815	606	66766513286230
90816	929	506882910895171
90817	2134	96236735000
90818	1874	14173000
90819	2132	148221222000
90820	1874	14174000
90821	2133	96669348000
90822	1874	14176000
90823	1395	58140627333007706
90847	1397	1319688103000
90848	1678	23040756997000
90849	1397	1319678102000
90850	1678	23040756998000
90851	2133	96665340000
90852	1874	14194000
90853	2134	96232723000
90854	1874	14197000
90855	2133	96664338000
90856	1874	14199000
90857	2134	96231720000
90858	1874	14202000
90859	1943	2878931000000
90860	1943	2878955000000
90931	1690	140404476000000
90932	1690	140404501000000
90996	1397	1319498084000
90997	1678	23040757016000
90998	2134	96214669000
90999	1874	14292000
91000	2132	148214215000
91001	1874	14293000
91002	1547	19293718000000
91003	1547	19293730000000
91026	369	88836792000000
91120	1397	1319378072000
91121	1678	23040757028000
91122	2134	96202633000
91123	1874	14358000
91124	2133	96633276000
91125	1874	14360000
91126	2132	148210211000
91127	1874	14361000
91128	1679	26639318653000
91129	1679	26639331653000
91185	1448	10836835000001
91190	1601	7813633620000
91200	1394	443527422500000
91201	1394	443527434500000
91237	1397	1319258060000
91238	1678	23040757040000
91239	2134	96191600000
91240	1874	14419000
91241	2133	96621252000
91242	1874	14421000
91243	1394	444967434500000
91244	1394	444967446500000
91296	1397	1319188053000
91297	1678	23040757047000
91298	1397	1319178052000
91299	1678	23040757048000
91300	2134	96184579000
91301	1874	14456000
91302	2132	148204205000
91303	1874	14457000
91304	2133	96614238000
91305	1874	14459000
91306	2133	96613236000
91307	1874	14461000
91308	2134	96183576000
91309	1874	14464000
91342	1397	1319128047000
91343	1678	23040757053000
91344	2133	96608226000
91345	1874	14487000
91346	2134	96178561000
91347	1874	14490000
91371	1681	18503455759830
91372	1681	18503457759830
91424	1397	1319058040000
91425	1678	23040757060000
91426	1397	1319048039000
91427	1678	23040757061000
91428	2134	96171540000
91429	1874	14525000
91430	2134	96170537000
91431	1874	14528000
91432	2133	96601212000
91433	1874	14530000
91434	2133	96600210000
91435	1874	14532000
90437	1874	13998000
90438	2134	96268831000
90439	1874	14001000
90440	1394	432007289500000
90483	1397	1320018136000
90484	1678	23040756964000
90485	1397	1320008135000
90486	1678	23040756965000
90487	2133	96697404000
90488	1874	14030000
90489	2133	96696402000
90490	1874	14032000
90491	2134	96262813000
90492	1874	14035000
90493	1690	138964454000000
90510	606	81555194812962
90511	606	81555227812962
90521	1698	21417203550035
90522	1698	21417225550035
90540	1397	1319958130000
90541	1678	23040756970000
90542	2133	96691392000
90543	1874	14059000
90544	2134	96257798000
90545	1874	14062000
90546	2248	1439240000000
90547	2248	1439252000000
90565	1601	7813620620000
90594	1397	1319928127000
90595	1678	23040756973000
90596	2133	96688386000
90597	1874	14074000
90598	2132	148227228000
90599	1874	14075000
90600	1395	58139187252007706
90601	1395	58139187264007706
90641	1397	1319878122000
90642	1678	23040756978000
90643	1397	1319868121000
90644	1678	23040756979000
90645	2132	148225226000
90646	1874	14097000
90647	2134	96250777000
90648	1874	14100000
90649	2133	96683376000
90650	1874	14102000
90651	2133	96682374000
90652	1874	14104000
90653	2134	96249774000
90654	1874	14107000
90655	1693	2342227908632
90662	1395	58140627290007706
90663	1395	58140627315007706
90687	1717	20988264000023
90688	1717	20988301000023
90689	1397	1319828117000
90690	1678	23040756983000
90691	2132	148224225000
90692	1874	14120000
90693	2134	96246765000
90694	1874	14123000
90695	1850	21519311949999
90696	1850	21519323949999
90698	1397	1319818116000
90699	1678	23040756984000
90700	1397	1319808115000
90701	1678	23040756985000
90702	2133	96678366000
90703	1874	14125000
90704	2133	96677364000
90705	1874	14127000
90706	2134	96245762000
90707	1874	14130000
90708	2134	96244759000
90709	1874	14133000
90710	1656	21741740999990
90711	1656	21741764999990
90714	1397	1319798114000
90715	1678	23040756986000
90716	2134	96243756000
90717	1874	14136000
90718	2133	96676362000
90719	1874	14138000
90720	2132	148223224000
90721	1874	14139000
90722	1668	3393466000000
90723	1668	3393479000000
90756	1439	5743583578477
90757	1439	5743596578477
90788	1397	1319748109000
90789	1678	23040756991000
90790	2134	96238741000
90791	1874	14163000
90792	2133	96671352000
90793	1874	14165000
90794	1559	17962846000000
90795	1559	17962858000000
90808	1395	58140627312007706
90861	1397	1319668101000
90862	1678	23040756999000
90863	1397	1319658100000
90864	1678	23040757000000
90865	2132	148219220000
90866	1874	14203000
90867	2133	96663336000
90868	1874	14205000
90869	2133	96662334000
90870	1874	14207000
90871	2134	96230717000
90872	1874	14210000
90873	2134	96229714000
90874	1874	14213000
90875	1610	1440011999950
90876	1610	1440036999950
90877	1397	1319648099000
90878	1678	23040757001000
90879	1397	1319638098000
90880	1678	23040757002000
90881	1397	1319628097000
90882	1678	23040757003000
90883	2133	96661332000
90884	1874	14215000
90885	2134	96228711000
90886	1874	14218000
90887	2132	148218219000
90888	1874	14219000
90889	2133	96660330000
90890	1874	14221000
90891	2134	96227708000
90892	1874	14224000
90893	1394	437767385500000
90894	2133	96659328000
90895	1874	14226000
90896	1394	439207385500000
90897	1394	439207386500000
90901	1397	1319618096000
90902	1678	23040757004000
90903	2134	96226705000
90904	1874	14229000
90905	2133	96658326000
90906	1874	14231000
90907	1992	20159477990000
90908	1992	20159489990000
90933	1397	1319578092000
90934	1678	23040757008000
90935	1397	1319568091000
90936	1678	23040757009000
90937	1397	1319558090000
90938	1678	23040757010000
90939	1397	1319548089000
90940	1678	23040757011000
90941	2133	96654318000
90942	1874	14249000
90943	2134	96222693000
90944	1874	14252000
90945	2133	96653316000
90946	1874	14254000
90947	2133	96652314000
90948	1874	14256000
90949	2133	96651312000
90950	1874	14258000
90951	2132	148216217000
90952	1874	14259000
90953	2134	96221690000
90954	1874	14262000
90955	2134	96220687000
90956	1874	14265000
90957	2134	96219684000
90958	1874	14268000
90959	1395	58141347333007706
90960	1395	58141347382007706
90962	1397	1319538088000
90963	1678	23040757012000
90964	2133	96650310000
90965	1874	14270000
90966	2134	96218681000
90967	1874	14273000
90970	1685	137522836571430
90971	1685	137522848571430
90972	1397	1319528087000
90973	1678	23040757013000
90974	1397	1319518086000
90975	1678	23040757014000
90976	2132	148215216000
90977	1874	14274000
90525	1397	1319978132000
90526	1678	23040756968000
90527	1397	1319968131000
90528	1678	23040756969000
90529	2133	96693396000
90530	1874	14048000
90531	2133	96692394000
90532	1874	14050000
90533	2134	96259804000
90534	1874	14053000
90535	2134	96258801000
90536	1874	14056000
90537	2132	148228229000
90538	1874	14057000
90539	633	85324181900000
90602	1397	1319918126000
90603	1678	23040756974000
90604	2134	96254789000
90605	1874	14078000
90606	2133	96687384000
90607	1874	14080000
90658	1874	14099000
90659	1874	14101000
90660	1723	21239550085979
90661	1723	21239573085979
90684	1560	22194487277001
90685	1560	22194524277001
90745	1397	1319768111000
90746	1678	23040756989000
90747	2134	96240747000
90748	1874	14152000
90749	2133	96673356000
90750	1874	14154000
90751	2132	148222223000
90752	1874	14155000
90753	1457	25104522040000
90754	1457	25104535040000
90758	1710	2393872664140
90759	1280	1709955533869714
90760	1874	14094000
90761	1874	14095000
90762	1874	14098000
90763	1874	14108000
90764	1874	14111000
90765	1874	14114000
90766	1874	14117000
90767	1439	5024100578477
90768	1874	14126000
90769	1874	14129000
90770	1874	14131000
90771	1874	14135000
90772	1874	14137000
90773	1874	14141000
90774	1874	14143000
90775	1874	14145000
90776	1874	14151000
90777	1874	14153000
90778	1439	5744100578477
90779	1439	5744116578477
90796	606	74795607916843
90797	1295	1707807077084620
90798	1397	1319738108000
90799	1678	23040756992000
90800	2133	96670350000
90801	1874	14167000
90802	2134	96237738000
90803	1874	14170000
90804	1690	139684454000000
90805	1690	139684476000000
90831	1710	2393862664140
90832	1397	1319708105000
90833	1678	23040756995000
90834	1397	1319698104000
90835	1678	23040756996000
90836	2134	96234729000
90837	1874	14184000
90838	2132	148220221000
90839	1874	14185000
90840	2133	96667344000
90841	1874	14187000
90842	2133	96666342000
90843	1874	14189000
90844	2134	96233726000
90845	1874	14192000
90846	2248	1439285000000
90915	1397	1319598094000
90916	1678	23040757006000
90917	1397	1319588093000
90918	1678	23040757007000
90919	2134	96224699000
90920	1874	14239000
90921	2134	96223696000
90922	1874	14242000
90923	2133	96656322000
90924	1874	14244000
90925	2133	96655320000
90926	1874	14246000
90927	2132	148217218000
90928	1874	14247000
90929	1711	3306324000000
90930	1711	3306349000000
90968	1874	14271000
90969	1634	20352363641004
91011	1547	19293731000000
91012	1397	1319488083000
91013	1678	23040757017000
91014	1397	1319478082000
91015	1678	23040757018000
91016	2133	96645300000
91017	1874	14297000
91018	2133	96644298000
91019	1874	14299000
91020	2134	96213666000
91021	1874	14302000
91022	2134	96212663000
91023	1874	14305000
91024	1719	2160061000000
91025	1719	2160086000000
91034	1395	58141347345007706
91043	1559	18682858000000
91044	1559	18682870000000
91061	1694	4138761197225
91107	1395	58141347357007706
91108	1536	8467735999959
91109	1536	4546245999959
91110	1700	12595641400429
91111	1700	9512837655741
91112	1700	4943830025733
91113	1700	2394143979053
91114	42	77233202000000
91115	606	71915397916843
91116	606	68319702097546
91117	1536	1900335999959
91118	42	77953202000000
91119	42	77953722000000
91143	1580	2160032000000
91144	1580	2160056000000
91163	1685	136802857571430
91164	1685	137522857571430
91165	1685	137522860571430
91177	2133	96629268000
91178	1874	14378000
91179	1874	14381000
91180	1874	14384000
91181	2133	96628266000
91182	1874	14386000
91183	1874	14387000
91184	2106	4319096000000
91187	1429	555000000000
91188	1448	10281810000001
91189	1448	10281835000001
91192	1397	1319318066000
91193	1678	23040757034000
91194	2133	96627264000
91195	1874	14389000
91196	2134	96196615000
91197	1874	14392000
91198	2248	2159285000000
91199	2248	2159297000000
91221	1397	1319278062000
91222	1678	23040757038000
91223	1397	1319268061000
91224	1678	23040757039000
91225	2134	96193606000
91226	1874	14408000
91227	2133	96623256000
91228	1874	14410000
91229	2133	96622254000
91230	1874	14412000
91231	2134	96192603000
91232	1874	14415000
91233	2132	148207208000
91234	1874	14416000
91235	1395	58142067369007706
91236	1395	58142067394007706
91247	1397	1319248059000
91248	1678	23040757041000
91249	1397	1319238058000
91250	1678	23040757042000
91251	2134	96190597000
91252	1874	14424000
91253	2133	96620250000
91254	1874	14426000
91255	2133	96619248000
91256	1874	14428000
90628	1874	14089000
90629	2133	96685380000
90630	1874	14091000
90631	1395	58139907264007706
90632	1395	58139907290007706
90656	1394	434887302500000
90657	1394	434887327500000
90665	1397	1319858120000
90666	1678	23040756980000
90667	1397	1319848119000
90668	1678	23040756981000
90669	1397	1319838118000
90670	1678	23040756982000
90671	2133	96681372000
90672	1874	14103000
90673	2133	96680370000
90674	1874	14105000
90675	2133	96679368000
90676	1874	14110000
90677	1874	14113000
90678	2134	96248771000
90679	1874	14116000
90680	2134	96247768000
90681	1874	14119000
90682	1710	23274832473290
90683	1710	23274869473290
90697	1394	434887314500000
90712	1394	436327314500000
90713	1394	436327338500000
90724	1397	1319788113000
90725	1678	23040756987000
90726	2134	96242753000
90727	1874	14142000
90728	2133	96675360000
90729	1874	14144000
90730	1686	19652204550062
90731	1686	19652216550062
90732	1397	1319778112000
90733	1678	23040756988000
90734	1710	19819405209850
90735	914	507519164923296
90736	1710	14917550910810
90737	1034	909469995118336
90738	1710	11610168886100
90739	1154	613637528176164
90740	2134	96241750000
90741	1874	14147000
90742	2133	96674358000
90743	1874	14149000
90744	1489	20064535000000
90824	1397	1319718106000
90825	1678	23040756994000
90826	2133	96668346000
90827	1874	14178000
90828	2134	96235732000
90829	1874	14181000
90830	1394	437767350500000
90898	484	73628929000000
90899	484	74348929000000
90900	484	74348930000000
90909	1397	1319608095000
90910	1678	23040757005000
90911	2133	96657324000
90912	1874	14233000
90913	2134	96225702000
90914	1874	14236000
90961	1695	2824979999000
90988	1397	1319508085000
90989	1678	23040757015000
90990	2134	96215672000
90991	1874	14287000
90992	2133	96647304000
90993	1874	14289000
90994	1394	440647386500000
90995	1394	440647398500000
91010	1688	71280754905200
91027	1397	1319468081000
91028	1678	23040757019000
91029	2132	148213214000
91030	1874	14306000
91031	2133	96643296000
91032	1874	14308000
91033	1698	21417215550035
91035	1397	1319458080000
91036	1678	23040757020000
91037	2134	96211660000
91038	1874	14311000
91039	2133	96642294000
91040	1874	14313000
91041	633	86764206900000
91042	633	86764218900000
91057	1874	14316000
91058	1874	14319000
91059	1694	4138747197225
91060	1694	4138759197225
91062	1397	1319438078000
91063	1678	23040757022000
91064	1397	1319428077000
91065	1678	23040757023000
91066	2132	148212213000
91067	1874	14324000
91068	2133	96639288000
91069	1874	14326000
91070	2133	96638286000
91071	1874	14328000
91072	2134	96208651000
91073	1874	14331000
91074	2134	96207648000
91075	1874	14334000
91076	1394	442087398500000
91077	1394	442087423500000
91094	1397	1319398074000
91095	1678	23040757026000
91096	1397	1319388073000
91097	1678	23040757027000
91098	2134	96204639000
91099	1874	14348000
91100	2134	96203636000
91101	1874	14351000
91102	2133	96635280000
91103	1874	14353000
91104	2133	96634278000
91105	1874	14355000
91106	1587	720024000000
91131	1874	14356000
91132	1633	15156717975638
91133	1397	1319368071000
91134	1678	23040757029000
91135	1874	14359000
91136	2134	96201630000
91137	1874	14362000
91138	1874	14364000
91139	2133	96632274000
91140	1874	14366000
91141	58	90426660999641
91142	58	90426684999641
91160	1394	440647419500000
91161	1394	442087419500000
91162	1394	442087422500000
91166	1397	1319338068000
91167	1678	23040757032000
91168	1397	1319328067000
91169	1678	23040757033000
91170	2134	96198621000
91171	1874	14379000
91172	2134	96197618000
91173	1874	14382000
91174	2132	148209210000
91175	1874	14383000
91176	1426	24045233000000
91202	1397	1319308065000
91203	1678	23040757035000
91204	1397	1319298064000
91205	1678	23040757036000
91206	1397	1319288063000
91207	1678	23040757037000
91208	2134	96195612000
91209	1874	14395000
91210	2133	96626262000
91211	1874	14397000
91212	2133	96625260000
91213	1874	14399000
91214	2133	96624258000
91215	1874	14401000
91216	2134	96194609000
91217	1874	14404000
91218	2132	148208209000
91219	1874	14405000
91220	1395	58141347369007706
91270	1397	1319218056000
91271	1678	23040757044000
91272	2134	96187588000
91273	1874	14440000
91274	2133	96617244000
91275	1874	14442000
91278	1397	1319208055000
91279	1678	23040757045000
91280	2134	96186585000
91281	1874	14445000
91282	2132	148205206000
91283	1874	14446000
91284	2133	96616242000
91285	1874	14448000
91286	43	84000972890000
91287	43	84000985890000
90978	2134	96217678000
90979	1874	14277000
90980	2134	96216675000
90981	1874	14280000
90982	2133	96649308000
90983	1874	14282000
90984	2133	96648306000
90985	1874	14284000
90986	633	86044181900000
90987	633	86044206900000
91004	2133	96646302000
91005	1874	14291000
91006	1874	14294000
91007	1874	14295000
91008	1710	3113862664140
91009	1710	3113875664140
91045	1397	1319448079000
91046	1678	23040757021000
91047	2133	96641292000
91048	1874	14315000
91049	2134	96210657000
91050	1874	14318000
91051	2133	96640290000
91052	1874	14320000
91053	2134	96209654000
91054	1874	14323000
91055	1402	70414923319298
91056	1402	70414937319298
91078	1397	1319418076000
91079	1678	23040757024000
91080	1397	1319408075000
91081	1678	23040757025000
91082	2134	96206645000
91083	1874	14337000
91084	2132	148211212000
91085	1874	14338000
91086	2133	96637284000
91087	1874	14340000
91088	2133	96636282000
91089	1874	14342000
91090	2134	96205642000
91091	1874	14345000
91092	576	84005346726895
91093	576	84005371726895
91130	1394	442087411500000
91145	1397	1319358070000
91146	1678	23040757030000
91147	1397	1319348069000
91148	1678	23040757031000
91149	2133	96631272000
91150	1874	14368000
91151	1679	25919339653000
91152	2133	96630270000
91153	1874	14370000
91154	2134	96200627000
91155	1874	14373000
91156	2134	96199624000
91157	1874	14376000
91158	1679	26639339653000
91159	1679	26639342653000
91186	1426	24045235000000
91191	1692	42260758619999
91245	1693	3062214908632
91246	1693	3062226908632
91262	1397	1319228057000
91263	1678	23040757043000
91264	2134	96188591000
91265	1874	14435000
91266	2133	96618246000
91267	1874	14437000
91268	1395	58142787394007706
91269	1395	58142787406007706
91318	1397	1319158050000
91319	1678	23040757050000
91320	2134	96181570000
91321	1874	14472000
91322	2133	96611232000
91323	1874	14474000
91324	1596	20881006000000
91325	1596	20881018000000
91348	1723	21959573085979
91349	1723	21959585085979
91353	1397	1319118046000
91354	1678	23040757054000
91355	2134	96177558000
91356	1874	14493000
91357	2133	96607224000
91358	1874	14495000
91359	470	66720053000000
91360	470	66720065000000
91373	1681	18503468759830
91390	2133	96605220000
91391	2133	96604218000
91392	1874	14505000
91393	2133	96603216000
91394	1874	14507000
91395	1874	14508000
91396	1874	14511000
91397	1874	14514000
91398	1681	18503504759830
91399	1874	14517000
91400	1681	19223504759830
91401	1681	19223505759830
91438	1397	1319038038000
91439	1678	23040757062000
91440	2134	96169534000
91441	1874	14535000
91442	2132	148200201000
91443	1874	14536000
91444	2133	96599208000
91445	1874	14538000
91446	1395	58143507406007706
91447	1395	58143507419007706
91452	1688	72000766905200
91453	1688	72000779905200
91509	1397	1318988033000
91510	1678	23040757067000
91511	2134	96165522000
91512	1874	14559000
91513	2133	96594198000
91514	1874	14561000
91567	149	85710616000341
91646	1397	1318828017000
91647	1678	23040757083000
91648	2133	96578166000
91649	1874	14637000
91650	2134	96150477000
91651	1874	14640000
91652	1395	58145667465007706
91653	1395	58145667477007706
91657	1637	238325648819988
91658	1637	238325660819988
91677	1571	1872029151056
91678	1571	2592029151056
91679	1571	2592031151056
91729	1397	1318758010000
91730	1678	23040757090000
91731	1596	12279145859486
91732	1363	1709955533869748
91733	2133	96571152000
91734	1874	14669000
91735	2134	96144459000
91736	1874	14672000
91737	1691	20843395100019
91738	1691	20843412100019
91768	1444	18952370159999
91769	1444	18952382159999
91836	1397	1318668001000
91837	1678	23040757099000
91838	2134	96135432000
91839	1874	14713000
91840	2133	96563136000
91841	1874	14715000
91842	1395	58147107487507701
91843	1395	58147107499507701
91853	1932	38799152658
91854	1397	1318647999000
91855	1678	23040757101000
91856	1397	1318637998000
91857	1678	23040757102000
91858	1560	21169652986418
91859	1560	20864818695835
91860	1560	20559984405252
91861	1874	14678000
91862	1874	14681000
91863	1874	14693000
91864	1874	14695000
91865	1874	14699000
91866	1874	14701000
91867	1874	14703000
91868	1874	14709000
91869	1874	14711000
91870	2133	96561132000
91871	1874	14716000
91872	1874	14719000
91873	1560	20255150114669
91874	1560	19950315824086
91875	1560	19645481533503
91876	1560	19340647242920
91877	1560	19035812952337
91878	1560	18730978661754
91879	1874	14722000
91880	2134	96133426000
91881	1874	14725000
91882	2134	96132423000
91257	2134	96189594000
91258	1874	14431000
91259	2132	148206207000
91260	1874	14432000
91261	1685	137522861571430
91276	1685	138242861571430
91277	1685	138242873571430
91288	1397	1319198054000
91289	1678	23040757046000
91290	2133	96615240000
91291	1874	14450000
91292	2134	96185582000
91293	1874	14453000
91294	1573	15099269000000
91295	1573	15099281000000
91361	1397	1319108045000
91362	1678	23040757055000
91363	2134	96176555000
91364	1874	14498000
91365	2132	148202203000
91366	1874	14499000
91367	2133	96606222000
91368	1874	14501000
91369	1394	446407446500000
91370	1394	446407459500000
91374	1397	1319098044000
91375	1678	23040757056000
91376	1397	1319088043000
91377	1678	23040757057000
91378	1397	1319078042000
91379	1678	23040757058000
91380	2132	148201202000
91381	1874	14500000
91382	2134	96175552000
91383	1874	14503000
91384	2134	96174549000
91385	1874	14506000
91386	2134	96173546000
91387	1874	14509000
91388	1681	19223457759830
91389	1681	19223501759830
91402	1397	1319068041000
91403	1678	23040757059000
91404	1610	1440046999950
91405	1681	18947743296868
91406	531	66683261448682
91407	2134	96172543000
91408	1874	14512000
91409	1874	14516000
91410	1874	14518000
91411	1874	14520000
91412	2133	96602214000
91413	1874	14522000
91414	1681	16850589061564
91415	984	507975067800536
91416	1681	13092507432300
91417	1104	910286969168176
91418	1681	10556854546689
91419	1224	614188756846949
91420	1681	3491034109853
91421	1350	1711491581573374
91422	1610	2160046999950
91423	1610	2160057999950
91448	149	85710601000341
91449	149	85710614000341
91465	1458	21693828908540
91501	1397	1318998034000
91502	1678	23040757066000
91503	2133	96595200000
91504	1874	14553000
91505	2134	96166525000
91506	1874	14556000
91507	1547	20013730000000
91508	1547	20013742000000
91530	1397	1318958030000
91531	1678	23040757070000
91532	1397	1318948029000
91533	1678	23040757071000
91534	2133	96591192000
91535	1874	14574000
91536	2134	96162513000
91537	1874	14577000
91538	2133	96590190000
91539	1874	14579000
91540	2134	96161510000
91541	1874	14582000
91542	1395	58144227453007706
91582	1397	1318918026000
91583	1678	23040757074000
91584	1397	1318908025000
91585	1678	23040757075000
91586	2134	96158501000
91587	1874	14596000
91588	2133	96587184000
91589	1874	14598000
91590	2133	96586182000
91591	1874	14600000
91592	1402	71134937319298
91593	1402	71134960319298
91609	1397	1318878022000
91610	1678	23040757078000
91611	2134	96155492000
91612	1874	14613000
91613	2133	96583176000
91614	1874	14615000
91615	1756	11233192545609
91616	1756	11233204545609
91638	1397	1318838018000
91639	1678	23040757082000
91640	2134	96151480000
91641	1874	14633000
91642	2133	96579168000
91643	1874	14635000
91644	1680	18009739490035
91645	1680	18009751490035
91656	1688	72720791905200
91680	1397	1318798014000
91681	1678	23040757086000
91682	2134	96148471000
91683	1874	14650000
91684	2133	96575160000
91685	1874	14652000
91686	1402	71134949319298
91739	1397	1318748009000
91740	1678	23040757091000
91741	1596	7704086180381
91742	1117	909469995118338
91743	1596	4617200623985
91744	1237	613637528176164
91745	1596	2064139511435
91746	997	507519164923307
91747	2134	96143456000
91748	1874	14675000
91749	2133	96570150000
91750	1874	14677000
91751	1560	22194514277001
91770	1932	1382938664093
91771	1397	1318718006000
91772	1678	23040757094000
91773	2134	96140447000
91774	1874	14690000
91775	1684	722724219748
91776	1684	722745219748
91822	2134	96137438000
91823	1874	14705000
91824	1394	449287482500000
91825	1394	449287508500000
91828	1397	1318678002000
91829	1678	23040757098000
91830	1932	1382928664093
91831	2133	96564138000
91832	1874	14707000
91833	2134	96136435000
91834	1874	14710000
91835	1688	72720801905200
91893	1874	14723000
91894	1419	7487973560130
91895	1419	7487997560130
91908	1690	141844538000000
91915	1397	1318597994000
91916	1678	23040757106000
91917	2134	96129414000
91918	1874	14745000
91919	2133	96556122000
91920	1874	14747000
91921	1402	71854949319298
91922	1402	71854961319298
91931	1397	1318587993000
91932	1678	23040757107000
91933	2133	96555120000
91934	1874	14749000
91935	2134	96128411000
91936	1874	14752000
91937	1509	20112106351155
91938	1509	20112118351155
91941	1397	1318577992000
91942	1678	23040757108000
91943	1397	1318567991000
91944	1678	23040757109000
91945	1397	1318557990000
91946	1678	23040757110000
91947	2133	96554118000
91948	1874	14754000
91949	2134	96127408000
91950	1874	14757000
91310	1397	1319168051000
91311	1678	23040757049000
91312	2133	96612234000
91313	1874	14466000
91314	2134	96182573000
91315	1874	14469000
91316	1559	19402870000000
91317	1559	19402882000000
91326	1397	1319148049000
91327	1678	23040757051000
91328	1397	1319138048000
91329	1678	23040757052000
91330	2132	148203204000
91331	1874	14475000
91332	2134	96180567000
91333	1874	14478000
91334	2134	96179564000
91335	1874	14481000
91336	2133	96610230000
91337	1874	14483000
91338	2133	96609228000
91339	1874	14485000
91340	1690	141124501000000
91341	1690	141124526000000
91350	1874	14488000
91351	2100	2157880000000
91352	2100	2157891000000
91454	1397	1319028037000
91455	1678	23040757063000
91456	1397	1319018036000
91457	1678	23040757064000
91458	2133	96598206000
91459	1874	14540000
91460	2134	96168531000
91461	1874	14543000
91462	2133	96597204000
91463	1874	14545000
91464	1395	58143507429007706
91466	1681	17507697296868
91467	1643	1149397914700
91468	1874	14148000
91469	1874	14159000
91470	1874	14161000
91471	1874	14166000
91472	1874	14168000
91473	1874	14169000
91474	1874	14171000
91475	1681	15410543061564
91476	1681	11652461432300
91477	1681	9116808546689
91478	1681	2050988109853
91479	1874	14175000
91480	1874	14177000
91481	1874	14179000
91482	1874	14183000
91483	1874	14191000
91484	1874	14193000
91485	1874	14195000
91486	1643	1869397914700
91487	1571	1869432914692
91488	1643	1872019151064
91499	1637	236885612819988
91500	1637	236885625819988
91515	1397	1318978032000
91516	1678	23040757068000
91517	1397	1318968031000
91518	1678	23040757069000
91519	2132	148198199000
91520	1874	14562000
91521	2133	96593196000
91522	1874	14564000
91523	2133	96592194000
91524	1874	14566000
91525	2134	96164519000
91526	1874	14569000
91527	2134	96163516000
91528	1874	14572000
91529	1764	16567120100000
91544	1397	1318938028000
91545	1678	23040757072000
91546	2133	96589188000
91547	1874	14584000
91548	2134	96160507000
91549	1874	14587000
91550	2132	148197198000
91551	1874	14588000
91552	1670	720793000000
91553	1670	720806000000
91568	1688	72720779905200
91569	1688	72720794905200
91596	1397	1318898024000
91597	1678	23040757076000
91598	1397	1318888023000
91599	1678	23040757077000
91600	2134	96157498000
91601	1874	14603000
91602	2133	96585180000
91603	1874	14605000
91604	2133	96584178000
91605	1874	14607000
91606	2134	96156495000
91607	1874	14610000
91608	1394	446407470500000
91619	1397	1318868021000
91620	1678	23040757079000
91621	1397	1318858020000
91622	1678	23040757080000
91623	1397	1318848019000
91624	1678	23040757081000
91625	2133	96582174000
91626	1874	14617000
91627	2134	96154489000
91628	1874	14620000
91629	2134	96153486000
91630	1874	14623000
91631	2134	96152483000
91632	1874	14626000
91633	2133	96581172000
91634	1874	14628000
91635	2133	96580170000
91636	1874	14630000
91637	1457	25104558040000
91654	1394	447847470500000
91655	1394	447847482500000
91659	1692	42260745619999
91660	1397	1318818016000
91661	1678	23040757084000
91662	2133	96577164000
91663	1874	14642000
91664	1547	20733742000000
91665	1547	20733753000000
91700	1397	1318768011000
91701	1678	23040757089000
91702	1874	14599000
91703	1874	14602000
91704	1874	14608000
91705	1874	14611000
91706	1874	14614000
91707	1874	14629000
91708	1874	14632000
91709	2134	96145462000
91710	1874	14639000
91711	1874	14641000
91712	1874	14643000
91713	1874	14645000
91714	1874	14649000
91715	1874	14651000
91716	1874	14653000
91717	1874	14655000
91718	1874	14659000
91719	1874	14661000
91720	1874	14663000
91721	1874	14665000
91722	2133	96572154000
91723	1874	14667000
91724	1419	6048151560130
91725	1419	6768151560130
91754	1397	1318738008000
91755	1678	23040757092000
91756	2133	96569148000
91757	1874	14679000
91758	2134	96142453000
91759	1874	14682000
91789	1397	1318688003000
91790	1678	23040757097000
91791	2133	96565140000
91792	1874	14702000
91793	1560	21889679986418
91794	135	66772980736837
91795	1560	21584845695835
91796	170	66772980736837
91797	1560	21280011405252
91798	202	66772980736837
91799	1560	20975177114669
91800	264	66772980736837
91801	1560	20670342824086
91802	279	66772980736837
91803	1560	20365508533503
91804	331	66772980736837
91805	1560	20060674242920
91806	382	66772980736837
91807	1560	19755839952337
91808	388	66772980736837
91809	1560	19451005661754
91810	400	66772980736837
91436	1634	21072364641004
91437	1634	21072388641004
91450	1690	141844526000000
91451	1690	141844539000000
91489	1397	1319008035000
91490	1678	23040757065000
91491	2133	96596202000
91492	1874	14547000
91493	2134	96167528000
91494	1874	14550000
91495	2132	148199200000
91496	1874	14551000
91497	1395	58144227429007706
91498	1395	58144227442007706
91543	1696	19937570835100
91554	1397	1318928027000
91555	1678	23040757073000
91556	2134	96159504000
91557	1874	14591000
91558	2133	96588186000
91559	1874	14593000
91560	369	86101373736560
91561	946	508296362263440
91562	369	81199528437520
91563	1066	910862659299040
91564	369	77892155412810
91565	1186	614577322024710
91566	1762	22642127994000
91570	1874	14549000
91571	1874	14555000
91572	1874	14557000
91573	1874	14563000
91574	1874	14567000
91575	1874	14568000
91576	1874	14575000
91577	1874	14578000
91578	1874	14581000
91579	1874	14590000
91580	149	86430614000341
91581	149	86430751000341
91594	1637	237605625819988
91595	1637	237605648819988
91617	1395	58144947453007706
91618	1395	58144947465007706
91666	1397	1318808015000
91667	1678	23040757085000
91668	1395	58144947475007706
91669	2133	96576162000
91670	1874	14644000
91671	2134	96149474000
91672	1874	14647000
91673	1395	58145667475007706
91674	1520	58145667475507701
91675	1395	100000006
91676	1509	19392106351155
91687	1397	1318788013000
91688	1678	23040757087000
91689	1397	1318778012000
91690	1678	23040757088000
91691	2133	96574158000
91692	1874	14654000
91693	2134	96147468000
91694	1874	14657000
91695	2134	96146465000
91696	1874	14660000
91697	2133	96573156000
91698	1874	14662000
91699	55	66720024000000
91726	1874	14664000
91727	1419	6767961560130
91728	1419	6767973560130
91752	1739	30239828000000
91753	1739	30239855000000
91760	1397	1318728007000
91761	1678	23040757093000
91762	2133	96568146000
91763	1874	14684000
91764	2134	96141450000
91765	1874	14687000
91766	1395	58146387475507701
91767	1395	58146387487507701
91777	1397	1318708005000
91778	1678	23040757095000
91779	1397	1318698004000
91780	1678	23040757096000
91781	2133	96567144000
91782	1874	14692000
91783	2133	96566142000
91784	1874	14694000
91785	2134	96139444000
91786	1874	14697000
91787	2134	96138441000
91788	1874	14700000
91826	576	84725371726895
91827	576	84725397726895
91939	1709	720009000000
91940	1709	720021000000
92045	1397	1318487983000
92046	1678	23040757117000
92047	2133	96545100000
92048	1874	14796000
92049	2134	96119384000
92050	1874	14799000
92131	2133	96536082000
92132	1874	14841000
92133	1874	14844000
92134	2148	720019880750
91811	1560	19146171371171
91812	505	66772980736837
91813	1560	16940489787155
91814	925	508370750766612
91815	1560	12987928078835
91816	1045	910996029653240
91817	1560	10321055608607
91818	1165	614667174085221
91819	1560	2889580131803
91820	1291	1712824733746403
91821	1756	11233217545609
91844	1397	1318658000000
91845	1678	23040757100000
91846	2133	96562134000
91847	1874	14717000
91848	2134	96134429000
91849	1874	14720000
91850	1394	450727508500000
91851	1394	450727520500000
91852	1687	10700237223172
91902	1397	1318617996000
91903	1678	23040757104000
91904	2133	96558126000
91905	1874	14737000
91906	2134	96130417000
91907	1874	14740000
91909	1397	1318607995000
91910	1678	23040757105000
91911	2133	96557124000
91912	1874	14742000
91913	1690	142564538000000
91914	1690	142564549000000
91988	1701	2878096500103
91989	1701	2878132500103
91998	58	91146684999641
91999	58	91146694999641
92002	58	91146696999641
92095	1596	1440000000000
92096	1596	1440048000000
92105	1397	1318417976000
92106	1678	23040757124000
92107	1397	1318407975000
92108	1678	23040757125000
92109	2134	96112363000
92110	1874	14832000
92111	2134	96111360000
92112	1874	14835000
92113	2133	96538086000
92114	1874	14837000
92115	2133	96537084000
92116	1874	14839000
92117	1693	3782226908632
92118	1693	3782250908632
92136	1690	143284549000000
92137	1690	143284564000000
91883	1874	14728000
91884	1560	18426144371171
91885	1560	16220462787155
91886	1560	12267901078835
91887	1560	9601028608607
91888	1560	2169553131803
91889	2133	96560130000
91890	1874	14730000
91891	1419	7488151560130
91892	1419	7488360560130
91896	1397	1318627997000
91897	1678	23040757103000
91898	2134	96131420000
91899	1874	14733000
91900	2133	96559128000
91901	1874	14735000
91923	1596	11559133859486
91924	1596	6984074180381
91925	1596	3897188623985
91926	1596	1344127511435
91927	369	68675868190850
91928	1312	1712574323973610
91929	1509	20112104851155
91930	1509	20112157851155
91960	1397	1318547989000
91961	1678	23040757111000
91962	2134	96124399000
91963	1874	14770000
91964	2133	96551112000
91965	1874	14772000
91966	1654	22605270999798
91967	1654	22605282999798
91968	1397	1318537988000
91969	1678	23040757112000
91970	1397	1318527987000
91971	1678	23040757113000
91972	1397	1318517986000
91973	1678	23040757114000
91974	2133	96550110000
91975	1874	14774000
91976	2134	96123396000
91977	1874	14777000
91978	2134	96122393000
91979	1874	14780000
91980	2134	96121390000
91981	1874	14783000
91982	2133	96549108000
91983	1874	14785000
91984	2133	96548106000
91985	1874	14787000
91986	1992	20879489990000
91987	1992	20879525990000
91990	1397	1318507985000
91991	1678	23040757115000
91992	2134	96120387000
91993	1874	14790000
91994	2133	96547104000
91995	1874	14792000
91996	1746	10594420000000
91997	1746	10594432000000
92003	1397	1318497984000
92004	1678	23040757116000
92005	2133	96546102000
92006	1874	14794000
92007	1715	17306838436096
92008	1715	17306849436096
92051	1701	2878108500103
92064	2133	96544098000
92065	1874	14801000
92066	2134	96118381000
92067	1874	14804000
92068	1422	17425252860211
92069	1397	1318467981000
92070	1678	23040757119000
92071	1397	1318457980000
92072	1678	23040757120000
92073	1397	1318447979000
92074	1678	23040757121000
92075	1397	1318437978000
92076	1678	23040757122000
92077	2133	96543096000
92078	1874	14806000
92079	2134	96117378000
92080	1874	14809000
92081	2133	96542094000
92082	1874	14811000
92083	2133	96541092000
92084	1874	14813000
92085	2133	96540090000
92086	1874	14815000
92087	2134	96116375000
92088	1874	14818000
92089	2134	96115372000
92090	1874	14821000
92091	2134	96114369000
92092	1874	14824000
92093	1698	22137215550035
92094	1698	22137263550035
92097	1397	1318427977000
92098	1678	23040757123000
92099	2133	96539088000
92100	1874	14826000
92101	2134	96113366000
92102	1874	14829000
92103	1402	72574961319298
92104	1402	72574973319298
92135	1671	3263860003785
91951	2134	96126405000
91952	1874	14760000
91953	2134	96125402000
91954	1874	14763000
91955	2133	96553116000
91956	1874	14765000
91957	2133	96552114000
91958	1874	14767000
91959	1991	23516165441475
92000	1704	4445310000000
92001	1704	4445322000000
92009	1874	14201000
92010	1874	14209000
92011	1874	14211000
92012	1874	14217000
92013	1874	14223000
92014	1874	14225000
92015	1874	14227000
92016	1874	14235000
92017	1874	14237000
92018	1874	14241000
92019	1874	14243000
92020	1874	14245000
92021	1643	200000001
92022	2215	1870005914690
92023	1520	100000002
92024	1874	14251000
92025	1874	14253000
92026	1874	14255000
92027	1874	14257000
92028	1874	14261000
92029	1874	14263000
92030	1874	14267000
92031	1874	14269000
92032	1874	14275000
92033	1874	14279000
92034	1874	14281000
92035	1874	14283000
92036	1874	14285000
92037	1874	14290000
92038	1874	14296000
92039	1874	14314000
92040	1874	14317000
92041	1874	14329000
92042	1874	14332000
92043	1643	2590005914690
92044	1643	2590040914690
92052	1397	1318477982000
92053	1678	23040757118000
92054	1874	14724000
92055	1874	14726000
92056	1874	14732000
92057	1874	14734000
92058	1874	14736000
92059	1874	14738000
92060	1874	14744000
92061	1874	14746000
92062	1422	17425240860211
92063	1422	17425433860211
92119	1397	1318397974000
92120	1678	23040757126000
92121	1680	17721802346879
92122	1993	1956349532446
92123	1680	15533467536127
92124	907	508157428951432
92125	1680	11611991096895
92126	1027	910613758788112
92127	2134	96110357000
92128	1874	14842000
92129	2148	720004880750
92130	2148	720018880750
92138	1397	1318387973000
92139	1678	23040757127000
92140	1680	8966092477127
92141	1147	614409248315263
92142	1680	8106091477127
92143	1993	2816349532446
92144	2134	96109354000
92145	1874	14847000
92146	2133	96535080000
92147	1874	14849000
92148	1650	2272806000000
92149	1650	2272821000000
92150	1397	1318377972000
92151	1678	23040757128000
92152	1397	1318367971000
92153	1678	23040757129000
92154	2132	148196197000
92155	1874	14848000
92156	1874	14850000
92157	2133	96534078000
92158	1874	14852000
92159	2133	96533076000
92160	1874	14854000
92161	1726	38530112000
92162	2251	200000000
92163	1726	37329112000
92164	2252	200000000
92165	1726	36128112000
92166	2253	200000000
92167	2134	96108351000
92168	1874	14857000
92169	2134	96107348000
92170	1874	14860000
92171	1396	720063000000
92172	1874	14851000
92173	1874	14853000
92174	1679	27359342653000
92175	1679	27359370653000
92176	1476	720028000000
92177	1397	1318357970000
92178	1678	23040757130000
92179	2133	96532074000
92180	1874	14862000
92181	1726	34927112000
92182	2254	200000000
92183	2134	96106345000
92184	1874	14865000
92185	1726	33726112000
92186	2255	200000000
92187	1394	452167520500000
92188	1394	452167534500000
92189	1701	2878110500103
92190	1685	138962873571430
92191	1685	138962887571430
92192	1397	1318347969000
92193	1678	23040757131000
92194	1397	1318337968000
92195	1678	23040757132000
92196	2133	96531072000
92197	1874	14867000
92198	2134	96105342000
92199	1874	14870000
92200	2134	96104339000
92201	1874	14873000
92202	2133	96530070000
92203	1874	14875000
92204	1395	58147827499507701
92205	1395	58147827523507701
92206	526	67440114000000
92207	1474	16751389000023
92208	1397	1318327967000
92209	1678	23040757133000
92210	2132	148195196000
92211	1874	14876000
92212	2133	96529068000
92213	1874	14878000
92214	1394	452167532500000
92215	1397	1318317966000
92216	1678	23040757134000
92217	2134	96103336000
92218	1874	14881000
92219	2133	96528066000
92220	1874	14883000
92221	1686	20372216550062
92222	1686	20372228550062
92223	1397	1318307965000
92224	1678	23040757135000
92225	2134	96102333000
92226	1874	14886000
92227	1850	20799322949999
92228	2133	96527064000
92229	1874	14888000
92230	1850	21519322949999
92231	1402	72574984319298
92232	1402	73294984319298
92233	1402	73294985319298
92234	1759	18720986999889
92235	1759	19440986999889
92236	1759	19440987999889
92237	1764	16567131100000
92238	1764	17287131100000
92239	1764	17287132100000
92240	1680	733061499559
92241	1273	1712106000654838
92242	1724	20097550500000
92243	1724	20097551500000
92244	1397	1318297964000
92245	1678	23040757136000
92246	1397	1318287963000
92247	1678	23040757137000
92248	2134	96101330000
92249	1874	14891000
92250	2132	148194195000
92251	1874	14892000
92252	2134	96100327000
92253	1874	14895000
92254	2133	96526062000
92255	1874	14897000
92256	2133	96525060000
92257	1874	14899000
92258	1724	20097576500000
92274	1693	4502250908632
92275	1693	4502265908632
92303	1397	1318257960000
92304	1678	23040757140000
92305	2134	96097318000
92306	1874	14913000
92307	2133	96522054000
92308	1874	14915000
92309	1394	453607532500000
92310	1394	453607544500000
92327	1679	28079370653000
92328	1679	28079381653000
92348	1681	4211034109853
92349	1681	4211046109853
92372	1394	456487557500000
92373	1394	456487581500000
92382	1397	1318177952000
92383	1678	23040757148000
92384	2134	96090297000
92385	1874	14952000
92386	2133	96514038000
92387	1874	14954000
92388	1693	5222264908632
92389	1693	5222276908632
92394	1613	19368110600000
92395	1397	1318167951000
92396	1678	23040757149000
92397	2133	96513036000
92398	1874	14956000
92399	2132	148190191000
92400	1874	14957000
92401	1521	720001000000
92402	1521	720013000000
92421	2256	90000000
92422	1397	1318137948000
92423	1678	23040757152000
92424	2134	96087288000
92425	1874	14968000
92426	1874	14970000
92427	2133	96510030000
92428	1874	14972000
92429	1637	239765680819988
92430	1637	239765703819988
92479	1397	1318127947000
92480	1678	23040757153000
92481	2132	148189190000
92482	1874	14973000
92483	2133	96509028000
92484	1874	14975000
92485	2134	96086285000
92486	1874	14978000
92487	1395	58148547511507701
92488	1395	58148547524507701
92521	1397	1318087943000
92522	1678	23040757157000
92523	1709	1440046000000
92524	1397	1318077942000
92525	1678	23040757158000
92526	1703	10080817000000
92527	2133	96504018000
92528	1874	14998000
92529	2134	96082273000
92530	1874	15001000
92531	1457	25824558040000
92532	1457	25824580040000
92650	1397	1317987933000
92651	1678	23040757167000
92652	1397	1317977932000
92653	1678	23040757168000
92654	2133	96495000000
92655	1874	15043000
92656	2133	96493998000
92657	1874	15045000
92658	2134	96074249000
92659	1874	15048000
92660	2134	96073246000
92661	1874	15051000
92662	1476	720024000000
92713	1397	1317907925000
92714	1678	23040757175000
92715	2133	96487986000
92716	1874	15083000
92717	1656	21741751999990
92731	1704	4445323000000
92786	1397	1317837918000
92787	1678	23040757182000
92788	1397	1317827917000
92789	1678	23040757183000
92790	1397	1317817916000
92791	1678	23040757184000
92792	1397	1317807915000
92793	1678	23040757185000
92794	1397	1317797914000
92795	1678	23040757186000
92796	2132	148180181000
92797	1874	15116000
92798	2132	148179180000
92799	1874	15117000
92800	1726	31324112000
92801	2206	3799000000
92802	2134	96060207000
92803	1874	15120000
92804	2134	96059204000
92805	1874	15123000
92806	2134	96058201000
92807	1874	15126000
92808	1699	306750126
92809	2134	96057198000
92810	1874	15129000
92811	2134	96056195000
92812	1874	15132000
92813	2133	96480972000
92814	1874	15134000
92815	2133	96479970000
92816	1874	15136000
92817	2133	96478968000
92818	1874	15138000
92819	2133	96477966000
92820	1874	15140000
92821	2133	96476964000
92822	1874	15142000
92823	1726	30123112000
92824	2205	3799000000
92825	1726	28922112000
92826	2184	3799000000
92827	1726	27721112000
92828	2185	2599000000
92829	1726	26520112000
92830	2258	200000000
92831	1699	720306750126
92832	1699	720317750126
92856	1594	721521000000
92868	470	67440078000000
92869	1397	1317757910000
92870	1678	23040757190000
92871	1474	14175263684843
92872	963	506768371327637
92873	1651	19491731809512
92874	462	66347494240603
92875	1651	19486456745295
92876	754	1005265064217
92877	1651	16842910956157
92878	935	508064846578276
92879	1651	12105707471846
92880	1055	910447851968622
92881	1474	10849153951023
92882	1083	908124579427713
92883	2133	96472956000
92884	1874	15160000
92885	641	80581888200000
92886	1090	910776965400000
92887	641	78484811600000
92888	970	508247873800000
92889	641	71419569400000
92890	1336	1712409905351650
92891	1718	9110300707068
92892	932	505786783998400
92893	641	68883570000000
92894	1210	614519753200000
92895	632	69597277000000
92940	1688	74160813905200
92941	1688	74160825905200
92957	1690	143284601000000
92958	633	77016161900000
92959	633	72597141900000
92960	633	69615121900000
92961	633	67149101900000
92962	1643	3310040914690
92963	1643	3310330914690
93001	1397	1317657900000
93002	1678	23040757200000
93003	2134	96044159000
93004	1874	15210000
93005	1958	3599186000000
93006	2259	498800000000
93007	2133	96461934000
93008	1874	15212000
93009	1749	10805382930000
92259	1709	720035000000
92276	1693	4502264908632
92296	2133	96523056000
92297	1874	14907000
92298	1874	14910000
92299	1637	239045660819988
92300	1637	239045680819988
92302	1692	42260752619999
92312	632	69597201000000
92313	632	69597212000000
92314	1397	1318247959000
92315	1678	23040757141000
92316	2133	96521052000
92317	1874	14917000
92318	2134	96096315000
92319	1874	14920000
92320	1672	27362264000000
92340	1397	1318217956000
92341	1678	23040757144000
92342	2133	96518046000
92343	1874	14930000
92344	2134	96094309000
92345	1874	14933000
92346	1711	3306336000000
92352	1397	1318207955000
92353	1678	23040757145000
92354	2133	96517044000
92355	1874	14935000
92356	2134	96093306000
92357	1874	14938000
92358	1395	58147827511507701
92375	1719	2160085000000
92411	1536	720012000000
92505	1397	1318097944000
92506	1678	23040757156000
92507	2133	96506022000
92508	1874	14990000
92509	2134	96083276000
92510	1874	14993000
92511	2132	148188189000
92512	1874	14994000
92513	1395	58149267524507701
92514	1395	58149267537507701
92517	2133	96505020000
92518	1874	14996000
92519	1709	1440035000000
92520	1709	1440036000000
92568	633	78456198900000
92569	1384	1710568637751650
92570	633	74037178900000
92571	1138	909796465000000
92572	633	71055158900000
92573	1258	613860750000000
92574	633	68589138900000
92575	1018	507701775000000
92576	1397	1318067941000
92577	1678	23040757159000
92578	1397	1318057940000
92579	1678	23040757160000
92580	1703	807000000
92581	1651	10083236050115
92582	1397	1318047939000
92583	1678	23040757161000
92584	1397	1318037938000
92585	1678	23040757162000
92586	1397	1318027937000
92587	1678	23040757163000
92588	1397	1318017936000
92589	1678	23040757164000
92590	2132	148187188000
92591	1874	15002000
92592	1726	32525112000
92593	2257	200000000
92594	2134	96081270000
92595	1874	15005000
92596	2134	96080267000
92597	1874	15008000
92598	2134	96079264000
92599	1874	15011000
92600	2134	96078261000
92601	1874	15014000
92602	2133	96503016000
92603	1874	15016000
92604	2133	96502014000
92605	1874	15018000
92606	2132	148186187000
92607	1874	15019000
92608	2134	96077258000
92609	1874	15022000
92610	2134	96076255000
92611	1874	15025000
92612	2133	96501012000
92613	1874	15027000
92614	2133	96500010000
92615	1874	15029000
92616	2133	96499008000
92617	1874	15031000
92618	2133	96498006000
92619	1874	15033000
92620	633	69309138900000
92621	633	69309303900000
92629	1702	1044352000000
92630	1651	19839236050115
92631	1397	1317997934000
92632	1678	23040757166000
92633	2134	96075252000
92634	1874	15038000
92635	2132	148185186000
92636	1874	15039000
92637	2133	96496002000
92638	1874	15041000
92639	1668	4113479000000
92640	1668	4113502000000
92645	1874	15020000
92646	1874	15023000
92647	1874	15026000
92648	1874	15037000
92649	1451	16459224000000
92663	1687	11420237223172
92664	1687	11420261223172
92674	1637	240485703819988
92675	1637	240485715819988
92705	1397	1317917926000
92706	1678	23040757174000
92707	2134	96067228000
92708	1874	15079000
92709	2133	96488988000
92710	1874	15081000
92711	1687	12140261223172
92712	1687	12140273223172
92719	1709	2160046000000
92720	1709	2160047000000
92721	1709	2160057000000
92740	1397	1317877922000
92741	1678	23040757178000
92742	2133	96484980000
92743	1874	15096000
92744	2134	96064219000
92745	1874	15099000
92746	149	86430616000341
92747	149	86430628000341
92758	633	77736186900000
92759	633	73317166900000
92760	633	70335146900000
92761	633	67869126900000
92762	1651	9759236050115
92763	1675	2444344999977
92764	1675	3164344999977
92765	1675	3165394999977
92769	1397	1317857920000
92770	1678	23040757180000
92771	2134	96062213000
92772	1874	15108000
92773	2133	96482976000
92774	1874	15110000
92775	1992	21599525990000
92776	1992	21599537990000
92778	1397	1317847919000
92779	1678	23040757181000
92780	2134	96061210000
92781	1874	15113000
92782	1693	5222275908632
92833	1394	456487637500000
92834	1394	457927637500000
92835	1394	457927648500000
92857	576	84725395726895
92896	1474	8604958183403
92897	1203	612729749400383
92898	1397	1317747909000
92899	1678	23040757191000
92900	1651	8909418632720
92901	1175	614297307678252
92902	2133	96471954000
92903	1874	15162000
92904	1718	6822772367516
92905	1052	906365583343957
92906	1718	5279331089318
92907	1172	611542919692213
92908	1718	978396519070
92909	1298	1704118721087018
92910	2134	96052183000
92911	1874	15165000
92912	1685	138962908571430
92913	484	71171874000000
92914	1319	1708419637751650
92260	1397	1318277962000
92261	1678	23040757138000
92262	1991	23188695338131
92263	83	66578558947810
92264	2133	96524058000
92265	1874	14901000
92266	1991	22861225234787
92267	348	66579458947810
92268	1991	22533755131443
92269	380	66578558947810
92270	2134	96099324000
92271	1874	14904000
92272	1649	26204406999992
92273	1649	26204421999992
92301	1540	720020000000
92321	1397	1318237958000
92322	1678	23040757142000
92323	2133	96520050000
92324	1874	14922000
92325	111	70320064000000
92326	111	70320075000000
92347	1402	73294973319298
92359	1397	1318197954000
92360	1678	23040757146000
92361	2224	717943000000
92362	2256	100000000
92363	1993	2816348532446
92364	2133	96516042000
92365	1874	14940000
92366	2134	96092303000
92367	1874	14943000
92368	2132	148191192000
92369	1874	14944000
92370	2248	2879297000000
92371	2248	2879321000000
92376	1397	1318187953000
92377	1678	23040757147000
92378	2134	96091300000
92379	1874	14947000
92380	2133	96515040000
92381	1874	14949000
92392	1613	19368099600000
92393	1613	19368111600000
92418	2133	96511032000
92419	1874	14967000
92420	1634	21792400641004
92490	1397	1318117946000
92491	1678	23040757154000
92492	2134	96085282000
92493	1874	14981000
92494	2133	96508026000
92495	1874	14983000
92496	1705	16475640500145
92497	1705	16475652500145
92515	2039	20881542000000
92516	2039	20881555000000
92535	1991	22468659338131
92536	1680	17001790346879
92537	1991	22141189234787
92538	1874	14731000
92539	1419	7488939560130
92540	1874	14741000
92541	1874	14748000
92542	1991	21813719131443
92543	1991	21486249028099
92544	1991	21158778924755
92545	1991	18665325533665
92546	1991	14197079212725
92547	1991	11182264058615
92548	1874	14751000
92549	1874	14766000
92550	1874	14769000
92551	1874	14775000
92552	1874	14776000
92553	1874	14778000
92554	1874	14779000
92555	1874	14782000
92556	1874	14784000
92557	1874	14786000
92558	1874	14798000
92559	1874	14800000
92560	1874	14802000
92561	1874	14810000
92562	1680	14813455536127
92563	1680	10891979096895
92564	1680	8246080477127
92565	1680	873050499559
92566	1419	8208939560130
92567	1419	8208998560130
92622	633	87484218900000
92623	1397	1318007935000
92624	1678	23040757165000
92625	2133	96497004000
92626	1874	15035000
92627	1593	25030465000000
92628	1593	25030476000000
92641	1451	16459046000000
92642	1451	16459069000000
92665	1476	720004000000
92676	1397	1317957930000
92677	1678	23040757170000
92678	1397	1317947929000
92679	1678	23040757171000
92680	1397	1317937928000
92681	1678	23040757172000
92682	2134	96071240000
92683	1874	15058000
92684	2134	96070237000
92685	1874	15061000
92686	2134	96069234000
92687	1874	15064000
92688	2133	96492996000
92689	1874	15066000
92690	2133	96491994000
92691	1874	15068000
92692	2133	96490992000
92693	1874	15070000
92694	1681	4211070109853
92722	1397	1317897924000
92723	1678	23040757176000
92724	2132	148182183000
92725	1874	15084000
92726	2133	96486984000
92727	1874	15086000
92728	2134	96066225000
92729	1874	15089000
92730	1746	10594433000000
92766	1874	15101000
92767	1874	15104000
92768	1675	3164106999977
92783	2133	96481974000
92784	1874	15112000
92785	1874	15115000
92836	2086	2335310300069
92837	2086	3055310300069
92838	2086	3055321300069
92839	1397	1317787913000
92840	1678	23040757187000
92841	1397	1317777912000
92842	1678	23040757188000
92843	2134	96055192000
92844	1874	15145000
92845	2134	96054189000
92846	1874	15148000
92847	576	84725393726895
92858	1397	1317767911000
92859	1678	23040757189000
92860	2134	96053186000
92861	1874	15155000
92862	2133	96473958000
92863	1874	15157000
92864	2132	148178179000
92865	1874	15158000
92866	1673	29125594000000
92867	1673	29125607000000
92923	484	69864854000000
92924	1073	908653465000000
92925	2133	96469950000
92926	1874	15172000
92927	2132	148177178000
92928	1874	15173000
92929	2134	96050177000
92930	1874	15176000
92931	1711	3306347000000
92953	1657	16561493990100
92954	1657	16561545990100
92977	1397	1317687903000
92978	1678	23040757197000
92979	2134	96046165000
92980	1874	15197000
92981	2133	96464940000
92982	1874	15199000
92983	1395	58149987536507701
92984	1395	58149987548507701
93044	1702	1764352000000
93045	1702	1764364000000
93046	1703	720807000000
93047	1703	720819000000
93049	1397	1317607895000
93050	1678	23040757205000
93051	1397	1317597894000
93052	1678	23040757206000
93053	2132	148173174000
93054	1874	15234000
93055	2134	96039144000
92277	1397	1318267961000
92278	1678	23040757139000
92279	2132	148193194000
92280	1874	14905000
92281	1991	22206285028099
92282	530	66578657947810
92283	1991	21878814924755
92284	675	66578558947810
92285	1991	19385361533665
92286	959	507182874224259
92287	2134	96098321000
92288	1874	14908000
92289	1991	14917115212725
92290	1079	908867365066994
92291	1991	11902300058615
92292	1199	613230921672261
92293	1991	3501251355805
92294	1325	1708822488693281
92295	1540	720019000000
92311	1698	22137227550035
92329	1694	4138758197225
92330	1397	1318227957000
92331	1678	23040757143000
92332	2132	148192193000
92333	1874	14923000
92334	2134	96095312000
92335	1874	14926000
92336	2133	96519048000
92337	1874	14928000
92338	1394	455047544500000
92339	1394	455047557500000
92350	1560	3609580131803
92351	1560	3609592131803
92374	1710	3113886664140
92390	1688	73440801905200
92391	1688	73440813905200
92403	1397	1318157950000
92404	1678	23040757150000
92405	2133	96512034000
92406	1874	14959000
92407	2134	96089294000
92408	1874	14962000
92409	1394	457927581500000
92410	1394	457927593500000
92412	1397	1318147949000
92413	1678	23040757151000
92414	2134	96088291000
92415	1874	14965000
92416	1634	21792388641004
92417	1634	21792399641004
92431	1993	1668400389290
92432	1993	1956348532446
92433	1874	14788000
92434	1874	14789000
92435	1874	14791000
92436	1874	14795000
92437	1874	14797000
92438	1874	14803000
92439	1874	14805000
92440	1874	14807000
92441	1874	14808000
92442	1874	14812000
92443	1874	14814000
92444	1874	14816000
92445	1680	1593062499559
92446	1874	14820000
92447	1874	14822000
92448	1874	14828000
92449	1874	14830000
92450	1874	14834000
92451	1874	14836000
92452	1874	14838000
92453	1874	14840000
92454	1874	14846000
92455	1874	14856000
92456	1874	14858000
92457	1874	14864000
92458	1874	14866000
92459	1874	14868000
92460	1695	2825421999000
92461	1874	14872000
92462	1874	14874000
92463	1874	14879000
92464	1874	14882000
92465	1874	14885000
92466	1874	14894000
92467	1874	14900000
92468	1874	14903000
92469	1874	14906000
92470	1874	14909000
92471	1874	14912000
92472	1874	14918000
92473	1874	14921000
92474	1874	14924000
92475	1874	14927000
92476	1874	14936000
92477	1695	3545421999000
92478	1695	3545446999000
92489	1690	143284562000000
92498	1397	1318107945000
92499	1678	23040757155000
92500	2134	96084279000
92501	1874	14986000
92502	2133	96507024000
92503	1874	14988000
92504	1571	2592019151056
92533	1419	8207997560130
92534	1419	8208019560130
92643	1673	28405571000000
92644	1673	28405594000000
92666	1397	1317967931000
92667	1678	23040757169000
92668	2132	148184185000
92669	1874	15052000
92670	2134	96072243000
92671	1874	15055000
92672	1706	16772356600135
92673	1706	16772368600135
92695	1397	1317927927000
92696	1678	23040757173000
92697	2134	96068231000
92698	1874	15073000
92699	2133	96489990000
92700	1874	15075000
92701	2132	148183184000
92702	1874	15076000
92703	1610	2880057999950
92704	1610	2880070999950
92718	1706	16772367600135
92732	1747	9376932000000
92733	1747	9376945000000
92734	1397	1317887923000
92735	1678	23040757177000
92736	2134	96065222000
92737	1874	15092000
92738	2133	96485982000
92739	1874	15094000
92748	1397	1317867921000
92749	1678	23040757179000
92750	2132	148181182000
92751	1874	15100000
92752	2133	96483978000
92753	1874	15102000
92754	2134	96063216000
92755	1874	15105000
92756	1675	3164104999977
92757	1675	3164117999977
92777	1992	21599527990000
92848	2133	96475962000
92849	1874	15144000
92850	2133	96474960000
92851	1874	15146000
92852	1874	15149000
92853	1874	15152000
92854	470	67440065000000
92855	470	67440089000000
92932	1394	457927604500000
92933	1397	1317727907000
92934	1678	23040757193000
92935	2134	96049174000
92936	1874	15179000
92937	2133	96468948000
92938	1874	15181000
92939	1395	58149267536507701
92955	369	78612155412810
92956	369	78612207412810
92985	1397	1317677902000
92986	1678	23040757198000
92987	1474	2350325000043
92988	1329	1707426927595874
92989	2133	96463938000
92990	1874	15201000
92991	2134	96045162000
92992	1874	15204000
92993	2132	148175176000
92994	1874	15205000
92995	1397	1317667901000
92996	1678	23040757199000
92997	2133	96462936000
92998	1874	15207000
92999	2112	720000000000
93000	2112	720011000000
93048	1684	1442745219748
93072	1708	18756007000021
93073	1708	18756019000021
92915	1397	1317737908000
92916	1678	23040757192000
92917	2134	96051180000
92918	1874	15168000
92919	2133	96470952000
92920	1874	15170000
92921	1634	22512399641004
92922	1634	22512431641004
92942	484	68982834000000
92943	1193	613086750000000
92944	484	68253814000000
92945	953	507063775000000
92946	1397	1317717906000
92947	1678	23040757194000
92948	2133	96467946000
92949	1874	15183000
92950	2134	96048171000
92951	1874	15186000
92952	1756	11233244545609
92964	1397	1317707905000
92965	1678	23040757195000
92966	1397	1317697904000
92967	1678	23040757196000
92968	2132	148176177000
92969	1874	15187000
92970	2134	96047168000
92971	1874	15190000
92972	2133	96466944000
92973	1874	15192000
92974	2133	96465942000
92975	1874	15194000
92976	1693	5222288908632
93036	1397	1317617896000
93037	1678	23040757204000
93038	2134	96040147000
93039	1874	15231000
93040	2133	96457926000
93041	1874	15233000
93042	1395	58150707548507701
93043	1395	58150707560507701
93076	1397	1317577892000
93077	1678	23040757208000
93078	2134	96036135000
93079	1874	15252000
93080	2133	96453918000
93081	1874	15254000
93082	2132	148172173000
93083	1874	15255000
93084	1395	58150707561507701
93139	1394	459367604500000
93140	1394	459367717500000
93141	1397	1317547889000
93142	1678	23040757211000
93143	2134	96034129000
93144	1874	15265000
93145	2133	96450912000
93146	1874	15267000
93147	1395	58151427561507701
93148	1395	58151427573507701
93173	1422	18145252860211
93174	1422	18145287860211
93180	1623	60482978899898
93209	1397	1317517886000
93210	1678	23040757214000
93211	2133	96447906000
93212	1874	15280000
93213	2134	96031120000
93214	1874	15283000
93215	2245	199000000
93216	1690	144004601000000
93217	1690	144004614000000
93218	2179	90000000
93219	1397	1317507885000
93220	1678	23040757215000
93221	2132	148170171000
93222	1874	15284000
93223	2133	96446904000
93224	1874	15286000
93225	1455	751517000000
93226	1455	751629000000
93238	1634	21050649710383
93239	1634	21039772909139
93240	1634	20731418591144
93241	1634	20423064273149
93242	1634	20114709955154
93243	1634	17828255728828
93244	1634	13730957265508
93245	1634	10966425095072
93246	1634	3262828259504
93247	1419	8209738560130
93248	1874	14833000
93249	1874	14843000
93250	1419	8929738560130
93251	1419	8929934560130
93295	606	67486595286230
93309	369	79332267412810
93310	369	79332289412810
93335	1874	15316000
93336	1458	21693827908540
93398	1397	1317397874000
93399	1678	23040757226000
93400	2133	96436884000
93401	1874	15336000
93402	2134	96021090000
93403	1874	15339000
93404	1690	144724614000000
93405	1690	144724626000000
93416	1613	19368100600000
93458	1673	29845607000000
93459	1673	29845644000000
93460	1397	1317327867000
93461	1678	23040757233000
93462	2133	96429870000
93463	1874	15367000
93464	2134	96016075000
93465	1874	15370000
93466	1656	22461751999990
93467	1656	22461763999990
93498	1397	1317277862000
93499	1678	23040757238000
93500	2134	96011060000
93501	1874	15390000
93502	2133	96426864000
93503	1874	15392000
93504	2157	1197001999
93505	2133	96425862000
93506	1874	15394000
93507	2133	96424860000
93508	1874	15396000
93509	2132	148163164000
93510	1874	15397000
93511	1555	13155379979096
93512	1726	25319112000
93513	2260	200000000
93514	1726	24118112000
93515	2262	200000000
93516	1726	22917112000
93517	2184	4999000000
93518	2133	96423858000
93519	1874	15399000
93520	2134	96010057000
93521	1874	15402000
93522	1698	22137220550035
93733	1599	22660427393047
93734	1599	22660439393047
93735	1397	1317137848000
93736	1678	23040757252000
93737	2133	96405822000
93738	1874	15488000
93739	1394	462247663500000
93740	1394	462247674500000
93789	1397	1317067841000
93790	1678	23040757259000
93791	2134	95988994000
93792	1874	15520000
93793	2133	96398808000
93794	1874	15522000
93795	1395	58156468083507701
93796	1395	58156468095507701
93817	1397	1317057840000
93818	1678	23040757260000
93819	2132	148155156000
93820	1874	15523000
93821	2133	96397806000
93822	1874	15525000
93823	2134	95987991000
93824	1874	15528000
93825	1681	4931070109853
93826	1681	4931083109853
93867	43	84720985890000
93868	43	84720998890000
93878	1874	15546000
93879	1688	74160814905200
93925	1637	242645750819988
93926	1637	242645762819988
93967	1447	18873639943000
93968	1447	18873675943000
93983	1874	15559000
93984	1874	15562000
93985	1874	15564000
93986	1874	15568000
93987	1874	15570000
93988	1918	2159260000000
93989	1874	15577000
93990	1874	15583000
93010	1749	10805395930000
93011	1651	2693450231
93012	1301	1711794068116628
93013	2179	190000000
93014	1397	1317647899000
93015	1678	23040757201000
93016	1397	1317637898000
93017	1678	23040757202000
93018	2134	96043156000
93019	1874	15215000
93020	2132	148174175000
93021	1874	15216000
93022	2133	96460932000
93023	1874	15218000
93024	2134	96042153000
93025	1874	15221000
93026	2133	96459930000
93027	1874	15223000
93028	1850	21519356949999
93029	1397	1317627897000
93030	1678	23040757203000
93031	2133	96458928000
93032	1874	15225000
93033	2134	96041150000
93034	1874	15228000
93035	1710	3113874664140
93074	1546	18001031000000
93075	1546	18001043000000
93119	1634	20330625710383
93120	1634	20319748909139
93121	1509	20112377851155
93122	1634	20011394591144
93123	1634	19703040273149
93124	1634	19394685955154
93125	1474	2351325000043
93126	1329	1707425927595874
93127	1634	17108231728828
93128	1634	13010933265508
93129	1634	10246401095072
93130	1634	2542804259504
93131	1991	2781215355805
93132	1509	20832377851155
93133	1420	125000
93134	1568	1434965950000
93135	1814	66720003000000
93136	115	200100000
93137	1509	100000005
93138	1520	20832527756151
93155	1702	720354000000
93156	2003	2428970654821
93157	1397	1317537888000
93158	1678	23040757212000
93159	1397	1317527887000
93160	1678	23040757213000
93161	2132	148171172000
93162	1874	15268000
93163	2133	96449910000
93164	1874	15270000
93165	2134	96033126000
93166	1874	15273000
93167	2134	96032123000
93168	1874	15276000
93169	2133	96448908000
93170	1874	15278000
93171	1395	58152147573507701
93172	1395	58152147608507701
93179	1451	16459081000000
93184	1702	342000000
93185	1634	21770660710383
93186	1634	21759783909139
93187	1634	21451429591144
93188	1634	21143075273149
93189	1634	20834720955154
93190	1634	18548266728828
93191	1634	14450968265508
93192	1634	11686436095072
93193	1634	3982839259504
93194	1874	15040000
93195	1874	15042000
93196	1874	15044000
93197	1874	15047000
93198	1874	15049000
93199	1451	16460001000000
93200	1874	15053000
93201	1874	15056000
93202	1874	15059000
93203	1874	15062000
93204	1874	15065000
93205	1874	15071000
93206	1874	15074000
93207	1451	17180001000000
93208	1451	17180010000000
93228	1397	1317497884000
93229	1678	23040757216000
93230	2134	96030117000
93231	1874	15289000
93232	2133	96445902000
93233	1874	15291000
93234	1672	28082264000000
93235	1672	28082276000000
93253	1419	8928019560130
93254	1419	8928031560130
93255	171	79968490851086
93256	1008	506594957082875
93257	1397	1317487883000
93258	1678	23040757217000
93259	1397	1317477882000
93260	1678	23040757218000
93261	2132	148169170000
93262	1874	15292000
93263	2134	96029114000
93264	1874	15295000
93265	2133	96444900000
93266	1874	15297000
93267	2133	96443898000
93268	1874	15299000
93269	2134	96028111000
93270	1874	15302000
93271	470	67440100000000
93298	1397	1317457880000
93299	1678	23040757220000
93300	1506	1732576967172
93301	598	66514703000574
93302	2133	96442896000
93303	1874	15307000
93304	2134	96026105000
93305	1874	15310000
93306	1610	3600070999950
93307	1610	3600092999950
93320	1687	12860273223172
93321	1687	12860285223172
93377	2133	96439890000
93378	1874	15323000
93379	1593	25750476000000
93380	1593	25750487000000
93413	1571	3312042151056
93417	171	79248478851086
93418	171	75911702541976
93419	171	73660309823457
93420	171	67386621696494
93421	1724	20817551500000
93422	1724	20817861500000
93468	1397	1317317866000
93469	1678	23040757234000
93470	2133	96428868000
93471	1874	15372000
93472	2134	96015072000
93473	1874	15375000
93474	1395	58153587621507701
93475	1395	58153587633507701
93524	2133	96422856000
93525	1874	15404000
93526	2157	1196001999
93527	1726	21716112000
93528	2263	200000000
93529	1726	20515112000
93530	2264	200000000
93531	1726	19314112000
93532	2265	200000000
93533	1657	16561498990100
93534	2179	0
93535	2260	280000000
93536	2133	96421854000
93537	1874	15406000
93538	2133	96420852000
93539	1874	15408000
93540	2132	148162163000
93541	1874	15409000
93542	2157	1195001999
93543	2134	96009054000
93544	1874	15412000
93545	2134	96008051000
93546	1874	15415000
93547	1708	18756023000021
93723	1711	4026347000000
93724	1711	4026700000000
93751	1555	13875379979096
93752	1555	13875392979096
93753	1397	1317117846000
93754	1678	23040757254000
93755	2134	95993006000
93756	1874	15497000
93757	2133	96403818000
93758	1874	15499000
93759	1395	58155748071507701
93056	1874	15237000
93057	2134	96038141000
93058	1874	15240000
93059	2133	96456924000
93060	1874	15242000
93061	2133	96455922000
93062	1874	15244000
93063	1444	18952395159999
93064	1397	1317587893000
93065	1678	23040757207000
93066	2134	96037138000
93067	1874	15247000
93068	2133	96454920000
93069	1874	15249000
93070	1850	22239356949999
93071	1850	22239368949999
93085	1719	2880085000000
93086	1719	2880098000000
93149	526	68160114000000
93150	526	68160116000000
93175	606	67486513286230
93176	606	67486548286230
93181	1700	3834155979053
93182	1700	3834170979053
93227	369	78612267412810
93252	1696	19937558835100
93296	2039	21601555000000
93297	2039	21601637000000
93311	1610	3600082999950
93312	1397	1317447879000
93313	1678	23040757221000
93314	2134	96025102000
93315	1874	15313000
93316	2133	96441894000
93317	1874	15315000
93318	1395	58152867608507701
93319	1395	58152867620507701
93337	389	68880058000000
93338	389	68880091000000
93339	1440	5845133045924
93340	1131	910286595000000
93341	1440	3039923045924
93342	1251	614188560000000
93343	1506	227406967172
93344	1007	506698773004376
93345	1440	719883045924
93346	1011	507974845000000
93347	1397	1317427877000
93348	1678	23040757223000
93349	1874	15164000
93350	1874	15166000
93351	1874	15169000
93352	1874	15174000
93353	1874	15175000
93354	1874	15177000
93355	1874	15178000
93356	1874	15180000
93357	1874	15182000
93358	1593	25031195000000
93359	1874	15184000
93360	1874	15188000
93361	1874	15196000
93362	1874	15198000
93363	1874	15200000
93364	1874	15202000
93365	1874	15206000
93366	1874	15208000
93367	1874	15214000
93368	1874	15220000
93369	1874	15222000
93370	1874	15243000
93371	1874	15246000
93372	1874	15261000
93373	1874	15264000
93374	1874	15279000
93375	1593	25751195000000
93376	1593	25751235000000
93406	1458	22413838908540
93407	1458	22413850908540
93408	1397	1317387873000
93409	1678	23040757227000
93410	2133	96435882000
93411	1874	15341000
93412	1610	3600081999950
93523	1698	22137373550035
93579	1419	9648031560130
93580	1419	9648047560130
93581	1397	1317267861000
93582	1678	23040757239000
93583	2157	1194001999
93584	2133	96419850000
93585	1874	15417000
93586	2134	96007048000
93587	1874	15420000
93588	2134	96006045000
93589	1874	15423000
93590	2133	96418848000
93591	1874	15425000
93592	470	68160099000000
93593	470	68160114000000
93594	1397	1317257860000
93595	1678	23040757240000
93596	2132	148161162000
93597	1874	15426000
93598	2134	96005042000
93599	1874	15429000
93600	1602	17699144460000
93601	1003	506881650540000
93602	2133	96417846000
93603	1874	15431000
93604	2248	2879311000000
93605	1397	1317247859000
93606	1678	23040757241000
93607	1397	1317237858000
93608	1678	23040757242000
93609	1397	1317227857000
93610	1678	23040757243000
93611	1602	13287483590000
93612	1123	908327124870000
93613	2133	96416844000
93614	1874	15433000
93615	2133	96415842000
93616	1874	15435000
93617	2133	96414840000
93618	1874	15437000
93619	1602	10310847770000
93620	1243	612866384820000
93621	1602	2016189170000
93622	1369	1707805295351650
93623	2134	96004039000
93624	1874	15440000
93625	2134	96003036000
93626	1874	15443000
93627	2132	148160161000
93628	1874	15444000
93629	1687	13580285223172
93630	1687	13580324223172
93631	1397	1317217856000
93632	1678	23040757244000
93633	1397	1317207855000
93634	1678	23040757245000
93635	2133	96413838000
93636	1874	15446000
93637	2133	96412836000
93638	1874	15448000
93639	1726	18113112000
93640	2266	200000000
93641	2134	96002033000
93642	1874	15451000
93643	2134	96001030000
93644	1874	15454000
93645	1943	3598955000000
93646	1943	3598980000000
93647	1768	13453800110000
93648	1308	1708575037751650
93649	1768	9572000110000
93650	1062	908736865000000
93651	1768	6953200110000
93652	1182	613142150000000
93653	1768	4786500110000
93654	942	507110975000000
93655	1397	1317197854000
93656	1678	23040757246000
93657	1397	1317187853000
93658	1678	23040757247000
93659	2133	96411834000
93660	1874	15456000
93661	2133	96410832000
93662	1874	15458000
93663	2134	96000027000
93664	1874	15461000
93665	1395	58153588056507701
93666	2134	95999024000
93667	1874	15464000
93668	2132	148159160000
93669	1874	15465000
93670	1726	16912112000
93671	2262	1400000000
93672	1395	58154308056507701
93673	1395	58154308059507701
93674	1762	12854252994000
93675	1307	1712116157751650
93676	58	90782016999641
93677	149	86795298000341
93678	58	81422296999641
93087	1874	15253000
93088	1719	2880097000000
93089	1397	1317567891000
93090	1678	23040757209000
93091	1634	22490692710383
93092	13	4694444607287
93093	1634	22479815909139
93094	19	2347726974088
93095	1634	22171461591144
93096	203	66616500555940
93097	1634	21863107273149
93098	241	66616500555940
93099	1634	21554752955154
93100	313	66616500555940
93101	1634	19268298728828
93102	965	507350663452652
93103	1634	15171000265508
93104	1085	909168041926640
93105	1634	12406468095072
93106	1205	613433794340872
93107	1634	4702871259504
93108	1331	1709387811422786
93109	1397	1317557890000
93110	1678	23040757210000
93111	2134	96035132000
93112	1874	15258000
93113	2133	96452916000
93114	1874	15260000
93115	2133	96451914000
93116	1874	15262000
93117	1509	20832118351155
93118	1509	20832231351155
93151	1474	3070325000043
93152	1474	3070337000043
93153	2126	250000007
93154	1422	18145433860210
93177	1571	3312031151056
93178	1571	3312066151056
93183	1700	3834190979053
93236	2261	719000000000
93237	2261	719012000000
93272	1874	15300000
93273	470	67440099000000
93274	1397	1317467881000
93275	1678	23040757219000
93276	1506	12997246967172
93277	2037	1546000000000
93278	171	76631714541976
93279	1128	907813822586899
93280	171	74380321823457
93281	1248	612520075567628
93282	171	68106633696494
93283	1374	1706841652817754
93284	1506	7159736967172
93285	1373	1707191380766396
93286	1506	4054926967172
93287	1127	907999854007842
93288	1506	1960016967172
93289	1247	612645625005290
93290	2134	96027108000
93291	1874	15303000
93292	1874	15305000
93293	1679	28799381653000
93294	1679	28799463653000
93308	1394	459367626500000
93322	1440	17819353045924
93323	2040	2016040000000
93324	1440	10002643045924
93325	1377	1711490787751650
93326	1397	1317437878000
93327	1678	23040757222000
93328	2134	96024099000
93329	1874	15318000
93330	2132	148168169000
93331	1874	15319000
93332	2133	96440892000
93333	1874	15321000
93334	1458	21693838908540
93381	1397	1317417876000
93382	1678	23040757224000
93383	2134	96023096000
93384	1874	15326000
93385	2133	96438888000
93386	1874	15328000
93387	1695	3544979999000
93388	1695	3544991999000
93389	1397	1317407875000
93390	1678	23040757225000
93391	2133	96437886000
93392	1874	15330000
93393	2132	148167168000
93394	1874	15331000
93395	2134	96022093000
93396	1874	15334000
93397	1395	58152867621507701
93414	1637	241205715819988
93415	1637	241205726819988
93423	1397	1317377872000
93424	1678	23040757228000
93425	1397	1317367871000
93426	1678	23040757229000
93427	2134	96020087000
93428	1874	15344000
93429	2132	148166167000
93430	1874	15345000
93431	2133	96434880000
93432	1874	15347000
93433	2133	96433878000
93434	1874	15349000
93435	1724	20097574500000
93436	1397	1317357870000
93437	1678	23040757230000
93438	1397	1317347869000
93439	1678	23040757231000
93440	1397	1317337868000
93441	1678	23040757232000
93442	2132	148165166000
93443	1874	15350000
93444	2134	96019084000
93445	1874	15353000
93446	2134	96018081000
93447	1874	15356000
93448	2133	96432876000
93449	1874	15358000
93450	2133	96431874000
93451	1874	15360000
93452	2133	96430872000
93453	1874	15362000
93454	2134	96017078000
93455	1874	15365000
93456	1394	460807626500000
93457	1394	460807663500000
93476	1397	1317307865000
93477	1678	23040757235000
93478	2132	148164165000
93479	1874	15376000
93480	2133	96427866000
93481	1874	15378000
93482	2157	1199001999
93483	2134	96014069000
93484	1874	15381000
93485	1426	24765235000000
93486	1426	24765249000000
93487	1397	1317297864000
93488	1678	23040757236000
93489	1397	1317287863000
93490	1678	23040757237000
93491	2157	1198001999
93492	2134	96013066000
93493	1874	15384000
93494	2134	96012063000
93495	1874	15387000
93496	1691	21563412100019
93497	1691	21563435100019
93548	2179	80000000
93549	1708	18036241000021
93550	1874	15322000
93551	1874	15324000
93552	1874	15325000
93553	1874	15327000
93554	1874	15337000
93555	1874	15340000
93556	1874	15343000
93557	1874	15346000
93558	1874	15352000
93559	1874	15355000
93560	1874	15361000
93561	1874	15364000
93562	1874	15373000
93563	1874	15377000
93564	1874	15379000
93565	1874	15383000
93566	1874	15385000
93567	1874	15389000
93568	1874	15391000
93569	1874	15393000
93570	1874	15395000
93571	1874	15401000
93572	1874	15403000
93573	1874	15405000
93574	1874	15407000
93575	1874	15411000
93576	1874	15413000
93577	1708	18756241000021
93578	1708	18756293000021
93679	1281	1712096207751650
93680	1397	1317177852000
93681	1678	23040757248000
93682	1397	1317167851000
93683	1678	23040757249000
93684	58	76444156999641
93685	1035	910608555000000
93686	58	73085296999641
93687	1155	614405750000000
93688	58	70307296999641
93689	915	508154535000000
93690	2134	95998021000
93691	1874	15468000
93692	2133	96409830000
93693	1874	15470000
93694	2133	96408828000
93695	1874	15472000
93696	2134	95997018000
93697	1874	15475000
93698	1685	139682908571430
93699	1685	139683082571430
93700	1762	8031302994000
93701	1061	910619165000000
93702	1762	4777132994000
93703	1181	614412890000000
93704	1762	2085282994000
93705	941	508161275000000
93706	1397	1317157850000
93707	1678	23040757250000
93708	149	78978258000341
93709	1283	1707425937751650
93710	149	74820618000341
93711	1037	908124585000000
93712	149	72015368000341
93713	1157	612729760000000
93714	149	69695238000341
93715	917	506768385000000
93716	2134	95996015000
93717	1874	15478000
93718	2132	148158159000
93719	1874	15479000
93720	2133	96407826000
93721	1874	15481000
93722	1671	3264198003785
93741	1397	1317127847000
93742	1678	23040757253000
93743	2133	96404820000
93744	1874	15490000
93745	2132	148157158000
93746	1874	15491000
93747	2134	95994009000
93748	1874	15494000
93749	1394	463687674500000
93750	1394	463687687500000
93797	1508	22356734500009
93798	1508	22356746500009
93827	1764	18007132100000
93828	1764	18007145100000
93842	1397	1317047839000
93843	1678	23040757261000
93844	2134	95986988000
93845	1874	15531000
93846	2133	96396804000
93847	1874	15533000
93848	1397	1317037838000
93849	1678	23040757262000
93850	2134	95985985000
93851	1874	15536000
93852	2133	96395802000
93853	1874	15538000
93854	1394	465127687500000
93855	1394	465127699500000
93869	1394	466567699500000
93870	1394	466567712500000
93880	1397	1317007835000
93881	1678	23040757265000
93882	2133	96392796000
93883	1874	15551000
93885	1397	1316997834000
93886	1678	23040757266000
93887	1397	1316987833000
93888	1678	23040757267000
93889	1397	1316977832000
93890	1678	23040757268000
93891	1397	1316967831000
93892	1678	23040757269000
93893	2133	96391794000
93894	1874	15553000
93895	2133	96390792000
93896	1874	15555000
93897	2133	96389790000
93898	1874	15557000
93899	2132	148153154000
93900	1874	15558000
93901	2133	96388788000
93902	1874	15560000
93903	2134	95982976000
93904	1874	15563000
93905	2134	95981973000
93906	1874	15566000
93907	2134	95980970000
93908	1874	15569000
93909	2134	95979967000
93910	1874	15572000
93911	1699	720250750126
93912	1699	720299750126
93927	1397	1316947829000
93928	1678	23040757271000
93929	1547	20733763000000
93930	2134	95978964000
93931	1874	15578000
93932	2133	96386784000
93933	1874	15580000
93934	1547	21453763000000
93935	1547	21453765000000
93969	1394	468007711500000
93970	1394	468007747500000
93998	1397	1316887823000
93999	1678	23040757277000
94000	2132	148150151000
94001	1874	15605000
94002	2133	96381774000
94003	1874	15607000
94054	1397	1316867821000
94055	1678	23040757279000
94056	2133	96379770000
94057	1874	15614000
94058	2134	95971943000
94059	1874	15617000
94086	1992	22319537990000
94087	1992	22319549990000
94088	1656	14166643999990
94089	1343	1712413637751650
94090	1397	1316827817000
94091	1678	23040757283000
94092	1397	1316817816000
94093	1678	23040757284000
94094	2134	95967931000
94095	1874	15636000
94096	2134	95966928000
94097	1874	15639000
94098	2132	148148149000
94099	1874	15640000
94100	2133	96375762000
94101	1874	15642000
94102	2133	96374760000
94103	1874	15644000
94104	1395	58157188095507701
94105	1395	58157188240507701
94128	1654	23325282999798
94129	1654	23325654999798
94130	2134	95965925000
94131	1874	15649000
94132	2133	96372756000
94133	1874	15651000
94134	686	68880045000000
94135	686	68880047000000
94136	1397	1316797814000
94137	1678	23040757286000
94138	1397	1316787813000
94139	1678	23040757287000
94140	1397	1316777812000
94141	1678	23040757288000
94142	2132	148147148000
94143	1874	15652000
94144	2134	95964922000
94145	1874	15655000
94146	2134	95963919000
94147	1874	15658000
94148	2133	96371754000
94149	1874	15660000
94150	2133	96370752000
94151	1874	15662000
94152	1691	22283435100019
94153	1691	22283470100019
94158	1397	1316767811000
94159	1678	23040757289000
94160	2133	96369750000
94161	1874	15664000
94162	2134	95962916000
94163	1874	15667000
94288	1397	1316687803000
94289	1678	23040757297000
94290	1397	1316677802000
94291	1678	23040757298000
93725	1397	1317147849000
93726	1678	23040757251000
93727	2133	96406824000
93728	1874	15483000
93729	2134	95995012000
93730	1874	15486000
93731	1395	58155028059507701
93732	1395	58155028071507701
93761	1397	1317107845000
93762	1678	23040757255000
93763	2134	95992003000
93764	1874	15502000
93765	2133	96402816000
93766	1874	15504000
93767	1397	1317097844000
93768	1678	23040757256000
93769	1397	1317087843000
93770	1678	23040757257000
93771	2134	95991000000
93772	1874	15507000
93773	2133	96401814000
93774	1874	15509000
93775	2133	96400812000
93776	1874	15511000
93777	2132	148156157000
93778	1874	15512000
93779	1637	241925726819988
93780	1637	241925750819988
93781	1397	1317077842000
93782	1678	23040757258000
93783	2133	96399810000
93784	1874	15514000
93785	2134	95989997000
93786	1874	15517000
93787	1680	1453061499559
93788	1680	1453073499559
93801	1508	21637834500009
93802	1874	15320000
93803	1874	15329000
93804	1874	15332000
93805	1874	15333000
93806	1874	15382000
93807	1874	15388000
93808	1874	15400000
93809	1508	22357834500009
93810	1420	66000050000000
93811	289	1434963970000
93812	1527	66720002000000
93813	115	272999977
93814	435	180000000
93815	2179	66000000030000
93816	1508	22357990500010
93829	58	90062004999641
93830	149	86075286000341
93831	58	80702284999641
93832	149	78258246000341
93833	149	74100606000341
93834	149	71295356000341
93835	149	68975226000341
93836	58	75724144999641
93837	58	72365284999641
93838	58	69587284999641
93839	1764	17288632100000
93840	1764	18008632100000
93841	1764	18009142100000
93858	1397	1317027837000
93859	1678	23040757263000
93860	2134	95984982000
93861	1874	15541000
93862	2133	96394800000
93863	1874	15543000
93864	2132	148154155000
93865	1874	15544000
93866	1395	58156468096507701
93915	2086	3775321300069
93916	2086	3775370300069
93917	1397	1316957830000
93918	1678	23040757270000
93919	2133	96387786000
93920	1874	15574000
93921	2132	148152153000
93922	1874	15575000
93923	1506	2452576967172
93924	1506	2452588967172
93946	1394	466567711500000
93947	1397	1316927827000
93948	1678	23040757273000
93949	1397	1316917826000
93950	1678	23040757274000
93951	1397	1316907825000
93952	1678	23040757275000
93953	2133	96384780000
93954	1874	15587000
93955	2133	96383778000
93956	1874	15589000
93957	2132	148151152000
93958	1874	15590000
93959	2134	95976958000
93960	1874	15593000
93961	2134	95975955000
93962	1874	15596000
93963	2134	95974952000
93964	1874	15599000
93965	1670	1440806000000
93966	1670	1440842000000
93981	1918	2879149000000
93982	1918	2879161000000
94006	1874	15416000
94007	1874	15418000
94008	1874	15421000
94009	1874	15424000
94010	1874	15427000
94011	1874	15439000
94012	1874	15441000
94013	1874	15445000
94014	1708	18757572000021
94015	1874	15447000
94016	1874	15449000
94017	1874	15453000
94018	1874	15455000
94019	1874	15457000
94020	1874	15459000
94021	1874	15463000
94022	1874	15467000
94023	1874	15469000
94024	1874	15471000
94025	1874	15473000
94026	1874	15477000
94027	1874	15485000
94028	1874	15487000
94029	1874	15493000
94030	1874	15495000
94031	1874	15501000
94032	1874	15503000
94033	1874	15505000
94034	1874	15510000
94035	1874	15513000
94036	1874	15516000
94037	1874	15519000
94038	1874	15534000
94039	1874	15537000
94040	1874	15540000
94041	1874	15552000
94042	1874	15561000
94043	1874	15567000
94044	1708	19477572000021
94045	1708	19477624000021
94046	1397	1316877822000
94047	1678	23040757278000
94048	2134	95972946000
94049	1874	15610000
94050	2133	96380772000
94051	1874	15612000
94052	1684	1442757219748
94071	1397	1316847819000
94072	1678	23040757281000
94073	2133	96377766000
94074	1874	15625000
94075	2134	95969937000
94076	1874	15628000
94077	1397	1316837818000
94078	1678	23040757282000
94079	2134	95968934000
94080	1874	15631000
94081	1594	1441521000000
94082	1594	1441532000000
94107	1656	13446631999990
94108	1656	9034511999990
94109	1097	910778465000000
94110	1656	6057391999990
94111	1217	614520750000000
94112	1656	3595271999990
94113	977	508248775000000
94114	1654	22606752999798
94115	1654	23326752999798
94116	1654	66000007920000
94117	646	23326762009798
94155	641	69603570000000
94156	641	69603605000000
94190	1395	58157908240507701
94191	1395	58157908251507701
94201	1564	16386596000000
94202	1564	16386609000000
94212	1656	13446644999990
94213	1656	9034524999990
93760	1395	58155748083507701
93799	1749	11525395930000
93800	1749	11525407930000
93856	2248	3599311000000
93857	2248	3599323000000
93871	1673	29845620000000
93872	1397	1317017836000
93873	1678	23040757264000
93874	2134	95983979000
93875	1874	15547000
93876	2133	96393798000
93877	1874	15549000
93884	1688	74160824905200
93913	1426	25485249000000
93914	1426	25485298000000
93936	1623	59762953899898
93937	1623	60482953899898
93938	1397	1316937828000
93939	1678	23040757272000
93940	2133	96385782000
93941	1874	15582000
93942	2134	95977961000
93943	1874	15585000
93944	1423	720571750023
93945	1423	720583750023
93971	1680	2173073499559
93972	1680	2173109499559
93973	1397	1316897824000
93974	1678	23040757276000
93975	2134	95973949000
93976	1874	15602000
93977	2133	96382776000
93978	1874	15604000
93979	1768	5506500110000
93980	1768	5506512110000
94004	1673	30565620000000
94005	1673	30565632000000
94060	162	68160022000000
94061	162	68160034000000
94062	1397	1316857820000
94063	1678	23040757280000
94064	2134	95970940000
94065	1874	15620000
94066	2132	148149150000
94067	1874	15621000
94068	2133	96378768000
94069	1874	15623000
94070	1637	242645763819988
94106	1690	144724759000000
94154	526	68160149000000
94164	171	68826633696494
94165	171	68826645696494
94166	1397	1316757810000
94167	1678	23040757290000
94168	1397	1316747809000
94169	1678	23040757291000
94170	579	66000004000000
94171	1469	90000000
94172	2134	95961913000
94173	1874	15670000
94174	2134	95960910000
94175	1874	15673000
94176	2132	148146147000
94177	1874	15674000
94178	2133	96368748000
94179	1874	15676000
94180	2133	96367746000
94181	1874	15678000
94182	1705	17195652500145
94183	1705	17195678500145
94184	1397	1316737808000
94185	1678	23040757292000
94186	2133	96366744000
94187	1874	15680000
94188	1480	2140909000000
94189	1480	2140920000000
94192	1397	1316727807000
94193	1678	23040757293000
94194	2133	96365742000
94195	1874	15682000
94196	2132	148145146000
94197	1874	15683000
94198	2134	95959907000
94199	1874	15686000
94200	1394	468007724500000
94211	1476	720012000000
94252	1397	1316697804000
94253	1678	23040757296000
94254	2133	96362736000
94255	1874	15698000
94256	1458	23853850908540
94257	1458	23853861908540
94309	1448	10836847000001
94335	1687	14300324223172
94336	1687	14300361223172
94337	1397	1316627797000
94338	1678	23040757303000
94339	1397	1316617796000
94340	1678	23040757304000
94341	2134	95951883000
94342	1874	15730000
94343	2133	96355722000
94344	1874	15732000
94345	2133	96354720000
94346	1874	15734000
94347	2132	148142143000
94348	1874	15735000
94349	2134	95950880000
94350	1874	15738000
94351	1457	25824583040000
94421	1688	59645962450200
94422	786	2465521918273720
94423	1688	59529129345200
94424	791	56035771273584
94425	1688	58244066307200
94426	792	616392946080101
94427	1397	1316547789000
94428	1678	23040757311000
94429	2133	96347706000
94430	1874	15772000
94431	2134	95943859000
94432	1874	15775000
94433	1395	58157908282507701
94446	1688	57864390111200
94447	801	14010279247666
94448	1688	57543086204200
94449	802	154112937240275
94450	1397	1316527787000
94451	1678	23040757313000
94452	1688	57317026881200
94453	811	108427593503286
94454	2133	96345702000
94455	1874	15782000
94456	2132	148139140000
94457	1874	15783000
94458	2134	95941853000
94459	1874	15786000
94460	1610	3600113999950
94497	1397	1316497784000
94498	1678	23040757316000
94499	2133	96342696000
94500	1874	15798000
94501	2134	95938844000
94502	1874	15801000
94503	1726	14510112000
94504	2268	200000000
94505	2132	148138139000
94506	1874	15802000
94507	1699	720264750126
94566	1688	70668064113200
94567	1688	70513232531200
94568	1698	21093634378297
94569	1698	18631748841201
94570	1698	14220078972065
94571	1698	11243434149826
94572	1688	70374438872200
94573	1688	70316017319200
94574	1688	69673480800200
94575	1688	64533362610200
94576	1688	64066069640200
94577	1688	58925951450200
94578	1688	58809118345200
94579	1688	57524055307200
94580	1688	57494842148200
94581	1688	57173597673200
94582	1688	57144379111200
94583	1688	56823075204200
94584	1698	2948766550062
94585	1688	56597015881200
94586	1688	54110465494200
94587	1688	50483151402200
94588	1688	10582831210200
94589	1688	3598620910200
94590	1708	19478794000021
94591	1874	15571000
94592	1874	15573000
94593	1874	15579000
94594	1874	15635000
94595	1874	15637000
94596	1874	15641000
94597	1874	15650000
94598	1874	15653000
94599	1708	20198794000021
94600	1708	20198893000021
94616	1587	1440024000000
93991	1874	15586000
93992	1874	15592000
93993	1874	15595000
93994	1874	15598000
93995	1874	15601000
93996	1918	2879260000000
93997	1918	2879271000000
94053	1680	2173085499559
94083	2133	96376764000
94084	1874	15633000
94085	1594	1441533000000
94118	1656	9754523999990
94119	1656	6777403999990
94120	1656	4315283999990
94121	1397	1316807815000
94122	1678	23040757285000
94123	1726	15711112000
94124	2267	200000000
94125	2133	96373758000
94126	1874	15646000
94127	1693	5222636908632
94157	1474	3070360000043
94203	1613	19368112600000
94204	1397	1316717806000
94205	1678	23040757294000
94206	2134	95958904000
94207	1874	15689000
94208	2133	96364740000
94209	1874	15691000
94210	2086	3775333300069
94244	1397	1316707805000
94245	1678	23040757295000
94246	2134	95957901000
94247	1874	15694000
94248	2133	96363738000
94249	1874	15696000
94250	1710	3833874664140
94251	1710	3833886664140
94310	2106	5039083000000
94311	2106	5039120000000
94312	1685	140403082571430
94313	1685	140403119571430
94360	1688	74880824905200
94361	1688	74880836905200
94402	1613	19368163600000
94403	1688	70393491800200
94404	780	308196473040051
94405	1688	65253373610200
94406	782	2465521918273720
94407	1397	1316557790000
94408	1678	23040757310000
94409	1688	64786080640200
94410	785	224138551816807
94411	2134	95944862000
94412	1874	15767000
94413	2133	96348708000
94414	1874	15769000
94415	2132	148140141000
94416	1874	15770000
94417	1705	17915678500145
94418	1705	17915721500145
94476	1506	3172588967172
94477	1506	3172630967172
94509	1536	1440012000000
94510	1536	1440026000000
94511	1397	1316487783000
94512	1678	23040757317000
94513	1679	28128547709000
94514	1	375562550686000
94515	1679	27978365513000
94516	841	84064023338298
94517	1679	27698380388000
94518	843	156725652655667
94519	2133	96341694000
94520	1874	15804000
94521	2134	95937841000
94522	1874	15807000
94526	1749	12245407930000
94527	1646	1438913000000
94528	1706	16053356600135
94529	1646	1437813000000
94530	1706	16054356600135
94531	1679	25625486252000
94532	849	1155353613497640
94533	1679	21609986866000
94534	851	2247807533667750
94535	1679	21167204552000
94536	853	247856948044225
94537	1397	1316477782000
94538	1678	23040757318000
94539	1397	1316467781000
94540	1678	23040757319000
94541	1397	1316457780000
94542	1678	23040757320000
94543	1679	20932984592000
94544	855	131107036356125
94545	1679	20342417677000
94546	857	330584433102608
94547	1679	19526710919000
94548	861	456614161103125
94549	1688	4318631910200
94550	2177	70684766549641
94551	1874	15729000
94552	1874	15731000
94553	2132	148137138000
94554	1874	15733000
94555	1638	720717000000
94606	1638	720174000000
94620	1679	13740752370000
94621	879	135627968644750
94622	1397	1316447779000
94623	1678	23040757321000
94624	2133	96337686000
94625	1874	15819000
94626	1439	5743604578477
94656	1474	3070508000043
94715	1440	3040153045924
94716	1251	614188360000000
94717	596	67094752000000
94718	1981	100980000000
94719	1397	1316337768000
94720	1678	23040757332000
94721	1688	5038675910100
94722	2177	71944805349741
94723	2132	148133134000
94724	1874	15843000
94725	2133	96326664000
94726	1874	15845000
94727	1549	26256153000000
94732	1508	22359080500010
94733	1508	23078080500010
94734	1397	1316327767000
94735	1678	23040757333000
94736	2133	96325662000
94737	1874	15847000
94738	1715	18026849436096
94739	1715	18026860436096
94768	1710	3833896664140
94769	1397	1316287763000
94770	1678	23040757337000
94771	2133	96322656000
94772	1874	15854000
94773	1637	244085816819988
94872	2133	96310632000
94873	1874	15881000
94874	1874	15882000
94875	1992	23039561990000
94891	1702	1440354000000
94892	1702	1440365000000
94906	1574	720000000000
94907	1574	720011000000
94949	1402	75455036319298
94950	1402	75455047319298
94961	1476	1440024000000
94968	1397	1316077742000
94969	1678	23040757358000
94970	2133	96301614000
94971	1874	15902000
94972	1690	144724625000000
94973	1397	1316067741000
94974	1678	23040757359000
94975	2133	96300612000
94976	1874	15904000
94977	2132	148125126000
94978	1874	15905000
94979	1395	58158628251507701
94980	1395	58158628263507701
94983	1688	5758675910100
94984	1688	5758687910100
94985	1992	20668550990000
94986	940	507428775000000
94987	1397	1316057740000
94988	1678	23040757360000
94989	2268	199000000
94990	1637	244805816819988
94991	1637	244805837819988
95009	1633	15876728975638
95022	1688	5758707910100
95032	1692	43700781619999
95033	1692	43700802619999
95039	1397	1316007735000
95040	1678	23040757365000
95041	1684	2162745219748
95042	1684	2162755219748
95165	1397	1315837718000
94214	1656	6057404999990
94215	1656	3595284999990
94216	1440	17099341045924
94217	1440	9282631045924
94218	58	89341980999641
94219	149	85355271000341
94220	58	79982260999641
94221	149	77538231000341
94222	149	73380591000341
94223	149	70575341000341
94224	149	68255211000341
94225	1634	19610613710383
94226	1634	19599736909139
94227	1634	19291382591144
94228	1634	18983028273149
94229	1634	18674673955154
94230	1440	5125121045924
94231	1440	2319911045924
94232	58	75004120999641
94233	58	71645260999641
94234	58	68867260999641
94235	1634	16388219728828
94236	1634	12290921265508
94237	1634	9526389095072
94238	1634	1822792259504
94239	1643	200000002
94240	2215	3311150914689
94241	1447	18154639943000
94242	1643	4031150914689
94243	1964	4031260914688
94258	1874	15489000
94259	1874	15498000
94260	1874	15530000
94261	1874	15532000
94262	1874	15542000
94263	1874	15548000
94264	1874	15550000
94265	1874	15554000
94266	1874	15556000
94267	1458	22414826908540
94268	1874	15576000
94269	1874	15584000
94270	1874	15588000
94271	1874	15591000
94272	1874	15594000
94273	1874	15597000
94274	1874	15600000
94275	1874	15603000
94276	1874	15606000
94277	1874	15609000
94278	1874	15615000
94279	1874	15618000
94280	1874	15624000
94281	1874	15627000
94282	1874	15630000
94283	1874	15645000
94284	1874	15647000
94285	1874	15648000
94286	1458	23854826908540
94287	1458	23854856908540
94352	1397	1316607795000
94353	1678	23040757305000
94354	2134	95949877000
94355	1874	15741000
94356	2133	96353718000
94357	1874	15743000
94358	1696	20657558835100
94359	1696	20657570835100
94372	1397	1316587793000
94373	1678	23040757307000
94374	2133	96351714000
94375	1874	15750000
94376	2132	148141142000
94377	1874	15751000
94378	2134	95947871000
94379	1874	15754000
94380	1694	4138760197225
94381	1397	1316577792000
94382	1678	23040757308000
94383	1397	1316567791000
94384	1678	23040757309000
94385	1688	71388075113200
94386	31	1329981875386000
94387	1688	71233243531200
94388	32	74262251044000
94389	1688	71094449872200
94390	40	66569445570000
94391	1688	71036028319200
94392	779	28017885636792
94393	2134	95946868000
94394	1874	15757000
94395	2133	96350712000
94396	1874	15759000
94397	2133	96349710000
94398	1874	15761000
94399	2134	95945865000
94400	1874	15764000
94401	1395	58157908304507701
94434	1685	140403124571430
94435	1688	58214853148200
94436	799	14007687631181
94437	1688	57893608673200
94438	800	154084429483607
94439	1397	1316537788000
94440	1678	23040757312000
94441	2134	95942856000
94442	1874	15778000
94443	2133	96346704000
94444	1874	15780000
94445	1768	5506532110000
94478	1637	243365763819988
94479	1637	243365805819988
94480	1698	21813639378297
94481	556	66743135511028
94482	1698	19351753841201
94483	930	508430970677776
94484	1698	14940083972065
94485	1050	911103943218016
94486	1698	11963439149826
94487	1170	614739985517734
94488	1698	3668771550062
94489	1296	1713027629277034
94490	1397	1316507785000
94491	1678	23040757315000
94492	2133	96343698000
94493	1874	15793000
94494	2134	95939847000
94495	1874	15796000
94496	1850	22239418949999
94523	1650	2992821000000
94524	1650	2992863000000
94556	1874	15808000
94557	2133	96340692000
94558	1874	15810000
94559	2134	95936838000
94560	1874	15813000
94561	2133	96339690000
94562	1874	15815000
94563	1708	19476019000021
94564	1509	19476294500022
94565	1708	20832238851155
94607	1679	18810610696000
94608	865	400855996215417
94609	1679	14449449713000
94610	867	2441303436168000
94611	1679	13983048536000
94612	869	261078414520845
94613	2133	96338688000
94614	1874	15817000
94615	1395	58157908391507701
94627	1439	5743594578477
94628	1646	1713000000
94629	1706	17490356600135
94630	1679	12690835652000
94631	881	587721197459250
94632	1679	12529301542000
94633	883	90418645762500
94634	1679	12047208297000
94635	887	269862585957154
94636	1679	11642515252000
94637	889	226535176490249
94638	1679	10754122645000
94639	891	497302551695750
94640	1679	10636923672000
94641	897	65600535873885
94642	1397	1316437778000
94643	1678	23040757322000
94644	1397	1316427777000
94645	1678	23040757323000
94646	2133	96336684000
94647	1874	15821000
94648	2133	96335682000
94649	1874	15823000
94650	2132	148136137000
94651	1874	15824000
94652	1394	469447931500000
94657	576	84725494726895
94728	1762	2805282994000
94729	1762	2805324994000
94740	1613	20088163600000
94741	1613	20088173600000
94774	1397	1316277762000
94775	1678	23040757338000
94776	1706	17951519221216
94777	451	66564722585011
94292	1397	1316667801000
94293	1678	23040757299000
94294	2134	95956898000
94295	1874	15701000
94296	2134	95955895000
94297	1874	15704000
94298	2132	148144145000
94299	1874	15705000
94300	2134	95954892000
94301	1874	15708000
94302	2133	96361734000
94303	1874	15710000
94304	2133	96360732000
94305	1874	15712000
94306	2133	96359730000
94307	1874	15714000
94308	1395	58157908277507701
94314	1692	42260770619999
94315	1397	1316657800000
94316	1678	23040757300000
94317	1397	1316647799000
94318	1678	23040757301000
94319	1397	1316637798000
94320	1678	23040757302000
94321	2258	199000000
94322	2133	96358728000
94323	1874	15716000
94324	2133	96357726000
94325	1874	15718000
94326	2134	95953889000
94327	1874	15721000
94328	2133	96356724000
94329	1874	15723000
94330	2132	148143144000
94331	1874	15724000
94332	2134	95952886000
94333	1874	15727000
94334	1394	468007748500000
94362	1874	15728000
94363	1696	20657589835100
94364	1397	1316597794000
94365	1678	23040757306000
94366	2133	96352716000
94367	1874	15745000
94368	2134	95948874000
94369	1874	15748000
94370	1602	2736189170000
94371	1602	2736201170000
94419	1564	17106609000000
94420	1564	17106652000000
94461	1740	20085584000000
94462	1688	54830476494200
94463	812	1192702487640140
94464	1397	1316517786000
94465	1678	23040757314000
94466	1688	51203162402200
94467	823	1739885117760760
94468	1688	11302842210200
94469	824	19138719592487700
94470	2134	95940850000
94471	1874	15789000
94472	2133	96344700000
94473	1874	15791000
94474	1394	469447748500000
94475	1394	469447790500000
94508	2086	3775335300069
94525	470	68880114000000
94601	1633	15157037975638
94602	1633	15877037975638
94603	2097	15877227465639
94604	1633	200014017
94605	1509	20832253851155
94618	1633	15876717975638
94619	1633	15877001975638
94655	576	84725554726895
94684	1943	4319003000000
94685	1397	1316387773000
94686	1678	23040757327000
94687	2133	96331674000
94688	1874	15833000
94689	1692	42980770619999
94690	1692	42980781619999
94691	1440	5845163045924
94692	1131	910286565000000
94693	1397	1316377772000
94694	1678	23040757328000
94695	1397	1316367771000
94696	1678	23040757329000
94697	1397	1316357770000
94698	1678	23040757330000
94699	2133	96330672000
94700	1874	15835000
94701	2132	148134135000
94702	1874	15836000
94703	2133	96329670000
94704	1874	15838000
94705	2133	96328668000
94706	1874	15840000
94707	1688	12022842210200
94708	1688	12022886210200
94709	1397	1316347769000
94710	1678	23040757331000
94711	2133	96327666000
94712	1874	15842000
94713	1706	18210356600135
94714	1706	18210367600135
94730	1637	244085805819988
94731	1637	244085847819988
94759	596	67094432000000
94760	1981	101280000000
94761	1397	1316297764000
94762	1678	23040757336000
94763	2132	148132133000
94764	1874	15850000
94765	2133	96323658000
94766	1874	15852000
94767	1422	18145274860211
94805	1397	1316257760000
94806	1678	23040757340000
94807	1402	74015036319298
94808	1402	74735036319298
94809	1397	1316247759000
94810	1678	23040757341000
94811	2133	96318648000
94812	1874	15863000
94813	1451	16459057000000
94851	576	77846549225192
94852	1355	1708676653253353
94853	576	74187819517990
94854	1109	908789804707202
94855	576	71719195173600
94856	1229	613178594344390
94857	576	69677474726897
94858	989	507139625446703
94859	576	69677454726897
94860	1397	1316177752000
94861	1678	23040757348000
94862	2133	96311634000
94863	1874	15879000
94864	1394	473767832500000
94865	1394	473767943500000
94866	1397	1316167751000
94867	1678	23040757349000
94868	2132	148128129000
94869	1874	15880000
94870	1992	23039549990000
94871	1992	23039560990000
94890	1703	720818000000
94954	1397	1316097744000
94955	1678	23040757356000
94956	2133	96303618000
94957	1874	15897000
94958	1874	15898000
94981	1439	6463604578477
94982	1439	6463616578477
94996	1397	1316047739000
94997	1678	23040757361000
94998	2133	96298608000
94999	1874	15909000
95000	1679	5038448654000
95001	1679	5038459654000
95030	1701	4318121500103
95031	1701	4318142500103
95034	1397	1316017736000
95035	1678	23040757364000
95036	2133	96295602000
95037	1874	15916000
95038	1649	26204417999992
95054	1992	15699529990000
95055	1992	12832519990000
95056	1992	4844509990000
95057	1992	3600499990000
95058	596	68338432000000
95059	1633	17317502435642
95060	1633	17317542435642
95080	1701	3598131500103
95081	1701	4318131500103
95082	1701	4318133500103
95127	2148	1440018880750
95128	2148	1440050880750
95192	1587	2160065000000
95193	1587	2160107000000
95206	1397	1315777712000
95207	1678	23040757388000
95208	2133	96271554000
94617	1587	1440065000000
94653	526	68880149000000
94654	526	68880332000000
94658	1679	10567057725000
94659	899	39104255918990
94660	1397	1316417776000
94661	1678	23040757324000
94662	1679	10357066381000
94663	901	117544239492250
94664	1679	9601931165000
94665	905	422707168941938
94666	2133	96334680000
94667	1874	15826000
94668	1402	74014985319298
94669	1402	74015026319298
94670	1679	8341882365000
94671	2177	64960605049641
94672	1397	1316407775000
94673	1678	23040757325000
94674	1397	1316397774000
94675	1678	23040757326000
94676	2132	148135136000
94677	1874	15827000
94678	2133	96333678000
94679	1874	15829000
94680	2133	96332676000
94681	1874	15831000
94682	1943	4318980000000
94683	1943	4319013000000
94742	1440	720143045924
94743	1011	507974815000000
94744	1679	3980721382000
94745	873	2441303436168000
94746	1397	1316317766000
94747	1678	23040757334000
94748	596	67094642000000
94749	1981	101080000000
94750	1546	18721043000000
94751	1546	18721084000000
94752	1397	1316307765000
94753	1678	23040757335000
94754	1679	3598437654000
94755	875	213990794972583
94756	2133	96324660000
94757	1874	15849000
94758	1394	469447769500000
94804	2112	1440053000000
94849	1679	4318437654000
94850	1679	4318448654000
94888	1394	475207943500000
94889	1394	475207954500000
94908	576	77126366225192
94909	576	73467636517990
94910	576	70999012173600
94911	576	68957291726897
94912	576	68957271726897
94913	1706	17231508221216
94914	1706	16972659842297
94915	1706	16964806255072
94916	1706	14994349389476
94917	1706	11463315489116
94918	1679	9621887553000
94919	1679	9239603825000
94920	1679	9078069715000
94921	1679	8595976470000
94922	1679	8191283425000
94923	1679	7302890818000
94924	1679	7185691845000
94925	1679	7115825898000
94926	1679	6905834554000
94927	1679	6150699338000
94928	1679	4890650538000
94929	1679	529489555000
94930	873	2445664587151000
94931	1679	147205827000
94932	875	214373068700583
94933	1706	9080853302936
94934	1706	2441928450256
94935	1696	20658879835100
94936	2177	71944805349641
94937	1696	21378879835100
94938	1696	21379096835100
94939	1706	3881939450256
94940	1397	1316117746000
94941	1678	23040757354000
94942	2133	96305622000
94943	1874	15893000
94944	1706	3881950450256
94945	1397	1316107745000
94946	1678	23040757355000
94947	2133	96304620000
94948	1874	15895000
94959	1476	1440012000000
94960	1476	1440023000000
95010	1397	1316037738000
95011	1678	23040757362000
95012	1992	16419540990000
95013	1060	909307465000000
95014	1992	13552530990000
95015	1180	613528750000000
95016	2133	96297606000
95017	1874	15911000
95018	2132	148124125000
95019	1874	15912000
95020	1717	21708301000023
95021	1717	21708333000023
95045	1684	2162756219748
95046	1397	1315997734000
95047	1678	23040757366000
95048	2132	148123124000
95049	1874	15917000
95050	1874	15919000
95051	2133	96293598000
95052	1874	15921000
95053	1688	5758688910100
95071	1397	1315967731000
95072	1678	23040757369000
95073	1394	473767953500000
95074	2132	148122123000
95075	1874	15926000
95076	2133	96290592000
95077	1874	15928000
95078	1394	475207953500000
95079	1394	475207955500000
95114	1395	58159348263507701
95115	1395	58159348328507701
95125	1699	1440264750126
95126	1699	1440296750126
95129	1397	1315887723000
95130	1678	23040757377000
95131	2133	96282576000
95132	1874	15946000
95133	1705	10839355040145
95134	1234	613303927936822
95135	1705	10839335040140
95136	1360	1703067102686958
95137	1397	1315877722000
95138	1678	23040757378000
95139	1397	1315867721000
95140	1678	23040757379000
95141	1397	1315857720000
95142	1678	23040757380000
95143	1397	1315847719000
95144	1678	23040757381000
95145	2132	148119120000
95146	1874	15947000
95147	1444	10657736559999
95148	1381	1710569952951650
95149	1444	6246075689999
95150	1135	909796784740000
95151	1444	3269439869999
95152	1255	613858019650000
95153	1444	807563329999
95154	1015	507701526080000
95155	2133	96281574000
95156	1874	15949000
95157	2133	96280572000
95158	1874	15951000
95159	2133	96279570000
95160	1874	15953000
95161	2133	96278568000
95162	1874	15955000
95163	1394	476647955500000
95164	1394	476648044500000
95180	1705	4880489580140
95181	1360	1709025928146958
95182	1397	1315817716000
95183	1678	23040757384000
95184	1397	1315807715000
95185	1678	23040757385000
95186	2133	96275562000
95187	1874	15962000
95188	2133	96274560000
95189	1874	15964000
95190	1395	58160068328507701
95191	1395	58160068370507701
95213	1874	15883000
95214	1874	15885000
95215	1874	15888000
95216	1874	15890000
95217	1874	15892000
95218	1874	15894000
95219	1874	15906000
95220	1874	15913000
95221	1874	15915000
94778	1706	17692670842297
94779	487	66564722585011
94780	1706	17684817255072
94781	744	2017112805578
94782	1706	15714360389476
94783	988	507076931797664
94784	2133	96321654000
94785	1874	15856000
94786	1394	470887769500000
94787	1394	470887820500000
94788	1397	1316267761000
94789	1678	23040757339000
94790	1706	12183326489116
94791	1108	908677517146240
94792	1706	9800864302936
94793	1228	613102827497120
94794	1706	3161939450256
94795	1354	1708465542884770
94796	2132	148131132000
94797	1874	15857000
94798	2133	96320652000
94799	1874	15859000
94800	2133	96319650000
94801	1874	15861000
94802	2112	1440011000000
94803	2112	1440054000000
94814	1397	1316237758000
94815	1678	23040757342000
94816	2133	96317646000
94817	1874	15865000
94818	2132	148130131000
94819	1874	15866000
94820	1394	472327820500000
94821	1394	472327832500000
94822	1397	1316227757000
94823	1678	23040757343000
94824	2133	96316644000
94825	1874	15868000
94826	1599	22660438393047
94827	1397	1316217756000
94828	1678	23040757344000
94829	1397	1316207755000
94830	1678	23040757345000
94831	1397	1316197754000
94832	1678	23040757346000
94833	2133	96315642000
94834	1874	15870000
94835	2133	96314640000
94836	1874	15872000
94837	2132	148129130000
94838	1874	15873000
94839	2133	96313638000
94840	1874	15875000
94841	1634	5422871259504
94842	1634	5422905259504
94843	1397	1316187753000
94844	1678	23040757347000
94845	2133	96312636000
94846	1874	15877000
94847	1426	26205298000000
94848	1426	26205309000000
94876	1397	1316157750000
94877	1678	23040757350000
94878	2133	96309630000
94879	1874	15884000
94880	364	66720000000000
94881	364	66720012000000
94882	1397	1316147749000
94883	1678	23040757351000
94884	2133	96308628000
94885	1874	15886000
94886	404	67440020000000
94887	404	67440031000000
94893	1397	1316137748000
94894	1678	23040757352000
94895	2132	148127128000
94896	1874	15887000
94897	2133	96307626000
94898	1874	15889000
94899	1762	2805294994000
94900	1397	1316127747000
94901	1678	23040757353000
94902	2133	96306624000
94903	1874	15891000
94904	1696	21377570835100
94905	1696	21377581835100
94951	2132	148126127000
94952	1874	15896000
94953	2261	719001000000
94962	1397	1316087743000
94963	1678	23040757357000
94964	2133	96302616000
94965	1874	15900000
94966	1701	3598110500103
94967	1701	3598121500103
94992	2133	96299610000
94993	1874	15907000
94994	1457	26544583040000
94995	1457	26544605040000
95002	1992	19948539990000
95003	1633	16597227465639
95004	1633	201000000
95005	2145	16597502435642
95006	1655	66000200000000
95007	442	25000000
95008	2097	200044014
95023	1992	5564520990000
95024	1306	1709649637751650
95025	1397	1316027737000
95026	1678	23040757363000
95027	2133	96296604000
95028	1874	15914000
95029	369	79332288412810
95043	2133	96294600000
95044	1874	15918000
95061	1992	4320510990000
95062	1397	1315987733000
95063	1678	23040757367000
95064	1397	1315977732000
95065	1678	23040757368000
95066	2133	96292596000
95067	1874	15923000
95068	2133	96291594000
95069	1874	15925000
95070	1633	15876749975638
95083	1397	1315957730000
95084	1678	23040757370000
95085	1397	1315947729000
95086	1678	23040757371000
95087	2133	96289590000
95088	1874	15930000
95089	2133	96288588000
95090	1874	15932000
95091	1546	19441084000000
95092	1546	19441106000000
95093	1705	16147086490145
95094	994	507243255271745
95095	1397	1315937728000
95096	1678	23040757372000
95097	1397	1315927727000
95098	1678	23040757373000
95099	1397	1315917726000
95100	1678	23040757374000
95101	1397	1315907725000
95102	1678	23040757375000
95103	2132	148121122000
95104	1874	15933000
95105	2133	96287586000
95106	1874	15935000
95107	2133	96286584000
95108	1874	15937000
95109	2133	96285582000
95110	1874	15939000
95111	2133	96284580000
95112	1874	15941000
95113	1426	26205363000000
95116	1705	12977771140145
95117	1114	908975568495245
95118	1397	1315897724000
95119	1678	23040757376000
95120	2132	148120121000
95121	1874	15942000
95122	2133	96283578000
95123	1874	15944000
95124	2086	3775353300069
95173	1397	1315827717000
95174	1678	23040757383000
95175	1932	1382918664093
95176	2133	96276564000
95177	1874	15960000
95178	1740	20805584000000
95179	1740	20805605000000
95194	1397	1315797714000
95195	1678	23040757386000
95196	1397	1315787713000
95197	1678	23040757387000
95198	2133	96273558000
95199	1874	15966000
95200	2133	96272556000
95201	1874	15968000
95202	2132	148117118000
95203	1874	15969000
95204	1685	141123124571430
95205	1685	141123147571430
95243	1684	2882755219748
95166	1678	23040757382000
95167	2133	96277566000
95168	1874	15957000
95169	2132	148118119000
95170	1874	15958000
95171	2112	2160054000000
95172	2112	2160066000000
95212	1719	2880096000000
95235	1397	1315767711000
95236	1678	23040757389000
95237	2132	148116117000
95238	1874	15972000
95239	2133	96270552000
95240	1874	15974000
95241	1992	5040510990000
95242	1992	5040522990000
95260	633	70029303900000
95261	633	70029314900000
95279	1637	244805838819988
95335	1395	58160788370507701
95336	1395	58160788392507701
95345	1623	60482954899898
95369	1394	478088044500000
95370	1394	478088056500000
95377	1397	1315607695000
95378	1678	23040757405000
95379	2133	96255522000
95380	1874	16008000
95381	1395	58160788381507701
95400	2106	5039094000000
95406	1397	1315567691000
95407	1678	23040757409000
95408	1397	1315557690000
95409	1678	23040757410000
95410	2133	96251514000
95411	1874	16017000
95412	2132	148110111000
95413	1874	16018000
95414	2133	96250512000
95415	1874	16020000
95416	1684	3602766219748
95417	1684	3602789219748
95458	1397	1315477682000
95459	1678	23040757418000
95460	2133	96242496000
95461	1874	16038000
95462	1514	720000030400
95463	1514	720011030400
95478	1688	7198721910100
95481	1397	1315457680000
95482	1678	23040757420000
95483	1397	1315447679000
95484	1678	23040757421000
95485	242	66001385291044
95486	2269	649000000000
95487	2133	96240492000
95488	1874	16043000
95489	2133	96239490000
95490	1874	16045000
95491	1395	58162228392507701
95492	1395	58162228424507701
95495	1397	1315437678000
95496	1678	23040757422000
95497	2133	96238488000
95498	1874	16047000
95516	1397	1315407675000
95517	1678	23040757425000
95518	2039	18325785000000
95519	924	507246525000000
95520	2133	96235482000
95521	1874	16054000
95522	1637	245525838819988
95523	1637	245525859819988
95546	1397	1315367671000
95547	1678	23040757429000
95548	2132	148104105000
95549	1874	16062000
95550	2133	96231474000
95551	1874	16064000
95552	1394	483848113500000
95553	1394	483848125500000
95607	365	66017201000000
95608	2270	699000000000
95609	1397	1315287663000
95610	1678	23040757437000
95611	2133	96223458000
95612	1874	16082000
95613	1394	485288125500000
95614	1394	485288236500000
95636	1397	1315247659000
95637	1678	23040757441000
95638	2133	96219450000
95639	1874	16091000
95640	1688	7918721910100
95641	1688	7918732910100
95664	1397	1315217656000
95665	1678	23040757444000
95666	1397	1315207655000
95667	1678	23040757445000
95668	2133	96216444000
95669	1874	16098000
95670	2133	96215442000
95671	1874	16100000
95672	1637	246245859819988
95673	1637	246245881819988
95701	1397	1315157650000
95702	1678	23040757450000
95703	2133	96210432000
95704	1874	16112000
95705	2261	1439012000000
95706	2261	1439023000000
95721	1397	1315127647000
95722	1678	23040757453000
95723	2132	148097098000
95724	1874	16117000
95725	2133	96207426000
95726	1874	16119000
95727	1679	5758459654000
95728	1679	5758471654000
95735	1688	8638732910100
95736	1688	8638743910100
95737	1397	1315107645000
95738	1678	23040757455000
95739	1397	1315097644000
95740	1678	23040757456000
95741	1397	1315087643000
95742	1678	23040757457000
95743	2132	148096097000
95744	1874	16122000
95745	2133	96205422000
95746	1874	16124000
95747	2133	96204420000
95748	1874	16126000
95749	2133	96203418000
95750	1874	16128000
95751	1657	17281498990100
95752	1657	17281532990100
95779	2100	2830000000
95780	1564	3558520000000
95781	588	66471000000000
95782	1457	27264605040000
95783	1457	27264935040000
95796	1397	1315017636000
95797	1678	23040757464000
95798	2133	96197406000
95799	1874	16142000
95800	1814	200055000
95801	2221	200800000
95802	1719	200004800
95803	1855	2880090142829
95804	1571	277999972
95805	1527	3312042151232
95810	1397	1315007635000
95811	1678	23040757465000
95812	2133	96196404000
95813	1874	16144000
95814	1696	22097581835100
95815	1696	22097592835100
95841	1672	721214000000
95842	2016	2332000000000
95843	1397	1314987633000
95844	1678	23040757467000
95845	2133	96193398000
95846	1874	16151000
95847	1688	9358743910100
95848	1688	9358764910100
95849	1419	10368047560130
95850	1419	10368068560130
95876	1402	76895068319298
95877	1402	76895079319298
95884	1397	1314927627000
95885	1678	23040757473000
95886	2133	96187386000
95887	1874	16165000
95888	1447	20313686943000
95889	1447	20313697943000
95906	1397	1314897624000
95907	1678	23040757476000
95908	1397	1314887623000
95909	1678	23040757477000
95910	2039	2779255000000
95911	2039	2779275000000
95917	2039	2779277000000
95946	1703	720892000000
95985	1397	1314817616000
95209	1874	15971000
95210	1688	6478688910100
95211	1688	6478699910100
95245	1705	5600489580140
95246	1705	5600501580140
95256	1397	1315737708000
95257	1678	23040757392000
95258	2133	96267546000
95259	1874	15980000
95270	1397	1315717706000
95271	1678	23040757394000
95272	1397	1315707705000
95273	1678	23040757395000
95274	2133	96265542000
95275	1874	15985000
95276	2133	96264540000
95277	1874	15987000
95278	1671	3263867003785
95304	484	68254074000000
95305	1874	15922000
95306	1874	15924000
95307	1874	15934000
95308	1874	15936000
95309	1874	15938000
95310	1874	15940000
95311	1874	15948000
95312	1874	15950000
95313	1874	15952000
95314	1874	15954000
95315	1874	15956000
95316	1874	15970000
95317	1874	15982000
95318	1874	15984000
95319	1874	15986000
95320	1874	15988000
95321	484	68974074000000
95322	484	68974322000000
95327	1397	1315667701000
95328	1678	23040757399000
95329	149	69695228000341
95330	2133	96261534000
95331	1874	15994000
95332	2132	148113114000
95333	1874	15995000
95334	1467	17246937100039
95339	1397	1315657700000
95340	1678	23040757400000
95341	2133	96260532000
95342	1874	15997000
95343	1447	19593675943000
95344	1447	19593686943000
95352	1451	16459068000000
95353	1451	17179068000000
95354	1688	6478710910100
95355	1688	7198710910100
95361	1397	1315627697000
95362	1678	23040757403000
95363	2133	96257526000
95364	1874	16003000
95365	2132	148112113000
95366	1874	16004000
95367	1489	21504545000000
95368	1489	21504557000000
95371	1397	1315617696000
95372	1678	23040757404000
95373	2133	96256524000
95374	1874	16006000
95375	1394	479528056500000
95376	1394	479528067500000
95389	1394	480968067500000
95390	1394	480968079500000
95399	1448	10836821000001
95401	1397	1315577692000
95402	1678	23040757408000
95403	2133	96252516000
95404	1874	16015000
95405	1684	2882766219748
95418	1688	7198699910100
95419	1688	7198722910100
95470	242	66648395291044
95471	2269	2000000000
95472	1397	1315467681000
95473	1678	23040757419000
95474	2132	148107108000
95475	1874	16039000
95476	2133	96241494000
95477	1874	16041000
95500	1397	1315427677000
95501	1678	23040757423000
95502	2039	20879545000000
95503	1445	1004169000000
95504	2133	96237486000
95505	1874	16049000
95506	2132	148106107000
95507	1874	16050000
95508	1613	20808173600000
95509	1613	20808195600000
95535	1397	1315387673000
95536	1678	23040757427000
95537	2039	2059255000000
95538	1290	1709035637751650
95539	2133	96233478000
95540	1874	16059000
95541	1402	75455057319298
95582	1474	3070336000043
95605	632	70317277000000
95606	632	70317380000000
95628	2270	698900000000
95629	2100	1434860000000
95630	2271	2000000000
95631	1397	1315257660000
95632	1678	23040757440000
95633	2133	96220452000
95634	1874	16089000
95635	1395	58162228523507701
95653	1516	3562056390000
95654	1168	612272180460622
95655	1294	1706150513755879
95656	1397	1315227657000
95657	1678	23040757443000
95658	2132	148100101000
95659	1874	16094000
95660	2133	96217446000
95661	1874	16096000
95662	1588	22535329000000
95663	1588	22535541000000
95692	1394	486728236500000
95693	1394	486728270500000
95708	1397	1315147649000
95709	1678	23040757451000
95710	2133	96209430000
95711	1874	16114000
95712	1685	141843147571430
95713	1685	141843158571430
95761	1489	21504586000000
95775	1397	1315047639000
95776	1678	23040757461000
95777	2133	96200412000
95778	1874	16135000
95808	1571	2880095999992
95809	1719	3312042151064
95821	1672	15791254000000
95822	1285	1714307637751650
95823	1672	9637244000000
95824	1039	911784465000000
95825	1672	5484234000000
95826	1159	615200750000000
95827	1672	2049224000000
95828	919	508811775000000
95829	2132	148093094000
95830	1874	16145000
95831	2133	96195402000
95832	1874	16147000
95833	1706	4601950450256
95834	1706	4601992450256
95835	1397	1314997634000
95836	1678	23040757466000
95837	2133	96194400000
95838	1874	16149000
95839	1980	18719435000000
95840	1980	18719446000000
95851	1397	1314977632000
95852	1678	23040757468000
95853	2132	148092093000
95854	1874	16152000
95855	2133	96192396000
95856	1874	16154000
95857	1587	2880098000000
95858	1587	2880110000000
95859	1690	147604702000000
95860	1690	147604714000000
95866	1397	1314957630000
95867	1678	23040757470000
95868	2133	96190392000
95869	1874	16158000
95872	1397	1314947629000
95873	1678	23040757471000
95874	2133	96189390000
95875	1874	16160000
95897	1698	4388771550062
95898	1698	4388782550062
95899	1397	1314907625000
95900	1678	23040757475000
95901	2133	96185382000
95902	1874	16169000
95222	1874	15927000
95223	1874	15929000
95224	1874	15931000
95225	1687	13580911223172
95226	1874	15943000
95227	1874	15945000
95228	1874	15959000
95229	1874	15961000
95230	1874	15963000
95231	1874	15965000
95232	1874	15967000
95233	1687	14300911223172
95234	1687	14300930223172
95262	1397	1315727707000
95263	1678	23040757393000
95264	2132	148115116000
95265	1874	15981000
95266	2133	96266544000
95267	1874	15983000
95268	1740	21525605000000
95269	1740	21525617000000
95280	1671	2544375003785
95281	1874	15908000
95282	1874	15910000
95283	1874	15920000
95284	1874	15973000
95285	1874	15975000
95286	1874	15977000
95287	1874	15979000
95288	1671	3264375003785
95289	1671	3264428003785
95298	1397	1315687703000
95299	1678	23040757397000
95300	2133	96262536000
95301	1874	15992000
95302	1692	44420802619999
95303	1692	44420813619999
95323	1397	1315677702000
95324	1678	23040757398000
95325	1489	20784535000000
95326	1489	20784545000000
95337	1708	20196294500022
95338	1708	20196316500022
95346	1397	1315647699000
95347	1678	23040757401000
95348	2133	96259530000
95349	1874	15999000
95350	1717	21708344000023
95351	1717	22428344000023
95356	1397	1315637698000
95357	1678	23040757402000
95358	2133	96258528000
95359	1874	16001000
95360	1564	17106620000000
95382	1397	1315597694000
95383	1678	23040757406000
95384	2133	96254520000
95385	1874	16010000
95386	2132	148111112000
95387	1874	16011000
95388	1668	4113491000000
95397	1634	6142905259504
95398	1634	6142916259504
95426	1397	1315537688000
95427	1678	23040757412000
95428	1397	1315527687000
95429	1678	23040757413000
95430	1397	1315517686000
95431	1678	23040757414000
95432	2133	96248508000
95433	1874	16024000
95434	2132	148109110000
95435	1874	16025000
95436	2133	96247506000
95437	1874	16027000
95438	2133	96246504000
95439	1874	16029000
95440	1690	145444625000000
95441	1690	145444659000000
95442	1397	1315507685000
95443	1678	23040757415000
95444	1397	1315497684000
95445	1678	23040757416000
95446	1397	1315487683000
95447	1678	23040757417000
95448	2133	96245502000
95449	1874	16031000
95450	2132	148108109000
95451	1874	16032000
95452	2133	96244500000
95453	1874	16034000
95454	2133	96243498000
95455	1874	16036000
95456	1394	482408079500000
95457	1394	482408113500000
95524	2039	15238175000000
95525	1164	613308350000000
95526	2039	10662265000000
95527	1044	908981365000000
95528	1397	1315397674000
95529	1678	23040757426000
95530	2133	96234480000
95531	1874	16056000
95532	2132	148105106000
95533	1874	16057000
95534	1762	3525326994000
95554	1397	1315357670000
95555	1678	23040757430000
95556	2133	96230472000
95557	1874	16066000
95558	43	84720996890000
95559	1397	1315347669000
95560	1678	23040757431000
95561	1397	1315337668000
95562	1678	23040757432000
95563	1397	1315327667000
95564	1678	23040757433000
95565	2269	648990000000
95566	2133	96229470000
95567	1874	16068000
95568	2133	96228468000
95569	1874	16070000
95570	1711	4026742000000
95571	2133	96227466000
95572	1874	16072000
95573	2132	148103104000
95574	1874	16073000
95575	1711	4746742000000
95576	1711	4746744000000
95577	1397	1315317666000
95578	1678	23040757434000
95579	2133	96226464000
95580	1874	16075000
95581	526	68880160000000
95603	1850	22959418949999
95604	1850	22959521949999
95642	1516	6735106290000
95643	928	506566118619092
95644	1516	4840470180000
95645	1048	907446321720448
95646	1397	1315237658000
95647	1678	23040757442000
95648	2271	1899000000
95649	2100	1434960000000
95650	2133	96218448000
95651	1874	16093000
95652	632	70317489000000
95690	1594	2161532000000
95691	1594	2161566000000
95694	1397	1315167651000
95695	1678	23040757449000
95696	2132	148098099000
95697	1874	16108000
95698	2133	96211434000
95699	1874	16110000
95700	1684	3602778219748
95719	1756	4160720195609
95720	1756	4160731195609
95729	1397	1315117646000
95730	1678	23040757454000
95731	2133	96206424000
95732	1874	16121000
95733	1546	20161106000000
95734	1546	20161117000000
95753	2100	2930000000
95754	1958	5031186000000
95755	1397	1315077642000
95756	1678	23040757458000
95757	2133	96202416000
95758	1874	16130000
95759	1768	6226532110000
95760	1768	6226573110000
95763	1650	3712863000000
95764	1650	3712904000000
95806	1444	2247575329999
95807	1444	2247586329999
95816	1564	10241589000000
95817	1705	15427043490145
95818	1564	6973569000000
95819	1696	22099096835100
95820	1696	22099256835100
95870	1402	76175057319298
95871	1402	76175068319298
95890	1689	720034287617
95892	1397	1314917626000
95244	1684	2882767219748
95247	1397	1315757710000
95248	1678	23040757390000
95249	1397	1315747709000
95250	1678	23040757391000
95251	2133	96269550000
95252	1874	15976000
95253	2133	96268548000
95254	1874	15978000
95255	1560	3609602131803
95290	1397	1315697704000
95291	1678	23040757396000
95292	2133	96263538000
95293	1874	15989000
95294	2132	148114115000
95295	1874	15990000
95296	1444	1527563329999
95297	1444	1527575329999
95391	1397	1315587693000
95392	1678	23040757407000
95393	2133	96253518000
95394	1874	16013000
95395	1509	21552238851155
95396	1509	21552249851155
95420	1397	1315547689000
95421	1678	23040757411000
95422	2133	96249510000
95423	1874	16022000
95424	1395	58161508381507701
95425	1395	58161508392507701
95464	1514	660030400
95465	1874	15899000
95466	1874	15901000
95467	1874	15903000
95468	1514	720660030400
95469	1514	720850030400
95479	1762	3525294994000
95480	1762	3525316994000
95493	1690	146164659000000
95494	1690	146164691000000
95499	1395	58162228403507701
95510	1397	1315417676000
95511	1678	23040757424000
95512	2133	96236484000
95513	1874	16052000
95514	1690	146884691000000
95515	1690	146884702000000
95542	1397	1315377672000
95543	1678	23040757428000
95544	2133	96232476000
95545	1874	16061000
95583	1564	10961600000000
95584	1338	1705962637751650
95585	1564	7693580000000
95586	1092	907346465000000
95587	1564	5488560000000
95588	1212	612204750000000
95589	1564	4026540000000
95590	972	506334775000000
95591	1397	1315307665000
95592	1678	23040757435000
95593	1397	1315297664000
95594	1678	23040757436000
95595	2133	96225462000
95596	1874	16077000
95597	2133	96224460000
95598	1874	16079000
95599	2132	148102103000
95600	1874	16080000
95601	1680	2893085499559
95602	1680	2893188499559
95615	1397	1315277662000
95616	1678	23040757438000
95617	1756	3440720195609
95618	1516	7792474350000
95619	1397	1315267661000
95620	1678	23040757439000
95621	2133	96222456000
95622	1874	16084000
95623	2133	96221454000
95624	1874	16086000
95625	2132	148101102000
95626	1874	16087000
95627	1587	2160098000000
95674	1397	1315197654000
95675	1678	23040757446000
95676	1397	1315187653000
95677	1678	23040757447000
95678	1397	1315177652000
95679	1678	23040757448000
95680	2133	96214440000
95681	1874	16102000
95682	2132	148099100000
95683	1874	16103000
95684	2133	96213438000
95685	1874	16105000
95686	2133	96212436000
95687	1874	16107000
95688	1395	58162948523507701
95689	1395	58162948557507701
95707	1395	58162948534507701
95714	1397	1315137648000
95715	1678	23040757452000
95716	2133	96208428000
95717	1874	16116000
95718	1691	22283446100019
95762	1764	18007173100000
95765	1397	1315067641000
95766	1678	23040757459000
95767	1397	1315057640000
95768	1678	23040757460000
95769	2132	148095096000
95770	1874	16131000
95771	2133	96201414000
95772	1874	16133000
95773	1637	246965881819988
95774	1637	246965903819988
95784	1397	1315037638000
95785	1678	23040757462000
95786	1397	1315027637000
95787	1678	23040757463000
95788	2133	96199410000
95789	1874	16137000
95790	2133	96198408000
95791	1874	16139000
95792	2132	148094095000
95793	1874	16140000
95794	1764	18727173100000
95795	1764	18727196100000
95861	1397	1314967631000
95862	1678	23040757469000
95863	2133	96191394000
95864	1874	16156000
95865	1394	486728247500000
95878	1397	1314937628000
95879	1678	23040757472000
95880	2133	96188388000
95881	1874	16162000
95882	2132	148091092000
95883	1874	16163000
95891	1688	9358754910100
95896	1423	720582750023
95918	1714	11638176439708
95919	1300	1710301631910020
95920	1714	9295374638556
95921	1174	613761729502880
95922	1714	5823121253616
95923	1054	909654073462350
95924	1714	3885466171760
95925	934	507621887704640
95926	1397	1314877622000
95927	1678	23040757478000
95928	1397	1314867621000
95929	1678	23040757479000
95930	1397	1314857620000
95931	1678	23040757480000
95932	1397	1314847619000
95933	1678	23040757481000
95934	2133	96182376000
95935	1874	16176000
95936	2133	96181374000
95937	1874	16178000
95938	2133	96180372000
95939	1874	16180000
95940	2133	96179370000
95941	1874	16182000
95942	2132	148089090000
95943	1874	16183000
95944	1547	22173765000000
95945	1547	22173850000000
95948	1547	21454295000000
95949	1874	16053000
95950	1874	16055000
95951	1874	16058000
95952	1874	16060000
95953	1874	16063000
95954	1874	16065000
95955	1874	16067000
95956	1874	16069000
95957	1874	16071000
95958	1874	16081000
95959	1874	16083000
95960	1874	16085000
95961	1874	16095000
95962	1874	16097000
95893	1678	23040757474000
95894	2133	96186384000
95895	1874	16167000
95912	2133	96184380000
95913	1874	16172000
95914	2133	96183378000
95915	1874	16174000
95916	2148	1440040880750
95947	1702	1440439000000
95973	1397	1314837618000
95974	1678	23040757482000
95975	1397	1314827617000
95976	1678	23040757483000
95977	2133	96178368000
95978	1874	16185000
95979	2133	96177366000
95980	1874	16187000
95981	2132	148088089000
95982	1874	16188000
95983	1719	2880108000000
95991	1395	58163668534507701
95992	1395	58163668545507701
96008	1397	1314787613000
96009	1678	23040757487000
96010	2133	96173358000
96011	1874	16197000
96012	1458	24573861908540
96013	1458	24573872908540
96034	1397	1314777612000
96035	1678	23040757488000
96036	2133	96172356000
96037	1874	16199000
96038	2132	148086087000
96039	1874	16200000
96040	1656	5035283999990
96041	1656	5035295999990
96060	1397	1314747609000
96061	1678	23040757491000
96062	1397	1314737608000
96063	1678	23040757492000
96064	2133	96169350000
96065	1874	16206000
96066	2133	96168348000
96067	1874	16208000
96068	2132	148085086000
96069	1874	16209000
96070	2248	3599334000000
96072	1397	1314727607000
96073	1678	23040757493000
96074	2133	96167346000
96075	1874	16211000
96076	1654	23325293999798
96081	1397	1314717606000
96082	1678	23040757494000
96083	1397	1314707605000
96084	1678	23040757495000
96085	1397	1314697604000
96086	1678	23040757496000
96087	2133	96166344000
96088	1874	16213000
96089	2132	148084085000
96090	1874	16214000
96091	2133	96165342000
96092	1874	16216000
96093	1509	21552271851155
96096	1395	58163668567507701
96099	1397	1314687603000
96100	1678	23040757497000
96101	2133	96164340000
96102	1874	16218000
96103	676	67440021000000
96129	1397	1314647599000
96130	1678	23040757501000
96131	2133	96161334000
96132	1874	16225000
96133	2133	96160332000
96134	1874	16227000
96135	1684	4322778219748
96136	1684	4322790219748
96139	1688	10798777910100
96160	1397	1314607595000
96161	1678	23040757505000
96162	2133	96156324000
96163	1874	16236000
96164	2132	148081082000
96165	1874	16237000
96166	1395	58163668546507701
96177	1397	1314587593000
96178	1678	23040757507000
96179	1397	1314577592000
96180	1678	23040757508000
96181	2133	96154320000
96182	1874	16241000
96183	2132	148080081000
96184	1874	16242000
96185	1684	5042790219748
96186	1684	5042812219748
96188	1397	1314567591000
96189	1678	23040757509000
96190	2133	96153318000
96191	1874	16244000
96198	1397	1314547589000
96199	1678	23040757511000
96200	1397	1314537588000
96201	1678	23040757512000
96202	2133	96151314000
96203	1874	16248000
96204	2132	148079080000
96205	1874	16249000
96206	2133	96150312000
96207	1874	16251000
96208	1637	249125925819988
96209	1637	249125948819988
96252	1593	26470659000000
96266	2133	96147306000
96267	1874	16257000
96268	1874	16258000
96269	1588	23255541000000
96270	1588	23255553000000
96315	1706	5321992450256
96316	1706	5322004450256
96321	1690	147604713000000
96341	1703	829000000
96342	1703	720829000000
96343	1703	720830000000
96369	1397	1314357570000
96370	1678	23040757530000
96371	1397	1314347569000
96372	1678	23040757531000
96373	2133	96132276000
96374	1874	16292000
96375	2133	96131274000
96376	1874	16294000
96377	1747	9376954000000
96394	1397	1314327567000
96395	1678	23040757533000
96396	1637	250565981819988
96397	1637	250565991819988
96411	1397	1314297564000
96412	1678	23040757536000
96413	1874	16298000
96414	2133	96127266000
96415	1874	16304000
96416	1688	12238908910100
96417	1688	12238942910100
96419	1397	1314287563000
96420	1678	23040757537000
96421	2133	96126264000
96422	1874	16306000
96423	1394	495368314500000
96424	1394	495368336500000
96429	1394	495368324500000
96441	1397	1314257560000
96442	1678	23040757540000
96443	2133	96124260000
96444	1874	16311000
96445	1394	495368325500000
96447	1397	1314247559000
96448	1678	23040757541000
96449	2133	96123258000
96450	1874	16313000
96451	1688	12958919910100
96452	1688	12958930910100
96470	1397	1314207555000
96471	1678	23040757545000
96472	2132	148069070000
96473	1874	16321000
96474	2133	96119250000
96475	1874	16323000
96476	1587	3600110000000
96477	1587	3600122000000
96494	2132	148068069000
96495	1874	16330000
96496	2133	96115242000
96497	1874	16332000
96498	1693	5942636908632
96499	1693	5942638908632
96504	1692	45860835619999
96505	1692	45860837619999
96516	1397	1314147549000
96517	1678	23040757551000
96518	2132	148067068000
96519	1874	16337000
96520	2133	96112236000
96521	1874	16339000
95903	2132	148090091000
95904	1874	16170000
95905	1580	2160044000000
95995	1397	1314807615000
95996	1678	23040757485000
95997	1397	1314797614000
95998	1678	23040757486000
95999	2132	148087088000
96000	1874	16191000
96001	2133	96175362000
96002	1874	16193000
96003	2133	96174360000
96004	1874	16195000
96005	1489	21504568000000
96077	1688	10078754910100
96078	1688	10078765910100
96094	2112	2880066000000
96095	2112	2880099000000
96104	1688	10798765910100
96105	1688	10798776910100
96114	1874	16220000
96115	1451	17179079000000
96125	1397	1314657600000
96126	1678	23040757500000
96127	1394	488168247500000
96128	1394	488168257500000
96152	1397	1314617596000
96153	1678	23040757504000
96154	2133	96157326000
96155	1874	16234000
96156	1394	489608257500000
96157	1394	489608268500000
96175	1637	247685903819988
96176	1637	247685914819988
96210	1682	10341000000
96211	1850	22240418949999
96212	1682	9331000000
96213	1850	22241418949999
96214	1397	1314527587000
96215	1678	23040757513000
96216	2133	96149310000
96217	1874	16253000
96218	1688	11518787910100
96219	1688	11518908910100
96246	1397	1314517586000
96247	1678	23040757514000
96248	2133	96148308000
96249	1874	16255000
96250	1395	58164388545507701
96251	1395	58164388596507701
96253	1685	142563209571430
96272	2106	5039095000000
96296	1397	1314457580000
96297	1678	23040757520000
96298	2133	96142296000
96299	1874	16269000
96303	1397	1314447579000
96304	1678	23040757521000
96305	2133	96141294000
96306	1874	16271000
96322	1397	1314417576000
96323	1678	23040757524000
96324	2133	96138288000
96325	1874	16278000
96326	1756	4880731195609
96327	1756	4880742195609
96351	1724	20817574500000
96352	1724	20817585500000
96355	1397	1314377572000
96356	1678	23040757528000
96357	1397	1314367571000
96358	1678	23040757529000
96359	2133	96134280000
96360	1874	16287000
96361	2133	96133278000
96362	1874	16289000
96363	2132	148074075000
96364	1874	16290000
96365	662	67440120000000
96366	662	67440143000000
96380	1451	17899091000000
96384	1397	1314337568000
96385	1678	23040757532000
96386	2132	148073074000
96387	1874	16295000
96388	2133	96130272000
96389	1874	16297000
96390	1549	26976153000000
96391	1549	26976165000000
96398	1692	45140823619999
96418	1688	12238931910100
96440	1446	720012000000
96460	1397	1314227557000
96461	1678	23040757543000
96462	1397	1314217556000
96463	1678	23040757544000
96464	2133	96121254000
96465	1874	16318000
96466	2133	96120252000
96467	1874	16320000
96468	1681	5651083109853
96469	1681	5651105109853
96478	1688	13678930910100
96479	1688	13678942910100
96480	1397	1314197554000
96481	1678	23040757546000
96482	1397	1314187553000
96483	1678	23040757547000
96484	1397	1314177552000
96485	1678	23040757548000
96486	2133	96118248000
96487	1874	16325000
96488	2133	96117246000
96489	1874	16327000
96490	2133	96116244000
96491	1874	16329000
96492	1705	6320501580140
96493	1705	6320534580140
96514	1692	46580837619999
96515	1692	46580848619999
96526	1395	58165108556507701
96527	1395	58165108568507701
96539	1714	4605466171760
96540	1714	4605488171760
96558	1395	58165108567507701
96616	1397	1313997534000
96617	1678	23040757566000
96618	1397	1313987533000
96619	1678	23040757567000
96620	1932	1372906664093
96621	2133	96097206000
96622	1874	16372000
96623	2133	96096204000
96624	1874	16374000
96625	1690	148324713000000
96626	1690	148324737000000
96645	1397	1313947529000
96646	1678	23040757571000
96647	2133	96092196000
96648	1874	16382000
96649	1705	7040534580140
96650	1705	7040545580140
96671	1395	58165828611507701
96672	1395	58165828622507701
96673	1397	1313897524000
96674	1678	23040757576000
96675	2133	96087186000
96676	1874	16392000
96677	1394	496808325500000
96678	1394	496808336500000
96711	1559	20122881000000
96712	1559	20122892000000
96724	1649	26924417999992
96725	1649	26924449999992
96732	1397	1313807515000
96733	1678	23040757585000
96734	1397	1313797514000
96735	1678	23040757586000
96736	2133	96079170000
96737	1874	16408000
96738	2133	96078168000
96739	1874	16410000
96740	1395	58165828633507701
96747	1397	1313777512000
96748	1678	23040757588000
96749	1397	1313767511000
96750	1678	23040757589000
96751	1397	1313757510000
96752	1678	23040757590000
96753	2133	96076164000
96754	1874	16414000
96755	2133	96075162000
96756	1874	16416000
96757	2133	96074160000
96758	1874	16418000
96759	1394	498248369500000
96773	2135	719877000000
96774	2135	1439877000000
96775	2135	1440367000000
96802	1397	1313687503000
96803	1678	23040757597000
96804	2133	96068148000
96805	1874	16430000
96806	1394	499688380500000
96814	1746	10594443000000
95963	1874	16099000
95964	1874	16101000
95965	1874	16109000
95966	1874	16111000
95967	1874	16113000
95968	1874	16115000
95969	1874	16123000
95970	1874	16125000
95971	1547	22174295000000
95972	1547	22174780000000
95984	1509	21552261851155
95993	526	69600160000000
95994	526	69600171000000
96007	1489	21504566000000
96042	364	67440012000000
96043	364	67440024000000
96071	1690	147604725000000
96097	1692	45140813619999
96098	1692	45140846619999
96116	1397	1314667601000
96117	1678	23040757499000
96118	2133	96162336000
96119	1874	16223000
96120	1740	22245617000000
96121	1740	22245628000000
96137	1594	2881566000000
96138	1594	2881578000000
96140	1397	1314637598000
96141	1678	23040757502000
96142	1397	1314627597000
96143	1678	23040757503000
96144	2133	96159330000
96145	1874	16229000
96146	2133	96158328000
96147	1874	16231000
96148	2132	148082083000
96149	1874	16232000
96150	1444	2967586329999
96151	1444	2967609329999
96167	1679	6478471654000
96168	1679	6478483654000
96170	1397	1314597594000
96171	1678	23040757506000
96172	2133	96155322000
96173	1874	16239000
96174	1700	3834166979053
96187	1688	10798787910100
96254	1564	4768549000000
96255	1564	3306529000000
96256	1564	2838509000000
96257	484	68975152000000
96258	484	69695152000000
96259	484	69695832000000
96271	1448	11556833000001
96273	1397	1314497584000
96274	1678	23040757516000
96275	1397	1314487583000
96276	1678	23040757517000
96277	1397	1314477582000
96278	1678	23040757518000
96279	2133	96146304000
96280	1874	16260000
96281	2133	96145302000
96282	1874	16262000
96283	2133	96144300000
96284	1874	16264000
96285	1637	249845948819988
96286	1637	249845981819988
96294	1394	491048268500000
96295	1394	491048280500000
96344	1702	1440461000000
96345	1702	2160461000000
96346	1702	2160462000000
96347	1397	1314387573000
96348	1678	23040757527000
96349	2133	96135282000
96350	1874	16285000
96353	1613	21528195600000
96354	1613	21528206600000
96378	1746	11314433000000
96379	1746	11314455000000
96405	1397	1314307565000
96406	1678	23040757535000
96407	2132	148072073000
96408	1874	16300000
96409	2133	96128268000
96410	1874	16302000
96425	1692	45140835619999
96438	1711	5466744000000
96439	1711	5466756000000
96446	1688	12238919910100
96453	1397	1314237558000
96454	1678	23040757542000
96455	2133	96122256000
96456	1874	16315000
96457	2132	148070071000
96458	1874	16316000
96459	1422	18145264860211
96500	1397	1314167551000
96501	1678	23040757549000
96502	247	66720000000000
96503	247	66720012000000
96506	2133	96114240000
96507	1874	16334000
96508	1397	1314157550000
96509	1678	23040757550000
96510	2133	96113238000
96511	1874	16336000
96512	1679	7198483654000
96513	1679	7198494654000
96524	1602	3456201170000
96525	1602	3456213170000
96556	1637	251285991819988
96557	1637	251286002819988
96559	1397	1314097544000
96560	1678	23040757556000
96561	1397	1314087543000
96562	1678	23040757557000
96563	2133	96107226000
96564	1874	16350000
96565	2133	96106224000
96566	1874	16352000
96567	1441	720000000000
96568	1441	720022000000
96601	1397	1314027537000
96602	1678	23040757563000
96603	2133	96100212000
96604	1874	16366000
96633	1588	23975564000000
96697	1471	25100195900000
96698	1471	25100206900000
96699	1671	3265408003785
96700	1671	3985408003785
96701	1671	3985938003785
96709	470	69600114000000
96710	470	69600125000000
96713	1397	1313847519000
96714	1678	23040757581000
96715	1397	1313837518000
96716	1678	23040757582000
96717	1397	1313827517000
96718	1678	23040757583000
96719	2133	96082176000
96720	1874	16402000
96721	2133	96081174000
96722	1874	16404000
96723	1688	15118974910100
96745	1685	143283209571430
96746	1685	143283220571430
96762	1397	1313747509000
96763	1678	23040757591000
96764	1740	4050615000000
96765	563	83475615000000
96766	1675	3884117999977
96767	1675	3884129999977
96792	1685	144003220571430
96793	1685	144003264571430
96820	1397	1313667501000
96821	1678	23040757599000
96822	2133	96066144000
96823	1874	16434000
96882	1397	1313567491000
96883	1678	23040757609000
96884	2133	96056124000
96885	1874	16454000
96886	1402	78335090319298
96887	1402	78335101319298
96896	1395	58166548644507701
96933	1397	1313477482000
96934	1678	23040757618000
96935	2133	96047106000
96936	1874	16472000
96969	1691	23003446100019
96970	1691	23003468100019
96972	1397	1313407475000
96973	1678	23040757625000
96974	1394	505448435500000
96975	1394	505448445500000
96992	1394	508328467500000
96993	1394	508328478500000
97000	1690	149044737000000
97001	1690	149044748000000
97026	1397	1313347469000
97027	1678	23040757631000
97028	2133	96035082000
95986	1678	23040757484000
95987	2133	96176364000
95988	1874	16190000
95989	1402	77615079319298
95990	1402	77615090319298
96006	1555	13875402979096
96014	1564	9521576000000
96015	1705	14707017490145
96016	1564	6253556000000
96017	1705	11537702140145
96018	1564	4048536000000
96019	1564	2586516000000
96020	1564	2118496000000
96021	1705	9399286040145
96022	1705	9399266040140
96023	1705	3440420580140
96024	1992	19228527990000
96025	1992	14979517990000
96026	1992	12112507990000
96027	1992	4124497990000
96028	1992	2880487990000
96029	596	68338752000000
96030	1756	2720708195609
96031	1458	23856346908540
96032	1458	24576346908540
96033	1458	24576646908540
96044	1397	1314767611000
96045	1678	23040757489000
96046	1397	1314757610000
96047	1678	23040757490000
96048	1608	12149912000000
96049	1289	1708728477751650
96050	1608	7737612000000
96051	1043	908817755000000
96052	1608	4760542000000
96053	1163	613197810000000
96054	2133	96171354000
96055	1874	16202000
96056	2133	96170352000
96057	1874	16204000
96058	1571	4032042151056
96059	1571	4032094151056
96079	1685	142563158571430
96080	1685	142563169571430
96106	1397	1314677602000
96107	1678	23040757498000
96108	2132	148083084000
96109	1874	16219000
96110	2133	96163338000
96111	1874	16221000
96112	1451	17179057000000
96113	1451	17179069000000
96122	171	69546645696494
96123	171	69546656696494
96124	1692	45140824619999
96158	1980	19439446000000
96159	1980	19439457000000
96169	1685	142563170571430
96192	1397	1314557590000
96193	1678	23040757510000
96194	2133	96152316000
96195	1874	16246000
96196	1637	248405914819988
96197	1637	248405925819988
96220	1850	14038008949999
96221	1277	1709780037751650
96222	1850	9674898949999
96223	1031	909376565000000
96224	1850	6730988949999
96225	1151	613574650000000
96226	1850	4296178949999
96227	911	507467575000000
96228	1608	2298302000000
96229	923	507155005000000
96230	1874	16014000
96231	1874	16016000
96232	1874	16019000
96233	1874	16021000
96234	1874	16023000
96235	1874	16026000
96236	1874	16028000
96237	1874	16030000
96238	1874	16033000
96239	1874	16035000
96240	1874	16037000
96241	1874	16040000
96242	1874	16042000
96243	1874	16044000
96244	1593	26470487000000
96245	1593	26471129000000
96260	1397	1314507585000
96261	1678	23040757515000
96262	2132	148078079000
96263	1874	16256000
96264	1448	11556821000001
96265	1448	11556832000001
96287	1397	1314467581000
96288	1678	23040757519000
96289	2132	148077078000
96290	1874	16265000
96291	2133	96143298000
96292	1874	16267000
96293	2148	1440030880750
96300	1395	58164388556507701
96301	1702	2160439000000
96302	1702	2160450000000
96307	1397	1314437578000
96308	1678	23040757522000
96309	2132	148076077000
96310	1874	16272000
96311	2133	96140292000
96312	1874	16274000
96313	1555	14595402979096
96314	1555	14595414979096
96317	1397	1314427577000
96318	1678	23040757523000
96319	2133	96139290000
96320	1874	16276000
96328	1397	1314407575000
96329	1678	23040757525000
96330	1397	1314397574000
96331	1678	23040757526000
96332	2132	148075076000
96333	1874	16279000
96334	2133	96137286000
96335	1874	16281000
96336	1394	491048302500000
96337	2133	96136284000
96338	1874	16283000
96339	1394	492488302500000
96340	1394	492488303500000
96367	1451	17899069000000
96368	1451	17899219000000
96381	1704	4445332000000
96382	171	70266656696494
96383	171	70266678696494
96392	1656	5755295999990
96393	1656	5755307999990
96399	1397	1314317566000
96400	1678	23040757534000
96401	2133	96129270000
96402	1874	16299000
96403	1394	493928303500000
96404	1394	493928314500000
96426	1397	1314277562000
96427	1678	23040757538000
96428	1455	751527000000
96430	1397	1314267561000
96431	1678	23040757539000
96432	2132	148071072000
96433	1874	16307000
96434	2133	96125262000
96435	1874	16309000
96436	1686	21092228550062
96437	1686	21092240550062
96528	1397	1314137548000
96529	1678	23040757552000
96530	1397	1314127547000
96531	1678	23040757553000
96532	2133	96111234000
96533	1874	16341000
96534	2133	96110232000
96535	1874	16343000
96536	1700	3834177979053
96542	1397	1314117546000
96543	1678	23040757554000
96544	2132	148066067000
96545	1874	16340000
96546	1874	16342000
96547	1874	16344000
96548	2133	96109230000
96549	1874	16346000
96550	1692	46580871619999
96569	1397	1314077542000
96570	1678	23040757558000
96571	2132	148065066000
96572	1874	16353000
96573	2133	96105222000
96574	1874	16355000
96575	2261	2159023000000
96576	2261	2159035000000
96577	1932	1372908664093
96578	259	66010000000000
96579	1397	1314067541000
96580	1678	23040757559000
96522	1588	23975553000000
96523	1588	23975565000000
96537	1395	58165108578507701
96538	1700	3834175979053
96541	1692	46580859619999
96551	1397	1314107545000
96552	1678	23040757555000
96553	2133	96108228000
96554	1874	16348000
96555	1489	21504556000000
96600	1688	14398942910100
96614	1564	4746540000000
96615	1564	4746573000000
96627	1397	1313977532000
96628	1678	23040757568000
96629	2133	96095202000
96630	1874	16376000
96631	1688	15118942910100
96632	1688	15118953910100
96638	1476	2160024000000
96639	1476	2160035000000
96665	1397	1313907525000
96666	1678	23040757575000
96667	2133	96088188000
96668	1874	16390000
96669	1696	22817592835100
96670	1696	22817603835100
96685	1394	498248336500000
96686	1394	498248347500000
96692	1397	1313867521000
96693	1678	23040757579000
96694	2133	96084180000
96695	1874	16398000
96696	1671	3263856003785
96708	1680	3613350499559
96768	484	69696402000000
96769	1397	1313737508000
96770	1678	23040757592000
96771	484	70416402000000
96772	484	70416902000000
96807	1397	1313677502000
96808	1678	23040757598000
96809	1747	8656942000000
96810	2133	96067146000
96811	1874	16432000
96812	1747	9376942000000
96813	1747	9376943000000
96845	1649	26924418999992
96866	1687	14302250223172
96867	1687	15022250223172
96868	1687	15022440223172
96870	1397	1313587493000
96871	1678	23040757607000
96872	2133	96058128000
96873	1874	16450000
96874	1656	5755306999990
96894	1637	252006002819988
96895	1637	252006013819988
96897	1397	1313547489000
96898	1678	23040757611000
96899	2133	96054120000
96900	1874	16458000
96901	1596	2160048000000
96902	1596	2160059000000
96903	1397	1313537488000
96904	1678	23040757612000
96905	2133	96053118000
96906	1874	16460000
96907	1394	501128391500000
96918	1555	14595422979096
96959	1397	1313427477000
96960	1678	23040757623000
96961	1397	1313417476000
96962	1678	23040757624000
96963	2133	96042096000
96964	1874	16482000
96965	2133	96041094000
96966	1874	16484000
96967	1673	31285632000000
96968	1673	31285654000000
96986	1397	1313377472000
96987	1678	23040757628000
96988	2133	96038088000
96989	1874	16490000
96990	1850	5736189949999
96991	1850	5736200949999
97008	1471	14856185900000
97009	1386	1712107637751650
97010	1471	9790175900000
97011	1140	910615465000000
97012	1471	6372165900000
97013	1260	614410750000000
97014	1471	3545155900000
97015	1020	508158775000000
97016	1611	14581365550000
97017	975	506861175900000
97018	1611	10922654840000
97019	1095	908290884420000
97020	1611	8454049500000
97021	1215	612841958680000
97022	1611	1575063000000
97023	1341	1707738608751650
97024	1680	4333350499559
97025	1680	4333397499559
97035	1764	19447196100000
97036	1764	19447251100000
97050	1397	1313327467000
97051	1678	23040757633000
97052	2133	96033078000
97053	1874	16500000
97054	1740	4770626000000
97072	1649	17198479999992
97073	1383	1710879637751650
97074	1649	11642469999992
97075	1137	909961465000000
97076	1649	7893459999992
97077	1257	613969750000000
97078	1649	4792449999992
97079	1017	507794775000000
97080	1397	1313297464000
97081	1678	23040757636000
97082	1397	1313287463000
97083	1678	23040757637000
97084	2133	96030072000
97085	1874	16506000
97086	2133	96029070000
97087	1874	16508000
97088	1696	23537603835100
97089	1696	23537665835100
97094	1394	509768478500000
97095	1394	509768540500000
97096	1397	1313277462000
97097	1678	23040757638000
97098	1991	4221251355805
97099	1991	4221261355805
97112	1397	1313247459000
97113	1678	23040757641000
97114	2133	96026064000
97115	1874	16514000
97116	1394	509768489500000
97146	1522	2923305000000
97147	1397	1313177452000
97148	1678	23040757648000
97149	1397	1313167451000
97150	1678	23040757649000
97151	2133	96019050000
97152	1874	16528000
97153	2133	96018048000
97154	1874	16530000
97155	1622	25740524000005
97156	1622	25740546000005
97159	1476	2160046000000
97167	1444	3687610329999
97168	1397	1313147449000
97169	1678	23040757651000
97170	1397	1313137448000
97171	1678	23040757652000
97172	1397	1313127447000
97173	1678	23040757653000
97174	2132	148063064000
97175	1874	16533000
97176	2133	96016044000
97177	1874	16535000
97178	2133	96015042000
97179	1874	16537000
97180	1726	13309112000
97181	2272	200000000
97182	1726	12108112000
97183	2273	200000000
97184	1726	10907112000
97185	2274	200000000
97186	1394	512648500500000
97187	1394	512648536500000
97211	1397	1313107445000
97212	1678	23040757655000
97213	1397	1313097444000
97214	1678	23040757656000
97215	1397	1313087443000
97216	1678	23040757657000
97217	2134	95935835000
97218	1874	16540000
97219	2134	94734835000
97220	2280	200000000
97221	2134	93533835000
97222	2281	200000000
96581	1395	58164388576507701
96582	1397	1314057540000
96583	1678	23040757560000
96584	1397	1314047539000
96585	1678	23040757561000
96586	1397	1314037538000
96587	1678	23040757562000
96588	2132	148064065000
96589	1874	16356000
96590	2133	96104220000
96591	1874	16358000
96592	2133	96103218000
96593	1874	16360000
96594	2133	96102216000
96595	1874	16362000
96596	2133	96101214000
96597	1874	16364000
96598	1395	58165108576507701
96599	1395	58165108611507701
96605	1397	1314017536000
96606	1678	23040757564000
96607	1397	1314007535000
96608	1678	23040757565000
96609	2133	96099210000
96610	1874	16368000
96611	2133	96098208000
96612	1874	16370000
96613	1394	495368347500000
96634	1397	1313967531000
96635	1678	23040757569000
96636	2133	96094200000
96637	1874	16378000
96640	1397	1313957530000
96641	1678	23040757570000
96642	2133	96093198000
96643	1874	16380000
96644	1508	22356745500009
96651	1397	1313937528000
96652	1678	23040757572000
96653	1397	1313927527000
96654	1678	23040757573000
96655	1397	1313917526000
96656	1678	23040757574000
96657	2133	96091194000
96658	1874	16384000
96659	2133	96090192000
96660	1874	16386000
96661	2133	96089190000
96662	1874	16388000
96663	1549	27696165000000
96664	1549	27696198000000
96679	1397	1313887523000
96680	1678	23040757577000
96681	2133	96086184000
96682	1874	16394000
96683	1850	5016178949999
96684	1850	5016189949999
96687	1397	1313877522000
96688	1678	23040757578000
96689	2133	96085182000
96690	1874	16396000
96691	1559	19402881000000
96702	1397	1313857520000
96703	1678	23040757580000
96704	2133	96083178000
96705	1874	16400000
96706	1680	3613188499559
96707	1680	3613199499559
96726	1397	1313817516000
96727	1678	23040757584000
96728	2133	96080172000
96729	1874	16406000
96730	2039	3499277000000
96731	2039	3499288000000
96741	1397	1313787513000
96742	1678	23040757587000
96743	2133	96077166000
96744	1874	16412000
96760	1395	58166548633507701
96761	1395	58166548666507701
96776	1397	1313727507000
96777	1678	23040757593000
96778	1397	1313717506000
96779	1678	23040757594000
96780	1397	1313707505000
96781	1678	23040757595000
96782	2133	96073158000
96783	1874	16420000
96784	2133	96072156000
96785	1874	16422000
96786	2133	96071154000
96787	1874	16424000
96788	2133	96070152000
96789	1874	16426000
96790	1394	499688369500000
96791	1394	499688413500000
96794	1397	1313697504000
96795	1678	23040757596000
96796	563	75487613000000
96797	1359	1709956237751650
96798	2133	96069150000
96799	1874	16428000
96800	2248	4319334000000
96801	2248	4319347000000
96817	1704	3725320000000
96818	1704	4445320000000
96819	1704	4445321000000
96860	1601	8533620620000
96861	1601	8533653620000
96881	2148	1440029880750
96888	1397	1313557490000
96889	1678	23040757610000
96890	2133	96055122000
96891	1874	16456000
96892	1634	6862916259504
96893	1634	6862927259504
96908	1397	1313527487000
96909	1678	23040757613000
96910	1397	1313517486000
96911	1678	23040757614000
96912	2133	96052116000
96913	1874	16462000
96914	2133	96051114000
96915	1874	16464000
96916	1552	3600042000000
96917	1552	3600064000000
96919	1397	1313507485000
96920	1678	23040757615000
96921	1397	1313497484000
96922	1678	23040757616000
96923	1397	1313487483000
96924	1678	23040757617000
96925	2133	96050112000
96926	1874	16466000
96927	2133	96049110000
96928	1874	16468000
96929	2133	96048108000
96930	1874	16470000
96931	1394	502568391500000
96932	1394	502568424500000
96949	1397	1313447479000
96950	1678	23040757621000
96951	1397	1313437478000
96952	1678	23040757622000
96953	2133	96044100000
96954	1874	16478000
96955	2133	96043098000
96956	1874	16480000
96957	1611	18063067000000
96958	1611	18063089000000
96994	1397	1313367471000
96995	1678	23040757629000
96996	2133	96037086000
96997	1874	16492000
96998	1522	2923261000000
96999	1522	2923272000000
97002	1397	1313357470000
97003	1678	23040757630000
97004	2133	96036084000
97005	1874	16494000
97006	1679	7918494654000
97007	1679	7918505654000
97045	1444	2967619329999
97046	1444	3687619329999
97047	1444	3687620329999
97059	1426	15961288000000
97060	1364	1709956637751650
97061	1426	10895278000000
97062	1118	909471465000000
97063	1397	1313307465000
97064	1678	23040757635000
97065	1426	7477268000000
97066	1238	613638750000000
97067	1426	4650258000000
97068	998	507520775000000
97069	2133	96031074000
97070	1874	16504000
97071	1547	22173816000000
97101	1397	1313267461000
97102	1678	23040757639000
97103	2133	96028068000
97104	1874	16510000
97105	1668	4833502000000
97106	1668	4833513000000
97107	1397	1313257460000
96815	1746	11314443000000
96816	1746	11314444000000
96824	1397	1313657500000
96825	1678	23040757600000
96826	1397	1313647499000
96827	1678	23040757601000
96828	1397	1313637498000
96829	1678	23040757602000
96830	563	71238611000000
96831	1113	909471065000000
96832	563	68371609000000
96833	1233	613638650000000
96834	563	66000607000000
96835	993	507519575000000
96836	2133	96065142000
96837	1874	16436000
96838	2247	648999000000
96839	2133	96064140000
96840	1874	16438000
96841	2133	96063138000
96842	1874	16440000
96843	1649	27644449999992
96844	1649	27644489999992
96846	1397	1313627497000
96847	1678	23040757603000
96848	1397	1313617496000
96849	1678	23040757604000
96850	1397	1313607495000
96851	1678	23040757605000
96852	2133	96062136000
96853	1874	16442000
96854	2133	96061134000
96855	1874	16444000
96856	2133	96060132000
96857	1874	16446000
96858	1394	501128380500000
96859	1394	501128413500000
96862	1397	1313597494000
96863	1678	23040757606000
96864	2133	96059130000
96865	1874	16448000
96869	1656	5755298999990
96875	1397	1313577492000
96876	1678	23040757608000
96877	2133	96057126000
96878	1874	16452000
96879	1672	1441214000000
96880	1672	1441225000000
96937	1397	1313467481000
96938	1678	23040757619000
96939	2133	96046104000
96940	1874	16474000
96941	1608	5480542000000
96942	1608	5480553000000
96943	1397	1313457480000
96944	1678	23040757620000
96945	2133	96045102000
96946	1874	16476000
96947	1394	504008424500000
96948	1394	504008435500000
96971	1395	58166548655507701
96976	1397	1313397474000
96977	1678	23040757626000
96978	1397	1313387473000
96979	1678	23040757627000
96980	2133	96040092000
96981	1874	16486000
96982	2133	96039090000
96983	1874	16488000
96984	1394	506888445500000
96985	1394	506888467500000
97037	1397	1313337468000
97038	1678	23040757632000
97039	1688	14398952910100
97040	2133	96034080000
97041	1874	16498000
97042	1688	15118952910090
97043	1817	15118953910040
97044	1688	200000060
97048	1740	4770615000000
97049	1740	4770824000000
97055	1397	1313317466000
97056	1678	23040757634000
97057	2133	96032076000
97058	1874	16502000
97092	1724	21537585500000
97093	1724	21537647500000
97117	1397	1313237458000
97118	1678	23040757642000
97119	2133	96025062000
97120	1874	16516000
97121	1394	511208489500000
97122	1394	511208500500000
97160	1692	47300871619999
97161	1692	47300893619999
97162	1397	1313157450000
97163	1678	23040757650000
97164	2133	96017046000
97165	1874	16532000
97166	1444	3687609329999
97188	1608	3018303000000
97189	923	507155015000000
97190	1397	1313117446000
97191	1678	23040757654000
97192	1726	9706112000
97193	2275	200000000
97194	2133	96014040000
97195	1874	16539000
97196	1726	8505112000
97197	2276	200000000
97198	1726	7304112000
97199	2277	200000000
97200	1726	6103112000
97201	2276	1400000000
97202	1726	4902112000
97203	2277	1400000000
97204	1726	3701112000
97205	2278	200000000
97206	1726	2500112000
97207	2279	200000000
97208	1740	5490626000000
97209	1740	5490654000000
97252	1397	1313077442000
97253	1678	23040757658000
97254	2133	96010032000
97255	1874	16554000
97256	2134	87515829000
97257	1874	16557000
97258	2132	148061062000
97259	1874	16558000
97260	1680	3613201499559
97298	1397	1313047439000
97299	1678	23040757661000
97300	2134	87512820000
97301	1874	16571000
97302	2133	96007026000
97303	1874	16573000
97304	2248	5039347000000
97305	2248	5039359000000
97368	1397	1312967431000
97369	1678	23040757669000
97370	1397	1312957430000
97371	1678	23040757670000
97372	2134	87504796000
97373	1874	16614000
97374	2134	87503793000
97375	1874	16617000
97376	2133	95999010000
97377	1874	16619000
97378	2133	95998008000
97379	1874	16621000
97380	1679	8638505654000
97381	1679	8638529654000
97404	1444	4407620329999
97405	1444	4407633329999
97409	1397	1312927427000
97410	1678	23040757673000
97411	2133	95995002000
97412	1874	16634000
97413	2134	87500784000
97414	1874	16637000
97415	1708	20916316500022
97416	1708	20916328500022
97430	1489	22944581000000
97433	1506	2453308967172
97434	1506	3173308967172
97435	1506	3174098967172
97442	1397	1312907425000
97443	1678	23040757675000
97444	1397	1312897424000
97445	1678	23040757676000
97446	2133	95992998000
97447	1874	16648000
97448	2134	87497775000
97449	1874	16651000
97450	1571	4752094151056
97451	1571	4752116151056
97507	1397	1312817416000
97508	1678	23040757684000
97509	2134	87489751000
97510	1874	16691000
97511	2133	95984982000
97512	1874	16693000
97513	1637	253446026819988
97514	1637	253446038819988
97029	1874	16496000
97030	1611	16021387550000
97031	1611	12362676840000
97032	1611	9894071500000
97033	1611	3015085000000
97034	1680	3613243499559
97090	1672	2161225000000
97091	1672	2161287000000
97100	1394	509768488500000
97157	1426	5370258000000
97158	1426	5370280000000
97270	1451	17899082000000
97316	1397	1313027437000
97317	1678	23040757663000
97318	2134	87510814000
97319	1874	16582000
97320	2133	96005022000
97321	1874	16584000
97322	1508	23076745500009
97323	1508	23076757500009
97341	1395	58166548646507701
97356	1650	3712887000000
97394	1397	1312937428000
97395	1678	23040757672000
97396	2132	148057058000
97397	1874	16627000
97398	2134	87501787000
97399	1874	16630000
97400	2133	95996004000
97401	1874	16632000
97402	1547	22893816000000
97403	1547	22893829000000
97419	1685	146163288571430
97420	1685	146163300571430
97429	1506	3172600967172
97454	1397	1312887423000
97455	1678	23040757677000
97456	2134	87496772000
97457	1874	16654000
97458	2133	95991996000
97459	1874	16656000
97460	1508	23796757500009
97461	1508	23796769500009
97462	1397	1312877422000
97463	1678	23040757678000
97464	1397	1312867421000
97465	1678	23040757679000
97466	1397	1312857420000
97467	1678	23040757680000
97468	1397	1312847419000
97469	1678	23040757681000
97470	2132	148055056000
97471	1874	16657000
97472	2134	87495769000
97473	1874	16660000
97474	2133	95990994000
97475	1874	16662000
97476	2133	95989992000
97477	1874	16664000
97478	2134	87494766000
97479	1874	16667000
97480	2134	87493763000
97481	1874	16670000
97482	2134	87492760000
97483	1874	16673000
97484	2133	95988990000
97485	1874	16675000
97486	2133	95987988000
97487	1874	16677000
97488	606	67486562286230
97517	1397	1312807415000
97518	1678	23040757685000
97519	2132	148053054000
97520	1874	16694000
97521	2133	95983980000
97522	1874	16696000
97523	2134	87488748000
97524	1874	16699000
97525	1686	21092241550062
97545	1740	6210646000000
97546	1740	6210658000000
97598	1549	28416198000000
97599	1549	28416210000000
97613	1693	6662647908632
97614	1693	6662671908632
97642	1397	1312687403000
97643	1678	23040757697000
97644	2132	148049050000
97645	1874	16761000
97646	2133	95971956000
97647	1874	16763000
97648	2134	87475709000
97649	1874	16766000
97650	1724	22977671500000
97651	1724	22977684500000
97677	1397	1312647399000
97678	1678	23040757701000
97679	2132	148048049000
97680	1874	16782000
97681	2133	95967948000
97682	1874	16784000
97683	2134	87471697000
97684	1874	16787000
97685	2112	3600099000000
97686	2112	3600112000000
97695	1397	1312627397000
97696	1678	23040757703000
97697	1397	1312617396000
97698	1678	23040757704000
97699	1397	1312607395000
97700	1678	23040757705000
97701	2133	95965944000
97702	1874	16794000
97703	2134	87469691000
97704	1874	16797000
97705	2134	87468688000
97706	1874	16800000
97707	2134	87467685000
97708	1874	16803000
97709	2133	95964942000
97710	1874	16805000
97711	2133	95963940000
97712	1874	16807000
97713	2132	148047048000
97714	1874	16808000
97715	1690	151205164000000
97716	1690	151205201000000
97717	1685	146883300571430
97718	1685	146884103571430
97760	1397	1312537388000
97761	1678	23040757712000
97762	1397	1312527387000
97763	1678	23040757713000
97764	2133	95957928000
97765	1874	16840000
97766	2134	87460664000
97767	1874	16843000
97768	1688	15838999910040
97769	2134	87459661000
97770	1874	16846000
97771	2133	95956926000
97772	1874	16848000
97773	1688	16558999910040
97774	1688	16559001910040
97796	1397	1312507385000
97797	1678	23040757715000
97798	1397	1312497384000
97799	1678	23040757716000
97800	2134	87457655000
97801	1874	16857000
97802	2134	87456652000
97803	1874	16860000
97804	2133	95954922000
97805	1874	16862000
97806	2133	95953920000
97807	1874	16864000
97808	1447	21033697943000
97809	1447	21033721943000
97810	1397	1312487383000
97811	1678	23040757717000
97812	2134	87455649000
97813	1874	16867000
97814	2133	95952918000
97815	1874	16869000
97816	2132	148043044000
97817	1874	16870000
97820	1419	11088068560130
97821	1419	11088081560130
97845	1397	1312447379000
97846	1678	23040757721000
97847	1397	1312437378000
97848	1678	23040757722000
97849	2134	87451637000
97850	1874	16888000
97851	2134	87450634000
97852	1874	16891000
97853	2132	148042043000
97854	1874	16892000
97855	2133	95948910000
97856	1874	16894000
97857	2133	95947908000
97858	1874	16896000
97859	1686	21812241550062
97860	1686	21812266550062
97863	1397	1312427377000
97108	1678	23040757640000
97109	2133	96027066000
97110	1874	16512000
97111	1693	5942647908632
97123	1397	1313227457000
97124	1678	23040757643000
97125	2133	96024060000
97126	1874	16518000
97127	1685	144723264571430
97128	1685	144723275571430
97129	1397	1313217456000
97130	1678	23040757644000
97131	1397	1313207455000
97132	1678	23040757645000
97133	1397	1313197454000
97134	1678	23040757646000
97135	1397	1313187453000
97136	1678	23040757647000
97137	2133	96023058000
97138	1874	16520000
97139	2133	96022056000
97140	1874	16522000
97141	2133	96021054000
97142	1874	16524000
97143	2133	96020052000
97144	1874	16526000
97145	1670	1440850000000
97210	1740	5490646000000
97280	1397	1313067441000
97281	1678	23040757659000
97282	1397	1313057440000
97283	1678	23040757660000
97284	2133	96009030000
97285	1874	16560000
97286	2133	96008028000
97287	1874	16562000
97288	2134	87514826000
97289	1874	16565000
97290	1688	15118976910040
97291	2134	87513823000
97292	1874	16568000
97293	1688	15838976910040
97294	1688	15838977910040
97324	1397	1313017436000
97325	1678	23040757664000
97326	2134	87509811000
97327	1874	16587000
97328	2133	96004020000
97329	1874	16589000
97330	1426	5370270000000
97342	1397	1312997434000
97343	1678	23040757666000
97344	1397	1312987433000
97345	1678	23040757667000
97346	2133	96002016000
97347	1874	16597000
97348	2134	87507805000
97349	1874	16600000
97350	2134	87506802000
97351	1874	16603000
97352	2133	96001014000
97353	1874	16605000
97354	1489	22224556000000
97355	1489	22224580000000
97357	1397	1312977432000
97358	1678	23040757668000
97359	2132	148058059000
97360	1874	16606000
97361	2134	87505799000
97362	1874	16609000
97363	2133	96000012000
97364	1874	16611000
97365	1467	17246928100039
97382	2261	2879035000000
97383	2261	2879059000000
97385	1397	1312947429000
97386	1678	23040757671000
97387	2133	95997006000
97388	1874	16623000
97389	2134	87502790000
97390	1874	16626000
97391	1593	26470499000000
97417	1474	3790336000043
97418	1474	3790348000043
97431	1633	16596749975638
97432	1633	16596761975638
97489	2134	87491757000
97490	1874	16680000
97491	259	66009999000000
97492	2133	95986986000
97493	1874	16682000
97494	2132	148054055000
97495	1874	16683000
97496	1690	149764748000000
97497	1690	149764752000000
97515	1718	1698396519070
97516	1718	1698408519070
97526	1397	1312797414000
97527	1678	23040757686000
97528	1599	22660448393047
97529	2133	95982978000
97530	1874	16701000
97531	2134	87487745000
97532	1874	16704000
97533	1599	23380448393047
97534	1599	23380450393047
97541	1527	273999976
97542	1740	6210645000001
97543	1527	6210656000002
97544	1740	274999975
97560	1522	3643305000000
97561	1522	3643518000000
97563	2134	87484736000
97564	1874	16718000
97565	2133	95979972000
97566	1874	16720000
97567	1594	2881568000000
97569	1397	1312767411000
97570	1678	23040757689000
97571	2133	95978970000
97572	1874	16722000
97573	2134	87483733000
97574	1874	16725000
97575	1672	2161237000000
97600	1397	1312737408000
97601	1678	23040757692000
97602	1397	1312727407000
97603	1678	23040757693000
97604	2134	87480724000
97605	1874	16737000
97606	2133	95976966000
97607	1874	16739000
97608	2134	87479721000
97609	1874	16742000
97610	2133	95975964000
97611	1874	16744000
97612	1715	18026873436096
97615	1724	22257647500000
97616	1724	22257671500000
97617	1458	6425072908540
97618	1323	1712107637751650
97619	1397	1312717406000
97620	1678	23040757694000
97621	1397	1312707405000
97622	1678	23040757695000
97623	1397	1312697404000
97624	1678	23040757696000
97625	2134	87478718000
97626	1874	16747000
97627	2134	87477715000
97628	1874	16750000
97629	2134	87476712000
97630	1874	16753000
97631	1514	700010030400
97632	2287	19000000000
97633	2133	95974962000
97634	1874	16755000
97635	2133	95973960000
97636	1874	16757000
97637	2133	95972958000
97638	1874	16759000
97639	2132	148050051000
97640	1874	16760000
97641	2199	719238000000
97667	1397	1312657400000
97668	1678	23040757700000
97669	2134	87472700000
97670	1874	16779000
97671	1514	9030400
97672	2287	719000000000
97673	2133	95968950000
97674	1874	16781000
97675	1705	7760545580140
97676	1705	7760558580140
97758	1402	79055101319298
97759	1402	79055174319298
97824	1397	1312477382000
97825	1678	23040757718000
97826	2134	87454646000
97827	1874	16873000
97828	2133	95951916000
97829	1874	16875000
97830	2287	718999000000
97831	1637	253446039819988
97897	1874	16716000
97223	2134	92332835000
97224	2282	200000000
97225	2134	91131835000
97226	2282	1400000000
97227	2134	89930835000
97228	2283	200000000
97229	1874	16542000
97230	2133	96013038000
97231	1874	16544000
97232	2132	148062063000
97233	1874	16545000
97234	1726	1299112000
97235	2284	200000000
97236	1726	98112000
97237	2285	200000000
97238	2134	89919835000
97239	1885	10000000
97240	2134	88718835000
97241	2286	200000000
97242	2134	88717832000
97243	1874	16548000
97244	2134	87516832000
97245	2276	2600000000
97246	2133	96012036000
97247	1874	16550000
97248	2133	96011034000
97249	1874	16552000
97250	1681	6371105109853
97251	1681	6371159109853
97261	1608	2298292000000
97262	1649	15758407999992
97263	1649	10202397999992
97264	1649	6453387999992
97265	1649	3352377999992
97266	1874	16230000
97267	1874	16233000
97268	1680	5053397499559
97269	1680	5053510499559
97271	1874	16519000
97272	1874	16527000
97273	1874	16534000
97274	1874	16536000
97275	1874	16538000
97276	1874	16546000
97277	1874	16549000
97278	1874	16556000
97279	1451	17899269000000
97295	1394	512648559500000
97296	1394	514088559500000
97297	1394	514088560500000
97306	1397	1313037438000
97307	1678	23040757662000
97308	2132	148060061000
97309	1874	16574000
97310	2133	96006024000
97311	1874	16576000
97312	2134	87511817000
97313	1874	16579000
97314	1685	145443275571430
97315	1685	145443288571430
97331	1397	1313007435000
97332	1678	23040757665000
97333	2132	148059060000
97334	1874	16590000
97335	2133	96003018000
97336	1874	16592000
97337	2134	87508808000
97338	1874	16595000
97339	1991	4941261355805
97340	1991	4941274355805
97366	1637	252726013819988
97367	1637	252726026819988
97384	1395	58166548657507701
97392	1394	514088536500000
97393	1394	514088548500000
97406	526	68881310000000
97407	526	69601310000000
97408	526	69601500000000
97421	1397	1312917426000
97422	1678	23040757674000
97423	2134	87499781000
97424	1874	16640000
97425	2133	95994000000
97426	1874	16642000
97427	1489	22944580000000
97428	1489	22944592000000
97436	2134	87498778000
97437	1874	16645000
97438	2132	148056057000
97439	1874	16646000
97440	111	71040075000000
97441	111	71040077000000
97452	1395	58167268657507701
97453	1395	58167268679507701
97498	1397	1312837418000
97499	1678	23040757682000
97500	1397	1312827417000
97501	1678	23040757683000
97502	2133	95985984000
97503	1874	16685000
97504	2134	87490754000
97505	1874	16688000
97506	470	69600136000000
97568	1594	2881778000000
97576	1395	58167988679507701
97577	1395	58167988691507701
97591	1397	1312747409000
97592	1678	23040757691000
97593	2132	148051052000
97594	1874	16731000
97595	2134	87481727000
97596	1874	16734000
97597	1696	23537615835100
97654	1397	1312677402000
97655	1678	23040757698000
97656	1397	1312667401000
97657	1678	23040757699000
97658	2133	95970954000
97659	1874	16768000
97660	2133	95969952000
97661	1874	16770000
97662	2134	87474706000
97663	1874	16773000
97664	2134	87473703000
97665	1874	16776000
97666	1684	5042814219748
97687	1397	1312637398000
97688	1678	23040757702000
97689	2133	95966946000
97690	1874	16789000
97691	2134	87470694000
97692	1874	16792000
97693	1471	4265155900000
97694	1471	4265167900000
97781	1611	3015107000000
97782	1611	3735107000000
97783	1527	3735107000002
97784	1611	274999975
97787	1397	1312517386000
97788	1678	23040757714000
97789	2132	148044045000
97790	1874	16849000
97791	2133	95955924000
97792	1874	16851000
97793	2134	87458658000
97794	1874	16854000
97795	641	69603583000000
97832	1397	1312467381000
97833	1678	23040757719000
97834	1397	1312457380000
97835	1678	23040757720000
97836	2133	95950914000
97837	1874	16877000
97838	2133	95949912000
97839	1874	16879000
97840	2134	87453643000
97841	1874	16882000
97842	2134	87452640000
97843	1874	16885000
97844	1559	20122905000000
97872	1397	1312417376000
97873	1678	23040757724000
97874	694	66522947693786
97875	2288	0
97876	2132	148041042000
97877	1874	16902000
97878	2134	87448628000
97879	1874	16905000
97880	633	70749314900000
97881	633	70749336900000
97882	1397	1312407375000
97883	1678	23040757725000
97884	2133	95945904000
97885	1874	16907000
97886	2134	87447625000
97887	1874	16910000
97888	1691	23723468100019
97889	1691	23723480100019
97996	1471	4985167900000
97997	1471	4985224900000
98016	1692	48020893619999
98017	1692	48020937619999
98041	1408	720052000000
98093	1657	17281596990100
98094	1657	18001596890100
97535	1397	1312787413000
97536	1678	23040757687000
97537	2133	95981976000
97538	1874	16706000
97539	2134	87486742000
97540	1874	16709000
97547	1740	6210648000000
97548	1458	22110672908540
97549	957	508158775000000
97550	1397	1312777412000
97551	1678	23040757688000
97552	2133	95980974000
97553	1874	16711000
97554	2134	87485739000
97555	1874	16714000
97556	2132	148052053000
97557	1874	16715000
97558	1850	6456200949999
97559	1850	6456413949999
97562	1522	3643308000000
97578	526	69600172000000
97579	1458	19133472908540
97580	1197	614409750000000
97581	1458	14721272908540
97582	1077	910614465000000
97583	1397	1312757410000
97584	1678	23040757690000
97585	2134	87482730000
97586	1874	16728000
97587	2133	95977968000
97588	1874	16730000
97589	1690	150484752000000
97590	1690	150485164000000
97652	1508	24516769500009
97653	1508	24516782500009
97719	1397	1312597394000
97720	1678	23040757706000
97721	1397	1312587393000
97722	1678	23040757707000
97723	1397	1312577392000
97724	1678	23040757708000
97725	1397	1312567391000
97726	1678	23040757709000
97727	1397	1312557390000
97728	1678	23040757710000
97729	1397	1312547389000
97730	1678	23040757711000
97731	2134	87466682000
97732	1874	16811000
97733	2132	148046047000
97734	1874	16812000
97735	2132	148045046000
97736	1874	16813000
97737	2134	87465679000
97738	1874	16816000
97739	2134	87464676000
97740	1874	16819000
97741	2134	87463673000
97742	1874	16822000
97743	2134	87462670000
97744	1874	16825000
97745	2134	87461667000
97746	1874	16828000
97747	2133	95962938000
97748	1874	16830000
97749	2133	95961936000
97750	1874	16832000
97751	2133	95960934000
97752	1874	16834000
97753	2133	95959932000
97754	1874	16836000
97755	2133	95958930000
97756	1874	16838000
97757	1637	253446099819988
97775	1696	23537637835100
97776	1696	24257637835100
97777	1696	24257639835100
97778	1637	252726048819988
97779	1637	253446048819988
97780	1637	253446050819988
97785	1394	512648558500000
97786	1394	514088558500000
97818	1547	23613829000000
97819	1547	23613842000000
97822	1594	3601568000000
97823	1594	3601581000000
97861	1402	79775174319298
97862	1402	79775199319298
97871	1509	21552250851155
97957	1394	514088549500000
97959	1397	1312377372000
97960	1678	23040757728000
97961	2134	87444616000
97962	1874	16924000
97963	2133	95942898000
97964	1874	16926000
97965	1447	21753721943000
97966	1447	21753733943000
97969	1874	16923000
97970	1718	2418408519070
97971	1718	2418419519070
97999	470	70320136000000
98000	470	70320193000000
98001	1547	22605789000000
98002	683	66626585999999
98003	1397	1312337368000
98004	1678	23040757732000
98005	1397	1312327367000
98006	1678	23040757733000
98007	2133	95938890000
98008	1874	16944000
98009	2133	95937888000
98010	1874	16946000
98011	2134	87440604000
98012	1874	16949000
98013	2134	87439601000
98014	1874	16952000
98015	1402	79775218319298
98028	1992	5040523990000
98059	1397	1312297364000
98060	1678	23040757736000
98061	2133	95934882000
98062	1874	16965000
98063	2134	87436592000
98064	1874	16968000
98065	1458	7145072908540
98066	1458	7145084908540
98101	2133	95930874000
98102	1874	16986000
98103	2134	87432580000
98104	1874	16989000
98105	1395	58169428743507701
98106	1395	58169428755507701
98122	1705	8480558580140
98123	1705	8480570580140
98198	1397	1312147349000
98199	1678	23040757751000
98200	1397	1312137348000
98201	1678	23040757752000
98202	2133	95920854000
98203	1874	17043000
98204	2134	87421547000
98205	1874	17046000
98206	2134	87420544000
98207	1874	17049000
98208	2133	95919852000
98209	1874	17051000
98210	1623	60482967899898
98239	1686	21518995869379
98240	1771	598176214766
98241	1686	21229800079363
98242	195	66589992681547
98243	2132	148031032000
98244	1874	17068000
98245	2133	95915844000
98246	1874	17070000
98247	694	66001944693786
98248	2288	521000000000
98295	1397	1312047339000
98296	1678	23040757761000
98297	2134	87411517000
98298	1874	17097000
98299	2133	95910834000
98300	1874	17099000
98319	1686	4711765700122
98320	1579	0
98321	1397	1312017336000
98322	1678	23040757764000
98323	2134	87408508000
98324	1874	17113000
98325	2133	95907828000
98326	1874	17115000
98327	1395	58170148777507701
98393	1397	1311957330000
98394	1678	23040757770000
98395	1397	1311947329000
98396	1678	23040757771000
98397	2133	95901816000
98398	1874	17143000
98399	2134	87402490000
98400	1874	17146000
98401	2133	95900814000
98402	1874	17148000
98403	2132	148027028000
98404	1874	17149000
97864	1678	23040757723000
97865	2133	95946906000
97866	1874	16898000
97867	2134	87449631000
97868	1874	16901000
97869	1426	6090270000000
97870	1426	6090282000000
97890	1397	1312397374000
97891	1678	23040757726000
97892	2133	95944902000
97893	1874	16912000
97894	2134	87446622000
97895	1874	16915000
97896	1536	1440024000000
97947	1397	1312387373000
97948	1678	23040757727000
97949	2134	87445619000
97950	1874	16918000
97951	2133	95943900000
97952	1874	16920000
97953	2132	148040041000
97954	1874	16921000
97955	1599	24100450393047
97956	1599	24100463393047
97998	1724	22977728500000
98018	1397	1312317366000
98019	1678	23040757734000
98020	2134	87438598000
98021	1874	16955000
98022	2133	95936886000
98023	1874	16957000
98024	2132	148038039000
98025	1874	16958000
98026	1588	24695564000000
98027	1588	24695577000000
98042	1394	515528549500000
98043	1394	515528590500000
98044	1458	21390661908540
98045	1458	18413461908540
98046	1458	14001261908540
98047	1458	5705061908540
98048	1547	21452745000000
98049	1547	21165725000000
98050	1547	18976705000000
98051	1547	16329685000000
98052	1649	15038396999992
98053	1649	9482386999992
98054	1649	5733376999992
98055	1649	2632366999992
98056	1687	15024300223172
98057	1687	15744300223172
98058	1687	15744460223172
98096	1397	1312267361000
98097	1678	23040757739000
98098	1657	17281605990100
98099	1657	18001605990100
98100	1657	18001609990100
98115	1397	1312247359000
98116	1678	23040757741000
98117	2133	95929872000
98118	1874	16995000
98119	694	66521946693786
98120	2288	1000000000
98121	2039	4219300000000
98124	1397	1312237358000
98125	1678	23040757742000
98126	2134	87430574000
98127	1874	16998000
98128	2133	95928870000
98129	1874	17000000
98130	1693	6662659908632
98143	1394	515528562500000
98178	1394	516968562500000
98179	1394	516968599500000
98190	1756	5600742195609
98191	1756	5600754195609
98192	1397	1312157350000
98193	1678	23040757750000
98194	2132	148033034000
98195	1874	17038000
98196	2134	87422550000
98197	1874	17041000
98212	1397	1312127347000
98213	1678	23040757753000
98214	1397	1312117346000
98215	1678	23040757754000
98216	2134	87419541000
98217	1874	17054000
98218	2134	87418538000
98219	1874	17057000
98220	2133	95918850000
98221	1874	17059000
98222	2132	148032033000
98223	1874	17060000
98224	2133	95917848000
98225	1874	17062000
98226	1719	3600108000000
98227	1719	3600133000000
98281	1397	1312057340000
98282	1678	23040757760000
98283	1686	12130552407697
98284	1263	613335864722998
98285	1686	4711775700122
98286	1389	1709114921835103
98287	2134	87412520000
98288	1874	17091000
98289	2133	95911836000
98290	1874	17093000
98291	2132	148030031000
98292	1874	17094000
98293	1695	4264991999000
98294	1695	4265024999000
98302	1397	1312037338000
98303	1678	23040757762000
98304	1397	1312027337000
98305	1678	23040757763000
98306	2134	87410514000
98307	1874	17102000
98308	2133	95909832000
98309	1874	17104000
98310	2132	148029030000
98311	1874	17105000
98312	1596	2160082000000
98313	2134	87409511000
98314	1874	17108000
98315	2133	95908830000
98316	1874	17110000
98317	1596	2880082000000
98318	1596	2880084000000
98337	1771	304905534083
98338	1719	4320109000000
98339	1719	4320201000000
98350	1397	1311987333000
98351	1678	23040757767000
98352	2134	87405499000
98353	1874	17129000
98354	2133	95904822000
98355	1874	17131000
98356	2261	2879047000000
98383	1547	12407665000000
98384	1547	5034645000000
98385	1874	16245000
98386	1874	16254000
98387	1874	16263000
98388	1874	16266000
98389	1874	16275000
98390	1874	16284000
98391	1680	5054552499559
98392	1680	5774552499549
98425	1397	1311917326000
98426	1678	23040757774000
98427	2133	95897808000
98428	1874	17165000
98429	2134	87398478000
98430	1874	17168000
98431	1619	720000000000
98432	1619	720012000000
98441	1724	22977683500000
98478	1684	6482839219748
98479	1684	6482851219748
98511	1679	8638518654000
98514	1601	9253653620000
98515	1601	9253666620000
98553	1397	1311767311000
98554	1678	23040757789000
98555	885	63455021096354
98556	2134	87383433000
98557	1874	17243000
98558	2133	95883780000
98559	1874	17245000
98560	1637	254166073819988
98561	1637	254886073819988
98572	2134	87381427000
98573	1874	17251000
98574	1992	6480560990000
98575	1992	6480571990000
98585	1397	1311727307000
98586	1678	23040757793000
98587	886	63455031096354
98588	1397	1311717306000
98589	1678	23040757794000
98590	2134	87379421000
98591	1874	17257000
98592	2134	87378418000
98593	1874	17260000
97898	1874	16719000
97899	1874	16721000
97900	1874	16723000
97901	1874	16726000
97902	1874	16729000
97903	1874	16732000
97904	1874	16735000
97905	1874	16738000
97906	1874	16741000
97907	1874	16752000
97908	1874	16754000
97909	1874	16756000
97910	1874	16758000
97911	1874	16762000
97912	1874	16764000
97913	1874	16772000
97914	1874	16774000
97915	1874	16778000
97916	1874	16780000
97917	1874	16783000
97918	1874	16786000
97919	1874	16795000
97920	1874	16798000
97921	1874	16801000
97922	1874	16804000
97923	1874	16810000
97924	1874	16831000
97925	1874	16837000
97926	1874	16852000
97927	1874	16855000
97928	1874	16858000
97929	1874	16861000
97930	1874	16871000
97931	1874	16881000
97932	1874	16883000
97933	1874	16884000
97934	1536	721071000000
97935	1874	16886000
97936	1874	16887000
97937	1874	16889000
97938	1874	16890000
97939	1874	16893000
97940	1874	16895000
97941	1874	16897000
97942	1874	16899000
97943	1874	16903000
97944	1536	1441071000000
97945	2221	1441083999997
97946	1536	200000002
97958	1749	12245420930000
97967	1685	147604103571430
97968	1685	147604114571430
97972	1547	22892809000000
97973	683	66339585999999
97974	1397	1312367371000
97975	1678	23040757729000
97976	1397	1312357370000
97977	1678	23040757730000
97978	1397	1312347369000
97979	1678	23040757731000
97980	2134	87443613000
97981	1874	16929000
97982	2134	87442610000
97983	1874	16932000
97984	2134	87441607000
97985	1874	16935000
97986	2133	95941896000
97987	1874	16937000
97988	2133	95940894000
97989	1874	16939000
97990	2132	148039040000
97991	1874	16940000
97992	2133	95939892000
97993	1874	16942000
97994	2039	4219288000000
97995	2039	4219345000000
98029	1547	20416769000000
98030	1012	506425775000000
98031	1547	17769749000000
98032	1252	612316750000000
98033	1397	1312307365000
98034	1678	23040757735000
98035	2133	95935884000
98036	1874	16960000
98037	2134	87437595000
98038	1874	16963000
98039	1395	58168708691507701
98040	1395	58168708743507701
98067	1673	31285644000000
98068	1547	13847729000000
98069	1132	907510465000000
98070	1547	6474709000000
98071	1378	1706269637751650
98072	1397	1312287363000
98073	1678	23040757737000
98074	1397	1312277362000
98075	1678	23040757738000
98076	2134	87435589000
98077	1874	16971000
98078	2133	95933880000
98079	1874	16973000
98080	2132	148037038000
98081	1874	16974000
98082	2134	87434586000
98083	1874	16977000
98084	1549	27696262000000
98085	2134	87433583000
98086	1874	16980000
98087	2133	95932878000
98088	1874	16982000
98089	2133	95931876000
98090	1874	16984000
98091	1549	28416262000000
98092	1549	28416265000000
98131	149	70415228000341
98132	149	70415240000341
98144	1397	1312217356000
98145	1678	23040757744000
98146	1397	1312207355000
98147	1678	23040757745000
98148	2133	95926866000
98149	1874	17008000
98150	2133	95925864000
98151	1874	17010000
98152	2134	87428568000
98153	1874	17013000
98154	2134	87427565000
98155	1874	17016000
98180	1397	1312167351000
98181	1678	23040757749000
98182	2133	95921856000
98183	1874	17034000
98184	2134	87423553000
98185	1874	17037000
98186	1656	6475306999990
98187	1656	6475318999990
98211	1718	2418432519070
98228	1719	3600109000000
98249	1397	1312097344000
98250	1678	23040757756000
98251	1397	1312087343000
98252	1678	23040757757000
98253	1686	20940604289347
98254	291	66589992681547
98255	2134	87416532000
98256	1874	17073000
98257	2134	87415529000
98258	1874	17076000
98259	2133	95914842000
98260	1874	17078000
98261	1451	17899102000000
98301	1395	58170148767507701
98357	1686	20078957869379
98358	1686	19789762079363
98359	1686	19500566289347
98360	1686	17298647403647
98361	1686	13352835546422
98362	1686	10690514407697
98363	1686	3271737700122
98364	1686	3271727700122
98365	1685	148324114571430
98366	1685	148324327571430
98367	1397	1311977332000
98368	1678	23040757768000
98369	2133	95903820000
98370	1874	17133000
98371	2134	87404496000
98372	1874	17136000
98373	1508	25236782500009
98374	1508	25236794500009
98409	1397	1311937328000
98410	1678	23040757772000
98411	1397	1311927327000
98412	1678	23040757773000
98413	2133	95899812000
98414	1874	17154000
98415	2133	95898810000
98416	1874	17156000
98417	2132	148026027000
98418	1874	17157000
98419	2134	87400484000
98420	1874	17160000
98421	2134	87399481000
98422	1874	17163000
98423	1394	518408599500000
98095	1758	1603500000
98107	1397	1312257360000
98108	1678	23040757740000
98109	2134	87431577000
98110	1874	16992000
98111	2132	148036037000
98112	1874	16993000
98113	1692	48740937619999
98114	1692	48740949619999
98133	1397	1312227357000
98134	1678	23040757743000
98135	2134	87429571000
98136	1874	17003000
98137	2132	148035036000
98138	1874	17004000
98139	2133	95927868000
98140	1874	17006000
98141	1395	58170148755507701
98142	1395	58170148768507701
98156	1397	1312197354000
98157	1678	23040757746000
98158	1397	1312187353000
98159	1678	23040757747000
98160	1397	1312177352000
98161	1678	23040757748000
98162	2134	87426562000
98163	1874	17019000
98164	2133	95924862000
98165	1874	17021000
98166	2134	87425559000
98167	1874	17024000
98168	2134	87424556000
98169	1874	17027000
98170	2132	148034035000
98171	1874	17028000
98172	2133	95923860000
98173	1874	17030000
98174	2133	95922858000
98175	1874	17032000
98176	1675	4604129999977
98177	1675	4604166999977
98188	1637	254166039819988
98189	1637	254166051819988
98229	1397	1312107345000
98230	1678	23040757755000
98231	2134	87417535000
98232	1874	17065000
98233	2133	95916846000
98234	1874	17067000
98235	694	66511945693786
98236	2288	11000000000
98237	641	70323583000000
98238	641	70323596000000
98262	1395	58170148788507701
98263	1686	18738685403647
98264	1023	507269669126828
98265	1686	14792873546422
98266	1143	909022900788739
98267	1397	1312077342000
98268	1678	23040757758000
98269	1397	1312067341000
98270	1678	23040757759000
98271	2134	87414526000
98272	1874	17081000
98273	2134	87413523000
98274	1874	17084000
98275	2133	95913840000
98276	1874	17086000
98277	2133	95912838000
98278	1874	17088000
98279	1690	151925201000000
98280	1690	151925245000000
98328	1397	1312007335000
98329	1678	23040757765000
98330	1771	598166214766
98331	2134	87407505000
98332	1874	17118000
98333	2133	95906826000
98334	1874	17120000
98335	1719	4320133000000
98336	1719	4320155000000
98340	1397	1311997334000
98341	1678	23040757766000
98342	2134	87406502000
98343	1874	17123000
98344	2132	148028029000
98345	1874	17124000
98346	2133	95905824000
98347	1874	17126000
98348	1740	6930658000000
98349	1740	6930671000000
98375	1397	1311967331000
98376	1678	23040757769000
98377	2133	95902818000
98378	1874	17138000
98379	2134	87403493000
98380	1874	17141000
98381	1680	4333201499559
98382	1680	4333213499559
98435	1397	1311907325000
98436	1678	23040757775000
98437	2133	95896806000
98438	1874	17170000
98439	2134	87397475000
98440	1874	17173000
98465	1992	5760523990000
98466	1992	5760560990000
98468	1402	79775211319298
98476	632	71037489000000
98477	632	71037501000000
98480	641	71043596000000
98481	641	71043608000000
98503	1397	1311827317000
98504	1678	23040757783000
98505	2134	87389451000
98506	1874	17213000
98507	2132	148023024000
98508	1874	17214000
98509	2133	95888790000
98510	1874	17216000
98512	1746	12034444000000
98513	1746	12034457000000
98537	1397	1311787313000
98538	1678	23040757787000
98539	2133	95885784000
98540	1874	17232000
98541	2134	87385439000
98542	1874	17235000
98543	1394	521288649500000
98544	1394	521288661500000
98551	1740	7650671000000
98552	1740	7650683000000
98568	1397	1311747309000
98569	1678	23040757791000
98570	1395	58170868777507701
98571	1395	58170868787507701
98576	1685	149044327571430
98577	1685	149044337571430
98579	1397	1311737308000
98580	1678	23040757792000
98581	2134	87380424000
98582	1874	17254000
98583	1688	17278988910040
98584	1688	17279000910040
98597	1397	1311707305000
98598	1678	23040757795000
98599	2134	87377415000
98600	1874	17263000
98601	1675	4604140999977
98613	1688	17999000910040
98614	1688	17999011910040
98617	1397	1311677302000
98618	1678	23040757798000
98619	1397	1311667301000
98620	1678	23040757799000
98621	2134	87374406000
98622	1874	17272000
98623	2134	87373403000
98624	1874	17275000
98625	1717	23148344000023
98626	1717	23148366000023
98657	1718	2418421519070
98705	1397	1311547289000
98706	1678	23040757811000
98707	2134	87361367000
98708	1874	17328000
98709	2133	95875764000
98710	1874	17330000
98711	149	71135240000341
98712	149	71135252000341
98713	1850	22960521949999
98714	1850	22961521949999
98715	1850	14758111949999
98716	1850	10395001949999
98717	1850	7451091949999
98718	1850	5016281949999
98719	1874	16092000
98720	1874	16104000
98721	1874	16134000
98722	1440	721805045924
98723	1874	16143000
98724	1874	16146000
98725	1874	16155000
98726	1874	16161000
98727	1874	16164000
98405	2134	87401487000
98406	1874	17152000
98407	1684	5762814219748
98408	1684	5762839219748
98467	1599	24100487393047
98469	1397	1311867321000
98470	1678	23040757779000
98471	2134	87393463000
98472	1874	17192000
98473	2133	95892798000
98474	1874	17194000
98475	1571	4752106151056
98518	1397	1311817316000
98519	1678	23040757784000
98520	2134	87388448000
98521	1874	17219000
98545	1397	1311777312000
98546	1678	23040757788000
98547	2133	95884782000
98548	1874	17237000
98549	2134	87384436000
98550	1874	17240000
98578	1692	49460960619999
98602	1397	1311697304000
98603	1678	23040757796000
98604	2134	87376412000
98605	1874	17266000
98606	1544	720011000000
98627	1397	1311657300000
98628	1678	23040757800000
98629	2134	87372400000
98630	1874	17278000
98631	1571	4752105151056
98632	1397	1311647299000
98633	1678	23040757801000
98634	1397	1311637298000
98635	1678	23040757802000
98636	1397	1311627297000
98637	1678	23040757803000
98638	2134	87371397000
98639	1874	17281000
98640	2134	87370394000
98641	1874	17284000
98642	2134	87369391000
98643	1874	17287000
98644	1696	24977639835100
98645	1696	24977672835100
98648	1397	1311617296000
98649	1678	23040757804000
98650	2133	95882778000
98651	1874	17289000
98652	2134	87368388000
98653	1874	17292000
98654	2132	148021022000
98655	1874	17293000
98656	1541	722049000000
98665	1397	1311597294000
98666	1678	23040757806000
98667	1397	1311587293000
98668	1678	23040757807000
98669	2134	87366382000
98670	1874	17301000
98671	2133	95880774000
98672	1874	17303000
98673	2133	95879772000
98674	1874	17305000
98675	2132	148020021000
98676	1874	17306000
98677	2134	87365379000
98678	1874	17309000
98679	2039	4939300000000
98680	2039	4939325000000
98704	1688	17999013910040
98733	1397	1311537288000
98734	1678	23040757812000
98735	2133	95874762000
98736	1874	17332000
98737	2134	87360364000
98738	1874	17335000
98739	1440	1440143045924
98740	1440	1440155045924
98748	1506	3175378967172
98749	1506	3895378967172
98750	1506	3896168967172
98753	1397	1311517286000
98754	1678	23040757814000
98755	2133	95872758000
98756	1874	17342000
98757	2134	87358358000
98758	1874	17345000
98759	2132	148018019000
98760	1874	17346000
98761	1723	21959586085979
98783	1397	1311487283000
98784	1678	23040757817000
98785	1397	1311477282000
98786	1678	23040757818000
98787	2134	87355349000
98788	1874	17359000
98789	2134	87354346000
98790	1874	17362000
98791	2133	95869752000
98792	1874	17364000
98793	2133	95868750000
98794	1874	17366000
98795	1686	5431765700122
98796	1686	5431789700122
98819	1746	12034456000000
98822	58	71027308999641
98833	1874	17378000
98834	1555	14595413979096
98892	1397	1311407275000
98893	1678	23040757825000
98894	2134	87347325000
98895	1874	17399000
98896	2133	95861736000
98897	1874	17401000
98898	2112	4320112000000
98899	2112	4320124000000
98902	1571	4032094151064
98903	1536	2161083999989
98919	2133	95857728000
98920	1874	17415000
98921	2134	87344316000
98922	1874	17418000
98923	1395	58171588789507701
98955	1422	18865264860211
98956	1422	18865276860211
98974	1397	1311357270000
98975	1678	23040757830000
98976	2134	87339301000
98977	1874	17441000
98978	2133	95852718000
98979	1874	17443000
99007	1397	1311327267000
99008	1678	23040757833000
99009	2134	87336292000
99010	1874	17454000
99011	1874	17456000
99012	2133	95849712000
99013	1874	17458000
99014	1764	20167251100000
99015	1764	20167264100000
99024	1402	80495186319298
99025	1402	80495210319298
99037	2134	87333283000
99038	1874	17471000
99039	2133	95846706000
99040	1874	17473000
99041	1602	4176225170000
99044	1397	1311287263000
99045	1678	23040757837000
99046	1678	23760757837000
99047	1678	23760767837000
99078	1397	1311247259000
99079	1678	23760767841000
99080	2133	95841696000
99081	1874	17495000
99082	2134	87328268000
99083	1874	17498000
99084	1419	11808081560130
99085	1419	11808093560130
99119	1474	3070358000043
99120	1474	3790358000043
99121	1474	3790361000043
99139	1397	1311187253000
99140	1678	23760767847000
99141	2133	95835684000
99142	1874	17525000
99143	2134	87322250000
99144	1874	17528000
99145	1395	58173748824957278
99146	1395	58173748836957278
99147	1397	1311177252000
99148	1678	23760767848000
99149	2134	87321247000
99150	1874	17531000
99151	2133	95834682000
99152	1874	17533000
99153	1395	58174468836957278
99154	1395	58174468848957278
99157	1419	12528093560130
99158	1419	12528105560130
99163	2134	87320244000
99164	1874	17536000
98424	1394	518408624500000
98433	1692	49460949619999
98434	1692	49460961619999
98442	1759	19440975999889
98443	1397	1311897324000
98444	1678	23040757776000
98445	1397	1311887323000
98446	1678	23040757777000
98447	1397	1311877322000
98448	1678	23040757778000
98449	2133	95895804000
98450	1874	17175000
98451	2132	148025026000
98452	1874	17176000
98453	2133	95894802000
98454	1874	17178000
98455	2134	87396472000
98456	1874	17181000
98457	2134	87395469000
98458	1874	17184000
98459	2134	87394466000
98460	1874	17187000
98461	2133	95893800000
98462	1874	17189000
98463	606	68206562286230
98464	606	68206599286230
98482	1397	1311857320000
98483	1678	23040757780000
98484	1397	1311847319000
98485	1678	23040757781000
98486	1397	1311837318000
98487	1678	23040757782000
98488	2133	95891796000
98489	1874	17196000
98490	2133	95890794000
98491	1874	17198000
98492	2134	87392460000
98493	1874	17201000
98494	2134	87391457000
98495	1874	17204000
98496	2134	87390454000
98497	1874	17207000
98498	2132	148024025000
98499	1874	17208000
98500	2133	95889792000
98501	1874	17210000
98502	1439	6463641578477
98516	1394	519848624500000
98517	1394	519848637500000
98522	1397	1311807315000
98523	1678	23040757785000
98524	1397	1311797314000
98525	1678	23040757786000
98526	2134	87387445000
98527	1874	17222000
98528	2133	95887788000
98529	1874	17224000
98530	2132	148022023000
98531	1874	17225000
98532	2134	87386442000
98533	1874	17228000
98534	2133	95886786000
98535	1874	17230000
98536	1394	519848649500000
98562	1397	1311757310000
98563	1678	23040757790000
98564	2134	87382430000
98565	1874	17248000
98566	1688	16558977910040
98567	1688	16558988910040
98595	1394	522728661500000
98596	1394	522728693500000
98607	1397	1311687303000
98608	1678	23040757797000
98609	2134	87375409000
98610	1874	17269000
98611	1991	5661274355805
98612	1991	5661285355805
98615	1394	524168693500000
98616	1394	524168704500000
98646	1608	3738303000000
98647	1608	3738336000000
98681	1397	1311577292000
98682	1678	23040757808000
98683	1397	1311567291000
98684	1678	23040757809000
98685	2133	95878770000
98686	1874	17311000
98687	2134	87364376000
98688	1874	17314000
98689	2133	95877768000
98690	1874	17316000
98691	2134	87363373000
98692	1874	17319000
98693	1673	31285656000000
98741	1397	1311527287000
98742	1678	23040757813000
98743	2133	95873760000
98744	1874	17337000
98745	2134	87359361000
98746	1874	17340000
98747	1395	58171588799507701
98762	1397	1311507285000
98763	1678	23040757815000
98764	2133	95871756000
98765	1874	17348000
98766	2134	87357355000
98767	1874	17351000
98772	576	70397466726897
98773	1397	1311497284000
98774	1678	23040757816000
98775	2134	87356352000
98776	1874	17354000
98777	2133	95870754000
98778	1874	17356000
98779	1693	7382671908632
98780	1693	7382683908632
98797	1397	1311467281000
98798	1678	23040757819000
98799	2134	87353343000
98800	1874	17369000
98801	1694	4858760197225
98802	1694	4858771197225
98806	1397	1311457280000
98807	1678	23040757820000
98808	2134	87352340000
98809	1874	17374000
98810	2133	95866746000
98811	1874	17376000
98812	58	71027296999641
98813	2097	300000
98814	1568	200263992
98815	58	21552253851155
98816	1509	71027303539245
98817	1571	274999975
98818	1527	4752105151480
98835	1874	16373000
98836	1874	16377000
98837	1874	16379000
98838	1874	16381000
98839	1611	15301365550000
98840	1611	11642654840000
98841	1611	9174049500000
98842	1611	2295063000000
98843	1874	16385000
98844	1874	16387000
98845	1874	16389000
98846	1874	16393000
98847	1874	16399000
98848	1874	16405000
98849	1874	16411000
98850	1874	16417000
98851	1874	16423000
98852	1874	16429000
98853	1874	16435000
98854	1874	16441000
98855	1874	16447000
98856	1874	16453000
98857	1874	16459000
98858	1613	20809449600000
98859	1874	16465000
98860	1874	16471000
98861	1874	16477000
98862	1874	16483000
98863	1874	16489000
98864	1874	16495000
98865	1874	16501000
98866	1874	16507000
98867	1613	21529449600000
98868	1613	21529466600000
98889	1402	79775181319298
98924	1451	18619102000000
98925	1451	18619104000000
98964	326	66720000000000
98965	326	66720012000000
98984	1397	1311347269000
98985	1678	23040757831000
98986	2133	95851716000
98987	1874	17445000
98988	2134	87338298000
98989	1874	17448000
98990	1395	58172308789507701
98991	1395	58172308802507701
98994	1547	7194709000000
98995	1547	7194722000000
98594	1698	4388803550062
98658	1397	1311607295000
98659	1678	23040757805000
98660	2133	95881776000
98661	1874	17295000
98662	2134	87367385000
98663	1874	17298000
98664	1394	524168705500000
98694	1397	1311557290000
98695	1678	23040757810000
98696	2133	95876766000
98697	1874	17321000
98698	2134	87362370000
98699	1874	17324000
98700	2132	148019020000
98701	1874	17325000
98702	1395	58171588787507701
98703	1395	58171588800507701
98769	1874	17349000
98770	576	70397454726897
98771	576	70397465726897
98803	2133	95867748000
98804	1874	17371000
98805	1694	4858772197225
98831	547	66720000000000
98832	547	66720010000000
98869	1397	1311437278000
98870	1678	23040757822000
98871	1397	1311427277000
98872	1678	23040757823000
98873	1397	1311417276000
98874	1678	23040757824000
98875	2133	95864742000
98876	1874	17383000
98877	2133	95863740000
98878	1874	17385000
98879	2133	95862738000
98880	1874	17387000
98881	2134	87350334000
98882	1874	17390000
98883	2134	87349331000
98884	1874	17393000
98885	2134	87348328000
98886	1874	17396000
98887	1693	8102683908632
98888	1693	8102720908632
98890	1690	152645245000000
98891	1690	152645281000000
98912	2133	95859732000
98913	1874	17408000
98914	2133	95858730000
98915	1874	17410000
98916	2134	87345319000
98917	1874	17413000
98918	1394	525608708500000
98947	1397	1311387273000
98948	1678	23040757827000
98949	2134	87342310000
98950	1874	17426000
98951	2133	95855724000
98952	1874	17428000
98953	1684	7202851219748
98954	1684	7202863219748
98957	1397	1311377272000
98958	1678	23040757828000
98959	2133	95854722000
98960	1874	17430000
98961	2134	87341307000
98962	1874	17433000
98963	1402	79775186319298
98982	2087	720193000000
98983	2087	720204000000
98996	1397	1311337268000
98997	1678	23040757832000
98998	2134	87337295000
98999	1874	17451000
99000	1594	3601579000000
99003	1394	527048708500000
99004	1394	527048720500000
99006	1613	21528197600000
99034	1397	1311297264000
99035	1678	23040757836000
99036	1602	4176223170000
99042	1402	81215210319298
99043	1402	81215236319298
99068	2148	1440047880750
99094	1705	9200570580140
99095	1705	9200582580140
99096	1397	1311227257000
99097	1678	23760767843000
99098	1397	1311217256000
99099	1678	23760767844000
99100	2134	87326262000
99101	1874	17506000
99102	2134	87325259000
99103	1874	17509000
99104	1395	58172308824507701
99105	2133	95839692000
99106	1874	17511000
99107	2133	95838690000
99108	1874	17513000
99109	2284	198000000
99110	1395	58173028824507701
99111	1395	150000
99112	1568	58173028824957278
99113	1527	22272264351155
99114	1509	273999976
99115	1571	4752105151480
99138	632	71037513000000
99155	1675	5324140999977
99156	1675	5324152999977
99159	1397	1311167251000
99160	1678	23760767849000
99161	2133	95833680000
99162	1874	17535000
99175	2133	95832678000
99176	1874	17540000
99177	2134	87319241000
99178	1874	17543000
99179	1710	4553896664140
99180	1710	4553908664140
99195	1457	27264617040000
99214	1564	4747253000000
99215	1564	5467253000000
99216	1564	5467883000000
99234	606	68206586286230
99236	1678	23040757838000
99237	1678	23040757839000
99238	1678	23040757840000
99239	1678	23040757841000
99240	1678	23040757842000
99241	1678	23040757843000
99242	1678	23040757844000
99243	1678	23040757845000
99244	1678	23040757846000
99245	1678	23040757847000
99246	1678	23040757848000
99247	1678	23040757849000
99248	1678	23040757850000
99249	1678	23040757851000
99250	1678	23040757852000
99251	1678	23040757853000
99252	1678	23040757854000
99253	1678	23040757855000
99254	1874	17277000
99255	1874	17279000
99256	1874	17283000
99257	1874	17285000
99258	1874	17288000
99259	1874	17290000
99260	1874	17294000
99261	1874	17296000
99262	1874	17300000
99263	1874	17302000
99264	1874	17304000
99265	1874	17308000
99266	1874	17310000
99267	1874	17312000
99268	1874	17318000
99269	1874	17320000
99270	1874	17322000
99271	1874	17326000
99272	1874	17334000
99273	1874	17336000
99274	1874	17338000
99275	1874	17344000
99276	1874	17350000
99277	1874	17352000
99278	1670	721462000000
99279	1874	17353000
99280	1874	17357000
99281	1874	17360000
99282	1874	17363000
99283	1874	17372000
99284	1874	17375000
99285	1874	17384000
99286	1874	17402000
99287	1670	1441462000000
99288	1670	1441480000000
99289	1397	1311087243000
99290	1678	23760767857000
99291	2133	95825664000
99292	1874	17575000
99293	1394	528488729500000
99337	1536	2880058000000
98728	1874	16173000
98729	1874	16179000
98730	1440	1441805045924
98731	1571	1441822045788
98732	1440	2592031151192
98751	1506	3892600967172
98752	1506	3892612967172
98768	300	66720012000000
98781	1685	149764337571430
98782	1685	149764347571430
98820	1394	525608705500000
98821	1394	525608717500000
98823	1397	1311447279000
98824	1678	23040757821000
98825	2134	87351337000
98826	1874	17379000
98827	2133	95865744000
98828	1874	17381000
98829	1637	255606073819988
98830	1637	255606085819988
98900	1536	2160024000000
98901	1536	2160054000000
98904	1874	17398000
98905	2112	4320123000000
98906	2133	95860734000
98907	1874	17403000
98908	2134	87346322000
98909	1874	17406000
98910	1608	4458336000000
98911	1608	4458338000000
98926	1602	4176213170000
98927	1602	4176215170000
98928	1686	20798970869379
98929	1686	20509775079363
98930	1686	20220579289347
98931	1686	18018660403647
98932	1686	14072848546422
98933	1686	11410527407697
98934	1686	3991750700122
98935	1686	3991740700122
98936	1602	3457363170000
98937	1602	4177363170000
98938	1602	4177523170000
98939	1397	1311397274000
98940	1678	23040757826000
98941	2134	87343313000
98942	1874	17421000
98943	2133	95856726000
98944	1874	17423000
98945	1738	2158922000000
98946	1738	2158934000000
98966	1397	1311367271000
98967	1678	23040757829000
98968	2133	95853720000
98969	1874	17435000
98970	2134	87340304000
98971	1874	17438000
98972	1623	61202967899898
98973	1623	61202979899898
98980	1699	2160296750126
98981	1699	2160308750126
98992	1694	5578772197225
98993	1694	5578785197225
99016	1397	1311317266000
99017	1678	23040757834000
99018	2133	95848710000
99019	1874	17460000
99020	2134	87335289000
99021	1874	17463000
99022	1509	22272250851155
99023	1509	22272262851155
99033	1546	20161118000000
99076	1709	2880057000000
99077	1709	2880069000000
99086	1397	1311237258000
99087	1678	23760767842000
99088	2133	95840694000
99089	1874	17500000
99090	2134	87327265000
99091	1874	17503000
99092	2112	5040124000000
99093	2112	5040136000000
99136	1685	150484347571430
99137	1685	150484349571430
99171	1536	2160036000000
99189	1397	1311137248000
99190	1678	23760767852000
99191	2134	87317235000
99192	1874	17551000
99193	2133	95830674000
99194	1874	17553000
99204	1688	18719013910040
99205	1688	18719025910040
99233	1670	1440828000000
99299	1397	1311077242000
99300	1678	23760767858000
99301	1397	1311067241000
99302	1678	23760767859000
99303	2133	95824662000
99304	1874	17580000
99305	2133	94614662000
99306	2289	200000000
99307	2133	94613660000
99308	1874	17582000
99309	2134	87311217000
99310	1874	17585000
99311	2134	87310214000
99312	1874	17588000
99313	1419	12528128560130
99330	1536	2880036000000
99331	1536	2880057000000
99350	2134	87307205000
99351	1874	17601000
99352	1874	17603000
99353	1593	27190541000000
99355	1397	1311027237000
99356	1678	23760767863000
99357	2134	87306202000
99358	1874	17604000
99359	1874	17606000
99360	1672	2161238000000
99364	1397	1311017236000
99365	1678	23760767864000
99366	2134	87305199000
99367	1874	17611000
99368	2133	94608650000
99369	1874	17613000
99370	1426	6090283000000
99379	1691	24443480100019
99380	1691	24443492100019
99438	1547	22172796000000
99439	1547	21885776000000
99440	1547	19696756000000
99441	1547	17049736000000
99442	1547	13127716000000
99443	1547	5754696000000
99444	1508	19804356117393
99445	1508	19808157929693
99446	1508	20059727541648
99447	1508	15485875556796
99448	1508	12399803229364
99449	1508	3800206156616
99450	1739	29521558000000
99451	1739	30241558000000
99452	1739	30241898000000
99474	1397	1310917226000
99475	1678	23760767874000
99476	2133	94597628000
99477	1874	17665000
99478	2134	87294166000
99479	1874	17668000
99515	1397	1310867221000
99516	1678	23760767879000
99517	1693	7381573908632
99518	2290	100000000
99519	2133	94592618000
99520	1874	17690000
99521	2134	87289151000
99522	1874	17693000
99523	1395	58175188848957278
99524	1395	58175188870957278
99546	2134	87287145000
99547	1874	17699000
99548	1874	17701000
99549	1874	17703000
99550	1602	4896247170000
99581	470	71760205000000
99582	470	71760217000000
99584	1573	14899271000000
99585	1958	5231186000000
99586	1397	1310797214000
99587	1678	23760767886000
99588	2133	94585604000
99589	1874	17725000
99590	2134	87282130000
99591	1874	17728000
99592	1717	23868366000023
99593	1717	23868388000023
99610	1508	22688206929693
99611	1693	6661561908632
99612	1508	22939776541648
99613	1508	18365924556796
99614	1508	15279852229364
99615	43	85441118890000
99718	1546	17252756000000
99001	2133	95850714000
99002	1874	17453000
99005	1594	3601580000000
99026	1397	1311307265000
99027	1678	23040757835000
99028	2134	87334286000
99029	1874	17466000
99030	2133	95847708000
99031	1874	17468000
99032	1451	18619114000000
99048	1397	1311277262000
99049	1678	23760767838000
99050	1397	1311267261000
99051	1678	23760767839000
99052	2284	199000000
99053	2134	87332280000
99054	1874	17474000
99055	2134	87331277000
99056	1874	17477000
99057	2134	87330274000
99058	1874	17480000
99059	1874	17482000
99060	2133	95845704000
99061	1874	17484000
99062	2133	95844702000
99063	1874	17486000
99064	2133	95843700000
99065	1874	17488000
99066	1458	7865084908540
99067	1458	7865113908540
99069	1397	1311257260000
99070	1678	23760767840000
99071	2133	95842698000
99072	1874	17490000
99073	2134	87329271000
99074	1874	17493000
99075	1696	24977651835100
99116	526	69603380000000
99117	526	70323380000000
99118	526	70323570000000
99122	1397	1311207255000
99123	1678	23760767845000
99124	1397	1311197254000
99125	1678	23760767846000
99126	2133	95837688000
99127	1874	17515000
99128	2133	95836686000
99129	1874	17517000
99130	2134	87324256000
99131	1874	17520000
99132	2134	87323253000
99133	1874	17523000
99134	1443	720000000000
99135	1443	720024000000
99168	1654	23325294999798
99169	1425	914812000000
99170	1536	2783683999989
99172	1397	1311157250000
99173	1678	23760767850000
99174	1394	527048718500000
99196	1397	1311127247000
99197	1678	23760767853000
99198	2133	95829672000
99199	1874	17555000
99200	2134	87316232000
99201	1874	17558000
99202	1708	21636328500022
99203	1708	21636340500022
99206	1397	1311117246000
99207	1678	23760767854000
99208	2134	87315229000
99209	1874	17561000
99210	2133	95828670000
99211	1874	17563000
99228	2134	87314226000
99229	1874	17570000
99230	2134	87313223000
99231	1874	17573000
99232	1395	58174468860957278
99235	1670	1440830000000
99294	2134	87312220000
99295	1874	17576000
99296	1874	17578000
99297	1673	32005656000000
99298	1673	32005668000000
99322	1508	22684405117393
99323	1021	507244438919578
99324	1397	1311047239000
99325	1678	23760767861000
99326	2133	94611656000
99327	1874	17595000
99328	1394	529928729500000
99329	1394	529928750500000
99338	1397	1311037238000
99339	1678	23760767862000
99340	1508	18110553132541
99341	1141	908977688473491
99342	1508	15024480805109
99343	1261	613305359073006
99344	1508	6424883732361
99345	1387	1709029915128959
99346	2133	94610654000
99347	1874	17600000
99348	1593	27190499000000
99349	1593	27190540000000
99354	1692	49460989619999
99381	1397	1310997234000
99382	1678	23760767866000
99383	2133	94606646000
99384	1874	17620000
99385	2133	94605644000
99386	1874	17622000
99394	1397	1310987233000
99395	1678	23760767867000
99396	1874	17625000
99397	2133	94604642000
99398	1874	17627000
99399	1874	17630000
99400	2134	87301187000
99401	1874	17633000
99402	1691	24443494100019
99422	1397	1310957230000
99423	1678	23760767870000
99424	2134	87298178000
99425	1874	17646000
99426	2133	94601636000
99427	1874	17648000
99480	1397	1310907225000
99481	1678	23760767875000
99482	885	63455011096354
99483	2133	94596626000
99484	1874	17670000
99485	2134	87293163000
99486	1874	17673000
99487	1756	5600764195609
99505	1397	1310877222000
99506	1678	23760767878000
99507	2133	94593620000
99508	1874	17685000
99509	1671	3983856003785
99510	1671	3983867003785
99529	2134	87288148000
99530	1874	17696000
99531	2133	94591616000
99532	1874	17698000
99533	1560	4329614131803
99551	2112	5040148000000
99553	1397	1310837218000
99554	1678	23760767882000
99555	1397	1310827217000
99556	1678	23760767883000
99557	2133	94589612000
99558	1874	17705000
99559	2133	94588610000
99560	1874	17707000
99561	2134	87286142000
99562	1874	17710000
99563	2134	87285139000
99564	1874	17713000
99565	1696	27137671335104
99566	1696	27137695335104
99583	1685	151924349571430
99594	1397	1310787213000
99595	1678	23760767887000
99596	2133	94584602000
99597	1874	17730000
99598	2134	87281127000
99599	1874	17733000
99600	1690	153365281000000
99601	1690	153365293000000
99690	1678	23760767889000
99691	2133	94582598000
99692	1874	17740000
99693	2134	87279121000
99694	1874	17743000
99695	1690	154085293000000
99696	1690	154085305000000
99697	1564	3966553000000
99698	588	66783000000000
99699	1397	1310757210000
99700	1678	23760767890000
99701	2133	94581596000
99702	1874	17745000
99703	2134	87278118000
99704	1874	17748000
99165	1874	17538000
99166	1451	19339114000000
99167	1451	19339126000000
99181	1397	1311147249000
99182	1678	23760767851000
99183	2133	95831676000
99184	1874	17542000
99185	1874	17545000
99186	2134	87318238000
99187	1874	17548000
99188	1714	4605480171760
99212	1759	20160987999889
99213	1759	20160999999889
99217	1685	151204349571430
99218	1397	1311107245000
99219	1678	23760767855000
99220	1397	1311097244000
99221	1678	23760767856000
99222	2133	95827668000
99223	1874	17565000
99224	2133	95826666000
99225	1874	17567000
99226	1394	528488718500000
99227	1394	528488740500000
99314	1397	1311057240000
99315	1678	23760767860000
99316	2134	87309211000
99317	1874	17591000
99318	2133	94612658000
99319	1874	17593000
99320	2261	3599047000000
99321	2261	3599059000000
99332	2134	87308208000
99333	1874	17596000
99334	1874	17598000
99335	1723	22679586085979
99336	1723	22679608085979
99430	1688	19439025910040
99431	1688	19439037910040
99436	2148	2160047880750
99437	2148	2160059880750
99453	1397	1310947229000
99454	1678	23760767871000
99455	1397	1310937228000
99456	1678	23760767872000
99457	1397	1310927227000
99458	1678	23760767873000
99459	2133	94600634000
99460	1874	17650000
99461	2133	94599632000
99462	1874	17652000
99463	2133	94598630000
99464	1874	17654000
99465	2134	87297175000
99466	1874	17657000
99467	2134	87296172000
99468	1874	17660000
99469	2134	87295169000
99470	1874	17663000
99471	1708	21636364500022
99497	1397	1310887223000
99498	1678	23760767877000
99499	2134	87291157000
99500	1874	17681000
99501	2133	94594622000
99502	1874	17683000
99503	1696	26417659335104
99504	1696	26417671335104
99525	1397	1310857220000
99526	1678	23760767880000
99527	1560	4329602131803
99528	1560	4329612131803
99534	1693	5221526908632
99535	1560	3611312131803
99536	1560	4331312131803
99537	1560	4331672131803
99567	1397	1310817216000
99568	1678	23760767884000
99569	2134	87284136000
99570	1874	17716000
99571	2133	94587608000
99572	1874	17718000
99573	1444	5127664329999
99574	1444	5127676329999
99616	1678	23040757856000
99617	1678	23040757857000
99618	1678	23040757858000
99619	1678	23040757859000
99620	1678	23040757860000
99621	1678	23040757861000
99622	1678	23040757862000
99623	1678	23040757863000
99624	1678	23040757864000
99625	1678	23040757865000
99626	1678	23040757866000
99627	1678	23040757867000
99628	1678	23040757868000
99629	1402	81215636319298
99630	1678	23040757869000
99631	1678	23040757870000
99632	1678	23040757871000
99633	1678	23040757872000
99634	1678	23040757873000
99635	1678	23040757874000
99636	1678	23040757875000
99637	1678	23040757876000
99638	1678	23040757877000
99639	1678	23040757878000
99640	1678	23040757879000
99641	1678	23040757880000
99642	1678	23040757881000
99643	1678	23040757882000
99644	1678	23040757883000
99645	1678	23040757884000
99646	1678	23040757885000
99647	1678	23040757886000
99648	1678	23040757887000
99649	1678	23040757888000
99650	1397	1310767211000
99651	1678	23040757889000
99652	1874	17475000
99653	1874	17479000
99654	1874	17481000
99655	1874	17483000
99656	1874	17485000
99657	1874	17487000
99658	1874	17489000
99659	1874	17491000
99660	1874	17496000
99661	1874	17499000
99662	1874	17502000
99663	1874	17505000
99664	1874	17508000
99665	1874	17514000
99666	1874	17527000
99667	1874	17529000
99668	1874	17537000
99669	1874	17539000
99670	1874	17541000
99671	1874	17547000
99672	1874	17550000
99673	1874	17556000
99674	1874	17559000
99675	1874	17562000
99676	1874	17568000
99677	1874	17571000
99678	1874	17574000
99679	1874	17577000
99680	1874	17584000
99681	1874	17586000
99682	1874	17590000
99683	1874	17599000
99684	1874	17602000
99685	1874	17605000
99686	1874	17614000
99687	1874	17617000
99688	1402	81935636319298
99689	1402	81935946319298
99707	2087	1440204000000
99708	2087	1440236000000
99710	1397	1310747209000
99711	1678	23760767891000
99712	2133	94580594000
99713	1874	17747000
99714	1874	17750000
99715	2134	87277115000
99716	1874	17753000
99717	2087	1440248000000
99724	1546	10685356000000
99725	1093	909143945000000
99726	1546	3312316000000
99727	1339	1709341667751650
99728	1397	1310737208000
99729	1678	23760767892000
99730	1397	1310727207000
99731	1678	23760767893000
99732	1397	1310717206000
99733	1678	23760767894000
99734	2133	94579592000
99735	1874	17755000
99736	2133	94578590000
99737	1874	17757000
99738	2133	94577588000
99739	1874	17759000
99740	2134	87276112000
99361	2133	94609652000
99362	1874	17608000
99363	1672	2161239000000
99371	1397	1311007235000
99372	1678	23760767865000
99373	2133	94607648000
99374	1874	17615000
99375	2134	87304196000
99376	1874	17618000
99377	470	71040193000000
99378	470	71040205000000
99387	2134	87303193000
99388	1874	17621000
99389	1874	17623000
99390	2134	87302190000
99391	1874	17626000
99392	1874	17628000
99393	1684	7202865219748
99403	1397	1310977232000
99404	1678	23760767868000
99405	1397	1310967231000
99406	1678	23760767869000
99407	773	1000000000000
99408	1508	6428685544661
99409	478	66000000000000
99410	1508	6680255156616
99411	1444	3687660329999
99412	2133	94603640000
99413	1874	17635000
99414	2133	94602638000
99415	1874	17637000
99416	2134	87300184000
99417	1874	17640000
99418	2134	87299181000
99419	1874	17643000
99420	1444	4407660329999
99421	1444	4407664329999
99428	1696	25697651835100
99429	1696	25697663835100
99432	2284	198500000
99433	1696	25697651335100
99434	1527	25697659335104
99435	1696	277999972
99472	1637	256326085819988
99473	1637	256326121819988
99488	886	63455021096354
99489	1397	1310897224000
99490	1678	23760767876000
99491	2133	94595624000
99492	1874	17675000
99493	2134	87292160000
99494	1874	17678000
99495	1680	5053213499559
99496	1680	5053235499559
99511	2134	87290154000
99512	1874	17686000
99513	1874	17688000
99514	1671	3983868003785
99538	2290	90000000
99539	1397	1310847219000
99540	1678	23760767881000
99541	1874	17695000
99542	2133	94590614000
99543	1874	17697000
99544	1602	4896223170000
99545	1602	4896245170000
99552	1675	5324164999977
99575	1397	1310807215000
99576	1678	23760767885000
99577	2133	94586606000
99578	1874	17720000
99579	2134	87283133000
99580	1874	17723000
99602	1397	1310777212000
99603	1678	23760767888000
99604	2134	87280124000
99605	1874	17736000
99606	2133	94583600000
99607	1874	17738000
99608	43	85440996890000
99609	43	85441008890000
99705	1686	6151789700122
99706	1686	6151821700122
99775	1699	2160318750126
99778	1397	1310677202000
99779	1678	23760767898000
99780	2133	94573580000
99781	1874	17785000
99782	2134	87270094000
99783	1874	17788000
99784	1679	8638519654000
99793	1723	23399608085979
99794	1723	23399620085979
99797	1714	5325480171760
99798	1714	5325492171760
99881	1397	1310547189000
99882	1678	23760767911000
99883	2133	94560554000
99884	1874	17847000
99885	2134	87258058000
99886	1874	17850000
99887	1608	5178338000000
99888	1608	5178350000000
99905	1541	1442049000000
99906	1541	1442073000000
99932	1397	1310477182000
99933	1678	23760767918000
99934	2134	87251037000
99935	1874	17883000
99936	2133	94553540000
99937	1874	17885000
99938	360	67440001000000
99939	360	67440013000000
99956	1637	257046133819988
99957	1637	257046145819988
99965	1536	3600059000000
99966	1536	3600071000000
99967	2134	87247025000
99968	1874	17903000
99969	2133	94549532000
99970	1874	17905000
99971	1395	58175908870957278
99972	1395	58175908872957278
99983	1657	18001532990100
100089	1594	4321579000000
100090	1594	4321588000000
100091	1564	4687863000000
100092	1508	21964393117393
100093	1508	21968194929693
100094	1693	5941537908632
100095	1508	22219764541648
100096	1508	17645912556796
100097	1508	14559840229364
100098	1508	5960243156616
100099	1564	4688583000000
100100	1564	5408583000000
100101	1514	5409212990100
100102	1564	700010040300
100131	1691	25163494100019
100132	1691	25163506100019
100221	1397	1310347169000
100222	1678	23760767931000
100223	2134	87231980000
100224	1874	17978000
100225	2133	94534502000
100226	1874	17980000
100227	2112	6480160000000
100228	2112	6480172000000
100241	2133	94533500000
100242	1874	17985000
100243	1395	58176628882957278
100244	1395	58176628894957278
100253	1685	152644349571430
100254	1397	1310317166000
100255	1678	23760767934000
100256	2134	87228971000
100257	1874	17993000
100258	2133	94531496000
100259	1874	17995000
100260	1428	2160030000000
100261	1428	2160042000000
100292	1397	1310277162000
100293	1678	23760767938000
100294	2134	87224959000
100295	1874	18013000
100296	2133	94527488000
100297	1874	18015000
100298	1594	4321591000000
100299	1397	1310267161000
100300	1678	23760767939000
100301	2134	87223956000
100302	1874	18018000
100303	2133	94526486000
100304	1874	18020000
100305	1394	535688777500000
100306	1394	535688789500000
100307	1397	1310257160000
100308	1678	23760767940000
100309	1397	1310247159000
100310	1678	23760767941000
100311	1397	1310237158000
100312	1678	23760767942000
100313	2133	94525484000
100314	1874	18022000
100315	2133	94524482000
99709	1699	2160316750126
99762	1397	1310697204000
99763	1678	23760767896000
99764	1397	1310687203000
99765	1678	23760767897000
99766	2134	87272100000
99767	1874	17776000
99768	2134	87271097000
99769	1874	17779000
99770	2133	94575584000
99771	1874	17781000
99772	2133	94574582000
99773	1874	17783000
99774	2086	3775345300069
99831	1397	1310607195000
99832	1678	23760767905000
99833	2134	87263073000
99834	1874	17821000
99835	1440	2160155045924
99836	1440	2160166045924
99853	1874	17826000
99854	2133	94565564000
99855	1874	17828000
99856	2133	94564562000
99857	1874	17830000
99858	1874	17833000
99859	1693	8101698908632
99879	1536	2880059000000
99892	1397	1310537188000
99893	1678	23760767912000
99894	1397	1310527187000
99895	1678	23760767913000
99896	2133	94559552000
99897	1874	17852000
99898	2134	87257055000
99899	1874	17855000
99900	2134	87256052000
99901	1874	17858000
99902	2133	94558550000
99903	1874	17860000
99904	1637	256326109819988
99907	1397	1310517186000
99908	1678	23760767914000
99909	1397	1310507185000
99910	1678	23760767915000
99911	1397	1310497184000
99912	1678	23760767916000
99913	1397	1310487183000
99914	1678	23760767917000
99915	2133	94557548000
99916	1874	17862000
99917	2134	87255049000
99918	1874	17865000
99919	2134	87254046000
99920	1874	17868000
99921	2134	87253043000
99922	1874	17871000
99923	2133	94556546000
99924	1874	17873000
99925	2133	94555544000
99926	1874	17875000
99927	2134	87252040000
99928	1874	17878000
99929	2133	94554542000
99930	1874	17880000
99931	1637	256326133819988
99948	1397	1310457180000
99949	1678	23760767920000
99950	2134	87249031000
99951	1874	17893000
99952	2133	94551536000
99953	1874	17895000
99954	1991	6381285355805
99955	1991	6381297355805
99958	1397	1310447179000
99959	1678	23760767921000
99960	2133	94550534000
99961	1874	17897000
99962	2134	87248028000
99963	1874	17900000
99964	1394	531368753500000
99982	1394	532808753500000
99985	1678	23040757890000
99986	1678	23040757891000
99987	1678	23040757892000
99988	1678	23040757893000
99989	1678	23040757894000
99990	1678	23040757895000
99991	1678	23040757896000
99992	1678	23040757897000
99993	1678	23040757898000
99994	1678	23040757899000
99995	1678	23040757900000
99996	1678	23040757901000
99997	1678	23040757902000
99998	1678	23040757903000
99999	1678	23040757904000
100000	1678	23040757905000
100001	1678	23040757906000
100002	1678	23040757907000
100003	1678	23040757908000
100004	1678	23040757909000
100005	1678	23040757910000
100006	1678	23040757911000
100007	1678	23040757912000
100008	1678	23040757913000
100009	1678	23040757914000
100010	1678	23040757915000
100011	1678	23040757916000
100012	1678	23040757917000
100013	1678	23040757918000
100014	1678	23040757919000
100015	1678	23040757920000
100016	1678	23040757921000
100017	1402	81936428319298
100018	1874	17629000
100019	1874	17632000
100020	1874	17638000
100021	1874	17641000
100022	1874	17644000
100023	1874	17647000
100024	1874	17653000
100025	1874	17656000
100026	1874	17659000
100027	1874	17662000
100028	1874	17671000
100029	1874	17674000
100030	1874	17677000
100031	1874	17680000
100032	1874	17689000
100033	1874	17692000
100034	1874	17704000
100035	1874	17719000
100036	1874	17722000
100037	1874	17731000
100038	1874	17734000
100039	1874	17737000
100040	1874	17746000
100041	1874	17749000
100042	1874	17752000
100043	1874	17758000
100044	1874	17761000
100045	1874	17764000
100046	1874	17767000
100047	1874	17782000
100048	2134	87245019000
100049	1874	17795000
100050	1874	17797000
100051	1874	17799000
100052	1874	17801000
100053	1874	17803000
100054	1874	17805000
100055	1874	17807000
100056	1874	17811000
100057	1874	17813000
100058	1874	17817000
100059	1874	17819000
100060	1874	17825000
100061	1874	17829000
100062	1874	17831000
100063	1874	17837000
100064	1874	17839000
100065	1874	17843000
100066	1874	17849000
100067	1874	17851000
100068	1402	82656428319298
100069	1402	82656513319298
100070	1874	17913000
100071	1877	719010000000
100072	1442	0
100073	2134	87244016000
100074	1874	17916000
100075	2134	87243013000
100076	1874	17919000
100077	2134	87242010000
100078	1874	17922000
100079	2133	94547528000
100080	1874	17924000
100081	2133	94546526000
100082	1874	17926000
100083	2133	94545524000
100084	1874	17928000
100085	2133	94544522000
100086	1874	17930000
100087	1599	24820463393047
99719	973	507337115000000
99720	1546	14606846000000
99721	1213	613417650000000
99722	1874	17751000
99723	1675	5324172999977
99751	1634	6862981259504
99752	1634	7582981259504
99753	1634	7582983259504
99795	1596	3600084000000
99796	1596	3600095000000
99799	1397	1310657200000
99800	1678	23760767900000
99801	2134	87268088000
99802	1874	17796000
99803	2133	94571576000
99804	1874	17798000
99805	1394	529928741500000
99806	1397	1310647199000
99807	1678	23760767901000
99808	1397	1310637198000
99809	1678	23760767902000
99810	1397	1310627197000
99811	1678	23760767903000
99812	1397	1310617196000
99813	1678	23760767904000
99814	2133	94570574000
99815	1874	17800000
99816	2133	94569572000
99817	1874	17802000
99818	2133	94568570000
99819	1874	17804000
99820	2133	94567568000
99821	1874	17806000
99822	2134	87267085000
99823	1874	17809000
99824	2134	87266082000
99825	1874	17812000
99826	2134	87265079000
99827	1874	17815000
99828	2134	87264076000
99829	1874	17818000
99830	1688	19439073910040
99837	2133	94566566000
99838	1874	17820000
99839	1874	17823000
99840	1440	2160167045924
99860	1397	1310577192000
99861	1678	23760767908000
99862	2133	94563560000
99863	1874	17835000
99864	2134	87260064000
99865	1874	17838000
99866	369	79332279412810
99973	1619	1440012000000
99974	1619	1440014000000
99984	1506	4612612967172
100117	1637	257046157819988
100119	1702	2880462000000
100120	1702	2880486000000
100202	43	86161118890000
100203	43	86161279890000
100211	1419	13248128560130
100212	1419	13248140560130
100246	1397	1310327167000
100247	1678	23760767933000
100248	2134	87229974000
100249	1874	17988000
100250	2133	94532498000
100251	1874	17990000
100252	1637	257046146819988
100278	1634	7582927259504
100279	1634	7582951259504
100282	1397	1310287163000
100283	1678	23760767937000
100284	2134	87225962000
100285	1874	18008000
100286	2133	94528490000
100287	1874	18010000
100288	1559	20842905000000
100289	1559	20842917000000
100397	1874	18053000
100398	171	70986678696494
100399	171	70986689696494
100414	1613	21528195599999
100415	1964	21528207599997
100416	1613	200000003
100435	641	71043622000000
100497	1695	4265514999000
100498	1397	1310117146000
100499	1678	23760767954000
100500	1695	4985514999000
100501	1695	4986221999000
100541	1395	58177348906957278
100542	1395	58177348930957278
100552	1397	1310087143000
100553	1678	23760767957000
100554	1397	1310077142000
100555	1678	23760767958000
100556	2133	94507448000
100557	1874	18109000
100558	2133	94506446000
100559	1874	18111000
100560	2134	87205902000
100561	1874	18114000
100562	2134	87204899000
100563	1874	18117000
100564	1395	58178068930957278
100565	1395	58178068954957278
100569	1560	5049612131803
100570	1560	5049636131803
100609	1397	1310027137000
100610	1678	23760767963000
100611	1397	1310017136000
100612	1678	23760767964000
100613	2133	94501436000
100614	1874	18139000
100615	2133	94500434000
100616	1874	18141000
100617	2134	87199884000
100618	1874	18144000
100619	2134	87198881000
100620	1874	18147000
100637	1397	1309987133000
100638	1678	23760767967000
100639	1397	1309977132000
100640	1678	23760767968000
100641	2134	87195872000
100642	1874	18160000
100643	2133	94497428000
100644	1874	18162000
100645	2133	94496426000
100646	1874	18164000
100647	2134	87194869000
100648	1874	18167000
100649	2148	2160071880750
100692	1397	1309907125000
100693	1678	23760767975000
100694	1397	1309897124000
100695	1678	23760767976000
100696	2133	94489412000
100697	1874	18199000
100698	2133	94488410000
100699	1874	18201000
100700	2134	87187848000
100701	1874	18204000
100702	2134	87186845000
100703	1874	18207000
100704	1850	6456224949999
100758	1397	1309817116000
100759	1678	23760767984000
100760	2133	94480394000
100761	1874	18244000
100763	1690	154805305000000
100764	1690	154805316000000
100787	2134	87176815000
100788	1874	18257000
100789	2133	94477388000
100790	1874	18259000
100791	1476	2160036000000
100808	1637	258486194819988
100817	1397	1309747109000
100818	1678	23760767991000
100819	1397	1309737108000
100820	1678	23760767992000
100821	2134	87172803000
100822	1874	18277000
100823	2133	94473380000
100824	1874	18279000
100825	2134	87171800000
100826	1874	18282000
100827	2133	94472378000
100828	1874	18284000
100829	1419	13248152560130
100832	1739	30242908000000
100833	1739	30962908000000
100834	1739	30963248000000
100890	1668	5553513000000
100891	1668	5553549000000
100906	1397	1309637098000
100907	1678	23760768002000
100908	2133	94462358000
100909	1874	18331000
100910	2134	87161770000
100911	1874	18334000
100912	1650	3712875000000
99741	1874	17762000
99742	1593	26470553000000
99743	2134	87275109000
99744	1874	17765000
99745	2134	87274106000
99746	1874	17768000
99747	1593	27190553000000
99748	2275	27190554999966
99749	1593	200000002
99750	1571	4752105151512
99754	1593	27190555000000
99755	1397	1310707205000
99756	1678	23760767895000
99757	2133	94576586000
99758	1874	17770000
99759	2134	87273103000
99760	1874	17773000
99761	1694	5578784197225
99776	2087	2160236000000
99777	2087	2160260000000
99785	1397	1310667201000
99786	1678	23760767899000
99787	2134	87269091000
99788	1874	17791000
99789	2133	94572578000
99790	1874	17793000
99791	1571	5472105151480
99792	1571	5472117151480
99841	2186	522957693786
99842	2291	0
99843	1397	1310597194000
99844	1678	23760767906000
99845	1397	1310587193000
99846	1678	23760767907000
99847	2134	87262070000
99848	1874	17824000
99849	2134	87261067000
99850	1874	17827000
99851	1693	8101573908632
99852	1693	8101695908632
99867	1397	1310567191000
99868	1678	23760767909000
99869	1397	1310557190000
99870	1678	23760767910000
99871	2133	94562558000
99872	1874	17840000
99873	2133	94561556000
99874	1874	17842000
99875	2134	87259061000
99876	1874	17845000
99877	1394	531368741500000
99878	1394	531368764500000
99880	1874	17841000
99889	1874	17848000
99890	1692	50180989619999
99891	1692	50181000619999
99940	1397	1310467181000
99941	1678	23760767919000
99942	2133	94552538000
99943	1874	17887000
99944	2134	87250034000
99945	1874	17890000
99946	1688	20159073910040
99947	1688	20159085910040
99975	1656	6475308999990
99976	2134	87246022000
99977	1874	17908000
99978	2133	94548530000
99979	1874	17910000
99980	1696	27857695335104
99981	1696	27857697335104
100121	1397	1310417176000
100122	1678	23760767924000
100123	2134	87239001000
100124	1874	17943000
100125	2133	94541516000
100126	1874	17945000
100127	1587	4320122000000
100128	1587	4320134000000
100133	1686	6151801700122
100134	1397	1310407175000
100135	1678	23760767925000
100136	2134	87237998000
100137	1874	17948000
100138	2133	94540514000
100139	1874	17950000
100156	1397	1310377172000
100157	1678	23760767928000
100158	2134	87234989000
100159	1874	17963000
100160	2133	94537508000
100161	1874	17965000
100162	2112	5760148000000
100163	2112	5760160000000
100166	1874	17808000
100167	1874	17814000
100168	1874	17832000
100169	1874	17844000
100170	1874	17853000
100171	1874	17856000
100172	1874	17859000
100173	1874	17874000
100174	1874	17877000
100175	1874	17886000
100176	1874	17889000
100177	1874	17892000
100178	1874	17899000
100179	1874	17901000
100180	1874	17907000
100181	1874	17909000
100182	1874	17911000
100183	1874	17915000
100184	1874	17917000
100185	1874	17921000
100186	1874	17923000
100187	1874	17925000
100188	1874	17927000
100189	1874	17929000
100190	1874	17931000
100191	1874	17935000
100192	1874	17937000
100193	1874	17939000
100194	1874	17941000
100195	1874	17947000
100196	1874	17949000
100197	1874	17951000
100198	1874	17959000
100199	1874	17961000
100200	2112	5040608000000
100201	2112	5760608000000
100213	1397	1310357170000
100214	1678	23760767930000
100215	2133	94535504000
100216	1874	17972000
100217	2134	87232983000
100218	1874	17975000
100219	1458	8585084908540
100220	1458	8585096908540
100229	1874	17969000
100230	1874	17971000
100231	1874	17974000
100232	1874	17977000
100233	2112	6480608000000
100234	2112	6480644000000
100262	1705	9920582580140
100263	1705	9920594580140
100280	1623	61922979899898
100281	1623	61923003899898
100290	1549	29136265000000
100291	1549	29136277000000
100327	1678	23040757922000
100328	1678	23040757923000
100329	1678	23040757924000
100330	1678	23040757925000
100331	1678	23040757926000
100332	1678	23040757927000
100333	1678	23040757928000
100334	1678	23040757929000
100335	1678	23040757930000
100336	1678	23040757931000
100337	1678	23040757932000
100338	1678	23040757933000
100339	1678	23040757934000
100340	1678	23040757935000
100341	1678	23040757936000
100342	1678	23040757937000
100343	1678	23040757938000
100344	1678	23040757939000
100345	1678	23040757940000
100346	1678	23040757941000
100347	1678	23040757942000
100348	1397	1310227157000
100349	1678	23040757943000
100350	1874	17861000
100351	1874	17864000
100352	1874	17867000
100353	1874	17869000
100354	1402	82656751319298
100355	1874	17898000
100356	1874	17904000
100357	1874	17932000
100358	1874	17934000
100359	1874	17942000
100360	1874	17944000
100361	1874	17946000
100088	1599	24820472393047
100103	1397	1310437178000
100104	1678	23760767922000
100105	1397	1310427177000
100106	1678	23760767923000
100107	2134	87241007000
100108	1874	17933000
100109	2134	87240004000
100110	1874	17936000
100111	2133	94543520000
100112	1874	17938000
100113	2133	94542518000
100114	1874	17940000
100115	1394	534248753500000
100116	1394	534248777500000
100118	1703	720831000000
100129	1508	7400255156616
100130	1508	7400267156616
100140	1397	1310397174000
100141	1678	23760767926000
100142	2134	87236995000
100143	1874	17953000
100144	2133	94539512000
100145	1874	17955000
100146	1688	20879085910040
100147	1688	20879097910040
100148	1397	1310387173000
100149	1678	23760767927000
100150	2133	94538510000
100151	1874	17957000
100152	2134	87235992000
100153	1874	17960000
100154	1694	6298784197225
100155	1694	6298796197225
100164	43	86161008890000
100165	43	86161020890000
100204	1397	1310367171000
100205	1678	23760767929000
100206	2133	94536506000
100207	1874	17967000
100208	2134	87233986000
100209	1874	17970000
100210	1395	58175908882957278
100235	1397	1310337168000
100236	1678	23760767932000
100237	2134	87230977000
100238	1874	17983000
100239	1688	21599097910040
100240	1688	21599108910040
100245	1692	50181001619999
100264	1397	1310307165000
100265	1678	23760767935000
100266	1397	1310297164000
100267	1678	23760767936000
100268	2134	87227968000
100269	1874	17998000
100270	2133	94530494000
100271	1874	18000000
100272	2133	94529492000
100273	1874	18002000
100274	2134	87226965000
100275	1874	18005000
100276	1546	4032316000000
100277	1546	4032340000000
100369	1678	23760767943000
100370	1397	1310217156000
100371	1678	23760767944000
100372	1874	18038000
100373	2134	87218941000
100374	1874	18041000
100375	2133	94522478000
100376	1874	18043000
100377	2133	94521476000
100378	1874	18045000
100379	1724	22977695500000
100380	1397	1310207155000
100381	1678	23760767945000
100382	2134	87217938000
100383	1874	18048000
100384	2133	94520474000
100385	1874	18050000
100436	1397	1310147149000
100437	1678	23760767951000
100438	1573	8682270000000
100439	1318	1710516637751650
100440	1573	5375269000000
100441	1072	910057465000000
100442	1573	3144268000000
100443	1192	614032750000000
100444	2133	94513460000
100445	1874	18079000
100446	1573	1299267000000
100447	952	507686775000000
100448	2134	87211920000
100449	1874	18082000
100450	1394	537128805500000
100483	1623	61922995899898
100543	1762	4245326994000
100544	1762	4245350994000
100566	1688	22319108910040
100567	1688	22319132910040
100591	1397	1310047139000
100592	1678	23760767961000
100593	2133	94503440000
100594	1874	18129000
100595	2134	87201890000
100596	1874	18132000
100597	632	71757513000000
100598	632	71757525000000
100607	497	66720011000000
100608	497	66720023000000
100621	1593	27910555000000
100622	1593	27910579000000
100623	1397	1310007135000
100624	1678	23760767965000
100625	1397	1309997134000
100626	1678	23760767966000
100627	2134	87197878000
100628	1874	18150000
100629	2134	87196875000
100630	1874	18153000
100631	2133	94499432000
100632	1874	18155000
100633	2133	94498430000
100634	1874	18157000
100650	1397	1309967131000
100651	1678	23760767969000
100652	1397	1309957130000
100653	1678	23760767970000
100654	2133	94495424000
100655	1874	18169000
100656	2133	94494422000
100657	1874	18171000
100658	2134	87193866000
100659	1874	18174000
100660	2134	87192863000
100661	1874	18177000
100662	1679	9358519654000
100663	1679	9358543654000
100665	1397	1309947129000
100666	1678	23760767971000
100667	1397	1309937128000
100668	1678	23760767972000
100669	1397	1309927127000
100670	1678	23760767973000
100671	1397	1309917126000
100672	1678	23760767974000
100673	2133	94493420000
100674	1874	18179000
100675	2133	94492418000
100676	1874	18181000
100677	2133	94491416000
100678	1874	18183000
100679	2133	94490414000
100680	1874	18185000
100681	2134	87191860000
100682	1874	18188000
100683	2134	87190857000
100684	1874	18191000
100685	2134	87189854000
100686	1874	18194000
100687	2134	87188851000
100688	1874	18197000
100689	369	80052279412810
100690	369	80052327412810
100705	1397	1309887123000
100706	1678	23760767977000
100707	1397	1309877122000
100708	1678	23760767978000
100709	2134	87185842000
100710	1874	18210000
100711	2134	87184839000
100712	1874	18213000
100713	2133	94487408000
100714	1874	18215000
100715	2133	94486406000
100716	1874	18217000
100717	2248	5759359000000
100718	2248	5759383000000
100762	1395	58178068941957278
100765	1397	1309807115000
100766	1678	23760767985000
100767	1397	1309797114000
100768	1678	23760767986000
100769	2133	94479392000
100316	1874	18024000
100317	2133	94523480000
100318	1874	18026000
100319	2134	87222953000
100320	1874	18029000
100321	2134	87221950000
100322	1874	18032000
100323	2134	87220947000
100324	1874	18035000
100325	1637	257766146819988
100326	1637	257766182819988
100394	1671	4703868003785
100395	1671	4703880003785
100407	1397	1310177152000
100408	1678	23760767948000
100409	2133	94517468000
100410	1874	18059000
100411	2134	87215932000
100412	1874	18062000
100413	1613	21528207600000
100451	1874	17981000
100452	1874	17984000
100453	1874	17987000
100454	1874	17992000
100455	1874	17994000
100456	1874	17997000
100457	1874	18003000
100458	1874	18006000
100459	1874	18012000
100460	1874	18014000
100461	1874	18016000
100462	1874	18021000
100463	1874	18027000
100464	1874	18030000
100465	1874	18033000
100466	1874	18036000
100467	1874	18039000
100468	1874	18042000
100469	1874	18051000
100470	1874	18054000
100471	1874	18056000
100472	1874	18058000
100473	1874	18060000
100474	1874	18064000
100475	1874	18066000
100476	1874	18068000
100477	1874	18070000
100478	1874	18072000
100479	1874	18076000
100480	1874	18078000
100481	1874	18080000
100482	1701	4318378500103
100533	1397	1310107145000
100534	1678	23760767955000
100535	1874	18094000
100536	2134	87207908000
100537	1874	18100000
100538	2133	94509452000
100539	1874	18102000
100540	1719	5040179000000
100545	1685	153364349571430
100546	1397	1310097144000
100547	1678	23760767956000
100548	2133	94508450000
100549	1874	18104000
100550	2134	87206905000
100551	1874	18107000
100571	1546	17972768000000
100572	1546	15326858000000
100573	1546	11405368000000
100574	1546	4032328000000
100575	1560	5049787131803
100590	1633	16596773975638
100599	1397	1310037138000
100600	1678	23760767962000
100601	2134	87200887000
100602	1874	18135000
100603	2133	94502438000
100604	1874	18137000
100605	633	71469336900000
100606	633	71469348900000
100664	1759	20161011999889
100727	1397	1309867121000
100728	1678	23760767979000
100729	1397	1309857120000
100730	1678	23760767980000
100731	2133	94485404000
100732	1874	18219000
100733	2133	94484402000
100734	1874	18221000
100735	1874	18224000
100736	1874	18227000
100737	1509	22992264351155
100738	1509	22992288351155
100800	1397	1309767111000
100801	1678	23760767989000
100802	2134	87174809000
100803	1874	18267000
100804	2133	94475384000
100805	1874	18269000
100806	1395	58178788941957278
100807	1395	58178788953957278
100811	1397	1309757110000
100812	1678	23760767990000
100813	2133	94474382000
100814	1874	18271000
100815	2134	87173806000
100816	1874	18274000
100854	1447	22473733943000
100855	1447	22473769943000
100857	1397	1309697104000
100858	1678	23760767996000
100859	2133	94468370000
100860	1874	18301000
100861	2134	87167788000
100862	1874	18304000
100863	1698	4388783550062
100870	1397	1309677102000
100871	1678	23760767998000
100872	1397	1309667101000
100873	1678	23760767999000
100874	1397	1309657100000
100875	1678	23760768000000
100876	2133	94466366000
100877	1874	18311000
100878	2134	87165782000
100879	1874	18314000
100880	2133	94465364000
100881	1874	18316000
100882	2133	94464362000
100883	1874	18318000
100884	2134	87164779000
100885	1874	18321000
100886	2134	87163776000
100887	1874	18324000
100888	1394	538568813500000
100889	1394	538568849500000
100893	1541	1442085000000
100902	171	71706689696494
100903	171	71706701696494
100919	1397	1309617096000
100920	1678	23760768004000
100921	2134	87159764000
100922	1874	18342000
100923	2133	94460354000
100924	1874	18344000
100925	1675	6044172999977
100926	1675	6044184999977
100950	1634	8302951259504
100982	1567	130000000101
100983	1634	8894154194579
101010	1666	1440011000000
101011	1666	1440023000000
101030	1397	1309527087000
101031	1678	23760768013000
101032	1397	1309517086000
101033	1678	23760768014000
101034	2133	94451336000
101035	1874	18386000
101036	2133	94450334000
101037	1874	18388000
101038	2134	87150737000
101039	1874	18391000
101040	2134	87149734000
101041	1874	18394000
101042	1549	29856277000000
101043	1549	29856301000000
101070	1397	1309477082000
101071	1678	23760768018000
101072	2134	87145722000
101073	1874	18412000
101074	2133	94446326000
101075	1874	18414000
101076	1573	2019267000000
101077	1573	2019279000000
101089	1397	1309457080000
101090	1678	23760768020000
101103	1397	1309437078000
101104	1678	23760768022000
101105	2133	94442318000
101106	1874	18431000
101107	2134	87141710000
101108	1874	18434000
101131	1419	13968152560130
101132	1419	13968164560130
100362	1874	17952000
100363	1874	17954000
100364	2134	87219944000
100365	1874	17966000
100366	1874	17968000
100367	1402	83376751319298
100368	1402	83376780319298
100386	1397	1310197154000
100387	1678	23760767946000
100388	2133	94519472000
100389	1874	18052000
100390	2134	87216935000
100391	1874	18055000
100392	1719	5040155000000
100393	1719	5040167000000
100396	1700	3834167979053
100400	1397	1310187153000
100401	1678	23760767947000
100402	1422	18865287860211
100403	2133	94518470000
100404	1874	18057000
100405	1422	19585287860211
100406	1422	19585288860211
100417	1397	1310167151000
100418	1678	23760767949000
100419	1397	1310157150000
100420	1678	23760767950000
100421	2134	87214929000
100422	1874	18065000
100423	2133	94516466000
100424	1874	18067000
100425	2133	94515464000
100426	1874	18069000
100427	2133	94514462000
100428	1874	18071000
100429	2134	87213926000
100430	1874	18074000
100431	2134	87212923000
100432	1874	18077000
100433	1394	537128789500000
100434	1394	537128815500000
100484	1397	1310137148000
100485	1678	23760767952000
100486	1397	1310127147000
100487	1678	23760767953000
100488	2133	94512458000
100489	1874	18084000
100490	2133	94511456000
100491	1874	18086000
100492	2134	87210917000
100493	1874	18089000
100494	2134	87209914000
100495	1874	18092000
100496	1395	58176628906957278
100502	1695	4265154999000
100503	1874	17906000
100504	1874	17912000
100505	1874	17918000
100506	1874	17996000
100507	1874	17999000
100508	1874	18011000
100509	2134	87208911000
100510	1874	18017000
100511	1874	18019000
100512	1874	18023000
100513	1874	18025000
100514	1874	18031000
100515	1874	18037000
100516	1874	18047000
100517	1874	18049000
100518	1874	18061000
100519	1874	18063000
100520	1874	18073000
100521	1874	18075000
100522	1874	18081000
100523	1874	18083000
100524	1874	18085000
100525	1874	18087000
100526	1874	18091000
100527	1874	18093000
100528	1874	18095000
100529	2133	94510454000
100530	1874	18097000
100531	1695	4985154999000
100532	1695	4985450999000
100568	1394	537128813500000
100576	1397	1310067141000
100577	1678	23760767959000
100578	1397	1310057140000
100579	1678	23760767960000
100580	2134	87203896000
100581	1874	18120000
100582	2133	94505444000
100583	1874	18122000
100584	2133	94504442000
100585	1874	18124000
100586	2134	87202893000
100587	1874	18127000
100588	1623	62642995899898
100589	1623	62643019899898
100635	1717	24588388000023
100636	1717	24588412000023
100691	1395	58178068978957278
100719	1718	3138432519070
100720	1718	3138456519070
100721	2134	87183836000
100722	1874	18220000
100723	2134	87182833000
100724	1874	18223000
100725	1637	258486182819988
100726	1637	258486184819988
100739	1397	1309847119000
100740	1678	23760767981000
100741	1397	1309837118000
100742	1678	23760767982000
100743	1397	1309827117000
100744	1678	23760767983000
100745	2133	94483400000
100746	1874	18229000
100747	2133	94482398000
100748	1874	18231000
100749	2133	94481396000
100750	1874	18233000
100751	2134	87181830000
100752	1874	18236000
100753	2134	87180827000
100754	1874	18239000
100755	2134	87179824000
100756	1874	18242000
100757	1474	3790372000043
100779	1397	1309787113000
100780	1678	23760767987000
100781	1874	17787000
100782	1874	17790000
100783	1476	1441045000000
100784	1476	2161045000000
100785	1476	66000007920000
100786	646	2161050010000
100792	1397	1309777112000
100793	1678	23760767988000
100794	2133	94476386000
100795	1874	18261000
100796	2134	87175812000
100797	1874	18264000
100798	1594	5041591000000
100799	1594	5041603000000
100864	1397	1309687103000
100865	1678	23760767997000
100866	2133	94467368000
100867	1874	18306000
100868	2134	87166785000
100869	1874	18309000
100892	1718	3138468519070
100894	1397	1309647099000
100895	1678	23760768001000
100896	2133	94463360000
100897	1874	18326000
100898	2134	87162773000
100899	1874	18329000
100900	1394	540008849500000
100901	1394	540008861500000
100904	1611	3735085000000
100905	1611	3735097000000
100935	1397	1309597094000
100936	1678	23760768006000
100937	2134	87157758000
100938	1874	18352000
100939	2133	94458350000
100940	1874	18354000
100941	1684	7202875219748
100942	1438	99999999
100943	1684	7922775219749
100949	1684	7922875219748
100976	1568	7583944194587
100977	1634	125000
100978	115	273999976
100979	1634	8303944194587
100980	1571	8304154194579
100981	1634	4752105151080
101018	1397	1309547089000
101019	1678	23760768011000
101020	1397	1309537088000
101021	1678	23760768012000
101022	2134	87152743000
101023	1874	18377000
100770	1874	18246000
100771	2133	94478390000
100772	1874	18248000
100773	2134	87178821000
100774	1874	18251000
100775	2134	87177818000
100776	1874	18254000
100777	1693	8821698908632
100778	1693	8821722908632
100809	1448	12276833000001
100810	1448	12276845000001
100830	1555	15315414979096
100831	1555	15315438979096
100835	1397	1309727107000
100836	1678	23760767993000
100837	1397	1309717106000
100838	1678	23760767994000
100839	1397	1309707105000
100840	1678	23760767995000
100841	2133	94471376000
100842	1874	18286000
100843	2133	94470374000
100844	1874	18288000
100845	2134	87170797000
100846	1874	18291000
100847	2134	87169794000
100848	1874	18294000
100849	2134	87168791000
100850	1874	18297000
100851	2133	94469372000
100852	1874	18299000
100853	1688	22319144910040
100856	1692	50181025619999
100913	1397	1309627097000
100914	1678	23760768003000
100915	2134	87160767000
100916	1874	18337000
100917	2133	94461356000
100918	1874	18339000
100946	1874	18351000
100947	1681	7091159109853
100948	1681	7091160109853
100951	1634	6863057259504
100952	1874	17365000
100953	1874	17368000
100954	1874	17373000
100955	1874	17377000
100956	1874	17382000
100957	1874	17388000
100958	1874	17391000
100959	1874	17394000
100960	1874	17397000
100961	1874	17400000
100962	1874	17412000
100963	1874	17414000
100964	1874	17416000
100965	1874	17420000
100966	1874	17422000
100967	1874	17424000
100968	1634	7583057259504
100969	2257	7583746219586
100970	1634	200000001
100971	1514	1400000001
100972	2229	9040300
100973	707	66000000050000
100974	435	9000300000000
100975	1571	4752105151072
101004	1397	1309567091000
101005	1678	23760768009000
101006	2133	94455344000
101007	1874	18366000
101008	2134	87154749000
101009	1874	18369000
101012	1397	1309557090000
101013	1678	23760768010000
101014	2134	87153746000
101015	1874	18372000
101016	2133	94454342000
101017	1874	18374000
101052	1637	259206194819988
101053	1637	259206206819988
101062	1397	1309487083000
101063	1678	23760768017000
101064	2133	94447328000
101065	1874	18406000
101066	2134	87146725000
101067	1874	18409000
101068	1740	8370683000000
101069	1740	8370695000000
101091	1394	541448861500000
101092	1394	541448873500000
101095	1397	1309447079000
101096	1678	23760768021000
101097	2133	94443320000
101098	1874	18426000
101099	2134	87142713000
101100	1874	18429000
101101	1423	1440582750023
101102	1423	1440604750023
101124	1397	1309407075000
101125	1678	23760768025000
101126	2134	87138701000
101127	1874	18447000
101128	2133	94439312000
101129	1874	18449000
101130	1688	22319120910040
101133	1723	24119620085979
101134	1723	24119632085979
101186	1397	1309377072000
101187	1678	23760768028000
101188	1397	1309367071000
101189	1678	23760768029000
101190	2133	94436306000
101191	1874	18461000
101192	2133	94435304000
101193	1874	18463000
101194	2134	87135692000
101195	1874	18466000
101196	2134	87134689000
101197	1874	18469000
101198	633	72189348900000
101199	633	72189372900000
101224	2133	94431296000
101225	1874	18486000
101226	1690	154805306000000
101257	1397	1309287063000
101258	1678	23760768037000
101259	1397	1309277062000
101260	1678	23760768038000
101261	2134	87126665000
101262	1874	18507000
101263	2134	87125662000
101264	1874	18510000
101265	2133	94427288000
101266	1874	18512000
101267	2133	94426286000
101268	1874	18514000
101270	1397	1309267061000
101271	1678	23760768039000
101272	1397	1309257060000
101273	1678	23760768040000
101274	1397	1309247059000
101275	1678	23760768041000
101276	1397	1309237058000
101277	1678	23760768042000
101278	1397	1309227057000
101279	1678	23760768043000
101280	1397	1309217056000
101281	1678	23760768044000
101282	1397	1309207055000
101283	1678	23760768045000
101284	2134	87124659000
101285	1874	18517000
101286	2134	87123656000
101287	1874	18520000
101288	2134	87122653000
101289	1874	18523000
101290	2134	87121650000
101291	1874	18526000
101292	2134	87120647000
101293	1874	18529000
101294	2134	87119644000
101295	1874	18532000
101296	2134	87118641000
101297	1874	18535000
101298	2133	94425284000
101299	1874	18537000
101300	2133	94424282000
101301	1874	18539000
101302	2133	94423280000
101303	1874	18541000
101304	2133	94422278000
101305	1874	18543000
101306	2133	94421276000
101307	1874	18545000
101308	2133	94420274000
101309	1874	18547000
101310	2133	94419272000
101311	1874	18549000
101312	1686	6871801700122
101313	1686	6871885700122
101330	2039	5659336000000
101343	1397	1309157050000
101344	1678	23760768050000
101345	2133	94415264000
100927	1397	1309607095000
100928	1678	23760768005000
100929	2133	94459352000
100930	1874	18346000
100931	2134	87158761000
100932	1874	18349000
100933	1693	9541722908632
100934	1693	9541734908632
100944	1681	6371171109853
100945	1681	7091171109853
100984	1397	1309587093000
100985	1678	23760768007000
100986	1397	1309577092000
100987	1678	23760768008000
100988	2134	87156755000
100989	1874	18357000
100990	2134	87155752000
100991	1874	18360000
100992	2133	94457348000
100993	1874	18362000
100994	2133	94456346000
100995	1874	18364000
100996	1471	4985202900000
100997	1874	18340000
100998	1874	18345000
100999	1874	18348000
101000	1874	18356000
101001	1874	18358000
101002	1749	11525479930000
101003	1749	12245479930000
101044	1397	1309507085000
101045	1678	23760768015000
101046	2133	94449332000
101047	1874	18396000
101048	2134	87148731000
101049	1874	18399000
101050	1395	58179508953957278
101051	1395	58179508965957278
101054	1397	1309497084000
101055	1678	23760768016000
101056	2134	87147728000
101057	1874	18402000
101058	2133	94448330000
101059	1874	18404000
101060	1608	5898350000000
101061	1608	5898362000000
101078	1397	1309467081000
101079	1678	23760768019000
101080	2134	87144719000
101081	1874	18417000
101082	2133	94445324000
101083	1874	18419000
101123	1691	25163518100019
101178	1397	1309387073000
101179	1678	23760768027000
101180	2134	87136695000
101181	1874	18457000
101182	2133	94437308000
101183	1874	18459000
101184	1693	10261734908632
101185	1693	10261746908632
101210	1397	1309347069000
101211	1678	23760768031000
101212	2133	94433300000
101213	1874	18476000
101214	2134	87132683000
101215	1874	18479000
101216	1992	6480572990000
101217	1397	1309337068000
101218	1678	23760768032000
101219	2134	87131680000
101220	1874	18482000
101221	2133	94432298000
101222	1874	18484000
101223	1684	7922863219748
101244	1397	1309307065000
101245	1678	23760768035000
101246	1397	1309297064000
101247	1678	23760768036000
101248	2133	94429292000
101249	1874	18496000
101250	2133	94428290000
101251	1874	18498000
101252	2134	87128671000
101253	1874	18501000
101254	2134	87127668000
101255	1874	18504000
101256	1587	4320146000000
101269	1762	4245330994000
101320	1397	1309187053000
101321	1678	23760768047000
101322	2134	87116635000
101323	1874	18557000
101324	2133	94417268000
101325	1874	18559000
101329	1702	2880474000000
101390	1397	1309097044000
101391	1678	23760768056000
101392	2134	87108611000
101393	1874	18597000
101394	2133	94409252000
101395	1874	18599000
101396	1395	58180948977957278
101397	1395	58180948989957278
101024	2134	87151740000
101025	1874	18380000
101026	2133	94453340000
101027	1874	18382000
101028	2133	94452338000
101029	1874	18384000
101084	2133	94444322000
101085	1874	18421000
101086	2134	87143716000
101087	1874	18424000
101088	1671	4703870003785
101093	1637	259926206819988
101094	1637	259926218819988
101109	1397	1309427077000
101110	1678	23760768023000
101111	1397	1309417076000
101112	1678	23760768024000
101113	2133	94441316000
101114	1874	18436000
101115	2134	87140707000
101116	1874	18439000
101117	2134	87139704000
101118	1874	18442000
101119	2133	94440314000
101120	1874	18444000
101121	1457	27984617040000
101122	1457	27984641040000
101326	1447	22473745943000
101348	1637	260646218819988
101349	1637	260646229819988
101359	1397	1309137048000
101360	1678	23760768052000
101361	2134	87112623000
101362	1874	18577000
101363	2133	94413260000
101364	1874	18579000
101365	1395	58180228965957278
101366	1395	58180228977957278
101382	1397	1309107045000
101383	1678	23760768055000
101384	2134	87109614000
101385	1874	18592000
101386	2133	94410254000
101387	1874	18594000
101388	1692	51621037619999
101389	1692	51621049619999
101398	1637	262086255819988
101399	1637	262086267819988
101135	1397	1309397074000
101136	1678	23760768026000
101137	2133	94438310000
101138	1874	18451000
101139	2134	87137698000
101140	1874	18454000
101141	1649	5512449999992
101142	1649	5512461999992
101143	1701	4318408500103
101144	1874	18103000
101145	1874	18106000
101146	1874	18112000
101147	1874	18115000
101148	1874	18118000
101149	1874	18121000
101150	1874	18130000
101151	1874	18133000
101152	1874	18136000
101153	1874	18142000
101154	1874	18145000
101155	1874	18148000
101156	1874	18151000
101157	1874	18154000
101158	1874	18163000
101159	1874	18166000
101160	1874	18172000
101161	1874	18175000
101162	1874	18178000
101163	1874	18184000
101164	1874	18187000
101165	1874	18190000
101166	1874	18193000
101167	1874	18196000
101168	1874	18202000
101169	1874	18205000
101170	1874	18208000
101171	1874	18211000
101172	1874	18214000
101173	1874	18226000
101174	1874	18228000
101175	1701	5038408500103
101176	1571	5039178500095
101177	1701	4752105151488
101200	1718	3858456519070
101201	1718	3858480519070
101202	1397	1309357070000
101203	1678	23760768030000
101204	2134	87133686000
101205	1874	18472000
101206	2133	94434302000
101207	1874	18474000
101208	1692	50901025619999
101209	1692	50901037619999
101227	1397	1309327067000
101228	1678	23760768033000
101229	1397	1309317066000
101230	1678	23760768034000
101231	1458	8585116908540
101232	1932	1362904664093
101233	602	66010000000000
101234	2133	94430294000
101235	1874	18488000
101236	2134	87130677000
101237	1874	18491000
101238	2134	87129674000
101239	1874	18494000
101240	1458	9305116908540
101241	1458	9305121908540
101242	1690	154805309000000
101243	1690	155525309000000
101314	1397	1309197054000
101315	1678	23760768046000
101316	2134	87117638000
101317	1874	18552000
101318	2133	94418270000
101319	1874	18554000
101327	2039	5659325000000
101328	2039	5659337000000
101331	1397	1309177052000
101332	1678	23760768048000
101333	1397	1309167051000
101334	1678	23760768049000
101335	2133	94416266000
101336	1874	18561000
101337	2134	87115632000
101338	1874	18564000
101339	2134	87114629000
101340	1874	18567000
101341	1705	10640594580140
101342	1705	10640617580140
101350	1601	9253664620000
101351	1397	1309147049000
101352	1678	23760768051000
101353	2133	94414262000
101354	1874	18571000
101355	2134	87113626000
101356	1874	18574000
101401	1397	1309087043000
101402	1678	23760768057000
101403	2134	87107608000
101404	1874	18602000
101405	2133	94408250000
101406	1874	18604000
101407	1686	7591897700122
101346	1874	18569000
101347	1394	541448872500000
101357	111	71760077000000
101358	111	71760089000000
101367	1397	1309127047000
101368	1678	23760768053000
101369	1397	1309117046000
101370	1678	23760768054000
101371	1932	1362902664093
101372	2133	94412258000
101373	1874	18581000
101374	2133	94411256000
101375	1874	18583000
101376	2134	87111620000
101377	1874	18586000
101378	2134	87110617000
101379	1874	18589000
101380	1637	261366229819988
101381	1637	261366255819988
101400	1686	7591885700122
101408	1397	1309077042000
101409	1678	23760768058000
101410	1397	1309067041000
101411	1678	23760768059000
101412	1397	1309057040000
101413	1678	23760768060000
101414	2133	94407248000
101415	1874	18606000
101416	2133	94406246000
101417	1874	18608000
101418	2133	94405244000
101419	1874	18610000
101420	2134	87106605000
101421	1874	18613000
101422	2134	87105602000
101423	1874	18616000
101424	2134	87104599000
101425	1874	18619000
101426	1394	541448897500000
101427	1756	6320764195609
101428	1756	6320800195609
101429	1397	1309047039000
101430	1678	23760768061000
101431	1397	1309037038000
101432	1678	23760768062000
101433	2134	87103596000
101434	1874	18622000
101435	2134	87102593000
101436	1874	18625000
101437	2133	94404242000
101438	1874	18627000
101439	2133	94403240000
101440	1874	18629000
101441	1688	23039132910040
101442	1688	23039156910040
101443	1397	1309027037000
101444	1678	23760768063000
101445	1397	1309017036000
101446	1678	23760768064000
101447	2133	94402238000
101448	1874	18631000
101449	2134	87101590000
101450	1874	18634000
101451	2133	94401236000
101452	1874	18636000
101453	2134	87100587000
101454	1874	18639000
101455	1394	542888897500000
101456	1394	542888921500000
101457	1397	1309007035000
101458	1678	23760768065000
101459	1397	1308997034000
101460	1678	23760768066000
101461	1397	1308987033000
101462	1678	23760768067000
101463	2133	94400234000
101464	1874	18641000
101465	2133	94399232000
101466	1874	18643000
101467	2133	94398230000
101468	1874	18645000
101469	2134	87099584000
101470	1874	18648000
101471	2134	87098581000
101472	1874	18651000
101473	2134	87097578000
101474	1874	18654000
101475	1394	544328921500000
101476	1394	544328957500000
101477	1693	10981746908632
101478	1693	10981782908632
101479	1692	52341049619999
101480	1692	52341085619999
101481	1714	6045492171760
101482	1714	6045528171760
101483	1397	1308977032000
101484	1678	23760768068000
101485	2133	94397228000
101486	1874	18656000
101487	2134	87096575000
101488	1874	18659000
101489	1688	23759156910040
101490	1688	23759168910040
101491	1692	53061085619999
101492	1692	53061097619999
101493	1397	1308967031000
101494	1678	23760768069000
101495	2134	87095572000
101496	1874	18662000
101497	2133	94396226000
101498	1874	18664000
101499	1679	9358531654000
101500	1610	4320082999950
101501	1610	4320094999950
101502	1688	24479168910040
101503	1688	24479180910040
101504	2039	6379337000000
101505	2039	6379349000000
101506	1724	23697695500000
101507	1724	23697707500000
101508	1724	23697699500000
101509	1874	18658000
101510	1874	18661000
101511	2039	6379361000000
101512	484	68973814000000
101513	1397	1308957030000
101514	1678	23760768070000
101515	1397	1308947029000
101516	1678	23760768071000
101517	2133	94395224000
101518	1874	18666000
101519	2133	94394222000
101520	1874	18668000
101521	2134	87094569000
101522	1874	18671000
101523	2134	87093566000
101524	1874	18674000
101525	1874	18667000
101526	1874	18670000
101527	1699	2880318750126
101528	1699	2880340750126
101529	1768	6226556110000
101530	1397	1308937028000
101531	1678	23760768072000
101532	2134	87092563000
101533	1874	18677000
101534	2133	94393220000
101535	1874	18679000
101536	1522	4363518000000
101537	1522	4363530000000
101538	1675	6764184999977
101539	1675	6764196999977
101540	1718	3858468519070
101541	1522	3644258000000
101542	1522	4364258000000
101543	1522	4364868000000
101544	1541	1442061000000
101545	1397	1308927027000
101546	1678	23760768073000
101547	1397	1308917026000
101548	1678	23760768074000
101549	2133	94392218000
101550	1874	18681000
101551	2133	94391216000
101552	1874	18683000
101553	2134	87091560000
101554	1874	18686000
101555	2134	87090557000
101556	1874	18689000
101557	1619	2160014000000
101558	1619	2160038000000
101559	1397	1308907025000
101560	1678	23760768075000
101561	2133	94390214000
101562	1874	18691000
101563	2134	87089554000
101564	1874	18694000
101565	1613	22248207600000
101566	1613	22248219600000
101567	1397	1308897024000
101568	1678	23760768076000
101569	2134	87088551000
101570	1874	18697000
101571	2133	94389212000
101572	1874	18699000
101573	1422	20305288860211
101574	1422	20305300860211
101611	1395	58181668989957278
101612	1395	58181669001957278
101629	1397	1308817016000
101630	1678	23760768084000
101631	2134	87081530000
101632	1874	18734000
101633	2133	94381196000
101634	1874	18736000
101635	1768	6946556110000
101636	1768	6946568110000
101653	1673	32725668000000
101654	1673	32725680000000
101694	1397	1308787013000
101695	1678	23760768087000
101696	2134	87078521000
101697	1874	18749000
101698	2133	94378190000
101699	1874	18751000
101700	1457	28704641040000
101701	1457	28704653040000
101718	1397	1308757010000
101719	1678	23760768090000
101720	1397	1308747009000
101721	1678	23760768091000
101722	2133	94375184000
101723	1874	18763000
101724	2133	94374182000
101725	1874	18765000
101726	369	71556064190850
101727	2134	87075512000
101728	1874	18768000
101729	2134	87074509000
101730	1874	18771000
101731	2248	6479383000000
101732	2248	6479408000000
101741	1444	5847676329999
101742	1444	5847688329999
101751	1419	13248162560130
101752	1874	18779000
101753	1419	13968162560130
101754	1419	13968163560130
101761	1397	1308707005000
101762	1678	23760768095000
101763	2134	87070497000
101764	1874	18789000
101765	2039	6379348000000
101769	1397	1308697004000
101770	1678	23760768096000
101771	2134	87069494000
101772	1874	18792000
101773	1874	18794000
101774	2133	94369172000
101775	1874	18796000
101776	1394	548648969500000
101777	1394	548648982500000
101780	1559	20842918000000
101790	1458	10025121908540
101791	1458	10025133908540
101807	1397	1308657000000
101808	1678	23760768100000
101809	2134	87065482000
101810	1874	18814000
101811	2133	94365164000
101812	1874	18816000
101820	1724	15296685500000
101821	1303	1710570985351650
101822	1724	11211675500000
101823	1057	909797285400000
101824	1724	8454665500000
101825	1177	613859313200000
101826	1724	6174655500000
101827	937	507702913800000
101828	2132	148017018000
101829	1874	18820000
101830	2134	87063476000
101831	1874	18823000
101832	2134	87062473000
101833	1874	18826000
101834	1394	550088982500000
101835	1394	550089025500000
101870	1724	14576661500000
101871	1724	10491651500000
101872	1724	7734641500000
101873	1724	5454631500000
101874	1678	23040757944000
101875	1678	23040757945000
101876	1670	1442650000000
101877	1678	23040757946000
101878	1678	23040757947000
101879	1678	23040757948000
101880	1678	23040757949000
101881	1678	23040757950000
101882	1678	23040757951000
101883	1678	23040757952000
101884	1678	23040757953000
101885	1678	23040757954000
101886	1678	23040757955000
101887	1678	23040757956000
101888	1678	23040757957000
101889	1678	23040757958000
101890	1678	23040757959000
101891	1678	23040757960000
101892	1678	23040757961000
101893	1678	23040757962000
101894	1678	23040757963000
101895	1670	2162650000000
101896	1670	2162830000000
101897	1397	1308586993000
101898	1678	23760768107000
101899	1397	1308576992000
101900	1678	23760768108000
101901	1397	1308566991000
101902	1678	23760768109000
101903	2133	94358150000
101904	1874	18847000
101905	2134	87059464000
101906	1874	18850000
101907	2133	94357148000
101908	1874	18852000
101909	2133	94356146000
101910	1874	18854000
101911	2134	87058461000
101912	1874	18857000
101913	2134	87057458000
101914	1874	18860000
101915	1694	7018796197225
101916	1694	7018832197225
102013	1397	1308436978000
102014	1678	23760768122000
102015	2133	94343120000
102016	1874	18926000
102017	2134	87044419000
102018	1874	18929000
102019	1724	6894655500000
102020	1724	6894667500000
102041	1594	6481615000000
102042	1594	6481627000000
102080	1397	1308356970000
102081	1678	23760768130000
102082	2134	87036395000
102083	1874	18969000
102084	2133	94335104000
102085	1874	18971000
102086	2132	148009010000
102087	1874	18972000
102088	1587	5040146000000
102089	1587	5040159000000
102106	1694	7738832197225
102107	1694	7738856197225
102117	369	69395980190850
102118	43	86881279890000
102119	43	86881328890000
102134	1746	12754456000000
102135	1746	12754498000000
102153	1397	1308286963000
102154	1678	23760768137000
102155	2133	94328090000
102156	1874	19003000
102157	2134	87030377000
102158	1874	19006000
102159	1706	6762016450256
102160	1706	6762028450256
102162	1397	1308276962000
102163	1678	23760768138000
102164	2133	94327088000
102165	1874	19008000
102166	2134	87029374000
102167	1874	19011000
102168	1395	58182389023957278
102215	1397	1308246959000
102216	1678	23760768141000
102217	2134	87026365000
102218	1874	19023000
102219	1613	22968219600000
102220	1613	22968242600000
102228	1518	10800431000000
102232	1474	4510372000043
102233	1474	4510397000043
102241	1692	54501110619999
102242	1692	54501122619999
102292	1397	1308176952000
102293	1678	23760768148000
102294	2133	94316066000
101575	1623	63363019899898
101576	1623	63363031899898
101591	1397	1308867021000
101592	1678	23760768079000
101593	1397	1308857020000
101594	1678	23760768080000
101595	2133	94386206000
101596	1874	18708000
101597	2134	87086545000
101598	1874	18711000
101599	2133	94385204000
101600	1874	18713000
101601	2134	87085542000
101602	1874	18716000
101603	369	80772327412810
101604	369	80772351412810
101616	1397	1308837018000
101617	1678	23760768082000
101618	1397	1308827017000
101619	1678	23760768083000
101620	2134	87083536000
101621	1874	18724000
101622	2134	87082533000
101623	1874	18727000
101624	2133	94383200000
101625	1874	18729000
101626	2133	94382198000
101627	1874	18731000
101628	1394	544328945500000
101704	1397	1308777012000
101705	1678	23760768088000
101706	2133	94377188000
101707	1874	18753000
101708	2134	87077518000
101709	1874	18756000
101710	1623	64083031899898
101711	1623	64083043899898
101733	1397	1308737008000
101734	1678	23760768092000
101735	2134	87073506000
101736	1874	18774000
101737	2133	94373180000
101738	1874	18776000
101739	1688	25919191910040
101740	1688	25919203910040
101743	1555	15315426979096
101783	1541	1442062000000
101801	1397	1308667001000
101802	1678	23760768099000
101803	2133	94366166000
101804	1874	18808000
101805	2134	87066485000
101806	1874	18811000
101917	1397	1308556990000
101918	1678	23760768110000
101919	2133	94355144000
101920	1874	18862000
101921	2134	87056455000
101922	1874	18865000
101923	2132	148015016000
101924	1874	18866000
101925	1638	720013000000
101940	1397	1308526987000
101941	1678	23760768113000
101942	2132	148014015000
101943	1874	18877000
101944	2134	87053446000
101945	1874	18880000
101946	2133	94352138000
101947	1874	18882000
101948	1611	4455097000000
101949	1611	4455110000000
101952	1397	1308516986000
101953	1678	23760768114000
101954	2134	87052443000
101955	1874	18885000
101956	1394	551528993500000
101957	1394	551529004500000
101958	1397	1308506985000
101959	1678	23760768115000
101960	1397	1308496984000
101961	1678	23760768116000
101962	1397	1308486983000
101963	1678	23760768117000
101964	1397	1308476982000
101965	1678	23760768118000
101966	2133	94351136000
101967	1874	18887000
101968	2132	148013014000
101969	1874	18888000
101970	2133	94350134000
101971	1874	18890000
101972	2134	87051440000
101973	1874	18893000
101974	2134	87050437000
101975	1874	18896000
101976	2134	87049434000
101977	1874	18899000
101978	2134	87048431000
101979	1874	18902000
101980	2133	94349132000
101981	1874	18904000
101982	2133	94348130000
101983	1874	18906000
101984	2133	94347128000
101985	1874	18908000
101986	1980	19439496000000
102005	1397	1308446979000
102006	1678	23760768121000
102007	2133	94344122000
102008	1874	18921000
102009	2134	87045422000
102010	1874	18924000
102011	1623	64803043899898
102012	1623	64803055899898
102072	1397	1308366971000
102073	1678	23760768129000
102074	2133	94336106000
102075	1874	18963000
102076	2134	87037398000
102077	1874	18966000
102078	1679	10078531654000
102079	1679	10078543654000
102108	1397	1308326967000
102109	1678	23760768133000
102110	2133	94332098000
102111	1874	18984000
102112	2134	87033386000
102113	1874	18987000
102114	2132	148008009000
102115	1874	18988000
102116	43	86161021890000
102120	1654	15750361999798
102121	1340	1708727510151650
102122	1397	1308316966000
102123	1678	23760768134000
102124	1654	11337351999798
102125	1094	908818024600000
102126	1654	8359341999798
102127	1214	613198226800000
102128	2134	87032383000
102129	1874	18991000
102130	2133	94331096000
102131	1874	18993000
102132	1394	552969004500000
102133	1394	552969046500000
102138	1747	9376974000000
102161	1706	6762018450256
102221	1874	19018000
102222	1874	19021000
102223	1874	19024000
102224	2133	94324082000
102225	1874	19026000
102226	1874	19027000
102227	1613	22968244600000
102229	1874	19025000
102230	1690	156965603000000
102231	1690	156965615000000
102234	1397	1308236958000
102235	1678	23760768142000
102236	2133	94323080000
102237	1874	19029000
102238	2134	87025362000
102239	1874	19032000
102240	1394	552969016500000
102300	1397	1308166951000
102301	1678	23760768149000
102302	2133	94315064000
102303	1874	19071000
102304	2134	87017338000
102305	1874	19074000
102306	2132	148003004000
102307	1874	19075000
102308	1696	28577697335104
102309	1696	28577710335104
102337	1397	1308126947000
102338	1678	23760768153000
102339	2133	94311056000
102340	1874	19093000
102341	2134	87013326000
102342	1874	19096000
102387	1397	1308056940000
102388	1678	23760768160000
102389	1723	15683622085979
102390	1366	1711789637751650
101577	1397	1308887023000
101578	1678	23760768077000
101579	2134	87087548000
101580	1874	18702000
101581	2133	94388210000
101582	1874	18704000
101583	1594	5761603000000
101584	1594	5761615000000
101605	1397	1308847019000
101606	1678	23760768081000
101607	2133	94384202000
101608	1874	18718000
101609	2134	87084539000
101610	1874	18721000
101645	1397	1308797014000
101646	1678	23760768086000
101647	2134	87079524000
101648	1874	18744000
101649	2133	94379192000
101650	1874	18746000
101651	1394	545768945500000
101652	1394	545768957500000
101655	1701	5039208500095
101656	1874	18230000
101657	1874	18232000
101658	1874	18234000
101659	1874	18238000
101660	1874	18240000
101661	1874	18250000
101662	1874	18252000
101663	1874	18256000
101664	1874	18258000
101665	1874	18260000
101666	1874	18262000
101667	1874	18266000
101668	1874	18268000
101669	1874	18270000
101670	1874	18272000
101671	1874	18276000
101672	1874	18278000
101673	1874	18280000
101674	1874	18290000
101675	1874	18292000
101676	1874	18296000
101677	1874	18298000
101678	1874	18300000
101679	1874	18302000
101680	1874	18308000
101681	1874	18310000
101682	1874	18312000
101683	1874	18320000
101684	1874	18322000
101685	1874	18328000
101686	1874	18330000
101687	1874	18332000
101688	1874	18336000
101689	1874	18338000
101690	1874	18350000
101691	1701	5759208500095
101692	1571	5759845500087
101693	1701	4752105151496
101712	1397	1308767011000
101713	1678	23760768089000
101714	2134	87076515000
101715	1874	18759000
101716	2133	94376186000
101717	1874	18761000
101744	1397	1308727007000
101745	1678	23760768093000
101746	2133	94372178000
101747	1874	18778000
101748	2134	87072503000
101749	1874	18781000
101750	1679	9358529654000
101779	1448	12276846000001
101784	1397	1308687003000
101785	1678	23760768097000
101786	2134	87068491000
101787	1874	18799000
101788	2133	94368170000
101789	1874	18801000
101792	1397	1308677002000
101793	1678	23760768098000
101794	2134	87067488000
101795	1874	18804000
101796	2133	94367168000
101797	1874	18806000
101798	1440	2880166045924
101799	1440	2880178045924
101815	1397	1308646999000
101816	1678	23760768101000
101817	2134	87064479000
101818	1874	18819000
101819	484	68973825000000
101852	1397	1308606995000
101853	1678	23760768105000
101854	2134	87061470000
101855	1874	18837000
101856	1394	550088993500000
101926	1397	1308546989000
101927	1678	23760768111000
101928	2134	87055452000
101929	1874	18869000
101950	1690	156245318000000
101951	1690	156245331000000
101987	1685	146883350571430
101994	1397	1308456980000
101995	1678	23760768120000
101996	2132	148012013000
101997	1874	18914000
101998	2133	94345124000
101999	1874	18916000
102000	2134	87046425000
102001	1874	18919000
102002	1850	7176224949999
102003	1850	7176237949999
102033	1397	1308416976000
102034	1678	23760768124000
102035	2133	94341116000
102036	1874	18937000
102037	2134	87042413000
102038	1874	18940000
102039	1395	58182389001957278
102040	1395	58182389013957278
102043	1550	1440010000000
102044	1550	1440022000000
102045	1397	1308406975000
102046	1678	23760768125000
102047	1397	1308396974000
102048	1678	23760768126000
102049	1397	1308386973000
102050	1678	23760768127000
102051	2132	148010011000
102052	1874	18941000
102053	2133	94340114000
102054	1874	18943000
102055	2133	94339112000
102056	1874	18945000
102057	2133	94338110000
102058	1874	18947000
102059	2134	87041410000
102060	1874	18950000
102061	2134	87040407000
102062	1874	18953000
102063	2134	87039404000
102064	1874	18956000
102065	1656	6475343999990
102092	1397	1308346969000
102093	1678	23760768131000
102094	1397	1308336968000
102095	1678	23760768132000
102096	2134	87035392000
102097	1874	18975000
102098	2134	87034389000
102099	1874	18978000
102100	2133	94334102000
102101	1874	18980000
102102	2133	94333100000
102103	1874	18982000
102104	1679	10798543654000
102105	1679	10798567654000
102139	1673	32725710000000
102140	1397	1308306965000
102141	1678	23760768135000
102142	1397	1308296964000
102143	1678	23760768136000
102144	2134	87031380000
102145	1874	18996000
102146	2132	148007008000
102147	1874	18997000
102148	2133	94330094000
102149	1874	18999000
102150	2133	94329092000
102151	1874	19001000
102152	1637	262086279819988
102177	1654	5897331999798
102178	974	507156496200000
102179	1397	1308256960000
102180	1678	23760768140000
102181	1874	18923000
102182	1874	18933000
102183	1874	18934000
102184	1874	18936000
102185	1874	18938000
102186	1874	18942000
101585	1397	1308877022000
101586	1678	23760768078000
101587	2133	94387208000
101588	1874	18706000
101589	1688	25199180910040
101590	1688	25199191910040
101613	1394	544328933500000
101614	1690	155525306000000
101615	1690	155525318000000
101637	1397	1308807015000
101638	1678	23760768085000
101639	2133	94380194000
101640	1874	18738000
101641	2134	87080527000
101642	1874	18741000
101643	1573	2739279000000
101644	1573	2739291000000
101702	1394	547208957500000
101703	1394	547208969500000
101755	1397	1308717006000
101756	1678	23760768094000
101757	2134	87071500000
101758	1874	18784000
101759	2133	94371176000
101760	1874	18786000
101766	2133	94370174000
101767	1874	18788000
101768	1874	18791000
101778	2106	5039096000000
101781	1718	4578468519070
101782	1718	4578481519070
101800	1440	2880176045924
101813	1672	2881238000000
101814	1672	2881250000000
101836	1397	1308636998000
101837	1678	23760768102000
101838	1397	1308626997000
101839	1678	23760768103000
101840	1397	1308616996000
101841	1678	23760768104000
101842	2133	94364162000
101843	1874	18828000
101844	2133	94363160000
101845	1874	18830000
101846	2133	94362158000
101847	1874	18832000
101848	2133	94361156000
101849	1874	18834000
101850	1654	24045294999798
101851	1654	24045371999798
101857	2133	94360154000
101858	1874	18836000
101859	1874	18839000
101860	1601	9253665620000
101861	1397	1308596994000
101862	1678	23760768106000
101863	2132	148016017000
101864	1874	18840000
101865	2134	87060467000
101866	1874	18843000
101867	2133	94359152000
101868	1874	18845000
101869	1670	1440819000000
101930	1397	1308536988000
101931	1678	23760768112000
101932	2133	94354142000
101933	1874	18871000
101934	2133	94353140000
101935	1874	18873000
101936	2134	87054449000
101937	1874	18876000
101938	1698	5108783550062
101939	1698	5108796550062
101988	1397	1308466981000
101989	1678	23760768119000
101990	2133	94346126000
101991	1874	18910000
101992	2134	87047428000
101993	1874	18913000
102004	1850	7046224949999
102021	1706	6042004450256
102022	1706	6042016450256
102023	1397	1308426977000
102024	1678	23760768123000
102025	2133	94342118000
102026	1874	18931000
102027	2132	148011012000
102028	1874	18932000
102029	2134	87043416000
102030	1874	18935000
102031	1692	53781097619999
102032	1692	53781110619999
102066	1397	1308376972000
102067	1678	23760768128000
102068	2134	87038401000
102069	1874	18959000
102070	2133	94337108000
102071	1874	18961000
102090	1874	18970000
102091	1587	5040158000000
102136	2292	719000000000
102137	2292	719042000000
102169	1397	1308266961000
102170	1678	23760768139000
102171	2133	94326086000
102172	1874	19013000
102173	2134	87028371000
102174	1874	19016000
102175	1688	26639203910040
102176	1688	26639215910040
102243	1397	1308226957000
102244	1678	23760768143000
102245	2132	148005006000
102246	1874	19033000
102247	1555	16035426979096
102248	1555	16035437979096
102282	1397	1308186953000
102283	1678	23760768147000
102284	2133	94317068000
102285	1874	19061000
102286	2134	87019344000
102287	1874	19064000
102288	2112	7200172000000
102289	2112	7200184000000
102334	1980	19439471000000
102371	1397	1308076942000
102372	1678	23760768158000
102373	1397	1308066941000
102374	1678	23760768159000
102375	2133	94306046000
102376	1874	19119000
102377	2133	94305044000
102378	1874	19121000
102379	2132	148000001000
102380	1874	19122000
102381	2134	87008311000
102382	1874	19125000
102383	2134	87007308000
102384	1874	19128000
102385	1593	28630579000000
102386	1593	28630604000000
102399	1397	1308046939000
102400	1678	23760768161000
102401	1723	11196612085979
102402	1120	910446465000000
102403	1397	1308036938000
102404	1678	23760768162000
102405	2133	94303040000
102406	1874	19135000
102407	2133	94302038000
102408	1874	19137000
102409	2134	87005302000
102410	1874	19140000
102411	2134	87004299000
102412	1874	19143000
102413	2132	147999000000
102414	1874	19144000
102415	1705	11360617580140
102416	1705	11360652580140
102470	1723	5664592085979
102471	1000	508063659823781
102472	1397	1307996934000
102473	1678	23760768166000
102474	2134	87000287000
102475	1874	19163000
102476	2133	94298030000
102477	1874	19165000
102478	1395	58183109055957278
102547	1457	29424653040000
102548	1457	29424665040000
102549	1397	1307906925000
102550	1678	23760768175000
102551	2133	94289012000
102552	1874	19209000
102553	2132	147994996000
102554	1874	19210000
102555	2134	86991260000
102556	1874	19213000
102557	1432	1440012000000
102558	1432	1440025000000
102573	1397	1307876922000
102574	1678	23760768178000
102575	1397	1307866921000
102576	1678	23760768179000
102577	2132	147993995000
102187	1874	18944000
102188	1874	18946000
102189	1874	18948000
102190	1874	18949000
102191	2132	148006007000
102192	1874	18951000
102193	1874	18954000
102194	1874	18958000
102195	1874	18960000
102196	1874	18962000
102197	1874	18964000
102198	1874	18968000
102199	2133	94325084000
102200	1874	18974000
102201	1874	18977000
102202	1874	18983000
102203	1874	18986000
102204	1874	18989000
102205	1874	18992000
102206	1874	18995000
102207	1874	18998000
102208	1874	19004000
102209	1874	19007000
102210	1874	19010000
102211	1874	19019000
102212	2134	87027368000
102213	1874	19022000
102214	1690	156245603000000
102249	2133	94322078000
102250	1874	19034000
102251	2134	87024359000
102252	1874	19037000
102253	1555	16035428979096
102254	1397	1308216956000
102255	1678	23760768144000
102256	1397	1308206955000
102257	1678	23760768145000
102258	1397	1308196954000
102259	1678	23760768146000
102260	2134	87023356000
102261	1874	19040000
102262	2134	87022353000
102263	1874	19043000
102264	2134	87021350000
102265	1874	19046000
102266	2134	87020347000
102267	1874	19049000
102268	2133	94321076000
102269	1874	19051000
102270	1686	7591942700122
102271	2133	94320074000
102272	1874	19053000
102273	2133	94319072000
102274	1874	19055000
102275	2133	94318070000
102276	1874	19057000
102277	1874	19058000
102278	2132	148004005000
102279	1874	19059000
102280	1686	8311942700122
102281	1686	8311947700122
102290	1637	262806279819988
102291	1637	262806291819988
102310	1397	1308156950000
102311	1678	23760768150000
102312	2134	87016335000
102313	1874	19078000
102314	2133	94314062000
102315	1874	19080000
102316	1458	10745133908540
102317	1458	10745145908540
102335	676	68160021000000
102336	676	68160046000000
102343	1397	1308116946000
102344	1678	23760768154000
102345	2133	94310054000
102346	1874	19098000
102347	2134	87012323000
102348	1874	19101000
102417	1397	1308026937000
102418	1678	23760768163000
102419	2133	94301036000
102420	1874	19146000
102421	2134	87003296000
102422	1874	19149000
102423	1395	58183109023957278
102424	1395	58183109035957278
102427	1549	30576301000000
102428	1549	30576313000000
102501	1397	1307956930000
102502	1678	23760768170000
102503	1723	5649582085979
102504	723	3031599090000
102505	1397	1307946929000
102506	1678	23760768171000
102507	2133	94294022000
102508	1874	19183000
102509	2134	86996275000
102510	1874	19186000
102511	2134	86995272000
102512	1874	19189000
102513	2133	94293020000
102514	1874	19191000
102515	1850	7176271949999
102516	1850	7896271949999
102537	1397	1307916926000
102538	1678	23760768174000
102539	2134	86992263000
102540	1874	19205000
102541	2133	94290014000
102542	1874	19207000
102543	1395	58184549067957278
102544	1395	58184549079957278
102602	1559	20842929000000
102652	1397	1307776912000
102653	1678	23760768188000
102654	2133	94275986000
102655	1874	19275000
102656	2134	86979224000
102657	1874	19278000
102658	1610	5040106999950
102684	1874	19284000
102685	2049	719013000000
102691	1426	6810308000000
102692	1397	1307736908000
102693	1678	23760768192000
102694	2133	94271978000
102695	1874	19296000
102696	2132	147989991000
102697	1874	19297000
102698	2134	86975212000
102699	1874	19300000
102700	1394	557289040500000
102701	1394	557289053500000
102724	1397	1307696904000
102725	1678	23760768196000
102726	2134	86971200000
102727	1874	19319000
102728	2133	94267970000
102729	1874	19321000
102730	1394	558729053500000
102731	1394	558729065500000
102741	1397	1307676902000
102742	1678	23760768198000
102743	1397	1307666901000
102744	1678	23760768199000
102745	1397	1307656900000
102746	1678	23760768200000
102747	2134	86969194000
102748	1874	19329000
102749	2132	147987989000
102750	1874	19330000
102751	2133	94265966000
102752	1874	19332000
102753	2133	94264964000
102754	1874	19334000
102755	2133	94263962000
102756	1874	19336000
102757	2134	86968191000
102758	1874	19339000
102759	2134	86967188000
102760	1874	19342000
102761	1654	9079341999798
102762	1654	9079378999798
102770	1397	1307646899000
102771	1678	23760768201000
102772	2133	94262960000
102773	1874	19344000
102774	1394	561609065500000
102775	1394	561609076500000
102798	1397	1307616896000
102799	1678	23760768204000
102800	1874	19345000
102801	2133	94259954000
102802	1874	19354000
102803	1874	19357000
102804	2134	86964179000
102805	1874	19360000
102806	2148	2880071880750
102807	2148	2880120880750
102810	2148	2880083880750
102825	1457	29424866040000
102862	1397	1307566891000
102863	1678	23760768209000
102864	2133	94255946000
102295	1874	19066000
102296	2134	87018341000
102297	1874	19069000
102298	1394	554409016500000
102299	1394	554409028500000
102318	1397	1308146949000
102319	1678	23760768151000
102320	1397	1308136948000
102321	1678	23760768152000
102322	2134	87015332000
102323	1874	19083000
102324	2132	148002003000
102325	1874	19084000
102326	2134	87014329000
102327	1874	19087000
102328	2133	94313060000
102329	1874	19089000
102330	2133	94312058000
102331	1874	19091000
102332	1610	5040094999950
102333	1610	5040119999950
102349	1397	1308106945000
102350	1678	23760768155000
102351	1397	1308096944000
102352	1678	23760768156000
102353	1397	1308086943000
102354	1678	23760768157000
102355	2134	87011320000
102356	1874	19104000
102357	2132	148001002000
102358	1874	19105000
102359	2134	87010317000
102360	1874	19108000
102361	2134	87009314000
102362	1874	19111000
102363	2133	94309052000
102364	1874	19113000
102365	2133	94308050000
102366	1874	19115000
102367	2133	94307048000
102368	1874	19117000
102369	1509	23712288351155
102370	1509	23712325351155
102397	1509	24432325351155
102398	1509	24432347351155
102425	1705	12080652580140
102426	1705	12080664580140
102429	604	66714579919853
102430	1723	8168602085979
102431	1240	614296750000000
102432	1397	1308016936000
102433	1678	23760768164000
102434	2134	87002293000
102435	1874	19152000
102436	2133	94300034000
102437	1874	19154000
102438	1679	11518567654000
102439	1679	11518689654000
102457	2133	94299032000
102458	1874	19156000
102459	2134	87001290000
102460	1874	19159000
102461	2132	147997999000
102462	1874	19160000
102463	1696	29297710335104
102464	1696	29297713335104
102468	1740	9090695000000
102469	1740	9090708000000
102517	1397	1307936928000
102518	1678	23760768172000
102519	1723	3601572085979
102520	2293	2047000000000
102521	2134	86994269000
102522	1874	19194000
102523	2133	94292018000
102524	1874	19196000
102525	2132	147995997000
102526	1874	19197000
102527	1637	263526291819988
102528	1637	263526314819988
102545	1394	555849028500000
102546	1394	555849040500000
102565	1397	1307886923000
102566	1678	23760768177000
102567	257	66000000000000
102568	1546	5277318000000
102569	2133	94287008000
102570	1874	19220000
102571	1587	5760159000000
102572	1587	5760180000000
102605	1634	9614154194579
102606	1397	1307836918000
102607	1678	23760768182000
102608	2133	94281998000
102609	1874	19243000
102610	2134	86985242000
102611	1874	19246000
102612	2132	147992994000
102613	1874	19247000
102614	1746	12754469000000
102659	1397	1307766911000
102660	1678	23760768189000
102661	1397	1307756910000
102662	1678	23760768190000
102663	1397	1307746909000
102664	1678	23760768191000
102665	2132	147990992000
102666	1874	19279000
102667	1885	9000000
102668	2133	94274984000
102669	1874	19281000
102670	2133	94273982000
102671	1874	19283000
102672	2133	94272980000
102673	1874	19285000
102674	2134	86978221000
102675	1874	19288000
102676	2134	86977218000
102677	1874	19291000
102678	2134	86976215000
102679	1874	19294000
102680	1850	8616271949999
102681	1850	8616309949999
102686	1874	19287000
102687	1874	19290000
102688	1874	19292000
102689	1395	58184549092957278
102763	1555	16755428979096
102764	2052	10000000
102765	1664	210000142
102766	1527	16755436979105
102767	1555	286999963
102769	1555	16755465979096
102776	1397	1307636898000
102777	1678	23760768202000
102778	2134	86966185000
102779	1874	19347000
102780	2132	147986988000
102781	1874	19348000
102782	2133	94261958000
102783	1874	19350000
102784	1635	11000000
102785	2294	719000000000
102786	1395	58184549081957278
102789	1397	1307626897000
102790	1678	23760768203000
102791	2133	94260956000
102792	1874	19352000
102793	2134	86965182000
102794	1874	19355000
102795	1679	12238689654000
102796	1679	12238701654000
102808	1649	6232461999992
102809	1649	6232473999992
102839	1696	12683606335104
102840	1304	1706115953081650
102841	1509	22243913540403
102842	954	507610345498744
102843	1509	18322338101171
102844	1074	909633389928304
102845	1509	15676340481403
102846	1194	613747773910321
102847	1509	8303211503835
102848	1320	1710262743410446
102849	1397	1307586893000
102850	1678	23760768207000
102851	2294	718998000000
102852	2134	86961170000
102853	1874	19374000
102854	1717	24589000000023
102872	1397	1307556890000
102873	1678	23760768210000
102874	2133	94254944000
102875	1874	19387000
102876	2134	86958161000
102877	1874	19390000
102878	1395	58185269081957278
102879	1395	58185269093957278
102936	1637	264246338819988
102945	1397	1307466881000
102946	1678	23760768219000
102947	2133	94245926000
102948	1874	19434000
102949	2134	86949134000
102950	1874	19437000
102391	2134	87006305000
102392	1874	19131000
102393	2133	94304042000
102394	1874	19133000
102395	1688	27359215910040
102396	1688	27359237910040
102440	1874	19063000
102441	1874	19065000
102442	1690	156965993000000
102443	1874	19067000
102444	1874	19068000
102445	1874	19070000
102446	1874	19073000
102447	1874	19076000
102448	1874	19079000
102449	1874	19082000
102450	1874	19085000
102451	1874	19088000
102452	1874	19094000
102453	1874	19097000
102454	1874	19100000
102455	1690	157685993000000
102456	1690	157686007000000
102465	1397	1308006935000
102466	1678	23760768165000
102467	1696	29297723335104
102479	1397	1307986933000
102480	1678	23760768167000
102481	1397	1307976932000
102482	1678	23760768168000
102483	1397	1307966931000
102484	1678	23760768169000
102485	2132	147996998000
102486	1874	19166000
102487	2134	86999284000
102488	1874	19169000
102489	2133	94297028000
102490	1874	19171000
102491	2133	94296026000
102492	1874	19173000
102493	2133	94295024000
102494	1874	19175000
102495	2134	86998281000
102496	1874	19178000
102497	2134	86997278000
102498	1874	19181000
102499	1474	5230397000043
102500	1474	5230434000043
102529	1397	1307926927000
102530	1678	23760768173000
102531	2133	94291016000
102532	1874	19199000
102533	2134	86993266000
102534	1874	19202000
102535	1395	58183829055957278
102536	1395	58183829067957278
102559	1397	1307896924000
102560	1678	23760768176000
102561	2134	86990257000
102562	1874	19216000
102563	2133	94288010000
102564	1874	19218000
102589	1397	1307856920000
102590	1678	23760768180000
102591	1397	1307846919000
102592	1678	23760768181000
102593	2134	86987248000
102594	1874	19234000
102595	2134	86986245000
102596	1874	19237000
102597	2133	94284002000
102598	1874	19239000
102599	2133	94283000000
102600	1874	19241000
102601	1547	7194733000000
102615	2292	719013000000
102638	1397	1307796914000
102639	1678	23760768186000
102640	1397	1307786913000
102641	1678	23760768187000
102642	2134	86981230000
102643	1874	19266000
102644	2133	94277990000
102645	1874	19268000
102646	2133	94276988000
102647	1874	19270000
102648	2134	86980227000
102649	1874	19273000
102650	1474	5950434000043
102651	1474	5950458000043
102690	1850	8616296949999
102708	1397	1307716906000
102709	1678	23760768194000
102710	1397	1307706905000
102711	1678	23760768195000
102712	2132	147988990000
102713	1874	19306000
102714	2134	86973206000
102715	1874	19309000
102716	2134	86972203000
102717	1874	19312000
102718	2133	94269974000
102719	1874	19314000
102720	2133	94268972000
102721	1874	19316000
102722	1474	6670458000043
102723	1474	6670483000043
102740	1394	560169065500000
102823	1394	563049076500000
102824	1394	563049289500000
102826	1696	23003941195104
102827	1058	907781840850000
102828	1696	20278350325104
102829	1178	615170912210000
102830	1397	1307596894000
102831	1678	23760768206000
102832	2294	718999000000
102833	2134	86962173000
102834	1874	19369000
102835	2133	94257950000
102836	1874	19371000
102837	1611	5175110000000
102838	1611	5175523000000
102896	1991	7101297355805
102897	1991	7101322355805
102906	1397	1307516886000
102907	1678	23760768214000
102908	1397	1307506885000
102909	1678	23760768215000
102910	2134	86954149000
102911	1874	19409000
102912	2133	94250936000
102913	1874	19411000
102914	2134	86953146000
102915	1874	19414000
102916	2132	147982984000
102917	1874	19415000
102918	2133	94249934000
102919	1874	19417000
102920	1395	58185989093957278
102921	1395	58185989118957278
102937	1397	1307476882000
102938	1678	23760768218000
102939	2134	86950137000
102940	1874	19430000
102941	2133	94246928000
102942	1874	19432000
102943	1637	264966338819988
102944	1637	264966350819988
102967	1685	147603350571430
102968	1685	147603374571430
102985	1397	1307436878000
102986	1678	23760768222000
102987	1397	1307426877000
102988	1678	23760768223000
102989	1611	5175543000000
102990	2132	147980982000
102991	1874	19449000
102992	2134	86946125000
102993	1874	19452000
102994	2134	86945122000
102995	1874	19455000
102996	2133	94242920000
102997	1874	19457000
102998	2133	94241918000
102999	1874	19459000
103000	1611	5895543000000
103001	1611	5895548000000
103021	1397	1307396874000
103022	1678	23760768226000
103023	2134	86942113000
103024	1874	19473000
103025	2133	94238912000
103026	1874	19475000
103027	1685	147603362571430
103055	1397	1307356870000
103056	1678	23760768230000
103057	1397	1307346869000
103058	1678	23760768231000
103059	2133	94234904000
103060	1874	19493000
103061	2133	94233902000
103062	1874	19495000
103063	733	2720025000000
103064	640	66720007000000
102578	1874	19221000
102579	2134	86989254000
102580	1874	19224000
102581	2134	86988251000
102582	1874	19227000
102583	2133	94286006000
102584	1874	19229000
102585	2133	94285004000
102586	1874	19231000
102587	1692	55221122619999
102588	1692	55221147619999
102603	1634	9022951259504
102604	1634	9022975259504
102616	1397	1307826917000
102617	1678	23760768183000
102618	1397	1307816916000
102619	1678	23760768184000
102620	1397	1307806915000
102621	1678	23760768185000
102622	2132	147991993000
102623	1874	19248000
102624	2134	86984239000
102625	1874	19251000
102626	2134	86983236000
102627	1874	19254000
102628	2134	86982233000
102629	1874	19257000
102630	2133	94280996000
102631	1874	19259000
102632	2133	94279994000
102633	1874	19261000
102634	2133	94278992000
102635	1874	19263000
102636	641	71763622000000
102637	641	71763659000000
102682	1426	6810283000000
102683	1426	6810321000000
102702	1397	1307726907000
102703	1678	23760768193000
102704	2134	86974209000
102705	1874	19303000
102706	2133	94270976000
102707	1874	19305000
102732	1397	1307686903000
102733	1678	23760768197000
102734	2134	86970197000
102735	1874	19324000
102736	2133	94266968000
102737	1874	19326000
102738	1684	8642875219748
102739	1684	8642887219748
102768	1615	1440057000000
102787	1637	264246314819988
102788	1637	264246328819988
102797	1637	264246326819988
102811	1696	27043433305104
102812	938	507800938770000
102813	1397	1307606895000
102814	1678	23760768205000
102815	2134	86963176000
102816	1874	19363000
102817	2133	94258952000
102818	1874	19365000
102819	2132	147985987000
102820	1874	19366000
102821	1679	12958701654000
102822	1679	12958914654000
102855	1397	1307576892000
102856	1678	23760768208000
102857	2133	94256948000
102858	1874	19376000
102859	2134	86960167000
102860	1874	19379000
102861	1740	9090707000000
102880	1397	1307546889000
102881	1678	23760768211000
102882	1397	1307536888000
102883	1678	23760768212000
102884	2134	86957158000
102885	1874	19393000
102886	2134	86956155000
102887	1874	19396000
102888	2132	147983985000
102889	1874	19397000
102890	2133	94253942000
102891	1874	19399000
102892	2133	94252940000
102893	1874	19401000
102894	484	69693825000000
102895	484	69693850000000
102898	1397	1307526887000
102899	1678	23760768213000
102900	2134	86955152000
102901	1874	19404000
102902	2133	94251938000
102903	1874	19406000
102904	1455	1471527000000
102905	1455	1471539000000
102954	1397	1307456880000
102955	1678	23760768220000
102956	1397	1307446879000
102957	1678	23760768221000
102958	2134	86948131000
102959	1874	19441000
102960	2133	94244924000
102961	1874	19443000
102962	2134	86947128000
102963	1874	19446000
102964	2133	94243922000
102965	1874	19448000
102966	1688	27359239910040
103010	1397	1307406875000
103011	1678	23760768225000
103012	733	3439024000000
103013	640	66001009000000
103014	2132	147979981000
103015	1874	19465000
103016	2134	86943116000
103017	1874	19468000
103018	2133	94239914000
103019	1874	19470000
103020	1394	563049090500000
103036	1397	1307376872000
103037	1678	23760768228000
103038	2134	86940107000
103039	1874	19483000
103040	2133	94236908000
103041	1874	19485000
103042	1594	7201627000000
103043	1594	7201639000000
103154	1397	1307296864000
103155	1678	23760768236000
103156	2134	86932083000
103157	1874	19526000
103158	2133	94228892000
103159	1874	19528000
103160	2134	86931080000
103161	1874	19531000
103162	2133	94227890000
103163	1874	19533000
103164	1679	13678914654000
103165	1679	13678938654000
103187	1397	1307266861000
103188	1678	23760768239000
103189	2134	86928071000
103190	1874	19547000
103191	2133	94224884000
103192	1874	19549000
103193	733	2717775000000
103194	2295	999000000
103195	1768	7666568110000
103196	1768	7666581110000
103303	1397	1307146849000
103304	1678	23760768251000
103305	2134	86917038000
103306	1874	19607000
103307	2132	147971973000
103308	1874	19608000
103309	2134	86916035000
103310	1874	19611000
103311	2133	94212860000
103312	1874	19613000
103313	2134	86915032000
103314	1874	19616000
103315	2133	94211858000
103316	1874	19618000
103317	2133	94210856000
103318	1874	19620000
103319	1599	25540472393047
103320	1599	25540489393047
103353	43	86881033890000
103356	1397	1307116846000
103357	1678	23760768254000
103358	2132	147969971000
103359	1874	19642000
103360	2133	94205846000
103361	1874	19644000
103362	2134	86910017000
103363	1874	19647000
103364	1395	58188149181957278
103369	1874	19537000
103370	1874	19539000
103371	1874	19541000
103372	1874	19545000
103373	1874	19548000
102865	1874	19381000
102866	2134	86959164000
102867	1874	19384000
102868	2132	147984986000
102869	1874	19385000
102870	1471	5705202900000
102871	1471	5705215900000
102922	1397	1307496884000
102923	1678	23760768216000
102924	1397	1307486883000
102925	1678	23760768217000
102926	2133	94248932000
102927	1874	19419000
102928	2133	94247930000
102929	1874	19421000
102930	2134	86952143000
102931	1874	19424000
102932	2134	86951140000
102933	1874	19427000
102934	1555	17475436979105
102935	1555	17475460979105
103002	1397	1307416876000
103003	1678	23760768224000
103004	2133	94240916000
103005	1874	19461000
103006	2134	86944119000
103007	1874	19464000
103008	1698	5828796550062
103009	1698	5828808550062
103044	1397	1307366871000
103045	1678	23760768229000
103046	2134	86939104000
103047	1874	19488000
103048	2133	94235906000
103049	1874	19490000
103050	2132	147978980000
103051	1874	19491000
103052	1688	28079239910040
103053	1688	28079252910040
103071	1397	1307336868000
103072	1678	23760768232000
103073	2133	94232900000
103074	1874	19503000
103075	2134	86936095000
103076	1874	19506000
103077	2132	147977979000
103078	1874	19507000
103079	1394	564489090500000
103080	1394	564489103500000
103109	1756	6323284195609
103110	1397	1307306865000
103111	1678	23760768235000
103112	1740	8370693000000
103113	1874	18777000
103114	1874	18782000
103115	1874	18783000
103116	1874	18785000
103117	1874	18787000
103118	1874	18793000
103119	1874	18795000
103120	1874	18797000
103121	1874	18798000
103122	1874	18807000
103123	1874	18810000
103124	1874	18813000
103125	1874	18818000
103126	1874	18822000
103127	1874	18824000
103128	1874	18825000
103129	1874	18827000
103130	1874	18829000
103131	1874	18831000
103132	1874	18833000
103133	1874	18835000
103134	1874	18838000
103135	1874	18841000
103136	1874	18842000
103137	1874	18844000
103138	1874	18846000
103139	1874	18848000
103140	1874	18849000
103141	1874	18851000
103142	1874	18853000
103143	1874	18855000
103144	1874	18859000
103145	1874	18861000
103146	1874	18863000
103147	1874	18867000
103148	1874	18875000
103149	1874	18879000
103150	1874	18881000
103151	1874	18883000
103152	1756	7043284195609
103153	1756	7043988195609
103185	1692	56661150619999
103186	1692	56661163619999
103197	1397	1307256860000
103198	1678	23760768240000
103199	2133	94223882000
103200	1874	19551000
103201	2134	86927068000
103202	1874	19554000
103203	2112	7920196000000
103237	1397	1307236858000
103238	1678	23760768242000
103239	1397	1307226857000
103240	1678	23760768243000
103241	1397	1307216856000
103242	1678	23760768244000
103243	2134	86925062000
103244	1874	19563000
103245	2133	94221878000
103246	1874	19565000
103247	2133	94220876000
103248	1874	19567000
103249	2132	147973975000
103250	1874	19568000
103251	2134	86924059000
103252	1874	19571000
103253	2134	86923056000
103254	1874	19574000
103255	2133	94219874000
103256	1874	19576000
103257	1395	58187429130957278
103258	1395	58187429167957278
103295	1588	25415564000000
103296	1588	25415600000000
103297	1397	1307156850000
103298	1678	23760768250000
103299	2134	86918041000
103300	1874	19602000
103301	2133	94213862000
103302	1874	19604000
103342	1397	1307126847000
103343	1678	23760768253000
103344	2134	86911020000
103345	1874	19639000
103346	43	86881021890000
103347	43	86881032890000
103354	1749	12245418930000
103367	1874	19645000
103368	1587	6480193000000
103411	1397	1307086843000
103412	1678	23760768257000
103413	1397	1307076842000
103414	1678	23760768258000
103415	2132	147968970000
103416	1874	19658000
103417	2134	86907008000
103418	1874	19661000
103419	2134	86906005000
103420	1874	19664000
103421	1865	199000000
103422	1705	12800664580140
103423	1705	12800688580140
103453	1717	21619243895735
103454	920	507882026116745
103455	1397	1307046839000
103456	1678	23760768261000
103457	1717	16297474321623
103458	1040	910120239268005
103459	1717	12706767093431
103460	1160	614076260860955
103461	1717	2700960000055
103462	1286	1711178101505890
103463	2134	86903999000
103464	1874	19679000
103465	2133	94198832000
103466	1874	19681000
103467	470	72480217000000
103468	470	72480269000000
103471	1397	1307036838000
103472	1678	23760768262000
103473	2133	94197830000
103474	1874	19683000
103475	2134	86902996000
103476	1874	19686000
103477	1705	13520688580140
103478	1705	13520700580140
103484	1705	10640634580140
103514	2039	7819360000000
103515	2039	7819373000000
103516	1397	1307006835000
103517	1678	23760768265000
103518	1397	1306996834000
102951	2132	147981983000
102952	1874	19438000
102953	1522	4363531000000
102969	1696	25603417305104
102970	1696	21563925195104
102971	1696	18838334325104
102972	1696	11243590335104
102973	1509	20803854540403
102974	1756	5601764195609
102975	1509	16882279101171
102976	1509	14236281481403
102977	1509	6863152503835
102978	1654	15030284999798
102979	1546	4557306000000
102980	1654	10617274999798
102981	1654	7639264999798
102982	1654	5177254999798
102983	1756	6321764195609
102984	1756	6323224195609
103028	1397	1307386873000
103029	1678	23760768227000
103030	2134	86941110000
103031	1874	19478000
103032	2133	94237910000
103033	1874	19480000
103034	2039	7099348000000
103035	2039	7099360000000
103054	1613	22968232600000
103081	1637	265686350819988
103082	1637	265686363819988
103168	1397	1307286863000
103169	1678	23760768237000
103170	2133	94226888000
103171	1874	19535000
103172	2134	86930077000
103173	1874	19538000
103174	1395	58186709118957278
103175	1395	58186709130957278
103204	1397	1307246859000
103205	1678	23760768241000
103206	2133	94222880000
103207	1874	19556000
103208	2134	86926065000
103209	1874	19559000
103210	2132	147974976000
103211	1874	19560000
103212	1688	28799252910040
103213	1688	28799265910040
103259	1672	3601250000000
103260	1672	3601287000000
103321	2134	86914029000
103322	1874	19623000
103323	2132	147970972000
103324	1874	19624000
103325	2133	94209854000
103326	1874	19626000
103327	2133	94208852000
103328	1874	19628000
103329	2134	86913026000
103330	1874	19631000
103331	1471	6425215900000
103332	1471	6425220900000
103348	2133	94206848000
103349	1874	19638000
103350	1874	19641000
103351	1395	58188149167957278
103352	1395	58188149179957278
103355	1749	12245419930000
103424	1708	16813509885983
103425	1139	909288714334550
103426	1397	1307066841000
103427	1678	23760768259000
103428	1708	14122167478972
103429	1019	507418003287950
103430	1708	10868088115923
103431	1259	613515214419050
103432	2133	94202840000
103433	1874	19666000
103434	2134	86905002000
103435	1874	19669000
103436	2133	94201838000
103437	1874	19671000
103438	2133	94200836000
103439	1874	19673000
103440	1701	5038133500103
103441	1701	5038177500103
103443	1764	21607288100000
103444	1764	21607332100000
103469	1560	5769636131803
103470	1560	5769688131803
103479	1717	20898631895735
103480	1717	15576862321623
103481	1717	11986155093431
103482	1717	1980348000055
103483	1705	9920622580140
103485	1691	24047998090117
103486	192	66623285364088
103487	1691	21039029100333
103488	918	507519164923296
103489	1691	15646990371389
103490	1038	909469995118336
103491	1397	1307026837000
103492	1678	23760768263000
103493	1691	5509065527233
103494	1284	1709955533869714
103495	1691	1870946300052
103496	1158	613637528176164
103497	2133	94196828000
103498	1874	19688000
103499	2134	86901993000
103500	1874	19691000
103501	1705	14240700580140
103502	1705	14240762580140
103546	1601	9253678620000
103563	1637	265686362819988
103573	1699	2880331750126
103575	1397	1306936828000
103576	1678	23760768272000
103577	2134	86892966000
103578	1874	19737000
103579	2133	94187810000
103580	1874	19739000
103581	484	70413850000000
103582	484	70413862000000
103592	1522	5083543000000
103628	1980	20159471000000
103629	1980	20159509000000
103638	1397	1306866821000
103639	1678	23760768279000
103640	2133	94180796000
103641	1874	19773000
103642	2134	86885945000
103643	1874	19776000
103696	1394	570249140500000
103697	1394	570249152500000
103712	1397	1306776812000
103713	1678	23760768288000
103714	2134	86877921000
103715	1874	19819000
103716	2133	94171778000
103717	1874	19821000
103732	1740	9810705000000
103733	1740	9810707000000
103764	1397	1306746809000
103765	1678	23760768291000
103766	2134	86873909000
103767	1874	19840000
103768	2133	94167770000
103769	1874	19842000
103770	1670	2880831000000
103771	1670	2880843000000
103808	369	72996365190850
103809	369	72996369190850
103854	1397	1306666801000
103855	1678	23760768299000
103856	2133	94159754000
103857	1874	19881000
103858	2134	86865885000
103859	1874	19884000
103860	1678	24480768299000
103861	1678	24480780299000
103940	2112	8640196000000
103941	2112	8640208000000
103999	1397	1306556790000
104000	1678	24480780310000
104001	2132	147952954000
104002	1874	19938000
104003	2134	86854852000
104004	1874	19941000
104005	2133	94148732000
104006	1874	19943000
104007	1394	577449217500000
104132	484	111200000
104133	1501	71133879800000
104135	1735	4300045000000
104153	1397	1306416776000
104154	1678	24480780324000
104155	1397	1306406775000
104156	1678	24480780325000
104157	1397	1306396774000
104158	1678	24480780326000
104159	2133	94134704000
104160	2132	147947949000
104161	2133	94133702000
104162	1874	20014000
103065	2134	86938101000
103066	1874	19498000
103067	2134	86937098000
103068	1874	19501000
103069	1608	6618362000000
103070	1608	6618387000000
103083	733	2719775000000
103084	1397	1307326867000
103085	1678	23760768233000
103086	1397	1307316866000
103087	1678	23760768234000
103088	1899	1995000000
103089	1740	9090705000000
103090	563	66000605000000
103091	2134	86935092000
103092	1874	19510000
103093	2133	94231898000
103094	1874	19512000
103095	2133	94230896000
103096	1874	19514000
103097	2134	86934089000
103098	1874	19517000
103099	369	72276064190850
103100	369	72276344190850
103101	2134	86933086000
103102	1874	19520000
103103	2132	147976978000
103104	1874	19521000
103105	2133	94229894000
103106	1874	19523000
103107	1692	55941147619999
103108	1692	55941150619999
103166	2112	7920184000000
103167	2112	7920208000000
103176	1397	1307276862000
103177	1678	23760768238000
103178	2133	94225886000
103179	1874	19540000
103180	2134	86929074000
103181	1874	19543000
103182	2132	147975977000
103183	1874	19544000
103184	1426	6810296000000
103214	1756	7044048195609
103215	1874	18889000
103216	1874	18891000
103217	1874	18895000
103218	1874	18897000
103219	1874	18898000
103220	1874	18900000
103221	1874	18912000
103222	1874	18915000
103223	1874	18917000
103224	1874	18925000
103225	1874	18927000
103226	1874	18939000
103227	1874	18955000
103228	1874	18957000
103229	1874	18965000
103230	1874	18967000
103231	1874	18973000
103232	1874	18979000
103233	1874	18981000
103234	1874	18985000
103235	1756	7764048195609
103236	1756	7764102195609
103261	1397	1307206855000
103262	1678	23760768245000
103263	1397	1307196854000
103264	1678	23760768246000
103265	2134	86922053000
103266	1874	19579000
103267	2134	86921050000
103268	1874	19582000
103269	2133	94218872000
103270	1874	19584000
103271	2133	94217870000
103272	1874	19586000
103273	1764	20887264100000
103274	1764	20887288100000
103275	1397	1307186853000
103276	1678	23760768247000
103277	1397	1307176852000
103278	1678	23760768248000
103279	1397	1307166851000
103280	1678	23760768249000
103281	2134	86920047000
103282	1874	19589000
103283	2134	86919044000
103284	1874	19592000
103285	2133	94216868000
103286	1874	19594000
103287	2133	94215866000
103288	1874	19596000
103289	2133	94214864000
103290	1874	19598000
103291	2132	147972974000
103292	1874	19599000
103293	1698	6548808550062
103294	1698	6548844550062
103333	1654	5897241999798
103334	1397	1307136848000
103335	1678	23760768252000
103336	2133	94207850000
103337	1874	19633000
103338	2134	86912023000
103339	1874	19636000
103340	1611	6615548000000
103341	1611	6615660000000
103365	1587	6480180000000
103366	1587	6480194000000
103397	1619	2880038000000
103398	1619	2880052000000
103399	1397	1307106845000
103400	1678	23760768255000
103401	1397	1307096844000
103402	1678	23760768256000
103403	2134	86909014000
103404	1874	19650000
103405	2133	94204844000
103406	1874	19652000
103407	2133	94203842000
103408	1874	19654000
103409	2134	86908011000
103410	1874	19657000
103445	1397	1307056840000
103446	1678	23760768260000
103447	2133	94199834000
103448	1874	19675000
103449	2132	147967969000
103450	1874	19676000
103451	1686	9031947700122
103452	1686	9031959700122
103503	1705	11360707580140
103504	1397	1307016836000
103505	1678	23760768264000
103506	2134	86900990000
103507	1874	19694000
103508	2133	94195826000
103509	1874	19696000
103510	2132	147966968000
103511	1874	19697000
103512	1394	565929103500000
103513	1394	565929116500000
103530	1397	1306986833000
103531	1678	23760768267000
103532	1397	1306976832000
103533	1678	23760768268000
103534	2134	86897981000
103535	1874	19710000
103536	2132	147965967000
103537	1874	19711000
103538	2133	94192820000
103539	1874	19713000
103540	2133	94191818000
103541	1874	19715000
103542	2134	86896978000
103543	1874	19718000
103544	1522	5083531000000
103545	1522	5083556000000
103564	1397	1306946829000
103565	1678	23760768271000
103566	2134	86893969000
103567	1874	19731000
103568	2133	94188812000
103569	1874	19733000
103570	2132	147964966000
103571	1874	19734000
103572	2086	3775334300069
103574	2087	2160249000000
103672	1397	1306826817000
103673	1678	23760768283000
103674	1397	1306816816000
103675	1678	23760768284000
103676	2133	94176788000
103677	1874	19794000
103678	2133	94175786000
103679	1874	19796000
103680	2134	86881933000
103681	1874	19799000
103682	2134	86880930000
103683	1874	19802000
103684	1559	6066035000000
103685	1353	1709640037751650
103686	2132	147960962000
103374	1874	19550000
103375	1874	19552000
103376	1874	19558000
103377	1874	19562000
103378	1874	19564000
103379	1874	19566000
103380	1874	19569000
103381	1874	19570000
103382	1874	19572000
103383	1874	19578000
103384	1874	19580000
103385	1619	2160337000000
103386	1874	19587000
103387	1874	19590000
103388	1874	19593000
103389	1874	19605000
103390	1874	19614000
103391	1874	19617000
103392	1874	19629000
103393	1874	19632000
103394	1874	19635000
103395	1619	2880337000000
103396	1619	2880359000000
103442	1422	20305332860211
103529	1692	56661174619999
103547	1397	1306966831000
103548	1678	23760768269000
103549	2134	86895975000
103550	1874	19721000
103551	2133	94190816000
103552	1874	19723000
103553	1680	5773235499559
103554	1680	5773247499559
103583	484	70413861000000
103644	1394	567369116500000
103645	1394	567369128500000
103664	1397	1306836818000
103665	1678	23760768282000
103666	2133	94177790000
103667	1874	19789000
103668	2134	86882936000
103669	1874	19792000
103670	1394	568809128500000
103671	1394	568809140500000
103718	1271	1347726435000000
103719	1271	1347726447000000
103772	1397	1306736808000
103773	1678	23760768292000
103774	2134	86872906000
103775	1874	19845000
103776	2133	94166768000
103777	1874	19847000
103778	1679	14398938654000
103779	1679	14398950654000
103810	1397	1306706805000
103811	1678	23760768295000
103812	1397	1306696804000
103813	1678	23760768296000
103814	2134	86869897000
103815	1874	19861000
103816	2134	86868894000
103817	1874	19864000
103818	2133	94163762000
103819	1874	19866000
103820	2133	94162760000
103821	1874	19868000
103822	2132	147956958000
103823	1874	19869000
103824	1394	576009179500000
103842	1509	8303931503835
103843	1874	19386000
103844	1874	19388000
103845	1874	19391000
103846	1874	19394000
103847	1874	19400000
103848	1874	19403000
103849	1874	19407000
103850	1874	19408000
103851	1874	19410000
103852	1509	9023931503835
103853	1509	9024614503835
103862	1394	577449204500000
103863	1394	577449216500000
103899	1685	148323362571430
103900	1685	148323374571430
103908	1513	33121033000000
103909	1397	1306596794000
103910	1678	24480780306000
103911	1397	1306586793000
103912	1678	24480780307000
103913	1397	1306576792000
103914	1678	24480780308000
103915	1555	15296924474753
103916	981	505968249228270
103917	2134	86858864000
103918	1874	19919000
103919	2133	94152740000
103920	1874	19921000
103921	2134	86857861000
103922	1874	19924000
103923	2134	86856858000
103924	1874	19927000
103925	2132	147953955000
103926	1874	19928000
103927	2133	94151738000
103928	1874	19930000
103929	2133	94150736000
103930	1874	19932000
103931	1467	17246962100039
103943	1692	57381174619999
103944	1692	57381186619999
104024	1397	1306526787000
104025	1678	24480780313000
104026	2133	94145726000
104027	1874	19955000
104028	2134	86851843000
104029	1874	19958000
104030	2132	147951953000
104031	1874	19959000
104032	2261	4319059000000
104033	2261	4319072000000
104055	1397	1306496784000
104056	1678	24480780316000
104057	1397	1306486783000
104058	1678	24480780317000
104059	1555	10919816296305
104060	1221	611762327909290
104061	1555	6005756540449
104062	1347	1704730121592585
104063	2133	94142720000
104064	1874	19971000
104065	2132	147950952000
104066	1874	19972000
104067	733	2000074000000
104068	2295	718699000000
104069	2134	86848834000
104070	1874	19975000
104071	1657	11705990990100
104072	1098	908293245000000
104073	1657	9291459990100
104074	1218	612843560000000
104075	2134	86847831000
104076	1874	19978000
104077	2133	94141718000
104078	1874	19980000
104079	1706	7482018450256
104080	1706	7482066450256
104081	1397	1306476782000
104082	1678	24480780318000
104083	1397	1306466781000
104084	1678	24480780319000
104085	1397	1306456780000
104086	1678	24480780320000
104087	2134	86846828000
104088	1874	19983000
104089	2134	86845825000
104090	1874	19986000
104091	1657	2563168990100
104092	1344	1707743047751650
104093	2134	86844822000
104094	1874	19989000
104095	1420	1434996980000
104096	2132	147949951000
104097	1874	19990000
104098	2133	94140716000
104099	1874	19992000
104100	2133	94139714000
104101	1874	19994000
104102	2133	94138712000
104103	1874	19996000
104104	1420	2154996980000
104105	1420	2155000980000
104130	484	71133862000000
104131	484	71133887000000
104134	1681	7811185109853
104145	1874	20005000
104146	1874	20008000
104147	2134	86841813000
104148	1874	20011000
104149	1874	20012000
104150	1649	6232476999992
104216	1397	1306336768000
104217	1678	24480780332000
104218	2134	86832786000
104219	1874	20057000
103519	1678	23760768266000
103520	2133	94194824000
103521	1874	19699000
103522	2134	86899987000
103523	1874	19702000
103524	2133	94193822000
103525	1874	19704000
103526	2134	86898984000
103527	1874	19707000
103528	1710	4553920664140
103555	1397	1306956830000
103556	1678	23760768270000
103557	2133	94189814000
103558	1874	19725000
103559	2134	86894972000
103560	1874	19728000
103561	1688	29519265910040
103562	1688	29519277910040
103584	1397	1306926827000
103585	1678	23760768273000
103586	2134	86891963000
103587	1874	19742000
103588	2133	94186808000
103589	1874	19744000
103590	1670	2160819000000
103591	1670	2160831000000
103593	1397	1306916826000
103594	1678	23760768274000
103595	2132	147963965000
103596	1874	19745000
103597	2134	86890960000
103598	1874	19748000
103599	2133	94185806000
103600	1874	19750000
103601	1559	18837998000000
103602	987	507425545000000
103603	1637	265686364819988
103604	1397	1306906825000
103605	1678	23760768275000
103606	1397	1306896824000
103607	1678	23760768276000
103608	1397	1306886823000
103609	1678	23760768277000
103610	2133	94184804000
103611	1874	19752000
103612	2132	147962964000
103613	1874	19753000
103614	1559	16413867000000
103615	1227	613524320000000
103616	2133	94183802000
103617	1874	19755000
103618	2133	94182800000
103619	1874	19757000
103620	2134	86889957000
103621	1874	19760000
103622	2134	86888954000
103623	1874	19763000
103624	2134	86887951000
103625	1874	19766000
103626	1686	9751959700122
103627	1686	9751997700122
103630	1397	1306876822000
103631	1678	23760768278000
103632	2133	94181798000
103633	1874	19768000
103634	2134	86886948000
103635	1874	19771000
103636	1768	8386581110000
103637	1768	8386593110000
103646	1397	1306856820000
103647	1678	23760768280000
103648	1397	1306846819000
103649	1678	23760768281000
103650	2134	86884942000
103651	1874	19779000
103652	2134	86883939000
103653	1874	19782000
103654	2133	94179794000
103655	1874	19784000
103656	2133	94178792000
103657	1874	19786000
103658	1559	12821076000000
103659	1107	909302195000000
103660	2132	147961963000
103661	1874	19787000
103662	633	72909372900000
103663	633	72909398900000
103690	1397	1306806815000
103691	1678	23760768285000
103692	2134	86879927000
103693	1874	19806000
103694	2133	94174784000
103695	1874	19808000
103720	1397	1306766811000
103721	1678	23760768289000
103722	2133	94170776000
103723	1874	19823000
103724	2134	86876918000
103725	1874	19826000
103726	2133	94169774000
103727	1874	19828000
103728	2134	86875915000
103729	1874	19831000
103730	1394	571689152500000
103731	1394	571689154500000
103744	1506	4612625967172
103782	1594	7921639000000
103783	1594	7921651000000
103805	1394	574569200500000
103806	1394	576009200500000
103807	1394	576009204500000
103839	1874	19872000
103840	1874	19875000
103841	171	71706711696494
103893	1397	1306616796000
103894	1678	24480780304000
103895	2133	94154744000
103896	1874	19908000
103897	2134	86860870000
103898	1874	19911000
103901	1397	1306606795000
103902	1678	24480780305000
103903	2133	94153742000
103904	1874	19913000
103905	2134	86859867000
103906	1874	19916000
103907	1693	10981758908632
103932	1397	1306566791000
103933	1678	24480780309000
103934	2133	94149734000
103935	1874	19934000
103936	2134	86855855000
103937	1874	19937000
103938	1467	17966962100039
103939	1467	17966974100039
103942	1698	6548820550062
103945	1678	23760768300000
103946	1678	23760768301000
103947	1678	23760768302000
103948	1678	23760768303000
103949	1678	23760768304000
103950	1678	23760768305000
103951	1678	23760768306000
103952	1678	23760768307000
103953	1678	23760768308000
103954	1678	23760768309000
103955	1874	19788000
103956	1874	19790000
103957	1874	19793000
103958	1874	19795000
103959	1874	19797000
103960	1874	19798000
103961	1874	19800000
103962	1874	19801000
103963	1874	19805000
103964	1874	19807000
103965	1874	19809000
103966	1874	19813000
103967	1874	19815000
103968	1874	19817000
103969	1874	19825000
103970	1874	19827000
103971	1874	19829000
103972	1874	19833000
103973	1874	19835000
103974	1874	19839000
103975	1874	19841000
103976	1874	19843000
103977	2112	7920546000000
103978	1874	19853000
103979	1874	19856000
103980	1874	19859000
103981	1874	19862000
103982	1874	19865000
103983	1874	19874000
103984	1874	19877000
103985	1874	19880000
103986	1874	19883000
103987	1874	19889000
103988	1874	19895000
103989	1874	19898000
103990	1874	19901000
103991	1874	19904000
103992	1874	19907000
103993	1874	19910000
103687	1874	19803000
103688	1708	11588088115923
103689	1708	11588114115923
103698	1397	1306796814000
103699	1678	23760768286000
103700	1397	1306786813000
103701	1678	23760768287000
103702	2134	86878924000
103703	1874	19811000
103704	2132	147959961000
103705	1874	19812000
103706	2133	94173782000
103707	1874	19814000
103708	2133	94172780000
103709	1874	19816000
103710	1471	7145220900000
103711	1471	7145244900000
103734	1397	1306756810000
103735	1678	23760768290000
103736	2132	147958960000
103737	1874	19832000
103738	2133	94168772000
103739	1874	19834000
103740	2134	86874912000
103741	1874	19837000
103742	1394	573129154500000
103743	1394	573129167500000
103745	1509	20083830540403
103746	1509	16162255101171
103747	1509	13516257481403
103748	1509	6143128503835
103749	1654	14310272999798
103750	1723	14963610085979
103751	1723	10476600085979
103752	1723	7448590085979
103753	1723	4944580085979
103754	1723	4929570085979
103755	1723	2881560085979
103756	1654	9897262999798
103757	1654	6919252999798
103758	1654	4457242999798
103759	1506	3894272967172
103760	1708	1800324500051
103761	1385	1709614695710050
103762	1506	4614272967172
103763	1506	4615072967172
103780	1394	574569167500000
103781	1394	574569179500000
103784	1397	1306726807000
103785	1678	23760768293000
103786	1397	1306716806000
103787	1678	23760768294000
103788	2133	94165766000
103789	1874	19849000
103790	369	72276365190850
103791	2133	94164764000
103792	1874	19851000
103793	2134	86871903000
103794	1874	19854000
103795	2132	147957959000
103796	1874	19855000
103797	2134	86870900000
103798	1874	19858000
103799	2260	280000010
103800	369	72996365190840
103801	1501	280000020
103802	2260	100800000
103803	369	3200000
103804	1604	72996365290830
103825	1397	1306686803000
103826	1678	23760768297000
103827	1397	1306676802000
103828	1678	23760768298000
103829	2133	94161758000
103830	1874	19871000
103831	2133	94160756000
103832	1874	19873000
103833	2134	86867891000
103834	1874	19876000
103835	2134	86866888000
103836	1874	19879000
103837	1509	9023211503835
103838	1509	9023235503835
103864	1397	1306656800000
103865	1678	24480780300000
103866	1397	1306646799000
103867	1678	24480780301000
103868	1397	1306636798000
103869	1678	24480780302000
103870	1397	1306626797000
103871	1678	24480780303000
103872	2132	147955957000
103873	1874	19885000
103874	2132	147954956000
103875	1874	19886000
103876	2133	94158752000
103877	1874	19888000
103878	2133	94157750000
103879	1874	19890000
103880	2133	94156748000
103881	1874	19892000
103882	2133	94155746000
103883	1874	19894000
103884	2134	86864882000
103885	1874	19897000
103886	2134	86863879000
103887	1874	19900000
103888	2134	86862876000
103889	1874	19903000
103890	2134	86861873000
103891	1874	19906000
103892	1571	5472155151480
104008	1397	1306546789000
104009	1678	24480780311000
104010	2133	94147730000
104011	1874	19945000
104012	2134	86853849000
104013	1874	19948000
104014	1394	578889217500000
104015	1394	578889229500000
104036	1397	1306516786000
104037	1678	24480780314000
104038	1397	1306506785000
104039	1678	24480780315000
104040	1555	12683290483409
104041	1101	906690767481065
104042	1657	15284551990100
104043	978	506862505000000
104044	2134	86850840000
104045	1874	19962000
104046	2134	86849837000
104047	1874	19965000
104048	2133	94144724000
104049	1874	19967000
104050	2133	94143722000
104051	1874	19969000
104052	1711	5466779000000
104111	1397	1306446779000
104112	1678	24480780321000
104113	1397	1306436778000
104114	1678	24480780322000
104115	2133	94137710000
104116	1874	19998000
104117	2133	94136708000
104118	1874	20000000
104119	2134	86843819000
104120	1874	20003000
104121	2134	86842816000
104122	1874	20006000
104123	1657	1441167990100
104124	2074	2293600000000
104125	1610	5760106999950
104126	1610	5760131999950
104136	1397	1306426777000
104137	1678	24480780323000
104138	2133	94135706000
104139	1874	20002000
104140	2132	147948950000
104141	1691	2589946300028
104142	1691	2589958300028
104167	2134	86840810000
104168	1874	20017000
104169	2134	86839807000
104170	1874	20020000
104171	2134	86838804000
104172	1874	20023000
104173	1874	20024000
104174	1874	20026000
104175	1874	20028000
104176	1611	7335660000000
104177	1611	7335698000000
104208	1397	1306346769000
104209	1678	24480780331000
104210	2133	94127690000
104211	1874	20051000
104212	2134	86833789000
104213	1874	20054000
104214	1703	1440819000000
104215	1703	1440831000000
104294	606	68926586286230
104295	606	68926599286230
104329	1397	1306236758000
104330	1678	24480780342000
104331	2133	94116668000
104332	1874	20106000
103994	1874	19922000
103995	1874	19925000
103996	1874	19931000
103997	2112	8640546000000
103998	2112	8640578000000
104016	1397	1306536788000
104017	1678	24480780312000
104018	2133	94146728000
104019	1874	19950000
104020	2134	86852846000
104021	1874	19953000
104022	1688	30239277910040
104023	1688	30239289910040
104034	1634	9742975259504
104035	1634	9742988259504
104053	1623	65523055899898
104054	1623	65523090899898
104106	1688	30239323910040
104107	1688	30959323910040
104108	1501	280000040
104109	2260	104000000
104110	1688	30959324710020
104127	1681	7811160109853
104128	1681	111200000
104129	1501	7811175909853
104143	1649	6231461999968
104144	1649	6231473999968
104151	1874	20009000
104152	1687	14300326223172
104178	1397	1306386773000
104179	1678	24480780327000
104180	1397	1306376772000
104181	1678	24480780328000
104182	1874	20019000
104183	2133	94131698000
104184	1874	20021000
104185	2133	94130696000
104186	1874	20029000
104187	1874	20032000
104188	2134	86837801000
104189	1874	20035000
104190	2134	86836798000
104191	1874	20038000
104192	1701	5038161500103
104222	1397	1306326767000
104223	1678	24480780333000
104224	2134	86831783000
104225	1874	20062000
104226	2132	147945947000
104227	1874	20063000
104228	2133	94125686000
104229	1874	20065000
104230	1394	580329229500000
104231	1394	580329242500000
104232	1397	1306316766000
104233	1678	24480780334000
104234	1397	1306306765000
104235	1678	24480780335000
104236	1397	1306296764000
104237	1678	24480780336000
104238	2133	94124684000
104239	1874	20067000
104240	2132	147944946000
104241	1874	20068000
104242	2133	94123682000
104243	1874	20070000
104244	2133	94122680000
104245	1874	20072000
104246	2134	86830780000
104247	1874	20075000
104248	2134	86829777000
104249	1874	20078000
104250	2134	86828774000
104251	1874	20081000
104252	1708	12308114115923
104253	1708	12308151115923
104255	1700	3834189979053
104298	1397	1306246759000
104299	1678	24480780341000
104300	2133	94117670000
104301	1874	20104000
104302	1764	22327332100000
104303	1764	22327343100000
104345	633	73629398900000
104346	633	73629444900000
104355	2248	7199408000000
104356	2248	7199420000000
104379	484	70413873000000
104380	484	71133873000000
104381	484	71133875000000
104385	1397	1306186753000
104386	1678	24480780347000
104387	1397	1306176752000
104388	1678	24480780348000
104389	1397	1306166751000
104390	1678	24480780349000
104391	2134	86818744000
104392	1874	20134000
104393	2134	86817741000
104394	1874	20137000
104395	2134	86816738000
104396	1874	20140000
104397	2133	94111658000
104398	1874	20142000
104399	2133	94110656000
104400	1874	20144000
104401	2133	94109654000
104402	1874	20146000
104403	1419	13968188560130
104456	1397	1306096744000
104457	1678	24480780356000
104458	1397	1306086743000
104459	1678	24480780357000
104460	2133	94103642000
104461	1874	20175000
104462	2132	147938940000
104463	1874	20176000
104464	2134	86810720000
104465	1874	20179000
104466	2134	86809717000
104467	1874	20182000
104468	2133	94102640000
104469	1874	20184000
104470	1395	58190309204957278
104471	1395	58190309229957278
104494	1706	8202066450256
104495	1706	8202091450256
104519	1397	1306016736000
104520	1678	24480780364000
104521	2133	94095626000
104522	1874	20218000
104523	2134	86802696000
104524	1874	20221000
104525	1395	58191029229957278
104526	1395	58191029241957278
104529	1397	1306006735000
104530	1678	24480780365000
104531	1560	5768587131803
104532	2199	720338000000
104533	2133	94094624000
104534	1874	20223000
104535	2134	86801693000
104536	1874	20226000
104537	1536	4320084000000
104538	1536	4320097000000
104567	1608	7338387000000
104568	1608	7338399000000
104570	1608	6618507000000
104571	1874	20121000
104572	1874	20124000
104573	1874	20127000
104574	1874	20130000
104575	1874	20138000
104576	1874	20141000
104577	1874	20145000
104578	1874	20149000
104579	1874	20155000
104580	1874	20158000
104581	1874	20162000
104582	1874	20172000
104583	1874	20174000
104584	1874	20177000
104585	1874	20180000
104586	1874	20181000
104587	1874	20183000
104588	1874	20185000
104589	1874	20187000
104590	1874	20191000
104591	1874	20194000
104592	1874	20197000
104593	1874	20206000
104594	1874	20209000
104595	1874	20212000
104596	1874	20215000
104597	1874	20220000
104598	1874	20222000
104599	1874	20224000
104600	1874	20228000
104601	1874	20230000
104602	1874	20236000
104603	1874	20238000
104604	1608	7338507000000
104605	1608	7338693000000
104627	1685	149043387571430
104636	1397	1305936728000
104163	2133	94132700000
104164	1874	20016000
104165	1457	30144653040000
104166	1457	30144687040000
104193	1397	1306366771000
104194	1678	24480780329000
104195	1397	1306356770000
104196	1678	24480780330000
104197	2134	86835795000
104198	1874	20041000
104199	2134	86834792000
104200	1874	20044000
104201	2132	147946948000
104202	1874	20045000
104203	2133	94129694000
104204	1874	20047000
104205	2133	94128692000
104206	1874	20049000
104207	1536	3600084000000
104256	1397	1306286763000
104257	1678	24480780337000
104258	1397	1306276762000
104259	1678	24480780338000
104260	2133	94121678000
104261	1874	20074000
104262	2133	94120676000
104263	1874	20076000
104264	1874	20079000
104265	1874	20082000
104266	1874	20085000
104267	111	71760102000000
104274	1397	1306266761000
104275	1678	24480780339000
104276	2133	94119674000
104277	1874	20087000
104278	1874	20090000
104279	1874	20093000
104280	2134	86825765000
104281	1874	20096000
104282	1637	266406364819988
104283	1637	266406378819988
104357	633	73629410900000
104404	1397	1306156750000
104405	1678	24480780350000
104406	2133	94108652000
104407	1874	20148000
104408	2134	86815735000
104409	1874	20151000
104410	2132	147940942000
104411	1874	20152000
104412	1395	58188869179957278
104413	1395	58188869192957278
104416	1397	1306146749000
104417	1678	24480780351000
104418	2133	94107650000
104419	1874	20154000
104420	2134	86814732000
104421	1874	20157000
104422	1688	31679324710020
104423	1688	31679336710020
104444	1397	1306116746000
104445	1678	24480780354000
104446	1684	9362887219748
104447	1684	9362897219748
104472	1397	1306076742000
104473	1678	24480780358000
104474	2133	94101638000
104475	1874	20186000
104476	2134	86808714000
104477	1874	20189000
104496	1397	1306046739000
104497	1678	24480780361000
104498	1397	1306036738000
104499	1678	24480780362000
104500	2134	86805705000
104501	1874	20203000
104502	2133	94098632000
104503	1874	20205000
104504	2133	94097630000
104505	1874	20207000
104506	2134	86804702000
104507	1874	20210000
104508	1425	1537412000000
104509	1425	1537436000000
104527	1684	10082897219748
104528	1684	10082909219748
104539	633	74349444900000
104540	633	74349445900000
104551	1397	1305986733000
104552	1678	24480780367000
104553	2133	94092620000
104554	1874	20234000
104555	2134	86799687000
104556	1874	20237000
104557	1649	6951473999968
104558	1649	6951485999968
104569	1623	65523067899898
104615	1560	6488587131803
104616	1560	6488599131803
104686	1637	267126378819988
104687	1637	267126403819988
104701	1397	1305876722000
104702	1678	24480780378000
104703	2133	94081598000
104704	1874	20292000
104705	1679	15118950654000
104707	1397	1305866721000
104708	1678	24480780379000
104709	2134	86788654000
104710	1874	20295000
104711	606	68926597286230
104773	1397	1305796714000
104774	1678	24480780386000
104775	2133	94073582000
104776	1874	20331000
104777	1394	586089304500000
104778	1394	586089315500000
104797	1850	9336319949999
104801	1397	1305766711000
104802	1678	24480780389000
104803	1397	1305756710000
104804	1678	24480780390000
104805	2132	147928930000
104806	1874	20343000
104807	2133	94070576000
104808	1874	20345000
104809	2133	94069574000
104810	1874	20347000
104811	2134	86779627000
104812	1874	20350000
104813	2134	86778624000
104814	1874	20353000
104815	633	75069423900000
104816	633	75069448900000
104855	1764	23047343100000
104856	1764	23047356100000
104857	1764	23047567100000
104858	1764	23047687100000
104867	1678	23760768310000
104868	1678	23760768311000
104869	1678	23760768312000
104870	1678	23760768313000
104871	1678	23760768314000
104872	1678	23760768315000
104873	1678	23760768316000
104874	1678	23760768317000
104875	1678	23760768318000
104876	1678	23760768319000
104877	1678	23760768320000
104878	1678	23760768321000
104879	1678	23760768322000
104880	1678	23760768323000
104881	1678	23760768324000
104882	1678	23760768325000
104883	1678	23760768326000
104884	1678	23760768327000
104885	1678	23760768328000
104886	1678	23760768329000
104887	1678	23760768330000
104888	1678	23760768331000
104889	1678	23760768332000
104890	1678	23760768333000
104891	1678	23760768334000
104892	1678	23760768335000
104893	1678	23760768336000
104894	1678	23760768337000
104895	1678	23760768338000
104896	1678	23760768339000
104897	1678	23760768340000
104898	1678	23760768341000
104899	1678	23760768342000
104900	1678	23760768343000
104901	1678	23760768344000
104902	1678	23760768345000
104903	1678	23760768346000
104904	1678	23760768347000
104905	1678	23760768348000
104906	1678	23760768349000
104907	1678	23760768350000
104908	1678	23760768351000
104909	1678	23760768352000
104910	1678	23760768353000
104911	1678	23760768354000
104912	1678	23760768355000
104913	1678	23760768356000
104220	2133	94126688000
104221	1874	20059000
104254	1700	3834192979053
104268	2134	86827771000
104269	1874	20088000
104270	2134	86826768000
104271	1874	20091000
104272	1588	26135600000000
104273	1588	26135627000000
104284	1397	1306256760000
104285	1678	24480780340000
104286	2133	94118672000
104287	1874	20098000
104288	2132	147943945000
104289	1874	20099000
104290	2134	86824762000
104291	1874	20102000
104292	1680	6493247499559
104293	1680	6493260499559
104296	1710	5273908664140
104297	1710	5273921664140
104304	1874	20004000
104305	1874	20007000
104306	1874	20010000
104307	1874	20013000
104308	1874	20022000
104309	1874	20025000
104310	1874	20031000
104311	1874	20034000
104312	1874	20037000
104313	1874	20040000
104314	1874	20043000
104315	1874	20046000
104316	1874	20048000
104317	1874	20052000
104318	1874	20055000
104319	1874	20058000
104320	1874	20061000
104321	1874	20064000
104322	1874	20080000
104323	1874	20084000
104324	1874	20086000
104325	1874	20092000
104326	1874	20094000
104327	1874	20100000
104328	1764	22327567100000
104347	1397	1306216756000
104348	1678	24480780344000
104349	2134	86821753000
104350	1874	20118000
104351	2133	94114664000
104352	1874	20120000
104353	1394	583209255500000
104354	1394	583209267500000
104358	1455	2191539000000
104359	1455	2191551000000
104360	1397	1306206755000
104361	1678	24480780345000
104362	2134	86820750000
104363	1874	20123000
104364	2133	94113662000
104365	1874	20125000
104366	1705	14960762580140
104367	1705	14960774580140
104382	1593	28630615000000
104383	1593	29350615000000
104384	1593	29350617000000
104414	1559	6786035000000
104415	1559	6786048000000
104424	1397	1306136748000
104425	1678	24480780352000
104426	1397	1306126747000
104427	1678	24480780353000
104428	2134	86813729000
104429	1874	20160000
104430	2132	147939941000
104431	1874	20161000
104432	2134	86812726000
104433	1874	20164000
104434	2133	94106648000
104435	1874	20166000
104436	2133	94105646000
104437	1874	20168000
104438	1688	32399336710020
104439	1688	32399361710020
104442	1685	149043374571430
104443	1685	149043399571430
104478	1397	1306066741000
104479	1678	24480780359000
104480	1397	1306056740000
104481	1678	24480780360000
104482	2134	86807711000
104483	1874	20192000
104484	2132	147937939000
104485	1874	20193000
104486	2134	86806708000
104487	1874	20196000
104488	2133	94100636000
104489	1874	20198000
104490	2133	94099634000
104491	1874	20200000
104492	1457	30864687040000
104493	1457	30864712040000
104559	1397	1305976732000
104560	1678	24480780368000
104561	2134	86798684000
104562	1874	20240000
104563	2133	94091618000
104564	1874	20242000
104565	1681	8531175909853
104566	1681	8531187909853
104606	1397	1305966731000
104607	1678	24480780369000
104608	2134	86797681000
104609	1874	20245000
104610	2133	94090616000
104611	1874	20247000
104612	1588	26135612000000
104644	1397	1305926727000
104645	1678	24480780373000
104646	2134	86793669000
104647	1874	20266000
104648	2133	94086608000
104649	1874	20268000
104650	2132	147933935000
104651	1874	20269000
104652	1633	16596762975638
104706	1395	58191749252957278
104712	2133	94080596000
104713	1874	20294000
104714	1874	20297000
104715	606	68926598286230
104758	1397	1305806715000
104759	1678	24480780385000
104760	2134	86782636000
104761	1874	20327000
104762	1547	7194720000000
104767	1714	6045504171760
104779	1701	5758161500103
104780	1701	5758172500103
104798	369	73716390290830
104799	1559	6786060000000
104824	1573	4179315000000
104825	1573	4179327000000
104834	1397	1305726707000
104835	1678	24480780393000
104836	2134	86775615000
104837	1874	20366000
104838	2132	147927929000
104839	1874	20367000
104840	2133	94066568000
104841	1874	20369000
104842	1654	7337253999798
104843	1654	7337266999798
104973	1397	1305696704000
104974	1678	24480780396000
104975	1397	1305686703000
104976	1678	24480780397000
104977	1673	31860688000000
104978	100	66769780000000
104979	2132	147926928000
104980	1874	20380000
104981	2133	94063562000
104982	1874	20382000
104983	2133	94062560000
104984	1874	20384000
104985	2134	86772606000
104986	1874	20387000
104987	2134	86771603000
104988	1874	20390000
104989	1506	4612638967172
105032	1759	20881011999889
105033	1759	20881023999889
105061	1637	267846415819988
105076	1397	1305616696000
105077	1678	24480780404000
105078	2133	94055546000
105079	1874	20421000
105080	2134	86765585000
105081	1874	20424000
105082	1395	58193189277957278
105083	1395	58193189289957278
105102	1441	1440022000000
105103	1441	1440034000000
105124	1397	1305566691000
104333	2134	86823759000
104334	1874	20109000
104335	1397	1306226757000
104336	1678	24480780343000
104337	2134	86822756000
104338	1874	20112000
104339	2132	147942944000
104340	1874	20113000
104341	2133	94115666000
104342	1874	20115000
104343	1394	581769242500000
104344	1394	581769255500000
104368	1397	1306196754000
104369	1678	24480780346000
104370	2134	86819747000
104371	1874	20128000
104372	1679	14398961654000
104373	2132	147941943000
104374	1874	20129000
104375	2133	94112660000
104376	1874	20131000
104377	1679	15118961654000
104378	1679	15118963654000
104440	1476	2880036000000
104441	1476	2880061000000
104448	1397	1306106745000
104449	1678	24480780355000
104450	2133	94104644000
104451	1874	20170000
104452	2134	86811723000
104453	1874	20173000
104454	1395	58189589192957278
104455	1395	58189589204957278
104510	1397	1306026737000
104511	1678	24480780363000
104512	2132	147936938000
104513	1874	20211000
104514	2134	86803699000
104515	1874	20214000
104516	2133	94096628000
104517	1874	20216000
104518	1692	57381187619999
104541	1397	1305996734000
104542	1678	24480780366000
104543	2132	147935937000
104544	1874	20227000
104545	2133	94093622000
104546	1874	20229000
104547	2134	86800690000
104548	1874	20232000
104549	633	74349410900000
104550	633	74349423900000
104613	1395	58191749241957278
104614	1395	58191749253957278
104617	1397	1305956730000
104618	1678	24480780370000
104619	2132	147934936000
104620	1874	20248000
104621	2134	86796678000
104622	1874	20251000
104623	2133	94089614000
104624	1874	20253000
104625	632	72477525000000
104626	632	72477538000000
104628	1397	1305946729000
104629	1678	24480780371000
104630	2133	94088612000
104631	1874	20255000
104632	2134	86795675000
104633	1874	20258000
104634	1594	8641651000000
104635	1594	8641663000000
104653	1397	1305916726000
104654	1678	24480780374000
104655	1397	1305906725000
104656	1678	24480780375000
104657	2133	94085606000
104658	1874	20271000
104659	2133	94084604000
104660	1874	20273000
104661	2134	86792666000
104662	1874	20276000
104663	2134	86791663000
104664	1874	20279000
104665	1448	12276857000001
104667	2106	5039107000000
104668	1573	3459291000000
104669	1573	3459315000000
104716	369	73716365290830
104717	369	73716377290830
104718	1397	1305856720000
104719	1678	24480780380000
104720	1397	1305846719000
104721	1678	24480780381000
104722	1397	1305836718000
104723	1678	24480780382000
104724	2132	147931933000
104725	1874	20298000
104726	2133	94079594000
104727	1874	20300000
104728	2133	94078592000
104729	1874	20302000
104730	2133	94077590000
104731	1874	20304000
104732	2134	86787651000
104733	1874	20307000
104734	2134	86786648000
104735	1874	20310000
104736	2134	86785645000
104737	1874	20313000
104738	1696	13403606335104
104739	1696	13403643335104
104742	1397	1305826717000
104743	1678	24480780383000
104744	2133	94076588000
104745	1874	20315000
104746	2134	86784642000
104747	1874	20318000
104748	2132	147930932000
104749	1874	20319000
104750	1476	2880049000000
104763	2133	94074584000
104764	1874	20326000
104765	1874	20329000
104766	1547	7194721000000
104768	1874	20296000
104769	1874	20299000
104770	1874	20301000
104771	1874	20316000
104772	1714	6045562171760
104800	633	75069445900000
104844	1397	1305716706000
104845	1678	24480780394000
104846	2133	94065566000
104847	1874	20371000
104848	1673	32293199000000
104849	144	66769780000000
104850	2134	86774612000
104851	1874	20374000
104852	1717	3420960000055
104853	1717	3420973000055
104859	1397	1305706705000
104860	1678	24480780395000
104861	2134	86773609000
104862	1874	20377000
104863	2133	94064564000
104864	1874	20379000
104865	2112	9360208000000
104866	2112	9360220000000
104990	1601	9973678620000
104991	1601	9973704620000
105023	1397	1305676702000
105024	1678	24480780398000
105025	2134	86770600000
105026	1874	20393000
105027	149	71855252000341
105028	149	71855263000341
105084	1700	4554189979053
105085	1700	4554201979053
105094	2087	2880249000000
105095	2087	2880262000000
105112	2133	94052540000
105113	1874	20436000
105114	1874	20439000
105115	1874	20440000
105165	1397	1305546689000
105166	1678	24480780411000
105167	2134	86758564000
105168	1874	20459000
105169	1422	20305299860211
105336	2133	94036508000
105337	1874	20521000
105338	1874	20522000
105339	1394	591849493500000
105378	1397	1305396674000
105379	1678	24480780426000
105380	1693	7017163175566
105381	453	66702358779471
105382	1693	6970414083172
105383	283	66047229092394
105384	1693	6919317420480
105385	308	66702358779471
105386	1693	6868220757788
105387	201	66702358779471
105388	1693	6866792739669
104637	1678	24480780372000
104638	2133	94087610000
104639	1874	20260000
104640	2134	86794672000
104641	1874	20263000
104642	1458	11465145908540
104643	1458	11465157908540
104666	1680	6493271499559
104670	1397	1305896724000
104671	1678	24480780376000
104672	1397	1305886723000
104673	1678	24480780377000
104674	2133	94083602000
104675	1874	20281000
104676	2132	147932934000
104677	1874	20282000
104678	2134	86790660000
104679	1874	20285000
104680	2134	86789657000
104681	1874	20288000
104682	2133	94082600000
104683	1874	20290000
104684	1608	8058399000000
104685	1608	8058424000000
104688	1874	20243000
104689	1874	20246000
104690	1874	20249000
104691	1874	20257000
104692	1874	20259000
104693	1874	20261000
104694	1874	20265000
104695	1874	20274000
104696	1874	20277000
104697	1874	20278000
104698	1874	20284000
104699	1608	8058693000000
104700	1608	8058791000000
104740	1394	584649267500000
104741	1394	584649304500000
104751	1397	1305816716000
104752	1678	24480780384000
104753	2134	86783639000
104754	1874	20322000
104755	2133	94075586000
104756	1874	20324000
104757	1694	7738844197225
104781	1397	1305786713000
104782	1678	24480780387000
104783	1397	1305776712000
104784	1678	24480780388000
104785	2134	86781633000
104786	1874	20334000
104787	2132	147929931000
104788	1874	20335000
104789	2134	86780630000
104790	1874	20338000
104791	2133	94072580000
104792	1874	20340000
104793	2133	94071578000
104794	1874	20342000
104795	1850	9336296949999
104796	1850	9336321949999
104817	1397	1305746709000
104818	1678	24480780391000
104819	2134	86777621000
104820	1874	20356000
104821	2133	94068572000
104822	1874	20358000
104823	1394	586089316500000
104826	1397	1305736708000
104827	1678	24480780392000
104828	2134	86776618000
104829	1874	20361000
104830	2133	94067570000
104831	1874	20363000
104832	1654	6617241999798
104833	1654	6617253999798
104854	1675	6764197999977
105042	1397	1305656700000
105043	1678	24480780400000
105044	2134	86768594000
105045	1874	20403000
105046	2132	147925927000
105047	1874	20404000
105048	2133	94059554000
105049	1874	20406000
105050	1654	8057266999798
105051	1654	8057279999798
105054	1397	1305646699000
105055	1678	24480780401000
105056	2134	86767591000
105057	1874	20409000
105058	2133	94058552000
105059	1874	20411000
105088	1397	1305606695000
105089	1678	24480780405000
105090	2133	94054544000
105091	1874	20426000
105092	2134	86764582000
105093	1874	20429000
105116	1397	1305576692000
105117	1678	24480780408000
105118	2133	94051538000
105119	1874	20442000
105120	2134	86761573000
105121	1874	20445000
105122	1650	4432875000000
105123	1650	4432887000000
105143	1509	9025244503835
105144	1678	23760768396000
105145	1678	23760768397000
105146	1678	23760768398000
105147	1678	23760768399000
105148	1678	23760768400000
105149	1678	23760768401000
105150	1678	23760768402000
105151	1678	23760768403000
105152	1678	23760768404000
105153	1678	23760768405000
105154	1678	23760768406000
105155	1678	23760768407000
105156	1678	23760768408000
105157	1678	23760768409000
105158	1678	23760768410000
105159	1560	5048535131803
105160	1874	19412000
105161	1874	19413000
105162	1874	19416000
105163	1509	9745244503835
105164	1509	9745783503835
105173	1397	1305536688000
105174	1678	24480780412000
105175	1397	1305526687000
105176	1678	24480780413000
105177	2132	147921923000
105178	1874	20462000
105179	2133	94047530000
105180	1874	20464000
105181	2133	94046528000
105182	1874	20466000
105183	2134	86757561000
105184	1874	20469000
105185	2134	86756558000
105186	1874	20472000
105187	1471	7865244900000
105188	1471	7865269900000
105190	1397	1305516686000
105191	1678	24480780414000
105192	1397	1305506685000
105193	1678	24480780415000
105194	1397	1305496684000
105195	1678	24480780416000
105196	1397	1305486683000
105197	1678	24480780417000
105198	2134	86755555000
105199	1874	20475000
105200	2132	147920922000
105201	1874	20476000
105202	2133	94045526000
105203	1874	20478000
105204	2134	86754552000
105205	1874	20481000
105206	2134	86753549000
105207	1874	20484000
105208	2134	86752546000
105209	1874	20487000
105210	2133	94044524000
105211	1874	20489000
105212	2133	94043522000
105213	1874	20491000
105214	2133	94042520000
105215	1874	20493000
105216	1394	588969329500000
105217	1394	588969378500000
105255	1723	4321572085979
105256	1723	4321644085979
105274	1394	591849420500000
105275	1394	591849482500000
105340	1397	1305416676000
105341	1678	24480780424000
105342	1693	8000280851587
105343	1962	701270954698
105344	1693	7949184188895
105345	63	66702358779471
105346	1693	7478484273724
104914	1678	23760768357000
104915	1678	23760768358000
104916	1678	23760768359000
104917	1678	23760768360000
104918	1678	23760768361000
104919	1678	23760768362000
104920	1678	23760768363000
104921	1678	23760768364000
104922	1678	23760768365000
104923	1678	23760768366000
104924	1678	23760768367000
104925	1678	23760768368000
104926	1678	23760768369000
104927	1678	23760768370000
104928	1678	23760768371000
104929	1678	23760768372000
104930	1678	23760768373000
104931	1678	23760768374000
104932	1678	23760768375000
104933	1678	23760768376000
104934	1678	23760768377000
104935	1678	23760768378000
104936	1678	23760768379000
104937	1678	23760768380000
104938	1678	23760768381000
104939	1678	23760768382000
104940	1678	23760768383000
104941	1678	23760768384000
104942	1678	23760768385000
104943	1678	23760768386000
104944	1678	23760768387000
104945	1678	23760768388000
104946	1678	23760768389000
104947	1678	23760768390000
104948	1678	23760768391000
104949	1678	23760768392000
104950	1678	23760768393000
104951	1678	23760768394000
104952	1678	23760768395000
104953	2112	8641472000000
104954	1874	19944000
104955	1874	19947000
104956	1874	19956000
104957	1874	19957000
104958	1874	19964000
104959	1874	19966000
104960	1874	19968000
104961	1874	19970000
104962	1874	19973000
104963	1874	19976000
104964	1874	19979000
104965	1874	19982000
104966	1874	19985000
104967	1874	19988000
104968	1874	19991000
104969	1874	19997000
104970	1874	20015000
104971	2112	9361472000000
104972	2112	9361504000000
104992	1601	9253878620000
104993	1874	20267000
104994	1874	20280000
104995	1874	20283000
104996	1874	20287000
104997	1874	20289000
104998	1874	20291000
104999	1874	20293000
105000	1874	20303000
105001	1874	20305000
105002	1874	20309000
105003	1874	20311000
105004	1874	20317000
105005	1874	20321000
105006	1874	20323000
105007	1874	20325000
105008	1874	20330000
105009	1874	20333000
105010	1874	20336000
105011	1874	20339000
105012	1874	20348000
105013	1874	20351000
105014	1874	20354000
105015	1874	20357000
105016	1874	20360000
105017	1874	20372000
105018	1874	20375000
105019	1874	20378000
105020	1874	20381000
105021	1601	9973878620000
105022	1601	9974035620000
105029	2133	94061558000
105030	1874	20395000
105031	149	71855264000341
105034	1397	1305666701000
105035	1678	24480780399000
105036	2134	86769597000
105037	1874	20398000
105038	2133	94060556000
105039	1874	20400000
105040	470	71760229000000
105041	470	72480229000000
105052	1637	267846403819988
105053	1637	267846416819988
105060	1602	4896235170000
105062	1397	1305636698000
105063	1678	24480780402000
105064	1397	1305626697000
105065	1678	24480780403000
105066	2134	86766588000
105067	1874	20414000
105068	2133	94057550000
105069	1874	20416000
105070	2133	94056548000
105071	1874	20418000
105072	2132	147924926000
105073	1874	20419000
105074	1395	58192469253957278
105075	1395	58192469277957278
105086	1874	20422000
105087	1700	4554200979053
105096	1397	1305596694000
105097	1678	24480780406000
105098	2133	94053542000
105099	1874	20431000
105100	2134	86763579000
105101	1874	20434000
105104	1397	1305586693000
105105	1678	24480780407000
105106	2134	86762576000
105107	1874	20437000
105108	2132	147923925000
105109	1874	20438000
105110	1688	33119361710020
105111	1688	33119373710020
105131	1397	1305556690000
105132	1678	24480780410000
105133	2133	94049534000
105134	1874	20452000
105135	2132	147922924000
105136	1874	20453000
105137	2134	86759567000
105138	1874	20456000
105139	1394	587529316500000
105140	1394	587529329500000
105170	2133	94048532000
105171	1874	20461000
105172	1610	5760118999950
105218	1397	1305476682000
105219	1678	24480780418000
105220	1693	10210650245940
105221	2181	700610585574
105222	1693	10159553583248
105223	438	66702358779471
105224	1693	10112804767742
105225	262	66046804815506
105226	2134	86751543000
105227	1874	20496000
105228	2133	94041518000
105229	1874	20498000
105230	1394	590409378500000
105231	1394	590409420500000
105234	1397	1305466681000
105235	1678	24480780419000
105236	1693	10066055243367
105237	240	66047839524375
105238	1693	10014958580675
105239	304	66702358779471
105240	1693	9968209771540
105241	562	66046828809135
105242	1693	9917113108848
105243	560	66702358779471
105244	1693	9870364356368
105245	441	66046748752480
105246	1693	9503498553907
105247	1772	5023827484556
105248	2134	86750540000
105249	1874	20501000
105250	1547	7194780000000
105276	1693	9244135038735
105277	660	66702358779471
105278	1693	9193040521774
105279	395	66199315633740
105280	1693	9146291712639
105281	394	66046828809135
105282	1397	1305446679000
105125	1678	24480780409000
105126	2134	86760570000
105127	1874	20448000
105128	2133	94050536000
105129	1874	20450000
105130	1506	4612624967172
105141	1509	9743235503835
105142	1509	9743248503835
105189	1637	267846428819988
105232	1594	9361663000000
105233	1594	9361705000000
105251	2133	94040516000
105252	1874	20500000
105253	1874	20503000
105254	1547	7194781000000
105257	1397	1305456680000
105258	1678	24480780420000
105259	1693	9452401891215
105260	653	66702358779471
105261	1693	9401305228523
105262	373	66702358779471
105263	1693	9350208565831
105264	92	66702358779471
105265	1693	9346328364119
105266	710	5053208998381
105267	1693	9295231701427
105268	1961	701270954698
105269	2133	94039514000
105270	1874	20505000
105271	2132	147919921000
105272	1874	20506000
105273	369	73716427290830
105415	1874	20538000
105416	1874	20541000
105417	1874	20544000
105418	1684	10082930219748
105423	1684	10082932219748
105440	1693	6702979030556
105441	225	66702358779471
105442	1397	1305356670000
105443	1678	24480780430000
105444	1397	1305346669000
105445	1678	24480780431000
105446	1397	1305336668000
105447	1678	24480780432000
105448	1693	6651882367864
105449	2164	701019585574
105450	1693	6600785705172
105451	99	66702358779471
105452	1693	6549689042480
105453	206	66702358779471
105454	1693	6498592379788
105455	122	66702358779471
105456	1693	6451843359622
105457	443	66047127020166
105458	1693	6400746696930
105459	691	66702358779471
105460	1693	6349650034238
105461	377	66702358779471
105462	1693	6298553371546
105463	49	66702358779471
105464	1693	6251804556040
105465	530	66625396763316
105466	1693	6014301240164
105467	893	310088064614009
105468	1693	5963204577472
105469	54	66702358779471
105470	1693	5912107914780
105471	217	66702358779471
105472	1693	5864848576916
105473	603	66768259337864
105474	1693	5818099767781
105475	165	66046828809135
105476	1693	5767003105089
105477	194	66702358779471
105478	1693	5715906442397
105479	339	66702358779471
105480	1693	5664809779705
105481	105	66702358779471
105482	2134	86740510000
105483	1874	20554000
105484	2134	86739507000
105485	1874	20557000
105486	1874	20559000
105487	2133	94029494000
105488	1874	20561000
105489	2133	94028492000
105490	1874	20563000
105491	2133	94027490000
105492	1874	20565000
105493	2132	147916918000
105494	1874	20566000
105495	1395	58193189494957278
105496	1397	1305326667000
105497	1678	24480780433000
105498	1693	5613713117013
105499	322	66702358779471
105500	1693	5562616454321
105501	252	66702358779471
105502	1693	5515867708926
105503	636	66046738745395
105504	1693	5514441307150
105505	1778	5451506401776
105506	1693	5463344644458
105507	146	66702358779471
105508	1693	5416593958696
105509	114	66049473685762
105510	2133	94026488000
105511	1874	20568000
105512	2134	86738504000
105513	1874	20571000
105514	1541	2162193000000
105515	1541	2162265000000
105560	1693	3551786436625
105561	450	66702358779471
105562	1688	32399371710020
105563	646	66000007920000
105564	1688	33119370720020
105586	1397	1305286663000
105587	1678	24480780437000
105588	1693	3320174559771
105589	2017	700958113870
105590	1693	3269077897079
105591	520	66702358779471
105592	1693	3217981234387
105593	452	66702358779471
105594	1693	3166884571695
105595	652	66702358779471
105596	1693	3120134133789
105597	354	66049130437906
105598	1693	3069037471097
105599	569	66702358779471
105600	2134	86734492000
105601	1874	20586000
105602	2132	147914916000
105603	1874	20589000
105604	1874	20591000
105605	2133	94022480000
105606	1874	20593000
105607	1555	6725756540449
105608	1555	6725893540449
105619	1649	7671485999968
105620	1649	7671507999968
105640	1723	5041644085979
105641	1723	5041657085979
105656	1397	1305236658000
105657	1678	24480780442000
105658	1693	2766805348502
105659	551	66702358779471
105660	1693	2720056603107
105661	366	66046738745395
105662	1693	2668959940415
105663	82	66702358779471
105664	1693	2617863277723
105665	680	66702358779471
105666	1693	2571113753348
105667	342	66047839524375
105668	1693	2520017090656
105669	361	66052356779471
105670	2134	86730480000
105671	1874	20614000
105672	2133	94017470000
105673	1874	20616000
105674	1508	8120267156616
105675	1508	8120339156616
105754	1397	1305186653000
105755	1678	24480780447000
105756	2132	147911913000
105757	1874	20638000
105758	2134	86725465000
105759	1874	20641000
105760	2133	94012460000
105761	1874	20643000
105762	2148	3600083880750
105763	2148	3600096880750
105816	1693	1599490548141
105817	312	66046738745395
105818	1693	1596625228230
105819	1772	5026682804467
105820	1693	1595527611252
105821	1811	1919507019037
105822	1693	1548778802117
105823	649	66046828809135
105824	1397	1305116646000
105825	1678	24480780454000
105283	1678	24480780421000
105284	1693	9140863430240
105285	29	7074492597754
105286	1693	9089766767548
105287	251	66702358779471
105288	1693	9038670104856
105289	91	66702358779471
105290	1693	8987573442164
105291	89	66702358779471
105292	1693	8847241097656
105293	1811	1918419402059
105294	1693	8796144434964
105295	84	66702358779471
105296	1693	8745047772272
105297	390	66702358779471
105298	1693	8355745817802
105299	910	508128148220237
105300	1513	33121153000000
105301	1693	8304649155110
105302	658	66702358779471
105303	1397	1305436678000
105304	1678	24480780422000
105305	2133	94038512000
105306	1874	20508000
105307	2133	94037510000
105308	1874	20510000
105309	2134	86749537000
105310	1874	20513000
105311	2134	86748534000
105312	1874	20516000
105313	1513	33841153000000
105314	1513	33841177000000
105315	1397	1305426677000
105316	1678	24480780423000
105317	1693	8253552492418
105318	150	66702358779471
105319	1693	8206803683283
105320	154	66046828809135
105321	1693	8155707020591
105322	593	66701357779471
105323	1693	8104610357899
105324	180	66702358779471
105325	1693	8102474176971
105326	711	3004516180928
105327	1693	8051377514279
105328	245	66702358779471
105329	2134	86747531000
105330	1874	20519000
105331	2132	147918920000
105332	1874	20520000
105333	2296	0
105334	1688	33118361710020
105335	1688	33118433710020
105377	1718	4578612519070
105422	1991	7101332355805
105434	1874	20551000
105435	1684	10802932219748
105436	1684	10802953219748
105609	1397	1305276662000
105610	1678	24480780438000
105611	1693	3017940808405
105612	352	66702358779471
105613	2134	86733489000
105614	1874	20596000
105615	2133	94021478000
105616	1874	20598000
105617	1717	4140973000055
105618	1717	4140995000055
105621	1397	1305266661000
105622	1678	24480780439000
105623	2134	86732486000
105624	1874	20601000
105625	2133	94020476000
105626	1874	20603000
105627	1711	6186779000000
105628	1711	6186791000000
105639	1394	593289506500000
105642	1397	1305246659000
105643	1678	24480780441000
105644	1693	2966844145713
105645	663	66702358779471
105646	1693	2915747483021
105647	266	66089338779471
105648	1693	2864650820329
105649	191	66702358779471
105650	1693	2817902011194
105651	379	66046828809135
105652	2133	94018472000
105653	1874	20611000
105654	1657	2161167990100
105655	1657	2161218990100
105695	1394	594729506500000
105696	1394	594729578500000
105764	1397	1305176652000
105765	1678	24480780448000
105766	1397	1305166651000
105767	1678	24480780449000
105768	2133	94011458000
105769	1874	20645000
105770	2134	86724462000
105771	1874	20648000
105772	2133	94010456000
105773	1874	20650000
105774	2134	86723459000
105775	1874	20653000
105776	1693	1646217293536
105777	1693	1646241293536
105798	1702	3600474000000
105799	1702	3600499000000
105801	1397	1305136648000
105802	1678	24480780452000
105803	1397	1305126647000
105804	1678	24480780453000
105805	2133	94007450000
105806	1874	20666000
105807	1394	597609729500000
105808	2133	94006448000
105809	1874	20668000
105810	2134	86720450000
105811	1874	20671000
105812	2134	86719447000
105813	1874	20674000
105814	1394	599049729500000
105815	1394	599049732500000
105914	43	87601032890000
105915	43	87601044890000
105916	1397	1305016636000
105917	1678	24480780464000
105918	2132	147906908000
105919	1874	20726000
105920	1874	20728000
105921	2134	86708414000
105922	1874	20731000
105923	2133	93995426000
105924	1874	20733000
105925	1710	5993921664140
105926	1710	5993935664140
105954	1394	600489781500000
105972	1397	1304946629000
105973	1678	24480780471000
105974	1397	1304936628000
105975	1678	24480780472000
105976	2134	86701393000
105977	1874	20768000
105978	2134	86700390000
105979	1874	20771000
105980	2133	93988412000
105981	1874	20773000
105982	2133	93987410000
105983	1874	20775000
105984	1656	7915378999990
105985	1656	7915402999990
106013	1692	58101187619999
106014	1692	58101199619999
106046	1762	4245338994000
106075	1687	15020326223172
106076	1687	15020365223172
106084	1397	1304816616000
106085	1678	24480780484000
106086	2133	93976388000
106087	1874	20833000
106088	2132	147900902000
106089	1874	20834000
106090	1467	18686974100039
106091	1467	18686986100039
106143	1397	1304766611000
106144	1678	24480780489000
106145	1874	20850000
106146	2134	86684342000
106147	1874	20853000
106148	1874	20854000
106149	2133	93973382000
106150	1874	20856000
106151	2133	93972380000
106152	1874	20858000
106153	2133	93971378000
106154	1874	20860000
106155	1444	6567700329999
106156	1444	6567738329999
106185	1866	14036160040241
106186	481	66538923411010
106187	1866	14031846886335
106188	734	2016331012363
106189	1866	12823976094654
106190	845	574541103991681
105347	1150	614373845207994
105348	1693	7427387611032
105349	163	66702358779471
105350	1397	1305406675000
105351	1678	24480780425000
105352	1693	7376290948340
105353	78	66702358779471
105354	1693	7325194285648
105355	678	66702358779471
105356	1693	7274097622956
105357	108	66702358779471
105358	1693	7272539542275
105359	745	2021283599286
105360	1693	7221442879583
105361	600	66702358779471
105362	1693	7170453163642
105363	112	66088313832720
105364	1693	7119356500950
105365	103	66702358779471
105366	1693	7068259838258
105367	383	66702358779471
105368	2134	86746528000
105369	1874	20525000
105370	2134	86745525000
105371	1874	20528000
105372	2133	94035506000
105373	1874	20530000
105374	2133	94034504000
105375	1874	20532000
105376	1541	1442193000000
105397	1397	1305386673000
105398	1678	24480780427000
105399	1397	1305376672000
105400	1678	24480780428000
105401	1693	6800824502383
105402	2073	700533689541
105403	2133	94032500000
105404	1874	20539000
105405	2132	147917919000
105406	1874	20540000
105407	2133	94031498000
105408	1874	20542000
105409	2134	86743519000
105410	1874	20545000
105411	2134	86742516000
105412	1874	20548000
105413	1670	3600843000000
105414	1670	3600878000000
105421	1395	58193189312957278
105424	1397	1305366671000
105425	1678	24480780429000
105426	1693	6754075693248
105427	237	66046828809135
105428	2133	94030496000
105429	1874	20550000
105430	2134	86741513000
105431	1874	20553000
105432	1439	7183641578477
105433	1439	7183663578477
105438	1874	20546000
105439	1439	7183644578477
105553	2133	94025486000
105554	1874	20574000
105555	1874	20577000
105556	2133	94024484000
105557	1874	20579000
105558	1874	20582000
105559	641	72483804000000
105565	576	70397476726897
105566	1397	1305296664000
105567	1678	24480780436000
105568	1693	3528719370809
105569	10	32582047065816
105570	1693	3477622708117
105571	421	66702358779471
105572	1693	3426526045425
105573	620	66702358779471
105574	1693	3375429382733
105575	594	66702358779471
105576	1693	3371271222463
105577	622	66658400277049
105578	2134	86735495000
105579	1874	20581000
105580	1874	20583000
105581	1874	20585000
105582	2133	94023482000
105583	1874	20587000
105584	576	71117476726897
105585	576	71117540726897
105629	1397	1305256660000
105630	1678	24480780440000
105631	2132	147913915000
105632	1874	20604000
105633	2133	94019474000
105634	1874	20606000
105635	2134	86731483000
105636	1874	20609000
105637	1395	58193909494957278
105638	1395	58193909507957278
105676	1397	1305226657000
105677	1678	24480780443000
105678	1693	2468920427964
105679	499	66702358779471
105680	1693	2417823765272
105681	391	66701248779471
105682	1693	2366727102580
105683	186	66702358779471
105684	1693	2319976664674
105685	458	66049130437906
105686	1693	2273227919279
105687	327	66046738745395
105688	1693	2035724603403
105689	894	310088064614009
105690	2133	94016468000
105691	1874	20618000
105692	2134	86729477000
105693	1874	20621000
105694	1395	58193909566957278
105725	1637	267846506819988
105746	1397	1305196654000
105747	1678	24480780446000
105748	2134	86726468000
105749	1874	20635000
105750	2133	94013462000
105751	1874	20637000
105752	1691	2590946300052
105753	1691	2590958300052
105781	1397	1305156650000
105782	1678	24480780450000
105783	1397	1305146649000
105784	1678	24480780451000
105785	2132	147910912000
105786	1874	20652000
105787	2134	86722456000
105788	1874	20655000
105789	2134	86721453000
105790	1874	20658000
105791	1874	20660000
105792	2133	94009454000
105793	1874	20662000
105794	2133	94008452000
105795	1874	20664000
105796	1394	597609681500000
105797	1394	597609708500000
105800	1703	1440846000000
105862	1397	1305076642000
105863	1678	24480780458000
105864	2133	94001438000
105865	1874	20698000
105866	2134	86714432000
105867	1874	20701000
105868	1395	58193909506957278
105897	1759	21601023999889
105898	1759	21601080999889
105910	2134	86709417000
105911	1874	20725000
105912	2133	93996428000
105913	1874	20727000
105962	1397	1304956630000
105963	1678	24480780470000
105964	2132	147904906000
105965	1874	20760000
105966	2133	93989414000
105967	1874	20762000
105968	2134	86702396000
105969	1874	20765000
105970	1710	6713935664140
105971	1710	6713948664140
105993	1397	1304916626000
105994	1678	24480780474000
105995	2133	93985406000
105996	1874	20782000
105997	2134	86698384000
105998	1874	20785000
105999	2132	147903905000
106000	1874	20786000
106001	2112	10080220000000
106002	2112	10080233000000
106005	1397	1304906625000
106006	1678	24480780475000
106007	2133	93984404000
106008	1874	20788000
106009	2134	86697381000
106010	1874	20791000
106011	1686	10471997700122
105389	748	2723708018119
105390	1693	6851921165075
105391	35	19404322553971
105392	2134	86744522000
105393	1874	20535000
105394	2133	94033502000
105395	1874	20537000
105396	1681	8531247909853
105419	1394	593289493500000
105420	1394	593289528500000
105437	1684	10802954219748
105516	1718	4578540519070
105517	1397	1305316666000
105518	1678	24480780434000
105519	1397	1305306665000
105520	1678	24480780435000
105521	1693	5365497296004
105522	587	66702358779471
105523	1693	5318748437302
105524	238	66046924858702
105525	1693	5267651774610
105526	392	66702358779471
105527	1693	5220902965475
105528	578	66046828809135
105529	1693	5169806302783
105530	408	66702358779471
105531	1693	5118709640091
105532	504	66089288779471
105533	1693	5067612977399
105534	611	66702358779471
105535	1693	5016516314707
105536	500	66702358779471
105537	1693	5012358154437
105538	353	66004148160270
105539	1693	4965609062043
105540	301	66057220092394
105541	1693	4914512399351
105542	601	66702358779471
105543	1693	3602883099317
105544	1276	1712007346748474
105545	2132	147915917000
105546	1874	20572000
105547	2134	86737501000
105548	1874	20575000
105549	2134	86736498000
105550	1874	20578000
105551	641	72483659000000
105552	641	72483802000000
105697	1397	1305216656000
105698	1678	24480780444000
105699	1599	22896943603909
105700	921	507426751732622
105701	1599	18159740119598
105702	1041	909304391472409
105703	1599	14963451280472
105704	1161	613525792096394
105705	1599	6056726097983
105706	1287	1709644171348441
105707	1693	1984627940711
105708	570	66702358779471
105709	1693	1933531278019
105710	399	66702358779471
105711	1693	1931973197338
105712	721	2021283599286
105713	1693	1880876534646
105714	534	66702358779471
105715	1693	1879318453965
105716	731	2021283599286
105717	2132	147912914000
105718	1874	20622000
105719	2134	86728474000
105720	1874	20625000
105721	2133	94015466000
105722	1874	20627000
105723	1394	596169578500000
105724	1394	596169681500000
105726	1397	1305206655000
105727	1678	24480780445000
105728	1693	1828221791273
105729	138	66702358779471
105730	1693	1777125128581
105731	402	66702358779471
105732	1693	1726028465889
105733	275	66702358779471
105734	1693	1028410618920
105735	1030	910561287968894
105736	1693	977313956228
105737	309	66702358779471
105738	1693	926217293536
105739	690	66702358779471
105740	2134	86727471000
105741	1874	20630000
105742	2133	94014464000
105743	1874	20632000
105744	1685	149763387571430
105745	1685	149763459571430
105778	1874	20646000
105779	1874	20649000
105780	1693	1646239293536
105844	1693	1400035229373
105845	320	66420959644087
105846	1397	1305096644000
105847	1678	24480780456000
105848	1397	1305086643000
105849	1678	24480780457000
105850	2133	94003442000
105851	1874	20687000
105852	2132	147908910000
105853	1874	20688000
105854	2133	94002440000
105855	1874	20690000
105856	2134	86716438000
105857	1874	20693000
105858	2134	86715435000
105859	1874	20696000
105860	1656	7195343999990
105861	1656	7195378999990
105871	1693	1398937612395
105872	1811	1920594636015
105873	1397	1305066641000
105874	1678	24480780459000
105875	1397	1305056640000
105876	1678	24480780460000
105877	1397	1305046639000
105878	1678	24480780461000
105879	1693	1396072292484
105880	1772	5029538124378
105881	2134	86713429000
105882	1874	20704000
105883	2134	86712426000
105884	1874	20707000
105885	2134	86711423000
105886	1874	20710000
105887	2132	147907909000
105888	1874	20711000
105889	2133	94000436000
105890	1874	20713000
105891	2133	93999434000
105892	1874	20715000
105893	2133	93998432000
105894	1874	20717000
105895	1685	150483459571430
105896	1685	150483516571430
105927	1397	1305006635000
105928	1678	24480780465000
105929	1397	1304996634000
105930	1678	24480780466000
105931	1397	1304986633000
105932	1678	24480780467000
105933	1397	1304976632000
105934	1678	24480780468000
105935	2134	86707411000
105936	1874	20736000
105937	2134	86706408000
105938	1874	20739000
105939	2133	93994424000
105940	1874	20741000
105941	2133	93993422000
105942	1874	20743000
105943	2133	93992420000
105944	1874	20745000
105945	2133	93991418000
105946	1874	20747000
105947	2132	147905907000
105948	1874	20748000
105949	2134	86705405000
105950	1874	20751000
105951	2134	86704402000
105952	1874	20754000
105953	1670	3600892000000
105955	1397	1304966631000
105956	1678	24480780469000
105957	2134	86703399000
105958	1874	20757000
105959	2133	93990416000
105960	1874	20759000
105961	1596	3600096000000
105986	1444	5847700329999
105987	1397	1304926627000
105988	1678	24480780473000
105989	2134	86699387000
105990	1874	20778000
105991	2133	93986408000
105992	1874	20780000
106015	1397	1304896624000
105826	1397	1305106645000
105827	1678	24480780455000
105828	1693	1497682139425
105829	205	66702358779471
105830	1693	1450932756681
105831	120	66047639382744
105832	2132	147909911000
105833	1874	20675000
105834	2134	86718444000
105835	1874	20678000
105836	2134	86717441000
105837	1874	20681000
105838	2133	94005446000
105839	1874	20683000
105840	2133	94004444000
105841	1874	20685000
105842	1679	15838961654000
105843	1679	15839046654000
105869	1419	14688188560130
105870	1419	14688200560130
105899	1397	1305036638000
105900	1678	24480780462000
105901	2134	86710420000
105902	1874	20720000
105903	2133	93997430000
105904	1874	20722000
105905	1394	600489732500000
105906	1394	600489744500000
105907	1397	1305026637000
105908	1678	24480780463000
105909	1602	4896233170000
106003	1633	17316762975638
106004	1633	17316775975638
106047	1684	11522953219748
106048	1684	11522965219748
106119	1397	1304796614000
106120	1678	24480780486000
106121	2133	93974384000
106122	1874	20841000
106123	2134	86687351000
106124	1874	20844000
106125	1650	5152887000000
106126	1650	5152899000000
106171	1687	844971103402
106172	1866	14175294119770
106173	1397	1304746609000
106174	1678	24480780491000
106175	2134	86682336000
106176	1874	20869000
106177	2133	93969374000
106178	1874	20871000
106179	1601	10693704620000
106180	1601	10693816620000
106220	1693	2116072292484
106221	1693	2116684292484
106288	1397	1304646599000
106289	1678	24480780501000
106290	2134	86671303000
106291	1874	20927000
106292	2133	93958352000
106293	1874	20929000
106294	470	73200229000000
106295	470	73200251000000
106308	1397	1304626597000
106309	1678	24480780503000
106310	1397	1304616596000
106311	1678	24480780504000
106312	1397	1304606595000
106313	1678	24480780505000
106314	1397	1304596594000
106315	1678	24480780506000
106316	2246	0
106317	2112	12766633101924
106318	2132	147894896000
106319	1874	20935000
106320	2132	147893895000
106321	1874	20936000
106322	2133	93956348000
106323	1874	20938000
106324	2134	86669297000
106325	1874	20941000
106326	2134	86668294000
106327	1874	20944000
106328	2134	86667291000
106329	1874	20947000
106330	2134	86666288000
106331	1874	20950000
106332	2133	93955346000
106333	1874	20952000
106334	2133	93954344000
106335	1874	20954000
106336	2133	93953342000
106337	1874	20956000
106338	1394	601929744500000
106339	1394	601929804500000
106369	1394	603369804500000
106370	1394	603369819500000
106378	43	87601043890000
106468	1874	21018000
106469	1874	21021000
106470	641	73203814000000
106532	1397	1304386573000
106533	1678	24480780527000
106534	2134	86646228000
106535	1874	21062000
106536	2133	93932300000
106537	1874	21064000
106538	1637	267126415819988
106566	1637	268566415819988
106567	1637	268566440819988
106570	1397	1304346569000
106571	1678	24480780531000
106572	2133	93928292000
106573	1874	21082000
106574	2134	86642216000
106575	1874	21085000
106576	1723	5041656085979
106596	1874	21091000
106597	1394	604809819500000
106598	1394	604809831500000
106610	1397	1304306565000
106611	1678	24480780535000
106612	1397	1304296564000
106613	1678	24480780536000
106614	2134	86639207000
106615	1874	21101000
106616	2133	93924284000
106617	1874	21103000
106618	2133	93923282000
106619	1874	21105000
106620	2134	86638204000
106621	1874	21108000
106622	2132	147884886000
106623	1874	21109000
106624	55	67440024000000
106625	55	67440049000000
106626	1397	1304286563000
106627	1678	24480780537000
106628	1397	1304276562000
106629	1678	24480780538000
106630	1397	1304266561000
106631	1678	24480780539000
106632	2134	86637201000
106633	1874	21112000
106634	2134	86636198000
106635	1874	21115000
106636	2133	93922280000
106637	1874	21117000
106638	2134	86635195000
106639	1874	21120000
106640	2132	147883885000
106641	1874	21121000
106642	2133	93921278000
106643	1874	21123000
106644	2133	93920276000
106645	1874	21125000
106646	1649	7671522999968
106740	1397	1304146549000
106741	1678	24480780551000
106742	2133	93908252000
106743	1874	21185000
106744	2134	86623159000
106745	1874	21188000
106746	1688	37439449720020
106747	1688	37439461720020
106750	1397	1304136548000
106751	1678	24480780552000
106752	2134	86622156000
106753	1874	21191000
106754	2133	93907250000
106755	1874	21193000
106756	1693	2836696292484
106793	1691	4751013300052
106794	1691	4751035300052
106801	1633	13435820083107
106802	1264	612385279822721
106803	1633	10287637513689
106804	1144	907614042293421
106805	1397	1304076542000
106806	1678	24480780558000
106807	1397	1304066541000
106808	1678	24480780559000
106809	1633	4368537125277
106810	1390	1706466032489164
106811	2133	93901238000
106012	1686	10472009700122
106032	1397	1304876622000
106033	1678	24480780478000
106034	2134	86694372000
106035	1874	20805000
106036	1467	17246973100039
106037	2133	93981398000
106038	1874	20807000
106039	1467	17966973100039
106040	1397	1304866621000
106041	1678	24480780479000
106042	2134	86693369000
106043	1874	20810000
106044	2133	93980396000
106045	1874	20812000
106049	1397	1304856620000
106050	1678	24480780480000
106051	1397	1304846619000
106052	1678	24480780481000
106053	1397	1304836618000
106054	1678	24480780482000
106055	2134	86692366000
106056	1874	20815000
106057	845	573333333200000
106058	2297	3472784111139
106059	2132	147901903000
106060	1874	20816000
106061	2133	93979394000
106062	1874	20818000
106063	2086	333300069
106064	1773	3775000000000
106065	2087	1155375147766
106066	1773	4779872852234
106067	2133	93978392000
106068	1874	20820000
106069	2134	86691363000
106070	1874	20823000
106071	2134	86690360000
106072	1874	20826000
106073	1679	16559046654000
106074	1679	16559085654000
106077	1397	1304826617000
106078	1678	24480780483000
106079	2134	86689357000
106080	1874	20829000
106081	2133	93977390000
106082	1874	20831000
106083	2112	10080232000000
106094	1669	720000000000
106095	1669	720012000000
106117	1555	7445893540449
106118	1555	7445966540449
106159	1397	1304756610000
106160	1678	24480780490000
106161	2132	147898900000
106162	1874	20861000
106163	2133	93970376000
106164	1874	20863000
106165	2298	136988601386
106166	1527	286999963
106167	2134	86683339000
106168	1874	20866000
106169	1419	15408200560130
106170	1419	15408214560130
106181	1687	124932103402
106182	1601	9974615620000
106183	1601	10694615620000
106184	1601	10695375620000
106222	1397	1304716606000
106223	1678	24480780494000
106224	2134	86679327000
106225	1874	20884000
106226	2132	147897899000
106227	1874	20885000
106228	2133	93966368000
106229	1874	20887000
106230	1536	5760109000000
106231	1536	5760122000000
106233	1397	1304706605000
106234	1678	24480780495000
106235	2134	86678324000
106236	1874	20890000
106237	2133	93965366000
106238	1874	20892000
106239	1714	7485542171760
106240	1714	7485554171760
106241	1397	1304696604000
106242	1678	24480780496000
106243	1397	1304686603000
106244	1678	24480780497000
106245	2132	147896898000
106246	1874	20893000
106247	1688	33839370720020
106248	1688	33839391720020
106283	2246	2686411101924
106284	1451	18619317000000
106285	1451	19339317000000
106286	1571	19339318999728
106287	1451	5472155151752
106297	1397	1304636598000
106298	1678	24480780502000
106299	470	73200261000000
106300	2134	86670300000
106301	1874	20932000
106302	2133	93957350000
106303	1874	20934000
106304	1426	7530296000000
106305	1426	7530308000000
106341	1874	20939000
106342	1874	20942000
106343	1874	20945000
106344	1874	20948000
106345	1639	720056000000
106356	1397	1304566591000
106357	1678	24480780509000
106358	2134	86663279000
106359	1874	20965000
106360	2132	147892894000
106361	1874	20966000
106362	2133	93952340000
106363	1874	20968000
106364	2133	93951338000
106365	1874	20970000
106366	2133	93950336000
106367	1874	20972000
106368	1613	22968234600000
106371	1397	1304556590000
106372	1678	24480780510000
106373	2133	93949334000
106374	1874	20974000
106375	1679	16559057654000
106379	1397	1304546589000
106380	1678	24480780511000
106381	1397	1304536588000
106382	1678	24480780512000
106383	1397	1304526587000
106384	1678	24480780513000
106385	2132	147891893000
106386	1874	20975000
106387	2134	86662276000
106388	1874	20978000
106389	2134	86661273000
106390	1874	20981000
106391	2134	86660270000
106392	1874	20984000
106393	1706	8202100450256
106401	1397	1304516586000
106402	1678	24480780514000
106403	2134	86659267000
106404	1874	20987000
106405	1874	20989000
106406	1874	20991000
106407	1874	20993000
106408	2133	93945326000
106409	1874	20995000
106410	1850	9336311949999
106414	1991	7101312355805
106426	1685	150483475571430
106458	1397	1304466581000
106459	1678	24480780519000
106460	2132	147889891000
106461	1874	21017000
106462	2133	93940316000
106463	1874	21019000
106464	2134	86654252000
106465	1874	21022000
106466	641	73203802000000
106467	641	73203815000000
106484	1637	267846427819988
106493	1397	1304426577000
106494	1678	24480780523000
106495	2134	86650240000
106496	1874	21040000
106497	2133	93936308000
106498	1874	21042000
106499	2132	147888890000
106500	1874	21043000
106501	1850	10056318949999
106502	1850	10056331949999
106568	1692	58821211619999
106569	1692	58821236619999
106577	1397	1304336568000
106578	1678	24480780532000
106579	2134	86641213000
106580	1874	21088000
106016	1678	24480780476000
106017	1397	1304886623000
106018	1678	24480780477000
106019	2134	86696378000
106020	1874	20794000
106021	845	576805118311139
106022	2297	1000000000
106023	2134	86695375000
106024	1874	20797000
106025	2132	147902904000
106026	1874	20798000
106027	2133	93983402000
106028	1874	20800000
106029	2133	93982400000
106030	1874	20802000
106031	1395	58193909520957278
106092	1536	5040097000000
106093	1536	5040109000000
106096	1773	4697069091402
106097	2298	81793760832
106098	1397	1304806615000
106099	1678	24480780485000
106100	1773	4641863250848
106101	2298	136989601386
106102	1773	4011885219274
106103	927	509266136284689
106104	1773	2882977904260
106105	1047	912600552829904
106106	1773	2122525554495
106107	1167	614748529681380
106108	1293	1715841505382575
106109	2133	93975386000
106110	1874	20836000
106111	2134	86688354000
106112	1874	20839000
106113	846	573333333200000
106114	2297	6946569222278
106115	1395	58194629520957278
106116	1395	58194629593957278
106127	1397	1304786613000
106128	1678	24480780487000
106129	1397	1304776612000
106130	1678	24480780488000
106131	1874	20837000
106132	1874	20840000
106133	2134	86686348000
106134	1874	20843000
106135	2134	86685345000
106136	1874	20846000
106137	2132	147899901000
106138	1874	20847000
106139	2297	6946568222278
106140	1647	20000000
106141	1596	4320096000000
106142	1596	4320203000000
106157	1714	6765504171760
106158	1714	6765542171760
106199	1866	11616105302973
106200	846	574541103991681
106201	1866	10498102594221
106202	936	507110804697234
106203	1866	8494730518328
106204	1056	908738217092021
106205	1866	7142982930705
106206	1176	613143782960121
106207	1866	3376396745986
106208	1302	1708579668923873
106209	1866	3372461001076
106210	1687	848806848312
106211	1397	1304726607000
106212	1678	24480780493000
106213	2134	86680330000
106214	1874	20879000
106215	2133	93967370000
106216	1874	20881000
106217	1543	720612000000
106249	1397	1304676602000
106250	1678	24480780498000
106251	1397	1304666601000
106252	1678	24480780499000
106253	1397	1304656600000
106254	1678	24480780500000
106255	2133	93964364000
106256	1874	20895000
106257	2132	147895897000
106258	1874	20896000
106259	2133	93963362000
106260	1874	20898000
106261	2133	93962360000
106262	1874	20900000
106263	2133	93961358000
106264	1874	20902000
106265	2133	93960356000
106266	1874	20904000
106267	2133	93959354000
106268	1874	20906000
106269	2134	86677321000
106270	1874	20909000
106271	2134	86676318000
106272	1874	20912000
106273	2134	86675315000
106274	1874	20915000
106275	2134	86674312000
106276	1874	20918000
106277	2134	86673309000
106278	1874	20921000
106279	2134	86672306000
106280	1874	20924000
106281	1691	3310958300052
106282	1691	3311001300052
106296	1451	19339136000000
106340	1639	720060000000
106346	1397	1304586593000
106347	1678	24480780507000
106348	1397	1304576592000
106349	1678	24480780508000
106350	2134	86665285000
106351	1874	20959000
106352	2134	86664282000
106353	1874	20962000
106354	1688	34559391720020
106355	1688	34559413720020
106413	1991	7101308355805
106415	1397	1304506585000
106416	1678	24480780515000
106417	2134	86658264000
106418	1874	20992000
106419	1874	20994000
106420	1874	20996000
106421	1874	20998000
106422	2133	93944324000
106423	1874	21000000
106424	1395	58196069905957278
106425	1395	58196069921957278
106427	1397	1304496584000
106428	1678	24480780516000
106429	2132	147890892000
106430	1874	21001000
106431	2133	93943322000
106432	1874	21003000
106433	2134	86657261000
106434	1874	21006000
106435	1693	2836684292484
106436	1693	2836697292484
106440	1764	23047355100000
106442	1397	1304486583000
106443	1678	24480780517000
106444	2133	93942320000
106445	1874	21008000
106446	2134	86656258000
106447	1874	21011000
106448	1656	7915390999990
106450	1397	1304476582000
106451	1678	24480780518000
106452	2112	12766623101924
106453	2133	93941318000
106454	1874	21013000
106455	2134	86655255000
106456	1874	21016000
106457	1850	9336318949999
106471	1397	1304456580000
106472	1678	24480780520000
106473	1397	1304446579000
106474	1678	24480780521000
106475	2133	93939314000
106476	1874	21024000
106477	2134	86653249000
106478	1874	21027000
106479	2133	93938312000
106480	1874	21029000
106481	2134	86652246000
106482	1874	21032000
106483	1668	5553537000000
106485	1397	1304436578000
106486	1678	24480780522000
106487	2133	93937310000
106488	1874	21034000
106489	2134	86651243000
106490	1874	21037000
106491	1457	31584712040000
106492	1457	31584724040000
106505	1541	2882265000000
106506	1541	2882278000000
106507	1397	1304416576000
106508	1678	24480780524000
106191	1397	1304736608000
106192	1678	24480780492000
106193	2133	93968372000
106194	1874	20873000
106195	2134	86681333000
106196	1874	20876000
106197	1395	58195349593957278
106198	1395	58195349905957278
106218	1619	3600052000000
106219	1619	3600664000000
106232	1611	7335673000000
106306	1717	4860995000055
106307	1717	4861007000055
106376	1599	6776726097983
106377	1599	6776737097983
106394	2133	93948332000
106395	1874	20986000
106396	2133	93947330000
106397	1874	20988000
106398	2133	93946328000
106399	1874	20990000
106400	1706	8202103450256
106411	1688	35279413720020
106412	1688	35279424720020
106437	1874	21004000
106438	1624	722000000000
106439	1624	722002000000
106441	1685	150483472571430
106449	1656	7915401999990
106503	1671	5423870003785
106504	1671	5423883003785
106520	1675	6764208999977
106522	1397	1304396574000
106523	1678	24480780526000
106524	2133	93933302000
106525	1874	21055000
106526	2134	86647231000
106527	1874	21058000
106528	2132	147887889000
106529	1874	21059000
106530	1991	7101310355805
106540	1397	1304376572000
106541	1678	24480780528000
106542	2134	86645225000
106543	1874	21067000
106544	2133	93931298000
106545	1874	21069000
106550	1397	1304366571000
106551	1678	24480780529000
106552	1397	1304356570000
106553	1678	24480780530000
106554	2133	93930296000
106555	1874	21071000
106556	2133	93929294000
106557	1874	21073000
106558	2134	86644222000
106559	1874	21076000
106560	2134	86643219000
106561	1874	21079000
106562	2132	147886888000
106563	1874	21080000
106564	1559	7506060000000
106565	1559	7506085000000
106587	1397	1304326567000
106588	1678	24480780533000
106589	2133	93926288000
106590	1874	21092000
106591	1885	8000000
106592	2132	147885887000
106593	1874	21093000
106594	1471	8585269900000
106595	1471	8585282900000
106607	1637	269286440819988
106608	1637	269286452819988
106648	1397	1304256560000
106649	1678	24480780540000
106650	1397	1304246559000
106651	1678	24480780541000
106652	1397	1304236558000
106653	1678	24480780542000
106654	2133	93919274000
106655	1874	21127000
106656	2134	86634192000
106657	1874	21130000
106658	2134	86633189000
106659	1874	21133000
106660	2134	86632186000
106661	1874	21136000
106662	2133	93918272000
106663	1874	21138000
106664	2133	93917270000
106665	1874	21140000
106666	1422	20305324860211
106677	1688	35999424720020
106678	1688	35999437720020
106687	1506	5332624967172
106688	1506	5332636967172
106712	1601	11413816620000
106713	1601	11413828620000
106722	1397	1304166551000
106723	1678	24480780549000
106724	2133	93910256000
106725	1874	21174000
106726	2134	86625165000
106727	1874	21177000
106728	2132	147880882000
106729	1874	21178000
106730	1458	12185157908540
106731	1458	12185170908540
106782	1580	2880044000000
106783	1580	2880056000000
106797	1397	1304086543000
106798	1678	24480780557000
106799	2133	93902240000
106800	1874	21214000
106842	1395	58198229960957278
106863	1397	1303996534000
106864	1678	24480780566000
106865	43	69600030890000
106866	2028	2521198400000
106867	2133	93893222000
106868	1874	21234000
106869	2132	147875877000
106870	1874	21235000
106871	1602	4896236170000
106876	405	67440000000000
106877	405	67440013000000
106894	1397	1303976532000
106895	1678	24480780568000
106896	1397	1303966531000
106897	1678	24480780569000
106898	1397	1303956530000
106899	1678	24480780570000
106900	2133	93891218000
106901	1874	21239000
106902	2133	93890216000
106903	1874	21241000
106904	2133	93889214000
106905	1874	21243000
106906	2132	147874876000
106907	1874	21244000
106908	1521	1440013000000
106909	1521	1440047000000
106916	1395	58198949960957278
106917	1395	58198949971957278
106920	1397	1303936528000
106921	1678	24480780572000
106922	1397	1303926527000
106923	1678	24480780573000
106924	2132	147873875000
106925	1874	21247000
106926	2133	93887210000
106927	1874	21249000
106928	2133	93886208000
106929	1874	21251000
106930	1394	606249887500000
106944	1633	5088537125277
106945	1633	5088561125277
106946	1397	1303896524000
106947	1678	24480780576000
106948	1397	1303886523000
106949	1678	24480780577000
106950	2133	93882200000
106951	1874	21260000
106952	2133	93881198000
106953	1874	21262000
106954	1447	23193745943000
106955	1447	23193767943000
106969	1708	12308126115923
106975	1506	5332635967172
106977	1397	1303846519000
106978	1678	24480780581000
106979	2133	93877190000
106980	1874	21271000
106981	1702	3600485000000
107030	1397	1303756510000
107031	1678	24480780590000
107032	2133	93869174000
107033	1874	21290000
107034	2134	86618144000
107035	1874	21293000
107121	1397	1303636498000
107122	1678	24480780602000
107123	1397	1303626497000
107124	1678	24480780603000
106509	1397	1304406575000
106510	1678	24480780525000
106511	2134	86649237000
106512	1874	21046000
106513	2133	93935306000
106514	1874	21048000
106515	2133	93934304000
106516	1874	21050000
106517	2134	86648234000
106518	1874	21053000
106519	1619	3600076000000
106521	1692	58101211619999
106531	1588	26135613000000
106539	1573	3459327000000
106546	1588	26855613000000
106547	1588	26855625000000
106548	1874	21066000
106549	1588	26855624000000
106599	1397	1304316566000
106600	1678	24480780534000
106601	2134	86640210000
106602	1874	21096000
106603	2133	93925286000
106604	1874	21098000
106609	1700	5274211979053
106689	1397	1304206555000
106690	1678	24480780545000
106691	1397	1304196554000
106692	1678	24480780546000
106693	2134	86629177000
106694	1874	21154000
106695	2132	147881883000
106696	1874	21155000
106697	2134	86628174000
106698	1874	21158000
106699	2133	93914264000
106700	1874	21160000
106701	2133	93913262000
106702	1874	21162000
106703	1715	18026874436096
106732	1397	1304156550000
106733	1678	24480780550000
106734	2134	86624162000
106735	1874	21181000
106736	2133	93909254000
106737	1874	21183000
106738	1395	58198229945957278
106739	1395	58198229957957278
106757	1397	1304126547000
106758	1678	24480780553000
106759	1397	1304116546000
106760	1678	24480780554000
106761	2134	86621153000
106762	1874	21196000
106763	2134	86620150000
106764	1874	21199000
106765	2133	93906248000
106766	1874	21201000
106767	2133	93905246000
106768	1874	21203000
106769	2132	147879881000
106770	1874	21204000
106771	1850	10776331949999
106772	1850	10776356949999
106795	1749	12965418930000
106796	1749	12965440930000
106818	1710	7433948664140
106819	1710	7434001664140
106828	1397	1304046539000
106829	1678	24480780561000
106830	2133	93898232000
106831	1874	21223000
106832	2028	11156372590000
106833	1310	1709614189931650
106834	2028	8522723500000
106835	1184	613515032910000
106836	2028	4619402040000
106837	1064	909288445330000
106838	2028	2441198400000
106839	944	507417853180000
106840	1458	12905170908540
106841	1458	12905185908540
106844	1397	1304036538000
106845	1678	24480780562000
106846	1397	1304026537000
106847	1678	24480780563000
106848	1397	1304016536000
106849	1678	24480780564000
106850	1397	1304006535000
106851	1678	24480780565000
106852	2132	147876878000
106853	1874	21224000
106854	2133	93897230000
106855	1874	21226000
106856	2133	93896228000
106857	1874	21228000
106858	2133	93895226000
106859	1874	21230000
106860	2133	93894224000
106861	1874	21232000
106862	1394	604809864500000
106874	1670	4320892000000
106875	1670	4320905000000
106892	1681	9251247909853
106893	1681	9251262909853
106931	1749	12965441930000
106970	1397	1303856520000
106971	1678	24480780580000
106972	2133	93878192000
106973	1874	21269000
106974	1394	606249875500000
106982	1703	1440829000000
106997	1397	1303816516000
106998	1678	24480780584000
106999	1397	1303806515000
107000	1678	24480780585000
107001	2133	93874184000
107002	1874	21278000
107003	2132	147869871000
107004	1874	21279000
107005	606	68206608286230
107006	606	68926608286230
107007	1397	1303796514000
107008	1678	24480780586000
107009	2133	93873182000
107010	1874	21281000
107011	1602	5616236170000
107012	1602	5616247170000
107036	1397	1303746509000
107037	1678	24480780591000
107038	2134	86617141000
107039	1874	21296000
107040	2133	93868172000
107041	1874	21298000
107042	1397	1303736508000
107043	1678	24480780592000
107044	1397	1303726507000
107045	1678	24480780593000
107046	1397	1303716506000
107047	1678	24480780594000
107048	1397	1303706505000
107049	1678	24480780595000
107050	2133	93867170000
107051	1874	21300000
107052	2133	93866168000
107053	1874	21302000
107054	2133	93865166000
107055	1874	21304000
107056	2133	93864164000
107057	1874	21306000
107058	2132	147867869000
107059	1874	21307000
107060	2132	147866868000
107061	1874	21308000
107062	2134	86616138000
107063	1874	21311000
107064	2134	86615135000
107065	1874	21314000
107066	2134	86614132000
107067	1874	21317000
107068	2134	86613129000
107069	1874	21320000
107070	1717	4861045000055
107087	1397	1303676502000
107088	1678	24480780598000
107089	2134	86610120000
107090	1874	21333000
107091	2131	190997000
107092	2133	93861158000
107093	1874	21335000
107094	1395	58198949973957278
107097	1397	1303666501000
107098	1678	24480780599000
107099	2134	86609117000
107100	1874	21338000
107101	2133	93860156000
107102	1874	21340000
107103	2132	147865867000
107104	1874	21341000
107105	1476	3600049000000
107106	1476	3600062000000
107159	1397	1303596494000
107160	1678	24480780606000
107161	2134	86602096000
107162	1874	21376000
106581	2133	93927290000
106582	1874	21090000
106583	1395	58196789921957278
106584	1395	58196789933957278
106585	1474	7390483000043
106586	1474	7390495000043
106605	1700	5274200979053
106606	1700	5274212979053
106647	1611	7335697000000
106667	1397	1304226557000
106668	1678	24480780543000
106669	2133	93916268000
106670	1874	21142000
106671	2132	147882884000
106672	1874	21143000
106673	2134	86631183000
106674	1874	21146000
106675	1680	7213260499559
106676	1680	7213273499559
106679	1397	1304216556000
106680	1678	24480780544000
106681	2134	86630180000
106682	1874	21149000
106683	2133	93915266000
106684	1874	21151000
106685	1688	36719437720020
106686	1688	36719449720020
106704	1397	1304186553000
106705	1678	24480780547000
106706	2133	93912260000
106707	1874	21164000
106708	2134	86627171000
106709	1874	21167000
106710	1395	58197509933957278
106711	1395	58197509945957278
106714	1397	1304176552000
106715	1678	24480780548000
106716	2134	86626168000
106717	1874	21170000
106718	2133	93911258000
106719	1874	21172000
106720	1706	8922100450256
106721	1706	8922112450256
106748	1691	4031001300052
106749	1691	4031013300052
106773	1587	6480205000000
106774	1397	1304106545000
106775	1678	24480780555000
106776	2133	93904244000
106777	1874	21206000
106778	2134	86619147000
106779	1874	21209000
106780	1701	6478172500103
106781	1701	6478184500103
106784	1633	15559964847463
106785	1024	506483472011067
106786	1397	1304096544000
106787	1678	24480780556000
106788	2132	147878880000
106789	1874	21210000
106790	2133	93903242000
106791	1874	21212000
106792	1688	37439471720020
106911	1397	1303946529000
106912	1678	24480780571000
106913	2133	93888212000
106914	1874	21246000
106915	1637	269286451819988
106918	1536	6480122000000
106919	1536	6480133000000
106932	1397	1303916526000
106933	1678	24480780574000
106934	1397	1303906525000
106935	1678	24480780575000
106936	2133	93885206000
106937	1874	21253000
106938	2133	93884204000
106939	1874	21255000
106940	2133	93883202000
106941	1874	21257000
106942	2132	147872874000
106943	1874	21258000
106961	1397	1303866521000
106962	1678	24480780579000
106963	2133	93879194000
106964	1874	21266000
106965	2132	147871873000
106966	1874	21267000
106967	1691	5471035300052
106968	1691	5471047300052
106983	1397	1303836518000
106984	1678	24480780582000
106985	2132	147870872000
106986	1874	21272000
106987	2133	93876188000
106988	1874	21274000
106989	1679	17279057654000
106990	1679	17279070654000
107022	1397	1303766511000
107023	1678	24480780589000
107024	2133	93870176000
107025	1874	21287000
107026	2132	147868870000
107027	1874	21288000
107028	1551	720000000000
107029	1551	720012000000
107071	1513	34561177000000
107072	1513	34561227000000
107095	1394	607689875500000
107096	1394	607689888500000
107107	1397	1303656500000
107108	1678	24480780600000
107109	1397	1303646499000
107110	1678	24480780601000
107111	2133	93859154000
107112	1874	21343000
107113	2133	93858152000
107114	1874	21345000
107115	2134	86608114000
107116	1874	21348000
107117	2134	86607111000
107118	1874	21351000
107119	1637	270006452819988
107120	1637	270006476819988
107140	1397	1303616496000
107141	1678	24480780604000
107142	2134	86604102000
107143	1874	21361000
107144	1874	21363000
107145	1874	21365000
107146	2133	93855146000
107147	1874	21367000
107148	1698	7268820550062
107149	1698	7268834550062
107172	1709	2880068000000
107174	1633	14119938847463
107175	1633	11995794083107
107176	1633	8847611513689
107177	2112	7920186000000
107178	2112	10606587101924
107179	1633	2928511125277
107180	633	75070255900000
107181	633	75790255900000
107182	633	75790645900000
107222	1397	1303536488000
107223	1678	24480780612000
107224	2133	93847130000
107225	1874	21406000
107226	2132	147861863000
107227	1874	21407000
107228	2134	86596078000
107229	1874	21410000
107230	1395	58199669972957278
107231	1395	58199669985957278
107262	1740	9810719000000
107263	1397	1303496484000
107264	1678	24480780616000
107265	2133	93843122000
107266	1874	21425000
107267	2134	86593069000
107268	1874	21428000
107269	1394	610569925500000
107270	1394	610569937500000
107286	1702	3600487000000
107297	1397	1303456480000
107298	1678	24480780620000
107299	1397	1303446479000
107300	1678	24480780621000
107301	2133	93839114000
107302	1874	21446000
107303	2134	86589057000
107304	1874	21449000
107305	2134	86588054000
107306	1874	21452000
107307	2133	93838112000
107308	1874	21454000
107309	1679	18719094654000
107310	1679	18719118654000
107353	1394	613449950500000
107354	1394	613450025500000
107357	1397	1303376472000
107358	1678	24480780628000
107359	2133	93831098000
107360	1874	21488000
107361	2134	86581033000
106812	1874	21216000
106813	2133	93900236000
106814	1874	21218000
106815	43	69680031890000
106816	2028	18495268170000
106817	1467	18687027100039
106820	1397	1304056540000
106821	1678	24480780560000
106822	2132	147877879000
106823	1874	21219000
106824	2133	93899234000
106825	1874	21221000
106826	632	73197538000000
106827	632	73197550000000
106843	1685	150483474571430
106872	1394	606249864500000
106873	1394	606249877500000
106878	1397	1303986533000
106879	1678	24480780567000
106880	2133	93892220000
106881	1874	21237000
106882	2028	2487063010000
106883	1310	1709648324321650
106884	2028	2474812480000
106885	1184	613527282440000
106886	2028	2456656500000
106887	1064	909306600310000
106888	2028	2446524320000
106889	944	507427984360000
106890	1599	7496737097983
106891	1599	7496752097983
106910	1394	606249898500000
106956	1397	1303876522000
106957	1678	24480780578000
106958	2133	93880196000
106959	1874	21264000
106960	1471	8585280900000
106976	1489	22944591000000
106991	1397	1303826517000
106992	1678	24480780583000
106993	2133	93875186000
106994	1874	21276000
106995	1650	5872899000000
106996	1650	5872910000000
107013	1397	1303786513000
107014	1678	24480780587000
107015	1397	1303776512000
107016	1678	24480780588000
107017	2133	93872180000
107018	1874	21283000
107019	2133	93871178000
107020	1874	21285000
107021	1623	65523077899898
107073	1397	1303696504000
107074	1678	24480780596000
107075	1397	1303686503000
107076	1678	24480780597000
107077	2134	86612126000
107078	1874	21323000
107079	2134	86611123000
107080	1874	21326000
107081	2133	93863162000
107082	1874	21328000
107083	2133	93862160000
107084	1874	21330000
107085	1679	17999070654000
107086	1679	17999094654000
107132	2133	93857150000
107133	1874	21353000
107134	2133	93856148000
107135	1874	21356000
107136	1874	21359000
107137	1874	21362000
107138	1588	27575625000000
107139	1588	27575650000000
107150	1397	1303606495000
107151	1678	24480780605000
107152	2134	86603099000
107153	1874	21370000
107154	2133	93854144000
107155	1874	21372000
107156	2132	147863865000
107157	1874	21373000
107158	1692	58821224619999
107173	1686	10472008700122
107183	1397	1303586493000
107184	1678	24480780607000
107185	1397	1303576492000
107186	1678	24480780608000
107187	1397	1303566491000
107188	1678	24480780609000
107189	2132	147862864000
107190	1874	21379000
107191	2133	93852140000
107192	1874	21381000
107193	2133	93851138000
107194	1874	21383000
107195	2134	86601093000
107196	1874	21386000
107197	2134	86600090000
107198	1874	21389000
107199	2134	86599087000
107200	1874	21392000
107201	2133	93850136000
107202	1874	21394000
107203	1394	609129888500000
107204	1394	609129925500000
107271	1397	1303486483000
107272	1678	24480780617000
107273	2134	86592066000
107274	1874	21431000
107275	1451	19339125000000
107382	1397	1303346469000
107383	1678	24480780631000
107384	2134	86578024000
107385	1874	21505000
107386	2133	93828092000
107387	1874	21507000
107388	1685	152643579571430
107389	1685	152643591571430
107402	2003	2075960654821
107403	1651	355693450231
107404	1397	1303326467000
107405	1678	24480780633000
107406	1397	1303316466000
107407	1678	24480780634000
107408	2134	86576018000
107409	1874	21516000
107410	2134	86575015000
107411	1874	21519000
107412	2133	93826088000
107413	1874	21521000
107414	2133	93825086000
107415	1874	21523000
107416	2248	7919420000000
107417	2248	7919454000000
107420	1672	3601284000000
107438	1397	1303286463000
107439	1678	24480780637000
107440	1651	350418386014
107441	754	1010530128434
107442	1651	2914145411
107443	462	66694988481206
107444	1397	1303276462000
107445	1678	24480780638000
107446	2134	86572006000
107447	1874	21537000
107448	2134	86571003000
107449	1874	21540000
107450	2133	93822080000
107451	1874	21542000
107452	2133	93821078000
107453	1874	21544000
107454	1395	58200389985957278
107455	1395	58200390029957278
107497	1397	1303226457000
107498	1678	24480780643000
107499	2134	86565988000
107500	1874	21569000
107501	2133	93816068000
107502	1874	21571000
107525	1397	1303196454000
107526	1678	24480780646000
107527	2134	86562979000
107528	1874	21584000
107529	2132	147851853000
107530	1874	21585000
107531	2133	93813062000
107532	1874	21587000
107533	1395	58201110029957278
107534	1395	58201110042957278
107570	1397	1303156450000
107571	1678	24480780650000
107572	2134	86558967000
107573	1874	21606000
107574	2133	93809054000
107575	1874	21608000
107576	1394	616329991500000
107577	1394	616330003500000
107609	1397	1303116446000
107610	1678	24480780654000
107611	2134	86554955000
107612	1874	21625000
107613	2134	86553952000
107614	1874	21628000
107125	2132	147864866000
107126	1874	21352000
107127	2134	86606108000
107128	1874	21355000
107129	2134	86605105000
107130	1874	21358000
107131	1685	150483482571430
107167	1701	7198184500103
107168	1701	7198196500103
107207	1397	1303556490000
107208	1678	24480780610000
107209	2134	86598084000
107210	1874	21397000
107211	2133	93849134000
107212	1874	21399000
107213	1395	58198949972957278
107232	1397	1303526487000
107233	1678	24480780613000
107234	1397	1303516486000
107235	1678	24480780614000
107236	2133	93846128000
107237	1874	21412000
107238	2133	93845126000
107239	1874	21414000
107240	1637	270726510819988
107241	2134	86595075000
107242	1874	21417000
107243	2134	86594072000
107244	1874	21420000
107245	1637	271446510819988
107246	1758	200000006
107247	1796	1601100000
107248	1637	271446512119985
107253	1549	31296313000000
107429	1397	1303296464000
107430	1678	24480780636000
107431	2132	147854856000
107432	1874	21529000
107433	2133	93823082000
107434	1874	21531000
107435	2134	86573009000
107436	1874	21534000
107522	1980	20159495000000
107547	1705	15680774580140
107548	1705	15680786580140
107549	1397	1303176452000
107550	1678	24480780648000
107551	2133	93811058000
107552	1874	21594000
107553	2134	86560973000
107554	1874	21597000
107555	2148	4320096880750
107556	2148	4320108880750
107559	1397	1303166451000
107560	1678	24480780649000
107561	2134	86559970000
107562	1874	21598000
107563	1874	21600000
107564	2133	93810056000
107565	1874	21602000
107566	2132	147850852000
107567	1874	21603000
107568	1447	23913767943000
107569	1447	23913791943000
107586	1397	1303136448000
107587	1678	24480780652000
107588	2134	86556961000
107589	1874	21616000
107590	2132	147849851000
107591	1874	21617000
107592	1671	5423882003785
107607	1541	2882277000000
107623	1397	1303106445000
107624	1678	24480780655000
107625	1397	1303096444000
107626	1678	24480780656000
107627	2134	86552949000
107628	1874	21635000
107629	2134	86551946000
107630	1874	21638000
107631	2133	93804044000
107632	1874	21640000
107633	2133	93803042000
107634	1874	21642000
107635	2132	147848850000
107636	1874	21643000
107637	1395	58202550079957278
107655	1397	1303066441000
107656	1678	24480780659000
107657	2133	93800036000
107658	1874	21656000
107659	2134	86548937000
107660	1874	21659000
107661	1711	6906791000000
107662	1711	6906803000000
107689	1397	1303026437000
107690	1678	24480780663000
107691	2134	86544925000
107692	1874	21678000
107693	2133	93796028000
107694	1874	21680000
107697	1397	1303016436000
107698	1678	24480780664000
107699	2119	194000000
107700	2134	86543922000
107701	1874	21683000
107702	2133	93795026000
107703	1874	21685000
107704	1719	5040168000000
107726	1546	5997330000000
107730	1397	1302986433000
107731	1678	24480780667000
107732	2134	86540913000
107733	1874	21699000
107734	1688	38159472720020
107784	1397	1302926427000
107785	1678	24480780673000
107786	2134	86534895000
107787	1874	21731000
107788	2133	93786008000
107789	1874	21733000
107790	1698	7988834550062
107791	1698	7988846550062
107800	1394	620650040500000
107801	1394	620650052500000
107832	1716	720023000000
107844	1623	66243077899898
107845	1623	66243090899898
107846	1397	1302876422000
107847	1678	24480780678000
107848	2132	147841843000
107849	1874	21755000
107850	2134	86529880000
107851	1874	21758000
107852	1603	61000000
107853	2302	1439000000000
107854	2133	93780998000
107855	1874	21760000
107856	1506	6052649967172
107869	470	73920251000000
107870	470	73920264000000
107886	1397	1302836418000
107887	1678	24480780682000
107888	1493	9000000
107889	2304	719000000000
107890	2134	86525868000
107891	1874	21778000
107892	2133	93776990000
107893	1874	21780000
107894	2132	147840842000
107895	1874	21781000
107896	484	71133876000000
107912	1397	1302806415000
107913	1678	24480780685000
107914	2132	147839841000
107915	1874	21792000
107916	2134	86522859000
107917	1874	21795000
107918	2133	93773984000
107919	1874	21797000
107920	1679	19439118654000
107921	1679	19439131654000
107924	1596	4320109000000
107927	1692	60261262619999
107941	1397	1302776412000
107942	1678	25200791688000
107943	2134	86519850000
107944	1874	21808000
107945	2132	147838840000
107946	1874	21809000
107947	2133	93771980000
107948	1874	21811000
107949	1818	720088890000
107950	1818	720101890000
107969	1397	1302746409000
107970	1678	25200791691000
107971	2134	86516841000
107972	1874	21824000
107973	2133	93768974000
107974	1874	21826000
108027	526	70320197000000
108028	526	70320209000000
108048	1397	1302686403000
108049	1678	25200791697000
108050	2134	86510823000
107163	2133	93853142000
107164	1874	21378000
107165	149	72575264000341
107166	149	72575276000341
107169	1874	21375000
107170	1440	3600178045924
107171	1440	3600189045924
107205	633	75789448900000
107206	633	75789485900000
107214	1397	1303546489000
107215	1678	24480780611000
107216	2134	86597081000
107217	1874	21402000
107218	2133	93848132000
107219	1874	21404000
107220	1637	270726476819988
107221	1637	270726488819988
107249	1874	21413000
107250	1874	21416000
107251	1685	150483504571430
107252	1685	151203504571430
107254	1397	1303506485000
107255	1678	24480780615000
107256	2132	147860862000
107257	1874	21419000
107258	1874	21421000
107259	2133	93844124000
107260	1874	21423000
107261	1440	3600192045924
107276	1397	1303476482000
107277	1678	24480780618000
107278	2133	93842120000
107279	1874	21433000
107280	2134	86591063000
107281	1874	21436000
107282	2133	93841118000
107283	1874	21438000
107284	1703	2160829000000
107285	1703	2160842000000
107287	1397	1303466481000
107288	1678	24480780619000
107289	2132	147859861000
107290	1874	21439000
107291	2134	86590060000
107292	1874	21442000
107293	2133	93840116000
107294	1874	21444000
107295	1394	612009937500000
107296	1394	612009950500000
107311	1397	1303436478000
107312	1678	24480780622000
107313	1397	1303426477000
107314	1678	24480780623000
107315	1397	1303416476000
107316	1678	24480780624000
107317	1397	1303406475000
107318	1678	24480780625000
107319	1397	1303396474000
107320	1678	24480780626000
107321	1397	1303386473000
107322	1678	24480780627000
107323	2132	147858860000
107324	1874	21455000
107325	2134	86587051000
107326	1874	21458000
107327	2134	86586048000
107328	1874	21461000
107329	2132	147857859000
107330	1874	21462000
107331	1549	30576312000000
107332	2134	86585045000
107333	1874	21465000
107334	2133	93837110000
107335	1874	21467000
107336	2133	93836108000
107337	1874	21469000
107338	2133	93835106000
107339	1874	21471000
107340	2133	93834104000
107341	1874	21473000
107342	2133	93833102000
107343	1874	21475000
107344	2133	93832100000
107345	1874	21477000
107346	2134	86584042000
107347	1874	21480000
107348	2134	86583039000
107349	1874	21483000
107350	2134	86582036000
107351	1874	21486000
107352	1688	37439524720020
107355	1685	151923504571430
107356	1685	151923579571430
107365	1397	1303366471000
107366	1678	24480780629000
107367	2134	86580030000
107368	1874	21494000
107369	2133	93830096000
107370	1874	21496000
107371	2132	147856858000
107372	1874	21497000
107373	1717	5581045000055
107374	1717	5581058000055
107390	1397	1303336468000
107391	1678	24480780632000
107392	2133	93827090000
107393	1874	21509000
107394	2132	147855857000
107395	1874	21510000
107396	2134	86577021000
107397	1874	21513000
107398	606	69646608286230
107399	606	69646621286230
107418	1716	720000000000
107419	1716	720034000000
107456	1397	1303266461000
107457	1678	24480780639000
107458	1397	1303256460000
107459	1678	24480780640000
107460	2133	93820076000
107461	1874	21546000
107462	2132	147853855000
107463	1874	21547000
107464	2133	93819074000
107465	1874	21549000
107466	2134	86570000000
107467	1874	21552000
107468	2134	86568997000
107469	1874	21555000
107470	1692	59541224619999
107471	1692	59541249619999
107503	1397	1303216456000
107504	1678	24480780644000
107505	1397	1303206455000
107506	1678	24480780645000
107507	2133	93815066000
107508	1874	21573000
107509	2134	86564985000
107510	1874	21576000
107511	2134	86563982000
107512	1874	21579000
107513	2133	93814064000
107514	1874	21581000
107515	1688	38159461720020
107516	1688	38159485720020
107519	1693	3556696292484
107520	1693	3556720292484
107535	413	66720000000000
107536	413	66720013000000
107557	1874	21595000
107558	2148	4320097880750
107593	576	71117466726897
107594	576	71117478726897
107597	1397	1303126447000
107598	1678	24480780653000
107599	2134	86555958000
107600	1874	21620000
107601	2133	93807050000
107602	1874	21622000
107603	1691	6191047300052
107604	1691	6191059300052
107608	1718	4578470519070
107621	1394	617770003500000
107622	1394	617770017500000
107663	1710	7433958664140
107695	1657	2881218990100
107696	1657	2881230990100
107735	2133	93792020000
107736	1874	21701000
107737	171	72426701696494
107738	171	72426713696494
107792	1397	1302916426000
107793	1678	24480780674000
107794	2134	86533892000
107795	1874	21736000
107796	2133	93785006000
107797	1874	21738000
107798	1637	273606538819988
107799	1637	273606550819988
107818	1768	9106593110000
107819	1768	9106616110000
107834	2248	7919442000000
107835	1397	1302886423000
107836	1678	24480780677000
107837	2133	93782000000
107362	1874	21491000
107363	1440	4320192045924
107364	1440	4320204045924
107375	1397	1303356470000
107376	1678	24480780630000
107377	2134	86579027000
107378	1874	21500000
107379	2133	93829094000
107380	1874	21502000
107381	1394	613449962500000
107400	1394	614889962500000
107401	1394	614889975500000
107421	1397	1303306465000
107422	1678	24480780635000
107423	2133	93824084000
107424	1874	21525000
107425	2134	86574012000
107426	1874	21528000
107427	1271	1348446447000000
107428	1271	1348446459000000
107437	1675	6764187999977
107472	1397	1303246459000
107473	1678	24480780641000
107474	1394	613449972500000
107475	1397	1303236458000
107476	1678	24480780642000
107477	2134	86567994000
107478	1874	21558000
107479	2133	93818072000
107480	1874	21560000
107481	2133	93817070000
107482	1874	21562000
107483	1549	20745605000000
107484	1362	1715178097751650
107485	2132	147852854000
107486	1874	21563000
107487	2134	86566991000
107488	1874	21566000
107489	1549	15516970000000
107490	1116	912247707000000
107491	1549	11989105000000
107492	1236	615511707000000
107493	1549	9071325000000
107494	996	509069236000000
107495	1394	614889972500000
107496	1394	614889991500000
107517	1422	21025324860211
107518	1422	21025348860211
107521	1422	21025344860211
107523	1506	6052635967172
107524	1506	6052659967172
107537	1560	7208599131803
107538	1560	7208612131803
107539	1397	1303186453000
107540	1678	24480780647000
107541	2134	86561976000
107542	1874	21590000
107543	2133	93812060000
107544	1874	21592000
107545	1395	58201830042957278
107546	1395	58201830054957278
107578	1397	1303146449000
107579	1678	24480780651000
107580	2134	86557964000
107581	1874	21611000
107582	2133	93808052000
107583	1874	21613000
107584	2299	719000000000
107585	2299	719012000000
107595	1692	60261249619999
107596	1692	60261261619999
107605	1637	271446488819988
107606	1637	271446500819988
107645	1397	1303076442000
107646	1678	24480780658000
107647	2132	147847849000
107648	1874	21649000
107649	2133	93801038000
107650	1874	21651000
107651	2134	86549940000
107652	1874	21654000
107653	1687	1568806848312
107654	1687	1568819848312
107685	1874	21661000
107686	1874	21663000
107687	1874	21665000
107688	1474	7390517000043
107707	1397	1303006435000
107708	1678	24480780665000
107709	2133	93794024000
107710	1874	21687000
107711	2132	147845847000
107712	1874	21688000
107713	2134	86542919000
107714	1874	21691000
107715	1637	271446501819988
107716	1397	1302996434000
107717	1678	24480780666000
107718	2134	86541916000
107719	1874	21694000
107720	2133	93793022000
107721	1874	21696000
107722	1546	5997318000000
107723	2250	5997327800000
107724	1546	201000000
107725	1758	1601600000
107739	1397	1302976432000
107740	1678	24480780668000
107741	1397	1302966431000
107742	1678	24480780669000
107743	2133	93791018000
107744	1874	21703000
107745	2133	93790016000
107746	1874	21705000
107747	2134	86539910000
107748	1874	21708000
107749	2134	86538907000
107750	1874	21711000
107751	2132	147844846000
107752	1874	21712000
107753	1637	272166501819988
107754	1637	272166526819988
107762	1397	1302946429000
107763	1678	24480780671000
107764	2133	93788012000
107765	1874	21719000
107766	2134	86536901000
107767	1874	21722000
107768	1637	272886526819988
107769	1637	272886538819988
107779	2133	93787010000
107780	1874	21725000
107781	1874	21728000
107782	1394	619210017500000
107783	1394	619210040500000
107822	1550	0
107823	2301	719000000000
107824	1397	1302896424000
107825	1678	24480780676000
107826	2133	93783002000
107827	1874	21743000
107828	1874	21746000
107829	2134	86531886000
107830	1874	21749000
107831	2248	7919443000000
107842	2106	5759107000000
107843	2106	5759120000000
107859	1397	1302866421000
107860	1678	24480780679000
107861	2134	86528877000
107862	1874	21763000
107863	1531	89000000
107864	2303	719000000000
107865	2133	93779996000
107866	1874	21765000
107867	1696	13403619335104
107868	1980	20159484000000
107983	1694	8458844197225
107984	1694	8458857197225
107987	1678	24480780687000
107988	1678	24480780688000
107989	1678	24480780689000
107990	1678	24480780690000
107991	1678	24480780691000
107992	1678	24480780692000
107993	1874	21766000
107994	1874	21771000
107995	1874	21774000
107996	1874	21777000
107997	1874	21783000
107998	1874	21796000
107999	1874	21798000
108000	1874	21799000
108001	1874	21801000
108002	1874	21807000
108003	1874	21810000
108004	1874	21816000
108005	1874	21820000
108006	1874	21822000
108007	1874	21828000
108008	1768	9826788110000
108037	1711	7626803000000
108038	1711	7626816000000
108046	1571	6912168151480
108047	1571	6912180151480
107615	2133	93806048000
107616	1874	21630000
107617	2133	93805046000
107618	1874	21632000
107619	1395	58202550054957278
107620	1395	58202550068957278
107638	1397	1303086443000
107639	1678	24480780657000
107640	2133	93802040000
107641	1874	21645000
107642	2134	86550943000
107643	1874	21648000
107644	1588	27575637000000
107664	1397	1303056440000
107665	1678	24480780660000
107666	1397	1303046439000
107667	1678	24480780661000
107668	1397	1303036438000
107669	1678	24480780662000
107670	2134	86547934000
107671	1874	21662000
107672	2133	93799034000
107673	1874	21664000
107674	2133	93798032000
107675	1874	21666000
107676	2133	93797030000
107677	1874	21668000
107678	2134	86546931000
107679	1874	21671000
107680	2134	86545928000
107681	1874	21674000
107682	2132	147846848000
107683	1874	21675000
107684	526	69600197000000
107705	1571	6192155151480
107706	1571	6192168151480
107727	1546	66000000001310
107728	45	5997327599990
107729	1758	1602800000
107755	1397	1302956430000
107756	1678	24480780670000
107757	2133	93789014000
107758	1874	21714000
107759	2134	86537904000
107760	1874	21717000
107761	1509	9743247503835
107770	1580	2100034000000
107771	2300	59000000000
107772	1397	1302936428000
107773	1678	24480780672000
107774	2132	147843845000
107775	1874	21723000
107776	2134	86535898000
107777	1874	21726000
107778	1688	38159483720020
107802	1509	10463247503835
107803	1509	10463259503835
107804	1509	10463235503835
107805	1509	10463236503835
107806	1397	1302906425000
107807	1678	24480780675000
107808	1580	24000000
107809	2300	2159000000000
107810	2132	147842844000
107811	1874	21739000
107812	2134	86532889000
107813	1874	21742000
107814	2133	93784004000
107815	1874	21744000
107816	1395	58203270079957278
107817	1395	58203270102957278
107820	1874	21741000
107821	1768	9106615110000
107833	1394	620650063500000
107871	1397	1302856420000
107872	1678	24480780680000
107873	470	73920274000000
107874	2134	86527874000
107875	1874	21768000
107876	2133	93778994000
107877	1874	21770000
107897	1397	1302826417000
107898	1678	24480780683000
107899	1397	1302816416000
107900	1678	24480780684000
107901	2134	86524865000
107902	1874	21784000
107903	2133	93775988000
107904	1874	21786000
107905	2134	86523862000
107906	1874	21789000
107907	2133	93774986000
107908	1874	21791000
107909	1594	9361687000000
107925	1419	16128214560130
107926	1419	16128227560130
107928	1397	1302796414000
107929	1678	24480780686000
107930	2134	86521856000
107931	1874	21800000
107932	1678	25200780686000
107933	1678	25200791686000
107951	1397	1302766411000
107952	1678	25200791689000
107953	1397	1302756410000
107954	1678	25200791690000
107955	1455	1471559000000
107956	2133	93770978000
107957	1874	21813000
107958	2133	93769976000
107959	1874	21815000
107960	2134	86518847000
107961	1874	21818000
107962	2134	86517844000
107963	1874	21821000
107964	1455	2191559000000
107965	1455	2191563000000
108009	1397	1302726407000
108010	1678	25200791693000
108011	2134	86514835000
108012	1874	21835000
108013	2133	93766970000
108014	1874	21837000
108015	1698	8708846550062
108016	1698	8708858550062
108017	1874	21834000
108018	1718	4578479519070
108029	1397	1302706405000
108030	1678	25200791695000
108031	2134	86512829000
108032	1874	21845000
108033	2133	93764966000
108034	1874	21847000
108035	2132	147836838000
108036	1874	21848000
108039	1397	1302696404000
108040	1678	25200791696000
108041	2134	86511826000
108042	1874	21851000
108043	2133	93763964000
108044	1874	21853000
108045	1688	38159473720020
108056	2087	1875375147766
108057	2087	1875387147766
108079	1397	1302666401000
108080	1678	25200791699000
108081	2133	93760958000
108082	1874	21866000
108083	2134	86508817000
108084	1874	21869000
108085	1395	58203990091957278
108086	1395	58203990103957278
108119	1874	21870000
108120	1419	16848266560130
108137	1397	1302606395000
108138	1678	25200791705000
108139	1397	1302596394000
108140	1678	25200791706000
108141	1397	1302586393000
108142	1678	25200791707000
108143	2132	147833835000
108144	1874	21896000
108145	2134	86502799000
108146	1874	21899000
108147	2133	93754946000
108148	1874	21901000
108149	2133	93753944000
108150	1874	21903000
108151	2133	93752942000
108152	1874	21905000
108153	2134	86501796000
108154	1874	21908000
108155	2134	86500793000
108156	1874	21911000
108157	1395	58203990128957278
108181	1397	1302556390000
108182	1678	25200791710000
108183	2297	9362107805640
108184	2133	93749936000
108185	1874	21924000
108186	2134	86497784000
108187	1874	21927000
108188	1691	6911059300052
108189	1691	6911072300052
108210	1637	276486587819988
107838	1874	21751000
107839	2119	193000000
107840	2134	86530883000
107841	1874	21754000
107857	2039	8539373000000
107858	2039	8539387000000
107878	1397	1302846419000
107879	1678	24480780681000
107880	2133	93777992000
107881	1874	21772000
107882	2134	86526871000
107883	1874	21775000
107884	606	70366621286230
107885	606	70366633286230
107910	1650	6592910000000
107911	1650	6592934000000
107922	1394	622090052500000
107923	1394	622090065500000
107934	1397	1302786413000
107935	1678	25200791687000
107936	2134	86520853000
107937	1874	21803000
107938	2133	93772982000
107939	1874	21805000
107940	1395	58203270091957278
107966	1715	18026894436096
107967	1715	18746894436096
107968	1715	18746898436096
107975	1397	1302736408000
107976	1678	25200791692000
107977	2132	147837839000
107978	1874	21827000
107979	2134	86515838000
107980	1874	21830000
107981	2133	93767972000
107982	1874	21832000
107985	1768	9826615110000
107986	1768	9826628110000
108019	1397	1302716406000
108020	1678	25200791694000
108021	2133	93765968000
108022	1874	21839000
108023	2134	86513832000
108024	1874	21842000
108025	1637	274326550819988
108026	1637	274326562819988
108059	1874	21836000
108060	2132	147835837000
108061	1874	21840000
108062	1874	21843000
108063	1686	9752002700122
108064	1874	21846000
108065	1874	21849000
108066	2134	86509820000
108067	1874	21852000
108068	1758	1601700000
108069	1686	10472002600122
108070	1686	1602800000
108071	1758	10472004500122
108177	1874	21920000
108178	1474	7390485000043
108223	1874	21935000
108224	1874	21936000
108225	43	70320030890000
108226	43	70320042890000
108228	1593	30790630000000
108229	1593	30790643000000
108232	1397	1302526387000
108233	1678	25200791713000
108234	2134	86494775000
108235	1874	21941000
108236	2133	93746930000
108237	1874	21943000
108256	1397	1302516386000
108257	1678	25200791714000
108258	2134	86493772000
108259	1874	21946000
108260	2133	93745928000
108261	1874	21948000
108262	2250	117200000
108263	1501	203000000
108264	1569	100000015
108265	1520	720848999991
108266	1520	100000007
108267	1569	720844999999
108268	1520	112200000
108269	1501	100000009
108270	1569	720853999997
108287	1394	623530064500000
108288	1394	623530077500000
108296	1397	1302486383000
108297	1678	25200791717000
108298	2134	86490763000
108299	1874	21962000
108300	2133	93742922000
108301	1874	21964000
108374	1560	7208660131803
108384	1508	8840339156616
108385	1508	8840351156616
108433	1593	30790642000000
108489	1397	1302326367000
108490	1678	25200791733000
108491	2134	86474715000
108492	1874	22047000
108493	1569	847999991
108494	485	68878999000000
108495	2133	93726890000
108496	1874	22049000
108497	606	71086633286230
108498	606	71086646286230
108499	1426	8250308000000
108500	1426	8250321000000
108508	1394	624970090500000
108509	1394	624970102500000
108512	1560	7928660131803
108513	1560	7928672131803
108525	1874	22057000
108526	632	73917562000000
108540	1397	1302276362000
108541	1678	25200791738000
108542	2134	86469700000
108543	1874	22073000
108544	606	71086644286230
108547	1541	3602277000000
108548	1541	3602288000000
108576	1566	1440010000000
108577	1566	1440021000000
108632	1397	1302236358000
108633	1678	25200791742000
108634	1397	1302226357000
108635	1678	25200791743000
108636	1397	1302216356000
108637	1678	25200791744000
108638	2133	93718874000
108639	1874	22088000
108640	2133	93717872000
108641	1874	22090000
108642	2132	147822824000
108643	1874	22091000
108644	2134	86466691000
108645	1874	22094000
108646	2133	93716870000
108647	1874	22096000
108648	1690	156245353000000
108666	1397	1302176352000
108667	1678	25200791748000
108668	2132	147821823000
108669	1874	22103000
108670	2133	93712862000
108671	1874	22105000
108672	2112	14926641101924
108673	2112	14926653101924
108678	2112	14926643101924
108691	1397	1302146349000
108692	1678	25200791751000
108693	2132	147820822000
108694	1874	22110000
108695	2133	93709856000
108696	1874	22112000
108697	1467	19407027100039
108698	1467	19407059100039
108711	1685	153363591571430
108712	1685	153363614571430
108721	1397	1302106345000
108722	1678	25200791755000
108723	2133	93705848000
108724	1874	22123000
108725	2134	86464685000
108726	1874	22126000
108727	2132	147819821000
108728	1874	22127000
108729	1394	626410127500000
108793	1394	627850127500000
108794	1394	627850139500000
108842	2261	4319085000000
108856	1559	8226082999999
108857	1397	1301956330000
108858	1678	25200791770000
108859	1397	1301946329000
108860	1678	25200791771000
108861	1397	1301936328000
108862	1678	25200791772000
108863	1397	1301926327000
108864	1678	25200791773000
108865	2134	86449640000
108051	1874	21856000
108052	2133	93762962000
108053	1874	21858000
108054	2086	720333300069
108055	2086	720345300069
108072	1397	1302676402000
108073	1678	25200791698000
108074	1874	21861000
108075	1874	21862000
108076	2133	93761960000
108077	1874	21864000
108078	1686	10472010700122
108087	1397	1302656400000
108088	1678	25200791700000
108089	1397	1302646399000
108090	1678	25200791701000
108091	1397	1302636398000
108092	1678	25200791702000
108093	1422	21018034190073
108094	715	2015703046640
108095	2133	93759956000
108096	1874	21871000
108097	2133	93758954000
108098	1874	21873000
108099	2133	93757952000
108100	1874	21875000
108101	2132	147834836000
108102	1874	21876000
108103	2134	86507814000
108104	1874	21879000
108105	2134	86506811000
108106	1874	21882000
108107	2134	86505808000
108108	1874	21885000
108109	1447	17718630793000
108110	1345	1709321034299650
108111	1447	14423624653000
108112	1099	909132525338000
108113	1447	12200418023000
108114	1219	613409830595000
108115	1447	10361677683000
108116	979	507330843835000
108117	1419	16848227560130
108118	1419	16848269560130
108129	1458	12905182908540
108136	1394	622090064500000
108168	1397	1302566391000
108169	1678	25200791709000
108170	2133	93750938000
108171	1874	21919000
108172	2297	8154338013959
108173	2134	86498787000
108174	1874	21922000
108175	526	71040209000000
108176	526	71040222000000
108179	1271	1349166459000000
108180	1271	1349166472000000
108238	1422	21018030190073
108239	1447	16998606793000
108240	1447	13703600653000
108241	1447	11480394023000
108242	1447	9641653683000
108243	1569	720845000000
108244	1569	720892000000
108283	1668	6273537000000
108284	1668	6273550000000
108345	1397	1302456380000
108346	1678	25200791720000
108347	1397	1302446379000
108348	1678	25200791721000
108349	1397	1302436378000
108350	1678	25200791722000
108351	2132	147828830000
108352	1874	21976000
108353	2133	93739916000
108354	1874	21978000
108355	2133	93738914000
108356	1874	21980000
108357	2133	93737912000
108358	1874	21982000
108359	1457	21754165600000
108360	1391	1712412932951650
108361	1457	16525559160000
108362	1145	910777100200000
108363	2134	86487754000
108364	1874	21985000
108365	2134	86486751000
108366	1874	21988000
108367	2134	86485748000
108368	1874	21991000
108369	1457	12997869200000
108370	1265	614519166800000
108371	1457	10080197800000
108372	1025	508248407000000
108373	1394	623530125500000
108383	1394	623530076500000
108387	1508	8120819156616
108388	1508	8840819156616
108389	1508	8841589156616
108390	1397	1302416376000
108391	1678	25200791724000
108392	1397	1302406375000
108393	1678	25200791725000
108394	2133	93735908000
108395	1874	21998000
108396	2133	93734906000
108397	1874	22000000
108398	2132	147827829000
108399	1874	22001000
108400	2119	192000000
108401	2134	86483742000
108402	1874	22004000
108403	2134	86482739000
108404	1874	22007000
108405	1394	623530090500000
108407	1397	1302396374000
108408	1678	25200791726000
108409	1593	30790871000000
108410	1874	21947000
108411	1874	21953000
108412	1874	21963000
108413	1874	21965000
108414	1874	21968000
108415	1874	21977000
108416	1874	21979000
108417	1874	21981000
108418	1874	21983000
108419	1874	21987000
108420	1874	21989000
108421	1874	21993000
108422	1874	21995000
108423	1874	21997000
108424	1874	21999000
108425	2133	93733904000
108426	1874	22003000
108427	1874	22006000
108428	1874	22009000
108429	2134	86481736000
108430	1874	22012000
108431	1593	31510871000000
108432	1593	31510909000000
108442	1675	6764636999977
108443	1874	21986000
108444	1874	21992000
108445	1874	22005000
108446	1874	22008000
108447	1874	22011000
108448	1675	7484636999977
108449	1675	7484653999977
108501	1397	1302316366000
108502	1678	25200791734000
108503	2133	93725888000
108504	1874	22051000
108505	2134	86473712000
108506	1874	22054000
108507	1599	7496749097983
108514	2112	14206631101924
108545	1447	11081677683000
108546	1447	11081688683000
108571	1397	1302246359000
108572	1678	25200791741000
108573	2133	93719876000
108574	1874	22086000
108575	1690	156245329000000
108580	1678	24480780693000
108581	1678	24480780694000
108582	1678	24480780695000
108583	1678	24480780696000
108584	1678	24480780697000
108585	1678	24480780698000
108586	1678	24480780699000
108587	1678	24480780700000
108588	1678	24480780701000
108589	1678	24480780702000
108590	1678	24480780703000
108591	1678	24480780704000
108592	1678	24480780705000
108593	1678	24480780706000
108594	1678	24480780707000
108595	1678	24480780708000
108596	1678	24480780709000
108597	1678	24480780710000
108598	1678	24480780711000
108599	1678	24480780712000
108600	1678	24480780713000
108058	1699	2880330750126
108121	1397	1302626397000
108122	1678	25200791703000
108123	2134	86504805000
108124	1874	21888000
108125	2133	93756950000
108126	1874	21890000
108127	1637	275046562819988
108128	1637	275046574819988
108130	1397	1302616396000
108131	1678	25200791704000
108132	2134	86503802000
108133	1874	21893000
108134	2133	93755948000
108135	1874	21895000
108158	1397	1302576392000
108159	1678	25200791708000
108160	2132	147832834000
108161	1874	21912000
108162	2134	86499790000
108163	1874	21915000
108164	2133	93751940000
108165	1874	21917000
108166	1637	275766574819988
108167	1637	275766587819988
108190	1397	1302546389000
108191	1678	25200791711000
108192	2297	8154337013959
108193	1874	21894000
108194	1874	21898000
108195	1874	21900000
108196	1874	21902000
108197	1874	21904000
108198	1874	21906000
108199	1874	21910000
108200	2133	93748934000
108201	1874	21914000
108202	2297	9362106805640
108203	1874	21923000
108204	1874	21926000
108205	1874	21929000
108206	2134	86496781000
108207	1874	21932000
108208	1593	30070617000000
108209	1593	30070718000000
108212	1593	30070630000000
108273	1397	1302506385000
108274	1678	25200791715000
108275	2134	86492769000
108276	1874	21951000
108277	2132	147830832000
108278	1874	21952000
108279	2133	93744926000
108280	1874	21954000
108281	1850	11496356949999
108282	1850	11496369949999
108289	1397	1302496384000
108290	1678	25200791716000
108291	2134	86491766000
108292	1874	21957000
108293	2133	93743924000
108294	1874	21959000
108295	1679	19439130654000
108302	1874	21823000
108303	1874	21825000
108304	1874	21829000
108305	1874	21838000
108306	1874	21841000
108307	1874	21844000
108308	1874	21850000
108309	1874	21865000
108310	1874	21868000
108311	1874	21874000
108312	1874	21877000
108313	1874	21880000
108314	1874	21883000
108315	1874	21886000
108316	1874	21889000
108317	1874	21892000
108318	1874	21907000
108319	1874	21942000
108320	1874	21944000
108321	1874	21950000
108322	1874	21956000
108323	1874	21958000
108324	1874	21960000
108325	1675	6764524999977
108344	2112	13486629101924
108375	1397	1302426377000
108376	1678	25200791723000
108377	2134	86484745000
108378	1874	21994000
108379	2133	93736910000
108380	1874	21996000
108381	1656	8635401999990
108382	1656	8635413999990
108386	1513	34561189000000
108434	1397	1302386373000
108435	1678	25200791727000
108436	2133	93732902000
108437	1874	22014000
108438	2134	86480733000
108439	1874	22017000
108440	1675	7484196999977
108441	1675	7484208999977
108510	2112	14206629101924
108511	2112	14206641101924
108527	1397	1302296364000
108528	1678	25200791736000
108529	1397	1302286363000
108530	1678	25200791737000
108531	2133	93723884000
108532	1874	22062000
108533	2133	93722882000
108534	1874	22064000
108535	2134	86471706000
108536	1874	22067000
108537	2134	86470703000
108538	1874	22070000
108539	1394	624970114500000
108560	1559	7506072000000
108569	1874	22081000
108570	1476	4320073000000
108578	1706	9642112450256
108579	1706	9642123450256
108649	1394	626410114500000
108650	1394	626410149500000
108674	1874	22097000
108675	1874	22099000
108676	1874	22101000
108677	2112	14926687101924
108679	1397	1302166351000
108680	1678	25200791749000
108681	1397	1302156350000
108682	1678	25200791750000
108683	2133	93711860000
108684	1874	22107000
108685	1422	6714554804270
108686	1337	1708019573872989
108687	2133	93710858000
108688	1874	22109000
108689	1439	7183674578477
108730	1397	1302096344000
108731	1678	25200791756000
108732	1397	1302086343000
108733	1678	25200791757000
108734	2134	86463682000
108735	1874	22130000
108736	2134	86462679000
108737	1874	22133000
108738	2133	93704846000
108739	1874	22135000
108740	2133	93703844000
108741	1874	22137000
108742	1711	8346816000000
108743	1711	8346840000000
108744	1397	1302076342000
108745	1678	25200791758000
108746	1397	1302066341000
108747	1678	25200791759000
108748	1397	1302056340000
108749	1678	25200791760000
108750	1397	1302046339000
108751	1678	25200791761000
108752	2134	86461676000
108753	1874	22140000
108754	2134	86460673000
108755	1874	22143000
108756	2132	147818820000
108757	1874	22144000
108758	2132	147817819000
108759	1874	22145000
108760	2133	93702842000
108761	1874	22147000
108762	2133	93701840000
108763	1874	22149000
108764	2133	93700838000
108765	1874	22151000
108766	2133	93699836000
108767	1874	22153000
108768	2134	86459670000
108769	1874	22156000
108770	2134	86458667000
108771	1874	22159000
108772	1719	5040205000000
108211	1637	276486600819988
108213	1397	1302536388000
108214	1678	25200791712000
108215	2133	93747932000
108216	1874	21934000
108217	2134	86495778000
108218	1874	21937000
108219	2132	147831833000
108220	1874	21938000
108221	1593	30790718000000
108222	1593	30790731000000
108227	1649	7671498999968
108230	1571	7632180151480
108231	1571	7632193151480
108245	1874	21859000
108246	1874	21860000
108247	1874	21863000
108248	1874	21867000
108249	1874	21887000
108250	1874	21916000
108251	1874	21918000
108252	1874	21928000
108253	1874	21930000
108254	1874	21940000
108255	1569	721061000000
108271	1569	100000017
108272	1520	720848999989
108285	1395	58204710128957278
108286	1395	58204710141957278
108326	1397	1302476382000
108327	1678	25200791718000
108328	1397	1302466381000
108329	1678	25200791719000
108330	2134	86489760000
108331	1874	21967000
108332	2133	93741920000
108333	1874	21969000
108334	2133	93740918000
108335	1874	21971000
108336	1422	19077349239740
108337	971	506944567057213
108338	2134	86488757000
108339	1874	21974000
108340	2132	147829831000
108341	1874	21975000
108342	2112	13486623101924
108343	2112	13486649101924
108406	1690	156245344000000
108450	1397	1302376372000
108451	1678	25200791728000
108452	1397	1302366371000
108453	1678	25200791729000
108454	1474	6665473000043
108455	2305	4000000000
108456	1397	1302356370000
108457	1678	25200791730000
108458	1397	1302346369000
108459	1678	25200791731000
108460	1397	1302336368000
108461	1678	25200791732000
108462	1422	16730882166024
108463	1211	612942786305089
108464	2132	147826828000
108465	1874	22018000
108466	2132	147825827000
108467	1874	22019000
108468	2133	93731900000
108469	1874	22021000
108470	2133	93730898000
108471	1874	22023000
108472	2133	93729896000
108473	1874	22025000
108474	2133	93728894000
108475	1874	22027000
108476	2133	93727892000
108477	1874	22029000
108478	2134	86479730000
108479	1874	22032000
108480	2134	86478727000
108481	1874	22035000
108482	2134	86477724000
108483	1874	22038000
108484	2134	86476721000
108485	1874	22041000
108486	2134	86475718000
108487	1874	22044000
108488	1395	58204710201957278
108515	1397	1302306365000
108516	1678	25200791735000
108517	2133	93724886000
108518	1874	22056000
108519	2134	86472709000
108520	1874	22059000
108521	2132	147824826000
108522	1874	22060000
108523	632	73917550000000
108524	632	73917563000000
108549	1397	1302266361000
108550	1678	25200791739000
108551	2133	93721880000
108552	1874	22075000
108553	2132	147823825000
108554	1874	22076000
108555	2134	86468697000
108556	1874	22079000
108557	1559	6786073000000
108558	1520	100000016
108559	1559	7506072999999
108561	1397	1302256360000
108562	1678	25200791740000
108563	2134	86467694000
108564	1874	22082000
108565	2133	93720878000
108566	1874	22084000
108567	1476	4320062000000
108568	1476	4320074000000
108690	1439	7183654578477
108702	1397	1302136348000
108703	1678	25200791752000
108704	1397	1302126347000
108705	1678	25200791753000
108706	2133	93708854000
108707	1874	22114000
108708	2133	93707852000
108709	1874	22116000
108710	1709	2880080000000
108713	1397	1302116346000
108714	1678	25200791754000
108715	2133	93706850000
108716	1874	22118000
108717	2134	86465688000
108718	1874	22121000
108719	1690	156965353000000
108720	1690	156965365000000
108773	1397	1302036338000
108774	1678	25200791762000
108775	2134	86457664000
108776	1874	22162000
108777	2133	93698834000
108778	1874	22164000
108779	1688	38879473720020
108780	1688	38879485720020
108791	1679	20879142654000
108792	1679	20879154654000
108805	1397	1302006335000
108806	1678	25200791765000
108807	2132	147816818000
108808	1874	22175000
108809	2133	93695828000
108810	1874	22177000
108811	2134	86454655000
108812	1874	22180000
108813	1634	10462988259504
108814	1634	10463001259504
108823	1440	5040204045924
108824	1440	5040216045924
108828	1397	1301986333000
108829	1678	25200791767000
108830	1397	1301976332000
108831	1678	25200791768000
108832	2132	147815817000
108833	2133	93693824000
108834	2133	93692822000
108835	1874	22187000
108836	1874	22190000
108837	2134	86452649000
108838	1874	22193000
108839	2134	86451646000
108840	1874	22196000
108841	1688	38879499720020
108845	1874	22186000
108846	1874	22188000
108847	2261	4319084000000
108905	1593	31510642000000
108906	1593	31510654000000
108908	1397	1301906325000
108909	1678	25200791775000
108910	2134	86444625000
108911	1874	22230000
108912	1395	58206150213957278
108913	1395	58206150224957278
108932	1397	1301876322000
108933	1678	25200791778000
108934	1397	1301866321000
108935	1678	25200791779000
108601	1678	24480780714000
108602	1678	24480780715000
108603	1678	24480780716000
108604	1678	24480780717000
108605	1678	24480780718000
108606	1678	24480780719000
108607	1678	24480780720000
108608	1678	24480780721000
108609	1678	24480780722000
108610	1678	24480780723000
108611	1678	24480780724000
108612	1678	24480780725000
108613	1678	24480780726000
108614	1678	24480780727000
108615	1678	24480780728000
108616	1678	24480780729000
108617	1678	24480780730000
108618	1678	24480780731000
108619	1678	24480780732000
108620	1678	24480780733000
108621	1678	24480780734000
108622	1678	24480780735000
108623	1678	24480780736000
108624	1678	24480780737000
108625	1678	24480780738000
108626	1678	24480780739000
108627	1678	24480780740000
108628	1678	24480780741000
108629	1706	8923114450256
108630	1706	9643114450256
108631	1706	9643132450256
108651	1397	1302206355000
108652	1678	25200791745000
108653	1397	1302196354000
108654	1678	25200791746000
108655	1397	1302186353000
108656	1678	25200791747000
108657	1422	13253192154809
108658	1091	908440320665449
108659	2133	93715868000
108660	1874	22098000
108661	2133	93714866000
108662	1874	22100000
108663	2133	93713864000
108664	1874	22102000
108665	1650	6592944000000
108699	1874	22111000
108700	1673	32580688000000
108701	1673	32580719000000
108783	1397	1302026337000
108784	1678	25200791763000
108785	2134	86456661000
108786	1874	22167000
108787	2133	93697832000
108788	1874	22169000
108789	1850	12216369949999
108790	1850	12216381949999
108797	1397	1302016336000
108798	1678	25200791764000
108799	2134	86455658000
108800	1874	22172000
108801	2133	93696830000
108802	1874	22174000
108803	1395	58205430201957278
108804	1395	58205430213957278
108854	1559	8226072999999
108855	1559	8226084999999
108888	1397	1301916326000
108889	1678	25200791774000
108890	1874	22015000
108891	1874	22016000
108892	1874	22020000
108893	1593	32230909000000
108894	1593	32231408000000
108918	1397	1301896324000
108919	1678	25200791776000
108920	1397	1301886323000
108921	1678	25200791777000
108922	2134	86443622000
108923	1874	22233000
108924	1874	22234000
108925	2134	86442619000
108926	1874	22237000
108927	2133	93685808000
108928	1874	22239000
108929	2133	93684806000
108930	1874	22241000
108931	1671	5423895003785
109005	1780	1438922000000
109025	1397	1301766311000
109026	1678	25200791789000
109027	2133	93672782000
109028	1874	22302000
109029	2134	86430583000
109030	1874	22305000
109079	1749	13685441930000
109080	1749	13685466930000
109088	1397	1301696304000
109089	1678	25200791796000
109090	2133	93664766000
109091	1874	22344000
109092	2134	86422559000
109093	1874	22347000
109094	1649	8391510999968
109095	1649	8391522999968
109097	1397	1301686303000
109098	1678	25200791797000
109099	2134	86421556000
109100	1874	22350000
109101	2132	147806808000
109102	1874	22351000
109103	2133	93663764000
109104	1874	22353000
109105	1394	632170164500000
109106	1394	632170165500000
109139	1593	31510655000000
109163	1397	1301616296000
109164	1678	25200791804000
109165	2134	86414535000
109166	1874	22387000
109167	2132	147804806000
109168	1874	22388000
109169	2133	93656750000
109170	1874	22390000
109171	1458	12905183908540
109174	1397	1301606295000
109175	1678	25200791805000
109176	2134	86413532000
109177	1874	22393000
109178	2133	93655748000
109179	1874	22395000
109180	1394	633610177500000
109212	1397	1301566291000
109213	1678	25200791809000
109214	2134	86409520000
109215	1874	22414000
109216	2133	93651740000
109217	1874	22416000
109314	1397	1301456280000
109315	1678	25200791820000
109316	2132	147799801000
109317	1874	22450000
109318	1874	22452000
109319	1874	22454000
109320	1874	22456000
109321	1874	22462000
109322	1874	22468000
109323	2134	86398487000
109324	1874	22471000
109325	1874	22473000
109326	2133	93640718000
109327	1874	22475000
109328	1637	278646623819988
109329	1637	278646685819988
109344	1397	1301426277000
109345	1678	25200791823000
109346	1397	1301416276000
109347	1678	25200791824000
109348	2132	147798800000
109349	1874	22486000
109350	2133	93637712000
109351	1874	22488000
109352	2133	93636710000
109353	1874	22490000
109354	2134	86395478000
109355	1874	22493000
109356	2134	86394475000
109357	1874	22496000
109358	1395	58208310249957278
109359	1395	58208310274957278
109393	2134	86390463000
109394	1874	22517000
109395	1685	154083615571430
109452	1397	1301296264000
109453	1678	25200791836000
109454	2133	93624686000
109455	1874	22553000
109456	2134	86383442000
109457	1874	22556000
109458	1394	635050177500000
109459	1394	635050189500000
109469	1397	1301276262000
109470	1678	25200791838000
109471	1397	1301266261000
109472	1678	25200791839000
108781	1679	20159130654000
108782	1679	20159142654000
108795	171	73146713696494
108796	171	73146725696494
108815	1397	1301996334000
108816	1678	25200791766000
108817	2134	86453652000
108818	1874	22183000
108819	2133	93694826000
108820	1874	22185000
108821	2306	719000000000
108822	2306	719012000000
108825	1444	6567712329999
108826	1874	22182000
108827	1444	6567711329999
108843	96	68161222000000
108844	96	68161248000000
108848	1397	1301966331000
108849	1678	25200791769000
108850	2133	93691820000
108851	1874	22198000
108852	2134	86450643000
108853	1874	22201000
108887	1422	7434603804270
108895	2134	86445628000
108896	1874	22225000
108897	2133	93686810000
108898	1874	22227000
108899	1394	629290127500000
108900	1394	629290139500000
108903	1702	4320487000000
108904	1702	4320499000000
108907	1703	2160839000000
108916	1690	157685365000000
108917	1690	157685377000000
108956	1397	1301846319000
108957	1678	25200791781000
108958	1397	1301836318000
108959	1678	25200791782000
108960	1397	1301826317000
108961	1678	25200791783000
108962	2134	86438607000
108963	1874	22260000
108964	2134	86437604000
108965	1874	22263000
108966	2134	86436601000
108967	1874	22266000
108968	2133	93680798000
108969	1874	22268000
108970	2133	93679796000
108971	1874	22270000
108972	2133	93678794000
108973	1874	22272000
108974	2132	147811813000
108975	1874	22273000
108976	1654	8777279999798
108977	1654	8777316999798
108995	1394	630730139500000
108996	1394	630730164500000
109024	1394	630730152500000
109033	1397	1301756310000
109034	1678	25200791790000
109035	1397	1301746309000
109036	1678	25200791791000
109037	2134	86429580000
109038	1874	22308000
109039	2134	86428577000
109040	1874	22311000
109041	2133	93671780000
109042	1874	22313000
109043	2133	93670778000
109044	1874	22315000
109045	2132	147808810000
109046	1874	22316000
109047	1711	9066840000000
109048	1711	9066865000000
109050	1397	1301736308000
109051	1678	25200791792000
109052	2133	93669776000
109053	1874	22318000
109054	2134	86427574000
109055	1874	22321000
109056	1395	58207590236957278
109057	1395	58207590248957278
109064	1397	1301726307000
109065	1678	25200791793000
109066	1397	1301716306000
109067	1678	25200791794000
109068	2133	93667772000
109069	1874	22328000
109070	2134	86425568000
109071	1874	22331000
109072	2132	147807809000
109073	1874	22332000
109074	2134	86424565000
109075	1874	22335000
109076	2133	93666770000
109077	1874	22337000
109078	1710	7433973664140
109081	1397	1301706305000
109082	1678	25200791795000
109083	2134	86423562000
109084	1874	22340000
109085	2133	93665768000
109086	1874	22342000
109087	1637	276486599819988
109126	1476	5040074000000
109127	1476	5040098000000
109138	1489	22944593000000
109140	1397	1301646299000
109141	1678	25200791801000
109142	1397	1301636298000
109143	1678	25200791802000
109144	2133	93659756000
109145	1874	22371000
109146	2133	93658754000
109147	1874	22373000
109148	2134	86417544000
109149	1874	22376000
109150	2134	86416541000
109151	1874	22379000
109152	1719	5760205000000
109153	1719	5760229000000
109155	1522	7243584000000
109183	1397	1301596294000
109184	1678	25200791806000
109185	2133	93654746000
109186	1874	22397000
109187	1634	11183012259504
109203	1440	5040217045924
109227	1397	1301546289000
109228	1678	25200791811000
109229	2134	86407514000
109230	1874	22425000
109231	2133	93649736000
109232	1874	22427000
109233	1637	277926611819988
109234	1637	277926623819988
109235	1397	1301536288000
109236	1678	25200791812000
109237	1397	1301526287000
109238	1678	25200791813000
109239	1397	1301516286000
109240	1678	25200791814000
109241	2134	86406511000
109242	1874	22430000
109243	2132	147801803000
109244	1874	22431000
109245	2134	86405508000
109246	1874	22434000
109247	2134	86404505000
109248	1874	22437000
109249	2133	93648734000
109250	1874	22439000
109251	2133	93647732000
109252	1874	22441000
109253	2133	93646730000
109254	1874	22443000
109255	1688	39599485720020
109256	1688	39599522720020
109266	1397	1301496284000
109267	1678	25200791816000
109268	1397	1301486283000
109269	1678	25200791817000
109270	1397	1301476282000
109271	1678	25200791818000
109272	1397	1301466281000
109273	1678	25200791819000
109274	1874	22362000
109275	1874	22364000
109276	1874	22365000
109277	1874	22375000
109278	1874	22378000
109279	1874	22396000
109280	1874	22402000
109281	1874	22405000
109282	1874	22417000
109283	1874	22420000
109284	2134	86402499000
109285	1874	22423000
109286	2134	86401496000
109287	1874	22426000
109288	2134	86400493000
109289	1874	22429000
109290	2134	86399490000
108866	1874	22204000
108867	2132	147814816000
108868	1874	22205000
108869	2134	86448637000
108870	1874	22208000
108871	2134	86447634000
108872	1874	22211000
108873	2134	86446631000
108874	1874	22214000
108875	2133	93690818000
108876	1874	22216000
108877	2133	93689816000
108878	1874	22218000
108879	2133	93688814000
108880	1874	22220000
108881	2133	93687812000
108882	1874	22222000
108883	1422	7434554804270
108884	2275	7434592804278
108885	1422	203000000
108886	1527	294999955
108901	1685	154083614571430
108902	1685	154083626571430
108914	2132	147813815000
108915	1874	22231000
108954	1634	11183001259504
108955	1634	11183038259504
108980	1397	1301816316000
108981	1678	25200791784000
108982	1397	1301806315000
108983	1678	25200791785000
108984	2134	86435598000
108985	1874	22276000
108986	2133	93677792000
108987	1874	22278000
108988	2133	93676790000
108989	1874	22280000
108990	2134	86434595000
108991	1874	22283000
108992	2132	147810812000
108993	1874	22284000
108994	1649	7671510999968
108997	1397	1301796314000
108998	1678	25200791786000
108999	2133	93675788000
109000	1874	22286000
109001	2134	86433592000
109002	1874	22289000
109003	1395	58206870224957278
109004	1395	58206870236957278
109014	1613	22968231600000
109058	2133	93668774000
109059	1874	22323000
109060	2134	86426571000
109061	1874	22326000
109062	1751	1439010000000
109063	1751	1439012000000
109096	1522	6523584000000
109110	1679	20159154654000
109111	1679	20879155654000
109128	1397	1301656300000
109129	1678	25200791800000
109130	2134	86418547000
109131	1874	22366000
109132	2132	147805807000
109133	1874	22367000
109134	2133	93660758000
109135	1874	22369000
109136	1768	10546628110000
109137	1768	10546641110000
109162	1522	6523568000000
109181	1637	277206599819988
109182	1637	277206611819988
109199	1874	22398000
109200	1874	22401000
109201	1874	22404000
109202	2306	719013000000
109204	1397	1301576292000
109205	1678	25200791808000
109206	2133	93652742000
109207	1874	22408000
109208	2134	86410523000
109209	1874	22411000
109210	1451	20059125000000
109211	1451	20059137000000
109262	2133	93645728000
109263	1874	22448000
109264	1740	9810717000000
109265	1703	2160841000000
109330	1397	1301446279000
109331	1678	25200791821000
109332	2134	86397484000
109333	1874	22478000
109334	2133	93639716000
109335	1874	22480000
109360	1679	20879167654000
109362	1397	1301406275000
109363	1678	25200791825000
109364	2133	93635708000
109365	1874	22498000
109366	2134	86393472000
109367	1874	22501000
109368	526	71040221000000
109385	1397	1301376272000
109386	1678	25200791828000
109387	2133	93632702000
109388	1874	22511000
109389	2134	86391466000
109390	1874	22514000
109391	367	66720000000000
109392	367	66720012000000
109396	1397	1301366271000
109397	1678	25200791829000
109398	2133	93631700000
109399	1874	22516000
109400	1874	22519000
109416	1397	1301336268000
109417	1678	25200791832000
109418	2133	93628694000
109419	1874	22532000
109420	2134	86387454000
109421	1874	22535000
109422	526	71760221000000
109423	526	71760233000000
109424	1397	1301326267000
109425	1678	25200791833000
109426	2134	86386451000
109427	1874	22538000
109428	2133	93627692000
109429	1874	22540000
109430	1688	40319522720020
109431	1688	40319534720020
109442	1637	280086709819988
109443	1637	280086722819988
109460	1397	1301286263000
109461	1678	25200791837000
109462	2134	86382439000
109463	1874	22559000
109464	2132	147794796000
109465	1874	22560000
109466	2133	93623684000
109467	1874	22562000
109490	1397	1301246259000
109491	1678	25200791841000
109492	647	66000099000000
109493	2113	543308726895
109494	2133	93619676000
109495	1874	22580000
109496	2134	86378427000
109497	1874	22583000
109498	1395	58208310262957278
109513	1397	1301216256000
109514	1678	25200791844000
109515	2134	86375418000
109516	1874	22596000
109517	2132	147792794000
109518	1874	22597000
109519	1555	7445905540449
109529	1397	1301196254000
109530	1678	25200791846000
109531	1397	1301186253000
109532	1678	25200791847000
109533	2132	147791793000
109534	1874	22603000
109535	2134	86373412000
109536	1874	22606000
109537	2133	93615668000
109538	1874	22608000
109539	2133	93614666000
109540	1874	22610000
109541	2134	86372409000
109542	1874	22613000
109543	1692	60981261619999
109544	1692	60981286619999
109696	1394	636490189500000
109697	1394	636490214500000
109726	1397	1301066241000
109727	1678	25200791859000
109728	2134	86360373000
109729	1874	22674000
109730	2133	93602642000
109731	1874	22676000
109754	1397	1301026237000
109755	1678	25200791863000
109756	2134	86356361000
108936	1397	1301856320000
108937	1678	25200791780000
108938	2133	93683804000
108939	1874	22243000
108940	2133	93682802000
108941	1874	22245000
108942	2132	147812814000
108943	1874	22246000
108944	2133	93681800000
108945	1874	22248000
108946	2134	86441616000
108947	1874	22251000
108948	2134	86440613000
108949	1874	22254000
108950	2134	86439610000
108951	1874	22257000
108952	1701	7918196500103
108953	1701	7918233500103
108978	329	68164612000000
108979	329	68164649000000
109006	1397	1301786313000
109007	1678	25200791787000
109008	2133	93674786000
109009	1874	22291000
109010	2134	86432589000
109011	1874	22294000
109012	1439	7903654578477
109013	1439	7903666578477
109015	1397	1301776312000
109016	1678	25200791788000
109017	2133	93673784000
109018	1874	22296000
109019	2132	147809811000
109020	1874	22297000
109021	2134	86431586000
109022	1874	22300000
109023	1708	12308127115923
109031	1522	5803543000000
109032	1522	5803584000000
109049	1522	5803568000000
109107	1522	5803580000000
109108	1522	6523580000000
109109	1522	6523581000000
109112	1397	1301676302000
109113	1678	25200791798000
109114	1397	1301666301000
109115	1678	25200791799000
109116	2134	86420553000
109117	1874	22356000
109118	2134	86419550000
109119	1874	22359000
109120	2133	93662762000
109121	1874	22361000
109122	2133	93661760000
109123	1874	22363000
109124	1394	633610165500000
109125	1394	633610189500000
109154	171	73146737696494
109156	1397	1301626297000
109157	1678	25200791803000
109158	2133	93657752000
109159	1874	22381000
109160	2134	86415538000
109161	1874	22384000
109172	1419	17568269560130
109173	1419	17568282560130
109188	1397	1301586293000
109189	1678	25200791807000
109190	2133	93653744000
109191	1874	22399000
109192	2132	147803805000
109193	1874	22400000
109194	2134	86412529000
109195	1874	22403000
109196	2134	86411526000
109197	1874	22406000
109198	1440	5040218045924
109218	1397	1301556290000
109219	1678	25200791810000
109220	2133	93650738000
109221	1874	22418000
109222	2134	86408517000
109223	1874	22421000
109224	2132	147802804000
109225	1874	22422000
109226	1395	58207590249957278
109257	1397	1301506285000
109258	1678	25200791815000
109259	2134	86403502000
109260	1874	22446000
109261	1740	9810716000000
109371	1397	1301396274000
109372	1678	25200791826000
109373	1397	1301386273000
109374	1678	25200791827000
109375	2132	147797799000
109376	1874	22502000
109377	2133	93634706000
109378	1874	22504000
109379	2133	93633704000
109380	1874	22506000
109381	2134	86392469000
109382	1874	22509000
109383	1637	279366685819988
109384	1637	279366709819988
109410	1397	1301346269000
109411	1678	25200791831000
109412	2134	86388457000
109413	1874	22528000
109414	2133	93629696000
109415	1874	22530000
109440	1672	4321284000000
109441	1672	4321297000000
109444	1397	1301306265000
109445	1678	25200791835000
109446	2134	86384445000
109447	1874	22549000
109448	2133	93625688000
109449	1874	22551000
109512	1749	13685465930000
109527	1650	7312944000000
109528	1650	7312956000000
109549	1397	1301176252000
109550	1678	25200791848000
109551	2134	86371406000
109552	1874	22618000
109553	484	71853888000000
109567	1693	3556710292484
109621	2134	86369400000
109622	1874	22627000
109623	1874	22629000
109624	2133	93610658000
109625	1874	22631000
109626	2134	86368397000
109627	1874	22634000
109628	1684	11522975219748
109629	1684	11522980219748
109679	2261	5039084000000
109680	2261	5039111000000
109681	1397	1301116246000
109682	1678	25200791854000
109683	1397	1301106245000
109684	1678	25200791855000
109685	2132	147789791000
109686	1874	22645000
109687	2133	93607652000
109688	1874	22647000
109689	2133	93606650000
109690	1874	22649000
109691	2134	86365388000
109692	1874	22652000
109693	2134	86364385000
109694	1874	22655000
109695	1719	5760230000000
109708	1397	1301086243000
109709	1678	25200791857000
109710	2134	86362379000
109711	1874	22663000
109712	2133	93604646000
109713	1874	22665000
109714	2132	147788790000
109715	1874	22666000
109716	1395	58209030262957278
109717	1395	58209030275957278
109718	1397	1301076242000
109719	1678	25200791858000
109720	2133	93603644000
109721	1874	22668000
109722	2134	86361376000
109723	1874	22671000
109724	1395	58209750275957278
109725	1395	58209750287957278
109732	1397	1301056240000
109733	1678	25200791860000
109734	1397	1301046239000
109735	1678	25200791861000
109736	1397	1301036238000
109737	1678	25200791862000
109738	2132	147787789000
109739	1874	22677000
109740	2133	93601640000
109741	1874	22679000
109742	2133	93600638000
109743	1874	22681000
109744	2134	86359370000
109291	1874	22432000
109292	1874	22433000
109293	1874	22435000
109294	1874	22436000
109295	2132	147800802000
109296	1874	22445000
109297	1874	22447000
109298	1874	22449000
109299	1874	22451000
109300	1874	22453000
109301	1874	22455000
109302	1874	22457000
109303	1874	22459000
109304	1874	22461000
109305	2133	93644726000
109306	1874	22463000
109307	2133	93643724000
109308	1874	22465000
109309	2133	93642722000
109310	1874	22467000
109311	2133	93641720000
109312	1874	22469000
109313	1623	66243347899898
109336	1397	1301436278000
109337	1678	25200791822000
109338	2134	86396481000
109339	1874	22483000
109340	2133	93638714000
109341	1874	22485000
109342	1654	9497316999798
109343	1654	9497328999798
109361	149	72575289000341
109369	1474	7385473000043
109370	1474	7385485000043
109401	1397	1301356270000
109402	1678	25200791830000
109403	2132	147796798000
109404	1874	22520000
109405	2133	93630698000
109406	1874	22522000
109407	2134	86389460000
109408	1874	22525000
109409	1601	11413829620000
109432	1397	1301316266000
109433	1678	25200791834000
109434	2134	86385448000
109435	1874	22543000
109436	2132	147795797000
109437	1874	22544000
109438	2133	93626690000
109439	1874	22546000
109450	1980	20879484000000
109451	1980	20879496000000
109468	1611	8055697000000
109499	1749	13685442930000
109500	1397	1301236258000
109501	1678	25200791842000
109502	1397	1301226257000
109503	1678	25200791843000
109504	2133	93618674000
109505	1874	22585000
109506	2134	86377424000
109507	1874	22588000
109508	2133	93617672000
109509	1874	22590000
109510	2134	86376421000
109511	1874	22593000
109545	2133	93613664000
109546	1874	22615000
109547	484	71853876000000
109548	484	71853877000000
109554	1397	1301166251000
109555	1678	25200791849000
109556	2133	93612662000
109557	1874	22620000
109558	2134	86370403000
109559	1874	22623000
109560	1593	20972641000000
109561	1346	1711775637751650
109562	1593	15750640000000
109563	1100	910438465000000
109564	1602	5616250170000
109568	1593	19532616000000
109569	1874	21854000
109570	1874	21855000
109571	1874	21857000
109572	1593	14310615000000
109573	1874	21872000
109574	1874	21878000
109575	1874	21881000
109576	1874	21884000
109577	1874	21966000
109578	1874	21970000
109579	1874	21972000
109580	1874	21973000
109581	1874	22010000
109582	1874	22013000
109583	1874	22022000
109584	1874	22028000
109585	1874	22031000
109586	1874	22034000
109587	1874	22037000
109588	1874	22040000
109589	1874	22043000
109590	1874	22046000
109591	1874	22052000
109592	1874	22055000
109593	1874	22058000
109594	1874	22061000
109595	1758	100000010
109596	1520	1614000000
109597	1686	10472123300118
109598	1686	11192123300118
109599	1758	100000012
109600	1520	1614100000
109601	1686	11192125200116
109630	1444	6567734329999
109631	1874	22628000
109632	1444	7287734329999
109633	1444	7287737329999
109698	1702	5040499000000
109699	1702	5040524000000
109761	1672	5041297000000
109762	1672	5041309000000
109826	1394	636490223500000
109827	1397	1300976232000
109828	1678	25200791868000
109829	2134	86351346000
109830	1874	22716000
109831	1440	5760218045924
109832	1440	5760229045924
109858	1397	1300926227000
109859	1678	25200791873000
109860	2134	86346331000
109861	1874	22732000
109874	1711	9066852000000
109953	2134	86343322000
109954	1874	22742000
109955	1874	22743000
109956	2134	86342319000
109957	1874	22746000
109958	1684	12242999819748
109959	1397	1300876222000
109960	1678	25200791878000
109961	2134	86341316000
109962	1874	22749000
109963	1395	58211190337957278
109989	1397	1300836218000
109990	1678	25200791882000
109991	1397	1300826217000
109992	1678	25200791883000
109993	1684	12243037819748
109994	1397	1300816216000
109995	1678	25200791884000
109996	1874	22753000
109997	2132	147780782000
109998	1874	22754000
109999	1684	12963037819748
110000	1684	200000008
110001	2275	12963049819412
110002	1571	7632193151808
110022	1680	7214153499559
110023	1680	7934153499559
110024	1680	7934523499559
110051	1705	15680785580140
110069	1395	58211910337957278
110070	1395	58211910349957278
110075	1874	22788000
110076	1693	3556697292484
110111	1571	8352193151808
110112	1571	8352215151808
110120	1693	3556707292484
110131	1394	639370245500000
110163	1764	23767380100000
110164	1764	23767391100000
110199	2275	201000000
110200	1271	1349886471000000
110215	1547	6475904000000
110216	1547	7195904000000
110217	1547	7195905000000
110230	547	66720011000000
110248	1394	642250246500000
110249	1394	642250257500000
110250	1397	1300566191000
110251	1678	25200791909000
109473	1397	1301256260000
109474	1678	25200791840000
109475	2134	86381436000
109476	1874	22565000
109477	2133	93622682000
109478	1874	22567000
109479	2133	93621680000
109480	1874	22569000
109481	2132	147793795000
109482	1874	22570000
109483	2133	93620678000
109484	1874	22572000
109485	2134	86380433000
109486	1874	22575000
109487	2134	86379430000
109488	1874	22578000
109489	1764	23047380100000
109520	1397	1301206255000
109521	1678	25200791845000
109522	2133	93616670000
109523	1874	22599000
109524	2134	86374415000
109525	1874	22602000
109526	1633	5088549125277
109565	1686	11192010700122
109566	1686	11192024700122
109602	1759	22321080999889
109603	1759	22321094999889
109604	1397	1301156250000
109605	1678	25200791850000
109606	1397	1301146249000
109607	1678	25200791851000
109608	2132	147790792000
109609	1874	22624000
109610	1593	12226639000000
109611	1220	614291750000000
109612	1684	10802975219748
109613	1593	9312638000000
109614	980	508059775000000
109615	2133	93611660000
109616	1874	22626000
109617	2252	200100000
109618	1684	11522975119748
109619	1684	200400000
109620	2252	11522976819748
109634	1874	22515000
109635	1874	22521000
109636	1874	22523000
109637	1874	22524000
109638	1874	22531000
109639	1874	22534000
109640	1874	22537000
109641	1874	22552000
109642	1874	22555000
109643	1874	22557000
109644	1874	22558000
109645	1874	22563000
109646	1874	22566000
109647	1874	22568000
109648	1874	22574000
109649	1874	22576000
109650	1874	22582000
109651	1874	22584000
109652	1874	22586000
109653	1874	22592000
109654	1874	22594000
109655	1874	22598000
109656	1874	22601000
109657	1874	22604000
109658	1874	22607000
109659	1874	22616000
109660	1874	22619000
109661	1874	22622000
109662	1874	22625000
109663	1444	7287712329999
109664	1444	7287986329999
109665	1397	1301136248000
109666	1678	25200791852000
109667	1397	1301126247000
109668	1678	25200791853000
109669	2133	93609656000
109670	1874	22633000
109671	2133	93608654000
109672	1874	22635000
109673	1874	22638000
109674	2134	86367394000
109675	1874	22641000
109676	2134	86366391000
109677	1874	22644000
109678	1637	280086736819988
109700	1703	2160854000000
109701	1397	1301096244000
109702	1678	25200791856000
109703	2134	86363382000
109704	1874	22658000
109705	2133	93605648000
109706	1874	22660000
109707	1476	5760098000000
109763	1419	17568281560130
109784	1397	1301006235000
109785	1678	25200791865000
109786	2134	86354355000
109787	1874	22706000
109788	1633	5808549125277
109789	1633	5808560125277
109833	2306	719011000000
109834	1397	1300966231000
109835	1678	25200791869000
109836	1397	1300956230000
109837	1678	25200791870000
109838	2132	147784786000
109839	1874	22717000
109840	2134	86350343000
109841	1874	22720000
109842	2134	86349340000
109843	1874	22723000
109844	1719	6480230000000
109845	1719	6480253000000
109862	1520	720100000016
109863	1520	720111000016
109875	1394	637930223500000
109876	1394	637930235500000
109964	1397	1300866221000
109965	1678	25200791879000
109966	2134	86340313000
109967	1874	22752000
109968	1768	11266641110000
109969	1768	11266652110000
109970	1397	1300856220000
109971	1678	25200791880000
109972	1397	1300846219000
109973	1678	25200791881000
109974	1874	22533000
109975	1874	22541000
109976	1874	22545000
109977	1874	22561000
109978	1874	22571000
109979	1874	22573000
109980	2132	147781783000
109981	1874	22600000
109982	1518	10080963000000
109983	1874	22612000
109984	1874	22614000
109985	1874	22639000
109986	1874	22651000
109987	1518	10800963000000
109988	1518	10800990000000
110003	2134	86339310000
110004	1874	22755000
110005	2134	86338307000
110006	1874	22758000
110007	2134	86337304000
110008	1874	22761000
110009	2134	86336301000
110010	1874	22764000
110011	2134	86335298000
110012	1874	22767000
110013	1874	22768000
110014	1874	22769000
110015	1684	12963054819748
110025	1397	1300806215000
110026	1678	25200791885000
110027	1874	22757000
110028	1874	22760000
110029	1874	22763000
110030	1874	22766000
110031	2134	86334295000
110032	1874	22772000
110033	1679	21599154654000
110034	1679	21599170654000
110035	1397	1300796214000
110036	1678	25200791886000
110037	1397	1300786213000
110038	1678	25200791887000
110039	2132	147779781000
110040	1874	22773000
110041	2134	86333292000
110042	1874	22776000
110043	2134	86332289000
110044	1874	22779000
110045	1608	8058422000000
110046	1397	1300776212000
110047	1678	25200791888000
110048	2134	86331286000
110049	1874	22782000
109745	1874	22684000
109746	2133	93599636000
109747	1874	22686000
109748	2134	86358367000
109749	1874	22689000
109750	2134	86357364000
109751	1874	22692000
109752	1395	58210470287957278
109753	1395	58210470324957278
109764	633	75070258900000
109765	1874	22113000
109766	1874	22115000
109767	1874	22117000
109768	1874	22119000
109769	1874	22120000
109770	633	75790258900000
109771	633	75790581900000
109772	1397	1301016236000
109773	1678	25200791864000
109774	2133	93597632000
109775	1874	22699000
109776	2134	86355358000
109777	1874	22702000
109778	2132	147786788000
109779	1874	22703000
109780	1688	41039534720020
109781	1688	41039547720020
109790	1874	22630000
109791	1874	22632000
109792	1874	22636000
109793	1874	22640000
109794	1874	22642000
109795	1874	22646000
109796	1874	22648000
109797	1874	22650000
109798	1874	22654000
109799	1874	22657000
109800	1444	7288143329999
109801	1874	22669000
109802	1874	22672000
109803	1874	22675000
109804	1874	22678000
109805	1874	22687000
109806	1874	22690000
109807	1874	22693000
109808	1874	22696000
109809	1874	22698000
109810	1874	22701000
109811	1444	8008143329999
109812	1444	8008159329999
109846	1513	34561200000000
109847	1397	1300946229000
109848	1678	25200791871000
109849	1397	1300936228000
109850	1678	25200791872000
109851	2134	86348337000
109852	1874	22726000
109853	2134	86347334000
109854	1874	22729000
109855	2307	719000000000
109856	2307	719022000000
109864	42	77949393000000
109865	1397	1300916226000
109866	1678	25200791874000
109867	2134	86345328000
109868	1874	22735000
109869	2132	147783785000
109870	1874	22736000
109871	1395	58211190324957278
109872	1395	58211190336957278
109877	1397	1300906225000
109878	1678	25200791875000
109879	2134	86344325000
109880	1874	22739000
109881	1588	28295637000000
109882	1588	28295648000000
110016	1394	636490263500000
110017	1394	637930263500000
110018	1394	637930280500000
110058	1394	637930234500000
110073	1716	720012000000
110087	1397	1300726207000
110088	1678	25200791893000
110089	2134	86326271000
110090	1874	22798000
110091	1560	8648671131803
110092	1560	8648682131803
110093	1397	1300716206000
110094	1678	25200791894000
110095	2132	147777779000
110096	1874	22799000
110097	2134	86325268000
110098	1874	22802000
110099	1717	6301058000055
110100	1717	6301070000055
110101	1397	1300706205000
110102	1678	25200791895000
110103	1397	1300696204000
110104	1678	25200791896000
110105	2134	86324265000
110106	1874	22805000
110107	2134	86323262000
110108	1874	22808000
110109	1394	639370256500000
110114	1397	1300686203000
110115	1678	25200791897000
110116	2134	86322259000
110117	1874	22811000
110118	1671	6143895003785
110119	1671	6143906003785
110123	1673	33300719000000
110124	1673	33300720000000
110150	1397	1300666201000
110151	1678	25200791899000
110152	394	66001818809135
110153	2308	44000000000
110154	2134	86320253000
110155	1874	22817000
110156	1688	41039555720020
110167	1397	1300646199000
110168	1678	25200791901000
110169	2134	86318247000
110170	1874	22823000
110171	1749	14405465930000
110172	1749	14405476930000
110173	2308	43990000000
110174	1397	1300636198000
110175	1678	25200791902000
110176	2134	86317244000
110177	1874	22826000
110178	576	71837478726897
110179	576	71837499726897
110212	1547	7194831000000
110218	1397	1300606195000
110219	1678	25200791905000
110220	2134	86314235000
110221	1874	22835000
110222	1608	8778422000000
110223	1608	8778433000000
110240	1394	640810235500000
110241	1394	640810246500000
110256	1397	1300556190000
110257	1678	25200791910000
110258	2134	86308217000
110259	1874	22853000
110280	1637	280086731819988
110303	1397	1300496184000
110304	1678	25200791916000
110305	2134	86302199000
110306	1874	22871000
110307	1637	280086720819988
110308	1397	1300486183000
110309	1678	25200791917000
110310	2134	86301196000
110311	1874	22874000
110312	1695	4985024999000
110313	1695	4985035999000
110326	1397	1300456180000
110327	1678	25200791920000
110328	2134	86298187000
110329	1874	22883000
110330	1564	4686553000000
110331	1564	4686564000000
110332	1397	1300446179000
110333	1678	25200791921000
110334	112	66000012832720
110335	1821	700693000000
110336	2134	86297184000
110337	1874	22886000
110338	1394	643690257500000
110339	1394	643690269500000
110347	2087	2595387147766
110348	2087	2595398147766
110373	1506	6772657967172
110374	1506	6772690967172
110375	1397	1300386173000
110376	1678	25200791927000
110377	2134	86291166000
110378	1874	22904000
110397	1718	5298479519070
110398	1718	5298490519070
110447	1716	1440012000000
110448	1716	1440045000000
110449	1397	1300286163000
110450	1678	25200791937000
109757	1874	22695000
109758	2133	93598634000
109759	1874	22697000
109760	633	75789460900000
109782	641	73923814000000
109783	641	73923827000000
109813	1633	5808559125277
109814	1397	1300996234000
109815	1678	25200791866000
109816	1397	1300986233000
109817	1678	25200791867000
109818	2132	147785787000
109819	1874	22707000
109820	2134	86353352000
109821	1874	22710000
109822	2134	86352349000
109823	1874	22713000
109824	1649	9111522999968
109825	1649	9111556999968
109857	1506	6052657967172
109873	1688	41039546720020
109883	1678	24480780742000
109884	1588	27576307000000
109885	1678	24480780743000
109886	1678	24480780744000
109887	1678	24480780745000
109888	1678	24480780746000
109889	1678	24480780747000
109890	1678	24480780748000
109891	1678	24480780749000
109892	1678	24480780750000
109893	1678	24480780751000
109894	1678	24480780752000
109895	1678	24480780753000
109896	1678	24480780754000
109897	1678	24480780755000
109898	1678	24480780756000
109899	1678	24480780757000
109900	1678	24480780758000
109901	1678	24480780759000
109902	1678	24480780760000
109903	1678	24480780761000
109904	1678	24480780762000
109905	1678	24480780763000
109906	1678	24480780764000
109907	1678	24480780765000
109908	1678	24480780766000
109909	1678	24480780767000
109910	1678	24480780768000
109911	1678	24480780769000
109912	1678	24480780770000
109913	1678	24480780771000
109914	1678	24480780772000
109915	1678	24480780773000
109916	1678	24480780774000
109917	1678	24480780775000
109918	1678	24480780776000
109919	1678	24480780777000
109920	1678	24480780778000
109921	1678	24480780779000
109922	1678	24480780780000
109923	1678	24480780781000
109924	1678	24480780782000
109925	1678	24480780783000
109926	1678	24480780784000
109927	1678	24480780785000
109928	1678	24480780786000
109929	1678	24480780787000
109930	1678	24480780788000
109931	1678	24480780789000
109932	1678	24480780790000
109933	1678	24480780791000
109934	1678	24480780792000
109935	1678	24480780793000
109936	1678	24480780794000
109937	1678	24480780795000
109938	1678	24480780796000
109939	1678	24480780797000
109940	1678	24480780798000
109941	1678	24480780799000
109942	1678	24480780800000
109943	1588	28296307000000
109944	1588	28296887000000
109945	1397	1300896224000
109946	1678	25200791876000
109947	1397	1300886223000
109948	1678	25200791877000
109949	2132	147782784000
109950	1874	22740000
109951	1684	12242976819748
109952	1684	12242997819748
110019	1680	7213313499559
110020	1680	7933313499559
110021	1680	7933330499559
110052	1397	1300766211000
110053	1678	25200791889000
110054	2134	86330283000
110055	1874	22785000
110056	1719	7200253000000
110057	1719	7200264000000
110071	1394	639370234500000
110072	1394	639370246500000
110077	1397	1300746209000
110078	1678	25200791891000
110079	2134	86328277000
110080	1874	22792000
110081	1724	6894666500000
110082	1397	1300736208000
110083	1678	25200791892000
110084	2134	86327274000
110085	1874	22795000
110086	1560	7928671131803
110113	470	73920273000000
110121	1457	10800197800000
110122	1457	10800208800000
110132	1623	66243847899898
110133	1874	22474000
110134	1874	22476000
110135	1874	22477000
110136	1874	22481000
110137	1874	22484000
110138	1874	22487000
110139	1874	22491000
110140	1874	22492000
110141	1874	22494000
110142	1874	22500000
110143	1874	22508000
110144	1874	22510000
110145	1874	22512000
110146	1874	22518000
110147	1623	66963847899898
110148	1623	200000000
110149	1734	66964074899898
110165	1749	14405442930000
110166	1749	14405456930000
110201	394	66001718809135
110202	1397	1300626197000
110203	1678	25200791903000
110204	1397	1300616196000
110205	1678	25200791904000
110206	2134	86316241000
110207	1874	22829000
110208	2134	86315238000
110209	1874	22832000
110210	1679	22319170654000
110211	1679	22319292654000
110231	2134	86312229000
110232	1874	22841000
110233	1394	639370235500000
110234	1397	1300586193000
110235	1678	25200791907000
110236	2134	86311226000
110237	1874	22844000
110238	1688	41759545720020
110239	1688	41759556720020
110254	2306	1439011000000
110255	2306	1439022000000
110279	1489	22944602000000
110291	1611	8775697000000
110292	1611	8775812000000
110301	1687	2288819848312
110302	1687	2288830848312
110320	1692	61701286619999
110321	1692	61701297619999
110322	1397	1300466181000
110323	1678	25200791919000
110324	2134	86299190000
110325	1874	22880000
110346	1699	2880329750126
110359	1992	7200573990000
110360	1397	1300416176000
110361	1678	25200791924000
110362	1397	1300406175000
110363	1678	25200791925000
110364	1397	1300396174000
110365	1678	25200791926000
110366	2134	86294175000
110367	1874	22895000
110368	2134	86293172000
110369	1874	22898000
110370	2134	86292169000
110371	1874	22901000
110372	2307	719033000000
110390	1397	1300356170000
110391	1678	25200791930000
110050	1656	8635412999990
110059	1555	8165905540449
110060	1555	8165916540449
110061	1397	1300756210000
110062	1678	25200791890000
110063	2132	147778780000
110064	1874	22786000
110065	2134	86329280000
110066	1874	22789000
110067	2248	8639443000000
110068	2248	8639455000000
110074	1693	3556708292484
110110	1690	157685387000000
110125	1740	9810706000000
110126	1397	1300676202000
110127	1678	25200791898000
110128	2134	86321256000
110129	1874	22814000
110130	1395	58211910348957278
110157	1690	158405387000000
110158	1690	158405408000000
110159	1397	1300656200000
110160	1678	25200791900000
110161	2134	86319250000
110162	1874	22820000
110180	1874	22730000
110181	1874	22731000
110182	576	71117780726897
110183	1874	22734000
110184	1874	22737000
110185	1874	22770000
110186	1874	22791000
110187	1874	22801000
110188	1874	22804000
110189	1874	22807000
110190	1874	22810000
110191	1874	22813000
110192	1874	22816000
110193	1874	22819000
110194	1874	22822000
110195	1874	22824000
110196	1874	22825000
110197	576	71837780726897
110198	576	71837815726897
110213	58	71747308999641
110214	58	71747430999641
110224	1688	41039545720020
110225	1397	1300596194000
110226	1678	25200791906000
110227	2134	86313232000
110228	1874	22838000
110229	1622	25740535000005
110242	1397	1300576192000
110243	1678	25200791908000
110244	2134	86310223000
110245	1874	22847000
110246	149	73295289000341
110247	149	73295300000341
110260	1657	3601230990100
110261	1657	3601241990100
110262	1397	1300546189000
110263	1678	25200791911000
110264	2134	86307214000
110265	1874	22856000
110266	1679	23039292654000
110267	1679	23039303654000
110281	1397	1300516186000
110282	1678	25200791914000
110283	2134	86304205000
110284	1874	22865000
110285	2275	200000030
110286	2266	200000010
110287	1571	8635412999222
110288	1656	7632193152544
110293	1455	2911563000000
110294	1455	2911574000000
110295	1397	1300506185000
110296	1678	25200791915000
110297	2134	86303202000
110298	1874	22868000
110314	1397	1300476182000
110315	1678	25200791918000
110316	2134	86300193000
110317	1874	22877000
110318	1509	11183270503835
110340	1692	61701298619999
110349	1394	645130269500000
110350	1394	645130280500000
110351	1397	1300426177000
110352	1678	25200791923000
110353	2134	86295178000
110354	1874	22892000
110355	1992	7200572990000
110356	1992	7200583990000
110399	1397	1300336168000
110400	1678	25200791932000
110401	2134	86287154000
110402	1874	22916000
110403	1395	58212630348957278
110404	1395	58212630359957278
110455	1397	1300276162000
110456	1678	25200791938000
110457	2134	86281136000
110458	1874	22934000
110459	633	75789459900000
110515	1394	646570279500000
110516	1394	646570301500000
110544	1678	24480780801000
110545	1678	24480780802000
110546	1678	24480780803000
110547	1678	24480780804000
110548	1678	24480780805000
110549	1678	24480780806000
110550	1678	24480780807000
110551	1678	24480780808000
110552	1678	24480780809000
110553	1678	24480780810000
110554	1678	24480780811000
110555	1678	24480780812000
110556	1678	24480780813000
110557	1678	24480780814000
110558	1678	24480780815000
110559	1678	24480780816000
110560	1678	24480780817000
110561	1678	24480780818000
110562	1678	24480780819000
110563	1678	24480780820000
110564	1678	24480780821000
110565	1678	24480780822000
110566	1678	24480780823000
110567	1678	24480780824000
110568	1678	24480780825000
110569	1678	24480780826000
110570	1678	24480780827000
110571	1678	24480780828000
110572	1678	24480780829000
110573	1678	24480780830000
110574	1678	24480780831000
110575	1678	24480780832000
110576	1678	24480780833000
110577	1678	24480780834000
110578	1678	24480780835000
110579	1678	24480780836000
110580	1678	24480780837000
110581	1678	24480780838000
110582	1678	24480780839000
110583	1678	24480780840000
110584	1678	24480780841000
110585	1678	24480780842000
110586	1678	24480780843000
110587	1678	24480780844000
110588	1678	24480780845000
110589	1678	24480780846000
110590	1678	24480780847000
110591	1678	24480780848000
110592	1678	24480780849000
110593	1678	24480780850000
110594	1678	24480780851000
110595	1678	24480780852000
110596	1678	24480780853000
110597	1678	24480780854000
110598	1680	7935493499559
110599	1678	24480780855000
110600	1678	24480780856000
110601	1678	24480780857000
110602	1678	24480780858000
110603	1678	24480780859000
110604	1678	24480780860000
110605	1678	24480780861000
110606	1678	24480780862000
110607	1678	24480780863000
110608	1678	24480780864000
110609	1678	24480780865000
110610	1678	24480780866000
110611	1678	24480780867000
110612	1678	24480780868000
110613	1678	24480780869000
110614	1678	24480780870000
110615	1678	24480780871000
110616	1678	24480780872000
110617	1678	24480780873000
110618	1678	24480780874000
110619	1678	24480780875000
110620	1678	24480780876000
110621	1678	24480780877000
110252	2134	86309220000
110253	1874	22850000
110268	1685	154083728571430
110269	1397	1300536188000
110270	1678	25200791912000
110271	1397	1300526187000
110272	1678	25200791913000
110273	2134	86306211000
110274	1874	22859000
110275	2134	86305208000
110276	1874	22862000
110277	1509	11183259503835
110278	1509	11183281503835
110289	1447	11801688683000
110290	1447	11801699683000
110299	1637	280806709819988
110300	1637	280806720819988
110319	1673	33300730000000
110341	1397	1300436178000
110342	1678	25200791922000
110343	2134	86296181000
110344	1874	22889000
110345	2086	720344300069
110357	1684	13683049819412
110358	1684	13683060819412
110379	1724	7614666500000
110380	1724	7614677500000
110381	1397	1300376172000
110382	1678	25200791928000
110383	1397	1300366171000
110384	1678	25200791929000
110385	2134	86290163000
110386	1874	22907000
110387	2134	86289160000
110388	1874	22910000
110389	1633	5808571125277
110405	686	69600047000000
110406	686	69600058000000
110407	1397	1300326167000
110408	1678	25200791933000
110409	2134	86286151000
110410	1874	22919000
110411	1476	6480110000000
110412	1476	6480121000000
110460	1681	9971262909853
110461	1681	9971273909853
110517	1397	1300216156000
110518	1678	25200791944000
110519	2134	86275118000
110520	1874	22952000
110638	1397	1300156150000
110639	1678	25200791950000
110640	2134	86269100000
110641	1874	22970000
110642	1684	14403060819412
110643	1684	14403071819412
110662	1397	1300116146000
110663	1678	25200791954000
110664	2134	86265088000
110665	1874	22982000
110666	1395	58213350359957278
110667	1395	58213350370957278
110699	1678	25920791959000
110700	1678	25920813959000
110728	1439	7903665578477
110729	1397	1300006135000
110730	1678	25920813965000
110731	2134	86254055000
110732	1874	23015000
110755	1458	12906133908540
110756	1458	13626133908540
110757	1458	13626253908540
110758	2044	1199000000
110759	1739	30238828000000
110943	1594	10081687000000
110944	1594	10081698000000
110945	1397	1299836118000
110946	1678	25920813982000
110947	1397	1299826117000
110948	1678	25920813983000
110949	2134	86236001000
110950	1874	23069000
110951	2134	86234998000
110952	1874	23072000
110953	1701	8638233500103
110954	1701	8638255500103
110955	1397	1299816116000
110956	1678	25920813984000
110957	2134	86233995000
110958	1874	23075000
110959	1599	7496748097983
110977	1397	1299786113000
110978	1678	25920813987000
110979	2134	86230986000
110980	1874	23084000
110981	1564	5406564000000
110982	1564	5406575000000
110983	1397	1299776112000
110984	1678	25920813988000
110985	2134	86229983000
110986	1874	23087000
111025	1509	12623281503835
111056	1701	9358255500103
111057	1397	1299656100000
111058	1678	25920814000000
111059	2134	86217947000
111060	1874	23123000
111081	1762	4965338994000
111082	1762	4965349994000
111083	171	73866737696494
111084	171	73866858696494
111085	1685	156243729571430
111086	1685	156243739571430
111088	1397	1299616096000
111089	1678	25920814004000
111090	1397	1299606095000
111091	1678	25920814005000
111092	1397	1299596094000
111093	1678	25920814006000
111094	1397	1299586093000
111095	1678	25920814007000
111096	1397	1299576092000
111097	1678	25920814008000
111098	2134	86213935000
111099	1874	23135000
111100	2134	86212932000
111101	1874	23138000
111102	2134	86211929000
111103	1874	23141000
111104	2134	86210926000
111105	1874	23144000
111106	2134	86209923000
111107	1874	23147000
111108	1395	58214070370957278
111109	1395	58214070425957278
111110	1688	43199623720020
111122	1740	9810727000000
111125	1693	4996740292484
111210	1397	1299516086000
111211	1678	25920814014000
111212	2134	86203905000
111213	1874	23165000
111239	1559	8226116999999
111250	1397	1299436078000
111251	1678	25920814022000
111252	2134	86195881000
111253	1874	23189000
111254	1471	10025291900000
111255	1471	10025302900000
111261	1397	1299426077000
111262	1678	25920814023000
111263	2134	86194878000
111264	1874	23192000
111265	2261	5759111000000
111266	2261	5759122000000
111307	1693	4996926292484
111325	2134	86184848000
111326	1874	23222000
111327	2039	9979442000000
111335	1397	1299306065000
111336	1678	25920814035000
111337	2134	86182842000
111338	1874	23228000
111339	1679	25199324653000
111340	1679	25199335653000
111348	2261	6479122000000
111349	2261	6479133000000
111356	1602	6336250170000
111357	1602	6336261170000
111362	1397	1299276062000
111363	1678	25920814038000
111364	2134	86179833000
111365	1874	23237000
111366	1395	58215510447957278
111367	1395	58215510458957278
111368	1397	1299266061000
111369	1678	25920814039000
111370	2134	86178830000
111371	1874	23240000
111372	1693	5716729292484
111373	1693	5716740292484
111402	1397	1299226057000
111403	1678	25920814043000
111404	2133	93595628000
111405	1874	23253000
110392	1394	645130279500000
110393	1397	1300346169000
110394	1678	25200791931000
110395	2134	86288157000
110396	1874	22913000
110413	1623	66964556899898
110414	1874	22577000
110415	1874	22579000
110416	1874	22643000
110417	1874	22661000
110418	1874	22664000
110419	1874	22667000
110420	1874	22670000
110421	1874	22673000
110422	1874	22682000
110423	1874	22685000
110424	1874	22688000
110425	1874	22691000
110426	1874	22694000
110427	1874	22700000
110428	1874	22709000
110429	1874	22712000
110430	1874	22715000
110431	1874	22718000
110432	1623	67684556899898
110433	1623	67684616899898
110434	1397	1300316166000
110435	1678	25200791934000
110436	1397	1300306165000
110437	1678	25200791935000
110438	1397	1300296164000
110439	1678	25200791936000
110440	2134	86285148000
110441	1874	22922000
110442	2134	86284145000
110443	1874	22925000
110444	2134	86283142000
110445	1874	22928000
110446	2248	8639476000000
110462	1874	22129000
110463	1514	75791445890100
110464	633	9040300
110465	1874	22132000
110466	1874	22138000
110467	1874	22141000
110468	1874	22150000
110469	1874	22165000
110470	1874	22168000
110471	1874	22171000
110472	1874	22189000
110473	1874	22192000
110474	1874	22195000
110475	1874	22207000
110476	1874	22210000
110477	1874	22213000
110478	1874	22219000
110479	1874	22228000
110480	1874	22240000
110481	1874	22249000
110482	1874	22252000
110483	1874	22255000
110484	1874	22258000
110485	1874	22261000
110486	633	76511445890100
110487	633	76511489890100
110488	1397	1300266161000
110489	1678	25200791939000
110490	1397	1300256160000
110491	1678	25200791940000
110492	2134	86280133000
110493	1874	22937000
110494	2134	86279130000
110495	1874	22940000
110496	1610	6480118999950
110497	1610	6480140999950
110498	1397	1300246159000
110499	1678	25200791941000
110500	2134	86278127000
110501	1874	22943000
110502	1690	159125408000000
110503	1690	159125419000000
110504	1397	1300236158000
110505	1678	25200791942000
110506	1397	1300226157000
110507	1678	25200791943000
110508	2134	86277124000
110509	1874	22946000
110510	2134	86276121000
110511	1874	22949000
110512	1439	7903676578477
110521	1397	1300206155000
110522	1678	25200791945000
110523	1397	1300196154000
110524	1678	25200791946000
110525	2134	86274115000
110526	1874	22955000
110527	2134	86273112000
110528	1874	22958000
110529	1637	280806742819988
110530	1397	1300186153000
110531	1678	25200791947000
110532	2134	86272109000
110533	1874	22961000
110644	2039	9259387000000
110645	2039	9259398000000
110668	1394	648010301500000
110669	1394	648010312500000
110670	1397	1300106145000
110671	1678	25200791955000
110672	576	72557499726897
110673	576	72557509726897
110701	1637	281526742819988
110702	1637	281526764819988
110703	1397	1300056140000
110704	1678	25920813960000
110705	1397	1300046139000
110706	1678	25920813961000
110707	2134	86259070000
110708	1874	23000000
110709	2134	86258067000
110710	1874	23003000
110711	1694	8458866197225
110733	1685	154803728571430
110734	1685	154803729571430
110746	1703	2160851000000
110760	1397	1299966131000
110761	1678	25920813969000
110762	2134	86250043000
110763	1874	23027000
110764	1759	22321091999889
110778	1397	1299936128000
110779	1678	25920813972000
110780	2134	86247034000
110781	1874	23036000
110782	1684	15123071819412
110783	1684	15123082819412
110784	1397	1299926127000
110785	1678	25920813973000
110786	1397	1299916126000
110787	1678	25920813974000
110788	2134	86246031000
110789	1874	23039000
110790	2134	86245028000
110791	1874	23042000
110792	1690	160565430000000
110793	1690	160565452000000
110814	2134	86241016000
110815	1874	23054000
110816	1724	8334677500000
110817	1724	8334678500000
110837	1394	650890323500000
110838	1394	650890345500000
110960	1397	1299806115000
110961	1678	25920813985000
110962	1679	23039313654000
110963	2076	200001000
110964	1679	23759313653000
110987	1715	18746874436096
110988	1715	18746885436096
110989	1397	1299766111000
110990	1678	25920813989000
110991	1397	1299756110000
110992	1678	25920813990000
110993	2134	86228980000
110994	1874	23090000
110995	2134	86227977000
110996	1874	23093000
110997	1394	652330345500000
110998	1394	652330367500000
111026	1397	1299706105000
111027	1678	25920813995000
111028	2134	86222962000
111029	1874	23108000
111030	1509	12623292503835
111039	1746	13474469000000
111040	1746	13474480000000
111041	1397	1299686103000
111042	1678	25920813997000
111043	1397	1299676102000
111044	1678	25920813998000
111045	1397	1299666101000
111046	1678	25920813999000
111047	2134	86220956000
111048	1874	23114000
111049	2134	86219953000
110451	2134	86282139000
110452	1874	22931000
110453	1509	11903270503835
110454	1509	11903281503835
110513	1672	5761309000000
110514	1672	5761331000000
110534	1397	1300176152000
110535	1678	25200791948000
110536	2134	86271106000
110537	1874	22964000
110538	1397	1300166151000
110539	1678	25200791949000
110540	2134	86270103000
110541	1874	22967000
110542	1680	7933273499559
110543	1680	7933284499559
110674	576	71838490726897
110675	2134	86264085000
110676	1874	22985000
110677	576	72558490726897
110678	576	72558509726897
110679	1397	1300096144000
110680	1678	25200791956000
110681	1397	1300086143000
110682	1678	25200791957000
110683	2134	86263082000
110684	1874	22988000
110685	2134	86262079000
110686	1874	22991000
110687	1719	7200276000000
110712	1397	1300036138000
110713	1678	25920813962000
110714	2134	86257064000
110715	1874	23006000
110716	1397	1300026137000
110717	1678	25920813963000
110718	2134	86256061000
110719	1874	23009000
110720	1768	11986652110000
110721	1768	11986663110000
110735	1397	1299996134000
110736	1678	25920813966000
110737	1397	1299986133000
110738	1678	25920813967000
110739	2134	86253052000
110740	1874	23018000
110741	2134	86252049000
110742	1874	23021000
110743	1688	42479556720020
110744	1688	42479578720020
110747	1397	1299976132000
110748	1678	25920813968000
110749	2134	86251046000
110750	1874	23024000
110751	1458	13625183908540
110752	1458	13625194908540
110765	1397	1299956130000
110766	1678	25920813970000
110767	2134	86249040000
110768	1874	23030000
110769	1447	12521699683000
110770	1447	12521710683000
110794	42	78669393000000
110795	42	78669415000000
110818	1457	10800198800000
110819	1397	1299876122000
110820	1678	25920813978000
110821	2134	86240013000
110822	1874	23057000
110823	1471	9305280900000
110824	1471	9305291900000
110825	1397	1299866121000
110826	1678	25920813979000
110827	1397	1299856120000
110828	1678	25920813980000
110829	2134	86239010000
110830	1874	23060000
110831	2134	86238007000
110832	1874	23063000
110833	1588	29015648000000
110834	1588	29015670000000
110839	1678	24480780892000
110840	1678	24480780893000
110841	1678	24480780894000
110842	1678	24480780895000
110843	1678	24480780896000
110844	1678	24480780897000
110845	1678	24480780898000
110846	1678	24480780899000
110847	1678	24480780900000
110848	1678	24480780901000
110849	1678	24480780902000
110850	1678	24480780903000
110851	1678	24480780904000
110852	1678	24480780905000
110853	1678	24480780906000
110854	1678	24480780907000
110855	1678	24480780908000
110856	1678	24480780909000
110857	1678	24480780910000
110858	1678	24480780911000
110859	1678	24480780912000
110860	1678	24480780913000
110861	1678	24480780914000
110862	1678	24480780915000
110863	1678	24480780916000
110864	1678	24480780917000
110865	1678	24480780918000
110866	1678	24480780919000
110867	1678	24480780920000
110868	1678	24480780921000
110869	1678	24480780922000
110870	1678	24480780923000
110871	1678	24480780924000
110872	1678	24480780925000
110873	1678	24480780926000
110874	1678	24480780927000
110875	1678	24480780928000
110876	1678	24480780929000
110877	1678	24480780930000
110878	1678	24480780931000
110879	1678	24480780932000
110880	1678	24480780933000
110881	1678	24480780934000
110882	1678	24480780935000
110883	1678	24480780936000
110884	1678	24480780937000
110885	1678	24480780938000
110886	1678	24480780939000
110887	1678	24480780940000
110888	1678	24480780941000
110889	1678	24480780942000
110890	1678	24480780943000
110891	1678	24480780944000
110892	1678	24480780945000
110893	1678	24480780946000
110894	1678	24480780947000
110895	1678	24480780948000
110896	1678	24480780949000
110897	1678	24480780950000
110898	1678	24480780951000
110899	1678	24480780952000
110900	1678	24480780953000
110901	1678	24480780954000
110902	1678	24480780955000
110903	1678	24480780956000
110904	1678	24480780957000
110905	1678	24480780958000
110906	1678	24480780959000
110907	1678	24480780960000
110908	1678	24480780961000
110909	1678	24480780962000
110910	1678	24480780963000
110911	1678	24480780964000
110912	1678	24480780965000
110913	1678	24480780966000
110914	1678	24480780967000
110915	1678	24480780968000
110916	1678	24480780969000
110917	1678	24480780970000
110918	1678	24480780971000
110919	1678	24480780972000
110920	1678	24480780973000
110921	1678	24480780974000
110922	1678	24480780975000
110923	1678	24480780976000
110924	1678	24480780977000
110925	1678	24480780978000
110926	1680	8656743499559
110927	1678	24480780979000
110928	1678	24480780980000
110929	1874	21601000
110930	1874	21605000
110931	1874	21607000
110932	1680	9376743499559
110933	1520	9376770469664
110934	1680	100000106
110935	1527	9050200
110936	1514	291999958
110965	1395	58212630369957278
110966	2134	86232992000
110967	1874	23078000
110968	1395	58213350369957278
110999	2223	200100000
111000	1271	1350606471900000
110622	1678	24480780878000
110623	1678	24480780879000
110624	1678	24480780880000
110625	1678	24480780881000
110626	1678	24480780882000
110627	1678	24480780883000
110628	1678	24480780884000
110629	1678	24480780885000
110630	1678	24480780886000
110631	1678	24480780887000
110632	1678	24480780888000
110633	1678	24480780889000
110634	1678	24480780890000
110635	1678	24480780891000
110636	1680	8655493499559
110637	1680	8655863499559
110646	1397	1300146149000
110647	1678	25200791951000
110648	2134	86268097000
110649	1874	22973000
110650	1690	159845419000000
110651	1690	159845430000000
110652	1397	1300136148000
110653	1678	25200791952000
110654	1397	1300126147000
110655	1678	25200791953000
110656	2134	86267094000
110657	1874	22976000
110658	2134	86266091000
110659	1874	22979000
110660	1593	10032638000000
110661	1593	10032660000000
110688	1271	1349886472000000
110689	1397	1300076142000
110690	1678	25200791958000
110691	1397	1300066141000
110692	1678	25200791959000
110693	2134	86261076000
110694	1874	22994000
110695	2134	86260073000
110696	1874	22997000
110697	1610	7200140999950
110698	1610	7200162999950
110722	1397	1300016136000
110723	1678	25920813964000
110724	2134	86255058000
110725	1874	23012000
110726	1991	7821308355805
110727	1991	7821319355805
110745	1685	155523729571430
110753	1394	649450312500000
110754	1394	649450323500000
110771	58	71747319999641
110772	1397	1299946129000
110773	1678	25920813971000
110774	2134	86248037000
110775	1874	23033000
110776	1693	4276707292484
110777	1693	4276718292484
110796	1474	6470463000043
110797	2305	199000000000
110798	1397	1299906125000
110799	1678	25920813975000
110800	1397	1299896124000
110801	1678	25920813976000
110802	2134	86244025000
110803	1874	23045000
110804	2134	86243022000
110805	1874	23048000
110806	2100	722930000000
110807	2100	722962000000
110808	1397	1299886123000
110809	1678	25920813977000
110810	2134	86242019000
110811	1874	23051000
110812	1422	8154603804270
110813	1422	8154614804270
110835	1680	8653284499559
110836	1680	8653306499559
110937	1397	1299846119000
110938	1678	25920813981000
110939	2134	86237004000
110940	1874	23066000
110941	1593	10752660000000
110942	1593	10752671000000
110969	1701	8638265500103
110970	1701	9358265500103
110971	1701	9358266500103
110972	1397	1299796114000
110973	1678	25920813986000
110974	2134	86231989000
110975	1874	23081000
110976	1688	42479568720020
111023	1394	653770367500000
111024	1394	653770389500000
111032	1634	11903012259504
111033	1634	11903023259504
111034	1397	1299696104000
111035	1678	25920813996000
111036	2134	86221959000
111037	1874	23111000
111038	2292	719011000000
111052	2134	86218950000
111053	1874	23120000
111054	1688	43199568720020
111055	1688	43199579720020
111075	1397	1299626097000
111076	1678	25920814003000
111077	2134	86214938000
111078	1874	23132000
111079	1594	10801698000000
111080	1594	10801709000000
111111	1397	1299566091000
111112	1678	25920814009000
111113	1397	1299556090000
111114	1678	25920814010000
111115	2134	86208920000
111116	1874	23150000
111117	2134	86207917000
111118	1874	23153000
111119	633	75789470900000
111126	1678	25200791960000
111127	1678	25200791961000
111128	1678	25200791962000
111129	1678	25200791963000
111130	1678	25200791964000
111131	1678	25200791965000
111132	1678	25200791966000
111133	1678	25200791967000
111134	1678	25200791968000
111135	1678	25200791969000
111136	1678	25200791970000
111137	1678	25200791971000
111138	1678	25200791972000
111139	1678	25200791973000
111140	1678	25200791974000
111141	1678	25200791975000
111142	1678	25200791976000
111143	1678	25200791977000
111144	1678	25200791978000
111145	1678	25200791979000
111146	1678	25200791980000
111147	1678	25200791981000
111148	1678	25200791982000
111149	1678	25200791983000
111150	1678	25200791984000
111151	1678	25200791985000
111152	1678	25200791986000
111153	1678	25200791987000
111154	1678	25200791988000
111155	1678	25200791989000
111156	1678	25200791990000
111157	1678	25200791991000
111158	1678	25200791992000
111159	1678	25200791993000
111160	1678	25200791994000
111161	1678	25200791995000
111162	1678	25200791996000
111163	1678	25200791997000
111164	1678	25200791998000
111165	1678	25200791999000
111166	1678	25200792000000
111167	1678	25200792001000
111168	1678	25200792002000
111169	1678	25200792003000
111170	1678	25200792004000
111171	1678	25200792005000
111172	1678	25200792006000
111173	1678	25200792007000
111174	1678	25200792008000
111175	1678	25200792009000
111176	1678	25200792010000
111177	1874	22264000
111178	1874	22267000
111179	1874	22279000
111180	1874	22282000
111181	1874	22285000
111182	45	76512227890090
111183	633	66000000001310
111184	1874	22288000
111185	1874	22303000
111186	1874	22306000
111187	1874	22309000
111188	1874	22312000
111189	1874	22324000
111001	2223	200900000
111002	2275	200400000
111003	1271	288999961
111004	1527	1350606478700002
111005	1397	1299746109000
111006	1678	25920813991000
111007	1397	1299736108000
111008	1678	25920813992000
111009	2134	86226974000
111010	1874	23096000
111011	2134	86225971000
111012	1874	23099000
111013	1623	66243099899898
111014	1397	1299726107000
111015	1678	25920813993000
111016	1397	1299716106000
111017	1678	25920813994000
111018	2134	86224968000
111019	1874	23102000
111020	2134	86223965000
111021	1874	23105000
111022	1547	7194731000000
111031	1394	653770378500000
111063	75	68160013000000
111064	75	68160079000000
111065	1397	1299646099000
111066	1678	25920814001000
111067	1397	1299636098000
111068	1678	25920814002000
111069	2134	86216944000
111070	1874	23126000
111071	2134	86215941000
111072	1874	23129000
111073	1599	8216748097983
111074	1599	8216770097983
111123	1693	4996718292484
111124	1693	4996720292484
111196	1397	1299546089000
111197	1678	25920814011000
111198	2134	86206914000
111199	1874	23156000
111214	1397	1299506085000
111215	1678	25920814015000
111216	2134	86202902000
111217	1874	23168000
111218	1637	281526753819988
111219	1397	1299496084000
111220	1678	25920814016000
111221	1397	1299486083000
111222	1678	25920814017000
111223	1397	1299476082000
111224	1678	25920814018000
111225	1397	1299466081000
111226	1678	25920814019000
111227	2134	86201899000
111228	1874	23171000
111229	2134	86200896000
111230	1874	23174000
111231	2134	86199893000
111232	1874	23177000
111233	2134	86198890000
111234	1874	23180000
111235	1681	10691273909853
111236	1681	10691317909853
111256	1444	8007712329999
111257	1444	8007723329999
111274	1397	1299406075000
111275	1678	25920814025000
111276	1397	1299396074000
111277	1678	25920814026000
111278	2134	86192872000
111279	1874	23198000
111280	2134	86191869000
111281	1874	23201000
111282	1423	1440629750023
111283	1587	6480155000000
111284	1587	6480177000000
111288	1397	1299386073000
111289	1678	25920814027000
111290	2134	86190866000
111291	1874	23204000
111292	2248	9359476000000
111293	2248	9359487000000
111329	1397	1299316066000
111330	1678	25920814034000
111331	2134	86183845000
111332	1874	23225000
111333	1764	24487391100000
111334	1764	24487402100000
111341	1506	7492690967172
111342	1506	7492701967172
111358	1716	2160023000000
111359	1716	2160034000000
111374	1693	4996946292484
111375	1693	5716946292484
111376	2076	5717026291484
111377	1693	200002000
111390	149	74015300000341
111391	149	74015311000341
111394	1397	1299236058000
111395	1678	25920814042000
111396	2133	93596630000
111397	1874	23248000
111398	2134	86175821000
111399	1874	23251000
111400	1536	7200133000000
111401	1536	7200145000000
111410	2306	1439023000000
111413	1444	8727723329999
111414	1444	8727735329999
111415	1678	25200792011000
111416	1678	25200792012000
111417	1678	25200792013000
111418	1678	25200792014000
111419	1678	25200792015000
111420	1678	25200792016000
111421	1678	25200792017000
111422	1678	25200792018000
111423	1678	25200792019000
111424	1678	25200792020000
111425	1678	25200792021000
111426	1678	25200792022000
111427	1678	25200792023000
111428	1678	25200792024000
111429	1678	25200792025000
111430	1678	25200792026000
111431	1678	25200792027000
111432	1678	25200792028000
111433	1678	25200792029000
111434	1678	25200792030000
111435	1678	25200792031000
111436	1678	25200792032000
111437	1678	25200792033000
111438	1678	25200792034000
111439	1678	25200792035000
111440	1678	25200792036000
111441	1678	25200792037000
111442	1678	25200792038000
111443	1678	25200792039000
111444	1678	25200792040000
111445	1678	25200792041000
111446	1678	25200792042000
111447	1678	25200792043000
111448	1874	22705000
111449	1874	22711000
111450	1874	22724000
111451	1874	22727000
111452	1874	22733000
111453	1874	22745000
111454	1874	22748000
111455	1874	22751000
111456	1874	22775000
111457	1874	22778000
111458	1874	22781000
111459	1874	22784000
111460	1874	22787000
111461	1874	22790000
111462	1874	22793000
111463	1874	22796000
111464	1520	8730129320098
111465	1444	100000017
111466	1514	9040300
111467	1444	9450129320098
111468	1527	9450132320099
111469	1444	287999962
111470	1397	1299216056000
111471	1678	25920814044000
111472	1397	1299206055000
111473	1678	25920814045000
111474	1397	1299196054000
111475	1678	25920814046000
111476	2134	86173815000
111477	1874	23259000
111478	2134	86172812000
111479	1874	23262000
111480	2133	93594626000
111481	1874	23264000
111482	2133	93593624000
111483	1874	23266000
111484	2134	86171809000
111485	1874	23269000
111486	2133	93592622000
111487	1874	23271000
111488	1692	62421319619999
111489	1692	62421355619999
111050	1874	23117000
111051	470	73920283000000
111061	1394	655210378500000
111062	1394	655210389500000
111087	1685	156963739571430
111120	1850	12936381949999
111121	1850	12936403949999
111258	1444	8009339329999
111259	1444	8729339329999
111260	1444	8729499329999
111267	1397	1299416076000
111268	1678	25920814024000
111269	1695	4985045999000
111270	2134	86193875000
111271	1874	23195000
111272	1695	5705045999000
111273	1695	5705046999000
111286	1457	11520198800000
111287	1457	11520374800000
111295	112	66000001832720
111296	1483	11000000
111297	1397	1299376072000
111298	1678	25920814028000
111299	2134	86189863000
111300	1874	23207000
111301	1690	160565451000000
111308	1397	1299356070000
111309	1678	25920814030000
111310	1397	1299346069000
111311	1678	25920814031000
111312	1397	1299336068000
111313	1678	25920814032000
111314	2134	86187857000
111315	1874	23213000
111316	2134	86186854000
111317	1874	23216000
111318	2134	86185851000
111319	1874	23219000
111320	1692	61701319619999
111328	2039	9979409000000
111350	1718	6018490519070
111351	1718	6018501519070
111352	1397	1299286063000
111353	1678	25920814037000
111354	2134	86180836000
111355	1874	23234000
111360	404	68160031000000
111361	404	68160042000000
111384	1397	1299246059000
111385	1678	25920814041000
111386	2134	86176824000
111387	1874	23246000
111388	1684	15843082819412
111389	1684	15843093819412
111409	1458	13625195908540
111504	1397	1299166051000
111505	1678	25920814049000
111506	2132	147776778000
111507	1874	23282000
111508	2133	93589616000
111509	1874	23284000
111510	2134	86168800000
111511	1874	23287000
111512	1571	8352206151808
111522	1394	655210390500000
111531	1397	1299136048000
111532	1678	25920814052000
111533	2134	86165791000
111534	1874	23300000
111535	2133	93586610000
111536	1874	23302000
111537	2132	147775777000
111538	1874	23303000
111539	1395	58216950495957278
111560	1747	9376944000000
111190	1874	22327000
111191	1874	22330000
111192	1874	22333000
111193	633	77232227890090
111194	1527	77232242880091
111195	633	287999962
111200	1397	1299536088000
111201	1678	25920814012000
111202	2134	86205911000
111203	1874	23159000
111204	1679	24479313653000
111205	1679	24479324653000
111206	1397	1299526087000
111207	1678	25920814013000
111208	2134	86204908000
111209	1874	23162000
111237	1695	5705035999000
111238	1695	5705079999000
111240	1397	1299456080000
111241	1678	25920814020000
111242	1397	1299446079000
111243	1678	25920814021000
111244	2134	86197887000
111245	1874	23183000
111246	2134	86196884000
111247	1874	23186000
111248	1395	58214790425957278
111249	1395	58214790447957278
111285	1587	6480202000000
111294	1716	1440023000000
111302	1397	1299366071000
111303	1678	25920814029000
111304	2134	86188860000
111305	1874	23210000
111306	1693	4996729292484
111321	1397	1299326067000
111322	1678	25920814033000
111323	2039	9979398000000
111324	2039	9979408000000
111343	2307	719011000000
111344	1397	1299296064000
111345	1678	25920814036000
111346	2134	86181839000
111347	1874	23231000
111378	1397	1299256060000
111379	1678	25920814040000
111380	2134	86177827000
111381	1874	23243000
111382	1710	8153973664140
111383	1710	8153984664140
111392	1684	15123609819412
111393	1684	15843609819412
111411	1440	6480229045924
111412	1440	6480241045924
111490	1397	1299186053000
111491	1678	25920814047000
111492	1397	1299176052000
111493	1678	25920814048000
111494	2134	86170806000
111495	1874	23274000
111496	2134	86169803000
111497	1874	23277000
111498	2133	93591620000
111499	1874	23279000
111500	2133	93590618000
111501	1874	23281000
111502	1395	58216230458957278
111503	1395	58216230482957278
111542	1687	3008830848312
111543	1687	3008843848312
111544	1397	1299126047000
111545	1678	25920814053000
111546	2133	93585608000
111547	1874	23305000
111548	2134	86164788000
111549	1874	23308000
111550	1536	7920145000000
111551	1536	7920157000000
111562	1670	4320904000000
111565	1397	1299106045000
111566	1678	25920814055000
111567	1397	1299096044000
111568	1678	25920814056000
111569	1397	1299086043000
111570	1678	25920814057000
111571	2134	86162782000
111572	1874	23316000
111573	2134	86161779000
111574	1874	23319000
111575	2132	147774776000
111576	1874	23320000
111577	2133	93583604000
111578	1874	23322000
111579	2133	93582602000
111580	1874	23324000
111581	2134	86160776000
111582	1874	23327000
111583	2133	93581600000
111584	1874	23329000
111585	369	74436427290830
111586	369	74436464290830
111602	2300	2879000000000
111603	2300	2879012000000
111406	2134	86174818000
111407	1874	23256000
111408	1680	8653296499559
111514	1397	1299156050000
111515	1678	25920814050000
111516	2133	93588614000
111517	1874	23289000
111518	2134	86167797000
111519	1874	23292000
111520	1395	58216950482957278
111521	1395	58216950494957278
111523	1397	1299146049000
111524	1678	25920814051000
111525	2134	86166794000
111526	1874	23295000
111527	2133	93587612000
111528	1874	23297000
111529	1394	656650390500000
111530	1394	656650402500000
111552	1397	1299116046000
111553	1678	25920814054000
111554	2133	93584606000
111555	1874	23310000
111556	2134	86163785000
111557	1874	23313000
111558	1746	14194480000000
111559	1746	14194492000000
111563	1685	157683739571430
111564	1685	157683749571430
111587	1397	1299076042000
111588	1678	25920814058000
111589	2133	93580598000
111590	1874	23331000
111591	2134	86159773000
111592	1874	23334000
111593	1555	8165917540449
111513	1608	8778435000000
111540	1690	161285451000000
111541	1690	161285464000000
111561	2292	719012000000
111594	1397	1299066041000
111595	1678	25920814059000
111596	2132	147773775000
111597	1874	23335000
111598	2133	93579596000
111599	1874	23337000
111600	1719	7920276000000
111601	1719	7920288000000
111604	1397	1299056040000
111605	1678	25920814060000
111606	1397	1299046039000
111607	1678	25920814061000
111608	2133	93578594000
111609	1874	23339000
111610	2133	93577592000
111611	1874	23341000
111612	2134	86158770000
111613	1874	23344000
111614	2134	86157767000
111615	1874	23347000
111616	1394	658090402500000
111617	1394	658090426500000
111618	1601	12133829620000
111619	1601	12133853620000
111620	1397	1299036038000
111621	1678	25920814062000
111622	2133	93576590000
111623	1874	23349000
111624	2134	86156764000
111625	1874	23352000
111626	2132	147772774000
111627	1874	23353000
111628	1684	15843095819412
111629	1397	1299026037000
111630	1678	25920814063000
111631	2133	93575588000
111632	1874	23355000
111633	2134	86155761000
111634	1874	23358000
111635	1688	43919579720020
111636	1688	43919591720020
111637	1611	8055709000000
111638	1555	8885917540449
111639	1555	8885929540449
111640	1397	1299016036000
111641	1678	25920814064000
111642	1397	1299006035000
111643	1678	25920814065000
111644	2133	93574586000
111645	1874	23360000
111646	2134	86154758000
111647	1874	23363000
111648	2134	86153755000
111649	1874	23366000
111650	2133	93573584000
111651	1874	23368000
111652	1694	9178866197225
111653	1694	9178890197225
111654	1623	66963099899898
111655	1623	66963123899898
111656	1397	1298996034000
111657	1678	25920814066000
111658	2133	93572582000
111659	1874	23370000
111660	2134	86152752000
111661	1874	23373000
111662	2132	147771773000
111663	1874	23374000
111664	1672	6481309000000
111665	1672	6481322000000
111666	1654	10217328999798
111667	1654	10217341999798
111668	1394	659530426500000
111669	1394	659530439500000
111670	1458	13625196908540
111671	1874	22738000
111672	1874	22744000
111673	1874	22750000
111674	1874	22756000
111675	1874	22762000
111676	171	73866884696494
111677	171	74586884596494
111678	1397	1298986033000
111679	1678	25920814067000
111680	2133	93571580000
111681	1874	23376000
111682	2134	86151749000
111683	1874	23379000
111684	1397	1298976032000
111685	1678	25920814068000
111686	1397	1298966031000
111687	1678	25920814069000
111688	2132	147770772000
111689	1874	23380000
111690	2134	86150746000
111691	1874	23383000
111692	2133	93570578000
111693	1874	23385000
111694	2133	93569576000
111695	1874	23387000
111696	2134	86149743000
111697	1874	23390000
111698	2039	10699409000000
111699	2039	10699434000000
111700	1634	11903037259504
111701	1397	1298956030000
111702	1678	25920814070000
111703	2133	93568574000
111704	1874	23392000
111705	2134	86148740000
111706	1874	23395000
111707	1394	659530438500000
111708	1623	66963111899898
111709	1560	9368682131803
111710	1560	9368694131803
111711	1397	1298946029000
111712	1678	25920814071000
111713	2133	93567572000
111714	1874	23397000
111715	2134	86147737000
111716	1874	23400000
111717	526	72480233000000
111718	526	72480245000000
111719	1474	7190463000043
111720	1474	7190475000043
111721	1397	1298936028000
111722	1678	25920814072000
111723	2133	93566570000
111724	1874	23402000
111725	2132	147769771000
111726	1874	23403000
111727	2134	86146734000
111728	1874	23406000
111729	1395	58217670495957278
111730	1395	58217670508957278
111731	1702	5040512000000
111732	1703	2880851000000
111733	1703	2880864000000
111734	2134	86145731000
111735	1874	23409000
111736	1698	8708847550062
111737	1397	1298926027000
111738	1678	25920814073000
111739	2134	86144728000
111740	1874	23412000
111741	2133	93565568000
111742	1874	23414000
111743	2133	93564566000
111744	1874	23416000
111745	1705	16400785580140
111746	1705	16400798580140
111747	1448	12996846000001
111748	1448	12996859000001
111749	1874	23411000
111750	2106	5759118000000
111751	1397	1298916026000
111752	1678	25920814074000
111753	1874	23413000
111754	2134	86143725000
111755	1874	23419000
111756	2133	93563564000
111757	1874	23421000
111758	1447	13241710683000
111759	1447	13241724683000
111760	1447	13241720683000
111761	1397	1298906025000
111762	1678	25920814075000
111763	2132	147768770000
111764	1874	23420000
111765	1874	23422000
111766	2133	93562562000
111767	1874	23424000
111768	2134	86142722000
111769	1874	23427000
111770	2039	10699426000000
111771	1394	659530443500000
111772	1397	1298896024000
111773	1678	25920814076000
111774	1397	1298886023000
111775	1678	25920814077000
111776	1397	1298876022000
111777	1678	25920814078000
111778	2134	86141719000
111779	1874	23430000
111780	2134	86140716000
111781	1874	23433000
111782	2134	86139713000
111783	1874	23436000
111784	2133	93561560000
111785	1874	23438000
111786	2133	93560558000
111787	1874	23440000
111788	2133	93559556000
111789	1874	23442000
111790	2132	147767769000
111791	1874	23443000
111792	2112	15646643101924
111793	2112	15646680101924
111795	2112	14926793101924
111796	2112	15646793101924
111797	2112	15647253101924
111806	1397	1298856020000
111807	1678	25920814080000
111808	2133	93557552000
111809	1874	23450000
111810	2134	86137707000
111811	1874	23453000
111813	1397	1298846019000
111814	1678	25920814081000
111815	1397	1298836018000
111816	1678	25920814082000
111817	1397	1298826017000
111818	1678	25920814083000
111819	1448	10667836000001
111820	945	506263745391541
111821	1448	7783826000001
111822	1065	907220979807644
111823	1448	5837816000001
111824	1185	612120180476079
111825	1448	416806000001
111826	1311	1705725607568145
111827	1448	204796000001
111828	489	66458391250309
111829	2134	86136704000
111830	1874	23456000
111831	2133	93556550000
111832	1874	23458000
111833	2133	93555548000
111834	1874	23460000
111835	2133	93554546000
111836	1874	23462000
111837	2134	86135701000
111838	1874	23465000
111839	2134	86134698000
111840	1874	23468000
111841	2132	147766768000
111842	1874	23469000
111843	1749	15125476930000
111844	1749	200000020
111845	2266	15125563529980
111846	1758	1602000000
111848	1397	1298816016000
111849	1678	25920814084000
111850	2134	86133695000
111851	1874	23472000
111852	2133	93553544000
111853	1874	23474000
111854	1675	8204208999977
111855	1675	8204220999977
111875	1448	188786000001
111876	741	5034666003811
111877	1448	172776000001
111878	730	5034666003811
111879	1685	158403749571430
111880	1685	158403819571430
111929	1394	662410467500000
111947	1397	1298706005000
111948	1678	25920814095000
111949	2133	93542522000
111950	1874	23529000
111951	2134	86122662000
111952	1874	23532000
111953	2132	147762764000
111954	1874	23533000
111955	1560	9368695131803
111998	1764	25207402100000
111999	1764	25207426100000
112013	1668	6273552000000
112041	1436	720000000000
112042	1436	720013000000
112053	1688	46079628720020
112054	1688	46079650720020
112121	1686	12632035700122
112122	1686	12632057700122
112130	1397	1298515986000
112131	1678	25920814114000
112132	2132	147756758000
112133	1874	23631000
112134	2133	93522482000
112135	1874	23633000
112136	2134	86103605000
112137	1874	23636000
112138	2086	1440344300069
112139	2086	1440357300069
112143	1397	1298505985000
112144	1678	25920814115000
112145	2133	93521480000
112146	1874	23638000
112147	2134	86102602000
112148	1874	23641000
112149	2148	5040097880750
112150	2148	5040109880750
112169	1397	1298475982000
112170	1678	25920814118000
112171	1397	1298465981000
112172	1678	25920814119000
112173	2134	86099593000
112174	1874	23655000
112175	2133	93518474000
112176	1874	23657000
112177	2133	93517472000
112178	1874	23659000
112179	2134	86098590000
112180	1874	23662000
112181	2039	10699433000000
112228	1559	8226083999999
112257	149	74735397000341
112266	1394	668170531500000
112278	1708	13748171115923
112279	1708	13748183115923
112292	1397	1298385973000
112293	1678	25920814127000
112294	2134	86090566000
112295	1874	23702000
112296	2132	147752754000
112297	1874	23703000
112298	1448	6439776000001
112299	1448	6439788000001
112300	1397	1298375972000
112301	1678	25920814128000
112302	1397	1298365971000
112303	1678	25920814129000
112304	1397	1298355970000
112305	1678	25920814130000
112306	2133	93509456000
112307	1874	23705000
112308	2133	93508454000
112309	1874	23707000
112310	2133	93507452000
112311	1874	23709000
112312	2134	86089563000
112313	1874	23712000
112314	2134	86088560000
112315	1874	23715000
112316	2132	147751753000
112317	1874	23716000
112318	2134	86087557000
112319	1874	23719000
112320	1719	8640288000000
112321	1719	8640325000000
112323	1992	8640607990000
112465	2134	86072512000
112466	1874	23796000
112467	1874	23798000
112468	1480	2860932000000
112469	1397	1298195954000
112470	1678	25920814146000
112471	2133	93491420000
112472	1874	23800000
112473	2134	86071509000
112474	1874	23803000
112475	1395	58219110543957278
112572	1394	671050584500000
112591	1397	1298075942000
112592	1678	25920814158000
112593	2133	93478394000
112594	1874	23869000
112595	2134	86058470000
112596	1874	23872000
112597	1688	47519653720020
112598	1688	47519665720020
112610	1397	1298065941000
112611	1678	25920814159000
112612	1397	1298055940000
112613	1678	25920814160000
112614	1397	1298045939000
111794	1395	58217670532957278
111812	1688	44639591720020
111847	1749	15125563930000
111856	1397	1298806015000
111857	1678	25920814085000
111858	2134	86132692000
111859	1874	23477000
111860	2133	93552542000
111861	1874	23479000
111862	2132	147765767000
111863	1874	23480000
111864	1402	80495199319298
111867	1397	1298796014000
111868	1678	25920814086000
111869	2133	93551540000
111870	1874	23482000
111871	2134	86131689000
111872	1874	23485000
111932	1397	1298726007000
111933	1678	25920814093000
111934	2134	86124668000
111935	1874	23520000
111936	2133	93544526000
111937	1874	23522000
111938	1395	58217670507957278
111979	2307	719025000000
112014	1394	666730504500000
112015	1394	666730519500000
112032	1397	1298615996000
112033	1678	25920814104000
112034	2132	147759761000
112035	1874	23581000
112036	2133	93532502000
112037	1874	23583000
112038	2134	86112632000
112039	1874	23586000
112040	1686	11192023700122
112043	2106	5759098000000
112044	1448	172786000001
112045	1397	1298605995000
112046	1678	25920814105000
112047	2133	93531500000
112048	1874	23588000
112049	2134	86111629000
112050	1874	23591000
112051	1402	81215199319298
112052	1402	81215221319298
112055	1687	3008852848312
112070	1476	7200121000000
112071	1476	7200145000000
112099	1680	9373309499559
112111	1448	5719776000001
112112	449	66458391250309
112113	1397	1298535988000
112114	1678	25920814112000
112115	2133	93524486000
112116	1874	23622000
112117	2134	86105611000
112118	1874	23625000
112119	1709	3600068000000
112120	1709	3600090000000
112123	1397	1298525987000
112124	1678	25920814113000
112125	2133	93523484000
112126	1874	23627000
112127	2134	86104608000
112128	1874	23630000
112129	1541	3602289000000
112142	2087	2595400147766
112152	1397	1298495984000
112153	1678	25920814116000
112154	2133	93520478000
112155	1874	23643000
112156	2134	86101599000
112157	1874	23646000
112158	1610	7200152999950
112185	1394	668170519500000
112186	1394	668170543500000
112213	1874	23628000
112214	1874	23635000
112215	1874	23637000
112216	1874	23639000
112217	1874	23642000
112218	1874	23645000
112219	1874	23648000
112220	1874	23650000
112221	1874	23654000
112222	1874	23658000
112223	1874	23661000
112224	1874	23664000
112225	1874	23667000
112226	1874	23670000
112227	1559	8226194999999
112229	1571	8292062832307
112230	38	66443668039709
112231	1571	7837329766131
112232	969	506150276480512
112233	1571	7022459927607
112234	1089	907016958757500
112235	1571	6472647757326
112236	1209	611982415663305
112237	1571	4940565124154
112238	1335	1705343415688246
112239	1571	4940555124154
112240	1397	1298425977000
112241	1678	25920814123000
112242	1397	1298415976000
112243	1678	25920814124000
112244	2133	93514466000
112245	1874	23678000
112246	2134	86094578000
112247	1874	23681000
112248	2132	147753755000
112249	1874	23682000
112250	2133	93513464000
112251	1874	23684000
112252	2133	93512462000
112253	1874	23686000
112254	2134	86093575000
112255	1874	23689000
112256	1587	7200288000000
112258	1397	1298405975000
112259	1678	25920814125000
112260	2134	86092572000
112261	1874	23692000
112262	2133	93511460000
112263	1874	23694000
112264	1690	162005464000000
112265	1690	162005476000000
112273	2134	86091569000
112274	1874	23697000
112275	1874	23699000
112276	1489	23664602000000
112277	1489	23664614000000
112339	1397	1298325967000
112340	1678	25920814133000
112341	2134	86084548000
112342	1874	23732000
112343	2133	93504446000
112344	1874	23734000
112355	1637	282966790819988
112382	1546	6717366800000
112397	1448	12276856000001
112398	1448	10667846000001
112399	1448	7783836000001
112400	1448	5837826000001
112401	1673	32580929000000
112402	1448	416816000001
112403	1448	204806000001
112404	1448	188796000001
112405	1874	23298000
112406	1874	23304000
112407	1874	23307000
112408	1874	23309000
112409	1874	23311000
112410	1874	23314000
112411	1874	23315000
112412	1874	23317000
112413	1874	23323000
112414	1874	23326000
112415	1874	23333000
112416	1673	33300929000000
112417	1673	33301772000000
112442	1394	671050571500000
112443	1394	671050583500000
112459	1397	1298205955000
112460	1678	25920814145000
112461	2133	93492422000
112462	1874	23795000
112463	1480	2860920000000
112464	1480	2860931000000
112478	1397	1298185953000
112479	1678	25920814147000
112480	1397	1298175952000
112481	1678	25920814148000
112482	2132	147746748000
112483	1874	23804000
112484	2134	86070506000
112485	1874	23807000
112486	2133	93490418000
112487	1874	23809000
112488	2134	86069503000
112489	1874	23812000
112490	2133	93489416000
112491	1874	23814000
111798	1397	1298866021000
111799	1678	25920814079000
111800	2133	93558554000
111801	1874	23445000
111802	2134	86138710000
111803	1874	23448000
111804	1394	660970443500000
111805	1394	660970455500000
111865	1394	662410455500000
111866	1394	662410468500000
111873	149	74735311000341
111874	149	74735323000341
111881	1397	1298786013000
111882	1678	25920814087000
111883	1397	1298776012000
111884	1678	25920814088000
111885	2132	147764766000
111886	1874	23486000
111887	2133	93550538000
111888	1874	23488000
111889	2133	93549536000
111890	1874	23490000
111891	2134	86130686000
111892	1874	23493000
111893	2134	86129683000
111894	1874	23496000
111895	1708	13028126115923
111896	1708	13028171115923
111897	1397	1298766011000
111898	1678	25920814089000
111899	1397	1298756010000
111900	1678	25920814090000
111901	1397	1298746009000
111902	1678	25920814091000
111903	2132	147763765000
111904	1874	23497000
111905	2133	93548534000
111906	1874	23499000
111907	2133	93547532000
111908	1874	23501000
111909	2133	93546530000
111910	1874	23503000
111911	2134	86128680000
111912	1874	23506000
111913	2134	86127677000
111914	1874	23509000
111915	2134	86126674000
111916	1874	23512000
111917	1602	6336287170000
111920	1397	1298736008000
111921	1678	25920814092000
111922	2134	86125671000
111923	1874	23515000
111924	2133	93545528000
111925	1874	23517000
111926	1619	3600064000000
111939	1397	1298716006000
111940	1678	25920814094000
111941	2134	86123665000
111942	1874	23525000
111943	2133	93543524000
111944	1874	23527000
111945	1394	663850467500000
111946	1394	663850479500000
111964	1397	1298686003000
111965	1678	25920814097000
111966	1397	1298676002000
111967	1678	25920814098000
111968	2132	147761763000
111969	1874	23539000
111970	2133	93540518000
111971	1874	23541000
111972	2133	93539516000
111973	1874	23543000
111974	2134	86120656000
111975	1874	23546000
111976	2134	86119653000
111977	1874	23549000
111978	1696	13403631335104
111996	1395	58218390507957278
111997	1395	58218390531957278
112000	1397	1298645999000
112001	1678	25920814101000
112002	2134	86116644000
112003	1874	23562000
112004	2132	147760762000
112005	1874	23563000
112006	2134	86115641000
112007	1874	23566000
112008	2133	93536510000
112009	1874	23568000
112010	2133	93535508000
112011	1874	23570000
112012	1706	9642127450256
112072	1397	1298575992000
112073	1678	25920814108000
112074	2106	88000000
112075	1448	5931786000001
112076	2133	93528494000
112077	1874	23601000
112078	2134	86109623000
112079	1874	23604000
112080	1397	1298565991000
112081	1678	25920814109000
112082	2133	93527492000
112083	1874	23606000
112084	2134	86108620000
112085	1874	23609000
112086	1686	11912023700122
112087	1686	11912035700122
112100	1623	66963112899898
112140	1694	9898890197225
112141	1694	9898903197225
112151	1688	46079640720020
112159	1397	1298485983000
112160	1678	25920814117000
112161	2132	147755757000
112162	1874	23647000
112163	2133	93519476000
112164	1874	23649000
112165	2134	86100596000
112166	1874	23652000
112167	1395	58219110531957278
112168	1395	58219110544957278
112182	1992	7920583990000
112183	1992	7920607990000
112187	1874	23644000
112188	1874	23651000
112189	1874	23653000
112190	1874	23656000
112191	1992	7920632990000
112192	1397	1298455980000
112193	1678	25920814120000
112194	1397	1298445979000
112195	1678	25920814121000
112196	2132	147754756000
112197	1874	23663000
112198	2134	86097587000
112199	1874	23666000
112200	2134	86096584000
112201	1874	23669000
112202	2133	93516470000
112203	1874	23671000
112204	2133	93515468000
112205	1874	23673000
112206	1692	63141355619999
112207	1692	63141380619999
112280	2106	5039087000000
112281	1571	7572049831979
112282	1571	7117316765803
112283	1571	6302446927279
112284	1571	5752634756998
112285	1571	4220552123826
112286	1571	4220542123826
112287	1685	159123819571430
112288	1685	159123889571430
112291	1546	6717339800000
112322	1394	668170556500000
112324	1397	1298345969000
112325	1678	25920814131000
112326	1397	1298335968000
112327	1678	25920814132000
112328	2134	86086554000
112329	1874	23722000
112330	2133	93506450000
112331	1874	23724000
112332	2133	93505448000
112333	1874	23726000
112334	2134	86085551000
112335	1874	23729000
112336	1708	14468183115923
112337	1708	14468207115923
112356	1397	1298305965000
112357	1678	25920814135000
112358	1397	1298295964000
112359	1678	25920814136000
112360	1397	1298285963000
112361	1678	25920814137000
112362	2058	546500000
112363	2132	147749751000
112364	1874	23741000
112365	2133	93502442000
112366	1874	23743000
112367	2133	93501440000
112368	1874	23745000
111918	1688	45359591720020
111919	1688	45359628720020
111927	1680	9373296499559
111928	1680	9373308499559
111930	632	74637563000000
111931	632	74637574000000
111956	1397	1298696004000
111957	1678	25920814096000
111958	2133	93541520000
111959	1874	23535000
111960	2134	86121659000
111961	1874	23538000
111962	1439	8623665578477
111963	1439	8623677578477
111980	1394	665290479500000
111981	1394	665290504500000
111982	1397	1298666001000
111983	1678	25920814099000
111984	1397	1298656000000
111985	1678	25920814100000
111986	2134	86118650000
111987	1874	23552000
111988	2133	93538514000
111989	1874	23554000
111990	2133	93537512000
111991	1874	23556000
111992	2134	86117647000
111993	1874	23559000
111994	1587	7200202000000
111995	1587	7200226000000
112016	1700	5994212979053
112017	1700	5994227979053
112018	1397	1298635998000
112019	1678	25920814102000
112020	1397	1298625997000
112021	1678	25920814103000
112022	2134	86114638000
112023	1874	23573000
112024	2133	93534506000
112025	1874	23575000
112026	2133	93533504000
112027	1874	23577000
112028	2134	86113635000
112029	1874	23580000
112030	1637	282246753819988
112031	1637	282246777819988
112056	1397	1298595994000
112057	1678	25920814106000
112058	1397	1298585993000
112059	1678	25920814107000
112060	2133	93530498000
112061	1874	23593000
112062	2132	147758760000
112063	1874	23594000
112064	2133	93529496000
112065	1874	23596000
112066	2134	86110626000
112067	1874	23599000
112068	369	75156464290830
112069	369	75156488290830
112088	526	73200245000000
112089	526	73200257000000
112090	1397	1298555990000
112091	1678	25920814110000
112092	2134	86107617000
112093	1874	23612000
112094	2132	147757759000
112095	1874	23613000
112096	2133	93526490000
112097	1874	23615000
112098	369	75156477290830
112101	1874	23610000
112102	1634	12623037259504
112103	1634	12623049259504
112104	1397	1298545989000
112105	1678	25920814111000
112106	2133	93525488000
112107	1874	23617000
112108	2134	86106614000
112109	1874	23620000
112110	1724	8334689500000
112184	1395	58219110555957278
112208	1397	1298435978000
112209	1678	25920814122000
112210	2134	86095581000
112211	1874	23676000
112212	1395	58219110542957278
112267	1397	1298395974000
112268	1678	25920814126000
112269	2133	93510458000
112270	1874	23696000
112271	1546	6717327800000
112272	1546	6717338800000
112289	1637	282966777819988
112290	1637	282966789819988
112338	1670	4320916000000
112345	1397	1298315966000
112346	1678	25920814134000
112347	2132	147750752000
112348	1874	23735000
112349	2134	86083545000
112350	1874	23738000
112351	2133	93503444000
112352	1874	23740000
112353	1719	9360325000000
112354	1719	9360338000000
112372	2134	86082542000
112373	1874	23744000
112374	2134	86081539000
112375	2134	86080536000
112376	1874	23750000
112377	1874	23752000
112378	1874	23754000
112379	1874	23756000
112380	2261	7199133000000
112381	2261	7199172000000
112383	1397	1298275962000
112384	1678	25920814138000
112385	1397	1298265961000
112386	1678	25920814139000
112387	1874	23753000
112388	2134	86079533000
112389	1874	23759000
112390	2134	86078530000
112391	1874	23762000
112392	2133	93499436000
112393	1874	23764000
112394	2133	93498434000
112395	1874	23766000
112396	1394	668170546500000
112434	1397	1298235958000
112435	1678	25920814142000
112436	2134	86075521000
112437	1874	23780000
112438	2133	93495428000
112439	1874	23782000
112440	1719	10080338000000
112441	1719	10080350000000
112496	1397	1298165951000
112497	1678	25920814149000
112498	1397	1298155950000
112499	1678	25920814150000
112500	2134	86068500000
112501	1874	23817000
112502	2134	86067497000
112503	1874	23820000
112504	2133	93488414000
112505	1874	23822000
112506	2133	93487412000
112507	1874	23824000
112508	2133	93486410000
112509	1874	23826000
112510	2134	86066494000
112511	1874	23829000
112512	2132	147745747000
112513	1874	23830000
112514	1549	9791325000000
112515	1549	9791352000000
112529	1397	1298135948000
112530	1678	25920814152000
112531	1397	1298125947000
112532	1678	25920814153000
112533	2132	147744746000
112534	1874	23836000
112535	2133	93484406000
112536	1874	23838000
112537	2133	93483404000
112538	1874	23840000
112539	2134	86064488000
112540	1874	23843000
112541	2134	86063485000
112542	1874	23846000
112543	1587	7920288000000
112544	1587	7920313000000
112546	1397	1298115946000
112547	1678	25920814154000
112548	2133	93482402000
112549	1874	23848000
112550	2134	86062482000
112551	1874	23851000
112552	1536	8640157000000
112553	1536	8640169000000
112573	42	74368733400000
112574	1361	1705653644951650
112575	42	72080927000000
112369	2133	93500438000
112370	1874	23747000
112371	1546	6717363800000
112418	1397	1298255960000
112419	1678	25920814140000
112420	1397	1298245959000
112421	1678	25920814141000
112422	2133	93497432000
112423	1874	23768000
112424	2133	93496430000
112425	1874	23770000
112426	2134	86077527000
112427	1874	23773000
112428	2134	86076524000
112429	1874	23776000
112430	2132	147748750000
112431	1874	23777000
112432	1394	669610546500000
112433	1394	669610571500000
112444	1397	1298225957000
112445	1678	25920814143000
112446	1397	1298215956000
112447	1678	25920814144000
112448	2134	86074518000
112449	1874	23785000
112450	2133	93494426000
112451	1874	23787000
112452	2133	93493424000
112453	1874	23789000
112454	2134	86073515000
112455	1874	23792000
112456	2132	147747749000
112457	1874	23793000
112458	1602	6336275170000
112476	1690	162725476000000
112477	1690	162725488000000
112494	1552	4320064000000
112495	1552	4320089000000
112517	1633	6528571125277
112518	1633	6528598125277
112527	1508	9560351156616
112528	1508	9560363156616
112554	1397	1298105945000
112555	1678	25920814155000
112556	2133	93481400000
112557	1874	23853000
112558	2134	86061479000
112559	1874	23856000
112560	1723	5761656085979
112561	1723	5761668085979
112590	1992	9361018990000
112599	1506	200000030
112600	2266	7492702967162
112631	1688	48239665720020
112632	1688	48239702720020
112641	1700	5994224979053
112664	2133	93472382000
112665	1874	23901000
112666	1560	10088707131803
112690	470	74640298000000
112694	1703	2880874000000
112716	2106	720088000000
112736	1458	14345196908540
112737	1458	14345222908540
112764	1397	1297905925000
112765	1678	25920814175000
112766	2133	93461360000
112767	1874	23956000
112768	2134	86042422000
112769	1874	23959000
112770	1717	7021070000055
112771	1717	7021082000055
112792	1397	1297865921000
112793	1678	25920814179000
112794	2134	86038410000
112795	1874	23978000
112796	2132	147736738000
112797	1874	23979000
112798	2133	93457352000
112799	1874	23981000
112835	1471	9305313900000
112836	1471	10025313900000
112837	1471	10025316900000
112862	1874	24003000
112863	1874	24006000
112864	1874	24009000
112865	1874	24012000
112866	608	6436755292484
112867	1693	66000020000000
112869	1397	1297785913000
112870	1678	26640839187000
112871	1397	1297775912000
112872	1678	26640839188000
112873	2134	86030386000
112874	1874	24017000
112875	2134	86029383000
112876	1874	24020000
112877	1874	24022000
112878	1874	24024000
112879	2133	93449336000
112880	1874	24026000
112881	2133	93448334000
112882	1874	24028000
112883	1746	1248843000000
112884	2309	2742644000000
112885	1602	7056275170000
112886	1602	7056303170000
112901	2133	93446330000
112902	1874	24039000
112903	2039	10699421000000
112906	1397	1297745909000
112907	1678	26640839191000
112908	2133	93445328000
112909	1874	24041000
112910	2134	86026374000
112911	1874	24044000
112912	1623	67683112899898
112913	1623	67683124899898
112931	1684	16563095819412
112932	1684	16563108819412
112934	1397	1297715906000
112935	1678	26640839194000
112936	1397	1297705905000
112937	1678	26640839195000
112938	2134	86023365000
112939	1874	24058000
112940	2133	93442322000
112941	1874	24060000
112942	2133	93441320000
112943	1874	24062000
112944	2134	86022362000
112945	1874	24065000
112946	1571	5660579124154
112963	1599	8936770097983
112964	1599	8936781097983
113007	1394	673930622500000
113008	1394	673930646500000
113010	1397	1297625897000
113011	1678	26640839203000
113012	1397	1297615896000
113013	1678	26640839204000
113014	2132	147729731000
113015	1874	24103000
113016	2133	93433304000
113017	1874	24105000
113018	2134	86014338000
113019	1874	24108000
113020	2309	2742643000000
113021	1523	0
113022	2134	86013335000
113023	1874	24111000
113024	2133	93432302000
113025	1874	24113000
113026	1693	7156755292484
113027	1693	7156781292484
113110	2058	535500000
113111	1397	1297495884000
113112	1678	26640839216000
113113	2132	147725727000
113114	1874	24172000
113115	2133	93420278000
113116	1874	24174000
113117	2134	86001299000
113118	1874	24177000
113119	1588	29015672000000
113167	1394	675370634500000
113168	1394	675370648500000
113182	369	75876477290830
113183	369	75876492290830
113197	1397	1297455880000
113198	1678	26640839220000
113199	2134	85997287000
113200	1874	24198000
113201	2133	93415268000
113202	1874	24200000
113203	576	73277509726897
113204	576	73277521726897
113300	1762	5685363994000
113301	1762	5685375994000
113311	1690	163445488000000
113312	1690	163445500000000
113408	1397	1297325867000
113409	1678	26640839233000
113410	1397	1297315866000
113411	1678	26640839234000
112492	1656	9355413999990
112493	1656	9355438999990
112516	1394	671050598500000
112519	1397	1298145949000
112520	1678	25920814151000
112521	2133	93485408000
112522	1874	23832000
112523	2134	86065491000
112524	1874	23835000
112525	1715	19466885436096
112526	1715	19466897436096
112545	1394	671050596500000
112562	1397	1298095944000
112563	1678	25920814156000
112564	2132	147743745000
112565	1874	23857000
112566	2133	93480398000
112567	1874	23859000
112568	2134	86060476000
112569	1874	23862000
112570	1688	46799640720020
112571	1688	46799653720020
112602	1759	23041091999889
112603	1759	23041103999889
112604	42	72928700400000
112605	42	70640894000000
112606	42	69097142800000
112607	42	67820562000000
112608	1685	159843889571430
112609	1685	159844291571430
112644	1874	23891000
112645	1700	5994223979053
112656	1874	23897000
112657	1739	30239840000000
112667	1397	1298005935000
112668	1678	25920814165000
112669	2133	93471380000
112670	1874	23903000
112671	2134	86052452000
112672	1874	23906000
112673	1780	1438923000000
112692	1702	5760512000000
112693	1702	5760537000000
112703	1560	10808706131803
112704	1560	10808717131803
112706	1397	1297965931000
112707	1678	25920814169000
112708	2134	86048440000
112709	1874	23925000
112710	2132	147739741000
112711	1874	23926000
112712	2133	93467372000
112713	1874	23928000
112714	1448	7159788000001
112715	1448	7159801000001
112717	1685	160564291571430
112800	1397	1297855920000
112801	1678	25920814180000
112802	2134	86037407000
112803	1874	23984000
112804	2133	93456350000
112805	1874	23986000
112806	1679	25199336653000
112815	1397	1297835918000
112816	1678	25920814182000
112817	1397	1297825917000
112818	1678	25920814183000
112819	2132	147735737000
112820	1874	23992000
112821	2133	93454346000
112822	1874	23994000
112823	1549	9071347000000
112824	2133	93453344000
112825	1874	23996000
112826	2134	86035401000
112827	1874	23999000
112828	2134	86034398000
112829	1874	24002000
112830	1549	9791347000000
112831	1549	9791350000000
112868	1685	161284291571430
112914	1397	1297735908000
112915	1678	26640839192000
112916	2133	93444326000
112917	1874	24046000
112918	2134	86025371000
112919	1874	24049000
112920	1657	4321241990100
112921	1657	4321253990100
112947	1397	1297695904000
112948	1678	26640839196000
112949	2132	147731733000
112950	1874	24066000
112951	2134	86021359000
112952	1874	24069000
112953	2133	93440318000
112954	1874	24071000
112955	1395	58220550556957278
112956	1395	58220550569957278
112968	1599	8936782097983
112969	1397	1297675902000
112970	1678	26640839198000
112971	1397	1297665901000
112972	1678	26640839199000
112973	2133	93438314000
112974	1874	24078000
112975	2132	147730732000
112976	1874	24079000
112977	2133	93437312000
112978	1874	24081000
112979	2134	86019353000
112980	1874	24084000
112981	2134	86018350000
112982	1874	24087000
112983	1471	10025317900000
112986	1397	1297655900000
112987	1678	26640839200000
112988	2133	93436310000
112989	1874	24089000
112990	2134	86017347000
112991	1874	24092000
113044	1397	1297585893000
113045	1678	26640839207000
113046	2134	86010326000
113047	1874	24127000
113048	2133	93429296000
113049	1874	24129000
113050	1700	6714224979053
113051	1700	6714236979053
113097	1397	1297515886000
113098	1678	26640839214000
113099	1397	1297505885000
113100	1678	26640839215000
113101	2134	86003305000
113102	1874	24164000
113103	2133	93422282000
113104	1874	24166000
113105	2133	93421280000
113106	1874	24168000
113107	2134	86002302000
113108	1874	24171000
113109	1489	23664626000000
113169	1692	63861380619999
113170	1692	63861392619999
113187	1448	7879814000001
113191	1397	1297465881000
113192	1678	26640839219000
113193	2133	93416270000
113194	1874	24195000
113195	606	71806646286230
113196	606	71806657286230
113253	1397	1297375872000
113254	1678	26640839228000
113255	1397	1297365871000
113256	1678	26640839229000
113257	2133	93407252000
113258	1874	24239000
113259	2134	85989263000
113260	1874	24242000
113261	2133	93406250000
113262	1874	24244000
113263	2132	147721723000
113264	1874	24245000
113265	2134	85988260000
113266	1874	24248000
113267	1762	4965363994000
113298	1394	675370635500000
113422	1678	25920814232000
113423	1678	25920814233000
113424	1678	25920814234000
113425	1874	23900000
113426	1874	23902000
113427	1874	23908000
113428	1874	23914000
113429	1874	23918000
113430	1874	23924000
113431	1874	23930000
113432	1874	23932000
113433	1593	10033432000000
113434	1874	23944000
113435	1874	23946000
113436	1874	23950000
113437	1874	23952000
113438	1874	23968000
113439	1874	23971000
112576	1115	907182953800000
112577	42	70537175800000
112578	1235	612094660400000
112579	42	69260595000000
112580	995	506242508600000
112581	1992	8641007990000
112582	1397	1298085943000
112583	1678	25920814157000
112584	2134	86059473000
112585	1874	23865000
112586	2133	93479396000
112587	1874	23867000
112588	1992	9361007990000
112589	1992	9361019990000
112601	2307	719012000000
112642	1395	58219830543957278
112643	1395	58219830555957278
112646	1397	1298025937000
112647	1678	25920814163000
112648	2132	147741743000
112649	1874	23894000
112650	2133	93473384000
112651	1874	23896000
112652	2134	86053455000
112653	1874	23899000
112654	470	74640273000000
112655	470	74640286000000
112691	1395	58219830568957278
112695	1397	1297975932000
112696	1678	25920814168000
112697	2134	86049443000
112698	1874	23920000
112699	2133	93468374000
112700	1874	23922000
112701	1654	10937365999798
112702	1654	10937377999798
112738	1397	1297935928000
112739	1678	25920814172000
112740	1397	1297925927000
112741	1678	25920814173000
112742	1746	7075490000000
112743	1075	909796465000000
112744	2133	93464366000
112745	1874	23940000
112746	2133	93463364000
112747	1874	23942000
112748	1746	3992489000000
112749	1195	613858750000000
112750	2134	86045431000
112751	1874	23945000
112752	2134	86044428000
112753	1874	23948000
112754	2132	147738740000
112755	1874	23949000
112756	1536	9360169000000
112757	1536	9360196000000
112772	1397	1297895924000
112773	1678	25920814176000
112774	1397	1297885923000
112775	1678	25920814177000
112776	2134	86041419000
112777	1874	23962000
112778	2134	86040416000
112779	1874	23965000
112780	2133	93460358000
112781	1874	23967000
112782	2133	93459356000
112783	1874	23969000
112784	2132	147737739000
112785	1874	23970000
112887	1397	1297765911000
112888	1678	26640839189000
112889	2133	93447332000
112890	1874	24030000
112891	2134	86028380000
112892	1874	24033000
112893	2132	147733735000
112894	1874	24034000
112895	1395	58219830556957278
112904	484	72573888000000
112905	484	72573900000000
112933	1684	16563107819412
112965	2133	93439316000
112966	1874	24076000
112967	2112	16366692101924
113009	1670	5040940000000
113028	1397	1297605895000
113029	1678	26640839205000
113030	1397	1297595894000
113031	1678	26640839206000
113032	2134	86012332000
113033	1874	24116000
113034	2134	86011329000
113035	1874	24119000
113036	2132	147728730000
113037	1874	24120000
113038	2133	93431300000
113039	1874	24122000
113040	2133	93430298000
113041	1874	24124000
113042	1571	6380579124154
113043	1571	6380604124154
113068	1397	1297555890000
113069	1678	26640839210000
113070	2133	93426290000
113071	1874	24142000
113072	2134	86007317000
113073	1874	24145000
113074	1394	673930634500000
113075	1397	1297545889000
113076	1678	26640839211000
113077	1397	1297535888000
113078	1678	26640839212000
113079	1397	1297525887000
113080	1678	26640839213000
113081	2133	93425288000
113082	1874	24147000
113083	2134	86006314000
113084	1874	24150000
113085	2134	86005311000
113086	1874	24153000
113087	2134	86004308000
113088	1874	24156000
113089	2132	147726728000
113090	1874	24157000
113091	2133	93424286000
113092	1874	24159000
113093	2133	93423284000
113094	1874	24161000
113095	1719	10800350000000
113096	1719	10800387000000
113120	1678	25920814184000
113121	1455	2192723000000
113122	1678	25920814185000
113123	1678	25920814186000
113124	1678	25920814187000
113125	1678	25920814188000
113126	1678	25920814189000
113127	1678	25920814190000
113128	1678	25920814191000
113129	1678	25920814192000
113130	1678	25920814193000
113131	1678	25920814194000
113132	1678	25920814195000
113133	1678	25920814196000
113134	1678	25920814197000
113135	1678	25920814198000
113136	1678	25920814199000
113137	1678	25920814200000
113138	1678	25920814201000
113139	1678	25920814202000
113140	1678	25920814203000
113141	1678	25920814204000
113142	1678	25920814205000
113143	1678	25920814206000
113144	1678	25920814207000
113145	1678	25920814208000
113146	1678	25920814209000
113147	1678	25920814210000
113148	1678	25920814211000
113149	1678	25920814212000
113150	1678	25920814213000
113151	1678	25920814214000
113152	1678	25920814215000
113153	1678	25920814216000
113154	1455	2912723000000
113155	1455	2913067000000
113184	1874	24190000
113185	1874	24192000
113186	369	75876490290830
113190	2106	720099000000
113205	1397	1297445879000
113206	1678	26640839221000
113207	1397	1297435878000
113208	1678	26640839222000
113209	1397	1297425877000
113210	1678	26640839223000
113211	1397	1297415876000
113212	1678	26640839224000
113213	1397	1297405875000
113214	1678	26640839225000
113215	1397	1297395874000
113216	1678	26640839226000
113217	1397	1297385873000
113218	1678	26640839227000
112615	1678	25920814161000
112616	2132	147742744000
112617	1874	23873000
112618	2134	86057467000
112619	1874	23876000
112620	2134	86056464000
112621	1874	23879000
112622	2133	93477392000
112623	1874	23881000
112624	2133	93476390000
112625	1874	23883000
112626	2134	86055461000
112627	1874	23886000
112628	2133	93475388000
112629	1874	23888000
112630	1654	10217365999798
112633	1397	1298035938000
112634	1678	25920814162000
112635	2133	93474386000
112636	1874	23890000
112637	2134	86054458000
112638	1874	23893000
112639	1670	5040916000000
112640	1670	5040928000000
112658	1611	8775709000000
112659	1611	8775722000000
112660	1397	1298015936000
112661	1678	25920814164000
112662	1560	10088695131803
112663	1560	10088706131803
112674	1397	1297995934000
112675	1678	25920814166000
112676	1397	1297985933000
112677	1678	25920814167000
112678	2134	86051449000
112679	1874	23909000
112680	2134	86050446000
112681	1874	23912000
112682	2132	147740742000
112683	1874	23913000
112684	2133	93470378000
112685	1874	23915000
112686	2133	93469376000
112687	1874	23917000
112688	1656	10075438999990
112689	1656	10075463999990
112705	1560	10808718131803
112718	1397	1297955930000
112719	1678	25920814170000
112720	1397	1297945929000
112721	1678	25920814171000
112722	1747	65931000000
112723	1321	1710569637751650
112724	1746	11644491000000
112725	955	507701775000000
112726	2134	86047437000
112727	1874	23931000
112728	2134	86046434000
112729	1874	23934000
112730	2133	93466370000
112731	1874	23936000
112732	2133	93465368000
112733	1874	23938000
112734	1571	5660555124154
112735	1571	5660581124154
112758	1397	1297915926000
112759	1678	25920814174000
112760	2133	93462362000
112761	1874	23951000
112762	2134	86043425000
112763	1874	23954000
112786	1397	1297875922000
112787	1678	25920814178000
112788	2133	93458354000
112789	1874	23972000
112790	2134	86039413000
112791	1874	23975000
112807	1397	1297845919000
112808	1678	25920814181000
112809	2133	93455348000
112810	1874	23988000
112811	2134	86036404000
112812	1874	23991000
112813	1717	7741082000055
112814	1717	7741094000055
112832	1678	25920836183000
112833	1678	26640836183000
112834	1678	26640839183000
112838	1397	1297815916000
112839	1678	26640839184000
112840	1397	1297805915000
112841	1678	26640839185000
112842	1397	1297795914000
112843	1678	26640839186000
112844	2133	93452342000
112845	1874	24004000
112846	2132	147734736000
112847	1874	24005000
112848	2134	86033395000
112849	1874	24008000
112850	2134	86032392000
112851	1874	24011000
112852	2134	86031389000
112853	1874	24014000
112854	2133	93451340000
112855	1874	24016000
112856	2133	93450338000
112857	1874	24018000
112858	1746	3990488000000
112859	2309	1000000000
112860	1693	6436740292484
112861	1693	6436778292484
112896	1397	1297755910000
112897	1678	26640839190000
112898	2134	86027377000
112899	1874	24037000
112900	2039	10699420000000
112922	1397	1297725907000
112923	1678	26640839193000
112924	2132	147732734000
112925	1874	24050000
112926	2134	86024368000
112927	1874	24053000
112928	2133	93443324000
112929	1874	24055000
112930	1402	81215212319298
112957	1397	1297685903000
112958	1678	26640839197000
112959	2134	86020356000
112960	1874	24074000
112961	2112	16366680101924
112962	2112	16366691101924
112984	1394	672490596500000
112985	1394	672490622500000
112992	1686	12632047700122
112993	1397	1297645899000
112994	1678	26640839201000
112995	1397	1297635898000
112996	1678	26640839202000
112997	2133	93435308000
112998	1874	24094000
112999	2133	93434306000
113000	1874	24096000
113001	2134	86016344000
113002	1874	24099000
113003	2134	86015341000
113004	1874	24102000
113005	43	71040042890000
113006	43	71040066890000
113052	1397	1297575892000
113053	1678	26640839208000
113054	1397	1297565891000
113055	1678	26640839209000
113056	2134	86009323000
113057	1874	24132000
113058	2133	93428294000
113059	1874	24134000
113060	2133	93427292000
113061	1874	24136000
113062	2132	147727729000
113063	1874	24137000
113064	2134	86008320000
113065	1874	24140000
113066	1675	8924220999977
113067	1675	8924245999977
113156	1397	1297485883000
113157	1678	26640839217000
113158	2133	93419276000
113159	1874	24179000
113160	2134	86000296000
113161	1874	24182000
113162	2134	85999293000
113163	1874	24185000
113164	2133	93418274000
113165	1874	24187000
113166	1708	14468197115923
113171	1397	1297475882000
113172	1678	26640839218000
113173	2134	85998290000
113174	1874	24188000
113175	2132	147724726000
113176	1874	24189000
113177	1874	24191000
113178	2133	93417272000
113179	1874	24193000
113180	1448	7879801000001
113181	1448	7879816000001
113188	1394	676810648500000
113189	1394	676810661500000
113268	1874	24162000
113269	1874	24165000
113270	1874	24167000
113271	1874	24169000
113272	1874	24173000
113273	1874	24176000
113274	1874	24178000
113275	1874	24180000
113276	1874	24184000
113277	1874	24186000
113278	1874	24201000
113279	1874	24207000
113280	1874	24210000
113281	1874	24213000
113282	1874	24216000
113283	1874	24219000
113284	1874	24222000
113285	1874	24233000
113286	1874	24235000
113287	1874	24241000
113288	1874	24243000
113289	1762	4965547994000
113299	1656	10075450999990
113304	1397	1297345869000
113305	1678	26640839231000
113306	2134	85986254000
113307	1874	24256000
113308	2133	93404246000
113309	1874	24258000
113310	1668	6273549000000
113358	1874	23665000
113359	1874	23675000
113360	1874	23677000
113361	1874	23679000
113362	1874	23683000
113363	1874	23685000
113364	1874	23687000
113365	1874	23691000
113366	1874	23693000
113367	1874	23695000
113368	1874	23701000
113369	1874	23711000
113370	1874	23713000
113371	1874	23717000
113372	1874	23721000
113373	1874	23723000
113374	1874	23725000
113375	1874	23727000
113376	1874	23731000
113377	1874	23733000
113378	1874	23736000
113379	1874	23739000
113380	1874	23742000
113381	1874	23748000
113382	1874	23751000
113383	1874	23757000
113384	1874	23760000
113385	1874	23763000
113386	1874	23769000
113387	1874	23772000
113388	1874	23775000
113389	1874	23778000
113390	1874	23781000
113391	1874	23784000
113392	1874	23790000
113393	1455	2913282000000
113394	1874	23877000
113395	1874	23880000
113396	1874	23889000
113397	1874	23892000
113398	1874	23895000
113399	1874	23898000
113400	1874	23904000
113401	1874	23907000
113402	1874	23910000
113403	1874	23916000
113404	1874	23919000
113405	1874	23921000
113406	1455	3633282000000
113407	1455	3633327000000
113464	1397	1297285863000
113465	1678	26640839237000
113466	2133	93398234000
113467	1874	24287000
113468	2134	85980236000
113469	1874	24290000
113470	1717	8461094000055
113471	1717	8461126000055
113483	1397	1297265861000
113484	1678	26640839239000
113485	2133	93396230000
113486	1874	24298000
113487	2134	85978230000
113488	1874	24301000
113489	1688	48959678720020
113490	1688	48959690720020
113493	1397	1297255860000
113494	1678	26640839240000
113495	2134	85977227000
113496	1874	24304000
113497	2133	93395228000
113498	1874	24306000
113499	2253	200100000
113500	1693	7876781192484
113501	2253	7876803092484
113502	1693	200200000
113538	171	75306884596494
113539	1397	1297205855000
113540	1678	26640839245000
113541	2132	147716718000
113542	1874	24328000
113543	2133	93390218000
113544	1874	24330000
113545	2134	85972212000
113546	1874	24333000
113547	1395	58221270569957278
113548	1395	58221270582957278
113578	1693	8596803092484
113579	1693	8596816092484
113583	1397	1297165851000
113584	1678	26640839249000
113585	2133	93386210000
113586	1874	24348000
113587	1874	24351000
113588	2134	85968200000
113589	1874	24354000
113590	1402	81935212319298
113591	1402	81935235319298
113601	1654	11657377999798
113602	1654	11657379999798
113617	1719	11520387000000
113618	1719	11520409000000
113681	58	71747571999641
113689	1633	7248598125277
113690	1633	7248610125277
113693	1397	1297055840000
113694	1678	26640839260000
113695	2133	93375188000
113696	1874	24409000
113697	2134	85957167000
113698	1874	24412000
113699	1394	678250671500000
113700	1394	678250683500000
113717	1397	1297025837000
113718	1678	26640839263000
113719	1397	1297015836000
113720	1678	26640839264000
113721	1476	7920190000000
113722	2133	93372182000
113723	1874	24425000
113724	2133	93371180000
113725	1874	24427000
113726	2134	85954158000
113727	1874	24430000
113728	2134	85953155000
113729	1874	24433000
113730	1476	8640190000000
113731	1476	8640194000000
113757	2134	85950146000
113758	1874	24449000
113759	1447	13961732683000
113787	1397	1296945829000
113788	1678	26640839271000
113789	2134	85946134000
113790	1874	24468000
113791	2133	93364166000
113792	1874	24470000
113793	42	69980607000000
113809	1610	7920152999950
113810	1610	7920177999950
113816	1397	1296915826000
113817	1678	26640839274000
113818	2133	93361160000
113819	1874	24483000
113820	2133	93360158000
113821	1874	24485000
113822	2132	147707709000
113823	1874	24486000
113824	1451	20779150000000
113833	1874	24484000
113834	1874	24487000
113219	2133	93414266000
113220	1874	24202000
113221	2133	93413264000
113222	1874	24204000
113223	2132	147723725000
113224	1874	24205000
113225	2134	85996284000
113226	1874	24208000
113227	2134	85995281000
113228	1874	24211000
113229	2134	85994278000
113230	1874	24214000
113231	2134	85993275000
113232	1874	24217000
113233	2134	85992272000
113234	1874	24220000
113235	2132	147722724000
113236	1874	24221000
113237	2133	93412262000
113238	1874	24223000
113239	2133	93411260000
113240	1874	24225000
113241	2133	93410258000
113242	1874	24227000
113243	2133	93409256000
113244	1874	24229000
113245	2133	93408254000
113246	1874	24231000
113247	2134	85991269000
113248	1874	24234000
113249	2134	85990266000
113250	1874	24237000
113251	1458	15065222908540
113252	1458	15065308908540
113290	1397	1297355870000
113291	1678	26640839230000
113292	2133	93405248000
113293	1874	24250000
113294	2134	85987257000
113295	1874	24253000
113296	1895	2159936000000
113297	1895	2159948000000
113302	1762	5685547994000
113303	1762	5685559994000
113313	1698	9428847550062
113314	1698	9428859550062
113315	1698	8709808550062
113316	1678	25920814217000
113317	1678	25920814218000
113318	1678	25920814219000
113319	1678	25920814220000
113320	1678	25920814221000
113321	1678	25920814222000
113322	1678	25920814223000
113323	1678	25920814224000
113324	1678	25920814225000
113325	1678	25920814226000
113326	1678	25920814227000
113327	1678	25920814228000
113328	1678	25920814229000
113329	1678	25920814230000
113330	1678	25920814231000
113331	1874	23799000
113332	1874	23802000
113333	1874	23805000
113334	1874	23808000
113335	1874	23811000
113336	1874	23823000
113337	1874	23841000
113338	1874	23844000
113339	1874	23847000
113340	1874	23850000
113341	1874	23868000
113342	1874	23871000
113343	1874	23874000
113344	1698	9429808550062
113345	1520	9430151550053
113346	1698	100000017
113347	1571	4940555124162
113348	1397	1297335868000
113349	1678	26640839232000
113350	2133	93403244000
113351	1874	24260000
113352	2132	147720722000
113353	1874	24261000
113354	2134	85985251000
113355	1874	24264000
113356	1671	6863906003785
113357	1671	6863919003785
113421	1690	163445512000000
113446	1397	1297305865000
113447	1678	26640839235000
113448	1397	1297295864000
113449	1678	26640839236000
113450	2133	93400238000
113451	1874	24276000
113452	2134	85982242000
113453	1874	24279000
113454	2133	93399236000
113455	1874	24281000
113456	2132	147719721000
113457	1874	24282000
113458	2134	85981239000
113459	1874	24285000
113460	1705	16400810580140
113527	1587	8640313000000
113528	1587	8640325000000
113531	1397	1297215856000
113532	1678	26640839244000
113533	2134	85973215000
113534	1874	24325000
113535	2133	93391220000
113536	1874	24327000
113555	1397	1297195854000
113556	1678	26640839246000
113557	1397	1297185853000
113558	1678	26640839247000
113559	2134	85971209000
113560	1874	24338000
113561	1874	24340000
113562	2134	85970206000
113563	1874	24343000
113564	1451	20779161000000
113566	2132	147715717000
113567	1874	24344000
113568	2133	93387212000
113569	1874	24346000
113570	1675	9644245999977
113571	1675	9644247999977
113581	1749	15845563529980
113582	1749	15845576529980
113603	2087	2595399147766
113613	1426	8970321000000
113614	1426	8970343000000
113619	1564	6126575000000
113620	1564	6126597000000
113621	1397	1297135848000
113622	1678	26640839252000
113623	1397	1297125847000
113624	1678	26640839253000
113625	2133	93383204000
113626	1874	24366000
113627	2133	93382202000
113628	1874	24368000
113629	2132	147714716000
113630	1874	24369000
113631	2134	85965191000
113632	1874	24372000
113633	2134	85964188000
113634	1874	24375000
113635	1394	676810646500000
113636	1394	676810671500000
113647	1706	9642124450256
113656	1397	1297095844000
113657	1678	26640839256000
113658	1397	1297085843000
113659	1678	26640839257000
113660	2134	85961179000
113661	1874	24389000
113662	2134	85960176000
113663	1874	24392000
113664	2133	93379196000
113665	1874	24394000
113666	2133	93378194000
113667	1874	24396000
113668	1711	9786852000000
113669	1711	9786876000000
113703	1397	1297045839000
113704	1678	26640839261000
113705	2133	93374186000
113706	1874	24414000
113707	2134	85956164000
113708	1874	24417000
113772	1874	24454000
113773	2134	85949143000
113774	1874	24457000
113775	2134	85948140000
113776	1874	24460000
113777	1762	5685389994000
113779	1397	1296955830000
113780	1678	26640839270000
113781	2134	85947137000
113782	1874	24463000
113783	2133	93365168000
113784	1874	24465000
113412	2134	85984248000
113413	1874	24267000
113414	2134	85983245000
113415	1874	24270000
113416	2133	93402242000
113417	1874	24272000
113418	2133	93401240000
113419	1874	24274000
113420	1593	10752684000000
113462	1714	8205554171760
113463	1714	8205579171760
113472	1397	1297275862000
113473	1678	26640839238000
113474	1688	47519675720020
113475	2133	93397232000
113476	1874	24292000
113477	2134	85979233000
113478	1874	24295000
113479	2132	147718720000
113480	1874	24296000
113481	1688	48239675720020
113482	1688	48239678720020
113491	1508	10280363156616
113492	1508	10280365156616
113503	1693	7876781292484
113504	1693	7876803292484
113521	1397	1297225857000
113522	1678	26640839243000
113523	2134	85974218000
113524	1874	24320000
113525	2133	93392222000
113526	1874	24322000
113529	1692	64581392619999
113530	1692	64581404619999
113549	2133	93389216000
113550	1874	24335000
113551	2133	93388214000
113552	1874	24337000
113553	1451	20779137000000
113554	1451	20779139000000
113580	1675	9644258999977
113592	2148	5760109880750
113593	2148	5760132880750
113605	1397	1297145849000
113606	1678	26640839251000
113607	2133	93384206000
113608	1874	24361000
113609	2134	85966194000
113610	1874	24364000
113611	1602	7776303170000
113612	1602	7776325170000
113639	1397	1297115846000
113640	1678	26640839254000
113641	2134	85963185000
113642	1874	24378000
113643	2133	93381200000
113644	1874	24380000
113645	1717	9181126000055
113646	1717	9181138000055
113648	1397	1297105845000
113649	1678	26640839255000
113650	2134	85962182000
113651	1874	24383000
113652	2132	147713715000
113653	1874	24384000
113654	2133	93380198000
113655	1874	24386000
113691	1637	283686801819988
113692	1637	283686813819988
113749	1541	4322289000000
113750	1541	4322314000000
113760	1397	1296975832000
113761	1678	26640839268000
113762	1397	1296965831000
113763	1678	26640839269000
113764	2133	93367172000
113765	1874	24448000
113766	2133	93366170000
113767	1874	24450000
113768	2132	147709711000
113769	1874	24451000
113770	1447	14681731683000
113771	1447	14681754683000
113794	1471	10025541900000
113811	1395	58221990582957278
113812	1395	58221990607957278
113825	2134	85943125000
113826	1874	24488000
113827	1874	24489000
113828	2134	85942122000
113829	1874	24492000
113830	1451	20779152000000
113867	1397	1296865821000
113868	1678	26640839279000
113869	2133	93355148000
113870	1874	24515000
113871	2134	85937107000
113872	1874	24518000
113873	1690	164165512000000
113874	1690	164165524000000
113897	1675	10364247999977
113898	1675	10364259999977
113941	1397	1296785813000
113942	1678	26640839287000
113943	2134	85929083000
113944	1874	24558000
113945	2133	93347132000
113946	1874	24560000
113947	2132	147703705000
113948	1874	24561000
113949	1688	50399702720020
113950	1688	50399715720020
113960	42	73648711400000
113961	42	71360905000000
113962	42	69817153800000
113963	42	68540573000000
113964	1513	33842837000000
113965	1678	25200792044000
113966	1678	25200792045000
113967	1678	25200792046000
113968	1678	25200792047000
113969	1678	25200792048000
113970	1678	25200792049000
113971	1678	25200792050000
113972	1678	25200792051000
113973	1678	25200792052000
113974	1678	25200792053000
113975	1678	25200792054000
113976	1678	25200792055000
113977	1678	25200792056000
113978	1678	25200792057000
113979	1678	25200792058000
113980	1678	25200792059000
113981	1513	34562837000000
113982	1513	34563027000000
114012	446	66720000000000
114013	446	66720025000000
114023	1397	1296725807000
114024	1678	26640839293000
114025	1397	1296715806000
114026	1678	26640839294000
114027	2132	147701703000
114028	1874	24588000
114029	2134	85923065000
114030	1874	24591000
114031	2134	85922062000
114032	1874	24594000
114033	2133	93341120000
114034	1874	24596000
114035	2133	93340118000
114036	1874	24598000
114037	1395	58222710594957278
114038	1395	58222710619957278
114063	1397	1296675802000
114064	1678	26640839298000
114065	2133	93336110000
114066	1874	24613000
114067	2134	85919053000
114068	1874	24616000
114069	1673	33300731000000
114137	1397	1296605795000
114138	1678	26640839305000
114139	1874	24643000
114140	2133	93329096000
114141	1874	24647000
114142	1874	24650000
114143	2134	85912032000
114144	1874	24653000
114145	1692	66021441619999
114146	1692	66021466619999
114200	1397	1296525787000
114201	1678	26640839313000
114202	2134	85904008000
114203	1874	24693000
114204	2133	93321080000
114205	1874	24695000
114206	1560	11528731131803
114207	1560	11528743131803
114261	1397	1296455780000
114262	1678	26640839320000
114263	2133	92213066000
114264	1874	24729000
114265	2134	85896987000
114266	1874	24732000
114267	1536	11520220000000
113440	1874	23974000
113441	1874	23977000
113442	1874	23980000
113443	1874	23983000
113444	1593	10753432000000
113445	1593	10753452000000
113461	1705	16400790580140
113505	1397	1297245859000
113506	1678	26640839241000
113507	1397	1297235858000
113508	1678	26640839242000
113509	2133	93394226000
113510	1874	24308000
113511	2133	93393224000
113512	1874	24310000
113513	2134	85976224000
113514	1874	24313000
113515	2134	85975221000
113516	1874	24316000
113517	2132	147717719000
113518	1874	24317000
113519	1476	7920145000000
113520	1476	7920170000000
113537	1394	675370646500000
113565	1637	282966801819988
113572	1397	1297175852000
113573	1678	26640839248000
113574	2134	85969203000
113575	1874	24349000
113576	1679	25919336653000
113577	1679	25919349653000
113594	1397	1297155850000
113595	1678	26640839250000
113596	2134	85967197000
113597	1874	24357000
113598	2133	93385208000
113599	1874	24359000
113600	2086	1440356300069
113604	1654	11657389999798
113615	484	73293900000000
113616	484	73293922000000
113637	42	69980595000000
113638	42	69980620000000
113670	1419	17567031560130
113671	2310	0
113672	1397	1297075842000
113673	1678	26640839258000
113674	2134	85959173000
113675	1874	24399000
113676	2133	93377192000
113677	1874	24401000
113678	2132	147712714000
113679	1874	24402000
113680	1602	7776566170000
113682	1397	1297065841000
113683	1678	26640839259000
113684	2133	93376190000
113685	1874	24404000
113686	2134	85958170000
113687	1874	24407000
113688	1679	25919348653000
113701	1458	15785308908540
113702	1458	15785320908540
113709	1397	1297035838000
113710	1678	26640839262000
113711	2133	93373184000
113712	1874	24419000
113713	2134	85955161000
113714	1874	24422000
113715	2132	147711713000
113716	1874	24423000
113732	1397	1297005835000
113733	1678	26640839265000
113734	1397	1296995834000
113735	1678	26640839266000
113736	2132	147710712000
113737	1874	24434000
113738	2133	93370178000
113739	1874	24436000
113740	2133	93369176000
113741	1874	24438000
113742	2134	85952152000
113743	1874	24441000
113744	2134	85951149000
113745	1874	24444000
113746	1596	3600196000000
113747	1718	6018390519070
113748	1718	6018415519070
113751	1397	1296985833000
113752	1678	26640839267000
113753	2133	93368174000
113754	1874	24446000
113755	1447	13961720683000
113756	1447	13961731683000
113778	1447	14681757683000
113795	1397	1296935828000
113796	1678	26640839272000
113797	1397	1296925827000
113798	1678	26640839273000
113799	2133	93363164000
113800	1874	24472000
113801	2133	93362162000
113802	1874	24474000
113803	2132	147708710000
113804	1874	24475000
113805	2134	85945131000
113806	1874	24478000
113807	2134	85944128000
113808	1874	24481000
113814	1637	284406813819988
113815	1637	284406838819988
113836	1397	1296905825000
113837	1678	26640839275000
113838	2134	85941119000
113839	1874	24495000
113840	2133	93359156000
113841	1874	24497000
113842	1536	10080196000000
113843	1536	10080208000000
113845	1397	1296895824000
113846	1678	26640839276000
113847	2133	93358154000
113848	1874	24499000
113849	2134	85940116000
113850	1874	24502000
113899	1723	6481668085979
113900	1723	6481680085979
113951	1397	1296775812000
113952	1678	26640839288000
113953	2133	93346130000
113954	1874	24563000
113955	2134	85928080000
113956	1874	24566000
113957	1395	58221990594957278
113991	470	75360298000000
113993	2097	200104017
113994	446	66719999900001
114014	1397	1296735808000
114015	1678	26640839292000
114016	2133	93342122000
114017	1874	24581000
114018	1874	24584000
114019	2134	85924068000
114020	1874	24587000
114021	1850	12936418949999
114039	1397	1296705805000
114040	1678	26640839295000
114041	2133	93339116000
114042	1874	24600000
114043	2134	85921059000
114044	1874	24603000
114045	1747	785931000000
114046	1747	785943000000
114070	1402	83375247319298
114071	1402	83375259319298
114072	1397	1296665801000
114073	1678	26640839299000
114074	1397	1296655800000
114075	1678	26640839300000
114076	2133	93335108000
114077	1874	24618000
114078	2134	85918050000
114079	1874	24621000
114080	2134	85917047000
114081	1874	24624000
114082	2133	93334106000
114083	1874	24626000
114084	1547	7914731000000
114085	1547	7914755000000
114088	1397	1296645799000
114089	1678	26640839301000
114090	1397	1296635798000
114091	1678	26640839302000
114092	1397	1296625797000
114093	1678	26640839303000
114094	2133	93333104000
114095	1874	24628000
114096	2133	93332102000
114097	1874	24630000
114098	2133	93331100000
114099	1874	24632000
114100	2132	147699701000
114101	1874	24633000
114102	2134	85916044000
114103	1874	24636000
113785	1688	49679690720020
113786	1688	49679702720020
113813	1560	10808731131803
113831	1709	4320090000000
113832	1709	4320105000000
113875	1397	1296855820000
113876	1678	26640839280000
113877	1397	1296845819000
113878	1678	26640839281000
113879	2134	85936104000
113880	1874	24521000
113881	2134	85935101000
113882	1874	24524000
113883	2133	93354146000
113884	1874	24526000
113885	2133	93353144000
113886	1874	24528000
113887	2132	147705707000
113888	1874	24529000
113889	1711	11226901000000
113890	1711	11226926000000
113911	1397	1296825817000
113912	1678	26640839283000
113913	1397	1296815816000
113914	1678	26640839284000
113915	1397	1296805815000
113916	1678	26640839285000
113917	2132	147704706000
113918	1874	24535000
113919	2133	93351140000
113920	1874	24537000
113921	2133	93350138000
113922	1874	24539000
113923	2133	93349136000
113924	1874	24541000
113925	2134	85933095000
113926	1874	24544000
113927	2134	85932092000
113928	1874	24547000
113929	2134	85931089000
113930	1874	24550000
113931	1740	10530727000000
113932	1740	10530764000000
114011	1690	164885549000000
114110	1397	1296615796000
114111	1678	26640839304000
114112	1874	24625000
114113	2132	147698700000
114114	1874	24634000
114115	2133	93330098000
114116	1874	24645000
114117	2134	85913035000
114118	1874	24648000
114119	632	74637637000000
114184	1397	1296545789000
114185	1678	26640839311000
114186	1397	1296535788000
114187	1678	26640839312000
114188	2133	93323084000
114189	1874	24681000
114190	2133	93322082000
114191	1874	24683000
114192	2134	85906014000
114193	1874	24686000
114194	2134	85905011000
114195	1874	24689000
114196	2132	147696698000
114197	1874	24690000
114198	362	66720000000000
114199	362	66720025000000
114208	1397	1296515786000
114209	1678	26640839314000
114210	1397	1296505785000
114211	1678	26640839315000
114212	2133	93320078000
114213	1874	24697000
114214	2133	93319076000
114215	1874	24699000
114216	2134	85903005000
114217	1874	24702000
114218	2134	85902002000
114219	1874	24705000
114220	2132	147695697000
114221	1874	24706000
114222	1633	7248623125277
114249	1397	1296465781000
114250	1678	26640839319000
114251	633	75789480900000
114252	2134	85897990000
114253	1874	24725000
114254	2133	92214068000
114255	1874	24727000
114256	633	76509480900000
114257	633	76509482900000
114269	1749	16565588529980
114274	1397	1296445779000
114275	1678	26640839321000
114276	2133	92212064000
114277	1874	24734000
114278	2132	147693695000
114279	1874	24735000
114280	2134	85895984000
114281	1874	24738000
114282	2261	7199146000000
114285	1397	1296435778000
114286	1678	26640839322000
114287	2134	85894981000
114288	1874	24741000
114289	2133	92211062000
114290	1874	24743000
114291	1710	8873984664140
114292	1710	8873996664140
114305	1691	7631084300052
114317	1489	24384626000000
114318	1489	24384639000000
114329	1694	10618915197225
114502	369	75876515290830
114509	1397	1296295764000
114510	1678	26640839336000
114511	2132	147688690000
114512	1874	24813000
114513	2134	85880939000
114514	1874	24816000
114515	2133	92197034000
114516	1874	24818000
114517	1675	10364260999977
114528	1439	9343677578477
114529	1439	9343689578477
114546	1724	9054689500000
114547	1724	9054701500000
114582	1397	1296215756000
114583	1678	26640839344000
114584	2133	92189018000
114585	1874	24857000
114586	2134	85872915000
114587	1874	24860000
114589	1397	1296205755000
114590	1678	26640839345000
114591	2134	85871912000
114592	1874	24863000
114593	2133	92188016000
114594	1874	24865000
114595	1681	10691329909853
114596	1681	11411329909853
114619	1471	10025305900000
114635	1397	1296155750000
114636	1678	26640839350000
114637	2134	85866897000
114638	1874	24889000
114639	2133	92183006000
114640	1874	24891000
114641	1571	7100604124154
114642	1571	7100616124154
114645	1602	8496566170000
114646	1602	8496578170000
114674	1874	24893000
114675	1874	24895000
114676	1764	25207435100000
114687	326	66720015000000
114704	1560	12248757131803
114713	1397	1296075742000
114714	1678	26640839358000
114715	1397	1296065741000
114716	1678	26640839359000
114717	2134	85858873000
114718	1874	24929000
114719	2134	85857870000
114720	1874	24932000
114721	2133	92174990000
114722	1874	24934000
114723	2133	92173988000
114724	1874	24936000
114725	1670	6480952000000
114726	1670	6480976000000
114750	1402	80210098344073
114751	1678	25920814328000
114752	1678	25920814329000
114753	1678	25920814330000
114754	1678	25920814331000
114755	1678	25920814332000
114756	1678	25920814333000
114757	1678	25920814334000
114758	1678	25920814335000
114759	1678	25920814336000
114760	1678	25920814337000
113835	1709	4320092000000
113844	43	71040054890000
113851	1397	1296885823000
113852	1678	26640839277000
113853	1397	1296875822000
113854	1678	26640839278000
113855	2134	85939113000
113856	1874	24505000
113857	2133	93357152000
113858	1874	24507000
113859	2133	93356150000
113860	1874	24509000
113861	2132	147706708000
113862	1874	24510000
113863	2134	85938110000
113864	1874	24513000
113865	1711	10506876000000
113866	1711	10506901000000
113891	1397	1296835818000
113892	1678	26640839282000
113893	2134	85934098000
113894	1874	24532000
113895	2133	93352142000
113896	1874	24534000
113901	1419	16847019560130
113902	1571	7572049832307
113903	1571	7117316766131
113904	1457	11521084800000
113905	1571	6302446927607
113906	1571	5752634757326
113907	1571	4220552124154
113908	1571	4220542124154
113909	1457	12241084800000
113910	1457	12242224800000
113933	1397	1296795814000
113934	1678	26640839286000
113935	2134	85930086000
113936	1874	24553000
113937	2133	93348134000
113938	1874	24555000
113939	1536	10800208000000
113940	1536	10800220000000
113958	1690	164885524000000
113959	1690	164885536000000
113983	1397	1296765811000
113984	1678	26640839289000
113985	2133	93345128000
113986	1874	24568000
113987	2134	85927077000
113988	1874	24571000
113989	1402	82655235319298
113990	1402	82655247319298
113992	1749	16565576529980
113995	1397	1296755810000
113996	1678	26640839290000
113997	1397	1296745809000
113998	1678	26640839291000
113999	2132	147702704000
114000	1874	24572000
114001	2134	85926074000
114002	1874	24575000
114003	2133	93344126000
114004	1874	24577000
114005	2133	93343124000
114006	1874	24579000
114007	2134	85925071000
114008	1874	24582000
114009	1688	51119715720020
114010	1688	51119740720020
114022	1688	51119752720020
114047	1746	1968843000000
114048	1746	1968855000000
114049	1397	1296695804000
114050	1678	26640839296000
114051	1397	1296685803000
114052	1678	26640839297000
114053	2134	85920056000
114054	1874	24606000
114055	2132	147700702000
114056	1874	24607000
114057	2133	93338114000
114058	1874	24609000
114059	2133	93337112000
114060	1874	24611000
114061	1654	12377379999798
114062	1654	12377403999798
114086	1691	7631072300052
114087	1691	7631096300052
114165	1397	1296575792000
114166	1678	26640839308000
114167	1397	1296565791000
114168	1678	26640839309000
114169	1397	1296555790000
114170	1678	26640839310000
114171	2133	93326090000
114172	1874	24666000
114173	2133	93325088000
114174	1874	24668000
114175	2134	85909023000
114176	1874	24671000
114177	2134	85908020000
114178	1874	24674000
114179	2134	85907017000
114180	1874	24677000
114181	2133	93324086000
114182	1874	24679000
114183	1447	14681767683000
114231	1397	1296485783000
114232	1678	26640839317000
114233	1397	1296475782000
114234	1678	26640839318000
114235	2132	147694696000
114236	1874	24712000
114237	2133	92217074000
114238	2311	100000000
114239	2133	92216072000
114240	1874	24714000
114241	2134	85899996000
114242	1874	24717000
114243	2134	85898993000
114244	1874	24720000
114245	2133	92215070000
114246	1874	24722000
114247	1395	58223430619957278
114248	1395	58223430645957278
114258	1601	11413839620000
114259	1601	12133839620000
114260	1601	12133841620000
114303	1670	5760940000000
114304	1670	5760952000000
114308	1397	1296415776000
114309	1678	26640839324000
114310	2133	92209058000
114311	1874	24750000
114312	2134	85892975000
114313	1874	24753000
114314	2132	147692694000
114315	1874	24754000
114316	1402	83375260319298
114319	1874	24749000
114320	1489	24384627000000
114328	58	71747320999641
114330	58	71747321999641
114480	1397	1296335768000
114481	1678	26640839332000
114482	1397	1296325767000
114483	1678	26640839333000
114484	1397	1296315766000
114485	1678	26640839334000
114486	2133	92201042000
114487	1874	24793000
114488	2134	85884951000
114489	1874	24796000
114490	2133	92200040000
114491	1874	24798000
114492	2133	92199038000
114493	1874	24800000
114494	2134	85883948000
114495	1874	24803000
114496	2134	85882945000
114497	1874	24806000
114498	2119	191000000
114499	2132	147689691000
114500	1874	24807000
114501	1599	8936808097983
114503	1397	1296305765000
114504	1678	26640839335000
114505	2133	92198036000
114506	1874	24809000
114507	2134	85881942000
114508	1874	24812000
114526	1546	7437363800000
114527	1546	7437375800000
114530	1397	1296275762000
114531	1678	26640839338000
114532	2134	85878933000
114533	1874	24826000
114534	2133	92195030000
114535	1874	24828000
114536	1395	58224150645957278
114537	1395	58224150657957278
114538	1397	1296265761000
114539	1678	26640839339000
114540	2134	85877930000
114541	1874	24831000
114104	2134	85915041000
114105	1874	24639000
114106	2134	85914038000
114107	1874	24642000
114108	1692	65301404619999
114109	1692	65301441619999
114120	632	73918204000000
114121	1874	24093000
114122	1874	24095000
114123	1874	24097000
114124	1874	24098000
114125	1874	24100000
114126	1874	24101000
114127	1874	24104000
114128	1874	24106000
114129	1874	24107000
114130	1874	24109000
114131	1874	24110000
114132	632	74638204000000
114133	632	200000004
114134	1796	74638871999998
114135	1964	10000000
114136	1538	200000001
114147	1397	1296595794000
114148	1678	26640839306000
114149	1397	1296585793000
114150	1678	26640839307000
114151	2132	147697699000
114152	1874	24644000
114153	1874	24646000
114154	1874	24651000
114155	1874	24654000
114156	2134	85911029000
114157	1874	24657000
114158	2134	85910026000
114159	1874	24660000
114160	2133	93328094000
114161	1874	24662000
114162	2133	93327092000
114163	1874	24664000
114164	1637	284406863819988
114223	1397	1296495784000
114224	1678	26640839316000
114225	2133	93318074000
114226	1874	24708000
114227	2134	85900999000
114228	1874	24711000
114229	641	74643827000000
114230	641	74643839000000
114273	1559	8946095999999
114301	2112	17086691101924
114302	2112	17086703101924
114306	1419	18287031560130
114307	1419	18287043560130
114323	1874	24751000
114324	2133	92208056000
114325	1874	24756000
114326	1694	10618903197225
114327	1694	10618916197225
114346	1448	8599816000001
114347	1448	8599841000001
114381	1678	25920814235000
114382	1678	25920814236000
114383	1678	25920814237000
114384	1678	25920814238000
114385	1678	25920814239000
114386	1678	25920814240000
114387	1678	25920814241000
114388	1678	25920814242000
114389	1678	25920814243000
114390	1678	25920814244000
114391	1678	25920814245000
114392	1678	25920814246000
114393	1678	25920814247000
114394	1678	25920814248000
114395	1678	25920814249000
114396	1678	25920814250000
114397	1678	25920814251000
114398	1678	25920814252000
114399	1678	25920814253000
114400	1678	25920814254000
114401	1678	25920814255000
114402	1678	25920814256000
114403	1678	25920814257000
114404	1678	25920814258000
114405	1678	25920814259000
114406	1678	25920814260000
114407	1678	25920814261000
114408	1678	25920814262000
114409	1678	25920814263000
114410	1678	25920814264000
114411	1678	25920814265000
114412	1678	25920814266000
114413	1678	25920814267000
114414	1678	25920814268000
114415	1678	25920814269000
114416	1678	25920814270000
114417	1678	25920814271000
114418	1678	25920814272000
114419	1678	25920814273000
114420	1678	25920814274000
114421	1678	25920814275000
114422	1678	25920814276000
114423	1678	25920814277000
114424	1678	25920814278000
114425	1678	25920814279000
114426	1678	25920814280000
114427	1678	25920814281000
114428	1678	25920814282000
114429	1678	25920814283000
114430	1678	25920814284000
114431	1678	25920814285000
114432	1678	25920814286000
114433	1678	25920814287000
114434	1678	25920814288000
114435	1678	25920814289000
114436	1678	25920814290000
114437	1678	25920814291000
114438	1678	25920814292000
114439	1678	25920814293000
114440	1678	25920814294000
114441	1678	25920814295000
114442	1678	25920814296000
114443	1678	25920814297000
114444	1678	25920814298000
114445	1678	25920814299000
114446	1678	25920814300000
114447	1678	25920814301000
114448	1678	25920814302000
114449	1678	25920814303000
114450	1678	25920814304000
114451	1678	25920814305000
114452	1678	25920814306000
114453	1678	25920814307000
114454	1678	25920814308000
114455	1678	25920814309000
114456	1678	25920814310000
114457	1455	3634367000000
114458	1678	25920814311000
114459	1678	25920814312000
114460	1678	25920814313000
114461	1678	25920814314000
114462	1678	25920814315000
114463	1678	25920814316000
114464	1678	25920814317000
114465	1678	25920814318000
114466	1678	25920814319000
114467	1678	25920814320000
114468	1678	25920814321000
114469	1678	25920814322000
114470	1678	25920814323000
114471	1678	25920814324000
114472	1678	25920814325000
114473	1678	25920814326000
114474	1678	25920814327000
114475	1455	4354367000000
114476	2250	200000004
114477	1796	204000000
114478	1571	4354535999991
114479	1455	4940555124162
114518	1397	1296285763000
114519	1678	26640839337000
114520	2133	92196032000
114521	1874	24820000
114522	2134	85879936000
114523	1874	24823000
114524	1719	12240435000000
114525	1719	12240447000000
114548	1397	1296255760000
114549	1678	26640839340000
114550	2134	85876927000
114551	1874	24836000
114552	2132	147687689000
114553	1874	24837000
114554	2133	92193026000
114555	1874	24839000
114556	1715	19466898436096
114567	2133	92192024000
114568	1874	24841000
114569	1874	24842000
114570	2133	92191022000
114571	1874	24844000
114572	2133	92190020000
114573	1874	24846000
114574	2134	85875924000
114268	1536	11520232000000
114270	1874	24730000
114271	1559	8946083999999
114272	1559	8946084999999
114283	1874	24733000
114284	2261	7199134000000
114293	1397	1296425777000
114294	1678	26640839323000
114295	2134	85893978000
114296	1874	24746000
114297	2133	92210060000
114298	1874	24748000
114299	1673	34020731000000
114300	1673	34020743000000
114321	1723	7201680085979
114322	1723	7201681085979
114331	1397	1296405775000
114332	1678	26640839325000
114333	1397	1296395774000
114334	1678	26640839326000
114335	2133	92207054000
114336	1874	24758000
114337	2133	92206052000
114338	1874	24760000
114339	2132	147691693000
114340	1874	24761000
114341	2134	85891972000
114342	1874	24764000
114343	2134	85890969000
114344	1874	24767000
114345	2106	720113000000
114348	1397	1296385773000
114349	1678	26640839327000
114350	2133	92205050000
114351	1874	24769000
114352	2134	85889966000
114353	1874	24772000
114354	1588	29735672000000
114355	1588	29735684000000
114356	1397	1296375772000
114357	1678	26640839328000
114358	1397	1296365771000
114359	1678	26640839329000
114360	1397	1296355770000
114361	1678	26640839330000
114362	1397	1296345769000
114363	1678	26640839331000
114364	2134	85888963000
114365	1874	24775000
114366	2132	147690692000
114367	1874	24776000
114368	2134	85887960000
114369	1874	24779000
114370	2134	85886957000
114371	1874	24782000
114372	2134	85885954000
114373	1874	24785000
114374	2133	92204048000
114375	1874	24787000
114376	2133	92203046000
114377	1874	24789000
114378	2133	92202044000
114379	1874	24791000
114380	1719	11520435000000
114608	1874	24870000
114609	1714	8205566171760
114615	2134	85869906000
114616	1874	24876000
114617	1706	10362124450256
114618	1706	10362138450256
114663	1701	10078266500103
114664	1701	10078290500103
114665	1397	1296125747000
114666	1678	26640839353000
114667	2134	85863888000
114668	1874	24900000
114669	1874	24902000
114670	1874	24904000
114671	2133	92180000000
114672	1874	24906000
114673	1764	25207438100000
114702	1560	12248755131803
114703	1560	12248767131803
114705	1397	1296085743000
114706	1678	26640839357000
114707	2133	92175992000
114708	1874	24923000
114709	2134	85859876000
114710	1874	24926000
114711	1623	68403124899898
114712	1623	68403136899898
114792	2134	85853858000
114793	1874	24956000
114794	1714	8925587171760
114801	1402	79532332968864
114802	796	616579120319670
114803	1397	1296015736000
114804	1678	26640839364000
114805	1402	79420304719737
114806	807	28013292775935
114807	1402	78188095054345
114808	808	308145951608564
114809	1402	77933870405665
114810	809	60255571266433
114811	1402	75137501710178
114812	810	662810705478461
114813	1402	74782969331459
114814	842	84031146773964
114815	1402	74122001778122
114816	844	156664358883961
114817	1402	69228384075906
114818	850	1154676151626426
114819	1402	59748717473867
114820	852	2246928439532916
114821	1402	58703422804871
114822	854	247760013772034
114823	1402	58150496390061
114824	856	131055761758687
114825	2133	92167976000
114826	1874	24963000
114827	1394	679690792500000
114853	1395	58225590661957278
114854	1395	58225590734957278
114872	1688	51119777720020
114882	1397	1295975732000
114883	1678	26640839368000
114884	2133	92163968000
114885	1874	24983000
114886	2134	85847840000
114887	1874	24986000
114888	1422	8154615804270
114914	1402	25019782421307
114915	890	226446580939895
114916	1402	22922503261602
114917	892	497108061843492
114918	1402	22645836766968
114919	898	65574880186960
114920	1402	22480912773160
114921	900	39088962651939
114922	1402	21985184608176
114923	902	117498269162913
114924	1709	5040105000000
114925	1709	5040395000000
114933	1709	5040115000000
114953	1397	1295905725000
114954	1678	26640839375000
114955	2133	92156954000
114956	1874	25018000
114957	1426	8970332000000
115008	1397	1295865721000
115009	1678	26640839379000
115010	2134	85837810000
115011	1874	25036000
115012	2133	92152946000
115013	1874	25038000
115014	1622	25740536000005
115037	1717	9901138000055
115038	1717	9901174000055
115070	1623	69123147899898
115073	1397	1295785713000
115074	1678	26640839387000
115075	1397	1295775712000
115076	1678	26640839388000
115077	2134	85829786000
115078	1874	25074000
115079	2134	85828783000
115080	1874	25077000
115081	2133	92145932000
115082	1874	25079000
115083	2133	92144930000
115084	1874	25081000
115085	1394	682570828500000
115097	1637	285126863819988
115098	1637	285126875819988
115107	1397	1295745709000
115108	1678	26640839391000
115109	2134	85825774000
115110	1874	25094000
115111	2133	92141924000
115112	1874	25096000
115199	1637	285846875819988
115200	1637	285846887819988
115201	1397	1295655700000
115202	1678	26640839400000
115203	2134	85816747000
114542	2133	92194028000
114543	1874	24833000
114544	576	73997521726897
114545	576	73997533726897
114557	1397	1296245759000
114558	1678	26640839341000
114559	1397	1296235758000
114560	1678	26640839342000
114561	1397	1296225757000
114562	1678	26640839343000
114563	2132	147686688000
114564	1874	24840000
114565	1394	679690671500000
114566	1394	679690702500000
114588	1693	8596815092484
114597	1397	1296195754000
114598	1678	26640839346000
114599	2133	92187014000
114600	1874	24867000
114601	2132	147685687000
114602	1874	24868000
114603	2134	85870909000
114604	1874	24871000
114605	1685	154083627571430
114620	1395	58224150659957278
114621	1397	1296175752000
114622	1678	26640839348000
114623	1397	1296165751000
114624	1678	26640839349000
114625	2134	85868903000
114626	1874	24879000
114627	2133	92185010000
114628	1874	24881000
114629	2134	85867900000
114630	1874	24884000
114631	2133	92184008000
114632	1874	24886000
114633	576	73997545726897
114643	621	68160044000000
114644	621	68160056000000
114647	1687	3728852848312
114648	1687	3728864848312
114649	1588	30455684000000
114696	1397	1296095744000
114697	1678	26640839356000
114698	2134	85860879000
114699	1874	24919000
114700	2133	92176994000
114701	1874	24921000
114727	1397	1296055740000
114728	1678	26640839360000
114729	1397	1296045739000
114730	1678	26640839361000
114731	1402	82370146344073
114732	34	67574074366663
114733	2134	85856867000
114734	1874	24939000
114735	2134	85855864000
114736	1874	24942000
114737	2133	92172986000
114738	1874	24944000
114739	2133	92171984000
114740	1874	24946000
114741	369	76596515290830
114742	369	76596549290830
114795	2134	85852855000
114796	1874	24959000
114797	2133	92168978000
114798	1874	24961000
114799	1395	58224870659957278
114800	1395	58224870661957278
114873	1397	1295985733000
114874	1678	26640839367000
114875	42	69980617000000
114876	2133	92164970000
114877	1874	24978000
114878	2134	85848843000
114879	1874	24981000
114880	42	70700617000000
114881	42	70700619000000
114907	1397	1295945729000
114908	1678	26640839371000
114909	2134	85844831000
114910	1874	24999000
114911	2133	92160962000
114912	1874	25001000
114913	1611	8775721000000
114926	1397	1295935728000
114927	1678	26640839372000
114928	2133	92159960000
114929	1874	25003000
114930	2134	85843828000
114931	1874	25006000
114932	1709	5040117000000
114951	1688	51839777720020
114952	1688	51839789720020
114958	1397	1295895724000
114959	1678	26640839376000
114960	2134	85840819000
114961	1874	25021000
114962	2133	92155952000
114963	1874	25023000
114974	1654	13097403999798
114975	1654	13097415999798
115006	1402	25739782421307
115007	1402	25739792421307
115039	1397	1295825717000
115040	1678	26640839383000
115041	2133	92148938000
115042	1874	25055000
115043	2134	85833798000
115044	1874	25058000
115045	1394	682570804500000
115046	1394	682570816500000
115048	1397	1295815716000
115049	1678	26640839384000
115050	2133	92147936000
115051	1874	25060000
115052	2134	85832795000
115053	1874	25063000
115054	367	66000011000000
115055	446	66000998900001
115056	1933	3722269000000
115057	1394	682570818500000
115071	1633	7968623125277
115072	1633	7968634125277
115086	1874	25073000
115087	1874	25075000
115088	1692	66021463619999
115113	1397	1295735708000
115114	1678	26640839392000
115115	2133	92140922000
115116	1874	25098000
115117	2134	85824771000
115118	1874	25101000
115119	1671	8303956003785
115120	1671	8303968003785
115130	1508	10280387156616
115131	1508	11000387156616
115140	1397	1295705705000
115141	1678	26640839395000
115142	2133	92137916000
115143	1874	25113000
115144	2134	85821762000
115145	1874	25116000
115146	519	66721917000000
115147	1719	12238528000000
115148	1719	12238570000000
115150	1402	20202495822424
115151	906	422541852566961
115152	1402	19804066757638
115153	1267	94435818214287
115154	1397	1295695704000
115155	1678	26640839396000
115156	2134	85820759000
115157	1874	25119000
115158	2133	92136914000
115159	1874	25121000
115160	1527	287999962
115161	1686	12632034700123
115162	1686	12632076700123
115191	1397	1295665701000
115192	1678	26640839399000
115193	2134	85817750000
115194	1874	25134000
115195	2133	92133908000
115196	1874	25136000
115211	1675	11084260999977
115212	1675	11084272999977
115226	1397	1295625697000
115227	1678	26640839403000
115228	2134	85813738000
115229	1874	25154000
115230	2133	92129900000
115231	1874	25156000
115232	1395	58225590673957278
115235	1397	1295615696000
115236	1678	26640839404000
115237	2133	92128898000
115238	1874	25158000
115239	1587	8640324000000
115249	2133	92127896000
115250	1874	25163000
115251	1395	58226310673957278
115252	1395	58226310685957278
114575	1874	24849000
114576	2134	85874921000
114577	1874	24852000
114578	2134	85873918000
114579	1874	24855000
114580	1671	7583919003785
114581	1671	7583956003785
114606	1874	24866000
114607	1714	8205565171760
114610	1397	1296185753000
114611	1678	26640839347000
114612	2133	92186012000
114613	1874	24873000
114614	1471	10025304900000
114634	1560	11528755131803
114650	1397	1296145749000
114651	1678	26640839351000
114652	1397	1296135748000
114653	1678	26640839352000
114654	2134	85865894000
114655	1874	24894000
114656	2134	85864891000
114657	1874	24897000
114658	2133	92182004000
114659	1874	24899000
114660	2133	92181002000
114661	1874	24901000
114662	2112	17086715101924
114677	1397	1296115746000
114678	1678	26640839354000
114679	1874	24903000
114680	2133	92178998000
114681	1874	24905000
114682	1874	24908000
114683	2134	85862885000
114684	1874	24911000
114685	1447	15401767683000
114686	1447	15401782683000
114688	1397	1296105745000
114689	1678	26640839355000
114690	2133	92177996000
114691	1874	24913000
114692	2134	85861882000
114693	1874	24916000
114694	1602	9216578170000
114695	1602	9216590170000
114743	1397	1296035738000
114744	1678	26640839362000
114745	2133	92170982000
114746	1874	24948000
114747	2134	85854861000
114748	1874	24951000
114749	1593	10752672000000
114784	1397	1296025737000
114785	1678	26640839363000
114786	1402	82133653373639
114787	795	56052696220424
114788	2133	92169980000
114789	1874	24953000
114790	1714	8925565171760
114791	1714	8925586171760
114833	1402	56756315912048
114834	858	330455144970164
114835	1402	54830631501773
114836	862	456435584056305
114837	1402	53140095451847
114838	866	400699225607122
114839	1397	1296005735000
114840	1678	26640839365000
114841	1402	42844400483440
114842	868	2440348667799579
114843	1402	41743347053908
114844	870	260976309470763
114845	1402	31447652085501
114846	874	2440348667799579
114847	2133	92166974000
114848	1874	24965000
114849	1874	24968000
114850	2134	85850849000
114851	1874	24971000
114852	1756	6320837195609
114855	1402	30545180810740
114856	876	213907105399279
114857	1402	29973188312672
114858	880	135574925957243
114859	1402	27494587487553
114860	882	587491345815068
114861	1402	27113255822176
114862	884	90383283971510
114863	1402	25975156992857
114864	888	269757045508602
114865	1397	1295995734000
114866	1678	26640839366000
114867	2134	85849846000
114868	1874	24974000
114869	2133	92165972000
114870	1874	24976000
114871	1395	58225590723957278
114893	1397	1295965731000
114894	1678	26640839369000
114895	2133	92162966000
114896	1874	24988000
114897	2134	85846837000
114898	1874	24991000
114899	1672	6481321000000
114942	641	75363839000000
114943	641	75363851000000
114964	1711	11946926000000
114965	1711	11946938000000
115017	1397	1295855720000
115018	1678	26640839380000
115019	1397	1295845719000
115020	1678	26640839381000
115021	1397	1295835718000
115022	1678	26640839382000
115023	2134	85836807000
115024	1874	25041000
115025	2134	85835804000
115026	1874	25044000
115027	2134	85834801000
115028	1874	25047000
115029	2133	92151944000
115030	1874	25049000
115031	2133	92150942000
115032	1874	25051000
115033	2133	92149940000
115034	1874	25053000
115035	1670	7200976000000
115036	1670	7201012000000
115047	2112	17086692101924
115058	1693	8596817092484
115065	1397	1295795714000
115066	1678	26640839386000
115067	2134	85830789000
115068	1874	25071000
115069	1394	682570815500000
115089	1397	1295765711000
115090	1678	26640839389000
115091	2134	85827780000
115092	1874	25084000
115093	2133	92143928000
115094	1874	25086000
115095	1573	4899327000000
115096	1573	4899339000000
115099	1397	1295755710000
115100	1678	26640839390000
115101	2134	85826777000
115102	1874	25089000
115103	2133	92142926000
115104	1874	25091000
115105	1694	11338916197225
115106	1694	11338928197225
115121	1397	1295725707000
115122	1678	26640839393000
115123	2133	92139920000
115124	1874	25103000
115125	2134	85823768000
115126	1874	25106000
115127	1716	2160045000000
115149	1719	12240477000000
115163	1686	12632077700122
115197	1768	12706663110000
115198	1768	12706675110000
115233	1560	12968767131803
115234	1560	12968779131803
115240	1394	686890923500000
115241	1394	686890934500000
115267	1688	51839779720020
115276	1397	1295575692000
115277	1678	26640839408000
115278	1397	1295565691000
115279	1678	26640839409000
115280	2133	92123888000
115281	1874	25180000
115282	2134	85808723000
115283	1874	25183000
115284	2134	85807720000
115285	1874	25186000
115286	2133	92122886000
115287	1874	25188000
115301	1397	1295535688000
115302	1678	26640839412000
115303	1397	1295525687000
115304	1678	26640839413000
115305	2134	85804711000
114761	1593	10754742000000
114762	1678	25920814338000
114763	1678	25920814339000
114764	1678	25920814340000
114765	1678	25920814341000
114766	1678	25920814342000
114767	1678	25920814343000
114768	1678	25920814344000
114769	1678	25920814345000
114770	1678	25920814346000
114771	1678	25920814347000
114772	1678	25920814348000
114773	1678	25920814349000
114774	1678	25920814350000
114775	1678	25920814351000
114776	1678	25920814352000
114777	1678	25920814353000
114778	1678	25920814354000
114779	1678	25920814355000
114780	1678	25920814356000
114781	1678	25920814357000
114782	1593	11474742000000
114783	1593	11474942000000
114828	2134	85851852000
114829	1874	24964000
114830	1874	24966000
114831	1623	69123136899898
114832	1623	69123258899898
114889	1796	200000004
114890	1422	8154603804269
114891	2069	8154614804269
114892	1422	201000000
114900	1397	1295955730000
114901	1678	26640839370000
114902	2133	92161964000
114903	1874	24993000
114904	2134	85845834000
114905	1874	24996000
114906	1467	19407039100039
114934	1397	1295925727000
114935	1678	26640839373000
114936	2133	92158958000
114937	1874	25008000
114938	2134	85842825000
114939	1874	25011000
114940	1422	8874615804270
114941	1422	8874627804270
114944	1397	1295915726000
114945	1678	26640839374000
114946	2134	85841822000
114947	1874	25014000
114948	2133	92157956000
114949	1874	25016000
114950	1608	8778434000000
114966	1397	1295885723000
114967	1678	26640839377000
114968	2134	85839816000
114969	1874	25026000
114970	2133	92154950000
114971	1874	25028000
114972	1657	5041253990100
114973	1657	5041265990100
114976	1874	24736000
114977	1874	24737000
114978	1874	24740000
114979	1874	24742000
114980	1874	24744000
114981	1874	24752000
114982	1874	24755000
114983	1874	24757000
114984	1874	24759000
114985	1874	24763000
114986	1874	24765000
114987	1874	24771000
114988	1874	24773000
114989	1874	24777000
114990	1874	24781000
114991	1874	24783000
114992	1657	4322145990100
114993	1874	24795000
114994	1874	24797000
114995	1874	24799000
114996	1657	5042145990100
114997	1657	5042152990100
114998	1397	1295875722000
114999	1678	26640839378000
115000	2134	85838813000
115001	1874	25031000
115002	2133	92153948000
115003	1874	25033000
115004	1394	681130792500000
115005	1394	681130804500000
115015	1764	25927435100000
115016	1764	25927447100000
115059	1397	1295805715000
115060	1678	26640839385000
115061	2133	92146934000
115062	1874	25065000
115063	2134	85831792000
115064	1874	25068000
115128	2248	9359509000000
115129	2248	10079509000000
115132	1397	1295715706000
115133	1678	26640839394000
115134	2133	92138918000
115135	1874	25108000
115136	2134	85822765000
115137	1874	25111000
115138	1394	684010828500000
115139	1394	684010840500000
115164	1402	19799800143739
115165	1268	1003915681688
115166	1402	18902767145435
115167	2081	1880807942836
115168	1397	1295685703000
115169	1678	26640839397000
115170	1397	1295675702000
115171	1678	26640839398000
115172	1613	18250029400000
115173	1349	1703417022151650
115174	1613	13531827200000
115175	1223	617341134400000
115176	1613	10654529700000
115177	1103	906728040000000
115178	1613	7777232200000
115179	983	508532350000000
115180	2133	92135912000
115181	1874	25123000
115182	2133	92134910000
115183	1874	25125000
115184	2134	85819756000
115185	1874	25128000
115186	2134	85818753000
115187	1874	25131000
115188	2012	201000000
115189	1394	685450839500000
115190	1394	685450923500000
115209	1705	17120790580140
115210	1705	17120802580140
115213	1397	1295645699000
115214	1678	26640839401000
115215	1397	1295635698000
115216	1678	26640839402000
115217	2133	92131904000
115218	1874	25143000
115219	2133	92130902000
115220	1874	25145000
115221	2134	85815744000
115222	1874	25148000
115223	2134	85814741000
115224	1874	25151000
115225	1687	3728876848312
115242	1522	6523579000000
115243	1397	1295605695000
115244	1678	26640839405000
115245	2134	85812735000
115246	1874	25161000
115247	1402	19622767145435
115248	1402	19622778145435
115253	1397	1295595694000
115254	1678	26640839406000
115255	2134	85811732000
115256	1874	25164000
115257	1874	25166000
115258	2133	92126894000
115259	1874	25168000
115260	1394	686890936500000
115299	2248	10079487000000
115300	2248	10079510000000
115313	1693	9316817092484
115314	1693	9316837092484
115334	1397	1295485683000
115335	1678	26640839417000
115336	2134	85799696000
115337	1874	25214000
115338	1394	688330947500000
115435	1397	1295375672000
115436	1678	26640839428000
115437	2134	85788663000
115438	1874	25247000
115439	1596	4320107000000
115454	1679	25919347653000
115461	1397	1295325667000
115462	1678	26640839433000
115463	2134	85783648000
115204	1874	25139000
115205	2133	92132906000
115206	1874	25141000
115207	1711	12666938000000
115208	1711	12666950000000
115288	1397	1295555690000
115289	1678	26640839410000
115290	1397	1295545689000
115291	1678	26640839411000
115292	2133	92121884000
115293	1874	25190000
115294	2134	85806717000
115295	1874	25193000
115296	2134	85805714000
115297	1874	25196000
115298	1716	2160046000000
115311	2106	1440113000000
115312	2106	1440135000000
115316	1693	9316839092484
115317	1397	1295515686000
115318	1678	26640839414000
115319	2134	85802705000
115320	1874	25205000
115321	1395	58226310686957278
115341	1397	1295475682000
115342	1678	26640839418000
115343	2134	85798693000
115344	1874	25217000
115345	1426	9690332000000
115346	1426	9690343000000
115413	1397	1295425677000
115414	1678	26640839423000
115415	1397	1295415676000
115416	1678	26640839424000
115417	1397	1295405675000
115418	1678	26640839425000
115419	1397	1295395674000
115420	1678	26640839426000
115421	1397	1295385673000
115422	1678	26640839427000
115423	2134	85793678000
115424	1874	25232000
115425	2134	85792675000
115426	1874	25235000
115427	2134	85791672000
115428	1874	25238000
115429	2134	85790669000
115430	1874	25241000
115431	2134	85789666000
115432	1874	25244000
115433	1818	1440101890000
115434	1818	1440156890000
115449	1397	1295345669000
115450	1678	26640839431000
115451	2134	85785654000
115452	1874	25256000
115453	1705	17120801580140
115469	1397	1295315666000
115470	1678	26640839434000
115471	2134	85782645000
115472	1874	25265000
115473	1671	9023968003785
115474	1671	9023979003785
115504	171	73866748696494
115514	2134	85774621000
115515	1874	25289000
115516	1759	24481124999889
115517	1759	24481125999889
115538	2292	719044000000
115572	1395	58227030686957278
115573	1395	58227030697957278
115587	1397	1295115646000
115588	1678	26640839454000
115589	2134	85762585000
115590	1874	25325000
115610	2134	85757570000
115611	1874	25340000
115612	1649	8391523999968
115613	1649	9111523999968
115643	1688	52559778720020
115644	1688	52559824720020
115649	2086	1440355300069
115650	1397	1295035638000
115651	1678	26640839462000
115652	1397	1295025637000
115653	1678	26640839463000
115654	2134	85749546000
115655	1874	25364000
115656	2134	85748543000
115657	1874	25367000
115658	1675	11804272999977
115659	1675	11804294999977
115668	1397	1295005635000
115669	1678	26640839465000
115670	1397	1294995634000
115671	1678	26640839466000
115672	2134	85746537000
115673	1874	25373000
115674	2134	85745534000
115675	1874	25376000
115676	1688	52559800720020
115683	1723	7921681085979
115684	1723	7921692085979
115693	1397	1294965631000
115694	1678	26640839469000
115695	1397	1294955630000
115696	1678	26640839470000
115697	1397	1294945629000
115698	1678	26640839471000
115699	2134	85742525000
115700	1874	25385000
115701	2134	85741522000
115702	1874	25388000
115703	1489	16703587030000
115704	1380	1710262743411650
115705	1489	13947442680000
115706	1254	613748195750000
115707	2134	85740519000
115708	1874	25391000
115709	2307	719035000000
115724	1397	1294915626000
115725	1678	26640839474000
115726	2134	85737510000
115727	1874	25400000
115728	1394	692650980500000
115729	1394	692650991500000
115774	1458	15785330908540
115937	1402	21062788145435
115938	1402	21062800145435
115949	1611	9495721000000
115950	1611	9495732000000
115993	1397	1294665601000
115994	1678	26640839499000
115995	1397	1294655600000
115996	1678	26640839500000
115997	2132	147669682000
115998	1874	25474000
115999	2134	85713438000
116000	1874	25477000
116001	2134	85712435000
116002	1874	25480000
116003	1687	5168877848312
116004	1687	5168900848312
116024	1397	1294615596000
116025	1678	26640839504000
116026	2134	85708423000
116027	1874	25493000
116028	1756	7760837195609
116029	1756	7760848195609
116032	1685	154803647571430
116052	1397	1294565591000
116053	1678	26640839509000
116054	1740	11250764000000
116055	1740	11250774000000
116076	1397	1294525587000
116077	1678	26640839513000
116078	2134	85699396000
116079	1874	25522000
116080	2132	147665678000
116081	1874	25523000
116082	1686	13352076700123
116083	1686	13352088700123
116105	1395	58227750697957278
116106	1395	58227750708957278
116160	1397	1294445579000
116161	1678	26640839521000
116162	2134	85691372000
116163	1874	25561000
116164	2133	92114870000
116165	1874	25563000
116166	1709	5760117000000
116167	1709	5760129000000
116184	1402	21062812145435
116185	1402	21782812145435
116214	1692	66741453619999
116215	1692	66741478619999
116242	1397	1294355570000
116243	1678	26640839530000
116244	2132	147660673000
116245	1874	25603000
116246	2134	85683348000
116247	1874	25606000
116248	2133	92105852000
116249	1874	25608000
116250	2261	7919159000000
115261	2134	85810729000
115262	1874	25171000
115263	2133	92125892000
115264	1874	25173000
115265	43	71760054890000
115266	43	71760056890000
115268	1397	1295585693000
115269	1678	26640839407000
115270	2133	92124890000
115271	1874	25175000
115272	2134	85809726000
115273	1874	25178000
115274	1588	31175684000000
115275	1588	31175696000000
115315	1448	8599838000001
115322	1397	1295505685000
115323	1678	26640839415000
115324	2134	85801702000
115325	1874	25208000
115326	1434	2159120000000
115327	1434	2159131000000
115339	1719	12958570000000
115340	1719	12958581000000
115347	1397	1295465681000
115348	1678	26640839419000
115349	2134	85797690000
115350	1874	25220000
115352	1874	24801000
115353	1874	24805000
115354	1874	24811000
115355	1874	24815000
115356	1874	24817000
115357	1874	24819000
115358	1874	24821000
115359	1874	24825000
115360	1874	24827000
115361	1874	24829000
115362	1874	24835000
115363	1874	24843000
115364	1874	24845000
115365	1874	24847000
115366	1874	24851000
115367	1874	24853000
115368	1874	24856000
115369	1874	24859000
115370	1874	24862000
115371	1874	24874000
115372	1874	24877000
115373	1874	24880000
115374	1874	24883000
115375	1874	24892000
115376	1874	24898000
115377	1874	24907000
115378	1874	24910000
115379	1874	24922000
115380	1874	24925000
115381	1874	24928000
115382	1874	24931000
115383	1874	24937000
115384	1874	24940000
115385	1874	24943000
115386	1874	24949000
115387	1874	24952000
115388	1874	24955000
115389	1874	24958000
115390	1874	24967000
115391	1874	24970000
115392	1657	5042720990100
115393	1874	24973000
115394	1874	24979000
115395	1874	24982000
115396	1874	24985000
115397	1657	5762720990100
115398	1657	5762727990100
115400	1397	1295455680000
115401	1678	26640839420000
115402	1397	1295445679000
115403	1678	26640839421000
115404	1397	1295435678000
115405	1678	26640839422000
115406	2134	85796687000
115407	1874	25223000
115408	2134	85795684000
115409	1874	25226000
115410	2134	85794681000
115411	1874	25229000
115412	1422	8874648804270
115440	1397	1295365671000
115441	1678	26640839429000
115442	1397	1295355670000
115443	1678	26640839430000
115444	2134	85787660000
115445	1874	25250000
115446	2134	85786657000
115447	1874	25253000
115448	1759	23041113999889
115467	1684	17283108819412
115468	1684	17283119819412
115475	1397	1295305665000
115476	1678	26640839435000
115477	2134	85781642000
115478	1874	25268000
115479	1691	7631083300052
115480	1397	1295295664000
115481	1678	26640839436000
115482	1397	1295285663000
115483	1678	26640839437000
115484	1397	1295275662000
115485	1678	26640839438000
115486	2134	85780639000
115487	1874	25271000
115488	2134	85779636000
115489	1874	25274000
115490	2134	85778633000
115491	1874	25277000
115492	1564	6846597000000
115493	1564	6846630000000
115496	1397	1295265661000
115497	1678	26640839439000
115498	2134	85777630000
115499	1874	25280000
115500	1762	6405389994000
115501	1762	6405400994000
115521	1397	1295225657000
115522	1678	26640839443000
115523	1397	1295215656000
115524	1678	26640839444000
115525	1397	1295205655000
115526	1678	26640839445000
115527	2134	85773618000
115528	1874	25292000
115529	2134	85772615000
115530	1874	25295000
115531	2134	85771612000
115532	1874	25298000
115533	2134	85770609000
115534	1874	25301000
115535	1746	1968887000000
115541	1397	1295195654000
115542	1678	26640839446000
115543	2134	85769606000
115544	1874	25304000
115545	1564	7566630000000
115546	1564	7566641000000
115558	1397	1295165651000
115559	1678	26640839449000
115560	1397	1295155650000
115561	1678	26640839450000
115562	2134	85766597000
115563	1874	25313000
115564	2134	85765594000
115565	1874	25316000
115566	1654	13817415999798
115567	1654	13817437999798
115581	576	73997532726897
115583	1397	1295125647000
115584	1678	26640839453000
115585	1533	720000000000
115586	1533	720010000000
115614	2134	85756567000
115615	1874	25343000
115677	1397	1294985633000
115678	1678	26640839467000
115679	2134	85744531000
115680	1874	25379000
115681	1422	9594648804270
115682	1422	9594659804270
115691	1688	53279800720020
115692	1688	53279811720020
115732	1768	13426675110000
115733	1768	13426686110000
115739	1397	1294905625000
115740	1678	26640839475000
115741	1397	1294895624000
115742	1678	26640839476000
115743	1693	10036859092484
115763	2134	85730489000
115764	1874	25421000
115765	2134	85729486000
115766	1874	25424000
115767	1458	15785310908540
115775	1678	25920814358000
115776	1678	25920814359000
115777	1402	79973605373639
115778	1402	77372284968864
115306	1874	25199000
115307	2134	85803708000
115308	1874	25202000
115309	1394	688330936500000
115310	1394	688330958500000
115328	1397	1295495684000
115329	1678	26640839416000
115330	2134	85800699000
115331	1874	25211000
115332	1623	69843147899898
115333	1623	69843158899898
115351	1657	5041264990100
115399	1756	7040837195609
115455	1397	1295335668000
115456	1678	26640839432000
115457	2134	85784651000
115458	1874	25259000
115459	1759	23761113999889
115460	1759	23761124999889
115494	1693	10036837092484
115495	1693	10036870092484
115502	1546	8157375800000
115503	1546	8157386800000
115505	1397	1295255660000
115506	1678	26640839440000
115507	1397	1295245659000
115508	1678	26640839441000
115509	2134	85776627000
115510	1874	25283000
115511	2134	85775624000
115512	1874	25286000
115513	1394	689770969500000
115536	1747	1505943000000
115537	1747	1505987000000
115547	1397	1295185653000
115548	1678	26640839447000
115549	2134	85768603000
115550	1874	25307000
115551	1637	285846886819988
115568	1397	1295145649000
115569	1678	26640839451000
115570	2134	85764591000
115571	1874	25319000
115582	1560	12968778131803
115592	1702	5760523000000
115599	1397	1295095644000
115600	1678	26640839456000
115601	2134	85760579000
115602	1874	25331000
115603	2134	85759576000
115604	1874	25334000
115605	1692	66021453619999
115606	2134	85758573000
115607	1874	25337000
115608	1687	4448876848312
115609	1687	4448877848312
115616	2134	85755564000
115617	1874	25346000
115618	1717	10621174000055
115619	1717	10621175000055
115621	1397	1295085643000
115622	1678	26640839457000
115623	1397	1295075642000
115624	1678	26640839458000
115625	1397	1295065641000
115626	1678	26640839459000
115627	1397	1295055640000
115628	1678	26640839460000
115629	1489	24384531490000
115630	1014	505330831110000
115631	2134	85754561000
115632	1874	25349000
115633	2134	85753558000
115634	1874	25352000
115635	1489	24383826550000
115636	1380	1702582504891650
115637	2134	85752555000
115638	1874	25355000
115639	2134	85751552000
115640	1874	25358000
115641	2112	17806703101924
115642	2112	17806749101924
115645	1397	1295045639000
115646	1678	26640839461000
115647	2134	85750549000
115648	1874	25361000
115662	1397	1295015636000
115663	1678	26640839464000
115664	2134	85747540000
115665	1874	25370000
115666	633	76509470900000
115667	633	76509481900000
115711	1397	1294935628000
115712	1678	26640839472000
115713	1397	1294925627000
115714	1678	26640839473000
115715	1489	9862571430000
115716	1134	909633748050000
115717	1489	7583056040000
115718	1014	507610345500000
115719	2134	85739516000
115720	1874	25394000
115721	2134	85738513000
115722	1874	25397000
115723	1546	8157399800000
115768	1397	1294845619000
115769	1678	26640839481000
115770	1397	1294835618000
115771	1678	26640839482000
115772	1593	11472672000000
115773	1593	11472694000000
115892	1657	6482727990100
115893	1657	6483247990100
115898	1402	20342778145435
115899	1402	20342788145435
115929	1397	1294755610000
115930	1678	26640839490000
115931	2132	147672685000
115932	1874	25444000
115933	2134	85722465000
115934	1874	25447000
115935	1672	7201321000000
115936	1672	7201333000000
115947	1637	286566886819988
115948	1637	286566897819988
115951	1397	1294735608000
115952	1678	26640839492000
115953	1397	1294725607000
115954	1678	26640839493000
115955	1397	1294715606000
115956	1678	26640839494000
115957	1708	4680419500051
115958	2134	85720459000
115959	1874	25453000
115960	2134	85719456000
115961	1874	25456000
115962	2134	85718453000
115963	1874	25459000
115964	2132	147671684000
115965	1874	25460000
115966	1613	9217232200000
115967	1613	9217276200000
115968	1397	1294705605000
115969	1678	26640839495000
115970	2134	85717450000
115971	1874	25463000
115972	1458	15785319908540
115986	1395	58227030710957278
116007	1397	1294645599000
116008	1678	26640839501000
116009	1397	1294635598000
116010	1678	26640839502000
116011	1397	1294625597000
116012	1678	26640839503000
116013	1924	1193000000
116014	2134	85711432000
116015	1874	25483000
116016	2134	85710429000
116017	1874	25486000
116018	2134	85709426000
116019	1874	25489000
116020	2132	147668681000
116021	1874	25490000
116022	646	66720007920000
116023	646	66720042920000
116098	1397	1294515586000
116099	1678	26640839514000
116100	2134	85698393000
116101	1874	25526000
116102	1719	13678581000000
116103	1719	13678592000000
116104	1680	10093319499559
116107	1397	1294505585000
116108	1678	26640839515000
116109	2134	85697390000
116110	1874	25529000
116111	2133	92120882000
116112	1874	25531000
116124	1397	1294485583000
116125	1678	26640839517000
116126	1397	1294475582000
116127	1678	26640839518000
116128	2133	92118878000
116129	1874	25539000
116130	2133	92117876000
115464	1874	25262000
115465	1394	689770947500000
115466	1394	689770958500000
115518	1397	1295235658000
115519	1678	26640839442000
115520	1573	4899338000000
115539	1992	10081019990000
115540	1992	10081063990000
115552	1397	1295175652000
115553	1678	26640839448000
115554	2134	85767600000
115555	1874	25310000
115556	1394	691210969500000
115557	1394	691210980500000
115574	1685	154083625571430
115575	1397	1295135648000
115576	1678	26640839452000
115577	2134	85763588000
115578	1874	25322000
115579	1613	8497232200000
115580	1613	8497243200000
115591	1703	2880862000000
115593	1397	1295105645000
115594	1678	26640839455000
115595	2134	85761582000
115596	1874	25328000
115597	1698	10148859550062
115598	1698	10148870550062
115620	1688	51839778720020
115660	1684	18003119819412
115661	1684	18003141819412
115685	1397	1294975632000
115686	1678	26640839468000
115687	2134	85743528000
115688	1874	25382000
115689	1656	10795450999990
115690	1656	10795461999990
115710	1506	7492725967172
115730	42	71420619000000
115731	42	71420630000000
115734	2134	85736507000
115735	1874	25403000
115736	2134	85735504000
115737	1874	25406000
115738	1693	10036839092484
115744	1397	1294885623000
115745	1678	26640839477000
115746	2134	85734501000
115747	1874	25409000
115748	1679	26639347653000
115749	1679	26639358653000
115750	1397	1294875622000
115751	1678	26640839478000
115752	1397	1294865621000
115753	1678	26640839479000
115754	1397	1294855620000
115755	1678	26640839480000
115756	2134	85733498000
115757	1874	25412000
115758	2134	85732495000
115759	1874	25415000
115760	2134	85731492000
115761	1874	25418000
115762	1602	9216611170000
115890	1690	165605536000000
115891	1690	165605547000000
115900	1397	1294805615000
115901	1678	26640839485000
115902	1397	1294795614000
115903	1678	26640839486000
115904	2134	85727480000
115905	1874	25430000
115906	2134	85726477000
115907	1874	25433000
115908	2132	147684686000
115909	1874	25434000
115910	1619	3600075000000
115913	1397	1294785613000
115914	1678	26640839487000
115915	2134	85725474000
115916	1874	25437000
115917	2132	147673686000
115918	1495	10000000
115919	632	74637575000000
115939	1685	154803636571430
115940	1685	154803648571430
115941	1397	1294745609000
115942	1678	26640839491000
115943	2134	85721462000
115944	1874	25450000
115945	1394	694090991500000
115946	1394	694091002500000
115987	1397	1294675602000
115988	1678	26640839498000
115989	2134	85714441000
115990	1874	25473000
115991	1547	8634755000000
115992	1547	8634766000000
116005	1594	11521709000000
116006	1594	11521732000000
116030	1601	12853841620000
116031	1601	12853852620000
116056	2134	85703408000
116057	1874	25509000
116059	1397	1294555590000
116060	1678	26640839510000
116061	2134	85702405000
116062	1874	25512000
116063	2132	147666679000
116064	1874	25513000
116065	1991	8541319355805
116066	1991	8541331355805
116068	1397	1294545589000
116069	1678	26640839511000
116070	2134	85701402000
116071	1874	25516000
116084	1874	25007000
116085	1489	23664530490000
116086	1489	23663825550000
116087	1489	15983586030000
116088	1489	13227441680000
116089	1489	9142570430000
116090	1489	6863055040000
116091	1874	25009000
116092	1874	25010000
116093	1874	25012000
116094	1874	25013000
116095	1874	25015000
116096	1680	10093308499559
116097	1680	10093468499559
116113	1419	19007043560130
116114	1419	19007055560130
116138	1397	1294465581000
116139	1678	26640839519000
116140	2133	92116874000
116141	1874	25549000
116142	2134	85693378000
116143	1874	25552000
116144	1564	8286641000000
116145	1564	8286653000000
116168	1701	10078278500103
116186	1439	9343701578477
116187	1685	154803671571430
116188	1685	155523671571430
116225	1397	1294375572000
116226	1678	26640839528000
116227	2133	92107856000
116228	1874	25594000
116229	2134	85685354000
116230	1874	25597000
116231	1588	31895696000000
116232	1588	31895708000000
116234	1397	1294365571000
116235	1678	26640839529000
116236	2134	85684351000
116237	1874	25600000
116238	2133	92106854000
116239	1874	25602000
116240	1739	30959840000000
116241	1739	30959852000000
116251	1395	58228470722957278
116252	1395	58228470734957278
116288	1395	58229190734957278
116289	1395	58229190747957278
116308	1397	1294295564000
116309	1678	26640839536000
116310	2133	92099840000
116311	1874	25636000
116312	2132	147658671000
116313	1874	25637000
116314	2134	85677330000
116315	1874	25640000
116317	1397	1294285563000
116318	1678	26640839537000
116319	2133	92098838000
116320	1874	25642000
116321	2112	18526749101924
116322	2112	18526760101924
116344	1397	1294255560000
116345	1678	26640839540000
116346	2132	147657670000
116347	1874	25653000
116348	2134	85674321000
116349	1874	25656000
116350	2133	92095832000
115779	1678	25920814360000
115780	1678	25920814361000
115781	1678	25920814362000
115782	1678	25920814363000
115783	1678	25920814364000
115784	1678	25920814365000
115785	1678	25920814366000
115786	1678	25920814367000
115787	1678	25920814368000
115788	1678	25920814369000
115789	1678	25920814370000
115790	1678	25920814371000
115791	1678	25920814372000
115792	1678	25920814373000
115793	1678	25920814374000
115794	1678	25920814375000
115795	1678	25920814376000
115796	1678	25920814377000
115797	1678	25920814378000
115798	1678	25920814379000
115799	1678	25920814380000
115800	1678	25920814381000
115801	1678	25920814382000
115802	1678	25920814383000
115803	1678	25920814384000
115804	1678	25920814385000
115805	1678	25920814386000
115806	1402	77260256719737
115807	1402	76028047054345
115808	1402	75773822405665
115809	1678	25920814387000
115810	1678	25920814388000
115811	1678	25920814389000
115812	1678	25920814390000
115813	1678	25920814391000
115814	1678	25920814392000
115815	1678	25920814393000
115816	1678	25920814394000
115817	1678	25920814395000
115818	1678	25920814396000
115819	1678	25920814397000
115820	1678	25920814398000
115821	1678	25920814399000
115822	1402	72977453710178
115823	1402	72622921331459
115824	1402	71961953778122
115825	1402	67068336075906
115826	1402	57588669473867
115827	1402	56543374804871
115828	1402	55990448390061
115829	1402	54596267912048
115830	1402	52670583501773
115831	1402	50980047451847
115832	1402	40684352483440
115833	1402	39583299053908
115834	1402	29287604085501
115835	1402	28385132810740
115836	1402	27813140312672
115837	1402	25334539487553
115838	1402	24953207822176
115839	1402	23815108992857
115840	1402	22859734421307
115841	1402	20762455261602
115842	1402	20485788766968
115843	1402	20320864773160
115844	1402	19825136608176
115845	1402	18042447822424
115846	1402	17644018757638
115847	1402	17639752143739
115848	1402	16742719145435
115849	1678	25920814400000
115850	1678	25920814401000
115851	1678	25920814402000
115852	1678	25920814403000
115853	1678	25920814404000
115854	1678	25920814405000
115855	1678	25920814406000
115856	1678	25920814407000
115857	1678	25920814408000
115858	1678	25920814409000
115859	1678	25920814410000
115860	1678	25920814411000
115861	1678	25920814412000
115862	1678	25920814413000
115863	1678	25920814414000
115864	1678	25920814415000
115865	1678	25920814416000
115866	1678	25920814417000
115867	1678	25920814418000
115868	1678	25920814419000
115869	1678	25920814420000
115870	1678	25920814421000
115871	1678	25920814422000
115872	1678	25920814423000
115873	1678	25920814424000
115874	1678	25920814425000
115875	1678	25920814426000
115876	1571	11475991999984
115877	1593	4940555124170
115878	1678	25920814427000
115879	1678	25920814428000
115880	1678	25920814429000
115881	1593	12195991999984
115882	1571	12196021999960
115883	1593	4940555124194
115884	1397	1294825617000
115885	1678	26640839483000
115886	2134	85728483000
115887	1874	25427000
115888	1679	27359358653000
115889	1679	27359369653000
115894	1397	1294815616000
115895	1678	26640839484000
115896	2261	7919146000000
115897	2261	7919156000000
115911	1623	70563158899898
115912	1623	70563181899898
115920	1397	1294775612000
115921	1678	26640839488000
115922	1397	1294765611000
115923	1678	26640839489000
115924	2134	85724471000
115925	1874	25440000
115926	2134	85723468000
115927	1874	25443000
115928	1685	154083636571430
115973	1397	1294695604000
115974	1678	26640839496000
115975	1397	1294685603000
115976	1678	26640839497000
115977	2134	85716447000
115978	1874	25466000
115979	2132	147670683000
115980	1874	25467000
115981	1925	1192000000
115982	2134	85715444000
115983	1874	25470000
115984	1693	10756859092484
115985	1693	10756883092484
116033	1397	1294605595000
116034	1678	26640839505000
116035	2134	85707420000
116036	1874	25496000
116037	1397	1294595594000
116038	1678	26640839506000
116039	1397	1294585593000
116040	1678	26640839507000
116041	1397	1294575592000
116042	1678	26640839508000
116043	2132	147667680000
116044	1874	25497000
116045	2134	85706417000
116046	1874	25500000
116047	2134	85705414000
116048	1874	25503000
116049	2134	85704411000
116050	1874	25506000
116051	1394	694091025500000
116058	1740	11250775000000
116067	1447	15401779683000
116072	1397	1294535588000
116073	1678	26640839512000
116074	2134	85700399000
116075	1874	25519000
116115	1397	1294495584000
116116	1678	26640839516000
116117	2133	92119880000
116118	1874	25533000
116119	2134	85696387000
116120	1874	25536000
116121	2132	147664677000
116122	1874	25537000
116123	1670	7200989000000
116146	1397	1294455580000
116147	1678	26640839520000
116148	2132	147663676000
116149	1874	25553000
116150	2133	92115872000
116151	1874	25555000
116152	2134	85692375000
116153	1874	25558000
116154	1402	21782788145435
116155	1402	21782801145435
116157	1874	24896000
116158	1709	5760395000000
116131	1874	25541000
116132	2134	85695384000
116133	1874	25544000
116134	2134	85694381000
116135	1874	25547000
116136	1394	695531025500000
116137	1394	695531049500000
116156	1764	25927448100000
116169	1397	1294435578000
116170	1678	26640839522000
116171	1397	1294425577000
116172	1678	26640839523000
116173	2132	147662675000
116174	1874	25564000
116175	2133	92113868000
116176	1874	25566000
116177	2133	92112866000
116178	1874	25568000
116179	2134	85690369000
116180	1874	25571000
116181	1439	8623701578477
116182	1520	100000017
116183	1439	9343701578476
116197	1397	1294405575000
116198	1678	26640839525000
116199	1397	1294395574000
116200	1678	26640839526000
116201	2133	92110862000
116202	1874	25578000
116203	2132	147661674000
116204	1874	25579000
116205	2133	92109860000
116206	1874	25581000
116207	2134	85688363000
116208	1874	25584000
116209	2134	85687360000
116210	1874	25587000
116211	1593	12192694000000
116212	1593	12192719000000
116224	1402	21782800145435
116263	1397	1294335568000
116264	1678	26640839532000
116265	2134	85681342000
116266	1874	25616000
116267	2133	92103848000
116268	1874	25618000
116269	1691	8351083300052
116270	1691	8351095300052
116273	1397	1294325567000
116274	1678	26640839533000
116275	2132	147659672000
116276	1874	25619000
116277	2134	85680339000
116278	1874	25622000
116279	2133	92102846000
116280	1874	25624000
116281	1657	5041266990100
116285	2148	5760122880750
116297	1685	156243671571430
116298	1685	156243683571430
116307	1395	58229190746957278
116316	1688	53279813720020
116352	1709	6480507000000
116353	1709	6480513000000
116361	1397	1294235558000
116362	1678	26640839542000
116363	1397	1294225557000
116364	1678	26640839543000
116365	1397	1294215556000
116366	1678	26640839544000
116367	1397	1294205555000
116368	1678	26640839545000
116369	2134	85672315000
116370	1874	25666000
116371	2134	85671312000
116372	1874	25669000
116373	2133	92093828000
116374	1874	25671000
116375	2132	147656669000
116376	1874	25672000
116377	2134	85670309000
116378	1874	25675000
116379	2134	85669306000
116380	1874	25678000
116381	2133	92092826000
116382	1874	25680000
116383	2133	92091824000
116384	1874	25682000
116385	2133	92090822000
116386	1874	25684000
116387	1708	5400419500051
116388	1708	5400468500051
116407	1693	11476883092484
116408	1693	11476908092484
116510	1634	12623097259504
116519	1756	8480898195609
116533	1397	1294045539000
116534	1678	26640839561000
116535	2310	990000000
116536	2134	85653258000
116537	1874	25767000
116538	2133	92074790000
116539	1874	25769000
116540	1693	11476905092484
116564	1508	11720387156616
116565	1508	11720400156616
116571	1637	288006910819988
116572	1637	288006923819988
116573	1397	1294015536000
116574	1678	26640839564000
116575	2133	92071784000
116576	1874	25782000
116577	2134	85650249000
116578	1874	25785000
116579	1670	7920989000000
116580	1670	7921001000000
116610	1764	26647448100000
116611	1764	26647460100000
116650	1594	12241756000000
116651	1397	1293925527000
116652	1678	26640839573000
116653	2133	92062766000
116654	1874	25829000
116655	2134	85641222000
116656	1874	25832000
116657	2132	147647660000
116658	1874	25833000
116659	64	68160030000000
116660	64	68160043000000
116669	1560	13688779131803
116670	1560	13688791131803
116671	1397	1293905525000
116672	1678	26640839575000
116673	1397	1293895524000
116674	1678	26640839576000
116675	2134	85639216000
116676	1874	25841000
116677	1668	6273570000000
116678	2134	85638213000
116679	1874	25844000
116680	2133	92060762000
116681	1874	25846000
116682	2132	147646659000
116683	1874	25847000
116684	2133	92059760000
116685	1874	25849000
116686	1668	6993570000000
116687	1668	6993574000000
116700	1397	1293875522000
116701	1678	26640839578000
116702	2133	92057756000
116703	1874	25856000
116704	2134	85636207000
116705	1874	25859000
116706	1602	9936611170000
116707	1602	9936623170000
116812	1718	6018539519070
116823	1397	1293715506000
116824	1678	26640839594000
116825	1397	1293705505000
116826	1678	26640839595000
116827	2058	533500000
116828	2133	92041724000
116829	1874	25938000
116830	2133	92040722000
116831	1874	25940000
116832	2134	85621162000
116833	1874	25943000
116834	2134	85620159000
116835	1874	25946000
116836	1522	7963639000000
116837	1522	7963665000000
116842	2134	85619156000
116843	1874	25949000
116844	2134	85618153000
116845	1874	25952000
116846	2134	85617150000
116847	1874	25955000
116848	2132	147640653000
116849	1874	25956000
116850	2133	92039720000
116851	1874	25958000
116852	2133	92038718000
116853	1874	25960000
116854	2133	92037716000
116159	1709	5760507000000
116189	1397	1294415576000
116190	1678	26640839524000
116191	2133	92111864000
116192	1874	25573000
116193	2134	85689366000
116194	1874	25576000
116195	576	74717532726897
116196	576	74717544726897
116213	1395	58227750722957278
116216	1397	1294385573000
116217	1678	26640839527000
116218	2133	92108858000
116219	1874	25589000
116220	2134	85686357000
116221	1874	25592000
116222	1471	10745302900000
116223	1471	10745314900000
116233	1688	53279812720020
116253	2261	7919158000000
116254	1397	1294345569000
116255	1678	26640839531000
116256	2134	85682345000
116257	1874	25609000
116258	1874	25611000
116259	2133	92104850000
116260	1874	25613000
116261	1637	287286897819988
116262	1637	287286910819988
116284	484	73293913000000
116290	1397	1294315566000
116291	1678	26640839534000
116292	2134	85679336000
116293	1874	25627000
116294	2133	92101844000
116295	1874	25629000
116296	1394	698411073500000
116299	1397	1294305565000
116300	1678	26640839535000
116301	2134	85678333000
116302	1874	25632000
116303	2133	92100842000
116304	1874	25634000
116305	1701	10798278500103
116306	1701	10798290500103
116323	1397	1294275562000
116324	1678	26640839538000
116325	2134	85676327000
116326	1874	25645000
116327	2133	92097836000
116328	1874	25647000
116329	1601	12853853620000
116334	1397	1294265561000
116335	1678	26640839539000
116336	2134	85675324000
116337	1874	25650000
116338	2133	92096834000
116339	1874	25652000
116340	2106	1440125000000
116342	1419	19727055560130
116343	1419	19727067560130
116360	1271	1349886484000000
116391	1397	1294195554000
116392	1678	26640839546000
116393	1397	1294185553000
116394	1678	26640839547000
116395	2133	92089820000
116396	1874	25686000
116397	2133	92088818000
116398	1874	25688000
116399	2132	147655668000
116400	1874	25689000
116401	2134	85668303000
116402	1874	25692000
116403	2134	85667300000
116404	1874	25695000
116405	1447	16121779683000
116406	1447	16121804683000
116427	1394	698411123500000
116457	1623	70563207899898
116467	1448	9319828000001
116468	1448	9319841000001
116482	1397	1294105545000
116483	1678	26640839555000
116484	1397	1294095544000
116485	1678	26640839556000
116486	1397	1294085543000
116487	1678	26640839557000
116488	1397	1294075542000
116489	1678	26640839558000
116490	2133	92080802000
116491	1874	25734000
116492	2133	92079800000
116493	1874	25736000
116494	2134	85659276000
116495	1874	25739000
116496	2134	85658273000
116497	1874	25742000
116498	2134	85657270000
116499	1874	25745000
116500	2133	92078798000
116501	1874	25747000
116502	2133	92077796000
116503	1874	25749000
116504	2132	147652665000
116505	1874	25750000
116506	2134	85656267000
116507	1874	25753000
116508	1522	7243579000000
116509	1522	7243639000000
116511	1397	1294065541000
116512	1678	26640839559000
116513	2133	92076794000
116514	1874	25755000
116515	2134	85655264000
116516	1874	25758000
116517	1395	58229910747957278
116518	1395	58229910759957278
116529	1476	9360194000000
116530	1476	9360207000000
116543	558	66241140726895
116544	2312	1000000000
116545	1397	1294035538000
116546	1678	26640839562000
116547	2133	92073788000
116548	1874	25771000
116549	2134	85652255000
116550	1874	25774000
116551	1710	9593996664140
116552	1710	9594058664140
116554	1397	1294025537000
116555	1678	26640839563000
116556	2134	85651252000
116557	1874	25777000
116558	2133	92072786000
116559	1874	25779000
116560	2132	147650663000
116561	1874	25780000
116562	1394	699851061500000
116563	1394	699851074500000
116568	1874	25775000
116569	1688	53999813720020
116570	1688	53999824720020
116602	1397	1293985533000
116603	1678	26640839567000
116604	2133	92068778000
116605	1874	25798000
116606	2134	85647240000
116607	1874	25801000
116608	1394	701291073500000
116609	1394	701291085500000
116635	1691	8351120300052
116638	1397	1293945529000
116639	1678	26640839571000
116640	1397	1293935528000
116641	1678	26640839572000
116642	2133	92064770000
116643	1874	25819000
116644	2134	85643228000
116645	1874	25822000
116646	2134	85642225000
116647	1874	25825000
116648	2133	92063768000
116649	1874	25827000
116691	1637	288006944819988
116692	1637	288726944819988
116693	1637	288726948819988
116694	1397	1293885523000
116695	1678	26640839577000
116696	2134	85637210000
116697	1874	25852000
116698	2133	92058758000
116699	1874	25854000
116709	1397	1293865521000
116710	1678	26640839579000
116711	1397	1293855520000
116712	1678	26640839580000
116713	1397	1293845519000
116714	1678	26640839581000
116715	2134	85635204000
116716	1874	25862000
116717	2134	85634201000
116718	1874	25865000
116719	2133	92056754000
116720	1874	25867000
116271	1394	696971049500000
116272	1394	696971061500000
116282	1394	698411061500000
116283	1394	698411074500000
116286	633	77229481900000
116287	633	77229494900000
116330	1874	25326000
116331	1874	25327000
116332	1874	25329000
116333	1448	7879838000001
116341	1448	8599828000001
116389	1685	156963683571430
116390	1685	156963732571430
116469	1397	1294115546000
116470	1678	26640839554000
116471	2134	85660279000
116472	1874	25730000
116473	2133	92081804000
116474	1874	25732000
116475	1690	166325547000000
116476	1690	166325559000000
116477	558	66242190726895
116478	2312	0
116479	1419	19006054560130
116480	2310	1000000000
116481	1756	7760898195609
116531	1611	10215732000000
116532	1611	10215745000000
116541	1700	7434236979053
116542	1700	7434258979053
116553	1692	66741515619999
116566	1419	19726054560130
116567	1419	19726067560130
116582	1397	1294005535000
116583	1678	26640839565000
116584	2134	85649246000
116585	1874	25788000
116586	2133	92070782000
116587	1874	25790000
116589	1397	1293995534000
116590	1678	26640839566000
116591	2134	85648243000
116592	1874	25793000
116593	2132	147649662000
116594	1874	25794000
116595	2133	92069780000
116596	1874	25796000
116597	1467	20127039100039
116598	1467	20127052100039
116601	1688	53999826720020
116612	1397	1293975532000
116613	1678	26640839568000
116614	1397	1293965531000
116615	1678	26640839569000
116616	1397	1293955530000
116617	1678	26640839570000
116618	2132	147648661000
116619	1874	25802000
116620	2134	85646237000
116621	1874	25805000
116622	2134	85645234000
116623	1874	25808000
116624	2133	92067776000
116625	1874	25810000
116626	2133	92066774000
116627	1874	25812000
116628	2133	92065772000
116629	1874	25814000
116630	2134	85644231000
116631	1874	25817000
116632	1768	14146686110000
116633	1768	14146723110000
116661	1397	1293915526000
116662	1678	26640839574000
116663	2133	92061764000
116664	1874	25835000
116665	2134	85640219000
116666	1874	25838000
116688	1668	66720045890000
116689	646	6993570630000
116690	1788	200400000
116708	1623	70563170899898
116729	1573	4899363000000
116748	1397	1293815516000
116749	1678	26640839584000
116750	2134	85631192000
116751	1874	25886000
116752	2133	92051744000
116753	1874	25888000
116840	1594	12961756000000
116841	1594	12961780000000
116857	1397	1293695504000
116858	1678	26640839596000
116859	2134	85616147000
116860	1874	25965000
116861	2133	92036714000
116862	1874	25967000
116863	1850	13656430949999
116876	1506	5040080967172
116877	1397	1293675502000
116878	1678	26640839598000
116879	1397	1293665501000
116880	1678	26640839599000
116881	1397	1293655500000
116882	1678	26640839600000
116883	2134	85614141000
116884	1874	25976000
116885	2134	85613138000
116886	1874	25979000
116887	2132	147638651000
116888	1874	25980000
116889	2133	92034710000
116890	1874	25982000
116891	2133	92033708000
116892	1874	25984000
116893	2133	92032706000
116894	1874	25986000
116895	2134	85612135000
116896	1874	25989000
116897	2292	719047000000
116924	1397	1293625497000
116925	1678	26640839603000
116926	2134	85609126000
116927	1874	26002000
116928	1637	289446959819988
116976	1992	10081031990000
117014	1719	13678593000000
117021	1702	6480523000000
117022	1702	6480534000000
117023	1397	1293495484000
117024	1678	26640839616000
117025	2134	85597090000
117026	1874	26056000
117027	1685	156963694571430
117038	1395	58232070782957278
117039	1395	58232070794957278
117089	1623	71283158899898
117090	1623	71283292899898
117092	1397	1293395474000
117093	1678	26640839626000
117094	2134	85587060000
117095	1874	26089000
117096	1602	10656634170000
117097	1397	1293385473000
117098	1678	26640839627000
117099	2134	85586057000
117100	1874	26092000
117101	2132	147630643000
117102	1874	26093000
117103	1759	25201125999889
117104	1759	25201137999889
117123	1397	1293365471000
117124	1678	26640839629000
117125	1693	13636930092484
117126	1693	13636940092484
117129	1397	1293355470000
117130	1678	26640839630000
117131	2132	147629642000
117132	1874	26097000
117133	2134	85584051000
117134	1874	26100000
117135	1656	11515461999990
117136	1656	11515473999990
117171	1637	290886981819988
117172	1397	1293285463000
117173	1678	26640839637000
117174	2134	85577030000
117175	1874	26122000
117176	2132	147627640000
117177	1874	26123000
117178	1608	10218456000000
117179	1608	10218468000000
117184	1688	55439851720020
117192	1874	26094000
117193	1874	26095000
117194	1874	26098000
117195	1874	26099000
117196	1874	26102000
117197	1874	26105000
117198	1874	26108000
117199	1874	26111000
117200	1874	26114000
117201	1573	5619363000000
117202	1573	5620045000000
117209	1536	12960256000000
116351	1874	25658000
116354	1397	1294245559000
116355	1678	26640839541000
116356	2134	85673318000
116357	1874	25661000
116358	2133	92094830000
116359	1874	25663000
116409	1397	1294175552000
116410	1678	26640839548000
116411	1622	25332983250418
116412	169	66586284844974
116413	1622	22232833685186
116414	990	507245623196952
116415	1622	16677400146274
116416	1110	908979810688432
116417	1622	12929035184936
116418	1230	613306790973693
116419	1622	2483900800048
116420	1356	1709033905247518
116421	2134	85666297000
116422	1874	25698000
116423	2133	92087816000
116424	1874	25700000
116425	1762	7125400994000
116426	1762	7125462994000
116428	1918	3599161000000
116429	1397	1294165551000
116430	1678	26640839549000
116431	1397	1294155550000
116432	1678	26640839550000
116433	1397	1294145549000
116434	1678	26640839551000
116435	1397	1294135548000
116436	1678	26640839552000
116437	2132	147654667000
116438	1874	25701000
116439	2134	85665294000
116440	1874	25704000
116441	2133	92086814000
116442	1874	25706000
116443	2133	92085812000
116444	1874	25708000
116445	2133	92084810000
116446	1874	25710000
116447	2134	85664291000
116448	1874	25713000
116449	2134	85663288000
116450	1874	25716000
116451	2134	85662285000
116452	1874	25719000
116453	2133	92083808000
116454	1874	25721000
116455	2041	2159351000000
116456	2041	2159400000000
116458	1397	1294125547000
116459	1678	26640839553000
116460	2133	92082806000
116461	1874	25723000
116462	2134	85661282000
116463	1874	25726000
116464	2132	147653666000
116465	1874	25727000
116466	2106	1440126000000
116520	1397	1294055540000
116521	1678	26640839560000
116522	2133	92075792000
116523	1874	25760000
116524	2132	147651664000
116525	1874	25761000
116526	2134	85654261000
116527	1874	25764000
116528	1599	8936783097983
116581	1696	13403618335104
116588	1394	699851073500000
116599	1426	10410343000000
116600	1426	10410356000000
116634	1768	14146687110000
116636	1594	12241732000000
116637	1594	12241843000000
116667	1670	8641001000000
116668	1670	8641013000000
116730	1397	1293835518000
116731	1678	26640839582000
116732	1397	1293825517000
116733	1678	26640839583000
116734	2132	147644657000
116735	1874	25873000
116736	2134	85633198000
116737	1874	25876000
116738	2134	85632195000
116739	1874	25879000
116740	2133	92053748000
116741	1874	25881000
116742	2133	92052746000
116743	1874	25883000
116744	1850	13656418949999
116745	1850	13656443949999
116754	1397	1293805515000
116755	1678	26640839585000
116756	1397	1293795514000
116757	1678	26640839586000
116758	2132	147643656000
116759	1874	25889000
116760	2134	85630189000
116761	1874	25892000
116762	2134	85629186000
116763	1874	25895000
116764	2133	92050742000
116765	1874	25897000
116766	2133	92049740000
116767	1874	25899000
116768	1692	67461515619999
116769	1692	67461540619999
116838	1672	7921333000000
116839	1672	7921359000000
116864	1637	289446948819988
116865	1637	289446960819988
116866	1397	1293685503000
116867	1678	26640839597000
116868	2134	85615144000
116869	1874	25970000
116870	2132	147639652000
116871	1874	25971000
116872	2133	92035712000
116873	1874	25973000
116874	1693	12196905092484
116875	1693	12196918092484
116901	1402	21782835145435
116911	1394	702731097500000
116921	1394	702731107500000
116922	1394	704171107500000
116923	1394	704171109500000
116936	1395	58230630759957278
116937	1395	58230630771957278
116946	1397	1293595494000
116947	1678	26640839606000
116948	2134	85607120000
116949	1874	26013000
116950	2133	92027696000
116951	1874	26015000
116952	1394	707051121500000
116953	1394	707051133500000
116969	1397	1293565491000
116970	1678	26640839609000
116971	2134	85604111000
116972	1874	26029000
116973	2133	92024690000
116974	1874	26031000
116975	1706	10362136450256
116991	1536	12240232000000
116992	1536	12240256000000
116997	1746	2688898000000
116999	1634	12623048259504
117006	1397	1293515486000
117007	1678	26640839614000
117008	2132	147634647000
117009	1874	26047000
117010	2134	85599096000
117011	1874	26050000
117012	1693	12916918092484
117013	1693	12916930092484
117030	1397	1293485483000
117031	1678	26640839617000
117032	2134	85596087000
117033	1874	26059000
117034	2132	147633646000
117035	1874	26060000
117036	1690	167045559000000
117037	1690	167045571000000
117051	1451	7824937000000
117052	1046	909797465000000
117053	1397	1293455480000
117054	1678	26640839620000
117055	1397	1293445479000
117056	1678	26640839621000
117057	2134	85593078000
117058	1874	26069000
117059	2134	85592075000
117060	1874	26072000
117061	2132	147632645000
117062	1874	26073000
117063	1762	7845462994000
117064	1762	7845585994000
117071	1451	4958837000000
117072	1166	613858750000000
116721	2133	92055752000
116722	1874	25869000
116723	2132	147645658000
116724	1874	25870000
116725	2133	92054750000
116726	1874	25872000
116727	1394	702731085500000
116728	1394	702731121500000
116746	1458	16505319908540
116747	1458	16505344908540
116770	1397	1293785513000
116771	1678	26640839587000
116772	1397	1293775512000
116773	1678	26640839588000
116774	2133	92048738000
116775	1874	25901000
116776	2134	85628183000
116777	1874	25904000
116778	2134	85627180000
116779	1874	25907000
116780	2133	92047736000
116781	1874	25909000
116782	1422	10314659804270
116783	1422	10314683804270
116784	1397	1293765511000
116785	1678	26640839589000
116786	1397	1293755510000
116787	1678	26640839590000
116788	1397	1293745509000
116789	1678	26640839591000
116790	1397	1293735508000
116791	1678	26640839592000
116792	2134	85626177000
116793	1874	25912000
116794	2134	85625174000
116795	1874	25915000
116796	2133	92046734000
116797	1874	25917000
116798	2134	85624171000
116799	1874	25920000
116800	2134	85623168000
116801	1874	25923000
116802	2132	147642655000
116803	1874	25924000
116804	2133	92045732000
116805	1874	25926000
116806	2133	92044730000
116807	1874	25928000
116808	2133	92043728000
116809	1874	25930000
116810	1541	5042314000000
116811	1541	5042363000000
116813	1397	1293725507000
116814	1678	26640839593000
116815	2132	147641654000
116816	1874	25931000
116817	2133	92042726000
116818	1874	25933000
116819	2134	85622165000
116820	1874	25936000
116821	1688	54719826720020
116822	1688	54719839720020
116898	1746	2688887000000
116899	1746	2688934000000
116902	1705	17120837580140
116903	1397	1293645499000
116904	1678	26640839601000
116905	2133	92031704000
116906	1874	25991000
116907	2134	85611132000
116908	1874	25994000
116909	1671	9743979003785
116910	1671	9743991003785
116912	1397	1293635498000
116913	1678	26640839602000
116914	1608	8778444000000
116915	2133	92030702000
116916	1874	25996000
116917	2134	85610129000
116918	1874	25999000
116919	1608	9498444000000
116920	1608	9498446000000
116938	1397	1293605495000
116939	1678	26640839605000
116940	2134	85608123000
116941	1874	26008000
116942	2133	92028698000
116943	1874	26010000
116944	1394	705611109500000
116945	1394	705611121500000
117000	1397	1293525487000
117001	1678	26640839613000
117002	2134	85600099000
117003	1874	26046000
117004	1395	58231350771957278
117005	1395	58231350782957278
117028	1637	290166959819988
117029	1637	290166970819988
117065	1397	1293435478000
117066	1678	26640839622000
117067	2134	85591072000
117068	1874	26076000
117069	1673	34020742000000
117115	1759	25921137999889
117116	1759	25921248999889
117127	1637	290886970819988
117128	1637	290886980819988
117137	1397	1293345469000
117138	1678	26640839631000
117139	1397	1293335468000
117140	1678	26640839632000
117141	2134	85583048000
117142	1874	26103000
117143	2134	85582045000
117144	1874	26106000
117145	1608	9498434000000
117146	1608	9498456000000
117162	1508	11720421156616
117164	1397	1293295464000
117165	1678	26640839636000
117166	2134	85578033000
117167	1874	26119000
117168	1549	9791336000000
117180	1874	26117000
117181	1874	26120000
117182	1688	55439839720020
117183	1688	55439862720020
117219	171	74586748696494
117220	171	74586760696494
117235	1397	1293215456000
117236	1678	26640839644000
117237	2134	85571012000
117238	1874	26142000
117239	2132	147625638000
117240	1874	26143000
117241	1717	10621186000055
117249	1596	5040107000000
117250	1596	5040118000000
117264	1397	1293185453000
117265	1678	26640839647000
117266	2134	85568003000
117267	1874	26152000
117268	2132	147624637000
117269	1874	26153000
117290	1397	1293145449000
117291	1678	26640839651000
117292	2134	85563991000
117293	1874	26166000
117294	1717	11341186000055
117295	1717	11341197000055
117302	1739	30959851000000
117318	1397	1293095444000
117319	1678	26640839656000
117320	2134	85558976000
117321	1874	26182000
117322	1715	20186898436096
117323	1715	20186909436096
117394	1688	55439850720020
117395	1397	1293015436000
117396	1678	26640839664000
117397	2132	147619632000
117398	1874	26206000
117399	2134	85550952000
117400	1874	26209000
117401	1549	9791337000000
117407	641	76803872000000
117408	641	76803884000000
117432	576	75437544726897
117433	576	75437578726897
117449	1397	1292945429000
117450	1678	26640839671000
117451	2134	85543931000
117452	1874	26232000
117453	1395	58234230826957278
117454	1395	58234230837957278
117469	1395	58234950837957278
117470	1395	58234950848957278
117489	2248	10799510000000
117490	2248	10799532000000
117509	1397	1292855420000
117510	1678	26640839680000
117511	2132	147614627000
117512	1874	26256000
117513	2134	85535907000
117514	1874	26259000
116855	1874	25962000
116856	42	71420626000000
116900	1747	1505990000000
116929	1397	1293615496000
116930	1678	26640839604000
116931	2132	147637650000
116932	1874	26003000
116933	2133	92029700000
116934	1874	26005000
116935	633	77229493900000
116954	1397	1293585493000
116955	1678	26640839607000
116956	1397	1293575492000
116957	1678	26640839608000
116958	2133	92026694000
116959	1874	26017000
116960	2133	92025692000
116961	1874	26019000
116962	2134	85606117000
116963	1874	26022000
116964	2132	147636649000
116965	1874	26023000
116966	2134	85605114000
116967	1874	26026000
116968	1668	6993549000000
116977	1397	1293555490000
116978	1678	26640839610000
116979	1397	1293545489000
116980	1678	26640839611000
116981	2132	147635648000
116982	1874	26032000
116983	2134	85603108000
116984	1874	26035000
116985	2133	92023688000
116986	1874	26037000
116987	2134	85602105000
116988	1874	26040000
116989	1489	8303056040000
116990	1489	8303080040000
116993	1397	1293535488000
116994	1678	26640839612000
116995	2134	85601102000
116996	1874	26043000
116998	1747	1505954000000
117015	1397	1293505485000
117016	1678	26640839615000
117017	2134	85598093000
117018	1874	26053000
117019	1708	6120468500051
117020	1708	6120479500051
117040	1451	12073037000000
117041	1292	1710568637751650
117042	1397	1293475482000
117043	1678	26640839618000
117044	1397	1293465481000
117045	1678	26640839619000
117046	2134	85595084000
117047	1874	26063000
117048	2134	85594081000
117049	1874	26066000
117050	1685	156963805571430
117070	1394	707051132500000
117105	1451	2587737000000
117106	926	507702775000000
117107	1397	1293375472000
117108	1678	26640839628000
117109	2134	85585054000
117110	1874	26096000
117111	1394	708491132500000
117112	1394	708491243500000
117117	1874	26075000
117118	1874	26078000
117119	1874	26081000
117120	1874	26088000
117121	1874	26091000
117122	1476	10080642000000
117147	1397	1293325467000
117148	1678	26640839633000
117149	1397	1293315466000
117150	1678	26640839634000
117151	1397	1293305465000
117152	1678	26640839635000
117153	2132	147628641000
117154	1874	26107000
117155	2134	85581042000
117156	1874	26110000
117157	2134	85580039000
117158	1874	26113000
117159	2134	85579036000
117160	1874	26116000
117161	1684	18003153819412
117169	1439	9343688578477
117185	1397	1293275462000
117186	1678	26640839638000
117187	2134	85576027000
117188	1874	26126000
117189	2261	7919157000000
117221	1397	1293245459000
117222	1678	26640839641000
117223	1397	1293235458000
117224	1678	26640839642000
117225	2134	85573018000
117226	1874	26136000
117227	641	76083851000000
117228	641	76083872000000
117242	1685	157683805571430
117243	1685	157683817571430
117278	1397	1293165451000
117279	1678	26640839649000
117280	2134	85565997000
117281	1874	26159000
117282	1394	709931147500000
117283	1394	709931168500000
117324	1685	157683816571430
117350	1559	8947285999999
117351	1874	25762000
117352	1874	25765000
117353	1874	25772000
117354	1874	25773000
117355	1874	25776000
117356	1874	25778000
117357	1559	9667285999999
117358	1559	9667566999999
117371	1397	1293055440000
117372	1678	26640839660000
117373	1397	1293045439000
117374	1678	26640839661000
117375	1397	1293035438000
117376	1678	26640839662000
117377	2132	147620633000
117378	1874	26193000
117379	2134	85554964000
117380	1874	26196000
117381	2134	85553961000
117382	1874	26199000
117383	2134	85552958000
117384	1874	26202000
117385	1650	7312978000000
117402	1402	22502800145435
117403	1402	22502812145435
117409	1397	1293005435000
117410	1678	26640839665000
117411	2134	85549949000
117412	1874	26212000
117413	1611	4082354241757
117414	1611	4082365241757
117434	1397	1292965431000
117435	1678	26640839669000
117436	2134	85545937000
117437	1874	26225000
117438	1611	4802365241757
117439	1611	4802376241757
117472	1397	1292915426000
117473	1678	26640839674000
117474	2134	85540922000
117475	1874	26241000
117476	2132	147616629000
117477	1874	26242000
117478	1740	11250776000000
117491	1685	157683827571430
117500	632	75357575000000
117501	632	75357587000000
117517	1687	5168889848312
117529	1395	58234950859957278
117534	1700	8154236979053
117535	1700	8154247979053
117577	1397	1292755410000
117578	1678	26640839690000
117579	2132	147611624000
117580	1874	26289000
117581	2134	85525877000
117582	1874	26292000
117583	1710	9594008664140
117585	1476	10080218000000
117592	1394	712811179500000
117593	1394	712811190500000
117608	1397	1292715406000
117609	1678	26640839694000
117610	2134	85521865000
117611	1874	26304000
117612	2132	147610623000
117613	1874	26305000
117614	1693	15076986092484
117620	2039	11419433000000
117638	1397	1292665401000
117073	1397	1293425477000
117074	1678	26640839623000
117075	1397	1293415476000
117076	1678	26640839624000
117077	1397	1293405475000
117078	1678	26640839625000
117079	2134	85590069000
117080	1874	26079000
117081	2134	85589066000
117082	1874	26082000
117083	2134	85588063000
117084	1874	26085000
117085	2132	147631644000
117086	1874	26086000
117087	2112	19246760101924
117088	2112	19246894101924
117091	1602	10656623170000
117113	1476	10080207000000
117114	1476	10080318000000
117163	1419	19726088560130
117170	1395	58232070793957278
117190	1564	9006653000000
117191	1564	9006664000000
117203	1397	1293265461000
117204	1678	26640839639000
117205	2134	85575024000
117206	1874	26129000
117207	1422	11034683804270
117208	1422	11034694804270
117211	1397	1293255460000
117212	1678	26640839640000
117213	2134	85574021000
117214	1874	26132000
117215	2132	147626639000
117216	1874	26133000
117217	1759	26641248999889
117218	1759	26641260999889
117229	1397	1293225457000
117230	1678	26640839643000
117231	2134	85572015000
117232	1874	26139000
117233	1395	58232790793957278
117234	1395	58232790804957278
117270	2134	85567000000
117271	1874	26156000
117272	1690	167765571000000
117273	1690	167765572000000
117296	1397	1293135448000
117297	1678	26640839652000
117298	2134	85562988000
117299	1874	26169000
117300	1768	14866723110000
117301	1768	14866734110000
117303	1397	1293125447000
117304	1678	26640839653000
117305	1397	1293115446000
117306	1678	26640839654000
117307	1397	1293105445000
117308	1678	26640839655000
117309	2132	147622635000
117310	1874	26170000
117311	2134	85561985000
117312	1874	26173000
117313	2134	85560982000
117314	1874	26176000
117315	2134	85559979000
117316	1874	26179000
117317	1671	9744013003785
117359	1397	1293075442000
117360	1678	26640839658000
117361	1397	1293065441000
117362	1678	26640839659000
117363	2134	85556970000
117364	1874	26189000
117365	2134	85555967000
117366	1874	26192000
117367	1394	711371168500000
117368	1394	711371202500000
117386	1397	1293025437000
117387	1678	26640839663000
117388	2134	85551955000
117389	1874	26205000
117390	470	76080298000000
117391	470	76080309000000
117404	1547	8634767000000
117415	1690	168485572000000
117416	1397	1292995434000
117417	1678	26640839666000
117418	1397	1292985433000
117419	1678	26640839667000
117420	1397	1292975432000
117421	1678	26640839668000
117422	2134	85548946000
117423	1874	26215000
117424	2132	147618631000
117425	1874	26216000
117426	2134	85547943000
117427	1874	26219000
117428	2134	85546940000
117429	1874	26222000
117430	1693	14356940092484
117431	1693	14356974092484
117455	1397	1292935428000
117456	1678	26640839672000
117457	2134	85542928000
117458	1874	26235000
117459	1394	711371179500000
117462	1688	55439861720020
117479	1397	1292905425000
117480	1678	26640839675000
117481	1397	1292895424000
117482	1678	26640839676000
117483	2134	85539919000
117484	1874	26245000
117485	2134	85538916000
117486	1874	26248000
117487	1536	13680267000000
117488	1536	13680289000000
117502	1397	1292875422000
117503	1678	26640839678000
117504	1397	1292865421000
117505	1678	26640839679000
117506	2134	85536910000
117507	1874	26255000
117508	1593	12192715000000
117536	1397	1292815416000
117537	1678	26640839684000
117538	2132	147613626000
117539	1874	26269000
117540	2134	85531895000
117541	1874	26272000
117542	1426	10410355000000
117543	1397	1292805415000
117544	1678	26640839685000
117545	1397	1292795414000
117546	1678	26640839686000
117547	1397	1292785413000
117548	1678	26640839687000
117549	2134	85530892000
117550	1874	26275000
117551	2134	85529889000
117552	1874	26278000
117553	2134	85528886000
117554	1874	26281000
117555	2132	147612625000
117556	1874	26282000
117557	1694	12058928197225
117558	1694	12058962197225
117605	1980	21599496000000
117606	1980	21599518000000
117615	1397	1292705405000
117616	1678	26640839695000
117617	2134	85520862000
117618	1874	26308000
117619	1623	70563169899898
117646	1397	1292655400000
117647	1678	26640839700000
117648	1397	1292645399000
117649	1678	26640839701000
117650	2132	147608621000
117651	1874	26322000
117652	2134	85515847000
117653	1874	26325000
117654	2134	85514844000
117655	1874	26328000
117656	1695	6425046999000
117657	1695	6425069999000
117674	1397	1292605395000
117675	1678	26640839705000
117676	1397	1292595394000
117677	1678	26640839706000
117678	2134	85510832000
117679	1874	26341000
117680	2134	85509829000
117681	1874	26344000
117682	1668	7713574000000
117683	1668	7713596000000
117690	2134	85508826000
117691	1874	26348000
117692	1693	15796986092484
117693	1693	15796998092484
117730	1397	1292515386000
117731	1678	26640839714000
117732	2134	85501805000
117733	1874	26370000
117210	1536	12960267000000
117244	1397	1293205455000
117245	1678	26640839645000
117246	2134	85570009000
117247	1874	26146000
117248	1444	8727734329999
117251	1397	1293195454000
117252	1678	26640839646000
117253	2134	85569006000
117254	1874	26149000
117255	1611	8663559824916
117256	975	507693347075084
117257	1611	7172315202966
117258	1095	909782128041950
117259	1611	6166142403568
117260	1215	613848130479398
117261	1611	3362354241757
117262	1341	1710542395913461
117263	1394	708491147500000
117274	1397	1293175452000
117275	1678	26640839648000
117276	1395	58233510804957278
117277	1395	58233510815957278
117284	1397	1293155450000
117285	1678	26640839650000
117286	2132	147623636000
117287	1874	26160000
117288	2134	85564994000
117289	1874	26163000
117325	1559	8946205999999
117326	1397	1293085443000
117327	1678	26640839657000
117328	1874	26135000
117329	1874	26138000
117330	1874	26141000
117331	1874	26144000
117332	1874	26147000
117333	1874	26150000
117334	1874	26162000
117335	1874	26165000
117336	1874	26168000
117337	1874	26171000
117338	1874	26174000
117339	1874	26177000
117340	2134	85557973000
117341	1874	26180000
117342	1874	26181000
117343	1874	26183000
117344	1874	26184000
117345	1874	26185000
117346	2132	147621634000
117347	1874	26186000
117348	1559	9666205999999
117349	1559	9666313999999
117369	1705	17840837580140
117370	1705	17840871580140
117392	1582	720000000000
117393	1582	720011000000
117405	1613	9937276200000
117406	1613	9937288200000
117440	114	66043463685762
117441	2003	2081960654821
117442	1397	1292955430000
117443	1678	26640839670000
117444	2134	85544934000
117445	1874	26228000
117446	2132	147617630000
117447	1874	26229000
117448	1395	58233510826957278
117460	1874	26231000
117461	1688	55439883720020
117463	1397	1292925427000
117464	1678	26640839673000
117465	2134	85541925000
117466	1874	26238000
117467	1717	12061197000055
117468	1717	12061208000055
117471	1740	11251178000000
117492	1397	1292885423000
117493	1678	26640839677000
117494	2134	85537913000
117495	1874	26251000
117496	2132	147615628000
117497	1874	26252000
117498	1447	16841804683000
117499	1447	16841816683000
117518	1397	1292845419000
117519	1678	26640839681000
117520	1397	1292835418000
117521	1678	26640839682000
117522	2134	85534904000
117523	1874	26262000
117524	2134	85533901000
117525	1874	26265000
117526	1451	3307737000000
117527	1451	3307759000000
117559	1601	8800843620000
117560	1388	1715855704351650
117561	1601	6644833620000
117562	1142	912608755600000
117563	1601	5189823620000
117564	1262	615754826200000
117565	1601	3985813620000
117566	1022	509273064000000
117567	1397	1292775412000
117568	1678	26640839688000
117569	1397	1292765411000
117570	1678	26640839689000
117571	2134	85527883000
117572	1874	26285000
117573	2134	85526880000
117574	1874	26288000
117575	1588	32615708000000
117576	1588	32615770000000
117584	1476	10080219000000
117594	1397	1292735408000
117595	1678	26640839692000
117596	1397	1292725407000
117597	1678	26640839693000
117598	2134	85523871000
117599	1874	26298000
117600	2134	85522868000
117601	1874	26301000
117602	1546	9597411800000
117603	1546	9597433800000
117607	1637	290886992819988
117621	1397	1292695404000
117622	1678	26640839696000
117623	1397	1292685403000
117624	1678	26640839697000
117625	2132	147609622000
117626	1874	26309000
117627	2134	85519859000
117628	1874	26312000
117629	2134	85518856000
117630	1874	26315000
117631	2039	11419456000000
117658	1397	1292635398000
117659	1678	26640839702000
117660	1397	1292625397000
117661	1678	26640839703000
117662	2134	85513841000
117663	1874	26331000
117664	2134	85512838000
117665	1874	26334000
117684	42	72140626000000
117685	42	72140648000000
117700	176	66720000000000
117701	176	66720012000000
117709	1397	1292555390000
117710	1678	26640839710000
117711	1397	1292545389000
117712	1678	26640839711000
117713	2134	85505817000
117714	1874	26357000
117715	2134	85504814000
117716	1874	26360000
117717	2132	147605618000
117718	1874	26361000
117719	1690	168485596000000
117721	1397	1292535388000
117722	1678	26640839712000
117723	2134	85503811000
117724	1874	26364000
117725	1610	7920163999950
117738	1601	8080831620000
117739	1601	5924821620000
117740	1601	4469811620000
117741	1601	3265801620000
117742	1654	13819007999798
117743	1654	14539007999798
117744	1654	14539087999798
117751	1397	1292495384000
117752	1678	26640839716000
117753	2134	85499799000
117754	1874	26377000
117755	1394	714251190500000
117756	1394	714251201500000
117777	1602	11376634170000
117778	1602	11376645170000
117792	526	72481145000000
117793	526	73201145000000
117794	526	73201855000000
117811	526	73200279000000
117812	1622	24612971250418
117515	1546	8877399800000
117516	1546	8877411800000
117528	1679	27359380653000
117530	1397	1292825417000
117531	1678	26640839683000
117532	2134	85532898000
117533	1874	26268000
117586	1397	1292745409000
117587	1678	26640839691000
117588	2134	85524874000
117589	1874	26295000
117590	1693	15076974092484
117591	1693	15076985092484
117604	1688	55439859720020
117632	1397	1292675402000
117633	1678	26640839698000
117634	2134	85517853000
117635	1874	26318000
117636	1656	12235473999990
117637	1656	12235484999990
117702	1397	1292565391000
117703	1678	26640839709000
117704	1724	9774701500000
117705	1724	9774711500000
117720	1685	157683829571430
117726	1397	1292525387000
117727	1678	26640839713000
117728	2134	85502808000
117729	1874	26367000
117757	1397	1292485383000
117758	1678	26640839717000
117759	1397	1292475382000
117760	1678	26640839718000
117761	2134	85498796000
117762	1874	26380000
117763	2132	147603616000
117764	1874	26381000
117765	2134	85497793000
117766	1874	26384000
117767	1701	11518290500103
117768	1701	11518313500103
117779	1397	1292455380000
117780	1678	26640839720000
117781	1397	1292445379000
117782	1678	26640839721000
117783	2132	147602615000
117784	1874	26388000
117785	2134	85495787000
117786	1874	26391000
117787	2134	85494784000
117788	1874	26394000
117789	1394	714251213500000
117795	1397	1292435378000
117796	1678	26640839722000
117797	1397	1292425377000
117798	1678	26640839723000
117799	1397	1292415376000
117800	1678	26640839724000
117801	2132	147601614000
117802	1874	26395000
117803	2134	85493781000
117804	1874	26398000
117805	2134	85492778000
117806	1874	26401000
117807	2134	85491775000
117808	1874	26404000
117809	1692	68181540619999
117810	1692	68181574619999
117838	1402	23222812145435
117839	1402	23222823145435
117842	1675	12524294999977
117843	1675	12524305999977
117925	1397	1292335368000
117926	1678	26640839732000
117927	1397	1292325367000
117928	1678	26640839733000
117929	2134	85483751000
117930	1874	26430000
117931	2134	85482748000
117932	1874	26433000
117933	1681	12131329909853
117934	1681	12131351909853
117958	1541	5042347000000
117978	1684	18723153819412
117979	1684	18723175819412
117992	1397	1292235358000
117993	1678	26640839742000
117994	2134	85474724000
117995	1874	26460000
117996	1394	718571258500000
117997	1394	718571269500000
118008	1397	1292215356000
118009	1678	26640839744000
118010	1397	1292205355000
118011	1678	26640839745000
118012	2134	85472718000
118013	1874	26466000
118014	2132	147595608000
118015	1874	26467000
118016	2134	85471715000
118017	1874	26470000
118018	1547	8634778000000
118021	1654	14540257999798
118022	1654	15260257999798
118023	1654	15260337999798
118043	1397	1292165351000
118044	1678	26640839749000
118045	2134	85467703000
118046	1874	26483000
118047	1394	720011269500000
118048	1394	720011280500000
118073	1394	721451280500000
118074	1394	721451302500000
118077	1397	1292115346000
118078	1678	26640839754000
118079	2132	147592605000
118080	1874	26497000
118081	2134	85462688000
118082	1874	26500000
118083	1694	12778962197225
118084	1694	12778974197225
118085	1397	1292105345000
118086	1678	26640839755000
118087	1397	1292095344000
118088	1678	26640839756000
118089	1397	1292085343000
118090	1678	26640839757000
118091	1397	1292075342000
118092	1678	26640839758000
118093	2134	85461685000
118094	1874	26503000
118095	2134	85460682000
118096	1874	26506000
118097	2134	85459679000
118098	1874	26509000
118099	2134	85458676000
118100	1874	26512000
118101	2132	147591604000
118102	1874	26513000
118103	1541	5042359000000
118111	1402	23942823145435
118112	1402	23942834145435
118119	2303	1439000000000
118120	2303	1439012000000
118127	1397	1292035338000
118128	1678	26640839762000
118129	2134	85454664000
118130	1874	26526000
118131	1394	721451291500000
118132	1715	20651063224631
118133	2291	255757211465
118134	1397	1292025337000
118135	1678	26640839763000
118136	1397	1292015336000
118137	1678	26640839764000
118138	1397	1292005335000
118139	1678	26640839765000
118140	2132	147589602000
118141	1874	26527000
118142	2134	85453661000
118143	1874	26530000
118144	2134	85452658000
118145	1874	26533000
118146	2134	85451655000
118147	1874	26536000
118148	1684	18723287819412
118181	1613	9217308200000
118182	1613	9937308200000
118183	1613	9937310200000
118187	1520	9791358999998
118188	1549	100000018
118229	1717	12781208000055
118230	1717	12781242000055
118235	1991	8541330355805
118241	606	72526657286230
118242	606	72526668286230
118252	1394	724331314500000
118253	1394	724331326500000
118295	1394	727211347500000
118296	1394	727211359500000
118441	1693	15797019092484
118442	1693	16517019092484
118443	1693	16517022092484
118464	1489	8303118040000
118485	1549	10511471000000
117639	1678	26640839699000
117640	1419	19006064560130
117641	2134	85516850000
117642	1874	26321000
117643	1419	19726064560130
117644	1419	200003180
117645	1855	19726065559750
117666	1397	1292615396000
117667	1678	26640839704000
117668	2132	147607620000
117669	1874	26335000
117670	2134	85511835000
117671	1874	26338000
117672	1695	7145069999000
117673	1695	7145081999000
117686	1397	1292585393000
117687	1678	26640839707000
117688	2132	147606619000
117689	1874	26345000
117694	1397	1292575392000
117695	1678	26640839708000
117696	2134	85507823000
117697	1874	26351000
117698	1768	15586734110000
117699	1768	15586746110000
117706	2134	85506820000
117707	1874	26354000
117708	1724	9774712500000
117745	1397	1292505385000
117746	1678	26640839715000
117747	2134	85500802000
117748	1874	26374000
117749	1688	56159850720020
117750	1688	56159861720020
117769	1397	1292465381000
117770	1678	26640839719000
117771	2134	85496790000
117772	1874	26387000
117773	1696	14123618335104
117774	1696	14123629335104
117790	1395	58235670848957278
117791	1395	58235670871957278
117828	1397	1292405375000
117829	1678	26640839725000
117830	2134	85490772000
117831	1874	26407000
117832	1679	28079369653000
117833	1679	28079380653000
117844	1675	11805044999977
117845	1675	12525044999977
117846	1675	12525904999977
117888	1395	58235670859957278
117889	1397	1292395374000
117890	1678	26640839726000
117891	1397	1292385373000
117892	1678	26640839727000
117893	2132	147600613000
117894	1874	26408000
117895	2134	85489769000
117896	1874	26411000
117897	2134	85488766000
117898	1874	26414000
117899	1394	715691213500000
117900	1394	715691236500000
117903	1397	1292375372000
117904	1678	26640839728000
117905	2134	85487763000
117906	1874	26417000
117907	1426	11130355000000
117908	1426	11130366000000
117935	1874	26409000
117936	1874	26412000
117937	1874	26415000
117938	1874	26418000
117939	1874	26421000
117940	1681	12131430909853
117942	132	66001000000000
117943	1688	56878861720020
117998	1690	168485583000000
118000	1397	1292225357000
118001	1678	26640839743000
118002	2134	85473721000
118003	1874	26463000
118004	1715	20906909436096
118005	1715	20906920436096
118019	1654	15257449999798
118020	1654	15257472999798
118037	1397	1292175352000
118038	1678	26640839748000
118039	1594	12961766000000
118104	1718	6738584519070
118149	1397	1291995334000
118150	1678	26640839766000
118151	1397	1291985333000
118152	1678	26640839767000
118153	2134	85450652000
118154	1874	26539000
118155	2134	85449649000
118156	1874	26542000
118157	2132	147588601000
118158	1874	26543000
118159	1394	722891291500000
118160	1394	722891314500000
118184	2306	719043000000
118185	2306	1439043000000
118186	2306	1439045000000
118211	1397	1291905325000
118212	1678	26640839775000
118213	1397	1291895324000
118214	1678	26640839776000
118215	1397	1291885323000
118216	1678	26640839777000
118217	2134	85442628000
118218	1874	26566000
118219	2132	147585598000
118220	1874	26567000
118221	2134	85441625000
118222	1874	26570000
118223	2134	85440622000
118224	1874	26573000
118225	2148	6480122880750
118226	2148	6480156880750
118243	2148	6480123880750
118270	1397	1291825317000
118271	1678	26640839783000
118272	1397	1291815316000
118273	1678	26640839784000
118274	2133	92022686000
118275	1874	26591000
118276	2132	147583596000
118277	1874	26592000
118278	2134	85434604000
118279	1874	26595000
118280	2134	85433601000
118281	1874	26598000
118282	2133	92021684000
118283	1874	26600000
118284	1402	26102878145435
118285	1402	26102903145435
118299	2039	12139456000000
118300	2039	12139468000000
118311	1637	291606992819988
118312	1637	291607004819988
118359	1397	1291725307000
118360	1678	26640839793000
118361	2133	92012666000
118362	1874	26644000
118363	2134	85424574000
118364	1874	26647000
118365	2086	2160355300069
118366	2086	2160367300069
118373	1685	159123841571430
118374	1685	159123853571430
118385	1715	20395206013166
118386	2288	776757211465
118387	1397	1291705305000
118388	1678	26640839795000
118389	1397	1291695304000
118390	1678	26640839796000
118391	2134	85422568000
118392	1874	26656000
118393	2133	92010662000
118394	1874	26658000
118395	2133	92009660000
118396	1874	26660000
118397	2133	92008658000
118398	1874	26662000
118399	2132	147579592000
118400	1874	26663000
118401	2134	85421565000
118402	1874	26666000
118403	2134	85420562000
118404	1874	26669000
118405	1723	8641693085979
118406	1723	8641820085979
118414	1702	6480535000000
118417	1715	20139348801701
118418	50	66779714905251
118419	1397	1291675302000
118420	1678	26640839798000
118421	1397	1291665301000
118422	1678	26640839799000
118423	2134	85418556000
118424	1874	26677000
118425	2133	92006654000
117734	2132	147604617000
117735	1874	26371000
117736	1654	14537437999798
117737	1654	14537449999798
117775	1668	9153596000000
117776	1668	9153607000000
117834	1657	5761265990100
117835	1657	5761276990100
117840	1615	1440031000000
117909	1397	1292365371000
117910	1678	26640839729000
117911	2134	85486760000
117912	1874	26420000
117944	1397	1292315366000
117945	1678	26640839734000
117946	1397	1292305365000
117947	1678	26640839735000
117948	1397	1292295364000
117949	1678	26640839736000
117950	2132	147598611000
117951	1874	26434000
117952	2134	85481745000
117953	1874	26437000
117954	2134	85480742000
117955	1874	26440000
117956	1718	6738539519070
117957	1718	6738572519070
117959	1397	1292285363000
117960	1678	26640839737000
117961	2132	147597610000
117962	1874	26435000
117963	1874	26438000
117964	1874	26441000
117965	2134	85479739000
117966	1874	26444000
117967	1719	13678626000000
117981	1397	1292255360000
117982	1678	26640839740000
117983	1397	1292245359000
117984	1678	26640839741000
117985	2134	85476730000
117986	1874	26453000
117987	2134	85475727000
117988	1874	26456000
117989	2132	147596609000
117990	1874	26457000
117991	1693	15797009092484
118006	1685	158403829571430
118007	1685	158403840571430
118024	1397	1292195354000
118025	1678	26640839746000
118026	2134	85470712000
118027	1874	26473000
118028	1701	12238313500103
118029	1701	12238324500103
118040	2134	85468706000
118041	1874	26480000
118042	1594	12961767000000
118049	1397	1292155350000
118050	1678	26640839750000
118051	2132	147593606000
118052	1874	26484000
118053	2134	85466700000
118054	1874	26487000
118055	1685	158403841571430
118062	1397	1292135348000
118063	1678	26640839752000
118064	1397	1292125347000
118065	1678	26640839753000
118066	2134	85464694000
118067	1874	26493000
118068	2134	85463691000
118069	1874	26496000
118070	1698	10868870550062
118071	1698	10868892550062
118075	1395	58236390860957278
118076	1395	58236390882957278
118121	1397	1292045339000
118122	1678	26640839761000
118123	2134	85455667000
118124	1874	26523000
118125	1402	24662834145435
118126	1402	24662845145435
118161	1397	1291975332000
118162	1678	26640839768000
118163	1397	1291965331000
118164	1678	26640839769000
118165	1397	1291955330000
118166	1678	26640839770000
118167	2134	85448646000
118168	1874	26546000
118169	2132	147587600000
118170	1874	26547000
118171	1549	9071357000000
118172	2134	85447643000
118173	1874	26550000
118174	2134	85446640000
118175	1874	26553000
118176	1549	9791357000000
118177	1549	9791359000000
118227	1426	11850366000000
118228	1426	11850400000000
118231	1397	1291875322000
118232	1678	26640839778000
118233	2134	85439619000
118234	1874	26576000
118236	1397	1291865321000
118237	1678	26640839779000
118238	2134	85438616000
118239	1874	26579000
118240	2148	6480133880750
118254	1397	1291845319000
118255	1678	26640839781000
118256	1588	31681760000000
118257	2068	935000000000
118258	2134	85436610000
118259	1874	26586000
118260	1394	725771326500000
118261	1394	725771347500000
118264	1397	1291835318000
118265	1678	26640839782000
118266	2134	85435607000
118267	1874	26589000
118268	1693	16517009092484
118269	1693	16517020092484
118286	1397	1291805315000
118287	1678	26640839785000
118288	2134	85432598000
118289	1874	26603000
118290	2133	92020682000
118291	1874	26605000
118292	1695	7865081999000
118293	1695	7865093999000
118303	1397	1291795314000
118304	1678	26640839786000
118305	2133	92019680000
118306	1874	26607000
118307	2134	85431595000
118308	1874	26610000
118314	1397	1291785313000
118315	1678	26640839787000
118316	1397	1291775312000
118317	1678	26640839788000
118318	1397	1291765311000
118319	1678	26640839789000
118320	1397	1291755310000
118321	1678	26640839790000
118322	1397	1291745309000
118323	1678	26640839791000
118324	2134	85430592000
118325	1874	26613000
118326	2132	147582595000
118327	1874	26614000
118328	2132	147581594000
118329	1874	26615000
118330	2134	85429589000
118331	1874	26618000
118332	2134	85428586000
118333	1874	26621000
118334	2134	85427583000
118335	1874	26624000
118336	2134	85426580000
118337	1874	26627000
118338	2133	92018678000
118339	1874	26629000
118340	2133	92017676000
118341	1874	26631000
118342	2133	92016674000
118343	1874	26633000
118344	2133	92015672000
118345	1874	26635000
118346	2133	92014670000
118347	1874	26637000
118348	576	75437606726897
118351	1397	1291735308000
118352	1678	26640839792000
118353	2134	85425577000
118354	1874	26640000
118355	2133	92013668000
118356	1874	26642000
118367	1715	19211041224631
118368	1588	30961698000000
118369	1740	11971178000000
118370	1740	11971328000000
118463	1688	57598923720020
117813	1622	21512821685186
117814	1622	15957388146274
117815	1622	12209023184936
117816	1622	1763888800048
117817	1419	17566030560130
117818	1611	7223536824916
117819	1611	5732292202966
117820	1611	4726119403568
117821	1611	1922331241757
117822	1874	24909000
117823	1874	24912000
117824	1874	24914000
117825	1874	24915000
117826	1709	6481097000000
117827	1709	7201097000000
117836	1458	17225344908540
117837	1458	17225355908540
117841	1709	5760128000000
117847	1874	26233000
117848	1874	26234000
117849	1874	26236000
117850	1874	26239000
117851	1874	26249000
117852	1874	26250000
117853	1874	26253000
117854	1874	26254000
117855	1874	26257000
117856	1874	26258000
117857	1874	26260000
117858	1874	26263000
117859	1874	26266000
117860	1874	26284000
117861	1874	26287000
117862	1874	26290000
117863	1874	26293000
117864	1874	26296000
117865	1874	26299000
117866	1874	26302000
117867	1874	26311000
117868	1874	26314000
117869	1874	26317000
117870	1874	26320000
117871	1874	26323000
117872	1874	26326000
117873	1874	26329000
117874	1874	26332000
117875	1874	26347000
117876	1874	26350000
117877	1874	26353000
117878	1874	26356000
117879	1874	26359000
117880	1874	26362000
117881	1874	26365000
117882	1874	26368000
117883	1874	26383000
117884	1874	26386000
117885	1874	26389000
117886	1874	26392000
117887	1458	17225513908540
117901	1791	3210000072
117902	1426	11129342999976
117913	1397	1292355370000
117914	1678	26640839730000
117915	1397	1292345369000
117916	1678	26640839731000
117917	2134	85485757000
117918	1874	26423000
117919	2132	147599612000
117920	1874	26424000
117921	2134	85484754000
117922	1874	26427000
117923	1444	9447734329999
117924	1444	9447757329999
117941	1706	11082136450256
117968	1397	1292275362000
117969	1678	26640839738000
117970	1397	1292265361000
117971	1678	26640839739000
117972	2134	85478736000
117973	1874	26447000
117974	2134	85477733000
117975	1874	26450000
117976	1394	717131236500000
117977	1394	717131258500000
117980	1571	7820616124154
117999	1692	68181551619999
118030	1397	1292185353000
118031	1678	26640839747000
118032	2132	147594607000
118033	1874	26474000
118034	2134	85469709000
118035	1874	26477000
118036	1395	58235670860957278
118056	1397	1292145349000
118057	1678	26640839751000
118058	2134	85465697000
118059	1874	26490000
118060	1588	33335770000000
118061	1588	33335781000000
118072	1679	28079391653000
118105	1397	1292065341000
118106	1678	26640839759000
118107	2134	85457673000
118108	1874	26516000
118109	1688	57598861720020
118110	1688	57598872720020
118113	1397	1292055340000
118114	1678	26640839760000
118115	2132	147590603000
118116	1874	26517000
118117	2134	85456670000
118118	1874	26520000
118178	1440	5760261045924
118179	1440	6480261045924
118180	1440	6480263045924
118189	1397	1291945329000
118190	1678	26640839771000
118191	2134	85445637000
118192	1874	26556000
118193	1668	8433596000000
118194	1668	8433607000000
118195	1397	1291935328000
118196	1678	26640839772000
118197	1397	1291925327000
118198	1678	26640839773000
118199	1397	1291915326000
118200	1678	26640839774000
118201	2134	85444634000
118202	1874	26559000
118203	2134	85443631000
118204	1874	26562000
118205	2132	147586599000
118206	1874	26563000
118207	1402	25382845145435
118208	1402	25382878145435
118209	1501	398117200000
118210	1426	11451342999976
118244	1397	1291855320000
118245	1678	26640839780000
118246	2134	85437613000
118247	1874	26582000
118248	2132	147584597000
118249	1874	26583000
118250	1691	9071095300052
118251	1691	9071107300052
118262	1764	27367460100000
118263	1764	27367481100000
118294	1723	7921693085979
118297	606	73246668286230
118298	606	73246680286230
118301	1705	18560871580140
118302	1705	18560883580140
118309	1587	9360324000000
118310	1587	9360336000000
118313	1560	13688781131803
118349	1402	26822903145435
118350	1402	26822965145435
118357	1706	11802136450256
118358	1706	11802148450256
118371	1740	11970776000000
118372	1740	11970788000000
118375	1397	1291715306000
118376	1678	26640839794000
118377	2133	92011664000
118378	1874	26649000
118379	2134	85423571000
118380	1874	26652000
118381	2132	147580593000
118382	1874	26653000
118383	1555	9605929540449
118384	1555	9605942540449
118407	1397	1291685303000
118408	1678	26640839797000
118409	2134	85419559000
118410	1874	26672000
118411	2133	92007656000
118412	1874	26674000
118413	1688	57598873720020
118415	1703	3600862000000
118416	1703	3600874000000
118430	1397	1291655300000
118431	1678	26640839800000
118432	1649	9111533999968
118433	2133	92004650000
118434	1874	26683000
118426	1874	26679000
118427	2133	92005652000
118428	1874	26681000
118429	2039	12139579000000
118446	1467	17088711371984
118447	1010	508715470792656
118448	1467	12934295866644
118449	1130	911613764986289
118450	1397	1291645299000
118451	1678	26640839801000
118452	1467	10131225689819
118453	1250	615083972423684
118454	1467	2320239272869
118455	1376	1713986179376152
118456	1467	2320229272869
118457	2134	85416550000
118458	1874	26690000
118459	2133	92003648000
118460	1874	26692000
118461	1549	10511359000000
118462	1549	10511421000000
118465	2067	1402590000
118466	1489	8303053450000
118467	1489	66000009999990
118468	417	8303105450010
118469	1715	18955184013166
118470	1715	18699326801701
118471	1489	7584336040000
118472	1489	8304336040000
118473	1489	8304936040000
118513	1637	292327004819988
118514	1637	292327116819988
118515	1715	12736867349966
118516	1246	614721890239616
118517	1715	6503518663945
118518	1372	1712977205175714
118519	1397	1291605295000
118520	1678	26640839805000
118521	1397	1291595294000
118522	1678	26640839806000
118523	2133	91999640000
118524	1874	26710000
118525	2133	91998638000
118526	1874	26712000
118527	2134	85412538000
118528	1874	26715000
118529	2134	85411535000
118530	1874	26718000
118531	2132	147576589000
118532	1874	26719000
118533	1723	9361820085979
118534	1723	9362045085979
118542	1508	11720399156616
118572	2133	91993628000
118573	1874	26742000
118574	1715	7223518663945
118575	1715	7223519663945
118697	1397	1291405275000
118698	1678	26640839825000
118699	2133	91979600000
118700	1874	26813000
118701	2134	85393481000
118702	1874	26816000
118703	1395	58239270936957278
118704	1395	58239270948957278
118705	1397	1291395274000
118706	1678	26640839826000
118707	1397	1291385273000
118708	1678	26640839827000
118709	1397	1291375272000
118710	1678	26640839828000
118711	2132	147570583000
118712	1874	26817000
118713	2133	91978598000
118714	1874	26819000
118715	2133	91977596000
118716	1874	26821000
118717	2133	91976594000
118718	1874	26823000
118719	2134	85392478000
118720	1874	26826000
118721	2134	85391475000
118722	1874	26829000
118723	2134	85390472000
118724	1874	26832000
118725	606	73246705286230
118740	1397	1291355270000
118741	1678	26640839830000
118742	2133	91974590000
118743	1874	26839000
118744	2132	147569582000
118745	1874	26840000
118746	2134	85388466000
118747	1874	26843000
118776	1395	58240710972957278
118777	1395	58240711004957278
118782	1397	1291315266000
118783	1678	26640839834000
118784	1693	15436995979531
118785	1811	2128932225014
118786	1693	15361485337310
118787	283	66122729734615
118788	1693	15285652575333
118789	308	66778181541448
118790	1693	15209819813356
118791	186	66778181541448
118792	1693	15133987051379
118793	392	66778181541448
118794	2133	91970582000
118795	1874	26858000
118796	2134	85385457000
118797	1874	26861000
118798	1685	159843915571430
118869	1394	731531524500000
118870	1394	731531731500000
118931	1395	58239991032957278
118932	1395	58240711032957278
118933	1395	58240711034957278
119012	1679	28799391653000
119013	1679	28799453653000
119154	1271	1350606484000000
119155	1693	5030810319126
119156	1961	777093716675
119157	1397	1291095244000
119158	1678	26640839856000
119159	1693	4954977557149
119160	658	66778181541448
119161	1693	4879466217123
119162	240	66123340864401
119163	2133	91949540000
119164	1874	26969000
119165	2134	85364394000
119166	1874	26972000
119167	2132	147561574000
119168	1874	26973000
119169	1685	161283950571430
119170	1685	161283993571430
119190	1395	58240711014957278
119191	1395	58241431014957278
119192	1395	58241431036957278
119194	1693	4425437458477
119195	2308	119490184646
119196	1397	1291075242000
119197	1678	26640839858000
119198	1693	4349604696500
119199	653	66778181541448
119200	1693	4273771934523
119201	217	66778181541448
119202	1693	4197939172546
119203	103	66778181541448
119204	2134	85362388000
119205	1874	26981000
119206	2133	91947536000
119207	1874	26983000
119208	1695	8585093999000
119209	1695	8585155999000
119211	1397	1291065241000
119212	1678	26640839859000
119213	1693	3845441885027
119214	893	310440551901528
119215	1693	3769609123050
119216	54	66778181541448
119217	1693	3694098928113
119218	530	66700896958253
119219	1693	3617764053785
119220	603	66844584212192
119221	2133	91946534000
119222	1874	26985000
119223	2134	85361385000
119224	1874	26988000
119225	1394	735851898500000
119226	1394	735851950500000
119287	1471	12185327900000
119288	1471	12185389900000
119307	1564	9726664000000
119308	1564	9726717000000
119365	1696	14843691335104
119366	1696	14843704335104
119378	1397	1290935228000
119379	1678	26640839872000
119380	1397	1290925227000
119381	1678	26640839873000
119382	2132	147556569000
119383	1874	27050000
119384	2133	91933508000
118435	2132	147578591000
118436	1874	26684000
118437	2134	85417553000
118438	1874	26687000
118439	1649	9831533999968
118440	1649	9831536999968
118444	1571	9831536999960
118445	1649	7100616124162
118484	1394	727211459500000
118486	1397	1291625297000
118487	1678	26640839803000
118488	2134	85414544000
118489	1874	26700000
118490	2132	147577590000
118491	1874	26701000
118492	2133	92001644000
118493	1874	26703000
118494	2106	2160126000000
118495	2106	2160139000000
118498	1708	6120481500051
118509	1506	5760080967172
118510	1506	5760192967172
118535	1397	1291585293000
118536	1678	26640839807000
118537	2133	91997636000
118538	1874	26721000
118539	2134	85410532000
118540	1874	26724000
118541	484	73293912000000
118551	1394	728651471500000
118558	1397	1291555290000
118559	1678	26640839810000
118560	2134	85407523000
118561	1874	26737000
118562	2132	147575588000
118563	1874	26738000
118564	2133	91994630000
118565	1874	26740000
118570	1474	7910475000043
118571	1474	7910488000043
118588	1395	58236390872957278
118631	1397	1291475282000
118632	1678	26640839818000
118633	2134	85400502000
118634	1874	26777000
118635	2133	91986614000
118636	1874	26779000
118637	1673	12361978000000
118638	1242	614993850000000
118639	1656	12955484999990
118640	1656	12955497999990
118643	1397	1291465281000
118644	1678	26640839819000
118645	2133	91985612000
118646	1874	26781000
118647	2134	85399499000
118648	1874	26784000
118694	1692	67461572619999
118695	1692	68181572619999
118696	1692	68181578619999
118728	1397	1291365271000
118729	1678	26640839829000
118730	2134	85389469000
118731	1874	26835000
118732	2133	91975592000
118733	1874	26837000
118734	1673	8855435000000
118735	756	1012990000000
118736	1602	11376647170000
118739	1759	26641261999889
118780	2248	10799542000000
118799	1397	1291305265000
118800	1678	26640839835000
118801	1693	15058476409158
118802	301	66132720734615
118803	1693	14982643647181
118804	339	66778181541448
118805	1693	14906810885204
118806	601	66778181541448
118807	1693	14830595305742
118808	1821	776898579462
118809	2134	85384454000
118810	1874	26864000
118811	2133	91969580000
118812	1874	26866000
118813	1394	730091524500000
118814	1693	14754762543765
118815	408	66778181541448
118816	1397	1291295264000
118817	1678	26640839836000
118818	1397	1291285263000
118819	1678	26640839837000
118820	1397	1291275262000
118821	1678	26640839838000
118822	1693	14678929781788
118823	322	66778181541448
118824	1693	14641674230206
118825	10	32619292617398
118826	1693	14565841468229
118827	450	66778181541448
118828	1693	14490331386537
118829	366	66122238827087
118830	1693	14414498624560
118831	587	66778181541448
118832	1693	14338665862583
118833	500	66778181541448
118834	1693	14262833100606
118835	611	66778181541448
118836	1693	14187000338629
118837	146	66778181541448
118838	1693	14111487122540
118839	114	66118966901851
118840	1693	14035976596999
118841	443	66122627545707
118842	1693	13960143835022
118843	138	66778181541448
118844	1693	13884311073045
118845	205	66778181541448
118846	1693	13808800888399
118847	578	66122328993781
118848	1693	13733290703753
118849	649	66122328993781
118850	1693	13657457941776
118851	504	66165111541448
118852	1693	11710661097788
118853	1276	1713954133592462
118854	2132	147567580000
118855	1874	26867000
118856	2133	91968578000
118857	1874	26869000
118858	2133	91967576000
118859	1874	26871000
118860	2133	91966574000
118861	1874	26873000
118862	2134	85383451000
118863	1874	26876000
118864	2134	85382448000
118865	1874	26879000
118866	2134	85381445000
118867	1874	26882000
118868	1457	11520405800000
118872	1716	2160230000000
118873	1693	11634828335811
118874	194	66778181541448
118875	1693	11558995573834
118876	399	66778181541448
118877	1397	1291265261000
118878	1678	26640839839000
118879	1693	11483485492142
118880	636	66122238827087
118881	1693	11481177832698
118882	721	2023581258730
118883	2133	91965572000
118884	1874	26884000
118885	2134	85380442000
118886	1874	26887000
118887	1419	20446065559750
118888	1419	20446117559750
118929	1444	10167757329999
118930	1444	10167769329999
118934	1693	9214090375323
118935	1772	5574212177275
118936	1693	9138577559614
118937	354	66124633253615
118938	1397	1291235258000
118939	1678	26640839842000
118940	1693	9062744797637
118941	570	66778181541448
118942	1693	8710247510118
118943	894	310440551901528
118944	2134	85377433000
118945	1874	26901000
118946	2133	91962566000
118947	1874	26903000
118948	411	66726400000000
118949	411	66726452000000
118952	1693	8634414748141
118953	569	66778181541448
118954	1397	1291225257000
118955	1678	26640839843000
118956	1693	8558581986164
118957	390	66778181541448
118958	1693	8483070646138
118959	342	66123340864401
118960	1693	8480762986694
118474	1715	18289204689316
118475	1006	508416004675840
118476	1397	1291635298000
118477	1678	26640839802000
118478	2133	92002646000
118479	1874	26694000
118480	2134	85415547000
118481	1874	26697000
118482	1688	58318923720020
118483	1688	58319035720020
118496	1394	728651459500000
118497	1394	728651472500000
118499	1715	14973841491090
118500	1126	911077124270784
118501	1397	1291615296000
118502	1678	26640839804000
118503	2133	92000642000
118504	1874	26705000
118505	2134	85413541000
118506	1874	26708000
118507	2112	19966894101924
118508	2112	19967006101924
118543	1397	1291575292000
118544	1678	26640839808000
118545	2134	85409529000
118546	1874	26727000
118547	2133	91996634000
118548	1874	26729000
118549	1599	9656782097983
118550	1599	9656794097983
118552	1397	1291565291000
118553	1678	26640839809000
118554	2133	91995632000
118555	1874	26731000
118556	2134	85408526000
118557	1874	26734000
118568	2313	719000000000
118569	2313	719013000000
118576	1397	1291545289000
118577	1678	26640839811000
118578	1622	3203900800048
118579	1622	3203911800048
118580	1397	1291535288000
118581	1678	26640839812000
118582	2134	85406520000
118583	1874	26745000
118584	2133	91992626000
118585	1874	26747000
118586	171	75306760696494
118587	171	75306772696494
118589	1397	1291525287000
118590	1678	26640839813000
118591	2132	147574587000
118592	1874	26748000
118593	2134	85405517000
118594	1874	26751000
118595	2133	91991624000
118596	1874	26753000
118597	1711	12666951000000
118600	1397	1291515286000
118601	1678	26640839814000
118602	1397	1291505285000
118603	1678	26640839815000
118604	1397	1291495284000
118605	1678	26640839816000
118606	1673	22226300000000
118607	1368	1713735727751650
118608	2132	147573586000
118609	1874	26754000
118610	1673	16336169000000
118611	1122	911480185000000
118612	2134	85404514000
118613	1874	26757000
118614	2134	85403511000
118615	1874	26760000
118616	2134	85402508000
118617	1874	26763000
118618	2133	91990622000
118619	1874	26765000
118620	2133	91989620000
118621	1874	26767000
118622	2133	91988618000
118623	1874	26769000
118624	1668	9153646000000
118625	1397	1291485283000
118626	1678	26640839817000
118627	2134	85401505000
118628	1874	26772000
118629	2133	91987616000
118630	1874	26774000
118661	1397	1291445279000
118662	1678	26640839821000
118663	2134	85397493000
118664	1874	26793000
118665	2133	91983608000
118666	1874	26795000
118667	1395	58237830886957278
118668	1395	58237830898957278
118669	1397	1291435278000
118670	1678	26640839822000
118671	1397	1291425277000
118672	1678	26640839823000
118673	1397	1291415276000
118674	1678	26640839824000
118675	2132	147571584000
118676	1874	26796000
118677	1673	8861976000000
118678	23	32937710000000
118679	1395	58237830930957278
118680	2134	85396490000
118681	1874	26799000
118682	2134	85395487000
118683	1874	26802000
118684	2134	85394484000
118685	1874	26805000
118686	2133	91982606000
118687	1874	26807000
118688	2133	91981604000
118689	1874	26809000
118690	2133	91980602000
118691	1874	26811000
118692	1395	58238550930957278
118693	1395	58238550936957278
118726	2261	7919183000000
118738	1439	9343690578477
118748	1397	1291345269000
118749	1678	26640839831000
118750	1397	1291335268000
118751	1678	26640839832000
118752	2133	91973588000
118753	1874	26845000
118754	2133	91972586000
118755	1874	26847000
118756	2134	85387463000
118757	1874	26850000
118758	2134	85386460000
118759	1874	26853000
118760	1394	730091472500000
118761	1394	730091496500000
118764	1693	15721176330507
118765	245	66778181541448
118766	1397	1291325267000
118767	1678	26640839833000
118768	1693	15645343568530
118769	2017	776780875847
118770	2132	147568581000
118771	1874	26854000
118772	2133	91971584000
118773	1874	26856000
118774	1688	58318955720020
118778	1708	6840481500051
118779	1708	6840513500051
118871	2248	10799717000000
118910	1693	10061461119735
118911	120	66123140493981
118912	1693	9985950033866
118913	320	66496460729956
118914	1693	9910117271889
118915	251	66778181541448
118916	1397	1291245259000
118917	1678	26640839841000
118918	1693	9834607190197
118919	312	66122238827087
118920	1693	9758774428220
118921	663	66778181541448
118922	1444	9447817329999
118923	2134	85378436000
118924	1874	26896000
118925	2133	91963568000
118926	1874	26898000
118927	1444	10167817329999
118928	1444	10167819329999
118969	1397	1291215256000
118970	1678	26640839844000
118971	2134	85376430000
118972	1874	26909000
118973	2133	91960562000
118974	1874	26911000
118975	632	76077587000000
118976	632	76077639000000
118979	1397	1291205255000
118980	1678	26640839845000
118981	1397	1291195254000
118982	1678	26640839846000
118983	1693	8404930224717
118511	2307	1439035000000
118512	2307	1439147000000
118566	526	73920279000000
118567	526	73920292000000
118598	1685	159843853571430
118599	1685	159843866571430
118641	1471	11465314900000
118642	1471	11465327900000
118649	1397	1291455280000
118650	1678	26640839820000
118651	2132	147572585000
118652	1874	26785000
118653	1673	9075057000000
118654	1002	508641525000000
118655	2134	85398496000
118656	1874	26788000
118657	2133	91984610000
118658	1874	26790000
118659	1395	58237110872957278
118660	1395	58237110886957278
118727	1637	292327041819988
118737	1759	26641251999889
118762	1395	58239990948957278
118763	1395	58239990972957278
118775	1691	9071127300052
118781	1716	2160055000000
118889	1397	1291255260000
118890	1678	26640839840000
118891	1693	11405345070721
118892	105	66778181541448
118893	1693	11329512308744
118894	206	66778181541448
118895	1693	11323758160116
118896	710	5058953147009
118897	1693	11247925398139
118898	499	66778181541448
118899	1693	10212482495691
118900	1030	911596720871342
118901	1693	10136972230972
118902	238	66122425123421
118903	2133	91964570000
118904	1874	26889000
118905	2134	85379439000
118906	1874	26892000
118907	2132	147566579000
118908	1874	26893000
118909	1696	14123691335104
118950	1439	10063690578477
118951	1439	10063742578477
118968	1395	58240710984957278
118977	1637	293047041819988
118978	1637	293047092819988
118995	1397	1291185253000
118996	1678	26640839847000
118997	1693	8329097462740
118998	82	66778181541448
118999	1693	8253264700763
119000	361	66128179541448
119001	1693	8177431938786
119002	402	66778181541448
119003	1693	8101599176809
119004	275	66778181541448
119005	1693	8025766414832
119006	452	66778181541448
119007	2133	91958558000
119008	1874	26922000
119009	2134	85373421000
119010	1874	26925000
119011	1688	58318985720020
119092	2039	12859579000000
119093	2039	12859920000000
119130	1397	1291115246000
119131	1678	26640839854000
119132	1693	5257986027726
119133	29	7082534405834
119134	1693	5182153265749
119135	593	66777180541448
119136	1693	5106643081103
119137	154	66122328993781
119138	2133	91951544000
119139	1874	26959000
119140	2134	85366400000
119141	1874	26962000
119142	1394	734411856500000
119143	1394	734411898500000
119152	1522	8683665000000
119153	1522	8683677000000
119171	1693	4803956022186
119172	262	66122305010443
119173	1693	4728123260209
119174	660	66778181541448
119175	1397	1291085243000
119176	1678	26640839857000
119177	1672	7201363000000
119178	1693	4652290498232
119179	304	66778181541448
119180	1693	4576780405100
119181	441	66122248845612
119182	1693	4500947643123
119183	122	66778181541448
119184	2133	91948538000
119185	1874	26975000
119186	2134	85363391000
119187	1874	26978000
119188	1672	7921363000000
119189	1672	7921395000000
119193	1672	7921385000000
119289	1397	1291025237000
119290	1678	26640839863000
119291	1693	2529761802826
119292	237	66122328993781
119293	1693	2453929040849
119294	2164	776842347551
119295	1693	2378418856203
119296	165	66122328993781
119297	1693	2302586094226
119298	600	66778181541448
119299	2134	85357373000
119300	1874	27007000
119301	2132	147559572000
119302	1874	27008000
119303	2133	91942526000
119304	1874	27010000
119305	1588	32401760000000
119306	1588	32401813000000
119319	1397	1290995234000
119320	1678	26640839866000
119321	1693	2226753332249
119322	691	66778181541448
119323	1693	2150920570272
119324	620	66778181541448
119325	2133	91941524000
119326	1874	27018000
119327	2133	91940522000
119328	1874	27020000
119329	2133	91939520000
119330	1874	27022000
119331	2134	85354364000
119332	1874	27025000
119333	2132	147558571000
119334	1874	27026000
119335	1671	10464013003785
119336	1671	10464048003785
119355	1397	1290955230000
119356	1678	26640839870000
119357	2133	91935512000
119358	1874	27040000
119359	2132	147557570000
119360	1874	27041000
119361	2134	85351355000
119362	1874	27044000
119363	1544	1440011000000
119364	1544	1440024000000
119367	1397	1290945229000
119368	1678	26640839871000
119369	2134	85350352000
119370	1874	27047000
119371	2133	91934510000
119372	1874	27049000
119373	1455	2911575000000
119377	1692	68181552619999
119398	1673	9575435000000
119399	1673	9575460000000
119424	1588	12241763000000
119425	2068	1943000000000
119426	1397	1290895224000
119427	1678	26640839876000
119428	2133	91929500000
119429	1874	27072000
119430	2133	91928498000
119431	1874	27074000
119432	1394	735851972500000
119433	2132	147555568000
119434	1874	27075000
119435	2134	85345337000
119436	1874	27078000
119437	2134	85344334000
119438	1874	27081000
119439	1394	737291972500000
119440	1394	737291975500000
119452	1693	2870920570272
119453	1693	2870932570272
119481	1397	1290845219000
119482	1678	26640839881000
119483	2133	91923488000
118961	731	2023581258730
118962	2132	147565578000
118963	1874	26904000
118964	2133	91961564000
118965	1874	26906000
118966	1476	10800218000000
118967	1476	10800270000000
119090	1594	13681767000000
119091	1594	13682108000000
119094	1693	6377806984034
119095	453	66778181541448
119096	1693	6301974222057
119097	373	66778181541448
119098	1693	6226141460080
119099	63	66778181541448
119100	1693	6150308698103
119101	150	66778181541448
119102	1693	6074475936126
119103	92	66778181541448
119104	1693	5998965751480
119105	562	66122328993781
119106	1693	5421144449517
119107	910	508705959522200
119108	1693	5417699893618
119109	711	3007950736827
119110	1693	5341870597783
119111	395	66275134929575
119112	1693	5266037835806
119113	78	66778181541448
119114	1397	1291135248000
119115	1678	26640839852000
119116	1397	1291125247000
119117	1678	26640839853000
119118	2132	147562575000
119119	1874	26947000
119120	2133	91953548000
119121	1874	26949000
119122	2133	91952546000
119123	1874	26951000
119124	2134	85368406000
119125	1874	26954000
119126	2134	85367403000
119127	1874	26957000
119128	1394	732971731500000
119129	1394	732971856500000
119265	1419	21166117559750
119266	1419	21166252559750
119269	1693	2835070888673
119270	163	66778181541448
119271	1693	2759238126696
119272	1962	777093716675
119273	1693	2756937511426
119274	748	2725998633389
119275	1693	2681104749449
119276	2073	776356451518
119277	1693	2605271987472
119278	180	66778181541448
119279	1397	1291035238000
119280	1678	26640839862000
119281	2134	85358376000
119282	1874	27002000
119283	2133	91943528000
119284	1874	27004000
119285	1684	19443287819412
119286	1684	19443349819412
119309	1397	1291015236000
119310	1678	26640839864000
119311	1397	1291005235000
119312	1678	26640839865000
119313	2134	85356370000
119314	1874	27013000
119315	2134	85355367000
119316	1874	27016000
119317	1395	58241430984957278
119318	1395	58241431006957278
119338	1397	1290985233000
119339	1678	26640839867000
119340	1397	1290975232000
119341	1678	26640839868000
119342	1397	1290965231000
119343	1678	26640839869000
119344	2134	85353361000
119345	1874	27029000
119346	2134	85352358000
119347	1874	27032000
119348	2133	91938518000
119349	1874	27034000
119350	2133	91937516000
119351	1874	27036000
119352	2133	91936514000
119353	1874	27038000
119354	1688	58318958720020
119376	606	73246679286230
119394	1874	27053000
119395	1874	27056000
119396	1690	169205572000000
119397	1690	169205595000000
119444	1397	1290885223000
119445	1678	26640839877000
119446	2134	85343331000
119447	1874	27084000
119448	2133	91927496000
119449	1874	27086000
119450	1588	12961763000000
119451	1588	12961775000000
119474	1673	9575448000000
119487	1397	1290835218000
119488	1678	26640839882000
119489	2134	85339319000
119490	1874	27107000
119491	2132	147553566000
119492	1874	27108000
119493	2133	91922486000
119494	1874	27110000
119495	1394	737291950500000
119496	1394	737291963500000
119512	1394	737291974500000
119582	1397	1290785213000
119583	1678	26640839887000
119584	1397	1290775212000
119585	1678	26640839888000
119586	1397	1290765211000
119587	1678	26640839889000
119588	1397	1290755210000
119589	1678	26640839890000
119590	1397	1290745209000
119591	1678	26640839891000
119592	2133	91917476000
119593	1874	27133000
119594	2133	91916474000
119595	1874	27135000
119596	1926	1190000000
119597	2133	91915472000
119598	1874	27137000
119599	2134	85334304000
119600	1874	27140000
119601	2134	85333301000
119602	1874	27143000
119603	2134	85332298000
119604	1874	27146000
119605	2134	85331295000
119606	1874	27149000
119607	2134	85330292000
119608	1874	27152000
119609	2132	147551564000
119610	1874	27153000
119611	2133	91914470000
119612	1874	27155000
119613	2133	91913468000
119614	1874	27157000
119615	1698	10868932550062
119640	1397	1290705205000
119641	1678	26640839895000
119642	2132	147549562000
119643	1874	27174000
119644	2134	85326280000
119645	1874	27177000
119646	2133	91909460000
119647	1874	27179000
119648	1593	12912715000000
119649	1593	12912728000000
119713	1397	1290625197000
119714	1678	26640839903000
119715	1637	293767114819988
119716	2133	91901444000
119717	1874	27218000
119718	2134	85318256000
119719	1874	27221000
119720	1637	294487114819988
119721	1637	294487116819988
119790	1874	27249000
119791	1710	10314008664140
119792	1710	10314010664140
119840	641	76803895000000
119890	1394	738731974500000
119891	1394	738731997500000
119926	1394	740171997500000
119927	1394	740172047500000
119936	1419	21166129559750
119955	1690	169925585000000
119956	1690	169925620000000
119964	1874	27309000
119965	1397	1290445179000
119966	1678	26640839921000
119967	2134	85300202000
118984	309	66778181541448
118985	2132	147564577000
118986	1874	26912000
118987	2133	91959560000
118988	1874	26914000
118989	2134	85375427000
118990	1874	26917000
118991	2134	85374424000
118992	1874	26920000
118993	1685	160563915571430
118994	1685	160563950571430
119014	1536	14400289000000
119015	1536	14400351000000
119016	1397	1291175252000
119017	1678	26640839848000
119018	1397	1291165251000
119019	1678	26640839849000
119020	1397	1291155250000
119021	1678	26640839850000
119022	1397	1291145249000
119023	1678	26640839851000
119024	1693	7950253599123
119025	458	66124633253615
119026	1693	7874420837146
119027	391	66777071541448
119028	1693	7798588075169
119029	680	66778181541448
119030	1693	7722755313192
119031	690	66778181541448
119032	1693	7646922551215
119033	2181	776433347551
119034	1693	7571412469523
119035	327	66122238827087
119036	1693	7495579707546
119037	652	66778181541448
119038	1693	7419746945569
119039	266	66165161541448
119040	1693	7343914183592
119041	352	66778181541448
119042	1693	7268081421615
119043	534	66778181541448
119044	1693	7192248659638
119045	520	66778181541448
119046	1693	7116415897661
119047	551	66778181541448
119048	1693	7040583135684
119049	191	66778181541448
119050	1693	6964750373707
119051	421	66778181541448
119052	1693	6266113161963
119053	1150	615072472419738
119054	1693	6190280399986
119055	84	66778181541448
119056	1693	6114770215340
119057	379	66122328993781
119058	1693	6038937453363
119059	678	66778181541448
119060	1693	5963104691386
119061	89	66778181541448
119062	1693	5887271929409
119063	383	66778181541448
119064	1693	5811439167432
119065	91	66778181541448
119066	1693	5735606405455
119067	438	66778181541448
119068	1693	5733298746011
119069	745	2023581258730
119070	2132	147563576000
119071	1874	26926000
119072	2133	91957556000
119073	1874	26928000
119074	2133	91956554000
119075	1874	26930000
119076	2134	85372418000
119077	1874	26933000
119078	2133	91955552000
119079	1874	26935000
119080	2133	91954550000
119081	1874	26937000
119082	2134	85371415000
119083	1874	26940000
119084	2134	85370412000
119085	1874	26943000
119086	2134	85369409000
119087	1874	26946000
119088	1693	6453298746011
119089	1693	6453639746011
119144	1397	1291105245000
119145	1678	26640839855000
119146	2134	85365397000
119147	1874	26965000
119148	2133	91950542000
119149	1874	26967000
119150	1693	5826643081103
119151	1693	5826655081103
119210	1613	9937338200000
119227	1693	3595696523039
119228	35	19426380084717
119229	1693	3519863761062
119230	49	66778181541448
119231	1397	1291055240000
119232	1678	26640839860000
119233	1397	1291045239000
119234	1678	26640839861000
119235	1693	3517565746466
119236	1778	5453794416372
119237	1693	3441732984489
119238	99	66778181541448
119239	1693	3365900222512
119240	108	66778181541448
119241	1693	3290067460535
119242	252	66778181541448
119243	1693	3214234698558
119244	225	66778181541448
119245	1693	3138401936581
119246	377	66778181541448
119247	1693	3062569174604
119248	560	66778181541448
119249	1693	2986736412627
119250	594	66778181541448
119251	1693	2910903650650
119252	201	66778181541448
119253	2134	85360382000
119254	1874	26991000
119255	2133	91945532000
119256	1874	26993000
119257	2133	91944530000
119258	1874	26995000
119259	2132	147560573000
119260	1874	26996000
119261	2134	85359379000
119262	1874	26999000
119263	1601	4705813620000
119264	1601	4705948620000
119267	1555	10325942540449
119268	1555	10326077540449
119337	1687	5168912848312
119374	1762	8565585994000
119375	1762	8565597994000
119402	1588	23643327000000
119403	1392	1710871984751650
119404	1397	1290915226000
119405	1678	26640839874000
119406	1397	1290905225000
119407	1678	26640839875000
119408	1588	18984967000000
119409	1146	909957426000000
119410	1588	15849321000000
119411	1266	612507047000000
119412	1588	13249773000000
119413	1026	507791170000000
119414	2133	91931504000
119415	1874	27062000
119416	2134	85347343000
119417	1874	27065000
119418	2134	85346340000
119419	1874	27068000
119420	2133	91930502000
119421	1874	27070000
119422	1599	10376794097983
119423	1599	10376858097983
119464	1397	1290865221000
119465	1678	26640839879000
119466	2134	85341325000
119467	1874	27094000
119468	2133	91925492000
119469	1874	27096000
119470	2132	147554567000
119471	1874	27097000
119472	1991	9261330355805
119473	1991	9261343355805
119475	1397	1290855220000
119476	1678	26640839880000
119477	2134	85340322000
119478	1874	27100000
119479	2133	91924490000
119480	1874	27102000
119498	1397	1290825217000
119499	1678	26640839883000
119500	1397	1290815216000
119501	1678	26640839884000
119502	2134	85338316000
119503	1874	27113000
119504	2134	85337313000
119505	1874	27116000
119385	1874	27052000
119386	2133	91932506000
119387	1874	27054000
119388	2134	85349349000
119389	1874	27057000
119390	2134	85348346000
119391	1874	27060000
119392	1547	9354778000000
119393	1547	9354803000000
119400	1395	58242151006957278
119401	1395	58242151031957278
119441	1708	6840535500051
119442	1708	7560535500051
119443	1708	7560538500051
119454	1693	2870765570272
119455	1693	2870776570272
119456	1397	1290875222000
119457	1678	26640839878000
119458	2133	91926494000
119459	1874	27088000
119460	2134	85342328000
119461	1874	27091000
119462	1467	3040229272869
119463	1467	3040241272869
119485	1555	11046077540449
119486	1555	11046088540449
119497	1705	18560884580140
119513	1397	1290805215000
119514	1678	26640839885000
119515	2133	91919480000
119516	1874	27122000
119517	2134	85336310000
119518	1874	27125000
119519	2132	147552565000
119520	1874	27126000
119521	1458	17225357908540
119616	1397	1290735208000
119617	1678	26640839892000
119618	2133	91912466000
119619	1874	27159000
119620	2132	147550563000
119621	1874	27160000
119622	2134	85329289000
119623	1874	27163000
119624	632	76077600000000
119639	1426	12171342999976
119672	1874	27181000
119673	1874	27183000
119674	1874	27185000
119675	1455	3631575000000
119676	1455	3631579000000
119679	1397	1290665201000
119680	1678	26640839899000
119681	1397	1290655200000
119682	1678	26640839900000
119683	2132	147548561000
119684	1874	27195000
119685	2134	85322268000
119686	1874	27198000
119687	2134	85321265000
119688	1874	27201000
119689	2133	91905452000
119690	1874	27203000
119691	2133	91904450000
119692	1874	27205000
119693	1701	12958324500103
119694	1701	12958349500103
119722	114	66117956901851
119723	2314	0
119724	1397	1290615196000
119725	1678	26640839904000
119726	2133	91900442000
119727	1874	27223000
119728	2134	85317253000
119729	1874	27226000
119730	1717	13501242000055
119731	1717	13501264000055
119752	1397	1290585193000
119753	1678	26640839907000
119754	283	66001719734615
119755	2314	122000000000
119756	114	66000936901851
119757	2314	238000000000
119758	10	32558282617398
119759	2314	299000000000
119760	2134	85314244000
119761	1874	27240000
119762	2133	91897436000
119763	1874	27242000
119764	1668	9873646000000
119765	1668	9873688000000
119768	1397	1290575192000
119769	1678	26640839908000
119770	301	66002710734615
119771	2314	429000000000
119772	2134	85313241000
119773	1874	27245000
119774	2133	91896434000
119775	1874	27247000
119776	1593	12912737000000
119778	1395	58242871031957278
119779	1395	58242871052957278
119793	1588	22923274000000
119794	114	66042453685762
119795	114	66041443685762
119796	1588	18264914000000
119797	1588	15129268000000
119798	1588	12529720000000
119799	1588	11521710000000
119800	1693	5657465984034
119801	1693	5581633222057
119802	1693	5505800460080
119803	1693	5429967698103
119804	1693	5354134936126
119805	1693	5278624751480
119806	1693	4700803449517
119807	1693	4697358893618
119808	1693	4621529597783
119809	1693	4545696835806
119810	1693	4537645027726
119811	1693	4461812265749
119812	1693	4386302081103
119813	1693	4310469319126
119814	1693	4234636557149
119815	1693	4159125217123
119816	1693	4083615022186
119817	1693	4007782260209
119818	1693	3931949498232
119819	1693	3856439405100
119820	1693	3780606643123
119821	1693	3705096458477
119822	1693	3629263696500
119823	1693	3553430934523
119824	1693	3477598172546
119825	1966	200112200
119826	1649	10551536887768
119827	1509	10552599887768
119828	1649	11903338503835
119892	1397	1290525187000
119893	1678	26640839913000
119894	2133	91891424000
119895	1874	27271000
119896	2134	85308226000
119897	1874	27274000
119898	149	75455323000341
119899	149	75455335000341
119928	1397	1290485183000
119929	1678	26640839917000
119930	2134	85304214000
119931	1874	27293000
119932	2133	91887416000
119933	1874	27295000
119934	1451	4027759000000
119935	1451	4027771000000
119957	1394	740172032500000
120042	1397	1290355170000
120043	1678	26640839930000
120044	2133	91874390000
120045	1874	27361000
120046	2134	85291175000
120047	1874	27364000
120048	2148	6480134880750
120059	1874	27367000
120060	1706	11802147450256
120142	1613	10657338200000
120143	1613	10657350200000
120170	1397	1290205155000
120171	1678	26640839945000
120172	1397	1290195154000
120173	1678	26640839946000
120174	2134	85276130000
120175	1874	27441000
120176	2133	91859360000
120177	1874	27443000
120178	2133	91858358000
120179	1874	27445000
120180	2132	147534547000
120181	1874	27446000
120182	1769	1578900000
120183	2134	85275127000
120184	1874	27449000
120185	1457	11520224800000
120189	1397	1290185153000
120190	1678	26640839947000
120191	1397	1290175152000
119484	1874	27104000
119650	1426	11850379000000
119651	1397	1290695204000
119652	1678	26640839896000
119653	1397	1290685203000
119654	1678	26640839897000
119655	1397	1290675202000
119656	1678	26640839898000
119657	2134	85325277000
119658	1874	27182000
119659	2133	91908458000
119660	1874	27184000
119661	2133	91907456000
119662	1874	27186000
119663	2133	91906454000
119664	1874	27188000
119665	2134	85324274000
119666	1874	27191000
119667	2134	85323271000
119668	1874	27194000
119669	1926	1189000000
119670	1623	71283169899898
119671	1623	71283206899898
119677	1458	19385393908540
119678	1458	19385430908540
119703	1397	1290635198000
119704	1678	26640839902000
119705	2133	91902446000
119706	1874	27212000
119707	2132	147547560000
119708	1874	27213000
119709	2134	85319259000
119710	1874	27216000
119711	1594	13681780000000
119744	1397	1290595194000
119745	1678	26640839906000
119746	2133	91898438000
119747	1874	27234000
119748	2134	85315247000
119749	1874	27237000
119750	576	76157606726897
119751	576	76157618726897
119830	1397	1290555190000
119831	1678	26640839910000
119832	2134	85311235000
119833	1874	27256000
119834	2133	91894430000
119835	1874	27258000
119836	576	76877618726897
119837	576	76877641726897
119841	2314	368000000000
119842	1874	27005000
119843	1874	27006000
119844	1874	27009000
119845	1874	27012000
119846	1874	27015000
119847	1874	27021000
119848	1874	27023000
119849	1874	27024000
119850	641	76084584000000
119851	1874	27027000
119852	1874	27028000
119853	1874	27030000
119854	1874	27031000
119855	1874	27033000
119856	1874	27042000
119857	1874	27046000
119858	1874	27048000
119859	1874	27058000
119860	1874	27064000
119861	1874	27066000
119862	1874	27076000
119863	1874	27087000
119864	1874	27090000
119865	1874	27093000
119866	1874	27099000
119867	1874	27105000
119868	1874	27111000
119869	641	76804584000000
119870	641	76804627000000
119871	1397	1290545189000
119872	1678	26640839911000
119873	2134	85310232000
119874	1874	27261000
119875	2133	91893428000
119876	1874	27263000
119877	1637	295207116819988
119878	1637	295207128819988
119958	1397	1290455180000
119959	1678	26640839920000
119960	2133	91884410000
119961	1874	27308000
119962	2134	85301205000
119963	1874	27311000
119973	1394	741612032500000
119974	1394	741612044500000
119990	1397	1290415176000
119991	1678	26640839924000
119992	2133	91880402000
119993	1874	27329000
119994	2134	85297193000
119995	1874	27332000
119996	1395	58242871043957278
119997	1397	1290405175000
119998	1678	26640839925000
119999	1397	1290395174000
120000	1678	26640839926000
120001	1397	1290385173000
120002	1678	26640839927000
120003	2132	147540553000
120004	1874	27333000
120005	2133	91879400000
120006	1874	27335000
120007	2133	91878398000
120008	1874	27337000
120009	2133	91877396000
120010	1874	27339000
120011	2134	85296190000
120012	1874	27342000
120013	2134	85295187000
120014	1874	27345000
120015	1546	9597469800000
120016	2134	85294184000
120017	1874	27348000
120018	1546	10317469800000
120019	1546	10317470800000
120038	1394	743052069500000
120039	1394	743052094500000
120051	1637	295927128819988
120052	1637	295927140819988
120071	1394	744492094500000
120072	1394	744492107500000
120110	1397	1290275162000
120111	1678	26640839938000
120112	1397	1290265161000
120113	1678	26640839939000
120114	2132	147536549000
120115	1874	27402000
120116	2133	91866374000
120117	1874	27404000
120118	2134	85283151000
120119	1874	27407000
120120	2134	85282148000
120121	1874	27410000
120122	2133	91865372000
120123	1874	27412000
120124	1394	745932119500000
120125	1394	745932144500000
120161	149	76175335000341
120162	149	76175360000341
120163	1397	1290215156000
120164	1678	26640839944000
120165	2133	91860362000
120166	1874	27435000
120167	2134	85277133000
120168	1874	27438000
120169	1395	58243591055957278
120187	1402	28262965145435
120188	1402	28262991145435
120214	1397	1290155150000
120215	1678	26640839950000
120216	2134	85271115000
120217	1874	27468000
120218	2133	91854350000
120219	1874	27470000
120220	1696	15563716335104
120221	1696	15563728335104
120224	1874	27467000
120225	1619	4320075000000
120226	1619	4320086000000
120279	1397	1290095144000
120280	1678	26640839956000
120281	2133	91847336000
120282	1874	27504000
120283	2134	85264094000
120284	1874	27507000
120285	1394	747372144500000
120286	1394	747372156500000
120292	1397	1290085143000
120293	1678	26640839957000
120294	2133	91846334000
120295	1874	27509000
120296	2134	85263091000
120297	1874	27512000
120320	1397	1290055140000
119506	2133	91921484000
119507	1874	27118000
119508	2133	91920482000
119509	1874	27120000
119510	1719	14398626000000
119511	1719	14398650000000
119522	1715	19931052224631
119523	1715	19675195013166
119524	1715	19419337801701
119525	1715	17569193689316
119526	1715	14253830491090
119527	1715	12016856349966
119528	1715	5783507663945
119529	1693	14281141330507
119530	1588	22203212000000
119531	1588	17544852000000
119532	1588	14409206000000
119533	1693	14205308568530
119534	1693	13996960979531
119535	1693	13921450337310
119536	1693	13845617575333
119537	1693	13769784813356
119538	1693	13693952051379
119539	1458	17226373908540
119540	1693	13618441409158
119541	1693	13542608647181
119542	1693	13466775885204
119543	1693	13390560305742
119544	1693	13314727543765
119545	1693	13238894781788
119546	1693	13201639230206
119547	1693	13125806468229
119548	1693	13050296386537
119549	1693	12974463624560
119550	1693	12898630862583
119551	1693	12822798100606
119552	1693	12746965338629
119553	1693	12671452122540
119554	1693	12595941596999
119555	1693	12520108835022
119556	1693	12444276073045
119557	1693	12368765888399
119558	1693	12293255703753
119559	1693	12217422941776
119560	1693	10270626097788
119561	1693	10194793335811
119562	1693	10118960573834
119563	1693	10043450492142
119564	1693	10041142832698
119565	1693	9965310070721
119566	1693	9889477308744
119567	1693	9883723160116
119568	1693	9807890398139
119569	1693	8772447495691
119570	1693	8696937230972
119571	1693	8621426119735
119572	1458	17946373908540
119573	1458	17946693908540
119574	1397	1290795214000
119575	1678	26640839886000
119576	2134	85335307000
119577	1874	27129000
119578	2133	91918478000
119579	1874	27131000
119580	1458	17945357908540
119581	1458	17945369908540
119625	1397	1290725207000
119626	1678	26640839893000
119627	1397	1290715206000
119628	1678	26640839894000
119629	2133	91911464000
119630	1874	27165000
119631	2134	85328286000
119632	1874	27168000
119633	2134	85327283000
119634	1874	27171000
119635	2133	91910462000
119636	1874	27173000
119637	1458	18665369908540
119638	1458	18665393908540
119695	1397	1290645199000
119696	1678	26640839901000
119697	2134	85320262000
119698	1874	27208000
119699	2133	91903448000
119700	1874	27210000
119701	1637	293767092819988
119702	1637	293767104819988
119712	1690	169205585000000
119732	114	66116946901851
119733	2314	1000000000
119734	1397	1290605195000
119735	1678	26640839905000
119736	2134	85316250000
119737	1874	27229000
119738	2132	147546559000
119739	1874	27230000
119740	2133	91899440000
119741	1874	27232000
119742	1688	59038958720020
119743	1688	59038981720020
119766	1723	10082045085979
119767	1723	10082087085979
119777	1654	15257471999798
119780	1397	1290565191000
119781	1678	26640839909000
119782	2134	85312238000
119783	1874	27250000
119784	2133	91895432000
119785	1874	27252000
119786	2132	147545558000
119787	1874	27253000
119788	1649	10551536999968
119789	1649	10551549999968
119829	1573	5619376000000
119838	1675	13244305999977
119839	1675	13244328999977
119879	1692	1180542619999
119880	1860	67001978700000
119881	1397	1290535188000
119882	1678	26640839912000
119883	2132	147544557000
119884	1874	27264000
119885	2134	85309229000
119886	1874	27267000
119887	2133	91892426000
119888	1874	27269000
119889	1679	28799414653000
119900	1397	1290515186000
119901	1678	26640839914000
119902	1397	1290505185000
119903	1678	26640839915000
119904	1397	1290495184000
119905	1678	26640839916000
119906	2058	531500000
119907	2314	427899000000
119908	114	66002036901851
119909	2314	427389000000
119910	1950	13890351000000
119911	2134	85307223000
119912	1874	27277000
119913	2133	91890422000
119914	1874	27279000
119915	2133	91889420000
119916	1874	27281000
119917	2133	91888418000
119918	1874	27283000
119919	2134	85306220000
119920	1874	27286000
119921	2132	147543556000
119922	1874	27287000
119923	2134	85305217000
119924	1874	27290000
119925	1402	26822953145435
119937	1397	1290475182000
119938	1678	26640839918000
119939	1397	1290465181000
119940	1678	26640839919000
119941	2314	879000000
119942	1950	14316851000000
119943	2134	85303211000
119944	1874	27298000
119945	2132	147542555000
119946	1874	27299000
119947	2134	85302208000
119948	1874	27302000
119949	2133	91886414000
119950	1874	27304000
119951	2133	91885412000
119952	1874	27306000
119953	1467	3760241272869
119954	1467	3760276272869
119975	1397	1290435178000
119976	1678	26640839922000
119977	1397	1290425177000
119978	1678	26640839923000
119979	2134	85299199000
119980	1874	27319000
119981	2134	85298196000
119982	1874	27322000
119983	2132	147541554000
119984	1874	27323000
119985	2133	91882406000
119986	1874	27325000
119987	2133	91881404000
119968	1874	27314000
119969	2133	91883408000
119970	1874	27316000
119971	1402	27542953145435
119972	1402	27542965145435
120023	1397	1290375172000
120024	1678	26640839928000
120025	1397	1290365171000
120026	1678	26640839929000
120027	2133	91876394000
120028	1874	27350000
120029	2132	147539552000
120030	1874	27351000
120031	2134	85293181000
120032	1874	27354000
120033	2134	85292178000
120034	1874	27357000
120035	2133	91875392000
120036	1874	27359000
120037	1670	8641026000000
120061	1397	1290335168000
120062	1678	26640839932000
120063	2134	85289169000
120064	1874	27372000
120065	2132	147538551000
120066	1874	27373000
120067	2133	91872386000
120068	1874	27375000
120069	1608	10938468000000
120070	1608	10938481000000
120095	1397	1290295164000
120096	1678	26640839936000
120097	1397	1290285163000
120098	1678	26640839937000
120099	2132	147537550000
120100	1874	27391000
120101	2134	85285157000
120102	1874	27394000
120103	2133	91868378000
120104	1874	27396000
120105	2133	91867376000
120106	1874	27398000
120107	2134	85284154000
120108	1874	27401000
120109	1394	744492119500000
120135	1397	1290245159000
120136	1678	26640839941000
120137	2134	85280142000
120138	1874	27420000
120139	2133	91863368000
120140	1874	27422000
120141	1690	169925597000000
120159	1447	17561816683000
120160	1447	17561841683000
120261	1397	1290115146000
120262	1678	26640839954000
120263	2134	85266100000
120264	1874	27494000
120265	2133	91849340000
120266	1874	27496000
120267	1536	14400301000000
120291	2307	1439047000000
120318	1706	12522148450256
120319	1706	12522160450256
120344	1587	10080336000000
120345	1587	10080348000000
120346	1397	1290025137000
120347	1678	26640839963000
120348	2133	91841324000
120349	1874	27536000
120350	2134	85258076000
120351	1874	27539000
120352	1623	71283181899898
120371	1673	9575471000000
120458	1397	1289895124000
120459	1678	26640839976000
120460	2133	91828298000
120461	1874	27605000
120462	2134	85245037000
120463	1874	27608000
120464	1549	10511371000000
120539	1508	12440399156616
120540	1508	12440433156616
120564	1397	1289795114000
120565	1678	26640839986000
120566	2133	91818278000
120567	1874	27658000
120568	2134	85235007000
120569	1874	27661000
120571	1672	8641385000000
120572	1672	8641397000000
120587	1397	1289785113000
120588	1678	26640839987000
120589	2134	85234004000
120590	1874	27664000
120591	2133	91817276000
120592	1874	27666000
120593	1706	13242160450256
120594	1706	13242172450256
120604	1397	1289765111000
120605	1678	26640839989000
120606	1397	1289755110000
120607	1678	26640839990000
120608	2134	85231998000
120609	1874	27675000
120610	2134	85230995000
120611	1874	27678000
120612	2133	91815272000
120613	1874	27680000
120614	2133	91814270000
120615	1874	27682000
120616	1694	13498974197225
120617	1694	13498998197225
120643	1874	27657000
120644	1874	27660000
120645	1874	27662000
120646	1874	27668000
120647	1874	27670000
120648	1874	27674000
120649	1874	27677000
120650	1874	27683000
120651	1874	27686000
120652	1874	27689000
120653	1874	27692000
120654	1874	27695000
120655	1549	11951482000000
120656	1549	11951580000000
120686	1687	5888912848312
120687	1687	5888924848312
120688	1397	1289685103000
120689	1678	26640839997000
120690	1397	1289675102000
120691	1678	26640839998000
120692	2314	869000000
120693	1950	14438851000000
120694	2134	85223974000
120695	1874	27717000
120696	2134	85222971000
120697	1874	27720000
120698	2132	147518531000
120699	1874	27721000
120700	2133	91807256000
120701	1874	27723000
120702	2133	91806254000
120703	1874	27725000
120704	1447	17561851683000
120706	1397	1289665101000
120707	1678	26640839999000
120708	2133	91805252000
120709	1874	27727000
120710	2134	85221968000
120711	1874	27730000
120712	1564	10446677000000
120713	1564	10446689000000
120757	1762	7845595994000
120758	1762	8565595994000
120769	1397	1289595094000
120770	1678	26640840006000
120771	2133	91798238000
120772	1874	27764000
120773	1608	11658481000000
120774	1608	11658492000000
120815	1397	1289545089000
120816	1678	26640840011000
120817	2133	91793228000
120818	1874	27790000
120819	2134	85209932000
120820	1874	27793000
120833	2087	3315398147766
120834	2087	3315410147766
120835	1397	1289525087000
120836	1678	26640840013000
120837	1397	1289515086000
120838	1678	26640840014000
120839	1474	6390465000043
120840	2316	799000000000
120841	1397	1289505085000
120842	1678	26640840015000
120843	2133	91791224000
120844	1874	27801000
120845	2133	91790222000
120846	1874	27803000
120847	2132	147513526000
120848	1874	27804000
120849	2133	91789220000
119988	1874	27327000
119989	1723	10082070085979
120020	1394	740172068500000
120021	1394	741612068500000
120022	1394	741612069500000
120040	1395	58243591043957278
120041	1395	58243591068957278
120049	1675	13964328999977
120050	1675	13964340999977
120053	1397	1290345169000
120054	1678	26640839931000
120055	2133	91873388000
120056	1874	27366000
120057	2134	85290172000
120058	1874	27369000
120073	1397	1290325167000
120074	1678	26640839933000
120075	1397	1290315166000
120076	1678	26640839934000
120077	1397	1290305165000
120078	1678	26640839935000
120079	1860	1968700000
120080	2152	107000000000000
120081	2133	91871384000
120082	1874	27377000
120083	2133	91870382000
120084	1874	27379000
120085	2133	91869380000
120086	1874	27381000
120087	2134	85288166000
120088	1874	27384000
120089	2134	85287163000
120090	1874	27387000
120091	2134	85286160000
120092	1874	27390000
120093	1688	59758981720020
120094	1688	59759027720020
120126	441	66000148845612
120127	2314	122879000000
120128	1397	1290255160000
120129	1678	26640839940000
120130	2134	85281145000
120131	1874	27415000
120132	2133	91864370000
120133	1874	27417000
120134	1671	10464125003785
120144	1397	1290235158000
120145	1678	26640839942000
120146	1397	1290225157000
120147	1678	26640839943000
120148	2134	85279139000
120149	1874	27425000
120150	2134	85278136000
120151	1874	27428000
120152	2132	147535548000
120153	1874	27429000
120154	2133	91862366000
120155	1874	27431000
120156	2133	91861364000
120157	1874	27433000
120158	1696	14843716335104
120186	42	72140652000000
120204	1397	1290165151000
120205	1678	26640839949000
120206	2134	85272118000
120207	1874	27462000
120208	1769	1575700000
120209	2132	147533546000
120210	1874	27463000
120211	2133	91855352000
120212	1874	27465000
120213	1634	12623051259504
120227	1619	4320087000000
120228	1691	9071096300052
120230	1397	1290145149000
120231	1678	26640839951000
120232	238	66112415123421
120233	2315	9000000000
120234	1397	1290135148000
120235	1678	26640839952000
120236	1397	1290125147000
120237	1678	26640839953000
120238	2134	85270112000
120239	1874	27471000
120240	1769	1574700000
120241	2132	147532545000
120242	1874	27472000
120243	1874	27474000
120244	2133	91853348000
120245	1874	27476000
120246	2133	91852346000
120247	1874	27478000
120248	2133	91851344000
120249	1874	27480000
120250	2133	91850342000
120251	1874	27482000
120252	2134	85269109000
120253	1874	27485000
120254	2134	85268106000
120255	1874	27488000
120256	1594	12961827000000
120257	2134	85267103000
120258	1874	27491000
120259	1594	13681827000000
120260	1594	13681828000000
120277	1749	17285588529980
120278	1749	17285601529980
120289	1708	8280538500051
120290	1708	8280550500051
120308	1402	28982991145435
120309	1402	28983013145435
120328	149	76175347000341
120343	1271	1350606496000000
120355	1397	1290015136000
120356	1678	26640839964000
120357	1397	1290005135000
120358	1678	26640839965000
120359	2133	91840322000
120360	1874	27541000
120361	2132	147528541000
120362	1874	27542000
120363	2133	91839320000
120364	1874	27544000
120365	1769	1573700000
120366	2134	85257073000
120367	1874	27547000
120368	2134	85256070000
120369	1874	27550000
120370	1394	750252204500000
120380	1650	8032978000000
120381	1650	8032990000000
120397	1397	1289965131000
120398	1678	26640839969000
120399	1397	1289955130000
120400	1678	26640839970000
120401	2133	91835312000
120402	1874	27568000
120403	2133	91834310000
120404	1874	27570000
120405	2134	85252058000
120406	1874	27573000
120407	2134	85251055000
120408	1874	27576000
120409	1394	751692204500000
120410	1394	751692228500000
120438	2261	7919170000000
120457	1746	2688900000000
120465	1588	13681775000000
120466	1588	13681787000000
120474	1724	10494711500000
120475	1724	10494723500000
120476	1397	1289875122000
120477	1678	26640839978000
120478	2133	91826294000
120479	1874	27615000
120480	2132	147524537000
120481	1874	27616000
120482	1656	12235496999990
120483	2134	85243031000
120484	1874	27619000
120485	1656	12955496999990
120486	1397	1289865121000
120487	1678	26640839979000
120488	2133	91825292000
120489	1874	27621000
120490	2134	85242028000
120491	1874	27624000
120492	1637	297367152819988
120493	1637	297367164819988
120502	1397	1289845119000
120503	1678	26640839981000
120504	2133	91823288000
120505	1874	27631000
120506	2134	85240022000
120507	1874	27634000
120508	2132	147523536000
120509	1874	27635000
120510	1596	5040120000000
120538	1540	720034000000
120554	1397	1289805115000
120555	1678	26640839985000
120556	2134	85236010000
120557	1874	27653000
120558	2133	91819280000
120559	1874	27655000
120192	1678	26640839948000
120193	2133	91857356000
120194	1874	27451000
120195	2133	91856354000
120196	1874	27453000
120197	1769	1576700000
120198	44	66000001200000
120199	2134	85274124000
120200	1874	27456000
120201	2134	85273121000
120202	1874	27459000
120203	1573	5619388000000
120222	1717	14221264000055
120223	1717	14221276000055
120229	1619	4320076000000
120268	1397	1290105145000
120269	1678	26640839955000
120270	2134	85265097000
120271	1874	27499000
120272	2133	91848338000
120273	1874	27501000
120274	2132	147531544000
120275	1874	27502000
120276	1564	9726677000000
120287	1506	6480192967172
120288	1506	6480204967172
120298	238	66111405123421
120299	2315	10000000000
120300	1397	1290075142000
120301	1678	26640839958000
120302	2132	147530543000
120303	1874	27513000
120304	2133	91845332000
120305	1874	27515000
120306	43	72480056890000
120307	43	72480078890000
120310	1397	1290065141000
120311	1678	26640839959000
120312	2133	91844330000
120313	1874	27517000
120314	2134	85262088000
120315	1874	27520000
120316	1394	748812156500000
120317	1394	748812168500000
120335	1397	1290035138000
120336	1678	26640839962000
120337	2133	91842326000
120338	1874	27531000
120339	2134	85259079000
120340	1874	27534000
120341	1394	750252168500000
120342	1394	750252180500000
120353	1395	58244311055957278
120354	1395	58244311057957278
120372	1397	1289995134000
120373	1678	26640839966000
120374	2134	85255067000
120375	1874	27553000
120376	2133	91838318000
120377	1874	27555000
120378	1637	296647140819988
120379	1637	296647152819988
120388	1397	1289975132000
120389	1678	26640839968000
120390	2134	85253061000
120391	1874	27563000
120392	2133	91836314000
120393	1874	27565000
120394	2132	147527540000
120395	1874	27566000
120396	1402	28983004145435
120421	1991	9981343355805
120422	1991	9981356355805
120424	1397	1289935128000
120425	1678	26640839972000
120426	1397	1289925127000
120427	1678	26640839973000
120428	2134	85249049000
120429	1874	27585000
120430	2134	85248046000
120431	1874	27588000
120432	2133	91832306000
120433	1874	27590000
120434	2133	91831304000
120435	1874	27592000
120436	1610	8640163999950
120437	1610	8640187999950
120455	1747	2225954000000
120456	1747	2225967000000
120467	1397	1289885123000
120468	1678	26640839977000
120469	2134	85244034000
120470	1874	27611000
120471	2133	91827296000
120472	1874	27613000
120473	1571	7820628124154
120494	1397	1289855120000
120495	1678	26640839980000
120496	2134	85241025000
120497	1874	27627000
120498	2133	91824290000
120499	1874	27629000
120500	1723	10802070085979
120501	1723	10802082085979
120511	1397	1289835118000
120512	1678	26640839982000
120513	2134	85239019000
120514	1874	27638000
120515	2133	91822286000
120516	1874	27640000
120520	1395	58245031057957278
120521	1395	58245031059957278
120536	1711	13386951000000
120537	1711	13386985000000
120543	2314	121000000000
120544	1692	460530619999
120545	2314	123000000000
120546	2314	244000000000
120547	2314	360000000000
120548	2314	490000000000
120549	2314	551000000000
120550	1508	11721659156616
120551	1874	27103000
120552	1508	12441659156616
120553	1508	12441668156616
120620	1397	1289745109000
120621	1678	26640839991000
120622	2133	91813268000
120623	1874	27684000
120624	2134	85229992000
120625	1874	27687000
120626	1679	28799403653000
120636	1395	58245751062957278
120657	1397	1289715106000
120658	1678	26640839994000
120659	2133	91810262000
120660	1874	27700000
120661	2134	85226983000
120662	1874	27703000
120663	1710	11034010664140
120664	1710	11034022664140
120666	1397	1289705105000
120667	1678	26640839995000
120668	2134	85225980000
120669	1874	27706000
120670	2132	147519532000
120671	1874	27707000
120672	2133	91809260000
120673	1874	27709000
120682	1874	27712000
120683	1613	11377350200000
120684	1613	11377361200000
120722	1397	1289645099000
120723	1678	26640840001000
120724	1397	1289635098000
120725	1678	26640840002000
120726	1397	1289625097000
120727	1678	26640840003000
120728	2133	91803248000
120729	1874	27737000
120730	2132	147517530000
120731	1874	27738000
120732	2133	91802246000
120733	1874	27740000
120734	2133	91801244000
120735	1874	27742000
120736	2134	85219962000
120737	1874	27745000
120738	2134	85218959000
120739	1874	27748000
120740	2134	85217956000
120741	1874	27751000
120742	1714	9645587171760
120743	1714	9645624171760
120780	1623	71283179899898
120796	1588	14401787000000
120797	1588	14401813000000
120807	1397	1289555090000
120808	1678	26640840010000
120809	2134	85210935000
120810	1874	27786000
120811	2133	91794230000
120812	1874	27788000
120813	1394	756012273440200
120814	1394	756012285440200
120321	1678	26640839960000
120322	2133	91843328000
120323	1874	27522000
120324	2134	85261085000
120325	1874	27525000
120326	606	73966680286230
120327	606	73966692286230
120329	1397	1290045139000
120330	1678	26640839961000
120331	2132	147529542000
120332	1874	27526000
120333	2134	85260082000
120334	1874	27529000
120382	1397	1289985133000
120383	1678	26640839967000
120384	2134	85254064000
120385	1874	27558000
120386	2133	91837316000
120387	1874	27560000
120411	1397	1289945129000
120412	1678	26640839971000
120413	2134	85250052000
120414	1874	27579000
120415	2132	147526539000
120416	1874	27580000
120417	2133	91833308000
120418	1874	27582000
120419	1422	11754694804270
120420	1422	11754707804270
120423	1690	169925598000000
120439	1397	1289915126000
120440	1678	26640839974000
120441	2133	91830302000
120442	1874	27594000
120443	2134	85247043000
120444	1874	27597000
120445	1698	11588932550062
120446	1698	11588944550062
120447	1397	1289905125000
120448	1678	26640839975000
120449	2134	85246040000
120450	1874	27600000
120451	2133	91829300000
120452	1874	27602000
120453	2132	147525538000
120454	1874	27603000
120517	1874	27637000
120518	1874	27639000
120519	1560	13688804131803
120522	1397	1289825117000
120523	1678	26640839983000
120524	1397	1289815116000
120525	1678	26640839984000
120526	2134	85238016000
120527	1874	27643000
120528	2134	85237013000
120529	1874	27646000
120530	2133	91821284000
120531	1874	27648000
120532	2133	91820282000
120533	1874	27650000
120534	1394	753132228500000
120535	1394	753132262500000
120541	1395	58245751059957278
120542	1395	58245751063957278
120570	1476	10800230000000
120573	1549	10511451000000
120574	1874	27612000
120575	1874	27614000
120576	1874	27618000
120577	1874	27622000
120578	1874	27626000
120579	1874	27628000
120580	1874	27630000
120581	1874	27632000
120582	1874	27641000
120583	1874	27644000
120584	1874	27647000
120585	1549	11231451000000
120586	1549	11231482000000
120595	1397	1289775112000
120596	1678	26640839988000
120597	2134	85233001000
120598	1874	27669000
120599	2133	91816274000
120600	1874	27671000
120601	2132	147521534000
120602	1874	27672000
120603	1684	19443300819412
120618	1672	9361397000000
120619	1672	9361421000000
120627	1397	1289735108000
120628	1678	26640839992000
120629	2132	147520533000
120630	1874	27688000
120631	2134	85228989000
120632	1874	27691000
120633	2133	91812266000
120634	1874	27693000
120635	1695	8585106999000
120675	1397	1289695104000
120676	1678	26640839996000
120677	2133	91808258000
120678	1874	27711000
120679	2134	85224977000
120680	1874	27714000
120681	1467	3760253272869
120705	1395	58245751094957278
120714	1397	1289655100000
120715	1678	26640840000000
120716	2134	85220965000
120717	1874	27733000
120718	2133	91804250000
120719	1874	27735000
120720	1688	60479027720020
120721	1688	60479039720020
120775	2134	85214947000
120776	1874	27765000
120777	1874	27767000
120778	1694	14218998197225
120779	1694	14219010197225
120781	1397	1289585093000
120782	1678	26640840007000
120783	1397	1289575092000
120784	1678	26640840008000
120785	2134	85213944000
120786	1874	27770000
120787	2134	85212941000
120788	1874	27773000
120789	2133	91797236000
120790	1874	27775000
120791	2133	91796234000
120792	1874	27777000
120793	2132	147515528000
120794	1874	27778000
120795	1768	15586760110000
120821	1397	1289535088000
120822	1678	26640840012000
120823	2133	91792226000
120824	1874	27792000
120825	2132	147514527000
120826	1874	27796000
120827	2134	85208929000
120828	1874	27799000
120829	1679	29519403653000
120830	1679	29519417653000
120859	1740	11970823000000
120952	2134	85199902000
120953	1874	27842000
120954	1874	27844000
120955	1874	27846000
120956	1547	9354804000000
120977	1702	6480558000000
120978	1397	1289405075000
120979	1678	26640840025000
120980	2132	147510523000
120981	1874	27857000
120982	2133	91779200000
120983	1874	27859000
121002	1397	1289375072000
121003	1678	26640840028000
121004	2132	147509522000
121005	1874	27864000
121006	2133	91776194000
121007	1874	27866000
121008	1397	1289365071000
121009	1678	26640840029000
121010	2133	91775192000
121011	1874	27868000
121012	1693	2870931570272
121034	1397	1289325067000
121035	1678	26640840033000
121036	2133	91771184000
121037	1874	27877000
121038	1394	757452285440200
121039	1394	757452296440200
121047	1597	727012000000
121080	1394	757452295440200
121081	1397	1289255060000
121082	1678	26640840040000
121083	2133	91765172000
121084	1874	27891000
121085	1688	61199039720020
121086	1688	61199050720020
121115	1650	8032989000000
120560	2132	147522535000
120561	1874	27656000
120562	1850	14376430949999
120563	1850	14376443949999
120637	1397	1289725107000
120638	1678	26640839993000
120639	2134	85227986000
120640	1874	27696000
120641	2133	91811264000
120642	1874	27698000
120665	2039	12859591000000
120674	1395	58245751072957278
120685	1613	11377362200000
120744	1397	1289615096000
120745	1678	26640840004000
120746	1394	753132272500000
120747	2133	91800242000
120748	1874	27753000
120749	2134	85216953000
120750	1874	27756000
120751	1855	200003280
120752	1394	754572272499900
120753	1855	66720043910000
120754	646	200003680
120755	1514	754572273440200
120756	1394	9099700
120759	1397	1289605095000
120760	1678	26640840005000
120761	2133	91799240000
120762	1874	27758000
120763	2132	147516529000
120764	1874	27759000
120765	2134	85215950000
120766	1874	27762000
120767	1685	162003993571430
120768	1685	162004006571430
120798	171	75306786696494
120799	1397	1289565091000
120800	1678	26640840009000
120801	2134	85211938000
120802	1874	27781000
120803	2133	91795232000
120804	1874	27783000
120805	1723	11522082085979
120806	1723	11522094085979
120832	2086	2160369300069
120918	2306	1439048000000
120932	1874	27805000
120933	1874	27807000
120934	1874	27810000
120935	1874	27813000
120936	1874	27824000
120937	1874	27827000
120938	1874	27830000
120939	2134	85200905000
120940	1874	27839000
120941	1649	10551633999968
120975	1703	4320874000000
120976	1703	4320908000000
121001	1560	13688806131803
121017	1397	1289345069000
121018	1678	26640840031000
121019	2133	91773188000
121020	1874	27872000
121021	1546	10317444800000
121022	1397	1289335068000
121023	1678	26640840032000
121024	1623	70563179899898
121025	2133	91772186000
121026	1874	27874000
121027	2132	147508521000
121028	1874	27875000
121029	1855	200003780
121030	1623	71283179899798
121031	1855	204000000
121032	2250	200004980
121033	1623	71283180898598
121045	369	77316549290830
121046	369	77316560290830
121048	1397	1289305065000
121049	1678	26640840035000
121050	1397	1289295064000
121051	1678	26640840036000
121052	1397	1289285063000
121053	1678	26640840037000
121054	2132	147507520000
121055	1874	27878000
121056	1874	27880000
121057	2133	91769180000
121058	1874	27882000
121059	2133	91768178000
121060	1874	27884000
121061	2133	91767176000
121062	1874	27886000
121063	1439	10063735578477
121067	2317	254745211465
121068	1397	1289275062000
121069	1678	26640840038000
121070	2133	91766174000
121071	1874	27888000
121072	2132	147506519000
121073	1874	27889000
121074	1601	4705835620000
121076	1397	1289265061000
121077	1678	26640840039000
121078	1671	11184125003785
121079	1671	11184135003785
121107	1587	10800348000000
121108	1587	10800371000000
121109	1397	1289215056000
121110	1678	26640840044000
121111	2133	91761164000
121112	1874	27900000
121113	1692	1900542619999
121114	1692	1900553619999
121131	1397	1289185053000
121132	1678	26640840047000
121133	2133	91758158000
121134	1874	27907000
121135	1522	9403677000000
121136	1522	9403688000000
121147	1698	11588943550062
121174	1397	1289135048000
121175	1678	26640840052000
121176	2132	147502515000
121177	1874	27917000
121178	2133	91753148000
121179	1874	27919000
121180	1594	14401840000000
121191	2133	91751144000
121192	1874	27923000
121193	1637	298807175819988
121194	1637	298807186819988
121201	1397	1289095044000
121202	1678	26640840056000
121203	1714	10365624171760
121204	1714	10365634171760
121208	1397	1289085043000
121209	1678	26640840057000
121210	2133	91748138000
121211	1874	27930000
121219	1474	7110465000043
121220	1474	7110476000043
121284	1397	1288985033000
121285	1678	26640840067000
121286	2134	85192881000
121287	1874	27971000
121288	2133	91737116000
121289	1874	27973000
121290	1705	19280884580140
121291	1705	19280896580140
121358	1397	1288895024000
121359	1678	26640840076000
121360	2133	91728098000
121361	1874	28012000
121362	1874	28015000
121363	1874	28018000
121364	2134	85183854000
121365	1874	28021000
121366	1394	763212341440200
121367	1394	763212375440200
121387	1715	7223531663945
121396	1397	1288855020000
121397	1678	26640840080000
121398	1397	1288845019000
121399	1678	26640840081000
121400	2133	91724090000
121401	1874	28036000
121402	2133	91723088000
121403	1874	28038000
121404	2132	147493506000
121405	1874	28039000
121406	1874	28042000
121407	2134	85179842000
121408	1874	28045000
121409	2134	85178839000
121410	1874	28048000
121411	1536	15840314000000
121412	1536	15840340000000
121413	1513	34561203000000
121429	1397	1288815016000
121430	1678	26640840084000
121431	1397	1288805015000
121432	1678	26640840085000
121433	1397	1288795014000
120831	1699	2880332750126
120860	1874	27556000
120861	1874	27559000
120862	1874	27562000
120863	1874	27571000
120864	1874	27574000
120865	1874	27578000
120866	1740	11251306000000
120867	1874	27584000
120868	1874	27586000
120869	1874	27587000
120870	1874	27589000
120871	1874	27591000
120872	1874	27593000
120873	1874	27595000
120874	1874	27596000
120875	1874	27598000
120876	1874	27599000
120877	1874	27601000
120878	1874	27607000
120879	1874	27609000
120880	1874	27617000
120881	1874	27623000
120882	1874	27625000
120883	1874	27633000
120884	1874	27645000
120885	1874	27649000
120886	1874	27651000
120887	1874	27659000
120888	1874	27663000
120889	1874	27665000
120890	1874	27667000
120891	1874	27673000
120892	1874	27679000
120893	1874	27681000
120894	1874	27685000
120895	1740	11971306000000
120896	1740	11971369000000
120897	1397	1289495084000
120898	1678	26640840016000
120899	1397	1289485083000
120900	1678	26640840017000
120901	1397	1289475082000
120902	1678	26640840018000
120903	2132	147512525000
120904	1874	27816000
120905	2133	91788218000
120906	1874	27818000
120907	2133	91787216000
120908	1874	27820000
120909	2133	91786214000
120910	1874	27822000
120911	2134	85204917000
120912	1874	27825000
120913	2134	85203914000
120914	1874	27828000
120915	2134	85202911000
120916	1874	27831000
120917	1440	6480266045924
120919	1397	1289465081000
120920	1678	26640840019000
120921	2133	91785212000
120922	1874	27833000
120923	2134	85201908000
120924	1874	27836000
120925	1546	10317433800000
120926	1546	10317445800000
120928	2112	19966906101924
120957	1547	9354802000000
120984	484	74013912000000
120985	484	74013924000000
120987	1397	1289395074000
120988	1678	26640840026000
120989	1397	1289385073000
120990	1678	26640840027000
120991	2058	527500000
120992	2317	254755211465
120993	2133	91778198000
120994	1874	27861000
120995	2152	106998999000000
120996	2318	0
120997	2133	91777196000
120998	1874	27863000
120999	1594	14401828000000
121000	1594	14401855000000
121013	1397	1289355070000
121014	1678	26640840030000
121015	2133	91774190000
121016	1874	27870000
121040	42	72140637000000
121066	1560	14408840131803
121075	1395	58245751081957278
121087	1738	2878934000000
121088	1738	2878945000000
121116	2132	147504517000
121117	1874	27901000
121118	2133	91760162000
121119	1874	27903000
121120	1395	58245751061957278
121121	1397	1289205055000
121122	1678	26640840045000
121123	1397	1289195054000
121124	1678	26640840046000
121125	2133	91759160000
121126	1874	27905000
121127	1402	30423015145435
121128	1402	30423036145435
121139	1874	27604000
121140	1874	27610000
121141	1522	8683722000000
121142	1874	27652000
121143	1522	9403721999900
121144	1855	9403728999100
121145	1522	200004080
121149	1397	1289175052000
121150	1678	26640840048000
121151	1397	1289165051000
121152	1678	26640840049000
121153	2133	91757156000
121154	1874	27909000
121155	2132	147503516000
121156	1874	27910000
121157	2133	91756154000
121158	1874	27912000
121159	2152	106988998000000
121160	2318	10000000000
121161	1695	9305106999000
121162	1695	9305130999000
121181	1397	1289125047000
121182	1678	26640840053000
121183	2133	91752146000
121184	1874	27921000
121185	1637	298087164819988
121186	1637	298087175819988
121218	526	73920290000000
121221	1397	1289065041000
121222	1678	26640840059000
121223	2132	147500513000
121224	1874	27933000
121225	2133	91746134000
121226	1874	27935000
121227	2133	91745132000
121228	1874	27937000
121229	1395	58246471061957278
121230	1395	58246471074957278
121254	1397	1289015036000
121255	1678	26640840064000
121256	2134	85195890000
121257	1874	27955000
121258	2133	91740122000
121259	1874	27957000
121260	2132	147498511000
121261	1874	27958000
121262	1506	7200204967172
121263	1506	7200217967172
121292	1397	1288975032000
121293	1678	26640840068000
121294	2132	147497510000
121295	1874	27974000
121296	2134	85191878000
121297	1874	27977000
121298	2133	91736114000
121299	1874	27979000
121300	1690	170645598000000
121301	1690	170645611000000
121318	1397	1288945029000
121319	1678	26640840071000
121320	1397	1288935028000
121321	1678	26640840072000
121322	2132	147496509000
121323	1874	27990000
121324	2133	91733108000
121325	1874	27992000
121326	2133	91732106000
121327	1874	27994000
121328	2134	85188869000
121329	1874	27997000
121330	2134	85187866000
121331	1874	28000000
121332	1467	4480241272869
121333	1467	4480266272869
121388	1397	1288865021000
121389	1678	26640840079000
121390	2133	91725092000
121391	1874	28034000
120850	1874	27806000
120851	2134	85207926000
120852	1874	27809000
120853	2134	85206923000
120854	1874	27812000
120855	2134	85205920000
120856	1874	27815000
120857	1679	30239417653000
120858	1679	30239464653000
120927	2112	19966905101924
120929	1692	1180568619999
120930	1649	11272599887768
120931	1649	11272709887768
120942	1397	1289455080000
120943	1678	26640840020000
120944	1397	1289445079000
120945	1678	26640840021000
120946	2058	529500000
120947	2133	91784210000
120948	1874	27838000
120949	2133	91783208000
120950	1874	27840000
120951	1649	10551560999968
120958	1397	1289435078000
120959	1678	26640840022000
120960	1397	1289425077000
120961	1678	26640840023000
120962	1397	1289415076000
120963	1678	26640840024000
120964	2133	91782206000
120965	1874	27848000
120966	2133	91781204000
120967	1874	27850000
120968	2133	91780202000
120969	1874	27852000
120970	2132	147511524000
120971	1874	27853000
120972	2134	85198899000
120973	1874	27856000
120974	1588	14401822000000
120986	1657	5761277990100
121041	1397	1289315066000
121042	1678	26640840034000
121043	2133	91770182000
121044	1874	27879000
121064	1560	14408806131803
121065	1560	14408851131803
121089	1397	1289245059000
121090	1678	26640840041000
121091	2133	91764170000
121092	1874	27893000
121093	1402	29703004145435
121094	1402	29703015145435
121095	1397	1289235058000
121096	1678	26640840042000
121097	1397	1289225057000
121098	1678	26640840043000
121099	2133	91763168000
121100	1874	27895000
121101	2133	91762166000
121102	1874	27897000
121103	2132	147505518000
121104	1874	27898000
121105	1394	758892295440200
121106	1394	758892318440200
121129	1471	12905389900000
121130	1471	12905410900000
121146	1451	4027770000000
121163	1397	1289155050000
121164	1678	26640840050000
121165	1397	1289145049000
121166	1678	26640840051000
121167	2316	498999000000
121168	2319	299000000000
121169	2133	91755152000
121170	1874	27914000
121171	2133	91754150000
121172	1874	27916000
121173	1457	11520221800000
121187	1397	1289115046000
121188	1678	26640840054000
121189	1634	13343051259504
121190	1634	13343061259504
121195	1397	1289105045000
121196	1678	26640840055000
121197	2132	147501514000
121198	1874	27924000
121199	2133	91750142000
121200	1874	27926000
121231	1397	1289055040000
121232	1678	26640840060000
121233	1397	1289045039000
121234	1678	26640840061000
121235	1397	1289035038000
121236	1678	26640840062000
121237	2132	147499512000
121238	1874	27938000
121239	2134	85197896000
121240	1874	27941000
121241	2133	91744130000
121242	1874	27943000
121243	2133	91743128000
121244	1874	27945000
121245	2133	91742126000
121246	1874	27947000
121247	1688	61199074720020
121264	2307	1439048000000
121273	1637	299527186819988
121274	1637	299527198819988
121282	1685	162724006571430
121283	1685	162724018571430
121302	1397	1288965031000
121303	1678	26640840069000
121304	2134	85190875000
121305	1874	27982000
121306	2133	91735112000
121307	1874	27984000
121308	1690	171365611000000
121309	1690	171365623000000
121334	1397	1288925027000
121335	1678	26640840073000
121336	2133	91731104000
121337	1874	28002000
121338	2134	85186863000
121339	1874	28005000
121340	1724	11214723500000
121341	1724	11214735500000
121369	1397	1288885023000
121370	1678	26640840077000
121371	2134	85182851000
121372	1874	28024000
121373	2133	91727096000
121374	1874	28026000
121375	1756	8480871195609
121376	1756	8480883195609
121377	1397	1288875022000
121378	1678	26640840078000
121379	2134	85181848000
121380	1874	28029000
121381	2133	91726094000
121382	1874	28031000
121383	2132	147494507000
121384	1874	28032000
121385	1536	15120301000000
121386	1536	15120314000000
121393	2134	85180845000
121394	1874	28037000
121395	1649	10551548999968
121414	1397	1288835018000
121415	1678	26640840082000
121416	2133	91722086000
121417	1874	28050000
121418	2134	85177836000
121419	1874	28053000
121420	1633	7968635125277
121421	1397	1288825017000
121422	1678	26640840083000
121423	2133	91721084000
121424	1874	28055000
121425	2134	85176833000
121426	1874	28058000
121427	1549	11231371000000
121428	1549	11231383000000
121459	1397	1288775012000
121460	1678	26640840088000
121461	2133	91716074000
121462	1874	28081000
121463	2132	147491504000
121464	1874	28082000
121465	2134	85171818000
121466	1874	28085000
121467	1539	720014000000
121490	2134	85168809000
121491	1874	28100000
121492	1874	28101000
121493	1694	14219011197225
121502	1541	5042326000000
121505	1718	7458584519070
121506	1718	7458596519070
121517	1402	30423027145435
121562	1874	28114000
121563	1874	28116000
121564	1395	58247911087957278
121565	1395	58247911120957278
121595	1397	1288655000000
121137	1394	760332318440200
121138	1394	760332329440200
121148	1698	11588933550062
121205	2133	91749140000
121206	1874	27928000
121207	1714	10365635171760
121212	1397	1289075042000
121213	1678	26640840058000
121214	2133	91747136000
121215	1874	27932000
121216	43	73200078890000
121217	43	73200089890000
121248	1397	1289025037000
121249	1678	26640840063000
121250	2134	85196893000
121251	1874	27950000
121252	2133	91741124000
121253	1874	27952000
121265	1397	1289005035000
121266	1678	26640840065000
121267	2133	91739120000
121268	1874	27960000
121269	2134	85194887000
121270	1874	27963000
121271	1447	18281851683000
121272	1447	18281863683000
121275	1397	1288995034000
121276	1678	26640840066000
121277	2134	85193884000
121278	1874	27966000
121279	2133	91738118000
121280	1874	27968000
121281	1596	5760132000000
121310	1397	1288955030000
121311	1678	26640840070000
121312	2133	91734110000
121313	1874	27986000
121314	2134	85189872000
121315	1874	27989000
121316	1394	761772329440200
121317	1394	761772341440200
121342	1397	1288915026000
121343	1678	26640840074000
121344	1397	1288905025000
121345	1678	26640840075000
121346	2133	91730102000
121347	1874	28007000
121348	2133	91729100000
121349	1874	28009000
121350	2132	147495508000
121351	1874	28010000
121352	2134	85185860000
121353	1874	28013000
121354	2134	85184857000
121355	1874	28016000
121356	1709	5760142000000
121357	1709	5760120000000
121368	1756	7760871195609
121457	1705	20000896580140
121458	1705	20000945580140
121482	1596	5040144000000
121483	1596	5760144000000
121495	1397	1288735008000
121496	1678	26640840092000
121497	2133	91712066000
121498	1874	28103000
121499	2134	85167806000
121500	1874	28106000
121501	369	77316561290830
121503	610	66720000000000
121504	610	66720012000000
121515	2112	20686906101924
121516	2112	20686918101924
121541	1397	1288715006000
121542	1678	26640840094000
121543	1397	1288705005000
121544	1678	26640840095000
121545	1397	1288695004000
121546	1678	26640840096000
121547	2132	147489502000
121548	1874	28112000
121549	2134	85165800000
121550	1874	28115000
121551	2134	85164797000
121552	1874	28118000
121553	1874	28120000
121554	2133	91709060000
121555	1874	28122000
121556	2133	91708058000
121557	1874	28124000
121558	2134	85163794000
121559	1874	28127000
121560	42	72860637000000
121561	42	72860674000000
121566	1474	7830678000043
121567	1874	28107000
121568	1874	28110000
121569	1474	8550678000043
121570	1474	8550697000043
121587	1397	1288665001000
121588	1678	26640840099000
121589	2133	91705052000
121590	1874	28140000
121591	2134	85160785000
121592	1874	28143000
121593	1571	8540628124154
121594	1571	8540640124154
121626	641	76803896000000
121641	1693	3590931570272
121642	1693	3590943570272
121664	1397	1288594994000
121665	1678	26640840106000
121666	2133	91697036000
121667	1874	28182000
121668	2134	85152761000
121669	1874	28185000
121670	1395	58247191086957278
121688	1690	172085635000000
121705	1602	11376659170000
121708	1746	2688912000000
121710	1397	1288544989000
121711	1678	26640840111000
121712	2134	85147746000
121713	1874	28210000
121714	2133	91692026000
121715	1874	28212000
121716	1672	9361409000000
121752	1397	1288504985000
121753	1678	26640840115000
121754	1596	5040130000000
121755	2133	91688018000
121756	1874	28230000
121757	2134	85143734000
121758	1874	28233000
121759	1596	5760130000000
121760	1527	5760130000002
121761	1596	289999960
121805	1397	1288474982000
121806	1678	26640840118000
121807	1439	10783735578477
121808	1439	10783749578477
121810	1397	1288464981000
121811	1678	26640840119000
121812	2320	999000000
121813	2133	91684010000
121814	1874	28251000
121815	2134	85139722000
121816	1874	28254000
121817	1690	172805637000000
121818	1690	172805650000000
121861	1397	1288424977000
121862	1678	26640840123000
121863	2133	91680002000
121864	1874	28272000
121865	2134	85135710000
121866	1874	28275000
121880	1649	11271547999968
121881	1649	11271560999968
121892	1397	1288394974000
121893	1678	26640840126000
121894	2134	85132701000
121895	1874	28289000
121896	2133	91676996000
121897	1874	28291000
121898	1457	12240243800000
121932	1397	1288344969000
121933	1678	26640840131000
121934	2133	91671986000
121935	1874	28315000
121936	2134	85127686000
121937	1874	28318000
121989	1714	11805636171760
121990	1714	11805674171760
122011	1397	1288274962000
122012	1678	26640840138000
122013	1670	7921011000000
122014	1759	8137245139889
122015	1315	1711655347751650
122016	2134	85120665000
122017	1874	28353000
122018	2133	91664972000
122019	1874	28355000
122020	1670	8641011000000
122021	697	8641011500003
122022	1670	66000000499999
121392	1649	10551547999968
121484	1397	1288745009000
121485	1678	26640840091000
121486	2133	91713068000
121487	1874	28097000
121488	2132	147490503000
121489	1874	28098000
121518	526	73920291000000
121520	1419	21886129559750
121521	1419	21886141559750
121571	1397	1288685003000
121572	1678	26640840097000
121573	2133	91707056000
121574	1874	28129000
121575	2134	85162791000
121576	1874	28132000
121577	1394	763212353440200
121601	2134	85158779000
121602	1874	28151000
121603	2132	147487500000
121604	1874	28152000
121605	2133	91703048000
121606	1874	28154000
121607	1680	10813319499559
121608	1680	10813322499559
121643	2039	13579591000000
121644	2039	13579603000000
121655	1419	21886142559750
121730	2248	10799522000000
121739	1560	14408818131803
121783	1874	28184000
121784	1874	28189000
121785	1874	28193000
121786	1874	28195000
121787	1874	28197000
121788	1874	28201000
121789	1874	28213000
121790	1874	28216000
121791	1874	28219000
121792	1874	28231000
121793	1874	28234000
121794	1874	28237000
121795	1874	28239000
121796	1637	299527336819988
121809	1622	3923925800048
121819	2320	775742211465
121820	1397	1288454980000
121821	1678	26640840120000
121822	2134	85138719000
121823	1874	28257000
121824	2132	147481494000
121825	1874	28258000
121826	2133	91683008000
121827	1874	28260000
121828	2026	75199000000
121829	1671	11184150003785
121832	1749	17285613529980
121834	1397	1288444979000
121835	1678	26640840121000
121836	2134	85137716000
121837	1874	28263000
121838	2133	91682006000
121839	1874	28265000
121840	1394	766092366440200
121841	1394	766092378440200
121850	1397	1288434978000
121851	1678	26640840122000
121852	2320	775741211465
121853	2134	85136713000
121854	1874	28268000
121855	2133	91681004000
121856	1874	28270000
121857	1622	4643925800048
121858	1622	4643938800048
121890	1395	58248631112957278
121917	1397	1288364971000
121918	1678	26640840129000
121919	2134	85129692000
121920	1874	28305000
121921	2133	91673990000
121922	1874	28307000
121938	1397	1288334968000
121939	1678	26640840132000
121940	2133	91670984000
121941	1874	28320000
121942	2134	85126683000
121943	1874	28323000
121944	1691	9791096300052
121945	1691	9791108300052
121954	1397	1288314966000
121955	1678	26640840134000
121956	1397	1288304965000
121957	1678	26640840135000
121958	1397	1288294964000
121959	1678	26640840136000
121960	1874	28303000
121961	1759	23508329289889
121962	949	508024693710000
121963	1874	28306000
121964	1874	28309000
121965	1874	28312000
121966	2134	85124677000
121967	1874	28321000
121968	2134	85123674000
121969	1874	28324000
121970	2134	85122671000
121971	1874	28327000
121972	2132	147477490000
121973	1874	28330000
121974	1874	28332000
121975	1874	28334000
121976	1874	28336000
121977	1874	28338000
121978	2133	91668980000
121979	1874	28340000
121980	2133	91667978000
121981	1874	28342000
121982	2133	91666976000
121983	1874	28344000
121984	1716	2160134000000
121993	1716	2160061000000
121995	1397	1288284963000
121996	1678	26640840137000
121997	2133	91665974000
121998	1874	28346000
121999	2132	147476489000
122000	1874	28347000
122001	1759	20590886789889
122002	1189	614247191500000
122003	1759	16266956139889
122004	1069	910373894650000
122005	2134	85121668000
122006	1874	28350000
122007	1678	27360840137000
122008	1678	27360855137000
122039	1397	1288254960000
122040	1678	26640840140000
122041	1397	1288244959000
122042	1678	26640840141000
122043	2133	91662968000
122044	1874	28362000
122045	2134	85118659000
122046	1874	28365000
122047	2134	85117656000
122048	1874	28368000
122049	2133	91661966000
122050	1874	28370000
122051	1764	24606459100000
122052	968	507359775000000
122053	2132	147475488000
122054	1874	28371000
122055	1685	163444018571430
122056	1685	163444044571430
122066	1688	63359098720020
122067	1688	63359110720020
122095	1397	1288224957000
122096	1678	26640840143000
122097	1397	1288214956000
122098	1678	26640840144000
122099	2133	91659962000
122100	1874	28378000
122101	2132	147474487000
122102	1874	28379000
122103	2134	85115650000
122104	1874	28382000
122105	2133	91658960000
122106	1874	28384000
122107	2134	85114647000
122108	1874	28387000
122109	1762	8565610994000
122112	632	76797600000000
122113	632	76797625000000
122182	1397	1288124947000
122183	1678	26640840153000
122184	2134	85105620000
122185	1874	28432000
122186	2133	91649942000
122187	1874	28434000
122188	1690	173525662000000
122211	1715	7943533663945
122212	1715	7943546663945
122219	1685	164164044571430
122220	1685	164164056571430
122231	1476	10800231000000
122273	1397	1288044939000
121434	1678	26640840086000
121435	1397	1288785013000
121436	1678	26640840087000
121437	2134	85175830000
121438	1874	28061000
121439	2134	85174827000
121440	1874	28064000
121441	2134	85173824000
121442	1874	28067000
121443	2134	85172821000
121444	1874	28070000
121445	2132	147492505000
121446	1874	28071000
121447	2133	91720082000
121448	1874	28073000
121449	2133	91719080000
121450	1874	28075000
121451	2133	91718078000
121452	1874	28077000
121453	2133	91717076000
121454	1874	28079000
121455	58	72467319999641
121456	58	72467368999641
121468	1397	1288765011000
121469	1678	26640840089000
121470	1397	1288755010000
121471	1678	26640840090000
121472	2133	91715072000
121473	1874	28087000
121474	2134	85170815000
121475	1874	28090000
121476	2134	85169812000
121477	1874	28093000
121478	2133	91714070000
121479	1874	28095000
121480	1696	15563752335104
121481	1696	16283752335104
121494	1670	8641014000000
121507	1397	1288725007000
121508	1678	26640840093000
121509	2134	85166803000
121510	1874	28109000
121511	2133	91711064000
121512	1874	28111000
121513	1547	10074804000000
121514	1547	10074816000000
121519	2112	20686908101924
121522	1874	28040000
121523	1874	28043000
121524	1874	28044000
121525	1874	28046000
121526	1874	28049000
121527	1874	28052000
121528	1874	28076000
121529	1874	28088000
121530	1874	28092000
121531	1874	28094000
121532	1874	28096000
121533	1874	28102000
121534	1874	28104000
121535	1474	7830476000043
121536	1474	7830648000043
121537	2133	91710062000
121538	1874	28113000
121539	1395	58247191074957278
121540	1395	58247191087957278
121578	1397	1288675002000
121579	1678	26640840098000
121580	2134	85161788000
121581	1874	28135000
121582	2133	91706054000
121583	1874	28137000
121584	2132	147488501000
121585	1874	28138000
121586	1717	14221277000055
121623	1394	764652353440200
121624	1394	764652377440200
121627	1520	76805536999997
121628	641	100000019
121629	641	77525536999997
121630	2275	77525956999981
121631	641	200000014
121632	1964	100000028
121633	1520	200000001
121645	1397	1288614996000
121646	1678	26640840104000
121647	2132	147486499000
121648	1874	28170000
121649	2133	91699040000
121650	1874	28172000
121651	2134	85154767000
121652	1874	28175000
121653	1690	172085623000000
121654	1690	172085636000000
121656	1397	1288604995000
121657	1678	26640840105000
121658	2133	91698038000
121659	1874	28177000
121660	2134	85153764000
121661	1874	28180000
121662	1991	10701356355805
121663	1991	10701368355805
121680	1397	1288574992000
121681	1678	26640840108000
121682	2134	85150755000
121683	1874	28194000
121684	2133	91695032000
121685	1874	28196000
121686	1599	11096858097983
121687	1599	11096870097983
121689	1397	1288564991000
121690	1678	26640840109000
121691	1397	1288554990000
121692	1678	26640840110000
121693	2134	85149752000
121694	1874	28199000
121695	2132	147484497000
121696	1874	28200000
121697	2134	85148749000
121698	1874	28203000
121699	2133	91694030000
121700	1874	28205000
121701	2133	91693028000
121702	1874	28207000
121703	1444	10887819329999
121704	1444	10887844329999
121719	1706	13962172450256
121720	1706	13962184450256
121729	1716	2160035000000
121731	1397	1288524987000
121732	1678	26640840113000
121733	2134	85145740000
121734	1874	28220000
121735	2133	91690022000
121736	1874	28222000
121737	1688	61919074720020
121738	1688	61919086720020
121773	1397	1288484983000
121774	1678	26640840117000
121775	2133	91686014000
121776	1874	28240000
121777	2132	147482495000
121778	1874	28241000
121779	2119	190000000
121780	2134	85141728000
121781	1874	28244000
121782	1690	172085637000000
121797	2288	774754211465
121798	2320	1000000000
121799	2134	85140725000
121800	1874	28247000
121801	2133	91685012000
121802	1874	28249000
121803	1622	3923911800048
121804	1622	3923915800048
121830	1457	12240221800000
121831	1457	12240246800000
121833	1271	1350606509000000
121842	1637	299527376819988
121843	2320	775743211465
121844	1874	28245000
121845	1874	28248000
121846	1874	28250000
121847	1874	28252000
121848	1637	300247376819988
121849	1637	300247397819988
121871	1397	1288414976000
121872	1678	26640840124000
121873	2134	85134707000
121874	1874	28278000
121875	2132	147480493000
121876	1874	28279000
121877	2133	91679000000
121878	1874	28281000
121879	1711	13386964000000
121882	1397	1288404975000
121883	1678	26640840125000
121884	2133	91677998000
121885	1874	28283000
121886	2134	85133704000
121887	1874	28286000
121888	1714	11085634171760
121889	1714	11085646171760
121891	1714	11085636171760
121909	1397	1288374972000
121596	1678	26640840100000
121597	2134	85159782000
121598	1874	28146000
121599	2133	91704050000
121600	1874	28148000
121609	1397	1288644999000
121610	1678	26640840101000
121611	1397	1288634998000
121612	1678	26640840102000
121613	2133	91702046000
121614	1874	28156000
121615	2134	85157776000
121616	1874	28159000
121617	2134	85156773000
121618	1874	28162000
121619	2133	91701044000
121620	1874	28164000
121621	1571	9260640124154
121622	1571	9260664124154
121625	1395	58247191098957278
121634	1397	1288624997000
121635	1678	26640840103000
121636	2134	85155770000
121637	1874	28167000
121638	2133	91700042000
121639	1874	28169000
121640	1394	764652365440200
121671	1397	1288584993000
121672	1678	26640840107000
121673	2133	91696034000
121674	1874	28187000
121675	2134	85151758000
121676	1874	28190000
121677	2132	147485498000
121678	1874	28191000
121679	1394	764652366440200
121706	2292	1439013000000
121707	2292	1439038000000
121709	1747	2225979000000
121717	1710	11754022664140
121718	1710	11754034664140
121721	1397	1288534988000
121722	1678	26640840112000
121723	2133	91691024000
121724	1874	28214000
121725	2134	85146743000
121726	1874	28217000
121727	1654	15977471999798
121728	1654	15977483999798
121740	1397	1288514986000
121741	1678	26640840114000
121742	2133	91689020000
121743	1874	28224000
121744	2288	775756211465
121745	2320	0
121746	2132	147483496000
121747	1874	28225000
121748	2134	85144737000
121749	1874	28228000
121750	1395	58247911086957278
121751	1395	58247911100957278
121762	1397	1288494984000
121763	1678	26640840116000
121764	2133	91687016000
121765	1874	28235000
121766	2134	85142731000
121767	1874	28238000
121768	697	66000000499999
121769	1588	15121821500001
121770	697	15121822000016
121771	1588	66000003999992
121772	1527	297999952
121859	1395	58248631100957278
121860	1395	58248631113957278
121867	1874	28271000
121868	1874	28273000
121869	1637	300967397819988
121870	1637	300967423819988
121899	1397	1288384973000
121900	1678	26640840127000
121901	2133	91675994000
121902	1874	28293000
121903	2134	85131698000
121904	1874	28296000
121905	2132	147479492000
121906	1874	28297000
121907	1394	767532378440200
121908	1394	767532391440200
121923	1397	1288354970000
121924	1678	26640840130000
121925	2134	85128689000
121926	1874	28310000
121927	2132	147478491000
121928	1874	28311000
121929	2133	91672988000
121930	1874	28313000
121931	43	73200091890000
122024	1394	767532401440200
122025	1394	768972401440200
122026	1394	768972404440200
122027	2186	7693786
122028	2317	777595211465
122029	1397	1288264961000
122030	1678	26640840139000
122031	2134	85119662000
122032	1874	28358000
122033	2133	91663970000
122034	1874	28360000
122035	1709	7200120000000
122036	1709	7200232000000
122064	1564	11166689000000
122065	1564	11166701000000
122068	1874	28108000
122069	1874	28130000
122070	1874	28133000
122071	1874	28136000
122072	1874	28139000
122073	1874	28141000
122074	1874	28142000
122075	1874	28144000
122076	1874	28145000
122077	1874	28147000
122078	1874	28149000
122079	1874	28150000
122080	1874	28153000
122081	1874	28155000
122082	1874	28157000
122083	1874	28161000
122084	1874	28163000
122085	1874	28165000
122086	1874	28171000
122087	1874	28173000
122088	1874	28179000
122089	1874	28181000
122090	1874	28183000
122091	1874	28209000
122092	1874	28211000
122093	470	75361002000000
122094	470	76081002000000
122152	1397	1288154950000
122153	1678	26640840150000
122154	2133	91652948000
122155	1874	28415000
122156	2134	85108629000
122157	1874	28418000
122158	1402	31143027145435
122159	1402	31143039145435
122160	632	77517625000000
122161	632	77517637000000
122162	1718	8178596519070
122163	1718	8178608519070
122174	1397	1288134948000
122175	1678	26640840152000
122176	2133	91650944000
122177	1874	28426000
122178	2134	85106623000
122179	1874	28429000
122180	1394	770412404440200
122181	1394	770412416440200
122202	1397	1288104945000
122203	1678	26640840155000
122204	2133	91647938000
122205	1874	28442000
122206	2134	85103614000
122207	1874	28445000
122208	1764	11602456100000
122209	1208	613443250000000
122210	1522	9403690000000
122244	1397	1288064941000
122245	1678	26640840159000
122246	2133	91643930000
122247	1874	28463000
122248	2134	85099602000
122249	1874	28466000
122250	1608	12378492000000
122251	1608	12378506000000
122258	1874	28464000
122259	1694	15659036197225
122291	1397	1288034938000
122292	1678	26640840162000
122293	1397	1288024937000
122294	1678	26640840163000
122295	2133	91640924000
122296	1874	28479000
122297	2133	91639922000
121910	1678	26640840128000
121911	2134	85130695000
121912	1874	28300000
121913	2133	91674992000
121914	1874	28302000
121915	1688	62639086720020
121916	1688	62639098720020
121946	1397	1288324967000
121947	1678	26640840133000
121948	2134	85125680000
121949	1874	28326000
121950	2133	91669982000
121951	1874	28328000
121952	1601	5425835620000
121953	1601	5425847620000
121985	1874	28337000
121986	1874	28343000
121987	1701	13678349500103
121988	1701	13678387500103
121991	2248	11519522000000
121992	2248	11519560000000
121994	1714	11805644171760
122009	1681	12851351909853
122010	1681	12851366909853
122114	1397	1288204955000
122115	1678	26640840145000
122116	2133	91657958000
122117	1874	28389000
122118	2134	85113644000
122119	1874	28392000
122120	1694	14939011197225
122121	1694	14939023197225
122138	1397	1288174952000
122139	1678	26640840148000
122140	1397	1288164951000
122141	1678	26640840149000
122142	2133	91654952000
122143	1874	28405000
122144	1769	1572700000
122145	2134	85110635000
122146	1874	28408000
122147	2134	85109632000
122148	1874	28411000
122149	2133	91653950000
122150	1874	28413000
122151	1593	12912740000000
122213	1397	1288094944000
122214	1678	26640840156000
122215	2133	91646936000
122216	1874	28447000
122217	2134	85102611000
122218	1874	28450000
122221	1397	1288084943000
122222	1678	26640840157000
122223	2132	147470483000
122224	1874	28451000
122225	2133	91645934000
122226	1874	28453000
122227	2134	85101608000
122228	1874	28456000
122229	1768	16306760110000
122230	1768	16306773110000
122240	1696	17003752335104
122241	1696	17003764335104
122254	1694	15659023197225
122255	1694	15659037197225
122261	1397	1288054940000
122262	1678	26640840160000
122263	1933	1819268000000
122264	1749	18468588529980
122265	2134	85098599000
122266	1874	28469000
122267	2133	91642928000
122268	1874	28471000
122269	1749	15963587529980
122270	961	507418275000000
122271	1622	5363938800048
122272	1622	5363952800048
122285	1657	5761279990100
122287	1634	13343065259504
122309	1397	1288014936000
122310	1678	26640840164000
122311	2134	85094587000
122312	1874	28490000
122313	2132	147468481000
122314	1874	28491000
122315	2133	91638920000
122316	1874	28493000
122317	1439	10783748578477
122383	1397	1287974932000
122384	1678	26640840168000
122385	2133	91634912000
122386	1874	28511000
122387	2134	85090575000
122388	1874	28514000
122419	1397	1287924927000
122420	1678	26640840173000
122421	2133	91629902000
122422	1874	28537000
122423	2134	85085560000
122424	1874	28540000
122425	1395	58249351112957278
122426	1395	58249351124957278
122427	1397	1287914926000
122428	1678	26640840174000
122429	1397	1287904925000
122430	1678	26640840175000
122431	1397	1287894924000
122432	1678	26640840176000
122433	2132	147465478000
122434	1874	28541000
122435	2134	85084557000
122436	1874	28544000
122437	2134	85083554000
122438	1874	28547000
122439	2134	85082551000
122440	1874	28550000
122441	2133	91628900000
122442	1874	28552000
122443	2133	91627898000
122444	1874	28554000
122445	2133	91626896000
122446	1874	28556000
122447	1471	13625410900000
122448	1471	13625447900000
122451	1397	1287884923000
122452	1678	26640840177000
122453	2132	147464477000
122454	1874	28557000
122455	2133	91625894000
122456	1874	28559000
122457	2134	85081548000
122458	1874	28562000
122459	1992	10801044990000
122461	1397	1287874922000
122462	1678	26640840178000
122463	2134	85080545000
122464	1874	28565000
122465	2133	91624892000
122466	1874	28567000
122467	1394	779052392440200
122468	1394	779052404440200
122483	1397	1287844919000
122484	1678	26640840181000
122485	2133	91621886000
122486	1874	28579000
122487	2134	85077536000
122488	1874	28582000
122489	2132	147463476000
122490	1874	28583000
122491	1714	12525674171760
122492	1714	12525687171760
122545	1397	1287774912000
122546	1678	26640840188000
122547	1397	1287764911000
122548	1678	26640840189000
122549	2134	85070515000
122550	1874	28616000
122551	2133	91615874000
122552	1874	28618000
122553	2134	85069512000
122554	1874	28621000
122555	2133	91614872000
122556	1874	28623000
122557	1402	31143051145435
122619	1397	1287734908000
122620	1678	26640840192000
122621	2134	85066503000
122622	1874	28637000
122623	2133	91611866000
122624	1874	28639000
122625	1685	165604067571430
122626	1685	165604079571430
122645	1397	1287704905000
122646	1678	26640840195000
122647	1397	1287694904000
122648	1678	26640840196000
122649	2134	85063494000
122650	1874	28653000
122651	2134	85062491000
122652	1874	28656000
122653	1747	2225976000000
122659	2292	2159062000000
122661	1685	166324079571430
122662	1685	166324103571430
122023	1527	291999958
122037	1681	13571366909853
122038	1681	13571478909853
122057	1397	1288234958000
122058	1678	26640840142000
122059	2134	85116653000
122060	1874	28374000
122061	2133	91660964000
122062	1874	28376000
122063	470	76080310000000
122110	1690	173525650000000
122111	1690	173525675000000
122122	1397	1288194954000
122123	1678	26640840146000
122124	1397	1288184953000
122125	1678	26640840147000
122126	2134	85112641000
122127	1874	28395000
122128	2134	85111638000
122129	1874	28398000
122130	2132	147473486000
122131	1874	28399000
122132	2133	91656956000
122133	1874	28401000
122134	2133	91655954000
122135	1874	28403000
122136	1724	11934735500000
122137	1724	11934760500000
122164	1397	1288144949000
122165	1678	26640840151000
122166	2132	147472485000
122167	1874	28419000
122168	2134	85107626000
122169	1874	28422000
122170	2133	91651946000
122171	1874	28424000
122172	1709	6480120000000
122173	1709	6480133000000
122189	1397	1288114946000
122190	1678	26640840154000
122191	2134	85104617000
122192	1874	28437000
122193	2132	147471484000
122194	1874	28438000
122195	2133	91648940000
122196	1874	28440000
122197	1764	20948458100000
122198	1088	909182965000000
122199	1764	14070457100000
122200	1334	1709415637751650
122201	1715	7223533663945
122232	1397	1288074942000
122233	1678	26640840158000
122234	2134	85100605000
122235	1874	28459000
122236	2133	91644932000
122237	1874	28461000
122238	1708	9000550500051
122239	1708	9000562500051
122242	1611	5522376241757
122243	1611	5522386241757
122252	1992	10801031990000
122253	1992	10801045990000
122256	1623	72003180898598
122257	1623	72003194898598
122260	1992	10801043990000
122290	1693	3589931570248
122308	1688	63359124720020
122326	1397	1287994934000
122327	1678	26640840166000
122328	1874	28285000
122329	1874	28287000
122330	1874	28290000
122331	1874	28292000
122332	1874	28295000
122333	1874	28299000
122334	1874	28301000
122335	1874	28314000
122336	1874	28316000
122337	1874	28317000
122338	1874	28319000
122339	1874	28333000
122340	1874	28339000
122341	1874	28345000
122342	1874	28348000
122343	1874	28351000
122344	1874	28354000
122345	1874	28357000
122346	1874	28363000
122347	1874	28366000
122348	1874	28369000
122349	1874	28372000
122350	1874	28375000
122351	1637	300968014819988
122352	1874	28381000
122353	1874	28390000
122354	1874	28393000
122355	1874	28396000
122356	1874	28402000
122357	1874	28414000
122358	1874	28417000
122359	1874	28420000
122360	1874	28423000
122361	1874	28435000
122362	1637	301688014819988
122363	1637	301688034819988
122378	1536	15840339000000
122381	1700	8874247979053
122382	1700	8874272979053
122495	1419	22606142559750
122496	1419	22606155559750
122499	1555	12486112540449
122500	1555	12486125540449
122543	1690	174245662000000
122544	1690	174245724000000
122635	1397	1287714906000
122636	1678	26640840194000
122637	2133	91609862000
122638	1874	28646000
122639	2134	85064497000
122640	1874	28649000
122641	2132	147459472000
122642	1874	28650000
122643	1458	20105430908540
122644	1458	20105443908540
122672	1447	19001863683000
122673	1447	19001876683000
122682	1397	1287664901000
122683	1678	26640840199000
122684	1397	1287654900000
122685	1678	26640840200000
122686	2134	85059482000
122687	1874	28674000
122688	2133	91604852000
122689	1874	28676000
122690	2133	91603850000
122691	1874	28678000
122692	2134	85058479000
122693	1874	28681000
122694	2086	2880367300069
122695	2086	2880391300069
122723	1701	13678351500103
122787	1397	1287594894000
122788	1678	26640840206000
122789	2133	91596836000
122790	1874	28715000
122791	2132	147455468000
122792	1874	28716000
122793	2134	85051458000
122794	1874	28719000
122795	1560	15128818131803
122796	1560	15128831131803
122274	1678	26640840161000
122275	2133	91641926000
122276	1874	28473000
122277	2132	147469482000
122278	1874	28474000
122279	2134	85097596000
122280	1874	28477000
122281	1749	12934586529980
122282	1201	613649750000000
122283	1394	771852416440200
122284	1394	771852430440200
122286	1402	31143041145435
122288	1596	5760230000002
122289	1394	773292330440200
122318	1397	1288004935000
122319	1678	26640840165000
122320	2134	85093584000
122321	1874	28496000
122322	2133	91637918000
122323	1874	28498000
122324	1394	774732330440200
122325	1394	774732342440200
122403	1397	1287944929000
122404	1678	26640840171000
122405	1397	1287934928000
122406	1678	26640840172000
122407	2134	85087566000
122408	1874	28527000
122409	2134	85086563000
122410	1874	28530000
122411	2132	147466479000
122412	1874	28531000
122413	2133	91631906000
122414	1874	28533000
122415	2133	91630904000
122416	1874	28535000
122417	1394	777612367440200
122418	1394	777612392440200
122477	1397	1287854920000
122478	1678	26640840180000
122479	2133	91622888000
122480	1874	28574000
122481	2134	85078539000
122482	1874	28577000
122493	1395	58250791136957278
122494	1395	58250791149957278
122497	171	76026772696494
122498	171	76026785696494
122574	1657	5761290990100
122575	1747	1506084000000
122576	1874	28470000
122577	1874	28475000
122578	1874	28483000
122579	1874	28486000
122580	1874	28489000
122581	1874	28492000
122582	1874	28495000
122583	1874	28500000
122584	1874	28501000
122585	1874	28503000
122586	1874	28504000
122587	1874	28506000
122588	1874	28512000
122589	1874	28515000
122590	1874	28518000
122591	1874	28536000
122592	1874	28539000
122593	1874	28542000
122594	1874	28545000
122595	1874	28548000
122596	1874	28551000
122597	1874	28560000
122598	1874	28563000
122599	1874	28566000
122600	1874	28575000
122601	1874	28578000
122602	1874	28581000
122603	1874	28584000
122604	1874	28588000
122605	1874	28598000
122606	1874	28600000
122607	1874	28604000
122608	1874	28606000
122609	1874	28610000
122610	1874	28612000
122611	1874	28614000
122612	1874	28620000
122613	1874	28622000
122614	1874	28626000
122615	1874	28628000
122616	1874	28630000
122617	1747	2226084000000
122618	1747	2226351000000
122627	1397	1287724907000
122628	1678	26640840193000
122629	2134	85065500000
122630	1874	28642000
122631	2133	91610864000
122632	1874	28644000
122633	1623	72723194898598
122634	1623	72723206898598
122663	1397	1287684903000
122664	1678	26640840197000
122665	2133	91606856000
122666	1874	28662000
122667	2134	85061488000
122668	1874	28665000
122669	2132	147458471000
122670	1874	28666000
122671	1587	10800361000000
122715	1688	64079124720020
122716	1688	64079136720020
122762	1397	1287624897000
122763	1678	26640840203000
122764	2133	91599842000
122765	1874	28699000
122766	2134	85054467000
122767	1874	28702000
122768	2132	147456469000
122769	1874	28703000
122770	1471	13625423900000
122799	1397	1287584893000
122800	1678	26640840207000
122801	2134	85050455000
122802	1874	28722000
122803	1439	11503748578477
122804	1439	11503759578477
122808	1439	11503760578477
122298	1874	28481000
122299	2134	85096593000
122300	1874	28484000
122301	2134	85095590000
122302	1874	28487000
122303	1749	8444585529980
122304	1081	909489465000000
122305	1749	2584529980
122306	1327	1709992637751650
122307	1693	3590957570272
122364	1397	1287984933000
122365	1678	26640840167000
122366	2132	147467480000
122367	1874	28499000
122368	2134	85092581000
122369	1874	28502000
122370	2134	85091578000
122371	1874	28505000
122372	2133	91636916000
122373	1874	28507000
122374	2133	91635914000
122375	1874	28509000
122376	1394	776172342440200
122377	1394	776172367440200
122379	689	67440011000000
122380	689	67440036000000
122389	1397	1287964931000
122390	1678	26640840169000
122391	1397	1287954930000
122392	1678	26640840170000
122393	2134	85089572000
122394	1874	28517000
122395	2133	91633910000
122396	1874	28519000
122397	2133	91632908000
122398	1874	28521000
122399	2134	85088569000
122400	1874	28524000
122401	1555	11766088540449
122402	1555	11766112540449
122449	1675	14684340999977
122450	1675	14684377999977
122460	1657	5761278990100
122469	1397	1287864921000
122470	1678	26640840179000
122471	2133	91623890000
122472	1874	28569000
122473	2134	85079542000
122474	1874	28572000
122475	1395	58250071124957278
122476	1395	58250071136957278
122501	1397	1287834918000
122502	1678	26640840182000
122503	2134	85076533000
122504	1874	28586000
122505	1685	164884056571430
122506	1685	164884067571430
122507	1397	1287824917000
122508	1678	26640840183000
122509	1397	1287814916000
122510	1678	26640840184000
122511	1397	1287804915000
122512	1678	26640840185000
122513	1397	1287794914000
122514	1678	26640840186000
122515	1397	1287784913000
122516	1678	26640840187000
122517	2132	147462475000
122518	1874	28587000
122519	2133	91620884000
122520	1874	28589000
122521	2132	147461474000
122522	1874	28590000
122523	2133	91619882000
122524	1874	28592000
122525	2133	91618880000
122526	1874	28594000
122527	2133	91617878000
122528	1874	28596000
122529	2134	85075530000
122530	1874	28599000
122531	2134	85074527000
122532	1874	28602000
122533	2134	85073524000
122534	1874	28605000
122535	2134	85072521000
122536	1874	28608000
122537	2134	85071518000
122538	1874	28611000
122539	2133	91616876000
122540	1874	28613000
122541	2148	7200122880750
122542	2148	7200184880750
122558	1397	1287754910000
122559	1678	26640840190000
122560	1397	1287744909000
122561	1678	26640840191000
122562	2132	147460473000
122563	1874	28624000
122564	2134	85068509000
122565	1874	28627000
122566	2133	91613870000
122567	1874	28629000
122568	2134	85067506000
122569	1874	28632000
122570	2133	91612868000
122571	1874	28634000
122572	2292	2159038000000
122573	2292	2159063000000
122654	2133	91608860000
122655	1874	28658000
122656	2133	91607858000
122657	1874	28660000
122658	1587	10800372000000
122660	1746	2688911000000
122674	1397	1287674902000
122675	1678	26640840198000
122676	2133	91605854000
122677	1874	28668000
122678	2134	85060485000
122679	1874	28671000
122680	1690	174965724000000
122681	1690	174965736000000
122697	1699	2880342750126
122707	1397	1287634898000
122708	1678	26640840202000
122709	2133	91601846000
122710	1874	28689000
122711	2134	85056473000
122712	1874	28692000
122713	1679	30959464653000
122714	1679	30959476653000
122717	2133	91600844000
122718	1874	28694000
122719	2134	85055470000
122720	1874	28697000
122721	1402	31863051145435
122722	1402	31863053145435
122724	1874	28441000
122725	1874	28444000
122726	1874	28446000
122727	1874	28448000
122728	1874	28449000
122729	1874	28452000
122730	1874	28460000
122731	1874	28467000
122732	1874	28476000
122733	1874	28482000
122734	1874	28485000
122735	1874	28488000
122736	1874	28494000
122737	1874	28497000
122738	1874	28571000
122739	1874	28573000
122740	1874	28585000
122741	1874	28591000
122742	1874	28593000
122743	1874	28595000
122744	1874	28597000
122745	1874	28601000
122746	1874	28603000
122747	1637	301688463819988
122748	1874	28607000
122749	1874	28609000
122750	1874	28615000
122751	1874	28617000
122752	1874	28619000
122753	1874	28625000
122754	1874	28631000
122755	1874	28633000
122756	1874	28635000
122757	1874	28641000
122758	1874	28643000
122759	1874	28645000
122760	1637	302408463819988
122761	1637	302408483819988
122779	1397	1287604895000
122780	1678	26640840205000
122781	2133	91597838000
122782	1874	28710000
122783	2134	85052461000
122784	1874	28713000
122785	1679	31679476653000
122786	1679	31679488653000
122696	2087	3315422147766
122698	1397	1287644899000
122699	1678	26640840201000
122700	2132	147457470000
122701	1874	28682000
122702	2133	91602848000
122703	1874	28684000
122704	2134	85057476000
122705	1874	28687000
122706	1455	3631588000000
122771	1397	1287614896000
122772	1678	26640840204000
122773	2134	85053464000
122774	1874	28706000
122775	2133	91598840000
122776	1874	28708000
122777	1402	32583053145435
122778	1402	32583065145435
122797	1509	11903409503835
122798	1509	12623409503835
122805	2133	91595834000
122806	1874	28724000
122807	1509	12623293503835
122809	1397	1287574892000
122810	1678	26640840208000
122811	2134	85049452000
122812	1874	28727000
122813	2133	91594832000
122814	1874	28729000
122815	1447	19001875683000
122816	1397	1287564891000
122817	1678	26640840209000
122818	2134	85048449000
122819	1874	28732000
122820	2133	91593830000
122821	1874	28734000
122822	1711	14106964000000
122823	1711	14106976000000
122824	1991	11421368355805
122825	1991	11421380355805
122826	1397	1287554890000
122827	1678	26640840210000
122828	2133	91592828000
122829	1874	28736000
122830	2132	147454467000
122831	1874	28737000
122832	2134	85047446000
122833	1874	28740000
122834	1397	1287544889000
122835	1678	26640840211000
122836	2134	85046443000
122837	1874	28743000
122838	2133	91591826000
122839	1874	28745000
122840	1474	7830488000043
122841	1397	1287534888000
122842	1678	26640840212000
122843	2133	91590824000
122844	1874	28747000
122845	2134	85045440000
122846	1874	28750000
122847	1464	2160022000000
122848	1464	2160034000000
122849	2132	147453466000
122850	1874	28751000
122851	2134	85044437000
122852	1874	28754000
122853	1395	58250791138957278
122854	1397	1287524887000
122855	1678	26640840213000
122856	1397	1287514886000
122857	1678	26640840214000
122858	2134	85043434000
122859	1874	28757000
122860	1747	1505975000000
122861	1571	9260664124162
122862	1747	2225974999992
122863	2292	1439059000000
122864	2133	91589822000
122865	1874	28759000
122866	2133	91588820000
122867	1874	28761000
122868	2292	2159059000000
122869	2292	2159061000000
122870	1746	3408911000000
122871	1807	200000006
122872	1395	58251511138957277
122873	1397	1287504885000
122874	1678	26640840215000
122875	2134	85042431000
122876	1874	28760000
122877	1874	28762000
122878	1874	28764000
122879	2133	91587818000
122880	1874	28766000
122881	1594	15121840000000
122882	1807	200000004
122883	1796	200000043
122884	1571	15121853999873
122885	1594	9260664124250
122886	1599	11816870097983
122887	1599	11816884097983
122888	1610	9360187999950
122889	1610	9360201999950
122890	1513	35281203000000
122891	1513	35281217000000
122892	1594	15121854000000
122893	1397	1287494884000
122894	1678	26640840216000
122895	2134	85041428000
122896	1874	28769000
122897	2133	91586816000
122898	1874	28771000
122899	2132	147452465000
122900	1874	28772000
122901	1394	780492404440200
122902	1394	780492417440200
122903	2112	20686919101924
122904	1874	28768000
122905	2112	20686917101924
122906	1397	1287484883000
122907	1678	26640840217000
122908	1397	1287474882000
122909	1678	26640840218000
122910	1397	1287464881000
122911	1678	26640840219000
122912	2133	91585814000
122913	1874	28774000
122914	2133	91584812000
122915	1874	28776000
122916	2133	91583810000
122917	1874	28778000
122918	2134	85040425000
122919	1874	28781000
122920	2134	85039422000
122921	1874	28784000
122922	2134	85038419000
122923	1874	28787000
122924	1394	781932417440200
122925	1394	781932453440200
122926	1397	1287454880000
122927	1678	26640840220000
122928	1397	1287444879000
122929	1678	26640840221000
122930	1397	1287434878000
122931	1678	26640840222000
122932	2134	85037416000
122933	1874	28790000
122934	2134	85036413000
122935	1874	28793000
122936	2134	85035410000
122937	1874	28796000
122938	2133	91582808000
122939	1874	28798000
122940	2133	91581806000
122941	1874	28800000
122942	2133	91580804000
122943	1874	28802000
122944	2132	147451464000
122945	1874	28803000
122946	1670	9361013000000
122947	1670	9361050000000
122948	1394	783372453440200
122949	1394	783372490440200
122950	1397	1287424877000
122951	1678	26640840223000
122952	2133	91579802000
122953	1874	28805000
122954	2132	147450463000
122955	1874	28806000
122956	1476	11520231000000
122957	1476	11520243000000
122958	222	66713079919853
122959	2321	500000000
122960	1397	1287414876000
122961	1678	26640840224000
122962	2134	85034407000
122963	1874	28809000
122964	2133	91578800000
122965	1874	28811000
122966	1455	4351588000000
122967	1455	4351700000000
122968	1698	11589044550062
122969	1692	2620553619999
122970	1692	2620665619999
122971	1397	1287404875000
122972	1678	26640840225000
122973	2134	85033404000
122974	1874	28814000
122975	2133	91577798000
122976	1874	28816000
122977	1684	20163300819412
122978	1684	20163312819412
123011	1700	8874259979053
123037	2134	85027386000
123038	1874	28846000
123039	1395	58251511139957278
123053	1643	1868647914700
123066	1874	28854000
123067	641	76803873000000
123069	222	66540679919853
123070	2321	172500000000
123071	1397	1287314866000
123072	1678	26640840234000
123073	2133	91568780000
123074	1874	28858000
123075	1874	28861000
123076	2134	85024377000
123077	1874	28864000
123078	1394	783372577440200
123148	1559	9666095999999
123149	1559	9666119999999
123184	1601	6145847620000
123185	1601	6145859620000
123193	1740	12690788000000
123194	1740	12690800000000
123227	1397	1287154850000
123228	1678	26640840250000
123229	2132	147442455000
123230	1874	28944000
123231	2133	91552748000
123232	1874	28946000
123233	2134	85008329000
123234	1874	28949000
123235	1688	64799237720020
123236	1688	64799250720020
123245	2248	11519534000000
123269	1397	1287114846000
123270	1678	26640840254000
123271	1874	28963000
123272	2133	91548740000
123273	1874	28967000
123274	2134	85004317000
123275	1874	28970000
123276	1698	11588966550062
123300	222	66058279919853
123301	2321	654500000000
123302	1397	1287084843000
123303	1678	26640840257000
123304	2134	85001308000
123305	1874	28981000
123306	2132	147440453000
123307	1874	28982000
123308	1874	28984000
123309	2133	91545734000
123310	1874	28986000
123311	1602	11376749170000
123313	1724	12654760500000
123314	1724	12654875500000
123340	1397	1287044839000
123341	1678	26640840261000
123342	2133	91541726000
123343	1874	29004000
123344	2134	84997296000
123345	1874	29007000
123346	1394	790572787440200
123347	1394	790572799440200
123366	1457	12960256800000
123372	1397	1287014836000
123373	1678	26640840264000
123374	2133	91538720000
123375	1874	29023000
123376	1705	20000908580140
123378	1397	1287004835000
123379	1678	26640840265000
123380	2134	84993284000
123381	1874	29024000
123382	1439	10783769578477
123383	1439	11503769578477
123388	1397	1286994834000
123389	1678	26640840266000
123390	2134	84992281000
123391	1874	29027000
123392	1874	29029000
123393	1874	29031000
123394	2133	91536716000
123395	1874	29033000
123396	1549	11951383000000
123397	1549	11951397000000
123400	1685	167764203571430
123401	1685	167764217571430
123421	1397	1286964831000
123422	1678	26640840269000
123423	2133	91533710000
123424	1874	29046000
123425	2134	84989272000
123426	1874	29049000
123427	1692	3340665619999
123428	1692	3340677619999
123473	1397	1286914826000
123474	1678	26640840274000
123475	2134	84984257000
123476	1874	29074000
123477	2133	91528700000
123478	1874	29076000
123479	1395	58252951154957278
123503	1489	8303068040000
123517	1397	1286874822000
123518	1678	26640840278000
123519	1397	1286864821000
123520	1678	26640840279000
123521	2133	91524692000
123522	1874	29094000
123523	2134	84980245000
123524	1874	29097000
123525	2321	709999000000
123526	2134	84979242000
123527	1874	29100000
123528	2133	91523690000
123529	1874	29102000
123530	1395	58253671154957278
123531	1395	58253671179957278
123544	1397	1286844819000
123545	1678	26640840281000
123546	2133	91521686000
123547	1874	29110000
123548	2134	84977236000
123549	1874	29113000
123577	1397	1286814816000
123578	1678	26640840284000
123579	1397	1286804815000
123580	1678	26640840285000
123581	2133	91518680000
123582	1874	29126000
123583	2133	91517678000
123584	1874	29128000
123585	2134	84974227000
123586	1874	29131000
123587	2134	84973224000
123588	1874	29134000
123589	1818	2160156890000
123590	1818	2160180890000
123617	1688	66239274720020
123621	1397	1286764811000
123622	1678	26640840289000
123623	2134	84969212000
123624	1874	29153000
123625	2133	91513670000
123626	1874	29155000
123627	1768	17747009110000
123642	1685	167764227571430
123643	1685	168484227571430
123644	1685	168484230571430
123672	1509	13343293503835
123673	1509	13343305503835
123700	1397	1286684803000
123701	1678	26640840297000
123702	2134	84961188000
123703	1874	29193000
123704	2133	91505654000
123705	1874	29195000
123732	1747	2945974999992
123733	1747	2945986999992
123745	1397	1286634798000
123746	1678	26640840302000
123747	2133	91500644000
123748	1874	29217000
123749	2134	84956173000
123750	1874	29220000
123751	1622	6083952800048
123752	1622	6083964800048
123776	1694	15659035197225
123779	1397	1286594794000
123780	1678	26640840306000
123781	2134	84952161000
123782	1874	29238000
123783	2133	91496636000
123784	1874	29240000
123787	1397	1286584793000
123788	1678	26640840307000
122979	1690	175685736000000
122980	1690	175685748000000
122981	222	66702479919853
122982	2321	11000000000
122983	2134	85032401000
122984	1874	28819000
122985	2132	147449462000
122986	1874	28820000
122987	2134	85031398000
122988	1874	28823000
122989	1395	58251511138957278
122990	1395	58251511241957278
123020	222	66681879919853
123021	2321	31500000000
123022	1397	1287364871000
123023	1678	26640840229000
123024	1397	1287354870000
123025	1678	26640840230000
123026	2132	147448461000
123027	1874	28833000
123028	2134	85029392000
123029	1874	28836000
123030	2134	85028389000
123031	1874	28839000
123032	2133	91573790000
123033	1874	28841000
123034	2133	91572788000
123035	1874	28843000
123036	1768	16306885110000
123054	1397	1287324867000
123055	1678	26640840233000
123056	2133	91569782000
123057	1874	28855000
123058	2132	147447460000
123059	1874	28856000
123060	2134	85025380000
123061	1874	28859000
123062	1711	14106977000000
123068	641	76803885000000
123086	1874	28867000
123134	1397	1287244859000
123135	1678	26640840241000
123136	1397	1287234858000
123137	1678	26640840242000
123138	2133	91561766000
123139	1874	28898000
123140	2133	91560764000
123141	1874	28900000
123142	2134	85017356000
123143	1874	28903000
123144	2134	85016353000
123145	1874	28906000
123146	1394	786252614440200
123147	1394	786252638440200
123150	2132	147444457000
123151	1874	28907000
123152	2134	85015350000
123153	1874	28910000
123154	1395	58252231139957278
123155	1395	58252231141957278
123156	1397	1287224857000
123157	1678	26640840243000
123158	2133	91559762000
123159	1874	28909000
123160	1874	28912000
123161	1693	3590944570272
123176	1397	1287204855000
123177	1678	26640840245000
123178	2133	91557758000
123179	1874	28919000
123180	2134	85013344000
123181	1874	28922000
123182	1690	176405748000000
123183	1690	176405760000000
123186	1397	1287194854000
123187	1678	26640840246000
123188	2133	91556756000
123189	1874	28924000
123190	2134	85012341000
123191	1874	28927000
123192	1394	787692650440200
123216	1874	28936000
123217	2106	2160138000000
123219	1397	1287164851000
123220	1678	26640840249000
123221	2133	91553750000
123222	1874	28940000
123223	2134	85009332000
123224	1874	28943000
123225	1471	14345423900000
123226	1471	14345435900000
123237	1397	1287144849000
123238	1678	26640840251000
123239	2134	85007326000
123240	1874	28952000
123241	2133	91551746000
123242	1874	28954000
123243	1688	65519250720020
123244	1688	65519262720020
123257	1397	1287134848000
123258	1678	26640840252000
123259	1397	1287124847000
123260	1678	26640840253000
123261	2133	91550744000
123262	1874	28957000
123263	2133	91549742000
123264	1874	28959000
123265	1874	28962000
123266	1874	28965000
123267	1710	12474034664140
123268	1710	12474059664140
123277	171	76026806696494
123312	606	73966795286230
123315	1724	12655662500000
123348	1397	1287034838000
123349	1678	26640840262000
123350	2134	84996293000
123351	1874	29010000
123352	2133	91540724000
123353	1874	29012000
123354	1687	6608924848312
123355	1687	6608936848312
123377	1705	20000897580140
123384	1874	29026000
123385	2133	91537718000
123386	1874	29028000
123387	1439	11503771578477
123398	526	74640291000000
123399	526	74640305000000
123402	526	74640303000000
123429	1397	1286954830000
123430	1678	26640840270000
123431	1397	1286944829000
123432	1678	26640840271000
123433	2133	91532708000
123434	1874	29051000
123435	2133	91531706000
123436	1874	29053000
123437	2134	84988269000
123438	1874	29056000
123439	2134	84987266000
123440	1874	29059000
123441	2132	147436449000
123442	1874	29060000
123443	1768	17746997110000
123444	1768	17747034110000
123463	1397	1286924827000
123464	1678	26640840273000
123465	2133	91529702000
123466	1874	29067000
123467	2134	84985260000
123468	1874	29070000
123469	2132	147435448000
123470	1874	29071000
123471	1675	16124389999977
123472	1675	16124402999977
123482	1394	792012799440200
123483	1394	792012811440200
123484	1680	11533322499559
123504	1397	1286884823000
123505	1678	26640840277000
123506	2132	147434447000
123507	1874	29085000
123508	2134	84981248000
123509	1874	29088000
123510	1874	29090000
123511	2133	91525694000
123512	1874	29092000
123513	1688	66239262720020
123514	1688	66239276720020
123554	1874	29111000
123555	576	76877629726897
123556	2321	709899000000
123557	1397	1286834818000
123558	1678	26640840282000
123559	2133	91520684000
123560	1874	29115000
123561	2134	84976233000
123562	1874	29118000
123563	1394	792012911440200
123591	1397	1286794814000
123592	1678	26640840286000
123593	2134	84972221000
123594	1874	29137000
123595	2133	91516676000
122991	1397	1287394874000
122992	1678	26640840226000
122993	1397	1287384873000
122994	1678	26640840227000
122995	2148	7200245880750
123002	2148	7200247880750
123014	1700	8874258979053
123044	222	66661279919853
123045	2321	52000000000
123046	1397	1287334868000
123047	1678	26640840232000
123048	2133	91570784000
123049	1874	28850000
123050	2134	85026383000
123051	1874	28853000
123052	1980	21599619000000
123063	1691	10511108300052
123064	1691	10511121300052
123087	1670	10081050000000
123088	1670	10081062000000
123089	1685	166324091571430
123122	1397	1287254860000
123123	1678	26640840240000
123124	2132	147445458000
123125	1874	28891000
123126	2134	85018359000
123127	1874	28894000
123128	1419	21886154559750
123129	2133	91562768000
123130	1874	28896000
123131	1419	22606154559750
123162	1394	787692638440200
123163	1394	787692651440200
123164	1599	12536884097983
123165	1599	12536897097983
123206	1637	303128483819988
123207	1637	66720044900000
123208	646	303129332829988
123218	1455	4351600000000
123249	1733	2159022000000
123278	1397	1287104845000
123279	1678	26640840255000
123280	1397	1287094844000
123281	1678	26640840256000
123282	2134	85003314000
123283	1874	28973000
123284	1791	1209000048
123285	2322	0
123286	1791	208000048
123287	2323	0
123288	2134	85002311000
123289	1874	28976000
123290	470	76800310000000
123291	470	76800334000000
123299	470	76800336000000
123316	222	66002679919853
123317	2321	710000000000
123318	1397	1287074842000
123319	1678	26640840258000
123320	1397	1287064841000
123321	1678	26640840259000
123322	1397	1287054840000
123323	1678	26640840260000
123324	2134	85000305000
123325	1874	28989000
123326	2132	147439452000
123327	1874	28990000
123328	2133	91544732000
123329	1874	28992000
123330	2133	91543730000
123331	1874	28994000
123332	2133	91542728000
123333	1874	28996000
123334	2134	84999302000
123335	1874	28999000
123336	2134	84998299000
123337	1874	29002000
123338	1394	789132650440200
123339	1394	789132787440200
123356	1397	1287024837000
123357	1678	26640840263000
123358	2133	91539722000
123359	1874	29014000
123360	2134	84995290000
123361	1874	29017000
123362	2132	147438451000
123363	1874	29018000
123364	1599	13256897097983
123365	1599	13256910097983
123367	1687	7328936848312
123368	1687	7328949848312
123369	2134	84994287000
123370	1874	29021000
123371	1422	11754695804270
123403	1397	1286984833000
123404	1678	26640840267000
123405	2134	84991278000
123406	1874	29036000
123407	2133	91535714000
123408	1874	29038000
123409	2132	147437450000
123410	1874	29039000
123411	621	68160057000000
123418	2133	91534712000
123419	1874	29041000
123420	1874	29044000
123445	1874	29050000
123446	1768	17746998110000
123448	1596	6480230000002
123449	1596	6480255000002
123452	1874	29047000
123453	1874	29054000
123454	1739	30959874000000
123485	1397	1286904825000
123486	1678	26640840275000
123487	2133	91527698000
123488	1874	29078000
123489	2134	84983254000
123490	1874	29081000
123491	1680	11533334499559
123492	1685	168484217571430
123493	1685	168484229571430
123502	1489	8303067040000
123515	2112	20686920101924
123540	2133	91522688000
123541	1874	29105000
123542	1874	29108000
123543	1489	9023080040000
123552	1992	11521044990000
123553	1992	11521056990000
123564	2321	413499000000
123565	2321	413399000000
123566	1419	23326155559748
123567	1419	23326258559748
123609	1397	1286774812000
123610	1678	26640840288000
123611	2134	84970215000
123612	1874	29148000
123613	2133	91514672000
123614	1874	29150000
123615	606	74686795286230
123616	606	74686807286230
123620	1706	13962174450256
123649	1397	1286744809000
123650	1678	26640840291000
123651	2134	84967206000
123652	1874	29163000
123653	2133	91511666000
123654	1874	29165000
123655	1536	15840326000000
123663	1559	9666107999999
123680	1397	1286704805000
123681	1678	26640840295000
123682	2134	84963194000
123683	1874	29183000
123684	2133	91507658000
123685	1874	29185000
123686	1394	793452911440200
123687	1394	793452923440200
123690	1397	1286694804000
123691	1678	26640840296000
123692	2134	84962191000
123693	1874	29188000
123694	2133	91506656000
123695	1874	29190000
123698	1874	29187000
123699	1560	15848832131803
123706	1397	1286674802000
123707	1678	26640840298000
123708	1397	1286664801000
123709	1678	26640840299000
123710	2133	91504652000
123711	1874	29197000
123712	2134	84960185000
123713	1874	29200000
123714	2134	84959182000
123715	1874	29203000
123716	2133	91503650000
123717	1874	29205000
123718	1684	20883313819412
123719	1684	20883337819412
123721	1448	10039840000001
123722	1448	10039864000001
123730	1709	7200133000000
123731	1709	7200145000000
122996	2133	91576796000
122997	1874	28822000
122998	2133	91575794000
122999	1874	28824000
123000	1874	28827000
123001	1394	783372578440200
123003	1397	1287374872000
123004	1678	26640840228000
123005	2134	85030395000
123006	1874	28830000
123007	2133	91574792000
123008	1874	28832000
123009	1679	32399488653000
123010	1679	32399500653000
123012	1457	12960243800000
123013	1457	12960255800000
123015	1402	33303065145435
123016	1402	33303077145435
123017	1874	28826000
123018	1874	28828000
123019	1684	20163314819412
123040	1397	1287344869000
123041	1678	26640840231000
123042	2133	91571786000
123043	1874	28848000
123065	641	76803972000000
123079	1397	1287304865000
123080	1678	26640840235000
123081	2133	91567778000
123082	1874	28866000
123083	2134	85023374000
123084	1874	28869000
123085	1522	9403689000000
123090	222	66420079919853
123091	2321	293000000000
123092	1397	1287294864000
123093	1678	26640840236000
123094	2134	85022371000
123095	1874	28872000
123096	2133	91566776000
123097	1874	28874000
123098	1685	167044091571430
123099	1685	167044203571430
123100	1397	1287284863000
123101	1678	26640840237000
123102	1397	1287274862000
123103	1678	26640840238000
123104	1397	1287264861000
123105	1678	26640840239000
123106	2133	91565774000
123107	1874	28876000
123108	2132	147446459000
123109	1874	28877000
123110	2134	85021368000
123111	1874	28880000
123112	2134	85020365000
123113	1874	28883000
123114	2134	85019362000
123115	1874	28886000
123116	2133	91564772000
123117	1874	28888000
123118	2133	91563770000
123119	1874	28890000
123120	1394	784812577440200
123121	1394	784812614440200
123132	1419	200000007
123133	1807	22606155559748
123166	222	66299479919853
123167	2321	413500000000
123168	1397	1287214856000
123169	1678	26640840244000
123170	2134	85014347000
123171	1874	28915000
123172	2133	91558760000
123173	1874	28917000
123174	1768	17026885110000
123175	1768	17026997110000
123195	222	66178879919853
123196	2321	534000000000
123197	1397	1287184853000
123198	1678	26640840247000
123199	2133	91555754000
123200	1874	28929000
123201	2134	85011338000
123202	1874	28932000
123203	2132	147443456000
123204	1874	28933000
123205	1688	64079237720020
123209	1397	1287174852000
123210	1678	26640840248000
123211	2133	91554752000
123212	1874	28935000
123213	2134	85010335000
123214	1874	28938000
123215	1448	9319840000001
123246	1675	15404377999977
123247	1675	15404389999977
123248	576	76877630726897
123250	2132	147441454000
123251	1874	28955000
123252	2134	85006323000
123253	1874	28958000
123254	2134	85005320000
123255	1874	28961000
123256	1395	58252231142957278
123292	2133	91547738000
123293	1874	28972000
123294	1874	28975000
123295	1874	28978000
123296	2133	91546736000
123297	1874	28980000
123298	1688	65519276720020
123412	1397	1286974832000
123413	1678	26640840268000
123414	2134	84990275000
123415	1874	29042000
123416	1395	58252951142957278
123417	1395	58252951153957278
123447	1768	17747199110000
123450	2256	720090000000
123451	2256	720115000000
123455	1397	1286934828000
123456	1678	26640840272000
123457	2134	84986263000
123458	1874	29063000
123459	2133	91530704000
123460	1874	29065000
123461	641	77523873000000
123462	641	77523885000000
123480	1587	11520361000000
123481	1587	11520373000000
123494	610	67440012000000
123495	610	67440024000000
123496	1397	1286894824000
123497	1678	26640840276000
123498	2134	84982251000
123499	1874	29084000
123500	2133	91526696000
123501	1874	29086000
123516	1687	7328950848312
123532	1397	1286854820000
123533	1678	26640840280000
123534	2132	147433446000
123535	1874	29103000
123536	2134	84978239000
123537	1874	29106000
123538	1489	9023067040000
123539	1489	9023079040000
123550	1467	5200266272869
123551	1467	5200278272869
123568	1397	1286824817000
123569	1678	26640840283000
123570	2132	147432445000
123571	1874	29119000
123572	2134	84975230000
123573	1874	29122000
123574	2133	91519682000
123575	1874	29124000
123576	1684	20163313819412
123599	1397	1286784813000
123600	1678	26640840287000
123601	2133	91515674000
123602	1874	29141000
123603	2134	84971218000
123604	1874	29144000
123605	2132	147431444000
123606	1874	29145000
123607	1692	4060677619999
123608	1692	4060690619999
123639	1608	11658502000000
123640	1608	12378502000000
123641	1608	12378505000000
123656	1397	1286734808000
123657	1678	26640840292000
123658	2134	84966203000
123659	1874	29168000
123660	2133	91510664000
123661	1874	29170000
123662	1980	21599508000000
123664	1397	1286724807000
123665	1678	26640840293000
123666	2133	91509662000
123667	1874	29172000
123668	2134	84965200000
123669	1874	29175000
123596	1874	29139000
123597	1717	14941277000055
123598	1717	14941289000055
123618	1447	19721875683000
123619	1447	19721887683000
123628	1397	1286754810000
123629	1678	26640840290000
123630	1671	11184160003785
123631	2133	91512668000
123632	1874	29157000
123633	2068	942999000000
123634	2152	107988998000000
123635	2134	84968209000
123636	1874	29160000
123637	1671	11904160003785
123638	1671	11904163003785
123645	1555	12486135540449
123646	1555	13206135540449
123647	1555	100001000
123648	2311	13206138539449
123674	1397	1286714806000
123675	1678	26640840294000
123676	2134	84964197000
123677	1874	29178000
123678	2133	91508660000
123679	1874	29180000
123736	1746	3408923000000
123737	1397	1286644799000
123738	1678	26640840301000
123739	2134	84957176000
123740	1874	29213000
123741	2133	91501646000
123742	1874	29215000
123743	1768	18467009110000
123744	1768	18467021110000
123777	1692	4780690619999
123778	1692	4780702619999
123818	1688	66959274720020
123819	1688	66959286720020
123820	1874	29252000
123821	1476	12240244000000
123841	1394	796332935440200
123842	1394	796332947440200
123873	1397	1286484783000
123874	1678	26640840317000
123875	1717	14221287000055
123876	2133	91485614000
123877	1874	29289000
123878	2134	84942131000
123879	1874	29292000
123880	1717	14941287000055
123883	1397	1286474782000
123884	1678	26640840318000
123885	2134	84941128000
123886	1874	29295000
123887	2133	91484612000
123888	1874	29297000
123889	1668	11313722000000
123890	1668	11313734000000
123901	1397	1286454780000
123902	1678	26640840320000
123903	1397	1286444779000
123904	1678	26640840321000
123905	2133	91482608000
123906	1874	29304000
123907	2134	84939122000
123908	1874	29307000
123909	2134	84938119000
123910	1874	29310000
123911	2133	91481606000
123912	1874	29312000
123913	1708	9000574500051
123919	1685	170644254571430
123920	1685	170644265571430
123933	1419	24046258559748
123934	1419	24046259559748
123937	1397	1286414776000
123938	1678	26640840324000
123939	1397	1286404775000
123940	1678	26640840325000
123941	2133	91478600000
123942	1874	29327000
123943	2133	91477598000
123944	1874	29329000
123945	2134	84934107000
123946	1874	29332000
123947	2134	84933104000
123948	1874	29335000
123949	1395	58254391203957278
124027	1397	1286334768000
124028	1678	26640840332000
124029	2134	84926083000
124030	1874	29368000
124031	2133	91470584000
124032	1874	29370000
124156	1397	1286214756000
124157	1678	26640840344000
124158	2134	84914047000
124159	1874	29428000
124160	2133	91458560000
124161	1874	29430000
124173	1684	20163343819412
124174	2134	84913044000
124175	1874	29433000
124176	2134	84912041000
124177	1874	29436000
124178	2133	91457558000
124179	1874	29438000
124180	2133	91456556000
124181	1874	29440000
124182	2134	84911038000
124183	1874	29443000
124184	2133	91455554000
124185	1874	29445000
124186	1684	20883343819412
124187	1684	20883349819412
124224	1397	1286134748000
124225	1678	26640840352000
124226	2134	84906023000
124227	1874	29468000
124228	2133	91450544000
124229	1874	29470000
124230	1715	8663546663945
124231	1715	8663558663945
124262	2306	2159048000000
124263	2306	2159096000000
124272	1394	799212959440200
124273	1394	799212971440200
124287	1397	1286054740000
124288	1678	26640840360000
124289	2134	84897999000
124290	1874	29508000
124291	2112	21406920101924
124292	2112	21406931101924
124303	1419	24766259559748
124322	1397	1286014736000
124323	1678	26640840364000
124324	1397	1286004735000
124325	1678	26640840365000
124326	2133	91438520000
124327	1874	29527000
124328	2134	84893987000
124329	1874	29530000
124330	2134	84892984000
124331	1874	29533000
124332	2133	91437518000
124333	1874	29535000
124334	1711	14106988000000
124355	1440	7200331045924
124387	1601	6865859620000
124388	1601	6865871620000
124417	1397	1285894724000
124418	1678	26640840376000
124419	1397	1285884723000
124420	1678	26640840377000
124421	2133	91426496000
124422	1874	29587000
124423	2133	91425494000
124424	1874	29589000
124425	2134	84881951000
124426	1874	29592000
124427	2134	84880948000
124428	1874	29595000
124429	1693	3590955570272
124444	1397	1285854720000
124445	1678	26640840380000
124446	1397	1285844719000
124447	1678	26640840381000
124448	2134	84877939000
124449	1874	29604000
124450	2134	84876936000
124451	1874	29607000
124452	1874	29609000
124453	1874	29611000
124454	2133	91422488000
124455	1874	29613000
124456	2133	91421486000
124457	1874	29615000
124458	1394	800653017440200
124460	1706	14682184450256
124461	1706	14682230450256
124478	1397	1285814716000
124479	1678	26640840384000
124480	1397	1285804715000
124481	1678	26640840385000
123670	1444	10887831329999
123671	1509	12623381503835
123688	1623	73443206898598
123689	1623	73443218898598
123696	1560	15848831131803
123697	1560	15848843131803
123720	2106	2160150000000
123723	1397	1286654800000
123724	1678	26640840300000
123725	2134	84958179000
123726	1874	29208000
123727	2133	91502648000
123728	1874	29210000
123729	2292	2159050000000
123734	1422	12474695804270
123735	1422	12474707804270
123753	1397	1286624797000
123754	1678	26640840303000
123755	2134	84955170000
123756	1874	29223000
123757	2133	91499642000
123758	1874	29225000
123759	2039	14299603000000
123760	2039	14299615000000
123785	1685	169204230571430
123786	1685	169204242571430
123794	1394	794892923440200
123795	1394	794892935440200
123798	1397	1286574792000
123799	1678	26640840308000
123800	2134	84950155000
123801	1874	29248000
123802	2133	91494632000
123803	1874	29250000
123835	1397	1286534788000
123836	1678	26640840312000
123837	2134	84947146000
123838	1874	29265000
123839	2133	91490624000
123840	1874	29267000
123843	633	77949494900000
123844	633	77949506900000
123847	1397	1286524787000
123848	1678	26640840313000
123849	1397	1286514786000
123850	1678	26640840314000
123851	1397	1286504785000
123852	1678	26640840315000
123853	2134	84946143000
123854	1874	29270000
123855	2134	84945140000
123856	1874	29273000
123857	2134	84944137000
123858	1874	29276000
123859	2133	91489622000
123860	1874	29278000
123861	2133	91488620000
123862	1874	29280000
123863	2133	91487618000
123864	1874	29282000
123865	484	74013948000000
123867	1397	1286494784000
123868	1678	26640840316000
123869	2134	84943134000
123870	1874	29285000
123871	2133	91486616000
123872	1874	29287000
123899	43	73920091890000
123900	43	73920103890000
123922	1397	1286424777000
123923	1678	26640840323000
123924	2133	91480604000
123925	1874	29317000
123926	2133	91479602000
123927	1874	29319000
123928	2134	84936113000
123929	1874	29322000
123930	2134	84935110000
123931	1874	29325000
123932	1672	9361411000000
123956	1397	1286384773000
123957	1678	26640840327000
123958	2134	84931098000
123959	1874	29343000
123960	2133	91475594000
123961	1874	29345000
123962	1719	14398638000000
123981	2134	84928089000
123982	1874	29360000
123983	1622	6803964800048
123984	1622	6803965800048
123993	1874	29241000
123994	1874	29244000
123995	1874	29247000
123996	1874	29256000
123997	1874	29259000
123998	1874	29268000
123999	1874	29271000
124000	1874	29274000
124001	1874	29277000
124002	1874	29283000
124003	1874	29286000
124004	1874	29294000
124005	1874	29296000
124006	1874	29298000
124007	1874	29300000
124008	1555	12486408540449
124009	1874	29305000
124010	1874	29308000
124011	1874	29311000
124012	1874	29314000
124013	1874	29320000
124014	1874	29323000
124015	1874	29331000
124016	1874	29333000
124017	1874	29337000
124018	1874	29339000
124019	1874	29341000
124020	1874	29347000
124021	1874	29349000
124022	1874	29359000
124023	1874	29361000
124024	1874	29363000
124025	1555	13206408540449
124026	1555	13206437540449
124033	1397	1286324767000
124034	1678	26640840333000
124035	1397	1286314766000
124036	1678	26640840334000
124037	2133	91469582000
124038	1874	29372000
124039	2134	84925080000
124040	1874	29375000
124041	2134	84924077000
124042	1874	29378000
124043	2133	91468580000
124044	1874	29380000
124045	1546	11037444800000
124046	1546	11037468800000
124048	1874	29073000
124049	1874	29075000
124050	1874	29077000
124051	1874	29079000
124052	1874	29083000
124053	1874	29087000
124054	1874	29089000
124055	1874	29091000
124056	1874	29093000
124057	1874	29095000
124058	1874	29099000
124059	1874	29101000
124060	1874	29114000
124061	1874	29117000
124062	1874	29120000
124063	1546	10318204800000
124064	1874	29123000
124065	1874	29129000
124066	1874	29132000
124067	1874	29135000
124068	1874	29138000
124069	1874	29147000
124070	1874	29156000
124071	1874	29159000
124072	1874	29162000
124073	1874	29171000
124074	1874	29174000
124075	1874	29177000
124076	1874	29186000
124077	1874	29189000
124078	1874	29192000
124079	1874	29198000
124080	1874	29201000
124081	1874	29204000
124082	1874	29207000
124083	1546	11038204800000
124084	1546	11038235800000
124138	662	68160143000000
124139	662	68160179000000
124142	1397	1286234758000
124143	1678	26640840342000
124144	1397	1286224757000
124145	1678	26640840343000
124146	2134	84916053000
124147	1874	29418000
124148	2134	84915050000
123761	1397	1286614796000
123762	1678	26640840304000
123763	2133	91498640000
123764	1874	29227000
123765	2134	84954167000
123766	1874	29230000
123767	1703	4320886000000
123768	1397	1286604795000
123769	1678	26640840305000
123770	2133	91497638000
123771	1874	29232000
123772	2134	84953164000
123773	1874	29235000
123774	1395	58254391179957278
123775	1395	58254391191957278
123796	1699	3600342750126
123797	1699	3600354750126
123804	58	73187368999641
123805	58	73187380999641
123808	1685	169924242571430
123809	1685	169924254571430
123822	1397	1286554790000
123823	1678	26640840310000
123824	1397	1286544789000
123825	1678	26640840311000
123826	2133	91492628000
123827	1874	29254000
123828	1874	29257000
123829	2134	84948149000
123830	1874	29260000
123831	2133	91491626000
123832	1874	29262000
123833	1668	10593688000000
123834	1668	10593722000000
123845	1690	177125760000000
123846	1690	177125772000000
123866	1687	7328972848312
123881	1688	66239284720020
123882	1688	66959284720020
123891	1397	1286464781000
123892	1678	26640840319000
123893	2133	91483610000
123894	1874	29299000
123895	2134	84940125000
123896	1874	29302000
123897	1394	797772947440200
123898	1394	797772959440200
123950	1397	1286394774000
123951	1678	26640840326000
123952	2134	84932101000
123953	1874	29338000
123954	2133	91476596000
123955	1874	29340000
123985	1397	1286344769000
123986	1678	26640840331000
123987	2133	91471586000
123988	1874	29362000
123989	2134	84927086000
123990	1874	29365000
123991	1555	13206125540449
123992	1555	13206137540449
124047	1564	11166713000000
124085	1397	1286304765000
124086	1678	26640840335000
124087	2134	84923074000
124088	1874	29383000
124089	2133	91467578000
124090	1874	29385000
124091	1489	9743080040000
124092	1489	9743092040000
124106	1397	1286274762000
124107	1678	26640840338000
124108	2133	91464572000
124109	1874	29397000
124110	2134	84920065000
124111	1874	29400000
124112	1423	2160604750023
124113	1423	2160616750023
124116	1685	170644266571430
124117	1703	5040886000000
124118	1703	5040898000000
124140	1723	12242094085979
124141	1723	12242130085979
124162	1397	1286204755000
124163	1678	26640840345000
124164	1397	1286194754000
124165	1678	26640840346000
124166	1397	1286184753000
124167	1678	26640840347000
124168	1613	11377391200000
124169	2275	209800008
124170	1613	12097381400000
124191	1685	170644296571430
124192	1685	171364296571430
124193	1685	171364302571430
124216	1397	1286144749000
124217	1678	26640840351000
124218	2133	91451546000
124219	1874	29462000
124220	2134	84907026000
124221	1874	29465000
124222	1685	172084308571430
124223	1685	172084320571430
124234	2321	654499000000
124235	2321	654399000000
124236	1440	6480331045924
124274	1397	1286074742000
124275	1678	26640840358000
124276	2134	84900005000
124277	1874	29498000
124278	1637	299527197819988
124307	1397	1286034738000
124308	1678	26640840362000
124309	1397	1286024737000
124310	1678	26640840363000
124311	2134	84895993000
124312	1874	29518000
124313	2133	91440524000
124314	1874	29520000
124315	2133	91439522000
124316	1874	29522000
124317	2134	84894990000
124318	1874	29525000
124319	2148	7920247880750
124320	2148	7920271880750
124335	1397	1285994734000
124336	1678	26640840366000
124337	1397	1285984733000
124338	1678	26640840367000
124339	2134	84891981000
124340	1874	29538000
124341	2134	84890978000
124342	1874	29541000
124343	2133	91436516000
124344	1874	29543000
124345	2133	91435514000
124346	1874	29545000
124356	1397	1285964731000
124357	1678	26640840369000
124358	1397	1285954730000
124359	1678	26640840370000
124360	2134	84888972000
124361	1874	29553000
124362	2134	84887969000
124363	1874	29556000
124364	1440	6480251045924
124371	1397	1285944729000
124372	1678	26640840371000
124373	2134	84886966000
124374	1874	29559000
124375	1874	29561000
124376	1874	29563000
124377	2133	91431506000
124378	1874	29565000
124379	1395	58255111217957278
124381	1397	1285934728000
124382	1678	26640840372000
124383	2133	91430504000
124384	1874	29567000
124385	2134	84885963000
124386	1874	29570000
124399	1991	12141380355805
124400	1991	12141392355805
124401	1397	1285914726000
124402	1678	26640840374000
124403	1397	1285904725000
124404	1678	26640840375000
124405	1159	615190749000000
124406	2232	10200000000
124407	2134	84883957000
124408	1874	29578000
124409	2134	84882954000
124410	1874	29581000
124411	2133	91428500000
124412	1874	29583000
124413	2133	91427498000
124414	1874	29585000
124415	1671	14064198003785
124416	1671	14064223003785
124430	2134	84879945000
124431	1874	29598000
124432	2134	84878942000
124433	1874	29601000
124434	1684	20883315819412
124489	1397	1285794714000
123789	2133	91495634000
123790	1874	29242000
123791	2134	84951158000
123792	1874	29245000
123793	2086	2880379300069
123806	1656	13675497999990
123807	1656	13675509999990
123810	1397	1286564791000
123811	1678	26640840309000
123812	2134	84949152000
123813	1874	29253000
123814	2133	91493630000
123815	1874	29255000
123816	1476	12240243000000
123817	1476	12240255000000
123914	1397	1286434778000
123915	1678	26640840322000
123916	2134	84937116000
123917	1874	29315000
123918	1395	58254391190957278
123921	1741	719011000000
123935	1419	24046155559748
123936	1419	24046156559748
123963	1397	1286374772000
123964	1678	26640840328000
123965	1397	1286364771000
123966	1678	26640840329000
123967	1397	1286354770000
123968	1678	26640840330000
123969	2134	84930095000
123970	1874	29348000
123971	2134	84929092000
123972	1874	29351000
123973	2133	91474592000
123974	1874	29353000
123975	2133	91473590000
123976	1874	29355000
123977	2133	91472588000
123978	1874	29357000
123979	470	77520334000000
123980	470	77520369000000
124093	1397	1286294764000
124094	1678	26640840336000
124095	1397	1286284763000
124096	1678	26640840337000
124097	2134	84922071000
124098	1874	29388000
124099	2134	84921068000
124100	1874	29391000
124101	2133	91466576000
124102	1874	29393000
124103	2133	91465574000
124104	1874	29395000
124105	576	76877642726897
124114	1688	67679286720020
124115	1688	67679298720020
124119	1397	1286264761000
124120	1678	26640840339000
124121	1397	1286254760000
124122	1678	26640840340000
124123	1397	1286244759000
124124	1678	26640840341000
124125	2133	91463570000
124126	1874	29402000
124127	2133	91462568000
124128	1874	29404000
124129	2133	91461566000
124130	1874	29406000
124131	2134	84919062000
124132	1874	29409000
124133	2134	84918059000
124134	1874	29412000
124135	2134	84917056000
124136	1874	29415000
124137	1602	11376670170000
124171	1791	208010048
124172	1613	12097391190000
124237	1397	1286124747000
124238	1678	26640840353000
124239	1397	1286114746000
124240	1678	26640840354000
124241	1397	1286104745000
124242	1678	26640840355000
124243	1397	1286094744000
124244	1678	26640840356000
124245	2134	84905020000
124246	1874	29473000
124247	2134	84904017000
124248	1874	29476000
124249	2133	91449542000
124250	1874	29478000
124251	2134	84903014000
124252	1874	29481000
124253	2134	84902011000
124254	1874	29484000
124255	2133	91448540000
124256	1874	29486000
124257	2133	91447538000
124258	1874	29488000
124259	2133	91446536000
124260	1874	29490000
124261	1440	6480277045924
124264	1397	1286084743000
124265	1678	26640840357000
124266	2133	91445534000
124267	1874	29492000
124268	2134	84901008000
124269	1874	29495000
124270	1395	58255111203957278
124271	1395	58255111215957278
124293	2133	91442528000
124294	1874	29507000
124295	1874	29510000
124296	2112	21406932101924
124297	1397	1286044739000
124298	1678	26640840361000
124299	2134	84896996000
124300	1874	29513000
124301	1637	300247197819988
124302	1637	300247208819988
124304	1419	24766156559748
124321	1656	13675521999990
124347	1746	3408935000000
124349	1397	1285974732000
124350	1678	26640840368000
124351	2134	84889975000
124352	1874	29548000
124353	2133	91434512000
124354	1874	29550000
124365	2133	91433510000
124366	1874	29558000
124367	2133	91432508000
124368	1874	29560000
124369	2306	2879096000000
124370	2306	2879120000000
124389	1397	1285924727000
124390	1678	26640840373000
124391	2134	84884960000
124392	1874	29573000
124393	2133	91429502000
124394	1874	29575000
124395	1671	13344186003785
124396	1671	13344198003785
124459	1637	300247243819988
124462	1643	2588647914700
124463	1643	2588693914700
124495	1397	1285784713000
124496	1678	26640840387000
124497	1397	1285774712000
124498	1678	26640840388000
124499	2134	84871921000
124500	1874	29640000
124501	2133	91415474000
124502	1874	29642000
124503	2133	91414472000
124504	1874	29644000
124505	2134	84870918000
124506	1874	29647000
124507	1587	12240384000000
124508	1587	12240408000000
124560	1397	1285694704000
124561	1678	26640840396000
124562	2134	84862894000
124563	1874	29685000
124564	2133	91406456000
124565	1874	29687000
124574	1555	13926137540449
124575	1555	13926149540449
124578	1874	29371000
124579	1874	29374000
124580	1874	29377000
124581	1874	29387000
124582	1874	29390000
124583	1874	29396000
124584	1874	29398000
124585	1874	29408000
124586	1874	29410000
124587	1874	29414000
124588	1874	29417000
124589	1874	29420000
124590	1874	29426000
124591	1874	29429000
124592	1874	29432000
124593	1874	29435000
124594	1874	29437000
124149	1874	29421000
124150	2133	91460564000
124151	1874	29423000
124152	2133	91459562000
124153	1874	29425000
124154	1671	11904150003785
124155	1671	11904174003785
124188	2039	14299645000000
124189	2039	15019645000000
124190	2039	15019651000000
124194	1684	1400010000
124195	2096	20883349809412
124196	1397	1286174752000
124197	1678	26640840348000
124198	1397	1286164751000
124199	1678	26640840349000
124200	1397	1286154750000
124201	1678	26640840350000
124202	2133	91454552000
124203	1874	29447000
124204	2133	91453550000
124205	1874	29449000
124206	2133	91452548000
124207	1874	29451000
124208	2134	84910035000
124209	1874	29454000
124210	2134	84909032000
124211	1874	29457000
124212	2134	84908029000
124213	1874	29460000
124214	1685	171364266571430
124215	1685	171364308571430
124232	1671	12624174003785
124233	1671	12624186003785
124279	1397	1286064741000
124280	1678	26640840359000
124281	2133	91444532000
124282	1874	29500000
124283	2134	84899002000
124284	1874	29503000
124285	2133	91443530000
124286	1874	29505000
124305	2133	91441526000
124306	1874	29515000
124348	1747	2945998999992
124380	1471	14345437900000
124397	1394	800652971440200
124398	1394	800652983440200
124435	1397	1285874722000
124436	1678	26640840378000
124437	1397	1285864721000
124438	1678	26640840379000
124439	2133	91424492000
124440	1874	29600000
124441	2133	91423490000
124442	1874	29602000
124443	1874	29605000
124464	1397	1285834718000
124465	1678	26640840382000
124466	1397	1285824717000
124467	1678	26640840383000
124468	2134	84875933000
124469	1874	29618000
124470	2134	84874930000
124471	1874	29621000
124472	2133	91420484000
124473	1874	29623000
124474	2133	91419482000
124475	1874	29625000
124476	2148	8640271880750
124477	2148	8640295880750
124549	1764	12322456100000
124550	1764	12322504100000
124557	1614	720012000000
124617	1397	1285674702000
124618	1678	26640840398000
124619	1397	1285664701000
124620	1678	26640840399000
124621	2133	91404452000
124622	1874	29694000
124623	2134	84860888000
124624	1874	29697000
124625	2134	84859885000
124626	1874	29700000
124627	2133	91403450000
124628	1874	29702000
124629	1719	15118638000000
124630	1719	15118662000000
124646	1397	1285634698000
124647	1678	26640840402000
124648	2134	84856876000
124649	1874	29715000
124650	2133	91400444000
124651	1874	29717000
124652	1747	3665998999992
124653	1747	3666010999992
124663	1874	29720000
124664	1714	12525686171760
124680	1397	1285604695000
124681	1678	26640840405000
124682	1397	1285594694000
124683	1678	26640840406000
124684	2292	1439058000000
124685	2134	84852864000
124686	1874	29735000
124687	2133	91396436000
124688	1874	29737000
124689	2133	91395434000
124690	1874	29739000
124691	2134	84851861000
124692	1874	29742000
124693	2292	2159058000000
124779	1397	1285484683000
124780	1678	26640840417000
124781	2134	84840828000
124782	1874	29795000
124783	2133	91384412000
124784	1874	29797000
124785	1394	803532995440200
124786	1394	803533007440200
124818	338	67440026000000
124837	2133	91380404000
124838	1874	29814000
124839	2133	91379402000
124840	2133	91378400000
124841	1874	29818000
124842	1874	29821000
124843	1874	29824000
124844	1874	29827000
124845	1991	12141417355805
124856	1397	1285404675000
124857	1678	26640840425000
124858	1397	1285394674000
124859	1678	26640840426000
124860	2134	84832804000
124861	1874	29835000
124862	2133	91376396000
124863	1874	29837000
124864	2134	84831801000
124865	1874	29840000
124866	2133	91375394000
124867	1874	29842000
124868	1394	803533019440200
124871	1705	21440932580140
124872	1705	21440956580140
124885	1679	33839512653000
124886	1679	33839524653000
124922	1397	1285314666000
124923	1678	26640840434000
124924	2134	84824780000
124925	1874	29877000
124926	2133	91367378000
124927	1874	29879000
124928	1619	5040087000000
124929	1619	5040099000000
124932	1740	13410788000000
124933	1740	13410800000000
124954	1397	1285284663000
124955	1678	26640840437000
124956	2133	91364372000
124957	1874	29891000
124958	2134	84821771000
124959	1874	29894000
124960	1637	301687267819988
124961	1637	301687280819988
124964	1402	34743114145435
124965	1402	34743127145435
124974	1397	1285264661000
124975	1678	26640840439000
124976	1397	1285254660000
124977	1678	26640840440000
124978	2134	84819765000
124979	1874	29902000
124980	2133	91362368000
124981	1874	29904000
124982	2133	91361366000
124983	1874	29906000
124984	2134	84818762000
124985	1874	29909000
124986	2134	84817759000
124987	1874	29912000
124988	1395	58255831227957278
124989	1395	58255831252957278
124991	1703	5040911000000
125019	1397	1285214656000
124482	2133	91418480000
124483	1874	29627000
124484	2134	84873927000
124485	1874	29630000
124486	2133	91417478000
124487	1874	29632000
124488	1587	11520384000000
124509	1705	20720908580140
124510	1705	20720932580140
124566	1397	1285684703000
124567	1678	26640840397000
124568	2134	84861891000
124569	1874	29690000
124570	2133	91405454000
124571	1874	29692000
124572	1444	11607831329999
124573	1444	11607843329999
124576	1692	6220714619999
124577	1692	6220726619999
124669	2133	91398440000
124670	1874	29727000
124671	1684	21603317819412
124694	1747	3666030999992
124695	1747	4386030999992
124696	1747	4386034999992
124702	1397	1285584693000
124703	1678	26640840407000
124704	1397	1285574692000
124705	1678	26640840408000
124706	2133	91394432000
124707	1874	29744000
124708	2324	19000000
124709	2232	9179000000
124710	2134	84850858000
124711	1874	29747000
124712	2134	84849855000
124713	1874	29750000
124714	2133	91393430000
124715	1874	29752000
124716	1623	74163218898598
124717	1623	74163243898598
124718	1397	1285564691000
124719	1678	26640840409000
124720	1397	1285554690000
124721	1678	26640840410000
124722	1397	1285544689000
124723	1678	26640840411000
124724	1397	1285534688000
124725	1678	26640840412000
124726	2134	84848852000
124727	1874	29755000
124728	2134	84847849000
124729	1874	29758000
124730	2134	84846846000
124731	1874	29761000
124732	2133	91392428000
124733	1874	29763000
124734	2133	91391426000
124735	1874	29765000
124736	2134	84845843000
124737	1874	29768000
124738	2133	91390424000
124739	1874	29770000
124740	2133	91389422000
124741	1874	29772000
124742	1980	22319508000000
124743	1980	22319556000000
124766	1687	8048972848312
124767	1687	8048983848312
124769	1397	1285494684000
124770	1678	26640840416000
124771	2134	84841831000
124772	1874	29790000
124773	1536	16560326000000
124774	1536	16560337000000
124804	1714	13245687171760
124805	1714	13245698171760
124807	1397	1285454680000
124808	1678	26640840420000
124809	2134	84837819000
124810	1874	29810000
124811	2133	91381406000
124812	1874	29812000
124813	1448	10039852000001
124819	1874	29808000
124820	338	67440027000000
124821	1397	1285444679000
124822	1678	26640840421000
124823	1397	1285434678000
124824	1678	26640840422000
124825	1397	1285424677000
124826	1678	26640840423000
124827	2134	84836816000
124828	1874	29813000
124829	2134	84835813000
124830	1874	29816000
124831	2134	84834810000
124832	1874	29819000
124833	1679	33119500653000
124834	1679	33119533653000
124846	1686	14072125700123
124847	1402	34023077145435
124848	1402	34023114145435
124873	1397	1285384673000
124874	1678	26640840427000
124875	2133	91374392000
124876	1874	29844000
124877	1693	4310955570272
124878	1693	4310966570272
124962	1764	12323456100000
124963	1513	35281205000000
124992	1397	1285244659000
124993	1678	26640840441000
124994	1397	1285234658000
124995	1678	26640840442000
124996	1397	1285224657000
124997	1678	26640840443000
124998	2133	91360364000
124999	1874	29914000
125000	2133	91359362000
125001	1874	29916000
125002	2133	91358360000
125003	1874	29918000
125004	1422	13194707804270
125005	1422	13194740804270
125016	58	73187404999641
125046	1397	1285184653000
125047	1678	26640840447000
125048	2133	91354352000
125049	1874	29944000
125050	2134	84810738000
125051	1874	29947000
125052	1402	35463127145435
125053	1402	35463139145435
125069	1397	1285154650000
125070	1678	26640840450000
125071	2133	91351346000
125072	1874	29959000
125073	2134	84807729000
125074	1874	29962000
125075	1395	58256551252957278
125076	1395	58256551264957278
125097	1397	1285114646000
125098	1678	26640840454000
125099	2133	91347338000
125100	1874	29979000
125101	2134	84803717000
125102	1874	29982000
125125	1397	1285074642000
125126	1678	26640840458000
125127	2134	84799705000
125128	1874	30000000
125129	2133	91343330000
125130	1874	30002000
125131	1710	12474046664140
125158	1397	1285034638000
125159	1678	26640840462000
125160	2134	84795693000
125161	1874	30020000
125162	2133	91339322000
125163	1874	30022000
125164	1769	1571700000
125165	1769	1570700000
125166	1680	11533336499559
125169	1690	178565784000000
125170	1690	178565787000000
125173	1692	8380776619999
125176	2134	84794690000
125177	1874	30025000
125178	1690	177845785000000
125179	1791	308000048
125180	1690	178565685000000
125200	58	73907404999641
125201	58	73907427999641
125207	1397	1284994634000
125208	1678	26640840466000
125209	2134	84792684000
125210	1874	30037000
125211	1769	1569700000
125212	2133	91335314000
125213	1874	30039000
125214	1395	58257271277957278
125216	1397	1284984633000
125217	1678	26640840467000
125218	2133	91334312000
124490	1678	26640840386000
124491	2133	91416476000
124492	1874	29634000
124493	2134	84872924000
124494	1874	29637000
124511	1397	1285764711000
124512	1678	26640840389000
124513	1397	1285754710000
124514	1678	26640840390000
124515	2134	84869915000
124516	1874	29650000
124517	2134	84868912000
124518	1874	29653000
124519	2133	91413470000
124520	1874	29655000
124521	2133	91412468000
124522	1874	29657000
124523	1694	15659047197225
124524	1397	1285744709000
124525	1678	26640840391000
124526	1397	1285734708000
124527	1678	26640840392000
124528	1397	1285724707000
124529	1678	26640840393000
124530	1397	1285714706000
124531	1678	26640840394000
124532	2133	91411466000
124533	1874	29659000
124534	2134	84867909000
124535	1874	29662000
124536	2133	91410464000
124537	1874	29664000
124538	2134	84866906000
124539	1874	29667000
124540	2134	84865903000
124541	1874	29670000
124542	2133	91409462000
124543	1874	29672000
124544	2133	91408460000
124545	1874	29674000
124546	2134	84864900000
124547	1874	29677000
124548	162	68160070000000
124551	1397	1285704705000
124552	1678	26640840395000
124553	2134	84863897000
124554	1874	29680000
124555	2133	91407458000
124556	1874	29682000
124558	1692	5500702619999
124559	1692	5500714619999
124631	1474	8550488000043
124632	1474	8550512000043
124654	1397	1285624697000
124655	1678	26640840403000
124656	2133	91399442000
124657	1874	29719000
124658	2232	1199000000
124659	2324	8000000000
124660	2134	84855873000
124661	1874	29722000
124662	1685	172084321571430
124744	1397	1285524687000
124745	1678	26640840413000
124746	1397	1285514686000
124747	1678	26640840414000
124748	2133	91388420000
124749	1874	29774000
124750	2134	84844840000
124751	1874	29777000
124752	2134	84843837000
124753	1874	29780000
124754	2133	91387418000
124755	1874	29782000
124756	1622	7523965800048
124757	1622	7523989800048
124787	1691	10511120300052
124788	1397	1285474682000
124789	1678	26640840418000
124790	2134	84839825000
124791	1874	29800000
124792	2133	91383410000
124793	1874	29802000
124794	1690	177845772000000
124795	1690	177845784000000
124814	2106	2880150000000
124815	2106	2880162000000
124835	1686	14072088700123
124836	1686	14072121700123
124869	1637	300967243819988
124870	1637	300967267819988
124887	1397	1285364671000
124888	1678	26640840429000
124889	1397	1285354670000
124890	1678	26640840430000
124891	2134	84829795000
124892	1874	29852000
124893	2133	91372388000
124894	1874	29854000
124895	2133	91371386000
124896	1874	29856000
124897	2134	84828792000
124898	1874	29859000
124899	1672	10081411000000
124900	1672	10081435000000
124901	1397	1285344669000
124902	1678	26640840431000
124903	1397	1285334668000
124904	1678	26640840432000
124905	1397	1285324667000
124906	1678	26640840433000
124907	2134	84827789000
124908	1874	29862000
124909	2133	91370384000
124910	1874	29864000
124911	2133	91369382000
124912	1874	29866000
124913	2133	91368380000
124914	1874	29868000
124915	1624	1001000000
124916	1764	13043504100000
124917	2134	84826786000
124918	1874	29871000
124919	2134	84825783000
124920	1874	29874000
124921	1610	9360224999950
124930	1633	8688635125277
124931	1633	8688647125277
124966	1397	1285274662000
124967	1678	26640840438000
124968	2134	84820768000
124969	1874	29897000
124970	2133	91363370000
124971	1874	29899000
124972	610	68160024000000
124973	610	68160036000000
124990	1702	6480548000000
125027	1692	6940726619999
125028	1692	6940738619999
125037	1634	13343063259504
125054	1397	1285174652000
125055	1678	26640840448000
125056	1397	1285164651000
125057	1678	26640840449000
125058	2134	84809735000
125059	1874	29950000
125060	2134	84808732000
125061	1874	29953000
125062	2133	91353350000
125063	1874	29955000
125064	2133	91352348000
125065	1874	29957000
125066	1520	720100000026
125067	1520	720124000026
125154	1657	6481290990100
125155	1657	6481314990100
125171	369	78036561290830
125172	369	78036575290830
125181	1397	1285024637000
125182	1678	26640840463000
125183	1448	9319850000001
125184	2133	91338320000
125185	1874	30024000
125186	1874	30027000
125187	1448	10039850000001
125190	1419	25486156559748
125191	1419	25486160559748
125224	1422	13194719804270
125225	1397	1284974632000
125226	1678	26640840468000
125227	2134	84790678000
125228	1874	30047000
125229	2133	91333310000
125230	1874	30049000
125231	1714	13965699171760
125232	1714	13965711171760
125243	641	78963909000000
125244	641	78963921000000
125251	1746	4128934999989
125252	1746	4128946999989
125263	1397	1284934628000
125264	1678	26640840472000
125265	2134	84786666000
125266	1874	30067000
125267	2133	91329302000
124595	1874	29439000
124596	1555	13207127540449
124597	1874	29441000
124598	1874	29453000
124599	1874	29455000
124600	1874	29459000
124601	1874	29461000
124602	1874	29463000
124603	1874	29467000
124604	1874	29469000
124605	1874	29471000
124606	1874	29475000
124607	1874	29477000
124608	1874	29479000
124609	1874	29483000
124610	1874	29485000
124611	1874	29487000
124612	1874	29489000
124613	1874	29491000
124614	1555	13927127540449
124615	1571	13927153540441
124616	1555	9260664124170
124633	1397	1285654700000
124634	1678	26640840400000
124635	1397	1285644699000
124636	1678	26640840401000
124637	2134	84858882000
124638	1874	29705000
124639	2134	84857879000
124640	1874	29708000
124641	2133	91402448000
124642	1874	29710000
124643	2133	91401446000
124644	1874	29712000
124645	1395	58255111227957278
124665	2134	84854870000
124666	1874	29725000
124667	1684	21603315819412
124668	1684	21603316819412
124672	1397	1285614696000
124673	1678	26640840404000
124674	2134	84853867000
124675	1874	29730000
124676	2133	91397438000
124677	1874	29732000
124678	1394	802092983440200
124679	1394	802092995440200
124697	1746	2688931000000
124698	1746	3408931000000
124699	1746	100000026
124700	1520	3408934999989
124701	1807	200000008
124758	1397	1285504685000
124759	1678	26640840415000
124760	2134	84842834000
124761	1874	29785000
124762	2133	91386416000
124763	1874	29787000
124764	1588	15121822000000
124765	1588	15121834000000
124768	1687	8048984848312
124775	2133	91385414000
124776	1874	29789000
124777	1874	29792000
124778	1536	16560338000000
124796	1397	1285464681000
124797	1678	26640840419000
124798	2134	84838822000
124799	1874	29805000
124800	2133	91382408000
124801	1874	29807000
124802	1708	9720574500051
124803	1708	9720586500051
124806	1714	13245699171760
124816	338	67440014000000
124817	338	67440025000000
124849	1397	1285414676000
124850	1678	26640840424000
124851	2133	91377398000
124852	1874	29829000
124853	2134	84833807000
124854	1874	29832000
124855	1679	33119512653000
124879	1397	1285374672000
124880	1678	26640840428000
124881	2134	84830798000
124882	1874	29847000
124883	2133	91373390000
124884	1874	29849000
124934	1397	1285304665000
124935	1678	26640840435000
124936	1509	12623303503835
124937	2133	91366376000
124938	1874	29881000
124939	2134	84823777000
124940	1874	29884000
124941	1509	13343303503835
124942	1509	66000000001350
124943	45	13343305503785
124944	1397	1285294664000
124945	1678	26640840436000
124946	2133	91365374000
124947	1874	29886000
124948	2134	84822774000
124949	1874	29889000
124950	1675	16844402999977
124951	1675	16844414999977
124952	1874	29887000
124953	1675	16844413999977
125006	2134	84816756000
125007	1874	29917000
125008	2134	84815753000
125009	1874	29920000
125010	2134	84814750000
125011	1874	29923000
125012	1874	29925000
125013	1874	29927000
125014	576	77597642726897
125015	576	77597678726897
125017	497	67440023000000
125018	497	67440059000000
125038	1397	1285194654000
125039	1678	26640840446000
125040	2133	91355354000
125041	1874	29939000
125042	2134	84811741000
125043	1874	29942000
125044	1471	15065437900000
125045	1471	15065449900000
125077	1397	1285144649000
125078	1678	26640840451000
125079	2134	84806726000
125080	1874	29965000
125081	2133	91350344000
125082	1874	29967000
125103	1692	7660750619999
125104	1692	7660762619999
125132	1397	1285064641000
125133	1678	26640840459000
125134	2134	84798702000
125135	1874	30005000
125136	2133	91342328000
125137	1874	30007000
125138	1474	9990524000043
125139	1474	9990536000043
125167	1536	17280338000000
125168	1536	17280352000000
125174	1419	25486259559748
125175	1419	25486263559748
125215	1587	12240397000000
125253	1747	4386010999992
125254	1747	4386022999992
125255	1397	1284944629000
125256	1678	26640840471000
125257	2133	91330304000
125258	1874	30061000
125259	2134	84787669000
125260	1874	30064000
125292	685	66720000000000
125293	685	66720012000000
125317	1397	1284874622000
125318	1678	26640840478000
125319	2134	84780648000
125320	1874	30097000
125321	2133	91323290000
125322	1874	30099000
125323	2307	2159048000000
125324	2307	2159060000000
125326	1397	1284864621000
125327	1678	26640840479000
125328	2134	84779645000
125329	1874	30102000
125330	2133	91322288000
125331	1874	30104000
125332	1394	804973019440200
125333	1394	804973031440200
125361	1541	5042338000000
125383	1684	22323317819412
125384	1684	22323330819412
125431	1601	6145918620000
125432	1601	6865918620000
125433	1601	6865921620000
125441	1747	4386021999992
125452	1397	1284714606000
125453	1678	26640840494000
125020	1678	26640840444000
125021	2134	84813747000
125022	1874	29930000
125023	2133	91357358000
125024	1874	29932000
125025	1474	9270512000043
125026	1474	9270524000043
125029	1397	1285204655000
125030	1678	26640840445000
125031	2134	84812744000
125032	1874	29935000
125033	2133	91356356000
125034	1874	29937000
125035	1426	12570379000000
125036	1426	12570391000000
125068	1692	6940750619999
125083	1397	1285134648000
125084	1678	26640840452000
125085	1397	1285124647000
125086	1678	26640840453000
125087	2133	91349342000
125088	1874	29969000
125089	2133	91348340000
125090	1874	29971000
125091	2134	84805723000
125092	1874	29974000
125093	2134	84804720000
125094	1874	29977000
125095	641	78243885000000
125096	641	78243909000000
125105	1397	1285104645000
125106	1678	26640840455000
125107	1397	1285094644000
125108	1678	26640840456000
125109	1397	1285084643000
125110	1678	26640840457000
125111	2133	91346336000
125112	1874	29984000
125113	2133	91345334000
125114	1874	29986000
125115	2134	84802714000
125116	1874	29989000
125117	2134	84801711000
125118	1874	29992000
125119	2134	84800708000
125120	1874	29995000
125121	2133	91344332000
125122	1874	29997000
125123	2041	2879400000000
125124	2041	2879436000000
125140	1397	1285054640000
125141	1678	26640840460000
125142	1397	1285044639000
125143	1678	26640840461000
125144	2133	91341326000
125145	1874	30009000
125146	2133	91340324000
125147	1874	30011000
125148	2134	84797699000
125149	1874	30014000
125150	2134	84796696000
125151	1874	30017000
125152	1671	14784223003785
125153	1671	14784247003785
125156	1692	8380762619999
125157	1692	8380786619999
125188	2106	2160160000000
125189	2106	2880160000000
125192	1397	1285014636000
125193	1678	26640840464000
125194	2133	91337318000
125195	1874	30029000
125196	2134	84793687000
125197	1874	30032000
125198	1395	58257271264957278
125199	1395	58257271287957278
125202	1397	1285004635000
125203	1678	26640840465000
125204	2133	91336316000
125205	1874	30034000
125206	1701	13678360500103
125233	1397	1284964631000
125234	1678	26640840469000
125235	2133	91332308000
125236	1874	30051000
125237	2134	84789675000
125238	1874	30054000
125239	1686	14072100700123
125261	1419	26206263559748
125262	1419	26206264559748
125271	1439	12223769578477
125272	1439	12223781578477
125275	1764	13763504100000
125276	1764	13763516100000
125284	1874	30070000
125285	1874	30072000
125314	1701	14398360500103
125315	1701	14398384500103
125334	1397	1284854620000
125335	1678	26640840480000
125336	1397	1284844619000
125337	1678	26640840481000
125338	2134	84778642000
125339	1874	30107000
125340	2133	91321286000
125341	1874	30109000
125342	2133	91320284000
125343	1874	30111000
125344	2134	84777639000
125345	1874	30114000
125346	1693	5750978570272
125347	1693	5751002570272
125362	610	68160048000000
125364	1397	1284814616000
125365	1678	26640840484000
125366	2134	84774630000
125367	1874	30127000
125368	2133	91317278000
125369	1874	30129000
125372	1397	1284804615000
125373	1678	26640840485000
125374	2134	84773627000
125375	1874	30132000
125376	610	67438023000000
125377	2325	1000000000
125378	1451	4747771000000
125379	1451	4747783000000
125434	1397	1284734608000
125435	1678	26640840492000
125436	2133	91309262000
125437	1874	30166000
125438	1746	4848946999989
125439	1746	4848957999989
125548	1598	720048000000
125600	1397	1284534588000
125601	1678	26640840512000
125602	2134	84747549000
125603	1874	30264000
125604	2133	91289222000
125605	1874	30266000
125606	1708	10440586500051
125607	1708	10440598500051
125635	1397	1284494584000
125636	1678	26640840516000
125637	2134	84743537000
125638	1874	30284000
125639	2133	91285214000
125640	1874	30286000
125641	547	66000009000000
125642	2326	719000000000
125643	1489	10463092040000
125644	1489	10463105040000
125647	1679	34559537653000
125650	1397	1284484583000
125651	1678	26640840517000
125652	2133	91284212000
125653	1874	30288000
125654	2134	84742534000
125655	1874	30291000
125656	1637	301687279819988
125682	1397	1284454580000
125683	1678	26640840520000
125684	2133	91281206000
125685	1874	30303000
125686	1395	58258711300957278
125691	632	77517636000000
125706	1397	1284424577000
125707	1678	26640840523000
125708	1397	1284414576000
125709	1678	26640840524000
125710	1397	1284404575000
125711	1678	26640840525000
125712	2134	84737519000
125713	1874	30316000
125714	2134	84736516000
125715	1874	30319000
125716	2030	199000000
125717	2133	91278200000
125718	1874	30321000
125719	2133	91277198000
125720	1874	30323000
125721	2133	91276196000
125722	1874	30325000
125723	2134	84735513000
125724	1874	30328000
125219	1874	30041000
125220	2134	84791681000
125221	1874	30044000
125222	1693	5030966570272
125223	1693	5030978570272
125240	1874	30050000
125241	1874	30052000
125242	1560	15848855131803
125245	1397	1284954630000
125246	1678	26640840470000
125247	2134	84788672000
125248	1874	30057000
125249	2133	91331306000
125250	1874	30059000
125286	1397	1284914626000
125287	1678	26640840474000
125288	2133	91327298000
125289	1874	30076000
125290	2134	84784660000
125291	1874	30079000
125294	1397	1284904625000
125295	1678	26640840475000
125296	2134	84783657000
125297	1874	30082000
125298	2133	91326296000
125299	1874	30084000
125300	1623	74883243898598
125301	1623	74883255898598
125325	1506	7200216967172
125348	1397	1284834618000
125349	1678	26640840482000
125350	1397	1284824617000
125351	1678	26640840483000
125352	2134	84776636000
125353	1874	30117000
125354	2134	84775633000
125355	1874	30120000
125356	2133	91319282000
125357	1874	30122000
125358	2133	91318280000
125359	1874	30124000
125360	1608	12378516000000
125363	1718	8178620519070
125380	2133	91316276000
125381	1874	30134000
125382	1451	4747784000000
125385	1451	4747773000000
125388	1397	1284794614000
125389	1678	26640840486000
125390	2134	84772624000
125391	1874	30135000
125392	1874	30137000
125393	2133	91315274000
125394	1874	30139000
125395	1397	1284784613000
125396	1678	26640840487000
125397	1397	1284774612000
125398	1678	26640840488000
125399	1397	1284764611000
125400	1678	26640840489000
125401	1397	1284754610000
125402	1678	26640840490000
125403	1397	1284744609000
125404	1678	26640840491000
125405	2134	84771621000
125406	1874	30142000
125407	610	66000022000000
125408	1718	8896596519070
125409	2134	84770618000
125410	1874	30145000
125411	2134	84769615000
125412	1874	30148000
125413	2134	84768612000
125414	1874	30151000
125415	2134	84767609000
125416	1874	30154000
125417	2133	91314272000
125418	1874	30156000
125419	2133	91313270000
125420	1874	30158000
125421	2133	91312268000
125422	1874	30160000
125423	1608	12378575000000
125424	610	66000021000000
125425	2133	91311266000
125426	1874	30162000
125427	2133	91310264000
125428	1874	30164000
125429	1608	13098575000000
125430	1608	13098578000000
125440	2292	2159049000000
125442	1394	806413031440200
125443	1394	806413042440200
125460	1611	6242386241757
125461	1611	6242398241757
125490	1397	1284674602000
125491	1678	26640840498000
125492	2134	84761591000
125493	1874	30194000
125494	2133	91303250000
125495	1874	30196000
125496	1395	58257991277957278
125497	1395	58257991289957278
125500	1397	1284664601000
125501	1678	26640840499000
125502	2134	84760588000
125503	1874	30199000
125504	2133	91302248000
125505	1874	30201000
125508	1397	1284654600000
125509	1678	26640840500000
125510	2133	91301246000
125511	1874	30203000
125512	2134	84759585000
125513	1874	30206000
125514	1768	19907045110000
125515	1768	19907057110000
125516	1397	1284644599000
125517	1678	26640840501000
125518	1397	1284634598000
125519	1678	26640840502000
125520	2134	84758582000
125521	1874	30209000
125522	2134	84757579000
125523	1874	30212000
125524	2133	91300244000
125525	1874	30214000
125526	2133	91299242000
125527	1874	30216000
125528	1693	6471002570272
125529	1693	6471026570272
125532	1623	76323267898598
125570	1560	15848856131803
125571	1397	1284574592000
125572	1678	26640840508000
125573	1397	1284564591000
125574	1678	26640840509000
125575	1397	1284554590000
125576	1678	26640840510000
125577	2134	84751561000
125578	1874	30244000
125579	2134	84750558000
125580	1874	30247000
125581	2133	91293230000
125582	1874	30249000
125583	2133	91292228000
125584	1874	30251000
125585	2133	91291226000
125586	1874	30253000
125587	2134	84749555000
125588	1874	30256000
125589	1394	807853042440200
125590	1394	807853078440200
125593	1397	1284544589000
125594	1678	26640840511000
125595	2133	91290224000
125596	1874	30258000
125597	2134	84748552000
125598	1874	30261000
125599	1679	34559536653000
125608	1397	1284524587000
125609	1678	26640840513000
125610	1397	1284514586000
125611	1678	26640840514000
125612	547	66719010000000
125613	2326	0
125614	2133	91288220000
125615	1874	30268000
125616	2133	91287218000
125617	1874	30270000
125618	2134	84746546000
125619	1874	30273000
125620	2134	84745543000
125621	1874	30276000
125622	1395	58258711289957278
125623	1395	58258711314957278
125625	1397	1284504585000
125626	1678	26640840515000
125627	2133	91286216000
125628	1874	30278000
125629	2134	84744540000
125630	1874	30281000
125631	1688	69119310720020
125632	1688	69119322720020
125657	470	78240369000000
125268	1874	30069000
125269	43	74640103890000
125270	43	74640115890000
125273	1419	26206160559748
125274	1419	26206161559748
125277	1397	1284924627000
125278	1678	26640840473000
125279	2133	91328300000
125280	1874	30071000
125281	2134	84785663000
125282	1874	30074000
125283	576	77597654726897
125302	1397	1284894624000
125303	1678	26640840476000
125304	1397	1284884623000
125305	1678	26640840477000
125306	2134	84782654000
125307	1874	30087000
125308	2134	84781651000
125309	1874	30090000
125310	2133	91325294000
125311	1874	30092000
125312	2133	91324292000
125313	1874	30094000
125316	1506	7200209967172
125370	1688	68399298720020
125371	1688	68399310720020
125386	1602	12096670170000
125387	1602	12096683170000
125444	1402	36183139145435
125445	1402	36183150145435
125446	1397	1284724607000
125447	1678	26640840493000
125448	2134	84766606000
125449	1874	30169000
125450	2133	91308260000
125451	1874	30171000
125478	1397	1284684603000
125479	1678	26640840497000
125480	685	66000011000000
125481	1933	2539268000000
125482	2134	84762594000
125483	1874	30189000
125484	2133	91304252000
125485	1874	30191000
125486	1668	12033734000000
125487	1668	12033747000000
125498	1622	8243989800048
125499	1622	8244001800048
125530	1555	14646149540449
125531	1555	14646173540449
125533	1397	1284624597000
125534	1678	26640840503000
125535	1397	1284614596000
125536	1678	26640840504000
125537	2134	84756576000
125538	1874	30215000
125539	2134	84755573000
125540	1874	30218000
125541	1874	30220000
125542	1874	30222000
125543	2133	91298240000
125544	1874	30224000
125545	2133	91297238000
125546	1874	30226000
125547	632	77517673000000
125549	1397	1284604595000
125550	1678	26640840505000
125551	2133	91296236000
125552	1874	30228000
125553	1692	8380773619999
125645	1394	809293067440200
125646	1394	809293080440200
125648	1513	36001205000000
125649	1513	36001213000000
125660	1688	69839322720020
125661	1688	69839334720020
125672	1702	6480536000000
125741	1397	1284374572000
125742	1678	26640840528000
125743	2133	91273190000
125744	1874	30340000
125745	2134	84732504000
125746	1874	30343000
125747	1711	14826988000000
125748	1711	14827000000000
125749	1397	1284364571000
125750	1678	26640840529000
125751	2133	91272188000
125752	1874	30345000
125753	2134	84731501000
125754	1874	30348000
125755	1746	4848958999989
125780	171	76026807696494
125848	1637	302407291819988
125854	1694	16379048197225
125870	1394	809293091440200
125886	1657	6481323990100
125900	1397	1284214556000
125901	1678	26640840544000
125902	2133	91257158000
125903	1874	30405000
125904	1394	809293078440200
125906	1397	1284204555000
125907	1678	26640840545000
125908	2133	91256156000
125909	1874	30407000
125910	1402	37623199145435
125930	1634	13343062259504
125936	1596	7200255000002
125937	1596	7200266000002
125943	1397	1284144549000
125944	1678	26640840551000
125945	1397	1284134548000
125946	1678	26640840552000
125947	1397	1284124547000
125948	1678	26640840553000
125949	1397	1284114546000
125950	1678	26640840554000
125951	1397	1284104545000
125952	1678	26640840555000
125953	2133	91250144000
125954	1874	30419000
125955	2133	91249142000
125956	1874	30421000
125957	2133	91248140000
125958	1874	30423000
125959	2133	91247138000
125960	1874	30425000
125961	2133	91246136000
125962	1874	30427000
125963	2133	91245134000
125964	1874	30429000
125965	45	66000000001310
125966	1395	58260151324957268
125967	416	58260151362557268
125968	1395	66000028400000
125971	1397	1284094544000
125972	1678	26640840556000
125973	2133	91244132000
125974	1874	30431000
125975	1471	15785449900000
125976	1471	15785460900000
125987	1708	11160598500051
125988	1708	11160619500051
125995	1397	1284064541000
125996	1678	26640840559000
125997	2133	91241126000
125998	1874	30437000
125999	1395	58260151335957278
126018	1394	812173123440200
126021	1397	1284024537000
126022	1678	26640840563000
126023	2133	91237118000
126024	1874	30445000
126025	1394	813613123440200
126026	1394	813613134440200
126029	1685	172804320571430
126030	1685	172804331571430
126056	1397	1283974532000
126057	1678	26640840568000
126058	2133	91232108000
126059	1874	30455000
126060	2086	2880378300069
126062	1699	3600353750126
126069	1397	1283954530000
126070	1678	26640840570000
126071	1397	1283944529000
126072	1678	26640840571000
126073	1397	1283934528000
126074	1678	26640840572000
126075	2133	91230104000
126076	1874	30459000
126077	2133	91229102000
126078	1874	30461000
126079	2133	91228100000
126080	1874	30463000
126081	1394	815053134440200
126082	1394	815053167440200
126088	1397	1283914526000
126089	1678	26640840574000
126090	1397	1283904525000
126091	1678	26640840575000
126092	2133	91226096000
126093	1874	30467000
125454	2133	91307258000
125455	1874	30173000
125456	2134	84765603000
125457	1874	30176000
125458	1684	22323329819412
125459	1402	36183151145435
125462	1397	1284704605000
125463	1678	26640840495000
125464	1397	1284694604000
125465	1678	26640840496000
125466	2133	91306256000
125467	1874	30178000
125468	2134	84764600000
125469	1874	30181000
125470	2134	84763597000
125471	1874	30184000
125472	2133	91305254000
125473	1874	30186000
125474	1768	19187021110000
125475	1768	19187045110000
125476	1679	34559524653000
125477	1679	34559548653000
125488	1474	10710536000043
125489	1474	10710549000043
125506	1623	75603255898598
125507	1623	75603267898598
125554	1397	1284594594000
125555	1678	26640840506000
125556	1397	1284584593000
125557	1678	26640840507000
125558	2133	91295234000
125559	1874	30230000
125560	2133	91294232000
125561	1874	30232000
125562	2134	84754570000
125563	1874	30235000
125564	2134	84753567000
125565	1874	30238000
125566	2134	84752564000
125567	1874	30241000
125568	2148	9360295880750
125569	2148	9360320880750
125591	1714	14685711171760
125592	1714	14685747171760
125624	1394	807853067440200
125633	1601	7585921620000
125634	1601	7585933620000
125659	1419	23326167559748
125662	1397	1284474582000
125663	1678	26640840518000
125664	547	66000004000000
125665	2326	719004000000
125666	2133	91283210000
125667	1874	30293000
125668	2134	84741531000
125669	1874	30296000
125689	1687	8768984848312
125690	1687	8768995848312
125692	1397	1284444579000
125693	1678	26640840521000
125694	1397	1284434578000
125695	1678	26640840522000
125696	2134	84739525000
125697	1874	30306000
125698	2134	84738522000
125699	1874	30309000
125700	2133	91280204000
125701	1874	30311000
125702	2133	91279202000
125703	1874	30313000
125704	606	75406807286230
125705	606	75406831286230
125762	1874	30351000
125763	1686	14072089700123
125831	2134	84726486000
125832	1874	30371000
125833	2134	84725483000
125834	1874	30374000
125835	2133	91267178000
125836	1874	30376000
125837	2133	91266176000
125838	1874	30378000
125839	1706	14682208450256
125852	1694	16379047197225
125853	1694	16379059197225
125855	1397	1284284563000
125856	1678	26640840537000
125857	1397	1284274562000
125858	1678	26640840538000
125859	2134	84723477000
125860	1874	30386000
125861	2134	84722474000
125862	1874	30389000
125863	2133	91264172000
125864	1874	30391000
125865	2133	91263170000
125866	1874	30393000
125867	1746	4848970999989
125887	1397	1284234558000
125888	1678	26640840542000
125889	2133	91259162000
125890	1874	30401000
125891	2039	15019615000000
125892	2039	15019626000000
125894	1397	1284224557000
125895	1678	26640840543000
125896	2133	91258160000
125897	1874	30403000
125898	1710	12474045664140
125911	1397	1284194554000
125912	1678	26640840546000
125913	1397	1284184553000
125914	1678	26640840547000
125915	2133	91255154000
125916	1874	30409000
125917	2133	91254152000
125918	1874	30411000
125919	1564	11886713000000
125920	1564	11886735000000
125923	1690	179285685000000
125924	1690	179285707000000
125938	1397	1284154550000
125939	1678	26640840550000
125940	2133	91251146000
125941	1874	30417000
125942	1394	809293089440200
125977	470	77519349000000
125978	2327	10000000
125979	1397	1284084543000
125980	1678	26640840557000
125981	2133	91243130000
125982	1874	30433000
125983	2039	15739626000000
125984	2039	15739647000000
125994	1705	21440943580140
126019	564	67440011000000
126020	564	67440045000000
126049	1709	7200155000000
126083	1397	1283924527000
126084	1678	26640840573000
126085	2133	91227098000
126086	1874	30465000
126087	1457	12960254800000
126104	1397	1283884523000
126105	1678	26640840577000
126106	1397	1283874522000
126107	1678	26640840578000
126108	1678	26640830578000
126109	2133	91223090000
126110	1874	30473000
126111	2133	91222088000
126112	1874	30475000
126113	1688	70559333720020
126114	1688	70559365720020
126127	1397	1283844519000
126128	1678	26640830581000
126129	2133	91219082000
126130	1874	30481000
126131	1536	17280349000000
126150	1397	1283794514000
126151	1678	26640830586000
126152	1688	71279365720020
126153	1688	71279375720020
126154	1397	1283784513000
126155	1678	26640830587000
126156	1397	1283774512000
126157	1678	26640830588000
126158	1397	1283764511000
126159	1678	26640830589000
126160	1397	1283754510000
126161	1678	26640830590000
126162	2133	91214072000
126163	1874	30491000
126164	2133	91213070000
126165	1874	30493000
126166	2133	91212068000
126167	1874	30495000
126168	1762	7845628994000
126169	1791	408000048
126170	1762	8565528994000
126183	1801	1439065000000
126199	1521	2160069000000
126227	1573	6339409000000
126260	1695	10025130999000
126261	1695	10025153999000
125658	470	78240381000000
125670	1703	5760898000000
125671	1703	5760911000000
125673	1397	1284464581000
125674	1678	26640840519000
125675	2326	719003000000
125676	2134	84740528000
125677	1874	30299000
125678	2133	91282208000
125679	1874	30301000
125680	1768	20627057110000
125681	1768	20627070110000
125687	1637	302407279819988
125688	1637	302407290819988
125727	1397	1284394574000
125728	1678	26640840526000
125729	1397	1284384573000
125730	1678	26640840527000
125731	2133	91275194000
125732	1874	30330000
125733	2133	91274192000
125734	1874	30332000
125735	2134	84734510000
125736	1874	30335000
125737	2134	84733507000
125738	1874	30338000
125739	1395	58259431300957278
125740	1395	58259431324957278
125756	1397	1284354570000
125757	1678	26640840530000
125758	2133	91271186000
125759	1874	30350000
125760	2134	84730498000
125761	1874	30353000
125778	1588	15121857000000
125789	1397	1284314566000
125790	1678	26640840534000
125791	1397	1284304565000
125792	1678	26640840535000
125793	1874	30073000
125794	1874	30075000
125795	1874	30078000
125796	1874	30081000
125797	1874	30093000
125798	1874	30096000
125799	1706	13962830450256
125800	1874	30101000
125801	1874	30103000
125802	1874	30105000
125803	1874	30113000
125804	1874	30115000
125805	1874	30119000
125806	1874	30121000
125807	1874	30123000
125808	1874	30125000
125809	1874	30131000
125810	1874	30133000
125811	1874	30141000
125812	1874	30143000
125813	1874	30147000
125814	1874	30149000
125815	1874	30153000
125816	1874	30155000
125817	1874	30157000
125818	1874	30159000
125819	1874	30161000
125820	1874	30163000
125821	1874	30165000
125822	1874	30167000
125823	1874	30175000
125824	1874	30177000
125825	1874	30179000
125826	1874	30183000
125827	1874	30185000
125828	1874	30187000
125829	1706	14682830450256
125830	1706	14682876450256
125850	1402	37623188145435
125851	1402	37623200145435
125893	470	78240380000000
125921	1394	810733078440200
125922	1394	810733100440200
125989	1397	1284074542000
125990	1678	26640840558000
125991	2133	91242128000
125992	1874	30435000
125993	1546	11037455800000
126002	1397	1284054540000
126003	1678	26640840560000
126004	1397	1284044539000
126005	1678	26640840561000
126006	1397	1284034538000
126007	1678	26640840562000
126008	2133	91240124000
126009	1874	30439000
126010	2133	91239122000
126011	1874	30441000
126012	2133	91238120000
126013	1874	30443000
126014	2073	776166541448
126015	106	66001000000000
126016	576	78317654726897
126017	576	78317688726897
126036	1395	58260871335957278
126037	1395	58260871346957278
126039	1397	1284004535000
126040	1678	26640840565000
126041	1397	1283994534000
126042	1678	26640840566000
126043	2133	91235114000
126044	1874	30449000
126045	2133	91234112000
126046	1874	30451000
126047	1698	12308966550062
126048	1698	12308988550062
126063	1397	1283964531000
126064	1678	26640840569000
126065	2133	91231106000
126066	1874	30457000
126067	1623	77043267898598
126068	1623	77043278898598
126132	1397	1283834518000
126133	1678	26640830582000
126134	2133	91218080000
126135	1874	30483000
126136	1397	1283824517000
126137	1678	26640830583000
126138	1397	1283814516000
126139	1678	26640830584000
126140	1397	1283804515000
126141	1678	26640830585000
126142	2133	91217078000
126143	1874	30485000
126144	2133	91216076000
126145	1874	30487000
126146	2133	91215074000
126147	1874	30489000
126148	1692	9100773619999
126149	1692	9100806619999
126178	1768	20627113110000
126179	1768	21347113110000
126180	1768	21347115110000
126221	1397	1283684503000
126222	1678	26640830597000
126223	2133	91204052000
126224	1874	30511000
126225	1394	816493167440200
126226	1394	816493188440200
126248	1397	1283644499000
126249	1678	26640830601000
126250	1397	1283634498000
126251	1678	26640830602000
126252	2133	91200044000
126253	1874	30519000
126254	568	66000007000000
126255	2328	719004000000
126256	2133	91199042000
126257	1874	30521000
126258	1649	11271570999968
126262	1685	174244342571430
126263	1685	174244365571430
126264	1611	6242409241757
126281	1402	39063255145435
126282	1402	39063266145435
126302	1397	1283574492000
126303	1678	26640830608000
126304	2133	91192028000
126305	1874	30535000
126306	1715	9383568663945
126307	1715	9383579663945
126331	1397	1283524487000
126332	1678	26640830613000
126333	2133	91187018000
126334	1874	30545000
126335	1394	816493178440200
126370	1397	1283454480000
126371	1678	26640830620000
126372	2133	91180004000
126373	1874	30559000
126374	1690	180725729000000
126375	1690	180725740000000
126378	1397	1283444479000
126379	1678	26640830621000
126380	2133	91179002000
126381	1874	30561000
125725	1402	36903151145435
125726	1402	36903188145435
125764	1397	1284344569000
125765	1678	26640840531000
125766	1397	1284334568000
125767	1678	26640840532000
125768	2133	91270184000
125769	1874	30355000
125770	2133	91269182000
125771	1874	30357000
125772	2134	84729495000
125773	1874	30360000
125774	2134	84728492000
125775	1874	30363000
125776	1395	58260151324957278
125777	1395	58260151359957278
125779	1688	69839357720020
125781	1397	1284324567000
125782	1678	26640840533000
125783	2134	84727489000
125784	1874	30366000
125785	2133	91268180000
125786	1874	30368000
125787	1679	35279537653000
125788	1679	35279549653000
125840	1397	1284294564000
125841	1678	26640840536000
125842	2134	84724480000
125843	1874	30381000
125844	2133	91265174000
125845	1874	30383000
125846	1587	12960397000000
125847	1587	12960409000000
125849	1394	809293079440200
125868	2292	2879050000000
125869	2292	2879074000000
125871	1587	13680409000000
125872	1587	13680433000000
125873	1397	1284264561000
125874	1678	26640840539000
125875	1397	1284254560000
125876	1678	26640840540000
125877	1397	1284244559000
125878	1678	26640840541000
125879	2133	91262168000
125880	1874	30395000
125881	2133	91261166000
125882	1874	30397000
125883	2133	91260164000
125884	1874	30399000
125885	1394	809293100440200
125899	1455	4351599000000
125905	1688	69839333720020
125925	1397	1284174552000
125926	1678	26640840548000
125927	2133	91253150000
125928	1874	30413000
125929	1394	810733089440200
125931	1397	1284164551000
125932	1678	26640840549000
125933	2133	91252148000
125934	1874	30415000
125935	1684	22323328819412
125969	1402	38343199145435
125970	1402	38343255145435
125985	1394	812173089440200
125986	1394	812173110440200
126000	1455	5071599000000
126001	1455	5071610000000
126027	470	78239349000000
126028	470	78239360000000
126031	1397	1284014536000
126032	1678	26640840564000
126033	2133	91236116000
126034	1874	30447000
126035	1696	17003763335104
126038	1696	17003762335104
126050	1397	1283984533000
126051	1678	26640840567000
126052	2133	91233110000
126053	1874	30453000
126054	1588	15841857000000
126055	1588	15841868000000
126061	2087	3315409147766
126097	1397	1283894524000
126098	1678	26640840576000
126099	2133	91224092000
126100	1874	30471000
126101	1656	13675508999990
126115	1397	1283864521000
126116	1678	26640830579000
126117	1397	1283854520000
126118	1678	26640830580000
126119	2133	91221086000
126120	1874	30477000
126121	2133	91220084000
126122	1874	30479000
126123	1850	15096443949999
126124	1850	15096465949999
126171	1801	719063000000
126172	2133	91211066000
126173	1874	30497000
126174	2133	91210064000
126175	1874	30499000
126176	1801	1439063000000
126177	2250	206000000
126184	1397	1283744509000
126185	1678	26640830591000
126186	1692	9820806619999
126187	1692	9820816619999
126197	1521	2160047000000
126198	1521	2160079000000
126209	1587	14400433000000
126210	1587	14400455000000
126217	1678	26640830559000
126218	470	77395339000000
126219	2327	124010000000
126220	1637	302407300819988
126228	1397	1283674502000
126229	1678	26640830598000
126230	1397	1283664501000
126231	1678	26640830599000
126232	2133	91203050000
126233	1874	30513000
126234	2133	91202048000
126235	1874	30515000
126236	1395	58261591346957278
126237	1395	58261591368957278
126240	1611	6242408241757
126247	171	76026783696494
126275	484	74013925000000
126289	1397	1283594494000
126290	1678	26640830606000
126291	2133	91194032000
126292	1874	30531000
126293	1695	10025141999000
126300	1637	303127300819988
126301	1637	303127301819988
126310	1397	1283564491000
126311	1678	26640830609000
126312	1397	1283554490000
126313	1678	26640830610000
126314	2133	91191026000
126315	1874	30537000
126316	2133	91190024000
126317	1874	30539000
126318	1402	39783266145435
126319	1402	39783288145435
126358	1397	1283474482000
126359	1678	26640830618000
126360	2133	91182008000
126361	1874	30555000
126362	1602	12096681170000
126369	1723	12242105085979
126390	1688	71999375720020
126391	1688	71999386720020
126404	1471	16505460900000
126415	1397	1283384473000
126416	1678	26640830627000
126417	2133	91172990000
126418	1874	30573000
126419	1698	12309000550062
126421	1698	12308984550062
126428	2133	91171988000
126429	1874	30575000
126444	1397	1283344469000
126445	1678	26640830631000
126446	2133	91168982000
126447	1874	30587000
126448	2134	84719465000
126449	1874	30590000
126450	1402	40503288145435
126451	1402	40503300145435
126474	1397	1283304465000
126475	1678	26640830635000
126476	2133	91164974000
126477	1874	30607000
126478	2134	84715453000
126479	1874	30610000
126618	1476	12960244000000
126626	1874	30622000
126627	1476	12960245000000
126650	1397	1283234458000
126651	1678	26640830642000
126652	2134	84708432000
126094	2133	91225094000
126095	1874	30469000
126096	1715	8663568663945
126102	1685	173524331571430
126103	1685	173524342571430
126125	1573	6339388000000
126126	1573	6339410000000
126181	1762	8565628994000
126182	1762	8565630994000
126188	1397	1283734508000
126189	1678	26640830592000
126190	1397	1283724507000
126191	1678	26640830593000
126192	2133	91209062000
126193	1874	30501000
126194	2133	91208060000
126195	1874	30503000
126196	633	77949526900000
126200	1397	1283714506000
126201	1678	26640830594000
126202	1397	1283704505000
126203	1678	26640830595000
126204	2133	91207058000
126205	1874	30505000
126206	2133	91206056000
126207	1874	30507000
126208	1670	10081072000000
126211	1397	1283694504000
126212	1678	26640830596000
126213	2133	91205054000
126214	1874	30509000
126215	2112	22126932101924
126216	2112	22126943101924
126238	1690	180005707000000
126239	1690	180005729000000
126241	1397	1283654500000
126242	1678	26640830600000
126243	2133	91201046000
126244	1874	30517000
126245	1509	14063305503835
126246	1509	14063316503835
126259	1395	58261591369957278
126265	1397	1283624497000
126266	1678	26640830603000
126267	2133	91198040000
126268	1874	30523000
126269	2133	91197038000
126270	1874	30525000
126271	2328	719003000000
126272	1426	13290391000000
126273	1426	13290404000000
126294	1397	1283584493000
126295	1678	26640830607000
126296	2133	91193030000
126297	1874	30533000
126298	1623	77763278898598
126299	1623	77763289898598
126308	1679	35999549653000
126309	1679	35999560653000
126320	1397	1283544489000
126321	1678	26640830611000
126322	2133	91189022000
126323	1874	30541000
126324	1685	174244353571430
126336	1397	1283514486000
126337	1678	26640830614000
126338	2133	91186016000
126339	1874	30547000
126340	1394	817933178440200
126341	1394	817933189440200
126342	42	73580674000000
126343	42	73580685000000
126363	1397	1283464481000
126364	1678	26640830619000
126365	2133	91181006000
126366	1874	30557000
126367	1394	819373189440200
126368	1394	819373200440200
126384	1397	1283434478000
126385	1678	26640830622000
126386	2133	91178000000
126387	1874	30563000
126388	2112	22846943101924
126389	2112	22846954101924
126403	1686	14792089700123
126405	1397	1283404475000
126406	1678	26640830625000
126407	1397	1283394474000
126408	1678	26640830626000
126409	2133	91174994000
126410	1874	30569000
126411	2133	91173992000
126412	1874	30571000
126413	2327	124009000000
126414	1471	16505483900000
126420	1594	15121874000000
126430	1397	1283364471000
126431	1678	26640830629000
126432	1397	1283354470000
126433	1678	26640830630000
126434	2134	84721471000
126435	1874	30576000
126436	2134	84720468000
126437	1874	30579000
126438	1874	30581000
126439	2133	91170986000
126440	1874	30583000
126441	2133	91169984000
126442	1874	30585000
126443	1395	58261591371957278
126466	1397	1283314466000
126467	1678	26640830634000
126468	2133	91165976000
126469	1874	30602000
126470	2134	84716456000
126471	1874	30605000
126472	1705	22160943580140
126473	1705	22160955580140
126619	1397	1283274462000
126620	1678	26640830638000
126621	2134	84712444000
126622	1874	30623000
126623	2133	91161968000
126624	1874	30625000
126625	1476	12960256000000
126628	1685	174964353571430
126629	1685	174964365571430
126648	1610	10080224999950
126649	1610	10080235999950
126787	1397	1283184453000
126788	1678	26640830647000
126789	2134	84703417000
126790	1874	30652000
126791	1395	58264471417957278
126792	1395	58264471428957278
126872	1688	58655279750020
126873	801	14036777239666
126874	1688	58363792090020
126875	802	154404414900275
126876	1688	58158710265020
126877	811	108632665328286
126878	1688	55902912159020
126879	812	1194958275746140
126880	1688	52612213832020
126881	823	1743175806087760
126882	1688	16414663820020
126883	824	19174917132499700
126884	1688	16414653694020
126885	1900	65126000
126886	1688	10150586113020
126887	2177	78208862930741
126888	1397	1283084443000
126889	1678	26640830657000
126890	2134	84692384000
126891	1874	30685000
126892	1719	15118729000000
126894	1397	1283074442000
126895	1678	26640830658000
126896	2134	84691381000
126897	1874	30688000
126898	1439	12223860578477
126901	1397	1283064441000
126902	1678	26640830659000
126903	2134	84690378000
126904	1874	30691000
126905	1444	11607842329999
126927	1688	69483948668020
126928	1688	69343484612020
126929	1688	69217570151020
126930	1688	69164569222020
126931	1688	68581659509020
126932	1688	63918546115020
126933	1688	63494617255020
126934	1688	58831503861020
126935	1688	58725512003020
126936	1688	57559702576020
126937	1688	57533199485020
126938	1688	57241765742020
126939	1688	57215257750020
126940	1688	56923770090020
126941	1688	56718688265020
126942	1688	54462890159020
126943	1688	51172191832020
126944	1688	14974641820020
126945	1688	14974631694020
126274	1394	816493180440200
126276	1397	1283614496000
126277	1678	26640830604000
126278	2133	91196036000
126279	1874	30527000
126280	1395	58261591357957278
126283	1397	1283604495000
126284	1678	26640830605000
126285	2133	91195034000
126286	1874	30529000
126287	1741	1439011000000
126288	1741	1439022000000
126325	1397	1283534488000
126326	1678	26640830612000
126327	2133	91188020000
126328	1874	30543000
126329	1700	9594259979053
126330	1700	9594270979053
126344	1397	1283504485000
126345	1678	26640830615000
126346	1397	1283494484000
126347	1678	26640830616000
126348	1397	1283484483000
126349	1678	26640830617000
126350	2133	91185014000
126351	1874	30549000
126352	2133	91184012000
126353	1874	30551000
126354	2133	91183010000
126355	1874	30553000
126356	1709	7920155000000
126357	1709	7920188000000
126376	1692	10540816619999
126377	1692	10540827619999
126425	1397	1283374472000
126426	1678	26640830628000
126427	1703	5760908000000
126480	1397	1283294464000
126481	1678	26640830636000
126482	1159	614190748000000
126483	1726	1000098112000
126484	2134	84714450000
126485	1874	30613000
126486	2133	91163972000
126487	1874	30615000
126488	1602	12816681170000
126489	1602	12816694170000
126491	1678	26640830360000
126492	1678	26640830361000
126493	1678	26640830362000
126494	1678	26640830363000
126495	1678	26640830364000
126496	1678	26640830365000
126497	1678	26640830366000
126498	1678	26640830367000
126499	1678	26640830368000
126500	1678	26640830369000
126501	1678	26640830370000
126502	1678	26640830371000
126503	1678	26640830372000
126504	1678	26640830373000
126505	1678	26640830374000
126506	1678	26640830375000
126507	1678	26640830376000
126508	1678	26640830377000
126509	1678	26640830378000
126510	1678	26640830379000
126511	1678	26640830380000
126512	1678	26640830381000
126513	1678	26640830382000
126514	1678	26640830383000
126515	1678	26640830384000
126516	1678	26640830385000
126517	1678	26640830386000
126518	1678	26640830387000
126519	1678	26640830388000
126520	1678	26640830389000
126521	1678	26640830390000
126522	1678	26640830391000
126523	1678	26640830392000
126524	1678	26640830393000
126525	1678	26640830394000
126526	1678	26640830395000
126527	1678	26640830396000
126528	1678	26640830397000
126529	1678	26640830398000
126530	1678	26640830399000
126531	1678	26640830400000
126532	1678	26640830401000
126533	1678	26640830402000
126534	1678	26640830403000
126535	1678	26640830404000
126536	1678	26640830405000
126537	1678	26640830406000
126538	1678	26640830407000
126539	1678	26640830408000
126540	1678	26640830409000
126541	1678	26640830410000
126542	1678	26640830411000
126543	1678	26640830412000
126544	1678	26640830413000
126545	1678	26640830414000
126546	1678	26640830415000
126547	1678	26640830416000
126548	1678	26640830417000
126549	1678	26640830418000
126550	1678	26640830419000
126551	1678	26640830420000
126552	1678	26640830421000
126553	1678	26640830422000
126554	1678	26640830423000
126555	1678	26640830424000
126556	1678	26640830425000
126557	1678	26640830426000
126558	1678	26640830427000
126559	1678	26640830428000
126560	1678	26640830429000
126561	1678	26640830430000
126562	1678	26640830431000
126563	1678	26640830432000
126564	1678	26640830433000
126565	1678	26640830434000
126566	1678	26640830435000
126567	1678	26640830436000
126568	1678	26640830437000
126569	1678	26640830438000
126570	1423	1441454750023
126571	1678	26640830439000
126572	1678	26640830440000
126573	1678	26640830441000
126574	1678	26640830442000
126575	1678	26640830443000
126576	1678	26640830444000
126577	1678	26640830445000
126578	1678	26640830446000
126579	1678	26640830447000
126580	1678	26640830448000
126581	1678	26640830449000
126582	1678	26640830450000
126583	1678	26640830451000
126584	1678	26640830452000
126585	1678	26640830453000
126586	1678	26640830454000
126587	1678	26640830455000
126588	1678	26640830456000
126589	1678	26640830458000
126590	1678	26640830459000
126591	1678	26640830460000
126592	1678	26640830461000
126593	1678	26640830462000
126594	1678	26640830463000
126595	1678	26640830464000
126596	1678	26640830465000
126597	1678	26640830466000
126598	1678	26640830467000
126599	1678	26640830468000
126600	1678	26640830469000
126601	1678	26640830470000
126602	1678	26640830471000
126603	1678	26640830472000
126604	1678	26640830473000
126605	1678	26640830474000
126606	1678	26640830475000
126607	1678	26640830476000
126608	1678	26640830477000
126609	1678	26640830478000
126610	1423	2161454750023
126611	1423	2161854750023
126630	1397	1283264461000
126631	1678	26640830639000
126632	2134	84711441000
126633	1874	30628000
126634	1657	7201323990100
126635	1657	7201334990100
126640	1688	72719386720020
126641	1688	72719397720020
126656	1397	1283224457000
126657	1678	26640830643000
126658	2134	84707429000
126659	1874	30640000
126660	1850	15816465949999
126661	1850	15816476949999
126664	1395	58263751406957278
126665	1395	58263751417957278
126668	1678	26640830479000
126382	1672	10801435000000
126383	1672	10801446000000
126392	1397	1283424477000
126393	1678	26640830623000
126394	1397	1283414476000
126395	1678	26640830624000
126396	2133	91176998000
126397	1874	30565000
126398	2133	91175996000
126399	1874	30567000
126400	1587	15120455000000
126401	1587	15120477000000
126402	1768	22067115110000
126422	1678	26640830457000
126423	1698	13028984550062
126424	1698	13029006550062
126452	1397	1283334468000
126453	1678	26640830632000
126454	1397	1283324467000
126455	1678	26640830633000
126456	2134	84718462000
126457	1874	30593000
126458	2133	91167980000
126459	1874	30595000
126460	2133	91166978000
126461	1874	30597000
126462	2134	84717459000
126463	1874	30600000
126464	1395	58262311371957278
126465	1395	58262311395957278
126490	43	74640116890000
126612	1397	1283284463000
126613	1678	26640830637000
126614	2133	91162970000
126615	1874	30617000
126616	2134	84713447000
126617	1874	30620000
126636	1397	1283254460000
126637	1678	26640830640000
126638	2134	84710438000
126639	1874	30631000
126642	1397	1283244459000
126643	1678	26640830641000
126644	2134	84709435000
126645	1874	30634000
126646	1395	58263031395957278
126647	1395	58263031406957278
126666	1715	10103579663945
126667	1715	10103590663945
126785	1637	302407301819988
126800	1688	73439397720020
126801	1688	73439408720020
126817	1397	1283134448000
126818	1678	26640830652000
126819	1397	1283124447000
126820	1678	26640830653000
126821	2329	719000000000
126822	2329	719020000000
126849	1688	70021681509020
126850	780	308779372753051
126851	1555	13926159540449
126852	1397	1283094444000
126853	1678	26640830656000
126854	1688	65358568115020
126855	782	2470185021667720
126856	1688	64934639255020
126857	785	224562470676807
126858	1688	60271525861020
126859	786	2470185021667720
126860	1688	60165534003020
126861	791	56141753131584
126862	1688	58999724576020
126863	792	617558745507101
126864	1688	58973221485020
126865	799	14034180722181
126866	1688	58681787742020
126867	800	154375853226607
126868	2134	84693387000
126869	1874	30682000
126870	1555	14646159540449
126871	1555	14646240540449
126906	1560	15848842131803
126974	1397	1283024437000
126975	1678	26640830663000
126976	1397	1283014436000
126977	1678	26640830664000
126978	2134	84686366000
126979	1874	30703000
126980	2134	84685363000
126981	1874	30706000
126982	1394	820813200440200
126983	1394	820813222440200
127037	1692	10540870619999
127087	1688	10870597113020
127092	2292	2879061000000
127107	1718	8896606519070
127108	1718	9616606519070
127109	1718	9616607519070
127113	1541	4322324000000
127114	1541	5042324000000
127115	1541	5042325000000
127116	1397	1282814416000
127117	1678	26640830684000
127118	1397	1282804415000
127119	1678	26640830685000
127120	1397	1282794414000
127121	1678	26640830686000
127122	1397	1282784413000
127123	1678	26640830687000
127124	2134	84665303000
127125	1874	30766000
127126	2134	84664300000
127127	1874	30769000
127128	2134	84663297000
127129	1874	30772000
127130	2134	84662294000
127131	1874	30775000
127132	1559	9666139999999
127150	1705	22880955580140
127151	1705	22880966580140
127158	1679	4318081657000
127159	1679	4318092657000
127160	1397	1282734408000
127161	1678	26640830692000
127162	2134	84657279000
127163	1874	30790000
127164	1394	823693233440200
127165	1394	823693244440200
127204	1394	826573255440200
127205	1394	826573266440200
127217	1397	1282674402000
127218	1678	26640830698000
127219	1397	1282664401000
127220	1678	26640830699000
127221	2134	84651261000
127222	1874	30808000
127223	2134	84650258000
127224	1874	30811000
127225	1514	720009099700
127226	1514	720031099700
127294	1397	1282624397000
127295	1678	26640830703000
127296	2134	84646246000
127297	1874	30823000
127298	1709	8640188000000
127299	1709	8640199000000
127338	1397	1282554390000
127339	1678	26640830710000
127340	1397	1282544389000
127341	1678	26640830711000
127342	2134	84639225000
127343	1874	30844000
127344	2134	84638222000
127345	1874	30847000
127346	1402	41223300145435
127347	1402	41223322145435
127382	1397	1282464381000
127383	1678	26640830719000
127384	1394	832333353440200
127385	2134	84630198000
127386	1874	30871000
127387	1394	833773353440200
127388	1394	833773354440200
127397	1489	11183105040000
127398	1489	11183116040000
127401	1423	2880616750023
127402	1423	2880627750023
127411	1679	5038092657000
127412	1679	5038103657000
127422	1397	1282424377000
127423	1678	26640830723000
127424	1397	1282414376000
127425	1678	26640830724000
127426	2134	84626186000
127427	1874	30883000
127428	2134	84625183000
127429	1874	30886000
127430	1608	13818527000000
127431	1608	13818549000000
127446	1397	1282384373000
127447	1678	26640830727000
127448	2134	84622174000
127449	1874	30895000
127450	1395	58265911439957278
127451	1395	58265911450957278
126653	1874	30637000
126654	1980	23039556000000
126655	1980	23039567000000
126662	1671	15504247003785
126663	1671	15504258003785
126775	1397	1283204455000
126776	1678	26640830645000
126777	1397	1283194454000
126778	1678	26640830646000
126779	2134	84705423000
126780	1874	30646000
126781	2134	84704420000
126782	1874	30649000
126783	1684	23043328819412
126784	1684	23043350819412
126807	1397	1283154450000
126808	1678	26640830650000
126809	1397	1283144449000
126810	1678	26640830651000
126811	2134	84700408000
126812	1874	30661000
126813	2134	84699405000
126814	1874	30664000
126815	1634	14063062259504
126816	1634	14063084259504
126893	1719	15118649000000
126913	1679	34436108583000
126914	1	376405981756000
126915	1679	34247309235000
126916	841	84252812686298
126917	1679	33895327813000
126918	843	157077624077667
126919	1679	31289386384000
126920	849	1157959544926640
126921	1397	1283044439000
126922	1678	26640830661000
126923	2134	84688372000
126924	1874	30697000
126925	58	74627427999641
126926	58	74627478999641
126950	1679	26241293952000
126951	851	2252855616099750
126952	1397	1283034438000
126953	1678	26640830662000
126954	1679	25684651640000
126955	853	248413580356225
126956	1679	25390204008000
126957	855	131401473988125
126958	1679	24647773919000
126959	857	331326853191608
126960	1679	23622308719000
126961	861	457639616303125
126962	1679	22722064121000
126963	865	401756230813417
126964	1679	17239422355000
126965	867	2446786067934000
126966	1679	16653087531000
126967	869	261664739344845
126968	1679	11170445765000
126969	873	2446786067934000
126970	2134	84687369000
126971	1874	30700000
126972	1509	14783316503835
126973	1509	14783417503835
127053	1397	1282914426000
127054	1678	26640830674000
127055	1397	1282904425000
127056	1678	26640830675000
127057	1397	1282894424000
127058	1678	26640830676000
127059	1397	1282884423000
127060	1678	26640830677000
127061	2134	84675333000
127062	1874	30736000
127063	2134	84674330000
127064	1874	30739000
127065	2134	84673327000
127066	1874	30742000
127067	2134	84672324000
127068	1874	30745000
127069	369	78756575290830
127070	369	78756619290830
127081	1688	10870586113020
127082	1688	10870608113020
127093	1397	1282834418000
127094	1678	26640830682000
127095	2134	84667309000
127096	1874	30760000
127097	1509	15503417503835
127098	1509	15503428503835
127139	1397	1282764411000
127140	1678	26640830689000
127141	2134	84660288000
127142	1874	30781000
127143	689	67440022000000
127144	1397	1282754410000
127145	1678	26640830690000
127146	2134	84659285000
127147	1874	30784000
127148	1700	10314270979053
127149	1700	10314281979053
127172	1397	1282714406000
127173	1678	26640830694000
127174	2134	84655273000
127175	1874	30796000
127176	1675	17564413999977
127177	1675	17564424999977
127212	1397	1282684403000
127213	1678	26640830697000
127214	2134	84652264000
127215	1874	30805000
127216	1643	2588658914700
127229	1717	15661289000055
127230	1717	15661311000055
127245	470	76799314000000
127246	1679	30836047583000
127247	1688	63723836668020
127248	1688	63583372612020
127249	1688	63457458151020
127250	1688	63404457222020
127251	1688	62821547509020
127252	1688	58158434115020
127253	1679	30647248235000
127254	1679	30295266813000
127255	1679	27689325384000
127256	1679	22641232952000
127257	1679	22084590640000
127258	1678	26640830297000
127259	1679	21790143008000
127260	1679	21047712919000
127261	1679	20022247719000
127262	1679	19122003121000
127263	1679	13639361355000
127264	1679	13053026531000
127265	1679	7570384765000
127266	1679	7089798401000
127267	1679	6785197747000
127268	1679	5465294915000
127269	1679	4348452519000
127270	1679	4201118112000
127271	1679	4113288535000
127272	1679	3849299969000
127273	1679	2899982432000
127274	470	76675304000000
127275	1688	57734505255020
127276	1688	53071391861020
127277	1688	52965400003020
127278	1688	51799590576020
127279	1688	51773087485020
127280	1688	51481653742020
127281	1688	51455145750020
127282	1688	51163658090020
127283	1688	50958576265020
127284	1688	48702778159020
127285	1688	45412079832020
127286	1688	9214529820020
127287	1688	9214519694020
127288	1688	2950452113020
127289	1679	1315911532000
127290	1679	835325168000
127291	1679	530724514000
127292	1506	7920209967172
127293	1506	7920690967172
127302	2307	2879060000000
127303	2307	2879071000000
127310	1397	1282604395000
127311	1678	26640830705000
127312	2134	84644240000
127313	1874	30829000
127314	1980	23759567000000
127315	1980	23759578000000
127328	1397	1282574392000
127329	1678	26640830708000
127330	1397	1282564391000
127331	1678	26640830709000
127332	2134	84641231000
127333	1874	30838000
127334	2134	84640228000
127335	1874	30841000
127336	1394	830893299440200
127337	1394	830893321440200
127357	1397	1282514386000
127358	1678	26640830714000
127359	2134	84635213000
127360	1874	30856000
126669	1678	26640830480000
126670	1678	26640830481000
126671	1678	26640830482000
126672	1678	26640830483000
126673	1678	26640830484000
126674	1678	26640830485000
126675	1678	26640830486000
126676	1678	26640830487000
126677	1678	26640830488000
126678	1678	26640830489000
126679	1678	26640830490000
126680	1678	26640830491000
126681	1678	26640830492000
126682	1678	26640830493000
126683	1678	26640830494000
126684	1678	26640830495000
126685	1678	26640830496000
126686	1678	26640830497000
126687	1678	26640830498000
126688	1678	26640830499000
126689	1678	26640830500000
126690	1678	26640830501000
126691	1678	26640830502000
126692	1678	26640830503000
126693	1678	26640830504000
126694	1678	26640830505000
126695	1678	26640830506000
126696	1678	26640830507000
126697	1678	26640830508000
126698	1678	26640830509000
126699	1678	26640830510000
126700	1678	26640830511000
126701	1678	26640830512000
126702	1678	26640830513000
126703	1678	26640830514000
126704	1678	26640830515000
126705	1678	26640830516000
126706	1678	26640830517000
126707	1678	26640830518000
126708	1678	26640830519000
126709	1678	26640830520000
126710	1678	26640830521000
126711	1678	26640830522000
126712	1678	26640830523000
126713	1678	26640830524000
126714	1678	26640830525000
126715	1678	26640830526000
126716	1678	26640830527000
126717	1678	26640830528000
126718	1678	26640830529000
126719	1678	26640830530000
126720	1678	26640830531000
126721	1678	26640830532000
126722	1678	26640830533000
126723	1678	26640830534000
126724	1678	26640830535000
126725	1678	26640830536000
126726	1671	14784887003785
126727	1678	26640830537000
126728	1678	26640830538000
126729	1678	26640830539000
126730	1678	26640830540000
126731	1678	26640830541000
126732	1678	26640830542000
126733	1678	26640830543000
126734	1678	26640830544000
126735	1678	26640830545000
126736	1678	26640830546000
126737	1678	26640830547000
126738	1678	26640830548000
126739	1678	26640830549000
126740	1678	26640830550000
126741	1678	26640830551000
126742	1678	26640830552000
126743	1678	26640830553000
126744	1678	26640830554000
126745	1678	26640830555000
126746	1678	26640830556000
126747	1678	26640830557000
126748	1678	26640830558000
126749	1678	26640830560000
126750	1678	26640830561000
126751	1678	26640830562000
126752	1678	26640830563000
126753	1678	26640830564000
126754	1678	26640830565000
126755	1678	26640830566000
126756	1678	26640830567000
126757	1678	26640830568000
126758	1678	26640830569000
126759	1678	26640830570000
126760	1678	26640830571000
126761	1678	26640830572000
126762	1678	26640830573000
126763	1678	26640830574000
126764	1678	26640830575000
126765	1678	26640830576000
126766	1678	26640830577000
126767	1671	15504887003785
126768	1671	15505497003785
126769	1397	1283214456000
126770	1678	26640830644000
126771	2134	84706426000
126772	1874	30643000
126773	1696	17723763335104
126774	1696	17723774335104
126786	1555	14646171540449
126793	1397	1283174452000
126794	1678	26640830648000
126795	2134	84702414000
126796	1874	30655000
126797	1395	58265191428957278
126798	1395	58265191439957278
126799	1991	12141391355805
126802	1397	1283164451000
126803	1678	26640830649000
126804	2134	84701411000
126805	1874	30658000
126806	526	74640302000000
126823	1690	181445740000000
126824	1690	181445760000000
126825	1688	70923970668020
126826	31	1332497303438000
126827	1397	1283114446000
126828	1678	26640830654000
126829	1397	1283104445000
126830	1678	26640830655000
126831	1688	70783506612020
126832	32	74402705100000
126833	1688	70657592151020
126834	40	66695350031000
126835	1688	70604591222020
126836	779	28070876565792
126837	2134	84698402000
126838	1874	30667000
126839	2134	84697399000
126840	1874	30670000
126841	2134	84696396000
126842	1874	30673000
126843	2134	84695393000
126844	1874	30676000
126845	2134	84694390000
126846	1874	30679000
126847	1685	175684365571430
126848	1685	175684430571430
126899	1749	722584529980
126900	1749	722675529980
126907	1397	1283054440000
126908	1678	26640830660000
126909	2134	84689375000
126910	1874	30694000
126911	1685	176404430571430
126912	1685	176404441571430
126986	1679	10967375329000
126987	883	90621706198500
126988	1679	10361313183000
126989	887	270468638103154
126990	1679	9852554890000
126991	889	227043924783249
126992	1679	8735712494000
126993	891	498419384091750
126994	1679	8588378087000
126995	897	65747860280885
126996	1679	8500548510000
126997	899	39192075495990
126998	1679	8236559944000
126999	901	117808218058250
127000	1679	7287242407000
127001	905	423656476478938
127002	1679	5703171507000
127003	2177	79792923830741
127004	1397	1283004435000
127005	1678	26640830665000
127006	1397	1282994434000
127007	1678	26640830666000
127008	1397	1282984433000
127009	1678	26640830667000
127010	2134	84684360000
127011	1874	30709000
127012	2134	84683357000
127013	1874	30712000
127014	2134	84682354000
127015	1874	30715000
127016	1564	11886836000000
127017	1397	1282974432000
126946	1688	8710564113020
126947	58	73907854999641
126948	58	74627854999641
126949	58	74627859999641
126984	1623	78483289898598
126985	1623	78483311898598
127038	1397	1282934428000
127039	1678	26640830672000
127040	1679	4917984489000
127041	879	135932559298750
127042	1397	1282924427000
127043	1678	26640830673000
127044	1679	3598081657000
127045	881	589041090291250
127046	2134	84677339000
127047	1874	30730000
127048	2134	84676336000
127049	1874	30733000
127050	1643	2588689914700
127071	369	78756608290830
127088	1397	1282844419000
127089	1678	26640830681000
127090	2134	84668312000
127091	1874	30757000
127099	1394	822253222440200
127100	1394	822253233440200
127166	1397	1282724407000
127167	1678	26640830693000
127168	2134	84656276000
127169	1874	30793000
127170	1394	825133244440200
127171	1394	825133255440200
127178	1679	10689859401000
127179	1679	10385258747000
127180	1679	9065355915000
127181	1679	7948513519000
127182	1679	7801179112000
127183	1679	7713349535000
127184	1679	7449360969000
127185	1679	6500043432000
127186	1679	4915972532000
127187	1679	4435386168000
127188	875	214951947700583
127189	1679	4130785514000
127190	879	136237149952750
127191	1679	2810882682000
127192	881	590360983123250
127193	1675	16845333999977
127194	1874	30609000
127195	1874	30611000
127196	1874	30616000
127197	1874	30619000
127198	1675	17565333999977
127199	1675	17565492999977
127235	1397	1282644399000
127236	1678	26640830701000
127237	1397	1282634398000
127238	1678	26640830702000
127239	2134	84648252000
127240	1874	30817000
127241	2134	84647249000
127242	1874	30820000
127243	1394	828013266440200
127244	1394	828013288440200
127300	1684	23763350819412
127301	1684	23763361819412
127304	1474	10710547000043
127316	1397	1282594394000
127317	1678	26640830706000
127318	2134	84643237000
127319	1874	30832000
127320	1608	13098516000000
127321	1608	13098527000000
127348	1397	1282534388000
127349	1678	26640830712000
127350	1397	1282524387000
127351	1678	26640830713000
127352	2134	84637219000
127353	1874	30850000
127354	2134	84636216000
127355	1874	30853000
127356	1991	12141402355805
127363	1688	11590598113020
127364	1688	11590609113020
127399	1489	175000
127400	1568	11183116015000
127414	1397	1282434378000
127415	1678	26640830722000
127416	2134	84627189000
127417	1874	30880000
127418	1536	18000349000000
127419	1536	18000360000000
127432	1397	1282404375000
127433	1678	26640830725000
127434	2134	84624180000
127435	1874	30889000
127436	1476	12960255000000
127438	1402	41943322145435
127439	1402	41943333145435
127452	369	80196630290830
127453	369	80196641290830
127501	1397	1282324367000
127502	1678	26640830733000
127503	1397	1282314366000
127504	1678	26640830734000
127505	2134	84616156000
127506	1874	30921000
127507	2134	84615153000
127508	1874	30924000
127509	2133	91156958000
127510	1874	30926000
127511	2133	91155956000
127512	1874	30928000
127513	1671	15504271003785
127516	1700	11034281979053
127517	1700	11034305979053
127536	1709	9360199000000
127537	1709	9360213000000
127539	1397	1282294364000
127540	1678	26640830736000
127541	1397	1282284363000
127542	1678	26640830737000
127543	2133	91153952000
127544	1874	30935000
127545	2134	84613147000
127546	1874	30938000
127547	1726	996795112000
127548	2332	100000000
127549	1726	995694112000
127550	2333	100000000
127551	2133	91152950000
127552	1874	30940000
127553	2134	84612144000
127554	1874	30943000
127555	1395	58267351500957278
127558	1397	1282274362000
127559	1678	26640830738000
127560	2133	91151948000
127561	1874	30945000
127562	1726	994593112000
127563	2296	100000000
127564	1726	993492112000
127565	2334	100000000
127566	1726	992391112000
127567	2335	100000000
127568	2134	84611141000
127569	1874	30948000
127570	43	75360116890000
127571	43	75360131890000
127581	1397	1282254360000
127582	1678	26640830740000
127583	1397	1282244359000
127584	1678	26640830741000
127585	2134	84609135000
127586	1874	30956000
127587	2134	84608132000
127588	1874	30959000
127589	2133	91149944000
127590	1874	30961000
127591	2133	91148942000
127592	1874	30963000
127593	1695	10745141999000
127594	1695	10745165999000
127601	2148	10080320880750
127602	2148	10080332880750
127629	1726	989088112000
127630	2338	100000000
127631	2133	91143932000
127632	1874	30985000
127633	2134	84603117000
127634	1874	30988000
127635	1692	10540819619999
127637	1711	15547000000000
127638	1397	1282194354000
127639	1678	26640830746000
127640	1397	1282184353000
127641	1678	26640830747000
127642	1397	1282174352000
127643	1678	26640830748000
127644	1397	1282164351000
127645	1678	26640830749000
127646	2134	84602114000
127647	1874	30991000
127648	2133	91142930000
127649	1874	30993000
127018	1678	26640830668000
127019	1397	1282964431000
127020	1678	26640830669000
127021	1679	5222585143000
127022	875	214471371336583
127023	1397	1282954430000
127024	1678	26640830670000
127025	1397	1282944429000
127026	1678	26640830671000
127027	2134	84681351000
127028	1874	30718000
127029	2134	84680348000
127030	1874	30721000
127031	2134	84679345000
127032	1874	30724000
127033	2134	84678342000
127034	1874	30727000
127035	2300	3599012000000
127036	2300	3599066000000
127051	1650	8752990000000
127052	1650	8753032000000
127072	1397	1282874422000
127073	1678	26640830678000
127074	1397	1282864421000
127075	1678	26640830679000
127076	2134	84671321000
127077	1874	30748000
127078	2134	84670318000
127079	1874	30751000
127080	2329	719022000000
127083	1397	1282854420000
127084	1678	26640830680000
127085	2134	84669315000
127086	1874	30754000
127101	1397	1282824417000
127102	1678	26640830683000
127103	1723	11522104085979
127104	2134	84666306000
127105	1874	30763000
127106	1723	12242104085979
127110	610	66000031000000
127111	610	66720031000000
127112	610	66720032000000
127133	1397	1282774412000
127134	1678	26640830688000
127135	2134	84661291000
127136	1874	30778000
127137	369	79476619290830
127138	369	79476630290830
127152	1397	1282744409000
127153	1678	26640830691000
127154	2134	84658282000
127155	1874	30787000
127156	2329	1439022000000
127157	2329	1439033000000
127200	1397	1282704405000
127201	1678	26640830695000
127202	2134	84654270000
127203	1874	30799000
127206	1397	1282694404000
127207	1678	26640830696000
127208	2320	775740211465
127209	2134	84653267000
127210	1874	30802000
127211	1688	10870598113020
127227	1598	1440048000000
127228	1598	1440070000000
127231	1397	1282654400000
127232	1678	26640830700000
127233	2134	84649255000
127234	1874	30814000
127305	1506	7200215967172
127306	1397	1282614396000
127307	1678	26640830704000
127308	2134	84645243000
127309	1874	30826000
127322	1397	1282584393000
127323	1678	26640830707000
127324	2134	84642234000
127325	1874	30835000
127326	1394	829453288440200
127327	1394	829453299440200
127365	1397	1282504385000
127366	1678	26640830715000
127367	1397	1282494384000
127368	1678	26640830716000
127369	2134	84634210000
127370	1874	30859000
127371	2134	84633207000
127372	1874	30862000
127373	1394	832333343440200
127389	1397	1282454380000
127390	1678	26640830720000
127391	2134	84629195000
127392	1874	30874000
127393	1568	175000
127394	1423	2880616725023
127395	1423	200000
127396	1568	2880627700023
127403	1688	12310609113020
127404	1688	12310620113020
127413	1623	78483300898598
127454	1397	1282374372000
127455	1678	26640830728000
127456	2134	84621171000
127457	1874	30898000
127480	1397	1282334368000
127481	1678	26640830732000
127482	2133	91157960000
127483	1874	30915000
127484	2134	84617159000
127485	1874	30918000
127486	1992	12241056990000
127487	1992	12241068990000
127518	1394	836653365440200
127519	1394	836653389440200
127522	1397	1282304365000
127523	1678	26640830735000
127524	2133	91154954000
127525	1874	30930000
127526	1726	998997112000
127527	2330	100000000
127528	2134	84614150000
127529	1874	30933000
127530	1726	997896112000
127531	2331	100000000
127532	1395	58267351474957278
127533	1395	58267351488957278
127538	1623	78483303898598
127572	1397	1282264361000
127573	1678	26640830739000
127574	2133	91150946000
127575	1874	30950000
127576	2134	84610138000
127577	1874	30953000
127578	1394	836653377440200
127603	1397	1282224357000
127604	1678	26640830743000
127605	1397	1282214356000
127606	1678	26640830744000
127607	2133	91146938000
127608	1874	30970000
127609	2133	91145936000
127610	1874	30972000
127611	2134	84606126000
127612	1874	30975000
127613	2134	84605123000
127614	1874	30978000
127615	1726	991290112000
127616	2336	100000000
127617	1726	990189112000
127618	2337	100000000
127619	1394	838093377440200
127620	1394	838093403440200
127686	1394	839533403440200
127687	1394	839533428440200
127712	1992	12961068990000
127713	1992	12961080990000
127738	1397	1282104345000
127739	1678	26640830755000
127740	2133	91133912000
127741	1874	31039000
127742	2134	84593087000
127743	1874	31042000
127744	1726	987987112000
127745	2339	100000000
127746	1696	18443774335104
127747	1696	18443787335104
127762	1397	1282084343000
127763	1678	26640830757000
127764	1397	1282074342000
127765	1678	26640830758000
127766	1397	1282064341000
127767	1678	26640830759000
127768	2134	84591081000
127769	1874	31050000
127770	2134	84590078000
127771	1874	31053000
127772	2133	91131908000
127773	1874	31055000
127774	2133	91130906000
127775	1874	31057000
127776	2133	91129904000
127777	1874	31059000
127778	2134	84589075000
127361	1394	832333321440200
127362	1394	832333332440200
127374	1397	1282484383000
127375	1678	26640830717000
127376	2134	84632204000
127377	1874	30865000
127378	1397	1282474382000
127379	1678	26640830718000
127380	2134	84631201000
127381	1874	30868000
127405	1397	1282444379000
127406	1678	26640830721000
127407	2134	84628192000
127408	1874	30877000
127409	1394	835213354440200
127410	1394	835213365440200
127420	1657	7921334990100
127421	1657	7921345990100
127437	1419	23326166559748
127440	1397	1282394374000
127441	1678	26640830726000
127442	2134	84623177000
127443	1874	30892000
127444	1564	12606836000000
127445	1564	12606847000000
127458	1397	1282364371000
127459	1678	26640830729000
127460	2133	91160966000
127461	1874	30900000
127462	2134	84620168000
127463	1874	30903000
127464	1681	14291478909853
127465	1681	14291490909853
127514	1471	17225460900000
127515	1471	17225484900000
127534	1593	13632740000000
127535	1593	13632754000000
127556	1706	15402208450256
127557	1706	15402234450256
127595	1397	1282234358000
127596	1678	26640830742000
127597	2134	84607129000
127598	1874	30966000
127599	2133	91147940000
127600	1874	30968000
127621	1397	1282204355000
127622	1678	26640830745000
127623	2134	84604120000
127624	1874	30981000
127625	2133	91144934000
127626	1874	30983000
127627	1608	14538549000000
127628	1608	14538561000000
127670	2261	7919196000000
127694	1397	1282124347000
127695	1678	26640830753000
127696	2133	91135916000
127697	1874	31025000
127698	2134	84596096000
127699	1874	31028000
127700	2134	84595093000
127701	1874	31031000
127702	2132	147427440000
127703	1874	31032000
127704	1455	5791610000000
127705	1455	5791624000000
127758	1723	12242107085979
127785	1397	1282054340000
127786	1678	26640830760000
127787	2132	147425438000
127788	1874	31064000
127789	2134	84588072000
127790	1874	31067000
127791	2133	91128902000
127792	1874	31069000
127793	1726	986886112000
127794	2340	100000000
127795	58	75347478999641
127796	58	75347492999641
127828	1489	11183119040000
127845	2134	84582054000
127846	1874	31098000
127847	2133	91122890000
127848	1874	31100000
127849	1402	41943324145435
127891	1397	1281944329000
127892	1678	26640830771000
127893	2133	91116878000
127894	1874	31129000
127895	2134	84576036000
127896	1874	31132000
127897	1549	12671408000000
127898	1549	12671420000000
127910	1397	1281924327000
127911	1678	26640830773000
127912	2133	91114874000
127913	1874	31140000
127914	2134	84574030000
127915	1874	31143000
127916	1395	58268791536957278
127917	1395	58268791548957278
127925	1397	1281904325000
127926	1678	26640830775000
127927	2133	91112870000
127928	1874	31150000
127929	2134	84572024000
127930	1874	31153000
127942	1690	182165760000000
127943	1690	182165773000000
127946	1397	1281884323000
127947	1678	26640830777000
127948	1397	1281874322000
127949	1678	26640830778000
127950	2134	84570018000
127951	1874	31162000
127952	2133	91110866000
127953	1874	31164000
127954	2134	84569015000
127955	1874	31167000
127956	2133	91109864000
127957	1874	31169000
127958	1688	13030620113020
127959	1688	13030644113020
127981	1397	1281844319000
127982	1678	26640830781000
127983	1397	1281834318000
127984	1678	26640830782000
127985	2132	147418431000
127986	1874	31181000
127987	2133	91106858000
127988	1874	31183000
127989	2133	91105856000
127990	1874	31185000
127991	2134	84566006000
127992	1874	31188000
127993	2134	84565003000
127994	1874	31191000
127995	1693	6471027570272
128026	1397	1281794314000
128027	1678	26640830786000
128028	1397	1281784313000
128029	1678	26640830787000
128030	1397	1281774312000
128031	1678	26640830788000
128032	1397	1281764311000
128033	1678	26640830789000
128034	1726	984684112000
128035	2342	100000000
128036	2134	84564000000
128037	1874	31194000
128038	2133	91104854000
128039	1874	31196000
128040	2133	91103852000
128041	1874	31198000
128042	2133	91102850000
128043	1874	31200000
128044	2133	91101848000
128045	1874	31202000
128046	2133	91100846000
128047	1874	31204000
128048	2133	91099844000
128049	1874	31206000
128050	2133	91098842000
128051	1874	31208000
128052	2132	147417430000
128053	1874	31209000
128054	2132	147416429000
128055	1874	31210000
128056	2134	84562997000
128057	1874	31213000
128058	2134	84561994000
128059	1874	31216000
128060	2134	84560991000
128061	1874	31219000
128062	2134	84559988000
128063	1874	31222000
128064	2134	84558985000
128065	1874	31225000
128066	2134	84557982000
128067	1874	31228000
128068	1599	13976910097983
128069	1599	13976997097983
128071	1397	1281754310000
128072	1678	26640830790000
128073	2134	84556979000
127466	1397	1282354370000
127467	1678	26640830730000
127468	1397	1282344369000
127469	1678	26640830731000
127470	2133	91159964000
127471	1874	30905000
127472	2133	91158962000
127473	1874	30907000
127474	2134	84619165000
127475	1874	30910000
127476	2134	84618162000
127477	1874	30913000
127478	1395	58266631450957278
127479	1395	58266631474957278
127488	1874	30873000
127489	1874	30875000
127490	1874	30878000
127491	1874	30881000
127492	1874	30885000
127493	1874	30888000
127494	1874	30891000
127495	1874	30894000
127496	1874	30897000
127497	1874	30906000
127498	1874	30909000
127499	1874	30912000
127500	1992	12241203990000
127520	1679	5758103657000
127521	1679	5758127657000
127579	1685	177124441571430
127580	1685	177124453571430
127636	2049	1439013000000
127671	1397	1282154350000
127672	1678	26640830750000
127673	1397	1282144349000
127674	1678	26640830751000
127675	2132	147428441000
127676	1874	31011000
127677	2133	91138922000
127678	1874	31013000
127679	2134	84598102000
127680	1874	31016000
127681	2134	84597099000
127682	1874	31019000
127683	2133	91137920000
127684	1874	31021000
127685	1549	11951408000000
127688	1692	11260819619999
127689	1692	11260844619999
127706	1397	1282114346000
127707	1678	26640830754000
127708	2134	84594090000
127709	1874	31035000
127710	2133	91134914000
127711	1874	31037000
127714	1874	30932000
127715	1874	30939000
127716	1874	30941000
127717	1874	30947000
127718	1874	30952000
127719	1874	30954000
127720	1874	30958000
127721	1874	30960000
127722	1874	30962000
127723	1874	30964000
127724	1874	30967000
127725	1874	30969000
127726	1874	30971000
127727	1874	30973000
127728	1874	30977000
127729	1874	30979000
127730	1874	30986000
127731	1874	30989000
127732	1874	30992000
127733	1874	30998000
127734	1874	31022000
127735	1874	31034000
127736	1992	12961203990000
127737	1992	12961483990000
127748	1654	15977484999798
127797	58	74629059999641
127798	1874	30699000
127799	58	75349059999641
127800	58	75349100999641
127801	1397	1282044339000
127802	1678	26640830761000
127803	1397	1282034338000
127804	1678	26640830762000
127805	2134	84587069000
127806	1874	31072000
127807	2134	84586066000
127808	1874	31075000
127809	2133	91127900000
127810	1874	31077000
127811	2133	91126898000
127812	1874	31079000
127813	1419	24046166559748
127814	1419	24046190559748
127829	1654	15977485999798
127830	1397	1282014336000
127831	1678	26640830764000
127832	2134	84584060000
127833	1874	31088000
127834	2133	91124894000
127835	1874	31090000
127836	1706	16122234450256
127837	1706	16122246450256
127899	1397	1281934328000
127900	1678	26640830772000
127901	2133	91115876000
127902	1874	31134000
127903	2132	147421434000
127904	1874	31135000
127905	2134	84575033000
127906	1874	31138000
127907	1695	11465165999000
127908	1695	11465178999000
127931	1397	1281894324000
127932	1678	26640830776000
127933	2132	147420433000
127934	1874	31154000
127935	2133	91111868000
127936	1874	31156000
127937	2134	84571021000
127938	1874	31159000
127939	1693	6471015570272
127960	1397	1281864321000
127961	1678	26640830779000
127962	2133	91108862000
127963	1874	31171000
127964	2134	84568012000
127965	1874	31174000
127966	2132	147419432000
127967	1874	31175000
127968	1489	11903119040000
127969	1489	11903132040000
127971	1397	1281854320000
127972	1678	26640830780000
127973	2134	84567009000
127974	1874	31178000
127975	2133	91107860000
127976	1874	31180000
127977	1394	842413427440200
127978	1394	842413439440200
127996	1394	842413452440200
128070	633	77949581900000
128079	1397	1281744309000
128080	1678	26640830791000
128081	2134	84555976000
128082	1874	31236000
128083	2133	91096838000
128084	1874	31238000
128085	1394	843853452440200
128086	1394	843853464440200
128129	1397	1281684303000
128130	1678	26640830797000
128131	2134	84549958000
128132	1874	31268000
128133	2133	91090826000
128134	1874	31270000
128135	1394	848173514440200
128136	1394	848173526440200
128182	1397	1281624297000
128183	1678	26640830803000
128184	2134	84543940000
128185	1874	31300000
128186	2133	91084814000
128187	1874	31302000
128188	2330	101000000
128189	1684	23763349819412
128190	2333	103000000
128191	1684	23763358819412
128195	1687	9488996848312
128196	1687	9489008848312
128197	1397	1281614296000
128198	1678	26640830804000
128199	2134	84542937000
128200	1874	31305000
128201	2133	91083812000
128202	1874	31307000
128203	1696	19163787335104
128204	1696	19163799335104
128250	1397	1281544289000
128251	1678	26640830811000
128252	2134	84535916000
127650	2132	147430443000
127651	1874	30994000
127652	2132	147429442000
127653	1874	30995000
127654	2133	91141928000
127655	1874	30997000
127656	2133	91140926000
127657	1874	30999000
127658	2133	91139924000
127659	1874	31001000
127660	2134	84601111000
127661	1874	31004000
127662	2134	84600108000
127663	1874	31007000
127664	2134	84599105000
127665	1874	31010000
127666	1568	66000000001420
127667	45	175000
127668	1571	7919195974016
127669	2261	9260664125026
127690	1397	1282134348000
127691	1678	26640830752000
127692	2133	91136918000
127693	1874	31023000
127749	1397	1282094344000
127750	1678	26640830756000
127751	1637	301686278819988
127752	2329	1440022000000
127753	2133	91132910000
127754	1874	31044000
127755	2134	84592084000
127756	1874	31047000
127757	1476	12960257000000
127759	1701	13679530500103
127760	1701	14399530500103
127761	1701	14399610500103
127815	1759	8857245139889
127816	1759	8857269139889
127861	1394	840973415440200
127862	1394	840973428440200
127863	1397	1281984333000
127864	1678	26640830767000
127865	1397	1281974332000
127866	1678	26640830768000
127867	1397	1281964331000
127868	1678	26640830769000
127869	1397	1281954330000
127870	1678	26640830770000
127871	2133	91120886000
127872	1874	31108000
127873	2134	84580048000
127874	1874	31111000
127875	2134	84579045000
127876	1874	31114000
127877	2134	84578042000
127878	1874	31117000
127879	2134	84577039000
127880	1874	31120000
127881	2132	147422435000
127882	1874	31121000
127883	2133	91119884000
127884	1874	31123000
127885	2133	91118882000
127886	1874	31125000
127887	2133	91117880000
127888	1874	31127000
127889	1395	58268071487957278
127890	1395	58268071536957278
127918	1397	1281914326000
127919	1678	26640830774000
127920	2133	91113872000
127921	1874	31145000
127922	2134	84573027000
127923	1874	31148000
127924	1394	840973427440200
127940	1395	58269511548957278
127941	1395	58269511561957278
127944	1686	15512127700123
127945	1686	15512140700123
127970	1711	15547013000000
127979	1395	58270231561957278
127980	1395	58270231573957278
127997	1397	1281824317000
127998	1678	26640830783000
127999	1397	1281814316000
128000	1678	26640830784000
128001	1397	1281804315000
128002	1678	26640830785000
128003	2329	0
128004	2329	301686177819988
128005	1874	30586000
128006	1874	30588000
128007	1874	30592000
128008	1874	30599000
128009	1874	30601000
128010	1874	30603000
128011	1874	30621000
128012	1874	30627000
128013	1874	30629000
128014	1874	30633000
128015	1874	30635000
128016	1874	30639000
128017	1874	30641000
128018	1701	14400429500103
128019	1874	30645000
128020	1874	30647000
128021	1874	30651000
128022	1874	30653000
128023	1874	30657000
128024	1701	15120429500103
128025	1701	15120437500103
128104	1397	1281714306000
128105	1678	26640830794000
128106	2133	91093832000
128107	1874	31251000
128108	2134	84552967000
128109	1874	31254000
128110	1687	8768996848312
128192	1675	18284424999977
128193	1675	18284436999977
128275	1397	1281514286000
128276	1678	26640830814000
128277	2133	91073792000
128278	1874	31357000
128279	2134	84532907000
128280	1874	31360000
128283	1759	9577269139889
128284	1759	9577281139889
128323	1687	9489021848312
128332	1397	1281454280000
128333	1678	26640830820000
128334	1397	1281444279000
128335	1678	26640830821000
128336	2134	84525886000
128337	1874	31395000
128338	2132	147406419000
128339	1874	31396000
128340	2133	91066778000
128341	1874	31398000
128342	2134	84524883000
128343	1874	31401000
128344	2133	91065776000
128345	1874	31403000
128346	1394	848173539440200
128406	1715	10103592663945
128436	1688	68763937668020
128437	1688	68623473612020
128438	1688	68497559151020
128439	1688	68444558222020
128440	1688	67861648509020
128441	1688	63198535115020
128442	1688	62774606255020
128443	1688	58111492861020
128444	1688	58005501003020
128445	1688	56839691576020
128446	1688	56813188485020
128447	1688	56521754742020
128448	1688	56495246750020
128449	1688	56203759090020
128450	1688	55998677265020
128451	1688	53742879159020
128452	1688	50452180832020
128453	1688	14254630820020
128454	1688	14254620694020
128455	1688	7990553113020
128456	1739	30960611000000
128457	1739	31680611000000
128458	1739	31681101000000
128476	1457	12960277800000
128479	1397	1281294264000
128480	1678	26640830836000
128481	2134	84510841000
128482	1874	31471000
128483	1696	19883799335104
128484	1696	19883810335104
128487	1397	1281284263000
128488	1678	26640830837000
128489	2134	84509838000
128490	1874	31474000
128491	1684	24483358819412
128492	1684	24483369819412
128493	1397	1281274262000
128494	1678	26640830838000
128495	1397	1281264261000
128496	1678	26640830839000
127779	1874	31062000
127780	1637	100000000
127781	2329	303126199819988
127782	2132	147426439000
127783	1874	31063000
127784	1686	14792127700123
127817	1397	1282024337000
127818	1678	26640830763000
127819	1726	985785112000
127820	2341	100000000
127821	2132	147424437000
127822	1874	31080000
127823	2134	84585063000
127824	1874	31083000
127825	2133	91125896000
127826	1874	31085000
127827	1467	5200280272869
127838	1397	1282004335000
127839	1678	26640830765000
127840	2134	84583057000
127841	1874	31093000
127842	2133	91123892000
127843	1874	31095000
127844	1394	839533415440200
127850	149	76895347000341
127851	149	76895349000341
127852	1397	1281994334000
127853	1678	26640830766000
127854	2134	84581051000
127855	1874	31103000
127856	2132	147423436000
127857	1874	31104000
127858	2133	91121888000
127859	1874	31106000
127860	1395	58267351487957278
127909	1610	10080237999950
128087	1397	1281734308000
128088	1678	26640830792000
128089	1397	1281724307000
128090	1678	26640830793000
128091	2134	84554973000
128092	1874	31241000
128093	2133	91095836000
128094	1874	31243000
128095	2133	91094834000
128096	1874	31245000
128097	2134	84553970000
128098	1874	31248000
128099	2132	147415428000
128100	1874	31249000
128101	1394	845293464440200
128102	1394	845293489440200
128103	1679	5758128657000
128111	1397	1281704305000
128112	1678	26640830795000
128113	1397	1281694304000
128114	1678	26640830796000
128115	2133	91092830000
128116	1874	31256000
128117	2133	91091828000
128118	1874	31258000
128119	2134	84551964000
128120	1874	31261000
128121	2134	84550961000
128122	1874	31264000
128123	2132	147414427000
128124	1874	31265000
128125	1394	846733489440200
128126	1394	846733514440200
128194	1684	23763362819412
128205	1397	1281604295000
128206	1678	26640830805000
128207	2134	84541934000
128208	1874	31310000
128209	2133	91082810000
128210	1874	31312000
128211	1693	6471014570272
128258	1397	1281534288000
128259	1678	26640830812000
128260	2134	84534913000
128261	1874	31347000
128262	2133	91075796000
128263	1874	31349000
128264	2132	147409422000
128265	1874	31350000
128266	64	68880043000000
128267	64	68880056000000
128281	1402	42663324145435
128282	1402	42663336145435
128347	1397	1281434278000
128348	1678	26640830822000
128349	2133	91064774000
128350	1874	31405000
128351	2134	84523880000
128352	1874	31408000
128361	1559	10386139999999
128362	1559	10386151999999
128388	1397	1281384273000
128389	1678	26640830827000
128390	2133	91059764000
128391	1874	31428000
128392	2134	84519868000
128393	1874	31431000
128420	1397	1281344269000
128421	1678	26640830831000
128422	2133	91055756000
128423	1874	31449000
128424	2134	84515856000
128425	1874	31452000
128426	2132	147403416000
128427	1874	31453000
128459	1397	1281324267000
128460	1678	26640830833000
128461	1397	1281314266000
128462	1678	26640830834000
128463	1397	1281304265000
128464	1678	26640830835000
128465	2134	84513850000
128466	1874	31461000
128467	2134	84512847000
128468	1874	31464000
128469	2134	84511844000
128470	1874	31467000
128471	2132	147402415000
128472	1874	31468000
128473	2148	10080354880750
128522	1397	1281224257000
128523	1678	26640830843000
128524	2134	84503820000
128525	1874	31494000
128526	1622	8244000800048
128557	1740	14130800000000
128558	1740	14130847000000
128566	1397	1281154250000
128567	1678	26640830850000
128568	1397	1281144249000
128569	1678	26640830851000
128570	2134	84496799000
128571	1874	31517000
128572	2134	84495796000
128573	1874	31520000
128574	2132	147397410000
128575	1874	31521000
128576	1850	15816488949999
128581	1397	1281134248000
128582	1678	26640830852000
128583	1397	1281124247000
128584	1678	26640830853000
128585	1397	1281114246000
128586	1678	26640830854000
128587	2134	84494793000
128588	1874	31524000
128589	2134	84493790000
128590	1874	31527000
128591	2134	84492787000
128592	1874	31530000
128593	1709	9360232000000
128612	1397	1281074242000
128613	1678	26640830858000
128614	2132	147395408000
128615	1874	31541000
128616	2134	84488775000
128617	1874	31544000
128618	2112	22126955101924
128619	2112	22846955101924
128621	1395	58273831658957278
128638	1397	1281064241000
128639	1678	26640830859000
128640	1397	1281054240000
128641	1678	26640830860000
128642	2134	84487772000
128643	1874	31547000
128644	2134	84486769000
128645	1874	31550000
128646	2336	2160029000000
128647	1716	125000000
128648	2330	105000000
128660	1874	31551000
128661	576	78317665726897
128672	1395	58273831681957278
128677	1509	15503440503835
128678	1397	1281014236000
128679	1678	26640830864000
128680	1397	1281004235000
128681	1678	26640830865000
128074	1874	31231000
128075	2133	91097840000
128076	1874	31233000
128077	43	76080131890000
128078	43	76080143890000
128127	1594	15841874000000
128128	1594	15841899000000
128137	1397	1281674302000
128138	1678	26640830798000
128139	2134	84548955000
128140	1874	31273000
128141	2133	91089824000
128142	1874	31275000
128143	1395	58270951573957278
128144	1395	58270951585957278
128145	1397	1281664301000
128146	1678	26640830799000
128147	1397	1281654300000
128148	1678	26640830800000
128149	1397	1281644299000
128150	1678	26640830801000
128151	43	76080173890000
128152	1397	1281634298000
128153	1678	26640830802000
128154	2132	147413426000
128155	1874	31276000
128156	1726	983583112000
128157	2343	100000000
128158	2133	91088822000
128159	1874	31278000
128160	2134	84547952000
128161	1874	31281000
128162	2134	84546949000
128163	1874	31284000
128164	2134	84545946000
128165	1874	31287000
128166	2134	84544943000
128167	1874	31290000
128168	1726	982482112000
128169	2344	100000000
128170	2133	91087820000
128171	1874	31292000
128172	1726	981381112000
128173	2345	100000000
128174	2132	147412425000
128175	1874	31293000
128176	2133	91086818000
128177	1874	31295000
128178	2133	91085816000
128179	1874	31297000
128180	43	76800173890000
128181	43	76800196890000
128212	1397	1281594294000
128213	1678	26640830806000
128214	2134	84540931000
128215	1874	31315000
128216	2133	91081808000
128217	1874	31317000
128218	2132	147411424000
128219	1874	31318000
128220	43	77520196890000
128221	43	77520209890000
128222	1397	1281584293000
128223	1678	26640830807000
128224	1397	1281574292000
128225	1678	26640830808000
128226	1397	1281564291000
128227	1678	26640830809000
128228	1397	1281554290000
128229	1678	26640830810000
128230	2133	91080806000
128231	1874	31320000
128232	2133	91079804000
128233	1874	31322000
128234	2132	147410423000
128235	1874	31323000
128236	2134	84539928000
128237	1874	31326000
128238	2134	84538925000
128239	1874	31329000
128240	2134	84537922000
128241	1874	31332000
128242	2134	84536919000
128243	1874	31335000
128244	2133	91078802000
128245	1874	31337000
128246	2133	91077800000
128247	1874	31339000
128248	1395	58271671585957278
128249	1395	58271671634957278
128268	1397	1281524287000
128269	1678	26640830813000
128270	2134	84533910000
128271	1874	31353000
128272	2133	91074794000
128273	1874	31355000
128274	1690	182165772000000
128293	1397	1281494284000
128294	1678	26640830816000
128295	2133	91071788000
128296	1874	31367000
128297	2133	91070786000
128298	1874	31369000
128299	2134	84530901000
128300	1874	31372000
128301	2134	84529898000
128302	1874	31375000
128303	2132	147408421000
128304	1874	31376000
128305	171	76746783696494
128306	171	76746798696494
128363	1397	1281414276000
128364	1678	26640830824000
128365	2134	84521874000
128366	1874	31416000
128367	2133	91062770000
128368	1874	31418000
128369	1679	5758115657000
128370	1397	1281404275000
128371	1678	26640830825000
128372	2132	147405418000
128373	1874	31419000
128374	1679	5758126657000
128375	2134	84520871000
128376	1874	31422000
128377	2133	91061768000
128378	1874	31424000
128379	1679	6478126657000
128380	1807	6478128656999
128381	1679	200000009
128394	1397	1281374272000
128395	1678	26640830828000
128396	2132	147404417000
128397	1874	31432000
128398	2133	91058762000
128399	1874	31434000
128400	2134	84518865000
128401	1874	31437000
128402	1395	58272391634957278
128403	1395	58272391647957278
128428	1397	1281334268000
128429	1678	26640830832000
128430	2133	91054754000
128431	1874	31455000
128432	2134	84514853000
128433	1874	31458000
128434	1608	15258561000000
128435	1608	15258573000000
128474	1719	15838649000000
128475	1719	15838683000000
128477	1688	14470655113020
128478	1688	14470689113020
128485	1634	14783084259504
128486	1634	14783095259504
128508	1397	1281244259000
128509	1678	26640830841000
128510	2134	84505826000
128511	1874	31487000
128512	2132	147400413000
128513	1874	31488000
128514	43	78240209890000
128515	43	78240221890000
128559	1688	14470702113020
128560	1397	1281164251000
128561	1678	26640830849000
128562	2134	84497802000
128563	1874	31514000
128564	1394	853933597440200
128577	1980	24479578000000
128578	1980	24479601000000
128594	1397	1281104245000
128595	1678	26640830855000
128596	1397	1281094244000
128597	1678	26640830856000
128598	2132	147396409000
128599	1874	31531000
128600	2134	84491784000
128601	1874	31534000
128602	2134	84490781000
128603	1874	31537000
128604	1991	12861402355805
128605	1991	12861425355805
128622	2329	720022000000
128623	2329	302406199819988
128624	1874	30929000
128253	1874	31342000
128254	2133	91076798000
128255	1874	31344000
128256	1643	3308658914700
128257	1643	3308670914700
128285	1397	1281504285000
128286	1678	26640830815000
128287	2134	84531904000
128288	1874	31363000
128289	2133	91072790000
128290	1874	31365000
128291	2329	303846199819988
128292	2329	303846211819988
128307	1397	1281484283000
128308	1678	26640830817000
128309	1397	1281474282000
128310	1678	26640830818000
128311	2133	91069784000
128312	1874	31378000
128313	2133	91068782000
128314	1874	31380000
128315	2132	147407420000
128316	1874	31381000
128317	2134	84528895000
128318	1874	31384000
128319	2134	84527892000
128320	1874	31387000
128321	1402	43383336145435
128322	1402	43383361145435
128324	1397	1281464281000
128325	1678	26640830819000
128326	2133	91067780000
128327	1874	31389000
128328	2134	84526889000
128329	1874	31392000
128330	1710	13194046664140
128331	1710	13194058664140
128353	1397	1281424277000
128354	1678	26640830823000
128355	2134	84522877000
128356	1874	31411000
128357	2133	91063772000
128358	1874	31413000
128359	1394	849613539440200
128360	1394	849613551440200
128382	1397	1281394274000
128383	1678	26640830826000
128384	2133	91060766000
128385	1874	31426000
128386	1688	13750644113020
128387	1688	13750655113020
128404	1394	851053551440200
128405	1394	851053564440200
128407	1397	1281364271000
128408	1678	26640830829000
128409	1397	1281354270000
128410	1678	26640830830000
128411	2134	84517862000
128412	1874	31440000
128413	2134	84516859000
128414	1874	31443000
128415	2133	91057760000
128416	1874	31445000
128417	2133	91056758000
128418	1874	31447000
128419	1394	851053575440200
128516	1397	1281234258000
128517	1678	26640830842000
128518	2134	84504823000
128519	1874	31491000
128520	1395	58273111647957278
128521	1395	58273111658957278
128565	1688	14470666113020
128620	2112	22846944101924
128650	1716	2160056000000
128651	1397	1281044239000
128652	1678	26640830861000
128653	2134	84485766000
128654	1874	31553000
128655	2132	147394407000
128656	1874	31554000
128657	576	78317666726897
128690	1397	1280994234000
128691	1678	26640830866000
128692	2134	84480751000
128693	1874	31570000
128694	1684	25203380819412
128701	1700	11034292979053
128711	2134	84478745000
128712	1874	31577000
128713	2134	84477742000
128714	1874	31580000
128715	1670	10801085000000
128745	632	78237647000000
128760	1397	1280884223000
128761	1678	26640830877000
128762	2134	84469718000
128763	1874	31606000
128764	1402	44103361145435
128765	1402	44103372145435
128775	1764	14483516100000
128776	1764	14483528100000
128778	1764	14483518100000
128800	1765	720040001000
128801	1765	720074001000
128828	1694	16379081197225
128832	1397	1280784213000
128833	1678	26640830887000
128834	2134	84458685000
128835	1874	31642000
128836	2132	147386399000
128837	1874	31643000
128838	1394	858253643440200
128839	1394	858253655440200
128859	1397	1280744209000
128860	1678	26640830891000
128861	2134	84454673000
128862	1874	31656000
128863	1508	12440410156616
128880	1397	1280704205000
128881	1678	26640830895000
128882	1397	1280694204000
128883	1678	26640830896000
128884	2134	84450661000
128885	1874	31669000
128886	2134	84449658000
128887	1874	31672000
128888	1394	861133666440200
128889	1394	861133688440200
128903	1397	1280664201000
128904	1678	26640830899000
128905	2133	91053752000
128906	1874	31675000
128907	1874	31678000
128908	1874	31681000
128909	2134	84446649000
128910	1874	31684000
128911	1726	980280112000
128912	2346	100000000
128913	1439	12943860578477
128914	1439	12943875578477
128945	1397	1280624197000
128946	1678	26640830903000
128947	1397	1280614196000
128948	1678	26640830904000
128949	1726	978078112000
128950	2348	100000000
128951	2132	147381394000
128952	1874	31701000
128953	2134	84442637000
128954	1874	31704000
128955	2133	91049744000
128956	1874	31706000
128957	2133	91048742000
128958	1874	31708000
128959	2134	84441634000
128960	1874	31711000
128961	1467	5200292272869
128979	1680	12253334499559
128980	1680	12253346499559
128993	2086	2880380300069
128996	1397	1280574192000
128997	1678	26640830908000
128998	2134	84437622000
128999	1874	31730000
129000	2133	91044734000
129001	1874	31732000
129002	1613	12817381400000
129003	1613	12817393400000
129042	1397	1280514186000
129043	1678	26640830914000
129044	1397	1280504185000
129045	1678	26640830915000
129046	2133	91038722000
129047	1874	31760000
129048	2133	91037720000
129049	1874	31762000
129050	2132	147378391000
129051	1874	31763000
129052	2134	84431604000
129053	1874	31766000
129054	2134	84430601000
129055	1874	31769000
129056	1395	58274551658957278
129057	1395	58274551683957278
128497	1397	1281254260000
128498	1678	26640830840000
128499	2132	147401414000
128500	1874	31475000
128501	2134	84508835000
128502	1874	31478000
128503	2134	84507832000
128504	1874	31481000
128505	2134	84506829000
128506	1874	31484000
128507	149	76895381000341
128527	1397	1281214256000
128528	1678	26640830844000
128529	2134	84502817000
128530	1874	31497000
128531	1394	852493575440200
128532	1394	852493586440200
128533	1397	1281204255000
128534	1678	26640830845000
128535	1397	1281194254000
128536	1678	26640830846000
128537	1397	1281184253000
128538	1678	26640830847000
128539	1397	1281174252000
128540	1678	26640830848000
128541	2132	147399412000
128542	1874	31498000
128543	2132	147398411000
128544	1874	31499000
128545	2134	84501814000
128546	1874	31502000
128547	2134	84500811000
128548	1874	31505000
128549	2134	84499808000
128550	1874	31508000
128551	2134	84498805000
128552	1874	31511000
128553	531	66000000000000
128554	1681	14974751358535
128555	1394	853933586440200
128556	1394	853933633440200
128579	1714	15405747171760
128580	1714	15405770171760
128606	1397	1281084243000
128607	1678	26640830857000
128608	2134	84489778000
128609	1874	31540000
128610	1681	15694751358535
128611	1681	15694762358535
128658	1693	7191014570272
128659	1693	7191026570272
128662	1397	1281034238000
128663	1678	26640830862000
128664	1397	1281024237000
128665	1678	26640830863000
128666	2134	84484763000
128667	1874	31557000
128668	2134	84483760000
128669	1874	31560000
128670	1684	25203369819412
128671	1684	25203392819412
128675	1489	12623132040000
128676	1489	12623155040000
128689	1759	9577292139889
128695	1397	1280984233000
128696	1678	26640830867000
128697	2134	84479748000
128698	1874	31573000
128699	1395	58273831669957278
128716	1619	5040110000000
128723	1397	1280944229000
128724	1678	26640830871000
128725	2134	84475736000
128726	1874	31586000
128727	2132	147391404000
128728	1874	31587000
128729	1394	855373609440200
128766	1756	8480882195609
128777	1714	15405759171760
128779	1714	15405758171760
128780	2134	84467712000
128781	1874	31613000
128782	42	73580675000000
128852	1397	1280754210000
128853	1678	26640830890000
128854	2132	147385398000
128855	1874	31650000
128856	2134	84455676000
128857	1874	31653000
128858	1395	58273831670957278
128890	1397	1280684203000
128891	1678	26640830897000
128892	1397	1280674202000
128893	1678	26640830898000
128894	2132	147383396000
128895	1874	31673000
128896	1619	5760108000000
128897	1619	5760129000000
128962	1622	8244015800048
128970	1692	11260831619999
128994	1699	3600355750126
129004	1397	1280564191000
129005	1678	26640830909000
129006	2133	91043732000
129007	1874	31734000
129008	2134	84436619000
129009	1874	31737000
129010	1711	16267013000000
129011	1711	16267025000000
129058	1602	12816706170000
129163	1397	1280424177000
129164	1678	26640830923000
129165	2134	84422577000
129166	1874	31807000
129167	2133	91030706000
129168	1874	31809000
129169	2133	91029704000
129170	1874	31811000
129171	1762	8565598994000
129200	1397	1280384173000
129201	1678	26640830927000
129202	2134	84418565000
129203	1874	31830000
129204	2132	147374387000
129205	1874	31831000
129206	2133	91025696000
129207	1874	31833000
129208	1422	13194720804270
129211	1397	1280374172000
129212	1678	26640830928000
129213	1874	31812000
129214	1874	31815000
129215	1874	31818000
129216	1874	31821000
129217	1874	31823000
129218	1874	31825000
129219	1874	31829000
129220	1691	11231120300052
129221	1691	11231204300052
129257	1623	79203313898598
129258	1623	79203325898598
129259	1397	1280334168000
129260	1678	26640830932000
129261	1397	1280324167000
129262	1678	26640830933000
129263	1397	1280314166000
129264	1678	26640830934000
129265	1397	1280304165000
129266	1678	26640830935000
129267	1397	1280294164000
129268	1678	26640830936000
129269	2132	147372385000
129270	1874	31855000
129271	2134	84413550000
129272	1874	31858000
129273	1726	976977112000
129274	2349	100000000
129275	1726	975876112000
129276	2350	100000000
129277	2134	84412547000
129278	1874	31861000
129279	2134	84411544000
129280	1874	31864000
129281	2134	84410541000
129282	1874	31867000
129283	2134	84409538000
129284	1874	31870000
129285	2133	91020686000
129286	1874	31872000
129287	2133	91019684000
129288	1874	31874000
129289	2133	91018682000
129290	1874	31876000
129291	2133	91017680000
129292	1874	31878000
129293	2133	91016678000
129294	1874	31880000
129295	1476	13680257000000
129296	1476	13680320000000
129309	1643	4028670914700
129310	1643	4028683914700
129317	1397	1280264161000
129318	1678	26640830939000
129319	1397	1280254160000
129320	1678	26640830940000
128625	1874	30931000
128626	1874	30934000
128627	1874	30936000
128628	1874	30937000
128629	1874	30942000
128630	1874	30944000
128631	1874	30946000
128632	1874	30949000
128633	1874	30951000
128634	1874	30955000
128635	1874	30957000
128636	1555	15366240540449
128637	1555	15366279540449
128649	2248	11519555000000
128673	1394	855373597440200
128674	1394	855373620440200
128688	2329	303846222819988
128710	1619	5040108000000
128717	1513	35281226000000
128718	1397	1280954230000
128719	1678	26640830870000
128720	2134	84476739000
128721	1874	31583000
128722	1708	11160611500051
128739	1397	1280914226000
128740	1678	26640830874000
128741	2134	84472727000
128742	1874	31596000
128743	632	78237637000000
128744	632	78237648000000
128746	1397	1280904225000
128747	1678	26640830875000
128748	1397	1280894224000
128749	1678	26640830876000
128750	2134	84471724000
128751	1874	31599000
128752	2132	147390403000
128753	1874	31600000
128754	2134	84470721000
128755	1874	31603000
128756	1685	177844453571430
128757	1685	177844476571430
128767	1397	1280874222000
128768	1678	26640830878000
128769	2132	147389402000
128770	1874	31607000
128771	2134	84468715000
128772	1874	31610000
128773	1394	856813609440200
128774	1394	856813621440200
128783	1634	15503095259504
128784	1634	15503096259504
128785	1397	1280864221000
128786	1678	26640830879000
128787	1397	1280854220000
128788	1678	26640830880000
128789	1397	1280844219000
128790	1678	26640830881000
128791	2134	84466709000
128792	1874	31616000
128793	2132	147388401000
128794	1874	31617000
128795	2134	84465706000
128796	1874	31620000
128797	2134	84464703000
128798	1874	31623000
128799	1394	856813643440200
128802	1397	1280834218000
128803	1678	26640830882000
128804	2134	84463700000
128805	1874	31626000
128812	1397	1280814216000
128813	1678	26640830884000
128814	1397	1280804215000
128815	1678	26640830885000
128816	1397	1280794214000
128817	1678	26640830886000
128818	2134	84461694000
128819	1874	31632000
128820	2132	147387400000
128821	1874	31633000
128822	2134	84460691000
128823	1874	31636000
128824	2134	84459688000
128825	1874	31639000
128826	1679	7198128656999
128827	1679	7198162656999
128829	1694	15659817197225
128830	1694	16379817197225
128831	1694	16380297197225
128846	1397	1280764211000
128847	1678	26640830889000
128848	2134	84456679000
128849	1874	31649000
128850	2329	304566222819988
128851	2329	304566233819988
128864	1397	1280734208000
128865	1678	26640830892000
128866	1397	1280724207000
128867	1678	26640830893000
128868	1397	1280714206000
128869	1678	26640830894000
128870	2134	84453670000
128871	1874	31659000
128872	2134	84452667000
128873	1874	31662000
128874	2134	84451664000
128875	1874	31665000
128876	2132	147384397000
128877	1874	31666000
128878	606	76126831286230
128879	606	76126865286230
128928	1684	25923380819412
128929	1684	25923395819412
128931	1397	1280644199000
128932	1678	26640830901000
128933	1397	1280634198000
128934	1678	26640830902000
128935	2134	84444643000
128936	1874	31693000
128937	2133	91051748000
128938	1874	31695000
128939	2134	84443640000
128940	1874	31698000
128941	2133	91050746000
128942	1874	31700000
128943	1474	11430547000043
128944	1474	11430571000043
128963	1397	1280604195000
128964	1678	26640830905000
128965	2134	84440631000
128966	1874	31714000
128967	2133	91047740000
128968	1874	31716000
128969	1724	12654772500000
128971	1397	1280594194000
128972	1678	26640830906000
128973	2133	91046738000
128974	1874	31718000
128975	2134	84439628000
128976	1874	31721000
128977	1394	862573688440200
128978	1394	862573700440200
128991	1394	864013700440200
128992	1394	864013713440200
129028	1397	1280534188000
129029	1678	26640830912000
129030	1397	1280524187000
129031	1678	26640830913000
129032	2134	84433610000
129033	1874	31751000
129034	2133	91040726000
129035	1874	31753000
129036	2133	91039724000
129037	1874	31755000
129038	2134	84432607000
129039	1874	31758000
129040	1711	16987025000000
129041	1711	16987049000000
129059	1874	30804000
129060	1874	30806000
129061	1874	30807000
129062	1874	30809000
129063	1874	30810000
129064	1874	30812000
129065	1874	30816000
129066	1874	30818000
129067	1874	30822000
129068	1874	30824000
129069	1874	30828000
129070	1874	30830000
129071	1874	30834000
129072	1874	30836000
129073	1874	30840000
129074	1874	30842000
129075	1874	30846000
129076	1874	30848000
129077	1874	30852000
129078	1874	30854000
129079	1874	30858000
129080	1874	30860000
129081	1874	30864000
129082	1874	30866000
129083	1874	30870000
129084	1874	30872000
128682	2134	84482757000
128683	1874	31563000
128684	2134	84481754000
128685	1874	31566000
128686	2132	147393406000
128687	1874	31567000
128700	1700	11034291979053
128702	1397	1280974232000
128703	1678	26640830868000
128704	1397	1280964231000
128705	1678	26640830869000
128706	2132	147392405000
128707	1874	31574000
128708	1670	10801062000000
128709	1670	10801083000000
128730	1397	1280934228000
128731	1678	26640830872000
128732	1397	1280924227000
128733	1678	26640830873000
128734	2134	84474733000
128735	1874	31590000
128736	2134	84473730000
128737	1874	31593000
128738	1688	14470677113020
128758	1688	15190677113020
128759	1688	15190700113020
128806	1397	1280824217000
128807	1678	26640830883000
128808	2134	84462697000
128809	1874	31629000
128810	1593	14352754000000
128811	1593	14352765000000
128840	1397	1280774212000
128841	1678	26640830888000
128842	2134	84457682000
128843	1874	31646000
128844	1394	859693655440200
128845	1394	859693666440200
128898	2134	84448655000
128899	1874	31676000
128900	2134	84447652000
128901	1874	31679000
128902	1619	5760131000000
128915	1397	1280654200000
128916	1678	26640830900000
128917	2134	84445646000
128918	1874	31687000
128919	1726	979179112000
128920	2347	100000000
128921	2338	9000000
128922	2346	190000000
128923	2132	147382395000
128924	1874	31688000
128925	2133	91052750000
128926	1874	31690000
128927	1698	12308981550062
128930	1692	11260834619999
128981	1397	1280584193000
128982	1678	26640830907000
128983	2132	147380393000
128984	1874	31722000
128985	2133	91045736000
128986	1874	31724000
128987	2134	84438625000
128988	1874	31727000
128989	1619	6480129000000
128990	1619	6480142000000
128995	2087	3315411147766
129012	1397	1280554190000
129013	1678	26640830910000
129014	1397	1280544189000
129015	1678	26640830911000
129016	2133	91042730000
129017	1874	31739000
129018	2133	91041728000
129019	1874	31741000
129020	2132	147379392000
129021	1874	31742000
129022	2134	84435616000
129023	1874	31745000
129024	2134	84434613000
129025	1874	31748000
129026	149	77615381000341
129027	149	77615406000341
129126	1397	1280474182000
129127	1678	26640830918000
129128	2134	84427592000
129129	1874	31783000
129130	2133	91034714000
129131	1874	31785000
129132	1395	58275271683957278
129133	1395	58275271695957278
129190	1397	1280394174000
129191	1678	26640830926000
129192	2133	91026698000
129193	1874	31824000
129194	2134	84419568000
129195	1874	31827000
129196	1394	865453713440200
129197	1394	865453725440200
129209	1536	18720360000000
129210	1536	18720373000000
129222	1397	1280364171000
129223	1678	26640830929000
129224	2134	84417562000
129225	1874	31836000
129226	2134	84416559000
129227	1874	31839000
129228	2133	91024694000
129229	1874	31841000
129230	2133	91023692000
129231	1874	31843000
129232	1679	7918162656999
129233	1679	7918186656999
129235	1701	15121607500103
129236	1701	15841607500103
129247	2329	306006245819988
129248	2329	306006258819988
129297	1610	10800237999950
129298	1610	10800300999950
129333	1397	1280244159000
129334	1678	26640830941000
129335	2133	91011668000
129336	1874	31901000
129337	2134	84405526000
129338	1874	31904000
129345	1694	16381067197225
129346	1694	17101067197225
129347	1694	17101150197225
129364	1394	869773762440200
129365	1394	869773774440200
129376	1397	1280204155000
129377	1678	26640830945000
129378	2133	91007660000
129379	1874	31922000
129380	2134	84401514000
129381	1874	31925000
129382	2055	2159014000000
129383	2055	2159026000000
129421	1397	1280154150000
129422	1678	26640830950000
129423	2134	84396499000
129424	1874	31949000
129425	2132	147367380000
129426	1874	31950000
129427	2133	91002650000
129428	1874	31952000
129429	1547	10794816000000
129430	1547	10794829000000
129440	1613	13537393400000
129441	1613	13537405400000
129470	1874	31968000
129471	1874	31971000
129472	1719	15838651000000
129481	1765	720052001000
129487	1397	1280084143000
129488	1678	26640830957000
129489	2134	84389478000
129490	1874	31984000
129491	2132	147365378000
129492	1874	31985000
129493	2133	90996638000
129494	1874	31987000
129584	1719	16558649000000
129699	1397	1279974132000
129700	1678	26640830968000
129701	1397	1279964131000
129702	1678	26640830969000
129703	2133	90984614000
129704	1874	32047000
129705	2134	84377442000
129706	1874	32050000
129707	2133	90983612000
129708	1874	32052000
129709	2134	84376439000
129710	1874	32055000
129711	2132	147361374000
129712	1874	32056000
129713	1684	25923405819412
129741	1397	1279934128000
129742	1678	26640830972000
129743	2134	84373430000
129744	1874	32069000
129745	2352	99000000
129746	2133	90980606000
129085	1874	30876000
129086	1874	30882000
129087	1874	30884000
129088	1874	30890000
129089	1874	30896000
129090	1874	30902000
129091	1874	30904000
129092	1874	30908000
129093	1874	30914000
129094	1874	30916000
129095	1874	30920000
129096	1874	30922000
129097	1602	12096758170000
129098	1681	14254739358535
129099	1874	30965000
129100	1874	30974000
129101	1874	30976000
129102	1874	30980000
129103	1571	9260664124170
129104	1602	12816758169992
129105	1568	66000000001360
129106	45	400000
129107	1855	1602600000
129108	1758	200006780
129109	1571	12816795318124
129110	1602	9260664124178
129134	1397	1280464181000
129135	1678	26640830919000
129136	2134	84426589000
129137	1874	31788000
129138	1741	1439021000000
129139	1561	0
129140	2133	91033712000
129141	1874	31790000
129172	1397	1280414176000
129173	1678	26640830924000
129174	2133	91028702000
129175	1874	31813000
129176	2134	84421574000
129177	1874	31816000
129178	2132	147375388000
129179	1874	31817000
129180	1559	11106151999999
129181	1559	11106164999999
129198	1690	182885772000000
129199	1690	182885784000000
129249	1397	1280344169000
129250	1678	26640830931000
129251	2133	91021688000
129252	1874	31851000
129253	2134	84414553000
129254	1874	31854000
129255	1394	866893725440200
129256	1394	866893737440200
129339	1706	16842246450256
129340	1706	16842258450256
129366	1397	1280214156000
129367	1678	26640830944000
129368	2133	91008662000
129369	1874	31916000
129370	2132	147369382000
129371	1874	31917000
129372	2134	84402517000
129373	1874	31920000
129374	1571	9980664124162
129375	1571	9980677124162
129384	1397	1280194154000
129385	1678	26640830946000
129386	1397	1280184153000
129387	1678	26640830947000
129388	1395	58275991728957278
129389	2134	84400511000
129390	1874	31928000
129391	2134	84399508000
129392	1874	31931000
129393	2133	91006658000
129394	1874	31933000
129395	2132	147368381000
129396	1874	31934000
129397	2133	91005656000
129398	1874	31936000
129399	1395	58276711728957278
129400	1395	58276711733957278
129404	1397	1280174152000
129405	1678	26640830948000
129406	1397	1280164151000
129407	1678	26640830949000
129408	2133	91004654000
129409	1874	31938000
129410	2133	91003652000
129411	1874	31940000
129412	2134	84398505000
129413	1874	31943000
129414	2134	84397502000
129415	1874	31946000
129416	1444	12327842329991
129417	1571	12327866329975
129418	1444	9260664124186
129419	1444	12327842329999
129420	1444	12327866329999
129457	55	68160049000000
129458	55	68160073000000
129469	1719	15838662000000
129473	1397	1280104145000
129474	1678	26640830955000
129475	2133	90997640000
129476	1874	31975000
129477	2134	84391484000
129478	1874	31978000
129479	1467	5920292272869
129480	1467	5920304272869
129495	1874	31859000
129496	1874	31860000
129497	1874	31862000
129498	1874	31863000
129499	1874	31865000
129500	1874	31868000
129501	1874	31871000
129502	1874	31877000
129503	1874	31883000
129504	1874	31889000
129505	1874	31895000
129506	1874	31898000
129507	1874	31910000
129508	1874	31913000
129509	1874	31919000
129510	1874	31937000
129511	1874	31939000
129512	1874	31941000
129513	1874	31945000
129514	1874	31947000
129515	1402	44103674145435
129516	1874	31951000
129517	1874	31953000
129518	1874	31955000
129519	1874	31963000
129520	1874	31965000
129521	1874	31977000
129522	1874	31979000
129523	1874	31983000
129524	1402	44823674145435
129525	1402	44823693145435
129551	1874	31842000
129552	1874	31845000
129553	1874	31848000
129554	1874	31857000
129555	1874	31866000
129556	1874	31869000
129557	1874	31875000
129558	1874	31881000
129559	1874	31884000
129560	1874	31887000
129561	1874	31902000
129562	1874	31905000
129563	1874	31908000
129564	1874	31918000
129565	1874	31921000
129566	1874	31923000
129567	1874	31924000
129568	1874	31926000
129569	1874	31927000
129570	1874	31929000
129571	1874	31935000
129572	1468	457000000
129573	1468	720457000000
129574	1527	720458000001
129575	1468	290999959
129585	1397	1280034138000
129586	1678	26640830962000
129587	1397	1280024137000
129588	1678	26640830963000
129589	2134	84384463000
129590	1874	32011000
129591	2134	84383460000
129592	1874	32014000
129593	2133	90991628000
129594	1874	32016000
129595	2133	90990626000
129596	1874	32018000
129597	1719	15838673000000
129600	2134	84382457000
129601	1874	32021000
129602	2132	147363376000
129603	1874	32022000
129604	2133	90989624000
129111	1397	1280494184000
129112	1678	26640830916000
129113	1397	1280484183000
129114	1678	26640830917000
129115	2132	147377390000
129116	1874	31770000
129117	2133	91036718000
129118	1874	31772000
129119	2133	91035716000
129120	1874	31774000
129121	2134	84429598000
129122	1874	31777000
129123	2134	84428595000
129124	1874	31780000
129125	1705	22880980580140
129142	1397	1280454180000
129143	1678	26640830920000
129144	1546	10317454800000
129145	1397	1280444179000
129146	1678	26640830921000
129147	2133	91032710000
129148	1874	31792000
129149	2133	91031708000
129150	1874	31794000
129151	2134	84425586000
129152	1874	31797000
129153	2134	84424583000
129154	1874	31800000
129155	2132	147376389000
129156	1874	31801000
129157	1546	11037454800000
129158	1546	11037469800000
129159	1397	1280434178000
129160	1678	26640830922000
129161	2134	84423580000
129162	1874	31804000
129182	1397	1280404175000
129183	1678	26640830925000
129184	2134	84420571000
129185	1874	31820000
129186	2133	91027700000
129187	1874	31822000
129188	2329	305286233819988
129189	2329	305286245819988
129234	1623	78483313898598
129237	1397	1280354170000
129238	1678	26640830930000
129239	2132	147373386000
129240	1874	31844000
129241	2133	91022690000
129242	1874	31846000
129243	2134	84415556000
129244	1874	31849000
129245	1395	58275991695957278
129246	1395	58275991708957278
129299	1397	1280284163000
129300	1678	26640830937000
129301	2133	91015676000
129302	1874	31882000
129303	2134	84408535000
129304	1874	31885000
129305	2132	147371384000
129306	1874	31886000
129307	418	66720000000000
129308	418	66720013000000
129311	1397	1280274162000
129312	1678	26640830938000
129313	1741	1439010000000
129314	3	145418010000000
129315	2133	91014674000
129316	1874	31888000
129341	1471	17945484900000
129342	1471	17945496900000
129348	1397	1280234158000
129349	1678	26640830942000
129350	2134	84404523000
129351	1874	31907000
129352	2133	91010666000
129353	1874	31909000
129354	1762	9285598994000
129355	1762	9285610994000
129431	1394	869773775440200
129442	1397	1280134148000
129443	1678	26640830952000
129444	1397	1280124147000
129445	1678	26640830953000
129446	2133	91000646000
129447	1874	31959000
129448	2133	90999644000
129449	1874	31961000
129450	2134	84394493000
129451	1874	31964000
129452	2134	84393490000
129453	1874	31967000
129454	2329	306726258819988
129455	2329	306726282819988
129459	1397	1280114146000
129460	1678	26640830954000
129461	2133	90998642000
129462	1874	31969000
129463	2132	147366379000
129464	1874	31970000
129465	2134	84392487000
129466	1874	31973000
129467	1588	15841870000000
129528	1397	1280074142000
129529	1678	26640830958000
129530	2133	90995636000
129531	1874	31989000
129532	2134	84388475000
129533	1874	31992000
129534	1690	183605796000000
129535	1690	183605808000000
129576	1397	1280044139000
129577	1678	26640830961000
129578	2133	90992630000
129579	1874	32005000
129580	2134	84385466000
129581	1874	32008000
129582	1656	14395508999990
129583	1656	14395520999990
129598	1623	79923325898598
129599	1623	79923349898598
129607	1397	1280014136000
129608	1678	26640830964000
129609	2134	84381454000
129610	1874	32027000
129611	2133	90988622000
129612	1874	32029000
129613	1394	871213775440200
129614	1394	871213787440200
129617	1874	31847000
129618	1874	31852000
129619	1874	31853000
129620	1874	31856000
129621	1874	31873000
129622	1874	31879000
129623	1874	31891000
129624	1874	31894000
129625	1874	31897000
129626	1874	31900000
129627	1874	31903000
129628	1874	31906000
129629	1874	31912000
129630	1874	31915000
129631	1874	31930000
129632	1874	31942000
129633	641	78964315000000
129634	1874	31948000
129635	1874	31960000
129636	1874	31991000
129637	1874	31993000
129638	1874	31995000
129639	1874	31997000
129640	1874	32001000
129641	1874	32007000
129642	1874	32009000
129643	1874	32013000
129644	1874	32015000
129645	1874	32017000
129646	1874	32019000
129647	1874	32023000
129648	1874	32025000
129649	641	79684315000000
129650	641	79684355000000
129691	1395	58278151744957278
129692	1395	58278151770957278
129714	1397	1279954130000
129715	1678	26640830970000
129716	1726	974775112000
129717	2351	100000000
129718	418	66310011000000
129719	1950	14848851000000
129720	2134	84375436000
129721	1874	32059000
129722	1726	973674112000
129723	2352	100000000
129724	2133	90982610000
129725	1874	32061000
129726	1423	3600627750023
129727	1423	3600642750023
129728	1395	58278151759957278
129771	2307	2879072000000
129792	1397	1279884123000
129793	1678	26640830977000
129321	2133	91013672000
129322	1874	31890000
129323	2133	91012670000
129324	1874	31892000
129325	2132	147370383000
129326	1874	31893000
129327	2134	84407532000
129328	1874	31896000
129329	2134	84406529000
129330	1874	31899000
129331	1394	868333737440200
129332	1394	868333762440200
129343	606	76846865286230
129344	606	76846877286230
129356	1397	1280224157000
129357	1678	26640830943000
129358	2133	91009664000
129359	1874	31911000
129360	2134	84403520000
129361	1874	31914000
129362	1705	23600980580140
129363	1705	23600992580140
129401	1419	23326186559748
129402	1419	24046186559748
129403	1419	24046191559748
129432	1397	1280144149000
129433	1678	26640830951000
129434	2133	91001648000
129435	1874	31954000
129436	2134	84395496000
129437	1874	31957000
129438	1395	58277431733957278
129439	1395	58277431745957278
129456	1690	182885796000000
129468	2329	306726271819988
129482	1397	1280094144000
129483	1678	26640830956000
129484	2134	84390481000
129485	1874	31981000
129486	1395	58277431744957278
129526	1756	9200882195609
129527	1756	9200895195609
129536	1397	1280064141000
129537	1678	26640830959000
129538	1397	1280054140000
129539	1678	26640830960000
129540	2133	90994634000
129541	1874	31994000
129542	2133	90993632000
129543	1874	31996000
129544	2134	84387472000
129545	1874	31999000
129546	2132	147364377000
129547	1874	32000000
129548	2134	84386469000
129549	1874	32003000
129550	1657	7921359990100
129615	641	79683921000000
129616	641	79683933000000
129651	641	78964481000000
129652	1874	31608000
129653	1874	31609000
129654	1874	31619000
129655	1874	31622000
129656	1874	31625000
129657	1874	31628000
129658	2338	99000000
129659	1874	31635000
129660	1874	31637000
129661	1874	31638000
129662	1874	31640000
129663	1874	31641000
129664	1874	31644000
129665	1874	31645000
129666	1874	31652000
129667	1874	31655000
129668	1874	31658000
129669	1874	31661000
129670	1874	31664000
129671	1874	31667000
129672	641	79684481000000
129673	641	79684829000000
129729	1447	19721890683000
129730	1397	1279944129000
129731	1678	26640830971000
129732	2134	84374433000
129733	1874	32064000
129734	1726	972573112000
129735	2353	100000000
129736	1690	183605820000000
129737	2133	90981608000
129738	1874	32066000
129739	1690	184325820000000
129740	1690	184325821000000
129772	1394	872653787440200
129773	1394	872653799440200
129774	1397	1279904125000
129775	1678	26640830975000
129776	2134	84370421000
129777	1874	32085000
129778	2133	90977600000
129779	1874	32087000
129780	1394	874093799440200
129781	1394	874093811440200
129799	1397	1279874122000
129800	1678	26640830978000
129801	1397	1279864121000
129802	1678	26640830979000
129803	2132	147358371000
129804	1874	32099000
129805	2134	84367412000
129806	1874	32102000
129807	2134	84366409000
129808	1874	32105000
129809	2133	90974594000
129810	1874	32107000
129811	2133	90973592000
129812	1874	32109000
129813	1394	875533811440200
129814	1394	875533836440200
129834	1678	26640830980000
129835	1678	26640830981000
129836	1397	1279834118000
129837	1678	26640830982000
129838	1397	1279824117000
129839	1678	26640830983000
129840	1874	31840000
129841	2132	147357370000
129842	1691	11231795300052
129843	1874	31966000
129844	1874	31972000
129845	1691	11951795300052
129846	1691	11951824300052
129878	1397	1279794114000
129879	1678	27360855986000
129880	1397	1279784113000
129881	1678	27360855987000
129882	2134	84359388000
129883	1874	32143000
129884	2134	84358385000
129885	1874	32146000
129886	2133	90966578000
129887	1874	32148000
129888	2133	90965576000
129889	1874	32150000
129890	2132	147356369000
129891	1874	32151000
129892	1476	14400320000000
129893	1476	14400345000000
129918	1634	15503120259504
129946	1397	1279714106000
129947	1678	27360855994000
129948	2133	90958562000
129949	1874	32185000
129950	2134	84351364000
129951	1874	32188000
129960	1678	26640830984000
129961	1678	26640830985000
129962	1678	26640830986000
129963	1678	26640830987000
129964	1678	26640830988000
129965	1678	26640830989000
129966	1678	26640830990000
129967	1678	26640830991000
129968	1678	26640830992000
129969	1678	26640830993000
129970	1678	26640830994000
129971	1678	26640830995000
129972	1874	31990000
129973	1874	32002000
129974	1874	32004000
129975	1874	32020000
129976	1874	32026000
129977	1874	32035000
129978	1874	32038000
129979	1874	32041000
129980	1874	32044000
129981	1874	32053000
129982	1874	32062000
129983	1874	32065000
129984	1874	32067000
129985	1874	32073000
129986	1874	32081000
129987	1874	32083000
129988	1874	32091000
129605	1874	32024000
129606	369	80196633290830
129674	1397	1280004135000
129675	1678	26640830965000
129676	1397	1279994134000
129677	1678	26640830966000
129678	2133	90987620000
129679	1874	32031000
129680	418	66620012000000
129681	1950	14538851000000
129682	2132	147362375000
129683	1874	32032000
129684	2133	90986618000
129685	1874	32034000
129686	2134	84380451000
129687	1874	32037000
129688	2134	84379448000
129689	1874	32040000
129690	1654	15977497999798
129693	1397	1279984133000
129694	1678	26640830967000
129695	2134	84378445000
129696	1874	32043000
129697	2133	90985616000
129698	1874	32045000
129760	1690	185045821000000
129761	1690	185045835000000
129832	1684	26643405819412
129833	1684	26643417819412
129876	1874	32138000
129877	1692	11260820619999
129902	1397	1279764111000
129903	1678	27360855989000
129904	1397	1279754110000
129905	1678	27360855990000
129906	2132	147355368000
129907	1874	32157000
129908	2134	84356379000
129909	1874	32160000
129910	2134	84355376000
129911	1874	32163000
129912	2133	90963572000
129913	1874	32165000
129914	2133	90962570000
129915	1874	32167000
129916	2261	8639196000000
129917	2261	8639221000000
129919	1397	1279744109000
129920	1678	27360855991000
129921	2134	84354373000
129922	1874	32170000
129923	2133	90961568000
129924	1874	32172000
129925	1643	4028682914700
129952	1397	1279704105000
129953	1678	27360855995000
129954	2133	90957560000
129955	1874	32190000
129956	2134	84350361000
129957	1874	32193000
129958	1705	24320992580140
129959	1705	24321004580140
130053	1397	1279654100000
130054	1678	27360856000000
130055	2133	90952550000
130056	1874	32214000
130057	1874	32217000
130058	2134	84345346000
130059	1874	32220000
130060	1444	13047866329999
130061	1444	13047891329999
130069	1397	1279634098000
130070	1678	27360856002000
130071	2134	84343340000
130072	1874	32228000
130073	2133	90950546000
130074	1874	32230000
130075	1394	878413835440200
130076	1394	878413847440200
130098	1874	32238000
130099	1451	5467783000000
130100	1451	5467794000000
130114	1397	1279594094000
130115	1678	27360856006000
130116	2132	147350363000
130117	1874	32247000
130118	2133	90946538000
130119	1874	32249000
130120	2134	84339328000
130121	1874	32252000
130122	1394	879853848440200
130123	1394	879853861440200
130150	1654	16697497999798
130173	1702	6480559000000
130174	1397	1279524087000
130175	1678	27360856013000
130176	1397	1279514086000
130177	1678	27360856014000
130178	2132	147348361000
130179	1874	32284000
130180	2134	84332307000
130181	1874	32287000
130182	2134	84331304000
130183	1874	32290000
130184	42	74300675000000
130185	42	74300698000000
130194	1397	1279504085000
130195	1678	27360856015000
130196	2133	90937520000
130197	1874	32296000
130198	2134	84330301000
130199	1874	32299000
130200	2351	99000000
130201	1690	185045834000000
130244	2329	307446274819988
130281	1397	1279404075000
130282	1678	27360856025000
130283	2132	147344357000
130284	1874	32350000
130285	2134	84320271000
130286	1874	32353000
130287	2133	90926498000
130288	1874	32355000
130289	1680	12253347499559
130357	1397	1279314066000
130358	1678	27360856034000
130359	2134	84311244000
130360	1874	32400000
130361	2133	90917480000
130362	1874	32402000
130363	1395	58281031817957278
130364	1395	58281031829957278
130365	1678	26640830996000
130366	1678	26640830997000
130367	1678	26640830998000
130368	1678	26640830999000
130369	1678	26640831000000
130370	1678	26640831001000
130371	1678	26640831002000
130372	1678	26640831003000
130373	1678	26640831004000
130374	1678	26640831005000
130375	1678	26640831006000
130376	1678	26640831007000
130377	1678	26640831008000
130378	1678	26640831009000
130379	1678	26640831010000
130380	1678	26640831011000
130381	1678	26640831012000
130382	1678	26640831013000
130383	1678	26640831014000
130384	1678	26640831015000
130385	1678	26640831016000
130386	1678	26640831017000
130387	1678	26640831018000
130388	1678	26640831019000
130389	1678	26640831020000
130390	1678	26640831021000
130391	1678	26640831022000
130392	1678	26640831023000
130393	1678	26640831024000
130394	1678	26640831025000
130395	1678	26640831026000
130396	1678	26640831027000
130397	1678	26640831028000
130398	1678	26640831029000
130399	1678	26640831030000
130400	1678	26640831031000
130401	1678	26640831032000
130402	1678	26640831033000
130403	1874	31998000
130404	1874	32006000
130405	1874	32010000
130406	1874	32012000
130407	1402	44824483145435
130408	1874	32033000
130409	1874	32039000
130410	1874	32049000
130411	1874	32051000
130412	1874	32057000
130413	1402	45544483145435
130414	1402	45544502145435
130469	1714	16125759171760
130502	1394	884173962440200
130545	1426	13290428000000
129747	1874	32071000
129748	1675	18284437999977
129749	1397	1279924127000
129750	1678	26640830973000
129751	2132	147360373000
129752	1874	32072000
129753	418	66000010000000
129754	1950	15158851000000
129755	2134	84372427000
129756	1874	32075000
129757	2133	90979604000
129758	1874	32077000
129759	2329	306726272819988
129762	1397	1279914126000
129763	1678	26640830974000
129764	2133	90978602000
129765	1874	32079000
129766	2134	84371424000
129767	1874	32082000
129768	1671	15504259003785
129769	1506	7920215967172
129770	1506	7920227967172
129782	1397	1279894124000
129783	1678	26640830976000
129784	2133	90976598000
129785	1874	32089000
129786	2132	147359372000
129787	1874	32090000
129788	2134	84369418000
129789	1874	32093000
129790	1762	10005610994000
129791	1762	10005623994000
129815	1678	27360830979000
129816	1678	27360855979000
129825	1397	1279844119000
129826	1678	27360855981000
129827	2134	84364403000
129828	1874	32117000
129829	2133	90971588000
129830	1874	32119000
129831	1394	875533823440200
129847	1678	27360855982000
129848	1678	27360855983000
129849	1397	1279814116000
129850	1678	27360855984000
129851	1874	32120000
129852	2134	84363400000
129853	1874	32123000
129854	2134	84362397000
129855	1874	32126000
129856	2134	84361394000
129857	1874	32129000
129858	2133	90970586000
129859	1874	32131000
129860	2133	90969584000
129861	1874	32133000
129862	2133	90968582000
129863	1874	32135000
129864	1395	58279591768957278
129865	1395	58279591805957278
129874	1708	11880611500051
129875	1708	11880623500051
129894	1397	1279774112000
129895	1678	27360855988000
129896	2134	84357382000
129897	1874	32154000
129898	2133	90964574000
129899	1874	32156000
129900	1394	876973823440200
129901	1394	876973835440200
129934	1474	12150571000043
129935	1474	12150583000043
130041	1685	177124485571430
130042	1685	177844485571430
130043	1685	177844490571430
130090	1397	1279614096000
130091	1678	27360856004000
130092	2134	84341334000
130093	1874	32239000
130094	2133	90948542000
130095	1874	32241000
130096	1458	20825443908540
130097	1458	20825455908540
130103	2329	307446272819988
130104	2329	307446284819988
130107	1397	1279604095000
130108	1678	27360856005000
130109	2134	84340331000
130110	1874	32244000
130111	2133	90947540000
130112	1874	32246000
130113	1602	12816693170000
130132	1710	13914058664140
130133	1710	13914070664140
130142	1397	1279564091000
130143	1678	27360856009000
130144	2133	90943532000
130145	1874	32264000
130146	2134	84336319000
130147	1874	32267000
130148	2132	147349362000
130149	1874	32268000
130171	1703	6480908000000
130172	1703	6480944000000
130235	1685	178564515571430
130267	1397	1279424077000
130268	1678	27360856023000
130269	1588	16561907000000
130270	2134	84321274000
130271	1874	32345000
130272	2133	90928502000
130273	1874	32347000
130274	1588	17281907000000
130275	1588	17281909000000
130276	1397	1279414076000
130277	1678	27360856024000
130278	2133	90927500000
130279	1874	32349000
130280	1688	15190688113020
130326	1397	1279344069000
130327	1678	27360856031000
130328	2133	90920486000
130329	1874	32383000
130330	2134	84314253000
130331	1874	32386000
130332	1656	15115520999990
130333	1656	15115532999990
130348	1394	884173923440200
130349	1394	884173936440200
130422	1397	1279294064000
130423	1678	27360856036000
130424	2134	84310241000
130425	1874	32408000
130426	2133	90915476000
130427	1874	32410000
130428	2134	84309238000
130429	1874	32413000
130430	1688	15910688113020
130431	1688	15910701113020
130477	1397	1279234058000
130478	1678	27360856042000
130479	1397	1279224057000
130480	1678	27360856043000
130481	1397	1279214056000
130482	1678	27360856044000
130483	2335	0
130484	2346	289000000
130485	2337	0
130486	2346	388000000
130487	2134	84303220000
130488	1874	32442000
130489	2134	84302217000
130490	1874	32445000
130491	2134	84301214000
130492	1874	32448000
130493	2132	147339352000
130494	1874	32449000
130495	2133	90909464000
130496	1874	32451000
130497	2133	90908462000
130498	1874	32453000
130499	2133	90907460000
130500	1874	32455000
130501	1622	8244028800048
130512	1397	1279194054000
130513	1678	27360856046000
130514	1397	1279184053000
130515	1678	27360856047000
130516	2134	84299208000
130517	1874	32464000
130518	2134	84298205000
130519	1874	32467000
130520	2133	90905456000
130521	1874	32469000
130522	2133	90904454000
130523	1874	32471000
130524	621	68880057000000
130525	621	68880081000000
130550	1571	16558697999992
130551	1719	9260664124170
130569	1397	1279134048000
130570	1678	27360856052000
130571	2133	90899444000
130572	1874	32494000
130573	2132	147336349000
129794	2133	90975596000
129795	1874	32095000
129796	2134	84368415000
129797	1874	32098000
129798	1395	58278151756957278
129817	1397	1279854120000
129818	1678	27360855980000
129819	2133	90972590000
129820	1874	32111000
129821	2134	84365406000
129822	1874	32114000
129823	1395	58278871756957278
129824	1395	58278871768957278
129866	1397	1279804115000
129867	1678	27360855985000
129868	2133	90967580000
129869	1874	32137000
129870	2134	84360391000
129871	1874	32140000
129872	1549	13391420000000
129873	1549	13391432000000
129926	1397	1279734108000
129927	1678	27360855992000
129928	2133	90960566000
129929	1874	32174000
129930	2134	84353370000
129931	1874	32177000
129932	1395	58280311805957278
129933	1395	58280311817957278
129936	1397	1279724107000
129937	1678	27360855993000
129938	2132	147354367000
129939	1874	32178000
129940	2133	90959564000
129941	1874	32180000
129942	2134	84352367000
129943	1874	32183000
129944	1508	13160410156616
129945	1508	13160423156616
130062	1397	1279644099000
130063	1678	27360856001000
130064	2134	84344343000
130065	1874	32223000
130066	2133	90951548000
130067	1874	32225000
130077	1685	178564490571430
130078	1685	178564502571430
130105	1643	4748682914700
130106	1643	4748694914700
130134	1397	1279574092000
130135	1678	27360856008000
130136	2133	90944534000
130137	1874	32259000
130138	2134	84337322000
130139	1874	32262000
130140	1693	7911026570272
130141	1693	7911038570272
130151	1397	1279554090000
130152	1678	27360856010000
130153	1397	1279544089000
130154	1678	27360856011000
130155	1397	1279534088000
130156	1678	27360856012000
130157	2134	84335316000
130158	1874	32271000
130159	2134	84334313000
130160	1874	32274000
130161	2134	84333310000
130162	1874	32277000
130163	2133	90942530000
130164	1874	32279000
130165	2133	90941528000
130166	1874	32281000
130167	2133	90940526000
130168	1874	32283000
130169	1654	16697533999798
130186	2133	90939524000
130187	1874	32286000
130188	2133	90938522000
130189	1874	32288000
130190	1874	32291000
130191	1874	32294000
130192	1394	881293861440200
130193	1394	881293886440200
130202	1397	1279494084000
130203	1678	27360856016000
130204	1397	1279484083000
130205	1678	27360856017000
130206	2134	84329298000
130207	1874	32302000
130208	2134	84328295000
130209	1874	32305000
130210	2351	98000000
130211	2133	90936518000
130212	1874	32307000
130213	2133	90935516000
130214	1874	32309000
130215	2351	97000000
130216	2132	147347360000
130217	1874	32310000
130218	1588	16561870000000
130219	1588	16561897000000
130236	2134	84325286000
130237	1874	32324000
130238	2133	90932510000
130239	1874	32326000
130240	1705	25041004580140
130241	1705	25041006580140
130298	1397	1279384073000
130299	1678	27360856027000
130300	1397	1279374072000
130301	1678	27360856028000
130302	2133	90924494000
130303	1874	32362000
130304	2134	84318265000
130305	1874	32365000
130306	2134	84317262000
130307	1874	32368000
130308	2133	90923492000
130309	1874	32370000
130310	2132	147343356000
130311	1874	32371000
130312	1679	7918187656999
130336	1397	1279334068000
130337	1678	27360856032000
130338	2132	147342355000
130339	1874	32387000
130340	2134	84313250000
130341	1874	32390000
130342	2133	90919484000
130343	1874	32392000
130344	1672	11521446000000
130345	1672	11521459000000
130432	1397	1279284063000
130433	1678	27360856037000
130434	2134	84308235000
130435	1874	32416000
130436	2133	90914474000
130437	1874	32418000
130438	1717	15661301000055
130439	2329	308166296819988
130440	2329	308166308819988
130443	1397	1279274062000
130444	1678	27360856038000
130445	1397	1279264061000
130446	1678	27360856039000
130447	2132	147340353000
130448	1874	32419000
130449	2134	84307232000
130450	1874	32422000
130451	2133	90913472000
130452	1874	32424000
130453	2133	90912470000
130454	1874	32426000
130455	2134	84306229000
130456	1874	32429000
130457	1709	10080232000000
130458	1709	10080257000000
130460	1397	1279254060000
130461	1678	27360856040000
130462	2338	8000000
130463	2133	90911468000
130464	1874	32431000
130465	2134	84305226000
130466	1874	32434000
130470	1397	1279244059000
130471	1678	27360856041000
130472	2134	84304223000
130473	1874	32437000
130474	2133	90910466000
130475	1874	32439000
130476	1714	16125771171760
130526	621	68880063000000
130548	1719	16558697000000
130549	1719	16558698000000
130552	1397	1279154050000
130553	1678	27360856050000
130554	1397	1279144049000
130555	1678	27360856051000
130556	2133	90901448000
130557	1874	32484000
130558	2133	90900446000
130559	1874	32486000
130560	2134	84295196000
130561	1874	32489000
129989	1874	32097000
129990	1874	32101000
129991	1874	32103000
129992	1874	32113000
129993	1874	32115000
129994	1874	32121000
129995	1874	32125000
129996	1874	32127000
129997	1874	32139000
129998	1874	32141000
129999	1874	32145000
130000	1874	32147000
130001	1874	32149000
130002	1874	32153000
130003	1874	32155000
130004	1874	32159000
130005	1874	32161000
130006	1874	32169000
130007	1874	32171000
130008	1874	32173000
130009	1874	32175000
130010	1691	11952028300052
130011	1874	32179000
130012	1874	32181000
130013	1874	32187000
130014	1874	32189000
130015	1874	32191000
130016	1691	12672028300052
130017	1691	12672036300052
130018	1397	1279694104000
130019	1678	27360855996000
130020	1397	1279684103000
130021	1678	27360855997000
130022	1397	1279674102000
130023	1678	27360855998000
130024	2134	84349358000
130025	1874	32196000
130026	2133	90956558000
130027	1874	32198000
130028	1613	13537437400000
130029	2133	90955556000
130030	1874	32200000
130031	2132	147353366000
130032	1874	32201000
130033	2134	84348355000
130034	1874	32204000
130035	2134	84347352000
130036	1874	32207000
130037	2133	90954554000
130038	1874	32209000
130039	1613	14257437400000
130040	1613	14257442400000
130044	1397	1279664101000
130045	1678	27360855999000
130046	2133	90953552000
130047	1874	32211000
130048	2132	147352365000
130049	1874	32212000
130050	2134	84346349000
130051	1874	32215000
130052	1692	11260832619999
130068	1690	185045833000000
130079	1508	13880423156616
130080	1508	13880435156616
130081	1397	1279624097000
130082	1678	27360856003000
130083	2133	90949544000
130084	1874	32232000
130085	2132	147351364000
130086	1874	32233000
130087	2134	84342337000
130088	1874	32236000
130089	1394	878413848440200
130101	1716	2880056000000
130102	1716	2880068000000
130124	1397	1279584093000
130125	1678	27360856007000
130126	2134	84338325000
130127	1874	32255000
130128	2133	90945536000
130129	1874	32257000
130130	1565	1440040000000
130131	1565	1440052000000
130170	1688	15190713113020
130220	1397	1279474082000
130221	1678	27360856018000
130222	1397	1279464081000
130223	1678	27360856019000
130224	2133	90934514000
130225	1874	32312000
130226	2134	84327292000
130227	1874	32315000
130228	2133	90933512000
130229	1874	32317000
130230	2134	84326289000
130231	1874	32320000
130232	2132	147346359000
130233	1874	32321000
130234	2329	307446297819988
130242	1587	15840477000000
130243	1587	15840479000000
130245	1397	1279454080000
130246	1678	27360856020000
130247	1397	1279444079000
130248	1678	27360856021000
130249	1397	1279434078000
130250	1678	27360856022000
130251	2133	90931508000
130252	1874	32328000
130253	2132	147345358000
130254	1874	32329000
130255	2134	84324283000
130256	1874	32332000
130257	2134	84323280000
130258	1874	32335000
130259	2134	84322277000
130260	1874	32338000
130261	2133	90930506000
130262	1874	32340000
130263	2133	90929504000
130264	1874	32342000
130265	1394	882733886440200
130266	1394	882733923440200
130290	1397	1279394074000
130291	1678	27360856026000
130292	2134	84319268000
130293	1874	32358000
130294	2133	90925496000
130295	1874	32360000
130296	576	79037665726897
130297	576	79037677726897
130313	1397	1279364071000
130314	1678	27360856029000
130315	1397	1279354070000
130316	1678	27360856030000
130317	2134	84316259000
130318	1874	32374000
130319	2134	84315256000
130320	1874	32377000
130321	2133	90922490000
130322	1874	32379000
130323	2133	90921488000
130324	1874	32381000
130325	2329	307446296819988
130334	1685	179284515571430
130335	1685	179284527571430
130346	1587	16560479000000
130347	1587	16560492000000
130350	1397	1279324067000
130351	1678	27360856033000
130352	2134	84312247000
130353	1874	32395000
130354	2133	90918482000
130355	1874	32397000
130356	1596	7200267000002
130415	1397	1279304065000
130416	1678	27360856035000
130417	2133	90916478000
130418	1874	32404000
130419	2132	147341354000
130420	1874	32405000
130421	1673	9575447000000
130441	1613	14257405400000
130442	1613	14257417400000
130459	2329	308166321819988
130467	149	78335406000341
130468	149	78335419000341
130503	1397	1279204055000
130504	1678	27360856045000
130505	2132	147338351000
130506	1874	32456000
130507	2133	90906458000
130508	1874	32458000
130509	2134	84300211000
130510	1874	32461000
130511	1509	15503430503835
130527	1397	1279174052000
130528	1678	27360856048000
130529	1397	1279164051000
130530	1678	27360856049000
130531	2134	84297202000
130532	1874	32474000
130533	2132	147337350000
130534	1874	32475000
130535	2134	84296199000
130536	1874	32478000
130537	2133	90903452000
130538	1874	32480000
130539	1719	15838697000000
130540	2133	90902450000
130541	1874	32482000
130542	2252	200500000
130543	1719	16558696900000
130544	2252	201500000
130565	1679	8638187656999
130566	1679	8638211656999
130600	1397	1279094044000
130601	1678	27360856056000
130602	1397	1279084043000
130603	1678	27360856057000
130604	2134	84289178000
130605	1874	32517000
130606	2134	84288175000
130607	1874	32520000
130608	2112	23566944101924
130609	2112	23566966101924
130621	1397	1279074042000
130622	1678	27360856058000
130623	2134	84287172000
130624	1874	32527000
130625	2132	147334347000
130626	1874	32528000
130627	2133	90893432000
130628	1874	32530000
130629	1394	885613947440200
130630	1394	885613960440200
130643	1685	179284529571430
130673	1397	1279014036000
130674	1678	27360856064000
130675	2133	90886418000
130676	1874	32563000
130677	2132	147332345000
130678	1874	32564000
130679	2134	84280151000
130680	1874	32567000
130681	1693	9351052570272
130682	1693	9351065570272
130686	1397	1279004035000
130687	1678	27360856065000
130688	2133	90885416000
130689	1874	32569000
130690	1693	9351064570272
130705	1397	1278984033000
130706	1678	27360856067000
130707	2132	147331344000
130708	1874	32575000
130709	2134	84278145000
130710	1874	32578000
130711	2134	84277142000
130712	1874	32581000
130713	2133	90883412000
130714	1874	32583000
130715	2133	90882410000
130716	1874	32585000
130717	1684	26643420819412
130746	1594	15841891000000
130747	1397	1278964031000
130748	1678	27360856069000
130749	1397	1278954030000
130750	1678	27360856070000
130751	1397	1278944029000
130752	1678	27360856071000
130753	1397	1278934028000
130754	1678	27360856072000
130755	1397	1278924027000
130756	1678	27360856073000
130757	2132	147329342000
130758	1874	32607000
130759	1726	971472112000
130760	2357	100000000
130761	2132	147328341000
130762	1874	32608000
130763	2134	84272127000
130764	1874	32611000
130765	2134	84271124000
130766	1874	32614000
130767	2134	84270121000
130768	1874	32617000
130769	2134	84269118000
130770	1874	32620000
130771	1726	970371112000
130772	2358	100000000
130773	1726	969270112000
130774	2359	100000000
130775	1726	968169112000
130776	2360	100000000
130777	1726	967068112000
130778	2361	100000000
130779	2134	84268115000
130780	1874	32623000
130781	2133	90877400000
130782	1874	32625000
130783	2133	90876398000
130784	1874	32627000
130785	2133	90875396000
130786	1874	32629000
130787	2133	90874394000
130788	1874	32631000
130789	1440	6480317045924
130790	2133	90873392000
130791	1874	32633000
130792	1440	7200317045924
130793	1440	7200318045924
130797	1394	887054038440200
130798	1394	888494038440200
130799	1394	888494039440200
130840	1680	12973347499559
130841	1680	12973372499559
130886	1448	10759852000001
130887	1448	10759865000001
130923	1397	1278784013000
130924	1678	27360856087000
130925	1397	1278774012000
130926	1678	27360856088000
130927	2133	90858362000
130928	1874	32706000
130929	2133	90857360000
130930	1874	32708000
130931	2134	84254073000
130932	1874	32711000
130933	2134	84253070000
130934	1874	32714000
130935	576	79037689726897
130958	1678	26640831034000
130959	1678	26640831035000
130960	1678	26640831036000
130961	1678	26640831037000
130962	1678	26640831038000
130963	1678	26640831039000
130964	1678	26640831040000
130965	1678	26640831041000
130966	1678	26640831042000
130967	1678	26640831043000
130968	1678	26640831044000
130969	1678	26640831045000
130970	1678	26640831046000
130971	1678	26640831047000
130972	1678	26640831048000
130973	1678	26640831049000
130974	1678	26640831050000
130975	1678	26640831051000
130976	1678	26640831052000
130977	1678	26640831053000
130978	1678	26640831054000
130979	1678	26640831055000
130980	1678	26640831056000
130981	1678	26640831057000
130982	1678	26640831058000
130983	1678	26640831059000
130984	1678	26640831060000
130985	1678	26640831061000
130986	1678	26640831062000
130987	1678	26640831063000
130988	1678	26640831064000
130989	1678	26640831065000
130990	1678	26640831066000
130991	1678	26640831067000
130992	1678	26640831068000
130993	1678	26640831069000
130994	1678	26640831070000
130995	1678	26640831071000
130996	1678	26640831072000
130997	1678	26640831073000
130998	1678	26640831074000
130999	1678	26640831075000
131000	1678	26640831076000
131001	1678	26640831077000
131002	1678	26640831078000
131003	1678	26640831079000
131004	1678	26640831080000
131005	1678	26640831081000
131006	1678	26640831082000
131007	1678	26640831083000
131008	1678	26640831084000
131009	1678	26640831085000
131010	1678	26640831086000
131011	1678	26640831087000
131012	1678	26640831088000
131013	1678	26640831089000
131014	1678	26640831090000
130546	1426	14010428000000
130547	1426	14010429000000
130578	1397	1279124047000
130579	1678	27360856053000
130580	1397	1279114046000
130581	1678	27360856054000
130582	2133	90898442000
130583	1874	32500000
130584	2133	90897440000
130585	1874	32502000
130586	2134	84292187000
130587	1874	32505000
130588	2134	84291184000
130589	1874	32508000
130618	2112	23566968101924
130619	610	67440032000000
130620	610	67440056000000
130644	1397	1279054040000
130645	1678	27360856060000
130646	2134	84284163000
130647	1874	32543000
130648	2133	90890426000
130649	1874	32545000
130650	1394	887053960440200
130651	1394	887053972440200
130683	1874	32562000
130684	1874	32565000
130685	1634	15503107259504
130699	1394	888493972440200
130700	1394	888493984440200
130718	2133	90881408000
130719	1874	32587000
130720	2134	84276139000
130721	1874	32590000
130722	1649	11991570999968
130723	1649	11991572999968
130724	1397	1278974032000
130725	1678	27360856068000
130726	2132	147330343000
130727	1874	32591000
130728	2133	90880406000
130729	1874	32593000
130730	2133	90879404000
130731	1874	32595000
130732	2133	90878402000
130733	1874	32597000
130734	2134	84275136000
130735	1874	32600000
130736	2134	84274133000
130737	1874	32603000
130738	2134	84273130000
130739	1874	32606000
130740	2248	11519539000000
130743	1619	7200142000000
130744	1619	7200159000000
130816	1397	1278894024000
130817	1678	27360856076000
130818	2134	84265106000
130819	1874	32646000
130820	2133	90870386000
130821	1874	32648000
130822	1991	13581425355805
130823	1991	13581437355805
130853	1397	1278854020000
130854	1678	27360856080000
130855	2134	84261094000
130856	1874	32667000
130857	2132	147326339000
130858	1874	32668000
130859	2133	90866378000
130860	1874	32670000
130861	1394	891374051440200
130862	1394	891374064440200
130864	1397	1278844019000
130865	1678	27360856081000
130866	2134	84260091000
130867	1874	32673000
130868	2133	90865376000
130869	1874	32675000
130870	1679	9358211656999
130871	1679	9358223656999
130911	1747	4386046999992
130948	1706	17562258450256
130949	1706	17562271450256
131033	1397	1278744009000
131034	1678	27360856091000
131035	2134	84250061000
131036	1874	32728000
131037	2133	90854354000
131038	1874	32730000
131039	1691	11231132300052
131069	484	74013923000000
131088	1764	14483542100000
131121	2087	2595418147766
131122	2087	3315418147766
131123	2087	3315423147766
131163	1397	1278613996000
131164	1678	27360856104000
131165	2134	84237022000
131166	1874	32797000
131167	2133	90841328000
131168	1874	32799000
131169	1695	11465177999000
131178	1397	1278593994000
131179	1678	27360856106000
131180	1397	1278583993000
131181	1678	27360856107000
131182	2132	147318331000
131183	1874	32805000
131184	2134	84235016000
131185	1874	32808000
131186	2133	90839324000
131187	1874	32810000
131188	2134	84234013000
131189	1874	32813000
131190	2133	90838322000
131191	1874	32815000
131192	1395	58281751854957278
131220	1395	58282471854957278
131221	1395	58282471890957278
131222	1397	1278543989000
131223	1678	27360856111000
131224	1397	1278533988000
131225	1678	27360856112000
131226	2133	90835316000
131227	1874	32831000
131228	2133	90834314000
131229	1874	32833000
131230	2132	147316329000
131231	1874	32834000
131232	1726	965967112000
131233	2363	100000000
131234	2134	84230001000
131235	1874	32837000
131236	2134	84228998000
131237	1874	32840000
131238	1850	17256479949999
131239	1850	17256505949999
131242	1596	7920267000002
131243	1596	7920293000002
131252	1397	1278513986000
131253	1678	27360856114000
131254	1397	1278503985000
131255	1678	27360856115000
131256	1397	1278493984000
131257	1678	27360856116000
131258	2133	90832310000
131259	1874	32847000
131260	2134	84226992000
131261	1874	32850000
131262	2134	84225989000
131263	1874	32853000
131264	2134	84224986000
131265	1874	32856000
131266	2133	90831308000
131267	1874	32858000
131268	2133	90830306000
131269	1874	32860000
131270	2132	147315328000
131271	1874	32861000
131272	1850	17256516949999
131355	1397	1278393974000
131356	1678	27360856126000
131357	1397	1278383973000
131358	1678	27360856127000
131359	1397	1278373972000
131360	1678	27360856128000
131361	2283	199000000
131362	2133	90820286000
131363	1874	32910000
131364	2133	90819284000
131365	1874	32912000
131366	2134	84214956000
131367	1874	32915000
131368	2134	84213953000
131369	1874	32918000
131370	2134	84212950000
131371	1874	32921000
131372	2133	90818282000
131373	1874	32923000
131374	2132	147312325000
131375	1874	32924000
131376	1522	10123688000000
131377	1655	10123723000000
131378	1522	1000000
130562	2134	84294193000
130563	1874	32492000
130564	1394	884173947440200
130567	1688	16630701113020
130568	1688	16630725113020
130590	1397	1279104045000
130591	1678	27360856055000
130592	2134	84290181000
130593	1874	32511000
130594	2132	147335348000
130595	1874	32512000
130596	2133	90896438000
130597	1874	32514000
130598	1476	15120345000000
130599	1476	15120358000000
130631	1397	1279064041000
130632	1678	27360856059000
130633	2133	90892430000
130634	1874	32532000
130635	2133	90891428000
130636	1874	32534000
130637	2134	84286169000
130638	1874	32537000
130639	2134	84285166000
130640	1874	32540000
130641	1693	8631038570272
130642	1693	8631052570272
130652	1397	1279044039000
130653	1678	27360856061000
130654	1397	1279034038000
130655	1678	27360856062000
130656	1397	1279024037000
130657	1678	27360856063000
130658	2134	84283160000
130659	1874	32548000
130660	2134	84282157000
130661	1874	32551000
130662	2132	147333346000
130663	1874	32552000
130664	2134	84281154000
130665	1874	32555000
130666	2133	90889424000
130667	1874	32557000
130668	2133	90888422000
130669	1874	32559000
130670	2133	90887420000
130671	1874	32561000
130672	1656	15115557999990
130701	1395	58281751829957278
130702	1395	58281751841957278
130741	1394	888493989440200
130745	1716	2880073000000
130824	1397	1278884023000
130825	1678	27360856077000
130826	1397	1278874022000
130827	1678	27360856078000
130828	2134	84264103000
130829	1874	32651000
130830	2134	84263100000
130831	1874	32654000
130832	2133	90869384000
130833	1874	32656000
130834	2133	90868382000
130835	1874	32658000
130836	2132	147327340000
130837	1874	32659000
130838	1602	13536693170000
130839	1602	13536718170000
130863	1688	16630714113020
130872	2134	84259088000
130873	1874	32678000
130874	2133	90864374000
130875	1874	32680000
130876	1850	15816467949999
130890	1397	1278824017000
130891	1678	27360856083000
130892	1397	1278814016000
130893	1678	27360856084000
130894	1397	1278804015000
130895	1678	27360856085000
130896	2133	90862370000
130897	1874	32688000
130898	2133	90861368000
130899	1874	32690000
130900	2133	90860366000
130901	1874	32692000
130902	2134	84257082000
130903	1874	32695000
130904	2134	84256079000
130905	1874	32698000
130906	2134	84255076000
130907	1874	32701000
130908	1746	5568957999989
130909	1746	5568993999989
130912	2292	2879086000000
130913	1397	1278794014000
130914	1678	27360856086000
130915	1724	12652760500000
130916	2362	1000000000
130917	2132	147324337000
130918	1874	32702000
130919	2133	90859364000
130920	1874	32704000
130921	1681	16414762358535
130922	1681	16414780358535
130938	1694	17099063197225
130950	1397	1278754010000
130951	1678	27360856090000
130952	2133	90855356000
130953	1874	32722000
130954	2134	84251064000
130955	1874	32725000
130956	1394	892814087440200
130957	1394	892814099440200
131040	1619	7920159000000
131041	1619	7920171000000
131056	1397	1278724007000
131057	1678	27360856093000
131058	2133	90852350000
131059	1874	32738000
131060	2134	84248055000
131061	1874	32741000
131062	1623	79923337898598
131097	1650	9473032000000
131098	1650	9473044000000
131124	2086	2160387300069
131125	2086	2880387300069
131126	2086	2880392300069
131127	1397	1278654000000
131128	1678	27360856100000
131129	2133	90845336000
131130	1874	32775000
131131	2134	84241034000
131132	1874	32778000
131133	2329	308886333819988
131142	1397	1278633998000
131143	1678	27360856102000
131144	2134	84239028000
131145	1874	32786000
131146	2132	147319332000
131147	1874	32787000
131148	2133	90843332000
131149	1874	32789000
131150	2261	10079247000000
131151	2261	10079260000000
131170	1397	1278603995000
131171	1678	27360856105000
131172	2134	84236019000
131173	1874	32802000
131174	2133	90840326000
131175	1874	32804000
131176	1850	16536467949999
131177	1850	16536479949999
131240	1602	14976730170000
131241	1602	14976756170000
131244	1397	1278523987000
131245	1678	27360856113000
131246	2134	84227995000
131247	1874	32843000
131248	2133	90833312000
131249	1874	32845000
131250	1688	17350714113020
131251	1688	17350726113020
131273	2261	10799260000000
131274	2261	10799297000000
131285	1397	1278473982000
131286	1678	27360856118000
131287	2134	84222980000
131288	1874	32869000
131289	2133	90828302000
131290	1874	32871000
131291	2329	310326370819988
131292	2329	310326382819988
131314	1397	1278443979000
131315	1678	27360856121000
131316	2133	90825296000
131317	1874	32884000
131318	2134	84219971000
131319	1874	32887000
131320	1394	897134123440200
131321	1394	897134135440200
131381	1522	9404068000000
131382	1522	10124068000000
131383	1522	10124938000000
131385	1397	1278363971000
130574	1874	32495000
130575	2134	84293190000
130576	1874	32498000
130577	1710	13914071664140
130610	2133	90895436000
130611	1874	32516000
130612	1874	32519000
130613	1874	32522000
130614	2133	90894434000
130615	1874	32524000
130616	1718	9616596519070
130617	1718	9616620519070
130691	1397	1278994034000
130692	1678	27360856066000
130693	2134	84279148000
130694	1874	32572000
130695	2133	90884414000
130696	1874	32574000
130697	1560	16568843131803
130698	1560	16568855131803
130703	1690	185765834000000
130704	1690	185765846000000
130742	1395	58281751846957278
130794	2306	2159162000000
130795	2306	2879162000000
130796	2306	2879163000000
130800	1397	1278914026000
130801	1678	27360856074000
130802	2133	90872390000
130803	1874	32635000
130804	2134	84267112000
130805	1874	32638000
130806	1711	17707049000000
130807	1711	17707061000000
130808	1397	1278904025000
130809	1678	27360856075000
130810	2134	84266109000
130811	1874	32641000
130812	2133	90871388000
130813	1874	32643000
130814	1394	889934039440200
130815	1394	889934051440200
130842	2329	308886321819988
130843	2329	308886346819988
130844	1397	1278864021000
130845	1678	27360856079000
130846	1724	12653766500000
130847	2362	0
130848	2134	84262097000
130849	1874	32662000
130850	2133	90867380000
130851	1874	32664000
130852	1680	12973365499559
130877	1397	1278834018000
130878	1678	27360856082000
130879	2134	84258085000
130880	1874	32683000
130881	2133	90863372000
130882	1874	32685000
130883	2132	147325338000
130884	1874	32686000
130885	2106	2880163000000
130888	58	76067492999641
130889	58	76067505999641
130910	1394	891374087440200
130936	1694	17099059197225
130937	1694	17099083197225
130939	1397	1278764011000
130940	1678	27360856089000
130941	2132	147323336000
130942	1874	32715000
130943	2134	84252067000
130944	1874	32718000
130945	2133	90856358000
130946	1874	32720000
130947	1709	10080245000000
131042	1394	894254099440200
131043	1394	894254111440200
131054	1634	16223107259504
131055	1634	16223120259504
131063	1397	1278714006000
131064	1678	27360856094000
131065	2134	84247052000
131066	1874	32744000
131067	2133	90851348000
131068	1874	32746000
131087	2329	308886347819988
131089	1397	1278684003000
131090	1678	27360856097000
131091	2133	90848342000
131092	1874	32759000
131093	2134	84244043000
131094	1874	32762000
131095	1394	895694111440200
131096	1394	895694123440200
131117	1668	12753772000000
131134	1397	1278643999000
131135	1678	27360856101000
131136	2134	84240031000
131137	1874	32781000
131138	2133	90844334000
131139	1874	32783000
131140	1602	14256718170000
131141	1602	14256730170000
131154	1395	58281751842957278
131201	1397	1278573992000
131202	1678	27360856108000
131203	1397	1278563991000
131204	1678	27360856109000
131205	1397	1278553990000
131206	1678	27360856110000
131207	2133	90837320000
131208	1874	32817000
131209	2132	147317330000
131210	1874	32818000
131211	2133	90836318000
131212	1874	32820000
131213	2134	84233010000
131214	1874	32823000
131215	2134	84232007000
131216	1874	32826000
131217	2134	84231004000
131218	1874	32829000
131219	58	76067528999641
131275	2329	309606333819988
131276	2329	309606370819988
131277	1397	1278483983000
131278	1678	27360856117000
131279	2134	84223983000
131280	1874	32864000
131281	2133	90829304000
131282	1874	32866000
131283	1726	964866112000
131284	2364	100000000
131303	606	76846878286230
131312	1724	13372760500000
131313	1724	13372772500000
131324	42	74300687000000
131341	1397	1278413976000
131342	1678	27360856124000
131343	1397	1278403975000
131344	1678	27360856125000
131345	2134	84216962000
131346	1874	32901000
131347	2134	84215959000
131348	1874	32904000
131349	2133	90822290000
131350	1874	32906000
131351	2133	90821288000
131352	1874	32908000
131353	1593	14352789000000
131354	1593	15072789000000
131384	1522	10123726000000
131437	1397	1278333968000
131438	1678	27360856132000
131439	1397	1278323967000
131440	1678	27360856133000
131441	2134	84208938000
131442	1874	32943000
131443	2134	84207935000
131444	1874	32946000
131445	2133	90814274000
131446	1874	32948000
131447	2133	90813272000
131448	1874	32950000
131449	2132	147310323000
131450	1874	32951000
131451	1619	7920184000000
131479	1397	1278283963000
131480	1678	27360856137000
131481	2133	90809264000
131482	1874	32969000
131483	2134	84203923000
131484	1874	32972000
131485	2329	311766394819988
131486	2329	311766406819988
131489	1397	1278273962000
131490	1678	27360856138000
131491	2134	84202920000
131492	1874	32975000
131493	2133	90808262000
131494	1874	32977000
131495	1633	8688646125277
131505	1397	1278253960000
131506	1678	27360856140000
131015	1874	32063000
131016	1874	32096000
131017	1874	32108000
131018	1874	32132000
131019	1874	32144000
131020	1874	32162000
131021	1402	45545131145435
131022	1874	32168000
131023	1874	32186000
131024	1874	32192000
131025	1874	32195000
131026	1874	32210000
131027	1874	32213000
131028	1874	32216000
131029	1874	32219000
131030	1874	32222000
131031	1402	46265131145435
131032	1402	46265150145435
131044	1397	1278734008000
131045	1678	27360856092000
131046	2133	90853352000
131047	1874	32732000
131048	2132	147322335000
131049	1874	32733000
131050	2134	84249058000
131051	1874	32736000
131052	1710	14634071664140
131053	1710	14634084664140
131070	1397	1278704005000
131071	1678	27360856095000
131072	1397	1278694004000
131073	1678	27360856096000
131074	2134	84246049000
131075	1874	32747000
131076	1874	32749000
131077	2134	84245046000
131078	1874	32752000
131079	2133	90850346000
131080	1874	32754000
131081	2133	90849344000
131082	1874	32756000
131083	2132	147321334000
131084	1874	32757000
131085	2261	9359221000000
131086	2261	9359247000000
131099	1397	1278674002000
131100	1678	27360856098000
131101	1397	1278664001000
131102	1678	27360856099000
131103	1668	12033767000000
131104	2133	90847340000
131105	1874	32764000
131106	2133	90846338000
131107	1874	32766000
131108	2134	84243040000
131109	1874	32769000
131110	2134	84242037000
131111	1874	32772000
131112	2132	147320333000
131113	1874	32773000
131114	1668	12753767000000
131115	1668	202100000
131116	2252	12753770300000
131118	1699	2880362750126
131119	1699	3600362750126
131120	1699	3600367750126
131152	1679	10078223656999
131153	1679	10078236656999
131155	1397	1278623997000
131156	1678	27360856103000
131157	2134	84238025000
131158	1874	32792000
131159	2133	90842330000
131160	1874	32794000
131161	1680	13693365499559
131162	1680	13693377499559
131193	1678	26640831091000
131194	1678	26640831092000
131195	1678	26640831093000
131196	1678	26640831094000
131197	1678	26640831095000
131198	1678	26640831096000
131199	1402	46985150145435
131200	1402	46985210145435
131293	1397	1278463981000
131294	1678	27360856119000
131295	2133	90827300000
131296	1874	32873000
131297	2132	147314327000
131298	1874	32874000
131299	2134	84221977000
131300	1874	32877000
131301	576	79757689726897
131302	576	79757702726897
131304	1397	1278453980000
131305	1678	27360856120000
131306	2134	84220974000
131307	1874	32880000
131308	2133	90826298000
131309	1874	32882000
131310	2329	311046382819988
131311	2329	311046394819988
131322	1679	10798236656999
131323	1679	10798248656999
131325	1397	1278433978000
131326	1678	27360856122000
131327	1397	1278423977000
131328	1678	27360856123000
131329	2133	90824294000
131330	1874	32889000
131331	2134	84218968000
131332	1874	32892000
131333	2134	84217965000
131334	1874	32895000
131335	2132	147313326000
131336	1874	32896000
131337	2133	90823292000
131338	1874	32898000
131339	1688	18070726113020
131340	1688	18070751113020
131401	1476	15120938000000
131402	1874	32566000
131403	1874	32568000
131404	1874	32570000
131405	1874	32573000
131406	1874	32576000
131407	1874	32579000
131408	1874	32582000
131409	1874	32589000
131410	1874	32599000
131411	1874	32601000
131412	1874	32605000
131413	1874	32610000
131414	1874	32612000
131415	1874	32616000
131416	1874	32618000
131417	1874	32619000
131418	1874	32621000
131419	1874	32622000
131420	1874	32624000
131421	1874	32626000
131422	1874	32628000
131423	1874	32630000
131424	1874	32634000
131425	1874	32637000
131426	1874	32640000
131427	1874	32649000
131428	1476	15840938000000
131429	1476	15841096000000
131477	1434	2879131000000
131478	1434	2879144000000
131557	1395	58282471879957278
131558	1601	7585946620000
131607	1397	1278133948000
131608	1678	27360856152000
131609	2134	84189881000
131610	1874	33046000
131611	2133	90794234000
131612	1874	33048000
131613	1688	19510765113020
131614	1688	19510777113020
131625	1874	33051000
131626	1874	33052000
131629	1560	16568856131803
131640	1397	1278103945000
131641	1678	27360856155000
131642	1397	1278093944000
131643	1678	27360856156000
131644	2133	90791228000
131645	1874	33061000
131646	2132	147303316000
131647	1874	33062000
131648	2134	84186872000
131649	1874	33065000
131650	2134	84185869000
131651	1874	33068000
131652	2133	90790226000
131653	1874	33070000
131654	58	76787528999641
131655	58	76787553999641
131658	1397	1278083943000
131659	1678	27360856157000
131660	2133	90789224000
131661	1874	33072000
131662	2134	84184866000
131379	2359	101000000
131380	2336	101000000
131430	1397	1278343969000
131431	1678	27360856131000
131432	2134	84209941000
131433	1874	32938000
131434	2133	90815276000
131435	1874	32940000
131436	2261	10799272000000
131452	1397	1278313966000
131453	1678	27360856134000
131454	1397	1278303965000
131455	1678	27360856135000
131456	2134	84206932000
131457	1874	32954000
131458	2133	90812270000
131459	1874	32956000
131460	2134	84205929000
131461	1874	32959000
131462	2133	90811268000
131463	1874	32961000
131464	1394	897134147440200
131467	1397	1278293964000
131468	1678	27360856136000
131469	2133	90810266000
131470	1874	32963000
131471	2132	147309322000
131472	1874	32964000
131473	2134	84204926000
131474	1874	32967000
131475	1593	15792789000000
131476	1593	15792802000000
131496	1397	1278263961000
131497	1678	27360856139000
131498	2132	147308321000
131499	1874	32978000
131500	2133	90807260000
131501	1874	32980000
131502	2134	84201917000
131503	1874	32983000
131504	1394	897134136440200
131523	1397	1278223957000
131524	1678	27360856143000
131525	2134	84198908000
131526	1874	32998000
131527	2133	90803252000
131528	1874	33000000
131529	2132	147307320000
131530	1874	33001000
131531	1623	80643337898598
131532	1623	80643350898598
131567	2039	16459647000000
131568	2039	16459659000000
131582	1688	18790751113020
131583	1688	18790765113020
131593	1397	1278153950000
131594	1678	27360856150000
131595	1397	1278143949000
131596	1678	27360856151000
131597	2134	84191887000
131598	1874	33036000
131599	2133	90796238000
131600	1874	33038000
131601	2133	90795236000
131602	1874	33040000
131603	2134	84190884000
131604	1874	33043000
131605	1395	58283191867957278
131606	1395	58283191891957278
131615	1397	1278123947000
131616	1678	27360856153000
131617	2133	90793232000
131618	1874	33050000
131619	2134	84188878000
131620	1874	33053000
131621	2132	147304317000
131622	1874	33054000
131623	1546	11757469800000
131624	1546	11757482800000
131627	64	69600056000000
131628	64	69600069000000
131673	1679	8638212656999
131737	1874	33113000
131738	1874	33117000
131739	1422	13914754804270
131812	1394	902894195440200
131813	1394	902894269440200
131828	641	79683945000000
131903	1394	904334207440200
131904	1394	904334219440200
131926	640	67440007000000
131927	640	67440019000000
131930	1397	1277773912000
131931	1678	27360856188000
131932	1397	1277763911000
131933	1678	27360856189000
131934	1397	1277753910000
131935	1678	27360856190000
131936	2132	147293306000
131937	1874	33232000
131938	2133	90758162000
131939	1874	33234000
131940	2133	90757160000
131941	1874	33236000
131942	2133	90756158000
131943	1874	33238000
131944	2134	84154776000
131945	1874	33241000
131946	2134	84153773000
131947	1874	33244000
131948	2134	84152770000
131949	1874	33247000
131950	2039	16459684000000
131969	1397	1277723907000
131970	1678	27360856193000
131971	2132	147292305000
131972	1874	33255000
131973	2134	84150764000
131974	1874	33258000
131975	2133	90753152000
131976	1874	33260000
131977	1650	9473045000000
132039	1397	1277643899000
132040	1678	27360856201000
132041	2134	84142740000
132042	1874	33300000
132043	2133	90745136000
132044	1874	33302000
132103	1397	1277563891000
132104	1678	27360856209000
132105	1395	58285352001957278
132106	2134	84134716000
132107	1874	33342000
132108	2132	147287300000
132109	1874	33343000
132110	2133	90737120000
132111	1874	33345000
132112	1395	58286072001957278
132113	1395	58286072004957278
132117	134	66000090000000
132118	2134	84133713000
132119	1874	33348000
132120	2133	90736118000
132121	1874	33350000
132122	1670	10801074000000
132126	1397	1277543889000
132127	1678	27360856211000
132128	2134	84132710000
132129	1874	33353000
132130	2133	90735116000
132131	1874	33355000
132132	1678	28080856211000
132133	1678	28080878211000
132158	1654	17417546999798
132159	1397	1277513886000
132160	1678	27360856214000
132161	2133	90732110000
132162	1874	33368000
132163	1394	908654244440200
132164	1394	908654255440200
132182	1394	910094255440200
132183	1394	910094268440200
132217	1397	1277443879000
132218	1678	27360856221000
132219	2133	90725096000
132220	1874	33402000
132221	2134	84123683000
132222	1874	33405000
132223	1547	10794828000000
132258	1394	911534268440200
132259	1394	911534280440200
132304	1397	1277333868000
132305	1678	27360856232000
132306	1397	1277323867000
132307	1678	27360856233000
132308	2134	84113653000
132309	1874	33458000
132310	2133	90714074000
132311	1874	33460000
132312	2134	84112650000
132313	1874	33463000
132314	2133	90713072000
132315	1874	33465000
132316	2132	147280293000
132317	1874	33466000
131386	1678	27360856129000
131387	1397	1278353970000
131388	1678	27360856130000
131389	2133	90817280000
131390	1874	32926000
131391	2132	147311324000
131392	1874	32927000
131393	2134	84211947000
131394	1874	32930000
131395	2134	84210944000
131396	1874	32933000
131397	2133	90816278000
131398	1874	32935000
131399	1476	15840358000000
131400	1476	15840383000000
131465	1474	12870583000043
131466	1474	12870607000043
131487	1474	13590607000043
131488	1474	13590619000043
131533	1397	1278213956000
131534	1678	27360856144000
131535	2134	84197905000
131536	1874	33004000
131537	2133	90802250000
131538	1874	33006000
131539	1394	900014171440200
131540	1394	900014183440200
131559	1397	1278183953000
131560	1678	27360856147000
131561	2134	84194896000
131562	1874	33020000
131563	2133	90799244000
131564	1874	33022000
131565	1668	12753747000000
131566	1668	12753759000000
131584	1397	1278163951000
131585	1678	27360856149000
131586	2133	90797240000
131587	1874	33029000
131588	2132	147305318000
131589	1874	33030000
131590	2134	84192890000
131591	1874	33033000
131592	1395	58282471867957278
131639	2329	311766419819988
131656	1654	17417497999798
131657	1654	17417525999798
131683	1679	9358233656999
131685	1397	1278053940000
131686	1678	27360856160000
131687	1397	1278043939000
131688	1678	27360856161000
131689	2134	84181857000
131690	1874	33089000
131691	2133	90786218000
131692	1874	33091000
131693	2133	90785216000
131694	1874	33093000
131695	2134	84180854000
131696	1874	33096000
131697	1613	14977417400000
131698	1613	14977441400000
131700	1397	1278033938000
131701	1678	27360856162000
131702	2134	84179851000
131703	1874	33099000
131704	2133	90784214000
131705	1874	33101000
131740	1649	12711572999968
131741	1649	12711609999968
131742	1643	4748719914700
131814	1397	1277883923000
131815	1678	27360856177000
131816	1397	1277873922000
131817	1678	27360856178000
131818	2133	90769184000
131819	1874	33175000
131820	2133	90768182000
131821	1874	33177000
131822	2134	84165809000
131823	1874	33180000
131824	2134	84164806000
131825	1874	33183000
131826	1602	14976754170000
131832	641	79685389000000
131833	641	80405389000000
131834	641	80406079000000
131845	1397	1277853920000
131846	1678	27360856180000
131847	2134	84162800000
131848	1874	33192000
131849	2133	90766178000
131850	1874	33194000
131851	1394	902894207440200
131852	1397	1277843919000
131853	1678	27360856181000
131854	1397	1277833918000
131855	1678	27360856182000
131856	1397	1277823917000
131857	1678	27360856183000
131858	2133	90765176000
131859	1874	33196000
131860	1395	58283191922957278
131861	2134	84161797000
131862	1874	33199000
131863	1726	961563112000
131864	2367	100000000
131865	1726	960462112000
131866	2368	100000000
131867	2133	90764174000
131868	1874	33201000
131869	2133	90763172000
131870	1874	33203000
131871	2134	84160794000
131872	1874	33206000
131873	2134	84159791000
131874	1874	33209000
131875	2132	147295308000
131876	1874	33210000
131877	1395	58283911922957278
131878	1395	58283911930957278
131881	1397	1277813916000
131882	1678	27360856184000
131883	2133	90762170000
131884	1874	33212000
131885	2134	84158788000
131886	1874	33215000
131887	1419	24766179559748
131888	1419	24766191559748
131891	1397	1277803915000
131892	1678	27360856185000
131893	2133	90761168000
131894	1874	33217000
131895	2134	84157785000
131896	1874	33220000
131897	2112	24286980101924
131898	1874	32046000
131899	1874	32048000
131900	1874	32054000
131901	1874	32058000
131902	497	67440052000000
131928	1394	905774219440200
131929	1394	905774231440200
131959	1458	21545455908540
131960	1458	21545467908540
131961	1397	1277733908000
131962	1678	27360856192000
131963	2133	90754154000
131964	1874	33254000
131965	1673	10295447000000
131966	1673	10295458000000
131997	1397	1277693904000
131998	1678	27360856196000
131999	2134	84147755000
132000	1874	33273000
132001	2133	90750146000
132002	1874	33275000
132003	2132	147291304000
132004	1874	33276000
132005	1684	27363420819412
132006	1684	27363433819412
132055	1394	907214231440200
132056	1394	907214243440200
132057	1397	1277623897000
132058	1678	27360856203000
132059	1397	1277613896000
132060	1678	27360856204000
132061	2132	147289302000
132062	1874	33308000
132063	2133	90743132000
132064	1874	33310000
132065	2133	90742130000
132066	1874	33312000
132067	2134	84140734000
132068	1874	33315000
132069	2134	84139731000
132070	1874	33318000
132071	1522	10843726000000
132072	1522	10843751000000
132114	1394	905774241440200
132115	1394	907214241440200
132116	1394	907214244440200
132123	1397	1277553890000
132124	1678	27360856210000
132125	1670	10801084000000
131507	1397	1278243959000
131508	1678	27360856141000
131509	1397	1278233958000
131510	1678	27360856142000
131511	2133	90806258000
131512	1874	32985000
131513	2133	90805256000
131514	1874	32987000
131515	2133	90804254000
131516	1874	32989000
131517	2134	84200914000
131518	1874	32992000
131519	2134	84199911000
131520	1874	32995000
131521	1394	898574136440200
131522	1394	898574171440200
131541	1397	1278203955000
131542	1678	27360856145000
131543	1397	1278193954000
131544	1678	27360856146000
131545	2134	84196902000
131546	1874	33009000
131547	2132	147306319000
131548	1874	33010000
131549	2133	90801248000
131550	1874	33012000
131551	2133	90800246000
131552	1874	33014000
131553	2134	84195899000
131554	1874	33017000
131555	2112	24286968101924
131556	2112	24286993101924
131569	1394	901454183440200
131570	1394	901454195440200
131571	1397	1278173952000
131572	1678	27360856148000
131573	1726	963765112000
131574	2365	100000000
131575	2133	90798242000
131576	1874	33024000
131577	1726	962664112000
131578	2366	100000000
131579	2134	84193893000
131580	1874	33027000
131581	1394	901454197440200
131630	1397	1278113946000
131631	1678	27360856154000
131632	2134	84187875000
131633	1874	33056000
131634	2133	90792230000
131635	1874	33058000
131636	1874	33059000
131637	1395	58283911891957278
131638	1395	58283911916957278
131684	1679	10078228656999
131715	1397	1278013936000
131716	1678	27360856164000
131717	1397	1278003935000
131718	1678	27360856165000
131719	1397	1277993934000
131720	1678	27360856166000
131721	2134	84177845000
131722	1874	33110000
131723	2133	90782210000
131724	1874	33112000
131725	2133	90781208000
131726	1874	33114000
131727	2133	90780206000
131728	1874	33116000
131729	2134	84176842000
131730	1874	33119000
131731	2134	84175839000
131732	1874	33122000
131733	2132	147300313000
131734	1874	33123000
131735	1422	13914720804270
131736	1422	13914757804270
131757	1397	1277963931000
131758	1678	27360856169000
131759	1397	1277953930000
131760	1678	27360856170000
131761	2132	147299312000
131762	1874	33134000
131763	2133	90777200000
131764	1874	33136000
131765	2133	90776198000
131766	1874	33138000
131767	2134	84172830000
131768	1874	33141000
131769	484	74733923000000
131770	484	74733947000000
131827	1666	1440035000000
131829	641	79685205000000
131830	641	80405205000000
131831	641	80405605000000
131835	1397	1277863921000
131836	1678	27360856179000
131837	2134	84163803000
131838	1874	33186000
131839	2132	147296309000
131840	1874	33187000
131841	2133	90767180000
131842	1874	33189000
131843	526	75360302000000
131844	526	75360315000000
131879	1874	33195000
131880	1692	11260822619999
131915	1506	7920228967172
131918	1397	1277783913000
131919	1678	27360856187000
131920	2133	90759164000
131921	1874	33228000
131922	2134	84155779000
131923	1874	33231000
131924	1395	58284631930957278
131925	1395	58284631942957278
131958	2292	2879062000000
131967	1764	15203528100000
131968	1764	15203539100000
131986	1992	13681080990000
131987	1992	13681092990000
131995	1599	14696997097983
131996	1599	14697009097983
132017	1397	1277673902000
132018	1678	27360856198000
132019	1397	1277663901000
132020	1678	27360856199000
132021	1397	1277653900000
132022	1678	27360856200000
132023	2132	147290303000
132024	1874	33282000
132025	2133	90748142000
132026	1874	33284000
132027	2133	90747140000
132028	1874	33286000
132029	2134	84145749000
132030	1874	33289000
132031	2134	84144746000
132032	1874	33292000
132033	2134	84143743000
132034	1874	33295000
132035	2133	90746138000
132036	1874	33297000
132037	1546	12477481800000
132038	1546	12477518800000
132053	1991	14301437355805
132054	1991	14301449355805
132075	1397	1277603895000
132076	1678	27360856205000
132077	1397	1277593894000
132078	1678	27360856206000
132079	1397	1277583893000
132080	1678	27360856207000
132081	1397	1277573892000
132082	1678	27360856208000
132083	2132	147288301000
132084	1874	33319000
132085	2134	84138728000
132086	1874	33322000
132087	2134	84137725000
132088	1874	33325000
132089	2134	84136722000
132090	1874	33328000
132091	2134	84135719000
132092	1874	33331000
132093	2133	90741128000
132094	1874	33333000
132095	2133	90740126000
132096	1874	33335000
132097	2133	90739124000
132098	1874	33337000
132099	2133	90738122000
132100	1874	33339000
132101	1395	58285351942957278
132102	1395	58285351991957278
132135	407	66720690000000
132143	1693	7190916570272
132144	1654	18137525999798
132145	1654	18137537999798
132157	2306	2879109000000
132173	1397	1277493884000
132174	1678	27360856216000
132175	2132	147285298000
132176	1874	33374000
132177	2133	90730106000
131663	1874	33075000
131664	1654	17417533999798
131665	1654	17417545999798
131666	1397	1278073942000
131667	1678	27360856158000
131668	2133	90788222000
131669	1874	33077000
131670	2134	84183863000
131671	1874	33080000
131672	1506	7920217967172
131674	1397	1278063941000
131675	1678	27360856159000
131676	2132	147302315000
131677	1874	33081000
131678	2133	90787220000
131679	1874	33083000
131680	2134	84182860000
131681	1874	33086000
131682	1419	24046179559748
131699	1679	11518248656999
131706	1397	1278023937000
131707	1678	27360856163000
131708	2133	90783212000
131709	1874	33103000
131710	2134	84178848000
131711	1874	33106000
131712	2132	147301314000
131713	1874	33107000
131714	1759	9577282139889
131743	1397	1277983933000
131744	1678	27360856167000
131745	1397	1277973932000
131746	1678	27360856168000
131747	2134	84174836000
131748	1874	33126000
131749	2133	90779204000
131750	1874	33128000
131751	2133	90778202000
131752	1874	33130000
131753	2134	84173833000
131754	1874	33133000
131755	1675	19004437999977
131756	1675	19004461999977
131771	1397	1277943929000
131772	1678	27360856171000
131773	1397	1277933928000
131774	1678	27360856172000
131775	1397	1277923927000
131776	1678	27360856173000
131777	1397	1277913926000
131778	1678	27360856174000
131779	1397	1277903925000
131780	1678	27360856175000
131781	1397	1277893924000
131782	1678	27360856176000
131783	2133	90775196000
131784	1874	33143000
131785	2132	147298311000
131786	1874	33144000
131787	2132	147297310000
131788	1874	33145000
131789	2133	90774194000
131790	1874	33147000
131791	2133	90773192000
131792	1874	33149000
131793	2133	90772190000
131794	1874	33151000
131795	2133	90771188000
131796	1874	33153000
131797	2133	90770186000
131798	1874	33155000
131799	2134	84171827000
131800	1874	33158000
131801	2134	84170824000
131802	1874	33161000
131803	2134	84169821000
131804	1874	33164000
131805	2134	84168818000
131806	1874	33167000
131807	2134	84167815000
131808	1874	33170000
131809	2134	84166812000
131810	1874	33173000
131811	2261	10799334000000
131889	1601	8305946620000
131890	1601	8305958620000
131905	1397	1277793914000
131906	1678	27360856186000
131907	2133	90760166000
131908	1874	33222000
131909	2132	147294307000
131910	1874	33223000
131911	2134	84156782000
131912	1874	33226000
131913	1672	12241459000000
131914	1672	12241472000000
131916	2307	3599072000000
131917	2307	3599085000000
131951	1397	1277743909000
131952	1678	27360856191000
131953	2134	84151767000
131954	1874	33250000
131955	2133	90755156000
131956	1874	33252000
131957	1746	5568969999989
131978	1397	1277713906000
131979	1678	27360856194000
131980	2133	90752150000
131981	1874	33262000
131982	2134	84149761000
131983	1874	33265000
131984	1688	20230777113020
131985	1688	20230789113020
131988	1397	1277703905000
131989	1678	27360856195000
131990	2133	90751148000
131991	1874	33267000
131992	2134	84148758000
131993	1874	33270000
131994	1546	11757481800000
132007	1693	9350954570272
132008	134	66000100000000
132009	1397	1277683903000
132010	1678	27360856197000
132011	2133	90749144000
132012	1874	33278000
132013	2134	84146752000
132014	1874	33281000
132015	2329	312486419819988
132016	2329	312486441819988
132045	1397	1277633898000
132046	1678	27360856202000
132047	2133	90744134000
132048	1874	33304000
132049	2134	84141737000
132050	1874	33307000
132051	1668	13473759000000
132052	1668	13473771000000
132073	2329	313206441819988
132074	2329	313206466819988
132155	1440	7200251045924
132156	1440	7200264045924
132165	1397	1277503885000
132166	1678	27360856215000
132167	2133	90731108000
132168	1874	33370000
132169	2134	84129701000
132170	1874	33373000
132171	1992	14401092990000
132172	1992	14401104990000
132184	1397	1277483883000
132185	1678	27360856217000
132186	2134	84127695000
132187	1874	33382000
132188	2133	90729104000
132189	1874	33384000
132190	633	78669506900000
132191	633	78669518900000
132194	1692	11260830619999
132224	1397	1277433878000
132225	1678	27360856222000
132226	2133	90724094000
132227	1874	33407000
132228	2134	84122680000
132229	1874	33410000
132230	1467	6640304272869
132231	1467	6640316272869
132232	1397	1277423877000
132233	1678	27360856223000
132234	2134	84121677000
132235	1874	33413000
132236	2132	147283296000
132237	1874	33414000
132238	2133	90723092000
132239	1874	33416000
132240	1688	20950789113020
132241	1688	20950802113020
132260	1397	1277393874000
132261	1678	27360856226000
132262	2133	90720086000
132263	1874	33428000
132264	2134	84118668000
132265	1874	33431000
132266	2132	147282295000
132267	1874	33432000
132134	407	66720022000000
132136	1397	1277533888000
132137	1678	27360856212000
132138	2133	90734114000
132139	1874	33357000
132140	2134	84131707000
132141	1874	33360000
132142	1679	11518260656999
132146	1397	1277523887000
132147	1678	27360856213000
132148	2132	147286299000
132149	1874	33361000
132150	2134	84130704000
132151	1874	33364000
132152	2133	90733112000
132153	1874	33366000
132154	1688	20230790113020
132243	1397	1277413876000
132244	1678	27360856224000
132245	2133	90722090000
132246	1874	33418000
132247	2134	84120674000
132248	1874	33421000
132249	1650	10193045000000
132250	1650	10193057000000
132328	1397	1277303865000
132329	1678	27360856235000
132330	2134	84110644000
132331	1874	33474000
132332	2133	90711068000
132333	1874	33476000
132334	1980	24479613000000
132335	1980	25199613000000
132515	1705	25041016580140
132516	1759	10297282139889
132517	1759	10297294139889
132547	1874	33377000
132548	1874	33383000
132549	1874	33385000
132550	1874	33391000
132551	1874	33393000
132552	1874	33394000
132553	1874	33399000
132554	1874	33408000
132555	1874	33411000
132556	1874	33417000
132557	1874	33420000
132558	1874	33423000
132559	1874	33429000
132560	1874	33435000
132561	1874	33438000
132562	1874	33456000
132563	1874	33459000
132564	1874	33462000
132565	1874	33477000
132566	1874	33480000
132567	1874	33486000
132568	1874	33489000
132569	1874	33495000
132570	1874	33498000
132571	1874	33501000
132572	1874	33507000
132573	1874	33519000
132574	1874	33522000
132575	1874	33525000
132576	1874	33528000
132577	1874	33537000
132578	1874	33543000
132579	1874	33546000
132580	1874	33549000
132581	1874	33552000
132582	1874	33555000
132583	1874	33558000
132584	1690	187206466000000
132585	1690	187206677000000
132614	1684	28803458819412
132615	1684	28803470819412
132627	1519	5039091000000
132628	1519	5039104000000
132629	1397	1277083843000
132630	1678	27360856257000
132631	2134	84088578000
132632	1874	33591000
132633	2133	90689024000
132634	1874	33593000
132635	1402	45543384145435
132636	1402	45543396145435
132656	1678	28080856259000
132657	1678	28080869259000
132733	1709	10080279000000
132770	1397	1276913826000
132771	1678	27360856274000
132772	1397	1276903825000
132773	1678	27360856275000
132774	2133	90672992000
132775	1874	33675000
132776	2134	84071527000
132777	1874	33678000
132778	2134	84070524000
132779	1874	33681000
132780	2133	90671990000
132781	1874	33683000
132782	1447	19721899683000
132793	1448	11479865000001
132794	1448	11479877000001
132813	1508	14600435156616
132814	1508	14600447156616
132819	1397	1276853820000
132820	1678	27360856280000
132821	2133	90666980000
132822	1874	33702000
132823	2134	84066512000
132824	1874	33705000
132825	1680	14413377499559
132826	1680	14413389499559
132842	1397	1276823817000
132843	1678	27360856283000
132844	1397	1276813816000
132845	1678	27360856284000
132846	2133	90663974000
132847	1874	33717000
132848	2134	84063503000
132849	1874	33720000
132850	2134	84062500000
132851	1874	33723000
132852	2133	90662972000
132853	1874	33725000
132854	1394	920174414440200
132877	1397	1276803815000
132878	1678	27360856285000
132879	2134	84061497000
132880	1874	33728000
132881	2133	90661970000
132882	1874	33730000
132883	1587	16560491000000
132884	1394	921614414440200
132885	1394	921614426440200
132904	1397	1276773812000
132905	1678	27360856288000
132906	2134	84058488000
132907	1874	33743000
132908	2133	90658964000
132909	1874	33745000
132912	1397	1276763811000
132913	1678	27360856289000
132914	2134	84057485000
132915	1874	33748000
132916	2133	90657962000
132917	1874	33750000
132918	1397	1276753810000
132919	1678	27360856290000
132920	1397	1276743809000
132921	1678	27360856291000
132922	1397	1276733808000
132923	1678	27360856292000
132924	2133	90656960000
132925	1874	33752000
132926	2133	90655958000
132927	1874	33754000
132928	2133	90654956000
132929	1874	33756000
132930	2134	84056482000
132931	1874	33759000
132932	2134	84055479000
132933	1874	33762000
132934	1458	21545502908540
132935	2134	84054476000
132936	1874	33765000
132937	1458	22265502908540
132938	1458	22265503908540
132967	1397	1276693804000
132968	1678	27360856296000
132969	2133	90650948000
132970	1874	33782000
132971	2134	84050464000
132972	1874	33785000
132973	1688	22390838113019
132990	1397	1276663801000
132991	1678	27360856299000
132992	1397	1276653800000
132993	1678	27360856300000
132994	1397	1276643799000
132995	1678	27360856301000
132996	2134	84047455000
132997	1874	33798000
132178	1874	33376000
132179	2134	84128698000
132180	1874	33379000
132181	2329	313206454819988
132192	1723	12962107085979
132193	1723	12962119085979
132195	1397	1277473882000
132196	1678	27360856218000
132197	1397	1277463881000
132198	1678	27360856219000
132199	1397	1277453880000
132200	1678	27360856220000
132201	2133	90728102000
132202	1874	33386000
132203	2134	84126692000
132204	1874	33389000
132205	2134	84125689000
132206	1874	33392000
132207	2134	84124686000
132208	1874	33395000
132209	2132	147284297000
132210	1874	33396000
132211	2133	90727100000
132212	1874	33398000
132213	2133	90726098000
132214	1874	33400000
132215	1619	8640184000000
132216	1619	8640221000000
132242	1395	58286071991957278
132251	1397	1277403875000
132252	1678	27360856225000
132253	2134	84119671000
132254	1874	33424000
132255	2133	90721088000
132256	1874	33426000
132257	1688	20950801113020
132298	1397	1277343869000
132299	1678	27360856231000
132300	2133	90715076000
132301	1874	33455000
132302	1768	22787115110000
132303	1768	22787126110000
132336	1397	1277293864000
132337	1678	27360856236000
132338	1397	1277283863000
132339	1678	27360856237000
132340	2133	90710066000
132341	1874	33478000
132342	2134	84109641000
132343	1874	33481000
132344	2133	90709064000
132345	1874	33483000
132346	2132	147279292000
132347	1874	33484000
132348	2134	84108638000
132349	1874	33487000
132350	1688	100000001
132351	2367	20950814113019
132464	1395	58286792004957278
132465	1395	58286792016957278
132466	1397	1277223857000
132467	1678	27360856243000
132468	1397	1277213856000
132469	1678	27360856244000
132470	2134	84102620000
132471	1874	33516000
132472	2133	90703052000
132473	1874	33518000
132474	2133	90702050000
132475	1874	33520000
132476	2134	84101617000
132477	1874	33523000
132478	2132	147277290000
132479	1874	33524000
132480	1588	18001909000000
132481	1588	18001934000000
132509	1397	1277173852000
132510	1678	27360856248000
132511	2133	90698042000
132512	1874	33542000
132513	2134	84097605000
132514	1874	33545000
132543	1402	44823372145435
132544	1402	44823384145435
132616	1397	1277093844000
132617	1678	27360856256000
132618	2133	90690026000
132619	1874	33584000
132620	2132	147273286000
132621	1874	33585000
132622	2134	84089581000
132623	1874	33588000
132624	1715	10823591663945
132625	1715	10823604663945
132639	1397	1277073842000
132640	1678	27360856258000
132641	2134	84087575000
132642	1874	33596000
132643	2133	90688022000
132644	1874	33598000
132645	1394	917294331440200
132646	1394	917294343440200
132785	1397	1276893824000
132786	1678	27360856276000
132787	2133	90670988000
132788	1874	33685000
132789	2134	84069521000
132790	1874	33688000
132791	1476	16560383000000
132792	1476	16560395000000
132797	1397	1276883823000
132798	1678	27360856277000
132799	2133	90669986000
132800	1874	33690000
132801	2134	84068518000
132802	1874	33693000
132803	470	78115339000000
132804	470	78115351000000
132827	1474	14310619000043
132828	1474	14310631000043
132902	1395	58288232028957278
132903	1395	58288232040957278
132939	1685	179284562571430
132940	1685	180004562571430
132941	1685	180004563571430
132958	1448	11479889000001
132961	1397	1276703805000
132962	1678	27360856295000
132963	2134	84051467000
132964	1874	33778000
132965	2133	90651950000
132966	1874	33780000
133054	1397	1276573792000
133055	1678	27360856308000
133056	2134	84038428000
133057	1874	33843000
133058	2133	90638924000
133059	1874	33845000
133060	2306	2879108000000
133062	1397	1276563791000
133063	1678	27360856309000
133064	2133	90637922000
133065	1874	33847000
133066	2134	84037425000
133067	1874	33850000
133068	1688	23110838113019
133069	1688	23110850113019
133085	1691	11231133300052
133086	1547	11514831000000
133095	1874	33834000
133096	1874	33836000
133097	1874	33838000
133098	1874	33841000
133099	1874	33844000
133100	1394	925934487440200
133101	1394	925934548440200
133132	1397	1276493784000
133133	1678	27360856316000
133134	2134	84031407000
133135	1874	33880000
133136	2133	90630908000
133137	1874	33882000
133152	1395	58288952040957278
133153	1395	58288952052957278
133156	1874	33237000
133157	1874	33239000
133158	1874	33243000
133159	1874	33245000
133160	1874	33269000
133161	1874	33352000
133162	1874	33354000
133163	1874	33356000
133164	1874	33358000
133165	1874	33362000
133166	1874	33372000
133167	1874	33380000
133168	1874	33388000
133169	1874	33404000
133170	1506	7920339967172
133171	1874	33406000
133172	1874	33412000
133173	1874	33422000
133174	1874	33430000
133175	1874	33436000
133176	1874	33440000
132268	1394	912974280440200
132269	1394	912974293440200
132270	1397	1277383873000
132271	1678	27360856227000
132272	1397	1277373872000
132273	1678	27360856228000
132274	1397	1277363871000
132275	1678	27360856229000
132276	1397	1277353870000
132277	1678	27360856230000
132278	2133	90719084000
132279	1874	33434000
132280	2134	84117665000
132281	1874	33437000
132282	2133	90718082000
132283	1874	33439000
132284	2133	90717080000
132285	1874	33441000
132286	2133	90716078000
132287	1874	33443000
132288	2132	147281294000
132289	1874	33444000
132290	2134	84116662000
132291	1874	33447000
132292	2134	84115659000
132293	1874	33450000
132294	2134	84114656000
132295	1874	33453000
132296	1623	81363350898598
132297	1623	81363399898598
132320	1397	1277313866000
132321	1678	27360856234000
132322	2133	90712070000
132323	1874	33468000
132324	2134	84111647000
132325	1874	33471000
132352	1397	1277273862000
132353	1678	27360856238000
132354	2134	84107635000
132355	1874	33490000
132356	2133	90708062000
132357	1874	33492000
132360	2087	4035423147766
132361	2087	4035435147766
132405	1397	1277263861000
132406	1678	27360856239000
132407	1397	1277253860000
132408	1678	27360856240000
132409	1397	1277243859000
132410	1678	27360856241000
132411	2132	147278291000
132412	1874	33493000
132413	2134	84106632000
132414	1874	33496000
132415	2134	84105629000
132416	1874	33499000
132417	2134	84104626000
132418	1874	33502000
132419	2133	90707060000
132420	1874	33504000
132421	2133	90706058000
132422	1874	33506000
132423	2133	90705056000
132424	1874	33508000
132425	1457	13680277800000
132426	1457	13680314800000
132482	1684	28083433819412
132483	1684	28083458819412
132485	1397	1277203855000
132486	1678	27360856245000
132487	2134	84100614000
132488	1874	33527000
132489	2133	90701048000
132490	1874	33529000
132500	1397	1277183853000
132501	1678	27360856247000
132502	2134	84098608000
132503	1874	33538000
132504	2133	90699044000
132505	1874	33540000
132506	1715	10103591663945
132507	1560	17288843131803
132508	1560	17288855131803
132528	1397	1277153850000
132529	1678	27360856250000
132530	2134	84095599000
132531	1874	33554000
132532	2133	90696038000
132533	1874	33556000
132534	1559	11826164999999
132535	1559	11826176999999
132537	1397	1277143849000
132538	1678	27360856251000
132539	2134	84094596000
132540	1874	33559000
132541	2133	90695036000
132542	1874	33561000
132545	1694	17819083197225
132546	1694	17819095197225
132608	1397	1277103845000
132609	1678	27360856255000
132610	2133	90691028000
132611	1874	33579000
132612	2134	84090584000
132613	1874	33582000
132626	1394	915854331440200
132647	1397	1277063841000
132648	1678	27360856259000
132649	2132	147272285000
132650	1874	33599000
132651	2134	84086572000
132652	1874	33602000
132653	2133	90687020000
132654	1874	33604000
132655	1696	19883812335104
132677	1397	1277043839000
132678	1678	27360856261000
132679	1397	1277033838000
132680	1678	27360856262000
132681	1874	33607000
132682	2134	84084566000
132683	1874	33610000
132684	2134	84083563000
132685	1874	33613000
132686	1874	33615000
132687	2133	90685016000
132688	1874	33617000
132689	2133	90684014000
132690	1874	33619000
132691	1717	15661337000055
132692	1717	16381337000055
132693	1686	15512176700123
132694	1686	16232176700123
132709	1397	1277003835000
132710	1678	27360856265000
132711	1397	1276993834000
132712	1678	27360856266000
132713	1397	1276983833000
132714	1678	27360856267000
132715	1397	1276973832000
132716	1678	27360856268000
132717	2134	84080554000
132718	1874	33633000
132719	2133	90681008000
132720	1874	33635000
132721	2133	90680006000
132722	1874	33637000
132723	2134	84079551000
132724	1874	33640000
132725	2133	90679004000
132726	1874	33642000
132727	2134	84078548000
132728	1874	33645000
132729	2134	84077545000
132730	1874	33648000
132731	1444	13767891329999
132732	1444	13767938329999
132758	1397	1276933828000
132759	1678	27360856272000
132760	2133	90674996000
132761	1874	33665000
132762	2134	84073533000
132763	1874	33668000
132764	1397	1276923827000
132765	1678	27360856273000
132766	2134	84072530000
132767	1874	33671000
132768	2133	90673994000
132769	1874	33673000
132805	1397	1276873822000
132806	1678	27360856278000
132807	2134	84067515000
132808	1874	33696000
132809	2133	90668984000
132810	1874	33698000
132811	1489	13343155040000
132812	1489	13343167040000
132815	1397	1276863821000
132816	1678	27360856279000
132817	2133	90667982000
132818	1874	33700000
132829	1397	1276843819000
132830	1678	27360856281000
132831	1397	1276833818000
132832	1678	27360856282000
132318	1394	914414293440200
132319	1394	914414318440200
132326	1474	15030619000043
132327	1474	15030631000043
132358	1394	915854318440200
132359	1394	915854330440200
132362	1874	33219000
132363	1874	33221000
132364	1874	33225000
132365	1874	33227000
132366	1874	33230000
132367	1874	33240000
132368	1874	33242000
132369	1874	33246000
132370	1874	33248000
132371	1874	33249000
132372	1874	33251000
132373	1874	33253000
132374	1874	33256000
132375	1874	33257000
132376	1874	33259000
132377	1874	33261000
132378	1874	33264000
132379	1874	33266000
132380	1874	33268000
132381	1874	33272000
132382	1874	33274000
132383	1874	33280000
132384	1874	33288000
132385	1874	33290000
132386	1874	33291000
132387	1874	33298000
132388	1874	33301000
132389	1874	33313000
132390	1874	33316000
132391	1874	33320000
132392	1690	185766453000000
132393	1874	33324000
132394	1874	33326000
132395	1874	33330000
132396	1874	33332000
132397	1874	33334000
132398	1874	33336000
132399	1874	33338000
132400	1874	33340000
132401	1874	33344000
132402	1874	33346000
132403	1690	186486453000000
132404	1690	186486466000000
132427	1397	1277233858000
132428	1678	27360856242000
132429	2133	90704054000
132430	1874	33510000
132431	2134	84103623000
132432	1874	33513000
132433	1688	21670814113019
132434	1688	21670826113019
132435	1874	33263000
132436	1874	33285000
132437	1874	33294000
132438	1874	33296000
132439	2112	23567515101924
132440	1874	33306000
132441	1874	33314000
132442	1874	33317000
132443	1874	33321000
132444	1874	33323000
132445	1874	33327000
132446	1874	33329000
132447	1874	33341000
132448	1874	33347000
132449	1874	33349000
132450	1874	33351000
132451	1874	33359000
132452	1874	33363000
132453	1874	33365000
132454	1874	33367000
132455	1874	33369000
132456	1874	33371000
132457	1874	33375000
132458	1874	33378000
132459	1874	33381000
132460	1874	33387000
132461	1874	33390000
132462	2112	24287515101924
132463	2112	24287561101924
132484	1634	16223132259504
132491	1397	1277193854000
132492	1678	27360856246000
132493	2133	90700046000
132494	1874	33531000
132495	2134	84099611000
132496	1874	33534000
132497	2132	147276289000
132498	1874	33535000
132499	1639	720013000000
132518	1397	1277163851000
132519	1678	27360856249000
132520	2133	90697040000
132521	1874	33547000
132522	2134	84096602000
132523	1874	33550000
132524	1841	1438025000000
132525	2132	147275288000
132526	1874	33551000
132527	1749	722598529980
132536	2329	313206453819988
132586	1397	1277133848000
132587	1678	27360856252000
132588	1397	1277123847000
132589	1678	27360856253000
132590	1397	1277113846000
132591	1678	27360856254000
132592	2133	90694034000
132593	1874	33563000
132594	2133	90693032000
132595	1874	33565000
132596	2132	147274287000
132597	1874	33566000
132598	2134	84093593000
132599	1874	33569000
132600	2134	84092590000
132601	1874	33572000
132602	2134	84091587000
132603	1874	33575000
132604	2133	90692030000
132605	1874	33577000
132606	1657	8641359990100
132607	1657	8641396990100
132637	1395	58287512016957278
132638	1395	58287512028957278
132658	1397	1277053840000
132659	1678	27360856260000
132660	1874	33576000
132661	1690	187206774000000
132662	1874	33581000
132663	1874	33583000
132664	1874	33587000
132665	1874	33589000
132666	2133	90686018000
132667	1874	33594000
132668	1874	33597000
132669	1874	33600000
132670	1874	33603000
132671	1874	33606000
132672	2134	84085569000
132673	1874	33609000
132674	1690	187926774000000
132675	1527	187926787000001
132676	1690	290999959
132695	1397	1277023837000
132696	1678	27360856263000
132697	1397	1277013836000
132698	1678	27360856264000
132699	2133	90683012000
132700	1874	33621000
132701	2133	90682010000
132702	1874	33623000
132703	2134	84082560000
132704	1874	33626000
132705	2132	147271284000
132706	1874	33627000
132707	2134	84081557000
132708	1874	33630000
132734	1394	918734343440200
132735	1394	918734390440200
132736	1397	1276963831000
132737	1678	27360856269000
132738	1397	1276953830000
132739	1678	27360856270000
132740	2133	90678002000
132741	1874	33650000
132742	2133	90677000000
132743	1874	33652000
132744	2134	84076542000
132745	1874	33655000
132746	2134	84075539000
132747	1874	33658000
132748	43	78960221890000
132749	43	78960245890000
132750	1397	1276943829000
132751	1678	27360856271000
132752	2134	84074536000
132753	1874	33661000
132754	2133	90675998000
132755	1874	33663000
132756	1608	15978573000000
132757	1608	15978585000000
132783	1649	13431609999968
132784	1649	13431633999968
132795	1394	920174390440200
132796	1394	920174402440200
132855	1874	33611000
132856	1874	33620000
132857	1874	33629000
132858	1874	33631000
132859	1874	33634000
132860	1874	33644000
132861	1874	33646000
132862	1874	33654000
132863	1874	33657000
132864	1874	33660000
132865	1874	33666000
132866	1874	33669000
132867	1874	33672000
132868	1874	33684000
132869	1874	33687000
132870	1874	33699000
132871	1874	33711000
132872	1874	33713000
132873	1874	33719000
132874	1874	33721000
132875	1690	188646787000001
132876	1690	188647074000001
132894	1397	1276783813000
132895	1678	27360856287000
132896	2134	84059491000
132897	1874	33738000
132898	2133	90659966000
132899	1874	33740000
132900	1622	8964028800048
132901	1622	8964040800048
132910	1394	924494438440200
132911	1394	924494450440200
132956	2106	3600162000000
132957	2106	3600186000000
132959	1685	180724563571430
132960	1685	180724587571430
132974	1397	1276683803000
132975	1678	27360856297000
132976	2133	90649946000
132977	1874	33787000
132978	2134	84049461000
132979	1874	33790000
132980	1619	9360221000000
132981	1619	9360233000000
132982	1397	1276673802000
132983	1678	27360856298000
132984	2133	90648944000
132985	1874	33792000
132986	2134	84048458000
132987	1874	33795000
132988	1768	23507126110000
132989	1768	23507138110000
133011	1397	1276633798000
133012	1678	27360856302000
133013	1397	1276623797000
133014	1678	27360856303000
133015	1397	1276613796000
133016	1678	27360856304000
133017	1397	1276603795000
133018	1678	27360856305000
133019	2047	40290000
133020	2134	84044446000
133021	1874	33813000
133022	2133	90644936000
133023	1874	33815000
133024	2133	90643934000
133025	1874	33817000
133026	2133	90642932000
133027	1874	33819000
133028	2133	90641930000
133029	1874	33821000
133030	2134	84043443000
133031	1874	33824000
133032	2134	84042440000
133033	1874	33827000
133034	2134	84041437000
133035	1874	33830000
133036	1394	924494487440200
133045	1700	11754292979053
133046	1700	11754304979053
133047	1397	1276583793000
133048	1678	27360856307000
133049	2133	90639926000
133050	1874	33837000
133051	2134	84039431000
133052	1874	33840000
133053	1593	15792801000000
133083	1547	11514828000000
133084	1547	11514841000000
133087	1397	1276543789000
133088	1678	27360856311000
133089	2134	84035419000
133090	1874	33858000
133091	2133	90635918000
133092	1874	33860000
133093	1509	16223430503835
133094	1509	16223442503835
133117	1719	16558673000000
133118	1719	16558699000000
133144	1397	1276473782000
133145	1678	27360856318000
133146	2134	84029401000
133147	1874	33890000
133148	2133	90628904000
133149	1874	33892000
133150	1402	46263396145435
133151	1402	46263408145435
133192	1397	1276453780000
133193	1678	27360856320000
133194	2133	90626900000
133195	1874	33899000
133196	2134	84027395000
133197	1874	33902000
133198	1693	10070979570272
133199	1527	290999959
133200	1693	10790978570273
133204	1705	25041028580140
133205	1705	25761028580140
133216	1397	1276443779000
133217	1678	27360856321000
133218	1397	1276433778000
133219	1678	27360856322000
133220	1397	1276423777000
133221	1678	27360856323000
133222	2134	84025389000
133223	1874	33910000
133224	2134	84024386000
133225	1874	33913000
133226	2133	90624896000
133227	1874	33915000
133228	2133	90623894000
133229	1874	33917000
133230	1675	20444497999977
133231	1675	20444531999977
133264	1397	1276363771000
133265	1678	27360856329000
133266	2134	84018368000
133267	1874	33945000
133268	2133	90617882000
133269	1874	33947000
133270	1458	22265467908540
133271	1458	22265479908540
133272	1458	22265469908540
133402	2248	11519546000000
133413	1700	12474316979053
133435	1467	5920314272869
133436	1467	6640314272869
133445	1397	1276143749000
133446	1678	27360856351000
133447	2133	90595838000
133448	1874	34054000
133449	2134	83996302000
133450	1874	34057000
133451	1394	930254523440200
133452	1394	930254535440200
133456	1395	58290392075957278
133457	1395	58290392087957278
133470	1397	1276113746000
133471	1678	27360856354000
133472	2134	83993293000
133473	1874	34070000
133474	2133	90592832000
133475	1874	34072000
133477	1756	9201475195609
133478	1874	33704000
133479	1874	33706000
133480	1874	33708000
133481	1874	33710000
133482	1874	33718000
133483	1874	33722000
133484	1874	33724000
133485	1874	33726000
133486	1874	33732000
133487	1874	33734000
133488	1874	33736000
133489	1874	33742000
133490	1874	33744000
133491	1874	33746000
132833	2133	90665978000
132834	1874	33707000
132835	2133	90664976000
132836	1874	33709000
132837	2134	84065509000
132838	1874	33712000
132839	2134	84064506000
132840	1874	33715000
132841	1684	28803482819412
132886	1397	1276793814000
132887	1678	27360856286000
132888	2134	84060494000
132889	1874	33733000
132890	2133	90660968000
132891	1874	33735000
132892	1394	923054426440200
132893	1394	923054438440200
132942	1397	1276723807000
132943	1678	27360856293000
132944	1397	1276713806000
132945	1678	27360856294000
132946	2133	90653954000
132947	1874	33767000
132948	2134	84053473000
132949	1874	33770000
132950	2133	90652952000
132951	1874	33772000
132952	2134	84052470000
132953	1874	33775000
132954	1688	22390826113019
132955	1688	22390850113019
133037	1397	1276593794000
133038	1678	27360856306000
133039	2133	90640928000
133040	1874	33832000
133041	2134	84040434000
133042	1874	33835000
133043	2112	25006980101924
133044	2112	25006992101924
133061	1440	7200263045924
133070	2329	313926453819988
133071	2329	313926465819988
133072	1397	1276553790000
133073	1678	27360856310000
133074	1775	837210000
133075	2047	51290000
133076	2134	84036422000
133077	1874	33853000
133078	2133	90636920000
133079	1874	33855000
133080	1688	23110851113019
133119	1397	1276513786000
133120	1678	27360856314000
133121	1397	1276503785000
133122	1678	27360856315000
133123	2133	90632912000
133124	1874	33872000
133125	2134	84032410000
133126	1874	33875000
133127	2133	90631910000
133128	1874	33877000
133129	1476	16560406000000
133138	1397	1276483783000
133139	1678	27360856317000
133140	2134	84030404000
133141	1874	33885000
133142	2133	90629906000
133143	1874	33887000
133154	2307	4319085000000
133155	2307	4319097000000
133201	1693	10790979570272
133251	1397	1276383773000
133252	1678	27360856327000
133253	1397	1276373772000
133254	1678	27360856328000
133255	2133	90619886000
133256	1874	33934000
133257	2133	90618884000
133258	1874	33936000
133259	2134	84020374000
133260	1874	33939000
133261	2134	84019371000
133262	1874	33942000
133263	1419	24766203559748
133286	1397	1276343769000
133287	1678	27360856331000
133288	2133	90614876000
133289	1874	33959000
133290	2134	84015359000
133291	1874	33962000
133292	1681	17134780358535
133293	1681	17134792358535
133314	1397	1276303765000
133315	1678	27360856335000
133316	2134	84011347000
133317	1874	33980000
133318	2133	90610868000
133319	1874	33982000
133320	1394	927374499440200
133321	1394	927374511440200
133324	1397	1276293764000
133325	1678	27360856336000
133326	2133	90609866000
133327	1874	33984000
133328	2134	84010344000
133329	1874	33987000
133330	1397	1276283763000
133331	1678	27360856337000
133332	1397	1276273762000
133333	1678	27360856338000
133334	1397	1276263761000
133335	1678	27360856339000
133336	2134	84009341000
133337	1874	33990000
133338	2134	84008338000
133339	1874	33993000
133340	2133	90608864000
133341	1874	33995000
133342	2133	90607862000
133343	1874	33997000
133344	2133	90606860000
133345	1874	33999000
133346	1546	13197518800000
133347	1546	13197553800000
133349	1397	1276253760000
133350	1678	27360856340000
133351	2134	84007335000
133352	1874	34002000
133353	2133	90605858000
133354	1874	34004000
133355	1696	20603812335104
133356	1696	20603824335104
133375	1397	1276223757000
133376	1678	27360856343000
133377	2134	84004326000
133378	1874	34017000
133379	2133	90602852000
133380	1874	34019000
133381	633	79389518900000
133382	633	79389530900000
133399	1716	2880080000000
133410	1874	34031000
133411	1700	12474304979053
133412	1700	12474305979053
133414	1397	1276183753000
133415	1678	27360856347000
133416	1397	1276173752000
133417	1678	27360856348000
133418	2133	90598844000
133419	1874	34036000
133420	2133	90597842000
133421	1874	34038000
133422	2134	84000314000
133423	1874	34041000
133424	2134	83999311000
133425	1874	34044000
133426	1395	58288952064957278
133437	1764	15203549100000
133438	1764	15923549100000
133439	1397	1276153750000
133440	1678	27360856350000
133441	2134	83997305000
133442	1874	34052000
133443	1395	58289672064957278
133444	1395	58289672075957278
133453	1522	11563751000000
133454	1522	11563762000000
133476	1694	17819085197225
133504	1397	1276103745000
133505	1678	27360856355000
133506	2134	83992290000
133507	1874	34075000
133508	2133	90591830000
133509	1874	34077000
133510	1703	6480930000000
133512	1397	1276093744000
133513	1678	27360856356000
133514	1874	34013000
133515	1874	34015000
133516	1874	34018000
133517	1874	34025000
133518	1874	34027000
133519	1874	34033000
133520	1874	34035000
133521	1874	34037000
132998	2134	84046452000
132999	1874	33801000
133000	2134	84045449000
133001	1874	33804000
133002	2133	90647942000
133003	1874	33806000
133004	2133	90646940000
133005	1874	33808000
133006	2133	90645938000
133007	1874	33810000
133008	1675	19724461999977
133009	1675	19724497999977
133010	1394	924494474440200
133081	1693	10070954570272
133082	1693	10070967570272
133102	1397	1276533788000
133103	1678	27360856312000
133104	1397	1276523787000
133105	1678	27360856313000
133106	2058	525500000
133107	2134	84034416000
133108	1874	33863000
133109	2133	90634916000
133110	1874	33865000
133111	2134	84033413000
133112	1874	33868000
133113	2133	90633914000
133114	1874	33870000
133115	606	77566877286230
133116	606	77566903286230
133130	1708	12600623500051
133131	1708	12600646500051
133184	1397	1276463781000
133185	1678	27360856319000
133186	2133	90627902000
133187	1874	33894000
133188	2134	84028398000
133189	1874	33897000
133190	2086	3600379300069
133191	2086	3600391300069
133202	1593	15792813000000
133203	1593	16512813000000
133206	1764	15203551100000
133207	1764	15923551100000
133210	2133	90625898000
133211	1874	33904000
133212	2134	84026392000
133213	1874	33907000
133214	641	80403945000000
133215	641	80403947000000
133273	1397	1276353770000
133274	1678	27360856330000
133275	2133	90616880000
133276	1874	33949000
133277	2134	84017365000
133278	1874	33952000
133279	1394	925934499440200
133294	1397	1276333768000
133295	1678	27360856332000
133296	1397	1276323767000
133297	1678	27360856333000
133298	2134	84014356000
133299	1874	33965000
133300	2134	84013353000
133301	1874	33968000
133302	2133	90613874000
133303	1874	33970000
133304	2133	90612872000
133305	1874	33972000
133306	1671	16224258003785
133307	1671	16224282003785
133322	1656	15835557999990
133323	1656	15835569999990
133348	42	74300710000000
133357	1650	10913057000000
133358	1650	10913069000000
133365	1633	9408647125277
133366	1633	9408658125277
133383	1693	11510979570272
133384	1693	11510991570272
133400	1762	10725623994000
133401	1762	10725647994000
133427	1397	1276163751000
133428	1678	27360856349000
133429	1696	19883822335104
133430	2133	90596840000
133431	1874	34046000
133432	2134	83998308000
133433	1874	34049000
133434	1696	20603822335104
133455	1522	11563763000000
133458	1397	1276133748000
133459	1678	27360856352000
133460	2134	83995299000
133461	1874	34060000
133462	2133	90594836000
133463	1874	34062000
133565	1440	7200265045924
133597	1692	11260843619999
133624	641	81123947000000
133625	641	81123948000000
133628	1397	1276003735000
133629	1678	27360856365000
133630	1397	1275993734000
133631	1678	27360856366000
133632	2134	83983263000
133633	1874	34120000
133634	2134	83982260000
133635	1874	34123000
133636	1874	34125000
133637	2133	90581810000
133638	1874	34127000
133639	2133	90580808000
133640	1874	34129000
133641	1670	11521109000000
133642	1555	16086240540449
133643	1555	16086275540449
133689	1397	1275923727000
133690	1678	27360856373000
133691	2133	90573794000
133692	1874	34161000
133693	1611	5687627453965
133694	975	508248127862876
133695	1611	4693464035601
133696	1095	910776290460314
133697	1611	4022681841845
133698	1215	614518911673154
133699	1611	2153489402899
133700	1341	1712411587352407
133701	1611	2153488402899
133702	2134	83975239000
133703	1874	34164000
133704	1717	17101337000055
133705	1717	17101354000055
133732	1506	7200225967172
133733	1506	7920225967172
133734	1506	7920239967172
133738	1874	33454000
133739	1874	33464000
133740	1874	33470000
133741	1874	33472000
133742	1874	33482000
133743	1874	33488000
133744	1874	33494000
133745	1874	33500000
133746	1874	33512000
133747	1874	33514000
133748	1874	33526000
133749	1874	33530000
133750	1874	33532000
133751	1874	33536000
133752	1874	33544000
133753	1874	33548000
133754	1874	33560000
133755	1874	33562000
133756	1874	33564000
133757	1874	33568000
133758	1874	33570000
133759	1874	33574000
133760	1874	33578000
133761	1874	33580000
133762	1874	33586000
133763	1874	33590000
133764	1874	33592000
133765	1874	33608000
133766	1874	33612000
133767	1874	33614000
133768	1874	33616000
133769	1874	33618000
133770	1874	33632000
133771	1874	33638000
133772	1874	33641000
133773	1506	8640464967164
133774	1874	33647000
133775	1874	33653000
133776	1874	33656000
133777	1874	33659000
133778	1874	33662000
133779	1874	33674000
133780	1874	33677000
133781	1874	33680000
133782	1874	33686000
133783	1874	33689000
133784	1874	33692000
133785	1874	33695000
133177	1874	33442000
133178	1874	33446000
133179	1874	33448000
133180	1874	33452000
133181	1506	8640339967172
133182	1571	8640363967164
133183	1506	9260664124170
133208	1564	12606859000000
133209	1564	13326859000000
133232	1397	1276413776000
133233	1678	27360856324000
133234	1397	1276403775000
133235	1678	27360856325000
133236	1397	1276393774000
133237	1678	27360856326000
133238	2133	90622892000
133239	1874	33919000
133240	2133	90621890000
133241	1874	33921000
133242	2133	90620888000
133243	1874	33923000
133244	2134	84023383000
133245	1874	33926000
133246	2134	84022380000
133247	1874	33929000
133248	2134	84021377000
133249	1874	33932000
133250	1559	11826200999999
133280	2133	90615878000
133281	1874	33954000
133282	2134	84016362000
133283	1874	33957000
133284	1992	15121104990000
133285	1992	15121106990000
133308	1397	1276313766000
133309	1678	27360856334000
133310	2133	90611870000
133311	1874	33974000
133312	2134	84012350000
133313	1874	33977000
133359	1397	1276243759000
133360	1678	27360856341000
133361	2134	84006332000
133362	1874	34007000
133363	1698	13028981550062
133364	1698	13028992550062
133367	1397	1276233758000
133368	1678	27360856342000
133369	2133	90604856000
133370	1874	34009000
133371	2133	90603854000
133372	1874	34011000
133373	2134	84005329000
133374	1874	34014000
133385	1397	1276213756000
133386	1678	27360856344000
133387	1397	1276203755000
133388	1678	27360856345000
133389	2133	90601850000
133390	1874	34021000
133391	2133	90600848000
133392	1874	34023000
133393	2134	84003323000
133394	1874	34026000
133395	2134	84002320000
133396	1874	34029000
133397	1394	928814511440200
133398	1394	928814535440200
133403	1397	1276193754000
133404	1678	27360856346000
133405	2134	84001317000
133406	1874	34032000
133407	2133	90599846000
133408	1874	34034000
133409	1394	928814523440200
133464	1397	1276123747000
133465	1678	27360856353000
133466	2134	83994296000
133467	1874	34065000
133468	2133	90593834000
133469	1874	34067000
133532	1679	12238260656999
133533	1679	12238272656999
133566	1690	188647454000001
133567	1690	189367454000001
133568	1520	175000
133569	1568	100000027
133570	1690	66000000499999
133571	697	189367473475001
133572	364	67440026000000
133575	576	80477702726897
133576	576	80477735726897
133584	1397	1276053740000
133585	1678	27360856360000
133586	1397	1276043739000
133587	1678	27360856361000
133588	2133	90586820000
133589	1874	34096000
133590	2134	83988278000
133591	1874	34099000
133592	2134	83987275000
133593	1874	34102000
133594	2133	90585818000
133595	1874	34104000
133596	1394	930254547440200
133612	43	79680245890000
133613	43	79680269890000
133622	1395	58291112087957278
133623	1395	58291112099957278
133626	1670	11521074000000
133627	1670	11521244000000
133658	1397	1275963731000
133659	1678	27360856369000
133660	2133	90577802000
133661	1874	34141000
133662	2134	83979251000
133663	1874	34144000
133664	1671	16944282003785
133665	1671	16944294003785
133675	1397	1275943729000
133676	1678	27360856371000
133677	1397	1275933728000
133678	1678	27360856372000
133679	2133	90575798000
133680	1874	34151000
133681	2133	90574796000
133682	1874	34153000
133683	2134	83977245000
133684	1874	34156000
133685	2134	83976242000
133686	1874	34159000
133687	632	78957648000000
133688	632	78957672000000
133706	1397	1275913726000
133707	1678	27360856374000
133708	2133	90572792000
133709	1874	34166000
133710	2134	83974236000
133711	1874	34169000
133712	1394	933134571440200
133713	1394	933134583440200
133735	2329	314646489819988
133736	2329	315366489819988
133737	2329	315366503819988
133812	2133	90567782000
133813	1874	34194000
133847	1623	81363479898598
133848	1623	82083479898598
133849	1623	82083839898598
133857	1397	1275793714000
133858	1678	27360856386000
133859	2134	83963203000
133860	1874	34224000
133861	2133	90560768000
133862	1874	34226000
133863	1394	934574583440200
133864	1394	934574595440200
133865	1397	1275783713000
133866	1678	27360856387000
133867	1397	1275773712000
133868	1678	27360856388000
133869	1397	1275763711000
133870	1678	27360856389000
133871	2134	83962200000
133872	1874	34229000
133873	2134	83961197000
133874	1874	34232000
133875	2134	83960194000
133876	1874	34235000
133877	364	66000011000000
133878	1933	3259268000000
133879	2133	90559766000
133880	1874	34237000
133881	2133	90558764000
133882	1874	34239000
133883	2133	90557762000
133884	1874	34241000
133885	1634	16223144259504
133910	1709	10080244000000
133919	1397	1275713706000
133920	1678	27360856394000
133921	2133	90552752000
133922	1874	34263000
133923	2134	83955179000
133924	1874	34266000
133492	1874	33758000
133493	1874	33760000
133494	1874	33764000
133495	1874	33766000
133496	1874	33768000
133497	1874	33774000
133498	1874	33776000
133499	1874	33784000
133500	1874	33786000
133501	1874	33788000
133502	1756	9921475195609
133503	1756	9921705195609
133511	1702	6480545000000
133527	2134	83991287000
133528	1874	34080000
133529	1874	34082000
133530	606	78286903286230
133531	606	78286915286230
133538	1397	1276083743000
133539	1678	27360856357000
133540	2134	83990284000
133541	1874	34085000
133542	2133	90589826000
133543	1874	34087000
133544	1726	959361112000
133545	2370	100000000
133546	1688	23830851113019
133547	1688	23830864113019
133550	1874	34084000
133551	1759	11017306139889
133577	1397	1276063741000
133578	1678	27360856359000
133579	2133	90587822000
133580	1874	34091000
133581	2134	83989281000
133582	1874	34094000
133583	576	80477714726897
133598	1397	1276033738000
133599	1678	27360856362000
133600	1397	1276023737000
133601	1678	27360856363000
133602	2134	83986272000
133603	1874	34107000
133604	2134	83985269000
133605	1874	34110000
133606	2133	90584816000
133607	1874	34112000
133608	2133	90583814000
133609	1874	34114000
133610	1991	15021449355805
133611	1991	15021473355805
133614	1397	1276013736000
133615	1678	27360856364000
133616	2134	83984266000
133617	1874	34117000
133618	2133	90582812000
133619	1874	34119000
133620	1688	24550864113019
133621	1688	24550876113019
133668	1397	1275953730000
133669	1678	27360856370000
133670	2134	83978248000
133671	1874	34147000
133672	2133	90576800000
133673	1874	34149000
133674	1706	17562270450256
133714	1397	1275903725000
133715	1678	27360856375000
133716	2307	3599095000000
133717	1744	905000000
133718	2307	4319090000000
133719	1571	9260674124162
133720	1397	1275893724000
133721	1678	27360856376000
133722	2133	90571790000
133723	1874	34171000
133724	2133	90570788000
133725	1874	34173000
133726	2134	83973233000
133727	1874	34176000
133728	2134	83972230000
133729	1874	34179000
133730	1571	9980674124162
133731	1571	9980688124162
133791	1397	1275883723000
133792	1678	27360856377000
133793	1397	1275873722000
133794	1678	27360856378000
133795	2133	90569786000
133796	1874	34181000
133797	2134	83971227000
133798	1874	34184000
133799	2134	83970224000
133800	1874	34187000
133801	2133	90568784000
133802	1874	34189000
133803	2148	10800332880750
133804	2148	10800356880750
133805	1397	1275863721000
133806	1678	27360856379000
133807	2134	83969221000
133808	1874	34192000
133809	1737	1399001100
133810	606	78286803286230
133811	606	78286814286230
133820	1710	15354084664140
133821	1710	15354096664140
133833	1397	1275823717000
133834	1678	27360856383000
133835	2133	90563774000
133836	1874	34208000
133837	2134	83966212000
133838	1874	34211000
133839	1395	58291832099957278
133840	1395	58291832111957278
133902	1397	1275733708000
133903	1678	27360856392000
133904	2134	83957185000
133905	1874	34254000
133906	2133	90554756000
133907	1874	34256000
133908	1402	47703432145435
133909	1402	47703444145435
133948	1522	12283763000000
133949	1522	12283775000000
133978	1447	20441899683000
133979	1447	20441923683000
134003	2332	100000001
134004	1706	18282282450255
134059	1397	1275583693000
134060	1678	27360856407000
134061	2133	90539726000
134062	1874	34328000
134063	1622	9684040800048
134064	1622	9684051800048
134067	1397	1275573692000
134068	1678	27360856408000
134069	2134	83942140000
134070	1874	34331000
134071	2133	90538724000
134072	1874	34333000
134090	1397	1275543689000
134091	1678	27360856411000
134092	2134	83939131000
134093	1874	34346000
134094	2133	90535718000
134095	1874	34348000
134096	1394	940334643440200
134097	1394	940334655440200
134147	1397	1275473682000
134148	1678	27360856418000
134149	2134	83931107000
134150	1874	34386000
134151	2133	90527702000
134152	1874	34388000
134153	1508	15320447156616
134154	1508	15320459156616
134171	1719	16558685000000
134203	1397	1275403675000
134204	1678	27360856425000
134205	2134	83924086000
134206	1874	34421000
134207	2133	90520688000
134208	1874	34423000
134211	1670	12241243900000
134255	2329	316806493819988
134256	2329	316806505819988
134312	1397	1275283663000
134313	1678	27360856437000
134314	1397	1275273662000
134315	1678	27360856438000
134316	2133	90508664000
134317	1874	34477000
134318	2133	90507662000
134319	1874	34479000
134320	2134	83913053000
134321	1874	34482000
134322	2134	83912050000
134323	1874	34485000
134324	1394	947534759440200
134325	1394	947534783440200
134334	1397	1275253660000
134335	1678	27360856440000
134336	1397	1275243659000
134337	1678	27360856441000
133522	1874	34039000
133523	2133	90590828000
133524	1874	34043000
133525	606	77567071286230
133526	606	78287070286231
133534	1594	16561899000000
133535	1594	16561911000000
133536	1874	34079000
133537	606	78286914286230
133548	1759	11017294139889
133549	1759	11017307139889
133552	1397	1276073742000
133553	1678	27360856358000
133554	2133	90588824000
133555	1874	34089000
133556	1726	958260112000
133557	2371	100000000
133558	1726	957159112000
133559	2372	100000000
133560	1726	956058112000
133561	2373	100000000
133562	2306	3599108000000
133563	2306	3599122000000
133564	364	67440016000000
133573	2329	314646465819988
133574	2329	314646479819988
133644	1397	1275983733000
133645	1678	27360856367000
133646	1397	1275973732000
133647	1678	27360856368000
133648	2133	90579806000
133649	1874	34131000
133650	2134	83981257000
133651	1874	34134000
133652	2133	90578804000
133653	1874	34136000
133654	2134	83980254000
133655	1874	34139000
133656	1394	931694547440200
133657	1394	931694571440200
133666	1573	7059409000000
133667	1573	7059421000000
133886	1397	1275753710000
133887	1678	27360856390000
133888	1397	1275743709000
133889	1678	27360856391000
133890	2134	83959191000
133891	1874	34244000
133892	2133	90556760000
133893	1874	34246000
133894	2134	83958188000
133895	1874	34249000
133896	2133	90555758000
133897	1874	34251000
133898	1402	46983408145435
133899	1402	46983432145435
133950	1397	1275673702000
133951	1678	27360856398000
133952	1397	1275663701000
133953	1678	27360856399000
133954	2134	83951167000
133955	1874	34284000
133956	2134	83950164000
133957	1874	34287000
133958	2133	90548744000
133959	1874	34289000
133960	2133	90547742000
133961	1874	34291000
133962	1564	13326847000000
133963	1564	13326871000000
133980	1397	1275633698000
133981	1678	27360856402000
133982	1397	1275623697000
133983	1678	27360856403000
133984	2133	90544736000
133985	1874	34303000
133986	2134	83947155000
133987	1874	34306000
133988	2133	90543734000
133989	1874	34308000
133990	2134	83946152000
133991	1874	34311000
133992	1444	13767915329999
134021	1874	33794000
134022	1874	33796000
134023	1874	33800000
134024	1874	33802000
134025	1756	9922222195609
134026	1874	33812000
134027	1874	33814000
134028	1874	33816000
134029	1874	33818000
134030	1874	33820000
134031	1874	33822000
134032	1874	33826000
134033	1874	33828000
134034	1874	33842000
134035	1874	33846000
134036	1874	33848000
134037	1874	33852000
134038	1874	33854000
134039	1874	33856000
134040	1874	33862000
134041	1874	33864000
134042	1874	33866000
134043	1874	33878000
134044	1874	33881000
134045	1874	33884000
134046	1874	33893000
134047	1874	33896000
134048	1874	33905000
134049	1874	33908000
134050	1874	33911000
134051	1874	33914000
134052	1874	33920000
134053	1874	33935000
134054	1874	33938000
134055	1874	33941000
134056	1874	33944000
134057	1756	10642222195609
134058	1756	10642289195609
134065	1611	2873488402899
134066	1611	2873499402899
134083	1397	1275553690000
134084	1678	27360856410000
134085	2133	90536720000
134086	1874	34340000
134087	2134	83940134000
134088	1874	34343000
134089	1706	18282270450256
134098	1397	1275533688000
134099	1678	27360856412000
134100	2134	83938128000
134101	1874	34351000
134102	2133	90534716000
134103	1874	34353000
134104	2039	17179684000000
134105	2039	17179696000000
134106	606	79006915286230
134107	606	79006927286230
134121	1397	1275503685000
134122	1678	27360856415000
134123	2133	90531710000
134124	1874	34365000
134125	2134	83935119000
134126	1874	34368000
134127	2134	83934116000
134128	1874	34371000
134129	2133	90530708000
134130	1874	34373000
134131	1394	941774655440200
134132	1394	941774669440200
134140	1397	1275483683000
134141	1678	27360856417000
134142	2133	90528704000
134143	1874	34380000
134144	2134	83932110000
134145	1874	34383000
134146	1447	20441911683000
134155	1397	1275463681000
134156	1678	27360856419000
134157	2134	83930104000
134158	1874	34391000
134159	2133	90526700000
134160	1874	34393000
134161	1711	18427061000000
134162	1711	18427073000000
134172	1397	1275443679000
134173	1678	27360856421000
134174	1397	1275433678000
134175	1678	27360856422000
134176	1397	1275423677000
134177	1678	27360856423000
134178	2133	90524696000
134179	1874	34400000
134180	2134	83928098000
134181	1874	34403000
134182	2134	83927095000
134183	1874	34406000
134184	2134	83926092000
134185	1874	34409000
134186	2133	90523694000
134187	1874	34411000
134188	2133	90522692000
134189	1874	34413000
133786	1874	33701000
133787	1874	33716000
133788	1506	9360464967164
133789	1527	9360487967165
133790	1506	290999959
133814	1397	1275853720000
133815	1678	27360856380000
133816	2133	90566780000
133817	1874	34196000
133818	2134	83968218000
133819	1874	34199000
133822	1397	1275843719000
133823	1678	27360856381000
133824	1397	1275833718000
133825	1678	27360856382000
133826	2134	83967215000
133827	1874	34202000
133828	2133	90565778000
133829	1874	34204000
133830	2133	90564776000
133831	1874	34206000
133832	1672	12241482000000
133841	1397	1275813716000
133842	1678	27360856384000
133843	2134	83965209000
133844	1874	34214000
133845	2133	90562772000
133846	1874	34216000
133850	1397	1275803715000
133851	1678	27360856385000
133852	2134	83964206000
133853	1874	34219000
133854	2133	90561770000
133855	1874	34221000
133856	1685	180724575571430
133900	1675	21164531999977
133901	1675	21164555999977
133911	1397	1275723707000
133912	1678	27360856393000
133913	2133	90553754000
133914	1874	34258000
133915	2134	83956182000
133916	1874	34261000
133917	1685	181444575571430
133918	1685	181444587571430
133940	1397	1275683703000
133941	1678	27360856397000
133942	2133	90549746000
133943	1874	34278000
133944	2134	83952170000
133945	1874	34281000
133946	1694	18539085197225
133947	1694	18539097197225
133964	1397	1275653700000
133965	1678	27360856400000
133966	1397	1275643699000
133967	1678	27360856401000
133968	2134	83949161000
133969	1874	34294000
133970	2133	90546740000
133971	1874	34296000
133972	2134	83948158000
133973	1874	34299000
133974	2133	90545738000
133975	1874	34301000
133976	1394	936014595440200
133977	1394	936014619440200
133993	1397	1275613696000
133994	1678	27360856404000
133995	2133	90542732000
133996	1874	34313000
133997	2134	83945149000
133998	1874	34316000
133999	1394	936014631440200
134000	1394	937454631440200
134001	1706	17562282450256
134002	1706	18282282450256
134005	1397	1275603695000
134006	1678	27360856405000
134007	2134	83944146000
134008	1874	34319000
134009	2133	90541730000
134010	1874	34321000
134011	1608	16698585000000
134012	1608	16698597000000
134075	1397	1275563691000
134076	1678	27360856409000
134077	2133	90537722000
134078	1874	34335000
134079	2134	83941137000
134080	1874	34338000
134081	1610	10800259999950
134133	1395	58291832113957278
134163	1397	1275453680000
134164	1678	27360856420000
134165	2134	83929101000
134166	1874	34396000
134167	2133	90525698000
134168	1874	34398000
134169	1394	943214669440200
134170	1394	943214681440200
134191	1522	12283799000000
134200	1749	1442600529980
134201	1685	182884611571430
134202	1685	182884623571430
134220	1670	12241109000000
134221	1670	12241121000000
134247	1685	182884646571430
134271	171	76747418696494
134272	171	77467418696494
134273	171	77468048696494
134280	1397	1275333668000
134281	1678	27360856432000
134282	1425	1537446000000
134283	1397	1275323667000
134284	1678	27360856433000
134285	1397	1275313666000
134286	1678	27360856434000
134287	1397	1275303665000
134288	1678	27360856435000
134289	1874	34459000
134290	2134	83915059000
134291	1874	34464000
134292	1874	34466000
134293	1874	34468000
134294	2133	90510668000
134295	1874	34470000
134296	1425	2257446000000
134297	1425	2257484000000
134298	1394	944654727440200
134299	1394	946094727440200
134300	1394	946094765440200
134328	1397	1275263661000
134329	1678	27360856439000
134330	2134	83911047000
134331	1874	34488000
134332	2133	90506660000
134333	1874	34490000
134369	576	81197735726897
134370	576	81197741726897
134387	1397	1275183653000
134388	1678	27360856447000
134389	1397	1275173652000
134390	1678	27360856448000
134391	2134	83903023000
134392	1874	34528000
134393	2133	90498644000
134394	1874	34530000
134395	2133	90497642000
134396	1874	34532000
134399	1397	1275163651000
134400	1678	27360856449000
134401	2134	83902020000
134402	1874	34535000
134403	2133	90496640000
134404	1874	34537000
134418	1397	1275133648000
134419	1678	27360856452000
134420	2133	90493634000
134421	1874	34549000
134422	2134	83899011000
134423	1874	34552000
134424	1394	950414795440200
134425	1394	950414807440200
134442	1397	1275103645000
134443	1678	27360856455000
134444	1397	1275093644000
134445	1678	27360856456000
134446	2134	83896002000
134447	1874	34565000
134448	2134	83894999000
134449	1874	34568000
134450	2133	90490628000
134451	1874	34570000
134452	2133	90489626000
134453	1874	34572000
134496	1395	58293272169957278
134497	1395	58293992169957278
134498	2332	58293992183957277
134499	1395	100000001
134514	2134	83887978000
134515	1874	34607000
134516	1688	26710912113019
134517	1688	26710924113019
134518	1706	19002282450256
133925	1705	25761016580140
133926	1397	1275703705000
133927	1678	27360856395000
133928	1397	1275693704000
133929	1678	27360856396000
133930	2134	83954176000
133931	1874	34269000
133932	2133	90551750000
133933	1874	34271000
133934	2133	90550748000
133935	1874	34273000
133936	2134	83953173000
133937	1874	34276000
133938	1685	182164587571430
133939	1685	182164611571430
134013	1397	1275593694000
134014	1678	27360856406000
134015	2133	90540728000
134016	1874	34323000
134017	2134	83943143000
134018	1874	34326000
134019	1394	938894631440200
134020	1394	938894643440200
134073	2329	315366479819988
134074	2329	315366481819988
134082	1610	10800249999950
134108	1397	1275523687000
134109	1678	27360856413000
134110	1397	1275513686000
134111	1678	27360856414000
134112	2133	90533714000
134113	1874	34355000
134114	2134	83937125000
134115	1874	34358000
134116	2133	90532712000
134117	1874	34360000
134118	2134	83936122000
134119	1874	34363000
134120	1489	13343179040000
134134	1397	1275493684000
134135	1678	27360856416000
134136	2133	90529706000
134137	1874	34375000
134138	2134	83933113000
134139	1874	34378000
134192	1397	1275413676000
134193	1678	27360856424000
134194	2133	90521690000
134195	1874	34415000
134196	2134	83925089000
134197	1874	34418000
134209	2329	316086481819988
134210	2329	316086493819988
134222	1397	1275383673000
134223	1678	27360856427000
134224	2133	90518684000
134225	1874	34430000
134226	2134	83922080000
134227	1874	34433000
134228	2306	3599120000000
134274	2133	90511670000
134275	1874	34462000
134276	2134	83916062000
134277	1874	34465000
134278	1692	11980822819983
134279	1692	11980824819983
134301	1874	34467000
134302	1394	946094717440200
134303	1394	946094759440200
134304	1397	1275293664000
134305	1678	27360856436000
134306	2134	83914056000
134307	1874	34473000
134308	2133	90509666000
134309	1874	34475000
134310	1395	58292552111957278
134311	1395	58292552123957278
134326	1688	25270876113019
134327	1688	25270900113019
134361	1397	1275213656000
134362	1678	27360856444000
134363	2133	90501650000
134364	1874	34512000
134365	2134	83906032000
134366	1874	34515000
134367	1394	948974783440200
134368	1394	948974795440200
134412	1397	1275143649000
134413	1678	27360856451000
134414	2133	90494636000
134415	1874	34544000
134416	2134	83900014000
134417	1874	34547000
134468	2329	317526505819988
134469	2329	317526529819988
134473	1397	1275063641000
134474	1678	27360856459000
134475	2133	90486620000
134476	1874	34584000
134477	2134	83891990000
134478	1874	34587000
134479	1705	26481028580140
134480	1705	26481040580140
134522	1610	12240283999950
134550	1457	13680674800000
134551	1397	1274973632000
134552	1678	27360856468000
134553	1874	34417000
134554	1874	34419000
134555	1874	34425000
134556	1874	34427000
134557	1874	34429000
134558	1874	34432000
134559	1874	34438000
134560	1874	34441000
134561	1874	34444000
134562	1874	34447000
134563	1874	34471000
134564	1874	34474000
134565	1874	34480000
134566	1874	34483000
134567	1874	34486000
134568	1874	34489000
134569	1874	34495000
134570	1874	34498000
134571	1874	34501000
134572	1874	34504000
134573	1874	34507000
134574	1874	34513000
134575	1874	34516000
134576	1874	34519000
134577	1874	34531000
134578	1874	34534000
134579	1874	34543000
134580	1874	34546000
134581	2134	83882963000
134582	1874	34558000
134583	1874	34560000
134584	1874	34564000
134585	1874	34566000
134586	1874	34574000
134587	1874	34576000
134588	1874	34578000
134589	1874	34580000
134590	1874	34586000
134591	1874	34588000
134592	1874	34590000
134593	1874	34594000
134594	1874	34596000
134595	1874	34598000
134596	1874	34606000
134597	1874	34608000
134598	1457	14400674800000
134599	1457	14400844800000
134681	1397	1274873622000
134682	1678	27360856478000
134683	2133	90468584000
134684	1874	34674000
134685	2134	83873936000
134686	1874	34677000
134712	1397	1274803615000
134713	1678	27360856485000
134714	1397	1274793614000
134715	1678	27360856486000
134716	2133	90466580000
134717	1874	34684000
134718	2134	83871930000
134719	1874	34687000
134720	2134	83870927000
134721	1874	34690000
134722	2134	83869924000
134723	1874	34693000
134724	2134	83868921000
134725	1874	34696000
134726	2134	83867918000
134727	1874	34699000
134728	2134	83866915000
134729	1874	34702000
134730	2134	83865912000
134731	1874	34705000
134732	2133	90465578000
134733	1874	34707000
134734	2133	90464576000
134735	1874	34709000
134736	2133	90463574000
134190	1394	943214705440200
134198	1749	1442598529980
134199	1749	1442610529980
134212	1397	1275393674000
134213	1678	27360856426000
134214	2134	83923083000
134215	1874	34426000
134216	2133	90519686000
134217	1874	34428000
134218	1394	944654705440200
134219	1394	944654717440200
134229	1397	1275373672000
134230	1678	27360856428000
134231	1397	1275363671000
134232	1678	27360856429000
134233	1397	1275353670000
134234	1678	27360856430000
134235	2133	90517682000
134236	1874	34435000
134237	2133	90516680000
134238	1874	34437000
134239	2134	83921077000
134240	1874	34440000
134241	2134	83920074000
134242	1874	34443000
134243	2133	90515678000
134244	1874	34445000
134245	111	72480102000000
134246	111	72480137000000
134248	1397	1275343669000
134249	1678	27360856431000
134250	2134	83919071000
134251	1874	34448000
134252	2133	90514676000
134253	1874	34450000
134254	697	66720012000000
134257	2134	83918068000
134258	1874	34453000
134259	1692	10540820619999
134260	2134	83917065000
134261	1874	34456000
134262	2133	90513674000
134263	1874	34458000
134264	2133	90512672000
134265	1874	34460000
134266	1692	200000004
134267	1796	11260822819983
134268	697	3500000
134269	1604	66000000499999
134270	1571	9980688124178
134354	1397	1275223657000
134355	1678	27360856443000
134356	2134	83907035000
134357	1874	34508000
134358	2133	90502652000
134359	1874	34510000
134360	1593	16512801000000
134379	1397	1275193654000
134380	1678	27360856446000
134381	2133	90499646000
134382	1874	34522000
134383	2134	83904026000
134384	1874	34525000
134385	1672	12961482000000
134386	1672	12961494000000
134434	1397	1275113646000
134435	1678	27360856454000
134436	2133	90491630000
134437	1874	34559000
134438	2134	83897005000
134439	1874	34562000
134440	1610	11520259999950
134441	1610	11520271999950
134481	1397	1275053640000
134482	1678	27360856460000
134483	1693	11511001570272
134484	1397	1275043639000
134485	1678	27360856461000
134486	2133	90485618000
134487	1874	34589000
134488	2134	83890987000
134489	1874	34592000
134490	2134	83889984000
134491	1874	34595000
134492	2133	90484616000
134493	1874	34597000
134494	1693	12231001570272
134495	1693	12231015570272
134508	1397	1275023637000
134509	1678	27360856463000
134510	2133	90482612000
134511	1874	34604000
134512	1610	12240271999950
134513	1610	12240282999950
134545	1397	1274983633000
134546	1678	27360856467000
134547	2134	83883966000
134548	1874	34625000
134549	1688	26710923113019
134618	1397	1274943629000
134619	1678	27360856471000
134620	2134	83879954000
134621	1874	34643000
134622	1726	954957112000
134623	2374	100000000
134624	2133	90475598000
134625	1874	34645000
134626	1726	953856112000
134627	2375	100000000
134628	1426	14730429000000
134629	1426	14730443000000
134631	1634	16943144259504
134632	1634	16943158259504
134634	1397	1274933628000
134635	1678	27360856472000
134636	2133	90474596000
134637	1874	34647000
134638	2134	83878951000
134639	1874	34650000
134640	1395	58293992171957278
134659	1397	1274903625000
134660	1678	27360856475000
134661	2133	90471590000
134662	1874	34662000
134663	2134	83875942000
134664	1874	34665000
134665	1693	12951015570272
134666	1693	12951027570272
134669	1397	1274893624000
134670	1678	27360856476000
134671	1397	1274883623000
134672	1678	27360856477000
134673	2134	83874939000
134674	1874	34668000
134675	2133	90470588000
134676	1874	34670000
134677	2133	90469586000
134678	1874	34672000
134679	1688	27430923113019
134680	1688	27430946113019
134687	1680	15133389499559
134688	1680	15133401499559
134695	1756	10642869195609
134696	1397	1274853620000
134697	1678	27360856480000
134698	1397	1274843619000
134699	1678	27360856481000
134700	1397	1274833618000
134701	1678	27360856482000
134702	1397	1274823617000
134703	1678	27360856483000
134704	1397	1274813616000
134705	1678	27360856484000
134706	1874	33950000
134707	1874	33953000
134708	1874	33956000
134709	1756	11362869195609
134710	1756	200000010
134711	1807	11363089195608
134746	1395	58294712171957278
134747	1395	58294712255957278
134781	1397	1274763611000
134782	1678	27360856489000
134783	1874	34720000
134784	2134	83862903000
134785	1874	34726000
134786	1874	34728000
134787	1874	34730000
134788	2133	90457562000
134789	1874	34732000
134790	1394	953294819440200
134791	1394	953294855440200
134814	1514	10079700
134815	1670	12241108020000
134816	1670	207000000
134817	2250	12241117020000
134824	1397	1274733608000
134825	1678	27360856492000
134826	1397	1274723607000
134827	1678	27360856493000
134828	2133	90454556000
134829	1874	34744000
134830	2133	90453554000
134831	1874	34746000
134832	2134	83859894000
134338	1397	1275233658000
134339	1678	27360856442000
134340	2133	90505658000
134341	1874	34492000
134342	2133	90504656000
134343	1874	34494000
134344	2134	83910044000
134345	1874	34497000
134346	2134	83909041000
134347	1874	34500000
134348	2134	83908038000
134349	1874	34503000
134350	2133	90503654000
134351	1874	34505000
134352	1395	58293272123957278
134353	1395	58293272159957278
134371	1397	1275203655000
134372	1678	27360856445000
134373	2134	83905029000
134374	1874	34518000
134375	2133	90500648000
134376	1874	34520000
134377	576	81197714726897
134378	576	81197726726897
134397	1681	17854792358535
134398	1681	17854815358535
134405	1397	1275153650000
134406	1678	27360856450000
134407	2134	83901017000
134408	1874	34540000
134409	2133	90495638000
134410	1874	34542000
134411	1675	21164543999977
134426	1397	1275123647000
134427	1678	27360856453000
134428	2134	83898008000
134429	1874	34555000
134430	2133	90492632000
134431	1874	34557000
134432	1596	8640293000002
134433	1596	8640305000002
134454	1397	1275083643000
134455	1678	27360856457000
134456	1397	1275073642000
134457	1678	27360856458000
134458	2134	83893996000
134459	1874	34575000
134460	2133	90488624000
134461	1874	34577000
134462	2133	90487622000
134463	1874	34579000
134464	2134	83892993000
134465	1874	34582000
134466	1395	58293992159957278
134467	1395	58293992183957278
134470	171	77468668696494
134471	171	78188668696494
134472	171	78189298696494
134500	1397	1275033638000
134501	1678	27360856462000
134502	2134	83888981000
134503	1874	34600000
134504	2133	90483614000
134505	1874	34602000
134506	1688	25990900113019
134507	1688	25990912113019
134530	43	79680257890000
134531	1397	1275003635000
134532	1678	27360856465000
134533	1397	1274993634000
134534	1678	27360856466000
134535	2133	90480608000
134536	1874	34614000
134537	2133	90479606000
134538	1874	34616000
134539	2134	83885972000
134540	1874	34619000
134541	2134	83884969000
134542	1874	34622000
134543	2112	25726992101924
134544	2112	25727016101924
134600	1397	1274963631000
134601	1678	27360856469000
134602	1874	34628000
134603	2133	90478604000
134604	1874	34630000
134605	2133	90477602000
134606	1874	34632000
134607	2134	83881960000
134608	1874	34635000
134609	1685	182884635571430
134610	1397	1274953630000
134611	1678	27360856470000
134612	2133	90476600000
134613	1874	34637000
134614	2134	83880957000
134615	1874	34640000
134616	1394	951854807440200
134617	1394	951854819440200
134630	1633	9408661125277
134633	1633	9408649125277
134657	1694	19259097197225
134658	1694	19259122197225
134748	1397	1274783613000
134749	1678	27360856487000
134750	1397	1274773612000
134751	1678	27360856488000
134752	1874	34631000
134753	1874	34634000
134754	1874	34642000
134755	1874	34644000
134756	1874	34646000
134757	1874	34648000
134758	1457	14401060800000
134759	1874	34652000
134760	1874	34654000
134761	1874	34656000
134762	1874	34658000
134763	1874	34664000
134764	1874	34666000
134765	1874	34676000
134766	1874	34678000
134767	1874	34681000
134768	2134	83864909000
134769	1874	34708000
134770	2134	83863906000
134771	1874	34719000
134772	1874	34721000
134773	1874	34723000
134774	2133	90459566000
134775	1874	34725000
134776	2133	90458564000
134777	1874	34727000
134778	1457	15121060800000
134779	1457	200000004
134780	1796	15121093799999
134804	1596	8640317000002
134805	1596	9360317000002
134822	1546	13917553800000
134823	1546	13917565800000
134856	1634	16943156259504
134858	1397	1274693604000
134859	1678	27360856496000
134860	2133	90450548000
134861	1874	34764000
134862	2134	83855882000
134863	1874	34767000
134864	1402	48423456145435
134893	1397	1274643599000
134894	1678	27360856501000
134895	2133	90445538000
134896	1874	34780000
134897	42	75020698000000
134898	42	75020709000000
134911	1395	58295432268957278
134930	1762	11445647994000
134931	1762	11445659994000
134946	1397	1274603595000
134947	1678	27360856505000
134948	2134	83850867000
134949	1874	34798000
134950	2133	90441530000
134951	1874	34800000
134952	1719	17278685000000
134953	1719	17278697000000
134955	1397	1274593594000
134956	1678	27360856506000
134957	2134	83849864000
134958	1874	34803000
134959	2133	90440528000
134960	1874	34805000
134961	43	80400257890000
134962	43	80400269890000
134972	1397	1274573592000
134973	1678	27360856508000
134974	2133	90438524000
134975	1874	34812000
134976	2134	83847858000
134977	1874	34815000
134978	1656	16555581999990
134989	2248	12239534000000
134990	2248	12239546000000
134991	1395	58297592292957278
134992	1395	58297592304957278
135024	1874	34686000
134519	1706	19002294450256
134520	1643	5468694914700
134521	1643	5468696914700
134523	1397	1275013636000
134524	1678	27360856464000
134525	2134	83886975000
134526	1874	34610000
134527	2133	90481610000
134528	1874	34612000
134529	1422	13914732804270
134641	1397	1274923627000
134642	1678	27360856473000
134643	1397	1274913626000
134644	1678	27360856474000
134645	2134	83877948000
134646	1874	34653000
134647	1726	952755112000
134648	2376	100000000
134649	2133	90473594000
134650	1874	34655000
134651	2133	90472592000
134652	1874	34657000
134653	2134	83876945000
134654	1874	34660000
134655	1571	10700688124178
134656	1571	10700713124178
134667	58	77507553999641
134668	58	77507565999641
134689	1397	1274863621000
134690	1678	27360856479000
134691	2134	83872933000
134692	1874	34680000
134693	2133	90467582000
134694	1874	34682000
134792	1395	58295432255957278
134793	1395	58295432291957278
134796	1397	1274753610000
134797	1678	27360856490000
134798	2134	83861900000
134799	1874	34735000
134800	2133	90456560000
134801	1874	34737000
134802	1671	16944306003785
134803	1671	17664306003785
134818	1546	13917552820000
134819	2250	13917560420000
134820	1546	206000000
134821	1449	8055416459
134846	1397	1274703605000
134847	1678	27360856495000
134848	2133	90451550000
134849	1874	34759000
134850	2134	83856885000
134851	1874	34762000
134852	633	80109530900000
134853	633	80109542900000
134887	1397	1274653600000
134888	1678	27360856500000
134889	2133	90446540000
134890	1874	34778000
134891	1706	19722294450256
134892	1706	19722305450256
134909	1402	49143456145435
134910	1402	49143469145435
134912	1397	1274623597000
134913	1678	27360856503000
134914	2134	83852873000
134915	1874	34788000
134916	2133	90443534000
134917	1874	34790000
134918	1395	58296152268957278
134919	1395	58296152280957278
134922	1397	1274613596000
134923	1678	27360856504000
134924	2134	83851870000
134925	1874	34793000
134926	2133	90442532000
134927	1874	34795000
134928	2261	11519334000000
134929	2261	11519346000000
134933	1687	8769786848312
134934	1874	34374000
134935	1874	34377000
134936	1874	34389000
134937	1874	34392000
134938	1874	34395000
134939	1874	34397000
134940	1874	34399000
134941	1874	34401000
134942	1874	34405000
134943	1874	34407000
134944	1687	9489786848312
134945	1687	9489931848312
134979	1395	58296872280957278
134980	1395	58296872292957278
134993	1692	12700824819983
135045	1709	10800244000000
135046	1709	10800256000000
135062	1397	1274523587000
135063	1678	27360856513000
135064	2133	90433514000
135065	1874	34837000
135066	2134	83842843000
135067	1874	34840000
135070	1397	1274513586000
135071	1678	27360856514000
135072	2133	90432512000
135073	1874	34842000
135074	2134	83841840000
135075	1874	34845000
134737	1874	34711000
134738	2133	90462572000
134739	1874	34713000
134740	2133	90461570000
134741	1874	34715000
134742	2133	90460568000
134743	1874	34717000
134744	1402	48423444145435
134745	1402	48423528145435
134794	2301	1439000000000
134795	2301	1439036000000
134806	1397	1274743609000
134807	1678	27360856491000
134808	2134	83860897000
134809	1874	34740000
134810	2133	90455558000
134811	1874	34742000
134812	1394	954734855440200
134813	1394	954734867440200
134840	1397	1274713606000
134841	1678	27360856494000
134842	2134	83857888000
134843	1874	34755000
134844	2133	90452552000
134845	1874	34757000
134865	1874	34765000
134866	1611	3593499402899
134867	1611	3593510402899
134920	2261	10799335000000
134921	2261	11519334900000
134932	1673	10295459000000
134954	1688	28150958113019
134963	1397	1274583593000
134964	1678	27360856507000
134965	2133	90439526000
134966	1874	34807000
134967	2134	83848861000
134968	1874	34810000
134971	1656	16555569999990
134981	1397	1274563591000
134982	1678	27360856509000
134983	2134	83846855000
134984	1874	34818000
134985	1679	12958272656999
134986	1679	12958283656999
134994	1397	1274553590000
134995	1678	27360856510000
134996	2133	90436520000
134997	1874	34822000
134998	2134	83845852000
134999	1874	34825000
135000	1394	956174903440200
135047	1397	1274543589000
135048	1678	27360856511000
135049	1397	1274533588000
135050	1678	27360856512000
135051	2133	90435518000
135052	1874	34827000
135053	2133	90434516000
135054	1874	34829000
135055	2134	83844849000
135056	1874	34832000
135057	2134	83843846000
135058	1874	34835000
135059	1991	15741473355805
135060	1991	15741497355805
135068	1395	58298312304957278
135069	1395	58298312316957278
135076	1489	14063179040000
135077	1489	14063191040000
135111	1874	34722000
135112	1874	34724000
135113	1874	34734000
135114	1874	34736000
135115	1874	34738000
135116	1692	14860950719970
135117	1449	14860960668970
135118	1692	8053067459
135141	1397	1274443579000
135142	1678	27360856521000
135143	2134	83833816000
135144	1874	34881000
135145	1394	957614903440200
135146	1394	957614914440200
134833	1874	34749000
134834	2134	83858891000
134835	1874	34752000
134836	1688	28150946113019
134837	1688	28150970113019
134838	1724	14092772500000
134839	1724	14092796500000
134854	1419	25486203559748
134855	1419	25486215559748
134857	1419	25486213559748
134868	1397	1274683603000
134869	1678	27360856497000
134870	1397	1274673602000
134871	1678	27360856498000
134872	1397	1274663601000
134873	1678	27360856499000
134874	2134	83854879000
134875	1874	34770000
134876	1726	951654112000
134877	2377	100000000
134878	1726	950553112000
134879	2378	100000000
134880	2133	90449546000
134881	1874	34772000
134882	2133	90448544000
134883	1874	34774000
134884	2133	90447542000
134885	1874	34776000
134886	1394	954734891440200
134899	1397	1274633598000
134900	1678	27360856502000
134901	2133	90444536000
134902	1874	34782000
134903	2134	83853876000
134904	1874	34785000
134905	1726	949452112000
134906	2379	100000000
134907	1394	956174891440200
134908	1394	956174904440200
134969	1693	13671027570272
134970	1693	13671039570272
134987	2133	90437522000
134988	1874	34820000
135001	1874	34506000
135002	1874	34509000
135003	1874	34521000
135004	1874	34524000
135005	1874	34527000
135006	1874	34533000
135007	1874	34536000
135008	1874	34539000
135009	1874	34545000
135010	1874	34548000
135011	1874	34551000
135012	1874	34554000
135013	1874	34563000
135014	1874	34569000
135015	1874	34581000
135016	1874	34618000
135017	1874	34620000
135018	1874	34624000
135019	1874	34626000
135020	1874	34636000
135021	1874	34638000
135022	1692	13420824819983
135023	1692	13420914819983
135086	1397	1274493584000
135087	1678	27360856516000
135088	1397	1274483583000
135089	1678	27360856517000
135090	1397	1274473582000
135091	1678	27360856518000
135092	2134	83839834000
135093	1874	34853000
135094	2134	83838831000
135095	1874	34856000
135096	2133	90430508000
135097	1874	34858000
135098	2134	83837828000
135099	1874	34861000
135100	2133	90429506000
135101	1874	34863000
135102	2133	90428504000
135103	1874	34865000
135104	1571	11420713124178
135105	1571	11420749124178
135119	1271	1349887454000000
135120	1397	1274463581000
135121	1678	27360856519000
135122	1874	34349000
135123	1874	34352000
135124	1874	34361000
135125	1874	34364000
135126	1874	34367000
135127	1874	34370000
135128	1271	1350607454000000
135129	1271	100000027
135130	1520	1350607588999983
135147	1587	16560490000000
135025	1874	34688000
135026	1692	13420938819983
135027	1874	34692000
135028	1874	34694000
135029	1874	34698000
135030	1874	34700000
135031	1874	34704000
135032	1874	34706000
135033	1874	34710000
135034	1874	34712000
135035	1874	34714000
135036	1874	34716000
135037	1874	34718000
135038	1692	14140938819983
135039	1655	205000000
135040	2250	1000000
135041	2252	14140950719970
135042	1692	200500000
135043	1527	9099714
135044	1514	290999959
135061	1474	15030655000043
135078	1397	1274503585000
135079	1678	27360856515000
135080	2134	83840837000
135081	1874	34848000
135082	2133	90431510000
135083	1874	34850000
135084	2039	17899696000000
135085	2039	17899708000000
135106	2133	90427502000
135107	1874	34867000
135108	2134	83836825000
135109	1874	34870000
135110	1594	16561901000000
135131	1397	1274453580000
135132	1678	27360856520000
135133	2134	83835822000
135134	1874	34873000
135135	2134	83834819000
135136	1874	34876000
135137	2133	90426500000
135138	1874	34878000
135139	2302	2159000000000
135140	2302	2159023000000
135148	1555	16086251540449
135149	1692	15580960668970
135150	1692	15580961668970
135151	1397	1274433578000
135152	1678	27360856522000
135153	2134	83832813000
135154	1874	34884000
135155	1719	17998697000000
135156	1719	17998708000000
135157	2039	18619708000000
135158	2039	18619719000000
135159	1397	1274423577000
135160	1678	27360856523000
135161	2134	83831810000
135162	1874	34887000
135163	149	79055419000341
135164	149	79055430000341
135165	1688	28150957113019
135166	1397	1274413576000
135167	1678	27360856524000
135168	1397	1274403575000
135169	1678	27360856525000
135170	2134	83830807000
135171	1874	34890000
135172	2134	83829804000
135173	1874	34893000
135174	1395	58298312326957278
135175	2133	90425498000
135176	1874	34883000
135177	1740	14850847000000
135178	1740	14850848000000
135179	1397	1274393574000
135180	1678	27360856526000
135181	1874	34895000
135182	2134	83828801000
135183	1874	34898000
135184	1740	14850859000000
135185	1397	1274383573000
135186	1678	27360856527000
135187	1397	1274373572000
135188	1678	27360856528000
135189	2133	90424496000
135190	1874	34900000
135191	2134	83827798000
135192	1874	34903000
135193	2133	90423494000
135194	1874	34905000
135195	2134	83826795000
135196	1874	34908000
135197	1708	13320646500051
135198	1708	13320670500051
135199	1555	16086264540449
135200	1397	1274363571000
135201	1678	27360856529000
135202	2134	83825792000
135203	1874	34911000
135204	2133	90422492000
135205	1874	34913000
135206	1397	1274353570000
135207	1678	27360856530000
135208	2134	83824789000
135209	1874	34916000
135210	2133	90421490000
135211	1874	34918000
135212	484	75453947000000
135213	484	75453959000000
135214	1508	16040459156616
135215	1508	16040471156616
135216	1397	1274343569000
135217	1678	27360856531000
135218	1397	1274333568000
135219	1678	27360856532000
135220	2134	83823786000
135221	1874	34921000
135222	2133	90420488000
135223	1874	34923000
135224	2133	90419486000
135225	1874	34925000
135226	2134	83822783000
135227	1874	34928000
135228	1395	58299032326957278
135229	1395	58299032350957278
135230	1397	1274323567000
135231	1678	27360856533000
135232	2134	83821780000
135233	1874	34931000
135234	2133	90418484000
135235	1874	34933000
135236	1397	1274313566000
135237	1678	27360856534000
135238	2134	83820777000
135239	1874	34936000
135240	2133	90417482000
135241	1874	34938000
135242	1696	21323824335104
135243	1696	21323836335104
135244	1559	12546200999999
135245	1559	12546212999999
135246	1397	1274303565000
135247	1678	27360856535000
135248	2134	83819774000
135249	1874	34941000
135250	2133	90416480000
135251	1874	34943000
135252	633	80829542900000
135253	633	80829554900000
135254	1657	9361396990100
135255	1657	9361408990100
135256	1717	17821354000055
135257	1717	17821366000055
135258	1686	16232140700123
135259	1686	16232152700123
135260	1397	1274293564000
135261	1678	27360856536000
135262	2134	83818771000
135263	1874	34946000
135264	2133	90415478000
135265	1874	34948000
135266	1688	28870958113019
135267	1688	28870970113019
135268	1397	1274283563000
135269	1678	27360856537000
135270	2133	90414476000
135271	1874	34950000
135272	2134	83817768000
135273	1874	34953000
135274	1679	12958284656999
135275	1397	1274273562000
135276	1678	27360856538000
135277	2134	83816765000
135278	1874	34956000
135279	2133	90413474000
135280	1874	34958000
135281	1679	13678284656999
135282	1679	13678296656999
135283	1397	1274263561000
135284	1678	27360856539000
135285	1397	1274253560000
135286	1678	27360856540000
135287	2134	83815762000
135288	1874	34961000
135289	2134	83814759000
135290	1874	34964000
135291	2133	90412472000
135292	1874	34966000
135293	2133	90411470000
135294	1874	34968000
135295	1668	13473783000000
135311	1394	959054915440200
135312	1394	959054927440200
135359	1513	35281215000000
135365	1508	16760471156616
135366	1508	16760483156616
135384	1397	1274143549000
135385	1678	27360856551000
135386	1751	1439011000000
135387	1454	0
135388	2133	90400448000
135389	1874	35020000
135390	2134	83803726000
135391	1874	35023000
135392	1688	29590970113019
135393	1688	29590983113019
135404	1397	1274123547000
135405	1678	27360856553000
135406	1397	1274113546000
135407	1678	27360856554000
135408	1397	1274103545000
135409	1678	27360856555000
135410	2134	83801720000
135411	1874	35031000
135412	2133	90398444000
135413	1874	35033000
135414	2133	90397442000
135415	1874	35035000
135416	2133	90396440000
135417	1874	35037000
135418	2134	83800717000
135419	1874	35040000
135420	2134	83799714000
135421	1874	35043000
135422	1693	14391039570272
135423	1693	14391075570272
135488	1397	1274013536000
135489	1678	27360856564000
135490	2134	83790687000
135491	1874	35086000
135492	2133	90387422000
135493	1874	35088000
135494	1679	15838320656999
135495	1679	15838332656999
135496	1402	49143468145435
135561	1691	11951132300052
135562	1691	11951168300052
135635	1397	1273823517000
135636	1678	27360856583000
135637	2134	83771630000
135638	1874	35181000
135639	2133	90368384000
135640	1874	35183000
135641	1662	1440032000000
135644	1874	34748000
135645	1874	34750000
135646	1874	34754000
135647	1874	34756000
135648	1874	34758000
135649	1874	34760000
135650	1874	34766000
135651	1874	34768000
135652	1874	34784000
135653	1874	34786000
135654	1874	34792000
135655	1874	34794000
135656	1874	34796000
135657	1874	34802000
135658	1874	34804000
135659	1874	34806000
135660	1874	34808000
135661	1874	34814000
135662	1874	34816000
135663	1874	34824000
135664	1874	34826000
135665	1874	34828000
135666	1874	34830000
135667	1874	34834000
135668	1874	34836000
135669	1874	34838000
135670	1874	34844000
135671	1874	34846000
135672	1874	34852000
135673	1874	34854000
135674	1692	16300961668970
135675	1692	16301023668970
135688	2106	4320186000000
135689	2106	4320198000000
135741	1397	1273723507000
135742	1678	27360856593000
135743	1397	1273713506000
135744	1678	27360856594000
135745	2134	83761600000
135746	1874	35231000
135747	2133	90358364000
135748	1874	35233000
135749	2133	90357362000
135750	1874	35235000
135751	2134	83760597000
135752	1874	35238000
135754	1397	1273703505000
135755	1678	27360856595000
135756	2134	83759594000
135757	1874	35241000
135758	2133	90356360000
135759	1874	35243000
135770	1397	1273683503000
135771	1678	27360856597000
135772	1397	1273673502000
135773	1678	27360856598000
135774	1397	1273663501000
135775	1678	27360856599000
135776	2134	83757588000
135777	1874	35251000
135778	2133	90354356000
135779	1874	35253000
135780	2134	83756585000
135781	1874	35256000
135782	2134	83755582000
135783	1874	35259000
135784	2133	90353354000
135785	1874	35261000
135786	2133	90352352000
135787	1874	35263000
135788	1695	12185177999000
135789	1695	12185213999000
135792	1397	1273653500000
135793	1678	27360856600000
135794	2133	90351350000
135795	1874	35265000
135796	2134	83754579000
135797	1874	35268000
135800	1703	6480920000000
135815	1394	960494951440200
135816	1675	21884567999977
135817	1397	1273623497000
135818	1678	27360856603000
135819	1397	1273613496000
135820	1678	27360856604000
135821	2134	83751570000
135822	1874	35281000
135823	2133	90348344000
135824	1874	35283000
135825	2134	83750567000
135826	1874	35286000
135827	2133	90347342000
135828	1874	35288000
135829	2329	318966541819988
135830	2329	318966565819988
135898	1397	1273503485000
135899	1678	27360856615000
135900	2134	83739534000
135901	1874	35341000
135902	2133	90336320000
135903	1874	35343000
135904	1395	58301912386957278
135905	1395	58301912398957278
135915	1397	1273483483000
135916	1678	27360856617000
135917	2134	83737528000
135918	1874	35351000
135919	2133	90334316000
135920	1874	35353000
135921	1705	27201040580140
135922	1705	27201052580140
135951	1448	12919889000001
135952	1448	12919901000001
135953	1397	1273443479000
135954	1678	27360856621000
135955	2134	83733516000
135956	1874	35371000
135957	2133	90330308000
135958	1874	35373000
135959	633	81549581900000
135960	633	81549593900000
135965	1439	13663875578477
135966	1439	13663887578477
136041	1703	7200920000000
136042	1703	7200956000000
135296	1397	1274243559000
135297	1678	27360856541000
135298	2134	83813756000
135299	1874	34971000
135300	2133	90410468000
135301	1874	34973000
135302	1394	957614915440200
135327	1397	1274203555000
135328	1678	27360856545000
135329	2134	83809744000
135330	1874	34991000
135331	2133	90406460000
135332	1874	34993000
135333	1685	183604635571430
135334	1685	183604647571430
135360	1432	1441025000000
135361	1508	16759471156616
135362	1508	16759483156616
135374	1594	17281901000000
135375	1594	17281913000000
135394	1397	1274133548000
135395	1678	27360856552000
135396	2134	83802723000
135397	1874	35026000
135398	2133	90399446000
135399	1874	35028000
135400	1688	30310983113019
135401	1688	30310995113019
135440	1397	1274073542000
135441	1678	27360856558000
135442	2133	90393434000
135443	1874	35055000
135444	2134	83796705000
135445	1874	35058000
135446	149	79775430000341
135447	149	79775442000341
135448	1675	21884543999977
135449	1675	21884555999977
135452	1397	1274063541000
135453	1678	27360856559000
135454	1397	1274053540000
135455	1678	27360856560000
135456	2133	90392432000
135457	1874	35060000
135458	2134	83795702000
135459	1874	35063000
135460	2134	83794699000
135461	1874	35066000
135462	2133	90391430000
135463	1874	35068000
135464	1693	15111075570272
135465	1693	15111099570272
135474	1397	1274033538000
135475	1678	27360856562000
135476	2134	83792693000
135477	1874	35076000
135478	2133	90389426000
135479	1874	35078000
135480	1679	15118308656999
135481	1679	15118320656999
135498	1397	1274003535000
135499	1678	27360856565000
135500	2134	83789684000
135501	1874	35091000
135502	2133	90386420000
135503	1874	35093000
135504	1395	58300472362957278
135505	1395	58300472374957278
135540	1397	1273943529000
135541	1678	27360856571000
135542	1397	1273933528000
135543	1678	27360856572000
135544	1397	1273923527000
135545	1678	27360856573000
135546	2134	83783666000
135547	1874	35121000
135548	2134	83782663000
135549	1874	35124000
135550	2134	83781660000
135551	1874	35127000
135552	2133	90380408000
135553	1874	35129000
135554	2133	90379406000
135555	1874	35131000
135556	2133	90378404000
135557	1874	35133000
135558	1679	15838356656999
135617	1397	1273843519000
135618	1678	27360856581000
135619	2133	90370388000
135620	1874	35170000
135621	2134	83773636000
135622	1874	35173000
135623	1549	14111432000000
135624	1549	14111444000000
135642	1587	17280490000000
135643	1587	17280502000000
135753	1395	58301192398957278
135831	1397	1273603495000
135832	1678	27360856605000
135833	2134	83749564000
135834	1874	35291000
135835	2133	90346340000
135836	1874	35293000
135837	1649	13431621999968
135884	1397	1273523487000
135885	1678	27360856613000
135886	2134	83741540000
135887	1874	35331000
135888	2133	90338324000
135889	1874	35333000
135890	623	67439940000000
135891	623	67439952000000
135908	1397	1273493484000
135909	1678	27360856616000
135910	2133	90335318000
135911	1874	35345000
135912	2134	83738531000
135913	1874	35348000
135914	1633	9408659125277
135923	1397	1273473482000
135924	1678	27360856618000
135925	2134	83736525000
135926	1874	35356000
135927	2133	90333314000
135928	1874	35358000
135929	1448	12199877000001
135930	1448	12199889000001
135931	1397	1273463481000
135932	1678	27360856619000
135933	2134	83735522000
135934	1874	35361000
135935	2133	90332312000
135936	1874	35363000
135937	1723	13682119085979
135938	1723	13682131085979
135961	1394	961934939440200
135962	1394	961934951440200
135967	1397	1273433478000
135968	1678	27360856622000
135969	1397	1273423477000
135970	1678	27360856623000
135971	1397	1273413476000
135972	1678	27360856624000
135973	2134	83732513000
135974	1874	35376000
135975	2133	90329306000
135976	1874	35378000
135977	2133	90328304000
135978	1874	35380000
135979	2134	83731510000
135980	1874	35383000
135981	2134	83730507000
135982	1874	35386000
135983	2133	90327302000
135984	1874	35388000
135985	1394	961934975440200
136059	1740	16290871000000
136060	1740	16290883000000
136077	1717	18541354000055
136078	1717	18541366000055
136092	1397	1273323467000
136093	1678	27360856633000
136094	1397	1273313466000
136095	1678	27360856634000
136096	2133	90318284000
136097	1874	35430000
136098	2133	90317282000
136099	1874	35432000
136100	2134	83721480000
136101	1874	35435000
136102	2134	83720477000
136103	1874	35438000
136104	1506	7920240967172
136110	1397	1273303465000
136111	1678	27360856635000
136112	1708	12600656500051
136113	2134	83719474000
136114	1874	35441000
136115	2133	90316280000
136116	1874	35443000
136117	1708	13320656500051
136118	1568	200000005
136119	1796	225000
136120	1708	200005380
135303	1397	1274233558000
135304	1678	27360856542000
135305	2134	83812753000
135306	1874	34976000
135307	2133	90409466000
135308	1874	34978000
135309	1679	14398296656999
135310	1679	14398308656999
135326	1610	12240295999950
135349	1599	13977021097983
135350	1599	14697021097983
135367	1397	1274163551000
135368	1678	27360856549000
135369	2133	90402452000
135370	1874	35010000
135371	2134	83805732000
135372	1874	35013000
135373	1547	11514840000000
135402	1714	16845771171760
135403	1714	16845783171760
135432	1397	1274083543000
135433	1678	27360856557000
135434	2133	90394436000
135435	1874	35050000
135436	2134	83797708000
135437	1874	35053000
135438	58	78227565999641
135439	58	78227577999641
135466	1397	1274043539000
135467	1678	27360856561000
135468	2133	90390428000
135469	1874	35070000
135470	2134	83793696000
135471	1874	35073000
135472	1395	58299752350957278
135473	1395	58299752362957278
135497	1474	15030643000043
135506	497	67440035000000
135527	1397	1273963531000
135528	1678	27360856569000
135529	1397	1273953530000
135530	1678	27360856570000
135531	2133	90382412000
135532	1874	35110000
135533	2133	90381410000
135534	1874	35112000
135535	2134	83785672000
135536	1874	35115000
135537	2134	83784669000
135538	1874	35118000
135539	1402	49143480145435
135560	1619	9360257000000
135563	1397	1273913526000
135564	1678	27360856574000
135565	1397	1273903525000
135566	1678	27360856575000
135567	1397	1273893524000
135568	1678	27360856576000
135569	2133	90377402000
135570	1874	35135000
135571	2133	90376400000
135572	1874	35137000
135573	2133	90375398000
135574	1874	35139000
135575	2134	83780657000
135576	1874	35142000
135577	2134	83779654000
135578	1874	35145000
135579	2134	83778651000
135580	1874	35148000
135581	497	66719022000000
135582	657	66001000000000
135583	497	66718021000000
135584	590	66001000000000
135585	633	80109580900000
135586	497	66717020000000
135587	553	66001000000000
135588	633	80829580900000
135589	633	80829581900000
135609	1397	1273853520000
135610	1678	27360856580000
135611	2134	83774639000
135612	1874	35166000
135613	2133	90371390000
135614	1874	35168000
135615	1740	15570859000000
135616	1740	15570871000000
135625	1397	1273833518000
135626	1678	27360856582000
135627	2134	83772633000
135628	1874	35176000
135629	2133	90369386000
135630	1874	35178000
135631	1726	948351112000
135632	2380	100000000
135633	1610	12960295999950
135634	1610	12960308999950
135682	1397	1273803515000
135683	1678	27360856585000
135684	2133	90366380000
135685	1874	35190000
135686	2134	83769624000
135687	1874	35193000
135698	1395	58301192374957278
135699	1395	58301192386957278
135740	1709	10800304000000
135768	369	80916633290830
135769	369	80916645290830
135801	1397	1273643499000
135802	1678	27360856601000
135803	1397	1273633498000
135804	1678	27360856602000
135805	2133	90350348000
135806	1874	35270000
135807	2133	90349346000
135808	1874	35272000
135809	2134	83753576000
135810	1874	35275000
135811	2134	83752573000
135812	1874	35278000
135813	1679	17278416656999
135814	1679	17278440656999
135870	1397	1273543489000
135871	1678	27360856611000
135872	1397	1273533488000
135873	1678	27360856612000
135874	2134	83743546000
135875	1874	35321000
135876	2133	90340328000
135877	1874	35323000
135878	2134	83742543000
135879	1874	35326000
135880	2133	90339326000
135881	1874	35328000
135882	58	78947577999641
135883	58	78947601999641
135892	1397	1273513486000
135893	1678	27360856614000
135894	2134	83740537000
135895	1874	35336000
135896	2133	90337322000
135897	1874	35338000
135941	42	75740709000000
135942	42	75740721000000
135943	1397	1273453480000
135944	1678	27360856620000
135945	2134	83734519000
135946	1874	35366000
135947	2133	90331310000
135948	1874	35368000
135949	1426	15450443000000
135950	1426	15450455000000
136022	1397	1273403475000
136023	1678	27360856625000
136024	1397	1273393474000
136025	1678	27360856626000
136026	1397	1273383473000
136027	1678	27360856627000
136028	2133	90326300000
136029	1874	35390000
136030	2133	90325298000
136031	1874	35392000
136032	2133	90324296000
136033	1874	35394000
136034	2134	83729504000
136035	1874	35397000
136036	2134	83728501000
136037	1874	35400000
136038	2134	83727498000
136039	1874	35403000
136040	1702	7200581000000
136043	1397	1273373472000
136044	1678	27360856628000
136045	2133	90323294000
136046	1874	35405000
136047	2134	83726495000
136048	1874	35408000
136057	1394	963374975440200
136058	1394	963374987440200
136067	1397	1273343469000
136068	1678	27360856631000
136069	2134	83723486000
136070	1874	35421000
136071	2133	90320288000
136072	1874	35423000
135313	1397	1274223557000
135314	1678	27360856543000
135315	1397	1274213556000
135316	1678	27360856544000
135317	2133	90408464000
135318	1874	34980000
135319	2133	90407462000
135320	1874	34982000
135321	2134	83811750000
135322	1874	34985000
135323	2134	83810747000
135324	1874	34988000
135325	1394	959054939440200
135335	1397	1274193554000
135336	1678	27360856546000
135337	1397	1274183553000
135338	1678	27360856547000
135339	2133	90405458000
135340	1874	34995000
135341	2133	90404456000
135342	1874	34997000
135343	2134	83808741000
135344	1874	35000000
135345	2134	83807738000
135346	1874	35003000
135347	1555	16086288540449
135348	1555	16806288540449
135351	1397	1274173552000
135352	1678	27360856548000
135353	2133	90403454000
135354	1874	35005000
135355	2134	83806735000
135356	1874	35008000
135357	1768	24227138110000
135358	1768	24227150110000
135363	1759	11016294139889
135364	1759	11016306139889
135376	1397	1274153550000
135377	1678	27360856550000
135378	2134	83804729000
135379	1874	35016000
135380	2133	90401450000
135381	1874	35018000
135382	1571	12140749124178
135383	1571	12140761124178
135424	1397	1274093544000
135425	1678	27360856556000
135426	2134	83798711000
135427	1874	35046000
135428	2133	90395438000
135429	1874	35048000
135430	1719	18718708000000
135431	1719	18718720000000
135450	1673	11015459000000
135451	1673	11015471000000
135482	1397	1274023537000
135483	1678	27360856563000
135484	2134	83791690000
135485	1874	35081000
135486	2133	90388424000
135487	1874	35083000
135507	1397	1273993534000
135508	1678	27360856566000
135509	1397	1273983533000
135510	1678	27360856567000
135511	1397	1273973532000
135512	1678	27360856568000
135513	2133	90385418000
135514	1874	35095000
135515	2133	90384416000
135516	1874	35097000
135517	2134	83788681000
135518	1874	35100000
135519	2134	83787678000
135520	1874	35103000
135521	2134	83786675000
135522	1874	35106000
135523	2133	90383414000
135524	1874	35108000
135525	1654	18137546999798
135526	1654	18137582999798
135559	2261	11519370000000
135590	1397	1273883523000
135591	1678	27360856577000
135592	1397	1273873522000
135593	1678	27360856578000
135594	1397	1273863521000
135595	1678	27360856579000
135596	2133	90374396000
135597	1874	35150000
135598	2133	90373394000
135599	1874	35152000
135600	2133	90372392000
135601	1874	35154000
135602	2134	83777648000
135603	1874	35157000
135604	2134	83776645000
135605	1874	35160000
135606	2134	83775642000
135607	1874	35163000
135608	1634	16943180259504
135676	1397	1273813516000
135677	1678	27360856584000
135678	2134	83770627000
135679	1874	35186000
135680	2133	90367382000
135681	1874	35188000
135690	1397	1273793514000
135691	1678	27360856586000
135692	2134	83768621000
135693	1874	35196000
135694	2133	90365378000
135695	1874	35198000
135696	1608	17418597000000
135697	1608	17418609000000
135700	1397	1273783513000
135701	1678	27360856587000
135702	2134	83767618000
135703	1874	35201000
135704	2133	90364376000
135705	1874	35203000
135706	2329	318246529819988
135707	2329	318246541819988
135708	1397	1273773512000
135709	1678	27360856588000
135710	1397	1273763511000
135711	1678	27360856589000
135712	1397	1273753510000
135713	1678	27360856590000
135714	1397	1273743509000
135715	1678	27360856591000
135716	1397	1273733508000
135717	1678	27360856592000
135718	2133	90363374000
135719	1874	35205000
135720	2133	90362372000
135721	1874	35207000
135722	2134	83766615000
135723	1874	35210000
135724	2134	83765612000
135725	1874	35213000
135726	2134	83764609000
135727	1874	35216000
135728	2134	83763606000
135729	1874	35219000
135730	2134	83762603000
135731	1874	35222000
135732	2133	90361370000
135733	1874	35224000
135734	2133	90360368000
135735	1874	35226000
135736	2133	90359366000
135737	1874	35228000
135738	1679	16558356656999
135739	1679	16558416656999
135760	1397	1273693504000
135761	1678	27360856596000
135762	2133	90355358000
135763	1874	35245000
135764	2134	83758591000
135765	1874	35248000
135766	1394	960494927440200
135767	1394	960494939440200
135790	1685	184324647571430
135791	1685	184324683571430
135798	1702	7200545000000
135799	1702	7200557000000
135838	1397	1273593494000
135839	1678	27360856606000
135840	1397	1273583493000
135841	1678	27360856607000
135842	1397	1273573492000
135843	1678	27360856608000
135844	1397	1273563491000
135845	1678	27360856609000
135846	1397	1273553490000
135847	1678	27360856610000
135848	2134	83748561000
135849	1874	35296000
135850	2134	83747558000
135851	1874	35299000
135852	2134	83746555000
135853	1874	35302000
135854	2134	83745552000
135855	1874	35305000
135856	2134	83744549000
135857	1874	35308000
135858	2133	90345338000
135859	1874	35310000
135860	2133	90344336000
135861	1874	35312000
135862	2133	90343334000
135863	1874	35314000
135864	2133	90342332000
135865	1874	35316000
135866	2133	90341330000
135867	1874	35318000
135868	1402	49863480145435
135869	1402	49863540145435
135906	1701	15118384500103
135907	1701	15118396500103
135939	1419	26206215559748
135940	1419	26206227559748
135963	1447	21161911683000
135964	1447	21161923683000
135986	1448	12919925000001
135987	2106	4320222000000
135988	1874	34860000
135989	1874	34862000
135990	1874	34864000
135991	1874	34866000
135992	1874	34868000
135993	1874	34872000
135994	1874	34874000
135995	1874	34880000
135996	1874	34882000
135997	1874	34886000
135998	1874	34888000
135999	1874	34892000
136000	1874	34894000
136001	1874	34896000
136002	1874	34902000
136003	1874	34904000
136004	1874	34906000
136005	1874	34910000
136006	1874	34912000
136007	1874	34914000
136008	1692	16301052668970
136009	1874	34920000
136010	1874	34922000
136011	1874	34924000
136012	1874	34926000
136013	1874	34930000
136014	1874	34932000
136015	1874	34934000
136016	1692	17021052668970
136017	1692	100000028
136018	1520	17021063668958
136019	1527	200000012
136020	1807	291999958
136021	1571	9980688124186
136049	1397	1273363471000
136050	1678	27360856629000
136051	2134	83725492000
136052	1874	35411000
136053	2133	90322292000
136054	1874	35413000
136055	58	79667601999641
136056	58	79667613999641
136061	1397	1273353470000
136062	1678	27360856630000
136063	2133	90321290000
136064	1874	35415000
136065	2134	83724489000
136066	1874	35418000
136079	576	81917726726897
136080	576	81917738726897
136081	1397	1273333468000
136082	1678	27360856632000
136083	2134	83722483000
136084	1874	35426000
136085	2133	90319286000
136086	1874	35428000
136087	1710	16074096664140
136088	1710	16074108664140
136105	2307	4319110000000
136124	1397	1273293464000
136125	1678	27360856636000
136126	1397	1273283463000
136127	1678	27360856637000
136128	2134	83718471000
136129	1874	35446000
136130	2133	90315278000
136131	1874	35448000
136132	2134	83717468000
136133	1874	35451000
136134	2133	90314276000
136135	1874	35453000
136136	1394	966254999440200
136137	1394	966255023440200
136143	2106	4320210000000
136174	1474	15750643000043
136175	1474	15750655000043
136225	1397	1273203455000
136226	1678	27360856645000
136227	2134	83709444000
136228	1874	35491000
136229	2133	90306260000
136230	1874	35493000
136231	1693	14148899781489
136232	452	66846781394804
136233	1693	14080298928133
136234	275	66846781394804
136235	1693	14011698074777
136236	402	66846781394804
136237	1693	13943097221421
136238	2181	845033200907
136239	1693	13874785836115
136240	458	66192943638921
136241	1693	13806184982759
136242	690	66846781394804
136243	1394	967695011440200
136244	1394	967695029440200
136247	1599	14697003097983
136269	1397	1273183453000
136270	1678	27360856647000
136271	1397	1273173452000
136272	1678	27360856648000
136273	1397	1273163451000
136274	1678	27360856649000
136275	1693	12720082164317
136276	894	310759461099813
136277	1693	12651772114121
136278	342	66191649914597
136279	1693	12463279838829
136280	1811	2317423500306
136281	1693	12394678985473
136282	499	66846781394804
136283	1693	12389481026893
136284	710	5064150105589
136285	1693	12321171183691
136286	120	66191449337183
136287	1693	12252570330335
136288	663	66846781394804
136289	1693	11315749085263
136290	1030	912533541116414
136291	1693	11247440007938
136292	238	66179713200746
136293	2134	83707438000
136294	1874	35501000
136295	2134	83706435000
136296	1874	35504000
136297	2134	83705432000
136298	1874	35507000
136299	1693	11179131096209
136300	312	66190546738816
136301	1693	11110530242853
136302	251	66846781394804
136303	1693	11042220422602
136304	320	66564769550207
136305	1693	10973909037296
136306	354	66192943638921
136307	1693	9212529464164
136308	1276	1715715512165594
136309	1693	9143928610808
136310	194	66846781394804
136311	2133	90304256000
136312	1874	35509000
136313	2133	90303254000
136314	1874	35511000
136315	2133	90302252000
136316	1874	35513000
136317	1394	967695062440200
136353	1678	28080856651000
136354	1678	28080863651000
136355	1451	5467790000000
136356	1691	13391156300052
136552	1397	1273023437000
136553	1678	27360856663000
136554	1693	4721452560631
136555	2308	187798189530
136556	1693	4652851707275
136557	122	66846781394804
136558	1693	4130069053118
136559	910	509228741176357
136560	2133	90288224000
136561	1874	35583000
136562	1693	4122792311107
136563	29	7089810147845
136564	1693	4054191457751
136073	1394	964814987440200
136074	1394	964814999440200
136106	1706	19002283450256
136138	2329	319686565819988
136139	2329	319686589819988
136144	1397	1273273462000
136145	1678	27360856638000
136146	2134	83716465000
136147	1874	35456000
136148	2133	90313274000
136149	1874	35458000
136150	1688	31030995113019
136151	1688	31031007113019
136153	1397	1273263461000
136154	1678	27360856639000
136155	2134	83715462000
136156	1874	35461000
136157	2133	90312272000
136158	1874	35463000
136176	1397	1273233458000
136177	1678	27360856642000
136178	1397	1273223457000
136179	1678	27360856643000
136180	1693	15042498716916
136181	383	66846781394804
136182	1693	14974189805187
136183	327	66190546738816
136184	1693	14905588951831
136185	652	66846781394804
136186	1693	14836988098475
136187	266	66233761394804
136188	1693	14768387245119
136189	352	66846781394804
136190	1693	14699786391763
136191	191	66846781394804
136192	1693	14631185538407
136193	520	66846781394804
136194	1693	14562584685051
136195	421	66846781394804
136196	2133	90309266000
136197	1874	35475000
136198	2133	90308264000
136199	1874	35477000
136200	2134	83712453000
136201	1874	35480000
136202	2134	83711450000
136203	1874	35483000
136204	1594	17281933000000
136248	1419	26206220559748
136410	1444	14487915329999
136411	1444	14487968329999
136430	1397	1273093444000
136431	1678	27360856656000
136432	1397	1273083443000
136433	1678	27360856657000
136434	1693	7120902488917
136435	180	66846781394804
136436	686	69550057000000
136437	2358	50100000000
136438	2134	83697408000
136439	1874	35549000
136440	1693	7052593484033
136441	165	66190636998665
136442	1693	6984284479149
136443	237	66190636998665
136444	1693	6915683625793
136445	2164	845442200907
136446	2134	83696405000
136447	1874	35552000
136448	2133	90295238000
136449	1874	35554000
136450	2133	90294236000
136451	1874	35556000
136452	1693	6847082772437
136453	691	66846781394804
136454	1693	6778481919081
136455	600	66846781394804
136456	1693	6709881065725
136457	245	66846781394804
136458	1693	6641280212369
136459	620	66846781394804
136460	1693	6572679359013
136461	594	66846781394804
136462	1693	6504078505657
136463	201	66846781394804
136464	1693	6435477652301
136465	163	66846781394804
136466	1395	58302632434957278
136467	1610	13680308999950
136468	1610	13680344999950
136489	1397	1273063441000
136490	1678	27360856659000
136491	1693	6088328899908
136492	252	66846781394804
136493	2133	90292232000
136494	1874	35563000
136495	1693	6019728046552
136496	377	66846781394804
136497	1693	5951127193196
136498	225	66846781394804
136499	2134	83694399000
136500	1874	35566000
136501	2112	26447016101924
136502	2112	26447031101924
136627	1522	11563804000000
136628	1522	12283804000000
136629	1522	12283817000000
136655	1397	1272963431000
136656	1678	27360856669000
136657	2134	83684369000
136658	1874	35614000
136659	2133	90282212000
136660	1874	35616000
136672	1397	1272943429000
136673	1678	27360856671000
136674	1397	1272933428000
136675	1678	27360856672000
136676	2133	90280208000
136677	1874	35623000
136678	2133	90279206000
136679	1874	35625000
136680	2134	83682363000
136681	1874	35628000
136682	2134	83681360000
136683	1874	35631000
136684	1394	973455150440200
136685	1394	973455174440200
136739	1397	1272863421000
136740	1678	27360856679000
136741	2134	83674339000
136742	1874	35664000
136743	2133	90272192000
136744	1874	35666000
136745	1571	12860761124178
136746	1571	12860773124178
136800	1397	1272773412000
136801	1678	27360856688000
136802	1397	1272763411000
136803	1678	27360856689000
136804	1397	1272753410000
136805	1678	27360856690000
136806	2134	83665312000
136807	1874	35709000
136808	2134	83664309000
136809	1874	35712000
136810	2134	83663306000
136811	1874	35715000
136812	2133	90263174000
136813	1874	35717000
136814	2133	90262172000
136815	1874	35719000
136816	2133	90261170000
136817	1874	35721000
136818	1684	30243508819412
136819	1684	30243544819412
136855	1675	22604578999977
136897	1397	1272673402000
136898	1678	27360856698000
136899	2132	147268281000
136900	1874	35759000
136901	2134	83655282000
136902	1874	35762000
136903	2133	90253154000
136904	1874	35764000
136905	1394	977775198440200
136906	1394	977775211440200
136929	1397	1272633398000
136930	1678	27360856702000
136931	2133	90249146000
136932	1874	35782000
136933	2134	83651270000
136934	1874	35785000
136935	1602	14976742170000
137037	1397	1272603395000
137038	1678	27360856705000
137039	2133	90246140000
137040	1874	35797000
137041	1394	979215211440200
137042	1394	979215222440200
137057	1693	1945763623117
137058	1444	14587917329999
137059	1397	1272583393000
137060	1678	27360856707000
137061	1397	1272573392000
137062	1678	27360856708000
136075	1395	58302632398957278
136076	1395	58302632410957278
136089	1515	1440048603400
136090	315	66000001000000
136091	1706	18282271450256
136107	1706	20442305450256
136108	1706	20442330450256
136109	1706	19722295450256
136140	1448	12919913000001
136152	1691	11951144300052
136166	1397	1273243459000
136167	1678	27360856641000
136168	2133	90310268000
136169	1874	35470000
136170	2134	83713456000
136171	1874	35473000
136172	1691	12671144300052
136173	1691	12671156300052
136205	1397	1273213456000
136206	1678	27360856644000
136207	1693	14493983831695
136208	534	66846781394804
136209	1693	14425382978339
136210	680	66846781394804
136211	2134	83710447000
136212	1874	35486000
136213	2133	90307262000
136214	1874	35488000
136215	1693	14356782124983
136216	82	66846781394804
136217	1693	14288181271627
136218	309	66846781394804
136219	1693	14219580418271
136220	361	66196779394804
136221	1693	14217500634845
136222	731	2025660042156
136223	1685	185044683571430
136224	1685	185044701571430
136245	1599	14697015097983
136249	1397	1273193454000
136250	1678	27360856646000
136251	1693	13737584129403
136252	391	66845671394804
136253	1693	13244794922670
136254	1772	6067000384008
136255	1693	13176194069314
136256	570	66846781394804
136257	1693	13107593215958
136258	390	66846781394804
136259	1693	13038992362602
136260	569	66846781394804
136261	2133	90305258000
136262	1874	35495000
136263	2134	83708441000
136264	1874	35498000
136265	1426	16170455000000
136266	1426	16170472000000
136319	1397	1273153450000
136320	1678	27360856650000
136321	1397	1273143449000
136322	1678	27360856651000
136323	2133	90301250000
136324	1874	35515000
136325	1693	9075327757452
136326	206	66846781394804
136327	1693	9007018845723
136328	636	66190546738816
136329	2134	83704429000
136330	1874	35518000
136331	2134	83703426000
136332	1874	35521000
136333	2133	90300248000
136334	1874	35523000
136335	1684	29523482819412
136336	1684	29523508819412
136337	2134	83702423000
136338	1874	35526000
136339	1693	8938417992367
136340	399	66846781394804
136341	2133	90299246000
136342	1874	35528000
136343	1693	8936338208941
136344	721	2025660042156
136345	1693	8867737355585
136346	105	66846781394804
136347	1693	8799136502229
136348	146	66846781394804
136349	1693	8730535648873
136350	611	66846781394804
136351	1394	969135062440200
136352	1394	969135069440200
136503	1397	1273053440000
136504	1678	27360856660000
136505	1397	1273043439000
136506	1678	27360856661000
136507	1397	1273033438000
136508	1678	27360856662000
136509	2134	83693396000
136510	1874	35569000
136511	1693	5882526339840
136512	560	66846781394804
136513	1693	5563616141555
136514	893	310759461099813
136515	1693	5495015288199
136516	103	66846781394804
136517	2134	83692393000
136518	1874	35572000
136519	2134	83691390000
136520	1874	35575000
136521	2133	90291230000
136522	1874	35577000
136523	2133	90290228000
136524	1874	35579000
136525	2133	90289226000
136526	1874	35581000
136527	315	66000000000000
136528	1693	5426414434843
136529	217	66846781394804
136530	1693	5358105420648
136531	530	66769204972448
136532	1693	5289504567292
136533	54	66846781394804
136534	1693	5220449433021
136535	603	66913638346463
136536	1693	5200492112057
136537	35	19446336405681
136538	1693	5131891258701
136539	49	66846781394804
136540	1693	5063581208505
136541	240	66191649914597
136542	1693	4995272194310
136543	262	66190613024638
136544	1693	4926963272227
136545	441	66068456767695
136546	1693	4858362418871
136547	304	66846781394804
136548	1693	4789761565515
136549	653	66846781394804
136550	1695	12905177999000
136551	1695	12905228999000
136630	1688	30311036113019
136631	1688	31031036113019
136632	1688	31031049113019
136661	1693	45773623117
136662	1778	5524464345059
136663	1397	1272953430000
136664	1678	27360856670000
136665	2134	83683366000
136666	1874	35619000
136667	2133	90281210000
136668	1874	35621000
136669	1444	16487927329999
136686	1397	1272923427000
136687	1678	27360856673000
136688	2134	83680357000
136689	1874	35634000
136690	2133	90278204000
136691	1874	35636000
136700	1686	16952152700123
136701	1686	16952164700123
136760	1397	1272833418000
136761	1678	27360856682000
136762	2133	90269186000
136763	1874	35678000
136764	2134	83671330000
136765	1874	35681000
136766	1394	976335186440200
136767	1394	976335198440200
136820	1397	1272743409000
136821	1678	27360856691000
136822	2133	90260168000
136823	1874	35723000
136824	2134	83662303000
136825	1874	35726000
136826	1662	2160032000000
136827	1662	2160044000000
136830	1874	35724000
136831	1698	13749003550062
136839	1395	58302632420957278
136840	2133	90259166000
136841	1874	35731000
136842	1395	58303352420957278
136844	102	66720010000000
136845	102	67440010000000
136846	102	67440012000000
136121	1855	13320657324650
136122	2346	101100000
136123	2333	389000000
136141	1693	15831099570272
136142	1693	15831123570272
136159	1397	1273253460000
136160	1678	27360856640000
136161	2133	90311270000
136162	1874	35465000
136163	2134	83714459000
136164	1874	35468000
136165	1394	966255011440200
136246	1419	26206233559748
136267	341	66720990000001
136268	341	66721007000001
136318	1622	9684091800048
136357	1397	1273133448000
136358	1678	27360856652000
136359	1397	1273123447000
136360	1678	27360856653000
136361	1397	1273113446000
136362	1678	27360856654000
136363	2133	90298244000
136364	1874	35530000
136365	2133	90297242000
136366	1874	35532000
136367	2133	90296240000
136368	1874	35534000
136369	1693	8661934795517
136370	500	66846781394804
136371	2134	83701420000
136372	1874	35537000
136373	1693	8593333942161
136374	587	66846781394804
136375	1693	8524733088805
136376	138	66846781394804
136377	1693	8456421341262
136378	114	66070347649394
136379	1693	8388112027959
136380	443	66190935859010
136381	1693	8319803023075
136382	649	66190636998665
136383	1693	8251494018191
136384	578	66190636998665
136385	1693	8182893164835
136386	205	66846781394804
136387	1693	8114292311479
136388	504	66233711394804
136389	1693	8045691458123
136390	339	66846781394804
136391	1693	7977382039261
136392	301	66071019153477
136393	1693	7908781185905
136394	408	66846781394804
136395	1693	7840180332549
136396	601	66846781394804
136397	1693	7771425317468
136398	1821	845652594543
136399	1693	7702824464112
136400	450	66846781394804
136401	1693	7669125939644
136402	10	32591980141866
136403	1693	7600525086288
136404	322	66846781394804
136405	2134	83700417000
136406	1874	35540000
136407	2134	83699414000
136408	1874	35543000
136409	1394	969135115440200
136412	1397	1273103445000
136413	1678	27360856655000
136414	1693	7532216174559
136415	366	66190546738816
136416	1693	7463615321203
136417	2017	845380729203
136418	1693	7395305902341
136419	283	66070028153477
136420	1693	7326705048985
136421	308	66846781394804
136422	1693	7258104195629
136423	392	66846781394804
136424	1693	7189503342273
136425	186	66846781394804
136426	2134	83698411000
136427	1874	35546000
136428	1394	970575115440200
136429	1394	970575132440200
136469	1397	1273073442000
136470	1678	27360856658000
136471	2134	83695402000
136472	1874	35559000
136473	2133	90293234000
136474	1874	35561000
136475	1693	6366876798945
136476	1962	845693570031
136477	1693	6364803388663
136478	748	2728071043671
136479	1693	6296202535307
136480	2073	844766394804
136481	1693	6227601681951
136482	99	66846781394804
136483	1693	6225530606620
136484	1778	5455864491703
136485	1693	6156929753264
136486	108	66846781394804
136487	1394	972015132440200
136488	1394	972015150440200
136570	1397	1273013436000
136571	1678	27360856664000
136572	1397	1273003435000
136573	1678	27360856665000
136574	1397	1272993434000
136575	1678	27360856666000
136576	2133	90287222000
136577	1874	35588000
136578	2133	90286220000
136579	1874	35590000
136580	2133	90285218000
136581	1874	35592000
136582	1693	3985593740346
136583	395	66343731646980
136584	1693	3916992886990
136585	593	66845780394804
136586	1693	3848392033634
136587	1961	845693570031
136588	1693	3780083028750
136589	154	66190636998665
136590	1693	3711482175394
136591	658	66846781394804
136592	1693	3642881322038
136593	660	66846781394804
136594	1693	3640801538612
136595	745	2025660042156
136596	2134	83689384000
136597	1874	35595000
136598	1489	13343220040000
136599	2134	83688381000
136600	1874	35598000
136601	2134	83687378000
136602	1874	35601000
136603	1693	3572200685256
136604	91	66846781394804
136605	1693	3503599831900
136606	438	66846781394804
136607	1693	3434998978544
136608	373	66846781394804
136609	1693	3366398125188
136610	453	66846781394804
136611	1693	3297797271832
136612	92	66846781394804
136613	1693	3229196418476
136614	150	66846781394804
136615	1693	3160595565120
136616	63	66846781394804
136617	1693	3092286560236
136618	562	66190636998665
136619	1693	3089178181597
136620	711	3011058115466
136621	1693	3020577328241
136622	551	66846781394804
136623	1693	2952268323357
136624	379	66190636998665
136625	1489	14063220040000
136626	1489	14063233040000
136692	1397	1272913426000
136693	1678	27360856674000
136694	2133	90277202000
136695	1874	35638000
136696	2134	83679354000
136697	1874	35641000
136698	1695	13625228999000
136699	1695	13625240999000
136702	1397	1272903425000
136703	1678	27360856675000
136704	2338	7000000
136705	2346	389000000
136706	2133	90276200000
136707	1874	35643000
136708	2134	83678351000
136709	1874	35646000
136710	1394	974895174440200
136711	1394	974895187440200
136712	1705	27921052580140
136713	1705	27921065580140
136721	1395	58303352410957278
136565	78	66846781394804
136566	2134	83690387000
136567	1874	35586000
136568	1402	50583540145435
136569	1402	50583557145435
136633	1397	1272983433000
136634	1678	27360856667000
136635	1397	1272973432000
136636	1678	27360856668000
136637	2134	83686375000
136638	1874	35604000
136639	1693	2883667470001
136640	84	66846781394804
136641	1693	2251575183185
136642	1150	615704563706554
136643	1693	2182974329829
136644	678	66846781394804
136645	2134	83685372000
136646	1874	35607000
136647	1693	2114373476473
136648	89	66846781394804
136649	2133	90284216000
136650	1874	35609000
136651	2133	90283214000
136652	1874	35611000
136653	1649	14151621999968
136654	1649	14151649999968
136670	1693	765773623117
136671	1693	2765785623117
136714	1397	1272893424000
136715	1678	27360856676000
136716	2133	90275198000
136717	1874	35648000
136718	2134	83677348000
136719	1874	35651000
136720	1394	974895186440200
136723	1634	17663180259504
136724	1634	17663192259504
136747	1397	1272853420000
136748	1678	27360856680000
136749	1397	1272843419000
136750	1678	27360856681000
136751	2134	83673336000
136752	1874	35669000
136753	2133	90271190000
136754	1874	35671000
136755	2134	83672333000
136756	1874	35674000
136757	2133	90270188000
136758	1874	35676000
136759	1850	17256503949999
136768	1397	1272823417000
136769	1678	27360856683000
136770	1397	1272813416000
136771	1678	27360856684000
136772	1397	1272803415000
136773	1678	27360856685000
136774	1397	1272793414000
136775	1678	27360856686000
136776	1397	1272783413000
136777	1678	27360856687000
136778	2134	83670327000
136779	1874	35684000
136780	2133	90268184000
136781	1874	35686000
136782	2133	90267182000
136783	1874	35688000
136784	2134	83669324000
136785	1874	35691000
136786	2134	83668321000
136787	1874	35694000
136788	2134	83667318000
136789	1874	35697000
136790	2134	83666315000
136791	1874	35700000
136792	2133	90266180000
136793	1874	35702000
136794	2133	90265178000
136795	1874	35704000
136796	2133	90264176000
136797	1874	35706000
136798	1522	12283823000000
136799	1688	31031055113019
136843	369	81636657290830
136856	1444	14487917329999
136857	1693	2045773623117
136858	1397	1272713406000
136859	1678	27360856694000
136860	2132	147270283000
136861	1874	35734000
136862	2133	90257162000
136863	1874	35739000
136864	2134	83659294000
136865	1874	35742000
136866	1708	14040657324650
136867	1708	14040681324650
136936	1695	13625239999000
137035	1685	185764701571430
137036	1685	185764725571430
137043	1397	1272593394000
137044	1678	27360856706000
137045	2133	90245138000
137046	1874	35799000
137047	2134	83648261000
137048	1874	35802000
137049	632	79677672000000
137050	632	79677684000000
137051	1693	12790979570272
137052	1687	10209931848312
137053	1499	200000010
137054	1807	1440132000000
137055	1687	201000000
137056	2069	10210570848311
137074	2384	719000000000
137075	2384	719034000000
137076	1397	1272563391000
137077	1678	27360856709000
137078	2133	90242132000
137079	1874	35814000
137080	2134	83645252000
137081	1874	35817000
137096	1447	21161933683000
137119	1634	17663216259504
137143	1686	17672164700123
137144	1686	17672176700123
137160	2307	5039110000000
137161	2307	5039123000000
137170	2134	83634219000
137171	1874	35870000
137172	2133	90231110000
137173	1874	35872000
137174	1710	16794108664140
137175	1710	16794110664140
137178	1397	1272453380000
137179	1678	27360856720000
137180	2134	83633216000
137181	1874	35875000
137182	2382	99000000
137183	2133	90230108000
137184	1874	35877000
137185	1394	982095246440200
137186	1394	982095259440200
137199	1402	51303557145435
137200	1402	51303569145435
137209	1397	1272423377000
137210	1678	27360856723000
137211	1397	1272413376000
137212	1678	27360856724000
137213	2133	90227102000
137214	1874	35889000
137215	2133	90226100000
137216	1874	35891000
137217	2134	83630207000
137218	1874	35894000
137219	2134	83629204000
137220	1874	35897000
137221	1619	9360245000000
137276	1714	17565783171760
137277	1714	17565784171760
137292	1685	187204761571430
137293	1685	187204785571430
137307	1714	18285784171760
137308	1397	1272323367000
137309	1678	27360856733000
137310	1397	1272313366000
137311	1678	27360856734000
137312	2133	90217082000
137313	1874	35939000
137314	2134	83620177000
137315	1874	35942000
137316	2133	90216080000
137317	1874	35944000
137318	2134	83619174000
137319	1874	35947000
137320	1714	17565807171760
137354	1397	1272263361000
137355	1678	27360856739000
137356	2134	83614159000
137357	1874	35966000
137358	1395	58305512456957278
137359	1395	58305512467957278
137366	1397	1272253360000
137367	1678	27360856740000
137368	2134	83613156000
137369	1874	35971000
136722	1395	58303352422957278
136725	1397	1272883423000
136726	1678	27360856677000
136727	1397	1272873422000
136728	1678	27360856678000
136729	2134	83676345000
136730	1874	35654000
136731	2134	83675342000
136732	1874	35657000
136733	2133	90274196000
136734	1874	35659000
136735	2133	90273194000
136736	1874	35661000
136737	1610	14400344999950
136738	1610	14400368999950
136828	1698	13748992550062
136829	1698	13749004550062
136832	1397	1272733408000
136833	1678	27360856692000
136834	369	80916655290830
136835	2134	83661300000
136836	1874	35729000
136837	369	81636655290830
136838	2346	390000000
136847	1397	1272723407000
136848	1678	27360856693000
136849	2133	90258164000
136850	1874	35733000
136851	2134	83660297000
136852	1874	35736000
136853	1675	22604567999977
136854	1675	22604579999977
136868	1397	1272703405000
136869	1678	27360856695000
136870	1397	1272693404000
136871	1678	27360856696000
136872	1397	1272683403000
136873	1678	27360856697000
136874	2132	147269282000
136875	1874	35743000
136876	2134	83658291000
136877	1874	35746000
136878	2133	90256160000
136879	1874	35748000
136880	2133	90255158000
136881	1874	35750000
136882	1726	947250112000
136883	2381	100000000
136884	2134	83657288000
136885	1874	35753000
136886	2133	90254156000
136887	1874	35755000
136888	1726	946149112000
136889	2382	100000000
136890	1726	945048112000
136891	2381	1200000000
136892	1726	943947112000
136893	2383	100000000
136894	2134	83656285000
136895	1874	35758000
136896	1672	12961523000000
136914	1397	1272653400000
136915	1678	27360856700000
136916	1397	1272643399000
136917	1678	27360856701000
136918	2134	83653276000
136919	1874	35772000
136920	2133	90251150000
136921	1874	35774000
136922	2133	90250148000
136923	1874	35776000
136924	2134	83652273000
136925	1874	35779000
136926	2132	147267280000
136927	1874	35780000
136928	2329	319686590819988
136937	1444	11767905329999
136938	1693	17111099570272
136939	1874	35189000
136940	1693	17042498716916
136941	1874	35191000
136942	1693	16974189805187
136943	1693	16905588951831
136944	1693	16836988098475
136945	1693	16768387245119
136946	1693	16699786391763
136947	1693	16631185538407
136948	1693	16562584685051
136949	1693	16493983831695
136950	1693	16425382978339
136951	1693	16356782124983
136952	1693	16288181271627
136953	1693	16219580418271
136954	1693	16217500634845
136955	1693	16148899781489
136956	1693	16080298928133
136957	1693	16011698074777
136958	1693	15943097221421
136959	1693	15874785836115
136960	1693	15806184982759
136961	1693	15737584129403
136962	1693	15244794922670
136963	1693	15176194069314
136964	1693	15107593215958
136965	1693	15038992362602
136966	1693	14720082164317
136967	1693	14651772114121
136968	1693	14463279838829
136969	1693	14394678985473
136970	1693	14389481026893
136971	1693	14321171183691
136972	1693	14252570330335
136973	1693	13315749085263
136974	1693	13247440007938
136975	1693	13179131096209
136976	1693	13110530242853
136977	1693	13042220422602
136978	1693	12973909037296
136979	1693	11212529464164
136980	1874	35192000
136981	1693	11143928610808
136982	1693	11075327757452
136983	1693	11007018845723
136984	1693	10938417992367
136985	1693	10936338208941
136986	1693	10867737355585
136987	1693	10799136502229
136988	1693	10730535648873
136989	1693	10661934795517
136990	1693	10593333942161
136991	1693	10524733088805
136992	1693	10456421341262
136993	1693	10388112027959
136994	1693	10319803023075
136995	1693	10251494018191
136996	1693	10182893164835
136997	1693	10114292311479
136998	1693	10045691458123
136999	1693	9977382039261
137000	1693	9908781185905
137001	1693	9840180332549
137002	1693	9771425317468
137003	1693	9702824464112
137004	1693	9669125939644
137005	1693	9600525086288
137006	1693	9532216174559
137007	1693	9463615321203
137008	1693	9395305902341
137009	1693	9326705048985
137010	1693	9258104195629
137011	1693	9189503342273
137012	1693	9120902488917
137013	1693	9052593484033
137014	1693	8984284479149
137015	1693	8915683625793
137016	1693	8847082772437
137017	1555	16806384540449
137018	1693	8778481919081
137019	1555	17526384540449
137020	1555	17526385540449
137084	1397	1272553390000
137085	1678	27360856710000
137086	1693	45753623117
137087	1778	7424464345059
137088	2134	83644249000
137089	1874	35820000
137090	1422	13914741804270
137097	1489	14783233040000
137098	1489	14783255040000
137120	1474	15750679000043
137121	1397	1272513386000
137122	1678	27360856714000
137123	1397	1272503385000
137124	1678	27360856715000
137125	2134	83640237000
137126	1874	35840000
137127	2134	83639234000
137128	1874	35843000
137129	2133	90237122000
137130	1874	35845000
137131	2133	90236120000
137132	1874	35847000
137133	1394	980655222440200
137134	1394	980655246440200
137187	1678	28080856720000
136907	1397	1272663401000
136908	1678	27360856699000
136909	2134	83654279000
136910	1874	35767000
136911	2133	90252152000
136912	1874	35769000
136913	1611	3593511402899
137021	1397	1272623397000
137022	1678	27360856703000
137023	1397	1272613396000
137024	1678	27360856704000
137025	2134	83650267000
137026	1874	35788000
137027	2133	90248144000
137028	1874	35790000
137029	2133	90247142000
137030	1874	35792000
137031	2134	83649264000
137032	1874	35795000
137033	1555	17526288540449
137034	1555	17526312540449
137073	1679	17278450656999
137082	606	79726927286230
137083	606	79726939286230
137099	1397	1272543389000
137100	1678	27360856711000
137101	1397	1272533388000
137102	1678	27360856712000
137103	1397	1272523387000
137104	1678	27360856713000
137105	2134	83643246000
137106	1874	35825000
137107	2133	90240128000
137108	1874	35827000
137109	2133	90239126000
137110	1874	35829000
137111	2133	90238124000
137112	1874	35831000
137113	2134	83642243000
137114	1874	35834000
137115	2134	83641240000
137116	1874	35837000
137117	1685	186484725571430
137118	1685	186484761571430
137151	1397	1272473382000
137152	1678	27360856718000
137153	2133	90234116000
137154	1874	35857000
137155	2134	83636225000
137156	1874	35860000
137157	2133	90233114000
137158	1874	35862000
137159	2306	3599121000000
137162	1397	1272463381000
137163	1678	27360856719000
137164	2133	90232112000
137165	1874	35864000
137166	2134	83635222000
137167	1874	35867000
137168	1395	58304792444957278
137169	1395	58304792456957278
137191	1397	1272443379000
137192	1678	27360856721000
137193	2133	90229106000
137194	1874	35879000
137195	2134	83632213000
137196	1874	35882000
137197	1394	983535259440200
137198	1394	983535271440200
137201	1559	13266212999999
137202	1559	13266224999999
137256	1693	13510991570272
137257	1874	34939000
137258	1874	34940000
137259	1693	13442390716916
137260	1874	34945000
137261	1874	34947000
137262	1693	13374081805187
137263	1874	34949000
137264	1693	13305480951831
137265	1874	34951000
137266	1874	34955000
137267	1693	13236880098475
137268	1693	13168279245119
137269	1693	13099678391763
137270	1693	13031077538407
137271	1693	12962476685051
137272	1693	12893875831695
137273	1693	12825274978339
137274	1692	17741063668958
137275	1692	17741095668958
137330	1397	1272293364000
137331	1678	27360856736000
137332	2133	90214076000
137333	1874	35954000
137334	2134	83617168000
137335	1874	35957000
137336	1685	187204773571430
137347	2133	90213074000
137348	1874	35959000
137349	2133	90212072000
137350	1874	35961000
137351	1874	35964000
137352	1874	35967000
137353	1426	16890496000000
137377	1397	1272243359000
137378	1678	27360856741000
137379	2134	83612153000
137380	1874	35980000
137381	2133	90209066000
137382	1874	35982000
137383	1471	18665496900000
137384	1471	18665508900000
137387	1571	12765205894466
137388	38	66539225269421
137389	1571	12038110913010
137390	969	506877361461968
137391	1571	10735170855898
137392	1089	908319888814612
137393	1571	9856047983650
137394	1209	612861528535553
137395	1571	7406311798770
137396	1335	1707793141873126
137397	1571	7406301798770
137398	1397	1272233358000
137399	1678	27360856742000
137400	2133	90208064000
137401	1874	35984000
137402	2134	83611150000
137403	1874	35987000
137404	1447	21881933683000
137405	1447	21882005683000
137467	1402	52023581145435
137518	1547	11515030000000
137519	1547	12235030000000
137520	1547	1434963970000
137521	1420	12235629010000
137542	2134	83598111000
137543	1874	36050000
137544	2133	90195038000
137545	1874	36052000
137546	2133	90194036000
137547	1874	36054000
137548	2133	90193034000
137549	1874	36056000
137550	2133	90192032000
137551	1874	36058000
137552	2134	83597108000
137553	1874	36061000
137554	2134	83596105000
137555	1874	36064000
137556	2134	83595102000
137557	1874	36067000
137558	1649	14871649999968
137559	1649	14871697999968
137560	1397	1272063341000
137561	1678	27360856759000
137562	1397	1272053340000
137563	1678	27360856760000
137564	1397	1272043339000
137565	1678	27360856761000
137566	2133	90191030000
137567	1874	36060000
137568	1874	36063000
137569	1874	36066000
137570	2133	90190028000
137571	1874	36068000
137572	2133	90189026000
137573	1874	36070000
137574	1874	36073000
137575	2134	83594099000
137576	1874	36076000
137577	2134	83593096000
137578	1874	36079000
137579	2134	83592093000
137580	1874	36082000
137581	1719	19438720000000
137582	1719	19438764000000
137608	1397	1272003335000
137609	1678	27360856765000
137610	1397	1271993334000
137611	1678	27360856766000
137612	2133	90185018000
137613	1874	36099000
137614	2133	90184016000
137063	2134	83647258000
137064	1874	35805000
137065	2133	90244136000
137066	1874	35807000
137067	2133	90243134000
137068	1874	35809000
137069	2134	83646255000
137070	1874	35812000
137071	1546	14637565800000
137072	1546	14637599800000
137091	2133	90241130000
137092	1874	35819000
137093	1874	35822000
137094	1395	58304072422957278
137095	1395	58304072444957278
137135	1397	1272493384000
137136	1678	27360856716000
137137	2133	90235118000
137138	1874	35849000
137139	2134	83638231000
137140	1874	35852000
137141	43	81120269890000
137142	43	81120281890000
137145	1397	1272483383000
137146	1678	27360856717000
137147	2134	83637228000
137148	1874	35855000
137149	1451	6907790000000
137150	1451	6907801000000
137176	1573	7779421000000
137177	1573	7779423000000
137189	1696	21323837335104
137230	1522	13003823000000
137231	1522	13003835000000
137234	1397	1272393374000
137235	1678	27360856726000
137236	1397	1272383373000
137237	1678	27360856727000
137238	2134	83627198000
137239	1874	35905000
137240	2133	90224096000
137241	1874	35907000
137242	2133	90223094000
137243	1874	35909000
137244	2134	83626195000
137245	1874	35912000
137246	1693	765753623117
137247	1693	765777623117
137278	1397	1272363371000
137279	1678	27360856729000
137280	1397	1272353370000
137281	1678	27360856730000
137282	2134	83624189000
137283	1874	35920000
137284	2133	90221090000
137285	1874	35922000
137286	2133	90220088000
137287	1874	35924000
137288	2134	83623186000
137289	1874	35927000
137290	1394	984975271440200
137291	1394	984975295440200
137294	1397	1272343369000
137295	1678	27360856731000
137296	1397	1272333368000
137297	1678	27360856732000
137298	2134	83622183000
137299	1874	35930000
137300	2134	83621180000
137301	1874	35933000
137302	2133	90219086000
137303	1874	35935000
137304	2133	90218084000
137305	1874	35937000
137306	1402	51303581145435
137321	1588	16224799000000
137322	2068	2000099000000
137323	1397	1272303365000
137324	1678	27360856735000
137325	2133	90215078000
137326	1874	35949000
137327	2134	83618171000
137328	1874	35952000
137329	1474	15750665000043
137360	1874	35965000
137361	1874	35968000
137362	1874	35970000
137363	2133	90211070000
137364	1874	35972000
137365	1694	19259111197225
137437	2039	18619732000000
137458	1394	986415295440200
137494	1397	1272123347000
137495	1678	27360856753000
137496	2133	90197042000
137497	1874	36039000
137498	2134	83600117000
137499	1874	36042000
137500	1547	12234840000000
137501	1547	12234852000000
137522	1397	1272113346000
137523	1678	27360856754000
137524	2133	90196040000
137525	1874	36044000
137526	2134	83599114000
137527	1874	36047000
137528	1489	14783245040000
137529	149	80495442000341
137530	149	80495454000341
137533	1397	1272103345000
137534	1678	27360856755000
137535	1397	1272093344000
137536	1678	27360856756000
137537	1397	1272083343000
137538	1678	27360856757000
137539	1397	1272073342000
137540	1678	27360856758000
137541	1394	986415335440200
137583	1397	1272033338000
137584	1678	27360856762000
137585	2134	83591090000
137586	1874	36085000
137587	2133	90188024000
137588	1874	36087000
137589	1593	17232813000000
137590	1593	17232825000000
137672	1573	8499423000000
137673	1573	8499435000000
137674	1395	58307672515957278
137742	2359	1100000000
137743	1687	10929570848311
137825	1397	1271773312000
137826	1678	27360856788000
137827	2133	90161972000
137828	1874	36214000
137829	2134	83565012000
137830	1874	36217000
137853	1693	1485777623117
137854	1693	1485803623117
137863	1397	1271723307000
137864	1678	27360856793000
137865	2134	83559997000
137866	1874	36240000
137867	2133	90156962000
137868	1874	36242000
137869	1395	58309112527957278
137870	1395	58309112539957278
137882	1991	16461497355805
137883	1991	16461509355805
137896	1724	16972928500000
137897	1724	16972940500000
137912	1395	58309832539957278
137913	1395	58309832550957278
137967	526	66000305000000
137968	1474	24390643000043
137969	1397	1271653300000
137970	1678	27360856800000
137971	1397	1271643299000
137972	1678	27360856801000
137973	2133	90149948000
137974	1874	36271000
137975	2133	90148946000
137976	1874	36273000
137977	2134	83553979000
137978	1874	36276000
137979	2134	83552976000
137980	1874	36279000
137981	610	66000000001310
137982	45	67440065009990
137983	1420	1434963970000
138007	1599	15417015097983
138008	1599	15417027097983
138009	1685	187924785571430
138017	1397	1271593294000
138018	1678	27360856806000
138019	2133	90143936000
138020	1874	36301000
138021	1394	990735369440200
138022	1394	990735380440200
138113	1397	1271573292000
138114	1678	27360856808000
138115	1397	1271563291000
138116	1678	27360856809000
138117	1397	1271553290000
138118	1678	27360856810000
137188	1678	28080869720000
137190	1508	16760484156616
137203	1397	1272433378000
137204	1678	27360856722000
137205	2134	83631210000
137206	1874	35885000
137207	2133	90228104000
137208	1874	35887000
137222	1397	1272403375000
137223	1678	27360856725000
137224	2134	83628201000
137225	1874	35900000
137226	2133	90225098000
137227	1874	35902000
137228	1608	18138609000000
137229	1608	18138621000000
137232	1559	13986224999999
137233	1559	13986236999999
137248	1397	1272373372000
137249	1678	27360856728000
137250	2134	83625192000
137251	1874	35915000
137252	2133	90222092000
137253	1874	35917000
137254	1684	30963544819412
137255	1684	30963556819412
137337	1397	1272283363000
137338	1678	27360856737000
137339	1397	1272273362000
137340	1678	27360856738000
137341	2134	83616165000
137342	1874	35960000
137343	2134	83615162000
137344	1874	35963000
137345	1426	16890472000000
137346	1426	16890494000000
137385	1455	6511624000000
137386	1455	6511636000000
137408	1397	1272223357000
137409	1678	27360856743000
137410	1397	1272213356000
137411	1678	27360856744000
137412	2068	89000000
137413	2152	109988998000000
137414	2133	90207062000
137415	1874	35989000
137416	2134	83610147000
137417	1874	35992000
137418	2134	83609144000
137419	1874	35995000
137420	2133	90206060000
137421	1874	35997000
137422	632	79677718000000
137423	632	80397718000000
137424	1397	1272203355000
137425	1678	27360856745000
137426	1397	1272193354000
137427	1678	27360856746000
137428	2133	90205058000
137429	1874	35999000
137430	2133	90204056000
137431	1874	36001000
137432	2134	83608141000
137433	1874	36004000
137434	2134	83607138000
137435	1874	36007000
137436	606	79726951286230
137502	1571	12045193894466
137503	1571	11318098913010
137504	1571	10015158855898
137505	1571	9136035983650
137506	1571	6686299798770
137507	1571	6686289798770
137508	1571	6650454673081
137509	1571	6377787805035
137510	1571	5889179033618
137511	1571	5559501706525
137512	1571	4640844387195
137513	1571	4640834387195
137514	1547	11515390000000
137515	1874	35494000
137516	1547	12235390000000
137517	1547	12236063000000
137531	1698	14469004550062
137532	1698	14469016550062
137621	1395	58306232467957278
137622	1395	58306232491957278
137625	1397	1271983333000
137626	1678	27360856767000
137627	2134	83586075000
137628	1874	36110000
137629	321	66009959000000
137630	2133	90183014000
137631	1874	36112000
137632	2112	27167031101924
137633	2112	27167044101924
137650	1397	1271953330000
137651	1678	27360856770000
137652	2133	90180008000
137653	1874	36124000
137654	2134	83583066000
137655	1874	36127000
137656	1724	16252916500000
137657	1724	16252928500000
137703	1688	31751007113019
137704	1688	31751055113019
137714	1649	14871671999968
137744	497	66717010000000
137745	657	66000990000000
137746	1397	1271833318000
137747	1678	27360856782000
137748	1397	1271823317000
137749	1678	27360856783000
137750	238	66000703200746
137751	2314	179869000000
137752	590	66000990000000
137753	2133	90167984000
137754	1874	36184000
137755	2133	90166982000
137756	1874	36186000
137757	2134	83571030000
137758	1874	36189000
137759	2134	83570027000
137760	1874	36192000
137761	1675	23324578999977
137762	1675	23324642999977
137792	1650	11633069000000
137793	1650	11633133000000
137837	1397	1271753310000
137838	1678	27360856790000
137839	1397	1271743309000
137840	1678	27360856791000
137841	2305	198999000000
137842	2133	90159968000
137843	1874	36224000
137844	2133	90158966000
137845	1874	36226000
137846	2131	189996000
137847	2172	199001000
137848	2134	83563006000
137849	1874	36229000
137850	2134	83562003000
137851	1874	36232000
137852	1688	31751033113019
137855	1397	1271733308000
137856	1678	27360856792000
137857	2134	83561000000
137858	1874	36235000
137859	2133	90157964000
137860	1874	36237000
137861	1671	18384306003785
137862	1671	18384318003785
137880	149	81215454000341
137881	149	81215466000341
137884	1397	1271703305000
137885	1678	27360856795000
137886	2134	83557991000
137887	1874	36250000
137888	2133	90154958000
137889	1874	36252000
137890	1394	989295357440200
137891	1394	989295369440200
137900	1705	28641077580140
137922	1397	1271663301000
137923	1678	27360856799000
137924	2133	90150950000
137925	1874	36266000
137926	2134	83554982000
137927	1874	36269000
137928	1675	24044642999977
137929	1675	24044654999977
137985	1397	1271633298000
137986	1678	27360856802000
137987	1397	1271623297000
137988	1678	27360856803000
137989	2134	83551973000
137990	1874	36282000
137991	2133	90147944000
137992	1874	36284000
137993	2133	90146942000
137994	1874	36286000
137995	2134	83550970000
137996	1874	36289000
137997	1402	52743581145435
137998	1402	52743605145435
137370	1874	35973000
137371	1874	35975000
137372	2133	90210068000
137373	1874	35977000
137374	1448	13639913000001
137375	1448	13639928000001
137376	2106	4320201000000
137406	1724	14812796500000
137407	1724	14812868500000
137438	1439	13663899578477
137439	1397	1272183353000
137440	1678	27360856747000
137441	1571	7370466673081
137442	38	66575050395110
137443	1571	7097799805035
137444	969	507150018330014
137445	1571	6609191033618
137446	1089	908808487586029
137447	1571	6279513706525
137448	1209	613191195862646
137449	1571	5360856387195
137450	1335	1708711789192456
137451	1571	5360846387195
137452	2134	83606135000
137453	1874	36010000
137454	2133	90203054000
137455	1874	36012000
137456	1740	17010883000000
137457	1740	17010955000000
137459	1397	1272173352000
137460	1678	27360856748000
137461	2134	83605132000
137462	1874	36015000
137463	2133	90202052000
137464	1874	36017000
137465	1444	15307917329999
137466	1444	15307929329999
137468	1397	1272163351000
137469	1678	27360856749000
137470	1397	1272153350000
137471	1678	27360856750000
137472	1397	1272143349000
137473	1678	27360856751000
137474	1397	1272133348000
137475	1678	27360856752000
137476	2133	90201050000
137477	1874	36019000
137478	2133	90200048000
137479	1874	36021000
137480	2134	83604129000
137481	1874	36024000
137482	2134	83603126000
137483	1874	36027000
137484	2133	90199046000
137485	1874	36029000
137486	2133	90198044000
137487	1874	36031000
137488	2134	83602123000
137489	1874	36034000
137490	2134	83601120000
137491	1874	36037000
137492	1724	15532868500000
137493	1724	15532916500000
137591	1397	1272023337000
137592	1678	27360856763000
137593	2134	83590087000
137594	1874	36090000
137595	2133	90187022000
137596	1874	36092000
137597	1723	14402131085979
137598	1723	14402143085979
137599	1764	15923539100000
137600	1397	1272013336000
137601	1678	27360856764000
137602	2133	90186020000
137603	1874	36094000
137604	2134	83589084000
137605	1874	36097000
137606	369	82356657290830
137607	369	82356669290830
137623	2329	320406590819988
137624	2329	320406614819988
137634	1685	187924773571430
137635	1685	187924786571430
137658	1397	1271943329000
137659	1678	27360856771000
137660	2134	83582063000
137661	1874	36130000
137662	2133	90179006000
137663	1874	36132000
137664	1394	987855335440200
137665	1394	987855347440200
137666	1397	1271933328000
137667	1678	27360856772000
137668	2134	83581060000
137669	1874	36135000
137670	2133	90178004000
137671	1874	36137000
137676	1397	1271923327000
137677	1678	27360856773000
137678	1397	1271913326000
137679	1678	27360856774000
137680	1397	1271903325000
137681	1678	27360856775000
137682	1397	1271893324000
137683	1678	27360856776000
137684	2133	90177002000
137685	1874	36139000
137686	2134	83580057000
137687	1874	36142000
137688	2134	83579054000
137689	1874	36145000
137690	2134	83578051000
137691	1874	36148000
137692	2134	83577048000
137693	1874	36151000
137694	2133	90176000000
137695	1874	36153000
137696	2133	90174998000
137697	1874	36155000
137698	2133	90173996000
137699	1874	36157000
137700	1395	58308392515957278
137701	1395	58308392563957278
137715	1397	1271873322000
137716	1678	27360856778000
137717	1397	1271863321000
137718	1678	27360856779000
137719	2133	90171992000
137720	1874	36164000
137721	2133	90170990000
137722	1874	36166000
137723	2134	83575042000
137724	1874	36169000
137725	2134	83574039000
137726	1874	36172000
137727	1850	17976503949999
137728	1850	17976527949999
137763	1675	22605098999977
137764	1874	35951000
137765	1874	35953000
137766	1874	35956000
137767	1874	35969000
137768	1874	35979000
137769	1874	35981000
137770	1874	35983000
137771	1874	35985000
137772	1874	35991000
137773	1874	35993000
137774	1874	36003000
137775	1874	36005000
137776	1874	36009000
137777	1874	36011000
137778	1874	36013000
137779	1874	36023000
137780	1874	36025000
137781	1874	36033000
137782	1874	36035000
137783	1874	36041000
137784	1874	36043000
137785	1874	36045000
137786	1874	36049000
137787	1874	36051000
137788	1874	36057000
137789	1874	36069000
137790	1675	23325098999977
137791	1675	23325306999977
137794	1397	1271813316000
137795	1678	27360856784000
137796	2133	90165980000
137797	1874	36194000
137798	2134	83569024000
137799	1874	36197000
137800	1395	58308392527957278
137817	1397	1271783313000
137818	1678	27360856787000
137819	2133	90162974000
137820	1874	36209000
137821	2134	83566015000
137822	1874	36212000
137892	1708	14760681324650
137893	1708	14760683324650
137898	1705	28641065580140
137899	1705	28641087580140
137901	1397	1271693304000
137615	1874	36101000
137616	2134	83588081000
137617	1874	36104000
137618	2134	83587078000
137619	1874	36107000
137620	1546	14637589800000
137636	1397	1271973332000
137637	1678	27360856768000
137638	1397	1271963331000
137639	1678	27360856769000
137640	2134	83585072000
137641	1874	36115000
137642	2134	83584069000
137643	1874	36118000
137644	2133	90182012000
137645	1874	36120000
137646	2133	90181010000
137647	1874	36122000
137648	1395	58306952491957278
137649	1395	58306952515957278
137675	1747	5106022999992
137702	1506	7920263967172
137705	2307	5039158000000
137706	1397	1271883323000
137707	1678	27360856777000
137708	553	66000990000000
137709	2134	83576045000
137710	1874	36160000
137711	2133	90172994000
137712	1874	36162000
137713	1394	987855357440200
137729	1397	1271853320000
137730	1678	27360856780000
137731	1397	1271843319000
137732	1678	27360856781000
137733	2133	90169988000
137734	1874	36174000
137735	2133	90168986000
137736	1874	36176000
137737	2134	83573036000
137738	1874	36179000
137739	2134	83572033000
137740	1874	36182000
137741	1687	9489020848312
137801	1397	1271803315000
137802	1678	27360856785000
137803	2133	90164978000
137804	1874	36199000
137805	2134	83568021000
137806	1874	36202000
137807	1444	16027929329999
137808	1444	16027941329999
137809	1397	1271793314000
137810	1678	27360856786000
137811	2134	83567018000
137812	1874	36205000
137813	2133	90163976000
137814	1874	36207000
137815	1679	17998450656999
137816	1679	17998462656999
137823	1668	14193783000000
137824	1668	14193795000000
137831	1397	1271763311000
137832	1678	27360856789000
137833	2133	90160970000
137834	1874	36219000
137835	2134	83564009000
137836	1874	36222000
137871	1759	11737306139889
137872	1759	11737318139889
137873	1397	1271713306000
137874	1678	27360856794000
137875	2134	83558994000
137876	1874	36245000
137877	2133	90155960000
137878	1874	36247000
137879	2039	18619720000000
137894	1679	18718462656999
137895	1679	18718474656999
137907	1397	1271683303000
137908	1678	27360856797000
137909	2133	90152954000
137910	1874	36259000
137911	1447	21881944683000
137914	1397	1271673302000
137915	1678	27360856798000
137916	2133	90151952000
137917	1874	36261000
137918	2134	83555985000
137919	1874	36264000
137920	2261	12239346000000
137921	2261	12239358000000
137966	641	81843948000000
138010	1397	1271603295000
138011	1678	27360856805000
138012	2133	90144938000
138013	1874	36296000
138014	2134	83548964000
138015	1874	36299000
138016	1693	1485789623117
138131	1397	1271543289000
138132	1678	27360856811000
138133	1397	1271533288000
138134	1678	27360856812000
138135	1397	1271523287000
138136	1678	27360856813000
138137	1397	1271513286000
138138	1678	27360856814000
138139	2133	90138926000
138140	1874	36311000
138141	2133	90137924000
138142	1874	36313000
138143	2133	90136922000
138144	1874	36315000
138145	2133	90135920000
138146	1874	36317000
138147	2329	321126614819988
138148	2329	321126658819988
138149	1397	1271503285000
138150	1678	27360856815000
138151	1397	1271493284000
138152	1678	27360856816000
138153	114	66001337649394
138154	2314	248869000000
138155	301	66002009153477
138156	2314	317869000000
138157	1397	1271483283000
138158	1678	27360856817000
138159	283	66001018153477
138160	2314	386869000000
138161	10	32559970141866
138162	2314	418869000000
138163	2133	90134918000
138164	1874	36319000
138165	2133	90133916000
138166	1874	36321000
138167	2133	90132914000
138168	1874	36323000
138169	1395	58310552550957278
138170	1395	58310552623957278
138172	1559	13986297999999
138212	1693	2925800623117
138213	1693	2925822623117
138243	1673	11015470000000
138246	1397	1271363271000
138247	1678	27360856829000
138248	2314	859000000
138249	1950	15576851000000
138250	2133	90120890000
138251	1874	36347000
138252	1394	993615391440200
138253	1394	993615412440200
138274	2329	321846658819988
138275	2329	321846669819988
138350	1747	5106033999992
138352	632	81117718000000
138353	632	81117729000000
138376	1499	2160032000000
138377	1499	2160043000000
138386	1714	19005818171760
138387	1714	19005829171760
138389	1397	1271123247000
138390	1678	27360856853000
138391	2133	90096842000
138392	1874	36395000
138393	1587	17280501000000
137902	1678	27360856796000
137903	2133	90153956000
137904	1874	36254000
137905	2134	83556988000
137906	1874	36257000
137930	1874	36071000
137931	1874	36088000
137932	1874	36091000
137933	1874	36100000
137934	1874	36103000
137935	1874	36106000
137936	1874	36109000
137937	1874	36126000
137938	1874	36128000
137939	1874	36134000
137940	1874	36140000
137941	1874	36143000
137942	1874	36146000
137943	1874	36149000
137944	1874	36152000
137945	1874	36158000
137946	1874	36161000
137947	1675	23325502999977
137948	1874	36167000
137949	1874	36170000
137950	1874	36173000
137951	1874	36185000
137952	1874	36188000
137953	1874	36191000
137954	1874	36200000
137955	1874	36203000
137956	1874	36206000
137957	1874	36215000
137958	1874	36218000
137959	1874	36221000
137960	1874	36227000
137961	1874	36230000
137962	1874	36233000
137963	1874	36236000
137964	1675	24045502999977
137965	1675	24045527999977
137984	1718	9616630519070
138023	1693	2205789623117
138024	1693	2205800623117
138031	1992	15841106990000
138032	1992	15841117990000
138127	1679	18718495656999
138129	1611	4313511402899
138130	1611	4313544402899
138195	1397	1271423277000
138196	1678	27360856823000
138197	2133	90126902000
138198	1874	36335000
138200	1702	7920581000000
138201	1702	7920592000000
138221	1764	16643551100000
138222	1764	16643562100000
138229	1613	14977428400000
138231	2314	69869000000
138232	2314	138869000000
138233	2314	207869000000
138234	1613	14258117400000
138235	1613	14978117400000
138236	1613	14978667400000
138254	1397	1271353270000
138255	1678	27360856830000
138256	1397	1271343269000
138257	1678	27360856831000
138258	2133	90119888000
138259	1874	36349000
138260	2133	90118886000
138261	1874	36351000
138262	1850	18696527949999
138263	1850	18696549949999
138267	1634	17663202259504
138282	1397	1271313266000
138283	1678	27360856834000
138284	1397	1271303265000
138285	1678	27360856835000
138286	1397	1271293264000
138287	1678	27360856836000
138288	2133	90115880000
138289	1874	36357000
138290	2133	90114878000
138291	1874	36359000
138292	2133	90113876000
138293	1874	36361000
138294	1394	995055412440200
138295	1394	995055445440200
138306	1440	7200262045924
138309	1397	1271263261000
138310	1678	27360856839000
138311	2133	90110870000
138312	1874	36367000
138313	1467	6640315272869
138378	606	80446951286230
138379	606	80446962286230
138380	1685	188644785571430
138381	1685	188644796571430
137999	1397	1271613296000
138000	1678	27360856804000
138001	2134	83549967000
138002	1874	36292000
138003	2133	90145940000
138004	1874	36294000
138005	1941	2877981000000
138006	1941	2877993000000
138025	1397	1271583293000
138026	1678	27360856807000
138027	2133	90142934000
138028	1874	36303000
138029	1700	13194316979053
138030	1700	13194327979053
138033	1474	23670631000043
138034	1693	15671039570272
138035	1874	35029000
138036	1874	35030000
138037	1693	15602438716916
138038	1693	15534129805187
138039	1693	15465528951831
138040	1693	15396928098475
138041	1693	15328327245119
138042	1693	15259726391763
138043	1693	15191125538407
138044	1693	15122524685051
138045	1693	15053923831695
138046	1693	14985322978339
138047	1693	14916722124983
138048	1693	14848121271627
138049	1693	14779520418271
138050	1693	14777440634845
138051	1693	14708839781489
138052	1693	14640238928133
138053	1693	14571638074777
138054	1693	14503037221421
138055	1693	14434725836115
138056	1693	14366124982759
138057	1693	14297524129403
138058	1693	13804734922670
138059	1693	13736134069314
138060	1693	13667533215958
138061	1693	13598932362602
138062	1693	13280022164317
138063	1693	13211712114121
138064	1693	13023219838829
138065	1693	12954618985473
138066	1693	12949421026893
138067	1693	12881111183691
138068	1693	12812510330335
138069	1693	11875689085263
138070	1693	11807380007938
138071	1693	11739071096209
138072	1693	11670470242853
138073	1693	11602160422602
138074	1693	11533849037296
138075	1693	9772469464164
138076	1874	35032000
138077	1693	9703868610808
138078	1693	9635267757452
138079	1693	9566958845723
138080	1693	9498357992367
138081	1693	9496278208941
138082	1693	9427677355585
138083	1693	9359076502229
138084	1693	9290475648873
138085	1693	9221874795517
138086	1693	9153273942161
138087	1693	9084673088805
138088	1693	9016361341262
138089	1693	8948052027959
138090	1693	8879743023075
138091	1693	8811434018191
138092	1693	8742833164835
138093	1693	8674232311479
138094	1693	8605631458123
138095	1693	8537322039261
138096	1693	8468721185905
138097	1693	8400120332549
138098	1693	8331365317468
138099	1693	8262764464112
138100	1693	8229065939644
138101	1693	8160465086288
138102	1693	8092156174559
138103	1693	8023555321203
138104	1693	7955245902341
138105	1693	7886645048985
138106	1693	7818044195629
138107	1693	7749443342273
138108	1693	7680842488917
138109	1693	7612533484033
138110	1693	7544224479149
138111	1693	7475623625793
138112	1700	13194550979053
138128	1681	17854825358535
138171	1394	990735442440200
138173	1397	1271473282000
138174	1678	27360856818000
138175	1397	1271463281000
138176	1678	27360856819000
138177	2133	90131912000
138178	1874	36325000
138179	2133	90130910000
138180	1874	36327000
138181	1991	16461519355805
138202	1397	1271413276000
138203	1678	27360856824000
138204	1397	1271403275000
138205	1678	27360856825000
138206	2133	90125900000
138207	1874	36337000
138208	2133	90124898000
138209	1874	36339000
138210	1395	58311272623957278
138211	1395	58311272645957278
138214	1397	1271393274000
138215	1678	27360856826000
138216	2133	90123896000
138217	1874	36341000
138218	1679	18718473656999
138219	1688	32471033113019
138220	1688	32471044113019
138244	1633	10128659125277
138245	1633	10128670125277
138276	1397	1271323267000
138277	1678	27360856833000
138278	2133	90116882000
138279	1874	36355000
138280	1395	58311992645957278
138281	1395	58311992656957278
138296	1397	1271283263000
138297	1678	27360856837000
138298	2133	90112874000
138299	1874	36363000
138307	1714	18285807171760
138308	1714	18285818171760
138316	1397	1271253260000
138317	1678	27360856840000
138318	1397	1271243259000
138319	1678	27360856841000
138320	1397	1271233258000
138321	1678	27360856842000
138322	1397	1271223257000
138323	1678	27360856843000
138324	1397	1271213256000
138325	1678	27360856844000
138326	1397	1271203255000
138327	1678	27360856845000
138328	1397	1271193254000
138329	1678	27360856846000
138330	2133	90109868000
138331	1874	36369000
138332	2133	90108866000
138333	1874	36371000
138334	2133	90107864000
138335	1874	36373000
138336	2133	90106862000
138337	1874	36375000
138338	2133	90105860000
138339	1874	36377000
138340	2133	90104858000
138341	1874	36379000
138342	2133	90103856000
138343	1874	36381000
138344	2039	19339720000000
138345	2039	19339797000000
138351	1746	5568968999989
138354	1397	1271173252000
138355	1678	27360856848000
138356	1397	1271163251000
138357	1678	27360856849000
138358	2133	90101852000
138359	1874	36385000
138360	2133	90100850000
138361	1874	36387000
138362	1458	22985479908540
138363	1458	22985501908540
138365	1397	1271153250000
138366	1678	27360856850000
138367	2133	90099848000
138368	1874	36389000
138369	1715	10823602663945
138388	1714	19005819171760
138394	1397	1271113246000
138395	1678	27360856854000
138119	2133	90141932000
138120	1874	36305000
138121	2133	90140930000
138122	1874	36307000
138123	2133	90139928000
138124	1874	36309000
138125	1657	10081408990100
138126	1657	10081441990100
138182	1397	1271453280000
138183	1678	27360856820000
138184	1397	1271443279000
138185	1678	27360856821000
138186	1397	1271433278000
138187	1678	27360856822000
138188	2133	90129908000
138189	1874	36329000
138190	2133	90128906000
138191	1874	36331000
138192	2133	90127904000
138193	1874	36333000
138194	1546	14637598800000
138199	1703	7200931000000
138223	1397	1271383273000
138224	1678	27360856827000
138225	2133	90122894000
138226	1874	36343000
138227	1394	992175380440200
138228	1394	992175391440200
138230	1650	11633080000000
138237	1397	1271373272000
138238	1678	27360856828000
138239	2133	90121892000
138240	1874	36345000
138241	1451	7627801000000
138242	1451	7627812000000
138264	1719	20158764000000
138265	1719	20158786000000
138266	1508	16760493156616
138268	1397	1271333268000
138269	1678	27360856832000
138270	2133	90117884000
138271	1874	36353000
138272	58	80387613999641
138273	58	80387624999641
138300	1397	1271273262000
138301	1678	27360856838000
138302	2133	90111872000
138303	1874	36365000
138304	2306	4319121000000
138305	2306	4319132000000
138314	1593	17952825000000
138315	1593	17952836000000
138346	1397	1271183253000
138347	1678	27360856847000
138348	2133	90102854000
138349	1874	36383000
138364	1701	15118406500103
138370	1397	1271143249000
138371	1678	27360856851000
138372	2133	90098846000
138373	1874	36391000
138374	1608	18858621000000
138375	1608	18858632000000
138382	1397	1271133248000
138383	1678	27360856852000
138384	2133	90097844000
138385	1874	36393000
138398	1395	58312712656957278
138399	1395	58312712667957278
138396	2133	90095840000
138397	1874	36397000
138400	1458	8640172798540
138401	45	66000000000660
138402	1515	4200600
138403	1758	400400000
138404	1492	12600000
138405	1737	1000001100
138406	45	66000000001040
138407	1515	12603400
138408	1761	10000001
138409	1794	200100000
138410	1623	14401420899898
138411	45	66000000001050
138412	1837	200000010
138413	1761	10000002
138414	1675	7200319999977
138415	1568	100000
138416	1634	10080189899999
138417	1831	200000002
138418	1791	1210000024
138419	1805	195000000
138420	1470	4200000
138421	1794	200100003
138422	1637	61921683799997
138423	1420	720000220000
138424	1894	205000000
138425	1718	12237483889008
138426	646	66000001980000
138427	1692	26659962020000
138428	646	66000003960000
138429	1637	108002684819997
138430	1467	15121750100000
138431	1893	209900000
138432	1728	9900000
138433	1764	18000419100000
138434	1679	69121261980000
138435	1804	1401000000
138436	45	66000000001290
138437	1723	18000260999760
138438	1759	20160409999999
138439	1807	200000001
138440	1786	200000002
138441	1692	32420148019999
138442	1560	2033997277001
138443	2000	200000001
138444	1677	277207932000000
138445	1740	19435146000000
138446	145	66000010000000
138447	1759	1440525999999
138448	1509	20880651000000
138449	1992	2879080990000
138450	1449	8053010459
138451	1762	3921700994000
138452	1599	19440521996199
138453	1514	3800
138454	1689	3600064287625
138455	1527	260999989
138456	1514	5700
138457	1677	92809298323100
138458	1790	201900000
138459	1761	18200002
138460	1536	10080640999959
138461	1988	190000040
138462	1447	11674501943000
138463	1677	107929647324100
138464	1709	5760059999976
138465	1726	674918185000
138466	1616	2880096410000
138467	1444	8495037159999
138468	2097	200000001
138469	1397	1271103245000
138470	1678	27360856855000
138471	1397	1271093244000
138472	1678	27360856856000
138473	1397	1271083243000
138474	1678	27360856857000
138475	1397	1271073242000
138476	1678	27360856858000
138477	1397	1271063241000
138478	1678	27360856859000
138479	2133	90094838000
138480	1874	36399000
138481	2133	90093836000
138482	1874	36401000
138483	2133	90092834000
138484	1874	36403000
138485	2133	90091832000
138486	1874	36405000
138487	2133	90090830000
138488	1874	36407000
138489	1701	15838406500103
138490	1701	15838461500103
138491	1686	18392176700123
138492	1686	18392231700123
138493	1397	1271053240000
138494	1678	27360856860000
138495	2133	90089828000
138496	1874	36409000
138497	1394	996495445440200
138498	1394	996495456440200
138499	1397	1271043239000
138500	1678	27360856861000
138501	2133	90088826000
138502	1874	36411000
138503	2307	5039121000000
138504	1506	8640263967172
138505	1506	8640274967172
138506	1397	1271033238000
138507	1678	27360856862000
138508	2133	90087824000
138509	1874	36413000
138510	2329	322566669819988
138511	2329	322566680819988
138512	1397	1271023237000
138513	1678	27360856863000
138514	2133	90086822000
138515	1874	36415000
138516	1467	7360315272869
138517	1467	7360326272869
138518	1397	1271013236000
138519	1678	27360856864000
138520	2133	90085820000
138521	1874	36417000
138522	1394	997935456440200
138523	1394	997935467440200
138524	1546	15357598800000
138525	1546	15357609800000
138526	1691	13391167300052
138527	1594	18001933000000
138528	1594	18001944000000
138529	1397	1271003235000
138530	1678	27360856865000
138531	2133	90084818000
138532	1874	36419000
138533	1649	14871660999968
138534	1547	12954852000000
138535	1397	1270993234000
138536	1678	27360856866000
138537	1397	1270983233000
138538	1678	27360856867000
138539	2133	90083816000
138540	1874	36421000
138541	2133	90082814000
138542	1874	36423000
138543	1508	17480493156616
138544	1508	17480515156616
138545	1397	1270973232000
138546	1678	27360856868000
138547	1397	1270963231000
138548	1678	27360856869000
138549	1397	1270953230000
138550	1678	27360856870000
138551	2133	90081812000
138552	1874	36425000
138553	2133	90080810000
138554	1874	36427000
138555	2133	90079808000
138556	1874	36429000
138557	2318	9000000
138558	2152	109998988000000
138559	1706	20442339450256
138560	1397	1270943229000
138561	1678	27360856871000
138562	2133	90078806000
138563	1874	36431000
138564	1439	13663886578477
138565	2329	323286680819988
138566	2329	323286691819988
138567	1397	1270933228000
138568	1678	27360856872000
138569	1397	1270923227000
138570	1678	27360856873000
138571	2133	90077804000
138572	1874	36433000
138573	2133	90076802000
138574	1874	36435000
138575	1740	17730955000000
138576	1740	17730977000000
138577	1397	1270913226000
138578	1678	27360856874000
138579	2133	90075800000
138580	1874	36437000
138581	58	81107624999641
138582	58	81107635999641
138583	1549	14831444000000
138584	1549	14831455000000
138754	1397	1270833218000
138755	1678	27360856882000
138756	1397	1270823217000
138757	1678	27360856883000
138758	2133	90067784000
138759	1874	36453000
138760	2133	90066782000
138761	1874	36455000
138762	1394	997935478440200
138780	1395	58312712679957278
138806	1397	1270753210000
138807	1678	27360856890000
138808	1397	1270743209000
138809	1678	27360856891000
138810	2134	83546958000
138811	1874	36473000
138812	2134	83545955000
138813	1874	36476000
138814	2133	90059768000
138815	1874	36478000
138816	2133	90058766000
138817	1874	36480000
138818	1601	9025958620000
138819	1601	9025982620000
138828	1506	8640275967172
138840	1717	19261366000055
138841	1717	19261379000055
138851	1694	19259109197225
138866	1601	9745982620000
138867	1601	9746006620000
138868	1397	1270683203000
138869	1678	27360856897000
138870	1397	1270673202000
138871	1678	27360856898000
138872	2133	90052754000
138873	1874	36507000
138874	2134	83539937000
138875	1874	36510000
138876	2134	83538934000
138877	1874	36513000
138878	2133	90051752000
138879	1874	36515000
138882	1476	17280395000000
138883	1476	17280419000000
138905	1397	1270633198000
138906	1678	27360856902000
138907	1397	1270623197000
138908	1678	27360856903000
138909	2134	83534922000
138910	1874	36533000
138911	2134	83533919000
138912	1874	36536000
138913	2133	90047744000
138914	1874	36538000
138915	2133	90046742000
138916	1874	36540000
138917	1694	19979109197225
138918	1694	19979133197225
138956	1397	1270563191000
138957	1678	27360856909000
138958	2134	83527901000
138959	1874	36568000
138960	2133	90040730000
138961	1874	36570000
138962	641	82563948000000
138963	641	82563960000000
138974	1397	1270543189000
138975	1678	27360856911000
138976	2133	90038726000
138977	1874	36577000
138978	2134	83525895000
138979	1874	36580000
138980	1555	17526300540449
138989	1650	11633081000000
139000	1397	1270513186000
139001	1678	27360856914000
139002	2133	90035720000
139003	1874	36592000
139004	2134	83522886000
139005	1874	36595000
139006	1394	1002255501440200
139007	1394	1002255513440200
139055	610	67440044000000
139064	1397	1270433178000
139065	1678	27360856922000
139066	2134	83514862000
139067	1874	36633000
139068	2133	90027704000
139069	1874	36635000
139070	1394	1003695513440200
139071	1394	1003695525440200
139093	1397	1270393174000
139094	1678	27360856926000
139095	2134	83510850000
139096	1874	36653000
139097	2133	90023696000
139098	1874	36655000
139099	1402	52743593145435
139102	1991	17181519355805
139103	1991	17181531355805
139104	1397	1270383173000
139105	1678	27360856927000
139106	1397	1270373172000
139107	1678	27360856928000
139108	1397	1270363171000
139109	1678	27360856929000
139110	2133	90022694000
139111	1874	36657000
139112	2134	83509847000
139113	1874	36660000
139114	2134	83508844000
139115	1874	36663000
139116	2134	83507841000
139117	1874	36666000
139118	2133	90021692000
139119	1874	36668000
139120	2133	90020690000
139121	1874	36670000
139122	1402	53463593145435
139123	1402	53463629145435
139140	1397	1270333168000
139141	1678	27360856932000
139142	2133	90017684000
139143	1874	36682000
139144	2134	83504832000
139145	1874	36685000
139146	1764	17363574100000
139155	1394	1006575561440200
139156	1394	1006575573440200
139157	1551	1440012000000
139158	1551	1440024000000
139200	1397	1270263161000
139201	1678	27360856939000
139202	2133	90010670000
139203	1874	36717000
139204	2134	83497811000
139205	1874	36720000
139206	1394	1008015573440200
139207	1394	1008015585440200
139223	1397	1270233158000
139224	1678	27360856942000
139225	2134	83494802000
139226	1874	36733000
139227	2133	90007664000
139228	1874	36735000
139237	1395	58314872715957278
139238	1395	58314872727957278
139239	1397	1270213156000
139240	1678	27360856944000
139241	2134	83492796000
139242	1874	36743000
139243	2133	90005660000
139244	1874	36745000
139263	1397	1270183153000
139264	1678	27360856947000
139265	1397	1270173152000
139266	1678	27360856948000
139267	2351	96000000
139268	2133	90002654000
139269	1874	36757000
139270	2133	90001652000
139271	1874	36759000
139272	2134	83489787000
139273	1874	36762000
139274	2134	83488784000
139275	1874	36765000
139276	1394	1009455585440200
139277	1394	1009455610440200
139293	1687	10929032848312
139294	1687	10929044848312
139336	1397	1270143149000
139337	1678	27360856951000
139338	2133	89998646000
139339	1874	36777000
139340	2134	83485775000
139341	1874	36780000
139342	1622	9684052800048
139369	1719	20158776000000
139388	1513	36001215000000
139389	1513	36001241000000
139393	1397	1270083143000
139394	1678	27360856957000
139395	2134	83478754000
138585	1397	1270903225000
138586	1678	27360856875000
138587	1397	1270893224000
138588	1678	27360856876000
138589	2133	90074798000
138590	1874	36439000
138591	1699	2880363750126
138592	2133	90073796000
138593	1874	36441000
138594	1699	3600363750126
138595	1699	3600364750126
138599	2086	3600412300069
138600	2086	4320412300069
138601	2086	4320413300069
138730	2317	777585211465
138731	1397	1270883223000
138732	1678	27360856877000
138733	1397	1270873222000
138734	1678	27360856878000
138735	1397	1270863221000
138736	1678	27360856879000
138737	2133	90072794000
138738	1874	36443000
138739	2133	90071792000
138740	1874	36445000
138741	2133	90070790000
138742	1874	36447000
138743	2039	20059797000000
138744	2039	20059840000000
138763	1397	1270813216000
138764	1678	27360856884000
138765	2133	90065780000
138766	1874	36457000
138767	1471	19385508900000
138768	1471	19385519900000
138781	1397	1270783213000
138782	1678	27360856887000
138783	2133	90062774000
138784	1874	36463000
138785	1394	999375478440200
138786	1394	999375489440200
138794	1395	58313432679957278
138795	1395	58313432694957278
138796	1685	189364796571430
138797	1685	189364811571430
138820	1397	1270733208000
138821	1678	27360856892000
138822	2133	90057764000
138823	1874	36482000
138824	2134	83544952000
138825	1874	36485000
138826	1474	25110643000043
138827	1474	25110655000043
138831	1397	1270723207000
138832	1678	27360856893000
138833	121	66000099000000
138834	2134	83543949000
138835	1874	36488000
138836	2133	90056762000
138837	1874	36490000
138838	1675	24764654999977
138839	1675	24764667999977
138842	1587	18000501000000
138843	1587	18000514000000
138844	1611	4313524402899
138852	1397	1270703205000
138853	1678	27360856895000
138854	1397	1270693204000
138855	1678	27360856896000
138856	2133	90054758000
138857	1874	36497000
138858	2134	83541943000
138859	1874	36500000
138860	2134	83540940000
138861	1874	36503000
138862	2133	90053756000
138863	1874	36505000
138864	2329	324006691819988
138865	2329	324006715819988
138881	1747	5106046999992
138884	1397	1270663201000
138885	1678	27360856899000
138886	1397	1270653200000
138887	1678	27360856900000
138888	2134	83537931000
138889	1874	36518000
138890	2134	83536928000
138891	1874	36521000
138892	2133	90050750000
138893	1874	36523000
138894	2133	90049748000
138895	1874	36525000
138896	1688	33191044113019
138897	1688	33191068113019
138919	1397	1270613196000
138920	1678	27360856904000
138921	2134	83532916000
138922	1874	36543000
138923	2133	90045740000
138924	1874	36545000
138925	1685	189364808571430
138939	1749	1442622529980
138940	1397	1270583193000
138941	1678	27360856907000
138942	2133	90042734000
138943	1874	36557000
138944	2134	83529907000
138945	1874	36560000
138946	1687	10209020848312
138947	1687	10209032848312
138964	1623	82083399898598
138965	1623	82083411898598
138990	1397	1270523187000
138991	1678	27360856913000
138992	2134	83523889000
138993	1874	36588000
138994	2133	90036722000
138995	1874	36590000
138996	1715	11543602663945
138997	1715	11543614663945
139008	1397	1270503185000
139009	1678	27360856915000
139010	2134	83521883000
139011	1874	36598000
139012	2133	90034718000
139013	1874	36600000
139014	1693	2925812623117
139041	2329	326166739819988
139042	2329	326166787819988
139053	1718	10336630519070
139054	1718	10336642519070
139072	1397	1270423177000
139073	1678	27360856923000
139074	2134	83513859000
139075	1874	36638000
139076	2133	90026702000
139077	1874	36640000
139078	1623	82803411898598
139079	1623	82803423898598
139124	1394	1005135525440200
139125	1394	1005135561440200
139147	1397	1270323167000
139148	1678	27360856933000
139149	2133	90016682000
139150	1874	36687000
139151	2134	83503829000
139152	1874	36690000
139153	1395	58314152691957278
139154	1395	58314152703957278
139159	1397	1270313166000
139160	1678	27360856934000
139161	2133	90015680000
139162	1874	36692000
139163	2134	83502826000
139164	1874	36695000
139165	1747	5826046999992
139166	1747	5826058999992
139167	1397	1270303165000
139168	1678	27360856935000
139169	2133	90014678000
139170	1874	36697000
139171	2134	83501823000
139172	1874	36700000
139173	1672	13681523000000
139174	1672	13681535000000
139184	1397	1270283163000
139185	1678	27360856937000
139186	1397	1270273162000
139187	1678	27360856938000
139188	2134	83499817000
139189	1874	36708000
139190	2134	83498814000
139191	1874	36711000
139192	2133	90012674000
139193	1874	36713000
139194	2133	90011672000
139195	1874	36715000
139196	1684	31683556819412
139197	1684	31683580819412
139208	1688	35351104113019
139209	1688	35351116113019
139229	1397	1270223157000
139230	1678	27360856943000
139231	2134	83493799000
139232	1874	36738000
138596	2087	3315444147766
138597	2087	4035444147766
138598	2087	4035445147766
138602	152	66000110000000
138603	2097	200000021
138604	1527	262999987
138605	58	79626436999641
138606	2004	200000018
138607	1622	15660307000005
138608	1796	200000002
138609	1654	13968121999798
138610	167	66000000000200
138611	1601	4970167620000
138612	1420	1434941200000
138613	1514	10600
138614	1696	11297338835100
138615	1527	264999985
138616	1715	34560589000002
138617	2097	200000022
138618	1395	57899690945533706
138619	1423	2913273999985
138620	1394	135362409000000
138621	248	66000000070000
138622	1749	5165258930000
138623	212	66000004000000
138624	1440	14399289049920
138625	1420	1434962980000
138626	2052	200000092
138627	1489	13584063000000
138628	2095	200170000
138629	1692	22100102619999
138630	45	66000000001300
138631	1759	15120809999889
138632	167	66000000600200
138633	1724	9307364500000
138634	1514	20500
138635	1657	15121469990100
138636	1849	200000200
138637	1715	42480803990002
138638	1693	4459278757818
138639	1849	200000400
138640	2095	200180000
138641	1633	14436716975638
138642	646	66000005940000
138643	1610	15120539019950
138644	484	70028806000000
138645	2052	200000142
138646	1765	40001000
138647	1695	15452318999000
138648	1520	100000001
138649	1727	16747234999999
138650	1688	63360475905200
138651	1855	200002800
138652	1440	17999351045924
138653	2097	200004018
138654	167	66000001100200
138655	1394	407526295500000
138656	2095	200190000
138657	1680	17289739490035
138658	646	66000006930000
138659	212	66000004060000
138660	1850	20799311949999
138661	1796	200000003
138662	2126	250000006
138663	1807	200000005
138664	1659	720083999990
138665	1395	58145667475507701
138666	1520	100000006
138667	1708	19476294500022
138668	1509	20832238851155
138669	1688	15118953910040
138670	1817	200000060
138671	1568	150000
138672	1395	58173028824957278
138673	1509	22272264351155
138674	1696	25697659335104
138675	1527	277999972
138676	1664	10000000
138677	2052	210000142
138678	1555	16755436979105
138679	2260	280000020
138680	1501	100800000
138681	1604	3200000
138682	369	72996365290830
138683	2260	280000040
138684	1501	104000000
138685	1501	111200000
138686	1681	7811175909853
138687	1546	5997327800000
138688	2250	201000000
138689	1501	117200000
138690	2250	203000000
138691	1520	100000015
138692	1569	720848999991
138693	2252	200400000
138694	1684	11522976819748
138695	2275	200000008
138696	1684	12963049819412
138697	2266	200000020
138698	1749	15125563529980
138699	1693	6436755292484
138700	608	66000020000000
138701	1693	7876803092484
138702	2253	200200000
138703	1855	200003180
138704	1419	19726065559750
138705	646	66720043910000
138706	1855	200003680
138707	1394	754572273440200
138708	1514	9099700
138709	2250	204000000
138710	1855	200004980
138711	1527	289999960
138712	1596	5760130000002
138713	1807	200000007
138714	1419	22606155559748
138715	1520	100000026
138716	1746	3408934999989
138717	2330	103000000
138718	2333	101000000
138719	1807	200000009
138720	1679	6478128656999
138721	2367	100000001
138722	1688	20950814113019
138723	1692	11260822819983
138724	1604	3500000
138725	1796	200000005
138726	1568	225000
138727	1855	200005380
138728	1708	13320657324650
138729	2333	101100000
138745	1397	1270853220000
138746	1678	27360856880000
138747	1397	1270843219000
138748	1678	27360856881000
138749	2133	90069788000
138750	1874	36449000
138751	2133	90068786000
138752	1874	36451000
138753	633	81549603900000
138769	1397	1270803215000
138770	1678	27360856885000
138771	1397	1270793214000
138772	1678	27360856886000
138773	2133	90064778000
138774	1874	36459000
138775	2133	90063776000
138776	1874	36461000
138777	329	67442611000000
138778	2385	1000000000
138779	1622	9684063800048
138787	1397	1270773212000
138788	1678	27360856888000
138789	2385	896000000
138790	121	66000100000000
138791	2133	90061772000
138792	1874	36465000
138793	1536	18720375000000
138798	1397	1270763211000
138799	1678	27360856889000
138800	2134	83547961000
138801	1874	36468000
138802	2133	90060770000
138803	1874	36470000
138804	1705	29361077580140
138805	1705	29361089580140
138829	2307	5759121000000
138830	2307	5759133000000
138845	1397	1270713206000
138846	1678	27360856894000
138847	2133	90055760000
138848	1874	36492000
138849	2134	83542946000
138850	1874	36495000
138880	1746	5568981999989
138898	1397	1270643199000
138899	1678	27360856901000
138900	2134	83535925000
138901	1874	36528000
138902	2133	90048746000
138903	1874	36530000
138904	1395	58313432691957278
138926	1397	1270603195000
138927	1678	27360856905000
138928	1397	1270593194000
138929	1678	27360856906000
138930	2133	90044738000
138931	1874	36547000
138932	2134	83531913000
138933	1874	36550000
138934	2134	83530910000
138935	1874	36553000
138936	2133	90043736000
138937	1874	36555000
138938	1599	15417039097983
138948	1397	1270573192000
138949	1678	27360856908000
138950	2134	83528904000
138951	1874	36563000
138952	2133	90041732000
138953	1874	36565000
138954	1587	18720514000000
138955	1587	18720526000000
138966	1397	1270553190000
138967	1678	27360856910000
138968	2134	83526898000
138969	1874	36573000
138970	2133	90039728000
138971	1874	36575000
138972	1394	1000815489440200
138973	1394	1000815501440200
138981	1397	1270533188000
138982	1678	27360856912000
138983	2133	90037724000
138984	1874	36582000
138985	2134	83524892000
138986	1874	36585000
138987	2329	324726715819988
138988	2329	324726727819988
138998	2329	325446727819988
138999	2329	325446739819988
139015	1397	1270493184000
139016	1678	27360856916000
139017	1397	1270483183000
139018	1678	27360856917000
139019	1397	1270473182000
139020	1678	27360856918000
139021	1397	1270463181000
139022	1678	27360856919000
139023	2134	83520880000
139024	1874	36603000
139025	2133	90033716000
139026	1874	36605000
139027	2133	90032714000
139028	1874	36607000
139029	2133	90031712000
139030	1874	36609000
139031	2133	90030710000
139032	1874	36611000
139033	2134	83519877000
139034	1874	36614000
139035	2134	83518874000
139036	1874	36617000
139037	2134	83517871000
139038	1874	36620000
139039	344	66720090000000
139040	344	66720138000000
139043	1764	17363562100000
139044	1764	17363610100000
139045	1397	1270453180000
139046	1678	27360856920000
139047	2134	83516868000
139048	1874	36623000
139049	2133	90029708000
139050	1874	36625000
139051	1598	2160070000000
139052	1598	2160082000000
139056	1397	1270443179000
139057	1678	27360856921000
139058	2133	90028706000
139059	1874	36627000
139060	2134	83515865000
139061	1874	36630000
139062	1688	33911068113019
139063	1688	33911080113019
139080	1397	1270413176000
139081	1678	27360856924000
139082	1397	1270403175000
139083	1678	27360856925000
139084	2134	83512856000
139085	1874	36643000
139086	2133	90025700000
139087	1874	36645000
139088	2133	90024698000
139089	1874	36647000
139090	2134	83511853000
139091	1874	36650000
139092	1724	16972952500000
139100	1706	21162339450256
139101	1706	21162351450256
139126	1397	1270353170000
139127	1678	27360856930000
139128	1397	1270343169000
139129	1678	27360856931000
139130	2134	83506838000
139131	1874	36673000
139132	2133	90019688000
139133	1874	36675000
139134	2133	90018686000
139135	1874	36677000
139136	2134	83505835000
139137	1874	36680000
139138	1685	190084808571430
139139	1685	190084832571430
139175	1397	1270293164000
139176	1678	27360856936000
139177	1599	15417049097983
139178	2134	83500820000
139179	1874	36703000
139180	2133	90013676000
139181	1874	36705000
139182	1599	16137049097983
139183	1599	16137051097983
139198	1688	34631080113019
139199	1688	34631104113019
139210	1397	1270253160000
139211	1678	27360856940000
139212	1397	1270243159000
139213	1678	27360856941000
139214	2134	83496808000
139215	1874	36723000
139216	2133	90009668000
139217	1874	36725000
139218	2133	90008666000
139219	1874	36727000
139220	2134	83495805000
139221	1874	36730000
139222	1395	58314152715957278
139253	1397	1270193154000
139254	1678	27360856946000
139255	2134	83490790000
139256	1874	36753000
139257	1726	942846112000
139258	2386	100000000
139259	2133	90003656000
139260	1874	36755000
139261	1688	36071116113019
139262	1688	36071129113019
139286	1397	1270153150000
139287	1678	27360856950000
139288	2134	83486778000
139289	1874	36773000
139290	2133	89999648000
139291	1874	36775000
139292	1499	2160044000000
139295	1560	16569303131803
139296	1874	36516000
139297	1874	36519000
139298	1874	36522000
139299	1874	36531000
139300	1874	36534000
139301	1874	36537000
139302	1874	36546000
139303	1874	36549000
139304	1874	36552000
139305	1874	36558000
139306	1874	36561000
139307	1874	36564000
139308	1874	36567000
139309	1874	36569000
139310	1874	36571000
139311	1874	36579000
139312	1874	36581000
139313	1874	36583000
139314	1874	36587000
139315	1874	36589000
139316	1874	36591000
139317	1874	36593000
139318	1874	36597000
139319	1874	36599000
139320	1874	36601000
139321	1874	36613000
139322	1874	36615000
139323	1874	36619000
139324	1874	36621000
139325	1874	36629000
139326	1874	36631000
139327	1874	36637000
139328	1874	36639000
139329	1874	36641000
139233	2133	90006662000
139234	1874	36740000
139235	1610	15120368999950
139236	1610	15120380999950
139245	1397	1270203155000
139246	1678	27360856945000
139247	2134	83491793000
139248	1874	36748000
139249	2133	90004658000
139250	1874	36750000
139251	1623	83523423898598
139252	1623	83523435898598
139278	1397	1270163151000
139279	1678	27360856949000
139280	2134	83487781000
139281	1874	36768000
139282	2133	90000650000
139283	1874	36770000
139284	1536	19440375000000
139285	1536	19440387000000
139352	1397	1270123147000
139353	1678	27360856953000
139354	2134	83483769000
139355	1874	36788000
139356	2133	89996642000
139357	1874	36790000
139358	1611	4313523402899
139367	1394	1010895610440200
139368	1394	1010895622440200
139390	2152	107998988000000
139391	1654	18857582999798
139392	1654	18857829999798
139427	1397	1270033138000
139428	1678	27360856962000
139429	1397	1270023137000
139430	1678	27360856963000
139431	1397	1270013136000
139432	1678	27360856964000
139433	2134	83473739000
139434	1874	36838000
139435	2134	83472736000
139436	1874	36841000
139437	2134	83471733000
139438	1874	36844000
139439	1395	58314872760957278
139440	2133	89986622000
139441	1874	36846000
139442	2133	89985620000
139443	1874	36848000
139444	2133	89984618000
139445	1874	36850000
139446	1395	58315592760957278
139447	1395	58315592763957278
139457	1521	2880069000000
139458	1521	2880081000000
139459	2250	205000000
139460	1521	2880068000000
139461	2250	207000000
139462	1489	14783279040000
139479	1397	1269973132000
139480	1678	27360856968000
139481	2134	83467721000
139482	1874	36868000
139483	2133	89980610000
139484	1874	36870000
139485	1395	58316312763957278
139486	1395	58316312775957278
139487	1571	6080846387195
139488	1571	6080858387195
139489	1397	1269963131000
139490	1678	27360856969000
139491	1397	1269953130000
139492	1678	27360856970000
139493	1521	67000000
139494	1931	7914486000000
139495	2133	89979608000
139496	1874	36872000
139497	2133	89978606000
139498	1874	36874000
139499	2134	83466718000
139500	1874	36877000
139501	2134	83465715000
139502	1874	36880000
139503	1394	1016655658440200
139504	1394	1016655683440200
139508	1397	1269943129000
139509	1678	27360856971000
139510	2133	89977604000
139511	1874	36882000
139512	2134	83464712000
139513	1874	36885000
139514	1394	1016655670440200
139523	1397	1269923127000
139524	1678	27360856973000
139525	1397	1269913126000
139526	1678	27360856974000
139527	2134	83462706000
139528	1874	36893000
139529	2134	83461703000
139530	1874	36896000
139531	2133	89975600000
139532	1874	36898000
139533	2133	89974598000
139534	1874	36900000
139535	1394	1016655682440200
139550	1397	1269883123000
139551	1678	27360856977000
139552	2134	83458694000
139553	1874	36913000
139554	2133	89971592000
139555	1874	36915000
139556	1717	19261378000055
139604	1397	1269813116000
139605	1678	27360856984000
139606	1397	1269803115000
139607	1678	27360856985000
139608	2133	89964578000
139609	1874	36947000
139610	2134	83451673000
139611	1874	36950000
139612	2134	83450670000
139613	1874	36953000
139614	2133	89963576000
139615	1874	36955000
139616	58	81107648999641
139624	1395	58317032775957278
139625	1395	58317032787957278
139626	498	67441252000000
139627	498	67441264000000
139643	1397	1269763111000
139644	1678	27360856989000
139645	2134	83446658000
139646	1874	36973000
139647	2133	89959568000
139648	1874	36975000
139649	1685	190804832571430
139650	1685	190804844571430
139673	1397	1269723107000
139674	1678	27360856993000
139675	2133	89955560000
139676	1874	36989000
139677	2134	83443649000
139678	1874	36992000
139679	2148	11518356880750
139680	2148	11518368880750
139683	2329	325446769819988
139684	1874	36988000
139685	1874	36990000
139686	2329	326166769819988
139687	2329	326166775819988
139688	1397	1269713106000
139689	1678	27360856994000
139690	2133	89954558000
139691	1874	36994000
139692	2134	83442646000
139693	1874	36997000
139704	1397	1269693104000
139705	1678	27360856996000
139706	2134	83440640000
139707	1874	37005000
139708	2133	89952554000
139709	1874	37007000
139710	1693	3645812623117
139711	1693	3645824623117
139721	1397	1269673102000
139722	1678	27360856998000
139723	2199	720328000000
139724	289	66000000000000
139725	2134	83438634000
139726	1874	37015000
139727	2133	89950550000
139728	1874	37017000
139729	1675	24764676999977
139740	1397	1269653100000
139741	1678	27360857000000
139742	2134	83436628000
139743	1874	37025000
139744	2133	89948546000
139745	1874	37027000
139746	1394	1019535706440200
139747	1394	1019535718440200
139748	1397	1269643099000
139749	1678	27360857001000
139750	1397	1269633098000
139751	1678	27360857002000
139330	1874	36649000
139331	1874	36651000
139332	1874	36659000
139333	1874	36661000
139334	1560	17289303131803
139335	1560	17289454131803
139343	1395	58315592727957278
139344	1395	58315592739957278
139345	1397	1270133148000
139346	1678	27360856952000
139347	2133	89997644000
139348	1874	36782000
139349	2134	83484772000
139350	1874	36785000
139351	1476	17280407000000
139359	1397	1270113146000
139360	1678	27360856954000
139361	2134	83482766000
139362	1874	36793000
139363	2133	89995640000
139364	1874	36795000
139365	1536	20160387000000
139366	1536	20160399000000
139370	1397	1270103145000
139371	1678	27360856955000
139372	1397	1270093144000
139373	1678	27360856956000
139374	2133	89994638000
139375	1874	36797000
139376	2134	83481763000
139377	1874	36800000
139378	2134	83480760000
139379	1874	36803000
139380	2134	83479757000
139381	1874	36806000
139382	2133	89993636000
139383	1874	36808000
139384	2133	89992634000
139385	1874	36810000
139386	1980	25919613000000
139387	1980	25919639000000
139400	1397	1270073142000
139401	1678	27360856958000
139402	1397	1270063141000
139403	1678	27360856959000
139404	1397	1270053140000
139405	1678	27360856960000
139406	2134	83477751000
139407	1874	36818000
139408	2133	89990630000
139409	1874	36820000
139410	2133	89989628000
139411	1874	36822000
139412	2133	89988626000
139413	1874	36824000
139414	2134	83476748000
139415	1874	36827000
139416	2134	83475745000
139417	1874	36830000
139418	1489	14783269040000
139448	1397	1270003135000
139449	1678	27360856965000
139450	2134	83470730000
139451	1874	36853000
139452	2133	89983616000
139453	1874	36855000
139454	2111	4200000000
139455	1521	2878069000000
139456	1521	2878081000000
139463	1397	1269993134000
139464	1678	27360856966000
139465	2133	89982614000
139466	1874	36857000
139467	2134	83469727000
139468	1874	36860000
139469	1394	1013775634440200
139470	1394	1013775646440200
139506	171	77466798696494
139507	171	77466823696494
139536	1397	1269903125000
139537	1678	27360856975000
139538	2133	89973596000
139539	1874	36902000
139540	2134	83460700000
139541	1874	36905000
139557	1397	1269873122000
139558	1678	27360856978000
139559	1397	1269863121000
139560	1678	27360856979000
139561	1397	1269853120000
139562	1678	27360856980000
139563	1397	1269843119000
139564	1678	27360856981000
139565	1397	1269833118000
139566	1678	27360856982000
139567	2133	89970590000
139568	1874	36917000
139569	1726	941745112000
139570	1865	1299000000
139571	2133	89969588000
139572	1874	36919000
139573	2133	89968586000
139574	1874	36921000
139575	1726	940644112000
139576	2387	100000000
139577	1726	939543112000
139578	2388	100000000
139579	1726	938442112000
139580	2389	100000000
139581	2134	83457691000
139582	1874	36924000
139583	2134	83456688000
139584	1874	36927000
139585	2134	83455685000
139586	1874	36930000
139587	2134	83454682000
139588	1874	36933000
139589	2134	83453679000
139590	1874	36936000
139591	2133	89967584000
139592	1874	36938000
139593	2133	89966582000
139594	1874	36940000
139595	1613	14977481400000
139617	1397	1269793114000
139618	1678	27360856986000
139619	2133	89962574000
139620	1874	36957000
139621	2134	83449667000
139622	1874	36960000
139623	1684	31683568819412
139628	1397	1269783113000
139629	1678	27360856987000
139630	1397	1269773112000
139631	1678	27360856988000
139632	2133	89961572000
139633	1874	36962000
139634	2133	89960570000
139635	1874	36964000
139636	2134	83448664000
139637	1874	36967000
139638	2134	83447661000
139639	1874	36970000
139640	1394	1018095682440200
139641	1394	1018095706440200
139651	1397	1269753110000
139652	1678	27360856990000
139653	1474	24290633000043
139654	2192	101000000000
139655	2133	89958566000
139656	1874	36977000
139657	42	75740730000000
139712	1693	3645823623117
139730	1701	16558461500103
139731	1701	16558483500103
139767	1397	1269613096000
139768	1678	27360857004000
139769	2133	89945540000
139770	1874	37042000
139771	2134	83432616000
139772	1874	37045000
139811	1762	12165659994000
139812	1762	12165671994000
139821	1397	1269543089000
139822	1678	27360857011000
139823	2134	83425595000
139824	1874	37078000
139825	2133	89938526000
139826	1874	37080000
139827	1726	937341112000
139828	2391	100000000
139829	1630	1440010000000
139830	1630	1440023000000
139844	1397	1269513086000
139845	1678	27360857014000
139846	1397	1269503085000
139847	1678	27360857015000
139848	1397	1269493084000
139849	1678	27360857016000
139850	2133	89935520000
139851	1874	37092000
139852	2133	89934518000
139853	1874	37094000
139854	2133	89933516000
139855	1874	37096000
139396	1874	36813000
139397	2133	89991632000
139398	1874	36815000
139399	1654	18857594999798
139419	1397	1270043139000
139420	1678	27360856961000
139421	2134	83474742000
139422	1874	36833000
139423	2133	89987624000
139424	1874	36835000
139425	1394	1012335622440200
139426	1394	1012335634440200
139471	1397	1269983133000
139472	1678	27360856967000
139473	2133	89981612000
139474	1874	36862000
139475	2134	83468724000
139476	1874	36865000
139477	1394	1015215646440200
139478	1394	1015215658440200
139505	1673	11015484000000
139515	1397	1269933128000
139516	1678	27360856972000
139517	2134	83463709000
139518	1874	36888000
139519	2133	89976602000
139520	1874	36890000
139521	149	81935466000341
139522	149	81935478000341
139542	1397	1269893124000
139543	1678	27360856976000
139544	2133	89972594000
139545	1874	36907000
139546	2134	83459697000
139547	1874	36910000
139548	1672	14401535000000
139549	1672	14401547000000
139596	1397	1269823117000
139597	1678	27360856983000
139598	2134	83452676000
139599	1874	36943000
139600	2133	89965580000
139601	1874	36945000
139602	1619	10080245000000
139603	1619	10080257000000
139642	484	75453971000000
139658	1397	1269743109000
139659	1678	27360856991000
139660	1397	1269733108000
139661	1678	27360856992000
139662	2134	83445655000
139663	1874	36980000
139664	1634	16943201259504
139665	2134	83444652000
139666	1874	36983000
139667	2133	89957564000
139668	1874	36985000
139669	2133	89956562000
139670	1874	36987000
139671	1634	17663201259504
139672	1634	17663204259504
139681	2148	11520356880750
139682	2148	11520368880750
139694	1724	17692952500000
139695	1724	17692964500000
139696	1397	1269703105000
139697	1678	27360856995000
139698	2134	83441643000
139699	1874	37000000
139700	2133	89953556000
139701	1874	37002000
139702	1685	191524844571430
139703	1685	191524856571430
139713	1397	1269683103000
139714	1678	27360856997000
139715	2134	83439637000
139716	1874	37010000
139717	2133	89951552000
139718	1874	37012000
139719	1513	36721241000000
139720	1513	36721253000000
139732	1397	1269663101000
139733	1678	27360856999000
139734	2133	89949548000
139735	1874	37019000
139736	2134	83437631000
139737	1874	37022000
139738	1672	15121547000000
139739	1672	15121559000000
139773	1698	15189016550062
139774	1698	15189028550062
139790	1397	1269583093000
139791	1678	27360857007000
139792	1397	1269573092000
139793	1678	27360857008000
139794	2133	89942534000
139795	1874	37057000
139796	2133	89941532000
139797	1874	37059000
139798	2134	83429607000
139799	1874	37062000
139800	2134	83428604000
139801	1874	37065000
139802	1394	1020975731440200
139803	1394	1020975755440200
139831	1397	1269533088000
139832	1678	27360857012000
139833	1397	1269523087000
139834	1678	27360857013000
139835	2134	83424592000
139836	1874	37083000
139837	2133	89937524000
139838	1874	37085000
139839	2133	89936522000
139840	1874	37087000
139841	2134	83423589000
139842	1874	37090000
139843	1708	14760705324650
139872	1395	58318472852457278
139873	1395	58318472864457278
139889	1673	11735484000000
139890	1673	11735508000000
139894	1397	1269453080000
139895	1678	27360857020000
139896	1397	1269443079000
139897	1678	27360857021000
139898	2133	89929508000
139899	1874	37122000
139900	2133	89928506000
139901	1874	37124000
139902	2134	83416568000
139903	1874	37127000
139904	2134	83415565000
139905	1874	37130000
139920	2329	326166763819988
139933	1397	1269393074000
139934	1678	27360857026000
139935	2134	83410550000
139936	1874	37153000
139937	2133	89923496000
139938	1874	37155000
139939	1693	4365824623117
139940	1693	4365836623117
139951	1541	5042346000000
139961	1685	192964880571430
139962	1685	192964914571430
139984	1397	1269333068000
139985	1678	27360857032000
139986	1397	1269323067000
139987	1678	27360857033000
139988	2134	83404532000
139989	1874	37183000
139990	2134	83403529000
139991	1874	37186000
139992	529	67440025000000
139993	529	67440047000000
140020	1395	58320632888457278
140021	1395	58320632926457278
140027	1439	13663913578477
140036	1397	1269273062000
140037	1678	27360857038000
140038	2133	89911472000
140039	1874	37212000
140040	2134	83398514000
140041	1874	37215000
140042	1601	9745994620000
140062	1397	1269263061000
140063	1678	27360857039000
140064	1397	1269253060000
140065	1678	27360857040000
140066	2133	89910470000
140067	1874	37217000
140068	2133	89909468000
140069	1874	37219000
140070	2133	89908466000
140071	1874	37221000
140072	2134	83397511000
140073	1874	37224000
140074	2134	83396508000
140075	1874	37227000
140076	2134	83395505000
140077	1874	37230000
140078	1675	25484676999977
140079	1675	25484702999977
140096	1395	58321352900457278
139752	1397	1269623097000
139753	1678	27360857003000
139754	2192	994500000
139755	2390	99000000000
139756	2133	89947544000
139757	1874	37029000
139758	2133	89946542000
139759	1874	37031000
139760	2134	83435625000
139761	1874	37034000
139762	2134	83434622000
139763	1874	37037000
139764	2134	83433619000
139765	1874	37040000
139766	1395	58317032816457278
139775	1397	1269603095000
139776	1678	27360857005000
139777	1397	1269593094000
139778	1678	27360857006000
139779	2133	89944538000
139780	1874	37047000
139781	2133	89943536000
139782	1874	37049000
139783	395	66044730646980
139784	1760	800000000000
139785	2134	83431613000
139786	1874	37052000
139787	2134	83430610000
139788	1874	37055000
139789	1394	1019535731440200
139804	1397	1269563091000
139805	1678	27360857009000
139806	2133	89940530000
139807	1874	37067000
139808	2134	83427601000
139809	1874	37070000
139810	1402	53463605145435
139813	1397	1269553090000
139814	1678	27360857010000
139815	2134	83426598000
139816	1874	37073000
139817	2133	89939528000
139818	1874	37075000
139819	1394	1022415755440200
139820	1394	1022415767440200
139864	1397	1269483083000
139865	1678	27360857017000
139866	2133	89932514000
139867	1874	37107000
139868	2134	83419577000
139869	1874	37110000
139870	1394	1023855767440200
139871	1394	1023855779440200
139876	1397	1269473082000
139877	1678	27360857018000
139878	1397	1269463081000
139879	1678	27360857019000
139880	2134	83418574000
139881	1874	37113000
139882	2134	83417571000
139883	1874	37116000
139884	2133	89931512000
139885	1874	37118000
139886	2133	89930510000
139887	1874	37120000
139888	1394	1023855791440200
139893	1395	58319192864457278
139906	1397	1269433078000
139907	1678	27360857022000
139908	1397	1269423077000
139909	1678	27360857023000
139910	2134	83414562000
139911	1874	37133000
139912	2133	89927504000
139913	1874	37135000
139914	2134	83413559000
139915	1874	37138000
139916	2133	89926502000
139917	1874	37140000
139918	1395	58319912864457278
139919	1395	58319912888457278
139942	1397	1269383073000
139943	1678	27360857027000
139944	1397	1269373072000
139945	1678	27360857028000
139946	2134	83409547000
139947	1874	37158000
139948	2134	83408544000
139949	1874	37161000
139950	1715	11543634663945
139959	610	68160044000000
139960	610	68160078000000
139963	1397	1269363071000
139964	1678	27360857029000
139965	1397	1269353070000
139966	1678	27360857030000
139967	1397	1269343069000
139968	1678	27360857031000
139969	2134	83407541000
139970	1874	37164000
139971	1874	37166000
139972	1874	37168000
139973	2133	89920490000
139974	1874	37170000
139975	2133	89919488000
139976	1874	37172000
139977	2133	89918486000
139978	1874	37174000
139979	2134	83406538000
139980	1874	37177000
139981	2134	83405535000
139982	1874	37180000
139983	1633	10128697125277
140018	1588	16944799000000
140019	1588	16944837000000
140025	2248	12959546000000
140026	2248	12959584000000
140029	1397	1269283063000
140030	1678	27360857037000
140031	2133	89912474000
140032	1874	37207000
140033	2134	83399517000
140034	1874	37210000
140035	1395	58320632900457278
140043	1560	17289914131803
140044	1874	36665000
140045	1874	36667000
140046	1874	36669000
140047	1874	36671000
140048	1874	36679000
140049	1874	36681000
140050	1874	36683000
140051	1874	36689000
140052	1874	36691000
140053	1874	36693000
140054	1874	36699000
140055	1874	36701000
140056	1874	36707000
140057	1874	36709000
140058	1874	36719000
140059	1874	36721000
140060	1560	18009914131803
140061	1560	18010371131803
140088	1397	1269233058000
140089	1678	27360857042000
140090	2133	89906462000
140091	1874	37237000
140092	2134	83393499000
140093	1874	37240000
140094	58	81827648999641
140095	58	81827660999641
140098	1397	1269223057000
140099	1678	27360857043000
140100	1397	1269213056000
140101	1678	27360857044000
140102	2133	89905460000
140103	1874	37242000
140104	2133	89904458000
140105	1874	37244000
140106	2134	83392496000
140107	1874	37247000
140108	2134	83391493000
140109	1874	37250000
140110	1394	1025295779440200
140111	1394	1025295803440200
140121	1397	1269193054000
140122	1678	27360857046000
140123	1397	1269183053000
140124	1678	27360857047000
140125	2134	83389487000
140126	1874	37258000
140127	2133	89902454000
140128	1874	37260000
140129	2133	89901452000
140130	1874	37262000
140131	2134	83388484000
140132	1874	37265000
140133	1395	58321352924457278
140156	1716	2160092000000
140157	1716	2880092000000
140167	1394	1026735803440200
140168	1394	1026735815440200
140173	1397	1269133048000
140174	1678	28080869052000
140175	2134	83383469000
139856	2134	83422586000
139857	1874	37099000
139858	2134	83421583000
139859	1874	37102000
139860	2134	83420580000
139861	1874	37105000
139862	1395	58317752816457278
139863	1395	58317752852457278
139874	1688	36791129113019
139875	1688	36791141113019
139891	1685	192244856571430
139892	1685	192244880571430
139921	1397	1269413076000
139922	1678	27360857024000
139923	1397	1269403075000
139924	1678	27360857025000
139925	2134	83412556000
139926	1874	37143000
139927	2134	83411553000
139928	1874	37146000
139929	2133	89925500000
139930	1874	37148000
139931	2133	89924498000
139932	1874	37150000
139941	1693	4365826623117
139952	2133	89922494000
139953	1874	37157000
139954	1874	37160000
139955	1874	37163000
139956	2133	89921492000
139957	1874	37165000
139958	1718	10336664519070
139994	1397	1269313066000
139995	1678	27360857034000
139996	1397	1269303065000
139997	1678	27360857035000
139998	1397	1269293064000
139999	1678	27360857036000
140000	2134	83402526000
140001	1874	37189000
140002	2133	89917484000
140003	1874	37191000
140004	2133	89916482000
140005	1874	37193000
140006	2134	83401523000
140007	1874	37196000
140008	2134	83400520000
140009	1874	37199000
140010	2133	89915480000
140011	1874	37201000
140012	2133	89914478000
140013	1874	37203000
140014	2133	89913476000
140015	1874	37205000
140016	1423	4320642750023
140017	1423	4320680750023
140022	1874	37192000
140023	1874	37195000
140024	1439	13663908578477
140028	1716	2880094000000
140080	1397	1269243059000
140081	1678	27360857041000
140082	2133	89907464000
140083	1874	37232000
140084	2134	83394502000
140085	1874	37235000
140086	1695	14345240999000
140087	1695	14345252999000
140113	1397	1269203055000
140114	1678	27360857045000
140115	2133	89903456000
140116	1874	37252000
140117	2134	83390490000
140118	1874	37255000
140119	1698	15909028550062
140120	1698	15909040550062
140154	1991	16461555355805
140155	1991	17181555355805
140158	1397	1269143049000
140159	1678	27360857051000
140160	2134	83384472000
140161	1874	37283000
140162	2133	89897444000
140163	1874	37285000
140164	1771	598416214766
140165	1549	15551205000000
140166	1549	15551217000000
140171	1549	15551455000000
140172	1549	15551467000000
140194	1397	1269103045000
140195	1678	28080869055000
140196	1634	18383204259504
140197	1634	18383214259504
140211	1685	193684892571430
140212	1685	193684916571430
140223	1678	27360857052000
140224	1678	27360857053000
140225	1678	27360857054000
140226	1678	27360857055000
140227	1678	27360857056000
140228	1678	27360857057000
140229	1874	36729000
140230	1874	36731000
140231	1874	36737000
140232	1874	36739000
140233	1874	36741000
140234	1874	36747000
140235	1874	36749000
140236	1874	36751000
140237	1874	36761000
140238	1874	36763000
140239	1874	36767000
140240	1874	36769000
140241	1874	36771000
140242	1560	18010606131803
140243	1874	36779000
140244	1874	36781000
140245	1874	36783000
140246	1874	36787000
140247	1874	36789000
140248	1874	36791000
140249	1874	36799000
140250	1874	36801000
140251	1874	36805000
140252	1874	36807000
140253	1874	36809000
140254	1874	36811000
140255	1874	36817000
140256	1874	36819000
140257	1874	36821000
140258	1874	36823000
140259	1874	36825000
140260	1874	36829000
140261	1874	36831000
140262	1874	36837000
140263	1874	36839000
140264	1874	36843000
140265	1874	36845000
140266	1874	36847000
140267	1874	36849000
140268	1874	36851000
140269	1560	18730606131803
140270	1560	18730644131803
140278	1397	1269063041000
140279	1678	28080869059000
140280	2133	89890430000
140281	1874	37320000
140282	2134	83376448000
140283	1874	37323000
140284	1668	14913795000000
140285	1668	14913807000000
140305	1528	720012000000
140320	1397	1269003035000
140321	1678	28080869065000
140322	1397	1268993034000
140323	1678	28080869066000
140324	1397	1268983033000
140325	1678	28080869067000
140326	2133	89884418000
140327	1874	37350000
140328	2133	89883416000
140329	1874	37352000
140330	2133	89882414000
140331	1874	37354000
140332	2134	83370430000
140333	1874	37357000
140334	2134	83369427000
140335	1874	37360000
140336	2134	83368424000
140337	1874	37363000
140338	1723	14402167085979
140346	1395	58322072935457278
140357	1397	1268953030000
140358	1678	28080869070000
140359	1397	1268943029000
140360	1678	28080869071000
140361	2133	89879408000
140362	1874	37372000
140363	2134	83366418000
140364	1874	37375000
140365	2134	83365415000
140366	1874	37378000
140367	2133	89878406000
140368	1874	37380000
140369	1547	13674852000000
140097	1395	58321352912457278
140112	1546	15357622800000
140134	1397	1269173052000
140135	1678	27360857048000
140136	1397	1269163051000
140137	1678	27360857049000
140138	1397	1269153050000
140139	1678	27360857050000
140140	2134	83387481000
140141	1874	37268000
140142	2134	83386478000
140143	1874	37271000
140144	2134	83385475000
140145	1874	37274000
140146	2133	89900450000
140147	1874	37276000
140148	2133	89899448000
140149	1874	37278000
140150	2133	89898446000
140151	1874	37280000
140152	2248	12959620000000
140153	2248	13679620000000
140169	1678	28080857051000
140170	1678	28080869051000
140179	1746	6288969999989
140180	1746	6288981999989
140187	1397	1269113046000
140188	1678	28080869054000
140189	2134	83381463000
140190	1874	37298000
140191	2133	89894438000
140192	1874	37300000
140193	1685	192964892571430
140210	1705	30081113580140
140221	1395	58322072924457278
140222	1395	58322072936457278
140273	1397	1269073042000
140274	1678	28080869058000
140275	2134	83377451000
140276	1874	37318000
140277	1455	6511635000000
140299	1397	1269033038000
140300	1678	28080869062000
140301	2134	83373439000
140302	1874	37336000
140303	2133	89887424000
140304	1874	37338000
140313	1397	1269013036000
140314	1678	28080869064000
140315	2134	83371433000
140316	1874	37346000
140317	2133	89885420000
140318	1874	37348000
140319	1588	16944811000000
140343	2133	89881412000
140344	1874	37365000
140345	1546	16077609800000
140355	1587	19440526000000
140356	1587	19440538000000
140381	1397	1268923027000
140382	1678	28080869073000
140383	2133	89876402000
140384	1874	37387000
140385	2134	83363409000
140386	1874	37390000
140387	2388	99000000
140388	1623	84243435898598
140389	1623	84243448898598
140423	1397	1268863021000
140424	1678	28080869079000
140425	2133	89870390000
140426	1874	37417000
140427	2134	83357391000
140428	1874	37420000
140429	2329	326886775819988
140439	1764	18083574100000
140440	1764	18083586100000
140450	1397	1268833018000
140451	1678	28080869082000
140452	2134	83354382000
140453	1874	37433000
140454	2133	89867384000
140455	1874	37435000
140456	1714	19005830171760
140464	1397	1268823017000
140465	1678	28080869083000
140466	1397	1268813016000
140467	1678	28080869084000
140468	2134	83352376000
140469	1874	37443000
140470	2134	83351373000
140471	1874	37446000
140472	2133	89865380000
140473	1874	37448000
140474	2133	89864378000
140475	1874	37450000
140476	1509	16943442503835
140477	1509	16943466503835
140478	1397	1268803015000
140479	1678	28080869085000
140480	2134	83350370000
140481	1874	37453000
140482	2133	89863376000
140483	1874	37455000
140484	606	80446963286230
140487	1654	19577829999798
140488	1654	19577855999798
140497	1451	8347823000000
140501	1397	1268783013000
140502	1678	28080869087000
140503	2133	89861372000
140504	1874	37462000
140505	2134	83348364000
140506	1874	37465000
140507	1698	16629040550062
140508	1698	16629052550062
140526	1397	1268753010000
140527	1678	28080869090000
140528	2133	89858366000
140529	1874	37477000
140530	2134	83345355000
140531	1874	37480000
140532	1588	17664811000000
140533	1588	17664823000000
140538	1397	1268743009000
140539	1678	28080869091000
140540	1397	1268733008000
140541	1678	28080869092000
140542	1397	1268723007000
140543	1678	28080869093000
140544	2133	89857364000
140545	1874	37482000
140546	2133	89856362000
140547	1874	37484000
140548	2133	89855360000
140549	1874	37486000
140550	2134	83344352000
140551	1874	37489000
140552	2134	83343349000
140553	1874	37492000
140554	2134	83342346000
140555	1874	37495000
140556	1395	58323512973457278
140573	1397	1268693004000
140574	1678	28080869096000
140575	2133	89852354000
140576	1874	37507000
140577	2134	83339337000
140578	1874	37510000
140579	1726	936240112000
140580	2392	100000000
140581	1419	26206228559748
140593	2134	83338334000
140594	1874	37513000
140595	2134	83337331000
140596	1874	37516000
140597	1874	37518000
140598	1874	37520000
140599	1657	10081432990100
140605	1397	1268663001000
140606	1678	28080869099000
140607	1397	1268653000000
140608	1678	28080869100000
140609	1397	1268642999000
140610	1678	28080869101000
140611	1397	1268632998000
140612	1678	28080869102000
140613	1397	1268622997000
140614	1678	28080869103000
140615	2133	89849348000
140616	1874	37522000
140617	2133	89848346000
140618	1874	37524000
140619	2133	89847344000
140620	1874	37526000
140621	2133	89846342000
140622	1874	37528000
140623	2133	89845340000
140624	1874	37530000
140625	2134	83336328000
140626	1874	37533000
140627	2134	83335325000
140628	1874	37536000
140629	2134	83334322000
140630	1874	37539000
140176	1874	37288000
140177	2133	89896442000
140178	1874	37290000
140181	1397	1269123047000
140182	1678	28080869053000
140183	2133	89895440000
140184	1874	37292000
140185	2134	83382466000
140186	1874	37295000
140198	1397	1269093044000
140199	1678	28080869056000
140200	2134	83380460000
140201	1874	37303000
140202	2134	83379457000
140203	1874	37306000
140204	2133	89893436000
140205	1874	37308000
140206	2133	89892434000
140207	1874	37310000
140208	1705	30081089580140
140209	1705	30081103580140
140213	1397	1269083043000
140214	1678	28080869057000
140215	2134	83378454000
140216	1874	37313000
140217	2133	89891432000
140218	1874	37315000
140219	1467	8080326272869
140220	1467	8080338272869
140271	1560	18008855131803
140272	1560	18008867131803
140286	1397	1269053040000
140287	1678	28080869060000
140288	1397	1269043039000
140289	1678	28080869061000
140290	2133	89889428000
140291	1874	37325000
140292	2134	83375445000
140293	1874	37328000
140294	2133	89888426000
140295	1874	37330000
140296	2134	83374442000
140297	1874	37333000
140298	1608	18858645000000
140306	1397	1269023037000
140307	1678	28080869063000
140308	2133	89886422000
140309	1874	37340000
140310	2134	83372436000
140311	1874	37343000
140312	1686	18392188700123
140339	1397	1268973032000
140340	1678	28080869068000
140341	1546	16077598800000
140342	1546	16077608800000
140347	1397	1268963031000
140348	1678	28080869069000
140349	2134	83367421000
140350	1874	37368000
140351	2133	89880410000
140352	1874	37370000
140353	1394	1028175815440200
140354	1394	1028175827440200
140379	632	81837729000000
140380	632	81837741000000
140422	1601	9746042620000
140433	1397	1268853020000
140434	1678	28080869080000
140435	2133	89869388000
140436	1874	37422000
140437	2134	83356388000
140438	1874	37425000
140447	2133	89868386000
140448	1874	37430000
140449	1693	5085838623117
140458	2133	89866382000
140459	1874	37437000
140460	2134	83353379000
140461	1874	37440000
140462	1395	58322792935457278
140463	1395	58322792937457278
140493	2134	83349367000
140494	1874	37458000
140495	2133	89862374000
140496	1874	37460000
140499	1654	19577594999798
140500	1654	19577606999798
140515	1747	6546058999992
140516	1747	6546070999992
140519	1397	1268763011000
140520	1678	28080869089000
140521	2134	83346358000
140522	1874	37473000
140523	2133	89859368000
140524	1874	37475000
140525	1402	54183617145435
140536	1764	18803586100000
140537	1764	18803598100000
140571	2261	12959358000000
140572	2261	12959382000000
140584	1397	1268683003000
140585	1678	28080869097000
140586	1397	1268673002000
140587	1678	28080869098000
140588	2133	89851352000
140589	1874	37512000
140590	2133	89850350000
140591	1874	37514000
140592	1657	10081430990100
140602	1564	14048351000000
140603	1564	14768351000000
140604	1564	14769371000000
140638	1622	10404112800048
140642	1397	1268612996000
140643	1678	28080869104000
140644	1397	1268602995000
140645	1678	28080869105000
140646	1397	1268592994000
140647	1678	28080869106000
140648	2133	89844338000
140649	1874	37532000
140650	2133	89843336000
140651	1874	37534000
140652	2133	89842334000
140653	1874	37548000
140654	1874	37551000
140655	2134	83331313000
140656	1874	37554000
140657	2134	83330310000
140658	1874	37557000
140659	2134	83329307000
140660	1874	37560000
140661	632	82557741000000
140662	632	82557832000000
140667	1397	1268582993000
140668	1678	28080869107000
140669	2134	83328304000
140670	1874	37563000
140671	2133	89841332000
140672	1874	37565000
140673	1518	10800418000000
140711	1668	15633807000000
140712	1668	15633831000000
140717	1397	1268522987000
140718	1678	28080869113000
140719	2134	83322286000
140720	1874	37594000
140721	2132	147265278000
140722	1874	37595000
140723	2133	89835320000
140724	1874	37597000
140725	2106	5040201000000
140726	2106	5040214000000
140729	1397	1268512986000
140730	1678	28080869114000
140731	2134	83321283000
140732	1874	37600000
140733	2133	89834318000
140734	1874	37602000
140778	1688	36791166113019
140787	2329	328326787819988
140788	2329	328326799819988
140789	1397	1268442979000
140790	1678	28080869121000
140791	2134	83314262000
140792	1874	37637000
140793	2133	89827304000
140794	1874	37639000
140795	1613	15697481400000
140796	1613	15697493400000
140826	1601	10466042620000
140827	1601	10466054620000
140843	1692	12700849819983
140844	1397	1268382973000
140845	1678	28080869127000
140846	1464	2158024000000
140847	2393	1000000000
140848	2133	89821292000
140849	1874	37668000
140850	2134	83308244000
140851	1874	37671000
140852	1688	37511166113019
140853	1688	37511188113019
140870	1394	1031055839440200
140871	1394	1031055864440200
140370	1547	13674876000000
140371	1397	1268933028000
140372	1678	28080869072000
140373	2133	89877404000
140374	1874	37382000
140375	2134	83364412000
140376	1874	37385000
140377	1671	19104318003785
140378	1671	19104330003785
140390	1397	1268913026000
140391	1678	28080869074000
140392	1397	1268903025000
140393	1678	28080869075000
140394	1397	1268893024000
140395	1678	28080869076000
140396	1397	1268883023000
140397	1678	28080869077000
140398	1397	1268873022000
140399	1678	28080869078000
140400	2134	83362406000
140401	1874	37393000
140402	2134	83361403000
140403	1874	37396000
140404	2134	83360400000
140405	1874	37399000
140406	2134	83359397000
140407	1874	37402000
140408	2133	89875400000
140409	1874	37404000
140410	2133	89874398000
140411	1874	37406000
140412	2133	89873396000
140413	1874	37408000
140414	2133	89872394000
140415	1874	37410000
140416	2133	89871392000
140417	1874	37412000
140418	2134	83358394000
140419	1874	37415000
140420	1402	54183605145435
140421	1402	54183665145435
140430	1564	13327101000000
140431	1564	14047101000000
140432	1564	14048121000000
140441	1397	1268843019000
140442	1678	28080869081000
140443	2134	83355385000
140444	1874	37428000
140445	1693	5085826623117
140446	1693	5085837623117
140457	1714	19005820171760
140485	1506	9360275967172
140486	1506	9360287967172
140489	1397	1268793014000
140490	1678	28080869086000
140491	1451	8347812000000
140492	1451	8347822000000
140498	1451	8347824000000
140509	1397	1268773012000
140510	1678	28080869088000
140511	2133	89860370000
140512	1874	37467000
140513	2134	83347361000
140514	1874	37470000
140517	1455	7231635000000
140518	1455	7231647000000
140534	1395	58323512937457278
140535	1395	58323512949457278
140557	1397	1268713006000
140558	1678	28080869094000
140559	1397	1268703005000
140560	1678	28080869095000
140561	2133	89854358000
140562	1874	37497000
140563	2133	89853356000
140564	1874	37499000
140565	2134	83341343000
140566	1874	37502000
140567	2134	83340340000
140568	1874	37505000
140569	1394	1029615827440200
140570	1394	1029615851440200
140582	1680	15853401499559
140583	1680	15853414499559
140600	1675	26204702999977
140601	1675	26204726999977
140640	1690	186485846000000
140641	1690	186485847000000
140665	1623	84963448898598
140666	1623	84963539898598
140697	1397	1268542989000
140698	1678	28080869111000
140699	1397	1268532988000
140700	1678	28080869112000
140701	2133	89837324000
140702	1874	37583000
140703	2133	89836322000
140704	1874	37585000
140705	2134	83324292000
140706	1874	37588000
140707	2134	83323289000
140708	1874	37591000
140709	1699	4320364750126
140710	1699	4320388750126
140715	2086	4320391300069
140716	2086	4320415300069
140728	1559	13986237999999
140737	1395	58324232973457278
140738	1395	58324232985457278
140739	1685	193684904571430
140740	1397	1268502985000
140741	1678	28080869115000
140742	2133	89833316000
140743	1874	37604000
140744	2134	83320280000
140745	1874	37607000
140746	1394	1029615839440200
140756	1476	17280408000000
140757	1397	1268482983000
140758	1678	28080869117000
140759	1397	1268472982000
140760	1678	28080869118000
140761	1397	1268462981000
140762	1678	28080869119000
140763	2134	83318274000
140764	1874	37616000
140765	2133	89831312000
140766	1874	37618000
140767	2132	147263276000
140768	1874	37619000
140769	2133	89830310000
140770	1874	37621000
140771	2133	89829308000
140772	1874	37623000
140773	2134	83317271000
140774	1874	37626000
140775	2134	83316268000
140776	1874	37629000
140777	1395	58324233010457278
140779	1992	16561117990000
140780	1992	16561154990000
140781	1397	1268452980000
140782	1678	28080869120000
140783	2134	83315265000
140784	1874	37632000
140785	2133	89828306000
140786	1874	37634000
140797	633	81550233900000
140798	633	82270233900000
140799	633	82270853900000
140816	633	82269603900000
140817	633	82269628900000
140818	1397	1268412976000
140819	1678	28080869124000
140820	2133	89824298000
140821	1874	37652000
140822	2134	83311253000
140823	1874	37655000
140824	2261	14399419000000
140825	2261	14399431000000
140828	1397	1268402975000
140829	1678	28080869125000
140830	1397	1268392974000
140831	1678	28080869126000
140832	2134	83310250000
140833	1874	37658000
140834	2134	83309247000
140835	1874	37661000
140836	2133	89823296000
140837	1874	37663000
140838	2132	147261274000
140839	1874	37664000
140840	2133	89822294000
140841	1874	37666000
140842	1419	26206240559748
140854	1397	1268372972000
140855	1678	28080869128000
140856	1397	1268362971000
140857	1678	28080869129000
140858	2133	89820290000
140859	1874	37673000
140860	2132	147260273000
140861	1874	37674000
140862	2133	89819288000
140863	1874	37676000
140631	2134	83333319000
140632	1874	37542000
140633	2134	83332316000
140634	1874	37545000
140635	1520	720160000026
140636	1622	10404052800048
140637	1622	10404107800048
140639	1520	720105000026
140663	1455	7951647000000
140664	1455	7951738000000
140674	1397	1268572992000
140675	1678	28080869108000
140676	1397	1268562991000
140677	1678	28080869109000
140678	1397	1268552990000
140679	1678	28080869110000
140680	2261	12959412000000
140681	2133	89840330000
140682	1874	37567000
140683	2134	83327301000
140684	1874	37570000
140685	2133	89839328000
140686	1874	37572000
140687	2133	89838326000
140688	1874	37574000
140689	2132	147266279000
140690	1874	37575000
140691	2134	83326298000
140692	1874	37578000
140693	2134	83325295000
140694	1874	37581000
140695	2261	13679412000000
140696	2261	13679419000000
140713	1604	3600000
140714	2087	4035447047766
140727	1448	13639926000001
140735	2329	327606775819988
140736	2329	327606787819988
140747	1397	1268492984000
140748	1678	28080869116000
140749	2134	83319277000
140750	1874	37610000
140751	2132	147264277000
140752	1874	37611000
140753	2133	89832314000
140754	1874	37613000
140755	1706	21162352450256
140800	1397	1268432978000
140801	1678	28080869122000
140802	1397	1268422977000
140803	1678	28080869123000
140804	2134	83313259000
140805	1874	37642000
140806	2132	147262275000
140807	1874	37643000
140808	2133	89826302000
140809	1874	37645000
140810	2133	89825300000
140811	1874	37647000
140812	2134	83312256000
140813	1874	37650000
140814	1714	19725830171760
140815	1714	19725855171760
140912	1397	1268302965000
140913	1678	28080869135000
140914	1397	1268292964000
140915	1678	28080869136000
140916	2132	147258271000
140917	1874	37707000
140918	2134	83300220000
140919	1874	37710000
140920	1271	1349886506000000
140921	2134	83299217000
140922	1874	37713000
140923	697	66000000999998
140924	1271	1350606505500001
140925	697	66000001999996
140926	1271	1350606505500003
140943	470	78835361000000
140948	1397	1268262961000
140949	1678	28080869139000
140950	1657	10801444990100
140958	1714	19725851171760
140959	1599	16857051097983
140960	1599	16857072097983
140977	1397	1268222957000
140978	1678	28080869143000
140979	2134	83293199000
140980	1874	37732000
140981	2132	147256269000
140982	1874	37733000
140983	1447	22601944683000
140984	1447	22601956683000
140999	1695	15785276999000
141000	1695	15785287999000
141013	1397	1268172952000
141014	1678	28080869148000
141015	2134	83288184000
141016	1874	37749000
141017	1701	16558472500103
141046	1397	1268132948000
141047	1678	28080869152000
141048	2134	83284172000
141049	1874	37762000
141050	1759	11737317139889
141069	1397	1268092944000
141070	1678	28080869156000
141071	1397	1268082943000
141072	1678	28080869157000
141073	2134	83280160000
141074	1874	37775000
141075	2132	147252265000
141076	1874	37776000
141077	2134	83279157000
141078	1874	37779000
141079	1594	18721944000000
141080	1594	18721967000000
141092	1397	1268062941000
141093	1678	28080869159000
141094	2134	83277151000
141095	1874	37785000
141096	1874	37786000
141097	1688	38231188113019
141098	1688	38231200113019
141130	1397	1267992934000
141131	1678	28080869166000
141132	1397	1267982933000
141133	1678	28080869167000
141134	1397	1267972932000
141135	1678	28080869168000
141136	2134	83270130000
141137	1874	37808000
141138	2134	83269127000
141139	1874	37811000
141140	2134	83268124000
141141	1874	37814000
141142	2132	147249262000
141143	1874	37815000
141144	1675	27644724999977
141145	1675	27644758999977
141148	1594	19441967000000
141149	1594	19442001000000
141154	641	82563982000000
141155	1397	1267962931000
141156	1678	28080869169000
141157	1395	58323512983457278
141158	2134	83267121000
141159	1874	37818000
141160	2132	147248261000
141161	1874	37819000
141162	1395	58324232983457278
141169	2221	200000100
141170	1509	17663477503735
141173	1680	16573414499559
141195	1397	1267942929000
141196	1678	28080869171000
141197	1397	1267932928000
141198	1678	28080869172000
141199	1397	1267922927000
141200	1678	28080869173000
141201	2134	83265115000
141202	1874	37825000
141203	2134	83264112000
141204	1874	37828000
141205	2134	83263109000
141206	1874	37831000
141207	2132	147247260000
141208	1874	37832000
141209	1706	21882352450256
141210	1706	21882386450256
141212	1397	1267912926000
141213	1678	28080869174000
141214	2134	83262106000
141215	1874	37835000
141216	1671	19104329003785
141220	2086	5040415300069
141221	2086	5040426300069
141223	2112	27887055101924
141237	1397	1267882923000
141238	1678	28080869177000
141239	2134	83258094000
141240	1874	37848000
141241	1688	39671222113019
141242	1688	39671233113019
141257	1397	1267852920000
140864	2134	83307241000
140865	1874	37679000
140866	2134	83306238000
140867	1874	37682000
140868	1768	24947150110000
140869	1768	24947175110000
140886	1397	1268332968000
140887	1678	28080869132000
140888	2133	89816282000
140889	1874	37694000
140890	2134	83303229000
140891	1874	37697000
140892	1693	5805838623117
140893	1693	5805850623117
140905	1397	1268312966000
140906	1678	28080869134000
140907	1464	14000000
140908	2393	2159000000000
140909	2134	83301223000
140910	1874	37706000
140911	2329	328326808819988
140940	1691	13391166300052
140944	2132	147257270000
140945	1874	37720000
140946	1657	10801432990100
140947	1657	10801434990100
140971	1397	1268232958000
140972	1678	28080869142000
140973	2134	83294202000
140974	1874	37729000
140975	43	81840281890000
140976	43	81840292890000
140991	1397	1268202955000
140992	1678	28080869145000
140993	2134	83291193000
140994	1874	37739000
140995	1684	32403580819412
140996	1684	32403591819412
141001	1397	1268192954000
141002	1678	28080869146000
141003	1397	1268182953000
141004	1678	28080869147000
141005	2394	1438994500000
141006	2132	147255268000
141007	1874	37740000
141008	2134	83290190000
141009	1874	37743000
141010	2134	83289187000
141011	1874	37746000
141012	1668	15633835500000
141041	1397	1268142949000
141042	1678	28080869151000
141043	2134	83285175000
141044	1874	37759000
141045	1710	16794119664140
141063	1397	1268102945000
141064	1678	28080869155000
141065	2134	83281163000
141066	1874	37772000
141067	1675	26924713999977
141068	1675	26924724999977
141087	1874	37469000
141088	2132	147251264000
141089	1874	37471000
141090	1690	187925892000000
141091	1690	187925895000000
141120	1397	1268012936000
141121	1678	28080869164000
141122	1397	1268002935000
141123	1678	28080869165000
141124	2134	83272136000
141125	1874	37802000
141126	2134	83271133000
141127	1874	37805000
141128	1688	38951200113019
141129	1688	38951222113019
141146	1402	54903617145435
141147	1402	54903651145435
141150	1623	85683539898598
141151	1623	85683573898598
141152	1692	14140881819983
141153	1692	14140915819983
141190	1680	16573425499559
141211	1762	12165693994000
141217	1699	4320375750126
141222	2087	4035434147766
141243	1397	1267872922000
141244	1678	28080869178000
141245	2132	147245258000
141246	1874	37849000
141247	2134	83257091000
141248	1874	37852000
141249	1656	17275581999990
141250	1656	17275593999990
141262	1397	1267842919000
141263	1678	28080869181000
141264	1397	1267832918000
141265	1678	28080869182000
141266	2134	83254082000
141267	1874	37861000
141268	2134	83253079000
141269	1874	37864000
141270	2132	147244257000
141271	1874	37865000
141272	1394	1033935863440200
141273	1394	1033935886440200
141275	1874	37476000
141276	1874	37478000
141277	1690	189365899000000
141278	1690	189365903000000
141296	1397	1267792914000
141297	1678	28080869186000
141298	2134	83249067000
141299	1874	37878000
141300	1688	40391233113019
141301	1688	40391244113019
141323	2134	83245055000
141324	1874	37891000
141325	1467	8080327272869
141328	1555	18246312540449
141329	1555	18246313540449
141347	1656	17275592999990
141348	1397	1267712906000
141349	1678	28080869194000
141350	2134	83241043000
141351	1874	37904000
141352	1394	1036815908440200
141381	2394	1438984500000
141382	1397	1267662901000
141383	1678	28080869199000
141384	2134	83236028000
141385	1874	37921000
141386	1476	17280416000000
141401	1723	15122167085979
141402	1723	15122178085979
141405	1549	15551466000000
141406	1397	1267632898000
141407	1678	28080869202000
141408	2134	83233019000
141409	1874	37930000
141410	2132	147238251000
141411	1874	37931000
141412	1560	18728867131803
141413	1560	18728879131803
141421	1397	1267612896000
141422	1678	28080869204000
141423	2134	83231013000
141424	1874	37937000
141425	1476	18000416000000
141426	1476	18000427000000
141429	1397	1267602895000
141430	1678	28080869205000
141431	2134	83230010000
141432	1874	37940000
141433	2132	147237250000
141434	1874	37941000
141449	1419	26926240559748
141450	1419	26926264559748
141451	1397	1267572892000
141452	1678	28080869208000
141453	2132	147236249000
141454	1874	37948000
141455	2134	83227001000
141456	1874	37951000
141468	1394	1041135931440200
141469	1394	1041135942440200
141477	58	81827659999641
141486	1397	1267522887000
141487	1678	28080869213000
141488	2134	83221986000
141489	1874	37967000
141490	1467	8800327272869
141491	1467	8800338272869
141515	1874	36456000
141516	1874	36458000
141517	1874	36460000
141518	1874	36462000
141519	1874	36464000
141520	1874	36466000
141521	1874	36467000
141522	1874	36469000
141523	1874	36471000
141524	1874	36472000
141525	1874	36474000
141526	1874	36475000
140872	1397	1268352970000
140873	1678	28080869130000
140874	1397	1268342969000
140875	1678	28080869131000
140876	2133	89818286000
140877	1874	37684000
140878	2134	83305235000
140879	1874	37687000
140880	2134	83304232000
140881	1874	37690000
140882	2133	89817284000
140883	1874	37692000
140884	1695	15065252999000
140885	1695	15065276999000
140894	2112	27887044101924
140895	2112	27887056101924
140896	1397	1268322967000
140897	1678	28080869133000
140898	2134	83302226000
140899	1874	37700000
140900	2132	147259272000
140901	1874	37701000
140902	2133	89815280000
140903	1874	37703000
140904	1394	1031055852440200
140927	1397	1268282963000
140928	1678	28080869137000
140929	2134	83298214000
140930	1874	37716000
140931	1522	13723835000000
140932	1522	13723846000000
140933	1675	26204713999977
140934	1397	1268272962000
140935	1678	28080869138000
140936	2134	83297211000
140937	1874	37719000
140938	470	78835351000000
140939	470	78835362000000
140941	1474	25010633000043
140942	1474	25010643000043
140951	1397	1268252960000
140952	1678	28080869140000
140953	96	66001212000000
140954	2394	1439000000000
140955	2134	83296208000
140956	1874	37723000
140957	1522	13723856000000
140961	1397	1268242959000
140962	1678	28080869141000
140963	2134	83295205000
140964	1874	37726000
140965	1726	935139112000
140966	2395	100000000
140967	1726	934038112000
140968	2396	100000000
140969	2329	329046808819988
140970	2329	329046821819988
140985	1397	1268212956000
140986	1678	28080869144000
140987	2134	83292196000
140988	1874	37736000
140989	1739	31679851000000
140990	1739	31679862000000
140997	1751	2159011000000
140998	1751	2159022000000
141018	1397	1268162951000
141019	1678	28080869149000
141020	2132	147254267000
141021	1874	37750000
141022	2134	83287181000
141023	1874	37753000
141024	1420	2154962980000
141025	1420	2154974980000
141026	1874	37456000
141027	1874	37457000
141028	1874	37459000
141029	1874	37461000
141030	1874	37463000
141031	1874	37464000
141032	1874	37466000
141033	1874	37468000
141034	1690	187205847000000
141035	1690	187205892000000
141036	1397	1268152950000
141037	1678	28080869150000
141038	2134	83286178000
141039	1874	37756000
141040	1692	12700835819983
141051	1397	1268122947000
141052	1678	28080869153000
141053	1397	1268112946000
141054	1678	28080869154000
141055	2132	147253266000
141056	1874	37763000
141057	2134	83283169000
141058	1874	37766000
141059	2134	83282166000
141060	1874	37769000
141061	1657	11521444990100
141062	1657	11521467990100
141081	1397	1268072942000
141082	1678	28080869158000
141083	2134	83278154000
141084	1874	37782000
141085	1657	12241467990100
141086	1657	12241478990100
141099	1397	1268052940000
141100	1678	28080869160000
141101	1397	1268042939000
141102	1678	28080869161000
141103	1397	1268032938000
141104	1678	28080869162000
141105	1397	1268022937000
141106	1678	28080869163000
141107	2132	147250263000
141108	1874	37787000
141109	2134	83276148000
141110	1874	37790000
141111	2134	83275145000
141112	1874	37793000
141113	2358	50099000000
141114	2134	83274142000
141115	1874	37796000
141116	2134	83273139000
141117	1874	37799000
141118	1692	13420835819983
141119	1692	13420881819983
141163	1397	1267952930000
141164	1678	28080869170000
141165	2134	83266118000
141166	1874	37822000
141167	1509	17663466503835
141168	1509	17663477503835
141171	1394	1032495852440200
141172	1394	1032495863440200
141174	1874	37281000
141175	1874	37282000
141176	1874	37284000
141177	1874	37286000
141178	1874	37287000
141179	1874	37289000
141180	1874	37291000
141181	1874	37293000
141182	1874	37294000
141183	1874	37296000
141184	1874	37297000
141185	1874	37299000
141186	2348	100000100
141187	1513	37441252999900
141188	1513	37441306399900
141189	1604	4100000
141191	1874	37472000
141192	1874	37474000
141193	1690	188645895000000
141194	1690	188645899000000
141218	1395	58324952985457278
141219	1395	58324952996457278
141224	1397	1267902925000
141225	1678	28080869175000
141226	1397	1267892924000
141227	1678	28080869176000
141228	2132	147246259000
141229	1874	37836000
141230	2134	83261103000
141231	1874	37839000
141232	2134	83260100000
141233	1874	37842000
141234	2134	83259097000
141235	1874	37845000
141236	1691	13391180300052
141251	2329	329766821819988
141252	2329	329766833819988
141253	1397	1267862921000
141254	1678	28080869179000
141255	2134	83256088000
141256	1874	37855000
141274	484	75453970000000
141279	1397	1267822917000
141280	1678	28080869183000
141281	2134	83252076000
141282	1874	37868000
141284	1397	1267812916000
141285	1678	28080869184000
141286	2134	83251073000
141287	1874	37871000
141258	1678	28080869180000
141259	2134	83255085000
141260	1874	37858000
141261	1706	21882363450256
141283	1690	190085903000000
141290	1397	1267802915000
141291	1678	28080869185000
141292	2132	147243256000
141293	1874	37872000
141294	2134	83250070000
141295	1874	37875000
141308	1397	1267772912000
141309	1678	28080869188000
141310	2132	147242255000
141311	1874	37882000
141312	2134	83247061000
141313	1874	37885000
141314	1471	20105519900000
141315	1471	20105531900000
141341	1397	1267722907000
141342	1678	28080869193000
141343	2134	83242046000
141344	1874	37901000
141345	1711	19147073000000
141346	1711	19147084000000
141359	1680	17293425499559
141360	1680	17293437499559
141367	1397	1267682903000
141368	1678	28080869197000
141369	2134	83238034000
141370	1874	37914000
141371	1717	19981378000055
141372	1717	19981389000055
141395	1397	1267642899000
141396	1678	28080869201000
141397	2134	83234022000
141398	1874	37927000
141399	1394	1039695920440200
141400	1394	1039695931440200
141416	1397	1267622897000
141417	1678	28080869203000
141418	2134	83232016000
141419	1874	37934000
141420	1426	17610505000000
141463	1397	1267552890000
141464	1678	28080869210000
141465	2134	83224995000
141466	1874	37957000
141467	1991	17181530355805
141472	1397	1267542889000
141473	1678	28080869211000
141474	2134	83223992000
141475	1874	37960000
141476	1670	12241120000000
141494	1397	1267512886000
141495	1678	28080869214000
141496	2134	83220983000
141497	1874	37970000
141498	641	82563959000000
141514	2306	4319133000000
141549	1688	41111268113019
141565	1681	18574825358535
141566	1681	18574836358535
141568	1397	1267432878000
141569	1678	28080869222000
141570	2134	83212959000
141571	1874	37996000
141572	2132	147232245000
141573	1874	37997000
141574	1693	6525862623117
141576	1739	32399862000000
141577	1739	32399874000000
141590	1685	193684903571430
141632	2329	331206855819988
141633	2329	331206866819988
141636	1397	1267352870000
141637	1678	28080869230000
141638	2134	83204935000
141639	1874	38023000
141657	1532	1440045000000
141658	1532	1440057000000
141665	1397	1267312866000
141666	1678	28080869234000
141667	2134	83200923000
141668	1874	38036000
141669	1394	1045455965440200
141670	1394	1045455976440200
141689	1509	18383477503835
141690	1509	18383488503835
141691	1397	1267282863000
141692	1678	28080869237000
141693	1397	1267272862000
141694	1678	28080869238000
141695	2134	83197914000
141696	1874	38046000
141697	2132	147227240000
141698	1874	38047000
141699	2134	83196911000
141700	1874	38050000
141701	1679	18718485656999
141721	1397	1267232858000
141722	1678	28080869242000
141723	1397	1267222857000
141724	1678	28080869243000
141725	2134	83192899000
141726	1874	38062000
141727	2132	147226239000
141728	1874	38063000
141729	2280	199000000
141730	2134	83191896000
141731	1874	38066000
141732	1688	41831268113019
141733	1688	41831292113019
141786	1397	1267112846000
141787	1678	28080869254000
141788	1397	1267102845000
141789	1678	28080869255000
141790	2132	147222235000
141791	1874	38097000
141792	2134	83181866000
141793	1874	38100000
141794	2134	83180863000
141795	1874	38103000
141796	1686	19112188700123
141797	1686	19112211700123
141830	1698	17349063550062
141841	1692	14140904819983
141853	1547	13674855000000
141892	1397	1266972832000
141893	1678	28080869268000
141894	1397	1266962831000
141895	1678	28080869269000
141896	1397	1266952830000
141897	1678	28080869270000
141898	2134	83167824000
141899	1874	38143000
141900	2134	83166821000
141901	1874	38146000
141902	2134	83165818000
141903	1874	38149000
141904	1536	20880399000000
141905	1536	20880432000000
141908	641	83283959000000
141909	641	83283992000000
141916	1746	6288980999989
141934	1701	17278472500103
141935	1701	17278516500103
141992	1874	37493000
141993	1874	37494000
141994	1874	37496000
141995	1874	37498000
141996	1874	37500000
141997	1874	37501000
141998	1690	191525920000000
141999	1690	191525945000000
142014	1714	19725841171760
142022	329	66000591000000
142023	2401	1366000000000
142024	1397	1266762811000
142025	1678	28080869289000
142026	1397	1266752810000
142027	1678	28080869290000
142028	2134	83145758000
142029	1874	38209000
142030	2134	83144755000
142031	1874	38212000
142032	1688	42551312113019
142033	1688	42551344113019
142046	1397	1266722807000
142047	1678	28080869293000
142048	2134	83141746000
142049	1874	38221000
142050	1695	16505299999000
142051	1695	16505310999000
142054	1397	1266712806000
142055	1678	28080869294000
142056	2134	83140743000
142057	1874	38224000
142058	1458	22985490908540
142070	1397	1266682803000
142071	1678	28080869297000
142072	2134	83137734000
142073	1874	38233000
142074	1610	15840380999950
142075	1610	15840391999950
141288	1526	1440000000000
141289	1526	1440011000000
141316	1397	1267762911000
141317	1678	28080869189000
141318	1397	1267752910000
141319	1678	28080869190000
141320	2134	83246058000
141321	1874	37888000
141322	470	78835372000000
141326	1394	1036815897440200
141327	1394	1036815898440200
141330	1397	1267742909000
141331	1678	28080869191000
141332	1397	1267732908000
141333	1678	28080869192000
141334	2134	83244052000
141335	1874	37894000
141336	2134	83243049000
141337	1874	37897000
141338	2132	147241254000
141339	1874	37898000
141340	2329	329766844819988
141361	1397	1267692904000
141362	1678	28080869196000
141363	2134	83239037000
141364	1874	37911000
141365	1596	9360305000002
141366	1596	9360316000002
141387	1397	1267652900000
141388	1678	28080869200000
141389	2394	1438974500000
141390	2039	20059860000000
141391	2134	83235025000
141392	1874	37924000
141393	2039	20779860000000
141394	2039	20779861000000
141414	1426	17610494000000
141415	1426	17610514000000
141435	1397	1267592894000
141436	1678	28080869206000
141437	1397	1267582893000
141438	1678	28080869207000
141439	2134	83229007000
141440	1874	37944000
141441	1769	1568700000
141442	2134	83228004000
141443	1874	37947000
141444	1769	1567700000
141445	1705	30801103580140
141446	1705	30801127580140
141457	1397	1267562891000
141458	1678	28080869209000
141459	2134	83225998000
141460	1874	37954000
141461	188	66720900000000
141462	188	66720911000000
141492	1489	15503279040000
141493	1489	15503290040000
141499	1397	1267502885000
141500	1678	28080869215000
141501	2132	147234247000
141502	1874	37971000
141503	2134	83219980000
141504	1874	37974000
141505	42	76460730000000
141506	42	76460742000000
141535	1397	1267482883000
141536	1678	28080869217000
141537	1397	1267472882000
141538	1678	28080869218000
141539	2134	83217974000
141540	1874	37980000
141541	2134	83216971000
141542	1874	37983000
141543	1253	607902749000000
141544	2398	1000000000
141545	2132	147233246000
141546	1874	37984000
141547	1693	6525850623117
141548	1693	6525874623117
141550	1397	1267462881000
141551	1678	28080869219000
141552	2134	83215968000
141553	1874	37987000
141564	1402	54903628145435
141584	1397	1267412876000
141585	1678	28080869224000
141586	2134	83210953000
141587	1874	38003000
141588	1394	1042575943440200
141589	1394	1042575954440200
141610	1397	1267392874000
141611	1678	28080869226000
141612	2134	83208947000
141613	1874	38010000
141618	1649	15591660999968
141619	1649	15591671999968
141628	1397	1267362871000
141629	1678	28080869229000
141630	2134	83205938000
141631	1874	38020000
141649	1397	1267332868000
141650	1678	28080869232000
141651	2132	147229242000
141652	1874	38027000
141653	2134	83202929000
141654	1874	38030000
141655	1395	58328553044457278
141656	1395	58328553056457278
141659	1397	1267322867000
141660	1678	28080869233000
141661	2134	83201926000
141662	1874	38033000
141663	42	77180742000000
141664	42	77180753000000
141673	43	82560292890000
141674	43	82560303890000
141703	1397	1267262861000
141704	1678	28080869239000
141705	1397	1267252860000
141706	1678	28080869240000
141707	2358	50096000000
141708	2134	83195908000
141709	1874	38053000
141710	2134	83194905000
141711	1874	38056000
141712	58	81827671999641
141719	1474	25730643000043
141720	1474	25730654000043
141734	1397	1267212856000
141735	1678	28080869244000
141736	2134	83190893000
141737	1874	38069000
141738	1419	27646264559748
141739	1419	27646275559748
141764	1762	12885704994000
141765	1397	1267162851000
141766	1678	28080869249000
141767	1397	1267152850000
141768	1678	28080869250000
141769	1397	1267142849000
141770	1678	28080869251000
141771	1397	1267132848000
141772	1678	28080869252000
141773	1397	1267122847000
141774	1678	28080869253000
141775	2132	147223236000
141776	1874	38084000
141777	2134	83185878000
141778	1874	38087000
141779	2134	83184875000
141780	1874	38090000
141781	2134	83183872000
141782	1874	38093000
141783	2134	83182869000
141784	1874	38096000
141785	1394	1045456021440200
141810	1874	38038000
141811	1874	38039000
141812	1874	38042000
141813	1874	38045000
141814	1874	38048000
141815	1874	38051000
141816	1874	38052000
141817	1874	38054000
141818	1874	38055000
141819	1874	38058000
141820	1874	38061000
141821	1874	38064000
141822	1874	38067000
141823	1874	38082000
141824	1874	38085000
141825	1874	38088000
141826	1874	38091000
141827	1874	38094000
141828	1698	17349052550062
141829	1698	17349313550062
141847	1397	1267042839000
141848	1678	28080869261000
141849	2134	83174845000
141850	1874	38122000
141851	1402	56343639145435
141852	1402	56343650145435
141859	1623	87123595898598
141860	1623	87123600898598
141302	1397	1267782913000
141303	1678	28080869187000
141304	2134	83248064000
141305	1874	37881000
141306	1394	1035375886440200
141307	1394	1035375897440200
141353	1397	1267702905000
141354	1678	28080869195000
141355	2132	147240253000
141356	1874	37905000
141357	2134	83240040000
141358	1874	37908000
141373	1397	1267672902000
141374	1678	28080869198000
141375	2132	147239252000
141376	1874	37915000
141377	2134	83237031000
141378	1874	37918000
141379	1394	1038255908440200
141380	1394	1038255920440200
141403	1688	41111244113019
141404	1688	41111255113019
141427	1599	17577072097983
141428	1599	17577083097983
141447	1694	20699133197225
141448	1694	20699157197225
141470	1623	86403573898598
141471	1623	86403595898598
141478	1397	1267532888000
141479	1678	28080869212000
141480	2134	83222989000
141481	1874	37963000
141482	2132	147235248000
141483	1874	37964000
141484	1395	58325672996457278
141485	1395	58325673008457278
141507	1397	1267492884000
141508	1678	28080869216000
141509	2358	50098000000
141510	2134	83218977000
141511	1874	37977000
141512	1395	58326393008457278
141513	1395	58326393020457278
141554	1397	1267452880000
141555	1678	28080869220000
141556	2134	83214965000
141557	1874	37990000
141558	1668	16353835500000
141559	1668	16353846500000
141560	1397	1267442879000
141561	1678	28080869221000
141562	2134	83213962000
141563	1874	37993000
141567	1696	21323835335104
141575	1394	1041135943440200
141592	1397	1267402875000
141593	1678	28080869225000
141594	2134	83209950000
141595	1874	38006000
141596	2132	147231244000
141597	1874	38007000
141598	1395	58327113020457278
141599	1395	58327113032457278
141620	1397	1267372872000
141621	1678	28080869228000
141622	2134	83206941000
141623	1874	38016000
141624	2132	147230243000
141625	1874	38017000
141626	1706	22602363450256
141627	1706	22602375450256
141640	1394	1044015954440200
141641	1394	1044015965440200
141671	2148	12240368880750
141672	2148	12240379880750
141683	1397	1267292864000
141684	1678	28080869236000
141685	2134	83198917000
141686	1874	38043000
141687	1668	17073846500000
141688	1668	17073857500000
141702	1693	6525873623117
141713	1397	1267242859000
141714	1678	28080869241000
141715	2134	83193902000
141716	1874	38059000
141717	1402	55623628145435
141718	1402	55623639145435
141740	1397	1267202855000
141741	1678	28080869245000
141742	2132	147225238000
141743	1874	38070000
141744	2134	83189890000
141745	1874	38073000
141746	1397	1267192854000
141747	1678	28080869246000
141748	1397	1267182853000
141749	1678	28080869247000
141750	2134	83188887000
141751	1874	38076000
141752	2134	83187884000
141753	1874	38079000
141754	1703	7200942000000
141756	1397	1267172852000
141757	1678	28080869248000
141758	2132	147224237000
141759	1874	38080000
141760	2134	83186881000
141761	1874	38083000
141762	1762	12885693994000
141763	1762	12885705994000
141798	1397	1267092844000
141799	1678	28080869256000
141800	2134	83179860000
141801	1874	38106000
141802	149	82655478000341
141803	149	82655489000341
141804	1397	1267082843000
141805	1678	28080869257000
141806	2134	83178857000
141807	1874	38109000
141808	1394	1046896021440200
141809	1394	1046896032440200
141842	1397	1267052840000
141843	1678	28080869260000
141844	2134	83175848000
141845	1874	38119000
141846	1395	58328553055457278
141861	1397	1267022837000
141862	1678	28080869263000
141863	1397	1267012836000
141864	1678	28080869264000
141865	1397	1267002835000
141866	1678	28080869265000
141867	2398	0
141868	1253	607903748000000
141869	1685	192964923571430
141870	2134	83172839000
141871	1874	38128000
141872	2134	83171836000
141873	1874	38131000
141874	2134	83170833000
141875	1874	38134000
141876	1685	193684923571430
141877	1685	193684926571430
141884	1705	31521127580140
141885	1705	31521138580140
141906	1608	19578645000000
141907	1608	19578678000000
141936	1397	1266892824000
141937	1678	28080869276000
141938	2134	83159800000
141939	1874	38167000
141940	1397	1266882823000
141941	1678	28080869277000
141942	2134	83158797000
141943	1874	38170000
141944	1670	12961120000000
141945	1670	12961131000000
141946	1397	1266872822000
141947	1678	28080869278000
141948	1397	1266862821000
141949	1678	28080869279000
141950	1397	1266852820000
141951	1678	28080869280000
141952	1397	1266842819000
141953	1678	28080869281000
141954	2134	83157794000
141955	1874	38173000
141956	2134	83156791000
141957	1874	38176000
141958	2134	83155788000
141959	1874	38179000
141960	2134	83154785000
141961	1874	38182000
141962	1394	1048336032440200
141963	1394	1048336076440200
141965	1688	41831312113019
141974	1397	1266822817000
141975	1678	28080869283000
141976	1397	1266812816000
141977	1678	28080869284000
141978	329	67367601000000
141979	2399	74000000000
141980	1379	1693978636751650
141527	1874	36477000
141528	1874	36479000
141529	1874	36481000
141530	1874	36483000
141531	1874	36484000
141532	1874	36486000
141533	1874	36487000
141534	2306	4319219000000
141578	1397	1267422877000
141579	1678	28080869223000
141580	2134	83211956000
141581	1874	38000000
141582	2329	330486844819988
141583	2329	330486855819988
141591	1680	17293436499559
141600	1874	37479000
141601	1874	37481000
141602	1874	37483000
141603	1874	37485000
141604	1874	37487000
141605	1874	37488000
141606	1874	37490000
141607	1874	37491000
141608	1690	190805903000000
141609	1690	190805920000000
141614	1397	1267382873000
141615	1678	28080869227000
141616	2134	83207944000
141617	1874	38013000
141634	1613	16417493400000
141635	1613	16417504400000
141642	1397	1267342869000
141643	1678	28080869231000
141644	2358	50097000000
141645	2134	83203932000
141646	1874	38026000
141647	1395	58327833032457278
141648	1395	58327833044457278
141675	1599	18297083097983
141676	1599	18297094097983
141677	1397	1267302865000
141678	1678	28080869235000
141679	2132	147228241000
141680	1874	38037000
141681	2134	83199920000
141682	1874	38040000
141755	1702	7920603000000
141831	1397	1267072842000
141832	1678	28080869258000
141833	1397	1267062841000
141834	2132	147221234000
141835	1874	38110000
141836	2134	83177854000
141837	1874	38113000
141838	2134	83176851000
141839	1874	38116000
141840	1695	15785299999000
141854	1397	1267032838000
141855	1678	28080869262000
141856	2134	83173842000
141857	1874	38125000
141858	1547	13674863000000
141878	1397	1266992834000
141879	1678	28080869266000
141880	2134	83169830000
141881	1874	38137000
141882	1451	9067824000000
141883	1451	9067835000000
141888	1397	1266982833000
141889	1678	28080869267000
141890	2134	83168827000
141891	1874	38140000
141910	1397	1266942829000
141911	1678	28080869271000
141912	2134	83164815000
141913	1874	38152000
141917	1397	1266932828000
141918	1678	28080869272000
141919	1397	1266922827000
141920	1678	28080869273000
141921	1397	1266912826000
141922	1678	28080869274000
141923	1397	1266902825000
141924	1678	28080869275000
141925	2134	83163812000
141926	1874	38155000
141927	2134	83162809000
141928	1874	38158000
141929	2134	83161806000
141930	1874	38161000
141931	2134	83160803000
141932	1874	38164000
141933	1509	18383521503835
141964	2148	12240412880750
141966	1397	1266832818000
141967	1678	28080869282000
141968	2134	83153782000
141969	1874	38185000
141970	1708	15480705324650
141971	1708	15480716324650
141991	1724	17692987500000
142015	1739	32399873000000
142044	1559	15426247999999
142045	1559	15426258999999
142076	1397	1266672802000
142077	1678	28080869298000
142078	2134	83136731000
142079	1874	38236000
142080	1717	20701389000055
142081	1717	20701400000055
142096	1633	10848697125277
142097	1633	10848708125277
142108	1874	37091000
142109	1874	37093000
142110	1874	37095000
142111	1874	37097000
142112	1508	17480584156616
142113	1571	5360846387203
142114	1508	18200584156608
142121	1419	28366275559748
142122	1419	28366286559748
142129	1506	9360286967172
142150	1789	90000000
142151	2401	2078880000000
142152	1397	1266582793000
142153	1678	28080869307000
142154	2134	83127704000
142155	1874	38263000
142156	1850	18696548949999
142166	1397	1266572792000
142167	1678	28080869308000
142168	2134	83126701000
142169	1874	38266000
142170	1395	58329273055457278
142171	1395	58329273066457278
142182	1397	1266542789000
142183	1678	28080869311000
142184	2400	0
142185	1379	1693979635751650
142186	2134	83123692000
142187	1874	38275000
142188	1395	58329993066457278
142189	1395	58329993078457278
142209	1395	58329993077457278
142212	610	68160055000000
142214	1397	1266502785000
142215	1678	28080869315000
142216	1507	49990000000
142217	2402	49000000000
142218	2134	83119680000
142219	1874	38287000
142220	1768	25667175110000
142221	1768	25667196110000
142227	1397	1266492784000
142228	1678	28080869316000
142229	2134	83118677000
142230	1874	38290000
142231	1509	19823499503835
142232	1509	19823510503835
142251	1397	1266452780000
142252	1678	28080869320000
142253	2134	83114665000
142254	1874	38302000
142255	519	67441917000000
142256	519	67441928000000
142277	1559	16146275499999
142278	1559	16146297499999
142287	1397	1266392774000
142288	1678	28080869326000
142289	1397	1266382773000
142290	1678	28080869327000
142291	1397	1266372772000
142292	1678	28080869328000
142293	1397	1266362771000
142294	1678	28080869329000
142295	1397	1266352770000
142296	1678	28080869330000
142297	1397	1266342769000
142298	1678	28080869331000
142299	1397	1266332768000
142300	1678	28080869332000
142301	2134	83108647000
142302	1874	38320000
142303	2134	83107644000
142304	1874	38323000
141886	2039	21499861000000
141887	2039	21499872000000
141914	1747	7266070999992
141915	1747	7266081999992
141972	1701	17998516500103
141973	1701	17998527500103
142010	1397	1266782813000
142011	1678	28080869287000
142012	2134	83147764000
142013	1874	38203000
142016	1397	1266772812000
142017	1678	28080869288000
142018	2134	83146761000
142019	1874	38206000
142020	1559	14706236999999
142021	1559	14706247999999
142038	1397	1266732808000
142039	1678	28080869292000
142040	2134	83142749000
142041	1874	38218000
142042	1675	27644735999977
142069	1509	19103510503835
142087	1671	19824329003785
142088	1671	19824340003785
142089	1611	5033523402899
142090	1611	5033534402899
142143	1397	1266592794000
142144	1678	28080869306000
142145	2134	83128707000
142146	1874	38260000
142157	2401	709000000000
142158	2401	711880000000
142159	1700	13914327979053
142160	1700	13914370979053
142162	2307	6479154000000
142172	1397	1266562791000
142173	1678	28080869309000
142174	2134	83125698000
142175	1874	38269000
142176	1724	17692963500000
142190	1696	22043859335104
142191	1696	22043871335104
142202	1688	43991355113019
142203	1688	43991377113019
142210	1696	23483871335104
142211	1696	23483882335104
142222	1394	1052656065440200
142223	1394	1052656086440200
142237	1397	1266482783000
142238	1678	28080869317000
142239	1397	1266472782000
142240	1678	28080869318000
142241	2134	83117674000
142242	1874	38293000
142243	2134	83116671000
142244	1874	38296000
142245	42	77900753000000
142246	42	77900785000000
142257	1397	1266442779000
142258	1678	28080869321000
142259	1397	1266432778000
142260	1678	28080869322000
142261	2402	48994500000
142262	2134	83113662000
142263	1874	38305000
142264	2134	83112659000
142265	1874	38308000
142266	1559	15426275499999
142279	1397	1266402775000
142280	1678	28080869325000
142281	2134	83109650000
142282	1874	38317000
142283	1654	19577605999798
142316	1397	1266322767000
142317	1678	28080869333000
142318	2134	83101626000
142319	1874	38341000
142320	1693	7245873623117
142321	1693	7245884623117
142343	1397	1266282763000
142344	1678	28080869337000
142345	1687	10209042848312
142346	2134	83097614000
142347	1874	38353000
142348	1687	10929042848312
142349	1687	10929043848312
142365	1397	1266242759000
142366	1678	28080869341000
142367	2134	83093602000
142368	1874	38365000
142369	1447	23321956683000
142370	1447	23321967683000
142389	1601	11186054620000
142390	1601	11186065620000
142412	1397	1266202755000
142413	1678	28080869345000
142414	1397	1266192754000
142415	1678	28080869346000
142416	2403	438994500000
142417	2134	83089590000
142418	1874	38377000
142419	2134	83088587000
142420	1874	38380000
142421	1656	17275609499990
142432	1394	1054096076440200
142433	1394	1054096098440200
142435	1718	10336652519070
142461	1668	17793857500000
142462	1668	17793868500000
142471	2106	5760214000000
142472	2106	5760225000000
142473	1397	1266102745000
142474	1678	28080869355000
142475	2134	83079560000
142476	1874	38407000
142481	1397	1266092744000
142482	1678	28080869356000
142483	2134	83078557000
142484	1874	38410000
142485	2248	13679584000000
142486	2248	13679595000000
142487	1716	3600092000000
142488	1716	3600103000000
142495	1397	1266072742000
142496	1678	28080869358000
142497	2134	83076551000
142498	1874	38416000
142499	1688	44711388113019
142502	1397	1266062741000
142503	1678	28080869359000
142504	1397	1266052740000
142505	1678	28080869360000
142506	2134	83075548000
142507	1874	38419000
142508	2134	83074545000
142509	1874	38422000
142510	1402	57063650145435
142511	1402	57063672145435
142514	1397	1266042739000
142515	1678	28080869361000
142516	1397	1266032738000
142517	1678	28080869362000
142518	2134	83073542000
142519	1874	38425000
142520	2134	83072539000
142521	1874	38428000
142522	1394	1056976098440200
142523	1394	1056976120440200
142537	1397	1266002735000
142538	1678	28080869365000
142539	2134	83069530000
142540	1874	38437000
142556	1394	1058416120440200
142557	1394	1058416131440200
142560	1397	1265962731000
142561	1678	28080869369000
142562	2134	83065518000
142563	1874	38449000
142564	1522	14443846000000
142565	1522	14443857000000
142568	1933	3979268000000
142569	1933	3979279000000
142572	1397	1265952730000
142573	1678	28080869370000
142574	2134	83064515000
142575	1874	38452000
142576	1467	9520338272869
142577	1467	9520349272869
142615	1397	1265882723000
142616	1678	28080869377000
142617	2134	83057494000
142618	1874	38473000
142619	1672	16561581000000
142620	1672	16561592000000
142646	1397	1265832718000
142647	1678	28080869382000
142648	2134	83052479000
142649	1874	38490000
142650	2133	89813276000
142651	1874	38492000
142665	1694	20699145197225
142688	1573	9219434000000
142689	1573	9219446000000
142706	1397	1265782713000
142707	1678	28080869387000
141981	2400	1000000000
141982	2134	83152779000
141983	1874	38188000
141984	2134	83151776000
141985	1874	38191000
141986	2134	83150773000
141987	1874	38194000
141988	1253	1000000000
141989	2398	607902747000000
141990	1696	21323859335104
142000	1397	1266802815000
142001	1678	28080869285000
142002	1397	1266792814000
142003	1678	28080869286000
142004	2134	83149770000
142005	1874	38197000
142006	2134	83148767000
142007	1874	38200000
142008	1723	15842178085979
142009	1723	15842200085979
142034	1397	1266742809000
142035	1678	28080869291000
142036	2134	83143752000
142037	1874	38215000
142043	632	82557752000000
142052	1619	10800257000000
142053	1619	10800268000000
142059	1397	1266702805000
142060	1678	28080869295000
142061	1397	1266692804000
142062	1678	28080869296000
142063	2134	83139740000
142064	1874	38227000
142065	2134	83138737000
142066	1874	38230000
142067	1509	19103477503835
142068	1509	19103499503835
142082	1397	1266662801000
142083	1678	28080869299000
142084	2134	83135728000
142085	1874	38239000
142086	1571	6080857387195
142091	1397	1266652800000
142092	1678	28080869300000
142093	2134	83134725000
142094	1874	38242000
142095	1394	1048336043440200
142105	1688	42551354113019
142106	1688	43271354113019
142107	1688	43271355113019
142135	1789	2980000000
142136	2401	2076000000000
142137	1397	1266602795000
142138	1678	28080869305000
142139	2134	83129710000
142140	1874	38257000
142141	1587	20160538000000
142142	1587	20160559000000
142148	1394	1049776043440200
142149	1394	1049776054440200
142161	1593	17952846000000
142163	1700	13914348979053
142177	1692	14140882819983
142178	1397	1266552790000
142179	1678	28080869310000
142180	2134	83124695000
142181	1874	38272000
142192	1397	1266532788000
142193	1678	28080869312000
142194	1397	1266522787000
142195	1678	28080869313000
142196	2134	83122689000
142197	1874	38278000
142198	2134	83121686000
142199	1874	38281000
142200	1394	1051216054440200
142201	1394	1051216076440200
142204	1397	1266512786000
142205	1678	28080869314000
142206	2134	83120683000
142207	1874	38284000
142208	1394	1051216065440200
142226	1608	19578666000000
142233	1509	19103700503835
142234	1509	19823700503835
142235	1501	118200000
142236	1509	19823748503835
142284	1573	8499434000000
142285	1690	192245945000000
142286	1690	192245986000000
142324	2329	331926866819988
142325	2329	331926877819988
142326	1693	7246077123117
142341	1692	14860882819983
142342	1692	14860893819983
142371	1874	37301000
142372	1874	37302000
142373	1874	37304000
142374	1874	37305000
142375	1874	37307000
142376	1874	37309000
142377	1874	37311000
142378	1874	37312000
142379	1874	37314000
142380	1874	37316000
142381	1874	37317000
142382	1874	37319000
142383	1874	37321000
142384	1874	37322000
142385	1874	37324000
142386	1874	37326000
142387	1513	38161306399900
142388	1513	38161392399900
142391	1703	7920942000000
142392	1703	7920953000000
142393	1397	1266232758000
142394	1678	28080869342000
142395	2134	83092599000
142396	1874	38368000
142397	42	78620785000000
142398	42	78620796000000
142422	1559	16146302999999
142434	610	68160066000000
142436	1397	1266162751000
142437	1678	28080869349000
142438	2134	83085578000
142439	1874	38389000
142440	1710	17514119664140
142441	1710	17514130664140
142465	1555	18246323540449
142489	1397	1266082743000
142490	1678	28080869357000
142491	2134	83077554000
142492	1874	38413000
142541	1397	1265992734000
142542	1678	28080869366000
142543	2134	83068527000
142544	1874	38440000
142621	1395	58332153144457278
142622	1395	58332153155457278
142641	1397	1265842719000
142642	1678	28080869381000
142643	2134	83053482000
142644	1874	38487000
142645	1559	16146286499999
142652	610	68160056000000
142663	1471	20825531900000
142664	1471	20825543900000
142666	1394	1058416132440200
142673	1874	37850000
142674	1874	37854000
142675	1874	37856000
142676	1426	18330514000000
142677	1426	18330587166670
142718	1394	1058416133440200
142749	1702	7920844000000
142759	1397	1265732708000
142760	1678	28080869392000
142761	2133	9553256000
142762	2132	7218232000
142763	2386	1020228000000
142764	2134	83043452000
142765	1395	58332873155457278
142766	1395	58332873168457278
142791	1397	1265692704000
142792	1678	28080869396000
142793	2133	9549248000
142794	1874	7559000
142795	1455	7951658000000
142799	1419	29086286559748
142800	1419	29086297559748
142816	1397	1265662701000
142817	1678	28080869399000
142818	2329	332646920819988
142819	2133	9546242000
142820	2329	333366920819988
142849	641	84724019500000
142881	1397	1265582693000
142882	1678	28080869407000
142883	2134	12784419000
142884	2133	9537224000
142885	1670	13681131000000
142886	1670	13681180000000
142924	1397	1265512686000
142925	1678	28080869414000
142098	1397	1266642799000
142099	1678	28080869301000
142100	484	74733957000000
142101	2134	83133722000
142102	1874	38245000
142103	484	75453957000000
142104	484	75453958000000
142115	1397	1266632798000
142116	1678	28080869302000
142117	2134	83132719000
142118	1874	38248000
142119	1508	18200515156616
142120	1508	18200526156616
142123	1397	1266622797000
142124	1678	28080869303000
142125	2134	83131716000
142126	1874	38251000
142127	2307	6479133000000
142128	2307	6479144000000
142130	1397	1266612796000
142131	1678	28080869304000
142132	2134	83130713000
142133	1874	38254000
142134	576	81917737726897
142147	623	67439951000000
142164	1506	10080286967172
142165	1506	10080307967172
142213	1718	10336641519070
142224	1688	44711377113019
142225	1688	44711398113019
142247	1397	1266462781000
142248	1678	28080869319000
142249	2134	83115668000
142250	1874	38299000
142267	1397	1266422777000
142268	1678	28080869323000
142269	1397	1266412776000
142270	1678	28080869324000
142271	2134	83111656000
142272	1874	38311000
142273	2134	83110653000
142274	1874	38314000
142275	1672	15841559000000
142276	1672	15841581000000
142322	1991	17901530355805
142323	1991	17901541355805
142336	1397	1266292764000
142337	1678	28080869336000
142338	2134	83098617000
142339	1874	38350000
142340	1394	1052656076440200
142406	1397	1266212756000
142407	1678	28080869344000
142408	2134	83090593000
142409	1874	38374000
142410	1684	33123591819412
142411	1684	33123602819412
142463	1395	58331433133457278
142464	1395	58331433144457278
142477	470	79555372000000
142478	470	79555383000000
142524	1397	1266022737000
142525	1678	28080869363000
142526	2134	83071536000
142527	1874	38431000
142528	1756	9920895195609
142529	1756	9920906195609
142551	1673	11735495000000
142566	369	83076669290830
142567	369	83076680290830
142570	1688	45431388113019
142571	1688	45431399113019
142580	1397	1265942729000
142581	1678	28080869371000
142582	2385	890500000
142583	2134	83063512000
142584	1874	38455000
142585	1633	10848713625277
142605	2307	6479169666670
142607	1397	1265892724000
142608	1678	28080869376000
142609	2134	83058497000
142610	1874	38470000
142611	1693	7965884623117
142612	1693	7965895623117
142625	1397	1265872722000
142626	1678	28080869378000
142627	1397	1265862721000
142628	1678	28080869379000
142629	1397	1265852720000
142630	1678	28080869380000
142631	2134	83056491000
142632	1874	38476000
142633	2133	89814278000
142634	1874	38478000
142635	2134	83055488000
142636	1874	38481000
142637	2134	83054485000
142638	1874	38484000
142639	1706	23322375450256
142640	1706	23322409450256
142655	1397	1265822717000
142656	1678	28080869383000
142657	2134	83051476000
142658	1874	38495000
142659	2133	89812274000
142660	1874	38497000
142661	1654	20297671999798
142662	1654	20297683999798
142667	1397	1265812716000
142668	1678	28080869384000
142669	2133	89811272000
142670	1874	38499000
142671	1426	18330505000000
142672	1426	18330516000000
142678	1397	1265802715000
142679	1678	28080869385000
142680	2133	89810270000
142681	1874	38501000
142682	2134	83050473000
142683	1874	38504000
142684	1668	18513868500000
142685	1668	18513880500000
142702	1462	1440013000000
142703	1462	1440027000000
142716	1602	14976743170000
142726	1397	1265762711000
142727	1678	28080869389000
142728	2134	83046461000
142729	1874	38523000
142730	2133	89806262000
142731	1874	38525000
142732	1693	7965896623117
142735	1599	19017107097983
142748	1703	7921205000000
142769	1616	5760144410000
142770	1616	5760157410000
142797	1633	11568713625277
142798	1633	11568724625277
142801	1397	1265682703000
142802	1678	28080869397000
142803	1726	130734112000
142804	2405	100000000
142805	2132	7216230000
142806	2133	9548246000
142807	1395	58334313442457278
142808	1395	58334313455457278
142833	1397	1265652700000
142834	1678	28080869400000
142835	2133	9545240000
142836	2134	12789439000
142837	2133	9544238000
142838	1874	7575000
142839	1616	5760158410000
142861	1613	16417506400000
142902	1711	19147109000000
142909	1397	1265532688000
142910	1678	28080869412000
142911	1397	1265522687000
142912	1678	28080869413000
142913	2134	12780403000
142914	1874	7636000
142915	2132	7211225000
142916	2133	9532214000
142917	2133	9531212000
142918	1874	7641000
142919	2134	12779399000
142920	1694	20699158197225
142922	1692	17740942819983
142923	1692	17740967819983
142967	1610	16560391999950
142968	1610	16560415999950
143006	1397	1265462681000
143007	1678	28080869419000
143008	1397	1265452680000
143009	1678	28080869420000
143010	2133	9525200000
143011	1874	7670000
143012	2133	9524198000
143013	1874	7672000
143014	2134	12775383000
143015	1874	7676000
143016	2132	7209223000
143017	2134	12774379000
143018	1874	7681000
142305	2134	83106641000
142306	1874	38326000
142307	2134	83105638000
142308	1874	38329000
142309	2134	83104635000
142310	1874	38332000
142311	2134	83103632000
142312	1874	38335000
142313	2134	83102629000
142314	1874	38338000
142315	1654	19577671999798
142327	1397	1266312766000
142328	1678	28080869334000
142329	1397	1266302765000
142330	1678	28080869335000
142331	2134	83100623000
142332	1874	38344000
142333	2134	83099620000
142334	1874	38347000
142335	2329	331926888819988
142350	1397	1266272762000
142351	1678	28080869338000
142352	1397	1266262761000
142353	1678	28080869339000
142354	1397	1266252760000
142355	1678	28080869340000
142356	338	67438024000000
142357	2403	1000000000
142358	2134	83096611000
142359	1874	38356000
142360	2134	83095608000
142361	1874	38359000
142362	2134	83094605000
142363	1874	38362000
142364	1395	58329993100457278
142399	1397	1266222757000
142400	1678	28080869343000
142401	2134	83091596000
142402	1874	38371000
142403	338	67000023000000
142404	2403	439000000000
142405	1599	18297095097983
142423	1397	1266182753000
142424	1678	28080869347000
142425	1397	1266172752000
142426	1678	28080869348000
142427	2134	83087584000
142428	1874	38383000
142429	2134	83086581000
142430	1874	38386000
142431	1541	5042336000000
142442	1394	1054096087440200
142443	1397	1266152750000
142444	1678	28080869350000
142445	1397	1266142749000
142446	1678	28080869351000
142447	1397	1266132748000
142448	1678	28080869352000
142449	2134	83084575000
142450	1874	38392000
142451	2134	83083572000
142452	1874	38395000
142453	2134	83082569000
142454	1874	38398000
142455	1395	58330713100457278
142456	1395	58330713133457278
142457	1397	1266122747000
142458	1678	28080869353000
142459	2134	83081566000
142460	1874	38401000
142466	1397	1266112746000
142467	1678	28080869354000
142468	2134	83080563000
142469	1874	38404000
142470	1448	13639924000001
142479	1759	12457317139889
142480	1759	12457328139889
142493	1394	1055536087440200
142494	1394	1055536098440200
142500	1690	192965986000000
142501	1690	192965988000000
142512	2329	332646888819988
142513	2329	332646910819988
142530	1397	1266012736000
142531	1678	28080869364000
142532	2401	2078874500000
142533	2134	83070533000
142534	1874	38434000
142535	641	84003992000000
142536	641	84004008500000
142545	1397	1265982733000
142546	1678	28080869367000
142547	2134	83067524000
142548	1874	38443000
142549	1587	20880559000000
142550	1587	20880570000000
142552	1397	1265972732000
142553	1678	28080869368000
142554	2134	83066521000
142555	1874	38446000
142558	1692	15580893819983
142559	1692	15580904819983
142578	2329	333366910819988
142579	2329	333366921819988
142586	1397	1265932728000
142587	1678	28080869372000
142588	2134	83062509000
142589	1874	38458000
142590	1397	1265922727000
142591	1678	28080869373000
142592	1397	1265912726000
142593	1678	28080869374000
142594	1397	1265902725000
142595	1678	28080869375000
142596	2385	786833330
142597	835	3199985404837430
142598	2134	83061506000
142599	1874	38461000
142600	2134	83060503000
142601	1874	38464000
142602	2134	83059500000
142603	1874	38467000
142604	1402	57063686812105
142606	1506	10080323633842
142613	1271	1351326505500003
142614	1271	1351326516500003
142623	1599	19017095097983
142624	1599	19017106097983
142653	1718	11056652519070
142654	1718	11056664519070
142686	1691	14111180300052
142687	1691	14111192300052
142690	1397	1265792714000
142691	1678	28080869386000
142692	2134	83049470000
142693	1874	38507000
142694	1726	932937112000
142695	2404	100000000
142696	1726	931836112000
142697	2404	1200000000
142698	2133	89809268000
142699	1874	38509000
142700	1679	19438473656999
142701	1679	19438487656999
142704	1685	194404926571430
142705	1685	194404940571430
142717	1602	14976732170000
142733	1394	1059856133440200
142734	1394	1059856145440200
142736	2133	9556262000
142737	2386	80100000000
142738	1397	1265752710000
142739	1678	28080869390000
142740	2134	83045458000
142741	1874	38528000
142742	1725	0
142743	2386	80198000000
142744	2133	9555260000
142745	1874	38530000
142746	1656	17995609499990
142747	1656	17995872499990
142767	1596	10080316000002
142768	1596	10080329000002
142771	1397	1265722707000
142772	1678	28080869393000
142773	2133	9552254000
142774	1874	7543000
142775	2134	83042449000
142776	1874	7546000
142777	1395	58332873167457278
142796	1394	1059856144440200
142809	1397	1265672702000
142810	1678	28080869398000
142811	2133	9547244000
142814	1746	7008980999989
142815	1746	7008991999989
142821	2403	994500000
142822	1874	6326000
142823	2386	130000000
142824	2386	228000000
142825	1874	6328000
142826	2386	140228000000
142827	1874	6329000
142828	2132	7215229000
142829	1874	6331000
142708	2134	83048467000
142709	1874	38512000
142710	2132	147220233000
142711	1874	38513000
142712	2133	89808266000
142713	1874	38515000
142714	1402	57783686812105
142715	1402	57783699812105
142719	1397	1265772712000
142720	1678	28080869388000
142721	2133	89807264000
142722	1874	38517000
142723	2134	83047464000
142724	1874	38520000
142725	1692	15580905819983
142750	1397	1265742709000
142751	1678	28080869391000
142752	2386	80228000000
142753	2133	9554258000
142754	2134	83044455000
142755	2132	147219232000
142756	1726	131835112000
142757	2386	880228000000
142758	1688	45431403113019
142778	1397	1265712706000
142779	1678	28080869394000
142780	1397	1265702705000
142781	1678	28080869395000
142782	2133	9551252000
142783	2133	9550250000
142784	2134	83041446000
142785	2134	12791446000
142786	2386	1090228000000
142787	2134	12790443000
142788	2132	7217231000
142789	1395	58333593167457278
142790	1395	58333593442457278
142812	1679	20158487656999
142813	1679	20158498656999
142847	641	84724008500000
142848	641	84724020500000
142850	1397	1265632698000
142851	1678	28080869402000
142852	2133	9542234000
142853	1458	23705490908540
142854	1458	23705501908540
142855	1397	1265622697000
142856	1678	28080869403000
142857	2132	7214228000
142858	2133	9541232000
142859	2134	12787431000
142860	1693	7965897623117
142862	1749	1442611529980
142869	1397	1265602695000
142870	1678	28080869405000
142871	1397	1265592694000
142872	1678	28080869406000
142873	1726	129633112000
142874	2406	100000000
142875	2134	12785423000
142876	2133	9539228000
142877	2133	9538226000
142878	2132	7213227000
142879	1692	17020917819983
142880	1692	17020942819983
142888	1397	1265572692000
142889	1678	28080869408000
142890	1397	1265562691000
142891	1678	28080869409000
142892	1397	1265552690000
142893	1678	28080869410000
142894	2134	12783415000
142895	2134	12782411000
142896	2133	9536222000
142897	2133	9535220000
142898	2133	9534218000
142899	1874	7625000
142900	2132	7212226000
142901	1700	13914363979053
142903	1397	1265542689000
142904	1678	28080869411000
142905	2134	12781407000
142906	2133	9533216000
142907	1654	21017683999798
142908	1654	21017695999798
142956	1397	1265482683000
142957	1678	28080869417000
142958	1397	1265472682000
142959	1678	28080869418000
142960	2134	12776387000
142961	1874	7664000
142962	2386	1090227000000
142963	2133	9527204000
142964	2133	9526202000
142965	1394	1061296144440200
142966	1394	1061296168440200
142969	2386	80130000000
142970	1874	7528000
142971	2386	80129000000
142972	2386	80227000000
142973	1874	7534000
142974	2386	220227000000
142975	1874	7537000
142976	2386	1020227000000
142977	1610	15840952999950
142978	1874	7549000
142979	1874	7567000
142980	1874	7573000
142981	1874	7585000
142982	2134	12789440000
142983	2134	12788436000
142984	2134	12787432000
142985	2134	12786428000
142986	2134	12785424000
142987	1874	7631000
142988	2134	12784420000
142989	2134	12783416000
142990	2134	12782412000
142991	1874	7643000
142992	2134	12781408000
142993	1874	7647000
142994	2134	12780404000
142995	1874	7651000
142996	2134	12779400000
142997	2134	12778396000
142998	1874	7659000
142999	2134	12777392000
143000	2134	12776388000
143001	1874	7667000
143002	1610	16560952999950
143003	1610	16561247999950
143005	1702	7920605000000
143021	1678	28800869420000
143022	1678	28800894420000
143028	1397	1265442679000
143029	1678	28800894421000
143030	1397	1265432678000
143031	1678	28800894422000
143032	2134	12773375000
143033	1874	7685000
143034	2133	9523196000
143035	1874	7687000
143036	2133	9522194000
143037	1536	20880422000000
143048	1536	21600422000000
143049	1536	21600435000000
143050	1397	1265412676000
143051	1678	28800894424000
143052	1397	1265402675000
143053	1678	28800894425000
143054	1397	1265392674000
143055	1678	28800894426000
143056	2133	9520190000
143057	2132	7207221000
143058	1874	7699000
143059	2133	9519188000
143060	2133	9518186000
143061	2134	12771367000
143062	1874	7707000
143063	2134	12770363000
143064	1394	1061296180440200
143073	1394	1062736180440200
143074	1394	1062736192440200
143120	1718	11056706519070
143141	1680	18013438499559
143142	1680	18013450499559
143151	1397	1265302665000
143152	1678	28800894435000
143153	2133	9508166000
143154	2134	12762331000
143155	2132	7204218000
143156	1874	7766000
143157	1693	8685910623117
143160	1672	17281581000000
143161	1672	17281622000000
143174	1397	1265272662000
143175	1678	28800894438000
143176	1397	1265262661000
143177	1678	28800894439000
143178	2134	12760323000
143179	1874	7778000
143180	2134	12759319000
143181	1874	7782000
143182	2133	9505160000
143183	1874	7784000
142830	2386	940228000000
142831	1513	38881392399900
142832	1513	38881425566570
142840	1397	1265642699000
142841	1678	28080869401000
142842	2133	9543236000
142843	1874	7577000
142844	2134	12788435000
142845	632	83277752000000
142846	632	83277764000000
142863	1397	1265612696000
142864	1678	28080869404000
142865	2134	12786427000
142866	2133	9540230000
142867	1692	16300905819983
142868	1692	16300917819983
142887	1670	13681143000000
142921	1685	194404951571430
142941	1716	3600128000000
142955	1419	29086322559748
143020	1394	1061296169440200
143023	2386	940227000000
143024	1874	6512000
143025	2052	230000142
143026	1690	194405996466662
143027	1690	194405998466662
143086	1596	10080339000002
143087	1596	10800339000002
143088	1596	10800341000002
143117	1541	5042368000000
143134	1397	1265322667000
143135	1678	28800894433000
143136	2133	9510170000
143137	1874	7749000
143138	2134	12764339000
143139	1756	10640906195609
143140	1756	10640918195609
143199	1397	1265232658000
143200	1678	28800894442000
143201	2132	7202216000
143202	1874	7796000
143203	2133	9501152000
143204	2134	12757311000
143205	1444	16027942329999
143208	1675	27644737999977
143231	1397	1265202655000
143232	1678	28800894445000
143233	2133	9499148000
143234	1874	7810000
143235	2134	12755303000
143236	2132	7201215000
143237	1874	7815000
143238	2112	28607056101924
143239	2112	28607069101924
143355	1688	47591428113019
143356	1688	47591439113019
143374	1397	1265072642000
143375	1678	28800894458000
143376	1670	14401155000000
143379	1394	1067056228440200
143384	1719	20158774000000
143429	1593	17952858000000
143432	1596	11520341000002
143433	1596	11520374000002
143441	1397	1264942629000
143442	1678	28800894471000
143443	1394	1067056226440200
143446	1397	1264932628000
143447	1678	28800894472000
143448	2132	7193207000
143449	1874	7913000
143450	2134	12735223000
143451	1588	17700782000000
143452	1588	17700794000000
143468	1692	18460964819983
143469	1692	18460975819983
143609	1397	1264822617000
143610	1678	28800894483000
143611	2133	9490130000
143612	1874	7956000
143613	1508	18920526156616
143614	1508	18920537156616
143618	1397	1264812616000
143619	1678	28800894484000
143620	2134	12726187000
143621	2133	9489128000
143630	1685	196564986571430
143631	1685	196564999571430
143644	1397	1264772612000
143645	1678	28800894488000
143646	2133	9485120000
143647	1874	7979000
143648	2132	7188202000
143649	1874	7980000
143650	2134	12723175000
143651	1759	13177328139889
143652	1759	13177341139889
143685	1489	16223290040000
143686	1489	16223302040000
143687	1397	1264732608000
143688	1678	28800894492000
143689	2132	7187201000
143690	1874	7999000
143691	2134	12720163000
143692	2133	9481112000
143693	1874	8005000
143694	1679	20878509656999
143695	1679	20878522656999
143714	1397	1264692604000
143715	1678	28800894496000
143716	2133	9477104000
143717	2134	12717151000
143718	2248	14399607000000
143723	1768	26387197110000
143727	1395	58335753468457278
143728	1395	58335753469457278
143740	1692	19180988819983
143750	1749	1442623529980
143756	2329	334086921819988
143757	2329	334086932819988
143768	1397	1264632598000
143769	1678	28800894502000
143770	2133	9470090000
143771	2134	12712131000
143773	2393	2157990000000
143774	1464	1014000000
143775	1397	1264622597000
143776	1678	28800894503000
143777	1688	48311480113019
143796	1724	17693483500000
143797	1724	18413483500000
143798	1724	18414213500000
143803	1700	15354375979053
143804	1700	15354386979053
143824	1749	1442609529980
143831	1467	10240362272869
143848	1397	1264522587000
143849	1678	28800894513000
143850	2132	7180194000
143851	1690	186485857000000
143904	2134	12697071000
143905	1874	8152000
143906	1688	48311440113019
143912	1522	15163857000000
143913	1522	15163869000000
143938	1439	14383886578477
143939	1439	14383910578477
143958	1397	1264372572000
143959	1678	28800894528000
143960	2133	9449048000
143961	1874	8192000
143962	2134	12691047000
143963	1874	8196000
143964	1506	10080298967172
144037	1397	1264262561000
144038	1678	28800894539000
144039	2134	12682011000
144040	1874	8258000
144041	2133	9437024000
144042	1573	9219447000000
144069	1434	3599144000000
144070	1434	3599156000000
144071	1397	1264222557000
144072	1678	28800894543000
144073	2133	9433016000
144074	1874	8277000
144075	2134	12678999000
144076	1874	8281000
144077	1571	6800857387195
144078	1571	6800869387195
144081	1397	1264212556000
144082	1678	28800894544000
144083	2132	7170184000
144084	1874	8282000
144085	2133	9432014000
144086	1672	17281605000000
144103	1397	1264182553000
144104	1678	28800894547000
144105	2133	9429008000
144106	1874	8298000
144107	1395	58337913519457278
144108	1395	58337913530457278
144121	1874	7972000
144122	1709	10800378000000
144123	1571	6080857387203
142926	1397	1265502685000
142927	1678	28080869415000
142928	1397	1265492684000
142929	1678	28080869416000
142930	2134	12778395000
142931	1874	7649000
142932	2134	12777391000
142933	2132	7210224000
142934	1874	7654000
142935	2133	9530210000
142936	2133	9529208000
142937	2133	9528206000
142938	1874	7660000
142939	2248	14399595000000
142940	2248	14399631000000
142942	1874	6502000
142943	1690	192966004666670
142944	1874	6504000
142945	1874	6506000
142946	1874	6507000
142947	1874	6509000
142948	1874	6510000
142949	1690	193686004666670
142950	1655	1000000
142951	1604	4700000
142952	2052	220000142
142953	697	66000001499997
142954	1690	193686006466662
143004	1703	7920966000000
143040	1394	1061296167440200
143041	1397	1265422677000
143042	1678	28800894423000
143043	2133	9521192000
143044	1874	7691000
143045	2132	7208222000
143046	2134	12772371000
143047	1680	17293438499559
143065	1397	1265382673000
143066	1678	28800894427000
143067	2133	9517184000
143068	1874	7713000
143069	2134	12769359000
143070	1874	7717000
143071	1693	8685897623117
143072	1693	8685909623117
143075	1397	1265372672000
143076	1678	28800894428000
143077	1672	15841591000000
143078	2133	9516182000
143079	2134	12768355000
143080	1874	7723000
143081	1672	16561591000000
143082	1672	16561593000000
143098	1588	17352010000000
143099	1392	1711184787751650
143100	1397	1265352670000
143101	1678	28800894430000
143102	1588	17185630000000
143103	1146	910123796000000
143104	1588	17073633000000
143105	1266	612619034000000
143106	1588	16980782000000
143107	1026	507884011000000
143108	2134	12767351000
143109	1874	7730000
143110	2134	12766347000
143111	1874	7734000
143112	2133	9514178000
143113	1874	7736000
143114	2133	9513176000
143115	1874	7738000
143116	1402	57783740812105
143118	610	68880056000000
143119	610	68880110000000
143121	1397	1265342669000
143122	1678	28800894431000
143123	2134	12765343000
143124	2133	9512174000
143125	1394	1064176192440200
143126	1397	1265332668000
143127	1678	28800894432000
143128	2133	9511172000
143129	1874	7746000
143130	2132	7205219000
143131	1874	7747000
143132	1696	22763871335104
143133	1696	22763883335104
143143	1649	15591672999968
143158	1688	46151403113019
143159	1688	46151416113019
143166	1394	1067056216440200
143167	1394	1067056227440200
143169	1397	1265282663000
143170	1678	28800894437000
143171	2133	9506162000
143172	2134	12761327000
143173	1874	7774000
143189	1397	1265252660000
143190	1678	28800894440000
143191	2133	9503156000
143192	1708	16200716324650
143193	1708	16200727324650
143209	1397	1265222657000
143210	1678	28800894443000
143211	2133	9500150000
143212	1874	7804000
143213	2134	12756307000
143214	1874	7808000
143215	1688	46871416113019
143216	1688	46871428113019
143228	1397	1265212656000
143229	1678	28800894444000
143230	1740	18450987000000
143258	1762	13605704994000
143259	1762	13605717994000
143290	1874	6521000
143291	1690	195846000566578
143292	1690	195846001566578
143296	1654	22457708999798
143297	1654	22457719999798
143311	1691	14831192300052
143312	1691	14831216300052
143357	1397	1265092644000
143358	1678	28800894456000
143359	1397	1265082643000
143360	1678	28800894457000
143361	2134	12747271000
143362	2134	12746267000
143363	1679	20158509656999
143367	1740	19170987000000
143368	1740	19171009000000
143385	1397	1265052640000
143386	1678	28800894460000
143387	1397	1265042639000
143388	1678	28800894461000
143389	2134	12744259000
143390	2134	12743255000
143391	1874	7881000
143392	1692	17740964819983
143430	1719	20878774000000
143431	1719	20878807000000
143436	1397	1264952630000
143437	1678	28800894470000
143438	2134	12736227000
143439	1740	19170998000000
143444	1740	19890998000000
143445	1740	19891008000000
143453	1397	1264922627000
143454	1678	28800894473000
143455	2134	12734219000
143456	1402	58503740812105
143457	1402	58503751812105
143458	1623	87123719065268
143459	1623	87843719065268
143460	2252	203700000
143461	1623	87844001765143
143462	1571	5360846387219
143488	2112	28607068101924
143491	1678	28080869421000
143492	1678	28080869422000
143493	1678	28080869423000
143494	1678	28080869424000
143495	1678	28080869425000
143496	1678	28080869426000
143497	1678	28080869427000
143498	1678	28080869428000
143499	1678	28080869429000
143500	1678	28080869430000
143501	1678	28080869431000
143502	1678	28080869432000
143503	1678	28080869433000
143504	1678	28080869434000
143505	1678	28080869435000
143506	1678	28080869436000
143507	1678	28080869437000
143508	1678	28080869438000
143509	1678	28080869439000
143510	1678	28080869440000
143511	1678	28080869441000
143512	1678	28080869442000
143513	1678	28080869443000
143514	1678	28080869444000
143515	1678	28080869445000
143516	1678	28080869446000
143517	1678	28080869447000
143019	1546	16077634800000
143038	1751	2879022000000
143039	1751	2879045000000
143083	1394	1062736202440200
143084	1394	1064176202440200
143085	1394	1064176204440200
143089	1397	1265362671000
143090	1678	28800894429000
143091	2133	9515180000
143092	1726	128532112000
143093	2407	100000000
143094	2132	7206220000
143095	1874	7726000
143096	1654	21737695999798
143097	1654	21737708999798
143144	1397	1265312666000
143145	1678	28800894434000
143146	2134	12763335000
143147	2133	9509168000
143148	1874	7759000
143149	1394	1065616204440200
143150	1394	1065616216440200
143162	1397	1265292664000
143163	1678	28800894436000
143164	2133	9507164000
143165	1874	7768000
143168	1672	18001622000000
143194	1397	1265242659000
143195	1678	28800894441000
143196	2133	9502154000
143197	1874	7791000
143198	2134	12758315000
143206	633	82989628900000
143207	633	82989641900000
143260	1397	1265192654000
143261	1678	28800894446000
143262	2134	12754299000
143263	1874	7819000
143264	2133	9498146000
143265	1874	7821000
143266	1685	195124951571430
143267	1685	195124963571430
143268	1397	1265182653000
143269	1678	28800894447000
143270	1397	1265172652000
143271	1678	28800894448000
143272	1397	1265162651000
143273	1678	28800894449000
143274	1397	1265152650000
143275	1678	28800894450000
143276	2133	9497144000
143277	1874	7823000
143278	2134	12753295000
143279	1874	7827000
143280	2132	7200214000
143281	2134	12752291000
143282	2134	12751287000
143283	1874	7836000
143284	2133	9496142000
143285	2133	9495140000
143286	1874	7840000
143287	2133	9494138000
143288	1874	7842000
143289	1619	10800305000000
143298	1397	1265132648000
143299	1678	28800894452000
143300	1397	1265122647000
143301	1678	28800894453000
143302	2132	7199213000
143303	1874	7845000
143304	2133	9492134000
143305	1874	7847000
143306	2134	12750283000
143307	1874	7851000
143308	2134	12749279000
143309	1476	18720427000000
143310	1476	18720451000000
143313	1397	1265112646000
143314	1678	28800894454000
143315	2134	12748275000
143316	555	67440075000000
143317	555	68160075000000
143324	2386	800227000000
143325	2386	880227000000
143326	1874	6900000
143327	1874	6902000
143328	1874	6908000
143329	1874	6912000
143330	1874	6924000
143331	1874	6930000
143332	1874	6932000
143333	1874	6934000
143334	1874	6938000
143335	1874	6940000
143336	1874	6942000
143337	1874	6948000
143338	1874	6950000
143339	1874	6954000
143340	1874	6956000
143341	1426	18330939166670
143342	1874	6970000
143343	1874	6972000
143344	1874	6982000
143345	1874	6984000
143346	1874	6986000
143347	1874	6990000
143348	1874	6992000
143349	1426	19050939166670
143350	1426	19050947166385
143351	1807	200000010
143352	1855	200005480
143353	2252	203400000
143354	1571	5360846387379
143364	1874	7524000
143365	1740	19171039000000
143366	1740	19171043000000
143369	2134	12745263000
143370	2132	7197211000
143371	1874	7873000
143372	1670	14401143000000
143373	1670	14401145000000
143377	1700	14634363979053
143378	1700	14634375979053
143404	1397	1265012636000
143405	1678	28800894464000
143406	1397	1265002635000
143407	1678	28800894465000
143408	1397	1264992634000
143409	1678	28800894466000
143410	2132	7195209000
143411	2134	12741247000
143412	2134	12740243000
143413	2134	12739239000
143414	1874	7899000
143415	149	82655512000341
143416	1397	1264982633000
143417	1678	28800894467000
143418	1397	1264972632000
143419	1678	28800894468000
143420	1397	1264962631000
143421	1678	28800894469000
143422	2134	12738235000
143423	1874	7903000
143424	2134	12737231000
143425	2132	7194208000
143426	1874	7908000
143427	1395	58335033455457278
143428	1395	58335033488457278
143434	1740	19891043000000
143435	1740	19891048000000
143463	1397	1264912626000
143464	1678	28800894474000
143465	2134	12733215000
143466	1762	14325717994000
143467	1762	14325728994000
143480	1397	1264882623000
143481	1678	28800894477000
143482	1379	2000001650
143483	2400	1693977634750000
143484	2134	12731207000
143485	1874	7934000
143486	1457	14400314800000
143487	1457	14400326800000
143578	1672	17281593000000
143579	1672	17281615000000
143622	1397	1264802615000
143623	1678	28800894485000
143624	2133	9488126000
143625	1874	7964000
143626	2132	7189203000
143627	2134	12725183000
143628	1874	7969000
143629	484	75453960000000
143667	1397	1264752610000
143668	1678	28800894490000
143669	2133	9483116000
143670	1874	7992000
143671	2004	200000063
143672	1602	14976730169991
143673	1602	14976736169996
143674	1527	305999944
143703	1649	17031672999968
143720	1716	3600094000000
143726	2087	4035424147766
143731	1695	17225311999000
143184	2133	9504158000
143185	1874	7786000
143186	2132	7203217000
143187	1657	12961478990100
143188	1657	12961503990100
143217	1874	7504000
143218	2386	129000000
143219	2386	227000000
143220	1874	7506000
143221	2386	140227000000
143222	1874	7509000
143223	1874	7512000
143224	1874	7516000
143225	1874	7522000
143226	1740	18450977000000
143227	1740	18451039000000
143240	1588	16631998000000
143241	1588	16465618000000
143242	1588	16353621000000
143243	1588	16260770000000
143244	1874	6513000
143245	1874	6515000
143246	1874	6516000
143247	1874	6518000
143248	1874	6519000
143249	1690	195125998466662
143250	2349	110000000
143251	1655	2000000
143252	1604	7100000
143253	2052	250000142
143254	697	66000006999986
143255	1964	200000006
143256	1690	195126000566578
143257	1527	298999951
143293	1397	1265142649000
143294	1678	28800894451000
143295	2133	9493136000
143318	1397	1265102645000
143319	1678	28800894455000
143320	2132	7198212000
143321	1874	7860000
143322	1426	19050516000000
143323	1426	19050527000000
143380	1397	1265062641000
143381	1678	28800894459000
143382	1467	10240349272869
143383	1467	10240359272869
143393	1397	1265032638000
143394	1678	28800894462000
143395	1397	1265022637000
143396	1678	28800894463000
143397	1754	4994000000
143398	1779	3000000000
143399	2132	7196210000
143400	2134	12742251000
143401	1874	7886000
143402	1685	195844963571430
143403	1685	195844986571430
143440	1740	20611048000000
143470	1397	1264902625000
143471	1678	28800894475000
143472	1397	1264892624000
143473	1678	28800894476000
143474	2132	7192206000
143475	1874	7926000
143476	2134	12732211000
143477	1874	7930000
143478	1402	59223751812105
143479	1402	59223773812105
143489	1610	17280415999950
143490	1610	17280427999950
143569	1397	1264872622000
143570	1678	28800894478000
143571	1397	1264862621000
143572	1678	28800894479000
143573	2132	7191205000
143574	1874	7935000
143575	2134	12730203000
143576	1874	7939000
143577	1698	17349074550062
143581	1768	26387196110000
143582	1768	26387218110000
143590	1397	1264852620000
143591	1678	28800894480000
143592	1397	1264842619000
143593	1678	28800894481000
143594	2134	12729199000
143595	1874	7943000
143596	2134	12728195000
143597	1874	7947000
143598	1394	1068496226440200
143599	1394	1068496248440200
143607	1394	1069936248440200
143608	1394	1069936261440200
143615	1874	6531000
143616	1690	197286012566578
143617	1690	197286013566578
143632	1688	48311439113019
143633	1688	48311452113019
143640	1397	1264782613000
143641	1678	28800894487000
143642	2133	9486122000
143643	1874	7977000
143663	1588	18420794000000
143664	1588	18420806000000
143676	1397	1264742609000
143677	1678	28800894491000
143678	2133	9482114000
143679	1874	7994000
143680	2134	12721167000
143681	1874	7998000
143682	2064	717200000000
143683	1489	15506290040000
143684	1489	15506302040000
143708	1397	1264702605000
143709	1678	28800894495000
143710	2134	12718155000
143711	1874	8017000
143712	2133	9478106000
143713	2132	7186200000
143724	1695	17225310999000
143729	1394	1071376261440200
143730	1394	1071376262440200
143738	2133	9475100000
143739	1451	9067837000000
143741	1397	1264672602000
143742	1678	28800894498000
143743	1397	1264662601000
143744	1678	28800894499000
143745	2134	12715143000
143746	2134	12714139000
143747	2133	9474098000
143748	2133	9473096000
143749	1654	22457733999798
143772	1991	17901542355805
143778	2134	12711127000
143779	2133	9469088000
143780	2148	12960401880750
143794	1395	58336473481457278
143795	1395	58336473492457278
143799	1397	1264592594000
143800	1678	28800894506000
143801	2134	12709119000
143802	1506	10080297967172
143819	1397	1264562591000
143820	1678	28800894509000
143821	2134	12706107000
143822	1874	8090000
143823	1394	1072816283440200
143825	1397	1264552590000
143826	1678	28800894510000
143827	2133	9468086000
143828	2132	7181195000
143829	1874	8093000
143830	2134	12705103000
143838	1440	7920262045924
143839	1440	7920273045924
143840	421	66843681394804
143841	2408	2000000000
143842	1397	1264532588000
143843	1678	28800894512000
143844	2134	12704099000
143845	2133	9466082000
143846	1874	8105000
143847	1692	19181087819983
143852	2133	9465080000
143853	2134	12703095000
143854	1599	19737107097983
143855	1599	19737120097983
143870	1747	7266091999992
143871	1747	7986091999992
143872	1747	7986107999992
143876	1397	1264492584000
143877	1678	28800894516000
143878	1397	1264482583000
143879	1678	28800894517000
143880	2134	12700083000
143881	2134	12699079000
143882	2133	9461072000
143883	1726	127431112000
143884	2409	100000000
143885	2133	9460070000
143886	1874	8139000
143887	1395	58336473506457278
143907	1397	1264452580000
143518	1678	28080869448000
143519	1678	28080869449000
143520	1678	28080869450000
143521	1678	28080869451000
143522	1678	28080869452000
143523	1678	28080869453000
143524	1678	28080869454000
143525	1678	28080869455000
143526	1678	28080869456000
143527	1678	28080869457000
143528	1678	28080869458000
143529	1678	28080869459000
143530	1678	28080869460000
143531	1678	28080869461000
143532	1678	28080869462000
143533	1678	28080869463000
143534	1678	28080869464000
143535	1678	28080869465000
143536	1678	28080869466000
143537	1678	28080869467000
143538	1678	28080869468000
143539	1678	28080869469000
143540	1678	28080869470000
143541	1678	28080869471000
143542	1678	28080869472000
143543	1678	28080869473000
143544	1678	28080869474000
143545	1678	28080869475000
143546	1678	28080869476000
143547	1678	28080869477000
143548	1874	7673000
143549	1874	7675000
143550	1874	7678000
143551	1874	7679000
143552	1874	7683000
143553	1610	16561893999950
143554	1874	7695000
143555	1874	7697000
143556	1874	7700000
143557	1874	7702000
143558	1874	7704000
143559	1874	7706000
143560	1874	7709000
143561	1874	7715000
143562	1874	7727000
143563	1874	7729000
143564	1874	7739000
143565	1874	7741000
143566	1874	7743000
143567	1610	17281893999950
143568	1610	17281932999950
143580	1684	33123613819412
143583	1874	6523000
143584	1874	6525000
143585	1874	6526000
143586	1874	6528000
143587	1874	6529000
143588	1690	196566001566578
143589	1690	196566012566578
143600	1397	1264832618000
143601	1678	28800894482000
143602	2134	12727191000
143603	1874	7951000
143604	2132	7190204000
143605	2133	9491132000
143606	1395	58335033468457278
143634	1397	1264792614000
143635	1678	28800894486000
143636	2133	9487124000
143637	1874	7971000
143638	2134	12724179000
143639	1874	7975000
143653	1397	1264762611000
143654	1678	28800894489000
143655	2134	12722171000
143656	2133	9484118000
143657	2004	200000027
143658	1687	11649043848303
143659	2252	200600000
143660	1687	11649044648287
143661	1527	300999949
143662	2004	200000054
143665	1692	19180975819983
143666	1692	19180987819983
143675	1602	14976741170000
143696	1397	1264722607000
143697	1678	28800894493000
143698	2133	9480110000
143699	2134	12719159000
143700	1874	8011000
143701	484	76173960000000
143702	484	76173972000000
143704	1397	1264712606000
143705	1678	28800894494000
143706	2133	9479108000
143707	1649	17031683999968
143719	1716	3600104000000
143721	2133	9476102000
143722	2086	5040416300069
143725	1699	4320365750126
143732	1397	1264682603000
143733	1678	28800894497000
143734	2134	12716147000
143735	1874	8032000
143736	2132	7185199000
143737	1451	9067836000000
143751	576	82637737726897
143752	576	82637762726897
143758	1397	1264642599000
143759	1678	28800894501000
143760	2132	7184198000
143761	1874	8050000
143762	2134	12713135000
143763	2133	9471092000
143764	1874	8056000
143765	2148	12960379880750
143766	2148	12960392880750
143787	1394	1071376272440200
143793	1536	21600433000000
143806	1397	1264582593000
143807	1678	28800894507000
143808	2132	7182196000
143809	1874	8078000
143810	2134	12708115000
143811	1451	9787836000000
143812	1451	9787848000000
143815	1395	58336473493457278
143832	1397	1264542589000
143833	1678	28800894511000
143834	2133	9467084000
143835	1874	8099000
143836	1422	14634732804270
143837	1422	14634743804270
143856	1397	1264512586000
143857	1678	28800894514000
143858	2292	2159060000000
143859	1397	1264502585000
143860	1678	28800894515000
143861	2133	9464078000
143862	2133	9463076000
143863	2133	9462074000
143864	2132	7179193000
143865	2134	12702091000
143866	1874	8123000
143867	2134	12701087000
143868	2292	2879060000000
143869	2292	2879076000000
143895	1596	11520362000002
143926	1650	11633104000000
143974	1397	1264352570000
143975	1678	28800894530000
143976	2133	9447044000
143977	1685	196564997571430
144000	1397	1264302565000
144001	1678	28800894535000
144002	2134	12686027000
144003	2132	7173187000
144004	1874	8231000
144005	2133	9442034000
144006	1395	58337193506457278
144007	1395	58337193519457278
144028	2132	7172186000
144029	1874	8248000
144030	2134	12683015000
144031	1874	8252000
144032	2133	9438026000
144033	1874	8254000
144034	1489	16943302040000
144035	1489	16943305040000
144043	1397	1264252560000
144044	1678	28800894540000
144045	1397	1264242559000
144046	1678	28800894541000
144047	2134	12681007000
144048	1874	8264000
144049	2132	7171185000
144050	1874	8265000
144051	2133	9436022000
144052	1474	25730701000043
144053	2133	9435020000
144054	1874	8269000
144055	1474	26450701000043
144056	1474	26450702000043
144060	1397	1264232558000
144061	1678	28800894542000
143753	1397	1264652600000
143754	1678	28800894500000
143755	2133	9472094000
143767	1395	58335753481457278
143781	1397	1264612596000
143782	1678	28800894504000
143783	2132	7183197000
143784	1874	8069000
143785	1693	9405910623117
143786	1693	9405921623117
143788	1397	1264602595000
143789	1678	28800894505000
143790	2134	12710123000
143791	1724	18412963500000
143792	1724	18412974500000
143805	1690	186485856000000
143813	1394	1072816272440200
143814	1394	1072816284440200
143816	1397	1264572592000
143817	1678	28800894508000
143818	2134	12707111000
143873	1746	6288990999989
143874	1746	7008990999989
143875	1746	7009006999989
143888	2408	1990000000
143889	1397	1264472582000
143890	1678	28800894518000
143891	2133	9459068000
143892	1874	8141000
143893	1687	12369044648287
143894	1687	12369065648287
143896	1397	1264462581000
143897	1678	28800894519000
143898	2132	7178192000
143899	2134	12698075000
143900	1874	8146000
143901	2133	9458066000
143902	1422	15354743804270
143903	1422	15354756804270
143915	1397	1264442579000
143916	1678	28800894521000
143917	1397	1264432578000
143918	1678	28800894522000
143919	2133	9456062000
143920	2132	7177191000
143921	1874	8157000
143922	2133	9455060000
143923	2134	12696067000
143924	1874	8163000
143925	1474	25730678000043
143936	1700	16074386979053
143937	1700	16074410979053
143949	1397	1264392574000
143950	1678	28800894526000
143951	1397	1264382573000
143952	1678	28800894527000
143953	2134	12692051000
143954	1874	8186000
143955	2133	9451052000
143956	2133	9450050000
143957	1671	19824352003785
143966	1397	1264362571000
143967	1678	28800894529000
143968	2132	7175189000
143969	2133	9448046000
143970	1874	8199000
143971	2134	12690043000
143972	1692	19901087819983
143973	1692	19901100819983
143996	1397	1264312566000
143997	1678	28800894534000
143998	2133	9443036000
143999	1874	8226000
144018	149	83375512000341
144019	149	83375535000341
144022	1397	1264272562000
144023	1678	28800894538000
144024	2133	9439028000
144025	2134	12684019000
144026	1688	48311451113019
144027	1693	9405922623117
144067	1679	22318535656999
144068	1679	22318547656999
144089	1671	20544364003785
144092	1397	1264202555000
144093	1678	28800894545000
144094	2134	12677995000
144095	2133	9431012000
144101	1402	60663785812105
144102	1402	60663797812105
144116	1397	1264162551000
144117	1678	28800894549000
144118	2134	12674983000
144119	1394	1075696308440200
144120	1394	1075696319440200
144143	1397	1264132548000
144144	1678	28800894552000
144145	2133	9423998000
144146	1874	8322000
144147	2134	12672975000
144148	1874	8326000
144149	2329	334806932819988
144150	2329	334806944819988
144161	1715	12263634663945
144162	1715	12263659663945
144165	1759	13897341139889
144166	1759	13897366139889
144169	1397	1264102545000
144170	1678	28800894555000
144171	1397	1264092544000
144172	1678	28800894556000
144173	2134	12669963000
144174	2133	9419990000
144175	2133	9418988000
144176	2134	12668959000
144177	1395	58338633530457278
144178	1395	58338633554457278
144197	2329	335526944819988
144198	2329	335526956819988
144213	1703	7920967000000
144229	1397	1264012536000
144230	1678	28800894564000
144231	1397	1264002535000
144232	1678	28800894565000
144233	2133	9410972000
144234	1874	8392000
144235	2133	9409970000
144236	1874	8394000
144237	2134	12662935000
144238	1874	8398000
144239	2134	12661931000
144240	1654	22457732999798
144259	1397	1263962531000
144260	1678	28800894569000
144261	1397	1263952530000
144262	1678	28800894570000
144263	2132	7162176000
144264	1874	8418000
144265	2133	9405962000
144266	2133	9404960000
144267	1874	8422000
144268	2134	12658919000
144269	1698	17349076550062
144291	1397	1263912526000
144292	1678	28800894574000
144293	1397	1263902525000
144294	1678	28800894575000
144295	1397	1263892524000
144296	1678	28800894576000
144297	1397	1263882523000
144298	1678	28800894577000
144299	1397	1263872522000
144300	1678	28800894578000
144301	2405	96230770
144302	2405	92461540
144303	2133	9400952000
144304	2133	9399950000
144305	1874	8445000
144306	2133	9398948000
144307	2133	9397946000
144308	2133	9396944000
144309	1874	8451000
144310	2134	12655907000
144311	2134	12654903000
144312	2134	12653899000
144313	1874	8463000
144314	2134	12652895000
144315	1874	8467000
144316	2132	7160174000
144317	1532	2160057000000
144318	1532	2160124538460
144343	1394	1078576331440200
144344	1394	1078576352440200
144350	1397	1263822517000
144351	1678	28800894583000
144352	656	66543490726895
144353	2411	0
144354	2134	12648879000
144355	2133	9391934000
144356	1874	8495000
144357	2132	7158172000
144358	1695	17945311999000
144359	1695	17945334999000
144392	1739	33119873000000
144393	1739	33119896000000
143908	1678	28800894520000
143909	2133	9457064000
143910	1686	19832211700123
143911	1686	19832223700123
143914	1686	19832212700123
143927	1397	1264422577000
143928	1678	28800894523000
143929	1397	1264412576000
143930	1678	28800894524000
143931	2133	9454058000
143932	2134	12695063000
143933	2134	12694059000
143934	2133	9453056000
143935	1394	1072816296440200
143940	1708	16920727324650
143941	1708	16920751324650
143942	1397	1264402575000
143943	1678	28800894525000
143944	2132	7176190000
143945	2134	12693055000
143946	2133	9452054000
143947	1679	21598522656999
143948	1679	21598535656999
143965	2307	6479145000000
143978	1397	1264342569000
143979	1678	28800894531000
143980	1397	1264332568000
143981	1678	28800894532000
143982	1397	1264322567000
143983	1678	28800894533000
143984	2132	7174188000
143985	1874	8206000
143986	2134	12689039000
143987	1874	8210000
143988	2133	9446042000
143989	1874	8212000
143990	2133	9445040000
143991	2133	9444038000
143992	1874	8216000
143993	2134	12688035000
143994	2134	12687031000
143995	1768	26387233110000
144008	1397	1264292564000
144009	1678	28800894536000
144010	1397	1264282563000
144011	1678	28800894537000
144012	2134	12685023000
144013	2133	9441032000
144014	1874	8239000
144015	2133	9440030000
144016	1874	8241000
144017	1654	22457731999798
144020	1559	16866286499999
144021	1559	16866309499999
144036	1690	186485848000000
144057	1692	19901123819983
144058	1692	20621123819983
144059	1692	20621124819983
144079	1690	187205848000000
144080	1690	187205859000000
144087	1671	20544352003785
144088	1671	20544353003785
144090	1402	59943773812105
144091	1402	59943785812105
144109	1397	1264172552000
144110	1678	28800894548000
144111	2134	12675987000
144112	2132	7169183000
144113	1874	8303000
144114	1394	1074256296440200
144115	1394	1074256308440200
144125	1397	1264152550000
144126	1678	28800894550000
144127	1397	1264142549000
144128	1678	28800894551000
144129	2133	9428006000
144130	1874	8309000
144131	2132	7168182000
144132	2134	12673979000
144133	1874	8314000
144134	2133	9427004000
144135	2133	9426002000
144136	1874	8318000
144137	2133	9425000000
144138	632	83997764000000
144139	632	83997790000000
144141	1709	11520256000000
144142	1709	11520282000000
144164	1613	16417518400000
144167	2133	9420992000
144168	1708	16920728324650
144189	1397	1264062541000
144190	1678	28800894559000
144191	2134	12666951000
144192	2133	9415982000
144195	1708	17640728324650
144196	1708	17640740324650
144214	1397	1264032538000
144215	1678	28800894562000
144216	2133	9412976000
144217	2329	335526955819988
144218	1397	1264022537000
144219	1678	28800894563000
144220	2132	7164178000
144221	2133	9411974000
144222	2134	12663939000
144223	1602	15696736169996
144224	1602	15696749169996
144319	1395	58339353554457278
144320	1395	58339353621995738
144329	1439	14383898578477
144332	1397	1263852520000
144333	1678	28800894580000
144334	2133	9394940000
144335	2132	7159173000
144336	2134	12650887000
144337	1874	8481000
144360	1397	1263812516000
144361	1678	28800894584000
144362	2133	9390932000
144363	1874	8498000
144364	1395	58339353565457278
144371	1508	19640537156616
144372	1508	19640549156616
144381	2411	10000000
144382	656	66543460726895
144383	1397	1263782513000
144384	1678	28800894587000
144385	2134	12645867000
144386	1874	8514000
144387	2133	9387926000
144388	2132	7157171000
144389	1874	8517000
144390	1850	19416548949999
144391	1850	19416571949999
144394	2133	9386924000
144395	1685	197284997571430
144396	1685	197284998571430
144446	1702	7920615000000
144447	1702	8640615000000
144476	1397	1263662501000
144477	1678	28800894599000
144478	2133	9374900000
144479	2134	12636831000
144480	2132	7153167000
144481	1874	8583000
144482	1536	22320433000000
144483	1536	22320446000000
144486	1874	8580000
144487	1686	20552224700123
144489	1397	1263652500000
144490	1678	28800894600000
144491	2133	9373898000
144492	2134	12635827000
144493	1874	8589000
144494	1693	10125922623117
144495	1693	10125935623117
144531	1874	8522000
144532	1874	8570000
144533	1650	10913302000000
144534	1650	11633302000000
144535	1650	11633321000000
144543	1397	1263602495000
144544	1678	28800894605000
144545	2133	9367886000
144546	2132	7151165000
144547	1874	8619000
144548	2329	336966992819988
144549	2329	336967004819988
144558	1654	23177744999798
144602	2307	6479156000000
144604	1397	1263562491000
144605	1678	28800894609000
144606	1397	1263552490000
144607	1678	28800894610000
144608	2133	9358868000
144609	1874	8663000
144610	2133	9357866000
144611	2134	12624783000
144612	1874	8669000
144613	2134	12623779000
144614	1874	8673000
144615	2132	7148162000
144616	484	76893972000000
144617	484	76893997000000
144062	2134	12680003000
144063	2133	9434018000
144064	1874	8275000
144065	1656	18715872499990
144066	1656	18715884499990
144096	1397	1264192554000
144097	1678	28800894546000
144098	2134	12676991000
144099	2133	9430010000
144100	1546	16077621800000
144151	1397	1264122547000
144152	1678	28800894553000
144153	1397	1264112546000
144154	1678	28800894554000
144155	2132	7167181000
144156	2133	9422996000
144157	2133	9421994000
144158	2134	12671971000
144159	2134	12670967000
144160	1688	48311464113019
144163	369	83076694290830
144199	1397	1264052540000
144200	1678	28800894560000
144201	1397	1264042539000
144202	1678	28800894561000
144203	2132	7165179000
144204	1874	8369000
144205	2133	9414980000
144206	2134	12665947000
144207	2133	9413978000
144208	2134	12664943000
144209	1513	37441253000000
144210	1513	37441278000000
144211	1702	8640592000000
144212	1702	8640617000000
144227	1599	20457120097983
144228	1599	20457133097983
144252	1397	1263972532000
144253	1678	28800894568000
144254	2134	12659923000
144255	1874	8415000
144256	2133	9406964000
144257	1394	1075696331440200
144258	1394	1077136331440200
144270	1540	720024000000
144321	1692	21341124819983
144322	1692	21341192358443
144330	1513	38161278000000
144331	1513	38161290000000
144338	656	66544500726895
144339	1397	1263842519000
144340	1678	28800894581000
144341	2133	9393938000
144342	1622	10404073800048
144365	1397	1263802515000
144366	1678	28800894585000
144367	2133	9389930000
144368	2134	12647875000
144369	1874	8504000
144370	1690	187205860000000
144403	2112	29327069101924
144404	2112	29327081101924
144420	1692	21341136819983
144426	2411	543000000000
144427	1397	1263732508000
144428	1678	28800894592000
144429	2133	9381914000
144430	2134	12641851000
144431	2132	7155169000
144432	1394	1080016343440200
144433	1394	1080016366440200
144434	1397	1263722507000
144435	1678	28800894593000
144436	1397	1263712506000
144437	1678	28800894594000
144438	2133	9380912000
144439	2134	12640847000
144440	2134	12639843000
144441	1703	7200965000000
144442	2133	9379910000
144443	1133	1000000000
144444	2413	900971464000000
144445	1703	7920965000000
144448	1397	1263702505000
144449	1678	28800894595000
144450	2133	9378908000
144451	1813	220000000
144452	1394	1081456346440200
144453	1394	1081456357440200
144473	1654	23177732999798
144474	1654	23177756999798
144488	632	83997777000000
144496	1693	10125934623117
144502	1623	86403584898598
144519	1397	1263612496000
144520	1678	28800894604000
144521	2134	12632815000
144522	1874	8603000
144523	1874	8606000
144524	2133	9369890000
144525	1874	8610000
144526	1688	49031451113019
144527	1688	49031487113019
144530	1623	86403606898598
144536	2134	12631811000
144537	1726	124128112000
144538	2415	100000000
144539	1874	8612000
144540	2133	9368888000
144541	1874	8616000
144542	1700	16074392979053
144556	1610	18000427999950
144557	1610	18000439999950
144559	2133	9365882000
144560	1874	8627000
144561	2133	9364880000
144562	1874	8629000
144563	2132	7150164000
144564	1874	8630000
144565	2134	12629803000
144566	2134	12628799000
144567	1874	8638000
144568	1623	87123606898598
144569	1623	87123611898598
144581	58	82547671999641
144582	58	82547673999641
144585	2133	9361874000
144586	2132	7149163000
144587	1874	8649000
144588	2134	12626791000
144589	1874	8653000
144590	43	82560295890000
144618	1693	10845935623117
144619	1693	10845960623117
144622	1397	1263542489000
144623	1678	28800894611000
144624	1726	123027112000
144625	2416	100000000
144626	2133	9356864000
144627	1874	8676000
144628	2134	12622775000
144629	1394	1084336369440200
144630	1394	1084336382440200
144632	1397	1263532488000
144633	1678	28800894612000
144634	2133	9355862000
144635	1874	8682000
144636	1768	27107233110000
144637	1768	27107244110000
144657	1555	18246324540449
144658	1397	1263492484000
144659	1678	28800894616000
144660	2133	9351854000
144661	2132	7146160000
144667	1397	1263472482000
144668	1678	28800894618000
144669	2134	12617755000
144670	2133	9349850000
144671	1547	14394863000000
144672	1547	14394875000000
144709	1711	19147110000000
144710	1397	1263412476000
144711	1678	28800894624000
144712	2133	9343838000
144715	1397	1263402475000
144716	1678	28800894625000
144717	2416	95142860
144718	2134	12612735000
144719	2133	9342836000
144720	1708	18360758181790
144730	1397	1263382473000
144731	1678	28800894627000
144732	2133	9340832000
144733	1593	18672858000000
144734	1593	18672869000000
144764	1395	58341513613457278
144765	1395	58341513638457278
144776	1397	1263322467000
144777	1678	28800894633000
144778	2134	12606711000
144779	1874	8792000
144780	2132	7141155000
144781	2133	9334820000
144782	1874	8795000
144783	2329	337687004819988
144124	1709	11520377999992
144140	171	77466824696494
144179	1397	1264082543000
144180	1678	28800894557000
144181	1397	1264072542000
144182	1678	28800894558000
144183	2133	9417986000
144184	2134	12667955000
144185	2133	9416984000
144186	2132	7166180000
144187	1402	61383797812105
144188	1402	61383821812105
144193	576	83357762726897
144194	576	83357774726897
144225	1684	33843613819412
144226	1684	33843626819412
144241	1397	1263992534000
144242	1678	28800894566000
144243	1397	1263982533000
144244	1678	28800894567000
144245	2132	7163177000
144246	2134	12660927000
144247	1874	8407000
144248	2133	9408968000
144249	2133	9407966000
144250	1482	2160030000000
144251	1482	2160054000000
144271	1397	1263942529000
144272	1678	28800894571000
144273	1397	1263932528000
144274	1678	28800894572000
144275	1397	1263922527000
144276	1678	28800894573000
144277	2133	9403958000
144278	1874	8428000
144279	2133	9402956000
144280	1874	8430000
144281	2134	12657915000
144282	1874	8434000
144283	2133	9401954000
144284	2132	7161175000
144285	1874	8437000
144286	2134	12656911000
144287	1726	126330112000
144288	2410	100000000
144289	2329	336246955819988
144290	2329	336246992819988
144323	1397	1263862521000
144324	1678	28800894579000
144325	2133	9395942000
144326	1874	8470000
144327	2134	12651891000
144328	1602	15696748169996
144345	1397	1263832518000
144346	1678	28800894582000
144347	2133	9392936000
144348	2134	12649883000
144349	470	79555384000000
144373	1397	1263792514000
144374	1678	28800894586000
144375	656	66543450726895
144376	2411	30000000
144377	2133	9388928000
144378	2134	12646871000
144379	1874	8510000
144380	1671	20544374003785
144405	656	66000450726895
144406	2411	543010000000
144407	1397	1263762511000
144408	1678	28800894589000
144409	2134	12643859000
144410	1874	8529000
144411	2132	7156170000
144412	2133	9384920000
144413	1395	58340073565457278
144414	1395	58340073588457278
144416	1397	1263752510000
144417	1678	28800894590000
144418	2134	12642855000
144419	2133	9383918000
144454	1397	1263692504000
144455	1678	28800894596000
144456	2132	7154168000
144457	2133	9377906000
144458	2134	12638839000
144459	1701	17998529500103
144460	1397	1263682503000
144461	1678	28800894597000
144462	1397	1263672502000
144463	1678	28800894598000
144464	2134	12637835000
144465	1874	8572000
144466	1726	125229112000
144467	2414	100000000
144468	2133	9376904000
144469	2133	9375902000
144470	1874	8576000
144471	1394	1082896357440200
144472	1394	1082896381440200
144475	576	83357786726897
144497	1397	1263642499000
144498	1678	28800894601000
144499	2134	12634823000
144500	2133	9372896000
144501	1394	1082896369440200
144573	2133	9362876000
144574	1874	8642000
144575	2134	12627795000
144576	1874	8646000
144577	1991	18621542355805
144578	1991	18621544355805
144580	1711	19147075000000
144584	171	77466800696494
144631	1688	49031464113019
144638	1397	1263522487000
144639	1678	28800894613000
144640	1397	1263512486000
144641	1678	28800894614000
144642	2132	7147161000
144643	1874	8683000
144644	2134	12621771000
144645	2134	12620767000
144646	2133	9354860000
144647	2133	9353858000
144648	1395	58340793588457278
144649	1395	58340793613457278
144675	1397	1263462481000
144676	1678	28800894619000
144677	2133	9348848000
144678	2134	12616751000
144679	1991	18621554355805
144682	641	85444019500000
144683	641	85444030500000
144685	1397	1263452480000
144686	1678	28800894620000
144687	2133	9347846000
144688	2132	7145159000
144689	1394	1085776382440200
144690	1394	1085776394440200
144735	1397	1263372472000
144736	1678	28800894628000
144737	2133	9339830000
144738	1874	8763000
144739	2134	12610727000
144740	1673	12455495000000
144741	1673	12455507000000
144766	1397	1263332468000
144767	1678	28800894632000
144768	2134	12607715000
144769	1874	8786000
144770	2133	9335822000
144771	1619	11520305000000
144772	1619	11520317000000
144788	1397	1263312466000
144789	1678	28800894634000
144790	1397	1263302465000
144791	1678	28800894635000
144792	2133	9333818000
144793	1874	8801000
144794	2133	9332816000
144795	1395	58341513636457278
144830	1700	16794392979053
144831	1700	16794416979053
144840	1397	1263232458000
144841	1678	28800894642000
144842	2133	9325802000
144843	2134	12599683000
144844	1874	8843000
144845	1695	18665334999000
144846	1695	18665346999000
144866	1395	58340793887457278
144867	1395	58341513887457278
144868	1395	58341513891457278
144878	2134	12597675000
144879	2133	9322796000
144880	1874	8858000
144881	1471	21545555900000
144886	1397	1263192454000
144887	1678	28800894646000
144888	2133	9321794000
144889	2132	7137151000
144890	1874	8861000
144908	1397	1263162451000
144909	1678	28800894649000
144910	2133	9318788000
144397	1397	1263772512000
144398	1678	28800894588000
144399	2134	12644863000
144400	2133	9385922000
144401	1874	8525000
144402	1394	1078576343440200
144415	1764	18803609100000
144421	1397	1263742509000
144422	1678	28800894591000
144423	1013	2000000000
144424	2412	502774774000000
144425	2133	9382916000
144484	1686	20552212700123
144485	1686	20552225700123
144503	1397	1263632498000
144504	1678	28800894602000
144505	1397	1263622497000
144506	1678	28800894603000
144507	1874	8533000
144508	1455	7951840000000
144509	2134	12633819000
144510	2132	7152166000
144511	1874	8586000
144512	1874	8592000
144513	1874	8600000
144514	2133	9371894000
144515	2133	9370892000
144516	1874	8604000
144517	1455	8671840000000
144518	1455	8671862000000
144528	1458	24425501908540
144529	1458	24425537908540
144550	1397	1263592494000
144551	1678	28800894606000
144552	2133	9366884000
144553	2134	12630807000
144554	1671	21264374003785
144555	1671	21264386003785
144570	2133	9363878000
144571	1467	10960362272869
144572	1467	10960363272869
144579	1711	19147074000000
144583	1599	20457122097983
144591	1397	1263582493000
144592	1678	28800894607000
144593	1397	1263572492000
144594	1678	28800894608000
144595	2134	12625787000
144596	1874	8657000
144597	2133	9360872000
144598	1874	8659000
144599	2133	9359870000
144600	1506	10800298967172
144601	1506	10800321967172
144603	1474	26450678000043
144652	1397	1263502485000
144653	1678	28800894615000
144654	2134	12619763000
144655	2133	9352856000
144656	1394	1084336381440200
144680	1874	8720000
144681	1991	18621553355805
144684	641	85444031500000
144721	1397	1263392474000
144722	1678	28800894626000
144723	2134	12611731000
144724	1874	8756000
144725	2133	9341834000
144726	2132	7143157000
144727	1874	8759000
144728	1701	18718529500103
144729	1701	18718542500103
144749	1397	1263352470000
144750	1678	28800894630000
144751	1397	1263342469000
144752	1678	28800894631000
144753	2134	12608719000
144754	2132	7142156000
144755	1874	8778000
144756	2133	9337826000
144757	2133	9336824000
144758	1726	121926112000
144759	2417	100000000
144760	1768	27827244110000
144761	1768	27827269110000
144773	2106	6480225000000
144774	2106	6480237000000
144785	2134	12605707000
144786	1874	8799000
144787	1610	18000428999950
144802	2132	7140154000
144811	1611	5033536402899
144819	1397	1263262461000
144820	1678	28800894639000
144821	1397	1263252460000
144822	1678	28800894640000
144823	2133	9328808000
144824	2133	9327806000
144825	2132	7139153000
144826	2134	12601691000
144827	1874	8831000
144828	1457	15120326800000
144829	1457	15120350800000
144849	2381	950000000
144850	1397	1263222457000
144851	1678	28800894643000
144852	1397	1263212456000
144853	1678	28800894644000
144854	1963	731505120000
144855	296	66002000000000
144856	1402	61384095812105
144857	2132	7138152000
144858	1874	8844000
144859	2133	9324800000
144860	1874	8846000
144861	2133	9323798000
144862	2134	12598679000
144863	1874	8852000
144864	1402	62104095812105
144865	1402	62104099812105
144869	1397	1263202455000
144870	1678	28800894645000
144871	1874	8620000
144872	1874	8622000
144873	1874	8623000
144874	1874	8633000
144875	1874	8635000
144876	1471	21545543900000
144877	1471	21546224900000
144884	2329	337687258819988
144891	1693	11565960623117
144892	1693	11565972623117
144899	1702	10080627000000
144900	1702	10080639000000
144946	1397	1263102445000
144947	1678	28800894655000
144948	1397	1263092444000
144949	1678	28800894656000
144950	2133	9312776000
144951	2134	12590647000
144952	1874	8909000
144953	2133	9311774000
144954	2134	12589643000
144955	1874	8915000
144956	2132	7134148000
144957	1874	8916000
144958	1711	19147098000000
144967	1397	1263072442000
144968	1678	28800894658000
144969	1397	1263062441000
144970	1678	28800894659000
144971	2134	12587635000
144972	2133	9309770000
144973	1874	8928000
144974	2133	9308768000
144975	1394	1091536454440200
144976	1394	1091536477440200
144979	1397	1263052440000
144980	1678	28800894660000
144981	2132	7133147000
144982	1874	8931000
144983	2133	9307766000
144984	2134	12586631000
144985	1874	8937000
144986	1571	7520869387195
144987	1571	7520882387195
145010	1623	87843611898598
145011	1623	87843635898598
145031	1397	1262982433000
145032	1678	28800894667000
145033	2133	9300752000
145034	2134	12581611000
145035	1573	9939447000000
145036	1573	9939459000000
145051	1395	58341513624457278
145060	1705	31521140580140
145072	693	66000000000000
145073	1397	1262922427000
145074	1678	28800894673000
145075	1397	1262912426000
145076	1678	28800894674000
145077	2134	12577595000
145078	1874	9000000
145079	2134	12576591000
145080	2133	9294740000
144620	1708	18360740324650
144621	1708	18360765324650
144650	1706	24042409450256
144651	1706	24042434450256
144662	1397	1263482483000
144663	1678	28800894617000
144664	2133	9350852000
144665	2134	12618759000
144666	1706	24042421450256
144673	1476	19440451000000
144674	1476	19440463000000
144691	2112	30047081101924
144692	2112	30047093101924
144693	1397	1263442479000
144694	1678	28800894621000
144695	1397	1263432478000
144696	1678	28800894622000
144697	1397	1263422477000
144698	1678	28800894623000
144699	2132	7144158000
144700	1874	8726000
144701	2133	9346844000
144702	2133	9345842000
144703	2133	9344840000
144704	2134	12615747000
144705	2134	12614743000
144706	2134	12613739000
144707	1394	1087216394440200
144708	1394	1087216431440200
144713	1702	9360617000000
144714	1702	9360627000000
144742	1397	1263362471000
144743	1678	28800894629000
144744	2133	9338828000
144745	1874	8769000
144746	2134	12609723000
144747	1688	49751464113019
144748	1688	49751476113019
144762	2148	13680401880750
144763	2148	13680426880750
144775	1448	13639925000001
144796	1610	18000450999950
144797	1397	1263292464000
144798	1678	28800894636000
144799	2133	9331814000
144800	2134	12604703000
144801	1599	20457132097983
144803	1397	1263282463000
144804	1678	28800894637000
144805	2133	9330812000
144806	1874	8811000
144807	2134	12603699000
144808	1874	8816000
144809	1599	21177132097983
144810	1599	21177145097983
144812	1397	1263272462000
144813	1678	28800894638000
144814	2134	12602695000
144815	2133	9329810000
144816	1874	8822000
144817	1549	16271467000000
144818	1549	16271479000000
144832	1397	1263242459000
144833	1678	28800894641000
144834	2134	12600687000
144835	1874	8835000
144836	2133	9326804000
144837	1874	8837000
144838	1467	11680363272869
144839	1467	11680375272869
144882	1471	21545555899991
144883	2004	200000072
144885	2329	336967246819988
144893	369	83076681290830
144906	1706	24762421450256
144907	1706	24762433450256
144933	1397	1263122447000
144934	1678	28800894653000
144935	2134	12591651000
144936	1874	8898000
144937	2132	7135149000
144938	2133	9314780000
144939	1874	8901000
144940	1688	49751477113019
144959	2112	30047106101924
144990	1679	23038547656999
144991	1679	23038560656999
144998	1397	1263032438000
144999	1678	28800894662000
145000	1397	1263022437000
145001	1678	28800894663000
145002	2132	7132146000
145003	2134	12584623000
145004	1874	8948000
145005	2133	9305762000
145006	2133	9304760000
145007	1874	8952000
145008	1695	19385346999000
145009	1695	19385370999000
145012	1397	1263012436000
145013	1678	28800894664000
145014	2134	12583619000
145015	2133	9303758000
145016	1874	8958000
145017	1719	20878786000000
145045	1397	1262962431000
145046	1678	28800894669000
145047	2133	9298748000
145048	1874	8981000
145049	1623	88563635898598
145050	1623	88563646898598
145052	1397	1262952430000
145053	1678	28800894670000
145054	2133	9297746000
145055	2134	12579603000
145056	2132	7130144000
145057	1874	8988000
145058	1690	187925860000000
145059	1690	187925873000000
145071	1656	18715895499990
145083	1397	1262902425000
145084	1678	28800894675000
145085	1397	1262892424000
145086	1678	28800894676000
145087	2133	9293738000
145088	2134	12575587000
145089	2132	7128142000
145090	1874	9014000
145091	2133	9292736000
145092	1693	12285972623117
145093	1693	12285996623117
145101	1681	18574837358535
145102	2414	90000000
145103	1397	1262872422000
145104	1678	28800894678000
145105	2133	9290732000
145106	2134	12573579000
145107	1394	1095856501440200
145108	1394	1095856523440200
145111	1397	1262862421000
145112	1678	28800894679000
145113	2133	9289730000
145114	1874	9030000
145130	1397	1262832418000
145131	1678	28800894682000
145132	2134	12570567000
145133	1874	9047000
145134	2133	9286724000
145135	470	80275384000000
145136	470	80275396000000
145150	1672	17281617000000
145168	1513	38161302000000
145169	1397	1262772412000
145170	1678	28800894688000
145171	2133	9280712000
145172	2134	12566551000
145173	1394	1097296513440200
145174	1394	1097296525440200
145231	1746	7008993999989
145232	1397	1262682403000
145233	1678	28800894697000
145234	2133	9271694000
145235	1668	18513879500000
145244	2134	12558519000
145245	2148	12960412880750
145246	2133	9269690000
145247	2148	13680412880750
145248	2148	13680413880750
145258	1397	1262652400000
145259	1678	28800894700000
145260	2132	7121135000
145261	2133	9268688000
145262	2134	12557515000
145263	1874	9143000
145264	1711	19867098000000
145265	1711	19867111000000
145271	1397	1262642399000
145272	1678	28800894701000
145273	2133	9267686000
145274	1874	9145000
145275	1599	21897145097983
145276	1599	21897156097983
145285	1693	12285984623117
145298	1397	1262602395000
145299	1678	28800894705000
144784	2329	337687017819988
144847	1394	1088656431440200
144848	1394	1088656443440200
144894	1397	1263182453000
144895	1678	28800894647000
144896	2133	9320792000
144897	2134	12596671000
144898	1703	7920954000000
144901	1397	1263172452000
144902	1678	28800894648000
144903	2134	12595667000
144904	1874	8871000
144905	2133	9319790000
144914	1397	1263152450000
144915	1678	28800894650000
144916	2132	7136150000
144917	2133	9317786000
144918	1874	8882000
144919	1673	13175507000000
144920	1673	13175519000000
144921	1397	1263142449000
144922	1678	28800894651000
144923	1397	1263132448000
144924	1678	28800894652000
144925	2133	9316784000
144926	2134	12593659000
144927	1874	8888000
144928	2133	9315782000
144929	2134	12592655000
144930	1874	8894000
144931	1768	28547269110000
144932	1768	28547293110000
144941	1397	1263112446000
144942	1678	28800894654000
144943	2133	9313778000
144944	1394	1090096443440200
144945	1394	1090096454440200
144988	1659	720082999990
144989	1659	720095999990
144992	1397	1263042439000
144993	1678	28800894661000
144994	2134	12585627000
144995	2133	9306764000
144996	1394	1092976477440200
144997	1394	1092976489440200
145018	296	66001900000000
145019	1397	1263002435000
145020	1678	28800894665000
145021	1397	1262992434000
145022	1678	28800894666000
145023	2133	9302756000
145024	2132	7131145000
145025	1874	8961000
145026	2133	9301754000
145027	2134	12582615000
145028	1874	8967000
145029	1547	15114875000000
145030	1547	15114999000000
145037	1397	1262972432000
145038	1678	28800894668000
145039	2133	9299750000
145040	1874	8975000
145041	2134	12580607000
145042	1874	8979000
145043	1394	1094416489440200
145044	1394	1094416501440200
145094	1458	24425525908540
145122	1696	23483883335104
145123	1696	23483896335104
145137	1397	1262822417000
145138	1678	28800894683000
145139	1397	1262812416000
145140	1678	28800894684000
145141	2133	9285722000
145142	1874	9051000
145143	2133	9284720000
145144	1874	9053000
145145	2134	12569563000
145146	1874	9057000
145147	2132	7126140000
145148	1688	51191490113019
145149	1688	51191514113019
145175	1699	4320376750126
145182	1633	11568725625277
145193	2112	30047105101924
145200	1397	1262722407000
145201	1678	28800894693000
145202	1397	1262712406000
145203	1678	28800894694000
145204	1397	1262702405000
145205	1678	28800894695000
145206	2132	7123137000
145207	2134	12562535000
145208	2133	9275702000
145209	2133	9274700000
145210	2133	9273698000
145211	2134	12561531000
145216	1508	20360549156616
145217	1508	20360585156616
145219	1397	1262692404000
145220	1678	28800894696000
145221	2134	12560527000
145222	1874	9119000
145223	2132	7122136000
145224	2133	9272696000
145225	2292	3599076000000
145226	2292	3599089000000
145252	1714	19725852171760
145253	1714	20445852171760
145254	1714	20445853171760
145266	1444	16747941329999
145267	1444	16747954329999
145269	1395	58342233624457278
145270	1395	58342233636457278
145277	1397	1262632398000
145278	1678	28800894702000
145279	2133	9266684000
145280	2134	12556511000
145281	1874	9151000
145282	1426	19050528000000
145292	484	76893985000000
145303	1397	1262592394000
145304	1678	28800894706000
145305	2133	9262676000
145306	2132	7119133000
145307	1874	9169000
145308	2134	12553499000
145309	58	83267673999641
145310	58	83267686999641
145339	1547	15834999000000
145340	1547	15835012000000
145341	606	79727201286230
145342	656	66000440726895
145343	2411	543030000000
145344	606	80447201286230
145345	606	80447274824690
145404	1397	1262482383000
145405	1678	28800894717000
145406	2133	9251654000
145407	2134	12545467000
145408	1489	17663314040000
145409	1489	17663326040000
145433	1397	1262442379000
145434	1678	28800894721000
145435	2133	9247646000
145436	2134	12542455000
145437	2329	338407017819988
145438	2329	338407029819988
145469	1693	12286007623117
145502	1397	1262352370000
145503	1678	28800894730000
145504	2132	7112126000
145505	1874	9290000
145506	2134	12536431000
145507	2133	9238628000
145508	1874	9296000
145509	1719	21598786000000
145510	1719	21598799000000
145521	1397	1262332368000
145522	1678	28800894732000
145523	1397	1262322367000
145524	1678	28800894733000
145525	2134	12534423000
145526	2132	7111125000
145527	2133	9236624000
145528	1874	9309000
145529	2133	9235622000
145530	1874	9311000
145531	1610	18000451999950
145590	1688	51191516113019
145615	1419	29806333559748
145629	1397	1262172352000
145630	1678	28800894748000
145631	2133	9220592000
145632	1693	12285983623117
145690	1397	1262082343000
145691	1678	28800894757000
145692	2132	7104118000
145693	1874	9430000
145694	2134	12516351000
145695	1874	9434000
145696	2133	9212576000
145697	1991	19341554355805
145698	1991	19341567355805
145713	1397	1262052340000
144911	2134	12594663000
144912	1874	8879000
144913	1536	22320445000000
144960	1397	1263082443000
144961	1678	28800894657000
144962	2133	9310772000
144963	1874	8918000
144964	2134	12588639000
144965	1874	8922000
144966	1715	12263646663945
144977	1559	17586309499999
144978	1559	17586332499999
145061	1397	1262942429000
145062	1678	28800894671000
145063	1397	1262932428000
145064	1678	28800894672000
145065	2133	9296744000
145066	2134	12578599000
145067	1874	8994000
145068	2133	9295742000
145069	1768	29267293110000
145070	1768	29267316110000
145110	55	68160059000000
145115	1397	1262852420000
145116	1678	28800894680000
145117	2134	12572575000
145118	2132	7127141000
145119	2133	9288728000
145120	1688	50471477113019
145121	1688	50471490113019
145151	1397	1262802415000
145152	1678	28800894685000
145153	2133	9283718000
145154	2134	12568559000
145155	1394	1095856513440200
145167	2106	6480249000000
145177	1397	1262762411000
145178	1678	28800894689000
145179	2133	9279710000
145180	2134	12565547000
145181	1688	51191502113019
145213	1716	4320104000000
145214	1716	4320140000000
145215	1693	12286008623117
145229	1747	7986081999992
145230	1747	7986094999992
145236	1397	1262672402000
145237	1678	28800894698000
145238	2134	12559523000
145239	2133	9270692000
145240	1601	11186066620000
145255	1633	11568736625277
145256	1633	12288736625277
145257	1633	12288737625277
145283	1877	1439010000000
145284	1877	1439022000000
145286	1397	1262622397000
145287	1678	28800894703000
145288	2132	7120134000
145289	2133	9265682000
145290	2134	12555507000
145291	1394	1098736538440200
145293	1397	1262612396000
145294	1678	28800894704000
145295	2133	9264680000
145296	1476	20160463000000
145297	1476	20160474000000
145329	1724	18412975500000
145346	1397	1262542389000
145347	1678	28800894711000
145348	2133	9257666000
145349	1394	1098736536440200
145370	1395	58342953636457278
145371	1395	58342953673457278
145377	1395	58343673673457278
145378	1395	58343673684457278
145395	1397	1262492384000
145396	1678	28800894716000
145397	2133	9252656000
145398	1874	9219000
145399	2132	7116130000
145400	1874	9220000
145401	2134	12546471000
145402	576	84077786726897
145403	576	84077799726897
145423	1397	1262452380000
145424	1678	28800894720000
145425	2134	12543459000
145426	1874	9242000
145427	2133	9248648000
145428	2132	7115129000
145429	1874	9245000
145430	2106	6480238000000
145451	1397	1262412376000
145452	1678	28800894724000
145453	1397	1262402375000
145454	1678	28800894725000
145455	1397	1262392374000
145456	1678	28800894726000
145457	2134	12540447000
145458	2133	9244640000
145459	1874	9266000
145460	2133	9243638000
145461	1874	9268000
145462	2133	9242636000
145463	2134	12539443000
145464	1874	9274000
145465	1684	34563626819412
145466	1684	34563661819412
145467	1564	14046871000000
145468	1564	14046906000000
145485	1397	1262382373000
145486	1678	28800894727000
145487	2134	12538439000
145488	1394	1098736547440200
145489	2133	9241634000
145490	1874	9280000
145491	2132	7113127000
145492	1394	1100176549440200
145493	1397	1262372372000
145494	1678	28800894728000
145495	1397	1262362371000
145496	1678	28800894729000
145497	2133	9240632000
145498	2133	9239630000
145499	2134	12537435000
145500	1394	1101616549440200
145501	1394	1101616572440200
145540	1397	1262312366000
145541	1678	28800894734000
145542	1397	1262302365000
145543	1678	28800894735000
145544	1397	1262292364000
145545	1678	28800894736000
145546	1397	1262282363000
145547	1678	28800894737000
145548	2133	9234620000
145549	2133	9233618000
145550	2133	9232616000
145551	1874	9317000
145552	2132	7110124000
145553	2133	9231614000
145554	2134	12533419000
145555	1874	9324000
145556	2134	12532415000
145557	2134	12531411000
145558	1874	9332000
145559	1633	12288725625277
145560	1633	12288773625277
145591	1397	1262232358000
145592	1678	28800894742000
145593	1397	1262222357000
145594	1678	28800894743000
145595	1397	1262212356000
145596	1678	28800894744000
145597	2133	9226604000
145598	2132	7108122000
145599	1874	9356000
145600	2133	9225602000
145601	2133	9224600000
145602	1874	9360000
145603	2134	12527395000
145604	1874	9364000
145605	2134	12526391000
145606	2134	12525387000
145607	1633	13008773625277
145608	1633	13008810625277
145616	1397	1262192354000
145617	1678	28800894746000
145618	1397	1262182353000
145619	1678	28800894747000
145620	2132	7107121000
145621	2133	9222596000
145622	1874	9377000
145623	2133	9221594000
145624	2134	12524383000
145625	1874	9383000
145626	2134	12523379000
145627	1874	9387000
145628	632	83997789000000
145646	369	83796705290830
145647	369	83796729290830
145657	1715	12983646663945
145658	1715	12983658663945
145678	1397	1262102345000
145081	2132	7129143000
145082	1522	15163891000000
145095	1397	1262882423000
145096	1678	28800894677000
145097	2134	12574583000
145098	2133	9291734000
145099	1705	32241140580140
145100	1705	32241152580140
145109	1679	23038569656999
145124	1397	1262842419000
145125	1678	28800894681000
145126	2133	9287726000
145127	2134	12571571000
145128	1874	9043000
145129	1489	16943314040000
145156	1397	1262792414000
145157	1678	28800894686000
145158	1397	1262782413000
145159	1678	28800894687000
145160	2134	12567555000
145161	2132	7125139000
145162	1874	9069000
145163	2133	9282716000
145164	2133	9281714000
145165	1874	9073000
145166	1448	13639937000001
145176	2086	5040427300069
145183	1397	1262752410000
145184	1678	28800894690000
145185	1397	1262742409000
145186	1678	28800894691000
145187	2133	9278708000
145188	2133	9277706000
145189	2134	12564543000
145190	2132	7124138000
145191	1402	62824099812105
145192	1402	62824123812105
145194	1397	1262732408000
145195	1678	28800894692000
145196	2134	12563539000
145197	2133	9276704000
145198	1394	1098736525440200
145199	1394	1098736537440200
145212	1394	1098736561440200
145218	369	83076705290830
145227	1402	63544123812105
145228	1402	63544136812105
145241	1397	1262662401000
145242	1678	28800894699000
145243	2148	13680411880750
145249	1593	18672880000000
145250	1593	19392880000000
145251	1593	19392881000000
145268	1444	16747953329999
145320	1692	22061136819983
145321	1692	22061169819983
145337	1654	23897744999798
145338	1654	23897757999798
145350	1679	23758569656999
145351	1679	23758580656999
145412	1397	1262472382000
145413	1678	28800894718000
145414	1397	1262462381000
145415	1678	28800894719000
145416	2134	12544463000
145417	1874	9234000
145418	2133	9250652000
145419	2133	9249650000
145420	1874	9238000
145421	1599	22617156097983
145422	1599	22617179097983
145472	1874	8862000
145473	1874	8864000
145474	1874	8865000
145475	1874	8891000
145476	1874	8892000
145477	1874	8895000
145478	1874	8897000
145479	1874	8906000
145480	1684	33844597819412
145481	1874	8912000
145482	1874	8924000
145483	1684	34564597819412
145484	1684	34564606819412
145511	1419	29806335559748
145512	1395	58344393684457278
145513	1395	58344393697457278
145532	1874	8475000
145533	1874	8488000
145534	1874	8490000
145535	1874	8501000
145536	1874	8508000
145537	1874	8520000
145538	132	66721000000000
145539	132	66721369000000
145573	1397	1262252360000
145574	1678	28800894740000
145575	1397	1262242359000
145576	1678	28800894741000
145577	2134	12530407000
145578	1874	9340000
145579	2134	12529403000
145580	1874	9344000
145581	2134	12528399000
145582	1874	9348000
145583	2132	7109123000
145584	1874	9349000
145585	2133	9228608000
145586	1874	9351000
145587	2133	9227606000
145588	42	79340796000000
145589	42	79340822000000
145609	1397	1262202355000
145610	1678	28800894745000
145611	2133	9223598000
145612	1874	9374000
145613	43	83280295890000
145614	43	83280306890000
145648	1397	1262142349000
145649	1678	28800894751000
145650	2133	9218588000
145651	2134	12520367000
145652	1874	9406000
145653	1686	21272224700123
145654	1686	21272236700123
145676	1601	11906066620000
145677	1601	11906102620000
145700	1397	1262072342000
145701	1678	28800894758000
145702	1397	1262062341000
145703	1678	28800894759000
145704	2134	12515347000
145705	1874	9440000
145706	2134	12514343000
145707	1874	9444000
145708	2133	9211574000
145709	1874	9446000
145710	2133	9210572000
145711	1622	11124073800048
145712	1622	11124097800048
145723	1397	1262032338000
145724	1678	28800894762000
145725	2133	9207566000
145726	1874	9458000
145727	2134	12512335000
145728	1622	11844097800048
145729	1622	11844109800048
145755	1397	1261982333000
145756	1678	28800894767000
145757	2133	9202556000
145758	1671	21264385003785
145761	1740	20611494000000
145762	1740	21331494000000
145763	1740	21331506999998
145764	1449	8053016461
145808	1546	16077641800000
145810	1668	19953915500000
145811	1668	19953950500000
145812	1397	1261942329000
145813	1678	28800894771000
145814	2133	9196544000
145815	1874	9512000
145816	2134	12504303000
145817	1402	64984148812105
145818	1402	64984160812105
145828	1397	1261922327000
145829	1678	28800894773000
145830	2133	9194540000
145831	149	83375523000341
145838	1474	27170701000043
145839	1474	27170713000043
145848	1395	58346553745457278
145849	1395	58346553757457278
145856	1874	9488000
145857	1874	9492000
145858	1874	9514000
145859	1874	9534000
145860	1576	720216000000
145872	1688	51911513113019
145873	1688	51911537113019
145875	1397	1261862321000
145876	1678	28800894779000
145877	2133	9188528000
145878	1874	9552000
145879	2134	12498279000
145300	2133	9263678000
145301	2134	12554503000
145302	1874	9166000
145311	1397	1262582393000
145312	1678	28800894707000
145313	835	3199985394837430
145314	1397	1262572392000
145315	1678	28800894708000
145316	2133	9261674000
145317	2133	9260672000
145318	2134	12552495000
145319	1724	18412996500000
145322	1397	1262562391000
145323	1678	28800894709000
145324	2134	12551491000
145325	2133	9259670000
145326	1874	9187000
145327	1522	15883891000000
145328	1522	15883903000000
145330	1397	1262552390000
145331	1678	28800894710000
145332	2134	12550487000
145333	1874	9191000
145334	2132	7118132000
145335	2133	9258668000
145336	606	80446964286230
145352	1397	1262532388000
145353	1678	28800894712000
145354	1397	1262522387000
145355	1678	28800894713000
145356	1397	1262512386000
145357	1678	28800894714000
145358	2133	9256664000
145359	1874	9198000
145360	2133	9255662000
145361	1874	9200000
145362	2133	9254660000
145363	1874	9202000
145364	2134	12549483000
145365	2134	12548479000
145366	2134	12547475000
145367	1874	9214000
145368	2132	7117131000
145369	1700	16794429979053
145372	1397	1262502385000
145373	1678	28800894715000
145374	2133	9253658000
145375	1394	1100176536440200
145376	1394	1100176547440200
145379	1874	8919000
145380	1611	4314271402899
145381	1874	8927000
145382	1874	8951000
145383	1874	8955000
145384	1874	8984000
145385	1874	8985000
145386	1874	8991000
145387	1874	8997000
145388	1874	9017000
145389	1874	9021000
145390	1874	9025000
145391	1874	9033000
145392	1874	9061000
145393	1611	5034271402899
145394	1611	5034323402899
145410	1419	29806322559748
145411	1419	29806334559748
145431	1448	14359937000001
145432	1448	14359950000001
145439	1397	1262432378000
145440	1678	28800894722000
145441	1397	1262422377000
145442	1678	28800894723000
145443	2132	7114128000
145444	2133	9246644000
145445	1874	9254000
145446	2133	9245642000
145447	1874	9256000
145448	2134	12541451000
145449	2329	339127029819988
145450	2329	339127053819988
145470	1687	13089065648287
145471	1687	13089100648287
145514	1397	1262342369000
145515	1678	28800894731000
145516	2133	9237626000
145517	1874	9298000
145518	2134	12535427000
145519	1394	1103056572440200
145520	1394	1103056584440200
145561	1455	8673132000000
145562	1455	9393132000000
145563	1455	9393352000000
145564	1397	1262272362000
145565	1678	28800894738000
145566	1397	1262262361000
145567	1678	28800894739000
145568	2133	9230612000
145569	1874	9334000
145570	2133	9229610000
145571	1394	1104496584440200
145572	1394	1104496606440200
145633	1397	1262162351000
145634	1678	28800894749000
145635	1397	1262152350000
145636	1678	28800894750000
145637	2133	9219590000
145638	2132	7106120000
145639	1874	9392000
145640	2134	12522375000
145641	1874	9396000
145642	2134	12521371000
145643	1874	9400000
145644	1610	18720451999950
145645	1610	18720475999950
145655	1402	64264136812105
145656	1402	64264148812105
145659	1397	1262132348000
145660	1678	28800894752000
145661	1397	1262122347000
145662	1678	28800894753000
145663	1397	1262112346000
145664	1678	28800894754000
145665	2133	9217586000
145666	2133	9216584000
145667	2132	7105119000
145668	1874	9411000
145669	2134	12519363000
145670	2134	12518359000
145671	1874	9419000
145672	2133	9215582000
145673	1874	9421000
145674	1395	58345113697457278
145675	1395	58345113733457278
145685	1397	1262092344000
145686	1678	28800894756000
145687	2133	9213578000
145688	1698	18789088550062
145689	1698	18789099550062
145699	1670	14401156000000
145730	1397	1262022337000
145731	1678	28800894763000
145732	2134	12511331000
145733	1874	9466000
145734	2133	9206564000
145753	1685	198004998571430
145754	1685	198005034571430
145772	1874	8639000
145773	1874	8643000
145774	1874	8647000
145775	1874	8667000
145776	1874	8675000
145777	1874	8679000
145778	1874	8685000
145779	1874	8689000
145780	1874	8705000
145781	1874	8723000
145782	1455	9393845000000
145783	1874	8762000
145784	1455	10113845000000
145785	1455	10113867000000
145791	1992	16561119990000
145803	2133	9199550000
145804	1874	9506000
145805	2133	9198548000
145806	2133	9197546000
145807	1546	16077644800000
145809	1546	16077639800000
145820	1397	1261932328000
145821	1678	28800894772000
145822	2134	12503299000
145823	1874	9520000
145824	2133	9195542000
145825	1874	9522000
145826	1395	58345833733457278
145827	1395	58345833745457278
145840	1397	1261902325000
145841	1678	28800894775000
145842	2133	9192536000
145843	1874	9532000
145844	2134	12501291000
145845	1874	9536000
145846	1668	19953927500000
145874	1679	23758593656999
145882	1397	1261852320000
145679	1678	28800894755000
145680	2133	9214580000
145681	2134	12517355000
145682	1874	9427000
145683	1698	18069076550062
145684	1698	18069088550062
145786	2134	12507315000
145787	2133	9200552000
145788	1874	9496000
145789	2086	5040417300069
145792	1508	20360551156616
145832	1397	1261912326000
145833	1678	28800894774000
145834	2134	12502295000
145835	1874	9528000
145836	2133	9193538000
145837	1700	16794404979053
145850	1576	720285000000
145900	1709	12240377999992
145909	1700	16794415979053
145921	1397	1261802315000
145922	1678	28800894785000
145923	1397	1261792314000
145924	1678	28800894786000
145925	1397	1261782313000
145926	1678	28800894787000
145927	2133	9182516000
145928	1874	9582000
145929	2133	9181514000
145930	2133	9180512000
145931	1874	9586000
145932	1592	66000000
145933	2134	12494263000
145934	1874	9590000
145935	2134	12493259000
145936	1874	9594000
145937	1592	720066000000
145938	1592	720068000000
146030	641	85444021500000
146036	2133	9174500000
146037	1397	1261712306000
146038	1678	28800894794000
146039	2132	7099113000
146040	1874	9629000
146041	1680	18013449499559
146043	1395	58347993770457278
146044	1395	58347993782457278
146050	1714	20445841171760
146080	1397	1261652300000
146081	1678	28800894800000
146082	1397	1261642299000
146083	1678	28800894801000
146084	2132	7097111000
146085	2133	9167486000
146086	1874	9661000
146087	2134	12483219000
146088	2133	9166484000
146089	470	80995396000000
146090	470	80995420000000
146103	1397	1261612296000
146104	1678	28800894804000
146105	2132	7096110000
146106	1874	9680000
146107	2133	9163478000
146108	2134	12480207000
146109	1874	9686000
146126	1397	1261582293000
146127	1678	28800894807000
146128	2133	9160472000
146129	2134	12478199000
146130	1688	52631525113019
146131	1688	52631537113019
146156	1698	19509099550062
146157	1698	19509112550062
146164	1397	1261522287000
146165	1678	28800894813000
146166	2133	9154460000
146167	2134	12474183000
146168	1874	9730000
146169	633	82989640900000
146182	1564	14766906000000
146183	1564	14766917000000
146190	171	78186810696494
146191	171	78186822696494
146205	1397	1261472282000
146206	1678	28800894818000
146207	1992	1107990000
146208	596	84178432000000
146209	1397	1261462281000
146210	1678	28800894819000
146211	2133	9148448000
146212	1723	16562200085979
146213	1723	16562231085979
146237	1397	1261412276000
146238	1678	28800894824000
146239	2132	7090104000
146240	2134	12466151000
146241	2133	9143438000
146242	1394	1111696703440200
146243	1394	1111696716440200
146246	1397	1261402275000
146247	1678	28800894825000
146248	1397	1261392274000
146249	1678	28800894826000
146250	2134	12465147000
146251	1874	9792000
146252	2134	12464143000
146253	2133	9142436000
146254	1874	9798000
146255	2133	9141434000
146256	303	67440026000000
146257	303	67440050000000
146261	1397	1261382273000
146262	1678	28800894827000
146263	1397	1261372272000
146264	1678	28800894828000
146265	1397	1261362271000
146266	1678	28800894829000
146267	1397	1261352270000
146268	1678	28800894830000
146269	2133	9140432000
146270	1874	9802000
146271	2132	7089103000
146272	2133	9139430000
146273	1874	9805000
146274	2133	9138428000
146275	1874	9807000
146276	2133	9137426000
146277	2134	12463139000
146278	2134	12462135000
146279	2134	12461131000
146280	1717	21421400000055
146281	1717	21421448000055
146284	1474	27890713000043
146285	1474	27890761000043
146297	1691	14111922300052
146298	1691	14831922300052
146299	1691	14832532300052
146309	149	84095523000341
146310	149	84095535000341
146311	1874	9674000
146312	1756	9921299195609
146313	1874	9742000
146314	1874	9748000
146315	1874	9804000
146316	1874	9808000
146317	1874	9822000
146318	1874	9826000
146319	1874	9832000
146320	1756	10641299195609
146321	1756	10641338195609
146354	1656	19435907499990
146384	1395	58352313890457278
146419	1397	1261192254000
146420	1678	28800894846000
146421	1397	1261182253000
146422	1678	28800894847000
146423	2133	9121394000
146424	2134	12449083000
146425	2133	9120392000
146426	1874	9908000
146427	1681	18574848358535
146430	2306	4319144000000
146462	1633	15168834625277
146463	1633	15168844625277
146487	1397	1261092244000
146488	1678	28800894856000
146489	2133	9112376000
146490	1394	1116016752440200
146491	1394	1116016763440200
146499	1555	18966323540449
146500	1555	18966335540449
146517	2134	12440047000
146518	1874	9970000
146519	1684	34563638819412
146549	2087	4755425147766
146550	2087	4755436147766
146584	1397	1260982233000
146585	1678	28800894867000
146586	1576	10000000
146587	605	66720000000000
146588	2133	9101354000
146589	1874	10008000
146590	1991	19341566355805
146645	1397	1260912226000
145714	1678	28800894760000
145715	1397	1262042339000
145716	1678	28800894761000
145717	2133	9209570000
145718	1874	9450000
145719	2133	9208568000
145720	2134	12513339000
145721	1874	9456000
145722	1688	51191513113019
145735	2112	30047092101924
145736	1397	1262012336000
145737	1678	28800894764000
145738	1397	1262002335000
145739	1678	28800894765000
145740	1397	1261992334000
145741	1678	28800894766000
145742	2134	12510327000
145743	1874	9472000
145744	2133	9205562000
145745	1874	9474000
145746	2134	12509323000
145747	2133	9204560000
145748	1874	9480000
145749	2133	9203558000
145750	1874	9482000
145751	1668	19233879500000
145752	1668	19233915500000
145759	58	83987686999641
145760	58	83987697999641
145765	1740	19891009000000
145766	2133	9201554000
145767	1874	9486000
145768	2134	12508319000
145769	1874	9490000
145770	1623	89283646898598
145771	1623	89283648898598
145790	2087	4035425147766
145793	1397	1261972332000
145794	1678	28800894768000
145795	1397	1261962331000
145796	1678	28800894769000
145797	1397	1261952330000
145798	1678	28800894770000
145799	2134	12506311000
145800	2134	12505307000
145801	1394	1105936606440200
145802	1394	1105936638440200
145819	171	77466810696494
145847	1992	16561129990000
145851	1397	1261892324000
145852	1678	28800894776000
145853	2133	9191534000
145854	1874	9538000
145855	1576	720011000000
145861	1397	1261882323000
145862	1678	28800894777000
145863	1397	1261872322000
145864	1678	28800894778000
145865	2134	12500287000
145866	2134	12499283000
145867	1874	9546000
145868	2133	9190532000
145869	2133	9189530000
145870	1671	21984385003785
145871	1671	21984409003785
145887	1397	1261842319000
145888	1678	28800894781000
145889	2133	9186524000
145890	1874	9560000
145891	2132	7103117000
145892	2134	12497275000
145893	1874	9565000
145894	1711	20587111000000
145895	1711	20587124000000
145898	1395	58347273757457278
145899	1395	58347273770457278
145910	1709	12240282000000
145911	1709	12240303000000
145939	606	80446997286230
145940	606	81166997286230
145941	606	81166999286230
145958	2292	3599091000000
145995	1397	1261762311000
145996	1678	28800894789000
145997	2134	12491251000
145998	1874	9605000
145999	2133	9178508000
146000	2330	1103000000
146001	1611	5032523402899
146002	1611	5032535402899
146013	1874	9609000
146021	1394	1105936619440200
146064	1395	58347993793457278
146073	1633	14448822625277
146074	1633	14448835625277
146110	1394	1108816631440200
146111	1394	1108816644440200
146116	1397	1261602295000
146117	1678	28800894805000
146118	2133	9162476000
146119	58	84707697999641
146120	58	84707708999641
146132	1690	187925872000000
146135	1397	1261572292000
146136	1678	28800894808000
146137	2133	9159470000
146138	2132	7095109000
146199	1633	14448834625277
146235	1679	23758617656999
146258	303	67440048000000
146286	1397	1261342269000
146287	1678	28800894831000
146288	1397	1261332268000
146289	1678	28800894832000
146290	2133	9136424000
146291	2132	7088102000
146292	2134	12460127000
146293	1874	9828000
146294	2133	9135422000
146295	1599	23337179097983
146296	1599	23337203097983
146307	2329	339847053819988
146308	2329	339847065819988
146350	1693	13005983623117
146351	1693	13005995623117
146357	1397	1261262261000
146358	1678	28800894839000
146359	2133	9128408000
146360	2134	12455107000
146361	1654	24617757999798
146362	1654	24617769999798
146379	1397	1261232258000
146380	1678	28800894842000
146381	2133	9125402000
146382	1874	9881000
146383	1394	1113136727440200
146385	1397	1261222257000
146386	1678	28800894843000
146387	1471	21545565900000
146388	2133	9124400000
146389	1874	9883000
146390	2134	12452095000
146391	1874	9887000
146392	1471	22265565900000
146393	1796	200000006
146394	1471	22265567899879
146395	45	66000000001420
146399	1633	13728832625277
146400	1633	14448832625277
146402	1397	1261212256000
146403	1678	28800894844000
146404	2132	7084098000
146405	1874	9888000
146406	2133	9123398000
146407	1874	9890000
146408	2134	12451091000
146409	1874	9894000
146410	1688	52631538113019
146428	2329	339847076819988
146431	1395	58352313902457278
146450	1397	1261142249000
146451	1678	28800894851000
146452	2133	9116384000
146453	2132	7082096000
146454	1874	9926000
146455	2134	12446071000
146456	1874	9930000
146457	2329	339847066819988
146459	1397	1261132248000
146460	1678	28800894852000
146461	2329	339847063819988
146464	1397	1261122247000
146465	1678	28800894853000
146466	2134	12445067000
146467	1874	9934000
146468	2133	9115382000
146469	1874	9936000
146470	606	81886997286229
146471	606	81887009286229
146493	1397	1261082243000
146494	1678	28800894857000
146495	2134	12442055000
146496	2133	9111374000
146497	1874	9957000
146498	1569	720859999991
145880	1619	12240317000000
145881	1619	12240329000000
145896	484	77613985000000
145897	484	77613998000000
145912	1397	1261812316000
145913	1678	28800894784000
145914	2133	9183518000
145915	1874	9575000
145916	2132	7102116000
145917	2134	12495267000
145918	1874	9580000
145919	1457	15840350800000
145920	1457	15840363800000
145943	1397	1261772312000
145944	1678	28800894788000
145945	2133	9179510000
145946	2132	7101115000
145947	1874	9589000
145948	1874	9593000
145949	1874	9597000
145950	2134	12492255000
145951	1746	7008995999989
146003	1613	17137518400000
146004	1613	17137530399972
146005	1807	200000055
146007	1397	1261752310000
146008	1678	28800894790000
146009	2134	12490247000
146010	1874	9611000
146011	2133	9177506000
146012	58	83987698999641
146014	1397	1261742309000
146015	1678	28800894791000
146016	2133	9176504000
146017	2132	7100114000
146018	1874	9612000
146019	1874	9616000
146020	1588	18420807000000
146022	1397	1261732308000
146023	1678	28800894792000
146024	2134	12489243000
146025	1874	9620000
146026	2133	9175502000
146027	1874	9622000
146028	1394	1107376619440200
146029	1394	1107376631440200
146031	1397	1261722307000
146032	1678	28800894793000
146033	2134	12488239000
146034	1874	9626000
146035	1471	21545554900000
146053	1397	1261692304000
146054	1678	28800894796000
146055	1397	1261682303000
146056	1678	28800894797000
146057	2134	12486231000
146058	2133	9171494000
146059	1874	9643000
146060	2133	9170492000
146061	1874	9645000
146062	1656	19435895499990
146063	1656	19435918499990
146065	1397	1261672302000
146066	1678	28800894798000
146067	2133	9169490000
146068	2134	12485227000
146069	2132	7098112000
146070	1874	9652000
146071	1395	58348713793457278
146072	1395	58348713806457278
146091	1397	1261632298000
146092	1678	28800894802000
146093	1397	1261622297000
146094	1678	28800894803000
146095	338	66010022000000
146096	2403	1428994500000
146097	2133	9165482000
146098	2133	9164480000
146099	2134	12482215000
146100	2134	12481211000
146101	1395	58349433806457278
146102	1395	58349433831457278
146114	1623	90003648898598
146115	1623	90003661898598
146121	1397	1261592294000
146122	1678	28800894806000
146123	2133	9161474000
146124	2134	12479203000
146125	1688	51911525113019
146139	1397	1261562291000
146140	1678	28800894809000
146141	1397	1261552290000
146142	1678	28800894810000
146143	2134	12477195000
146144	2134	12476191000
146145	2133	9158468000
146146	1874	9713000
146147	2133	9157466000
146148	1394	1108816655440200
146159	1397	1261532288000
146160	1678	28800894812000
146161	2133	9155462000
146162	1444	16747952329999
146170	1397	1261512286000
146171	1678	28800894814000
146172	2134	12473179000
146173	2133	9153458000
146174	1874	9736000
146175	2132	7093107000
146200	2134	12470167000
146201	2133	9149450000
146202	2132	7092106000
146203	1673	13895519000000
146204	1673	13895522000000
146236	1623	90003696898598
146244	1739	33839896000000
146245	1739	33839937000000
146259	1395	58351593855457278
146260	1395	58351593879457278
146322	1397	1261312266000
146323	1678	28800894834000
146324	1397	1261302265000
146325	1678	28800894835000
146326	2133	9133418000
146327	1874	9838000
146328	2132	7087101000
146329	2133	9132416000
146330	1874	9841000
146331	2134	12458119000
146332	1601	11906090620000
146345	1397	1261272262000
146346	1678	28800894838000
146347	2132	7086100000
146348	1874	9858000
146349	2133	9129410000
146363	1703	8640954000000
146364	1703	8640966000000
146396	1471	22265565899999
146397	1471	22265567899829
146398	45	66000000001470
146401	1471	22265567900000
146411	1397	1261202255000
146412	1678	28800894845000
146413	2133	9122396000
146414	1874	9896000
146415	2134	12450087000
146416	1874	9900000
146417	1700	18234440979053
146418	1700	18234452979053
146429	1440	7920285045924
146432	1397	1261172252000
146433	1678	28800894848000
146434	2133	9119390000
146435	1874	9910000
146436	2134	12448079000
146437	1874	9914000
146438	2132	7083097000
146472	1657	13681503990100
146473	1657	13681515990100
146492	1569	720847999991
146501	1397	1261072242000
146502	1678	28800894858000
146503	2134	12441051000
146504	1874	9961000
146505	2133	9110372000
146506	1874	9963000
146507	2132	7080094000
146508	1874	9964000
146509	470	81715420000000
146510	470	81715433000000
146523	1395	58353033892457278
146524	1395	58353033904457278
146541	1688	53351538113019
146542	1688	53351550113019
146545	1397	1261022237000
146546	1678	28800894863000
146547	2133	9105362000
146548	1874	9987000
146566	1397	1260992234000
146567	1678	28800894866000
146568	2133	9102356000
146569	1874	10002000
146570	1419	29805332559748
146571	2419	0
146572	1419	29804331559748
145883	1678	28800894780000
145884	2133	9187526000
145885	1593	20112881000000
145886	1593	20112892000000
145901	1397	1261832318000
145902	1678	28800894782000
145903	1397	1261822317000
145904	1678	28800894783000
145905	2133	9185522000
145906	2133	9184520000
145907	2134	12496271000
145908	1587	20880582000000
145942	606	81166997286229
145952	1807	200000011
145953	1747	7986081999991
145954	1604	3700000
145955	1747	7986096599975
145956	1807	200000027
145957	2252	200800000
145959	1874	9345000
145960	1874	9357000
145961	1874	9369000
145962	1874	9373000
145963	1874	9381000
145964	1874	9385000
145965	1874	9393000
145966	1874	9401000
145967	1874	9409000
145968	1874	9417000
145969	1513	37441820000000
145970	1874	9437000
145971	1874	9449000
145972	1874	9453000
145973	1874	9455000
145974	1874	9461000
145975	1874	9463000
145976	1874	9469000
145977	1874	9471000
145978	1874	9477000
145979	1874	9483000
145980	1874	9485000
145981	1874	9493000
145982	1874	9495000
145983	1874	9499000
145984	1874	9501000
145985	1874	9503000
145986	1874	9507000
145987	1874	9509000
145988	1874	9511000
145989	1874	9515000
145990	1874	9517000
145991	1874	9523000
145992	1874	9531000
145993	1513	38161820000000
145994	1513	38161862000000
146006	1613	17137530400000
146042	2133	9173498000
146045	1397	1261702305000
146046	1678	28800894795000
146047	2134	12487235000
146048	2133	9172496000
146049	1874	9637000
146051	1633	13728810625277
146052	1633	13728822625277
146075	1397	1261662301000
146076	1678	28800894799000
146077	2134	12484223000
146078	1874	9656000
146079	2133	9168488000
146112	1747	8706096599975
146113	1747	8706109599975
146133	1395	58350153831457278
146134	1395	58350153843457278
146149	1397	1261542289000
146150	1678	28800894811000
146151	2133	9156464000
146152	2132	7094108000
146153	2134	12475187000
146154	576	84797799726897
146155	576	84797812726897
146158	1698	19509111550062
146163	1685	198005009571430
146176	1397	1261502285000
146177	1678	28800894815000
146178	2133	9152456000
146179	1874	9739000
146180	2134	12472175000
146181	1547	15835011000000
146184	1397	1261492284000
146185	1678	28800894816000
146186	2133	9151454000
146187	1874	9745000
146188	1476	20880474000000
146189	1476	20880486000000
146192	1397	1261482283000
146193	1678	28800894817000
146194	2133	9150452000
146195	2134	12471171000
146196	1874	9751000
146197	1395	58350873843457278
146198	1395	58350873855457278
146214	1397	1261452280000
146215	1678	28800894820000
146216	1397	1261442279000
146217	1678	28800894821000
146218	1397	1261432278000
146219	1678	28800894822000
146220	1397	1261422277000
146221	1678	28800894823000
146222	2134	12469163000
146223	2134	12468159000
146224	2134	12467155000
146225	1874	9772000
146226	2133	9147446000
146227	2133	9146444000
146228	2133	9145442000
146229	1874	9778000
146230	2133	9144440000
146231	2132	7091105000
146232	1874	9781000
146233	1394	1110256655440200
146234	1394	1110256703440200
146282	1455	10833867000000
146283	1455	10834067000000
146300	1397	1261322267000
146301	1678	28800894833000
146302	2134	12459123000
146303	1874	9834000
146304	2133	9134420000
146305	1394	1113136716440200
146306	1394	1113136728440200
146333	1397	1261292264000
146334	1678	28800894836000
146335	1397	1261282263000
146336	1678	28800894837000
146337	1726	120825112000
146338	2418	100000000
146339	2133	9131414000
146340	2134	12457115000
146341	2134	12456111000
146342	1874	9855000
146343	2133	9130412000
146344	1679	23758594656999
146352	1672	18001617000000
146353	1672	18001629000000
146355	1395	58352313879457278
146356	1395	58352313891457278
146365	1397	1261252260000
146366	1678	28800894840000
146367	1397	1261242259000
146368	1678	28800894841000
146369	2132	7085099000
146370	1874	9867000
146371	2134	12454103000
146372	1874	9871000
146373	2134	12453099000
146374	2133	9127406000
146375	1874	9877000
146376	2133	9126404000
146377	1700	17514415979053
146378	1700	17514440979053
146439	1397	1261162251000
146440	1678	28800894849000
146441	1397	1261152250000
146442	1678	28800894850000
146443	2133	9118388000
146444	1874	9917000
146445	2133	9117386000
146446	2134	12447075000
146447	1874	9923000
146448	1708	19080758181790
146449	1708	19080781181790
146458	1395	58352313892457278
146474	1397	1261112246000
146475	1678	28800894854000
146476	1397	1261102245000
146477	1678	28800894855000
146478	2133	9114380000
146479	2132	7081095000
146480	2133	9113378000
146481	1874	9941000
146482	2134	12444063000
146483	2134	12443059000
146484	1874	9949000
146485	1394	1114576727440200
146486	1394	1114576752440200
146511	1397	1261062241000
146512	1678	28800894859000
146513	2133	9109370000
146514	1874	9966000
146515	1394	1117456763440200
146516	1394	1117456774440200
146520	1397	1261052240000
146521	1678	28800894860000
146522	2133	9108368000
146534	1397	1261032238000
146535	1678	28800894862000
146536	2134	12438039000
146537	1874	9983000
146538	2133	9106364000
146539	1622	12564109800048
146540	1622	12564121800048
146543	1395	58353753904457278
146544	1395	58353753916457278
146603	1426	19770528000000
146604	1426	19770541000000
146628	1706	24762434450256
146637	1397	1260922227000
146638	1678	28800894873000
146639	2134	12430007000
146640	1874	10040000
146641	2133	9095342000
146642	1874	10042000
146643	1394	1120336787440200
146644	1394	1120336799440200
146659	1688	55511587113019
146660	1688	55511611113019
146661	1397	1260892224000
146662	1678	28800894876000
146663	2133	9092336000
146664	1874	10053000
146665	2134	12427999000
146673	1701	19438542500103
146674	1701	19438554500103
146708	1397	1260822217000
146709	1678	28800894883000
146710	2133	9085322000
146711	1874	10089000
146712	2134	12422979000
146713	1619	12960329000000
146714	1619	12960341000000
146717	1397	1260812216000
146718	1678	28800894884000
146719	2133	9084320000
146720	1874	10095000
146721	2132	7072086000
146722	2134	12421975000
146726	1397	1260802215000
146727	1678	28800894885000
146728	2133	9083318000
146729	1874	10102000
146730	1706	24762432450256
146749	1397	1260772212000
146750	1678	28800894888000
146751	2132	7071085000
146752	1874	10115000
146753	2133	9080312000
146754	1670	15121156000000
146755	1670	15121168000000
146763	1397	1260752210000
146764	1678	28800894890000
146765	2133	9078308000
146766	1874	10125000
146767	2134	12417959000
146768	1619	13680341000000
146769	1619	13680353000000
146824	1419	30524367559748
146826	1397	1260652200000
146827	1678	28800894900000
146828	2134	12410931000
146829	2133	9069290000
146830	2329	340567065819988
146831	2329	340567077819988
146843	1397	1260622197000
146844	1678	28800894903000
146845	2133	9066284000
146846	2134	12408923000
146886	1397	1260552190000
146887	1678	28800894910000
146888	2132	7064078000
146889	1874	10230000
146890	2133	9058268000
146891	2134	12402899000
146892	2329	341287077819988
146893	2329	341287090819988
146919	1679	25198607656999
146920	1679	25198618656999
146930	1402	65704174812105
146947	1397	1260492184000
146948	1678	28800894916000
146949	1397	1260482183000
146950	1678	28800894917000
146951	2133	9052256000
146952	2133	9051254000
146953	2134	12397879000
146954	2132	7062076000
146955	1439	15103897578477
146956	1439	15103921578477
146965	1397	1260462181000
146966	1678	28800894919000
146967	2133	9049250000
146968	1419	31244367559748
146969	1419	31244378559748
146971	1397	1260452180000
146972	1678	28800894920000
146973	2134	12395871000
146974	2132	7061075000
146975	1874	10285000
146976	2133	9048248000
146977	1719	21598809000000
146979	1692	22781169819983
146980	1692	22781192819983
147040	1991	20060566355805
147041	1991	20060703355805
147060	612	66543000726895
147061	2423	500000000
147062	1397	1260332168000
147063	1678	28800894932000
147064	2134	12386835000
147065	2133	9037226000
147066	1457	16560363800000
147067	1457	16560385800000
147070	1395	58355913953457278
147071	1395	58355913975457278
147123	1397	1260272162000
147124	1678	28800894938000
147125	126	66000892250000
147126	1776	2133002366625
147127	2133	9031214000
147128	2134	12382819000
147129	1874	10378000
147130	1710	17514139414140
147155	1397	1260232158000
147156	1678	28800894942000
147157	1397	1260222157000
147158	1678	28800894943000
147159	1397	1260212156000
147160	1678	28800894944000
147161	1397	1260202155000
147162	1678	28800894945000
147163	2134	12379807000
147164	2134	12378803000
147165	2134	12377799000
147166	1726	119724112000
147167	2424	100000000
147168	1726	118623112000
147169	2425	100000000
147170	2133	9027206000
147171	1874	10407000
147172	2133	9026204000
147173	1874	10409000
147174	2133	9025202000
147175	2133	9024200000
147176	1874	10413000
147177	2132	7054068000
147178	1447	24041967683000
147179	1447	24042017683000
147181	1395	58356633975457278
147182	1395	58356634025457278
147189	1764	19523598100000
147190	1764	19523609100000
147193	1539	719914000000
147194	363	67439950000000
147195	1397	1260182153000
147196	1678	28800894947000
147197	2134	12376795000
147198	1874	10420000
147199	2133	9022196000
147200	1874	10422000
147201	2132	7053067000
147202	1698	19509312550062
147227	1397	1260132148000
147228	1678	28800894952000
147229	2134	12372779000
147230	1696	23483894335104
147254	1397	1260092144000
147255	1678	28800894956000
147256	2133	9013178000
147257	1874	10467000
147258	1680	19452463499559
146525	1397	1261042239000
146526	1678	28800894861000
146527	2132	7079093000
146528	1874	9973000
146529	2133	9107366000
146530	2134	12439043000
146531	1874	9979000
146532	519	68161928000000
146533	519	68161941000000
146551	1397	1261012236000
146552	1678	28800894864000
146553	1397	1261002235000
146554	1678	28800894865000
146555	2134	12437035000
146556	2133	9104360000
146557	1874	9993000
146558	2133	9103358000
146559	1874	9995000
146560	2134	12436031000
146561	1874	9999000
146562	2132	7078092000
146563	1874	10000000
146564	1688	54071550113019
146565	1688	54071575113019
146578	1691	14833172300052
146579	1419	29085321559748
146580	1419	29084320559748
146581	1874	8964000
146582	1691	15553172300052
146583	1691	15553467300052
146593	1397	1260972232000
146594	1678	28800894868000
146595	2132	7077091000
146596	1874	10009000
146597	2134	12434023000
146598	1874	10013000
146599	2133	9100352000
146600	1874	10015000
146601	1394	1118896774440200
146602	1394	1118896787440200
146619	1397	1260942229000
146620	1678	28800894871000
146621	2133	9097346000
146622	1874	10025000
146623	2134	12432015000
146624	1874	10029000
146625	2132	7076090000
146626	1874	10030000
146627	1679	24478607656999
146629	1397	1260932228000
146630	1678	28800894872000
146631	2133	9096344000
146632	1874	10032000
146633	2134	12431011000
146634	1874	10036000
146635	1688	54791575113019
146636	1688	54791587113019
146657	1394	1121776799440200
146658	1394	1121776823440200
146695	1397	1260842219000
146696	1678	28800894881000
146697	1397	1260832218000
146698	1678	28800894882000
146699	2132	7073087000
146700	1874	10079000
146701	2133	9087326000
146702	1874	10081000
146703	2133	9086324000
146704	2134	12423983000
146705	1425	2257436000000
146706	1425	2257460000000
146723	2106	7200238000000
146724	2106	7200251000000
146725	1714	20445854171760
146742	1397	1260782213000
146743	1678	28800894887000
146744	2134	12419967000
146745	1874	10112000
146746	2133	9081314000
146747	1693	14446007623117
146748	1693	14446019623117
146761	1451	10507848000000
146762	1451	10507860000000
146770	1397	1260742209000
146771	1678	28800894891000
146772	2132	7070084000
146773	2133	9077306000
146774	1874	10132000
146775	1402	65704172812105
146776	1593	20832892000000
146777	1593	20832904000000
146785	1693	15166019623117
146786	1693	15166031623117
146787	1397	1260722207000
146788	1678	28800894893000
146789	2134	12415951000
146790	2133	9075302000
146791	1874	10144000
146792	1395	58354473928457278
146793	1395	58354473940457278
146794	1397	1260712206000
146795	1678	28800894894000
146796	2134	12414947000
146797	1874	10148000
146798	2132	7069083000
146799	1522	16603903000000
146800	1522	16603915000000
146810	1397	1260682203000
146811	1678	28800894897000
146812	1397	1260672202000
146813	1678	28800894898000
146814	1397	1260662201000
146815	1678	28800894899000
146816	2133	9072296000
146817	2133	9071294000
146818	2132	7068082000
146819	2133	9070292000
146820	2134	12412939000
146821	2134	12411935000
146822	1394	1124656835440200
146823	1394	1124656871440200
146825	1419	30524367559747
146849	1397	1260612196000
146850	1678	28800894904000
146851	1397	1260602195000
146852	1678	28800894905000
146853	2132	7066080000
146854	2133	9065282000
146855	2133	9064280000
146856	2134	12407919000
146857	2134	12406915000
146858	1688	56231587113019
146859	1688	56231612113019
146902	1874	9840000
146903	1680	18012449499559
146904	1756	10642126195609
146905	1874	9844000
146906	1874	9861000
146907	1874	9864000
146908	1874	9868000
146909	1874	9870000
146910	1874	9873000
146911	1874	9874000
146912	1874	9878000
146913	1756	11362126195609
146914	1756	11362165195609
146937	1397	1260502185000
146938	1678	28800894915000
146939	2134	12398883000
146940	1874	10261000
146941	2133	9053258000
146942	1440	7920274045924
146945	632	84717789000000
146946	632	84717801000000
146995	1622	12564122800048
147049	1397	1260352170000
147050	1678	28800894930000
147051	2132	7058072000
147052	1874	10336000
147101	1692	23501192819983
147102	1692	23501212569983
147110	1394	1128976892440200
147111	1394	1128976904440200
147183	1397	1260192154000
147184	1678	28800894946000
147185	2133	9023198000
147186	1874	10416000
147187	42	80060822000000
147188	42	80060833000000
147191	171	78906822696494
147192	171	78906833696494
147210	1397	1260162151000
147211	1678	28800894949000
147212	1397	1260152150000
147213	1678	28800894950000
147214	1397	1260142149000
147215	1678	28800894951000
147216	2134	12374787000
147217	2132	7052066000
147218	1874	10434000
147219	2133	9020192000
147220	2133	9019190000
147221	2133	9018188000
147222	1874	10440000
147223	2134	12373783000
146573	2420	0
146574	2134	12435027000
146575	1874	10006000
146576	1680	18733450499559
146577	1680	18733464499559
146591	1679	24478594656999
146592	1679	24478606656999
146605	1397	1260962231000
146606	1678	28800894869000
146607	1397	1260952230000
146608	1678	28800894870000
146609	1659	94999990
146610	548	67440000000000
146611	2112	30047113101924
146612	2133	9099350000
146613	2133	9098348000
146614	1874	10019000
146615	2134	12433019000
146616	1874	10023000
146617	2112	30767113101924
146618	2112	30767116101924
146666	1397	1260882223000
146667	1678	28800894877000
146668	2134	12426995000
146669	2133	9091334000
146670	1874	10063000
146671	1394	1123216823440200
146672	1394	1123216835440200
146675	1397	1260872222000
146676	1678	28800894878000
146677	2133	9090332000
146678	1874	10065000
146679	2132	7074088000
146680	1874	10066000
146693	1419	30524331559748
146694	1419	30524355559748
146707	1395	58353753928457278
146731	1594	19441978000000
146732	1397	1260792214000
146733	1678	28800894886000
146734	2133	9082316000
146735	1874	10104000
146736	2134	12420971000
146737	1874	10108000
146738	1723	17282231085979
146739	1723	17282243085979
146832	1397	1260642199000
146833	1678	28800894901000
146834	2133	9068288000
146835	2134	12409927000
146836	2132	7067081000
146837	1668	20673927500000
146838	1668	20673940500000
146847	1749	2162609529980
146848	1749	2162621529980
146860	1397	1260592194000
146861	1678	28800894906000
146862	2133	9063278000
146863	484	78333998000000
146864	484	78334009000000
146883	1684	35283638819412
146884	1684	35283677819412
146915	1397	1260532188000
146916	1678	28800894912000
146917	2133	9056264000
146918	1693	15166030623117
146921	1397	1260522187000
146922	1678	28800894913000
146923	2132	7063077000
146924	2133	9055262000
146925	599	67439023000000
146926	613	66001000000000
146927	2134	12400891000
146928	1678	29520894913000
146929	1678	29520908913000
146970	1419	31244368559748
146978	1719	21598909000000
146981	1397	1260442179000
146982	1678	28800894921000
146983	2134	12394867000
146984	1874	10291000
146985	2133	9047246000
146986	2329	342007090819988
146987	2329	342007102819988
146996	1397	1260422177000
146997	1678	28800894923000
146998	1690	187925882000000
146999	1397	1260412176000
147000	1678	28800894924000
147001	1397	1260402175000
147002	1678	28800894925000
147003	2134	12392859000
147004	1874	10303000
147005	2132	7060074000
147006	2134	12391855000
147007	2133	9045242000
147008	2133	9044240000
147009	1874	10312000
147010	2133	9043238000
147011	1690	188645882000000
147012	1690	188645908000000
147021	1684	34563738819412
147022	1397	1260392174000
147023	1678	28800894926000
147024	1397	1260382173000
147025	1678	28800894927000
147026	1397	1260372172000
147027	1678	28800894928000
147028	2132	7059073000
147029	1874	10315000
147030	2134	12390851000
147031	2134	12389847000
147032	2133	9042236000
147033	2005	0
147034	2422	399000000
147035	2133	9041234000
147036	1874	10327000
147037	2133	9040232000
147038	1991	20061566355805
147039	1991	20061703355805
147042	1397	1260362171000
147043	1678	28800894929000
147044	2134	12388843000
147045	2133	9039230000
147046	1684	35283738819412
147047	1684	35283750819412
147053	1747	9426109599975
147054	1747	9426122599975
147083	612	66542450726895
147084	2423	1020000000
147085	1397	1260312166000
147086	1678	28800894934000
147087	1776	2133910116625
147088	126	66001000000000
147089	2134	12385831000
147090	2133	9035222000
147091	1874	10357000
147092	2301	1439029750000
147112	1708	19800781181790
147113	1708	19800793181790
147114	1522	17323915000000
147115	1522	17323927000000
147140	1397	1260252160000
147141	1678	28800894940000
147142	2132	7055069000
147143	2133	9029210000
147144	1874	10387000
147145	1673	14615522000000
147146	1673	14615534000000
147203	1397	1260172152000
147204	1678	28800894948000
147205	2134	12375791000
147206	2133	9021194000
147207	1874	10429000
147208	1673	15335534000000
147209	1673	15335546000000
147268	1397	1260072142000
147269	1678	28800894958000
147270	2133	9011174000
147271	1874	10476000
147272	2134	12368763000
147273	1690	188645872000000
147274	1690	188645884000000
147288	1596	11520370500002
147290	610	68880085500000
147305	345	66000940000000
147306	2402	48039000000
147307	1397	1260022137000
147308	1678	28800894963000
147309	2039	21498862000000
147310	1445	1725181000000
147311	1397	1260012136000
147312	1678	28800894964000
147313	2133	9006164000
147314	1874	10503000
147315	2132	7048062000
147316	2133	9005162000
147317	2134	12364747000
147318	1680	20172474499559
147319	1680	20172518499559
147322	1397	1260002135000
147323	1678	28800894965000
147324	532	66009037000000
147325	1724	18413975500000
147326	2133	9004160000
146646	1678	28800894874000
146647	1397	1260902225000
146648	1678	28800894875000
146649	2134	12429003000
146650	1874	10046000
146651	2133	9094340000
146652	1874	10048000
146653	2133	9093338000
146654	2132	7075089000
146655	1402	65704160812105
146656	1402	65704184812105
146681	1397	1260862221000
146682	1678	28800894879000
146683	1397	1260852220000
146684	1678	28800894880000
146685	2134	12425991000
146686	2134	12424987000
146687	2133	9089330000
146688	1874	10076000
146689	2133	9088328000
146690	1874	10078000
146691	1509	20543510503835
146692	1509	20543534503835
146715	1573	10659459000000
146716	1573	10659471000000
146740	1693	13725995623117
146741	1693	13726007623117
146756	1397	1260762211000
146757	1678	28800894889000
146758	2133	9079310000
146759	1874	10119000
146760	2134	12418963000
146778	1397	1260732208000
146779	1678	28800894892000
146780	2134	12416955000
146781	2133	9076304000
146782	1874	10138000
146783	1717	22141448000055
146784	1717	22141460000055
146801	1397	1260702205000
146802	1678	28800894895000
146803	1397	1260692204000
146804	1678	28800894896000
146805	2133	9074300000
146806	1874	10151000
146807	2134	12413943000
146808	2133	9073298000
146809	1610	18720474999950
146839	1397	1260632198000
146840	1678	28800894902000
146841	2133	9067286000
146842	1439	14383897578477
146865	1397	1260582193000
146866	1678	28800894907000
146867	1397	1260572192000
146868	1678	28800894908000
146869	1397	1260562191000
146870	1678	28800894909000
146871	2132	7065079000
146872	2134	12405911000
146873	1680	18732463499559
146874	80	66001000000000
146875	2133	9062276000
146876	2133	9061274000
146877	2133	9060272000
146878	2133	9059270000
146879	2134	12404907000
146880	2134	12403903000
146881	1705	32961152580140
146882	1705	32961191580140
146885	1684	35283673819412
146894	1397	1260542189000
146895	1678	28800894911000
146896	80	66000499000000
146897	1993	2816848532446
146898	2134	12401895000
146899	1874	10240000
146900	2133	9057266000
146901	1394	1124656848440200
146931	1397	1260512186000
146932	1678	28800894914000
146933	2134	12399887000
146934	2133	9054260000
146935	1394	1126096848440200
146936	1394	1126096860440200
146943	2306	5039144000000
146944	2306	5039156000000
146957	1397	1260472182000
146958	1678	28800894918000
146959	2134	12396875000
146960	584	66209425788612
146961	2421	334083938283
146962	2133	9050252000
146963	1395	58355193940457278
146964	1395	58355193953457278
146988	1397	1260432178000
146989	1678	28800894922000
146990	2133	9046244000
146991	584	66000000000000
146992	2421	543508726895
146993	2134	12393863000
146994	1587	20880572000000
147013	606	81887019286229
147014	606	82607019286229
147015	606	82607045286229
147016	511	66544310726895
147017	1684	33843726819412
147018	1680	17292437499559
147019	1739	34559937000000
147020	1739	34560045000000
147048	1684	35283748819412
147055	1397	1260342169000
147056	1678	28800894931000
147057	2134	12387839000
147058	2133	9038228000
147059	1874	10342000
147068	1593	21552904000000
147069	1593	21552926000000
147072	612	66542980726895
147073	2423	510000000
147074	1397	1260322167000
147075	1678	28800894933000
147076	612	66542960726895
147077	2423	520000000
147078	2132	7057071000
147079	1874	10349000
147080	2133	9036224000
147081	1394	1127536860440200
147082	1394	1127536892440200
147093	1397	1260302165000
147094	1678	28800894935000
147095	1776	2132902366625
147096	706	10001000000000
147097	2133	9034220000
147098	1874	10359000
147099	2134	12384827000
147100	1587	20880578750000
147103	1397	1260292164000
147104	1678	28800894936000
147105	2133	9033218000
147106	1874	10365000
147107	2134	12383823000
147108	1668	21393940500000
147109	1668	21393952500000
147116	1397	1260282163000
147117	1678	28800894937000
147118	2133	9032216000
147119	1874	10371000
147120	2132	7056070000
147121	1594	20161978000000
147122	1594	20161990000000
147131	1397	1260262161000
147132	1678	28800894939000
147133	706	10000895062500
147134	1776	2133102366625
147135	2134	12381815000
147136	2133	9030212000
147137	1874	10384000
147138	1422	16074756804270
147139	1422	16074773741770
147147	1397	1260242159000
147148	1678	28800894941000
147149	2134	12380811000
147150	1874	10391000
147151	2133	9028208000
147152	1874	10393000
147153	1445	1724169000000
147154	1445	1724181000000
147180	1768	29267343110000
147233	1397	1260122147000
147234	1678	28800894953000
147235	1397	1260112146000
147236	1678	28800894954000
147237	2132	7051065000
147238	1874	10449000
147239	2134	12371775000
147240	1874	10455000
147241	2133	9016184000
147242	2133	9015182000
147253	1694	20699395197225
147260	1397	1260082143000
147261	1678	28800894957000
147262	2133	9012176000
147263	2132	7050064000
147264	2134	12369767000
147224	1874	10444000
147225	2329	342727102819988
147226	2329	342727138819988
147231	2133	9017186000
147232	1696	23483895335104
147243	186	66845521394804
147244	180	66847791394804
147245	1397	1260102145000
147246	1678	28800894955000
147247	2134	12370771000
147248	1874	10463000
147249	2133	9014180000
147250	1874	10465000
147251	1564	15486917000000
147252	1564	15487179000000
147298	1397	1260032138000
147299	1678	28800894962000
147300	2133	9007166000
147301	1874	10497000
147302	2134	12365751000
147303	1850	19416560949999
147320	1705	33681191580140
147321	1705	33681235580140
147331	2039	2345852000000
147332	1445	20878181000000
147333	1397	1259992134000
147334	1678	28800894966000
147335	1397	1259982133000
147336	1678	28800894967000
147337	2402	47035000000
147338	2426	0
147339	2134	12362739000
147340	1874	10520000
147341	2132	7047061000
147342	1874	10521000
147343	2133	9003158000
147344	2133	9002156000
147345	2329	343447138819988
147346	2329	343447176819988
147363	1397	1259952130000
147364	1678	28800894970000
147365	2133	8999150000
147366	2134	12359727000
147367	1874	10543000
147368	2132	7046060000
147369	1402	66424174812105
147370	1402	66424187812105
147407	606	82607092286229
147408	606	83327092286229
147413	1397	1259892124000
147414	1678	28800894976000
147415	2133	8993138000
147416	1874	10569000
147417	2134	12355711000
147418	1874	10573000
147419	1394	1130416904440200
147420	1394	1130416916440200
147423	1397	1259882123000
147424	1678	28800894977000
147425	1397	1259872122000
147426	1678	28800894978000
147427	1397	1259862121000
147428	1678	28800894979000
147429	2132	7044058000
147430	1874	10574000
147431	2134	12354707000
147432	1874	10578000
147433	2134	12353703000
147434	1874	10582000
147435	2133	8992136000
147436	2133	8991134000
147437	2133	8990132000
147438	1874	10588000
147439	1687	13089101648287
147487	1397	1259772112000
147488	1678	28800894988000
147489	2133	8981114000
147490	1874	10633000
147491	1394	1130416915440200
147493	1397	1259762111000
147494	1678	28800894989000
147495	2133	8980112000
147496	2134	12346675000
147497	1874	10639000
147498	1422	16794773741770
147499	1422	16794785741770
147544	1397	1259692104000
147545	1678	28800894996000
147546	2133	8974100000
147547	2134	12341655000
147548	1874	10673000
147571	1397	1259652100000
147572	1678	28800895000000
147573	1397	1259642099000
147574	1678	28800895001000
147575	1769	1566700000
147576	2132	7037051000
147577	2134	12338643000
147578	1874	10693000
147579	2133	8970092000
147580	1874	10695000
147581	2133	8969090000
147582	1874	10697000
147583	1522	17323940000000
147586	1419	31963366559748
147587	1419	31963391559748
147596	1395	58358073998457278
147597	1395	58358074011457278
147617	1672	18001686000000
147618	1672	18721686000000
147619	1672	18721690000000
147648	1695	20825408999000
147649	1695	20825410999000
147666	1397	1259552090000
147667	1678	28800895010000
147668	1726	118522112000
147669	693	66000100000000
147670	2133	8959070000
147671	2134	12330611000
147672	1874	10752000
147673	1397	1259542089000
147674	1678	28800895011000
147675	2133	8958068000
147676	1874	10754000
147677	1608	19578656000000
147683	1397	1259532088000
147684	1678	28800895012000
147685	2133	8957066000
147686	2132	7033047000
147687	1874	10757000
147688	2134	12329607000
147689	2086	5760426300069
147690	2086	5760439300069
147692	149	84815535000341
147693	149	84815548000341
147696	2087	4755438147766
147697	1397	1259522087000
147698	1678	28800895013000
147699	2133	8956064000
147700	2134	12328603000
147701	1874	10767000
147702	1610	20160485999950
147703	1610	20160497999950
147706	1685	199445022571430
147707	1685	199445034571430
147756	1394	1134736951440200
147757	1394	1134736976440200
147759	1397	1259442079000
147760	1678	28800895021000
147761	2133	8948048000
147762	1874	10805000
147763	1688	58391671113019
147764	1688	58391682113019
147779	1724	19133975500000
147780	1724	19133999500000
147782	1395	58358074024457278
147795	1397	1259402075000
147796	1678	28800895025000
147797	2134	12320571000
147798	2133	8944040000
147799	1394	1134736963440200
147806	1710	17514485414140
147807	1874	10681000
147808	1874	10687000
147809	1874	10691000
147810	1874	10709000
147811	1874	10711000
147812	1874	10715000
147813	1874	10733000
147814	1874	10741000
147815	1874	10743000
147816	1874	10745000
147817	1874	10749000
147818	1874	10777000
147819	1874	10781000
147820	1874	10789000
147821	1874	10793000
147822	1874	10797000
147823	1874	10801000
147824	1874	10809000
147825	1874	10817000
147826	1874	10821000
147827	1874	10825000
147828	1874	10829000
147829	1710	18234485414140
147259	1680	19452474499559
147275	1397	1260062141000
147276	1678	28800894959000
147277	1397	1260052140000
147278	1678	28800894960000
147279	2402	47989000000
147280	345	66001000000000
147281	2134	12367759000
147282	2132	7049063000
147283	1874	10485000
147284	2133	9010172000
147285	1874	10487000
147286	2133	9009170000
147287	42	80060851500000
147289	1718	11056682019070
147291	1397	1260042139000
147292	1678	28800894961000
147293	2134	12366755000
147294	1874	10493000
147295	2133	9008168000
147296	1874	10495000
147297	1716	4320116000000
147348	2402	46025000000
147349	2426	1000000000
147350	1397	1259972132000
147351	1678	28800894968000
147352	2133	9001154000
147353	1874	10527000
147354	2134	12361735000
147355	1692	23501214819983
147361	576	85517812726897
147362	576	85517824726897
147385	1596	11520375000002
147411	641	84724066500000
147412	641	85444066500000
147463	1611	5752535402899
147464	1611	5752560402899
147465	1397	1259812116000
147466	1678	28800894984000
147467	1397	1259802115000
147468	1678	28800894985000
147469	1397	1259792114000
147470	1678	28800894986000
147471	1397	1259782113000
147472	1678	28800894987000
147473	2132	7041055000
147474	1874	10611000
147475	2134	12349687000
147476	2134	12348683000
147477	1874	10619000
147478	2133	8985122000
147479	1874	10621000
147480	2133	8984120000
147481	2133	8983118000
147482	2133	8982116000
147483	1874	10627000
147484	2134	12347679000
147485	1874	10631000
147486	1672	18001665000000
147492	1715	12983657663945
147500	58	85427708999641
147501	58	85427720999641
147503	1397	1259752110000
147504	1678	28800894990000
147505	2132	7040054000
147506	1874	10640000
147507	2134	12345671000
147508	1874	10644000
147509	2133	8979110000
147510	1874	10646000
147511	1685	198725009571430
147512	1685	198725022571430
147531	1397	1259712106000
147532	1678	28800894994000
147533	2133	8976104000
147534	1610	19440474999950
147535	1610	19440485999950
147584	1696	24203894335104
147585	1696	24203919335104
147642	2134	12332619000
147643	2133	8962076000
147644	1992	721107990000
147645	1992	721109990000
147678	1445	1005169000000
147679	1445	20158169000000
147680	1608	18860095000000
147681	1608	19580095000000
147682	1608	19580125000000
147741	1397	1259462081000
147742	1678	28800895019000
147743	1397	1259452080000
147744	1678	28800895020000
147745	2134	12324587000
147746	1874	10794000
147747	2133	8950052000
147748	2133	8949050000
147749	1874	10798000
147750	2132	7031045000
147751	2134	12323583000
147752	1874	10803000
147753	1564	16207204000000
147765	1397	1259432078000
147766	1678	28800895022000
147767	1397	1259422077000
147768	1678	28800895023000
147769	2132	7030044000
147770	2134	12322579000
147771	2133	8947046000
147772	113	66000000000000
147773	1504	157243000000
147774	2133	8946044000
147775	1874	10814000
147776	2134	12321575000
147777	1874	10818000
147778	1723	17282257085979
147783	1513	38163202000000
147784	1513	38883202000000
147785	1513	38883622000000
147794	2384	719015000000
147886	1679	25198631656999
147888	1397	1259302065000
147889	1678	28800895035000
147890	1397	1259292064000
147891	1678	28800895036000
147892	2133	8934020000
147893	2132	7026040000
147894	1874	10878000
147895	2133	8933018000
147896	2134	12312539000
147897	1649	17751683999968
147898	1649	17751707999968
147907	1693	17326060623117
147908	1693	17326072623117
147910	1397	1259272062000
147911	1678	28800895038000
147912	2133	8931014000
147913	1874	10892000
147914	1690	189365896000000
147924	1420	1854874980000
147925	403	66300000000000
147926	1428	2159532000000
147927	472	66000500000000
147928	1397	1259252060000
147929	1678	28800895040000
147930	2134	12309527000
147931	2133	8929010000
147932	58	85427830999641
147957	1428	2158922000000
147958	472	66001100000000
147959	1428	2157812000000
147960	735	3001100000000
147961	1397	1259212056000
147962	1678	28800895044000
147963	1397	1259202055000
147964	1678	28800895045000
147965	1397	1259192054000
147966	1678	28800895046000
147967	2134	12306515000
147968	1874	10924000
147969	2134	12305511000
147970	2133	8925002000
147971	2133	8924000000
147972	2133	8922998000
147973	1874	10934000
147974	2132	7023037000
147975	1599	24057203097983
147976	1599	24057259097983
147986	1747	10146122599975
147987	1747	10146134599975
148006	1573	10659485000000
148021	1690	190085896000000
148022	1690	190085919000000
148043	1397	1259102045000
148044	1678	28800895055000
148045	1397	1259092044000
148046	1678	28800895056000
148047	1397	1259082043000
148048	1678	28800895057000
148049	1397	1259072042000
148050	1678	28800895058000
148051	2134	12298483000
148052	1874	10979000
148053	2134	12297479000
148054	2133	8914982000
148055	2133	8913980000
147265	1874	10474000
147266	1675	28364735999977
147267	1675	28364748999977
147304	1623	90003660898598
147386	560	66846771394804
147387	1397	1259922127000
147388	1678	28800894973000
147389	1397	1259912126000
147390	1678	28800894974000
147391	1397	1259902125000
147392	1678	28800894975000
147393	2133	8996144000
147394	1874	10554000
147395	2132	7045059000
147396	2133	8995142000
147397	1874	10557000
147398	2133	8994140000
147399	1874	10559000
147400	2134	12357719000
147401	1874	10563000
147402	702	44000000000515
147403	2298	1420366374626
147404	2134	12356715000
147405	1622	12564169800048
147406	1622	13284169800048
147440	1397	1259852120000
147441	1678	28800894980000
147442	1397	1259842119000
147443	1678	28800894981000
147444	2133	8989130000
147445	2133	8988128000
147446	1874	10592000
147447	2132	7043057000
147448	2134	12352699000
147462	1395	58356634000457278
147519	1397	1259732108000
147520	1678	28800894992000
147521	2134	12344667000
147523	1397	1259722107000
147524	1678	28800894993000
147525	2132	7039053000
147526	1874	10653000
147527	2133	8977106000
147528	2134	12343663000
147529	1874	10659000
147530	1656	19435908499990
147536	1397	1259702105000
147537	1678	28800894995000
147538	2134	12342659000
147539	1874	10665000
147540	2133	8975102000
147541	1874	10667000
147542	1395	58357353986457278
147543	1395	58357353998457278
147549	613	66000090000000
147550	599	67439923000000
147551	1397	1259682103000
147552	1678	28800894997000
147553	2133	8973098000
147554	2132	7038052000
147555	2134	12340651000
147556	1394	1131856916440200
147557	1394	1131856939440200
147588	1397	1259632098000
147589	1678	28800895002000
147590	2133	8968088000
147591	1874	10699000
147592	2134	12337639000
147593	1769	1565700000
147594	1402	67144187812105
147595	1402	67144200812105
147614	2329	343447197819988
147615	2329	344167197819988
147616	2329	344167201819988
147620	1397	1259602095000
147621	1678	28800895005000
147622	1397	1259592094000
147623	1678	28800895006000
147624	1397	1259582093000
147625	1678	28800895007000
147626	2132	7035049000
147627	1874	10717000
147628	2133	8965082000
147629	2133	8964080000
147630	2134	12334627000
147631	1874	10725000
147632	2134	12333623000
147633	1874	10729000
147634	613	66000088910000
147635	599	67439923090000
147636	613	66000087820000
147637	599	67439923180000
147638	2133	8963078000
147639	1874	10731000
147640	1695	20105370999000
147641	1695	20105408999000
147652	43	83280297890000
147664	1768	29987343110000
147665	1768	29987367110000
147704	2329	344167176819988
147705	2329	344167188819988
147708	1397	1259512086000
147709	1678	28800895014000
147710	1397	1259502085000
147711	1678	28800895015000
147712	2133	8955062000
147713	2134	12327599000
147714	1874	10773000
147715	693	66000099000000
147716	1504	156244000000
147717	113	66001000000000
147718	2133	8954060000
147719	1874	10775000
147731	369	84516729290830
147732	369	84516753290830
147735	1397	1259472082000
147736	1678	28800895018000
147737	2133	8951054000
147738	1874	10786000
147739	2134	12325591000
147740	1394	1133296951440200
147758	1685	199445047571430
147800	1397	1259392074000
147801	1678	28800895026000
147802	2133	8943038000
147803	1874	10828000
147804	2134	12319567000
147805	2132	7029043000
147836	1397	1259372072000
147837	1678	28800895028000
147838	1397	1259362071000
147839	1678	28800895029000
147840	1397	1259352070000
147841	1678	28800895030000
147842	2133	8941034000
147843	1874	10837000
147844	2134	12318563000
147845	1874	10841000
147846	2134	12317559000
147847	1874	10845000
147848	2134	12316555000
147849	1874	10849000
147850	2132	7028042000
147851	1874	10850000
147852	2133	8940032000
147853	1874	10852000
147854	2133	8939030000
147855	1701	18718579500103
147856	1701	19438579500103
147863	1588	18420805000000
147887	1395	58358074022457278
147899	1397	1259282063000
147900	1678	28800895037000
147901	2133	8932016000
147902	1874	10886000
147903	2134	12311535000
147904	1874	10890000
147905	1664	720010000000
147906	1664	720022000000
147909	1693	17326071623117
147948	1397	1259222057000
147949	1678	28800895043000
147950	2134	12307519000
147951	1874	10918000
147952	2133	8926004000
147953	1874	10920000
147954	2148	14400426880750
147955	2148	14400438880750
147977	1397	1259182053000
147978	1678	28800895047000
147979	2134	12304507000
147980	1874	10939000
147981	2133	8921996000
147982	1874	10941000
147983	1394	1136176963440200
147984	1394	1136176975440200
147988	2292	3599088000000
148023	1397	1259132048000
148024	1678	28800895052000
148025	1397	1259122047000
148026	1678	28800895053000
148027	2134	12300491000
148028	1874	10964000
148029	2133	8917988000
148030	1874	10966000
147327	2134	12363743000
147328	1874	10516000
147329	1693	15886030623117
147330	1693	15886048623117
147347	1395	58356634013457278
147356	1397	1259962131000
147357	1678	28800894969000
147358	2134	12360731000
147359	1874	10535000
147360	2133	9000152000
147371	1397	1259942129000
147372	1678	28800894971000
147373	2426	990000000
147374	1397	1259932128000
147375	1678	28800894972000
147376	2133	8998148000
147377	1874	10546000
147378	2134	12358723000
147379	2133	8997146000
147380	1874	10552000
147381	182	66000000000000
147382	2298	907015465626
147383	1688	56951612113019
147384	1688	56951646113019
147409	1679	24478654656999
147410	1679	25198654656999
147421	1693	16606048623117
147422	1693	16606060623117
147449	1397	1259832118000
147450	1678	28800894982000
147451	1397	1259822117000
147452	1678	28800894983000
147453	2132	7042056000
147454	1874	10598000
147455	2134	12351695000
147456	2133	8987126000
147457	2134	12350691000
147458	2133	8986124000
147459	1874	10610000
147460	1688	57671646113019
147461	1688	57671671113019
147502	610	68880068000000
147513	1397	1259742109000
147514	1678	28800894991000
147515	2133	8978108000
147516	1874	10648000
147517	2112	31487116101924
147518	2112	31487127101924
147522	1395	58356633986457278
147558	1397	1259672102000
147559	1678	28800894998000
147560	2133	8972096000
147561	1419	31243367559748
147562	2419	1000000000
147563	1397	1259662101000
147564	1678	28800894999000
147565	1419	31243366559748
147566	2133	8971094000
147567	1874	10684000
147568	2134	12339647000
147569	1670	15841168000000
147570	1670	15841181000000
147598	1397	1259622097000
147599	1678	28800895003000
147600	1397	1259612096000
147601	1678	28800895004000
147602	2132	7036050000
147603	1874	10704000
147604	1439	15103942578477
147605	2134	12336635000
147606	1874	10708000
147607	2134	12335631000
147608	1874	10712000
147609	2133	8967086000
147610	1874	10714000
147611	2133	8966084000
147612	1439	15823942578477
147613	1439	15823946578477
147646	1394	1133296939440200
147647	1394	1133296941440200
147650	1564	16207179000000
147651	1564	16207181000000
147653	1397	1259572092000
147654	1678	28800895008000
147655	1397	1259562091000
147656	1678	28800895009000
147657	2133	8961074000
147658	1874	10739000
147659	2132	7034048000
147660	2133	8960072000
147661	2134	12331615000
147662	1874	10746000
147663	1547	15835023000000
147691	1699	4320377750126
147694	1549	16991479000000
147695	1549	16991492000000
147720	1397	1259492084000
147721	1678	28800895016000
147722	1397	1259482083000
147723	1678	28800895017000
147724	2134	12326595000
147725	2132	7032046000
147726	1874	10780000
147727	2133	8953058000
147728	2133	8952056000
147729	1874	10784000
147730	1602	15696760169996
147733	1690	189365884000000
147734	1690	189365908000000
147754	1670	16561181000000
147755	1670	16561206000000
147781	1724	19134001500000
147786	1397	1259412076000
147787	1678	28800895024000
147788	388	66772975736837
147789	1560	18728880131803
147790	2133	8945042000
147791	1874	10820000
147792	1536	23040445000000
147793	1536	23040460000000
147831	1397	1259382073000
147832	1678	28800895027000
147833	2133	8942036000
147834	1546	16797644800000
147835	1546	16797655800000
147873	1397	1259322067000
147874	1678	28800895033000
147875	1397	1259312066000
147876	1678	28800895034000
147877	2134	12314547000
147878	1874	10867000
147879	2134	12313543000
147880	2133	8936024000
147881	1874	10873000
147882	2133	8935022000
147883	1874	10875000
147884	1467	11680387272869
147933	1397	1259242059000
147934	1678	28800895041000
147935	2133	8928008000
147936	1874	10907000
147937	1448	14359948000001
147940	1397	1259232058000
147941	1678	28800895042000
147942	2132	7024038000
147943	2133	8927006000
147944	1874	10910000
147945	2134	12308523000
147946	1874	10914000
147947	1691	14831205300052
147956	1395	58358074010457278
147989	1397	1259172052000
147990	1678	28800895048000
147991	1397	1259162051000
147992	1678	28800895049000
147993	2134	12303503000
147994	1874	10945000
147995	2132	7022036000
147996	281	66000899000000
147997	1591	1611000000
147998	1726	117421112000
147999	2427	100000000
148000	2133	8920994000
148001	1874	10948000
148002	2133	8919992000
148003	1874	10950000
148004	1395	58358794010457278
148005	1395	58358794036457278
148007	1513	38884542000000
148008	1513	39604542000000
148009	1513	39604672000000
148035	1601	12626090620000
148036	1601	12626114620000
148067	1397	1259062041000
148068	1678	28800895059000
148069	1394	1136176985440200
148070	1397	1259052040000
148071	1678	28800895060000
148072	2133	8910974000
148073	1874	10998000
148074	2132	7019033000
148075	2133	8909972000
148076	1874	11001000
148077	2134	12295471000
148078	1874	11005000
147830	1710	18234548414140
147857	1397	1259342069000
147858	1678	28800895031000
147859	2133	8938028000
147860	1568	250000
147861	1588	18420793975000
147862	1588	18420804975000
147864	1397	1259332068000
147865	1678	28800895032000
147866	2132	7027041000
147867	1874	10857000
147868	2133	8937026000
147869	2134	12315551000
147870	1874	10863000
147871	1444	17467954329999
147872	1444	17467967329999
147885	1711	20587135000000
147915	1397	1259262061000
147916	1678	28800895039000
147917	2133	8930012000
147918	2132	7025039000
147919	1874	10895000
147920	2134	12310531000
147921	1874	10899000
147922	1764	20243609100000
147923	1764	20243622100000
147938	2106	7920251000000
147939	2106	7920262000000
147985	1746	7008992999989
148010	1397	1259152050000
148011	1678	28800895050000
148012	1397	1259142049000
148013	1678	28800895051000
148014	2134	12302499000
148015	1874	10954000
148016	2133	8918990000
148017	2134	12301495000
148018	1874	10960000
148019	1536	23760460000000
148020	1536	23760483000000
148081	1397	1259042039000
148082	1678	28800895061000
148083	2133	8908970000
148084	1685	199445033571430
148139	1672	18721665000000
148140	1672	18721676000000
148151	1397	1258982033000
148152	1678	28800895067000
148153	2134	12290451000
148154	2133	8902958000
148155	1768	30707367110000
148156	1768	30707379110000
148207	1397	1258902025000
148208	1678	28800895075000
148209	2133	8894942000
148210	1874	11079000
148211	2134	12284427000
148212	1874	11083000
148213	1685	200165033571430
148214	1685	200165045571430
148237	1506	11520321967172
148238	1506	11520366967172
148249	1394	1139056999440200
148250	1394	1139057023440200
148251	1397	1258842019000
148252	1678	28800895081000
148253	1397	1258832018000
148254	1678	28800895082000
148255	2427	96750000
148256	2133	8888930000
148257	2133	8887928000
148258	1874	11111000
148259	2134	12280411000
148260	1649	18471707999968
148261	1649	18471734249968
148286	1474	27890762000043
148295	1395	58359514058457278
148296	1395	58359514060457278
148323	1397	1258742009000
148324	1678	28800895091000
148325	2134	12273383000
148326	1874	11162000
148327	2133	8878910000
148328	1874	11164000
148329	1764	20963622100000
148330	1764	20963634100000
148340	1397	1258722007000
148341	1678	28800895093000
148342	2132	7009023000
148343	1874	11167000
148344	2133	8876906000
148345	2134	12272379000
148346	1874	11173000
148347	718	2000001000000
148348	1655	0
148349	1394	1141937011440200
148350	1394	1141937025440200
148356	1419	31963378559748
148367	1397	1258692004000
148368	1678	28800895096000
148369	2132	7008022000
148370	1874	11184000
148371	2133	8873900000
148372	1723	18002257085979
148373	1723	18002270085979
148397	2133	8871896000
148398	1874	11202000
148399	1874	11206000
148400	2133	8870894000
148401	2133	8869892000
148402	1874	11210000
148403	1874	11214000
148404	1874	11218000
148405	1716	5040116000000
148406	1716	5040134000000
148454	1701	20158579500103
148455	1701	20158595500103
148457	389	68159958000000
148458	744	2016912805578
148459	1646	1913000000
148460	1397	1258631998000
148461	1678	28800895102000
148462	1397	1258621997000
148463	1678	28800895103000
148464	2133	8860874000
148465	2133	8859872000
148466	1874	11283000
148467	2133	8858870000
148468	2133	8857868000
148469	2133	8856866000
148470	1874	11289000
148471	2133	8855864000
148472	1874	11291000
148473	2134	12254307000
148474	2134	12253303000
148475	1874	11299000
148476	2134	12252299000
148477	2134	12251295000
148478	1874	11307000
148479	2134	12250291000
148480	2134	12249287000
148481	1874	11315000
148482	2134	12248283000
148483	2132	7000014000
148484	1874	11320000
148485	2132	6999013000
148486	2132	6998012000
148487	1679	25918867656999
148540	2134	12235231000
148541	2132	6993007000
148542	2132	6992006000
148543	2133	8845844000
148544	1874	11400000
148545	2133	8844842000
148546	2134	12234227000
148547	1874	11406000
148548	2134	12233223000
148549	2134	12232219000
148550	1874	11414000
148551	718	2000000000000
148552	171	78906831696494
148633	2133	8832818000
148634	1874	11513000
148635	2133	8831816000
148636	2133	8830814000
148637	1850	20136578949999
148640	1397	1258521987000
148641	1678	28800895113000
148642	2134	12214147000
148643	2134	12213143000
148644	1874	11525000
148645	2132	6983998000
148646	1874	11526000
148647	2132	6982997000
148648	2133	8829812000
148649	1874	11529000
148650	2133	8828810000
148651	1395	58359514074457278
148031	2133	8916986000
148032	1874	10968000
148033	2132	7021035000
148034	1457	16560387800000
148037	1397	1259112046000
148038	1678	28800895054000
148039	2134	12299487000
148040	1874	10973000
148041	2133	8915984000
148042	1874	10975000
148066	1395	58358794058457278
148095	1874	11011000
148096	1619	14400365000000
148159	1436	720012000000
148168	1668	22113952500000
148169	1668	22114063500000
148193	1397	1258922027000
148194	1678	28800895073000
148195	1397	1258912026000
148196	1678	28800895074000
148197	2055	2159023000000
148198	718	2000002000000
148199	2133	8896946000
148200	2133	8895944000
148201	1874	11069000
148202	2134	12286435000
148203	2134	12285431000
148204	1768	30707392110000
148239	1397	1258862021000
148240	1678	28800895079000
148241	1397	1258852020000
148242	1678	28800895080000
148243	2133	8890934000
148244	2133	8889932000
148245	1874	11102000
148246	2132	7013027000
148247	2134	12281415000
148248	1686	21272248700123
148264	1397	1258822017000
148265	1678	28800895083000
148266	1397	1258812016000
148267	1678	28800895084000
148268	1397	1258802015000
148269	1678	28800895085000
148270	1397	1258792014000
148271	1678	28800895086000
148272	2134	12279407000
148273	1874	11119000
148274	2134	12278403000
148275	2132	7012026000
148276	2134	12277399000
148277	1874	11128000
148278	2133	8886926000
148279	1874	11130000
148280	2133	8885924000
148281	2133	8884922000
148282	2133	8883920000
148283	1874	11136000
148284	2132	7011025000
148285	1394	1139057048440200
148287	1397	1258782013000
148288	1678	28800895087000
148289	2134	12276395000
148290	1874	11141000
148291	2133	8882918000
148292	1874	11143000
148293	1684	36003748819412
148294	1684	36003760819412
148299	1397	1258772012000
148300	1678	28800895088000
148301	1397	1258762011000
148302	1678	28800895089000
148303	1397	1258752010000
148304	1678	28800895090000
148305	2428	189000000
148306	1597	5821000000
148307	2132	7010024000
148308	1726	116320112000
148309	2429	100000000
148310	2134	12275391000
148311	1874	11148000
148312	2134	12274387000
148313	1874	11152000
148314	2133	8881916000
148315	1874	11154000
148316	2133	8880914000
148317	1874	11156000
148318	2133	8879912000
148319	1874	11158000
148320	1402	67864200812105
148321	1402	67864238812105
148337	484	79054009000000
148338	484	79054021000000
148351	1397	1258712006000
148352	1678	28800895094000
148353	2133	8875904000
148354	2134	12271375000
148355	1874	11179000
148362	2133	8874902000
148363	1874	11185000
148364	1588	19860928000000
148407	451	66564522585011
148408	1646	1813000000
148409	1397	1258662001000
148410	1678	28800895099000
148411	1397	1258652000000
148412	1678	28800895100000
148413	2133	8868890000
148414	2133	8867888000
148415	2133	8866886000
148416	1874	11228000
148417	2134	12263343000
148418	2134	12262339000
148419	2134	12261335000
148420	1874	11240000
148421	2133	8865884000
148422	1874	11242000
148423	2134	12260331000
148424	1874	11246000
148425	2133	8864882000
148426	2132	7005019000
148427	1874	11249000
148428	2132	7004018000
148429	2132	7003017000
148430	2132	7002016000
148431	1874	11252000
148432	2133	8863880000
148433	2134	12259327000
148434	2134	12258323000
148435	1874	11262000
148436	470	82435433000000
148437	470	82435569000000
148488	379	66190536998665
148489	379	66000000000665
148490	2430	189526998000
148491	1397	1258611996000
148492	1678	28800895104000
148493	1397	1258601995000
148494	1678	28800895105000
148495	1397	1258591994000
148496	1678	28800895106000
148497	2134	12247279000
148498	1874	11326000
148499	2134	12246275000
148500	2132	6997011000
148501	1874	11331000
148502	2133	8854862000
148503	2133	8853860000
148504	1874	11335000
148505	2133	8852858000
148506	1874	11337000
148507	2132	6996010000
148508	1874	11338000
148509	1573	10659632000000
148510	2132	6995009000
148511	2133	8851856000
148512	2133	8850854000
148513	1874	11343000
148514	2133	8849852000
148515	1874	11345000
148516	2133	8848850000
148517	2133	8847848000
148518	2133	8846846000
148519	2132	6994008000
148520	1874	11352000
148521	2134	12245271000
148522	2134	12244267000
148523	1874	11360000
148524	2134	12243263000
148525	1874	11364000
148526	2134	12242259000
148527	1874	11368000
148528	2134	12241255000
148529	1874	11372000
148530	2134	12240251000
148531	1874	11376000
148532	2134	12239247000
148533	2134	12238243000
148534	1874	11384000
148535	2134	12237239000
148536	2134	12236235000
148537	1874	11392000
148538	1573	11379632000000
148539	1573	11379650000000
148553	1397	1258581993000
148056	1874	10987000
148057	2134	12296475000
148058	1874	10991000
148059	2133	8912978000
148060	1874	10993000
148061	2133	8911976000
148062	1874	10995000
148063	2132	7020034000
148064	1693	18046071623117
148065	1693	18046119623117
148105	1397	1259012036000
148106	1678	28800895064000
148107	2133	8905964000
148108	1874	11022000
148109	2134	12292459000
148110	1874	11026000
148111	1692	24221214819983
148112	1692	24221226819983
148221	1709	12240283000000
148235	1654	25337769999798
148236	1654	25337814999798
148262	1692	24941226819983
148263	1692	24941253069983
148297	1611	6472560402899
148298	1611	6472572402899
148322	1690	190085934000000
148331	1397	1258732008000
148332	1678	28800895092000
148333	309	66846780394804
148334	2133	8877908000
148335	1394	1140496999440200
148336	1394	1140497011440200
148339	484	79054020000000
148357	1397	1258702005000
148358	1678	28800895095000
148359	2134	12270371000
148360	1588	19860916000000
148361	1588	19860927000000
148365	1474	28610762000043
148366	1474	28610774000043
148384	1622	13284122800048
148385	1622	13284136800048
148578	2132	6990004000
148579	1874	11416000
148580	1874	11438000
148581	1874	11444000
148582	2329	344887220819988
148079	1394	1137616985440200
148080	1394	1137616999440200
148085	1397	1259032038000
148086	1678	28800895062000
148087	2132	7018032000
148088	1874	11008000
148089	2134	12294467000
148090	1874	11012000
148091	2133	8907968000
148092	1874	11014000
148093	1619	14400353000000
148094	1619	14400366000000
148097	1397	1259022037000
148098	1678	28800895063000
148099	2134	12293463000
148100	1874	11017000
148101	1597	5811000000
148102	2428	200000000
148103	2133	8906966000
148104	1613	17137532400000
148113	1397	1259002035000
148114	1678	28800895065000
148115	1874	10858000
148116	1874	10860000
148117	1874	10862000
148118	1874	10870000
148119	1710	18235087414140
148120	1874	10902000
148121	1874	10906000
148122	1874	10916000
148123	1874	10926000
148124	1874	10942000
148125	1874	10944000
148126	1874	10952000
148127	1874	10958000
148128	1874	10970000
148129	1874	10976000
148130	1874	10978000
148131	2133	8904962000
148132	1874	10982000
148133	1874	10984000
148134	1874	11000000
148135	1874	11016000
148136	1874	11024000
148137	1710	18955087414140
148138	1710	18955147414140
148141	1397	1258992034000
148142	1678	28800895066000
148143	2134	12291455000
148144	1874	11032000
148145	2132	7017031000
148146	1874	11033000
148147	2133	8903960000
148148	1874	11035000
148149	1445	21598181000000
148150	1445	21598194000000
148157	632	85437801000000
148158	632	85437813000000
148160	556	66720035511028
148161	1578	23000000000
148162	1397	1258972032000
148163	1678	28800895068000
148164	2133	8901956000
148165	1874	11043000
148166	1588	19140805000000
148167	1588	19140916000000
148170	1397	1258962031000
148171	1678	28800895069000
148172	1397	1258952030000
148173	1678	28800895070000
148174	1397	1258942029000
148175	1678	28800895071000
148176	1397	1258932028000
148177	1678	28800895072000
148178	2134	12289447000
148179	2134	12288443000
148180	2132	7016030000
148181	1874	11052000
148182	2134	12287439000
148183	2133	8900954000
148184	1874	11058000
148185	2133	8899952000
148186	1874	11060000
148187	2133	8898950000
148188	2133	8897948000
148189	2132	7015029000
148190	1874	11065000
148191	1616	6480158410000
148192	1616	6480207410000
148205	1679	25918631656999
148206	1679	25918656656999
148215	1397	1258892024000
148216	1678	28800895076000
148217	2133	8893940000
148218	1874	11085000
148219	2132	7014028000
148220	1709	12240294000000
148222	2425	90000000
148223	1397	1258882023000
148224	1678	28800895077000
148225	1397	1258872022000
148226	1678	28800895078000
148227	2134	12283423000
148228	1874	11090000
148229	2133	8892938000
148230	2133	8891936000
148231	1874	11094000
148232	2134	12282419000
148233	1874	11098000
148234	2307	6479178000000
148374	1397	1258682003000
148375	1678	28800895097000
148376	2134	12269367000
148377	2132	7007021000
148378	1874	11193000
148379	2134	12268363000
148380	2133	8872898000
148381	1874	11199000
148382	1394	1143377025440200
148383	1394	1143377039440200
148386	1397	1258672002000
148387	1678	28800895098000
148388	2132	7006020000
148389	1874	11200000
148390	2134	12267359000
148391	1874	11204000
148392	2134	12266355000
148393	2134	12265351000
148394	1874	11212000
148395	2134	12264347000
148396	2248	14399610000000
148438	1397	1258641999000
148439	1678	28800895101000
148440	2134	12257319000
148441	1874	11266000
148442	2133	8862878000
148443	1874	11268000
148444	2132	7001015000
148445	1874	11269000
148446	2134	12256315000
148447	1874	11273000
148448	2134	12255311000
148449	1874	11277000
148450	2133	8861876000
148451	1874	11279000
148452	606	84047092286229
148453	606	84047108286229
148456	1740	19891014000000
148611	1397	1258541989000
148612	1678	28800895111000
148613	2132	6987001000
148614	2132	6986000000
148615	2134	12220171000
148616	2134	12219167000
148617	2134	12218163000
148618	2133	8834822000
148619	2133	8833820000
148620	1874	11498000
148621	1679	26638867656999
148622	1679	26638884656999
148652	2430	189426998000
148653	50	66008900000000
148654	2431	769714905251
148655	1397	1258511986000
148656	1678	28800895114000
148657	1397	1258501985000
148658	1678	28800895115000
148659	1397	1258491984000
148660	1678	28800895116000
148661	2134	12212139000
148662	2134	12211135000
148663	2132	6981996000
148664	1874	11540000
148665	2132	6980995000
148666	1874	11541000
148667	2132	6979994000
148668	2132	6978993000
148669	1874	11543000
148670	2134	12210131000
148671	1874	11547000
148672	2133	8827808000
148673	1874	11549000
148674	2133	8826806000
148675	1874	11551000
148676	2133	8825804000
148554	1678	28800895107000
148555	1397	1258571992000
148556	1678	28800895108000
148557	2132	6991005000
148558	1874	11401000
148559	1874	11403000
148560	1874	11407000
148561	2055	2159021000000
148562	2134	12231215000
148563	1874	11419000
148564	2134	12230211000
148565	2134	12229207000
148566	2134	12228203000
148567	2134	12227199000
148568	1874	11435000
148569	2133	8843840000
148570	2133	8842838000
148571	1874	11439000
148572	2133	8841836000
148573	1874	11441000
148574	2133	8840834000
148575	1874	11443000
148576	2329	344887188819988
148577	2329	344887228819988
148583	1397	1258561991000
148584	1678	28800895109000
148585	1397	1258551990000
148586	1678	28800895110000
148587	2132	6989003000
148588	2134	12226195000
148589	1874	11449000
148590	2134	12225191000
148591	1874	11453000
148592	2134	12224187000
148593	1874	11457000
148594	2134	12223183000
148595	1874	11461000
148596	2134	12222179000
148597	2134	12221175000
148598	1874	11469000
148599	2132	6988002000
148600	1874	11470000
148601	2133	8839832000
148602	1874	11472000
148603	2133	8838830000
148604	1874	11474000
148605	2133	8837828000
148606	2133	8836826000
148607	2133	8835824000
148608	1874	11480000
148609	1594	20881990000000
148610	1594	20882023000000
148623	1397	1258531988000
148624	1678	28800895112000
148625	2134	12217159000
148626	2134	12216155000
148627	1874	11506000
148628	2134	12215151000
148629	2132	6984999000
148630	1874	11511000
148631	1850	20136560949999
148632	1850	20136575949999
148638	1602	16416748169996
148639	1602	16416766169996
148699	1397	1258481983000
148700	1678	28800895117000
148701	1397	1258471982000
148702	1678	28800895118000
148703	1444	17467987329999
148704	2132	6977992000
148705	1874	11598000
148706	2133	8818790000
148707	2133	8817788000
148708	2133	8816786000
148709	1874	11604000
148710	2133	8815784000
148711	2133	8814782000
148712	1874	11608000
148713	2134	12201095000
148714	1874	11612000
148715	2134	12200091000
148716	2134	12199087000
148717	1874	11620000
148718	2134	12198083000
148719	1874	11624000
148720	2134	12197079000
148721	1874	11628000
148722	2134	12196075000
148723	2134	12195071000
148724	1874	11636000
148725	2134	12194067000
148726	2132	6976991000
148727	1874	11641000
148728	2132	6975990000
148729	1444	18187987329999
148730	1444	18188003329999
148677	2133	8824802000
148678	2133	8823800000
148679	1874	11557000
148680	2133	8822798000
148681	2133	8821796000
148682	1874	11561000
148683	2133	8820794000
148684	1874	11563000
148685	2133	8819792000
148686	2134	12209127000
148687	2134	12208123000
148688	2134	12207119000
148689	1874	11577000
148690	2134	12206115000
148691	2134	12205111000
148692	1874	11585000
148693	2134	12204107000
148694	2134	12203103000
148695	1874	11593000
148696	2134	12202099000
148697	1688	59111682113019
148698	1688	59111936113019
148731	1397	1258461981000
148732	1678	28800895119000
148733	2133	8813780000
148734	2132	6974989000
148735	1874	11645000
148736	2132	6973988000
148737	1874	11646000
148738	2133	8812778000
148739	1874	11648000
148740	2133	8811776000
148741	2134	12193063000
148742	1874	11654000
148743	2134	12192059000
148744	2134	12191055000
148745	1874	11662000
148746	1656	20155908499990
148747	1656	20155926499990
148748	1759	13897359139889
148749	2431	769614905251
148750	1397	1258451980000
148751	1678	28800895120000
148752	1397	1258441979000
148753	1678	28800895121000
148754	2133	8810774000
148755	1874	11664000
148756	453	66845780394804
148757	712	6001000000000
148758	2132	6972987000
148759	1874	11665000
148760	2132	6971986000
148761	2132	6970985000
148762	1874	11667000
148763	2133	8809772000
148764	1874	11669000
148765	2133	8808770000
148766	2133	8807768000
148767	1874	11673000
148768	2133	8806766000
148769	1874	11675000
148770	2134	12190051000
148771	1874	11679000
148772	2134	12189047000
148773	1874	11683000
148774	2134	12188043000
148775	2134	12187039000
148776	1874	11691000
148777	2134	12186035000
148778	2134	12185031000
148779	1671	22704409003785
148780	1671	22704544003785
148781	1440	8640274045924
148782	1440	8640409045924
148783	2306	5039279000000
148784	1397	1258431978000
148785	1678	28800895122000
148786	1397	1258421977000
148787	1678	28800895123000
148788	2134	12184027000
148789	2133	8805764000
148790	2132	6969984000
148791	2132	6968983000
148792	1874	11707000
148793	2132	6967982000
148794	2134	12183023000
148795	1874	11712000
148796	2133	8804762000
148797	2133	8803760000
148798	2133	8802758000
148799	1874	11718000
148800	2133	8801756000
148801	2134	12182019000
148802	2134	12181015000
148803	1874	11728000
148804	2134	12180011000
148805	1690	190085929000000
148806	1397	1258411976000
148807	1678	28800895124000
148808	146	66846779269804
148809	2133	8800754000
148810	1874	11734000
148811	2132	6966981000
148812	2133	8799752000
148813	1874	11737000
148814	2133	8798750000
148815	2133	8797748000
148816	2134	12179007000
148817	2132	6965980000
148818	1874	11746000
148819	2132	6964979000
148820	2134	12178003000
148821	2134	12176999000
148822	1874	11755000
148823	2133	8796746000
148824	2134	12175995000
148825	2134	12174991000
148826	2134	12173987000
148827	2134	12172983000
148828	2133	8795744000
148829	1394	1144817039440200
148830	1394	1144817067565200
148831	1397	1258401975000
148832	1678	28800895125000
148833	2132	6963978000
148834	1874	11776000
148835	2133	8794742000
148836	1874	11778000
148837	2133	8793740000
148838	2133	8792738000
148839	2134	12171979000
148840	2134	12170975000
148841	2134	12169971000
148842	1874	11794000
148843	2134	12168967000
148844	1874	11798000
148845	1610	20160503999950
148846	651	66718925000000
148847	677	66001000000000
148848	1397	1258391974000
148849	1678	28800895126000
148850	472	66000990000000
148851	1428	2157912000000
148852	2133	8791736000
148853	2134	12167963000
148854	1874	11804000
148855	2134	12166959000
148856	1874	11808000
148857	180	66846790394804
148858	186	66846521394804
148859	2134	12165955000
148860	2132	6962977000
148861	2132	6961976000
148862	1874	11814000
148863	2133	8790734000
148864	1874	11816000
148865	2133	8789732000
148866	1688	59831936113019
148867	1688	59832065113019
148868	1874	11802000
148869	1633	15888844625277
148870	1633	15888970625277
148871	1633	15888973625277
148872	735	3000990000000
148873	1428	2158012000000
148874	1397	1258381973000
148875	1678	28800895127000
148876	2133	8788730000
148877	2134	12164951000
148878	2134	12163947000
148879	1874	11828000
148880	2134	12162943000
148881	2132	6960975000
148882	2133	8787728000
148883	2133	8786726000
148884	1874	11837000
148885	1717	22861460000055
148886	1717	22861490000055
148887	1397	1258371972000
148888	1678	28800895128000
148889	1397	1258361971000
148890	1678	28800895129000
148891	2132	6959974000
148892	2132	6958973000
148893	1874	11839000
148894	2132	6957972000
148895	1874	11840000
148896	1549	16991515000000
148897	2133	8785724000
148898	1874	11842000
148899	2134	12161939000
148900	2134	12160935000
148901	1874	11850000
148902	2134	12159931000
148903	2133	8784722000
148904	2133	8783720000
148905	2133	8782718000
148906	1874	11860000
148907	2133	8781716000
148908	2134	12158927000
148909	2134	12157923000
148910	2134	12156919000
148911	1874	11874000
148912	2134	12155915000
148913	1874	11878000
148914	1549	17711515000000
148915	1549	17711527000000
148923	1397	1258351970000
148924	1678	28800895130000
148925	2133	8780714000
148926	1874	11880000
148927	2132	6956971000
148928	2133	8779712000
148929	2132	6955970000
148930	1874	11884000
148931	2133	8778710000
148932	2134	12154911000
148933	2134	12153907000
148934	2134	12152903000
148935	1874	11898000
148936	2134	12151899000
148937	1679	27358884656999
148938	1679	27358903656999
148941	369	85236771290830
148953	1397	1258331968000
148954	1678	28800895132000
148955	2134	12149891000
148956	2133	8774702000
148957	1874	11919000
148958	2132	6953968000
148959	2132	6952967000
148960	2134	12148887000
148961	1874	11925000
148962	2133	8773700000
148963	2133	8772698000
148964	1695	20825425999000
148978	1397	1258311966000
148979	1678	28800895134000
148980	2134	12144871000
148981	2134	12143867000
148982	2134	12142863000
148983	1874	11958000
148984	2133	8769692000
148985	1874	11960000
148986	2132	6950965000
148987	1726	115219112000
148988	2432	100000000
148989	2132	6949964000
148990	2133	8768690000
148991	1874	11964000
148992	2133	8767688000
148993	1874	11966000
148994	2261	14399438000000
149008	1395	58360954090457278
149009	1395	58360954105457278
149031	1874	11990000
149032	1509	21263549503835
149047	1397	1258271962000
149048	1678	28800895138000
149049	1397	1258261961000
149050	1678	28800895139000
149051	1397	1258251960000
149052	1678	28800895140000
149053	2132	6944959000
149054	1874	12015000
149055	686	69550056000000
149056	2132	6943958000
149057	2132	6942957000
149058	2132	6941956000
149059	2134	12134831000
149060	2134	12133827000
149061	2133	8758670000
149062	2133	8757668000
149063	2133	8756666000
149064	1874	12032000
149065	2133	8755664000
149066	2133	8754662000
149067	2133	8753660000
149068	2133	8752658000
149069	2133	8751656000
149070	1874	12042000
149071	2432	99000000
149072	487	66563721585011
149073	1737	2299001100
149074	2134	12132823000
149075	2134	12131819000
149076	2134	12130815000
149077	1874	12054000
149078	2134	12129811000
149079	1874	12058000
149080	2134	12128807000
149081	2134	12127803000
149082	1874	12066000
149083	2134	12126799000
149084	2134	12125795000
149085	2134	12124791000
149086	2134	12123787000
149087	1394	1146257124565200
149091	1696	24203951335104
149093	1593	20833874000000
149094	1593	21553874000000
149095	1593	21554874000000
149201	1980	25201493000000
149202	1980	25921493000000
149203	1980	25922093000000
149222	369	85956839290830
149265	1874	12210000
149266	1654	26057814999798
149267	1654	26057829999798
149269	1397	1258171952000
149270	1678	28800895148000
149271	2133	8730614000
149272	1874	12219000
149273	2133	8729612000
149274	2132	6929944000
149275	1874	12222000
149276	2134	12101699000
149277	1874	12226000
149278	2134	12100695000
149279	1874	12230000
149280	2134	12099691000
149281	1874	12234000
149282	1422	16794789741770
149284	1547	15835015000000
149286	1764	21683634100000
149287	1764	21683650100000
149290	1874	12224000
149291	1693	18046085623117
149304	1397	1258151950000
149305	1678	28800895150000
149306	1397	1258141949000
149307	1678	28800895151000
149308	1397	1258131948000
149309	1678	28800895152000
149310	2133	8726606000
149311	2134	12096679000
149312	2133	8725604000
149313	2133	8724602000
149314	2133	8723600000
149315	1394	1147697183565200
149316	2132	6926941000
149317	1874	12261000
149318	2132	6925940000
149319	2132	6924939000
149320	2132	6923938000
149321	1874	12264000
149322	1268	1003855681688
149323	1269	32000000
149324	1268	1003853681688
149325	1269	33000000
149326	1268	1003851681688
149327	1269	34000000
149328	1268	1003849681688
149329	1269	35000000
149330	2133	8722598000
149331	2133	8721596000
149332	2133	8720594000
149333	2134	12095675000
149334	2134	12094671000
149335	1874	12278000
149336	2134	12093667000
149337	1874	12282000
149338	2134	12092663000
149339	2134	12091659000
149340	2134	12090655000
149341	1874	12294000
149342	2134	12089651000
149343	2134	12088647000
149344	1874	12302000
149345	2134	12087643000
148916	1622	12564145800048
148917	1622	13284145800048
148918	1622	13284157800048
148942	1397	1258341969000
148943	1678	28800895131000
148944	2133	8777708000
148945	2133	8776706000
148946	2133	8775704000
148947	1874	11908000
148948	2132	6954969000
148949	2134	12150895000
148950	1874	11913000
148951	1623	90723661898598
148952	1623	90723676898598
149014	149	84815550000341
149015	1397	1258291964000
149016	1678	28800895136000
149017	2134	12139851000
149018	2132	6947962000
149019	1874	11984000
149020	2134	12138847000
149021	2134	12137843000
149022	1874	11992000
149023	2132	6946961000
149024	2133	8764682000
149025	2133	8763680000
149026	2133	8762678000
149027	2329	345607220819988
149028	2329	345607238819988
149034	1397	1258281963000
149035	1678	28800895137000
149036	2134	12136839000
149037	2133	8761676000
149038	2133	8760674000
149039	2133	8759672000
149040	1874	12009000
149041	2134	12135835000
149042	2132	6945960000
149043	1402	68584238812105
149044	1402	68584254812105
149046	1395	58360954096457278
149089	369	85956772290830
149090	369	85956829290830
149132	1439	16543974578477
149159	1268	1003877681688
149160	1269	21000000
149161	1268	1003875681688
149162	1269	22000000
149163	1268	1003873681688
149164	1269	23000000
149165	1268	1003871681688
149166	1269	24000000
149167	1268	1003869681688
149168	1269	25000000
149169	1268	1003867681688
149170	1269	26000000
149171	1268	1003865681688
149172	1269	27000000
149173	1268	1003863681688
149174	1269	28000000
149175	1268	1003861681688
149176	1269	29000000
149177	1268	1003859681688
149178	1269	30000000
149179	1268	1003857681688
149180	1269	31000000
149181	1708	20520793181790
149182	1708	20520829181790
149204	498	67440214000000
149205	724	20002150000000
149206	1397	1258211956000
149207	1678	28800895144000
149208	2134	12112743000
149209	1874	12147000
149210	2134	12111739000
149211	2134	12110735000
149212	2133	8742638000
149213	1874	12157000
149214	2132	6935950000
149215	1874	12158000
149216	2133	8741636000
149217	1874	12160000
149218	2133	8740634000
149219	1874	12162000
149220	1471	22265555900000
149221	1471	22265622900000
149227	724	20001130000000
149228	1956	3000000000
149229	1397	1258201955000
149230	1678	28800895145000
149231	1397	1258191954000
149232	1678	28800895146000
149233	2134	12109731000
149234	2133	8739632000
149235	2133	8738630000
149236	1874	12170000
149237	2134	12108727000
149238	1874	12174000
149239	2134	12107723000
149240	2132	6934949000
149241	2132	6933948000
149242	1874	12180000
149243	2132	6932947000
149244	2133	8737628000
149245	2133	8736626000
149246	2133	8735624000
149247	2133	8734622000
149248	2134	12106719000
149249	2134	12105715000
149250	1613	17857532400000
149251	1613	17857586400000
149285	1688	59831952113019
149379	1688	59831954113019
149406	1397	1258091944000
149407	1678	28800895156000
149408	1397	1258081943000
149409	1678	28800895157000
149410	2132	6917932000
149411	2134	12077603000
149412	2132	6916931000
149413	2132	6915930000
149414	2134	12076599000
149415	1874	12378000
149416	2134	12075595000
149417	2134	12074591000
149418	2134	12073587000
149419	1874	12390000
149420	2134	12072583000
149421	2134	12071579000
149422	2112	32207127101924
149423	2112	32207157101924
149434	1623	91443676898598
149435	1623	91443712898598
149500	1397	1258021937000
149501	1678	28800895163000
149502	1397	1258011936000
149503	1678	28800895164000
149504	1693	17239788899116
149505	342	66277931638598
149506	1759	14617397139889
149507	1693	16836971063748
149508	894	311162277935181
149509	1693	16750321023883
149510	569	66933430434669
149511	1693	16663670984018
149512	390	66933430434669
149513	1693	16577020944153
149514	570	66933430434669
149515	1693	16490370904288
149516	251	66933430434669
149517	1693	16404089618295
149518	312	66276827024809
149519	1693	15781643702139
149520	1772	6689445300164
149521	1693	14598290813627
149522	1030	913716893004926
149523	1693	14512009318472
149524	238	66086983695901
149525	2132	6907922000
149526	2132	6906921000
149527	1874	12499000
149528	2132	6905920000
149529	1874	12502000
149530	1759	15337397139889
149531	1759	15337411039513
149532	1796	200000008
149533	2367	100000101
149534	152	66000110100000
149535	1807	200000037
149536	2332	100000100
149537	1571	6800869387355
149542	1759	14617385139889
149543	2134	12056519000
149544	2134	12055515000
149545	2134	12054511000
149546	2134	12053507000
149547	1874	12517000
149548	2133	8689532000
149549	2133	8688530000
149550	1874	12524000
149551	2133	8687528000
149552	1874	12526000
149553	2133	8686526000
149554	2133	8685524000
149555	1759	15337385139889
148919	1395	58359514097457278
148920	1395	58360234097457278
148921	1395	58360234109457270
148922	1571	6800869387203
148939	369	85236753290830
148940	369	85236772290830
148997	1397	1258301965000
148998	1678	28800895135000
148999	2134	12141859000
149000	1874	11970000
149001	2133	8766686000
149002	1874	11972000
149003	2133	8765684000
149004	2132	6948963000
149005	2134	12140855000
149006	1394	1146257067565200
149007	1394	1146257082565200
149010	1690	190805929000000
149011	1690	190805944000000
149033	1714	20445859171760
149088	1696	24203943335104
149092	1593	21552961000000
149223	1444	18908003329999
149224	1444	18908070329999
149226	1559	17586376499999
149252	1397	1258181953000
149253	1678	28800895147000
149254	2133	8733620000
149255	2132	6931946000
149256	2134	12104711000
149257	2134	12103707000
149258	2134	12102703000
149259	2133	8732618000
149260	2132	6930945000
149261	2133	8731616000
149262	1874	12217000
149263	1394	1149137148565200
149264	1394	1149137166565200
149268	1654	26057832999798
149283	1693	18046087623117
149288	1874	12220000
149289	1764	21683652100000
149292	1764	21683649100000
149380	1397	1258111946000
149381	1678	28800895154000
149382	1397	1258101945000
149383	1678	28800895155000
149384	2133	8714582000
149385	1874	12332000
149386	2133	8713580000
149387	2134	12083627000
149388	2134	12082623000
149389	1874	12342000
149390	2134	12081619000
149391	2134	12080615000
149392	1874	12350000
149393	2134	12079611000
149394	2134	12078607000
149395	2133	8712578000
149396	1874	12360000
149397	2133	8711576000
149398	1874	12362000
149399	2133	8710574000
149400	2132	6920935000
149401	1874	12365000
149402	2132	6919934000
149403	2132	6918933000
149404	1394	1152017230565200
149405	1394	1152017264565200
149424	2133	8709572000
149425	2133	8708570000
149426	2133	8707568000
149427	2133	8706566000
149428	2133	8705564000
149429	1874	12384000
149430	2133	8704562000
149431	1874	12402000
149432	2112	32207163101924
149458	2133	8703560000
149459	2133	8702558000
149460	2133	8701556000
149461	2133	8700554000
149462	2133	8699552000
149463	2133	8698550000
149464	2133	8697548000
149465	2133	8696546000
149466	2261	15119489000000
149469	2261	15119470000000
149638	1397	1257981933000
149639	1678	28800895167000
149640	2132	6900915000
149641	1874	12583000
149642	1693	12882427016142
149643	402	66933430434669
149644	1693	12795776976277
149645	275	66933430434669
149646	2132	6899914000
149647	1874	12584000
149648	1693	12709126936412
149649	452	66933430434669
149650	1693	12622842526026
149651	458	66279227049307
149652	1693	12536192486161
149653	690	66933430434669
149654	2134	12044471000
149655	1874	12588000
149656	2134	12043467000
149657	1874	12592000
149658	2133	8676506000
149659	1874	12594000
149660	2133	8675504000
149661	1874	12596000
149662	95	66720021000000
149721	1687	13809138648287
149834	2211	720920000000
149835	2211	720968999992
149837	1397	1257901925000
149838	1678	28800895175000
149839	1397	1257891924000
149840	1678	28800895176000
149841	2132	6888903000
149842	1874	12739000
149843	2132	6887902000
149844	2132	6886901000
149845	2134	12019371000
149846	1874	12745000
149847	2134	12018367000
149848	2134	12017363000
149849	2134	12016359000
149850	2134	12015355000
149851	1874	12761000
149852	2134	12014351000
149853	1874	12765000
149854	2134	12013347000
149855	1874	12769000
149856	1693	8098870803786
149857	578	66276917402319
149858	2133	8654462000
149859	1874	12771000
149860	2133	8653460000
149861	2133	8652458000
149862	2133	8651456000
149863	1874	12777000
149864	2133	8650454000
149865	1874	12779000
149866	1693	8012589400132
149867	649	66276917402319
149868	1693	7926304532202
149869	114	66087621517324
149870	1693	7840022738979
149871	443	66277216652233
149872	1693	7753372699114
149873	138	66933430434669
149874	1693	7666722659249
149875	500	66933430434669
149876	1693	7580072619384
149877	587	66933430434669
149878	1693	7493422579519
149879	146	66933428309669
149880	1693	7406772539654
149881	225	66933430434669
149882	1693	7320122499789
149883	377	66933430434669
149884	1693	7233472459924
149885	560	66933420434669
149886	1532	2880124538460
149887	1532	2880170538460
149917	1705	33681215580140
149918	1696	24203916335104
150069	1419	32683387424689
150070	1419	32683434424689
150076	1397	1257821917000
150077	1678	28800895183000
150078	2133	8633420000
150079	1874	12890000
150080	1693	4807793361311
150081	594	66933430434669
150082	2132	6876891000
150083	1693	4721143321446
150084	63	66933430434669
150085	1693	4634493281581
150086	150	66933430434669
150087	1693	4548211877927
150088	562	66276917402319
150089	1693	4461561838062
148965	1397	1258321967000
148966	1678	28800895133000
148967	2134	12147883000
148968	2134	12146879000
148969	1874	11937000
148970	2132	6951966000
148971	2134	12145875000
148972	2133	8771696000
148973	1874	11944000
148974	2133	8770694000
148975	1874	11946000
148976	1395	58360234074457278
148977	1395	58360234090457278
148995	1874	11947000
148996	2261	14399422000000
149012	1687	13809101648287
149013	1687	13809116648287
149029	1509	21263534503835
149030	1509	21263552503835
149045	2329	345607236819988
149096	1397	1258241959000
149097	1678	28800895141000
149098	1268	1003913681688
149099	1269	3000000
149100	1439	15823957578477
149101	1268	1003911681688
149102	1269	4000000
149103	2134	12122783000
149104	2134	12121779000
149105	1268	1003909681688
149106	1269	5000000
149107	1268	1003907681688
149108	1269	6000000
149109	2133	8750654000
149110	2133	8749652000
149111	2133	8748650000
149112	2134	12120775000
149113	1268	1003905681688
149114	1269	7000000
149115	1268	1003903681688
149116	1269	8000000
149117	1268	1003901681688
149118	1269	9000000
149119	1268	1003899681688
149120	1269	10000000
149121	1268	1003897681688
149122	1269	11000000
149123	1268	1003895681688
149124	1269	12000000
149125	1268	1003893681688
149126	1269	13000000
149127	2132	6940955000
149128	1874	12101000
149129	2132	6939954000
149130	1439	16543957578477
149131	1439	16543975578477
149133	1397	1258231958000
149134	1678	28800895142000
149135	1268	1003891681688
149136	1269	14000000
149137	2134	12119771000
149138	2134	12118767000
149139	2134	12117763000
149140	2132	6938953000
149141	1268	1003889681688
149142	1269	15000000
149143	1268	1003887681688
149144	1269	16000000
149145	2133	8747648000
149146	1874	12117000
149147	2133	8746646000
149148	2133	8745644000
149149	1268	1003885681688
149150	1269	17000000
149151	1268	1003883681688
149152	1269	18000000
149153	1268	1003881681688
149154	1269	19000000
149155	1268	1003879681688
149156	1269	20000000
149157	1394	1147697124565200
149158	1394	1147697148565200
149183	472	66000080000000
149184	1428	2158912000000
149185	1397	1258221957000
149186	1678	28800895143000
149187	2133	8744642000
149188	1874	12123000
149189	2133	8743640000
149190	1874	12125000
149191	2132	6937952000
149192	2132	6936951000
149193	1874	12127000
149194	2134	12116759000
149195	1874	12131000
149196	2134	12115755000
149197	2134	12114751000
149198	1874	12139000
149199	2134	12113747000
149200	1980	25919652000000
149225	1444	18908067329999
149293	1397	1258161951000
149294	1678	28800895149000
149295	2134	12098687000
149296	2132	6928943000
149297	1874	12239000
149298	2132	6927942000
149299	2134	12097683000
149300	2133	8728610000
149301	2133	8727608000
149302	1759	14617359139889
149303	1759	14617375139889
149364	1397	1258121947000
149365	1678	28800895153000
149366	2132	6922937000
149367	2134	12086639000
149368	1874	12315000
149369	2132	6921936000
149370	2134	12085635000
149371	1874	12320000
149372	2134	12084631000
149373	2133	8717588000
149374	2133	8716586000
149375	2133	8715584000
149376	1874	12330000
149377	1394	1150577212565200
149378	1394	1150577230565200
149436	1397	1258071942000
149437	1678	28800895158000
149438	1397	1258061941000
149439	1678	28800895159000
149440	1397	1258051940000
149441	1678	28800895160000
149442	2132	6914929000
149443	2132	6913928000
149444	2132	6912927000
149445	2132	6911926000
149446	2134	12070575000
149447	2134	12069571000
149448	2134	12068567000
149449	2134	12067563000
149450	2134	12066559000
149451	2134	12065555000
149452	2134	12064551000
149453	1874	12442000
149454	2134	12063547000
149455	2134	12062543000
149456	2261	15119438000000
149457	2261	15119481000000
149467	1685	200885045571430
149468	1685	200885096571430
149470	1397	1258041939000
149471	1678	28800895161000
149472	2132	6910925000
149473	1874	12467000
149474	1549	17711492000000
149475	1549	17711503000000
149485	1397	1258031938000
149486	1678	28800895162000
149487	2132	6909924000
149488	2132	6908923000
149489	1874	12487000
149490	1395	58360954102457278
149499	1703	8640968000000
149591	1397	1257991934000
149592	1678	28800895166000
149593	2134	12049491000
149594	2134	12048487000
149595	1874	12557000
149596	2132	6903918000
149597	1874	12558000
149598	2132	6902917000
149599	2133	8681516000
149600	2133	8680514000
149601	2133	8679512000
149602	1874	12565000
149603	1693	13835208700785
149604	1811	2555508410581
149605	1693	13748558660920
149606	520	66933430434669
149607	1693	13661908621055
149608	191	66933430434669
149609	1693	13575258581190
149610	421	66930330434669
149611	1693	13488608541325
149346	1268	1003847681688
149347	1269	36000000
149348	1268	1003845681688
149349	1269	37000000
149350	1268	1003843681688
149351	1269	38000000
149352	1268	1003841681688
149353	1269	39000000
149354	1268	1003839681688
149355	1269	40000000
149356	1268	1003837681688
149357	1269	41000000
149358	1268	1003835681688
149359	1269	42000000
149360	2133	8719592000
149361	2133	8718590000
149362	1394	1149137183565200
149363	1394	1149137212565200
149433	2329	345607256819988
149476	2133	8695544000
149477	2133	8694542000
149478	2134	12061539000
149479	2134	12060535000
149480	1874	12479000
149481	2134	12059531000
149482	2133	8693540000
149483	1874	12485000
149484	1549	17711509000000
149491	2133	8692538000
149492	2133	8691536000
149493	2133	8690534000
149494	2134	12058527000
149495	1874	12497000
149496	2134	12057523000
149497	1588	20580927000000
149498	1588	20580944000000
149538	1759	15337411139668
149539	1796	200000007
149540	1807	200000039
149541	1571	6800869387299
149560	1397	1258001935000
149561	1678	28800895165000
149562	1693	14425726855927
149563	120	66277730799728
149564	1693	14339444422371
149565	320	66651050983763
149566	1693	14253160011985
149567	354	66279227049307
149568	1693	14166509972120
149569	663	66933430434669
149570	1693	14159944650925
149571	710	5070714426784
149572	1693	14073294611060
149573	499	66933430434669
149574	1874	12508000
149575	2132	6904919000
149576	1874	12521000
149577	2134	12052503000
149578	1874	12529000
149579	1874	12533000
149580	1874	12535000
149581	2133	8684522000
149582	1874	12537000
149583	2133	8683520000
149584	2133	8682518000
149585	2134	12051499000
149586	1874	12545000
149587	2134	12050495000
149588	1701	20158611500094
149589	1807	200000040
149590	1571	6800869387307
149617	1733	2159030000000
149723	1397	1257941929000
149724	1678	28800895171000
149725	1397	1257931928000
149726	1678	28800895172000
149727	2133	8666486000
149728	1874	12654000
149729	2134	12033427000
149730	1874	12658000
149731	2134	12032423000
149732	1874	12662000
149733	2134	12031419000
149734	576	84797836726897
149735	2133	8665484000
149736	1874	12668000
149737	2133	8664482000
149738	1874	12670000
149739	2133	8663480000
149740	2133	8662478000
149741	1874	12674000
149742	2133	8661476000
149743	2132	6894909000
149744	1874	12677000
149745	2134	12030415000
149746	1874	12681000
149747	2134	12029411000
149748	2134	12028407000
149749	1693	11884819611768
149750	450	66933430434669
149751	1693	11798169571903
149752	601	66933430434669
149753	1693	11711519532038
149754	408	66933430434669
149755	2132	6893908000
149756	1874	12690000
149757	2132	6892907000
149758	1874	12691000
149759	1693	11624674763803
149760	1821	932496362778
149761	1693	11538392837247
149762	301	66088290080033
149763	1693	11451742797382
149764	339	66933430434669
149765	1693	11365092757517
149766	186	66933170434669
149767	1693	11278442717652
149768	392	66933430434669
149769	576	85517836726897
149770	576	85517857726738
149771	1964	200000010
149772	1571	6800869387443
149776	1397	1257921927000
149777	1678	28800895173000
149778	1397	1257911926000
149779	1678	28800895174000
149780	2132	6891906000
149781	2132	6890905000
149782	1874	12693000
149783	2134	12027403000
149784	1874	12697000
149785	2132	6889904000
149786	1874	12698000
149787	2134	12026399000
149788	2134	12025395000
149789	1874	12706000
149790	2134	12024391000
149791	1874	12710000
149792	2134	12023387000
149793	1874	12714000
149794	2133	8660474000
149795	2134	12022383000
149796	1874	12720000
149797	2134	12021379000
149798	1874	12724000
149799	2134	12020375000
149800	1693	11192160791096
149801	283	66087299080033
149802	1693	11105510751231
149803	308	66933430434669
149804	1693	11018860711366
149805	2017	932029769068
149806	1693	10932210671501
149807	105	66933430434669
149808	1693	10845560631636
149809	399	66933430434669
149810	1693	10759279345643
149811	636	66276827024809
149812	1693	10756652617172
149813	721	2028285770627
149814	2133	8659472000
149815	1874	12730000
149816	2133	8658470000
149817	2133	8657468000
149818	1874	12734000
149819	1693	10670002577307
149820	206	66933430434669
149821	1693	10583352537442
149822	194	66933430434669
149823	2133	8656466000
149824	1874	12736000
149825	2133	8655464000
149826	1693	8358452287170
149827	1276	1717940411415866
149828	1693	8271802247305
149829	504	66320360434669
149830	1693	8185152207440
149831	205	66933430434669
149832	1467	11680412272861
149833	1571	6800869387451
149919	2329	346327256819988
149920	2329	346327280819988
150074	1419	31963413559748
150075	1618	2880048000000
150101	1599	24777259097983
149556	1759	15337417139808
149557	1807	200000033
149558	1964	200000002
149559	1571	6800869387267
149689	1397	1257961931000
149690	1678	28800895169000
149691	1397	1257951930000
149692	1678	28800895170000
149693	2132	6897912000
149694	2133	8671496000
149695	1874	12614000
149696	1693	12014034272372
149697	322	66933430434669
149698	1693	11971469651633
149699	10	32602533762605
149700	2132	6896911000
149701	2134	12040455000
149702	1874	12619000
149703	2134	12039451000
149704	1874	12623000
149705	2133	8670494000
149706	1874	12625000
149707	2133	8669492000
149708	1874	12627000
149709	2132	6895910000
149710	2134	12038447000
149711	1874	12632000
149712	2134	12037443000
149713	2134	12036439000
149714	1874	12640000
149715	2134	12035435000
149716	2134	12034431000
149717	1874	12648000
149718	2133	8668490000
149719	2133	8667488000
149720	369	85956809290830
149722	369	85956807290830
149773	1874	12653000
149774	2126	250025006
149775	576	85517845701738
149914	2132	6884899000
149915	1874	12801000
149916	1696	24203918335104
149921	1397	1257871922000
149922	1678	28800895178000
149923	1397	1257861921000
149924	1678	28800895179000
149925	2133	8647448000
149926	1693	6772398501842
149927	49	66933430434669
149928	1693	6685174656010
149929	603	67000861192295
149930	1874	12803000
149931	2132	6883898000
149932	1874	12804000
149933	2132	6882897000
149934	2132	6881896000
149935	1874	12806000
149936	2134	12008327000
149937	2134	12007323000
149938	1874	12814000
149939	2134	12006319000
149940	2134	12005315000
149941	1874	12822000
149942	2133	8646446000
149943	2133	8645444000
149944	1693	6598524616145
149945	54	66933430434669
149946	2133	8644442000
149947	2133	8643440000
149948	1874	12830000
149949	2133	8642438000
149950	1874	12832000
149951	1686	21992248700123
149952	1686	21992286700123
149987	1419	31243376559748
149988	1874	12506000
149989	1874	12514000
149990	1874	12532000
149991	1874	12538000
149992	1874	12540000
149993	1874	12542000
149994	1874	12544000
149995	1874	12548000
149996	1874	12550000
149997	1874	12554000
149998	1874	12560000
149999	1874	12562000
150000	1874	12564000
150001	1874	12570000
150002	1874	12572000
150003	1874	12574000
150004	1874	12586000
150005	1874	12590000
150006	1874	12606000
150007	1419	31963376559748
150008	1807	200000032
150009	2330	1104000000
150010	1419	31963599559603
150011	1527	306999943
150012	1571	6800869387331
150015	1397	1257841919000
150016	1678	28800895181000
150017	1397	1257831918000
150018	1678	28800895182000
150019	2133	8639432000
150020	1874	12851000
150021	2133	8638430000
150022	1874	12853000
150023	2132	6879894000
150024	1874	12854000
150025	2133	8637428000
150026	1874	12856000
150027	2133	8636426000
150028	2133	8635424000
150029	1874	12860000
150030	2133	8634422000
150031	1693	5762825205903
150032	245	66933430434669
150033	1693	5676175166038
150034	600	66933430434669
150035	1693	5589525126173
150036	691	66933430434669
150037	1693	5502875086308
150038	2164	932091240772
150039	1693	5416593682654
150040	165	66276917402319
150041	1693	5329943642789
150042	180	66933439434669
150043	1693	5243662239135
150044	237	66276917402319
150045	1693	5157012199270
150046	2073	931415434669
150047	2132	6878893000
150048	1874	12863000
150049	2132	6877892000
150050	1693	5154393520771
150051	748	2730688722170
150052	1693	5067743480906
150053	163	66933430434669
150054	1693	4981093441041
150055	201	66933430434669
150056	1693	4894443401176
150057	1962	932342609896
150058	2134	12001299000
150059	2134	12000295000
150060	2134	11999291000
150061	1874	12876000
150062	2134	11998287000
150063	1874	12880000
150064	2134	11997283000
150065	2134	11996279000
150066	1874	12888000
150067	1546	17517655800000
150068	1546	17517702800000
150071	1874	12616000
150072	1419	32683599559603
150073	1419	32683625559603
150126	1764	21683655100000
150274	1874	12511000
150275	1874	12547000
150276	1874	12555000
150277	2261	15839824999991
150294	1402	69304254812105
150295	1402	69304274812105
150367	1619	15120365000000
150368	1619	15120379000000
150422	1397	1257661901000
150423	1678	28800895199000
150424	2132	6852867000
150425	2133	8591336000
150426	2133	8590334000
150427	1395	58360234103457278
150428	1395	58360954103457278
150456	1397	1257641899000
150457	1678	28800895201000
150458	2132	6850865000
150459	2132	6849864000
150460	1874	13250000
150461	2132	6848863000
150462	2134	11935035000
150463	1874	13255000
150464	2134	11934031000
150465	2134	11933027000
150466	1874	13263000
149612	266	66320410434669
149613	1693	13401958501460
149614	352	66933430434669
149615	1733	2159033000000
149616	1740	19891021000000
149618	2134	12047483000
149619	1874	12569000
149620	2134	12046479000
149621	2134	12045475000
149622	1874	12577000
149623	2133	8678510000
149624	2132	6901916000
149625	1874	12580000
149626	2133	8677508000
149627	1693	13315308461595
149628	534	66933430434669
149629	1693	13229027175602
149630	327	66276827024809
149631	1693	13142377135737
149632	652	66933430434669
149633	1693	13055727095872
149634	391	66932320434669
149635	1693	12969077056007
149636	2181	931682240772
149637	1684	36003759819412
149663	1397	1257971932000
149664	1678	28800895168000
149665	1693	12449542446296
149666	309	66933429434669
149667	2134	12042463000
149668	1874	12600000
149669	2134	12041459000
149670	2132	6898913000
149671	1874	12605000
149672	2133	8674502000
149673	2133	8673500000
149674	1874	12609000
149675	2133	8672498000
149676	1874	12611000
149677	1693	12362892406431
149678	82	66933430434669
149679	1693	12276242366566
149680	361	66283428434669
149681	1693	12189592326701
149682	680	66933430434669
149683	1693	12186965598230
149684	731	2028285770627
149685	1693	12100684312237
149686	366	66276827024809
149687	1394	1153457264565200
149688	1394	1153457286565200
149836	1623	91443725898590
149888	1397	1257881923000
149889	1678	28800895177000
149890	2133	8649452000
149891	2133	8648450000
149892	1693	7146822420059
149893	611	66933430434669
149894	2134	12012343000
149895	1874	12787000
149896	2134	12011339000
149897	2134	12010335000
149898	1874	12795000
149899	2134	12009331000
149900	1693	7060172380194
149901	252	66933430434669
149902	1693	6973522340329
149903	108	66933430434669
149904	1693	6970906574971
149905	1778	7427079110417
149906	1693	6884256535106
149907	99	66933430434669
149908	1693	6859048541707
149909	35	19471543399080
149910	2132	6885900000
149911	1874	12800000
149912	1394	1154897286565200
149913	1394	1154897309565200
149953	1397	1257851920000
149954	1678	28800895180000
149955	2132	6880895000
149956	1419	31243377559748
149957	1693	6512243200731
149958	530	66855485387862
149959	1693	6425593160866
149960	217	66933430434669
149961	1693	6338943121001
149962	103	66933430434669
149963	1693	5936125285633
149964	893	311162277935181
149965	1693	5849475245768
149966	620	66933430434669
149967	2133	8641436000
149968	1874	12835000
149969	2133	8640434000
149970	1874	12837000
149971	2134	12004311000
149972	2134	12003307000
149973	1874	12845000
149974	2134	12002303000
149975	1874	12849000
149976	1419	31963377559748
149977	1796	200000010
149978	2367	100000501
149979	2221	200030000
149980	2126	250075006
149981	1807	200000070
149982	1964	200000016
149983	1419	31963387424689
149984	2332	100000300
149985	2004	200004263
149986	1571	6800869387587
150013	1650	10913080000000
150014	1650	11633089864941
150103	1397	1257811916000
150104	1678	28800895184000
150105	1693	4374911798197
150106	373	66933430434669
150107	2132	6875890000
150108	2132	6874889000
150109	1874	12909000
150110	2133	8630414000
150111	1874	12911000
150112	2134	11992263000
150113	2134	11991259000
150114	1874	12919000
150115	1693	4288261758332
150116	453	66932429434669
150117	1693	4284335802777
150118	711	3014983071021
150119	1693	4197685762912
150120	91	66933430434669
150121	1693	4111035723047
150122	438	66933430434669
150123	1693	4108408994576
150124	745	2028285770627
150125	1656	20155929499990
150127	1714	20445862171760
150128	1643	3185279064700
150129	1299	1706538047667750
150130	1397	1257801915000
150131	1678	28800895185000
150132	1397	1257791914000
150133	1678	28800895186000
150134	1397	1257781913000
150135	1678	28800895187000
150136	1397	1257771912000
150137	1678	28800895188000
150138	1693	4021758954711
150139	89	66933430434669
150140	1693	3935108914846
150141	383	66933430434669
150142	1693	3848458874981
150143	678	66933430434669
150144	2132	6873888000
150145	2134	11990255000
150146	1874	12924000
150147	2134	11989251000
150148	1874	12928000
150149	2134	11988247000
150150	2134	11987243000
150151	2132	6872887000
150152	2132	6871886000
150153	1874	12938000
150154	2132	6870885000
150155	2132	6869884000
150156	1874	12940000
150157	2132	6868883000
150158	1874	12941000
150159	2134	11986239000
150160	2134	11985235000
150161	2134	11984231000
150162	1874	12953000
150163	2134	11983227000
150164	2134	11982223000
150165	1874	12961000
150166	2134	11981219000
150167	2134	11980215000
150168	1874	12969000
150169	2134	11979211000
150170	2134	11978207000
150171	1874	12977000
150172	2134	11977203000
150173	1874	12981000
150174	2134	11976199000
150090	92	66933430434669
150091	2134	11995275000
150092	1874	12895000
150093	2134	11994271000
150094	1874	12899000
150095	2134	11993267000
150096	1874	12903000
150097	2133	8632418000
150098	1874	12905000
150099	2133	8631416000
150100	1618	2880070000000
150245	1397	1257761911000
150246	1678	28800895189000
150247	2133	8618390000
150248	1874	13009000
150249	2132	6867882000
150250	2134	11975195000
150251	1874	13014000
150252	2134	11974191000
150253	1874	13018000
150254	2134	11973187000
150255	1874	13022000
150256	2134	11972183000
150257	1874	13026000
150258	2133	8617388000
150259	1874	13028000
150260	2133	8616386000
150261	1874	13030000
150262	2261	15839489000000
150263	1796	200000016
150264	1568	350000
150265	2367	100001201
150266	2221	200080000
150267	2126	250550006
150268	1807	200000082
150269	1964	200000021
150270	2332	100001000
150271	2004	200010563
150272	2261	15839506641890
150355	1397	1257701905000
150356	1678	28800895195000
150357	2133	8603360000
150358	1874	13140000
150359	2133	8602358000
150360	2132	6858873000
150361	1874	13143000
150362	2133	8601356000
150363	1874	13145000
150364	1394	1154897300565200
150378	1397	1257691904000
150379	1678	28800895196000
150380	1397	1257681903000
150381	1678	28800895197000
150382	2132	6857872000
150383	2133	8600354000
150384	2133	8599352000
150385	1874	13150000
150386	2133	8598350000
150387	1874	13152000
150388	2133	8597348000
150389	2133	8596346000
150390	1874	13156000
150391	2133	8595344000
150392	2132	6856871000
150393	2132	6855870000
150394	1601	12626119620000
150421	1850	20136616949999
150488	1397	1257631898000
150489	1678	28800895202000
150490	2134	11925999000
150491	2134	11924995000
150492	2134	11923991000
150493	1874	13311000
150494	2133	8580314000
150495	2134	11922987000
150496	1874	13317000
150497	2134	11921983000
150498	2132	6847862000
150499	2132	6846861000
150500	2133	8579312000
150501	1701	20878611500094
150502	1701	20878630500094
150521	1684	36723759819412
150522	1684	36723777819412
150542	1699	4320393750126
150546	1397	1257601895000
150547	1678	28800895205000
150548	2133	8573300000
150549	1874	13376000
150550	2133	8572298000
150551	1874	13378000
150552	2133	8571296000
150553	2132	6842857000
150554	1874	13381000
150555	2134	11911943000
150556	1874	13385000
150557	2134	11910939000
150558	2134	11909935000
150559	2134	11908931000
150560	1426	19770546000000
150575	1397	1257581893000
150576	1678	28800895207000
150577	2132	6839854000
150578	1874	13406000
150579	2134	11906923000
150580	2134	11905919000
150581	1874	13414000
150582	2134	11904915000
150583	2134	11903911000
150584	2134	11902907000
150585	2134	11901903000
150586	1874	13432000
150587	2133	8568290000
150588	2133	8567288000
150589	2133	8566286000
150590	1706	24762456450256
150603	1397	1257561891000
150604	1678	28800895209000
150605	2133	8562278000
150606	2132	6836851000
150607	1874	13449000
150608	2133	8561276000
150609	2133	8560274000
150610	1874	13453000
150611	1705	33681205580140
150614	1397	1257551890000
150615	1678	28800895210000
150616	2132	6835850000
150617	2132	6834849000
150618	2133	8559272000
150619	1874	13457000
150620	2133	8558270000
150621	1874	13459000
150622	1850	20856587949999
150623	1850	20856601949999
150646	1397	1257531888000
150647	1678	28800895212000
150648	1397	1257521887000
150649	1678	28800895213000
150650	2132	6832847000
150651	1874	13479000
150652	2132	6831846000
150653	2132	6830845000
150654	2134	11897887000
150655	1874	13485000
150656	2134	11896883000
150657	2134	11895879000
150658	2134	11894875000
150659	2133	8554262000
150660	2133	8553260000
150661	1874	13501000
150662	2133	8552258000
150663	2134	11893871000
150664	2134	11892867000
150665	2134	11891863000
150666	1874	13515000
150667	2134	11890859000
150668	2133	8551256000
150669	2133	8550254000
150670	2133	8549252000
150671	2134	11889855000
150672	2134	11888851000
150673	2134	11887847000
150674	2134	11886843000
150675	1679	27358925656999
150737	2132	6823838000
150738	2134	11867767000
150739	1874	13646000
150740	2134	11866763000
150741	2134	11865759000
150742	1874	13654000
150743	2134	11864755000
150744	1874	13658000
150745	2132	6822837000
150746	2133	8537228000
150747	2133	8536226000
150748	2133	8535224000
150749	2132	6821836000
150750	1874	13666000
150751	2132	6820835000
150752	1874	13667000
150753	2132	6819834000
150754	2132	6818833000
150755	1874	13669000
150756	2133	8534222000
150102	1599	24777281097983
150273	2261	15839505641890
150328	1397	1257721907000
150329	1678	28800895193000
150330	2134	11957123000
150331	2134	11956119000
150332	1874	13113000
150333	2132	6861876000
150334	2134	11955115000
150335	1874	13118000
150336	2134	11954111000
150337	1622	14004157800048
150338	1622	14004172800048
150345	1397	1257711906000
150346	1678	28800895194000
150347	2134	11953107000
150348	2133	8605364000
150349	2132	6860875000
150350	1874	13135000
150351	2132	6859874000
150352	2133	8604362000
150353	1768	31427407110000
150365	1679	27358898656999
150369	1601	11906130620000
150370	1874	12581000
150371	1874	12597000
150372	1874	12599000
150373	1874	12603000
150374	1874	12613000
150375	1601	12626130620000
150376	1601	12626519619919
150377	1807	200000031
150395	1397	1257671902000
150396	1678	28800895198000
150397	2134	11952103000
150398	1874	13164000
150399	2132	6854869000
150400	2132	6853868000
150401	2134	11951099000
150402	1874	13170000
150403	2134	11950095000
150404	2133	8594342000
150405	1874	13176000
150406	2134	11949091000
150407	2134	11948087000
150408	2134	11947083000
150409	2134	11946079000
150410	2134	11945075000
150411	2134	11944071000
150412	1874	13200000
150413	2134	11943067000
150414	2134	11942063000
150415	1874	13208000
150416	2134	11941059000
150417	2133	8593340000
150418	2133	8592338000
150419	1874	13216000
150420	1850	20136587949999
150429	1397	1257651900000
150430	1678	28800895200000
150431	2133	8589332000
150432	2132	6851866000
150433	2134	11940055000
150434	2133	8588330000
150435	1874	13230000
150436	2133	8587328000
150437	1874	13232000
150438	2134	11939051000
150439	2134	11938047000
150440	1874	13240000
150441	2134	11937043000
150442	1874	13244000
150443	2134	11936039000
150444	1796	200000019
150445	1568	550000
150446	1476	20880492175114
150447	2367	100001501
150448	152	66000110200000
150449	2221	200100000
150450	2126	250950006
150451	1807	200000094
150452	1964	200000028
150453	2332	100001300
150454	2004	200014763
150455	1571	6800869387675
150503	1397	1257621897000
150504	1678	28800895203000
150505	2133	8578310000
150506	1874	13327000
150507	2133	8577308000
150508	2133	8576306000
150509	1874	13331000
150510	2132	6845860000
150511	2134	11920979000
150512	1874	13336000
150513	2134	11919975000
150514	1874	13340000
150515	2134	11918971000
150516	1874	13344000
150517	2134	11917967000
150518	1874	13348000
150519	1395	58361674103457278
150520	1395	58361674121457278
150562	1397	1257591894000
150563	1678	28800895206000
150564	2132	6841856000
150565	1874	13398000
150566	2132	6840855000
150567	2133	8570294000
150568	1874	13401000
150569	2134	11907927000
150570	2133	8569292000
150571	1610	20880503999950
150572	1610	20880518999950
150573	1874	13403000
150574	1764	21683647100000
150591	1397	1257571892000
150592	1678	28800895208000
150593	2132	6838853000
150594	2133	8565284000
150595	1874	13441000
150596	2133	8564282000
150597	1874	13443000
150598	2133	8563280000
150599	1874	13445000
150600	2132	6837852000
150601	1613	18577586400000
150602	1613	18577601400000
150676	2329	346327297819988
150721	2134	11872787000
150722	2134	11871783000
150723	1874	13622000
150724	2132	6824839000
150725	1874	13623000
150726	2133	8540234000
150727	1874	13625000
150728	2133	8539232000
150729	2133	8538230000
150730	2134	11870779000
150731	1874	13633000
150732	2134	11869775000
150733	2134	11868771000
150734	1874	13641000
150735	1622	14724175800048
150736	1622	14724184800048
150789	1397	1257481883000
150790	1678	28800895217000
150791	1397	1257471882000
150792	1678	28800895218000
150793	2132	6814829000
150794	1874	13701000
150795	2132	6813828000
150796	1874	13702000
150797	2132	6812827000
150798	2133	8520194000
150799	1874	13705000
150800	2133	8519192000
150801	1874	13707000
150802	2133	8518190000
150803	2133	8517188000
150804	1874	13711000
150805	1688	59831979702819
150806	2134	11863751000
150807	2134	11862747000
150808	1874	13719000
150809	2134	11861743000
150810	2134	11860739000
150811	2134	11859735000
150812	1874	13731000
150813	2134	11858731000
150814	2134	11857727000
150815	2134	11856723000
150816	1874	13743000
150817	2134	11855719000
150818	2134	11854715000
150819	2134	11853711000
150820	2134	11852707000
150821	2134	11851703000
150822	2134	11850699000
150823	2134	11849695000
150824	2134	11848691000
150825	2134	11847687000
150826	2134	11846683000
150827	1874	13783000
150828	2134	11845679000
150175	1874	12985000
150176	1693	3050026775845
150177	1150	616502994805690
150178	1693	2963376735980
150179	84	66933430434669
150180	1693	2877095332326
150181	2430	275707401654
150182	1693	2790445292461
150183	551	66933430434669
150184	1693	2703795252596
150185	122	66933430434669
150186	1693	2617513848942
150187	2308	274078593184
150188	1693	2530863809077
150189	653	66933430434669
150190	1693	2444213769212
150191	304	66933430434669
150192	1693	2357932470143
150193	441	66154737066764
150194	1693	2271649746142
150195	240	66277931638598
150196	1693	2185368330728
150197	262	66276893440052
150198	1693	2099086927074
150199	154	66276917402319
150200	1693	2012436887209
150201	1961	932342609896
150202	1693	1925786847344
150203	658	66933430434669
150204	1693	1839136807479
150205	660	66933430434669
150206	1693	1752486767614
150207	593	66932429434669
150208	1693	1665840688796
150209	395	66131375725798
150210	1693	1579190648931
150211	78	66933430434669
150212	1693	1569999599262
150213	29	7099000197514
150214	1693	909642825590
150215	910	509889096950029
150216	2133	8629412000
150217	1714	20445957171760
150218	2133	8628410000
150219	2133	8627408000
150220	1874	12991000
150221	2133	8626406000
150222	2133	8625404000
150223	1874	12995000
150224	2133	8624402000
150225	1874	12997000
150226	2133	8623400000
150227	2133	8622398000
150228	1874	13001000
150229	2133	8621396000
150230	1874	13003000
150231	2133	8620394000
150232	1874	13005000
150233	2133	8619392000
150234	1874	13007000
150235	1714	21165957171760
150236	1796	200000015
150237	2221	200050000
150238	2126	250325006
150239	1807	200000075
150240	1714	21165966897123
150241	1964	200000019
150242	2332	100000700
150243	2004	200008463
150244	1571	6800869387611
150278	1397	1257751910000
150279	1678	28800895190000
150280	2133	8615384000
150281	2132	6866881000
150282	1874	13033000
150283	2132	6865880000
150284	2133	8614382000
150285	1874	13036000
150286	2134	11971179000
150287	2134	11970175000
150288	1874	13044000
150289	2134	11969171000
150290	2134	11968167000
150291	2134	11967163000
150292	1768	31427392110000
150293	1768	31427412110000
150296	1397	1257741909000
150297	1678	28800895191000
150298	1397	1257731908000
150299	1678	28800895192000
150300	2132	6864879000
150301	1874	13057000
150302	2134	11966159000
150303	1874	13061000
150304	2134	11965155000
150305	1874	13065000
150306	2132	6863878000
150307	2132	6862877000
150308	2134	11964151000
150309	2134	11963147000
150310	1874	13075000
150311	2134	11962143000
150312	2133	8613380000
150313	1874	13081000
150314	2133	8612378000
150315	2133	8611376000
150316	2133	8610374000
150317	1874	13087000
150318	2133	8609372000
150319	1874	13089000
150320	2134	11961139000
150321	2134	11960135000
150322	2134	11959131000
150323	1874	13101000
150324	2134	11958127000
150325	1874	13105000
150326	1549	18431509000000
150327	1549	18431546000000
150339	2133	8608370000
150340	1874	13124000
150341	2133	8607368000
150342	1874	13126000
150343	2133	8606366000
150344	1622	14004175800048
150354	1768	31427402110000
150366	2329	346327270819988
150486	1698	20229312550062
150487	1698	20229340550062
150624	1397	1257541889000
150625	1678	28800895211000
150626	2133	8557268000
150627	1874	13461000
150628	2134	11900899000
150629	2132	6833848000
150630	2134	11899895000
150631	2133	8556266000
150632	2133	8555264000
150633	2134	11898891000
150634	1796	200000020
150635	1568	625000
150636	2367	100002101
150637	152	66000110300000
150638	2221	200130000
150639	1688	59831952702819
150640	2126	251150006
150641	1807	200000106
150642	1964	200000035
150643	2332	100001600
150644	2004	200018963
150645	1571	6800869387755
150677	1397	1257511886000
150678	1678	28800895214000
150679	2134	11885839000
150680	2132	6829844000
150681	1874	13546000
150682	2132	6828843000
150683	2132	6827842000
150684	1874	13548000
150685	2132	6826841000
150686	1874	13549000
150687	2132	6825840000
150688	2134	11884835000
150689	1874	13554000
150690	2134	11883831000
150691	1874	13558000
150692	2134	11882827000
150693	2134	11881823000
150694	1874	13566000
150695	2134	11880819000
150696	1874	13570000
150697	2134	11879815000
150698	1874	13574000
150699	2134	11878811000
150700	2134	11877807000
150701	2134	11876803000
150702	1874	13586000
150703	2134	11875799000
150704	1874	13590000
150705	2134	11874795000
150706	2134	11873791000
150707	2133	8548250000
150708	2133	8547248000
150709	1874	13602000
150710	2133	8546246000
150711	1874	13604000
150467	2134	11932023000
150468	1874	13267000
150469	2134	11931019000
150470	2134	11930015000
150471	1874	13275000
150472	2134	11929011000
150473	2134	11928007000
150474	2134	11927003000
150475	1874	13287000
150476	2133	8586326000
150477	2133	8585324000
150478	2133	8584322000
150479	1874	13293000
150480	2133	8583320000
150481	2133	8582318000
150482	2133	8581316000
150483	1874	13299000
150484	1394	1156337300565200
150485	1394	1156337328565200
150523	238	66000973695901
150524	2314	86859000000
150525	1397	1257611896000
150526	1678	28800895204000
150527	2132	6844859000
150528	1874	13349000
150529	2134	11916963000
150530	1874	13353000
150531	2134	11915959000
150532	2134	11914955000
150533	2134	11913951000
150534	2133	8575304000
150535	1874	13367000
150536	2133	8574302000
150537	1874	13369000
150538	2132	6843858000
150539	2134	11912947000
150540	1874	13374000
150541	2086	5760455300069
150543	1874	13351000
150544	1874	13354000
150545	2087	4755449147766
150561	1596	11520359000002
150612	1714	21885966897123
150613	1714	21885980897123
150769	1397	1257501885000
150770	1678	28800895215000
150771	2133	8526206000
150772	2132	6817832000
150773	2132	6816831000
150774	2133	8525204000
150775	2133	8524202000
150776	1690	191525944000000
150777	1690	191525959000000
150959	1397	1257421877000
150960	1678	28800895223000
150961	2134	11814555000
150962	1874	13941000
150963	2134	11813551000
150964	2134	11812547000
150965	1874	13949000
150966	2134	11811543000
150967	2134	11810539000
150968	1874	13957000
150969	2133	8504162000
150970	2133	8503160000
150971	2132	6805820000
150972	1874	13962000
150973	1471	22265573900000
150991	1992	1441109990000
150992	1992	1441128990000
151060	1397	1257371872000
151061	1678	28800895228000
151062	1397	1257361871000
151063	1678	28800895229000
151064	2133	8491136000
151065	1874	14064000
151066	2134	11791463000
151067	1874	14068000
151068	2134	11790459000
151069	2132	6798813000
151070	1874	14073000
151071	2132	6797812000
151072	2132	6796811000
151073	2134	11789455000
151074	2134	11788451000
151075	1874	14083000
151076	2134	11787447000
151077	1874	14087000
151078	2134	11786443000
151079	2134	11785439000
151080	2134	11784435000
151081	2134	11783431000
151082	2133	8490134000
151083	2133	8489132000
151084	2133	8488130000
151085	1874	14109000
151086	2133	8487128000
151087	1688	61272012650513
151088	1688	61272049650513
151123	1699	4320392750126
151154	1397	1257311866000
151155	1678	28800895234000
151156	2132	6789804000
151157	2132	6788803000
151158	2134	11764355000
151159	2134	11763351000
151160	2134	11762347000
151161	2134	11761343000
151162	1439	17263975578477
151163	1439	17263991578477
151171	2314	43859000000
151172	1439	16544035578477
151173	1874	13222000
151174	1874	13246000
151175	1874	13257000
151176	1874	13261000
151177	1874	13264000
151178	1874	13266000
151179	1874	13269000
151180	1874	13272000
151181	1874	13278000
151182	1874	13282000
151183	1874	13284000
151184	1874	13285000
151185	1874	13290000
151186	1874	13309000
151187	1439	17264035578477
151188	1568	475000
151189	2367	100001401
151190	2126	250925006
151191	1807	200000095
151192	1439	17264463056451
151193	2004	200011963
151194	1571	6800869387715
151251	1397	1257271862000
151252	1678	28800895238000
151253	1397	1257261861000
151254	1678	28800895239000
151255	2134	11747287000
151256	1874	14309000
151257	2134	11746283000
151258	2132	6783798000
151259	2134	11745279000
151260	2134	11744275000
151261	1874	14322000
151262	2134	11743271000
151263	2133	8465084000
151264	2133	8464082000
151265	1874	14330000
151266	2133	8463080000
151267	2133	8462078000
151268	2133	8461076000
151269	1874	14336000
151270	2133	8460074000
151271	2132	6782797000
151272	1874	14339000
151273	2132	6781796000
151274	2134	11742267000
151275	1874	14344000
151276	2134	11741263000
151277	2134	11740259000
151278	1874	14352000
151279	2134	11739255000
151280	369	86676807290830
151281	369	86676845290830
151317	1397	1257231858000
151318	1678	28800895242000
151319	2132	6777792000
151320	2133	8453060000
151321	2134	11729215000
151322	1874	14414000
151323	2134	11728211000
151324	1874	14418000
151325	2134	11727207000
151326	1874	14422000
151327	2134	11726203000
151328	2134	11725199000
151329	1874	14430000
151330	2133	8452058000
151331	1395	58363114160457072
151371	1762	14325734994000
151387	1699	4320383750126
151391	606	84046008286229
151392	2238	1002997000000
151393	1397	1257191854000
150712	2133	8545244000
150713	1874	13606000
150714	2133	8544242000
150715	1874	13608000
150716	2133	8543240000
150717	2133	8542238000
150718	1874	13612000
150719	2133	8541236000
150720	1394	1156337336565200
150788	55	68160063000000
150891	1394	1157777336565200
150892	1394	1157777354564994
150920	2134	11823591000
150921	1874	13892000
150922	1714	22605980897123
150923	1714	22606040897123
150993	1874	13963000
150994	1874	13976000
150995	1474	28610778000043
151010	1397	1257391874000
151011	1678	28800895226000
151012	2132	6801816000
151013	2134	11800499000
151014	1874	14016000
151015	2133	8497148000
151016	2133	8496146000
151017	1426	19770560000000
151018	2133	8495144000
151019	2132	6800815000
151020	1874	14023000
151021	2134	11799495000
151022	2134	11798491000
151023	1874	14031000
151024	2134	11797487000
151025	1426	20490560000000
151026	1426	20490564704350
151027	1796	200000026
151028	1568	700000
151029	2367	100002501
151030	2221	200170000
151031	2126	251375006
151032	1807	200000144
151033	2336	100000003
151034	1964	200000042
151035	2332	100002800
151036	2004	200025263
151037	1571	6800869387963
151089	1397	1257351870000
151090	1678	28800895230000
151091	2134	11782427000
151092	1874	14115000
151093	2134	11781423000
151094	2132	6795810000
151095	2132	6794809000
151096	1874	14121000
151097	2133	8486126000
151098	2133	8485124000
151099	2134	11780419000
151100	2134	11779415000
151101	1724	19133993500000
151124	1394	1157777364565200
151126	1397	1257331868000
151127	1678	28800895232000
151128	1397	1257321867000
151129	1678	28800895233000
151130	2132	6792807000
151131	2133	8482118000
151132	2132	6791806000
151133	1874	14162000
151134	2132	6790805000
151135	2134	11773391000
151136	2134	11772387000
151137	2133	8481116000
151138	2134	11771383000
151139	2134	11770379000
151140	2134	11769375000
151141	2134	11768371000
151142	2133	8480114000
151143	2133	8479112000
151144	2133	8478110000
151145	2133	8477108000
151146	2134	11767367000
151147	2134	11766363000
151148	2134	11765359000
151149	1394	1159217364565200
151150	1394	1159217402565200
151164	2133	8476106000
151165	2133	8475104000
151166	1874	14214000
151167	2133	8474102000
151168	42	80780851500000
151169	42	80780870500000
151248	1559	16866320499999
151249	1559	17586320499999
151250	1559	17586328104999
151315	1703	9360968000000
151316	1703	9361006000000
151332	1394	1160657402565200
151333	1394	1160657420565200
151390	2087	4755444147766
151499	1397	1257141849000
151500	1678	28800895251000
151501	2133	8431016000
151502	2134	11689055000
151503	2132	6764779000
151504	1874	14631000
151505	2132	6763778000
151506	2133	8430014000
151507	1874	14634000
151508	2134	11688051000
151509	1874	14638000
151510	2134	11687047000
151511	2134	11686043000
151512	1874	14646000
151513	2134	11685039000
151514	1419	33403434424689
151515	1419	33403453424689
151569	1593	20832987000000
151570	1874	14560000
151571	1874	14565000
151572	1874	14592000
151573	1874	14612000
151574	1874	14636000
151575	1874	14656000
151576	1874	14666000
151577	1874	14668000
151578	1874	14670000
151579	1874	14674000
151580	1874	14676000
151581	1874	14686000
151582	1874	14688000
151583	1874	14696000
151584	1874	14704000
151585	1593	21552987000000
151586	1568	1000000
151587	2367	100003501
151588	1593	21553052307906
151589	2221	200220000
151590	2126	252100006
151591	1807	200000172
151592	2004	200036463
151593	1571	6800869388123
151595	1397	1257101845000
151596	1678	28800895255000
151597	2132	6758773000
151598	1874	14721000
151599	2133	8421998000
151600	2133	8420996000
151601	2134	11670983000
151602	1874	14729000
151603	2134	11669979000
151604	2134	11668975000
151605	2134	11667971000
151606	1395	58363114159457072
151619	2134	11666967000
151620	2133	8419994000
151621	2133	8418992000
151622	2133	8417990000
151623	1874	14753000
151624	2133	8416988000
151625	1874	14756000
151626	2133	8415986000
151627	1874	14758000
151628	2134	11665963000
151629	1874	14762000
151630	2134	11664959000
151631	2134	11663955000
151632	2134	11662951000
151633	2134	11661947000
151634	2134	11660943000
151635	2134	11659939000
151636	2134	11658935000
151637	484	79774068000000
151638	484	79774105000000
151640	1706	25482456450256
151641	1706	25482493450256
151659	1874	14372000
151660	1874	14374000
151661	1874	14377000
151662	1874	14380000
151663	1874	14385000
151664	1874	14388000
151665	1874	14390000
151666	1874	14393000
151667	1874	14394000
150757	1874	13671000
150758	2133	8533220000
150759	2133	8532218000
150760	1874	13675000
150761	2133	8531216000
150762	2133	8530214000
150763	2133	8529212000
150764	1874	13681000
150765	2133	8528210000
150766	1874	13683000
150767	2133	8527208000
150768	1395	58361674124457278
150778	1397	1257491884000
150779	1678	28800895216000
150780	2133	8523200000
150781	2132	6815830000
150782	1874	13696000
150783	2133	8522198000
150784	1874	13698000
150785	2133	8521196000
150786	1698	20949340550062
150787	1698	20949354550062
150862	1679	27358952656999
150863	1874	13791000
150864	1874	13803000
150865	1874	13811000
150866	1874	13815000
150867	1874	13819000
150868	1874	13831000
150869	1679	28078952656999
150870	1679	28078980604685
150871	1571	6800869387851
151038	1397	1257381873000
151039	1678	28800895227000
151040	2133	8494142000
151041	1874	14037000
151042	2133	8493140000
151043	2133	8492138000
151044	2134	11796483000
151045	2134	11795479000
151046	1874	14049000
151047	2134	11794475000
151048	2134	11793471000
151049	2132	6799814000
151050	1874	14058000
151051	2134	11792467000
151052	1402	70024274812105
151053	1402	70024293811104
151054	2367	100002701
151055	1807	200000145
151056	2332	100002900
151057	2004	200025963
151104	1690	192245959000000
151105	1690	192245977000000
151125	2087	4755453147766
151152	1679	28078925656999
151153	1679	28078957656999
151221	1756	9921843570609
151222	1756	10641843570609
151314	1702	10080665000000
151352	1687	13809120648287
151354	1397	1257211856000
151355	1678	28800895244000
151356	2133	8448050000
151357	1874	14458000
151358	2133	8447048000
151359	1874	14460000
151360	2134	11720179000
151361	2134	11719175000
151362	1874	14468000
151363	2134	11718171000
151364	2134	11717167000
151365	1874	14476000
151366	2132	6774789000
151367	1874	14477000
151368	2133	8446046000
151369	1874	14479000
151370	1762	14325735994000
151388	1602	17136766169996
151389	1602	17136785169996
151407	1992	2161128990000
151408	1992	2161246990000
151411	1874	14510000
151412	1764	22403750100000
151432	1397	1257171852000
151433	1678	28800895248000
151434	2134	11702107000
151435	2133	8439032000
151436	1874	14558000
151437	2134	11701103000
151438	2134	11700099000
151439	2134	11699095000
151440	1874	14570000
151441	2132	6768783000
151442	1874	14571000
151443	2133	8438030000
151444	1874	14573000
151445	2133	8437028000
151446	1670	17281206000000
151447	1796	200000033
151448	1568	975000
151449	2367	100003801
151450	2221	200230000
151451	2126	251950006
151452	1807	200000177
151453	1670	17281223474693
151454	2332	100003500
151455	2004	200034363
151456	1571	6800869388131
151459	1397	1257161851000
151460	1678	28800895249000
151461	2132	6767782000
151462	1874	14576000
151463	2133	8436026000
151464	2133	8435024000
151465	1874	14580000
151466	2418	97000000
151467	2132	6766781000
151468	2134	11698091000
151469	1874	14585000
151470	2134	11697087000
151471	1874	14589000
151472	2134	11696083000
151473	2134	11695079000
151474	1874	14597000
151475	2134	11694075000
151476	1874	14601000
151477	1394	1162097421565200
151478	1394	1162097441565200
151480	2132	6765780000
151481	1451	11227885000000
151482	1451	11227886000000
151522	1397	1257131848000
151523	1678	28800895252000
151524	2133	8429012000
151525	2133	8428010000
151526	2132	6762777000
151527	2134	11684035000
151528	2134	11683031000
151529	2134	11682027000
151530	1613	19297601400000
151531	1613	19297617400000
151536	1397	1257121847000
151537	1678	28800895253000
151538	2134	11680019000
151539	2134	11679015000
151540	2132	6761776000
151541	1874	14680000
151542	2132	6760775000
151543	2133	8427008000
151544	1874	14683000
151545	2133	8426006000
151546	1874	14685000
151547	2133	8425004000
151548	2134	11678011000
151549	1874	14691000
151550	2134	11677007000
151551	58	86147830999641
151552	58	86147849999641
151560	2134	11676003000
151561	2134	11674999000
151562	1874	14706000
151563	1874	14708000
151564	2134	11673995000
151565	1874	14712000
151566	2134	11672991000
151567	2134	11671987000
151568	1394	1162097439565200
151594	1685	200885063571430
151607	1394	1162097438565200
151749	2087	4035520147766
151750	1874	14819000
151751	1874	14823000
151752	2087	4755520147766
151753	1796	200000034
151754	1568	1100000
151755	2367	100004001
151756	2126	252125006
151757	1807	200000184
151758	2332	100003600
151759	2087	4755541823202
151760	1571	6800869388187
151769	1397	1257011836000
151770	1678	28800895264000
151771	2133	8398952000
150829	2133	8516186000
150830	2134	11844675000
150831	1874	13793000
150832	2134	11843671000
150833	2134	11842667000
150834	1874	13801000
150835	2134	11841663000
150836	2134	11840659000
150837	1874	13809000
150838	2134	11839655000
150839	1874	13813000
150840	2134	11838651000
150841	2134	11837647000
150842	1874	13821000
150843	2134	11836643000
150844	2134	11835639000
150845	1874	13829000
150846	2134	11834635000
150847	2134	11833631000
150848	1874	13837000
150849	2134	11832627000
150850	1874	13841000
150851	1688	60551979702819
150852	1796	200000021
150853	1568	650000
150854	2367	100002201
150855	1688	60552012650513
150856	2126	251175006
150857	1807	200000116
150858	2336	100000002
150859	1964	200000040
150860	2004	200021063
150861	1571	6800869387843
150872	1397	1257461881000
150873	1678	28800895219000
150874	2134	11831623000
150875	1874	13845000
150876	2134	11830619000
150877	1874	13849000
150878	2134	11829615000
150879	1874	13853000
150880	2134	11828611000
150881	2132	6811826000
150882	1874	13858000
150883	2133	8515184000
150884	2133	8514182000
150885	2133	8513180000
150886	1395	58362394124457278
150887	1796	200000022
150888	1395	58362394142457072
150889	1807	200000121
150890	2332	100001800
150893	10	32559523762605
150894	2314	129859000000
150895	301	66002280080033
150896	2314	215859000000
150897	283	66001289080033
150898	2314	301859000000
150899	1397	1257451880000
150900	1678	28800895220000
150901	114	66001611517324
150902	2314	387859000000
150903	2134	11827607000
150904	1874	13868000
150905	2134	11826603000
150906	1874	13872000
150907	2133	8512178000
150908	1874	13874000
150909	2133	8511176000
150910	1874	13876000
150911	2133	8510174000
150912	1874	13878000
150913	2132	6810825000
150914	2134	11825599000
150915	1874	13883000
150916	2134	11824595000
150917	1874	13887000
150918	2132	6809824000
150919	484	79054068000000
150924	1397	1257441879000
150925	1678	28800895221000
150926	1397	1257431878000
150927	1678	28800895222000
150928	2132	6808823000
150929	1874	13889000
150930	2132	6807822000
150931	1874	13890000
150932	2132	6806821000
150933	1874	13895000
150934	2134	11822587000
150935	1874	13899000
150936	2134	11821583000
150937	1874	13903000
150938	2133	8509172000
150939	1874	13905000
150940	2133	8508170000
150941	2134	11820579000
150942	1874	13911000
150943	2134	11819575000
150944	1874	13915000
150945	2134	11818571000
150946	1874	13919000
150947	2134	11817567000
150948	1874	13923000
150949	2134	11816563000
150950	1874	13927000
150951	2134	11815559000
150952	1874	13931000
150953	2133	8507168000
150954	2133	8506166000
150955	1874	13935000
150956	2133	8505164000
150957	1874	13937000
150958	1451	10507885000000
150974	1397	1257411876000
150975	1678	28800895224000
150976	2133	8502158000
150977	2133	8501156000
150978	1874	13966000
150979	2133	8500154000
150980	1874	13968000
150981	2132	6804819000
150982	1874	13969000
150983	2132	6803818000
150984	2134	11809535000
150985	2134	11808531000
150986	1874	13978000
150987	2134	11807527000
150988	2134	11806523000
150989	1395	58363114142457072
150990	1395	58363114161457072
150996	1397	1257401875000
150997	1678	28800895225000
150998	2133	8499152000
150999	1874	13988000
151000	2134	11805519000
151001	2133	8498150000
151002	1874	13994000
151003	2132	6802817000
151004	2134	11804515000
151005	2134	11803511000
151006	2134	11802507000
151007	2134	11801503000
151008	1622	15444184800048
151009	1622	15444202800048
151058	1673	16055546000000
151059	1673	16055564998999
151102	1715	13703657663945
151103	1715	13703675663945
151106	2314	849000000
151107	1950	15963851000000
151108	1397	1257341869000
151109	1678	28800895231000
151110	2133	8484122000
151111	2133	8483120000
151112	2132	6793808000
151113	2134	11778411000
151114	2134	11777407000
151115	1874	14146000
151116	2134	11776403000
151117	1874	14150000
151118	2134	11775399000
151119	2134	11774395000
151120	1874	14158000
151121	2086	6480455300069
151122	2086	6480483300069
151151	1422	16794811741770
151170	1439	17263990578477
151195	689	67438422000000
151196	1876	704963880000
151197	1397	1257301865000
151198	1678	28800895235000
151199	1397	1257291864000
151200	1678	28800895236000
151201	2132	6787802000
151202	1874	14234000
151203	2134	11760339000
151204	1874	14238000
151205	2134	11759335000
151206	2134	11758331000
151207	2134	11757327000
151208	1874	14250000
151209	2132	6786801000
151210	2134	11756323000
151211	2134	11755319000
151212	2134	11754315000
151213	2134	11753311000
151214	2134	11752307000
151215	2133	8473100000
151216	2133	8472098000
151217	2133	8471096000
151218	2133	8470094000
151219	2133	8469092000
151220	1588	20581063000000
151223	1397	1257281863000
151224	1678	28800895237000
151225	2133	8468090000
151226	1394	1159217413565200
151227	2132	6785800000
151228	2132	6784799000
151229	2134	11751303000
151230	2134	11750299000
151231	2134	11749295000
151232	2134	11748291000
151233	1874	14301000
151234	2133	8467088000
151235	1874	14303000
151236	2133	8466086000
151237	1394	1160657413565200
151238	1796	200000030
151239	1568	875000
151240	2367	100003201
151241	2221	200210000
151242	2126	251550006
151243	1807	200000161
151244	1394	1160657421170200
151245	2332	100003100
151246	2004	200030163
151247	1571	6800869388043
151282	1397	1257251860000
151283	1678	28800895240000
151284	1397	1257241859000
151285	1678	28800895241000
151286	2133	8459072000
151287	2133	8458070000
151288	2133	8457068000
151289	2133	8456066000
151290	2132	6780795000
151291	1874	14365000
151292	2132	6779794000
151293	2132	6778793000
151294	1874	14367000
151295	2133	8455064000
151296	1874	14369000
151297	2133	8454062000
151298	1874	14371000
151299	2134	11738251000
151300	1874	14375000
151301	2134	11737247000
151302	2134	11736243000
151303	2134	11735239000
151304	2134	11734235000
151305	1874	14391000
151306	2134	11733231000
151307	2134	11732227000
151308	2134	11731223000
151309	1874	14403000
151310	2134	11730219000
151311	1874	14407000
151312	1547	16555015000000
151313	1547	16555053000000
151334	1397	1257221857000
151335	1678	28800895243000
151336	2133	8451056000
151337	1874	14434000
151338	2134	11724195000
151339	1874	14438000
151340	2132	6776791000
151341	1874	14439000
151342	2134	11723191000
151343	1874	14443000
151344	2134	11722187000
151345	1874	14447000
151346	2132	6775790000
151347	2133	8450054000
151348	2133	8449052000
151349	1874	14452000
151350	2134	11721183000
151351	1394	1160657421565200
151353	1874	14436000
151372	1397	1257201855000
151373	1678	28800895245000
151374	2133	8445044000
151375	2134	11716163000
151376	2134	11715159000
151377	1874	14489000
151378	2134	11714155000
151379	2133	8444042000
151380	2132	6773788000
151381	1874	14496000
151382	2132	6772787000
151383	1874	14497000
151384	2134	11713151000
151385	2134	11712147000
151386	2086	6480474300069
151406	1422	16794891741770
151413	1397	1257181853000
151414	1678	28800895247000
151415	2132	6770785000
151416	1874	14527000
151417	2418	98000000
151418	2134	11707127000
151419	1874	14531000
151420	2134	11706123000
151421	2134	11705119000
151422	1874	14539000
151423	2134	11704115000
151424	2134	11703111000
151425	2132	6769784000
151426	1874	14548000
151427	2133	8441036000
151428	2133	8440034000
151429	1874	14552000
151430	1447	23321987683000
151431	1447	24041987683000
151489	1397	1257151850000
151490	1678	28800895250000
151491	2134	11693071000
151492	2134	11692067000
151493	2134	11691063000
151494	1874	14616000
151495	2134	11690059000
151496	1874	14622000
151497	1874	14624000
151498	1451	11227903000000
151517	1685	200885064571430
151532	1874	14648000
151533	2134	11681023000
151534	1874	14671000
151535	1613	19297620400000
151553	1397	1257111846000
151554	1678	28800895254000
151555	2133	8424002000
151556	2132	6759774000
151557	1874	14698000
151558	2133	8423000000
151559	1593	21552917000000
151609	1397	1257091844000
151610	1678	28800895256000
151611	1397	1257081843000
151612	1678	28800895257000
151613	2132	6757772000
151614	2132	6756771000
151615	1874	14743000
151616	2132	6755770000
151617	1684	37443777819412
151618	1684	37443800819412
151698	1397	1257061841000
151699	1678	28800895259000
151700	1397	1257051840000
151701	1678	28800895260000
151702	2132	6752767000
151703	1874	14817000
151704	2134	11652911000
151705	2134	11651907000
151706	1874	14825000
151707	2132	6751766000
151708	2132	6750765000
151709	1874	14827000
151710	1726	114118112000
151711	2433	100000000
151712	1726	113017112000
151713	2434	100000000
151714	2133	8412980000
151715	2133	8411978000
151716	1874	14831000
151717	2133	8410976000
151718	2133	8409974000
151719	2133	8408972000
151720	2133	8407970000
151721	1684	38163800819412
151722	1796	200000035
151723	1568	1150000
151724	2367	100004101
151725	2221	200250000
151726	2126	252075006
151727	1807	200000187
151728	1684	38163833494436
151729	2332	100003900
151730	2004	200038563
151394	1678	28800895246000
151395	2134	11711143000
151396	2133	8443040000
151397	2132	6771786000
151398	2134	11710139000
151399	2134	11709135000
151400	2134	11708131000
151401	1874	14524000
151402	2418	99000000
151403	2133	8442038000
151404	1874	14526000
151405	1395	58363114260457072
151409	1764	22403634100000
151410	1764	22403752100000
151457	1675	29084748999977
151458	1675	29084766474670
151479	1739	33839916000000
151483	2133	8434022000
151484	1874	14604000
151485	2133	8433020000
151486	1874	14606000
151487	2133	8432018000
151488	1451	11227889000000
151516	1419	33403451424689
151518	1874	12620000
151519	1874	12622000
151520	1419	33403625559603
151521	1419	33403840559603
151608	1719	21598803000000
151639	1684	37443814819412
151642	1397	1257071842000
151643	1678	28800895258000
151644	2132	6754769000
151645	1874	14755000
151646	1874	14759000
151647	2133	8414984000
151648	1874	14761000
151649	2133	8413982000
151650	1874	14771000
151651	2134	11657931000
151652	2134	11656927000
151653	2134	11655923000
151654	2134	11654919000
151655	2134	11653915000
151656	2132	6753768000
151657	1709	12960283000000
151658	1709	12960316000000
151746	1395	58363114170457072
151747	1547	17275053000000
151748	1547	17275081000000
151761	1397	1257021837000
151762	1678	28800895263000
151763	2133	8401958000
151764	2133	8400956000
151765	2132	6746761000
151766	2133	8399954000
151767	1874	14859000
151768	1547	17275067000000
151880	1397	1256941829000
151881	1678	28800895271000
151882	2133	8381918000
151883	1874	15010000
151884	2134	11624799000
151885	2134	11623795000
151886	2134	11622791000
151887	2133	8380916000
151888	1874	15024000
151889	2132	6734749000
151890	2133	8379914000
151891	2134	11621787000
151892	2134	11620783000
151893	1672	20161691000000
151894	1672	20161710000000
151948	1397	1256901825000
151949	1678	28800895275000
151950	2132	6729744000
151951	1874	15080000
151952	2132	6728743000
151953	2133	8370896000
151954	2133	8369894000
151955	1874	15085000
151956	1522	18043940000000
151957	1522	18043954000000
151961	1397	1256891824000
151962	1678	28800895276000
151963	2134	11613755000
151964	2132	6727742000
151965	1874	15090000
151966	2133	8368892000
151967	2133	8367890000
151968	2134	11612751000
151969	1874	15098000
151970	2134	11611747000
151971	2134	11610743000
151972	1874	15106000
151973	2134	11609739000
151974	2134	11608735000
151975	1874	15114000
151976	2134	11607731000
151977	1874	15118000
151978	2134	11606727000
151979	1874	15122000
151980	2134	11605723000
151981	2134	11604719000
151982	1874	15130000
151983	2134	11603715000
151984	2134	11602711000
151985	2134	11601707000
151986	1571	7520869388251
151987	1571	7520895388251
152031	1673	16055564000000
152033	1397	1256861821000
152034	1678	28800895279000
152035	1397	1256851820000
152036	1678	28800895280000
152037	2133	8360876000
152038	1874	15203000
152039	2133	8359874000
152040	2133	8358872000
152041	2134	11589659000
152042	1874	15211000
152043	2134	11588655000
152044	2134	11587651000
152045	1874	15219000
152046	2134	11586647000
152047	2132	6723738000
152048	1874	15224000
152049	2132	6722737000
152050	2132	6721736000
152051	1874	15226000
152052	2134	11585643000
152053	1874	15230000
152054	2134	11584639000
152055	2134	11583635000
152056	1874	15238000
152057	2134	11582631000
152058	2134	11581627000
152059	2133	8357870000
152060	1874	15248000
152061	1395	58363834170457072
152062	1395	58363834206457072
152067	1397	1256841819000
152068	1678	28800895281000
152069	1397	1256831818000
152070	1678	28800895282000
152071	2134	11580623000
152072	2133	8356868000
152073	2133	8355866000
152074	1874	15256000
152075	2132	6720735000
152076	1874	15257000
152077	2133	8354864000
152078	1874	15259000
152079	2133	8353862000
152080	2133	8352860000
152081	1874	15263000
152082	2133	8351858000
152083	2132	6719734000
152084	1874	15266000
152085	2132	6718733000
152086	2134	11579619000
152087	1874	15271000
152088	2134	11578615000
152089	1874	15275000
152090	2134	11577611000
152091	2134	11576607000
152092	2134	11575603000
152093	1874	15287000
152094	2134	11574599000
152095	2134	11573595000
152096	2134	11572591000
152097	1992	2881246990000
152098	1992	2881284990000
152161	1397	1256791814000
152162	1678	28800895286000
152163	1397	1256781813000
152164	1678	28800895287000
152165	2134	11558535000
152166	2133	8342840000
152167	2133	8341838000
152168	1874	15380000
152169	2133	8340836000
152170	2132	6712727000
152171	2132	6711726000
152172	2132	6710725000
151668	1874	14396000
151669	1874	14409000
151670	1874	14411000
151671	1874	14413000
151672	1874	14417000
151673	1874	14423000
151674	1874	14425000
151675	1874	14427000
151676	1874	14429000
151677	1874	14433000
151678	1874	14441000
151679	1874	14449000
151680	1874	14451000
151681	1874	14455000
151682	1874	14463000
151683	1874	14465000
151684	1709	12240644000000
151685	1874	14467000
151686	1874	14471000
151687	1874	14473000
151688	1709	12960644000000
151689	1568	925000
151690	2367	100003401
151691	152	66000110400000
151692	2126	251725006
151693	1807	200000164
151694	1709	12960647670962
151695	2332	100003400
151696	2004	200033663
151697	1571	6800869388075
151732	1685	201605063571430
151733	1685	201605096246454
151790	1397	1257001835000
151791	1678	28800895265000
151792	1723	18722270085979
151793	1723	18722287085979
151810	1874	14911000
151811	1670	18001251474693
151813	1397	1256981833000
151814	1678	28800895267000
151815	2133	8390936000
151816	1874	14914000
151817	2133	8389934000
151818	1874	14916000
151819	2132	6740755000
151820	2134	11642871000
151821	2134	11641867000
151822	1874	14925000
151823	2134	11640863000
151824	1874	14929000
151825	2134	11639859000
151826	2134	11638855000
151827	1874	14937000
151828	1685	201605081571430
151862	1397	1256951830000
151863	1678	28800895270000
151864	2134	11628815000
151865	2132	6736751000
151866	1874	14991000
151867	2134	11627811000
151868	1874	14995000
151869	2134	11626807000
151870	1874	14999000
151871	2133	8383922000
151872	2133	8382920000
151873	1874	15003000
151874	2134	11625803000
151875	1874	15007000
151876	2132	6735750000
151877	1649	19191734249968
151878	1649	19191752249968
151879	1672	20161676000000
151895	1690	192965977000000
151896	1690	192965996000000
151918	1685	201605092571430
151919	1685	202325092571430
151920	1685	202325100364230
151937	2133	8373902000
151938	470	83155568999999
151939	470	83155584964999
151958	1688	61992049650513
151959	1688	61992063650513
151988	2134	11600703000
151989	2134	11599699000
151990	1874	15150000
151991	1688	62712063650513
151992	1688	62712091650513
152011	1980	26639652000000
152012	1980	26639674000000
152028	1686	22712286700123
152029	1686	22712304700123
152228	1397	1256771812000
152229	1678	28800895288000
152230	1397	1256761811000
152231	1678	28800895289000
152232	2132	6709724000
152233	1874	15422000
152234	2134	11549499000
152235	2134	11548495000
152236	1874	15430000
152237	2134	11547491000
152238	1874	15434000
152239	2132	6708723000
152240	2134	11546487000
152241	2134	11545483000
152242	2134	11544479000
152243	2133	8337830000
152244	2133	8336828000
152245	2133	8335826000
152246	2133	8334824000
152247	2133	8333822000
152248	2132	6707722000
152249	2134	11543475000
152250	1874	15462000
152251	2134	11542471000
152252	1874	15466000
152253	2134	11541467000
152254	1439	17264012578477
152270	1623	91443699898598
152284	1397	1256731808000
152285	1678	28800895292000
152286	2134	11531427000
152287	2132	6703718000
152288	1874	15524000
152289	2134	11530423000
152290	2134	11529419000
152291	2134	11528415000
152292	2134	11527411000
152293	1656	20155924499990
152309	1671	22704424003785
152311	1397	1256711806000
152312	1678	29520912294000
152313	1397	1256701805000
152314	1678	29520912295000
152315	2134	11522391000
152316	2134	11521387000
152317	2134	11520383000
152318	2132	6701716000
152319	2132	6700715000
152320	2261	15839530641890
152321	2134	11519379000
152322	2134	11518375000
152323	2133	8323802000
152324	2134	11517371000
152325	2134	11516367000
152326	2134	11515363000
152327	2132	6699714000
152328	2133	8322800000
152329	2133	8321798000
152330	2133	8320796000
152331	1874	15608000
152332	2133	8319794000
152333	2134	11514359000
152334	2261	16559530641890
152335	1796	200000041
152336	1568	1450000
152337	2367	100005501
152338	2221	200310000
152339	2126	252450006
152340	1807	200000236
152341	2332	100005100
152342	2004	200039425
152343	2261	16559542381228
152344	1571	7520895388379
152348	1397	1256691804000
152349	1678	29520912296000
152350	2133	8318792000
152351	1874	15616000
152352	2133	8317790000
152353	2134	11513355000
152354	1874	15622000
152355	2132	6698713000
152356	2134	11512351000
152357	2134	11511347000
152358	2134	11510343000
152359	2132	6697712000
152360	2133	8316788000
152361	1874	15638000
152362	1568	1475000
152363	1593	21552922925000
152364	2126	252500006
152390	1397	1256681803000
152391	1678	29520912297000
152392	2134	11509339000
152393	2134	11508335000
151731	1571	6800869388195
151734	1397	1257041839000
151735	1678	28800895261000
151736	1397	1257031838000
151737	1678	28800895262000
151738	2132	6749764000
151739	2132	6748763000
151740	2132	6747762000
151741	2133	8406968000
151742	2133	8405966000
151743	2133	8404964000
151744	2133	8403962000
151745	2133	8402960000
151829	1397	1256971832000
151830	1678	28800895268000
151831	1397	1256961831000
151832	1678	28800895269000
151833	2133	8388932000
151834	1874	14939000
151835	2132	6739754000
151836	2132	6738753000
151837	1874	14941000
151838	2132	6737752000
151839	1874	14942000
151840	2134	11637851000
151841	1874	14946000
151842	2133	8387930000
151843	1874	14948000
151844	2134	11636847000
151845	2134	11635843000
151846	2133	8386928000
151847	1874	14958000
151848	2133	8385926000
151849	1874	14960000
151850	2133	8384924000
151851	2134	11634839000
151852	1874	14966000
151853	2134	11633835000
151854	2134	11632831000
151855	1874	14974000
151856	2134	11631827000
151857	2134	11630823000
151858	1874	14982000
151859	2134	11629819000
151860	1622	16164202800048
151861	1622	16164239800048
151960	43	83280309890000
151993	1397	1256881823000
151994	1678	28800895277000
151995	2134	11598695000
151996	1874	15154000
151997	2133	8366888000
151998	1874	15156000
151999	2132	6726741000
152000	2133	8365886000
152001	1874	15159000
152002	2133	8364884000
152003	1874	15161000
152004	2132	6725740000
152005	2134	11597691000
152006	2134	11596687000
152007	2134	11595683000
152008	2134	11594679000
152009	1587	21600578750000
152010	1587	21600600750000
152013	1397	1256871822000
152014	1678	28800895278000
152015	2133	8363882000
152016	2134	11593675000
152017	2132	6724739000
152018	1874	15185000
152019	2134	11592671000
152020	1874	15189000
152021	2134	11591667000
152022	1874	15193000
152023	2134	11590663000
152024	2133	8362880000
152025	2133	8361878000
152026	1588	21301063000000
152027	1588	21301081000000
152065	1874	15209000
152066	1560	19448907131803
152138	1397	1256801815000
152139	1678	28800895285000
152140	2134	11562551000
152141	2133	8345846000
152142	1874	15354000
152143	2133	8344844000
152144	2133	8343842000
152145	2132	6714729000
152146	1874	15359000
152147	2134	11561547000
152148	1874	15363000
152149	2134	11560543000
152150	2134	11559539000
152151	1874	15371000
152152	2132	6713728000
152153	1394	1163537459565200
152154	1394	1163537478565191
152155	2004	200039335
152160	1476	21600511175105
152184	1719	22318803000000
152185	1719	22318840000000
152188	1874	14953000
152189	1874	14961000
152190	1874	14963000
152191	1874	14969000
152192	1874	14971000
152193	1874	14977000
152194	1874	14979000
152195	1874	14985000
152196	1874	14987000
152197	1874	14989000
152198	58	86148075999641
152199	1874	14997000
152200	1874	15009000
152201	1874	15013000
152202	1874	15017000
152203	1874	15021000
152204	1874	15057000
152205	1874	15077000
152206	1874	15093000
152207	1874	15097000
152208	1874	15109000
152209	1874	15121000
152210	1874	15125000
152211	1874	15133000
152212	1874	15137000
152213	1874	15141000
152214	1874	15153000
152215	1874	15213000
152216	1874	15217000
152217	1874	15229000
152218	1874	15241000
152219	1874	15245000
152220	58	86868075999641
152221	1568	1225000
152222	2367	100004601
152223	1807	200000195
152224	58	86868150747275
152225	2332	100004300
152226	2004	200039972
152227	1571	6800869388243
152258	1397	1256751810000
152259	1678	28800895290000
152260	2132	6706721000
152261	2134	11540463000
152262	2134	11539459000
152263	2133	8332820000
152264	2133	8331818000
152265	2134	11538455000
152266	2134	11537451000
152267	2134	11536447000
152268	1768	32147407110000
152269	1768	32147430110000
152297	1397	1256721807000
152298	1678	28800895293000
152299	2134	11526407000
152300	2134	11525403000
152301	2133	8325806000
152302	2133	8324804000
152303	2132	6702717000
152304	2134	11524399000
152305	2134	11523395000
152306	1874	15565000
152307	1678	29520895293000
152308	1678	29520912293000
152345	1690	192246002000000
152346	1690	192966002000000
152347	1690	192966013739338
152487	1684	38883833494436
152488	1684	38883851494436
152616	2292	3599133000000
152617	1747	10146179599975
152766	1992	1236990000
152767	596	86338432000000
152768	1397	1256441779000
152769	1678	29520912321000
152770	1397	1256431778000
152771	1678	29520912322000
152772	2134	11402915000
152773	2134	11401911000
152774	2134	11400907000
152775	2134	11399903000
152776	2132	6661676000
151772	1874	14861000
151773	2132	6745760000
151774	2133	8397950000
151775	2132	6744759000
151776	2133	8396948000
151777	1672	19441676000000
151778	1672	19441691000000
151779	2132	6743758000
151780	2134	11650903000
151781	2134	11649899000
151782	2133	8395946000
151783	2133	8394944000
151784	1874	14880000
151785	2134	11648895000
151786	1874	14884000
151787	2134	11647891000
151788	1710	18234139414140
151789	1710	18234146414140
151794	1397	1256991834000
151795	1678	28800895266000
151796	2134	11646887000
151797	2132	6742757000
151798	1874	14893000
151799	2132	6741756000
151800	2133	8393942000
151801	1874	14896000
151802	2133	8392940000
151803	1874	14898000
151804	2133	8391938000
151805	2134	11645883000
151806	2134	11644879000
151807	2134	11643875000
151808	1670	18001223474693
151809	1670	18001252474693
151812	414	66720040000000
151897	1397	1256931828000
151898	1678	28800895272000
151899	2133	8378912000
151900	1559	17586339104999
151901	2132	6733748000
151902	2134	11619779000
151903	2132	6732747000
151904	2133	8377910000
151905	2133	8376908000
151906	2134	11618775000
151907	2134	11617771000
151908	2134	11616767000
151909	1559	18306339104999
151910	1568	1275000
151911	2367	100005001
151912	1559	18306346897799
151913	2221	200280000
151914	1807	200000204
151915	2332	100004400
151916	2004	200039290
151917	1571	6800869388251
151921	1397	1256921827000
151922	1678	28800895273000
151923	2134	11615763000
151924	1874	15063000
151925	2134	11614759000
151926	1874	15067000
151927	2133	8375906000
151928	1874	15069000
151929	2133	8374904000
151930	2132	6731746000
151931	1874	15072000
151932	1796	200000036
151933	1394	1162097421565199
151934	2221	200290000
151935	2126	252150006
151936	1394	1162097436530199
151940	1397	1256911826000
151941	1678	28800895274000
151942	2133	8372900000
151943	2133	8371898000
151944	1874	15078000
151945	2132	6730745000
151946	1693	1629642825590
151947	1693	1629655825590
152030	1679	28078943656999
152032	1686	22712300700123
152063	1560	19448880131803
152064	1560	19448916131803
152099	1394	1162097459565200
152100	1397	1256821817000
152101	1678	28800895283000
152102	1397	1256811816000
152103	1678	28800895284000
152104	2133	8350856000
152105	1874	15301000
152106	1980	25919673000000
152107	2132	6717732000
152108	2132	6716731000
152109	2133	8349854000
152110	2134	11571587000
152111	1874	15309000
152112	2134	11570583000
152113	2134	11569579000
152114	1874	15317000
152115	2134	11568575000
152116	2134	11567571000
152117	2134	11566567000
152118	2134	11565563000
152119	2134	11564559000
152120	2134	11563555000
152121	2132	6715730000
152122	1874	15342000
152123	2133	8348852000
152124	2133	8347850000
152125	2133	8346848000
152126	1874	15348000
152127	1980	26639673000000
152128	1796	200000037
152129	1568	1400000
152130	2367	100005301
152131	1980	26639688764171
152132	2221	200300000
152133	2126	252250006
152134	1807	200000224
152135	2332	100004800
152136	2004	200039326
152137	1571	7520895388323
152156	1874	15357000
152157	1874	15369000
152158	1476	21600492175114
152159	1476	21600510175105
152310	1671	22704426003785
152422	1397	1256661801000
152423	1678	29520912299000
152424	1397	1256651800000
152425	1678	29520912300000
152426	2133	8311778000
152427	1874	15687000
152428	2132	6693708000
152429	1874	15688000
152430	2132	6692707000
152431	2132	6691706000
152432	1874	15690000
152433	2133	8310776000
152434	1874	15692000
152435	2133	8309774000
152436	2133	8308772000
152437	2133	8307770000
152438	2133	8306768000
152439	1874	15700000
152440	2134	11500303000
152441	2134	11499299000
152442	2134	11498295000
152443	2134	11497291000
152444	2134	11496287000
152445	1874	15720000
152446	2134	11495283000
152447	2134	11494279000
152448	2134	11493275000
152449	2134	11492271000
152450	1874	15736000
152451	1602	17856766169996
152452	1602	17856804169996
152489	1397	1256621797000
152490	1678	29520912303000
152491	1397	1256611796000
152492	1678	29520912304000
152493	1397	1256601795000
152494	1678	29520912305000
152495	2132	6687702000
152496	2134	11482231000
152497	1874	15790000
152498	2133	8300756000
152499	1874	15792000
152500	2133	8299754000
152501	1874	15794000
152502	2133	8298752000
152503	2133	8297750000
152504	2133	8296748000
152505	1874	15800000
152506	2133	8295746000
152507	2133	8294744000
152508	2133	8293742000
152509	1874	15806000
152510	2134	11481227000
152511	2134	11480223000
152512	1874	15814000
152513	2134	11479219000
152514	1874	15818000
152173	2133	8339834000
152174	2133	8338832000
152175	2134	11557531000
152176	2134	11556527000
152177	2134	11555523000
152178	2134	11554519000
152179	2134	11553515000
152180	2134	11552511000
152181	2134	11551507000
152182	2134	11550503000
152183	1395	58363834207457072
152186	58	86867849999641
152187	58	86867886999641
152255	1874	15452000
152256	1874	15460000
152257	1439	17264007578477
152271	1397	1256741809000
152272	1678	28800895291000
152273	2134	11535443000
152274	2134	11534439000
152275	2134	11533435000
152276	2133	8330816000
152277	2133	8329814000
152278	2133	8328812000
152279	2132	6705720000
152280	2134	11532431000
152281	1874	15518000
152282	2132	6704719000
152283	1705	33681210580140
152294	2133	8327810000
152295	1874	15526000
152296	2133	8326808000
152365	1678	28800895294000
152366	1678	28800895295000
152367	1678	28800895296000
152368	1874	14727000
152369	1874	14739000
152370	1568	1025000
152371	2367	100003601
152372	1593	21553484282802
152373	1807	200000176
152374	1874	14750000
152375	1874	14764000
152376	1874	14773000
152377	1874	14781000
152378	1874	14793000
152379	1874	14845000
152380	1874	14869000
152381	1874	14877000
152382	1874	14889000
152383	1593	22273484282802
152384	2367	100003901
152385	1593	22273546812190
152386	152	66000112100000
152387	2221	200260000
152388	2143	200400000
152389	2004	200041363
152404	1397	1256671802000
152405	1678	29520912298000
152406	2133	8313782000
152407	1874	15665000
152408	2132	6695710000
152409	1874	15666000
152410	2132	6694709000
152411	2134	11504319000
152412	1874	15671000
152413	2134	11503315000
152414	1874	15675000
152415	2134	11502311000
152416	1874	15679000
152417	2134	11501307000
152418	2133	8312780000
152419	1874	15685000
152420	1723	18722288085979
152453	1688	62712101650513
152471	1397	1256631798000
152472	1678	29520912302000
152473	2132	6689704000
152474	2132	6688703000
152475	1874	15765000
152476	2133	8302760000
152477	2134	11486247000
152478	1874	15771000
152479	2134	11485243000
152480	2134	11484239000
152481	1874	15779000
152482	2134	11483235000
152483	2133	8301758000
152484	1874	15785000
152485	1709	13680316000000
152486	1709	13680334000000
152535	1397	1256591794000
152536	1678	29520912306000
152537	2133	8292740000
152538	2133	8291738000
152539	2132	6683698000
152540	2132	6682697000
152541	1874	15867000
152542	2134	11468175000
152543	1874	15871000
152544	2134	11467171000
152545	2134	11466167000
152546	2134	11465163000
152547	1568	1650000
152548	2367	100006101
152549	2221	200350000
152550	2126	252550006
152551	1807	200000260
152552	1394	1163537477299216
152553	2332	100005400
152554	2004	200039443
152555	1571	7520895388419
152632	606	84766024286229
152635	1474	28610775000043
152644	1608	20298670000000
152684	1710	18954146414140
152685	1710	18954183414140
152745	1397	1256451780000
152746	1678	29520912320000
152747	2134	11406931000
152748	2132	6662677000
152749	1874	16201000
152750	1726	111916112000
152751	2435	100000000
152752	1726	110815112000
152753	2436	100000000
152754	2134	11405927000
152755	1874	16205000
152756	2134	11404923000
152757	2134	11403919000
152758	2133	8257670000
152759	1874	16215000
152760	2133	8256668000
152761	1874	16217000
152762	1688	63432099545072
152763	1688	63432118545072
152798	1719	23758859000000
152799	1719	23758908000000
152862	1688	63432137545072
152879	497	67437010000000
152880	497	67437029000000
152910	1549	19151546000000
152911	1549	19151580854742
152997	1602	18576804169996
152998	1602	18576841169996
153029	2133	8217590000
153030	2133	8216588000
153031	2134	11336651000
153032	2134	11335647000
153033	1874	16591000
153034	2133	8215586000
153035	1874	16593000
153036	2133	8214584000
153037	2133	8213582000
153038	2133	8212580000
153039	1874	16599000
153040	2133	8211578000
153041	1874	16601000
153042	2133	8210576000
153043	2133	8209574000
153044	1874	16607000
153045	1874	16608000
153046	1874	16610000
153047	2134	11334643000
153048	2134	11333639000
153049	1874	16618000
153050	2134	11332635000
153051	1874	16622000
153052	2134	11331631000
153053	2134	11330627000
153054	2134	11329623000
153055	2134	11328619000
153056	1874	16638000
153057	2134	11327615000
153058	2134	11326611000
153059	2134	11325607000
153060	1874	16650000
153061	2134	11324603000
153062	2134	11323599000
153063	1874	16658000
153064	1657	13681562990100
153163	1397	1256211756000
153164	1678	29520912344000
153165	2133	8196548000
153166	2133	8195546000
152394	2132	6696711000
152395	2133	8315786000
152396	2133	8314784000
152397	2134	11507331000
152398	2134	11506327000
152399	1874	15659000
152400	2134	11505323000
152401	1874	15663000
152402	1685	202325081571430
152403	1685	202325099571430
152421	1874	15684000
152454	1397	1256641799000
152455	1678	29520912301000
152456	2133	8305766000
152457	2132	6690705000
152458	1874	15739000
152459	2134	11491267000
152460	2134	11490263000
152461	1874	15747000
152462	2134	11489259000
152463	2134	11488255000
152464	1874	15755000
152465	2134	11487251000
152466	2133	8304764000
152467	2133	8303762000
152468	1874	15763000
152469	1679	28798943656999
152470	1679	28798962656999
152556	1397	1256581793000
152557	1678	29520912307000
152558	2133	8290736000
152559	2133	8289734000
152560	2133	8288732000
152561	2132	6681696000
152562	2134	11464159000
152563	2134	11463155000
152564	2134	11462151000
152565	2134	11461147000
152566	1610	20880521999950
152661	1397	1256501785000
152662	1678	29520912315000
152663	1397	1256491784000
152664	1678	29520912316000
152665	2132	6670685000
152666	2133	8270696000
152667	2133	8269694000
152668	2133	8268692000
152669	2133	8267690000
152670	2133	8266688000
152671	2134	11429019000
152672	2134	11428015000
152673	2134	11427011000
152674	2134	11426007000
152675	2132	6669684000
152676	2132	6668683000
152677	2134	11425003000
152678	2134	11423999000
152679	2134	11422995000
152680	2134	11421991000
152681	2134	11420987000
152682	1395	58364554192457072
152683	1395	58364554229457072
152722	1397	1256461781000
152723	1678	29520912319000
152724	2134	11411951000
152725	2133	8260676000
152726	2133	8259674000
152727	2133	8258672000
152728	2134	11410947000
152729	2134	11409943000
152730	1874	16186000
152731	2132	6664679000
152732	2134	11408939000
152733	2134	11407935000
152734	2132	6663678000
152735	1874	16196000
152736	1622	16884239800048
152737	1622	16884259774848
152738	2367	100006301
152739	2126	252625006
152740	2332	100005800
152743	1419	34123840559603
152744	1419	34123842559603
152764	1719	23038840000000
152765	1719	23038859000000
152802	1397	1256421777000
152803	1678	29520912323000
152804	1397	1256411776000
152805	1678	29520912324000
152806	2133	8249654000
152807	1874	16270000
152808	2132	6658673000
152809	2134	11393879000
152810	355	66000099000000
152811	1726	109613112000
152812	2437	100000000
152813	2134	11392875000
152814	2134	11391871000
152815	2134	11390867000
152816	2134	11389863000
152817	1874	16291000
152818	2134	11388859000
152819	2134	11387855000
152820	2134	11386851000
152821	1874	16303000
152822	2134	11385847000
152823	2133	8248652000
152824	2133	8247650000
152825	2133	8246648000
152826	2133	8245646000
152827	2132	6657672000
152828	2132	6656671000
152829	1874	16317000
152830	1684	38883872494436
152833	1397	1256401775000
152834	1678	29520912325000
152835	1397	1256391774000
152836	1678	29520912326000
152837	2041	2879000000000
152838	155	66000435000000
152839	2132	6655670000
152840	2132	6654669000
152841	1874	16319000
152842	2132	6653668000
152843	2134	11384843000
152844	1874	16324000
152845	2134	11383839000
152846	1874	16328000
152847	2134	11382835000
152848	2134	11381831000
152849	2133	8244644000
152850	1874	16338000
152851	2133	8243642000
152852	2133	8242640000
152853	2133	8241638000
152854	2133	8240636000
152855	2134	11380827000
152856	2134	11379823000
152857	1874	16354000
152858	2134	11378819000
152859	2134	11377815000
152860	2134	11376811000
152861	1684	38883871494436
152912	1397	1256351770000
152913	1678	29520912330000
152914	2134	11362755000
152915	2133	8232620000
152916	2133	8231618000
152917	2132	6648663000
152918	1874	16445000
152919	2132	6647662000
152920	2134	11361751000
152921	2134	11360747000
152922	2134	11359743000
152923	155	66000334000000
152924	2041	2879100000000
152925	42	81500870500000
152926	42	81500889500000
152929	1397	1256341769000
152930	1678	29520912331000
152931	1397	1256331768000
152932	1678	29520912332000
152933	2134	11358739000
152934	2132	6646661000
152935	1874	16463000
152936	2133	8230616000
152937	2133	8229614000
152938	1874	16467000
152939	2133	8228612000
152940	1874	16469000
152941	2133	8227610000
152942	2133	8226608000
152943	1874	16473000
152944	2133	8225606000
152945	1874	16475000
152946	2134	11357735000
152947	1874	16479000
152948	2132	6645660000
152949	2134	11356731000
152950	2134	11355727000
152951	2134	11354723000
152952	2134	11353719000
152953	2134	11352715000
152954	2132	6644659000
152955	2134	11351711000
152515	2134	11478215000
152516	1874	15822000
152517	2134	11477211000
152518	2132	6686701000
152519	2132	6685700000
152520	1874	15828000
152521	2132	6684699000
152522	2134	11476207000
152523	2134	11475203000
152524	1874	15837000
152525	2134	11474199000
152526	1874	15841000
152527	2134	11473195000
152528	2134	11472191000
152529	2134	11471187000
152530	1874	15853000
152531	2134	11470183000
152532	2134	11469179000
152533	2329	345607312819988
152534	2329	346327312819988
152567	1397	1256571792000
152568	1678	29520912308000
152569	2134	11460143000
152570	2134	11459139000
152571	2132	6680695000
152572	2134	11458135000
152573	2133	8287730000
152574	2134	11457131000
152575	2134	11456127000
152576	2133	8286728000
152577	1394	1164977477299216
152578	1394	1164977495299216
152579	1397	1256561791000
152580	1678	29520912309000
152581	1397	1256551790000
152582	1678	29520912310000
152583	1397	1256541789000
152584	1678	29520912311000
152585	2132	6679694000
152586	2133	8285726000
152587	2132	6678693000
152588	2132	6677692000
152589	2132	6676691000
152590	2132	6675690000
152591	2133	8284724000
152592	2133	8283722000
152593	2133	8282720000
152594	2133	8281718000
152595	2133	8280716000
152596	2133	8279714000
152597	2133	8278712000
152598	2133	8277710000
152599	2134	11455123000
152600	2134	11454119000
152601	2134	11453115000
152602	2134	11452111000
152603	2134	11451107000
152604	2134	11450103000
152605	2134	11449099000
152606	2134	11448095000
152607	2134	11447091000
152608	2134	11446087000
152609	2134	11445083000
152610	1874	15998000
152611	2134	11444079000
152612	1874	16002000
152613	2134	11443075000
152614	1672	20881710000000
152615	1672	20881767000000
152618	1547	17995067000000
152619	1547	17995124000000
152620	1397	1256531788000
152621	1678	29520912312000
152622	2134	11442071000
152623	2133	8276708000
152624	1874	16012000
152625	2134	11441067000
152626	2134	11440063000
152627	2134	11439059000
152628	2133	8275706000
152629	2132	6674689000
152630	606	84766008286229
152631	606	84766025286229
152633	1874	16007000
152634	606	84766019286229
152636	1397	1256521787000
152637	1678	29520912313000
152638	2133	8274704000
152639	2132	6673688000
152640	2132	6672687000
152641	2133	8273702000
152642	1608	20298656000000
152643	1608	20298671000000
152645	1397	1256511786000
152646	1678	29520912314000
152647	2134	11438055000
152648	2134	11437051000
152649	2134	11436047000
152650	2134	11435043000
152651	2134	11434039000
152652	2134	11433035000
152653	2134	11432031000
152654	2134	11431027000
152655	2134	11430023000
152656	2133	8272700000
152657	2133	8271698000
152658	2132	6671686000
152659	1874	16074000
152660	1395	58363834192457072
152686	1397	1256481783000
152687	1678	29520912317000
152688	1397	1256471782000
152689	1678	29520912318000
152690	2133	8265686000
152691	2132	6667682000
152692	1688	61992085650513
152693	2133	8264684000
152694	2134	11419983000
152695	1874	16132000
152696	2134	11418979000
152697	1874	16136000
152698	2132	6666681000
152699	2132	6665680000
152700	1874	16138000
152701	2133	8263682000
152702	2133	8262680000
152703	2133	8261678000
152704	2134	11417975000
152705	1874	16148000
152706	2134	11416971000
152707	2134	11415967000
152708	2134	11414963000
152709	2134	11413959000
152710	2134	11412955000
152711	1874	16168000
152712	1688	62712085650513
152713	1796	200000044
152714	1568	1675000
152715	2367	100006201
152716	2221	200380000
152717	1688	62712099545072
152718	2126	252600006
152719	1807	200000264
152720	2332	100005700
152721	2004	200039479
152741	1419	34123451424689
152742	1419	34123471399489
152800	2329	347047312819988
152801	2329	347047361819988
152863	1723	19442288085979
152864	1723	19442326085979
152882	1397	1256371772000
152883	1678	29520912328000
152884	1397	1256361771000
152885	1678	29520912329000
152886	2133	8236628000
152887	2132	6650665000
152888	2132	6649664000
152889	2133	8235626000
152890	2133	8234624000
152891	2133	8233622000
152892	2134	11371791000
152893	2134	11370787000
152894	2134	11369783000
152895	2134	11368779000
152896	2134	11367775000
152897	2134	11366771000
152898	2134	11365767000
152899	2134	11364763000
152900	2134	11363759000
152901	1394	1166417495299216
152902	1796	200000046
152903	1568	1750000
152904	2367	100006501
152905	2221	200400000
152906	2126	252675006
152907	1807	200000275
152908	1394	1166417530153958
152909	2004	200039524
152961	1549	19871580854742
152962	1549	19871618854742
152999	1397	1256301765000
153000	1678	29520912335000
153001	2133	8219594000
153002	2132	6640655000
152777	2133	8255666000
152778	2133	8254664000
152779	1874	16238000
152780	2133	8253662000
152781	1874	16240000
152782	2133	8252660000
152783	1726	110714112000
152784	355	66000100000000
152785	2133	8251658000
152786	2133	8250656000
152787	2134	11398899000
152788	1874	16250000
152789	2134	11397895000
152790	2134	11396891000
152791	2134	11395887000
152792	2134	11394883000
152793	2132	6660675000
152794	2132	6659674000
152795	1874	16268000
152796	369	87396845290830
152797	369	87396894290830
152831	1708	20520832181790
152832	1694	20699172197225
152865	1397	1256381773000
152866	1678	29520912327000
152867	2132	6652667000
152868	1874	16367000
152869	2132	6651666000
152870	2134	11375807000
152871	2133	8239634000
152872	2133	8238632000
152873	2133	8237630000
152874	2134	11374803000
152875	2134	11373799000
152876	2134	11372795000
152877	1768	32867430110000
152878	1768	32867449110000
152881	1698	21669354550062
152927	1685	203045099571430
152928	1685	203045118571430
152963	1693	2349655825590
152964	1693	2349693825590
153065	1397	1256261761000
153066	1678	29520912339000
153067	2133	8208572000
153068	2132	6634649000
153069	1874	16661000
153070	2133	8207570000
153071	1874	16663000
153072	2134	11322595000
153073	2134	11321591000
153074	1874	16671000
153075	2112	31487142101924
153076	2134	11320587000
153077	2134	11319583000
153078	1874	16679000
153079	2112	32207142101924
153080	1796	200000049
153081	2112	32207144066403
153082	1568	1775000
153083	2221	200410000
153084	1807	200000284
153085	2332	100006300
153086	2004	200039533
153087	1397	1256251760000
153088	1678	29520912340000
153089	2133	8206568000
153090	1874	16681000
153091	2133	8205566000
153092	2133	8204564000
153093	2134	11318579000
153094	1874	16689000
153095	2134	11317575000
153096	2134	11316571000
153097	1874	16697000
153098	2134	11315567000
153099	2132	6633648000
153100	1874	16702000
153101	1796	200000050
153102	1723	19442288085978
153103	2367	100006601
153104	1723	19442306085766
153105	1807	200000287
153106	2332	100006400
153107	2004	200039542
153126	1397	1256231758000
153127	1678	29520912342000
153128	2132	6630645000
153129	2133	8201558000
153130	2134	11309543000
153131	2134	11308539000
153132	2133	8200556000
153133	2134	11307535000
153134	1874	16745000
153135	2134	11306531000
153136	1874	16749000
153137	1395	58366714286457072
153138	1395	58366714303457072
153149	2134	11305527000
153150	2134	11304523000
153151	2134	11303519000
153152	1874	16765000
153153	2134	11302515000
153154	1874	16769000
153155	2134	11301511000
153156	1874	16775000
153157	1874	16777000
153158	1395	58367434303457072
153159	1395	58367434323457072
153175	1533	717960000000
153176	455	66002000000000
153177	1533	715910000000
153178	707	9002150000000
153179	1397	1256201755000
153180	1678	29520912345000
153181	2133	8194544000
153182	2133	8193542000
153183	1874	16802000
153184	2134	11296491000
153185	1874	16806000
153186	2134	11295487000
153187	2134	11294483000
153188	1874	16814000
153189	2134	11293479000
153190	1874	16818000
153191	2132	6626641000
153192	2132	6625640000
153193	1874	16820000
153194	1672	20881828000000
153229	1397	1256171752000
153230	1678	29520912348000
153231	2134	11283439000
153232	2133	8187530000
153233	2133	8186528000
153234	2132	6621636000
153235	1874	16878000
153236	2134	11282435000
153237	2133	8185526000
153238	2134	11281431000
153239	2134	11280427000
153240	1547	18715124000000
153241	1547	18715142000000
153314	1397	1256131748000
153315	1678	29520912352000
153316	1397	1256121747000
153317	1678	29520912353000
153318	1397	1256111746000
153319	1678	29520912354000
153320	2133	8176508000
153321	1874	16967000
153322	2132	6615630000
153323	2134	11266371000
153324	1874	16972000
153325	2134	11265367000
153326	1874	16976000
153327	2134	11264363000
153328	2134	11263359000
153329	2132	6614629000
153330	1874	16985000
153331	2132	6613628000
153332	2132	6612627000
153333	1874	16987000
153334	2134	11262355000
153335	1874	16991000
153336	2133	8175506000
153337	2133	8174504000
153338	2133	8173502000
153339	1874	16997000
153340	2133	8172500000
153341	1874	16999000
153342	2133	8171498000
153343	1874	17001000
153344	2133	8170496000
153345	2133	8169494000
153346	1874	17005000
153347	2134	11261351000
153348	1874	17009000
153349	2134	11260347000
153350	2134	11259343000
153351	1874	17017000
153352	2134	11258339000
153353	2134	11257335000
153354	1874	17025000
153355	2134	11256331000
153356	1874	17029000
152956	1874	16505000
152957	2134	11350707000
152958	1874	16509000
152959	1680	20892518499559
152960	1680	20892556499559
152965	1397	1256321767000
152966	1678	29520912333000
152967	1397	1256311766000
152968	1678	29520912334000
152969	2134	11349703000
152970	1874	16513000
152971	2133	8224604000
152972	1874	16515000
152973	2133	8223602000
152974	1874	16517000
152975	2133	8222600000
152976	2134	11348699000
152977	1874	16523000
152978	2134	11347695000
152979	2134	11346691000
152980	1874	16531000
152981	2134	11345687000
152982	2134	11344683000
152983	2134	11343679000
152984	1874	16543000
152985	2134	11342675000
152986	1874	16547000
152987	2134	11341671000
152988	1874	16551000
152989	2132	6643658000
152990	2132	6642657000
152991	1874	16553000
152992	2132	6641656000
152993	2133	8221598000
152994	2133	8220596000
152995	1395	58365274229457072
152996	1395	58365274266457072
153012	1397	1256291764000
153013	1678	29520912336000
153014	1397	1256281763000
153015	1678	29520912337000
153016	1397	1256271762000
153017	1678	29520912338000
153018	1726	108512112000
153019	2438	100000000
153020	2132	6639654000
153021	1874	16580000
153022	2132	6638653000
153023	1874	16581000
153024	2132	6637652000
153025	2132	6636651000
153026	1874	16583000
153027	2132	6635650000
153028	1657	13681539990100
153108	1397	1256241759000
153109	1678	29520912341000
153110	2338	6000000
153111	2133	8203562000
153112	2134	11314563000
153113	1874	16708000
153114	2134	11313559000
153115	1874	16712000
153116	2132	6632647000
153117	1874	16713000
153118	2132	6631646000
153119	2133	8202560000
153120	2134	11312555000
153121	2134	11311551000
153122	1874	16724000
153123	2134	11310547000
153124	1395	58365994266457072
153125	1395	58365994286457072
153162	1471	22985593900000
153195	1397	1256191754000
153196	1678	29520912346000
153197	1397	1256181753000
153198	1678	29520912347000
153199	2133	8192540000
153200	2133	8191538000
153201	1874	16824000
153202	2133	8190536000
153203	1874	16826000
153204	2133	8189534000
153205	2133	8188532000
153206	2134	11292475000
153207	2134	11291471000
153208	2134	11290467000
153209	1874	16842000
153210	2134	11289463000
153211	2134	11288459000
153212	1874	16850000
153213	2134	11287455000
153214	2134	11286451000
153215	2134	11285447000
153216	2134	11284443000
153217	1874	16866000
153218	2132	6624639000
153219	2132	6623638000
153220	1874	16868000
153221	2132	6622637000
153222	1394	1167857512299216
153223	1394	1167857549299216
153288	1688	62712111545072
153289	1688	63432111545072
153290	1688	63432117294711
153362	1397	1256101745000
153363	1678	29520912355000
153364	2133	8168492000
153365	1874	17039000
153366	2132	6611626000
153367	1874	17040000
153368	2133	8167490000
153369	1874	17042000
153370	2132	6610625000
153371	2134	11253319000
153372	1874	17047000
153373	2134	11252315000
153374	2134	11251311000
153375	1874	17055000
153376	2134	11250307000
153377	1709	14400334000000
153378	1709	14400352000000
153384	1681	18574843358535
153401	1688	63432117545072
153422	1397	1256071742000
153423	1678	29520912358000
153424	1397	1256061741000
153425	1678	29520912359000
153426	2134	11240267000
153427	2134	11239263000
153428	1874	17109000
153429	2134	11238259000
153430	2134	11237255000
153431	1874	17119000
153432	2134	11236251000
153433	2134	11235247000
153434	1874	17127000
153435	2134	11234243000
153436	2134	11233239000
153437	1874	17135000
153438	2134	11232235000
153439	1874	17139000
153440	1874	17142000
153441	2132	6606621000
153442	2132	6605620000
153443	1874	17144000
153444	2132	6604619000
153445	1874	17145000
153446	2133	8162480000
153447	1874	17147000
153448	2133	8161478000
153449	2133	8160476000
153450	1874	17151000
153451	2133	8159474000
153452	1874	17153000
153453	2133	8158472000
153454	1874	17155000
153455	1395	58368874420206711
153494	1703	9360979000000
153615	1476	22320590175105
153625	1397	1255991734000
153626	1678	29520912366000
153627	2133	8139434000
153628	664	66544509726895
153629	2132	6594609000
153630	1874	17307000
153631	1874	17315000
153632	1874	17323000
153633	1547	19435162000000
153669	2306	5039196031580
153708	1397	1255931728000
153709	1678	29520912372000
153710	1397	1255921727000
153711	1678	29520912373000
153712	2132	6586601000
153713	2133	8126408000
153714	2133	8125406000
153715	1874	17447000
153716	2133	8124404000
153717	1874	17449000
153718	2134	11179023000
153719	2134	11178019000
153720	1874	17457000
153721	2134	11177015000
153722	1874	17461000
153003	1874	16561000
153004	2134	11340667000
153005	2134	11339663000
153006	1874	16569000
153007	2134	11338659000
153008	2134	11337655000
153009	1874	16577000
153010	2133	8218592000
153011	1394	1166417512299216
153139	1397	1256221757000
153140	1678	29520912343000
153141	2133	8199554000
153142	1874	16751000
153143	2132	6629644000
153144	2132	6628643000
153145	2133	8198552000
153146	2133	8197550000
153147	1471	22985573900000
153148	1471	22985588900000
153160	1599	25497281097983
153161	1599	25497301097983
153225	1874	16821000
153226	1874	16823000
153227	2106	8640262000000
153228	2106	8640285000000
153242	1397	1256161751000
153243	1678	29520912349000
153244	2133	8184524000
153245	2134	11279423000
153246	2134	11278419000
153247	2134	11277415000
153248	1874	16906000
153249	2132	6620635000
153250	2132	6619634000
153251	1874	16908000
153252	2133	8183522000
153253	2133	8182520000
153254	2134	11276411000
153255	1874	16916000
153256	1549	20591618854742
153257	1549	20591637854742
153260	1397	1256151750000
153261	1678	29520912350000
153262	2134	11274403000
153263	2133	8181518000
153264	1395	58366714315457072
153265	2134	11273399000
153266	1874	16930000
153267	2134	11272395000
153268	1874	16934000
153269	2134	11271391000
153270	1874	16938000
153271	2133	8180516000
153272	2133	8179514000
153273	2132	6618633000
153274	1874	16943000
153275	1395	58367434315457072
153276	1796	200000052
153277	1568	1900000
153278	2367	100006701
153279	1395	58367434321206711
153280	2126	252800006
153281	1807	200000295
153282	2332	100006600
153283	2004	200039569
153284	1571	7520895388443
153285	1684	38883883494436
153286	1684	39603883494436
153287	1684	39603889244075
153381	1657	14401576990100
153400	1668	22113969500000
153477	1397	1256051740000
153478	1678	29520912360000
153479	2133	8157470000
153480	2132	6603618000
153481	1874	17158000
153482	2134	11231231000
153483	1874	17162000
153484	2133	8156468000
153485	1874	17164000
153486	2133	8155466000
153487	1874	17166000
153488	2134	11230227000
153489	2134	11229223000
153490	1874	17174000
153491	2134	11228219000
153492	1560	20168916131803
153493	1560	20168934131803
153496	1874	17172000
153497	1602	18576821169996
153552	234	66531385942306
153553	2439	99000000000
153554	1397	1256011736000
153555	1678	29520912364000
153556	1397	1256001735000
153557	1678	29520912365000
153558	2132	6598613000
153559	1874	17167000
153560	1874	17169000
153561	1395	58368874458206711
153562	1874	17171000
153563	2132	6597612000
153564	1874	17188000
153565	2133	8146448000
153566	2132	6596611000
153567	1874	17203000
153568	1874	17211000
153569	1874	17215000
153570	1874	17223000
153571	1874	17227000
153572	1874	17231000
153573	1874	17239000
153574	1874	17247000
153575	1874	17255000
153576	2134	11214163000
153577	1874	17259000
153578	2134	11213159000
153579	2134	11212155000
153580	1874	17267000
153581	2134	11211151000
153582	1874	17271000
153583	2134	11210147000
153584	2134	11209143000
153585	2134	11208139000
153586	2134	11207135000
153587	2134	11206131000
153588	1874	17291000
153589	2133	8145446000
153590	2133	8144444000
153591	2133	8143442000
153592	1874	17297000
153593	2133	8142440000
153594	1874	17299000
153595	1395	58369594458206711
153596	1395	58369594499206711
153616	2132	6595610000
153617	2133	8141438000
153618	2133	8140436000
153619	2134	11205127000
153620	2134	11204123000
153621	2134	11203119000
153622	2134	11202115000
153623	1547	19435142000000
153624	1547	19435149000000
153667	1440	9360409045924
153668	1440	9360461077504
153670	1397	1255961731000
153671	1678	29520912369000
153672	1397	1255951730000
153673	1678	29520912370000
153674	1397	1255941729000
153675	1678	29520912371000
153676	2132	6590605000
153677	2134	11192075000
153678	2134	11191071000
153679	2134	11190067000
153680	2134	11189063000
153681	2132	6589604000
153682	2132	6588603000
153683	1874	17389000
153684	2132	6587602000
153685	2134	11188059000
153686	2134	11187055000
153687	2134	11186051000
153688	2134	11185047000
153689	2134	11184043000
153690	2134	11183039000
153691	2134	11182035000
153692	2134	11181031000
153693	2134	11180027000
153694	2133	8134424000
153695	2133	8133422000
153696	2133	8132420000
153697	1874	17432000
153698	2133	8131418000
153699	1874	17434000
153700	2133	8130416000
153701	1874	17436000
153702	2133	8129414000
153703	2133	8128412000
153704	1874	17440000
153705	2133	8127410000
153706	1874	17442000
153707	1668	22114007500000
153811	1874	17566000
153167	2134	11300507000
153168	1874	16785000
153169	2134	11299503000
153170	2134	11298499000
153171	1874	16793000
153172	2134	11297495000
153173	2132	6627642000
153174	2329	347047329819988
153224	1448	14359974000001
153258	2134	11275407000
153259	1549	20591638854742
153291	1874	16936000
153292	1796	200000053
153293	2126	252825006
153294	1807	200000296
153295	1684	39603887219081
153296	1571	7520895388435
153297	1397	1256141749000
153298	1678	29520912351000
153299	2133	8178512000
153300	1874	16945000
153301	2134	11270387000
153302	2134	11269383000
153303	1874	16953000
153304	2134	11268379000
153305	2134	11267375000
153306	1874	16961000
153307	2133	8177510000
153308	2132	6617632000
153309	1874	16964000
153310	2132	6616631000
153311	1611	7192572402899
153312	1611	7192590392899
153313	2221	200420000
153419	1696	24923916335104
153420	1696	24923934335104
153500	1397	1256041739000
153501	1678	29520912361000
153502	1397	1256031738000
153503	1678	29520912362000
153504	1397	1256021737000
153505	1678	29520912363000
153506	2393	2877990000000
153507	2393	2878020000000
153529	2134	11227215000
153530	1874	17202000
153531	2134	11226211000
153532	1874	17206000
153533	2134	11225207000
153534	2134	11224203000
153535	2134	11223199000
153536	1874	17218000
153537	2134	11222195000
153538	2134	11221191000
153539	1874	17226000
153540	2134	11220187000
153541	2134	11219183000
153542	1874	17234000
153543	2134	11218179000
153544	1874	17238000
153545	2134	11217175000
153546	1874	17242000
153547	2134	11216171000
153548	1874	17246000
153549	2134	11215167000
153550	1874	17250000
153551	2393	2878052000000
153600	1522	17323978000000
153601	1522	18043978000000
153602	1522	18044019000000
153603	1476	21600549175105
153604	1874	17205000
153605	1874	17209000
153606	1476	22320549175105
153607	1476	22320568175105
153634	1547	19435152000000
153637	1397	1255981733000
153638	1678	29520912367000
153639	1397	1255971732000
153640	1678	29520912368000
153641	2163	1198995968420
153642	2134	11201111000
153643	2133	8138432000
153644	2134	11200107000
153645	1874	17333000
153646	2133	8137430000
153647	2133	8136428000
153648	2133	8135426000
153649	1874	17339000
153650	2134	11199103000
153651	1874	17343000
153652	2134	11198099000
153653	1874	17347000
153654	2134	11197095000
153655	2134	11196091000
153656	1874	17355000
153657	2134	11195087000
153658	2134	11194083000
153659	2134	11193079000
153660	1874	17367000
153661	2132	6593608000
153662	2132	6592607000
153663	2132	6591606000
153664	1874	17370000
153665	1549	21311638854742
153666	1549	21311690886322
153739	1397	1255911726000
153740	1678	29520912374000
153741	2132	6583598000
153742	1874	17494000
153743	2133	8120396000
153744	2133	8119394000
153745	2134	11169987000
153746	2134	11168983000
153747	2134	11167979000
153748	1874	17510000
153749	2132	6582597000
153750	2132	6581596000
153751	1874	17512000
153752	2133	8118392000
153753	2133	8117390000
153754	1874	17516000
153755	2133	8116388000
153756	1874	17518000
153757	2133	8115386000
153758	2134	11166975000
153759	1874	17524000
153760	2134	11165971000
153761	2134	11164967000
153762	1874	17532000
153763	2134	11163963000
153764	2134	11162959000
153765	2134	11161955000
153766	1874	17544000
153767	1395	58369594420206711
153768	1796	200000054
153769	1568	2000000
153770	2367	100006901
153771	1395	58369594447906275
153772	2430	275707501654
153773	1807	200000302
153774	2332	100006800
153775	2004	200039596
153807	1874	17581000
153808	1874	17589000
153809	2134	11152919000
153810	1680	20892538499559
153813	1740	20611021000000
153814	1740	20611041000000
153816	1397	1255881723000
153817	1678	29520912377000
153818	2132	6577592000
153819	1874	17594000
153820	2134	11151915000
153821	2134	11150911000
153822	2134	11149907000
153823	2133	8109374000
153824	2133	8108372000
153825	1874	17610000
153826	1394	1169297529299216
153827	1394	1169297553299216
153901	1594	21602023000000
153902	1594	21602042000000
153918	1457	17280387800000
153919	1457	17280404800000
153922	1397	1255821717000
153923	1678	29520912383000
153924	2133	8096348000
153925	1874	17729000
153926	2134	11126815000
153927	2134	11125811000
153928	2134	11124807000
153929	1874	17741000
153930	2134	11123803000
153931	2134	11122799000
153932	2132	6569584000
153933	2132	6568583000
153934	2133	8095346000
153935	1395	58370314447906275
153936	1395	58370314466906275
154026	1397	1255751710000
154027	1678	29520912390000
154028	2132	6558573000
154029	2134	11095691000
154030	2134	11094687000
153357	2134	11255327000
153358	1874	17033000
153359	2134	11254323000
153360	1395	58368154321206711
153361	1395	58368154376206711
153379	1657	14401562990100
153380	1657	14401580990100
153382	1694	21419172197225
153383	1694	21419190197225
153385	1397	1256091744000
153386	1678	29520912356000
153387	2133	8166488000
153388	1874	17061000
153389	2132	6609624000
153390	2134	11249303000
153391	1874	17066000
153392	2134	11248299000
153393	2133	8165486000
153394	1874	17072000
153395	2134	11247295000
153396	2134	11246291000
153397	1874	17080000
153398	2134	11245287000
153399	1668	22113970500000
153402	1397	1256081743000
153403	1678	29520912357000
153404	2132	6608623000
153405	1874	17085000
153406	2134	11244283000
153407	1874	17089000
153408	2134	11243279000
153409	2134	11242275000
153410	2134	11241271000
153411	1874	17101000
153412	2133	8164484000
153413	1874	17103000
153414	2133	8163482000
153415	2132	6607622000
153416	1874	17106000
153417	1395	58368874376206711
153418	1395	58368874394206711
153421	1696	24923927335104
153456	1874	15656000
153457	1874	15657000
153458	1874	15661000
153459	1874	15668000
153460	1874	15669000
153461	1717	22862251000055
153462	1874	15672000
153463	1874	15677000
153464	1874	15681000
153465	1874	15693000
153466	1874	15695000
153467	1874	15697000
153468	1717	23582251000055
153469	1796	200000042
153470	1568	1500000
153471	2367	100005701
153472	1717	23582276824406
153473	2126	252650006
153474	1807	200000239
153475	2332	100005500
153476	2004	200039470
153495	1602	18576822169996
153498	1702	10080645000000
153499	1560	20168930131803
153508	2132	6602617000
153509	1874	17159000
153510	2132	6601616000
153511	2132	6600615000
153512	1874	17161000
153513	2132	6599614000
153514	2133	8154464000
153515	2133	8153462000
153516	2133	8152460000
153517	2133	8151458000
153518	2133	8150456000
153519	1874	17180000
153520	2393	2158033000000
153521	2133	8149454000
153522	1874	17182000
153523	2133	8148452000
153524	2133	8147450000
153525	1874	17186000
153526	1874	17190000
153527	2393	2878033000000
153528	2393	2878039000000
153597	1679	28799000656999
153598	1679	29519000656999
153599	1679	29519041656999
153608	341	66001028000001
153609	1874	17191000
153610	1874	17193000
153611	1874	17195000
153612	341	66721028000001
153613	1905	200001000
153614	341	66721042999001
153635	1688	64152117545072
153636	1688	64152137545072
153777	1397	1255901725000
153778	1678	29520912375000
153779	2134	11160951000
153780	2133	8114384000
153781	2133	8113382000
153782	1874	17552000
153783	2134	11159947000
153784	2132	6580595000
153785	1874	17557000
153786	2134	11158943000
153787	2134	11157939000
153788	1394	1167857529299216
153799	2134	11156935000
153800	2134	11155931000
153801	1874	17579000
153802	2134	11154927000
153803	1874	17583000
153804	2134	11153923000
153805	1874	17587000
153806	1680	20892536499559
153815	1740	20611035000000
153861	1874	17631000
153862	1874	17639000
153863	1874	17651000
153864	1719	24478929000000
153867	1874	17624000
153868	606	85486030286229
153883	1608	21018684000000
153938	1696	25643927335104
154006	1508	20360643132611
154025	1670	18001249474693
154040	1397	1255741709000
154041	1678	29520912391000
154042	2134	11091675000
154043	2134	11090671000
154044	2132	6557572000
154045	2134	11089667000
154046	2134	11088663000
154047	2133	8076308000
154048	2133	8075306000
154128	1599	25497367097983
154129	1599	26217367097983
154130	1599	26217375172678
154241	1397	1255621697000
154242	1678	29520912403000
154243	2133	8046248000
154244	2133	8045246000
154245	1874	18212000
154246	2132	6540555000
154247	2134	11038463000
154248	2134	11037459000
154249	2134	11036455000
154250	1874	18225000
154251	2134	11035451000
154252	1444	19628070329999
154253	1444	19628087329999
154255	1444	19628083329999
154294	1397	1255591694000
154295	1678	29520912406000
154296	1397	1255581693000
154297	1678	29520912407000
154298	2133	8041238000
154299	2133	8040236000
154300	2133	8039234000
154301	2133	8038232000
154302	2133	8037230000
154303	2133	8036228000
154304	2261	17279542381228
154305	2261	17279568381228
154455	1714	22606009897123
154457	180	66920128434669
154458	2441	7010000000
154459	1397	1255551690000
154460	1678	29520912410000
154461	1397	1255541689000
154462	1678	29520912411000
154463	2133	8022200000
154464	1874	18458000
154465	2132	6524539000
154466	2134	10992279000
154467	2132	6523538000
154468	1874	18464000
154469	2132	6522537000
154470	1874	18465000
154471	2134	10991275000
154472	2134	10990271000
153723	2134	11176011000
153724	1874	17465000
153725	2134	11175007000
153726	1874	17469000
153727	2133	8123402000
153728	2133	8122400000
153729	2133	8121398000
153730	2132	6585600000
153731	1874	17476000
153732	2132	6584599000
153733	2134	11174003000
153734	2134	11172999000
153735	2134	11171995000
153736	2134	11170991000
153737	1633	15889008625277
153738	1633	16609008625277
153776	1602	18576831869560
153789	1397	1255891724000
153790	1678	29520912376000
153791	2133	8112380000
153792	2133	8111378000
153793	1874	17569000
153794	2133	8110376000
153795	2132	6579594000
153796	1874	17572000
153797	2132	6578593000
153798	1680	20892533499559
153828	1397	1255871722000
153829	1678	29520912378000
153830	2134	11148903000
153831	2134	11147899000
153832	2133	8107370000
153833	2133	8106368000
153834	2134	11146895000
153835	2134	11145891000
153836	2134	11144887000
153837	1874	17634000
153838	2132	6576591000
153839	2132	6575590000
153840	1874	17636000
153841	1619	15120384000000
153844	1397	1255861721000
153845	1678	29520912379000
153846	2133	8105366000
153847	664	66543508726895
153848	2440	0
153849	2133	8104364000
153850	2132	6574589000
153851	2134	11143883000
153852	1874	17645000
153853	2134	11142879000
153854	1874	17649000
153855	2134	11141875000
153856	2134	11140871000
153857	606	85486024286229
153858	606	85486047286229
154150	1874	18088000
154151	1701	21598630500094
154152	1701	21598646949811
154155	1397	1255671702000
154156	1678	29520912398000
154157	2133	8057270000
154158	2134	11060551000
154159	2133	8056268000
154160	1874	18099000
154161	2132	6547562000
154162	2134	11059547000
154163	2134	11058543000
154164	1874	18108000
154165	2134	11057539000
154166	2292	3599093000000
154168	1747	10146139599975
154184	1559	19026346897799
154185	1559	19026364897799
154271	1874	18237000
154272	1874	18241000
154273	1874	18245000
154274	1874	18249000
154275	1610	21600538999950
154283	1397	1255601695000
154284	1678	29520912405000
154285	2134	11030431000
154286	1874	18255000
154287	2132	6537552000
154288	2133	8042240000
154289	2134	11029427000
154290	2134	11028423000
154291	2134	11027419000
154292	1395	58371754486906275
154293	1395	58371754502906275
154368	180	66930178434669
154369	2441	2010000000
154370	180	66925153434669
154371	1726	113512112000
154372	2439	628993000000
154373	2132	6531546000
154374	2133	8033222000
154375	2132	6530545000
154376	1874	18347000
154377	2132	6529544000
154378	2133	8032220000
154379	2133	8031218000
154380	512	66544509726895
154381	2134	11013363000
154382	2134	11012359000
154383	2133	8030216000
154384	1611	6730272069739
154385	975	508710445186036
154386	2134	11011355000
154387	2134	11010351000
154388	1874	18370000
154389	2134	11009347000
154390	2134	11008343000
154391	1874	18378000
154392	2134	11007339000
154393	2134	11006335000
154394	1611	5901802387769
154395	1095	911604759142284
154396	1611	5342817059639
154397	1215	615077896001284
154398	1611	3785156527184
154399	1341	1713969246884862
154400	2134	11005331000
154401	1874	18390000
154402	2261	17999578985774
154403	2261	17999881985774
154405	1692	24941529819983
154426	1397	1255561691000
154427	1678	29520912409000
154428	1874	18401000
154429	2132	6527542000
154430	2133	8026208000
154431	2133	8025206000
154432	2133	8024204000
154433	1874	18408000
154434	2132	6526541000
154435	2134	11000311000
154436	1874	18425000
154437	2134	10999307000
154438	2134	10998303000
154439	1874	18433000
154440	2134	10997299000
154441	1874	18437000
154442	2134	10996295000
154443	1874	18441000
154444	2134	10995291000
154445	1874	18445000
154446	2132	6525540000
154447	1874	18446000
154448	2134	10994287000
154449	1874	18450000
154450	2134	10993283000
154451	2133	8023202000
154452	1874	18456000
154453	1684	39603871494436
154454	1684	39603900494436
154456	1714	23326002897123
154609	1719	24478966624587
154635	2292	3599102934869
154641	632	85437827934869
154942	1670	18001235474382
154944	1397	1255381673000
154945	1678	29520912427000
154946	2133	7982120000
154947	2134	10917983000
154948	2132	6499514000
154949	1874	18864000
154950	2132	6498513000
154951	2134	10916979000
154952	2134	10915975000
154953	2134	10914971000
154954	2133	7981118000
154955	2133	7980116000
154966	391	66932120434669
154967	2226	109000000
154968	1688	64872124545072
154969	1688	64872224545072
155020	2329	349927412194886
155021	2329	349927449194886
155041	1874	19015000
155061	1397	1255301665000
155062	1678	29520912435000
155063	2133	7964084000
155064	2133	7963082000
155065	1874	19045000
153812	1685	203045111571430
153842	1874	17612000
153843	1874	17616000
153859	1719	24478908000000
153860	1719	24478931000000
153865	1874	17642000
153866	606	85486044286229
153869	1397	1255851720000
153870	1678	29520912380000
153871	2133	8103362000
153872	2132	6573588000
153873	2134	11139867000
153874	1874	17664000
153875	2134	11138863000
153876	2133	8102360000
153877	2134	11137859000
153878	2134	11136855000
153879	2134	11135851000
153880	1874	17682000
153881	1608	21018671000000
153882	1608	21018689000000
153884	1397	1255841719000
153885	1678	29520912381000
153886	2133	8101358000
153887	1874	17684000
153888	2134	11134847000
153889	2133	8100356000
153890	2133	8099354000
153891	2132	6572587000
153892	2132	6571586000
153893	1874	17694000
153894	2134	11133843000
153895	2134	11132839000
153896	1874	17702000
153897	2134	11131835000
153898	1874	17706000
153899	1394	1170737553299216
153900	1394	1170737572299216
153903	1397	1255831718000
153904	1678	29520912382000
153905	2133	8098352000
153906	1874	17708000
153907	2133	8097350000
153908	2134	11130831000
153909	1874	17714000
153910	2134	11129827000
153911	2134	11128823000
153912	2134	11127819000
153913	1874	17726000
153914	2132	6570585000
153915	1874	17727000
153916	1509	21983552503835
153917	1509	21983569503835
153920	326	67440015000000
153921	326	67440032000000
153937	632	85437820000000
153939	1397	1255811716000
153940	1678	29520912384000
153941	1397	1255801715000
153942	1678	29520912385000
153943	1397	1255791714000
153944	1678	29520912386000
153945	1397	1255781713000
153946	1678	29520912387000
153947	1397	1255771712000
153948	1678	29520912388000
153949	2133	8094344000
153950	2134	11121795000
153951	2134	11120791000
153952	1874	17763000
153953	2133	8093342000
153954	2134	11119787000
153955	1874	17769000
153956	2134	11118783000
153957	2134	11117779000
153958	1874	17777000
153959	2134	11116775000
153960	2134	11115771000
153961	2134	11114767000
153962	1874	17789000
153963	2134	11113763000
153964	2134	11112759000
153965	2134	11111755000
153966	2134	11110751000
153967	2133	8092340000
153968	2133	8091338000
153969	2133	8090336000
153970	2133	8089334000
153971	2133	8088332000
153972	2133	8087330000
153973	2133	8086328000
153974	2133	8085326000
153975	2132	6567582000
153976	1874	17822000
153977	2132	6566581000
153978	2132	6565580000
153979	2133	8084324000
153980	2133	8083322000
153981	2133	8082320000
153982	2133	8081318000
153983	664	66542507726895
153984	2440	1000000000
153985	2134	11109747000
153986	1874	17836000
153987	2134	11108743000
153988	2134	11107739000
153989	2134	11106735000
153990	2134	11105731000
153991	2134	11104727000
153992	2134	11103723000
153993	2134	11102719000
153994	2134	11101715000
153995	2134	11100711000
153996	1874	17872000
153997	2132	6564579000
153998	2132	6563578000
153999	2132	6562577000
154000	2132	6561576000
154001	1874	17876000
154002	1796	200000055
154003	1657	14401656966095
154004	1807	200000306
154005	2336	100024003
154007	664	66541497726895
154008	2440	2000000000
154009	1397	1255761711000
154010	1678	29520912389000
154011	2132	6560575000
154012	2134	11099707000
154013	1874	17881000
154014	2132	6559574000
154015	1874	17882000
154016	2133	8080316000
154017	1874	17884000
154018	2133	8079314000
154019	2134	11098703000
154020	2134	11097699000
154021	1874	17894000
154022	2134	11096695000
154023	1679	29518962656999
154024	1679	29518990656999
154037	1692	24941241819983
154065	1397	1255721707000
154066	1678	29520912393000
154067	1397	1255711706000
154068	1678	29520912394000
154069	1397	1255701705000
154070	1678	29520912395000
154071	1397	1255691704000
154072	1678	29520912396000
154073	2133	8071298000
154074	2134	11082639000
154075	2132	6554569000
154076	2132	6553568000
154077	1874	17976000
154078	2132	6552567000
154079	2132	6551566000
154080	2132	6550565000
154081	1874	17979000
154082	2133	8070296000
154083	2133	8069294000
154084	2133	8068292000
154085	2133	8067290000
154086	2133	8066288000
154087	1874	17989000
154088	2133	8065286000
154089	1874	17991000
154090	2133	8064284000
154091	2133	8063282000
154092	2133	8062280000
154093	2133	8061278000
154094	2133	8060276000
154095	1874	18001000
154096	2134	11081635000
154097	2134	11080631000
154098	1874	18009000
154099	2134	11079627000
154100	2134	11078623000
154101	2134	11077619000
154102	2134	11076615000
154103	2134	11075611000
154104	2134	11074607000
154105	1509	21263618503835
154106	2134	11073603000
154107	2134	11072599000
154031	2134	11093683000
154032	2134	11092679000
154033	2133	8078312000
154034	2133	8077310000
154035	216	66720000000000
154036	216	66720017000000
154038	2358	51096000000
154039	1756	11360843570609
154049	1397	1255731708000
154050	1678	29520912392000
154051	2133	8074304000
154052	2134	11087659000
154053	2134	11086655000
154054	2132	6556571000
154055	2132	6555570000
154056	2134	11085651000
154057	1874	17956000
154058	2134	11084647000
154059	2134	11083643000
154060	1874	17964000
154061	2133	8073302000
154062	2133	8072300000
154063	1395	58371034466906275
154064	1395	58371034486906275
154125	2367	100007101
154126	1807	200000311
154127	1509	21983626578530
154153	1587	22320600750000
154154	1587	22320618199717
154169	1397	1255661701000
154170	1678	29520912399000
154171	2134	11056535000
154172	1874	18116000
154173	2133	8055266000
154174	2133	8054264000
154175	2134	11055531000
154176	2134	11054527000
154177	1874	18128000
154178	2134	11053523000
154179	2132	6546561000
154180	2132	6545560000
154181	1874	18134000
154182	42	82220889500000
154183	42	82220907500000
154186	1397	1255651700000
154187	1678	29520912400000
154188	2133	8053262000
154189	2133	8052260000
154190	1874	18138000
154191	2132	6544559000
154192	180	66932438434669
154193	2441	0
154194	2134	11052519000
154195	1874	18143000
154196	2134	11051515000
154197	2134	11050511000
154198	2134	11049507000
154199	2134	11048503000
154200	1874	18159000
154201	1685	203765111571430
154202	1685	203765130571430
154209	1397	1255641699000
154210	1678	29520912401000
154211	1397	1255631698000
154212	1678	29520912402000
154213	2133	8051258000
154214	1874	18161000
154215	2133	8050256000
154216	2132	6543558000
154217	2133	8049254000
154218	2133	8048252000
154219	1874	18168000
154220	2133	8047250000
154221	1874	18170000
154222	2132	6542557000
154223	2132	6541556000
154224	2134	11047499000
154225	1874	18176000
154226	2134	11046495000
154227	1874	18180000
154228	2134	11045491000
154229	2134	11044487000
154230	2134	11043483000
154231	1874	18192000
154232	2134	11042479000
154233	2134	11041475000
154234	1874	18200000
154235	2134	11040471000
154236	2134	11039467000
154237	1693	2349692825590
154239	2329	347767329819988
154240	2329	347767366819988
154254	1749	2162626529980
154306	2132	6536551000
154307	1874	18273000
154308	2134	11026415000
154309	2134	11025411000
154310	1874	18281000
154311	1874	18283000
154312	1874	18285000
154313	1874	18287000
154314	1874	18289000
154315	2132	6535550000
154316	2132	6534549000
154317	1874	18293000
154318	2134	11024407000
154319	2134	11023403000
154320	2261	16559575381228
154321	2134	11022399000
154322	1874	18305000
154323	2134	11021395000
154324	2134	11020391000
154325	1874	18313000
154326	2134	11019387000
154327	1874	18317000
154328	2134	11018383000
154329	2261	17279575381228
154330	1796	200000063
154331	1568	2100000
154332	1420	1854875970000
154333	2367	100007301
154334	2221	200550000
154335	2126	254050006
154336	1807	200000323
154337	2332	100007300
154338	2004	200039713
154339	2261	17279578985774
154343	234	66001375942306
154344	2439	629000000000
154345	1397	1255571692000
154346	1678	29520912408000
154347	2133	8035226000
154348	1874	18323000
154349	2133	8034224000
154350	1874	18325000
154351	2134	11017379000
154352	2132	6533548000
154353	2132	6532547000
154354	2134	11016375000
154355	1874	18335000
154356	2134	11015371000
154357	2134	11014367000
154358	1874	18343000
154359	1395	58372474502906275
154360	1568	2125000
154361	1395	58372474529281173
154362	2430	275707701654
154363	1807	200000327
154364	697	66000002499995
154365	2332	100007400
154404	2261	17999869985774
154406	664	66540494726895
154407	2440	3000000000
154408	2132	6528543000
154409	2133	8029214000
154410	1874	18393000
154411	2133	8028212000
154412	1874	18395000
154413	2133	8027210000
154414	1874	18397000
154415	1688	64152124545072
154425	1714	22606002897123
154493	1395	58372474565906275
154517	1596	11520386000002
154520	369	86677183290830
154521	1874	17700000
154522	1874	17712000
154523	1874	17724000
154524	1874	17732000
154525	1874	17744000
154526	1874	17756000
154527	1874	17760000
154528	1874	17772000
154529	1874	17780000
154530	1874	17784000
154531	1874	17792000
154532	1874	17810000
154533	1874	17816000
154534	1874	17834000
154535	1874	17888000
154536	1874	17896000
154537	369	87397183290830
154538	1796	200000058
154539	152	66000110800000
154540	2221	200460000
154108	2134	11071595000
154109	2134	11070591000
154110	2134	11069587000
154111	2134	11068583000
154112	2134	11067579000
154113	2134	11066575000
154114	2134	11065571000
154115	1509	21983618503835
154116	2407	101000000
154117	1568	2025000
154118	2367	100007001
154119	2430	275707601654
154120	2126	253300006
154121	1807	200000310
154122	2252	201100000
154123	1509	21983625578631
154124	2332	100006900
154131	1397	1255681703000
154132	1678	29520912397000
154133	2133	8059274000
154134	2132	6549564000
154135	2133	8058272000
154136	2134	11064567000
154137	2134	11063563000
154138	2134	11062559000
154139	2134	11061555000
154140	1874	18090000
154141	2132	6548563000
154142	1678	30240912397000
154143	1796	200000059
154144	1568	2075000
154145	2126	253800006
154146	1807	200000318
154147	1678	30240929846717
154148	2332	100007100
154149	2004	200039668
154167	1746	7008997999989
154203	606	83325992286229
154204	2252	200900000
154205	1756	12080843470609
154206	2336	106000000
154207	2252	201400000
154208	1756	12081054002189
154238	1693	2349683825590
154256	1397	1255611696000
154257	1678	29520912404000
154258	2132	6539554000
154259	2133	8044244000
154260	2133	8043242000
154261	2132	6538553000
154262	1874	18235000
154263	2134	11034447000
154264	2134	11033443000
154265	1874	18243000
154266	2134	11032439000
154267	1874	18247000
154268	2134	11031435000
154269	1610	21600521999950
154270	1610	21600539999950
154276	472	66000390000000
154277	1428	2159632000000
154278	180	66845789394804
154279	718	2000003000000
154280	1634	18384382416084
154281	1634	19104382416084
154282	1634	19104395716084
154340	1874	18275000
154341	1690	193685977000000
154342	1690	193686006000000
154366	2329	348487366819988
154367	2329	348487393194886
154416	2134	11004327000
154417	2134	11003323000
154418	2134	11002319000
154419	1874	18403000
154420	2134	11001315000
154421	1874	18407000
154422	1874	18411000
154423	1874	18413000
154424	1714	22605991897123
154546	2443	24
154547	1634	19823395716060
154606	1719	23758954000000
154607	1719	24478954000000
154608	1719	24478965624587
154661	1397	1255481683000
154662	1678	29520912417000
154663	2133	8004164000
154664	2132	6513528000
154665	1874	18630000
154666	2133	8003162000
154667	1874	18632000
154668	2134	10961155000
154669	2134	10960151000
154670	1874	18640000
154671	2134	10959147000
154672	1874	18644000
154673	2134	10958143000
154674	1593	22272922925000
154675	1593	22272939925000
154820	1716	5760134000000
154821	1716	5760152000000
154822	1394	1170737575299216
154823	1716	5760156000000
154867	1397	1255421677000
154868	1678	29520912423000
154869	2134	10935051000
154870	1874	18769000
154871	2134	10934047000
154872	1874	18773000
154873	2132	6505520000
154874	2133	7991138000
154875	2133	7990136000
154876	2133	7989134000
154877	1874	18780000
154878	2134	10933043000
154879	2134	10932039000
154880	2132	6504519000
154881	1693	2349674825590
154886	2329	349207412194886
154891	610	68880075000000
154893	1397	1255411676000
154894	1678	29520912424000
154895	1397	1255401675000
154896	1678	29520912425000
154897	2132	6503518000
154898	1874	18790000
154899	2134	10931035000
154900	2134	10930031000
154901	2134	10929027000
154902	1874	18802000
154903	1402	70744385811104
154904	2133	7988132000
154905	2133	7987130000
154906	2133	7986128000
154907	2133	7985126000
154908	2132	6502517000
154909	2132	6501516000
154910	1874	18812000
154911	2134	10928023000
154912	2134	10927019000
154913	2134	10926015000
154914	2134	10925011000
154915	2134	10924007000
154916	2134	10923003000
154917	1402	71464385811104
154918	1796	200000066
154919	1402	71464395210775
154920	2367	100007701
154921	2221	200850000
154922	2126	254550006
154923	1807	200000338
154924	1527	308999941
154925	2332	100007800
154926	2004	200039776
154970	1397	1255361671000
154971	1678	29520912429000
154972	1397	1255351670000
154973	1678	29520912430000
154974	2134	10909951000
154975	2134	10908947000
154976	2132	6496511000
154977	1874	18909000
154978	2132	6495510000
154979	2132	6494509000
154980	1874	18911000
154981	2133	7978112000
154982	2133	7977110000
154983	2133	7976108000
154984	2133	7975106000
154985	2133	7974104000
154986	2134	10907943000
154987	2134	10906939000
154988	2134	10905935000
154989	2134	10904931000
154990	2134	10903927000
154991	2134	10902923000
154992	2134	10901919000
154993	1679	30238990656999
154994	1679	30239027656999
155040	610	68880076000000
155056	2134	10884851000
155057	1874	19039000
155058	1874	19041000
155059	1573	12099650000000
154473	1874	18473000
154474	2133	8021198000
154475	1874	18475000
154476	2134	10989267000
154477	2134	10988263000
154478	1874	18483000
154479	2134	10987259000
154480	1874	18487000
154481	2134	10986255000
154482	2134	10985251000
154483	1874	18495000
154484	2134	10984247000
154485	1874	18499000
154486	2133	8020196000
154487	2133	8019194000
154488	1874	18503000
154489	2133	8018192000
154490	1874	18505000
154491	2133	8017190000
154492	1680	20892581499559
154494	180	66000103434669
154495	2441	927010000000
154496	1397	1255531688000
154497	1678	29520912412000
154498	2132	6521536000
154499	1874	18508000
154500	2132	6520535000
154501	1874	18509000
154502	2134	10983243000
154503	1874	18513000
154504	2134	10982239000
154505	512	66543508726895
154506	2442	0
154507	2134	10981235000
154508	1874	18521000
154509	2134	10980231000
154510	1874	18525000
154511	2134	10979227000
154512	2133	8016188000
154513	1874	18531000
154514	2133	8015186000
154515	1874	18533000
154516	2148	14400471880750
154518	2329	349207393194886
154519	2329	349207438194886
154545	2148	14400452880750
154548	1397	1255521687000
154549	1678	29520912413000
154550	1397	1255511686000
154551	1678	29520912414000
154552	2132	6519534000
154553	1874	18518000
154554	1874	18522000
154555	1874	18530000
154556	2134	10978223000
154557	1874	18534000
154558	1874	18536000
154559	1874	18538000
154560	1726	112411112000
154561	2444	100000000
154562	1726	111310112000
154563	2445	100000000
154564	1726	110209112000
154565	2446	100000000
154566	2134	10977219000
154567	1874	18542000
154568	2134	10976215000
154569	1874	18546000
154570	1394	1169297599299216
154571	2132	6518533000
154572	2132	6517532000
154573	1874	18548000
154574	2134	10975211000
154575	2133	8014184000
154576	2133	8013182000
154577	1874	18556000
154578	2133	8012180000
154579	1874	18558000
154580	2133	8011178000
154581	1874	18560000
154582	2133	8010176000
154583	1874	18562000
154584	2133	8009174000
154585	2134	10974207000
154586	1874	18568000
154587	2134	10973203000
154588	1874	18572000
154589	2134	10972199000
154590	1874	18576000
154591	2134	10971195000
154592	1874	18580000
154593	2134	10970191000
154594	1874	18584000
154595	1394	1170737599299216
154596	1796	200000064
154597	1568	2200000
154598	2367	100007401
154599	2221	200750000
154600	2430	275707801654
154601	1807	200000332
154602	1394	1170737611923803
154603	697	66000003499993
154604	2332	100007700
154605	2004	200039722
154636	1874	18587000
154637	1874	18591000
154638	1747	10866139599975
154639	1747	10866166534844
154642	1439	17984007578477
154643	1439	17984034513346
154676	1678	28800895297000
154677	1678	28800895298000
154678	1678	28800895299000
154679	1678	28800895300000
154680	1678	28800895301000
154681	1678	28800895302000
154682	1678	28800895303000
154683	1678	28800895304000
154684	1678	28800895305000
154685	1678	28800895306000
154686	1678	28800895307000
154687	1678	28800895308000
154688	1678	28800895309000
154689	1678	28800895310000
154690	1678	28800895311000
154691	1678	28800895312000
154692	1678	28800895313000
154693	1678	28800895314000
154694	1678	28800895315000
154695	1678	28800895316000
154696	1678	28800895317000
154697	1678	28800895318000
154698	1678	28800895319000
154699	1678	28800895320000
154700	1678	28800895321000
154701	1678	28800895322000
154702	1678	28800895323000
154703	1678	28800895324000
154704	1678	28800895325000
154705	1678	28800895326000
154706	1678	28800895327000
154707	1678	28800895328000
154708	1678	28800895329000
154709	1678	28800895330000
154710	1678	28800895331000
154711	1678	28800895332000
154712	1678	28800895333000
154713	1678	28800895334000
154714	1678	28800895335000
154715	1678	28800895336000
154716	1678	28800895337000
154717	1678	28800895338000
154718	1678	28800895339000
154719	1678	28800895340000
154720	1678	28800895341000
154721	1678	28800895342000
154722	1593	22274117027394
154723	152	66000112400000
154724	1807	200000191
154725	2143	200600000
154726	1527	314999935
154727	2004	200045563
154728	1678	28800895343000
154729	1678	28800895344000
154730	1678	28800895345000
154731	1678	28800895346000
154732	1678	28800895347000
154733	1678	28800895348000
154734	1678	28800895349000
154735	1678	28800895350000
154736	1678	28800895351000
154737	1678	28800895352000
154738	1678	28800895353000
154739	1678	28800895354000
154740	1678	28800895355000
154741	1678	28800895356000
154742	1678	28800895357000
154743	1678	28800895358000
154744	1678	28800895359000
154745	1678	28800895360000
154746	1678	28800895361000
154747	1678	28800895362000
154748	1678	28800895363000
154749	1678	28800895364000
154750	1678	28800895365000
154541	369	87397599525475
154542	1807	200000308
154543	2252	201000000
154544	2004	200039641
154610	664	66010484726895
154611	2440	533000000000
154612	1397	1255501685000
154613	1678	29520912415000
154614	2132	6516531000
154615	1874	18585000
154616	2134	10969187000
154617	2134	10968183000
154618	1874	18593000
154619	2133	8008172000
154620	1874	18595000
154621	2133	8007170000
154622	2134	10967179000
154623	1874	18601000
154624	2134	10966175000
154625	1874	18605000
154626	512	66543506726895
154627	2442	1000000
154628	1796	200000065
154629	1568	2275000
154630	1420	1854876960000
154631	2367	100007501
154632	1746	7009007934858
154633	1807	200000335
154634	2004	200039749
154640	632	85437828934869
154644	1397	1255491684000
154645	1678	29520912416000
154646	2133	8006168000
154647	1874	18607000
154648	2132	6515530000
154649	2132	6514529000
154650	1874	18609000
154651	2133	8005166000
154652	1874	18611000
154653	2134	10965171000
154654	1874	18615000
154655	2134	10964167000
154656	2134	10963163000
154657	1874	18623000
154658	2134	10962159000
154659	1395	58373194565906275
154660	1395	58373194583906275
154785	1397	1255471682000
154786	1678	29520912418000
154787	2440	532996750000
154788	2134	10957139000
154789	1874	18652000
154790	2133	8002160000
154791	2133	8001158000
154792	2134	10956135000
154793	1874	18660000
154794	2132	6512527000
154795	2134	10955131000
154796	1874	18665000
154797	2134	10954127000
154798	1874	18669000
154799	484	79774088250000
154819	2248	14399617000000
154884	1718	11776664519070
154885	1718	11776683519070
154892	1693	2349660825590
154927	1397	1255391674000
154928	1678	29520912426000
154929	2134	10921999000
154930	2134	10920995000
154931	2134	10919991000
154932	2134	10918987000
154933	2132	6500515000
154934	2133	7984124000
154935	2133	7983122000
154936	2367	100007801
154937	1807	200000342
154938	1670	18001239474382
154939	697	66000004499991
154940	2332	100008000
154941	2004	200039785
154956	1397	1255371672000
154957	1678	29520912428000
154958	2134	10913967000
154959	2134	10912963000
154960	2134	10911959000
154961	2134	10910955000
154962	2132	6497512000
154963	2133	7979114000
154964	2112	32927144066403
154965	2112	32927160066403
154995	1397	1255341669000
154996	1678	29520912431000
154997	1397	1255331668000
154998	1678	29520912432000
154999	2133	7973102000
155000	2132	6493508000
155001	1874	18952000
155002	2133	7972100000
155003	2133	7971098000
155004	2133	7970096000
155005	2133	7969094000
155006	2132	6492507000
155007	2132	6491506000
155008	2134	10900915000
155009	2134	10899911000
155010	2134	10898907000
155011	2134	10897903000
155012	2134	10896899000
155013	2134	10895895000
155014	2134	10894891000
155015	1874	18990000
155016	2134	10893887000
155017	1874	18994000
155018	2134	10892883000
155019	1715	13703694663945
155042	1685	204485130571430
155043	1685	204485150571430
155122	1394	1172177610803869
155193	2148	15120556880750
155224	436	66717270000000
155225	1396	1020000000
155226	1397	1255221657000
155227	1678	29520912443000
155228	1397	1255211656000
155229	1678	29520912444000
155230	2133	7944044000
155231	2132	6475490000
155232	1874	19240000
155233	2132	6474489000
155234	2132	6473488000
155235	1874	19242000
155236	2133	7943042000
155237	1874	19244000
155238	2133	7942040000
155239	2133	7941038000
155240	2133	7940036000
155241	1874	19250000
155242	2134	10847703000
155243	2134	10846699000
155244	1874	19258000
155245	2134	10845695000
155246	1874	19262000
155247	2134	10844691000
155248	2134	10843687000
155249	2134	10842683000
155250	1874	19274000
155251	2134	10841679000
155252	2134	10840675000
155253	1874	19282000
155254	2134	10839671000
155255	1874	19286000
155256	2148	15840556880750
155257	2148	15840643880750
155338	1397	1255161651000
155339	1678	29520912449000
155340	1397	1255151650000
155341	1678	29520912450000
155342	163	66932426434669
155343	2448	0
155344	2134	10821599000
155345	2132	6467482000
155346	2132	6466481000
155347	1874	19389000
155348	2133	7927010000
155349	2134	10820595000
155350	1874	19395000
155351	2134	10819591000
155352	2134	10818587000
155353	2134	10817583000
155354	2134	10816579000
155355	2134	10815575000
155356	2134	10814571000
155357	2134	10813567000
155358	1874	19423000
155359	2133	7926008000
155360	1874	19425000
155361	2133	7925006000
155362	2133	7924004000
155363	1874	19429000
155364	2133	7923002000
155365	1874	19431000
155366	2132	6465480000
155367	1672	21601828000000
155368	1796	200000073
154751	1678	28800895366000
154752	1678	28800895367000
154753	1678	28800895368000
154754	1678	28800895369000
154755	1678	28800895370000
154756	1678	28800895371000
154757	1678	28800895372000
154758	1678	28800895373000
154759	1678	28800895374000
154760	1678	28800895375000
154761	1678	28800895376000
154762	1678	28800895377000
154763	1678	28800895378000
154764	1678	28800895379000
154765	1678	28800895380000
154766	1678	28800895381000
154767	1678	28800895382000
154768	1678	28800895383000
154769	1593	22994117027394
154770	2407	103000000
154771	1568	1550000
154772	1420	1854877950000
154773	2367	100004201
154774	1593	22994439081402
154775	1423	3600667750023
154776	1807	200000192
154777	2143	200900000
154778	1449	8063016459
154779	2330	1105000000
154780	1489	17663346040000
154781	1527	323999926
154782	2358	50109000000
154783	2332	100004500
154784	2004	200046263
154800	1397	1255461681000
154801	1678	29520912419000
154802	2441	927007000000
154803	2133	8000156000
154804	2132	6511526000
154805	1874	18672000
154806	2134	10953123000
154807	1874	18676000
154808	2133	7999154000
154809	1874	18678000
154810	2134	10952119000
154811	1874	18682000
154812	2134	10951115000
154813	2134	10950111000
154814	1874	18690000
154815	2134	10949107000
154816	2132	6510525000
154817	1874	18695000
154818	1588	21301085000000
154824	1397	1255451680000
154825	1678	29520912420000
154826	1397	1255441679000
154827	1678	29520912421000
154828	1397	1255431678000
154829	1678	29520912422000
154830	2134	10948103000
154831	2132	6509524000
154832	1874	18700000
154833	2132	6508523000
154834	1874	18701000
154835	2132	6507522000
154836	2132	6506521000
154837	1874	18703000
154838	2134	10947099000
154839	1874	18707000
154840	2134	10946095000
154841	2134	10945091000
154842	1874	18715000
154843	2134	10944087000
154844	1874	18719000
154845	2134	10943083000
154846	1874	18723000
154847	2134	10942079000
154848	2133	7998152000
154849	2133	7997150000
154850	2133	7996148000
154851	1874	18733000
154852	2134	10941075000
154853	1874	18737000
154854	2134	10940071000
154855	2134	10939067000
154856	1874	18745000
154857	2134	10938063000
154858	2134	10937059000
154859	2134	10936055000
154860	1874	18757000
154861	2133	7995146000
154862	2133	7994144000
154863	2133	7993142000
154864	2133	7992140000
154865	1402	70744293811104
154866	1402	70744347811104
154882	1619	15840379000000
154883	1619	15840398000000
154887	1874	18766000
154888	1874	18770000
154889	1874	18772000
154890	1619	15840394000000
154943	1670	18001233474382
155022	1397	1255321667000
155023	1678	29520912433000
155024	2134	10891879000
155025	1874	19002000
155026	2133	7968092000
155027	2133	7967090000
155028	2132	6490505000
155029	1726	109108112000
155030	2447	100000000
155031	1726	109007112000
155032	1538	100000000
155033	2132	6489504000
155034	2134	10890875000
155035	1874	19012000
155036	2134	10889871000
155037	2134	10888867000
155038	1874	19020000
155039	1718	11776684519070
155044	1397	1255311666000
155045	1678	29520912434000
155046	2134	10887863000
155047	2134	10886859000
155048	1874	19028000
155049	2132	6488503000
155050	2134	10885855000
155051	2133	7966088000
155052	1874	19035000
155053	2133	7965086000
155054	1394	1172177575299216
155055	1394	1172177593299216
155084	1397	1255291664000
155085	1678	29520912436000
155086	1397	1255281663000
155087	1678	29520912437000
155088	2133	7961078000
155089	2133	7960076000
155090	2134	10879831000
155091	1874	19072000
155092	2133	7959074000
155093	2132	6486501000
155094	2134	10878827000
155095	2133	7958072000
155096	1874	19081000
155097	2132	6485500000
155098	2134	10877823000
155099	1874	19086000
155100	2134	10876819000
155101	1874	19090000
155102	2132	6484499000
155103	2134	10875815000
155104	1874	19095000
155105	2134	10874811000
155106	1874	19099000
155107	2134	10873807000
155108	1874	19103000
155109	2134	10872803000
155110	1874	19107000
155111	2134	10871799000
155112	1796	200000069
155113	1568	2425000
155114	2367	100008001
155115	1604	3800000
155116	2126	254800006
155117	1807	200000352
155118	1673	16055581504653
155119	2332	100028300
155120	2004	200039830
155275	1397	1255191654000
155276	1678	29520912446000
155277	1397	1255181653000
155278	1678	29520912447000
155279	1397	1255171652000
155280	1678	29520912448000
155281	2132	6471486000
155282	2133	7936028000
155283	2132	6470485000
155284	2133	7935026000
155285	1874	19299000
155286	2133	7934024000
155287	2133	7933022000
155288	1874	19307000
155289	1874	19311000
155060	1573	12099669000000
155123	333	66209360726895
155124	2015	333750000000
155125	1397	1255271662000
155126	1678	29520912438000
155127	1397	1255261661000
155128	1678	29520912439000
155129	1397	1255251660000
155130	1678	29520912440000
155131	1397	1255241659000
155132	1678	29520912441000
155133	2440	531992750000
155134	664	66011484726895
155135	2132	6483498000
155136	1874	19112000
155137	2134	10870795000
155138	1874	19116000
155139	2132	6482497000
155140	2132	6481496000
155141	1874	19118000
155142	2132	6480495000
155143	2132	6479494000
155144	1874	19120000
155145	2134	10869791000
155146	1874	19124000
155147	2134	10868787000
155148	2134	10867783000
155149	1874	19132000
155150	2134	10866779000
155151	1874	19136000
155152	2134	10865775000
155153	2132	6478493000
155154	1874	19141000
155155	2133	7957070000
155156	2133	7956068000
155157	1874	19145000
155158	2133	7955066000
155159	1874	19147000
155160	2133	7954064000
155161	2133	7953062000
155162	1874	19151000
155163	2133	7952060000
155164	1874	19153000
155165	2134	10864771000
155166	1874	19157000
155167	2134	10863767000
155168	1874	19161000
155169	2134	10862763000
155170	2134	10861759000
155171	2134	10860755000
155172	2134	10859751000
155173	1874	19177000
155174	2134	10858747000
155175	2134	10857743000
155176	1874	19185000
155177	2134	10856739000
155178	2134	10855735000
155179	1874	19193000
155180	2134	10854731000
155181	2134	10853727000
155182	1874	19201000
155183	2133	7951058000
155184	1874	19203000
155185	2133	7950056000
155186	2133	7949054000
155187	2133	7948052000
155188	2133	7947050000
155189	1874	19211000
155190	2148	15120452880750
155191	2148	15120631880750
155192	632	85437980000000
155259	1397	1255201655000
155260	1678	29520912445000
155261	2132	6472487000
155262	2133	7939034000
155263	1874	19289000
155264	2133	7938032000
155265	2133	7937030000
155266	1874	19293000
155267	1749	2882626529980
155268	1749	2882640529980
155415	1397	1255121647000
155416	1678	29520912453000
155417	1397	1255111646000
155418	1678	29520912454000
155419	1397	1255101645000
155420	1678	29520912455000
155421	1397	1255091644000
155422	1678	29520912456000
155423	150	66932427747169
155424	2449	0
155425	2133	7915988000
155426	2133	7914986000
155427	1874	19487000
155428	2132	6461476000
155429	2132	6460475000
155430	1874	19489000
155431	2132	6459474000
155432	2132	6458473000
155433	2132	6457472000
155434	1874	19492000
155435	2132	6456471000
155436	2133	7913984000
155437	2133	7912982000
155438	1874	19497000
155439	2133	7911980000
155440	1874	19499000
155441	2133	7910978000
155442	2133	7909976000
155443	2133	7908974000
155444	1874	19505000
155445	2133	7907972000
155446	2133	7906970000
155447	1874	19509000
155448	2133	7905968000
155449	1874	19511000
155450	1602	18576863857496
155572	1716	5760151000000
155584	2134	10766379000
155585	1715	14423675663945
155586	1715	14423690663945
155593	2134	10765375000
155594	1874	19692000
155595	2134	10764371000
155596	2134	10763367000
155597	1874	19701000
155598	2134	10762363000
155599	1874	19705000
155600	1395	58374634611906275
155601	1395	58374634626906275
155603	610	68880071000000
155637	1397	1255001635000
155638	1678	29520912465000
155639	2132	6444459000
155640	1874	19741000
155641	2132	6443458000
155642	2134	10753327000
155643	1874	19746000
155644	2134	10752323000
155645	2134	10751319000
155646	1874	19754000
155647	2134	10750315000
155648	1874	19758000
155649	1679	31679044746974
155650	1679	31679060746974
155655	1874	19756000
155656	100	66769680000000
155657	1397	1254991634000
155658	1678	29520912466000
155659	2132	6442457000
155660	1874	19759000
155661	1746	7009093999989
155669	1747	10866275599975
155706	1693	3069660825590
155707	1693	3069671825590
155726	1397	1254921627000
155727	1678	29520912473000
155728	2134	10737263000
155729	1874	19820000
155730	2133	7892942000
155731	1874	19822000
155732	1690	193685988000000
155733	1796	200000077
155734	1568	2650000
155735	1807	200000375
155736	1690	193685988939967
155737	2332	100088300
155738	2004	200039947
155739	1571	7520895388475
155066	2134	10883847000
155067	2132	6487502000
155068	1874	19050000
155069	2133	7962080000
155070	1874	19052000
155071	2134	10882843000
155072	1874	19056000
155073	2134	10881839000
155074	1874	19060000
155075	1457	17280421800000
155076	2134	10880835000
155077	1457	18000421800000
155078	1568	2300000
155079	2367	100007901
155080	1807	200000344
155081	1457	18000422774789
155082	2332	100008100
155083	2004	200039794
155121	1564	16207214504653
155194	1397	1255231658000
155195	1678	29520912442000
155196	2132	6477492000
155197	1874	19142000
155198	1874	19148000
155199	1874	19150000
155200	1874	19158000
155201	1874	19162000
155202	1874	19170000
155203	1874	19174000
155204	1874	19182000
155205	1874	19190000
155206	1874	19198000
155207	2134	10852723000
155208	1874	19206000
155209	2134	10851719000
155210	2134	10850715000
155211	1874	19214000
155212	2134	10849711000
155213	2134	10848707000
155214	1874	19222000
155215	1874	19226000
155216	1874	19228000
155217	2132	6476491000
155218	1874	19233000
155219	2133	7946048000
155220	1874	19235000
155221	2133	7945046000
155222	1402	72184395210775
155223	1402	72184489210775
155258	2148	15840606880750
155269	2134	10838667000
155270	2134	10837663000
155271	1874	19301000
155272	2134	10836659000
155273	2134	10835655000
155274	1749	2882644529980
155332	43	82561880911580
155333	43	83281880911580
155334	1568	1925000
155335	43	83281888886366
155336	1807	200000300
155337	2004	200039578
155414	1623	91443697541458
155487	1397	1255071642000
155488	1678	29520912458000
155489	2132	6455470000
155490	1874	19518000
155491	2132	6454469000
155492	1874	19519000
155493	1874	19527000
155494	2133	7901960000
155495	2133	7900958000
155496	2133	7899956000
155497	1874	19573000
155498	1874	19577000
155499	1874	19581000
155500	1874	19585000
155501	2134	10786459000
155502	1874	19597000
155503	1705	33681243580140
155504	2134	10785455000
155505	1874	19601000
155506	2134	10784451000
155507	2134	10783447000
155508	1874	19609000
155509	2134	10782443000
155510	2134	10781439000
155511	2134	10780435000
155512	1874	19621000
155513	2134	10779431000
155514	1874	19625000
155515	2132	6453468000
155516	1705	34401243580140
155517	1568	2550000
155518	2367	100008401
155519	1604	4000000
155520	1807	200000363
155521	2336	100048003
155522	2252	201600000
155523	1705	34401250950973
155524	2332	100058300
155525	2004	200039911
155526	1571	7520895388467
155555	1397	1255051640000
155556	1678	29520912460000
155557	2134	10773407000
155558	2134	10772403000
155559	1726	107805112000
155560	2450	100000000
155561	2132	6451466000
155562	1874	19662000
155563	2132	6450465000
155564	1874	19663000
155565	2134	10771399000
155566	1874	19667000
155567	2134	10770395000
155568	1686	22712303700123
155570	1716	5040400330360
155571	1716	5760400330360
155573	1397	1255041639000
155574	1678	29520912461000
155575	2132	6449464000
155576	1874	19672000
155577	2134	10769391000
155578	2134	10768387000
155579	1874	19680000
155580	2134	10767383000
155581	1874	19684000
155582	1394	1173617610803869
155583	1394	1173617624803869
155615	2134	10761359000
155616	1874	19709000
155617	2134	10760355000
155618	1874	19714000
155619	1874	19716000
155620	2134	10759351000
155621	1874	19720000
155622	2134	10758347000
155623	1874	19724000
155624	2134	10757343000
155625	2134	10756339000
155626	1874	19732000
155627	2134	10755335000
155628	1874	19736000
155629	2134	10754331000
155630	1874	19740000
155631	1395	58374634642906275
155633	1471	22985604900000
155653	1455	8671658000000
155654	1455	8671674000000
155671	1397	1254981633000
155672	1678	29520912467000
155673	2132	6441456000
155674	1874	19772000
155675	2134	10746299000
155676	2132	6440455000
155677	1874	19777000
155678	2134	10745295000
155679	1874	19781000
155680	2134	10744291000
155681	1874	19785000
155682	2134	10743287000
155683	1439	18704034513346
155684	1439	18704050513346
155711	2261	17999588985774
155713	1397	1254941629000
155714	1678	29520912471000
155715	2440	531988750000
155716	2132	6439454000
155717	2134	10739271000
155718	1874	19810000
155719	2133	7893944000
155721	1397	1254931628000
155722	1678	29520912472000
155723	2134	10738267000
155724	1692	25661529819983
155725	1692	25661540819983
155740	1587	22320629199717
155741	1587	23040629199717
155742	1587	23040630139684
155290	1874	19315000
155291	2134	10834651000
155292	1874	19323000
155293	1467	11680453272861
155294	2134	10833647000
155295	1874	19327000
155296	2134	10832643000
155297	1874	19331000
155298	2132	6469484000
155299	2132	6468483000
155300	1874	19333000
155301	2133	7932020000
155302	1874	19335000
155303	2134	10831639000
155304	2134	10830635000
155305	1874	19343000
155306	2134	10829631000
155307	2134	10828627000
155308	1874	19351000
155309	2134	10827623000
155310	2134	10826619000
155311	1874	19359000
155312	2134	10825615000
155313	2133	7931018000
155314	2133	7930016000
155315	1874	19367000
155316	2133	7929014000
155317	2133	7928012000
155318	2134	10824611000
155319	1874	19375000
155320	2134	10823607000
155321	2134	10822603000
155322	1874	19383000
155323	1467	12400453272861
155324	1796	200000072
155325	1568	2475000
155326	2367	100008101
155327	1467	12400472122718
155328	1807	200000357
155329	2252	201200000
155330	2004	200039857
155331	1571	7520895388451
155374	1672	21601859899790
155396	1397	1255131648000
155397	1678	29520912452000
155398	597	66543509084035
155399	2446	1100000000
155400	2132	6462477000
155401	2134	10808547000
155402	2134	10807543000
155403	2133	7918994000
155404	1874	19467000
155405	2134	10806539000
155406	1874	19471000
155407	2134	10805535000
155408	2134	10804531000
155409	1874	19479000
155410	2133	7917992000
155411	1874	19481000
155412	2133	7916990000
155413	1711	20587131642860
155481	1397	1255081643000
155482	1678	29520912457000
155483	2133	7904966000
155484	2133	7903964000
155485	1874	19515000
155486	2133	7902962000
155604	1397	1255021637000
155605	1678	29520912463000
155606	1397	1255011636000
155607	1678	29520912464000
155608	2132	6447462000
155609	1874	19706000
155610	2132	6446461000
155611	2132	6445460000
155612	1874	19708000
155613	1610	22320539999950
155614	1610	22320562999950
155651	1608	21738689000000
155652	1608	21738705000000
155670	1395	58374634747906275
155686	1397	1254971632000
155687	1678	29520912468000
155688	1397	1254961631000
155689	1678	29520912469000
155690	2133	7895948000
155691	1874	19791000
155692	2133	7894946000
155693	2134	10742283000
155694	1541	2313000000
155695	1718	15376664519070
155696	2134	10741279000
155697	1608	21738714000000
155699	1874	19775000
155700	1608	21738724000000
155708	2261	17999589985774
155709	1402	72904489210775
155710	1402	72904500210775
155369	1672	21601868899790
155370	2367	100008301
155371	1807	200000358
155372	2252	201300000
155373	1571	7520895388459
155375	1397	1255141649000
155376	1678	29520912451000
155377	2132	6464479000
155378	2132	6463478000
155379	1874	19402000
155380	2133	7922000000
155381	2133	7920998000
155382	1874	19418000
155383	2133	7919996000
155384	1874	19420000
155385	1874	19428000
155386	1874	19436000
155387	1874	19440000
155388	2134	10812563000
155389	1874	19444000
155390	2134	10811559000
155391	2134	10810555000
155392	2134	10809551000
155393	1874	19456000
155394	1395	58373914583906275
155395	1395	58373914611906275
155451	2134	10803527000
155452	2134	10802523000
155453	1874	19496000
155454	2134	10801519000
155455	1874	19500000
155456	2134	10800515000
155457	1874	19504000
155458	1874	19508000
155459	2134	10799511000
155460	1874	19513000
155461	2134	10798507000
155462	2134	10797503000
155463	2134	10796499000
155464	1874	19525000
155465	2134	10795495000
155466	1874	19529000
155467	2134	10794491000
155468	2134	10793487000
155469	2134	10792483000
155470	2134	10791479000
155471	1874	19553000
155472	1874	19555000
155473	1874	19557000
155474	1874	19561000
155475	2134	10790475000
155476	2134	10789471000
155477	2134	10788467000
155478	1874	19575000
155479	2134	10787463000
155480	1602	18576880857496
155527	1397	1255061641000
155528	1678	29520912459000
155529	2133	7898954000
155530	2133	7897952000
155531	1874	19630000
155532	2133	7896950000
155533	2134	10778427000
155534	2134	10777423000
155535	1874	19640000
155536	2134	10776419000
155537	2132	6452467000
155538	1726	108906112000
155539	1538	200000000
155540	2134	10775415000
155541	1874	19649000
155542	2134	10774411000
155543	1874	19653000
155544	1679	30959027656999
155545	1796	200000074
155546	1568	2600000
155547	1679	30959044746974
155548	2126	255050006
155549	1807	200000371
155550	2252	201700000
155551	697	66000004999990
155552	1527	309999940
155553	2332	100078300
155554	2004	200039929
155569	2248	14399612000000
155587	1397	1255031638000
155588	1678	29520912462000
155589	2132	6448463000
155590	1874	19689000
155591	1688	65592224545072
155592	1688	65592235545072
155602	1718	11776679519070
155632	1610	22320570999950
155634	1673	16055577000000
155635	2329	350647449194886
155636	2329	350647480194886
155662	100	66769670000000
155663	100	66769660000000
155664	2134	10749311000
155665	2134	10748307000
155666	1874	19767000
155667	2134	10747303000
155668	2292	3599212000000
155685	1439	18704046513346
155698	1694	21419197197225
155701	1397	1254951630000
155702	1678	29520912470000
155703	2134	10740275000
155704	1451	11947903000000
155705	1451	11947914000000
155712	1693	3069670825590
155720	1685	204485147571430
\.


--
-- Data for Name: blocks; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks (id, state_hash, parent_id, parent_hash, creator_id, block_winner_id, snarked_ledger_hash_id, staking_epoch_data_id, next_epoch_data_id, ledger_hash, height, global_slot, global_slot_since_genesis, "timestamp") FROM stdin;
1	3NKeMoncuHab5ScarV5ViyF16cJPT4taWNSaTLS64Dp67wuXigPZ	\N	3NLoKn22eMnyQ7rxh5pxB6vBA3XhSAhhrf7akdqS6HbAKD14Dh1d	1676	1676	1	1	2	jx7buQVWFLsXTtzRgSxbYcT8EYLS8KCZbLrfDcJxMtyy4thw2Ee	1	0	0	1615939200000
2	3NLyWnjZqUECniE1q719CoLmes6WDQAod4vrTeLfN7XXJbHv6EHH	1	3NKeMoncuHab5ScarV5ViyF16cJPT4taWNSaTLS64Dp67wuXigPZ	1407	1395	1	1	3	jwCtBkoHByTR65wDXSWXFJBQQ59trDsH3NfCh4czw7ur8ZtjkiV	2	1	1	1615939380000
3	3NKd5So3VNqGZtRZiWsti4yaEe1fX79yz5TbfG6jBZqgMnCQQp3R	2	3NLyWnjZqUECniE1q719CoLmes6WDQAod4vrTeLfN7XXJbHv6EHH	1405	867	1	1	4	jx98RBFA7dS1wf5rS6pFt1HX4SUPVTUjSj2ji6Ab87hCY7a8XRh	3	2	2	1615939560000
4	3NL9qBsNibXPm5Nh8cSg5CCqrbzX5VUVY9gJzAbg7EVCF3hfhazG	3	3NKd5So3VNqGZtRZiWsti4yaEe1fX79yz5TbfG6jBZqgMnCQQp3R	80	1273	1	1	5	jxw3wNhAUhyVT4AK4dGxtn4Kpx6pvk3AXVoi2A6BAEQweyV8Uwe	4	3	3	1615939740000
5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	4	3NL9qBsNibXPm5Nh8cSg5CCqrbzX5VUVY9gJzAbg7EVCF3hfhazG	1477	1350	1	1	6	jwrUXdDdGkJ7xA7vd2s3sjhE4JR3jfxs2AUNKUYaDc83ZLJ6iCL	5	4	4	1615939920000
6	3NKqMEewA8gvEiW7So7nZ3DN6tPnmCtHpWuAzADN5ff9wiqkGf45	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1503	1277	1	1	7	jy24pVnJM6khgDRERUMbK8UPwGHUQggX55xeBinb3vQv4inHzXs	6	5	5	1615940100000
7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1406	1393	1	1	8	jxqrHaBcJzZAPW2rSa84chAxEHW7ot2GbqmRsWuNhwctZ8TFA2K	6	5	5	1615940100000
8	3NKvdydTvLVDJ9PKAXrisjsXoZQvUy1V2sbComWyB2uyhARCJZ5M	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	43	1310	1	1	9	jx4eFvGfdvYQ8bwkuK4FmLjDnxwFHvcysBTRiosC946nnns44U2	6	5	5	1615940100000
9	3NLM3k3Vk1qs36hZWdbWvi4sqwer3skbgPyHMWrZMBoscNLyjnY2	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1460	1198	1	1	10	jwMQWidFmfF7T4tdRP5RVJjJupWPJFUmBqiBibyJgFf6FZ9WCo1	6	5	5	1615940100000
10	3NL7dd6X6316xu6JtJj6cHwAhHrXwZC4SdBU9TUDUUhfAkB8cSoK	7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	1406	1393	1	1	11	jxYNAauXskqWQiwdNjomSFMepSwYHrgeBvFhhGRL1D8wFUVb2im	7	6	6	1615940280000
11	3NLGcwFVQF1p1PrZpusw2fZwBe5HKXGtrGy1Vc4aPkeBtT8nMNUc	7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	1637	816	1	1	12	jwFtwfnhd2PDb15c23uVgNqjS3PNVWP4HpZzYSVGQAv64Y2bdV5	7	6	6	1615940280000
12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	11	3NLGcwFVQF1p1PrZpusw2fZwBe5HKXGtrGy1Vc4aPkeBtT8nMNUc	1581	778	1	1	13	jx4nLzztQxDvRLTShNX355STsSbFxXkD1NVFJ1acTfUWNr9W2Ap	8	7	7	1615940460000
13	3NKK3QwQbAgMSmrHq4wpgqEwXp5pd9B18CMQjgYsjKTdq8CAsuM6	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1503	911	1	1	14	jwD8YdaprwhpRV8Ki6q5dSSnjPh9UmDjcfpuBP9eqZ8p1S9jvoW	9	8	8	1615940640000
14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1656	1097	1	1	15	jxQnxih5zyWLVHxi5n79Af65Gcib78BpmYRxPDeHJaGXyRAh8Du	9	8	8	1615940640000
15	3NKYjQ6h8xw8RdYvGk8Rc3NnNQHLXjRczUDDZLCXkTJsZFHDhsH6	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1652	1315	1	1	16	jwWgD8vcJfT3a17v99jifctcCjSVFQU29uTeE8X5xL26vrz64QL	9	8	8	1615940640000
16	3NKGgTk7en3347KH81yDra876GPAUSoSePrfVKPmwR1KHfMpvJC5	14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	1406	1393	1	1	17	jwDQkke4fjVcxy91DR9cMd1z4JbWfhJK4RaWMpEcyW8QDWSmg2R	10	9	9	1615940820000
17	3NKHYHrqKpDcon6ToV5CLDiheanjshk5gcsNqefnK78phCFTR2aL	14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	1577	961	1	1	18	jwee36gWPsQS2iEu26QixkjaWVvE4Q8vC9B1jVwkFYWyboFittA	10	9	9	1615940820000
18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	16	3NKGgTk7en3347KH81yDra876GPAUSoSePrfVKPmwR1KHfMpvJC5	1579	1023	1	1	19	jxZVWjsyuQkPVSj7ZbqC8PPx8FXzHQjxUYA3bhvdnQQZ15jn7mR	11	11	11	1615941180000
19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	80	1027	1	1	20	jwVZUkFNgb5fBf6ZRBtYXrwWs32erEyPTLXzdduGNhH6F71wjan	12	12	12	1615941360000
20	3NKDpimRQtNPUz8PPwSZVFL7kK83itXDaxYou1sZzYscqmJNNetD	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	1405	881	1	1	21	jxR1Fsbf8HthWBisdMr2H9ZHjRyo8owy7aZd8Lp19r7poEhF7gF	12	12	12	1615941360000
21	3NKaUU9un6G7XgnN4P2Gprsx1NmjUWncHskDKSCn1uyzD44CWsP3	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	1647	845	1	1	22	jwgMw1bmnJxWs5mPW7pM5fGKkUPjk3gzWPFMZriC7idS425569C	12	12	12	1615941360000
22	3NKXzc1hAE1bK9BSkJUhBBSznMhwW3ZxUTgdoLoqzW6SvqVFcAw5	19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	1406	1393	1	1	23	jwoM6sfB6wgGKd8Jtqj2u3dNu8t2fQ2eoMfjEiEyQP5yjdKHcxq	13	13	13	1615941540000
23	3NKHEHXsScTUd6kMDtoB4tf45MavdXv91qo3HZkLKrkc8XpX5CDv	19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	1513	1133	1	1	24	jwWEndSF3zitf5Lpa1gTpoxzNKQVoQEpFbjQdqXC8PSW9BAh5av	13	13	13	1615941540000
24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	22	3NKXzc1hAE1bK9BSkJUhBBSznMhwW3ZxUTgdoLoqzW6SvqVFcAw5	1656	1217	1	1	25	jwGs6WcWBfbCQ2imLiTMoCooCmr6wAsPeoJNsECuMQXyGBN1RM7	14	15	15	1615941900000
25	3NKkVW47d5Zxi7zvKufBrbiAvLzyKnFgsnN9vgCw65sffvHpv63M	24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	1671	999	1	1	26	jw93aP6yFRU2zCeqMddnTcrX1xRM5aQdwTGjLTNSVKKp6XBhUVr	15	17	17	1615942260000
26	3NLLdKZxuwxPVax8VLCx6sqKYzRvT1cT2vQ1MqHD1pCSktj4PinA	24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	632	1256	1	1	27	jwNWHTfwSUH9hNbH3sV79ceNzX8U2iTeBG94DsSFQHbjTAXGP6q	15	17	17	1615942260000
27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	25	3NKkVW47d5Zxi7zvKufBrbiAvLzyKnFgsnN9vgCw65sffvHpv63M	1637	816	1	1	28	jxtnyRqHcpQACg2XW4tcQP98Wuj6PNjEjUdY3xkrPQ4x7qQWxo3	16	18	18	1615942440000
28	3NKtGiwd1kg2r5Vx7qJ666H8PYkRaG8DTsrKz3DLz7quZkic2zVH	27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	1503	1277	1	1	29	jx2WFh4hpCpFzaoMba888AtBXLQwbY5hQfxKpw5NbNwspYSqPS1	17	20	20	1615942800000
29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	1476	1371	1	1	30	jwKNCo1RwEBmyEZ5K2Wh96q7ptyE9H5MPetZq7Ub7Ku43YwbTjT	17	20	20	1615942800000
30	3NLJq2sfiVtNWSsYHkgJAy2MREmDKc3bD4g24Z5c4Rs8MjW7xwzC	29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	1403	824	1	1	31	jwF8dqux7ehhgCUvBdy6nhzt5394dhZJ7g4sGgTLELFHUboc6EB	18	21	21	1615942980000
31	3NLZhhUTMGiWe9UYxY8aYHvRVSoKJTHgKJvopBdC2RA9KisGfPuo	29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	1634	1085	1	1	32	jxafAkere8pbVuReH5VZMNqz8qPduVUwRyGAAGF6aQmgCUP7HVu	18	21	21	1615942980000
32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	31	3NLZhhUTMGiWe9UYxY8aYHvRVSoKJTHgKJvopBdC2RA9KisGfPuo	1406	1393	1	1	33	jxhmxNsVfao1SSdzuoacnYvBBQeB4L7tJouANagaXRVg9sQ3tJt	19	22	22	1615943160000
33	3NL7a7hz1wBwSyebWJ7CLvVPVPreWc5G7yoySrNmhtGaRuFV74hi	32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	1406	1393	1	1	34	jxyyWuhkAiZSiEzTNqe7j6S4dqBphSQhS8ffEZ1cjb7WQ1YiHz8	20	23	23	1615943340000
40	3NLVctcthSLkPTjZ9ZPdmfqeD6grbXPAYRRFWkkKFnxw3f6svKPj	38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	1619	909	1	1	41	jxCXECybgUm3z1ibN1tERHJbWQedB4fQuGGzDJ8m4SZiVDJPDr9	25	32	32	1615944960000
41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	80	1273	1	1	42	jxHSh5orES6maFGFacDW9hEtgn6SGyMbb2cA3Pk2QAUnrqwctMc	26	33	33	1615945140000
44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1407	1395	1	1	45	jxNBCzxPKpqd4nDSREDgMvniuW8rj1gPDAJtgdPitaDT2KuGwJc	27	34	34	1615945320000
46	3NKsxA2WUYgmXM6WE5Qk7xRDPipsfBtqcdeVU2k7UcyGzQwm6sRJ	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1406	1393	1	1	47	jwHwjkkCHwWox3KhDW3T83Ps2i9VeRN4Jpv9Stx3HEsewqeJo3k	27	34	34	1615945320000
47	3NLE9tTNvK9smvS16afzMhiYdAW5YZkqzQRHLoxpxcHHJ9Gr1LDh	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1553	776	1	1	48	jwDutueBB8KzMjt8VjqwRgP64aP92uDKAfvUZoq28Sz5HVsG3GT	27	34	34	1615945320000
48	3NLwyF8poBuv19sfzVH7Pyc47TabSdzPK3TfbnJamS9yNyWkkAxo	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1447	1099	1	1	49	jx3PqUmEDxm1JKvsp2wAisb9zCMndJx8h9Kwixrr9yUT4RJRZB3	28	35	35	1615945500000
51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	48	3NLwyF8poBuv19sfzVH7Pyc47TabSdzPK3TfbnJamS9yNyWkkAxo	1546	1213	1	1	52	jwAB49n5jJs1yriuVSfFXaKY7ory9Kf3WWsTwbHxfqibnwZmcdw	29	36	36	1615945680000
34	3NLPpt5SyVnD1U5uJAqR3DL1Cqj5dG26SuWutRQ6AQpbQtQUWSYA	32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	1474	1203	1	1	35	jxcMQgBgvPT9CABuws7TKa1JAmJ23GiciewYYwcYdh9Y7u2GJvD	20	23	23	1615943340000
39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	1607	1102	1	1	40	jwnxMJTRc79MUqpiX9bKFfcsnBQS5a4ncwhU1HrMxLpawN2kjry	25	32	32	1615944960000
42	3NLtkfBsNLZGq26MdXo7LGTos15GrURu5CkwDh78JSf6tEKwfL6x	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	1406	1393	1	1	43	jxW8myYxLQAx5ptqR7qNGXFiexNHpsokAtU3LoNEyGBkDQcEWZP	26	33	33	1615945140000
45	3NKidUELim7Dvc2jrewJjoojDtTqqynoPmGwgU7n8VVe1j4CaDzj	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1654	974	1	1	46	jwLV9aeJzA53BEP4TGoCY3n7DFkZCXrxSEhVtVieMj84WuFFKCE	27	34	34	1615945320000
50	3NKaYKL5hUtGo5RSKxCtNYzEYaMYe658157az7Nk2T7Phr1oarAh	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1547	1132	1	1	51	jwikZFY3v82BeNPxhyNo4MXCrUMvSpFwmDEvsToYh6bi3d8WVzf	28	35	35	1615945500000
35	3NKZ6DTHiMtuaeP3tJq2xe4uujVRnGT9FX1rBiZY521uNToSppUZ	34	3NLPpt5SyVnD1U5uJAqR3DL1Cqj5dG26SuWutRQ6AQpbQtQUWSYA	1474	1329	1	1	36	jxmr2WKiGk3bi4yNp46RMWAppXJsdhafYi6Rwhy5y4t1vKunvMg	21	24	24	1615943520000
36	3NLHt6ojM9EWVE5MgZ4YjZ4bjEuzumZCfE6csRWWihC7pHmv8jW4	35	3NKZ6DTHiMtuaeP3tJq2xe4uujVRnGT9FX1rBiZY521uNToSppUZ	1460	376	1	1	37	jxKqFF5iBTxtmPbeWZsmqUek485yWArtL5rX9NseNu5BhVCSBCJ	22	25	25	1615943700000
37	3NKbWvjyJgCkAPm3T6Q5qNJxQsuVFqTw9fd4TzhmUAjFizJ1XTCf	36	3NLHt6ojM9EWVE5MgZ4YjZ4bjEuzumZCfE6csRWWihC7pHmv8jW4	55	509	1	1	38	jwUaJ45BU36DrWwSAT6zTvfYTL38imKVDMps9ryY88FG1WuBpoK	23	28	28	1615944240000
38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	37	3NKbWvjyJgCkAPm3T6Q5qNJxQsuVFqTw9fd4TzhmUAjFizJ1XTCf	1407	1395	1	1	39	jw8gMXbxvHzkq95BodwDTheBfzTCHqKy1P5k1Djuaze45jB6u3G	24	31	31	1615944780000
43	3NKscz4fVou6AUG2qZ7WkJk2ijubgcYFukbpd8Q2KGi5yTi6nWyq	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	1637	816	1	1	44	jxU1kKkSy6t25WTbPhYXG2ugczxMRtEWXuzU4r3zDuQVzbEPwB7	26	33	33	1615945140000
49	3NKGvigwGX8B95ZepxgcgXYJ5FtBkVmexqApb9KfSs2Si5sqdYFC	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1546	1339	1	1	50	jwnizex29ZSUE8wdH2BK3jQbTa8S28tgvVvUFomWRpW1gUVJBQq	28	35	35	1615945500000
52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	1406	1393	1	1	53	jwDsm6EkFKk5XuAR1x92iMqPEzonGuWr2BBAX2BmL5235wD2CmG	30	37	37	1615945860000
53	3NLpGhdRifLr31DGc61jUhsAdZiTy7EUw8cap41jrmzbTem5hc3V	51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	1559	1107	1	1	54	jxJZY8GVkta9jV21ipS2tyGKxFJUwF3msqRRxuGGYoaw26cQs3b	30	37	37	1615945860000
54	3NKQzfWDJSQkYrNC61nrMqMgJiVvrsvyF2e8Xtx18Vt4LvbasE9Z	52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	1403	824	1	1	55	jx7T8En89gQUHXBRtLpCBNedBLWkerFzpbgJ2gER2sNjmYffgMV	31	39	39	1615946220000
55	3NL7yV9h6ihis5BQEYoLF2ewR31NJZNamo3L71HZwEBa7MLyQiZ3	52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	1573	952	1	1	56	jxL5ENQkKBishdQMpo9SKdxUENiGLc1B9NfA7fG4Q6Eh5Ls9GiS	31	39	39	1615946220000
56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	55	3NL7yV9h6ihis5BQEYoLF2ewR31NJZNamo3L71HZwEBa7MLyQiZ3	1602	1369	1	1	57	jxrRGoEaXBVaSajW7K8d1YmU39Qv7k1kziwo9WNDJ81SKeWUvD2	32	40	40	1615946400000
57	3NKREKrhaAzKrpaC5JTD9oq5idtUsfZ9BWugaNbMGSngAon6VchZ	56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	1447	1345	1	1	58	jxqcLumdg9ennsTrkzxEfeCpM2JYjKFd1xo5CchXUpeaXoMTMtK	33	41	41	1615946580000
58	3NLWKJycMJbbVFgsedUj9hAKF7QzUcfoxBSt6K4eHzQ8B37xRwQ3	56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	1648	918	1	1	59	jy37nJKPgpBDaS3ZfFfjAz9BDBCtBG9Jr2dykkzyab5tdWKKmmV	33	41	41	1615946580000
59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	58	3NLWKJycMJbbVFgsedUj9hAKF7QzUcfoxBSt6K4eHzQ8B37xRwQ3	1406	1393	1	1	60	jwgvRFXTJ5NmdDf27wx1mgf1kiMzGXxc85Jnx5dTsLZJDZwNXjU	34	42	42	1615946760000
60	3NKF1TaV6jJc1sLVqMEKuWjTksDbYBFvMuCx7UTf5FJQjy77Gc4L	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1406	1393	1	1	61	jwcnWYriawp31Z6TWHrVZx7GZce1gNT77fiXoRfzXLqm7tQyt1c	35	43	43	1615946940000
61	3NKY38U72tAB4Tt2yLM6isEoyrJFDmDPUCGL5uf2gS8Zx19jCoRx	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1587	1357	1	1	62	jxDZKRNDKqWme1QCWWdq2G1L8YN3z4FGUGGUhbaQkpWC1VTZrye	35	43	43	1615946940000
62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1631	794	1	1	63	jxHfzJxavps5hFRcweor4KX1chjnNgYnKuKgt6bCkoy7ke5ZBEH	35	43	43	1615946940000
63	3NKPeTYgM1vUrF7wwa8fwVPE4UeqYEFxBURKGWiWHSwfbUo9pZvb	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1444	1381	1	1	64	jxGsnsRXWuyD1nrWKaUW2B8VXi4qLVR4ooudezkd6hxwcmdc8fJ	36	44	44	1615947120000
64	3NK67TjTno1bN7H1uKV5B2ZaCyAua8dvBGMkKRVtquaTck6La91v	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1407	1395	1	1	65	jwVppRb4sh6dF1zeohRgZQJG2z9u2Bmwj3QFjn3WAVBH9YtoFhu	36	44	44	1615947120000
65	3NLAM3XtX6gcV3HPAeM4KPYnGSX7CF4C2mfHZnn29wijozEp7QtJ	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1619	909	1	1	66	jwFmfS2w7DzmqS46WfZskxF9796bvi7wNH7QJLvo3RPkcvaarP9	36	44	44	1615947120000
66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	63	3NKPeTYgM1vUrF7wwa8fwVPE4UeqYEFxBURKGWiWHSwfbUo9pZvb	1654	1094	1	1	67	jxsmtoHcPt8vmtdaBdJH2nmQzSnpoUGf4UasvA7XpHz82GJWnKJ	37	45	45	1615947300000
67	3NKmJGt3kDyafEHnF6JamW5hdtwJgVytKkYpH6tFkmUyYePPKrzM	66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	1406	1393	1	1	68	jwUjxoK5Jh9KJHWQNWA1y2cEnE2u8YVQYznNB4F6fdR98uxHJer	38	47	47	1615947660000
68	3NKHRjmpWr3HTbTNfVXUS6cNtM7gdHvVzojRGxsh428eP3kS1N3t	66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	1483	1030	1	1	69	jxh2d8M2bstEMSXFYd9UyxYTmRM8XHcMDV95KLUtEQpVPgwpwAe	38	47	47	1615947660000
69	3NKwuqkJGrJRKJg3nUwjK6YnJ4aftExS3ZuMbHSjhEPc1oxtUaSu	67	3NKmJGt3kDyafEHnF6JamW5hdtwJgVytKkYpH6tFkmUyYePPKrzM	1483	275	1	1	70	jwrVmU2zshURS9z5FFQbCkYx7gwj2kbfUhpqNHr9M11yTp3D4CX	39	48	48	1615947840000
70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	69	3NKwuqkJGrJRKJg3nUwjK6YnJ4aftExS3ZuMbHSjhEPc1oxtUaSu	1407	1395	1	1	71	jxgTsrrr69sy5XMaECcM3F3fnveD1YZizHdWTdNQekhD1YAQoaa	40	49	49	1615948020000
71	3NKEsy4j1ZQLMGZAJt7q2e3tMoFPJ6UudGga3CmKZnoSKEHnmq2g	70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	1596	1363	1	1	72	jxo8mMqocJ1Jcm83JLN7B3HR2ZxSxqDb7Rccsut4Jmz3CxD21JS	41	50	50	1615948200000
72	3NKd8FSjqsZzaTK4LDvBEaafS5X36VipWcydr4HaYwtt84kUZeFd	70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	311	941	1	1	73	jxRprdeMkwgZN9u3amjFn2LrnSkPFD4tmCbSrPkrpiqntpD92vM	41	50	50	1615948200000
73	3NLuesuqs8NoehpUnNouzr6ArcmQcnjQhJaGsPfHMpT7BQZD6erj	72	3NKd8FSjqsZzaTK4LDvBEaafS5X36VipWcydr4HaYwtt84kUZeFd	1622	1110	1	1	74	jwEvJh6shAEEqxHv2nK3zykQfh9MNo7nX5F7dJJA13xMinrfmkj	42	51	51	1615948380000
74	3NLAgYAh6UdzRsDKwzYKegdEoB71u6s5z9Kh5gejGQGquchy1qoN	73	3NLuesuqs8NoehpUnNouzr6ArcmQcnjQhJaGsPfHMpT7BQZD6erj	1534	574	1	1	75	jx7s4w4BmdkzABhLcj6bpytgb4quhdcdNLKqNpK8RAfEgM4ux5a	43	52	52	1615948560000
75	3NK8xY5aCcBj7zVLk1DZRiw4NVsrqwQHNey5V8kDw3bYCuN6S3zR	74	3NLAgYAh6UdzRsDKwzYKegdEoB71u6s5z9Kh5gejGQGquchy1qoN	1547	1012	1	1	76	jxamcWH8ZELLnaYEDVdxnQ7yp2J2EQUaBFrbNZoLs8qtsZiSsQ9	44	53	53	1615948740000
76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	75	3NK8xY5aCcBj7zVLk1DZRiw4NVsrqwQHNey5V8kDw3bYCuN6S3zR	1613	1349	1	1	77	jwVqLsDbPSk5nGfnebop9h3KYo8VGHQiLcLDj8CQ6YEUiPfiZBw	45	55	55	1615949100000
77	3NLa3ZxXMMqrBUjqKbsSeuCPLABnrTBj9rapDNxYQEKGfokg8D5r	76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	1458	1197	1	1	78	jxSvZbSNN2v6cPmWx5YXMPbLLg16xu8DCXHqDWQMh4qkDzrvBAu	46	57	57	1615949460000
78	3NK7dbrMhBb8ittPPh86yR9Ym3ox9VdzYgPtgm6evdcgyPBCDiCL	76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	1623	839	1	1	79	jwFg6PoWdVx6y1Wrk358Ew1Nw8tRnZVpK4JPyj8JdL7Fg6axYtk	46	57	57	1615949460000
90	3NLuaJ8A7ubV4vFtc6YtnPUaMpiKAks2d7HmXByH6NkRS8EKG9Q8	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1406	1393	1	1	91	jwSgRBkXhc79WMaek6Dyo2ZQFXkYtN6A1VWZCRZ49GegHSNN5i8	57	73	73	1615952340000
93	3NKYGK7R7TJP4vHNifuZYUJygoikskpjKULVWjKur9wRMKE7obNB	90	3NLuaJ8A7ubV4vFtc6YtnPUaMpiKAks2d7HmXByH6NkRS8EKG9Q8	1489	1380	1	1	94	jx7sVUMpH37FtqtZohESoPtWRYbmEEaUneTdgLPt1DUQCa6uPq9	58	74	74	1615952520000
96	3NKu5MoEy2xvRMpKCg5FYVJ13paiFPzM3cuof5qr46v7XfXuRAdg	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1527	1293	1	1	97	jxnYeqGnNAGpB2w6CB2S5dTs5yNdbBJ1cSwyFRdFvoKzjrN4AS2	60	78	78	1615953240000
101	3NKBupxvxcso3xiWQr3f4fzPJQhSh9efLJMoA49aqKbrjC3saRsv	99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	1581	778	1	1	102	jxH7aJncfq7YfQQeUbH5JQeQ4gBDwHJQ2GNhHFmD1mWm5CYzpkj	62	82	82	1615953960000
103	3NLReQ6wpqdUYKoiprFYqkmsAsK2JyU94CaR3vTphqBaNWzmdoBF	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1527	1293	1	1	104	jxAfJX2WF6hHFVz255LgThwozENP6oA5aBaCgojvhAo3Uvri7CM	63	84	84	1615954320000
108	3NKMEx8HJZceqUX1h6RGrZJDKdAiYeXJ2PY2Rd17teVfQiSvvu4z	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1406	1393	1	1	109	jwUmHfBVHNJu8y9BSEw85S1Rx4DUnAU32DvU1wTvSgDjwuPxfUK	66	89	89	1615955220000
79	3NKdPZWJtwYTY6mpeTEgf2RbfLaJTV5HoAYy3GZcvJJ2cE8qTRVp	77	3NLa3ZxXMMqrBUjqKbsSeuCPLABnrTBj9rapDNxYQEKGfokg8D5r	1649	1257	1	1	80	jxwSP6uwv6mdmT7P7MPxLnVjxvakDjNTVJpi33nA8EWWUFdKE4e	47	58	58	1615949640000
82	3NLJeP3pBr2UFgLZpNgwKEw37UeYEsyuP63U9A3Q8D8ATBStWw6Y	81	3NLoHwSAML7FfGQLiEF4Fz4D2P1uaYZ3u5hwwGjBx8ELRqZyTcG1	1542	1304	1	1	83	jxKMWHWCvoWYfxTpZrmsBcUKBQg6n2oGX54FTuBMk4f9QtEMZhD	50	62	62	1615950360000
83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	82	3NLJeP3pBr2UFgLZpNgwKEw37UeYEsyuP63U9A3Q8D8ATBStWw6Y	1624	1334	1	1	84	jwRWsaQRr8gyfXV2jTistQZNSQwCzJxa2tW8UzgyjSbKzokdP31	51	63	63	1615950540000
84	3NLnsYgXCrsFN64KSpKXFP21WMTY1PvCeeBjyfc8X6BmBecGLdLH	83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	1407	1395	1	1	85	jwyteL9nypaLGUybdPptduyg5BhmW1YWrQYhFsK4SBdDAUsmc9T	52	66	66	1615951080000
88	3NLH1Waj2ujVpbfFRrJJbgAkBVsLCEEkv84GKZezd3PA6UQxr5D1	87	3NKxn9iD4s9uJ6j8ut9YMtVN7JRaC8o14k4AKvauCSguGksFoX6Y	1422	1091	1	1	89	jxXxZQDAVFiFaYWar3uHDC365AUHG6wC3zD5Pjeq93ovKb5WPuo	55	70	70	1615951800000
89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	88	3NLH1Waj2ujVpbfFRrJJbgAkBVsLCEEkv84GKZezd3PA6UQxr5D1	470	470	1	1	90	jxzyigj6bBstAb61G4kJCpfZs6yHrD93sJdNWVzqq6j9Bk28f72	56	72	72	1615952160000
92	3NKRrZouMYCKo9WppHm4j8EgjPBMCPXJg3d9dCoinUVWgQwMbUX6	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1578	930	1	1	93	jwfWnB9T8emHW4ix3BHFoVFJ7freykdgP1KqPTGotXAhn4YPjrj	57	73	73	1615952340000
95	3NKP31VbUuudpRoCkyXhd1DNNGW5Y67AS5kED62whs9WwvAXQjGa	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1542	1058	1	1	96	jxmodA75noneHFiXMDj64Wdjb4dV6F7abwZ2WVTxtE1pEvE2PZh	60	78	78	1615953240000
98	3NKYioZFVfvLw6BRmfnbpQRKaLcLQzyo6YTZ5Gr2TPtY4RiY8A2H	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1474	1203	1	1	99	jwx67py3DFtqFNGXZFkuM7JypvuBY6KNuJuuv23nsbyN7aciijR	60	78	78	1615953240000
99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	96	3NKu5MoEy2xvRMpKCg5FYVJ13paiFPzM3cuof5qr46v7XfXuRAdg	1440	1011	1	1	100	jwBkT263EHTuQcTzM3ERFhVhmKXDPJM4f7yerDJDxh7918eD13Y	61	79	79	1615953420000
100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	1617	1162	1	1	101	jxeUmczvdhS1vv9HsPCtuJ4hWnpzFxaSm38d7GVhKW9RZUM8DbJ	62	82	82	1615953960000
104	3NL3W58MGw9VD2Tjmg685KJUAPmjq7zDU37TqCcAsJ35rcJKFKJa	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1559	1353	1	1	105	jx9DTMz2BU8prQaGoAMoufj6bmcxuD7oU9EGwD3Ynk2b7bMbBTf	63	84	84	1615954320000
105	3NKcqgxhZhuPohp7Lan1A1fQMf5cS7tTruEVvoiGb5koyPRJrxsJ	104	3NL3W58MGw9VD2Tjmg685KJUAPmjq7zDU37TqCcAsJ35rcJKFKJa	1587	1231	1	1	106	jw9yQdXScmn5v7sHHAbsEQF5K419grkoMBm5gvV9jwxZV6vi8dZ	64	85	85	1615954500000
106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	105	3NKcqgxhZhuPohp7Lan1A1fQMf5cS7tTruEVvoiGb5koyPRJrxsJ	1405	867	1	1	107	jxikoyBzK3NZZjwKR4CJAciy9ZdVYiqwR52nLq3TC7UUCtMrZqQ	65	87	87	1615954860000
109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1419	814	1	1	110	jwvqnNvM88rY7w6cH1bEV1QcCn7c5TM7bAmCuXw7UAAq4KHtTgd	66	89	89	1615955220000
80	3NKM57jFp1XXwVyrg9SgxkEJ2zvcY3VuiCjCxXdsaBvdnPDZRmsD	79	3NKdPZWJtwYTY6mpeTEgf2RbfLaJTV5HoAYy3GZcvJJ2cE8qTRVp	1504	113	1	1	81	jxnMokDMva4JFZxtzSzdtbmXdDdDRQM8FCFb4DEZvUsJ42q1ZJy	48	59	59	1615949820000
81	3NLoHwSAML7FfGQLiEF4Fz4D2P1uaYZ3u5hwwGjBx8ELRqZyTcG1	80	3NKM57jFp1XXwVyrg9SgxkEJ2zvcY3VuiCjCxXdsaBvdnPDZRmsD	152	1330	1	1	82	jwGA4SgMN3etZ2zaVy3KWGhLxNmQ7S7BFuhrHwqaMaCYLSzwRhW	49	61	61	1615950180000
85	3NLY4ci13GgX1GGkUrfTKr1Zt69U6Xj546d15nU9o1WrfHVnbosd	83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	311	941	1	1	86	jwfhn5RDc4yktgM5jejQoG9Kqq8PsiBwGLVn72mb2YMfGMobJR8	52	66	66	1615951080000
86	3NKYK9ZCxE2dFqwrTHmPtvTVn5297c6ix6AP5CwR6cA2iHoTGxyW	85	3NLY4ci13GgX1GGkUrfTKr1Zt69U6Xj546d15nU9o1WrfHVnbosd	1671	1119	1	1	87	jxqRDi8NqNak9bhgxbLMsGGNSckZW29HoeZfUbMn9jS3K6f8uZj	53	68	68	1615951440000
87	3NKxn9iD4s9uJ6j8ut9YMtVN7JRaC8o14k4AKvauCSguGksFoX6Y	86	3NKYK9ZCxE2dFqwrTHmPtvTVn5297c6ix6AP5CwR6cA2iHoTGxyW	1623	830	1	1	88	jxikiDQcKQG2SozjjX1iUeRoeqWYwrGgW5UKQcicpU8gDUdKNbB	54	69	69	1615951620000
91	3NKWDr5JxnekJFpuTsz4jjnBa5VvUthh2aFdoestvmAzVS9KuRKN	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1407	1395	1	1	92	jx7kDH697fW7wHgDtaqoFGdNQMTeJB8ZMoq86uwoCA5JRnzS7yQ	57	73	73	1615952340000
94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	93	3NKYGK7R7TJP4vHNifuZYUJygoikskpjKULVWjKur9wRMKE7obNB	369	1312	1	1	95	jwhtrWfPbqCN9yK2EB9FMLeARfaYN8a6qtfEkTY8g9oQ43UeDHo	59	77	77	1615953060000
97	3NKCdQt2pAeLqrPYxLHNs7UeusGGrTL8X6HcaFs8yJH4YAe45oLz	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	448	1305	1	1	98	jwdsK5ukwfWoXNeaeFHPtaF75NqAMsFBSLREWq8DvnkwaqsUsQR	60	78	78	1615953240000
102	3NKPkSDMLMHxttJFbfBRoYFzYaTPxywUsYZbeiTfGAq1LJYrxgn6	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1403	824	1	1	103	jwqzK86vxbkdv77PBRqpEABSiYguJz2GqaqbVt4J9ungy7hh9Xz	63	84	84	1615954320000
107	3NLxHifB9s96eUpkPgExzeKkp1vhW6Rhwv5yMqkDKHERVwpRWSvg	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1407	1395	1	1	108	jwQt6zWhvzSSbXNFA1n1EpkytmpKzusYCogC1zjzAmFxM4rZVDX	66	89	89	1615955220000
110	3NLKre9hW1wRShnnyMt3k5HYwc2GbTUivUMiDPuQsHc1dZfyULLy	109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	1403	824	1	1	111	jxad4XY7yReM3rLAZDDcptdB95C2wgYsCuJkfci3rLFj7ebEJXw	67	90	90	1615955400000
111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	1407	1395	1	1	112	jwhwk3p3WKhuhffx5nC2PU5cQho8ei2Ypj3KaXSpwVSUQBrF1KR	67	90	90	1615955400000
112	3NLEUNSiAfmN5gohvmYuKWpB1JF84RqgKrsRUj19ybRbXx6p7ow6	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	470	943	1	1	113	jwhGXAMGKbsWyBQJQrpMFZzs9Qm8SsXfyw8W6BGPMKTwNtN8ayC	68	91	91	1615955580000
113	3NKxZfJbFLv3UoRnPUKsimRZQuzW1NaoAA3YBEqywQ4uRbftiUgd	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1483	1276	1	1	114	jwFXRbpGsRJdHcjqBX6zBhuK1yaxfSg9KbPUEEgnz7LFqMf82TH	68	91	91	1615955580000
114	3NLvxoHq8vrVJnh5vHYDZNpD4ygTfsaVZJy3uicDXNBXL5YdJo3B	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1651	1301	1	1	115	jwo8HkLTtHQ5AwqFg5KzJsG44h4YagCLBQAgfx1Nekb98KirZih	68	91	91	1615955580000
115	3NL321XkaQuY7bkR1FNo5quu9kNVEzYCNBXiuu4y7wznv4V6xP3y	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1651	1301	1	1	115	jwkDQQircvHZpZmLWogFNJgqAmNf65ncextEC5aRQgFvLxnwkys	68	91	91	1615955580000
116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	112	3NLEUNSiAfmN5gohvmYuKWpB1JF84RqgKrsRUj19ybRbXx6p7ow6	369	946	1	1	116	jwgGip1VBDsrHm8C4NWwkXJi4eSDXgRLtkHnX27gGyQBeDgJwX6	69	95	95	1615956300000
117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	1599	1161	1	1	117	jwCKVEed8QGMy5UAb6tgmFxLRF7zWhcfnMj4aXEDQzoeKQimNFU	70	96	96	1615956480000
118	3NLLW8wvytn913FtfqvqETPfJWW9GEGqEYTqYKSriAKGXUFqqnDi	116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	1581	778	1	1	118	jwqtFgJAWuVXDmNMCku5Mpxb2jCtkK47yVBzzW2Nohf8ttcgv9S	70	96	96	1615956480000
119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	1406	1393	1	1	119	jwRB15pao6GxRwSruwNnFht9165izvSpzYJkxJS8NGZ6aVaxavg	71	97	97	1615956660000
120	3NLsorVVc9VmXBKmomsLBuAFYfkTcC4B7qn8BHUqakxgzMFQ9shi	117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	1522	1322	1	1	120	jx2hBbsgCkD6P3SwWR2wswb3Fn1eYRYT2WNrUXBteC2PcoUSXXr	71	97	97	1615956660000
121	3NLBQ2UBs7mb3ckrPuA7iC9PkCUxagnaJdZiyYcHiQdgDerwPPcp	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1656	1343	1	1	121	jy2YdNLbMyDydRCiPhs1KgVE56MFF8vvENPAgqNkeMLaiwtuE2g	72	98	98	1615956840000
122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1474	1083	1	1	122	jxkEeKw9RDhZgTBU8bkoJ1bv68wa6bp42uc2Gghh2aJ3HjXuHDV	72	98	98	1615956840000
123	3NKF3gkPkEAa6Nozz3bB4fekkrMi1nXmECioJ9SjrcbF5BKK7jDh	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1581	778	1	1	123	jwrzByauKtESeFdyT36v9HfMV7pQLzAwCEsNLJcv2BG67bMaYFV	72	98	98	1615956840000
124	3NLRgvHYBxbxwphPTXD2ktUz4eYuycWvCwMr1UiVjEo2fAr9QPyx	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1571	969	1	1	124	jwxdQjHS3Kyg4NmDCARXoWoXcMJoQmNF5nGogJHmVdjozBJiNc4	73	101	101	1615957380000
125	3NLpvnuo5PAo3TrUb75drNfkacrau2p8EzQwLLk1AmFDUpKMrsuh	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1523	1321	1	1	125	jx8RfaUeYKX4JUiCTgqwEnZtQnDdymM5mVz2MeXVNDws5dU3mqE	73	101	101	1615957380000
126	3NLhgoB9XJAma495Vkv29ghngFPzr5SppCwn2qvjZeH9EaHF65FF	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1593	1346	1	1	126	jxQG4FRC5ZyNnEw1dSggyf51stptQ7mTnXV9ceWPbihrrs73xEn	73	101	101	1615957380000
127	3NKjAjygbeZPh3ebdjq9JfbWwn8Vj99kKkQgeh6BcS3EfajmpHTQ	126	3NLhgoB9XJAma495Vkv29ghngFPzr5SppCwn2qvjZeH9EaHF65FF	1657	978	1	1	127	jxXWfNknRhscaPzyiCtNAcTg4apipE5S7wEH75fvLuNpD5UKDBt	74	104	104	1615957920000
128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	127	3NKjAjygbeZPh3ebdjq9JfbWwn8Vj99kKkQgeh6BcS3EfajmpHTQ	1571	969	1	1	128	jwWPS85497fNrQPBotTNhDZtde8LjAeeugBipV7hM65LRauXrzB	75	105	105	1615958100000
129	3NLppkyBnB8bVJJbkkbF6biLMNcTXov4qhfY1ZxtFDXgwbnVuq3q	128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	1534	428	1	1	129	jwtUGt173hug8ts13y79yWDhhrhUnQLRukLCjTsJENMnVaJMCSa	76	107	107	1615958460000
130	3NK9UP94qo6YgZrYVS7S8BTD1uQoFDLtoyWVk3L2Cdkv6hpYyGkW	128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	1637	816	1	1	130	jxDwEsbgs1twqRUSKcAmeBuokCtGdJnqmtmE4CW5GAnuozuNPhJ	76	107	107	1615958460000
131	3NL1JQVhA7N68L4n5t18Mt1QQVEwox31ZWuWaLqJ3iBMs7Fu4oSD	129	3NLppkyBnB8bVJJbkkbF6biLMNcTXov4qhfY1ZxtFDXgwbnVuq3q	1406	1393	1	1	131	jxd2BLEeT1b8Wd1fERpd6VMnUbVcB5kKN3n4HdHus9Zjp1khLok	77	109	109	1615958820000
132	3NLvdt5xHD17RtjWZdarhJyE53wmP5PBefQFMd7SRumoEQazgu13	131	3NL1JQVhA7N68L4n5t18Mt1QQVEwox31ZWuWaLqJ3iBMs7Fu4oSD	1405	887	1	1	132	jwz64eFciKFiMoMzoRxuNR7TjMAQSnTxE6ULtf98WchLNpZrkb1	78	110	110	1615959000000
135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	1631	794	1	1	135	jwd4QVxtgCoTFrGhvmnTT1bjFGwvPCkoZzHfLhxe542wEMYyaFX	80	113	113	1615959540000
138	3NKNNGFf169C9B9j2h2An5bYEYwoPLHe2yB3gMEFdLAzNiAiqTeg	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	152	1330	1	1	138	jxSzeG2J9jqWHMQNSz7XQuEn7FYh8SXYhLzaPo1RAtNvV3Vkxs5	81	114	114	1615959720000
139	3NKmsGqZ1qf56qeso9dCeqfPu2C7dYHUECvq6nVEd2FJGWKZ8Sqa	136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	1474	1329	1	1	139	jx8inMpUETjjuqZvk29M7xKqSerGSvrZVXUw86kua29uQ9okqDB	82	116	116	1615960080000
142	3NL9jBREsPPiZvzMJGXnvrJhaa274TLkz1eUYHrcmkmNmLqjbr8G	141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	1671	1119	1	1	142	jxLWVaQvTMrrkEPU2hciY8cAnLDHQew7HSpDvSzBeBNCPGmGFsQ	84	118	118	1615960440000
145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	144	3NKY6THQfXZRbb6YQcxJg8Spi6Pgtj45JJHnwZsVRgvtuYAAu71e	1560	925	1	1	145	jx5633SwZxKwvR1bRCnTSDUYBsf4Fa9kRSeh71drTcoQmeiJ3Ug	86	120	120	1615960800000
146	3NKAJFaipEzHSUNe4mwyV1ozJJmAF9GvY5HXYR3nNW24CXmt4nTA	145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	1619	1275	1	1	146	jwwB1ntwpNx8ifaYwa9cvRMmSRtmA9sGNijmLatYKRZx19VX3yB	87	121	121	1615960980000
149	3NLGFikKPfBnCtmY8na47yd5SHGajzLSY6jVGT6dCzCFmCpsSV2y	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1546	1339	1	1	149	jxTSZReppbq61LTD3NwD6bFdft5aazeJ2rKc8H6zPbR29bybLXg	89	124	124	1615961520000
152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	150	3NLdvNALUiJZvSscUoc2PJotDeFZQZZ4NSKKaH4WgjVMNPzhWrwQ	1405	851	1	1	152	jx1zkN5jcDKHggTgX8kt3i3y2wvwsuNJyiBjcJ9H3aZHSKBwHTr	90	125	125	1615961700000
155	3NKWsin4QitwZ78snY2cEUYG98TCAAk71uFB2pLJzXk66xNAzvZ8	153	3NKSWPVxC1dUg7NcsWV5vji1ZwFowU5SSLMEFPcKT6dKpCFzxacp	1406	1393	1	1	155	jxmzPFNgTqqhL5qE7enGSqXr6jQNkrdiEbtaEBjfgpb1uYAZ2RJ	92	127	127	1615962060000
158	3NK7n6j2Bx9yCVjv2AKnfxwvwvCL9uww9mQaefkm3zyabdrcczjA	156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	1631	794	1	1	158	jxfJsRMFEzg3ohN4EfiXBGxAcoYXCimh7c4BqS5UoFc2vPNQu43	94	133	133	1615963140000
159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	158	3NK7n6j2Bx9yCVjv2AKnfxwvwvCL9uww9mQaefkm3zyabdrcczjA	1457	1391	1	1	159	jx1mMFf433UeHdb6c4pPHcMvyRGsdmzEaYh7p66m49Cz7RJmPXR	95	136	136	1615963680000
162	3NKXu6Epr1PqhoJNAQkRoc7neKRm5LvVvyeVJmqFmNigWRvxDg7z	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	1518	788	1	1	162	jwDFfqkdxSh6SNkRLEuC8kAfegUttwLZwZAJprENtj4iUNGehmw	96	138	138	1615964040000
165	3NLdywCHZmuqxS4hUnW7Uuu6sr97iifh5Ldc6m9EbzVZyLqbxqCh	164	3NLAuBJPgT4Tk4LpufAEDQq4Jv9QVUefq3n3eB9x9VgGqe6LKzWp	1458	1077	1	1	165	jxVcdY8ZJEFhEdZCq7W94eT1XyugU6j5wjmT2f7WX7ysodZAXsL	99	144	144	1615965120000
166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	165	3NLdywCHZmuqxS4hUnW7Uuu6sr97iifh5Ldc6m9EbzVZyLqbxqCh	1407	1395	1	1	166	jwWHNKQPdgLxHCsBki57a6zBfNPUFkAQmsrCNq3E7Q8oiNCNdkm	100	145	145	1615965300000
169	3NLVwpAyDreuBDKHhyGQ9ZTXBgoed8ng5N33bPcXEDEd55T58o4w	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1553	776	1	1	169	jxLkw4fTR4Jgc9s2z5bJrfwb53BWvgNVoxkoAJSBWMdrnpzHuPW	101	148	148	1615965840000
170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	1500	1297	1	1	170	jwKaVwyiVGKRoEYvwH5M9EzDN3nq1XAbFd2hR57Sks7dPWJyMJb	102	149	149	1615966020000
133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	132	3NLvdt5xHD17RtjWZdarhJyE53wmP5PBefQFMd7SRumoEQazgu13	1501	1360	1	1	133	jxff6W6tWhhMRjB3qis9DiH5Yb4at6cCao8LK4B6HLm4GpvzHgk	79	111	111	1615959180000
134	3NKGCV6HQB8JxVva4fEB7EBAmmUBHHamvmazZQPDTwtMBZKDWsbq	133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	1542	1058	1	1	134	jw9xJFfrm7qxYCbpVGnpH3WgpXnxcmShycEusUA5d6th4JDouq9	80	113	113	1615959540000
137	3NKpCp1mxV6CqXt6ozYyZoWp2UJ135sdMduh6Kaz5sLs7fr9KtZf	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	1405	851	1	1	137	jwPeXcWtkeisKSskhtjD76ssy9VV8c7pvZD7eH8pNxxaXmBxFWt	81	114	114	1615959720000
141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	140	3NLQAAxZezvRsey98HZpTjCMRfoK7NWYzXeJNUSuncvTbrdjcshH	1637	816	1	1	141	jxmCn1mE6FDHMWHuzQqgvSs4VCf6K5iifbqJKpfAbGJPzcbcmtD	83	117	117	1615960260000
144	3NKY6THQfXZRbb6YQcxJg8Spi6Pgtj45JJHnwZsVRgvtuYAAu71e	143	3NLftXM1dfzGJwLef5NCk974CXq8oXtAaQAkkhpJZxpaBwLFiemo	1546	973	1	1	144	jwUWJnyGSVoRyvSnxWi4LukkWd6jowLESsLJZWYshFSqfn7uzN8	85	119	119	1615960620000
147	3NKU9K29gncR4JtCP49MTaj2oGrroeB1pbn46TUQXCpEyGcrZgmt	145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	1553	776	1	1	147	jxELmHiCDLoFyVdhMcF3c2xNcuGhgCy38bLPf5BcYTdKf7Y4qwg	87	121	121	1615960980000
150	3NLdvNALUiJZvSscUoc2PJotDeFZQZZ4NSKKaH4WgjVMNPzhWrwQ	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1509	1320	1	1	150	jwxndatu9V3JDZ9YVaUWBo19Cs1xxJf3vX3hxkUdrwePtT2crMX	89	124	124	1615961520000
153	3NKSWPVxC1dUg7NcsWV5vji1ZwFowU5SSLMEFPcKT6dKpCFzxacp	152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	1405	851	1	1	153	jxDnqMtg7iAP1hTUgvXRBCyMHLZx2onhB4waeN1vCCRB5zekKi1	91	126	126	1615961880000
156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	155	3NKWsin4QitwZ78snY2cEUYG98TCAAk71uFB2pLJzXk66xNAzvZ8	1637	816	1	1	156	jwrKo1H5gCVyXqut2CjGdmieco5YcP5eyU9fDTknTsJmVPyrhEd	93	129	129	1615962420000
160	3NLk3W18mspMqvCRgyoPyEpyBHrKZcqGjroabZJEMxZ18pvE5joy	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	369	1312	1	1	160	jxeacUHBAbfyhoKTDoPs4Gu7MsDph5k4ZbMjM9RZRnm39kxMkVH	96	138	138	1615964040000
163	3NLgPYVDSV6y7ZKSQrjowedjZn9RuLwdx311vheWZEy3mBjKDbmj	161	3NKqUTiHax7cJjVy1sJ2hUZ1oWw4auqG8e6vMJEh4kv9L6qMWyFj	1477	1104	1	1	163	jxaJQn6oKpki6gSJfqQUEFKowD2W9ox7EDpcsbH7wXmdaCx5WDb	97	140	140	1615964400000
167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1627	1385	1	1	167	jxDwUbxwEE4ZnpzZKJMZWXuue7wAmVwNdVah4PhrwecdZMqjXcp	101	148	148	1615965840000
136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	1503	1277	1	1	136	jwqg4FyeTQfXBwprhk7NCVNUVfEYXpAGGfzLeeASQ2CQeiQ5J16	81	114	114	1615959720000
140	3NLQAAxZezvRsey98HZpTjCMRfoK7NWYzXeJNUSuncvTbrdjcshH	136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	1559	1107	1	1	140	jx3bFEvSFGVeWtwHXYnDYtrveHEes3Brt2yQCEie25pqd4sj5Sh	82	116	116	1615960080000
143	3NLftXM1dfzGJwLef5NCk974CXq8oXtAaQAkkhpJZxpaBwLFiemo	141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	1581	778	1	1	143	jxWnvVsM2HCdPrEi5E2QV6FRQWL3oWBPVr7BgPBHACvLUux9WBe	84	118	118	1615960440000
148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	147	3NKU9K29gncR4JtCP49MTaj2oGrroeB1pbn46TUQXCpEyGcrZgmt	1406	1393	1	1	148	jx8wWyUR66zWSbnEcMbXjgsQdz7bnYPJsmvmsKx33TvYnvSqbGn	88	122	122	1615961160000
151	3NLPfAvmqxN6BR9TJGni8nL1w4ZesntR35L7fZFhvVi4ze8fabf7	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1553	776	1	1	151	jwm8FWmxy81GNWM7u123BeBotLg72SPhUFzzY7HuyyT9HLcfbVX	89	124	124	1615961520000
154	3NLRUisuGPu1N2dQxLvC5WqCMxUTiqkwjGL1zLd6ojmkC6cNYqmM	152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	1624	1334	1	1	154	jxCj8QrQD5FoUq8R9LV8WRNWZAUm7gkze5AyJCc8PFiF2nDk7Qn	91	126	126	1615961880000
157	3NK5zDgjQcY5g5VF74vSuHCMvkEjgjuavCNQEYqQU46d2no9FopH	156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	1646	1354	1	1	157	jxLX7YV4qu8DemuSVp4F2cL6wBEP4MVoeiVN2GUijTpCeCxuNF4	94	133	133	1615963140000
161	3NKqUTiHax7cJjVy1sJ2hUZ1oWw4auqG8e6vMJEh4kv9L6qMWyFj	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	1652	1189	1	1	161	jxGXta8esr3FSnBvSkgAz5PMMqqVRHX4cp9fvTRjHVgbegQsfBG	96	138	138	1615964040000
164	3NLAuBJPgT4Tk4LpufAEDQq4Jv9QVUefq3n3eB9x9VgGqe6LKzWp	163	3NLgPYVDSV6y7ZKSQrjowedjZn9RuLwdx311vheWZEy3mBjKDbmj	1406	1393	1	1	164	jwZhLnqoA7gngY3F5jMf9SXEXRS76LqHt2YZkZ6e2whURiNt5ZV	98	141	141	1615964580000
168	3NL9oTg9i373jA6yxA51epRFQhGg7e41v2nnsUey4fH7P3x6iFFx	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1396	436	1	1	168	jxKwNCZ542hAK6kWtHcXzG6UuKc5QB6CkWokJYhuM9sFSgmpM4s	101	148	148	1615965840000
171	3NK89nY6UKeDmu8g7zjeoepC1sKMAh3mXfxa5D3gdqduMfjwZ3rK	167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	1647	1176	1	1	171	jwjSM2k8x5uWzbKhkb4Lv3LepVJ79HqFGhZzU1fgRnTYq15F4SJ	102	149	149	1615966020000
172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	1407	1395	1	1	172	jwchntqCj9vkAiVKaspqU5Fj6CCkqRjxvM83b9uF55RnNvuo1BF	103	151	151	1615966380000
173	3NLTbzHyK2fEbYZ27UvFcDgQiqNz3a4WFhgCL4WrAV8fVXPqffXm	170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	1617	1042	1	1	173	jwoxKcLyC1xggvDXoPTpN67rXoJAbXQB5bY313gNMoQKncm2qRd	103	151	151	1615966380000
174	3NK8VVU7sSLSQXBqtapDUCjANfjx2BV5eZ53iMp7C6pSGY8frGxB	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	1403	824	1	1	174	jxLwBau7BqM71kJXrS2Wxt4RosyeCbTmKSohN8hYjnKCZcCJs84	104	152	152	1615966560000
175	3NLi19wzyT23KWzippDRoEjvLmzjUorVv4MavM2DbWJrLGreXLKj	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	1406	1393	1	1	175	jxjwLDEPPnbGmJbBMPPB5EGD95MoCFtCgGzAnFaTBGPfsa9jejL	104	152	152	1615966560000
176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	641	1090	1	1	176	jy1VoNG3LR3KJ3bwZSM63FfCgaZo7LYtbwWXUGuhdRo4N2HSn95	104	152	152	1615966560000
177	3NKYXgdPvNG71Fk8tRMheg6BppRuadyPJTnuLN4eHgc6P4ncgPVm	176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	1671	1239	1	1	177	jwUMYz1TqsfotTJsjmxwPbwto6ou1j8U9pcJsQ2kqxEiAiXRK7d	105	153	153	1615966740000
178	3NKaedAQ1R1Az8RZdVWRu4Gt3utnZygt5HT7rdEfWSdxqafuq8ey	176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	1405	867	1	1	178	jwUCphCFxihND98W4DTVn8AY331tPuVkd8QqM5mDD18Zm9jiKEU	105	153	153	1615966740000
179	3NLpqwrzfDE3hFCu7qmzz2JXKqcFKi8RRbtsEimcJzcWn9tjuNwh	178	3NKaedAQ1R1Az8RZdVWRu4Gt3utnZygt5HT7rdEfWSdxqafuq8ey	1458	1197	1	1	179	jxehQYq6ua7vpJZn7FG4sajNdLpA1XNzeKQd9nEewPynSwfVLw3	106	154	154	1615966920000
180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	179	3NLpqwrzfDE3hFCu7qmzz2JXKqcFKi8RRbtsEimcJzcWn9tjuNwh	80	1027	1	1	180	jwVBYMsszsCdfJjPozc6Yiyez5SvWGzVCahLux4Jt56vxjezASb	107	155	155	1615967100000
181	3NKmNCCZoG4fLJuQMPfXkUvARY8qUhzaG37rpsBj9FzjgdJnuNGt	180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	1467	1130	1	1	181	jwsdoNcGFXpPDAsFzJPAYsw38RuU3G8cGWRhzJgUgh3dN4UKYqU	108	156	156	1615967280000
182	3NLxmqo1M4t77ig42a1C4rbQ3UERvcYPYcnmC44ncxpSSP5kDVMi	180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	1403	823	1	1	182	jwvDxECUffpSmeuB7Kt31zvNnuGujoVvFZgJxCbKnrmMZ62GzrC	108	156	156	1615967280000
183	3NKGUXQYm1nF1hdEDEzwuLRWZjBTdSeKqHfqS3JPCzJ2i31mrovV	182	3NLxmqo1M4t77ig42a1C4rbQ3UERvcYPYcnmC44ncxpSSP5kDVMi	1477	1104	1	1	183	jxEE8wKJnxLD5ySfWoH9MMU9oZP8R9bYBbdPdQ9qdwGd2QJvCtB	109	157	157	1615967460000
184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	183	3NKGUXQYm1nF1hdEDEzwuLRWZjBTdSeKqHfqS3JPCzJ2i31mrovV	152	1084	1	1	184	jwx6BgpxQiPMY8L4yV8w4x9QLzK6wdXP7rdaSu6oRnSrs8AXr57	110	159	159	1615967820000
185	3NLj4yaEa4kGamq93k8ZMqbiZWuR26USzzndXVGoBupEZRQ6zJjm	184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	1406	1393	1	1	185	jx4SpMv8zHZqnbV9sHQXk9BRntgst41sybLoDgV6Vw3ejMhWGAq	111	162	162	1615968360000
186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	1617	1162	1	1	186	jxN9vGamS11EfAWsysPDadXMpZ37u1eJmpa5enkVHtaSUZMDLg5	111	162	162	1615968360000
187	3NKXAsEpwmRGArLdd4bcnxYfC5q1apRHZpFGyz2aCQuLegbmFKFk	186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	1651	1301	1	1	187	jxjzhn3rrPTT13ihkY5qEmhrmDymYKL7FJGHQpN4zCr32QHFiEi	112	164	164	1615968720000
188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	1651	1301	1	1	187	jw9vhPJrAw5rNJrCzBLStxk4TH6jU6chdPN7Dtx4mZUpMV82LGU	112	164	164	1615968720000
189	3NKAfXH5Miy4aYZbSfE37MiQSkKVdpFgfT8dMb4UaeLBhaEbgUJN	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1407	1395	1	1	188	jxNS378HQQSzhv9qHQUyPy8qrzyPqo1e5LwWnqCZksGRLk5gHv2	113	165	165	1615968900000
190	3NK528UG9QPGCiThqJgLx5gZXbm3XvLWMq8szLVNh1EJVBESLGvx	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1440	1377	1	1	189	jweQ1CvV1TBCVW9aAjzLmU9YQLZazTXKfJQNLqLTtaeVGRWPyZE	113	165	165	1615968900000
191	3NKp5qnN5KADjnX5gRpdzuuzRxYdDe9J5yLBbyKstXGw1wE3kkVP	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1489	1380	1	1	190	jxv5vXRP1x9zv2UHq2epiEbPEdi2JxdFdiazNBvXb1znnsp1Q5S	113	165	165	1615968900000
192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	190	3NK528UG9QPGCiThqJgLx5gZXbm3XvLWMq8szLVNh1EJVBESLGvx	1631	794	1	1	191	jxfr6NUJnwixVesAvAhpSziyd6cU2xmAwuz2rqMAsrCeNhPWaxi	114	166	166	1615969080000
193	3NKxBqpTfp2PPn7rGZ51aRNyz9Npt1si8y7MXWdZrA77GAEgc1eb	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1549	1362	1	1	192	jwW3i69fiJXbz1qSY1sp9huJKVpcJmJEv3WiJvEcSuQZ6iRntdV	115	167	167	1615969260000
196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	193	3NKxBqpTfp2PPn7rGZ51aRNyz9Npt1si8y7MXWdZrA77GAEgc1eb	80	907	1	1	195	jxMpujd6jcNeeWrKqw9FxmtGPwN4J6EzxUSgQMx6JkEzgqiK4tm	116	168	168	1615969440000
197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	1668	1370	1	1	196	jxPfoF5enFiwK8oYHF25isAHiC1J7gWWyJjAcPnSpDkFdYnwWPS	117	169	169	1615969620000
200	3NLgqwocJHbVDSionMVKw916f5kcpFyvx8JVZVyHivJW1DF4TorS	197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	1406	1393	1	1	199	jwxhq3zLGSvaSw6s5ybjEsyPMVESy9B2RSrX6n4o7g48Ln3wSqn	118	170	170	1615969800000
203	3NKFoxsSXhZ5YVfAUWgkEh6FXdATjHgUxfjTnGtJcrTuUZavq7d1	202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	1642	1001	1	1	202	jwitPfMPjcmaXJP2R54MVbZm26PKf8uQhHEoy8kkpSGe34k7qjY	120	173	173	1615970340000
206	3NL9oScSvsJgB1e7SD4XWL2fEhybHnk4cBTGYMxS5bfvWTkrrY4t	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1649	1257	1	1	205	jxuDyFyBtxvbYszRMV8aXrg1iniycUv9t5stTPqbjwyKct6nPvJ	121	174	174	1615970520000
212	3NLUSnu6iknwLCkkewnaHRDEFC611oCoWnxFDmjLvEkBKWcwZ3k1	210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	1403	824	1	1	211	jxyKHh8r4NLcUzNoB9TpqsmHBxbwyisgJGFvRA3QJC3aJ8VmEMM	124	178	178	1615971240000
215	3NKjyLahF2GU73KLAqAjcoZWjy4z1ek6rZ5ktLefvbc2A9EAeRqE	214	3NKMzHr2jpcHwGw2UJ4SH417ePMxPRRSLResAgUmHMguNDaYUgNS	1581	778	1	1	214	jx5KZyDKUVvo725Pc5GFFp3pBuZs7U2mNrPSgjY3mzqLyWxiHEs	126	181	181	1615971780000
218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	217	3NLTjXS1Ch7RHn3Pn3Zp7daoKz9RCZjdws6d5Y3BH4i79C6gHTUK	1407	1395	1	1	217	jxPv4Ww9ckXodyGUfRRnBWXS2YW4Xz17LdqZzQpQWhiyzK92GV4	129	185	185	1615972500000
221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	1668	1004	1	1	220	jwEUMHokJwhym8x4o1USRr3C7EbxmSGmxUGZkUVj1Gao6b7hezu	131	187	187	1615972860000
224	3NLXj3ZwKKZbiHn7eRevQ7Qt7rK5vxSiCjo2tXJ9eEZCy4Rj8eah	221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	1527	1167	1	1	223	jwTYdPWZ4E2GBWiYeYYNr9Yy3ckiRFbAXpVgvgVVwiQemdCi7yP	132	188	188	1615973040000
227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	152	1084	1	1	226	jwSxHgkNukAJMc9RA4YRrFiGbFEknekHgrwnaTAURB1LAVWozKX	134	190	190	1615973400000
230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	229	3NLCEWuKssvAxk6sp6pGWNftfE2U6CWmA1rDS51JiaV3tSLhtutk	1573	1192	1	1	229	jwFfBf3b3ethv1ZDcGcF2YCvCtV5Ka1pQK8Rd1q58BwQzjaaxVe	136	192	192	1615973760000
233	3NKZhycHJVd13yGJ37ERpaTYuEiPPWsKVirMEpGmSgQ9pthejW7r	232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	484	1319	1	1	232	jx1wyQhUTCsdjYXYX2sGkECcjtDqx1q5dJQqDDYpnezpsgacsk8	138	194	194	1615974120000
236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	235	3NK6r5ciM4qoruuneg7xxqYCVzQzFMYSSw5H7NyNiwrg9oipSf7Y	1406	1393	1	1	235	jxGnKK9KsRQoZm5fAXsbVgqgsepJ5JWoj5SFiij2WsHEQngbv1e	140	198	198	1615974840000
237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	1406	1393	1	1	236	jxBYvY25bETYyJ2tn1M3a188rvRUc89My56ZpKm66hye8Kr5Vs1	141	200	200	1615975200000
194	3NKAa5kAEvAhSRLVQZLC5iAsBbMjjY7QxpNKvd3bq4X917vFZKoH	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1507	914	1	1	193	jxYCfM58wB24cjUiegjHqzA6KLRWVaSqAFsvdTsmAmsrEsG419w	115	167	167	1615969260000
199	3NLCUCD6Vbg1yvaSe4YmGPY3nwSRkdwiQdVexvSLe7xgeVZA21Pp	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	1611	1215	1	1	198	jxXRmZnK15jwkJv3pwXVVwr51TgfWodTB3ocsxhieA5VUApx8of	117	169	169	1615969620000
204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	1506	1373	1	1	203	jx5jYGvMJq4xhaB2VutXw3vzUy9StVcyZMB23ygi8xmNvszxk5v	120	173	173	1615970340000
207	3NKr6HMunb7fjF4obYeedU4HtcKasfKhz1QnPNuPD199qhjwpbuT	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1601	1142	1	1	206	jxXa6LncjN2V71pwV6mpKHF58r6ZFByRk6ASLYMfDwm1Yp4WRm9	121	174	174	1615970520000
208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	1559	1353	1	1	207	jwFVEk6k1jBRHmGYsuNqcVkAQRtTLv8cphFVAySoW8pHS3dnp5W	122	175	175	1615970700000
211	3NKGjizyLVPZiLvGHojXL1yWPuR8EHPEhStmr2aAX2FZAo596K7C	208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	1617	1288	1	1	210	jxGchjQ3TbJx1hq2dZGhPTcNBDv3CobTBuptpupkT8C8yx5Ru63	123	177	177	1615971060000
214	3NKMzHr2jpcHwGw2UJ4SH417ePMxPRRSLResAgUmHMguNDaYUgNS	213	3NLqqXwMZhR6ffs6PCYL67wFWn7pmcYd5qAcgTkbRzX5c7FqZm1A	1579	1389	1	1	213	jxGn37Hts5FMXuhhbpW8P3Bd2fwhWCxCWCc2TNADt5Y4Ag4Kcq1	125	179	179	1615971420000
216	3NKEtm8C4zwxe7zkiyd3HHiaEbUTSBZ4rV99njyH3wEznedfYY8q	215	3NKjyLahF2GU73KLAqAjcoZWjy4z1ek6rZ5ktLefvbc2A9EAeRqE	1507	1280	1	1	215	jxnvwa7kmPJLZiYEKWAXGpnERD9TH5aXSeKXGQbCePLZeWRRuE5	127	183	183	1615972140000
219	3NLZ6GJ7WXxhF6MdSZ2C6R5aFHgxhBo2p7V9Dkh9ixTzTsvFusxD	218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	700	832	1	1	218	jxaCjxmMT9zXg64vKgoLt6jG4vmSV8BkapYoVx79RNsFsY4wPSE	130	186	186	1615972680000
222	3NLFRCtiqeBHhaZ8RdfUWMt2qXgmM4DuQjXhQjm5e92qnVjkMcT2	220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	152	1330	1	1	221	jw8NkxY9cDFPvK3kQdGnZ6YhSXPHs7VvVppWhMXc4URhK3qccbp	131	187	187	1615972860000
225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	223	3NKgNo9Z3minLdnobnXLMrEPCfLoHnSkJ7E3YKGeQESzXQVm5ci1	1610	1314	1	1	224	jwidiwmuX9WoXzZiubggPcfsUppMQkbDMjCUszkp3z9YVhLYnbH	133	189	189	1615973220000
228	3NLdMZ6Xv7Ume11cX8HDvpJYi4z6paHn5dE5QcKhQyTZhJuCcu5V	227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	1560	1291	1	1	227	jxfC4qeYoYhRVMTkDvgqPRqQT5ioZMx1T2trqgy4MnpSgFZkQ3c	135	191	191	1615973580000
231	3NLircUtp3qoRA3j6N2HMKwkU75wGbBowP2MqmnXJ6WKwDgrSqjB	230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	1403	824	1	1	230	jwH99cxJRuDzFyW4T2yWQUetRmnVcYbBodBvnuUAJ3K2hvXUhgQ	137	193	193	1615973940000
234	3NLk8uJHrHhgnmweZr3vWNo7vM2W3P7Tp9AGt5NZgnkwNzFAWRLD	232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	1541	1172	1	1	233	jxCGSLYQjXsdv3KBxiMUS34DeMDkuSFZkeN3Bf3JkzocrAR3WFH	138	194	194	1615974120000
239	3NLQXsaXuFCSoqKzJqjfcsY5bxjFqgNtvcFHZ39eMyW3pVgwTaQn	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	700	840	1	1	238	jxrx6iYvciardWqhXKFVWP8mkkVJfnbgK53bgQa1nUvv1L5exgn	141	200	200	1615975200000
195	3NKdijar8CNAaN7enSPULyrKbRntTet9DGNyY8M5x4vev2rYVt2Q	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1631	793	1	1	194	jxwD7e3XZ9wn3rYzgSQ6C2iFxznPArC7GBVJdirGEzgHatwYz2y	115	167	167	1615969260000
198	3NLgbVt67xbbKxJYrvhAmQbQeKcdf8fhwkJZjoAWsB6mS67V5gmB	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	298	942	1	1	197	jwyJF36JJWz1QjgLsmHSKQJ5A4gojAPJX4gArrpcAa9B7PdVXLp	117	169	169	1615969620000
201	3NL4fohfZnCfm4goCS2hqxBQS88XqM6jtnaqCGAdA8aAtNBgd8Ah	197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	1541	1298	1	1	200	jx7DdKbVpawq46k85FyPAEkb5h5pmrCT6FcGjzpXbiJsbF4gGw2	118	170	170	1615969800000
202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	201	3NL4fohfZnCfm4goCS2hqxBQS88XqM6jtnaqCGAdA8aAtNBgd8Ah	1637	816	1	1	201	jx1SG2riCEDqdxvVzqviozestbzeDySrGqC4LvoRL1tZNM5LVFw	119	172	172	1615970160000
205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1407	1395	1	1	204	jxFBH5RyciPvdQo2TrS4yzpUCgiv9y45vdZXk9V3svje8C9z6WU	121	174	174	1615970520000
209	3NLa6WLkktrXSXBcSSSeRFV7cpf4PpiAYZpp73fZc9ZEMHxEULAY	205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	1631	793	1	1	208	jxVXdNsRmkv5SueFCfbG3GSK4iCrHDYVsL4ra6YyiH8ecSzirxv	122	175	175	1615970700000
210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	1444	1381	1	1	209	jxUDwGirvtVuQRZsCFijF4g734P7JZmRNLYZ5FBA35xENe4whEh	123	177	177	1615971060000
213	3NLqqXwMZhR6ffs6PCYL67wFWn7pmcYd5qAcgTkbRzX5c7FqZm1A	210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	1623	839	1	1	212	jx6Wgv2kfH5paU9m5hD9gDRSt15SrKdLuKwtVgXEysxtRyf8xMa	124	178	178	1615971240000
217	3NLTjXS1Ch7RHn3Pn3Zp7daoKz9RCZjdws6d5Y3BH4i79C6gHTUK	216	3NKEtm8C4zwxe7zkiyd3HHiaEbUTSBZ4rV99njyH3wEznedfYY8q	44	1325	1	1	216	jxAhZTu1hTh2zZSYupXfSRzAAYo94rWCHqAvHXRRSZ3dqkRHKcA	128	184	184	1615972320000
220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	1477	984	1	1	219	jxvZept3WS3aV5D8ma56nvXqp6nv2RPDVHhJf5mCoGDop9jdCCw	130	186	186	1615972680000
223	3NKgNo9Z3minLdnobnXLMrEPCfLoHnSkJ7E3YKGeQESzXQVm5ci1	221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	1447	1099	1	1	222	jw8MWBRqEzqP61hAfijSFVcDkEp1JBn3XKEKoiCNBFmWPdANAbm	132	188	188	1615973040000
226	3NKjYdSnZazz43mKA8NqjgKy5nLfWdELm5fTFT6gavecN9AvkX7H	225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	1407	1395	1	1	225	jwLFs9WLBPgnuQgPCAtwGaXXcXwJA8DFctAYEUCc7u5SppTSzPR	134	190	190	1615973400000
229	3NLCEWuKssvAxk6sp6pGWNftfE2U6CWmA1rDS51JiaV3tSLhtutk	227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	1601	1262	1	1	228	jwmALpJm4NB1smBTKpjau5mJuvRRZccwMboB3BypHtfHQPXLWpj	135	191	191	1615973580000
232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	484	1073	1	1	231	jwXFmwqyANRrjNis9h9XEzujbaaoJXiN5ias3a5uCjx1XeNy6D5	137	193	193	1615973940000
235	3NK6r5ciM4qoruuneg7xxqYCVzQzFMYSSw5H7NyNiwrg9oipSf7Y	233	3NKZhycHJVd13yGJ37ERpaTYuEiPPWsKVirMEpGmSgQ9pthejW7r	1483	1276	1	1	234	jwfPAQWtLAsXZDG79bcP1JTB8h73VJhg2gryFAcYEStPNKYXrWH	139	196	196	1615974480000
238	3NLYS5AFDXg8v9QajRcA2P9LozodEgPMqNrh1tDnRgDfV2QLb9TE	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	1672	1285	1	1	237	jw7187r7QxxSgXWw5qPrNLKu94F5ze1M7FUF5kNSgQR7sesz7Z6	141	200	200	1615975200000
240	3NL2HEAZUveLHewGAQpxYvEohSu6B2WxFTmUnMJgoFAX61pXFXG7	237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	43	1310	1	1	239	jxfuyoXmzh7M9zRLD5vRBqPcjSLDe2agpxFhi1bcuCH2QECtsNr	142	201	201	1615975380000
241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	1448	1311	1	1	240	jwt7D18cjZuZwM5C1pUc8f1Gyiup5MHJrrQZ3TDL4w5KRDi7dR1	142	201	201	1615975380000
242	3NK9H85ra3AWW1whEUCxBjBiDh7pVQDw6wSEFSjttskmYniJYkTB	241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	1654	1214	1	1	241	jxYDj1gtvuwfxxa4a1ezjZbt8tE2e52ykW2Tm8TCqtUDfvrUFAo	143	202	202	1615975560000
243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	1619	1275	1	1	242	jwhKhtmcWu9PATAbjhLjXrZzKPWrfrRDQMqmhr33F9FC1ThsmLH	143	202	202	1615975560000
244	3NKQvg3dWGS3aDuppXwd8cBPJzix5TupsLi8BjG13r6jBkCqu4mm	243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	1406	1393	1	1	243	jxxxbAZKcjvooxiEdopHrrUxQ3LWbP1ZrXktV3gUyADoRsq1jVP	144	203	203	1615975740000
245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	1471	1140	1	1	244	jw8tSz5X1vpgcritf6E4fGk5zXoq4a3rBeQdyLPPcSScLZjfo4D	144	203	203	1615975740000
246	3NLBYkeQJoTBWFya2efMTwC2JBwxuUi7uGJwpGamPFut9y7SBxja	245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	596	1306	1	1	245	jxRCExunc4tjVxbFFe3f4TzpH84nKZCQgeRqZrD9yRQhaMrr536	145	206	206	1615976280000
247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	1456	244	1	1	246	jwgB8zF1SJra5ZeA2ZUiiNVoxTzjVCaM2AtK2eidibFegn811XJ	145	206	206	1615976280000
248	3NLNuNfKNBZs7cxxRbqLST6BgMuVwSBp3X3P6LQh8AXmriiBWEqs	247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	1405	881	1	1	247	jxjmr42AyyvePDa8R63tPxB9pfiWS4aBWFSmzsK3uL88LfeCTaf	146	208	208	1615976640000
249	3NKotenkTz5RSnSzbrCsUJtZfuD6YyDt3L42mu75XesMAkzLEt1N	247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	1406	1393	1	1	248	jwnYtpsVKVA6rTX2AE2PWR4ZMtZdtVqaWQKEPF72zs79H51MRG3	146	208	208	1615976640000
250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	249	3NKotenkTz5RSnSzbrCsUJtZfuD6YyDt3L42mu75XesMAkzLEt1N	1407	1395	1	1	249	jwJUoufECGXomomZX2HTMHpT9baHjPahc57WD9Bg4mQZL66mgAN	147	211	211	1615977180000
251	3NLB2D5VB1nWfihw4ugDt5d4YYwFQikYjwym5GbDJ8zETucZgQ9S	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1553	776	1	1	250	jx1EA6VVDXHke3fQe4cP7NEZprEYZtH5JcKz15KXjm4X2hNxBQF	148	212	212	1615977360000
252	3NLvNe6X9Y8ArGibbeF3E43sx9887psAvh9y872cyK4dEpyojNjm	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1555	1221	1	1	251	jwZq4cAmok39J539GENxQ7Dyw5rurDgPgbQ1HJ3m886omemyJ6a	148	212	212	1615977360000
253	3NK7JZWEKWNGGLv3oY8ud5Bb12mx64R5ANeiHKQ7qGqW7f6k7mcp	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1474	1329	1	1	252	jxHMcRwgYWkpgi3kW5YcPhq1oMNgy1oLpnNSygVUjaCrJGw5iGa	148	212	212	1615977360000
254	3NKa83pLN7gqyzxT9Q4L3FQWfhywiZdq9mYLHjgZUAUafQvVMpef	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1590	1054	1	1	253	jwBgDeVL5mPAauA5CZcG7yDATt7mSfF9JgQGH14i1uE6euhYKk9	148	212	212	1615977360000
255	3NKUrHbmQQL4DL9vUYrd9VFYep8eUtdpk5MkkzVWPwrofASZVN4u	252	3NLvNe6X9Y8ArGibbeF3E43sx9887psAvh9y872cyK4dEpyojNjm	1534	951	1	1	254	jwUb5rQaPQww72zR4AHUeJd4TMp5mDjWM8VUYFdTme8459MtjMD	149	215	215	1615977900000
256	3NKWovz2sP2AnyVHXoKYgo7ZwZmP9Ud2vVp2uPRCd46XyRC4zew3	255	3NKUrHbmQQL4DL9vUYrd9VFYep8eUtdpk5MkkzVWPwrofASZVN4u	1406	1393	1	1	255	jx3MWWYnC5gRLXKXr8P2suP12wHaYS2AHegMBEakHnP3AM1Hqdd	150	216	216	1615978080000
257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	256	3NKWovz2sP2AnyVHXoKYgo7ZwZmP9Ud2vVp2uPRCd46XyRC4zew3	1647	1176	1	1	256	jwwKnBGvgvBLPyJZFZ3vChET2nwinhTpYmBenSNyxEWhV7ajfhk	151	217	217	1615978260000
260	3NL7enp8w1fcBnTdBDV7K2BKSEgCUCfJxUfLhzK6DWsfQqqqtkFB	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1633	1390	1	1	258	jwGSKLsN4KGiB1e5587AfGUmVFvwE9xPJDVASinDALfWRXTEwUL	152	218	218	1615978440000
263	3NL5V725WiyfuqUaTiKXVm7mcWiMG9pQ9u1NFR4YLtr2TXEL1tPR	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	369	946	1	1	261	jwX4KKVn4HzXX57o45Ng22XZGszkV9UAQz1uFLN2uGvSmS2X899	153	219	219	1615978620000
270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	269	3NLgvAtQKTwVpm44AP3EwGfxTE1BpPMr72fETFu4BbMEgmXUesCZ	1407	1395	1	1	267	jxmVH7VbsA7XP9qZ2crYczZ15wPtvbvXmAJ29ZEuC6221KhxjK5	157	225	225	1615979700000
275	3NLnHoU6KoGQhW6EKiUvyvtzcXt4n4EnZ7u4SzwEED5JG1rR7Z5J	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1576	605	1	1	272	jxZ4Sx3dDAVt21fZvB3FamhWtpr1hcQoaYaWoaPXNQxyum66TJG	159	227	227	1615980060000
278	3NLUtRbJDbms8QtwQcoJUjq2FVE6mDGMUCUXPLoQLCE1LwB6pDKG	277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	1445	1164	1	1	275	jy37KDpiYdd1pmoAdCqacRxwxygT337TJC8a4WuJdNLM9CVxqxx	161	229	229	1615980420000
281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	1577	1081	1	1	278	jwPytQMvd24eLoheEYJA7v8xADTGumBXrUxPvJMrdg2c2kfAcBg	162	230	230	1615980600000
284	3NKrdRNp78V3BaCBeovhsm5FSCd2jCKBHN1L68VVKdng6o6dzqMb	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	80	1147	1	1	281	jwggebK9A4TMZsQwU3acvC9qwKj9TZ8ywCytKpNVwjQz3zct8vZ	164	232	232	1615980960000
286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1600	1372	1	1	283	jwR77nVNLvhrrRDj8N6ooeUyHZhfxtYxTVSwoVjkeUS1QtTitDw	164	232	232	1615980960000
287	3NK7ACi7yLMsSuvoBBKoYQrsgYgW4k6zdFu6z7huNyESdccb2XHY	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1549	1362	1	1	284	jxf9HudKiLdvsEiSHrZL1N1HpTFntrfG6k8mB8kZG5R4KbdbbwX	164	232	232	1615980960000
290	3NLkQjhLyqCcHpha9Nt93ZxGuRhfKAuYkaYHLR69D6b7rGy9JXrK	288	3NLqh2XF9xceyAhqUydiAm15pNscjBDdgM2BV8zhQC1YnfeeJCMh	1594	1326	1	1	287	jy1KrkSsVktxJ415oxBytdgJcySX9HT3UxdEFRpPM18PSr4TYTE	166	235	235	1615981500000
293	3NLjECjRkyh969PsNm2WZHeGg4EcFwub4TTUtEz6XKiafpNQRGim	291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	1529	950	1	1	290	jxTz6VTEj8ogBVXT4uceyARcowooNMKuSncE8iZ8FVq8HJ4awNL	168	237	237	1615981860000
297	3NL7f7ifxb9LGrjsXEeiN9oauBE86gzU7B56MACVmF6W6fnHk4XF	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1407	1395	1	1	294	jy2ZDYZ22bqqfxEDZiKApSuoqqZtgDyqKiprcQ9qeJZNKRpNSTR	171	243	243	1615982940000
301	3NKWc9MGWbVjuhzbyzMnUvgeVuY7FmCevUu5KYkehDca6qVDyU9Z	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	1529	1316	1	1	298	jwfHjNMNfMFwJuD11nxZAyRTvRyPWzgX4sqqAEb5nHxqgGUCM65	173	245	245	1615983300000
304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	303	3NKwpBPcUva36bwJHoBgwFv6iTEMq7cqP1HJ4PHAZYNzGQgXEKiG	1589	920	1	1	301	jx23CQTB4jQ4HhKSxB68sg7yN9dux9tsEZALHFFG7VA8FiMKU9j	175	251	251	1615984380000
307	3NLjv5ajLNev18TUc9REZUKdU7U7XRkNWwts6EetYTW7bzrHaDcx	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1559	1107	1	1	304	jwwvoW7jXbQ1dkWieeeZSoDTWEofd5ezLh2HhEJkUDErDbTcTh7	176	252	252	1615984560000
309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	308	3NLCP5QPi4fKpT8d5QeRfbVLg7N9TPzgVsdp1XRzF6uwkQThj6SF	606	1049	1	1	306	jwbSevsERHMpL3MzaionrpED17QoRfLHPhMiQeLMXhqAPuznvR9	178	254	254	1615984920000
310	3NLRjacT5RPtEc3T5wM81SJcDoL7crG6gJW4PsvN464hQmmcPCWb	309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	1407	1395	1	1	307	jx6ahYLsUswzWiLUdTtxtmN66EAsBhNWKfHke5ukQWRXZg1Jt4f	179	255	255	1615985100000
315	3NKSZdU7MMtAVNyUAwDrTUQawwcK2GzXEHMQVuR83uKKQ37rHfjq	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1555	1221	1	1	312	jxZjUev7NPcwn76gFKoQ6oLBBvAiTxCB4C8WeSsaaqR6g6CoQgy	181	258	258	1615985640000
258	3NLH4VkbsKeLy4aYf4vfCwzAexHyLy999UiPAcMnAtUfGBFwKmdv	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1651	1055	1	1	257	jxvMpEGFKfcYUpzXZ2u7eS2xSTwb8sNKwgX2SVCdueQ9kP644DH	152	218	218	1615978440000
261	3NK6edhb7iUHMHvACytTQn4qTuWEPkFLfa5omn1D19dCRUr9kYuv	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	344	344	1	1	259	jxYt8nejgt8So1zYdReFw6sEg3P4NT7vrbEpT2dSptTSZMHn3oW	152	218	218	1615978440000
264	3NKe2ynue5GvD6z4ggzYUR3PQW5Cy4gLyapgcE32r7ZXAJuWL2gT	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	369	946	1	1	261	jwTrCNuo3vmVi9BhKgKZtUw2qRjCbpCkqBgvc75Fr7m95LjWwms	153	219	219	1615978620000
267	3NL7R1KzArCiYL6CiYAkNK2WaKtD4uni2BUQz6CNrjxeLVr6PHPq	265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	152	1084	1	1	264	jwq35iVvLQwAxgcGuV1qNmbpnuv4B4SsHnB5MAGeJApRHt19Rt2	155	223	223	1615979340000
268	3NLE1MUivhAC3vKq8vYNSfXSDw57sXA4YBmCp2tXF7BL919Kmaxy	266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	171	1128	1	1	265	jwCk9SJjRNSxnC73ksSNvBXS3HrDkjghSGVkNZAqBXQQKMgUH1m	156	224	224	1615979520000
271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	1571	1209	1	1	268	jwHKZZ28cuGtm277XUv19fiEmyxtVBPAvefcwQb4KZ6QynfNrV3	158	226	226	1615979880000
274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1407	1395	1	1	271	jxbedzsvm1xa1LXbbS2hhG9C8NPbFnGNkkncLgz6JNBCtKDke6A	159	227	227	1615980060000
277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	1631	794	1	1	274	jwnboQquuESViWcEe9HjLb48wPWosxmzsUaMgsqKiWYHKe7ESLA	160	228	228	1615980240000
280	3NK7pTgDP5JKPwTPpAPQ6XhuUxcpMfARm3c5ghc3QrNianiBN3Hy	279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	1455	1332	1	1	277	jxVBmo5M7aJhtD8XQRt4R7Cmt3BCYtvVxSWmup2ND66qf2QCrVF	162	230	230	1615980600000
283	3NKxfpsY58PTfgGGn71TQ7FjTH9sjDvhXyuUSNnUQyn7N1QQR9QR	281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	1637	816	1	1	280	jxopVEGNmD5394525ScCRrSHkuWxax4u3Sr87UMpb7dk1W6K9fe	163	231	231	1615980780000
289	3NKrzpubRfiCe4Zm1GCqBrVo8XEjipVhHhb5yE2ndV1KRtqiKALm	286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	606	1169	1	1	286	jwp4XgcsApYFxFXeH2zAk5yk1FwcjDMMi67JihFhZuZCFjvUSHE	165	233	233	1615981140000
292	3NLnSEG1RWsTRifrn5kNdSGBCijXXjMRmdHKAp39kfuNQ21vTttv	291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	1403	824	1	1	289	jwn38ZGDfHyerYikyQnZggSGiK7jXaZ3AC8vxd5bJ3Nn8hpAYdo	168	237	237	1615981860000
295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	294	3NLvuqb5SkHshrNv6svMWNxEHvDo7WyEk6tN7a1wJFuqWQnSJdSg	1637	816	1	1	292	jxY89fbuL52dNm6ZgzDgVa4KCwF6vNFekXaLwoncwzm5YsRjap3	170	240	240	1615982400000
296	3NKsbj3fgjpoQPFThBoNW7ubxKb5MdoaXSX2DyBHkaiPZ7L6jXp8	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1457	1025	1	1	293	jxv2TJwZjdntczBMpD42JET6spFLEmQKTcpswpj4gPqvuBRCCt7	171	243	243	1615982940000
298	3NKFJConE4XmXg3LnwUFi8aSNyoBxHRsLD8sjbFSJjy64GMSAp6o	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1600	1126	1	1	295	jwUkSgoh4pTxUSy1Q3Wumf4vZvA5yKy3bKDn6pxyEna18nsCb5Y	171	243	243	1615982940000
299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	296	3NKsbj3fgjpoQPFThBoNW7ubxKb5MdoaXSX2DyBHkaiPZ7L6jXp8	1542	1304	1	1	296	jwqUW7YipVmksB8jXcLU4q65RYnjsPYfkCSGKitBcjTSgpFeKGM	172	244	244	1615983120000
300	3NLTVKQTPBGD3R4HS9VJhPmU8Kve6r15359aZjLeKHSoR5EPeZWY	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	298	1308	1	1	297	jwnydg5k3Kw3b4cKxRrnko8xBjAA2kWyeson4gE9mfQTeRcAjm9	173	245	245	1615983300000
305	3NKEWAPuz3NrTQ3r8Bv51qf2PBjHYG8JwcbuwBhN3s3fSiq2aQYX	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1406	1393	1	1	302	jxmWpqZDQsQQwvFakTnrQ3Tm2Z34Aab7SoXu8HJ8CrwgwYiTypY	176	252	252	1615984560000
308	3NLCP5QPi4fKpT8d5QeRfbVLg7N9TPzgVsdp1XRzF6uwkQThj6SF	305	3NKEWAPuz3NrTQ3r8Bv51qf2PBjHYG8JwcbuwBhN3s3fSiq2aQYX	1581	777	1	1	305	jwnfYiyBjRpXpnNgVVciQpSjXoNx7ipVGchSfP4rymT8HJRm8HC	177	253	253	1615984740000
311	3NKCr1JDqXhyY4NJFzvVTH1n52hLuWLQH5vCjDePTBpbhx94ZajT	309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	1654	1214	1	1	308	jwyXqcamTxxZnnMSqh1jX198iArZqh96oCS3oQ27jNWk5n2d3oY	179	255	255	1615985100000
314	3NLhn971xP5RH7DUNx196safQKrKNtA4FuhWbW2qmnTa4yymMJrs	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1541	1298	1	1	311	jxQKuKi61DSZHyVowxQxrUV678N1SWXe9ykkJBm9hap7XUQSqNU	181	258	258	1615985640000
259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1651	1055	1	1	257	jxNj5UrVLqBmeCYBY6T95cXavWWb5pqk7tep1RHpDuNPNW6fh8n	152	218	218	1615978440000
262	3NLfQ1boKxvTL5RqaBXjqaPcHeTrTWc1y7jYK6MGRuf2cbuCg6us	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	1406	1393	1	1	260	jxyJwwfiiH7cE7nTUgt5PEVCLrNUKk9qFhhSeBVc65k4rpbjsFJ	153	219	219	1615978620000
265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	264	3NKe2ynue5GvD6z4ggzYUR3PQW5Cy4gLyapgcE32r7ZXAJuWL2gT	1527	1047	1	1	262	jwGwCTunUj1ko8wHfsbZrzo7VLjweFRaXKYnD7T3tGZvgxR52LW	154	221	221	1615978980000
266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	1534	156	1	1	263	jxwWJrtiyQDhgFrHZK5GrV94LAv5i4PJYMnqHfNBLzspKzjnKZi	155	223	223	1615979340000
269	3NLgvAtQKTwVpm44AP3EwGfxTE1BpPMr72fETFu4BbMEgmXUesCZ	266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	1601	1388	1	1	266	jxBci9XVsjDTn3DdZVYPdD9QUSE9reAdipx2wkFeMF3AEEib17Y	156	224	224	1615979520000
272	3NL269N9dqVw4GS6UiNYQrXUmKubSqX2A7JCs5RzwiGH71HeeVAM	270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	1590	1300	1	1	269	jxrFBSzKB2DwqiB261AZJbKuvbPTqZ3o8CuCsGbiqXhJwe56D5C	158	226	226	1615979880000
273	3NLNspguYhduGTGsMYBWBavejnoCEDUmfnftnWQxHLDndeggGTmt	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1406	1393	1	1	270	jxyjWb6DRH2xDRdRnVnqqmTJbovTG6aVi4Sw8bpeUfwWjYdiZcZ	159	227	227	1615980060000
276	3NLWc5eoogmpbXezrMhK7BDv6rxNmhRS9X2JxzDJ8qihe13y9wNx	274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	1483	1276	1	1	273	jwB52E23eX8oC21txTVUXiQQ5VBmFF1rGi5wvQxDBTVhmH95JDs	160	228	228	1615980240000
279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	1633	1264	1	1	276	jxVK2RN99fxgFcFs7vvR6dFbuTYf58z2a8rWfZdNRK3YdRmFVpp	161	229	229	1615980420000
282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	1406	1393	1	1	279	jw8ijxDuWjaVvvSSLt7UmD9FmH93adxdRWWym7F2tSyoqnmXUeq	163	231	231	1615980780000
285	3NKVzHSbHSd2wpFqJa7iRfGbTk8tptXBHiQHcmwYnuMwzB4gBvo8	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1406	1393	1	1	282	jwQQrq6pKmz66zHW5Xqga8rJt3rRc1e5PzNEGbKdwFCh8UVDdmY	164	232	232	1615980960000
288	3NLqh2XF9xceyAhqUydiAm15pNscjBDdgM2BV8zhQC1YnfeeJCMh	286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	1406	1393	1	1	285	jxAnbm9XyLp8sRfc2zS5WrYbpH6ECmQTuG6mKCrosSGTtT7EWTs	165	233	233	1615981140000
291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	290	3NLkQjhLyqCcHpha9Nt93ZxGuRhfKAuYkaYHLR69D6b7rGy9JXrK	149	917	1	1	288	jwiNeaKLa5UimYx3rwX7u11maspWEbL38Z7VQThrkCYB87mPfqk	167	236	236	1615981680000
294	3NLvuqb5SkHshrNv6svMWNxEHvDo7WyEk6tN7a1wJFuqWQnSJdSg	292	3NLnSEG1RWsTRifrn5kNdSGBCijXXjMRmdHKAp39kfuNQ21vTttv	1594	1326	1	1	291	jy1w5ZiFkMciHkXDPQn32NU1r1o544X8oEFS23Mho7Sxs1hiKv2	169	238	238	1615982040000
302	3NLiLZXqKXSDGRvrvUPLp1DubUrCFHv9EmtQAsbKLu7teKPJMqaH	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	311	1061	1	1	299	jwTHym2wQ7Zb9GpZnXSkBRAagoQitBTCogbSYLdN8sk9rnCMFYe	173	245	245	1615983300000
303	3NKwpBPcUva36bwJHoBgwFv6iTEMq7cqP1HJ4PHAZYNzGQgXEKiG	301	3NKWc9MGWbVjuhzbyzMnUvgeVuY7FmCevUu5KYkehDca6qVDyU9Z	1483	1030	1	1	300	jxQWhwuqgQzzBc6J977fmmTKL61HQ3LutGRcAGwGi4HkUeqmiN5	174	247	247	1615983660000
306	3NK8MbzX6MrjU3smAByLbeQfkwbiAnn36EShFHKSiNVULo6f5NFK	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1507	1280	1	1	303	jwGBgFknXUS2EwvZ3icETxWC2Z1T2w3tSFZUbcBqpqs8JUXv5mW	176	252	252	1615984560000
312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	311	3NKCr1JDqXhyY4NJFzvVTH1n52hLuWLQH5vCjDePTBpbhx94ZajT	1503	1277	1	1	309	jwaPf8y8LG23dWFFtxM5ovyHTDMLpnrHo8CduH7K6FWj87b6m6s	180	256	256	1615985280000
313	3NKGvm3BpovrE4g6KMAZ5yW3MadnbKhYTUdJwD3E2PMY99kB3w5C	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1406	1393	1	1	310	jwJY5LuzDRBt9VjLs43dt8DuqSEzgd32pCZdbfd8SdHVZjydGaw	181	258	258	1615985640000
316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	313	3NKGvm3BpovrE4g6KMAZ5yW3MadnbKhYTUdJwD3E2PMY99kB3w5C	1407	1395	1	1	313	jxX2RkYz9ccYhbqxSRsFdV2tm2wfyUWWT1uBvxZwBTxiYCH8xtN	182	259	259	1615985820000
317	3NKzFEV1UTiFYrCGE17WDuQsf2T9EatXr4hsQ9c8toVc8eUMGe7n	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1403	782	1	1	314	jxsGGDy5cM6bcCLui3fgjzsVrM5Ngj5DTXqA7YLDf3SnUhgBxzF	183	260	260	1615986000000
318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1407	1395	1	1	315	jxLD27iqMQRUJMHM6Qaew4cTEpjiEphRzMp27RJDcadq7iFddAJ	183	260	260	1615986000000
319	3NKAg1fDaT79x4v69M9u3Cb4X674vHvS5gh7UMeZjvvqyHAEu1ND	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1631	794	1	1	316	jx2qnXmBqcJqNCpVeC6azAC7awfqybA8ncvgh8FSY7Y71rxYV38	183	260	260	1615986000000
320	3NKpBHMh1uJonbxwUx5s1a3PHRzVm5LPav88ikCv2ii3YpyPVQA8	318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	1406	1393	1	1	317	jwdmeRSLYXsrAYLKnPWqd5MBjtwQHY2zUFgjur5DixiETVrBmB1	184	261	261	1615986180000
321	3NKhAchWTAoFGfcX8gwMJDGXAyBHXYxTAYxpehd7DdEdrm4mCKAU	318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	684	1226	1	1	318	jwdYdkAob9rkxBXbsTmjRQ4GL444s2mTfa45Gvgg3fQVtj4b9FE	184	261	261	1615986180000
322	3NKQ3K2SNp58PEAb8UjpBe5uo3KQKxphURuE9Eq2J8JYBVCD7PSu	320	3NKpBHMh1uJonbxwUx5s1a3PHRzVm5LPav88ikCv2ii3YpyPVQA8	1553	776	1	1	319	jxPgyLee8L9hLbuaNvDDvMLcMeEYMVVPhiDwG2YjqvzgUMnejiM	185	263	263	1615986540000
323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	322	3NKQ3K2SNp58PEAb8UjpBe5uo3KQKxphURuE9Eq2J8JYBVCD7PSu	1672	1039	1	1	320	jxFaPeRcqUFJ9puVJ4NFfpa66k25pmFc8KfFsmdcfFxaDTxgvJF	186	264	264	1615986720000
324	3NL4WKqpCiWTuorgbLt5nVH5aWKCFnFKseY1gbLJzq7fcXif4fpm	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	1406	1393	1	1	321	jwVHvpEoy8oqKDAC4A8Ay977bVGJSoQhzkTks1UZupMR2JWH2hn	187	266	266	1615987080000
325	3NKWLL5sHjwE4jizSYHPBb3Yj9JfPFvDcmRP46t7dhnJsQHeU3zZ	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	42	1361	1	1	322	jxK5bVuKn2rpCqKUao8KYqGwcm2rDZ5XnZvaCEUjc4FryJ1o5Vf	187	266	266	1615987080000
326	3NKKcQ91BH3uZAi4D9vrooeQWKCY58EakUieKANWBdhhB81rt5XR	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	1483	1150	1	1	323	jxVthbjToFZyoU5VuemCo3Y7h4LnMKLGywdZfejVq9KTHtKt61a	187	266	266	1615987080000
327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	325	3NKWLL5sHjwE4jizSYHPBb3Yj9JfPFvDcmRP46t7dhnJsQHeU3zZ	1407	1395	1	1	324	jxtbzaZ5kh1fFYjiudKCEPAWdverpaTftuY8sbn2s79N9qzhjKm	188	268	268	1615987440000
328	3NLoV2xF3YWkQ74o9cCP96hpqJGZfCt3QxQNZADGsfpDNK4eoeeK	327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	1536	1313	1	1	325	jwu8bmwApJT7zq6w5RsFGTmuuNzbNfqiseMJs7viRP5bKE8zUo6	189	269	269	1615987620000
329	3NK8F24XUQaztxZ4eByUXJhb7YVGso2GbXGr6m4X2YTRsk1bCmrv	327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	1516	928	1	1	326	jwnCU9LFeXu7eTAF46TGwkuK5oV3r4NYh7xyd3cUzphEnSCi9Jh	189	269	269	1615987620000
332	3NKixCUBUaivA195eGoGMP46Y7J4KyvhRUJ6urQ5zH68cRgcEoy6	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	606	1049	1	1	329	jxMRWWCGrLdTEv7nbhKZyNHD1P1LKccFD8PwpGv78SYEELyWezU	191	271	271	1615987980000
335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	563	1233	1	1	332	jwrJGagt6SDNDxnF9eE36UTZP5NW8CbapfQnjzzR7DWbQygSFrb	192	272	272	1615988160000
338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	1631	794	1	1	335	jwEJnaWUEQk1gEU5pjyQkmdeuXqQs16TSkx6tNxpUxQ2Qh9JFX5	193	274	274	1615988520000
339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	1406	1393	1	1	336	jwP5b1izuEYqdHsFexN6k7KG97k9RgjuPjAUHKSRMamuTSArfFZ	194	275	275	1615988700000
342	3NKzqbUb1wQx9kgdLAV4M9pm7iY1YeDZMBvRJhXhSbvZWyvJERHg	339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	1637	816	1	1	339	jxvqPdfRXdNteq2Nx32FVv64eCg6rr5xnvCZemNDVDyuWybe3xK	195	277	277	1615989060000
345	3NLESDKboCbsFHsMeHBHRPkNjW5gNrf9TrZNSXVddd7oMsmEatbe	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1405	867	1	1	342	jwqrEjiUe2Un6X3Me8QebG1MV8iZjma43SemGZ4XVvxdM74H8sB	197	280	280	1615989600000
348	3NLigq6xRmEeRBToYNJ4Hx22mRS9DtzTDW1CrEXRm7fJVtwz8WWe	347	3NKb9A64shsGEYHYVNecTUR4A76nabCkriNFt8qqNSq1BYayuwaL	1406	1393	1	1	345	jwmVDewhybBUU4HgvHrV9RvcL989vfZnfLZjfq1eKzA5n1DZFEQ	199	282	282	1615989960000
351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1657	1344	1	1	348	jxKrxXup1qMxv1RjRFrKC9j5hAA5nXM1HahCSsmt7JFrgJtDZQ1	201	284	284	1615990320000
354	3NKkbDjZ9qs4JViTonTjxnHDAdfSxDHHZ4RgYjE52rNkwFQdPbdg	351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	1407	1395	1	1	350	jwMPdM5xjNjnLKR8vpAxnkCHYqaXGwDEC1hgRXw9af4jzJewLUb	202	286	286	1615990680000
358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	357	3NLVGieupLJWUYBrCDtB9TV9KGYoQtk955qnEeizswvSYdKJnCXo	1619	1275	1	1	354	jwwmBGX3dJkgoH5Ven4BaKZqTiNLssewYb9oUzKgjW9C2Y5ZQ2X	204	291	291	1615991580000
359	3NKFt2eJnKqCqviaZ7mftzRCJyzQs8t6iNNeUvmHZb4AqsRuiZ4X	358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	1406	1393	1	1	355	jxaxNPqjzJrCuUpTRyzoqmq12s8TW2nFykP56r5Ju8duJ9Yjfpn	205	293	293	1615991940000
364	3NLHzADsbmA6iqmWBkRZduT1f376iAScbJNSz9xHMR1JD7qz3ek6	362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	1407	1395	1	1	360	jy1vomNnyBgJy7mmLzZzYwAwjzdwqDbJhkKgqUAncZpLjc5Axm8	208	296	296	1615992480000
367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	1396	436	1	1	363	jwKNxbLvPVi9H2DYHde1K6SrT2Vpn4KaW9dQdP99jXXPN6M4LGY	209	298	298	1615992840000
370	3NKr3ie113yjCgEzckFawyU1xtAg3DccYiLvDrJVSiUdSGAgtGb1	367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	1483	1276	1	1	366	jwzpvVoLsYVDWWZSmAdnFyU6URVLM7qqBGcjyER318oiPazNn9K	210	300	300	1615993200000
373	3NL7c3B78NXp2AuAawmXq6SgtJENprGzUnLfkuQAtRFxeXU3P43U	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1524	119	1	1	369	jxnooLhPvV3zs4ktggg5kzH4Tsm3AyQxopbSRY96BUEiBLcv45n	213	303	303	1615993740000
375	3NLxxJFLxmDHxXdWA6f3Hp2bi99SiucD1dLijaVZC6CjwSPA7bbR	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	43	1310	1	1	371	jxh9xjYF8G5mBzEbpsPN3Rp9ebBXv7GAPVDCVuhvSLgvi91hChv	213	303	303	1615993740000
379	3NLBYPTuQV9EpfbjnS1d1s47Ny1Q6MuffWZFKw7oMCNftysoKiQz	378	3NKfBKYgysLTUumXscGUFK51cbj7eeYy38ka1sEVZxwaF23GHdFB	1405	849	1	1	375	jxFoacQRmcCnp8nkPwRyPdzssFau3vohLD2YucqcwoD8Yb5Xv4E	215	306	306	1615994280000
382	3NLUMVTutHHFoeyYR54QjzMJQrr6wi9vxXW5zFhgeVsESSiKg5t9	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	1407	1395	1	1	378	jxcvPe3XdE8cC4Bpy9ZdUARaGwFdCHtrqRN1WsoDb7EA8YqTTPR	218	309	309	1615994820000
389	3NKFFQDkj7Xx8oN2uQQFVXroviSZque3QTfs6D77sxMWiXEKPSuG	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	1643	1173	1	1	385	jwG1NMs17nTZNNpEFsgYKh2Ecn1pt87wGNrsviXvy63ALow37As	221	313	313	1615995540000
393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	392	3NKdAwzou2W8DhrtFwPDPJkYz4jDj7KU4Y5NxUsiW15EUevPw91m	1581	778	1	1	389	jwj7iw1M7rZHRkeFx5oLwacLqL77rVxkhZG4FPp4K6LfsqFPqES	224	316	316	1615996080000
394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	1508	1387	1	1	390	jwGB1hV3neh1sg1PpHzhTF9Sx7eY6jbspiH8oEs3vQSxEi29i76	225	317	317	1615996260000
397	3NL8AiW3y4epGxtoL5G4DBUoWVBwHLQvaVfbQXUGpQigQKxqPa21	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1607	1348	1	1	393	jxnzUP8zX3emJ4DJsgMkJ3qEun6GdYioigttiY3RvNkPitirzbk	226	319	319	1615996620000
330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	328	3NLoV2xF3YWkQ74o9cCP96hpqJGZfCt3QxQNZADGsfpDNK4eoeeK	1440	1377	1	1	327	jwhmkoL3pWcRgke613BXGdfbgWNpwsoj4CEiyU63vx9qyhAssqM	190	270	270	1615987800000
333	3NKS5oAfJRmLDuREhRqXFBStMfba7Tsu1HYwcZxMDseau2ZKfuiM	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	1581	778	1	1	330	jxghWJP8sZ6vp1ttMoZNN1vN6p7VffpJy1mRzq7BPRT2n86c2nz	191	271	271	1615987980000
336	3NKTSf6X9mGEKhmsBz2XjmP6JuDi4T2mt1rWS4LSRwcTSKRvC7ez	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	1406	1393	1	1	333	jwE2ZNSdqbb4mdXvb2PniF4gtagkuquh4dMCyqMKZ9NowQL1R13	193	274	274	1615988520000
341	3NKFBzGMixEa8AU6riAsen6xoKgEoMUh2LzXNim6c2L9pgn5V8kC	339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	1405	867	1	1	338	jwd78LvkzrwfN5j4aAU6gUvkCXJyacXDGnUch83DG4ugchyksJz	195	277	277	1615989060000
344	3NK6AGwYVDdhCipZpWbJmp5Zv4vShAWrVVpyN4MtfSK1McYQqt3a	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1406	1393	1	1	341	jxVMgqWNBb9uJ5igEk29gQn9m8bboyVs68C8V1c3JGAdavc2iQU	197	280	280	1615989600000
347	3NKb9A64shsGEYHYVNecTUR4A76nabCkriNFt8qqNSq1BYayuwaL	345	3NLESDKboCbsFHsMeHBHRPkNjW5gNrf9TrZNSXVddd7oMsmEatbe	1407	1395	1	1	344	jwiAZrvotQG7yaiqhoPGeiTZCjqPCK1FeLJCAw3NRg5WxD7ft77	198	281	281	1615989780000
350	3NLKxkstFTXLERmS5nQGEGf89AxVsj3kEcjKFC2DevAWkwAFkPsH	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1405	843	1	1	347	jxWaStfkk2VK9mtLbppmxr7VkndqJdD2wnAjZhfnT2uifqQCCV7	201	284	284	1615990320000
353	3NK6Ts4p4setuSinGyJTEjF51gk89ecs3b7R95d4vKCuBX23L9nf	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1463	464	1	1	349	jwwZoiVddez3Zmu5uZNwZQbgJJn6r1bLsaSbBKEW3ZsGmheHUZj	201	284	284	1615990320000
356	3NKgskw1jmCB7gmBBw6FADC5G3n1BgcLJLSRGXLPeA7etjesJK2y	355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	1460	1324	1	1	352	jxyDK8sTCzYcknFr7fFqMp5bPTXM8q1F8AKKJDfVHjdtRxrJGhN	203	288	288	1615991040000
361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	359	3NKFt2eJnKqCqviaZ7mftzRCJyzQs8t6iNNeUvmHZb4AqsRuiZ4X	1610	1068	1	1	357	jxRswh2Dw76ZDixyCyp2zxZBicqFX4Vb1KfPxtFs6xWKJNLYF5R	206	294	294	1615992120000
362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	1406	1393	1	1	358	jwJnE3zTP72mvfFFgT3qUMTCGonWuJZLQf6Ng14YSaqk8nktEYx	207	295	295	1615992300000
365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	1477	1350	1	1	361	jxrDxYRgvXxhbgN6XEqV7uHUdzshJ4WvcNPzCTSk31SVsA3qpmV	208	296	296	1615992480000
366	3NKJTJ96ZP3AiroYn5WGVTHzEQ8gKPLgsoATgp6tbrZFhp7x1sxG	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	1406	1393	1	1	362	jxBEeaYzHSE4URCveoFnPcJBKBkdKE9vxYubfj4Zc1HuSXp1ZaG	209	298	298	1615992840000
371	3NKkxASK4PW5Lh4Xiaz3TuquEn7GRDK2guDiXtE7qpy92WELaN9u	370	3NKr3ie113yjCgEzckFawyU1xtAg3DccYiLvDrJVSiUdSGAgtGb1	44	83	1	1	367	jwHPGAzGorszMkgAE8ycWZvCPhooLq2ANy8eQjtc9qYF68vXM1S	211	301	301	1615993380000
374	3NKzu5QbFCSzUrGxPqZRNTS3VfiJ1c9qa7QDr6a55JPCzLkxZXL3	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1405	851	1	1	370	jwqEi3v2uimXbNEHBiSaSHrfAmCZ1TCLYDvDpQeSzY7EHi7jNEV	213	303	303	1615993740000
376	3NKTWmW9t4DFkaR5bnpEoqdn2jBxRdWa8SS3CJucEBXHEFU6Teuo	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1407	1395	1	1	372	jxJNtpHUdoujuF9a48LaMH5na8SqBjfkKtVmnWZ81xvcuZt6SE7	213	303	303	1615993740000
377	3NK4ZhCVmCGDEz1o2HGGkpKJm34jHCMV79bVBHgyGvWJ4sdXmmdU	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1581	778	1	1	373	jw8of9k3uzpR3nNAi1m8eQp1f3CLSkdaRi5c9wbvPQWDHdwhFY8	213	303	303	1615993740000
380	3NLSa2ctSd1MXxJb5pBBZTfQXjvodBQXcXmG7aB5ybciq5kNqroL	379	3NLBYPTuQV9EpfbjnS1d1s47Ny1Q6MuffWZFKw7oMCNftysoKiQz	1585	1240	1	1	376	jxhtaXt5sdbppEsTT3gid61xQh8jyPejFif1M3HepCvzE5vyYR8	216	307	307	1615994460000
383	3NLScDpvTrfefxVmMC8KHvHymZzDv6fFaYfcNzDRiSwKFckWAJBv	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	1460	1324	1	1	379	jwrzh3Lg6qqTpfy3xaPyM3sjgC9wA4Uqj2CXgzwKVTK9twFbb8e	218	309	309	1615994820000
386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	385	3NK8iwLoZYmUUdQsseZ3sbLeRW5Dy46mtFuKmPz1DjvWZTLPJmfY	1407	1395	1	1	382	jx1UgeiJSA98574dc7WGVuPLWA1nQArJzPRuh4Ljcaucwwza2Ht	220	312	312	1615995360000
387	3NLVTYxNX5bp3o6wM8kBrvLDKGkg3Q973ZwFUAo2sVyUSw9A72wg	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	596	1180	1	1	383	jxxDkM5ot6r8dEfV43MsCcmJZUwEPxfmYn4CetM5Pu3BCi8iKqp	221	313	313	1615995540000
390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	388	3NLk3PwP9TNtv5trqYB7mPzKbMG3EghP5mznzG1jKyCijquVHh89	1673	1242	1	1	386	jx1nJimgeSvsNDh5yu5QEoaPS1ZEQaZ44HimwWJBkixYtr42Qjy	222	314	314	1615995720000
391	3NLWdQqiBkDbYzduZ8RJra4EiRFACF2pusb4CL2a9oyGNCmDyFBW	390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	1407	1395	1	1	387	jwQXUHi5WfXj9qpvn6J6bmfobFHmdjVTesVAAm7MqPVuuZUC9dh	223	315	315	1615995900000
398	3NKKLkGspf4qqBY84hRyZzZkGNiVSrdMk75WBN2EAFKSbNmnnkyT	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1476	1371	1	1	394	jwoKuS3S5sMqAHGPRNEq16EjVpGTGvZqu7gQ2e97d8xDBMr86rW	226	319	319	1615996620000
331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	1599	921	1	1	328	jxAjqNqQyqGoLbEje1HNQt1xfGmFuhTWhrC7tGDwY3TYADovSJJ	191	271	271	1615987980000
334	3NLLB1qq3hV1exeZ8SdUM6pP1kVWui3zr7RuPLWUVYGm14xF6rd7	331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	1529	1316	1	1	331	jxq6VK71AmAoHzoFZKSvMZYPNrJghJppGE83CvWSomGNWcvRm1m	192	272	272	1615988160000
337	3NLDvNN69tvBfFjBoUefXKdGxNHcz4LQMTewZdEqWbXJqD7dU7DQ	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	55	463	1	1	334	jwjjfupnB8SFKNqoPueGdEgQiUf7ugz2MzxYnERLXqekPJKL1Bj	193	274	274	1615988520000
340	3NLTgYRVxW7g8W5U5kTW6rC3xCD1sv51jn6FF9MRcUe87WETMioV	338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	1631	794	1	1	337	jwNisQ5wwHLbAjfYNdismdLHY1Pe9WZWJt655iPLgmJBXHB1eYU	194	275	275	1615988700000
343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	342	3NKzqbUb1wQx9kgdLAV4M9pm7iY1YeDZMBvRJhXhSbvZWyvJERHg	1527	927	1	1	340	jwEVsvrmJdYZjbP8BM3btpX4B4sptxJVjRakBTLGtFPsNjupBMu	196	278	278	1615989240000
346	3NLsCQVQBSaNcCpiNv7cGTVjse1Rf9aDJ91bNnHkPHVH3ACWxmrj	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1448	1311	1	1	343	jwf1msCugsLH1QRAnJDt8R3X7VBtDuUyAFve5QiM1dVW9khvPhk	197	280	280	1615989600000
349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	348	3NLigq6xRmEeRBToYNJ4Hx22mRS9DtzTDW1CrEXRm7fJVtwz8WWe	1426	1118	1	1	346	jwXXYzFUkxTU2zz5CfmtHpDM1KP7GtcHxvRyDZG8NjJdFN3CGqK	200	283	283	1615990140000
352	3NKrBVvhQPfvxG9D3ZLDY8AVJVbJBPsFsNQUS8QBRnCtoowf7Rmq	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1463	464	1	1	349	jwSwJ6jRyhpmTxmcFrmARi6t6FF9GbhbYF7qa9daRrAMbxZs9xB	201	284	284	1615990320000
355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	1448	1311	1	1	351	jxTLTb7jcxpXJGBK5UttM5EAdjpDsKd7D871NZTffeFFDu4p9Wg	202	286	286	1615990680000
357	3NLVGieupLJWUYBrCDtB9TV9KGYoQtk955qnEeizswvSYdKJnCXo	355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	1560	1291	1	1	353	jxXw1we7oFkvdWxYwaKXJi6ta4GR5WAKp4ywTJy8cugLL3cPoTx	203	288	288	1615991040000
360	3NK7qH4xU5FQrvBhjMgNvwXTUKpU4iPdcEhne4neJMaFoCLwMqag	358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	1560	1291	1	1	356	jwjAKYjPtEcbDBrv8AcTQdKN3nfsoQbbALVeBC7KyPvE8UWiiZP	205	293	293	1615991940000
363	3NL5ZzDcDD1vy9wkxpJRgqRd2JT8kqwyVKXJzftUJkWf3AyvcCHC	361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	1455	1332	1	1	359	jxAtqaSDWje9wqPX4hm9i1r5JHssnAJR2fy5SAbxzzL1ByGjk6z	207	295	295	1615992300000
368	3NKVfcGRwB7w2naBGvWhF7sMowVavWP7ZjyDktgF48YvWbjh2vwY	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	641	1210	1	1	364	jxACvnEH5ZhTSaJXFZpwBeEzj56QbAs7726e9yZmwhe63H9hJEf	209	298	298	1615992840000
369	3NLUY4JatL5DEHEoyChLCMsLq4dwrkixFQgwmCV9a7CLLLBBzmsX	367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	1509	1320	1	1	365	jwjcWvPGPLExzZ9zhCnXQZR2VzoErxGhoTmLXjNHN1j8HdLcyM4	210	300	300	1615993200000
372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	371	3NKkxASK4PW5Lh4Xiaz3TuquEn7GRDK2guDiXtE7qpy92WELaN9u	1406	1393	1	1	368	jx9YFEp4DmnKbwvri85fnHGTmjPanhfyRVSrsUrVCc3PShyphhq	212	302	302	1615993560000
378	3NKfBKYgysLTUumXscGUFK51cbj7eeYy38ka1sEVZxwaF23GHdFB	376	3NKTWmW9t4DFkaR5bnpEoqdn2jBxRdWa8SS3CJucEBXHEFU6Teuo	1536	1067	1	1	374	jx6duACWMdrAGhZDz5WTZXTYYtaWSPqgfZHpqK31mNfzCxWPbA9	214	304	304	1615993920000
381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	380	3NLSa2ctSd1MXxJb5pBBZTfQXjvodBQXcXmG7aB5ybciq5kNqroL	1637	816	1	1	377	jwEoPYJ1urKJztm4FkGXfLeT8UtZzcfMY1DJjqZ7rC5AhK5tN2X	217	308	308	1615994640000
384	3NK5hBdcATJ2hZUBkS41LWUAUUj4Fk7koA2h354vFkvP5CnhZQwF	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	149	1283	1	1	380	jx6QjDvWQAjAVr2cWtLWikCzweNJbfGaeUWgL6m4DSkd51WfLUP	218	309	309	1615994820000
385	3NK8iwLoZYmUUdQsseZ3sbLeRW5Dy46mtFuKmPz1DjvWZTLPJmfY	382	3NLUMVTutHHFoeyYR54QjzMJQrr6wi9vxXW5zFhgeVsESSiKg5t9	1529	1070	1	1	381	jx9G6dxzbgmY9RdjgTaKY4cHhKzF5B5B7BMv1JwPkPsqWcM8Pty	219	311	311	1615995180000
388	3NLk3PwP9TNtv5trqYB7mPzKbMG3EghP5mznzG1jKyCijquVHh89	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	1406	1393	1	1	384	jw7GEpETVY97dLi5g4H6MzwXwV7hJ9j3hzdYT2gcv88Vg1jvd55	221	313	313	1615995540000
392	3NKdAwzou2W8DhrtFwPDPJkYz4jDj7KU4Y5NxUsiW15EUevPw91m	390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	532	1303	1	1	388	jwQxKTNKJ5hSfKETdEVEjZTT5PyXUqobiR49ers45gvzyMYkD42	223	315	315	1615995900000
395	3NLEM28fNtqkJ24z4ni85PY88SA1UbHdSaD9Vr2u1GCAvgSfgTBY	393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	1581	778	1	1	391	jxe8N5AjcijGbYjRRK4vVK6yKE45msshrn7EH52TqdUDvJ7iprp	225	317	317	1615996260000
396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1403	824	1	1	392	jwwFxR35ToNc8UBPs589BErH6ASNZM98NLmiLyD8ekGY1swkxua	226	319	319	1615996620000
399	3NLkpT7znSRzMhB1bgtfGD5CGLS7xtxsruRbQJTgS9mmvQ4FDZh4	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1460	1078	1	1	395	jxD6g8pdjNWLv2ZN3LbX9XndLJP6z5uHigxeZhVHzQdWqUfZB7U	227	322	322	1615997160000
400	3NLTFwwxwpbLM1wj2DNvirj4WPergf7sjm1kkUnHGs8SXd8QTns3	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1619	1149	1	1	396	jxUXBhfS618RCepuWvif6XQAbshz7dppKix9V8cNmUSb5vobeyw	227	322	322	1615997160000
401	3NKDeQnVTpehtKHyFEJ8pmSezsBxnzr6Kco8hhMfH9bQaoMoHP1B	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1601	1388	1	1	397	jxgVNLX3BMDV1uyxTamafTHb6U54Pez8BSdn4TpgXnZCkkgfcpp	227	322	322	1615997160000
402	3NLrZ81Ew9JgpkKYhED3BNkeQY388BZKPfviBPqPzr1c6i7Xb6at	401	3NKDeQnVTpehtKHyFEJ8pmSezsBxnzr6Kco8hhMfH9bQaoMoHP1B	1637	815	1	1	398	jxv1ED5kRErfSWKgpDrxdFUC1RPFCqSKqRrLEtQn2ycuVtAfTWy	228	324	324	1615997520000
403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	402	3NLrZ81Ew9JgpkKYhED3BNkeQY388BZKPfviBPqPzr1c6i7Xb6at	1571	1089	1	1	399	jx4JSTe8mDRChdFcoUYQ4XCrRyRmH7ziGgwMASrhUNBusg8ZxZr	229	326	326	1615997880000
404	3NLy2pnWZjy3oLcbZZTYuDAWh6BmpmehfM5ykyvvtgzPTFjQWwHy	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1407	1395	1	1	400	jx2tBBmTk3RLwxw9V5oyFp2QsjXcMonLGAqHFbDWTA97AxJ72uq	230	327	327	1615998060000
405	3NKpodPQHWajSxxqDLugXgyS69Wrn8nrTc2LPBGfZErtyipL44X1	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1406	1393	1	1	401	jxDxhnUoXG14Ti3DAMeiBbm4ja7qqVp7MCwj7yxV3eEc3HigjhP	230	327	327	1615998060000
406	3NKGYJLoksXd76aGsMr1F2TAKYQ9uXopyXM5nxMaiex3edw6EPib	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1585	1120	1	1	402	jxfQuhK2z8rCiU5DjSqMu74eqi7jXE38ZjWVKH8DQq9FVeDKSxn	230	327	327	1615998060000
407	3NKUE2NdwPbwXcHSsaRsTZ1u3PRHTggA1NnMXBVQFdWkJazjssJY	406	3NKGYJLoksXd76aGsMr1F2TAKYQ9uXopyXM5nxMaiex3edw6EPib	1555	1347	1	1	403	jwYXDUnsxkZJq9EQzLgVesbpM2x5vPgfSQMt44MpPAgyDfQxS4B	231	328	328	1615998240000
408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	407	3NKUE2NdwPbwXcHSsaRsTZ1u3PRHTggA1NnMXBVQFdWkJazjssJY	1407	1395	1	1	404	jxTYb6UCrzz2kxJhQRrBcPhXqERqJQC9tJoY7nC1odF6YFaH97p	232	329	329	1615998420000
409	3NL1ocfoyJj94ingD4cQoYo2AgF54mYUeyPzXBAggiZru7W3HawZ	408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	1403	786	1	1	405	jx4g4k4ve2CPAgADsD9s6KtxYZUbtDgu1a2ouVsaMyp22ugevv3	233	330	330	1615998600000
411	3NLt1RN78sAC2FkjsBJx91NE8wcPT53eg17FM22x1frzEXeuvt3D	410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	1406	1393	1	1	407	jwwjN76u6gMb7dCqgdYkKufogNH43PRBA8w8tLzAcbo1A6SbvS1	234	331	331	1615998780000
413	3NKVKNv3SXb3rZb9EYkWggNym2d3ce5tayymRRrnSqivV9xWpUp2	411	3NLt1RN78sAC2FkjsBJx91NE8wcPT53eg17FM22x1frzEXeuvt3D	1546	1093	1	1	409	jwTDae76ubQ3V3zwKXBBbWnwL6GBU4WpnqTq1Kr1MEKVmKprHE9	235	333	333	1615999140000
414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	413	3NKVKNv3SXb3rZb9EYkWggNym2d3ce5tayymRRrnSqivV9xWpUp2	1643	933	1	1	410	jwEAVgHrR1E3u332GWaJhYKncFGDYrncKCcKMSXQQkX8mDjxbcj	236	334	334	1615999320000
415	3NLF2dBmVb4aWCAyVgfMEeHoDeizT6Q5M71iPPd6NaAFcB2sGSSu	414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	1406	1393	1	1	411	jwr1NRksqppKwAQFAuKLQWN7juj6sQjyQUL1ryhee2shLxJA7Yw	237	336	336	1615999680000
416	3NLPxKtgVtcM292DdcBeThfyJdVWq5Q3LzvdgxwFLCF7gm63txgz	414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	1445	1164	1	1	412	jxZcWyymbQeQhTdoEhJ5xbJkHvE9P6RhNxTijC1iFHjyoiQhjmh	237	336	336	1615999680000
419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	1617	1288	1	1	415	jwRbiYwQXpQuWyXYuwLsyCk7jzfEz1icxbyybExCxMTf9UuULvD	239	339	339	1616000220000
420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	1588	1392	1	1	416	jwfSF4HjsyjiVAzAQtDVCKEB8QocEijyHmSEYaKnrNWYMDWy3FY	240	340	340	1616000400000
423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	311	1307	1	1	419	jxtT3gJ9mRn8DsQ7e7EDu3WHcPytKAf8JUm9jZS379NgnzEReeE	241	341	341	1616000580000
424	3NKRiaXJFqj5qtaT8AbT2hB2x7dD4g4T4Phopg9rDyo9ehNRhZzm	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	1600	1372	1	1	420	jxcNuQSmmHg8BJVrhZu1h7wVeegreRHqCmyTX15nc73rHFvbAgT	242	342	342	1616000760000
426	3NK61RUJDwdabaM8ZWR9oqWJFoaEHWgbs4R6CaEhC8zTpQzQeSU6	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	1594	1200	1	1	422	jx3Jri5sVL8WLbq5dCpu7gya97nj1hJrk3bz2TfmNUkoVeAxHVG	242	342	342	1616000760000
427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	424	3NKRiaXJFqj5qtaT8AbT2hB2x7dD4g4T4Phopg9rDyo9ehNRhZzm	1405	1	1	1	423	jxt8PVosyejPScqkkfd1HhhpYEiCX7J5SXQomw8n76CR81ahrYu	243	343	343	1616000940000
429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	1447	1345	1	1	425	jxPfUDB3TTpYbVVEGHzpyXGzhMss5mMDjcVnyrDqCWo11gbMHAY	244	344	344	1616001120000
430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1502	128	1	1	426	jxnhysWTjwhvQXfWhZcDSfYaYGNeweUsLN4zytjechjrinwozqM	245	345	345	1616001300000
431	3NLqbjcGgB5oUZGoduRAGKnrfe8AGZ88EkkpJ4r8HS6BigagzC6n	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1447	1345	1	1	427	jwtfVZJ7ud6TtPqsWvMNAdvihDBpuxKD4WFV3GWeDrkCS4pBLGM	245	345	345	1616001300000
432	3NKh1SSkJwPNSZn8mmCxSt36WZSTVmvR9s3cfQPFDna2MXnGrsHP	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1581	778	1	1	428	jxGACHYPExZq6Ryi2wacCZBZANveeU1dpyjuwhMtL5iLzB3xY2K	245	345	345	1616001300000
433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	1596	1363	1	1	429	jxbjRANgkTCxBXWqhwEKAzH5NFe3v3yctdvFGaHcVyFyDgZToeR	246	346	346	1616001480000
436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	1631	794	1	1	432	jwfDUWg74MAvG2HS7j422hARYxrKySXECeGiUsgLbnbA5TjCkfC	247	347	347	1616001660000
437	3NKgEqivMfJRRYyJ268GPpfjtRRMwMYdATkDBgtcLsgo66xFSQWT	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	684	1352	1	1	433	jwZsjh6v5HizoZav4bqY4tFUBoaq1Je5CQXScrhd98sqbnTezcs	248	348	348	1616001840000
439	3NL72GBdyDCaSjMcMkXeBdSKKYzAJJeGazZrodHWbxGpSLkYKhCh	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	1616	2	1	1	435	jx87zqAuXJbacVhFq1DEPkRWqSrrkgHmpLMdmFsJaHfPAoiTbQw	248	348	348	1616001840000
440	3NL8hiKDSuCBhUnjKdeUrh9wXN15KA8Zo6dpfB8UifDQRj8foKTF	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1588	1392	1	1	436	jwaWxz7pFu6CsPHFDCmBXdJVQwjw22NH68tTJYkGGoNZPLv5vLE	249	350	350	1616002200000
442	3NKRogCaDVQF8Ew6oPoEjbCGEgV2nRhans4Wh3d9iLqeTXXEAV5r	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1457	1391	1	1	438	jxRWiWp2V5FSQqhgakaW4d5G2jW1iYJBNSWsfEtZfCXEA3CY75q	249	350	350	1616002200000
445	3NKZytxEjzmNLcKtawuQ8gCZBya7D9GtcJVgtKdFCJzN5hTiS4K1	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	700	840	1	1	441	jxqtmsRT5GXviagWN2jijUg33rpCiE39hkNZcfyXUHvCFrg2yZ6	249	350	350	1616002200000
446	3NLtkKctMEauqAzgu7YAHKGL1sJFvvReTD4u6icznJDpxrQpZCw5	443	3NKtFJx9Xairvn3iBvGF9U3d5rUKxKGqPpk27CySzQPTJC6ndy8K	1553	776	1	1	442	jwKgWiKhR8g1shV3xqKnfmLPXsFTZETSy8UagRp71XeLn2NdvP9	250	351	351	1616002380000
448	3NLXHhHWreiCvfZKTgLU4CfYhSuywQm31mFak8YxEnCr6KjLubrH	447	3NLjDeVhtn3hPruqxR8oaoBjDJNz8G1WQip1YtjhYbj3BW9ToymX	1516	1168	1	1	444	jxLAs1er3GD7MLPTXmrESdNgxdUHVWsXzN5Qv7ytQykkT2HVfDv	252	353	353	1616002740000
449	3NLFAHqWkRmT81kqzM5pD99mo3HPsji9gCZ9UfTnVEQQh5qnbmAm	448	3NLXHhHWreiCvfZKTgLU4CfYhSuywQm31mFak8YxEnCr6KjLubrH	1403	824	1	1	445	jwZimUopRh6mEXUvLySbrHheXvdP2XWEoZSJJTyJ6HukQTNvi5L	253	354	354	1616002920000
450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	449	3NLFAHqWkRmT81kqzM5pD99mo3HPsji9gCZ9UfTnVEQQh5qnbmAm	1406	1393	1	1	446	jwouRe8fbVhr4Q2wSGUApKVH61AA6TGvfi1UZKRRnbPG2sSkmFU	254	356	356	1616003280000
451	3NLRYHASLKbjKXaBxmq7mnP491fdAi9G4wWvCc8Du3f8dGPSX9Wo	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1406	1393	1	1	447	jxHvot2EEfUZbQdjcpRezrSPssMsC7kp1S1bJJiGAMaHgqHWq5q	255	357	357	1616003460000
453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1508	1021	1	1	449	jwDV1NsL8EMmrHb6B9yNK2cgXekhyuXoNrHCqGP2dU1mAwAxPat	255	357	357	1616003460000
454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	1546	1339	1	1	450	jwSxbGruyANM6aVMheByZJqM88cJj8gc4VzEPb7CmksVJvMNQYW	256	359	359	1616003820000
455	3NKbSx9228q1gGzugzB2TXr5Cayvrq3DsuQvzwALvnrdjPu3uC99	453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	1445	1164	1	1	451	jxy13SRXhCbe5Yw4MzjugkJ6QWhaRWGgP5XUnex4TL74EWzuizk	256	359	359	1616003820000
410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	1506	1373	1	1	406	jx8yWgiJYE2bKfuqB6Uo1ak8TjYCdxR2KRXoPUQTugwt9A8y9Q8	233	330	330	1615998600000
412	3NLMiWQcwjezCdXHhnx9Gj9SYDqtJXveQeu8wketFicwxVGpPYFL	410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	1405	887	1	1	408	jxtMxfDNc9DWAqcia13CmxUP8b3W6fogqDBt7FKYubVLKmUQFQS	234	331	331	1615998780000
417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	416	3NLPxKtgVtcM292DdcBeThfyJdVWq5Q3LzvdgxwFLCF7gm63txgz	1407	1395	1	1	413	jx5RKvJX6MDy611WX6NgGDeELTb89EzZ2MJHE9HTjyMQB1QhbHf	238	338	338	1616000040000
418	3NL4o8nrBGj5EpMYww4McwPh3duiRGFGkwWALHKwGhAbcr21jvk4	417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	1403	824	1	1	414	jxsWB26ntcUVYrwKx4ubLFcL1tLottAnsWme79LeehirRSB8wX4	239	339	339	1616000220000
421	3NLjk3f6a83L2PiYfKa7SjryAeF4P3du7hFpFMCa2YgP8xgWoXcW	419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	1624	1088	1	1	417	jxJ8BhGLTYMKjtMjwTeohZJCUvZahyYgDnQg1PqgqMN3QVKXUoB	240	340	340	1616000400000
422	3NLQ1KisssptAHUi5bhUmxPZtr8tjoQkkHxbKC6YR9jsqbDyu9LJ	420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	632	1136	1	1	418	jwW7XoqhD8wU9BZrguFqsmggzJhbk35bJnEhtiMhRjBVvAS5NZq	241	341	341	1616000580000
425	3NKg1HJ3T2fPczQ5XYi6qt42w9EQiSXyncqgH6XVn6r33jajnsqX	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	369	1312	1	1	421	jxz9cx7vGDZy4BsjQpgfLEgu1HFhsWbJXWWcSuu4NUm6EWcwDLQ	242	342	342	1616000760000
428	3NLakPEDxNz493AVS78VMGFbFGhvXk2YsgTAxPwyNKNgR9ovuMFi	427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	1671	1365	1	1	424	jxVy8TnhDY5f4RtuiUyBF71XsDngiFn9p8znHHAfbNQrtHRsn2i	244	344	344	1616001120000
434	3NLiRQ1fJU7TBbARnkYmZwZpzYrFnUELHxC7KHi8Sb67PGcPrrgE	430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	1581	778	1	1	430	jx7wc2ErDhq2JLsdosUFpzMfjioikifAq6LkXahb5qiXsJg1ejh	246	346	346	1616001480000
435	3NK3qWUiNvyyMMdkdXRzuGuuGjWVpTmdH4XrRxLrw1sYtUtpSyJ2	433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	1613	1103	1	1	431	jxsoihUjyzpiZH5NHYb5soJEyJ1fhjUQiHX7631wesBTEaf6awn	247	347	347	1616001660000
438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	149	1283	1	1	434	jxk9JU4ZY1WvAf44NNnXqXJm3UgvzU6ZKNhgm48yEVUYXyfU74p	248	348	348	1616001840000
441	3NKLSyrTR4CvWuFNGJQCMyLnM7YKu8XJCLBJ17KfzPmYwcYYcwLh	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1406	1393	1	1	437	jxL6r8i67Vcer3oPk2z4UnUGwrRjDypEbmZzG1bGr7hkqNcxmQ5	249	350	350	1616002200000
443	3NKtFJx9Xairvn3iBvGF9U3d5rUKxKGqPpk27CySzQPTJC6ndy8K	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1428	472	1	1	439	jxQ7BYBbfivuco44LHfYS9DsKT7P4b3jiSJg3ckxnEiLqEpR4Mz	249	350	350	1616002200000
444	3NKNLPp7FSCEM8pWJ9G3is2YQ1wVBaQHQdWQ3WYp63kxwDSkMVNG	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1579	1263	1	1	440	jwhQeugkCDBgyTunBjQ43Qm2twX5wjfLfHdfFfJ8PwGdSCRAeUy	249	350	350	1616002200000
447	3NLjDeVhtn3hPruqxR8oaoBjDJNz8G1WQip1YtjhYbj3BW9ToymX	446	3NLtkKctMEauqAzgu7YAHKGL1sJFvvReTD4u6icznJDpxrQpZCw5	1458	1323	1	1	443	jxjNAJtsDZVoWeCunfZWgFJSFmh5fzu9B5dyrVd7i5gwEohPH3j	251	352	352	1616002560000
452	3NKgf9aBUwDThvHFkKVfH7HmTjiTFAy1XVbgwyqx9cL4LgBV7w77	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1440	1377	1	1	448	jwPm5zU1NrL8vdHZw8bP3kqWHZpyVPVnd1WvM6dNQePcPyH4abv	255	357	357	1616003460000
456	3NKoM1VxH5yuL5R9Aw1QT9VFwouFWS4ZFKvYokoy4nneYWC2MysG	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1407	1395	1	1	452	jwwKfrpMtQFgFBdYqD4pg5cTm8iFwAdGt1z9E2HPmQDZZ2VZdJY	257	360	360	1616004000000
459	3NL6hTZv56Z3teHq64D8QMrnWm9Ba4RJaVjefAA1xwknvqqdy19Y	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1651	1055	1	1	454	jxpGvqH5Uhiuov6oT9awad2hefFtsd4pBnYTf561Mwhnip214U3	257	360	360	1616004000000
460	3NKAeNaky9h4XanuyQXy9qe46uT4f8VZ4iETxK46sk5kQ8HrHjDh	457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	1456	244	1	1	455	jxkYMvMP7NnBRTb2P8jUDoSCvFbnECYkUnz2iE2s1T9nY5DM5zR	258	361	361	1616004180000
463	3NL3hSUiDjfYzQ3tpdecGBMTgQ85fAbqnPB8uten3AHdgKzobaLN	462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	1440	1377	1	1	458	jxMdbABm8YHJ7aasJZr4UXdkBPzotdMT8hUK3SZdYPUteDY4QQe	260	363	363	1616004540000
468	3NKdQNMriDvCUr9kAMBrqdM8EiFTReKcYn29eFedudRhmGJRnRav	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1534	638	1	1	463	jwF8BcrhM9jMNvw7yqZZwHxJV4g2uxkwV182bVyk999UW1bsFhy	262	365	365	1616004900000
471	3NLheZJyNoyxZYaKc8GGGaB4YdyfS9LZe2tzJDnMpf1sjGkB6jp3	469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	1656	1343	1	1	466	jxZGQV6pLEVLmCzLkxThDcwnhYpDMVTr7ZCDvB9rQfG2q4ahQme	264	370	370	1616005800000
474	3NLjyHQKWiVBTvAkhqZEak3ipUmPcvCHrzk7MFPVPeNgZrbqaTJD	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1406	1393	1	1	469	jx5WaGzSJxSdX8GTP6TCSK2Mk2aZzgNUTbckEx6URh2chnqNnQW	265	373	373	1616006340000
475	3NKneazcQZKKzAHMF2kHFiqogsLgmqY8RVTWaa8cKzauP4pJaxwZ	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1483	894	1	1	470	jwnGbSJhqzZMU8wwnG1iZpSMMzycvNZVeeVjx6c1Bs9kMXtsdim	265	373	373	1616006340000
478	3NLVNtVvdgqZ5JDjp361ZsJA37zSTS8FACboTfT7ms8RYTSBnVb2	477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	1670	1282	1	1	473	jxBXdyGDRVdzDLEmzFbFKR993yskxyxFs3DWNLdsrg4n3DPZ6km	267	375	375	1616006700000
483	3NKBv5HL64TyUgAk8N8cc2WX2JSDEWbxr2XrBBpT23TuvA1s1XmV	481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	1483	108	1	1	478	jxEzHiWe2BVXEfto4afnoZgS4faz4CUVMG8KmpanM4xombPnFRJ	270	378	378	1616007240000
486	3NKsPREqT97JQEvsFKNSvBL2LwXsTTHLLMggGW27bis6ZRbud1Tc	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1651	1055	1	1	481	jxENebVkwWzmDKLb6LVbjdSnM19jNWUc1XVGQCjLSbbJ7Wk4uA9	271	379	379	1616007420000
457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1599	1287	1	1	453	jwe5fb4CwW38KXkFDEY9wWNcFmTNYaQ3UrCP2Hfu9bUJEBSQ4mM	257	360	360	1616004000000
462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	460	3NKAeNaky9h4XanuyQXy9qe46uT4f8VZ4iETxK46sk5kQ8HrHjDh	1407	1395	1	1	457	jxX1usu2wBWfaWFLtQ6DqYKzRT2ps8jmCpMBybTWecd4mVjwUMx	259	362	362	1616004360000
464	3NKuqJ13aUcmTsAJBdmuA5XsXTmybgyJptaTcb35Ec74UttkWcZN	462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	1490	1274	1	1	459	jwVTfjLCr84v5GPPfFG72sWzxo2r9BHoGes9t4bPeivMqe2KX2F	260	363	363	1616004540000
465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	464	3NKuqJ13aUcmTsAJBdmuA5XsXTmybgyJptaTcb35Ec74UttkWcZN	1426	1238	1	1	460	jxMThTfi23qnykGVTUDj3iq76sET24XLi6aovR9gwnhw2goBNi2	261	364	364	1616004720000
466	3NKwxwe8PZ7NLjbQVcY2Jy3JwhYfcoTMcdYgsowsEaHgVKng8Asj	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1588	1392	1	1	461	jwQXwcLJz6gnY1VQEroMTm5Gm65Hj2ns1QBxYRzYuWe7M6JCirN	262	365	365	1616004900000
469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	43	1064	1	1	464	jxPEa9ZpSgfB6n4PGUBBhQpmt7vp6oRojoDTrVBYuXYuXvsjvDa	263	369	369	1616005620000
473	3NLqAfVw3VVCnbCeYjcBiF8WhQVbLjsF6psWs4BvZci4dVL8V9Kw	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1407	1395	1	1	468	jw9XKkxBZ1cW1qJaneF1RNkjS2oN4yQcnLJQ5A9cSwQ3RHeQXHJ	265	373	373	1616006340000
476	3NKYEgqzncuvDGTp3wcKVq9Wpcq5CPYcHzr2okzeDFibd2WZM6eW	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1637	816	1	1	471	jwAed73gkbo8mMD62ywoeXLYgUNa8YXARAmDFkUiV9SHxVzWpqT	265	373	373	1616006340000
479	3NL1hYLpDSJZbQ2xZGiZXsTo9cCPtqbxcaS2TsXu4EnmtiMMGFnF	477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	1609	1087	1	1	474	jxoYcMusPBtLC1VBmyDWNfSGhGY42FaHSBSGnuSfbo3h54MQG1L	267	375	375	1616006700000
482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	1503	1277	1	1	477	jxfqwfyZtw2LiDVGmSEH6ctpCGegepz2vtLqd95XFn6SbYjudbt	270	378	378	1616007240000
485	3NKhAVEDtrv1gZS8ZSSrCe2bpSyr6P54R7fLpqZ5hUSJAXx2cpYt	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1506	1373	1	1	480	jwAX6Yh5J6NB76RnMReMxaoMWygTzrAnScU3pTFkp3eXKbYVFx3	271	379	379	1616007420000
488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1590	1054	1	1	482	jxho1cmFWcS3ZLfjAe2Xh4AWyb3fzBzPbc815ZfpRZ4pP4fsWhC	271	379	379	1616007420000
458	3NL6pot4eGLtvBQEweZtbmMnpoJH4oth2RR5UZSmNrqqRN5skGES	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1651	1055	1	1	454	jxt4iG63t7SCsmZwp6e2F9ZCTTuGqufcm97hiXjmHdSSnYGZJTM	257	360	360	1616004000000
461	3NLyEPh9ZrEyTK88kzSNtUk4hPYLjw6n5veDTv6zDQKK72bFeyVM	457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	1623	830	1	1	456	jwn6k8AbKZgL1wDUJXRyyzBoZkuxfeR6nHUr8LKpWEizR6xbCwx	258	361	361	1616004180000
467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1405	905	1	1	462	jxc1F1N3BHnfkxiLDEDCigSb3ZL4Pxyj9td9R44RF8GXoAnQcJX	262	365	365	1616004900000
470	3NL2eErjBhjUPzKfoTTUDJx1cMPMXb5anSRHSZHTzf4RzheAo7VG	467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	1613	1103	1	1	465	jx8dWTugD348jiqS33TfbZ8oRozvbduUvwMU4teA5gAgfmYGLj5	263	369	369	1616005620000
472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	1407	1395	1	1	467	jwpFLyvC6anhuvwB5dTLJu93XpsEZCcihSt9YxRW6XWpuexVrfQ	264	370	370	1616005800000
477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	475	3NKneazcQZKKzAHMF2kHFiqogsLgmqY8RVTWaa8cKzauP4pJaxwZ	1631	794	1	1	472	jwLGE5REZmVwz7WeFAXSsQTTUQFLeiqGKaJpdPkUnXbwoKLGHfb	266	374	374	1616006520000
480	3NLnqr1cQFwJSgtZycKiutfWEp2WDwYmYWCR2Zg2xKid34wPNG71	478	3NLVNtVvdgqZ5JDjp361ZsJA37zSTS8FACboTfT7ms8RYTSBnVb2	1474	1329	1	1	475	jxEejDHnhQSJAu4rk32U6exhY6ujTaNA7UkTDc2JapXyhvbhpRs	268	376	376	1616006880000
481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	480	3NLnqr1cQFwJSgtZycKiutfWEp2WDwYmYWCR2Zg2xKid34wPNG71	1634	1331	1	1	476	jwm8b61UY9EVoBRRcjEcaBwTFmvySHtLzRUCcu77pSQsJaVzNmm	269	377	377	1616007060000
484	3NK8AqzYCPKg89PteBjG3Niv8S8Fi9yZhqgvzP34KrE23uggiqyc	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1406	1393	1	1	479	jxKrSpm3hcr8bgdUWAmjZ4pYULS8YJKWMNeZyhLtU9wEEVU6SqD	271	379	379	1616007420000
487	3NLyYL78WHUpTPKPK64RsRbgmu63ven1eGPNeQe85Uf8SQrg4FD3	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1651	1055	1	1	481	jwrqm1SYxoMi6V9RThCsWcYQgUUNQQjT3TeXwrQGEUzj9Qqs154	271	379	379	1616007420000
489	3NKaj125SVrZ9XzFb3EseE86kbvzLiErfTAnBiexfCxqpVsNzva4	488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	1403	824	1	1	483	jw8BPu13P8jEvnS4QCZZHjh6i1D54Fs2usK3kd8eFBmU6NyCgVa	272	382	382	1616007960000
490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	1536	1313	1	1	484	jxG3zrUKPSxNSP5sxtW5tneHwzeYCoRLD18oBF4wcaGdfLL7SUd	272	382	382	1616007960000
491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	633	1018	1	1	485	jwEgXfBdv1pLRe3kcYCs8kxFJWEc6jTTNfCpthUyq2mRzKJDdR3	273	383	383	1616008140000
492	3NL1R4et5p4BeHYSYFumuHJZHfnECkYd7NdwaMwzMzgiNVFnuSXy	490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	576	1355	1	1	486	jxKsvrMt2knm7Ky6gsh4RZhory3osbHDi8mUh9ATVPsnNUr4rHE	273	383	383	1616008140000
493	3NLpdoGupgNLDPUoDpd4RGNpJgSUMWy14F8pbtmFmZhnMWS5gJex	491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	1571	969	1	1	487	jxAyqZ1CRkh9GMRjEZCCAtKCs6mvWk954MSCDfTopUSZXUZvgVa	274	384	384	1616008320000
494	3NKi7Vq6VyZWS4yvrmBku1vevnzH4hWfwVGnB22yCdz7Y1bG8So3	491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	1406	1393	1	1	488	jwd3EEeP8LwbSgTZbSkQ59oBZE9Zviy4fCxei7m2apvz9UVf4sn	274	384	384	1616008320000
495	3NLcRJXE7zEfsYpxENDcAr23kmYWZTm4qKCeSmfd5FSnU9PWsBDH	493	3NLpdoGupgNLDPUoDpd4RGNpJgSUMWy14F8pbtmFmZhnMWS5gJex	1617	1288	1	1	489	jwn2zCK1XohsycKHkBnjcAfKjQrXLpSJg5Tr26XUGT65Y5N2CBT	275	387	387	1616008860000
496	3NLiDUAr9FR4NyE15mLVdoxx7sFdrjoM8h5GE1VnF8pUvKZrhcVh	495	3NLcRJXE7zEfsYpxENDcAr23kmYWZTm4qKCeSmfd5FSnU9PWsBDH	1647	1302	1	1	490	jxHdcTVzoPqYbKzSwJgnxWLEcA33fvZoJxzYBxmwAiSaZ1CApc6	276	388	388	1616009040000
497	3NLtz2f6CuF5H2ptcqtihjYPxHxxF8ACBjdnUidiMvk7H78Uqo3Y	496	3NLiDUAr9FR4NyE15mLVdoxx7sFdrjoM8h5GE1VnF8pUvKZrhcVh	1444	1381	1	1	491	jxcVYVaFxuWGTthSKaYuXKMGpZXvUqxaNu4NTs2HgLWo7qT1N4y	277	390	390	1616009400000
498	3NK63uN5Q95WhbS1jdWgJBdeWM3ftyxBBRjS3n4z3aU6yJ4HLB1a	497	3NLtz2f6CuF5H2ptcqtihjYPxHxxF8ACBjdnUidiMvk7H78Uqo3Y	1656	977	1	1	492	jxRYX32zKV8Z5NwKk6tDt8dRjkUyG8R9UH26cQE5yQkm2r6dCtZ	278	391	391	1616009580000
499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	498	3NK63uN5Q95WhbS1jdWgJBdeWM3ftyxBBRjS3n4z3aU6yJ4HLB1a	700	832	1	1	493	jwFdhRP6DzucHpbVKhMJKT52fRN35hs54Jqi4BHP4EKy1MY7Mqn	279	392	392	1616009760000
500	3NKS4591rFCTxcapowbMcRTX6KA4eC9WvP2V27vgDndndW4LpwGu	499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	1527	1167	1	1	494	jwXjxSCWrkpsAJ51D6gi1czge1q6uezhpFURFBdNSfaEtyeqqzd	280	393	393	1616009940000
501	3NLn6GUP654hLLbXe2QhVkGLxJHyhKXuNtvy48hC2mK5h2T2PaQ4	499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	1672	1039	1	1	495	jxdk8yQiR1Nwb451h3fwaTrRLF8bhB7SVQ9EdRJwhSbixQxoQ92	280	393	393	1616009940000
502	3NKbLivvz5EN8YyCQHoKF1hQCSctofNcK5JUsy1MeBa8fNc6PtJw	501	3NLn6GUP654hLLbXe2QhVkGLxJHyhKXuNtvy48hC2mK5h2T2PaQ4	1482	226	1	1	496	jwdJiR9UvxNnk3sYwc6FWQwrwJG1LPpRQ42SaEBkQ1g9KBBfraA	281	395	395	1616010300000
503	3NLMciB9XuoEUo5QxnoN4znXbuFfXxsR64uDSPc1sJKkP28EeMsi	502	3NKbLivvz5EN8YyCQHoKF1hQCSctofNcK5JUsy1MeBa8fNc6PtJw	1403	824	1	1	497	jwNxMDTEiKx398JpmFsx2dLr6Yg6eJuKMzDD3q5GBQSEsi8VcPw	282	396	396	1616010480000
504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	503	3NLMciB9XuoEUo5QxnoN4znXbuFfXxsR64uDSPc1sJKkP28EeMsi	1461	1271	1	1	498	jwAVsgwHaPFpiCXSVJdiEEtEmmMCT91mfiL5fQkN1ehVyX9CNEJ	283	397	397	1616010660000
505	3NKGpTxox935efB7sPUDU3jL8fwxt1QMD6RV1Z5nHwqd1pbfmWoA	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1460	1198	1	1	499	jx2gxcC5NMXsAvgm5Cmrz2TbiQy5rpPsa2eYvCBMF7SndPtkZbB	284	400	400	1616011200000
506	3NKykhATq9Vy3YSeSbop8BJncDG1ehzijCxcHdHVpmuUjn425x2x	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1623	839	1	1	500	jxE9oAZ6MZvyNfqZGB5oT6AWhmyVpaLobPVgREGfnsShoVYWgx9	284	400	400	1616011200000
507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1581	778	1	1	501	jxiNLFkg4QL7bjZJQyKA6iMByQ6cG42j76t937koCyf9j7Dd5wR	284	400	400	1616011200000
508	3NKELvoHSPjJ3NpNvhbMzCQwsMs1YHkv8a8zJiFapFZF57k9LSeA	507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	1458	1077	1	1	502	jxZEoa9GZW4qvEpGKjzPFiy9v2AXDFB2A1rq2j9dJ29GtbLfLEF	285	401	401	1616011380000
509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	563	1113	1	1	503	jxyi9GYw2kv3RkE16h581vDsfN5pDQwmCfX6n3YxJDRTHpt3NcC	285	401	401	1616011380000
510	3NLK2nmLyvnjkQ4u6EC9WxRNWZKF6eBW4QQEDvCoP4dRMufyZMjp	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1405	849	1	1	504	jx9otETpDgbpKkxH8itxZkHLyPtrFbRMNfP8FgDRo2hDrqr95Wx	286	402	402	1616011560000
511	3NLRui1UYsMseTJzr8ZdYUsGuLJNtbqV7occfaHzQ7XYoQ7BuKJ7	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1517	197	1	1	505	jwVLzPTdsbuyyFC9TDTRa2XmqL4r4exniiy4DTgNLJDCNHNVrDZ	286	402	402	1616011560000
514	3NLWPavoWPgLg3EPB4Ja2V62V3wNtGUStVYSWqEC7mmhsRMp9gFx	513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	1460	1324	1	1	507	jxMivgEmxoi6fwqme2wWGVrgwC6qe6jHfkWw2JBGuUhagPE7t3c	288	407	407	1616012460000
517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	516	3NK8vC11n2vWYBrztr5S8KPFvP6DQ4s9rDECKYifZJNAdfg39bAa	687	687	1	1	510	jwxPaiGio8X76AbqfPHfz3EMmkuEA76q37MBV8en7WXQRrVkibF	290	410	410	1616013000000
520	3NKWbkL7bDA8mnEyTHnsHjS269AJHkYh4XZ36Ab9EMeSAZiDwQpw	519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	1403	824	1	1	513	jwbdddkr5g5LtZihqXfwfcQFJ1jRbYiFwQy5ty6ok9HqzUyDNuh	292	415	415	1616013900000
525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	524	3NL7d9qrbtUK9veMiM83onqvXh7KhZepqhfHTY38vv5J7N5Yc62c	1407	1395	1	1	518	jxmBpzJCnkB5HrPSrgKSxyx4YQjaA5M8fpMTsWTELaEAgBJePBN	296	422	422	1616015160000
526	3NLTaDbarbN7dgm9APz7Bq1FfrJf9HTZQED1V2jx5E72t5XVyXAq	525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	1403	824	1	1	519	jxeCZAZ1j8ZPhVnuLUdZLYRFWf4659wHBM8L6nWyYfa35eRi38J	297	423	423	1616015340000
531	3NK5YnUDoAzXJr5ZuimsYb2g4AeugEVjfGA6dZqnvQHcptWzJ26N	530	3NLyNBekM9J9Ghfc6jpzXgy3sFp4tumguVV4csXHBqsfA5HqGd18	1631	794	1	1	524	jxDFTndQj7y4dnrNs3D9RTmz4zxehnHDU4yBGLqZPktakB2pfKr	301	427	427	1616016060000
534	3NLL2DqWf4AYfaLqyQBSAHJurhrM2L3BCaxckMduUVNECDfSmWiv	532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	1458	1323	1	1	527	jxzn9x1dUWssqXmeXqo5wYh4GkMcHdsD5qL77VGxnUKccfPwnUG	303	429	429	1616016420000
537	3NL5qBpY57zQnYgyK1TL4kWsiG7EFhLuqjmT7CZtQtxhPCw3GGue	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1406	1393	1	1	530	jx4EEpw5XyZffTD95mMaaHfsku2K4d5E4gqh7wNurLB6fDiZibA	305	431	431	1616016780000
540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	537	3NL5qBpY57zQnYgyK1TL4kWsiG7EFhLuqjmT7CZtQtxhPCw3GGue	1609	1333	1	1	533	jx2qHzYpymrETxsLBJie1fv1pCF4zcjXvBSk8WunfjAdk4AVXhd	306	432	432	1616016960000
543	3NKLQu98TFYw7D7KXaAG91Rz4yEPJq16EEFStrrA4k5hmuJnwH7q	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1457	1391	1	1	536	jxJsHdszc1jNBDcUFbYEWhMwSM9Gv3AgNGADc4eMEdCVG7225tr	307	433	433	1616017140000
546	3NL1RXdg4r37MmbYca9qLCZyoRCNiqfSoMzCFJ11S56L9e6eDPT2	545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	1648	1038	1	1	539	jwoG5jc5okXd8hhKgzYb7CkhmmG849CvVFpUZhawjVG6Ph8JpvM	309	437	437	1616017860000
550	3NLNGqDy93b9ikqNb7SAfz7aPq2NtfnLjaC1uVNrak8GEjVTyyPA	548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	1646	1354	1	1	543	jxF7mzsgGghfX1ph1NoHH1sxihPVDTQ1wHdGqNuhUKzo77nmGCg	311	439	439	1616018220000
553	3NLEy6mCYg1DS5Eg9gMKL3n1wBQM17JLXMJeN7fKbMj5t34n7Fvo	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	152	1084	1	1	546	jwkyMhmRcEwh3cyjTq1awcGeDNPqjhmF2aTmWE4Q4uyi8kso86d	313	441	441	1616018580000
556	3NLs5fiUVxttbxgLHjaZti9AdXYB5TeWoW3t5piVDE9hf3RLLstK	552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	1476	1371	1	1	549	jxJLFA94DNPhkJzWRKkvHRWbpsdRqrSkMdsf3CDJ3gF4SMUSQPE	314	442	442	1616018760000
559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	558	3NKTaN9cmsb8KQVNtJyW8nAXJGPgGZVWH4WhNgEfpyX2q5R5KBEZ	1403	811	1	1	552	jxdWswU9epZk4rTQEFxAvM6PX2jF1VfGYqNtbvmcNPmdekWRh4U	316	444	444	1616019120000
565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	484	1319	1	1	558	jxD3XRqNtDUjeDwiLgE1npUFyfcw47AVLRdLCFfVhvBuEdBUdmZ	319	448	448	1616019840000
568	3NLgBLZKt5j1AWBHLQLS4KfRctqMm9PT9xuNoTz9xTARRymiqJbf	566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	1403	824	1	1	561	jxGgKAhkLh1ipWn1P82jGGXQZ7H9RMiGs4WCoJ17BNVw8fWyJGp	321	450	450	1616020200000
571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	570	3NLAStcBA6mgqfTKyP1V1UfhiJdJ9n8zZHWFCcXHCBfH6UN7evJA	1451	1046	1	1	564	jwbLyH6vmyNijKmBqFkfeVwMh2EXdb3YhxtaiNq3th4p3DC5QMx	323	452	452	1616020560000
574	3NKmU2r7wDMmwTSDH6C3NMQEZhbF8nhc7T1DKvSaCYYgfGeoqEdX	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1617	1042	1	1	567	jxaa6fuNJ9wReggUxvxca8t3KzpCeSnRDTitjjZkQiqu4EjzMmG	324	453	453	1616020740000
577	3NKawRzPLjzyK391HvfFAKLTsH1RsCJXtc5CoKsyrfq2CRCJzEnd	573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	149	1037	1	1	570	jxHZbvZuZzLL7Vf1Cax7Ho7adCSuPfcq2jHyS1TEKfu4DLAkg37	325	456	456	1616021280000
580	3NKyGsgzCHWWHnQs1ttV8MdiMVuhHJMuyYP7u4SDHBhJQeUqYjNu	578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	1501	1234	1	1	573	jxg65jxp9gswCj83LUW1JGCXy6c8XADZhPJ77ko1s7ABFghV3BT	327	459	459	1616021820000
583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1457	401	1	1	576	jwfWisov6V72R18AD5icttL1kbJTD5PecBYzvAHeXtEKuJ15Jta	330	462	462	1616022360000
585	3NLSCszv8xddJSaVLtaAQf6r8Enekt3DYC7WMagTgML9m6XZgNKm	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1643	1053	1	1	578	jxYTRUYqsqmstQ8XiMFfmo5yAHEHCjR5eR3pqju9gWNAvmmnrk8	330	462	462	1616022360000
512	3NLAHBUTDYQHpohyCiRf44N7gMhMp5jkbzvRXtE9RMDt5mWs8cqX	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1517	197	1	1	505	jxDbGQ1niFgXZyebSYUBYwdJyD4AUA6epL4X8F4Q3QCU7qzkc3L	286	402	402	1616011560000
515	3NKTPvUGkbswczqo9hJNkmiUtLDqzdaHD8fgzYHrunzmVMpQDZup	513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	1483	1030	1	1	508	jxSFWd49zSwwhKpgvtaSSt6VF9TcmugTTsvHgrPyyinHPngSr5L	288	407	407	1616012460000
518	3NLUmbA2WYSJToMCwBFaAokkpjAq5o5bDQGfLiwbUnbxuMnLud6X	517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	1460	1078	1	1	511	jwRDbnjrJTYv48t8VdmeDZVGCVKpwe4pABy7btbDKoxoVFfVxcH	291	412	412	1616013360000
521	3NLVGwAyVhdxnd56TwfYqqfkZpufEHwghyEEEcwJ1fQnfUr5FJTD	519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	576	1109	1	1	514	jx7t91eEoFmdPoDCzorCVNAs6H5U3C6x8PeRLVYB5xLXy9f1gHp	292	415	415	1616013900000
524	3NL7d9qrbtUK9veMiM83onqvXh7KhZepqhfHTY38vv5J7N5Yc62c	523	3NLa2BY6XBKhtNBGt9toFubHmaDA1c6bumo7xtTBJWzCgPiAZLFj	1406	1393	1	1	517	jxQZsiD2stGxoxxfbh21wE9zLLCVmz6hubsWCF3ynK6h29mHLKA	295	421	421	1616014980000
528	3NLqyguzus94qW6iC2TUZzzB2hqoZw7sqQhWLKvHHNwmHfhcBuuQ	527	3NKJqaYgfYiTVb2RXiKLkzPQzbruWNShRHw9szgES1uPySpMC1ZY	1642	280	1	1	521	jxRt8ZcGTXBR2vaXzLt85xy5qutNmdHUTrWrGAEn4UX2U4YV6Di	298	424	424	1616015520000
529	3NLfk4TrZEDFU7ekD4uxDEBY3fG7qp3M8nfufvRrdmpYZjLvyiF4	528	3NLqyguzus94qW6iC2TUZzzB2hqoZw7sqQhWLKvHHNwmHfhcBuuQ	1500	1297	1	1	522	jx9TDT44BCumPj2n8NpacxaZUhZzsEnLLdo2VkzAdgA1vM7P51z	299	425	425	1616015700000
532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	531	3NK5YnUDoAzXJr5ZuimsYb2g4AeugEVjfGA6dZqnvQHcptWzJ26N	1402	807	1	1	525	jwEe8VbhTzpW2X4L89ik4H69L1iWaSXDni6mfubCJupsuSwxEAz	302	428	428	1616016240000
535	3NL4V4HRon1pnDc3r7uGAynyMwSS33Z4D9dA32UPPoiGvhLJaGyq	533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	1657	1218	1	1	528	jwDMuEs79eNtJUx7SQXE669zi4fKVj8JYwjHP4Gfc3mhZ7YETp8	304	430	430	1616016600000
538	3NKvDYqMnmpR9kgsUTnyvbanh33khJkJvwhSDxwud3ELQA3cWX9r	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1508	1387	1	1	531	jwKpk7vUBmewpsXtXPrFjZcCTKiDTueXKpvUVFmTi3kPJ9ALnaE	305	431	431	1616016780000
541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1406	1393	1	1	534	jwGm41Gk1oQEfPS31da8oiWWi1X5a2GBM5euNtxfkWwBAhGGaYm	307	433	433	1616017140000
544	3NKnys9eTgvaKvnZfCt1SRJprh1YAjoidjtY9ByubfsRs7XhVe7T	541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	80	1027	1	1	537	jx6fNCzntQ37PCiFyQnaRqeMzAh7JLFt11JEVeCNFv4VHeR1aFk	308	434	434	1616017320000
551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	550	3NLNGqDy93b9ikqNb7SAfz7aPq2NtfnLjaC1uVNrak8GEjVTyyPA	633	1258	1	1	544	jxyZ5kTrxkmZgtseQMdKPka6SA82uZqGpVB53hhCK6r2ARFebLc	312	440	440	1616018400000
557	3NKotxAdCPAKAG2gQYb4QLboWCMjTkjFH8nkCLcBMkn7MiJcHfrK	552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	42	1361	1	1	550	jxivBbUtn5r8NjUg2uECTMwkS6cBzK4Bry2UVNiuhiQavucarJK	314	442	442	1616018760000
560	3NKkADv6LNAeuJNHtkcLsWBMFXZNN1qMKaXQfCwi15Bmr9Cs9QDw	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	1403	824	1	1	553	jwjwdvvGiqC5ngz5XBis2NuxcJFMkMctviRbmtPMzvnckfmTBn2	317	446	446	1616019480000
562	3NKh3VUUt7yhGxhPE6hagzFVifRj1a6oZXZyzrfk1B8Mmp6qPqSi	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	470	1309	1	1	555	jwpcFstDm7KNCAyWukDEPvXA13waMYjAGMFsZshCNHv4Vzm1zd9	317	446	446	1616019480000
563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	560	3NKkADv6LNAeuJNHtkcLsWBMFXZNN1qMKaXQfCwi15Bmr9Cs9QDw	1607	1222	1	1	556	jx5mKn5PxaE4HtsVbhGtrMM2JBiQZXQTV2FSHXgZeVtzncJBUjs	318	447	447	1616019660000
566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	1406	1393	1	1	559	jxnFa8gzPi9kynk6kFQ6wQjuXr4RdbPzu1oJcSiEgv752HTJc3X	320	449	449	1616020020000
569	3NLdH55p95q2GviiTVLVEzdz6bkrXWAy44etMzT8TLWTrwRfsa5C	566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	606	1295	1	1	562	jx15i9cFkFp1HjtgchDgznMVkNfzjPtRC2giZMsee4G63jJwQXm	321	450	450	1616020200000
572	3NKJvdnkY43kbCVpRHg7kiZ1F9kMfjcoBqhY3H8SwnWjzJ1kmUkA	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1406	1393	1	1	565	jwvatWDiBHYBVSCmhwB6ctmH7sRyrWoatFcWoY55FKQjaotwUf7	324	453	453	1616020740000
575	3NLwDQ7voAd6NsHVe6jYoYvHDNoR64kkc6J9V9XuSrXuGSAMn8mC	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1637	815	1	1	568	jwBSy11u1LRL5bdmXcrPjaYFjZw9hKTFND1663VVgdH77fPD2rw	324	453	453	1616020740000
578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	577	3NKawRzPLjzyK391HvfFAKLTsH1RsCJXtc5CoKsyrfq2CRCJzEnd	1402	852	1	1	571	jwvp1mL1tResMWtgdu5tyDic1dHHk4fpskevBSrd7NggTmCmWnn	326	457	457	1616021460000
581	3NKBioP9qbXeoixxcPdUoKaPEPRVLBzEy4YXGM3jA7tJRcLg8FFR	579	3NK7W5va9JDQGRX1wLZtXh1xEEBpdur5zSxw1LtX6VcSNRdrK4TE	1649	1383	1	1	574	jxF9FTX1VoZXq6BuZfKh45sEfDPHBA4ZEVSkkKVhyBA9mRAtd9L	328	460	460	1616022000000
582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	581	3NKBioP9qbXeoixxcPdUoKaPEPRVLBzEy4YXGM3jA7tJRcLg8FFR	470	470	1	1	575	jwRvGoXaTmckGZ1LN2pU7xK4URuztdTesLwgwxve9a9sCWMp49j	329	461	461	1616022180000
586	3NKtDwm1BrLNbVNtu9fH4ED4WREdsj1RUSqgrMJDbiocn8rrJs8Q	583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	684	1352	1	1	579	jwAbQpEe1LpAMwBt5rK7JUKbCemWeRiJ6hQvEqNdURdKmcwKGTq	331	463	463	1616022540000
513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	512	3NLAHBUTDYQHpohyCiRf44N7gMhMp5jkbzvRXtE9RMDt5mWs8cqX	1637	816	1	1	506	jw7PwiSfQamSqbmPQNuCBfhCscfGdoeyNH9bVkadyb7UULjsLoJ	287	406	406	1616012280000
516	3NK8vC11n2vWYBrztr5S8KPFvP6DQ4s9rDECKYifZJNAdfg39bAa	514	3NLWPavoWPgLg3EPB4Ja2V62V3wNtGUStVYSWqEC7mmhsRMp9gFx	1460	1078	1	1	509	jxZRLUk9BscdxSpCTVUBabwqMGkDnXhs3w8rjPgV5axkT5Jouix	289	409	409	1616012820000
519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	1440	1011	1	1	512	jwCrJp4rkFv8DnHY2QxSHNWHryXQa8EstjtdkrjftoCWPUgUFcC	291	412	412	1616013360000
522	3NKj1D2zRTcobUMuUAkAbDTZTwSK3twroWGfzQiGDhNoaZdffRCc	520	3NKWbkL7bDA8mnEyTHnsHjS269AJHkYh4XZ36Ab9EMeSAZiDwQpw	1419	814	1	1	515	jxFfcApN5Q1kSsosExx2kiLQ5mj2d5rshqSm7rBKbMrsRmuigHD	293	417	417	1616014260000
523	3NLa2BY6XBKhtNBGt9toFubHmaDA1c6bumo7xtTBJWzCgPiAZLFj	522	3NKj1D2zRTcobUMuUAkAbDTZTwSK3twroWGfzQiGDhNoaZdffRCc	1610	1188	1	1	516	jwQsz5kh1Y6DDsLMNELa3kAXXUJ9qSCo1Ddt8kNPERS6nj3jKZh	294	420	420	1616014800000
527	3NKJqaYgfYiTVb2RXiKLkzPQzbruWNShRHw9szgES1uPySpMC1ZY	525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	1637	816	1	1	520	jwr7nk48fWAtYqjPvkgj5QtDTmRUwPZsAfeLSuXCV6eWHPMNF42	297	423	423	1616015340000
530	3NLyNBekM9J9Ghfc6jpzXgy3sFp4tumguVV4csXHBqsfA5HqGd18	529	3NLfk4TrZEDFU7ekD4uxDEBY3fG7qp3M8nfufvRrdmpYZjLvyiF4	1401	71	1	1	523	jwoQDMYpP8C4bxfvaqyMj3jitcaRCR3qntoXRh4xcrXL5bjDiT4	300	426	426	1616015880000
533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	1407	1395	1	1	526	jwHWK4eiRfXYa6enbyTLBEWjj3KzEqZvHEsgRmyeku5bH1jVE3Q	303	429	429	1616016420000
536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	1637	815	1	1	529	jwVPd6VGsz54gvPNNcJUMVVhRN2C6jmYURDAknTGeT1DqK79Epg	304	430	430	1616016600000
539	3NKG61kXj3iVjVWinKj6jVHMmkTTWiUqjvKkT3qvFVVc2xszwLVL	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1573	1192	1	1	532	jwTUeoz4WmXkC7eLbdDGeKwzCSiH8EQ4bxxei7hdKKrP889MxWY	305	431	431	1616016780000
542	3NKy12UDjbMnNBtTSZRwgdwBDR7AJztRsFoX9z14CDxbYQwUQEjX	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1405	861	1	1	535	jwf5FnBv7Vrtg6W7mnD62U6r7Sezaw7fBqM2YJxijFcphrzWcvK	307	433	433	1616017140000
545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	1623	830	1	1	538	jwqTBeFfhwNkrkHeLJkxN62P4GfjdkvV71iERdKhLarX1WD5Gx4	308	434	434	1616017320000
547	3NKt3FDcs1PLz3mnRQaDehxXuLUnCEsMKF2A3SrKsxkgoqG4ggHg	545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	1406	1393	1	1	540	jwzupj84nNm4D8fudczT2VRpYne4yCjTYcZW9gnGoeoLifThPv8	309	437	437	1616017860000
548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	547	3NKt3FDcs1PLz3mnRQaDehxXuLUnCEsMKF2A3SrKsxkgoqG4ggHg	1406	1393	1	1	541	jwrb1ae4VgRAn5VnxczswzJsXpHiT11u6fJeLqPbiK8gvkc36gM	310	438	438	1616018040000
549	3NLpWvMnyUKWNXndN4LZL8P2UyfGuEbTLSJLDugAebAigrauC2AL	548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	1406	1393	1	1	542	jxPv1qJw1xXLASUb1JMFQ7HMRXwx6koqGqcUjcxSWSKAVSUYDV3	311	439	439	1616018220000
552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1588	1026	1	1	545	jwh4m8yZ8RKH2Vw7xBkSB5KD9YcnJf2mW6DGZjdoDtccy2CqeFi	313	441	441	1616018580000
554	3NL5bMFvv1XLb9ZntdK912bXG1qr2LBTk7g7GK1wEwFXAwCuKST7	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1619	1275	1	1	547	jxPFydmAnELV9eCpiSsV1DuXvn2hvgokWY1Teq5SpJFfXWzPgxQ	313	441	441	1616018580000
555	3NKDwso22CGUxHxpFF75mKjvWkrgLHj1vFS3hNQGTzdgG6rMawH8	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1631	794	1	1	548	jxUF3pxmsWYBsNzXhxSpUEKYrWo7FBiAbtYXAWm61HtLqwSeZfB	313	441	441	1616018580000
558	3NKTaN9cmsb8KQVNtJyW8nAXJGPgGZVWH4WhNgEfpyX2q5R5KBEZ	556	3NLs5fiUVxttbxgLHjaZti9AdXYB5TeWoW3t5piVDE9hf3RLLstK	1406	1393	1	1	551	jwsDuSmkozxV8RtytjJ1EV3KbfTDMMAN4JBzhzB1x38sgWka9V8	315	443	443	1616018940000
561	3NLiCLGNwFxs8Hy7NgNMV3ZnvV7k42NxBHaZSeT4HiWDwTU1EyLn	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	1648	918	1	1	554	jwN73EScmCx8YXQBQUbpwVw1uy1Sjf58GDsp37c6XgQ8R9rvckf	317	446	446	1616019480000
564	3NLpfRhYxHCwqDaWBRWfTUWENc97QQzF8DzMLa5V5bM92QcdzN8k	563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	1403	824	1	1	557	jwNrZKLPmdgQHaVqJew81RpeeV4MwfDcivagKagQ6tduNTbE9tD	319	448	448	1616019840000
567	3NLErxp4MG8yDV3KjMqDUTVB7qc8fTf4VjbBxeVPwRMvHi8miQSF	565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	1555	1221	1	1	560	jxqKWaXe3Lpm972Fp1PKJhfwnsrqUaFTzZYgHAkwraeP4V1CYts	320	449	449	1616020020000
570	3NLAStcBA6mgqfTKyP1V1UfhiJdJ9n8zZHWFCcXHCBfH6UN7evJA	569	3NLdH55p95q2GviiTVLVEzdz6bkrXWAy44etMzT8TLWTrwRfsa5C	1581	778	1	1	563	jwJQZMqK2Jgcf5LjgovPxNtxaa4YdZUoDBEqCcLu2RwSnvtd4eQ	322	451	451	1616020380000
573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1619	909	1	1	566	jxW5CYyqKewbtFfpcR5poicBm35ddGwjA6WUxMVviM6GYDB7s5G	324	453	453	1616020740000
576	3NKAafy17sWJvqNbWuzLy97NC37cFWmRQM5isxD3u8p3V1qYNpkr	573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	1599	921	1	1	569	jwTGw3QakREA88ZYtYLzFapTtu2nPXcirG2TiU7vvU8WwMhEvPC	325	456	456	1616021280000
579	3NK7W5va9JDQGRX1wLZtXh1xEEBpdur5zSxw1LtX6VcSNRdrK4TE	578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	1407	1395	1	1	572	jwzuYie9xEKvAAi7L1Rh7CG84sHFiRtgBS9CmTdxXq6b8hjaQnP	327	459	459	1616021820000
584	3NKgm92jWsZKCkqWCn4ReWQD17Q7zDfHDKTBXoZ9sjmnBGmpRpqz	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1637	816	1	1	577	jxyH1M4EVov7s7cFbUqVgs1mbpZGSLR4YPDoKsySGyVVXHXB21b	330	462	462	1616022360000
587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	563	993	1	1	580	jxTmeKhnHrAE9gjbCSAdo99hiFdmfsQe3cV8gHX1ZvpCKrRTBxf	331	463	463	1616022540000
588	3NK9NJ9ZpuncuyZw2Lo7yZURGWPeKYK4EJaaMoCMFmYZRMJ8BLqZ	587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	1406	1393	1	1	581	jwfc6cvRu2UAYreJr6ZQQtpgfLB9Kjhzt26gr4r4PzMyLVk2pL9	332	464	464	1616022720000
589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	588	3NK9NJ9ZpuncuyZw2Lo7yZURGWPeKYK4EJaaMoCMFmYZRMJ8BLqZ	1460	617	1	1	582	jxckeM2Gq7kyymTTU9yfxCAdiTGaMqk6Lmvgs4LUCEWGfkntsk3	333	465	465	1616022900000
590	3NLXhcxVUNc9aBi7Yw1bwfxMyURJDqQfhUV5KE9v8bE51VKrUnSZ	589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	1406	1393	1	1	583	jwfeiPbDom7d6w7ELxLconMoZqQMpqpymPN2MVAC52vzPBWM123	334	466	466	1616023080000
591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	590	3NLXhcxVUNc9aBi7Yw1bwfxMyURJDqQfhUV5KE9v8bE51VKrUnSZ	1637	816	1	1	584	jwvUgveJ1ZRkVJU1FN5f1TVGd1mjcKyZt1iYpauA1bYPsvijdB3	335	467	467	1616023260000
592	3NLKLMFAwDMFG5ciJfBG9bE6snrWVoFuez1sC5XhZtQC8VeCpmfo	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1500	1297	1	1	585	jwsMEDj2kaCAQVihkEedSQ6gPWkbmNPpkDPxMLHo6p4xSwRLugr	336	468	468	1616023440000
594	3NLgHMgLExtTteHj8fGh1qtChV25xNh5qt6RTzfgw7pwSTx8GQkG	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1649	1383	1	1	587	jx4dAAMnWNAWZTfJgZqyxZiC97Gxrtb99vbKUvHmAzM17dcTY3m	336	468	468	1616023440000
597	3NKgZKWsVJ5Tr4VjSsi3YtoUAkeXh9fVtv5s92nHWzZWJS8xrgSg	596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	1476	1371	1	1	590	jxPi5zsG86cTtpTr7rqjqs2A32o93QS3mmz6cuAVm6ZbcTohRxx	339	472	472	1616024160000
600	3NL7fjr68ek7KDNPhX5gbLqkiqt5qWzEXJnpK16Pun6Qdtyf8JCE	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	1407	1395	1	1	593	jwBwUWqbu8MTPWw8gNYFADR28xitCQqHBGYnQA8UB67yV6jNjQp	341	474	474	1616024520000
603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1516	1168	1	1	596	jwXkuz3e3XpgsS2pW26vgvhXrJFgdHdvLafH28RvfnsfmKAYM6e	342	475	475	1616024700000
606	3NL9Qq7cgkqmQTshbpUn9MpnGn3qW3ch3tESXBiQGsXmSENjzEmf	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	1406	1393	1	1	599	jwyqq8KGrjbsf3Ntp6yyWt8EujeofjoGNXjsaYiK3xz3EfNQNGf	343	476	476	1616024880000
610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	1607	1102	1	1	603	jxB57bX4sPzY74G71yE8uFituWfFzzgAWQYMXaGtcuMNfPxhjqb	344	477	477	1616025060000
612	3NLqviTqQFsJkaT8ZBiDJKWaCuAVDV5pLLBmF3mrQNqspsmZhz5K	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1589	1160	1	1	605	jwyQS9er1nfW3eFZ4G19XExjgVjX9ZdS4FRpQL2bvhR3wUbvmYq	345	478	478	1616025240000
613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1483	127	1	1	606	jwLmFMBid99yTnQbRwSd5y5r8tn1fFkjfUGNSqPfHzMmQ4tx8rU	345	478	478	1616025240000
615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1407	1395	1	1	608	jwTAxAjDEWpd8u2L3hZnXiFKSE2duZn3VvXudhDGw8iTxy1cLAi	346	479	479	1616025420000
616	3NKEymFwNDaVakiPBHBSLavNX27FLjbHFXwpbap171D73Fo82n6t	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1519	860	1	1	609	jxdr8m63MnVsJ5soNbrZvotWaECwCN9S1EtbeXW4TAz5fBSZm9N	346	479	479	1616025420000
618	3NKn5SSb2EpdXLGURYTCr4zSDQqPf4tLKrN6sMg4Y6xmFVdMM7va	615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	1656	1343	1	1	611	jxRG5jB2nBQ6DNGiCjcS1gdQH8fPA3EPEGacnWGwpa3p8WXHHUR	347	480	480	1616025600000
619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	618	3NKn5SSb2EpdXLGURYTCr4zSDQqPf4tLKrN6sMg4Y6xmFVdMM7va	1624	1208	1	1	612	jxiMuNiTTzvrcKrKULQQRXnem2SFobaDkNrUFtTeaqadJrn66Ew	348	481	481	1616025780000
622	3NKYXdjtvchDhRkuRNFNrxi1Kr2BnLKGMPtiT7NFDMyyn7kir7Pm	619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	1577	1327	1	1	613	jxAYTtWbFMo5FSaVQBfqJ7u8jYediq2x3qsH4TcFzjRbtdjjv3d	349	483	483	1616026140000
628	3NL26HZHa6ETjnoKL7WhxHBfAvSW9H41D3WWreRau8UC7AXxsbTJ	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	576	1355	1	1	620	jwcPCEvCuSKokZSTG4ZU3UadHXAZZVGvZjZ13zW4DAbhUQUc64P	353	489	489	1616027220000
631	3NKhoNtdnTkEoDVEoBaE7GWxBj9BVPUkB5rRiYhRqExUgLXc7Bry	630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	1402	858	1	1	623	jxStA14Zbbz53XYPaGEGoZw5AwcFsuXTpR9e3bamtNjBjjoq37Q	354	490	490	1616027400000
634	3NL6MhzM8ubVJNdWJquYohajr3toZbkY2wv9AgBL8Rgpab5Ec2iH	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1407	1395	1	1	626	jwRHWCQHS8qrqzNKmvqXA2yJaKEtZi2w8iXgFUriPLB1qhB1aHT	356	492	492	1616027760000
639	3NK5fjQmb2odKYPHBWN9t5VaTu5fzRjbMyjuajyEzBskzyCtJmio	638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	1671	1365	1	1	631	jwfDaZucUYNabUjuhdjPrHStabMCvpztzGPwEHiwocFnrYrHdvd	359	495	495	1616028300000
642	3NKaW94sgCN3ZuGRtcxex3M1jFkcaRbPE4PhEx35edvDhiym5Cb4	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1406	1393	1	1	634	jx4KZ9NSwUk9ymyZHfSTMaTni5VGnsaTuD4ceeL1DWnYDMD6vSU	360	496	496	1616028480000
645	3NKGEDEh5EVxJVMtRQEXaKbCD7KSFoaEA3vSffhucMQFdWUdcvee	644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	1600	1126	1	1	637	jxndFHzXFnN16UPxHbvVN4dScQ9xxUcJJ5wepbKqWZnZXBdzgRm	362	499	499	1616029020000
648	3NL1FQgwGcQuKjprUbHMAxtYHAFLukpvQcfUtCdXuuLURn62ArbG	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	484	1193	1	1	640	jxaq1sVKUdxdADdWyvhwWkDDAM8GcgAD7hNmzFnqqnL9RZSWS3r	364	502	502	1616029560000
652	3NKqzMqWAp3td2hYHn59Y6Yob4gdVDWNTR22vPLEUkGxntABwz2j	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1407	1395	1	1	644	jxcCYvnqkH51Z3awT6NyCmggo5o9CCp9sPAQTvNYeyJwrDej3aQ	365	505	505	1616030100000
653	3NLbNnKtSMXqaNrznTAoCUofnxoXndoxzbThevywkSePtL15fKER	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	152	1084	1	1	645	jx5LxLZ6cKJNdJPkWFF8tGo3QYk3kT5Y2Q7FF7pRuWGcULw6Kpv	365	505	505	1616030100000
656	3NLTn9NzoUjTKLAx7GEe2pv428qXWBPCSgSBYwAArzt3anv8oE5r	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1609	1087	1	1	648	jwYw61uDJK9jgHMMZ3fgNYoqZgYSYbF9SzHtSitNBE8j1hS8UAV	366	507	507	1616030460000
660	3NLyEPkbrG7ahPEdisoKsB7e149dKtnzHq5dc2R5QceF91GhyRRu	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1516	1048	1	1	652	jxywxzMVjAUkQbi2KNAB23GmGAXfiZcqUfYdAMDEZ1d7oyXqmtr	368	512	512	1616031360000
662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1527	1293	1	1	654	jx9NRVrHHGpRxuMan4WJw2zr9LcNxhkWSberkittXUTD3cVdqH7	368	512	512	1616031360000
665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	576	1355	1	1	657	jxepjSdiCzNKkpZmNwNoDxA3mWk57z3TjTmqQzsh6DN37BKzYz3	370	514	514	1616031720000
669	3NKSf3nctjjf8GkwvrsuK8dhy4Jwyp4BeTqD95shicD7H7tgCgmh	667	3NLyQmQVXvFs7YeLHZ9ntXkVix4nNyevHRDdw2akvfs1jLm5RKoQ	1406	1393	1	1	661	jxSxZR8sG6bwcggd3z8H8ac7k5cXR42AoH8hBhu5Zbv8CFRUvQ3	372	517	517	1616032260000
672	3NKZCraBfQxyhKAYzLg5BCF3Y8tVHE8XAUqDHdJEeFPVj8pMsuYj	670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	1405	873	1	1	664	jxpvpz3gKR7w41mk3nQpHntYcPsGTeMfQvYGzcSDDjEBJCyxaay	374	524	524	1616033520000
675	3NL5ue4GHuTY9ha97n1iW1yUFtwNgoKmwhGQW7GDpHmUbPLWHUQd	673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	1587	1231	1	1	667	jxJRKnpAgyQUmmxr5Pt8P4xNLc11Ad4W14aJVWKrskZS3NVSYnE	376	526	526	1616033880000
678	3NLGFRDzcS61VmXnUC6iAXiRHQEHnaMxD9jLX53BYv2J51tReM8q	676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	1407	1395	1	1	670	jwLqzDyWrcVA2o5EyvDH15jTmdxJmSQg37uKf6f9vW1SdvczhbA	378	532	532	1616034960000
680	3NKt4zEgQWm7KYZraDqwh8bLaLBTxDjnNJ8Wqx8ygU5kBnHJT9eq	677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	1631	794	1	1	672	jxRLmo5zUZEs7Co39wSaTWSzmHMxAyMsKSJ8ZD6fvQDTzRQT6Wz	379	533	533	1616035140000
593	3NLuNEom9JdW6bzTyrGNC6ngpsahvCjp36VyTV7zTcXBf9nz5DDx	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1407	1395	1	1	586	jxKnXxqZEyD1zPqoXQECDMqyX1Q4Hur8M5vH9MHP45V9qt6qCRf	336	468	468	1616023440000
595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	592	3NLKLMFAwDMFG5ciJfBG9bE6snrWVoFuez1sC5XhZtQC8VeCpmfo	1406	1393	1	1	588	jxafaLpQ1JQnF2A59G3LNT4FnnM8BpXB4iAFGYutPkD1P19BAVH	337	469	469	1616023620000
596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	1407	1395	1	1	589	jxeW1fAkyXTCp4t6fw1AKZB8hEGU7g9vhKMM13WUmnKn11u2gx6	338	471	471	1616023980000
599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	597	3NKgZKWsVJ5Tr4VjSsi3YtoUAkeXh9fVtv5s92nHWzZWJS8xrgSg	1457	1025	1	1	592	jwA7rG24tMQ1zLpGC1mX3pCWDTnsAs8rrwxhKD1p8Teae245rj8	340	473	473	1616024340000
602	3NLbpzez9u2beYhBktZxmpyBGZu6oUMJdGVAKzh2XkKfWaMzq3w3	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	641	1336	1	1	595	jxN4StQkeFQjUSavNf9SLXdCTFJij5nkecErJej4TyCzrFSk2iH	341	474	474	1616024520000
604	3NKQmbXHgLiLy6u2cpQSgBmmUgprREfXxFRAvSr3VA7Tb7AWLbuM	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1652	1069	1	1	597	jy1TbT2cmbTK6AfBvNQbiZfz4FZBatMLRMXrCnoHNVWqpEmNNKR	342	475	475	1616024700000
605	3NKLHFk391XWufbes2qz52gM9Ke95WfofzbtbLjLL2TjvdTHYKjN	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1601	1388	1	1	598	jxQ8LKXdiKWyLNnaQWKbCwg1SFNspBmHkH1khsjFeWHwiMj2Qg1	342	475	475	1616024700000
608	3NK7FHt6ubXtMu4abHgA7pRN4G8FoX3khYyC4KsLbaWwxWTA7AVY	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	1553	776	1	1	601	jxvqQmT6Nd28ctVAotH8maZHzNCzfU1Cm4icDxsh4QxW3K7cMzF	343	476	476	1616024880000
609	3NKNWgbJoDLZDBavLrzPnsAhKVJbP4Me9TxPC2KmsTjJ6oobXM5A	607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	1407	1395	1	1	602	jw7cC6d3rNMUYADpV483ixQnL4enjY5rrAhEuVMLk7YWD4MJ4zP	344	477	477	1616025060000
621	3NKgmj6D2KTxnUKvy1d5yA74CEAsv45ncKWh4UPGnqxU6UvtbJK5	595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	1577	1327	1	1	614	jxwRdKQ6mkGu3k1Fent2vHRwRjuthbPfshZDpaKrr4ssZs5kBDJ	338	483	483	1616026140000
624	3NLZu7zL8Q1tumxWvrXRcqexmNi264qo1b5Zu1qhxDuCxTkWYtYP	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1402	796	1	1	616	jwwdwjsvFY8DsPTDbJ58LANrLgW3ce2K3EgYuXjpVuE4sijN1Gz	351	486	486	1616026680000
626	3NK8jMkLZFqGXi7o4WH7E9EGPJTVHKdeYajTqPGtS8oApMrg1tRT	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1637	816	1	1	618	jw7a6ufUbhQht5xQBiY4Wrr1X9kQH3C8Dkzd7dftCwtZY6ddMo5	351	486	486	1616026680000
636	3NKZeHFu3QcLuRxs3m2Ev4QPyHiB6R3iqtYfvzf5VhgrKjJzyz8q	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1406	1393	1	1	628	jxzagdZLktwftRrJTMKbyWXzPcVFEy1Dg8p4ZSfUxHHydBQMFUk	356	492	492	1616027760000
638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	637	3NLKYRpLDX9LTfBgua8tgf5UV2EfmdDdyxB68TAfzNaxg5Wdn24C	1407	1395	1	1	630	jxbokFWPTxY6Jk34gDoFPrkVmUkghyy3sD3XANrk8CHdR55HhN9	358	494	494	1616028120000
641	3NKGRjyeTRY9hztL4VJ6aYPjDNCzSk3EidW4x8mYJyxVTn4PCBSB	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1405	869	1	1	633	jwkfdsYFmZgHiBMJDznntXpsmPCw462v1gSScRMvZtbsehTE9SN	360	496	496	1616028480000
644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	643	3NKSnn6v2xvss1fbPcjYb6vjuZKT596pLmw9S12QjtPeyqFPq7N2	1513	1133	1	1	636	jxpchxGCvjgc3V1HjNnyVkGvjzbsAWkyE4aqGHnUcLm2BcpomHE	361	497	497	1616028660000
646	3NLT3WqSbEQ8chxJNMsfDytuPDuf8HQprLUJ6vtgCbfed8uDZuQw	644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	1407	1395	1	1	638	jxszN6stUnmX4EP2MqMd4jSrZLKjsXS1KCZbRd7V2JZFf1iNAxZ	362	499	499	1616029020000
649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	298	1182	1	1	641	jx2FhM7B9ArUg8vydtpDPztnp6JLK7sX26JnLQ1bQLgDbdPEviW	364	502	502	1616029560000
655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1637	816	1	1	647	jxHo17QxBWLcjyNx7otehHt2CAtfeUEthSwGRWJCDkfGfXdsizM	366	507	507	1616030460000
658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	1455	1206	1	1	650	jwbctG7oWKTA8Q7tDKesXKrUuCqVgFN8zw7E8BPJptBQV75tJxU	367	508	508	1616030640000
664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	58	1281	1	1	656	jwbCuVqQL28d6ePaDdgC7debXJ5dhvPUSSnzEhPMURt9PznULUy	369	513	513	1616031540000
667	3NLyQmQVXvFs7YeLHZ9ntXkVix4nNyevHRDdw2akvfs1jLm5RKoQ	665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	1668	1370	1	1	659	jxCrqFpZeNA5DJ3NZCQSbNnqrQVQhQsDXMvoVGjKpSTbhbBbxjs	371	515	515	1616031900000
670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	669	3NKSf3nctjjf8GkwvrsuK8dhy4Jwyp4BeTqD95shicD7H7tgCgmh	1406	1393	1	1	662	jwTAaieRQrDoXGXE7HFtXANK4aZGmWHsR9kDQAVY7FMs2huknyV	373	523	523	1616033340000
673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	672	3NKZCraBfQxyhKAYzLg5BCF3Y8tVHE8XAUqDHdJEeFPVj8pMsuYj	1407	1395	1	1	665	jxdSKX6qWXE9LiMAynRgimbDy5ecSmzKg8eYNayDfXPCX22hRED	375	525	525	1616033700000
676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	675	3NL5ue4GHuTY9ha97n1iW1yUFtwNgoKmwhGQW7GDpHmUbPLWHUQd	632	1136	1	1	668	jwHuMHdPiocLjpksJWx22uRuZzkBggoPMmKgnpaV3sDRxr4Vwfs	377	531	531	1616034780000
679	3NLMBdE8hvfpZFUfL6oRGGgm6KfehnrRGt86orGJda6CVg8uu4eT	677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	1448	1065	1	1	671	jweuLj3fL3X9kvNCehYPzNbBiDbLEXxKswybpuov2qp2sXMVBzU	379	533	533	1616035140000
684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	1406	1393	1	1	676	jwgkrEVnPT1mAGsMb1pDxeBSgt47HT7snbrRrpS4ZKHV2ntihUp	382	536	536	1616035680000
687	3NLbZB6MpS94FF8GVAMqgghLGm96pFH4USwwTVuooAQjcu82xhAk	685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	43	1310	1	1	679	jx2W6dJawV6h1eXAm8C2aREZk7KNGAi5gNbVFWu5EnAGabBRQaX	384	539	539	1616036220000
690	3NKeUGQeXNZb2srxhTmdBysDehDPinNq5vxwYddEGiJgD1G4MDCY	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	298	1308	1	1	682	jxNB4aYArFr3H22s219fVgv4y3sDgUPDRbHV3E3B2UY7gZZBsaV	385	540	540	1616036400000
693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	690	3NKeUGQeXNZb2srxhTmdBysDehDPinNq5vxwYddEGiJgD1G4MDCY	1631	793	1	1	685	jxaTHHTg7feCu3ewhpeCctpJUm7Dx7VzFU7gWJNKEPS2fM7s6JT	386	541	541	1616036580000
696	3NLViifuzjunXnKtDE9Z4VkdPNxSn9VKH6UTVQiKDGcviQHydkAq	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1633	1390	1	1	688	jxs8fh5wwHA13sS9pC7RThHRVxVqvhyQmHkg5KKwk9L4Y6zomKJ	387	542	542	1616036760000
598	3NKNNi1BYKAB7h5bmchNg5TNUyJrR16DTeeKfHveZrbmQVYHAXnw	596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	1529	1190	1	1	591	jwxcyycQtfJdB8ktfRpb7TiDVrbZWPP2Q38DKxAzLBRDJHtdvk4	339	472	472	1616024160000
601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	1637	816	1	1	594	jxvM5w2WQfH5LQc165stYPAkYZPPwcwtynshDFedggEs4sWVmNV	341	474	474	1616024520000
607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	632	1382	1	1	600	jwYJe1zPT9s8jZBV9yLm785vqivR1AbaJgVMKfuUN6yXgd79MQ8	343	476	476	1616024880000
611	3NLkeUUCkXAUxYkcP4XtZzMsqeRARGtLtF8eg3LM69zM7d5nm179	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1407	1395	1	1	604	jxnwVn8tXCbUPrDWw1dsRBeCAoWdVWBNQyQ9Jr1cy64pMmAN2zk	345	478	478	1616025240000
614	3NKTY29wveoM7vY4g6Hwk6ypgr4xyjKrrTymRwHtiWga5uKW85tS	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1608	1043	1	1	607	jwaBB5bL8HqrPS6KVvo8cfcnXMkFMZcrKkPn2f6NLBAiBq37D42	346	479	479	1616025420000
617	3NLbaf1j3n1gp3JURFYyoL1LCy5UVbZWxSopM9Sk8DPxkQcjCktC	615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	43	1310	1	1	610	jxcztGjtF2ySJe1MBKrR2DLDAMZC8PeuCKFwUJtZwCxiBc6NuRn	347	480	480	1616025600000
620	3NLq4fMp6amjdaQJd3sthExqqMbSD6kz518dFvXzJLVXB8WTYMvS	619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	1577	1327	1	1	613	jwzQVVRbxLjnJP5sqjQSPCT7ZXpUFZrDt14omwYdU7qoxhcZUwr	349	483	483	1616026140000
623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	622	3NKYXdjtvchDhRkuRNFNrxi1Kr2BnLKGMPtiT7NFDMyyn7kir7Pm	1406	1393	1	1	615	jxDQfgiMEb7bYihQmPuy5dM5Li5BjdfEdzRLChEEyDgw34fEHLr	350	484	484	1616026320000
625	3NK3YN3d6LGRczrUq3dJLyPitczz4NQjTVGAkqvu55RD5zhaSUuy	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1407	1395	1	1	617	jwZsGK98gbmn6rAcKbHf72ChzD3D8roJxH7UXrsguL1u3Z39hya	351	486	486	1616026680000
627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	624	3NLZu7zL8Q1tumxWvrXRcqexmNi264qo1b5Zu1qhxDuCxTkWYtYP	1458	1197	1	1	619	jwS5L5NbB4f9RGxQRKn2fsKuex58vG4C1PqAB9eMoq33LuGz7Mq	352	488	488	1616027040000
629	3NKKTbSECA224tYr8kKmoP2c6tuYnVCQoy7C4zNCo1pv97dD6jga	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	1405	865	1	1	621	jwJ8cvQrMAGXMHU2NoBo7gbhhuaHn6bycDddY3AiqaQJeCuXE3y	353	489	489	1616027220000
630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	1611	1341	1	1	622	jxqsu3ZT5znqnrro5aaUVuEgc7UBJPUT1yVdMSdp1VRA13Bq1rd	353	489	489	1616027220000
632	3NKpHk5cy1ZWVz9gbfVMpSUHrLMN7rMTfAxmDswZACu7jkXLiJvE	630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	1407	1395	1	1	624	jxhFBxX64PVSCgNCqskosMMWBAahpDN2J3McZBKm1nDVzYE1sKz	354	490	490	1616027400000
633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	631	3NKhoNtdnTkEoDVEoBaE7GWxBj9BVPUkB5rRiYhRqExUgLXc7Bry	1406	1393	1	1	625	jwvthmKYd52WC6pVAQc92eahnxo9e883qc6YHZ6zzneXWoQMvxL	355	491	491	1616027580000
635	3NKFxafKrnZJaEC37scp8Vv8qRARFWzb2m2iiRpSAmQujLcnsuGz	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1457	1265	1	1	627	jwQvsbkLp6Zy9r5Fj1FRrerDz6JM6ms1MRGKE2XqmnTYjMfQ2n3	356	492	492	1616027760000
637	3NLKYRpLDX9LTfBgua8tgf5UV2EfmdDdyxB68TAfzNaxg5Wdn24C	634	3NL6MhzM8ubVJNdWJquYohajr3toZbkY2wv9AgBL8Rgpab5Ec2iH	175	175	1	1	629	jxb8jJHJBrTam6NENoPYYxbF4ABBJ37qLNXtNrTHRwHos9UPJPa	357	493	493	1616027940000
640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	1402	796	1	1	632	jwsiHDBUw3eDbkaXNGF2YEd2nPLg4RE8FEUnf7qiXyNmz8yyShS	359	495	495	1616028300000
643	3NKSnn6v2xvss1fbPcjYb6vjuZKT596pLmw9S12QjtPeyqFPq7N2	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1476	1005	1	1	635	jw6gQbCLwUVxkMfHb38yaEtJnPRK7x1FhaBHUbBYk3JSfJbqaTF	360	496	496	1616028480000
647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	646	3NLT3WqSbEQ8chxJNMsfDytuPDuf8HQprLUJ6vtgCbfed8uDZuQw	1406	1393	1	1	639	jwYLJpnqYFfRb9FX2RY1qicg9SCP2EpbMdwuvEwtqvJnhgyEzbV	363	501	501	1616029380000
650	3NLTNHy1Urwyd1AKSWC37imBgyAu8gehNFqL2gPCuyY2oi3etWWU	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	1631	794	1	1	642	jw7mdKnUCh1Etea4PZhceGWVacCgSzGyKDQuFMgpUWX66FS2ztw	364	502	502	1616029560000
651	3NLGdiEMsZT9u1FtkDAx7oEb5fW9kcqojTn7Ve4FkoCV3DFnKFKi	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1534	1317	1	1	643	jwr3ccHCeJv1Lxn8ZmjdCew5QLEC3j15SVwBykYCWnvpma7bm1e	365	505	505	1616030100000
654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1477	1350	1	1	646	jxoG3K3BriujLWuoT49BxyDvJ1U1GVYHGY7NitFtAiFvAkpjfec	365	505	505	1616030100000
657	3NLYMTR2FHW3HWoLHfhakf4VT5SZ5CPA3mmwioa6CPu2rVgKh72X	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1631	794	1	1	649	jy1wYrHN2Qw4wYPdszZUVPhQxvP7mVvPUQY1Kcf5rejKhTRDQRq	366	507	507	1616030460000
659	3NK866B9UU9YuiPhHKRuP3QdxtWm4Bba4DAK6MHv9fsR5ggSFhX7	655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	1477	1350	1	1	651	jxWYSfioLjDgNYu6xSdVF6nzrEAovZ5r6FkwvxKWCvcns1Ci2CP	367	508	508	1616030640000
661	3NLKdYh4Q7i11gcA2axwbPfw2m2ake63MTLRMoAbzzaDRzTgVngC	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1407	1395	1	1	653	jxndsW5TCpzQf49psgwMohnsXLeHYqa9PECcDxS638Lemejw2rZ	368	512	512	1616031360000
663	3NKMQqrUdFZcWnnQCbHFK4FrVWNTy6eLD5Sv1Vfo61aBaXy4s4M2	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	1406	1393	1	1	655	jxV3ns6Bb6oXFJCZ8GkY8McQnyN69waSP7BvMnLa3XL9vZDaVVB	369	513	513	1616031540000
666	3NKPFLME3wsKHVsFJKijGyGRZprW1vVknx4w1DRFXBqiTcD4YjJi	664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	1623	829	1	1	658	jwqaHPM8giue8B18x71Wz4qmPTeQDEPkBGkXEvEG9QcUbsGcdkJ	370	514	514	1616031720000
668	3NKsMdhhCrXxv4k6VfzfhNMSkMEukSYZPB5E5BVhduEwFSVG7u1G	665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	1407	1395	1	1	660	jx4x2f8Qjz8ySgaEp7b5HDhtTJfX88zbuy7vus3FqR4dD9MLUC5	371	515	515	1616031900000
671	3NK55Q3Jg5Rci6e6hFxsgp8sDbWTNPVVHLowAFNhfdkXYfPR7g7R	670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	1403	824	1	1	663	jw8wVcYzoAH54hCpGWH4tytd2ifdyJxDdVqPMznUCaU4AzEraM8	374	524	524	1616033520000
674	3NLCxFzTqEmVytcR7rAjnorWLar7fFQNi7T5SurKEgk1RsrKAJ6b	673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	1608	1163	1	1	666	jxEbHjP7VC6DKVuR4gwnq5gyEhQn7z5fw6ne3Fhy4iMXdZ8AjNZ	376	526	526	1616033880000
677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	1406	1393	1	1	669	jxtX36XztiBxYNj5JmzsEVTqMBRBLdFubk5gDQxRVU4QNWj91ii	378	532	532	1616034960000
681	3NKK2jzAKiQSAKdaWA8Y8YZUiA7NTTrw1CPTc1buj8eMK4aGrsBv	680	3NKt4zEgQWm7KYZraDqwh8bLaLBTxDjnNJ8Wqx8ygU5kBnHJT9eq	1673	1242	1	1	673	jxPRrKEN1KCFM9ooQDcv5Ty6Pn7wcnGWJNsK1mUxcYPQiDbGKWS	380	534	534	1616035320000
682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	681	3NKK2jzAKiQSAKdaWA8Y8YZUiA7NTTrw1CPTc1buj8eMK4aGrsBv	1553	776	1	1	674	jwnez5WZfpddBeLfbCMfWTUrwyodhCpH3rzDrrVyK2dFDFm8FjK	381	535	535	1616035500000
685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	1397	838	1	1	677	jwsi7XZEBucNQySw4jYZ9RTKgjjBRbYKjzCTBfUL3pRRWfiNY4j	383	537	537	1616035860000
688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	311	1307	1	1	680	jxyhzEaBBKHXzUKiksJTPhMP3ZR6cePBq9N22wonMnzbG5aXMsS	384	539	539	1616036220000
694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1578	1050	1	1	686	jxfhtbhDknuT2hrdAKUDpzvowKW82w9fJqzRsvLeoNpLUVpzSba	387	542	542	1616036760000
683	3NL6QqBPV3b3YvMZuGsocV3w8P1nToFV4uDPtvvJActArKuwEVDT	682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	1546	973	1	1	675	jxnv11BbKLuUMJqjUbEq9pK6mRokqevFDtNf9do8sQZJUBuHRFv	382	536	536	1616035680000
686	3NLT2qBcgSwBgVhGbvX6URzcBBbWLmePsRWcHCazRNL8dpvqL6ur	684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	1587	991	1	1	678	jxFQnzDstrXQwf5JRCcTZpWyhFga2D1bgxQk28n5RGmRFQqCYo7	383	537	537	1616035860000
689	3NLCHhb3kZiptFJ9iYqtbbCtKBdCjuqgHLaE5n8i5XVH6FhxEqJZ	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1406	1393	1	1	681	jxgzK7g6Jg7iWYcn3FMddDTuBFWZGYqvHeFU37k7KsXGy1wLSof	385	540	540	1616036400000
691	3NL3tCmZJMooTGvTTtrMe5pPygqRPKFVkjVot2ZSLSxsapfAWdPa	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1522	1322	1	1	683	jxfWPsQFYgnydLyXrxVRa8nqGXrCHCjjyAZcSQy4ArgTW4cTg5U	385	540	540	1616036400000
692	3NLugNa6vYWaHv7PMQ5QPS2HSdBVpv8H8oeu3mXioGEe8j7xLo4n	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1481	790	1	1	684	jxiu8acB54BCGXj3ey3JfMdBtqWmxcZ8cwhUxYckGgadB4Dp1Lc	385	540	540	1616036400000
695	3NKfhSKFwoKiEzzX3jwTbYRuMc4s1FZNV7HRaQZGhkSgjYbPGsum	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1471	1386	1	1	687	jxMi9QssH4ZXoSHFS3yuFhyJh24iWAkNAP8kBEUwsLdtgVyJvuq	387	542	542	1616036760000
697	3NKC3Qygz8cqb34bwDZ3AM1xje6zStF4jzqeuwuuLQyWCqi5cfZ2	694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	1402	807	1	1	689	jwD1Uwva53mbA7QMPsMekkRzp31puEyMcqDmrVjFirmGmDM9sLv	388	544	544	1616037120000
698	3NKx8a5WnSs6KD5NNuYNMeLxXXXhiZVmMujTnsZcVEKUxuDVuWx9	694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	1407	1395	1	1	690	jwHpiAxd2saMvZnVKHy2bZUrraA1GAyWG6xxWUfLVm1p4gwrz1p	388	544	544	1616037120000
699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	698	3NKx8a5WnSs6KD5NNuYNMeLxXXXhiZVmMujTnsZcVEKUxuDVuWx9	1633	1390	1	1	691	jwR1cPoSroQtaJpXLxuUMAvURanzCsrSHBzCTCS3BN8A26CbHyV	389	546	546	1616037480000
700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	1402	862	1	1	692	jxJGqBZemUUHvLks8e6BJ9MuP5saE38kFPznvotXeK6XJ9AVgfs	390	547	547	1616037660000
701	3NK4bcDXLQRmK9Ej1JECCj3r3rsbts2nSACTjFyyyooPQRaqf4w8	699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	1656	1343	1	1	693	jwGFEczAYSaxunqstWbWGb5hpef14bmS5Svp2Rqn5qoD7eM53rL	390	547	547	1616037660000
702	3NKKjqyxdN1Xb6fVkbEyaYXCm62WGW7urMVa7wsjYCAjydZQvcKb	700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	1448	1065	1	1	694	jx3rpetEF4466SGyqYoQ7HFiqymo2P6fdHQ4uANq51MgjRw4QQG	391	550	550	1616038200000
703	3NLS6EEeKQLXv8EvWqWDPtkwzvN5kVWQwMvXyXCiR5Phfem2V7nL	700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	1581	778	1	1	695	jxjuzzheTaY8DWeR8HgyWyq81SqAMcKF79TwwNn59EBjfTUEDXD	391	550	550	1616038200000
704	3NK9Rta4W25z6Cw4UzpCVqj8iRBe2df8ww6sUDTzkSJQs71jQkuN	703	3NLS6EEeKQLXv8EvWqWDPtkwzvN5kVWQwMvXyXCiR5Phfem2V7nL	1406	1393	1	1	696	jwTpeCXQ5yrMWJNifjU8kdxWhdUpdEAjTx8a5JbRRsnHewhCtEb	392	552	552	1616038560000
705	3NLLjFhivU1WoosniCUNC6ekMhwzQM8pmU79GdXCkPgRUG5cgHJW	704	3NK9Rta4W25z6Cw4UzpCVqj8iRBe2df8ww6sUDTzkSJQs71jQkuN	1637	816	1	1	697	jxAH7aa3ougcBh2GchjCvDXmLECcetk3ThqGesiTYV7TaWqu8tn	393	553	553	1616038740000
706	3NLc4q7QJ2rmdnRjH4NWQrRJHoqfNkEzjaF1VBdnAp4kUuNJLW97	705	3NLLjFhivU1WoosniCUNC6ekMhwzQM8pmU79GdXCkPgRUG5cgHJW	1577	1081	1	1	698	jwHsN2h5h4B43U2bwx16J2Zep3v2ou1xtHKkNZZKXjDQfkL3fDZ	394	554	554	1616038920000
707	3NLMxQ4ZXPa1DPe8iQQGyBfqtknjmkjz6qTQoV4AfzJY7fNXoFF7	706	3NLc4q7QJ2rmdnRjH4NWQrRJHoqfNkEzjaF1VBdnAp4kUuNJLW97	1634	1331	1	1	699	jxM8dHCzAm9XPQuXJd41AF9UBxjCiw6zcZeasDJAMVnXV5M96tN	395	557	557	1616039460000
708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	707	3NLMxQ4ZXPa1DPe8iQQGyBfqtknjmkjz6qTQoV4AfzJY7fNXoFF7	1549	1116	1	1	700	jxLB1UxQSuM6UV7udbMDrKJCYqPrvSAiSUoVXRX5MDHm29dpPce	396	558	558	1616039640000
709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	1596	1363	1	1	701	jxi7UvHrSvkrEJos3EHRHWYh2nknWiEPDoaZw8rewrh8obNXfJn	397	559	559	1616039820000
710	3NLmRk8uqNFYwRTVf4QeubyK6dym6ac72qmJh1187gqAxnBeFegT	708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	1613	983	1	1	702	jw7QRu7RpccC84sG3rB5SCLG3c1hB36AqcUMvMPf8HoXi2sJUpj	397	559	559	1616039820000
711	3NLQEkT8beVL1VpBfxtaxuDY84cWgCpkiEPXbcW8kq6s9AF8PuiB	709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	1405	851	1	1	703	jwCzQvLETdyu7Zeh9dfP97U3bXzgpNWHMAjZaqKQrCQxBQkkqe5	398	560	560	1616040000000
712	3NKi5CyUTUQvcEJkZper3dQwUQ5PEsUFGgjBbK6yDArzz8m4q3dt	587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	1569	485	1	1	704	jxXMY9DUcGSgyMAKonDiajh8UCfXg2zws7Dj6rLL4G5zqKWCBDg	332	560	560	1616040000000
713	3NL8pgSLioPS8EpfB44EEb8HSnDpVRJeBT5bpbmswU9ieY8Ppke1	589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	1569	485	1	1	705	jwCWucYHmBKi1of5rKM9Xc2cr9EaBQJ9BuYCGxaMHnpLBUppY91	334	560	560	1616040000000
714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	1569	485	1	1	706	jwiokcgJoE7zbJabVi3krzDCjNQthecyPokVQh2Ky798yrXTcmF	398	560	560	1616040000000
715	3NKQy6zNWYS9xrYQcqd4KfTE8AcZ61beujRcbgUrfUzfApVrDtyu	714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	1403	824	1	1	707	jxcnSmcnQ5L1enTDiHfhCBcdfLzGEAYascN66dVdLA1HR49UUws	399	561	561	1616040180000
716	3NKaQveh9H2ktHPNecR6wsgSAUDpBhCjszY9iVrYMAgNHoV9upbz	714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	1407	1395	1	1	708	jwg399qNYZgPLvsqVDSr6Nq4jJZEfYuSvqtRQrhagxWinbJoKMM	399	561	561	1616040180000
717	3NKNRF4hjhDJk4VLkhRPZbveBdhyUDgyAxn6z2FGm46mbGnxRBdL	715	3NKQy6zNWYS9xrYQcqd4KfTE8AcZ61beujRcbgUrfUzfApVrDtyu	1406	1393	1	1	709	jxNv5VX1TEAAik2SZczDqDm3Q5jg64DWEyzM7SDbcJFYqg8Lg2c	400	563	563	1616040540000
718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	717	3NKNRF4hjhDJk4VLkhRPZbveBdhyUDgyAxn6z2FGm46mbGnxRBdL	1406	1393	1	1	710	jxZsnkHqh3UKrRJgfPvdt3aQpnWdf6e2WDNibxLHdoFvaDCMKxh	401	566	566	1616041080000
719	3NLVJeW8eEQtbKZ17rxsgDQyXLXxe385i5NP2tSGwRyh4iPFUcuv	718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	1407	1395	1	1	711	jw78LnLNdvQ3aYJDpDCiyo4kfAZLfDCxPADUja55ZZBbFdPdMcw	402	567	567	1616041260000
720	3NLHKv5uDA23cCqeTGtEBe2XbToFWXya5TVWvTgr6P1Jfzs9Kj57	718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	1637	816	1	1	712	jwdBvLMyx5Wm92kukSRy1s1BY8EsKDsd3qgZ2czKJrMouxxSdzm	402	567	567	1616041260000
721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	719	3NLVJeW8eEQtbKZ17rxsgDQyXLXxe385i5NP2tSGwRyh4iPFUcuv	1516	1294	1	1	713	jwpQMpm6nSj5VhDyR2cbPpTygU58GVZEG1tyY3z2RKzcu1WqUWu	403	568	568	1616041440000
722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	44	959	1	1	714	jwekneCFrwVNHRQ8u5PriQLD2ejjJWVdBLNXJLEVpTuonZsbqis	404	569	569	1616041620000
723	3NLKYkDfZqBtEUcN3UtkK3VqTDfQj9tx9fyz2F3KxzFFey9mESw2	721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	1631	794	1	1	715	jxxXTKBJXxwEtHtviucTcAPEJhAdUAaM68pmgPKgYG3X55CmrMm	404	569	569	1616041620000
724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	1671	1365	1	1	716	jwzz3PR5SDmwSs72DUtu1Tvp1ZerXJz6zkvzmpGdRWjV9en4aXa	405	572	572	1616042160000
730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	729	3NKCxs5ERnZ443WpZwj87rs1qYNg2TofuvG97E5EJnMzVYMQG8c2	1483	593	1	1	722	jxRhAUiueagsEis7Qgxiatv72aH1yAjcp4dr8ccDqqmQfdwuHeS	409	577	577	1616043060000
732	3NLFMRbSGw7mdxNJVcnSyQ4zpfCJkpDmKf42Ujwc9RZPw1wHuBmr	730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	1508	1261	1	1	724	jw95mCXmXmPjcWGy6UaxvpaWoN6TCCTTfLe5UdCDVxusdrDa6R9	410	578	578	1616043240000
733	3NKqTd5CyUr2sPpVaotxsA4zERk8WRSteYXKcBuR6EknM8CRhy18	731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	1675	1096	1	1	725	jxswtvyGcjUhf3RovAxN7zej2ZahgrJvYSBFHejDPJ7HGGgAxib	411	579	579	1616043420000
739	3NKZj8R6mdmn9kUkDNcd5tm4yv4Nex8vN8Ces3izF7GbLPLCYUfS	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1608	1163	1	1	731	jxitBoXwM1JN2V2iruiGSRE825yDc8fLwqHEnXXwetaxXva162i	414	583	583	1616044140000
741	3NKzaF8zbbWKLHzuyxdKQXdoNWgV6Xi7jQmGgVTHi26jKgfLaHhn	740	3NLJ4j4ZsmGFmkhnY2ykQ8oZMuXoSC25t9ogpMK9uYgg2beMG6Zk	1405	849	1	1	733	jxM4kEM8J57wDzGBtL34Ha2Gxu8s3gzMSpzvQnT1UCCsGe2Uy6s	415	585	585	1616044500000
748	3NLmfZengoBEsv3jwgiUw4Be64nUEmBgRLrVc1tkVDzeg34mghhu	744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	1446	518	1	1	740	jwjVi77bbx9mgtGng92usUrnzdmaLrbRK9NykwL543zSmtCP9HS	419	590	590	1616045400000
751	3NKdbPnpEcpcjooYEnSuQbxPyt7E6mZ6Th9CCgr9Rk5TPp7EcSzv	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1594	1326	1	1	743	jwUKXTdnaaJjUqMudhSbzuPu4hMEizoWH34p8KajNqENqZMzcrt	420	591	591	1616045580000
754	3NLx5SNqjQjSAijAyA1fDesQtrcNV5gXyJNEkb1zUHSZt1CBRnXe	752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	1600	1126	1	1	746	jxJqCrAW1XCQBiM1M8JhhKL7rwNqqD4PrKq1nKahvuhFU12bNcB	422	593	593	1616045940000
757	3NLB9fEURAg5tJzQjWcZKNmAegvGhNtUT6vJgzdurRUCGVsjAq1v	755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	152	964	1	1	749	jx8QdERtbbX6eQPN3f5rGF4KXRJxUgSTzKTfVgh9o8oMCZXrE5C	423	595	595	1616046300000
763	3NKNW5NvkLYgnkXjoiK4SjPQ987WXEH44pwe32PVcsysRJg9AG6x	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	341	341	1	1	755	jwY3mmfRUwkLFgd5WFeWnDurUVCQJQ5nTvoLpzp1hxCkJABEh5x	424	596	596	1616046480000
772	3NL5HdHGTHdbC87J7AcNdPRNkiSBnSzrqN2sEDaiUmkCv3xRvsJ4	770	3NKBBe7Mq9LGifmQayk7C6YvzryUQ8a1tVNQAXCd1BNx6ZPD2zmU	58	915	1	1	764	jwEgsy8X59J6Zz77kZpLxcRHN8pU2BJrDYohS6JPsUJUjg87m5R	429	603	603	1616047740000
775	3NLqGGvMxigCiVdPoyCMM4wDMeufbpVCNScrehKZ76vvycCk93qE	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1405	869	1	1	767	jwAVmNgjoWEmVoafUy3hPuJCjnC5rQMCymGPWfzPnxu4LuP3ECf	431	605	605	1616048100000
781	3NLpLLSLP3d1BZyLHsLnfU5Y3H2VTZMxiGoGvw84YRzxTgkABHZ8	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	1637	816	1	1	773	jwy9iuGHrdS6hApqNY7xkLkNWx3h9VyV4JnPxpBy41zahKkCQEC	433	608	608	1616048640000
784	3NLTFuuD6kf6xHpVzLcPoGUvUeR8Vuhj2vLHs6Gdr4MJn4AFy7Fu	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1654	1340	1	1	776	jxShygmB1eTKTsCx9jm3JXxRCeBCpuXj3dD4V5yqyfCrRstyf8e	435	611	611	1616049180000
790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	789	3NKmWJRJpxFKpNY64iJhh6cSqwNqsmh3q2dCMr8J9Wn3fpRqdiAP	1402	900	1	1	782	jxy7EHZYm4BFyiyBMWAYRn2MufDqH5msi3SR3ki3UTw8B2CQDuy	437	613	613	1616049540000
792	3NLafWB9tfj8XjDjWEJfHV11aVwcvDhJt6QrVjcveHbhFJBfyRC6	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1600	1372	1	1	784	jxwiJ7DgmaLhYqkC4apZ6pDsmmenDM74zaDZyXxVqhJDvXrpkrJ	438	614	614	1616049720000
795	3NLmTwef7xbmRU236UyaNghSzBfBpCduep3Cd8GwSyqdDAhABurA	794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	1668	1124	1	1	787	jwC2KLdaYRr2fmWXJgP8MMJgXL7vXhvTm8QFWwfyZkbhmwMzEXe	441	618	618	1616050440000
798	3NKHKedGWUExQjMXJv1mSViVPLBmK7MhGnAMPYWD3UTDzPFwVyLZ	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1426	1364	1	1	790	jwLn4cc575LR3riXW4RvsmUciLd5ArDxMNqprg54cgnhG72xyCH	442	619	619	1616050620000
801	3NLfVwsTqdN7w1ZFtU4tzHCBCyD9WLXEdJKE6rheGZvJwVGr11bQ	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1637	816	1	1	793	jxrboFkYhnbeXZE3XcBWZaMSJAFG1Wk6TWBBNR4n7mzLNfYGfGt	443	620	620	1616050800000
804	3NLv8ku1kuh28Wm1tCMPExFZ6Fu92w5wxHfWLe11BgWPjtwDikbu	802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	1481	790	1	1	796	jxb5A1WoPvbwwxefSAgMkvapnHdqUAT6Z6kcjbnYYtgHkZNd9TT	444	622	622	1616051160000
810	3NKQs2rHK5vM2fWEQjVi59sjoEmZTTjgewa5epAthLEysQgp6Phh	808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	1631	794	1	1	802	jxbjKhV6iKApFNrTiMn7D4N9dVpJ5ZSzNKUcmDRAWezg3DaHqN6	448	629	629	1616052420000
813	3NLWwupMVwKFqx6QZ8WhJmUAe6kbGT7R7wHYhqj4Eo7TSKKj11Ju	812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	1607	1222	1	1	805	jxgNhuJhVpe7M3Bc2wwGyMkUTnBYwq2o5qHsDFBFoFPMnH9mqgf	450	631	631	1616052780000
725	3NKQyWCFocB6Bg6my9z5jcMpVTySTpi2mLgd12h3mQACFyAzSamA	722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	152	1204	1	1	717	jxm2YSPzQPkhay7uairos9ku1HwFXXM6LQxafbisX3mfkBSDqiH	405	572	572	1616042160000
727	3NLLXfo8SBrtWgEgxmSqeCg7ByzUSX6Y8PqfDJsJsFuhZBBvg9kN	724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	1637	816	1	1	719	jxvneWoq4D11NZCdvtTny8CKWzNYyX6i9iuiK6JFbYguN2XenZg	406	573	573	1616042340000
728	3NK4yGR9BVJjhMi57gNBu8E9gusLzU1FLogXt5MyJg4aGs8u7Xju	726	3NKtKCciQZe8MiHPLdHZ9HhRCeWsYhqpF8DL6H5SNaWZYGbYozg9	563	993	1	1	720	jwoyu4z9V5hf8b1MCiXr67ASv1J2gFAFPDzezan6z8g6DUEFfCe	407	575	575	1616042700000
731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	470	1063	1	1	723	jwoYZS16ACq9XR8945SG5Lp691ZoXxdh1HcEwHmvbmLsTgMop9R	410	578	578	1616043240000
734	3NKryXbzFExaZBfzZLuY5sjMef7WcoAMXRYCym8XhCXmoSQuFWUb	731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	1419	814	1	1	726	jwntYTWVga5ubkCq1foyCp3PYdFP41vWsukFA7gzMUjbrEV5jDL	411	579	579	1616043420000
738	3NK7rwAceYgWw3wJK3wXFWz9FByFCLtMvrftP4b5tFLQxEKbWaHa	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1585	1366	1	1	730	jxx8HeKMqfwgwxBccZexcN8QkmqUbLSQ9rj47m9QezV16QEPJ62	414	583	583	1616044140000
740	3NLJ4j4ZsmGFmkhnY2ykQ8oZMuXoSC25t9ogpMK9uYgg2beMG6Zk	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1579	1023	1	1	732	jxhZkaDKV3mcAFHtYT1X5HNi4naqacXimX6hvWHkNyZMLQZvCfS	414	583	583	1616044140000
742	3NKGUu18HMBXaRSKXGpC31HgB2zgS86euT5p6VAivpvkBebF1uct	741	3NKzaF8zbbWKLHzuyxdKQXdoNWgV6Xi7jQmGgVTHi26jKgfLaHhn	1581	778	1	1	734	jy3BqVWGiWixj9Hp1PRaSEeaHrwybqpfc9wcE1u2DwhCh6TsD8U	416	586	586	1616044680000
745	3NL2cw43tepXT1g2dsgWfuawe46pd745d7av5xQizARC4KdQdgc4	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	1406	1393	1	1	737	jx3kWDT25FZcRqrgvtQBPKdxffiUUvdkjUjeNgY47nuqhiwwdN5	418	589	589	1616045220000
746	3NLrqmX22uAMb6WhoEjRdCPYjRfgiLLNCnBEwBZhe3w4hEzg4cX1	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	606	929	1	1	738	jwQtuPstms7ZemKxdniHp4WPDgyktCR5z9gNTaYUdyfP4nzAL3D	418	589	589	1616045220000
749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1407	1395	1	1	741	jxga5oKUMJwxvbQnnMwcUooHcNaRLai6vwYg6M2vSf5WK85ju4w	420	591	591	1616045580000
752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	1534	1191	1	1	744	jwCgvQZDvSq3rMCnQZx7dDyZnjUKWZAE6EiGnBPXTzRUkUaqQig	421	592	592	1616045760000
755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	1559	1353	1	1	747	jxc4tPRWkC8bBPQW1DENRwz1QsQqjmevcEqt35EosA2JPJFYNj8	422	593	593	1616045940000
758	3NLB81Q5DvaWEuJ1qRXPQfGsoTB6U8CWsd4NWUgYYrhCbcKfpSnX	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1423	561	1	1	750	jx88FatTzBBGg2nNo6c152TkjLFVDcXvU2fUj9635hGjWQmJMfv	424	596	596	1616046480000
760	3NKW4zGHmVStQhRoturqeA6tDkurCgFp7Dse4G8dj48vR8Azrk8o	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1483	82	1	1	752	jxwuzMXSUKZD51jVKuWZ9cAgiQvw5JF3BFRpkB49CTwA2LaTdSk	424	596	596	1616046480000
761	3NK5PEhW8ifChej11WSfRX3GirdDsLBCXzpo3CNEsz27i8PKHkQG	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1555	461	1	1	753	jxPiJAL8zk3xX1MdxkTGciBpBSsk7nurb2HFkdTZa3ZJD8mHqxh	424	596	596	1616046480000
764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	760	3NKW4zGHmVStQhRoturqeA6tDkurCgFp7Dse4G8dj48vR8Azrk8o	1642	1121	1	1	756	jxsHfzvHJ7a53CDsrYC5TunhNTVypyqBzLk3SJFZECuMaG9mKk9	425	597	597	1616046660000
766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1406	1393	1	1	758	jwLmamsssaVreLBBGEdw6wrVwPk7NSMEsvcDzEmVmEUtztpChPu	426	598	598	1616046840000
767	3NKWxcBNfTT7kuYc2yD4fJ5buH6JL5xeRTMztq2P44a6UJDZo3kY	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1581	778	1	1	759	jx7hVc3K2yAzhjdsoVrTASgdUnTpgVHScE2sXRPwgCmmCfhm9hM	426	598	598	1616046840000
769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	1407	1395	1	1	761	jxypj83oS9dYaFcbBkXRmxWxxAWFo78KmQ66p5Xr8PEQRSwGPbi	427	599	599	1616047020000
770	3NKBBe7Mq9LGifmQayk7C6YvzryUQ8a1tVNQAXCd1BNx6ZPD2zmU	769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	1670	1282	1	1	762	jwkZda92DQZHp7JBoHfn3yrxGCby51Nr6eHhTv26wtS8fZfAvAX	428	601	601	1616047380000
773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	772	3NL5HdHGTHdbC87J7AcNdPRNkiSBnSzrqN2sEDaiUmkCv3xRvsJ4	1448	1065	1	1	765	jxCxKBptHm4Y5HeyyV7vzsE9cKgtg8MJjtxwsZSAtFbegVeR5zV	430	604	604	1616047920000
776	3NK4SAF1RfbCCKjLSJr9G3xv2yj6dPq1S5zahCaJHszunBKzWjME	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1483	893	1	1	768	jwu7gRoKy4vLWPLUUpyMskM9NLQyrDcRMSW7PcXhPKtoXqoYem2	431	605	605	1616048100000
778	3NL24frm7BihjS93sqK55C2WnZMD8H5oJ7E3FArQm3qXYBS75jLv	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	1541	1052	1	1	770	jx9698HMTgo5y6SZVziNNhAUhe3pT2irtW1ziBgWHcFEaNuFMfm	432	606	606	1616048280000
782	3NLeCj6vU17hCKeA13BRgtbH6byvEvf2SLrpH5CS5akXr4beTGNA	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	1553	776	1	1	774	jxUYffy8CnuRDVC31eJmyN3UYPyb2FDVRiEPaNgJpX5tNXg8YZh	433	608	608	1616048640000
787	3NK3m39VvMpYj3PHcn7h694s5Px67ew7xWjiwGwTd9q7FFU4ZT5c	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	44	1325	1	1	779	jx9VXYehdV2GRGjNRY4De5xrZdPPkZwP3hMRWtc6VghbvFBoSBp	435	611	611	1616049180000
788	3NLGz1QWSckQP5CfrnLGBUQpFnoTAMTT2zUaeQYLdrfJVTrB4Z8L	786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	1646	1354	1	1	780	jxvZadspDYLr41DKrm19Xk7XZPTTRqjQzHxjqRmcy5aFXMpH4xM	436	612	612	1616049360000
789	3NKmWJRJpxFKpNY64iJhh6cSqwNqsmh3q2dCMr8J9Wn3fpRqdiAP	786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	1573	1318	1	1	781	jwSnKyiZiubyYR2EajeqVmSSPJvqKYxaJD2QuHymry4dXW3p5mC	436	612	612	1616049360000
793	3NLemXZYqAZPeD9D4amTGCD2B5EirAnPVB95bhBK8pc53qfFbSM4	792	3NLafWB9tfj8XjDjWEJfHV11aVwcvDhJt6QrVjcveHbhFJBfyRC6	1670	1282	1	1	785	jxPyKs7KTBrumb2vXFJadFTeHWnTnymnimrAzmSC2UwetrSTbCz	439	615	615	1616049900000
796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	1406	1393	1	1	788	jwMjks8wCsxihK4mSbkavkYx8awbtx71RapYUCmS1XxJd1QDjwH	441	618	618	1616050440000
799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1637	816	1	1	791	jxRb3RNjLLY5GSg27fvKgG8imwq7VXSiEURzNsgax9YuFVRSdL6	442	619	619	1616050620000
802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1440	1011	1	1	794	jx4P9tYJBW9Z2hM3sPPVU3zRFRGEHbe8rnbak7CDeqEq25JBzPS	443	620	620	1616050800000
726	3NKtKCciQZe8MiHPLdHZ9HhRCeWsYhqpF8DL6H5SNaWZYGbYozg9	724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	1650	1375	1	1	718	jxzmFZiyhC559gBhXfoYcQszurw1Xo6z8YcZgkHsvAXpgE4LFjz	406	573	573	1616042340000
729	3NKCxs5ERnZ443WpZwj87rs1qYNg2TofuvG97E5EJnMzVYMQG8c2	728	3NK4yGR9BVJjhMi57gNBu8E9gusLzU1FLogXt5MyJg4aGs8u7Xju	1406	1393	1	1	721	jwHx5dEWf5BLxri7A7EgmUVeigTLYm4wUjqQqQtpxwsWe9DM3AU	408	576	576	1616042880000
735	3NLGF84Yy9tAttYjk9XCfVQ1MhM6fwH6WVFXXbEZ7cdaRBpDBUWx	734	3NKryXbzFExaZBfzZLuY5sjMef7WcoAMXRYCym8XhCXmoSQuFWUb	1426	1238	1	1	727	jxE5Bd823hWhMLEshSVTUuU27TxEmp9TNmnkhRcEN4zXEUmxboL	412	580	580	1616043600000
736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	735	3NLGF84Yy9tAttYjk9XCfVQ1MhM6fwH6WVFXXbEZ7cdaRBpDBUWx	1419	814	1	1	728	jxLKwTimNEk6Rerh5tMStd9HjaKZpMenM5cwyDWTFxMcAvLQJfr	413	582	582	1616043960000
737	3NLFUqqvNiDxZhM1hFfMS8mXhd5WEUdrvfeyrhD6nTDHY4EJx6SF	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1536	947	1	1	729	jwWQDBbCriayosFJwSdQmA1tes7N3iQhm25SCSNbr5vpZMPD8Pa	414	583	583	1616044140000
743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	742	3NKGUu18HMBXaRSKXGpC31HgB2zgS86euT5p6VAivpvkBebF1uct	1585	1366	1	1	735	jx7M22yKcTfFQULzeNqWGhTjU1HgyjrC4xrgQmeHcGq9jWFmmY7	417	588	588	1616045040000
744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	1668	1370	1	1	736	jxwbHbvLtSX3dpaaPnbyUDEty1USJBhP7redRwygcyc3pfNz3Cx	418	589	589	1616045220000
747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	1579	1389	1	1	739	jwrWMAse53a7LKxq9euqNqGeNPoyZMheydRTqYabskjNZADVdrb	419	590	590	1616045400000
750	3NKx29vmdZpv7uT8C6gaMwSowrv7NDBNBMGkKEEP48SWDJNMdJ73	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1536	947	1	1	742	jwkWqTawzbSbUiYRS44sZkp8N9pXDUdzjzTMRmHPEaKDme9LEHW	420	591	591	1616045580000
753	3NLhAbi6tjPW1D7nUSLnqfbo4MysmhEU5FKLjrTZa9kNu4Zi2GGB	749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	1547	1012	1	1	745	jwWoToC6DiXFaEHvKHHdo12gXVrviYwG6hjKK8bWUS7SxX6a44f	421	592	592	1616045760000
756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	1642	1367	1	1	748	jwp98zZFRgqHF23w59nfLj7rGrk16eqH9nLAn8Cww5rw54xvgdP	423	595	595	1616046300000
759	3NK3JnmzJHRgDrDy8zNZD5H4Wtu6WfV7DEkLx5Nq4TbBncfGysTf	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1617	1288	1	1	751	jwXzhuW1rWH4iu9XA1fmZgS9YDE59qkodybGP1QJo6cvhzh3qnj	424	596	596	1616046480000
762	3NLbUH8t7WdiR3aATe4SgYw4KaZoZx22QYAjr85tKkP1cPKHeigW	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	341	341	1	1	754	jwnsyfxKV1msrNVe1D8Z9ReNHjm1C3Tc7V9zezTFRah3jXMV92q	369	596	596	1616046480000
765	3NLC2mJF4hivx2WyvTWmP9C1eCdNuNN1bgjMavSbY4g2RAcFjcd4	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1587	991	1	1	757	jwuPwtDvove3nThaZrMa9HeWR4Rh8A5GWqeKDhvpuPypuceFJVF	426	598	598	1616046840000
768	3NLkNDu5h5g9GUewRb3KSJRk5yEMAURYx64GoRXxBxrtZJQuZuqG	766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	1585	1120	1	1	760	jxquc3kfb6tFxBNTVpzm83tc23AgikYdy29Dzaqw4Zcz7zyZE8H	427	599	599	1616047020000
771	3NKe3LZUtjBZKH341jqrDzzw8LwetaWgF7Szzsg9SKW56phfyYig	769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	1553	776	1	1	763	jwZWVznzqkXPknBvfMXG4LyDwDLrtgch3SoEq7skuA5Gki5kYtg	428	601	601	1616047380000
774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1434	642	1	1	766	jxwr3rEBsYC44w64nweLe85CZjMcvCbZzP93cx2ZFfjmbvH9uZ8	431	605	605	1616048100000
777	3NLBtTsKUmA4Yk115mTwSuyhBPNhdpgjNewTr8zLsPytVCmFzV9a	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	1508	1387	1	1	769	jxy3wVh6vLvuUm6afEuopfqFZ9AmWkv8D14Ap332BVSLG4eKrya	432	606	606	1616048280000
779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	171	1374	1	1	771	jxQGKE22cf5gBdgzT3QAbJFi96Ejfpme2i4p7GHfRWsAMWcoP3Z	432	606	606	1616048280000
780	3NKX5XBQNCr13GDFshPTNWcMeULNEBPMpss5oub3UN8tu4uXCe67	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	576	1355	1	1	772	jxxJRZGtFkvDWuekpExuGMifzsBWuV3YeVKLAfs2TXYkaM8SCNV	433	608	608	1616048640000
783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	782	3NLeCj6vU17hCKeA13BRgtbH6byvEvf2SLrpH5CS5akXr4beTGNA	1631	794	1	1	775	jxRx3BcVBbLGkUpUH6AiPXPVnsYU2kKASmAWemUD2Djg9WzAk7A	434	609	609	1616048820000
785	3NKpJ5tD84QZPSkvTzHsCCi4vhDYq1UbFALSppxuG66oN7MDS1N5	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1407	1395	1	1	777	jwmUD23VEePyPrH5jfatkuSyY7bWsEUBZekgSmyrYnDjpyN9CSZ	435	611	611	1616049180000
786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1553	776	1	1	778	jxv8pSxnQXbMGowUu5ZiYvA2U17q4mhPujx1mRNc2B7Vx1RRzqs	435	611	611	1616049180000
791	3NKz6QX7UEHmVNHnYJTTUy1WdTRkdYcavz7xp1ZRQYZpXZS7ZgjF	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1402	852	1	1	783	jxe9XaHS1pTbqWNnrQnfq8ttH5v3XCbEg2XPNwswmsaj1sAw2o8	438	614	614	1616049720000
794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	793	3NLemXZYqAZPeD9D4amTGCD2B5EirAnPVB95bhBK8pc53qfFbSM4	1457	1265	1	1	786	jxnQaqyqVi3SNxhmXov693o8YD2De8N9f3UQUmZPBxPoGjsKxqc	440	617	617	1616050260000
797	3NKV2UBTH3iijZjFrjGydr8TAVa1tUqpgc6FJvjebutcPRvHyq59	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1403	824	1	1	789	jw7dD8iJV6jykoHw75G13hMWZmJtCujehk35zJzgqioSRDa433T	442	619	619	1616050620000
800	3NKKasi2HGN7jiikHBFuVUUxqC5c1XF4c8zcAb85yYZPfo5AarTc	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1657	1344	1	1	792	jxoh8FXs7osbDf4gxMGY6sK7brpRp8WHwv2ruoNmAaWakFGfxKG	443	620	620	1616050800000
803	3NLputsiGMDzCwHPUWJQ9HswrzGZ97fd58frY3kGdenXoocDTzeo	802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	1613	1349	1	1	795	jwErq1DYRPMVCrKUTbxneeNfcEfvMNA1QRPMd6oY9ScBKPhs8eA	444	622	622	1616051160000
807	3NKc7xg83z1Ee9cBnYEATz68oYpq65VPykE29HuRgVmWcuJA6BQy	805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	1553	776	1	1	799	jxodZ9Be27BRcFD363KCwtnUHmK9y1aXvWiMjVcg2LjHkAnkL4W	446	626	626	1616051880000
808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	1407	1395	1	1	800	jxZt9KC6SVCn8HEy2DWKETS5sFvJd6KvLfBsMc6F7cEyJQ16qrk	447	627	627	1616052060000
811	3NLwyuioYjzdrKeSZDK1RSuiqDar8SEejXv99D9JLriQx7c9WMcc	809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	1637	816	1	1	803	jxfkFti2fZ5gY8xwkqrcahSaeoUYyzGFKW2riuvGnhFbRaAzXxv	449	630	630	1616052600000
812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	1616	2	1	1	804	jxaWkNhBKiybXEVFVKtggM5xL2xfCzZ45v5UfnGGdERoSx5xqkW	449	630	630	1616052600000
805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	804	3NLv8ku1kuh28Wm1tCMPExFZ6Fu92w5wxHfWLe11BgWPjtwDikbu	1607	1348	1	1	797	jwMpr69FSV7Df2Lin6ssVRA5rAunoU8qSn6WfkWDdrqmfxu1BxM	445	623	623	1616051340000
806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	1652	1315	1	1	798	jxPuedTephU1tCHUZ75YA52D9atQ8yFBMH1aKkJA3Eg3GcNCuqz	446	626	626	1616051880000
809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	1477	1224	1	1	801	jxK2BnbdCvBGU4gzzSV68NrJuPgKAEinyF2be3Gak5JaTCKchKu	448	629	629	1616052420000
814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	1590	1174	1	1	806	jxV2zj4YrHvbNLgLPKRZzMoscJxCLpTkcPYFWCXQ4w88vDCbvbp	450	631	631	1616052780000
816	3NL39vLX2ZYvoekqspRtgzMQHJcTtPyLjHXfTyGpjLHgv915hZR9	814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	1553	776	1	1	808	jx1KfPB8MhR12t5epgpwK112hyst9BQThNc86VPG1oURzipKVp1	451	632	632	1616052960000
815	3NLjGGQ2SpxyQ3yv77in1un67vDCdfn8gShc7vv6DKYyGqL3zMJR	814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	1617	267	1	1	807	jxeQb1HptiMXKsDA9hcdXkHP1ZSzg9sKU42Le4LwrY3YiXqiwSu	451	632	632	1616052960000
817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	815	3NLjGGQ2SpxyQ3yv77in1un67vDCdfn8gShc7vv6DKYyGqL3zMJR	1607	1102	1	1	809	jwS3rZs3WJ983bCsfrZqPf29R2Vx6XKYUYjPcKVXMMW5XxwiDUD	452	633	633	1616053140000
818	3NKRzpw61KtCxYbSHVCkCjNWe1KX75S4wA7tAfvbed18rhCusuw3	817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	1609	1087	1	1	810	jy13aJ9W5rpPjam9Zz6MsqucLnubAvWBw9LnTYsRGHpsJiyNLF9	453	634	634	1616053320000
819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	1631	794	1	1	811	jwnNRc9zAG8JathRGz47VpmGcbSGhk2bg6JvnU8wZazCFVU3ehm	453	634	634	1616053320000
820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1458	1077	1	1	812	jwbL29nEUYnWZ6ndfd11WA6XPggHN7FZG1BfGwypbHnAaSht6to	454	635	635	1616053500000
821	3NKhZbEPUeH2JtL1LeDXWaiwEczaXBrjyERT23GD7GFaGxGogGBh	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1611	1215	1	1	813	jwQFMGk2u3zRJZhs2Rx69ra538LZMMoKE5AWjGEQkqJt8CAR193	454	635	635	1616053500000
822	3NLQCHMeEYTd2TCQpdcmiYpHhYVnG4GZDyNZCr2WSGGRGzsSHdhS	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1547	1378	1	1	814	jy1z44oNscHappPFFXADNikrrj2NwH17np6F1vjXWphM7VTjEUX	454	635	635	1616053500000
823	3NKRFSEz8vxt3rPxLwEtkUz7uyxciEcvuaRkz9e1AA2n6T3u5hEL	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1406	1393	1	1	815	jxNmQ95vAnwUg3c2wp9ytVZrQivw8hJqLRiJh1Ngfb9fRFZUrrB	455	637	637	1616053860000
824	3NL1heM4udhiLFLiuGHEiL2SD2kCy2S8aivA2c7S4gj3A2uyi66K	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1407	1395	1	1	816	jxZHQmce1bJ1edgZ9ZBUhvKsiRTqWbPNWNMBqYrYZPCVkCPYFh7	455	637	637	1616053860000
825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1649	1137	1	1	817	jwWuuUCqDJ485hiqtnvZkH7x1p6e89aTY4iashM6em5cY4EJRrV	455	637	637	1616053860000
826	3NLqntsuAKJQoUy1Rf7uczxh9YcaDXTR1DYqxNeJr7MBrRKxxAMR	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	470	1183	1	1	818	jwtCjriAugNsyhFb1z5RbQLZWZRpVRpMxjDwATrSUraVFAaXxHS	455	637	637	1616053860000
827	3NLiMuLVfUxmycU8pDeaEPk9cw1PRVkZfbxKRFXU67BZiyyCg4vY	825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	1406	1393	1	1	819	jxb1wiBnT77YohZ6ayt1rXYirkKHBjviEiNSumF6wma4BBaag6g	456	638	638	1616054040000
828	3NKrsKWGEKHJeGD5HVP2UvPmxXP92hqKcuTy2TR1h6PaC7RJNKgG	825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	1407	1395	1	1	820	jxBzgLSW9SVizwSG53B3JC8eUEQsjp1cSroNaatwLE1ojmhV5du	456	638	638	1616054040000
829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	827	3NLiMuLVfUxmycU8pDeaEPk9cw1PRVkZfbxKRFXU67BZiyyCg4vY	1406	1393	1	1	821	jwGxayhnCCp7tP8BinYopBc9P4BjR54pA7QsFJZZLMNyX7hMPph	457	639	639	1616054220000
830	3NLCiCbJBf9RJ7RiQpBvUduFy7TxuTqGsrNChZTn6EWbPgWDkK3M	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1588	1146	1	1	822	jxiTETj1h4YFWk82fgA3pTY6LK1mSvR8uHPaoiJcBw9UsB9N7vg	458	640	640	1616054400000
831	3NLG91jsNFsFyEh1ySES4ueM7CmUojgvV8Bzd3RUtCRnad4tj7WA	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1553	776	1	1	823	jwEDjr8z5Ft1nuruNxe6HvGE6LUbEw7zzes3gvL3KvfLceGMwSu	458	640	640	1616054400000
832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1637	816	1	1	824	jxRnBgfZWgcLStZmnfNWJtf2ZJKFJqC2NFdxt1SL8PY8GDZqCvJ	458	640	640	1616054400000
833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	1573	952	1	1	825	jwH6v36AboFkMWiCDKdtWSNMNATf6hgEPEhVz7uWxW7BAxjz67B	459	641	641	1616054580000
834	3NKT6TZ5h7WdycDbqRbu1ZMEVbfbSb3bWRGr88LLNHF7RANvPSf4	832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	1561	3	1	1	826	jxjroAMzw2r3DEs345GKCJjhDYUK7ceN8UMgcPnkJQe6KyJXGeQ	459	641	641	1616054580000
835	3NLovJvnbkSkYP38JZZgC46GHuXcVDnhtMBoAPh8ktEQGJ2x9UHo	833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	1643	1053	1	1	827	jwU66KbTFrrAmbn9pHCNWBFSGUsZXjknoFfHWHCGivUtK1wA84K	460	642	642	1616054760000
836	3NLTL6uwMERP1buYg4zGVeDFqfjCgHJCDL3av9uJp18d2Noxso83	833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	1581	778	1	1	828	jwxQ2PNNSFEEBtQeGjZSFdaamGjSwpC5WM2RsshZewNA4GfQ8jm	460	642	642	1616054760000
837	3NKxfdPqfUDKx6HM3R2JiCNYQfTPyz49QRRMuJARgZmaxmNrbTux	836	3NLTL6uwMERP1buYg4zGVeDFqfjCgHJCDL3av9uJp18d2Noxso83	1654	1340	1	1	829	jxKQVoEGzRettAHxKQvPCcqJpCB8aS2ToGi82cVXgefUpz3fiaZ	461	644	644	1616055120000
838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	837	3NKxfdPqfUDKx6HM3R2JiCNYQfTPyz49QRRMuJARgZmaxmNrbTux	532	1303	1	1	830	jxGzZ7vhzEx3mzRjWmzLis63QLeYzo6YuZAVuJRtSLfpaFnhYKD	462	646	646	1616055480000
839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	1624	1334	1	1	831	jwUwJnbsPFjMggnndYeyCsKX7ayHZ11XakRmRoahoJFmfVaWz14	463	648	648	1616055840000
840	3NKg1wTjvcyy4nugVzc2Fhv4LX5rT84eS5fZbQJqBJQ1rqdX89nW	838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	1483	99	1	1	832	jxq388nxDMJ7aw4bBXG5FetqCe4J6mYJWoBU1cooES5NCXsf4N7	463	648	648	1616055840000
841	3NKS1B6tzRRhTYEZh5AaA2jRx4M9kvFfcKU6W1vsUP37Aq6LkfwN	839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	1406	1393	1	1	833	jxxVosqh3cc1kVfgyEJknHcD57fcue9TDL7E8cdZzpmCtktXh1v	464	649	649	1616056020000
842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	1483	390	1	1	834	jxk8tR5dTwusq4oWESRLEQbFAPPxiTxBm1iki1hjdFrPBgwdtNC	464	649	649	1616056020000
843	3NKpMmwatqrbVmvAY6QJTCUbDTjWMeHSpRCbq8hvd1noEqqYoGk5	842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	1457	1391	1	1	835	jx1xDdrcFL4nEqzyFiPpp6wwr1UD3orcgvvw6R5xx8s5Cma5khn	465	650	650	1616056200000
844	3NLvqdksbbFRj1YadGy6KRmSebjdkGYmmCafADUEDd1mVPLmwLFE	842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	1481	789	1	1	836	jwNrG5cGpV2QQtqGriTi1ifoCpKybNWJNFBFbKUr81YXZiGfVjx	465	650	650	1616056200000
845	3NLnHYxj469cZkJJ1BThw34dBu6GRbkTznTx3uoXJbUgoPBPK1er	844	3NLvqdksbbFRj1YadGy6KRmSebjdkGYmmCafADUEDd1mVPLmwLFE	1585	1240	1	1	837	jwYrmVjZ1eaMAb3b7pbCYAAYmf9i8W1yJYzkmHj28rTsH43Zdxn	466	651	651	1616056380000
846	3NLyDDhQRJiz7im1uEf5RtervXUCan6YkMVVurEEue1Ap6G8PUu7	845	3NLnHYxj469cZkJJ1BThw34dBu6GRbkTznTx3uoXJbUgoPBPK1er	1407	1395	1	1	838	jxv2yzhSGHKXcofTuC8rRhSuXFqoNkFqdyynhzimhxtkVoai5QY	467	652	652	1616056560000
847	3NKGrXoMpZSYSoNxeHoft1iVNUrKkjGAtomxyXjST8ajhWjNi8hy	846	3NLyDDhQRJiz7im1uEf5RtervXUCan6YkMVVurEEue1Ap6G8PUu7	1599	1041	1	1	839	jxR72P4bd9xZhxCmYMQ3pryjshMwkZyPb4Rton44VkwzicuaQoF	468	654	654	1616056920000
848	3NKhfcwMXWxSSKLkFbWsYv6rssEw6xNhQZPMDW32zZBFghBUJJ8g	847	3NKGrXoMpZSYSoNxeHoft1iVNUrKkjGAtomxyXjST8ajhWjNi8hy	1406	1393	1	1	840	jwAptmyLSd5nwAv4MFA4FLRg27DS5H4qBxJ3R4h6benj6pjpGBm	469	655	655	1616057100000
851	3NLQCCAsGfWCd4EaLrLncAHMZwBTzPRDVNGZYFQtiJ4XeZowpHz6	850	3NKmKacb8QGKU5h1L1r535ZV7rJ7eTn8dCMAf6pySFVv2ngWPYnL	1564	972	1	1	843	jw8byb9NcNyLT8v2bM9u2uxVYpzHBGqfg8jcQALJhNsZNS3C5h8	472	658	658	1616057640000
854	3NKp5FizKdGiXww4ANh53UxQLuhdyVUWa1XXD1U7bMF9intrv29L	852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	1541	1052	1	1	846	jwjRmUnt2bgSS8PLP7bxeLzHUpNUHWVgDWwLSnwL27zeGvZGttw	474	662	662	1616058360000
856	3NKuH14r4KJVQUVbsDmgA644uJL2d6gvPqPqDPjrKn1NBU8v139R	853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	1476	1371	1	1	848	jwe9wD5PQoMjizPK5Gtuw2rWuXoFbYTMEqSVHUk69N5PtAuLLk1	475	665	665	1616058900000
857	3NLedkwGqfhn1KkWtunVPvATn7krYSnWDuHab6RxfPsSRHbv2Lp8	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1651	1055	1	1	849	jwRWgy2F1Mj6BGyypnHqHMyV738aPNzTveeZpnLwdyYn7ZmRgKG	476	666	666	1616059080000
859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1573	1192	1	1	850	jxYbvYvinDJVxQkFsnykgUrzdEFz8xWH9go89HAc6Nod5WKYAZw	476	666	666	1616059080000
860	3NLtJB8grjunVZesq4GsfUK88Z9sfXarNYBBfi3ajm5dCd8phukU	859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	1585	1366	1	1	851	jxio7VKt1TtKJi69jS8fvrzvJsREQeYGk3MA2LgWeN3Zr2H1fmi	477	669	669	1616059620000
863	3NKFnsJcV1vw13JQ76zEdoymhGNa51yfJfGe5WFifSw6tiCYFDCS	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	1405	873	1	1	854	jxaXREtuBhE9hCUYh5qXjSX8YXdpPbnoXbfN7FmZxL8Rwv8XgPh	478	670	670	1616059800000
866	3NK3b9cjS19xtShY6HSX8ztWPSfjLVzbkGhN8YtgiwgkbHSnMiRw	864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	563	1359	1	1	857	jx7MLAQPEj71nXNgxkpKu2Q59YJtgQDfBgmtateUsgZJ9f9t5M8	479	671	671	1616059980000
869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	1593	1220	1	1	860	jwZNX4CXiSYwR4tj8Fz35AEzUqeA82VxbgLgXhYZMY19ME7aUXZ	482	674	674	1616060520000
873	3NKfgnZaAUh7wbk6FNvDKSeF6VbRTLmVXXQmX3g9Q2xgRUFaQWW3	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1536	1313	1	1	864	jx3GdXqrTUwBecq8xVvX7vLheD4u4agnZmcVpcgqda9YTBeErWQ	483	675	675	1616060700000
877	3NK5jtZLo3tRmpGXD4cYunDtRiZirv2PcVnCGqvdDwdCYDqFBo8R	876	3NLvLBVZ7Z9QR3jX1NAgwPrKueYVkDWZfoy9oKuGAsBqLdJwXPTJ	1654	1094	1	1	868	jxqGFsYfnF7bbAt26GDaxzWMSqdz1YueqNRF5YHLPzMRbwmwhK2	487	684	684	1616062320000
880	3NLG1f32AeBYUVpHz8Ms8tdbEPwusd69mTF2EfyAP4J9KMFUjy6m	878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	1422	1337	1	1	871	jxkurxWdirwHG3GgNQoJgxb2z1UxF3WSihwvTqT2WG846LjeVps	489	687	687	1616062860000
883	3NKSDC2Y3R5KCmq3CHV8aLGQfu1GMkW1fWm8VBG7ypbxQvkx687r	882	3NKQMATK8ophUKZ1imjmbzmn6UAs86yy7dK6fivi84swfkyokqCi	1637	816	1	1	874	jx42BDw6sgmtbK9sKGC3EsrvmhztMcW2JFTowZZLz3ZEesy9YMd	491	689	689	1616063220000
887	3NKULx437jYfTo3PEh32nK46pGoeybD1RuM71KSoS6EK1A93GHyH	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1516	1168	1	1	878	jxJf6zyiGmMAgGtdpyLij97y3jrFJh3ANJ8qoMuYZDr3qjbfHCB	493	691	691	1616063580000
889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	885	3NKj3XovsHpw5rDvdoQgoprCQ9BcNtGDhRvUdEqNbSrPSwSz2ZWd	1585	1120	1	1	880	jwyFMwk2TMV66EDjd8BL8ndMEeohbNpczbiewpHasGWKFUJZbj4	494	692	692	1616063760000
891	3NKUgAF1Mw2rGgtk9txf5H9hZz4Eo5e8vi8QXjtB6gicvykrmfZf	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1536	947	1	1	882	jx6qTZmxJFd1XCHLGULwPbXQtBLCwHmACZzY7s7h7YUq9EouTzQ	495	694	694	1616064120000
894	3NK5YxxLBRfiYeCxhviSxsCVCtQZedXnwh4V1BwaAp6XKh83hERD	892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	1407	1395	1	1	885	jxEnxU8fqpvsYW1TYkp74Ay9VUfY9xb5eT9VMd9MV6Aj5KF2LMf	496	695	695	1616064300000
895	3NKwbWe4r3f1UD9iuvt4dK6QwtZJWiR3jy6puErT3YKHzyyUgCyM	893	3NLDVx59XjQJ7Jt5PtykjeaicVoK9Yh5hUUnivD4MaUMZmU9mcTR	1646	988	1	1	886	jx5TN8yZAqd1YHEXggp95ZbQDCBk8iwKDSgLRz5AioZkBtFAL4N	497	697	697	1616064660000
896	3NKiCdmgaobCiiNgyhi8pAVq81r6z6rxq4P9FVE2zJpA9R2ppkvB	895	3NKwbWe4r3f1UD9iuvt4dK6QwtZJWiR3jy6puErT3YKHzyyUgCyM	1509	1194	1	1	887	jwZcyKNb46yJY2XaGKR3yBwx5PRcK7QJUkgZAHgdpBQ3t3CJrsT	498	699	699	1616065020000
899	3NLf7x7odrpc3oRogqd6ZD3BMy4sbtu5Szdcsq4f7ofxwWE7oWLZ	897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	1637	815	1	1	890	jwn4xcLgAB8BY6FaxJtVqy9pN74bqxfxDrT8vp51HdFUJwHcBP6	500	701	701	1616065380000
902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1448	945	1	1	893	jwxHdgHMW7ts9wZg8eMujgM6e85mZGzsxCagX1KYbgDrAc5hEm7	502	704	704	1616065920000
905	3NLMCuqsm9y7dG9tx6iPp47wpMx7qNVPuGEohpcE82PMkDdkPUQx	902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	43	1310	1	1	896	jxLAkWb1oE33o58kJXrjzUiTT7WCfLR5cYDtigYpikHsaDNaXMh	503	706	706	1616066280000
908	3NL2CMP8VurBrxRuB4cvaqF194aGey9M9JM2dQ96heizMgNk6QNB	907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	80	1273	1	1	899	jxY9BZQWXNzR4hRqXG7wQBxGeVXrkF72WMJtzvg1kEMn6WcHHgK	505	708	708	1616066640000
911	3NKv3cHY159cXb7xcLbWx86xongyhgxHk5X6kCceDSzQr2CGPYK3	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	1622	1356	1	1	902	jx4d4WiGmL5FcJCY513DqTJnhySgrn1ZbxMEBFoVN5vRKP7z7MH	507	712	712	1616067360000
913	3NKXV3hcouKBdktSM67UZkqXYppqp4wD57jtftdHrqZQ9cgoU98R	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	484	1319	1	1	904	jwAWp1A3d2PyNB9mRayAdcXKs8GvA5ks3QmKmwfbCC5dok7um3t	507	712	712	1616067360000
914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	912	3NKft7qRgXvzVVt5NNWuVfCAaviK3iCP8KchWP3BBBdaxFGvBzXt	1407	1395	1	1	905	jxSMPL8r9MfT8bd7ei4PtA4Jzhs2NrGgozZ8WXxSzYZeuQEHauF	508	713	713	1616067540000
917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	915	3NKEkxjT4J7X4aRk1qQzVYrjMYyJ9disvD2iuNhXpzFkFtRKY2KK	1407	1395	1	1	908	jwS2zVMiaeKACSG37rek3SM9Dv6dHGgPkJTMhbq4NR3C5cqujRk	510	718	718	1616068440000
918	3NL5CbVMLJW9A77MJhSH6Eu6oRoGhvgwZi3eNnfUiVgW6FwxjiYr	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1403	782	1	1	909	jwXDcFuxSsyV8jxiCsH1cChuMwj6tw2tHENRRW35WiaKZwQSkcV	511	719	719	1616068620000
921	3NKk3meAQka7pygkcMLLGDeudCFnmrS59LioDqcukGGQiVcZAHbp	920	3NKD1BxHLCkvgjh1GuCf3uHew5QvYs2SGRePwWXuJJurDNp1bQh9	311	1307	1	1	912	jxZD69UCPB9FRPKDGv4Qh5MdFTKLCK9yFEqpsZLBeHe323wvoyk	512	720	720	1616068800000
930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	1402	868	1	1	921	jwFLd3QLQvL2PenEk9HQuNvXFU17CL3CnBYL8PChyzkpN3wR3qG	518	727	727	1616070060000
933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	1407	1395	1	1	924	jwz6xdHDsjw8HCr5oenYaWJoo6euT1fE9ZXiqoXUByfaM5iRE7e	519	729	729	1616070420000
849	3NKu5H5prn9ftZsAQAoSdoWKr6iPU83eLULqddqYgXkaFESbMdDn	848	3NKhfcwMXWxSSKLkFbWsYv6rssEw6xNhQZPMDW32zZBFghBUJJ8g	1656	1343	1	1	841	jxyaZXeWRdYvqYaaKkHq4ipdMepkUSXNRtY3BAw82RFUqAbVisQ	470	656	656	1616057280000
852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	851	3NLQCCAsGfWCd4EaLrLncAHMZwBTzPRDVNGZYFQtiJ4XeZowpHz6	1602	1369	1	1	844	jwX82KZ496YaaXztWPxmRCYPfWpzkv62ovDXMr1fDK2Lr8vxkYD	473	660	660	1616058000000
855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	484	1193	1	1	847	jxs9Z8fTBcHTBWJCENYQedSFZbFWVB2QeUrsGi16xbRkUfd3BXP	475	665	665	1616058900000
858	3NKFrJkjX3Gb6zA5hZspZBfwm9dzuGEdn3t8VRytiZ4YFGYKxvqJ	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1651	1055	1	1	849	jx3HMZy1zukpuzGgmjjcACJP28r8ZNjuCfBgat7UEBPgZiV8kDx	476	666	666	1616059080000
861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	641	1090	1	1	852	jwoYCMNoMaJrVQQnNv6vLum5GyyrfzXDETuBR3KJHcZPkmdh8Kw	477	669	669	1616059620000
864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	1541	932	1	1	855	jxTgHTy91MGMEUmvmzM5iVKeJZEr5VKwMLQyHagrH8ra5ByHnz1	478	670	670	1616059800000
867	3NLBQQ1SYGvVYahiTrjjBZv6KwiMkrVfc5Q48qPe3m5GtbnHCQvk	865	3NKLM8bt3Y4peQETFBuLpRR1jR31nEUMGjn26Vp8fJMsPAvi1UPQ	1460	1324	1	1	858	jwBPZ4LaMvXDRXxKUdKAWSsowZA8igL1DZqPZAA4bFEWvrYjB3B	480	672	672	1616060160000
870	3NKUVUiB1DrDXPDtpRk5buL42h2LSqwwiF7tdnePnzpNcvKobV6N	868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	1637	816	1	1	861	jxepCWqHeNwwzRHiwAc6PGuJSihF4MbMoWyFcGmnHmFXseW1jvh	482	674	674	1616060520000
871	3NLkBH8bBhMvtHzsSMgm6ctaMsU5ZuBHrHfZ5VEUVkdhj467VBha	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1406	1393	1	1	862	jxyha7kA5QPFQ2CCNh4rCCHdfTM7KaGivXZWHJd4yQgK4uRjbBc	483	675	675	1616060700000
874	3NKXbwgjHPjpyj762DJcFXfuNDfHbhMWKHefYDXXnCAf7A1jxUFJ	873	3NKfgnZaAUh7wbk6FNvDKSeF6VbRTLmVXXQmX3g9Q2xgRUFaQWW3	1581	778	1	1	865	jxcnHt7HSgJV4Pd92gGwk3kVyYC8i7tLdqrwCBK5AkrrdJBnw1B	484	677	677	1616061060000
875	3NKTWV8ZvNg8MZxg8CB4ArkxW2rm4w6H4dTRCwBRVHThtzkdUw6j	874	3NKXbwgjHPjpyj762DJcFXfuNDfHbhMWKHefYDXXnCAf7A1jxUFJ	1407	1395	1	1	866	jwi8JEP5dMTbGpdpnTCDxhonNrEKrvWEVEAMUR35AEPT2Spwm6W	485	679	679	1616061420000
878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	877	3NK5jtZLo3tRmpGXD4cYunDtRiZirv2PcVnCGqvdDwdCYDqFBo8R	1407	1395	1	1	869	jxazEx6X99iwRidign8SSvRb5R3QXP3fVTu61ELVEE5xJRgYNEy	488	685	685	1616062500000
881	3NKXeqKonVwqYSVj7dMmLiAQezVSKhqtj1M7TVSdp3qxrZDcCRvT	879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	1578	556	1	1	872	jxMbgsJdBRY3pJtQP1yuCDNQUSttWvoqRVFm9dvSrRWbgfTFWbt	490	688	688	1616063040000
884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	883	3NKSDC2Y3R5KCmq3CHV8aLGQfu1GMkW1fWm8VBG7ypbxQvkx687r	1600	1126	1	1	875	jwntVNSxVeVr3NuXW57x2rihcjcA6gHmVHpZ6kntCSye9nUQGhU	492	690	690	1616063400000
886	3NLoCtV1hrynWYCXq26hbJAawuqxVQx2PV3haxADSYiAxWREzoMW	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1637	816	1	1	877	jxGxkxmqb1f7KYbQGgESrXgNdqDttUYbBdiFeD8x5Yw48qNB7dx	493	691	691	1616063580000
890	3NKMNLsVydsyhKZPvKtWPZh51zjoG11LLQQud8wGEjmWGnawKgrc	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1402	852	1	1	881	jwDyywi4u9CiDFxtkcYzoXQRZhHB4nrNFn1mGijgc3fRGyTV5Pj	495	694	694	1616064120000
892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1600	1372	1	1	883	jwfMYfEQ5mJpBV6YvYkUzfRKS7gFfSvcr5hBsFjyxk93bZZySbk	495	694	694	1616064120000
893	3NLDVx59XjQJ7Jt5PtykjeaicVoK9Yh5hUUnivD4MaUMZmU9mcTR	892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	484	1319	1	1	884	jxNi7ZDgJXUgj4iYGAG4N386oDZ3NUTiLJHwS7QLYxatSqdfgHC	496	695	695	1616064300000
898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	1406	1393	1	1	889	jwZH2NfN2gSWoBQYFAKLkm758U12fjRYDdNjjtN2DYuodQt2P7w	500	701	701	1616065380000
901	3NLSVoawFQgz5k7BPiKoMuJEL1Xvj2GxAF6HvwPARGncuHWEx1MZ	898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	1637	816	1	1	892	jx3F6DkfB653vjusy6nVaa65hb2NV1VVf9vt42jDYtFBre4cEin	501	702	702	1616065560000
903	3NLWknmWvFvmKNjuAYczn9P6Vk4wrTvNE5PvdRhKm93gohyQnha9	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1405	861	1	1	894	jx2E9Kx4MMp4ERaHt65C61JwjNBE5xeGH6pzPFCkfFjuuUBekqs	502	704	704	1616065920000
906	3NKqoWT8YdR3WXkSaGDDqe2sBPcPu6uN9XGc3W82Z5JxzBk95pXV	902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	1610	1188	1	1	897	jxqatDkwzHp5SaMXE5bfRdyCogWTw7MwwwvsemdkvBbjbUF9qxU	503	706	706	1616066280000
909	3NLeSw2agsqZDtnu1DXvqGTUdz2ofF1F8gSUEABGuEsWqSz8JnKD	907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	1637	816	1	1	900	jxnbYo5UF9HgRQ9ziioGHQ5MQmf4ZrK1oYLjViWApvoKXk84v7q	505	708	708	1616066640000
915	3NKEkxjT4J7X4aRk1qQzVYrjMYyJ9disvD2iuNhXpzFkFtRKY2KK	914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	1405	851	1	1	906	jxjwsxfWYNbzJ7ov8FmahVC556XXRiKs5wKGHQTpgGLwYHiZe2V	509	714	714	1616067720000
920	3NKD1BxHLCkvgjh1GuCf3uHew5QvYs2SGRePwWXuJJurDNp1bQh9	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1553	776	1	1	911	jxmWAYXvnrWqU2wc2fAo53pw8RqXrq4HiAnA6mYA8dx3zw4yxzX	511	719	719	1616068620000
923	3NKZBAx9CNXjwoMSZDwE6S4PArnQfhtrG4iGwBkps5hTwwgVMWMN	922	3NLy8Y2CnVrgqVgbVNQFcp4ptMHt6wVqT1Nkwe4y58gZhGdHUHUe	1500	1171	1	1	914	jx7ZvEZA25exhwzG1oZek747wvfE95dLb4hwk138N9RWACchioQ	514	722	722	1616069160000
924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	923	3NKZBAx9CNXjwoMSZDwE6S4PArnQfhtrG4iGwBkps5hTwwgVMWMN	1577	1327	1	1	915	jxJqUwJnLkquco2fmLKNKHRiM2XPbA5FAKQnV5UwaHzh3K4U8wv	515	723	723	1616069340000
926	3NKnC1EbEVrwCDia6Q2A98pSDjewANXDaCjd2a4sfiaDzvvCYHkB	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	1657	1344	1	1	917	jxwmiUuEaSB3a7xenr8Ca4NuHEh2BTFDc7Fq3Yc7JL5LNLumwC1	516	724	724	1616069520000
928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	1447	1345	1	1	919	jxyZcPs3uyBzfj3Sx6ixFsgfKhWLfYheeZBVS6QNNqqCdCHYn5k	517	725	725	1616069700000
932	3NKVdjxBvPj5HAUM1JuF2m62wv1hHDh1seLgM5k9txBkVPeaYDGf	930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	1523	1075	1	1	923	jxv6Ry72AUB36ayNHDtkRtRi6cEc37ifPYhtC1cennJzwW1BFeF	519	729	729	1616070420000
935	3NLqhGP9YeoRk8J4jwEooHBBTqD7P1HH1Jnrry16NT7zBRPeZk89	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1407	1395	1	1	926	jwDcKyE5bkvqib5J5hUHgpkgo384D2JpJXCNYvRmviZPVdtWgu6	520	730	730	1616070600000
938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	937	3NLoqBuXvxfXg1uDC5Cw7YXnvnnjCGfUDRtefh1uNg3T4Zego1H8	1608	1289	1	1	929	jxUVL9V3B4myExDTRwPYL2md4pHNyUU4B6YZZjaGKZ9uEbcZaCY	522	732	732	1616070960000
850	3NKmKacb8QGKU5h1L1r535ZV7rJ7eTn8dCMAf6pySFVv2ngWPYnL	849	3NKu5H5prn9ftZsAQAoSdoWKr6iPU83eLULqddqYgXkaFESbMdDn	1516	1294	1	1	842	jy2GE6vYNuzYXwuvGpSMnCHJSo6TRyGJHq5Fg4pohUeHXxriDa4	471	657	657	1616057460000
853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	1559	987	1	1	845	jxzmM1M2amb8yDswYnTsANHNwUBBaA25Zxo1HhhAQVMLhgEvqFq	474	662	662	1616058360000
862	3NLtPCCnWLPFiW2pCKTsets6Gxa6uF67jPbT3A6pYcs9Z5QJG4QN	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	152	1330	1	1	853	jwsYjaCtoHjrWKEWMFL68AuiSE3kj4fXEnc9uNMyrUCUG2asdU5	478	670	670	1616059800000
865	3NKLM8bt3Y4peQETFBuLpRR1jR31nEUMGjn26Vp8fJMsPAvi1UPQ	864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	1451	1046	1	1	856	jxUCjN61P9dYpUYCt2YXC8frTSgCzgmrjcAXqCpzEtDuPckgE8h	479	671	671	1616059980000
868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	867	3NLBQQ1SYGvVYahiTrjjBZv6KwiMkrVfc5Q48qPe3m5GtbnHCQvk	1518	788	1	1	859	jxbEiDPBeVQeTqQag5gUpR9H2bgTooh4Me8ie3yLi3CfpZhN9cf	481	673	673	1616060340000
872	3NKhkDHAaQnaQcJvEQHmzEwuD64oj9yKmVCPHWtAjLK6nZkwZoz2	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1447	1345	1	1	863	jxKLnd5VHPKed73hvHfYVCEWMr4n8ZvTvrHyQkxVdDwDyGv1RL9	483	675	675	1616060700000
876	3NLvLBVZ7Z9QR3jX1NAgwPrKueYVkDWZfoy9oKuGAsBqLdJwXPTJ	875	3NKTWV8ZvNg8MZxg8CB4ArkxW2rm4w6H4dTRCwBRVHThtzkdUw6j	1602	1123	1	1	867	jxX6zRrzuRhmCmEeMn7WtWw73Zbrj8do6u259Y2Uf5aBkHwMT6C	486	681	681	1616061780000
879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	1406	1393	1	1	870	jxKrqJkopK7BgA1LaK26XUhecQZSbFMKSCsPevMWbwvK1eVz3LQ	489	687	687	1616062860000
882	3NKQMATK8ophUKZ1imjmbzmn6UAs86yy7dK6fivi84swfkyokqCi	879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	1646	1108	1	1	873	jxpAb2qPXU5Ru94cdMSxVR4yLRQmW1RjdjLh5mFC1Um38SQcJbC	490	688	688	1616063040000
885	3NKj3XovsHpw5rDvdoQgoprCQ9BcNtGDhRvUdEqNbSrPSwSz2ZWd	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1534	1317	1	1	876	jxMj6GVy6wx69uuApYVWip7tw3zndtPiMLYh17up1ciMbbd65YP	493	691	691	1616063580000
888	3NL23fDxeAgdYPMPZUyy3C5ygfLuaeg3s936p57iqsXYQ7GTSCmQ	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1513	1379	1	1	879	jy1zT5dXhY83555jcxUid7SE8wSiY94nQYneEwxCMVemR9k4mAn	493	691	691	1616063580000
897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	896	3NKiCdmgaobCiiNgyhi8pAVq81r6z6rxq4P9FVE2zJpA9R2ppkvB	1406	1393	1	1	888	jwSB4KnhSfcZ1UJfUqCjzMwfKQaaJiRXYCQY6bTT2Metw5pmQ76	499	700	700	1616065200000
900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	1406	1393	1	1	891	jxrFn6gABcmHtLASofBwRvfmAPUyAvGbvCCHnDveVdi4FarLvQa	501	702	702	1616065560000
904	3NKeVDxfgM8yzWvnz1bWv25czBwTXZnu1gah3UYkig2QN6gKf9YC	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1406	1393	1	1	895	jx4uCdwtZwbf5hCnBHPMU5ZHapXEofEFdc6XNWJp8y7fkRf8iEM	502	704	704	1616065920000
907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	906	3NKqoWT8YdR3WXkSaGDDqe2sBPcPu6uN9XGc3W82Z5JxzBk95pXV	1406	1393	1	1	898	jxeThcwmYNA5PkeB2HaiUbFKHcVPstvznCrWzPYkiDgXA6L3nwj	504	707	707	1616066460000
910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	908	3NL2CMP8VurBrxRuB4cvaqF194aGey9M9JM2dQ96heizMgNk6QNB	1402	852	1	1	901	jwciaMzgKLagKMHk9Jo737ekP96hBo17n46XRitNYLMfgQ5W42q	506	710	710	1616067000000
912	3NKft7qRgXvzVVt5NNWuVfCAaviK3iCP8KchWP3BBBdaxFGvBzXt	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	1670	1036	1	1	903	jwvKjDco4pKLSkqk2NHkBrzZCayCSWGCu7PMuEmQiZg5jYJq5P7	507	712	712	1616067360000
916	3NKSHBw6pCWQNeQ6s6ZMLV6n7vGmXd7HGvbhRSGqHwpbZLaLY8Vd	914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	1560	1291	1	1	907	jwgP2nMDp3dVF1zK5j7BSFuk8wpbTFXDE7v5F4wqXK2dfDZy2HW	509	714	714	1616067720000
919	3NLva9AFEsndKt8gkTSaNyfE3wM35PE58ZNMAoPw3gyAp4zmtoSc	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1534	21	1	1	910	jwHYSsYZefTNLXZmsdJ4f9RzhAthHmepiyaRceS3EH9RLGs6Jqq	511	719	719	1616068620000
922	3NLy8Y2CnVrgqVgbVNQFcp4ptMHt6wVqT1Nkwe4y58gZhGdHUHUe	921	3NKk3meAQka7pygkcMLLGDeudCFnmrS59LioDqcukGGQiVcZAHbp	1549	1116	1	1	913	jxS3oJFoesFDaKahtoAzqAJQ5nUA84P8bZoAqQ2EqamsNg1jhWq	513	721	721	1616068980000
925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	1457	1145	1	1	916	jwDfqr4Azup3a2sH7y8BtNXXw4rcJj7KbNkhUjiui2troRio15i	516	724	724	1616069520000
927	3NKMkY4SaGmrMbYFqwJqLT9n3Tu2GzPCQ5E9sSMaDP29QKrEAgF1	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	69	69	1	1	918	jwGH5Fg1RuUJGrV1ESCVw8ZpWuM3v5ip5wjij5DNwQhXPn1xxAb	516	724	724	1616069520000
929	3NKzfTsZm7KA6ibBBJT2aFabFBhaXpjHHdKqn2wPLSMaucGab3gs	925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	1407	1395	1	1	920	jwUFBJCt6vXzbvoJZ6R69Sq8ibvdU88egZb4GBMPMnyZ9oFdAoF	517	725	725	1616069700000
931	3NKpVKaUdKpDLhgBHW5UyEgVai4p8QFtCgqN51GLvHL9MKYvhtg2	928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	1407	1395	1	1	922	jxRQXPXQJ4L1xgr9viTS7pLdvtEq8YhHTXAGJ3FLnT5ATu41g3U	518	727	727	1616070060000
934	3NLBEcYy3CuWgm3AiTp3GS55LSFEpySvupKzTe3BsXMBUortHQ79	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1406	1393	1	1	925	jwkuwEUM1z9w6TCbVCuSgSHpH9CHcJe6pL5rK7CAmZx6njLxYMm	520	730	730	1616070600000
937	3NLoqBuXvxfXg1uDC5Cw7YXnvnnjCGfUDRtefh1uNg3T4Zego1H8	936	3NKZjiju1xQSqFodEwgPvANaTcY76FnAeLWkyMBAXBHjZo9xhyLu	1610	1068	1	1	928	jwjbUbeMdzduzBfAFLarXXzHfLVGsoQtrbquytDZaMNo4Ff7s8w	521	731	731	1616070780000
940	3NKXyQgmTD4icPVcyL56LgsUAeNLzJc6Dq3uCUpFHbw6zesRybqT	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1406	1393	1	1	931	jxMsRV3WceAkd6eR1bCmgSUVTyo7HzBvYPg8ckWDYFbznHWpzUh	523	733	733	1616071140000
945	3NKS2cWFXqDNBokqEdB7VmSydEGei3hYR2mChYAr38xnCPwgtjLB	944	3NLsgAq9Dq18xX6P3ZFuVoP6TpAfznmoZ9MhoDjQ2ecMtw3xXHTo	1406	1393	1	1	936	jwNTjXzrpckkYtU387wKJXVbFmdgMX7h5uhUNu2XbD7bUq8UDsy	526	738	738	1616072040000
936	3NKZjiju1xQSqFodEwgPvANaTcY76FnAeLWkyMBAXBHjZo9xhyLu	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1566	318	1	1	927	jxLcrtETu3ScH1zEgcCym6EqqzgB6DtU6Dihz8oUhejcZcrmR3V	520	730	730	1616070600000
939	3NKEipCSVKUDWV3EqTxJB496opY2GB5SWcJZtqz4TkQTF8ui8YCt	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1403	824	1	1	930	jwr3NwLihHGAVFuvdrFkaUwUja8kBWTJJk59dvCapg9zZq2S6HR	523	733	733	1616071140000
942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	939	3NKEipCSVKUDWV3EqTxJB496opY2GB5SWcJZtqz4TkQTF8ui8YCt	1581	778	1	1	933	jxNAkBKhYi6MqbBD13coq726eye7XaBPPt8gwitThATR5EGkGZg	524	736	736	1616071680000
943	3NKbDmL2ZdnujM1aabrFF4dDzYx6kfY8tm2pqJeeV6zS93MqWyjd	942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	1407	1395	1	1	934	jwNveBsUurUb6Aq1x6G6M2W9UUJuLTmVX597NQCvrPeXCb2ikG6	525	737	737	1616071860000
946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	945	3NKS2cWFXqDNBokqEdB7VmSydEGei3hYR2mChYAr38xnCPwgtjLB	1406	1393	1	1	937	jx7v1JSi9xfAz8wLsdxZUaCbNRDJS3tYGs2T31f12d6km1R5koa	527	740	740	1616072400000
947	3NKREjfwpjSmdro47F21noeUya8EE9hG95CrpFBH7Dt58tHimdTZ	946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	1671	1365	1	1	938	jwEzjnUGFb4qcm3jwVN2jRnEPadq14ZcPLj3L7ibqN364hRz6Kg	528	742	742	1616072760000
941	3NLCi4aEr1uDw15ymUcR64iHhaXhu4qDT86HMFbYHibX2i64XwVV	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1619	1275	1	1	932	jx4kiqqc6w8PUqJdtNTAZB3ZRewLb1g9ecdV2p6DXLFrZGk6unu	523	733	733	1616071140000
944	3NLsgAq9Dq18xX6P3ZFuVoP6TpAfznmoZ9MhoDjQ2ecMtw3xXHTo	942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	1623	830	1	1	935	jwGGkxAoLgwHCTTEpvbYerGdnGhws2zdo6bnHdV27Gfj2bU4toS	525	737	737	1616071860000
948	3NLTbW3twbr3W8hraUWzvMu3mhwwEVi5i6o48rSGVpTrtVzxt5UY	946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	1407	1395	1	1	939	jxCGXeuQtmGCWdqBHnx5xDSs5UsnbbQsDUDSBdYAjKsqvM6KnP6	528	742	742	1616072760000
949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	947	3NKREjfwpjSmdro47F21noeUya8EE9hG95CrpFBH7Dt58tHimdTZ	1656	977	1	1	940	jwYz91C3uSWQUuAu9RmR4MPzvMJKujCwW6rv12TRv4onZcd86Eg	529	743	743	1616072940000
950	3NLvc8Wqv29yz1ykmDGg5hVyXH1NFNzH3dGa8nydGjk5A7QG7kqh	949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	633	1384	1	1	941	jxr5NzmSN595sKKsojZQqNf4wpSas8FyvfSRjxG21UW45PGDxnN	530	745	745	1616073300000
951	3NLeWQrqkYG2794g2b4vECBeyS1KdrCkECDtcEzye74NNTMqnULT	949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	58	915	1	1	942	jxbEVfKaGLecNSzx2FBYMT9D1f2cyokQijtnoJsqvp9pdwyFyB1	530	745	745	1616073300000
952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	951	3NLeWQrqkYG2794g2b4vECBeyS1KdrCkECDtcEzye74NNTMqnULT	1444	1381	1	1	943	jx6Et3DevvZaZPirWURD48xehxB6J6iWS8FwWXYvczdrCJ3g1y6	531	747	747	1616073660000
953	3NLjfpxTVo49r5R2gFv13FfSyt1Go7Sr4qn9yDg46KcCF61dRiMF	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	1619	1029	1	1	944	jxQH6rQyjtmSBLhuBNdwAjbNGhH8xgtoDp1FCiVcXHAB5vqvW15	532	748	748	1616073840000
954	3NLs7XBvRHHJTZTYyin2oEarSVzNW6tV38Q8EDSHxD9K9gry1nWj	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	684	986	1	1	945	jw9VGaCx2tBr3vaeH4ArbretTxBxr6GwoFwwUb72TRazLoeST8C	532	748	748	1616073840000
955	3NK3u1YSK72RVDoLLaAGW6Yrk9WPka4XYMEnydJvSS32V4ZcEGLs	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	1581	778	1	1	946	jwAwU7KixZgRfeesxDxPHaBfBmiUZTPhEbzCeKqkgzCdQHeQfA3	532	748	748	1616073840000
956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	953	3NLjfpxTVo49r5R2gFv13FfSyt1Go7Sr4qn9yDg46KcCF61dRiMF	1509	1074	1	1	947	jx8jKgsDuky1Tt6HMdp4ewsnvHpQEjXuFdXCx14dxxNewAdeCf7	533	751	751	1616074380000
957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	633	1258	1	1	948	jxtB3ZMoXECFyS9ayzq2DFT4g8Qs47CJ7DUZD54sZMs4WBCbjHj	534	752	752	1616074560000
958	3NKxcaNTgig2UtRq7NF5tSaTjYYtmgixPJC91TSVjkMW4bChqoba	956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	1599	921	1	1	949	jw8JuV9xStcqodt31dnwUxKUAtaodahRKUUTYbXEsNvToj9kHkN	534	752	752	1616074560000
959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	1403	824	1	1	950	jxwqXKnLCB9pEQKz5v1Cog5jhMs93eupqYxSz2x3J2ZzKN78yiW	535	758	758	1616075640000
960	3NK4mgMYyEKtdSMvSqPgrZkW6H63ufXSSEcPSbBX78zPdeZf6pob	957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	1407	1395	1	1	951	jxCPFXA8TzutaPQVYQd5wMtXj7aKz7LZKMsiRrLyh5sErBLTq19	535	758	758	1616075640000
961	3NL5La3n6voFLsZyEefubBrKbdVoUnGAiCdWxo1Ug8dwDyAGBeK8	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1670	1282	1	1	952	jxzvMycBbk1kUS5eSZDCfWQG8ZwwErTWxLZC8HPxqtYrNXPUJ8d	536	760	760	1616076000000
962	3NLTeSwRjA9FuWnwDXQT4NxnkBWKZPs8G9tBNStvr4SZhbzTPk8j	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1407	1395	1	1	953	jxTjy8BsHsnNPStom68gEMtMCwaiACTafbGn4BAkHEgDHFvczMC	536	760	760	1616076000000
963	3NLWbrhbyNL85zDTxg9RZAT7gg6uaxcCjQP169ifezuJkuPVmxG6	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1619	1149	1	1	954	jxwBqn2GynwqLiucfi1LMz6dicPQJRqxped9ESsCwBhQo99bNRo	536	760	760	1616076000000
964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	961	3NL5La3n6voFLsZyEefubBrKbdVoUnGAiCdWxo1Ug8dwDyAGBeK8	1407	1395	1	1	955	jwAAu9FL4aDmafcmFENRpQxMF4m4Z1CAskB2UPm2BtJAiDiT5kt	537	762	762	1616076360000
965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	1564	1338	1	1	956	jxfcxHyZHwMu2phdGLXnMbySH8bWgPRihwFXMkei4fmgW3mRHrV	538	763	763	1616076540000
966	3NLTdfPvDe5F83q22YmgSKJvV6FUvE4Pi5bhDqT4xDCYW6vhVnEC	964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	1593	1346	1	1	957	jwBxo6T41VNmjqT8CKfqhJSQQo9iYYBVM7tnkzA5BqE3CwLERSA	538	763	763	1616076540000
967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1403	824	1	1	958	jxRk4jndxx9LAfEsCGBbjURKScZ4moep2acHKr9FU94VJ3wPKTg	539	764	764	1616076720000
968	3NLmWdwtjrmtSeTZin6jhgFGeXCLuuC2mez1bFuEkaFuBrEkiKct	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1555	1347	1	1	959	jwLkjLTjGckMPhMqvUQXEpNuZqAFQSaxcvz6fPT8UAw77zc55qc	539	764	764	1616076720000
969	3NLtx9DzEVFf9RojUwvsbS3gNt14MoknQeRAdFuBFG36ZAmw9ihi	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1581	778	1	1	960	jwDaatWSnVAPHGhies3gYLqPxLG2wk7jRt4itcTtfD1Cy8QSvBa	539	764	764	1616076720000
970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	1640	174	1	1	961	jxLYsFgtS11ixkt1zvtVzcKeUf9u7PkhJe1pTrLaixDrmYW4HyN	540	765	765	1616076900000
971	3NKsGqmSteCBVR5DRVFcjLw9AAd348AJKEC1BvQatcKY1jDpojBW	967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	1406	1393	1	1	962	jwZ93ULRN637vzt6XHTiiU6bWXum5wdULNBdzK8VrTUAttbWjYC	540	765	765	1616076900000
972	3NLqLpabmMJ6yFF99yxvSvgC3Yc5zAt9L2APmzbtBakTV3iQ6EZ3	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1500	1171	1	1	963	jxy2yRk1y1RZ5aN4i4iJfKRqDzMSZJsDeX9boEQ5nT8rggPMSRg	541	766	766	1616077080000
973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1406	1393	1	1	964	jxzKCdf1Bw35e6ha1sXHhsBNNrNyctLbScDxsZxegh4aGsd3su1	541	766	766	1616077080000
974	3NLJmeaxHxYk9ni5KgmBiSan1xvLgqTVf85yEEFjd4vwTFXCTHf7	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1631	793	1	1	965	jwtdixqNyveHZRtfAsafAF4KKdY62b7GoFvRuhhWDr8bwFQ7qyQ	541	766	766	1616077080000
975	3NKCFSNvSXCRjCKB33St5rVUP3g5Dkpkq4KytWQReXScnQMm1Br3	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1600	1372	1	1	966	jxywKQhN6zGgcYGymKgEFEE4dvqpJ4BHdqRMcmp7MURTFATFRWE	542	767	767	1616077260000
976	3NLBmqNM8j9o72113b8qr7xLuu1e8xDQMPXZPg7rp8JjPu1SA3XX	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1534	222	1	1	967	jwuypbyVXF8cHsMyJyM1JaxW4T8gcvFe4PtBJDDsnX9MF2NtE5Z	542	767	767	1616077260000
977	3NLdQ2TGRjT6FhVJ8me5B3UeuM9Jj6FF2GtvWzr4uRyU75Maw769	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1637	816	1	1	968	jxLtFqkRtFMQordhmHYpjGH9vezznupUZaVRgBN9sXujbbAEQk1	542	767	767	1616077260000
978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	976	3NLBmqNM8j9o72113b8qr7xLuu1e8xDQMPXZPg7rp8JjPu1SA3XX	1403	824	1	1	969	jwcx8NSJ5AY1iBPMjCi3tN9dRDGDHtFuBXTpmrrFzn4VLWzwd6L	543	768	768	1616077440000
979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	596	1180	1	1	970	jx3DQsYZRoj2Wb1ev22bTpcGjWfgBCdJq1vpsNWhss2DzRhwThV	544	769	769	1616077620000
981	3NKQtE6rcoxFAebLmMt66LGnT3N95FXRpNmWqc8abjGMXtVuvQbV	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	1407	1395	1	1	972	jwCbxbWhss9erFK56FWPi8Rc7K1vLAMjY7y1tDw6V2BrRBcLKHz	544	769	769	1616077620000
982	3NKasQn3T2R3Zoah9imvqDSbQSJg8sG9ZQ7gbgphCHKTk9bX86s2	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	641	1090	1	1	973	jxTc3GRVZ47Wvt68VTLD85YYbhmt6MgQUvQcRcM6KwmCNYsi4zu	544	769	769	1616077620000
985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	298	1062	1	1	976	jwJnwQRCZd1r8SLNtAqX9dtr5T1nQEhzJdNUGhdSjZibfabzSPn	546	771	771	1616077980000
990	3NLPtLQKxsogTWBFC3WoXdeciU5GszxsMVXQGqZWrZFBjf8FWsfX	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1406	1393	1	1	981	jxoxKCYuzc7n7GrtK2L8zrmyZMcaWZsMbk3EYKuhwuxHEsPKorb	547	772	772	1616078160000
991	3NL24PAon1rTbko9ujSVJkPM1avTPwEC3yQjLBt1MqF3g3HMnzdE	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	684	1352	1	1	982	jwxYVTGDaVuCn2S2vca3eAQQjoBBkm2cUXKkoM3HvynkxNT4L9v	547	772	772	1616078160000
994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	43	1184	1	1	985	jxtNQKkjooZtwhbUuzXPPgq5ATicNZBdAEtRyVGEeiBwANhQqKh	548	773	773	1616078340000
997	3NLkkmjPUrxVgahoiHr2h7WJFHE6WmmmSbwqMtjkuV7fS987fm4G	995	3NKm7aQemBruz2dxymXjy4Z8TMMBxob7T6y2Cnn65nJ8jfdZA7Jy	1403	823	1	1	988	jxcUUrs7NnxWVuBAFMrhcz2epDuoJ2Esgwq3wPyrkRJv7HACrJH	550	775	775	1616078700000
1001	3NKkvv1tRzTToKwGA1E1QrTrZwpcPxd8jMFPH75mgmt8tQLWfkaE	999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	1646	1354	1	1	992	jxpa3nHUxf5MjQWY5DWM8evn2UvTcke4txGqGVgT6nMFHFUTZNy	553	778	778	1616079240000
1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1001	3NKkvv1tRzTToKwGA1E1QrTrZwpcPxd8jMFPH75mgmt8tQLWfkaE	1529	1316	1	1	993	jxbBFiDbVMgVDfxd2ne1xXwskZzU38azAFevYnFkLLYHRz1DHcZ	554	779	779	1616079420000
1006	3NKUCsXwKzxN14jm2QCnToYVTL5BjtP5xBsueKeGRLub7HD2MJYU	1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1457	1145	1	1	997	jxVWEZxVLGBn83iQZ18BqLKXGnUAZqQbrmzsVQxk41FsjWBgxnh	556	781	781	1616079780000
1007	3NLjy1R3J7uxriRDkLfDfeeN8X43eQb5yyFvBqwEiDw8jZrXQrZ1	1005	3NL44VHTpU6UfeYNgMsmrXrzUEbcqdkSPTDQ3LBCD3T6XyedjUZu	1397	838	1	1	998	jwVe6XKm9pgh9HGNd6m3UJpxMjspx1Dn3m4N4prCXVUDSUmwPnt	557	782	782	1616079960000
1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	1007	3NLjy1R3J7uxriRDkLfDfeeN8X43eQb5yyFvBqwEiDw8jZrXQrZ1	1671	1239	1	1	999	jwKLSikcQ9g4JLRpK3uxnZgPGUETK4yRG1Vj17VsLTbdDnBsoMT	558	787	787	1616080860000
1014	3NLwbqf9TTiSkiHXHLZLF4sRjjQ24oMy1uf839rVkpVM2hhHYxvs	1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1448	1065	1	1	1004	jx6wM1sFYMkTYPTGjxwkzr6b76EK4V2dbzQeqMLrUfWCr2881HU	561	790	790	1616081400000
1017	3NLus1rdUwbzwMnBn7rJSKMvwSszZag37bY21dYx7nshoNAKvJDo	1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	1403	824	1	1	1007	jwiqL9qwR2pFzYvsk3d2BDiuf92VsNmG5rd2qCpsr6ZBTLWbXEj	563	792	792	1616081760000
1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1019	3NLroFgcZpvjTihHynU6gMbzpWHR6Pa3fJ2i8smuHqXzpxf7pUPp	171	1248	1	1	1010	jwpkt9bYELbzrNEiB1CupFFU32ngchaoFTB44VB3rQhut3bTjL6	565	794	794	1616082120000
1023	3NLAN7GdeEugi7Q2vqEwdngxcJ4RAtbSEJCqGrQtecuyLoC9gb8i	1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1546	1339	1	1	1013	jwcKJxv9UqT5HfBLEw3VEVQzThCtocFMaav8YYZ1UbEAsTZ3YhV	567	796	796	1616082480000
1026	3NLgQXpiXQtVQS8Vt7z73LbKo8UJRT8i5Br53sNF5FWaNnsqXpGC	1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1623	830	1	1	1016	jwjrDZJ2sZHZQERBY2usRqYK5X2gzbsKxm7c5HDYXkd5vFBAJHs	568	798	798	1616082840000
1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1028	3NLJEJMyNsppz1uctCpB2sR4RL8cW1y7Ueq9UtFPZtY2nsZm2381	1571	1335	1	1	1019	jx5gc21yZ67cspmGqmXYTfDXHfTA7NGtz2rYoLFZi39hUKVXiN4	570	800	800	1616083200000
1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1579	1389	1	1	1020	jwA279RjQe8KgDrYGSNQwh3qP2c8vMDzxJ9VSo3weqTM63ZSzdy	571	801	801	1616083380000
1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1034	3NLksm5Qyghdamva9xnTXMxLRYCyf36s1HtCv1m7bmCXusmpQBKm	1406	1393	1	1	1025	jxo9RyCCTcpm9FFhoJyaJWtVzRBwckcvPNqsBfRSWnJvLaKM5rU	575	805	805	1616084100000
1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1519	863	1	1	1030	jwhkgAZCbFBv8ia3UMuejuskMQyrzHgs4dFEavX183p2AYJ7Kzo	578	808	808	1616084640000
1043	3NLWtVTdKtzqPNZj2VrKYQW372bJdGBw3jApP6T7yp1PNkY88eTn	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1647	1056	1	1	1033	jwKdBe5J3pVgAHcSzb2omnR4gLiAQ4wGNtPGxFSkSpi2XSVpdXQ	579	809	809	1616084820000
1046	3NLTv2BVHcB69e8XqyYZEBvNjoPXdjZMWT9t8KCRSZdHnQCsByXF	1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1457	1391	1	1	1036	jw6oxme6VtderUuRgUZiUBCjoGHAwoiauGoxQhU6LSzJpEhPpgY	581	811	811	1616085180000
1049	3NKrvcLgkrCc4sDb7pzdQjkzwrsRvm9iu9iiHBLGQ5mFkYHyaTGP	1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1402	874	1	1	1039	jxdnZvcGUTQjSxNGvk3vTaBcGLHHeJnKqpRL8gfNJHhFTMQ15KW	582	815	815	1616085900000
1052	3NLXkdrZbjcvBaZegX4RgYvrzTEJNQtSGwg3UvoVPYFXG9FMybwK	1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1581	778	1	1	1042	jwaqjt5jzRun5N8VV79fre1CnfTMPQajNE9W1kWmJUuQ5vuUP2n	584	817	817	1616086260000
1055	3NKAc6PiN5s4s9khixwmXGgnZgqaEwYpFA43PL5KmpnWmXxjeKtS	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1579	291	1	1	1045	jwpouf5Put3DB5GFs8abpDmBsxcU4bC3YsBBoRL8Yey26RJpPnY	585	819	819	1616086620000
1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1064	3NL61j9pdbJXtm4ZrVdxbJWdKhcjQkuVvDy86cuhSzY1jQ4mz3DY	448	448	1	1	1055	jwRe6ZMCrgjzithifAf6LQ6YHGQWWxPKuX9JfrtxhT8BsyVyCGC	590	825	825	1616087700000
1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1067	3NKDkTYRpZTYhTQjigXosbtk8RKNUyp3fR7yKfNAqxmqMifjFTuk	1405	851	1	1	1058	jwQLUqJcWbzg4YsYs3p7Hf2jdswodfxM1cyb9rk3GxU8hCCVTMB	592	827	827	1616088060000
1071	3NLRDXRpYVzw8GxmigCESVeL6tViCWQHUQn3uFQycTx3gW65eSs4	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1490	1274	1	1	1061	jwhQPGq8tAX9fAzfT75qKQsaYV6QF1s5sQeBGLmU82Ti2G3mptD	593	828	828	1616088240000
1074	3NKMnz1vVFN6tvULMu3FjmuHq3BYZWG5fawjNRrXVAc7D7pXYxUT	1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1631	794	1	1	1064	jwVfhjD1WsNXfnNgE6z2mN2uEfcNtggMVzAvudEUex268oKkMdw	594	830	830	1616088600000
980	3NKN7eQFJutridCxoyZ6XXiqeZtVvQR7VgaHSdkZnyir5iM7sb7K	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	1668	1370	1	1	971	jxsUy2Gax9nyXE2L7SCh7ftzpHQEBnLWydxYCZZgzR4yLvtA66x	544	769	769	1616077620000
984	3NKtpPSDZnAzRTFbVorMv7AuHLJw6eqCEjr1wfbNvEVNBor3EvEm	979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	1675	1342	1	1	975	jwUCCw7TuiFAxSkKAcKFJ2WEnUe4GZ7wWXZ8DrRvWUa2bSi9pcE	545	770	770	1616077800000
986	3NKQMn2FU8Js2ivkKTs1AV84vXMZLATqKqTJ4Zr5fVnasKwkPMME	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1406	1393	1	1	977	jxMaycWrbWShF1kWM2W3SAVP1X7hVfB6LxS3BWR8WHMog6dhSZu	546	771	771	1616077980000
988	3NLa2bER8PqR9DDQMm93aDo9pFA6EPgPKAWsjYWdWcEXJqhxzctW	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1637	816	1	1	979	jxqZQRuKjY5Lur32H2cBxg8WRJpdiagv1afHvFRd3qvn3yQbWK3	546	771	771	1616077980000
993	3NL5DAxAgFLQ8v95SCEJuWc5wgfT7hoTZ6mGXHpQP13YJo4w5a6p	992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	1403	786	1	1	984	jxjuJpCtV6QEqU1rDBetiLJzt7CTCUbPbboStkjmzGFJFLoKNTf	548	773	773	1616078340000
996	3NLNKErrvcwooGb4s731agdjQqSpdmJTjVM5t8x92WW7afHmTTjt	994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	1627	1259	1	1	987	jwaFLuvxMdDoKeUi6y1n5FR8nVc9vwPaVMdCrQ6zPSsbVgx2MaE	549	774	774	1616078520000
1000	3NLHj5S6s6WHeQ3KA78QLwxdqMgz6W6W4s2jQbvbJq5aJtir2EjJ	999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	1405	861	1	1	991	jwHh1MUGyS4vr8MHuE3rnZ54C3RhvfzXeEM46bJEcWpdW6JeTyd	553	778	778	1616079240000
1003	3NKrHznMZGYoGpM6EwvmJdBBw5XmGs5tgVQgcKRQRWPC6P1jRtJR	1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1407	1395	1	1	994	jxpWThAH8DLWJvWUA5hwGp2wnufKKViXj3bNTzKad2xWQcQUW7Z	555	780	780	1616079600000
1009	3NLsokqag4JvevowPd1A2enCYaVJtjCLpsgfTpyD1tW9QmEB1shT	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	1602	1369	1	1	1000	jx4sPcKWLu1eyrhs5GRbJfV32KHErYkKtuBASVA4nznredNFLkZ	559	788	788	1616081040000
1011	3NLic5kz1tymMKLQnoWuijmWz6CSkpYdhmpe9cZRu1YGqnrqVYDV	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	532	1057	1	1	1002	jy2rruXRjD8xQoRGVZW5YhAh2KmXz5w5UjqwSXujVQSUX1TgsP9	559	788	788	1616081040000
1012	3NKr4ioU5Rt4iLMUPCew5BEBprZR6TsYT9saiDyWmUEoPKFpmDGx	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	470	943	1	1	1001	jwVF343XsLYvFPwQvbY7ibEyS55qwZKjyyUqZ8KsjHpdePAvhkm	559	788	788	1616081040000
1018	3NKU1uCr5eo4zKKUtaTwXN7txaVN4GNRzBt1odfRWE5z2xigoM2C	1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	576	989	1	1	1008	jxPWitGfzoJ1x1RJoeXbZxn4XzWhrNFu7vrNyq8u9LZcbL4ps9j	563	792	792	1616081760000
1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1593	1346	1	1	1011	jwfGugBShQBKXvNWNbPYRuM8GbNidNgC9bAbbhVu8ZZehc1FUFj	566	795	795	1616082300000
1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1637	816	1	1	1014	jwZiom7ysQJEAcv6goZZA1LpQsPvezNtQncXbehoK6UhkpreFBv	567	796	796	1616082480000
1027	3NL363PWEX9eLVGVkrDuTLUMJ8ctw8Y8vkwS21AGbYLJpsHZ6drp	1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	152	964	1	1	1017	jxVQcrfQfDuNxnTYyDMgJGVAV5Z9g9tG9yzbKJ7nunmUPCBhhE8	569	799	799	1616083020000
1031	3NLoDPZPM3CwM9gJUrf7fMJZ5nv4Ys1t6MQ4UouNGnY3NNW9iw5x	1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1609	967	1	1	1021	jwoefseczoPRAbfPUe6Vzn84nfE1jZtJcWYrSRmhMBb9rNuEKaJ	571	801	801	1616083380000
1032	3NLgRiup1Cn6k95YPafnGzBt2fmdYRDduFV3Cs1HQiyXu7uhakdy	1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1516	479	1	1	1022	jx7pBb5YZV8LAJSCyRciL61ie2uSXCPZkQ2HF256YkxiSpN8xrg	572	802	802	1616083560000
1033	3NKjbrAio8WUy8zGfGGgw9ssMoidGjCgDGHNPGvASb48Y6yEfJzS	1032	3NLgRiup1Cn6k95YPafnGzBt2fmdYRDduFV3Cs1HQiyXu7uhakdy	1585	1366	1	1	1023	jwjGdWaYAtTAptu8HSSvBwKFHUjP9Dd2hBZNSWYA2Rtwr39TjEY	573	803	803	1616083740000
1036	3NKBBGrh9thykFLRo3qSg1CyCQGtt6bX7HoiWzqCBXKXFGyDQGLD	1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1599	1287	1	1	1026	jx5ju6KBj6wDaDksVBcVaxpFbp1qHra156CCmEo7qWjapvNFdZn	576	806	806	1616084280000
1039	3NKjHQAmVKRorZbGoN54iwiiVNkB9rRcb4vQfH3vPbNdEoXUxuL4	1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1405	887	1	1	1029	jxXEJhJi1wC7pk2VYodyJMdVXrwx8zekyfa6gzXBygSFoPCg3L3	578	808	808	1616084640000
1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1402	868	1	1	1032	jxD5XRektdERbEyXnfXYjm4m4pt6b13fmoWiBfJxYiR8U5tUKg1	579	809	809	1616084820000
1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	243	243	1	1	1035	jwPz8NYjCwBaoU74zo1S2qujXDcAFmGjdxB4QZxq7wxeF85E5L1	580	810	810	1616085000000
1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1402	874	1	1	1037	jwyv3HKEcVV1TA3oiQnqbwVPJme5UyTUFCXUtm3EQM96u5XbiuQ	581	811	811	1616085180000
1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1049	3NKrvcLgkrCc4sDb7pzdQjkzwrsRvm9iu9iiHBLGQ5mFkYHyaTGP	1406	1393	1	1	1040	jwTHWwHT5dDJZmTT7qSdfiyzXJqCj3RmoYiwfzCcZttHkMBr7b6	583	816	816	1616086080000
1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1467	1250	1	1	1043	jwmXeDAevYWgiGshovpR9AKctHrLv5iTg6tbZuS8aYUCwZBEJTr	585	819	819	1616086620000
1056	3NKqwBBrybVCppmXgZTnw7tKxrDBeu3TSZCBUb3xHWyqctGiD7cf	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1523	1321	1	1	1046	jwkc9KXQpsURQAv4b7bp8feimoZpA54xW6WhMo3TkcCKGmte49R	586	820	820	1616086800000
1058	3NKw2Kse6NY1vMcEUhgroogBrFPWUy14WaHdSHkXuochQ5SSYRNd	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1500	1051	1	1	1048	jxXD9Re3cvNsemroNoNcrWi2zjm6HnFH7gAjDzZqctST8m5JuiS	586	820	820	1616086800000
1059	3NKxYRUZXbcuGm4xBiT5VL1LDD9DHsoGtcnfn4Drnj1schtzDegH	1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1523	1321	1	1	1049	jxQEc6chLsx9Y6k6d738uAtBETFytuHUfn1Y5vq3huzyVmkvtKr	572	820	820	1616086800000
1061	3NKt4qLYVYny3DEsb4afjjx4bUV9R1rTKjpCfZWDD8mwddP7qJ2Y	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1407	1395	1	1	1051	jwZrcUWYiZKfg2EqBHQnXrQMrrLbndmGB6HhTesuECnYvp4sLxp	588	822	822	1616087160000
1066	3NLRvXeP46ntPpFsHSCTL9jogbXca3ASmqCjKnV8RZKXYJtSZ4KM	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1406	1393	1	1	1056	jwvria5RhSebLPhhJPtSXce2VdgamFPjXpt6ztB9sf67VmPR9r6	591	826	826	1616087880000
1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1407	1395	1	1	1059	jxzr3xbXsJn3kS4euaY6hoQDQZE3U2fS5GDFgbPaJwCwHFYDZAh	593	828	828	1616088240000
1072	3NKX4Ai56iX1rYRkjiQu1jUngzjxoNfDSUikeDqjiAm4QHSb2ioa	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1637	816	1	1	1062	jwxhexomsKtXzmacETTUhsyp6P8JJWV1zNdoQdc3p9PrcuskrBw	593	828	828	1616088240000
983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	1407	1395	1	1	974	jxZ2Kk3LZVZArce5KjjRmkiwpvKG9fWMYRr6q6gVPQaZ67NRauQ	545	770	770	1616077800000
987	3NLxVwpu18LziTW2x8HnUvnutSaiaCRUz9ZE8BJrjLRNwqQFU5pQ	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1527	1167	1	1	978	jwmXSRZhXQhMhVdjGMALB2hZCCntadTwVKoZQDbnhDo74M4dwfe	546	771	771	1616077980000
989	3NLvWbCwMjSUzfGDWY4XW6kCvSPi5YUQcdmN6v3g7dTFxnEYEivw	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1439	1279	1	1	980	jwgaUsADefSCDtmWLLGuWnvFMRDXdVbakufe588WaU6xATqwiNW	547	772	772	1616078160000
992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1401	231	1	1	983	jx17HeVRf6PWkzuSdAhBhszUdgHaxWYq5FwuQQPQh8ozTntQkvi	547	772	772	1616078160000
995	3NKm7aQemBruz2dxymXjy4Z8TMMBxob7T6y2Cnn65nJ8jfdZA7Jy	994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	1403	824	1	1	986	jwCAsRAMwuL4MjDJQkGdYCRVtNd3BbM6b64Aa2f1smpGjjRW9L9	549	774	774	1616078520000
998	3NLBqUWTWLSysNcehaYrF6VVJ7QAxu1EuB7w75Xg1aFw6VV9Nmos	997	3NLkkmjPUrxVgahoiHr2h7WJFHE6WmmmSbwqMtjkuV7fS987fm4G	1656	1097	1	1	989	jwb4QJMXbgTHfSFxa4CjA87teD7rgrv2pMuNvzvEcfmiAj6ivzX	551	776	776	1616078880000
999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	998	3NLBqUWTWLSysNcehaYrF6VVJ7QAxu1EuB7w75Xg1aFw6VV9Nmos	1534	951	1	1	990	jwLEXbvLUmabvMgvnkcAzmst7fXSvUR2Q1LGGwfSNExLgdgfFzv	552	777	777	1616079060000
1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1675	1216	1	1	995	jwcYU2igSiKSUtvdGpa8s5yzBR1mSBN39Yfd4ENrbVpTaaAoZNv	555	780	780	1616079600000
1005	3NL44VHTpU6UfeYNgMsmrXrzUEbcqdkSPTDQ3LBCD3T6XyedjUZu	1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1406	1393	1	1	996	jwtEv9eniWYfndqbMLLNA2D1Pu31kZ4tMLGV4AJJYAJLLAzaoui	556	781	781	1616079780000
1010	3NKyYjj9hHBQfcbM52uBigkao3B4jaGv8hMe8utyFMJRB14xJSuV	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	470	943	1	1	1001	jwKY9GDRKA4FLiU3sWWZWuJKLR58n6rjXFJGUv233yZNpxvM2vN	559	788	788	1616081040000
1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1011	3NLic5kz1tymMKLQnoWuijmWz6CSkpYdhmpe9cZRu1YGqnrqVYDV	1609	1087	1	1	1003	jwWjFKR25YFHgw7BXyEU67ARQWNQQ3Nb4eoFX8pax9hLq1Gbgps	560	789	789	1616081220000
1015	3NKfAncZr3BxoQVmJBBhBq2s8YhTKW19hfwfzGP5YunYv8bU6d2W	1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1646	1108	1	1	1005	jwVxBj2B1UPYcehR3ZVwA68mMWgF5t3nfZbLdL3ykzjrCQKdArc	561	790	790	1616081400000
1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	1014	3NLwbqf9TTiSkiHXHLZLF4sRjjQ24oMy1uf839rVkpVM2hhHYxvs	1444	1255	1	1	1006	jwkMgfbFkiFFfa1VezqVBfvGrgXuxEruqaoGZ2wRKKGiRCpmjY2	562	791	791	1616081580000
1019	3NLroFgcZpvjTihHynU6gMbzpWHR6Pa3fJ2i8smuHqXzpxf7pUPp	1017	3NLus1rdUwbzwMnBn7rJSKMvwSszZag37bY21dYx7nshoNAKvJDo	1407	1395	1	1	1009	jwxycgihLWvUopC5Fvsu96ivNRfLB28Y2n8iRb3QaJMGfj6Peh8	564	793	793	1616081940000
1022	3NL5EtQEwSHfGwJvMhdfVgq9BneafjFK7J8hmqLK9hoBzATvK7Ww	1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1509	1320	1	1	1012	jwbsgbs8kmnKDmth13rTQj2bGAyBe4PkWXv8coZopVB5t3rzWiL	566	795	795	1616082300000
1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1602	1369	1	1	1015	jxUQRG2JpEMU9S7CZ7fLpA1sWorFcwZPZRAVret6HWBgHJuBBzh	568	798	798	1616082840000
1028	3NLJEJMyNsppz1uctCpB2sR4RL8cW1y7Ueq9UtFPZtY2nsZm2381	1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	101	101	1	1	1018	jxdG7R13oC5YKsJuCwCiYdpQiaUw8aRXtiStWnDUALGA59y7GhA	569	799	799	1616083020000
1034	3NLksm5Qyghdamva9xnTXMxLRYCyf36s1HtCv1m7bmCXusmpQBKm	1033	3NKjbrAio8WUy8zGfGGgw9ssMoidGjCgDGHNPGvASb48Y6yEfJzS	1509	954	1	1	1024	jxwgY37XV6Qt2AXmggSnnqCSYcqsQgvNfXB3Cuz3f2YXseW3Wkp	574	804	804	1616083920000
1037	3NLuQY5w6iVbABdVMZvwd4LaAHP57pFrfEmx4BzBgKMq3yFMRGhp	1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1477	984	1	1	1027	jwiRuobd7nCsmzco4FwNn3tUnGbD3Rf6yHB88mfpm1dPdqJ5VAJ	576	806	806	1616084280000
1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1037	3NLuQY5w6iVbABdVMZvwd4LaAHP57pFrfEmx4BzBgKMq3yFMRGhp	1581	778	1	1	1028	jwYdkXAdAvhoQNUFcm4gArRBd3iYyfvR3D5f1TaiR6jZtA2t1i2	577	807	807	1616084460000
1041	3NKqsx4Cpzgmh4eGcHJdeP4PLNFm4jwVXpDf7LWuUp5VYgkXaGHB	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1406	1393	1	1	1031	jxeaQuU4rvQTr3AasPhygNDniqf5x6dg7vdsSw3nRask7QaDL4w	579	809	809	1616084820000
1044	3NLAtDMMrd8QBL4t3rvpfjV5aPZYRKNHgnepzJEYnDSooV9mDCYz	1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	1407	1395	1	1	1034	jwGgsLgfB4Wah7wHUSwRYdkPoTY3c8M2dyekBzqfsFjKoXBoCa5	580	810	810	1616085000000
1048	3NLMumjvAp8FwrALEEH1LBv5DbL96tAEkAo8E15CnSCpyjGwAjLU	1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1600	1372	1	1	1038	jwJ6z92ocp5pNoTVDjNfG9BNmHKyrLmi1yekTuRhgKt2iJMBfkX	582	815	815	1616085900000
1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1405	1	1	1	1041	jwirNKJgzLByib68moVThjy9pS74YLMuzakCiMYDC3ac6NtKysx	584	817	817	1616086260000
1054	3NKUccuKEfQvRPkQ8Bhs7UR3ZoP7KiLf3ZgoJBoBfv5Nbp8TTony	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1622	990	1	1	1044	jwJV2txdZpjLZKUWwFKz5ywpKKAmr6HQQkQKKBXxEGfaZ9WiH1t	585	819	819	1616086620000
1057	3NLYeNESCNPDi6TBuWhKR7w8E3jpYP8pBehvJrt34jrjrmFFKT23	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1407	1395	1	1	1047	jw9zQppuYHmkYgqs3xPTdpbN5BwivjDQXA8dWEeVhAWJPidAguy	586	820	820	1616086800000
1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1058	3NKw2Kse6NY1vMcEUhgroogBrFPWUy14WaHdSHkXuochQ5SSYRNd	1553	775	1	1	1050	jxiBxUxgPoJHMomTqGe9654X8U3bAy8XzoEjTEVw8aUYdvqUJWd	587	821	821	1616086980000
1062	3NLr9ajAguT4nTotZ33TZ4Mru5G8EiMUNXRHhTdzHDyX97r3m6Tg	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1439	1153	1	1	1052	jxyVTL7AVboUCB6msQHVxbbiXoV6LPkgWXt1BxLcJYDYYJokHPX	588	822	822	1616087160000
1063	3NLGSAYLdxQUWCPtV34qkLeYpJnRZWMjeiL2zm7LieagNRuU8zWk	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	171	1374	1	1	1053	jxCYpK9WEr2f1Uz7tCFUwoLqXewakJpnRTYwWcpRKhesMfAXDbT	588	822	822	1616087160000
1064	3NL61j9pdbJXtm4ZrVdxbJWdKhcjQkuVvDy86cuhSzY1jQ4mz3DY	1061	3NKt4qLYVYny3DEsb4afjjx4bUV9R1rTKjpCfZWDD8mwddP7qJ2Y	1406	1393	1	1	1054	jwDer5ntfZMak3wnY29JyquNfza3hb6Dxs2NTKniuT8sXpumqcw	589	824	824	1616087520000
1067	3NKDkTYRpZTYhTQjigXosbtk8RKNUyp3fR7yKfNAqxmqMifjFTuk	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1637	816	1	1	1057	jwGotQd373dgvTejWVgdxNYV5PV5MH6A4Z5JvjrBcEkkdp8kChF	591	826	826	1616087880000
1070	3NLRQUQek8bPhkdDYqyLWoiLuZNGz4eoxUU1Ztj26oL92a5qSN1f	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1610	467	1	1	1060	jwUDJ7jQ6cFx8mvhK75zHPWbsjtpRsFqSg4EVLZZkmVaeqvBaiA	593	828	828	1616088240000
1073	3NKH5uWrHTFToEe5j29yTCeWoUMPexq2RLG1j28YpfZmpgawB7g6	1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1406	1393	1	1	1063	jwvenaQxnGFuLa2B3sM6i875CSUd2MC3nokQrcbPCMHZ1BQmW4s	594	830	830	1616088600000
1076	3NLZKH4qa3ogzRX7be9CdUixEB96MaCzwXb2R7FkK3rWTNEP2mZ3	1075	3NL4wiJ9mn4UkEHNUWe2MPMENkNc6A9LJ72jenLG9EfkBwVHJ5s3	1529	950	1	1	1066	jxvqEaHFgUACiFXXJgewuw8qadNNaYetAaaouFNi7nC4BstWrUp	596	832	832	1616088960000
1080	3NKkWHCBdivA1j9WkSbw4LH75z3bERMbnVfpn4axvbSv9Dq1c7Fk	1079	3NLxhuv3ncQRdbRxb1oCXYhyMdiwyCUQXsXduvpwg7vDyWXifHTH	1423	314	1	1	1070	jxdPLypMVxLsRi6afSw7R3yyse7Fjcgxx9ZbHTYhzmMVvwkDYBe	599	837	837	1616089860000
1086	3NKZJM4ZydgQbrbSn57BsVgr39j8gTAQEjqwmucVgBpv7Nt525wm	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1422	1337	1	1	1076	jxCMr7Z9a8XSPhiULmWz3uqyMG8yttBKVD36rSjYKMcjkwAqY8f	602	840	840	1616090400000
1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1088	3NKHEdWdb95ds3ebeidWGtFuzsAHKKpjbM1awuPz4gRZ9cufRrhi	1405	867	1	1	1078	jxsqEjMiBNSa32SgukwMD7GRjZ12ewpCEPmgwaCL7zG3BxduGpP	603	842	842	1616090760000
1090	3NLVSY3TLht5zN4cQbw7HjPcoen15WgSYp65GEgmoTf4B7NcTZTU	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1489	1134	1	1	1079	jwvZMusGT6UM7jmKDQKZUSj57RJrrX4TL9LnTFZhEjXfjVJkrPU	604	843	843	1616090940000
1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	448	939	1	1	1081	jxFLK99EMacCLUsAoc33tVkY9fBYQi9gyte52275TbfuUhEmyVw	605	844	844	1616091120000
1075	3NL4wiJ9mn4UkEHNUWe2MPMENkNc6A9LJ72jenLG9EfkBwVHJ5s3	1073	3NKH5uWrHTFToEe5j29yTCeWoUMPexq2RLG1j28YpfZmpgawB7g6	1513	1379	1	1	1065	jxhKyEPDjkgoB43SQx5uKP6rtYb4HQvj1nvUnoFudAJivgCc8Fa	595	831	831	1616088780000
1078	3NKLAUJQDLnqXMG8jrromaGNk3LHZ37c2KEoPAUpcmbFdCLTgbzK	1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1585	1366	1	1	1068	jxKDW93PsS6NFmVdEFtYi9ePXEN4tbHvooZuQqxQmY4WuHLh8dR	598	836	836	1616089680000
1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1080	3NKkWHCBdivA1j9WkSbw4LH75z3bERMbnVfpn4axvbSv9Dq1c7Fk	1474	1329	1	1	1071	jwXpu1hLHQT4EqVHe1muLNgiCubt7CkKaW1RoZcZkesokuM3NRm	600	838	838	1616090040000
1082	3NKb8E5ePpzyUCCHq5ga8NA2TvQwSUhELEECDcc7UP3VUiQg1yzy	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1536	1313	1	1	1072	jwNS8PoXYmb8hkxUxRipxLmsNXZc5janmRiS4XvVBLnd4G2Sovg	601	839	839	1616090220000
1085	3NL81PDErgwdPB4rLmCmhGddFJd3d19i522xhdG3yujHo9MswBLh	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1495	196	1	1	1075	jwe5qsN6txeDa8qzg51NWhzB7p94NvKwU2hBpBDrYodrp4mn9SF	601	839	839	1616090220000
1088	3NKHEdWdb95ds3ebeidWGtFuzsAHKKpjbM1awuPz4gRZ9cufRrhi	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	58	1035	1	1	1077	jxkEt9soh7CP2mvimmYTHoRv6xh9SFAQb9VyMx7V9UQ1smGj1wg	602	840	840	1616090400000
1091	3NKwJM7pGsDEvN86HVfQR4TsxucegB1h5VM5NsEsPWWZj8hyfxUQ	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1489	1134	1	1	1079	jx5sRdfUYCfuHKDD4rwzCKBMqtrX7QyFkaTkDVnbA1QHFnBqzKa	604	843	843	1616090940000
1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1076	3NLZKH4qa3ogzRX7be9CdUixEB96MaCzwXb2R7FkK3rWTNEP2mZ3	1458	1323	1	1	1067	jwi7GFam187t64aJHtLWjVrQBevLdymBLqM4WRGuuhkChs4Vn17	597	833	833	1616089140000
1079	3NLxhuv3ncQRdbRxb1oCXYhyMdiwyCUQXsXduvpwg7vDyWXifHTH	1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1610	948	1	1	1069	jwWtZG1oKHfYALp4aE7oaSRe1FU9z9qEAm2Cu8ioWve1kc2Cu4a	598	836	836	1616089680000
1083	3NLUDRHFTouoztJWHCoCJN47VpecwwYoU9zRcQPMH9WpgrJSKzc3	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1602	1369	1	1	1073	jwg4Bd2xuyVNLF84VNTvznpj8vAENaFu6McBy5CEr6LHpYR8JR2	601	839	839	1616090220000
1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	58	1281	1	1	1074	jxYrQqsvhNoVExpofk7gZvgX3Rg7f3dLw5F7zZaiKVZBC3kvdEZ	601	839	839	1616090220000
1087	3NLHGmB1yZQjjGFWiCNF5FGYH8BLSt4EtpCrsCy9SbvgQcSGtScg	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1422	1337	1	1	1076	jwemL2b1HTJvN6MV2qAwbPX9xEPcrAU3SfodhCMT6PyF2AS3AqS	602	840	840	1616090400000
1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1531	294	1	1	1080	jwuh9ebSLkx1g3Xzub1n6shE1trjqazXaJrrn5pDedtvQn99h2c	604	843	843	1616090940000
1094	3NLrRXbJW4CYx2y8BXfUNniPjF1sGYjuGa49Gb7bCyxHGRSYnQab	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1403	824	1	1	1082	jwtGZZAq4zQMYFiQGQ7R2XcLStuRRYC4rbiq9VwQvu3z75UXPEg	606	845	845	1616091300000
1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1407	1395	1	1	1083	jxLyHsGCjFq4VqLnGdbavVdv9JQ1kZuDz6KYJcxz7F2wDk7aMeM	606	845	845	1616091300000
1096	3NLWogafJbTK3zeqrEehVs7yfe8ZhYjP6JLc4mYXDfPg5Vji16KJ	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1642	1367	1	1	1084	jy1S8MoF9phaRg67keDi48aKsExxb2tHrwWwJgefYo9rxpcDFpK	606	845	845	1616091300000
1097	3NKgbJw8og1uV58wx5AmTNAof2PQXyC7Zg8dj4PjhpHtm73TP9JD	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1407	1395	1	1	1085	jwnMW83BtzuMfNxfPYN4x6mvjdRFM8eadQZowhBzyU1zUDUfLpW	607	846	846	1616091480000
1098	3NLxJygTkcyKpo1MBZyUMGJqPRC27tYCU5Dte3Qey8piP6dEAZik	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1527	1047	1	1	1086	jxoGr8Mo5nsenwiZi2CHJ4ytakjXbjY6rNiQiWpNxwzjR9F9ZUM	607	846	846	1616091480000
1099	3NLgaCbqa1Hy3Pm291ixUUPri3zMa4cc6yub12egigdsn9tUErdp	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1490	1274	1	1	1087	jwG9fFhG4PRS7EtusRR6A5hN6hJ2GfbMb5PGHgLphTRWvviQFLR	607	846	846	1616091480000
1100	3NLBu8HNXphV7uSev97xGY5VxqUpDmvxpSNE623EY28S7Kd5ru8m	1098	3NLxJygTkcyKpo1MBZyUMGJqPRC27tYCU5Dte3Qey8piP6dEAZik	1650	1249	1	1	1088	jwTV4L1yWi7zSr7gZx1P1XFdrvhYBg7puvFVBLicq3T7dffDvfP	608	847	847	1616091660000
1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1100	3NLBu8HNXphV7uSev97xGY5VxqUpDmvxpSNE623EY28S7Kd5ru8m	1407	1395	1	1	1089	jwcuqnaiUhDQRkgtCDM5jDYdwvx9ejBEWyM7cyAA5ackhkrU9vf	609	848	848	1616091840000
1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1668	1124	1	1	1090	jxcmU5Dg1u5QAMH1aqzQUzUgcHCBQ4Y5EUmCHQbG234BeiCdDPq	610	849	849	1616092020000
1103	3NK7fHXJwH8nVU7tbZGWZgQTAxLLEXiSPdbPfXYwsPvyRXyNjJUX	1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1631	794	1	1	1091	jxjohudNU5Amsce6NsYbPFYnPFs7LwpmRAA8zajFifdt9DtHLpm	610	849	849	1616092020000
1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1445	1290	1	1	1092	jwr46d6DhXqtE7hyXx9ReKJ8gjZSLem6QxRQRTU2PWCWxRHexKy	611	850	850	1616092200000
1105	3NKK3t9hnMJfD5JwiaXHHzcZYu1YW6kPoTC6zqtF6bcbEbCByzj7	1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1559	1353	1	1	1093	jxrgdk9VZ2M3Ym5F3B4NHQQkivW1NG1kfDztEBBeNJ9TL7CZCX4	611	850	850	1616092200000
1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1406	1393	1	1	1094	jxeBqpTFX4fWJqoZ2oyz5Bp1RN8xNMTM6Wom2GDAVP3uNgpNvxP	612	851	851	1616092380000
1107	3NKoSbnJe53Zik8KHWaWpvC9jWQm6nKHT7xzAWES8cz4a55wBMbf	1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1500	1051	1	1	1095	jxj5c58qiwRb9Y2b2yKoepX8VB9NX8Qqh6Yrxxgiip3WFWpRnm4	612	851	851	1616092380000
1108	3NKjnRUBuWkhsYrYvvA8HA6erdwqmET85H13B48DWqWbFzewEXiy	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1670	916	1	1	1096	jy1znkpUC8r8AQ51xeP8JGQEtQcUCkdiXgfHB6PXKZdFmsTAh8C	613	852	852	1616092560000
1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1406	1393	1	1	1097	jxGXVJZ4LH4sRYQD7GdXCwcsuAr7NwiWPMN8TMpGKjPG2VnfEJ4	613	852	852	1616092560000
1110	3NKL3RJ3DKakcTxk6QagX6EjS9n9SEqneuQPJq8LMzbtemok84Fx	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1608	1289	1	1	1098	jxRccvmdMsQJcwmwd1ptj61VAYuxjhXE3n4hxZtGXPzRjimvTsE	613	852	852	1616092560000
1111	3NLfkR76TYArhQf3ikcc3RJBh6oNKPSNHreNTZg8RQujHeESSUkp	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1541	932	1	1	1099	jwkX6jFB6fwm7oj2Us78wBSXDW2TKDDKvetAJpc2P2b2Y6QpChN	613	852	852	1616092560000
1112	3NL68YvDFuia7S8xosf4FuSPoxqm9aycoUdoFzkapChkexYRyanB	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1523	1321	1	1	1100	jwZGXW4rQZgLezZPsaTPWrYZGsoBd71dzoGeSDiC5CU9HJ4AAZq	614	854	854	1616092920000
1113	3NLJ3UQbPuKoTM2mqnfjPWiFEiquoXncG3cx8di3arVdbxUc55xx	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1506	1373	1	1	1101	jwwzJUPDgEudm5EmxE9k4a1LnZusFxjiXgepRmjqMAWAH28u24c	614	854	854	1616092920000
1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1477	1350	1	1	1102	jwn2tjJVND8ctgnWJUqyv7jPAbzHsCeLNaLwUYsNp9odfkDp9Ma	614	854	854	1616092920000
1115	3NK99UV3oXM18dw61AqDY5WTf5zTc5C4gGvEvShCSg2bEuxPgHn4	1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1534	1191	1	1	1103	jxW1goeLQ8vZ1MeeUh91tS8KxVekHq3f683wV9xSMvQa1BTJMyg	615	855	855	1616093100000
1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1447	1345	1	1	1104	jxds8kn9xqBDXvmeocaxVQ67zesVnwh4cEjmwYEDShxYu3aTdNz	615	855	855	1616093100000
1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1403	824	1	1	1105	jwBPyAMqrhoSBTQNC6PAQMZYC6gc2HPPpYnd7W5arv6TB4JGVfw	616	856	856	1616093280000
1118	3NKDEw4rXCPoHQxVG21QN6dwfGXBeNkXuTq5ffSUpLk2mgy2Rj9D	1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1627	1385	1	1	1106	jx7qttKXkHjsZ7DqJ4xS8MGtcbsAr69nJJPZMCNEZTHfMdXou92	616	856	856	1616093280000
1119	3NLhYeGGifKgYaeJDmHuekMFTibasEmUUrquYk1yWZTHNFdUCj6t	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	43	1310	1	1	1107	jwWfjUxULd3sS6vkEMBJjv4JysMipT67H4v7TQqE9rXV8XtDKb2	617	858	858	1616093640000
1120	3NKEg6JevvXjyweh3k6Hz2FQeLn4Prrd9cJSemnUjxTs9P5SKVJn	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1637	816	1	1	1108	jxn2F65pfW65Dx26tDLsmPn989eytozPDxvbZJ184apGnNxvFf6	617	858	858	1616093640000
1123	3NLHHuT3iAfB867LuBfT6knyCAep5nP2N1HFXeYKzgtypWEMWBYs	1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	80	1273	1	1	1111	jxfT1Lm3qbJWgUJrUJtV2tnvm3gfBZFmftU1piHwwq3ysysUtbU	619	861	861	1616094180000
1126	3NKncLXAovbVPYpAcEsSt1xYebLqoh1EUE6GPviNiY7WRqCc7Lip	1124	3NKUBTrWHVnekiaQHWpKirHAmmfD4NuUf7s3NECdcm8ZkbsRWdpT	1403	824	1	1	1114	jwPQx1SsiCKeMHmBPsr72nLC2UvX4BsHRveQF4AdFvBJcXRqUjR	620	862	862	1616094360000
1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1126	3NKncLXAovbVPYpAcEsSt1xYebLqoh1EUE6GPviNiY7WRqCc7Lip	1483	1150	1	1	1115	jxMWxWU6Jd2XGk4vapBeW29L8xEkp1NsuVfbFVww57cwbij5xQM	621	863	863	1616094540000
1130	3NKrKNWjdUw1s9QAonfMxQETAUp7aSfQthVFn9AnBQYRxs8vkv7Z	1129	3NKcKG9d9ntHngatKU8W6XaSMn8dpzpn266WaWiSWNbGUmE425ZB	1406	1393	1	1	1118	jx2AGXBmyoJLvgAom896qp67MJokTibf47GYCVAfhi31ZZRiNqW	623	865	865	1616094900000
1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	1476	1371	1	1	1123	jwDSGxpwFeCw8cJ2e8ARNQc6wSnR2qxuYt7Dc8yQq7KYUAhSSVM	627	871	871	1616095980000
1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1483	893	1	1	1128	jwahchGcKhZTC3hpkw1y2u7CzALMY6PGSvJnQ1mua5pyBb3BPUk	629	873	873	1616096340000
1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1402	852	1	1	1131	jwxX6w7iiZTjFn88hTeAxuahmKJauLRzNzF4PcAu5sA15kqx8DZ	631	875	875	1616096700000
1146	3NKDToQQekbsVJ8wLs896rCvy2LdRLqMzWEEAFtWLxpEiK2bjSsy	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1403	824	1	1	1134	jwHmLGdmRXQK6TQeuK8QSjA8FGuXhpb8sokZGRr9vR8SEMXyHum	632	876	876	1616096880000
1149	3NKZPz93ghKvXGSBGeFsAJu7mTmU1JZzSX9sPyNvRJwZ6WJ3Zu3A	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1513	1379	1	1	1137	jxnAL7rxCXXpaaSTwjpe3aRPFys7RuTT8kv8cPxqQLkEi4F53ef	632	876	876	1616096880000
1152	3NKB5HozftkwYM8xzWJKSxg2JJgnx5rmZYvZwWizPXtEy3u3zj9k	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1406	1393	1	1	1140	jxcrFf4p6w9EJy9KDwq2MuzjR8VP6t85ZfNoUFPXx5XD8RshVux	635	882	882	1616097960000
1157	3NLXUWg5Df7CNctB95NgqMf6Aqqd6xDrWUvQWEQPdNFbhcxHKhY5	1156	3NLHC83JNXT3AbLWWr47H8cjamUV5WupgFnQNNXGXKvwdtBSFqVe	576	1355	1	1	1145	jxDdM1WQuoQgUiH38yAFRrvsXNZGdnpLCLSkh1XXeHd5j3KFDsk	637	884	884	1616098320000
1160	3NKDLWcUsrBAEBxBecC9JZ9vhjYTuwtHLQmWNoU9HAvU4uewYfvb	1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	298	1308	1	1	1148	jxXcTY8eBiYvdKwBCvrJLi19sEBCEBYP2zckQH3SpBFJjUy2n9x	639	886	886	1616098680000
1163	3NLJc6tqBSB9oychfkaQjkFjKg19miMH7pw1prHGJQmcRrW9QGSt	1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	633	1384	1	1	1151	jxARHpWrECyNEfThz7YeKwr1nLCe4YBwVU3M7YFrWQCs9pGGLVt	641	889	889	1616099220000
1168	3NLTWQM8BwFL49TEpZN3YEhKF4zZsUmSpLJFH332kgwcrfAxtUZB	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1403	824	1	1	1156	jwRY2YwXCSEv7Wb5wsEyFmob84qa8u76uPS75f1tuoWCCR7YHt2	643	892	892	1616099760000
1172	3NLWNHLsYoaPXqJGzE97jBGkyPvTLEii5nvSp2qBSWGBvgqqZnb4	1171	3NL3STGisLGwAGU36ce28KfMKBGnSkmABYdostGGgY82NXnCaZbi	1546	1213	1	1	1160	jxnGw48ws4wNnrfrZTTo24kJD4FudouuvtRQ9WcruBE6jTbsmW3	645	894	894	1616100120000
1175	3NKxX8RBWHumRQL1Dy7sVbWgZx5z2mk1oQE9PciS5zmZCJRRdWiH	1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1581	778	1	1	1163	jxnUYgb4xtg1kfwvu4SWrx9tPgpeemY61AydSxfKEVKzEfvLiL9	647	897	897	1616100660000
1180	3NKKYiZHchb9weFbJPMgr486cq1BFiUJxNanZpTvTuad2MjfVGL7	1179	3NKwQrCyUyPj3bZG3V3iVUu3hrAVoyKPNkVHTpWFkRXgw2UL2BVa	1403	824	1	1	1168	jxpuMUZdDSM82zYHfhQVYFbLbrfDtBu1kQvz8j2jsvaii4bTfGA	651	902	902	1616101560000
1183	3NL6RsrL2hjWtad6shrpbqfmi3YdAfB8Nhr54nTNxkbrRCGN7tpU	1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	311	1307	1	1	1171	jwtxzQT7jWzXwVkwUkZGqdkRdxmCgqY2Ssk9XVVGToMHTQ1SuiU	653	904	904	1616101920000
1192	3NLsuS4p1U5M5Y8BnRzxeYnbRCF8ZFWTukTqYrmApUYr8ejZcd2C	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1483	520	1	1	1180	jwQ1G66z2QGU2caoTL1UXrp5hsYKivaTc8M8xYgYFXiRTgx8Sk1	658	914	914	1616103720000
1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1406	1393	1	1	1183	jxJd8R7f5s7y48dQQ8oUxaz6b6pWxR51fdMmCVRSBsA1xCTx4kh	659	915	915	1616103900000
1198	3NLHyYRQR9seC6SWTsdreooZFBdo1j8gyAzrQ3Bp23oVsX3tr3xb	1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1481	790	1	1	1186	jxFPSyCZnVxwn2uYtebLWo8cRXHqPfURML4Q8AU75jKWdV3zwg2	660	916	916	1616104080000
1201	3NLf7o3f58S67L2469JZ8QXoQvsyY2KruGaUcmpbiTwKBjvTjomx	1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	700	832	1	1	1189	jwzzCoQWsAxgEFdK4hsWYytx2maL28kXHxALb7nqzCJazwD9FQp	662	918	918	1616104440000
1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1201	3NLf7o3f58S67L2469JZ8QXoQvsyY2KruGaUcmpbiTwKBjvTjomx	1406	1393	1	1	1190	jxwijipiE41WBvTcqpZXATn82WHxxfvU4e34E8BkUkrPmTBGjm1	663	919	919	1616104620000
1205	3NKRdJGTLUGUXMnekiTA5U78mDkjPZ91bhB4DdtWjVncEHxGUUXN	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	44	1325	1	1	1193	jwznK8hqyvvhTz9wonNkiyUUqBJPmE6RqrNCtpJu58f6DUB62xh	664	920	920	1616104800000
1217	3NK4Bb83CNaUd3zU9rh238d9oVThm7M7mfX38D86xxbJ3mYciT3Y	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1460	1078	1	1	1205	jxCS8JcrXTcceRAkmV3SaVbGJF9WR4XNksaxknUZZZbznTXHmHX	670	929	929	1616106420000
1220	3NLFQuDeREdH5WnXuegpVBa8KLNMSdLydBfrfiHc8SCBcicwyN8t	1219	3NLwuHvciBeEWvuEqMsagU828qAvF3jBMxAptNFyvJ2DFRzqRiRn	563	1113	1	1	1208	jwHJfAqbY7KDs64t2xtu5rjhs99R7eHac339zW4fYcn2bpV9mf9	672	931	931	1616106780000
1223	3NLsWAFJfG3K7VA2QY9N5XV7cbkfBMQbFWDDeJJgo4hSqijtokKu	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1589	1160	1	1	1211	jxWf7fkKLXWB25EwAbBwJGdNYMhUCiifEMocQxiywSSb7GyXrv4	674	936	936	1616107680000
1226	3NKPtj4yWQrGymtFQZXNSiUQd47XgpmPAzrNYEwis2ScfafasLHa	1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1406	1393	1	1	1214	jxSh2juA5uafZ7tQQWuzGvTM4W5XvzXKVxcm75xQdeTjk7HpfCQ	676	938	938	1616108040000
1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	1228	3NLAbccH5GLR1NyeSLCE1pt4KtbK5gp5HDdLdv1vYNSwUpfnnS7p	1549	996	1	1	1217	jxw6M8fFiWRD3YtVkQXACF5TTuCchAknGTLX1MgdyZXLE4Tc175	678	940	940	1616108400000
1232	3NLd4wid7Ptv8zCs6W9zje6eeFR3yBJo4VZkZsaBh9xz8e7QV2jy	1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1403	824	1	1	1220	jxATE1mPaZnZX8dcv3rynE1WL3di9ZDvuFrxK1WHfiduuE5sT4K	680	943	943	1616108940000
1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1234	3NKgwunF69gUBVEGD7yYea2RsxSbQGoTwtK8THFGNABk1w8UqReL	1406	1393	1	1	1223	jxsViUaR4ZUgs8sNJCQuCZjpYqMr2kkBEhdLF1uunFoJR6JvkCJ	683	947	947	1616109660000
1121	3NL4a8k48MpKUtMj6vQn9StXc72KA72pJa2T9yN6HKpJ1gSacdod	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1623	830	1	1	1109	jxmrYL4jTucQ9mBajEmvJFSJfhgHoMLgSFSGS37Fckj7vCArLXW	617	858	858	1616093640000
1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	1121	3NL4a8k48MpKUtMj6vQn9StXc72KA72pJa2T9yN6HKpJ1gSacdod	1406	1393	1	1	1110	jxrMt18wZq3xTbY6KbGwoSsardTdfKVKKZ6EFLueiwbZHW4CqA8	618	860	860	1616094000000
1124	3NKUBTrWHVnekiaQHWpKirHAmmfD4NuUf7s3NECdcm8ZkbsRWdpT	1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	1403	782	1	1	1112	jwFUtftMS2BnSV71tviYGoxryMPqnYTsmeEf1AoLCbMF2N3ffyA	619	861	861	1616094180000
1125	3NLoPbdNggPdfJUgtg7xpRg8oWmTXzj5ivHxP5XpyPNGvgrYSB9e	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	80	1273	1	1	1113	jweZqHmPBFY54kzjPPCx7gKC4W9ach5BBwVwPzxnQerh2NG6eAz	591	861	861	1616094180000
1128	3NKS33KYdWBcqro2UAzrevFG7AWNiFirSqHEAsWZVq6q4E9AaTR2	1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1588	1392	1	1	1116	jwwTWZZWcrwZCVXXh2AHQXtZw1XTqpELpNYmXrNW5TyiovkanHD	622	864	864	1616094720000
1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1130	3NKrKNWjdUw1s9QAonfMxQETAUp7aSfQthVFn9AnBQYRxs8vkv7Z	1447	1099	1	1	1119	jwgn7FegHjkAbdTVkWCsrZHfzRC7o1MyaG4tocBfdZEqSUtd7mM	624	866	866	1616095080000
1134	3NK8b1fRXnJnqUcY7TJxnxM6rb69szBrzkF2nXcJvboRUTU1nHaE	1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	298	1182	1	1	1122	jxnTDji1frC1Fe3DBKe8emn1uSGFyV1voxzLLR8YnAaHYKCHQef	627	871	871	1616095980000
1137	3NKrMphnBpvXRWEMiW9rQ9YLGytLYLKbtu8bAgZyarPVj1mfon3f	1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1651	935	1	1	1125	jwKNvLAAYKMTeXrMcmESBaykLTJGz2kBW4bDnndSLcme41YEU5m	628	872	872	1616096160000
1138	3NL6XHD2yycDdKHb5GUHZDsfRS2NDQm2sNEhgfsFZ5uaZ8BNbfEh	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	369	946	1	1	1126	jx2C5RZks1MJpnG223BnJDi5Qet9YQf8LGaZz1kCGb2o3qv9EYk	629	873	873	1616096340000
1141	3NLvbs3S1rRB1pDoXcxUg6UUXvEQBpHDhXTnALvdDTXMzU2RXKMP	1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1460	496	1	1	1129	jwMCWB511MK98oE3C7pCnHPfXRJx99CBMN5m2iGCDdrMT1NRAvw	630	874	874	1616096520000
1144	3NLgcYv4nPsd4kdKTvipAxWuEFax5qgvQAzhq44tqrGVKmdhUXt6	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1672	1159	1	1	1132	jwo1tXeUsjgjYkBSz8RYNwuw2pb9o9N8tkqbPNJxKWgqpfASQXh	631	875	875	1616096700000
1147	3NKbMu3pmNu7wFTcPziBvVvScfKN3dMMsA9YP9gNC1JrSAb2D5ZU	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1407	1395	1	1	1135	jwK1smgtTgb7hmRm8MyftGKnZkCFwr3qPmB1koMx3YhKhTZ7qge	632	876	876	1616096880000
1150	3NKfGC21ujdZg3bYrXeJ1CxcJ1r4pLDCu8bMy3CSJ4njud4bf5Nx	1147	3NKbMu3pmNu7wFTcPziBvVvScfKN3dMMsA9YP9gNC1JrSAb2D5ZU	1467	1376	1	1	1138	jwNHAnEa46ij4ZYBo9n9qfzcF8Vtsrmsv1sRD95FTWbVrAUPFL5	633	877	877	1616097060000
1153	3NKHnaF366qzhxRG81yRCH6fMMU56stMUKURhYakjQ4wEDDSMv6m	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1405	875	1	1	1141	jx2GNsaQsB7UVDsDGq1MvAhXqqpQ2RLTWDifrEGts3PFGuuebFD	635	882	882	1616097960000
1156	3NLHC83JNXT3AbLWWr47H8cjamUV5WupgFnQNNXGXKvwdtBSFqVe	1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1631	794	1	1	1144	jxe2rMiDXPHUmraCjE1TxAhEr1UtVTsNcgZM5ffXzN9NXAYpFQf	636	883	883	1616098140000
1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	1407	1395	1	1	1147	jxR3gRqypAvALjvT1cvcc3RjZWWzBpatS21awNPALKq1HbX92nw	639	886	886	1616098680000
1162	3NL67gL1n8SyzLRgAVxQZSqDUNENiRAuj2NAQjDB8AxYEEDko8kP	1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1445	1164	1	1	1150	jxsxEUDg5k41s9e3TAU965w4WEJcgk97Nr1bqXyF4Y3WNeo3C6U	640	888	888	1616099040000
1165	3NLnvokp6D82EJ9AeCjQX4fxTtbUBJGR1QMWS2oDPbpcbFThyFS9	1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1670	1282	1	1	1153	jxQXuGLpfNjvCFN722zP9nTw97bPWCuJCzK1YKyhJbY3oy867MQ	642	891	891	1616099580000
1170	3NKvxiZ9hGWAN9qW4KYi2VPW6EFy2FXxPqyLZRtVY9AL7mpYCqtS	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1559	1353	1	1	1158	jxXH383z87eHUs2yFChvW3YuZYkR5pvEPBt4nYPNVFr6zPUUaXb	643	892	892	1616099760000
1171	3NL3STGisLGwAGU36ce28KfMKBGnSkmABYdostGGgY82NXnCaZbi	1169	3NKpu8E7qb4JksnfqBtpGXUF8ecPYz5yHKFLoh92i1cxYjyQFEEt	1402	34	1	1	1159	jxXoSQ8xrMvdi4yC8GWCDmMtbkPovWHmhXDqbYmxyAvnzGdnwJR	644	893	893	1616099940000
1176	3NLYgg2qbWSUxxyCzEjCJyh1RpTtPqFA4w5UtXWoefpYLEKjf78D	1175	3NKxX8RBWHumRQL1Dy7sVbWgZx5z2mk1oQE9PciS5zmZCJRRdWiH	1518	788	1	1	1164	jxkjJ73pTmgqxcGfrAJGrFFSc7QkgG4L6tmFimuxQxzMpRiWWLg	648	898	898	1616100840000
1179	3NKwQrCyUyPj3bZG3V3iVUu3hrAVoyKPNkVHTpWFkRXgw2UL2BVa	1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	1553	775	1	1	1167	jwyeKWHayLML5VLBm1fhQvLTJX7bccMvGbUmWvBM8a8ZE3JajYL	650	901	901	1616101380000
1182	3NKSecfXhaxrViEU538jKsyA9qYH237ec7usd1pr1ApZgdEzH2sJ	1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	1406	1393	1	1	1170	jxVRPWhAAk3Qs6htuyhos7nto6RDG9efDoSBwEwehjHchbCixRN	653	904	904	1616101920000
1186	3NLjBffdssnWyhB47hPPZchuFzLHmdeD5FczdfP51ZbG1uVNBv23	1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1402	852	1	1	1174	jwrzNFRKgRTT4DJ1nxSoCHYh4Z1uRu8LNTJndKKfxpYQ5Qxr6GY	655	908	908	1616102640000
1187	3NLdcCqH5xuLVFyGjTxhKuWYwYbNefekPS7GB2mHEtZa7navTvfL	1185	3NKFjdiKRTohpZajdH3vnfvrp3mAP3ttuvr6USFdNKdxhKrfJQd9	1560	1291	1	1	1175	jwfKE7ZMrNU67YPWMQGcdYSuvo82JjX9BYcrtRAygb36CZ2vQZS	656	911	911	1616103180000
1189	3NLSrfwZh3ytKmgLJ2URddbE5w6MYvh9FnL6Mn5TTpWFpWwQr5jY	1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	1560	1291	1	1	1177	jwjmApGayQH7SJoaxNsjaLMTFLsn2aZQwyr2QELCKjTJvAFFpac	605	911	911	1616103180000
1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1187	3NLdcCqH5xuLVFyGjTxhKuWYwYbNefekPS7GB2mHEtZa7navTvfL	576	1229	1	1	1178	jw8dv7pzSGMou78QDpGDbmmpVejnAy5MUgAg3K88sCDQt9AZX3A	657	912	912	1616103360000
1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1650	1009	1	1	1181	jxiR7qEAc3ApvtZ1N1Erq2xAVSRVdexQFCLf3YhgxVNz5srGNjw	658	914	914	1616103720000
1196	3NLkZrFcwUYTyrAmf4qwbvcePHJkJdzTT7rpFrsF6U6yCK7oqmCn	1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1513	1133	1	1	1184	jwFazx8s5GcpGQ3QgVSyebFQJsgTJNYYQRGwgP4qCeqdJMrKmxy	659	915	915	1616103900000
1199	3NK99hGwo9zVm3bJ1SRkX3C3Zv7WDub9gTdx4MujjXDWohyGHVFC	1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	1622	990	1	1	1187	jwyaRm12YDu3QUoCYfzqDHCr3daj5kr14jaNP5392v21ywQoNZp	661	917	917	1616104260000
1204	3NL1mtdjnRm9ZVXHyYraLSK1Qq6pxdYm2FsYekKNRfuUszjF6u7N	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1407	1395	1	1	1192	jwmmU8p7esLGu35Cqn5B3dxa74hMNHinCmQPcSTzkCvvWmii2F4	664	920	920	1616104800000
1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1204	3NL1mtdjnRm9ZVXHyYraLSK1Qq6pxdYm2FsYekKNRfuUszjF6u7N	1608	1289	1	1	1195	jwe9UX3dQqNde7nfMfMdKoUdbHLCBk4JBuotwnCC4fzRyg3merX	665	922	922	1616105160000
1129	3NKcKG9d9ntHngatKU8W6XaSMn8dpzpn266WaWiSWNbGUmE425ZB	1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1501	1360	1	1	1117	jx5Pcua3ipXB6kceasGUcccpgWZnGwj8G9yu9HVipfgwyxJcko3	622	864	864	1616094720000
1132	3NKyXT4WNvNQjMVwVLdg98362kwPACaygj1AQcdQqpkoi8gGQ2C8	1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1637	816	1	1	1120	jxC7UDWKJ2MXw1wXxQSvCvekDXPS3BG5itUPk2YRVYB46YmBtCA	625	868	868	1616095440000
1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	1132	3NKyXT4WNvNQjMVwVLdg98362kwPACaygj1AQcdQqpkoi8gGQ2C8	1581	778	1	1	1121	jx68dU9FahE9P1tUAsvtu5BbvtzDNehDqJqEC7pCxEzYq5hgfJk	626	869	869	1616095620000
1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1444	1135	1	1	1124	jwezBa2fAYQcm74P8QNLgfmEdj2ZKf2qVpR9PMtQA3t2HN7CL1m	628	872	872	1616096160000
1139	3NLXGvXLEAg1YFhiEbTAgYhFNyG9iz5U8MFbLxtSK6BYa9pAikXz	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1578	1050	1	1	1127	jwyjxTKpCR5gJJPjt4rfus2eVkS1Ch9WPKAbv9oiizSK9umXjXj	629	873	873	1616096340000
1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1590	934	1	1	1130	jxKBc94PngixrrYYLKKzdimUnGAH7YbRJfzzZyYm2KE4vnfTHJx	630	874	874	1616096520000
1145	3NKVJREkMnTjcEJA6tL7cRKepQXLH7YvifAPtkMheJoin8kCh2eu	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1631	794	1	1	1133	jwpy27ETJVpR7Mpkq7nqGEuTikyhvshNW16HMU9QaxCJtjEhTPY	631	875	875	1616096700000
1148	3NKCdQW7jiFAscKviUFh7GHP2pvSfJ5eC1b1CEaz2JoFnN1RVSkS	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	448	1305	1	1	1136	jxzzbAntyV7WsNCkJgdBfGUXFVxHT5hS1KT6Hm9U2yAvRmS3obP	632	876	876	1616096880000
1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1150	3NKfGC21ujdZg3bYrXeJ1CxcJ1r4pLDCu8bMy3CSJ4njud4bf5Nx	1501	1114	1	1	1139	jxXEvf4KKTQ9nkWdzJbh5dKPY9vAkkhXg6bpvXZenA2g6E1j3Ue	634	879	879	1616097420000
1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	363	363	1	1	1142	jwpgwgUADpAZ7cmAhLf69FkqgvFgogGWsLmA2qkEzUHQjqJsV22	635	882	882	1616097960000
1155	3NKqN8ZTQB1qGcrL1hX64UwYXziRMyYYJsdPAkxb4h8RwLqs14cH	1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1541	1298	1	1	1143	jxY6T4wCoxtqk9HixEYCdu5PcAAYmX6yhAvsPQcQQmPikJYgjuh	636	883	883	1616098140000
1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	1157	3NLXUWg5Df7CNctB95NgqMf6Aqqd6xDrWUvQWEQPdNFbhcxHKhY5	448	1059	1	1	1146	jxQGALdkQ6Ynn3RTgqWqzY5mqYiPj9BhP9SKaBQjLZA3frxeqLb	638	885	885	1616098500000
1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1406	1393	1	1	1149	jwrnRwkB4VrFdqhXQrY7WTYdPofiL25oHfirF1TxdpGFnkuvSJU	640	888	888	1616099040000
1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	1508	1021	1	1	1152	jw8LwNMjUxbhuZYDU4V9pJ9WF838xhsi2LgjMvDg4wqADyEnpzU	641	889	889	1616099220000
1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1536	1313	1	1	1154	jxSo9M4Zfre28dfo3GSneC2nqfWm5wmFe2n2XRHaVVzFQtfcMAN	642	891	891	1616099580000
1167	3NLWRMT48QKZXCb8HwsFCQygPGoEa5oJ4VbbfpoPft4PsZgC6KJQ	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1671	1119	1	1	1155	jy1CuqQ51szmvK6k6e1LnsUGACkuFq8coH9TkLGBNMSvJPxYoWY	643	892	892	1616099760000
1169	3NKpu8E7qb4JksnfqBtpGXUF8ecPYz5yHKFLoh92i1cxYjyQFEEt	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1407	1395	1	1	1157	jwUvcYwx7EzH9KwsQABuzc6pPmCBYdFZf2FqpppwT95uBZ5Wtz8	643	892	892	1616099760000
1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1172	3NLWNHLsYoaPXqJGzE97jBGkyPvTLEii5nvSp2qBSWGBvgqqZnb4	1407	1395	1	1	1161	jwtnFNdWvD8YzPSXV1ej194bUS93QmoFHT9yWrsgdBRWqcZe3qA	646	895	895	1616100300000
1174	3NLCbN92RTCeWywfMc3svbzXsZ92YR7dsChJdU4yb5NrkLaE1gvs	1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1657	1344	1	1	1162	jxmZdCpKx6VryUeD1pNrPBQpp8Wccnm4pwcZVwg9ubXcWxd7gAM	647	897	897	1616100660000
1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	1176	3NLYgg2qbWSUxxyCzEjCJyh1RpTtPqFA4w5UtXWoefpYLEKjf78D	1552	513	1	1	1165	jx4WnAqfkqJFWzm5q6TbDqrxJ4tKv38MTRoXopqqv8LYRtnMzEL	649	899	899	1616101020000
1178	3NLQX3NVXiWrqgpm1tr4iC2tvPhip2HvWpwejComHhYoXNqVX2CA	1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	80	907	1	1	1166	jxwCER41AqJdJ258mCv6qNsCCe8j31qxbDPhzK99UVUa9YiZBEt	650	901	901	1616101380000
1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	1180	3NKKYiZHchb9weFbJPMgr486cq1BFiUJxNanZpTvTuad2MjfVGL7	1405	851	1	1	1169	jxPQMgeCdHcDrKDS98yyFNZbT3g1fpsaxswmcVA6YmUzcDDqHu8	652	903	903	1616101740000
1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1183	3NL6RsrL2hjWtad6shrpbqfmi3YdAfB8Nhr54nTNxkbrRCGN7tpU	1596	1363	1	1	1172	jxBeyLQHMNrPyxCTsnGhgcjkwr769sjm23j6QDLepDZ3Xq1exaz	654	906	906	1616102280000
1185	3NKFjdiKRTohpZajdH3vnfvrp3mAP3ttuvr6USFdNKdxhKrfJQd9	1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1534	951	1	1	1173	jx8wk9zhWc8yrAfv98mwVS3skdATgo5PuL1PibSWCPCvRYbN4WY	655	908	908	1616102640000
1188	3NLaXZY7wEGsdjMzJxTTBuheExn7xB4dc94H69N2A4wPkqaWjrax	1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1560	1291	1	1	1176	jxJSedbZJrJBj2prkDK9ok24x7Pr4uwk8XsFybmShoHdGoC4DFe	625	911	911	1616103240995
1191	3NLPAA1AccGmqMF5FBEE5nPuRYT2iUD4sDTi3WoW16apBanpbwNn	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1608	1289	1	1	1179	jwFxsdrD9ef1PbmdzUsntKo2jbcjVz4cVn9w9ak8MAgA974kYjX	658	914	914	1616103720000
1194	3NLQhkfRdkuw2yFeL5c8ozW1yXAwNQybDGFBM81TXiw1TUwqATmD	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1581	778	1	1	1182	jwdWnTHySWjW7n7wYdbSZbs2EePKDHJvYyoNczmmR261g7x28Ha	658	914	914	1616103720000
1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1402	862	1	1	1185	jwzXqVMp8gv9XP5ZfRaggG3dfMoYKFwNx2UnVPsHGyPjQQQyKTz	660	916	916	1616104080000
1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	80	1147	1	1	1188	jwVVBWJRsZoERczad6RN6613E6ifBR5tbCDES75bT3haCTU2vHf	661	917	917	1616104260000
1203	3NL9adJrtkg8zUC5248Hc8DCyank7rBEEY8ygo3gCP8XJ7PwnZyf	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1406	1393	1	1	1191	jwgTyK9bVPz8FCpiKFkGYqxvWWnsLnXBg6bY8tWw4CGvk1Sr2wQ	664	920	920	1616104800000
1206	3NKgbb9uCNBCbDbRSQ7RbYc94CTtbZHb1956RG844BWKYeweAsEN	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1573	1318	1	1	1194	jxieSK6DgCaN3XJ6stkmPtJm35FGppQLdSgfLj3h8Ye3GWaNUM3	664	920	920	1616104800000
1209	3NKhP2vRVkoTkwB1KRC5nLUQC1nW1kkM14zPxDiFz3Kmdx4yyhTE	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1529	1316	1	1	1197	jwXRNELLWgTAea5sNx9ESoTkAjcjSG8RFN91PbhqCwrXKryf8Ck	666	923	923	1616105340000
1208	3NKDDJqB1R5rKQ7aeMkEhP6tD5pCzBegvZ9Nqg511A23mmqnymkB	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1634	1085	1	1	1196	jwyLyPLWEpyqApiipuumyNDN6kWHtmKbSyZYTGdzzEaZJd6Z2sA	666	923	923	1616105340000
1211	3NKFAatRdduSGgfPoqeyx7o7krdiQjZ5SftnA1auU3AzuKpxC3YF	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1439	1279	1	1	1199	jxsdFYyixAL1nVcYUuUQfWPgT1L79XBbMJEKWrnW19MRVsTvV51	667	924	924	1616105520000
1214	3NLXgxzNhmvqiY6GT2RXe27WMHWYwfFe5ajf3td8p14iwmJxv5j8	1211	3NKFAatRdduSGgfPoqeyx7o7krdiQjZ5SftnA1auU3AzuKpxC3YF	1407	1395	1	1	1202	jx3bkozobrZXSRbSjpTwV3TRdC8FbpYND9awtLutd5rbC4gsoMo	668	925	925	1616105700000
1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1214	3NLXgxzNhmvqiY6GT2RXe27WMHWYwfFe5ajf3td8p14iwmJxv5j8	1406	1393	1	1	1203	jxGEtjhx6krmGqKN23TovSfjjLocamQGtBpmUmbnedjJCsyiNiX	669	928	928	1616106240000
1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1220	3NLFQuDeREdH5WnXuegpVBa8KLNMSdLydBfrfiHc8SCBcicwyN8t	1455	1332	1	1	1209	jxCPPifx2LRxzQN8GRBZc9KFjaE3sYzmUUJM5hfmANFKpt7MjFo	673	933	933	1616107140000
1224	3NKm8BuFVmhBgq1rSFSCLUiwTHnhDQG8bBp7wDmke9QKanoGawLU	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1471	1020	1	1	1212	jxG3ghVMAR5Sm221gXmz9vMD3pLkpLUfHHW4A3to5ja72yMJ3pd	674	936	936	1616107680000
1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1224	3NKm8BuFVmhBgq1rSFSCLUiwTHnhDQG8bBp7wDmke9QKanoGawLU	1402	862	1	1	1213	jxeCzF3VNCsHub9QsMunFWjVtYnHPTAtwNJnbK2JKrQBKCQsHAQ	675	937	937	1616107860000
1230	3NKJSV8a6V35kWXSUa9UzX3qRWy6eL4GySy3VySDmy12sjaF9awc	1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	311	1061	1	1	1218	jxr4FhPNJw745H2eYXEepKUq3YtJmAMZXW5CFYuMVQC23Gm4uB9	679	942	942	1616108760000
1233	3NLKBySStPFcaA8SjVzUUN1aTy6WnWZ7PzZExWbmzgjKbN6tXWVa	1232	3NLd4wid7Ptv8zCs6W9zje6eeFR3yBJo4VZkZsaBh9xz8e7QV2jy	1648	918	1	1	1221	jy2L25YTqvQS1wiCj9gvxWLPyi1fa5BLrnP5NgYNrcuHsjQcZgG	681	944	944	1616109120000
1234	3NKgwunF69gUBVEGD7yYea2RsxSbQGoTwtK8THFGNABk1w8UqReL	1233	3NLKBySStPFcaA8SjVzUUN1aTy6WnWZ7PzZExWbmzgjKbN6tXWVa	1602	1123	1	1	1222	jwCXrPFJTzc6a7WLQbKVdAVo9Y21qaKNcEzc38hTxr1tsSXhCwZ	682	946	946	1616109480000
1240	3NL5Nd5gp9cPduqTSGevfGR8HZmmKmXoGphTxmhzjVov6kkJf9k4	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1634	1205	1	1	1227	jwMf8Ug2SRvutCHmo5wez27TAdZ2HB476hdZJqJf5DrUr8nCadk	685	949	949	1616110020000
1243	3NKoVv265cQuzTH4XAUHKGpWY3h3KiJC9BLmvTu1byvBSLrPNLqU	1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1406	1393	1	1	1230	jwPJnaVguEGinAFMVw84yLYUYn7w9g9NCJtQjE26tchRaUyB6qg	688	952	952	1616110560000
1253	3NL8zNLWHSx8zCtwS6fbFg7qTAkwJJmtPoT1ktYS8j5iREwh1f7Y	1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1617	1288	1	1	1240	jwqnWyjb1dbrwb8G4B1mQt9hcBka6q4yHLBd8HtHMUS7MF41gNH	693	958	958	1616111640000
1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	563	1359	1	1	1198	jxAokq86Pfk4pEAzJEAicDpjh2t8bZ3rArMqwfosk9HRjkTwBcT	666	923	923	1616105340000
1212	3NLk23xubN8PDPwgbp8sA3fuKHSZgvnm96ZVGhMQn9B9788onfje	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1447	1345	1	1	1200	jwyUJciWiQyBJRfcneZvoqDHED9drV5X7uiQQ41VQUS9oeJFL2K	667	924	924	1616105520000
1213	3NLc1eiFndSnxU4XSCZ3x8C9JMKLcnc7yt4Xe5DkqZKs64azhcZm	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1631	794	1	1	1201	jwNUpjmXFsFeAUxhVfn4YHLwWgLFX1qryEAks2PuYpN3Cyzu2iC	667	924	924	1616105520000
1216	3NLnVedhmMBpXd2R6LGWY4dMJDEworZ4Y3i7T7Hr35WWSN5NXTmz	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1503	1031	1	1	1204	jwUcbGgaFazwecsN7YRk1GP9PHpBBppNZkCNuL4vCJ175kewxn7	670	929	929	1616106420000
1218	3NLnuKnb3mMPCCahgi3fNDzkXNzNSBTTFYBAYq83sCpyQjAtG6Fa	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1555	1101	1	1	1206	jxa1MQmmSGDkFKKNHcMm82dfRKetZ4BrYTCRtY2nkDidXWuU6af	670	929	929	1616106420000
1219	3NLwuHvciBeEWvuEqMsagU828qAvF3jBMxAptNFyvJ2DFRzqRiRn	1217	3NK4Bb83CNaUd3zU9rh238d9oVThm7M7mfX38D86xxbJ3mYciT3Y	1481	790	1	1	1207	jxTA7FJCTALkre8LjJgNnSxZZvUjrma3gZYaeieddGSNDGGM7yD	671	930	930	1616106600000
1222	3NLZsCyRG24rznibzs92nugszt9EeZGfcF1GbuRRC7MJefz9GutC	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1407	1395	1	1	1210	jwWZKfnTL3YVTJdBqZJBqjh52stngiHXMsTVJbByyg2wpzK8Sak	674	936	936	1616107680000
1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1587	1231	1	1	1215	jxKRB8wCcurbA7d8rEw4HG5gQEffKEme5qRbkjnhyL1AmsEJHwE	676	938	938	1616108040000
1228	3NLAbccH5GLR1NyeSLCE1pt4KtbK5gp5HDdLdv1vYNSwUpfnnS7p	1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1611	1341	1	1	1216	jwtQhuweA4thqng9P29KXmTrCb32h7Uyhss2s37C9XEftB2MirW	677	939	939	1616108220000
1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	1643	1299	1	1	1219	jx7hsrv6DZyJ9NyeUmK9Z9qjToKKu2DcPmPU9NaycPxeuzTktup	679	942	942	1616108760000
1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1651	1175	1	1	1224	jxhqpyiG7xtJd9cD6fXK5rMhZ8jiNCdcxjV4Atqrs6G4ns9FrUD	684	948	948	1616109840000
1239	3NKvCsM2f3eL72hQczQMqD5o2TTMBBxVsKx9etzB1dSET8PUgCtg	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1406	1393	1	1	1226	jwFQ39zamBh5qufGsH5YPbZ2RocWAP4qfCaH3Sr7fVE9wNx4TxX	685	949	949	1616110020000
1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1608	923	1	1	1229	jxQEdRekYgS2TPpRnsyoWdNZBRKB33yyxpnbwxbJu7sQo8mJ4u1	687	951	951	1616110380000
1245	3NL1hyRh2nuQ3avzfTwYhyy98izmB9tvV8nz6dKhS8cPyccFHBVX	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1577	1327	1	1	1232	jxJXunFYcp2MQuNswqmr3odtGMsyUbnFx7dzFU8U6LtdcfFCA6P	690	954	954	1616110920000
1248	3NKH4vFVaAGeYVazXgGm7dz2NkJmZcDvAtSBqzws6vjDWv5M2iH8	1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1534	1317	1	1	1235	jxNCJkshGn7aj6xtETfqBmc7vM8Myn7dg7Jz6C7JkJ3GqxqYTev	691	955	955	1616111100000
1237	3NLVtJeU4Dj6xjiYmkouVv4X2uWYFCACSXnQsuK2acqYSF1aYgKW	1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1651	1175	1	1	1224	jwqe5GnitcV1ezwbRzWDj9ReX75DysVYdEHz1dGS32kBXZPsqsR	684	948	948	1616109840000
1238	3NLEWx91csxjRx7BaA8xza5VmdnGJSwk5jXCdhASPT83BEHZRYt3	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1403	824	1	1	1225	jwoGWcQUWRWfLsBaSP3fkyQeEY9dC73qRtMgZGk3N56TSzTSsUc	685	949	949	1616110020000
1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1240	3NL5Nd5gp9cPduqTSGevfGR8HZmmKmXoGphTxmhzjVov6kkJf9k4	80	1273	1	1	1228	jx9SkwHV3XmWq4u7HPKsHzsQXxxhMLWdEbQH81oAGoGKJ5xb1Qz	686	950	950	1616110200000
1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1243	3NKoVv265cQuzTH4XAUHKGpWY3h3KiJC9BLmvTu1byvBSLrPNLqU	1407	1395	1	1	1231	jx3qxpFTQBDP33LCKHz7vhVw6rbFXJC2mLx4K5CLypWgX83zaZS	689	953	953	1616110740000
1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1402	870	1	1	1233	jwWc3AH6xdYWJYvzGfRjHqb3YejcDE1nY8XK9xPLbYE3X5qrvQ7	690	954	954	1616110920000
1247	3NLW6RX9DrMFW52euKaUz2Hgk4nGusAiMqRjp6qmx7c49Lt8vibp	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1611	1095	1	1	1234	jwHUVjEdvCV1tyUfLUEbKJ1cLRd3icw84U8Fk5LiWz6ZRhNnGSk	690	954	954	1616110920000
1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1585	1240	1	1	1236	jwRJwdk3FtVrNU9hpRNK21cx5mHVBBVCZ2iF4wFcFCNoaiv4yDn	691	955	955	1616111100000
1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1536	1313	1	1	1237	jwAi8SxfrbpkvvTZwoRr2AuPgcRqAK1Wz2atGWHMhcvmSifkCQr	692	956	956	1616111280000
1251	3NLkTGEeXt3pX6TN1DmjdaZjiqGcGrto4KGDupGDVnJKduRHBBN5	1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1407	1395	1	1	1238	jxSefmGUPdYxeJFNLMjignqCzRhJ3Ao3kMbbwJoHGcK3BeY9Hor	692	956	956	1616111280000
1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1407	1395	1	1	1239	jxChKfA38nfqXjNM7rG7LSHTWmXLvg7a56BqmwB8QzvYe8p1WqB	693	958	958	1616111640000
1254	3NKUnYt2bgikE6RHWjiqvZYgT7AHrQ5B3LRCsJAgu8ZmGnybpbbL	1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1643	1053	1	1	1241	jxgrFiu45Wi2x7Rr5TEWKCADuGgB3YrY7PZ6WEMTd3YqKmcNMPY	677	959	959	1616111820000
1255	3NLpQ1BXQFKvFjqJkchT37yKjYz3b4tibJWiEhS4LYgWLiuKf5pj	1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1589	1040	1	1	1242	jw7ywQJqXa9riAoseVmmYx89znzVCJLKTpduVvxR32i1HqqKUVD	694	959	959	1616111820000
1256	3NK5Z6nRaqYg4211iCKSPXndWtZPv5Tbd9EbvJ9FCmKTbbKGkjWE	1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1643	1053	1	1	1243	jxfBWsJbvDfMtFKGEtR34MzaKD5vGdDWDgVUUJT376LoHJNaqhk	694	959	959	1616111820000
1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1256	3NK5Z6nRaqYg4211iCKSPXndWtZPv5Tbd9EbvJ9FCmKTbbKGkjWE	1407	1395	1	1	1244	jxwRMehSKQCD4YVZSbXREqqnTLjeycWGxGC2SVEvyBdyBNufe7W	695	960	960	1616112000000
1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1460	512	1	1	1245	jwLayhzYnqsivcc2WaXKZv9TSphNtpCi8xvWhQocab5PHKk85J8	696	964	964	1616112720000
1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	596	1306	1	1	1246	jxZuJoLCwCof4awM8YXHzXS2kycPADUtGPspnFX9UeyWHgtKupd	697	965	965	1616112900000
1260	3NLy9EReKkw66qLEFydHmdUBc9E1bMKASBqXMb6tgy5zoCz4sX62	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1407	1395	1	1	1247	jwsjuRECFs3jZYU99XcSKF1nZJvNZdeHrMiF9mSjodh8gUhJZjx	697	965	965	1616112900000
1261	3NLH21SapdoycPdx36ugAS7wCZGqpbxqu46zFCJaWqS8c7AZFnwA	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1631	794	1	1	1248	jwtXhAbuukNA5vw59EV9zT3aRhx9TkBxC8cGUZ8kV4tXT9WwovU	697	965	965	1616112900000
1262	3NLrQGEm7bmqCojDTmmhjDormieSnozwhityLZhfouEgP91THKoU	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1483	1276	1	1	1249	jwein5VxKfwG5L6EoSJTpLb6j5JkuQDbUswdYqbMQAswUfQ1r8J	698	969	969	1616113620000
1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1581	778	1	1	1250	jwHpTmFDeXNkvXiYY3XD6EGXtnbR32aZm2t97t74YVCrQr1qyyk	698	969	969	1616113620000
1264	3NL3LQSsiMojQBKrVsVGywX8JnVBAFxzfpHsUzrYd7Rw4N7CdBiP	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	667	667	1	1	1251	jwNzF3ukkZ5XgewyzXdEb636eXZF8VaFtqmu1w6aDuZrMEjjv64	698	969	969	1616113620000
1265	3NKrhV84T2yA6synxjsjrBe9KRUQJHNKTSp2pNLnamwmfLfDsXEM	1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1553	776	1	1	1252	jxcYjAr9wPAnhKK8wLciR2r7bJPkhqjgcbd8VLt5FesjtVAyzDS	688	970	970	1616113800000
1266	3NLX4CMBzWciygWpBfdJ2WieAhkS7AGiP8rXNVPRy3Uj359TVxsS	1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1637	816	1	1	1253	jwdFiw5qFBoqMhtrQ8DHjCwF5DfWnbQpEQzdWZnooxxkaCfQYio	699	972	972	1616114160000
1267	3NLU755ZSf6FPGSNiMNnmRnvchhVQEL92JoAbqAmX1ZzRReLfD41	1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1602	1123	1	1	1254	jx4gQHGrZAmAePyUH9SPL5rk9Ekf4Fnk5BGYo9DrP5wtmrxuZFs	699	972	972	1616114160000
1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1267	3NLU755ZSf6FPGSNiMNnmRnvchhVQEL92JoAbqAmX1ZzRReLfD41	1578	1296	1	1	1255	jwtD4qSTwe4aBtJDyoQQgaAe3yVz7mMWmNgb7MfMsXg6EceVNgP	700	973	973	1616114340000
1269	3NLhfNPxSmn2V6eK4ztj3pkh1jLmZNrAKDh4yXZd2SvMTreLaKKi	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jx6JnArSpNx7jfagiKBdHk81rVCGGNRWu3TtwjMKfhfS3xeVjKo	701	974	974	1616114520000
1270	3NKqCpVcckTiGCkRfH2h3QFZY5gEeAMSRLhoC2QuDfBcWJCLDRQ2	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jwirERQFJKZuePJFTPHaiaRN6NQRr9UCmPdquoTVy1i29YhpCrJ	701	974	974	1616114520000
1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jxXWy96vuygDQ3Zy35zD5Px6fHz3AQ7qJdMEfa64DgkL4AXGd1E	701	974	974	1616114520000
1272	3NKiFmGkBEpmMtuijix2NMJJf3zriAE1ZtTm8kTSBhz4eKE5Y25r	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	1654	1094	1	1	1257	jxvpC8VCpSsp1MfdNCHF6ZzNCHbHfvJgNCNyZiSfBvByKECRX26	702	975	975	1616114700000
1273	3NLDmuktU1PkiGq86doA2nLA3nmjZQV2aWmLRMnu5ujfFbwmVam9	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	311	1307	1	1	1258	jwU4T5NUCGAbsd23hzXusgrfsJit6neXQfmc3FnZmQK6641Fgx9	702	975	975	1616114700000
1274	3NK4BP9y6JTs97dctUJQkXyS7X8xDi6YfyUwiEPkHxnrW29nzpGY	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	632	1136	1	1	1259	jxSX6QdMENjU8ddpB5vEbH1V6jPocf4Az6LtvNXrqFZ686eTB8n	702	975	975	1616114700000
1275	3NLrVkHpvD1WeE56cVpnj1RLWzWHxL18UTSBBdxZLz972X3KVbA4	1272	3NKiFmGkBEpmMtuijix2NMJJf3zriAE1ZtTm8kTSBhz4eKE5Y25r	1599	1041	1	1	1260	jx4BoAVVBfTriA5cbzFEWuXg449z6TLyyfTdj6BzL4xNz8jkurx	703	976	976	1616114880000
1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1275	3NLrVkHpvD1WeE56cVpnj1RLWzWHxL18UTSBBdxZLz972X3KVbA4	1406	1393	1	1	1261	jx8DfmbcSWWgFwLcmoyUzWcnciXreRQNW9nmrnXsBHKtmPNmnEm	704	977	977	1616115060000
1279	3NK7icc4C5pJ2ECBTZjEUc1HsRmZzKsrvV1UszFJXMNGLyHYsSiR	1278	3NLSQ6fAepdmBTnkDnG8i8wKocDjm9HGpuLYZhKz7sYB81yrTzXC	1617	1288	1	1	1264	jxKUCErMAvgsAQVvhSVvbTYqzYwCd27XqkqEaA3sWYiriwQZtPk	706	979	979	1616115420000
1282	3NLXS9xuDuyjJ2ByxgCrChv8u86qu6RVmN7Sh54c7hsxJ59oLQBq	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1407	1395	1	1	1267	jxehgGWkKS6eM4hWsmTzHC27H5JFvmybqktRGNdYbmsbhdxgtrX	709	982	982	1616115960000
1285	3NKv3ppWVL4J8c8yMbn7i1CNYS4htpa8tb1vT7sY1EsN34QV1CCz	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1451	926	1	1	1270	jxCWG9hA9nokj2DAw6TFack3pAQdSBNvnmoEKXHJmvQAykEvoFe	709	982	982	1616115960000
1286	3NKTCpD3pf9FwxVHqac7rkvm1AAX1VyhWGa8cFRpcajxnwrvoiuh	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1439	488	1	1	1271	jwHWEJk4MhkyBdshoGPmSaSu8QZH4Ryj3gzr2FHZ7vqH13PSXhw	709	982	982	1616115960000
1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1657	1344	1	1	1276	jy1TLKCDaDX7TUkhaCMFmpxexCCoMvagNxEZSCXwLy2Rxx67BHJ	713	987	987	1616116860000
1294	3NL2st5mHwxmadTgRvdsYewWEbq7Vj8eAvmMGyLxWiZbU3pLCBHb	1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	641	1336	1	1	1279	jxiYDHUyYyJQtDKUrFFHnPXEE2d6bnZf5tnQw5y37fB25Jrfvjq	714	988	988	1616117040000
1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1293	3NKnEMpydQaRHUy8upuRmVtuZ7es1zKsVoTpv2vLcVL5hzcFgDLQ	1405	851	1	1	1280	jxcnVCvpNNZ779WT64EGYXJFeTBeffcyK5KwkjwxjbydgL8BQdG	715	989	989	1616117220000
1297	3NLduXMq5fKakNMNKrQ2padHY4CjP3r9c1zMoqJuhT6xYgpy3grn	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1534	951	1	1	1282	jxnrPMtZALWNm2ZVh8C1L971aW3kMYV8TWf2PPeeiyA2yNwxktk	716	993	993	1616117940000
1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1402	862	1	1	1286	jxH1E2oUUEpgwJixpytQCoXGYYEj4b7jKJWypgpQnf5LdsLHP8k	717	994	994	1616118120000
1304	3NLLLTp8Ffy8djHbcHLmcKWWmB6ZErNHuxisvFe3HnjqYRxhqooj	1303	3NLYdY5g9XxsGdWALiAaVxSiccor8pXKuJUTz1caGA1mWXecxzZs	1534	129	1	1	1289	jwcNqEc1Djs3j66vviaF9SwqtaShjEoKLf7WNj6BByxZkqWpGhr	719	997	997	1616118660000
1307	3NKwn5Bf33aw3Z4jqBHgrBv29mm6cbQVhoRkquZRZUzvBfoxJZtS	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1406	1393	1	1	1292	jxwLRU3CR3Vr8Q3zzxxjTB865nA4QZQdUZHTiH42aghRtLnyRcM	701	1000	1000	1616119232768
1310	3NKQE8wQ41YQiyvuCHfg9ktDK97hFiKNAx39VLWkxkJkNhrryzAv	1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1402	882	1	1	1295	jxSD7MhC7dyE5WVbaPy8C5heMSgyJNeCuuzAFTQayDx8BAsW7uh	722	1001	1001	1616119380000
1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	470	1063	1	1	1298	jxFcSfwJRvfwqVxN1FeZ9guA6BAUyU9sr6PRXWRqWgDEmJXp37D	724	1003	1003	1616119740000
1315	3NK8Cm12tNKXzJxaeNEk4payBFpCnXYHR8ZEEEKs7XY3HaEit2uD	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1646	1354	1	1	1300	jxuKJxHsGLf2qpsdv9H3At1qXuja45mDiAUyqKKcshMceWkVY3n	724	1003	1003	1616119740000
1316	3NKMtreV2aiMudr1uZu4sbpo1UYVDDgpgasLymdFxXTHm2NuegFi	1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1406	1393	1	1	1301	jx9ZRTN8FB3VYseCHjyHs6ftmNbycUK4f7wUwCLdXnx1zbHH6nD	725	1004	1004	1616119920000
1321	3NLqXbKFNxAiyoMPhfdW7QQaoZHgvNrtatyHKWUcLjuhnadkmWsG	1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1489	1380	1	1	1306	jxQLiZYYryKyqtySv192ENUZR8bDYzQ54P2Fohri8h8smMa4Zkw	727	1010	1010	1616121000000
1322	3NKsGLHhxtMQedijqzL7Y1mweGAepNDcsoCqMY8ZvtNX8wCviX7C	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1599	1287	1	1	1307	jwB1R1LznpcKuJuPCeLjahpKjP73npk1ABsRyzGBAaw2YynKE2M	438	1011	1011	1616121262441
1325	3NKD4Vaijrpt8Jw7hkxyeivbbPBdnK9n6w43hVro9wA2dhPxnR5d	1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1581	778	1	1	1310	jwLnRUGSd7LApi83t7h5PkyUMpvFpLwLnmu12kYLrZ1nFGfEzVe	728	1012	1012	1616121360000
1328	3NKfLnV1nA65YAADGpqynYXtBfWor41MN73xakLcpQ8BcsSPjF24	1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1596	1363	1	1	1313	jy3GvcuL86rB8K5ByPAdyJ3qekCUiptysJtPd7SReFifRdVjhh3	731	1017	1017	1616122260000
1334	3NLf9jELRcUTdGxTNCx77HLVPvKVnJ3KZHAeyKp8FLWmLkN5FcYL	1265	3NKrhV84T2yA6synxjsjrBe9KRUQJHNKTSp2pNLnamwmfLfDsXEM	1553	776	1	1	1319	jwEGFsXRep4yaaD3KZm8fQ2UA27YVfVdkh5ct6p63jczjB84o6W	689	1020	1020	1616122800000
1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	1332	3NKRFa4gTmxjBeVSToGfP1MW1EtvicQNmXca6XSYnfSG6ynZuo5X	80	1147	1	1	1320	jwnzXhtDRzLGgEpgXMHx9cNw4VHU59Vzhbf1ZYTAtx4UruE3PKy	734	1021	1021	1616122980000
1337	3NLLdmDgEXotWAZyeozF3cJxDMzCf8k4xQXRtG5HyJsKDBiw4vXM	1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	152	964	1	1	1322	jwVrtRXjw1Po8A75HDfARQcXQfxJRJvcphy3uvNjxNN28hkgxMv	735	1022	1022	1616123160000
1338	3NKLgB339kGkearrPTEbavonqiWj5HNrhdnRJDRmshU9UQX5Ed9V	1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1406	1393	1	1	1323	jwgAufgJa3ZwLLp7D4C5wP8yVHFvzhPJTPzZkV2airRq5aqEp4K	736	1023	1023	1616123340000
1340	3NLcwS9NFwzNRobkVuhKkEvgiZFmduuMny9h5pGVhyfrTDEGKKMA	1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1534	1317	1	1	1325	jxt9srdb2RLmvoNRrGMgYbVac11Hy1dvtKdCWKvbVNcajvm1qnT	736	1023	1023	1616123340000
1341	3NKKkniTUwAfiWcbfq4MYZwgVhesabBGtEDoF1TZhxZ9i65uzN62	1340	3NLcwS9NFwzNRobkVuhKkEvgiZFmduuMny9h5pGVhyfrTDEGKKMA	563	1113	1	1	1326	jwKTyLjwtmntKnvZR9qHM64XjHYzhZy1VDVogV1L8k49eQ1uoPi	737	1024	1024	1616123520000
1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1341	3NKKkniTUwAfiWcbfq4MYZwgVhesabBGtEDoF1TZhxZ9i65uzN62	1599	1287	1	1	1327	jwVZp3xM2TtjYazZJTa9dLhDHjyE9mg6GtiLF515CbnHB1DGU5W	738	1025	1025	1616123700000
1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1581	778	1	1	1330	jxmLKp52XwY1WMTa8QYse6zAUdb4NRxuNcaYFTzckS8vC6ndfjz	739	1026	1026	1616123880000
1347	3NLUmYLCmSMH4xHgLkfxwc99oBip8CP9tCcL4oz267zKx45a1CjD	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000
1350	3NLcg3vdynmtsNzvSNZ8M3jRiPcVCpTwSbphktnmra6Ws2ab2D8u	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000
1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1348	3NKboqB9Jtd3GPnbqHhRS9H5WuL7rk5F7M3AzS3pEDHrtyHvqtmZ	576	989	1	1	1334	jxwiBq5QfHb2UvtGTLNffQCdGTyrG41KNgNZ35YuwegTSnn24ax	741	1028	1028	1616124240000
1354	3NLuZ6x9bqyFAeTr1dFpsECqnDbN525HaZg543SC2w2neu4UMp8n	1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1439	1279	1	1	1337	jwFiNXJrww6K2cuqZrcccLBrfQdNFzmELcMTwHRgDrbHYzpfR4a	743	1031	1031	1616124780000
1277	3NKH4NLAVTKE59P3ZHutBrgK95otJeLoWqtteBzRWWgnGaD2D9L9	1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1588	1146	1	1	1262	jwgZ5ff3JJWVVAAJKNJNPRRNoaMhVomyi8bpm2uZpJ4iy1ACfTF	705	978	978	1616115240000
1280	3NLuT8YFJKyrXWu3Bjz2xgQwQh5DSMeuKP2weGtKWUd9TNhF6Y2f	1279	3NK7icc4C5pJ2ECBTZjEUc1HsRmZzKsrvV1UszFJXMNGLyHYsSiR	1549	1362	1	1	1265	jxEc2nd8ueM9WayBA6rn991jarzt14tikHK9x6b9qPfjhSgvjPJ	707	980	980	1616115600000
1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1280	3NLuT8YFJKyrXWu3Bjz2xgQwQh5DSMeuKP2weGtKWUd9TNhF6Y2f	1637	816	1	1	1266	jwUJm9BSE49bWdMB1R9WFLVxJGacsbez7u6BHPtaXTXyso5xmYu	708	981	981	1616115780000
1283	3NLsQp94vmp9YGRnPa6aXdonV16yUdS62KjygT3tJUXNmFgpZD8W	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1403	824	1	1	1268	jwKpazRYsZd2RiSJeyZZwtMoGVyjUnnsX2kkD8g2SNukeLgPTeH	709	982	982	1616115960000
1287	3NLcJmkqthwi6mACvbbTKQp6Lc1JAxmxXu85MM9aw3s9nKrbyJWv	1286	3NKTCpD3pf9FwxVHqac7rkvm1AAX1VyhWGa8cFRpcajxnwrvoiuh	1522	1076	1	1	1272	jxhVXvx2dwgWSNVfR9tKn5XEExYzJL28AnALTCmwUG8k3V9DzjS	710	983	983	1616116140000
1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	1287	3NLcJmkqthwi6mACvbbTKQp6Lc1JAxmxXu85MM9aw3s9nKrbyJWv	1445	1164	1	1	1273	jwFGRhj7V5wxWSFhRNfE83Y3vjfa8PNajAAGmC9qGSAGYpfkeqg	711	985	985	1616116500000
1290	3NK9iNSoo5VZMwJLN7szLNMudhEcQmU8RNib8bcvaNAMM9Qb95q8	1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	42	1361	1	1	1275	jwzFem5PRStuxZ5AnzBBR2RXubbJTdhAYD3fb5Nwgnk948hWSr8	712	986	986	1616116680000
1293	3NKnEMpydQaRHUy8upuRmVtuZ7es1zKsVoTpv2vLcVL5hzcFgDLQ	1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	152	1330	1	1	1278	jwbdHp4xYNzHDAYCpoymxS6y6und25QHJbyQgfypfu9TtBk93v9	714	988	988	1616117040000
1296	3NLvVDNh9vqwRZf27gn8smoo7LgyK3BBHCgnAKMjzEmaXCbD63Ze	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1406	1393	1	1	1281	jxiUVaTPbrAfqi3CmXdZBPfjaFA1WnJxAcUEruGT6Qc9Q5gyCDt	716	993	993	1616117940000
1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1407	1395	1	1	1284	jw6mCthnVVRs5zP4bDre1Vmy9ktMM794Jc5yUqJWmXn2tX76uRR	716	993	993	1616117940000
1305	3NKci5pqYruc9a11SUkEv8HtEPN8SvofLyiVbtcuoqDVZ6HvJLXP	1304	3NLLLTp8Ffy8djHbcHLmcKWWmB6ZErNHuxisvFe3HnjqYRxhqooj	298	1062	1	1	1290	jxQtmbyNqKizJupUaqBV9shmWRtwjNNUttVSwzs2GhrSgcSVBXX	720	998	998	1616118840000
1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1305	3NKci5pqYruc9a11SUkEv8HtEPN8SvofLyiVbtcuoqDVZ6HvJLXP	1649	1137	1	1	1291	jwCj1PQEudNKymuKBsdPFWDNE4zrmB1uWfBaSzrW5Waa2fsHRTV	721	1000	1000	1616119200000
1308	3NKC28T7ZNa91KYJndmCFgtihxwA3CUmSyoJE8zXqT8sQy2Z5iP7	1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1406	1393	1	1	1293	jy1RoScp8wAE5yX49BU6VdaQW2mhnNgx4izFDHRXxFHXNxUP783	687	1000	1000	1616119200000
1309	3NLCGHKwxZoGPG4w6mTgKcQDipAxoCYNBNibxtSaBt3Jamfxwgjk	1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	1406	1393	1	1	1294	jxyKLJFmDweC5zXqjnWp4vDq41hB4NzzZwn9YMP4pSvtoSHakHj	718	1000	1000	1616119265840
1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1311	3NLV244uLfHQnuLgU4zt6ZEECJuNJjForu8rNdq8X6cKvET4uxpb	1609	1207	1	1	1297	jwTd6CyNTuHS8bRMBHokpULPnSy4mjZJpYqHUgQVpnU86Scowhj	723	1002	1002	1616119560000
1314	3NLmoxm4udaGf1F6zqeUh1EFGGqir18e3WGbS4z2osmRJ1yKSrwU	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1546	1339	1	1	1299	jxf93wZwftM2LJMdVqj97PiCVPQhB6aWbnhe9aVpG6QrwMDuiz2	724	1003	1003	1616119740000
1318	3NLtiizQV5iyhpUtyeYYSHC739QQycudtMQKZn6mzmbWSHacTvKy	1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1627	1385	1	1	1303	jxMYgBKqXjZxtvrLohDpjSLnHZzYNepDAAt8oq6TPCzQEJnKb3s	726	1005	1005	1616120100000
1324	3NL81hXC62JZDwod4rE4VikZ1mrcHJKBXzj767kgxzuBGmDZQHsZ	1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1542	1304	1	1	1309	jwja952tgPw2LLxxgY6X12StfFXBVa6cfbgx2tEVkLTypx8nVbC	728	1012	1012	1616121360000
1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1326	3NKjyv4h5wQkgVu1RW1KewzFVLuEbttFc5KyUxHpdECTA5owDuBE	1559	987	1	1	1312	jwEKvi3tkEAj1EFiNtoSTKVBuD9eP4HxyAhkRt4fK98kmC16JbB	730	1016	1016	1616122080000
1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1527	1167	1	1	1315	jxUgR2UoV4M8zfnMjuG38QV5gi3qNc5i6K7aQQvJVgwwfR2Mmpj	732	1018	1018	1616122440000
1333	3NLpFUAmT35sfJgaqsewpG8u93XhpjK6DTrQVkNBPA7hfocSn2M2	1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1581	778	1	1	1318	jy2uxDUfCatH4RfyDNhydJ7iNJxhQb4RzhHpQ9isZ5oZvNkYihc	733	1019	1019	1616122620000
1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	1406	1393	1	1	1321	jwsLuzt5Zdk9gia34hNHV4HGk71qajHnBD23ZZzkRJ58S3PJcmS	735	1022	1022	1616123160000
1339	3NKW7mCe6krWJBZjFgxx61KHjNttrMMruA52CvJ4mzVWwwx93XMM	1334	3NLf9jELRcUTdGxTNCx77HLVPvKVnJ3KZHAeyKp8FLWmLkN5FcYL	1553	776	1	1	1324	jxQHaDmrJL9bm1VNm65sAnwvsCwadFtKNcwqdWatFFAXy8aFAjo	690	1023	1023	1616123340000
1344	3NKi87Lufs29upngFT9onRfUtC6DWcNHLaTkCeXAMdPUSZE6rh3x	1339	3NKW7mCe6krWJBZjFgxx61KHjNttrMMruA52CvJ4mzVWwwx93XMM	1553	776	1	1	1329	jx24eBdp4NWt8pWpGv2xckUfNckTVhZdos8pvkF1Egf3tF4APD8	691	1026	1026	1616123880000
1349	3NLo96AYY3CnPARwbcxWmtfodSWKtXpWhkCrEHkKGrqZY8w8f6Vy	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000
1353	3NLC5HC4DSWfzzRGgksBCPDhhphrpqBmceC5AkosDLTRcZoCW1zj	1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1573	1192	1	1	1336	jxYRpCQnV7kMFgmXrpfKbgdXC6qhkv9ELK4zUMRk1Xiw4MkjPDU	742	1029	1029	1616124420000
1355	3NLihEe6Md3nkpgpnoEcGhMon1yPGDHtrPehaaLRLLwe6DtygvMT	1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1407	1395	1	1	1338	jwFpPHnRf55DJT8YWQSMq1MaFVdDxoLoX4FTf3n4gdgLncgzrce	743	1031	1031	1616124780000
1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1355	3NLihEe6Md3nkpgpnoEcGhMon1yPGDHtrPehaaLRLLwe6DtygvMT	1402	890	1	1	1339	jwB6pZcA7j4NEDZyk3Q8dJEM8QArZT1n8KPZDnRzxBQYT2rjH3w	744	1034	1034	1616125320000
1357	3NKm6vtFZXrq2XaGVwG1LM1VuDqDVowGGGjHWQ3wvpe7ZBbn67sa	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1406	1393	1	1	1340	jxEfurfP1cUuQMmFAdYWoz6QwfbAt8WTpTzd4ShAC4SfaJQzZeK	745	1035	1035	1616125500000
1360	3NLPg1TJghuUuUQQctW5BJeafkdgzQVWw3tdhdRVs9QPvdPD8eQK	1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	1407	1395	1	1	1343	jwYnXU4iQfHgxr6HcBCJVaStA2KgJvnfAyYvVpZzYXRi3ozu3Dg	746	1036	1036	1616125680000
1367	3NLDMFwWWQNTkuZEqxMwFGxPvs2L85zRvT4G874CGjDwTzHML1pC	1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	633	1258	1	1	1350	jwyvM6Tfw6PnpmYjLNzxj5WFhzvzmzFr88BF49EwGwCxqFXphSS	749	1039	1039	1616126220000
1368	3NKiNxvbkmudgmwXLP65ghGJ3yVZ8xVDykZsvxiMxnRNaLqrtWMq	1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	1406	1393	1	1	1351	jxRpu89uTiMWNiqJoCuQcpVxVXhh3kHy4bTRhEBY5nhcWjphS6a	750	1040	1040	1616126400000
1278	3NLSQ6fAepdmBTnkDnG8i8wKocDjm9HGpuLYZhKz7sYB81yrTzXC	1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1549	1362	1	1	1263	jwKE8zeSPghCQQEw3Gc9BbCFgZBMm6t1vPR87t1CWWKn12QqciS	705	978	978	1616115240000
1284	3NLAz1pZLhYe2fQUq6Z49n8AAe7NQW8wqebULkjeKyaU7yUGp9j2	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1406	1393	1	1	1269	jxtVABd7C8HW2KmtQAmUKxcGKv9hNwzwn4C3ZHZDnmYHSy4YFmL	709	982	982	1616115960000
1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	1407	1395	1	1	1274	jxziGdvSHGZv4ta51Gw7arW8wW5pMv7J4h5rS9DAThjFCicQo6G	712	986	986	1616116680000
1292	3NLHn4FihCDpEW5Zxzo13cDFHP5M8FSdGA5SMpvGphGd4qpVNRBF	1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1650	1129	1	1	1277	jx44S6msXD5GafkwfpeUz2NFH4daEwTuGoHtom2M3GLKz38aDsp	713	987	987	1616116860000
1298	3NLwe6796QPzqdppV69xikxk2dJHyLFZfoF5KsEd38ubTCW7uGCh	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	44	1199	1	1	1283	jwJYn6hZFZB9XhSHjxmkBozrQm271hk2rxWCmjsdjsaKSNghGno	716	993	993	1616117940000
1300	3NKfhYpfKqREsyTQsmRRoA2yMobKLWu3wrxZLy1tLg3G7evgPSxU	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	532	1057	1	1	1285	jwNvpaEZuU8mmHQ9rGymYs7W2X7RY3evR6fDyxcvFiKinNjWVZm	716	993	993	1616117940000
1302	3NLH4wGkMwhXMnqqVdShurGckiTS4x7Me6NUcuwL1t9HHC1QTDQS	1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1610	948	1	1	1287	jwurctDRio8K1JRwDcEcEbQVMnrYGgSEXhuRSAAcaRaKs8wNzLK	717	994	994	1616118120000
1303	3NLYdY5g9XxsGdWALiAaVxSiccor8pXKuJUTz1caGA1mWXecxzZs	1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	596	1060	1	1	1288	jwVc2SbnGfxseY9yysNh6mrcM4xFiqxkHmzmWDbKcnKFKStP18x	718	996	996	1616118480000
1311	3NLV244uLfHQnuLgU4zt6ZEECJuNJjForu8rNdq8X6cKvET4uxpb	1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1634	1331	1	1	1296	jwPjposmrWH6pRPqiFirpdajcicLWMngmGaXVbx6KB66Nzakty5	722	1001	1001	1616119380000
1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1403	824	1	1	1302	jwPrPFDcwveJw3fPEpqVvo7rANaJcAoisysEpLn4tsb6jMYdQLb	725	1004	1004	1616119920000
1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1637	816	1	1	1304	jwwiphXKKkLsQxpzY2wxPSpUTmaYG8WE2RtfmMac2NxuoeTozBF	726	1005	1005	1616120100000
1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1516	1294	1	1	1305	jxP8kwbakiQJWsABTPwAe1h51eRKcM192GUUUhjcxjHZmiKNuvx	727	1010	1010	1616121000000
1323	3NKHEv23kbVMd84GcWf3AzZ5ZdJA6D6HM1iF4Cbj4X1a98Xw4fLe	806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	1599	1287	1	1	1308	jxvSrbka4uoUwceVeBYBSWHC7ShgXmQBWudwjfN9grbTKbjMprB	447	1011	1011	1616121306621
1326	3NKjyv4h5wQkgVu1RW1KewzFVLuEbttFc5KyUxHpdECTA5owDuBE	1324	3NL81hXC62JZDwod4rE4VikZ1mrcHJKBXzj767kgxzuBGmDZQHsZ	1529	1316	1	1	1311	jwgfHP24voPSm8qx5QCrS6wewM9ku8g9XxBHsfpHF43jne9YGh2	729	1015	1015	1616121900000
1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1581	778	1	1	1314	jwdC4VpQerBr5EfDXECpCqDshwF7VP2jwvM31qUSMSBpLT5QoNc	731	1017	1017	1616122260000
1331	3NLmiH1VxiDhHce7iYaEmWUwfgNmY3pjkGma89MhWE8hgDxq9gVs	1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1610	1314	1	1	1316	jxwqABw9dAK4Ye96MTso6aABApit75rDqzJ6B4NU5KmxvbSgxuq	732	1018	1018	1616122440000
1332	3NKRFa4gTmxjBeVSToGfP1MW1EtvicQNmXca6XSYnfSG6ynZuo5X	1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1637	816	1	1	1317	jwSBE7RtwqZczST1Avg6JzuBcLe9vUB6edzFamzAQJAD48x3cnc	733	1019	1019	1616122620000
1343	3NKP6ZKtmbAqmocYUgVQv2VyGopsFLfEZUV2YmNBvjFCg2JrpK8L	1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1503	1031	1	1	1328	jwrPupFk7TLptwWnPWrbMLzKdDpqBENhyEf9EiqMtpDtxwAnJ5j	739	1026	1026	1616123880000
1346	3NKZKYJGjtXZbVbH9WLdBtvhrMDGLs6W2CmWnmC9PbQYAK6dpaUW	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1422	1337	1	1	1331	jwsEXYKfVWxBPdr1bkePY2jpqS8jSyRHhwti2knW3H3nNfk52uo	740	1027	1027	1616124060000
1348	3NKboqB9Jtd3GPnbqHhRS9H5WuL7rk5F7M3AzS3pEDHrtyHvqtmZ	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1448	1311	1	1	1333	jwbV5s6xxcRTwmQBxsakvvBYsQHB5Tj9ZjCta4kosEA5hJKZPK9	740	1027	1027	1616124060000
1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1549	1362	1	1	1335	jwxwT2zqnptW3mnkHc8goQfqCnG924MKZcmUgn8EaDuAKw5cg3G	742	1029	1029	1616124420000
1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1407	1395	1	1	1341	jwueWVgFowc5jwZ8Z76whQn5KG49fyQfBcrA9zuVt1iPMknP5oP	745	1035	1035	1616125500000
1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	311	1061	1	1	1344	jx9Dh8P9YtzBUpMGZmNeDr81oxhisy4AKzGbdXd2YCWDBwnD3XF	746	1036	1036	1616125680000
1363	3NKa7f7eFiw32pkNMpGHuUkYeJs1j3Q4ovLC9eqCR2PEhUJ9u2ir	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	633	1384	1	1	1346	jx3VvQKqcp3jAq6yfEhMCbQMoDkgTbbWKWCaYL6iWAJik33Bk3A	747	1037	1037	1616125860000
1364	3NK938DP2oRbL9Bbn2mCGoVYN2YtQbZWmGANQTZXvqP5CG7tz5JK	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1483	1276	1	1	1347	jxoo25pFcyuMkzAUs9SCJDhqkn5Zk7QHwrmjtZnPtS7ZVGoAkYP	747	1037	1037	1616125860000
1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1642	1367	1	1	1353	jwwnJAFt3gZ7mu2MYfsR6NrN6j2D84qcv4JpEJW1gQmCSLWAoUL	751	1041	1041	1616126580000
1373	3NKw2UFTJ7bL9h6p4kdCkjBjgTSJ9b5aB9fhggWjEF129pkcNigy	1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1617	1288	1	1	1356	jwbUEaiNfrdzwgZdF1aUwcJzJZcLdRmTtZhkV9xnMEehUQfX4db	752	1042	1042	1616126760000
1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1372	3NL7V4YucUZ1kmZbyBhZJor5dSvM2eRVLY53pshHwL24BoCpnanY	596	1180	1	1	1357	jx8SM2fXCmABt2gGXUJbmr1GFkPcvr1JYrAYnixEpFfpW7ivZGL	753	1044	1044	1616127120000
1376	3NKN4phD29UyWjV1wpePXkcFP49SgEV9wrGP3r4aVeYMFUPywm1b	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1407	1395	1	1	1359	jxsP3Sz7FXWyqGCwwHdzaHNpwLNkrcZkJx6rRUMUGTkhmgK6voW	754	1045	1045	1616127300000
1377	3NKmxESPyJztHZaSustE7PxdJnXZguM6HzhjLrANL12y6L78sus7	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1609	1333	1	1	1360	jww1yFcja1rHEzKLuDuwKstLvJNHiesTRBbCY9ATLwcifh5Axoy	754	1045	1045	1616127300000
1380	3NKbvJjvzXUFCeB2qjGNn9VsGhnN8nfjVuGXM81g8QtcVYfnXHVS	1344	3NKi87Lufs29upngFT9onRfUtC6DWcNHLaTkCeXAMdPUSZE6rh3x	1553	776	1	1	1363	jxTWuhC2c7oajufvrSKHHuNWPNKeFEygU6fQMyKx3enrjcumgae	692	1050	1050	1616128200000
1383	3NKpEyzBpnFuMTG6GyMSe6dX8xuSYHaHXdi8BUUfy43xC9ACYNUU	1382	3NLFWssNFJ8kJtmcy6vxEHuxZLedufuk4LEwpkYXK7fHJR4zCCif	1406	1393	1	1	1366	jwSNy1eYyQ6NxW1kRvb8uTiXkwXQyNYQmVh7VZmAwVTgk5WkEEy	758	1056	1056	1616129280000
1359	3NLMySFebRZ6BLYpx7U6dkMqWksGE9S9AVmmo7WvZmwkRMi71SH3	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	58	1281	1	1	1342	jwg6BeeMQxRQUSiw8kBs6YwU23qExv5yghfrPuZnXj4EYwLcBYn	745	1035	1035	1616125500000
1362	3NKR12UdeLLD3z91B7bDML98Zt31vjhHukQGtgq4pPoqAcF77nNq	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1406	1393	1	1	1345	jwKPAJQfcB18L9w1GTjfgyccq6AYq5uYojMFACactzm9S1A9gv7	747	1037	1037	1616125860000
1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	1362	3NKR12UdeLLD3z91B7bDML98Zt31vjhHukQGtgq4pPoqAcF77nNq	1407	1395	1	1	1348	jxJspj9FsWsc23AvzywcdfToL2VvhWQ1kwjXysvSa8mh6sYjN3c	748	1038	1038	1616126040000
1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	1406	1393	1	1	1349	jx37oaxqp6PoV4ep3tcG5zqsTkhe2BxSiYNMGFi1Uzfb44dAZpN	749	1039	1039	1616126220000
1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	632	1382	1	1	1352	jxnWxjpwyiA4MPZnzKnHiAoMCmCqDTuMhV9yo13A1VCcBkKatiq	750	1040	1040	1616126400000
1371	3NLJ6LMUidtxxu7YaoF1mW7dU1aAdw4PFAAiEuSW1VMQHLRnFMNo	1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1646	988	1	1	1354	jx3XoktYHxHmUr5WrrAySdgAqHqLYKWmuJaAyj9K2ShtYNtkjkP	751	1041	1041	1616126580000
1372	3NL7V4YucUZ1kmZbyBhZJor5dSvM2eRVLY53pshHwL24BoCpnanY	1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1406	1393	1	1	1355	jx8HRpndL8dNfEB16ja8JjKC6WDrxSkj2F6YAmxN7MDPQuBYt5D	752	1042	1042	1616126760000
1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1378	3NKdFPTavjuWmBwAmHuR9fVRZUjNgFPSTirDu55G7SvAsUbL1QQP	532	1303	1	1	1362	jy23yQJDmr85EPLNDmxR8TjoBUGqhcA8UDEM6XVCp4zqJmyeDgw	756	1048	1048	1616127840000
1382	3NLFWssNFJ8kJtmcy6vxEHuxZLedufuk4LEwpkYXK7fHJR4zCCif	1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1590	1300	1	1	1365	jwD3QHAQBQ1rhggmkLX9bMtS1D3hHb37Zga72LHjCQmdFRp7SCM	757	1050	1050	1616128200000
1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1384	3NKtUqPYC3QSsv9nhZWiM5ArsqXDafZeDsrruDDELpfLRDjxt8v8	1675	976	1	1	1368	jxeoor4FopH8cCdUM1JmmmLLLechkzrNeewBopqjDe5Hkajhma1	760	1058	1058	1616129640000
1386	3NLgj9GjnsyRR9ni8JEqui3h97R3pdbiAbqoemJQEtZoRDBwKeyD	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1500	1171	1	1	1369	jxgVDt3D43ningHARxc7xEsWcBpyLvvGHj1Dc45R2J72BFnsWUJ	761	1063	1063	1616130540000
1389	3NKFUNovb2hAZW6WaD5BMmpb9oRwRUDFCe9Vy13usngGijwVAvuY	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1426	1364	1	1	1372	jxV649ReBG9wNQX5M1xLzPJNQeqEwxg7kkkDCqmL3955tLoyz8B	762	1064	1064	1616130720000
1392	3NKW52oPmAHntW52M4U9epxHBY6pVgLMSL7WXaQwZ35bxy2rpFFH	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1405	851	1	1	1375	jxG38aszGRbfec2PX5LZCyrAcQQ5iAWjk2F4984gkMYgBmbMgCS	762	1064	1064	1616130720000
1395	3NLRun6r3j7q8zAzWDwAGmc7VrQCX2MawJAUnDoLBDCNXWwApoHv	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1675	976	1	1	1378	jxCh3WM83CbZZVPDVyNFxWVdQrL94SH6TmAiyuzSyDdmcUCv6Nc	763	1065	1065	1616130900000
1399	3NKSEp448XBrgujfQgaPR29KVqLG7My5UToaFcX8Ci6yz661x1N1	1397	3NKPwQkaXXqC97bVED72hnc6DcTD1J5UtTpFKjYTtPrn2nDwwJBw	1527	1167	1	1	1382	jwoNbuw63DZSRFxVCx2NsAXAfUSef5mA53FqawgJzCzJTTnM6EX	765	1072	1072	1616132160000
1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1399	3NKSEp448XBrgujfQgaPR29KVqLG7My5UToaFcX8Ci6yz661x1N1	470	1309	1	1	1383	jxWpj4542xfMhfr3MJKH9knR8YyrSF2eRuQAwYLZfAdrYLThU9G	766	1073	1073	1616132340000
1402	3NLNtMRE6n5Erv1ow9drPNiR6aZW2tCzVZmQKRJeP8U9kSc63Vet	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1656	1217	1	1	1385	jxrpctMTSfCWf7fxkjVmwUU7L5gAKjnAwoFxcXvDsAt7omfr3bF	767	1074	1074	1616132520000
1404	3NKpK2kvyCq6hEH1dRVDX4JZ5QyJi7mspXPM9qeL3Dhitp3a6xxC	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1422	1091	1	1	1387	jxNGj8mkTKZrV1CqW6SHy53FAzBekoMYppqDBnJS4kaBkdJetPC	767	1074	1074	1616132520000
1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jwMkngiPc9QFGGLaERCMXPWBXnooSzGtv5VeAK6AweYCV6XoCfV	769	1076	1076	1616132880000
1412	3NKy6Y1Qm4qBRJHAGUcJc3so5EDjt59Vn7kHhm8VLzosuJEJvv7F	1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	1657	1098	1	1	1393	jwMsGWG6dPbB4qkYufFCwycJeGnim7SfzWxhQPZHVGq5iLzZG7q	770	1078	1078	1616133240000
1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1622	1110	1	1	1395	jwVZneEkgN7T5vQAe1V5sbZeY2KvxWg5giawEfyTQJFZcrEpmwo	771	1079	1079	1616133420000
1416	3NK7826BbHbySBcvnm854C18ZHwT95H12afpfNyAfBcCkaLwbGuv	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1527	927	1	1	1397	jxkrDSQSJaVNcaS7HytvhAtshYRh7rRDYc8hLdvqKEzAWmgvyun	771	1079	1079	1616133420000
1419	3NK863XNzYzwB6Mhu346VZFEFeq2G2byyRKh1MurBH6GuGqQQP1D	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	470	1309	1	1	1399	jxZ7jm4edmVLRBLU3z1UhZVSH2KGRRkkoBdKoLyxjqXSJUrwWjZ	772	1080	1080	1616133600000
1423	3NKmTdDFK53fZNEPyLvVje69x5Kfqq7ZyWqrPXbXxYiVy92cJAFH	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	58	1281	1	1	1403	jwwxh5iuHNastHaM4YWXUPhxbJE7i924zDz7dtdxKkeZ6ysK7C2	774	1083	1083	1616134140000
1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	58	58	1	1	1406	jxYJJfMmWPmqWDYz6p2ifCtsWrCSW4m9e4Dqz7nPxxCSjbsch3Y	775	1084	1084	1616134320000
1428	3NKH28pdnEgEK9t24hQRnhmAvT5Kwug5XdjrEQaDLXT7jAzkzEUj	1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1471	1386	1	1	1408	jwYTeDbrQ25h1kWYZwh3ErB7uEZS3W4M1VDhvTEfTi8rDESzC3R	776	1085	1085	1616134500000
1429	3NKpSyV9Z1nUJkTuA2WikbBEnAWHcJHP3NDYosnZG2MGoRup6Baq	1427	3NLvSUNs6ZfS1npXucgPBBZpCXG68VWnPmk3rT9bEwLEMo5PELK1	1406	1393	1	1	1409	jwsY5CUtpyonmz9bYjMyDarGMNmWKmdtu3mDorDXZfKkMMTEWr8	777	1086	1086	1616134680000
1375	3NLDiJdESwsRccF3PQUqxRAPrcFBTSPSFJycbD5cS3XKPiWV1ABc	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1654	1094	1	1	1358	jwqAJMyLTpE8juspejPjzDms4fJs6yaL1DWTqKo6Gkr2Fw411rH	754	1045	1045	1616127300000
1378	3NKdFPTavjuWmBwAmHuR9fVRZUjNgFPSTirDu55G7SvAsUbL1QQP	1377	3NKmxESPyJztHZaSustE7PxdJnXZguM6HzhjLrANL12y6L78sus7	576	1229	1	1	1361	jwuCcEEYPjYKVdkt4zN6CE9aX5HjeUc3jgP58AAhtJ2huhgDm94	755	1046	1046	1616127480000
1381	3NKfpxYoKRLRdvnAbpMY4h8qavPYfGqM5jqMhwFfxJwTpMkqwm72	1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1647	1056	1	1	1364	jxsWQPrEbubhAe38LoDoPSAZVERU31odwY6pa99GiRAmS9bP4bq	757	1050	1050	1616128200000
1387	3NLCpzh1ZsqFZoQhPXghzGe5W8v3Qy2iKjDH5VHLfFSrGqr9gEgr	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1642	1121	1	1	1370	jxTYhWhMUQK98KTNt8R2rEwAeGtDZc1jX5XzAdPzwfZMFDEaRqw	761	1063	1063	1616130540000
1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1474	1329	1	1	1373	jwUqjmUaMV4kmvMofhdm5ReFChQyeL5uorp4EdMHEdPYqNVYpsv	762	1064	1064	1616130720000
1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1406	1393	1	1	1377	jwiJTyv2oHVzRwdsdFvBs9TxXE5sNAVAs5wgebcoPFwQ4o4Nfnj	763	1065	1065	1616130900000
1397	3NKPwQkaXXqC97bVED72hnc6DcTD1J5UtTpFKjYTtPrn2nDwwJBw	1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1657	1344	1	1	1380	jwo5qNrMzTg6ng5YCgoKZdsLQH4ana8Vykq29t8MHmYj1g7QmQy	764	1067	1067	1616131260000
1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1455	1332	1	1	1384	jxLdUpVJ4zdvg4mqGRXcR6eQ6yoBMydFoPWQRtyHN1GBiJXVVyU	767	1074	1074	1616132520000
1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1406	1393	1	1	1388	jxJDRkuWXDwmP8D28uhrafuHhgrdBHQmVDTz1ESFUC5Mp3mNkr6	768	1075	1075	1616132700000
1408	3NLtEeALqGXkBmUvEnfs2GoYZFUiEqPKHdsTEPc6zBK6uutA2Z6X	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1623	830	1	1	1391	jwrj3FEWhdUFuD5dxj1P98y8TzZKDbnWZRPsnWc9Pu7xgYJFVKe	768	1075	1075	1616132700000
1410	3NKSVTwk6ypQ1NkAgTaSzP9WSsYEUmYYn2iq26ZHL72iuxYScx1b	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jwSHfwmDDuRDxD3H28rtr6e9LWMtP2bQkKEDz4uPkGxh3DYWNuo	769	1076	1076	1616132880000
1418	3NLJpUaFdKnk4sAeFHdtrmPhrdtw2dH729wqHqarc1HhyTQoYRZV	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	470	1309	1	1	1399	jwsrHjSB7M65jVSQ1ZkW4AtmsXt2tKBjnqvZ9JQNKLNsCWeSMEF	772	1080	1080	1616133600000
1420	3NK7e5eeB9t4GuYVycemDGLYodGBoXqoSHAUa5AoJH87kb5r3jDP	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	1419	814	1	1	1400	jwUTfinunnyFFHrs3bFMeQqTWRvh7ejaJt9WAd1eL3wuYRX48dB	772	1080	1080	1616133600000
1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1419	3NK863XNzYzwB6Mhu346VZFEFeq2G2byyRKh1MurBH6GuGqQQP1D	44	959	1	1	1401	jx6KGmck7UpRCW7tWptrQpW46QsYqixB2XugMj2QHouJ6oiCZL4	773	1081	1081	1616133780000
1424	3NKA3Vm3E5xVTMSpzthZBFnujs4yQtLEFRFtKNcJ5hGHBuith7Kh	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1581	778	1	1	1404	jxvmvEFYjK77bhWJ5sGaQSiRcdoYf8EdjUjtMsSi3Ee4XEsNgdZ	774	1083	1083	1616134140000
1427	3NLvSUNs6ZfS1npXucgPBBZpCXG68VWnPmk3rT9bEwLEMo5PELK1	1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1402	850	1	1	1407	jxhhX3grh45RCpoJVtHNrZUNcbKav8pSmvnMbRs8QbnxmFvcDBh	776	1085	1085	1616134500000
1384	3NKtUqPYC3QSsv9nhZWiM5ArsqXDafZeDsrruDDELpfLRDjxt8v8	1383	3NKpEyzBpnFuMTG6GyMSe6dX8xuSYHaHXdi8BUUfy43xC9ACYNUU	1406	1393	1	1	1367	jwAVwksTPbCDA2J83xfsuNSPtzPWYYi47sq8739vEFf7kzz4yyE	759	1057	1057	1616129460000
1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1534	1317	1	1	1371	jxvJFWKBR2Je33v12FFv6oDpB1D22tAzDx41UvW2BJQc7R3NdsL	761	1063	1063	1616130540000
1391	3NLWW5MgKhCNBNqJx5J716eLAS8qTQGbsyqCWZjUadKoKGFpqNJ1	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1471	1260	1	1	1374	jwFsEV8YBYswTZ8RMLTzPChtXcxki9DR68PfMb9h41Sfixg845X	762	1064	1064	1616130720000
1393	3NKGGTuxRwpjDUHC2AW57qagtqBxByqdHFAHY16btiTRWLMnWK7j	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1534	1317	1	1	1376	jwE9FGYxgeyMoiWhTnByRghwXHjW83Ljjzwk6sY95wVjsssKRqx	762	1064	1064	1616130720000
1396	3NLXRtmZ2MpUD4X51Hs7inwW1LPY6aqv6hBo46ZwzqP7azhxZ95U	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1527	1293	1	1	1379	jxddecBtcpPrZpR9Fw2wcqKbWjkRMsqVEDhBSskyk1dExtRL4GU	763	1065	1065	1616130900000
1398	3NLQhEsGHKKMpatmgPedUAEXVvkdyDxQgoEmqn3mZA6ksVptbec7	1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1403	792	1	1	1381	jxZNBkRQsP8pvFfLzZf7q3kkeF1hMKNP5tbSzqL9BHQLfpLSwcT	764	1067	1067	1616131260000
1403	3NLcHQh5m6PSkZdnR6mb1p945yEuK52xJAgitLDyLvz84t85BooB	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1403	31	1	1	1386	jwimkLAk6ew6wYZBJRcqkhQTM1audcDHsAyzavBZasCPcQ5S9oS	767	1074	1074	1616132520000
1406	3NK4LXcLhKxuHH9r8HVyMwW4TFjUiZho88TPGP8au8SCzoeqEFLJ	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	448	1305	1	1	1389	jw8b2nQ3XwLugHbHyMR5fQT3gdXfMZiPUYFuC8mEpx1ZtnnTFqR	768	1075	1075	1616132700000
1407	3NLAMnzZSF9Vr1vs3pfE8h2RFDpj2xjQBe1pbgEqmpyQ7qJBhiPS	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1407	1395	1	1	1390	jxLLxajEry7c7eZgy8wwgD1jwVFGa2RDuMkCDgSQPRC89YjcE6L	768	1075	1075	1616132700000
1411	3NLkGjMnMuzG9BmeZUNSXBCb6xSMgGmnAPWtkjLKkZf5QDrSY1T9	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jxMHRnexjVxnDp36wmds5HdqCsgDfgcZT9f7khZNBFos2VskJYa	769	1076	1076	1616132880000
1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	171	1374	1	1	1394	jxnoDB4yi8uy6rzzMGRd2XQGvMrefhRSd43m7a4di3djcZ4grtQ	770	1078	1078	1616133240000
1415	3NKLuunBayq7hx7CHNwHWVU6whgNpnfCmRnGLEjxk84hd3xK1FML	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1402	874	1	1	1396	jxGNudP2mZ8D6coAcbau7znEUF12Az5sMj5pezgk8S18cpdvwA1	771	1079	1079	1616133420000
1417	3NKFy5zjMCiQRAjuTCfnbpAD7gCF987SmZRB5AnVxoycBgofXpUD	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1506	1373	1	1	1398	jxVZevEoLK1MQbveT61GkRRmft38hvnkGeFQAHv28SVkJDfKqch	771	1079	1079	1616133420000
1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1406	1393	1	1	1402	jxcjo5NuiHsBy7njAr71NvV4dnn4z1RUHEYSkHSQcCaQL4KnnuA	774	1083	1083	1616134140000
1425	3NLcRafR1N8tEezjypc84rGDbmrndv7GE7Yqmhj4jLXvMaKvZhYw	1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	1467	1376	1	1	1405	jwdPwRXVei9aa4EmBb97BVf29b4Pt6X2XbBogh2X7TpkcTDy6kD	775	1084	1084	1616134320000
1430	3NKxCMovRNxZL2yNDToeR9MxHSvB54tBgiUbRnELYNMJXMcSzjDw	1429	3NKpSyV9Z1nUJkTuA2WikbBEnAWHcJHP3NDYosnZG2MGoRup6Baq	1403	824	1	1	1410	jwUWtL3iZijkPL1nCpmotFrShsSYYvrQNfVdNWQ7BpT3dkd2PtC	778	1089	1089	1616135220000
1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1430	3NKxCMovRNxZL2yNDToeR9MxHSvB54tBgiUbRnELYNMJXMcSzjDw	1397	838	1	1	1411	jxvpGYXJ4Pb61PBvjHYQMySLpSY6qhV7u83cXdTutSfLVkCep4w	779	1090	1090	1616135400000
1432	3NKC1S4VptVcKmUBVVFo9YHHqTZCaTWT2RbRBw6gf5G5LHn4tt8B	1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1610	1068	1	1	1412	jxqRqbsy59KAYTf4YwySjMYbKfzmYLkDfqBUm8tXy5z5x4p5Vy3	780	1093	1093	1616135940000
1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1600	1372	1	1	1413	jwKA7TtbryvNcmye6sSP3FPxTrKRkX5cMFajWTUg8zk18JWf9PU	780	1093	1093	1616135940000
1434	3NLJoHWrB69FaL79db15zgZQVPgx6NhUtBuBsa7Npp8GQ8wY8U76	1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	576	1229	1	1	1414	jxCmD5JuZRvS4tAdQZEz1xJf6ZFKS72P4oqdLsuWqtME8rUwa6f	781	1094	1094	1616136120000
1435	3NKqAym4wHm6UQHb1YXmbSY6Y5Zf2NMoA4vFRBfFKJ5B4miZc9Fj	1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	1652	1315	1	1	1415	jwGKMVoorxsiLyVXHscGiBEf5kbN5SCWASPc9d2qjXbgQZAUkBn	781	1094	1094	1616136120000
1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1435	3NKqAym4wHm6UQHb1YXmbSY6Y5Zf2NMoA4vFRBfFKJ5B4miZc9Fj	1407	1395	1	1	1416	jwyHcC166xa6WUsqtJAfXaKkUGqeWPqBwZ5qTpzTkB19wadWaCe	782	1097	1097	1616136660000
1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1476	1005	1	1	1417	jx3RhMAFsUk6mZQfaQ3xMhuJQz2A1Ar94ZkfwgDqG1ofYXQ8mVm	783	1099	1099	1616137020000
1438	3NLHR8zzFMiynCV8owxHF6jtXxsHt4bkZ2RSxXqRQv6WH7ewu9KH	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1483	245	1	1	1418	jwTiJANe4Kj2vsHwuuhch6kgg47GwtkQ3UbEBou77JuejdFXb89	783	1099	1099	1616137020000
1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	448	1179	1	1	1419	jxnbud5tKSMVVcRrgSvyhE8RYXPD2Rbkw9CVzqSo13L9ZPLut4S	784	1100	1100	1616137200000
1440	3NKLRumTynAeSJHp9AWLP1oTiEwAy8Zd1LKij5MXEWVwfmqgHujE	1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	80	1273	1	1	1420	jwsyAUfJQCMCXNE7EZxH8XC5JaHzU9LpUxX9L8YXVR2uSJ1FD2i	784	1100	1100	1616137200000
1441	3NL9Ha8JBwcZ3UFSs81KpVbYPdrnKRr2WpWyLpVovuqopFSto5pK	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1474	1083	1	1	1421	jwZpmeiUhF6pKKMrdZW84nFGDHL6cdMg5eiZ686x8wzwpvM97me	785	1102	1102	1616137560000
1442	3NKD6cRJijkNNQKi5et36HdVmpAx1A4uNd9pA4JHoTPGMKNknVin	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1596	1363	1	1	1422	jxHtMD1o8d78m6QTigx2qNWAc8zCrtfN3GKwbwvM9gHfwDXaweJ	785	1102	1102	1616137560000
1443	3NL2c1228be2Q57DKWnU3we1GEo55esNmNJvRpT41y92HGKd4nyH	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1483	383	1	1	1423	jwqFMFUCEGSJxoGHYM9QLeyofSujViiVKJMwjPZoJN4c3N3ou4K	785	1102	1102	1616137560000
1444	3NKA1tAoHtHUvX2ZwjzQF5e8RaCS7QGJx3c8z4XCmf8iFLW12Pz5	1380	3NKbvJjvzXUFCeB2qjGNn9VsGhnN8nfjVuGXM81g8QtcVYfnXHVS	1553	776	1	1	1424	jxCWTSTaWCPsQyuBZkewofABS89EPNc8h5mHUVWCyWGKBNKb3cJ	693	1102	1102	1616137560000
1445	3NKz6W5xAPWwJTZxfkMXZgZq1opnCxMdKoQequh3RorR9mFoPfH6	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1486	335	1	1	1425	jxYGkDb5qQ5yKpr7QXSZgfEzfrrFQrcFPDf4ijxtfHnfEmVmEZS	785	1102	1102	1616137560000
1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	1442	3NKD6cRJijkNNQKi5et36HdVmpAx1A4uNd9pA4JHoTPGMKNknVin	1402	852	1	1	1426	jxrFU6cRwXfm8UU3B1VVZ8KD5bUbmk2yK3DAekamUt6cS5ghsFc	786	1103	1103	1616137740000
1447	3NKGkx6mhgobucMoMkypaEp5NZ9yb4Zbj9Mgf4ddQqu5tefJQfH7	1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	1403	824	1	1	1427	jxmxa9Lcgdp27qDa6MLkxNCC4ewgRSMWFytfRUWaArHsUdr7Nxf	787	1104	1104	1616137920000
1450	3NLQuUcXipQFAKhvMH4iPeTYW7jpYZPQB6r3Nzmnvyzob1xTxGS5	1449	3NK6zhM1NYK7b5ydNf9NrW5prjbmFzUb3vm7CMTbRe6kJB3kyzPz	1623	830	1	1	1430	jxhaDBuja4VoJr7poCmCsV56BRje4P1Z7Lv9U6xE4QxBmv1Ts7U	789	1107	1107	1616138460000
1456	3NKzECLmHxGbUBdnXzES21eVQifi6SwFcqi2xV3RCp8d1ZAvSrgj	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1637	816	1	1	1436	jxFSsjbA8kDQ6VsUq22nvWDbgiwGZvyfGEvV4n9bhLs98iCRyKr	793	1112	1112	1616139360000
1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1581	778	1	1	1438	jwFouhSq9SPFeeC9vBBaV3X8Mb7kBLNt5ihD6NTnvv4TZtkUsw3	794	1113	1113	1616139540000
1461	3NKLvXrN6vGoLr3uULAJzV6Waft7DD2BDR5J9146qB7UhwgbFc5S	1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1402	868	1	1	1441	jxvLXxUYCCgJHmBmfBPSCLAkz38FdnKBTw7HkRmGbLdfmWwHJpd	796	1118	1118	1616140440000
1464	3NLMFsdKZcWF9DFue4Nw3UENW9kwqdXxEWqVH7pdc8pKQkkHTkzF	1461	3NKLvXrN6vGoLr3uULAJzV6Waft7DD2BDR5J9146qB7UhwgbFc5S	1578	1296	1	1	1444	jw8oRSz11hqhhy7iNwxsLUBZeVoMWaAdrKsSu4bBq8DdkxsyHZ3	797	1119	1119	1616140620000
1467	3NKtBKsSTK58gjQFvVycv7HPBSi5DWSsDpU4HZAxAsds8csgUQVR	1466	3NLbMv7zsYpzU8vQx4i79wu72diWEnFPtFGufosFHH6te62umTiY	1454	130	1	1	1447	jxYgNjKbr7F6S9UuCFStLCzjqeskWc6oi7HEKuSt5ayQZUEbozt	800	1123	1123	1616141340000
1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1468	3NL2DXvH5bafnFQSS8FsPQHwEP43M82hbtjP8Lz3YHHTjyhJrYTZ	1407	1395	1	1	1450	jwG3nf1cpkvM6gxdYnhVgT6LVfPsnQp9kJq629iP3UhWwVVw84o	802	1125	1125	1616141700000
1472	3NKpY15RWfXcYxmQoskAXJSNdzpSFuzumMtSPr3RPFYtyBCQSuJq	1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1506	1127	1	1	1452	jxUD4Qvn8z2SSLPJoLppKqdL2UHb79nqCiMThYr3aJ11yNvhgBj	803	1126	1126	1616141880000
1476	3NLGzTBhcVRqVdQHqjehywjE3vAzreBtjL3vLHAmAmJRmZG5WPzQ	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1529	1070	1	1	1456	jwyiaQahZNnbmADheerMBAMoyhz6Qi6uWkSu4nTi7zHDWr2u7V8	805	1133	1133	1616143140000
1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1590	1054	1	1	1458	jxZMt6sqGcsdCiE2WskhixQduXcU4MSET3aWzcKkj2VH7xkZX69	806	1134	1134	1616143320000
1480	3NLhWNT5N958i8Y4bZy1QfK6FQu17pnC9Lwk6yMhSKar429J7JA3	1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	1546	1093	1	1	1460	jxgWPjhnQEL9QE5RBBGhS7oQCcVoYLDYaK61AD3zcGHEzs5Pwjk	807	1136	1136	1616143680000
1481	3NKsyvhrXYzabGtAyWjpEoptmr7Ph6o229dF7UrqNe2fxxy2TPZA	1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1407	1395	1	1	1461	jxd751r3Ep9ZMDhnoMg84n2W3zPcjW5Ui3nLQoFRzMJn1pFufhV	808	1138	1138	1616144040000
1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1483	3NLqCRaxCStHoGXghNSM4tqbJStR1e7ospznon3pWaSTuPSaWuBL	1571	1335	1	1	1464	jxVUVFZjhVDP21UZvyuEJ1YWRZGW39k4GiQ9nHLCCmjuQnyAqWr	810	1140	1140	1616144400000
1485	3NLh7RbuNqXX4z8zv7pcMU5XR4vHGPAJcWpX2VPcvS4rSeG7tUZq	1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1407	1395	1	1	1465	jx2NHse7FsRHz3H5iqZ7p9JqpKCEstgMUaurYu1HDtTEDR4JLDt	811	1141	1141	1616144580000
1490	3NLbkZSneZteh3PhVLQb39mQ3ctxSuKHaPehuq4yuQuLEziRLUNa	1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1650	1375	1	1	1470	jxtLWYB4UZD8LL5Bxqy1Lx47CCGmv3PB5eAbtciB4zJAnBYozvz	813	1144	1144	1616145120000
1491	3NLfHaQ7Ubce81eCHMPT5hparDBDeY6bJgYxGGdMu4V9Qnhb3R3Y	1489	3NK349srW8wE9NfMFQYsWc9aazMHt6tt1KheFHCxE6F1oNwTQ8yq	1534	81	1	1	1471	jx6qLFfTRG16cqNnpPGUMDP7eY7117vVBg6RmhRh5u9rh4W7kqV	814	1145	1145	1616145300000
1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1493	3NLEsPzdfSLBRv8WYKJ3CfaaoTUdwY4wUGXiqP13EwUxNHoeg4FA	1406	1393	1	1	1474	jxb7q5No3fiLBkNJrSnHqqbMfd1ecmR1CrHka7DCjpNPRFjHdGn	817	1148	1148	1616145840000
1500	3NLRhohgfsqkFQC895q2qCC4VaiECWetrvZyN9f3sNqnLcKGaGSn	1499	3NLL3LKeSWkq5r4Cg87YVEySxGtts7yWGKE76jdpHdmSx37otEjA	1406	1393	1	1	1480	jxngRtk78dDEkEYWSNN1M9BJsDgz7L94ZoK96Z9UYWwsJa3phH6	820	1153	1153	1616146740000
1503	3NLE2TSYe9xCfVQrKpCSmLArLHmjaFhXJHpHcFq3orRMzknfM1G1	1502	3NLkBvGeHyceuL8zspmJj2DrJr3probZGcoMg6tsxMF7JeyxDrpt	1534	433	1	1	1483	jx56VrdJ9PSrTsTQfB5zs95dqWFWqHTk7JeFiGQdJRZzhTqYvLA	823	1156	1156	1616147280000
1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1483	89	1	1	1486	jx1N7jfuysrhSRAuZ5QcCGErbUbBAaoVuVPpCEoQUQef768981C	826	1159	1159	1616147820000
1508	3NKJzSC7jvo9dWo245mmd2PoWx6tDiMRdgWQtQYXiEF9b6F8Q3BD	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1637	816	1	1	1488	jw8XYRdiJwJJX1xrtxy7dHF9hnsf6Q5gZoCRem87SLC8sERGQVh	826	1159	1159	1616147820000
1511	3NLYQFCrNpf9twJRD93PnpLkNcojSz6nURiVdmSwyVZzdW7cgJyo	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1560	1291	1	1	1491	jxCHG37y93NNCEXGCHkbTJwVY4cxZyMq5jsFbQ4MRqbk5MaTUxs	827	1161	1161	1616148180000
1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1445	1164	1	1	1492	jwe4wFo5ACp9THYXb11i9QLxVm3nZEFbcC89LuBdALEYNHAbob1	827	1161	1161	1616148180000
1514	3NKs5FVUdxUNCAhHBzv5gE3zGr81mzxXEVsfYeSZmR2qQkkfpn97	1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1671	550	1	1	1494	jx2BJidkmMPTYcdw6NexTp5ZxQ6pbC2HQaRnPhedYvDHKghTw3T	828	1163	1163	1616148540000
1515	3NLvDcwskRqcENA3wU7VLjtuXrr8zaK4eWrUC4ZTGw5S9etiruYF	1514	3NKs5FVUdxUNCAhHBzv5gE3zGr81mzxXEVsfYeSZmR2qQkkfpn97	1578	1296	1	1	1495	jxEnP2wdiuGgGpiAqRyEpDSWRmy5bGmFtezoNdv2A7gQ9pCJuPo	829	1164	1164	1616148720000
1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1515	3NLvDcwskRqcENA3wU7VLjtuXrr8zaK4eWrUC4ZTGw5S9etiruYF	1579	1143	1	1	1496	jxmWrbL5H37ZgCSb4iwqjygT6yw99WbkQUQLzfvUjhcj65e1ufR	830	1168	1168	1616149440000
1519	3NKQGpUxicNinfNZEmtYo3sNCLggQ78x5nwUPrRKdFJuYddEUvG8	1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	1501	1360	1	1	1499	jxkRKix4VgTdnBhufA8cTHErwGGGdo8cDiD126vMn8W9ALFqbEG	832	1171	1171	1616149980000
1526	3NLtYom5YxiXoHAa5bqip76oWw8ZsHD8TArFpYipQcMCNxzQ8egz	1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1559	1353	1	1	1506	jwf6dw5wjtjNPgKJj7LCdZYtESQz9TYGwb3fLQw9zqfSAEHsCeB	835	1178	1178	1616151240000
1532	3NLcWTxWgNjFGrEPyURyje3XNBoxbwVRSo1LnEaKbVPzyAFR9TpK	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1670	1156	1	1	1512	jwLCWc38EWGgsQBchaBe312JNPdDvAWxfqnbGzSMTF2b2uynNq3	839	1182	1182	1616151960000
1535	3NLVAfm3qrR3x7EMsHkWr9RKKwmCXyCX9NhPqiYEqrj7hRw3Mq3Y	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1406	1393	1	1	1515	jx1KZfLAMKNwx9m6YZhhvsptfn7VingoshL4WD3Xym3XJTacbzn	840	1183	1183	1616152140000
1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	311	1307	1	1	1517	jxTZ8icgo6BS236c5XKf4ddrhKHnYShWh63jkzVmSaZa38c7eyT	841	1184	1184	1616152320000
1448	3NKE1fMAgza7PNeHSLiEi8n6ppHZhf1it6XZ2qB1DUezPdeihqJc	1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	633	1384	1	1	1428	jwBh75qDftmYrTaPaZDk1bLrBATG1aRg8uDpMWJMHmni3xSP3YB	787	1104	1104	1616137920000
1449	3NK6zhM1NYK7b5ydNf9NrW5prjbmFzUb3vm7CMTbRe6kJB3kyzPz	1447	3NKGkx6mhgobucMoMkypaEp5NZ9yb4Zbj9Mgf4ddQqu5tefJQfH7	1650	1375	1	1	1429	jwrUHmCnAu99LtozAvfJ2H4Z6ufCaru3enboicyd8ynW59RkYFn	788	1105	1105	1616138100000
1452	3NLD2Sw6GNcBrLG77ninAwAJMKuH5JwEAF6qHZQSmta4Brv7FUPd	1451	3NKQMRwgTr3q5oARzLAHNavQ4sd4EhyUjgitdsyauj6SPQysTmBe	1527	1047	1	1	1432	jwaJpEfqk6orzUQz757pLFn3bifEorznpqMgHzyqTda6K5uKojp	791	1109	1109	1616138820000
1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1452	3NLD2Sw6GNcBrLG77ninAwAJMKuH5JwEAF6qHZQSmta4Brv7FUPd	1534	1317	1	1	1433	jwzNKLh3xJqCR4x11ytvC6vE5i6SCUjMTXSZKEvTyY2AUZ3pua7	792	1111	1111	1616139180000
1455	3NLmqfHwadJ3XkbDH9LLJUupbvusGKCMadA5nTE64JRF4GMfzjKi	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1483	551	1	1	1435	jwJUWiweNhGUpkRmbCw2ohpmJ8TYyAdCxePJTbnEwhuWM1GGucP	793	1112	1112	1616139360000
1459	3NLNyrppdKLtGyNnNXAYLeM772D913JUj6MwkiWdViseEwc6kaQB	1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1455	1332	1	1	1439	jxFWWmmPss2v5XcehkCbaY4QNQwkAYNWW37J2dC5khY6RgLo3cC	795	1117	1117	1616140260000
1462	3NKNGR5dKYN1eWPAPuBkurVXs2UNfmFVRE7WmerEyi3ruaBAMbgu	1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1650	1375	1	1	1442	jwyVJ5kCzqUidqDHHhPYJgnNP8vpfCubSAeZZmerK6YDNKJauyo	796	1118	1118	1616140440000
1465	3NLLdRud8zJwBxttcpv2rdjCK3inpZCrDkxPBLkFwEuaBEFaVr34	1464	3NLMFsdKZcWF9DFue4Nw3UENW9kwqdXxEWqVH7pdc8pKQkkHTkzF	1406	1393	1	1	1445	jwbW8Rr8Y9jcjhPH8ETYjJz27Ys4JoEs9SiiF8fBNw9q3aQsZ87	798	1120	1120	1616140800000
1468	3NL2DXvH5bafnFQSS8FsPQHwEP43M82hbtjP8Lz3YHHTjyhJrYTZ	1467	3NKtBKsSTK58gjQFvVycv7HPBSi5DWSsDpU4HZAxAsds8csgUQVR	1673	1002	1	1	1448	jwRUDWhdPVsM5Af9VDnbmVvwLbu7mgiadYiWAGsE28cE5crzHxk	801	1124	1124	1616141520000
1471	3NLxhDyZjM8tbPjAqzv8Wv2T2u5wauim9XSDdPRQsKG1bLB8erxA	1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1654	1094	1	1	1451	jx8cuEcKYzEqzPbSJMrHJCA6ki6CU2F1VfxKKDbZ8xXqD67Geym	803	1126	1126	1616141880000
1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1483	1276	1	1	1455	jwQBBBtTRAthR1LUt9baKPiG2ETgjr5ERHAdRdzr8aLF5GjjwcM	805	1133	1133	1616143140000
1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	596	1306	1	1	1459	jwxESQdTsavnwj1poSP6yiNzPM3SRVcg3Wo9F5u4rC3GX9viGZQ	807	1136	1136	1616143680000
1482	3NLACJmMf7pmh1C35GJei5EzoiDWvq4G6FP5ziRZRKneEknCCtdE	1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1637	816	1	1	1462	jy2jsDKYiraEJJeakercbk1PPejjW8un3ys94rcJPFwHjHrfdD5	808	1138	1138	1616144040000
1488	3NLTWQNL2FN7YcJnv4L2C2K3yesYzPemwQgdxst8f116ZGCRFwzG	1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1609	1333	1	1	1468	jwog9U9s1uCEiRRiN4wXmykt6XqkMXaozdxz1qkqjo7RopFsXfB	812	1143	1143	1616144940000
1489	3NK349srW8wE9NfMFQYsWc9aazMHt6tt1KheFHCxE6F1oNwTQ8yq	1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1647	846	1	1	1469	jx3szjgFxZSdSAD46XDCu4qPKp5Yg93vcedtuEYT187uM8tSNz2	813	1144	1144	1616145120000
1492	3NKss3AVVyw4LiTjFMH7k7z4ViFtudGBbYYKfwpiGhCtztexMhCZ	1491	3NLfHaQ7Ubce81eCHMPT5hparDBDeY6bJgYxGGdMu4V9Qnhb3R3Y	532	1303	1	1	1472	jxNz1kVRZqLrrkn4oJPFvySQEfEZ63TutoKSwfPPiEubzwWNypi	815	1146	1146	1616145480000
1495	3NLXaBey8Tx5m6EiUHRTruMCy3NaJY5afKdaUYh9QX8d4JV3JtRs	1469	3NKwBDNW3PhGS7pnbEkDKb99AGrRLdf45o9XXa6bcxNMh985njg2	1553	776	1	1	1475	jwcAifVEBN1yd7kLUXSypSYJDyPEDiQih8TvSvsAcpMi9s1kRmc	695	1149	1149	1616146020000
1496	3NL6ynceF5LbRbGF3DPKPmNAum9KJCfuHSZQzu4XqtFwgPEpyugQ	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1619	1275	1	1	1476	jwnPtica3M8F7ne4Rdcqh7Tqh4WhroUtsxbtTmMZpT4nKvtYepm	818	1151	1151	1616146380000
1498	3NK5HYC3gTCmGPhBHfiLZtccDWUcz6w6kN4ZGFH3rjrVsxRb1TbL	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1601	1022	1	1	1478	jwLrNjU1EFdUFSK1PrenF4eK1Lp8J7q4v8XtVgi61Lhq98Ann51	818	1151	1151	1616146380000
1499	3NLL3LKeSWkq5r4Cg87YVEySxGtts7yWGKE76jdpHdmSx37otEjA	1498	3NK5HYC3gTCmGPhBHfiLZtccDWUcz6w6kN4ZGFH3rjrVsxRb1TbL	1406	1393	1	1	1479	jw78iipkWyHxzgYBYD5j4NikLWcbvkompBt2b8sJRbemA5NMAqF	819	1152	1152	1616146560000
1504	3NKEUpMwm81jqCSHH7Ai82pdbS2eEgoZaskoYBQd63AvCGFUyuKs	1503	3NLE2TSYe9xCfVQrKpCSmLArLHmjaFhXJHpHcFq3orRMzknfM1G1	1407	1395	1	1	1484	jwFdobP7ectPhmCAuaLVh6zDfNRy9zfLwxgjD7ND3Lc6QtEa4xK	824	1157	1157	1616147460000
1510	3NLcUeL6H7GmMeUYNtpLgzg8zery3DPSNc8Uj7DHxtzjX61UGBkg	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1403	780	1	1	1490	jxZBHCbTZAVSi13cY11igCQJUNzEDChnFYHCevLzkWQPfhbRFbN	827	1161	1161	1616148180000
1513	3NKJPq9zeubLwnFQoxPs8rAi6WvZwmkZ22Pr4ZUhhfESTboNd3GF	1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1402	862	1	1	1493	jwXJwVWscffkRjy3EJ1emypYcRpacxLaqJvpQe3edDG5xbAQegi	828	1163	1163	1616148540000
1518	3NLwELLMrqvAG2zNDXG8buEvj8NM12eB47cv7cZU3CuKudkn3FEx	1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1577	1327	1	1	1498	jxmKBAwi5mjQda6X9uWRFyHGzTSQi76xLTGt4d1Em6xjMetS2AJ	831	1169	1169	1616149620000
1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	576	989	1	1	1500	jxzBYWSYDUJvrpAMbCpfwk7Nr8b9D41yCbeFyQTyQsawWjBvNUA	832	1171	1171	1616149980000
1521	3NLGpXKpABqGE4K91mRrVfV5UiQbJwp3qzPzs7FoxXuHuhr1kD31	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1406	1393	1	1	1501	jxDSchZf3YV7q3LY9FXdU8Ca8YfUchLY2dqFbrX4yDwJW53xao3	833	1173	1173	1616150340000
1523	3NLPCGZ8pvqromu6Kn6495UMiD4zk79vrikeGGePyBHnSQ1RqAFs	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	532	1303	1	1	1503	jwcGjACrzA5K4paHaKyafu3QW3Hf5ev2W4ysggFwaCUxamEmzyT	833	1173	1173	1616150340000
1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1522	3NLUFmm5xNfqtnYoBwgqiRuyen67st6WwWw1sbKSKJPXMm47kuW5	1474	1329	1	1	1504	jxufxWX6cRQcEVwgsgdPQJjBmsYpS9UCMWWLs173sykecAoemtW	834	1174	1174	1616150520000
1525	3NLLR8fT2pwYfCPYShk1D2JZd71u5snsMRncneHCivLXBR6rT93M	1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1407	1395	1	1	1505	jwE4eH6m5PDPshsQwrQnDtwEkU36aKXqJw2CytHAVXiR4KSQ6J9	835	1178	1178	1616151240000
1528	3NLJ4X6yV2WzJ8ibBFpme52jzyGrnLXSNc3oyhoHEYAAdzqGqh6C	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	369	1066	1	1	1508	jwpfPRZD46i2huWiSyyhtuneNMqjpCTic2Rca2X1ukzbBVfk5Qf	837	1180	1180	1616151600000
1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1528	3NLJ4X6yV2WzJ8ibBFpme52jzyGrnLXSNc3oyhoHEYAAdzqGqh6C	1406	1393	1	1	1511	jwJzd1mDcmBLPGqtV7oCYu2KgTHDqrYdNMP2TPtbKy3C3QgNaF4	838	1181	1181	1616151780000
1533	3NKWwwhQ23R7YRSKfvDJpBpZYVcHvkMQZMVagXzQDNXyLhvYNvsR	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	311	1307	1	1	1513	jwKL3sSyaUh4SnWLCSv6E1YXYwWP228xuT9tdBCtgxmTNXWGm4z	839	1182	1182	1616151960000
1451	3NKQMRwgTr3q5oARzLAHNavQ4sd4EhyUjgitdsyauj6SPQysTmBe	1450	3NLQuUcXipQFAKhvMH4iPeTYW7jpYZPQB6r3Nzmnvyzob1xTxGS5	1581	778	1	1	1431	jwgnAhUx5Vqog8rZ1aMLFGzrQDEF7wgp59CKXzjUm5ipc4y9uuK	790	1108	1108	1616138640000
1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	152	1330	1	1	1434	jxS2Kk3gwFtMaF55sKbVxAjZbjEXbxL9PbV7eeXeStqoT4QoPNR	793	1112	1112	1616139360000
1457	3NKRqDz47pT3MZcLuU53NYGkjEnoGabS4XDMLwes9mnsLTq9JsPP	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1555	1221	1	1	1437	jxxZugd868wSky8UYK85Ey565KHJkz7bc2rXofhEj4kCo9ATY8F	793	1112	1112	1616139360000
1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1637	816	1	1	1440	jwT8RfUgFWhmXfs6iPD1fxznMMwVcERgFYh6ApCKDQF8HrzA47p	795	1117	1117	1616140260000
1463	3NLssf5upN9HjVHSXAaPieQPGeiysZwFExs11CSuP1pjfYzb3oHk	1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1633	1264	1	1	1443	jwAR5LoKNxja7cS7qDdwwqZnDWb2pzLsciJvk1qRtMnQ6gvxStZ	794	1118	1118	1616140440000
1466	3NLbMv7zsYpzU8vQx4i79wu72diWEnFPtFGufosFHH6te62umTiY	1465	3NLLdRud8zJwBxttcpv2rdjCK3inpZCrDkxPBLkFwEuaBEFaVr34	1489	1134	1	1	1446	jx3pHkPThPUnJihCYpskRdzJEtZW5s3SzTjsxpGzSwwD8VZ9D84	799	1122	1122	1616141160000
1469	3NKwBDNW3PhGS7pnbEkDKb99AGrRLdf45o9XXa6bcxNMh985njg2	1444	3NKA1tAoHtHUvX2ZwjzQF5e8RaCS7QGJx3c8z4XCmf8iFLW12Pz5	1553	776	1	1	1449	jxviD4C2UCprjFSqBffZkWv2VFN4cTFBeYvvSTcdSUnP5c3ytVi	694	1124	1124	1616141520000
1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1471	3NLxhDyZjM8tbPjAqzv8Wv2T2u5wauim9XSDdPRQsKG1bLB8erxA	42	1361	1	1	1453	jxnQt7BxZTs22LSbPwZcZeDEQjGJK9WuLTfviN8g748ktmWYMQ4	804	1128	1128	1616142240000
1474	3NKTmfGraGuJbF812EvTTi715AMxmwfntfNZnrwP7m7ZWPkvmVnu	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1534	574	1	1	1454	jx2764sxCUAiDSS1biTqYEyZa2rLLRWgTNcJP1QchC1Ny8LARd9	805	1133	1133	1616143140000
1477	3NLi9T5F43YAwF8okujmXMr3pUckdu2qQ7BfTAkeQRqs3GmXKEbq	1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1589	1286	1	1	1457	jwhWYgUrkAJctUrtdyt9SmQzgmmvm8WDPqEjNoLvHrPht7GZLv9	806	1134	1134	1616143320000
1483	3NLqCRaxCStHoGXghNSM4tqbJStR1e7ospznon3pWaSTuPSaWuBL	1482	3NLACJmMf7pmh1C35GJei5EzoiDWvq4G6FP5ziRZRKneEknCCtdE	563	1113	1	1	1463	jwdScn1rBn9Vt4PQDWa7XBj46vBx8PaXcPietA4EBt3fTtvR3Y8	809	1139	1139	1616144220000
1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1624	1088	1	1	1466	jxi4sx3xQsLNE7cqvnBYtifgYBdPfNzGh2ckgQfHc6444nhgL8Z	811	1141	1141	1616144580000
1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1407	1395	1	1	1467	jxhCHec7mKGbNm7Qr7sfd43LxkxabUKDaKqqfjNeL1d1kwEMwho	812	1143	1143	1616144940000
1493	3NLEsPzdfSLBRv8WYKJ3CfaaoTUdwY4wUGXiqP13EwUxNHoeg4FA	1492	3NKss3AVVyw4LiTjFMH7k7z4ViFtudGBbYYKfwpiGhCtztexMhCZ	532	1303	1	1	1473	jy2tneeG39zMtDMPgvzdz79He7kgPf63DroXywLW66WNH3rsXbb	816	1147	1147	1616145660000
1497	3NKt1HXjgUGVcdKZmhoxRcrnVoBUQTa5Arnz8SmWPTARKh8mfqKo	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1405	869	1	1	1477	jxPYhWF5qAnmZiD8KSgdvqfqoEi8jXPddhCjyyWexhKc6pP2bmA	818	1151	1151	1616146380000
1501	3NKh76NZdGJDoeYeMfYi3xmXVyouMz6Sd456uAW4P72rkzqvED6t	1500	3NLRhohgfsqkFQC895q2qCC4VaiECWetrvZyN9f3sNqnLcKGaGSn	1500	1297	1	1	1481	jxUyqLw5yWpQudhF5qraKqYQy3ijcT6cLT6L5GpTgqALLexTbaa	821	1154	1154	1616146920000
1502	3NLkBvGeHyceuL8zspmJj2DrJr3probZGcoMg6tsxMF7JeyxDrpt	1501	3NKh76NZdGJDoeYeMfYi3xmXVyouMz6Sd456uAW4P72rkzqvED6t	1445	1290	1	1	1482	jxff2Y9jFfp5Upv67pwKooFeKUgKaHRLa21ownvU8ZuDmryg2bV	822	1155	1155	1616147100000
1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1504	3NKEUpMwm81jqCSHH7Ai82pdbS2eEgoZaskoYBQd63AvCGFUyuKs	1650	1249	1	1	1485	jxqQwPCJYxCFCT4JU7PnGU3uRc7qnMBHwBrsTNfAVCm4iBAkdTc	825	1158	1158	1616147640000
1507	3NKaror93K4Rm8NwGbobhWfgkmACzyRoFGREgUNn3yW9VxWTtxVE	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	484	1073	1	1	1487	jxtTVPrN9ZWRTsidKf6k7uzxXQ2dwzdMgtEtV1hUwk5vtFNEyrs	826	1159	1159	1616147820000
1509	3NKGX8FPzHMh5tBhCEbBmnfoN1uqQwCShfxta8bnHhX3yuNE4QCd	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1477	1350	1	1	1489	jwXb7FtLUBu2bTnZocVPbuxLk9McCpsgK4XVN3EGLfam39ua2pa	826	1159	1159	1616147820000
1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1648	1284	1	1	1497	jxT5cpT1kA7JA7hBnXnRRkseFJqKVZuYwzAhfEgW3ojJ1RQxuiQ	831	1169	1169	1616149620000
1522	3NLUFmm5xNfqtnYoBwgqiRuyen67st6WwWw1sbKSKJPXMm47kuW5	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1671	1365	1	1	1502	jxchQGEwAq8pzdsWow7TqjV88pnFDiUqqhSnHYvqnDcP4Ba75ow	833	1173	1173	1616150340000
1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1525	3NLLR8fT2pwYfCPYShk1D2JZd71u5snsMRncneHCivLXBR6rT93M	1406	1393	1	1	1507	jxCcpCFPMGj9E7ULGri17ZsKKCZmzMjX83K4bKHK5kYknjjQYNf	836	1179	1179	1616151420000
1529	3NL6NB2EskXEbG58NfAVZj1BLuDomWnBYEqFz8SkFWZ2efP72idL	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1619	1275	1	1	1509	jwo47UNS17yCUfWXmEamYmDSe4ovvU72xbyuRciLn4UDzdmEfWt	837	1180	1180	1616151600000
1530	3NLgRYRn7cwSj9gvJD5nn7Z5yWpDHSDU3HdZpUY3Uv9ANJbo9SNT	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1578	1170	1	1	1510	jw96ucSJjqY5zVcoUykx677hs2NbxfKndDoafo3WFFaGAW3eY4w	837	1180	1180	1616151600000
1536	3NLgnXSKN7gjTvkhFmDeGh3TQavjeihYregFwyFh5Z1o7UupyVFe	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1651	935	1	1	1516	jwEqUazAMh2rQ24MzEye5qPb1P9Qqgfd9Jv5dQCHnVFqiRFznEs	840	1183	1183	1616152140000
1539	3NKLVUmZ8jPq7DE6z9fruEUAxrdCXDZcGGBiQ2PjXx542MKLH96e	1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1406	1393	1	1	1518	jxDfWsuhG7p1UwxqSYCCKVXed6WBqRjVpvnQsjXsfsbU6Xr5SAV	842	1185	1185	1616152500000
1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1407	1395	1	1	1521	jwHbySmzTTwfRpTzttCvQ8LPovRphE9ATMPV9kPVhQ4fh6H487D	842	1185	1185	1616152500000
1545	3NKQsWTryzYp9SpjAs1wmLTD5E2M4xpiLyPWe9tgwJV1mDDmDZhV	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1406	1393	1	1	1524	jwZU4rb4e5XRnmVcaTmUNFgHRtmzGSYWXdLpgv62TnFYCVvJAvW	843	1186	1186	1616152680000
1549	3NLom155tPZorNjukV3iBZyBvzxWXDUAeMErKw7mBLBHvF3H8iV6	1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	1559	1353	1	1	1528	jxjihEktiJthiCp5s1o1fQoBx5a7xSYjU6DSoqAZLCr6A4FBsq8	844	1187	1187	1616152860000
1555	3NLUfbe9VRgsicNgczHb82faQ8G86ZxyQPYy8KTNdzP1tzgYMm4Z	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1501	1360	2	1	1533	jxz1AB9NPhieecYuMQfhSJ4UyfP8Y8CDWwEuHtPXrrXoUuVWWX6	846	1190	1190	1616153400000
1557	3NKiLkbBVHutcbutynSKUTApL33wKxasAWT6royyfXTduaYLHvrV	1555	3NLUfbe9VRgsicNgczHb82faQ8G86ZxyQPYy8KTNdzP1tzgYMm4Z	1590	1174	2	1	1534	jxRWtqij9rtLacD5WzpT935GwEv5uh1bDm43y3Ujt8KD6KUKHrC	847	1191	1191	1616153580000
1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1581	778	1	1	1514	jwuX78UtX8v4evN72JQopHaroiRZ6i1J5SxAjSVfU6kmrBe2C59	839	1182	1182	1616151960000
1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1651	935	1	1	1516	jxy1312bjkeX9vjGc11oPWkGcoAAXmxRQa1442i1DLU2kgUfNhE	840	1183	1183	1616152140000
1541	3NK6YhC2AncGSdPhVatyQ93WjKNUz6o7W7CV438mQQwyBJXPTXJJ	1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	1560	1045	1	1	1520	jxbpnQciBX95z2XQKgT5j1bvVkNsuYYSKieKLPLigPFPSvio6zW	841	1185	1185	1616152500000
1543	3NLfzsQDgbUrHXYfXBjC9gG226SjKn6wWGdhnHDEJFaDv2KuLicH	1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1560	1045	1	1	1522	jw97TSx9oysLenZvAmb2i3SyvankYhRb2V4mXmaRg7MXjejHEdo	680	1185	1185	1616152549087
1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1407	1395	1	1	1525	jxVsMZD4VyL6QwcVC6yaNYaJHwL43rwc1dfY13AGyzMhjnVsNRA	843	1186	1186	1616152680000
1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	298	1062	1	1	1527	jxxTH6Xj9bqFPSeFAqMbTRi7W9jHNRJ1c9z9wpqFcp79w1LC6d9	844	1187	1187	1616152860000
1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1654	1340	1	1	1529	jxqumMumVf1asvN6VizbWZAbDQaKKt6kmpv3wEjZbtikNdQpe7L	845	1189	1189	1616153220000
1553	3NL98rqLgx2My4PphGzqRx7dB6VnNa6V8uLX8VQbaoaKXXhfwA8V	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	2	1	1531	jwXpD4esoiVsPKZNrxzQYbsQh42hXS5PqiqhbCKJw6Mfm2vJZdm	846	1190	1190	1616153400000
1556	3NLqj3zd2R632kS9nq5QyRuReMEpG9rxS8VarSSMAXhQVxoXygrU	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	1	1	1531	jwXpD4esoiVsPKZNrxzQYbsQh42hXS5PqiqhbCKJw6Mfm2vJZdm	846	1190	1190	1616153400000
1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1407	1395	2	1	1536	jwxMRiT8hGKfoy8ZPkRxdggWDJGwM5hKNuDPjQWMKRDZZreSrcu	849	1194	1194	1616154120000
1564	3NLXD7DkyrC9pvUm8XjJWViKLA3b52J7G8rRTgHFZKBUC9kXLuzZ	1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1673	1368	2	1	1541	jxRgDrCZP4abSf2aRshXZat4Z3iLNDwH3pTDK8RgHtuHYVqgJzh	851	1196	1196	1616154480000
1565	3NKg3BXWGuNjjzsvVQnRSRUQTAfegmJerbPqzttKBxpMJidLCwMr	1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1509	1320	2	1	1542	jxCLZR1YNAswafKnq9FSTyEPdv58km9YyAktHaBqsqTdWLR3qau	852	1197	1197	1616154660000
1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	1567	3NKw5SMBiJP6HPMpuVgJUBprtqAnL7bX2SuimRX5HBzUKHfHUuLr	1675	1096	2	1	1545	jxi5cpNbKpQ66dUeu2vz3LD23uSNxU16CvjDsZCxUmADutLrhZZ	854	1200	1200	1616155200000
1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1637	816	2	1	1548	jwP6Sqe3U7AxEuxXEAByBoiYDqVTHoyb89ugpr9paPAre6rt78h	856	1202	1202	1616155560000
1574	3NKqrDu8w8eyeqzfPNn9skin9D5gLsBmUAnqCC9HsUpKgeHRoWRx	1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	171	1374	2	1	1551	jxgPHANmvCkGZBCQdR1W7Ld77iXqZW1y4GbWwv7UyxoF5r4R5cJ	857	1203	1203	1616155740000
1576	3NKg9jxkfSWv3hLq8dmXcWNL6igC7p4t6ND6QAvbphQiDw88RnTn	1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	1637	816	2	1	1553	jwDfuR7no4y83oQXvGpoxo4sabBupC878TpsZgF6oVMR8LimDR9	858	1204	1204	1616155920000
1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1406	1393	2	1	1554	jwx1MADGRQMr13cAW2fZWDsNW6UQEbnbWvmRSGE1Lh751VuqVfM	859	1205	1205	1616156100000
1580	3NLVu6PLj8qfgde25pUWHz42ps2FD2rWK346Lc3DspQ1d8GCBHDS	1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1541	1172	2	1	1557	jx3Xkg2bZiKL8dmzd4B3pz9bhpmtMtbDLHUHQu6hyE2Q5BdeKSR	860	1208	1208	1616156640000
1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	1406	1393	2	1	1563	jwpgUxpUX9PYtZn561jUUrvmJTc4o9LXN6SC8Mi7L5jcNxyzDS2	862	1210	1210	1616157000000
1592	3NLjKVeE1GC4mG6zXYPVUMFkRLQEkgnoCZLuGcW8QMd9rstLF9kJ	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1406	1393	2	1	1569	jwzc45TL5yGYwVPknr4fv6J1AxRZPzAni6tjdCjDiXKrEXLHWEN	866	1215	1215	1616157900000
1594	3NKt7CWiXWUnibW6TqGQeduFWdeyeKGg5LytviGEaCmmjUGjgeng	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1422	971	1	1	1571	jxNvYKhPW7iSPEoQCAvGnyg2CNJyf2mfvqVi4TQsSDSjt5soABr	785	1215	1215	1616157900000
1596	3NKxpTNzMQ6p3sY1TGkyr7U5URgeqwLQcAntVsPn3UsiD1d1Agd4	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1541	1172	2	1	1573	jwUWya5gFAeqKtiZRwtVkuuo5BfDvHQvEvY3sJTHWu6Fa3EWKYx	866	1215	1215	1616157900000
1601	3NKARMHo24dYiYqd9wYHjnc35kHMVSDaFbGuHPNaUqZVHcsNZRKa	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1560	170	2	1	1578	jxLdvgqWqCvhf6zYT17hU8xQ4tcVaVTdM9uMvNaLmX2xnowsZds	867	1217	1217	1616158260000
1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1460	1198	2	1	1581	jwz7GkvNtSQmUMhhMZguGRDexG12GkVMFKMp5z8yf5hPdRiFpR2	867	1217	1217	1616158260000
1606	3NKs1T6W6eXEtE8AXFP73yywKSKX4moEhAerYpD5fS5kpDArQBtd	1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	448	1305	2	1	1583	jwxrtthephM7WwCKyEa9oWnccNLx3HMv1bzrY6DKYeGXxjhknZu	868	1219	1219	1616158620000
1607	3NLcg4pi33Vvy9Xkq7Ytizjht9JuLawS72VtV7GVhGPGGKybSsdg	1606	3NKs1T6W6eXEtE8AXFP73yywKSKX4moEhAerYpD5fS5kpDArQBtd	1406	1393	2	1	1584	jxzzCg7UpSW9L2t9ivULS48mDvQSBxADsttaGFNWhgc8nRAoW3c	869	1220	1220	1616158800000
1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1609	3NKUvJtHwNdAmYAbcryiqGvKvTHcrzsGbWR1QhFFBvgZkmdsyU7n	1407	1395	2	1	1587	jwoSLUhrEt6dps3tgctTNE6JEvm6DxQe6xLJkbGsSks2VxbYDMy	871	1223	1223	1616159340000
1611	3NLaAhEdxUp2muvDvxqvoXbaVXo2koiLtk6Zav79K3vYFnr4SmUc	1594	3NKt7CWiXWUnibW6TqGQeduFWdeyeKGg5LytviGEaCmmjUGjgeng	1422	971	1	1	1588	jwCQqXXWAb5WBW9rfLsS75yPjhrbv3N8SkdPmBxndiMFbUMWtmf	786	1227	1227	1616160060000
1614	3NKDvbYgMWk7tSCuvJ5c9Htt42WfW5P8hZWqKPNZp9RgDK8FLCXz	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	448	1059	2	1	1591	jxg8cxvL8h8k9Q6er3rJRtzcs2jXen5Yeqp5SXquLz1v6cYniJe	873	1228	1228	1616160240000
1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1503	911	2	1	1594	jxT4VgswBfcU1VpeH6fN7CtdRDmWbc9J8LjhBZ5eeFnJxRi8zs3	874	1229	1229	1616160420000
1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1403	824	2	1	1597	jxqBX4UVSnuNYYamifd5qVuQRqnGGAijDqne8df1RrknP2i43hh	875	1230	1230	1616160600000
1540	3NLQteRLvqAu8n4Q7gnKzMetUsFgZNZRxHDxgadEU9FPt4eEosKw	1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	1560	1045	1	1	1519	jxPCVk2qNgWdUDt9sK9e3FqczDxDU8dqQE1qGKVRgmVJPb5NG9Y	662	1185	1185	1616152500000
1544	3NLxVegm4TVMvpvMZctF5McseACaPVqFgv2UirYgbjKKVM5NQ2zi	1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1560	1045	1	1	1523	jxU3mZBubsK7qUtrxRud2wPMoPwNuNR9mtLXdWCR4mnzwGTZ4Ub	696	1185	1185	1616152595105
1547	3NLjPdZF22m8wcjJjxUvNCYdNEM4XZBiDH33qsjwQMDHfhXoKUVJ	1495	3NLXaBey8Tx5m6EiUHRTruMCy3NaJY5afKdaUYh9QX8d4JV3JtRs	1553	776	1	1	1526	jxcV2UkUH8HHyPFXxiUzbZ9VXLxsFWmn5r89EoF3cv3wzfik7zk	696	1187	1187	1616152860000
1551	3NKrGzj6UhCdCRCdHk1x5KVxpcBCUNvYkLJraf8jmUGQi5eFXvES	1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1587	1357	1	1	1530	jxdjuEiMoR14E6vEcnqgcDS3ecBwpiLBve5Re14wd8UYA3mDdEk	845	1189	1189	1616153220000
1552	3NLpRw9JuWKuD3XXKFoskF5JeMQBvw5XGArpYPV9XavbYgyJEfRS	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	1	1	1531	jwzpHDjJdnbbodSeBp83W2nsxWC8A3UYg81wgrsWPWBRcKHp6Fw	846	1190	1190	1616153400000
1554	3NLnNAZkb9W9VUz1pDC2hvg74225FGhgV4RKTPvDAwGBfokTFfeU	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1642	1367	2	1	1532	jxtuGgfmTpVEFhGcb4FAAW2d13mxjWSeAQPCqVsJH5fzfVimqnt	846	1190	1190	1616153400000
1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1557	3NKiLkbBVHutcbutynSKUTApL33wKxasAWT6royyfXTduaYLHvrV	171	1128	2	1	1535	jwzdyLtuTbteeJcSztwe1ZY3xM5cNpyd7U1eAxfUdFoYmGsa5uR	848	1192	1192	1616153760000
1562	3NKZ2ELogKzEd7TkcHWhKGUH7gT1yyVBFB3A2qPFba8JwHbg8h1F	1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1596	1363	2	1	1539	jxqR3w9yBPGQT4kZeMBYUCkRSt3Pq4PnSC2s7oJdgBvGkhTLbCb	850	1195	1195	1616154300000
1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1407	1395	2	1	1540	jwkJMoax4hv5vTVPassjgu9UM884tJ9PLvcm4GZ9Yw7BtdbW2tz	851	1196	1196	1616154480000
1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	1637	816	2	1	1546	jxF8tRicuzCb2d5v7d6LJm6Tn4tZDkd9ctHu6ug26WfkvnS9x8h	855	1201	1201	1616155380000
1572	3NKJ8oVmrwXohEVwMjPiJnr273e3iXaTVg1fuU1RsHJ4FLWh7i36	1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1611	1341	2	1	1549	jxF5e41xZ8hVb5mNDDsTGTV8KTGHdVNgwxS97jtZJVd71b6cmFq	856	1202	1202	1616155560000
1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	632	1136	2	1	1552	jwGyrdyrQ9Dx4uHMQfTLyUQEhDV3LwTicDgepiJv1NDk7B2oRdL	858	1204	1204	1616155920000
1583	3NKqKfLepectgunwQ4JCZkKLkyazrT6yoQ9exaBv6ZBXhBcdtB1Y	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1642	1367	2	1	1560	jwsFPm9QhHiHzVYqysFZkk77GrQQfQLMi6Wd3R1JXv5SmiJDN43	861	1209	1209	1616156820000
1585	3NL75sbGeXk9BeMoyzC5z1Q6JA3wzqsyMDngeRFAgwtvuaTBAxwx	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1483	395	2	1	1562	jx2nKaXYpwLmKRfThCykHF5266YcHWasx273KZP5io7LDjhN7kW	861	1209	1209	1616156820000
1589	3NKQusUP7qC2enj1z26YBJurA2ryDVcuPsrdUnbXE2NBMKkwHBQk	1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	1407	1395	2	1	1566	jw9fBwzwvbrYyEBHr6nhPJqHbhaSt6KgwaE1zKSSA3aMQZgMVxP	863	1211	1211	1616157180000
1590	3NKsHaB1rz4QW5SMqEE7ZBs43ypFwiJRTS8iYpkbDmG4MA8sZUkB	1589	3NKQusUP7qC2enj1z26YBJurA2ryDVcuPsrdUnbXE2NBMKkwHBQk	369	1312	2	1	1567	jwS6fuSygTxgQNWtgsct9ej2iL5QDPKwyLGmMqVWsnfVkmw7D3M	864	1212	1212	1616157360000
1599	3NLEe415pFZGH2m95wox3ULbad5YNRCBSPkfKhuPH1u2dpAA1tJY	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1631	793	2	1	1576	jwa1EcGCLJ2xBkW8hHWCjSvMkybFBahBqZ2hFB5QVa8MHCA5bXA	866	1215	1215	1616157900000
1603	3NK5Zc6uKKSgnWspM5Nvng5NTEomyZUYQYC5FC57Mr5awteCZeHJ	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1460	1198	2	1	1580	jwWDHA8vKUojaNACEpAW4U2T9f288z5WhvSd9JcWBNBVfioVjpb	859	1217	1217	1616158260000
1605	3NLbRheqrDUuq1UGPJ2sJbtGxgkcrWsrwkS7pz4NqekY59e9HuxB	1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	1406	1393	2	1	1582	jwRTq8y5ZwkKt8o6o4cJeQZyxsXDhGeNNuYsN6aVvcuk7RXpEaY	868	1219	1219	1616158620000
1609	3NKUvJtHwNdAmYAbcryiqGvKvTHcrzsGbWR1QhFFBvgZkmdsyU7n	1607	3NLcg4pi33Vvy9Xkq7Ytizjht9JuLawS72VtV7GVhGPGGKybSsdg	1649	1137	2	1	1586	jwX8FkSbGdiJ5Bj1XoVy3G7ZCJ6XtJGCNPknzGtrxZv3LhiATBp	870	1222	1222	1616159160000
1616	3NKjcVXWi39NNtZWMRHjjJw27jXsMkCVHnUcWZjHGH856DFaJmRu	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	298	1308	2	1	1593	jxRFskpkUfmJNDco9etD4NeG4bxHGjAmT7BMVeptGsXdN9SR9T5	873	1228	1228	1616160240000
1618	3NKo8mmSWd8SfJpbHR9XhyEx1kcnYAqhxVdsZixc131etraUfShu	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	42	1115	2	1	1595	jxs3cenEab6Bk6k3wY1CtuyQxRUD7SdnXPbV5nu2PtuCbbKEGcQ	874	1229	1229	1616160420000
1619	3NK9qeGpJwbXbHTjkHCM3ZUZeuG9V7JFrZaLe4qsaXEaqHzVQnAZ	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1631	794	2	1	1596	jxbxkFzG4Kh6q4RtFmb8StYbBEpwKFqhWwhsTpaxLKXhcz7NwQb	874	1229	1229	1616160420000
1622	3NKy81fqwvu2ycBdZzJb1HEfczHhGcc8zrBi1J7t9bHsCJFtr4yJ	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1489	1254	2	1	1599	jwky2PaGdJYTM1N8ckvLfSbwccnXpYbC6bPKEBDprNXmiTV4AyY	876	1231	1231	1616160780000
1560	3NKZhuWL7rTQ5pmfxkGUtZfugBTrLV14C6ZhjDB7fS2nEK6nX8EY	1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1522	1322	2	1	1537	jxxTyQ27NJZzkPkrwfkCuDQq7nc21RYRSJ5VkbuHKw1VPuZnVfV	849	1194	1194	1616154120000
1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1501	1114	2	1	1538	jxVQojsxiFmCmJyPkhApa92yeCrib1Fb6vbxUtBw1oh6agJ3kJM	850	1195	1195	1616154300000
1566	3NLsqGoQvUfrattqimnYgbGRGTRd2hLJbUVuLqxEXNYp3fGGtHD1	1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1607	1348	2	1	1543	jwmawk9HWgD6oMrCn9ybpqbZQCyeHnx4ZnihD8Wu8na5oVcFngq	852	1197	1197	1616154660000
1567	3NKw5SMBiJP6HPMpuVgJUBprtqAnL7bX2SuimRX5HBzUKHfHUuLr	1566	3NLsqGoQvUfrattqimnYgbGRGTRd2hLJbUVuLqxEXNYp3fGGtHD1	43	1184	2	1	1544	jx8MQmg3sgdT2GvAiyZwt7eBAyb6ecN6dkHvpRAZQE4UqT1otCg	853	1199	1199	1616155020000
1570	3NLhyvFS8aAD6qU2tbZVLAFjpgWWQDymh99YUVcdWW46cc2QutiG	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	171	1374	2	1	1547	jwi1W7R8fQfmhWfjbYzV12HLetnoBqRNjocuQHQHyoZa4VXYyFa	855	1201	1201	1616155380000
1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	1406	1393	2	1	1550	jwdaYMhAKVzqJoBaDAib5Mscn3A918yg4A3NNU6PwJWtEnH7VTN	857	1203	1203	1616155740000
1578	3NLhpzmDBhWv8zfuTeaZZiL7RygLY1oRwf7gnxfXWDFL9GE5WgP7	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	519	536	2	1	1555	jxxwaPLCkLAmi1ZK6bbDmNLGot1U9y1FGdTFeXyTKqL9L7LCh5A	859	1205	1205	1616156100000
1579	3NLTniKRbWZ1JfkRfT1w6Tuip8Ew8YiMH8fEj8t2gAcQB7HW3prp	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1631	794	2	1	1556	jwPg6xiMNgr2i8Hj8DHeGbKKLBTNnqEpsMxFjAGQBCcJKDNqRzq	859	1205	1205	1616156100000
1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1407	1395	2	1	1558	jwPYwLW6Vaq522edrdKAV9fyzKrdmhc8PVKMsm2NhAMzDcMFyZ8	860	1208	1208	1616156640000
1582	3NLUh4Z8pLCruzs5oRFEfbVKnVwnzs1c84BmjD46JBgGQ6dorUq7	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1654	1340	2	1	1559	jx4BAyrjKLxgHgF84JBmiRu4zA5ucB5xYUB7K25AuEoQWBxAxTV	861	1209	1209	1616156820000
1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1647	846	2	1	1561	jxRb2KreXRMWJyN5y8LyXvV8L3h5WkaLw3nhnW6LbGc2wJqdkq7	861	1209	1209	1616156820000
1587	3NKenyjhCFkCZcvsEguvqP4pwMcyUW68XV5cE4WUwqQ7Tv2VmNW5	1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	576	1355	2	1	1564	jxzMhinNWaEXfmRQYhbUWNNaKixQwEyXX4J2Nx2zdoR8opXeoNt	862	1210	1210	1616157000000
1588	3NL7B2yYytNfVJunoL1D4JiiL9FuD8pTeca7z8NNJrz4JBtAXkQg	1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	470	1063	2	1	1565	jwm2B2Yc5M5PtUUtViLfT4j7o3r59bcq4wo9kWXShNzUTP1egWQ	863	1211	1211	1616157180000
1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1590	3NKsHaB1rz4QW5SMqEE7ZBs43ypFwiJRTS8iYpkbDmG4MA8sZUkB	1407	1395	2	1	1568	jwi9FBdzLvqb7hwnhtSC9c82xhRcVVxYuyjYNxeE8MkEudhyTgp	865	1214	1214	1616157720000
1593	3NLh1HzU6qRXkf98wQzgPACPNQcYHMrcxYAhxi4ypBb5UgSXZ6WG	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1422	971	2	1	1570	jxSvXuZEkGCbe7SBbNnFujTeza6j47xHfEtuUHafjFDRZ8ZeNMh	866	1215	1215	1616157900000
1595	3NK6MvT5s1BindgEnUnCAEegNkcmgf9CGwC7CjsRc1LfQFg3pG3F	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1522	1322	2	1	1572	jwbjcV9nYNn4i67z5VT2ZcW9oV82gFCEKM44r2FjkQD6azqYu6J	866	1215	1215	1616157900000
1597	3NKScmJfsYhcKNK1mLUmSK37XK1EmsmzKV8pey5aWrgmM1K3ymGC	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1668	1370	2	1	1574	jwrPompXycRFujpMHHuKsUNGE2qCjDQ5rA5Nm1wLkrftkDMfEyn	866	1215	1215	1616157900000
1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1476	1245	2	1	1575	jwpdtYJPcf2QX1TPDxehtJoeFT9DPdz1W2qoJaHVFzSSvrpUb2U	866	1215	1215	1616157900000
1600	3NLfPqD9EjdnQViZvBUzaRnjegF41XPMhm9HdLBQuDhNTiBxP8yu	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1560	170	1	1	1577	jx4zESQbSuJ1iX6ZAFwyb9Lx65nMJFv8XedEQroTko68euaNd8r	843	1217	1217	1616158260000
1602	3NLqApn8PjYurTfU3D1ZdSmwRFrxKGvt4ST3dV8jiRBAtWiFcGKq	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1447	1345	2	1	1579	jxvF2w8ZXRBJZYZvkMRxJ4XYVQSyonKx61UJSR8S3QwsxagpJaN	867	1217	1217	1616158260000
1608	3NKfV9ERfCSMkWntkM6QetqFsm8wKNc6m4cX6zZ7xYSSff7gv7M4	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1397	828	1	1	1585	jwLcXVbrQy1F9etXBTHV4bLkd7V9eoFpy7FZi6cPaWTCKqrv6Me	783	1220	1220	1616158800000
1612	3NKSF4pVBBVZm5VtRHFTjcjiMx3z9U1tZzue15Y5CwUbw8saBRPM	1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1422	971	2	1	1589	jwXzdWn9Hv5dTD7qCCF15n2WxUjr21wiVW5YdMuvW1ZvxJ3SsxC	872	1227	1227	1616160060000
1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1477	984	2	1	1590	jxYBLWZoSzfzKZe3LeYRwPv8823oq1WQ8ndf2qEVs7Ffm9JkACz	872	1227	1227	1616160060000
1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	1490	1274	2	1	1592	jxHLR4X1bEXxGssNx8ZxLzKDgzwwEAj1yuVfCfWhUSdfB1K8c6w	873	1228	1228	1616160240000
1621	3NLB2GXjVNkcnHy6eUyQRPhCdvtowP1fU1DC6NhvRMnm8A3TMGn4	1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1407	1395	2	1	1598	jxCcXYFBdipF7oCCucagF4RbZ3RGAnkGJ8A3t3RRry5ykQKpaNr	875	1230	1230	1616160600000
1623	3NKzuNdjCUB6FnJUX1KimcgPRA2E9vqhrQjdCsm4VvXwgLLHZDyT	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1501	994	2	1	1600	jwBPaWDdZM4RzM8HhJ1GrGq1HGr5ww3mnHuZuMUSKtVz1NdAq4d	876	1231	1231	1616160780000
1624	3NK6x6vtQy2Hmkzpkd8XFo14cYSsMRX8fSMhKkcUxBsDmRzXJzLL	1547	3NLjPdZF22m8wcjJjxUvNCYdNEM4XZBiDH33qsjwQMDHfhXoKUVJ	1553	776	1	1	1601	jxqcacPzU8XazpcPD8pcYN9x731GM5wgwVaKwTJN25sALBHH3UR	697	1231	1231	1616160780000
1625	3NKwdEXBdxiUhNL9PzhbhJpQgmz5W1bRcKCN74mMRhVfDr4fDEqk	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1597	274	2	1	1602	jxsANmvrs6MPYkfTfNDrfAzE9UrCwS4B4qySb5expLbvimmKKnj	876	1231	1231	1616160780000
1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	1625	3NKwdEXBdxiUhNL9PzhbhJpQgmz5W1bRcKCN74mMRhVfDr4fDEqk	1649	1017	2	1	1603	jxwcbBQkwQroapqu2TBmoJU5gxh8Q3nEKoJGBw5eP5fwNWHgt8Y	877	1232	1232	1616160960000
1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	641	970	2	1	1604	jxPKma2rVAigQwiTck5tNewJ1REHWzEj2QFvLqKeYZzXnwp1L65	878	1233	1233	1616161140000
1628	3NKShCH6fAcAXHjGBaTbnyf4GHpbhce5D3yBHtEm4vk1a7T6tw2U	1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	1590	1300	2	1	1605	jxHZzZQquFjoS8iGpGb92X5HNh1bfShaVWqNCZq9jLJhCkz8Uy5	878	1233	1233	1616161140000
1629	3NLK2xK3WEbEv7aHStDeaugvUBqzNNMD7KMVhTK1QQ2eXSduGJSk	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	369	1186	2	1	1606	jwaE2s32qHTs9wceEfNArXRXu8Pq4WVG2LHEPx8YdY1JbKXWeXD	879	1234	1234	1616161320000
1630	3NLhCmL1Z4xkRLeLfsPLcSmh2KsZN3YQyRyK1CJFGeiHzA1FKCpS	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1458	1077	2	1	1607	jwSzVEVcQP62LCBrTz8exciAZ8ZXPr2S7Nf1FuVKzJPBV9ikTh6	879	1234	1234	1616161320000
1633	3NKJVAbUJjLp1x6XsqCL5fAwB2JFckWBHZwWNv8KcKbbuJXHGru6	1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1610	1068	2	1	1610	jxRYcgLYejKUUEgKyiM9SYiieyvUvFxTZWkGXmSXUKFxewm7Dt6	880	1236	1236	1616161680000
1634	3NLBp4p9a8E4KYcyUFQJekNk22nRY7DfzLJEjtB3QugUBU3LVyKZ	1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1631	794	2	1	1611	jwxm18NPW7e4ERdZFE5n7FJECzTzii92zrogu4dfTm9UQXt6VBT	880	1236	1236	1616161680000
1637	3NL6XqgaFPf4xKDUrJ2DH7RgFHLvmr7h4WEYJgEZUxFE7PCjbXeh	1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1631	794	2	1	1614	jxbiizr4j6QgFBAn4zQkms2ZqumyFoF8UJ6yV9AyVT9dnWg4kf6	882	1239	1239	1616162220000
1638	3NKZ5uJFCSQXMT8peg6sx93LTxHvkVArkUaZwv2mFAGvrL9X37PP	1636	3NKFvTodvxg9x7Ak6emCrQKWo8ZNDAfBZAMPKFsJ4GX8PiywhQqN	1637	815	2	1	1615	jws7Rq3QPZCdryzTS51skgDD84Tw1JvFdwHaSL9487xp3crZbC9	883	1240	1240	1616162400000
1642	3NKcLpaajLqXUSA2WLWGbgmyep67M2TQVJmrJgAvqU4YMmvjGnM2	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jw9PpNAuJeYEV4opQgzgPHxUvCqb64hn4Nrfo7r7FpkxbryYP1z	885	1242	1242	1616162760000
1644	3NKiFDffSZe6oMRgScfBTe2MnmyEaDyLo6w2L2qaJ2yFjNGSPHFx	1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	1637	816	3	1	1619	jwkbAQA8A6tKBXLEgzHH7gDVQ6fbX4SihHK2fkB5ZKSHdRKnQZp	886	1243	1243	1616162940000
1647	3NL3m2kMfnKNNKMXTENwBxtUCjo7Rifq4RxyuoVJb4NMtGLczzJP	1624	3NK6x6vtQy2Hmkzpkd8XFo14cYSsMRX8fSMhKkcUxBsDmRzXJzLL	1553	776	1	1	1622	jxxz7Z42HHqyUFVBDvj8FvWrFrSYMFPPT5R3W7hjL92EEci8fs8	698	1244	1244	1616163120000
1649	3NLubeDznQi8CeMgHLTM1eJpMZB1sqA37AaohsQV9tj3CxbKeyhr	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1588	1146	3	1	1624	jwRVSLSvVMzA5WLHMZNjwdwijxymBMr8VG2iG4XoiQ7ByJPEwc7	888	1245	1245	1616163300000
1652	3NKkafyVm1s3f9byvVJqx2eLG4dSErRnaYmrHUUY2FRxUXwTH5Ms	1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1594	960	3	1	1627	jwavScbB8GWx33afSx4bA3bds9dVKcrRquCzCcSVu4M6zS25bZv	890	1248	1248	1616163840000
1655	3NKwEuJcL8rBRw1f8jHy8se9aL5Cd5Bby2EcMBZ2kAXKSHuHwFXa	1653	3NKWVg8CThhXWuhpEY4ys8dKugujAkciBK5oDXGdLn1LH6Ekb3X6	1601	1388	3	1	1630	jxPbF7PihWYCBRXdctEEGzG9ksGgAxjd3maMvBnNyoo8HMtry79	891	1249	1249	1616164020000
1658	3NLy2Qa65afwd1BQjMf1agvaApP3Uvr528K5UobUo4zW4DtccvVd	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1662	218	3	1	1633	jxFMEpQxhvV63pr1uPbXoy4PG73zPH6N3ovXfyaXRQL8HnHWMQ9	893	1252	1252	1616164560000
1662	3NKVGCY2UR2e3W9tr6oV8QBkpdE5ds7zcRjL3nCVJmLUHokqjeD3	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1407	1395	3	1	1637	jxYWR45F1xLd9KsXiNyq29NjFKGNvGxLGpdMKEjKSKQsUWV1gvE	894	1256	1256	1616165280000
1665	3NLQZCuWhur1BGo9k7chJ2Y6gfFFVTzJfzsnrV3fPoYnAP1s4R3G	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	532	1177	3	1	1640	jw8T2Y9mHt3u5Un3XW8Mfyn6pZBhFKZzeUZLhrg5DK3axznFmMz	895	1258	1258	1616165640000
1667	3NLLoiFSjb977EsxYBFTPu1kpiU1pFNry8RRyKnd4HcwhLCxr8MY	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1547	1132	3	1	1642	jwu2kkAs6s77JB2BVJS8nVDqrUbgdHefn9azXYzFZmCCNodZXr8	895	1258	1258	1616165640000
1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1669	3NKFt8xe4KAUPbPxkATbxuw45QUkxvac31QTyxvrJtwjoRjTNaWe	1402	868	3	1	1645	jx9VixeqV3TMPtnMdbPkZp39XtwLAAxks1QXzUM92ogF5tgWFnF	897	1262	1262	1616166360000
1672	3NLjm4hAqfeCcmoVJzEurYVRMwDdtHqenSCWxoY4NNrvnU1hSHYo	1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1406	1393	3	1	1647	jwpeHKch2JMM77A41Rs91UUcNfeCktCX5enoAQQzzomMcyM5vJF	898	1263	1263	1616166540000
1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	80	1273	3	1	1648	jxmMYMkvhxNGeN8Y6dN5LishEcTQZvEHZ3LAqLAVJjf7yDGDHnK	899	1267	1267	1616167260000
1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1522	956	3	1	1651	jxGKUtKWxMrEyXwgf3RjrndXHavvydc62hyg9SFJyn112caXaRU	900	1268	1268	1616167440000
1679	3NLXUEpTFsW9SeiqHcNbKGe4odp6ybGWXLVjEhmGASLZsD3M51ii	1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1611	1095	3	1	1654	jwFkdyX435xbuLP3tfWB7kRmy7uqEWhwgfp61VJEVhY1bZDe9yc	901	1269	1269	1616167620000
1682	3NKenqGLsaQPDHuaGMJEJitUZ5zd4scCtWsaX9iaRTGiHY1hizob	1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	1650	1009	3	1	1657	jxnZf1WQ4Fw897ZVgDT9akiWjLz6cetWdrzZseoVQ3Uimv9fEPW	903	1271	1271	1616167980000
1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1684	3NKvg3h1wbnnVHgoVzY5QfrTcdcydu6pWPvh1LTePwRPQ69tgD3t	484	1193	3	1	1660	jwszmSNUA5xMkMNu31ijsEd2NDnL7YdaBkT9H3uQhYGMa5pSLU5	905	1273	1273	1616168340000
1688	3NLrKUT76NLkMn7ebZpe6zBQh6y8iYaCoyfqiWMWfQMPskyCcJHj	1687	3NLvQfDFewuzJ3RFRGMo3F1Rz441pjZpFNhs3KMyxkBcTFze2ady	1405	851	3	1	1663	jw7um6SaaQSubDicAQjCXrkUC6j4XugRwjcYrkuWpA8VBaU1eJc	907	1275	1275	1616168700000
1691	3NKEwsNnjAxUKQKEHBdWdE5a6uF3DYqHDLF54Q7HBULyEpUFqyhG	1654	3NLc3hXr1rHUggdRc3xqhFvLVMmf64yHaiKnb9JTXEdgopAtuiLm	1553	776	1	1	1666	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	700	1278	1278	1616169240000
1694	3NLFexS1NEznnRe9RUhhLgc8KMdCq1z7d4aC1q31QXznSTAa28ZU	1693	3NKZ9RHXZp6r91AoyZ4pUn6sEKSvx8jVd9t17abxMP5pFoDwP9jK	1451	926	3	1	1669	jxMXDHiYJt9LWxqgdguD4KfUtpLJKzLpNZqoQyY29E4z1voLxDR	911	1281	1281	1616169780000
1697	3NLmJ2cqECdgKXN7KaWsx1KLFokFB2xZWVK4ZZuFUKVupZsezzxz	1696	3NKxhnDBoeYan2U22HjrQEew7AkY7Tv9R5ETvM3z7z3xJDCo25BC	1581	778	3	1	1672	jxc5HZDgYNqv2Bqc7EGBZWxk7Kw3MtzJ5H3rXn2qSsvK4esuR6Q	914	1285	1285	1616170500000
1700	3NKxQoqWt4RdAhsHo5szASXkgXv3oUytqsG9b5yNH2xKiPfHNeFh	1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	532	1057	3	1	1675	jx1Hw8phM9KFcWSqYgYyZFfhvsMqhfGXzW8VnUFzKWFa1zyNHJx	913	1287	1287	1616170860000
1703	3NKpsLmDmLSzTu9ita2h4dWqv2E2kFt9N2Xkgv3DT39Bh5Cs9vDM	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	532	1057	3	1	1678	jwxC2PkpJ9oWyKBjXMTJJAjucH2XZXh8wpgFifdGGrJML5r1zW6	916	1287	1287	1616170860000
1706	3NLAYDn2Gdhxx4eaMp14JVAoakJfdMXoXXPHmEPiAGDrWBH9BHwV	1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1534	1317	3	1	1680	jwFnHLjdKcQur1oLLKCnrnXeLWYo7euPEGkBTUCMo1KZNFp4PNh	917	1288	1288	1616171040000
1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1706	3NLAYDn2Gdhxx4eaMp14JVAoakJfdMXoXXPHmEPiAGDrWBH9BHwV	1536	947	3	1	1683	jwTiHwL6L9jZAQCjSDxh3CW3ASLY7kb9Whpm6TJs88RUe1J8bBT	918	1291	1291	1616171580000
1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1403	824	3	1	1685	jwwg8RabQqYbffM68nfzvim41SrZa7kBrUjW5n6cLutE8EfrSGM	919	1292	1292	1616171760000
1714	3NKpt1JUDKzqh152TgFUp8J9ms8uGjbbFs2VWXsabEpKuvVGMTbc	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1631	794	3	1	1688	jwUshXXGpWYfTtULGmGreKPirLiam1RJuNNBZPVpQozZCcidHtZ	920	1293	1293	1616171940000
1631	3NKKJ4jXLLmckvtny2eKJsgY9n6ctWTR2XyPrK6HjpWXQQigdVFs	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1509	1320	2	1	1608	jx98RVf72cEcV52aMsEuqGaAZAWRyPehs9yRHwuoYw7tQHb8eQ1	879	1234	1234	1616161320000
1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1597	274	2	1	1609	jxkeTJpWRWPxLKLLQc5UNAMDFxCrr44QWskrBASoXAmhhSBd8mC	879	1234	1234	1616161320000
1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1634	3NLBp4p9a8E4KYcyUFQJekNk22nRY7DfzLJEjtB3QugUBU3LVyKZ	404	404	2	1	1612	jxAQKH3r3sCWCCjvL4dL5WLxawuvdc4hB7VZigaRjkr6iS7nyzY	881	1238	1238	1616162040000
1636	3NKFvTodvxg9x7Ak6emCrQKWo8ZNDAfBZAMPKFsJ4GX8PiywhQqN	1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1516	1294	2	1	1613	jwz31hnoRgtpXYbstcEyJiLnWzRTa439WiSGmqmXDRsHER8bSWU	882	1239	1239	1616162220000
1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1638	3NKZ5uJFCSQXMT8peg6sx93LTxHvkVArkUaZwv2mFAGvrL9X37PP	1516	1294	3	1	1616	jwcUAbFic5KD5hHc2H8Eo13vY7HGRjMrX3VjAN8NhKG4zLVY7e1	884	1241	1241	1616162580000
1640	3NK7kjDxBJWVxQ4qeJKHfpDQu8A7KYFfj9ZY8aappDSUP3Vw2GYt	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jxshSRdpabSEaCqQGN46ydBh3xy3V7KYdVTztifjraGM7diEA6j	885	1242	1242	1616162760000
1641	3NL1jDEJLgTcxTUoizQycjzdt5coLHBg2ZCsEdpGHAi5sbm3eYwQ	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jwkETv3nR5WjUFsFzaRR2NmvYpZEXW9h4rSQ8t6suVUV3UaqWhf	885	1242	1242	1616162760000
1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	80	1027	3	1	1618	jwFPwsjA5EvQAByRZy58MPCRbmR5wA4ye8aqTSVtoD71TSAPotM	885	1242	1242	1616162760000
1645	3NKd3MtxJ4mHeWi6ZCqFsj1Sxia4MXH8eQGuAtVdmKTyt2cbLz4e	1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	563	1359	3	1	1620	jxkU68nhYpGLM54ZcAaL2HqFWMXesxjEuxTZ3XnaC1LsdQb7jSr	886	1243	1243	1616162940000
1646	3NLXSG6sq1Z1Bt6ZfenqiGkSCJCLBsUr3QMbusKwckFmubVEZYYt	1600	3NLfPqD9EjdnQViZvBUzaRnjegF41XPMhm9HdLBQuDhNTiBxP8yu	1560	135	1	1	1621	jw7QxJB3CzzKjx1WsWNQFiAYG2rhiLWXPHibacpRkQxsyvQggbP	844	1244	1244	1616163120000
1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1644	3NKiFDffSZe6oMRgScfBTe2MnmyEaDyLo6w2L2qaJ2yFjNGSPHFx	1560	135	3	1	1623	jx37QNw7nMqHjSEdKnVgfYwQzdkGCgzu1RRkQq2ZXq5CsLHJZyC	887	1244	1244	1616163120000
1650	3NKfdq54xiqaSpwm4LhHricTiwnpVuKjRKKoqUoJV3wm8VzgJdoZ	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1403	824	3	1	1625	jx2TtQEJEF6BN2g9bH1tuuDEj3CKJvRvCwiVFFk22BoPmhL3Jkr	888	1245	1245	1616163300000
1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1649	3NLubeDznQi8CeMgHLTM1eJpMZB1sqA37AaohsQV9tj3CxbKeyhr	1622	1230	3	1	1626	jw7chKJrSsTEoAx5gWztwxZhrGE82ZD3uLaW6gPqtcsN6jRqinp	889	1246	1246	1616163480000
1653	3NKWVg8CThhXWuhpEY4ys8dKugujAkciBK5oDXGdLn1LH6Ekb3X6	1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1581	778	3	1	1628	jwCRKnwC3b26AsvuAfFpnE4cgok5MxbNJCWs6ZqZAVDweYSMgJF	890	1248	1248	1616163840000
1654	3NLc3hXr1rHUggdRc3xqhFvLVMmf64yHaiKnb9JTXEdgopAtuiLm	1647	3NL3m2kMfnKNNKMXTENwBxtUCjo7Rifq4RxyuoVJb4NMtGLczzJP	1553	776	1	1	1629	jxosrM5s8csrhqcAtf2ZUhhnV7SPPXKekBUSnqvWxMn5NuVTJrJ	699	1249	1249	1616164020000
1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1655	3NKwEuJcL8rBRw1f8jHy8se9aL5Cd5Bby2EcMBZ2kAXKSHuHwFXa	1406	1393	3	1	1631	jwSckxpLH2LqkSREAo7StyNSFPQ4MFiunqxuwm7JStNYKfBbvKo	892	1251	1251	1616164380000
1657	3NKackbqfxnG4KmwucvjZ6zE7nbQPVfy2AqcYvoo85dLVCeBHYdH	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1536	1067	3	1	1632	jx1LM5ssZDhXfxpZrUwFkXJtNZ1HKMwVeW5C54QPS3oxCKAKybn	893	1252	1252	1616164560000
1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1633	1390	3	1	1634	jwyWJK73MZSw3dpv6969yCTBuLUF44jvb4BKB2JCtGPynzt6yar	893	1252	1252	1616164560000
1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1445	1044	3	1	1635	jxKtrVAkRtFCZzeujmnmh1CLCkuzHDnCZb2thbHDVDL53NUqt34	894	1256	1256	1616165280000
1661	3NKnSJ9BrqgvTnBrdymQmrsUeKFTDyCxNEbQSrL6jwJyZdNzA15K	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1406	1393	3	1	1636	jwbRp17jXpSEhMc2SMdQmss5k1hiWfeGJFh8ich6FtpVd3pWuA8	894	1256	1256	1616165280000
1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1634	1085	3	1	1638	jwcfiGCWDhYMgg5uT11KeFrqmrjJsh6Txq5fdacjoukX4mg7mFH	895	1258	1258	1616165640000
1664	3NKB8HVWcp2mqc41t88gbTzzswij7PWAGxWCoFji5Zvmcv3G36QD	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	532	1177	3	1	1639	jw78VsUCppcVZfnB4JYZVHHGktfi43wCWfNA426gpu3BRHd85JR	888	1258	1258	1616165640000
1666	3NLhUr6VtH9mBKJZ7QF3RfZbU7R8nhea2iY2a4Bd933fGAhwKECh	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1631	794	3	1	1641	jwiNvu7QnQSu5Ggq5V2n9kX3QiBVTqJViLUJ8jNgY4gN4ZH9Sbe	895	1258	1258	1616165640000
1668	3NK8CnThKFWukGxq3bnH5Dnr8ZFiGMaJxNTPzFDVQaNqGAynFZLu	1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1402	868	3	1	1643	jxrw6uHpBKeKF79TtjC7qGzSEFrZjuM4yz6AVWvwSsBobMnfA47	896	1260	1260	1616166000000
1669	3NKFt8xe4KAUPbPxkATbxuw45QUkxvac31QTyxvrJtwjoRjTNaWe	1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1670	916	3	1	1644	jwvzxSNQpdZhK1AsADFQ6tmtougp4kwHFy1upWULsR7h981rR5j	896	1260	1260	1616166000000
1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1642	1367	3	1	1646	jx7UUuFqvHZs2Zbm8z5xc7seZcGG3zdwamMJ8yMNjBFnSHGjWve	898	1263	1263	1616166540000
1674	3NLAmHXmT5Go3Py47EZDEsBeazJHtaobAyFB7UxoMUWoN63LRozv	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1656	1217	3	1	1649	jxYgyjGPExeqx5HGk91vVBZtDXgacSnQcj9cqVifZvKKWRoZkDX	899	1267	1267	1616167260000
1675	3NKUJ2FmTtVyFT5PPC9dxoHu454eKb9Q4spvWpXTqHLZMo9tMhAd	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1555	1347	3	1	1650	jwhH3DrYE4pP69836rw4MAQm1TXgJCPeUjznyAP9HoYmcAwf64x	899	1267	1267	1616167260000
1677	3NLfzGXGFwA9BmCX3sy29njf3av1mjcwgSnzJGQBzZ5Estr4yLkH	1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1483	658	3	1	1652	jxaBY8K3m2Dhbmna8ow88CPctjEFEdrFZ365H4wXCXonwDJVp3s	900	1268	1268	1616167440000
1678	3NKEoyqMX1XeGSzvWNB6zqHVM54Y1nArpjAP9JjWdX5F5M9u7uk1	1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1426	1364	3	1	1653	jxJjpMZmqoAJUeS9toCg7J4KCQJ4AoxytsaZD2qdKsMiWza5ymz	901	1269	1269	1616167620000
1680	3NKyFj3XFBU3ZMfymF5UoTqNCzqsspfi1PqturoS754PrE7wGvGw	1646	3NLXSG6sq1Z1Bt6ZfenqiGkSCJCLBsUr3QMbusKwckFmubVEZYYt	1560	1291	1	1	1655	jwGiEH6rSPRLSa4gtu4n8ZrZysz6fV4XDdryroBC6bQtVLZjKZS	845	1270	1270	1616167800000
1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	1679	3NLXUEpTFsW9SeiqHcNbKGe4odp6ybGWXLVjEhmGASLZsD3M51ii	1560	1291	3	1	1656	jwuiKEZb8f6rgSfMfsStaxZAb4ZH3iH6usfdzJbwmmL1Kz1GzG1	902	1270	1270	1616167800000
1683	3NKwVLE4tZ6wfGC7GBzEbUmXLj5TNUceQkaqp5e6A9nLFez4aV2D	1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	606	1295	3	1	1658	jwTKhv1G8qkc3uqvrm6CdbjVme8gJ8RFKZd3w4bGiu4k6xAuMYQ	903	1271	1271	1616167980000
1684	3NKvg3h1wbnnVHgoVzY5QfrTcdcydu6pWPvh1LTePwRPQ69tgD3t	1683	3NKwVLE4tZ6wfGC7GBzEbUmXLj5TNUceQkaqp5e6A9nLFez4aV2D	1631	794	3	1	1659	jwSFLE4ZCF6M4wnN4K9SwkN6bARBktdrFZyWYykDvyWFmDsWD4H	904	1272	1272	1616168160000
1687	3NLvQfDFewuzJ3RFRGMo3F1Rz441pjZpFNhs3KMyxkBcTFze2ady	1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1483	108	3	1	1662	jxV6D9Q3T1vbd9dLxC1uM2v31cQSX3rHRH3Zdhj2PCmZUQTNDEQ	906	1274	1274	1616168520000
1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1689	3NL7XLJxc8kPHox4hVCGRorAamscvCFG5kk2Nre4CwrvP6FsKkqB	1503	1151	3	1	1665	jx8hus52K4psSM9urfrdzA3NtaVi8aUcEWnAod8cnWXQwrEtQqU	909	1278	1278	1616169240000
1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	1694	3NLFexS1NEznnRe9RUhhLgc8KMdCq1z7d4aC1q31QXznSTAa28ZU	1624	1334	3	1	1670	jwRZriYrhX46teF8uKgrf6PGXrN2sRDDEG1Z4j9nx61RXCoApD3	912	1282	1282	1616169960000
1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	1697	3NLmJ2cqECdgKXN7KaWsx1KLFokFB2xZWVK4ZZuFUKVupZsezzxz	1403	786	3	1	1673	jxGYLyGNYipxGcxGoFjPRdKdnMDj9Kmte2LBPbYQpSzpajTgZq7	915	1286	1286	1616170680000
1699	3NKsAEv2WFp7GqCbCFBgm3G3XPxyMjP5qwEP4AJzcbgvKA8j1CC8	1691	3NKEwsNnjAxUKQKEHBdWdE5a6uF3DYqHDLF54Q7HBULyEpUFqyhG	1553	776	1	1	1674	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	701	1287	1287	1616170860000
1702	3NLkmyDUoKHegBCuyiYDw8s3hD8Uo5zrqiYbCpmPDhtFrrDocFoJ	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	1613	1223	3	1	1677	jxJdkkBnF6yEom7W1LbwkKjwTvukxCzqNqWgRkvz8x4U67Ua9vA	916	1287	1287	1616170860000
1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	532	1057	3	1	1678	jwEkxPzH2baxjk11XvJDwdUWEmFh6fAvLZFBTus13r4ZAZa7tFG	916	1287	1287	1616170931378
1708	3NKRoHEtXT17ndoDQyFPvwfaaMiEbgqjkgAv3VkhA6Q2WX3vs52d	1608	3NKfV9ERfCSMkWntkM6QetqFsm8wKNc6m4cX6zZ7xYSSff7gv7M4	1397	838	1	1	1682	jxBscpVTqTT7nxtonqQx2VEVxKuHEQvhkfWtsnioFz17BVNokgE	784	1289	1289	1616171220000
1712	3NKDgVveLjMkCpL1hM13eaxTR5uyqhhTNKQ7VLGiLEAfvUQHVKcc	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1403	786	3	1	1686	jwbkVdgwq49Khjp7DAs5cyE73CnxKhG8tXhseHTjt4kSFYTxBFH	920	1293	1293	1616171940000
1715	3NKND5MzAbNYUVPWv8qNj3cj5M5SmfDKh3rz1Ts7i8JzTd3Ew9fT	1713	3NLeE8rXZEwyS63qyJVR8cSxG7qNkHfM43o5GPLhoP15xMFGL3nF	1593	1346	4	1	1689	jxYRRKzM9sAiVrDJWndH5fkVa8qFGDqS1wbjmvtgGzZMhngcNxa	921	1294	1294	1616172120000
1719	3NK6mdWepvUQXvrygg1RKDdoVwDFGNsTfwbTtsnUoZwGueF2c7zR	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	532	1177	4	1	1693	jwTT7wP7cyYf33w1t7R9dW9SmkPxPMmSwirwDzT4RbqN9LXUeHx	923	1296	1296	1616172480000
1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1552	513	4	1	1694	jwhxoqPrjCeEK6LMGJoMEXVchL4dsBbFWH2E3VVVgscJpEEamWk	923	1296	1296	1616172480000
1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1578	1296	4	1	1695	jwD4hYYqtjrwwjecyvFGsda6rki7EQrxpLU7RdxpqNegPFrrWd4	924	1300	1300	1616173200000
1727	3NLLkJvGJa4h6P2uSK68Cewd9MZQgc52xdFzfjXTZRFjzY5AfCyT	1726	3NKSCrrZ5gXpvmMufmV62HjnkPvEgptSC4KxR8wNvYMV3iSA8pCU	532	1057	4	1	1701	jx4c54WQoPGEtvw2ShQZMu5d1Ae8Unsp3ZQ8XcK7pSAAB8H3tXg	928	1305	1305	1616174100000
1730	3NL6pED5NJSU4tmFSNo3xWDDHUsmEEawzZCHegy8knKp5KPTitST	1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1607	1222	4	1	1704	jxEDKZUfh4BprsPsB92kEC6gwkn8z2EbEV4cqTCS6UeXCBnPdbY	930	1308	1308	1616174640000
1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1581	778	4	1	1709	jx2zWdrcfX9esov9xhoZeBWX66PmgUPJc2Pc2n7B7mppECxJTeY	931	1309	1309	1616174820000
1736	3NLUq2d3rta5HL15WpC5QxAogFp8UkFL77LUYzPJ43d7LgyAGUiq	1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1405	873	4	1	1710	jwP85kd4r33TixvqBmkVqzP1cVCnAkAnpxe3xRWpMx6gBHMycpa	932	1310	1310	1616175000000
1741	3NLZAC4f7sxJfStRKC7EMvJAA1RKL5j4LWWvktBmqJ2js3LioZBY	1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1407	1395	4	1	1714	jxGvkSx69Ltsx6RXwTpgoy31Ca1e3RvgyVoJh2MXSXX4Dbhiogq	934	1312	1312	1616175360000
1742	3NLdFaLGhmy8pJh7FCSGbXu4EwgU79DGi49Y4TxKDQ8qgev3tiMC	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1467	1376	4	1	1715	jxFUpUxZ4L59EXa9QTUen4JJBR9WAJTPyFq5ybfLwB3UJNqvdVL	935	1313	1313	1616175540000
1747	3NKhgT1doyPdTBndS2DBSurdR61rJJptFREkAbC7QPsXoNkSuPyo	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1403	824	4	1	1720	jxHScqcT4dXHzPjS7tyrPUn5ny9PFzxaTmobwqu13892h6pX3Y5	937	1316	1316	1616176080000
1749	3NKqXpefwV2uH5YoAf5keRYyAUq68N1v8Bb9WMduQK5Af5ewMaeg	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1581	778	4	1	1722	jwxmjqcXUWtec9ySsVK2fJs7RUH6oHn9cR69mSgKVDXmUtezUqJ	937	1316	1316	1616176080000
1751	3NKN1LY2DWhkhqzjHAd5iBntmxDwSL7nTXbmMXCA5NjYVReHkWAN	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1647	936	4	1	1724	jxXx6FPTggxF8aDshrfs4hn7ohdXJ3MXttrCyMQKxGzeg38aHVJ	938	1317	1317	1616176260000
1756	3NKQJj1iNcZAkfTH81NhidnrQGfs3sTGPsYvcAAwRZgAvgMEY38o	1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1627	1385	4	1	1729	jxeRTRtaxsSq2sCe6HdtZAD4s1ZVKZbM6wjRxq9QKtx8Jx8sMx7	940	1319	1319	1616176620000
1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1439	1033	4	1	1730	jwUNTbaaXxk3waZpo65TD8UDd8kkvHzNP2SLxn2ArXphXuBqNy7	941	1321	1321	1616176980000
1760	3NK4QwEELG6xnjMnK7Z38J2ANF2y9u2H4DhSDGHe5o96ZNNzNJB3	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1407	1395	4	1	1733	jxgYzbTjemGSB68pGpjDoMfcmq2zdK9S4WVTboJmBJTPJomReR3	942	1322	1322	1616177160000
1763	3NLD37sjLzUVQc4J9Yaq7ymiETyuV2phsg3ydx3PQegRzd3GwDi7	1762	3NKEJi61vk5P6M4GhgT3idLNmoEMjicbuaxBQu34wRfiHQ7WmBBH	1594	960	4	1	1736	jwpsm8erJNk1YSkWwkQU9kn9CxL1as6k5dDvjFD958Vzsrph2Fy	944	1326	1326	1616177880000
1766	3NLvQgpE44fLS3VswNSbHxgaeDP8nqzAYcjdDddGXLBSxF6diw2G	1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1596	1117	4	1	1739	jxDKRkh2fv3nzDYa2hMQXsj5i8i4GygnQoA13vSDTTrXM2CWsG8	947	1329	1329	1616178420000
1768	3NLheE3e3XN7iHq6PfSTpZAyuNdajcDJi24nr35M6MPUwLXMspS6	1699	3NKsAEv2WFp7GqCbCFBgm3G3XPxyMjP5qwEP4AJzcbgvKA8j1CC8	1553	776	1	1	1741	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	702	1329	1329	1616178420000
1769	3NL1ZxUP6RR9Dp7om7sycW2NascC1a94iYMjrMEyQPLPGdqz8RsG	1767	3NLo58HqvhGrW4jFzoL4x8pYeR9yotZFYa6cQqQ8MJZFNwUUhZe9	1516	1168	4	1	1742	jwy7DDhpH54PM6PP1VXx6Ht8dNBYb2YCMx54DdB1Tgcj9rsWEor	948	1330	1330	1616178600000
1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1771	3NLaSYedLNCMZzqtP4KGvbyhLChuxsKbZWgLqgo4j5vAzJ6yCydD	1439	1033	4	1	1745	jwRSVQVejyqAxbGrTY9Jo2NnMdvScFMmGLBPHBJKBb9nPkeq4Ed	951	1337	1337	1616179860000
1686	3NLBdGMaFeMjz5E8HmiDPRnfnPD4uN5hVnGF2f6L7ca8awX38ro9	1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1420	403	3	1	1661	jwCtHo7qTDMEkEcywhEh8U92VSQxcRDjQmufa4zjw9gHMDb2cEQ	906	1274	1274	1616168520000
1689	3NL7XLJxc8kPHox4hVCGRorAamscvCFG5kk2Nre4CwrvP6FsKkqB	1688	3NLrKUT76NLkMn7ebZpe6zBQh6y8iYaCoyfqiWMWfQMPskyCcJHj	1406	1393	3	1	1664	jwipNm1UC5cmzfvYJPVYSUZ2e8Ef7Peon8oN1fX8sbMaSuGaLf7	908	1276	1276	1616168880000
1692	3NKcCjjS3RW6kFVLk2YFxppkptUcvVJUeCLaZkF8a7aPr38ZUutt	1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1402	852	3	1	1667	jwnPdKnaT79Ebjpn6i6rZJNtNEAhAn1JnwrgfQ7vqkt7izWM2td	910	1280	1280	1616169600000
1693	3NKZ9RHXZp6r91AoyZ4pUn6sEKSvx8jVd9t17abxMP5pFoDwP9jK	1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1581	777	3	1	1668	jy2rRyLzNZoBdEyKNEvZdtKtesZqjPDWkRkutQzEMHefsYmQiMd	910	1280	1280	1616169600000
1696	3NKxhnDBoeYan2U22HjrQEew7AkY7Tv9R5ETvM3z7z3xJDCo25BC	1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	1637	816	3	1	1671	jy31iAX14MjfV1C7hBREqUuv5GMFEuorBW4HxcLraLWayGdJxLK	913	1283	1283	1616170140000
1701	3NLRwSPBGPKCqmh4RXaowozy4wbWoKNeY4CuGRARoBoe5rwnYjrc	1664	3NKB8HVWcp2mqc41t88gbTzzswij7PWAGxWCoFji5Zvmcv3G36QD	532	1057	3	1	1676	jx9Gux3JStYRqzKgJ4fR4P8eNK7RdUg3ZAn5uYL3wu5oPYTzQ8R	889	1287	1287	1616170860000
1704	3NKwGUjCEMr5GG6j9nXxMcLv8u6Fgz5ae39L1quHtFG5YthCN1iP	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	327	327	3	1	1679	jxMtAicjeKFuX43j3vErec5mQmnZAuJ1nHErKv1NhppKMUXYr4f	916	1287	1287	1616170860000
1707	3NKLWwpcBG7xMmYq7GMRXrHwcthe2cateStF34eUWURGYCyyQ4ir	1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1611	1215	3	1	1681	jxuJEqWMy6zryx9ijdWHEKw39KLrQ9RptbyYBwVJot83Rgn7WdZ	917	1288	1288	1616171040000
1710	3NKrPzGb6BG9tk6KDwveuUzHksP7MXiZyX3xnVdm5q8Jb5uausBc	1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1500	1051	3	1	1684	jxxEwLAp2MUtWZ2wh14TS2vCds4wk6DVYsvxxjr6PiKWaCJZD4q	919	1292	1292	1616171760000
1713	3NLeE8rXZEwyS63qyJVR8cSxG7qNkHfM43o5GPLhoP15xMFGL3nF	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1506	1373	3	1	1687	jwY4oQaPTQW8x9dx5XbAXn6B7LoM87za3m8i3An9aPGdMWgmhT6	920	1293	1293	1616171940000
1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1715	3NKND5MzAbNYUVPWv8qNj3cj5M5SmfDKh3rz1Ts7i8JzTd3Ew9fT	298	1182	4	1	1690	jwXZ2p3UNxzN6NP4jQQnfXtFGpSs8GtpcaiAVkTnJJSn4PZ8gJF	922	1295	1295	1616172300000
1718	3NKFwYkEWsGnh6DPYDVXPkacgMr4TKt5xsJhpYGxqUCys2e7pywn	1701	3NLRwSPBGPKCqmh4RXaowozy4wbWoKNeY4CuGRARoBoe5rwnYjrc	532	1177	3	1	1692	jwj3y3oBBDCx1yTM67rPvtnp5RZpNxiMxvaEYwafBtYjbPyfGkG	890	1296	1296	1616172480000
1724	3NKf27XeD7u1PaUEHSFM6hFkGfsfXiTSaXKX6pQYc3Put67FSwRM	1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1637	816	4	1	1698	jxWDTRX5otePfxCgKWZa2ArkTAG4CnuRscT9LmArjvkrCenATZ5	925	1302	1302	1616173560000
1725	3NLq1A7koTtryB4xncx3YWGsvfscpBcGbJ92YX42RVEhuDCweumu	1723	3NKZjs7UQaTe93LxFLxu5v1dXxSpbrf59UrfuvaNe6H9SH2vcyyf	1406	1393	4	1	1699	jxsdvSfyxQM18sb5H9BCQoVXccxifCjFNmQKDVbWwos5sRXhfs6	926	1303	1303	1616173740000
1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1401	224	4	1	1705	jw8pe5KrCbzBukLwdz58THiP3gtxhsQpYbkidPtxe6dfpkzYGq6	930	1308	1308	1616174640000
1733	3NKMjxNWbQgS2Cz1MzEbkTp6g8o1wRBGxSsSY1LyUdi4NTETEWH3	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1536	1187	4	1	1707	jxdoHxAVy6ByLvKL1sKBZLKC696dxWzzL6hrHoW8C3fegHTKxVc	931	1309	1309	1616174820000
1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1581	777	4	1	1711	jwAnHhw87qHdHLFPW3X8Yc6iLimnXHd9R3fJ1kNDtXKNqVq2SuW	932	1310	1310	1616175000000
1739	3NLUFTcT1pZQq45xzBRnV7iU31mfPeWNH9F65buBT7jEExxbCRoX	1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	80	1027	4	1	1712	jxqVVR861Mm3j47XTeNgHBTcGNsmkLZAJm8yinzu8EdU8novVTR	933	1311	1311	1616175180000
1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1656	1097	4	1	1713	jxDJyQL52ePbzXd8jsBnhEo6gBMgP9aR3roTfZ5HcpfvbjUYkj3	934	1312	1312	1616175360000
1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1406	1393	4	1	1716	jxZgsrAeAnbDLYRboaKKYWhEijjyahCjZ8zrFGhcRpfxYANdp8i	935	1313	1313	1616175540000
1745	3NL8qGk2rLqpsUZVgXxAeRZZpaaTS4CxQBWM1iLndLsKbHPK6Tnn	1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1406	1393	4	1	1718	jwPdMmZyd4J4rKxF9PSKuucX1jFFxLNUddAsSXnri17PydgYdWw	936	1314	1314	1616175720000
1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1587	1357	4	1	1719	jwFZKMsMfW7hEuW1sRgWiccEidVeYKwmbsHvcugCM9rJS9fBkXe	937	1316	1316	1616176080000
1748	3NLDvxBSV5u9hBwd7RrAVwJKHrDxXMLNx5bXePHhn5ZGbTyj14XM	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1407	1395	4	1	1721	jxEksrMjbppKWC9Wn5giqsUgRgzfe2aReKwGU1TB1RapDYVkcBx	937	1316	1316	1616176080000
1754	3NKynMakVwhTS3TpbJvi7Q5X6oeLY8ECim1QKFkxPt6kBbRBUx99	1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	1476	1245	4	1	1727	jwQdrXotqeDZJpBY5531oHUUtjWcXP34LqUzbUWiLnUPHq1P2eo	939	1318	1318	1616176440000
1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1406	1393	4	1	1728	jxMQ56hf9kqFNZcVrYfkSbxZXGcLvwTnAL7YSykVMC9SpFwVXXq	940	1319	1319	1616176620000
1761	3NLU1pUo4U7gTjX1pX9oE8sjZLs6VsybQovAXcFrd69m5hpi7zSA	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	171	1128	4	1	1734	jxkSoqGkQGqj5rfKVpiXxNnUybr8KhJjp1KbHygxTr3JPG8sRQt	942	1322	1322	1616177160000
1764	3NKJ64ZCRhxtZ1hYMGD8kJvhvqQJK9YY4JFcqG1ktNFcoZ4YcSUR	1763	3NLD37sjLzUVQc4J9Yaq7ymiETyuV2phsg3ydx3PQegRzd3GwDi7	311	1061	4	1	1737	jxagnaifE86h1rbdbqpURKQd9nkYcuhhnLk4EjUkPzxCN1C5Hk4	945	1327	1327	1616178060000
1767	3NLo58HqvhGrW4jFzoL4x8pYeR9yotZFYa6cQqQ8MJZFNwUUhZe9	1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1607	372	4	1	1740	jwqebf7Q7CkE1v8sWDtc8rfeN3ks3XEQ3XGjz9V77pXCmRNVgZ1	947	1329	1329	1616178420000
1770	3NKMzYVC5vvRWmBofe6uLqK7JtFiN5fTsRsU6PeqfSBD4BK4wF4b	1769	3NL1ZxUP6RR9Dp7om7sycW2NascC1a94iYMjrMEyQPLPGdqz8RsG	1637	816	4	1	1743	jx1QCh1KHWg5zxRoU6Q4Ti8Suokm2h5oWCQrgRf3wLTuViMiS7r	949	1333	1333	1616179140000
1773	3NKzMNnSa5MmjUjYgsPSA6F8kbew68GCZSSF2ZxiyFwNcJSma7Kg	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1642	1367	4	1	1746	jxQRTGtKLPKxxhDJCrQtdj5aUVfbzziW2spnKdjphtpvGVWtBHn	952	1338	1338	1616180040000
1775	3NKXx4q5qovKCm7Dh8ed22t1ZcNgGqLivQiujMmHpZ11BSh92AsF	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1457	1391	4	1	1748	jxdj6HKqNoEYXLByuHFnLQ9cx8KZJVFTcwAXENNyagUeSEMth3J	952	1338	1338	1616180040000
1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1631	794	4	1	1749	jxb3biXkH5yyHTPJB7RXX571m57PDGa7Mt5f7nJ42tEExKucbsE	952	1338	1338	1616180040000
1717	3NLWsrQ6vDVR8ccfvWiek6XHZYw7Nadp6p1Ja4FPeAygWFU9mbMc	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1406	1393	4	1	1691	jxWrrQLe1DW5Eaq5iWBLMYxKnKXpU4Zo5RNNJB2RB32FcuShvDB	923	1296	1296	1616172480000
1722	3NKDSP5jwmRyqHxx9QLCvuTo3bz618Rguoe4fW6KQGFpBCHwwM64	1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1407	1395	4	1	1696	jxwsGRiWfqKWz5SechizHEQyhJXfv9mXcj48FRLhtmPuZUffMV2	924	1300	1300	1616173200000
1723	3NKZjs7UQaTe93LxFLxu5v1dXxSpbrf59UrfuvaNe6H9SH2vcyyf	1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1501	1234	4	1	1697	jxce4ea4jv8CqqsRhgmjZeAU8yV85Gw57sBztBaox2ULDEN3swq	925	1302	1302	1616173560000
1726	3NKSCrrZ5gXpvmMufmV62HjnkPvEgptSC4KxR8wNvYMV3iSA8pCU	1725	3NLq1A7koTtryB4xncx3YWGsvfscpBcGbJ92YX42RVEhuDCweumu	1560	925	4	1	1700	jxhY8WEcTqXeP5othmigL8x5sc6qpc5kp7SCiApTEy7Dgr6fK8R	927	1304	1304	1616173920000
1728	3NKe7DL5ZS1rTFUjGsfcwrmMQuxQz93YAHXsqB627WBDtEJJg8we	1718	3NKFwYkEWsGnh6DPYDVXPkacgMr4TKt5xsJhpYGxqUCys2e7pywn	532	1057	3	1	1702	jxnxAwyucyff1qMuepSKBR44cLxZKuNX6D3YtUc6aUB8PwzdbRY	891	1305	1305	1616174100000
1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1727	3NLLkJvGJa4h6P2uSK68Cewd9MZQgc52xdFzfjXTZRFjzY5AfCyT	1406	1393	4	1	1703	jxQ8t35g7trTAeR4baBXHCrzJXx9mUtahe1fCH1MoqvKepLcHvs	929	1306	1306	1616174280000
1732	3NKT6nhTsrf9oAAKZiEkyfUMWBFTBbAHEVeq5jqPmATUaVLXxoph	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1406	1393	4	1	1706	jxChindkp4oDNsQw6hDxJP9ygZ4U9G6Ee4yuHwaNkLMuhfzoR6L	931	1309	1309	1616174820000
1734	3NLmprvwNHBVYagBYSaL72o3rBAr4gYDLgrpa3DexvLd2WRG59eM	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1483	399	4	1	1708	jxnc2o5MgNr2oLfqww1cXMQxgWWSAzztnGXXX6VjvAv4UQui8BK	931	1309	1309	1616174820000
1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	80	1027	4	1	1712	jxUBsyW7rjakqARht4Qm2fhhpver3Li8uWJu5ciayXzdqpE1mfq	933	1311	1311	1616175180000
1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1527	1047	4	1	1717	jxt1MtRQonRuS4zubxziFvYexY48frUj7aRdBoYKu9nz1JVM8rC	936	1314	1314	1616175720000
1750	3NL7e7mwW9oiTkETGCsLCm35s3i1Q5K6CB55ZhvCmpSZxPqpKu1Q	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1500	1171	4	1	1723	jwGXmK1xPFYnwRrEvUezvxYpnv4WsGSWCa9XqzsSPs8dwaTnZrp	938	1317	1317	1616176260000
1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	44	959	4	1	1725	jxktYvPwK5F4nXVKPePudn6SVdDFxuE3obiWXjeZpZjhhYnpJsu	938	1317	1317	1616176260000
1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	519	536	4	1	1726	jxxQtcNxRHhPLf6YhctPQcrag7inGRbbX4MmsWaDonmCHA8YMoQ	939	1318	1318	1616176440000
1758	3NLLjBgVcQ2Tb94fLyKAKJfZCRVUjPQg9SuSUjAuN6LRoCgqn24g	1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1407	1395	4	1	1731	jxF6vJ3r3AaQZ3i6aMMUK8XSwYrvpSucgtXXxyDcxqXgTFPhDih	941	1321	1321	1616176980000
1759	3NKHtmXRgeSeLC33dghZSqnjiqoJLhDatya7bgHkmbCzqYZWQQTT	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1422	1337	4	1	1732	jwjncyEDqGf5vQaUVnnpuVxkXdCizZ3KwNzBYkGtkejeHoaC9Ng	942	1322	1322	1616177160000
1762	3NKEJi61vk5P6M4GhgT3idLNmoEMjicbuaxBQu34wRfiHQ7WmBBH	1759	3NKHtmXRgeSeLC33dghZSqnjiqoJLhDatya7bgHkmbCzqYZWQQTT	1534	129	4	1	1735	jxC82DUSiAphYGBxxsnTZkDA98scNBovWyUuSSB8ZLV7c1UgeY4	943	1325	1325	1616177700000
1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1764	3NKJ64ZCRhxtZ1hYMGD8kJvhvqQJK9YY4JFcqG1ktNFcoZ4YcSUR	1534	1317	4	1	1738	jxEWg8he4MWirGf6ezgFAD2GxobtpVTk61QmWF6vrVMFctmVvQp	946	1328	1328	1616178240000
1771	3NLaSYedLNCMZzqtP4KGvbyhLChuxsKbZWgLqgo4j5vAzJ6yCydD	1770	3NKMzYVC5vvRWmBofe6uLqK7JtFiN5fTsRsU6PeqfSBD4BK4wF4b	1559	1353	4	1	1744	jwpSZHaKygcfqmrAwmPdCYgA8QB2y2M6Tj9eaMjaCjr4BR7ex15	950	1335	1335	1616179500000
1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	406	406	4	1	1750	jx9ZQWVFb3B1EqoCXQbVywUGwkJz3n3ZtLY7B9FZsxhMKZok1hY	953	1339	1339	1616180220000
1780	3NL56HbrG8mav8hxjDenxdo57n7KJDA12oxm2XqezamdG4MLGmyg	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1652	1315	4	1	1753	jwkHCaCuJ9dKsbw3fLsJoL4oyP4hpZLe5DiVuFEeJJLMprp9Bcn	953	1339	1339	1616180220000
1783	3NK73fJVCnuPnEiskJLAoft3uBDqhj1uDoLoycwtyQZqgbYc6VvT	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1581	778	4	1	1756	jw6u7YVyYGsCCU6aUHQstxUhGQudccyV3LNJBmt54BxLKqGABEM	954	1341	1341	1616180580000
1788	3NLFdZDdcbrRNYpajzQ8QmktW9YLm2nPHh8q4VcQLdDtkVutm4kq	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1541	1172	4	1	1761	jx5zMaNcLep2D9Fo1n3wVrwvDztYQFeEQLFjxCJzwK43deUrnbC	957	1348	1348	1616181840000
1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1790	3NK9Td4TpniKpsa12iV3FHAZCjRNtjb4sQ7GUAWQNapUgMXDKrTw	1406	1393	5	1	1764	jwJQtLSu4VdM8bEjS4bNuDCKA1FqsEnPxqmoRH5mTrFib7WnJyN	958	1350	1350	1616182200000
1794	3NKoxpX9xxMAVdGSefmGkQ9iRNHaoJ8ME8RwejtgzxeFCMWVxNpc	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1577	1201	5	1	1767	jwPp8Fcdz9FiiQ9B7cbK8xWU7JcpV4L1SwnDJjGNYH4ArQ72LNS	959	1351	1351	1616182380000
1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	1796	3NK7WGhjNwERCabf1ZoPKxbKzkDdHmT7bJUem9niVbVC9TDriqRs	1483	1030	5	1	1769	jxehjr4PvDEgUGwbNmbw3X7RqtXXcmUF759p9d2XcVqDz2PxAM3	961	1354	1354	1616182920000
1799	3NK7GzU9D7qrtmJhcCBhvrWjVZb5VyNoda7ByBog2YKj3HUVq5DB	1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	58	1035	5	1	1771	jx8XjLWUCoJ7SVBjcFE8iggPbPHwFbsosPZ65Fssz8pgRT6tD6Y	962	1356	1356	1616183280000
1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1798	3NLmKYZDeCrypocic9jWhSSFE31gK1WLCQ9vNcq67NZcgsGntsRw	1546	1213	5	1	1772	jx9HZmVpUy8CxrkmPRGLzr1JPGt4H1g6XVAdbbawWA18jkVk7eZ	963	1357	1357	1616183460000
1805	3NLjqreC4U7pjSLvW5xa81L9rEQ3cFsUbEimKb3itULH8q92oGsu	1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1631	794	5	1	1777	jwSi9RAiDXHArDtnJ33pHi2hnNmALiCyyggTD1BU3QkPKvcBjeC	965	1360	1360	1616184000000
1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1406	1393	5	1	1780	jxCfR1UYo34k7MqmAMqnMiEQ6XbdAXUCoGwZv9q4m81S41vakoA	967	1362	1362	1616184360000
1809	3NKBMCMavMse8ZPZ4XrWYfevcHZakkAqr6yjFNsv3k3tRjVdQkCW	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1507	1154	5	1	1781	jwWHVVwmPu7Waeavanbof5BWCACnxxNH6qoFkLfz7kZHoD8WvBn	968	1363	1363	1616184540000
1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1811	3NLjREgumxnGVnJZpjiw4o62JEtTaCAArFEoMM9pEhFwQDpebh4V	1672	1285	5	1	1784	jwQEBv2J6Y8FfzdHLnH2tWYRoC6vkJj572o5xXUVWDXKTSXhL5H	969	1365	1365	1616184900000
1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1534	1317	5	1	1786	jxCVdxVbBQFLm7yNkKg3W23ZHzP1HAprJPseBfefng63wGP4Gx1	970	1366	1366	1616185080000
1774	3NLteSiSmM4vcsEY8CWGcjMgT746ctvGs6CgpxUHgxZNZ743QHxi	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1593	1346	4	1	1747	jwf27C51pSL9GFcddaaT8G5aoBSjg6Xc3xCp5Q7LWCHi3U5AqHM	952	1338	1338	1616180040000
1779	3NLpGLLtasuWohtrnjwp5qRNnpHcrL7pmowmcC8CiJnbo8yBQgHn	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	42	995	4	1	1752	jxk2uiymPAhCtdmAnPQimEgmQxFHjT5z9K72GwMdbQhq3Q3nT5S	953	1339	1339	1616180220000
1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1426	1118	4	1	1754	jwC4D8mUkh2uL8VoE36GeTVVD5yAA2fhDWd7eto8hsbR5Rb747B	954	1341	1341	1616180580000
1784	3NLnqexVrPX4ZThfANPxXHoa8kGdix86BCtw7p5UNqfEHAk7zk1p	1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	369	1066	4	1	1757	jwg4JXaekLGf5bGHU6ASpwtSg1Mr6nrLMrYkKMCXZYR5NWAf59w	955	1342	1342	1616180760000
1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1637	816	4	1	1760	jx74wWJcf1hipfTgunrmevzona8ohQtsMdW3JoVFg6GYF7vLgR7	956	1347	1347	1616181660000
1789	3NLVMdfFgJpkYFRtgZQQ91oM899wpHusknZZnWV5vtQdN4WFtnTn	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1648	1284	4	1	1762	jxiP1bgfhrtSLA5XUmzpc2vpqMZkVrX7rNmGLvrjHLduDKshTYe	957	1348	1348	1616181840000
1790	3NK9Td4TpniKpsa12iV3FHAZCjRNtjb4sQ7GUAWQNapUgMXDKrTw	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1637	816	4	1	1763	jxefCkmovMtChET4Y4xSJMLLb32rTXSpzQip7frJTcgqJxVwNxR	957	1348	1348	1616181840000
1793	3NKGZpVdfHM2LXBzzPT5hf9hfq9QDWFuci4R8Kwf16mMvFPQArat	1700	3NKxQoqWt4RdAhsHo5szASXkgXv3oUytqsG9b5yNH2xKiPfHNeFh	1577	1201	3	1	1766	jwrzNxXmnqUarbFBdYEp1jqo8FxCkf8KYzZfJUA3MJnn6FvhDcJ	914	1351	1351	1616182380000
1796	3NK7WGhjNwERCabf1ZoPKxbKzkDdHmT7bJUem9niVbVC9TDriqRs	1794	3NKoxpX9xxMAVdGSefmGkQ9iRNHaoJ8ME8RwejtgzxeFCMWVxNpc	1460	273	5	1	1768	jxufoVq5DqgnHmCCBJ1o2XoCs84wojVkR2mYbXARSpDTERo1bG9	960	1353	1353	1616182740000
1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1529	1316	5	1	1774	jwAo3VwvjLRNfF6BNwgteXgUKcLP7GKwQFqe3hgyKf112bRbEwX	964	1358	1358	1616183640000
1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1805	3NLjqreC4U7pjSLvW5xa81L9rEQ3cFsUbEimKb3itULH8q92oGsu	1631	794	5	1	1778	jxptx64tadVswKKXS3Fm416viWBb9jBTCiBbasDbrYAeS4BdcAF	966	1361	1361	1616184180000
1810	3NLxQ5uX9toDRrncLnDoMtqFhpFkzhL5Vfbi4LqFKjm4CyVwBbzV	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1529	1316	5	1	1782	jwL82EZZ2YLuAbo6rpjjj31bntjiUUwGxtScsuxPeaUyjdsprwt	968	1363	1363	1616184540000
1811	3NLjREgumxnGVnJZpjiw4o62JEtTaCAArFEoMM9pEhFwQDpebh4V	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1419	814	5	1	1783	jw73dC4E5kwbAC9YRGD2Tid7txyX2FoxKsVyVQAXnPkxEWuXJCk	968	1363	1363	1616184540000
1815	3NLi4W7M6Q9pEnXzD5a1948jHRXudVXgc6zar27V6Fr3P2KWxDs4	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1613	1349	5	1	1787	jw87jksDXTQnoK4pJRX9BMKmBwbAzDfaneAnjNFF5ZSv1KFjypH	971	1368	1368	1616185440000
1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	1516	1048	5	1	1790	jxocmhAJQgronmRLkg97m8d1CkNmfZjywCabNqe4fCnw7fzTMnj	974	1373	1373	1616186340000
1821	3NLCZMR3u676Kzmxrb6j1ty3jA77HSYoooWhfwYpLtm5WFVYiG1h	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	618	618	5	1	1792	jwo3uExSbSwiWztc8noxYSurU4H9TNjpV2erSWF26fWyPiKYD4R	975	1374	1374	1616186520000
1823	3NLdXPYoFy5zdxc8PTnpHyXgpnjCRc8XZhq6DByQMaPrn7Qw44TY	1793	3NKGZpVdfHM2LXBzzPT5hf9hfq9QDWFuci4R8Kwf16mMvFPQArat	1577	1327	3	1	1794	jxsvXdMkD1Cf19hurUypxc9VJbdH8gFEiCKgdUeMUWg1WLpdKin	915	1374	1374	1616186520000
1825	3NKBMhk5Rm1zksZqsrVygCKPa6QVVUBSrbbaVNkxK9MgVyXFrMRZ	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1577	1327	5	1	1793	jwYsZRQrA1wngWA5rRJ6sGqJ2jDUWFXxE2PUCAWHBP6EhvgiTTu	975	1374	1374	1616186520000
1828	3NLSyCvhY9tyJcfRwidSHAGVb82VLJTE3yQK5t47xMyxYYdw7AUV	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1560	925	5	1	1798	jwErR8ScDyn6j3k3B6EedevH329JMLi46q6qy6aptTC1PyNmBZr	978	1377	1377	1616187060000
1830	3NK2vPjSevE3wZrnAyrBckGuSZfRHVmVsarDokFoB8qKhkqykhwz	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1476	1125	5	1	1800	jxfAAdTsmayhV3hQyPELf53cX6uYUvbr6xupxnUyWWvWpbS1WLs	978	1377	1377	1616187060000
1831	3NLf1HSUdxKSeoy3J4CPHvj2WoMZMbwTsFz7EzWAF8GGAxS9fkAn	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1516	1294	5	1	1801	jxS6RsMAuPB6JNC7yvs82iPtNNC2p4izSd3vwqLvSuQKAjJocdP	979	1378	1378	1616187240000
1833	3NLVaLFHCwysohywBpJ7uoytE8vTUqj3yrNy8z838BJ7KwGdU4mj	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1613	1223	5	1	1803	jxgMJgbDKs5JvmgarqbAtJ91YL53PRnwERWZZvUuFysbwfqZngx	979	1378	1378	1616187240000
1837	3NLMKKRXGXUCKmkMCti5aNJ9Vw25Yjy2j68Ss1Zuw5UjZ7Ke6Khb	1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	733	507	5	1	1806	jwoztV6MfQHYEWmpM2BjJJsBzA3EHNrAD1hzoeFN9L9Jz6Lmn1R	981	1380	1380	1616187600000
1778	3NKufymvTAPjLU8wpuKbmzufPzWMtQUJSh6zfqgNR7kDwxmBHZL2	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1406	1393	4	1	1751	jwbj2aa42JByyYGefZNxiUxSQWbTZaNgeYkr4MadYP2DK3Wr6ma	953	1339	1339	1616180220000
1782	3NLBV7ZBQpRTD1vAj1pmzRKTB9ghjmgWGdZhagFdrjKcsiNuj1QW	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1403	824	4	1	1755	jxNenaVQy4pR53jVyUACTHEZsiJQ5aqeqqEoT1YFLfgApLyvpCp	954	1341	1341	1616180580000
1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	1607	1222	4	1	1758	jwozN6xdgw1RsqxAFUAPp7R7MFx3Kx3CwkbKKYmGtdnbpezeWCH	955	1342	1342	1616180760000
1786	3NL1HgZYmBqhsMBDgEkVc2TcjrdY5otdz6PEpLDdDuAqZnUNPwmV	1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1553	775	4	1	1759	jxanUP1nqNoL851uxTJmNHRh4342knezUeiTVSzhQhRHZHdStjj	956	1347	1347	1616181660000
1792	3NLBDFt5QUCj8rErsN7ARkESTkdG8Q7xcGQsoD7hfuqBPsyGvZTv	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1500	1051	5	1	1765	jxgKWisajzoKkujxrWrFao1fwMzQ8Q4H16iUpsPbf7MRjGXb9aQ	959	1351	1351	1616182380000
1795	3NKBZ3pcwok49VAsarxtzAq7eY5tGUHtdDTaUkYzsE6HuDxq7ufh	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1577	1201	5	1	1767	jwdNn8gY2qqo6P4hmC39NCHzBuouZ6c7caDoTEdhum5TtTH5V9X	959	1351	1351	1616182380000
1798	3NLmKYZDeCrypocic9jWhSSFE31gK1WLCQ9vNcq67NZcgsGntsRw	1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	1407	1395	5	1	1770	jwmZXhGPBbD5tdVoTQJCxxsT9fbrSLJiQvdn4GUqMmfS664tyHE	962	1356	1356	1616183280000
1801	3NL14TS9DXy37XjmGCNPjrawaiZyA19TKCQTDJmyeDdN5ygAx7M7	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1589	1286	5	1	1773	jwaadoskwQREezWZ9F8QjqU6URAoE2J5Ay2tzewCFDMueZnHUU9	964	1358	1358	1616183640000
1803	3NKqkc7DHYhJssvxwTP71cCSDabCjJkjhmp7aZt8JogaM9dPGzMN	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1490	908	5	1	1775	jxuQdcpZznTh1fxzzQp1sPb8vryXwcTsF4Nh6q8FTozUhW8bPgK	964	1358	1358	1616183640000
1804	3NKGoyqprs6R2fvCMZRk8Q9R77UKQfhkiins6PyJPzc8ksXMW3EF	1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1406	1393	5	1	1776	jwbX63oausyeQ6oYue5Kn5FsKPRqAWy4sohhxVNNQ7SpSv2v39f	965	1360	1360	1616184000000
1807	3NLyJq2j2QCAjjSkFBWufLK3tYCLDNdy5FrmJoXuH8veitUDFgjB	1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1402	874	5	1	1779	jxBLvzPYezi6QzCoh3qRytX6VyhXAyE8hvFBy1LNa5GFyLuU63Q	967	1362	1362	1616184360000
1813	3NKL2MND72BQwpT6iS7WGL1YGjUYiYSvXS8xyZ6xKY8r1HjtbkgB	1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1527	1293	5	1	1785	jxARZQfXtUur38EimVk6o1LUHmM9q4wLmxq1ke1RyHRheCMmsbL	970	1366	1366	1616185080000
1816	3NKZSvbsKBMpFWR8LZZKLhpui2mBhdngxhXdc1Qxi57MQHkGhgq9	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1613	1349	5	1	1787	jwa9pEPiKDu3C48SGYf1nBAu46VJRChAf3zCfzDGWFY5JPTiQ3E	971	1368	1368	1616185440000
1820	3NKdGUrK7KzJFhHMpYn495Qqay8zTVm7otv9wT8ExDd225KrjoXt	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1507	1280	5	1	1791	jwqJeywW42siZgjaCmQoaweKZQM8nHCFiUt62spm9y8hgCGprax	975	1374	1374	1616186520000
1826	3NLqHBqnfxKJh4hTBrYPqS9JKczDNiu8tshA6fVT7xgc7424VyJK	1820	3NKdGUrK7KzJFhHMpYn495Qqay8zTVm7otv9wT8ExDd225KrjoXt	1458	1197	5	1	1796	jxf2UXE4bcJ4pjp9dAdeday3yBeSGLxh5LMaek3uASHJtRWGWTT	976	1375	1375	1616186700000
1834	3NLGRqSebybEsTmSgnky8HaCJviW9gS2dXVegYJnXqEZxHU1ZVxy	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1613	1223	5	1	1803	jxeJA8bachnH1LQWccRB16v6rBnM2XW42CTMpLdZ5GBc8SZCzys	979	1378	1378	1616187240000
1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	1834	3NLGRqSebybEsTmSgnky8HaCJviW9gS2dXVegYJnXqEZxHU1ZVxy	1406	1393	5	1	1804	jxTMu8RY8VHfHH91SXmCqavki69Xhriy5ujdkUQhwKhE4aEgkqh	980	1379	1379	1616187420000
1817	3NLsohHWvP5YoUEVbyWASEiQNwj8TFyKjEeow63czxxen419eCwo	1816	3NKZSvbsKBMpFWR8LZZKLhpui2mBhdngxhXdc1Qxi57MQHkGhgq9	1405	873	5	1	1788	jwkmvJ8ismSZB78qpk7CRNvJvMraefvjyVw8gdfNyT2XYuGQRHp	972	1370	1370	1616185800000
1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	1817	3NLsohHWvP5YoUEVbyWASEiQNwj8TFyKjEeow63czxxen419eCwo	1460	1078	5	1	1789	jxaHbGBH6LhjJP85kpVbVvYaEKQmF1hjHwqQigE5Smb1aaLE4Rm	973	1371	1371	1616185980000
1822	3NLuBNFq8m3gYjit5zDpphvc73gRnqcKAaqN1Wh2YzMWZznqFDz7	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1577	1327	5	1	1793	jxtsAwPYyui7awesV8wBK46mAPoGVZZ6YSEcBZ2FkxMmyu96xBo	975	1374	1374	1616186520000
1824	3NKPVYS9AzeRL9camryEQF36tNbyRpXCeKkP1VvQa9XNbSoA9J5a	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1581	778	5	1	1795	jwveo922FNwMwjjTDvKZMZbcGHHFRLYXFJuJZamwRHiFqCH9Nz9	975	1374	1374	1616186520000
1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1826	3NLqHBqnfxKJh4hTBrYPqS9JKczDNiu8tshA6fVT7xgc7424VyJK	1402	852	5	1	1797	jweLtQ8ApyTWUcpKB58M8Zbo3CkHBH72DMFNRujNZGTDSXgF629	977	1376	1376	1616186880000
1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1426	1238	5	1	1799	jxbYuEr7pJ4oFmcorMdcqf8XMmBEAaLedwX4rFTE6vtS7aXxkJ3	978	1377	1377	1616187060000
1832	3NLcda83gzYnZPS82DAK1QUNzhB4QLxU4zA7NEWLX8wEWpzM4A5g	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1407	1395	5	1	1802	jxnMgdVk2rxUCQHjeaPh6PtAfWqjHMT7LqHxAtHVyvzLUyNm5gz	979	1378	1378	1616187240000
1836	3NKUHp1CAg5qGAHEUDpsHg57KZskhUnf5aPhfuZXpjKb4B3fkW4d	1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	1654	1340	5	1	1805	jxharMoPQkEThzNSJxMgqLAM3JEttj2EuDCc3v6uaxdAmuJKCyE	981	1380	1380	1616187600000
1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1836	3NKUHp1CAg5qGAHEUDpsHg57KZskhUnf5aPhfuZXpjKb4B3fkW4d	1587	1357	5	1	1807	jx4jYjBzwrkahtecNjX4f7DcvsQz1T9jLAqG3FnPkpwcPXehfyU	982	1381	1381	1616187780000
1839	3NLAFhJb8EDRt9YPRuHEQLHzDHtEyqnSRqKzQdKzsNDQ3vdWYFyd	1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1650	1375	5	1	1808	jwedrPLdyLEqHi6dLZviXw4CTJQE6EogABrtfP4NDYbU9s8MQbm	983	1382	1382	1616187960000
1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1559	987	5	1	1809	jxjhZMDDJF6CSbJJWFx5bCDFhyMe7CrCeJRLkRuUjB1rgVBCCHv	983	1382	1382	1616187960000
1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1670	1282	5	1	1810	jwL5yo9QQjA8zVpsCps7R2cVBRycnzFukdGkDfoJMemvg8WrBut	984	1383	1383	1616188140000
1842	3NLEE3VyKGnDNrdiUPHefkAJmLY3TTo4XwuzWMntJBHsCg55dQAq	1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1671	999	5	1	1811	jwJLW8RaVTteQY3WUK5Ly153GTD99DtM6tdc7JzBsjYKeWzmyZ3	984	1383	1383	1616188140000
1843	3NKn6CbmMXLadHZCpSj38mREVu6Vixc266jmueR64BkajUBbNwFD	1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	43	1184	5	1	1812	jwBYq7iBczjtRZecSzv2guu4N7xE4A8u8qGuk7AAcx6dwH2AFmi	985	1384	1384	1616188320000
1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	1403	782	5	1	1813	jwSmxGDGTDafsFDBz6EToaYHMfoE9hAdx3XPqj3e94jUQNSVNrn	985	1384	1384	1616188320000
1845	3NKdFFW2owX2tRJuJ4r22k3t1fbroCdNShWCua37kCa4sv26WRNv	1839	3NLAFhJb8EDRt9YPRuHEQLHzDHtEyqnSRqKzQdKzsNDQ3vdWYFyd	43	1184	5	1	1814	jxVYuGGdwVAhRdvuxr6cz8D1T1w2pjt5DBvhdwqRhEz5B3rNtGs	984	1384	1384	1616188320000
1846	3NLZSS8AmEVEHo36sC2b7S4HiFKoNeqnLGM5s4u8mwNiaysazUue	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1654	1214	5	1	1815	jxdpY8JvaZnigUpSauttYpXc2G8AVTEYBM4Rfk9gUTkysiz6m1v	986	1385	1385	1616188500000
1847	3NKtLWbDSppjH9Y4pUu4BcJjSwNbkGLdqA9MBBJNajCDJfxN7d2Y	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1489	1254	5	1	1816	jxp3paPsSJRCougnedE3um8Z2GEj64FtE54k4Hux39BmCMxn4m6	986	1385	1385	1616188500000
1848	3NLrdvW6Fc2VRHcHtpzMdhCvezptuHmeA5a95auf7ry599pFp1Ss	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	641	1210	5	1	1817	jwvaVPrVhvgkXKQpxMLnh81PRFyfb62xF3aRvr9EnuotqtVAdyQ	986	1385	1385	1616188500000
1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1631	794	5	1	1818	jwdagHYrGKMgszyGiWokMU1WwuZrvuU1ZM3Xao1xJMLGhS7bRGU	986	1385	1385	1616188500000
1850	3NK9SFAM8PMFKb6FP6qQ87voLDqjL3tBm7niJ6TBs5fsDpSa53wx	1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1553	776	5	1	1819	jwdSJhHoet8D1zKhmm6oUyY2NsH749bpVYCHHwixTobqxSyv1JE	987	1386	1386	1616188680000
1851	3NKh1XhVDQmJp7a53JTgA2mJvVSiKrhxpB117WWu5CCXR2S8ErNm	1848	3NLrdvW6Fc2VRHcHtpzMdhCvezptuHmeA5a95auf7ry599pFp1Ss	1407	1395	5	1	1820	jwekmjpeQEgwxMfuNpF38ZDj5yvnJpEopp6qGZSpfwWwMufbqcx	987	1386	1386	1616188680000
1852	3NLAwE55G1d6oEgAvoZzJSJHMPiakVzcL1PaYw95CogkNmGuBYYq	1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1633	1264	5	1	1821	jwX5LkFsNDm9Cc9B3W42co3zENUcpJ5unXe4uBuDgxsGSxn9GTn	987	1386	1386	1616188680000
1853	3NK9BEvRC3aWZyDWQccgdXCPv9WWtqAJrwCoGnY7veNHTAgWZpHK	1852	3NLAwE55G1d6oEgAvoZzJSJHMPiakVzcL1PaYw95CogkNmGuBYYq	1489	1380	5	1	1822	jwze4RKqt93quMV4jPbao3xrbibeKErVuV5uAV2AficjVuvFU2T	988	1387	1387	1616188860000
1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1851	3NKh1XhVDQmJp7a53JTgA2mJvVSiKrhxpB117WWu5CCXR2S8ErNm	1489	1380	5	1	1823	jwyF8RYTzWCT4mPw7qxUWNNQH6zr2uxiM1ULbBaPtGDeuUsB5NC	988	1387	1387	1616188860000
1855	3NKjzBg2PBjdZr7YRHx28QxKdxMwqS92J6ZPNiZL52HcHgtdNVJQ	1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1593	1220	5	1	1824	jxuY8DafoJKVfHBTmYCahn6g3FitezSVGnBCizZsNJjyawDAxAh	989	1388	1388	1616189040000
1856	3NLcuYbaARwRUvQE6DUgwchUjGbWz9doegL24mX4W1rijXSNxED9	1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1529	1316	5	1	1825	jwn8KnaSzLEBfc9cKMq4z5vG11L2VnXA8hHkAQPahGYmqbj4xf5	989	1388	1388	1616189040000
1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1856	3NLcuYbaARwRUvQE6DUgwchUjGbWz9doegL24mX4W1rijXSNxED9	1507	1154	5	1	1826	jxe5REnSb6RmAGVV5VyrkfSXGDaYmEMgvy9ynzGqU1strMki97Z	990	1389	1389	1616189220000
1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1405	865	5	1	1827	jxcRULHStWe5s4a9mzPMxgzJx3eTtgS8Be6gAhzGnwqKmwTgdUe	991	1391	1391	1616189580000
1859	3NLNhx7fhY2iRGkYVSnLvDhPPfaMuVgvz8fB9ZFoL2FGxGMdgWpi	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1646	1354	5	1	1828	jwtfcjmx8CQsiiC3XwSBKkcqXDfQb8FAG8pDZw8t3Dopr2w1MSa	991	1391	1391	1616189580000
1860	3NL2DtkdVrJv5Hb1b6tffCGet7Zt6j4Sr7JXaipJujDPBtotRmLo	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1623	830	5	1	1829	jxjnb1whX5qYxKegDnKDoEPjibbxiFpBm4mCdvYzumdprF9icNj	991	1391	1391	1616189580000
1861	3NKWkEYZp2eT1ry8EPT2JuPTWJR4B4fY2ZTSQwTwsRo93kB1aTP1	1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	1599	921	5	1	1830	jxbvevPDxsc2pQ1MF7EXknHG3xWkpBBHPit6XxMDf1LqLZVabMR	992	1392	1392	1616189760000
1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	676	676	5	1	1831	jxJUgoVtE77Zu2i6i9xnTpr6mg5YLa5cwCfsLrnjRbPBeWo5Mqx	992	1392	1392	1616189760000
1865	3NKPd8tpXURES9jEKH6NE7vJYCeeFy4YVEiJjfYV6A1qiKhva1mj	1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1634	1331	5	1	1834	jwWEipw2djcoZSVC2k7H4ByXR4Hx1ibCCgrUqynLPfwuBN3kKS2	994	1394	1394	1616190120000
1868	3NKKGVvksGswb68TsYad7c2oJXkij4HrXq2UEX8NQRu7f2WMpQq2	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1622	1356	4	1	1837	jxTApUXxtwTz5v8SUHPjKdYLCy6FPbDG9aY7WDm5CoLqfW3AF46	935	1396	1396	1616190480000
1872	3NKyqirn322qtk9LKK1q9gpV6YgQi39ryeaWwrqjfXbkGzYxVVsi	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	152	1330	5	1	1841	jxDB9nhCJvVXzqk6cXtkpAwZ4C3ygG5z4HJg7AUKeqypUNhDwGU	997	1398	1398	1616190840000
1875	3NLqNKfuFL72ugkwueZQKKHoac73bxptPpmWwysbY8eBJW1djWhx	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1571	1335	6	1	1843	jxBUUnPhuUqfV1KxR2nqs6A8a7dh7Prnydxh697C4wjjzHrfuWE	998	1399	1399	1616191020000
1878	3NLxAvCJ387hQjioMjyhdnyKTW4scnsv34xgoYDy25RQwwPJJeZU	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	171	1374	6	1	1846	jxReJTGHr2Gx4c15X9TKkmWb3DxBondFuM37P6Gb7LGD8WuEo9J	998	1399	1399	1616191020000
1887	3NL9ePJn4P9k6wtaLgGHWwDcYihvgysP7mFjyEC6cpBzhQokyUop	1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1609	1333	6	1	1855	jxSYU33hcz4XYPSge6pbDYVqXssTd7EGY4Cj1JxGWk3Dy8uK6h3	1004	1407	1407	1616192460000
1890	3NKwSZbvmtGeXcsLrXuSDoPeEmXXX9mb1jaiy2unF6t1wdBRbyG8	1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1573	1318	6	1	1858	jwKpsWbB6XZho94Z5Ym2TnsxnaQPxq3SmN4ckmoMgwd2SeDYUX3	1005	1408	1408	1616192640000
1894	3NLC4RGk4UfUGXpmC8WXj8C2CqkWg2vUCssp2BfoU7EMNPgqehHw	1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1633	1264	6	1	1862	jxSYnfGqy7MnZmwUHA8BWXNttdgLP72RkwKPvhQ6CArmLJuri8u	1008	1411	1411	1616193180000
1897	3NKncNTfWVeG4tEANsc8fDUDJKCbaezmsQkwoDtP6ZiexpEK8zFX	1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	448	1305	6	1	1865	jxR1b51Qu5fWoTribMt4RnHTUQXKSqfxjEFoRCzwWMwgiaqGhGg	1011	1416	1416	1616194080000
1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1527	1047	6	1	1868	jx4ygoSwuqkhWN2zLV2WTxEwyp9uK49P7kQ93oa84PUG5oYNAL5	1013	1420	1420	1616194800000
1903	3NKZJFiCPQw9Pe8pco4yTCoh4chQmqSFjvd8oyTCfdEE5u7QPpr4	1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1429	510	6	1	1871	jxC9xY39hWj8dDFSkCoLTrN16d8xXAFu5mMiVQRF8AL9eTMdFHD	1014	1421	1421	1616194980000
1909	3NLB9pxcsdUgwgqCvejjbUgYe8cCmtRk4wvFjaFPbZerRDxYgz7M	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1541	1172	6	1	1876	jx87shMfmN3gA7onH5hSCsawo27JWNCd15irpKRDELEzErUaBTe	1016	1423	1423	1616195340000
1910	3NKkzLupsTGgfjuzuaUcFDcpTTBX1LnviJkyBzntFA78HxM3aqDJ	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1581	777	6	1	1877	jxg8N5GpfBMKvBT7kxJXwEGMi1fdcizTEg139SNhJZZRC9jCPLu	1016	1423	1423	1616195340000
1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1912	3NKdwdxqXQ27SvxsJya2TTXgD8uxFzTBgURD1iFqfFHuDwU84bmH	1477	1350	6	1	1880	jx1KqDjjn8fHKzmzFvxwsoaWaqrVb9pmjcoRLkVEPxztTi8udoq	1019	1427	1427	1616196060000
1916	3NKJiyqiJx7hNHe5vZzNiMFpSorVbiAPC6Ebpt813cSMzuw7tmZP	1915	3NLZQb8QbkJEKsE7ap9yp3aiYqyqzqZvyhBZMtU3FZ1g1tao8J6q	1657	1344	6	1	1883	jwsTFZNnWkKdaaj5W7c65GwYLA7sDtgP8EZ2CQvZwNRpePtArpP	1021	1429	1429	1616196420000
1922	3NLDuymY4o1x2B5gM9kHQZHr9kBddK5oTnmo8XcKgz26cRmxe9Ck	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1609	1207	6	1	1889	jwHEkfFj1QeEaG7QKu19Xe49nUNQKbG2tUmVYt8nBntGWdKZxAT	1024	1432	1432	1616196960000
1924	3NLAkojo4cHEKkBaM2Maiyjb6A2YaQ9CPBwQvESgN1jKfQQmVP5i	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1637	816	6	1	1891	jxyWoSRgvP6Ukm2W13Q12YNf2jvWt2tqqWTo4NSsegfUAuKWscH	1024	1432	1432	1616196960000
1925	3NKoGi3V2VY9gXfb8zNPouyTw56c8rPhQkJhYeNHSDqZeC9cW5vf	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1631	794	6	1	1892	jxgkzv1JM1KczRBNJZTfvpJGUDu8Npk77cc2paocFJiYS7cNFWC	1024	1432	1432	1616196960000
1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	684	986	6	1	1894	jxptwxqWudWteEutSsb2qyfrTdh2376wmhPA9ce3LzS3TFqfPkD	1025	1435	1435	1616197500000
1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1930	3NKfM79W2BYYbuxpXP6ESqTZ4r6NByFZrC9VZkG1vywXc48LCT3H	606	1295	6	1	1898	jx3oJDKv7jDX7R7PhdpaK2ubSP3z6F7f9gtLa1iT8qMnJfsMiKR	1027	1438	1438	1616198040000
1933	3NL3mrzFQ8joPYGfQQ7xkodipB3CRqEQVvsiUqu4eqDFj1Jd97XM	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1407	1395	6	1	1900	jx14TADyvHciWVPGWv3SXRGZxiWhnaQ4rqcRdAnwNVwaFSehw7Y	1028	1439	1439	1616198220000
1935	3NKZVBAcVH93NZyGMx2Y3DoF8YdAVkuF436s5zGn7Hn1Sv2fMAWi	1929	3NLw1DyfKf1VKrs3Q3ufX6VnTkPYs2DYY8J322ZJ3YwU8QxTXFVC	1489	1134	6	1	1902	jwqQuR5ZD75puUpX1Ur9FZu6LqY7rdieGp9H1spcE1rdUWAEJuB	1027	1439	1439	1616198220000
1941	3NLvKZFjkvFKF9z3GLvJEv6Yr34L83tmr6uYEFr6GzHoU8Vqx5bH	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1553	776	6	1	1908	jy1jm54WCHtoCx3JRCuhWDyRQfgDeEMMAFQMQ3aZhTbtexrxvzv	1030	1441	1441	1616198580000
1945	3NL7NEnqVNHRPFGP1zmgqX4mWoYUNMg2RRJpzByp1dKdwd4CPAkj	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1406	1393	6	1	1912	jxWdmuea2PiNkkinG9zKCw21t1LeUBqmWxMZmAoe2RMVRY5MhBh	1032	1444	1444	1616199120000
1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1460	1324	6	1	1916	jwso14Naq3NgXMmyyjvWvgFkYsBXVxpcFB6YDM4GTw4WX61b3yY	1034	1447	1447	1616199660000
1952	3NK82riDuEbrKtrHmzgzr4g4oYrEcSGV4SJgLMAGJwu2bXGxjYKj	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1631	794	6	1	1919	jxL9vmaAqupLkF8vKgwJAJ4HCC94rmG8FX6P8Kd7wLfAaSugq7u	1034	1447	1447	1616199660000
1955	3NLtQrtUmy1X49ZkkWC3FCrhxjzjqP3fNQZwPbtcjHGPaf45LViR	1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1534	1317	7	1	1921	jxGmNycKcQMVtMPcguBispGZB2gDFipUnk7Q3yLk6M57egozhuX	1036	1450	1450	1616200200000
1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1652	1069	7	1	1927	jy2CpmR161ubkfazxQrEjNsWUjxWzeyzr9Q6AuRBBU5h4aNnehJ	1038	1453	1453	1616200740000
1963	3NKdUQbg6Hjp6yyFojuqzXF2p3LEiUNKpPyFi2v7s5MqC8kqdTdE	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1650	1249	7	1	1929	jwU9uJocS9CwCE2pMdkn2yK6b3rctoQ6adUHYeiGFSEphRoSU4R	1039	1454	1454	1616200920000
1964	3NKbU6kYjmBzP3h3Kz74Hw9jUZMNJx6xm7QG3bthAxLAxTKRwn8m	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1652	1189	7	1	1930	jxwDVLtikG8KHBrRNmoFinwhCxVgJiSEoQADAfgW1yLwW6wkxiq	1039	1454	1454	1616200920000
1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1542	1058	7	1	1933	jwXafa2XQBoVEdd9ki2jWCmDz1RWvjbHKxMZivKbyeshsJTBa7G	1041	1462	1462	1616202360000
1863	3NKMg96PV3RVhgxWgdqoN9qMznzqrKzSQ4GNLuqHsL3XbYxhxVov	1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1406	1393	5	1	1832	jwnQjR8H9vQPrekyztttUNwtE6KLiz66fCLb5uApF3STes5ix9F	993	1393	1393	1616189940000
1866	3NKKZsWivW4z1uNHsPjAF1NhuU4RMJZaY5uph1BKmghjZNDhBecc	1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1407	1395	5	1	1835	jxx8Y1bZiCYSrNh1xAenJTVPTmKAE32tAPPD42jGYzmmF5tTcAt	994	1394	1394	1616190120000
1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1419	814	5	1	1840	jwx1XghC5heKL9B8bb2qarASJY9beFVKvPKwbX4hgbBS7JGQ6gr	996	1396	1396	1616190480000
1874	3NKydw9GiW9vQ5V98UriQoKkvjDHoojrQVVYF29gzGTPHPDNNjqw	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	152	1330	5	1	1841	jxDB9nhCJvVXzqk6cXtkpAwZ4C3ygG5z4HJg7AUKeqypUNhDwGU	997	1398	1398	1616190840000
1876	3NLRK7bV9hg9qc9WfZZPWfBPNCrbyTzHU7L47k6jkzeUPFByzL9D	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	58	1035	6	1	1844	jxkLHpdV2cYj7as72dNFbWTvkHLjHiqrHLvN1uAiattd81NHb6d	998	1399	1399	1616191020000
1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1875	3NLqNKfuFL72ugkwueZQKKHoac73bxptPpmWwysbY8eBJW1djWhx	1403	824	6	1	1847	jxrfp6MfY4nUnRrQmFPiaCXL9FDETXkw98toCHrHsN8SSkfGBcw	999	1401	1401	1616191380000
1881	3NKaYkX59MdThj5o9c4nhdA4oniBQiQTwvhfvwGMrH2o2Bk6xFjZ	1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1447	1099	6	1	1849	jwPRHsckDkNkX4VxC9XjNgYxbHXFt2GmAUjYDZFUNeac7M2yqni	1000	1402	1402	1616191560000
1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1880	3NKrnCRmvomXqor8pnqrUsLv4XcofJBu8VWqAsWRirGNPszo1a66	1406	1393	6	1	1850	jw9DRnG4wZoLYDxtVXfkJcVUXkFCNnnuxioeWYfRBRjJ9dz8j7N	1001	1403	1403	1616191740000
1884	3NLaM85fs9WBDAX8RXCBLDyPKUVMMhEXwkwnymQswzmfsDGLUw1C	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1406	1393	6	1	1852	jwXYPqY7za5ZwkLV3Rc1QkXUsX6R6yUSN9PifmDZbBfq97AGgoU	1002	1404	1404	1616191920000
1891	3NKEgoUYPvpjWemBLFJAR6Pae83QBJUftcsF8DhpEs5RGtF4j42f	1890	3NKwSZbvmtGeXcsLrXuSDoPeEmXXX9mb1jaiy2unF6t1wdBRbyG8	1507	1154	6	1	1859	jwW62vTgdgR4b5d5jd5N5Yiun1v5ZDNPwYE43bobHB1sWUM1MMo	1006	1409	1409	1616192820000
1895	3NLQRyK881UevGtNCgpMgTsiWrEqhcbPRANQvdL1DfZSMP11f8pi	1894	3NLC4RGk4UfUGXpmC8WXj8C2CqkWg2vUCssp2BfoU7EMNPgqehHw	1619	1275	6	1	1863	jxFFyUNeq9WCkbhuf7WN9pXNCw4NA1FuCespWJAriEdbSGYPT5w	1009	1412	1412	1616193360000
1898	3NKcUqrt3oXmkmcQHu6LuKJDPDJniwkZ6KgVzAjf9Zdj4oC3VcMh	1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	1594	1080	6	1	1866	jwfEELDuW5QSVf5Ymr2AkEd4mb959oPpjs7G1U41CzMM1cM5U1W	1011	1416	1416	1616194080000
1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1429	510	6	1	1871	jxYt63vvCR1fqwwuwriphkrfAbfX5akxkHRjZk4CEiRLzLTzd2A	1014	1421	1421	1616194980000
1906	3NLhx7Ky2LwDdicDnDwzwTUoJ85bDwDqG1oidj2SSHT1xgSLFvnN	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1406	1393	6	1	1873	jwTQunYbKGShuY3Gh3wJ4535NwjPkSAgxoaW2QTePQaix7kYTmn	1015	1422	1422	1616195160000
1907	3NLj4oy8mYAWEQJkTpuKW8YpWqohwmgJQhxutiLTXVqK6tVbKxRJ	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1590	1054	6	1	1874	jxcAonanydvsGjC35bPH5tVHPmmf5ncU4ppuEum4RDw2Zy6DZAz	1015	1422	1422	1616195160000
1908	3NKjsvu9SRR1rJiWS7jYpKkyJvgzVUfMiKxbmnpmLNHLoRwJKP9P	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1503	911	6	1	1875	jwQhTyuoXBDRMJjGk4p8AmPbzgarGJJEefQj5HTyjwzWfbBeAJ6	1016	1423	1423	1616195340000
1911	3NLcgJ6pS7nnVYLoJwHGrTzSc15eggaAGmzzNvGL1DzsQduCvjLS	1910	3NKkzLupsTGgfjuzuaUcFDcpTTBX1LnviJkyBzntFA78HxM3aqDJ	1585	1366	6	1	1878	jwuVTBaMjhPM4WqrEpP4xYGA3MdHD41pQQL3PcZVzFEMsXvCamo	1017	1425	1425	1616195700000
1914	3NLwJbUvZ4n5ctTXVRPxHPEyrExXFCDZf3zCJDJYoZWztu5td475	1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1564	1092	6	1	1881	jwx5pb7EYstatb3d2BDKhhPJaQZzbZMaAZcF6y8P89TeeaapNQ5	1020	1428	1428	1616196240000
1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1916	3NKJiyqiJx7hNHe5vZzNiMFpSorVbiAPC6Ebpt813cSMzuw7tmZP	1407	1395	6	1	1884	jxfEa7kw6sVUiKemKojicdD38JJUjLqWdQBG6CAhrhy71uj3NYc	1022	1430	1430	1616196600000
1919	3NLujkTroXnM1k8wayHBJWTGnLXQmkywCtc7nonN2N4dG31wNGZ4	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1560	279	6	1	1886	jxhgcUPuV2hrdLpta7bQjDgDwqBGT65Ljb8UrrHjQ2AkQYiFShA	1023	1431	1431	1616196780000
1921	3NKPMvWEviDKD1mQW8pjNw5kXAGc8gdHakvxX9Q4KPwV6zSFppYV	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1646	1354	6	1	1888	jwCYJEtCu2kh9sdY16Dmx1Rn7SmjBwWAaqrGXo3vgBqfd8DfXw2	1023	1431	1431	1616196780000
1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1406	1393	6	1	1890	jwMfkS88eg8FvxCDd8pZXYSgkNHVMkZTpdXwsX7sx79S9eV13JW	1024	1432	1432	1616196960000
1926	3NKvGrDNyHjX32ik4cchUD9nYu4DUHxjpvRBfZn1ULRJMwxRhy8o	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	1553	776	6	1	1893	jxGzbkQdJxtpt5tYaFTETQXv9JEtxxQ8VBTgPddgAa42mhJz3Ss	1025	1435	1435	1616197500000
1928	3NKFWefKTjqekd2kLBhKWgHUj4tqjayE4AcmPFV3VzfpLPE5kW9M	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	58	1281	6	1	1895	jxS4SKeuASwpiBZ51LmizZwcr7XEyF16LzFe6KFhEPBh2gRy8JX	1025	1435	1435	1616197500000
1929	3NLw1DyfKf1VKrs3Q3ufX6VnTkPYs2DYY8J322ZJ3YwU8QxTXFVC	1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1406	1393	6	1	1896	jxHxXu1eD4RgJp56WKeuKRSrQAzgM3xPw19uKtM2gyUYV6hgAiL	1026	1436	1436	1616197680000
1932	3NK565aesyTMnN1cBtaZsrsr4AKpTXiMdCgffUcPCTKCogP5Yew2	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1489	1134	6	1	1899	jxpnDJzL3QqGMYSuXSSFwy4rko8RBau5A5fArircrQhGSVDev3c	1028	1439	1439	1616198220000
1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	484	1319	6	1	1901	jxacvzN6wCXDxuP4hhMvgNd7WVrR48CKqKMJSMAct6bFt7p3RE9	1028	1439	1439	1616198220000
1937	3NKHqw5CFcoWfb97WhucokTFbQtmkSq7xGxf2oBR2DBwYF1ZimJS	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1407	1395	6	1	1904	jxEcZ5an7wVNEAXV5KQHFyjjAyekczdE7rrxTyhmMqRNFWqttwu	1029	1440	1440	1616198400000
1938	3NL4MGDVq8bULp4t9DbKDg3FkkKWcTpUR2zcVBx7wHxw6Pehi1XV	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1547	1378	6	1	1905	jwM5iSxctHqbPMMXdWYWLSpeFV93JApKsAnYdufdcqjD3QgWcFA	1029	1440	1440	1616198400000
1940	3NKbd33uLNjzU3mR5cq6JwfnfpWqYDqHoWp28AUkFDYq7Bks9yd1	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1600	1372	6	1	1907	jwaMQ3SoppEkHPtq86rE9Zgs6TLvWoETEz4aKqozfn9K3QnJLgb	1030	1441	1441	1616198580000
1943	3NKk6WFjohXiVRjnayQcumsDEvXsa3BA4KRvjCbbHb42vhBo428k	1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1587	1111	6	1	1910	jwzSV8jsoNgndZ5KNrNQUiFeQHM2BVxMtwAocLzrDj61PTQFLUd	1031	1443	1443	1616198940000
1944	3NLsUV129StmT7pCaBy23ha6CkEBYyWfq8U9bvZtBURNuJZSA9Vq	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1522	1322	6	1	1911	jxLGyGpqwxQHkpUPuQdYBFuLRBzuu7hwMKisKeYoMAS12HstoHB	1032	1444	1444	1616199120000
1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1647	936	5	1	1833	jxb2fVQ7Sr6ubKqfA7okbHYhZQQCD2cVcuzQNpEzoBCGBmSifrX	993	1393	1393	1616189940000
1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1865	3NKPd8tpXURES9jEKH6NE7vJYCeeFy4YVEiJjfYV6A1qiKhva1mj	1407	1395	5	1	1836	jw8tgFSPSUCdiNkkerufRRDFsPXMCz3Jctdg2Kthpd4b4mEer1a	995	1395	1395	1616190300000
1869	3NLD8giC3YVLzNo1eGP8e625vo6MtFQ5Dtpzd5J8oAMMyso8rRmo	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1622	1356	5	1	1838	jwWoJfuxzSAXfMGbQon51fePuGhorWmf53HksAETfSDeUaARGew	996	1396	1396	1616190480000
1870	3NL3WN1FeyVW9rLtAb1VYip64AWgQC6nkjhsd7sjov5NK3SYkowS	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1579	1023	5	1	1839	jwwj52fN9ZrvwSFT4MH4SDBNsJ2uWwTQ5MEJ1883jNP9LuBsKbg	996	1396	1396	1616190480000
1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	1509	1074	5	1	1842	jwP8WvJaheiCtYjRrduKkiQEw6iXAJXzwAaMfVoRuPygzKfgWbe	997	1398	1398	1616190840000
1877	3NL8eNXbw42f845M4qxmdj8SdU8oot8hKapSJoyeHL916Lamg3qi	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1637	816	6	1	1845	jwHUgJXBAzB867A75TpgnB1pACuQcoUmeNw6EHKo9Ngw3cPsLYN	998	1399	1399	1616191020000
1880	3NKrnCRmvomXqor8pnqrUsLv4XcofJBu8VWqAsWRirGNPszo1a66	1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1403	824	6	1	1848	jwg29vfaZ8FQNwavvaLP76mVgvcs8EVbwDtC2czwLD5DfcQfx1Q	1000	1402	1402	1616191560000
1883	3NKuqeTE8TrPB6xadfxV5rpxaJoQBW4N9WFAUn3wcHtBN1Ais8FL	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1503	1277	6	1	1851	jwkvNpNRzs89KLTC8AvPmmuopTpV8o3oHoFN5KxkcR2Vs4h2odp	1002	1404	1404	1616191920000
1885	3NLbY7WQb29isKPmFQMYgQKFqQDvN3SaLBdHYB27Vs8V1DRVDkbj	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	470	1309	6	1	1853	jxL2gVcstZmdmaF6urZS5GNiREfs5WWcCqxbe9hdMVeVfwALdGP	1002	1404	1404	1616191920000
1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1885	3NLbY7WQb29isKPmFQMYgQKFqQDvN3SaLBdHYB27Vs8V1DRVDkbj	1559	1353	6	1	1854	jwYjKkP2QmQYuLkhyge68cP7h5qiTMTAVRN7SHDynQv6ZjCYzgE	1003	1406	1406	1616192280000
1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1440	1377	6	1	1856	jwYaB1hLKuBJAsyjbG1kUZEEWZb8c7hehvisXBbU73NAtbTZFcY	1004	1407	1407	1616192460000
1889	3NLvbVrfaRZCjP6Su4tjicDBwQXnFNB4YF5VRVkWcDuBaCXLLTJu	1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1619	1275	6	1	1857	jx2dfQh8s9Nonc91Gpd23D8HJoEqCp2DjX1yyUx7y533Uz8QWos	1005	1408	1408	1616192640000
1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1891	3NKEgoUYPvpjWemBLFJAR6Pae83QBJUftcsF8DhpEs5RGtF4j42f	1445	924	6	1	1860	jwePw2fvdVMHnLxhKDByWYwU5vYpSAVDp6nX7nh7aEcFqNr9AZr	1007	1410	1410	1616193000000
1893	3NL4GW7Js1eHyjorNmEkb7FnYXxKjSLL91WUr1YTzMF6Ju9sFudw	1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1608	1289	6	1	1861	jwcKGqJVtmKmA8mEnmDCwhYzEAUpLBaYUQB1PuXPpRJTxucHKhP	1008	1411	1411	1616193180000
1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	1895	3NLQRyK881UevGtNCgpMgTsiWrEqhcbPRANQvdL1DfZSMP11f8pi	1407	1395	6	1	1864	jwbdqFMtS4b3RvRqJaareUg531gtdJqY83z16DCcXLxmKksAvnw	1010	1415	1415	1616193900000
1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1898	3NKcUqrt3oXmkmcQHu6LuKJDPDJniwkZ6KgVzAjf9Zdj4oC3VcMh	1627	1385	6	1	1867	jwr1V6KebjHqn2dZhLzn8X4qfDMjf2JXRFkN4pZEccp8xRFGJY5	1012	1419	1419	1616194620000
1901	3NLncycmyLj8DHHiZK86ra7qZaxhnq2ZLm7JSCVE9HLHLJevjguq	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1406	1393	6	1	1869	jx9gqsxTt4HFyqtw6GwvPDLLGGXr3mbaDbTjx6AoTc7q6fR3bZE	1013	1420	1420	1616194800000
1902	3NLeFenrpvrB7NFm4AvHRsP8ZD9V1epUe7veD9CK6f3NQsCR49Rt	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1581	778	6	1	1870	jxWfHTy54fAin9eJBACS52UAGkBuymNps7PTD7aT8y23uk3fUMt	1013	1420	1420	1616194800000
1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1654	974	6	1	1872	jwan5uGixrthTCuR7BXWFQziFudDDGy5pvB2XKoaaej9WovgTrX	1015	1422	1422	1616195160000
1912	3NKdwdxqXQ27SvxsJya2TTXgD8uxFzTBgURD1iFqfFHuDwU84bmH	1911	3NLcgJ6pS7nnVYLoJwHGrTzSc15eggaAGmzzNvGL1DzsQduCvjLS	1402	870	6	1	1879	jxYtpxrpzHdpSP9iCcXv357NjTKs3dwhyeHgeS6exERzuBUGJLU	1018	1426	1426	1616195880000
1915	3NLZQb8QbkJEKsE7ap9yp3aiYqyqzqZvyhBZMtU3FZ1g1tao8J6q	1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1590	1300	6	1	1882	jwx7Uhk2t8P1ZLuNWNVpmL9hdPFAbYjACXSh45eAXLxNU2t1FaB	1020	1428	1428	1616196240000
1918	3NKQctcY6X2swtLxBVTxmNdUBzDkq7PHhHueAcn5q1E3CwRB4x6V	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1670	916	6	1	1885	jxowqakJnKCq9UEEHF9cy9PJ69RxBdEUJ9meRpd3ATyYRHx91FM	1023	1431	1431	1616196780000
1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1407	1395	6	1	1887	jxJKdWfEeFV63GkSi7kMbMq2qjrXGA8UvfnYmgFarAhpgZ6BcG4	1023	1431	1431	1616196780000
1930	3NKfM79W2BYYbuxpXP6ESqTZ4r6NByFZrC9VZkG1vywXc48LCT3H	1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1631	794	6	1	1897	jxikBYHfr1p97A3c5GkJyJvRqm1yy7ekD8qVfWJBUTZAKgmfQyy	1026	1436	1436	1616197680000
1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1501	1114	6	1	1903	jxrDFHjxHgWTBicKSkeiqj1N3scJ9xHPWFdZ2FDRXpQQaV7MH2B	1029	1440	1440	1616198400000
1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1588	1026	6	1	1906	jxbBTfZCQeFt2aeFimdLM3wPncKZ7Ducyb8uyAzMW5Ub9LE35YK	1030	1441	1441	1616198580000
1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1553	776	6	1	1909	jwG9AvEn9X9DeV6752jsiezofyQ9CgtHRy7EXNgd5uCjdwiAgoT	1031	1443	1443	1616198940000
1946	3NKK87UKgAtTUJYCM7hZ7e373oCtMSv6786L63QSux2YjPvSyyEz	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1522	1322	6	1	1913	jxP5SAxJwbrMiyJZiy9YixHHayyiPqC25wwSht7aXAxDLUZr5iQ	998	1444	1444	1616199120000
1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1947	3NKkB9goizbGafdsWXWzDFM3mrK52PZkfdRyf6zqZLLZfEXyDsVx	1421	508	6	1	1915	jwLrXKBoRVfmre7kwGQmWcub1X1eL2G6E9zxdHM3jR67dT1Csc3	1033	1446	1446	1616199480000
1950	3NLUzQnqPMGyymobZZ4UUq4JAn3R83YqwArLMi5HuRtByhXK4Qnj	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1406	1393	6	1	1917	jwtqweE3zYxhBdbKFB9xdtbhVd455vkpztaNyrNGgBkmv3ck92d	1034	1447	1447	1616199660000
1951	3NLofStZZperDw2Bqm7rGDQHGUvdrzLERLsEH21icYLFYZJQ91FQ	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	606	1295	6	1	1918	jxhqhVjvV6DUPk7dkHwRQKoS37yahEbcDk5CCXszWwJDhMU3Paw	1034	1447	1447	1616199660000
1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	633	1258	7	1	1920	jx7gXmLvDv1oRcDqE5z81iE9bDbuGZ3xU6B8KebmFEBNdPXSjGJ	1035	1448	1448	1616199840000
1947	3NKkB9goizbGafdsWXWzDFM3mrK52PZkfdRyf6zqZLLZfEXyDsVx	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1590	1174	6	1	1914	jxZQdGEzZERCV49hSk83WbcKeS36sMtRjgV35LaRn2X18tLK71J	1032	1444	1444	1616199120000
1953	3NLeATDzw16JEezG89MqepK4FJkLscfeSpg133tk6AnJxqJ25hSH	1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	633	1258	7	1	1920	jx7gXmLvDv1oRcDqE5z81iE9bDbuGZ3xU6B8KebmFEBNdPXSjGJ	1035	1448	1448	1616199840000
1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1476	1125	7	1	1922	jwSqTX3oaDQVjYCpQdLUBZiwh5zwM8DFmrjv6UwZ3JVV6hg4DKk	1036	1450	1450	1616200200000
1958	3NLgf15cfwjKBYWyf9Zuq5dXc1KNPpsS5GwUf2f47Dq31JkFrhDM	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1477	1104	7	1	1924	jxsctt1TwVfqnPLBz8EBmeYQDK5Pcv5bN6SZW3qgK5tNPtkifWx	1037	1451	1451	1616200380000
1962	3NLe7FDKonX42JfMGKDQo3fupCcQLDTDxiAho4ShHHfcTJj6akzv	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1490	1274	7	1	1928	jxtJeBjQqAoTTN8ywvcyUnEzsQZT5WRGjcMbY2HZ4UcFaB2fdh2	1039	1454	1454	1616200920000
1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1457	1265	7	1	1937	jx594NNcGxk2q1otMPQiUh6LQQAsH5oo4X8WAko2MZHm7XfAV6s	1042	1463	1463	1616202540000
1973	3NKBcBSGhAAjs5Ss8RaeGC69mxMiGy3jfnr2Ckarcx2R65nBJYjd	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1405	855	7	1	1939	jx6skCo42BEpbcsPn4qZwFCfXN5gpKnh7S5AZ6xdWzt29rvJmEk	1043	1464	1464	1616202720000
1975	3NLC3kfxjFZdwJSH9tBh5d5ToxvdtB2TcvCLPDHL2RosBtsdCax9	1728	3NKe7DL5ZS1rTFUjGsfcwrmMQuxQz93YAHXsqB627WBDtEJJg8we	532	937	3	1	1941	jxBub5xi2fF3qhA7KZTqDxy5thbdyyovaTCivQHyJM4MLCabTU8	892	1464	1464	1616202720000
1977	3NK9kwioVHGuR96Z9MCkXdRE1z3p7CZiHC99CpkWyzDasfPKVH1o	1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1546	1093	7	1	1943	jxmjqFfh89DURfvwhndHro5P4nJXDm3stSVMuKAwonS6uL3w9UN	1045	1466	1466	1616203080000
1980	3NLZALUSEcqTsKNqPGXxCvmtjXs1Ryyy1Y2V5cjzWdxHGu6y1ADb	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1402	906	7	1	1946	jwe58EXHwz3BZzZbimLk5Qa5qED67kmGWPAbLkYFh1DcJ7jSoh9	1047	1470	1470	1616203800000
1982	3NKM8NNQia8TzbvWoxCfFEG62NVLQ9oyGG5Hmquo3y6ZL489Hcdd	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1560	925	7	1	1948	jxFvQrNJZVtPRH1drYaLUkTnB8NJhHy22te49x88FsbFkFA9zPF	1047	1470	1470	1616203800000
1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	1982	3NKM8NNQia8TzbvWoxCfFEG62NVLQ9oyGG5Hmquo3y6ZL489Hcdd	1406	1393	7	1	1949	jxp5cSnBCDcVoyM6iCMak8hBv66xKpjYZivCjdyYbLqJwtpY912	1048	1471	1471	1616203980000
1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1985	3NKy3YcXPY1cUeHe5aQifLPYK6iWTPye7nsaGNhhxrAuDsHPVaA9	1668	1370	7	1	1952	jwQhrryzjidoPerhACeCmYh6CYkuf2VqN1Y2aaw7gEmpwaG9Xmv	1050	1474	1474	1616204520000
1991	3NKRwhXM8uZ27qbtTYdbZ7M7YboHxdp72YigaBVHiADiKYknCQGY	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	684	1226	7	1	1957	jw8Da1uRv4NyPfyfJdExZM7U1rAUMigT9VeY6eF9wij8dGqav44	1052	1476	1476	1616204880000
1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1991	3NKRwhXM8uZ27qbtTYdbZ7M7YboHxdp72YigaBVHiADiKYknCQGY	1407	1395	7	1	1959	jwoADzPUyAm8cJPzQrpDzt1PqZTmPXt2FA5WAM1pkDmqUeC8sox	1053	1477	1477	1616205060000
1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1471	1386	7	1	1961	jwidwtoP9eS1yEmyzcfirDU8WMypokmdSGNmMtyLnkzUdGw7tq6	1054	1478	1478	1616205240000
1996	3NKkrhoNmBZfsMKRcDZXRUYARGaLY17iSQ3RzaG6uEgbiK32nK1h	1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	152	964	7	1	1962	jx26YbjX9MVhD33EkYRzrhaTT7Ue4zNWfkK7tg7Q2UbmjkJ8jvs	1055	1480	1480	1616205600000
1999	3NKmZktyS4E2nv8u8zV7USie8DSPih1WpsHQb5SkwyWeFHqzoHLB	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	311	1307	7	1	1965	jxFBj26AJ8UgdnpP8N3T8LELAZ1PTCEjNhqsMZcobhFyW8SpU3D	1057	1482	1482	1616205960000
2001	3NLHPnWXQHtqeqrxATaSw67eSxfkcUVP1QpVwuJGE1uZ89uKNtsV	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	1581	778	7	1	1967	jxNRurMjcvFgaK9EWEmkBMyQDHtNusj57FqSdkZqi78x54UZXVY	1057	1482	1482	1616205960000
2005	3NKKyb8mRhFEjBwBG3opHYtdeXmZrqFYCsQTpv3x2YY1y7Fpo12o	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1546	1339	7	1	1971	jwkJTWKZpcfg8tf3Cr5BbyBAyFJxAoThy8Kd9hJ3jEsrBa3Q6JX	1059	1485	1485	1616206500000
2007	3NLQR75fjpn4jmNdhSYUG1NejLpwuiirRqy6ZpFWHWcEzBxqeepz	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1405	867	7	1	1973	jwptU2tq3g3WyJowUSjkgducnBKu9Ep64nJfZwn81s7eqBFiPjp	1059	1485	1485	1616206500000
2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1596	1237	7	1	1976	jx4QoH6s3HhEyDucJF3kAeCLzFhjiRePdFHGfC4wBB9iArsiGsR	1062	1490	1490	1616207400000
2014	3NKSJ2E86GiFf4JB38MrrhbB7eG5bCVV3fPYDiavyLMLhLJCr4yX	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1643	1173	7	1	1980	jwxgYZ8hn4PyZdRZSgvkNzZLj6BcMUWEBEfRVSuTDvuq7wg9nYP	1062	1490	1490	1616207400000
2016	3NKj4UhwptDagfED4RTSFNjjYPJ59H7BswyFdbkC6uftL98ck9RQ	2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	1407	1395	7	1	1982	jxtY4cS4yVYrcg8NWpafr8hf2CNKSry6XpycuW3ArY1344ksy43	1063	1493	1493	1616207940000
2022	3NKK6a3uwTC5Pg31EfmptqA8Xsv7A9fsNTDyYk4QMYP6WMoahnfL	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1405	873	7	1	1988	jx2sTv1BBy8Yc5FgusqWv96GtXgQ8GURiKN8ogULkHsZ5w7LoCM	1066	1497	1497	1616208660000
2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	1637	816	7	1	1996	jw9KKje3F68WjK14P5uB3WNNsbr7xVctPN8GdydsuJ9wL815GSa	1071	1504	1504	1616209920000
2032	3NLqmZJpXzva9QFKBknKVJbnPpp774nGUBCdFRLpvogRRXUEbeRh	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	8	1	1998	jxhtouYVeXxy1B4Q9iVYykyuJBZUf6VeuuGH8yh4uKc3jLSSjeg	1072	1506	1506	1616210280000
2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	2034	3NLcHM2CY5UnBFcGAHGWnDgfPLRCgTGBMDpfwgtms93oFCfqb95i	1637	816	7	1	1999	jxLmMVz9kGEiVw1AVHAnuXnNfMzegPcpwjSx7EXzxsFTUdxwhCY	1073	1507	1507	1616210460000
2036	3NKzBBsJcTvTHBiQbDdM33zocwzqvARHFeLSiKNFQAh3bXruvnqM	2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	1445	1290	8	1	2000	jxf1Ff3qMGhcNDK1gYG5WBbZ4fpLiNWaPbt4yRsgHVBvw3j9HFh	1074	1509	1509	1616210820000
2045	3NKxx4gJBq4MBDbpp1YDN95UDmXX3frJoiKoQiDDqCQLkj6f1wwW	1940	3NKbd33uLNjzU3mR5cq6JwfnfpWqYDqHoWp28AUkFDYq7Bks9yd1	1623	830	6	1	2008	jy24a53gdnXkUMio6XdbgHcVw4Abwmmezxp68B4bBGADdxwKpE4	1031	1522	1522	1616213160000
2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	2046	3NLutJ4baPD9qGB4wjSkxxFPhxbpwetSfGuBUEqbaMSWYgSa7a5D	1652	949	8	1	2010	jxDw4ELqULHSZRjF97Xo6BXbpzGjzxcViMbGEpR98DGNmLVvPy8	1081	1523	1523	1616213340000
2052	3NLX1fNtCwGKTw364VAS7fa6H4qyT5utGv1mAvNScgWArKjxWCJQ	2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	1490	1148	8	1	2015	jxneciX54fA1L59hAr7mLhJjLqkNMTrsqXJdwHue8wMwmYxrqQW	1084	1527	1527	1616214060000
1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1406	1393	7	1	1923	jxHjEpvT5CFdgtmZJDrSB6RXonpfCNmucF64moorjdULaEFp1oJ	1037	1451	1451	1616200380000
1959	3NKeXLRVcgATKUtSP1BijSpjd6KjqCW2GizaFVJjTkEt8Rdrzfe5	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1581	777	7	1	1925	jxre8f5khyhRbSLVZrGEDVAQYmLx4SHk7b1iDtFtvVrrtmUR3bL	1037	1451	1451	1616200380000
1960	3NLeWQAkKKoMvckgNnaKMb24Pk4cPQk8LNmYj55RTXKDSqKj3Yh8	1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1406	1393	7	1	1926	jxWYnG8KMamuby6JCaxX1Nq3KdWnCNaxo83oX2SM9agjykRwLjB	1038	1453	1453	1616200740000
1965	3NKvKsYMjVrQyEbcrDwbKWiVSk68FWzGm3uQcZKkR15NfoLAUN4p	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1581	778	7	1	1931	jwb4hTZXyg6UWQbDktPXLHqUNQD4dHn2sKugNz5aiBbiQ9kjRyQ	1039	1454	1454	1616200920000
1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1964	3NKbU6kYjmBzP3h3Kz74Hw9jUZMNJx6xm7QG3bthAxLAxTKRwn8m	470	1309	7	1	1932	jxEKBva7ebEo4D67NjvmUsrivs1UQbuQb4geNdRwVmbJQsnFn2w	1040	1460	1460	1616202000000
1968	3NKcL52rqD3PEmjvRF9icu17MiYuDjX3LP5VwJMyZs6zccAMcNBg	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1402	870	7	1	1934	jx8xbeEZ5NK1atbHPPQdZRsiNFj6anoRw4YMSuEQ1i8EX4h6pN1	1041	1462	1462	1616202360000
1972	3NLmh1YLQqMfTPk4SFN2E3zKL4wfbe2Py83wMf7YYoSzZjf1azor	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1406	1393	7	1	1938	jwEH2mvWG2Lgw5E3d8ev3bxb8VCXPY5H5fegF7s8Bu1i3RrAWsV	1043	1464	1464	1616202720000
1978	3NLjy5Sz6ZknRek9GdmY7cuTZjaEfJ5D7UScDmGQsumeyFPJaE9V	1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1489	1380	7	1	1944	jwKt46uNwdAL2S1EQW3L1oKpAnHGcmYEGgQMp9FeUAxaWo4ccCG	1045	1466	1466	1616203080000
1981	3NKqFMVoFvR4mW41wocamggZDZUQ1Fxfgfb221atprWkVYvw6U5h	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1407	1395	7	1	1947	jxpQ6LofgejUMuCjb7fzSMGY9dHeRLbh2bF3aHmptefAc5bcY2k	1047	1470	1470	1616203800000
1984	3NKzjE4kz4WSNqcE53YJGq55rrNotvfSqQG7YkwyktUDxXHS4ihn	1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	1637	816	7	1	1950	jxSmR1sJN3JfMUbe34UVDVPD9y47XLUZiKQi8GqBS3Pv2LtcFJs	1049	1473	1473	1616204340000
1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1406	1393	7	1	1954	jwgDXHeHjnCGQ3ENmNbmMpugF1qMx1f126Q3hCvw773tFEmta12	1051	1475	1475	1616204700000
1990	3NKPZUPWrjqWLFeHjEorTdwbkZsUjdUh2UjrYBnvvAxT5d2xS2bY	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1579	1389	7	1	1956	jxtChqs7zSAzrAtH3XVRVCJspqWw6YXuDtundvQ5u6PQHNKwX1g	1052	1476	1476	1616204880000
1994	3NKiRmyJS1bULqSENvhss2CVnsnjRi5QCCj6vU9rwvWCRTmxwMCf	1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1657	1344	7	1	1960	jxgDp9xAgjXQ6EVk86Pf4eHv8YaJSoHVa2bU3Pe8vDXtw315GU9	1054	1478	1478	1616205240000
1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	1996	3NKkrhoNmBZfsMKRcDZXRUYARGaLY17iSQ3RzaG6uEgbiK32nK1h	1406	1393	7	1	1964	jxt1fFWdA2LCXwVrk2qaUKu4vEWH4Prytg2YEHEMutj7RRGT32o	1056	1481	1481	1616205780000
2004	3NK9zzUFmK5KcAbd3DoGXH1affJshFBQZLUsrck43EQaB8WpktM6	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1588	1392	7	1	1970	jwx6XqCXmtaEDtF3sKcEhs2PPnGXDn7wq2uJS9ofngpc1trNKMx	1059	1485	1485	1616206500000
2008	3NLvVA8QuFS84E18afR313uxXGp5vMTjZxWyQ2Luh7ZCpD5WeGbY	2005	3NKKyb8mRhFEjBwBG3opHYtdeXmZrqFYCsQTpv3x2YY1y7Fpo12o	1407	1395	7	1	1974	jxCA1s7V6WAMZXGTGb3DkFbE11yds4N1DzCZe4a59w2aXKrvQAR	1060	1488	1488	1616207040000
2011	3NKN28rxg1nGfmyPM5Ew3iuN8TD6NdjcxuZmfQTThW3PC1qYdQFb	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1643	1173	5	1	1977	jxDxgCwtB81mntFaKej94ERyXtRtR2LsZdLx7eZrLr9jbFR63Qt	971	1490	1490	1616207400000
2012	3NLgtiJf8tJvfLUw7HqzNA9L1mQXVQrKuQkdE4NmEM4xgjZg5zBr	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1536	1067	7	1	1978	jy2CtAmqLfRvHhvveCTjGYBcbU4kHprLcP3qnwC9oMmxVS8PRE5	1062	1490	1490	1616207400000
2015	3NKEo2Aqh5TVPN5wyJo2KKtHxeafhPQzfKXLHgDKTMiuUCGsY9jU	2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	1589	1286	7	1	1981	jwHJWk18G46cvgAzxhVL2g3tcYuNYVVtAqw3amGS92vuMoNJzCf	1063	1493	1493	1616207940000
2018	3NL9ahKSYmFVyG2uGLxQ93po7DNEeeiEMBGQdXBCovPdPymaDvLj	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	1588	1146	7	1	1984	jxob8DDfYcJUjTDjD2GL1FWjBrKWdAzzzSLjR7skyxGnYfAwGhy	1065	1495	1495	1616208300000
2019	3NKt4ZW7huJBKQnbyUvaHDXHYTMvxyXapFaSar7Q1gS2w3FtWkN3	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	152	1330	7	1	1985	jxNfZYUnLiuqYmHFBX8JuerSxfLUXKxHMthN8a7YPXg1rrKTaEn	1065	1495	1495	1616208300000
2021	3NK8byEqCv6TJfMzioSEXNJg28YRr7ghvgEbcmW8vib6Twv7VMsq	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1654	974	7	1	1987	jxs84bTf4UNnEhiGi19dHUAToaCRnHEMyhmzFBTXTASR4RtWoCn	1066	1497	1497	1616208660000
2026	3NL6m6CRSn6d1CTG5srtACbZtxnRtGijck2i4KjJGXTW4ko2qJbk	2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	1508	1021	7	1	1992	jxPQSZY8SyoS4PYK4FAv1Vthy2PuLoNdoCv6XoxCsChyuhtANCv	1068	1501	1501	1616209380000
2031	3NK5uXBsjuFNmUXbzRnwyBVzi8pndQir7kdFiHkGctWwwfX8FwMc	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	1631	794	8	1	1997	jxTaGVpYAAUnyw8LPfpBpwN5DSFdDCdqng9TdmAzbvtJwuD2B6H	1072	1505	1505	1616210100000
2034	3NLcHM2CY5UnBFcGAHGWnDgfPLRCgTGBMDpfwgtms93oFCfqb95i	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	7	1	1998	jxnMvqtM9DCyf57s6J1ZbqYW2H6PdDjrozubyHnFrZ3JsjzpYNS	1072	1506	1506	1616210280000
2038	3NLwx53dXLJYJYRWnEf6944ggz4P9YXC92fJYmuJQrNGbwRHWm2c	2037	3NKSsRtAE2S2hZNMN7UtkLWsUdQQcUE4LbcNQwPXgLyXdEzKSGgu	1407	1395	7	1	2001	jwPAcRH8r2pRmDu4CbWbaLnUFC4Udvt7ASSsmumQ1t2b5i3TJST	1075	1511	1511	1616211180000
2041	3NKSPG5QD4L22aX7ApnWRNnX8qpCgoPUeBS7prA7hQgvWNwvkeGD	2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	1637	816	8	1	2004	jxgRh9zzRvbox4iqtQwFLD22DwZeFs6N81H9Na336TTQEw4QBWT	1077	1514	1514	1616211720000
2044	3NLevkU7Kzwve6CgwHRWzhjoS9KACjnBDE2CH6eGzFjyDrGqjMV4	2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	1631	794	8	1	2007	jxex7sGE2G2gAZeGtA1TvUoH7jZhX61bi6FX5VLi69ryjk3SZX4	1079	1516	1516	1616212080000
2046	3NLutJ4baPD9qGB4wjSkxxFPhxbpwetSfGuBUEqbaMSWYgSa7a5D	2043	3NKcnRVxSzSKMu6AMywCFDAq5RuTvPFXvRuaRuCwRCKMtvjjFw3T	1506	1373	8	1	2009	jxxrHsc9iWkQRrG3zQuVjWUhkGSgm4kh1QrS869nNmcFHaF3Kq2	1080	1522	1522	1616213160000
2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1406	1393	8	1	2011	jwjcnStff6BDbS6Yqd2Bj8ZToveHraxmYxucvcdzG2YMiGAXhpZ	1082	1524	1524	1616213520000
2049	3NKhiVrUx2Lc1Ken8yyUimziKDgwjooxTX81vR5D5HX674iGFcgh	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1646	1354	8	1	2012	jxbXLAmuSvyL4zGTNX581LshbyxLx9GmRoYraDcRVFYntqXtx2D	1082	1524	1524	1616213520000
2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	1578	1296	8	1	2013	jxcJGsF6dM9Yz5hvgMn9qAFhZCwUeynLwoWQiDMgZQZELmEEu6w	1083	1525	1525	1616213700000
1969	3NLPXFaMtjxz6WuzYjZN4py8RnYtjL4LUoeNBqsjsX9UCQmRv4Yu	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1405	867	7	1	1935	jwp7H6fXxewW36zsQ7bQCpyADpyvGYr6aC1Bo56W7geeCrhBA3M	1041	1462	1462	1616202360000
1970	3NKKAb3VRwjSWGNa32NPgUxgKeTgnUQcKEceYEUx1UrrDunsaGxJ	1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1402	906	7	1	1936	jwZXeohFhZZmKaYnZQgSBXjXM5unMRqTbSKGJGzign94vdtz1bx	1042	1463	1463	1616202540000
1974	3NKMNAF8UE3ehUkkq6Lnm3Z9VwVRauysVEPBfBb84Zbtn6tpVYf3	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	532	937	7	1	1940	jwdVttHe1rtM8bcZE5dz9JCbRXa3CQq5ce39JKaeLvG6a31n5KJ	1043	1464	1464	1616202720000
1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1972	3NLmh1YLQqMfTPk4SFN2E3zKL4wfbe2Py83wMf7YYoSzZjf1azor	596	1060	7	1	1942	jwD9oBtyqM33n6RHGqWRpgiU982oEqWXTyKY7ygYykkWyg7d6gK	1044	1465	1465	1616202900000
1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1978	3NLjy5Sz6ZknRek9GdmY7cuTZjaEfJ5D7UScDmGQsumeyFPJaE9V	1503	911	7	1	1945	jx2gdrqHYkNayN5UzQdFf6nKrKop6vqYUM9nfzH1HQauGwjShcJ	1046	1469	1469	1616203620000
1985	3NKy3YcXPY1cUeHe5aQifLPYK6iWTPye7nsaGNhhxrAuDsHPVaA9	1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	641	1210	7	1	1951	jxYxg1iB1fquYVRJBhbFQ18Txr45p8ibNh6u5eJL7eGuLqgkfyA	1049	1473	1473	1616204340000
1987	3NLstNA8fFtCHY1Vd7YSmk6arTaFfkWwqHSFvqQah1PtmaZ9EUt9	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1501	1360	7	1	1953	jxbsRU2p3iTiDcEwC8mzSFqK1WN2FS3hMQZUNWk86dGpcZHfeLW	1051	1475	1475	1616204700000
1989	3NL9ohaKhocB2VbJj69EkkJJatZVeGLs7sTNjmdMMYYdr73d9Qrq	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1573	1318	7	1	1955	jwHzFqT84n26fi35ZxqZiipeenvWQYMjpsVqj8mqhmvWa4KR47Q	1051	1475	1475	1616204700000
1992	3NKB5TRjogG944xt8YbrggLBVmXangWcEp4LMu1Ei4uLeZspJDV5	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1406	1393	7	1	1958	jxwycSU8LibXRvdHPsxYuVdV4NYiBDC1nu5nZAi9JSobbzNk6RT	1052	1476	1476	1616204880000
1997	3NLkiP9N9xKnV3FPxpZZ4nx9jdJoMUDnPt96n6zQaAKmqzRJ4eWm	1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	1476	1371	7	1	1963	jx6n1pxvKBLuxv2ZLbstDZbVBdnfxKbfjTVAdAkQ8ZNi2oVVUTm	1055	1480	1480	1616205600000
2000	3NKCyRYJGc34VMedXej9qqRm44no41v21DnjGgoqEquRbebcCBf6	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	532	1177	7	1	1966	jwokddcbppXhQAbUJJRH83XPmRuVXiPCbdnMgAjnZWkp79sU5D7	1057	1482	1482	1616205960000
2002	3NLkSb1gtyD2rm1eaAJmeqCRgCTAyCSa6gmEWbG2mq8SeTdoYgKg	1975	3NLC3kfxjFZdwJSH9tBh5d5ToxvdtB2TcvCLPDHL2RosBtsdCax9	532	1177	4	1	1968	jxc8GgefQoYDiZNKXYVGb3peXg4ywrha8bvFYFidUZg5QSMUfxo	893	1482	1482	1616205960000
2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1999	3NKmZktyS4E2nv8u8zV7USie8DSPih1WpsHQb5SkwyWeFHqzoHLB	1407	1395	7	1	1969	jwnD5HrQp8NzHtycfLZj6aV835SGCVnQrvH3HeY8z9qfcDBaZz9	1058	1483	1483	1616206140000
2006	3NLRhGRh5u8Xde3E9n3oQbS5LZQyqPrA5uT9gK2BoZPGnuEUPVev	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1406	1393	7	1	1972	jwkBTSn4e3Lc51eg9ix8LKFd4qN1SqFSsbzuJxh8n63LLyksw9y	1059	1485	1485	1616206500000
2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	2008	3NLvVA8QuFS84E18afR313uxXGp5vMTjZxWyQ2Luh7ZCpD5WeGbY	162	162	7	1	1975	jxgHe9A83GHgwbwRgh45TZ1tzDg75kfrpn5xKHVp1ghewJrX7yB	1061	1489	1489	1616207220000
2013	3NKKipw6psS19KXaaGLjJ8SJEkzYVeftpsz41hafYtujdsFDUXb2	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1518	788	7	1	1979	jwVrixrvfursPKaBjkJRJyhREqyXh2cHmx2YM3znc1jP2M417EX	1062	1490	1490	1616207400000
2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	2015	3NKEo2Aqh5TVPN5wyJo2KKtHxeafhPQzfKXLHgDKTMiuUCGsY9jU	1460	475	7	1	1983	jxK1Bukk5aoZSHbHkNp1dXxVR8cvN5ZwWeFf7pztwTSwXBztf3u	1064	1494	1494	1616208120000
2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	1624	1334	7	1	1986	jxjsuqivwFM1FVTTyR2yuyibvNwP8dkggN2oH3fhscnE8YWemVw	1065	1495	1495	1616208300000
2023	3NLXmsy9XfHrDvSvHvjRbmhThd7KFywPdSGwymPEwbiMxMSeP1oa	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1549	1362	7	1	1989	jxFiTENbrume1sxYhQbW8QdXaxoHpqbpXPhQGSfXmE2rhaiBWgH	1066	1497	1497	1616208660000
2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	2023	3NLXmsy9XfHrDvSvHvjRbmhThd7KFywPdSGwymPEwbiMxMSeP1oa	1483	611	7	1	1990	jxRCRKSb4cEWFvmaZpiB6Q7w1xEEKdWfWtR3wDroeQs9Kfu8zBK	1067	1499	1499	1616209020000
2025	3NL4E9erXAYRVrLhFWRr5RQ5WSJrND5A988eG8szLKxgb4APea1k	2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	1406	1393	7	1	1991	jwJkLLzoEYsvsM8g9m3E55fJzVSJcWMtaU6WmeqHPT6B4qxDUm4	1068	1501	1501	1616209380000
2027	3NKYFu41ofNb7wMp6fUnE3beQM8BABRKMZaj2u9k5FtV1rjVgPk1	2025	3NL4E9erXAYRVrLhFWRr5RQ5WSJrND5A988eG8szLKxgb4APea1k	1581	778	7	1	1993	jxPnRkNzW2gyPvoZfnRZCT9skV8VzepgppWcsvEZhcoSctDebhk	1069	1502	1502	1616209560000
2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	2027	3NKYFu41ofNb7wMp6fUnE3beQM8BABRKMZaj2u9k5FtV1rjVgPk1	1406	1393	7	1	1994	jwkzvqVj2WCVLfRAd7A3Pmq7d1tUAYGwj4mLjkk99iy4jnWgPzR	1070	1503	1503	1616209740000
2029	3NLkdJALxLG6Wcicoyd57oEvuV8sjFe19LTj5HP3PEJcQKEEHaE9	2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	1406	1393	8	1	1995	jwxPDeaKedVXGbo8XLLd6JTk6qvPSpJtnUjuB2CWsLvxy6hpswp	1071	1504	1504	1616209920000
2033	3NKYjmARt2sGuBafaNDdcj3zohLuRxBHjfmAMRA9kR91YYNMPGj3	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	7	1	1998	jxAEuxJfA44g2ndYr1oQchkGoMbUE37VKt6ENF5kJRyi5BAfS2U	1072	1506	1506	1616210280000
2037	3NKSsRtAE2S2hZNMN7UtkLWsUdQQcUE4LbcNQwPXgLyXdEzKSGgu	2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	1445	1290	7	1	2000	jxf1Ff3qMGhcNDK1gYG5WBbZ4fpLiNWaPbt4yRsgHVBvw3j9HFh	1074	1509	1509	1616210820000
2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	2038	3NLwx53dXLJYJYRWnEf6944ggz4P9YXC92fJYmuJQrNGbwRHWm2c	1451	1046	8	1	2002	jxPvq6by3b6VyeomrUznKo2KBZXaRzVUPfZFvHNJZKJGhQsoJE2	1076	1512	1512	1616211360000
2040	3NLZzwq7E6WAHYctgCgyNf18w1WKpPDkjXQTL6AbCXAM2xtiCAUT	2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	1407	1395	8	1	2003	jx3WoNtEQDFcDXBuxyS3TC9pvhPP6pmLfNKX347ges6ikug9ajc	1077	1514	1514	1616211720000
2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	2040	3NLZzwq7E6WAHYctgCgyNf18w1WKpPDkjXQTL6AbCXAM2xtiCAUT	1656	977	8	1	2005	jwXLt3uKZdkmBgXDtD6tw6AAQfRzM2hXVD6jCcMSsLZK6eEnAVH	1078	1515	1515	1616211900000
2043	3NKcnRVxSzSKMu6AMywCFDAq5RuTvPFXvRuaRuCwRCKMtvjjFw3T	2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	1536	1187	8	1	2006	jxRwK4qwBqmt2LX8j92C2mNVGZ1RSTtfpYmsVAXFsLnnFpSuS5C	1079	1516	1516	1616212080000
2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	1407	1395	8	1	2014	jwkb85TpoN9QsV24BbhnKB65XNfpCv3FSGSgekUUs8xrcMnYaaD	1084	1527	1527	1616214060000
2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	1402	852	8	1	2016	jxPiQZdJ6ytYNhTYsdZdKCAYKnkco3mEZFrrYDddg7X7WLbqXmR	1085	1528	1528	1616214240000
2054	3NL8qoKSM3ZA27XGnP87M2A3sW7nsjbtoGrYD4kpuFszdKGzLSeV	2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	1477	1104	8	1	2017	jxraNdRwLu6Cs4a2WxSt5f474qdAKB2q4Li9sasTYngLWTwpPXH	1085	1528	1528	1616214240000
2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	1406	1393	8	1	2018	jx1wwqjaeswEfP5J7MgLsyHACrfx8aCMeAKiFnujYpnSLvMGQMb	1086	1529	1529	1616214420000
2058	3NLuTvZSLK1wLZj3NFkHrYSrsgU6LAGbvAmDCN48MYoZcC1neDnD	2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	1406	1393	8	1	2021	jxuPWwxnS4ny2ThgeaSErRkKPxrYizHx6h6Z9BoksQo8Z8maoz2	1087	1530	1530	1616214600000
2060	3NKdHSkWQJHsWaLGzX7Kutp4usU7zwjnm3uPqspSShRVnkD4AgyR	2059	3NKsNb4eeTJFSjsCcE79zbJJoTVpCsQ5hM3iwT5r2g1xzNDJnmPy	1407	1395	8	1	2023	jwopTa6Eb32FzDZc9qoUSJuPeTn8FjEJjGxXmKkP94Z3Wrvsfk6	1088	1531	1531	1616214780000
2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	2060	3NKdHSkWQJHsWaLGzX7Kutp4usU7zwjnm3uPqspSShRVnkD4AgyR	1444	1381	8	1	2024	jy37cZvW7ne7GCMQTuEuSM1tkxdg1vZXjtzVY86wyQekkcAyt6S	1089	1532	1532	1616214960000
2064	3NLajkMagz1AsdScj96HTzmr3y61jukWDHhSBvzcdT9vAveWwmJk	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1406	1393	8	1	2027	jxuYRNGjDtg4kGCRyAmX55otJ4YjJ1VTK74UHwDDAn3hYz4tKc7	1090	1533	1533	1616215140000
2066	3NLFwjFG77xTqyE1peHXKQoiBCtumY3SUGjyzpShYfUvT5smxXa5	2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	1624	1334	8	1	2029	jwhegAk99uHKtLSVcAsDogvtv17RhtBfJJi1T6imsvirhAPZT4i	1092	1535	1535	1616215500000
2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	1406	1393	8	1	2030	jxVGYrYz6mVzq4x62xSj3ouyJfrwCQ88UNtNgJY4MLryXBpGpMj	1092	1535	1535	1616215500000
2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1403	786	8	1	2031	jwQENWCaY6ADiTBLFwTN16H94dR142rWeXM32qT9tfJ1Bhx6toj	1093	1536	1536	1616215680000
2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	1403	824	8	1	2034	jw6kt4eJA9GSBK7j9eok3a5JDLgm8RSDpz93ZPDMKVLkzx3RahL	1094	1537	1537	1616215860000
2056	3NKHFHQHSHz4w756KxYAst8qxYTxLuaJDR5ixgpUmGZVMZcW5iju	2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	393	393	8	1	2019	jwd9XnonbkpWqCG8ZBcVPsjAbeLv7SkSWE39WHASb4rDMRtNhiE	1086	1529	1529	1616214420000
2059	3NKsNb4eeTJFSjsCcE79zbJJoTVpCsQ5hM3iwT5r2g1xzNDJnmPy	2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	633	1384	8	1	2022	jwXDHQwim4jZgJA1knMv1DwUVViZHpMDNhx254N1szjxhxfa4e1	1087	1530	1530	1616214600000
2062	3NLeWMofJUUdJA8ifntdNrQEjZ8f4Vgqv2PPgiNsYMKztuYv7WMm	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1600	1006	8	1	2025	jxxBasdJjiVVx44UXQER4SVZM46DfjRcz1i1NgeoHVzCY6L1wAr	1090	1533	1533	1616215140000
2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	2063	3NLuqLnNHp2x9Mrxiiy6sJVPWqiAPT5sbw4oBbwGW1fyE1Db9W3x	1617	1288	8	1	2028	jwW4L23sEfkC1kdat3UVTJ7Mst1P9aJcxmTxqLjeHUoWg4cApQV	1091	1534	1534	1616215320000
2069	3NLkqFPhovG9yfkcUvdRSMB1YuZQPQKkkNjaKS8Kwt7JUKptY2gZ	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1407	1395	8	1	2032	jxnhhsjzcQcFgBZzHAQh2xAT9g156WMG8SLoKT2ETPa2cPJJf9g	1093	1536	1536	1616215680000
2057	3NKXfPiPTFazNzwpEBU6UCSrdPeskquX4ckzRm3dhxtGpoFyUpbF	2056	3NKHFHQHSHz4w756KxYAst8qxYTxLuaJDR5ixgpUmGZVMZcW5iju	633	1384	8	1	2020	jwpsYwAu5zoCZHPUBxqP351aBhgoF6jPgifVdHYt9GokWgwA567	1087	1530	1530	1616214600000
2063	3NLuqLnNHp2x9Mrxiiy6sJVPWqiAPT5sbw4oBbwGW1fyE1Db9W3x	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1608	1043	8	1	2026	jwWDQNX42vAostpoCeedo3j37QHC2pDpDxN6SjM4mSV4H11KtV7	1090	1533	1533	1616215140000
2070	3NK3s1rbSBJpojiLKBRN2DYfrjnMHQm8nZ4Y6ZacijSEnJurd5fE	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1406	1393	8	1	2033	jwbtumH57cQiXxmT4zK5rLNsgkJqbnFedt64BpWEUhpYegB7soF	1093	1536	1536	1616215680000
2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	1403	786	8	1	2035	jxyU43zo5fuZGTpF24vJzKSHMxtfET71dUVLA1MtETupmGpYeqL	1095	1539	1539	1616216220000
2073	3NLqEoNyLpCTpKvbJ8V74kw9tu2iD2avE3yK325uQy8wzL7ixd94	2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	1637	816	8	1	2036	jxkghFJVyWH5NpUamWjiLj6sqNfPHarqAugqrTmkTZyKMzquwn5	1095	1539	1539	1616216220000
2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1402	808	8	1	2037	jy1xUibzQMBfY8uevUW7kD9uv2Z1SuPZ5xLdvZ9Z4179a34tLKB	1096	1540	1540	1616216400000
2075	3NL8DuAxm9z1FZ32y4QS1EnpvLtaxNqW4dzpn52Ea6133sD2LDx9	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1483	877	8	1	2038	jwWpgEf7J1FjoGSJewd1oKzGKZ7JNtFn6NeveWxhPwDYVfdKNPZ	1096	1540	1540	1616216400000
2076	3NLrWmUbawT7KPB6zeTU7zbKZWZp3HJWnKnS5v2DHkDhrrHydzJR	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1529	950	8	1	2039	jwUWVxNncdCYYMKUnpm8x3YDr71SzNEz8RUTAZMaFgrobfEqiRR	1096	1540	1540	1616216400000
2077	3NLsfcuV4wUbrpEk9bEMBm4FF33Z4oGhRLcGJ4PvcqTeWS36jXJv	2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	1578	1170	8	1	2040	jwgzQJgXkLaQKnMk7ss8d9fJyuZVs3AGoaYimwzxgddrDkB3vSp	1097	1541	1541	1616216580000
2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	1581	778	8	1	2041	jxWqA9QT1ikQtvq4HGu5N8sJ3GKk45GcN8mU5Hegs5gMFyKNBvA	1097	1541	1541	1616216580000
2079	3NK91BxvWp5f2w6JrRAGKPwrLXt77oAuk5rgdh3ciDtAEv7eEqnr	2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	1654	1340	8	1	2042	jwfdMpEdz6Aw6xU8wwpZtLnRRBvy74gpwrsGQtdRLUESQXumt2D	1098	1542	1542	1616216760000
2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	336	336	8	1	2043	jx1KuPX1eWV9B6SNFrCQ3fz1mc2cpig2nHxiNuGpN3X3Wb8r7KK	1098	1542	1542	1616216760000
2081	3NKpewZj2KevysMTrMZ3n6wGZoDh128YHxUnMZQcP22mBXsMxjgh	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1440	1377	8	1	2044	jwxQ14bX8E8oSk7X6i3LZr7dc4vs5mpAiteeFwcuU8oXYZB6FAo	1099	1543	1543	1616216940000
2082	3NLGrrEkxL1fpP7DP8iekxv1ksAUePnzqN8DLocRiCsVrpRU2fGq	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1406	1393	8	1	2045	jxxRu1ZrsKXG6ane1j3MiCmSVheenN9mfSdewGH4BMMviqz6tLQ	1099	1543	1543	1616216940000
2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1646	1354	8	1	2046	jwWBdiCchdti71VHBfHdeFv9ykAVjA5c7Mv3NGFC2f15u9JKRMp	1099	1543	1543	1616216940000
2084	3NL2wxyjPDzTprp1yb1dPmKYW1NvhrNT3xi7uE1niQmhXTrZF1Hb	2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	1403	782	8	1	2047	jx3ZKtPDuVGasi8GzzXvjY8Yg9kn2Z7HeTbZRvbGb9V1wDKKHCD	1100	1544	1544	1616217120000
2085	3NKccKUDJE2AE6CAzSnBEh2Hw6aEG1J4oFoumi6aUeK3dy1nVy2t	2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	1490	1274	8	1	2048	jxTyji3izJmn2oSJfZBna495ggypomv63z8e7nfr3Gr5gGJs4gw	1100	1544	1544	1616217120000
2086	3NLLpLBgJVzq4AnfZsP2ZkoFJpa1Mz91cjKGZCEqqzkFTVA4LmaV	2084	3NL2wxyjPDzTprp1yb1dPmKYW1NvhrNT3xi7uE1niQmhXTrZF1Hb	1403	824	8	1	2049	jx3STZaBaQ9mMp7WtHeT8MGUQx2mSUvNewkM8WtJUxt2KK3RBc1	1101	1545	1545	1616217300000
2087	3NLKbj12ebh4ETrjdeZRvNVn3MaBPK2UV2ikwjz2uiYxjSZqM8ZJ	2086	3NLLpLBgJVzq4AnfZsP2ZkoFJpa1Mz91cjKGZCEqqzkFTVA4LmaV	1403	824	8	1	2050	jxxz3XuWcW9JEeiDSxWxPLeqYkCcFekAoSYVV5BfGuSb5CJ6DY8	1102	1548	1548	1616217840000
2088	3NLcxDo4BRu1cQuJZD7giXyZhT9VbBSoALoFd3Nqii25SqkycjMw	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1448	1311	1	1	2051	jwKqSNbbj7ngrZKog5Yxyu7gh9pUsagqY4nNZgqwpgbXKDno6Gu	818	1550	1550	1616218200000
2089	3NLgxT6Yt9KR5UPFuXDcin89mjGpDcFpTxHojraA2H3TAo63FvKM	2087	3NLKbj12ebh4ETrjdeZRvNVn3MaBPK2UV2ikwjz2uiYxjSZqM8ZJ	1593	1100	8	1	2052	jxBAXzXtTTuk52kj2Fo3q4k9swpsL1SRtzUEdj8aWQadS5dMELg	1103	1551	1551	1616218380000
2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	2089	3NLgxT6Yt9KR5UPFuXDcin89mjGpDcFpTxHojraA2H3TAo63FvKM	1529	1316	8	1	2053	jwxJZxgc1EmtdEWDnKwnkN4zqkLiXCRMSSsPZXEQbcTV7oTv5V4	1104	1552	1552	1616218560000
2091	3NLjidijoWjBoequm6Yq4HTpH7greSN24xRG26xteJ36oqtG7Hj4	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1489	1380	8	1	2054	jwMtrMxZxYQW7r3YBUHZrpoyerB4c4gWnx2LDkvZBxmVXSzfqCu	1105	1553	1553	1616218740000
2092	3NKk6AHd2TwuPWpjGGp5sfQb6842m6svENarCHLtvtmdorMCGPtH	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1553	776	8	1	2055	jx6qQ8BcdS1msLoAhBrSBF9HU5xmUKmQvmb2XDA4QrTtwTB3zF4	1105	1553	1553	1616218740000
2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1407	1395	8	1	2056	jwDz5Wy49rmSgpLTMtMyeN6Mb2cosmpKYv1j2QfGDDRyFzCyW8f	1105	1553	1553	1616218740000
2094	3NLg3U6kLxHPV1uFG8oCKmbMGHb4Pc8eQ47VH9reUNYr4u4Xw9KE	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1501	1360	8	1	2057	jwr35GWyfApkw1UwnSKRowyXoHTGi69orPQkK9cxufuMiPtgYay	1105	1553	1553	1616218740000
2095	3NKbiCnid2W8PJsoHNtedqkdoAtb7J1Hcf9utGMUwBwvPeJL8WkL	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1579	1389	8	1	2058	jwfG3VZiCFVHTeBjAMRCNsYTgCsJptKV5comcCPpgdj4NxJtFfW	1106	1555	1555	1616219100000
2096	3NLonp7fRagpwTaVA4rQFN3wXU4MfYWgwHnhBxE7UWTgDPtN8n8o	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1406	1393	8	1	2059	jwn1gngmkevC219t9PqWk8QAyWrVvVMPYr9pYyirCBhWCGXYCt2	1106	1555	1555	1616219100000
2097	3NKVzZUZ3zPa2N9gXUNWKa3DnTWbdSrQC9MjVzwvrxwAR1F2dqEv	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1456	244	8	1	2060	jxUMoxv1rQ5pown6pNwDsVxmMjipPbqfk5CKUtdzWk1iALm5JKP	1106	1555	1555	1616219100000
2098	3NKcFMjQK6qY52Km8HV7MNcpjdWnPRuw6aphq4X4MXaZwTnjCw2L	2096	3NLonp7fRagpwTaVA4rQFN3wXU4MfYWgwHnhBxE7UWTgDPtN8n8o	1634	313	8	1	2061	jxcQb2tMajo84GwkLzmF6sz85XwUGa8VP95epyqEpAiH4mfXbx9	1107	1557	1557	1616219460000
2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	2098	3NKcFMjQK6qY52Km8HV7MNcpjdWnPRuw6aphq4X4MXaZwTnjCw2L	1406	1393	8	1	2062	jwunG9np8JmphSKYTVX3PECnY7Es1eh4pGbdBjqNCE7qqSEok2R	1108	1558	1558	1616219640000
2100	3NKRtsH2stvcd5SrphqJ2ZT2nJDv7arwtfAd57xdmGqw9Pfdfzga	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	448	1305	8	1	2063	jwVLLs2axhsqGx1iznABYBckjXdEq5ewrEGLuhPj7tq58rHvcKX	1109	1559	1559	1616219820000
2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	1407	1395	8	1	2064	jwcG3YNQivh69NPcGJkiBdgNosFPCBRPqXgPY6pXZ5eV88NCSHj	1109	1559	1559	1616219820000
2105	3NKmPCgG5qbafuJCW6YtuT1CLwkbeC9XY4xuZhthR9bKCj5HsxSF	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1406	1393	8	1	2067	jwCb7Sa8NYsGhaaoaRKybazYbhREbq3cpWizxjQwXnYhFrCrDmL	1110	1560	1560	1616220000000
2108	3NK3H2LK364BUw4RkWVZFG1DHbKtj2Yvw8ewy1sndLEq8kvpwF3G	2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	1637	816	9	1	2069	jwk6fJSnBsycKHFGFohnWuBDzcnDMwbpJRixS4K3DkJovbGsByZ	1111	1561	1561	1616220180000
2111	3NLPfpwUJCBYv46Eko8ChBFpBgKoew1PTuc6DVEnxprmEv55uaFn	2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	1477	1350	9	1	2072	jwGojwCiVy9D1791M9FJ4mneossFRd9yn9i1D3Lf1hist4tVyL9	1112	1562	1562	1616220360000
2112	3NKgpSN4wfHeJKKK5qYebrN7TFdY3ssHQo2vSFLWoGjM1tbnFv3y	2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	1466	502	9	1	2073	jx4euTKc5YBcSbz2KjVmhipdbYWgXNqFJt4oFwYxbxuF2441vRC	1113	1563	1563	1616220540000
2114	3NLUHCHKwo9W8pjTAaPFwaSdWmf3rJidL5Y5gFtgsGRtojF2bpam	2112	3NKgpSN4wfHeJKKK5qYebrN7TFdY3ssHQo2vSFLWoGjM1tbnFv3y	1529	1070	9	1	2075	jxvXesZagCxuufqWuvjPt76XhHXgf2t8YCTxmPb5ADe66T69FuA	1114	1564	1564	1616220720000
2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	2114	3NLUHCHKwo9W8pjTAaPFwaSdWmf3rJidL5Y5gFtgsGRtojF2bpam	1652	1189	9	1	2076	jwPARhCcsXq6tNmmup5CvGHxT55eJDExhmwakBwnmvFc7a4L4zW	1115	1566	1566	1616221080000
2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	1458	1323	9	1	2078	jxydtpVQ3sS4igqjgQvu3jYcKEySuiTBP8D8BdMAZgbsKtvvrxT	1116	1568	1568	1616221440000
2119	3NL33eeMpB5AYXeBGaQuQ5xVNekd2q8SytEnNA6Eqw5JKzhkfV53	2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	1547	1132	9	1	2080	jw78HFauQ3H9KKcbV67izr3jcWaPfAPwmghfwg9zXHG8Rb5BqM3	1117	1569	1569	1616221620000
2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	2120	3NLnkc716zv7qU2QDgpw5XNgenMkpaKP8bqVy9asHeyovTkohn6g	1406	1393	9	1	2084	jxzmPgaA5HhsnrPMNCYFXgUvhf9jPyYETuVahzaGf3S3uhaWGne	1119	1571	1571	1616221980000
2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	2128	3NKB4KDjMs287wW5qsdcdvzA1MBTm2vhPu4vGVvTUp4jQp55u5UC	1474	1083	9	1	2090	jxYmXo6aXhKGDFpSQDcmfizntQpmG8kZq1HoQFLCkLxsCCaFUDi	1124	1577	1577	1616223060000
2134	3NLf7tT2bdxGK8q9WzHDVpRKazH6Cy3R57a38MogWvVWyHiKPxcM	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1458	1077	9	1	2095	jwkRfWG6U23Ptt1y3HUjTZ8U1MV29YYgdvgKrJ9CDvG6vFQZxQn	1127	1580	1580	1616223600000
2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	1646	1228	9	1	2099	jxspr9zGZ4JDJbhUh1hjqHkLzSSrSpt77xvKagSFmZ3FA7rsi8Z	1128	1581	1581	1616223780000
2144	3NLTC3MrGiPjydNR4gj6vMVT6uXjt46eM68BX3mHbXiPTrJeScK7	2143	3NKQRGi4ady6H53CtAi2Br1482uYKbrgQ5XJp6mcFzb9pa2KKVzc	1619	1029	9	1	2105	jwDfcnQGsf7Sqnm8F4JrJfDRbrr3yfLXPvuPYwiv7vr5QHX39DU	1131	1584	1584	1616224320000
2146	3NLXcrk6EnLFkggsCfnJtY5v1Za1xUgkP8ftwVQbnz6wF9cHxfrm	2145	3NKwrsn9bFy7UAMJ5rgruqmnPyWtSZrb5qRW2hs2giHytD8Xh5wL	1553	775	9	1	2107	jy2F1Yc1HG7fH7Ab57JmcGGrijbhUnSEMC21vYSY4mUPhLuboyG	1133	1587	1587	1616224860000
2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	2148	3NKmWY7Tj1nVNb9jZ1DifJjUV8vFdbvoN9v8jwep4ucuXgQMAWqA	1521	173	9	1	2110	jwsodfh6X5uBEvdnwq1Di4LdVSPAk1hwjkzo6UbeuwXscQFrW1S	1136	1591	1591	1616225580000
2150	3NKiytzySdaAx1QkyEqd1Z7f9akHF7mVUs9dVjbXF3XuevhB4ojZ	2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	532	937	9	1	2111	jx6WZHApsKdiYmxUNZQqddZcjE2diGxQBEqpgKuxjn5wf4nvzxP	1137	1593	1593	1616225940000
2151	3NLRozf8kNKMuv9ycxgaHqDrsTiLawxbfsX6ipaL1CRBrhHqqtNJ	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	532	937	2	1	2112	jxhAbhMoCUxGfjTsPKSv8mEAEpmj7FfXBeaJhtp4ruWaNnbxA7V	855	1593	1593	1616225940000
2152	3NL56kFxPBhMyvfWCoqapj9oFxr5nuYLtr1BLZs8UQqwNDmC7LD6	2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	1637	816	9	1	2113	jwexsiWVZNzLjr4ex942YJ3qfvHBNvVunqMX1fHNSeoshJzqczn	1137	1593	1593	1616225940000
2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	2153	3NKGmrMUfY92kpFXrn8jDTsapwJKnEnuzcPdHr3JEceJ3SSRK42e	1419	814	9	1	2115	jxSakDGLw1LAa6pwCDHsBWxXisdMCcUPSGqziT9EPx3Li3mDCQA	1139	1596	1596	1616226480000
2156	3NKmQhVmG8snd6iNFx9V6b128PfSR1Ay4UiQVEdXiiFjBPVnmexG	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jweRRfhZa82ogJs3dKqMEQWdSz37ejwD1qbP5QPLKgNZURddqxg	1140	1598	1598	1616226840000
2159	3NKRC7pyLng5wwNfPMtigRzF7pGcP2WiArzb5ax7jvwfhFCqge58	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1627	1385	9	1	2118	jwwPwMrswaub5Q2bb8bNKcXqvsG4ZVVwvS6QsdtJEvLpVaEASRr	1140	1598	1598	1616226840000
2161	3NKTALJJsHaWWq2qSjFbxDFfAWRGJQ3c9EpaN4UiyVHbAetFeYHn	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1578	1296	9	1	2120	jwyHGbAsqzT574Eq1ZzEdyTBSZdvA5vEsLYxCryfpJZbGpS82NV	1141	1599	1599	1616227020000
2169	3NKiZxxy14CkqPJSnbEHevhQfSyMY69qejgx4Br5hFLjKyeFajYy	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jxH5taE18TuB1ZKoisfrhZqbcp1McEmR24DfQB51N88PrzeYb9P	1144	1602	1602	1616227560000
2171	3NLKXoe7yE9wXxiJffLifz4HKVThXHAZ3asNHXEz9qEP1kdYr5Y9	2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	1637	816	9	1	2128	jy1jLTkKRMBAR73aUjMeR5LSxEJCV6qx1Qv5wZH4NNckByKtZbh	1145	1603	1603	1616227740000
2176	3NLbEv7tDBhM3bQVP98e8wX6ECv8QcYQ3YCVKDY5jLAgFPoB7o2P	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	1581	778	9	1	2131	jwumGntwvfXztcMb1rPRJ7RLL6WVs3JYHhSZJMmdM8ZqpCYp7Y8	1147	1607	1607	1616228460000
2177	3NKMtqcTAzs7Vr28VzcqKVPrFtcLthieBy4YbyfwgMFddWxr1XtP	2176	3NLbEv7tDBhM3bQVP98e8wX6ECv8QcYQ3YCVKDY5jLAgFPoB7o2P	1402	876	10	1	2132	jxrhcWDKaSwJReL9r1u2KgbGKscCjkSbJQWy8xGeQ9nQ3UFXwng	1148	1608	1608	1616228640000
2180	3NKdVnqSxxZ9ywBXAyHLdx5U1bJcLNoB8XtZ7bZuoSTgBcf4uABD	2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	1627	1259	10	1	2135	jwVtm17uMs7qcw8xmAf77dKfvFnkwB6NYkMgcDwrrkfT3bB6WRf	1150	1613	1613	1616229540000
2184	3NLRuR4VwjuuobDmEUuEnkfZcth842YRiHfsncwwk6gGNZS6Gfwh	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1633	1264	10	1	2139	jwAzoyNNZpWZFajtyVAjFQm6QPduBEtAYTEfxpW2ZX8FnZRjTiu	1151	1614	1614	1616229720000
2187	3NLDz6PVD8NSuegTWMHJzJVDHgW1UH6v3yrtTDcxPj1K4jk5wFXM	2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	1643	1299	10	1	2142	jxFbpb2bqxxWjtR9t4ac69fCZPRsjDF8sfpU9Hm3p9cYFATTWyp	1152	1616	1616	1616230080000
2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	1553	776	10	1	2145	jxkngTT2p9JTQSZxMJosj6tUd3C76Q1r7tuudMdXVmn5DkhqnyS	1154	1618	1618	1616230440000
2192	3NKurUhgbeZxg2iRGAwekNLaPP8DWrTacV7grFv8uqx8mBzkAGLb	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	641	1336	10	1	2147	jxK2mMXjHvuD7Qb1QMZ5sAvG94NdhShBXH9ujmdCQyJTeCb7yda	1155	1619	1619	1616230620000
2102	3NLjHvkDmoJ6zJHNfb25qrsEFirEwppg9xr8FEZShngFwrtQZYdj	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	1573	1192	8	1	2065	jxJamJ2iEkNYr3cAkAQGTddYN7E98sNweaAAXHXQJZo3zrsRgBj	1109	1559	1559	1616219820000
2104	3NLo5qRCDQcvFekjtd6xu4DEfuUjmRHkLnMJF9irVS6iE79orB2Y	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1649	1017	9	1	2066	jx95JWvC776TqKgYKqSrYS1kjFGyQNPyrVneGPj5UG2kJhkTKM9	1110	1560	1560	1616220000000
2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	563	1233	9	1	2070	jxn3ZNvFYwXEhThxWULjHafXY1XrqJRV2HQ7vBxdPDk1gMAumGt	1111	1561	1561	1616220180000
2113	3NK8Px5xynh7amdSiqnk9NSJ3R492pjhixAZDrLPRoXa6Jtt3KxT	2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	1553	776	9	1	2074	jxdyrc718KX4EJBFsrzAjRfkVwC4DbyvgeGHMGm3NHUkP3c5oV5	1113	1563	1563	1616220540000
2121	3NLs2ECRjJjTZHtqKXxCq2eTPEvxsHJEgbt5wc9pg1i7LQB2uQp3	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1553	776	9	1	2082	jwPcg164s7dUxkqQaxqnDwZuQDtG6GhHUBLRaLSHD4zWfzNEbg2	1118	1570	1570	1616221800000
2125	3NLHgQd8LWQbHzP6VMMro1tu2tZQ1134F5x6dEmjCfpDizs1MMQ9	2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	1403	824	9	1	2086	jxAyBzz918aJdzDSWQovShieUe4T6vu3SELpvbVF76ricqZBQNa	1120	1573	1573	1616222340000
2126	3NLmriwwa5h8MUoazPq58QZ8f1eZX4KfK1uFox4WjxL6hm8MVVJv	2125	3NLHgQd8LWQbHzP6VMMro1tu2tZQ1134F5x6dEmjCfpDizs1MMQ9	1527	1047	9	1	2087	jxpcCWcEUdk2xKcsqasRDM97E77Ds1SJTzmvuQxx94xYrdZzqnC	1121	1574	1574	1616222520000
2127	3NKKg59oYf3vzH2G8vzoPpPAxPWarn16DbivtYorA7LRYQ4beDEJ	2126	3NLmriwwa5h8MUoazPq58QZ8f1eZX4KfK1uFox4WjxL6hm8MVVJv	1585	1366	9	1	2088	jwx4jKcyTMui4gxbSzNamVZ5fj65xfBiBuC3pxwYV3Eut1q2jVh	1122	1575	1575	1616222700000
2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	1513	1013	9	1	2091	jxSq4aoo8kSuhgeiX4jPCXxJWw9paDzfXDdyrPoYZLvsJQYpW7i	1125	1578	1578	1616223240000
2136	3NLe9Q73NJWi8hTbJyqmvvq6gKkTrBcSL5aMnqexBVYeenBxLXk4	2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	1458	1077	9	1	2097	jxNRC2c2wFu4vhP15Rvr3dLw4NeLai8VkEFnEmHD53iq7s9xSxw	1125	1580	1580	1616223600000
2139	3NLMEU8YVrqmJugZmZ7dn1LrBtgVExNfdMkUZW7i3XBYqnZLRTpV	2134	3NLf7tT2bdxGK8q9WzHDVpRKazH6Cy3R57a38MogWvVWyHiKPxcM	1406	1393	9	1	2100	jxDrhf7FBFvfrsUFZ2BnrYGu5wuf6tPq9FRxfKVwkbqcLbTRooZ	1128	1581	1581	1616223780000
2141	3NLtZD9rMLwDfqbLDBecDoy2o2wfdNdMHJhBC2bwU9oXw1PQXscQ	2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	1407	1395	9	1	2102	jwc46VKWk5AFsMMfM1UdpimFYnUrN8ierN7cWsMouJpEKGwqPE6	1129	1582	1582	1616223960000
2148	3NKmWY7Tj1nVNb9jZ1DifJjUV8vFdbvoN9v8jwep4ucuXgQMAWqA	2147	3NL23K7fKAMFduGpScvF4aWnbqgJkDLhEpKtu3x9HWHHVRdgymQs	563	993	9	1	2109	jwUykYD3eFe5eykq8GVqL4gae5er3ZoFcxtLR6yXoy3nuVFuedT	1135	1590	1590	1616225400000
2153	3NKGmrMUfY92kpFXrn8jDTsapwJKnEnuzcPdHr3JEceJ3SSRK42e	2152	3NL56kFxPBhMyvfWCoqapj9oFxr5nuYLtr1BLZs8UQqwNDmC7LD6	1440	1377	9	1	2114	jxjJQk6ctxYn9zePcKfaQqBhf36RGsEDa8VtL1hAAx6XdyUnKtL	1138	1594	1594	1616226120000
2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jwiVkcmmoBkjJM2o6NngjWehcdTGSPnTJwyZBuhPx2WMbidDsPY	1140	1598	1598	1616226840000
2162	3NLkWXc9M63QwV42YBQGPB5XGc4R2VVAmEU9k1knXQSNXAuHmmVz	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1403	824	9	1	2121	jxsDDMWpfMpaPj6nucV5oeJxxy6MdJaTorbaTMxriqgbEQvAE4B	1141	1599	1599	1616227020000
2164	3NKRLmv6eTeXaWoaKBg2RGGCuc4V3dqvdXbkkaoeDaFjQwj4vrpG	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	632	1136	9	1	2123	jxzX3mLtQr8x8dpdsoH76DhMTa4vAuycDS6WiZPBLoXDqNb9g7n	1143	1601	1601	1616227380000
2167	3NLTQJDxroA2twoRmMKbXkL9kVCy727nNGfDx5vMiURSzzBSVfNi	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jwWnKxHgjwy55NWeVKYoc2S5n9YA9Zr5M6CmnufroFzLqM7fZ8y	1144	1602	1602	1616227560000
2170	3NLrCT7cyexTFeeQmz8eRhxyCyKPPW7YkRjAVGav6q4QiePdiA25	2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	1447	701	9	1	2127	jxusquE4969f4NscrmzAry3qEc4r6pFHqRE2qFvqnQYVJVgY6cA	1145	1603	1603	1616227740000
2173	3NL3QvcjeqUD5w8VA35iokCPqG8CPDDdWmLsusrgwd3YmP4UetzK	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	9	1	2130	jxmLNobjK3JGUMLriD1AXWvcQ5UsnT7DwwzUoM1i3YxubQk8QWe	1147	1607	1607	1616228460000
2178	3NKXd17tWmYKkqGAqaKNiwTZjCK8FdrHbtantXRHQmjFQgsi5MWi	2175	3NL2tUDSFbfeuGGgUVVWxdZdNXnt4izDM3jgfAWxRfwZgK8Vfajk	1406	1393	10	1	2133	jwzFfh44E9dWGKjjypdkZjV4Pwpo62MndwhyraTBGqudLJTdyW1	1148	1608	1608	1616228640000
2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	2178	3NKXd17tWmYKkqGAqaKNiwTZjCK8FdrHbtantXRHQmjFQgsi5MWi	1578	556	10	1	2134	jxCMbFD9kfh8viYttJAuCMCcSg5J8M3vMPdfu28SD6fcR1H73i3	1149	1611	1611	1616229180000
2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1671	1119	10	1	2137	jwjXiiwdkYjUTvoJZXdPgg3NTCZZenMJ6R5CMcmUz2hCyNaM1uL	1151	1614	1614	1616229720000
2185	3NKMESLDuajiw1AZBrhE9ne1aCyjfxKvhD2fVxqnjr7mBRQgBTy5	2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	1483	322	10	1	2140	jxuopnBdGACX6fpsMeD7zU26uxEdc3rUoSYoxGBtYrJhob3kQ3A	1152	1616	1616	1616230080000
2186	3NLhiUdtnfPRN2qAqZJVfojrdG42Y4fj5oy7sTxpBVvaR9qUuhoj	2011	3NKN28rxg1nGfmyPM5Ew3iuN8TD6NdjcxuZmfQTThW3PC1qYdQFb	1643	1299	5	1	2141	jxoK2sXWkgFDTJ2ZT314xGKpkCJHjMS279R7ywUgnB6fqmQTsc6	972	1616	1616	1616230080000
2189	3NLKbKbn8n3snc11wJiu8Upqp1Zggb2dr8E89LT3AVXVMMmvDdQr	2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	1483	1276	10	1	2144	jxy1sQMhfnheEZ3c9BYwPuU3XtimRKSrtwmFmLP5fsatsx5FaWq	1154	1618	1618	1616230440000
2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	2192	3NKurUhgbeZxg2iRGAwekNLaPP8DWrTacV7grFv8uqx8mBzkAGLb	43	944	10	1	2149	jwyPJp3C5n2etoabcRQS5wZSCW9mf4zQUysAZhEKVAum8xs7oUu	1156	1622	1622	1616231160000
2196	3NLn1aWv2mnWFeSprVdsrWqSXsxLumqDorU1r5p2NnRZi4rNFABL	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	42	1115	10	1	2151	jxSg5GZXo7oMGBaoX2BEQRUcfDHRbyPp5L1VtLqg7NxerRPUbZC	1157	1623	1623	1616231340000
2198	3NKdNBuWfthcaWXVTtoiPHorsC6WmzUAfA6qJBgGEb7muepm9TiN	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	1407	1395	10	1	2153	jxQjw1WgbA3cYT96LbhXjVcFZvopy7ZEvsAQZoh9fHLm86NKipA	1157	1623	1623	1616231340000
2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	2197	3NL5o9NvCPMeSj1up17otBhgYtZzh9ajBo3aoVEit8pEN1zq2RdN	1506	1007	10	1	2154	jwa9dgUs5bNeNqkVVaFzvUBhjV1iBBcMoAy8wXd5JfQJfSyXLdr	1158	1626	1626	1616231880000
2201	3NLZDKL8rsPGMpXjbuysycJLw1WbCzPvZE5Qk4HdVnfipD1GefPm	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1467	1250	10	1	2156	jwLvYJLCmEciTNQGxDuPBH4Xg3ZSBYuUD8NXWfzXccrSLWjVb3t	1159	1627	1627	1616232060000
2203	3NLVeakW7PnPCdNHjU72H7mGdYC8s7ECnximmtTtW3F2SSrCwaeC	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1637	816	10	1	2158	jx2ZEV3WKeRwT3bfzZk6ZLihBEP5hAmL28Nph7r7rWbuwWxBk3t	1159	1627	1627	1616232060000
2103	3NLR5SfaXqSCRL1ubXXyKonEw2wm5nRzV8iP6RmHhPgpN7RxP5z9	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	448	1305	9	1	2063	jwVLLs2axhsqGx1iznABYBckjXdEq5ewrEGLuhPj7tq58rHvcKX	1109	1559	1559	1616219820000
2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1649	1017	9	1	2066	jx95JWvC776TqKgYKqSrYS1kjFGyQNPyrVneGPj5UG2kJhkTKM9	1110	1560	1560	1616220000000
2107	3NLMytc1jarVNfKFVdaac3nDUW94W9c2DAHgQfUS2rDrRyhoypoZ	1887	3NL9ePJn4P9k6wtaLgGHWwDcYihvgysP7mFjyEC6cpBzhQokyUop	563	1233	6	1	2068	jwT7P1eHeTDfknvWtSQ627ZoWk2atDjdqR6VG2tFoKJDQsJgPU6	1005	1561	1561	1616220180000
2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	596	1306	9	1	2071	jxFx6yD9VWThL69ebLcpX9kHgZc15jzJBdcQMHggCnGpwmrGyYW	1112	1562	1562	1616220360000
2116	3NKgzVP4V97H3dcNNDEDkPbxokMeqUiSJyz4cv3a4MyGFbWq7hJ7	2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	1407	1395	9	1	2077	jwjZueQNp93xWke3kHQXk7ggsSJxynrTLzGKLXAZq3WRcuBA3qx	1116	1568	1568	1616221440000
2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	1403	824	9	1	2079	jw6ewNzu5SCYyBzho9Q9YaZAm1fHH5MnqMdRACRmXXmX6dBrXWp	1117	1569	1569	1616221620000
2120	3NLnkc716zv7qU2QDgpw5XNgenMkpaKP8bqVy9asHeyovTkohn6g	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	298	1308	9	1	2081	jxJbXxKVCRvwM9MLYhQKJRBGAYzLDuAHWTeCrgf9KUjSsnna2TQ	1118	1570	1570	1616221800000
2122	3NKNAxbyQqBUarCL6EfdmSpj3Vk4yJ4srSeyZUjquytbZhCQdheo	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1406	1393	9	1	2083	jxuC47eJTSdE8RmrnEzYFBA7rmbghSwDt99dgWfXvvNxCdY8f2R	1118	1570	1570	1616221800000
2124	3NKpe9AZwYbqqBgFrZpUErvAiUixbcgv26U4XZCXRS1tRcuNkady	2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	1610	1314	9	1	2085	jwpfYBmdu5f3XLnsW79EC733pepWNgjTMHEPsnSrGffhXt4Bwaz	1120	1573	1573	1616222340000
2128	3NKB4KDjMs287wW5qsdcdvzA1MBTm2vhPu4vGVvTUp4jQp55u5UC	2127	3NKKg59oYf3vzH2G8vzoPpPAxPWarn16DbivtYorA7LRYQ4beDEJ	1609	1333	9	1	2089	jwssmMDYfCcmamtW2qgKwuY1H2cpM5esB6GZWfS4C7ydDFqcmUi	1123	1576	1576	1616222880000
2131	3NLm9JmsPpXc8cEg4i3RcFeydgLmH6UFMTfPmfSK5RYABuMhvRnV	2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	632	1256	9	1	2092	jwgg4QtHyTFWP5TcVUMvsrktj1hiWSFPsSAvSSV4dzeRHwkvMd1	1126	1579	1579	1616223420000
2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	1631	794	9	1	2093	jx3bn6AHCVwsAg5V5QAqJ6Knaxk5nTSmTGCAejta7VV5YHYPMPi	1126	1579	1579	1616223420000
2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1589	920	9	1	2094	jx7K8GXTctH8TknBJQfmmXYWm8pYzp2nDvPykYjsuRtuz4J247w	1127	1580	1580	1616223600000
2135	3NLVsrRCg8ZkER5mJxoP3chY5USM3WQq66u2kZ9zSU7JnAaEnxZf	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1619	1275	9	1	2096	jxNCW2bVHme4Q8bdzi3pY6fHkkFgEdhHmbuoch2iimV3f7r7xRL	1127	1580	1580	1616223600000
2137	3NLVoZe2gQTHYU8bVH7MDCrnsX7GgoMFrCXUkRn7ama2N1FKJuW2	2131	3NLm9JmsPpXc8cEg4i3RcFeydgLmH6UFMTfPmfSK5RYABuMhvRnV	1458	1077	9	1	2098	jxFhPJTuJUsUemHNBybXs9wQtETTJBDa16QfWhdNCdVLSSgraBc	1127	1580	1580	1616223671491
2140	3NKXN2fc2evDf7mrk6zv5pzxxdbkxjEkWUfKDHoUhV39bZZp1CY1	2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	1477	1104	9	1	2101	jwjDVRvtUubk2cf4uM9a6G3VjcsVZLvvcyMWvEyq2fhyrJqKa93	1128	1581	1581	1616223780000
2142	3NL96o8fSgh6YzeqZZscJd5EuNaosu6hhXg4e9PiZHRcZR56YNgV	2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	1506	1373	9	1	2103	jxDYC984aP7XpxQ3Bmy3NYRpkvWPyVsJar9SfRFY5pfGmQ1DpKn	1129	1582	1582	1616223960000
2143	3NKQRGi4ady6H53CtAi2Br1482uYKbrgQ5XJp6mcFzb9pa2KKVzc	2141	3NLtZD9rMLwDfqbLDBecDoy2o2wfdNdMHJhBC2bwU9oXw1PQXscQ	1553	776	9	1	2104	jxrMW5YJuTyMBRGnM4qoCYH1GrdmiqY7ARyQTtuotnUdyqXCsZr	1130	1583	1583	1616224140000
2145	3NKwrsn9bFy7UAMJ5rgruqmnPyWtSZrb5qRW2hs2giHytD8Xh5wL	2144	3NLTC3MrGiPjydNR4gj6vMVT6uXjt46eM68BX3mHbXiPTrJeScK7	171	1374	9	1	2106	jxNtC88Ds6yFXracbkC5LxFQtgCZNMxbKprFsHFAMjjZhP6HbAq	1132	1585	1585	1616224500000
2147	3NL23K7fKAMFduGpScvF4aWnbqgJkDLhEpKtu3x9HWHHVRdgymQs	2146	3NLXcrk6EnLFkggsCfnJtY5v1Za1xUgkP8ftwVQbnz6wF9cHxfrm	1489	1380	9	1	2108	jxjWdMBTM1yLekoem94JdmmND3t3KfUH5wUeAtZKbfXkrym4R3K	1134	1589	1589	1616225220000
2155	3NKQD87puDtDghhf3Tn5LNDewajXg93VCACydcwMGnhLw1w3kV48	2045	3NKxx4gJBq4MBDbpp1YDN95UDmXX3frJoiKoQiDDqCQLkj6f1wwW	1623	839	6	1	2116	jy24a53gdnXkUMio6XdbgHcVw4Abwmmezxp68B4bBGADdxwKpE4	1032	1597	1597	1616226660000
2158	3NKWPfvcQ1TqhxXiAHeg5kgEY2L2Ckqg6Seu57fPrXQpb7Mvmx4J	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jws8y9fURef8bRS4DSfPie6WV8S5ozJu6VxTNpCCWt61Me2eMRR	1140	1598	1598	1616226840000
2160	3NLjcJbwoPGTb7CZUce5U2FfuQ3G9V1jFAkaV9K2C4wZSb9CzQat	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1406	1393	9	1	2119	jwDSqaWUsAHWxU9FYiqk2pWXNDmbG1hcnDJv2kvdXQ7QprLZuv9	1141	1599	1599	1616227020000
2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	2160	3NLjcJbwoPGTb7CZUce5U2FfuQ3G9V1jFAkaV9K2C4wZSb9CzQat	1647	1176	9	1	2122	jxZjhiTFdbEekcN7vpNcn63fejkTVGdkeyttnTqVHoMvXYCKXTk	1142	1600	1600	1616227200000
2165	3NKXRkmkXy6a4nZTPvm1Upxc4o4UfMhe89HXbgb9GjeE45hjrcxd	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	1406	1393	9	1	2124	jxH3LuTH2wsyrYV5sG8HXDzMYPFsScwJHoH3KpY3fuXsBW8REWU	1143	1601	1601	1616227380000
2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	149	1037	9	1	2125	jxszqeVexzccZNWCVQvXdNsw3yyWsopohW2zD9T9h2JtJdNHbjR	1143	1601	1601	1616227380000
2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jx2FWPxvTQNTrrH1Q9QS2gVC16nt4dHBLNwkCb7yYHe3DTEosiQ	1144	1602	1602	1616227560000
2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	2171	3NLKXoe7yE9wXxiJffLifz4HKVThXHAZ3asNHXEz9qEP1kdYr5Y9	1423	559	9	1	2129	jwEMNr44pRjdvdQZRhCbdyk6gyMEpg16FJztEpq1zvvVZNktvcR	1146	1606	1606	1616228280000
2174	3NKH4L2LJRWhTXsnTLhLxWTnZoWXhFq1mFbcvN9EEFNoq5ETWH3Q	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	10	1	2130	jxMSqkr9fPgcZcziiKU7F256RWoRhmJMwUpRpT4JJmi5LFGkYC4	1147	1607	1607	1616228460000
2175	3NL2tUDSFbfeuGGgUVVWxdZdNXnt4izDM3jgfAWxRfwZgK8Vfajk	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	9	1	2130	jx9uctYARXpTYF1etdRd3gF5Quxy3PXLUjWZotJLo2TdrTBEoXj	1147	1607	1607	1616228460000
2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	1631	794	10	1	2136	jx5zBGTHYT6FXB1jcd5ge2XsmNP5KooskQ8qUa5j3EEwDa49WMG	1150	1613	1613	1616229540000
2183	3NLKJnPqw6t3CoZsTCebStvn1tHNH2faZUtjpFpbeeLVHe7hCexD	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1451	1292	10	1	2138	jwH5tFKTD8jx7uPjL7WcLh11eWyUNhvma7WBEd6iGdNu9nNed9q	1151	1614	1614	1616229720000
2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	2187	3NLDz6PVD8NSuegTWMHJzJVDHgW1UH6v3yrtTDcxPj1K4jk5wFXM	1406	1393	10	1	2143	jwb8U7AGyuzMaoNBpJU4jAGirhgbVnKCRyNfwW5rQFHLY3oHCxc	1153	1617	1617	1616230260000
2191	3NLWZ7pFth3B621EN6LUqmoqTaMkHmrRr4syt5H7Kmh7UC9tWmQH	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	1637	816	10	1	2146	jwh4VPkodrg9NoBAhACUkTXmvidjfdDAemuHo8kRW5o5WLQqo8C	1155	1619	1619	1616230620000
2195	3NK3rU5UV8DXNDX4rHGFsgfWCHw5ocAh3wimW9bnKgzLSyMU7FEv	2108	3NK3H2LK364BUw4RkWVZFG1DHbKtj2Yvw8ewy1sndLEq8kvpwF3G	43	944	9	1	2150	jwxzBWRYqhi8ARhWEeqWknifsbYgkF46SHSe71g7pG2ZgXxWRcD	1112	1622	1622	1616231160000
2197	3NL5o9NvCPMeSj1up17otBhgYtZzh9ajBo3aoVEit8pEN1zq2RdN	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	1403	824	10	1	2152	jxq67vfgpNibmz1A24Dwe3v79ApiTjULvFLJkqXYk9mM6GE8aNQ	1157	1623	1623	1616231340000
2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1406	1393	10	1	2157	jwfp61EJZpqfCXT8Nhhndw1rHBmQSisRTmeFcXbg8LWfR3Nvzx4	1159	1627	1627	1616232060000
2204	3NKGmukaWhwnEyKLNEVGeQdJWvV3Yw9773ogUMUXqczj8jHvV9ND	2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	1648	1284	10	1	2159	jwhe7YLkxburZDTkiXnyXiNczzbtMwfPiYwtWRZbywzL6RCQCiu	1160	1629	1629	1616232420000
2207	3NLMQ2dSpu837dLuNPfvEhp3x5i2xpLZfkkEhbF8tAKuwohYyKHp	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1559	1353	10	1	2162	jwhTS6rm3Bj4Z8BFMpXj7F34CapgPRiAt8QgDbj8htTe2vqDAvV	1162	1632	1632	1616232960000
2210	3NKwrwn6uNKEo8ucTGJ4xeNwfzEkJwmgoa66zcvLsCENx4TmLeaZ	2209	3NKQ13KxonaamAd8FNWqWrfPcQSUYngpbYTLtQ42xn4Ma3z54nH2	369	1312	10	1	2165	jx2V7kBCHJh4rm8LUmrsSmqWTd4Kddewg7vZioQc2FDt3zz9x6E	1163	1634	1634	1616233320000
2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	1405	853	10	1	2169	jxs8TDCq6PFpNk6CpPZRLsKtE5Bxx2rhV6SQXRLuXAbfK4AV4U8	1166	1637	1637	1616233860000
2220	3NKxYh5nKiTyyPJQ1tom6k2E3YyQkYSwkV7zQxgGPxfGRnhRSesW	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1529	1070	10	1	2175	jwpdyVtbTMbA2honu9f4vb1hbT4RmYCEgW4Gk9PDHEDe2cmxG6b	1169	1640	1640	1616234400000
2223	3NKu1dAVX9sFMoc3PhwMDPc6M611uZs7L3936cS4myxxKGHb9zW7	2221	3NKtsQ1k4sRp46W8XMvNTiPc7cHqFcq8WjxcgrudfwsczADUfAif	1581	778	10	1	2178	jxJcBF9R3bcZovoDmr1FmzgtRc5aUHnUguCehcz755iAHWipTBM	1170	1641	1641	1616234580000
2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	2225	3NKijJdjMPSPygkjkkxTDwNFdgj9xhmpoCdXKNtmeqdSA9dGcsoq	1448	1311	10	1	2181	jxh94MEvjJbSVtTKD479duYAFyBJWowoVp1qe6xtB7xE7pUvRMD	1173	1648	1648	1616235840000
2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	1599	1041	10	1	2183	jxemRM9mSZQajA2xcXbdCk3X4VJE72G16KRyS8yQpnxkKdgyWKE	1174	1649	1649	1616236020000
2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	2229	3NKRNc3PsNTC81fuE2xSVrwdddNgUSFi9sgQibRVKCbhwLupRooX	1590	1300	10	1	2186	jwuuYWwrQWC3S5f83KKf9fTvuKGBNuM59Br7sV4TGsPUHCXdtvf	1176	1651	1651	1616236380000
2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	1476	538	10	1	2188	jxhFpYcLhAbfbpmVoorhVcZW1Up3xgmDmE2bvRPXLfWx3ULjuXy	1177	1652	1652	1616236560000
2234	3NLPLJgUvaMMcrdD5Ksjba8YM6XYHrHFifFy1MmRbP7m4Mm5uvXq	2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	1652	1069	10	1	2189	jwGVTbB4bhV38zDC9pNiMy1EYYL2Fd9XMZSXM1pDkx4bhLnF8dn	1178	1653	1653	1616236740000
2238	3NLsKz5GE8z8dUR5SHCTJAxdLEXFr1edNfkTypXFshCjeAbRaWUs	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1407	1395	10	1	2193	jwucbxSmzh7kVTDD1PnLcbLuEftKLbzsHzKeAsNADqLMH2nGv1g	1179	1654	1654	1616236920000
2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	2239	3NKQjW2wDnYaoL5WxYrq1cqdoA9hDFLRDsWrcvZhMXSrahthcXQY	1648	1038	10	1	2195	jxsKuwdujtqvfCkM2duymq1hpWEbco8rUFNXPWBYWX7pZr6fkDd	1181	1658	1658	1616237640000
2245	3NKZrBnRzBabrJsxAzaK59AfZiSFA4YbjuBgSS9EzWTxuej4jASS	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1672	1159	10	1	2200	jxYVNAy2BweN5n6Vof9EWoHMfHW2vf96VjseK71cbvpUZ3ebDjD	1183	1660	1660	1616238000000
2247	3NKxx3gvhb4CXUhChhAkZCf7f3deravkvGUB4mKfQGo66nCHzUey	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1509	1074	10	1	2202	jxheJgUFbrCweFCADp35yLVs9ioEViULQSjai2w4gBtsdHmh63B	1183	1660	1660	1616238000000
2249	3NLvUhXr6Lk7yK4AAU9krdMLQfED4Z3JxGHM2xNHubyw69WX2ox6	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	42	1115	10	1	2204	jxSSv445UxjUkascAWDKg778GbKbnKhqXbxv9XYzUhUJabXCLg1	1183	1660	1660	1616238000000
2250	3NLyYZeFw9dndYcnXU1KCQoFApj7YqMn9Ee1DL9huHzwj26RnUY7	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	386	386	10	1	2201	jwi3evpMnoHjrWe8mUxnHoyV6ecHeKn9VGMzs6JR34vtwgqoYip	1183	1660	1660	1616238000000
2253	3NKQ2j4VWAegtXhFbPNcjQsKmQvW6E4vuddj79ZTjVJExwFJvJ3t	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1426	1118	11	1	2207	jwCDnAKantSpX8qtg4G5A9WAdcoK3bk1FXVrz8xqhL3n11sk65n	1184	1662	1662	1616238360000
2255	3NL4v85nQLYzdKesCqr7L5AYxkWWMWkSvdgv28YjfuKqJutaTT1h	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1564	1338	10	1	2208	jwGFq8mL9LQY2Ggxw6VC7xcjuSQhinMDkghEajgggCuJbK7U3D1	1184	1662	1662	1616238360000
2258	3NKcMkbPXgiuPJGVeHKphofs4GA6dHpFM99wS7bkdgcWPQpx7TdG	2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	1647	1302	11	1	2211	jxp4j6Pkre2yvzhVJZ7U7DAQ2W946GJhJZEqNTYsnFxGJbqK3mM	1185	1663	1663	1616238540000
2261	3NLsXes7FScPCyZG7rCjBfn48yeLAR37yNXsBM7cNctrWrcBPjHd	2252	3NLZgD6WMBLFYVSGZMYzhwhGkecoWcLQwkHn7dBNzrv4r1KWGeen	1643	1173	5	1	2214	jwQ3MMAFUtmPFmhrXT8iQ25wUpWyRZar1teYXVxS1mHHKcTY9AW	974	1670	1670	1616239800000
2263	3NLF49N5y13MsKHKvCpdWiTqFgdcz5FH6Vt7wMVno4nANXwKcjhg	2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	1643	1173	11	1	2216	jxTrNqZaemL81syoxZY4wrg5RbMruP9qRvzN9jyAfm9uzS8beRB	1188	1670	1670	1616239800000
2264	3NLbqPRp8c8qE788WLC5yQwfvw9cydd4PbzdquUgZMzaQRBoeLw7	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1536	260	11	1	2217	jwcyT4wbhkM6UhNnVxJj4M6cY9sVDFdKpMUAxxLKziaxzVWRgbX	1189	1672	1672	1616240160000
2267	3NL5Ew9HLJMSU623FRX1sFZRRdhfkAKGB6V2sodEstEftvL4eFvd	2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	1439	1279	11	1	2220	jwoWeiqr86zMD9ZDFfzDEbEMYBxiF6epp9746HAFAAiMTDpQYWv	1190	1673	1673	1616240340000
2270	3NL6sqhT3qiVMUpe9cqdT3C3TJwLxm27AYFpWvajLZjPUoFDRcfs	2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	1623	839	11	1	2223	jxHkqhYYaVdRDXEGCHP861WxKS1GcCSddFEAC36BVZLvjTQoRcn	1192	1675	1675	1616240700000
2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1403	824	11	1	2227	jwrf2quSjfyRjUshs21ox3tCrSBVQwM6RFVyyiFrqcoVuXoPWy8	1193	1676	1676	1616240880000
2276	3NLvELUYbrvpGZqbdFkXUoSN9CFwwStgiMozmnLBrjVofrgTMsA7	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1577	1327	11	1	2225	jy3JtAjjQmh6tS7fg95abUYvA7hBHmNQpy8bDbCCEtce3XCocCV	1193	1676	1676	1616240880000
2193	3NLofcPTDsPQj7As8cB4C9ffFpYsTTxa9VSG9cbL7sWvxv5s1SwK	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	43	944	10	1	2148	jxtQvkQg7pGkQjcrQmxjs4hedQTqLZbqJ8u5nef27EkFtrhs83Q	1155	1622	1622	1616231160000
2200	3NKFEHjxokefN9pzTfBqED8YLDvdz8xT2P9W4BRZpSa1CYuuB5wU	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	311	1181	10	1	2155	jwkuMdGJ6hV7PUpUUc8j55R8nPG8QfNsAyC3aV1UqPRhgfzQ6mX	1159	1627	1627	1616232060000
2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	1403	824	10	1	2160	jxcc5Ad9dUgqzhstA9kJPrhHE6NXMYytgZiHDKmAJ9ztL8ymze4	1160	1629	1629	1616232420000
2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	149	917	10	1	2161	jxB2UB4JiYcYNBoTZZQc4z73e7wRbtfNsW9ebg4nMtupeapWSgA	1161	1630	1630	1616232600000
2208	3NLNC8EFCn5TUvLQYC4F7agmJeEpjsnvRJjoJw5vForQYNNomg1n	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1647	1176	10	1	2163	jxxb65RwThnjv2tEaSJ686ZHU7MmhSrPpq5WBwLoBvfau58zJv7	1162	1632	1632	1616232960000
2211	3NKnwjAA8fbJca19azkyRQM1oSrPszbRPFrEcLYitLaMUGF1s2JD	2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	369	1312	10	1	2166	jxNsDxjHMJ1jAh5GuFAdhywUQ2RtMMq5ei1jS9VZJtEkCvfYvid	1161	1634	1634	1616233320000
2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	1631	794	10	1	2168	jwQfwK5XByVZWqqQuYdJbZCoNghYm1aKTdByBhBooXt9zh4BQSZ	1165	1636	1636	1616233680000
2215	3NK9UPs6LD1Cu3P3zdNbheaXccrrrvKc8VDLpu3688hbo7cTxkDg	2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	1426	1364	10	1	2170	jw6yLPXLobAHdtqrzyri63jCSASsRi4rp6wMSSWQBZDasik327v	1166	1637	1637	1616233860000
2216	3NKJgdVoUrLPBGgE8UxY6REquBNG9k6KTe4c6cGGVv6tQp6UzdHv	2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	43	1310	10	1	2171	jwNqJPm8TNQg6zw1oE5MBQ9bJvtMtGWTGe8SXRMMeEN6sTzRTeN	1165	1638	1638	1616234040000
2218	3NLBpNHhD8kz8KzzPv6hrujsHEHvUsXChqh64YpV5KCc35qagdgh	2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	43	1310	10	1	2173	jwehcs7F4J5qqFgTVLbLZqL7iJ1s76MmRQZmBtfvdekj4P6Z3hR	1167	1638	1638	1616234040000
2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	2218	3NLBpNHhD8kz8KzzPv6hrujsHEHvUsXChqh64YpV5KCc35qagdgh	1458	1197	10	1	2174	jxz73GKpdASyMQgYH2wyLDXDSR9eZ8u8iSrwQmmVCrBiamnKaer	1168	1639	1639	1616234220000
2221	3NKtsQ1k4sRp46W8XMvNTiPc7cHqFcq8WjxcgrudfwsczADUfAif	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1648	1284	10	1	2176	jxRQTeWw84YBvhhGitL65hZV84hujQKTskDGdCHAzZgby1ZTg1e	1169	1640	1640	1616234400000
2225	3NKijJdjMPSPygkjkkxTDwNFdgj9xhmpoCdXKNtmeqdSA9dGcsoq	2224	3NLocL61xH48BrXTfDbq4fiSai4iSREDg1NQGoPxsC3JZh1yb8Ti	1600	1246	10	1	2180	jxtR9U8pfp953DQ5Eri9xAJjCLBnKpaskoSW2TmnBd9R7Uhx3BA	1172	1647	1647	1616235660000
2229	3NKRNc3PsNTC81fuE2xSVrwdddNgUSFi9sgQibRVKCbhwLupRooX	2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	1419	814	10	1	2184	jxNDLRBGm7NrtxhqUTNMqRXsjLwwXjuawHwAPJVUQR9dU58q6Rs	1175	1650	1650	1616236200000
2232	3NLpLBGNKRadqH8saMdukzAQEHtEcxDi8DM5tzfh3gYSLH3EDCoi	2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	1406	1393	10	1	2187	jw6en121bZ71TPWQTptU2SoEic3HAZ6REck8gGmXdiBFtLPc7c2	1177	1652	1652	1616236560000
2237	3NLUn5w1Mo7Y8UViwbRQtne88bJn3caoK8hDoJFQNxvta2E3BYZw	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1403	780	10	1	2192	jwbtBrFK38N79oaP3A2YFEQKAriFPzTBUDFCyjJq9HhLLEH9Zmq	1179	1654	1654	1616236920000
2241	3NKy5dzBN33pxRky3vxqeA4CcDmz4hThxVkjxQ2ftxpScVry5f3i	1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	554	554	5	1	2196	jxTsauboK7xbWhpGtz466Dpf5cXTnq1gJ2kFvVzQcgUcZHVuybj	974	1658	1658	1616237640000
2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	1407	1395	10	1	2198	jwArGy8xYgX1p3HEDN6ksMtTb4sADAGdDURG7miDyZVgqZ52iR2	1182	1659	1659	1616237820000
2244	3NLdE3rd6NpjfC6g1x6Wx4dnkeifuq1Nxk6uDr7NjsTk4oz12zzt	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1542	1304	10	1	2199	jxSA13Xyh75uviPAgq3w1XGa4eHjptoGwD1KRSCpbtNxRboT8sT	1183	1660	1660	1616238000000
2252	3NLZgD6WMBLFYVSGZMYzhwhGkecoWcLQwkHn7dBNzrv4r1KWGeen	2186	3NLhiUdtnfPRN2qAqZJVfojrdG42Y4fj5oy7sTxpBVvaR9qUuhoj	1643	933	5	1	2206	jxpjH1kdvr9mivFwvDkNprzpm1MmgEhjF8MPUq5PT2YvcmWwksp	973	1662	1662	1616238360000
2254	3NLcWXkZUAFP7i37qnLu7DmaKUTWqfWjzBqXYmvcENHcBikkskPx	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1426	1118	10	1	2207	jy2MEHtb5cnaRiYsvbB1NXhXm61PMPXg71AWSB7TYC6jJ62GrnH	1184	1662	1662	1616238360000
2259	3NKoG934G9AHdpqP4gMpdLnDx2BDh4qoSbUKn84kGRUB1Zo85QW2	2257	3NLwZeBnUNU1PEDa6bqTffKkG1FKRs5dS9NZ1h76xt3dPNZhW6FP	1675	1096	11	1	2212	jxrV3XCJKEK6Y7yuGHKwKyC5CKp7WwZyF9poFD4HMEF2dkiLCth	1186	1666	1666	1616239080000
2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1508	1387	11	1	2219	jwdeumoS2auWQw2hJCoZhNNe5VNUTRWens4wevVnhweBsL1URcG	1189	1672	1672	1616240160000
2268	3NKqEYukJcpX5EV6X5JadAuAGKYmv8Dehhievoo56WqD8BKhKFup	2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	606	1169	11	1	2221	jw9cQRTAwjnnfZ3RBDa8ikX2Jo31esZo2rrKfBxbpCUWHxhbe17	1190	1673	1673	1616240340000
2273	3NLBevui3G93viA3S8mymrFfmXYqBcLsriV2renzY6fdwy1qYSaw	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1501	1114	11	1	2226	jwY1FE2XopvarqcG5KZSHmQpBFaY7wcure6Vkb8PhUuU7pfdg7D	1193	1676	1676	1616240880000
2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	1610	1314	11	1	2229	jxtwcaCeokw9wY9THhHAMPZqdE78MFnQrJibHmj1fhQgGtTMrzM	1194	1677	1677	1616241060000
2283	3NLMxeq1SJ8ApoUTCkbsuGKcmFPeSS7SP5zEsgEnirHu9F9bjCyG	2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	311	1307	11	1	2235	jwv1dsqF9eRM5sp8vE8B58oaV2qUiDeLgRBMbER4UdMHKnkBGU9	1197	1681	1681	1616241780000
2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	2285	3NLCc9MUcDZktdoAcMxpKC1LCvCHhQWx7ht4DCoTPFw45FbozWYS	1406	1393	11	1	2237	jwy4uj5DwkKWwiEdUbs2ncSnQVr6Rgmo2sAiVbGCjMgYyitnis8	1199	1683	1683	1616242140000
2288	3NKsJsNcxFsGsWQfbrRPugPBXLqaZbop1gW1G7C5gDwsFaoiNUfu	2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	1455	966	11	1	2239	jx7av9pP1yEgHAEhuHgjWNJNPjsRTi3Pg2ZmcyuaQHnfkn3QPET	1200	1684	1684	1616242320000
2289	3NLccPT2fspG64AvqRduhh9YnCRtYCRDTKi28NdYtZwvx2D6B8QQ	2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	1407	1395	11	1	2240	jw9tRbdsnM3n7ZeiFCEXrtiwak8aZ32kv52gLCGsZGKFTuhDTPT	1201	1685	1685	1616242500000
2292	3NKttgbqfxiTStub71D5Fsuy4cWUXyXny24v6L2rYzvehcARhBMJ	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1460	1324	11	1	2243	jw8t7UQakmV33QAvTXw6n6RtTChx4WNYapB7ydzttprfvt3RQDQ	1203	1689	1689	1616243220000
2295	3NLbtWJqardpeBAT5JEgFUWtBKs9kWs9ZPMo5GLvRd5zCtqopd4Z	2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	576	1229	11	1	2246	jx2vGApe6JR9YhXFNeEz5kMYuK4xptPGE1FaCpcjDpJCCApWL1z	1204	1691	1691	1616243580000
2209	3NKQ13KxonaamAd8FNWqWrfPcQSUYngpbYTLtQ42xn4Ma3z54nH2	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1516	1294	10	1	2164	jxWHEMwHTQRh7fWSwtEhnzCi6xD1NKdDxH4PZmHxkdfcSFzkuR4	1162	1632	1632	1616232960000
2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	2210	3NKwrwn6uNKEo8ucTGJ4xeNwfzEkJwmgoa66zcvLsCENx4TmLeaZ	1618	527	10	1	2167	jx4SvT4vCg4A6w23dXAZZ28o6ecvCCuK11WvdAQE72A1wrAMz3n	1164	1635	1635	1616233500000
2217	3NLsom31H7SA3VTdi5anHWycYQWi28a9DtkxyVFhHXaA8ceC2w98	2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	1471	1386	10	1	2172	jwoCNKvT8JQofy6bWcQpo9KNw4gG1j3c4VHurfsu6YPjR3CKuJB	1167	1638	1638	1616234040000
2222	3NKF2t5mdRdBfP3UnkraenH82qMDUNNqDKCC13vxKeoZkUMdJNMr	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1403	824	10	1	2177	jwBj5KW5VPy7Bn8ohbvoLyZpvzvTAGC9tEMS6reRhrvtjAky7UP	1169	1640	1640	1616234400000
2224	3NLocL61xH48BrXTfDbq4fiSai4iSREDg1NQGoPxsC3JZh1yb8Ti	2223	3NKu1dAVX9sFMoc3PhwMDPc6M611uZs7L3936cS4myxxKGHb9zW7	1581	778	10	1	2179	jwQ3RWh6ARJZ1Tvsp8QwGo9mv98McbPj92s9emuEQyTAPRSPdR1	1171	1645	1645	1616235300000
2227	3NKPWy3vDozYm1XapmuxjLhMa27BsnU7isZ872hgwhC9PsRbRFrh	2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	369	1312	10	1	2182	jxfaJq4QsUtenKqxvDaEH5AKEyaHxZrcP6x4P6zHoTaQ83U9QrE	1174	1649	1649	1616236020000
2230	3NKMtRHcP3WDFmpeeYhm8zTHUCPcD8PrrX25BqUTQxqAMoWZfUgH	2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	1513	1379	10	1	2185	jwPr7HTVdy3rYNg3j9B4eHtfdBNku865uqBb5pnb8hjdhhSm2uz	1175	1650	1650	1616236200000
2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	1607	982	10	1	2190	jwUXuEEZJdzy3RThkcCwStKoi5BWYdfKCnnS6MyHChXf23XRk1t	1178	1653	1653	1616236740000
2236	3NK7PhhXj1PFHXAN2WnbiuVbhQmQLTrzQeipEPjEvU84qyNbfgXT	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1608	1163	10	1	2191	jxw9kxMwjAGQHVywPt3FZxFd1sv2eTL9QzZZRnEghFuvaSy7pHZ	1179	1654	1654	1616236920000
2239	3NKQjW2wDnYaoL5WxYrq1cqdoA9hDFLRDsWrcvZhMXSrahthcXQY	2237	3NLUn5w1Mo7Y8UViwbRQtne88bJn3caoK8hDoJFQNxvta2E3BYZw	1444	1135	10	1	2194	jwuocwKJ1REJvSfTVbWNy47qejQLnQEHzP5eLhFX56fZHU31SQr	1180	1656	1656	1616237280000
2242	3NKHtepzcQfatseLyeSC2aPJVazKFjNmoJcdMh3f2H28ezKF1y36	2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	1406	1393	10	1	2197	jxaBtUEvJeRG5mV1P66bvUGXNT1vub8w1YmUV6rpmCL4JFnPFSo	1182	1659	1659	1616237820000
2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	386	386	10	1	2201	jwUXvtspmR4AWVgKmbDoRsnCs37YtnZAK6bZ1tVdCoTjA2JgErN	1183	1660	1660	1616238000000
2248	3NLnNcLMjCmRNsJ2HXhexNuLsrGmnjKei3NvRZjFWuR6wwB52s75	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1553	776	10	1	2203	jxrD1KNta72cC6YLvW4uDNxQmai4SyLBZfSEYM1b7Z8k7Rxqsy8	1183	1660	1660	1616238000000
2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1507	1034	11	1	2205	jx31ji5VdT35ZdPFosSmi1ry6gnLd8xuNebibMhe7JXib2wJt9X	1184	1662	1662	1616238360000
2256	3NLfgteaeuYdEr78BebRRSd6ym6GJGZMf9JzDFPDLe6CT3fkiTcn	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1643	933	11	1	2209	jxC4BuG3UsJVMicYpHbMiBHyniRQvYGC1EwQX4umey6ZQMPCbnF	1184	1662	1662	1616238360000
2257	3NLwZeBnUNU1PEDa6bqTffKkG1FKRs5dS9NZ1h76xt3dPNZhW6FP	2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	1627	1385	11	1	2210	jwogSykwD2B3z3qaAYASCEBKc6ELKGAnUZsan7KYcHB19htNFW5	1185	1663	1663	1616238540000
2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	2259	3NKoG934G9AHdpqP4gMpdLnDx2BDh4qoSbUKn84kGRUB1Zo85QW2	1419	139	11	1	2213	jwtWo9eVoLZqxoCfQfFwyqEpgiwiQKK2gAVpK5Y2xtavcE97WW1	1187	1667	1667	1616239260000
2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	1521	233	11	1	2215	jxdTift9PJVgJSDKBNMJ41u2P5F7CNS6WX6igd4o4rwsFWf3ZNG	1188	1670	1670	1616239800000
2265	3NL3oKLDiccBdPg4CeceNDQXEGifMpzSNC48mGBbnW6tKtCbRsWp	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1406	1393	11	1	2218	jw8KGMbKh6M8HsaAebRk5AWbEyVfnvkzEj5rHJHEDH25LhEYu5n	1189	1672	1672	1616240160000
2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	2268	3NKqEYukJcpX5EV6X5JadAuAGKYmv8Dehhievoo56WqD8BKhKFup	1600	1372	11	1	2222	jxSTQNoyUpCtkSwCkPG8T6mLX3LYHqUcoTWkzhyQJP8y4E9cgdS	1191	1674	1674	1616240520000
2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	1403	824	11	1	2224	jw6gcSnWnmTGZZh4uuojJWnLJBZN2NLFXz27xEy9KGH6fPbbX4S	1192	1675	1675	1616240700000
2272	3NLwaRJhwpyGqvg2cd3aDi6ZgK3dxj5rvsvvfhrPoyyadApCL6N4	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1577	1327	11	1	2225	jx7KeY4Z2uhnUwaFNP95LDRNocX8KriaLDWdm6ewwoMnAktvtPx	1193	1676	1676	1616240880000
2275	3NK971rc9eGs99nKmAajtvL17wFewMMKJ3REUSVycG7SqB2zWDMy	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1470	542	11	1	2228	jxP22oqoT3LG7Kb1jY4aprSyDTmV6MUMdTDGNLmX5NV3s4m4NeZ	1193	1676	1676	1616240880000
2280	3NLaZ85bsR7YEdyPASMgjiNpCAqjCVyaGYKDEMBfnUiATaW2Mji5	2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	1506	1373	11	1	2232	jwbB9RrDeTJXHwdAL1sMnqchBim4U5U5WRj473y2KQYx5gW8Jhv	1195	1678	1678	1616241240000
2281	3NKr2wgQqCgiL9MwtSKFkhyF4bL35h2gxfBWb65h37367ci8sn1b	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1555	981	6	1	2233	jwwdq9vJpvBDitBV2FVi1cD3vQnethty1SzUY7V4GkEWjZ7Zg64	1016	1679	1679	1616241420000
2284	3NK5w1JADvZiNQ3ZhNoRdWCvGsaPQN2E1nzDW3WxSZEDGEq9gCDf	2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	311	1307	11	1	2235	jxkXHdvqbzrPNRPMSEUF9M4TGL6qCShCgEtSNTDS1gpU2NJAE9T	1197	1681	1681	1616241780000
2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	1608	1163	11	1	2238	jwrC2aep2VAfiYRz6TX4Mt1z1rnUkU4MLedtZj4Ew7uFKLVistJ	1200	1684	1684	1616242320000
2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1553	776	11	1	2245	jx5enTqGEabEHhjqwh2v5DHg6gU8eaDRk3SzTs5XmfPeicuVqVX	1203	1689	1689	1616243220000
2301	3NKQNc5qKvp1NbScMWUNmxU47QWkVwnFJyqTs5EFKJ59FQS2Ns3S	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1546	1339	8	1	2252	jx2qGFtARgscgqDsX6baMQHJ83uWaQtvp1kcrEJkbHzVmDMcMGv	1082	1693	1693	1616243940000
2302	3NL7JbVXyHz6ueLcZJ1wQmtb6Qn93PBZ8CsfWAMszwH9Zf9PwAdL	2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	1647	846	11	1	2253	jwVk4WGfcV6XwUYGCkevkNmZheMnPi866jvsoyJLyvSA3mGTiac	1207	1694	1694	1616244120000
2305	3NLpTHZ7NXyyP3sdZWLyJnaBrxTxaj4CceVQJKq8Pb2jrRoQde7X	2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	1668	1370	8	1	2256	jxWGRVV81ZYDu8ZoGF71jWzVXEdFC4fryt8R9hpv88wzDhJ9P25	1083	1696	1696	1616244480000
2307	3NLXTPneJ19mvstQ6NtDNrx6hjiFnmQVUy7PKVVjRr3ZFtdGNgiD	2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	1668	1370	8	1	2258	jwZQ1KxZFDJVzdT34Qtx6S5rj7jeAzAkVf9JbVL6DqLoZsPJgJa	1094	1696	1696	1616244518725
2278	3NLJA3HXDgn6K7b8PDNsxKDx9mjzuzEp9Vxq5TVbZ77uRdr5EFyo	2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	1402	874	11	1	2230	jwuq4JVhjkrwyxdoqYNJiCcCVUFibfDgqxAKADNuupJrCvsTGz6	1194	1677	1677	1616241060000
2279	3NKBrSJxmvvRgR2akaUpn5975EV1oAf8Rc2ovyAujgAp51yi89uM	2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	1522	1322	11	1	2231	jx127wRHkkwtoSRJH3X6g8wG1PueZwc2CV7ntzfnsEDyXZDE4uQ	1195	1678	1678	1616241240000
2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	2280	3NLaZ85bsR7YEdyPASMgjiNpCAqjCVyaGYKDEMBfnUiATaW2Mji5	1631	794	11	1	2234	jxpRbwPU5TRtj764uw1TA4m2fNpJANUDcBx7e2UcC5kvAjh6ypG	1196	1680	1680	1616241600000
2285	3NLCc9MUcDZktdoAcMxpKC1LCvCHhQWx7ht4DCoTPFw45FbozWYS	2284	3NK5w1JADvZiNQ3ZhNoRdWCvGsaPQN2E1nzDW3WxSZEDGEq9gCDf	1406	1393	11	1	2236	jx4etXrp9mBaNuXULXnJknkHWAnooAux217XubcprsAs7spgMwR	1198	1682	1682	1616241960000
2290	3NLK4d5yK1wHBKjjZNTLRk8TtRkH8KEZYBWBLqEk8Ciykr87hkJQ	2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	1553	776	11	1	2241	jwSCPqwYYa4ypSq8s1EADbqxpALt4vxfGMpVBCRH2WzM4PfBXz2	1201	1685	1685	1616242500000
2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	2290	3NLK4d5yK1wHBKjjZNTLRk8TtRkH8KEZYBWBLqEk8Ciykr87hkJQ	58	1281	11	1	2242	jwxrhMyihfhpK37VeU2LFN2UThZPToxBmS12U5r77rydVYdo7Xo	1202	1686	1686	1616242680000
2293	3NKHxVvhYq7YhxVWHcN4BXJKcQr4Z7xmmCi6SpohFdJszX8b79P9	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1406	1393	11	1	2244	jx2xuQkfR8tZpXhDSdjebU3zcdP22v9WMk4fvNxbCKhZMCC38qu	1203	1689	1689	1616243220000
2296	3NLuPVxzAb6ZG65gki1Q3fFHSgso7Qf3CLAhRHS3n4VYFXXr4DTY	2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	1407	1395	11	1	2247	jwqcSzjXY1zpvocVpkCAoDvttQg6CMaRyPR17w6FkV4bw1WRXJb	1204	1691	1691	1616243580000
2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	2296	3NLuPVxzAb6ZG65gki1Q3fFHSgso7Qf3CLAhRHS3n4VYFXXr4DTY	1578	1296	11	1	2248	jwWsMm5jWuBKjQ3XbaGmv76MXhEJZYfpC3jNYHcgHZNvjG7GTtt	1205	1692	1692	1616243760000
2299	3NKTzgHp7dtPuLXZbTAFPk7CVvBiPnXWzGTsBFBJhvoFhHw3BZvr	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1546	1339	11	1	2250	jwzJVw3HQP7FUcyDhSNKWtuTXTa9nqH97oNmqiYWKA6zH4VEs2h	1206	1693	1693	1616243940000
2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	1668	1370	11	1	2257	jwh7XW52eYM6gnGPbzcKzFV9fjey6ESXLr5LJD9HqjhNqej6Luz	1209	1696	1696	1616244480000
2309	3NKzLmoYVrKpzwWKQQ9PjfsyJPBSUibjip8UX2wt7vcThhMQYL7e	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1668	1370	8	1	2260	jxWXJVCxGyMEJT2tDqwm6hMt65pMrkMC2CNydLRvXnSGLUNuS1g	1106	1696	1696	1616244558759
2313	3NLfDhWHemrFCiVDUWCxxbWhsgK7o7FwWkydCyqBtmMxMocB1NKa	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	596	1306	11	1	2264	jwt9ry4hsAL3s8D1QByRa1e3sQEfosWm6SQ9LCTsYFDtVDhHRaa	1203	1699	1699	1616245020000
2318	3NKA1uVoH3ZjmdtbShcSZsZnhSh5wPCJjrmC3Pwuv1CpdncucMtX	1868	3NKKGVvksGswb68TsYad7c2oJXkij4HrXq2UEX8NQRu7f2WMpQq2	1622	1230	4	1	2269	jxu4jReDr14Vh7eUxYrzen3GW8AV9dFgDDq3JvvU3XnpzQxRaeT	936	1705	1705	1616246100000
2319	3NLKZJZNrWKCycF42nM752oLu41yNmw1xAcVUEgedUrc7TxknQLd	2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	1622	1230	11	1	2270	jwDyYnFTaK8KE4XRd9ej1aDBo7v34Yt5SFPgN6CarrVbpsPBQu1	1214	1705	1705	1616246100000
2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	2324	3NKJhgqNgxRsUUyFXzDGofGq51QczwFQWzpsFnZuARKzUY7VUXFz	1419	814	11	1	2276	jxVjhoL6aPhRXqPhxocy12BvtP7zPNaQN2YtTpF8u3MYPM8SR3M	1218	1709	1709	1616246820000
2327	3NLqzFU7uxhTF7gADoieU2rjE343QF4yM86EjGKNXg8WVyt1eiJ4	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1668	1124	11	1	2278	jwESG8HStcj91QD3iiUDSPtCrqgdwrSnNt3BQbxRUkrNA59rEq6	1219	1711	1711	1616247180000
2298	3NK6sN7Ym3KHgrgEHwJmG9GBNf9eVeeTrfG8bCbW4jrepj3KRC7R	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1483	1150	11	1	2249	jws2LPd4SNVqSXVUnzBQ2MN2ZGygf1zXrgmU7ozVHmELPzpHAt1	1206	1693	1693	1616243940000
2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1670	1036	11	1	2251	jwrF9B4zj2Q6vGdKdJtmTG54V2EFsCf2N57GkZxavmMp42pcock	1206	1693	1693	1616243940000
2303	3NKjM54fZPSk5PrL8YQfUoZvXivY7No1ui3Dn6zo2MYStRJ4HrHp	2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	1672	1285	11	1	2254	jxXmKXPS9VgUFjSjjGyeTq1Rz4MTU63FaYFW91PmZaHsmbKVTZx	1207	1694	1694	1616244120000
2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	2303	3NKjM54fZPSk5PrL8YQfUoZvXivY7No1ui3Dn6zo2MYStRJ4HrHp	1503	1151	11	1	2255	jxUcZbLFo9PHA2oYaAFJUCLzVsJ9eLQqnSfF81KgtDSQMfKmTw2	1208	1695	1695	1616244300000
2308	3NKWXo9HihwiJkJLnrATMTqjL7FsAgy6skU7zrYfanDxnHU56ddq	2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	1403	824	11	1	2259	jxvRzNsvqxn8ufkgFVM4HxMJu51p7E8vwwZmHtAmLjKfx12U5Wg	1209	1696	1696	1616244480000
2310	3NKu3LR1JgB9RWEDWt8dgQvj6WbLuCjGJKXpFEGQnNnjteASFe76	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1668	1370	9	1	2261	jxAJpCFP8yPzkgfCttLjHeL5ifoTuGhEAEq4ft577ssjnhiRNF8	1118	1696	1696	1616244596821
2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	1596	1363	11	1	2263	jxcHeARgatpnorQMxFv2TmYYZDuE4VTEVeczko61trwAfqPfxJA	1210	1699	1699	1616245020000
2315	3NL9ZxvgMSPoGKEiGaUEadGsjUV78QRjk57bpWc5hDr3STSbC67g	2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	1402	868	11	1	2266	jxUqKnivWiZiShU1y3QxMg9KLEHX57gJD2R7HLsGzrwrDpHaGmM	1211	1700	1700	1616245200000
2316	3NLYomCQswhWDmb2Fi6p3UoSFtoZjNqDzeM5Gt7z3NQy7TiC6y1k	2315	3NL9ZxvgMSPoGKEiGaUEadGsjUV78QRjk57bpWc5hDr3STSbC67g	1403	823	11	1	2267	jwi12rGh9myJBZGZxGz3GLqQ9mZgRSXdihzk4JFeBxCM8uBMNa6	1212	1702	1702	1616245560000
2322	3NLVFHFw5rju14AgqZ6cqBnW9g1Gwa9vPEbcS6yKwH2QnTD4BBg3	2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	1406	1393	11	1	2273	jxcp4qLyiVMxXbXoQ76L6dXD65QfsVPnuDbGid75W9Hrpz5hUzq	1215	1706	1706	1616246280000
2323	3NKSwDZa7Fr5ByXjurpoKV1L4nyTkZuqcuZKANSFP91SEAWYmuV6	2322	3NLVFHFw5rju14AgqZ6cqBnW9g1Gwa9vPEbcS6yKwH2QnTD4BBg3	1457	1391	11	1	2274	jxnS7rMKVRt2Lc1WLhdJoKqzFvMwuzdukry3zZKJvfNvavgRqWq	1216	1707	1707	1616246460000
2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1407	1395	11	1	2277	jxaV3TLTsytdHtB5rtKwih7tB4hUVdoVxWapTbhRjn5fTezpkWu	1219	1711	1711	1616247180000
2329	3NLm5zRHhDw9D7RPg56LF4B9BRb42yd1sCCWESeTx9xZpdaFr2he	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1553	776	11	1	2280	jx47YZfKvnysswHE4N3aVnvAbb8UJAbqhiMFsiuA4UgVxfGJGa6	1219	1711	1711	1616247180000
2311	3NLSi594KBrysRXnMwnhA49wbfJnGi3HeXxR81ditmSrUjYas86F	2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	596	1306	11	1	2262	jxe7oPKNLdnJjXRR1qaGNYA1zYs9B9x8rMzYsfS1nQBAbTht6QX	1210	1699	1699	1616245020000
2314	3NLpM5Cr4mejriHLW4Z7VUjVa6WJ4yyJoYaEBtrwHbxn28mV5RdR	2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	1503	911	11	1	2265	jxatCJ69VP5Fg5h2YkE59MejA7LUQJ5ozXrBCQgjTHJBtkSKSoR	1211	1700	1700	1616245200000
2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	2316	3NLYomCQswhWDmb2Fi6p3UoSFtoZjNqDzeM5Gt7z3NQy7TiC6y1k	58	1281	11	1	2268	jxJBp5dfTNnMwYv1koMgNPmsCckD5wTJk1oTHXreXxWw1P8LcEM	1213	1704	1704	1616245920000
2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	1553	775	11	1	2271	jxSgdSUTz6JejELBTyU4DSTPzjjPJgx611kc27npXQNKmYjM4EL	1214	1705	1705	1616246100000
2321	3NK43ee97c7SRCW5czvmw9vTweVrpVfqZzuJTvnHLasFjoM9Egnb	2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	42	1361	11	1	2272	jwDAKnfcPW4Dzz2Qm6caJQ4BR7gYTaCX8TXDYvcfpjKtqws5nQS	1215	1706	1706	1616246280000
2324	3NKJhgqNgxRsUUyFXzDGofGq51QczwFQWzpsFnZuARKzUY7VUXFz	2323	3NKSwDZa7Fr5ByXjurpoKV1L4nyTkZuqcuZKANSFP91SEAWYmuV6	1406	1393	11	1	2275	jxGGvoqKhYRfzi8ahFFNnpyEww3xZkmFKsbMd7xC6G6XZwf3UU4	1217	1708	1708	1616246640000
2328	3NLKMcuhbs71GSHXMcdjijrKPeEGtEvaD7mJNNwGVpmA5m5oLAY1	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1619	909	11	1	2279	jwPUmkRWjBsyBkbgmH36F9LKeRB6tWgoJYLGRKdmFyiV9GiwZDk	1219	1711	1711	1616247180000
2330	3NLbT51frYuvbDrphpSFrTakParBLMFkNfW757pPpGGWzGSBLwH7	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jwkuV7198YcfXbbCy2GFN9H2jA2uLxZNtjwLZ46LDTf8Kkyx6Ld	1220	1714	1714	1616247720000
2331	3NKp3TAkeqy8EefTydGsVLpa7B8q9cX4T55ZGwouZ2CrmFXBn4RR	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jxyRsRVjdXAPas49oBrLZktBFpM7xhrh95puSH6QruwHjgDJhXV	1220	1714	1714	1616247720000
2332	3NLXBNjNBjQjuzTzZM5K5TinwGLZoVva1RWPvGhzZmCBbMd7YncX	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1407	1395	11	1	2282	jxAwLknAwkqijnGSVj8CzkQMvukSN6v452sq1QRGwaVMWYCX7yn	1220	1714	1714	1616247720000
2333	3NKpJrC4jDGN5sE5xsJTraGRsQbRbDpTiYwFeYejVcesdK2zmEin	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jxWemhbhMxjH6uNc1m4PgrgruQLrzpTpB6TqymaVFDowDgLzuYW	1220	1714	1714	1616247720000
2334	3NKtKDZzb6XVp4nsvHNrsD3FCqi8r1RwRLQHfj4wcAQtGDKZ9Bfp	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1419	814	11	1	2283	jwbxQitZ912krF6vXnva1Jgwmu6Dr7GqCoQKFL4eY3jgG9jpxRa	1220	1714	1714	1616247720000
2335	3NLLM73chi5ppyzpatzanrgbA7whMkDLu93jcuZ4MTenC99yLzvH	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1633	1390	11	1	2284	jxkt1LJPvtgBTnfuHWPnkYxGRn7GgvGin3QpP9GKRdKd7Aq3juo	1220	1714	1714	1616247720000
2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	2330	3NLbT51frYuvbDrphpSFrTakParBLMFkNfW757pPpGGWzGSBLwH7	1403	824	11	1	2285	jxUY8ZpZf9eNHnGSjVjhgJ9g3jViS23WKhoQ1rk8cpVAAWNaCWo	1221	1715	1715	1616247900000
2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	1405	851	11	1	2286	jxqu2DksmzbxpsgZrAdBTeK2UKRuoWCDL92wND3KXEVgx4GhZH6	1222	1716	1716	1616248080000
2338	3NL2RH22nbsefvHGNZWEpftkHsvHyt8eqgLpu4oYbncUpFGPJ7BN	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	633	1384	12	1	2287	jxzd7LFzi2TxoPEcdGCUbDbbKd9rLfpfieSdamW4UT11pCtC8P9	1222	1716	1716	1616248080000
2339	3NLbpwhYpcnXnprZLiyE5dNfuN53DL5PjkRchf31E2B5WCB85aKJ	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	633	1384	12	1	2287	jwwMnforTjQUx8WGSGvfy7iuhduExMvi9s4JGaUTnbYNGbDMpuk	1222	1716	1716	1616248080000
2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	1578	1050	12	1	2288	jxBnmHxuYFCRYkW6dWhmDbjES49zqYedGJdWM7RaxSzS3xNArFn	1223	1718	1718	1616248440000
2341	3NLsfN7MnHkkBeDpN9RKxYdQaFqfGxDPA69phNXrHdCFhbbCAiR5	2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	1578	1050	11	1	2288	jxBnmHxuYFCRYkW6dWhmDbjES49zqYedGJdWM7RaxSzS3xNArFn	1223	1718	1718	1616248440000
2342	3NKtc9p9hGV7j5wfRQA8PPGk3mURqxtheWeAuHHjxqnkddhLJAJy	2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	337	337	12	1	2289	jxc6xMXSUYk2hMAGQw9eDRzgNf82ee61ZHRNpjDjrWds7FeXrRA	1224	1720	1720	1616248800000
2343	3NLCHxUrWiptLTNQL1PpNQodUhNwwBBBXJFNjSifaaZzqQnhdBK1	2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	1513	1379	12	1	2290	jwhwvbujFqRknF8XQCPi9oaLsJeBAbi4vhAWFrNgLcd5t3o7fWa	1224	1720	1720	1616248800000
2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	2342	3NKtc9p9hGV7j5wfRQA8PPGk3mURqxtheWeAuHHjxqnkddhLJAJy	1403	782	12	1	2291	jy2GUg1Jv9G5S64QRgxUm11r4SG24fJ6sa8APTBUc5Lcxm3oh5T	1225	1723	1723	1616249340000
2345	3NKKZnnihvQmt9bE1PX15D3m32fTz2hT8jptNZFpi6YQfNNEW7H4	2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	448	1305	12	1	2292	jx4pUmzJ9DDALrEvJKk9VAMjXDWh9THvLnBXfRoQD9K6iGzV7m5	1226	1724	1724	1616249520000
2346	3NKPcqMXHRNKi3pCihFZ8o14XdsjdyDuSdA2iP5hb7orai1ohmTY	2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	1560	1165	12	1	2293	jxAgKUxB3gDgYB3AV1sYhEGfUKEgPy3PEQ82RhU6oH5fSSK9a3V	1226	1724	1724	1616249520000
2347	3NKXFhWCDXoQTbXjbHadgBi1y9pYbB5cm3FYD61tGRCGv89xEo94	2345	3NKKZnnihvQmt9bE1PX15D3m32fTz2hT8jptNZFpi6YQfNNEW7H4	1670	1036	12	1	2294	jxoFf8fkeCbutGFg3c8V7BM9toz1wcqWVdX1mtyAHTyBJronWxr	1227	1725	1725	1616249700000
2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	2347	3NKXFhWCDXoQTbXjbHadgBi1y9pYbB5cm3FYD61tGRCGv89xEo94	1489	1380	12	1	2295	jwWAWzuhW5kWpWXUVFwtVZdz38vhzauxn64DgwZ3miC9w8RTUxk	1228	1726	1726	1616249880000
2349	3NL63pX2kKi4pezYnm6MPjsDK9VSvJ1XFiUaed9vxPEa5PuWPLeZ	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	1405	867	12	1	2296	jxDVQTPMRvwUE94shJoo2Li5qj8et4x9zeTAgHRv9sKyAAWkSpj	1229	1728	1728	1616250240000
2350	3NLgw6854WzMpf5x1FCkpn8U6Xob97nkUDKt6GzWP5SUiQcVk49a	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	448	1179	12	1	2297	jxj27ksY5YrbbiGfeMqNEfcBWTWEzKm8fEuS5xGpZYXBJxWBSTm	1229	1728	1728	1616250240000
2351	3NKTMAh1ePdfDQW42VJvMarHMH82Yvsu3d7X4hAydoc4B2S4nR7Y	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	44	1325	12	1	2298	jxYshNAqg9LKJVYpr4xZR82DYPgnt9RuRJS9yLpavWXeP7AtoYx	1229	1728	1728	1616250240000
2352	3NLU6jZai3xytD6PkpdKNFTYjfYSsEWoksr9AmufqYbxJN2Mpuke	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	1440	1377	12	1	2299	jx22Hbd1yhYmaz3UhtRZEB9MDxbP7uJG9Y2oMUJkbcvXojtUqSs	1229	1728	1728	1616250240000
2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	2349	3NL63pX2kKi4pezYnm6MPjsDK9VSvJ1XFiUaed9vxPEa5PuWPLeZ	633	1384	12	1	2300	jxxmhG3gRiQ6umwZw8CSDdNWisGqore5BsrjUhq2gYeBXsNULDy	1230	1729	1729	1616250420000
2354	3NKn5pDUC96GJykFJifGaWNnAucVw114iadHJGKWvPPM9bGZ353g	2261	3NLsXes7FScPCyZG7rCjBfn48yeLAR37yNXsBM7cNctrWrcBPjHd	1643	1173	5	1	2301	jwQ3MMAFUtmPFmhrXT8iQ25wUpWyRZar1teYXVxS1mHHKcTY9AW	975	1731	1731	1616250780000
2355	3NLN2uxCoRsiB2C4uZHDcY6WxJDz6EEWmoruCFva74E4cgTYgJCQ	2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	1445	1044	12	1	2302	jxjTmcrTjmqGWg3aCEEu6KfU4DMGXs5FUFrtmy5mBxwdhDytXc7	1231	1731	1731	1616250780000
2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	2357	3NK86abekKmd1YqdWxKVLUgCpozLecksYDWpmHEXfqXoQxz8Xkig	484	1073	12	1	2305	jwCVcccvEQzv8fBeb5pa9eqpZXqBPyfYT5xniN6Wb74m5HpvcpJ	1233	1733	1733	1616251140000
2360	3NLZK97Jn2h2eZ8tMXdYF7YL4RdNCR6qg9qnd3kWV5Kj7d3SPHBG	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	1406	1393	12	1	2307	jxPZJWWnbW3umhGEdJbkHBHoUF93q6bnvELu1Z2FaREXCUjACgu	1234	1734	1734	1616251320000
2361	3NKUoCo6rbrr7ehvvsaEFca2xi66ZuVWtzgnFJpB5KBko3i4tMge	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	441	441	12	1	2308	jxPKyjoT8kbiH1nMJjgAvEa5sXPNWZazfwjfTj3f2e9fmzptcFV	1234	1734	1734	1616251320000
2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	1553	776	12	1	2313	jwRqp5zTDuchVJDASK8ZVbhV496JfHPqvPQxVe4XECWSL2gqBNL	1236	1737	1737	1616251860000
2367	3NLkDbui2U3u1vHMyztWPAuzMXiiADfaoM3rTqVQCNbNrbaBc5qb	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1405	849	12	1	2314	jw7bmg1EitkGx8fkxLKVjZ33NwwDWqYH2GKsTYjW9CsQqFrnsh9	1237	1738	1738	1616252040000
2369	3NKehaXcNfPoFA62epxxGbwnjisABcW5D54NAeQEbWyaQaaDaPxj	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1579	1389	12	1	2316	jxAtk9fUBSoaK4jGC2HvPDna5hZ7TEEYnEremQLERWRdLNoudya	1237	1738	1738	1616252040000
2370	3NKRGXqsifh1tbRV1wRknpJbYLhXJihKpxwNF3RtdFSN1PuiXPab	2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	1553	776	12	1	2317	jwW5eUGaAw1AKPDXS4Mq4hxk26WAzY1Qaxb5yCgXABf7pn4h6bq	1238	1740	1740	1616252400000
2373	3NK6RY1ekrfEmmrcJyQazhXrJvNJjuTS4VPQZGUGK3xEPaoHQPKY	2372	3NKwKYGxLZhgYVnHW3tLcrTmXMXWsc3YvBFhib7QZCgXH8BxoZZa	1403	786	12	1	2320	jx5MRuERNnr1TusN8hS53PDQPt7Ctyv7mpjSo71jib4ZR3eZJsv	1240	1742	1742	1616252760000
2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	2378	3NKP6MrKzzDyUuH5XGx5VtxpkRkXvLQzf4zj8qqYeZsQ6Sp5ky3D	1587	1231	12	1	2326	jwR1Q1TE2EFQ9D3rVCpdEJ49WMEtg3K5fyTVFHmceWkxtaHknxS	1245	1747	1747	1616253660000
2381	3NLDeV1DXXeQ4JkwmcpmDRVXfhFTUejvj2BBbT3nmoV4rHtPMsuS	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1546	973	12	1	2328	jw9p6QPLC77VmMXSJWQLHbK5oXbh4ytJarsd1XKGtpmmjicqzSJ	1246	1748	1748	1616253840000
2385	3NKDJJFfAsLm3WySnMATb3DZ2KX3vruh4ewvk7VJkNvyma14bHpv	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1536	1313	12	1	2332	jy1sBpfx37fr8oVFs5p2y79po52BqbWVnZq2w89kYs77JMrPC3g	1247	1749	1749	1616254020000
2387	3NLDo9UtwBhWA24AaCxWcKEnmnJDJSEtmc9gg5bA25xiACW1jRvk	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1646	1108	12	1	2334	jw7wEVr2JAYFwiEB8oH8nBqFdp3sDAUHoKwFw33MaVMYp9itjQc	1247	1749	1749	1616254020000
2391	3NKEgw5JmSBUTQtfjMTHWHxwacvNyTtE3DUGgN4DwbFXocgkJYCi	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	1555	1101	12	1	2337	jxQ8ZBeGsLnPLDrbuV2eYVfjoXHMSMd79yhsJg4dsQeL8BCfQ8k	1250	1752	1752	1616254560000
2393	3NLYyUATtG44YrvTF99zyks42QsWVZFN4XhUZRoDfR2cBBNsjA2D	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	606	1295	12	1	2339	jwurprQ2mjnE8QpiHxSCb7PtxTCNn5GA1U865BrUYZGkp5m3MqV	1250	1752	1752	1616254560000
2394	3NLvLfE3Q8mRZQA6qJrJAFxtjVV9bp17n7waw8EHvgB8B7wF2fJF	2391	3NKEgw5JmSBUTQtfjMTHWHxwacvNyTtE3DUGgN4DwbFXocgkJYCi	606	1049	12	1	2340	jwrek1jZmpu6zEJ5dToGyyu9Xyh7RvrUNN1ckBd7YFXhrh8hfvP	1251	1753	1753	1616254740000
2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	2396	3NKuxDtz5chnP2fidKTMVPsQXw2vuyq3vCcY7ULr63o8Z1N3FRMa	1458	957	12	1	2343	jxFpq2vZ22sHRjtGHbTHpvtkQzbvXGkWyUVtsmRzgHKv9zFAGNr	1254	1760	1760	1616256000000
2399	3NKLgRBMhJi4aRsQYVdELsJ5uRGXV2W468MGuuzaSQ1rkWTF6S96	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	152	1084	12	1	2345	jxZ2ixAKBtmsGBcJkvxzWfUSi56sKiPEZrXhHR9Higt1etDFwci	1255	1761	1761	1616256180000
2402	3NLg3srSk5EpTeMcRqNgHDhf2ka8fxkVPjg8kT4xTZ4QB8zx7bmB	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1500	931	12	1	2348	jxVbFPmjdUuHbwYyA6J3iwbUNTSJkJQ5bkcbtN9HvhAyLvMDkic	1256	1762	1762	1616256360000
2406	3NK5g2Ho8FJyRPnhCLEcmf4n8LXttDDoApRRqsNo1RtDsnMSVXoX	2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	1631	794	12	1	2352	jxas4tK8aBG7pRb6ocmcnJ7F4FmqWGTALc2Fqjhgb6yWTMazxAb	1258	1764	1764	1616256720000
2411	3NLpT8K8yryr3K2vBZeh1cjRbn3eqxFwpzzTkGydmN5WimyG3Wsf	2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	1634	1331	13	1	2357	jwfdTvx2ffVoAveRXXmz4tYysrYeYsdrzbstix9Z5mg19btvytK	1261	1768	1768	1616257440000
2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	2411	3NLpT8K8yryr3K2vBZeh1cjRbn3eqxFwpzzTkGydmN5WimyG3Wsf	1673	1368	13	1	2358	jxZxNZEpHtQcTHW5ENqGgyftfgFFFtLxyd3f7rCvMj9RbfB9ELS	1262	1770	1770	1616257800000
2414	3NLCUGwFJgkDBJPJR3WtnsXFtxLhqTMYgx1nPfJEdAZQ2dp1Mo42	2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	1406	1393	13	1	2360	jwRCBqLb3Jtnxk7aFjgThvjraiLwuChQcPt7X7NmTpVS599L3gR	1263	1771	1771	1616257980000
2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	2414	3NLCUGwFJgkDBJPJR3WtnsXFtxLhqTMYgx1nPfJEdAZQ2dp1Mo42	1490	1274	13	1	2361	jxmt56XcWwa7YDQ96dGmnjF3V4XpS2WRcw5mhyYGosFFhdYmaHL	1264	1772	1772	1616258160000
2417	3NLBdvgbPcr4svJBfwFPH7jdx7xCWq7Ypv8ntsy1H6WmZaqZL2Kq	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1490	1028	13	1	2363	jwQGcDBf4AtBwyMVoBBop3qg5fqwTfsgnYLvEFLqN6vWK2qUvL4	1265	1774	1774	1616258520000
2420	3NKnyC11b56P4JbUscU96dKevWxzS1nQi56U7a9psLK2FoRc9VKA	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	1649	1017	13	1	2366	jxN4DBRHvwLMEUwxEXxYePmzUW3wwdcguGuriT3Z253YGS8VnVs	1266	1776	1776	1616258880000
2421	3NK8f8w1qzrBPaGs2TZHT3Q9fM222A2gmwZc1e12syWfKGtZxEbp	2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	1534	574	13	1	2367	jxanfPt3LEXf6Hq4vtBg3exid5JtYGjRoFfFtHrGvDnF5kmiGyb	1267	1777	1777	1616259060000
2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	64	521	13	1	2370	jxfWN3RyL3w7XpPw2x38otwbe5PhQLHeMBsyqkxFQzRhzrDoqTU	1269	1780	1780	1616259600000
2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	1637	816	13	1	2372	jxDL637dwmkf2zGsqhjsTpw4swb4MD8Mgz8K38MASdjbapWn5Qg	1270	1781	1781	1616259780000
2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	1500	1297	13	1	2373	jwPox4sTzfL9wsJdcgNxuRRLeVi6JeJ9aFGgX5RNT7X86cYUCfK	1271	1782	1782	1616259960000
2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1613	1349	13	1	2378	jxLrsVJMWGbZbiWMUCN4TMPQPkcQozTmz6Zw2E4rEuYWbGrmH97	1273	1784	1784	1616260320000
2436	3NLJhhnbwfXapiUf3TsW8ZSmRqvSioi9zPsZ8Td8TPsG6BAJKnNL	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1657	978	13	1	2382	jwuQfzT7pvaEBhymQ9HjB9n9Gqy3z5jnYsok4kMDkXUcdebXM9P	1275	1789	1789	1616261220000
2356	3NLc4kGkfWUSrtaJVUMiaePDnDqLfBJXrLStvoCCG1SPnKz1Zaw2	2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	1643	1173	12	1	2303	jwZHsaQuxriCMGVj1nGUepE3LwN7HyesnyiTeVbkkZoUUBCgKZ9	1231	1731	1731	1616250780000
2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	1670	1282	12	1	2306	jxKr9W8mzzS7JGZLQ79ZD53TS5cVKRmje1eejhAAQRyhyX7k2qg	1234	1734	1734	1616251320000
2362	3NLHcezPGTwh8RCja6w9LUe9rSSXQUNQWdiqSA4YJLJUcXpyd4SJ	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	441	441	7	1	2309	jx2jxefnc89o73nUvJzjyvvW6ptvxSbEXcL82VYvkFPW8VaiGWi	1062	1734	1734	1616251320000
2364	3NK9L314QdpWLVTwcoaJfaDFY9EFEnCLYSQShe7uU1dm2mm49jdU	2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	641	1210	12	1	2311	jx2ZX67m5T5qBRze643w6vyP2Wd6ZPtdqVN3n121pZphpQAK1UB	1235	1736	1736	1616251680000
2365	3NLBMrfeNnKMxYqrJZNne9fDtmbUHYSsuuWWk4vqE7nQF787H8Ed	2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	1490	1148	12	1	2312	jxo3c4E7Ao6xFbU5LhmnsJpqU6A7dxSerd8bAMrGehZ9P2riQpW	1236	1737	1737	1616251860000
2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	2373	3NK6RY1ekrfEmmrcJyQazhXrJvNJjuTS4VPQZGUGK3xEPaoHQPKY	484	1319	12	1	2321	jxc2dB1gD4nfc19vd4gbBDv3ZqEzcd8buJJ6qWLbwS7WQau7Gk4	1241	1743	1743	1616252940000
2376	3NLGcqcN79SJ3SehVUfrSYDHtR5wXhpBNQcgBto26tz32DHLTHUs	2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	1483	910	12	1	2323	jxtmeTEjVyFm4w9t4cGoCqHtBEdi6ZyrErepkc7xWP5Z7qve4eK	1242	1744	1744	1616253120000
2377	3NLgJ8ZyzRvk25Aey5H1428CVopG9cNS2SbxRg5JEQz2V87gPj8A	2376	3NLGcqcN79SJ3SehVUfrSYDHtR5wXhpBNQcgBto26tz32DHLTHUs	1522	956	12	1	2324	jwKQMWA87DjiqfdMWV8MfTu4WQZVNMHAaGHgbS5yNb1Kou7Mdcf	1243	1745	1745	1616253300000
2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	369	1066	12	1	2327	jxV5NnpZFUyDFzUjquXAyPPRDg4LX99XbGMZH8HwbkM6JqfVTjg	1246	1748	1748	1616253840000
2383	3NKDBTw4qsGCsvDXHRj8bHu63kC5eZwGvgJZcByUfbpjM2U497Va	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1623	839	12	1	2330	jxNHoH9cuYE1osMdfGUvs9dHeVRVYcw1uosWw3TK8apEcSCvJUp	1246	1748	1748	1616253840000
2386	3NLcJPZbUEq2d9oJvT6eKWXKvyc84dLpTEvnsrJa3qu3mz3WJdgU	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1651	1175	12	1	2333	jxaXi5noYNc4ePcAQNxsUcJPHHAZjQyMVX4PoawbVM5RVL7KSSv	1247	1749	1749	1616254020000
2389	3NKWMXKre38zKQsuc3NKgB5Qo7FZpRfViLTGPScPT7XgLZYFwZ22	2388	3NL7ukHkoYRGx8kfyBTNUoiBV8VLuYwuUAnzuRgGJPxpBbJHP3C6	1406	1393	12	1	2335	jwyaChrz4fEqPYqjsMyqgXingiGJjwSvnGBo7osf9GDh64qk9Bn	1248	1750	1750	1616254200000
2395	3NLEwmWntnxymPZZEfcAoqDdF5UHVQKStXBEUg1CnBMrLRAwKKbt	2394	3NLvLfE3Q8mRZQA6qJrJAFxtjVV9bp17n7waw8EHvgB8B7wF2fJF	149	1283	12	1	2341	jxKikGPoDsaEyJ6dV6wnwa4oZqkqjBGM2HQJx4J414ZNE4akDm1	1252	1757	1757	1616255460000
2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	1407	1395	12	1	2344	jxmh31EeRnwzu6UE7r2QKY7pG4HbNTsguVZ7Vm51P7dMfKeTZhj	1255	1761	1761	1616256180000
2401	3NLTWtQpr665mWzXALmFzSVQEJ9u4hg81gRiHhdiJ8kRCwQZbDhp	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1483	112	12	1	2347	jxQeng9Wxf5DkaXzPHSQRT88a9c2117SpxsfeeGYxXNiiFusqTQ	1256	1762	1762	1616256360000
2403	3NKvfnjfVVgWn6YmAb9qpCwskvELpnm2NqsRMdiSkUXMTn751vC2	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1581	778	12	1	2349	jwQyJRFevNr3TNzanWdVQEesU3ovwuTGgCfg8BCkJAbHKbGMprL	1256	1762	1762	1616256360000
2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	2403	3NKvfnjfVVgWn6YmAb9qpCwskvELpnm2NqsRMdiSkUXMTn751vC2	1656	1217	12	1	2350	jx72egdBn9G1o2a2SVuF5YU2ZtaeP2FTfF2AN3eerAgRmjVxcjD	1257	1763	1763	1616256540000
2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	2405	3NLorEADbNp7MGQnBp66ga7pZh1sa5YGHMibLcxzL3fsV1ofsyJh	1406	1393	12	1	2353	jxLjcXzML6xeS2NFARN4xgpQxzQKqhC24mfozekvaSh3B1GKm2J	1259	1766	1766	1616257080000
2409	3NLurhRba9kHEshyjtin2AHSryF5T5FAaRyBUwhw5ehrGwQoTUeD	2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	1457	1145	13	1	2355	jxbH8PYqupU5LrLEVSj4GjVcn4p7mY1zCGHF6LBJdwYxjeJ19Qq	1260	1767	1767	1616257260000
2410	3NKUfGYDe3rSSb3482zyy8pZaMGuZVdrDuEmDgPXcnMMK5PW5zVv	2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	1402	874	13	1	2356	jxZc4pkJsEMdMx8NfL8g4LZeojJLzb7iUpv5CFmRf8vSmbLLpsJ	1261	1768	1768	1616257440000
2413	3NK9ajtSjMghWTeBKFipTSrDQCYXT7WJPTkesRuCq8rGncKqhndP	2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	1613	983	13	1	2359	jwtzG7SinhJ931htpMbKh4fMdwdo8TZcGiskWzUEsCTfXu9cDYv	1263	1771	1771	1616257980000
2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1670	1282	13	1	2362	jxihBh6HtQ8oZefS8gT7RZstY2bAAYVFynzmZ3kFQ3CmqfcBDav	1265	1774	1774	1616258520000
2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	1560	1291	13	1	2365	jxEQPQfrgRzfUniEN3gCTMnxR7WS9dePtSUrnaP56EXuQDwyDQy	1266	1776	1776	1616258880000
2425	3NLnqPjoRXBsUymJqXebhys3eo3XkmVX5nfmjQbLFUZY24XVAHus	2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	1619	1149	13	1	2371	jweMmKCVVSqwHBdTDayUzuFZ5VSXSNzV4gMQGoJHncKUwTBL76T	1270	1781	1781	1616259780000
2430	3NLhW2T2cWXCXqXgRNXjff7yg4FXQ64o6DMdK6MdfV3FpceV5tFD	2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	1542	1304	13	1	2376	jwg8CSsyXjhx1uU2eQGsHLB9ny83FFAXrbH4RHe5MJgwS3ZbQbW	1272	1783	1783	1616260140000
2431	3NLvCHGjQh2Jsd7Y3LMEWA4UMFGY1pyZFCNcUjQdgUZk1B3mR9en	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1406	1393	13	1	2377	jwSxqjFLhpVky4irqRx4YrPyRcKfsHZJYvCVi5hPBz7gF27C8ht	1273	1784	1784	1616260320000
2434	3NKac27JAYT48BpqSqWW28CQvi8PSsfoJya5FomrnPCMHaxZRhN1	2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	171	1374	13	1	2380	jxsGwpzsuiazAsNatKaowwQDVonyWxzVPb3yZQTxdNoZt68njXR	1274	1786	1786	1616260680000
2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1406	1393	13	1	2384	jxRNdxnYiUeGnaMTFDmkBsTf7QqAWNm6RK5Bf2THfSc5RpbmV9D	1275	1789	1789	1616261220000
2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	1623	830	13	1	2386	jy1gkmrbdEVzb2sSdZTL8aYU7c1SCUKuiSTW8BzMoZRBr4b5y2p	1276	1790	1790	1616261400000
2443	3NLXh5UM1rwsiqbvvpJoyQTRr78R2uHNS4M6TRUNcQmDiqYkQ8N1	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	1623	830	13	1	2389	jwVDaErXsnx55AFiEmTd6zCNne3hWf3kxoawxF6sjBxX3LbUqfP	1277	1791	1791	1616261580000
2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	2445	3NKUBcPd6KDMg4CihLWaRVWaDVECpQdfgLztJH2S6gXnYHiTbVTR	1406	1393	13	1	2393	jwMXzUHaSUxtoewgNwhFYE5Ju8TY5VWXxBreGJKX8imSjn342c5	1280	1794	1794	1616262120000
2454	3NK5XGPARdXzbEn5hQmLZiQxNH2Q8VX4j1MSu2bw3xLEvDCcQhLn	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	55	463	13	1	2399	jws28dczrEiCfeEQ9SpxhJpGzDSonthomEsywZT4JbbPi51R8Nn	1284	1799	1799	1616263020000
2357	3NK86abekKmd1YqdWxKVLUgCpozLecksYDWpmHEXfqXoQxz8Xkig	2356	3NLc4kGkfWUSrtaJVUMiaePDnDqLfBJXrLStvoCCG1SPnKz1Zaw2	1587	1357	12	1	2304	jxcY4xzN3Wrr4pXToViz3pmk6z5UXRTJ9QDA5uypNeqaK5XDUUN	1232	1732	1732	1616250960000
2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	563	1359	12	1	2310	jw71M8kZMM33PRkkGLbZfEAAK1AdJMjeqZEocXdhmKXh7C8GQnJ	1235	1736	1736	1616251680000
2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1657	1098	12	1	2315	jx4Sm1T5C9NMXu3mNLdrcGfTmg5Rf7AN89wJKspCWrB6ctHL72T	1237	1738	1738	1616252040000
2371	3NLfSpXGvyQHuPCjceCXJKfWgMVbrz9QxPX1uXnv1FbV9LBoExe2	2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	171	1374	12	1	2318	jw9MQv1B2z62ZCzo5WbQV8Cg7Xgxdq1i1DY8nWCT9KvvoN74wXN	1238	1740	1740	1616252400000
2372	3NKwKYGxLZhgYVnHW3tLcrTmXMXWsc3YvBFhib7QZCgXH8BxoZZa	2371	3NLfSpXGvyQHuPCjceCXJKfWgMVbrz9QxPX1uXnv1FbV9LBoExe2	1403	824	12	1	2319	jxJ8EF2gJRn5dTqgk7UZbgrGkQuXuVKH4uE2NkuH1aHNYgGZuC4	1239	1741	1741	1616252580000
2375	3NKBNzQGyrUnuaHd3TP48Vju3ynNjbhMCzNBnorjeagaxXLT9fok	2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	1407	1395	12	1	2322	jxGXi54ozY6AM3UAg9DWAkTFc5uBs6HAxAggHmz7hUddz2SMtcW	1242	1744	1744	1616253120000
2378	3NKP6MrKzzDyUuH5XGx5VtxpkRkXvLQzf4zj8qqYeZsQ6Sp5ky3D	2377	3NLgJ8ZyzRvk25Aey5H1428CVopG9cNS2SbxRg5JEQz2V87gPj8A	1606	671	12	1	2325	jxBcDDCSiygVxx2qRYSJRZyhiyQN4bD8hvgcX9J5DShoM5CyZE4	1244	1746	1746	1616253480000
2382	3NKNeQRhuqNeW9pXavUradsdyBuf9WfN1AhwZ3iWCtXmdFtWsCDB	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1673	1242	12	1	2329	jw6iQSn6YAdnEGHQzjYhdiu3iGPvcGhbPiVFzYgG7sHTcXra2Vx	1246	1748	1748	1616253840000
2384	3NKvYRrSEsBYTAsR1CvDMV4uaowE9NXqzVDLBGrZQfdVXi9YNE2M	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1403	824	12	1	2331	jxaV7KNNW3uXTMfuLZwmaLyRFyPEDxj6b4wjkLoxvrBK5xyXXtv	1246	1748	1748	1616253840000
2388	3NL7ukHkoYRGx8kfyBTNUoiBV8VLuYwuUAnzuRgGJPxpBbJHP3C6	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1651	1175	12	1	2333	jwkkJdfyBwg5oKwxLQ1UStdSYuXzHF61qwMPNvQj1jY9Yw3x7pt	1247	1749	1749	1616254020000
2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	2389	3NKWMXKre38zKQsuc3NKgB5Qo7FZpRfViLTGPScPT7XgLZYFwZ22	448	1059	12	1	2336	jwEvhAg2KkkE8nYZq5Hq1rHAW3UHpYgZnQfLb9kgwwDp8f8mR1u	1249	1751	1751	1616254380000
2392	3NK6LA4j4MNY13WqCnDUPciN3MavM7KFLDy1Y9A57m4bFh2vVUUa	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	1403	824	12	1	2338	jwB7qFM8RPBiHzVoR8GfsBFJ4r2KwaVesDm4H6uAjXQ1CdXi5N7	1250	1752	1752	1616254560000
2396	3NKuxDtz5chnP2fidKTMVPsQXw2vuyq3vCcY7ULr63o8Z1N3FRMa	2395	3NLEwmWntnxymPZZEfcAoqDdF5UHVQKStXBEUg1CnBMrLRAwKKbt	1407	1395	12	1	2342	jxk73Gj3to167FFH8ANDYdkMzu69sDS2gP1pZViUVrYewacQD9Z	1253	1758	1758	1616255640000
2400	3NKGJSzgio5XCKZddz8YhsD2LSsFsh9x8hTJ4vMVd39fw3NgtZLb	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	1402	874	12	1	2346	jx1CZ1Wuf5UyvxjtQ5gLeYyPhn6T5J11SDsEvWfm5siLw7YMeVx	1255	1761	1761	1616256180000
2405	3NLorEADbNp7MGQnBp66ga7pZh1sa5YGHMibLcxzL3fsV1ofsyJh	2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	42	1115	12	1	2351	jwWjnaBpxUb8PKGHX2KjNmnRrnovkjZTiFDgXqQs1tubuEj2yxT	1258	1764	1764	1616256720000
2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	1490	1274	13	1	2354	jxzCBaZZkjRUVHJ5MvYTaiBueNxdMNS3qbrSe5tDWZAQdWcuwiS	1260	1767	1767	1616257260000
2418	3NLxNAUqVWCstNGsLGUMfc6JFtf2aFzJDAjM9RCWkuWYDfZGwH5K	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1654	1340	13	1	2364	jwcLmER116cKq1hRJHAPfxViEA5giv9iKdhB6xNBv5fJ6TLustX	1265	1774	1774	1616258520000
2422	3NLFrJkaPK6r9KjuHtBEMqqMVEXSfuKnbnbcxoPXVhPzRVTRkfJG	2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	1406	1393	13	1	2368	jxe3YUhSQmHpGRP5SDeSqhk8YALMnj5d8kErR8rjrLnMALsZdQG	1267	1777	1777	1616259060000
2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	2422	3NLFrJkaPK6r9KjuHtBEMqqMVEXSfuKnbnbcxoPXVhPzRVTRkfJG	1670	1036	13	1	2369	jwkHufyu8xdHBY4GhwyfGh6krJ9mfYsLJtErQ5EaR6q8hABFPHk	1268	1779	1779	1616259420000
2428	3NL49pEf9TqbVVyQ29bEaH7fupLUj6foFNTP5ub8XbEByTr9cEHH	2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	1599	921	13	1	2374	jx5bBuS7kmuBtbCxCc3sydRP3BLEid4XrwxXeMSpHZ45PRuym29	1271	1782	1782	1616259960000
2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	1668	1370	13	1	2375	jxgeDuZMKrzwYfRzz5VsMsjPxNYez8hNxqP2wEyTGy6JozWdC1D	1272	1783	1783	1616260140000
2433	3NLMiCyiLnTUz5VvQRY1RwUJwcoxL3KU4NrppgNBgbsoQ7z3Wcnw	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1637	816	13	1	2379	jw6uwKgRkNGgjSawZpxZWBs7if3qdSc22YDXZeQigNfaxiW78Cd	1273	1784	1784	1616260320000
2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	1611	1215	13	1	2381	jx5FbWHMhg5DS6VBy2ARoA7Rjp12YYo8VPhsVBatBmhHjyeEBg6	1274	1786	1786	1616260680000
2437	3NLEf1k7wxYGPfwU6CMCiXT4eCBwZBcnw8P5YJGeqVmiFo5grNdx	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1422	1337	13	1	2383	jxYh7Vrz2ELMtKH3CxdQ1SnKkkRj3EFHWbRzxsqKcWmc58neSe5	1275	1789	1789	1616261220000
2442	3NLhB5h6tprsipnLdC8qYJ57kk6E5SC8nUWVoG9m2FGaW167Ngpi	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	633	1138	13	1	2388	jwByTAAivrXJf2kqKApgvSWkiqEN3EuoX6BtyxqgP25QpZEYaaW	1277	1791	1791	1616261580000
2448	3NKdd9x3kKidszaXHfLVZTF5HmBNmD8yVdcRM2zyLsM9p3gFSyXs	2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	1651	1055	13	1	2394	jxBMC9b9ebt8aMnJmJUEaLQS6D5AbUGSZwHJ2pMWHfuQrdS72uN	1281	1795	1795	1616262300000
2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	1651	1055	13	1	2394	jxM7QggEuMHh1i2LmTHq3JHUA8V1N5gPSrH7RjYXBhN3mZuuNf7	1281	1795	1795	1616262300000
2451	3NLamQ94nuBvFmG6CqL1dXVcoALjoxnRaynpTZzAu4ZtPaTWdUK4	2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	1476	1245	13	1	2396	jwqF8cJWGC5SeP8Ux1i53Jkoohd9G2Ci4YewHnXfF2wzyENXQP8	1282	1796	1796	1616262480000
2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	2450	3NKUp6mzHDdsq7R6jjJWHBAF8QafAtbNPSRbCjowwmqDt39gAdq7	1467	1130	13	1	2397	jwEMh1pwF8X3SfXEq9YWVtzstfcThDjiNweDoAqHKFjbhqYXyFd	1283	1798	1798	1616262840000
2453	3NLx9G2m5NkGPfLpsA3cHvrBNUZWsbWvtR1UC73fgS3YCwBzvGtp	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	1654	1094	13	1	2398	jx3K92P8MTf7NgeYYqV6F5nEWir6L1uKhR3NabfnfGXjpfkvMpe	1284	1799	1799	1616263020000
2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	1508	1261	13	1	2406	jxSk2Dgb6xmi2n4aFQ6Gm9KC2Jr9bo4JtXxbzV4EWWhJHkUBJu2	1288	1806	1806	1616264280000
2466	3NKjxJNPYBxRwrSWczYapgoJLbrNCVTjxSvmqWYWSF2hBpZg8AiU	2464	3NKrhpGhhmDXwHVxYNRHvt4mW19s4Sjhqm5nnrzKK5GohEXahu9H	1637	816	13	1	2411	jwK59495eeS75aDhB4743XDWkAwjiwuNsvMTDmPm1U6EYTgDtpH	1291	1810	1810	1616265000000
2439	3NLRmzKyYXZpoXt88EKTQmG3KFAMAsiG2nPYWm2QWxt7Pdz5n34s	2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	1451	1292	13	1	2385	jxQMqM2z7VzV27fSQBvx9PAwnZFPC946Mq5NofxVue9wvzi2cdi	1276	1790	1790	1616261400000
2441	3NLdWBRDFkZP6Wo8rvxuHP9ew4QQEjEo3MBRdB7epBS3ZtHSrAv1	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	1405	873	13	1	2387	jx5dvJc8NkeMYjqMHHA3ScCVN65CdzvKExJCamkRGdajaaSwZKy	1277	1791	1791	1616261580000
2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	2443	3NLXh5UM1rwsiqbvvpJoyQTRr78R2uHNS4M6TRUNcQmDiqYkQ8N1	1406	1393	13	1	2390	jwtq6A62iba9UqBu1KkWzk3qseUKtUy8mg2T81U8MXd7Wd7pwMm	1278	1792	1792	1616261760000
2445	3NKUBcPd6KDMg4CihLWaRVWaDVECpQdfgLztJH2S6gXnYHiTbVTR	2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	1405	851	13	1	2391	jxT6LqTWASBSBr4Q6xMKV2sGih3fuPv1dumuPBSB1PmmCn8sqsW	1279	1793	1793	1616261940000
2446	3NK3jQWgwBdfA8ziRgjfJ8HWARgn5vwiv7KKVpUyYC9dSTDvESfb	2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	1589	1040	13	1	2392	jwUiJr6HCWp8ihVNJAek99a9SP1MGj6urcMMiA3rHgraUkE3k7G	1279	1793	1793	1616261940000
2450	3NKUp6mzHDdsq7R6jjJWHBAF8QafAtbNPSRbCjowwmqDt39gAdq7	2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	596	1180	13	1	2395	jxCafcYY5hZ17UbQkk3KrWruUbYowj4dWLGhxnatRHrFiebjcDJ	1282	1796	1796	1616262480000
2455	3NLujr3uKye2DHdPDWsNMrEDuXzZNLVKUku8orNg4cPpZkmBM5rW	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	1581	778	13	1	2400	jwgfCcJ9ZaPmJZiSDhDaYwVxBxkZFUkNaeGwhSVYnEHjVscM7BN	1284	1799	1799	1616263020000
2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	2456	3NKJ5QVikKMHizSHiY9NVpTguHRTHkNr462GUAG1BTUvzwQT8VjG	1623	830	13	1	2402	jxpB8Yt8pQmqcaJBcoTqET5FoMiFzTZU6mH27rT5Ntmp5wH1WRq	1286	1804	1804	1616263920000
2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	484	1319	13	1	2403	jxdLLPdrB7ZAJuPd54Ry2qCV1ZtWdgR2kAbiZn9PLG1Dv2ZdRGz	1287	1805	1805	1616264100000
2460	3NKtRsKrVw9u3fvLTxNxXxNQCE1DFrqgTGCgP1F2h3s1bpNyuMyw	2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	1571	1089	13	1	2405	jwGxWV5Bt2kUwosQDuqhmztziQewQuxvJB1hv7i56Gt5F3W8yrK	1288	1806	1806	1616264280000
2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	596	1306	13	1	2407	jxRM9FgSuvdPJV5KeefTVU7Hn6CJE2LFtQBofgToMRuYKvzreTx	1289	1808	1808	1616264640000
2463	3NKsF3fQjbqovpgcrWfK2T9ngGq1J7RAA5gWeXSETH93apsUDKsL	2460	3NKtRsKrVw9u3fvLTxNxXxNQCE1DFrqgTGCgP1F2h3s1bpNyuMyw	1513	1133	13	1	2408	jwWuYyattttk47tjTFykDEMCmisGt9H1UQb3zPXCJTQQYCMXzcq	1289	1808	1808	1616264640000
2464	3NKrhpGhhmDXwHVxYNRHvt4mW19s4Sjhqm5nnrzKK5GohEXahu9H	2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	1407	1395	13	1	2409	jwCb1X4NCuYvL4X36aWp9Z2Sfq7qLYbDwZVzAGfzmEb7mBp9Fh9	1290	1809	1809	1616264820000
2467	3NLGrGXtD4XNHyHUaLACr9tg1dT6x7zDMq4prn1MNc7kDnrjFqHn	2466	3NKjxJNPYBxRwrSWczYapgoJLbrNCVTjxSvmqWYWSF2hBpZg8AiU	1608	1043	13	1	2412	jwM1hj7QnYmfnjStbyVu4aLFGMS9Ui1wXyRwc4AXH7H8Q9h333k	1292	1812	1812	1616265360000
2470	3NKizaPnM6xUrmYewwMkUJDzpnueWHBFGEjGoEHAwC434fuEJa32	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	1541	1172	13	1	2415	jxCYxds4U4CoX4MG94z7MqCjXoRTaQWR6g2ereJ7yo7VMqbyLxa	1294	1814	1814	1616265720000
2473	3NKGUrKqhoPt1U7YToc7wtYhfxgKE8XLNpf4myzQBD8YKx15ZpRJ	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1407	1395	13	1	2418	jwQzpW8nQcnpb28jK6GNzWgYMquX4FLbg452qeqQJAtfyc58Se9	1295	1815	1815	1616265900000
2478	3NKsG1ziK5XvoALnyWFE7xNsujeTMj5trnQsEuYnTkiZjis7Z4JD	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	633	1138	14	1	2423	jwQ1Enj3udyNfETSp7vJzWh8r8wNTMZwsfEjqH7LgdiQ4xAozc7	1298	1822	1822	1616267160000
2483	3NLoAEc2tJM7tWaZsLXkdzBvfy3cxDrRPWak7BsuKcdcmbcnuHWM	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1402	888	14	1	2428	jxf7ZtoNK6JstDjM83WxhM2QeZPfpyywW9jxYbMrDj2b1rRe2fh	1301	1826	1826	1616267880000
2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	2484	3NLT9kptDXE1Xm8shbQyTvPuniWjU7ezxAQhMXa3D7HJx1qNGSYT	1649	1383	14	1	2431	jwU3mHgYauPGSuigZsjKFdWvi28mNqf6VGWSmvW9YP1NTQk9myS	1302	1827	1827	1616268060000
2488	3NKmFmaamRRr7qaMczo5oHsWVU4RyNzpaa4ZbhDCaha866koY2mA	2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	606	1169	14	1	2433	jwq3Eq2zQFdF2W9fUm8TGufdy3BizxkT2FYCDHkwCGQ9Cefi57F	1303	1828	1828	1616268240000
2494	3NLR7wTxQAqHs8VYsstVg4mxiBmgjoR9XT6vyVsZH1kVXyF4fWdH	2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	1407	1395	14	1	2439	jxevkHFeQZvwcZYHoxoFcDeUk6vpvgLajEDfaP13piPvs8xNzDC	1306	1831	1831	1616268780000
2498	3NLUUnKTuBXGPSZ93FpFRpmia989oxyF4rEr2USz7L1A69a6hwro	2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	1406	1393	14	1	2443	jwLoa1mNf9S8avB8PjtJnAALY2iL1cTXCnLyGCfZ9S5WSd8dxDd	1308	1836	1836	1616269680000
2499	3NKLpthCLYPQzwjQpn75PWvABiuEWCmL8JiVMWRSVQN52bpRnr8q	2498	3NLUUnKTuBXGPSZ93FpFRpmia989oxyF4rEr2USz7L1A69a6hwro	1553	776	14	1	2444	jwVh3dS5vHJiSGwsFvL7H2FhyBRRzX81BmFJ61PG6MZxbxBpQFq	1309	1837	1837	1616269860000
2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	2499	3NKLpthCLYPQzwjQpn75PWvABiuEWCmL8JiVMWRSVQN52bpRnr8q	641	1090	14	1	2445	jx54eF2zR7UyyyA1NzY4ra5ASMAJcpjxqgF6JejzrDv5SyAhzby	1310	1841	1841	1616270580000
2503	3NLwjoWH1pK3VPP3m9AP7rJiVJndLzJesc9Ji1zrBtiRjYMbw9N6	2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	446	446	14	1	2448	jxJhMQLVN7FyCw1ZSUoqBF3993zrvFtkbu3Y929vAD7YpThPrd4	1311	1844	1844	1616271120000
2504	3NKRHWJJKztPG2rexXPdQ2RJLmXcUCCMZvGJZZFv9wwTqQ7D3ZYc	2502	3NLwHpUhGrZBG7E4mpZSXYcFXTwmtwpEoDiLxDcRqKfz7uiXAL6s	1671	1365	14	1	2449	jxN8Mf99WUKGK2ZsXiapXc1ShtBmxRvsVc6Ty8qDpbrpu1s2qCh	1312	1845	1845	1616271300000
2506	3NKuBmL4FjAB9Xa5V2hKw5hLUB2wF1dAGWGfizeUmpwvMLaUv6PG	2505	3NLMRY6y29xjps56P1mz13YAJBk8DzazCQr6BRqHc7p2y4VSZyek	1613	1103	14	1	2451	jwnEbXbn7bwWGmyjRcd1aiSMrpvDYEnnyeyazwjCabgR1E23gm5	1314	1847	1847	1616271660000
2509	3NKqe3z4USXs32KFsywYDT7tftMjAYnbMmt1xm1ty6EX3ZkTVVoA	2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	1601	1388	14	1	2454	jxGLqjQ7EGha5425YB3pfubnmK25EYqTn4G5jV9UeUUz4sU8hBy	1316	1852	1852	1616272560000
2511	3NKmsekVHhaEfxyWgRVbspo1Cm27KsxizBrV1ZrWaqCFWLi2gPsG	2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	1458	1323	14	1	2456	jwu8a8n9Ffm5qgdhJKB7aCzNadfDpoddKXTeNwBamnmEniJcyZA	1318	1855	1855	1616273100000
2513	3NLUkpawyfF3qgnTCHaT7TVSXjj8Fac4tQYbdy7vpgF2t4PXXoXD	2512	3NLbS2PRa3V9jCxCfXwaUQ7hxjgJEV7VHvm5e19qGZ6JskHM8JWr	1407	1395	14	1	2458	jxqyMGQC2hiyu1qexBLZi1tBhiLEbKYQWfJUrAx3hEQkdDbtq8H	1319	1856	1856	1616273280000
2516	3NLXoZpE7ZGiJK1BbHsXgNtbDBuN843c5oLYDYxf6ceKJdwmy92c	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1624	1208	14	1	2461	jxGoigjPaYrL2q9ov6MLkU9CCgNBXyuCrEFVUPW6MZMKB4X5LGo	1321	1858	1858	1616273640000
2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1407	1395	14	1	2462	jxsuUHuj3rgERan2jaEcHW6NkJ5cg9SVaHm6WFhtJ9byhG4kDyN	1322	1861	1861	1616274180000
2456	3NKJ5QVikKMHizSHiY9NVpTguHRTHkNr462GUAG1BTUvzwQT8VjG	2455	3NLujr3uKye2DHdPDWsNMrEDuXzZNLVKUku8orNg4cPpZkmBM5rW	1541	1052	13	1	2401	jwDs9MTWvofGWkfjUC7n6gnZB6nbzGYVnZRCVmpfq16yv131Z9y	1285	1803	1803	1616263740000
2459	3NKWiPYnf9Meu9stELnbjrr1scPCaxpShauiyRmLyXTh5XVBn2eB	2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	1613	1103	13	1	2404	jx89pbqA73BGbGaUCrFPQGGZLCBtK72rDydvb53RyZ5N5ic63k2	1287	1805	1805	1616264100000
2465	3NKWVkKHMWhNN5B5wG65RCrQAGpWRWJNd7nm86XyQ7r9s8DyPzFC	2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	1602	1369	13	1	2410	jx3sMmQRCsNM8cDdW7s84X3UvsrBL7mqMzNjRY72NpBWmXFuUto	1290	1809	1809	1616264820000
2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	2467	3NLGrGXtD4XNHyHUaLACr9tg1dT6x7zDMq4prn1MNc7kDnrjFqHn	80	1273	13	1	2413	jw8KGJhb8mzWPMqvGAatPGufxkEP6mEpSgSkVpJNe6wfTMLAGBC	1293	1813	1813	1616265540000
2471	3NLcfhSK6HRc238a7hQGCWuYG2SWvUy4h4UoivRWD4sjasDq3pL8	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	171	1008	13	1	2416	jxTbYaJJLaBkAJ1BCizgHLYUt9PiBtgiVf4LGxnope6y33pSZMV	1294	1814	1814	1616265720000
2475	3NKCkgaFkrDB4UnDdrYMKRsTmjPUEXuQ2qqhdydq8iKaEbZ5YfAU	2474	3NKPVWbMZeo1BrvyCyNSwvMhZA3tFfM5ssYdDuWccWHC9kFR95Ap	1600	1126	13	1	2420	jwsSicFQ9e2AFyciru9gSBUcsENog8jTp9uR6rKqQ4BuFoKibJY	1296	1820	1820	1616266800000
2477	3NKSfH38q1yMxmWs1xJheTeUnMPgFP6GDPSGK4uFExpT7nrsCpex	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	1407	1395	14	1	2422	jx8dAPsuhdqYunhiE4sm29Atb8bQW2pSbeoSxBe64je9xWT8bRf	1298	1822	1822	1616267160000
2480	3NKhhPR8jqfbbWu9nujz7hoqHhwZ1KK67T1P5HNB1KfrSZoB4KZD	2479	3NLgShuhWj8H51PJEccx4YwpCspDNmwGCoLVvoLHPjW7akupYYBX	1419	813	14	1	2425	jxYWL2GXtkuxassvr4c7f3hZHiaf8AkWGeLU4zq8XJa8GYyKGhv	1299	1824	1824	1616267520000
2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	2480	3NKhhPR8jqfbbWu9nujz7hoqHhwZ1KK67T1P5HNB1KfrSZoB4KZD	1631	793	14	1	2426	jw8YYAwQ7oRF38Sa3nM5CeAmDTUugz2VVdE8FnJKfCDDg1qVTEo	1300	1825	1825	1616267700000
2482	3NLy3RvJ9K6mLFQd4wrX1JVk5jhDdKKJWRerhe8jcujCvrgJUsDw	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1571	1335	14	1	2427	jx8UC1rEhPnphNgAxbdyTQKwWWnwJAF3PkV4QXsYA8fXzGbEjK5	1301	1826	1826	1616267880000
2485	3NKNqeqRjSY8Qy1x4qwzfCVSCGUq2czp4Jo9E7pUY6ZnHTBg4JiW	2352	3NLU6jZai3xytD6PkpdKNFTYjfYSsEWoksr9AmufqYbxJN2Mpuke	1529	950	12	1	2430	jxzCUhafkVQFEBYaDMNZyc6fCNjPPBxrGiNCmvs6p6GANiBH8cH	1230	1827	1827	1616268060000
2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	1481	790	14	1	2432	jxViHW1fi1WZEtZkBdZRhAuN7JZNnQ6zjVFv5uZSt6GscsNR2GP	1303	1828	1828	1616268240000
2489	3NLicLBwfZPGkMEmdJ5UcayXgUfUofHfoKPKee5WYuYKN3xzF4zQ	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	1577	1327	14	1	2434	jwfUfw4HheLnvPVEHet83NhmzsGCsj45L2fYTxa6zgTqwNbnsZg	1304	1829	1829	1616268420000
2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	484	1319	14	1	2435	jwgvngw4BzYtkpT5vtPEAjprG6DTfHwVTiN82Rq1csA5hbbdHWe	1304	1829	1829	1616268420000
2493	3NLSPscq26kMxSenjUbztdHKLJTooRYrBTstVLUMFkvC4KmEAj3x	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1637	816	14	1	2438	jwfVpiywctg2GHen1mRLNZgmRo9qKBZgR91W9Q253PXZnpfedee	1305	1830	1830	1616268600000
2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	2494	3NLR7wTxQAqHs8VYsstVg4mxiBmgjoR9XT6vyVsZH1kVXyF4fWdH	448	1305	14	1	2441	jwyVamnZdKUBgbEgyFCBtNGQsKsZFmHvTtEtQweG5mKtFBfkbGr	1307	1835	1835	1616269500000
2501	3NKLtWLEWqQphQWaaNUTFCtzSotGtJD2pwyhTFXkrgb93WHjgNAK	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	641	1090	13	1	2446	jwhiSz5EoVWduhoPxCebVtEiVYC5kTDEhr7k5UJNfuFXDPFitvg	1266	1841	1841	1616270580000
2502	3NLwHpUhGrZBG7E4mpZSXYcFXTwmtwpEoDiLxDcRqKfz7uiXAL6s	2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	684	1352	14	1	2447	jwQxDepLZJhgo1xjMDhUd3K6kqUogHKjFfJNzByW62TXu1g7EPc	1311	1844	1844	1616271120000
2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	2506	3NKuBmL4FjAB9Xa5V2hKw5hLUB2wF1dAGWGfizeUmpwvMLaUv6PG	1541	932	14	1	2452	jwyCDCay63H4HxAH1Z7e3tot3e3s2TPxQ5xHoQUYqCt2WtpbNay	1315	1849	1849	1616272020000
2508	3NLAQEvm2f17Z21doHv2xZgFcjHR3baA52xZFGBxSyhXaKF7Ldz8	2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	1402	888	14	1	2453	jwxTwfJ5QMVQRsAZpsKVsxT9To82SMfKzRf9PjownHFjEbJYSQK	1316	1852	1852	1616272560000
2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	2509	3NKqe3z4USXs32KFsywYDT7tftMjAYnbMmt1xm1ty6EX3ZkTVVoA	1668	1370	14	1	2455	jwRxThoSBhTiW7jdNVF4jqzqY6yfJ298zk25JmJHvPWhMp35MBo	1317	1853	1853	1616272740000
2512	3NLbS2PRa3V9jCxCfXwaUQ7hxjgJEV7VHvm5e19qGZ6JskHM8JWr	2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	1559	987	14	1	2457	jy2BgALdKJXF4ZKHwBCxCfKLXqbkJ3B3xxhax4mXwKVbwwjLEVx	1318	1855	1855	1616273100000
2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	2513	3NLUkpawyfF3qgnTCHaT7TVSXjj8Fac4tQYbdy7vpgF2t4PXXoXD	1406	1393	14	1	2459	jx1if8QSqjAgYzL4QRgtZmjkKYqkppqRTi6TXrmseSS5dAJUETC	1320	1857	1857	1616273460000
2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1546	1213	14	1	2460	jxg345mtvD52s6FAw2d2n4JCypQ1FsB2SaVMi1FdBH6omDFarcg	1321	1858	1858	1616273640000
2518	3NLQrWov1HbNwmEJxJVau8uDxAX5o5vv85DVNnxiq4i9CRC1XAXv	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	43	944	14	1	2463	jw8pcJxkfCRXocVFPYzTBdiuFU2r75W8SD1so85stxeC3TauS9r	1322	1861	1861	1616274180000
2519	3NKUtEmiuEtUGuChZhkW57Vd6g3DfZNAJBNQw8LC5WTyseZWWwn5	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1559	987	14	1	2464	jxoSXrD695JXb4zuugCKXXDyQcJK31GorfKici8szRY59QVqYKo	1322	1861	1861	1616274180000
2522	3NKQV5TBdmZNS66LUF5dhTZbuU14frKzsPWQnnfVjXF4bPQ4J5qt	2520	3NL3n3tufo1uqD1NXWemNJLHJc318KJqz6JGwULLqHeXKeGf8MGm	1546	1093	14	1	2467	jxvqafXxG5uVdD2qyx6pFZL3bdsuCUHodMUpLLkQuGJqPqyf4Gp	1324	1865	1865	1616274900000
2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	2524	3NLfQU8DmifBjyMTjVQmwBGhpZFFj9bu6DxHhweqMqZpnPt9DtrM	1590	1054	14	1	2470	jwjEoBB2LjMvb9WxN57wzEa2AmrKeN9B5aw2rM1YsgicR71YGU9	1327	1871	1871	1616275980000
2528	3NKm8UMvpuobSPRzmowQDY3UE68C5r2ceufqzE4v8fpCZs8LAtB8	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	1559	1353	14	1	2473	jwkf43raHt14SjCq9ZDT8kcdGea15be6Ai6q4yeUgRj6Fq4TCxm	1328	1872	1872	1616276160000
2530	3NKxLEXB8WGNp2ngnuKk7PrUAQhVnKoGmujKx2tZvjjSYgVq3pFD	2529	3NKmRy1wuGbNbURn1e2CmiLRs4RtLAw1yb3DXahVUPtggu5SHFZs	1588	1146	14	1	2475	jxK4RZ4U4mXrJrs8j2WmNL5HrYmpXH4jUUnVRCy3LyBqTbtDUKS	1330	1874	1874	1616276520000
2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	1651	1175	15	1	2481	jx3NzqhebqTDUQ62z8V6tRzgx6AS7nmMsergAphkiCSXrdGYN3H	1335	1879	1879	1616277420000
2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	2543	3NLQ9ryh67Gftf5RFu7NuiNopj7o7m6i2vk4rWfJxgWybrpGBdLZ	1406	1393	15	1	2487	jx7wzQpiGCYx4nHvUGCr2Wwhws43U9MCDPE8jTEsWoFFvKqWJr3	1339	1883	1883	1616278140000
2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	1534	951	13	1	2414	jwEWAU5zWaZAu5nfDrFZma86mW2cMBwoRmXHJTunQQMt2LtGU7v	1294	1814	1814	1616265720000
2472	3NLdAnPXZsc1Pn4QpeLhueCvW4W24cVcm5uocEDGb9WKY3C86ACp	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1426	1364	13	1	2417	jxnyMp7AQpHzGEUR3VyPJVBJZHcnn9PsB5pgJGYVJefeRJdYcs7	1295	1815	1815	1616265900000
2474	3NKPVWbMZeo1BrvyCyNSwvMhZA3tFfM5ssYdDuWccWHC9kFR95Ap	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1642	1367	13	1	2419	jxnJApqEhvAjvBETSuEYirExhe7XvavuPEa5ibNVsphqUr94TDB	1295	1815	1815	1616265900000
2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	2475	3NKCkgaFkrDB4UnDdrYMKRsTmjPUEXuQ2qqhdydq8iKaEbZ5YfAU	1670	916	14	1	2421	jw9k42e5ifqDmL2xVL3dLPLkcZq15YNYv1LfY5ZpzK7pVYBdjMc	1297	1821	1821	1616266980000
2479	3NLgShuhWj8H51PJEccx4YwpCspDNmwGCoLVvoLHPjW7akupYYBX	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	311	941	14	1	2424	jxtB21JCpZrPWCJkBXqLXvUMKi8JhLyZWNxzmLX4oBkyZNjP2KK	1298	1822	1822	1616267160000
2484	3NLT9kptDXE1Xm8shbQyTvPuniWjU7ezxAQhMXa3D7HJx1qNGSYT	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1555	1347	14	1	2429	jwizem7uPaEcx9RoLoPnB9u5s8hs4uy9EENwAWeEvKnKsZUbAng	1301	1826	1826	1616267880000
2491	3NKLzn5boboG2zh6fZKvLfC6xDEAF9B1V6XNsgUUCz2kSQ336E3J	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1560	1165	14	1	2436	jwwhxEx4D828Y3FkNMqHLYwe9nvVLwo3Nj5DAfjMGHp1giroch1	1305	1830	1830	1616268600000
2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1631	794	14	1	2437	jxzMMyv5UtG7GQa6WMiNwy9VKKzrfuvGhcnHq7qEZeY8Hvb7mvk	1305	1830	1830	1616268600000
2495	3NLvGv5c8j6v2W5j5ceg1SVVDttZkYB38fiZacH5GPRQFAWBTS2e	2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	1571	1209	14	1	2440	jxUBwTbWUKcqcuKdfnKDhHXdRXAvuBsdFqs4gysoY6MGQsHakzk	1306	1831	1831	1616268780000
2497	3NLeyTzHsDuT6iuEACaWP3jgLYGSPgDU7AYeLkusVaH9WcoTYVJ9	2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	1422	1091	14	1	2442	jwwBcmzgHy4oekAbKx9F1fxPApfQG9X3THvFZjw7fdUUmRXrX1C	1308	1836	1836	1616269680000
2505	3NLMRY6y29xjps56P1mz13YAJBk8DzazCQr6BRqHc7p2y4VSZyek	2504	3NKRHWJJKztPG2rexXPdQ2RJLmXcUCCMZvGJZZFv9wwTqQ7D3ZYc	1447	1345	14	1	2450	jw6dsuLixUhNQBEZLY7zQj1VY8uN43UXUVxejp6tW1RTuzeV2q4	1313	1846	1846	1616271480000
2524	3NLfQU8DmifBjyMTjVQmwBGhpZFFj9bu6DxHhweqMqZpnPt9DtrM	2523	3NLxi9j4qDPDz4AnGuqRcrSU1oP9tsF5HPy4ApoFxx26ba92sTvV	1631	794	14	1	2469	jxCFyA9CRK9B86gncdpRwMwP6ZjihfLjtgGQyNjc2tgZMvg1Eij	1326	1869	1869	1616275620000
2526	3NLp1deJBTQw8gYJ9fxK2XH77p9qMZhB6dRtTKfGdhP1Ztm6pYBA	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	1483	78	14	1	2471	jxBxDyKHbcY9ZSJS1YdAtvCE3ymHCzVub1SGQmr3kgvjZpvzMdH	1328	1872	1872	1616276160000
2527	3NLX1YTdSE5kDxC9mvoWSLn85w9jyxMq91ykizwMYn3KxMX9HnWV	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	470	1183	14	1	2472	jxzPFwodmZKgpEZE4Gh8vvpUWVQ9cLrRcnp3PpQatFsKBGnCRYn	1328	1872	1872	1616276160000
2529	3NKmRy1wuGbNbURn1e2CmiLRs4RtLAw1yb3DXahVUPtggu5SHFZs	2527	3NLX1YTdSE5kDxC9mvoWSLn85w9jyxMq91ykizwMYn3KxMX9HnWV	1637	816	14	1	2474	jxDtfSv55eBSYP9TytJgXfrL8MBiLxLFDDqf57jZWwnVyC6KdUP	1329	1873	1873	1616276340000
2532	3NKxfcpRExBbbY7zhF8j7Xn1Ap6GEbfnBCA515M7gMyb6DnjaSQH	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	576	1229	14	1	2477	jwj6Rx5VWGHnUtP4RwA5SViBugVZnJAk6s5u2Z983ACMJ391k3f	1304	1876	1876	1616276880000
2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	576	1229	14	1	2478	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw	1332	1876	1876	1616276880000
2535	3NKP3VfQ3WMUkPRQejLR8zb5pGD4jXppDtkBvRpn7DFhrQJndgGs	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1458	957	15	1	2479	jwuXTcsfPywEhxwvbqZCoJ9qshrZS4QrUjm8KBr7BghtULWGaWe	1333	1877	1877	1616277060000
2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	1439	1279	15	1	2480	jxPuS5p23y8C9JvRDPrqkAYqTaX6DevjXoFSa7P4KDFtEjgo9Uf	1334	1878	1878	1616277240000
2539	3NLZJM9Pbf1XonL5rdqHXvKYTMgvbREwZnmKnE6JwYU5QAdYRvaW	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1405	873	15	1	2482	jx5gaAFojS2jxSV3cFpBcdAmZbqdm53iykQvmSRXAQZDAW32oBw	1336	1880	1880	1616277600000
2541	3NLQBrUPdr24mK9czDbR6cbA7w6JNTfsVSvQ7KtdYKcaNmPvkxZU	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1406	1393	15	1	2484	jx5eUYuC6HGafRV3fU6jCrgMRKZ6FK5jmfYhJmQNHMDkTarYp9i	1336	1880	1880	1616277600000
2542	3NKHwaFeFJpBJk4HnapVDRks3KWa6hWTu6vCjK7RbUQuod6bGx88	2540	3NLsqcCeffMk9VR64VK1kx4RtbiWCJcjAqGN7unhkMtqiGNjKd5s	1559	987	15	1	2485	jwzPdpsAPC5ScYMw6H9UwhGTStFAX2KiKnaLfZky4jV9tsCHvEc	1337	1881	1881	1616277780000
2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1642	1367	15	1	2488	jxCgq46mBUar49gTt1WBw7HatmngweDjSVtyepkyukq1w1rwRgf	1340	1884	1884	1616278320000
2547	3NKMsMAfNQmwHtALppaxMZNrm2BY37DymJva3j3nDy4azMmx1cZN	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1587	319	15	1	2489	jwcezy5xWykAfaS8znSYy25jvh2dps6HQKCaDNfiAWzSUzLJGPR	1340	1884	1884	1616278320000
2548	3NL7NMivd9H2WCtBuMwfwEyT5JZuewEZGq4uwY7kUR9vpNK5vYdm	2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	1579	1263	15	1	2490	jwS3M7QFDMrtczRWtNtAXGdUFzDrjhU1MwZphQqBHy5P3EmxA7X	1341	1888	1888	1616279040000
2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	2550	3NLmABi44QnET56cC1X81ctrFh39AGjVw4GASiC9mqY7xb8xzVnF	1647	1302	15	1	2493	jwKwfhx1LBPQvEmroDCNFzABqS7QEDS64hfAWsKcTmPDRXC511U	1343	1891	1891	1616279580000
2555	3NLJHf6SvLqZfexBJBUuxEm8tGGNwbKBrGNo6QKGViodk892o6EZ	2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	1646	1108	15	1	2497	jxHwStenXSdkLsm4adEoToMYZyzZaKVRtEun7LagjCZS2aNXxM4	1345	1894	1894	1616280120000
2558	3NKfxeVDo2C8yqauVgSuvSAaPQPVt8ssT456aqJ1hyDJz1VeSpXo	2557	3NL45CK4s21MrkvvgYLwv52rdsQx7Wd1yNL3CQsoFzHrNs4Zn3iG	1405	873	15	1	2500	jxw8xMFPhDQscZ7oVPJNudKTTEFmVA5n5XBV7k7LwVopWiNJ5Bx	1348	1898	1898	1616280840000
2561	3NKydTvrUos1j5EdPiDWSZkYVzptcCVeCe6bqxu4itNgw744CsWg	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1578	1050	14	1	2503	jxxVz6xwhAC7GFdo2kzBeoZ9FVJHkHX5ToQBQ9sHihDAqwx1J2T	1321	1901	1901	1616281380000
2570	3NLp2UmJHBhphR4SmPEGdeBS2wDbAxtnjn3WjYdZgkNdW7T3eeK5	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1445	1290	15	1	2511	jwwYuaeNWXXJS5NShfkXyYvbaRd2hLgRssgk7MfCz4TXvWqtU3k	1353	1904	1904	1616281920000
2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	2567	3NKUsh1Jr3tD92ZnSidZK9VnHpHMpmRkKjYDK54piT7B6q2ebdCJ	1407	1395	15	1	2512	jx96fDoGYkToezmsFkjkyPk5ijsbZbv6rMHxfpQej88G4ombGSs	1354	1906	1906	1616282280000
2574	3NKyN8RrQ2qsXB13eZToRjXcTr3VNZPacZgVN7q5KPYjngcU1kag	2573	3NLaYB8MHrq1bKfsJScWz5pZY96Bxqrabih3UNNhpUcddYgQf2CS	1555	981	15	1	2515	jxtjkPxf4BVSJxAoQTS9FmLpjAaRkG3YsX8XAfPhsQFiUz1BfNN	1357	1912	1912	1616283360000
2520	3NL3n3tufo1uqD1NXWemNJLHJc318KJqz6JGwULLqHeXKeGf8MGm	2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	1589	1286	14	1	2465	jxLtDDX1k2sgknd4L6fNmQek2BXsz617YkxZwVFZZjdPeLqHsyD	1323	1864	1864	1616274720000
2521	3NKyHuppukkzCPMQ1UPs6h1PzbLz45JJB14qr8Qbwsf6X13eG67e	2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	1627	1139	14	1	2466	jwnQyf6Rn34rxv8AxspyJHwYWZUKwhfx5EW9Hr3b9KFFUMCve9T	1323	1864	1864	1616274720000
2523	3NLxi9j4qDPDz4AnGuqRcrSU1oP9tsF5HPy4ApoFxx26ba92sTvV	2522	3NKQV5TBdmZNS66LUF5dhTZbuU14frKzsPWQnnfVjXF4bPQ4J5qt	1506	1373	14	1	2468	jwsSiTQuco9Qzr244RW7bVmJq5hBtNBFznPSuVoSDUi33TJgD64	1325	1866	1866	1616275080000
2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	2530	3NKxLEXB8WGNp2ngnuKk7PrUAQhVnKoGmujKx2tZvjjSYgVq3pFD	1600	410	14	1	2476	jx8eebiArUN8VGMCpW4485DU2CoLYwMUwT47LqcCRtv28b3iDzv	1331	1875	1875	1616276700000
2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1458	957	14	1	2479	jxiWEPJ84XJWmqEeFAHBBwp98N8g7qwMWUXxoVQwxNxNeHZQRZV	1333	1877	1877	1616277060000
2537	3NLXnEZhSGFhGiqrk8gdPX2thH7BWjUu7oSKh8WDLSDFUHUQ2gFC	2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	1651	1175	15	1	2481	jxGtVF5P5KVjmLmKhFHBoQcWqJ9tpcUFiNeQgLot8oP8rEZQa7R	1335	1879	1879	1616277420000
2540	3NLsqcCeffMk9VR64VK1kx4RtbiWCJcjAqGN7unhkMtqiGNjKd5s	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1599	1287	15	1	2483	jwmrib2ydATB44h7jWzoYRgnAhNtUYiU6qPmRJe9cFdabq7zozQ	1336	1880	1880	1616277600000
2543	3NLQ9ryh67Gftf5RFu7NuiNopj7o7m6i2vk4rWfJxgWybrpGBdLZ	2542	3NKHwaFeFJpBJk4HnapVDRks3KWa6hWTu6vCjK7RbUQuod6bGx88	1406	1393	15	1	2486	jwXvKjyizUt5btaue8GWA1iDZmv2f9hYoLPCw58X6mdfxDyVzYE	1338	1882	1882	1616277960000
2549	3NKFAudBwn4edkUFTVLmhQp2mXJRumNDrKwhmgZfgHD7nadBFh3f	2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	1402	810	15	1	2491	jxqx4SQegSh98Xj3GGMQFTAAarPxaWUHji67sMJmkhxBCAybPyq	1341	1888	1888	1616279040000
2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	1460	1198	15	1	2494	jx6f7QqX9mAV6Nh6539J2R48NRwnWLzAZwDHZYzMBQoRu6Gx7xo	1344	1892	1892	1616279760000
2556	3NLtbHCHosneoZLPqW5d6EYZVuvgRDx9M8NUqhNH4Am1SpNduf1p	2554	3NKRFXrxum8bWMqgGSRkd62NnDu4vadp4VUb9t9rQN9pwfJPvpK4	80	1273	15	1	2498	jxHykH4SsKJEAGRSaZ8tr7ZsDVCkRyQR8qabPzvzzWLbGRuNKJ6	1346	1895	1895	1616280300000
2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	2558	3NKfxeVDo2C8yqauVgSuvSAaPQPVt8ssT456aqJ1hyDJz1VeSpXo	1447	1219	15	1	2501	jwbuLEu5onjkjKJQfBEpHfM4wocaVQpCzm18figvN1EFrqNwU3r	1349	1899	1899	1616281020000
2562	3NKHcq7xArxrUGUJsoe5Nw8tZr7aNhwiazTbbxzmTYHTm9iz413w	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1651	1055	15	1	2504	jxovmy3jBmz9WCTu8vcNBpQYGctAoU2TAXF9AuHwHQocMgCGQo1	1350	1901	1901	1616281380000
2564	3NLThK9PPiPBdBBVpmxy4pfrf4mqBGjwyJ1Rbuhkr1xWMN6CeP3Z	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1651	1055	15	1	2504	jxCWzWuXtywYhs2CFmF9XnnLF4ot3tRFD2mf5ZMQSLhNSwHVDnB	1350	1901	1901	1616281380000
2565	3NLXvWZz4y1a5AdLTzNpTf6qJAr99iy56gV2fe2MGyvijHF49pk6	2563	3NKb2j7AECPkwD8yirfL519gUEziDhaFefxqCXrnbqzgWrckxfuR	1405	865	15	1	2506	jx8esXGnf9sSpFQSwL2vZZ831AE3D9SxQURGtUpmPbdkHTauacy	1351	1902	1902	1616281560000
2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	2565	3NLXvWZz4y1a5AdLTzNpTf6qJAr99iy56gV2fe2MGyvijHF49pk6	1585	1366	15	1	2507	jx71RvQDEuPdJgqMnajg9m44hdADuR3n3kLmA5nkDMhBgWFgrdj	1352	1903	1903	1616281740000
2568	3NLn66ZftSkahBc7n1M7fLuKqYWnH3ehSs6NtEMexuMw3zuE4WoB	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1407	1395	15	1	2509	jxFLdzM56gnH3fbWXzmevGyP5W52XfrjgY7bNx199eDSzhst5hL	1353	1904	1904	1616281920000
2569	3NKsog9yAhtzAV5sNSEnNkSuP8r4SRCLMqJKhRvkStye59JqEetR	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1518	788	9	1	2510	jwCK4Hq5ScLfhaBRX7dpAdTBjShauudHAXADGQ3ZKhxpJT545a2	1144	1904	1904	1616281920000
2572	3NKy2kMCNy94VtGCaSoJ3NijKKgz9ve3Ten2QcKK5MqqcN7ZZNu5	2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	1467	1376	15	1	2513	jwCi7hS5uL4kFHaR1gUYsmiGWdrxTbFko7En3ESDziJgnoMv2PF	1355	1908	1908	1616282640000
2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	2574	3NKyN8RrQ2qsXB13eZToRjXcTr3VNZPacZgVN7q5KPYjngcU1kag	1553	776	15	1	2516	jwje6zzViVSM7xX7quzFvpPUT46uPrzxyEaQibzrfyiAUXLun3e	1358	1913	1913	1616283540000
2578	3NKsyR81VHhYVvvbDESndUhHo6Q9fZFQNJXvRkGhWLesQ2tC1Xck	2553	3NK6uWsjghCTMtKVUtG8mKgRtY126hvhSLdwBMS579NFZJQBXk7X	1403	824	13	1	2519	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1278	1914	1914	1616283720000
2581	3NLnLKpVqnpdKNgnxWDLVz1Y1BarozA3dEbheA5A1cx7JofSY6oC	2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	1402	874	15	1	2522	jwiZ86oHha1kiSqa5tf1pu73toKGVHHNEz5W61MUK6df649Dwwm	1361	1918	1918	1616284440000
2589	3NLfidrJru32R47ykCrcpU2YHcipeyWuvPRFDN1xm6rRoX68qDHh	2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	1602	1003	15	1	2530	jxPzuQ3C9tnV7Ty1faAfMvzq5a2jopxvztCERQyhQ9C72WSaQd7	1364	1922	1922	1616285160000
2592	3NKCn9Abb5eTLoqZKrS7QKT7FiRwBekQ7uiXn2U82YTerhQZgoFD	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1509	1320	15	1	2533	jwSvDGyCozQB3LAiABnnF5t9gU11ZidNAdmi13Y828AWBqeusEp	1366	1924	1924	1616285520000
2595	3NKYQVXEkBBLbq2QkmVHhsaKT5UtYrmKs9B82BaevHfPwzPiyGT9	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1536	1313	15	1	2536	jxcfMS9NZzVPpxudAh9ew8DsJjMrhHunr1JxbmUh2XcAiTbvXfF	1367	1926	1926	1616285880000
2599	3NKqiRMA4KdWKuZ2UBAf7rUEJnjXDsbgsjRvV5EvTPqEpk3tNfg2	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1503	1151	15	1	2540	jwF2mhs9PMBt49yXJGFzx5FB5AVxUs4RSKhemFta1PBRoKbwbXZ	1369	1928	1928	1616286240000
2602	3NLyVsYufmfrLg6trGisyL116uJEp6Kbkw62NWHTKsvFrPu2Tgx3	2578	3NKsyR81VHhYVvvbDESndUhHo6Q9fZFQNJXvRkGhWLesQ2tC1Xck	1403	824	13	1	2543	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1279	1928	1928	1616286240000
2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	1507	1034	16	1	2546	jwGBDqCTmyjXDeMW1mxcqJ6j7kMixv2E6TK3bfVDt3gdKKEJjeY	1371	1931	1931	1616286780000
2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	1637	816	16	1	2549	jxyjiwUJpEgZ1CaJMjTPKmRC6NS8ohXEc11s55pAiFZUBrUnCmw	1372	1932	1932	1616286960000
2610	3NLx49mpdZiUrXAtoC6rrzDLkY1y1G7pyFrcTonKTqsCEGQ14izX	2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	43	1064	16	1	2551	jxSLVHWQMV7MnDdbfi64JgJc2EtdXKk6bY1cDuQY4tMoGLfqxhe	1373	1934	1934	1616287320000
2611	3NL8nCmrYyhsDtUz36aampyc3w5bBEHwZKBrMBD88VeWtcKThJkN	2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	1578	1296	16	1	2552	jx9EUngBkJL8EmJdTxv88WkMS9QxzWfT7PNeLd2uhLPM8ca8tdE	1373	1934	1934	1616287320000
2546	3NKT58MmQpmjtjSD4fyEw6JVCQFifiPm17pwN1pRcGq8Kis9wSp4	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1587	319	15	1	2489	jxvMPkx649ZZhtNCePDdWZw74wsdZMTQGDTdK1KpoPmiqF5pE68	1340	1884	1884	1616278320000
2550	3NLmABi44QnET56cC1X81ctrFh39AGjVw4GASiC9mqY7xb8xzVnF	2549	3NKFAudBwn4edkUFTVLmhQp2mXJRumNDrKwhmgZfgHD7nadBFh3f	1407	1395	15	1	2492	jwNY1GHAYL4iRLMvtec1XuQc4LaiZ6tsh5nYxQH4F3cDf8TDc8L	1342	1889	1889	1616279220000
2553	3NK6uWsjghCTMtKVUtG8mKgRtY126hvhSLdwBMS579NFZJQBXk7X	2439	3NLRmzKyYXZpoXt88EKTQmG3KFAMAsiG2nPYWm2QWxt7Pdz5n34s	1403	824	13	1	2495	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1277	1892	1892	1616279760000
2554	3NKRFXrxum8bWMqgGSRkd62NnDu4vadp4VUb9t9rQN9pwfJPvpK4	2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	1402	882	15	1	2496	jwD3BzcJ2Lacu7idj3pQZrhJzo1Z5GRbJWQZViupGRu2pjVjH84	1345	1894	1894	1616280120000
2557	3NL45CK4s21MrkvvgYLwv52rdsQx7Wd1yNL3CQsoFzHrNs4Zn3iG	2556	3NLtbHCHosneoZLPqW5d6EYZVuvgRDx9M8NUqhNH4Am1SpNduf1p	1555	1347	15	1	2499	jxW1qdDDDVyNL18uELGRZwXp9gN5dy7L9rddLNtZQW7eaBSDDkZ	1347	1897	1897	1616280660000
2560	3NL73C1v9kT4MFhM7YPbpTt1UMi5uGyud3N9pw1NfERg54JGgaNk	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1560	1165	15	1	2502	jxJxytADYEhu6upYzoFCaBnJF5VfuHVkcq51SdWaBHbhbqsvRBe	1350	1901	1901	1616281380000
2563	3NKb2j7AECPkwD8yirfL519gUEziDhaFefxqCXrnbqzgWrckxfuR	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1578	1050	15	1	2505	jx9jf5wqBGP7EHvn3JkJq7x2B87Nm6UZvcub8chwGRA5MX1t1QF	1350	1901	1901	1616281380000
2567	3NKUsh1Jr3tD92ZnSidZK9VnHpHMpmRkKjYDK54piT7B6q2ebdCJ	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1467	1250	15	1	2508	jxxTJfSSwrsdoBfGj2d8wKdqrU1K6zzKhuKVVnsv3rvrEpKpter	1353	1904	1904	1616281920000
2573	3NLaYB8MHrq1bKfsJScWz5pZY96Bxqrabih3UNNhpUcddYgQf2CS	2572	3NKy2kMCNy94VtGCaSoJ3NijKKgz9ve3Ten2QcKK5MqqcN7ZZNu5	1631	794	15	1	2514	jxwcy1gFcCX7tsZh4QPN2Y73Ah6H8tMMz3sXRL856EijgNe7muy	1356	1910	1910	1616283000000
2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	1407	1395	15	1	2517	jwvqF3XaH8AS2kKeeKd49PigEWw6RaFvSquPVRTnM5VdoS5DddE	1359	1914	1914	1616283720000
2579	3NLL3it8whJWQvXz82h7bPCLx2L3spQPoG1NkDs1L5NZxWixYgQM	2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	1672	1285	15	1	2520	jx5SCCxG4L7CfS144SNa6SFAKdfkvnJmXQ5RALw8219N2foJsyU	1360	1917	1917	1616284260000
2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	1457	1391	15	1	2523	jwoTUez4pVqUJCjP89Bvi4kBFnnbuCgJQKQHk7wfbtPprrKgAzy	1361	1918	1918	1616284440000
2584	3NLTq5AvNyDFbVH9BRKQUTpyoitdjAnv663pUsE9NhuMcr1sHBzf	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1405	851	15	1	2525	jwwYpwf12xTRqiThRWCwu8toCuBiDJsS95RdnYYD9SFhdtsWdCV	1362	1919	1919	1616284620000
2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1631	793	15	1	2526	jx3viSazvB9iY1peZDhmJ4jDHXRfbAN4kYzYatTcTRm76ds4qzz	1362	1919	1919	1616284620000
2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	1527	1167	15	1	2528	jwP11a77mhaEn8v99UCzJNui6xTaR8kLGPYXdeqeWtSJ8R7DPPY	1363	1920	1920	1616284800000
2588	3NLPBPJZodsedRsGQt5wUnDHqqBRT97fpXQvSoVFG8oAuJoKR4Ry	2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	1553	776	15	1	2529	jxpRDKtTDyi3CZBBTZVgyTkj2TNKuHtxY2TXxX51h1naGX9fPRC	1363	1920	1920	1616284800000
2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	2595	3NKYQVXEkBBLbq2QkmVHhsaKT5UtYrmKs9B82BaevHfPwzPiyGT9	1483	1276	15	1	2539	jx4bVAeCgd2opy2N52Y8a493pejhKSNpoHaLJbwVt2Ar316w4Lq	1368	1927	1927	1616286060000
2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1596	1363	15	1	2542	jwC2GikqzPvAborRYJmYhoFtoXiPeWD93XWxnndh4LF61NkvjQ9	1369	1928	1928	1616286240000
2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	1477	1104	15	1	2545	jxNRdniDCe2zMSaZByH6T37i8FoMs3AZvyodke78hFu7QVpBLbF	1370	1929	1929	1616286420000
2607	3NLeV9LptSNgsYqxbGxaUUaa9vXq31MKE3JKn5aHgvpjHoXGZcBY	2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	1527	1167	16	1	2548	jx2xhR91Kq4hXz4aDmsn33uWN8UCrHv72NjFvJWQK1ExVXuEkGx	1372	1932	1932	1616286960000
2577	3NLHyU3Xzr6VzMRB9unxSCDvLwnBMZtZVKegci9C6drYM4ssu9Da	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	1648	192	15	1	2518	jwtvBsb8XYmTWCVjKB95cobRuWYVBHbD3A2BWxKUWPnqaQsnTVa	1359	1914	1914	1616283720000
2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	1613	1103	15	1	2521	jxyEpg32zBgvqeiPARBgieTuR2Ue5n5B2bLxiLzccRar9cDYSJH	1360	1917	1917	1616284260000
2583	3NLusbXBtpzMTEcg6bmFnPyJ5AW5ahf9MkXddig944KmdEz4zS7D	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1407	1395	15	1	2524	jwR77cStccr1Z4BeKC6Z8pajPkMMg8C7qLsFwNsYHa66coAoJR4	1362	1919	1919	1616284620000
2586	3NKK3fcmmQwWt527RYaAJSP9jVrri84jMryg6MNMGd45NtkCQFJ9	2569	3NKsog9yAhtzAV5sNSEnNkSuP8r4SRCLMqJKhRvkStye59JqEetR	1518	788	9	1	2527	jx7gX6nj7kiT3GJjUVnjmzvkEJcCTDR95f8j1oW76wpd19D4f9j	1145	1920	1920	1616284800000
2590	3NKqTgVq259TMxnEmx15M5RSsvLd5cwWjGQhjjJ3zqaRiPegF2Qi	2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	1637	816	15	1	2531	jxAgGjKRaccthFbtJWKH2xECzMy261EynkeMHxK5eky9xcRaJtC	1364	1922	1922	1616285160000
2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	2589	3NLfidrJru32R47ykCrcpU2YHcipeyWuvPRFDN1xm6rRoX68qDHh	1402	850	15	1	2532	jwnmEWpPcfQGLGTaNZs644cuPaWbe2n2WCHYvUivFXmVsdaQjkZ	1365	1923	1923	1616285340000
2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1552	513	15	1	2534	jwpQmUX42cgqh6t7SjDNmorbQNStscKRL76qKcaS3qKLdGsbWvz	1366	1924	1924	1616285520000
2594	3NK8RsaDPyBpGyjWPCFdMSuhZbXmPq2qfQqxVdgPgeKiVsqfuXkQ	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1473	185	15	1	2535	jx2otfHtStP5Uz5KwgMAw8bxsi1THL1prc8DByCT3mY9p1TU1kB	1366	1924	1924	1616285520000
2596	3NLFFLSwmkHYqoWBtLikmreU3uNcXrk1CrC4Uux3HJHnLewtWUme	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1623	830	15	1	2537	jwqkyKAG3tWtyBzQQ9ZRsgq5RyEgZKZn5a57zQ8ya8t6oX6Cjby	1367	1926	1926	1616285880000
2597	3NLZgvzzAsKqyncK6jxZNrpSDARq8gVhYWxMs4B5fdSUQCdy3BTH	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1406	1393	15	1	2538	jxfUMSAGCmRa3aFwL1AxgCmC8Hjypp5ZKiPKXHUezPYMcg1NCM4	1367	1926	1926	1616285880000
2600	3NKuzrDkMP87ZLarS5DgJwtx6Rz7Z6y3cnEjgpqYehCfDCdSWdp1	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1654	974	15	1	2541	jxAVJXKPK99XNJg7pJ6yHd8ZanXzuCVo9mbWymj9oDjp5L8vcSR	1369	1928	1928	1616286240000
2603	3NKy3LTftVNA5Xx3ffixAf8QHyFiKNiwYo62ftPaDx5MrtS5MTE8	2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	1407	1395	16	1	2544	jwwSPjs865tAmAvVdBLtf3FH1x4TWWEPYxwePhqrBmo7v1CwgvK	1370	1929	1929	1616286420000
2606	3NKoLTSLDudyRCYim2xbbcx9Pukj2LDyyvm8RqpfuqnM8Ue3DEq7	2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	1637	816	16	1	2547	jxk8AqNWzeRZXr4AC3pQjct9bTxH9DAjLVbtgruWb2q5CUwtQEg	1371	1931	1931	1616286780000
2609	3NLdKvgPC7ZAySm62gCyGJJ4oE6w7zA6pnWkKZi5J1Psxp2VVKA5	2561	3NKydTvrUos1j5EdPiDWSZkYVzptcCVeCe6bqxu4itNgw744CsWg	1578	1296	14	1	2550	jwh4fUhQAzxQzK6RXUFeehoYYv1i9AdJAT5U2qcY7jcwP44BwQU	1322	1934	1934	1616287320000
2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	2610	3NLx49mpdZiUrXAtoC6rrzDLkY1y1G7pyFrcTonKTqsCEGQ14izX	1406	1393	16	1	2553	jwoWQ7cB5RbSUT7YuV5KYYUbVQFeni37H33h8ahGqyrWJqoqH8Y	1374	1935	1935	1616287500000
2613	3NLTeAXhGfsQpXP4w2f5nLi6TMnoUfVJGcPQBJVsLWp6wwo6CEJU	2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	1599	477	16	1	2554	jwnHwjrLoPpAHA8o9HWuD4y3DcnuMD6UEeDseoqnHcWnFwNMrxy	1375	1940	1940	1616288400000
2614	3NKk7ztxQ4UmLxWJwU1kfPmsi1MdK9ScntFi8HqJjFwCVoHAG8hM	2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	44	1325	16	1	2555	jwCgnqF2WNqJPgnwKtJ9R5xYESzJKGTTmBf7Yoj6pGrDpMaXQV8	1375	1940	1940	1616288400000
2615	3NKe4kfrP13WRhZPTmU1ZxUgpZscWPNP1ixvR3uAoZd8AHvsEDh8	2613	3NLTeAXhGfsQpXP4w2f5nLi6TMnoUfVJGcPQBJVsLWp6wwo6CEJU	1613	1103	16	1	2556	jwCzQWhy2KYDW6JEpMKgPNLNJFSanHAenwn784akrtpnmuX8cwD	1376	1941	1941	1616288580000
2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	2615	3NKe4kfrP13WRhZPTmU1ZxUgpZscWPNP1ixvR3uAoZd8AHvsEDh8	1587	1357	16	1	2557	jxMny7BaSCMznkUFRt2PzXRhAkYhAC8EZwYvZ8rQUHo3thoHtKc	1377	1942	1942	1616288760000
2617	3NK4xcbqzEai4gFyg1gB97Vu5uCjEXh3Qs26rqzzpTtbDffMENyg	2602	3NLyVsYufmfrLg6trGisyL116uJEp6Kbkw62NWHTKsvFrPu2Tgx3	1403	782	13	1	2558	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1280	1943	1943	1616288940000
2618	3NLrqH1eKuZamQ49v2F3gj9YwQP8f3uuQBSqVfAXk2BBvwkwbddu	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1652	1315	16	1	2559	jwxoNKhapHxiMfWtJ2Mk1xcVazUNkzWiLT5EYg539iNiQEKvXMQ	1378	1943	1943	1616288940000
2619	3NKtv5dT7R1Ubq8x6fuceZWuQUbYWEY2PD1tt9A8uZ9LqKcptzrD	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1406	1393	16	1	2560	jxdNwwEhxuhC2gE9iRn9oZMuFx8GPhnsq8g7Vq5j4UWJ3X7aj5c	1378	1943	1943	1616288940000
2620	3NKSCVgRgSDkw49VE9ryokXhCeoVpMuZhhMrci3PkLfarjNruUAq	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1652	1315	16	1	2559	jwLuMbgrddfyjdETmLJ1ezrgjxp4nDF6rbDQYP5CpnVeWjKeYeu	1378	1943	1943	1616288940000
2621	3NL4SsSq8pWeypnc6BGR9jTX7RzN8nUkm4q2FcxUDHTrL61BKFwT	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1581	778	16	1	2561	jxV4zFemw7MHAvqZkmycJxhDcxuQC77LQoPkMW4pbtCTGiyEzT4	1378	1943	1943	1616288940000
2622	3NKEaWuwEvfwFYfHBrH6H4WtLZEogSavTVzD7pBT3FNacUtDyJib	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	606	1049	16	1	2562	jwvJijJQ5P7X1fXTTeDoVZZUzgXQduAzzRaqocT2RXvgrKAzYMV	1378	1943	1943	1616288940000
2623	3NL74u8qM8CikiHZXLYPJeKrf9httJQCCfS8R13ZmxDU1QzoBNqd	2621	3NL4SsSq8pWeypnc6BGR9jTX7RzN8nUkm4q2FcxUDHTrL61BKFwT	1610	1314	16	1	2563	jxyXE6dhDaXoHkL4ycc2JdyPifQzY9Ucd7dpznVUhM7FEqajZgE	1379	1945	1945	1616289300000
2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	2623	3NL74u8qM8CikiHZXLYPJeKrf9httJQCCfS8R13ZmxDU1QzoBNqd	1527	1047	16	1	2564	jxQzRndt8mo45vsgYDKkSGoFnh98kGkha5JnuYQHa9XZy7gRPAg	1380	1947	1947	1616289660000
2625	3NKGygFghCvHn4YyrAYhS6YhHxAuc37uhnEYjMzSP231nvfyCNi6	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1407	1395	16	1	2565	jxkhjwhnHtbBkwGekd7kXMmVNxGY5L7ZBxa7Pou2DdbEkY4hKnr	1381	1948	1948	1616289840000
2626	3NLGHaaUkWj4oD4WtSTXeudpK1LUcYULsfZKA32E7dymFUrxwAf6	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1451	1292	16	1	2566	jwqzJKasEmEuwEtYcfv6mEcbNBQLhK5FVDRCJDKm9nPDV1N8ADW	1381	1948	1948	1616289840000
2627	3NKMWRYWpKvg2Eoywe1Aejgr1ySk2XVbUcC86pGXjEqfxYYMvLBD	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1509	1320	16	1	2567	jy1ewM34mLXE68kGLoZR4WDjstCANAEFKgHecd48izc9rY1hCi2	1381	1948	1948	1616289840000
2628	3NKCxJXu15oFHahQJ75pR1R2wkn17Dwq5mpiSyvPXzqshJ2sArbU	2625	3NKGygFghCvHn4YyrAYhS6YhHxAuc37uhnEYjMzSP231nvfyCNi6	1503	1031	16	1	2568	jxbWbgbnpz1X42u7P2HZUZzCaF5VPoeRXh2dNZB62cxxiEFxuXP	1382	1949	1949	1616290020000
2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	2628	3NKCxJXu15oFHahQJ75pR1R2wkn17Dwq5mpiSyvPXzqshJ2sArbU	1631	794	16	1	2569	jxdfpVFNZHvKx21BQFpxqY89agLsSEZDPCtDk6xZNx4KkJLDFTa	1383	1950	1950	1616290200000
2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	1571	1335	16	1	2570	jxZ8SgwHDKsHGabhLoMBZXiHgcSNAuC9F8pLinzgpGUt46EJ4QC	1384	1952	1952	1616290560000
2633	3NKZfmSLQWAkyxjaBugP2RAVuAr8A4VVra42G5gmUh4JEGitxj3j	2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	1406	1393	16	1	2573	jwhFzDBe3aP8ZwwKPmceqT8u8hKurzsknFTftykEhKtWg1WQWdM	1385	1953	1953	1616290740000
2635	3NLG5Bby4RBpwohHkaXzT5DxVMHKRk57nHEaF7n6YkgriAeg1QGC	2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	1652	1189	16	1	2575	jwKdVrZn1mihBjhL2TpVqMGyr9xqmmC6Ph7PYov1PDkadhHgEEA	1386	1954	1954	1616290920000
2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	1608	1043	16	1	2576	jxhPnFVs6MA96zSdD67ZqoGnXVxbSi2Z79fMcHLj7t4ZxmQesQQ	1387	1955	1955	1616291100000
2639	3NK5A3X7JJiJ8rwVg2uGmcEL6iuxsS18DrmrkMZgHktUt3isbnXK	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1527	1047	16	1	2579	jwXhDcdCqSVyzV57GLFxfviqKKZXoBaZQfgPQdkaPjcx3qVfLm2	1388	1956	1956	1616291280000
2642	3NLTTwyG2XwG31jvz9VSYycdTCsnSG69vtHixQA9Q9PB4Mi1ECA5	2640	3NKXVMJF8HGcKmEFgC2pLdAj9Kwu57stKJgzUVmCND3s66ZFfA41	1406	1393	16	1	2582	jwqzYDH5CKHeqK2Aan8EXarLF4rNjQVHPmQZPNNRbkVr1hbQJMN	1389	1957	1957	1616291460000
2645	3NLnG4SBmBBTrGsmZLUS64FYHDQfdpmPTQaEKxGRxRPNwQEw9y3T	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	1608	1289	16	1	2585	jxN6RshBWTQDEvMtYckANrdVLbFgC4WEg5XNvrVJyBs7T1RiPYC	1392	1961	1961	1616292180000
2648	3NLLDCuMdmE3YSQKH5AN2KTjVq8BSjLg65qAEx9d5WdXogGatLQj	2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	1602	1369	16	1	2588	jwp7fFQXd7RwXeoPvt1ijRWd9WLvjgwy1c8UQTvbpnui4avNysr	1393	1962	1962	1616292360000
2650	3NKxNDQndytQ2on39jMF4GMDZf9wmLgCfSH5YuY9EDPhJbJ1XuJZ	2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	1471	1140	16	1	2590	jxwf9Lvb5ZLjUihnfW34YMjwHqWq58MGowTrVfgRhzjtXUMSEFE	1394	1963	1963	1616292540000
2651	3NKatpL1YhWzXEu4DhMFZAEd95PFtQYrwemwg5WLLqQFPKsBvJtP	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1477	1104	16	1	2591	jxrcByfzsh5a5ZgiNji1BvJqFwJ9kLLms6UMwy6BA7wcT9gNESR	1395	1965	1965	1616292900000
2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	2651	3NKatpL1YhWzXEu4DhMFZAEd95PFtQYrwemwg5WLLqQFPKsBvJtP	641	1336	16	1	2594	jwMesV8Re2HHvYHrXBv5wYtRJSryb5Ej9X2fb8jmxKztRxAf242	1396	1970	1970	1616293800000
2657	3NKjwR6Tt9zX6VEJPgxAjW5fXNoCD5W835s6VC2PLfj7qRFFKR2X	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1675	976	16	1	2597	jx55P7ukY43L586FBSFNaSkYSr3JVRJ7Awxwb16AyvgA26KrjZs	1397	1971	1971	1616293980000
2660	3NKKZx9sKzpqa6DdiueghGN2QUb4jfPzEipVycRo83F7XnbSYzef	2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	1542	938	16	1	2600	jxDH81xcTpSRCkPkdLZ9kP16cBW52CMgQzRewCguyYanJeG6Y2y	1398	1972	1972	1616294160000
2663	3NKzs9tEFDvdJq7r1mxjFsJT6ErX2r79LhzrBQ3qWqeS5wvVA9cD	2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	1652	949	16	1	2603	jxxEtTDx1mpYkFD54vasv5scG4YDYWJcCyZtCyJRALsrbJoReHA	1399	1974	1974	1616294520000
2665	3NKK8wJry7Fv9dVBgg3LEHNLeNjZq55GkfNJW8QMxdPfm3qFJQ84	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	1455	1206	16	1	2605	jxXmwHkLn2Dqgw5Az15NNMHpYjfQcC5q9KPSCyHNToLFf6fN1FE	1400	1975	1975	1616294700000
2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	2666	3NKQef4yQfS73G1XoZHhUM9raPqnb3bw7wxV77hyrBYSXFaprcmP	1506	1247	16	1	2607	jwiBGkbiK9KZbuFGQqhzgi7adju2ZemC94WUcXXTMBm6FwRyTUa	1401	1976	1976	1616294880000
2670	3NKJDCY1MgctG8PHS6ER3GXdXxoDAbd49KHGu1gqGmQvHBddPGgr	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1652	949	16	1	2610	jxNTe8wYud526YMpWByEhGDLhUaSZucnz9ZjwgvCkKJzkvps9P4	1402	1978	1978	1616295240000
2675	3NKzC4qiL6C2N41X5pfpNsSWmSv6utUwPCHyRvZ7JEw2GtJ9uP7F	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	1507	914	17	1	2615	jweQVFVeHPk8xGXX2r3B225sZqYUFGM5mB8BnVNkY8sJ8G95cWR	1406	1985	1985	1616296500000
2678	3NLFDZv4mMH9WB2qGi7iHEqUob4PNuBS1YLt5pvMWv87GDsCNrch	2677	3NKJvMnGrdKXWXAFTbBcgveheAxy8VFcH4D7ZPZYN1u5Bbq5fSHS	1671	1239	17	1	2617	jwcyNMV7MJtGhq2LtjUTd9Gv7vw9crFbF6ezdLir3kFFzK6gqAk	1407	1987	1987	1616296860000
2681	3NKyz9nK42rXTYZkg8cpUtqXmF6smkN9hKggvgUrvfUV52gX4bWq	2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	1675	1096	17	1	2620	jw7atxAs12cPVJb6rqfKYNsCUmw5LnBhvgGUBwCiaJUiVq4eYjH	1409	1989	1989	1616297220000
2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	1643	933	17	1	2623	jxXjajeb8R6GvFDt7CwyGrtVm6B62CxUNwgRHaLwieuDo1t2vbT	1410	1990	1990	1616297400000
2687	3NLLWUojY9LtvEmYqjThs6g76jhebjdugWXMTq9z98YaaYYjxHrk	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1422	1337	17	1	2626	jwnKwqPYYRtmrZ8rfbf31R2JxwStStFvz1fzZ7FY8nrz4gtL7x7	1412	1992	1992	1616297760000
2690	3NKB2Hfz9DxySNYqYZr2wiEPv4bwfeeDrm66bUdynZSnQC89Yiu2	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1633	1390	17	1	2629	jxvWGQgjUhCRcy3LmH2Lre8DPpUiBQxwRTE6zHBfMZKtein9XLC	1412	1992	1992	1616297760000
2693	3NKiGzX8gWTCtq4wdeKKspJojXB3XJhbpzUxTeBBWAmoaohAhaAL	2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	1553	776	17	1	2632	jxvjnTJy5sjHgBTMLWbUMhWfg6eZbJuuH12AVoLAArVH17472Kg	1414	1995	1995	1616298300000
2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	2695	3NKdNnBPqCqp9cDYBR5jPsn4uY3r6mXAt9MsPbsXny3YUVdMMvWt	1405	867	17	1	2635	jwjZeWWyq36xHX52MWwK3NQ6YSvf6FSghj5UQFTitzEgyu5nPDD	1417	1999	1999	1616299020000
2699	3NKRUZxsmT9NJ1bvYfcSD7pzrmQfDEe7VGan1idSLJQTwwWhRBLw	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1651	1175	17	1	2637	jwv6TREWrB42rVqeLhjuMRTnqEZmvQqG46XcH4fMFXyhMBm2XDc	1418	2000	2000	1616299200000
2702	3NKvF2mKccw67eM9shyoqgsXh9UPTPE84dohpkjwJ7CLmCaYAusR	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	1627	1139	17	1	2640	jwTgMhLDxhuFy5gKYdrJG9j853ESHg9osAMiP9imjjr9ZyUke5p	1419	2001	2001	1616299380000
2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	2704	3NLg9ki5DZ8p2ggPWMnJd6XBA4gysPafKMKTkydHhdpcSc3RpNQp	1407	1395	17	1	2643	jxRZF5LZ2ydUPyEvxPtDE4aKLLga3rzm7zEEr1udoAr1BLMYuGn	1421	2004	2004	1616299920000
2708	3NKqTfesXfBhvZqikYK8W5WrTj8QaF2hGcHDTytLXF58bNB4bSaZ	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	1624	1088	17	1	2646	jxcgiP42msSu38XqnNYJsah3KHGGAwBk5Jij352Zs3epZqRKeyW	1422	2005	2005	1616300100000
2711	3NKQy1Wdmrd4XLGoEuCAXfYspNCQpVH7ZtHG4vcgTn996e9qo1s5	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1646	1228	17	1	2649	jwzBAxT4Uti3uXh5hatRjyZ7sWAYEPcMyJWTRsAZxaagQw3XA4s	1424	2007	2007	1616300460000
2714	3NKYMXf6vPAtbVe1KXM2Hb6non52pW6oAvvXgNTWaZ7sLh9HFVZf	2711	3NKQy1Wdmrd4XLGoEuCAXfYspNCQpVH7ZtHG4vcgTn996e9qo1s5	1555	1347	17	1	2651	jwGs7cWr8jB6H2VEjCrgCP6311H7BjasoCUBFcRSdnQkGr2B4Gi	1425	2008	2008	1616300640000
2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	1509	1320	17	1	2654	jxLXCwLY7TsBiDcRjiG9o2RRJG4hCE2sJwRczH4HGdgggVxQyPy	1428	2014	2014	1616301720000
2631	3NKY7ZwJAmYSnZcrzsZbXKJ4ZELwAyivKn8iUArajPf46qhyMre7	2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	1474	1329	16	1	2571	jxxNnJbAP4q8HRXpForz2yfB7z5nhwoLt2knWJfgytUosR474pw	1384	1952	1952	1616290560000
2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	1634	1331	16	1	2574	jwsqpcdTdnNBdaJWJK7vJhd9buLjMUjZZu47a6uqKx4Nkps9Nmg	1386	1954	1954	1616290920000
2637	3NKgRtgTLRkbhS8A5HDa4ZhRt4vJ8UhQbTGNi341ZH5e3nFvSBAe	2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	1637	816	16	1	2577	jxuxdoHaBAzKK9DpjYt4K9v75ooSTGis21EGHt9GAa3TbsR2U3N	1387	1955	1955	1616291100000
2643	3NKhPdBraP28GEeocEoQ9EUt6y4aaB5brVjvz7c1iwGMaVRJ8u3S	2642	3NLTTwyG2XwG31jvz9VSYycdTCsnSG69vtHixQA9Q9PB4Mi1ECA5	1534	951	16	1	2583	jxSFeCcFAjCF443Nv2rZEt7xPLPsS8kJaggytYhfATiMDa5Veoz	1390	1959	1959	1616291820000
2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	525	525	16	1	2586	jwHEtFR1z8JtkXagsYhWFemzTRKpzbYgxhgj7EpPhofdUxbhAvT	1392	1961	1961	1616292180000
2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	1509	954	16	1	2589	jx7caUoESzkzaH8L12zfN6zacYNXXLjyDbezYjdjPjtn91PMBi1	1394	1963	1963	1616292540000
2652	3NKfB7Ygco3SzTKdL27jfK8QEDnJXcAab4S3px2ZCRWWQ2o8vi1v	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1506	1373	16	1	2592	jxR25i9CepwzkEHwTC2bStU1rV1HvpeBc4BbZjSbj8YdoVxxy6d	1395	1965	1965	1616292900000
2655	3NL8xwQf1tTmefZU9NGKMq1aaakboatBhzSjxfngFRa2hLjUKm2y	2501	3NKLtWLEWqQphQWaaNUTFCtzSotGtJD2pwyhTFXkrgb93WHjgNAK	641	1336	13	1	2595	jx39AbM6QVZEVDm8FmfLtoMYz1KZdSRCAkVTQ5eCT8d7adF5XbW	1267	1970	1970	1616293800000
2656	3NKCaiSs5KrysHFBRaHAcXmxAHLazytAt5FppytBK6HrADbqFM1N	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1483	652	16	1	2596	jy1vRofur5nzgtVeNGjTiVpnA7dU4TmcXAajSRCWcNZYphKH34b	1397	1971	1971	1616293980000
2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	1672	1159	16	1	2599	jxQzcBacz4URCKgnEBasj1bnGrX5aPCFJU4Qb2ppy6eh13PAwfZ	1398	1972	1972	1616294160000
2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	1477	1224	16	1	2602	jwTK7PAu9rQNUYbToMH48zPGvfiHxMvdQYYuir2EhB15aHEymGF	1399	1974	1974	1616294520000
2664	3NLN7BE4Utbs1NPvnRqXxL99QiMAVQHXmwvGwE2efpqxyjXp7wWn	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	684	1352	16	1	2604	jwZn6bJkBztu3yhwMiWuzXmPNJn3cD2afKYpGVZd39uJ5GvyfWi	1400	1975	1975	1616294700000
2669	3NLSmffZn34kk5bsttzrNDeaDPLM7yxxRtuzNiAHzHuSms7RCqRM	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1527	1047	16	1	2609	jx5S5LTvc6uuJEHgPLtM5DXRXL3EBp78RaysEvGcnmjqRKMEpXz	1402	1978	1978	1616295240000
2673	3NLchqHkBkpoyuFi3k21v6agy4rrJFFDGxwsDC3YbzxQxjdpfg4i	2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	1406	1393	16	1	2613	jx43UhsTkwzgcnC1rDcbsp37DV2NdzmxXJ4Tn4i3Ka24mJdP4S3	1404	1980	1980	1616295600000
2676	3NKPkCPmgCmoF9YkQBqqScjvEUs8h8HqvTo1HKKrrFWgndCFLwvA	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	311	1061	17	1	2616	jwRyfypMXVW7PBhJ6bbFjatRdZJe75RbWonGgZxAZHcNRdikuLP	1406	1985	1985	1616296500000
2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	2678	3NLFDZv4mMH9WB2qGi7iHEqUob4PNuBS1YLt5pvMWv87GDsCNrch	1439	1033	17	1	2618	jwCxZ1VHBc1n89JaAmMYWn91SLNSXkAxu8wjzZE4WJ8WLJN6u8H	1408	1988	1988	1616297040000
2682	3NKt9CzWSmrdfRdpH8dcaPh2akczcBktP8ExLJguXTnmxNaAVpWh	2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	1643	933	13	1	2621	jwBxF1EngeeDc9BN539FC43v1MsUNLfmJbVGy4yNLC6oBqP6Tgd	1269	1990	1990	1616297400000
2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	1585	1240	17	1	2624	jxtPw6Ju79yDUyC9q4esU2y8b9LRM8kWdxWJV1fvc6AvKAUzTa6	1411	1991	1991	1616297580000
2688	3NKJkMVwt9FA4mBmMkfRwYDqppvCgmYqcGH2gPbuJxKxjjdzNNe9	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1617	1042	17	1	2627	jxEZJRRA9AhVJrumZBCkT1wzma84tT4BkNYApLpSZ9i2AgijKtL	1412	1992	1992	1616297760000
2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	2688	3NKJkMVwt9FA4mBmMkfRwYDqppvCgmYqcGH2gPbuJxKxjjdzNNe9	1631	794	17	1	2630	jxrXd1PeUAVYqDW6s47zTAcsFPEh73kBrMwYDuqWcMdXCMZF22u	1413	1993	1993	1616297940000
2694	3NKWhm3i9XLWGvstNdpi9UWcGJ53MMFmUJHZHgUqJk6Z2T927dCM	2693	3NKiGzX8gWTCtq4wdeKKspJojXB3XJhbpzUxTeBBWAmoaohAhaAL	1553	776	17	1	2633	jxqBBhnNLqs7rnxmr4REqw84NLfAsuwD1TqfWNrfwJ451iMfBfF	1415	1996	1996	1616298480000
2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1407	1395	17	1	2636	jxmNUccNuacKSMDvpRmfA83TgzfAoSQpaf9cVKbmRNaH9UQJRU3	1418	2000	2000	1616299200000
2700	3NLdifjpi4AB3LtfswEBoFFytMtW7V3qN21cfqrcYWrJt5eohnvz	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	1407	1395	17	1	2638	jww16czR6Xy9KifFuBMv2SVWAC8TqCU9R2pfenAvk91EM8ZJK2Q	1419	2001	2001	1616299380000
2703	3NLLDJaoAYHdAGnYcmNiKqFBCTDjoBk1rwEcYktmsTRswzGFBXzA	2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	369	1066	13	1	2641	jwwHRL8YZCGm2zavytrrUdVwJHJUh9nTC3mCEFHypdnJHJBUGQU	1289	2001	2001	1616299380000
2706	3NKPnd7e9wBLDdyvdpYrpxRKg7JJUwk9qufCpWGoQMn5AdLatqux	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	700	840	17	1	2644	jx6xDTumqWhmN27sAv5BURZeZg9wvxdATiJQXrm8ZjFMrkw1Hsg	1422	2005	2005	1616300100000
2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	2708	3NKqTfesXfBhvZqikYK8W5WrTj8QaF2hGcHDTytLXF58bNB4bSaZ	1600	1246	17	1	2647	jxXmi8rHbS7DiZ941Z7UE8jFZ2GmAd9hsXm9APPx6cTebMhWF8T	1423	2006	2006	1616300280000
2712	3NLExBUaXRjPVRPc5eFeBKJ6jEiHNXnXMhTJM26FYACn96pKRpus	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1611	1341	17	1	2650	jwaPHN6vaipvw5ujwLyJJVSU5QWJN8TYQQr2g7J267sa1sdtrHE	1424	2007	2007	1616300460000
2715	3NKrUXr7RtxHc6mqRAQh4c52XegKucDpimy7X3yjHLbRXZ1zTyHo	2714	3NKYMXf6vPAtbVe1KXM2Hb6non52pW6oAvvXgNTWaZ7sLh9HFVZf	1407	1395	17	1	2652	jwH631JziTrirksHRhSX7bQ7z392YnHX8hvcMkfGwVKA16Dq7Ns	1426	2011	2011	1616301180000
2718	3NLUVmY6SHbyu1b6Rs94Rs64FzJvi6PA7hCJXyrVy7854vVqU1tF	2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	1506	1247	17	1	2655	jwGw7mvxbMg8shUiLUjKDKYcXp9k7judjJMN634bf5RMXUUbDms	1428	2014	2014	1616301720000
2721	3NKScbihge19DFsyLwFtYp4pv3ZZTcfyP2oCM7VH7vkAvSjTZCgU	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1634	1085	17	1	2658	jx3nM5djNgDc6adq5orYJPYHzWJgL1yfFSxWMd653swv1YoM6VR	1429	2016	2016	1616302080000
2727	3NKnoSdVbnrRaVTwP27ujywgwSNEJTrqr9CST2mWyU8w1bSEv2Es	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1406	1393	17	1	2664	jxmjkAh7bN5Dmj2tnxaQYyNwTk5UYxJGdV8u9pXxpPDzURBq9vJ	1431	2020	2020	1616302800000
2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	2729	3NKbnhThWo2X1CfeXfCRxibSHaus1ah1ynDEyWVGVC74AxgfbfWz	1407	1395	17	1	2667	jwV2Vbr4sgBcdgTWPC2Tq2583oK1WPsVz2qysTHbc3LRwMa6E7w	1433	2022	2022	1616303160000
2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	1474	1083	16	1	2572	jwR8ybry2yJv6njzkLzuYv7d6zmzPWMXaQ1CfSBEE2H33pHh2mf	1385	1953	1953	1616290740000
2638	3NLdgh5tkTdgm5p76Rz5ReJE18pUrko5vaKovquEm7snuGAVXPEQ	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1407	1395	16	1	2578	jxcWAuoD634fkr8TKyEjqGV1Md8c8wDjVmYnNzYdQ9RkD5469kg	1388	1956	1956	1616291280000
2640	3NKXVMJF8HGcKmEFgC2pLdAj9Kwu57stKJgzUVmCND3s66ZFfA41	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1477	984	16	1	2580	jwysy13LQ4qkp5DtMxXCHiFKiR9AjqxGbkZ5jaLZdDXukyQf9qy	1388	1956	1956	1616291280000
2641	3NL9jUiu2b51Vey6N6z7JuMW2rdXNUnsSTA78roPPvBUsk7JdDqq	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1611	1095	16	1	2581	jxWa1NxgtKhKR3z6jPg6F83rC4PEymSfkVUgEMduq1RZZ93uBvK	1388	1956	1956	1616291280000
2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	2643	3NKhPdBraP28GEeocEoQ9EUt6y4aaB5brVjvz7c1iwGMaVRJ8u3S	43	1064	16	1	2584	jwnQtdvf5iDB4QYHMFKMPu2t5yjgbMsXMZNJ4eCygCLM41DRoj4	1391	1960	1960	1616292000000
2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	632	1136	16	1	2587	jwVUs1ZbYqkTG1bAHYcHnNfYH5XpY1sP9LmyBLUgBWjxBsVJ1Nq	1393	1962	1962	1616292360000
2653	3NKHoBBtmW5rV2joFq4DdvaqpYW4Zefsoxw4KfaGKAHzkftK39Yp	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1637	815	16	1	2593	jw9BzvsgJgpw15F7xSuEazky7SWjEgokojqzdWRumGCnURfgzLE	1395	1965	1965	1616292900000
2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1637	816	16	1	2598	jwrLP3VdYzLnjGJLH1JGY2ZsRipwb3XCAzCJeJvZ3kZpuGWDnsm	1397	1971	1971	1616293980000
2661	3NKYXGNQxVZNvbsFz7cusZgGeKEXUCYkuNwhZDqCafMSEipbXM9S	2657	3NKjwR6Tt9zX6VEJPgxAjW5fXNoCD5W835s6VC2PLfj7qRFFKR2X	1542	938	16	1	2601	jwXukdQCkmtgKhyZ2rshWwg8MEFd29HAnqgQCo2uQXv91j9BHk3	1398	1972	1972	1616294160000
2666	3NKQef4yQfS73G1XoZHhUM9raPqnb3bw7wxV77hyrBYSXFaprcmP	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	1637	816	16	1	2606	jxXVZ893ZNKRFUSJuhyZCnrzTgHieRsZmUeJr7vYKNZPtTaqJQA	1400	1975	1975	1616294700000
2668	3NK9ibK7MDKjfKxqVmaKgFehu7GVBXt45wC2c43JkiQgk2th6puH	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1489	1134	16	1	2608	jxrYZtG7e3AppRxMt6CkZveN2KHyKL5k3KzuJBD7F92qXZXGC1B	1402	1978	1978	1616295240000
2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	2668	3NK9ibK7MDKjfKxqVmaKgFehu7GVBXt45wC2c43JkiQgk2th6puH	1573	1192	16	1	2611	jxARmPiBCof9KA9uhca4GadgbKvHtcWvPhjztkt1VX4JPTFMgph	1403	1979	1979	1616295420000
2672	3NLYB2wrMR5zmMDi9qqssPGPbNjcfjtbNovmLoRAyCY4xmNygakn	2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	1458	957	16	1	2612	jxQ3HopL4vbd6X2eTZNi6g5cDSoSNvDNXou6ZhiChbAL28FSF9V	1404	1980	1980	1616295600000
2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	2673	3NLchqHkBkpoyuFi3k21v6agy4rrJFFDGxwsDC3YbzxQxjdpfg4i	1587	991	16	1	2614	jwQHnJueTcRxQjsnagTzH3hJJBLFd1xD5Sdsh6FpscSJoJ7hjcz	1405	1981	1981	1616295780000
2677	3NKJvMnGrdKXWXAFTbBcgveheAxy8VFcH4D7ZPZYN1u5Bbq5fSHS	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	311	1061	17	1	2616	jwRyfypMXVW7PBhJ6bbFjatRdZJe75RbWonGgZxAZHcNRdikuLP	1406	1985	1985	1616296500000
2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	1534	1317	17	1	2619	jxAZpdFFXkSpHuzGXz8RzezxB4TuZbvCWVUH2eKHFpNBdyP5shr	1409	1989	1989	1616297220000
2683	3NKRS8FUDC9GAhpffmDRCGpjxnGQgLGxdpSTYeVcu5T8FaFqryfq	2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	1596	1363	17	1	2622	jwq6ZMBtAFeBtFWPirPPamNKtDtupwq8Lz7g3SjLYng5qq36XvT	1410	1990	1990	1616297400000
2686	3NKe5vFr7Sp5ggFWE4Zf9DNUN6z51hH13XdAPDnBMRS29Jnf3VM1	2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	1590	1054	17	1	2625	jwz4kHjEbCwZiQsiqdZvVJmUHCzc15cKvJm7YQprkimNCSAfApq	1411	1991	1991	1616297580000
2689	3NKbwkr5UKMzXAYMB6BXfbPWY1L7iDSu4t2CmfiLNtx4JurduSAe	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1406	1393	17	1	2628	jxDc1nXWaPDEvk51NazNsNj5NHcfPwYdH7C6X42ut3ryUA9S88m	1412	1992	1992	1616297760000
2692	3NKLWMHDg5ohVYcaULi7eD4KvqVcMcAwm5WAiPQ97vMba8wJ1KR6	2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	1407	1395	17	1	2631	jwFVP3kr25qgA9YWgrnBrwejedZHtL8XCup9y1DCgTzjAKnUDQD	1414	1995	1995	1616298300000
2695	3NKdNnBPqCqp9cDYBR5jPsn4uY3r6mXAt9MsPbsXny3YUVdMMvWt	2694	3NKWhm3i9XLWGvstNdpi9UWcGJ53MMFmUJHZHgUqJk6Z2T927dCM	1675	1342	17	1	2634	jwyaKFRTGc6RsDh3nWbLxpqm3cRRHBp4f5N5oGZmGiGHR94Furd	1416	1998	1998	1616298840000
2698	3NKpPtBQ93bBuAcbncgLNxN8We76uMpFDybk8JyowwhyCjn8DPLg	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1651	1175	17	1	2637	jwmpMnv9EBpMmLjnKyQz146jHMctKNq3LRakqn7G32menucjvsJ	1418	2000	2000	1616299200000
2701	3NKH4e8LEAkGxezBh4f44iBNmVWKyHT43sUpSa2pwmroB7qnFVbP	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	369	1066	17	1	2639	jwG8L2iYHBgqr8Zay96FHREJbioKLyVELFZrdgRWChtCL32Gofj	1419	2001	2001	1616299380000
2704	3NLg9ki5DZ8p2ggPWMnJd6XBA4gysPafKMKTkydHhdpcSc3RpNQp	2700	3NLdifjpi4AB3LtfswEBoFFytMtW7V3qN21cfqrcYWrJt5eohnvz	1509	1074	17	1	2642	jwQUtmSAyKTjHqVAhtU7vT7Cnuz2yP7ZXzLBnc9bNgNbxMiSgfu	1420	2003	2003	1616299740000
2707	3NLuTLw5f3WR2dWyyZWnCZJh5BdSgv77V5G48cNTKRJatg3LsR9m	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	1585	1366	17	1	2645	jxajBgJD72wSoTqTc27RAXe3kAwhGpaVwXNx1bBAcPm5EZGonrD	1422	2005	2005	1616300100000
2710	3NKMPt84BT7cAc6Pyc35Uid19CdDoVbpGyZpuDf2yrGGYPTWT1hB	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1474	1329	17	1	2648	jx5DHKBbCQTeaKWgcNCUscyLZjiCHHLo7qWkiZxppkwYviPQ5h5	1424	2007	2007	1616300460000
2713	3NLjPBsfkzxJeCSuhx7sESYCWfVxiDRi5JUkZdAtFWcTun4efEg5	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1474	1329	17	1	2648	jwkNUo8zoMZjHenimtuRvyUbm8BhzQH1chLr31xH35FWwP3QE8K	1424	2007	2007	1616300460000
2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	2715	3NKrUXr7RtxHc6mqRAQh4c52XegKucDpimy7X3yjHLbRXZ1zTyHo	1406	1393	17	1	2653	jxEbVCxGT6qL2DJ2fSfL9c31MqEcNK6mbT5XxvT1nDqWY447oy3	1427	2012	2012	1616301360000
2719	3NLDrKS6VwcVBXi4DSjvx41T5KRFRACdVRKWeBU1pfcuVbtFb41s	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1407	1395	17	1	2656	jxTmQjSQP3CaS3UQLJf3st4D5NWXtp6xX3ATgx4hPo4PZSkWSaV	1429	2016	2016	1616302080000
2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	2720	3NKw4xUp3xSZ3VK3NuS9rSemanQxA2DCqmdfU9KYsnP45Gf71GSf	1637	816	17	1	2659	jwPwqYVxDM13Uo5kfgwLeLiurq9cXAdAiCQLZacnFCARjyX1szu	1430	2018	2018	1616302440000
2724	3NKfFdeTsgPEiKNVBhS2sof71Ad6qcF7CBv6VoaowvXotVvDj4dH	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1407	1395	17	1	2661	jwrhgM8QU8tgMFmGKtSds9r5GRC6SeVwfkDZ5Lzx56CAqu66b2P	1431	2020	2020	1616302800000
2725	3NKeHNeVp2XaAaJ1MomqnYjWond5oAs8J3aBxqKqsuTkurAxkCaN	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	369	1312	17	1	2662	jwMTWd3evrwsqD23sfhnegkLva9ea6cHvcoi5JaqeJq21pNxvux	1431	2020	2020	1616302800000
2720	3NKw4xUp3xSZ3VK3NuS9rSemanQxA2DCqmdfU9KYsnP45Gf71GSf	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	470	1309	17	1	2657	jxH2oyENHVKcxKQBZwWfyo6sN6pNKsjPk9tyCrhn6PENKgLrJKh	1429	2016	2016	1616302080000
2723	3NLNspHoKzMv48Zz73ERrW4X5UDkmpsLkkpxVPkkUQqZWTy1XnU5	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1657	978	17	1	2660	jxgLoNR5FwNbHZy7z3me4nRnKWhiFKwKYbHwXNxqac3VEn2iX6s	1431	2020	2020	1616302800000
2726	3NKvFf6cmccVgVfwdSen8fJi1FgdwNu3HXhofnfLt9rUEwSZyg5J	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1602	1003	17	1	2663	jwXuGqAXYpaxiwtx8EZG44WY4t2ReJz24Kq99JdqDigY4PSon1N	1431	2020	2020	1616302800000
2729	3NKbnhThWo2X1CfeXfCRxibSHaus1ah1ynDEyWVGVC74AxgfbfWz	2727	3NKnoSdVbnrRaVTwP27ujywgwSNEJTrqr9CST2mWyU8w1bSEv2Es	298	1062	17	1	2666	jxpb7aStrgE7zQQjn7LALE5j3kRd7dGzzhi184G3AqKvigs1m9s	1432	2021	2021	1616302980000
2732	3NKzy8evU6Urv6GpR3c7xjpU5wtmoPaD47R2aWFYttQZgtraq8qx	2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	1439	1033	17	1	2669	jwYBHCtX3gkPG7akCcoEnF4hTdMjXfHjzZE8psGR3tmuDtYtnBC	1434	2024	2024	1616303520000
2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	1639	250	17	1	2672	jwA5kvwyb3zoRZuBAzRr4QHHDbpETM1qjwrLq1Sv11dNUL6mfka	1436	2027	2027	1616304060000
2738	3NL2zM5qZogQYz3EyoRum28S8mb9h4UfH89exxJCUMXCMF1Ha96H	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	1637	816	17	1	2675	jxW6C4bfFzk55yZycyb2JopmTfMrYZiXRPt4Yk3dG6KADptLqfr	1437	2028	2028	1616304240000
2741	3NLuZe7XDX5vovEi4cUVxETQyZLutkkHYZSN1BrB6d2fgd16217d	2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	1579	1389	17	1	2677	jwHVZggaNPRQDb9SXP5EAWtBN1gukgxdues3uGhKYcTLfBUoFEh	1439	2031	2031	1616304780000
2744	3NKjC4cGUP8YtL3WijxiJThhf2pSPiEydNPqJ5JGy1pfPRPG547L	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1649	1137	17	1	2680	jxP1gC59iku3R27oAxUvgoMqTMg4HVRoHw2YrS992he7LF2RrHC	1440	2032	2032	1616304960000
2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1631	794	17	1	2683	jwjRv7XByMfqaVtR64YNeeN3pjKYeoJ76DycaD2ivPL4hk4SPqc	1440	2032	2032	1616304960000
2750	3NLPfzsfFNBf22ja4mf5wLpnDyvLrtcqcoMTzEZNsf2BCMW2oBAn	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	532	1177	17	1	2686	jxwXKHTerwT9VoGufztLMZwGqtSoTCpgCFAoaUkznAzFKyD8LAe	1441	2033	2033	1616305140000
2753	3NLMA5cm9cPywbBSaNixNStrfVfzNG9jRGNd8zge6TPronGkwHYK	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	641	1336	17	1	2688	jwNqhJshYye7qRo2JQVyC4qQVT6anUepPvyyMN2G6bYGMQbAiTt	1441	2033	2033	1616305140000
2754	3NLJJfAtHRTA1fF822h9y1a8ZQ1BMd9bJ13DuBw62vjjXrWNPDB1	2655	3NL8xwQf1tTmefZU9NGKMq1aaakboatBhzSjxfngFRa2hLjUKm2y	641	1336	13	1	2689	jx39AbM6QVZEVDm8FmfLtoMYz1KZdSRCAkVTQ5eCT8d7adF5XbW	1268	2033	2033	1616305140000
2755	3NKRHAvVvjfRNqYoqf6PGgZozghb9kSNmLKWx81QzAErM23MZRQ2	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1407	1395	17	1	2690	jwMEDan1ujFUotHca7XjKt4TqAE98Jf8M7wa7rqRptFEZ6jGv9H	1442	2034	2034	1616305320000
2757	3NKMVUyvYWxuFwiMRqJgQau7EgizmNReqL1ywWj3P5fjyHJJadna	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	448	1059	17	1	2691	jwis42q1KFk4HUqs2jHZNip97xTTfBVF8mLDsgx6RZ5z49mRWWq	1442	2034	2034	1616305320000
2758	3NKZQUr7HgRP2Fp6KYrLc74HProXPyJQZBmBg8LhVoem1xJATdtH	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1619	1029	17	1	2692	jxJZLJaNUsNiFDVTMTMTryzmQeB9P96u6zZENG69Ks9SEbTKZBE	1442	2034	2034	1616305320000
2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	1672	1285	18	1	2696	jxq2Q1fQxth15EfwKv2vpo84Z9vP4yoHSnPQA99hF4fwrAPEg2j	1444	2039	2039	1616306220000
2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	1651	1301	18	1	2698	jxtRhyoTXfUtF3aVY6gBBLodhavsEE6mQF48Wm3Vw7CsEULHguF	1445	2040	2040	1616306400000
2768	3NL9hduJbTdNrHSHV6NkLFskD8kNb3zhcErjvv7Efa3WQ3zJgyu9	2617	3NK4xcbqzEai4gFyg1gB97Vu5uCjEXh3Qs26rqzzpTtbDffMENyg	1403	782	13	1	2701	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1281	2045	2045	1616307300000
2770	3NKC4GLukMhH54TiCey8WqxBdezydEnrcNAn1Aun5jx9mHqRNeSR	2769	3NLojEqaq5j7Rxf6V8LLT37vpHhyzC94y871fKtQ4aaxfW5s18G6	1508	1141	18	1	2703	jwHhQoDpymSF3kQJcgiinD6e8a9w2KwSG3hZfpaFt8LwxoXGVdp	1448	2046	2046	1616307480000
2773	3NKzD6k2cDDrvJzVzMghKQSVrvM1hxMPk5uWg9HE8jA8vbozSTfH	2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	1627	1139	18	1	2706	jwUPUWgjLkb8UjgztzWpHRHsTzb8Drrxhcv9EniaS1ZcnRHuhaP	1451	2049	2049	1616308020000
2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1445	1164	18	1	2709	jxN361iYTjXoYv2o7szb4gMxgX6kLnmSxqqeRYLT7ieBsqAMKgz	1453	2052	2052	1616308560000
2778	3NKmSjasAYcyLJTHCUQ4aYZD7hGujc7zCvQYAXZqB1BGzGsCsoQU	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1553	776	18	1	2711	jw9FMtpov9u2KMTcDRdaAbRECdCt7Vcq1iWyoaKT6rRziLwNvcW	1453	2052	2052	1616308560000
2779	3NLLtAowAgDBtA42F71asqRLCfVLbQ5XVpCgtwSoTGBi2Sfb7vzx	2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	1406	1393	18	1	2712	jwamYivq9x5wBdDcAwYzwz79egjyv7SzbHhZfcBsfUqyLk9D2Mp	1454	2054	2054	1616308920000
2782	3NLuDkFGamHFFCpNeTdRGfHdAnHzwLGgzNRWfCEQSU1FK3npRSAb	2768	3NL9hduJbTdNrHSHV6NkLFskD8kNb3zhcErjvv7Efa3WQ3zJgyu9	1403	792	13	1	2715	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1282	2056	2056	1616309280000
2785	3NK7w7bQwDamw3rbKr1obArEiXBTteXSosYwHBf9uyQyVp9PfMPT	2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	1577	961	18	1	2718	jxw93xKmiLeXox6itxVSzNTSStUSCvz3JVK8Bj8kD2EDZCpBkUK	1458	2058	2058	1616309640000
2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	2789	3NLq2FKkJuwCqqCA3xT41UmqtwsGz4RpphajesUe499uKeimrJ2t	1540	110	18	1	2724	jxbziwHwF5kh74n2D23nvPojj15dKRXTYktGdaLg47Nedb8K5Jd	1461	2061	2061	1616310180000
2794	3NKkxVL2rosNvchtAbP2cAmE49ZArzLUjqWpuL2erf8Cc5vAxCg3	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1590	934	18	1	2727	jwqwLQHi7VW7PMZBRNre8thXsi3JbTzgbg8EL5UDUJp7TQjVDDu	1462	2062	2062	1616310360000
2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1536	1187	18	1	2730	jwsMGmHqbpghfZaznEpLZrHe5p1FgLQkGyjAg9Em5nfG68Y3ZRN	1463	2063	2063	1616310540000
2800	3NKezouAKHCMBnFfBKTbuJxHwnGf1CCq7HyXVKFC15RQ1ksjsLqg	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1581	778	18	1	2733	jxLdNZYiMjn14X9sf3AJkWWQz2QBzScRu8RJ8XjzDV6emZZ1gp4	1464	2067	2067	1616311260000
2802	3NLKx27p9nmPNjAG4XMzS5tqoHqqpNheykdVVdAnCGqFQRX71Kas	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	596	1180	18	1	2735	jxUqqHTQ9vn3EhZ4sXtUwex7g6uYqt4XW8TAraEu7LDJjg6VM3W	1465	2070	2070	1616311800000
2803	3NKtCQj95VqW9oZtbqfL3U9FHB4a3AYYBWTiCyyVf89ANe4DW2XE	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1541	1172	18	1	2736	jw9kR2tviK4e1mS4fguPq9Tr2gSfccBBgmkt6S1gu8yU9anWUtf	1465	2070	2070	1616311800000
2728	3NLBdFmSBh4Z6V93Z3nc7gxv5ukqbrkaLURGenb4tzqsASprmbWi	2703	3NLLDJaoAYHdAGnYcmNiKqFBCTDjoBk1rwEcYktmsTRswzGFBXzA	369	1312	14	1	2665	jxM7GTE8xYegaXbnQ5EdEckVyHYDrzZrXcagMeS1DK55bb6o5Ky	1290	2020	2020	1616302800000
2731	3NKKajQHh4pTaRXvZKPFkJdCeDNnkex3nKXU3CrKoK29ht796MZ7	2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	1448	1065	17	1	2668	jxtzQ7wAv1KebZ4Ems3oLvgG6yW7ZXw7PhpBLVMLyXHXioWvLNQ	1434	2024	2024	1616303520000
2734	3NLvDieyawwfnDyetz64WV78DYdfoR7oyaZcLp5RzZSKrSoeNfCd	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	1483	611	17	1	2671	jwwqtiYNrfXLo6PUTHpCUZMLWeS9YZqq2ebPttTK5VVjcbiRWVQ	1436	2027	2027	1616304060000
2737	3NKcxjWujLAtCKgxtVHAiUDSUEVXpCqmSfFAEXRQo4CuUKcPumGt	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	58	1281	17	1	2674	jxWpHeMaDy5aEfRnjRqhWEX4GWdo9L6YWrC2jknLVfLZ3f3h9za	1437	2028	2028	1616304240000
2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	1652	1189	17	1	2676	jx1HDdeRz5xWhAMJn4JRorc29FkU9RwQSTh9nHPWgpmRFPVufRU	1438	2029	2029	1616304420000
2743	3NKrkqeSEbvJnURy5TSF18zUni3oSw3jQfxy7WdzDLBubw5nE1W6	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	1579	1389	16	1	2679	jxUVbCEvm9KXS5a5CH8aiKeWqFgiU1WeLykTmxoRPgwhYy3AHYU	1392	2031	2031	1616304780000
2746	3NKBPFAkQCCQvBA9EaSRxHCCh9nMmsVxLizbBhtWVJr1m9x3KUWf	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1623	839	17	1	2682	jxNSyT3sSJBS7gcKyg7moBxoUeXNGz6mQgV78Wz2zt6r22KHSFX	1440	2032	2032	1616304960000
2749	3NKcEFhafv4BkFUP8JXx17cCu3zXHXAFGnFG9byf6LtRxAMKACzr	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	448	1179	17	1	2685	jxfhMCysXhdQZXty4Ge5dg7TBhUBpDjjkZsutSwoafqaNyWnArK	1441	2033	2033	1616305140000
2752	3NLd1FoWBY3ZVDCUZdyEa71EYKCLPAoYKECwYBnvZKfjKjBhk1D2	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	448	1179	17	1	2687	jxMAqgEmeuz7uGnrFK1BxpRqm6cigbnQqbN1zd5usy4vMJDC5bS	1440	2033	2033	1616305186337
2756	3NKzGAPq5iUrH3dZwHXQMdk42crihFW7ToQYaVzaoz3DAF6xQt3n	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	448	1059	17	1	2691	jxf3DgsQWiicKdFvULdFLKb7DiiygLELkQhjhfoWsxiKQKiNhpy	1442	2034	2034	1616305320000
2760	3NKMBzGM1pySPanKkLdxjnUS9mZ88oCeanq3Nhm2QZ6eNB5ZkeGn	2485	3NKNqeqRjSY8Qy1x4qwzfCVSCGUq2czp4Jo9E7pUY6ZnHTBg4JiW	1529	950	13	1	2694	jwFubYD5Zo3e2wgYnDPZ75TCnUr8URZUyosjLHNYBeWqwRrVhTK	1231	2034	2034	1616305320000
2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	2758	3NKZQUr7HgRP2Fp6KYrLc74HProXPyJQZBmBg8LhVoem1xJATdtH	1460	1198	17	1	2695	jwJPoEjZWLYz7qbjbTgu5UdQBn8HTnwnYLZqBba97YyLgA2hRfM	1443	2038	2038	1616306040000
2764	3NKyWQZHH1tAL8t7aqFWvKFbjiW2EkJcNuzHPGAv1qYofoG94vCw	2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	1651	1301	18	1	2698	jxW3yZFrzv8wpWsFEp1Ar18UvJ7f1b1CSHvc4A8srt5JnsBYQWn	1445	2040	2040	1616306400000
2767	3NLRL5LZRP8Ned9yJ88Lw8x2yJftQQyD4BtKDpTBfG1WxTc6uj2k	2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	1507	1280	18	1	2700	jwUowYcvm2HfcxyPL3mM3PcoByjEyo8CxzPr5aBYV94XcWxfiB5	1446	2044	2044	1616307120000
2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	2771	3NLqZgc4PGeqTRAKh5VtdzgbazGCgiivTaZTiHRTjH2Ryr4zoiWw	1407	1395	18	1	2705	jwBiunGekMWUKHQPmEADYUkragbzsCPFtDSedEzaMTfh4CmBgj9	1450	2048	2048	1616307840000
2775	3NL5coN6x2UUxZW6YAEi5M6HBPoNATrvPYuLgiMZxQT8WUgKVCjy	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	700	840	18	1	2708	jwaASAjYFG58uf3Vuk2QGnTYngmZnv67ovHyh3ZHs43CUwqcR58	1453	2052	2052	1616308560000
2777	3NKVsZKVyBZp18qCBhsEXntRgdoi5rxx4eYUndKQz3Dppsc9pmAL	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1555	1347	18	1	2710	jx4Asv59zQfFQkSMd929TuS4jWYdWb69r6c9iyJWtT1fjzEXGvo	1453	2052	2052	1616308560000
2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	2779	3NLLtAowAgDBtA42F71asqRLCfVLbQ5XVpCgtwSoTGBi2Sfb7vzx	80	907	18	1	2714	jy1eqEAJZSoGfuLR4ZL9kJ3VdcuACAbNmpMLgGHZmHeYPiz1cVx	1455	2055	2055	1616309100000
2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	2783	3NKjtGGRkntgCcZi7vZuuGtu1YUEQAZ141SyBifRm2pSxMVZhsGz	1601	1388	18	1	2717	jwVz8MGaVjirgP1ZbusqmhoQcEzJPw4ASz2BvNPCEStXvasYWYk	1457	2057	2057	1616309460000
2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	2785	3NK7w7bQwDamw3rbKr1obArEiXBTteXSosYwHBf9uyQyVp9PfMPT	1623	830	18	1	2720	jxdnuBgnGR4qeZoXvMAE6AmiVdCd1wYsV1YwHCjJ2J1nTjS2gTK	1459	2059	2059	1616309820000
2790	3NLEwGwjgZypGtHgCSbdVDmhU4Yqk9iBazSxPqWa2YK4gqJnV1ys	2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	1647	846	18	1	2723	jwnRkszLgHe5sqayE4fDZudnFrKXD6SWUbUWThoXCzkZTvhyPBP	1460	2060	2060	1616310000000
2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1675	1096	18	1	2726	jxERd27jnXPAWzReBcgsFRe26MtU9cZR3yKruCdv71Wga32ZrEp	1462	2062	2062	1616310360000
2796	3NLHnGWfPqxymjcThmuLjpdic7ZN9C9q9EH3w2hRoUZq5rZASM9m	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1619	1275	18	1	2729	jwgHyqjKRgDXikQQYqMaZkw7kyEE7rPju1csGgwasAr2N5RXsQg	1463	2063	2063	1616310540000
2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1407	1395	18	1	2732	jweS4q8HGBBCLi4r3G7s13XAheKL7J1Y4RFr8WfVrvynEoVJmpi	1464	2067	2067	1616311260000
2808	3NLbTw6CsTsWmc9HJBzFyKU291ZoyYkexB6tnpUhM72pfoseumLa	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1648	918	18	1	2741	jwNo2HEGVdmEMAKyreh9zrvDuzxgnB7gVK7a6w996Tq8vK7KdyQ	1467	2073	2073	1616312340000
2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	2810	3NLQTF9KTK8AAfuoiCYXr1gdZQB4WvHiKnSMAeQx34n4Se454wkF	1571	969	18	1	2744	jweFZ9kU5ysH4Akh36JoM8WxQs3pBuK4CDFCQ4p2KFr36eXP17W	1470	2076	2076	1616312880000
2814	3NLMfQUL68UzGWjx1hvZoEg8ymUkPQPfno8woaGt4KjcAhMKS5fn	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	641	1336	14	1	2747	jwwYp2itz8MNg4V6mDaxneETxPE8hvCUBxaXJg7ZSyRdEQrvkC7	1301	2078	2078	1616313240000
2817	3NKmtgAMoPRdHkSL3QxsgZDKcPSmAMXLTWfAQrwgNmTzjLaD86FK	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1527	1293	18	1	2750	jxxibTiH7tjVnwX1iBuWSMf4xHfBRTAbgH8SpRa424DcTRWGDz5	1473	2080	2080	1616313600000
2820	3NLiLiwtcwykDozB4yyXYmaEJJKcHBbteCVy3ACHm3YqR9uX7WBz	2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	1406	1393	15	1	2753	jx8hWLNtDwon18XNG7PvJ7RPgK597FHznxisFWvaahtHutAAQtR	1355	2080	2080	1616313700806
2822	3NKGBGUba8cRYPrfj3uDuqn3MyDkyH8mneLZhCDRKaLYmvAEYhtT	2817	3NKmtgAMoPRdHkSL3QxsgZDKcPSmAMXLTWfAQrwgNmTzjLaD86FK	1631	793	18	1	2755	jwpVKASzDvAZQ8sX2L7sJwCYnWw3ii9nioQqWEMD8r482f4eUZi	1474	2081	2081	1616313780000
2825	3NLmQkGXKC3SFSPimByDLDanccxgr26Yo5qLSc67JGHaocoe5tj3	2822	3NKGBGUba8cRYPrfj3uDuqn3MyDkyH8mneLZhCDRKaLYmvAEYhtT	1407	1395	18	1	2758	jwF5q38Q5UZSwjdCLguSKVeEfG2C9Y1q8vNZoRXDKN3cNztZfiS	1475	2086	2086	1616314680000
2828	3NLto3AEKdkUNy4mqQeMg3ccGF8MxmPe19cZSPA9CCHo52jHiGpN	2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	1649	1137	18	1	2761	jxet9sr3vDBkx4S9YBZk34QM19xULEUxK2pgDyXeeoSyVPwQeQS	1478	2089	2089	1616315220000
2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	2731	3NKKajQHh4pTaRXvZKPFkJdCeDNnkex3nKXU3CrKoK29ht796MZ7	606	1295	17	1	2670	jwSPa4DePqUeNb224vn1xE1qmjdk3SSRMPGkvU7hUqtQYg8Ssv3	1435	2025	2025	1616303700000
2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	1542	1304	17	1	2673	jxnKRqNZny9zZJ1vXJCsskcykDTRU5TUEUs1F6imNPJjWkuDhqg	1437	2028	2028	1616304240000
2739	3NKJNoiTBVwLYqjsuEmrHtmBVYAibZrisYHTZsvXiZ1zDoZHvxsX	2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	1652	1189	17	1	2676	jwjX1cAKFa2tUHYkihKGNCS6BEMVDXgNt3WBLyfna5fzda83TWP	1438	2029	2029	1616304420000
2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	632	1256	17	1	2678	jxmvJ4DjXjZF9sxMeZRvAaJKGBafjPzwVafMHfXWaSSb6STNj4B	1439	2031	2031	1616304780000
2745	3NLfBv6kV64uM5MGBXYToVts29Z1vSRei6gpvke4YccBEYc6XE2F	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1407	1395	17	1	2681	jwR6GjQf4Xb7Sn4QpwFWwXax4ufZKm7VBo7CX8gxvLZdS1AXsZc	1440	2032	2032	1616304960000
2748	3NKsZ3HPxzdZKcPWyS6VbHB7in4Gjb8NGUWsEebu7QZ1wiU9FZZ9	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	448	1179	17	1	2684	jwMnwaqUBt1LZX8N1ZFsFHA8G4Cu36We9FcfLwSKpi6k4T7ZrNt	1436	2033	2033	1616305140000
2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	532	1177	17	1	2686	jxPGyUf3kUmZTRwH7gFuwjPw6YMSh16jEumMuDSf3qj3N1Fw9mg	1441	2033	2033	1616305140000
2759	3NLbQj3fz5oqyWoMaucoUjvw7zsE3aP7VgQgiedWbYLGvyJqCpgf	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1553	776	17	1	2693	jx8v4JAoxDYmtvRZVL2a2c5idXGMoKVyGWjUi9AGfBmrqNfnjre	1442	2034	2034	1616305320000
2763	3NKQDirLjUyNeeToJVakxfEW47y9XvJmYNDJz4gXwjpfCpixmwsA	2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	1406	1393	18	1	2697	jwwdNE6CeQbTANX4i1Ze1NpKEJnJdjW7t8XgeoAEhMpYMJJo312	1444	2039	2039	1616306220000
2766	3NLsZTtrjzz45a3De7E5ZYWHXBq9ecvEEpbfCzJePujiQ4irfT5Y	2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	1673	1368	14	1	2699	jwWvPhR3UumQt1VA1HPF65QxTP7eWBqdCLCwHTW9Zr7oADJFLBv	1332	2043	2043	1616306940000
2769	3NLojEqaq5j7Rxf6V8LLT37vpHhyzC94y871fKtQ4aaxfW5s18G6	2767	3NLRL5LZRP8Ned9yJ88Lw8x2yJftQQyD4BtKDpTBfG1WxTc6uj2k	1482	226	18	1	2702	jwwtDuvAq8Hrmdbq12BAN3ePPHUwPsirGqmWz8goxVURDJRphwH	1447	2045	2045	1616307300000
2771	3NLqZgc4PGeqTRAKh5VtdzgbazGCgiivTaZTiHRTjH2Ryr4zoiWw	2770	3NKC4GLukMhH54TiCey8WqxBdezydEnrcNAn1Aun5jx9mHqRNeSR	1461	1271	18	1	2704	jxAUKqQ8JLUX7JocFXej2frh9eyzM9YusxgFpNgvz6zQcytm1Tc	1449	2047	2047	1616307660000
2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	2773	3NKzD6k2cDDrvJzVzMghKQSVrvM1hxMPk5uWg9HE8jA8vbozSTfH	1637	816	18	1	2707	jw8QnnToHyftxVBXNBdAjVYhZycgX4Aipn1EMxsJUBbUjkzfCW7	1452	2050	2050	1616308200000
2780	3NKtzd3mHNsrR1QptRPu5eat4CxcmaiXsVrRPnWntY8rc4ZT25MC	2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	1637	816	18	1	2713	jwzhHuYzt8h3tXxDiirSQCW9yXk1r3E2YYsKzq9Ghf1Q2gfbdVP	1454	2054	2054	1616308920000
2783	3NKjtGGRkntgCcZi7vZuuGtu1YUEQAZ141SyBifRm2pSxMVZhsGz	2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	1596	1237	18	1	2716	jxBXDjA1cQuhhwBUTZaQ6u6NcFoGhZ6iFxbGMeVrrmwBHsdZMg1	1456	2056	2056	1616309280000
2786	3NLXSoYCtFcgLyaJM3MrMmb1v6UXVi7ZwJ96Zcjmw2sMjYKb5Ban	2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	1406	1393	18	1	2719	jxeJMsmwH5GqRMMVpSuiM5o7gprrAbauWx54TB7JDEujodxT2u7	1458	2058	2058	1616309640000
2788	3NLqK6Ek82h2USzp5XGb7BmukQGERdarRoQ8JTyXEYSUwUe79hST	2766	3NLsZTtrjzz45a3De7E5ZYWHXBq9ecvEEpbfCzJePujiQ4irfT5Y	1673	1122	15	1	2721	jwhSNDU1mgrCETRiv3WrqR2CMJN7huXMBp8PtRXChHbacchsibE	1333	2059	2059	1616309820000
2789	3NLq2FKkJuwCqqCA3xT41UmqtwsGz4RpphajesUe499uKeimrJ2t	2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	1600	1246	18	1	2722	jwbJnhaNuucmjQbsFxno8FYLNpzVH5nZyBtpAXhH2Xp9V5CANhK	1460	2060	2060	1616310000000
2792	3NL1SKqjELfrLQhoidbe5iw3KykJGFoV9KCv3nzrRcM2aVtHD7ib	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1422	1337	18	1	2725	jxsjUSxurZvN3nCdRv42SsD3tnt7wfaRLcb2VTVrRuDAmp7gepf	1462	2062	2062	1616310360000
2795	3NKBhdoSRxCkW59W2pghiZeRy5HMQ4nrvtnAgHD1GeMZCgejYNNt	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1407	1395	18	1	2728	jxjsr8bKnhZZAWdi5gY1yWEoFz7iihazV42nRAUF9KXSgsRNkzu	1463	2063	2063	1616310540000
2798	3NLh5wMcM7TY74PvKykJyJirXD9LM9RCDhu64sGSJLmBtk4PsT7B	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1600	1006	18	1	2731	jxBus9KnfUYptG2ub55jYUjSevTqCWKAPV4SqkGJpSEooLfUqYZ	1464	2067	2067	1616311260000
2801	3NKjDYd7YNSKEHFfpZ2fjZEKkqU7Qqac1J9SvgS7dHrsGE86mKbY	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1617	922	18	1	2734	jxMkyRpkrMDPrTFFnsqfczgwF5aEDxQWfFC9RqH9NgFpVQuJMgU	1465	2070	2070	1616311800000
2804	3NK2vr9c2cR7PMamHavq9pRoghzLM4eoe2PPYcrjfeamZF9gmduV	2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	1541	1172	15	1	2737	jwArsBfC7TXgDfvD2cXwvE4wgzrobyjD31dAgyVBajyfC1x66BD	1334	2070	2070	1616311800000
2807	3NK3Uzp4Rk6hJKHaKWQct8NvWQjyLA52AeYWAyaE8YmXLmGSTLgq	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1587	1111	18	1	2740	jy3KhtDfgZJytmKcvo53zH9hm1SCxEwWKAtwvkMLdZ3VYWer7dB	1467	2073	2073	1616312340000
2810	3NLQTF9KTK8AAfuoiCYXr1gdZQB4WvHiKnSMAeQx34n4Se454wkF	2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	1471	1386	18	1	2743	jxvqj92cCnyudjnzJuVAxvxPUGGPrtVa3f4iz7P7Hh6QJi5xRek	1469	2075	2075	1616312700000
2813	3NK5Nv7vUo717dfPi9raapvtznvhT6zyxfTmCktrJ81zcdMjp6sH	2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	1598	543	18	1	2746	jwznWVJKqJVU1uTk1Rtpw3sZsoFDvxaaLdCBpM3Kom8x8xhkcf9	1471	2077	2077	1616313060000
2816	3NLiWUP6qWFKs5WExMb5XNYneA76a4Kzz1LzEFo16j851wQ8hSqo	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1406	1393	14	1	2749	jxKravBhCLkSd228LDmzg9hertPht9wAAvJPzBSPkpGixRbkeiB	1322	2080	2080	1616313600000
2819	3NLpXmub812jsuR3fKYmBH99wt1jxyPwqGQKTvbknyRtWoYHLsHg	2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	1406	1393	15	1	2752	jxoQSPL7LBcvbDVgMw6KMf8Lukb36sVsriRspbG4fkBSCy28grq	1344	2080	2080	1616313667706
2824	3NLN5C4HgQW35UFCud2F8qNz4FHg1XH7MWBvYKd5qvvDZ6W99DH3	2782	3NLuDkFGamHFFCpNeTdRGfHdAnHzwLGgzNRWfCEQSU1FK3npRSAb	1403	824	13	1	2757	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1283	2084	2084	1616314320000
2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	2826	3NKhjHydPRSLAXVgxoLBskJQHdLcnQ9WodxcxjYCPpx35g62dMSF	1407	1395	18	1	2760	jwhLB62X6xkRXizV3s2BMuwMBkj2cxjaWn6v7Ps7hoiQmJVERvo	1477	2088	2088	1616315040000
2830	3NLY4SjeXrb5btuU4kgL15ZfVMnRzLq2qbCiHtWRh6NSChRTafeA	2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	1607	1102	18	1	2763	jxgYMe4GidTQ699DJ1LC8U9TvhVFGMBQHPLV6xT7nAd7ecuAG9p	1479	2090	2090	1616315400000
2833	3NKkB4gB4gRpHYWBbLiQDfmUUJfHkuodoKibS4tAzvXFSsD5SwMR	2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	369	1066	19	1	2766	jx5PmFvj28XTZh4uW7H9hvkpdw6rq1hZjyPyCsJToHCbQwTTsWE	1480	2092	2092	1616315760000
2805	3NLSHyQg2J3YMrPNKwsVNG5y1WJHAoVpcNR1464VQXH2VD8fppBi	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1631	794	18	1	2738	jwPhcdXtyLg9zKc7p6KcT1aRZCxs9vsRrHV3PtkbkqZji9jzVQE	1465	2070	2070	1616311800000
2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	2802	3NLKx27p9nmPNjAG4XMzS5tqoHqqpNheykdVVdAnCGqFQRX71Kas	298	1062	18	1	2739	jxUWQHAqVedcXHZ9p1nh729aUtHdhPp6cCauUbGxDgUN2TZtyBQ	1466	2071	2071	1616311980000
2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	2808	3NLbTw6CsTsWmc9HJBzFyKU291ZoyYkexB6tnpUhM72pfoseumLa	171	1374	18	1	2742	jxvMiMZFNRiPtpuAguJZ5WUMRMrsz9YGqqhuDYbxj9s8h7NVuJ9	1468	2074	2074	1616312520000
2812	3NLDzXVh8HZKeS9Ukwc5f4FyXN9RwHogeJ6AB2eyt3mPMdwkLfK2	2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	1483	390	18	1	2745	jxgxoPLRcBssXFc9HWiiKpDYgmJeMqeuVavZqyDUJe4UUkeXNpL	1471	2077	2077	1616313060000
2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	2812	3NLDzXVh8HZKeS9Ukwc5f4FyXN9RwHogeJ6AB2eyt3mPMdwkLfK2	641	1336	18	1	2748	jx8wVWwJfnPJCbZFBUCUmTSWPBFTr5FhrSr4RdnQaEfxnsSSBiD	1472	2078	2078	1616313240000
2818	3NKt2QZPqY2W2qqtRDsNKMeB1MDNAUgiAiqzxyk4AzPDyTjUjgq7	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1406	1393	14	1	2751	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw	1333	2080	2080	1616313636361
2821	3NLC2HHkVbHrjrR1v2aHtki5m7WMfbQpfNNRK1g8dpMTzHPqqWcg	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1406	1393	15	1	2754	jxB5LoS5w6CNHr1tQPJBA3ECsTJ2JzDVmxqzeqcgbhPrz6WbgiL	1366	2080	2080	1616313734683
2823	3NK7HWx9zANRNzquzR5AR2dFyAuQMLEX6asTQj9dkkaAKDsPBcXP	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	1529	950	11	1	2756	jwUZGFkGuGqzhNRhdvNH3nxKvDvwuLsBNo11rgf3htJ7PkWCXF4	1222	2082	2082	1616313960000
2826	3NKhjHydPRSLAXVgxoLBskJQHdLcnQ9WodxcxjYCPpx35g62dMSF	2825	3NLmQkGXKC3SFSPimByDLDanccxgr26Yo5qLSc67JGHaocoe5tj3	1407	1395	18	1	2759	jx9aqynBEPMX4VopGwjAw2J2gzvzdr1ywvYULrFCiNd7A4tzTBU	1476	2087	2087	1616314860000
2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	1656	977	18	1	2762	jwvAgE6mGsqDjrnJYxmMFDz3KiwU1WC9pvTZhWugTocQXRM4ccV	1478	2089	2089	1616315220000
2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	171	1008	19	1	2765	jxj2nF2CWQhd9vFwib7Fq3H3aR5kYH5qjoPPLmRPG3jBPuZZcgQ	1480	2091	2091	1616315580000
2834	3NL5J9MbJK2dh6chsPqKkcCfgpm9RBTfPhLPjezwFzkmUX5V48LC	2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	369	1066	19	1	2767	jwjttpzDzv6b672sRWe4gRwPfwpKkDWJF2jDgGowiMVNHvNQ5wF	1481	2092	2092	1616315760000
2835	3NKu8j3nt4ReUzAQ6vKmbD2stwokKzqRZW1J7YZyw37grXBtxBcu	2824	3NLN5C4HgQW35UFCud2F8qNz4FHg1XH7MWBvYKd5qvvDZ6W99DH3	1403	782	13	1	2768	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1284	2095	2095	1616316300000
2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	2837	3NLHLvh391DxhYVpt7rCE8biUE84CW1tKsYv9h3zPvMaKQDSBoHs	1467	1376	19	1	2771	jwCzAMkLh58jcZbVafj7Q93okmJxrQVWbdYjhaiEkqvkjiEkGvR	1484	2098	2098	1616316840000
2841	3NKwwkmzHJt6dsebgdEfELf1Swyb4GXvgfPStZqgWXkQ68gXqGvr	2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	1647	1056	19	1	2774	jxR3UY7MRmiaMXLtw8R6RCQJVtFKYxFLpTitXSSpiCXmNoLw7qT	1486	2101	2101	1616317380000
2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	2843	3NL6MTyq2jydyFAo1is1eDw8Crv9iWB4yhXgmdpNW8SwiT97XpSD	1477	1350	19	1	2777	jwK972BjabPTFWDbnWgLU8o14FCvWzco9oWCHSeiZiwJ5rBq9Ju	1489	2105	2105	1616318100000
2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	2846	3NKXrMPm7KLbWiH8vZ6mvUV6MdFpHjtYn8TGhNFu2wuU3MQUEM8w	700	832	19	1	2780	jw6sEKnheuYcMLLoVAWBgesH8VpAcKsLtUd8qJAyPHew1h2Huua	1491	2108	2108	1616318640000
2850	3NLeUcMwdjY6mCNHohbcgBh9nrA86RUoPGvJvfKFXtPp7fpHYyHJ	2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	1509	1320	19	1	2783	jxinVaBp1sKpvBieuZcagLP4fQAwUZ5Dx8pV2MExum66QxgoNsQ	1493	2110	2110	1616319000000
2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	2850	3NLeUcMwdjY6mCNHohbcgBh9nrA86RUoPGvJvfKFXtPp7fpHYyHJ	1407	1395	19	1	2786	jxEkvaoc4a4N671ybhzTjNZjSrAxwcb77vyWPMcTdr8hrNHLyEf	1494	2111	2111	1616319180000
2856	3NLXHpPEkHnyANYwqZmTYAwXs9f4AnKVczEHGEMEmQVk3R5PChfZ	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1455	966	19	1	2789	jxkzUk263RJXjWSWirmU8jiqPZYUgRHazupzRiksmrMNLtZcHcC	1496	2114	2114	1616319720000
2858	3NK7UN3LnCjsdoRityDgioiVFUS7g9FGr3x9WLuL3iiqGu1Qzn5u	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1461	1271	19	1	2791	jwYoFBvTnYM9RowDdxfsxKB5MeagXQMeXv2RJtg87yKvWyNNJuA	1496	2114	2114	1616319720000
2859	3NLdFp5jq1HRb1a38JWXeCyjQ2hVrDarYvELzJYPQmDzE4YE64XC	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	532	937	19	1	2790	jwrtP3DB68gmFByKP9Yd6syimWA2MVfSEamL6s9oNucbeJrNfGH	1496	2114	2114	1616319720000
2862	3NKdmUZ9T1eEAQDz8ZbVPixdUvvww9MKyQtoNz7Qgr9wRbmD5Bz7	2672	3NLYB2wrMR5zmMDi9qqssPGPbNjcfjtbNovmLoRAyCY4xmNygakn	1513	1133	16	1	2794	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1405	2116	2116	1616320080000
2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	2861	3NKBfmBD9zeRLtMeaN9Vj4J89ZUCc6QUCog2GHWFzbLk3ReatV9i	596	1180	19	1	2795	jy1EKWCnvAaYaBtGjsKUFcM5KfDwWyL6nKwUk3amCjZHKF7Pv4F	1498	2117	2117	1616320260000
2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	1402	858	19	1	2798	jxxAfuBy2KtPz8hADdKtBWjDvaQiKyheUUUKYKtZ9kfDFhdmYdP	1500	2121	2121	1616320980000
2869	3NL6t4N6vNqbq1duNWQ92k5rMk2EzochE467vFSqssXJwtdqJ9y2	2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	1627	1259	19	1	2801	jxArkF5HYTSJxvwkFRbhLgsmvWroSMV63EBz8SLDspqC4mA8vVh	1501	2122	2122	1616321160000
2872	3NK4zYaotPVMm1bAnXchT8MFkXjxGKr2EotL4V77DEzz389qL2Hz	2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	1553	776	19	1	2804	jwV51usng8ZWstxzMTuZXov7hV5oArvZ4ERDYK8JdgqjcZpZdbc	1502	2123	2123	1616321340000
2875	3NKK8pWL3Fk3bpfAkHV1MtUYDUvPw8p1McKpye4EZEfhAT1BhZi3	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1422	1091	19	1	2807	jwG3kpzBKnN31Dq8cbAFkDUEjUDkHchv7QfpksLzZyA8h8Cgjmz	1504	2125	2125	1616321700000
2878	3NLQthAesmqPSTQb76uWuDU6Xt9K9xGhj8fNxCmWSjCAALYBXNkJ	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1608	1043	19	1	2810	jwnvEZjduTTm1SMWVxKYkdPZQ3vFZYGc7MCMqpsz7VV36NJzCJu	1505	2126	2126	1616321880000
2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1534	951	19	1	2809	jxwkxUUYqFcLobQMzoDZoRdW89jkHzA1iaBsxwXR7mxVZy75UjJ	1505	2126	2126	1616321880000
2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1405	865	19	1	2812	jxkhCv79ZmoKJwsL3sdjwSWkaLFXScE8XXnSzGvFoP92YZYcHi4	1506	2127	2127	1616322060000
2883	3NKs2f7RCjZABg3f5dpHPVas7xVMjefxgTFLTZHjf4szFVRMEHiy	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1608	1043	19	1	2814	jwqW3nJogbx954SHhrcpPu2Ru2ovWhNhf49ksrcCAZLPBoXN5Tp	1506	2127	2127	1616322060000
2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	152	1084	18	1	2764	jxXuzRSDeYsXACDgkM9GszmYChTocLcFFoRQdamwFokbquxN4GB	1479	2090	2090	1616315400000
2836	3NK8U7vr1tgpstyp47SLfrVBvygbY4Bvyqcf3rUU2JppWGLhA3gv	2834	3NL5J9MbJK2dh6chsPqKkcCfgpm9RBTfPhLPjezwFzkmUX5V48LC	1405	873	19	1	2769	jwsEwnHmJ2xM3tvvUUP856ewjWPuSrcvqTzuuT91og5eqLWHTLi	1482	2095	2095	1616316300000
2837	3NLHLvh391DxhYVpt7rCE8biUE84CW1tKsYv9h3zPvMaKQDSBoHs	2836	3NK8U7vr1tgpstyp47SLfrVBvygbY4Bvyqcf3rUU2JppWGLhA3gv	1407	1395	19	1	2770	jwgwwjsAz9sLReX1UYFMxxk4hFGAjaC2iZUd1nnFvi6XHwqsmjS	1483	2097	2097	1616316660000
2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	1508	1141	19	1	2773	jxp8ak4CjWjMqu8QjeV4XQSp4q1JTSf5G39e9YBeggwESSMv5yk	1485	2099	2099	1616317020000
2843	3NL6MTyq2jydyFAo1is1eDw8Crv9iWB4yhXgmdpNW8SwiT97XpSD	2842	3NLfnRoqhE6YURVxqzatiBpkHyVRxw8qsLvfa4Pr7CHYMHhWeqMM	1646	487	19	1	2776	jxL2tn5AN4rWVncvtskRTByUTsXQooDW2cJMb6NSqcPjQpx62Vv	1488	2104	2104	1616317920000
2846	3NKXrMPm7KLbWiH8vZ6mvUV6MdFpHjtYn8TGhNFu2wuU3MQUEM8w	2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	1637	816	19	1	2779	jxkH5uwd6rW8ocVhD5eAPEKi1WEjHP5hM8wyE69MtJbXu7wqjaH	1490	2106	2106	1616318280000
2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	1627	1259	19	1	2782	jxbdeee6CF96Sg85LFTgXekeGwFhds2aRN6B7MbF1aik6KUuUYu	1492	2109	2109	1616318820000
2852	3NLnzRGgE1L5MxJF9fWthg6yiDVXMtSnKeZbVj9Rd7YnMurH9f75	2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	641	1336	19	1	2785	jxPeCanCHcuHFWCpVcdobsx51x74DZ7CRm5RmXJs5Sv4ioH1YeG	1493	2110	2110	1616319000000
2855	3NLkeViDZjHmuqVcTmoHPoZoBYjmsDtFjgGM2CjBgxqLJxY4LZwQ	2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	1631	794	19	1	2788	jwjxaaQMsUhZCxWcy87bAzR27VJtxv64W697bJW9AatbaZ6FhZt	1495	2112	2112	1616319360000
2860	3NKaMySnEKzNziq4vScokqLWuFB9scQPuhVEdGf3TWT2uxnM2EBb	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1631	794	19	1	2792	jx7bkeMrQ8W1f8u8ojHwc7r9dXiEUbvVk4LjN5mYDTVWCEmPXbz	1496	2114	2114	1616319720000
2861	3NKBfmBD9zeRLtMeaN9Vj4J89ZUCc6QUCog2GHWFzbLk3ReatV9i	2856	3NLXHpPEkHnyANYwqZmTYAwXs9f4AnKVczEHGEMEmQVk3R5PChfZ	1527	1293	19	1	2793	jxvq6wxCTZqJxZjMApU5Duyd25TpsWsRRZryxG6UeB9km24tY4w	1497	2115	2115	1616319900000
2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	1547	1378	19	1	2797	jxFKzRL61VC53PVXmMBFJ5p66ZtbXSTXf84kGHNQuDfRMYhLVLT	1499	2118	2118	1616320440000
2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	1407	1395	19	1	2800	jwLc6rHaiUMpPfReWC4ZQouENXfR1oNFYENAeQxmDSdzMzAEvw3	1501	2122	2122	1616321160000
2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	632	1256	19	1	2803	jxUKYR6Xiu2ubt3gDFLbdC3SQ3tyv8ZUKCAtrKMUZtbm2VUAdmT	1502	2123	2123	1616321340000
2874	3NLQt8wDsiHNi8nF1tEK7cjojto5N8m5eUBiFBP5R3w9tPii2fjE	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1406	1393	19	1	2806	jxGBbLsthMmaywryCtrGxqCgyaDFbGn7JreZ2iChcyirVcd944j	1504	2125	2125	1616321700000
2877	3NKZdgXhjeFV2Lbxrh217EzramH1Pzw9p98XQm4eQ7Ka9kkux59m	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1534	951	19	1	2809	jwBA6qwRvAJYFNL5PKJGzooPmW285FCDfB9kvyWKttMQsCxDftv	1505	2126	2126	1616321880000
2889	3NKgL6XdEkteHF9tnbxEaLigU2dS47XLLwnx4Jta9hAJVbGJoBor	2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	1637	816	19	1	2818	jwZmAS9HcUKfKH2ECFyNK2rX3cmiA7nPeqojom2AuGn3KCAWQ9X	1509	2130	2130	1616322600000
2891	3NLdTxPVACBBgCPaGQjNNVxqAoQKrNEAyJnaUZoks84rPtCcshoR	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1457	1145	19	1	2820	jx9aNiuGfSce7gLH41HR7AmBFYHMdGuBKyGGYLo3MvZKPCA2pGt	1510	2131	2131	1616322780000
2893	3NLmD2uMjUBWrTah6VsSkxJSZPqp1ePGBCWJEASeYddEmqQ9Krsy	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1596	1363	19	1	2822	jx3N23CMTC36qiyxVwrEuVJJxaJzA9SmSwg71KfRaevUxx9nxCn	1510	2131	2131	1616322780000
2895	3NKL6PtYKjHdL2s1YYcmzKjX5xr6mA9bHE8jWDznR82pq8ZQva1c	2890	3NKTv9SwXyUg5m87CJW6WX4EH6iQgRwGs3WEK2VuJTvBxH4MmfpL	1474	1083	19	1	2824	jxDdiuiyGjiyVZSW4say145DBnUpyizuJ2tK56AVH2JMX3y5nXn	1511	2134	2134	1616323320000
2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	1637	816	19	1	2827	jxENxxjNN9fM21CYTTqcJKtw7okaVkYVKLkgEw7GGzb6zkYWC2a	1513	2137	2137	1616323860000
2901	3NL9Qd5YDYN2TsUfiVabQJyocdGExyMDjuswGm36caQ71Ycprb8X	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	1407	1395	19	1	2830	jwAz3XagUPMNF6837RtREqdhV6iVZRQsHutDsj7SpYkcX79g7DD	1515	2139	2139	1616324220000
2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	2903	3NKp2MVDmL9ctgZ9LbeNyUpyJ9SBjfH9scQ7G4ngfntT2zEriVT1	1589	1040	19	1	2833	jwP2MYom3dmB1LnMBCmTqzQTpRL98mb7MwajgCXeuYZwFWCN4KJ	1516	2140	2140	1616324400000
2907	3NKjzN5Eu4T5MRfJpvCiDs76YiaFWzUGTRD5aJEymVZHH8zPQoPQ	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1534	21	19	1	2835	jxMqHvkS82pucs22bLNoGWSVim2zqx8HuByrMfkBrYD1X3BgFhB	1517	2144	2144	1616325120000
2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	19	1	2838	jxjmU7QRmV8u9ei2kSEnq4ZjLKhohGJm88WUH1kQwXAaCwY2YXH	1518	2149	2149	1616326020000
2914	3NLA76kfnz1dNjAS8Y92Twx9ja2evs1vqbVLpQ1HkKugKoWm1bZj	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	20	1	2838	jwWag2DVtDkVotfFo8yEKZ1rT3rMU1GdZij5kgRGyty4gxySEKK	1518	2149	2149	1616326020000
2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	2916	3NKKozLHhGmqoMiiRGtXWhHo6fiiZrNoUmacGraRMYG7RzSYWwRu	1643	1299	20	1	2843	jwk6hunjzCg3YdqcGkv3e3JVv6nN73Yx5Hwskm1CJkrTidVawMy	1520	2153	2153	1616326740000
2922	3NLWDKehAcjdzTXsZ99PYuSRhpb82M88hLqaXRbye46kX3Aepdxr	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	80	1273	20	1	2847	jxsde8YpfbikUbgfvMY1xuUexEMDGhE742JbNWr8zA7CymE5DTr	1522	2156	2156	1616327280000
2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1447	1219	20	1	2848	jw7fbeQ6kh7ahs8496v9WUCKS6iSx3AqUxGzdRxknkmqk8dRyFV	1522	2156	2156	1616327280000
2839	3NLdjpqAn7rmB3JVp6W7o6HB4t7iVsZA4YvHD31HFzugxK5t9Tvx	2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	1406	1393	19	1	2772	jxsYLssCscPRxtZ7pfyvtwQUzDcgxDraksnXaPWdjycF86BaptV	1485	2099	2099	1616317020000
2842	3NLfnRoqhE6YURVxqzatiBpkHyVRxw8qsLvfa4Pr7CHYMHhWeqMM	2841	3NKwwkmzHJt6dsebgdEfELf1Swyb4GXvgfPStZqgWXkQ68gXqGvr	1623	839	19	1	2775	jwZZfaeJ8LEtEiqXrThy22Yb1V414YdMt2FBo5huoVx44dpxnRZ	1487	2103	2103	1616317740000
2845	3NLyTDTSyRBZSPksC4izVDqZVnawqm4pYYRSni3pf26mmtxzAPRW	2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	1405	851	19	1	2778	jwZ8cpjmCUfUc1SSFxTuhMx5w86MPPcudyr1u63V5rzgENUTGKC	1490	2106	2106	1616318280000
2848	3NLHoAoTo9x1C3cRvh1HqLdZ1SzFCEybqLzTiUEWaPfNpopWb5NP	2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	1407	1395	19	1	2781	jxeMJei5FDmyiyVLGKKUVJgyGWioayrECgbca3eJHvPE25KgdNg	1492	2109	2109	1616318820000
2851	3NLM33utr6E18BCza1WBp5qoD3sV9QUeAANnL3nRQjH81hr166kt	2814	3NLMfQUL68UzGWjx1hvZoEg8ymUkPQPfno8woaGt4KjcAhMKS5fn	641	1336	14	1	2784	jxQfNGf12rxZ4pB5kqX2n8NpsiTqgQSRT65vrxW7cC6cDE1w74o	1302	2110	2110	1616319000000
2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	1444	1381	19	1	2787	jwKMN5WhQBpx82nYyuUwd3dKuRR5JMudCSYZx4zN29EuNXd1kwc	1495	2112	2112	1616319360000
2857	3NKb7dJZsq2e7x4ghLBfA5h2NAJGepXB4PkBYxP5B4nVN3bwYbzi	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	532	937	19	1	2790	jxRJicRDQMWpxcrvzf7VX4VMBW8DSQFboxYgmSR8EDWxDFsBuEP	1496	2114	2114	1616319720000
2864	3NL1ZER7NaDYWX5CinuUyKs44HCjKFFY48CR7asbye2dcea8UTsd	2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	532	1303	19	1	2796	jws84ubYbSGSPGbXWEZko8ZGmWSC6Hz8M9Bx6EMAXTXgH7Koo8y	1499	2118	2118	1616320440000
2867	3NKwi1rSmcv5e15efmX5qLW6dXk493h4cxPXtm3kwEYTAzf919sw	2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	1613	1349	19	1	2799	jwP6L9BG8knPP2bp9PbEAHGYY5FJK1vsMpNsR3kjnsdZX39xJhg	1500	2121	2121	1616320980000
2870	3NKE6f9G5w9GCLMzdq9aGKWogvqGDLJiQNU1S6U5kLKxqGDS9mPH	2835	3NKu8j3nt4ReUzAQ6vKmbD2stwokKzqRZW1J7YZyw37grXBtxBcu	1403	792	13	1	2802	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1285	2123	2123	1616321340000
2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	1649	1257	19	1	2805	jwyUwMnHgBardrkyotDs2UioT4VKDkbX8BK4yf9BXpjcQ2usFeA	1503	2124	2124	1616321520000
2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1619	1275	19	1	2808	jwsRsAgc3VQRi9mCJAB4UkV8zbVTGH3we6VRbAHwewmU36AKTsd	1504	2125	2125	1616321700000
2879	3NL3JrJu9srSXshEmmBgK6QhY8L6NJcgDTZVBTZatWXxG77Qwhfq	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1458	1197	19	1	2811	jxiicVTZ6yXrLBrk43HvLhHjhX9yqTdLSWxh93uzWG69ix5BXPC	1505	2126	2126	1616321880000
2882	3NKoWSuMGFMEEbfeDpeTTNxyQe3Mtyw6LyhQGQBNzc2thgWiBXGC	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1593	980	19	1	2813	jwFuyZqea4zA5dqZL9ScPCmVFU8PARHtLDFXg7DniAYiNxUkegx	1506	2127	2127	1616322060000
2885	3NKiin4NhJ3vG4jsAyPDt1fAVzsqnXfGTANNx356qi1uryaLxpip	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jy1XJdXDEPcDvxnt5VbgvbuFiZrRYS1WM2Cc32XRUsELR5839HL	1507	2128	2128	1616322240000
2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	563	1359	19	1	2817	jwjQAJ4S9kEPJTUuFvKE9efsBXFqRVjoxTZPqXZb6Y1rnyGeKEB	1509	2130	2130	1616322600000
2894	3NKiUT61ga4iTk5dbXxgLmPHiaG26HzJUgFMKSgkx3FyPGSoPZYC	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1631	794	19	1	2823	jwQRi3mbxMbVXJciwwyiingMhhbuU2cUDnNvCvf2uP98cBBVirh	1510	2131	2131	1616322780000
2897	3NKmB8XGfgbZSZkPDY7aAQHJmi5mEecC1F7FiSowegSWkj8DMvwX	2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	1553	776	19	1	2826	jwavp8kzPuo5Kfnmzxvu6UNUbxwzrEY5wiyJBa6rizBZgTqQUgE	1513	2137	2137	1616323860000
2900	3NLr23HozvHq6rjqkezAV44sZzR632xfzpoW7UiRyV1goWjeRndS	2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	1608	1289	19	1	2829	jxY4vo8T4upgAHo1CDt4yaD7AA3mcM5qXjiG1LSk8QnMr38pD66	1514	2138	2138	1616324040000
2903	3NKp2MVDmL9ctgZ9LbeNyUpyJ9SBjfH9scQ7G4ngfntT2zEriVT1	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	1633	1024	19	1	2832	jxg94o7f66PfSNEJxoKWTF6kAnhAU2nyf5VioNtPLcUQvC4D1eZ	1515	2139	2139	1616324220000
2905	3NLQttBrGWXWSHkaGTsKWHyJWRVs8RD9P1ewqtsaV8BS6M87aQ2U	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1467	1130	19	1	2834	jxGu3FVxDnYPRrvjW36t3jJ1TMjB784ufsf4hYCbsTbdp4zRtXH	1517	2144	2144	1616325120000
2908	3NLHfmAGmVfnuysM48V7PZK5yNTGHaCP4ULRFz9Gvp9K7aeN9eJo	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1613	1349	19	1	2836	jwSN8PKyrMDEJHRVbcAwK8jokoCKfE81bT3QTEmhCguui1W9Q3d	1517	2144	2144	1616325120000
2910	3NLx2muhm1H7JLM2JjT9KddAyKtkJo1PJnBuczzLh9MCwJu3e5ha	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	19	1	2838	jwx74RKswWBjz761A6WSzEU8E9DsbcrryNk1TqoBGAxe3rzQ9Gk	1518	2149	2149	1616326020000
2911	3NKu7BGgRkkWWpgR8eyt8jCCsXKh6ntJn5yCQYSKtxVWWBHa3G1C	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	20	1	2838	jxnVxsuDi3ksWXkMFk1GezLZtvBfDD4EE3fyAqFVNVT4on8jDnC	1518	2149	2149	1616326020000
2912	3NLGqKng3Auh5VWuaMrECST23p2B2rau2DjpvTb5dScwoonvqjik	2798	3NLh5wMcM7TY74PvKykJyJirXD9LM9RCDhu64sGSJLmBtk4PsT7B	329	329	18	1	2839	jxgZ6iATWJRyZsbzFNeoZQfCCuhqpScunFKh34ywqJmU6uudTwj	1465	2149	2149	1616326020000
2915	3NLm2rhwtRxtpQ53En5hhrupjP3RWzQu9Eih14HYfPLZhTEHtQr4	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1509	1074	20	1	2840	jx1BridaE5jL2BaSv5R56NcPBoqfVWCtZju4Kmci3WGSpjqVNw2	1519	2150	2150	1616326200000
2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	1642	1367	20	1	2844	jw83g7dsnSsZwwntitUszh5WqzBA3nSk9WfUWpZDhyXPJQ4j88P	1521	2154	2154	1616326920000
2920	3NLRkdvGFyw4qjBJR9uiTWjucsWBEjj3pKN464FWpe2fbZCFFhsr	2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	1406	1393	20	1	2845	jx38yHphqjZq6XgFP7FELSFBffxzxz1xnvK9JvhyjFvqhouYwYm	1521	2154	2154	1616326920000
2921	3NKHyUMJpyKz847hfEkF4ETDVTFxuRh6B3GWMWdTXyX2GhJHioex	2725	3NKeHNeVp2XaAaJ1MomqnYjWond5oAs8J3aBxqKqsuTkurAxkCaN	1501	1234	17	1	2846	jwaGTsZzHMLMaHrT7tszf1HYSw9k1uzvAx178Ecw7MySD2VESBh	1432	2155	2155	1616327100000
2924	3NLFQgyFLf566gpnLb4nSQ7CYK8zmqZzQehZKx8Qb5thc9FxBpaB	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1522	1076	20	1	2849	jwBUR8DLtVQbJrKT33Vb3j8tBw5v93oM3Cpmtm5Xyz9LFzxofQt	1522	2156	2156	1616327280000
2884	3NLcJWEQPZkp2YdN4erDpMagCZaeLWEUtGzhhfMnitiWjsyeDaag	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jxTdSqJuBX8XGuWCntJv1GXocHHkHp6JdorYQ1nYhQSdvb4dmgC	1507	2128	2128	1616322240000
2886	3NKyLghS7fN8X1Pux7LeksB1bidhdPzYFLN5zHcB34HPqpKwGTrA	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jxtzB8Koqf2YXTPLnsLTNCxUDUsfQLcvAzALVWPQssy9A9BsiuM	1507	2128	2128	1616322240000
2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	2885	3NKiin4NhJ3vG4jsAyPDt1fAVzsqnXfGTANNx356qi1uryaLxpip	1549	1362	19	1	2816	jxHPxC7BdWBn42YBxrHduZ9iq53WhcqibmQeVcgaYG589fJLcVj	1508	2129	2129	1616322420000
2890	3NKTv9SwXyUg5m87CJW6WX4EH6iQgRwGs3WEK2VuJTvBxH4MmfpL	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	563	1233	19	1	2819	jwgPZT8uuyGt7YQ8biXBoYJWcXxgHLgfUqbY2EZ1cFUjvZGTGui	1510	2131	2131	1616322780000
2892	3NKKxW8yJjeXEfNLtMcNzs1RyVGETf5Zn4U6YPdvGz16G8r8ziUS	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1617	1288	19	1	2821	jwMymyB1v7Qm1crmSAg9XG788fiZLnhuvJuv85BbFjuF3hfAwKt	1510	2131	2131	1616322780000
2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	2895	3NKL6PtYKjHdL2s1YYcmzKjX5xr6mA9bHE8jWDznR82pq8ZQva1c	1402	868	19	1	2825	jwkDdUTegZs41eCQqisteEsYScHtJKiXV2pMaWR1igWTiTyb6bj	1512	2136	2136	1616323680000
2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	298	1308	19	1	2828	jxNFpbkwBmRFv962EDHMwijoEy7u3hYxsVKz8A7mCZHxCmF6h7T	1514	2138	2138	1616324040000
2902	3NLNCTsN7MCCdaCmUqrg6JJ7Ey7pCjpvwzbz9HwXQC9gXpgwSGTk	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	448	1305	19	1	2831	jxghdrotJmV7SFhkUJikYm5BgDaaZXgCXdU7Jq9biH5fLfjA91V	1515	2139	2139	1616324220000
2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1534	21	19	1	2835	jxo7YmJk51HZWtE71b4eoJywbPJiKoEyFvi7bfZiynt6hLsQWMS	1517	2144	2144	1616325120000
2909	3NKgcYKTCbSMeWGPk3akeMVDk3vEqwFxWVDt4WAQCDm9aa8nULvw	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1647	845	19	1	2837	jwEiPtJFrEXiNdid5mbuYeNmgdrWDxmBgHfr1x4iMJcP8HntRWh	1517	2144	2144	1616325120000
2916	3NKKozLHhGmqoMiiRGtXWhHo6fiiZrNoUmacGraRMYG7RzSYWwRu	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1444	1381	20	1	2841	jxJx6gB18bJm6LLUtg5EJ3v7CRXkQ2BrZybQkA643UBe9yNY8UW	1519	2150	2150	1616326200000
2917	3NLGPVxGUx6XBTx2aZ1F96fRnSUVCdXV91VDYynQfGTfyGAghtTp	2682	3NKt9CzWSmrdfRdpH8dcaPh2akczcBktP8ExLJguXTnmxNaAVpWh	1643	1299	13	1	2842	jwBxF1EngeeDc9BN539FC43v1MsUNLfmJbVGy4yNLC6oBqP6Tgd	1270	2153	2153	1616326740000
2925	3NLcSNnZJ4NLNVoJs34BLFUoJCE6Q8QxZajjiwJgaRvucHVS66S1	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1439	1033	20	1	2850	jxutQS1LG6UhJWhmaU9yvna2TwKhs9L1isHSntndFcFEXBnCDV1	1522	2156	2156	1616327280000
2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	1406	1393	20	1	2851	jwfVSkQYDkiFeyXewErEND7PYxpbdg9UMVriSWGjq1AreNJaxVT	1523	2157	2157	1616327460000
2927	3NL3ZLA9UskrxxWyVAmoqVmw2nNFQYL9UnRC3p1riu2SP73dJfJL	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	1670	1156	20	1	2852	jxohhac2Wa4nMtm2JwFbmA8RtZ8LCrmQDakLdLmrRYFDAvHWzWk	1523	2157	2157	1616327460000
2928	3NLyU97Wrn5HEKQaea455maeWdu9Sp2NnXUWxDknYaU1HdfBTDfY	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	532	1303	20	1	2853	jw8pUpbDhRbvifTWGm9KKvjWjnZ1KrvyCkE8a73F1p3v5ZyRrnZ	1523	2157	2157	1616327460000
2929	3NL3XszddgE1Hx7uTvNSLA82sZeDekSfCeaSbQaHQ8gZFdQFZkjX	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1579	1389	20	1	2854	jxh1XHRg6tqQQhEnUBhpPoDjCMd2TMtMBnvVNcJnPZYiZhKcrKS	1524	2158	2158	1616327640000
2930	3NLFKkckVgpBnbZRkDjeyPzr5aRTGEDbMognZjJaBpGGXd1Yv3HF	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1599	1161	20	1	2855	jwvCz7jCo7Psh6QggTNtzrJBei9rw465WE3TxPxpX1vKcRD9CtR	1524	2158	2158	1616327640000
2931	3NKJTNuUoz5y8TAHWhVMrQCyneiak9j7ff8RPRSSBsCNiLZhaErJ	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1631	794	20	1	2856	jxVRZB6AMpTnJNNBRu2xE1ZBHaenR9CJW1jSS4ZmrZHJtJXpcLi	1524	2158	2158	1616327640000
2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	2930	3NLFKkckVgpBnbZRkDjeyPzr5aRTGEDbMognZjJaBpGGXd1Yv3HF	1553	776	20	1	2857	jwZQu77tpTXhrJ279U7Z3oYBzn1WKX3ik1dXo9qFVS35LXwjVTK	1525	2160	2160	1616328000000
2933	3NLCq4GxFg5yqFuG3S5iojj9UouWTXqEj3z1ujXmPhYuCQH7KCPT	2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	1406	1393	20	1	2858	jx5EGzDASaAN175ahb35YRkuJMTU579U1tYrTCZxx7272wf6QNv	1526	2161	2161	1616328180000
2934	3NLfwzSrv6sq6NwfAgvBg31x3RTCktPaYh7PEURw6oyunuQkkerz	2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	1637	816	20	1	2859	jwdNVJ4eFDnu8SFJntyGfZ7LqddhrMSj9NTbzEMZY4pfexuTZDq	1526	2161	2161	1616328180000
2935	3NLV1ZKiWA3F8D8Gxx4NZNq25BxToB86z6KDcKdG6GkRvw12ZKnv	2933	3NLCq4GxFg5yqFuG3S5iojj9UouWTXqEj3z1ujXmPhYuCQH7KCPT	470	1063	20	1	2860	jwQAhE2k2iLKKWFLRV9dczTQ54399DnLqRinLFTZk6p7cc4Qt3D	1527	2162	2162	1616328360000
2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	2935	3NLV1ZKiWA3F8D8Gxx4NZNq25BxToB86z6KDcKdG6GkRvw12ZKnv	1422	971	20	1	2861	jwDBUPz6jQgrTxP9cvMWEYjRrTQBwjdCo5yQz2cummSrS9SDXPW	1528	2163	2163	1616328540000
2937	3NLaQuj7zpzp6CXPgLoFLynvTWNZW2m58Sy5MxRKS5xmP55YKQSi	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1422	971	17	1	2862	jwPMNKHNyNkZnoBR6sgxhUEtmsu5wXMzXwtjjamXvev9cxRwwWX	1429	2163	2163	1616328540000
2938	3NLi4Sv8TxPBSyaGS4tqcH4aDsD6UA29TZL7czxiTDwwrFczEviZ	2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	1422	971	18	1	2863	jxyqFUA5DigfJCXEV9KAPskQqEhUbSwM7in2rGRmooK8CEMEj26	1446	2163	2163	1616328576713
2939	3NKvZi4E7hCLPvmfWsWWXyenvX9mum4nzzmei1gsms9NdLTtptWJ	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1422	971	18	1	2864	jwWWHBowftbWz4mHbcLHNPZb8eKGFkGjDRXERxjsuTzBNmi2KoN	1465	2163	2163	1616328613326
2940	3NKuprfzsAhLnRv2ohaJAuphs7MeWAYxP2gMHuwdStNs2WetHkHn	2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	1422	971	19	1	2865	jxAsG8BG9eEo3mPreDHVSK2sNM4mXo5NbxRReMX6J5rJzeXTHwD	1481	2163	2163	1616328650033
2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	1577	1327	20	1	2866	jxcLiJio3gjovktBawPnDsf6udCx55MjruYtNP6yMDqv2N9Xoit	1529	2164	2164	1616328720000
2942	3NKHX5L6T2348RR1QJJjrLdqe4JEfBQwfRxmajqiM2QpzDLyzrh8	2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	1577	1327	20	1	2866	jwuM35D8VnCJgpz1PhEUuMWbZ6FjaNfNQZwSftFHAcKLN9NwniT	1529	2164	2164	1616328720000
2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	1668	1370	20	1	2867	jxAjmFR2yfit98nq9naiKDoz5t4fti3hKir2sT8WNKLbN9fjHHZ	1530	2165	2165	1616328900000
2944	3NL2qWbwUwDFVMyJtcC3sfn9mhMix5grF71Vmo7CDYDRk6gf22Ro	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1406	1393	20	1	2868	jw7qD7UovNEJzA9zAwTZZCFspwaL8BHrCE8chtwpRkjRA3LnFLc	1531	2166	2166	1616329080000
2945	3NKrRAyEt27yChHeKaQ3LNTVLaLmqUEDKCuC7xJ3y9cQv4DFgBZC	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1627	1385	20	1	2869	jy3J15eR7qokRyx4tPNLjrzHb1uzKwdMLf2LZVze8daGR8MjjcC	1531	2166	2166	1616329080000
2946	3NKzVj7cmpAwSBkAzkL7iRLdRWRijNRd6UXCRzMQaXsj4Ne9J1DU	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1637	816	20	1	2870	jxDnbTmX3anoPBLrmkbjeL7gcez8iopzUh2qnJxKXVu1HL22o7z	1531	2166	2166	1616329080000
2948	3NKGXCVcoQgoPW1napsYGdbiEzkskq7t3pYVevPzZGXJ5wbzjcGf	2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	1462	471	20	1	2872	jxsPyHcrUmQf2pv8sgzJ2hyytU8EQLW4CoicNQhzdyGxEik78hq	1533	2168	2168	1616329440000
2950	3NLdKLRVTLHgyPmib5m7kTTQwS3aWXqHUwDpQ5wfvcM1M3dAtvCP	2949	3NLtDyHRtDh8LmQbG8LBFWr5ot4D5td46yYZBoNNbrXF7CsojHdB	1631	794	20	1	2874	jwiZ8cgBbRT9bL7tmX4qA6AxyjdMxiy68bvbVncehKaSJbQQ826	1534	2172	2172	1616330160000
2951	3NKki19KLbqwvyCKWwiu7d5HSbWVmSYZkDpzq5kk8RRkn1mktHB4	2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	1611	1215	20	1	2875	jwAJNVJFS24D8fAJzAeWauxxiUoCAeMmeqNVmAC18ZBf3SzVhYP	1530	2174	2174	1616330520000
2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	2952	3NKZnpuzvPAGnQDXFijDaF4ttHYEqCnzUtwEjFhJejkBd1au8ND6	1553	776	20	1	2877	jwBGt51387Mt2ySYFxCMnfRhJv18cZDRQo2RmXXAquhPVWC6tjN	1536	2177	2177	1616331060000
2955	3NKtq1emtWjbnuCiTgpdodGXXWW7u4EQbkMHXBJdKM7urhKgYc2C	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	1507	1034	20	1	2879	jwrwAYGT6eJBBjGTa5kbDjw1eWknq96qHHEqLxdZuZixKHMGZ1V	1537	2178	2178	1616331240000
2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	311	1307	20	1	2880	jwSxP584Rhp67C9PwAEN9WAWDTLzTxFNRMnBPivcpzEQxrRFE7j	1537	2178	2178	1616331240000
2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1560	1291	20	1	2882	jwekRGTYQA2dKbRCjFgua8FJCu5cWMvf7V2cJi8nGVtB3caTbHU	1538	2179	2179	1616331420000
2960	3NKa5AfCRors3DL1eR1oZGU9imCUaL2iZuny468MNcYYciCqDXib	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	470	1309	20	1	2884	jxoGJUEu4sox2jjaTR41KbW47oPiVNrdBpYVTG8PMRDtQX7sNFP	1538	2179	2179	1616331420000
2964	3NKxhpiHcMCtXdpF7F9hSgsgvbskTZ8xJYCwW7LVmdvoFsYBo5PR	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1642	1121	20	1	2888	jxUt9tLCpCBAAgfExwKajxgTYU8UHnATVrRhUbpkkAWspLe7jgC	1540	2181	2181	1616331780000
2967	3NLtzeCKURGtn8ecVkfSpVDxUMhur2ZAXiiE1RJ8Wd2hgSn1Knx7	2965	3NKc5t8N9HutkyJKFHoyRqvSP6QceLHBhYpKfKEy7CopoWw2skuf	596	940	20	1	2891	jwXff5U2K6Vqjk1ELmQbsUuBHadhYDY6WEmy1ueVQWQFN3gcNsE	1541	2182	2182	1616331960000
2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	2969	3NLsUvi7y6UwR3ncnYwwDVWyiQPuowjtpwQd36N7unTxqn51scE3	1407	1395	20	1	2894	jwoK1R9USDUgGP88FpJEZiEf2ZeEjKLa8vxy2hkNFfHFJ6RecTv	1544	2187	2187	1616332860000
2973	3NLnL6tmiCn5n9NFMSDfGcSrMV9ZQ7RBNPoXhReojw8hgdbmQZH6	2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	470	1063	20	1	2897	jwBtumb6SSPibi8qcP5cAwkfaRQVgfdeQ3mzefo7MhqdHZhra6U	1546	2191	2191	1616333580000
2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	2975	3NLYcKgLM3jZmYMrMZfdWG5m5mqY6DodhFTaHDYDfnUm3Y1Dt3pf	1585	1366	20	1	2900	jwbQtHLF4qmN8JhyrGaSfu9k9j6PxnFzoekLNPzuYx4fqseYSN4	1548	2194	2194	1616334120000
2983	3NKePayuKTx3DXFU6fJagTFNvDj3M3LQx6BcEJqyvqzbJcGJFATf	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1407	1395	20	1	2907	jxk6QmL11dUwQJSfv8TcHn1ifvFyFXrXrKeqoFXEkjtA11xKYA3	1552	2198	2198	1616334840000
2986	3NLAmLut4GE6uffRGGSNd1UphmMaHDppmq1SEXqRk2TpXDvcwaix	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1496	427	20	1	2910	jxZgnr8x2L5k39WK3QEwz9w8z8mSqvr8xUNG55EbxJ2hk5ZeGcn	1552	2198	2198	1616334840000
2989	3NLM7233PUk5ui4pZmsGPD7Xuaktg9kwRCjm5sVuJzYtSXuRkcKX	2977	3NKPef1GyR2TdkRTJ3xqgLpdgVsArWbfUKkLwbSeu3QE7uLRQfQZ	1403	824	13	1	2913	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1287	2202	2202	1616335560000
2992	3NLMQSwiYHL19wLtxsLBQu9V2bEipgUq6iYjQspcyDCDNgs1xrLE	2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	1407	1395	20	1	2916	jwzDtTsuD4wruSukJKfTeqPRifeoTcxzMNovRBNnjZJpmL8H9Tp	1555	2203	2203	1616335740000
2995	3NLWfK1qpX1sBXDRFPboe5EWiqGiD8Zm1NEuEu3HQWbQe1T5NJ6M	2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	1474	1329	21	1	2919	jwbDNFGxTMWM7oyqwt6AT7UktkLnCEEYVi1qnqCSfTftpSAQfbf	1557	2206	2206	1616336280000
2998	3NL19Pzea9BkmMGaXcsUui31CRxcXZEzLuSr7vcRwVPYk2n2yseB	2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	1627	1139	21	1	2922	jx2VCrjTSTrm4FDC6NBDw9XHRFmxCeAHVrrva9x1Vdx1ehcJgQg	1558	2207	2207	1616336460000
3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	1559	456	21	1	2925	jxFz4Fdji3h6E6HPCD3DcyMb4zavY9SJnEapHWjvhAfqfdLkdEd	1559	2208	2208	1616336640000
3004	3NKh73y9jsHgBjqxUrcE7dd8eDjB9PJsBxGuhmHJJ4U8cRMGTYg8	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	633	1138	15	1	2928	jxdHhm1nzUukHUHQm2LXcQn8tFKJW7cSHWyxGm1EtFAYacmDSCx	1359	2209	2209	1616336820000
3007	3NLwHuFD2xtfxwF7UAVz7okbAPtLPM9WG5hG5jepGYHAx6Fb6MsS	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1652	1315	21	1	2930	jwvT1MRja6RWkxfJjznnoXe5YKACgXB9YjdoTFzq3BQw8gnVUuV	1561	2210	2210	1616337000000
3009	3NLNRG8E9CXiBPcWdztuv8mz7hwJeLKxvkqedorhfpfEkG5Efpce	3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	1407	1395	21	1	2932	jwZjGHzGTLMX3doJpLgEyXQZjktN97oQuzC5kmRHHtx6CKyrjaf	1562	2211	2211	1616337180000
3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	3009	3NLNRG8E9CXiBPcWdztuv8mz7hwJeLKxvkqedorhfpfEkG5Efpce	1536	1313	21	1	2933	jwdEBu97KSJsJHgPisFeH41PnkewzxmY6DY5ibJJ6S8ZSU4XVfW	1563	2213	2213	1616337540000
3013	3NKgzy5Qaom9hwFMZPRFDUeoRYD6vZ9CsSSNoTG9g1G4zYtACz22	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1600	1246	21	1	2936	jwFUTn7HGPFfJLrLgtwEEmKwoamMoLRqHZtrN3HAtecCytB8M73	1565	2215	2215	1616337900000
3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	1455	1332	21	1	2939	jxuuzuprU6mgRA884B1boAM9Sav6YwWK5Ngup965xNSRhAo14NA	1566	2216	2216	1616338080000
3019	3NLdTACLLUhWh5HGSPYcPR3o5x28MnFev3iJ5oJFTPp2ezgnfCmr	3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	1508	1141	21	1	2942	jwDsPLnwY1HXKeGz7VCAsddBzkGWjFDv89da7XKnn9rSzk95Loy	1567	2217	2217	1616338260000
3022	3NL53RyKy8ZrrGpELjCR8xtqTveJCBoEKgHexx4bwQSesTNdHXm9	3021	3NKhiAJMTSSxtgLgqhVxc1QYuUyG12PULcCXV1v8paKikzoNcnnq	1656	1343	21	1	2945	jxsnqoVjBgKKDc5da5sS9kn2XbBNrmWDeUdZ8SUtQGJLnd1jc8L	1569	2219	2219	1616338620000
3025	3NLpXtUQVuo7Y2oMHPh288N4KJMd2S3xm67KusDzAKkMFtMYqypy	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1447	1345	21	1	2948	jxrCnWcdLTCCyUcERMRQbtYjhPyWbkm4itEU51gQXThzPQcaNLU	1572	2222	2222	1616339160000
3028	3NKyTQmj5soejQioMSgVEJM21kVpDbtx5i4myFdAjCnFzis2UmR3	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1536	947	21	1	2951	jxbigWtEKWUCcxMbmQaodJhK95PFUnz3nkC3q8qB61si6mpGt7s	1572	2222	2222	1616339160000
2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	2946	3NKzVj7cmpAwSBkAzkL7iRLdRWRijNRd6UXCRzMQaXsj4Ne9J1DU	1609	1207	20	1	2871	jwmMcQQMZYaRLQoXayoWLNbNyqHLjiiGFm4dKJhnQoDULhmbsu5	1532	2167	2167	1616329260000
2949	3NLtDyHRtDh8LmQbG8LBFWr5ot4D5td46yYZBoNNbrXF7CsojHdB	2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	1637	816	20	1	2873	jwcNyRccrp5agW6iZfitsEW6LBH9gFXrDiFg3hzvAWfuTuP52J1	1533	2168	2168	1616329440000
2952	3NKZnpuzvPAGnQDXFijDaF4ttHYEqCnzUtwEjFhJejkBd1au8ND6	2950	3NLdKLRVTLHgyPmib5m7kTTQwS3aWXqHUwDpQ5wfvcM1M3dAtvCP	1407	1395	20	1	2876	jwZ6syKs9h3MdzN461Xv58qe3EzMv42UTAJiZaUfkaJLbwHcn1A	1535	2176	2176	1616330880000
2959	3NKrXK1dfugCFcYyqWbaEqazJ5n9MemVFxWraRELeAnR4DsmWq1q	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1600	1372	20	1	2883	jxfdBLuYWWGGA5SLCavfUVBPJ45k5fLUEJcxtAtXnXXax1SjGoE	1538	2179	2179	1616331420000
2961	3NKC1SRaayvfZtoAKGJLjVJRjnvS1YBtXsqbnKoJxbVQNmuK1YBt	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1588	1392	20	1	2885	jx1Niez71dfT5xkqdEiQpWJHJjQHNdXtrZc3YquFHLCbn58Rs7V	1538	2179	2179	1616331420000
2963	3NLFDzd38okVvtiV9dsxQWUgucQHPw83mTe7iZg53Bv3fpNQX8Ku	2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	415	415	20	1	2887	jwsJzQ5Pth4oLdXXD9MJJbZ46h9PrZ5T8xNPcin9Xrjbrn7vHYv	1539	2180	2180	1616331600000
2966	3NKbmMNPzq1imkaE1aFppXWiGKYFsGJX6bAJRPBe7VAoNJusjgMs	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1448	945	20	1	2890	jwZ2UuydvuL3zjPzXuViMKfQhv8WSLUEfV2HEZhWa5KhR6WbHWg	1540	2181	2181	1616331780000
2969	3NLsUvi7y6UwR3ncnYwwDVWyiQPuowjtpwQd36N7unTxqn51scE3	2968	3NLFjQ3vKThT7s9U3HdT8HtpPCysj9NQrDRUV6uAn1TCXwdDHcEs	1613	1223	20	1	2893	jwTEHYkjFYEe7pbF4kzL9uWTyRUCWeGTbG8KMHTahYCUiKgEUG4	1543	2186	2186	1616332680000
2972	3NLBQdKt7V66mdVDN7zkM461eoig4YChexZm3SuWuxkeMdvu6iB7	2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	1448	1311	20	1	2896	jxovx2AFWp6i4f8yopAjfn7JqDo2gj8Fktti1ajsp9UqzrNPrRb	1545	2190	2190	1616333400000
2975	3NLYcKgLM3jZmYMrMZfdWG5m5mqY6DodhFTaHDYDfnUm3Y1Dt3pf	2973	3NLnL6tmiCn5n9NFMSDfGcSrMV9ZQ7RBNPoXhReojw8hgdbmQZH6	1483	569	20	1	2899	jwkLkjdCLLi6D3qDNW9ouad5cF97jXzut7MzCpuLQwE5tD34fZ7	1547	2193	2193	1616333940000
2979	3NKeGcB8HNzhdoABTBRXM5NLZGzHPPVmtrB6xigUxvk3nPWm6t4k	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	484	1073	20	1	2903	jwnXY4tnKZkDSnypHJWTLoEitnD2659rJwfJizxG2hpVcvma4Cn	1549	2195	2195	1616334300000
2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	1631	794	20	1	2906	jwSSFDwUHZRshUuENz5RCV29d6R4QCe26fJsLhNo9SiTR4Z7cYh	1551	2197	2197	1616334660000
2985	3NLV8SaQcNJkvkEX4U9sHrifdK2i7ky4KG56p1srNKSL5jrGYdyA	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1559	1353	20	1	2909	jwDJgH9KnWhNnVtQiooYv3VVLk1wiCx3CK4yHEWY2uQsK1Wcoqe	1552	2198	2198	1616334840000
2988	3NLuF2eeoWDBfmdGNmCMgKJh3Gu9S5pNCuixyD5m6qaz4AjALWax	2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	1599	1041	20	1	2912	jwPHrfNZwDgSpAv2kqtzWMrcvevhTvDNFapHxu3aFTP9X7SmD9u	1553	2199	2199	1616335020000
2991	3NLYJHuFgYuemQ1QKzDDwVZfMd32vKD7bymvwYTFiXJUwbTFx17R	2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	1590	1054	20	1	2915	jxCmA5HcEuy6D59zD8H1DGritCHNcA1kLaFLjnXRyNSzewq6yAt	1554	2202	2202	1616335560000
2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	2992	3NLMQSwiYHL19wLtxsLBQu9V2bEipgUq6iYjQspcyDCDNgs1xrLE	1668	1244	21	1	2918	jxn41hsoC27hf1jhws7BAv2nkPWtsR9T8ADrinbbJruoYaTCE3W	1556	2204	2204	1616335920000
2997	3NKo7CiUyKmJAYJzaUxrWEsKdnB7kBnH4VKRbzaw5KV2NYsWxpM5	2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	1407	1395	21	1	2921	jxhC2hZVc4VQZTQ9khnrHKf93z5BDr9B2FU5h7i6Pxt69DrdFhL	1558	2207	2207	1616336460000
3000	3NKiuXtAzi1166JjkZ1X4bmLUyMm9Nuxv1WGpaQgZDGFjoETPMCB	2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	1622	1356	21	1	2924	jwLhNufHPh59JZ2wCGMSa7HawUjdvxqJHekap6gJc22BJcEM7DY	1559	2208	2208	1616336640000
3003	3NLTsYoDNjxskKfaWvG89HCrsjdn3umq3Z6TCtuP9vZS1nbXDP9A	3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	633	1138	21	1	2927	jwGUyPWAhRvGu8NdPRpcbfRUhceLNEsHr2oSJ41Gdu18ue4W7WC	1560	2209	2209	1616336820000
3006	3NLghWcS4HrguAWso9EJP3qofKZAMUhZGYfHnivGAkV2hahry78Q	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1652	1315	21	1	2930	jwxcQpaVuURr55VnVyQ9iPEsXJ3ku7hUA7CyyhW6xLzvaaGZiHd	1561	2210	2210	1616337000000
3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	1581	778	21	1	2935	jxw3LqRgruk6maKij6c9edRahMNMQ1gFZnSQZ3hxrYQtXf1up2X	1564	2214	2214	1616337720000
3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1648	1284	21	1	2938	jwT5dvhNVM63wQSMrmy8oSepCKp8SzkrFHkWx521JXkDG7uxw9V	1565	2215	2215	1616337900000
3017	3NKHfgjMFsK1r3LrPopMYeL5F517wkaRyvz5p4W4MrysTKdJrSZC	3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	1419	814	21	1	2940	jwhqiFqNGML8nQ1hitqK6z5oVnd74uAjSjzG7fRCzqpU6Cd7rcw	1566	2216	2216	1616338080000
3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	1579	1143	21	1	2941	jwmTpEQdbhzUBBatg68T5vPMgjXaP6L5AAunXMYyYduHvsDzBEC	1567	2217	2217	1616338260000
3021	3NKhiAJMTSSxtgLgqhVxc1QYuUyG12PULcCXV1v8paKikzoNcnnq	3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	1670	1036	21	1	2944	jwJt7LhhZZYEX4Zz3Bnp9Gh5CqWuEdYQQAaNBhtt13DkchRbxnT	1568	2218	2218	1616338440000
3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	3023	3NLn2Y5b135LF94a9t4jov8xVaTwuQS8MzGhvCPRCbVKQXkrxoUc	1503	1277	21	1	2947	jxpXxkULPuvM6RoPZQW1yG3HHxxrKV1yC2j2aK7U6gsDUvgSrP9	1571	2221	2221	1616338980000
3026	3NLmq8ukdXDKGjmpnQDBwTcWoCup3sSXJMpfZHUpxNy4j4giuSmR	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1406	1393	21	1	2949	jxpW1fEmYL4VKdra75zqNzis3DRaFDYXqJHcHtudVPLH65qgM4b	1572	2222	2222	1616339160000
3027	3NKoELMESoqWzuVU6CBEAMUatVBV8eJubyMMZ6GNgQUh8djW1NUa	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1657	1098	21	1	2950	jxaXVL5B7zVJrB7Df4j3egPbC9WYcqnGSTn1nQbCLJncboxDSAJ	1572	2222	2222	1616339160000
3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	3029	3NKdh3pRY5Kqj4RoUm2dfuMxqsfw93bsneRLnWmcKveq7ytDHDTZ	1617	1288	21	1	2953	jxZBaRMef3pUepfYa76UTUk4ixjDSfNLoVKcyAZDdthb2e2251y	1574	2224	2224	1616339520000
3033	3NKeTMP54cnoNbvxLVz2mUgPeEoMKhP3xUcvKPicArmshGY3PcBG	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1652	1069	21	1	2954	jxSH6fcQ1Qw381Kxa7K3AQQp55Rh9MT4kLWi549cS8ZXAbEhEFQ	1575	2225	2225	1616339700000
3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	3035	3NLQ3KSRdmWjS9k1ZGTrC6vntnSgbru48z5LsyC44ZW7PsXKTLvY	1536	1313	21	1	2958	jxKJZ4L16MsNm8UZSPthe1wqNnbChMHfUDsVwpxtdNX6SziEXLS	1577	2228	2228	1616340240000
3039	3NLLzGWXWiHNa4f9wCyUb67bq436gMPrfPJ4KamdjxHSnwL92wBf	3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	1675	1216	21	1	2961	jwMMaMUMQyxRDwK1SNYAVJYLfra8cfiY3M3QBCW9KgiGJevi7z5	1579	2230	2230	1616340600000
2954	3NKc7hGyJ7o292mGUkjVKBFE8qJCGs48P17uCyb7JeitKGDRoVrL	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	1593	1100	20	1	2878	jwdkEN6LEixTFHnpL3mGUV4djJa5UbgecsWNN7iswqx6zmbkg7Q	1537	2178	2178	1616331240000
2957	3NLPEwo3hkfkKNUMVapZ2MkYuuC1zFrXJ26rG3uvUzoGGQmRA5et	2862	3NKdmUZ9T1eEAQDz8ZbVPixdUvvww9MKyQtoNz7Qgr9wRbmD5Bz7	1513	1133	16	1	2881	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1406	2178	2178	1616331240000
2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	1607	982	20	1	2886	jwZkz4C4PsLFELMHXy2wyX45wzCLyfitzyd2U92MSxuuZZnkJ6F	1539	2180	2180	1616331600000
2965	3NKc5t8N9HutkyJKFHoyRqvSP6QceLHBhYpKfKEy7CopoWw2skuf	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1506	598	20	1	2889	jxKNFzw3ANnegrpRrXB1vqmEJhHBUSzpCNS2gpmJxEPTi6PMN5s	1540	2181	2181	1616331780000
2968	3NLFjQ3vKThT7s9U3HdT8HtpPCysj9NQrDRUV6uAn1TCXwdDHcEs	2967	3NLtzeCKURGtn8ecVkfSpVDxUMhur2ZAXiiE1RJ8Wd2hgSn1Knx7	1407	1395	20	1	2892	jxvbZJDKRLZE8JTvmXpB4kUMUYFzMyyPWNPxfXukF9GwkkMYEkA	1542	2183	2183	1616332140000
2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	1407	1395	20	1	2895	jwGhFmqjL4BAyJiivoZjxEWniMnR95umqvATRawArJ5A4wjD9Uu	1545	2190	2190	1616333400000
2974	3NL3gABD3AP4BxqWHiwcnhVn5VGHUPGccznamGUi41aypH4f9siQ	2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	1555	1101	20	1	2898	jwGDCDdqRjmid9dwSW99vT41PRzJPCKCD6DgQGfBt8BK1AUo6Mk	1546	2191	2191	1616333580000
2977	3NKPef1GyR2TdkRTJ3xqgLpdgVsArWbfUKkLwbSeu3QE7uLRQfQZ	2870	3NKE6f9G5w9GCLMzdq9aGKWogvqGDLJiQNU1S6U5kLKxqGDS9mPH	1403	792	13	1	2901	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1286	2194	2194	1616334120000
2978	3NLLqMqv2r5o93VpkHGcKMHjnKADRsyPzCT8QZ2vsaByNJbPAh78	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	1607	982	20	1	2902	jxhNF3ohyW962LGiJ81HGENii5bQpxhrP1725tQe76QpTdd5Lqt	1549	2195	2195	1616334300000
2980	3NLJeUk2tBmBu8zWcxSnxZbeTWnowH4k8iUzFZazUhPCPyxNoR34	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	1668	1124	20	1	2904	jwSmcy5bJzh4dnv4x8WEM1vWuzgBJ3sYDuTzZuGrMRg5D4jKomd	1549	2195	2195	1616334300000
2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	2980	3NLJeUk2tBmBu8zWcxSnxZbeTWnowH4k8iUzFZazUhPCPyxNoR34	1483	593	20	1	2905	jwcPAmVYrv5m8TCLqRPj1uuaYpc5GaLrHhhD4XGuSZA4pAY6akB	1550	2196	2196	1616334480000
2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1501	1114	20	1	2908	jwmeM3nSpJPqgB9iT5ob2n3AzNTM8g2q7drav2XJ46gxH3jM6LF	1552	2198	2198	1616334840000
2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	1406	1393	20	1	2911	jwWGFnWDRQAB5DZRb1zRdeZSRe2vtE7N55tfsmue6KFFDs1mgYd	1553	2199	2199	1616335020000
2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	1656	1343	20	1	2914	jwqSpHSSkWkAN9W1Mv4KYbKucEeENunp8DnUGgaXDyDnjZB8amW	1554	2202	2202	1616335560000
2993	3NKotHFCj5DF9rAkAcUod6prdxtXThVbZkjzj7Zg9WJzaMtqayUE	2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	1634	965	21	1	2917	jwQB7TFvEaF1duwPyjT4vytbigRWkewsyfXFyoKGgxQKUdgYQbs	1555	2203	2203	1616335740000
2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	1590	934	21	1	2920	jx49a9oNXd5wN36212XHUVTQ9r1TWCyWnipGncz6cXiEnrpRrok	1557	2206	2206	1616336280000
2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	2995	3NLWfK1qpX1sBXDRFPboe5EWiqGiD8Zm1NEuEu3HQWbQe1T5NJ6M	1646	1228	21	1	2923	jxL4SUhbCLzVWrkZLuut3JaopdktzoRJcb75jMmcTrXn2gdHSNr	1558	2207	2207	1616336460000
3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	1407	1395	21	1	2926	jxGyaBhpMDjUnjbVbA1nHpquT53P1ogL4Sai2b3PAEMcVBADiC3	1560	2209	2209	1616336820000
3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1406	1393	21	1	2929	jy2FQmmiD4MmWjSuJUFKzME1Kh2NUXxJCs2MpLSxaDeGHJPHHkZ	1561	2210	2210	1616337000000
3008	3NLu3jA5NHySVxHfNAKnujvSNSCLUDqKVggdtFqaXtAk2uUXGUtp	3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	1509	1320	21	1	2931	jwsjRxGFW8gUy3FMkaiW1UCvCGHoAszbczZaHfjQcN75mxNFGr2	1562	2211	2211	1616337180000
3011	3NL8PQrzqbBCRcy9dKW7NdE6s6VWGw1yshuBtJVM7geDcDXNKqnn	3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	1402	796	21	1	2934	jxiqJuHoaB1mzzX5uDcc3ZXKBZB5hepXTmTkgkMESw7CVXYFo5L	1564	2214	2214	1616337720000
3014	3NKQt7XP7tQNGkBASATmzSuohvUeGeoitEK3ptwUv6d62F6yc2Sy	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1623	839	21	1	2937	jwjaCrik5UjLhBnWdcu9eMf4hjiYmUtSYyLjA8Vwxrmpni1u6KZ	1565	2215	2215	1616337900000
3020	3NLnWvZLbann98z4aL69sn2Y9MF4haLiJW99hWth197Uir8dZCCa	3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	1407	1395	21	1	2943	jwpERofssmZpxA4QfydP7QfPk533q23vYTWL12bJUtxT6CKrk6e	1568	2218	2218	1616338440000
3023	3NLn2Y5b135LF94a9t4jov8xVaTwuQS8MzGhvCPRCbVKQXkrxoUc	3022	3NL53RyKy8ZrrGpELjCR8xtqTveJCBoEKgHexx4bwQSesTNdHXm9	1609	967	21	1	2946	jxbyS1NiV4jQqP3SMamXofR2dW6gDdiZeU3TkfU5fPyQHHLWwbx	1570	2220	2220	1616338800000
3029	3NKdh3pRY5Kqj4RoUm2dfuMxqsfw93bsneRLnWmcKveq7ytDHDTZ	3028	3NKyTQmj5soejQioMSgVEJM21kVpDbtx5i4myFdAjCnFzis2UmR3	1406	1393	21	1	2952	jw73Mt8wwHXZtxrxrFHU1bsb6SS5PCfbdQtJVrLsC9znfvtnAb1	1573	2223	2223	1616339340000
3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1599	921	21	1	2955	jxZPvmZetwr3zmo7ssw5UQSi5hrVkHHADQWz3XsXD4WsJ2YD43m	1575	2225	2225	1616339700000
3035	3NLQ3KSRdmWjS9k1ZGTrC6vntnSgbru48z5LsyC44ZW7PsXKTLvY	3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	1637	816	21	1	2957	jx9YBvUeuqq38bhVHjQDcU8aWDdAc91addm3qLYDHjeGKbign4G	1576	2226	2226	1616339880000
3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	1549	1116	21	1	2960	jxE9jAoCsDmGgGncTFduYrCyptP99P5Dj45gQMgNSs6HtnL2X1x	1578	2229	2229	1616340420000
3041	3NLp8Mf8rrNfzqYpQgyYuguio37sY7wtdar51vcBmsr2FZ3obUD7	2851	3NLM33utr6E18BCza1WBp5qoD3sV9QUeAANnL3nRQjH81hr166kt	641	1336	14	1	2963	jxEDopy8qr4TfCvfdrgWnhQ42Sq3viGxSWTdjmCA5hKPj28nHmZ	1303	2232	2232	1616340960000
3043	3NKjE8KcsbNgiiJBL6VhxUFT6emx6odeT3gsn7efMQjyF4TzXWV4	3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	1447	979	21	1	2965	jxeBXFM4arvhQDF7Wz4T7TvPMWYf31AhTwTmdc2fD4dNy2VnorV	1581	2234	2234	1616341320000
3046	3NK8TzRQbaDZZfNhpnSGYiiMJkcWqrZemAxCTxvMCXMEqPJ34RU7	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1651	1055	20	1	2968	jxfG1xKkwwHxG73UTdULdmYXafXaD2SrGbp5JTJw1JJUmRKcthN	1552	2235	2235	1616341500000
3049	3NLvBghs4ty9sZyoT8b4bfLZFpakyd7ffvQmYzRvXsjxs98iJPus	3047	3NLQAoho3MarwDq32M6ZFMrXBUafKGBsg8Gtv3oSwHP6rJ4nFsk7	152	1330	21	1	2971	jxBYLhR4mzfd8QYVUc3ou2zXfNnh5aRSmfeYVvi7kyCz9ZpNpf9	1584	2238	2238	1616342040000
3031	3NL6jrES1qxMg7gyoEH51KKtq4kiv7cRh2oJyj4GVWWWctYEGtSv	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1652	1069	21	1	2954	jwcTHghaZVXDoFM8RoDeDFewR1QNsxpULXxd7T2qPGfr2ms2A2U	1575	2225	2225	1616339700000
3034	3NLdpSLy89HW4kU2ZPTd96Tx1VxzwbXhFWATCgfQ7WWoU4zxWqPu	3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	1474	1329	21	1	2956	jwjo1wztoGMJoBfZjkfrTxnwkEs3hQCavNuCrqxMQsPF56FbFV5	1576	2226	2226	1616339880000
3037	3NL93eFVoeKoa6GbCDwNFCPibfernMYNkfaeHsFmPS2uwuhRpAmn	3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	1460	293	21	1	2959	jy12WQ46Ehys2CWPfb5irbBkxXz7wZpKcXTJz5SxBzY3UN4HAtT	1578	2229	2229	1616340420000
3040	3NKFC9kdmjajVXkb7xctVkyXDZfikU6LsN8xoVtNszo6FJbLHPwi	3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	1581	778	21	1	2962	jxJiM74fnhRnbCqiGvJVGHn5CCAuJvGWqXvf3W6rhtaNQtHnEAa	1579	2230	2230	1616340600000
3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	3040	3NKFC9kdmjajVXkb7xctVkyXDZfikU6LsN8xoVtNszo6FJbLHPwi	641	1336	21	1	2964	jwakrTJCo9JEcoCHPH6PKL1VSuaCFSYFzk3UWVRqdC6Jz2DFx8p	1580	2232	2232	1616340960000
3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	3044	3NKKSbGHbZUsPsQEC6cGrVcMeEjcLaRuf9FZuH1RPSrWsWLi17TN	576	1355	21	1	2967	jxALPC4aQv6g4JHQ7NRiywuQrYaYLXP1H1C6erVcZXaFc1JDSiD	1582	2235	2235	1616341500000
3048	3NKpfevURHHYxPUiY5QSkLKdXUnq6pr3KuwRPJeiDXXqmjemjP3f	3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	1648	1038	21	1	2970	jx6D59Ek2uUEVrKo2NouxYuTc2ks1dRLpmkyciFiPDZCn2DNRVY	1583	2237	2237	1616341860000
3051	3NLEPvXEJ3K2p2Qp4EZst8W8DmV4YAPhhsokHe3BgmqZmyrwcqkM	3050	3NL3rsR5J2Gs1STS9on3VjxwsP39i3yHX89dcUu1APrCvb46GM3j	1406	1393	21	1	2973	jxhhEpDuy3EGokxUKDd4pRgwMHLjmNNfvTUMEr8W3LSx1bhJ7rc	1586	2242	2242	1616342760000
3054	3NKvrqdAChGybeAb1xR36DciC3RPrM5dejXorBrP1m8Mnq9QkAtR	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1490	1028	21	1	2976	jxWjLAQwpg22wSqV4CUEACAB6xGM6Fj1VWHbq2YfnL1V9kBBiAk	1588	2245	2245	1616343300000
3057	3NK47hPXx3A3jt1PZZ8BvrNBNNVKVEqDQGvbnVYhChjZpzbCcMpz	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1403	824	17	1	2979	jxYrLgzxLRFy7q7Lk2fRnLZHu6UHvF5YtdYbeXxpA5Nv7vHC18A	1442	2247	2247	1616343695414
3060	3NLnEhHpFXQz9WmNmFAEqUKqhPXHH2PnDa3Ki2U9Byg5eRkLQVri	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1403	824	18	1	2982	jxWoNJaMC3MFh3LpipxTzUyAPbDRkLkFZ4dWkAzQd8nKDrJuENK	1467	2247	2247	1616343758005
3063	3NKdqFLhxUmHJ8eL5JRJpmcUNYfitQHquWfPLhFsLSUY1NxMpR3T	3058	3NKdKLgxAz1Mvhx8pc1LMBxpfDFukSzcfTwTF36R1cd6mkHz85TX	1643	1173	21	1	2985	jwAq6kyHkvofzuYyPrsdj7P5vqx2amvne2guwfBWdj3dqZYF27d	1590	2248	2248	1616343840000
3066	3NKJaMwsFgyJFb3WYEigCbLaiX6ZsVN5QoDaGUXgeE7cW3zTUX7B	2957	3NLPEwo3hkfkKNUMVapZ2MkYuuC1zFrXJ26rG3uvUzoGGQmRA5et	1513	1013	16	1	2988	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1407	2250	2250	1616344200000
3069	3NLX2CcAGqjZmR2NjBVUWrGSdjSGXHGCqYyvQdUepCi5L3mtFFc8	3068	3NKh5tFLzGdk89JMd95LKRvVLYxPdWbrKRr5nyZStbgU746uVnxX	1403	824	21	1	2991	jwakXxiefL7kMYAdzoAKUk64KUKhtzJd3gSHEfSDsHqWGLeU1ww	1595	2254	2254	1616344920000
3072	3NKH3VcezeVBQD926US87PzgVTHeNyP5EdqHkh1sWAGqZUBDTVQJ	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	80	1273	22	1	2994	jxdVTKnFziCfKNqfB41vt5kR6qVh6YBoBJoucKMjsKYefXyPj92	1598	2257	2257	1616345460000
3074	3NK5HbzBQxb4YuxRzGMFqCbhb1THY71AKEtnWLqbqt4grsR39k5R	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1654	1094	22	1	2996	jxfCLJpsaYkTvtnrtYDNB4J5KYdzbB8sBA5Q3oFbfpTJmwi6hpA	1598	2257	2257	1616345460000
3075	3NKkrbsMi6zGu2Je9o5MFbidn1UjWMt4WKW2PkjGPcLKPim6mp9v	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1553	776	22	1	2997	jwWd4FuxH7ZPE7GYhtLox6UgUJ5Txw7BdzwFMY3tLwdfCNg2X9N	1598	2257	2257	1616345460000
3078	3NLmxAmo8c3aKfch7bu1esEbxrDE6vdTb5Y9vTf2CWCvqKeL5fac	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1471	1260	22	1	3000	jwJ7cv1Q8CDWxjQWm7B4MVco7s7K58yPEWojjkpcQr667AHJa6a	1600	2259	2259	1616345820000
3080	3NKFz9A7DS4busd4RknaViXtD2naZyCZzAx8rNQ6SJW21GuoFuur	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1406	1393	22	1	3002	jxUBRf3D4Tsw9wqHUhkbzEw5jcLQTfHofjsvRzNPLmBWWShAn75	1600	2259	2259	1616345820000
3081	3NLkWF3wUa56b7cnd34HVVrYFhh59t9nK1ak5ZY83S3B3ViTsf2C	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1651	1055	22	1	3003	jxZ2gBtCAoh5iduvxJMz8FkKdRoi51P4TG4ZUKNDxaVhyzNtzRk	1600	2259	2259	1616345820000
3084	3NLhkUtqQKGdvxKyS129RyByxZwQ8rQdVyqAhbgFAuNZ9qtVsPRZ	3046	3NK8TzRQbaDZZfNhpnSGYiiMJkcWqrZemAxCTxvMCXMEqPJ34RU7	1651	1055	21	1	3006	jwCqDeBry8KEDvTeH25T3B2dnPr3Wam8aiWtdqtJiSK2A4FFj9u	1553	2259	2259	1616345820000
3087	3NLj1BjN61USoEJS4JCP4STr6woLJZvQKqiMenD9kRSvXBsppW5P	3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	1560	1045	22	1	3009	jximqYNJBhRCjeJk7XHQkb4Vos8VKsQZMeTYNxbNsUZ39R4fyXN	1602	2262	2262	1616346360000
3090	3NKxG7R3FCmKZhkZiar6cXhWxDpwgrR1uVmnFjBzNci3gF7LdcRp	3089	3NK4f7FD59jMfmpBfjKfVgFXHSiBKHfaT8CPLYgSqP9cFYt688kj	1553	776	22	1	3012	jwmu1CxmSKEegpyYCtHJ7ATw59ZtXk8XbExHGd3xpWUXP7gGZ9Z	1604	2264	2264	1616346720000
3095	3NKZTxNtsAAmKoxYp4TSencDuVXZx5N1avU1PMmrhVFk22XzJaz1	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1559	1353	22	1	3017	jxYwhAoYnLWiiGn3nme1KuSgYMb2ARLuFJi2TgJNkEYfnvt2bAF	1606	2272	2272	1616348160000
3098	3NKu38nr9mGTPu6ARkSrDxk4Qy3i1mncZ1wT2sKuULFHbeV7FYQT	3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	1407	1395	22	1	3020	jwuqyS2eXCi15Tgy6AtpzfVXjwggzeHtHikMkXnWFhmA44E8YQC	1608	2275	2275	1616348700000
3101	3NLKc2gHU96VteXwpindiWSoMZgteCJFb6V9YRpE1rRNmt9yabPY	3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	1647	1302	22	1	3023	jxmV7qWragYrWsaPnbXEynW8fbd5kqJ4jzMbtMbP8xZLcmNxinT	1609	2276	2276	1616348880000
3104	3NKrrSZJvSVYB6hVyqp11k1CTz2JSrzQ3owaxwCUiowWi82Kjhxf	3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	633	1384	22	1	3026	jxEtUiKNu5yZJthS86uNgrKdnGGEvXdQP9hzXqXdEwr3JfqXhmA	1612	2280	2280	1616349600000
3106	3NLTDqgF5oD4FqLHK64GgSrSxFsRPoPLeUAqdBVKCk6SWMqCyfDQ	3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	1619	1275	22	1	3028	jwNpd898d6Zh9CJaV7UxFVjFXwZW5mUyZGniUjHsk8iMJHsXknS	1612	2280	2280	1616349600000
3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	3106	3NLTDqgF5oD4FqLHK64GgSrSxFsRPoPLeUAqdBVKCk6SWMqCyfDQ	1508	1021	22	1	3029	jxPqBfy6naqufb4W3HzQ1rbPk39D6ZJoB3jyHirbTxMcsxkvzoW	1613	2281	2281	1616349780000
3109	3NKBpHZ7jJFpMWDXKpwQK6oKeuecwYKi6o47smkF1EqdqzuEcPGE	3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	1406	1393	22	1	3031	jwFXx7hqSY3hnAsop8QqxmRRQpGW9Qkr6Fe7JubQ77orvWiiESm	1614	2284	2284	1616350320000
3110	3NKUqsnPvDthurRuHma8fk4CP8eKMjtDMVBcRiZ9qtCX7dC2Kpsi	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	576	1355	22	1	3032	jxdnSPbHGLgK5zZcGRjB9KhKbd8mqKz1KMWUa3eaDpxCMj4YcFc	1615	2286	2286	1616350680000
3113	3NLCCPTwEDaxfwCbML5Lhu4HCoxLzbE7Yejjv3Mfam7wPo5mszcv	3110	3NKUqsnPvDthurRuHma8fk4CP8eKMjtDMVBcRiZ9qtCX7dC2Kpsi	1599	1287	22	1	3035	jxaFT48UFnSzf3oiZcPh4SZvVJ8JN2nVuSjSE8AwQmA8RfQ1DUP	1616	2287	2287	1616350860000
3044	3NKKSbGHbZUsPsQEC6cGrVcMeEjcLaRuf9FZuH1RPSrWsWLi17TN	3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	596	1306	21	1	2966	jwBrFrcp3Ff1KbuTdtTY2BzFAhkoEMnLWPoytS8RKwbk3rKZF9S	1581	2234	2234	1616341320000
3047	3NLQAoho3MarwDq32M6ZFMrXBUafKGBsg8Gtv3oSwHP6rJ4nFsk7	3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	1407	1395	21	1	2969	jwEU5wgRLoJEAXA1BfDqZAa5CkNoDy9fYHm7a5PutLaeW1CsKx3	1583	2237	2237	1616341860000
3050	3NL3rsR5J2Gs1STS9on3VjxwsP39i3yHX89dcUu1APrCvb46GM3j	3049	3NLvBghs4ty9sZyoT8b4bfLZFpakyd7ffvQmYzRvXsjxs98iJPus	1402	850	21	1	2972	jwWgrLXxHBWdWXqfVMxTcuhtbZDR8JghcQCCSkUz7jpVN5otmn6	1585	2241	2241	1616342580000
3053	3NK5hFidRypHU8ZJDNN97XtEAAhwYgzYLj6dr719u73Mur25fEmN	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1419	814	21	1	2975	jwatpyLSTzoJCrTvJNqW439xEoLJxJiRCnVnDbrRbUQxr8CJsjH	1588	2245	2245	1616343300000
3056	3NLAnkmw38oxaHZ2uWFtReXLMHmAfZWTEJ2AUKZoCa1LmHKE6oMc	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1403	824	17	1	2978	jw8AJiUmuMxLTiicx2cbeLC5oZbk7k2r7zGvNtcSYANEmdGCEr3	1429	2247	2247	1616343660000
3059	3NKQZA61GyrWFXtA5ywfxp8FvPS1ycnSca2RkePGRNNDqjkG1NAH	2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	1403	824	18	1	2981	jwGDkCcgdBbPqHfpZgxHCMapUG7AyEY3LHoSXzbGshj9L71KaGK	1456	2247	2247	1616343728015
3062	3NLUrxsfmTUztLvXf36JHHmRkTUwSaxthaJNzn8yZXL2CbFLhHuB	3013	3NKgzy5Qaom9hwFMZPRFDUeoRYD6vZ9CsSSNoTG9g1G4zYtACz22	1643	1173	21	1	2984	jxbd45sKXumqHcwoC8HQkhWBCoauSonviRY8rYTnLGMAeWshmZT	1566	2248	2248	1616343840000
3065	3NL3WSTDRK8hP9X8REY3e3zJDa7ENbuavSvSqNnfPRBCWhf6iekE	3064	3NLCk4LPenVMHH67EgMiAaDFQLU5SKmgcm7WU98ViJgGeM5HEDUZ	1406	1393	21	1	2987	jxWhaDow2EMf7ZJi31qnvEKCoRsuT7wG5WVaZtpHSwcnw3Yyrsx	1592	2250	2250	1616344200000
3068	3NKh5tFLzGdk89JMd95LKRvVLYxPdWbrKRr5nyZStbgU746uVnxX	3067	3NKUQTAspYw9KcbtafVRJKa2DFKQPczSrN7An1ZbxWdaVrTxgcAe	700	840	21	1	2990	jy2FDWyrutPtxDTWF8TG9yxhUnEvFcVzS8X8uwA9QxczQGpiX4y	1594	2253	2253	1616344740000
3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	3070	3NKD2VLMrkwF1LDKwTD4PJwGUkxX5tpi4kZoWjKfsxtrDUpHyjvK	1406	1393	22	1	2993	jxkN1b8z8ZjLb2k8vTJ3XxKxxW8rKzi4eAwAde2VScj5sRUMsfz	1597	2256	2256	1616345280000
3076	3NKk7H7aSbAdXpvgzWsboRyK874EHHP8Uqj5jLRXZWRQwbzagUkB	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1654	1094	18	1	2998	jxqF9Ukzuemc9FbZJBs6n4AnXzxBG4for15SwANrRqvAH2UgBEz	1473	2257	2257	1616345460000
3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	3073	3NL9WuzRym32sMfAWTojxfaBtjfrdrvzZUNh7iSVnmGhbja1WVfs	1407	1395	22	1	2999	jwh3CheuZYXz2tcEBiz58qo83uSAHnuSXEfe96G8bRcjQQKmysS	1599	2258	2258	1616345640000
3079	3NLXnMzRXRSEJFGtMd41C7kSUZrV6KyfPtjFtsKPqENXJAdhdeRJ	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1649	1017	22	1	3001	jxYLG2itf9pGSAw8np9HCP2kx5PrA8qu6hQJ4G5qDX3YSfYvTjB	1600	2259	2259	1616345820000
3082	3NKNHxiKzv8YP21hZSQA56BtZbSUBr22vrJvTPtph2VoPP8Q5PUv	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1594	1326	22	1	3004	jwKr89jZPeUfQGmwPwhSroUepa5x4nwA3Bm4XznP882SrbHKjLE	1600	2259	2259	1616345820000
3083	3NKFryKF5ZKhNViQxzEPYYtCMSJTRGo5fCjx1AupK7VkGusXhMfP	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1419	814	22	1	3005	jxkphKfJjs82M6JSHrh6gM6CZiVAt39uobgAkTy1DJAtdpQsKhP	1600	2259	2259	1616345820000
3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	3079	3NLXnMzRXRSEJFGtMd41C7kSUZrV6KyfPtjFtsKPqENXJAdhdeRJ	1590	1054	22	1	3008	jxpcsnz3GnoRq4MvdL2N4AMNa8Tgyt3PywpmgUm5NtDEntGYRfW	1601	2260	2260	1616346000000
3089	3NK4f7FD59jMfmpBfjKfVgFXHSiBKHfaT8CPLYgSqP9cFYt688kj	3087	3NLj1BjN61USoEJS4JCP4STr6woLJZvQKqiMenD9kRSvXBsppW5P	684	1106	22	1	3011	jwaJZSj1wVSU6i7ojfRaVQsxTd4diqBMnydf41A1Ufc5yvCe7Fi	1603	2263	2263	1616346540000
3092	3NLZ6PwaWnW21ktX5MD6JBTfE9vKcYfYXkfDb2AwATHjQhCEgY28	2788	3NLqK6Ek82h2USzp5XGb7BmukQGERdarRoQ8JTyXEYSUwUe79hST	1673	1122	16	1	3014	jxhHMcuC2r6TunEEFXvtHFnogzJg8peZLvR3iZXuBGkSpjmqdaq	1334	2270	2270	1616347800000
3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1467	1376	22	1	3016	jy3M76UcJKnJc9hw7tcoS4dPnjassU7TxvduVHcPvjhVsjNHNVf	1606	2272	2272	1616348160000
3097	3NLWjapBFnUvuBQLtCjhn8eTN8SFotEvdwq1oANmgMxpuT8SvrmP	3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	1668	1124	22	1	3019	jwwogBG8QxcZyPmmCgzX4YmcN7GLYhbN4BzDKgRMeQH7PDQ1Qxf	1607	2274	2274	1616348520000
3100	3NKh2xt3EL8GRDToxmooM5Yt3HyFLHNEoySGePsfbF84odsbuhBu	3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	1407	1395	22	1	3022	jxmjqLZLABPw6cargtMJuKD9MFNVZpJWmCc814Bm3UkAjE5QXtB	1609	2276	2276	1616348880000
3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	1609	967	22	1	3025	jxqLpYrkJsxpB4wZo8V8jZXFEypasUa5RZFBLjTB8dnRJpSRBfJ	1611	2279	2279	1616349420000
3111	3NLjExcgoVHLh5wksgY8uFJQUCK8byyqaDR9t1sNNzxSfbnm5ZHL	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	298	1308	22	1	3033	jx7HPco3L359ogEjDmNHmhjN6FNoSPXjYJ9HzW52TDzqcbdSZ7D	1615	2286	2286	1616350680000
3112	3NLAo1pzEnjdUzXWtvQ9rAzCi47eDfBNmbspfdTKt69mX2APPteo	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	1568	239	22	1	3034	jwdqQw2Epjd8n4bMCv7hyE6iUfR4Se9jCDogFFSmFrkKg5ZTCge	1615	2286	2286	1616350680000
3115	3NLNHGGtpBhUmQSL8tGUoUgS17ziLeSZwCVRYqEJocSNHUsKxrSd	3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	1407	1395	22	1	3037	jwLq3Gik8eqRxhmsbrDxAvZAtiaKMSkY7S86xNbfqdmUYrKbyqk	1618	2291	2291	1616351580000
3118	3NL8dCXLGetDxoBY4J54WP7TQGJsDgsH5DugWi113abNAjtM2Z7T	3117	3NK6ybBBHfjxCdEFVYPwCwga6AGwzVsgVSEFdwGt2Y9TFxM9Enr8	1588	1026	22	1	3040	jxmBh7sw9cRVZHqSoY4qDFWHWR4zFNMHaJK5eveZUnTnHJ2rx7d	1620	2294	2294	1616352120000
3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	448	1059	22	1	3043	jwGY5t3zxyqeSiwPDmSMDzUSeeTGA5wqtbsdsSzPBXVKUK51EEg	1622	2297	2297	1616352660000
3126	3NKBxJxdZ2F3NGR4V7htM5s8szRn4UXSgmM7jVwb7e3gvdTtfUrA	3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	1405	851	22	1	3048	jwkh4Wuc9jkJZeeQ6ykrYR6V2xm2oGbM8kgvYQLKfdmyFy2RubG	1626	2309	2309	1616354820000
3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	1642	1367	23	1	3051	jx4L4FePj3BCdgEqb4PLRDfhRBNbFareJhzoZvBqrKYhUkF39Hs	1628	2311	2311	1616355180000
3132	3NKQNPhAF9ML1mSLcDGWG4e3Xq3rKP2tkDQsS3j2sv8MpNxfD1C9	3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	1455	1086	23	1	3054	jwaURNhEeCkbTCbfbJ3o1bESCCwRmevrjsEQDpb3yQnAq5ypjsF	1629	2312	2312	1616355360000
3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	1608	1289	23	1	3057	jwakXfEpFQ955TmjwVdA5Qio9VWSCRiTni4dbsFiW2qNJqmH9tn	1631	2314	2314	1616355720000
3138	3NL6Hv2ccHNHVsFqoaxotAYb75B5ricynHPxBbEhPz532CwKzsHp	3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	1403	824	23	1	3060	jxMiSVhDhcbCcyh7tW9iVNK7Pdcngws5AAeGDBvruea18BMFy51	1632	2318	2318	1616356440000
3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	3051	3NLEPvXEJ3K2p2Qp4EZst8W8DmV4YAPhhsokHe3BgmqZmyrwcqkM	1407	1395	21	1	2974	jxp2vAAAe6rB7cxvrLoVa1C5oudcXzoqrNmU6tXeYDoCEHVyc2n	1587	2244	2244	1616343120000
3055	3NLmSFdMg7nN4xHhcDnkdbaUuz5n4gC6xWraS2WYDxN4ZYBrR4y9	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1476	1005	21	1	2977	jx8je3ZBBER1LWiXjUBJSuqcDxfqubz17HksVQJaSQCFkeW2LtN	1588	2245	2245	1616343300000
3058	3NKdKLgxAz1Mvhx8pc1LMBxpfDFukSzcfTwTF36R1cd6mkHz85TX	3054	3NKvrqdAChGybeAb1xR36DciC3RPrM5dejXorBrP1m8Mnq9QkAtR	1594	204	21	1	2980	jxQTSVmT5iZQ7xoXvuweg9m1ZaGmZYEUzZh4CB9gavzQkxMZ9rL	1589	2247	2247	1616343660000
3061	3NKgP7DzeiC2VewSvgpd86gu5PSNo3AkGPM16vhhpCNUTj8M6kFS	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1403	824	18	1	2983	jxqSJvXh8sTox6wEQ93DbrdPKcaQYB6spbu1hfVCc61VVUp9Smq	1473	2247	2247	1616343790510
3064	3NLCk4LPenVMHH67EgMiAaDFQLU5SKmgcm7WU98ViJgGeM5HEDUZ	3063	3NKdqFLhxUmHJ8eL5JRJpmcUNYfitQHquWfPLhFsLSUY1NxMpR3T	1672	1285	21	1	2986	jx5ep1irPjq3vtBpBhvttjTAndGjcdxf8iXMvdRc7TmkCaKoR5B	1591	2249	2249	1616344020000
3067	3NKUQTAspYw9KcbtafVRJKa2DFKQPczSrN7An1ZbxWdaVrTxgcAe	3065	3NL3WSTDRK8hP9X8REY3e3zJDa7ENbuavSvSqNnfPRBCWhf6iekE	1547	1378	21	1	2989	jy2x59Gbtovgqqc8UgbHditXHmyaMNra3xdNBcBnFWb3WGySjeM	1593	2251	2251	1616344380000
3070	3NKD2VLMrkwF1LDKwTD4PJwGUkxX5tpi4kZoWjKfsxtrDUpHyjvK	3069	3NLX2CcAGqjZmR2NjBVUWrGSdjSGXHGCqYyvQdUepCi5L3mtFFc8	1650	1375	22	1	2992	jxAa6KwKUsADkpYJ64zGVsPguk2gY7rs3uAubnKWBa6eevjMJwn	1596	2255	2255	1616345100000
3073	3NL9WuzRym32sMfAWTojxfaBtjfrdrvzZUNh7iSVnmGhbja1WVfs	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1534	1071	22	1	2995	jxZRofooxucZktGh4VKEZnN68ksbsSjTHJRezrdHw9mTbFD9x4x	1598	2257	2257	1616345460000
3085	3NKpDBGE3CXtLJSApXC3twsKDcvjdg6LscAroj8gzvLBnE9GTT98	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1631	794	22	1	3007	jxunGLvkp5uusLeUboWBpJqZg2pgB327TkGcMUCVoPoNyzbWpxS	1600	2259	2259	1616345820000
3088	3NLUDV9QHT8AxHBgyXvsgWQBVbUCcEpWhNBxhJEPS3UQsPRQNmA9	3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	1647	1302	22	1	3010	jxShEj9yEh6aLMDPND3HZhVLFtRxVBp5zoLMBx9EdpuNDYJxaR2	1602	2262	2262	1616346360000
3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	3090	3NKxG7R3FCmKZhkZiar6cXhWxDpwgrR1uVmnFjBzNci3gF7LdcRp	1637	816	22	1	3013	jxc8i1R1FCN8LxfvH6Y8dBnft9ivVhDUZTuEan6ESmPB7P4hvKi	1605	2265	2265	1616346900000
3093	3NLp1uQ6Z8yWPc8JojvZCqmjs5M74vSVW5ez3DCZskerrpjx1iss	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1579	1389	22	1	3015	jx6ERtyqTbEvSA4XDMuquyaZtpWr7w27ZPewy8A4jAqfamUGb2P	1606	2272	2272	1616348160000
3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	1407	1395	22	1	3018	jwsFpo4UCCrxtHzeCpqUNcwaShbPDcVU3GkJF8971BfoAxnHioz	1607	2274	2274	1616348520000
3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	1623	830	22	1	3021	jweP5rVSckZ5cEy1giGnFrGwQzkLiaaUCdcWgxGboxuZSYiSH9U	1608	2275	2275	1616348700000
3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	3100	3NKh2xt3EL8GRDToxmooM5Yt3HyFLHNEoySGePsfbF84odsbuhBu	1471	1140	22	1	3024	jx9EQs69KPbmHAADaHJGHsK75SqH3oJgFYwpb232JQ2otuzLG3V	1610	2277	2277	1616349060000
3105	3NLgFG9741ZdUfFesEhpSdyKzK7Kr5TqQAAwss4zDZfHFYbs7ni1	3004	3NKh73y9jsHgBjqxUrcE7dd8eDjB9PJsBxGuhmHJJ4U8cRMGTYg8	633	1384	15	1	3027	jxdHhm1nzUukHUHQm2LXcQn8tFKJW7cSHWyxGm1EtFAYacmDSCx	1360	2280	2280	1616349600000
3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	1405	873	22	1	3030	jxdSzkRK5k6oN79hUy6sXXvUt66cKX5eVKuKitNotUSGFw9VDsK	1614	2284	2284	1616350320000
3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	3113	3NLCCPTwEDaxfwCbML5Lhu4HCoxLzbE7Yejjv3Mfam7wPo5mszcv	1610	1068	22	1	3036	jwsSjrH4v7wQz1LRhzFZiKKw6pioaEib3L6g1vghTpTEXEUSLZo	1617	2288	2288	1616351040000
3117	3NK6ybBBHfjxCdEFVYPwCwga6AGwzVsgVSEFdwGt2Y9TFxM9Enr8	3116	3NK9v8bjnPZLHRESmw9vs5sDS3afPDN6ywNFNdYgtzCWsJHDEQLj	1500	1297	22	1	3039	jxiBLNGPNQhK77aVMLwhYyT32ezRwqNkj7ETwxFcSDfhbn7dGj2	1619	2293	2293	1616351940000
3120	3NKki8YjDg1JPpcZnLh4h1tVVpgCpdVTYfq2Rz4B55seHoSU1V6V	3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	1589	1040	22	1	3042	jwUZ2g3hmUHHH4NApXzzgNaYxiZJPz745bBD4C7yyyGwq3SfFx5	1622	2297	2297	1616352660000
3123	3NKy8ctt9ivui6P9uYgXfJxi9yUPvrmKpBzg2mxGRfZENTDjtQkV	3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	1637	816	22	1	3045	jwNk4mYi7d4QDcrgYrv5cqyQsdhHPP2o6LNP2aghm2Kx4ZvCS9b	1623	2300	2300	1616353200000
3124	3NLX5cbRBzefLut9p3FYis1aayUKUHR4JMuaDXMpTdYFgrSNUZM3	3123	3NKy8ctt9ivui6P9uYgXfJxi9yUPvrmKpBzg2mxGRfZENTDjtQkV	1407	1395	22	1	3046	jwH55YPEPbSwFiFuB6TApDvqV5gErMwYPsg6f3T7eKVmZ7psEE4	1624	2303	2303	1616353740000
3127	3NKqEGE3kue8jSzmivjbadhAY8zcaw6hr4u5RP1kcTFekwRNfJUV	3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	1599	1287	22	1	3049	jwcC7H2DBhhWngKxWjC9Vzr4UVHzjL5CgEzx5CkbHcmPX1crSsS	1626	2309	2309	1616354820000
3130	3NLt7XMGDHebk1FMqVLB3fg9ixgJzkik3zqoF6YBh6dgWA7Ys3YC	3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	1529	1316	23	1	3052	jx4V4mTaRGmjGidaeD8PuoCn3ai8yW5FCEDtaVyzDN67Bjoez4P	1628	2311	2311	1616355180000
3133	3NLhcBvWEu8dpxqozT3FEUbSa9y6Ei7BkmU2Ka1zGVuMsNZ5xy51	3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	1643	1053	23	1	3055	jwmGtsdp9g72faRfzDFXRfg9jFGGcPphD98qP2hNqn9iVEYNng9	1629	2312	2312	1616355360000
3142	3NKCefCCR3ynGvCBAd5V5tpvj5yeQQZzmnrQfKfqfKCE11r4oY4o	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1542	1304	23	1	3064	jwtuXNS1VNK1hFm7U5LDU1ebLA67ZzPLoCHQVTSTuuRvqnzep6Z	1635	2326	2326	1616357880000
3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1490	908	23	1	3067	jxhZESyfYVwgbUbpnRtY1NE8NyqtrFDmQC2obhRgr31M6FVJ1gX	1635	2326	2326	1616357880000
3148	3NLr7EMjEgN1rPneYWMh2TyiHbYmyC3G1s6Xroi2MRX1pjFrZbu4	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1402	892	23	1	3070	jxurRSVgGuUMMJJncVqNEFy1kNTHsb3rpepLvHhGYyGptCQ59Hb	1637	2329	2329	1616358420000
3151	3NLKeiGV8jFc77gFcWKzTp1JbP2zKGNQmejMDCJRHnKBDwcdKFjy	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1637	816	23	1	3073	jwVQCP2YSjFq8wQKNNvZrS1H3G8WLmkQHngFbXrf3jsMtiihkwV	1637	2330	2330	1616358600000
3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	3153	3NL53mfo3Gc7k6TpdbxeANmhtJqLBxCTZoGCmMpHeuHXVczL4M9n	349	349	23	1	3076	jxgH9LBCUAyy8F91DbmP81imJotrkpeuXHKwu9EnjhHvdJBAR43	1640	2332	2332	1616358960000
3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1407	1395	23	1	3078	jxWY6LrT5k6S93VieANHLQNsauvvQg2aidQTxoii3oP4smEr31D	1641	2333	2333	1616359140000
3163	3NKvGnP1jNvfDzJ7sWqAhn7cULf5Yb7iwARMnDRLG9dEgAEywvyX	3160	3NKjQbvu9MyUgYG5VxeBs41HsVNDU1WNQHpqAfdut8hnZMTtY595	1406	1393	23	1	3085	jwufd419XX9gbbeH8UKotKpAm88w4q6S3FhZP8ncQiCB2mG7YPW	1643	2335	2335	1616359500000
3116	3NK9v8bjnPZLHRESmw9vs5sDS3afPDN6ywNFNdYgtzCWsJHDEQLj	3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	1406	1393	22	1	3038	jxqrqGWxLncBdsRnafYExe7uwSDm5Cr9b2Heum2j4mosKdmBTci	1618	2291	2291	1616351580000
3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	3118	3NL8dCXLGetDxoBY4J54WP7TQGJsDgsH5DugWi113abNAjtM2Z7T	1405	897	22	1	3041	jxAr4LfX2ovBWkjXqegkY2RniPnc4Y2BQYtQhEeLRGLTaAbiQtp	1621	2295	2295	1616352300000
3122	3NKhRjMTwUDdn2FRNrLRDuQf1JNDCryJnyxw2QzFEh6bCEXuB8U1	3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	1405	873	22	1	3044	jwGyanpg7DbUaFSB9uQ7R3Lr8NiGFn7FsHC5tLwaxiQdbuU9jPo	1623	2300	2300	1616353200000
3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	3124	3NLX5cbRBzefLut9p3FYis1aayUKUHR4JMuaDXMpTdYFgrSNUZM3	1587	1357	22	1	3047	jwDfiaH4scbg1ETHNga3dJ8eSKeoHzDev8cYF6Fofw9vu3Yvysh	1625	2306	2306	1616354280000
3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	3126	3NKBxJxdZ2F3NGR4V7htM5s8szRn4UXSgmM7jVwb7e3gvdTtfUrA	1610	1314	23	1	3050	jxEpHBDpDYTGoK7ckHRinrKvExM68f5QjzE5TNnuAZzDYdph81M	1627	2310	2310	1616355000000
3131	3NLrPSkAekanw2RWhemJ8BhvtXdkL7d4Bza5nsXoRQ6oHr25Dkuc	3062	3NLUrxsfmTUztLvXf36JHHmRkTUwSaxthaJNzn8yZXL2CbFLhHuB	1643	1053	21	1	3053	jwV8bujanp8rhnrUuzY3vviccfB4evHYfTAbmUqeawZLwUVtM4Q	1567	2312	2312	1616355360000
3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	3132	3NKQNPhAF9ML1mSLcDGWG4e3Xq3rKP2tkDQsS3j2sv8MpNxfD1C9	1406	1393	23	1	3056	jwkph73DwsskvJar4uKUJ9PRZtsjc1x8Z7u3P73Ak56nKdtJsov	1630	2313	2313	1616355540000
3136	3NLgPVuBQiqetLma3PrmgF8FQNgMpWUdjZTSa1LXEo5SpmFk3AXi	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	44	1079	23	1	3058	jxQmPGntg7J1vD3HM6UNq1udk2p2beKdy6uje7RRjxDWmbNSD9X	1631	2314	2314	1616355720000
3137	3NKgUaYc57yjaribcJx7s1rXyR4zr29YcNgqPQkSvbwoMKTRSV4c	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	1601	1388	23	1	3059	jwgMTqL5vwRXfqSJgtSmDVt7k9B1PFwDiviNjqFp9h72kNULcH2	1631	2314	2314	1616355720000
3139	3NK4qt6xEUtuBpEbXySMZhD3pFQPhyhay4QMRjhTYeKyQMseCCoy	3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	1406	1393	23	1	3061	jwPwhwzbictF2fkNQZYzxJEjF4FrruRQe7hiqjVv1znYamupzeK	1632	2318	2318	1616356440000
3140	3NK6MC2vSEXbuwV6osVgrBcgb4sfC55dML8xQv1a98jik7rcqNFC	3139	3NK4qt6xEUtuBpEbXySMZhD3pFQPhyhay4QMRjhTYeKyQMseCCoy	298	1308	23	1	3062	jwtV3PLGWtERU4dKto2CtUM9btpR1KHptyHGZVoRMsFPr4brML8	1633	2320	2320	1616356800000
3143	3NKoW9HS2A3fVhxFnncteGqZmewwfN17VnpkyJb7pQ5wSQw6f1pk	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1529	1316	23	1	3065	jwgt3ruXCH9w8s2dbRwkagjeQQFQbXPU2oZjzqizeo2KyeJAiWi	1635	2326	2326	1616357880000
3146	3NLcC7qMVuwvS5JM3VLpa4mzf3d5qMD8skJeea1BrPaSm7X7Fu4d	3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	1407	1395	23	1	3068	jwehkb4tsLsQZbXN6Uvqjk1S93Df2VoCiTACNSeDKRUp9Ph2YhU	1636	2327	2327	1616358060000
3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1553	776	23	1	3071	jwwTAfnB7CsQm34Szs8bRBo5AUAED9wNuEWfjJphDTksAyTzAWn	1637	2329	2329	1616358420000
3152	3NLbFVJ61QAAMnQd88c8go4Knsu7dgKmnAVtQyCD15sdXpf2Kwpg	3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	1637	816	23	1	3074	jwwZtqpAXDhcgZHwEhJgjZcydwcJVJWgCaEyYqHJq6cfYS5HPae	1638	2330	2330	1616358682147
3155	3NKY9bhB4MucmCbthM7i6JhBLBuMdgpSygsAYkiQKZXP6A9nnvkq	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1673	1368	23	1	3077	jxAPApuRsHS15QUANTuJCMZKyLyrpV9zmWdCaeSGCkaMXrwH1A5	1641	2333	2333	1616359140000
3158	3NLZTPHcciK6Jg6UNTey4Rgq5zkJCxSeSH8mrTb5wwaqfUmVNcjV	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1474	1329	23	1	3080	jxFGN1MgZZYCmFgSA9dvCmJzkR8T2o6QWEm9rqGhcvkGYTYLoqt	1641	2333	2333	1616359140000
3160	3NKjQbvu9MyUgYG5VxeBs41HsVNDU1WNQHpqAfdut8hnZMTtY595	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1403	824	23	1	3082	jwRgYTGKRsq7PEM6x5SiHzrkLZ1yDoJG6PxNpbHwvWK5TjXdUpa	1642	2334	2334	1616359320000
3161	3NL4XxvivLPNJwnnT5ii9ppM9NRBaxocA8GfQpDuc5gmasWSxPCN	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1553	776	23	1	3083	jwu8FuWRPLr8R89PwGZeMQiJxLhSLyxDVbSBGNXviUvU3dBxQUU	1642	2334	2334	1616359320000
3164	3NL3bJ4atXE3L8XSW7BUe52xu8mo8koSoreVCTbd1xx7WDghFjBK	3163	3NKvGnP1jNvfDzJ7sWqAhn7cULf5Yb7iwARMnDRLG9dEgAEywvyX	1559	1353	23	1	3086	jwDQhaTjA66EEfmKsG7p5exUy5RE5gUQMgwUwDRU8KWpj9W3Da5	1644	2336	2336	1616359680000
3167	3NKP2b9Ct9kEgYNwz9WTwjQ1kmaSLwJ4MqYNFveav4zCeceRwpg2	3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	1578	930	23	1	3089	jwQLJsJNkZFNUTX2XpQYxP8pNebHy923DC3zPFDFqSbL4UWJzsk	1646	2342	2342	1616360760000
3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1529	950	23	1	3092	jxG7TanopUfXbNdvZPQ2seWMa7ddxvQ1GBiYwuiPKn2YjtMs4U3	1648	2344	2344	1616361120000
3176	3NK5JHAvkqPdj91tJsReTbKAHiSFZNqwByy3ojtP1C14fF36VCVD	2951	3NKki19KLbqwvyCKWwiu7d5HSbWVmSYZkDpzq5kk8RRkn1mktHB4	1611	1095	20	1	3098	jw8yE6sX6mksg9TgdEEsUHqrGVBCaptsVyqi9aGk19HLeowk2NM	1531	2346	2346	1616361480000
3177	3NKiyiCYdVDrrmychagSMuLH98Zjz2bvetszzQb9qFZ8RdbYiddX	3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	1407	1395	23	1	3099	jxSkDQpcdKZYftx7RLkR212TYTYgUYU2DoNLA8wge4qqh32AwSh	1650	2347	2347	1616361660000
3179	3NLU24SHKU5vgy7cYwDnhj1kP3TByEygEiRXDXKJL1wEep1i54U9	3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	1564	1338	23	1	3101	jxe9x5Bmqtv81BLdkpi69Erzy2UyTSRvLFkF3Y8jSRhn2fnmnyt	1651	2349	2349	1616362020000
3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1407	1395	23	1	3104	jxkzdi7NpjpvK5i4efek1ueZdrTf1YrZMh6SVbRxZaC9bPgRYu1	1652	2350	2350	1616362200000
3187	3NLpGm5TVLd7gKZcCf5ZcgKycKJecn7kbiVp6dnxHseAguqZn7Kp	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1652	1189	23	1	3109	jw8gvAr9tHvb1FTAYWpzgVsPnqQWwwsMSLyRicJPPoeaD948LjP	1655	2353	2353	1616362740000
3189	3NL5MnDhLoShm1ESVYq3Q1mB3J1r2ABGK5tLgNm26f8ZHWCTgXr4	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1652	1189	23	1	3109	jxDoDnwUaXzTM4aSB7dQCGyGvVrG9CX76RaxQYJgcuM9MGxfMQX	1655	2353	2353	1616362740000
3194	3NKcBtAxiMYjPjkN3591QQ97Xwyce9R6NyTKMAuSPHakr7YQdDWx	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1402	809	23	1	3115	jxejkpnwaXBjvhcrTbCLddKxXhmU53KYG7hidFpXVsS1Xos1dGK	1658	2359	2359	1616363820000
3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	3193	3NKBExG5npLE8VuKddgqxRb3TXggrsijK3bTPU4mDw15d8aDnMj8	1593	1100	23	1	3117	jx1gYidP89sagSkTQ6B3vFSGzs6hDfWUjD71tWEKumbHdyBAkNJ	1659	2360	2360	1616364000000
3204	3NLoqvvA6ptM2tcaQ3N3jr8DRgPYGxZX1r7bbqPkk6SLfHTUs6ts	3203	3NKCyFs9MZqxuNznqzG5B98AG1cAiS5NxSDDR3Ukz7ZzeFV6jRUE	1406	1393	24	1	3125	jxeG4p5GYvQpCYYgEWEQU6R8tPNJeRDFeVoECNEZLDJCyfi9hfa	1664	2371	2371	1616365980000
3207	3NLd8Ax1UwQkk1f9uUd6bM3vJeQ4fUSkpw7HtDd3guL57CEJRW3u	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1587	1111	24	1	3128	jxai6cTJU3bexUUyXbWtKbD52i2D8sJJm4fjxzs6pd6xKi1yP4P	1666	2373	2373	1616366340000
3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	3140	3NK6MC2vSEXbuwV6osVgrBcgb4sfC55dML8xQv1a98jik7rcqNFC	1589	1040	23	1	3063	jwSGCjNjQbexbW9NuT4UjBWJtdU8shXv5ny3dYoRgqYihKyHyo2	1634	2325	2325	1616357700000
3144	3NLNmnY3P8KSmRvzoZVAfpJaHARUQhEKQViY1kic911NZ6pWCmCV	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1534	1317	23	1	3066	jxXfyAUpjf74tNRwGq46oMZN295XkoMtXEWBwShANPjHaD6QrNJ	1635	2326	2326	1616357880000
3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	1581	778	23	1	3069	jxjP87phqrV85DsPUaV5hD9EXZ76wSr8D71htvkLsuaNWUYxQHT	1636	2327	2327	1616358060000
3150	3NLNZUb5fPyo3jRcnzzgHf1UQfAVg7PyYBi2nhyCBnWsGTqZNJTj	3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	1403	824	23	1	3072	jxhULnPywaM9dgZDjesTD7o5d3jd6UHa3kFzcdD8mH1HLwUtKR1	1638	2330	2330	1616358600000
3153	3NL53mfo3Gc7k6TpdbxeANmhtJqLBxCTZoGCmMpHeuHXVczL4M9n	3150	3NLNZUb5fPyo3jRcnzzgHf1UQfAVg7PyYBi2nhyCBnWsGTqZNJTj	1451	1292	23	1	3075	jwRvY3WVMiTicGkmx9Lp9EfokcFYgUnNFftrmF7xUjzHhN35Yad	1639	2331	2331	1616358780000
3157	3NLpoYvVoSR6gf24iwKCxhLZkj43r5Jskwfp5xhez7D2SrZHJnHn	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	369	1066	23	1	3079	jxyPTSgQJLVQTuAnU4bNzhQ6iCZ8Q4WGw2m9iD72f1w5a69wBdp	1641	2333	2333	1616359140000
3159	3NLukYvoEifZreoohZLoYXHPKmMrgtePQ3iMg6wGCokcrRQ2bx66	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1542	1058	23	1	3081	jxBWWpuAfcDVAy3r3q39iQmhEy22rGmQZATgA3onVNKyFdHReXp	1642	2334	2334	1616359320000
3162	3NL5mhrEQkJAroe4QiJkpkmR82bbb9yAKqV8nkTjYXRG2jbsvj7s	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1547	1132	23	1	3084	jwKkvNY3hcEPTGaVXU6M7VdY33tsyrrDy3ofHsXzLuJ8wtrjpcb	1642	2334	2334	1616359320000
3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	3164	3NL3bJ4atXE3L8XSW7BUe52xu8mo8koSoreVCTbd1xx7WDghFjBK	1406	1393	23	1	3087	jx7tzEdRsUKdSo7z1AEQqUg3jVVH7eQUGBfJ4oVpeYyfCtQZRVQ	1645	2341	2341	1616360580000
3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	1406	1393	23	1	3090	jxpM3eCt5Snhrgs3j9vC8H8aXynGDMrus8wwVqJf9Nd6Da8AWwH	1647	2343	2343	1616360940000
3171	3NLShekLpy7q3qziZMw4FYJKT7g8wx4UpgXbpbr62nwYrG8HSMDa	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1579	291	23	1	3093	jwjRa95hfKGto7o9rG5rkdZyXTncV3dvoHKi7WN931TGKLTJAKo	1648	2344	2344	1616361120000
3173	3NLa7e9bh62U5TsXog21sa9mgSkuwdW1PRHjSnrJrAwaAwMAJzEt	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1553	776	23	1	3095	jxtEDX1Qf3sAVJ6CFbe9DM1XyWRpZ1gmPTtRigiFkAX7JKHFavY	1648	2344	2344	1616361120000
3174	3NKNGgJfoNRotyXpqTpptNQDr6cmZGL4GdeeftS1ZDMnXo64rbKg	3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	1460	1324	23	1	3096	jxJifBnJ4aQDiLvrUqDSW2pHpeQQrJcn3BqMB5XxbitowW2UvnE	1649	2345	2345	1616361300000
3181	3NLvaEmBVoCNPostjZJXDgZ8Ti6dcB3mbqTQetaZy5AS7m5oYj9w	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1406	1393	23	1	3103	jxkBYoRDTPZBKjFf6ZyYBCo2xFA2XMegfmJfNmn2vne2BfJH97t	1652	2350	2350	1616362200000
3183	3NLXmr8uy8N33YJJiKxQRscoE9z7KAZBbS5XXQunpoixqQurYeCq	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1670	1036	23	1	3105	jwoaE6WfwQzcvCsEXmMbr3MBZ3vKvfgvzxRLypHmTSAXAT5Ns3Z	1652	2350	2350	1616362200000
3184	3NLxceg3E7g7VUV4DoB2sFsvugnAbbaRDJzUgp4CJjaaWz9d8EFE	3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	1448	1311	23	1	3106	jwkdRyJxdjY6WRWgF4BwU3TZGnSmoS2H6dcxprVaVdJdejMWGHu	1653	2351	2351	1616362380000
3185	3NLvdX73rDsXXEAPWYcVqnU6qahgUK2qkC3EttPGxyRkMUHYzD3L	3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	405	405	23	1	3107	jxQaDpFBFskYqy5Htm6KPV7USh2AaKcC8EBbm2tgH67Skzo6Lpc	1653	2351	2351	1616362380000
3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	3184	3NLxceg3E7g7VUV4DoB2sFsvugnAbbaRDJzUgp4CJjaaWz9d8EFE	1587	1357	23	1	3108	jxjeURUS4Ev8gP1S8pbFjTtVr4ByTFYneHaiT6U2TpeBspZREBb	1654	2352	2352	1616362560000
3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	3189	3NL5MnDhLoShm1ESVYq3Q1mB3J1r2ABGK5tLgNm26f8ZHWCTgXr4	1460	429	23	1	3111	jwTcV4gEb9XtVgcHFzPMNUReqZzH2eXg561L89A93di7p4gkZPk	1656	2357	2357	1616363460000
3192	3NL24BiV9wunNzZssJRo1TEbZqA4bbafxamiMMXuPojQ31kPLEcB	3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	1637	816	23	1	3113	jxh58CgbdNvJpRF3TGDTm3C7bFX8BL7fXbWGGp3eBkW2EoSnuJL	1657	2358	2358	1616363640000
3193	3NKBExG5npLE8VuKddgqxRb3TXggrsijK3bTPU4mDw15d8aDnMj8	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1407	1395	23	1	3114	jxGvF4fUb56vuEkPNf3Q1McDJH6Nvk2iaXuqXkaBUXnR2cMJ4pn	1658	2359	2359	1616363820000
3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	1407	1395	23	1	3119	jxeKaV4FK2wg2ijFipfhAXPX3b16HgyWieKxHwREzS4PBThxxCm	1660	2362	2362	1616364360000
3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	1581	778	23	1	3121	jx48udKByGyfAXxHQZy7BpYLp3Nc26wRbkr6KVza7ay9FgGzjjM	1661	2363	2363	1616364540000
3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	171	1128	23	1	3122	jy1GPEgXDPFUHXeYkXq3kzB7ftZnH6HsVLzimGK5f2swcSM4aiz	1662	2365	2365	1616364900000
3203	3NKCyFs9MZqxuNznqzG5B98AG1cAiS5NxSDDR3Ukz7ZzeFV6jRUE	3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	1593	284	24	1	3124	jxkKNmc2zP8H4SUZmPsJy6R1xzdo7jJXMSv223mEpLGnykewBzB	1663	2370	2370	1616365800000
3206	3NLsTDv9UkjVLjKLcyJHdfCXrXpkrPsmPkNFuYA2uv7LYoSjf7F1	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1402	850	24	1	3127	jxUDqw5SNQvJM2xNCk69ttxaNLajZgXLNtBUUrkkSHo9HDS9DV1	1666	2373	2373	1616366340000
3209	3NLcuWZk8VVgHdhRMxU4pWYjmZTphszX17Z8ovvQ8S7n5Nk8mehp	3084	3NLhkUtqQKGdvxKyS129RyByxZwQ8rQdVyqAhbgFAuNZ9qtVsPRZ	1651	1175	21	1	3130	jwX5a1KxWpGLCtCqsqcUeGBKGjWz1BT2ZcUG3T78usCZtwpqi4R	1554	2373	2373	1616366340000
3211	3NKuCzuGoGTsBUZKZPEbLGidnat92DnkRf8goC4ZstwGSSxhYARE	3210	3NLv4QzJ38N4g3PJArq3ZeCBs3NJ5P3nAP2S6fGCNNZxCakAuMMj	1529	1316	24	1	3132	jwtE6mR4b9B8B3nS5cTMPuwpQkytHSoJpvRobL6B6wXUnzwXBVN	1668	2376	2376	1616366880000
3212	3NKWhADKXBErNst49aSLUaP2RpA42Wvvbt69vK61vTYV1fUwAxHb	3211	3NKuCzuGoGTsBUZKZPEbLGidnat92DnkRf8goC4ZstwGSSxhYARE	1670	1156	24	1	3133	jxq8zG4sU8PjZFGauGwSpJCWSRgmHYFiZBph2Gd2ofVA9LtWB3V	1669	2377	2377	1616367060000
3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	3212	3NKWhADKXBErNst49aSLUaP2RpA42Wvvbt69vK61vTYV1fUwAxHb	1593	1346	24	1	3134	jwk8NCmkRoXregzbEFXokRooSoJT8wxQqHfhJAQYcKmJbw5311x	1670	2379	2379	1616367420000
3217	3NLv96inG3cwNRsiYqwmM1gY6pfWjxQrjEVVYTWX8iEWXWdoqZBF	3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	1407	1395	24	1	3138	jw8hrV9x1qCY33aEyqQfwFqymrZL7PS7eCHvY9hm8YCEgqRwXkp	1672	2382	2382	1616367960000
3219	3NKuxcmeJwcFRGHo1Mof49TyWUha1RXgsJAz11m4CroLNSLQzRZN	3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	1613	1349	24	1	3140	jws1vmiop3XYTD9ezRWMeMHZoRFTJrbDXsM2gsGdRXeaVyFGbAa	1673	2383	2383	1616368140000
3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	1406	1393	23	1	3088	jwTj39Dy37bo8U6u9DGXRXQni6jECowMLzkGqLbpbQxvTUgHf3E	1646	2342	2342	1616360760000
3169	3NLT8Uabz7YW8C5Q3bB1EaMoxfAKVqLDreyPHVz9ea233wZfAfTv	3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	1405	851	23	1	3091	jx2RkGmgmsFTjziHuoKhscpKDf8cjCgM1W6e7LUSaLhGCrgmyTd	1647	2343	2343	1616360940000
3172	3NLtFxpdxJdx8DZpQm7Bsg8Dk7kLhHX1Dkw7Cv6NVMKHBRdCJMyf	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1573	1192	23	1	3094	jwxrJ71poV1Pc8eRRRNdPfkBNqpHYBgLFsD8MWF4VeGkjAJrCM9	1648	2344	2344	1616361120000
3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	1637	816	23	1	3097	jwvrr62Lvi8kty9GNxRxhcDJKRPKTmXGMzYks344YXwucoZR9bS	1649	2345	2345	1616361300000
3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	1599	1287	23	1	3100	jxfAUC4uzsHxKPy1qCJ2K5EYoipMrVRsSgwLnP9SANp6woJMAL8	1650	2347	2347	1616361660000
3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	1406	1393	23	1	3102	jxYLvx56oAsDDmYePXEbe7oNpq2vEprBWK9SuMe6GdSmKdbUF6k	1651	2349	2349	1616362020000
3188	3NLDoRqxmjzF7xB6LM8ZMvS3qWZYGS6nzNJGjBmhgLoHE9M3qgyo	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1599	921	23	1	3110	jwAmSkYSf6xu4Ani7Cxnw4QPRmKXFxBZQzGgysWAoNCsRi1hKjz	1655	2353	2353	1616362740000
3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	1601	1388	23	1	3112	jwsAgRqDwiKLa1LzwrExDzax9t8jXzipi9dYU6NG7ebsFSCojND	1657	2358	2358	1616363640000
3195	3NKM2VgdN7CvkYafxrdXWPyKYEW4UiQCa3BJVrcRHhjAsvxNwFRh	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1631	794	23	1	3116	jxbHDYoyJv761CPtrBau9NiqVFzjZggm252uE55VR9LSHcGGHD1	1658	2359	2359	1616363820000
3197	3NL5RguTubeDoNMUeHmj2TgHcb7W7ZQGdAQnLPtABSnWKvSzCu4n	3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	1406	1393	23	1	3118	jwmZjPh2UsU7oSFVXD3cgma8WnV23zWoZhqjYKdLsMJXhXGT5WH	1660	2362	2362	1616364360000
3199	3NLBMdLTs7tmEUTKbVu3DWD9ZgKqD1kSLw6tFnd1znogVwCUkR8M	3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	1670	916	23	1	3120	jwNX7pw2BKRzBjq2Weg34HBvJFc5ou6ZtabwsWhvspsww3kKhVd	1661	2363	2363	1616364540000
3202	3NLBe97HtMqLHTiaEmQzm2xNpwmAmm1WJs5uafR1CUVXtunt64ES	3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	1534	371	24	1	3123	jwiaBAbsPs6PHQAyUTw5fvj3jRnBypeWM5xsqTXM8BKQDPUbBwT	1663	2370	2370	1616365800000
3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	3204	3NLoqvvA6ptM2tcaQ3N3jr8DRgPYGxZX1r7bbqPkk6SLfHTUs6ts	1637	816	24	1	3126	jwsxbqHUzgTbxgkTySWgRAC4zzq7qAo7EKzw1Ncptj8DcoUUDth	1665	2372	2372	1616366160000
3208	3NKqEvgKarXSoTma4N7w5zr9HDZt7VCCSqmnxYSTncn66fu549bE	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1651	1175	24	1	3129	jxRA5d6x9kfe8ZtT4hVL83DoyS3Rjg4Dyz8fFLunAuke4uwDzMf	1666	2373	2373	1616366340000
3210	3NLv4QzJ38N4g3PJArq3ZeCBs3NJ5P3nAP2S6fGCNNZxCakAuMMj	3208	3NKqEvgKarXSoTma4N7w5zr9HDZt7VCCSqmnxYSTncn66fu549bE	1490	1274	24	1	3131	jx37oUi5NXdwfwwpgzxRMzozq3xmN9wsSFW6fA6PbJ3ise9bLQE	1667	2375	2375	1616366700000
3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	1471	1386	24	1	3135	jwH33Q94tUYYY56QMFYd1sPxVRFQTojo4c5HZSPBFBc2NYUe7Wb	1671	2380	2380	1616367600000
3215	3NLXemG732s3FSYKbGWsAayHgp1sWkWKVAyiUktqVnxjKLBjRodv	3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	1555	1347	24	1	3136	jx8ATt6rKH8DYqzfft2g3TpdgLN57iXLcCyPGjLpfBy4waz7Yu8	1671	2380	2380	1616367600000
3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	1673	1368	24	1	3137	jx2FD8hbd9camGYWKsHWcokQ5QEjfWrEfL4idy7iQAuheUkhMSW	1672	2382	2382	1616367960000
3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	1403	824	24	1	3139	jxyy5vNPiWVk9N3sDAPNddjJdMEAzgtGz2ySmwJoqNYxCzhUVyf	1673	2383	2383	1616368140000
3220	3NKGZXJ9CgiULepCQEqMeDcZZZqeWABjEL8mLS4hnBRrYtWRFC4g	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1407	1395	24	1	3141	jxwwQ3eCraQT8oTehmZHiB9biT4k9bhxGqNF7VgC168c6JRHVvE	1674	2384	2384	1616368320000
3223	3NL8SDTJE2A9gNefpLbHYHtkmXWvZdhahTpc11ppZmthYiWUBSz9	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jwrazfaBkfRFTzCK3bSHhBRRraMLLrsFDgFUqq3aY7hGnfbEJsc	1674	2384	2384	1616368320000
3230	3NK6t3zXPrWptpxVnKnbKUoDDpr1UhSyirXNy8QrcvnWnRBK3eW7	3226	3NLLMkgCtDKk8jSBaYYU7gMxqP5sWzxRF2VWsQ2hD88CNWfvsvU4	1637	816	24	1	3148	jxYcU4gWX3592UZz1wDjE1JUXvxJFxQpdrXn6tsWZ6Mt4RLDph6	1676	2387	2387	1616368860000
3237	3NLSg4qTdhHEsAzDKM5jRx88fYCwrA5anB3f7SxpgeB8B7KrB22z	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	596	1306	24	1	3155	jx8uMRbUDySXB7V4LgbgmAyU69B2sUko9hLrmiWsAiRUd7oz37f	1681	2395	2395	1616370300000
3240	3NL8VsntNwZSkWb2HL3ACW5zapCXZ8essfxeLjtZ9rAYGHzXfbnK	3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	1637	816	24	1	3158	jwutVCQNazRCBXVVXQzKdMveMJH33C2LJnkSX49ravqBBJMMr6q	1682	2398	2398	1616370840000
3242	3NKqEGXukfdH3HtqbLX71reGZWfHBzFsoCp9QbqqQfdb7myh7XaK	3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	1489	1380	24	1	3160	jwtMjqPwmyB2PvirFEC1cSHrF8AzYGgw5H7ES7413HYajwbV4Zf	1683	2399	2399	1616371020000
3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	1649	1383	24	1	3161	jy1AofbqJt7PpF38nJkxpKxBYbaADqegskvovLEFVWTNUJP13Xz	1684	2400	2400	1616371200000
3245	3NKVku4UR6Q7jYyS7WYkwcwdS5gadgmmvxLwx4iNW5P1X8Kt4P59	3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	1500	1297	25	1	3162	jxq4unjCPfPeGe56CMyD9r5SYCo4BsxazjBWSjPf6HdgZ8bG7fg	1685	2402	2402	1616371560000
3247	3NLe27sY13b3f2TQAEUDihUH29HxQfKu2fN1dMGfCqhiBgbjPf91	3220	3NKGZXJ9CgiULepCQEqMeDcZZZqeWABjEL8mLS4hnBRrYtWRFC4g	1500	1297	24	1	3164	jxUMq9Rtp6htNHi5osTLBPinEtVwhrWzgTU8hsrsixzYPQKTseu	1675	2402	2402	1616371560000
3249	3NKim7ySbzJ1v2X9xAfDavPrKNpbijBipP4U8u4ujEFUch2xJcLJ	3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	1406	1393	25	1	3166	jwzYNyHQdMGCgXVK97WQzYsQedCXsVkMQQHMgeA95BYWC9PRGPt	1687	2404	2404	1616371920000
3254	3NLQe3fAQ3yJnCyvKAoCyq16ixawjzw26NPpmGKQMBVD5V6XHWue	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1406	1393	25	1	3171	jwH5KFPjHWE1xaNfyQUaPBitrmnMCTMcmJb8roNSmUx6jzaW8Jx	1691	2411	2411	1616373180000
3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	3257	3NKTDzRYb9kL75swwoXf2SAv6rKFKbz4ckjCGJFCyLnkmfKWhtFF	1406	1393	25	1	3176	jx3zNfbDbkMSJhsnFyWhBtFYFdhDYwqFi7EKSb15dXgS4sSMVzg	1693	2413	2413	1616373540000
3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	3261	3NKwjruKS8RZT3He77QThGo1PkrWAfCKPTSLtNmCNTvREAH3SuQ8	1406	1393	25	1	3179	jxNS9ocYWWa9RXSe81M8ZaEskcmqMaT3yELApm1i9FzVduZA21J	1695	2417	2417	1616374260000
3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jxFtSG4sXfEfB9Zcn2yQVLoQVVnPS3PsZwWwxwZ4PxpoBE3Bmnd	1674	2384	2384	1616368320000
3224	3NLPqWvHJejU7WtyWzDb1awDEM88Qy9pghJiQh1G2eo8KjfdHB4f	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1617	1288	24	1	3144	jxHgVt6q8rNGXTZiFGytGUbgXh5mZ68qHBDxdnJAkukfpHgFkBU	1674	2384	2384	1616368320000
3226	3NLLMkgCtDKk8jSBaYYU7gMxqP5sWzxRF2VWsQ2hD88CNWfvsvU4	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1481	790	24	1	3145	jxERj6wqXwr56D3u4W6F3e6xyC5ZUK4BmKgj6WnEhEFXWhhzVbr	1675	2386	2386	1616368680000
3227	3NLmzAUPcFJgsVxMW9BF1s6DdHhLATCDK9nmYz7LwSUtkRFTMrUt	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1634	1205	24	1	3146	jxRqHWnGK7xqSzGq3Y577dy7UYPZmdTkfdsNFGGk4SMbM8T8K65	1675	2386	2386	1616368680000
3228	3NKhtRqgXMJ4fTX1whWbx6mQzcvTqUGv5URGwdGCFspZQYeBjSWw	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1646	1108	24	1	3147	jxxGbW91yZEba3hKhsp4BY9ChCQk4RZd27wyL7odpUF4wYSHsEb	1675	2386	2386	1616368680000
3231	3NLA9d5fMtupGdo7XxhTjo4hckscD2fKVhFqAx9hjDyvUo4C6AC7	3230	3NK6t3zXPrWptpxVnKnbKUoDDpr1UhSyirXNy8QrcvnWnRBK3eW7	1509	954	24	1	3149	jy25S99TJ7PBsgLF6vnBeaqNvoP1EQYuNNC5HYQSv8KvKLjq22r	1677	2389	2389	1616369220000
3232	3NKtSVzd6SnqzrDPdhUESk3U7Gw2qp9tUwnz2sRDntfco7aHSoi5	3231	3NLA9d5fMtupGdo7XxhTjo4hckscD2fKVhFqAx9hjDyvUo4C6AC7	1406	1393	24	1	3150	jxn41kyH7DXe7zhMQTeottSryRHyGDjyqR5ru6P5nGYgJQHzKag	1678	2391	2391	1616369580000
3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	3234	3NKLpGKcraGZLsDDcwxpP5j5SRpx8r1fVEnc6Y1kdxWzG7TbrjFw	606	1295	24	1	3153	jxcvNGQTVcM4xck8y9S69uVYuKzqVsHHN3EzmMDGT8atSFs6zxY	1680	2394	2394	1616370120000
3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	1578	1296	24	1	3156	jx6wGFpF9t7BRtY4Mj7JJEPq1tQbqVU85GygF2z1vG2tABFu4oc	1681	2395	2395	1616370300000
3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	1407	1395	24	1	3157	jwuMEnjB5kiMiJt1oDZr3Rp3iPtjKoWjCFS4uZegoBkwtTRucCB	1682	2398	2398	1616370840000
3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	1619	1029	24	1	3159	jxwonFt8YCaYnEtgUmZBGVXWWxYLK3VKvM6PBVovvfqHBT5Wsr4	1683	2399	2399	1616371020000
3244	3NLa96YFoEV2z14vca6xKGsdjib9kRDQAcPDKoA47aYQuXXqmBrR	3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	1649	1383	24	1	3161	jwZo1CnBbWzvnsnEM8Rbp8DTTwo4Z9xNpjAaRGrRw4ybLmRCWi8	1684	2400	2400	1616371200000
3251	3NKzy57hjEnTgG7anTKW2jepTyw89ciWRrUsJLvfYNCqw3TPaW8R	3250	3NLRWC3ntkUCkh8SRzSDwoiF37nE3BVMboNzYz9Rf8rGymUGDPc8	1439	1033	25	1	3168	jwfrf3S7hJvjmB4KS6DYNm57ET3Y5F2LZvknLvbp3wDDhW8BnL2	1688	2406	2406	1616372280000
3252	3NLoqpVzjYRJBHqctsgGnQf1hY3Wcg33v1oMWn2kcpZ9MVctQ3Kg	3251	3NKzy57hjEnTgG7anTKW2jepTyw89ciWRrUsJLvfYNCqw3TPaW8R	1406	1393	25	1	3169	jxfLCJLFtF25aFGFxAWaNKLkUQginhRPmN8SF8JVS4jkmuaKeoV	1689	2408	2408	1616372640000
3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1534	1071	25	1	3173	jx7eUKU8EuyVhCieFo8CHSrqZNbDg7BCjtvNVwj8n4BvMhVjKCM	1691	2411	2411	1616373180000
3257	3NKTDzRYb9kL75swwoXf2SAv6rKFKbz4ckjCGJFCyLnkmfKWhtFF	3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	1516	1294	25	1	3174	jwUUUJQTCFBDzXAfwcBdoYY5WH5CenGzKR8tVXgyBrXS7VD5moG	1692	2412	2412	1616373360000
3260	3NLgkX5HTcDxHb3d221SmjTUseEeQyWpYYnvvyMMMEUdjNJki9Lp	3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	1403	824	25	1	3177	jxPAs8srzRrZDCC7QAUm87Za6zC1GzFT5P4u1XNhGchSYzB41r7	1694	2414	2414	1616373720000
3265	3NKvTfVb92HicFpLE2jaVAb8kH5EiPYQV9avccnc14hSv8Z53DCD	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1631	794	25	1	3182	jx1bskdvxiRUfjAadmwfEsnANWiXDqkgjC6rzwFyg7dpPQnBDLg	1696	2418	2418	1616374440000
3267	3NLt3kvWqV3iyn8upSx1DkTwhAe5MvjYqgHcYhtWg3Ac34eQCD3n	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	1509	299	25	1	3184	jxzYVsutfpDAURUh5m6S3dubf9EzZar1XFPtLsmPoeZveox39Q4	1698	2420	2420	1616374800000
3222	3NLReJVTG7ibjmbQmsxKp31EYFQSw7mSDP2h5rShL4a83zbZpAGR	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	470	943	24	1	3143	jxducHzDFf6wVugyxB4VrSSdTC96XMRey3pH91orLJZWWrVFoMB	1674	2384	2384	1616368320000
3225	3NLqQJ1YmJQiUPTP1poUFsFB3d94Crtvvbk4QqBCeMy3N31CHMiE	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jxQ1j4zL2vXFB2JMQ4tRSGM6DucBJELsr1P7dSACVippU53pRri	1674	2384	2384	1616368320000
3229	3NKFbM9StnQGjMNprYsngtzkXBn4AGj7RHpthuqNTqp3ksPGZ4UP	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1634	1205	24	1	3146	jx83T37RPGX6MQ9fTyP8WTpXjwSZzex9vPQKrnmjnLNf3E86X13	1675	2386	2386	1616368680000
3233	3NKJRwoH7ihxSCFy5Ri5YHZppzSs762gvGxA9qHUTCrcJBY6DE2q	2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	1461	1271	20	1	3151	jxCBgyr3W7EbH3goKshGj5Epi1JdxprEXjaHvpTpknby2wJgi8q	1551	2391	2391	1616369580000
3234	3NKLpGKcraGZLsDDcwxpP5j5SRpx8r1fVEnc6Y1kdxWzG7TbrjFw	3232	3NKtSVzd6SnqzrDPdhUESk3U7Gw2qp9tUwnz2sRDntfco7aHSoi5	1402	796	24	1	3152	jxfXS7WVUiqGoCZbYzgnEATc6Rgt64bubT2rRtmgXwob7mXvZF6	1679	2393	2393	1616369940000
3236	3NKupiteyby5j47gMYqr6udtQ3EV1FJewHS4S9qB5x7wtGRtRNjU	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	1403	824	24	1	3154	jwFpRBvCXvwc1JYEEX9cyMK23QKimWnwJoWTNFTGkoiE3bzbEZd	1681	2395	2395	1616370300000
3246	3NLbVAN3ZZphXmjXAChKsD5egaZC71mVAW5eCJdj7iRhGg1RGRQL	3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	58	915	25	1	3163	jxK8ZDadKvnUow9KMrjiDVSJhL2pwBCbpY3LaqQjtFnCuoLq1jJ	1685	2402	2402	1616371560000
3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	3246	3NLbVAN3ZZphXmjXAChKsD5egaZC71mVAW5eCJdj7iRhGg1RGRQL	1609	1333	25	1	3165	jxZFb6t6ri9L4t8LtziPbt9dzFfNYPv2197zXGSX5BuXwgFNe8t	1686	2403	2403	1616371740000
3250	3NLRWC3ntkUCkh8SRzSDwoiF37nE3BVMboNzYz9Rf8rGymUGDPc8	3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	606	1295	25	1	3167	jwX39spLR9q8mUbkPZFeEWLLXTtArhryziyK17HMctwUfoDhw2E	1687	2404	2404	1616371920000
3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	3252	3NLoqpVzjYRJBHqctsgGnQf1hY3Wcg33v1oMWn2kcpZ9MVctQ3Kg	1440	1251	25	1	3170	jw7sgtCtTnBgxASKnV7ofaJPGrYCb3WCaJciYnQWTpDdKqgDKHB	1690	2409	2409	1616372820000
3255	3NLyKMTfRHP6o9wzC7yMromcQm55dk4LcXsLuM5RbWsjXfEcXGkN	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1489	1380	25	1	3172	jx42crHm9JmxYRhPHvF3Q9gWtukMzCDu7MoPeEoMJwJwCxnxWMZ	1691	2411	2411	1616373180000
3258	3NKjBau2LCZ6M35L53av68BYREyN8tF3YzKScwFjg1J5npGGA9D7	3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	1599	1041	25	1	3175	jxH8in4Y8s8RCqzzPDoWftfjoz8avdKhFenLymrD6maEfU6M9K8	1692	2412	2412	1616373360000
3261	3NKwjruKS8RZT3He77QThGo1PkrWAfCKPTSLtNmCNTvREAH3SuQ8	3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	633	1384	25	1	3178	jxRPVquuEzbKiHc3UXarkAJPGX8JXU74v7HKBaJr4iHXiRMbLui	1694	2414	2414	1616373720000
3263	3NKep4CKTNC9pY497pd49cAYkenTC4wTwR9JLtwTA9JxgNSSC5ZR	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1407	1395	25	1	3180	jxVYQNi5yMyyXtqEAm8LXhCdmuDGGdtoq6vT3ZaKV1zobVJE48A	1696	2418	2418	1616374440000
3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	3265	3NKvTfVb92HicFpLE2jaVAb8kH5EiPYQV9avccnc14hSv8Z53DCD	1407	1395	25	1	3183	jwr3av7jFeBd5ZNgkZeDMcyACvbYn2TBkzLond6kMD1sJoHCXP3	1697	2419	2419	1616374620000
3268	3NLEGQW93t6Vu2GfouuwdPKKBJDjwdqYLcBMC9M1Qtshvro5Mtft	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	298	1182	25	1	3185	jw7iF1jNWR84hg3XGq7LFJcn2NyAV9ZMLaMpxv1qty3GF15pn61	1698	2420	2420	1616374800000
3264	3NKgPiJz3y2tZi1HazaiQM5JaXcuFMcMbJjCbHHbMA7nGss75ngJ	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1448	1065	25	1	3181	jwH4pzYLfTJF8qy86YDEyPJn32UJ1HzPUj8Loo61ucmRgSpDhhS	1696	2418	2418	1616374440000
3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	532	937	25	1	3186	jx7AEgf8fs8DrzrqD4jjaYqZznjsWvG7Jdm7JMoYt1PfnxjkXMQ	1698	2420	2420	1616374800000
3270	3NLLBgVrqYwYLSVzv5LuDtaQuoaYpkPWcKySGm18EGo3a2NQ7mar	3131	3NLrPSkAekanw2RWhemJ8BhvtXdkL7d4Bza5nsXoRQ6oHr25Dkuc	1643	933	21	1	3187	jwmxvL3fD36sVA7MizJhPHANUztD4Dyzti4nqrC35DrHDiPcv1N	1568	2422	2422	1616375160000
3271	3NLY2tf7XZpyNSRSG4JKqTgmWYKqqBbGHE5oXm3bP4imT47GYt3b	3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	1627	1139	25	1	3188	jxnzp5r7zNvZbvXSg5P2xEfsDrc4yFb8dwBwEWFikagQxxh2PzH	1699	2422	2422	1616375160000
3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	1643	933	25	1	3189	jxXLP8Y3f5DiJzggtWvNT9fFfS2UJ4h1DM1F4kptczGCA6FThHk	1699	2422	2422	1616375160000
3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	1406	1393	25	1	3190	jx8Nr1Ar2NA4bz6MVVcUPiTHYzkrvHUynmrMpuWtgqd7oUxeo96	1700	2424	2424	1616375520000
3274	3NLmh5YDu87X1Q6WUMguFNzk2uDfGzBb5pVbsHZRN7CKEE9GCmpH	3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	1600	1126	25	1	3191	jwM51xBuegSE5gVEU4rDmzhGpJEdYbL3MkLCZHGpaRXRsDCW2yf	1700	2424	2424	1616375520000
3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	1589	1286	25	1	3192	jxZsxck7WoXZ2jYdrM6PZKg3LQoLa2PNjk7oLWPYRNT9LHbKdia	1701	2425	2425	1616375700000
3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1406	1393	25	1	3193	jxJdVdJCEF9acSr3VpXaqat8gSrAQ5kHmi3tPeNMk2N41Dkspcb	1702	2426	2426	1616375880000
3277	3NLSecrqxexWfFb1whp9FEa4Ng4yhfyDABoYyHEtw8FQQW4Y79PU	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1585	1000	25	1	3194	jwy9jZkzmUUbM1qiDYZTd94u69L4dBNgjzy6kqr6px6eCtpGvQt	1702	2426	2426	1616375880000
3278	3NLQjxDq32QfejAz9ttWQhEXMQnYdqrJSN6RYFUUdjRb7SUxWJ78	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1536	1313	25	1	3195	jwdKc6SsbynxM3SsjrNjQwRUzvZGKNivAT7fKXWrboXk4QDywGt	1702	2426	2426	1616375880000
3279	3NLnQDqUTUfbT8zZ7fUaPfMZTysYX5FqbGCk9RVoRm8cRBPwV9dq	3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	1407	1395	25	1	3196	jwYMjUyS6PPAmMAvrhWf3SKH9bAPWSjmu89SLYbobNDaV264DUC	1703	2428	2428	1616376240000
3280	3NKtfeVGEibFQyhZE9xfMcMTAsXXH8hmbD22vUJBmWetbCNSRD2u	3279	3NLnQDqUTUfbT8zZ7fUaPfMZTysYX5FqbGCk9RVoRm8cRBPwV9dq	1637	816	25	1	3197	jwmm5iPCwZNz1PZkhsXGwL658pVgYb8aUJtsnNZ2pbQnaf8xmCK	1704	2430	2430	1616376600000
3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	3280	3NKtfeVGEibFQyhZE9xfMcMTAsXXH8hmbD22vUJBmWetbCNSRD2u	1607	1222	25	1	3198	jwUAv9MC1dXF1vBtzpVG56JfvekVeB3fpa8s9LsFpp4RzL6TXQX	1705	2432	2432	1616376960000
3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	1560	1045	25	1	3199	jwJdsgTuZjzdGNJLwx2U2rJ4mQVxXKMdm5j58mogzLGKtMgUxTt	1706	2435	2435	1616377500000
3283	3NLmr69S3HqcNSAe66GGs7Cs6UcxWLY9YSPmLYzutvYnfYyQ3Df2	3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	1650	1129	25	1	3200	jx46aA24eCzTW9xuJpjta8DMAp9uYzyG6xEZVAb3Aufb75nqTK9	1706	2435	2435	1616377500000
3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	1541	1052	25	1	3201	jwHiSqGgas2VrBYGiUtVsq5KFU8FquakMMpswzcsF2kf6ciVXPY	1707	2436	2436	1616377680000
3285	3NLHjDm8hiLbgxtfrpxJca1YnAsYTUFmzmsHRNg6Xx58S88ictob	3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	1647	846	25	1	3202	jwWmbRMGaJ6558NNQHB8rZTrdrmUjUKbRmrBwc7zhXFPsx6GgcW	1707	2436	2436	1616377680000
3286	3NKtCzNjkM7gaibqxd3U7m4hFEvfSnN3ZgLQfanXfkfvTfrLjLne	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	1642	1367	25	1	3203	jxzcrfpKXqiuhBmmrURd2K1qcqEoHUUC2bLevEATjPpK2he9Xr5	1708	2437	2437	1616377860000
3287	3NLtWcb9GcspBhQhuyKdPPyypUB9ZAodz16bf9Bd2CxYQK6XPBoH	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	298	316	25	1	3204	jwRTaHatbDdC8oYXcZsCgeW3DGnHG92AzpHA5cDN1PsABQPRjqg	1708	2437	2437	1616377860000
3288	3NKGqk4sEPY7mM9WKxR1LHTxN9EKUJ9bXaM82eq3MU91MNxmWMie	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	44	1325	25	1	3205	jxj9PSu5VQRVNEggFa96GoRCBc7EaMYUATpS7xgMSJpDtod5WnC	1708	2437	2437	1616377860000
3289	3NKqUsSoLzWf3wsiZKBJW1qJDAnj3ughZRp193QHdLDn5hUyfF5L	2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	1467	1376	18	1	3206	jwRZ1UyfbDTsA7T3dEYL5P8Gh81ywBxeR7xmmSrZVM97e6yQrSX	1451	2438	2438	1616378040000
3290	3NK4QFs5kzaPin8VMG5M4SPsdVHr7gY6d2dCg6ht7uDF8X5TMVUj	2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	1467	1376	18	1	3207	jwnGkkBABGBvZcWNPuYAryp4cfEb3WYESFX2sLHYXCn1HAViVEC	1469	2438	2438	1616378068748
3291	3NLG3eaMHbvkcFe8Qu6HakGSMFoJZUHfQMnRX8rH3iMW8Zft9WUB	3285	3NLHjDm8hiLbgxtfrpxJca1YnAsYTUFmzmsHRNg6Xx58S88ictob	1555	1347	25	1	3208	jwvr7y7ERkE1vfnD2T9E3DHL2SBUF19nxDM25e933RwG9fKbJvr	1708	2438	2438	1616378040000
3292	3NKC5aVwbUmNLat4mpV2RDzdetk7FBUiVCoSRyH1AttLvbECzAzq	2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	1467	1376	19	1	3209	jwKVnjUKtvJdUNWc6giZakpPstyowJPUYegoLYd9uyc8MK5DfRU	1486	2438	2438	1616378096416
3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	3287	3NLtWcb9GcspBhQhuyKdPPyypUB9ZAodz16bf9Bd2CxYQK6XPBoH	1467	1376	25	1	3210	jxWVD1USGmjJ7UkwawyumD9ZGwrsG7X5uMVEsAhpCdCsftyG8wA	1709	2438	2438	1616378040000
3294	3NK7mJt29QSbayDzYEEPvX1z8QpYutykAxHETaxnABwYeMJt5j3Y	2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	1467	1376	19	1	3211	jxwvBAhoVax4nRbmRp6XuYppf2thfeywKrdpVKkoK33AioL1pmD	1503	2438	2438	1616378123304
3295	3NLcEGEUJD6yNrKfCYpXxwxJf7WoGB3ywPaUWeWNZcGiVGGyXtn5	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1467	1376	19	1	3212	jx5NyLhWpobKeQycTxGwdmYX9A76Du3fDNdy7xuTTvBVaas27XX	1519	2438	2438	1616378151316
3296	3NLdAqRTFaHWJgxJB8usDWkMPvTXL4xGhiz7BNjkPjGRfG7hVZBB	3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	1490	908	25	1	3213	jxgLx6GyFjkJdLtkUDFVmTN4CesfwvQUnQBFajcjWRHY99N6FLD	1710	2439	2439	1616378220000
3297	3NL5ywDVK8UHjbwjzeuNhCHeKtAsYLqfjnoQFHytiEE4MJcQoVGQ	3291	3NLG3eaMHbvkcFe8Qu6HakGSMFoJZUHfQMnRX8rH3iMW8Zft9WUB	1555	981	25	1	3214	jwvqBUV5YZ24ruf8us37FQXpoBuJHC9cY4q4fWfyYxK3nXxBrts	1709	2440	2440	1616378400000
3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	3296	3NLdAqRTFaHWJgxJB8usDWkMPvTXL4xGhiz7BNjkPjGRfG7hVZBB	1634	1085	25	1	3215	jwomTDPYosdD9r1ykfKVZsAH8qYKN3xNcFEcYoJM7G6XQD6Pkgj	1711	2441	2441	1616378580000
3299	3NLNDVbKnGw4YEQB26VHwEbsRB25bqW5ECe5J7iKwHCkM44pQRNt	3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	1403	824	25	1	3216	jwNP7JfRAp9jPyJ6HHtbr7ByfoSDwfKo2trR1YhfzF4Ngq6GAAs	1712	2443	2443	1616378940000
3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	1600	1126	25	1	3217	jxRr1mQEMqsjGRwmXCUEutSYabTo11uBxWfx8v6pTsqeJHqe5VS	1712	2443	2443	1616378940000
3303	3NKx9ioXAPid7KwYw1GdeLamhd4d85AkhzftD27ExspSYmowpxRN	3301	3NKwJWUDdHUvYnTPCUigR95GT3fmuGy1pz1oSiheJDkXHCM5nzX3	1460	585	25	1	3220	jxqWVU6LZj4irF4R926RBLoh3QGKnH61hbNvkazCbRHN4fn2uT7	1714	2445	2445	1616379300000
3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	684	986	26	1	3223	jwYGY7FqmiTQ6AoZofYaV8Jirg8wDdwoeZWrE352zS1MZtCkGX5	1717	2448	2448	1616379840000
3309	3NLQFFoH2pWfonFeeVKuMuQLTpxdwDBW9ksZAJxS4B9QeLGY7Hg6	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1631	794	26	1	3226	jwyiXfyMiRcjqqvPpe1WJCQs2yt5jHSPXNQsLJGyUT4PhAEyjKx	1717	2448	2448	1616379840000
3311	3NKMse4uYGXDG2dWUs2YEKghRv85i3QSuL23XcZmi2ouLzmQoDUF	3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	1593	1220	26	1	3228	jwT4Nqnt8PizNtX3uYtPxDVLu7zJRtuotEg4XeaWqx23jn1KnWS	1718	2449	2449	1616380020000
3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1403	824	26	1	3229	jwAS82TyLP1qEE9q7AQszd7wUPc5qwyubsnqhkgJDFKk8gGTMVN	1719	2450	2450	1616380200000
3314	3NL7JXyvFe7qZQaMTtguKBRS8gmYSeyv7kWT7XZSbnKxSPdKJ1a4	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1587	1357	26	1	3231	jw9GiPWM7MhQY4Ywy5US3EkbcsJydr6Zynwz4ZNNx5Lv5j3yDxa	1719	2450	2450	1616380200000
3315	3NLGQEyaUWNexMMnd3xoL9NC6BG6uTGGsx26mzd56Ti68EtyGcoK	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1406	1393	26	1	3232	jxrPcXDwcQYwQBui3AvfxeoYtT6Qy7jE9UVhEGQ7DtED5nCXyg9	1720	2452	2452	1616380560000
3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	3319	3NKZfUeUxW1vzrTLZKmpvjASeurKSCv2KboPvYAGgtZLw3DKHZcM	1407	1395	26	1	3238	jwH9DmbyHk1rLkyxeTZwdPE6TNPFjZC6YgygpMZFUEGw6xh4Vyz	1722	2454	2454	1616380920000
3324	3NL575Ejwt17ghEAVA2vdDDgTYznpg5bjtSVL4xgDKcL5jvyPwBq	3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	1403	824	26	1	3241	jxNQSjL1k76WLEsziejXDxewJjXpGjUjnCH2qgAdHX7zSrJ17Ww	1724	2457	2457	1616381460000
3327	3NKLkaMNr9RsgSAPsPtnX3WWVX1nQ7wrJGt1hrrbBHMUifsrwbpo	3326	3NKrLY4tFaSi9UnkpEBq87vEhmtoJGUPHidQuHVgRvi4sbGqQwpr	1403	782	26	1	3244	jwpG4AmcrrCXEx2zEPep7baJoJdDMwqTXgHEFXTr5Jqb8CaNAS3	1726	2459	2459	1616381820000
3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	3328	3NLmGPgQfVxv3vfpnMC31GDG5XNQKwwyVnp4S28cbdLUVPEK7bVR	1656	1343	26	1	3247	jxjwApTRpNn39DkzEfZy1vTwdy2vHnvuucgJnV7mRQ7zXEPrxWX	1728	2462	2462	1616382360000
3334	3NKJvdtN2WrUM83XyL9SBtgYu3uxyG9VkSwm7zb9yLmPG9a9wHBo	3332	3NKozBMWTU9XXTfRsFBHkAXkpWzPiT5PoA5H8e6AJH1imxymLmEV	1402	850	26	1	3251	jxjpdomoKopBMzXPexUFFnJoE9LiHFoMdqgb4trBRgL4XPdvUWQ	1730	2466	2466	1616383080000
3337	3NKAmqvW8iRLGgv48e75xezp8y13sQyVMnrPQjsr7yNjtAyfEarP	3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	1460	589	26	1	3254	jwLN6xsrSS6pVXN7Goyx23TdZNTv9pCuNNiWx6qhbS4We3NMZoT	1732	2469	2469	1616383620000
3340	3NKcNYqgfgfTbendzpadrSrPukemtWite21euFBubKt12Fq6Xs3a	3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	1571	1335	26	1	3257	jwT3XtZPqXH5oJYrfLxFhucxVLR3kVYvvgzR3AZS9Er9XddcPQ2	1735	2474	2474	1616384520000
3343	3NKHEgmnavCGNb1thMpF8WSoCbvQeo4ZkdZCP9hfjfHkf8b4BsYV	3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	1637	816	26	1	3260	jwNLtMxaWVEayD2MrUngdDMVzd5L8bWfnh9xtww9cAUpbgoYNws	1736	2476	2476	1616384880000
3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	1617	1042	27	1	3266	jwKBxffc3b4Q2dYcbSsEhk5fEihvka5rkLxnwzmHm7vWLUPzh57	1740	2480	2480	1616385600000
3351	3NKghhLGwBKDEX2jAxE8j5iPmHkXAd4Nf2iGyJgFVLYkwhaHArwT	3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	1631	794	27	1	3268	jxRaD1Xafra7qPpv8mK5KdXaVMfY4ZN8deSv9CxxFpQo3e9xvjw	1741	2481	2481	1616385780000
3352	3NK9yr3jJuKEBPEmwnEnBxNCzohnAXQQW2WcrXbCGgnSFVs3kZi9	3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	1637	816	27	1	3269	jwQA9UJULv737dyv8Yoo5QQiFLbjBVK9w4FtVYKo9RrCuajtfEn	1741	2482	2482	1616385960000
3355	3NKAPVG6X9t9FniGcaiP361dsKfcTtrXtaNtXmAHcgSKREQacfvY	3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	1670	1156	27	1	3272	jwZ1JGPHXKFZePSfKcBDCQXiPM8y5x2bBZwVsYZH2SscntaH4KB	1743	2486	2486	1616386680000
3361	3NLt5ivkq2wNkaowSG9Cq6mkHSWMba7DEejJwvNvWF7HiwiUHkEV	3360	3NKoPsCBSzohmL61ty2FxcrHM3D2NhY4BHzQ5Jj2DHz1NodvajTH	1613	1349	27	1	3278	jwfX89RWEP6sY4WxVEt5QcPocTKgKCBUGc9rv3WwFeiszMQ5A74	1747	2492	2492	1616387760000
3364	3NKXSL2DGbbm4yceC8UPVVHsYdy7MmkEMDqGeZuBomBj1GY6yCXB	3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	1637	815	27	1	3281	jwrFM9XWYfEQA11jFuPXaPA1qvvi7izaBMqpWNTqJYAr9gzGcaH	1749	2494	2494	1616388120000
3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	3366	3NLPBJfSjfRkdWpt8D3uoe8dK9Bj25Q3brVNfq6TSXRT8q9kuPWV	1653	491	27	1	3284	jwiAFqJrM3GYik1m77JpnodqYecciofU9oqJ8fc2FPCxT62zra6	1752	2498	2498	1616388840000
3369	3NL7UcotRHMJg2kyDffy3PNH2U95JqQU7hvMpRZDqr5oW1Bp7d2W	3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	1476	1245	25	1	3286	jxs64QLJiTLcRTQ4dG3rP2buCjvVAmZs7AbSu7L2TFZRyA5SRzM	1703	2500	2500	1616389200000
3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	1476	1245	27	1	3287	jwWVtVwQHv9wEq8yVAyugMLeYqE6u6PxBB5sHncnoJXYYUyeqkc	1753	2500	2500	1616389200000
3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	3372	3NKnjDxZ5CHkfGCPWqwN1REPaZk4GMbsj9JfDcRWKatqxbSD9A3u	1405	873	27	1	3290	jwDekESfJuNijrLnqoB4QGqWJ3ydAUbN8yJjj54JfmBF5sWYaz8	1755	2505	2505	1616390100000
3376	3NK8oWwyEYQjeYZ4vNMT3UdFL5tJWoPKzNJzQiBE7ZBrHZrcne4q	3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	1506	1373	22	1	3293	jx1ajxzmBC5BZg6CxqNCtzPzyX5SfemmDBevaazkfWsk1bsHk1H	1611	2507	2507	1616390460000
3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	3378	3NKvYFCR2gPk83ZbxGPKe6zzQYDJvHmVBQfMoRJyrYb4jw4eVfVL	1594	1326	27	1	3296	jwqLSurGNznuEV82WSUWdF2RA6ConaRWH942CytbQZqp4uveiZp	1758	2509	2509	1616390820000
3381	3NLipXV2zsrQBEeRzXJTSdwuJXD7qmcZneiU8igeusM5RrZEcZPL	3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	1451	1046	27	1	3298	jx45k3Q5CP2b4oub9ntTL88JWBaytdFf5z9uq3s3obb7gWWV2KV	1759	2510	2510	1616391000000
3382	3NLvyDSMQ64w3YG6tFTtY64Jpkg7aowfzGbFLEL1NrwivX5gw8c8	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1588	1146	27	1	3299	jwkz8YybWus6cBfYo9yAZXqtA11Qn7w4WKyuL7Xcsd9oPNQezhp	1760	2511	2511	1616391180000
3385	3NL2QTvbsj2ks1qWuJaG8ASdBD173Zn6PjMrq7D76RzeiWPcvPUJ	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1483	504	27	1	3300	jw9XCQTzqD55vSGNozDG5ac5ryYwEkD3rS15X9NgYi3kRhaVQDG	1760	2511	2511	1616391180000
3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	3387	3NL128JTdSaUVHKzZxNJvBpru4SPk36g85UxsPcqizfcYDuTcNwD	1402	866	27	1	3304	jwgSSE1cvxkiXFdnGxdsjYFH4Zxjtjp93Uayjihz4ACocPncqu7	1763	2514	2514	1616391720000
3301	3NKwJWUDdHUvYnTPCUigR95GT3fmuGy1pz1oSiheJDkXHCM5nzX3	3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	1397	838	25	1	3218	jwn6Lpe5i8xvYVNHEmzb37Ng11e1fqR1vMRj4b4DDGnVCXLz6q2	1713	2444	2444	1616379120000
3304	3NKxRZPxN24sZnoeRerfgcc4LFASSUgfzg7x74ssV6dd1QLQozYY	3303	3NKx9ioXAPid7KwYw1GdeLamhd4d85AkhzftD27ExspSYmowpxRN	1401	4	25	1	3221	jwJx1vrMvfCkMuPnyVVdBvZKMAgPSrWGdUMGpoDxTwwzjQc5pCS	1715	2446	2446	1616379480000
3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	1407	1395	26	1	3227	jxNTKJ1DPKxKBGhbBswNfPQ1jj9H29SQjDNKpjbD4WrJENtWYFz	1718	2449	2449	1616380020000
3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1407	1395	26	1	3234	jxUuqsTSD9NLwmDu6AhKtmhDEb8fcLr5HqKe8wHjtkykD1kFFZT	1720	2452	2452	1616380560000
3319	3NKZfUeUxW1vzrTLZKmpvjASeurKSCv2KboPvYAGgtZLw3DKHZcM	3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	42	1361	26	1	3236	jwzFfa7QpZoLyijwRek9ECWRam79xEHYX4pPK2LcKA5pQUKyhLR	1721	2453	2453	1616380740000
3322	3NLEdP952T7ZzNEkoazFetfhSxkKh1HXwaUvf4aHYf18i8zc3Nzu	3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	1578	1296	26	1	3239	jwoPryubvkWfSUXswPseGM7kN7SQWKJYYqzEfK5fHRpGtW2N8WT	1723	2456	2456	1616381280000
3325	3NLXMKAtzi99rZa4A6FPY5Qz9VgNphzyFkcqoT1VXyibMZve8rr1	3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	470	1183	26	1	3242	jxQRZ7r79z1xtQfiTiFpsud7SHZesyinoWE6X128mTMhMaCJaaw	1724	2457	2457	1616381460000
3328	3NLmGPgQfVxv3vfpnMC31GDG5XNQKwwyVnp4S28cbdLUVPEK7bVR	3327	3NKLkaMNr9RsgSAPsPtnX3WWVX1nQ7wrJGt1hrrbBHMUifsrwbpo	1405	867	26	1	3245	jxHiX1X1w5HytA4r88nFxTCysAW15N8oYHzocvH93Tk4A37Vfxi	1727	2460	2460	1616382000000
3331	3NLXwemPCTXJC3j5JekbRetJJGdY5HuM8fHVXMkDAMREeU1ExqpY	3286	3NKtCzNjkM7gaibqxd3U7m4hFEvfSnN3ZgLQfanXfkfvTfrLjLne	1513	1133	25	1	3248	jxi6mbUH9PCkfwpEN1mDWMM7eqBESMcreHu2TfxiZXDvLANCf2U	1709	2463	2463	1616382540000
3332	3NKozBMWTU9XXTfRsFBHkAXkpWzPiT5PoA5H8e6AJH1imxymLmEV	3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	1642	1367	26	1	3249	jxWiKsRsqe3CxXDsDi1ZyyM1M7K4okg2w7VowWVWGWYZWzRX8BM	1729	2464	2464	1616382720000
3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	3334	3NKJvdtN2WrUM83XyL9SBtgYu3uxyG9VkSwm7zb9yLmPG9a9wHBo	1406	1393	26	1	3252	jwPYhZgzViKazFB2Pdwe1WmXVnkQGGQSmyXXsirF5dTSSUyVqqe	1731	2467	2467	1616383260000
3338	3NKYEqTKGxHRtnDywmJPvdotk7T5DBuDtVBdVM4R7t7XpsShV9gd	3337	3NKAmqvW8iRLGgv48e75xezp8y13sQyVMnrPQjsr7yNjtAyfEarP	1407	1395	26	1	3255	jwoevpkDatFBkQCSZybRwgwRtw1KbhuEXkwGb2cctRCcgUvmtCW	1733	2470	2470	1616383800000
3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	1553	776	26	1	3258	jxDMXLYnW3atqpm4bsY4NqLA9fahDjrLXKLrLjAgWdrSybiRAaL	1735	2474	2474	1616384520000
3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	3343	3NKHEgmnavCGNb1thMpF8WSoCbvQeo4ZkdZCP9hfjfHkf8b4BsYV	1509	1320	26	1	3261	jwpzBi6wZLh5SQ21pbtzmXcBDuXsS7EBp6JYpMakfqghQtg5e19	1737	2477	2477	1616385060000
3346	3NLGjpvveZhBFgeMTmoUJLZjjoX2Ugq2wmcJWprq4PZ38ZdkHmqx	3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	1516	928	26	1	3263	jxoj7r2b2o95dv3pdoPRQN98YSGJNdQM25p3wUHHAXd3VBpgrPe	1738	2478	2478	1616385240000
3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	3346	3NLGjpvveZhBFgeMTmoUJLZjjoX2Ugq2wmcJWprq4PZ38ZdkHmqx	1607	1348	27	1	3264	jxG54GWPaQqnPgUz5jq8fE3kBz3ymaUDYfPnrtPrih1k8Z7M7bh	1739	2479	2479	1616385420000
3350	3NL9sMa9s9WQX9FU3unfZj9HsAfL4moGq2MttiiQ17eh1vPBeMB6	3176	3NK5JHAvkqPdj91tJsReTbKAHiSFZNqwByy3ojtP1C14fF36VCVD	1611	1341	20	1	3267	jw7V28F3MotnADUUCvjTF45cuRXXKWSky9NBMiSWWYTuPnCgMPt	1532	2481	2481	1616385780000
3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	3352	3NK9yr3jJuKEBPEmwnEnBxNCzohnAXQQW2WcrXbCGgnSFVs3kZi9	1504	113	27	1	3270	jxWsCUTjRNsivYjL8WCGw5BBKh35ZXpjrg3nJRkuDukzAhgLtYK	1742	2484	2484	1616386320000
3356	3NL93cnZ4QMs4Ypx3A7mngJvSzV9AHTSPAh7vs3bXMt5WoLQUEDP	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1458	1323	23	1	3273	jxbh68qQWM2ciVM3aoc325crm6TSeB7NpRfZDAU45v6MspDczVm	1648	2487	2487	1616386860000
3358	3NKmjVu3BuCTqZptcy3SHinRuVVvA9AboFNENQ5KAyyK1WbxMGdh	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1458	1323	27	1	3275	jxEBQGX5kwCdqaP8AkHLKzEdDxFbVTRVySY6rbkwndfme1P3bw4	1744	2487	2487	1616386860000
3359	3NK9cVYCWZoR8NBt7gDsHypUwMc9evmN84dN5LBRgv6NQn2sm4TQ	3357	3NKbvChF886jw9k3NtrNNLrKenaQB5gCm9DCfWhXwq284hMAVg1t	1631	794	27	1	3276	jwNYa3tAT4aDX29abVgdM4KyALXkc65zUyYtcjGCia34DpurskT	1745	2488	2488	1616387040000
3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	3361	3NLt5ivkq2wNkaowSG9Cq6mkHSWMba7DEejJwvNvWF7HiwiUHkEV	1406	1393	27	1	3279	jwSGrjL9hw8SdtVz8NAxwqr5KmUvM5oF8im5Dkece8dTXPw59Yg	1748	2493	2493	1616387940000
3365	3NLMVMgPsMD8phz9Qq6JCiC1sAhEFhPZvsPHboDT9CowUE681SVt	3363	3NKZa4AykbtJziwhKSqB7ZJshMV27vYU7FtDTk2XQwdtYKAUhJd1	1656	977	27	1	3282	jwjbThCL4c3UcYwxo7UprqV4oKyTGJL7WMnygh13DTjgZJyGAK2	1750	2496	2496	1616388480000
3368	3NLUVS3nmeK8XXsY4AtRvuamseqtELNJ1ign9QDuxyw27s98ieD7	3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	1581	778	27	1	3285	jxBNrKhMkvJw9Pu1qPWHYtHHhzeSHb63FZFsMqYdz8s2KEK4drv	1753	2500	2500	1616389200000
3371	3NLmfkiuWn88haRJo7AKMS5T5Jm9H9QBrTmwZECJDs1qhY5n396j	3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	1406	1393	27	1	3288	jxUPrhviN2aJcCEuzwuRw2KFiUomz81pkCb38WWRDLmr3yhnSrH	1754	2501	2501	1616389380000
3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	1471	1140	27	1	3291	jx94KfBRiSnLMQT2vZHmXRVZZMkByVDeCbSRQ7u1qBVJWnXxJoj	1756	2507	2507	1616390460000
3377	3NKBj4mLpVzar3dME1cYMjz8onv7d5Q2cdyYu8mz6ebu2bz75TiX	3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	1527	927	27	1	3294	jwcK3GosJtdv4paLwSEoq1tHXQPUQB7j2DeU86K5oEgXXTF8RjJ	1757	2508	2508	1616390640000
3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	1405	889	27	1	3297	jxNFsdwi724nTPHH3yb2i7V3esjjGDNVMmv7GSFhpeGB2uLfMin	1759	2510	2510	1616391000000
3386	3NK4jn3eEKu6Qsw4GaD4BSi7fBGLFWVLAhSJMZNeLKQzdBypVAXX	3384	3NLxmWRaw5SoFH277fNbSnFGjSnXjBPZUGTm5VNo7354UzkjXkLp	1406	1393	27	1	3302	jxRSwHSvEm4yV66HEsns2MR1hQ82hDAyXfnzfPcWMAir4sS2PuH	1761	2512	2512	1616391360000
3389	3NKjcKQGL1GjhsRZEMvv1HMYDotAcFopdYf2cg8HNRBANCFrobhe	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1523	955	27	1	3305	jwZuncW73SfTNTMtXT7EEoKwoV1hQBD2wtonXuM3Bdcoe67ZJBK	1744	2515	2515	1616391900000
3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	3390	3NKAE2L8GmMJp7GiJamD1qExvmuTCcudc8n3Pxm1Cxe2AT3wUkcw	1444	1015	27	1	3307	jxBGv3fCF55YLKSGSrwqykDxagGp6TR8pWunntowJ8fZdK99CSZ	1765	2516	2516	1616392080000
3395	3NKqdNAb7XTfXTd2BKdXK2d1nAsHEAy4vi4yLV3hGHHbR5ma1RHa	3376	3NK8oWwyEYQjeYZ4vNMT3UdFL5tJWoPKzNJzQiBE7ZBrHZrcne4q	1506	1127	23	1	3310	jxC9p1oome9P13yz8Za9NvWtmq4KeKHhPkQZrinBFTJUd6cdnV6	1612	2517	2517	1616392260000
3302	3NL9Q2LPfQ74rwmYavQ3rQKVzABTAG9PZ4iJtunVUV13KwX6Gs6s	3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	298	1308	25	1	3219	jxW7tGxPGtQY4VeNFVwePEvK5hKuyFJ85NR3B7Jb9YhTKNDDbZt	1713	2444	2444	1616379120000
3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	3304	3NKxRZPxN24sZnoeRerfgcc4LFASSUgfzg7x74ssV6dd1QLQozYY	1406	1393	26	1	3222	jwD3A8pjvsWnCH8MZq6yw6QcBaYJjHNXyBp7qQPXiU68JQyHx9e	1716	2447	2447	1616379660000
3307	3NK7VKpb2f8RBDA4je9GzquvpGp7ziBaumfhE4enXsLULPgNkjpA	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1460	637	26	1	3224	jwUZsLvqgvqCdnVLf2DbZoznoz2mwAyqBaMibiSV2F87eaDGM2n	1717	2448	2448	1616379840000
3308	3NKUhNgUtLdDsEXFpjCjgwXrr2DHdSc6YgUQvo5Dw76GZmuo8CjP	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1647	1302	26	1	3225	jy1ELeHspPr1UKiWeqFJMRyyBokkASdt9gZezpMuBgtzSCtS3TQ	1717	2448	2448	1616379840000
3313	3NLNn3HsQmdcPddLxNwiDXDRxBPrEB1w2pVinC55QuNjnvvvCGZd	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1489	1134	26	1	3230	jxb7zryjAwXfaisKw2AQHWYrq5Xij7Dq4h7ZCss8wHPSq68gL6m	1719	2450	2450	1616380200000
3316	3NKXk8yMfZrQ8sbf8NRRmo4rakqQmudu2qWZRrRyqSmzhghjeniz	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1403	782	26	1	3233	jwwSRqRGtDj63GznQ62k7PxZVDVAKzu6KSDNbNSRaP2bSj5o35e	1720	2452	2452	1616380560000
3318	3NL4c4H6k819kEnQFjpdz39K7TazTmqGrtenDrwY814vFZnQedjW	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1483	910	26	1	3235	jxcD3mwBpookFY3gso7ucRVCxwwfQoGWTjmgLDHRNSrqE8vtBGU	1720	2452	2452	1616380560000
3320	3NLfjVistpYvjYaa6waTq3n8GMnxCQTBER7rS7vAVWCF9rdRws7J	3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	1599	1287	26	1	3237	jwNFwH8K7jxyLrGEgAoxavdc3QiESPTHzAdGswmCGmz1ae2eqbh	1721	2453	2453	1616380740000
3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	1637	816	26	1	3240	jwBrHp8kxev5v3ggrQRFfHG9UNt1YnWtvocQVoHSpdAoHcNjdJM	1723	2456	2456	1616381280000
3326	3NKrLY4tFaSi9UnkpEBq87vEhmtoJGUPHidQuHVgRvi4sbGqQwpr	3325	3NLXMKAtzi99rZa4A6FPY5Qz9VgNphzyFkcqoT1VXyibMZve8rr1	1406	1393	26	1	3243	jxr8P9iN7JHr73LJBZHgDjXfDbNN67T2MyUAYFBH48o8nbotTCh	1725	2458	2458	1616381640000
3329	3NKr2x8PU62w2DzFqQ6AxAWu6TGKWcEqjNfEnhkyAayTxAXjAxPA	3322	3NLEdP952T7ZzNEkoazFetfhSxkKh1HXwaUvf4aHYf18i8zc3Nzu	1440	1377	26	1	3246	jwM3anRnBHkeb6kuicG7HyWcEW1DbGySbJyrKGGbeVssZLm9vA3	1724	2461	2461	1616382180000
3333	3NLSbH5yoSQMmBEMaqBX7GFcwrGd8ASoMXVCSKo6KhxDGLBnx7ME	3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	532	1303	26	1	3250	jw8v77ou6Kipjkj5EQajDB43WbNwBZf2cH6TGGBbHdHqDa853xY	1729	2464	2464	1616382720000
3336	3NLU8bpYk2cVuBuaY1diMjS1bQtRbcaNkpLek5FaSB2NRLPE1pBy	3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	1444	1135	26	1	3253	jw7Qi4yhYa73CaLZiNoZ2ZyESmkDsfBZJez5K4MBMwqK4uCkrZY	1732	2469	2469	1616383620000
3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	3338	3NKYEqTKGxHRtnDywmJPvdotk7T5DBuDtVBdVM4R7t7XpsShV9gd	1406	1393	26	1	3256	jxpgM7eAtrfRKyfQmYJeAzpBne6udpLB3MJEr1dphbeH4mxQ8HK	1734	2473	2473	1616384340000
3342	3NKz3f63KHDWXPUhouTF2VdNitkscdKfFkod627dh1xrSzvspzGz	3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	1522	956	26	1	3259	jxrdRVXTjuhTMypxDsF4PFTbAwQmQeShxg6yXarFJa2Snt1NnuG	1736	2476	2476	1616384880000
3345	3NLdW5YamTVUSHnVQM6EMB8XMRc48gP3zFfLcUgoPeirmXRpq2hL	3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	1457	1391	26	1	3262	jx3sbL6my6o8izEngmy7ymp5Y2JitAWpwEU6t6QehLZSkCpfJLy	1738	2478	2478	1616385240000
3348	3NLqso4UXxbhNC3sPEThDho45ZeMncTBgHm7i2j3W2HCvCUUbUR2	3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	563	1233	27	1	3265	jwgfZ6HiYuFxSYYbWGAvR8fTX5E5iAfNECbxy2zh342k3BYr22g	1740	2480	2480	1616385600000
3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	1406	1393	27	1	3271	jwnK2M3zUaFtKwUGE6s24YWF6rqAyY1JRwvp3DpVpHQtfDd8G3G	1743	2486	2486	1616386680000
3357	3NKbvChF886jw9k3NtrNNLrKenaQB5gCm9DCfWhXwq284hMAVg1t	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1402	796	27	1	3274	jwtwSE1CP6HerFFHpKroM5H76omHGf8u3TtKmHdFntkLZ3iniU1	1744	2487	2487	1616386860000
3360	3NKoPsCBSzohmL61ty2FxcrHM3D2NhY4BHzQ5Jj2DHz1NodvajTH	3359	3NK9cVYCWZoR8NBt7gDsHypUwMc9evmN84dN5LBRgv6NQn2sm4TQ	1419	814	27	1	3277	jwjY27Wx3hk6rDCkkbm2xo6U2JNQ8mW3catpHfDuwzBDimknXPp	1746	2490	2490	1616387400000
3363	3NKZa4AykbtJziwhKSqB7ZJshMV27vYU7FtDTk2XQwdtYKAUhJd1	3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	1594	1326	27	1	3280	jxC5Nso22W2hGAfqNZEz6sFaNrMqXCbyDqqzNVvKpTH3YVYfwDb	1749	2494	2494	1616388120000
3366	3NLPBJfSjfRkdWpt8D3uoe8dK9Bj25Q3brVNfq6TSXRT8q9kuPWV	3365	3NLMVMgPsMD8phz9Qq6JCiC1sAhEFhPZvsPHboDT9CowUE681SVt	149	1283	27	1	3283	jwdmXLTZwUXP1fTSZ83nqm16nHgQfc71nUbGjJnMapRX5BBxyNk	1751	2497	2497	1616388660000
3372	3NKnjDxZ5CHkfGCPWqwN1REPaZk4GMbsj9JfDcRWKatqxbSD9A3u	3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	1581	778	27	1	3289	jwmhiuoztFxpHiYDTxddp5H1K5ng2JKopaoJgCVPXRXcMTGZmDn	1754	2501	2501	1616389380000
3375	3NLd6Gb9dJMAWCmyPokxYRC8zmdy7qHqkLF9GY7C4oYU7wFM5AhA	3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	1594	1326	27	1	3292	jx45yky9MP9eq4d3CVpvbx2Fr2WtrKRo4Cma6EE1btYGj5hR5Yd	1756	2507	2507	1616390460000
3378	3NKvYFCR2gPk83ZbxGPKe6zzQYDJvHmVBQfMoRJyrYb4jw4eVfVL	3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	484	1319	27	1	3295	jxTw9L2acGgiiRVbUgmDcgupuXU7PQVxLfdo6Lt1S9XXK3f81we	1757	2508	2508	1616390640000
3383	3NKCgC6o2LRQExXJK7KhN3QKGMFgYw8hQYdpDr7V9nAKL7EkgBNd	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1483	504	27	1	3300	jwUM74YBZzKhn3ojWgoq6NVj84u1LksaEDcvU7G1hYqJN7ctJaL	1760	2511	2511	1616391180000
3384	3NLxmWRaw5SoFH277fNbSnFGjSnXjBPZUGTm5VNo7354UzkjXkLp	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1509	1320	27	1	3301	jxXaUWcW8PEufNbEpE16RM11FYnYXopH2HFpQx1V3XsVSYZWZiz	1760	2511	2511	1616391180000
3387	3NL128JTdSaUVHKzZxNJvBpru4SPk36g85UxsPcqizfcYDuTcNwD	3386	3NK4jn3eEKu6Qsw4GaD4BSi7fBGLFWVLAhSJMZNeLKQzdBypVAXX	1670	1282	27	1	3303	jx1mzbaD4Yiar7Wz5JP1gVv8whY8LSQFcUGj9ZMxn9tSULBrNyA	1762	2513	2513	1616391540000
3393	3NKFqJx3wooWkGc4aPZNafyFWjpF9aGpW4Ps94PQC4pofLR34uEB	3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	1407	1395	27	1	3308	jxJMTnhNp2iD9QF7ptDUD5DHt5M2dH633bttJg7PdyNsJgBbYHG	1766	2517	2517	1616392260000
3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	80	907	27	1	3311	jx8xt3A6T9qJRZs25D7Z6PvaevXp2u4FKmPzZRHhBzxVMsybh9a	1767	2518	2518	1616392440000
3399	3NL8PJzuGwkfgt5BtT6wvjf8FLPXU3p3vng8ETyWH7djUvhfj5aY	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	369	1186	27	1	3314	jwxWUqrcpgR3B9zyzoQPWa9odovgX1rPkmB49ub2XHpiw7wTGuF	1768	2519	2519	1616392620000
3402	3NLFMJ15mFUY5cUMms5UbqHDfhCcDLG87ksjh5QPRoY9ukMxrGVs	3348	3NLqso4UXxbhNC3sPEThDho45ZeMncTBgHm7i2j3W2HCvCUUbUR2	1426	1118	27	1	3317	jwki6bKxvQfePmZDxBWymwBHaUwazXuUDhebWJPMoSmNZDLDC1U	1741	2519	2519	1616392620000
3390	3NKAE2L8GmMJp7GiJamD1qExvmuTCcudc8n3Pxm1Cxe2AT3wUkcw	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	1523	955	27	1	3306	jxn4n3Nfykf9Fvo9iwQDm9kZhTv8zVTzkJXq5HL8K5nkHNruNh6	1764	2515	2515	1616391900000
3391	3NKzJ2XgZKvRcNvMztcFrn34o8Unmig9MPnUwbtxZUzFsFCf1yaA	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	1523	955	27	1	3306	jxQsPmg9VindpAwcu7FS39nefwTb8xZeTYxFaWwBy1BYCqNQhXG	1764	2515	2515	1616391900000
3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	1522	1322	27	1	3309	jxuqMpU3DJ3nEXaT6A26zAmD83dJTBjiozsyMVuZBumAzqV8Ggz	1766	2517	2517	1616392260000
3397	3NKdE4D1J6nfS2po1g9ctykoVXp6UmRK6nL4bZ3okwe7F1GjQXr1	3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	1581	778	27	1	3312	jwxmdKj1ma3f6146tLxoZQXwKwqbubAHQmrcpya1ZFdTV16Ug9k	1767	2518	2518	1616392440000
3403	3NKzGa6VhSKm6pkV7GJQunTXv5YU431ZZdmEuKzwkQYS8jg3RvQG	3399	3NL8PJzuGwkfgt5BtT6wvjf8FLPXU3p3vng8ETyWH7djUvhfj5aY	1419	814	27	1	3318	jwMnZvUFdFE3XVb42T7xiEsjVpZDoHmdU1N4MFKdfRapdhkS254	1769	2520	2520	1616392800000
3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	1483	1150	27	1	3321	jwYiXp1nc4DDk6K95h1MirgGhyEBxSvDcexHJQu9uvZiEHbKbJJ	1772	2523	2523	1616393340000
3412	3NKbEWvcFrL16aT5YFMKUJA541LMc8d3Fkn9iRiY5kuaFa9Ch5Ge	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	80	1273	27	1	3325	jw9z7pMAPXJixmg8K7tW3rSeL25rxeU7pHzNqSoS2JA5XPzhvh3	1773	2524	2524	1616393520000
3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	1406	1393	28	1	3328	jwdCTsopDznAyiUjq5bRFiFWomAXyJDFd5Fh87U7vcSsEC2Ryym	1776	2527	2527	1616394060000
3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	1559	1353	28	1	3334	jxhnJMdRQ67u65JCwG7WNhbiG4uSKcWU5vDk5Cdr2kmJPqMYmny	1778	2530	2530	1616394600000
3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1483	421	28	1	3335	jwn3EosjvoqQxjyws86c9kpUbwY63m18v13fw1VmtEf695v4CoY	1779	2531	2531	1616394780000
3426	3NLmkuMxNoBKHSsDtG88QEbkb1Cug25bKFNrxSet18gTsi7QAqug	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1624	1088	28	1	3338	jxPng4vXRajv5pJc7mcVg87scrEkREcYaUzaZDsgNUu3naG6KpJ	1780	2533	2533	1616395140000
3429	3NL44beFgMb9cepT2DNNd4aQAXgiJhKuq2r4KX4XRNbuUgbFmQPG	3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	1422	1091	28	1	3340	jwgr9NzEa3ooNZmSmo47BJA4JSdS9mZegbMXFipvUzFfybYW1wQ	1781	2534	2534	1616395320000
3433	3NKkFTwrUVotPTNuv78hJXkHJ6CkkMTppr3iZjrzeNatetKyKzcg	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1422	1337	28	1	3344	jw9GsJ1Y4ry7fg2ADhuU4UennKsKZAm6dP2DWGwYbMfs5cTZuu5	1783	2536	2536	1616395680000
3436	3NLeZbLt66KmCwFB1YLYeCezXKQZbgvD1ebgRw2RKs2RwumBQiMA	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1622	1356	28	1	3347	jwR45sQ8BbuZemrrM3UQ3EK8r2aJKDoYdJJJPZEWQhwJvWTRujc	1785	2538	2538	1616396040000
3439	3NKbkioSRhb9UTpwTd896fdquSVXm2ZsfomxKUGTQP3EN61jayM4	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1403	824	28	1	3350	jxxo71DXHTn7DxCradYk71P6HhStZtHb59atHKsa1a9NnXd6ZXi	1785	2538	2538	1616396040000
3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	3439	3NKbkioSRhb9UTpwTd896fdquSVXm2ZsfomxKUGTQP3EN61jayM4	1407	1395	28	1	3351	jxPXG5exBoTsQnq3XFJ3iG9Au3hdAJu9FBdTgdUrcjtRkM54ayq	1786	2541	2541	1616396580000
3441	3NKdfWn14kzbwNnF7bJsma9yQcsYmWsfa2xoQhhPaC3sCmhjuDz5	3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	1407	1395	28	1	3352	jxy8h1eQmT6RUGBhRQ4coMVSPjfaPt7Dsz32k9Boo7bqcF6vat3	1787	2542	2542	1616396760000
3442	3NLNiUHLXJcXMLNDYHiPRVjLwex8KdQEnEmKJ9S2wyG4VLLrHjZB	3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	1585	1000	28	1	3353	jwfU6GKMugqvBk9oVVm5WW56zZTikyNBndHHU8hCZTbvJqyqonD	1787	2542	2542	1616396760000
3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	3441	3NKdfWn14kzbwNnF7bJsma9yQcsYmWsfa2xoQhhPaC3sCmhjuDz5	1407	1395	28	1	3355	jxGcAt1pzTGZqqtdo1y5ZR2i3idBxaD4s6bgcAzZE85iX7tz8Gu	1788	2544	2544	1616397120000
3450	3NKmnYBSagsHSEaZm5sKdAQkLbuAh4gW8QS2PEkVBWsbkLoFVFVb	3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	1637	816	28	1	3361	jwW5bELh8D8YfM7arUBMVXZfzHFTQ6ABLL53auJfyKcML1a6qzA	1790	2546	2546	1616397480000
3455	3NLHWbWM7aBF8jUE6RjkVw8EFkUQrNxy9rE8Jxc1ZXjTh4ACgfL6	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1500	931	28	1	3366	jw7BiG1fkWpwh8LkGWgfBMzN1CZQf7hLUVVTXsK6a37JG6DjE4H	1793	2551	2551	1616398380000
3457	3NLJn95Ujtws5z3FrnCshrN4KafwdySVLfC66KCdLzmUKVrQdEKp	3454	3NKPXGgj9XZtG25vEyyjq8wtdM8uiLPNZGbqoA5xAKGFU9vCNaVL	532	1303	28	1	3368	jxuY6rqm4rYqeU178pd9wWptC7bDvRAf2q9JRUYUaPkMJWpYwWb	1794	2552	2552	1616398560000
3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	641	1336	28	1	3371	jwvUd6KHPTpbFm7PY3AMLJB7ZuvUksCwTS1aECsVtkrCY59Fst6	1797	2557	2557	1616399460000
3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	1623	830	28	1	3374	jwyMWvC497vqDZhLm4cHgohSowxau1xuHg7d7GseYE52EFJK8PZ	1798	2558	2558	1616399640000
3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	1402	868	28	1	3376	jxMk6HLSp22yh8UyDa12dgxh9GBLEpbLEB7F1oSwCTPPoxnCHtj	1799	2560	2560	1616400000000
3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	1600	50	28	1	3377	jwDkyxPjqMgj3cFe2isMv73j3n7Xa9gJ5qK2812hZ6VWVeDXhNL	1800	2561	2561	1616400180000
3469	3NKPPdsNbq7ZAD3ce99upzAa3QwptbzaXSXTkZKiqceb4znGjNbZ	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	1652	1069	28	1	3380	jx43BbammqRxDXudsAd4sENTddehTkRv14AdRNiGo9bE7CYc93N	1801	2562	2562	1616400360000
3472	3NLUtEB4cNNqUF5sEw2fx9YG9tvS1E8YtfLxYgvQueQi1wU1jUzV	3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	1609	1207	28	1	3383	jxLgQ5joL91dpXtzfTXd8ej5v7iN7CTrGZSPhkKvrW1kzz43Rti	1803	2565	2565	1616400900000
3475	3NKdAHVDVDBJVUbuuwBxqDeQovKcdKMHGNqg7oRVMHs8Djtvqmzm	3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	1652	1315	28	1	3386	jxBFDeVzBwj3DfkKSJU9JNAnt5vqXgHoF2adjAq5q6bkxoVKDXh	1804	2566	2566	1616401080000
3482	3NLwg9LjPgqk3nCfnKnaNG1csG2yF7vWsBES4CF6TZDwtgJBr9Sq	3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	1483	1150	28	1	3393	jy3BEQHJfrPHUgLnyt17YKQKtTCATaR58r7WhXYPKuA6ZPLzMYv	1808	2573	2573	1616402340000
3485	3NLp2ZnP2G424GQrW7sLfxaqE8nonK8mWYBZVfuWFeGhYGsXivhL	3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	1633	1390	28	1	3396	jx48PjQKMTWeHkZ7Jr66vvn3NziZXmBzc8Hnhb5wos4NVz1vKvJ	1810	2575	2575	1616402700000
3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	3487	3NKQd1HUiocSNXN2DbTwecVp5on5HPJabKKEVkDdMeLWK8SspUsq	1646	1108	28	1	3399	jxvWaJh1GcvqMcYxmFxKs7wdqMpQc1uApcQV3rrEW4W8FsyoxnQ	1812	2579	2579	1616403420000
3398	3NLvVtLHvjV1fZcJ3EFVyNAviUaj71gMRedbLHzhajcjZkPPgZyi	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	80	907	27	1	3313	jxbeLoaKvACtMZfpvPpD58P7zz42UJTxiVkiaaDGfEPuHDh7pvj	1764	2518	2518	1616392440000
3400	3NLZmQQ1dNkxJ4UBGGmLvxbqZY2mANCWJzr2vPRzCyfMjEV9TNyW	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	1402	850	27	1	3315	jwYxdRYezW9rP1i2aZjDf2CtprdZKEmTvmwWwP1QuyDxE4yG6wR	1768	2519	2519	1616392620000
3401	3NKcBrwC5xGCD1sJp1FwtGK8LfWnUcfJWJEL5mLw2DWUgkBHAkLX	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	1426	1118	27	1	3316	jwtt4h7QNBFskQEjr6qmKq5KgvjaytiR2LGcZ5BkxQcqdqt2rdg	1768	2519	2519	1616392620000
3404	3NLrAmsSJbpfyCWdWCj3ZMbYtYUm1QuWi6mZXApWbwaCRTG2WA7w	3403	3NKzGa6VhSKm6pkV7GJQunTXv5YU431ZZdmEuKzwkQYS8jg3RvQG	1647	1302	27	1	3319	jwZzJCSsv6Vkbzk2PT8RDEZzE44awt4Ex4xWx65GhDuzrKyLcYM	1770	2521	2521	1616392980000
3407	3NLWWQXPD5iN1Zw3KbsfsDybZ5LoviWvQT8WP35GQsPuegREzDvC	3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	298	1308	27	1	3322	jw9T2VW6YNZi9CSLc8hJUdg5BGZnEYhofUfJRUaEZ3kEmvQ7Twg	1772	2523	2523	1616393340000
3409	3NLX7a618VLjUSExsDycmHNb7W7FFQG7tAA2s7KW4PByuB6jfoaC	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	1523	1321	28	1	3324	jwNHctpWBMdDHa9HJb71nyLiWUFVtEYtdDZQT3SzZNm1Hia11Fw	1773	2524	2524	1616393520000
3410	3NLK82Z9og8PpiQHMjvGzEbMfY5UoiqcNQuP6y6rUayU85U3nLfY	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	80	1273	28	1	3325	jx71Rs5313DUgxGNzF9cjhxBmxaZatfzsdFKpanENJYMsELPMv7	1773	2524	2524	1616393520000
3413	3NK8TpN1QVL4W3sL4ThDPRAefNSeSQ3cQEvjMKfGNV75g2LmF4HW	3412	3NKbEWvcFrL16aT5YFMKUJA541LMc8d3Fkn9iRiY5kuaFa9Ch5Ge	1407	1395	28	1	3326	jxysfSY2BXsPeaXpFksPag7zaSEP86vfXGfhFv6BXbtx2vte26n	1774	2525	2525	1616393700000
3416	3NLnjpyvCqCgMYpi1uWyPx5Dvj3TTvXdN5tLPfQLRC8J92KVwyXn	3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	1675	1342	28	1	3329	jwkQ12sEVMTLcSEhMfDjDx8XegE8dKAitAY5svf2ksF2CFwz9ai	1776	2527	2527	1616394060000
3418	3NKakstZ2GvAh4ox7qad3k4ZgfCkFuWx5vxzuFCKb8i3198Xy91P	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	43	1064	28	1	3331	jwNQTj9GFnCL1f1whYeXFYnpxCRtgbRf3bNsjTF9A64ctctf7BX	1777	2528	2528	1616394240000
3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	1599	1161	28	1	3332	jxHSkEnu26poePSKhCARQHxuyRN1xjpC9HnVwJxC5AS918e9phb	1777	2528	2528	1616394240000
3422	3NLMA2bn8fh5vxvCTLdgznb5Zm8QNT4z4K8VVhaFAr2BEzoUvZjx	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1483	421	28	1	3335	jxXSbg2kG32XEJDxDptncRaVMsqzDYV986WFwbe9GME2AYhx5VZ	1779	2531	2531	1616394780000
3425	3NK6TrjPBquVDaJct8vkerYPS6veJxamwp5cA9jTNgUm4U6tyFxh	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1536	1187	28	1	3337	jwnY3ZqtHYNfwLutECnEJohHzRaakW5aBRh1BUG54a9jw9Wqquy	1780	2533	2533	1616395140000
3428	3NLqZj39DU29V6u1oxk9Di8TAk3b8LjfudfbKD2aLpEs7mNHF4aW	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1624	1088	28	1	3338	jxXEd7W8hNUkbGExz3Kj4W4exnSdPzTAPPjs2g6gxmYhY9j8JEf	1780	2533	2533	1616395140000
3432	3NLVneRautHDrNQz4axxSNHoVJJLFk25iX9QHKZy6DB8fdNWrXMS	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1406	1393	28	1	3343	jy11aimeu2BENodxrQxQsU7qRax3jwdgtRouUDwm7ugoC93vcgr	1783	2536	2536	1616395680000
3438	3NLiGFJ5jdBZWE3NdG2RRh4a3CoqQjHkpDMJgi7QWiKfgjE3aQo1	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1490	1028	28	1	3349	jy1NSwby2EUEyMQptJLnSifWLoQSdK9dmX8n2ecD7Z5CoozamuE	1785	2538	2538	1616396040000
3445	3NLapzyVDgEzgqv2Z7Tdtq5kLV9TmXNPZm1Z7JPZo56A1ZLu9ZzS	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1403	824	28	1	3356	jx2PFGeibRdA2ug27yDqWhzChTTKuozy13XF85iYkk1EgsmmqP4	1789	2545	2545	1616397300000
3447	3NLV63JbZwbstHdKFs6bPtq9GSMehan6rwK47bdQADa9Jy8ob8j1	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1587	1111	28	1	3358	jxk5oG9xf96qAStixbMhuMbV5WcY2V2ywJpWWCfWhH2pGjKQpCm	1789	2545	2545	1616397300000
3448	3NKXVYCW3xJTe8TYwv9FruyRFkAfUfXYAsfhkFxZL9FEGgEtWW4g	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	311	1061	28	1	3359	jxX5VtBFp7vJ6qkYVFPKJ48d1BrXTiafgygXAbpBTVC1uDvEKRL	1789	2545	2545	1616397300000
3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	3449	3NKkMJGh6q588bMTnUkgNkjv2cvp1Ybjyx4tLqHEHdP84q9ZtiPQ	1637	816	28	1	3362	jx2AJwZvc3GEBZ6gixyVhmPirETmWCnZoasmoSUEKE9CKd9YN2u	1791	2548	2548	1616397840000
3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	1647	1302	28	1	3364	jxrPeW2UqA67nZaNw5phMTHhBkck2e8RtEhPsBJ9ugavSusxhri	1792	2550	2550	1616398200000
3454	3NKPXGgj9XZtG25vEyyjq8wtdM8uiLPNZGbqoA5xAKGFU9vCNaVL	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1483	910	28	1	3365	jw6pQjCmuEhu2D6WS2EVHyKyUvvP1owPpkwZskHF7Vzd2uFZrMV	1793	2551	2551	1616398380000
3456	3NKSjHU35J1oBzQh6KEaRogxf3ZSMM1v1isCcVNuQirmn2whkvCG	3247	3NLe27sY13b3f2TQAEUDihUH29HxQfKu2fN1dMGfCqhiBgbjPf91	1500	931	24	1	3367	jxD4DrQz4zgUiohPLpg1sf7dsP21JHNjUCgm3DeREdTrgPhb7wY	1676	2551	2551	1616398380000
3458	3NLQkAwwBS2dzsA8xyURkLrSeGcP6WnwHDWvQHkNvftTWE4M1ATS	3457	3NLJn95Ujtws5z3FrnCshrN4KafwdySVLfC66KCdLzmUKVrQdEKp	171	1128	28	1	3369	jwXoi7gpQBj54qkVVdYHwjKc7h2FZfCzBMPWhYkaqfsmC7wkJjM	1795	2553	2553	1616398740000
3461	3NLy6Z6nCSmaGGJ5U2z7MFM3qivAgGDTQHJZkfdd9zaLK8VpV8rE	3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	1637	816	28	1	3372	jxPajeqjzwMgFHrawS3vricZuKYV1ENnChBtq1FPECsWsyN9tJ6	1797	2557	2557	1616399460000
3464	3NLemj4RxAoe7xGVfrtezaaLykwRtJYCRt6TcvBk1ZaCpScEAqLm	3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	632	1136	28	1	3375	jwa5pECy8eMHLMyETMNwPMTFLHnScBwLVXYAsb8imALXxMWZcuD	1799	2560	2560	1616400000000
3467	3NKCVyAhtf8x4gWFe91SgNkd6Dv3SuctnZAZ4J2BtNzQuE9tgHDJ	3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	1406	1393	28	1	3378	jwzEgimEEpdasXSfECAPSWDcCT6Pf5vBQTePa8atqh7Cqm5nFGP	1800	2561	2561	1616400180000
3470	3NKaK7fFfs6SM7xvw3hv738h8XB1SMaMC5rKTnSL3V56in9KrepF	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	1648	1284	28	1	3381	jwBUDZcsB263q43e57mpmrJQYoHivxznKEL6cLxwYdV1os3kWJc	1801	2562	2562	1616400360000
3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	1578	1296	28	1	3384	jxTqsuA5q6Q8bzhhYiRG4Jn87LirNX7Fy2qaeGnSs2c18xNLHfy	1803	2565	2565	1616400900000
3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	3475	3NKdAHVDVDBJVUbuuwBxqDeQovKcdKMHGNqg7oRVMHs8Djtvqmzm	596	940	28	1	3387	jxGV77QgNWBWsJfSSY87GptV3JXBCfUDkvu67rXyYXWARTKJnm1	1805	2570	2570	1616401800000
3479	3NLVxjLhZ1xYXmXeW4JGkW3KJSibwTpzDR1AfSaroPNgHwmJpA62	3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	1402	850	28	1	3390	jwNbvgG2ALPxBvNffMQKC2hiV1T815P57mriPcvj6Fvxm1vF7Qs	1806	2571	2571	1616401980000
3480	3NLZUqxPFoH7osryru2sRap46zV7pPPxnzF7GsuBbVBM4mh3TXes	3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	1564	1338	28	1	3391	jxG4mKAURjnWLzLhLjsjBGBTrHgdoaxfSstjoD3tCsmWY5FVF7U	1807	2572	2572	1616402160000
3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	3404	3NLrAmsSJbpfyCWdWCj3ZMbYtYUm1QuWi6mZXApWbwaCRTG2WA7w	1406	1393	27	1	3320	jwAcoSjoL3iYG6uAoawe5FdJrVZG4vY1xUvu1Q99Mwptpb7AesL	1771	2522	2522	1616393160000
3408	3NKM7mLerMdUY1MfncUkZ8X4e11SrsMJEBdV1QtcRJA4Ry6icyMn	3389	3NKjcKQGL1GjhsRZEMvv1HMYDotAcFopdYf2cg8HNRBANCFrobhe	1523	1321	27	1	3323	jwaYTtnjk2PCFhRoqt4apkUHpXGfgHmUCLdrqnXiEp3KjJY6LKN	1745	2524	2524	1616393520000
3411	3NLDVjey74yrzrp9Ds9DsAKgv8MijeLdTWsyFBvvEhNcLFGWhbMQ	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	1523	1321	28	1	3324	jwBGKdRNdn8ySFmdj61Ls4ZHJ7QJADuaqJUqBGh7pzWN4kYm8hJ	1773	2524	2524	1616393520000
3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	3413	3NK8TpN1QVL4W3sL4ThDPRAefNSeSQ3cQEvjMKfGNV75g2LmF4HW	171	1008	28	1	3327	jwg833aTszv5Ujg5ht2CfqZpUHRopLWw63ibz6ANXztmpgdJxH1	1775	2526	2526	1616393880000
3417	3NK5Lozj6tBDm5E618UaTFPT1uJMWTLs1KdhWnp89qyxFuiRiNv7	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	1403	824	28	1	3330	jxB99Yo1xoah5aAAmKFe8WpVaS6R9HQXPGESbmTE2nzyzc4uEE9	1777	2528	2528	1616394240000
3420	3NLVGYx2v1q5MGKjM8KFB2U6uS5uyWeGx1KdG4Nzzi3GFdmJnYLJ	3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	1593	1100	28	1	3333	jy1aSPpCH9dsBGGgoYhDSGEe1rbQ5rCrWBNTXEWSr4wQvKDvAzm	1778	2530	2530	1616394600000
3424	3NL4qT167Y9XNsJfyC8gduBApsiqopDAopNFo1xsv4su7NRULouD	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1573	1072	28	1	3336	jx4LgqtKRQBTJW7CkD7abNXLmZVdn8kimg9XfrYog7V1Pa5hYup	1779	2531	2531	1616394780000
3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1401	231	28	1	3339	jxEMXJ6BXtRxm5yss7WBQzsse8R13ymiU9DEngnm6YaVQxVkMW1	1780	2533	2533	1616395140000
3430	3NKPA5YtUgedJ7Q9Vv1hKeafwES8wYssyCsuDoVp3KMY9UCTGTmJ	3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	1405	873	28	1	3341	jxDrsXi6aL28EFTLowwz6PHTUxt4hdSNE73yxuZL7QeiowE69Yc	1781	2534	2534	1616395320000
3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	3430	3NKPA5YtUgedJ7Q9Vv1hKeafwES8wYssyCsuDoVp3KMY9UCTGTmJ	1581	778	28	1	3342	jwgkoEBH5E1Yx73MKTdQsH8aTbFBnMeiAYKNTtpADF4dsobXvZG	1782	2535	2535	1616395500000
3434	3NK8GutijWQw9JJcRBr9XC6YiDtDfRFPneSr9bDoXnmzav5PLP7P	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1607	577	28	1	3345	jxZAsWJUpaXruG4wRsA5KkUrbDpfn6eRmmjFzMoYoELEQ3tpVCK	1783	2536	2536	1616395680000
3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	3432	3NLVneRautHDrNQz4axxSNHoVJJLFk25iX9QHKZy6DB8fdNWrXMS	1477	984	28	1	3346	jwbvwuL5NAUpsy2Sw7pRR3iTs11YRi29YTHtC73XTpvCfmkvagr	1784	2537	2537	1616395860000
3437	3NLjevtA1nvWUsMWfsbN68XDNWu5G8Q7Ze1BjQuGXX5zyf8xkpCz	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	44	1325	28	1	3348	jxS66DsPRZUYkjbEt7Efv3aXC9RiCGDRVXH2qT1mcdfgsumQhQf	1785	2538	2538	1616396040000
3443	3NLFdQu8JyQyXWHkPHqKJG7X8agxB3ETyo3uwzsWMvGqDSTveNbj	3350	3NL9sMa9s9WQX9FU3unfZj9HsAfL4moGq2MttiiQ17eh1vPBeMB6	1611	1341	20	1	3354	jxzg99kGK3yp39oDWrw2yinhZxq5DK8M5KFzMthMJp5r9vekHf7	1533	2543	2543	1616396940000
3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1579	1389	28	1	3357	jxZRcoCrMo8dbG517H2DjGqrJ5Eskw13CYouFWezv35ctAX834K	1789	2545	2545	1616397300000
3449	3NKkMJGh6q588bMTnUkgNkjv2cvp1Ybjyx4tLqHEHdP84q9ZtiPQ	3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	1522	1322	28	1	3360	jwgwfxxtH6Qa3uHqR83mJfrR9Z5x6p15aSRK6L1NKDSg11btAi1	1790	2546	2546	1616397480000
3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	470	943	28	1	3363	jxrKs6jEhTJniz3fNm3WPngQbPzU3bCUdPMTsuwNhPguz5xRGPq	1792	2550	2550	1616398200000
3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	3458	3NLQkAwwBS2dzsA8xyURkLrSeGcP6WnwHDWvQHkNvftTWE4M1ATS	1406	1393	28	1	3370	jxAy3b3mC99vM77drAbkGrq7G74THCDkQCWkU6cBCHS6kwU6AwD	1796	2556	2556	1616399280000
3462	3NLWNt3SKEzx3Xu7aDS1PzWoP2iR14iYBDWgruVdvfczxTSu7Xwx	3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	1609	1333	28	1	3373	jx6DYsPzqutXNSQ3i2pynJighR6BMUjJzRDKh4dVNXagvRhubKJ	1798	2558	2558	1616399640000
3468	3NKA8as4uaXyx5VxkPBpYdHSpPjVb68v4Ytnh41HV9LhdeFarJAr	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	42	1115	28	1	3379	jxWQkJJkH7ssYCd5FNjo6PWoWLtZgosz1bj55vsCfYWAzHHFcb5	1801	2562	2562	1616400360000
3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	3468	3NKA8as4uaXyx5VxkPBpYdHSpPjVb68v4Ytnh41HV9LhdeFarJAr	1559	1107	28	1	3382	jws3ZMmfAJpdeB6QWxpSh6E8JEMbaxE42qfZhYqgfD5xP8PCLio	1802	2564	2564	1616400720000
3474	3NLtdeDXBoV4DDaPSUvb2FXbcpmoqs8gtrhxMZiJrZsCdf3zeFoL	3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	1671	1365	28	1	3385	jxbPSdudB9r25JrTa5hvtSfGyUhBKLfR9sSZ7LUvmFfxmpKSkeF	1804	2566	2566	1616401080000
3477	3NKzENY3vvWUtp7CqEr5zwcXq2SXrXu8JhVRtUNiGJr8PxkgauuA	3356	3NL93cnZ4QMs4Ypx3A7mngJvSzV9AHTSPAh7vs3bXMt5WoLQUEDP	1458	1197	23	1	3388	jwSjdeKQTUg56hepffhPeUu6Wv3A6Hw5o8PPasXwTtWzKQW5ssL	1649	2571	2571	1616401980000
3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	1458	1197	28	1	3389	jwCpe2mpSXAJVauLt3uxdMijC2ZxtGZSm8Xkxh9bvmp38otHoQ1	1806	2571	2571	1616401980000
3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	1460	541	28	1	3392	jxNiYnBXmCiGDioafTtaRm4SFXumnoiNPfUQHTrpEFCQTirEfb3	1807	2572	2572	1616402160000
3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	3482	3NLwg9LjPgqk3nCfnKnaNG1csG2yF7vWsBES4CF6TZDwtgJBr9Sq	1671	1119	28	1	3395	jwiK2wpVPanPBf2fiVpgW521uTxCWQSeCRnxu71Yg9jEMNNYyif	1809	2574	2574	1616402520000
3486	3NL4xRixF2td96c3n3WQJVjXe73gmpNHhCeYJcrQVRBAYjvbPc8B	3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	1668	1244	28	1	3397	jwQkmEchNYbvui6ZmiFzxEJhEgwnMm3aPk5dYjnkLP5E9bEP1Br	1810	2575	2575	1616402700000
3487	3NKQd1HUiocSNXN2DbTwecVp5on5HPJabKKEVkDdMeLWK8SspUsq	3485	3NLp2ZnP2G424GQrW7sLfxaqE8nonK8mWYBZVfuWFeGhYGsXivhL	1516	928	28	1	3398	jwGYZfJbM4vomLQjTscBTMxgFD8kNEq7u6RmM1JyMaSScbXG2y5	1811	2577	2577	1616403060000
3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1407	1395	28	1	3401	jwtUevYU3FcgrrFYYrgiKjWch6CsLRFhCdjfnvZLj85PsNXkzwj	1813	2580	2580	1616403600000
3496	3NLD1BqWqZXaVzXFu7RXCtXp59FTz4RPaM5HvuKG8uNHKCirSb4o	3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	1650	1375	28	1	3407	jx5BxFocFV9oEiRhbnqQhvPpbonDQ76N2XzwZ31ZNFc4u6f3dZK	1814	2583	2583	1616404140000
3499	3NK4BDLm4qfBo5rvhv2fHvvW69FGbmZFk79BK2yZ2xJzZmJy28jY	3456	3NKSjHU35J1oBzQh6KEaRogxf3ZSMM1v1isCcVNuQirmn2whkvCG	1500	1297	25	1	3410	jxPdvKxQd58ycW5mwcKFefjB1T9mzRRnPxZHRcKfeKCv5Lr2uXV	1677	2586	2586	1616404680000
3502	3NKwYZ2kS8L5m69yvdb8w4E2y4ua3DTGejgy53azNr1EF4TQ2HJQ	3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	448	1305	28	1	3413	jwURY3Zm55pTa6kCXGpNGzqm4rUWMFYSh1pWo1euZcPgxFXpRxp	1818	2589	2589	1616405220000
3483	3NLfp5FG2ehRAGiD7JZ2ygoNNnYaoR2oswW79yoFMP23YQoAduce	3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	1637	816	28	1	3394	jx52RrAn2Lte7tnKLDz9dmFd6RLxkcWPMNxMKqERdHtvDgDnAKW	1808	2573	2573	1616402340000
3489	3NL33fwXYJoCkX7g6bAV2UFMSHe9UYP2qPaDC1oxnxHnvG3qddZx	3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	1646	1108	25	1	3400	jw7Ni9BbaqEvpZ75eCU6PCK1cRBVt9m3XgPr9ivNxxCwBawn7mz	1701	2579	2579	1616403420000
3492	3NLJ2Z3z68s9nqHqC9xqL1tajb11Fko9EH2UyK1Cvm6vGfQvy4PN	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1419	139	28	1	3403	jxMMCepNTJAxS1gqxuPxhf1i6DswBCFndk8S48xeUxsfpua3rYK	1813	2580	2580	1616403600000
3493	3NL88Hje2DScLA9ZA2XV9GSePiYZPiyiBHWd7HxZDQvdg9Ryw9Gy	3395	3NKqdNAb7XTfXTd2BKdXK2d1nAsHEAy4vi4yLV3hGHHbR5ma1RHa	1506	1247	24	1	3404	jwQjZKbnPHTD3xqNh58MuXcocm5RC9s9MkJv7Y4GtuGXRiv6Tzj	1613	2580	2580	1616403600000
3495	3NKRg5jFPp7WJK8Avh4NnrcNGEzm4LdwnB4u8bCrLPBmcuRXjqms	3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	1458	1323	28	1	3406	jwbZ1wJPLEymNhhuKnshnwpGezh8e8TjDCZPjbE9TEE7bKcmuVm	1814	2583	2583	1616404140000
3498	3NLdLAMtUe6MdZ5YEmayrfdWysTM5bwSoZQMSPY5vYn75bzcvAg9	3497	3NLjHruLb7P5dxBkwYMEqDv5bW4CVHJNxzfrRXefb6sMLy2vZox5	1500	1297	28	1	3409	jxh8aB6ZnWJHRf8ssgGp3DbC3yuc39izgoxwJs8nu9i73EyDeqS	1816	2586	2586	1616404680000
3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	1407	1395	28	1	3412	jxVkWARvmq31PQA8h5BS8t55ndBxbfMvd3tHsxVa3nXo9SprZvT	1818	2589	2589	1616405220000
3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1607	1222	28	1	3415	jx4yRkYEwY51Y16Saep5qfmwqBzX1avjXc2UWnGceTQJk581ddt	1819	2590	2590	1616405400000
3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	1547	1378	28	1	3418	jxfXuzpe7X5KvQpoCbxLMAMUMYia5N6S8epoCv6cEnPhJpAMfw5	1820	2591	2591	1616405580000
3510	3NLmaZQoCoGHo3LmvTjurCtLmzKbeDnRCCVu6Gk6o9Dn5TPAcotu	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1581	778	28	1	3421	jx7qeozjke6zygAosfsejtSYgH7KMKNBswiVD6gfauByA7LfrvH	1821	2592	2592	1616405760000
3516	3NKfTQPdQY6SjdxwuqnP4w5q9dNq6jXNFJBEUQfZguM3N9gqhbnc	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1553	776	28	1	3427	jxcBX4MrQs1wMvZaHmFpuDv11na8kfZC52WZ6mbEFJit6EcWzc9	1824	2595	2595	1616406300000
3519	3NKY2A4LTwxPNrp5Hs7JvpqSWkXZucU96otLHQvYfcPmax2Qg8VA	3518	3NLCnLCsMubKgH5ZUDz2AZmgGiuEfoikNhBRmjoHdVv3CEHcAHM9	1553	776	28	1	3430	jy2uhC62NenqTFDWzvA8TxzEw2DGNtRXDs4hQAXHHxETRCePUqE	1827	2599	2599	1616407020000
3522	3NKMLdE7JK16VU97zCd85U6Tw8s5mFcKuZyjJcXJ7qANyJW4kRDY	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	44	530	28	1	3433	jxC569TLQsQD63Xz1svqjiu7zSBZe9KNPSTx9GLrA2PKGEHaams	1830	2606	2606	1616408280000
3525	3NKZpLjA8f1vXUhTzepKqLADafYeC6sJKtwznyyCwRMxWWnoqX29	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	596	1306	28	1	3436	jwyf5sAAGmHNBzsviiC78LGEnpkw9X9SubkXm4Ehe9ak5cYXFv7	1830	2606	2606	1616408280000
3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	3523	3NLDSRwh5yLjkyYTGGkNGNvQSBz6LudgzM6BHmzQAwcsHaEaWxAZ	1573	1192	28	1	3438	jxEhCNJfXykjni8spLKRGHLtd6smy9iEZVLwHnxH1TmcVfsdTte	1831	2607	2607	1616408460000
3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1407	1395	28	1	3440	jw9NsaEkKvdMQY4U3nS2LbeJkgx7eE9eHzuWXubw3V6AUJ1PPZS	1832	2609	2609	1616408820000
3533	3NKKLPsYnXJJcj65WLq9XSQHFkVz5kXcpvAYZWYBvjaQrm9tvc6f	3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	298	942	28	1	3444	jwPMvqbVEqrmPfPL6avACx4PfteXGk2fjscFCK879fPdyogEd2F	1833	2612	2612	1616409360000
3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	1596	1237	28	1	3446	jxmyraW69acYwNSfV345jt38QV82cKheJ7Q1cyXuyF7URisWuF9	1834	2614	2614	1616409720000
3536	3NLd516hRw7Y1ASHzNea4pmqnJHSraAgizBbKVVjvYTbXykr53oX	3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	1647	846	28	1	3447	jxSMnMX6WQCdWg1fk59RFVcD2miaGxmVFsn656soDLdych5mqXx	1835	2615	2615	1616409900000
3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	3538	3NLuWtCVegKsbgFiQfW4jEV7YVvfF6BL6ZeTYMk3Kj7GNMZgHgVt	1631	794	28	1	3450	jwPEzKvcNUSvnUH6GRehwP6ANy3TE6Pai5MiNe4KQBsZweBap1X	1837	2617	2617	1616410260000
3541	3NLXZqLecJU4Jvz8LjhNzGWQj2XcXexHThMGFqe36THniW4Cf9fx	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1407	1395	28	1	3452	jwyTbqqCtkDKhMbBWnKYJRGS5KyyxJXxm5aiDRJuWhxQayn3877	1838	2618	2618	1616410440000
3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	3541	3NLXZqLecJU4Jvz8LjhNzGWQj2XcXexHThMGFqe36THniW4Cf9fx	1607	1102	28	1	3455	jxAsz9X6PN5Q8FnneqEDXgDazxtrrddMAF2LiMftEAC3aBBsbGU	1839	2620	2620	1616410800000
3546	3NLdTPtyReGaBHLnu2RUnvddJwJPrHb6k4d7f85YAtzB7XUCYG64	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1405	867	28	1	3457	jxvGF4sWzjTLzp7PK89wEhfY8RsM5HehG1oQEeJ2An5QRtXkfTu	1840	2621	2621	1616410980000
3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1623	839	28	1	3458	jxWfScFdMWUXDpwqfGAxmdVUY1XBu5wvkBDQuJUwQCH6vWUJK9y	1840	2621	2621	1616410980000
3549	3NKEeCkruWG1kVeuF2iH11KXfXauQCcVDKGvZQNg84PzpNaQPpFH	3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	1406	1393	28	1	3460	jxAmPLvNN81gCeNVP6uA3pN2WWwddhswK9N77uBF2MopKJVuVkQ	1841	2622	2622	1616411160000
3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	3548	3NLCF8PB8zHgEDX4y2MqioEff79QsqNiRr7RgzrtbZNoHAEbFSNr	1650	1375	28	1	3461	jx2QXDt972DhFajuhCbUza7EHNijMb77XtaeyniP2oFmVzqVnP7	1842	2624	2624	1616411520000
3553	3NL9Zhy7cW2xMwoDtqsU44Bucc5Wp6JcFemBnqvsTDVpiiDZMswK	3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	1406	1393	28	1	3464	jxEFDNSXpN4WJjyRHCBjyFpnn5knA4eWB1w5gYbDaTHJGVmKPCb	1844	2628	2628	1616412240000
3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1624	1334	28	1	3470	jwUmKbfjB6va7W449A4W7JJvod95DWZfoPRfQJyXi1gvzqocDb4	1846	2631	2631	1616412780000
3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	3560	3NK9JE3C9oLgViffetZ95axcCJRnQw1xHxNiU6LX8BnDsFdrrkNr	1546	1339	28	1	3473	jxxMPSQihh3G2hornBRNJhNgM85z1QdtBMbMZDcVng8qK7DDcnY	1848	2635	2635	1616413500000
3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1406	1393	28	1	3476	jxQnN4CZycmxZAT2m8Xp59vfmA4JjUuQhZgHTAfFL5Z2gCMGpYj	1850	2638	2638	1616414040000
3568	3NL1xeM318smgd6cvVeMEX24juT1Lfna7v8NxB5b3Z7pLGewnXP1	3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	1590	1174	28	1	3479	jxKcsM5exUxRdQGLpNtVomAPziA9d4W62y2VbWvFiHJ853wU3cj	1851	2639	2639	1616414220000
3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	3569	3NLjxRdnnea4E4QiHrHMYtthB5vPPLKomQxxvLRCX3ecr1YQDePb	1407	1395	28	1	3482	jxEMdGKgJfZwHuCJFUBTyggty8qQ1y7bHhaG2ivL8FK89CqEPgn	1853	2642	2642	1616414760000
3491	3NKi836KNixjfNwntgaxSPX5m19sxqoqAdHpkNnEYAAwbpTRd3cK	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1406	1393	28	1	3402	jw8VpRnKYeBqBezgaiMKY7Hov6VESpGKFFDNXkZdSzenbQzvdA5	1813	2580	2580	1616403600000
3494	3NKpMzrpxcSxMJaDPUT1KqLkYUba9yH3RVEnabDdSbDDWyazERoZ	3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	613	613	23	1	3405	jwfr4UsZNPiQyEKcJj41zmsXtmXarmirEjSdjzhBDuNJhc6cRjp	1662	2582	2582	1616403960000
3497	3NLjHruLb7P5dxBkwYMEqDv5bW4CVHJNxzfrRXefb6sMLy2vZox5	3495	3NKRg5jFPp7WJK8Avh4NnrcNGEzm4LdwnB4u8bCrLPBmcuRXjqms	1607	1222	28	1	3408	jxe4XYoZsYd5wAhyZZfAK6Xd75twNeut3iWwr7x7oQgChDpo6kt	1815	2585	2585	1616404500000
3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	3498	3NLdLAMtUe6MdZ5YEmayrfdWysTM5bwSoZQMSPY5vYn75bzcvAg9	1471	1386	28	1	3411	jwhrBDdW4mavCytz9jLGwWDrFyAoESVENEQXHNgNJQuBkLWhgLW	1817	2587	2587	1616404860000
3503	3NLZ9c4gozixYsLEe8gHNTZaPEaiSQudPdmNKYweD5Ytsaz3M7xj	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1407	1395	28	1	3414	jxCaQDvVxsBMRkRzwHkodDa3vZNtKoutvBLy5mG2G9LMzD7M2RX	1819	2590	2590	1616405400000
3506	3NKVCynT2KoxEdR2pZP52GdvT8sGf6CHJxAr551wJEK2Xm9xWNti	3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	1668	1244	28	1	3417	jwD2VcZZgQqANjSxaRN3avLbZo8drhxvDq1CMCUCeuDWQxCXRJn	1820	2591	2591	1616405580000
3509	3NL76tANUefiGGd1jgwyUJmwx3xHBjcYwJUegJR7N1p3MriSexXd	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1546	1093	28	1	3420	jxusULpxcUU3RsUpwo7qZbvxHLaiSmrGuCimYdYJSWCggtFmXLm	1821	2592	2592	1616405760000
3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	1407	1395	28	1	3423	jxF52XWAVVR9VWGPkYLquNW163J2oqFNxnCKeJEDZ9v2Ut9ytyV	1823	2594	2594	1616406120000
3515	3NKrRXcTy3xjBhV5LzL2yCDVuAsHcKDSe2e7Ru4vkzwzpiPXUMLG	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1647	846	28	1	3426	jxctjkzMw95DF8ZLHFBhUSxx9tdEjafz9hQeZet7HcLtreNN46E	1824	2595	2595	1616406300000
3518	3NLCnLCsMubKgH5ZUDz2AZmgGiuEfoikNhBRmjoHdVv3CEHcAHM9	3517	3NLeZbFW9Ppv3LMQxevNFj5t4EVaSRL2QS9nFbqecah4z3SxmZFS	1403	824	28	1	3429	jxuYKLvD91eo2PMxxihbEXqhon94eLfAojY66QqEoi7K83pdxx8	1826	2597	2597	1616406660000
3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	3520	3NL3VeBz3CiAnJS7rfwxZv2w9YmB7XfDKAx2yKxEXf62bdCCztVx	1579	1389	28	1	3432	jxtsr1RAE6ePe962vssY9gHFQQaXauZE4BLE3E2nvV4azS7Me5i	1829	2605	2605	1616408100000
3523	3NLDSRwh5yLjkyYTGGkNGNvQSBz6LudgzM6BHmzQAwcsHaEaWxAZ	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	1634	1085	28	1	3434	jx2VfTLKyQCckU85dJa3jCdDjJQfZMr8aCVviUxxfVT96X3SKpB	1830	2606	2606	1616408280000
3524	3NK8Aiguw4DRYrpwRc2dmFkXJuxGrzsH87Ls7GLgB1mRTCJvSh1G	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	1406	1393	28	1	3435	jwZV8ygaKfkNSy5jjG54zo4dHAanb95DgHRTDPpwdoXXLZ7eVw3	1830	2606	2606	1616408280000
3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	1503	911	28	1	3443	jx4RpiTJcAgQCkncoFvynq1XnPanBQ361GYJMWSKsdwqS8QkidA	1833	2612	2612	1616409360000
3540	3NLqoLGhMCGQHVvFFKkmmDLmtZRB1QZRpY2NHRx4bEAQfrLnwx6S	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1476	1371	28	1	3451	jwHMQTAToaWXkY7R6RxLyDDiMttvYH71stj5XGyAXa4BNN4rZH8	1838	2618	2618	1616410440000
3542	3NL52oB1n5JTTGgjziNHyvfHBm24ceazWNE667kMj8YbtSLjicQu	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1403	824	28	1	3453	jxzHBJkW27SC3DM5f5HiCsTmkypQR4Au65dFgZcLjVZ76f8QVho	1838	2618	2618	1616410440000
3543	3NKWSAUeoqthPeZenfMTgsN7aYYFJ7eCjxRPyEd7WaCLSRZrKgVb	3331	3NLXwemPCTXJC3j5JekbRetJJGdY5HuM8fHVXMkDAMREeU1ExqpY	1513	1379	25	1	3454	jwR6boNuoKW7SrUiSNQZo5oCGeCMLiHtr8GJpBeNuToiR2KoZVa	1710	2618	2618	1616410440000
3545	3NL4KmdJDC1TS7e3X24tRPjmfUiZ7hiDUCRzTAGvNWtrYDDsuUz1	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1422	1337	28	1	3456	jwdrQRGvdcWwYWYAjXAo2fARTRdwxMai3FRRyQJrUFeEjGBaqwA	1840	2621	2621	1616410980000
3548	3NLCF8PB8zHgEDX4y2MqioEff79QsqNiRr7RgzrtbZNoHAEbFSNr	3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	1476	1245	28	1	3459	jxgtx4MGv3j42rKCyT186vBGbLc2TF7b3Aq8j2ZMjFWBFVfy2vL	1841	2622	2622	1616411160000
3551	3NKdza65qYeSR1dDi18Y5t1hFnjS4aqoGjKvBUsVgQQsZuPAJ3cA	3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	1406	1393	28	1	3462	jwa8eWrhdV7svujFE3cg9NuDA97JRTfyocJUdy7oS3coLNkywEc	1843	2627	2627	1616412060000
3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	1585	1000	28	1	3465	jxB6qVh9TQLuP1MJV2cyRBVewTXRYDSSzpcaYyWS9NZBha9QCAb	1844	2628	2628	1616412240000
3556	3NLxLADuGJNWiup4Pk95VhePdCkMkUsb8QpHRXQMtg7zqehDHZSD	3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	1581	778	28	1	3467	jw9NFhRhr5gPq37jg2wPuoNyot4V4zviSqtvaUW8GnHNSw7QaXb	1845	2629	2629	1616412420000
3557	3NL8LGyoGeN3M98xw5xh78BcnXSZhJv2rQZfnH8YZsuMoHi9QsNW	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1490	1148	28	1	3468	jxEohhxjojMDE49aVYpP3SMBukfgtgBC2Zk8L7Dx5Cje8sPZEqJ	1846	2631	2631	1616412780000
3560	3NK9JE3C9oLgViffetZ95axcCJRnQw1xHxNiU6LX8BnDsFdrrkNr	3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	632	1382	28	1	3471	jxb8j99kgqZmwjQSdcF2Jc3MBiYTuNCNH8TErV5mCiiiVQBoi8p	1847	2632	2632	1616412960000
3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	1406	1393	28	1	3474	jwMV6o9SH2HAZKh9Qu8B1oEhZEzKR6GhChvAfa9rmV3jVoPwjVo	1849	2637	2637	1616413860000
3566	3NLKATuwTeC71QSiuiYhzsUBb6kXDYT5AnU6MEEJcwxkkBgyJyY2	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1633	1390	28	1	3477	jwE2kQiQyuUHfVj855STJbt2V1vDYo7Fv3szuhjyS89qoiUWMvS	1850	2638	2638	1616414040000
3569	3NLjxRdnnea4E4QiHrHMYtthB5vPPLKomQxxvLRCX3ecr1YQDePb	3567	3NKdA8HHXim1shTeSSmf8EoqADm8wkQhy9YMMCcgpJsjaaUjKRZf	1589	1040	28	1	3480	jwcECrWFBN365ahB1yreRdoGnGwiDDHB7oDxCY27LjGE9ZWcDNx	1852	2641	2641	1616414580000
3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	1550	434	29	1	3483	jxvbg7kUqixDvWAH82NVZgM1YiZ4odCtpS67MUJ3UpSSFP8xCGd	1854	2643	2643	1616414940000
3575	3NKLv9kquvqDv1QiT5PGdK1maaB6L7T8yToA2ucZu434hKnSi1Ph	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1631	794	29	1	3486	jwf21gKuJG1F6YddUoW9CD6PHgTK7RYDJyiHSXZC8UkKrjvYGoZ	1855	2644	2644	1616415120000
3578	3NLHLXUYtUbqvSsCw9kdovkhs5SkGc9MCxAVGQ7TsJvuEteRWawP	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	1481	790	29	1	3489	jxcQa6LcMxprtj5UJxvryJa75epcf1xgUa3JiEqheYWayVeNaAo	1857	2648	2648	1616415840000
3581	3NLW2JNbZT2Yk6gAwRnHoZNrZLqxmcXkyTgmJhPHmfGLyiQBk36j	3580	3NKZEwrrAVja6xnFVXc9EVLkhzS3js99V1FnN3hC1oYvsoBLS2SH	1406	1393	29	1	3492	jwCyzWLbPirVg9Wj6ikFUtzHfhxWLNoFcogx6Pknkv2SWQbvtnV	1859	2652	2652	1616416560000
3584	3NLPW1uMAYBpARj88g2w3dArpijTAEPPJjgMwBbx6QP4EFf2Mme1	3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	1476	1125	29	1	3495	jxPchXMXbXMLfS2cCNiWj2KCgbmD9woEQnnJcvDhhtsGVM2kgFQ	1862	2655	2655	1616417100000
3505	3NKjFMqQiocpJzYAKsmpok7zLeooemEYKxhXHyGoZ5ZxAaxzX6Mk	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1637	816	28	1	3416	jxPXk5caoAqnMeD4war8kg5MYofm2xBqXeKRRoukfHZqt8egAvz	1819	2590	2590	1616405400000
3508	3NLocUiFmMuS5vJFUu5qyfLggMRK7c7AxdozBiT7xiiXqrJTaitr	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1458	1197	28	1	3419	jxe3WQ9aFUtBb6kv31Lp7EYe2kDXgEEdsxvYt6XNBMwSvCdNmFM	1821	2592	2592	1616405760000
3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	3509	3NL76tANUefiGGd1jgwyUJmwx3xHBjcYwJUegJR7N1p3MriSexXd	1623	830	28	1	3422	jwZJq5Rk9m9bVwUCBtu2HvC49zPv5gAmPEnwhkyM5phW3h9ka92	1822	2593	2593	1616405940000
3513	3NL2qvnpnBDXuqVPqk7wePyEHLzvoFUwgbSkzNAgEEFEYGqUPAmW	3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	1403	786	28	1	3424	jweHAZX1vm5RDVnTBbsvP8MyakNQBFtYtVMYWxiQpde6vnUQ5iW	1823	2594	2594	1616406120000
3514	3NLZN1BPtrB7vifqUTFYG4uCbrogmBDoZHnxb8ELsvhNszV5Mzsd	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1444	1381	28	1	3425	jxfE47fyc75nJoFFHufsDdUBtViSQTvPGzcWHSEu4nvPQDv14jE	1824	2595	2595	1616406300000
3517	3NLeZbFW9Ppv3LMQxevNFj5t4EVaSRL2QS9nFbqecah4z3SxmZFS	3514	3NLZN1BPtrB7vifqUTFYG4uCbrogmBDoZHnxb8ELsvhNszV5Mzsd	1406	1393	28	1	3428	jxgdsqkGGiWK3rcTCJxkebVGZiaPNxVdC5Bk9wQcn8brD9gQDZ1	1825	2596	2596	1616406480000
3520	3NL3VeBz3CiAnJS7rfwxZv2w9YmB7XfDKAx2yKxEXf62bdCCztVx	3519	3NKY2A4LTwxPNrp5Hs7JvpqSWkXZucU96otLHQvYfcPmax2Qg8VA	1439	1033	28	1	3431	jwFHPbcpCdTht1QSHW71HGKtEa898DzwHMAnue7ySJdDTRyj2QM	1828	2600	2600	1616407200000
3526	3NL2dvvrsoBGikrsLNM5XbAkGCZRDjDk6aEUCkwZzjKNbPbM7tDx	3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	1634	1085	28	1	3437	jxSgnjbfBW4H5miq949giLwKH71u1dRqGkAqZa7Xa3oEzwaasvH	1793	2606	2606	1616408280000
3528	3NLinLbHz9R7wbRTJckvZdXhpX2j5TiuKr6gdMP2BuwihSx1csXY	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1405	865	28	1	3439	jxH13N1JuiTuLCZft36xkQH9XSNqLgHpyuVtRzK2W1oh1A2ZuvQ	1832	2609	2609	1616408820000
3530	3NLfrAGd1wU7SoXqY9qTSDnP6URvUbS8jxB4jQMfW5nXgY72qUzu	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1490	908	28	1	3441	jwNYrhrbhRFjWmLe2sthhf32vsJPzSwNi26AxvYm2sNzg7qiVbS	1832	2609	2609	1616408820000
3531	3NL5HinAjZ4SsvixnsvxQUTxxVySetxYTH8vzirhqPWZdeCPyZim	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1439	1033	28	1	3442	jxa8kAs4bp4cgj67jYnV3D2P1pZqQAJimNwiA76D42kRpauDULC	1832	2609	2609	1616408820000
3534	3NLHUmKEByaPQoDjb2JZsXtyAS9ooNt4udy4ATY9THThH5AM4dpY	3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	1406	1393	28	1	3445	jxFt2RxkYXzqgB7iEPrrxk7otsXHzcVndusco7HDo5GVnReBs3X	1834	2614	2614	1616409720000
3537	3NLV5Mn2pDqh1LwhgjRQxJ9riDv1Z5117onMMmtZ6vC7PfSPVMb2	3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	238	238	28	1	3448	jwbX6yqUVkAgKCTFD2krZ2tgh6kiuojGXs1GgHCp87XSjxyNFxK	1835	2615	2615	1616409900000
3538	3NLuWtCVegKsbgFiQfW4jEV7YVvfF6BL6ZeTYMk3Kj7GNMZgHgVt	3536	3NLd516hRw7Y1ASHzNea4pmqnJHSraAgizBbKVVjvYTbXykr53oX	1637	816	28	1	3449	jwATffV5Z8fZxTbK21vh2pSpAG36KiLgPvWo27wuw6hXQu6abEs	1836	2616	2616	1616410080000
3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	1553	776	28	1	3463	jwuTMZD3qwKr8oMVTS8LAEojNPCdVbzwWK3gDsNMbUm6rfZfuU8	1843	2627	2627	1616412060000
3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	311	1307	28	1	3466	jxJwWYgLbVHixFmRk2uvSXXsudNiKGGdWet5mh735aLMX7Cy4vy	1845	2629	2629	1616412420000
3558	3NLkr5iG6hKBvS5ai7sVcFucEgMWU92b4oXRkAAEw2mBsDEu2cHq	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1522	1322	28	1	3469	jwUcBKcn6iNH5u7Rz8YdLND1BicN6NYYsoaKtEApQL39UR9zwRc	1846	2631	2631	1616412780000
3561	3NLVxrAwwJMEsYtw1iWFU5ZDuxv12jHH5B6M9ZCVyFYE7anaqKDU	3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	1650	1375	28	1	3472	jxow642Es21PHbUQ2Zodhi1aQ3fd8hf7DVrqqAy81v18ncs4RNQ	1847	2632	2632	1616412960000
3564	3NKKxtUwpVKGMEmdvPcZNcTTwirdhrEwt5fYVMPFZeLTP3sHC2fs	3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	1419	814	28	1	3475	jwFC1DwjCGM9cUgn9LbydcP48F5XbJqrL1XubDXpxbBp9C36rMy	1849	2637	2637	1616413860000
3567	3NKdA8HHXim1shTeSSmf8EoqADm8wkQhy9YMMCcgpJsjaaUjKRZf	3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	1546	1213	28	1	3478	jwJLYYj7dB4NE89njFydYR9JjcsbFKTtFSzfNWsSjLCxMYLsirg	1851	2639	2639	1616414220000
3570	3NLKECu63mRYywvccRPXUrHQSzW7vUaS9Qmhg7uJt8wnKYLCvKR5	3543	3NKWSAUeoqthPeZenfMTgsN7aYYFJ7eCjxRPyEd7WaCLSRZrKgVb	1513	1379	25	1	3481	jxUAbBFo5EhC9fCH6oXrLLk5Ue84eCNsCUhMhXup4WK6ebkw6o1	1711	2641	2641	1616414580000
3573	3NKjv5Acns73b9meUUJzw4cdCuK2My3e7QcHj9fk1qe1yxJ1ziwm	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1405	851	29	1	3484	jwNNqMLgK9dS8kwgid3vZuRr4rkedtYMayncgGhiW7HxYL6yt5k	1855	2644	2644	1616415120000
3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	3573	3NKjv5Acns73b9meUUJzw4cdCuK2My3e7QcHj9fk1qe1yxJ1ziwm	1549	1362	29	1	3487	jxV5HivDT2oT5GwWz1zx7eEdWg6zksy7Bz5Un7ZQMDrmnJGxiU8	1856	2645	2645	1616415300000
3579	3NL9hdstEAhHycQxFxxmgD5pKE7gDrQkgeaKFs1jnM3YBGdoqiy1	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	1581	778	29	1	3490	jxPy4z1ByhPs11HkpoaSNZMwaffru4r1KLHp8Qx6tkizYg92gCc	1857	2648	2648	1616415840000
3582	3NLMsdKBTixobFaGu63zncmntEPW53ztpe7UY2Byzvy2yamZf2YZ	3581	3NLW2JNbZT2Yk6gAwRnHoZNrZLqxmcXkyTgmJhPHmfGLyiQBk36j	1529	1316	29	1	3493	jxqvmvfsddnkAYzvYtBvvziandfSLkbkkF9JVJNLNLxPxgnThKT	1860	2653	2653	1616416740000
3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	1642	1001	29	1	3499	jwWb2YCd5VZMUBt8MqnepJASUhqKDZTdTSKacBUtQ5RJMfhDomN	1864	2659	2659	1616417820000
3591	3NL9NMHWpodhKU7nxWvkV5YLB7uf6eHpYVxcTcdCo3atVSpzrUSr	3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	1406	1393	29	1	3502	jy316SUxuAWdgPc9vsQwp7gPjhpWAJUUEQcKU6Kp9EP2aZpGUED	1866	2661	2661	1616418180000
3594	3NLMFmtxSXCAFYKECVyFfmrsZrJxjk7y7ydbSb6t2YPUKxptKP7B	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1483	186	29	1	3505	jwLVHDbNK3Aa6XKJw5QaFH3j6a3SgCrvpcxkbm2jZ67AEjHg8Zp	1868	2664	2664	1616418720000
3597	3NKEC3hZhKpaMYFPRae9HrCsjm4a1DayfP5iFgvWSMSut1wq2Kbv	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1476	1371	29	1	3508	jwHNYJZmtRsk1WRbeVXMzacskUSAA2aQbP5q7BcW6wge8tsYvFq	1869	2665	2665	1616418900000
3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1426	1364	29	1	3513	jx6LbMjDVqZ6gVqjvVRGu77zpyJzYogiXB1Gat7JDbfpV9Chzvv	1870	2668	2668	1616419440000
3605	3NKkiGWwuYzjz89eq21SgtvbDZUafN7Q1mKswsFFX1AnJiQVK2QY	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1407	1395	29	1	3516	jxiURFDKxvKkwP3PpHhbCqaraBrPmRLPmiPNoXSZs5Z2yW6n2Zm	1871	2670	2670	1616419800000
3606	3NLGSFdTrYRaVQvdPEmSMwTyqL4UCCKaUVjvzxX2FxRAtoXLVbMA	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1637	816	29	1	3517	jxNUGYJ5Xr2Lz9ozCHDrDhypZCeTK2iXFNbpVfJRZ1n5XWrD2uC	1871	2670	2670	1616419800000
3574	3NLd5xJF84jHNMTVyesP9adp186wGb8G82fhtHJPpXznfrigpxzE	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1581	778	29	1	3485	jwiUE4MtkReCdN4dpYximCzvZSenMkH5XXrNjMofG8iFtu8Ff26	1855	2644	2644	1616415120000
3577	3NL83xyvXV8DxBWUWLMBWczZnCFnKLxWpU6HFhUnPyQDog9K8q5c	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	684	986	29	1	3488	jwx9rjvK8opfg461xkTxCUtFHMvMu7D8EAYdaeZfAWosz4PRM7t	1857	2648	2648	1616415840000
3580	3NKZEwrrAVja6xnFVXc9EVLkhzS3js99V1FnN3hC1oYvsoBLS2SH	3579	3NL9hdstEAhHycQxFxxmgD5pKE7gDrQkgeaKFs1jnM3YBGdoqiy1	1593	1346	29	1	3491	jx9GxAxhXPpKzjRd1vxtZ5HmFXbUqXmkWzbZUQDZ9jTjwNfxgEG	1858	2650	2650	1616416200000
3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	3582	3NLMsdKBTixobFaGu63zncmntEPW53ztpe7UY2Byzvy2yamZf2YZ	1458	1077	29	1	3494	jxwhqBKjC6cWggzKyreEMbCT8UadNBexrSnsnJCbzD58PB12Z5n	1861	2654	2654	1616416920000
3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	1483	251	29	1	3496	jxjsihCeiYScJ5PgtfyVmQMgWQXfoWGaS68oVY9ns3KEBsv7KCP	1862	2655	2655	1616417100000
3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	1406	1393	29	1	3497	jxGzE61Cjq9ojoSwCbsQi16GfzbQYnneJ6uKxWpHDcifMitYKRh	1863	2656	2656	1616417280000
3589	3NL6UmnPkW8iJHMYKZwLWqQ6pS7zLcZNndFuFjvAWrVjTGBtux1V	3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	1403	792	29	1	3500	jwVJm57JgDKuNo8JJuaYwSzCgJvHrUKdEcjoPWYnj5YSiTJMG2S	1865	2660	2660	1616418000000
3592	3NLmtdedpaffDHX5QMvyXLhGsUws6YkfUBUtCcbQuJ1KtfSYYLfy	3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	1536	947	29	1	3503	jxhTiduWYoXdnTeVofn7BJYXLDHJbiLwa4PHsJJXPwtQSZxCEWC	1866	2661	2661	1616418180000
3595	3NK5NGRTSMaxkPF3xXgoEymKA8vzDwb79YyVtNfCQMmN3ZBzTRjN	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1461	1271	29	1	3506	jxHBhDrkgHzVdxFDDkif16eBt3FUMAjmK1WTWVRG9JgjZkmJsKH	1868	2664	2664	1616418720000
3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1407	1395	29	1	3510	jxxdriFgPtKYwXLJRwakQZGQGCTegaHLxEhFemD9YaKMpRDTs6W	1869	2665	2665	1616418900000
3601	3NL4J1KCNfUbHEgUDj9MavGLxUCeyac2TUL4shjHdUCjE71Z7dHc	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1670	916	29	1	3512	jwkLpzp3uLdH3YAfVrgn4bdhLonD38aY3hcHVb33cMgUmkNi3xE	1870	2668	2668	1616419440000
3603	3NKaAcEj5d5NEnKFqrjMnKrCHgEH8NU1tdfhokdjp3NXN8M7eojk	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1624	1334	29	1	3514	jxWjuK9J2zL992APcDqdc7ovTUbA6ewxG1JNE8iSWTXp8prgm7G	1870	2668	2668	1616419440000
3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1596	1237	29	1	3515	jx46ZpmxY5vnafnQ1iU3NmcTxacsmp4pF5PDcYMdDYFreAYnDPY	1871	2670	2670	1616419800000
3607	3NLeXwhoavBqmNmeLGSLAH1QW2PWoRCGerSH6bc57FwrKkEkEPxm	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1578	1296	29	1	3518	jxFJT92B6tdQtad2ixoXiZX8LcjDHCmjUbWdZ3RsAvkgFjEp64C	1872	2671	2671	1616419980000
3609	3NKkTGxoeYTdUKg2cFfxVZvSHNUre8CmcGqYDpRnLPyMTc9Pk6B1	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1406	1393	29	1	3520	jws6SRaMT2herKUnEixLjKg4bgNWJzhRcMNB4QeEec5AU5zyJWZ	1872	2671	2671	1616419980000
3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	1483	1030	29	1	3521	jw7HiKaW9k4gmgayepPxv5CiNFzM2BB7DjASyW28FkdxdVLNxXt	1873	2672	2672	1616420160000
3613	3NLLyzPHedVqBxtwm1HHC2t42AV6nUna5pLJmcmjMh5XKYhUEdTQ	3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	1547	1378	29	1	3524	jwGo5j4UqxgSUShZ6ucHCQUnyDAo4jYbSHW71hJVsrJkRLZtea6	1874	2673	2673	1616420340000
3616	3NKJfWN6re5yaNUptJ96uySw3gCH9UatXBeNz1kHx7bpbD8cEZUR	3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	1422	1337	29	1	3527	jx8tFYBWzofd6J8yMtYHc9ktDbt4ka58asmqvmy5bxf21t9foat	1876	2675	2675	1616420700000
3622	3NKd2aLEsm3Qg38CbziXnDcbDkXwFBiuDfaH4iP8WW7YnP5J4JUx	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1631	794	29	1	3531	jwL1ZGsrFg8XiSjDUyXyuJ2tUGm6nR7fFo3n3PTuNQNKyHTQgPj	1878	2677	2677	1616421060000
3625	3NKLCjsXLzzuaNd2UCRnso216EExugTe6G4cTEF1ax8cg93fg3sC	3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	1634	965	29	1	3534	jxcrpfiftRUoTsCXNXKbmo1khCFtYqkVJmd9TTHPhuvnTRhkNUv	1880	2680	2680	1616421600000
3628	3NLiymmwinNHwPCnEDu2o3P55V6SL22TjCP7Tx87qAG5YJJ8hRR9	3526	3NL2dvvrsoBGikrsLNM5XbAkGCZRDjDk6aEUCkwZzjKNbPbM7tDx	1634	965	28	1	3537	jxXt3g9zP39uUA282hjyN6MxajSob5AW3fbpmfrwmT9eR6VtqYM	1794	2680	2680	1616421600000
3630	3NLXkLT4ejdZu1SnSkfeqKJsNhyRYTUU96jEHjUMhLah7RTm4zWT	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1611	1341	29	1	3539	jww6ePPMqxE9tHqP3cNadyKbQXzZPHgZsT1PyrLPqgeV1vmgKqk	1881	2681	2681	1616421780000
3633	3NLf9byFNgnBPLFLrAr2xTVLsqFTpdAhGuSCrJtJArmyySKbMtVZ	3632	3NLpiCkHV5ELFvYXEwv6zaLJRe7n8SrdtsJnLvEKeiuYFPFHhbmZ	1578	1050	29	1	3542	jwAKzPC9h5m9L3q9fxzAjFvsePYoPiiB9o2cEyWuQt5mHo9LkDf	1883	2686	2686	1616422680000
3637	3NKxgZjaEUgaPELkb7GtccHv6ALtw6jGVQSgMLa6mP7Tb7HexJWB	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1673	1368	29	1	3546	jxTA78UMnj35UwEq4uvJGT9aDzvq2LZMPbvWtunbPm7n9HqKNyL	1885	2691	2691	1616423580000
3639	3NKQDEmxDhYvQjRYTp7ZMjCVpZ7RJ46zRMR2WVSgvhRXhsH1F2p7	3638	3NKETgREU7vBFVjJEx8ik1f5bbdcRaW77VkKEC1Qjk3t64Mt1wmZ	1407	1395	29	1	3548	jx291nRmsnNC4umJKQTvKiBz53NVPr7KKvQv2hwbPBhZzXYQHWW	1887	2695	2695	1616424300000
3642	3NK9T1KLskzGMjV2DTtMZpsWn29hBuNojzPNVdv5Ar24Cju4UDe8	3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	1461	1271	29	1	3551	jwPbE568mEjFePGequ4TJuVRfgdHvSJhg3gJwHEmd3ECY8gJGFo	1889	2697	2697	1616424660000
3646	3NKzcw1FU7im8rUNsPnPFghmm7fdvKtU3rBRrmLobwHGjmQe7zZM	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1578	1296	29	1	3555	jxDqqaXry7Z9bmMX5kZijs6Cf7G94LeTkyqLSf5qtbu4sKRUqe7	1893	2702	2702	1616425560000
3587	3NK5CEodec8xmxfXKciygCeVDK1ymxgpetW9tC7LNFgNeidx7BNf	3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	1445	1164	29	1	3498	jwZfFoTjpEeqNDpsiVrkAeJQSbx5Y9z2HXHjkVjwZm5NLZ34tAF	1863	2656	2656	1616417280000
3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	1402	854	29	1	3501	jxta5dnbXqs8ZYjXCHC6zeLCtGiQHSZG6tXrPG6HawHT2R3HDbi	1865	2660	2660	1616418000000
3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	3591	3NL9NMHWpodhKU7nxWvkV5YLB7uf6eHpYVxcTcdCo3atVSpzrUSr	1405	891	29	1	3504	jxwaSFH3jVdnVy9jZu2nkUTpiX1bZJjGUrbJVgQGWWLH6ABCziC	1867	2662	2662	1616418360000
3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1627	1139	29	1	3507	jwuBqpcEPfN1ug64wVDXKeRQRBYzmE4Nby7KNiFuAiqY9AcyQPQ	1868	2664	2664	1616418720000
3598	3NKDgRYVMiEcW1tCSESzZRzrGRTMHeG52QVYB8jdbmP8EkghEmBC	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1483	1276	29	1	3509	jwdPHGRrKpN5au2wNeKzfVCGh8mA7ujt7B8wj8VuCdC1JdSHkhZ	1869	2665	2665	1616418900000
3600	3NK8avasVMqvNQ5mnUqTxhtkBXbJyZxQLvLU1NyQzredHpxxx4Bj	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1406	1393	29	1	3511	jxs9cvN7uhRYw359Xuzvc1LeTyh5CX3BLiXLbFcp9zfGif5TbxM	1869	2665	2665	1616418900000
3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1403	824	29	1	3519	jw8bpWkGzSQgssM2p5koREtUpgz9u3PAHJMp2K5pXg7WpZ4ZPqw	1872	2671	2671	1616419980000
3611	3NKB7QWxr9VZ6FZdZgGjMBKfkyZVHHahHbLtZqko42rjqr4Ks8cd	3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	1489	1014	29	1	3522	jxZyx9DM7V3qYZr9Uyvrvpm1yv7aHtNapFTu9wauKwD5V6vZXpv	1873	2672	2672	1616420160000
3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	3613	3NLLyzPHedVqBxtwm1HHC2t42AV6nUna5pLJmcmjMh5XKYhUEdTQ	1527	1167	29	1	3525	jw8Ub5m81JYvtTD9D8qhVXFqaGzmJMZZXradjwgcpdSUs1oK8uc	1875	2674	2674	1616420520000
3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	3616	3NKJfWN6re5yaNUptJ96uySw3gCH9UatXBeNz1kHx7bpbD8cEZUR	298	1308	29	1	3528	jwEVp93NCeuZNRiJBNsAR3Mhf3CzsCmtFTUr5MfxPSNqPjwgnEL	1877	2676	2676	1616420880000
3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1588	1146	29	1	3530	jx8Ct3ihCk4Ae6Afrxs8aG6MV2oyaitzgr2gh4uoqNd3mrrtH6q	1878	2677	2677	1616421060000
3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	1483	146	29	1	3532	jw9VShf4STgrhXqnHFkg8KbjJQRWjTPS1dsRK8dCvUXdyvXomZH	1879	2678	2678	1616421240000
3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	171	1128	29	1	3535	jwr6iencv4MHcDbrjtXfzN8eePkCRDZunsCZ5NBFbvGGQ7treuR	1880	2680	2680	1616421600000
3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1581	778	29	1	3540	jwqDQRRQDo8mQiywcw7tX6RZ9xXiTuCbX5bYLX47hSV7Emo6hu6	1881	2681	2681	1616421780000
3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	3633	3NLf9byFNgnBPLFLrAr2xTVLsqFTpdAhGuSCrJtJArmyySKbMtVZ	369	1066	29	1	3543	jwbdUC3STKKCtj74Me63iLCJ6uy5M72x7QNZVTVPgvahMg1iQir	1884	2687	2687	1616422860000
3636	3NKwQqanRASRuJUmVaBcGzwMJvBBgztGsM5HqbrChdR517ChiFkL	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1503	1031	29	1	3545	jwiJtX8sedwS7i7H4con9CfazyMcVM9ub4VwiEnN6xxYucxTBWd	1885	2691	2691	1616423580000
3640	3NLT7uFiGFQUkT453FVQfLarpPvaoTbAo5sPGF7NAXjHiUfN4o9Q	3570	3NLKECu63mRYywvccRPXUrHQSzW7vUaS9Qmhg7uJt8wnKYLCvKR5	1513	1379	25	1	3549	jwQZFwNPfKpZjVxfa8hZLZMkstW5XVCfSTx6WGMk12UQcuGeLPB	1712	2696	2696	1616424480000
3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	3642	3NK9T1KLskzGMjV2DTtMZpsWn29hBuNojzPNVdv5Ar24Cju4UDe8	1590	1054	29	1	3552	jxARdxu6yvVqEH6Qfu9YckGtocctoKjpMgRqGZXDWu6fPguCzBt	1890	2698	2698	1616424840000
3612	3NL3pLUEM1hfugDZzRaEr5SXPrHiYsHJbump8eMCs4HFgGtDTysM	3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	1406	1393	29	1	3523	jx6h9TQu4giKVExJ9rTDrD9gB8MhhvEEXow9yMGzfkNQnSBQXzr	1874	2673	2673	1616420340000
3615	3NKAj7MxJskBNThLSYNfdSPKDjnGqwz5fmdwWQ3wr5NEEmD1KrrK	3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	44	530	29	1	3526	jxwqBT5NJ6Zw54wiTrtfio6KbqGdWXWjy6wqt5fif8CFYRgx8uP	1876	2675	2675	1616420700000
3618	3NK8JajTHiDJ6qcJ6cevcgpvqyJi1QsvEyxZrm5vtfGBUitXpppt	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jwg9izkgvhkb1dFomkmwYzWmht9c1gFuahtEVi1A73uLUApEmbg	1878	2677	2677	1616421060000
3620	3NKczWtNQBj7J4GBzeGq8cK2ghVVwwa6Kh1WqAEipHxfZWpCDxeh	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jxpedyVHy78ypHMaQmi1s6taASyCAEo3Q428Zxi6oRWohBLxdQ2	1878	2677	2677	1616421060000
3621	3NKuLpZCLKRZTY9LqGJL7QiqyX2zQdEER1GPTPuqXM1K3TN7MqwK	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jwcP8wH2ueLTqRXdTFCD6Lin86RNWyTHsbNPMVwkfkqx5AgbJy9	1878	2677	2677	1616421060000
3624	3NK9rmdzTwnZKQjp5PoUaRYeBkkHogfdB6ceu5zmUrhg6axYLQP1	3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	1439	913	29	1	3533	jxJHBswffSWqNSUd4UWTzAtxtwjnSBQVF1D7uBYZQNtdrAFsuKX	1879	2678	2678	1616421240000
3627	3NKTkaaKHmaGS3WLEn3AvoJ3VjMVskCMnzfyQRZP1c1vRyKbtt2D	3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	1614	315	25	1	3536	jxs858w5XbXaxRDooBKKhmGLcBA4yDGKXuL88KSKPS5gF6QiLnB	1710	2680	2680	1616421600000
3629	3NLSZZuUqB6v4Mqgr8MPrW5YtnTxJWWLQ7Kf5EzF4aCWVv6vVZfY	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1407	1395	29	1	3538	jwkEhXBmvWj3d9RvKi9ujCYaTS8JaicGPTPy2d38uP9Aeas4Xqz	1881	2681	2681	1616421780000
3632	3NLpiCkHV5ELFvYXEwv6zaLJRe7n8SrdtsJnLvEKeiuYFPFHhbmZ	3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	1477	1104	29	1	3541	jxnPf8pENTTu4cV3QvseTcrxsSutgU1ptSoomidJhqzrNzmh8wZ	1882	2684	2684	1616422320000
3635	3NKi9iRuSQ4YBc8FaHadNUJxP1r86NCA1vpbp3EAnWofFLydHKjx	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1564	1092	29	1	3544	jxUnS7aKJjtrrLLodHJDp31As5wAAdpNLXjLgDhAr6TYySSFZvh	1885	2691	2691	1616423580000
3638	3NKETgREU7vBFVjJEx8ik1f5bbdcRaW77VkKEC1Qjk3t64Mt1wmZ	3635	3NKi9iRuSQ4YBc8FaHadNUJxP1r86NCA1vpbp3EAnWofFLydHKjx	1481	790	29	1	3547	jxpmua2gtdhdiUaJVqmFbsXXPhwgCztNQk8m2rcLoVwGUYKXRTf	1886	2694	2694	1616424120000
3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	3639	3NKQDEmxDhYvQjRYTp7ZMjCVpZ7RJ46zRMR2WVSgvhRXhsH1F2p7	1627	1259	29	1	3550	jx292wne2ELtbDD8yeE9vM4PVbpwpgWpDHJvjkL43QJrKuLHS6W	1888	2696	2696	1616424480000
3644	3NLBGkW64nUaqsi3KiT1iu7zqHgDBBzu7vyqDnZq6hqbSKrR3hhQ	3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	1668	1370	29	1	3553	jxrUfrihx9dcbw5k7eRbyZsMPD2hmUTjuVE6NdY4GLxjHnGFefB	1891	2700	2700	1616425200000
3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	3644	3NLBGkW64nUaqsi3KiT1iu7zqHgDBBzu7vyqDnZq6hqbSKrR3hhQ	1596	1237	29	1	3554	jxU2NsBA6vQ3NZRuZt8NPnjdFTvA1CGDckpkM1n4CCSAaqQCsne	1892	2701	2701	1616425380000
3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1460	1324	29	1	3556	jwPfmHgHNvbevy8hQDV3NVZ35LJATvFseA4NJxZFoDGpURUFD1i	1893	2702	2702	1616425560000
3648	3NKdbtcHESiVEAkRfMq86Wk9ysmrrNn4bsSrH6WQx53FAaY4Cxfa	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1546	1339	29	1	3557	jwwFoiNxTD3a3TiLKuThdsZDzevDYpVtFNXwsLX35EkmsxVn1tU	1893	2702	2702	1616425560000
3649	3NLyGxCfGor963SLMFPJNQjXaortHCXcY3BSKTDieErRMVzAUTQd	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	1544	347	29	1	3558	jwSFjFfdG1ZzcH3LNPzoXBw6U9GJ9yxgfRtPeHD2nTcvvTyX7sB	1894	2703	2703	1616425740000
3650	3NKaFpPMRCPAbZZMRJso8qEYYpAbxA2fqCpcMLfrEYzEZwRHojXp	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	1672	1285	29	1	3559	jx6DwqBMKNNALT5e7F5WYkRoksiRcWvBbfdWCr1briqTdxPq8F8	1894	2703	2703	1616425740000
3651	3NL91osmEeN2DHPYZrFANjcC8YPuFfTbZC2MQ2k4GFKaHX6wZgZE	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	606	1049	29	1	3560	jwqCqs8ePoXuYPY21miMNq4ugnKsiVKT3LAMae25nsihTT7mMHh	1894	2703	2703	1616425740000
3652	3NKcjn1QBrARz9rMsxFnM1vvDonPShtu869NCaWzYCmiS4LCcWEn	3650	3NKaFpPMRCPAbZZMRJso8qEYYpAbxA2fqCpcMLfrEYzEZwRHojXp	1596	997	29	1	3561	jwU6cFabU7qMT6CEm3SuEk4fE8hpCK4WnWqSKdUhuXVFYRJULpU	1895	2704	2704	1616425920000
3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	3652	3NKcjn1QBrARz9rMsxFnM1vvDonPShtu869NCaWzYCmiS4LCcWEn	1571	1335	29	1	3562	jxggQebJLN4MXsAHvaHU1xAw4fMFuSsNGyMqp62KxFc1HJZ3Jnb	1896	2706	2706	1616426280000
3654	3NK7QXi5Pz6Ygck9uvi1wbNFexQBogbRjK5aS6yr8VCfpXxhszzj	3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	1489	1380	29	1	3563	jwXCo4jGhWwdPLhHSRxwH17oPDWHJLSjeQSN2T645AbRMVewMeo	1897	2707	2707	1616426460000
3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	1623	839	29	1	3564	jwsCstiAuCgthAwxJG3C2zPaXc2SJ1iiJRjw4fVqvnzHhyYPBpE	1897	2707	2707	1616426460000
3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	1577	1327	29	1	3565	jwoswszNy3cczeFeD3nqi3h2nq55nQHuyvGre5TGH5qbfBfyN8A	1898	2709	2709	1616426820000
3657	3NLrh24R8fBs1EMz6heSJ1DZunqyc6b1jUGYYFC9T7tqoRVRv1iL	3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	1577	1327	29	1	3565	jw7NBcBpmg3co5215172goo85pD7Myiv235pRoFYT97bo42eWLP	1898	2709	2709	1616426820000
3658	3NKQSXPPBdhziKZ3hzBotiqzp7wGwiGCvCMfZF2gWKHU6bK4RCy3	3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	1633	1144	29	1	3566	jxAM6AReE1W5yexFTmAF5CAZfPPrgCcvJVd6BQaUJwTEA5TFho7	1899	2711	2711	1616427180000
3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	3658	3NKQSXPPBdhziKZ3hzBotiqzp7wGwiGCvCMfZF2gWKHU6bK4RCy3	1483	63	29	1	3567	jxJAmTq76Ax6DA5fd3U3VgooLsDhyeTf4MuUFUK9GhkBcnCPfqZ	1900	2712	2712	1616427360000
3660	3NLQRaDSqB5MsFmFXmffXoPyQvaYj4PuMQTeFU1LvYZTy4QXFs3C	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1500	1171	29	1	3568	jwTwSq1BzUriz3g9GuDnoY1kcuQjppYzAc2pn4VSnAjkvRDsJMm	1885	2713	2713	1616427540000
3661	3NK6gVvX6FRNPFTyvX1cEfwnsiYYhzsWumHBsmJek29LBs3AMbVm	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1500	1171	29	1	3569	jxAj28ipp1HrLXN8eeeKdAo3fZ3xPQWryNxRtiudZ2QkvyRzxbh	1901	2713	2713	1616427540000
3662	3NKrC3u4dFaXLn1AkTuTepmhivWo5GKC4k6GozhrrQ2yfzdCfZeb	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1500	1171	29	1	3569	jxAj28ipp1HrLXN8eeeKdAo3fZ3xPQWryNxRtiudZ2QkvyRzxbh	1901	2713	2713	1616427572000
3663	3NLi1j8fwZsn51VUvZiyQ5TZjrLxVvDSDCeW5vrxHN4iqgY451iB	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1590	1300	29	1	3570	jwnSgx6oUmgNNQj8eju6uH2HQku9my9TcmtCFusQQDHUNGRLbET	1901	2713	2713	1616427540000
3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	3662	3NKrC3u4dFaXLn1AkTuTepmhivWo5GKC4k6GozhrrQ2yfzdCfZeb	1564	1338	29	1	3571	jxX2yEw7mtwJv69akhWgHzfGFrD2iCHR935cae2d78VZU4E4PB4	1902	2714	2714	1616427720000
3665	3NKW5yignGCxeGEQar5M5F6gS4QXt9WgUgR48LonHepsSrfc57Vv	3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	1407	1395	29	1	3572	jxE5vURkhA9nXz6TSsYNPY2ZG7hsNjVTRUGkKEfW2W5B5Mju7wC	1903	2715	2715	1616427900000
3667	3NLTixVybdnKHeY58dSmCjt7U3oG4P4N987LruYhrbFMPxqZ3buM	3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	1406	1393	29	1	3574	jx3Qr5k4fwmuit9VBejsrGttLL79zCqEL4yK5wLRoRwfcWzoBQC	1904	2716	2716	1616428080000
3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	3669	3NKpC3UtrpvexbuTb4ehN3r9GmJiGjEzHGue2sBfTXU2Sn7fpU78	1631	794	29	1	3577	jx2Z5igrquxDsop2mxG25LCC6B9xH2BTm6jYvGj7VfyHBTethLL	1906	2719	2719	1616428620000
3672	3NKKtdRxWUwMEMASPZiwkSYrdK6mc8LkfED2C8VcNj2Wt5yuCUxp	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1587	1111	29	1	3579	jwM1HAP75VZ46zJ43BNYH84MrBngBUKfSGJWdDGW5NxUDE9AxXG	1907	2720	2720	1616428800000
3677	3NKWhHsWqhhcFAy33bJW6yrY98dcsQ79CmAwvbGASaCbYcu6mz9q	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1611	1215	29	1	3583	jxAVWCTmotLUBZgikUdorP3T8ug2MTW872G1UUfLK7YCpVMf3XF	1908	2721	2721	1616428980000
3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	3678	3NL99hnwTykfTLo8JoVpRdwsQXzqHHJXAK3KKvAbcds5NVrzkmvy	1637	816	29	1	3585	jwKWAncHX5hWbkVr6keLUTVnQzEbzN3f7KcYp6Y6djEBZGHCjoj	1910	2723	2723	1616429340000
3681	3NK3QLNFxybfBtsNa1rXHBjbSndvM1r5VJ3EB5Q9RuQABWJFG5ow	3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	1407	1395	29	1	3587	jx6zc4mWvjq9KCQEDVRTQzV95SYceN1Fw9VpjefjMAsHyiMhy88	1911	2724	2724	1616429520000
3684	3NK99ydUCz8A2Zt6cMzGrnhxxBZ6ULtrFVWpbn83ucegBaSYTJsj	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	563	1359	29	1	3590	jxKr63xRGf6zC1y7s9qAKo1FxtyZkgHTvnBi1vAQEgQ3YggPuV5	1914	2728	2728	1616430240000
3689	3NKhL4g775ikj4xEaoeFKupp4dXAPjrgy8czoZ53XqcLmdkzJRD7	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	369	1066	29	1	3595	jwnKbDdCrEruoQLV6yHEuAw4mzbGZbecxRG351whTHjY3KuVSGb	1916	2731	2731	1616430780000
3691	3NKkLsg3pYSK1JiU7rfeEuen6pNzrsMvKZmMciehrioYaPSNDm4J	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1577	1327	29	1	3597	jwv9FsC5KudxRZNk4qv9WLFHG29wJvTUvkg9tNCPVUPe8D49QJh	1916	2731	2731	1616430780000
3693	3NKMafAS318xfhnfhgGRez8U1sqKmMRYK8mKXUbZPgWj5JNo2KPM	3689	3NKhL4g775ikj4xEaoeFKupp4dXAPjrgy8czoZ53XqcLmdkzJRD7	1581	778	29	1	3598	jwYeRuP7pQzkXzEfix1peeBbMkMLzL2gA4bp5rrDTPkxdT2nzK3	1917	2732	2732	1616430960000
3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1651	1301	29	1	3600	jxrjHZfSLLj6Gi8ts5GBTknaXFMhKwbgieswxDA3vZRv2oWXayU	1919	2735	2735	1616431500000
3698	3NKfu2bEUkToyrUs1xoTtb8SwLusrSoQbaCoU8XP4xfFcCxPxqg4	3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	1553	775	29	1	3602	jwAV34qxrN1PLyPagwxUmgHnb7EpPMjvsLAygPXfRxm6eE8qobm	1920	2736	2736	1616431680000
3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1489	1380	29	1	3606	jxLwBQ8cnDAcCsPJRZJG59Vc4QAPLeTPvZdyGMbinh1UxZjvQnm	1922	2738	2738	1616432040000
3705	3NLpgBpcKkzaZ1Nz882Urb3ux6qQApxkmRAhty8D6SFwhrGm4W63	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1440	1251	30	1	3608	jw8AcftU5yWGWLu14qdwxt2zbHg89LwdXu9GH8DPSUuozcMXsu7	1923	2739	2739	1616432220000
3707	3NKw25tPgvR6mMznoJ8jBcu7nZbXD8AbCzHZxGM4eQB4qQVk7rQo	3705	3NLpgBpcKkzaZ1Nz882Urb3ux6qQApxkmRAhty8D6SFwhrGm4W63	1419	814	30	1	3609	jwRzyBZCn6m8iHQsvW9ozWHNtA58nzkWWMg7zyNQbCY1zM1Ktpn	1924	2740	2740	1616432400000
3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	532	1303	30	1	3613	jwg9sN5tPK8pyr2Z1RHDUYejyJTidRN9RS3h6EDzhsrNPPGh3WH	1927	2747	2747	1616433660000
3713	3NL2QTTDMfsy1AaQEhXSYXGamRfCoXeFBEpPaUSPiSEZaDUcNNgD	3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	1577	1327	30	1	3615	jxNrwLM31hJD696Hydgz65P7rRE9DQjddB5Z1B7StV9HV5rnP27	1928	2748	2748	1616433840000
3718	3NKvL6oDf3XCE6Ez4vcMqwweZ1vuNkXJjxCgdMz6THiYbcxCuJxt	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1553	776	30	1	3619	jxwqtudVThbue22aNw4ZigNqQPzPcAjwAv2p5DpSBjA1DbiW12m	1930	2750	2750	1616434200000
3720	3NKyA6EFL7eZcXsSBmAsF9MUJJUQzdzYGiNh3QCKc6juZftJJHNx	3699	3NK9PtUAzLKZAQsVMKngh2cXyGqdR6ApvNHDG7xCAUViqKdjMsLE	1646	1228	29	1	3621	jx6Yq89eD4ppJ1TkP12ipHuZPUnQN9Tgqk9ftrLcXXHvCkbEnWc	1922	2750	2750	1616434200000
3722	3NKmtfU2MD1CsZNA1borssZXz335D8naQAG4vA5ymR5zemtepAyW	3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	1534	1317	30	1	3623	jxX1yx92zWZGxqyTKu8T9UhgmCtWpMvvaUZZxmatZwZbr9TzyzW	1931	2751	2751	1616434380000
3725	3NKzui4CfCg7iR9jgGVfDpyKK7osD4j4Gr7qVbji6AeSvLiVVFbv	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1602	1123	30	1	3626	jwWSL1wBA78qvecmotNn47uYCC9tR9PnSVVoUMoP4H1Y1C1EF95	1933	2753	2753	1616434740000
3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	3728	3NL5yfUHwciW9Za9z7ypEmzqe4pX87EF1BiEoSrKbYbN7QFpE53k	1406	1393	30	1	3630	jxBFFiRBtaZCJbf15Qn3p28U2YcJv98FTwxuXAidSAG4rP7Ngrd	1935	2755	2755	1616435100000
3731	3NKWZrcUaNMKhYzLHcCADEua6WWwFfPbYC7WBtpzsMUTsqsaFes3	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1403	824	30	1	3632	jxwZP5m2B8RP1xBdEg6dSSzsQ4uC6CwAEjzYCCWLkQUncH45w4J	1936	2756	2756	1616435280000
3733	3NLyEzj9doYizHporp9Y7KS5PQ8YNuVVd87sVyb8pPbUBNjn6Hmo	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1668	1244	30	1	3634	jxMvZeXsgX1ohSBDvyQYBS1mFDCmKEvZQsiJDh5Y26Ba4x1exdq	1936	2756	2756	1616435280000
3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	1651	1301	30	1	3636	jxWXE4Qpwb6dbS5s6WSLyyCo2yPTXM9whykWPFnDASTgMEG17SQ	1938	2759	2759	1616435820000
3738	3NL5CyxuHxPntfwYJ9VS2Rapsc1unsyEwpja1cHeiE6s7g7QbDCt	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1428	472	30	1	3638	jxoBSibRYKutHNRYBQ5NZJ99tVFBcWszrjo8oPNF3BSPpg4BySa	1939	2760	2760	1616436000000
3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1406	1393	30	1	3641	jxh8jMLvKuhdYiydQgxhduvN9CwDU9s2i1MeCQPyVaucv9k3vtF	1940	2761	2761	1616436180000
3747	3NLXPmFK5fN1u6TYCJvFZ7YF8wV2ceb2Ddv2DTYCfr8fQLt8wbnr	3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	1599	1161	30	1	3647	jwfEt4pGmVqDf6AWWRFg3XUVKXdDZ7TM2WXxNHhRHggJmTaje5B	1942	2764	2764	1616436720000
3760	3NKZXF36MyygqyaLuVXrHEYy6W9zKAXcMnSaCYTQB136MgUyhutq	3757	3NKtucaDWDXHDbdRjoyT5ZDzjWJwDV1N389oTHwFC9eWX4dJDLQC	42	1235	30	1	3660	jwJHwpwVRiGd5Q3JrLwjoxcmrvwgcNMz8Eba9nd1Kdo9iJb15AX	1950	2775	2775	1616438700000
3768	3NKUMo9gkPHMykkWkiCdPZ84BuAoPNm3Yr7TJirQXEA6cj9yzDhh	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1507	1280	30	1	3668	jwM3hWYp5RWgGe8ojSemUp8dqYLuHV9JK73Xii97qBGkEhYy7U1	1954	2781	2781	1616439780000
3775	3NKbfe6CowwC6VVavk5hMUBFuPj4haFuZsVBTTuf5s9JZux4x1bf	3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	255	255	30	1	3675	jwijWNrL7bwTHCYRN8pnwixWLGR1P78pPitJZb9cRSvdgapwXgW	1957	2785	2785	1616440500000
3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	1406	1393	29	1	3573	jxKp3eBnUTiNy6d7myNps8mRUi3UZkRQrWxCrwrysC3zHuraLMw	1903	2715	2715	1616427900000
3668	3NKufVD3ChbmQsxtgjxWE9MUvPTfAQPJafwwcq7xcrcYZD4Dukcj	3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	1407	1395	29	1	3575	jwpHydxynUpB4winx8DREx9tVcnqVoCtEDeAuXHeSoV1roQVNt2	1904	2716	2716	1616428080000
3675	3NKHwMeDjqHPFypYLkxT25KYYGPHn8jxTNk9whtCaBoyp2TfZcyB	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1455	1332	29	1	3581	jwKLYoi5qrYp2oRMKGcYxFh9ERBAHRoEzer8RHSC7pc6Cq35CCD	1908	2721	2721	1616428980000
3682	3NKGufTef2ohMBEnJuGdU1kam9ZUVGhEmWB1gvftF3d8xpMJs8Dd	3681	3NK3QLNFxybfBtsNa1rXHBjbSndvM1r5VJ3EB5Q9RuQABWJFG5ow	1422	971	29	1	3588	jwYqFWDKw5yqRcqsRca3wKX54aKeuBuZdBXh3nPLqNc9SpRJwNw	1912	2725	2725	1616429700000
3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	1585	1366	29	1	3591	jx4kjgF3boxE76TbaWd6tatN8RS4vwBJt8NPqRvTkfQ7ji7EEie	1914	2728	2728	1616430240000
3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1402	874	29	1	3593	jwZ9e9rLYeHgo92NEuG2kD1qMQS5JDWv6oRAYu1hmZj6P6RZEiG	1915	2730	2730	1616430600000
3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	3693	3NKMafAS318xfhnfhgGRez8U1sqKmMRYK8mKXUbZPgWj5JNo2KPM	1509	1320	29	1	3599	jwDRU3DT1r4HMfZ1E3LsEzh5ojtwPvNd2yko4WJWU4MN3giac2x	1918	2733	2733	1616431140000
3699	3NK9PtUAzLKZAQsVMKngh2cXyGqdR6ApvNHDG7xCAUViqKdjMsLE	3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	1407	1395	29	1	3603	jxac8BCpBedsr2rXzz8gsQsTr7M9R48hiheZo5RNmww8m7ArGRA	1921	2737	2737	1616431860000
3701	3NKMGvw2uaoHpDVT9N9ixSHQgf8NJ3FNNp9Gkb3JfVgoVsMy23YK	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1407	1395	29	1	3605	jxvW9xjiJsQesQJWr9355GLT8vv4FmtPbvu8VgYBxqrfXrffZLy	1922	2738	2738	1616432040000
3706	3NLfvV2bQtr34n6Cz1gNv6hkQNcqVMdte8UxigTyXJgqen7T9iuX	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1458	1323	30	1	3607	jwwMsMtBZ4rnThMQ7a1Vov2BbCvXY6t2bjYBgGh22fkpZbnAheM	1923	2739	2739	1616432220000
3708	3NLH62crLDXbpfHGubtYGR4unCNzXwFpNSymQe1ZXxu7qtA1cEfF	3707	3NKw25tPgvR6mMznoJ8jBcu7nZbXD8AbCzHZxGM4eQB4qQVk7rQo	1405	849	30	1	3610	jwHPsJrudektfbFUojr8sMWNZisdQMsBC46zUjB3jRaZUJo1FZt	1925	2741	2741	1616432580000
3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	3708	3NLH62crLDXbpfHGubtYGR4unCNzXwFpNSymQe1ZXxu7qtA1cEfF	1672	919	30	1	3611	jwWvzLLx2EuKV1cwUhKf3PjeL3nStUaVNUD8ETFgvQ5jR8a4G6g	1926	2745	2745	1616433300000
3712	3NLcSUTqb3cKZUSyVG96NB3RdfofnHmKSzYYJkZHxWPXenDMcMn2	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	1406	1393	30	1	3614	jxPKvTcVcQ2LR39H1FYvmB7phNc6vxozp6aHD3Tf6x8gi9uMih4	1927	2747	2747	1616433660000
3714	3NKxLCEdmM8jbmZSWQEDpWdLN9AFX5W6nYxNtDJVJm1URoYVxPQn	3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	1577	1327	30	1	3615	jwoz7JqCUwamKgis3rseVTLzSNJYh3uvqLEyNvFzqnTPNSEyfHN	1928	2748	2748	1616433840000
3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1646	1228	30	1	3617	jwoKeCwk96mXy5Htu6zNwGmJhySHkqRTci23d1vamzw74SrWhfH	1930	2750	2750	1616434200000
3719	3NKvRAyMSb9nfDXWZ1kpu6Pp2MFfBBjUQ4EPwHAj57yjAh37qYnW	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1581	778	30	1	3620	jwA7vaNPRxGEkSg2NLY8zD1uSxc1f9ceiL29V6aXvxcRpMm9NUP	1930	2750	2750	1616434200000
3727	3NKS92M9MhioTsww4HPJkfFJK7Ntw8duwjHApHQ8WRWTa9PKLWtR	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1549	1236	30	1	3628	jxibiU3KUrhFpg13eyDWzWJyyazcq9rcQ18kaLneymAStErn32P	1933	2753	2753	1616434740000
3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	3732	3NK7BKVBC3JQehHVd7xDQa4MKivEeFBmgh9KyC9HjR3JbseoEM1L	1455	1332	30	1	3635	jx1VYEHLqxU7ow6ZgbmoMHDecJwksQbw4QsjFSQrTCn6boMbz2o	1937	2757	2757	1616435460000
3743	3NKuwkEcWc3c75p4aQGewue37rtQdaXgbtLfPbLVb6rpvBFMgNY2	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1560	1291	30	1	3643	jwmATs27tesfmSirGPD7SF6BhFmgBxxmGjuidzYLkqPH7yuBtbz	1941	2762	2762	1616436360000
3745	3NK8jPqa7eTFTEt38n79fYG1NF41fq8UVogaFikW1wV8su3qAQG5	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1648	1284	30	1	3645	jxc8MKatGSTYEXNF8L1mQBR8n4pT3pATyZjU3K3aivSGuTTVFma	1941	2762	2762	1616436360000
3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	3747	3NLXPmFK5fN1u6TYCJvFZ7YF8wV2ceb2Ddv2DTYCfr8fQLt8wbnr	1422	1337	30	1	3648	jwXheMq8YAGpsNBihQpmZdgut17phRDazBLcCpyNhJDkxY7nhkC	1943	2765	2765	1616436900000
3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	1483	309	30	1	3653	jw7CnDbGJCMsVejWUaeMF9iidGguNGhZhq7gfSZyudLu2cvjYeS	1946	2769	2769	1616437620000
3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	1403	823	30	1	3655	jwSuLPgaXtMpvBxXR81Kj9LjnuHBN5CJH4NRFAEjUTRRoH6bJoL	1947	2770	2770	1616437800000
3758	3NLXTQpNkpKzZFngsqu1yZxHjVXNYmwZYWstgWbjzdUegpTQHWqY	3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	1650	1129	30	1	3658	jwaeydygJK5pifybJCXyd8T6X1LnafVuFHkgph5KHi4tWM4zD96	1949	2774	2774	1616438520000
3763	3NKqjdbUUkJfTfyVJnuNKY55wyF8MpgwAjBx59cjVgaVcxftvqMJ	3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	1407	1395	30	1	3663	jxcnh4NmyeQrBKq6jXsKk49fKrKtXFRc6PcjoZxZGAjzi6nPEaL	1952	2777	2777	1616439060000
3766	3NLLpsQk6JfQoCSKCyB8UUBxc2zWaW5TePDDiNxJ7rxZeavoVvzS	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1458	1323	30	1	3666	jy1dG2ma8EkGsgozQC1XxPT2c4NsYfhB5TLCZrW4C6vxh1zx9Ca	1954	2781	2781	1616439780000
3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	1578	930	30	1	3670	jxKFePwunTBAGUfiud2SPZPJeH3Sp1DuLjprhBgi2Rrts37BM6Z	1956	2784	2784	1616440320000
3773	3NKo11ghWozniD2Q5UMurUpSDpxkRtCSLSNdsDy3bGyMYjUudbwz	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1602	1369	28	1	3673	jy1BE47euQx2HaAbHeMnXBjgQgHN2UWAnLxDQhZJHcc2ChqrFvL	1793	2785	2785	1616440500000
3779	3NLWMe2dqtmkv3YHRpLpHxQSWWU9sZbLAdgFoNzX3feEenPL8gbj	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1633	1144	30	1	3679	jxvxS8gvavVuX3x4bkuXcBY77SK5uRXuDWFbWnAWrPin916JSHz	1959	2787	2787	1616440860000
3781	3NLqDLyVe88TC8HnpGBWn2cFixzfZTABjryscwW4WzZVrcu6nFhn	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1651	1301	30	1	3680	jwfpi5D64aG9zVzvxz8me8ZnSivoNzhUHxZhoEpmbmfXQBm5HuT	1959	2787	2787	1616440860000
3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	3787	3NLpJxSEb3S86yiFNWaWF47WYGS7XjqRKmd6sPFTqiW3AT9cwFVu	1546	1339	31	1	3685	jxBKDpcXAhRbpvvYizW9mxbRA5yE4M9DQy58ix67UAQZgVB2GK6	1962	2792	2792	1616441760000
3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	1444	1381	31	1	3686	jw8aQyVpPQDrz8k2DFjDm5sudk1rzZxHJ9sAXLfEwG5VW2FH78c	1963	2796	2796	1616442480000
3669	3NKpC3UtrpvexbuTb4ehN3r9GmJiGjEzHGue2sBfTXU2Sn7fpU78	3668	3NKufVD3ChbmQsxtgjxWE9MUvPTfAQPJafwwcq7xcrcYZD4Dukcj	1601	1388	29	1	3576	jxp4kf469E3v1Hy4LR4Xsr2QMWJ3TFyXZHFFQVEDQp43WYRnHhy	1905	2718	2718	1616428440000
3674	3NKaat7N6vDYEGd5oMv26KycTHqedNhXoEK1B2trhJZpxAHPGi9j	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1670	916	29	1	3580	jxabMfhLw4TRwEnMTqgzppfpsub6ZDSUGQbYeoACXD4yyLGtQFe	1908	2721	2721	1616428980000
3678	3NL99hnwTykfTLo8JoVpRdwsQXzqHHJXAK3KKvAbcds5NVrzkmvy	3676	3NKnFJCUTrbwo2LrAe1yWYfRg84jLABTtzmCsJWzv388piqeqqdp	1460	1078	29	1	3584	jx4Q1vGne5XJRFF1VJqLgAGmHAGoSqe1s3Seiz9tLZRAQB3Xe31	1909	2722	2722	1616429160000
3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	3682	3NKGufTef2ohMBEnJuGdU1kam9ZUVGhEmWB1gvftF3d8xpMJs8Dd	1481	790	29	1	3589	jxpYi9P995kbjjVZNTSNPc4a7pVxgwWA9ap6igXe58E7iFJpPnT	1913	2726	2726	1616429880000
3686	3NKAjHTQP9SZzNNa6b7mZ7QQRUBy1ktrYJ8DssgzqMoxJshsSi8p	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1406	1393	29	1	3592	jw8Qtm5hQMt4uoJnPxn36wwd3toXvPyiWz3buXVjnAwvsmzGT4a	1915	2730	2730	1616430600000
3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	3713	3NL2QTTDMfsy1AaQEhXSYXGamRfCoXeFBEpPaUSPiSEZaDUcNNgD	1403	824	30	1	3616	jwm7JdHFiEyfcYdYzBrCTise2ufkwcKaBqJEThQvbNqkSaECByQ	1929	2749	2749	1616434020000
3724	3NLVeeC1KCXaxdaGASoGqAurp5pAf8Cv3P1FaDwb6zLCvtpBa2qk	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	152	1330	30	1	3625	jwKxfsZiKgrcUkhPco8sBcBS988vma1i1UNfA2WoqaCdEHcCeBg	1933	2753	2753	1616434740000
3726	3NK35ydNasAevZXLemiE5FYwst7goJbavzwMKyrFC9cSLW32hiPU	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1508	1387	30	1	3627	jxW38JnEpWpPPkpWmasxao34b26j7NtUCfRxr9JM6pkDoZjRRni	1933	2753	2753	1616434740000
3728	3NL5yfUHwciW9Za9z7ypEmzqe4pX87EF1BiEoSrKbYbN7QFpE53k	3724	3NLVeeC1KCXaxdaGASoGqAurp5pAf8Cv3P1FaDwb6zLCvtpBa2qk	1601	1262	30	1	3629	jxUjG6VRs7jqJvMnqEvQgJySF5HegHffPaAagTZo2wd2eYtqeG7	1934	2754	2754	1616434920000
3740	3NKfbGaiQpN4uRuCydqhfP8CoxANbyt5R1btN66ok1ghrmkkXX4r	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1457	1025	30	1	3640	jwqntC9CjSvx3NHxjWDPPfBoRDHCJwia2Yhnso4J3BXBQZAk8pX	1940	2761	2761	1616436180000
3742	3NKr5J1H3EozQvEX4nnkf96CTt3ery5sgnoX7MEx2DCRScbLBw3g	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1585	1120	30	1	3642	jxgNgLqCcbKgdwVjjHdurvEKfNGX9oiou8VSSMqSR9AiY2FF6oL	1940	2761	2761	1616436180000
3750	3NKbUhDXm1JwniMCQzmg2J7Dg3c6n4fyPQstqr2KhD2mw6kvbi4P	3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	1407	1395	30	1	3650	jxwWkfSB9bup82h176MMH7ABLSXHVmFdUmsoRMPgfGFpDMge1oK	1944	2767	2767	1616437260000
3752	3NLu7MKti1uymq5CkEvRtb1syPveXgSjKG1wmhXQMFdyHdp6oi5W	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1483	309	29	1	3652	jxQaru2My7QDAJnSQEvVTi78huPy9J5SLJSn9h32WS3qFthgJb1	1919	2769	2769	1616437620000
3754	3NKitqrh5wp7f6m8XgsY1r5gnfVVp2jhk8joCuEQXzbDNSx5ZHLJ	3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	1631	794	30	1	3654	jxVaXbwxkjDV9gQ25yszF1zSYuQrVyCq5qmHb7C99JL7nP7HJUJ	1946	2769	2769	1616437620000
3757	3NKtucaDWDXHDbdRjoyT5ZDzjWJwDV1N389oTHwFC9eWX4dJDLQC	3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	1500	1171	30	1	3657	jx7LziB7GThsgGQUzYNNSP63R9ZeDFvKjjn9pFiieC7R5e7yndk	1949	2774	2774	1616438520000
3759	3NK8ZWWfVSMAM6od3vDHPF2awjEg1nEN4b62FJbGUAfCKy9oCGCy	3640	3NLT7uFiGFQUkT453FVQfLarpPvaoTbAo5sPGF7NAXjHiUfN4o9Q	1513	1133	25	1	3659	jwAU1VeoBrCCSp6EANFe1EDwLHCSf93AszG3pzyKAvekJUn87CZ	1713	2774	2774	1616438520000
3762	3NLRNte27CJ4eZXwffJjBXdfmahmomiSN38eQgNCHKJA3rMVpDFE	3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	1406	1393	30	1	3662	jwxbUBKk4jj54H4f4B8aFV6hfThQvavZQp4absxoHVtXFfJKZcY	1952	2777	2777	1616439060000
3765	3NKY4J8wkEukJYdMeVHYwQNef3xcv2UJXu7XKVQKzUusgYShEZWx	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1444	1135	30	1	3665	jxn1hJJ81XFPPHzPmUtwhn68WkhrcmMEgTgx5LSiaU4oZ4AegZF	1954	2781	2781	1616439780000
3767	3NLDVGH28pFe9xwjHrx1coFeXdRFk6SWd7vqwDJ6HW43FoyTiHBv	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1483	877	30	1	3667	jwv4D7PoCr29D34zLuK1HXMozdsmJTAERQDG6RH1sEnnUaBMEMb	1954	2781	2781	1616439780000
3772	3NLmD6DccVF1RXA3PhDp68jLKv779s8T3EvH7Ffhw6v1R1KHaPVX	3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	1602	1369	30	1	3672	jxgw4jcE2txKuggs7PKkCaUpNMUfCV9k5GYXWMbc91vv6XnHNJW	1957	2785	2785	1616440500000
3774	3NLgtJ4w8YX2oh96GCuK16H8W8gVcgr8T7m2i58yaZ8646KyZJpj	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1602	1369	28	1	3674	jxiCKZHLiTobXvtmxvytPSQZNhgDGv2QDYyq8PMYzgS8kbqaPkD	1813	2785	2785	1616440539740
3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	3775	3NKbfe6CowwC6VVavk5hMUBFuPj4haFuZsVBTTuf5s9JZux4x1bf	1406	1393	30	1	3678	jwyJDgGrnESRcqt86gR7UKBKD8kZ2yib8kUakoKie7vR1vMMr8k	1958	2786	2786	1616440680000
3784	3NKGPZGporDxG3h3Bqm97FRvutobQ5tgyrTw6Gp7ddRSLyoLQRXC	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1403	782	30	1	3682	jwEcAmbcA9rUvDqi38EW8s58Nu4hVgExN1pqeqFJjgxNkWYxZdd	1960	2789	2789	1616441220000
3787	3NLpJxSEb3S86yiFNWaWF47WYGS7XjqRKmd6sPFTqiW3AT9cwFVu	3784	3NKGPZGporDxG3h3Bqm97FRvutobQ5tgyrTw6Gp7ddRSLyoLQRXC	1407	1395	31	1	3684	jxgfBiAKhZ6Z9mK5r3yUEH5q8tGAEoVxTnYRvMbgmiFtBRJAfPK	1961	2790	2790	1616441400000
3791	3NLggzCox6pp8jmBDjZGQ5XaZBUfkdhJAqykgZgVEjorSY3i1s12	3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	1640	174	30	1	3688	jxo2iEne3DCCmNbfwmnkf7BqYG8WU3tL5J8DMxBV63xSDRutEJC	1947	2797	2797	1616442660000
3793	3NL3Wvvzyk5QrYhyLDrphVNqoSHiSPfd5xAPRXQkA5qJx3EYTaV6	3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	1581	778	31	1	3690	jwpEwKK3JsZzR3ybagwgGtRVvHu1ywLRqL3dtbWW9sNfYJqqZAM	1964	2797	2797	1616442660000
3798	3NKQ2Q6Ys6jBAcCp2xmbDed4Kcn8ny2TD5Z2YTNAWh8iSwPFH5ev	3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	1407	1395	31	1	3695	jwXrniUGcNhi4hc19ewzYSXNWzDgc7PWo29JWPey3ADfMXCv6m9	1968	2801	2801	1616443380000
3801	3NKGYPxVLH7cDgo44RJMKoD9pGnopZh7V9VRd9odxyVuFdGRDc5H	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	532	1303	31	1	3698	jwBvX1doByz52vz6p5bMx6WqP7maPsqkBGqoVa3kfmV51BBP9Ja	1970	2804	2804	1616443920000
3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	3801	3NKGYPxVLH7cDgo44RJMKoD9pGnopZh7V9VRd9odxyVuFdGRDc5H	1573	1318	31	1	3700	jwSUsT4r6idDvZ77U3bfyEpx6aRcFE32U2aEKfCRh662YPikBn1	1971	2805	2805	1616444100000
3808	3NKnUxffXV3vKEX9Z7UfvvsEduoZpxfmibQrx4ntrafC2wVP87Bd	3807	3NKshXrALu36Q4bQRVmUcnnwgCo2Te9spHmxTfiCqAe4DKLmniLX	1406	1393	31	1	3705	jxSZFEHYNCgdchTcQ4CAaZg86ZH7qUjvwLRxyQNdw8X8u1yTW99	1974	2810	2810	1616445000000
3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	1407	1395	31	1	3708	jxfRmBtVxRdbZtrDagpV3z4yCQmVuedFs1eMWWmY2o673pbRDN9	1976	2812	2812	1616445360000
3813	3NLHhwp6MHcdQy6561VnCQSJVvNpvJn4W6LVRv493qPjYYs9njZN	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1652	1315	31	1	3710	jxhti67xZeNke7XtmT41gjDPBioFCJGDfRvCk7eEwHfDFUJheqD	1977	2814	2814	1616445720000
3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1445	924	29	1	3578	jwRgSny8NmVvGhxS3HxXSkZk1JdDvpZpepZAhMck98L6DwkZVUZ	1907	2720	2720	1616428800000
3673	3NKJBZ6zUQJ6hTvB188LGz6kiYya9D7cD3FautqqR7eZ6VyzdYAn	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1587	1111	29	1	3579	jxvaPLA1Fm7pVoVPpWYSiP5nhRE5YCUVLq81QQXoFtVeiTTCGD2	1907	2720	2720	1616428800000
3676	3NKnFJCUTrbwo2LrAe1yWYfRg84jLABTtzmCsJWzv388piqeqqdp	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1407	1395	29	1	3582	jxnefG9NS2uoautsgkrEcnrtcaf2qT5Wu8jtnLwTw7R7crS8Ytd	1908	2721	2721	1616428980000
3680	3NL1nSFSsBM6x2aYT9FbYaG3NBXbWfzxkiEzyiwW57nKoV1XET9F	3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	1483	1276	29	1	3586	jxLmmq297bmgdNdvq31VJFRCWB1chhzZDUS9r21jhYcSGDYaHrZ	1911	2724	2724	1616429520000
3688	3NLd9D3Z9cGpeeHWPQztqkReVmxhrZAX7dg3kiGXMSuqZxwiGfqE	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1637	816	29	1	3594	jxHqe7NDk22TBkcdEFLYJShFYyFYZYoMSWMFybyqR2rzubb4kLQ	1915	2730	2730	1616430600000
3690	3NK5C24wh3eKaaJg12rqgKTScoHK2zap4Whc1qCczr8TZjuTrhoE	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1642	1121	29	1	3596	jw8ZxkCpTrecM9UY8jXLb8kaQhjKshg4a2VEBUKjgpVfTVzasD8	1916	2731	2731	1616430780000
3692	3NLmCmCFguBW11x1KNtQdbB6aHjWTAMyivzYdKuwkjaHfErPMv48	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1577	1327	29	1	3597	jx3nZtMHNeD5GTR2RczNt2m5d1ctuwNrT3ijjpdEfL3UXLSKBPC	1916	2731	2731	1616430780000
3695	3NL6hYZbGFxHeXQDKNXBBAepGWCE8ta8rwgUK4Msku92gyBuDcLm	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1651	1301	29	1	3600	jx4tKCni7YKQeZhksFhTCJ6kvqbLcw7bCWe2nVdKLpe55gx7PTz	1919	2735	2735	1616431500000
3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	1406	1393	29	1	3601	jwK3MtUtvajPQgcpvpWf5P7tg7wq5xa5wAWhDV7c9fMRXXhY3Pv	1920	2736	2736	1616431680000
3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	1406	1393	29	1	3604	jwsjwSiCWNXbKErnK8dcKoTHFPXQpkt43p6uvaMoXxzB5YX1ND7	1921	2737	2737	1616431860000
3702	3NL8zFUA1eYqUshwNrbmpCs3GyxQrmG9GGb45EeHrbLCR6MCMEcg	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1489	1380	29	1	3606	jxLwBQ8cnDAcCsPJRZJG59Vc4QAPLeTPvZdyGMbinh1UxZjvQnm	1922	2738	2738	1616432040000
3704	3NKKYrdmScuwFhVu5F2eDxkBHiLW9Ys8CByTBNYED3zkupmZrJ5N	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1458	1323	30	1	3607	jwWo1PtXk2M5w29QyBL4hH6Rp1bdwyeS4JUea2KooeNz2k7ooV5	1923	2739	2739	1616432220000
3710	3NKa2xSaBqLZ3o6vQhDtS3tUauK3CaPx91p7coBa5eV6sJDekyrQ	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	1571	1209	30	1	3612	jwBDWNJWAFW88Ht4dYATtCjxG5de9bFy8b1jDZFTQTVLN7puLmH	1927	2747	2747	1616433660000
3717	3NLwdAUCeEHTFiPErm7EjzeRKoAQBKFTTSKJEo7HoDvEQxAhqUUo	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1461	1271	30	1	3618	jx4bY8SUfDCLtvws59PA2CktZHd6CN48aKWma5QeTxYYD1bYqj2	1930	2750	2750	1616434200000
3721	3NLB1ZwHTzgZvPEF4LBjXHtdsQgbepFjotFToSBdoy4G1QZVhHQu	3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	1407	1395	30	1	3622	jwcZryqrUfvW3s7hcW4oAf9Go8i29su3vspiVBV1dwpqE6Pm9Sq	1931	2751	2751	1616434380000
3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	3722	3NKmtfU2MD1CsZNA1borssZXz335D8naQAG4vA5ymR5zemtepAyW	1402	850	30	1	3624	jwMExbZCbZvH6QyiNudDST9X7X4iTZXDbKDM7M6vvcNAmPqtKny	1932	2752	2752	1616434560000
3730	3NLFNjF9gJLbrxjERugyBdQDwtwCxuMoqYQLxXbTLVsRkV4yWwoz	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1579	1263	30	1	3631	jwPZbZaGBziqEFfwjttxvk5vDEizo6bUNXLJjA3DV1jCQwEyUtE	1936	2756	2756	1616435280000
3732	3NK7BKVBC3JQehHVd7xDQa4MKivEeFBmgh9KyC9HjR3JbseoEM1L	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1406	1393	30	1	3633	jxru9H5j1hJKHnB3rmJVz3DRSSiVip2ujwmYkK5gCkUibFFzUXV	1936	2756	2756	1616435280000
3735	3NLqfeT9SjT7xSgvQCpVKMgwqxXr4PwQk1nhvmx9QPHhUvBsL4Qx	3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	1651	1301	30	1	3636	jxrrQ8FbdaXYV9LrFNsYzTwhaPvDGsJoDh7fhdzjC5a5smpeqYo	1938	2759	2759	1616435820000
3737	3NK9ZRgVcsKEUMHtqfGdbCtSMgkZZNWq8APrb9weUT8QHMG1Vm5n	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1654	1340	30	1	3637	jwXwjyZVL4GukruoKEcy2Wxe1MiquRUvomxvWBXssvgZu9m69X2	1939	2760	2760	1616436000000
3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1573	952	30	1	3639	jxP9PkyM5qDnL4dPy47NpggUvnpdpoK1Hwhnc7ZahnxLPTBYuAG	1939	2760	2760	1616436000000
3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1407	1395	30	1	3644	jxvjAMJceorUnKjxsz4v8iw3LPNFWPvARTdQA7PZvpRZyyckUEH	1941	2762	2762	1616436360000
3746	3NK5StAxBCKUeEjEPc6UaMikdTVjQr948a2F4cnUoW4bmCxpv52Q	3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	1534	1191	30	1	3646	jwYUcPPTs18Ubt9dmU65NbktK4L96oSmvB9EHesK2HJqKrHybW1	1942	2764	2764	1616436720000
3749	3NK76pK3AkYRvuQMuoJgcv48sLLTJDYLkaotJ8v6GuW21jhj7xj3	3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	1403	824	30	1	3649	jwV4rbnzNcfSA87Tk3eXSCXkQEqQvxXHec69UyVpPJU3RYdUKcz	1944	2767	2767	1616437260000
3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	3749	3NK76pK3AkYRvuQMuoJgcv48sLLTJDYLkaotJ8v6GuW21jhj7xj3	1403	824	30	1	3651	jwYgsyEWwBJKbfpkoTDqXSRE6gMRonGC8XdTPCZfyChUua6UnRE	1945	2768	2768	1616437440000
3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	563	1359	30	1	3656	jx8G2YyetFW52fPfBmfo7UiRuFTtdYU1HB8YJ83uhsmdH1cLSVZ	1948	2772	2772	1616438160000
3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	3760	3NKZXF36MyygqyaLuVXrHEYy6W9zKAXcMnSaCYTQB136MgUyhutq	1578	1296	30	1	3661	jxxzGHaiTYoXsq15wBGMi9ne7pNmBjrnBdUhGZmynb11WRHvixW	1951	2776	2776	1616438880000
3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	3762	3NLRNte27CJ4eZXwffJjBXdfmahmomiSN38eQgNCHKJA3rMVpDFE	1609	1207	30	1	3664	jxHN4nX1gjdDtWouSd9nY6zczXAik52QU8z34c2DHagzqVDPqmZ	1953	2779	2779	1616439420000
3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	3768	3NKUMo9gkPHMykkWkiCdPZ84BuAoPNm3Yr7TJirQXEA6cj9yzDhh	1593	1346	30	1	3669	jxpgQidtknrG3jot8pDv1SkkmVt8VE5iDZFaftwM81NxUJTRXwn	1955	2783	2783	1616440140000
3771	3NKHqSxBCdNgQvmqjjWxZ4YYswUqyoHDPorAv621ydH53rF6yFXv	3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	1406	1393	30	1	3671	jwCmZDefh8i9NoB4NsqPG1W24yiFs9kG8NUDWT5KJRSBAEEr4X9	1956	2784	2784	1616440320000
3776	3NKmS5c1ukGJpPxvHvFQktMy2EWgUpCegR8qrS2ZsJAuqHcVW5Ax	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1602	1369	28	1	3676	jwWktZsHeWxDv55Snk9CutWYor2joDjp6kPHkSykUpNBQY7DWN4	1832	2785	2785	1616440580632
3783	3NKS4r6SHGsZMv5RvJLvVTfQpYMNKZ5tMD2ib1DdUWPiV9udJJjn	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000
3777	3NKz5LoyWfVm1DbFbpLDFDzwnm6W1t1rc2toKhefB3PhPd4trWv2	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1602	1369	28	1	3677	jwRn1vVi6zupfRHfCEBVrFUdYtZLjXQYMFEyGQBiWrdD8QePoAX	1850	2785	2785	1616440620053
3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1651	1301	30	1	3680	jxwBtCQU2dUPxz3FbsdAGgdsJ5Sj598zqFPx7z3SB4ah8kqadY1	1959	2787	2787	1616440860000
3782	3NLQxuZBBMZ1P6RWGF8LQ3twbHMCw3Ue1WL4uXRQjFCgMN42Crtt	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000
3785	3NLZkrRZya12bxvJ5ATDHVj6xLmwKQmWDDqfA7DrJYSYRPns7Q9E	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000
3786	3NK3G9WHwUV9Lk8xeNhPh5fAK1CB2EaxebTiEHTQrPPrQJx7sGwm	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1623	839	30	1	3683	jxM76gW5LNkkN7sV6o2hSsfHHtP1B9QS4mFSEAAjwUL8qJTvGtV	1960	2789	2789	1616441220000
3790	3NLMnzKhYkFLWw5UbS5aRzcDLfVix2q76Nw15659WgfX1EiaFzCS	3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	1440	1251	31	1	3687	jxHV2ydyZWsmzijrBAqHJWaHbLB9aBo2mT4vdqG2ZxqErk6JsBN	1963	2796	2796	1616442480000
3792	3NKTipy3tHkTZ6ZwxpqBHh9icvPZKHnuhe3dt1QoxMVqEkpD9Mno	3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	1640	174	31	1	3689	jxtRHmY3R6Q4gm8WMVnvCuNVo5UqhJkSGujZ5dnzSqDsvFntfdJ	1964	2797	2797	1616442660000
3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	3792	3NKTipy3tHkTZ6ZwxpqBHh9icvPZKHnuhe3dt1QoxMVqEkpD9Mno	1501	148	31	1	3691	jwd2Fv8VcJpRqUQcDGv25fwyp1u4j7eQLmsot98rCSzPtFCZzCV	1965	2798	2798	1616442840000
3797	3NKNMQVjiEMkiD5GnazPz8hLMNRacrBLXj9L5RbDmooN4TK1Kz87	3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	484	1073	31	1	3694	jxsmik3GTRbREYSaMT82PJLwqabpZz1WKFkyXPp3Jme6a9Edwjd	1968	2801	2801	1616443380000
3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	3798	3NKQ2Q6Ys6jBAcCp2xmbDed4Kcn8ny2TD5Z2YTNAWh8iSwPFH5ev	1617	922	31	1	3696	jxEgowiBck34AYZCEHVc3S9nLJ9XRsMvsgBdCrUjFp8CkKtVowk	1969	2802	2802	1616443560000
3805	3NKwT2YShrCSjuJRk32wfnF4rw56E2M2TMYdFgh1wtf3bwnKeZFR	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1522	1322	31	1	3702	jwK6qhxJ3Vpu7ziLSK9LKvBh2p9q1syrmkCnbea2wNBmRP96vPG	1972	2808	2808	1616444640000
3807	3NKshXrALu36Q4bQRVmUcnnwgCo2Te9spHmxTfiCqAe4DKLmniLX	3806	3NKLiwH1EX2aGV3rJxMCEuPTHmMpVx9YG9VQK6UYA15ft7mJuinv	1546	1213	31	1	3704	jwdvH6mfBw755Q846j1gTW1p7bLqHsad29hMhcnPnyyYtcaLrTR	1973	2809	2809	1616444820000
3812	3NLWZJnjrM7EjamLMwSVnFt4bVJHeXUB31kevCGRYDPzyfXRkU4L	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1407	1395	31	1	3709	jwz4nJBaM1FvyJfnpu2kJtZXKxPkj2jpPCHPh6aeHRXWXQcHoCW	1977	2814	2814	1616445720000
3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1406	1393	31	1	3713	jxk8Ywis3MUe6xgdcQLSFTkCAp1Pu2h6AZpNiNjmcwRNCbXeX4n	1978	2815	2815	1616445900000
3821	3NLosiSiGNRYwKn1szGQEZyn216b8Q3wqpMVh7Sg6vghKY8K3Sbf	3819	3NLgqA4qUdsoeVogrw58uyEx8fwFTXeJKEyr9PJ4ZLbeQnopGF2R	1403	786	31	1	3717	jxsQwgpx5egjGfhEctq9SZnvDbZthrVuRLS8jLf3A48N8MMQ7vA	1980	2817	2817	1616446260000
3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	3823	3NKenvs4qDPoykEMKB6WquAd9ApdAsa7f4pFMxuH4dVjKMcTgVzc	1406	1393	31	1	3720	jxCHJeXHxwwkHV65pN9hAFWLZ3ojFa9tMe8BpmAVHqtWGokL8YG	1983	2821	2821	1616446980000
3826	3NLBYstHVBsCg7arm5NvuKvPHLx8mYtEyYeauUsL45Cmp9tARyCw	3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	662	662	28	1	3722	jwmFHBVSWAkUJS2ufvFXpLK3JcStwMcsHPMSEmSNW1vZ7EAWHTs	1793	2822	2822	1616447160000
3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	3828	3NKrrcvrKZhHnvfwQ9mTYU1RzynmnfMPxVhu37LV2Sns4cVvwNPb	43	1184	31	1	3725	jwk6nVPGAHri7xuNPTtJ2NgVJsB6gJUF8SG1x88yv9hr2ytA67N	1987	2825	2825	1616447700000
3831	3NK9f3kSnvcctEkRTgknX6driFPdc1JiM2kYoRpT468xs33XFo8N	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	42	1115	31	1	3727	jxMsPN3hTvLAbZ3up4rdWYQ9hJ9aqWWsTmcfaVxEoch2f4eBokP	1988	2826	2826	1616447880000
3832	3NLV8G2zAkD477WsK2uu9k6kiSv4ey8ef8XksWPbQojQnS6QABsT	3831	3NK9f3kSnvcctEkRTgknX6driFPdc1JiM2kYoRpT468xs33XFo8N	1553	776	31	1	3728	jwz8gjKpDaADh7LB2bA2iyeGMjHeGLf4kov2kbcxnboCF1HZxcT	1989	2829	2829	1616448420000
3835	3NKugtjavkmxSZkHM5t7cf1pCCbd16oUPhvBsm9tX52Vn7M5Yg6x	3834	3NKKJgLEsLjqQHqnuM95HtJSq3696Nx7bJW8ehi5DyJYbb92cfNv	1481	790	31	1	3731	jwdU7G8eWGTyoG2rdqyCLNCaCStpo69odrfcK5cdXK5SEjRx1qU	1992	2834	2834	1616449320000
3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	1407	1395	31	1	3734	jwr4g8HACNzPP6uAjYjSCksnDcnjdD6rk5Kj3wCNG1e6aHDZzjd	1995	2838	2838	1616450040000
3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	152	1330	32	1	3740	jw9czh2jWGs6w8TUpSXBQANEQYyQmGBkhQpVi5ifAaz94rmmj5o	1997	2841	2841	1616450580000
3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	1610	1188	32	1	3741	jwnRNassGZyG4SXbhsGL6MntmJoUYARo6eFBuk9SUSKThtGLzA1	1998	2842	2842	1616450760000
3852	3NK4GWQAVN1k9th44ij1xrhDzigMqmXEJhhFvWa5RWKoHv4mR3ga	3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	1579	1389	32	1	3746	jwFSM749nQa2AEQGV3cJAw5HhKyUgZ6UzHHdGTpvdeeMFRs8CAA	2000	2845	2845	1616451300000
3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	3853	3NK8ukCSK6uqQjquoNdbSQHgaoNDJvbJvbFdW5xNWNBF7rkcQ9RK	1601	1388	32	1	3748	jxceU64ResCjMNdZx8EvBTK3u1w8bxChp2bLQabs2qWUU8NeQCB	2001	2846	2846	1616451480000
3855	3NLBrohCjHzr72HRYiknNsaiQch2UgQUcAjipwAeVHfKWaQmtbub	3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	152	1204	32	1	3749	jxsSWCqNV5q2obY6PWp8DXLKLRGCTUADcmHCmxzLfUYHDmR1p1t	2002	2850	2850	1616452200000
3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	1407	1395	32	1	3756	jy3FEUR19r1bPG7ny7572ie7Q9MbsX8mfbhPVLoGLXtRRqcjYwL	2005	2853	2853	1616452740000
3870	3NK5baDtoeXNW4PwjTdrpHkGUaaaUZ3YVateYVNGUZp4EdM6ytqL	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1467	1130	32	1	3764	jwdFeMr7FDdjkAiVHssCsBtHWXbRDBDLj5NF8bBwEqnYTfqcYzR	2010	2861	2861	1616454180000
3872	3NKgBfoekfUpL9Byc4qekYTHpfbF36NX8LEGruAAdWoX2aqtWxgT	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1585	1366	32	1	3766	jxsqV6bSNrtSn8HTUw3U17UyLa7fXGb9wZyGGPqXiqQYcD8g9pp	2010	2861	2861	1616454180000
3877	3NLoRE15kgusmnwnbvRvR2uTzMa36m9RkoNNArw1gAvfWxEmE7V6	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	1656	1217	32	1	3771	jwdw8A1KuztkoQ5kCcghNHxu22ReUu1ZX51hY1h975mJkqvBkcG	2014	2865	2865	1616454900000
3879	3NLGzhtGxHrm8HBq427NLoAeZZsBHp39KdkfNvqCRPyxXxNgFHt7	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	1402	874	32	1	3773	jxANAnKdwPjBbyTDYoBFFmeRqGkzcvZwApFgLJjwbBvMa4AXMt1	2014	2865	2865	1616454900000
3795	3NKAJCTrs2qYvXyTjtKdkEWJWRChK5kWQ2ka6ZeW35cAeP5zvoLL	3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	1403	824	31	1	3692	jxeCMGJBAbRyNvuVrHhdNU2aiyzo5sMX3P7CQoGdnhLWpbmxCyh	1966	2799	2799	1616443020000
3800	3NLZCSuwnYvSMBkxNqoaVkyuzgmPmfDkMk2mog1KZBj45kGqdxdA	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	1405	873	31	1	3697	jw8sJ9EzrjwUVmR18UQKVbXHw9tfyZXyVYjDj9jMqr1yL8cit2k	1970	2804	2804	1616443920000
3802	3NLw4BUQLKmtMcNVMVjb7bTWDRvPPoJfwKkXEzi97QR5hQ8Jowum	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	1631	794	31	1	3699	jwsf5BNygS1RV8EbfxJVMCYGyxmjFaNG3cwfELBMQAzSHosCndJ	1970	2804	2804	1616443920000
3810	3NL7vbLv2zjFViJcRXHZeuUXV8SgcbDz17KQKuuj4EjfjSzg9KYH	3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	1589	920	31	1	3707	jwRwz4T17WQieJLaxkFMj5SB7VKyXogFWFmyGBno22JFXnjaibS	1976	2812	2812	1616445360000
3815	3NLi59YrjJQm9o3QscrbsgaK5ULkHMm6J9fNE4GSqEa4fcPggXDA	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1651	1055	31	1	3711	jwv48iSVghcbH82vP6aLot4utsuxnMKaSxozytN91Wmu83wzpbs	1977	2814	2814	1616445720000
3819	3NLgqA4qUdsoeVogrw58uyEx8fwFTXeJKEyr9PJ4ZLbeQnopGF2R	3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	1630	655	31	1	3715	jy19oC9afxUGBuoKovHcqEwPJcNa5F6tsWFBBh52P8MQ3N5dccW	1979	2816	2816	1616446080000
3827	3NLg7FdvVDEYM7HrJbxgXHUY3QGzyXXiZUFGHp6imsMVqwwMAwha	3825	3NLiTLEGpoUjYecXesqhFFL58zjecV6fpUiWoCM9tz749jX6BpM8	1516	1294	31	1	3723	jwTLLy52kAdHViqu9SBwKQT7FZuX99qpzj8cjtqE9vWA8SXfBvV	1985	2823	2823	1616447340000
3833	3NKyQWAJ9AeA8GGB69A2K4LUSAB2eMz2GNC4X61CZfpn3mvaU7Qt	3832	3NLV8G2zAkD477WsK2uu9k6kiSv4ey8ef8XksWPbQojQnS6QABsT	1652	1069	31	1	3729	jxdKheiQ1LDeofCbKfeF2PGRWhEcuchNE54seCCWRgMfcKpEw8u	1990	2831	2831	1616448780000
3836	3NKDSFZN866cAN4eQyVEEGHPjqZrMsFqBq2Rh8LMMcfdEDBjFrH1	3835	3NKugtjavkmxSZkHM5t7cf1pCCbd16oUPhvBsm9tX52Vn7M5Yg6x	1549	1116	31	1	3732	jx1W2JGP375MUkwVuKTyWKQuzBrMWYCiwUdoRC4kkWAUcBfuTkG	1993	2836	2836	1616449680000
3839	3NLyCyhCspwAhm83YRe6NoFJypHctxqbzp8DZxKcrH8GusxgHewk	3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	1643	1299	31	1	3735	jwn2U18a2vFsu6xB6f8PgcgXriBAcXxLnGHY9jABhWrNypqXwfn	1995	2838	2838	1616450040000
3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	1407	1395	31	1	3737	jx9pR2KpKnbX598quSwxSKmZw12b5KNaUNPNmecW5dieajBzzyw	1996	2839	2839	1616450220000
3844	3NKt8N27m3iBuB9WXJQE1tXd29FH9GCrW3PhKHm2JSJCyEKijjMg	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1406	1393	32	1	3739	jxajMb3NukmtjBPjTbytSTxoGmKHQmTucwEbxUxrLN7DUKB9SJL	1997	2841	2841	1616450580000
3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	1451	1166	32	1	3744	jwoqczArYT6CNossAzowM9wkXUinGves12VY338o45TQjhgor9y	1999	2844	2844	1616451120000
3858	3NKgjpSHLj7U88DQocXqT15J4jcvozF4LBziyhe1uPRocJ4AZ6Cw	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1407	1395	32	1	3752	jxpgs5DXuzMqXfayaWZBRrLTMPD13eE9xiNxnU6U89ke65T9ap2	2003	2851	2851	1616452380000
3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	3857	3NK54ZgfDXE7ktCkaJr3JMJYYQj62mGKkAxEWWVZbyruWZ5CrQM1	1647	936	32	1	3754	jy3DQpVKsH3op9gMRxRmjCRS6kUor1jX3gpUg32V6opxek6GCnX	2004	2852	2852	1616452560000
3863	3NLdZX8dgyyxZE5vnmHnkZfMz8nyEd38HyQ4MizxscikD2aLpTTY	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1407	1395	32	1	3757	jwnDyh7bLD4GN49SA4a3AvyMK5BuSD3cycPioZDCypJi84S1Q1A	2006	2856	2856	1616453280000
3865	3NLsfgZqsPLFfAHV1uRAufdpxhkXp6TFuHwoN56K2NZRAdhjpBAT	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1648	1284	32	1	3759	jwC4ZTAjyUFe7ky1wByCTPHMDb14c32mwUiQJc9mn2zxb1u2CoH	2006	2856	2856	1616453280000
3868	3NLd7vVwymGfaBSGr5L2vgftpdnUTLKegbBVb97Ff6VyEbQZJfaY	3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	686	686	32	1	3762	jxRT2DCaSVY7burzScM6GaX89vv7ygkfDAzzceNLG295pfUsTc3	2008	2859	2859	1616453820000
3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	1589	920	32	1	3769	jw81bDrYJeZB93c9y4Tk8YeqSg8RqUNFjaNWSQrbtG3DEtHgFez	2013	2864	2864	1616454720000
3878	3NL2rZfLxe9spwgsZdjsfpQ9J8TMtv1jL9FdK3DyHj9gzqCJrZ2C	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	632	1382	32	1	3772	jxzBdMVZAnmrTMh83HWqvvTb4brMr9KJWtk47quKeebEU5Fbf4X	2014	2865	2865	1616454900000
3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	3881	3NKye5Wv98FC628RM53LqSr6ZJyCD5wZgPVkaHDxuPGv186W3njk	1460	1324	32	1	3776	jwoiSx6JEgdkiYWQZRbmscZxr9njxJr9jsp8sZm8Ss9uVHZr7hS	2017	2868	2868	1616455440000
3885	3NKmq8o5dbTR4NKsqYSgpthrMxwfyxcsMGVbBgTjGWSqkfuDZtHS	3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	1406	1393	32	1	3779	jxcmpvHkmveAFz55qz2ekvxouzCxe3doZQKSJuWKjYrvTGj63h2	2019	2871	2871	1616455980000
3888	3NKs7MrgZmRxR573Lm6qoaqJYcrwEZQWM6JmzpRR8L3JpT3nVPq6	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1610	1188	28	1	3782	jxjnfKhaPQS2QUJjGmT5wVeQcFPmuVDdBN48JGTfDSHM4U4sptz	1840	2873	2873	1616456340000
3894	3NL76gYCvq7csS5SJCkffyRY38fU4VYgF85DP3YUFPCi1Apd6yZp	3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	1407	1395	32	1	3788	jwuzVk8NBQdkh2aaCxeTcvsyCVP7vsUGxQJRktE8rmTUj73HyMh	2022	2876	2876	1616456880000
3897	3NLqxk27mRGL9UjxFvXbhuuvNZ1UaMzLW7dVj8fyjbAiynTGnTKg	3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	327	327	32	1	3791	jxeZSYXeqeparebAqGA8BK8Gy46f4Bna1w56o4XUyUmVozJCZPP	2023	2877	2877	1616457060000
3899	3NLahoYBqHYHUiNHezht7srSvAcwnJojimQ886UnBxZYAwk4YBzz	3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	1407	1395	32	1	3793	jy2Pqv9xZX6TgGU8zfLKbYQRttQzCFuqQNWKyCCxHFcAVJwhSMQ	2024	2878	2878	1616457240000
3901	3NKXioc4wDBPkyFX5zZZzaypNqU4msEw8CMRGG5iA9HY5yCXduB6	3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	1407	1395	32	1	3795	jxpYpSRTf6qU8dP7pSz8e3V9gVy2UBKPPmRudhLjgkwMq4dtxVH	2026	2880	2880	1616457600000
3907	3NKu8c7p5Tgywfhkh4247wBobxEq5M5GvzuzcFVN8BuTkZoYiXab	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	152	1330	32	1	3801	jxQtatzdpPzf4cjAwrC381tK7FCJGBit85VZxTsrUWS87BW7B1v	2029	2885	2885	1616458500000
3911	3NLoUMPTuTFbquNPXA7JsZfYgbKfp4inMzvPWLb5yUFWTwzXEWEP	3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	1589	1286	32	1	3805	jwXg8VXyLwzX16djmeJuMR1f4gt3ipVuzh6NnsjYek1HAijx5VT	2031	2888	2888	1616459040000
3913	3NKFoZBiL9HzHiqCubvaXhPr5ifNRvS8NjkhQHi2ojdodRU1Z8TG	3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	1536	1313	29	1	3807	jwkmYc46Hs2cjJHMwxynWLjHVWRkNukbqpBWRMHDne87LVA6K1L	1882	2888	2888	1616459075705
3918	3NKSirhNAiwnDf3XEY1p7VS2FrjcBeMBCPR5rQZJqDL22EWxSQ5L	3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	484	1319	32	1	3812	jwW6KAMHPtTkh4ueeH6oC9vzd5n3NTPaffnJr8pvU5EGbn5TLFZ	2033	2890	2890	1616459400000
3921	3NLtcb3ckBJXdGU3MUjTp2YrQNses3UYu7QJfRmg8G14GqiUZG7Q	3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	1460	616	32	1	3815	jxdbwRgyLiEHDzHT19fGweHLAvZ5K1CVvCPwevtrW3XbKavwVqv	2034	2891	2891	1616459580000
3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	3795	3NKAJCTrs2qYvXyTjtKdkEWJWRChK5kWQ2ka6ZeW35cAeP5zvoLL	1407	1395	31	1	3693	jwbaJwfxbShae2BAxvJtjFbgii2Li4jw6EQcYUEYAWGCkxiuwim	1967	2800	2800	1616443200000
3804	3NLRZWqTEYPQJGcwT8WXzEMrA6ju75kvupaWBSJWaQm4nfM4vWo3	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1602	1243	31	1	3701	jxvWdmVafPGy3s2CxAg4Xkd9b7Gyy65Qx41p3H2MHDA7NrgLqkN	1972	2808	2808	1616444640000
3806	3NKLiwH1EX2aGV3rJxMCEuPTHmMpVx9YG9VQK6UYA15ft7mJuinv	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1590	1300	31	1	3703	jwn2rNHh9fwRjBm57tuE9vfCLavCmAj6UkbrLMZYAimXZZerwn8	1972	2808	2808	1616444640000
3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	3808	3NKnUxffXV3vKEX9Z7UfvvsEduoZpxfmibQrx4ntrafC2wVP87Bd	1407	1395	31	1	3706	jxUnnk4aiNLzyagZktSfAHrPY632XoHLRv66nhqcSrUQzLTnXMX	1975	2811	2811	1616445180000
3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1651	1055	31	1	3711	jwU6dE13tYDusKj2F1ZNHQnYTSTDb2rinbkUDn5uNz3GXXV9vpF	1977	2814	2814	1616445720000
3816	3NKYD4rjQSKWuxNvepRzkFMLA7c2Qc4uNc3Zs9vDccjZQtEc9StL	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1642	1367	31	1	3712	jxVbU3z8nf5Xws1MQNPELrZgeaPfkDWDyYNWLYY1Pn3v2snE8CK	1978	2815	2815	1616445900000
3818	3NLDuTR7oHfP4W8WEqrvVAQM3fn9XVuKPdySfHn5xbVkFgQMAnjf	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1549	1362	31	1	3714	jxFDvZn9GC1Vxxensra4hLTqVqsmFKcoVquonUtX7GGDZmjYHUe	1978	2815	2815	1616445900000
3823	3NKenvs4qDPoykEMKB6WquAd9ApdAsa7f4pFMxuH4dVjKMcTgVzc	3822	3NKsWpRTUostgSQHZc23KuHeKQECJhqqTzvSA1RVAKLfm8KPH2fN	44	959	31	1	3719	jxZjtiMUm75JmZuW26TACCY6dPzx4d6YdeNJUS3GPaRuLit6ftf	1982	2820	2820	1616446800000
3828	3NKrrcvrKZhHnvfwQ9mTYU1RzynmnfMPxVhu37LV2Sns4cVvwNPb	3827	3NLg7FdvVDEYM7HrJbxgXHUY3QGzyXXiZUFGHp6imsMVqwwMAwha	1529	1070	31	1	3724	jwWqFbrKJ9K8QZTCugoXnz5gHpqvfQiX8N5N2TULtceLsjZ4Eqn	1986	2824	2824	1616447520000
3840	3NLcpV6BejPBSpZMQEfp2kmwj8zQ4QUaVx4CpyeWxRAS7pFUXqgi	3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	1643	1299	29	1	3736	jwgaFpeycLy6N4cv4BHnnAQidNm2B4S5nPvt1FFdDBgaErgPN7z	1891	2838	2838	1616450040000
3843	3NLxn7ztagH7Z5qETgJ2BhrmzXVwXW6tMkphJNThcnYGqmKXws3m	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1602	1369	32	1	3738	jxPzdA49aSDN84rMVreTcSpXtyob3KSE5YLotZdvrZGo4r8NZic	1997	2841	2841	1616450580000
3845	3NKMkBnH7yu8nNZXTBkfW9BP1gKdVTY3LB9STjRqCQqyaSLfEWwU	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	152	1330	32	1	3740	jw9czh2jWGs6w8TUpSXBQANEQYyQmGBkhQpVi5ifAaz94rmmj5o	1997	2841	2841	1616450580000
3849	3NLxHb1azxmQ4NZ7fF5U9MWa9G4xQA5HH1TqQe5HXhXArKC1j1ge	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	369	946	32	1	3743	jxkCDzx82n98JeugunaKyE7XSFWDREgnAj7W7pMBFhHFcmYSF3Z	1999	2844	2844	1616451120000
3857	3NK54ZgfDXE7ktCkaJr3JMJYYQj62mGKkAxEWWVZbyruWZ5CrQM1	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1447	1345	32	1	3751	jwcJaFVedG6hqdtoBTmXsuVDoH9Bw3EP2NKqWpU4PaAwMaSAJwJ	2003	2851	2851	1616452380000
3859	3NLD5LHiDmFZkh524doz7DBtG43gYYvkt3EdXfKnGG2ip9MsA11d	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1448	1311	32	1	3753	jwtdVrKvuxLYPZAdnEusQi4GgxZk5bRe1yXXgLauAmNqexLt1gN	2003	2851	2851	1616452380000
3867	3NKVnzZN14fZae6zTvKiaz3oKUYeWQPutLafyj5TEGAZcT1BFesW	3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	1406	1393	32	1	3761	jwLLy9HKHn33TmyuCD6xsZ6Qkm51adDZXEMyPjztVy2dUzSjA3X	2008	2859	2859	1616453820000
3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	3867	3NKVnzZN14fZae6zTvKiaz3oKUYeWQPutLafyj5TEGAZcT1BFesW	1403	824	32	1	3763	jwf5eb7TwZSmokfkWenLLw1pWQqS7wGzPRj1dgdhUNqU4f5LATA	2009	2860	2860	1616454000000
3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	3873	3NLuDqaQ8zyfwpWqtJcesK7f4B7QdDZtFWSPmEj5EXQLo3fpa2WX	1407	1395	32	1	3768	jwWRzFwJbCCuDvuTn8LmM4caZMxF3LNWDn5bNQgGDm8HRQz2DJN	2012	2863	2863	1616454540000
3881	3NKye5Wv98FC628RM53LqSr6ZJyCD5wZgPVkaHDxuPGv186W3njk	3880	3NLsyNzZfNiTLgWKU9F6Fvb7iZGovS9798Yy3MXdZdumPbf2gDm3	1406	1393	32	1	3775	jwA5ys4T2EdT5gHgtS643gHXGeJoNyCvg8kdAJ6uGuwMFDwvv4E	2016	2867	2867	1616455260000
3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	1406	1393	32	1	3789	jxbAWEsNUPfqrZG7YZPSx7To9WLYwDPxbrfatTmWF88dcayCcUb	2022	2876	2876	1616456880000
3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	3898	3NKFZcUbt4Pzd9CM6aah2Rc9taGWx6reuY5DuxRSfgCkZGDZPjFW	684	1352	32	1	3794	jxF9QxrVpjrZZ3uaC1HnirYb6pY8dUfWBEABsrXqpHC8bJsqqTv	2025	2879	2879	1616457420000
3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	1581	778	32	1	3796	jx99sjU56i7N8rE5KJqgfFQhTU8WosxtaGCZYkpydsvNzmKWdvr	2026	2880	2880	1616457600000
3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	3904	3NLCPLCHa7DGZoRv8p8yooPGF3nzsyZ7DxppXE87FW1u3mrDu5MT	1507	1034	32	1	3799	jwFLdfjBCc7M85PXkH7wsEzXqJ6tuyHzZXxpv8HwUV1dheHfsCC	2028	2883	2883	1616458140000
3908	3NLVwKxunL7DkjN4oV7XHuAtdkURtXf42vyzarhpTa1nnTQebbAg	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	1407	1395	32	1	3802	jx8EEs6TZD1LyNMks1yFdDnSJpDZcwJwt6sZ5Pt5fiWnPXig2nz	2029	2885	2885	1616458500000
3910	3NLYEffQP2jzujmQaNnbdkN6z8jtpCw3iUALSTUKUU4yqZfdCBzs	3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	1536	1313	29	1	3804	jxDzt94CzizfJ1FPqKHAxryptjXyYqDTxpJdHoCPeLZPbGziMZt	1864	2888	2888	1616459040000
3914	3NKSMh7xrVwB5ZUn2tWDs8T9AoUUcbKrKeSysXcbiYQmnRXkD1a7	3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	1536	1313	29	1	3808	jx9cRasxLkAi7SDk6ZdstwknZ7HCNdm3JyqBX88e9Vv8Dikie3Q	1899	2888	2888	1616459110982
3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	3912	3NKVyXSU3ZiN3eZnLbw3dGjPgQLQBcqu9q8vdSDde6mR9qvthJzN	1672	1285	32	1	3811	jwv7bR69oEp4748u2bWSFq5pjep59qgGJUQU4X199vKkWGkijqk	2032	2889	2889	1616459220000
3924	3NLhwJNUUawX5ZKiEYEcueX8qCmAw2GKDnhBGQAyHj5R9UMCoTuM	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1643	1053	33	1	3818	jxbj4LctnN4g8MiK9an8PkW3zjgEU9fPUYMhqrXnuQshUUmbQeS	2036	2894	2894	1616460120000
3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	3928	3NKMQzEnNJCQz1p4vV75KcGM27gFdCKg912X74W6PfUgHAe6C7Tm	1601	1262	33	1	3823	jx1YVL86KzMfxXAQXuoaNt5A9infDTTU6oJ23vHdX8u33WWLqgY	2038	2897	2897	1616460660000
3934	3NLNd1MFXQxe4C5XjxK7ddZLXQwxSyv8Y252A7VB6tgEZJjozNmm	3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	1509	1320	33	1	3828	jwrVjZUz6wMutzkb9yiRSGWEtwxhiqoBtHnAPY5kTfR9aJMnJRh	2041	2901	2901	1616461380000
3936	3NLr8f5JSksTMxXrab3dVcwP99nvj81FEZZq7MbK7FqXjUzUnBnV	3934	3NLNd1MFXQxe4C5XjxK7ddZLXQwxSyv8Y252A7VB6tgEZJjozNmm	1406	1393	33	1	3830	jwgG8hxRD7wEXKN56FfBTwVpcKtRboHXNFoCxAwRSVFEFcaHNyH	2042	2902	2902	1616461560000
3944	3NLKfCoYMzXWpmKgUCrx6SKXxM5qgKqdPDA49gHanAhDGUfaEuVo	3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	1590	1300	33	1	3838	jxVGqWudDrcPE8E4bcEtNdLkLiBVLmNuy8KaJjK6gN1TpPiYqcd	2047	2910	2910	1616463000000
3820	3NKhTADzgeHRjdFA8XECniPKV8ywycjKhfzaspNBizR71JqMW3xX	3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	1406	1393	31	1	3716	jx6xF9TqmbuEN9VoP6aWRBo2afBafZt3nzkxhqwtaTA3n1Bf6pp	1979	2816	2816	1616446080000
3822	3NKsWpRTUostgSQHZc23KuHeKQECJhqqTzvSA1RVAKLfm8KPH2fN	3821	3NLosiSiGNRYwKn1szGQEZyn216b8Q3wqpMVh7Sg6vghKY8K3Sbf	1407	1395	31	1	3718	jxbLH6FXefMqfzxqmFBDcnV5SQCkusjnuwUwYZXuenpnNyqZBxo	1981	2818	2818	1616446440000
3825	3NLiTLEGpoUjYecXesqhFFL58zjecV6fpUiWoCM9tz749jX6BpM8	3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	1549	1116	31	1	3721	jxqrnUP7ngYZp9BUbDLuivasQ7Fbm26LLhjPMLdzC1FKmiKhJ4X	1984	2822	2822	1616447160000
3830	3NKdTHU33PBZUutZMThatd1QAZQNU6TU7pZM7HnJbAQETmMuCCEU	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	1503	1031	31	1	3726	jxcQV6LJmN4qQMsZu13FUqkhktUEZhd2DapwcZqbKwzoYpt794q	1988	2826	2826	1616447880000
3834	3NKKJgLEsLjqQHqnuM95HtJSq3696Nx7bJW8ehi5DyJYbb92cfNv	3833	3NKyQWAJ9AeA8GGB69A2K4LUSAB2eMz2GNC4X61CZfpn3mvaU7Qt	1542	1304	31	1	3730	jwvQhmwecT16V6xTR9U66Q26DTLXfXa6y1294xFBsGaZHtoMsAM	1991	2833	2833	1616449140000
3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	3836	3NKDSFZN866cAN4eQyVEEGHPjqZrMsFqBq2Rh8LMMcfdEDBjFrH1	1599	1287	31	1	3733	jxUf2HWTPvipj7zJtSaggXFMqodJAJcQM9FcZT3uHr2MoNGPmV2	1994	2837	2837	1616449860000
3842	3NLBw9UFTCtV3BSucLGfLcn9F7eFheuyd7xZfiEf4FpJBmUcLoGo	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1602	1369	32	1	3738	jxPzdA49aSDN84rMVreTcSpXtyob3KSE5YLotZdvrZGo4r8NZic	1997	2841	2841	1616450580000
3848	3NLao2bekMvkFbXW7jBzCiiK2eD9PjdcbkWpBpFFQUpzcsyzjUrs	3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	1508	1387	32	1	3742	jy37VorNY4Mx6nib45RTuVCYErTfETXr8Kx6HqqjkohqmcEgju7	1998	2842	2842	1616450760000
3851	3NK4XLN1yZUM1fBsP3J1h3DTkeigT8FEv7C1NgtdCJLfMW3sDj55	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	1587	1111	32	1	3745	jxyvnU2dt8bLDXsZ8oyWuFsWpXyXHs7rs4gSgp9jGgPSBcwz9RA	1999	2844	2844	1616451120000
3853	3NK8ukCSK6uqQjquoNdbSQHgaoNDJvbJvbFdW5xNWNBF7rkcQ9RK	3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	1402	844	32	1	3747	jxVZQb3vNKE9d257v24LKjeoUXV6o11T4nR9XRLFhjar8VR9vBv	2000	2845	2845	1616451300000
3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	1668	1370	32	1	3750	jxL2J7sCtTWWXB8jUu649wHxE7fsD17kVbu3cH1Pq3p3EN1fkZ4	2002	2850	2850	1616452200000
3861	3NKURpTU2uJXninjGC2gkboVrh3jzydFfTr93yE4ySBw4sLrE9Z7	3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	1447	1345	32	1	3755	jwLbDyn3x4AZdv2VU8qYVDoJGefMVSB1SYx7jWikjTseNWo3fPK	2005	2853	2853	1616452740000
3864	3NL3EDKbTcK9pktvkvgbD3qdDzHy2H8uuZNFs5fRrCXMGztYj8Dd	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1596	1363	32	1	3758	jxYyVf3rBo52g42JsWcz4NnCUXYoMmFoLHWifP3HqVh83qpkHkw	2006	2856	2856	1616453280000
3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	3863	3NLdZX8dgyyxZE5vnmHnkZfMz8nyEd38HyQ4MizxscikD2aLpTTY	1652	1315	32	1	3760	jx2yD52ED3dK6b6AhSS6pdbih2beVAXcDiUtF7LfVd1iR9GoEQ7	2007	2857	2857	1616453460000
3871	3NL79qRh263EAJHQ1AYYAWrhLQcCMoEcSoWKH7frdwh5PXmZf9oD	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1407	1395	32	1	3765	jwJ3ocbkdG3e4nUapuj1xGB3Dr3KVzXkc1RKjbkynxQZLvg6g6D	2010	2861	2861	1616454180000
3873	3NLuDqaQ8zyfwpWqtJcesK7f4B7QdDZtFWSPmEj5EXQLo3fpa2WX	3870	3NK5baDtoeXNW4PwjTdrpHkGUaaaUZ3YVateYVNGUZp4EdM6ytqL	1536	1067	32	1	3767	jworAMLYebTZne5nxLYgHuYqmEGykwNhvCXCdELfas8QJyNghqd	2011	2862	2862	1616454360000
3876	3NKsgFzwXDwaZNhhXnNZBNoNkdM7x7YztkCxLt8Hjmc7jygQxDhY	3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	1596	1117	32	1	3770	jx1ziypJR9zrSeSRV8zDNC7o6egGdtAaTLbqd7qVgZ9wspcaTzp	2013	2864	2864	1616454720000
3880	3NLsyNzZfNiTLgWKU9F6Fvb7iZGovS9798Yy3MXdZdumPbf2gDm3	3877	3NLoRE15kgusmnwnbvRvR2uTzMa36m9RkoNNArw1gAvfWxEmE7V6	1500	1297	32	1	3774	jxfEYYGqAPHAZgwh8Vbxx2djbMnfMGXyvStgnTitUZpTSF3h7kr	2015	2866	2866	1616455080000
3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	1444	1255	32	1	3777	jwwtBvptrbunowSrfchTEY3wxpkFANgBGqh8P3cERAXVxRMzC7Y	2018	2870	2870	1616455800000
3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	1407	1395	32	1	3780	jxFZnAUfAPj9CBpTdNNF6uQpteV9VFkr9WYBYv4XfP75WWczDpH	2019	2871	2871	1616455980000
3890	3NKKNgGmAXQk1frzEiSqdxvTF1Hmf7X93DyjmuDbiZnzbLWQL6La	3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	1610	1188	28	1	3784	jxeasJMQEnutVSV3RNLDTdQGfDkMQ27kceCK6V9AvirZ525zzp1	1854	2873	2873	1616456379972
3892	3NLKjcuU84eW9AcWGgpY9uiBGWQnd28xRXsxH69zuqBCr1e82dvi	3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	1610	1188	29	1	3786	jxvHWgQdvxT6jPBbdznVa3YD1pXaSSTFsv7LUGsRGtW8CKXeGaM	1889	2873	2873	1616456457045
3904	3NLCPLCHa7DGZoRv8p8yooPGF3nzsyZ7DxppXE87FW1u3mrDu5MT	3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	1590	1174	32	1	3798	jwN73wNq2dcLY9ifpBur3eBUMv4Ret3yEMxWxaFqfMpLJw5fAj8	2027	2882	2882	1616457960000
3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	3906	3NKT8ijB2BTLBorpbfbfHeTDRHYNQ8oNgATU46Kf9apqWK6fuPhP	1403	785	32	1	3803	jxZ3s2g1ynraJW8v6R1YMSt18xtHFGiD97J26VJL4gZYgJKayiK	2030	2886	2886	1616458680000
3912	3NKVyXSU3ZiN3eZnLbw3dGjPgQLQBcqu9q8vdSDde6mR9qvthJzN	3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	1536	1313	32	1	3806	jxox2wDmnys4NR3oLGZ1v3AnHcgWte6hbategQphprDTSeFNQqs	2031	2888	2888	1616459040000
3916	3NKL39NYt9u1PB1X5gPkSQStreJVbhiwj8JiRQfkbhszPs3a6VsV	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1536	1313	30	1	3810	jwopTAv4uNwDAgGkfrQS2AtWmM2yCWFUfjrz2iDeF6MHmgHnKUs	1930	2888	2888	1616459180476
3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	1407	1395	32	1	3813	jwy4HYv6DA9R7RURkaB3KEYagXiMPQ8BTcHc8pNC3v4qBabnfu7	2033	2890	2890	1616459400000
3928	3NKMQzEnNJCQz1p4vV75KcGM27gFdCKg912X74W6PfUgHAe6C7Tm	3925	3NK3oAst5ZL3jRujz6t6HUodHRxUjYPRM8m1HW6Zf4ZJBuak5LtJ	1406	1393	33	1	3822	jwCixgg2kjfTdyVZYnGfrMkAtxVLdXvUkFMH71Ji3UFqsbeDNKY	2037	2895	2895	1616460300000
3931	3NKusKsD3GgCViPy4ePF8eN14rsWwLUMmZJBcVpbb1kAog65Axeo	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	311	1061	33	1	3825	jwudhRLJvSq9Dq68AhgiR6WZQ3Up5Sb61fYSNUcZRicETPnF3pk	2039	2899	2899	1616461020000
3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	3932	3NLH5GSGVs4zSB5UxrnvSvPrTxjQCAR2t6nX9fGNMeEwG5rrgwyf	1559	1353	33	1	3827	jwjayzorS5gZSy3H8L7hGBUa9GCpUXzPFY2WwBMNGVyPsqugR9e	2040	2900	2900	1616461200000
3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	1553	776	33	1	3833	jwcixDkNwpxtaqTeR5Xv5zibaNYrj2CoizxYPFQms1q1WX17iZU	2045	2907	2907	1616462460000
3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	3949	3NKgE9hYcfYw9VRhcMnqNmcfqqhQ37CnbuojMsbPZFM54ZzrQvGs	1460	1198	33	1	3844	jwHuGHdtvXW4Ah67Ek5XML9cg6zSm3yab1ke5JJq4uuyYsLfH2t	2053	2919	2919	1616464620000
3884	3NLMbg4ABm1tGgFdxiXMrJHDpVTHQwuVHbEt59CbF5PMfREHf8Co	3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	1406	1393	32	1	3778	jwPbpgGAUN28R5Xmi2j3JPA8NTcHFGPwsRcoTCQaHPYkTt8jeQH	2018	2870	2870	1616455800000
3887	3NK8TwaZNhDEsyfVsSDxnjbdANrTMXvSWdTvMfx6KgjhyDPVXQ4C	3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	1605	166	32	1	3781	jwL3imd9UXqN9rjjSYKnawx5yRMYezkJ6pytJmbmaL5EaR61xBG	2020	2873	2873	1616456340000
3889	3NLfBCiwcRihduYLuzjEYxeQfbhL1AgYnzN1Y3LYh1Auo3ekr7yv	3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	1610	1188	32	1	3783	jwf5uuYrKE45NqMYYcKbFD5Ri6ARPr3dnsbxkqMNkuGD7SwdeBX	2020	2873	2873	1616456340000
3891	3NKsHF86FXu1KHS4TmtfHoQZrEjHmEWLd4R4vy7wwFkQdkk2ATPT	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1610	1188	29	1	3785	jxTb8THvfVoeqzYtN6EkZGisMfxbEJQZny3E4TC6kWe2GZpE9rc	1872	2873	2873	1616456419311
3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	3889	3NLfBCiwcRihduYLuzjEYxeQfbhL1AgYnzN1Y3LYh1Auo3ekr7yv	1668	1244	32	1	3787	jwHQyXfJHLQ8e3A1KtWA17URntsXMnACagqjSKBfeAd4qFynYNV	2021	2874	2874	1616456520000
3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	1449	385	32	1	3790	jx3eQ6USb4zNye3UvNrke9sLUreqCPgUXZUriUDW6zhb5DbrDLU	2023	2877	2877	1616457060000
3898	3NKFZcUbt4Pzd9CM6aah2Rc9taGWx6reuY5DuxRSfgCkZGDZPjFW	3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	1527	1293	32	1	3792	jxxnhjPg66YPJV595fwsvqf3bz7X6epp7TTejjXAFeRG41uLW6b	2024	2878	2878	1616457240000
3903	3NKYQNHwvwqhQzEHzTNBHZEUXxC1azZwGaLLtEHsM8VHca3kF6HY	3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	298	1308	32	1	3797	jxHDAyWB1hp2Mqk1qhN7uAGZmzCg9nsESiKzgHXMfoHdKkDptAU	2027	2882	2882	1616457960000
3906	3NKT8ijB2BTLBorpbfbfHeTDRHYNQ8oNgATU46Kf9apqWK6fuPhP	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	369	946	32	1	3800	jxKgDSX99fBcBuwYKdgMVPQjqcZQwazeFaQkK9ipgZtvuzek3Bz	2029	2885	2885	1616458500000
3915	3NL5Xfmcf3FTMntY5RNqHjizHQYWbmtX747BiQsjHc2SMTA2X8Hd	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	1536	1313	29	1	3809	jwJWyMsXZBaMgCknxHcbVzXjJZcdwu2smPBh4QqNxVeTERjpB4D	1914	2888	2888	1616459145015
3920	3NLLHzRhaiG25rF1Y3mExCE7DZx7ivkH8ExPaknnjUk3b4QGnXEX	3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	1608	923	32	1	3814	jxPSSofxzG9GGUAFVtAtSGhR9H844iB9EsooHhgjCXZVWe5sEAE	2034	2891	2891	1616459580000
3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	3920	3NLLHzRhaiG25rF1Y3mExCE7DZx7ivkH8ExPaknnjUk3b4QGnXEX	1407	1395	33	1	3816	jwRvG9fig4DCtRXEZhF8pPiGGKuShWH5svSo1FVRZg8aw8ycX3Z	2035	2892	2892	1616459760000
3925	3NK3oAst5ZL3jRujz6t6HUodHRxUjYPRM8m1HW6Zf4ZJBuak5LtJ	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1611	1341	33	1	3819	jxgv5Fv5DdiD4GE5iBS6FU3ogaCEU9zmjbTzPxfSrh2mPUPtPrR	2036	2894	2894	1616460120000
3927	3NKJKSHUTXu3g7zgWzEKy1XrrjjjXu6H2Yr9fW7gRimNNxF3QBvu	3840	3NLcpV6BejPBSpZMQEfp2kmwj8zQ4QUaVx4CpyeWxRAS7pFUXqgi	1643	1053	30	1	3821	jwUE1w7axR2XFozYcYEFwGW5PKW2xYT4stVvreUuwSW1151EgM4	1892	2894	2894	1616460120000
3930	3NLy5xXzE25CzU8K7LNUHwfkTPUAB51bditADK6vAArmR5bXkLFs	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1447	1099	33	1	3824	jxpRNnsuJiJDRVF6CXmJbtL3SzkPy14VCwWoGygZdb1NkYfZVrc	2039	2899	2899	1616461020000
3932	3NLH5GSGVs4zSB5UxrnvSvPrTxjQCAR2t6nX9fGNMeEwG5rrgwyf	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1631	794	33	1	3826	jwK1pjtp8kk9kNTpKe4q4Prh9kE4kXfbgh6nEJM9fccXQBAJZ7a	2039	2899	2899	1616461020000
3937	3NKy93HL1WQrY4p3DQe9ZU7qfCCi3A9FGwf26gE41oV6b7xfcncT	3936	3NLr8f5JSksTMxXrab3dVcwP99nvj81FEZZq7MbK7FqXjUzUnBnV	1553	776	33	1	3831	jwfRsRUey3JBNvSDEHHb3Hs4ch8qyquEb54DxHrMsTH6jrtzxJj	2043	2903	2903	1616461740000
3940	3NKYXw7rQFWHx7mCrRaewM96pg3bVgiWHJJrBEeiR8Z2tR1wNU9z	3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	1624	1334	33	1	3834	jwJSGTVtTRu29YBMR3GXF9NFN6iQRhduSj2gxFD3CBTnWoSF8Zo	2045	2908	2908	1616462640000
3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	1624	1334	33	1	3836	jwT6Sf1h9REKvCTNBkpBundVRoCGPDyEU7TeF9r4UJEhisrLKen	2046	2908	2908	1616462640000
3945	3NK7Qvar8xVXmEvgeSRAHWhk9QUA4bwwfYZVwox5Z5KEgTqAGSqZ	3943	3NKWWoYis3QQcihoFwa2eoUtYo4NTYvdoENgPXfQUSzAgQt5BkaU	1407	1395	33	1	3839	jxodsrk7hb888sUwwfSE8J7BkgupSbKocioUfDLeF7DrDvQdWKd	2048	2912	2912	1616463360000
3948	3NK7MK7sBSMHmDVpeYuTBLiizCkMfxj9HYtqwon2RiGSYdjZtPXv	3947	3NKR2tQ1JM3TPpEtVjiBciJizHz4FPoGcxiZsHJPzE4z2zAtu9ax	1445	1290	33	1	3842	jxM8c6NuJFR6QKXZpJ5i1d8DZ95k1EScBpiqNkG47rHvXqUhEJR	2051	2915	2915	1616463900000
3951	3NLEk4KVeByjTfgxrFojMkqfvNDFx1huq9sg65JxARk9SXvUVR3N	3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	1651	1055	33	1	3845	jwA96kqKc8MtaBCaxRFyhgz2tAXmUv7ECCEymMwfiPCyKdR8x18	2054	2920	2920	1616464800000
3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	3957	3NLjYWqpJYpNryiPSxMLUsG27dhVNP4AxLrwFxBv6toHgmPXKaNs	596	940	33	1	3851	jwiuawbz22rpE14L6362pLQUtL2BBZarQQw1CXw6YjPkRX94phW	2058	2924	2924	1616465520000
3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	3963	3NKhrXXQz3BNFLMn7hRDMyisQsaxP34oMuQxpNGDhc3WkHj5ahoN	532	1303	33	1	3860	jwV33pr7qaUU51mVb8HnzPEHwREUyyc4pSZWJy6bz8gXwCRbioU	2061	2928	2928	1616466240000
3972	3NLbm26wFY3NRNJy7uaqztjQYkNTA3Gu6T3wqNb1wHQPq12a5vhb	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1426	1364	33	1	3865	jxR9wTjCYQaqckrpbybYW4NCv2A4jBvYqvMvnHUf4GXD5Qtwy7i	2064	2932	2932	1616466960000
3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	1406	1393	33	1	3872	jxm73kj7TQduyGTaD74KZ5qTvVhVvrptyQYTQKC2eU2JNAEtuhk	2067	2936	2936	1616467680000
3984	3NKoRohmoyvCEra5ggaSHBR9puk6UgN25wrw87a3bgRASVQDnXEW	3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	80	1273	33	1	3877	jwKc7cDiDV1EGmDv3zsCyzBLFF8YzjrwjrybEARfhCZPaxCr2F9	2069	2939	2939	1616468220000
3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	3984	3NKoRohmoyvCEra5ggaSHBR9puk6UgN25wrw87a3bgRASVQDnXEW	1601	1388	33	1	3879	jxKYtCm1AaBjSHD64FNd3WjydT1cZXVZw5JCB2zUBPMpcN2gLD2	2070	2940	2940	1616468400000
3991	3NLJi3zm8noqfZtUuHb7tb1sEqKsnB67pnf2iCTSSaBqn3MGAGkT	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1529	1316	34	1	3883	jxhrCr4hEyeyNNSdkupsufzjmXW4zQU9E5a8rLCGEH62t5fnGjq	2072	2942	2942	1616468760000
3995	3NLeLKRZovih5bN6yY8EocEaaV4dUb9HGorjKmb5MTU79UWQbWLz	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1406	1393	34	1	3886	jwMVuqjF9h977ZJ6D7yTK691dtvcF2ZcraSnH6pHtesRSJvVBTY	2074	2944	2944	1616469120000
3997	3NLKa3LbkNpSXNsfu1K9vKqmU9tSNek7CgtqCTgfArYnmNNXdTQG	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1647	845	34	1	3888	jx9cxWShKQZmxsSmkjvQQS1aVpx89MH4uy2PaDmLbCDERzNqvDo	2074	2944	2944	1616469120000
3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	3997	3NLKa3LbkNpSXNsfu1K9vKqmU9tSNek7CgtqCTgfArYnmNNXdTQG	1631	794	34	1	3889	jwfRcbjiySWjUJQXbtisEzNKx2N4KUVB7Rs1G3chH84RdNJQ1F5	2075	2946	2946	1616469480000
3923	3NLCCe8XijMYDA5uWofLFcZH3zSsRZ93q9k2ebA7GZ6t7p4Ymj8c	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1657	1098	33	1	3817	jwLSMBtK2NbwaNiiycEzyEkKiHFpdsM1QtfF7NqDKKk2VbmCB6e	2036	2894	2894	1616460120000
3926	3NLXgAnWJ42mcoJua8CMqavwhvj4TwS6xswz9auHatGjXUuqddvv	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1547	1252	33	1	3820	jwbHutcQ9gwiU3PYwpufb96e3UsMzKSRtq8i3sV64fn3bYSLuoc	2036	2894	2894	1616460120000
3935	3NLc4fRj8wRfpZEwiQDN95kymj2biyMtWcbMGx6nN46F2Mmzfnt8	3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	1477	1104	33	1	3829	jxLJP83yyLKrtn3yHMAX1PSViramBHX5ncXHojFpKJQ6MBpU4Cf	2041	2901	2901	1616461380000
3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	3937	3NKy93HL1WQrY4p3DQe9ZU7qfCCi3A9FGwf26gE41oV6b7xfcncT	1590	1300	33	1	3832	jwfVdufkWg683HxrjTfqk7FrhNn2JwhTdirYeiAJ6tcLmoRFMNG	2044	2905	2905	1616462100000
3941	3NLMj3se1bSrWh1EaExE7h5rN3rMPLhoBkYJZv75poFx9EYX2qNs	3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	1508	1387	33	1	3835	jwzcu8ULor8nWNfhYS63iQK4fez84NofCfCNmMxZzsmabWZjSk5	2046	2908	2908	1616462640000
3943	3NKWWoYis3QQcihoFwa2eoUtYo4NTYvdoENgPXfQUSzAgQt5BkaU	3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	1402	874	33	1	3837	jwuM8NYoSbpRuTY5mpGfQ3KQkULdXXoU1g8S6T1apzSDJxmZogP	2047	2910	2910	1616463000000
3946	3NLiEebGRJYkpiFuhg8QrVoREFSSmRF1vR73enuiynyxdbj6U9rR	3945	3NK7Qvar8xVXmEvgeSRAHWhk9QUA4bwwfYZVwox5Z5KEgTqAGSqZ	1407	1395	33	1	3840	jwGXWgGvFbvse3BazZcGoH9kUdHzGt4nyMpM4Rc1hNLCYghnLY8	2049	2913	2913	1616463540000
3949	3NKgE9hYcfYw9VRhcMnqNmcfqqhQ37CnbuojMsbPZFM54ZzrQvGs	3948	3NK7MK7sBSMHmDVpeYuTBLiizCkMfxj9HYtqwon2RiGSYdjZtPXv	1553	776	33	1	3843	jxhjDFUnpHJKi662jtRyA16TEC4DPjfvHTyiVKBR1Aq2TkUX6pc	2052	2918	2918	1616464440000
3954	3NLQSVUVSpYRVD4ensSUH8wfgV6i6gDd6KcKs8q9NzHRYWjAAKXL	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1578	930	33	1	3847	jxnvEXHSnWmrFUn89f2wXANXPBvX3beMso4HccyyxRuZU8xYMfS	2056	2922	2922	1616465160000
3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1483	138	33	1	3852	jxVU8G1pgs8V1MBE5cE5YhjxWgT2pxxmRMaNbWg78sp2MwL58Mc	2059	2925	2925	1616465700000
3961	3NKEXMKcaXiSqVzuHkrTpZnFMzxix9SEYLP577mohQCN2MkRSQes	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1611	1341	33	1	3854	jxCD7kTMzJeHbJS6oVhkBsr58QMMEymiGwjioBeyJ1msVPEnF74	2059	2925	2925	1616465700000
3963	3NKhrXXQz3BNFLMn7hRDMyisQsaxP34oMuQxpNGDhc3WkHj5ahoN	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	1513	1133	33	1	3856	jwGcB51LVrtYHHhP6SqKHDHsR93PPC8EHJnp4ab4Kp6rKSvghoq	2060	2926	2926	1616465880000
3965	3NLgQDjkXoNHECZVvEBbjgg9vZWj2ppCcJUFVwYvzLDqGP2FGdWE	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	1631	794	33	1	3858	jxAB3jJ8f1z9JP2PYdVDaJkBb7WV4jUfksx96vprTfjwQmAjjcw	2060	2926	2926	1616465880000
3968	3NKk2gH7AFotGAMtNvrjy3Uh3GfrTB4J4AUgRMXDWHoygxPB1rUA	3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	1457	1025	33	1	3861	jwNGkPqDwmHu4TU8pHFL2AoFvxsAAGP5sbxEBSqwAVSTXd9s6cW	2062	2929	2929	1616466420000
3970	3NLDj3q1xx2RpcjqeH9CiV8dw7ipMGsGJPZELhejMR3Xg15TzxGg	3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	1501	1360	33	1	3863	jxAaWBhEjWPAD6E6WeQXoK5irUL8U2ZH15Zss4ynRQxd39QbTur	2063	2930	2930	1616466600000
3973	3NL2774ed3Xs8AU865JEngR6ppXmmiytNvxB4i1GzauN6uUpMNyq	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1407	1395	33	1	3866	jxFdSUxdEqHj5RBs1hEXT2nKRW7535XbDQhWUZp3PtBRF3865nc	2064	2932	2932	1616466960000
3977	3NKSABWcsMKwbhWBRy83CwiyYpkYqpFKVn4VyZEsbj6omCtYUGQk	3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	1402	882	33	1	3870	jy1vNT3MvtdfYx1VJ8RzSJ3vca21f2x8YzmjCLdHBvfEnef3hY3	2065	2933	2933	1616467140000
3982	3NLXtWnU3WbvVbgEhdefQFqMiWhZNoEvPbarexspyNyjrMHZrQCA	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1460	1078	33	1	3875	jwJAzsxPtKJJbcDzNWKNoRC6FqFLZztttKmLuxkwJme5kHo5bjV	2068	2937	2937	1616467860000
3985	3NKJ53fL5ANyX5BnWGJBwg22Zwiv7vvaMVwLhMCMfZ1Fnit2VmnB	3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	1579	1023	33	1	3878	jxE3ZqdpZ7KkXu4WLmpZQ51G7Z1eroDPwmceyuWEvrHqa1GuMvt	2069	2939	2939	1616468220000
3987	3NLTL29PtZWRWKR4EbwpuTxoGUW4nTDmvVxW5iE15ZC5UioM2eLi	3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	1406	1393	33	1	3880	jx9kDjRoSYezEwRSzy3Gj7J3ZNyPK1WPNPEgWwwEgsa9V6XSxLN	2071	2941	2941	1616468580000
3989	3NKssxwRomsgsKY5NTxu2Eq2vzNdr5JnjJzbqzTAGH44n6vYsPwC	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	633	1384	34	1	3882	jwx6PaTGrdDZoDxxrT2vpTGo4GKMo8v1aRcixbVSaq1mhgyTg8m	2072	2942	2942	1616468760000
3996	3NLbdkh79aty1mJnm4HKd6wNMmH9MXmBwrufGCkC5DmCT8xRQyX4	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1618	527	34	1	3887	jwauA2BThaPLLHXVDtsfG35ief7d2mDiaLYQa5VKEGL7s5mSeNm	2074	2944	2944	1616469120000
4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1460	637	34	1	3892	jwn2Hcy8tQkh3vQzuKNtH2ospBRp7g18snyaWM9zXCNFFunmwz8	2076	2947	2947	1616469660000
4005	3NLhFDML9UyvJ2uexCkHjH6VT6by6K3Akpz4bybgWYrJR7PsF5Ej	4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	1490	1028	34	1	3896	jwoKUVgy8omvGf8jUfZPNqiDzRPzSRRL3fsyGpZNQHF2LotTVFu	2078	2949	2949	1616470020000
4008	3NLvqBmUj1UuGMxwonhE2pZQjcWnLLwuFAECTUfz46FsEiRKPFAo	4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	1668	1244	34	1	3899	jwAFkdKN2oKM2SKhzEFpk19vtMe4LzrnJnhDq5yiZJz7zjEy9Mz	2081	2953	2953	1616470740000
4022	3NKx3jcjLbJQy8YwvRuWXAobhP6BuijNs5E8ojQwLH4bA4yFhK9q	4021	3NLktfrrAfFyzHRqNZKn9Boqiw6mg9WJYXGj2ANu8LSFqcEx5XNS	1602	1243	34	1	3913	jwYbHJNTUhihjYCYcWwdbZXXucGxJ9RAgXVqhjgJ1xj56tsap5r	2087	2962	2962	1616472360000
4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	4024	3NLqqbRUo7YGeHjVN7aUia3VJhjsaEpAezcpGVxVAqRDWtFjNEk8	1406	1393	34	1	3916	jxTdm6e54Lhg8dgpsdBShLYLd5Qkedk9dK7Bv77Kq4pMEjjJsft	2090	2965	2965	1616472900000
4027	3NLnJeZxJRi96AFmDpKniM5WbdD4sZE7aecdmrH3x9MyPWMpxgMP	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1651	1055	34	1	3918	jwiot1pbMtLQQxFXVxzEZe72P6Diyw1gwhvZ3gmh1v65e9eK4LZ	2091	2966	2966	1616473080000
4034	3NLwWw8vHeWY8mLSyAqA3kXGhiFDzNjMfvqW6R1EwX15eYGZanmx	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	1609	1087	34	1	3924	jwR8gLk3aobrnkQBYiXhzsHqN6zcYfWiRQt16RdNJRbjS24rPXH	2095	2970	2970	1616473800000
4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	4040	3NLuxfZ2SZHNe13nXJqzafhpQcEi2nuauCkREcB4eAeRhBhVmgX5	1407	1395	34	1	3932	jwQGkGA5JuDWevgMPQeMSXiL1cecfXqedKEogJaAVQMeettBgWv	2099	2977	2977	1616475060000
4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	4046	3NK3JdRfMA8tBCXq7hrndu18dx4M9gDKEGCem8F5syEDsArGs1ff	58	1035	34	1	3937	jwiyR6nxLimAwV8kx86SAYcizEAdcfLYVkda2uqcCGuKnKq56LQ	2102	2982	2982	1616475960000
4053	3NLg6UmCRSRVeXC56kXt1q3z2HCQzM1vvUkTqUWpDkHuGeHawD2f	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	1610	948	34	1	3943	jxse31naA8qXiyi4J3ems1FKeVsnrHmpoHXyCR1PhUwcWBThnkn	2106	2988	2988	1616477040000
3947	3NKR2tQ1JM3TPpEtVjiBciJizHz4FPoGcxiZsHJPzE4z2zAtu9ax	3946	3NLiEebGRJYkpiFuhg8QrVoREFSSmRF1vR73enuiynyxdbj6U9rR	1631	793	33	1	3841	jwysbRUXQB1ShDsSBMpmsP8N7HUJETSVsUbWEefoCf5sapYpz3s	2050	2914	2914	1616463720000
3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	3952	3NKz8WHC6vFjeYq7FYnxHFHSyQfFu1EwzCDhie7G1geMGuvpt6wH	1407	1395	33	1	3846	jxd6cAAG1aZ4nxunDj2JJPrnSm2oyfUtapXFYWP3azQjYkexkAW	2055	2921	2921	1616464980000
3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1589	920	33	1	3849	jwg7p7WVHbMpSpwnBx2CVfsckhHVvF3rXatK1eQ8uXVNSqrbbov	2056	2922	2922	1616465160000
3962	3NLg8jBG6iYFTvBAgryBiyVxabJpsWwcwskvRCE4mo2XD8XbMzfc	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	632	1016	33	1	3855	jx2DNcWzkZQX2gF3y6AXUvKu3s8ZVLgcK55NJfJCe6bRiugZLcc	2060	2926	2926	1616465880000
3964	3NKARf5Ee7HY545CW57LGeW23wxqTkUHeJi1tciiKKG9P9nwqZnC	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	641	1090	33	1	3857	jxAmqBzbJBxu4wVtGo8DB1umGerGygRyNG5cJX5L49U9ttFRN6B	2060	2926	2926	1616465880000
3966	3NKPuV2A7WssutjR5MM5UC2tEm3TzSQ2RkrpVADhrkv3Pyet4T9R	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	641	1090	31	1	3859	jwMJ9f61isFnY1ZPsaYdjD2NyKDvzSU78ntCJTsaLDu6wZ1diLY	1988	2926	2926	1616465880000
3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	1594	1200	33	1	3862	jwTSkRJ4iRyFEh9XTgGQqXsxcqDLpZRdX2Mt7wYoW5UcoynoKvM	2062	2929	2929	1616466420000
3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	1407	1395	33	1	3864	jxfmgN36gn62ZM8bmpR3DuQNSxuAdRgHMxftAsRmic8tT7czpaZ	2063	2930	2930	1616466600000
3974	3NL6NHN39UKYTupQDjbDFwHtVVz9s68TA2RfqX7sfouo9H2hUxHS	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1516	928	33	1	3867	jwVp2bnq7SCR5eH1yXi1VY8n8m9kn2GtUjkJiyZSJUobTDafBed	2064	2932	2932	1616466960000
3976	3NLqMsp8hQnyRZutvdz2aZVGHFw5DAc5rAJvqkD785FJRv5Uxi5p	3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	1406	1393	33	1	3869	jwrcUfgkZYQT9P9XVjFt7kSjZ5B8F3pyLZ2J2JYzuLmsUKUnXwK	2065	2933	2933	1616467140000
3981	3NLjnk64G7h6Vqx539fdWF69nZ3qr192Vsg2RLeyD6edbdkWxFqt	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1403	824	33	1	3874	jxpFT1YWumtKvWwCATVPGJAHHoPiczyMoJZkPnGsAJMFrSzsDLX	2068	2937	2937	1616467860000
3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1611	1341	33	1	3876	jxuKzepLZEBaYvJCqNwNDGdrFusBjPw1of7sh1AJoSwaCMp7anh	2068	2937	2937	1616467860000
3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	1477	984	33	1	3881	jxbXw9NW28dwcTmQRXPEGwho5HwWizBh6z7WQmKPkGgaE63K35L	2071	2941	2941	1616468580000
3993	3NLNe4CEaW37ex5p5BRBYgmyX81PcasV1kUDpve1wTWajqExpH7d	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	633	1384	34	1	3882	jwx6PaTGrdDZoDxxrT2vpTGo4GKMo8v1aRcixbVSaq1mhgyTg8m	2072	2942	2942	1616468760000
4004	3NLpzZUot6eV7Y9kYXbj5k7Js4NgU3BdgVVUTfcot5vMDbNvdCAQ	4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	1646	1354	34	1	3895	jwf8WGrNxD6oxdh5QXRx9PXE1gzeKE6NKqMTR9QbSYi9CwbPBH8	2078	2949	2949	1616470020000
4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	1549	1362	34	1	3900	jwkYJLdkWuWbEa8LcKjjoov13XNisUythhPg6DAgXmXSZpAJoVo	2081	2953	2953	1616470740000
4012	3NKxNsathwodLn3TKufrgovpBq1S2ZgCC2KyQPDyhu7XiuBTK5kc	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1619	1275	34	1	3903	jx4wc1Wxab8uuufjgvF9ArvmF45CbSp6P7YLHwMEFY7HmxWZKkz	2082	2955	2955	1616471100000
4014	3NKEXHq4anmZr5DKJXmYiXE3PYMFG91rxdUXEdd3jYmDqHTxucDj	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1647	936	34	1	3905	jwyQJh2Axsfjk1JqtiNqmHHmE3dUqLatkxdiii3vqoyUjNKUM7d	2082	2955	2955	1616471100000
4016	3NKwYndfycshn3tMW5Bo2VMibup4KSqNbxj3tksCwpAW9uSo9f4s	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1448	1311	34	1	3907	jx7cPXjE7Kywg3vs1ZbWZDqBFZnjfWsaRmxxhDSuRStWQgceDBa	2083	2956	2956	1616471280000
4018	3NKsjjN1JEoPZXznQonf2LojEwJkvMQRBoSEG4wH6n73iXpaaLXW	4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	1588	1392	34	1	3909	jwpR8dSiet3DcEnHH9mh2q9CZW1QD42kbxHuSVwdW8GwAjSXaD3	2084	2957	2957	1616471460000
4021	3NLktfrrAfFyzHRqNZKn9Boqiw6mg9WJYXGj2ANu8LSFqcEx5XNS	4020	3NLAjp7TZjSRFbr2nL2MBFCN8ddJQgg9uWXetuot4bnFvJ15wx5r	369	946	34	1	3912	jwxZqfxoCPcwh2MCLBzC4LAfti5pgoyWTTLQAZbAeiYJ48FDpmu	2086	2961	2961	1616472180000
4026	3NLsnUKGyCZxdEMjqW8kyK1J7z6MsGdrr5SVE51LCaLD88MwtPmo	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1467	1376	34	1	3917	jy1rPNcdC3h3iMSUcU511FPUZAQ5g3i7fbLxbT65aGDGd1zhqet	2091	2966	2966	1616473080000
4028	3NLx57B78BdyaW3GtD4wKQaXapxutWanRqX3TAZFHP399gZre8ms	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1651	1055	34	1	3918	jxMLc9UQv6yGgNMufWNg5jyy64RzyXznanEGKVwyAu4zLNLyaCo	2091	2966	2966	1616473080000
4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	4031	3NKEAjm56ouyM3vY4Lr8Fo939R1VL8ScDtVD5r2Mtb3cirjtxXTP	1501	1360	34	1	3923	jxyvaNMrCX9p4PFHKPdQkPQLvheHCiUc21W7WAvEAREekfBcQQL	2094	2969	2969	1616473620000
4038	3NLh7PmdoSGXY6jTA8iiGf9t3o5S4SemcA8hQ8owv8yDDc4FudRS	4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	1458	1323	34	1	3928	jwupAxr3cT51SJ57Q9iFVyCuJ6YKYjmCin5r8n2CmxRv3gvKqDW	2096	2971	2971	1616473980000
4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	1407	1395	34	1	3933	jxng8MFrCFeVQ8j9FB6pD1VugeD2Ff5MqsmaahD7xJYWtfhECHj	2100	2978	2978	1616475240000
4049	3NKgf3QLYnLgH6qudCcLW4Gk8P9DBvurPwdAchy6c5bFRd9cSskz	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1560	1291	34	1	3939	jwHvLYssxyd4FZJpYPfEc3kVBSBP3imxGn1KjGALutofitJMVY7	2103	2983	2983	1616476140000
4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	4055	3NKCYbC3mZzixmzgZdw7g5eMqgnwqe4ka8FMQApuJNbMUEEub8c1	1483	266	34	1	3946	jx2BPtGMejo729VUqw1QDoKERQL7qrSEtijZGbqPWUS17PWsQx7	2107	2990	2990	1616477400000
4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	1602	1123	34	1	3947	jwtA2fcD81CeLQUa8aphLLRPQLHy6yd3M7SNtHj7qe6p2oQHLmH	2108	2991	2991	1616477580000
4060	3NLvsiJukiofwuCXsxepS6LUtMxuteJh4w2xvmgGXCZUjCNAeUVY	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1457	1391	34	1	3950	jxwZhVp8fQdG8psECp6ZjjiedkbmuhEssr9qLErVk1WJsZHCHUF	2109	2992	2992	1616477760000
3952	3NKz8WHC6vFjeYq7FYnxHFHSyQfFu1EwzCDhie7G1geMGuvpt6wH	3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	1651	1055	33	1	3845	jy2JLhpp9PCGMHm8xapoxKRGXvzsHuPL3Jf1AQJ7UzQfgBdNQsL	2054	2920	2920	1616464800000
3955	3NKajMcLpz6Pq8nuQyyFCUhfQ9zvGMgP3GbsxgjF2ZQgVABpjz44	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1527	1293	33	1	3848	jxC2uWi3Fa8t7sCrn8wv4J9DUf5jRS3YwCxCrh12W64wK8JC1GP	2056	2922	2922	1616465160000
3957	3NLjYWqpJYpNryiPSxMLUsG27dhVNP4AxLrwFxBv6toHgmPXKaNs	3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	1447	1345	33	1	3850	jxjfRNMbPesgJDaWiepfvHz9ujodsTcU6Cryf9HaLhTWyoQbB6Y	2057	2923	2923	1616465340000
3960	3NLNA7Lsf8f3FjjZRvR2462CHhfKzmjCR4SmpeSzdhuw2i3buA8j	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1666	85	33	1	3853	jxGssWpvEfcipqhVGH4r5XbSqr2PKCZZfSBip2ZrzHK72HwjH6w	2059	2925	2925	1616465700000
3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1559	1227	33	1	3868	jxEcRGzzMytqHqeDcKPkJQSEXvNfwqCMMm93nyfJyD2ccMShigQ	2064	2932	2932	1616466960000
3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	3977	3NKSABWcsMKwbhWBRy83CwiyYpkYqpFKVn4VyZEsbj6omCtYUGQk	1476	1371	33	1	3871	jwR89cXqdDY1WQUvYbAi9jUdV4Nm6A4x5HzVusxBzghcsUK6JD3	2066	2935	2935	1616467500000
3980	3NLEAjacJS21TocuH2q5t2RL7ya2Nr94BwoB3pYp6BR33VcSQh4D	3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	1559	1107	33	1	3873	jxiGVu6kxvkH6nR28x6zAS24Pybfe1yK12eDB1koXViWsyVkEzF	2067	2936	2936	1616467680000
3990	3NLuHZUYkArRMKrbJQKTqRXgFKF1tVxchgp87Sb7uzDYwQS5se1r	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1529	1316	34	1	3883	jxhrCr4hEyeyNNSdkupsufzjmXW4zQU9E5a8rLCGEH62t5fnGjq	2072	2942	2942	1616468760000
3992	3NLnifEKxjcsDYyXEZNHq2zps6no7rhSjgQj8fmpE7ZA2cq4v9c6	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1402	880	34	1	3884	jwe25m1y5SevCRkKhFw8uyjxCmGPjXF1tdX4FhZ6p26nXHf55YP	2072	2942	2942	1616468760000
3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	3989	3NKssxwRomsgsKY5NTxu2Eq2vzNdr5JnjJzbqzTAGH44n6vYsPwC	1483	1276	34	1	3885	jy2YBFqBQeNSRXEkPS6cEr7xiq1Jhx65yRA3w5Jq6jzHqoUdMce	2073	2943	2943	1616468940000
3999	3NLXjonnHEDW2tqtXqCKttc9j6RNxmtSp7KBQwo2PWZmhNrwWjjU	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1406	1393	34	1	3890	jx5RjSP9uo4Z4bhJaLtuJksF822QrXdwuWZSqbQpYyMxjmMz1KF	2076	2947	2947	1616469660000
4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	1601	1388	34	1	3894	jxhXzJ5JbdEzonrKaqfzXLQLoeiReRM9N6Drc2PzYTU9YmvAxi8	2077	2948	2948	1616469840000
4006	3NKTX1Q4MFbiSUrATMKeQXbvPQA44kYMCvo5UJEPSWJwJiK98yRQ	4005	3NLhFDML9UyvJ2uexCkHjH6VT6by6K3Akpz4bybgWYrJR7PsF5Ej	1406	1393	34	1	3897	jwLtjHUUd5UNWGMQnd6duY9GHncLw8mvhRdVoJ2BsgqBYZVSRrV	2079	2951	2951	1616470380000
4011	3NK9zcgMqg7RapEf1NbPgBCVhC1aJfEG1Y8jvzwgddX5ZfdnpLSo	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1458	1323	34	1	3902	jxdhTi8XWBJFBbBm1gf2jbvKXvaKHEU7FApshf8gnUE7cUpqUP1	2082	2955	2955	1616471100000
4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1553	776	34	1	3904	jwoGZenZoxCBDYMMG5FJPZPHdNugMh8k1emwX34nxRqNxdDkdyT	2082	2955	2955	1616471100000
4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1458	1323	34	1	3906	jwEcPPqnEreCk76vE1yosMkdr5KMCDqC7RmY7LWKyTCpZzo6nMr	2083	2956	2956	1616471280000
4017	3NKc1YC6RnsZHZi9gGGnBVR5528xQJn2XrrrxDoXSdTb3tc6RkNY	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1419	813	34	1	3908	jwQzTNSkoDDSWSdbmchH6WEUWmkWWZ4vaCrbFiN5FMcbuuUFfUj	2083	2956	2956	1616471280000
4020	3NLAjp7TZjSRFbr2nL2MBFCN8ddJQgg9uWXetuot4bnFvJ15wx5r	4018	3NKsjjN1JEoPZXznQonf2LojEwJkvMQRBoSEG4wH6n73iXpaaLXW	1642	1241	34	1	3911	jx4Q6Dhmbbfbeih3MQZXhJvxSUnzknuEKBccvH32xrMByN1EjKU	2085	2959	2959	1616471820000
4023	3NKMgf1Pnbu6w2c6y5UinotZFspmmcpUYNXxqjTJhJ7xGrhxSLsY	4022	3NKx3jcjLbJQy8YwvRuWXAobhP6BuijNs5E8ojQwLH4bA4yFhK9q	1405	861	34	1	3914	jwwKW7NGZbweKB9z5JFTTeda81UaxmbcAcd4CTfKJfMmfkaG4Ka	2088	2963	2963	1616472540000
4030	3NLe2rZPLumNqQuJMLhTsmUZaComQTm7WWqypLMfBomYTybvt7fR	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1406	1393	34	1	3920	jx2KKvA8KeTtSvwSycREVkgActtFnmuiDa5yrucc6cThd3s8sR8	2093	2968	2968	1616473440000
4032	3NLMNcVT69ua4WBe9UQ4nP6VPQEmhLZj4eAoMrosvD37PyV95VWK	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1598	543	34	1	3922	jwW4vcSC9xZUCTt5qeJxnjTzFJEzm669dTbqVPtgzSoKnqQ3VRL	2093	2968	2968	1616473440000
4035	3NLmM47UfbaWy7W6xPLkTcUqXrr9S1KTDqBBiFQTzCTMz8AyAYdc	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	311	1307	34	1	3925	jxNETh5CH6MZgkJgSdiAx68notpnux5JAZveKK3T5HcsrN7Xs59	2095	2970	2970	1616473800000
4037	3NKimDFhk2VtJAHwyJ9xj9SWqVN2QjsmAwkDKvKKVDxF4UVoY8st	4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	1407	1395	34	1	3927	jwKWeAC1d1DmUxAsNYaM3ckK7RnDK8KMCLswVeq8ExQmkboYG52	2096	2971	2971	1616473980000
4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	4038	3NLh7PmdoSGXY6jTA8iiGf9t3o5S4SemcA8hQ8owv8yDDc4FudRS	1553	776	34	1	3929	jxNfttJWRb6doufpGh3hkPyy8Z4WrvGZJBdp3PaYyz8DnaFKYh8	2097	2972	2972	1616474160000
4040	3NLuxfZ2SZHNe13nXJqzafhpQcEi2nuauCkREcB4eAeRhBhVmgX5	4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	1503	1151	34	1	3930	jxxaQDXZ1KNL2JwWpibVMbf15Ykb53cxQJK8nPswqfjCL8j85Mc	2098	2975	2975	1616474700000
4045	3NKcfF1FWaaenkBrjRGAiqdrJhRb8qANrV6nJuxKPgRKTeoXS9u1	4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	1534	432	34	1	3935	jwbYow3Ct3swNyC4884ih4md6oxiDqSco8VSJY3dLxjsyVGge5q	2101	2979	2979	1616475420000
4048	3NKeEHZxmCUMhBAeKjA9wiiezhqijv7DBXy7imrUQRf3D2Cnyz7a	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1407	1395	34	1	3938	jwUnEC4zp7ZYFcbapcuXHVbsbxVvv3fVomXNeBsm1dQhsTAcMLz	2103	2983	2983	1616476140000
4054	3NLW4aJTqPcMHESTmX87C8A9JEWUKhDYir1E44cs7io9NzDTvoet	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	686	686	34	1	3944	jxXVZGQLb13UMdmEsLhnDNmjw83gNw3tRwqqCeZRDMU5Hz18tQ6	2106	2988	2988	1616477040000
4055	3NKCYbC3mZzixmzgZdw7g5eMqgnwqe4ka8FMQApuJNbMUEEub8c1	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	1616	2	34	1	3945	jxUVXtjgpJ4awfHD9jTVkqSCsuPoGXAaMcCktVsCiqzpSsCMf2Q	2106	2988	2988	1616477040000
4059	3NKThWtTiX7nKsgzbttpz496PnjnEwHh5scCaJfY4j6r8kbrkka7	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1407	1395	34	1	3949	jxpiFE9vosGxBodG3b1LovqFAGdh9BRYyPbFh9JHJS2QJBstT4R	2109	2992	2992	1616477760000
4000	3NLaAHT5sZZPUBLEAcfsNw3tmroNrz1P9Ty2eVmeSgzJNDVKg7hg	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1596	1117	34	1	3891	jy14r6rvtCXhKwFpi5yA2hwVwLWKWHfsCDbBZ5yF2MvTbDjkrdQ	2076	2947	2947	1616469660000
4002	3NKHihBYP7UszUL7b7PReMfUCFP2X313pEmDx6F4wvViN1MiTDJj	4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	1506	1373	34	1	3893	jxFBzeMdDGxwa775EWfbXscKbksTiXG2poQTNStgz3hVj4P3dHH	2077	2948	2948	1616469840000
4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	4006	3NKTX1Q4MFbiSUrATMKeQXbvPQA44kYMCvo5UJEPSWJwJiK98yRQ	1406	1393	34	1	3898	jxiHucUTSGPXdRTARaUyXPkHhwtnRtzTK3DdraS5mbAKHP3FVTr	2080	2952	2952	1616470560000
4010	3NLbMBcQmqUrka4Xgd1YgwUu6TotjrkKz6sZ87QBUhHNgY5VU8k3	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1407	1395	34	1	3901	jxWsViDJqNaLn2y5MFESmpMH2JdENHkx5B5ZG4udXCYPGyAepTu	2082	2955	2955	1616471100000
4019	3NLYGoGt1vhZMTrNwjy39aoRbNDdScng2wNpWVFRTnaMEGDNjWmK	4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	1596	1117	34	1	3910	jw7qBrndAajhsnRfLJFerJ9P8usYTagmCCq7EQwyFsc9u8HfNpK	2084	2957	2957	1616471460000
4024	3NLqqbRUo7YGeHjVN7aUia3VJhjsaEpAezcpGVxVAqRDWtFjNEk8	4023	3NKMgf1Pnbu6w2c6y5UinotZFspmmcpUYNXxqjTJhJ7xGrhxSLsY	1596	1363	34	1	3915	jxwriqF9cCQSK2RH6YHwC7D19Ln1SGr9qVpp9b4b3D2rSCesq7r	2089	2964	2964	1616472720000
4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	4026	3NLsnUKGyCZxdEMjqW8kyK1J7z6MsGdrr5SVE51LCaLD88MwtPmo	1673	1122	34	1	3919	jwzp6b5vtHtX4WpAkhPKeAks1rdLoHQFgfKygQEHZ8uxuvDJfBJ	2092	2967	2967	1616473260000
4031	3NKEAjm56ouyM3vY4Lr8Fo939R1VL8ScDtVD5r2Mtb3cirjtxXTP	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1657	978	34	1	3921	jxaFBWojECJXBmwXUW9mQBX5RqhUMVkBcAGHfVyp2oAMcEaQ7uE	2093	2968	2968	1616473440000
4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	1593	1346	34	1	3926	jxuSEhVz8FJdXuzFcLG5ZSzHkuvMjWD8zL85Eefu4g1BYAapww6	2095	2970	2970	1616473800000
4041	3NK4BtFHy1QTNRbiba2HDJddarnqSKYkFjy6gRxUCVpuUwq1P73N	4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	1631	793	34	1	3931	jwb7fou4KU4sFesZdhdFHRzEUFMyc1zRsAfmYTS26PmmYTZfnzP	2098	2975	2975	1616474700000
4044	3NKWc5Dt13gm9KLKAHi68gJ8GS9rsPUC6hUUetBUBFXKFFyw5vDy	4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	1406	1393	34	1	3934	jwaG4HvBBjbLLny8GosztujDo1PTxbaJMKPTUgNsQ1LteLeUGJA	2100	2978	2978	1616475240000
4046	3NK3JdRfMA8tBCXq7hrndu18dx4M9gDKEGCem8F5syEDsArGs1ff	4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	1519	863	34	1	3936	jxzoV4C5jTZ3pF6ZBjPzC8T4ER2noMP5HbJDaeh35Lp78Gu4G5v	2101	2979	2979	1616475420000
4050	3NK4bMAuVXhaPWrn55FkzwxGyhMCyn9buzZtqwiiWMC2DLP9jDDS	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1585	1366	34	1	3940	jxdTgpJTb41yUZxWJerkskyjymRHah7pjQHLKchczjGupFQsxSe	2103	2983	2983	1616476140000
4051	3NLFQPDbmmtCwZ4vmHpak29a7RaaHcc9KXB783Nw2JHEkDDH3fax	4048	3NKeEHZxmCUMhBAeKjA9wiiezhqijv7DBXy7imrUQRf3D2Cnyz7a	1407	1395	34	1	3941	jx6UUgTLCwdv2ez5DMzawTUy6aJdLpSdkbVwCsYcYXhLrAoxUeQ	2104	2984	2984	1616476320000
4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	4051	3NLFQPDbmmtCwZ4vmHpak29a7RaaHcc9KXB783Nw2JHEkDDH3fax	1560	925	34	1	3942	jwajSkBPuzXZ7BZdtMwMBaad6QgnoZMvyo6ndBFxfDXMYZgefCa	2105	2986	2986	1616476680000
4058	3NLatv8bDWGSFMqb2S2f4KCd8advLmQJb2whfMKh7sdJ5ayMF5nx	4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	1401	4	34	1	3948	jwuEMgBM8jQp6NcYKZxt97ETfzvvYkrFG9HQw1LpNixKwz6H3kq	2108	2991	2991	1616477580000
4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	4060	3NLvsiJukiofwuCXsxepS6LUtMxuteJh4w2xvmgGXCZUjCNAeUVY	1600	1126	35	1	3951	jxHAMJ4HshdjiGaRGncEDthz8DQqoA6gx6Bw89ZhugmnWnaKzw9	2110	2993	2993	1616477940000
4062	3NKjSTWWBtsqVfvpqeTre4XjzgM6CsUw2NEu9VbuLURXazHrq9mn	4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	1406	1393	35	1	3952	jxQfLbQMddmhuiPwZ5HVwZhb2kYGVaJEK56NygWF5aDuLhgsDnr	2111	2996	2996	1616478480000
4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	1652	1315	35	1	3953	jwqndNJJ5272wWfLfQB3XRCdazo7B1iNxpvMViL7U6hAEUoCnEf	2111	2996	2996	1616478480000
4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	1407	1395	35	1	3954	jxqnXkgHfGMACZRAvhGRQDYVdz3GCp3JBnZ9QHkdTaQF3N9NwgH	2112	2997	2997	1616478660000
4065	3NL23PF7rHEK5u5G6QTT69ZBWURWwenrbBEBjJJT4kRuDPkj8oKn	4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	1419	814	35	1	3955	jxbPX5dH2xeypReP9pUtTRfourNNR2PmaVAg9qL84s3i8K2HzCL	2112	2997	2997	1616478660000
4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	1406	1393	35	1	3956	jwHrRjXnfyjm3CnJh8aqeFHJfKQYJHKqU9QDmnPMe9KYUFcgkV5	2113	2998	2998	1616478840000
4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	1407	1395	35	1	3957	jwPcCnuNWptVccJfSHXD8obAUtu9onutVjceBSawz2ZovqCMkHj	2114	2999	2999	1616479020000
4068	3NKphQSyZjA9BN2XksBwpxvpTxmUgZ6zWoKvhxF9pxrfcEPFUrjY	4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	1403	824	35	1	3958	jwvoRWuPFgygeHUBosVV7dN5qYTmnogmLxwiMjz32uKhR4nT2fG	2114	2999	2999	1616479020000
4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	1405	857	35	1	3959	jwSUYbUynV9FscUavo4HoA78AcZTn599v558E2M2xtGdqEAZMqv	2115	3001	3001	1616479380000
4070	3NKjVp7SoA6TKKTDHD9q5jKeNsBHtGTp8WoRuo2ULyGFfQeKfGuB	4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	1407	1395	35	1	3960	jweJDJijrBERVWUJcKAiVdZrrKkyb8E6AGHroMLxAmu3Msw3pC4	2116	3002	3002	1616479560000
4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	1564	1092	35	1	3961	jwWysQAoykYpNgSzUdeaXGTbVTBoUCYJjyBSVcvECudfh3eZWPe	2116	3002	3002	1616479560000
4072	3NKGp4jzgs1wbPHQo6SiyitxA48PXYzxFfgvxNaTwoHv1idRKGaj	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	1471	1140	35	1	3962	jxNvN7HR22To7Z6WBE9x7YBTccUPQYzV2cCUkUEYs6KMBZrDz6B	2117	3003	3003	1616479740000
4073	3NLH3FTKaqcRG6rkk7LazpWkZnQcLpjyHQXrgzgYi5uqw4kNhqqh	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	633	1384	35	1	3963	jwJDZnVBHpfF6Ui4WuJTHbWeYpjuQwBvswdoRrT1aNp7HLvHaUi	2117	3003	3003	1616479740000
4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	42	1115	35	1	3964	jxUr9VzXsWpyDBFiGecz9SCZrkFhyrdh1W3cHxq6o1TuHDXNZ4C	2117	3003	3003	1616479740000
4075	3NLDk8gZVWUDfoFKUo6z887Hn8WoV5TrCNx9jKs5ybUZzsq7yrNc	4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	1407	1395	35	1	3965	jwRzE9v8bczne1EhQuyb9DEBqt2b9Ar8nLryAGDKG395gfWjcuT	2118	3004	3004	1616479920000
4076	3NKAr7GvvXzHZvnPBVstp8KVZwCt8tvNvpCXfRzYPcS1QvzW2EsQ	4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	1624	1208	35	1	3966	jwedEpyML36BSWdoxee879UCdbt8XoynnD3na7ZyWNr4HRXfsEx	2118	3004	3004	1616479920000
4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	4076	3NKAr7GvvXzHZvnPBVstp8KVZwCt8tvNvpCXfRzYPcS1QvzW2EsQ	1476	1245	35	1	3967	jwPVfTNZXLdEchMhuabgUMXmE26uDu2gLcF1ThoDmA9QfLeXmHp	2119	3005	3005	1616480100000
4078	3NK4g8vSGN4a6Mm9AhiUXBsbLKyrG9f1f3dpj5KLRSgsb77h7bjs	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	80	1147	35	1	3968	jy1XPdqdQx43xP5E4BY7XBdgKRdUHaFwNSWiMeaLxLbEdAWKTH6	2120	3007	3007	1616480460000
4079	3NK6an6uDY44UFCWVFTzYEUwmafcsDVLFzbtDGumE2597NrmAiRv	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1451	926	35	1	3969	jw7vsVP1c1xyjKXkZQVMwjL8kXNUC6QiCr9HK9jvoPmtiM8tY3d	2120	3007	3007	1616480460000
4080	3NLmkXzHxsJvaFtqyqJdWBp3XMrEQY13hc3bxVVX8v2hsmmcTr6L	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1648	1284	35	1	3970	jxDoPeAkUquT6PD5iFjWQtzrZy2Lwd1Mf2CFcHKuCtQNKtrg7sP	2120	3007	3007	1616480460000
4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1617	1288	35	1	3971	jx2aPz8XihyGrSySvLy6muwnbrh8xk8beB8XL7Tqt78XY7gQXyi	2120	3007	3007	1616480460000
4082	3NKEK637eavt8ygGpFZRDqMrbePcMcuPmC3FuhXGb3qSgpapSA1N	4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	1457	1145	35	1	3972	jwU8jGR5uV3hshrwtedssQ47E5n16ctneCp8en6bJKFq2nfxmEm	2121	3008	3008	1616480640000
4083	3NLDB5Y2hh9sgk8x8dgHbRGJpbMLD6TqpB2iW9P4jF7Kauq1d4MN	4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	298	1308	35	1	3973	jx8zJeUQv928pDCE2xeEgF1tVhXm14RWuwzbD6apEcNWrwrmhYf	2121	3008	3008	1616480640000
4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	4082	3NKEK637eavt8ygGpFZRDqMrbePcMcuPmC3FuhXGb3qSgpapSA1N	1601	1022	35	1	3974	jxpCAD43jtvy1dfNtzAKhPwqAMHWywHmgrKnM6HLrQRqhSx3Dh6	2122	3009	3009	1616480820000
4085	3NLfhjzbzKCHSiBamfvnic1fBPgkQkHk4AsUToGs9emEKYUWTMbH	4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	1407	1395	35	1	3975	jwfNroukNaGuYTEfgpdU9TywDDKNDqUvU1Tta3xgDBECi4emyM8	2123	3010	3010	1616481000000
4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	1607	1348	35	1	3976	jwtXvPWqyz4At4kfH6eCCzSM2rLCpp3KYyJq3YUs95osX2rZ82o	2123	3010	3010	1616481000000
4087	3NLPexratndUYk5TJz2EaQmAP8GGCbnURxz9mdrugRhcxaRBvXFZ	4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	1610	1188	35	1	3977	jxyHsyrvBFmkDcSJT2hxNNeK74XBEKNAdxxnz9NWmE7N1JwG9Fn	2124	3011	3011	1616481180000
4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	1601	1388	35	1	3978	jwgvXQthzMGP6WchjsVbhw7cx5gf5nvMdN4iZhvo5AYkgJkjDY6	2124	3011	3011	1616481180000
4089	3NKFSdo2aw5mYWvWGNcefjKQKZs1q46gMhGgQhrNauUkpoJPLwdV	4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	44	1325	35	1	3979	jwDJfBJP7MwXi3GuBg5zxvLZPkLwWkXGQsguQS764jnqTnmBpT2	2125	3012	3012	1616481360000
4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	1405	849	35	1	3980	jxjVfrBLT92NYLwDdVdxQ9abgq22qrrda5oiwk3pkjvJiEh443Q	2125	3012	3012	1616481360000
4091	3NLaFTi1bKALkFwJP9Bnc2DbovaoCBmC4SHGQFPVj6NazjMjBUMx	4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	1673	1002	35	1	3981	jwUmGUaFmPWBgzU57d92HYQMfHHRYsJgLHMcFpZ6sMLL1mSQWT5	2126	3016	3016	1616482080000
4092	3NL84VjnmjHBwqYGZR4MZrQx8hJMUmrrSTaNaE8TZgM6ThXwrCHS	4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	1615	459	35	1	3982	jxGuRXkcU3kskvFsSHgZBuAWyH9BgNBesxR7tf9FPt9cSXWp1bh	2126	3016	3016	1616482080000
4093	3NL2P4Xo9JTwp735t3jh9SAg7AWn8exD7GZ4GkcNrxs7FaXHmytb	4091	3NLaFTi1bKALkFwJP9Bnc2DbovaoCBmC4SHGQFPVj6NazjMjBUMx	1541	1298	35	1	3983	jxUJHXB4nAWeDxiFAb3Tzy91Tqd2YAjNd3dBQms2fAqvNRc3RjC	2127	3017	3017	1616482260000
4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	4093	3NL2P4Xo9JTwp735t3jh9SAg7AWn8exD7GZ4GkcNrxs7FaXHmytb	1522	1322	35	1	3984	jwUkzbjvirjz9g4ve5ttjNhA6DkbRkeZK7sDXWSc6i1LU5YJWHD	2128	3018	3018	1616482440000
4095	3NLbgvAMn96ZRAzJxk17GswnK1d87ejutGFYL7kX5CGXucmYtoQr	4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	1403	824	35	1	3985	jwrKVUp1yAMPpeqD6UdM3FXU3yQ2ETF6JoAtLijTMPc82oDq254	2129	3019	3019	1616482620000
4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	1607	1348	35	1	3988	jwpbzVDQF5WeUoxU4y6XPR1tCqD6BV2KNWaFS9RMy3tx2HhRosZ	2131	3023	3023	1616483340000
4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	1403	782	35	1	3990	jwBemCtbwqLxit6H774KDSUkWQSnAuL15JyG7uLZs4U4oN5UZmm	2132	3024	3024	1616483520000
4103	3NKvEsTz9WscnNaPTxqp6TuK7NyNSKrq89vDBjDz3ecQZnAHcYYR	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1642	1367	35	1	3993	jxmvyXndgg7yBKnc6yNyPEm8wpWMB4tVKDJkwmjXXrViRY8ZiWs	2133	3025	3025	1616483700000
4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	4108	3NKaXDMhqAtDzJu7vK4WY3QWKm9ZPGWN1pUTztBNSg1b5kkBaAbs	1406	1393	35	1	3999	jxdrQ6VuwPjgRKuoGCRvNmgRrWkbVpdSTqtLF6n1SUTygcFxpfF	2136	3028	3028	1616484240000
4116	3NKywdTeuqc5xxst1zPnapD6wvye449eU17DbGjvBcvhkpU5wMWc	4115	3NLGj29tZEjN8miYQ4kLmsKwpmaPW3SyFE6r4X9siV6EpR9zHwLn	632	1136	35	1	4006	jxYkdyUdckQZPPfuvewshNqniaDXKip9fGXF9nZeUvvTAqAubQj	2139	3031	3031	1616484780000
4119	3NKYYw1zGkCP5qgHDgHk5mceowHxbJ5jPDwUL7aot9hm2m6X7ibL	4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	1536	1313	35	1	4009	jxCSPdv37r4CNMDcFk5zorzB2vmAPEbJsMWpDwAvYDVcKhfiD8e	2141	3035	3035	1616485500000
4121	3NL5Smi24YgyUjb4Gwc8FDeyoZMc796tK2aoo97NeDvbuEzcspXn	4120	3NLwmJGNinL5NSmdcMMF8AkoFYcvEi3TN756rBV6iCP7wsT5NYev	1623	839	35	1	4011	jxwecusdSuYRU2ndNNHWMFRGJZUjcskMie9A8ASV1GA8XQjJRAS	2142	3036	3036	1616485680000
4124	3NKEkTUEJjAbdrYGf3HFRduUDudmfiGDcSCeRXSZ2FBAJpZ5yZmr	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	532	1177	35	1	4014	jx7RMxzjNUXZVfHuLoQEgk5reejqBLfo8zkN7Nyd9i2Jji887fu	2144	3039	3039	1616486220000
4126	3NKtwxqwz2DhDyYneRZ2ikmmrUQXKvBdn542qi4gjutTXC8Ui6ih	4123	3NLFsX3egPNHqD1hWj1ZuZqmehMWf23a12HoYmy8JYNuRUyZAZq3	1527	702	35	1	4016	jx91crtUGWGvdw27h9n11nTv5JpYT1GbmgBKvrcA7qTLbYnZMZU	2145	3040	3040	1616486400000
4134	3NKubRvAr79fLpDYJRGSZJjFtuE6Wq5YgRGcGT6dsMjqoQugEhrs	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	1403	824	36	1	4024	jwTVkZaMhK1832hNbRMJnBwgT3VavJs2antaes3JPVHm1M1HHzz	2151	3047	3047	1616487660000
4136	3NKDhuZ6u2vRhwpYFfoXAHgfRPL8Vmxh4C7d4JebxFo5SjZqQx1G	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	1508	1387	36	1	4026	jwNqz4fXCDNEunPRtUc6GnAuQVi1vDf6oozfi2FCPoYsAC3doWQ	2151	3047	3047	1616487660000
4143	3NLsTnqg2ENs7Z41JX511Lsq8TditQky9NEge5is9tkHw4Xw7rnD	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1403	824	36	1	4033	jwakwggS3FX3ZVh1HJGBGCabKbSSVUGYhpP57NYacBdPwWwzNCH	2155	3054	3054	1616488920000
4145	3NLd4p9FGLKEtLoMNst4saDyPuJ95PNhhaQMpbsjndZUVBKisGW3	4142	3NK3dBQ7nzLDAdVJ4mCYi6k1uwPY5R2q6Py7wzQ8fzhVrmaAZ5Ef	596	940	36	1	4035	jwGnnNbsQ1m6JHsJmLJuk1oDrrt5VfPfS4LYsscGtzvJWRnj2k2	2156	3056	3056	1616489280000
4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	4147	3NLvKLVp3XqV15R8CsoHCgevvLJJNcqWALxpVhpUntZBn7T7Y2yJ	1407	1395	36	1	4038	jwkvZpZJbw6Djr29u8fvxyDHpKjzxkJUUqqGLc4hkKZR8UdKeJL	2159	3060	3060	1616490000000
4157	3NLKoFwzNjNaGfafnFTVrjx8fAWmzG4i65ZZjp7isr8Ki5pVdiop	4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	1489	1380	36	1	4045	jxEA3vq4CsS4hVSJvEK9hajzLfABKJU9fjKkqz11kpcqcuDo8M6	2162	3063	3063	1616490540000
4164	3NLDophfT6QvZEuvXmYnMaVmTkaBdGY9vMn4HxjkAvngY5SPrDCJ	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1670	1036	36	1	4052	jxj8K38YBDvrkkv9Sfbubsm24dTQPq6zavzkgTufkFVhXYi3iqK	2166	3067	3067	1616491260000
4169	3NKoHxJi1xV2GKTXRWnpxhDuzTZKtCAT6BoA1FWaSeB3FgtQMcfT	4168	3NKjK1wZso1nCVdQHWQ4a3cMNHtt48PB5pWrBuAXXmnf15WaepCm	1406	1393	36	1	4057	jwXj4G51q8t1kAF2w99U8pLTicRd4auSo3gGBTT3wWAamhX1TWF	2169	3072	3072	1616492160000
4182	3NKqGj3U7Tu3gKLThbDRYeUZ8cS4kdqEqToUC9xx5xhoKCMU4wNk	4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	1670	1036	36	1	4069	jwixcA6EdzJw85NWQEXJwBRHEkHDqcACm1DJGH3Bm8136arHwin	2177	3082	3082	1616493960000
4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	484	1319	36	1	4072	jxcafmM9gvAyTXqcgCVQxXtu5c9xQADEr1MrF7fAQS3FxUi5xq1	2179	3085	3085	1616494500000
4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	1458	1077	37	1	4079	jxcziYqdwaTeG1mQk3fwzscaF64MK47pJk6wzbxGFCDrRK2zqMH	2182	3090	3090	1616495400000
4193	3NKnWE4CesiNmVpLzT3LmA4SXQPiUCTMuBYwGtMccQprgWjub39G	4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	1403	824	37	1	4080	jwChb1pKXnP2vQ7Bq4CeXytxRgAwmZ2S5xYQEvDjH5PF3HVTFco	2183	3093	3093	1616495940000
4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	1403	824	37	1	4086	jx8o7s67RLjWmakFzvPKKFy9hj3jpEvKU5d59gyDMJXFvUsMbFb	2186	3099	3099	1616497020000
4201	3NLaeJhsiM3GU7AQ7KhocDYpb5mKy8Pf7gDQ88QPkyoLL8PkW6MU	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1619	1029	37	1	4088	jwFGTLp7rhCRF3VX6gD9ffanSUwb7BozwMKy2WzMHcU3ejKELrb	2187	3100	3100	1616497200000
4208	3NKD4ajEVo2NxEDjEcCZ6pxMAGbWW3YxcNmSPJkXU3gFHsR4Gag4	4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	1407	1395	37	1	4095	jwrH48Wkk6yi4qKjqLow5pf9LAUbnjqgTfLQKXeEMmUTmruyMmZ	2190	3106	3106	1616498280000
4217	3NKz4bgoAjxqKnpM6SwgRB4wZYLC42T23JRyMZRwrD31wUsniELW	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1647	936	37	1	4104	jxxarE599s7McLHwwpqR2a3dvn7k5r4uaHgoReo4pYxGwULscaQ	2192	3108	3108	1616498640000
4219	3NKgMPvr3LcWDGjyadZ78MrTUh44rFMVdApTUAACfSTKuTZWqMyf	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	1426	1364	37	1	4105	jwPmn8G3mKqpX81JL5TARjJdAtZsHiMU5kEH4S64zyB9yYVn4MM	2193	3109	3109	1616498820000
4221	3NLp4LT7V55WZGsAS6MNKjRdyKrQeKvBHW4LQyVZJumovZk3YQFw	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	1406	1393	37	1	4107	jx2L1azxLGWG8WtzUqWVgQ4o7xTuPPKoyVQbePkJ9P2H2DjpXxq	2193	3109	3109	1616498820000
4226	3NKwuJR8F9pnyaZoE7tpUABbJ4Mv7ZeEtixtpKHnA2jMZkqBJifP	4184	3NKMGwPQ11xr8FMXJt13EGF5h9wrkg6Umqdsy6GxdoAHrwd5MrQS	1581	777	33	1	4112	jy3HEMTDKXqnJhGm8g8KaNhYGMvhABJvKFu1xkzu9ZukdS4sqt5	2059	3113	3113	1616499540000
4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	4225	3NLK5pHKNzgU3RxmVBAfPDXaKnX1d81LTPVdHUMPeN9thiyYosEf	1406	1393	37	1	4113	jwByKAnw2jv3Yn87hNVeao75DciJ6W5mnmWnotYc4pKCq4UrHnC	2196	3117	3117	1616500260000
4233	3NK3b4WBZrPEXNLJhn6VkVrXdAiW6J6x8fz2iAmiQMRZEUyD2FkS	4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	1445	1164	37	1	4119	jxqQBKkxkoshyqC7yyQoDjStSRmHojmRQCACyDnE3SwaoDPmNDk	2199	3125	3125	1616501700000
4235	3NKcaQVsemsbk7dZS6MVuQ8qshGro4MpZNfHgZnhSnNhJu9Jhxnk	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	684	986	37	1	4121	jwuLJifUqFwsTWszbogdUuBrc74TVRgTtiTZd7PRf4FysZ9kQ3s	2200	3126	3126	1616501880000
4096	3NKmJX8TYjq1C59CSNY3Rh7phd46RYfoQbzDVUiBKLw7bzJJuRtz	4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	1553	776	35	1	3986	jwvy465Lc7ksJiXqipiBC4vnjHh9h1EYqcqrq2B1k1TQM7ak32J	2129	3019	3019	1616482620000
4099	3NKvdF547Tp1ZudZRoGEc9azsxM8RpD3xtzaKBQsi1yqkx3UGZcX	4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	1402	868	35	1	3989	jwZadNUy6cykAsCQqSRrPSx9vmrHiPr1WeQKei8uma3sDRYcwZW	2131	3023	3023	1616483340000
4101	3NKFuS5tywNYM9GaPkKga4xFr7YyVpaH7cfh4ajMa6M9QdZjF7Vm	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	1406	1393	35	1	3991	jwvXwVHB3QSRvbDUdWujmi5Zhs7JG5kLKapJNLipH4ZQQzPWL6V	2132	3024	3024	1616483520000
4104	3NLV53goKw1RTPPvSLDhSTq5wkN9BxeT4DhxXaJqTqmfA4KKtTG2	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1483	308	35	1	3994	jwtxLkxQCHD8qKLC4pC1TMR9gNj67aYvRzT3upmC9LUUwPEHFwi	2133	3025	3025	1616483700000
4106	3NK7NB9JTfNsNnh3x5sGTzJnwJzNuRdUtfo4Pq4RPocX3C6obKnr	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1555	1101	35	1	3996	jxTqoqBcY5JuMtybjLg1WVmkpBuEnoAHm7S9aGn8tpKf4zTu8CB	2133	3025	3025	1616483700000
4108	3NKaXDMhqAtDzJu7vK4WY3QWKm9ZPGWN1pUTztBNSg1b5kkBaAbs	4107	3NKBCMwgRnEFJvpiHeUcy1RQiiWma3ZH48QVNzD29txFT4Qbbdn2	1403	824	35	1	3998	jxYET7ypUEyRz2CpKi7GPBzYZJwXHLp5dsNvF9K1FPvE8sLPo94	2135	3027	3027	1616484060000
4111	3NLEfLH3uecx8ntkvYNd9cWGVdAvLbrdakPhBWb3Vt2V4eTwkWRW	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	1474	1083	35	1	4001	jwdWCoPacdSAdNs4jvN6v8MoKM6ehcrGp5PRxxyiCVHdc8LDucv	2137	3029	3029	1616484420000
4117	3NL7oayULFbQ4HDSwYcmQxfAtGaqF4BDtUodrscLQYkERnWXpSo8	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1507	1280	33	1	4007	jwqPRYjvHg7NLR64RFtEfm8su7vdJjmLrg6GKEuBoSxnd2RYKNV	2039	3032	3032	1616484960000
4123	3NLFsX3egPNHqD1hWj1ZuZqmehMWf23a12HoYmy8JYNuRUyZAZq3	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	1608	923	35	1	4013	jxkWtiyzy3TKCsWt3ctiRCALHAszcvtz5StZ1HzkamHGc132Zef	2144	3039	3039	1616486220000
4125	3NKM4CHUtTSYPk1gcJSC2aAvyaZrWb4hYhdCr8Te1XTXJxXB3pVU	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	149	917	35	1	4015	jxLKNU3gEspWJRdfMX7hiYR2QvBqXQj9RndShPCXDFFkVFTLC2w	2144	3039	3039	1616486220000
4130	3NK8cYR43LexRiKDJp9GCMUbbYKfA2UWNxatzST2kt4ztNQM9DSi	4129	3NKHL4BXg3sBXXZNDkQ4aX38Tu9YD39hhU4EtsxofJvkMa8nhpLv	1579	1263	36	1	4020	jxuPnTKW38MUJHeWVGXm749dcxKCycZCW6vk6DnSDNiep4FViTH	2148	3044	3044	1616487120000
4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	4134	3NKubRvAr79fLpDYJRGSZJjFtuE6Wq5YgRGcGT6dsMjqoQugEhrs	1483	910	36	1	4027	jxtUF59bWFKKw7qzwDdyf3BQSoEZTGriDxVb6h6F74nWyZKukob	2152	3048	3048	1616487840000
4138	3NLorabWezBbG2v28MCwdGhU8cz6GHDMNvRErc5KkHZxXNbyvHmp	4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	1609	1333	36	1	4028	jx5aPTAkQtAH7uvfZRunKFJ2B4m99UdpMui1yMgEHv3wRAHfibC	2153	3051	3051	1616488380000
4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	1527	927	36	1	4031	jwcuop6FA4xRjYjMXLFzeCBA3KJJiGdAZ5Q3AVbZSDwrgAL5f5Z	2154	3053	3053	1616488740000
4146	3NKN2H6YZaSBag45K4oAJuDM9wwcewCkf83TmKTDwUwxykzHr24n	4145	3NLd4p9FGLKEtLoMNst4saDyPuJ95PNhhaQMpbsjndZUVBKisGW3	484	1073	36	1	4036	jweRutNdSnGBoKz39h6wUZNoxzNSCGbQtsU5QgUqwSqktFpYmZH	2157	3057	3057	1616489460000
4149	3NLZRjZv8zKnvdkWeLGWM36PHopkSdaWC4aL2Ye1Pre1pCNYGQG4	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	1423	282	36	1	4039	jxSEFjTB3CAi3ALYoCZYaKNbTfjDx4jD3UA5Dk1zQdEgCoDSrN8	2160	3061	3061	1616490180000
4151	3NKzKmHBj9qPQ4KbH3PSWFasPivTF1sE4Uj1KKKRVnM1zWRsCxLA	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	484	1319	36	1	4041	jxbSXxSPzC3mJ6yrkgbNRiNXrBc2Lybhd4TQaUpeAU4EKncAujh	2160	3061	3061	1616490180000
4153	3NKeQtnvAyZN4Rp4mLgnfN1GjzgmX9h2iTPTA8FmwwrU61QHJqjJ	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jwky4XwsJtTY25KS4cf1XjRVTUzBn9PHd12m4qSVxxraPXap9dj	2160	3061	3061	1616490180000
4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	4151	3NKzKmHBj9qPQ4KbH3PSWFasPivTF1sE4Uj1KKKRVnM1zWRsCxLA	1560	1165	36	1	4043	jxhdSi4LQoYAqRNqPr1gxdgiTnWafnYovSYcXXsw7rnM2QtuxK3	2161	3062	3062	1616490360000
4160	3NLCp9gU1E7kuAjs8n1rijwghkKqcGW9N6yfK9ca1DGwa1XmoweH	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	44	1325	36	1	4048	jxyRaRqw74LqGRLFuc3w2DMPU8wn8DPh6yLLAwvFFMVvmXB4GWC	2163	3064	3064	1616490720000
4162	3NKgHGy4JbKfG2HnnUSptCY3VU18jdEckaJ3bzEyhPoVeS5v7w6o	4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	1477	1350	36	1	4050	jwmnXxoiZghqdXWM6WgoWRLW2MXDNVAE7cu7Afedu3NpWU6NXGE	2165	3066	3066	1616491080000
4165	3NKbmF981NyE4rKcdKtiCaLfEzCkYD7Ss1HdVdw7MWcL17cD4V9u	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1403	824	36	1	4053	jxgvKcykzCDp7iKXpKtFrJchdQ995YeMqYWJjoUcGDQWvZKjS3T	2166	3067	3067	1616491260000
4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	4169	3NKoHxJi1xV2GKTXRWnpxhDuzTZKtCAT6BoA1FWaSeB3FgtQMcfT	632	1382	36	1	4058	jxwwf4YGeYPWDDbEF7haMrp4fymFjZLuGNs4Q5JZEWzpvpmC6SQ	2170	3073	3073	1616492340000
4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	1457	1145	36	1	4060	jxwA1Zb4Ft3gXC7GvNrGg3pX5QSMx75r4jAvHtTCBmNcpAbutyP	2171	3074	3074	1616492520000
4174	3NKVupDg4SUN9Q9AaqLDnusEKPyYMCFaCq1kMqfGZU1bsYFxGgPD	4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	1503	1151	36	1	4062	jwV73rXQGhN8aSxdCGTANeBsFLBStjspRNS6B9mo3tjXXhHvzdo	2172	3075	3075	1616492700000
4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	4178	3NLKZnjw8xdVnUyebCXu2C7N1foGcEggUZwZgmaCUvhn8bGfNHDd	1607	271	36	1	4067	jxMvUtr7mPLEpqCL8fp54iEYLs74VN9GpZxJKKRDKQrQXUCWZgr	2176	3081	3081	1616493780000
4181	3NLhTzoCr9XHzBUspBN69D8GkDxa7pLvxT2mSgc6km41dBwwNQR5	4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	1670	1036	36	1	4069	jxGYTKGCPmgi4begFoVH95KBYYFanVSACEngoV9oJ92pxP21hfE	2177	3082	3082	1616493960000
4186	3NK35wBpiLorENw2pbs4ZosSMKyH3DwsJSjKCEsWxENVQixe12Uy	4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	1553	776	36	1	4073	jwzWtWDnmuxtAYqkmyMQB995hdtT5nqEfe9W7iQ85EZmRsfhmg6	2179	3085	3085	1616494500000
4191	3NL5Tj92QEbc917iv1kzE2TXRGC7AzroyYFDoLbgnbENSXdZ32Dq	4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	1422	1091	37	1	4078	jxG1aLrFwwZLeKp3KAxk4Cownz74X6RZywGCsPmdzXwZ1sQnHoK	2182	3090	3090	1616495400000
4194	3NLRhUs5LNvJFF5PJSkfSzQhWqF58pzyGJnaQ73rZMkwYPuPggHx	4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	1594	1200	37	1	4081	jxyNn3BLfadPJ9khGQ6QDrxHTepiBKMaGK2xDG6jxu71ezPLMpQ	2183	3093	3093	1616495940000
4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	1594	960	37	1	4084	jxVEATeHJHGsr2iohSJHaBPNxXvFgqa45oS4EwYmDyuLRKkfuhP	2185	3096	3096	1616496480000
4202	3NLZMjPs6g6JrGS6q3DJVxWuS374p8RSi57PAyPHeRV35yfNffNv	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1534	1071	37	1	4089	jxwiwnrZc1YNz3RtgJ7L9vnxvystkU4pCiS5XDHxcP2wPvqT6Vs	2187	3100	3100	1616497200000
4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	4096	3NKmJX8TYjq1C59CSNY3Rh7phd46RYfoQbzDVUiBKLw7bzJJuRtz	1541	1298	35	1	3987	jwEh5yBBwgweRCSLMVPyWGgcgUTM5t2m8Z2Z1nscnph7mdj5icA	2130	3021	3021	1616482980000
4102	3NKjBmTkumK5cxfEZfJBifripJysYJ6Sg3VZRrhG1UPgg22ycPUJ	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1406	1393	35	1	3992	jwQdtsnKdsDcZjJaASDKt5QodhejVRprmVFMgEJ34vNdXaEGwap	2133	3025	3025	1616483700000
4105	3NLLZ6cmyDhudNZwuxCmvdbZqnvkVvxQeXP2JHkSTphweW3Mbb7U	3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	1581	778	33	1	3995	jxnwV9VsabC9C9YPUHm5RMBKVyqRwLFmatKidSeeVQuqtkB7jin	2057	3025	3025	1616483700000
4113	3NKjeLbnw5oK3b8LQbSuhmq6jm6cswBxTdjNDupd9nFdF9uxLcvr	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1460	681	35	1	4003	jwh2wSeAKQxQeJpGUnu6ExCG411x2DbVL6ZanQGNF7WLD9B5nvc	2138	3030	3030	1616484600000
4115	3NLGj29tZEjN8miYQ4kLmsKwpmaPW3SyFE6r4X9siV6EpR9zHwLn	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1668	1004	35	1	4005	jwsZtpVir9Z96o9YZE7gbGv3irJUeHtaji9SPnTGvTFpvpgmdnn	2138	3030	3030	1616484600000
4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	4116	3NKywdTeuqc5xxst1zPnapD6wvye449eU17DbGjvBcvhkpU5wMWc	1607	577	35	1	4008	jwzmJKKD3tvguaGtyiMwtTKq5dWP3Ly3EPBiYNTDErNbS1zinSW	2140	3033	3033	1616485140000
4120	3NLwmJGNinL5NSmdcMMF8AkoFYcvEi3TN756rBV6iCP7wsT5NYev	4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	1403	823	35	1	4010	jwBocCVrZweNnu2yKrr5pvS92VCoRJg25CJr4gpixw5RC1iCD65	2141	3035	3035	1616485500000
4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	4121	3NL5Smi24YgyUjb4Gwc8FDeyoZMc796tK2aoo97NeDvbuEzcspXn	1406	1393	35	1	4012	jwsUb3UpSCPKUCZgD513CN3f9KorQXVvM9NusuN9WMcrSKucbMM	2143	3038	3038	1616486040000
4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	4126	3NKtwxqwz2DhDyYneRZ2ikmmrUQXKvBdn542qi4gjutTXC8Ui6ih	1631	794	35	1	4017	jxcwDoWw3KW3MfqDoADqk7MJkQVsyynjTm7dPDwFhKjJCQmNJWr	2146	3041	3041	1616486580000
4129	3NKHL4BXg3sBXXZNDkQ4aX38Tu9YD39hhU4EtsxofJvkMa8nhpLv	4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	1553	776	36	1	4019	jwF73pisehWP5mDB5eCTxZ734RyKVCa5PJqjijb7uUZCry29z3G	2147	3042	3042	1616486760000
4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	1406	1393	36	1	4022	jwgJ1qnq2be6HZ9ekZDHAcuc5jW14pfCmdRHPjHueKZ8xt3UUrf	2150	3046	3046	1616487480000
4135	3NLbd5p9yEZXqyTvBGrQAYbqLRCyUpRUtgMiFwjEDq2KqPe7xqiN	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	369	1312	36	1	4025	jx5tseKKsSSbkazheNU5SquzwDXdjSck87AA3VCQJurLQAwQMTv	2151	3047	3047	1616487660000
4140	3NLQELKJGm4dzFXWS8XU3yKQ8KjC89ch649PaV6QC1pdUJifLNyp	4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	1406	1393	36	1	4030	jwusyShMD1pjNFabWoHRqMPdiQcsu3fCvwTDjXRB4cBDYSPtADL	2154	3053	3053	1616488740000
4142	3NK3dBQ7nzLDAdVJ4mCYi6k1uwPY5R2q6Py7wzQ8fzhVrmaAZ5Ef	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1407	1395	36	1	4032	jwu5WFBzCNz6ELcPXQbZBvpDp9NqSQ8Jy7GhL59QEo1RV2xn5M2	2155	3054	3054	1616488920000
4144	3NL3USUNVidu8ZjWUxJim3Qg7yQTobNX616vc9FkawQf9wX1699B	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1553	776	36	1	4034	jwnai7JMHeQCc3jEkJUjuoAFAJZyrwa6WKyFw2jJNQJSPpCkPM6	2155	3054	3054	1616488920000
4150	3NKEURqBJtY7GicAU8cY8qXG8zMLVpCxZAiv1m9DDHQDxGXHTmrd	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	1407	1395	36	1	4040	jwFnSV1nCAsTq9mYcFzNAzYdKWaFiyBEmcJ3m3xHefY7XZcbdrp	2160	3061	3061	1616490180000
4152	3NKNU5kTU7N5Wf8VcFGQhGgXxmYxAFuUbaDn2rNAJe53tyidkrrF	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jxPZWSjizrfPRBDrRmSKrr4AZuN6eQMFKZGML6Cgwfnwux3aSCL	2160	3061	3061	1616490180000
4154	3NKczwaho5D79WDngFE6BHB2eFFwgFae9365PpCTDQdNmeCQ1L7X	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jxWwwr7TqoovQ3MHEAjHEUh3Hq44wFMPDe5DwrJFaJdtxu1VKCb	2160	3061	3061	1616490180000
4159	3NL4RHAasmpDh2tkGsNVXHzU92G6ZbYYimFnQFPweFEkB1q5YAUf	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1600	1372	36	1	4047	jxPStkSPh7EoVSH4kn9cH6NgYmcsUzYFm4Wtoh7BrdajjfW3vax	2163	3064	3064	1616490720000
4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	4158	3NKNxSLQrCayMHnXLdAcaTxjdpxMScA2fK4Z1pCoybCXRn7cMyX7	1403	824	36	1	4049	jxxRxLSXmru96VWp93SmcEUUVVtoHagc1dTVWPrAMHch6xr1jUC	2164	3065	3065	1616490900000
4171	3NKD6KVGGzCxy7jCi5Nid1JPiupBnwXY6XBkEZkN6Wz9q7tYNufE	4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	1407	1395	36	1	4059	jwq6mgSLayfzKRscRFjCFnTwurtJfC5mZa8L6t9duGyESSkU1a1	2171	3074	3074	1616492520000
4177	3NLwGH4yfaKU1FnmXuPWWpSKdobTdWpHAxyuiwKsxGKnmfsoWvqZ	4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	1457	1145	36	1	4065	jwKV3iGhRVbL9iPxfdhDgXo22rqsjVNt99rqrnoWmkAnkThoGhq	2174	3079	3079	1616493420000
4180	3NKducHU4goKH3X6nNhBC1R9ucrt68QqvdC78wrnukFi8ksSuU8W	4117	3NL7oayULFbQ4HDSwYcmQxfAtGaqF4BDtUodrscLQYkERnWXpSo8	1507	1280	34	1	4068	jwxgzcwFMoxfSVdcFcDZpTqrb53nomnmmUnVsteWPrBLQrR8vFg	2040	3081	3081	1616493780000
4184	3NKMGwPQ11xr8FMXJt13EGF5h9wrkg6Umqdsy6GxdoAHrwd5MrQS	4105	3NLLZ6cmyDhudNZwuxCmvdbZqnvkVvxQeXP2JHkSTphweW3Mbb7U	1581	778	33	1	4071	jxhvRahgYVYiB4gcVuVjhctxX4hrJAjLG8hapoVQwbDbmjnMBKa	2058	3084	3084	1616494320000
4187	3NKmRuPhTD3wJ7TVibDFWonhw9y7WJGH67mJnZAw6hjNLEQnYTrf	4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	1403	824	36	1	4074	jwzajDhkckaiL4mtQoeWj1qdm3xPJ5dDgXnYxDqKo3BYzPAwfGt	2180	3087	3087	1616494860000
4189	3NLgC6GiC3sagmM9zwY7E8W82Wnc2Na5XMEgAKd2M2LVVPMEtVL3	4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	1656	1343	37	1	4076	jw9X48PQg1yxDfM4h9UUoT5RRCS7M4JUmdHJuw8Jb83FjZZC4K4	2181	3088	3088	1616495040000
4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	4193	3NKnWE4CesiNmVpLzT3LmA4SXQPiUCTMuBYwGtMccQprgWjub39G	1623	839	37	1	4082	jxnqdWZyf53ZbwVdX297C5Qr6ha3xDEzgKwJ9ozNM4rvyatGB3r	2184	3094	3094	1616496120000
4198	3NKw3rEPUAYNgqzJ4ymChwcU8vmtafGy8TEg861meASBMZZMpQNv	4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	1407	1395	37	1	4085	jwDBipZTfWQCv1wAKabMSYCQXQNBCS2RasoGncMfUCTEbsQpY2b	2186	3099	3099	1616497020000
4200	3NKYeeEra6YYUMP34eSjai8dgWSpSxWRhNZpvFNgrwHY83dsbHQT	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1407	1395	37	1	4087	jxVnDw4ApW87BuKXCJFwr25cdSoAkFstpN3Tzpp9k7iYu1wxPjw	2187	3100	3100	1616497200000
4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1403	824	37	1	4090	jwm3FAZfTpJeCAfRaydQqUHyP7zp7cGraYDgSCmSPehEBQ3Bs4i	2187	3100	3100	1616497200000
4205	3NKxtqfwyvcVwtEJVM1MhGastE2YTPmZk6mZg1encd5cZ4pxxS4m	4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	448	1059	37	1	4092	jwwFYNfKb6md6S8LvA38vYtb6eZ1Pkhkty7J2oA1TyA6En1vkZb	2188	3104	3104	1616497920000
4210	3NLRmbX6ZUdrX6bkWY54Q9j499GBYJFLRARUk5s5CVy1Mh3Lygcf	4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	1431	98	37	1	4097	jx8CjqFM5br8p3i77dJZo2heyfjVkSqH4WQ45z9qx4JqeiYbPhC	2191	3107	3107	1616498460000
4107	3NKBCMwgRnEFJvpiHeUcy1RQiiWma3ZH48QVNzD29txFT4Qbbdn2	4103	3NKvEsTz9WscnNaPTxqp6TuK7NyNSKrq89vDBjDz3ecQZnAHcYYR	1403	824	35	1	3997	jxnzPS4jH1J32XHjHaJkuZdnNDNKExq73uyZe9PAnkPKBLjxk4a	2134	3026	3026	1616483880000
4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	1529	1070	35	1	4000	jw8L4JU7MjykGuxncq1vyGvTSdTo2VWwG11fbpWuTzoWk53QrkL	2137	3029	3029	1616484420000
4112	3NKw6wfhENLmLiyqK1DtRTtCKEJ8oEoBgWCUrwuwXCzPm5Vt88fS	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	55	178	35	1	4002	jwAM4KMivRzKrhhJaNmjMpEa7JjTQJbmP3cNYdZoNNfYVvFZoAr	2137	3029	3029	1616484420000
4114	3NKFGKTmX6J5vgXXKx7pRGyA5UubtwDAveW43bnedzZpd6C639Di	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1657	1344	35	1	4004	jx6Le7BjWob4zJwmBf8nW7ieSL1aRYWSjQSVkVXwm14QKUETHq3	2138	3030	3030	1616484600000
4128	3NKoasvybE9sjuLbeQfCcGBBRG7poT8WxAk6YoV2Yjsh2Z1aTomD	4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	1670	1282	36	1	4018	jxpCzdrRt2H7Do9upvEww6ss1ucondKPSaznpczpVqvpy27Kgp1	2147	3042	3042	1616486760000
4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	4130	3NK8cYR43LexRiKDJp9GCMUbbYKfA2UWNxatzST2kt4ztNQM9DSi	1403	824	36	1	4021	jxHWoKJHxZ98K3WgDsGZYxiVgrDHR6c8yfLhttF4wgS5N8qR9r2	2149	3045	3045	1616487300000
4133	3NLZTyu59ScP2q3cKT8ukiHR3XW69BbsTWtNprLxw6hs3RBf2nav	4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	1402	890	36	1	4023	jx5FnJKtdi74LwwAyAonoKR4T1A6PDTABq5N18aJf8VQ7QeHxYE	2150	3046	3046	1616487480000
4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	1671	1239	36	1	4029	jxeksai4FaqFQnPauv3S1HJ6iQjxGRj2X7xSPRwUGhkqKxuMFvS	2153	3051	3051	1616488380000
4147	3NLvKLVp3XqV15R8CsoHCgevvLJJNcqWALxpVhpUntZBn7T7Y2yJ	4146	3NKN2H6YZaSBag45K4oAJuDM9wwcewCkf83TmKTDwUwxykzHr24n	1402	882	36	1	4037	jxfDi4fgBsAq4hiyfjg3ebDhCoKuqS2dBp7AkzWsT7db8SjoWzQ	2158	3059	3059	1616489820000
4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	1522	1322	36	1	4044	jwSJG6KaHacAQpatJgCsXtbuFCVpEde5Epygpm6pfXDarhPv6CQ	2162	3063	3063	1616490540000
4158	3NKNxSLQrCayMHnXLdAcaTxjdpxMScA2fK4Z1pCoybCXRn7cMyX7	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1407	1395	36	1	4046	jxLWL2aVqKdVydoDY1nmvW1nUdS1nCWCmqtu9p6MPo12t4hSe5Y	2163	3064	3064	1616490720000
4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	1590	1300	36	1	4051	jxLavuPeJ9h8wCtWQ2a5kGtmEbyqTBdzk1nDb8zk9WB9bnyBVpd	2165	3066	3066	1616491080000
4166	3NLoen16FZoSKTPJEcZRtZWkUatGBxUQqymh9LMNAnzYKQUaKV7k	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1406	1393	36	1	4054	jx6UcSGZ8SV5tY2kVwfRiLGaKzrN8VeGjFvNgkgae3Kq22Hq75o	2166	3067	3067	1616491260000
4167	3NKHm5rhTyKEnCtv8fhjzzxK8cycVnhKiPitBnJXHW2bCrzHKsa4	4165	3NKbmF981NyE4rKcdKtiCaLfEzCkYD7Ss1HdVdw7MWcL17cD4V9u	1407	1395	36	1	4055	jxpGW6j6WZdBT1KMd9w5nFHEMHkUq3oNAvCw5KiuNxCTfZwvfVx	2167	3068	3068	1616491440000
4168	3NKjK1wZso1nCVdQHWQ4a3cMNHtt48PB5pWrBuAXXmnf15WaepCm	4167	3NKHm5rhTyKEnCtv8fhjzzxK8cycVnhKiPitBnJXHW2bCrzHKsa4	1509	1320	36	1	4056	jwLzpMKVfyrumQvmHzExKPsszTPYXq5gqLNpz27FVVnRv4SgZ8i	2168	3071	3071	1616491980000
4173	3NKHpRUyNZZP3u44v1oA6BeaYFgneBVHyrNYqEQt4oxhPpSLmeeK	4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	1403	824	36	1	4061	jwBjyPtxLFU1eU9jEn9afbv6EaZVj6WKTjjwFidAkmrpZYo84vV	2172	3075	3075	1616492700000
4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	4173	3NKHpRUyNZZP3u44v1oA6BeaYFgneBVHyrNYqEQt4oxhPpSLmeeK	1668	1370	36	1	4063	jxqSSYP3yjGEf9w72cZV18HKxoz7GSurJqC78qK4VgjRebEKHVG	2173	3076	3076	1616492880000
4176	3NLQoRpbh6gpwBhW642CyBhXbbQsdAW6Ud7zRhfHK96NY5qP5hws	4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	1406	1393	36	1	4064	jwD5jrFr7vvEmo2ZCfmkSwp9rW8EfvSHPsTi8f9hLCS8VxaGBgq	2174	3079	3079	1616493420000
4178	3NLKZnjw8xdVnUyebCXu2C7N1foGcEggUZwZgmaCUvhn8bGfNHDd	4176	3NLQoRpbh6gpwBhW642CyBhXbbQsdAW6Ud7zRhfHK96NY5qP5hws	369	1186	36	1	4066	jxQVRgwztZPgAHedYjVDofuYqwT5BoENRQHWUfj2RqgaT3xa4a3	2175	3080	3080	1616493600000
4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	4182	3NKqGj3U7Tu3gKLThbDRYeUZ8cS4kdqEqToUC9xx5xhoKCMU4wNk	1617	1042	36	1	4070	jww8PVcKDhBbWyP9bsGN5sMSGYUv6ZJuqBsT5w3jhGP9KDUwD6T	2178	3083	3083	1616494140000
4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	1406	1393	36	1	4075	jxY3xSevWB7KxCR38DpSbU2g5CSXJpgXs28Zmcw9SsAJjhLHT1c	2180	3087	3087	1616494860000
4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	632	1382	37	1	4077	jx5taHMEFvCrrtPinxaqdSJYnXJ6Q4kwnjq5FTGcaQ3S3daGC88	2181	3088	3088	1616495040000
4196	3NKkKv9ZS9HAmx4TcoczBGu86ux7aYnVxtB2xKgNrzXLgT7Df9R9	4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	1546	1339	37	1	4083	jxrxLtCcvCHW5dj8AxXUUzRL1HUnGapEajUcEg46gezqZZQxZhn	2185	3096	3096	1616496480000
4204	3NKtpuKX8VdD2fN2R7kHfBE5Bs9v3aSTEs8ujy5fs1SWbn1qXX5T	4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	1403	824	37	1	4091	jwnWVjDMtZLsHgLpFiZmSEJdSQHJTbxdMoDaoxPa13meuidnFrK	2188	3104	3104	1616497920000
4206	3NK8MFwRDKzy8Erg5Qt2ysuPmUBWetECFBHkmC9zDocR8xhnMzDR	4200	3NKYeeEra6YYUMP34eSjai8dgWSpSxWRhNZpvFNgrwHY83dsbHQT	448	1059	37	1	4093	jy2G2mZdBdrMtpdYfDqCtH81xtShj3wazFsbUEd6FvQvorCGmkd	2188	3104	3104	1616497920000
4211	3NKLC5oR3XC4Tr5mFuRt1HYtKTJPSniVyJJPqHFb8DR8eucTtev3	4208	3NKD4ajEVo2NxEDjEcCZ6pxMAGbWW3YxcNmSPJkXU3gFHsR4Gag4	1549	1116	37	1	4098	jwyKgArsJejkAoFv6av5RizhoLxt9jtq6XsSuzVGa7ohxbptm2P	2191	3107	3107	1616498460000
4213	3NKT6Q9o5QoMLimpwHpFeiwTTZS5oSfd5LbBWUm8EnqeDTyByHPL	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1602	1369	37	1	4100	jxG1WWj4Y2H4MFbyN7o2J7GBvuWj8jXW9btBFWscYu95pZbGaWV	2192	3108	3108	1616498640000
4215	3NKc6i45r6YgpJd7PiKPRmV5wi2ELpUEJGC8wxUj2tXsEvhvL9vK	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1652	1069	37	1	4102	jwYPoASU4aWvebm9pcNSXToNcTf72dnBDwzMKZdCg5Nin9UvHHv	2192	3108	3108	1616498640000
4224	3NK7VtmTK6Y1Wcfqe8hAdLHZpvankY3H9Wf928YbWqsJ7YBBKmyr	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	44	1325	37	1	4110	jwCYiVarXtABkfUXb7xYBPTK2nTQTCYFBUjULm1RfsG654j1Cxo	2195	3112	3112	1616499360000
4230	3NLuvEuNZjUGAD9N94ZA1A85HHtf1vGF5Y1jNxgjVPhT5tMUWFTi	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1451	1166	37	1	4116	jwKPYj9heeGpqe9JrPxPDqGgmCmK64gVNQAnVmyNxgDqyv8csW8	2197	3118	3118	1616500440000
4238	3NL8Eckegg94T1FgHuhHYjzipVdMp6vsoxwaBNw1kMaNw5w9DjgH	4226	3NKwuJR8F9pnyaZoE7tpUABbJ4Mv7ZeEtixtpKHnA2jMZkqBJifP	1581	778	33	1	4124	jwmrhYGrg8nyvHsuAZdR2dcdgfnUQge3QheXxRiAdgk7iVVXMqM	2060	3127	3127	1616502060000
4240	3NK6HA43Vo1BoGJEXD2czrvT3i3zttpstztZyoiMbDBRDYU8WaNF	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1623	839	37	1	4126	jwSrjcww7U8Lr5hq57TDrPDS4ucbsrjaceWWePaW2kA67wmzMsr	2201	3127	3127	1616502060000
4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	4204	3NKtpuKX8VdD2fN2R7kHfBE5Bs9v3aSTEs8ujy5fs1SWbn1qXX5T	1460	523	37	1	4094	jx3jyxShYfX8UCchJUTjN6uyKa2gUSjvFUVW4XbtbfJL7ZSGW6t	2189	3105	3105	1616498100000
4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	1610	1068	37	1	4096	jxqTzNnuunvNvsUCmqpaakJB1Us4ecViaAiTzqhdtdMg1rZzRvG	2190	3106	3106	1616498280000
4216	3NKLdRJLqXqx5fs5rfwfoH7VzQ41zFvmEqCV3bT5jVQmsqkkP4Jd	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1553	776	37	1	4103	jwGQAeo5kKCN9LG9T8nCJqzD6pLHHo322qgWeEJHPD81o6zMNRY	2192	3108	3108	1616498640000
4218	3NL2JUgagbHoX2vGMNH4FSvhQxeCjixBwLcvJWizYfsJvG1S8DVk	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1652	1069	37	1	4102	jxDwJjf3ggb8HfLBvnupo9YWWMLMSahkKrHNotUbcgnxYBfBuAA	2192	3108	3108	1616498640000
4220	3NL9aUDvoHwu7LyBAiKV9js5Si3TCByQTYi4b7vzn3JFsBFMHv4D	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	44	44	37	1	4106	jwcTLzewB67u7s32Zdj3XGoFKpNJ6z1ZiVXAjjv3s4nbUqjQKZp	2193	3109	3109	1616498820000
4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	4221	3NLp4LT7V55WZGsAS6MNKjRdyKrQeKvBHW4LQyVZJumovZk3YQFw	1483	1276	37	1	4108	jwss7R9fgj2Mj9kyZDDiwMqoaBdgHGvxrR4uqqQKTysjjPkSbt8	2194	3110	3110	1616499000000
4228	3NKDoJQBtmL14nH4kCksTkjwauV5HYA165QvBkfgyiP3mpnVPmr2	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1426	1118	37	1	4114	jxnTqptAqB7K2NEiT35PpYarmuR6XbgsEb1C1ABvAuVbCahXTJp	2197	3118	3118	1616500440000
4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	4229	3NLcPFziA58Gkm2CxS3YY7TjreKrk75bQ4EiXy9wuEr14SLQBodC	1407	1395	37	1	4117	jxfV7QKhd7jM8o53cXcW1pNNUuwE47oDehchuziK2yG9cZFgq1V	2198	3121	3121	1616500980000
4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	1460	1324	37	1	4118	jxa5PMg45WrDvbtroaqtYLxd19PdW2SEwERbZAV3VQS2MVHdtAJ	2199	3125	3125	1616501700000
4234	3NL2zT4LFJqUj3h4ZkHEDFRWCkktAPFz3hJmqPsw88sEbisf7KWP	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	1587	991	37	1	4120	jwFntnML8N2J6m7mW5hht9LKYZ1zKhPwvWw77gpnCjHh4ygNTFA	2200	3126	3126	1616501880000
4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	1477	1104	37	1	4122	jxQkqtv8veko1x5QrNVDA4dTQ42XQBuaaT9z4evMWYHBUCFn9Zo	2200	3126	3126	1616501880000
4243	3NKmHyfgqnwYHCZzeaWHzEQjGcmHKGhvBU4nRvBGvnmaPVPFnydc	4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	1444	1255	37	1	4129	jxBiQRp7vRYyFJpaau3fqGazrS8G9SPyPxuCGuM1x7gLCPcZak4	2203	3129	3129	1616502420000
4245	3NKJFoPzgafYZFhRB7n41TS1NibjVoKhLNB2TwD9CpmJZHnayMZF	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1599	1041	36	1	4131	jwjTifip6Ww2MUfzoDvWp7TEW8bWngEycCadiyNj6oqPXnnmHPu	2163	3130	3130	1616502600000
4250	3NLRqEra8kx3yYbBP7s3i79tejwNr8ubYpBEHUwLndfMsjZxydGY	4246	3NLCmDgr9Eewx3kLbqv1QQJRW2KgzBJJrir8EoR2bDFyxLKekVSR	1406	1393	37	1	4136	jxiXroB3WKq7rPPDC5J4MNbKSjxxRzbzxDuhvRFfuaUZYvffb1S	2205	3134	3134	1616503320000
4256	3NKXzjtjgyxziVSGC2LpNtFWRwTz4fcN43iH3y9t2AjZzWZJqm1D	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	1560	331	37	1	4142	jy1ATK6vfoHMnp8Y2QeU8g1qgX9apLzFhSap8aKSxQJsgCV1bw9	2209	3141	3141	1616504580000
4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	1633	1264	37	1	4144	jw8kwBMnohpoz9Mqyc2mtFHwBddw5oPv6hJUbycWxJJ7gkgqHNL	2209	3141	3141	1616504580000
4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	4271	3NKzGmTn7UqVFdqStfayGD32E4CA38Roqur3z7QfwDAvSBdYhx3s	1536	947	38	1	4157	jxvQJRVaL7ZidRXvXZ4NGF5dLgqnfn9uJmzzgw4QQryBnD4H6w9	2216	3149	3149	1616506020000
4279	3NKAA6brJ99zPHTZwa4FLkCLQBGJCy635UTZW2ZfMDQ5JfEU18W9	4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	1447	1345	38	1	4163	jxmHrsCR4dw8KWbqJUxPXEfFaWpEauYb5vRRiFBJo2miiQT2r7q	2218	3152	3152	1616506560000
4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	4280	3NKcQKJDnue7CsQddWyS4e1KedyTzk8nTcvtRUrd68Uy5N8zgeMs	1407	1395	38	1	4165	jxPiBRzszJf5Q4q2bzYR5E4gSZVs1v5poHe7ou6biVH8LwdyFJb	2220	3154	3154	1616506920000
4284	3NL6oEumNBfeUTQHo5y749GUcRsRh4NsPt7rPv7zYz2vvP8fnQqx	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1668	1124	38	1	4168	jwR6NhhucJbatuXMei22t9UookASACJSWa3qGpBGt5hkRdguq1T	2222	3158	3158	1616507640000
4286	3NLZUeyEkcq4JLArATZpmytzD6oF8t2vK4gzZX7dTUzoGD3ywZQM	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1419	814	38	1	4170	jxg1AbqDNgq1jikGVsBvSrXZguvbJEndF56Ggorz76ioDNhkjg7	2222	3158	3158	1616507640000
4288	3NK3zEoC7N3x4cXcHuG41kxLdzKuhhRS9krgW73c5JyymbBR6zge	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1652	1315	38	1	4171	jwmKRs15ktAKGE22eUKCHgPGjnbq6AMf5dEJi6uXHyiWXXBRJYp	2222	3158	3158	1616507640000
4291	3NKqpZQzVRPGyTpyieDi8vad722DD2X8xB3bNhf5U8jeMfDH9Jdj	4290	3NKf4MMtA1LAsFjtd8THhKgsBtmvTJtiahP1UrXDpxErG4j4Kknt	448	1305	38	1	4174	jxbba3eTBqcHKsqTTPMRtgvMvUPnjCVMJ6KsHRgqwqZsVWHNrNN	2225	3161	3161	1616508180000
4296	3NK4YhRPZ1S4e7D4nchvkQt8Cb9z415CMTZi8owbFaUmQA8VE2R6	4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	1407	1395	38	1	4179	jwJ7tQtoBMMMKXJjN58vSbmd6E2JmL7NrG7Fph1c4DcEg3E7aj8	2229	3165	3165	1616508900000
4298	3NLR8iqahxsaJ3LqszB6R97xXXiq6PQPhVxQzMyQjQfb1UrjcRd4	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1634	1331	30	1	4181	jxxT6aYiakdJ6n2H8hQAzukjya38BazBkHogrNgGvQtBc2foyHA	1940	3166	3166	1616509080000
4303	3NLprJU7b7VxMddtvNcLRLhoRtYBWWj3VMX776DdpAqHhw7PgWjD	4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	1651	462	38	1	4186	jy1FhavL12r1PExxWc3EGdboBkDhLZ2GXcWy343MCvogw6yegXt	2231	3167	3167	1616509260000
4305	3NKor3E3cDFgbqPmnh5NNkd1uzzG4nqdbwCucPwWNXLikhyUw9bX	4304	3NLJ1Up8MvzGK1Uzbp3FDobWroqD8UxEyECWTvwMJqDTk5WRe9Nw	1406	1393	38	1	4187	jxHCicLgrCAbZJq5QiakRx3ivwK2W36misPSU4wFwPpCj8T1Vvs	2232	3168	3168	1616509440000
4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1577	1327	38	1	4192	jwnxZfJUR3wpEtr3nk2kY5qXbNbb6XccZuQeqEMGijaEh2gJVYL	2235	3171	3171	1616509980000
4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	4312	3NLx7pZPXeSSyj7Pe9L3T5yhHuJyb9dkhUKVaZkVKhYMrSPTCU2t	1407	1395	38	1	4196	jwz9iDTZhkY6kH9EVvLv6mywKnLFT5hfBvyeUN2K1v39u2iXFYU	2237	3176	3176	1616510880000
4322	3NK6AfdGtroZ72fL5eohywSbSF6mS6M4bpJrLswdb43xtCExd7dU	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1631	794	38	1	4203	jw7RBUqt5pZW2M77xT6tyVourXGq8SaK37QwasCAYUWya8nELav	2239	3178	3178	1616511240000
4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	633	1384	38	1	4208	jwAep2fXs9Ugonz1M4FjC7UeBiAV9Nct24XGarppNGDzDQcn5wX	2242	3183	3183	1616512140000
4330	3NLtKFv7XQR7zDhbgvxWjntU2nYXBePLSTs62dcL8u4iUk3ntEab	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1602	1003	38	1	4211	jxs4X4EMB7W9D3er8Uoaw6Tt9BswithPCP9EKF5P3D8KZs15dad	2243	3184	3184	1616512320000
4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	606	1295	37	1	4099	jwfKjh3NCWkk5pu5CoGTcbJZaWo8TG4AEHfQcDVhnH5jkYcapkG	2191	3107	3107	1616498460000
4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	80	1147	37	1	4101	jxqejZ7mUb5JkRUXeZ5TCjWKj46cZuy18XqsGuGTnjBosAQbqrL	2192	3108	3108	1616498640000
4223	3NK8f6upcNpTaKrLAMK6WPfaZP46bnYy2CsywtQKwyTExsFmYp9m	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	1619	1149	37	1	4109	jxyVW6FGoPZa7yp4icCJg9HjpfK7FRyrY5jkNZrwSrpBV1hd1Bh	2195	3112	3112	1616499360000
4225	3NLK5pHKNzgU3RxmVBAfPDXaKnX1d81LTPVdHUMPeN9thiyYosEf	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	1448	1311	37	1	4111	jwmQvxVz8vMU7TjK7D9ivPBKqkGhL2m9asCT5o5zPn41A2jwQv2	2195	3112	3112	1616499360000
4229	3NLcPFziA58Gkm2CxS3YY7TjreKrk75bQ4EiXy9wuEr14SLQBodC	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1571	1335	37	1	4115	jwZtf7YQRsCEiB2yLxEFh36PGV6LFYeXdhkVnjHXtFc3B3YurL4	2197	3118	3118	1616500440000
4237	3NKjarbFYSrkxoS3UBfvQZF9rWJiSFVaq3cD3xQq61RpLAmMh38b	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1602	1243	37	1	4123	jwyHJ7CBW4GGh5bbRUDTZEQbXD2U6qw97JCuoiPZTFuEirroqQn	2201	3127	3127	1616502060000
4239	3NKYkksdiQVJRr1nwyVG1G9SsQU8W18FgFUostv4UPc74nTemP93	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1573	952	37	1	4125	jwZPjXxzcS7CWVkhriFTCDgvATjWoKfB167Z5Q63hSDqbh6trka	2201	3127	3127	1616502060000
4241	3NLeRapiqJrixbFs2M9NqVX3JDEAqgKyb3o2ktxggdhHKdHMTS15	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1419	814	37	1	4127	jxW6ZhCNSdrKvmmxUcgU6aqYSQeUMihoPpXPHUFkEYTfaGDKRYm	2201	3127	3127	1616502060000
4246	3NLCmDgr9Eewx3kLbqv1QQJRW2KgzBJJrir8EoR2bDFyxLKekVSR	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1444	1381	37	1	4132	jwnjFrnWxXAu7hdGHyqdjo4AvD8VRDP2dm4fVCVRtyyYVNMQR4d	2204	3132	3132	1616502960000
4248	3NKcMVmE6vpRUVrgGRCXSUfDDgC5XHG2zttLkKWdBvbeV4R3Px9Y	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1529	1070	37	1	4134	jwm1Xj9qu9U1J4prWsyh7kpPEHx4sPsLhCXBm1kkfcxX7S93Ccg	2204	3132	3132	1616502960000
4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	4250	3NLRqEra8kx3yYbBP7s3i79tejwNr8ubYpBEHUwLndfMsjZxydGY	1573	952	37	1	4137	jwx2tgPjWj4dQjNdC2Ftkgm9DtgRS5DbxfgGVnnJu7PkvqJvusx	2206	3135	3135	1616503500000
4257	3NL2mp7ftpiMHzfHutXSEjxtaBBR8mfJ5h3pHBQvgfem2nJuhFgV	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	58	1155	37	1	4143	jwwLhR4Esx8TGq8h8PVCvNi1748N35zvvnTyrNBiLEdwZD6UsLB	2209	3141	3141	1616504580000
4259	3NKBkrdhQ1FVjTmuHQCuAtt6Fs7VSk6FTeB61oqpBqykjn1M7hZU	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	298	942	37	1	4145	jxU5VLvGdSb2dNnBcU7rrfZ4rsMDwYhDBHBYwqX8Xhux18V5ZJq	2209	3141	3141	1616504580000
4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	1483	1276	38	1	4147	jx5CJus2akxcoPaRdAAHUhC9FKjxv7WhVPXr117GpyEgMtf7zbG	2211	3143	3143	1616504940000
4263	3NKvCt8BVrYjJJQ3mGnpXXyrqZj87UC9HMQpkBjfz3SuDPvW75Wy	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1559	1353	37	1	4148	jwkNpmzpg5nihxChE7CL1DMShAUHUpSgPTRT5vuTgwsMjY5EJ6y	2210	3143	3143	1616504940000
4265	3NL4v9VBdMz2w38H41v1Az2EbLVkYtexreaoHkXZvp59bx1xP93y	4262	3NKi6VNp6TxpSZ3KA41hjT7LdJXbhUpnt4DADRPdLVRSBvTgdSpp	152	1330	38	1	4150	jxg5XrSvZwRMk3qUy9TLYNn5sH6D5PVfXhvQwpDYLKkcMPN6vDg	2211	3144	3144	1616505120000
4267	3NL5hhLGAU3HNeuerA5uQLSvzahSrpWU7MGovx5tkVhx8ZdXpYLA	4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	152	1330	38	1	4152	jwG4aaLD6Ln69hM8MpCaT5BQEsWPn8vqssUw5KWmdEGGiho3HHw	2212	3144	3144	1616505120000
4270	3NLZuPfSertBQc7XunytzZuu3WcGE5dGCbecg8idjLgvaY2z9adT	4268	3NKAVUqkszFQa75zt5BPM5Kdyq79kw1tPnpLnoHg1wBKSD3hR2dc	1460	474	38	1	4155	jwboipB3h1G3jpL3H2ThQeSdaiMzxT2V7QFCHbpvrmM4PKQEBan	2214	3147	3147	1616505660000
4277	3NL93qJ4cwSb9HYpgsb85mvEQo8uHEXG4jjCD6xsNo5AAtToVdNc	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	470	1309	38	1	4160	jxg7dwhsXchbdGemu485eVFVEaUxNFenpAeABZzV54QQLrErnLu	2217	3150	3150	1616506200000
4282	3NLK1baVC2i8w7zN18Wg6tVTtwpWXhsopeb8c1gXKzvdz7uBZvvK	4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	1589	1286	38	1	4166	jx9jPrSST2hrBYkGD1HTX9AuDN7KaJCSqBNeuWzC6MnRF3tWHy5	2221	3155	3155	1616507100000
4285	3NL9v7UbE5KSsQhPFQx8px4RpZAHkdPuufoyXmAx2gQ83umidR5N	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1672	1285	38	1	4169	jxAED2J4Rq98cZceFW9DiJUd75dJHgyQrft5tBKGa4RZXmBxvdW	2222	3158	3158	1616507640000
4287	3NKr6UCWjSe7LD6GNf6ZwzjUvXosDQq5QbjkYq9bi9apdUaPueea	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1652	1315	38	1	4171	jwee9xMup5wS9qXQ1he25EFhcKbKuDzuJGaBiDgNv7eKzw2a1CX	2222	3158	3158	1616507640000
4289	3NLCEPpguFhzCq7JpeeWu2CvYCZeAwYCtouH5odEuPaw9JCfV2s4	4284	3NL6oEumNBfeUTQHo5y749GUcRsRh4NsPt7rPv7zYz2vvP8fnQqx	1402	884	38	1	4172	jwoRu8aqMF6FbSUhGz1yVBuVykTXF8QryTb64oEgt2WJUCLuPwe	2223	3159	3159	1616507820000
4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	1542	1304	38	1	4177	jxsxKeE8GRhrQ6YXaVDr3HowjzyyFhMddiYf9NaRoUw5kGaT9Jy	2228	3164	3164	1616508720000
4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	4297	3NKagEtLPyzDApZMz8AZDrinKXPCzQVbTFv7d8bQHjm7gB9dFPse	1407	1395	38	1	4182	jwaZSd4zFQLKUoWGCY9KnkXv581Bd6YZNdi6dJzfhR4zz1SiHxy	2230	3166	3166	1616509080000
4301	3NKwC2PFEWN4zNyyFNMVbEbrjDYKxzJsLoebBq32WQuoYSTd2kpW	3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	1634	1331	31	1	4184	jwPeed73Udrt5m9EjaMs4ioLMxfUGMkLg4c9UiFu5GwwRmfzErg	1966	3166	3166	1616509148520
4306	3NKAwu5nYQAFBwMBSbZkHW23Mj1xAUSnqGv9RHU575DbBHe1qe2F	3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	171	1128	31	1	4188	jwtrRUZCzfNtYj1LL2V4CbSu6w3iTQ81qUWUoW3vWSGtFancc1n	1996	3168	3168	1616509440000
4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	4307	3NKiiyVhc1KTEWCJRQyZEyoBAjkmqjmkWS1yWtvAFBHyDaNvyuYM	1407	1395	38	1	4190	jwtbLuHp5KMcA5b1KTMjETTM7AVjpB6keKWtSuFhh6zYTK4kEqH	2234	3170	3170	1616509800000
4311	3NLRz1QbdFZ2ZoGTMP2WobDfNnPAMnrJ4dcDAwwcw7XRPQ6Snfp1	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1577	1327	38	1	4192	jwybquK45KuX8W6USN9Q6R6v2LqNWejwqimi2aAz1JExskYpqGm	2235	3171	3171	1616509980000
4313	3NLDbpC2pLQ8asaJvjwU6YAkLVHUmu7t8Y1aZfZQVfDieU2GYoTz	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1483	103	38	1	4194	jxnnLekDJQpN2ErdCbDCihecvErwwpNTYbAJ6TutiGe3KT9Uqx7	2236	3173	3173	1616510340000
4316	3NLaYxeZDAz1AfZFpJxAstNfDXDP8mSeZxcxwhuNuCAvw8EJ55us	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1406	1393	38	1	4197	jxDCzjCk3jWbRrZAUYrHNCmQ2YuAd1JpNFCAXPpPuTJXNJLHUaY	2238	3177	3177	1616511060000
4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1631	794	38	1	4199	jxJunZ7x424CjbV83KwvNyzT5BYfVqQFjXy9LfGUMtgZbX9Ew5U	2238	3177	3177	1616511060000
4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	4237	3NKjarbFYSrkxoS3UBfvQZF9rWJiSFVaq3cD3xQq61RpLAmMh38b	1542	1304	37	1	4128	jxaRmzJesPhqC7bXdt2FZt77tpsxH45gmztzb7u4N8eqbsqJkF1	2202	3128	3128	1616502240000
4249	3NLdGnm74tMdoeV6qVBkC9pNaZHwHQ1vCg6Yedurm9gB9nWewgzz	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1647	1302	37	1	4135	jwMYkp4SuWs85QdrwxjMJXrNQaNKxEFnyoDMknmh9HGYnBhEwnr	2204	3132	3132	1616502960000
4253	3NKKcUFCoWebohxVf2BKdLepNs7GSgEjT3PCsUL6ks9LVWaE8ugv	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	369	1312	37	1	4139	jxUr1sY7KtYwwZnmVeKN5V4rVTu9AdacpsXeDJ3dCkcrRV7q17G	2207	3137	3137	1616503860000
4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	4254	3NLZUTQzXxscEABQSRdwrJb3ohdFEKgX1T8VSKpsoBeZQ6bRggj9	1654	974	37	1	4141	jx9Y82aJpmNsdFUEwnu5rNxtLP78kUkaBLBwT3gcuyRUeipx2zK	2208	3140	3140	1616504400000
4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1590	1300	37	1	4146	jwz8cksVMT7aHRZqtNakrGCoaCziTdQHkjvKMTCTRa3pmFbDwPu	2210	3142	3142	1616504760000
4262	3NKi6VNp6TxpSZ3KA41hjT7LdJXbhUpnt4DADRPdLVRSBvTgdSpp	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1559	1353	37	1	4148	jwxHAtMtfuSBuiNNPKG45GX5GJ41dza5RDyJ73NRn7QVDQTGUJy	2210	3143	3143	1616504940000
4264	3NKPiLcifYTLn1FyshTbEgVNRjEA5b6XnvmXaXSbj1EARpWCkBjH	4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	1559	1353	38	1	4149	jxxY9ECV9gqJ4HWEi1B8w5p34iV1MMct1ZFwX5uTU6c8Hs5Tstx	2211	3143	3143	1616504997511
4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	1406	1393	38	1	4151	jxfj2ifCFms2k3yg3uKCGVoNgHsu6JRxW39EoUvCZ9v1yj7xqGx	2212	3144	3144	1616505120000
4269	3NLo2RkcGqDhNEbReeZwJgG9fYpV6Q2Fcgs7mcMY3HZaaRBxJzpm	4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	1527	927	38	1	4154	jwcwrWKNkgsWKbkY11TAw1pwx5NzLyTrzNjNhegGUXEJU8D8kFD	2213	3145	3145	1616505300000
4271	3NKzGmTn7UqVFdqStfayGD32E4CA38Roqur3z7QfwDAvSBdYhx3s	4270	3NLZuPfSertBQc7XunytzZuu3WcGE5dGCbecg8idjLgvaY2z9adT	1407	1395	38	1	4156	jxjyoeQDR1tfQDtFe9XajfqBNWpg4NiqiSh2DncWTeJdaP3KtJU	2215	3148	3148	1616505840000
4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	1426	1118	38	1	4159	jwZjBn3Asb257Zc9EtdUbQFgwjuD5YbufqeWcejcsvRdxdPMBtu	2217	3150	3150	1616506200000
4276	3NLWkagpcuSi9vqNf8e6R6KmZ5mDjHgCDwWv2CAGgzFupEGsj95x	4180	3NKducHU4goKH3X6nNhBC1R9ucrt68QqvdC78wrnukFi8ksSuU8W	1507	1034	34	1	4161	jwc4pTdK5qyDqrV5LSYg2dTKqN595mVi9hibra1kHAkNz1qApzw	2041	3150	3150	1616506200000
4278	3NKMRLztKJnBHBjZTbts73SiKavn9kmwNp6JycuytZjedvPfHiY4	4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	1406	1393	38	1	4162	jxn6JUt5CShY1MpdSZbXN1W11ake1cQDZGzij3W6knY3VKSeGc8	2218	3152	3152	1616506560000
4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	1553	776	38	1	4167	jwwFRDACALwyGmv2P6pnK6Naz5mExP9R2fALzCPpqUWnFEy3Egp	2221	3155	3155	1616507100000
4290	3NKf4MMtA1LAsFjtd8THhKgsBtmvTJtiahP1UrXDpxErG4j4Kknt	4289	3NLCEPpguFhzCq7JpeeWu2CvYCZeAwYCtouH5odEuPaw9JCfV2s4	1403	782	38	1	4173	jwx3Hv7AHf2tnRp5vJRXd3LSxeZZnGNDAqgnK7YHHpK2GYNedp4	2224	3160	3160	1616508000000
4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	4292	3NL7zht2j4dn9V2bCn1i8Q4FUXwXSQop6pBu3ZgUKs8EZrF4hSKJ	1579	1389	38	1	4176	jwvV3j4YtGn8WqRAgqSfteY4AqKfXogFhE7LMLfNN4ybUGzQ2Cd	2227	3163	3163	1616508540000
4295	3NKnQ1hbndMBCMtCJVkgkgCYcUWe1bAi2ec4V1FwbQqS88FzBPys	4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	576	989	38	1	4178	jwC2spnFPJc7yJLqYBHGYqQP7ry4vUAXpTFygCdFTzACTMLXHxA	2228	3164	3164	1616508720000
4300	3NL3Kg2DyQUwQ8TKmVqhf7wUJy81FPPTHC9bUAAZADQ7EpesjJWs	3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	1634	1331	30	1	4183	jwfZckeNTeqwdTD49LV1nixM6nKy3ufU9p8mbejwFngXEXm1Xjr	1948	3166	3166	1616509114222
4307	3NKiiyVhc1KTEWCJRQyZEyoBAjkmqjmkWS1yWtvAFBHyDaNvyuYM	4305	3NKor3E3cDFgbqPmnh5NNkd1uzzG4nqdbwCucPwWNXLikhyUw9bX	1654	1214	38	1	4189	jxX2uDY3f56trR3Re1YHW55YUqabbgP6PyULLSJFwaqoi42Vk89	2233	3169	3169	1616509620000
4312	3NLx7pZPXeSSyj7Pe9L3T5yhHuJyb9dkhUKVaZkVKhYMrSPTCU2t	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1672	1039	38	1	4193	jxwgs6XojgrgvT8FdSRwovTkfT2nXQRMwnKLmyyLxCC9raajtve	2236	3173	3173	1616510340000
4314	3NL1mMEpXB9P4LKrsmF94BcvnJiPRAmynfrxV33UypKJrvf15EWW	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1481	790	38	1	4195	jxcZjRb1X1zrm38qCWknkAxHteAQdqmcUTbubtyV7p7cN6a3itf	2236	3173	3173	1616510340000
4317	3NKveq2Kbxo6i7WYmotj51a5AKJfKuR2Q1HbanZ2GjrcecbMqKHW	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1607	1102	38	1	4198	jx2aT8cQjQsmG67DjU4PHB5ZwJ3i7Dh8Tm4a9m6gbSqvPULSZG3	2238	3177	3177	1616511060000
4319	3NLwpUbdSXZR3gsuGhx4fdA8aQxRZt5WejFKd789nE1WNbF8Yv1c	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1434	642	38	1	4200	jxovHWT9XKrvgWtp3vZnL11MLr8UnE7nB4PGiHeW7vUmBxQk13d	2239	3178	3178	1616511240000
4321	3NKXnT4FKFTgNRBu2d3SmQMwywynL1dkqjZ7Zv5psJzmMtUQAvSH	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1434	642	38	1	4202	jwZqrdFqp9EMXPXfH4YzvXR6hELBS1vPXQXoqUYbKRbsu3Ukoaz	2236	3178	3178	1616511240000
4324	3NLmBi1P5nhLpSXtKBPqc7WEEYjuhpCMmo1VB5XMoXZaS6Z5nUcz	4238	3NL8Eckegg94T1FgHuhHYjzipVdMp6vsoxwaBNw1kMaNw5w9DjgH	1581	778	33	1	4205	jwzrh1c9P6Qjzv9T69t26uqnUFeCH2Prfs6RFANrDHvbazugPqD	2061	3182	3182	1616511960000
4329	3NLy6Ra4zLy2CDaNTsN31Cr7VZ6DQ5Yns6FVTUzv2XrSX9JWTkfA	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1406	1393	38	1	4210	jwHyKdMsCkjaXEfhevD23yKNHxnC5R3EDUFhxVqYN6aH2srf8j6	2243	3184	3184	1616512320000
4331	3NKHEcq1QQ1eS28FpWxnbWKnryYF7kmNwTasQNVCCFuvT8hFt92q	4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	1474	1083	38	1	4212	jwJbAPZEds8HGE87jQ8jXU1SVB2TCKTfat3QDsint8vgmDDMrdM	2244	3185	3185	1616512500000
4333	3NLQxaKk6jLzVAaAcTt6udon9WQ4ckBQ5NB74pUsiCbyCPMuxq1V	4332	3NKB9mpAD5gzV8hZM77nRVWjV1Chh5bYCSvWAPdtF39eK26gDwu1	1444	1135	38	1	4214	jwgq8fcaFdkfnWLq5JFvkmzdsPKxU4vssLB5UeCZ8sX5K1keov9	2245	3186	3186	1616512680000
4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	1419	814	39	1	4220	jwkBh1beA8XRY3uXfe5AqmNDsQoP2djCXz8Mzj3GYMbVJgcGSaP	2249	3192	3192	1616513760000
4342	3NLcqYPYTYNx1ufUNpCrXCUYCzALTGpdnprjgegsFdwBUJV6xMJr	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1422	1091	39	1	4223	jwKVZubVGsDpQjycFLkeHc6owMHmwPZGY9yxqDru5BrCuDfuf37	2250	3193	3193	1616513940000
4343	3NKtFv6QvKvZKxHK36MLn2Jjfz9RjV8jw4zspkkvgwzT9xeakwxt	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	1403	824	39	1	4224	jwzxL8wHqcUerWpRMrzvYig7UfuXPwueF4jA8teZu4pbLtnx3wR	2251	3194	3194	1616514120000
4345	3NL3dqirQVCn8T8N5yWA8TywxpXgs26XSckmrQxHWKxNcHK796ND	4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	641	1090	35	1	4226	jxpRkV7Vh7Htkf6wuVHRDxacA8RuPLur9ZMxUHuH9M1cWUULidk	2113	3194	3194	1616514120000
4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	1522	1196	37	1	4130	jxrVMM2YLSsqXY8CCMx9o2e5JsExQ39BKxdcbarmvUrEVCr9CUN	2203	3129	3129	1616502420000
4247	3NLvh3GzmKaheqzuhHcaV116UDv2U1gngtJdkY2r6r1oy8krsiPx	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1646	1108	37	1	4133	jwaBEAfQFQCtLCrkPSQBxFaAj1sc3Bsuah8AaXfcQGggdim8NDF	2204	3132	3132	1616502960000
4252	3NKE1Q8CdePa5ZPVqNrEPDLeyG8DaMDDQD6kTTHPwV2e9zSrPU2L	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	1407	1395	37	1	4138	jxGQPZXBQA2Uw3kzo9gVWU6ET7CdbKhYau4jKsAWjwPRSgvXtxy	2207	3137	3137	1616503860000
4254	3NLZUTQzXxscEABQSRdwrJb3ohdFEKgX1T8VSKpsoBeZQ6bRggj9	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	1643	1299	37	1	4140	jwipAE5EQxTBvZdrFiSYALTNkuCBGhthY94xeaQR93PHZ7UzkUs	2207	3137	3137	1616503860000
4268	3NKAVUqkszFQa75zt5BPM5Kdyq79kw1tPnpLnoHg1wBKSD3hR2dc	4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	1671	1365	38	1	4153	jwNPKnvcFJseHgnNvcsm9u2kLgf4ijFH54mQeMhkW2Tcjs2ABUH	2213	3145	3145	1616505300000
4273	3NLw4GQdpWVkhBcKfFGLB2LF7hU8phMut2jWQ92FWUJtMRwPLt8J	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	1407	1395	38	1	4158	jwkrZa6QUKC754wXWNatc7uFCvkDYBXtHZ44g3UFRYogxEn3LAB	2217	3150	3150	1616506200000
4275	3NK3jPVMFjfNdcEaMPtSVrpDBbhjB4dsFnq25MQpjSAmmrzD9nue	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	470	1309	38	1	4160	jy1teVFqp7B1fZzA5PNFwKS3nwUTH4cZCBw2owSJTVbLqLCuw2C	2217	3150	3150	1616506200000
4280	3NKcQKJDnue7CsQddWyS4e1KedyTzk8nTcvtRUrd68Uy5N8zgeMs	4278	3NKMRLztKJnBHBjZTbts73SiKavn9kmwNp6JycuytZjedvPfHiY4	1573	1072	38	1	4164	jxTKACTVQcN91f7wC8QJHdGoEKquTn4Po56W9Bd3f7n8j5q5Zb3	2219	3153	3153	1616506740000
4292	3NL7zht2j4dn9V2bCn1i8Q4FUXwXSQop6pBu3ZgUKs8EZrF4hSKJ	4291	3NKqpZQzVRPGyTpyieDi8vad722DD2X8xB3bNhf5U8jeMfDH9Jdj	1406	1393	38	1	4175	jxtcPK87iZBEY9595fZMLzK4sRBJsqPR2FexKpkT5Uj4XLw8zky	2226	3162	3162	1616508360000
4297	3NKagEtLPyzDApZMz8AZDrinKXPCzQVbTFv7d8bQHjm7gB9dFPse	4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	1447	1219	38	1	4180	jwxeWWpd558FDzZKE8Yoai3ohbAa3nUHVAZYhiccMhBYPDo9R2W	2229	3165	3165	1616508900000
4302	3NKLtK9nqVHwMeAUQ8YxYhwPn5DSxDsEKk5nwTeFRX7x2MnCiQf5	3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	1634	1331	31	1	4185	jx9UkuoKyZ5tx1hDw9nPtsNb6rqk7o2pqoxPo3h4y4PySQVHskk	1984	3166	3166	1616509182326
4304	3NLJ1Up8MvzGK1Uzbp3FDobWroqD8UxEyECWTvwMJqDTk5WRe9Nw	4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	1651	462	38	1	4186	jwymcYQa91atmGeqszX1uCzR2dEW2zr1ueJfdPRsNLVaWkCkBXX	2231	3167	3167	1616509260000
4309	3NK84F6NWomMvNtniGboihSGLzkxgGFHrKM5wAcGT3VeFU3HAE9E	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1407	1395	38	1	4191	jxASegQAkAfnbXnV64JcZioEuyhtH6o2GWr9yzHa11pzECdqYKq	2235	3171	3171	1616509980000
4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	4322	3NK6AfdGtroZ72fL5eohywSbSF6mS6M4bpJrLswdb43xtCExd7dU	1483	453	38	1	4204	jwHVN7wD1TdDEtFGg9AxpFrUfR7h6UF7jSTqp3JVGsXjjrj9CCx	2240	3180	3180	1616511600000
4326	3NLpqSKJ24tBXCiwhCFEpV9cfWZJhDbJFhGEJ9zPThP4eJtexznM	4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	1458	1323	38	1	4207	jxkfb18gfZ1vXEjiprormsUWe5DNDbBXJAdrtzCk6aSeth49yCa	2242	3183	3183	1616512140000
4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1407	1395	38	1	4209	jwMa8op4XFnB8goNWkpr1JT55KXNtEwXrbQxmZSUU2XjkmPEhBd	2243	3184	3184	1616512320000
4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	1403	824	38	1	4217	jx9jDTCyogscfyBFbjD38ZEdoCkdmzKuWf6m5KueeFmGKHEv7ZR	2248	3191	3191	1616513580000
4338	3NKzA38yhHpZqVo5WSEmHqUcoQ8i9qWeZWEHjPWF3nQn2wcYYT5P	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	1654	1340	39	1	4219	jwrVyZd2idV9a9kKv9G6LjyEj8YA423GcoU9H8ZTC8D44kaiMLT	2249	3192	3192	1616513760000
4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1407	1395	39	1	4222	jxNoKyZ6xf7sKs8HYJVXs6n12atP5ip9XM8BRJiN63g24zgH74r	2250	3193	3193	1616513940000
4350	3NLPVVycL2FmcYBkZTr1A2YQ2TftpNWeXKS85M8ybZYMP35iAhEv	4324	3NLmBi1P5nhLpSXtKBPqc7WEEYjuhpCMmo1VB5XMoXZaS6Z5nUcz	1581	778	33	1	4231	jxt3P3esCwCCELvugyiWHLjRsgHe7CZLSG2oLW5Ah5vk27V9V6e	2062	3200	3200	1616515200000
4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	1406	1393	39	1	4239	jxU3hALAKMDQi7bas95Xa5T88o61c5Vp6p3dA59tqbhC8gDgNpL	2259	3207	3207	1616516460000
4360	3NKWCT3xeq1TNuwY8T28SCrYjXczz4XfHM5NfTorsrXEtJPnjpRZ	4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	152	1084	39	1	4241	jwRGECMEJiojEC6JDVn83bE5L8LG3Mn7mtayZJRhF5sTcDYP1XU	2260	3208	3208	1616516640000
4363	3NL4mtjpNBfxSqy87wjrz52W71TAvp2aSJpjUTnBkFVu26aiE1VL	4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	1536	947	39	1	4244	jxcza4NvnFghcTT4MtAXvSiEggUMgH1osE2aG7CD9JCSwnp6FU4	2263	3212	3212	1616517360000
4368	3NLLY3zacfFPGQiEQpYvCbQvdrP4Ls45tjs7Y9J9f929ivwJNBme	4366	3NLRCM9Y2yG3CJRs4TBLfTVEZmtL5ok6SKCq21FNgbAjsf4VCgXr	1426	1364	39	1	4249	jxNeD7yjamjCUe2K6wKWqLktmhPztdzVZapHyg44KNbypd3KZka	2265	3216	3216	1616518080000
4375	3NLrW6nCXX3PtvYQzjCoYCpFo2A3grBtrUgjs8BM91fM2jm33DyL	4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	1407	1395	39	1	4256	jxsYJDY99sTWxwVLRSBWorFLuUz3SxQYxM3fCxQ9weg2DaXUZYe	2269	3220	3220	1616518800000
4377	3NKx9sptAgHrTP2cgwrJqrBQPfqK2wkU5be5MAwfShxMdGdtkCXL	4372	3NKLCrWY44nqcaR293bDGpPkGa4PKEZW1pfL4BjNLkg96ZB93bSA	152	1084	39	1	4258	jy2MsTthwzR8QucPMkw2y3KxoJfpfyDvB3nX9aWmpdfpGU5fct5	2269	3220	3220	1616518800000
4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	4379	3NL1gv3ENXmsx1Ln66oFPANavA4jHzyKJE81aMuLiDm2F14F8z5f	1419	814	39	1	4261	jxfAJqrztUJbQ7A5m5Z3R2LFCGta1TpkLzKb31L3gZezx2m8WoU	2272	3223	3223	1616519340000
4382	3NLWfqDKXfK6iK8smP6LF556kgPunsdS51prqrwwCBi62Khwz3wt	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1489	1380	39	1	4263	jw75BbJTRr3KttJYN5R3HkvoiwY597wBsMpFMTANmPQ488XJEjw	2273	3224	3224	1616519520000
4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1555	1347	39	1	4265	jxHa1EqGjbzgRZx58UZVuh3fnqNPKySEsVvcJqpfUN4HYMK895m	2273	3224	3224	1616519520000
4389	3NL8e72MDCfERLhLknKWbZRfJx9vHafv8XAmj6YLaNciZwKMS4So	4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	1407	1395	39	1	4270	jwhqzQpueKHxEqy4Bb5wvBQtwsprQVvGTMCsEmsgVp5z9ecdS63	2276	3227	3227	1616520060000
4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	4390	3NKfJ6groJJP6CbQZ3HvLX8N9Jz5qZ52yaYNK9pP9dgDpB4EC8cZ	576	1355	39	1	4272	jxsNxZxo3BYPcXede7UbQBjtWa7pgV7VyHokmtGLTCp3mVydocX	2277	3228	3228	1616520240000
4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	632	1256	40	1	4277	jxYJmr8piQxv3ZoP9Sw6gGysT91G5UKoMAD38WqiBJPxxhwN4wR	2280	3231	3231	1616520780000
4320	3NK4B7aTK7iCke9VYY26X5UxEAzxcLLSqtX1XDgfxBRJerC2WJb5	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1406	1393	38	1	4201	jwsxJefP3Lm9avKL5WY3TCXsVceeobpvQvdg8gUMGC6X2CqMKiu	2239	3178	3178	1616511240000
4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	1600	1372	38	1	4206	jwi54TQxyQ3xqL13Zxy9nGAXDMyfjfSpga9mCJJL54MHv1S1Ynk	2241	3182	3182	1616511960000
4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	1560	1165	38	1	4216	jxbW8We1W1QQNAb4mS3VBSrWCUwetdo1cG1aCViGi6AZgsR4nNa	2247	3189	3189	1616513220000
4340	3NKfBZJUiDZhbfyT2XVXcHuzv8Uhvbu1E2CTtNzoyLhfkxFdB8pG	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1500	1297	39	1	4221	jxHBpFZK7eYK2JFNBanD6Knf6TML2eq9sXtctmeJCXDJx6PrXDc	2250	3193	3193	1616513940000
4344	3NLrjsjgqnxggSjx5u5JEq49iAVwzkgqj5G3wLvcUabL4H1w4zy8	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	1522	1076	39	1	4225	jwjyuCz3spCJJB7qm9cUKQKJk3cwbBe2A3bruGRjc16nwV5WF7u	2251	3194	3194	1616514120000
4347	3NK8q2Z42ccxzmS6BphuwxaMUbrS88t6XEW53fqKzTXCmFBZoYCa	4306	3NKAwu5nYQAFBwMBSbZkHW23Mj1xAUSnqGv9RHU575DbBHe1qe2F	171	1374	32	1	4228	jxTue3CB1qnadA7S1BJtVdDFp5ab3u5d7sfsuifb52h336ifAvM	1997	3196	3196	1616514480000
4353	3NKa2hvyjDPgVxSCf1QX9MZuDNbacx3kEKfbYbrmZ6wcW7civUZS	4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	1406	1393	39	1	4234	jxeRmkHR2KEoaVdZXUW6d1JgxmuroGRfj2pjgvHy3sQYth78aY7	2255	3203	3203	1616515740000
4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	4354	3NKrtba5NgQjZh4DBMv34QRdCTNWdqXgUtMpXcBapEfdoMYf9FPS	298	1308	39	1	4236	jy1htSuGZXe9EW8fYSBvB353zGj3AvsPxbuJbjJ4z2RBKvy6T5S	2257	3205	3205	1616516100000
4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	4361	3NKyMbeQfoqtvLnFiHNsWq3AHMBTDub8ia2oyQ1PjgvBJGjWkKht	1406	1393	39	1	4243	jxd6jmTgZ9kQiURpdRXyYix9EQ3NgtpPgAskGw4dS8Zugh2xB4o	2262	3210	3210	1616517000000
4365	3NLkj42fYHjegaYyJf3ZmgwDv3pVS8yCP2TXvUTNbcTw4NWUVqG4	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1444	1015	39	1	4246	jy19fU8J51vvNtm3igtiqeiYu6itTzdAHwa4ATRJYUsFoUfz8Kh	2264	3213	3213	1616517540000
4367	3NLtEtC6jLog6RaPTqRzyz1Qrv7Qg666VZPxABtzkzW3vbw7FBJo	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1631	794	39	1	4248	jxvFQA3hRZ9bcGXGxB5VUhAVGyknEN8uiMSxQC6x11neJoMkzab	2264	3213	3213	1616517540000
4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	1542	1304	39	1	4251	jwLGRbCKHpVaUDyUyg67DCbt89BBNCHLzGwiXY1PVQbYUrfYpfL	2267	3218	3218	1616518440000
4373	3NKmS368586rYejXykGgFF44ehPeWK9yy3M3N9Hq8rmq16LLxrQt	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1553	776	34	1	4254	jwXmVZx5toPk6Rude3zYwiE3g9E4hoLM215wkyHQDMirWm1UjAM	2109	3219	3219	1616518620000
4379	3NL1gv3ENXmsx1Ln66oFPANavA4jHzyKJE81aMuLiDm2F14F8z5f	4378	3NK6M3C3j8FCaBAQYoLSiH8wrqVAqKjh83vQg3ovJmDAekqkSuVJ	1646	988	39	1	4260	jwURPSQEio3L9VWXHTDTEjhLcLYauhzkbQeKe92ByE4hZSawvUf	2271	3222	3222	1616519160000
4386	3NLrpersADGioxhSAxq9GbCgMdcY1eTQk4ctV5D7kTEiP8miRkQQ	4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	1559	1107	39	1	4267	jxvCgS4H2qVWQhTfn8sxeZVsrdryxTGuqbSMn8R1JeUXUR3do73	2274	3225	3225	1616519700000
4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	1553	776	39	1	4274	jxvC92fgXMQ27YKPxxfHa53AdtRAGM6MaTWwKwKAAfMDYF8XFYT	2278	3229	3229	1616520420000
4400	3NK9P16sNss5BtPD8XWn595Ucu1UMkYgAbf7Jq8p5c6iQrqDRjtz	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1471	1386	40	1	4279	jy33GsBewVjYF7YpPqG9Y4RYDbKQA56CMMdpQRK6t1RS1cEaiqx	2281	3232	3232	1616520960000
4404	3NKzAwMzBSpAamA6cDFPYZgRzDQAsTDqC6jRWXxmZXk4MqbWPjcy	4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	58	1035	40	1	4282	jwYYk8ySpkyaPNDp7UfGi35NzgNr7iVLz8hH6wvMQHWfEDiXSCd	2282	3233	3233	1616521140000
4406	3NLjZDPDG6u33DN71sXTZjVzWK626vuCTF68EYgGSjDwHAzc4N9Z	4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	369	1066	40	1	4284	jwf7dDPcFboprBdfoHmYFjMRS1FWLGHQb8e6LuDHfowm97NuLcj	2283	3234	3234	1616521320000
4411	3NKEAXfNzzBaaAx5DqLrgFdLrkLj4Y11d2aKnCRCdHEAzoSF3v4a	4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	1406	1393	40	1	4289	jwgqTCUv7Ch1WpQjuiNi2oQRZrzKNhueShP4cXHRoWuGfUM3rvW	2287	3238	3238	1616522040000
4415	3NKEfKeStvD6kiixXNpRqVTGmAhLipGncEZsdvAtzZAf3Z4deYDH	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1646	1354	40	1	4293	jwh1F9qQvrjSjo4sgzhsEpMC66m9JT4Ze8oMEzneXdqkavAnAcd	2289	3243	3243	1616522940000
4417	3NK7z3FJsSNhcPiRGxUfYR8ZgA8ZaUXSbxVyvZv1o3tQJY87vVCR	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1407	1395	41	1	4294	jwLRwWKzWhh2MdjT8gKSUm9qtqHLP9JYzLWfnUAky13XXWifQnn	2290	3245	3245	1616523300000
4424	3NKZSsxaSB6JMpet5KpaEEBMsQagjxQKVpwqntKf1mKL24UGT9E8	4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	1652	1315	38	1	4300	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2241	3250	3250	1616524200000
4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	1506	1007	41	1	4305	jw9uR8titVMzoNCpRiZ5MGy6y88ZtF4pNeM3j6sjpC74c64aXgj	2297	3253	3253	1616524740000
4431	3NKUD75LZXb1G57PoALXtF3rm81ZGxE4NByJ1V1e7hxwWjnNy7MK	4404	3NKzAwMzBSpAamA6cDFPYZgRzDQAsTDqC6jRWXxmZXk4MqbWPjcy	576	1355	40	1	4307	jx4kX6oKVh9QmaPNT8Do2xsyzmbj7GrCxy7mqohyAGd9eixZNeG	2283	3253	3253	1616524740000
4434	3NKjC9reE6V39YpA7ThhHCZN2bmxAEDaHsXJXunae72dXbQz17jj	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1634	1205	41	1	4310	jwBCJg38piS9VyY8U6BPGaUWHUnKXbw3wcA9E1fph4TettqpZqZ	2299	3257	3257	1616525460000
4436	3NKHQPYzzSNGSMhBprubaGzayCy1i3CSr5zHVUXBXiHvsjckk7wJ	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1631	794	41	1	4312	jwzgNnyZ3wc1tT8KNDuXYUGACVEC1yDrLF8rAS78ghvrW3x63CB	2299	3257	3257	1616525460000
4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	633	1018	41	1	4317	jwGPjQaKFXAu7DFph1awiWNn58E6XPLS27L7DNBjLmjTKQ221Zv	2302	3261	3261	1616526180000
4452	3NKSsv2dmPrzJwGfFhCrkGmE7V1GgR6oPgf5ULm1xfDPN1cs9ya8	4451	3NLrRDxVZT3whja58Fk8vYUpc3ZzTLXz5J5uUfQ9AtaPvYzsrPru	1407	1395	41	1	4328	jxjXMfKz2FXfwTikvxTbvZsvUvJXzyaqB1YCvoYa3KS4TFPrPGY	2306	3265	3265	1616526900000
4456	3NLjEhZ3PhwkN3v2LPJCgiGjTFNz3YEf9vjjAKiRuTWtXpNCFCdx	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1406	1393	41	1	4332	jxa2RqVg63YB6SKornuX2PHbaGpgG7GdUqqNy1iLPimrnCz1gSP	2309	3268	3268	1616527440000
4458	3NK9zDyTF4K5o7xCGLbkK4eHJpNBjsmFDw151G82vVRmmcNAebis	4457	3NKWW956ykqsMa4nkASPWXd8z3gRprJd3n5BXGqPZeXPphUQuc6B	1649	571	41	1	4334	jwf8kYQowYt3NadqfcVuq3BnRZ2Z1vcXkMHmritGZW6pAEeTCYi	2310	3270	3270	1616527800000
4461	3NLHVvdAEjTzDkrm7GJhTPXHoE3ZiCBvNQzq73EXkmcQU7aoavmF	4213	3NKT6Q9o5QoMLimpwHpFeiwTTZS5oSfd5LbBWUm8EnqeDTyByHPL	1627	1385	37	1	4337	jxFkfTYi6SD8KYhfY7dEDTQNAUyTRQVvAmNSaEBaspNicnfm13e	2193	3272	3272	1616528160000
4332	3NKB9mpAD5gzV8hZM77nRVWjV1Chh5bYCSvWAPdtF39eK26gDwu1	4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	43	1064	38	1	4213	jwcAwZwdXNxrSM2AV7z1CDebmNEtnTkuzW6GWwRpEQ7HLSjgWsa	2244	3185	3185	1616512500000
4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	4333	3NLQxaKk6jLzVAaAcTt6udon9WQ4ckBQ5NB74pUsiCbyCPMuxq1V	1633	1390	38	1	4215	jxrzt74rc8iy89hBdHV29tPu17y5w7BbsbJsUQSzsD9jn4pjRRu	2246	3188	3188	1616513040000
4337	3NLDa2rbDEfApZgfWustoGzeBdt8zucRHJaaEefBx5YfbbHeB5D9	4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	1559	1353	38	1	4218	jxV3tzdsR8f5MD1xsbF13NLA7uffzAn9zv62hXWfDMSP3L2nXTA	2248	3191	3191	1616513580000
4346	3NKi2ypDcVtEnENQvDNhShSWBTVTW9VLQNd6MHN2kV23cNHxj5gZ	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	641	1090	39	1	4227	jxvohXhxWRgxJuLxFi1zCpYc9PoabkwqQoUQGotetKXyX6h6rC4	2251	3194	3194	1616514120000
4349	3NLKmCNnnyqJbWCdBrmnRXQPDSWg7zbCgjFSf6tHiqEw4iTKSgXd	4348	3NL197huVBXmjQgc4taMBfbvwrKYWSbEL2D3XqbRxzDvvhtteiqp	606	1295	39	1	4230	jx66SpiZedqqKRm7JYz76EDnBHLjGPsxZtiFpB41Rwf8sJvXXBK	2253	3198	3198	1616514840000
4352	3NLSemdnXUN1yMib8yW1qRT8k6yD76NXDX4vkAtUhj8r9jSQoGsL	4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	1668	1124	39	1	4233	jwUNF6XGioAk2VrWMd2kSNRqCCbYrjZP5Kc6KnoqKYVJ9ADoGB7	2255	3203	3203	1616515740000
4354	3NKrtba5NgQjZh4DBMv34QRdCTNWdqXgUtMpXcBapEfdoMYf9FPS	4352	3NLSemdnXUN1yMib8yW1qRT8k6yD76NXDX4vkAtUhj8r9jSQoGsL	576	1355	39	1	4235	jxHRbVi4SRKhsaoAduiLY4FfpjXuRRCVrXY29FWGsFan1KWb2W2	2256	3204	3204	1616515920000
4357	3NLA46sPp1TJm7WoYKDhuoANaqu35BhifDtCbnjdJy31XnDKGHLr	4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	1564	1092	39	1	4238	jxtt9UM95jsfmaAv7tsJpQieiHXYXh8cfshfG5xB5HMzE52pWtC	2258	3206	3206	1616516280000
4359	3NKoiRCLFRtoUFFQdaJrSt4hH3u28UcDN3ixSPY7NEUZ9puUynzW	4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	1654	974	39	1	4240	jwaxL2gtVWdifHPTTe1Q2jaKqhEZQPbSosUqF8eEYHPmUq52yzc	2259	3207	3207	1616516460000
4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	1560	1045	39	1	4245	jw81k7NqJs77PCQdsAGP9R2KsPKKNDSfvWxxnJsHL9EBrXUEiG9	2263	3212	3212	1616517360000
4372	3NKLCrWY44nqcaR293bDGpPkGa4PKEZW1pfL4BjNLkg96ZB93bSA	4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	1407	1395	39	1	4253	jwWs3NRspMGKynccwthGcnarbrVwgwQFkH49DoyAGVEBM2LSaHM	2268	3219	3219	1616518620000
4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	606	1295	39	1	4255	jwwmWSaBsyrtqesRR3XC65U36PArksnTdaTDbMZBByxNqDdacR7	2268	3219	3219	1616518620000
4376	3NKXC1QsFdQtKDzmCN9EXoZ6nx13YdzkNSFKVecTRorFGYtm45qw	4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	152	1084	39	1	4257	jx9m7Y38hzJpf3QERKxAB8zN4RCkf653BygA7p5xxpTRSssBxoE	2269	3220	3220	1616518800000
4381	3NLJtzLhNVy3gumTL2d6DzfPNqdQ1MeA5Nt9sWv9P7YK1e3zWsnJ	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1406	1393	39	1	4262	jxiSF1N5ugLmPZ5qAEgz2U4maauxUHpT2sGojjMobzbbuH7oKgc	2273	3224	3224	1616519520000
4383	3NKQaXNtrzBRtYebpCumU3XuJQ1LECPuVUSJVw2trDg3oK3bPhBy	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1577	1327	39	1	4264	jwJwTGvYmZhQVHBvzNA9p6kY1fYukaMJuCcVxG2yoR8TvKbD18Y	2273	3224	3224	1616519520000
4388	3NLW9YR7i4tUqXNdtC1x1utxGs4y77UFjWAo95in2RPsG4mM3gqh	4287	3NKr6UCWjSe7LD6GNf6ZwzjUvXosDQq5QbjkYq9bi9apdUaPueea	1476	1371	38	1	4269	jxDbob5pyG7BX5v2N7ooiY12ouDZ6ruxvDZXMJQ5DpUqAMxSfMd	2223	3226	3226	1616519880000
4390	3NKfJ6groJJP6CbQZ3HvLX8N9Jz5qZ52yaYNK9pP9dgDpB4EC8cZ	4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	1402	850	39	1	4271	jxHhAYqmD8DRTczhBMWx5qp1nXSp2NEeFmSkrNmPif2cue8YBss	2276	3227	3227	1616520060000
4392	3NLLH4DtBFHBWdEQE3GPwV8n38QdNb4hEZB3Q8U3rhhC4TedsTL7	4385	3NKWeqQcRJsA5TDgMnW7YiZbJzmPkGaTZ19UWRbseSphvDT7Mamf	576	1355	39	1	4273	jwmwFdyfQPyfzWsuCDqhdC3Zy4iRUAa69TL5qSxHKXQWv4hBDzM	2275	3228	3228	1616520240000
4395	3NK3m3dvytiUvf53ECVPsDt5Zo3bUpcwZHfCjdK1NTsv5trGvc2s	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1579	1389	39	1	4276	jwyX9Z543vaL5T6ZUR1i6r6svLXV5RmuGCUVwdgVrCCvw59HLSz	2279	3230	3230	1616520600000
4397	3NKoszHyUoSEZzRVAD3NyZuyhda5X5xRJaLtW9exWb76VdHvsuRD	4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	632	1256	39	1	4277	jxwL9z6q1kKgCKzA2ukVdZBmCvNso8Ez4WXapvGLsTgV7Cbj9TQ	2280	3231	3231	1616520780000
4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1407	1395	40	1	4278	jx7LNrzqWZD7ts48kjNCsp5CEsqnJ9989Az5QUb1eQDi9mgdL1D	2281	3232	3232	1616520960000
4408	3NK5G51T8CfX89Pja6NbJ1mJxmnbjb9hYtjfWTEY7DQvhbbuq5if	4406	3NLjZDPDG6u33DN71sXTZjVzWK626vuCTF68EYgGSjDwHAzc4N9Z	1407	1395	40	1	4286	jwMxST5oqPV4juSnNbcMHZnoczTeH4PKU7oSKdLzzF6UwXxLX7X	2284	3235	3235	1616521500000
4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	4412	3NLK3Sx6r783qErHVxALeqHv93kZHf1LvQVvxP9hr6T3PKUjrEXn	1516	1294	40	1	4291	jwgstuibQSotaL4nE5DiTrBp7vsk9itKe7V2eqWrfFvgucqyayU	2288	3239	3239	1616522220000
4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1581	778	40	1	4292	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE	2289	3243	3243	1616522940000
4416	3NLPcVMk7foVT8xwne7QSu1S7b2t35aABWbYyp2zFmAdq9TjHT6g	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1646	1354	40	1	4293	jwh1F9qQvrjSjo4sgzhsEpMC66m9JT4Ze8oMEzneXdqkavAnAcd	2289	3243	3243	1616522940000
4421	3NL4D9tNhX9iBvicf8mouZE97pNStLPnBXTw1U9pwVBT7R2ZpivY	4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	1407	1395	41	1	4297	jxjmHxxigSETMb2rJyCLBPjnQwuSwutSK8rEYgDE9A4GzxaHkU7	2292	3248	3248	1616523840000
4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	4425	3NKqpRbKKLFCKmySPX1srFrG7yWDvkwAPVkXXKk9CEaRw8qt62M6	1527	1293	41	1	4302	jwtZFo1hSyft7BMtPKG4F99G3AwdcCxAt3hzzYWAciNJPo25Vrm	2295	3251	3251	1616524380000
4443	3NKLNF1CzW6VpGvdS1qP3ckrMFsufd8EkhAKs4LrSgZrFBQg8LUa	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1649	1257	41	1	4319	jxrtR4rZAWHMTQGUSsX65oE9m2B5STbXHttZsbRTp3HjNp26xCH	2303	3262	3262	1616526360000
4445	3NLvAaDganveAuzx4ntTtPsN1nGWi8JdixzLgxtr1peqroJ4dWLo	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1407	1395	41	1	4321	jwq2jFVMk4RhiV2KE5msPmdsmtDTAAGQ2SfXRA7uDmoQTykvV5B	2304	3263	3263	1616526540000
4448	3NKxsX7RWQN8qrsa4tXKUcRkPtiA63x4YruqwaVHuLYJf4jLJLSj	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	633	1384	41	1	4324	jxZ91ZtsQWF3KnPqQuztJZ9BsruKYQafgBy1g6XZpcDGzdxqXwF	2304	3263	3263	1616526540000
4450	3NK7N5W1K1rxZ41xtCRhBB7qL4MN95Ce6RtnWNHWgtLVVkTA2iCs	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1601	1262	41	1	4326	jwhXgEmk8XPvXSuscgJden2saimiQwW8HRVfEJA11tt4r9xaM8A	2304	3263	3263	1616526540000
4451	3NLrRDxVZT3whja58Fk8vYUpc3ZzTLXz5J5uUfQ9AtaPvYzsrPru	4447	3NKS6XfoDd4Ra9j79EyAzfdVahTNi2MrbrKJnbHkK8DiQDPWe4Vg	1619	1029	41	1	4327	jwBAkscHGSPWm2tzWMX1aYriKoCEM7DMtVdggEiv2nXeT8KEuGx	2305	3264	3264	1616526720000
4348	3NL197huVBXmjQgc4taMBfbvwrKYWSbEL2D3XqbRxzDvvhtteiqp	4346	3NKi2ypDcVtEnENQvDNhShSWBTVTW9VLQNd6MHN2kV23cNHxj5gZ	1537	227	39	1	4229	jwQ4n3tX9NzbL63fH26BDi7gcDjM3jfpDDVyTSztDceWLF93LV7	2252	3197	3197	1616514660000
4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	4349	3NLKmCNnnyqJbWCdBrmnRXQPDSWg7zbCgjFSf6tHiqEw4iTKSgXd	311	1061	39	1	4232	jxYGCrZTUS187LkNijknXFEZGC2kGUYxVg3XYmsPYtCi2bj5zA2	2254	3202	3202	1616515560000
4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	1407	1395	39	1	4237	jxdoy8qeApDyK8yjxEMZfNxAnhtWoYfXoyB7a4TzRnRx9UhTK4h	2258	3206	3206	1616516280000
4361	3NKyMbeQfoqtvLnFiHNsWq3AHMBTDub8ia2oyQ1PjgvBJGjWkKht	4360	3NKWCT3xeq1TNuwY8T28SCrYjXczz4XfHM5NfTorsrXEtJPnjpRZ	1571	1335	39	1	4242	jwBj1gi4u534rqnG1kWXmf6dLJiwdscJCBpA8NBFtpcyrgDu6yC	2261	3209	3209	1616516820000
4366	3NLRCM9Y2yG3CJRs4TBLfTVEZmtL5ok6SKCq21FNgbAjsf4VCgXr	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1406	1393	39	1	4247	jwhnWHqpCctwWkuN4nRTbdENypJrfDfQYXfZWPbmszEBr9B9Vzp	2264	3213	3213	1616517540000
4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	4368	3NLLY3zacfFPGQiEQpYvCbQvdrP4Ls45tjs7Y9J9f929ivwJNBme	1509	1320	39	1	4250	jxBSC39CpZSJ9ps8web4X9W61j6KH5kctX23T2FWir7ugYxUF49	2266	3217	3217	1616518260000
4371	3NL9iRaCY9w1jUVN3jUMFyHFeP48PvxQvUyezARAx6XjV6vwFJeu	4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	1617	1288	39	1	4252	jxn28x2R5u7CeHzxMfHGPfzmUgUNLD323Z6c5rXjKMkUqKnVKPZ	2267	3218	3218	1616518440000
4378	3NK6M3C3j8FCaBAQYoLSiH8wrqVAqKjh83vQg3ovJmDAekqkSuVJ	4377	3NKx9sptAgHrTP2cgwrJqrBQPfqK2wkU5be5MAwfShxMdGdtkCXL	1534	67	39	1	4259	jwEGvQzAq3d2Q88cTLRcP7UiFcw67wu8W9APvwC7bSJbw2cn1d3	2270	3221	3221	1616518980000
4385	3NKWeqQcRJsA5TDgMnW7YiZbJzmPkGaTZ19UWRbseSphvDT7Mamf	4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	80	1147	39	1	4266	jwAJYTFU9RPyU89XgwjYqh625p5RJ8KY1ZSHrrNzVggvvhhg3qy	2274	3225	3225	1616519700000
4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	4386	3NLrpersADGioxhSAxq9GbCgMdcY1eTQk4ctV5D7kTEiP8miRkQQ	1476	1371	39	1	4268	jxurG4Xxy9MXWpBqfNGxu4ByqRirZSyVWArwhUFhgon3ymeV5He	2275	3226	3226	1616519880000
4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1407	1395	39	1	4275	jxv6KP25YBjTRwbWLhuh1tGenLUhGcjX3NcifJZ81PZYqqNtMD8	2279	3230	3230	1616520600000
4396	3NKvMBgXKr5vCDpder1Hr3ymM4o2Ucs6nrZSPRsb2sTgzjUkm2bT	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1579	1389	39	1	4276	jxurc3kQ8jVTqd94xNakD2bfvtuAP2jU9fjBrHUfm6SKcFVt9Bi	2279	3230	3230	1616520600000
4401	3NKqo9t2rgU23aVxD4vsk9hRXv8qFSrz7hYEeQ5XcJid4t9pMtZd	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1406	1393	40	1	4280	jxCdV8uksoKepcqKBw4rYAW5Sa3b1oKzypGfoWgK3ggjGRcchqD	2281	3232	3232	1616520960000
4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	1672	1285	40	1	4281	jwnDyncDBmqHuLMnCYtJRvP3adQJgZqwBbkmPSAvv9qTgptVJ7w	2282	3233	3233	1616521140000
4405	3NLXgP8v6F4PJrZo46QyfbrBVkduEVkKJRf3Zbe1mvpKXNiEBRb3	4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	1407	1395	40	1	4283	jweAesqoXH3AA4FFnHRVLY6559jmBzxcWYtYG3qVhRygd1uonWV	2283	3234	3234	1616521320000
4407	3NLDf8AnYPZWfYySTuy7Tvk7QJpFJkWLPGgcnh3XQ9R7Fhhn55Qw	4264	3NKPiLcifYTLn1FyshTbEgVNRjEA5b6XnvmXaXSbj1EARpWCkBjH	369	1066	38	1	4285	jy3Ex71iptKW7ZdJkZx1MbeFGnEhyGoXsNyRefpuYTqdfM7EGAb	2212	3234	3234	1616521320000
4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	4409	3NLncyrqzUWBgeBbWqkuJnubSKRNMYG7TqirRt2vpxGEs1eaXzrp	1406	1393	40	1	4288	jwd7unLeSD9Ao3UcU2FVE3Dh4gCs81rJfxFPCyPkMuPM1pXtPfj	2286	3237	3237	1616521860000
4419	3NLf88TAE6rAR4DTQZhfW4VfKs1D3fmN3d3ifrwavmwpnDpPxgsV	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1560	1045	41	1	4295	jwdSuArUSbeqiWCxMoieUvFgu4JSdeCHV1koFAvEyAfxudG61Fh	2290	3245	3245	1616523300000
4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	4417	3NK7z3FJsSNhcPiRGxUfYR8ZgA8ZaUXSbxVyvZv1o3tQJY87vVCR	1553	776	41	1	4296	jwwGqhWAJMGGUBD2ysp1sRtymwec3wbt29XqyFH5zJgUZaZWwLd	2291	3246	3246	1616523480000
4423	3NKce7xZVWWVrPKMTENi4PR28sVPnYk6Zp5tKeYBk5G7WgD8fBYF	4421	3NL4D9tNhX9iBvicf8mouZE97pNStLPnBXTw1U9pwVBT7R2ZpivY	1483	225	41	1	4299	jxySJQiHhwhS1FZmkT754GSp7rWt8g77x2CjxwxAY9zK6Bs6vmg	2293	3249	3249	1616524020000
4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	1513	1133	41	1	4304	jwgkGfDnq1oGcsuScXMLJhVi1HhJLTvkmmzSRsfywgJjkyqX8Dq	2296	3252	3252	1616524560000
4430	3NKEU9VjjqryTQ16zhFUUqNqcSrhJ8my8RGcL3nbgu8rhTJDzbi8	4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	576	1355	41	1	4306	jxJhRLMbH8ijvQmykHSk5wS8qRXHgAoUUxa97bbEMKf9sVZfH1n	2297	3253	3253	1616524740000
4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	633	1384	41	1	4309	jxR6MhGwjLaXB5ALYvnoWNVwqLMcyYUhyMfYzcbSTQdcNPWyeuZ	2298	3255	3255	1616525100000
4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1455	1332	41	1	4311	jxnGRvXXKJr9YaxxSBMGQSuWLxPwdrZTS86Lj8YRNK5m1f4TdeL	2299	3257	3257	1616525460000
4438	3NKUdJGd6FqwajmqkdgtnAV2KejZYqmSh4XdANY8rF5aHFt65N2t	4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	1406	1393	41	1	4314	jx8txJyAbmjJb2znpjZRmwtqfWDWPEvfZKpVnV1YwiMXmRt7JFv	2300	3259	3259	1616525820000
4440	3NLiH1VqYwX5bjgqrY2cv2QS57aMyra1R4V3qmxQicMyK5RG6JLe	4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	1406	1393	41	1	4316	jwpjCgM2vhGCetpJzmBq5LYph6fDf55TWbgDiu1MdR7eW62haHm	2302	3261	3261	1616526180000
4442	3NL32wtcPn6UGK3Wz4ZRht7EsnHUSzLEN8eUF5uZqXh51KmtbR71	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1407	1395	41	1	4318	jxENSNeD6nZfCGqBMiWUGk9chTmroSW8CThEoFE5MpNpgYGaWar	2303	3262	3262	1616526360000
4447	3NKS6XfoDd4Ra9j79EyAzfdVahTNi2MrbrKJnbHkK8DiQDPWe4Vg	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1403	824	41	1	4323	jxKNwQEJRGV5HzhNfRPnXfYQybvKfsgSrrmWq9NCyXBQyavJBWx	2304	3263	3263	1616526540000
4453	3NKFyGzvU6pvqSyiJJRe4Eyy8LbdU1zZEcDDQRcobsxmV9KkBjo7	4452	3NKSsv2dmPrzJwGfFhCrkGmE7V1GgR6oPgf5ULm1xfDPN1cs9ya8	1405	867	41	1	4329	jxtihS5RTLp5A8Mgdc2yQzvnYs6JMA93iuXTDZePZXYeawGgujw	2307	3266	3266	1616527080000
4459	3NL4eWJ9BCfwqGiyLp1yFSauZcR9MbGWkd3FRc7UHNiVHaH4my8N	4458	3NK9zDyTF4K5o7xCGLbkK4eHJpNBjsmFDw151G82vVRmmcNAebis	1656	977	41	1	4335	jxdSfr2aPFeyWsv64tUPioCkFZrwE1hYcMj55vrBmQv6GBmPGSJ	2311	3271	3271	1616527980000
4464	3NLRthU8akqHH3jLhKGFFPfcjbmHQv5qbEj2FV5aK4K8NFAgRF7N	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1400	77	41	1	4340	jw7BgXwr3iB5M62kZiM4HpoC6QirWUAhNQ5sFgvfFHGiipcuEgr	2313	3273	3273	1616528340000
4471	3NL1gSf8W1BgUJnDedM8iemWFmjX3pKuYeDM8VLJkMjiCV4NqFnh	4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	1483	201	41	1	4346	jxW6jjvMgfBXuMiXrUcu8WdmhwNYuMaYgU3yyrRqjqZ33w5Q96Z	2317	3279	3279	1616529420000
4402	3NL7m5MgpeSfdzoXDrxUV7xxJCoZiEDEbSUAYyASae9hYrSznHRM	4397	3NKoszHyUoSEZzRVAD3NyZuyhda5X5xRJaLtW9exWb76VdHvsuRD	1471	1386	40	1	4279	jwk13rTmcx3VjWKPKrEzYmybqkHoNfcSkMXYNb6CHizsW97Jpka	2281	3232	3232	1616520960000
4409	3NLncyrqzUWBgeBbWqkuJnubSKRNMYG7TqirRt2vpxGEs1eaXzrp	4408	3NK5G51T8CfX89Pja6NbJ1mJxmnbjb9hYtjfWTEY7DQvhbbuq5if	1403	824	40	1	4287	jwzUQjESHn7FBHJeF4o1bbeQJMDudwjZTE1oknLob4RgVTJv41S	2285	3236	3236	1616521680000
4412	3NLK3Sx6r783qErHVxALeqHv93kZHf1LvQVvxP9hr6T3PKUjrEXn	4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	1631	794	40	1	4290	jwDDbNXMUchuc6YKehMLTk1rbQ8YgaXZFTmbqC7iX6F4g3eJxb6	2287	3238	3238	1616522040000
4418	3NL37MH48HzYDdPEKUQsatAELHXb96gj3ArE6c5EC9eT5te7vUbF	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1560	1045	40	1	4295	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE	2290	3245	3245	1616523300000
4422	3NLpWesYcZ8rAv94fMK9Gq5AiXYB65D3zTFxV2jESYfQxMazoZwV	4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	1617	1162	41	1	4298	jxnnbTqHJAa8m2R3QVDBcY6BauthYYj73YS9vqCtmNeHJYAtjnk	2292	3248	3248	1616523840000
4425	3NKqpRbKKLFCKmySPX1srFrG7yWDvkwAPVkXXKk9CEaRw8qt62M6	4423	3NKce7xZVWWVrPKMTENi4PR28sVPnYk6Zp5tKeYBk5G7WgD8fBYF	1652	1315	41	1	4301	jwjRGYGWNR6TQPPdxA6ws8QTU7VTQBqnWR98VhzKXpP4zDudxsV	2294	3250	3250	1616524200000
4427	3NLpJPKHS8rbqoGiuHstLAmffnUT4fXWkbAM8Aq8cK6UU4yn9NtR	4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	1406	1393	41	1	4303	jwY6GsZDRbUYngE3mFEfhfoEnnDWFKtjd4vf4ziXi1NBUCpVyKu	2296	3252	3252	1616524560000
4432	3NKgvpVZZN7zQPcjsHvn43LNxhSiPfBUoB2QgQ5wbxfguCApHFZg	4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	1609	1333	41	1	4308	jxSxRm6Vc7YcEAHqthEKS5JCAq1Znjycq8WdsubNoXEvMW5Gwzh	2298	3255	3255	1616525100000
4437	3NL2uoE1NXsi67SLK7rp74LphTgP97ui9xKmKpZp7xZrRMxmEKan	4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	1407	1395	41	1	4313	jw6uD5W8CmaD9wTMFpyiuysB6Bw9e8RxzQp595LCv69yjUUxXsV	2300	3259	3259	1616525820000
4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	4437	3NL2uoE1NXsi67SLK7rp74LphTgP97ui9xKmKpZp7xZrRMxmEKan	1522	1322	41	1	4315	jw8QzJb2BVPArRtVGoT8wDijesrMjrcwsHdUDkzBzGjCk3setS9	2301	3260	3260	1616526000000
4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1573	1072	41	1	4320	jx4zai8XRyz3ZhpoRRaKJXKx35AQJimwiY8jAfJ86HxcWkUEJBW	2303	3262	3262	1616526360000
4446	3NLXdVhcKCdRxd2iWqSgeuxhU3RR6YX6XZvfFA8Sebu1Mjgnnhdt	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	369	1066	41	1	4322	jwFb3uP2XXmAegWAasax5yUkW5Hsad9Crm7UjJKeHwnJadhXLTW	2304	3263	3263	1616526540000
4449	3NLr2qMKesf8CDGYJirbZ9R9vPkGhf5paZ7Xiugobh8z15gREkad	4407	3NLDf8AnYPZWfYySTuy7Tvk7QJpFJkWLPGgcnh3XQ9R7Fhhn55Qw	369	1066	38	1	4325	jw7puAsAB6SUkxFPukA6Lrwn2z6BKLZmS2EPc1kxRnUH6mAetXV	2213	3263	3263	1616526540000
4455	3NKXmSFLqkz93oTKN7fvu8cu5c5ah6MvdG3NVrRLmpQAUGDRW8mK	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1541	1172	41	1	4331	jxvbc4uqWdxqe4dy8SK9tnpvoL1ZRdhnHYjosnNjmStvkRiuwus	2309	3268	3268	1616527440000
4457	3NKWW956ykqsMa4nkASPWXd8z3gRprJd3n5BXGqPZeXPphUQuc6B	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1585	1366	41	1	4333	jxbTmS7ET4YJYWjrHdYWTU2smQjWLdJMWc11vADdwEqZEaxSdfc	2309	3268	3268	1616527440000
4462	3NKbGZ2fNckZQSRoXVFpFU1R4Lb4Mp4gYrndDDHLH8d9343tDYz6	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1522	1076	41	1	4338	jy1LneUytEdgg3RkBGqNuNoPxSEcbFFy5b4gas93skiHLMEP4Fo	2313	3273	3273	1616528340000
4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1481	790	41	1	4341	jwPqNN2SpoBXXjAGvkGcqGdVNSpF5oFYWAgxbV7C1WDLb8cX2MQ	2313	3273	3273	1616528340000
4466	3NK8RexP5VG7a2fPQ9LAmYWjBzJC57hUmjL2FYUJCxZjdfrwspwY	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1608	1163	41	1	4342	jx2XaJT2jfRbohofLVqAM2M71uHQWUcX6snfCk3qNfnJNSaoyo9	2314	3274	3274	1616528520000
4468	3NL84rCPjWQkKaETM8xnBG8H2TxTMaCc5oryRtSkwbWUtVasobxV	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1608	1163	41	1	4342	jxuaABjNhWDivV4mAyJ6SjPYYVQzxCXZCEaUskVZNJXdFZmUMLx	2314	3274	3274	1616528520000
4472	3NKwCRF3jVC4xJyofD8DEUDbZXLBpQby3tZjGuJCtYbL6jd2Kstm	4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	1599	1287	41	1	4347	jwhu471EYFmsFYMjDdPzhakS2NPG19isxyxXAs8P7AmZEdtbetw	2317	3279	3279	1616529420000
4475	3NLbrhJ7ed1sq4ypCvD9fNb3ExvFXjv5yZMtsWpsJpRtJiXdbVTv	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1600	1006	41	1	4350	jwxN7SwkUcY825UVT3iFz7ysMjhuo4CYxyjeVe9NKUjER288pey	2319	3285	3285	1616530500000
4477	3NKdHMquzpn3SKAL4bBsYbHF3MyYkR9SH8PraroW1GsaxgKe6H7D	4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	1403	786	41	1	4352	jwxXpacq29KNLcd1cv6ytW6bsJDoChdAXgKazbwuedy7rE1ckGG	2320	3286	3286	1616530680000
4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1474	963	41	1	4355	jwF6uWjxazEBNoz1RtPMeZ81rfWgUX5cyeVGoSP741yibweda2n	2321	3287	3287	1616530860000
4486	3NLgPKuAkwEgYcprvbN22No5kG5xsDzQfwYvbMmqpNcVosYGhpvP	4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	632	1256	42	1	4359	jx2rhJBmXZsqjq5NQ4D9uKqfjFZvEoGb9RUDTj2rJi96JNkEvj9	2324	3290	3290	1616531400000
4491	3NLb2SyZFKHayT7U9ReXuqzXk9hejpB5CeLnX32p7EiEMRL4ocT8	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1403	824	42	1	4364	jwoYXoPS4U2MjU92PtGfKSQeMei5nSAXzYwwCQVSuCYQhYBMyGP	2327	3293	3293	1616531940000
4500	3NLsRj7tuoYhLjzSgy258WciBedxwMgCg3X7h1gaXPqtLHpL9zkD	4498	3NKGhjzTjtMgyjTUM1vDuwx7kJhEVUZErdmN12LHU61JsgBABeMn	1406	1393	42	1	4373	jwfUxDCr3wFRhyiUkYbF5ai9iZfysgRJtux5s2zrubUjwpqA8qN	2329	3298	3298	1616532840000
4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1657	1344	42	1	4378	jwGA66CSADehM2fCxPwom2sfqrDSEN9X54uvBg897otnRqMKzNr	2332	3302	3302	1616533560000
4508	3NLVKhXroM8MUqEjTjyaciML9uF6nL5TY2FEiVcZhboeRnP3VVvu	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1458	1323	42	1	4381	jxuuQ485rPop9xrN7FmGVPzA9vjph11rLcoBGhS88MN8aECEzwV	2333	3303	3303	1616533740000
4510	3NLbTtcn6EJbRHum6MVCBqkHd1cYtkVoDgVR6ujXb2oU59tMePtD	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1613	1223	42	1	4383	jxcv43LK8kfvxn69s4HjukBuAc6nAte8gJqAuRU53cH2k9UoUkU	2333	3303	3303	1616533740000
4512	3NKkeybXneGuqmhHH9rJL5hbXym3YBh1ghivzL1UkGjXk6AA33N8	4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	58	1035	42	1	4385	jwrsaoP23NQ7hZmbLDaUSrbhHxjVnaTtkxEsiZ45cEBnUDUTJEn	2334	3305	3305	1616534100000
4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	4512	3NKkeybXneGuqmhHH9rJL5hbXym3YBh1ghivzL1UkGjXk6AA33N8	1670	1156	42	1	4387	jwToVWachZd9hWRuApMgPuAAGtqKbckRgHJU6JBgHsssCMy1dSJ	2335	3306	3306	1616534280000
4519	3NKqLrNQF64u4F98QU5WoY4QKibYVevGjYpkAEVmZPoqbt3Nu2Wh	4518	3NLpR41x2oUxUsrxEtSpv5Ti1MPH54CUcuAu4muGZXsxnbmJaUYJ	1481	790	42	1	4392	jwZT3oNH4CYxFDd8dL2xd9o1siw14dDDc7HXg3ydQpdb881d3cy	2337	3309	3309	1616534820000
4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	4453	3NKFyGzvU6pvqSyiJJRe4Eyy8LbdU1zZEcDDQRcobsxmV9KkBjo7	1593	1346	41	1	4330	jx4qXL1S28Q55fwd8TH5yiybAcFzSfpCtAxMmTMXjSPeQwjo5nY	2308	3267	3267	1616527260000
4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	4459	3NL4eWJ9BCfwqGiyLp1yFSauZcR9MbGWkd3FRc7UHNiVHaH4my8N	1440	1377	41	1	4336	jwFcCUSqfmnEJQVqMzAeAZEWmXWWG9txRVvPz1WGi7zVGodq7Qp	2312	3272	3272	1616528160000
4469	3NKzJ2bu8PS8zowbm8J3YBkivYkfhscaLcJqUqiw6bNGSEn4o9kj	4468	3NL84rCPjWQkKaETM8xnBG8H2TxTMaCc5oryRtSkwbWUtVasobxV	1407	1395	41	1	4344	jwSeZGUoFvWGdUdAZ4xdQeg4ExaikbpMY1VdZrZmM5xM5FAjR8q	2315	3276	3276	1616528880000
4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	4471	3NL1gSf8W1BgUJnDedM8iemWFmjX3pKuYeDM8VLJkMjiCV4NqFnh	1460	958	41	1	4348	jwfFCAo3RQWahmpTFYpmh9gJKuFQZUL6M8bhBc5DWz9WDrfiFDz	2318	3284	3284	1616530320000
4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	1590	934	41	1	4353	jwbQqPwJTEDyn5CQVDubrPRbUUkhJzkNRoH56YnoTY7kLGoToYM	2320	3286	3286	1616530680000
4482	3NLCpJ21wLYWppmCek8r4cJtcHtTuPrtZ7j79xKnCwr2PT2ayQzD	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1490	1148	41	1	4354	jwASBWuMLbFszAeFZ16ZftQLFdBqbYzZLVLFobSXCQgNwH3Z1DE	2321	3287	3287	1616530860000
4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	1588	1146	42	1	4357	jwsengXRfX3Tv3NCwtMVqkFAVuKu2Kv2Eatdriv34MmzWt9e5zA	2322	3288	3288	1616531040000
4487	3NLAS6FjefhkL1vCNCMhYeJTjmcfqovvxDWHirfWfFQp6QS4aEsn	4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	1647	1302	42	1	4360	jx6kcXWefyPq9QKKWLVURX9iJu5ctDs51XYnUX9kUYV7Xnh4yKb	2324	3290	3290	1616531400000
4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	596	1060	42	1	4362	jwdyw3r6DZVco37j6ThLiaHbPgi2EunGtLoYXyVituza5W9JPvB	2326	3292	3292	1616531760000
4492	3NKuhsBRCTfp6jy9YVHUkDEcjPRz4SLG4Nt2UNJdCeEYTF9zhwWL	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1406	1393	42	1	4365	jxPm1qEHJ1HfJEB84CoujBYPFKWgwE1gsnKv5p7uswGicE1KmEb	2327	3293	3293	1616531940000
4496	3NLRq6xz2ubX4QYsLb39VSXD3EyZGJ9AaSQsXVGMCXSpqoJCDbKr	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1460	1078	42	1	4369	jxBbTaLcyqFgNKPgwQ7HGD4U8Qs8X96cSyTtdhH2QNFYBYDfNeA	2328	3295	3295	1616532300000
4498	3NKGhjzTjtMgyjTUM1vDuwx7kJhEVUZErdmN12LHU61JsgBABeMn	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1675	1216	42	1	4371	jxzsTJj7aw4x36Vzouvv4dcstKQVkPD7qAjnbMahyx5iPqmbCAm	2328	3295	3295	1616532300000
4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	4500	3NLsRj7tuoYhLjzSgy258WciBedxwMgCg3X7h1gaXPqtLHpL9zkD	1637	816	42	1	4374	jwCm8fiSxdhB73r5F6QaZi8diUMFtZQDQHgbAQtvyqsBNLEJy4z	2330	3299	3299	1616533020000
4506	3NKuRPsaQgX9VLQou18FTxhZ7Qo6R1rEZuBSkH5v148j1ukQHCcm	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1631	794	42	1	4379	jwAy16jHUKejYGtyrrrd9VuEg8RPWxoAVoYkaKVnLgbbTEhfkS5	2332	3302	3302	1616533560000
4515	3NLFpM4fUHEWPErT5n85fZMgWVeopo4HhhboSQRDAVQbgVCLAu8X	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1406	1393	42	1	4388	jxZKZxegDh5Y7FQMCyrKQQzd8YK9nn3YSTAmiwgjDfwXR6axFS7	2336	3307	3307	1616534460000
4517	3NKwho2JqkW9T7BGXqNBM2fYUNv4rpi6q8gU8RLcFp5HqcPi8aXA	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1529	1316	42	1	4390	jwyE1L1fHu7kmaW42MNFP9AND9aZW159Ap1VD5M3Na1JQHzoukA	2336	3307	3307	1616534460000
4463	3NKAZB3pV2UPFUqc7W4EFV8NEPucHSTuUoKv7qfmrnR3DXwutTcH	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	532	1057	41	1	4339	jxgMq1vUsC7okfpye4dUsSqJYqA5uD4nJ1dTQ5YxbskBVtUxTqj	2313	3273	3273	1616528340000
4467	3NKzcKgy5XnqAZwVDbfKoscHkDRHEnACj2R2hZQJAVaFV1aTfcjZ	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1529	1316	41	1	4343	jw9G4MzpQot3c1zhTpujNpCE8f7EEwfcj1ZJv7DtJ7vd8nZ28iE	2314	3274	3274	1616528520000
4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	4469	3NKzJ2bu8PS8zowbm8J3YBkivYkfhscaLcJqUqiw6bNGSEn4o9kj	1406	1393	41	1	4345	jxjmuKBPTQpZWe8XPa2VxChjcu7GeZKQ5zjmMDY9rknriMyez9e	2316	3277	3277	1616529060000
4474	3NLDTchbL6vMvAgkCp4VqU4KgGAywSZ2HyP9HMdE2gGgwoDDJRhs	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1637	816	41	1	4349	jxxfKA6iprpUSSuQvdWZP9kK9AaaFUi7ZkH96NsrDuYsHmwV52D	2319	3285	3285	1616530500000
4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1631	794	41	1	4351	jwgHG2aTKezzETd8BLJK5k3b2Va6JdpX7kEwiiWUAM9TZwve71y	2319	3285	3285	1616530500000
4481	3NLWGPqujwjDiyhNnNZJ58ybegaqrc9nM1vByh5zHNDtBnEKYifw	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1474	963	41	1	4355	jxSGqfzEiEvRTdddZG21JuHnoBpHHkvupjpirB4GvotMGA7CmT7	2321	3287	3287	1616530860000
4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	1673	1368	42	1	4358	jxjwW6iHH4nSDzn2o3fKvPhZcC44kwhKehvYVYDGvnz6SSZ1mKF	2323	3289	3289	1616531220000
4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1647	845	42	1	4367	jwCNkED9uizr3E9zdka9FtmazJkF6HfquokCRbn524hfYb4DEkQ	2327	3293	3293	1616531940000
4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	1406	1393	42	1	4375	jxYt5Z3L6uU11R1JgiLxwCqGFx7XPboJUtzPswS4N9M8iPG3F3M	2331	3301	3301	1616533380000
4504	3NKREDZtkzxAAFGcJoZMN6htC4ULsWsQYzAXQWB6ujAw7vLuMUf8	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1460	1324	42	1	4377	jxJD5f3C1SfYA2h6YwkwFZWVumyqgwfojCYhanowteEvPFS5PW5	2332	3302	3302	1616533560000
4513	3NLhvUUvAwyiU5pMq1jBbtP5SDLvjacroLgDzFjpJP523ynsi9Cm	4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	606	1049	42	1	4386	jx2RjFLJm1pLtmcWArdVMLswtyVUmf1g6CKhHSHRNoJbbpvpBf4	2334	3305	3305	1616534100000
4520	3NLKeqiJqop65LRP4KeJr3h5fjddoX9RTfF92kmFpjoVL2hsdjZU	4519	3NKqLrNQF64u4F98QU5WoY4QKibYVevGjYpkAEVmZPoqbt3Nu2Wh	1513	1133	42	1	4393	jwf5HNKW3hDMxQirDqV3Lo9vPCFxKPGQFiBd4f84x55nWL6S5xC	2338	3310	3310	1616535000000
4479	3NKn4r8FwXnymawyoTz3A2v5KCFmdjZkK1LYHRXKMCv4r2Fumv1v	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1490	1148	41	1	4354	jwASBWuMLbFszAeFZ16ZftQLFdBqbYzZLVLFobSXCQgNwH3Z1DE	2321	3287	3287	1616530860000
4483	3NKiihY6DiJhdTpEMidmeukFrjtN9x22Z9YSNYV8yz1Gt1Yzptmj	4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	1405	855	42	1	4356	jx6BKvsZJzHZjNJBjXULNZm4TzXkgb3biCyHWQnUzrTMjCvcEWa	2322	3288	3288	1616531040000
4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	4487	3NLAS6FjefhkL1vCNCMhYeJTjmcfqovvxDWHirfWfFQp6QS4aEsn	1407	1395	42	1	4361	jxZRcAsNR4TcEyCZJpvhhfC7wYV6TTeGD3chmnvQhDT81Fh1hpB	2325	3291	3291	1616531580000
4490	3NLN3UcFeWdWNWwx4pEwD5f9ndyXmWBr99ytg6J1BdhiPqhr2yZN	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	1631	794	42	1	4363	jxNkn9dS4ZAvHGD9kM4feSFGZzEZjtqr9PGgaSnNExFpW4EKMG7	2326	3292	3292	1616531760000
4493	3NKpAXkFX3aYCCz1VqfQ7TXkx9K3Di4S9t3odoJV4td4K6wv2XDj	4424	3NKZSsxaSB6JMpet5KpaEEBMsQagjxQKVpwqntKf1mKL24UGT9E8	1652	1069	38	1	4366	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2242	3293	3293	1616531940000
4495	3NLv6fh6MXpR167DfMSjJKNMHtdDMbzGqAjWUwg84nDGNyfLcWoX	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1652	1069	42	1	4368	jxwJ2qGKUixrbrfDf4yHfFKrL1Nt7vMYgAPXyeFGWkNj2JAGJB1	2327	3293	3293	1616531940000
4497	3NL6G18TUdA8vdshxQU4JQoLM7b2uyh7VG9tkatT3r3ZrJQaEctN	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1476	1371	42	1	4370	jx5zsjHFmf3ifwCRQLbL3qPBCUss9sppEB1YGJFH6fvF3jNWLx5	2328	3295	3295	1616532300000
4499	3NKSqpixU6qoV9q8g1N2QASsizH3NQBJHbHw5J2vf49BBACiF2np	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	1675	1216	42	1	4372	jxqUx8NUdrJdMsotbp19sHyLkW8Vc1grFX31BZvr6ZJKSZ6f5kZ	2326	3295	3295	1616532300000
4503	3NKCnsLhTQ2gha7i6JigSNhYFBN813JavqaXaksK5kFEs79vHwdH	4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	1553	776	42	1	4376	jwEGbi56uHMmqzFgWTt2TEcUtzM9TCjSHrRichcMDrgXiBqxBBr	2331	3301	3301	1616533380000
4507	3NL3zLvbCzo2ffuiPo4HwRHAQkANqk6drrvHG1cUMWLkE4jNwnkZ	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1407	1395	42	1	4380	jx2V6x2bD4Lu6F83PS873kWR4S39o8PavQHssMXv73NczvPWkXG	2333	3303	3303	1616533740000
4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	80	1027	42	1	4382	jxcLmUPE3sgivJzP7YrUyzpypMWPyaJkk7ExrbEgLzKXLRFFdxb	2333	3303	3303	1616533740000
4511	3NKf5jj4HFuamcUKATC9dqEMLvtdTmKDZYYf8jMgxme34iAvdgBM	4445	3NLvAaDganveAuzx4ntTtPsN1nGWi8JdixzLgxtr1peqroJ4dWLo	1613	1223	41	1	4384	jxBRawLmzrnayZa2ia4wbXQK9rvbxsjJqpxEjYukPjYPRE6GLmn	2305	3303	3303	1616533740000
4516	3NKPF9jzmMZB49c9RzSViQ4aU7wN9sfvpb4NgXF3prUiVxwewYKk	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1474	1329	42	1	4389	jxDR1xe4Ax3KC1ErnYeZ4ecnPiXGKrXF4bUMeg1ZF9ALPK8hPvT	2336	3307	3307	1616534460000
4518	3NLpR41x2oUxUsrxEtSpv5Ti1MPH54CUcuAu4muGZXsxnbmJaUYJ	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1631	794	42	1	4391	jxrrx8gW58zGBQuw4cMJ8KdoHT3WsijAaRA8sXtzrkDghqMWXUM	2336	3307	3307	1616534460000
4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	4520	3NLKeqiJqop65LRP4KeJr3h5fjddoX9RTfF92kmFpjoVL2hsdjZU	1471	1260	42	1	4394	jxCogx78Y5trydWfMXC9smAKiUtuJ3on4byJbpQgK2JMa6QZ6Pc	2339	3311	3311	1616535180000
4522	3NKUjMsLToRwkBytVKj5Ev7Cjtm8GvH9FDxHB6SHGLxLubatfSwV	4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	1651	1301	42	1	4395	jwSc5dK5UdrrC7PvrRpYKYBUsaMnDou65fHKsrj68hpUPXg4CbW	2340	3312	3312	1616535360000
4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	1651	1301	42	1	4395	jwjTbeFQc2Ff4xgx9wxua6YGV5MgHapXuJf44Rp5Pvq1HNzMr3u	2340	3312	3312	1616535360000
4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	470	1309	42	1	4396	jxHjBhmtEphCDiehZ1EpAdW8TD3W9dwDpqeZpngsFsViqu5jQVM	2341	3313	3313	1616535540000
4525	3NKhM5MH44rRytKYTRERsvgbry9jdcHdXi1BSbrDo3P6ZXc3ihax	4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	1631	794	42	1	4397	jxe3rfLztienoe5S5WS2vyXtUBUwq6rhgu1MpGuBhAzG1w3Lo66	2341	3313	3313	1616535540000
4526	3NKFR5C4CL6WT7iAfjc7spfJGXJTLqcfFq4ZuazfSSBMMSiiXdN7	4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	596	1306	42	1	4398	jxSK6aqJH65SXdPnK4RBzimuC8HRvUdn8Dwr8aPmW88FrnsjvMD	2342	3314	3314	1616535720000
4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	1553	776	42	1	4399	jxpyuW5nfjuo28MdttPLvj41xWnKauWZvPs8HkZB1nWMicifyFM	2342	3314	3314	1616535720000
4528	3NKt6av7CZNQ89e9EjGpAozZFvmRnSUrVVag3m6cpTuxDNfJD87C	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1534	951	42	1	4400	jwi1c42Lz3FJ6u5cQpT2YDbkWeHdTfCV6sBYZvPu1apww9tqdD1	2343	3315	3315	1616535900000
4529	3NKaV6f5Aywo4dhwXY3VVRNd221hff8UwhjWxTyfLPJtfTvyW6oJ	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1455	1332	42	1	4401	jxaWQeUESZRtiygoJFR9SS8ev5hRhPohvZzEDBvcVzpYPTq5w3e	2343	3315	3315	1616535900000
4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1507	1154	42	1	4402	jxCK8VcNUaeLWQr8AAsHjL8TJ6HDhNfeoyWNYGadf2UA8hLRPTg	2343	3315	3315	1616535900000
4531	3NK5Fp3f2iCiL6qorAq2TMninXsZ4bGFVBoA8EZagQV6VnqrgkyM	4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	1619	1275	42	1	4403	jxnRegrUH6PtyUMUbwKCyvmVWG3ho4N8hJLq2SMtyjaEDFvHjAW	2344	3316	3316	1616536080000
4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	1613	1223	42	1	4404	jwnmh1PNxNk9v3CruTLx7QH4TYdF9PK1pMGdJrXYDkQ2CAjVF5P	2344	3316	3316	1616536080000
4533	3NKxkH98m8cc8NmZLdpaxTXWTeBinnMJ17o9nSfKsiWp9VBdnQ6h	4511	3NKf5jj4HFuamcUKATC9dqEMLvtdTmKDZYYf8jMgxme34iAvdgBM	1613	1223	41	1	4405	jxpMXGggeLexRmWwF6oZn2S2K6qcMJEHueva2FTwf2ofbFaJKn8	2306	3316	3316	1616536080000
4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	1407	1395	42	1	4406	jxUpopTRwwsJe7F4N8PGyDcugHpxoz6qT9NjYo5srxRAMkZNA9L	2345	3317	3317	1616536260000
4535	3NKENGjtdpZxstcbuBCVwzT2sTD6rbhYLUVV7GBfwjpDKv2dNEUJ	4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	1647	846	42	1	4407	jwdpfBokdQZ8Zes7R8hKHa6wnW74uneYPcAfBHd3MGom3KZuNeT	2345	3317	3317	1616536260000
4536	3NKR9gJBMuBheeuzXdmLQj2ijMNNL4uYrcZou6q4Z8oTXcteTxaH	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1407	1395	42	1	4408	jxrQYuf4CNzVmxnNnuLJVnBZSzjEehT4Lh2av3CSLM4tnSs7F5o	2346	3318	3318	1616536440000
4537	3NKthtNErzzbnHLdChso8hxgVPaZwELtk9y27cw4MLo1masG2imM	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1448	945	42	1	4409	jw9CKTQmmqGQc4ZskJ1sxgQ4MCA45b2hBsexgYQmS6btKwjBXaa	2346	3318	3318	1616536440000
4538	3NK5hGDqfacK91bFogkvZsAwMhXJJWL4iLr1a1ySHTps6bU8KaEY	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1406	1393	42	1	4410	jxpyPKAnk7MeaX18WKMtB3zhjzbmmpMYMrbtYGuo5cFuDZ1dS54	2346	3318	3318	1616536440000
4539	3NLQt7LixoJiKqbsdUnBRG3WGnRteZuMu3tVsVozQXXMXBDwwP9r	4538	3NK5hGDqfacK91bFogkvZsAwMhXJJWL4iLr1a1ySHTps6bU8KaEY	1403	824	42	1	4411	jxHtLL8eBxFkYhS2G8sJdGQeARrZDY3HhRow7bF7VAsMPRcqBkT	2347	3319	3319	1616536620000
4544	3NKRb25ov1hUKkTZphsj6hezesEXigWiBZ5vJgMCBVdft2eXNiqr	4543	3NKRaZqrL1uAYHAPYui5HvirPMkS8P1qWHsMsEC5f12rfDAnLK3L	1578	1170	42	1	4416	jwxurxWskQZwh5bhz8DsudHmJgVRK5dnuGUsQyfkEdvLhA5VvMo	2351	3324	3324	1616537520000
4545	3NLxw58848rpaEDk5vrr3vrAS4qp4XyF6SjLNFVsPVgraZGQcJP8	4544	3NKRb25ov1hUKkTZphsj6hezesEXigWiBZ5vJgMCBVdft2eXNiqr	1647	936	42	1	4417	jwnjYT2aXgTMBpQGHMiSbCdcAwPfjNhyRrVp3W9NdqjqXonpfHD	2352	3326	3326	1616537880000
4547	3NKsCjnwX3hxwk8vd1tqQBLTYSdWKrMfMgJCyyXxWgroMnteYGKM	4545	3NLxw58848rpaEDk5vrr3vrAS4qp4XyF6SjLNFVsPVgraZGQcJP8	1652	1315	42	1	4419	jx9UGLwMvaUkLJAUbmrFFRfXCukCRyKTZfnuiRxc8jV2fCTCW37	2353	3327	3327	1616538060000
4552	3NLEqMMaMrhJFUoKzEUVa6VNcsgnfcfqutieauEqzM8FRFSDtBLA	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	149	1283	35	1	4424	jx6yzCXJ2DS3VJiNNPdmmitBMGPs5Z7RjLjuUanYSevW3uNwG9g	2132	3330	3330	1616538651326
4555	3NLeF3ttvLBYefo1xFG3P8T9eAjxb37aU6rFcYUEPczb84r7W19g	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1587	1357	42	1	4427	jxHqugaqoKgbm5n7XuqAP7Upv41mTf8ZpoKUs7MT2n9mRorSL9z	2356	3333	3333	1616539140000
4559	3NLnt4zMEA1jkVGpvhCTH9z6noK5LqRT9H1sikkqFZkzEQ1Jecmv	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1587	1357	43	1	4429	jwzRn3khM6gen4NS84B99W9EjJveU7M2aRoBHW4sR7xizUFsLYb	2357	3333	3333	1616539185310
4563	3NKNdCksDUAA9Gx9HkiTtWntCzeV32osvfawrMfFzGcrkcYpZJAx	4562	3NLK8RELzD27dFrHeimayKN2gYijQ4fJ6nfWhj4y5D5oBDGGdPj7	1581	778	43	1	4433	jxTRYWF25wMDEnW1CRXqnTVhXSdQxjuY8CepyxzjCCos4BozoA9	2359	3335	3335	1616539500000
4566	3NLGJsf1mFhQSeQJqn9NTrquJXWR3Wc1jJocgxzUREEa2ixZJ6MY	4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	1610	1314	43	1	4435	jxtec4izZ6oSZvKGusgnxhcAVsLjsFTkm5qBUUj9Q66EKuQzdAs	2361	3338	3338	1616540040000
4568	3NLaWLB8LvjiBWhuQL1hDWzopReESczFdzZZr2EwbsLoevycRApa	4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	1553	776	43	1	4437	jx37TDCJe9ubxcf89S5DyimfsXN2x2MCFnY9eeiQgJodE2v4zaL	2363	3340	3340	1616540400000
4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	4572	3NKeqK7twLGBmFug7xzQpjRpNqEFir7SeTnsh73QugqCUfA7dgFX	1407	1395	43	1	4442	jxTscNGGyTRi91YCsRs27fmPH1KyCfs2pyz6vqTr6yH7kkDU1CJ	2366	3344	3344	1616541120000
4576	3NLPTG9URNaCauTJkz24fx6S1zPMkyv2ThNiYztSYadFfnsznJiY	4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	1407	1395	43	1	4445	jxrXrGKvovQcxqzsGcYVLZ9sy7cQiJnz6cPwNf67MDaSeb1hqxi	2368	3347	3347	1616541660000
4578	3NLYDEreu4RLKLQj1nHYkLoYfjmKbUxVaLybEjzGYmmA9kd4c2Eb	4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	1599	1287	43	1	4447	jxYYzPm3oo41JW2bXixb5uSNnuyQrSkPFHJhCLo2MdZrxwD9BAD	2369	3348	3348	1616541840000
4581	3NLJ8NUhHHUPpusmdE7eqFBDqLyJSFxh4twuPWsTCkHm8rSP2uoK	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1406	1393	43	1	4450	jy1YkpuZxDkU2afUip1B8B4SXTLMeq8Nm9Bs4GcFdHWtEo7pG9f	2370	3349	3349	1616542020000
4586	3NKdfZxFS2rbptgWxgjKDWgVY6uSahVUbQq3nkDYq33VdBrVdvVm	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1406	1393	43	1	4455	jxF3UaqRHumvXjfnz4dfsS7gPrCrV7kCnRd5tHwadWgLaWQJyxX	2372	3354	3354	1616542920000
4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	1406	1393	43	1	4471	jwXHtU1UrFyvURZPtaFndbTxHPezFUuCknggWBvF2qr9sSVg8dG	2382	3372	3372	1616546160000
4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	4609	3NLg4okTYmRJs7mGTvbZkJQpLL5EkjS6ynjT6ohLg1CstNejWn8p	1650	1249	43	1	4479	jwoQyAYeFEcymdp5DS2m86Mf2Jvywuevnrr6rsJQVs43m9nELNY	2387	3378	3378	1616547240000
4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	4613	3NKC5DjoETeFCmj8mNM2PhddpasXGwgqaV32gwwL8vmXCiB1cgvn	1407	1395	43	1	4483	jxSSpfYN7V2eThTeLqW3r6CTSFGBxnUFfb2hbfiSXZhhMKArX8s	2389	3380	3380	1616547600000
4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1601	1022	44	1	4490	jx9TCLJnkSfk6nE1wGRiwryBMYJcmW8PF7yhP9fYdrJSPE3zHy6	2392	3383	3383	1616548140000
4623	3NLHiRjngd8X67uPYWnnJf2AiLnzud6T4SEfbzQgc9KdLEmeqmt4	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	1589	1040	44	1	4492	jwUo8LyXwzpK2K3HuP2ikCMBdHyBAcp9V2znrHZiDo5iyaEkJDB	2393	3384	3384	1616548320000
4625	3NLiTaurLaX6CCgrvz8GJZnUTpwKXvdyi4F7hMq7r1b7aWuAdAoF	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	484	1073	44	1	4494	jxb8LJvuZMaBVdXyFdY2CKKLYgjLGAYyr8u515mAMW5DaLhvFrN	2393	3384	3384	1616548320000
4628	3NLqZJnBxgmj4NmmRJibNFZFjqfEB5bfJGNuxWgrmBwM5LbG1uEN	4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	1407	1395	44	1	4497	jwNtvyEtqr9zMFAy3rqGpWHMg2hpCpv8yeMyzdrEsVDVbyL9WGm	2394	3387	3387	1616548860000
4631	3NLidPZJFRQtRcRvBRkHnQTCqk7s9eoVQcwzpckSpvVoJc3kG5ia	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1406	1393	44	1	4500	jwf5kpmij77tUnYeykHUMBbuhMYyu3Fp6pwFyJiYzP5KGTjv9KB	2396	3389	3389	1616549220000
4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1671	999	44	1	4502	jwR6YbURT4aubraqRTcQpDdmeze15YNyTFJHNM8VSJGDgwch8ze	2396	3389	3389	1616549220000
4635	3NL1TPQpqKPyzhdyc2LBPbetTLk3VdMfGyFzq8NxCaR1pWbuwfr8	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	596	1060	44	1	4504	jxZMyRs9fTf38xzyGNNhB2cgc57PXPM5JstpwbHZKZbte6N9rPT	2397	3390	3390	1616549400000
4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	4634	3NL7HpgkKtN1K1JAhwouyAwK1o3GUiVzcNroHznfRa1JaC4LBWgi	1578	1296	44	1	4506	jwKndUJY9EwuhMJ6cf2dxQeaoERiuLqUEgkSPG2JPLH1fjihxva	2398	3392	3392	1616549760000
4640	3NL9wtmXst6NuysXGAkdRVBYQMkVVi2G3bRf4bMGuEdhMJLWkchy	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jxQCzT3pLEij1GTW5YU2D1UTWVdCJFvwVSrcaEd8kFHRFsrTntd	2399	3393	3393	1616549940000
4648	3NKSgVs3YL5tcWHvDhTbgCT3s1cvmA8CEW8VA3MJQsPv11fZVqAj	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1419	814	44	1	4515	jxwDumxgmtqQhsG82zfXRwfaHq1zj3uhutFkdkqKCRmRz3K2Xet	2401	3395	3395	1616550300000
4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	4650	3NLu5KfGr6phEFrhsTa3fxRkYZXWyqrUfuAziTmPyTVfs7zKePg6	1553	775	44	1	4518	jwkmXVr55Ekoeo6JryHn1sygLzSgfFtAGzDjRcBUNNHah7MkGU2	2403	3399	3399	1616551020000
4654	3NKwApXTPZi8V4mtbn22ycijFLQyBqnjA6Gh44WPAtqXfg9msbCU	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	632	1382	44	1	4521	jxwcZwttaM6GpJqnmCTJLn9kLNZEtFR9KrqKJc7NnwVHpDrPAJk	2404	3400	3400	1616551200000
4656	3NK8nKxB1iD9FxL8Awg3vHmNb24hxaJ45jefLCDAnmmU5Qzrq6QG	4655	3NLZy6Q4sRvwcuuWwH7Wvrki7Qk5yNVKd3e4KSLvFEnDE8uTqbRB	1501	1114	44	1	4523	jxx6EYn4d8SNcRtHbohmbsqAxsePwB6VKUvJMLnRtMmvPouyJze	2406	3402	3402	1616551560000
4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	1587	1357	44	1	4526	jx6eVuK8PKscKxZ6J2947zgRLgjoyEwZoPmyqxrGMZ7sr2KjXTJ	2409	3405	3405	1616552100000
4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	4539	3NLQt7LixoJiKqbsdUnBRG3WGnRteZuMu3tVsVozQXXMXBDwwP9r	1471	151	42	1	4412	jw9d39CxbnYfF4mxqbpJUEDcBELMMPvRoBSdvjNNNWpRWAekaXi	2348	3320	3320	1616536800000
4543	3NKRaZqrL1uAYHAPYui5HvirPMkS8P1qWHsMsEC5f12rfDAnLK3L	4541	3NLuYpWmYwGVUwLBH7Ld6U8LXFZ5wAyyZ8ACbKzCcyhYmLc3eoFV	684	1106	42	1	4415	jwL72sGVHMydi3yAAp4sfCobiGiPn2QrJvAjr3JbkUZVAh9uaRo	2350	3323	3323	1616537340000
4546	3NKbVfzQ9b2kHW2cMnTvPUvfWrBv7VGgtKXEgHUdYmXG6TAvbbVB	4493	3NKpAXkFX3aYCCz1VqfQ7TXkx9K3Di4S9t3odoJV4td4K6wv2XDj	1652	1315	38	1	4418	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2243	3327	3327	1616538060000
4551	3NKPKMNZbKFEugMTuCZUhutimAVeLT9uHmYcRHmXfEJb7emGsyNm	4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	149	1283	35	1	4423	jy3DvAk5UukV4p6h5tY85wvY3SDn5jQKAEkf1Rpfi7aayumFtHG	2115	3330	3330	1616538600000
4556	3NK84WG6UgUvvVpcENYhYYQdcAUeB7tVSJWDPsdZEiw4mZ2usGfQ	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1503	1151	42	1	4426	jwUjRxeVWEERgusjw5JQs78Hyi4YpqAF2XRTLERiwdhz6K94Poh	2357	3333	3333	1616539140000
4558	3NKrZp7mY8P3KB8R4yH3qUDqyxenoj9cKDkqkZw49BGHMrwLtwEm	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1587	1357	43	1	4429	jwzRn3khM6gen4NS84B99W9EjJveU7M2aRoBHW4sR7xizUFsLYb	2357	3333	3333	1616539175099
4562	3NLK8RELzD27dFrHeimayKN2gYijQ4fJ6nfWhj4y5D5oBDGGdPj7	4557	3NLTh698YsM8dg9KAqrYjo9Wbs4i9Jv2nSf8pxJ4VmfaeS1GHs6Q	1493	614	43	1	4432	jwEPBUJjd4tRf2QYzvRbE4gTWtgVUg9dTKBEGDrMY1utMgZxtSL	2358	3334	3334	1616539320000
4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	4566	3NLGJsf1mFhQSeQJqn9NTrquJXWR3Wc1jJocgxzUREEa2ixZJ6MY	1406	1393	43	1	4436	jxE5yEiCRedazyvvQdmaVWj7g84H1VrTXSugJahJ4dwF51yFr1e	2362	3339	3339	1616540220000
4572	3NKeqK7twLGBmFug7xzQpjRpNqEFir7SeTnsh73QugqCUfA7dgFX	4570	3NKfJDNNmDBm2TfeMTnWeQgcyQyZuYmCyVvWALBv8MjmkxtDth5F	1406	1393	43	1	4441	jxsuABEykzmbEC26vWD45PN34NSwCM7h9tZpousSptrpNXAsuQB	2365	3343	3343	1616540940000
4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	1611	1095	43	1	4446	jxHQwfMGbm775KmJfJWnqyLbcKQy5z6iZ9dEzvNYvqRHbJUUnjM	2368	3347	3347	1616541660000
4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	532	937	43	1	4448	jx4vTgtrjsLJ3HDn4tLiBFVqxCNSJvTEC5RRWQkVt1LS1T88drm	2369	3348	3348	1616541840000
4589	3NLg8Xhe7H8YCsyPhXrBegT8HDmjVRhzE5cTama96qbf6v7tvm3p	4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	44	1079	42	1	4458	jxj2Z5zp3sLYKs16DwhJoR7PrHpBbUzniyJNobKdCLTcn2au3fY	2323	3354	3354	1616542920000
4592	3NLxJycCd3PSHH2yJQ69PTWUUPzDEWqk2zRPLKwE3JzcmFwFEbKe	4590	3NL97KgW8kESX3Z3gy1ncqoydQkxMX3yGfX4RW4khoiwgANv4evu	1642	280	43	1	4461	jxYuDS5LE29d9XqTZRj6zFMhou8UXcJAqhKrnd7xs638TMLdEiA	2374	3359	3359	1616543820000
4595	3NKPoq8m7tKffg1yGKejRa5bpxR7RPq2yzLjSBHnSGgrBPFMh9ee	4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	1407	1395	43	1	4464	jxqqXb2pZMvm5C5qFxp7oXLLp7REJ9sV86nkiiAVTVttmLAvkTY	2377	3364	3364	1616544720000
4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	4600	3NKQQp6TTZwCnewH41E816DsrQzApS1zT44djcSqBmoNHqyErCRT	1403	31	43	1	4470	jwhBUXjAYKC7c5npsgPCTerTBidUwc9chqwC57EsAXZvMRSmSwU	2381	3371	3371	1616545980000
4608	3NLsrDW9F8WzcPnrmryYwMJgzS4AV8Vvive2eVEXaCJkpNQYLbei	4607	3NKD5ZvX3RjtRgv3SisWGiAyztQBTCBJWBhoCLbdZJiRtQTkDP33	1508	1387	43	1	4477	jxuoduiS7JbmEMweCFLbhvu7a8ZYbTP1hcZ2Z75NQP8pwvQdZCb	2385	3375	3375	1616546700000
4611	3NKUe33rjAWA596XNh26UFpDYHsRFka5BUYav2j5LBhaj2tUMhUt	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1503	1277	43	1	4480	jxX27uKMwiDmcGCdMRu6dtGDp33mMQfgnS6PMUGCfAgBNAR62ZJ	2388	3379	3379	1616547420000
4613	3NKC5DjoETeFCmj8mNM2PhddpasXGwgqaV32gwwL8vmXCiB1cgvn	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1623	830	43	1	4482	jx6YF2RkAfLLh4bWP3zvgLEfr8nybbFgyAptAJSY2rfYyEriHHo	2388	3379	3379	1616547420000
4620	3NKG6tmuz9VB75txDDfzv97R7CZmzZVxcrdQub6Pwigsz8y9PDX4	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1594	1080	44	1	4489	jxCf7utNsMZaYsxoSq1YLWBbkvFhWn53dcXdrDKV4zdcGnxz5BR	2392	3383	3383	1616548140000
4622	3NKcZwxzaEXcbGjCBa3MsjZBLtZ49qgdm23F4ya1DbhUvB4wtSzm	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1633	1390	44	1	4491	jxCHB4CpsF3AVbPZxZfdW4pvwTNz6GrcEUcoKNTTohskLGUUq4P	2392	3383	3383	1616548140000
4627	3NKY8XER2fZPbj4VgefsCrhsG1t2icr5KAgW7hdahzw8SpX4QGp5	4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	1587	1231	44	1	4496	jwbCdQk6Htdr5pxjgjdTT4wNp9bGNs6XvoE7gkeomhf3f3HSBNZ	2394	3387	3387	1616548860000
4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	4628	3NLqZJnBxgmj4NmmRJibNFZFjqfEB5bfJGNuxWgrmBwM5LbG1uEN	1406	1393	44	1	4498	jwzzFz96s4o4iscKeE8Nc96dYx35BYDhGFBh5E3A5AVoGo5Hk6q	2395	3388	3388	1616549040000
4639	3NLPTQ6y8gjHhDCLPfVbsCWHVgFtGS9S29XQoJeAiMhxVUSWfDt8	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jwX3atc2nZoQLzTy4jkRr5TZLjmdqkWBeY4LS6xGWeMMnjYPjgS	2399	3393	3393	1616549940000
4645	3NKbJycLVZyFUUp9toAPqeWffzPyekkkgAkrkNu5ecnt6nzmGRCr	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1407	1395	44	1	4512	jxmSYpJFE9rzxVhW22WU7jLKWR711uNBxfUPbPeQ4gEhTJtizeX	2401	3395	3395	1616550300000
4647	3NLJ3wb1oMu8XwdJ9M1V3WQRjNV9bYFdLJ1fNLqdQv5J4Xdb2ZzP	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1652	1069	44	1	4514	jwZ4WYvWDzCtbVhvUf4wAWPd2ZtbXZQJVZVRKTUKDH2qDCGv1AS	2401	3395	3395	1616550300000
4649	3NL5geWvMYJbZPGYU3WMRHCMvYxt5rac2sX9sxhey3dg77EjL5jy	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1631	794	44	1	4516	jxRGkrBMJoppmdpSbQzZsHqHMyyYnTfssfC8q75C2wyTDjrAYYf	2401	3395	3395	1616550300000
4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	4657	3NL9eQ1JzDcZoRuWzWZs6SEdSWtMgykbasgVsPnDtA7v3LjDgu1k	1581	778	44	1	4525	jwcbYtVKBM4sJLzxGz9aNz2Bk8efM1iFWf8Yxd6j3PAcaqZV8fz	2408	3404	3404	1616551920000
4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	4664	3NKScj8XssSsyrB1E5yt5BGtCzNwrjG5Mw7hC5fKvUxvkSrXZrYn	1474	1329	44	1	4531	jxfHsj7QfTLKts947GQ9dwoVUsRrzE1oiGMzKrJqZxN58YK6bbZ	2412	3408	3408	1616552640000
4670	3NKPWGZxnEwpEHTLGxUpB8qKrjmr2dnLocjBNH5L1fL49D7trUfR	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	1444	1381	44	1	4536	jwsKpaCQ6eHAscN9HFwriw9eDm5wUBicykBGgN9E7QEGJwFczHL	2415	3411	3411	1616553180000
4672	3NLo4rB3Z9bWEaT3w83aRMx9G2e1Gv6YCif6jHyP1kjmYaHTJZfp	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	563	1233	44	1	4538	jxychQreAYHZqwEZbguaD7Sc66whJUM58TuvQSoQw49KRZ7ryKo	2415	3411	3411	1616553180000
4674	3NLA9361biNfnYoLrUpDa4nZimUowiB3zPfdbSSVBZw6hB5dqcoZ	4486	3NLgPKuAkwEgYcprvbN22No5kG5xsDzQfwYvbMmqpNcVosYGhpvP	1607	265	42	1	4540	jxSTfMNdF4tZemquqJi7TfqUpMoaAPcSWNAisxqB45KM7Zb42p1	2325	3412	3412	1616553360000
4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	1651	1301	44	1	4548	jxYzBTcWVrbd5o6j9VWwZ8ZZvrhvCXZPECZA1uNckrRC6c5bax6	2420	3417	3417	1616554260000
4541	3NLuYpWmYwGVUwLBH7Ld6U8LXFZ5wAyyZ8ACbKzCcyhYmLc3eoFV	4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	1564	1338	42	1	4413	jxtCtvB11UzPfwfnSteAW7A1xNXtaT7URpwyB5CZUWaAoKWAvFh	2349	3321	3321	1616536980000
4549	3NKzKALRn5HYxXS5h42QM5qa3tJMyj1scvQVcMiEMBoxZak19bgW	4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	1642	1121	42	1	4421	jwvyTuGgZwLFg9KxDTpvb6hM15CJUiUqecboAtMsScWjimURmEg	2355	3329	3329	1616538420000
4554	3NLGNQhLpvvv7Fiio3kt52KG2qTadfD4qniXiaYSTebq44BCs3V1	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1503	1151	43	1	4426	jwJfPpgt9qLy6EJy5R421KgU5dwXLU7fnnJp5Xu4HUkxARX27qc	2357	3333	3333	1616539140000
4565	3NKL3YQKo5HXjbx5kUavz3faaZp8bZHHa5FQK8CvrYcFwQymmpcA	4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	1610	1314	43	1	4435	jwf3eGVD9r4UNb3enmeAQrPGTrDqifAZhCEd2jD2EabyJwmbYQh	2361	3338	3338	1616540040000
4570	3NKfJDNNmDBm2TfeMTnWeQgcyQyZuYmCyVvWALBv8MjmkxtDth5F	4568	3NLaWLB8LvjiBWhuQL1hDWzopReESczFdzZZr2EwbsLoevycRApa	641	1336	43	1	4439	jwt8Zd3zmPDmrJGB91yKSAX8GogNFK712hZjrRA1BbH2VQtfRib	2364	3341	3341	1616540580000
4575	3NLtSbJsperrdHyjN11H2V3y6xcbnMhT6bUaLDFkzSkTrpXeKK4z	4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	1637	816	43	1	4444	jxJ6WRD6eyyzvechs5NcKRvx82DfTmh57EDfyKnBpdzstvMKWAZ	2367	3345	3345	1616541300000
4580	3NLPVKJUU5ABXgFzEioPHb52fsSVHFByoQiXELqnCNp67eTXeLy4	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1460	541	43	1	4449	jxC7WiScDB9Q6hCgP1b5iSCyjFLofhqoghrrzEkGiug11N8YFEs	2370	3349	3349	1616542020000
4582	3NKSJ3rmTNcuMPSL8CPbLgCpJZgnCbJANbtNUdgDfMrEX1fp7y8Z	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1534	1317	43	1	4451	jxqkr8c1xrbBfyEnbBw5igAH6Tsg7rhLHHiimBmnTGjhRVFTLFD	2370	3349	3349	1616542020000
4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	4583	3NKRuZzhcfCL3JE1LnzguVokvXTnBeJKv4hvzkcqCLVuxfd3H1Ns	632	1382	43	1	4453	jxKRKTMsMcoWhYtRYgbCDPKPmDQChWkTNqN7L8frdhsyuyYsasE	2371	3350	3350	1616542200000
4585	3NLRyAtDcCnAQ7spCmzj5dR4YrsYdCEKA65gGRziybRgPZt9PEVh	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1503	1277	43	1	4454	jwc76xB7GMrnBiqRLnvK3jje2sUDWRfvz7BZvPgSBwGNgNjkP2N	2372	3354	3354	1616542920000
4588	3NLoZC1TkKEkiBSNzGRE69ifxkAD7XMKGkjLMyDMAzefyqh9NfEZ	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1507	1280	43	1	4457	jwJkWNRM2bAz7nShvsGGpuFQc5DqaSgWXKJcojcZfnLJigpKKie	2372	3354	3354	1616542920000
4590	3NL97KgW8kESX3Z3gy1ncqoydQkxMX3yGfX4RW4khoiwgANv4evu	4585	3NLRyAtDcCnAQ7spCmzj5dR4YrsYdCEKA65gGRziybRgPZt9PEVh	1489	1254	43	1	4459	jwJzYRTC6FzyBzTPXjZJtJccacJdRb1NZkASKRwePr9ZyUwUpSK	2373	3358	3358	1616543640000
4593	3NK8eWrubc6A4JkR35WYsw8unKV4CybZwC9dc4bbx3PqJwYf3RA7	4592	3NLxJycCd3PSHH2yJQ69PTWUUPzDEWqk2zRPLKwE3JzcmFwFEbKe	1598	543	43	1	4462	jx28MVpDB7Hs9YMpPNQJowxGDiXmxh31y8woJicLQVDfoaDuaVD	2375	3361	3361	1616544180000
4596	3NLG9yLBCBjvjDwkHoLLJ15pZJtRssKQ3T2THVZKKvmaBfe935D7	4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	606	1295	43	1	4465	jwLAmt43En2QpdPoqnQWNuz5UGXhuZRrAHcdcyoP2vFd4SZX9td	2377	3364	3364	1616544720000
4598	3NL6xomwYzemxBjvo5tAjm97K5uK7vEEMsmwNToG8P7c94TQb373	4596	3NLG9yLBCBjvjDwkHoLLJ15pZJtRssKQ3T2THVZKKvmaBfe935D7	369	1066	43	1	4467	jxsmCS8igfcDUAYnnT7gm4VGP7xzgAPc1bnr5rUoNU9sogVNtwY	2378	3365	3365	1616544900000
4599	3NKk1aLjygvuxZdy35Qd6auM4FL3Q9iAoSiH8D339iK9v4h3qypQ	4598	3NL6xomwYzemxBjvo5tAjm97K5uK7vEEMsmwNToG8P7c94TQb373	1631	793	43	1	4468	jxQyNjgmyPVu1pN25y7XchVVihewLpUDm2JqEMhbWTcHTYMD47W	2379	3368	3368	1616545440000
4604	3NLJdEHHHFoQL2PgzdoVyqXgzbZGCVTgPw8MLNe68yYJYgBWbnVo	4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	1546	1093	43	1	4473	jxuggehCcozStoWW8vHmG9U5HsHAKtk9Lgr9PMRmv71v1Q5XUpo	2383	3373	3373	1616546340000
4606	3NLvXbdtakiSfACjpCGDwTfHhBnRWQBqW7LYDoe7VyyzfqBrvSyP	4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	1439	1033	43	1	4475	jxie84ozbz2YBufHxiQS12anJ5jC8nYCjCsiZP4CWMFrj5p76xo	2384	3374	3374	1616546520000
4609	3NLg4okTYmRJs7mGTvbZkJQpLL5EkjS6ynjT6ohLg1CstNejWn8p	4608	3NLsrDW9F8WzcPnrmryYwMJgzS4AV8Vvive2eVEXaCJkpNQYLbei	1406	1393	43	1	4478	jxKRFewUak4Gwe72DQ4xxCZeAomVsn1NBm5TtpZ5RGEce6nutLG	2386	3377	3377	1616547060000
4612	3NKsAsGsioY3Stbtn3XwgZ6VqJ4w5fS11j9VqSQMcmQSCVCDhdFh	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1406	1393	43	1	4481	jwJfNcyfntk9qD1MVCLE7UrctcR1fhicMbopmBRMWVmF1Lbf6Dr	2388	3379	3379	1616547420000
4616	3NLeHyiZcwEqk1PiXVgp1dhFpJRU2Bm8kyhm8Bh1dmhEP8AHhg5H	4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	576	1355	44	1	4485	jwKnBavcHzS9RLP91u9bNQiefB8YPog2rXwGSTk8FesWrJLaVnf	2390	3381	3381	1616547780000
4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	1665	137	44	1	4487	jw7mfp6wrW5dP75u8JtPsyGo2qv6Cb4ijvmd96DYXjnVzodn89h	2391	3382	3382	1616547960000
4630	3NLUCJhcpuMFZoENoK6xo7NvK4YD4BCrm7hnXJK223gHgioQc36N	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1407	1395	44	1	4499	jw7ytMyCq7TbrycSSGs3nm7TxTRANh1NXcuicxMQVKugubWbw3G	2396	3389	3389	1616549220000
4634	3NL7HpgkKtN1K1JAhwouyAwK1o3GUiVzcNroHznfRa1JaC4LBWgi	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	1407	1395	44	1	4503	jwn6FfFYw715CQptd5VY5J4wcsYkRXmFFPnRykNTCktUwtgywsb	2397	3390	3390	1616549400000
4643	3NKzxhNJjzYKmxv4L9iDxDjAyqvKtFEMvMfjjkTAjnUR93byFBkR	4497	3NL6G18TUdA8vdshxQU4JQoLM7b2uyh7VG9tkatT3r3ZrJQaEctN	43	1064	42	1	4510	jwW1vL7Sm9c6B5bRpnyr5uheWw6PA1GgmEaPPYkkHUMKV1haMRN	2329	3394	3394	1616550120000
4646	3NLVNkhr9CK78SDMbvdMq5B7D8oCVzmq5KHSGfBak7dYnobiJExt	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1406	1393	44	1	4513	jwfR8Bw1nbxRYFmvYsTc3nAQdJx2RP1CYxmRJQxABQbkNPvUjdt	2401	3395	3395	1616550300000
4650	3NLu5KfGr6phEFrhsTa3fxRkYZXWyqrUfuAziTmPyTVfs7zKePg6	4645	3NKbJycLVZyFUUp9toAPqeWffzPyekkkgAkrkNu5ecnt6nzmGRCr	1593	1100	44	1	4517	jwNquh9gR8PeVGEN6a8b5EEev8BS3KK1rMJrHHYWamp44Yyncuw	2402	3396	3396	1616550480000
4652	3NKDsSds3uUfk9qrYBuJAxYjkqLJ5qwrmzScAEhjhFVP9TKmfEWE	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	1403	824	44	1	4519	jxfp2ZNY3owXkvjj96C27P7uTxe1vZ9Py8xWTbu4Ei6kpqKuwVq	2404	3400	3400	1616551200000
4657	3NL9eQ1JzDcZoRuWzWZs6SEdSWtMgykbasgVsPnDtA7v3LjDgu1k	4656	3NK8nKxB1iD9FxL8Awg3vHmNb24hxaJ45jefLCDAnmmU5Qzrq6QG	1407	1395	44	1	4524	jwZHUkXP5M2VnHb6QvdW1nFrGSYhzUZuwT1y2zQFsbvFCqdd99q	2407	3403	3403	1616551740000
4662	3NLSutyoCW1QsuvYmrV2Bbi7T5B8HWYWBHzC19dLcxKXdQ2AwwsJ	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1651	935	44	1	4528	jxKaQAtGs321HNzUQTZrZ4AF9r3YXZ4u8jqUzZtSaYo7DVncz4Z	2410	3406	3406	1616552280000
4664	3NKScj8XssSsyrB1E5yt5BGtCzNwrjG5Mw7hC5fKvUxvkSrXZrYn	4661	3NKpbCyHFirGjvhsvbHNdAnAZCReWTqmG5dXqp6AisL1nBD4pE1R	596	1306	44	1	4530	jx1GHv8AeM2pf4xxYo8WfQ5tbovwNuvraBw7avJhoNDhpEkQrjB	2411	3407	3407	1616552460000
4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	4670	3NKPWGZxnEwpEHTLGxUpB8qKrjmr2dnLocjBNH5L1fL49D7trUfR	1607	265	44	1	4539	jxxK7T1C35KFiEj6eiKoGc5enoNhiNoEEs5BhrCFRcMrZgmQzXG	2416	3412	3412	1616553360000
4542	3NKqAKA76HCqQKziXrAjoCVR9d54ma2Vu6j8YvYMtP9TJcR9E3rV	4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	311	1061	42	1	4414	jxnR9qRoKFeZxFYDbyPgz8FzXitVsgUpQLyjX6HYUMF3cbsevFk	2349	3321	3321	1616536980000
4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	4547	3NKsCjnwX3hxwk8vd1tqQBLTYSdWKrMfMgJCyyXxWgroMnteYGKM	1623	839	42	1	4420	jwZK37UCE2tGeBzPuFeu77nWXbFjxQwpp8HVLyuEsCSW34SRpFK	2354	3328	3328	1616538240000
4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	1522	1322	42	1	4422	jxqDPESnb88BxqtXY2s2zD7Ha6n8Cb1WEw1huBJwADoYhh1aovh	2355	3329	3329	1616538420000
4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1623	830	42	1	4425	jxCzW2gvxMwmnXHpetrLb36GH62qGAdGDqDhCJSWmP28ZFf3kuC	2356	3332	3332	1616538960000
4557	3NLTh698YsM8dg9KAqrYjo9Wbs4i9Jv2nSf8pxJ4VmfaeS1GHs6Q	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1483	877	43	1	4428	jxFeDHHfoM5kb43NNKg5tg5RFVJeivYgVzQzRRkvgSPL8bPEZ9w	2357	3333	3333	1616539140000
4560	3NKhqJodQDp7qPsL4bmnNpz12jBMBbP71JRYb2EE8L858ThaoorZ	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1483	877	42	1	4430	jwbEyGkS9NsR7zLngpQrjbpL36ucErr6Hfrx2ekWvvS3BEkY2mn	2356	3333	3333	1616539140000
4561	3NLEVPJY2gYXjLE9sLtv8qHVVxFRS2We82Lxvn4e9L5e8WMAZDi5	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1503	1151	42	1	4431	jx26NidBMaK4QR6EMdNknr66kyzCHpAPvuQK3yAGY5fEkGCVAGS	2356	3333	3333	1616539140000
4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	4563	3NKNdCksDUAA9Gx9HkiTtWntCzeV32osvfawrMfFzGcrkcYpZJAx	700	840	43	1	4434	jwv77qFwhJd7UibV155ues1Ke5CEiRVFYfhh9MpxFKG8XGphd5M	2360	3337	3337	1616539860000
4569	3NLPJmgouSCtGnYddt5sXb2UP8ZS4RkUy6bMRkr3hSc2KH6enzPp	4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	1617	1288	43	1	4438	jw9D6TnUGmbqz7zwqrUaKeTFxsVQdyPs3schtXMiU3UgTZ3C4U6	2363	3340	3340	1616540400000
4571	3NKp3jv7GsV6EsBxoxiYVSr2rJjqmxfQuQGkXdMNCjcDX6CPbjuq	4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	641	1336	39	1	4440	jwzvwhhm9HFx5nJgBK9kHmLyCceqWy2zCYCFj7Qbez7mMGA8GYK	2260	3341	3341	1616540580000
4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	1483	1030	43	1	4443	jxCm2171zziWK88JmDFxChM5SKcLEF5BBWnn6ZoHjdk9GEoqSAV	2367	3345	3345	1616541300000
4583	3NKRuZzhcfCL3JE1LnzguVokvXTnBeJKv4hvzkcqCLVuxfd3H1Ns	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1522	1076	43	1	4452	jwTNY4B76sqfw2hoigznqHx7P7kinpJVDjQmNGwSVJbWkLyG4PB	2370	3349	3349	1616542020000
4587	3NKZKJBYu3u6AyGvWF6h9wB75aQMdyEWLAFBHHP6kyMCLpXxDTuX	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	44	1079	43	1	4456	jx2vWhGjWn2JY5RiHWBrVWeC7o35U3GNq4UD5WhNTsrbHMcM3Tr	2372	3354	3354	1616542920000
4591	3NKt47dn1NQHknTmtXZPSo8gGMPEJrrJWbL3LnPZWo7oJS9QswJP	4461	3NLHVvdAEjTzDkrm7GJhTPXHoE3ZiCBvNQzq73EXkmcQU7aoavmF	1627	1385	38	1	4460	jxysfR7R7ssjagEJMt459ZHraLi79CjmbFsv5ipCUuL8zz59ES5	2194	3358	3358	1616543640000
4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	4593	3NK8eWrubc6A4JkR35WYsw8unKV4CybZwC9dc4bbx3PqJwYf3RA7	1578	1170	43	1	4463	jy2PUAdZfodwtq7UDHsCoqQDpfjuR1Wx8LAi5dMRv7KmJbX1phK	2376	3362	3362	1616544360000
4597	3NLrnZUDgKV1jtqUL4SHqGiSV2PVWP77ApmD4hQkpttjy4hL4Bj3	4449	3NLr2qMKesf8CDGYJirbZ9R9vPkGhf5paZ7Xiugobh8z15gREkad	369	1066	38	1	4466	jw7puAsAB6SUkxFPukA6Lrwn2z6BKLZmS2EPc1kxRnUH6mAetXV	2214	3365	3365	1616544900000
4600	3NKQQp6TTZwCnewH41E816DsrQzApS1zT44djcSqBmoNHqyErCRT	4599	3NKk1aLjygvuxZdy35Qd6auM4FL3Q9iAoSiH8D339iK9v4h3qypQ	1460	1198	43	1	4469	jwqFTEpPyrknWUAGzhCzC2s7kbBcLAAHaPKP2RBXKFmQ5jAYGpJ	2380	3369	3369	1616545620000
4603	3NKQYRGxwp4Us4TNktFYTb3iKYR4612eLkvT3thXzQAnajdNKinR	4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	1516	928	43	1	4472	jxs9HF1iviXJdw3EfYi3MFgSDucSRYxc2rUazQfL6pr4vMNwD8B	2382	3372	3372	1616546160000
4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	1594	1200	43	1	4474	jwcCXhHALqWdUDA4Uy8D6v99cna6nuVAJCJ2vntnx6iq9pJPquT	2383	3373	3373	1616546340000
4607	3NKD5ZvX3RjtRgv3SisWGiAyztQBTCBJWBhoCLbdZJiRtQTkDP33	4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	1588	1026	43	1	4476	jwshCkuBTRd53ohHJKLT7Qp4TR7HLZYAmwwXkwFrQ1ej6AqmnyK	2384	3374	3374	1616546520000
4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	1541	1298	44	1	4484	jxqcYmqyDgRsyZDuw6HEeSaTUssnFk2JFhBHcQjQ4CQ15Fr7eaz	2390	3381	3381	1616547780000
4617	3NLnb2ArYfDdEs1dxzoThh2ATDMWWGQ7pcYZ1FwKZuxQgKb5VQxm	4431	3NKUD75LZXb1G57PoALXtF3rm81ZGxE4NByJ1V1e7hxwWjnNy7MK	576	1355	40	1	4486	jx3iWa9GeKwsnn2YBnFPcRozkZuHbBv6aTm1Y5UGV7kgoUgWB4Z	2284	3381	3381	1616547780000
4619	3NLSpcZbdqyEyREtEAEbzWShEMpVV3doTR9H6FkidWcEMEk8jvGo	4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	1624	1088	44	1	4488	jwzaTyZ5c6D2iKZfYSh4SsvASJ2CLZPZxmnGPoXuijKD5HJqQtz	2391	3382	3382	1616547960000
4624	3NKLko6ZQTqZsqf8pAd5zzYURTv9VgxRZUAfXK7w7DLfK1KQDR5e	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	1422	971	44	1	4493	jxC9QqYfi3yctnZkvk4JLs2jCMtNrQJd9Z2Lf2vzUMA8gfHUS1a	2393	3384	3384	1616548320000
4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	4620	3NKG6tmuz9VB75txDDfzv97R7CZmzZVxcrdQub6Pwigsz8y9PDX4	1590	198	44	1	4495	jwBKXD88PHppgMo6eNw6pNLebKPASJz8kw1i2YXyyUeziqM3gaA	2393	3384	3384	1616548320000
4632	3NLmNKTxtU6mEBCyy2BjMpcicdzqYqr8H2qwrxPddxei6SKeUZmF	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	470	1063	44	1	4501	jxifqztYPV4HNqE1mnQm2UijK81pJCvutJ9nj42DMSTXi1UhUFU	2396	3389	3389	1616549220000
4636	3NLgxxgUpC1GmukhNTPiQSTUP5QVa4xhnKsKNbwM5rXybAobuYAT	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	1406	1393	44	1	4505	jxPphtmUGftGcBGct8KeGBoCpmN5WtrzqbdMDsj6jWu5TPbzB4v	2397	3390	3390	1616549400000
4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jwHqWf4CnUtdFazimxTVCjRUAqasuwdCv8chwWkpgUopYoP1Usi	2399	3393	3393	1616549940000
4641	3NKV7maY892S5mAJDJtbqFMiHekpCpH9sMqeEnfjS3KsQDGDNHny	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1581	778	44	1	4508	jxJjp8NCXGSPg6ebDDNcsP9LQp4o8x3BLdEZXZstUXZGVQC9E4G	2399	3393	3393	1616549940000
4642	3NLBhXqzvJvrmtyBPzV2m18oMarfDb7itZXU9Lw6SZJFFt8md6ax	4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	1610	1314	44	1	4509	jwrgSq1gAumh8CpMKTMoX7C6An1hocKH7RZ4KHoBDuBH3GpSCQV	2400	3394	3394	1616550120000
4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	43	1064	44	1	4511	jwgVBpRQ3wqFfKbHeZYaxKRWFRDLSEymhVr4qBQXzuqPU3Ng6iV	2400	3394	3394	1616550120000
4653	3NKYCvT4y6niHHD31LfKZDk23NnccwdEnQZ4ba82R1jkDn18EM2f	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	1405	851	44	1	4520	jw8nugwnMezSL96Wwumvwb6H5qq9XfQ3CrxAmLAbXyXYDhCwD67	2404	3400	3400	1616551200000
4655	3NLZy6Q4sRvwcuuWwH7Wvrki7Qk5yNVKd3e4KSLvFEnDE8uTqbRB	4652	3NKDsSds3uUfk9qrYBuJAxYjkqLJ5qwrmzScAEhjhFVP9TKmfEWE	1447	1345	44	1	4522	jy1292zb7cEcbwzUrGixa3wASerBcJHp4r8ZUomRof6Dsuy6AYw	2405	3401	3401	1616551380000
4660	3NKh9QAP6tpyZFJjNCwLYmCLS2Cg5kJYA8gkY5J2JGDnfKx4B7Tz	4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	470	1309	44	1	4527	jwrTv9A2VL1rGLhMXKqXhjyi7DdadqDcFjoThNYcyBCmqkucF7J	2409	3405	3405	1616552100000
4663	3NK8Fy9eCRAXGaTmWyMTnWtHSoasxw1agCu8FFQyxW9Yw5eFV9Wj	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1401	4	44	1	4529	jxrgCCz6NEwhLRhFLhiiAScYWqtBMWcHNH5zCe8u69Fp3upDUz6	2410	3406	3406	1616552280000
4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	1650	1249	44	1	4533	jw9oDMSec35rBz8ZCekootNzcq9dqXb94gSbrL6kteHiZKRPgGW	2413	3409	3409	1616552820000
4669	3NK95vjPDap3FGtVFRsJGvbasLw7HcfzxyCSDCc5hjbBKm6JHHi9	4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	1419	814	44	1	4535	jxcj8dZSJEVTHjofx5289dwovLMxbaFPkbGZuW8wNoGu6P8cwkf	2414	3410	3410	1616553000000
4676	3NLYjBw1X4zVjBHuEdFVPZv555Zdv85hL4dJqzoG4FVsHnoHso4H	4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	1654	1340	44	1	4542	jxSZRd56vvDmmTYnGgM71367a3CPdjjPJcGWd2HL4PHHdoZYVMh	2417	3413	3413	1616553540000
4680	3NKpwLBZx8NduqZXWHvFL49ijSub8kNSDuGDtdzc91LigadDcCnn	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	58	1035	44	1	4546	jwaBcAiYzD5zi2oiEA8smExCHzNjyRbBYnYPJpxboQnBU37sGFS	2419	3416	3416	1616554080000
4686	3NKvN73M6sDz9ErRExwkfgTG41LivAcStkVWxVC6nRX1AiRhQV2a	4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	1564	1338	44	1	4551	jx7LtMddKMy8VjeCptcGefsmosTNA1uuMm9A4UatDrou8gsVDzz	2422	3419	3419	1616554620000
4688	3NLHLS3Qp2FbawYDNW4YzPua33ESPn9uMWBWNn98noLMWqS4NBWS	4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	632	1136	44	1	4553	jwfCGXjHYcCAisv281DGKFmZhGxQQUnJAUKh1XjBJ4UWxg7opJU	2424	3421	3421	1616554980000
4691	3NK3JsJSqMdvyyVfofbYAZ1CqgkE9FsVRPPyuF2uujbxfuiqHDrH	4688	3NLHLS3Qp2FbawYDNW4YzPua33ESPn9uMWBWNn98noLMWqS4NBWS	1529	1190	44	1	4556	jwSygVUdZjzByvQ8aFNUEJa2LHdxbfGg7AA3mi4d61DXUAmANdk	2425	3422	3422	1616555160000
4693	3NLxDQV2Ps9SxUNNnr8UZkTvXauJrRkw1rdC5HNJXJrrpFM9iiFT	4591	3NKt47dn1NQHknTmtXZPSo8gGMPEJrrJWbL3LnPZWo7oJS9QswJP	1627	1385	38	1	4558	jwJuNKo49qyFmSSmSQ2yxY6smist79Sf8yyysyhWeLaHAs3VyEr	2195	3423	3423	1616555340000
4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1406	1393	45	1	4567	jxMi1tgEeNo9Hbm37XQ5Tyr9sdpausBuR65k87VFekJJwRdKJGW	2431	3428	3428	1616556240000
4709	3NKZ7aRomk8TRKB8BpoHvFMqo1cEFoQoQ6qxUQ5uHjHWw3T3PbDL	4708	3NLtjfZQqcdBgN5JudGBf6pa9N4CjeBQJCqBk1k78CoLvmCBf3FP	1600	1246	45	1	4574	jxosHjQqMK1EiSsHqMuy576REKPLN2jYKWgMgPXZchFQumLWdmG	2434	3432	3432	1616556960000
4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	4709	3NKZ7aRomk8TRKB8BpoHvFMqo1cEFoQoQ6qxUQ5uHjHWw3T3PbDL	1646	1108	45	1	4575	jxNgjpVP2QVZCxzuY2BfMQLAeURsCeMMPVHcjvomD3q9Kz1WrKp	2435	3433	3433	1616557140000
4719	3NKbFW7vHxu655nDJZduYqebQjqFSNVDdiyD69YAmJ7MbeEgTGCD	4718	3NLaQvFP5cfa2C4s5XM3LH8vLBZJscky1dyad2L14fKrBMnCoT7h	1403	824	45	1	4584	jxKNqH5S6nSe2TY7zE4F4kP3p7jamTA1g6e4yKL7pTKogwebT2s	2440	3439	3439	1616558220000
4721	3NKnH9gUpbt4qznar9PgVdTMsSPAR7moYxwiBL7SqukKNA3Qgu5b	4720	3NLV36JM6RWeQyGKewe9N1PWkyKMKNPwREYmSba78Fu25xVSjPD1	1671	1239	45	1	4586	jwt8SVdMtAq6V6QxQrwwoi2LBotJ8smQcnRGzc9vKyzJvudmgSp	2442	3441	3441	1616558580000
4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwLHrH14xRVB4trPeZvcdE3tg3xtZd5X7EPGy5p3d8vUVYQh9Jj	2444	3444	3444	1616559120000
4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1560	1291	45	1	4592	jxe3eJXyFaKYCkQRcmf3pHTtnT9beRpPaA8DY3V523Q91DqCFTW	2445	3445	3445	1616559300000
4735	3NKnM9w5ASAbBYEmKkG4ToTNKScofxK3iFa2BYGtaHWt8e52ouXm	4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	1536	947	45	1	4598	jwZYvjpm1LX2nuQBjBWczoKGAFQDsn4ocmwupNGJpriFnxnhFni	2448	3449	3449	1616560020000
4737	3NLBGYtPGoM53Y2L5h6Zp9a7zEnVF6C8jBb6wuw9y5YyLUYcbq8M	4736	3NKiuCkwVYzh6hgnv9kVqBA2qxgVG2ZdZvf5aM2WgjUKNwhhJWfD	1601	1262	45	1	4600	jxfzBQXsbYbLaPayaAuxsymU6wnEFUP7moSTNmSXRDiur6tppX7	2449	3450	3450	1616560200000
4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	1440	1251	45	1	4604	jxL7jkn4m1qJCBgxPYz156UxHAfQTxA7aGQdyqeVhHX9Q6uGsv7	2452	3455	3455	1616561100000
4746	3NKdotfGqT5ZSeLZi2JxY2Gcmj8QgJSEvZJyjmd15uFgkUjr6xsS	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	576	1355	45	1	4609	jwZ881y8fwgXtej5bVo4f7BoZmqQqBYVV8rAQFzwKdvUR9f4jQW	2453	3457	3457	1616561460000
4750	3NKwMHEGKsasUE261BxR858Ukk7EAdGqB7QEzhu1yX8op52mqG49	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1455	1332	45	1	4613	jxifEzNGCnbqE2dHCVxLS25ghGDrnYawEAj1r885qQFmgLv718F	2455	3461	3461	1616562180000
4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	448	1305	45	1	4618	jy18rHBgBQNK5n1txd3C7xoDbZc5x2JGkJ9iHiaJsXx5x5M45bt	2457	3463	3463	1616562540000
4757	3NKdxzwF49qGJnubn82CMtKTwVuAjV9Fkdd2U8mR4Hqrg5WCXzhy	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	606	1295	45	1	4620	jxpQErG3vHRkpDdQ8nvSsxVNc9Nu5qhpJE7bDtQUQ2ixVmYHqWH	2457	3464	3464	1616562720000
4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	4756	3NK5wKwCVAPvsDV3QBH9Ez9VRGuNXSaZJnt9v5ohVMjphA3i92Ga	58	1035	45	1	4622	jwLdh7vtyGZDmMCBgb1YtwmxEmMLJm3q3QaxUTxMnEnAstLiGNF	2459	3466	3466	1616563080000
4764	3NKWoc5hC2ZAYuocZxVQPTySXuM4mGUUwYAbiJcnyKdnFqXXcKSK	4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	152	1204	39	1	4627	jwtKFMY95RdxatHMP2VeVpTRYrMFm8aFw5qKSmcjATZbwFogxNz	2278	3469	3469	1616563620000
4766	3NK6SkpQwop8eVAr3DzFFAJRyEpThb7FwnLd3dGPFR8d1mvM3hfG	4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	152	1204	45	1	4629	jwwJiX4zMhr5fHjRBDbquCHFPGw8sA5guKQSq1SSKsaF9SEJAUx	2462	3469	3469	1616563620000
4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	1555	1347	45	1	4632	jwkhTTokd34ujnLC22sV558zNgzkWSXQPBGCvEX3ifqScpUhqSs	2464	3471	3471	1616563980000
4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	1407	1395	46	1	4637	jxez5mYQ2fyFhQ3bDdYkwARH4QuX8aqrjoazJrsBX4VTNiheZLc	2467	3478	3478	1616565240000
4781	3NLgp3x9L3YT7BCoZN1ajpmGWYX5VvWuTJkTE1XJsR8zM5kRAs5Q	4779	3NL6HqBYgPi3qwmaGsqRU4e59qys1tzA9J4BzBUcAfWU6REPpK1e	1547	1378	46	1	4644	jxMUg6cgBDyNTDfMCTGcpb3tUuAAAqvdfFxXF9cbPuf9L1pHR3o	2470	3481	3481	1616565780000
4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	4783	3NLNMu8a4JeCXuEQ5LyPcB4rYcwZnohsmhSPG5EKS6ztLkcFKBys	1637	816	46	1	4647	jwHmAYWBUxjqhhWMb2XeLUTgV6eZwgcnawPX3Av2oEo5bYwtYck	2473	3485	3485	1616566500000
4661	3NKpbCyHFirGjvhsvbHNdAnAZCReWTqmG5dXqp6AisL1nBD4pE1R	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1651	935	44	1	4528	jwqtj3padgN2HZS352aZrqcPfjJmmCRFXAb1goLCLdYSWBFBJ6m	2410	3406	3406	1616552280000
4666	3NKdbu5AVvWs15DzY2kqdct3vStQzu2iPK8AE2DZor7ryHf9VRRf	4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	1547	1132	44	1	4532	jxP6NthNm4D7kH2ALpT9d9RMGgkyUqYMu3J7twYU9EntJkGkkPQ	2413	3409	3409	1616552820000
4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	1407	1395	44	1	4534	jxnYdPBDjnzKW3k213cHxFaqFdPRXT46s83aXrWVmLbAMvFAc1i	2414	3410	3410	1616553000000
4671	3NL4SBxYBMhmhHFJ4GjtphnyxiySSJvNRjYN1aBWJ58n9MJbSEdR	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	1637	816	44	1	4537	jwTXxQhUfe38cKDqB64wTukPuWzjkxzJwnZ7vWhBh1atPVvdPnJ	2415	3411	3411	1616553180000
4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	1637	816	44	1	4543	jxSdEGfMN691ZcT9naQJhtTECnRrWdeAE6rfwUR4dshwReEWqMS	2418	3415	3415	1616553900000
4679	3NKPKLNyh7aJw7957LQNazmTLbKujwxhFnCeiX28oYXGknCwazDt	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1670	1156	44	1	4545	jxerjPHERw6msVsqYAmH7HZqref8WpA8rDf4j2g14XrPXXwaSDo	2419	3416	3416	1616554080000
4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1594	1200	44	1	4547	jw8hrCd3GKR3Fs5YZxQewS9V9ysmFJy2RdfVRQwZPgP9EQqT8Es	2419	3416	3416	1616554080000
4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	1580	423	44	1	4549	jwqZCbsLWahCxRWyUtey8hhutxvMjEg1ehHY6ytL4CzCQ7wriqZ	2421	3418	3418	1616554440000
4690	3NKSkRVCiLdxiCTqSBropcCxYB4FUZvxbk6FUVzMvtwFxGoVqeR8	4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	1529	1190	44	1	4555	jxm2bC3aKi2gPWQJ6fMTa89agEdVJhoSLKQ8FAc34mUhrBrP1Pb	2421	3422	3422	1616555160000
4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	4695	3NKQVrWEEqVxAQXF9Rd6Qt2nv9cKpyDt1ntvPGhajfPFbSgnSCRB	1513	1253	45	1	4561	jxVteZHmrnnpo6iHMn4QFQm4WyuuZAfuNaZxZZDeicHHno2c9Y3	2428	3425	3425	1616555700000
4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1536	1187	45	1	4565	jwLLEGnTepjto2Y9qZnBVpWeLG6zciqTtqWTVGF2mtiCfDHcCSj	2430	3427	3427	1616556060000
4704	3NKBfVn5btWSTVQBn5ujV7h1SwoiPtdTGu5Fr8wJ1VVkX6u6NjTe	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1624	1088	45	1	4569	jwH8U6EXLHnaPKhWGRdLPeNyRQryxrwj14stZvn5tuNkESay8Fy	2431	3428	3428	1616556240000
4706	3NLRxv9RPQWXbP3U8Ln3bubnRv4U79vWDeYKeNUXu3toUK2ha6yQ	4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	1509	1320	45	1	4571	jxrxYGrQ32dPNSRFJFbvZZKWdRHbEph8haUqJ1fBz7sjJ3Mzpmf	2432	3429	3429	1616556420000
4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	1656	1097	45	1	4576	jwtimGabsA27CJA17nisN21dauSyH4s8PBFziqJLfoqjJ1mZDgm	2436	3434	3434	1616557320000
4715	3NK5ZKGiQkVWNimQiDUTw85PKnyikHh1D4bJ61FXZMSTsTErGhGE	4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	42	1115	45	1	4580	jx4i6gqFFDzCfxrbvi5Wbk7gGbXWEtBNgyLrbWeahnf9e4Den6F	2438	3436	3436	1616557680000
4718	3NLaQvFP5cfa2C4s5XM3LH8vLBZJscky1dyad2L14fKrBMnCoT7h	4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	1407	1395	45	1	4583	jxz7SAvAA3cczvyxZwqmRVf2A8u2CL5Eb9TsqsyNuZBVrhnLZmz	2439	3438	3438	1616558040000
4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	4721	3NKnH9gUpbt4qznar9PgVdTMsSPAR7moYxwiBL7SqukKNA3Qgu5b	1500	1171	45	1	4587	jwRL3af6kL4mb1jmG7kyNt2KoathSRUtEavPzuZbpnikrqWy2MW	2443	3442	3442	1616558760000
4723	3NLbDCuZMiVvceaWrWmWhmRe3Sr9HvBnmVgsNGxbqkmR4Vu6bGXD	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwvH2eBaVRdJCnytPDzGrGoPkSKLFpmtoJGRump2vLGNnMjCNW4	2444	3444	3444	1616559120000
4724	3NLPunYkyfkjGWyatCaGNgezzk3u9k73JZy4hU4k5UP5iK4bvcJg	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwUZQfheBfFNxyXPZPQw8Ku5aFotme4zWUbbvfwsJbGpDcDtCWU	2444	3444	3444	1616559120000
4727	3NL4nNx5A38mYYe2fcj1WR6eXCzeXG3fSTkKwvzqcReF5wK48MmY	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1483	127	45	1	4590	jxEtthZZeHJSFDN9gvtTSty4ArUgS4MjgysLSBbH22kW1yedgPv	2445	3445	3445	1616559300000
4734	3NLF2ggMCPKsDhjWNVf6Y74eSJsP7HswgNBWb2LaF2yhCD6i8ttB	4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	532	1177	45	1	4597	jxSvXVEQM3FrQJDz3Qk6vVTqKgbTKpXzc9oYJFFyb7TYB8mefAR	2447	3448	3448	1616559840000
4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	4738	3NLv5Af3Apgja5Y7qRydmbxL2xaaKrnHeFuknssnhCCuRoXDZaFp	1481	790	45	1	4602	jxuRmosA5P2wpKCt3sT3J2pm3xpDZV7P7HmTa82ed5ZhzoTJPdL	2451	3453	3453	1616560740000
4742	3NLKXpVuFj4fdzJ6N2sKovhy9WUP5EpQWZTKiDw5dSUBfyb5kjXt	4713	3NKfxQhuuikDxMAwLY8Z91sqiqvJeG4CPFJsnQV9VWx5gWsnpeS9	1489	1134	45	1	4605	jwrwTwT2fFikBD5KPBjmgyAeuCEzPuEZP8WoUMQZruUTAU57H4s	2438	3455	3455	1616561100000
4744	3NLR3x7ED8F5VPnuWsWTkZmhHY71MQ8hMXogdNjCNw2BiJFU3ukW	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	448	1305	45	1	4607	jxCNmPbCjNQKVe2Gk74hTWneryyZ8aS26jcG34KWaBrgzqQEKZq	2453	3457	3457	1616561460000
4752	3NKPhYqU3ZmoUGKjtdgc9aCxbRz8QpTVGpZNKFAefMbnzPJkYVTD	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1513	1253	45	1	4615	jwpzRCzzRQXKAuJZGBW9SpZi7DSuYFXN7zLHEjVDP6YQHDK9hLs	2455	3461	3461	1616562180000
4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	4750	3NKwMHEGKsasUE261BxR858Ukk7EAdGqB7QEzhu1yX8op52mqG49	1458	1077	45	1	4616	jxummvYkUxUZXhb2bMPgKuDKRca7qEdtQM4KheSs1Yy2sMzoegn	2456	3462	3462	1616562360000
4758	3NLsi3WG4mgsXZ3XriwyeUAhXqwDJEVbQZmvHBfCSFXpnwqa3rUp	4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	606	1295	45	1	4621	jwruFuFXDBxwyuYXCziuhJ3TgTvUZ1BAwmML2P19pWFuB5LJsU8	2458	3464	3464	1616562720000
4761	3NKWdQYNVkC5fcLEvbnkVgBTTAZWD7Aok3F4uvjTyAWuSfNBmrdf	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	1406	1393	45	1	4624	jxd4aMxVFBJZtSdQ6PtLiY2fwXj9EhGZJZYUYVAAD91duiqxcZy	2460	3467	3467	1616563260000
4765	3NKCkZ6tpoVwXizKM3fWukqcHXNeNRVAPnmh7FTmk3Ea8qtpRkwP	4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	1406	1393	45	1	4628	jwEWz6XsMf76JVxaUPKexgLZn5TWpsreypBzsoxBUoW32mPbbxn	2462	3469	3469	1616563620000
4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	4766	3NK6SkpQwop8eVAr3DzFFAJRyEpThb7FwnLd3dGPFR8d1mvM3hfG	1631	794	45	1	4630	jxvyRAcXr9ifco2pPoWWQ9zeYWNd5fzHP9dukqbuwooYFJb4HQR	2463	3470	3470	1616563800000
4776	3NLM4kz1cEVLRAmNmbM35P5UoziSvgEot8zrMa1zEem7mZPxC8Fy	4770	3NKeEiUnDuQ9KYEJACxdJTDMcpz7F5dJ1yHMafugSWuL37BXJWkF	1451	1166	46	1	4639	jwojzkuM2CXwJbT6QrHPdn3hJ7y66G86A4wzLEy7Rqv4yRR7sRc	2466	3478	3478	1616565240000
4780	3NKqVuhYd3ipXLZPKUcwoAoPN2NcSjb6UQXvwNNFzF8xqvB7iCng	4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	1422	1337	46	1	4643	jxwCPA8BCKNX9gsRiwdeuawcsYKZ1EQxoKk2RBRGzgZ72aFAN3s	2469	3480	3480	1616565600000
4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	1447	1099	44	1	4541	jxDPL2HTAs5a6a61Rwe4GDVhdTKs1kk6td6PHY5dJgKtyyKdtMh	2417	3413	3413	1616553540000
4678	3NKKTK3N6nSN1JfZ23No45sHFoqJCSUkA5nX1JSpFd5BAS4CfUjr	4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	633	1138	44	1	4544	jwTkpKShLCMGUkqtfJ43nVj78CeDMZCBCqVkNbWfK3TapyCFrUA	2418	3415	3415	1616553900000
4682	3NLiRdHzL6NPPyMm1ESWnbc2sNUUr2oZsZyi1ASexC8uDf7Zu4qu	4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	1651	1301	44	1	4548	jwJXXXA1Dqz26bVB25E9o7h6o5h1UrFPrswyS4yJxHXrnwKdh5E	2420	3417	3417	1616554260000
4685	3NKnV9okgn5rGGmS667g2kp5ikSrHY4yZb8b7tXGqdEmPsTrTq1x	4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	1406	1393	44	1	4550	jxn4zPbKDB7EDXTbsbTqyLJT89NafZQM4CUjBEjVxNXVhSfdfHb	2422	3419	3419	1616554620000
4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	4686	3NKvN73M6sDz9ErRExwkfgTG41LivAcStkVWxVC6nRX1AiRhQV2a	1506	1127	44	1	4552	jxLi5q1D3tzYaPyKWMtGFxZ93Td6bET5PpnCqELjmLjP8madGvj	2423	3420	3420	1616554800000
4692	3NL7Ho5ywVpXZQbKqnJNVkBMy3com5Nx8viriKUnBSWY7g1RXJPa	4691	3NK3JsJSqMdvyyVfofbYAZ1CqgkE9FsVRPPyuF2uujbxfuiqHDrH	149	917	44	1	4557	jx5KAM43HbwveBddeyJ45JtJpy8oc661jt4wcDDvL4HKEZY95pw	2426	3423	3423	1616555340000
4695	3NKQVrWEEqVxAQXF9Rd6Qt2nv9cKpyDt1ntvPGhajfPFbSgnSCRB	4692	3NL7Ho5ywVpXZQbKqnJNVkBMy3com5Nx8viriKUnBSWY7g1RXJPa	1622	1110	44	1	4560	jwoF9bduQ3X819veVcqa4SdepTPXqgGctAtY34tNUwXHkX3o7hS	2427	3424	3424	1616555520000
4701	3NKuvbgewmHPi879EmEvW6bj94jYuMua8FQ9y11e5ayP6caYbd91	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1631	794	45	1	4566	jy2MYaKY3udr9TwcBSobn2SjWwuAedWUAUU6B8dHR1tWEHFcqxz	2430	3427	3427	1616556060000
4705	3NKaPvrF47z9FVyKaAJv2nux64XNgDvmEV4ciCv3g53tHU7G3jei	4662	3NLSutyoCW1QsuvYmrV2Bbi7T5B8HWYWBHzC19dLcxKXdQ2AwwsJ	311	1061	44	1	4570	jwoYeHz59AxXtBkE4s8kWpARgdtTJtx6DLSzdmeVofP6FjWjwFG	2411	3428	3428	1616556240000
4707	3NLUnLigAfpZDyzqMR3W5kRrbbF6fAf1cTZB3i6BvdjL9eYZFXkF	4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	1672	1159	45	1	4572	jwdKrPJA18dLRiYfjF4j1dPZ4EpBrZTMV2wyvWBCHQBS6aoThTK	2432	3429	3429	1616556420000
4708	3NLtjfZQqcdBgN5JudGBf6pa9N4CjeBQJCqBk1k78CoLvmCBf3FP	4706	3NLRxv9RPQWXbP3U8Ln3bubnRv4U79vWDeYKeNUXu3toUK2ha6yQ	1406	1393	45	1	4573	jx47qsQWLRSLqWNmWKTmqqwRcumyZrjDoFUduYaTBfc7UPs4SSt	2433	3430	3430	1616556600000
4712	3NK5KGeKgMCEjkmhwwtF9sQSzZeteabkM2TWyjZp4GQVZAaKNV1m	4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	1573	1318	45	1	4577	jxoz8qEvWmLD6iyDPdiGu58KTwiwMrQwuKB3bHY5s794FMV9B2n	2436	3434	3434	1616557320000
4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	1654	1340	45	1	4579	jw8XTv49t7JGnv2GyFcekLTSTXngdGeafg2VinD9WTfc5cbwy8h	2437	3435	3435	1616557500000
4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	1675	1342	45	1	4581	jx5ieFXj4yhhWh3Qeqh21rtNCLbEKBULB5FrMXBsZmwRBpuJfTJ	2438	3436	3436	1616557680000
4717	3NLCBrAZ1zMpvbHL5bfPhCHninuvM1W18nGcxFeiftNHs7aEtx8E	4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	1406	1393	45	1	4582	jxSnFmUgun2rEgF9Tjax9eVcbYJZ6WETq3w4fNjo6tJaXW9zrku	2439	3437	3437	1616557860000
4720	3NLV36JM6RWeQyGKewe9N1PWkyKMKNPwREYmSba78Fu25xVSjPD1	4719	3NKbFW7vHxu655nDJZduYqebQjqFSNVDdiyD69YAmJ7MbeEgTGCD	1593	1100	45	1	4585	jwoyr6eVzrcmEx6c9fLRa9nwXX7CBjiEBHXjnyXFfzSP3RWjPTw	2441	3440	3440	1616558400000
4726	3NKH5SThcLgCQ5U9EN6mjgyHMRqz7PXrfgQaLmYD9JjH8nN95Uw6	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	532	1303	45	1	4589	jw7wcMsdKQQzR89z5M9KmsVzVQYMHEM5ynqm9w3cWr6JS8bGRgX	2444	3444	3444	1616559120000
4728	3NL8WnUnPiVQL35a7AXZ6TsU5Ry1FzM8JnT2VN14F5382DApSxNG	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1406	1393	45	1	4591	jwEWtyMXYq1JgSg63aBABuPx9rLReuPGJjkPFXxnoDym5ti2zbf	2445	3445	3445	1616559300000
4730	3NKAgjdYQSCFKLAtpia3dMW9E6YWAPoDS3U3LYoDbMgorXuRxTE4	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1400	77	45	1	4593	jwXiEvvkctNj2GmpQNNSR3gYRJV2th5tkfNwDy5i2SLbfa8RHbU	2445	3445	3445	1616559300000
4732	3NKNvNQTWGaCqx3x6d64ngXrLEXUAnqwvbET47jufVs1NbmhQQhA	4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	1646	1228	45	1	4595	jxn7PTpVZNut5RhBitxMwkP4LidMyc8T6ficvCqTfe1XwJVevnn	2446	3447	3447	1616559660000
4740	3NKGyyTDK1CkToMy9QvvFwBUCHMm1zXagvMe3FaVpYMQzd2PWFBq	4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	1489	1134	45	1	4603	jwYkYwwTTTNv3WXG22e5avpsSRJ5CiJKrxh3hsmfd1nAsAxn99M	2452	3455	3455	1616561100000
4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1405	867	45	1	4610	jwD4iHSBQQsYsHicnfJrQ5oD9NwpGdtGxbBqicgMGAPXwFVc6n9	2454	3460	3460	1616562000000
4749	3NKFeAQhHEoVdbfRRbHr79X5qAeW35fy32aNX3AxnBQh6bpak5uu	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1534	1317	45	1	4612	jxiysVqzAcxnEgbrS2TVDDXXQBo3KjZnfPR7kr4W1PeAcbBQoZ9	2454	3460	3460	1616562000000
4754	3NLpW4yQF4CbqX2qTBhwpEsvbkCEYyKtafBhXU5q7TWUH8KQbv9y	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	1564	1338	45	1	4617	jxtaqpBgB9iNjBZ1SZNqi2qhV9MxwBdBwVjxVczS6Sdzoa9YFDv	2457	3463	3463	1616562540000
4756	3NK5wKwCVAPvsDV3QBH9Ez9VRGuNXSaZJnt9v5ohVMjphA3i92Ga	4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	1624	1334	45	1	4619	jxSubSgHrRcsNX7SaFR4AqF5CW43uwdBjZLCGF4QBk4r19zmyBy	2458	3464	3464	1616562720000
4762	3NLZ4TNeGaD7GqR8QtcuDhhsRub5mgKQPADDZZWh5uxAMB6cNDyj	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	632	1382	45	1	4625	jxKoYgFfmo5ANqMNFyeEpN12x4UTQHUiErgVbCnTGGdHXeKfhic	2460	3467	3467	1616563260000
4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	4762	3NLZ4TNeGaD7GqR8QtcuDhhsRub5mgKQPADDZZWh5uxAMB6cNDyj	1673	1368	45	1	4626	jwu17E4RXvD2Lim8aTaaJ89Z5V2evzycXiv6442PCjaEgrsdpPy	2461	3468	3468	1616563440000
4768	3NL8xd5e7X5qXHkaAt5TYFdDUxJqVd3ipigvXDZpC3aKKMKzMcJ2	4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	1407	1395	45	1	4631	jwYcc7n1RFjzdT8aK4KYxtFc5qGnLn71iVxmbdHfGBpxHsPsDft	2464	3471	3471	1616563980000
4771	3NKXfZzhGHfjBu74EUScTKCXxWr6JHdEuNN7N1zYZtkQe9ZWJMVw	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1631	794	46	1	4634	jwWfYEUq5MrnoTrxfs2ZfB3qV3om4MXJQDaFKrsCuUiUoXRrxUT	2465	3475	3475	1616564700000
4773	3NKkAromGQLVG8PckahQNCo2Afs2wZJhiM2F17NB4SnznawcCaE5	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1616	2	45	1	4636	jxe62fR2ZjWDrMncx8zene1FnMajZPGZz4oD2TXByJZdFfBfdLG	2465	3476	3476	1616564880000
4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	1426	1118	46	1	4641	jxh5yDZfZPzB9svP8sJjtNNvKvEJJqp5jSRNaNiueUJ2wXPJhhr	2468	3479	3479	1616565420000
4783	3NLNMu8a4JeCXuEQ5LyPcB4rYcwZnohsmhSPG5EKS6ztLkcFKBys	4782	3NK7dJ4CPHo72UP1NJG3L5RaGosYFYC43Dh8W5CB1TnMGYV2DNKP	1560	1291	46	1	4646	jx4bMvz6TEAGykPAxepvwtZomeirYAfqEYPNdYAtyecBkje38hz	2472	3484	3484	1616566320000
4689	3NLDHWVj9kRXDH3B86k3CTbCeTCe6QuZPnnUStTH3244RcTMfvWT	4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	1637	816	44	1	4554	jw8c5cHjWNjtdWj88kmYsHLh1HfVRHW64DXx2B2RTkQbNgc1LHU	2424	3421	3421	1616554980000
4694	3NKV7BkTV64aTDKAmR47tPVNAFc2qGayBRaGM6LvEUR1wq7WjnzB	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1622	1110	44	1	4559	jwJQgh1Gqyg1Du5dTHngGw7xHHuNP7qoWYFrTa5GCT6ywtZSKQw	2419	3424	3424	1616555520000
4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	1397	838	45	1	4562	jx2xJ2T3PCm51fzm3qbJqQqbLjeNjXuaELnYq6gUHUnonLCRrvY	2429	3426	3426	1616555880000
4698	3NKzQ6onHmKR6L5y2U2E7jYBoq6HbeRLmczotwBxWbvFp2quxAmY	4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	1649	1383	45	1	4563	jweqmaViW5Hz8szyunUULGNXeFMrvXvLnqvZtje1xjZDZACFb9T	2429	3426	3426	1616555880000
4699	3NKNMEe7UJjkTJc1bdeZ6SLb1KsmKGFGwNzLAyLnzHBPcxQQmgBW	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1405	873	45	1	4564	jxha76FoP6oUqKBD7vS9MgPDPQSFWwLCumrGaQC828rFW76YUKH	2430	3427	3427	1616556060000
4703	3NKvkqPYVyN9HTcRjaMVL8D2BixvMQu52RTMxBmMPuaLELosXwe1	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	311	1061	45	1	4568	jxstcygNwiRykKERQnn9gthvfboBfuE9hbHS73nryJp6UUsysUU	2431	3428	3428	1616556240000
4713	3NKfxQhuuikDxMAwLY8Z91sqiqvJeG4CPFJsnQV9VWx5gWsnpeS9	4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	1637	816	45	1	4578	jxYzNXssYxibCimu3Angasj2GLrJqjJhgrzrbUVLuHDSeWiWBGQ	2437	3435	3435	1616557500000
4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	1458	1323	45	1	4594	jwfeWkVS2uwn4H2ndgekVgVooMz6AXAy4Notyh9XztBqBRrYeTt	2446	3447	3447	1616559660000
4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	563	1359	45	1	4596	jwvFzb64Z3yLbmsfS9Zk3Hhz5WVhSUDNJwyjf4MhvfcSJXVLae4	2447	3448	3448	1616559840000
4736	3NKiuCkwVYzh6hgnv9kVqBA2qxgVG2ZdZvf5aM2WgjUKNwhhJWfD	4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	1534	1317	45	1	4599	jwt8oCDF5tFAW3TrGHqXZCNnbQ8kzDkNqYHZtrNy6rKgAZP2rL3	2448	3449	3449	1616560020000
4738	3NLv5Af3Apgja5Y7qRydmbxL2xaaKrnHeFuknssnhCCuRoXDZaFp	4737	3NLBGYtPGoM53Y2L5h6Zp9a7zEnVF6C8jBb6wuw9y5YyLUYcbq8M	1402	852	45	1	4601	jxCEcPAUy3aRUrUGGwQfSUMzgh8ehtmNZKfi27ogvpQqKnWXBnH	2450	3452	3452	1616560560000
4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	1406	1393	45	1	4606	jxiFdyb6KMfgh7MQB1ZSuxC3bfkbNTMcdPGrYkDmLYgvrkCn3YN	2453	3457	3457	1616561460000
4745	3NLdeFZimMRp7ozYyP3aJoumtKwqvBBfNfXbMNeqr5Ekr6Tb8KSM	4617	3NLnb2ArYfDdEs1dxzoThh2ATDMWWGQ7pcYZ1FwKZuxQgKb5VQxm	576	1355	40	1	4608	jx3iWa9GeKwsnn2YBnFPcRozkZuHbBv6aTm1Y5UGV7kgoUgWB4Z	2285	3457	3457	1616561460000
4748	3NKZy4SZMfkLwrw5rghs5ximZSmG1EYM8eYEwrqwjqF1srur4DGK	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1564	1338	45	1	4611	jw9g9ANb95H1wbLq4yTtXtdfVYy8DqFpMBn5Wx4fvsUWtnZmALZ	2454	3460	3460	1616562000000
4751	3NKLYRSAwAsvR6bdRVUSe5eEa3pKGrhByfw39eWc1RhoFeMyHP7Z	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1402	842	45	1	4614	jw6dxj7dWgF2fEnXhqCsr7bGPMDgJENQ3XnXrHJoKqwvvUsib1o	2455	3461	3461	1616562180000
4760	3NKz3vz3Sw3s5TkgPUTBi3C3Pd13HJcux2zMBEw6MGwp4NCKxQKr	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	1509	954	45	1	4623	jx9Q9wERjAb3V6dGbrb581Ts35stLGB5cWyxyEXmaVMogsc1Nhd	2460	3467	3467	1616563260000
4770	3NKeEiUnDuQ9KYEJACxdJTDMcpz7F5dJ1yHMafugSWuL37BXJWkF	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1407	1395	46	1	4633	jwjjiyNyCrYMC4P7727SjUeueXyMefM5etoV7Jxe7VmNNvcxiy1	2465	3475	3475	1616564700000
4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	4771	3NKXfZzhGHfjBu74EUScTKCXxWr6JHdEuNN7N1zYZtkQe9ZWJMVw	1402	862	46	1	4635	jxzwkN1AJDX7v2pPwmsfXfo8S8wt1nsn3E7w9VZtQGQ9nytiMCH	2466	3476	3476	1616564880000
4775	3NKR1CQxbgwjPUbLTSAiwXCxJ9ji3gDCCWZv8hFBdzFKZdrgbTVi	4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	1451	1166	46	1	4638	jxmE4cbBLYbXi9ZSqohfcawVuQ41t2Mt8BY8gf2Nid1JiFLfddx	2467	3478	3478	1616565240000
4777	3NLVwVYsrjYhRJDjz3gem16tebciC8K61DFMpxmdH9qnEEHLBJxB	4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	1458	1077	46	1	4640	jwpu2aJk1jrf2yVkcXtUA4dm96Wm3cHUtwJ6dZjUQTUt3b7fKb8	2468	3479	3479	1616565420000
4779	3NL6HqBYgPi3qwmaGsqRU4e59qys1tzA9J4BzBUcAfWU6REPpK1e	4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	1403	824	46	1	4642	jxAZxvgyFvsyThbDf1t3Ayo2LadH2KrQx3deeKjQDeyY5jkzY7d	2469	3480	3480	1616565600000
4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	4786	3NLA5N1i1R4AyuEHKgD4Uo5c5kAnc8ULjN9LnuuHaXiNj461zB2w	1405	867	46	1	4650	jwhDhPZfDH6x161XZfFYeCwgicrGacozbSQ6sZrybkkZDLBuQ2W	2475	3487	3487	1616566860000
4790	3NKdHzAW2XihZoHKwdnRwmzRGwasrxUtWo6sqJZt6946QZGJEe2P	4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	1406	1393	46	1	4653	jxT5UWmcBzUnvsJ32x5i61a8MRZq1eAnq9qvWUMdb4g715zuuMh	2477	3491	3491	1616567580000
4792	3NKL6CMvAghZez2LkiyVy8rVTMnmXpq33kpaSE885n6ThknNmRsF	4790	3NKdHzAW2XihZoHKwdnRwmzRGwasrxUtWo6sqJZt6946QZGJEe2P	1509	1320	46	1	4655	jxT1Ue7rgKS2RfDAjMY2qr4tWYAMAWmDFv3WGLPuxkYpaS8Fa3K	2478	3492	3492	1616567760000
4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	4794	3NKPsqoKnRDtiBrCLZbEmwW6jsJ3QzzQQu6DGcdKUnTER8YXdK6K	1490	1274	46	1	4658	jxZeq17EkCdN1cW7peve3mgKBrP5F6gVtAsXxZ8bu2tncPofPR3	2481	3495	3495	1616568300000
4797	3NL9hAAzUUQd2f4yeegLKg9mqGtZHLUc4VmH95ufLBwQCh6rQkNo	4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	1631	794	46	1	4660	jwfvNZWPqSXFunBuxPqGSaeya6JTfHnVNeAkP7mKjD3W2YcQbmg	2482	3496	3496	1616568480000
4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	4800	3NLbmb59b8AEw9opBCEEmuAnGTcyZFP32yak1QyY72EMeUyY1WLk	1650	1129	46	1	4665	jwjchDFWAQvEUuoS57VjtooDmu1Wk6ptMKj7xxDDqctidJAi4ab	2485	3499	3499	1616569020000
4809	3NKrjsU8V3WrMrP8EJuSKzAj8dkaqTMFRqajNFERdiNCK9rA5SHQ	4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	298	1182	46	1	4672	jwkqj2f4Z2WEVMHd6VWUAEMfBdXn7h4X7M4EPCbMigDua5r2nzZ	2490	3504	3504	1616569920000
4811	3NKsEZHapJGZfaHf82eAvyWAPfUJiunNCQxu5kpx2NJPFiQuHMtf	4627	3NKY8XER2fZPbj4VgefsCrhsG1t2icr5KAgW7hdahzw8SpX4QGp5	298	1182	44	1	4674	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2395	3504	3504	1616569920000
4813	3NLZP7ayZ4miY7bAAzPkHrAZhtgcQZyQn5AuKQP117F5akJFLABX	4812	3NKejg5sVq8mjYGfzhDdfADWF8tBX1qbBett3YpUznHDwP2P7ExE	1581	778	46	1	4676	jx9S25t6D5vpnSyzyyUpTHBroNSiBho5D9qQkzHUtwNLtxnyxDV	2492	3506	3506	1616570280000
4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1507	1034	46	1	4679	jx8v927C98SSjLX8N23j7mg9eQDzwJ5iHUruPStdq4nnmZDLKmJ	2495	3509	3509	1616570820000
4823	3NLuTc3TTYHMWtNXqZjxYmPXoj4mwHybPw7yDje112ZCU7UrQQh8	4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	684	1106	46	1	4686	jxQ2SEFRekRpBXzSzV6Fug6ZqJZ3aFgFHwYcbWYDtnBLgws81B4	2499	3514	3514	1616571720000
4782	3NK7dJ4CPHo72UP1NJG3L5RaGosYFYC43Dh8W5CB1TnMGYV2DNKP	4781	3NLgp3x9L3YT7BCoZN1ajpmGWYX5VvWuTJkTE1XJsR8zM5kRAs5Q	1439	913	46	1	4645	jwCYW2iHU6LNEjBBsRTsHxDycVweV6RmSHpaMY3TCk6kPzhEmH5	2471	3482	3482	1616565960000
4785	3NLw1hAxiRbQAFfeoowyRtRFHbso9XBojeXW7rWeeXgGKf2DYp1y	4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	1406	1393	46	1	4648	jwMkaTesz7U4YTmRYA9VrCwjpPkyXXqVkR1tTYGmTegrQqvX5nz	2474	3486	3486	1616566680000
4788	3NLbgtbTADaYxmcX781xUc5q6XvKk7rQBQ5t6UCEBxfBYecKm3Ep	4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	1448	1185	46	1	4651	jxDgiiWLaA7CmDoAY3Pwq87cKmCBN6P2EV8VdqwPwfBJjWcBcLB	2476	3489	3489	1616567220000
4791	3NKmo8Tq1QS2gVLc8y6B84F4XDp7wpUcqJhtyNwq3juiEhdLYjXq	4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	1617	1288	46	1	4654	jwZXd1ZurUjummkvwVv43rYhtfuaNaCo2BCWFdkt5FamggXUdze	2477	3491	3491	1616567580000
4793	3NLi1iT4aVC1nJwX13CTV3FBcYYDQ6CxCYNMdpGLFw1rUvFVjAth	4792	3NKL6CMvAghZez2LkiyVy8rVTMnmXpq33kpaSE885n6ThknNmRsF	1407	1395	46	1	4656	jwRpvpsEjv5mxYoJk3JnfZZ2gZSwVTxJhjgEgAmXmn2aVvF7z7T	2479	3493	3493	1616567940000
4798	3NKAoftdvzEH2qRFGeDx2jspFPXrfepxVSJqYpYGseKMiVmRALLw	4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	1518	788	46	1	4661	jxUNt7Vs7TvpXSE8sxZeGa5GAM1X6rxGkwkViYtdbeuvLTirhug	2483	3497	3497	1616568660000
4800	3NLbmb59b8AEw9opBCEEmuAnGTcyZFP32yak1QyY72EMeUyY1WLk	4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	1403	823	46	1	4663	jwjwPHoia6ReczHZ7iQRtz7g3BgPQpdMpUUUMuYH84Nu8kCLfFm	2484	3498	3498	1616568840000
4805	3NLQn6CaNEfFw9Wg8wULwi25sU8epUBjsyo3YodGTbjWYeWpgbjV	4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	1406	1393	46	1	4668	jxjaSs8jhpogUcWpYW9gvDszYCYA5hJ6LqLh8jVpwZ2rsXrXLXL	2487	3501	3501	1616569380000
4807	3NLu3jMu3hfAyaQtkeFHvar9KLDCucuaSyG5G6mTm7MBa67okvGf	4806	3NKKC4KCftjbua1taj6FnyN8sVcEcD1vKwFaT7hozeRuGkVV5QCf	1560	1291	46	1	4670	jxpnDzNFTWHknrW9EQQM8jNFKjkhGRmtkjbD8UF8ZuMdtRerHHR	2488	3502	3502	1616569560000
4810	3NKARJGPnJZYkpek1iUzMSZA7oWHJmcFxtPZyfh2yP5NaCQQ3xoB	4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	1407	1395	46	1	4673	jwpBdCwU9GUrvxcYZqpsr5J62fHddRs41F7XoV6TciFjfGW8TUh	2490	3504	3504	1616569920000
4814	3NL4Qrx9tVaurrwA7f9prukgSkKnrvGigdrW62kvq2amKb1MTdfr	4813	3NLZP7ayZ4miY7bAAzPkHrAZhtgcQZyQn5AuKQP117F5akJFLABX	1571	1209	46	1	4677	jwEV6y5ujucYhfcY676WkPTKMhFxe3QyZH6SEQZ1YYTJSxNLzD4	2493	3507	3507	1616570460000
4817	3NL5DV3Gu9fXnrGs56Rw3odYYf5gAU59MG4CbLCutppwm7UtuV5M	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1534	1317	46	1	4680	jwhkzXc2ysLbMTQcd6Ee4gfqwh4ssGncBLw2o5XbpTyYKuzAQDq	2495	3509	3509	1616570820000
4821	3NLmseDXwE4XzkGvEynz9bHhB9xnMAb5EY74JZ4GJCDvn28J48KQ	4820	3NKFirq4t8JeTYQvz9vMCJuyLFh6Dk87UPujxzF6FWhjm3iY2H18	1407	1395	46	1	4684	jxKuhgexNkeiDSUmpuAVsa7Kypww7pmXEKYctH5SpvU7eD7Ktv8	2497	3512	3512	1616571360000
4824	3NKerSp5cadJPCSfpG7GpYZ1Ds67RRcWoS2KDm3LdyDcdj7SRBUG	4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	1407	1395	46	1	4687	jwsD4JFKviQEXE1XtiMgtwYcv5WdoGvHXKZVRt2CeMQUECq2UtU	2499	3514	3514	1616571720000
4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	1406	1393	46	1	4691	jwZCziEqoNfqVzaXYBnXkbBck7xxBUxByU33qz1AtNUrGbp7yW9	2501	3516	3516	1616572080000
4830	3NLBtPmUtoNyCFatqB1tcrg9D72WWKf8tr89N67zGZkvsvrNL4nZ	4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	1642	1121	47	1	4692	jxaQxCAnKCL1UXMgW7zPjJ2eVKDB2G6aGChmhFVv14uSc4HjfBP	2502	3517	3517	1616572260000
4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	1534	164	47	1	4698	jwpvve9X8TQMQepUH9h2mEGqzdaYKBUfHouFWbskU5GXhtWdX27	2505	3523	3523	1616573340000
4840	3NLf9Kbtww4RbeQxAcBS5owJpyavYYjzEi3AFxZ3NNNiXd7Wp6NU	4839	3NL2BWb5hkCYVtnmEHHj2ZsuwPBFzri1hxqhpTrzxcoZqbhinZL9	1555	1347	47	1	4702	jxyhuEQ6XHr6gHhJEgMpA8BYEBFapP6C4mjvtbDJmZZmpxzkpZR	2507	3525	3525	1616573700000
4845	3NKffFRVt6TeT8bFbZXvTeJtqTfxznGjfeBS1PChRkruhVnviuw5	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	1564	1212	47	1	4707	jxer2RbR8bkkLBzjCV7HnyitPHuMBg3j7nUGw7siwbHPVF65gYH	2510	3529	3529	1616574420000
4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1642	1241	47	1	4716	jxjWSneHTfLZFNXdAfo8kWS9FVFw8QSN11j6X8gZbKQsBLGL8AX	2515	3534	3534	1616575320000
4857	3NLPY49a3RuyBE7426Nxept9X2RXktztTG6feTUKEwMVbuhyboET	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1577	1081	47	1	4719	jwmM8k4RJsM7umrzGh1EvULgqB4aXQEyb1iTP6dhHafeWN6P7Ag	2516	3535	3535	1616575500000
4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1608	1163	47	1	4720	jxAPvJP11xgdmBmiQeuwiNBP7HcF8YGikbbLqdJB2YW5NLHvmpT	2516	3535	3535	1616575500000
4861	3NKmTB4MXwNH6iG191rvx5Kig1ZUTmAeHuiSKtwfNvzVcKL4dVqc	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1403	824	47	1	4722	jwYYHLnJpQNxV8EWZg3LD9b4n6p6HgoX6BfCE1Rh63eSBz9A4e6	2517	3539	3539	1616576220000
4868	3NLYJDT4UJLwGC73Z93UJSjfrCUdY5KnojcQ1LeVhwTQxuihjTUQ	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1483	127	47	1	4729	jxDJCdYeNDx1N24f8MrQYmd1Cmm8y5y588dvPp9gs4Z2ARqd7AT	2522	3544	3544	1616577120000
4876	3NLsYAiih34qazNQEbanG54yNefQE5hQcKYBpwZfUpRe5aHNjYU9	4875	3NKzQKvBe7NZCjWjRdKcnTk1KdXTzgjqxiD1aCt9UA6ivAtYDJV3	563	1359	47	1	4737	jxpJky8nTSyJNhxNwBFbe3yFecCKwDqEyLc6KtkHUbXv3c3so29	2525	3547	3547	1616577660000
4879	3NLhq4KHw7rstWCWLgS1z7zSwJ3PKURJwYVFS2rg1mwxQ8TGG7ci	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1406	1393	47	1	4740	jwCfNYgXAmFzfJmdLW1Nn4aWL7S1XQmWjwneqwTv7tnSN3rFF7S	2528	3552	3552	1616578560000
4882	3NKB43FvZdzHocdkznfbs3wAGWBfEq9X71FaPSZ7qFLSFRpUdxXS	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	484	1193	47	1	4743	jxZyxKmQhdAfBxhtdyTW5pqBm4J5peBxhwKJW3BX788UWuh7gqx	2528	3552	3552	1616578560000
4886	3NLSZphgWqp6MCtjHbvcCK8yeKAGeKpQTbpT6xomXkR2v9VrLeFG	4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	1657	1344	47	1	4747	jwoZNtDUXxKHYKfSkVGnydeRXc2U7negSpqqFVQ6D1VFt7QgThW	2531	3555	3555	1616579100000
4888	3NKobNaWAEY7Yg8MgdKh17xwkNTww5GYDAxsamdUnM8VHenmmPXb	4887	3NLpxGLNTnWaqMuqK7NZm6dkDrStkZBB2u62F1Z2zv2gW9DgdsiC	1589	1286	47	1	4749	jxH3WTtBvpwgaDCyVo8etVC6NPkrC2gHa1tfHnkBUjRGiYQHdTg	2532	3556	3556	1616579280000
4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1406	1393	47	1	4752	jxTXz9SwnD5tQvufTtCSH8CZAsJUEBgWtQnykAmSaDaf4gHLEmT	2535	3560	3560	1616580000000
4893	3NKWaNFeL588H8ogL6XL31h8nbbTJPJcpHueCw7bWz2sBxe9G5xy	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	641	1090	47	1	4754	jxe99L5JJNzgAHDzGzZ1Pc8cMf9rcE15uxqzJryNLMbHJeimzyF	2535	3560	3560	1616580000000
4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	563	993	47	1	4759	jwUHHhW4yBeWnHJaD6bpJdBeQETybSeRCdFAKnpFMHYxcWS5HDg	2537	3562	3562	1616580360000
4786	3NLA5N1i1R4AyuEHKgD4Uo5c5kAnc8ULjN9LnuuHaXiNj461zB2w	4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	1581	778	46	1	4649	jw8MNTXBxXHwxVBFf7oJYANcc6VE8bwhZw2i8inTT9avGSMhy6f	2474	3486	3486	1616566680000
4794	3NKPsqoKnRDtiBrCLZbEmwW6jsJ3QzzQQu6DGcdKUnTER8YXdK6K	4793	3NLi1iT4aVC1nJwX13CTV3FBcYYDQ6CxCYNMdpGLFw1rUvFVjAth	1596	1237	46	1	4657	jwCrNgUA7JZiKbp3vsoDfJnaPBNqE5vSa6eEU2GEDre1B8y8mCR	2480	3494	3494	1616568120000
4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	1402	852	46	1	4667	jxRY5y2JV6cwrY9q83sAnbrvGKj9qM2BCRGb4C239zbBrKFK92X	2486	3500	3500	1616569200000
4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	4814	3NL4Qrx9tVaurrwA7f9prukgSkKnrvGigdrW62kvq2amKb1MTdfr	1448	1311	46	1	4678	jw75svhBFsRcHN6QdAxHcfJoq8BCGJi3nsExKcDa9SdBTSquuey	2494	3508	3508	1616570640000
4818	3NKpchFp8Em2Tphuo6K4KpBUHe3pg198782Vyn1Tkz13UBbMWdKD	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1631	794	46	1	4681	jwCBu18g2dz3z3sQa1Q43CRWaN9QjtzF2J86TL9ViwPiQLaw1gz	2495	3509	3509	1616570820000
4820	3NKFirq4t8JeTYQvz9vMCJuyLFh6Dk87UPujxzF6FWhjm3iY2H18	4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	1508	1387	46	1	4683	jx1ZF5q5sWbiQnCKeNbKpuH6VyjGQfPQNbCG3NNfdHidusnsFha	2496	3510	3510	1616571000000
4825	3NKjTJPSnNVz1VaUnSDZ61uy4Xc5ygYK3sWtTqf8wmEEwfL9Sxi4	4631	3NLidPZJFRQtRcRvBRkHnQTCqk7s9eoVQcwzpckSpvVoJc3kG5ia	684	1106	44	1	4688	jxJUMnHC2dHa2MTqzc2PScxY8MsxBw95Njb3BdJVeYoJ5C4XwRg	2397	3514	3514	1616571720000
4829	3NKcF3s21Qdq1A52Ab6jrrNXTuRq834AF1eLEmkT5EkHDygVyZ8R	4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	1642	1121	47	1	4692	jxaQxCAnKCL1UXMgW7zPjJ2eVKDB2G6aGChmhFVv14uSc4HjfBP	2502	3517	3517	1616572260000
4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	4829	3NKcF3s21Qdq1A52Ab6jrrNXTuRq834AF1eLEmkT5EkHDygVyZ8R	1668	1370	47	1	4693	jx87dViFnMdkEyyiDbGurjouLw7cG2wJrmsBASuvDVgeJsnFWuw	2503	3518	3518	1616572440000
4839	3NL2BWb5hkCYVtnmEHHj2ZsuwPBFzri1hxqhpTrzxcoZqbhinZL9	4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	1652	1315	47	1	4701	jx25A5qsvcWJemRnfgkbtngVJvQsjGSmoRysuzbmZDj6XfQfKsC	2506	3524	3524	1616573520000
4841	3NKT8Ltm9XNjjpyBXkLti6UddpcUdUstgKQPaMD6RZbV9fgXLsxZ	4840	3NLf9Kbtww4RbeQxAcBS5owJpyavYYjzEi3AFxZ3NNNiXd7Wp6NU	1406	1393	47	1	4703	jxMZa4RGHDU5yZvF3wr6XjfeJSR25jUMoHUpSiXAwSyB2XN1Z2h	2508	3526	3526	1616573880000
4848	3NKePjVofTQpayx6S8PKfBWDTERSzHqr4pwDLjqDt4Qr6D8n3wt8	4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	563	993	47	1	4710	jxjFWVsqRkf5TwSN8nppcGTnKRaB4ptbCyD9Vh2VDDSDXuVvg1h	2512	3531	3531	1616574780000
4850	3NKFy9QyHwhWQ42E1FSYe6XXLK1CKozLPgGU4AgbZXMiQjCt6YCN	4849	3NKTLMScpnLa6KZKyBhaNyGP3Uu2obC9JS4qMFXCoFQvuuUADAkK	1637	816	47	1	4712	jwwDe2gHEczun3jKG3bi2HArPV1mfo3sSC2hVcuwUcx6YN6KDdo	2513	3532	3532	1616574960000
4853	3NLLAY4P55TF8kZ35htQvAhDFPVEZBnbYAsgLzu8TtV471QUdrYA	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1587	1231	47	1	4715	jwtu8aoze1hqAXHNj8gxiYaGr3dCEFqkH1LmafyzcKNV6EXM618	2515	3534	3534	1616575320000
4855	3NLoqb72bWLJtRvokayDyjenjVDHBSjDG7TAHor81PczWpgH8agL	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1403	786	47	1	4717	jwmVFsxWVgkxCHPbQBPTLPLDut1phhYcQFq5XVnHMYoErwcYcsE	2516	3535	3535	1616575500000
4864	3NLAB1yV6ymXfpcuz2rW82VC3NXJfpwr9kaL8UdToBY8e3F8ioJK	4862	3NLCbL8LUVFbiXU1FiAp3zuPQH36XY1TeRSZ1tatyx9EeqJxBjkW	1610	1188	47	1	4725	jwgLWVhfzaLjSTpZrmVNSGjMUfh9imwVz7bMwZiCPjbAXLyXSMX	2518	3540	3540	1616576400000
4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	4866	3NL8sdLNYLC17cXe7jRWiS5sj2Jg9YYtpcDEXkCMPAJhebho7h5Z	1652	1315	47	1	4728	jxx7ZoPCX6K8Gm5keMjT5yKumzJH2NfRkbYbxw9JcbM54rG9sM2	2521	3543	3543	1616576940000
4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1403	824	47	1	4731	jwMb11tvEzqcgvmJCwchvH5CTvisFBFJtEiGLH4fPkiF4AeFZNw	2522	3544	3544	1616577120000
4872	3NKnbvGrDEpV3V6LR7f7xnaAdYTj6vv11c9WA59iXY43w7tto6Ca	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1673	1368	47	1	4733	jxYswLZwBSoG8DAMFmmmcfTW7Xrh3oWCS74tCAXK7zozQFJJ7SN	2523	3545	3545	1616577300000
4877	3NKSN8uM1jDsmCEVC6Y3qrpaHiMXZNWJoSY87DxYMZJvxMwkDfck	4876	3NLsYAiih34qazNQEbanG54yNefQE5hQcKYBpwZfUpRe5aHNjYU9	1406	1393	47	1	4738	jxCwcPCrBNAhr1mnvqoD8o6yBneaFSTSEBAARr3DCpvUZe2AHMv	2526	3548	3548	1616577840000
4881	3NLVwwvegnmJeGF7obhpxEtacs1YMunwMH1WabewymEj5DcsVgug	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1549	1362	47	1	4742	jxc46BnC9nx8ZdRfavBKwUQPdrsbXjcu6c4wwYouBvw9pku83Fr	2528	3552	3552	1616578560000
4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	4889	3NKbLdai3CdrzDJhGZ1Ssmft1DrJLjS1VfJfbnyAJJCEopFgb6Hf	1522	1196	47	1	4751	jwU5HKRtmJz6kvYbjQY7vk8Wtz7J1xGGXUrv5oHXDnpJmBr2eq3	2534	3559	3559	1616579820000
4894	3NKoySMQFoMSa2HD3eBDPZapoWtjNQqgyiowJyVy9tnnLWcUJrkP	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1631	794	47	1	4755	jxwXwUQpGkDTDhS7qz1yR8gkkQZSoThsp3s5zMwCMaKBf2H6x3R	2535	3560	3560	1616580000000
4897	3NKKLwrhqwin9fYkKmYjcoReLKrBvvZeBHpw5zUx1XYXVmJNfetK	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jwVjMbRMHvLmH645MpcGq1XMT7rV86QtWpmgU2vGQA5df6MAWTe	2536	3561	3561	1616580180000
4906	3NLabGWfnVmeVg4LW2hBQ27ST62B4yWqQCLDpskP1sx3CjLyKZrZ	4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	1402	850	47	1	4765	jx53etQN1WtagkWRMorwWjCZ91gRbjcwoZwY4zQ1LQm1caSaytg	2539	3564	3564	1616580720000
4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1670	1282	48	1	4767	jwDQiByqyqsnk1zBym5bn2r63Qmc5DyaGBX1oAxBhZe6z5A6peh	2541	3566	3566	1616581080000
4913	3NKpCjZYxuoTBs3LfAokx8GyQ6F558QFJbKimTyjxXb8oCZQEAKD	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	563	993	48	1	4771	jxUyE654Ekk2yzJzRbsjHUP9AEzV7qwJrawLAQ6zHt5CD9f6oc6	2542	3567	3567	1616581260000
4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	4914	3NKFvNvF43qdMxWi7b3hd2LPWTC3EmBDsV9QmDPPKxeUfAdjFYjQ	633	1138	48	1	4773	jx6EVDoo1rwN46nvcFndSry5wWqp4buVguUZSDSFZ9w7FPCqYar	2543	3570	3570	1616581800000
4918	3NLQasR69yaCLgpSosZ84va9cviL5YPcpGZ9w147kq9PFgtipBSm	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1509	1320	48	1	4776	jwLipaMnnRiNdPWfdUiiE9SgktjuXTx9Jq5DiCT3KJkRtok6bPF	2545	3573	3573	1616582340000
4923	3NKyWrwitpZJGotqQWEZMHij4fgyxghxnUAH3cikyMXXSBQDNsgc	4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	1403	824	48	1	4781	jxGUhjFFQZjCxVefwfF9erJhzLRwbQvrZy5yZiJMPgdHQJmpch2	2547	3575	3575	1616582700000
4925	3NKsS7stWgPsC1sfKZ6pJgR8yBCtEakjASXB21bTkr4rUMqBJ69R	4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	1451	1166	48	1	4783	jwAeTSHFprFBkajqap5EGnUMnMx4fRkVfAxu7a4TN7dAsYpM2Ax	2548	3576	3576	1616582880000
4927	3NLFcdgb28bxreti51F9zXfpnkmmt91DYccoTk7Mnyprun2KeCBE	4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	1483	1030	48	1	4785	jwDW55GS5LE3khgBkpTvoxgt28mWs42brE95jxrz7ghjVkeyE49	2550	3578	3578	1616583240000
4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	1507	1034	46	1	4652	jwJ8XUmcZ6dXrGDa4DzASXmj6dJtWnYtegXhm55WmepAtV2afju	2476	3489	3489	1616567220000
4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	1406	1393	46	1	4659	jw99ykgnvQc96d8qYN8vkcGgmfcYiuNaQm2mXm4AWniPY1ts8Du	2482	3496	3496	1616568480000
4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	1585	1366	46	1	4662	jwPUSDyFxrQe9qUWnss9TPusCJRcRsJgEjjqoBvVV4DVbrprZEg	2483	3497	3497	1616568660000
4801	3NKAKvufK3FZccYT4P6Cfh84ksyaeBojYYEsVxgFca7ufRs4JuT1	4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	1513	1379	46	1	4664	jx1xDJZ8GLADSUgSgDuoZQoBbQaUjtsz4hEvsTb4ryJaDWG1ySD	2484	3498	3498	1616568840000
4803	3NLuhu7DiLFYBNXsUjQGqvgdDocnK4y6vq54qstkydQUS58ujUz1	4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	1448	1065	46	1	4666	jwjXzqsTJt5PLbh4QAjdPYwU1zsVUVtdcvy5hp8XDH3WjMT4c8t	2486	3500	3500	1616569200000
4806	3NKKC4KCftjbua1taj6FnyN8sVcEcD1vKwFaT7hozeRuGkVV5QCf	4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	1596	1363	46	1	4669	jwF1p4MxZ7KHBaHQ5ny5Wm1xHGk8b7ViQFk6BAWZT7cJiGRDN8w	2487	3501	3501	1616569380000
4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	4807	3NLu3jMu3hfAyaQtkeFHvar9KLDCucuaSyG5G6mTm7MBa67okvGf	1405	873	46	1	4671	jxzZhvKogRKeux5dhqeX6hPfT3vwkV7L65nkJUit2yXXHStsJsb	2489	3503	3503	1616569740000
4812	3NKejg5sVq8mjYGfzhDdfADWF8tBX1qbBett3YpUznHDwP2P7ExE	4810	3NKARJGPnJZYkpek1iUzMSZA7oWHJmcFxtPZyfh2yP5NaCQQ3xoB	1587	1231	46	1	4675	jxooefuV5iGmHvQy3JqpreJUoNJo3ChAip4CPyxRAFD4mSzhktd	2491	3505	3505	1616570100000
4819	3NKi2FXxJHKQnUDEhEAVrmR2Zah755JTFcBnUEfnL3j8EsB91NL8	4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	149	1283	46	1	4682	jx3Tm3NR8sA5e1sg2BkMfK4muTSPd8vHxnNKvn37wEXs1pqLbgD	2496	3510	3510	1616571000000
4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	4821	3NLmseDXwE4XzkGvEynz9bHhB9xnMAb5EY74JZ4GJCDvn28J48KQ	1624	1088	46	1	4685	jxtmsM4jkuihaDD7MabuBHDTj49gUBefDnEV2L3PSk4PYCLQeHf	2498	3513	3513	1616571540000
4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	4824	3NKerSp5cadJPCSfpG7GpYZ1Ds67RRcWoS2KDm3LdyDcdj7SRBUG	1632	297	46	1	4689	jwKYpudrgHrMCPm5CDdnjMCTXJu7EFpSUXMTREjMM2N3YVt7PV5	2500	3515	3515	1616571900000
4833	3NLHGGbkvSjeZtkmmLeDGLNMkHczrg8wJUcr2myChBM2hiy72Gu6	4825	3NKjTJPSnNVz1VaUnSDZ61uy4Xc5ygYK3sWtTqf8wmEEwfL9Sxi4	684	986	45	1	4695	jxmdKLmTkbyR6YwWSLHXEHQ6te1mvq4oFoLLTz4ZhMoFVVAW5aY	2398	3520	3520	1616572800000
4837	3NKrbE3A5ZH3ir1eoegekv2VWNb3QUdRoHZEcWhHdgJZc68DEKDW	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	1422	971	47	1	4699	jxDkC5CHXxV2SVxxA83M2niQbXW6toDUj77gMRDbaHrzQ6yFCh9	2505	3523	3523	1616573340000
4838	3NKkexjVDvs1ZbXNf7R9t4SU4ymkCYVpU8BRXSkSYzsUEitMBVjH	4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	1403	31	47	1	4700	jwjbmdYG44vhAY26X416FCj8UYxVzAY7rek94WFeVqhPCKMYDFR	2506	3524	3524	1616573520000
4843	3NLJt7qodiFFwRVazaib19EmhF3LyAAj6nRkKUBiAmB8HRiZc889	4571	3NKp3jv7GsV6EsBxoxiYVSr2rJjqmxfQuQGkXdMNCjcDX6CPbjuq	641	1210	40	1	4705	jxFQzrDNaVU3q2GgWnb69hbmBwdYmxoD2pyj1yABcrg3UhnpE7T	2261	3528	3528	1616574240000
4846	3NLfYbEcEvVxLwgbrEZGWm9XNabASjpDaf7aKkmmq2vNKmEFD1pU	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	42	1361	47	1	4708	jx4gMDw3soExKh4qTX5VgUNi5A4ox6aekhHgnVJY4aJyTyTQw8K	2510	3529	3529	1616574420000
4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	4844	3NLiRcD452WT5BoZme4HpXocMemJEFjx4NXwZKVreLmRsGC31yqg	1581	778	47	1	4709	jxLwSCpYhcfrKSF1WmJp5pETRcYfpgdDSnPkW69P4hcXdsb21qt	2511	3530	3530	1616574600000
4852	3NLCDtJA17wt658HwX3iBvAa3j7TdFNzHwAppMdF83nLKf8rAfDr	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1483	191	47	1	4714	jx3Hfo7EHJSRuF47mFbUQX7J9UxXHUPUWDq63c1JLkucebDe1GN	2515	3534	3534	1616575320000
4858	3NK7rwvXAWrrQDrpciAr67eQ1349cCJYaj5CY8rSejmwDveZnjCD	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1577	1081	47	1	4719	jwKpYDnTdpYFk1CkdSvnwhjinWS7CYcRY2cSLAot8QnWHnrFSB9	2516	3535	3535	1616575500000
4860	3NLMxPX4Qw4ABZXn4z1xAWdXtBnrUQiu3sVqe8Hd7hCNXZQeszxn	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1608	1163	45	1	4721	jxtgjfMxeuTfroiNjnAnfuVMjYJnoSW1L2mF1CpqgzxJVjsDbrf	2431	3535	3535	1616575500000
4862	3NLCbL8LUVFbiXU1FiAp3zuPQH36XY1TeRSZ1tatyx9EeqJxBjkW	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	43	1064	47	1	4723	jxH8Sor5W5qFrEPKN6YnSnyF6dfMz3xhQMMuinwXLL2q7EMXinP	2517	3539	3539	1616576220000
4866	3NL8sdLNYLC17cXe7jRWiS5sj2Jg9YYtpcDEXkCMPAJhebho7h5Z	4865	3NKJ6ma9wBihN2yxGsvpdvXLLCVPKNbQKic7eHJifg1tSFXXPwJY	1406	1393	47	1	4727	jwrhanAyi4AN28g6a9WfrnhV8QKJR3Ym7bUTPDmkE9e3B817SaY	2520	3542	3542	1616576760000
4869	3NKi6XweB9S1vxSH8hh48acHgdNaM8gMGvDRJtGQt9Uerz5LSSdU	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1507	1280	47	1	4730	jxyLxdd4jdWUriW4sqULeRiveCTTzGUEpjXJnoS8mYHU5VLKbdQ	2522	3544	3544	1616577120000
4871	3NLtSYwEkdTBx8zTtTEmAFHYDgrR5tTtZ5CvXB6MUWLKdNGqScs1	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1471	1020	47	1	4732	jwdhtWFu8aqE9RcbnE2aHho6PX17YZmPdq2nb4GuwaaVjPvM19G	2523	3545	3545	1616577300000
4880	3NLEF5EQaAY7hrFSugiufEiBMcpCp2G2kHXDowtzedP2ynQ9yKR3	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	448	939	47	1	4741	jwZufpRFVtMrykBfGUFnQDYdE6tvPBop9PLhS16QqVKcpAM4rPw	2528	3552	3552	1616578560000
4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	4881	3NLVwwvegnmJeGF7obhpxEtacs1YMunwMH1WabewymEj5DcsVgug	44	1325	47	1	4745	jw9qt3KVQjpAxATkV3PPJ1jU8Sws9UHxXA58Jh6G9YFYK2jGnpm	2529	3553	3553	1616578740000
4887	3NLpxGLNTnWaqMuqK7NZm6dkDrStkZBB2u62F1Z2zv2gW9DgdsiC	4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	1457	1265	47	1	4748	jwFvYw3s7Lx3dryMgS3UiE6YymxpCE5GKwUmxwXgCGMdsJHShn2	2531	3555	3555	1616579100000
4889	3NKbLdai3CdrzDJhGZ1Ssmft1DrJLjS1VfJfbnyAJJCEopFgb6Hf	4888	3NKobNaWAEY7Yg8MgdKh17xwkNTww5GYDAxsamdUnM8VHenmmPXb	484	1319	47	1	4750	jwxajWs3hmDMho5Mjo6RQ6mUDL46rXqCpKztDWmfhex3ycVHeCr	2533	3558	3558	1616579640000
4892	3NKKnmxu9GT7Qs5SQyuPwa4Pvcr3LwrKHnDWabrzwvVHUpi7uCbL	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1637	816	47	1	4753	jwiGyxtk7cMRdvWAPnDcNRJLTSucDUYezbH1LoXiD14fFGuCngq	2535	3560	3560	1616580000000
4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jxXHmFNfRmvgn9MM6AefkxugQRTvJ86f2GhJirTiruFZJPzNaSy	2536	3561	3561	1616580180000
4901	3NKnQjdwNKW1EFAo7NC2NhidXMjDZiKV4U1RheGooNPEZWWMa95g	4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	1581	778	47	1	4760	jw7TDD9mHh8mphkNitytDiP9SnbpY8HdFQL9guL1dWVL9xNhPXR	2537	3562	3562	1616580360000
4903	3NL9DR4ZxkkeajMiBFKLfV48d3pEUJFxbGbSeJhpBRYK8zr489Ad	4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	1402	868	47	1	4762	jx7PWD4Z5EK5gCFgdVBwDV6VcXQdS6Yd4eTNXhLTJrJNdqGyNdE	2538	3563	3563	1616580540000
4827	3NLcC57H22RrUF4JLATXA9zxtjDR3dFvpQRKp3uKxyGuG186De99	4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	58	1155	46	1	4690	jxwgSoMQJvCX3XAT2HrdX53micenrz29gLNaaY8SBDRat24ZmuD	2501	3516	3516	1616572080000
4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	684	986	47	1	4694	jxg8uVgsNyi7WsJMJkB13m95R5bnbNoBfsnB7qieAcmm9SMLXp6	2504	3520	3520	1616572800000
4834	3NLHX3WWqEq2Nc7JBnU78e6p3j56q2is4QhxFzrCwTNDfSN7cPxS	4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	1650	535	47	1	4696	jxpNMETZpqBM7vVSZpRkkZR9qV9ik2msoJc4SnfZcRvzV5njsUJ	2504	3520	3520	1616572800000
4835	3NKGm6rNDNdj5ExyjFA9N4FtxuCN8NtHnisgYHbKv1x1cxkGQrjM	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	44	1325	47	1	4697	jwdRSfTKw7ewGXfVT3z1cDQvVtWhZ774FxDYwT86JyNqQoJncgn	2505	3523	3523	1616573340000
4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	4841	3NKT8Ltm9XNjjpyBXkLti6UddpcUdUstgKQPaMD6RZbV9fgXLsxZ	641	1210	47	1	4704	jwmvUT8iVB6Cz4Ft7ydPhUoMp4cEQohhoT9ShmohWHGgpt1b8Xv	2509	3528	3528	1616574240000
4844	3NLiRcD452WT5BoZme4HpXocMemJEFjx4NXwZKVreLmRsGC31yqg	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	1403	824	47	1	4706	jxyeH4MhxNavCtwnvUeSJpQuoZ14xvSpxDpucRvikBKFZkXzwP8	2510	3529	3529	1616574420000
4849	3NKTLMScpnLa6KZKyBhaNyGP3Uu2obC9JS4qMFXCoFQvuuUADAkK	4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	1481	790	47	1	4711	jxdoj5ABS92fBHXFSsdo8yP8kFpaGsoWDfUWsQ8hkDyPMcYNMpT	2512	3531	3531	1616574780000
4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	4850	3NKFy9QyHwhWQ42E1FSYe6XXLK1CKozLPgGU4AgbZXMiQjCt6YCN	1406	1393	47	1	4713	jw8NVcCiG37qJAqzpp1scPgG3LK6hdMWw3h7rSbYZmNh5iBdPLJ	2514	3533	3533	1616575140000
4856	3NKCYVaDWoV1g4eSfJSvQJY5uCcS4pe17JQp6rb9gVWSK5xN3DmN	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1457	1265	47	1	4718	jxwauujoLQfgcJ6iAsm5G1K24G97w1iBk1DWuN9cYcXk7i6AWVn	2516	3535	3535	1616575500000
4863	3NLi2aFWCPg7PAYHDN23M7q7zuM9B2yfCM6mq3BxMBhHu8EMj1ez	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1553	776	47	1	4724	jwDXDEt9M7qvLnCMEKL8mX4DVEKQXgnP1joB7V9SgDxqFBdWEu8	2517	3539	3539	1616576220000
4865	3NKJ6ma9wBihN2yxGsvpdvXLLCVPKNbQKic7eHJifg1tSFXXPwJY	4864	3NLAB1yV6ymXfpcuz2rW82VC3NXJfpwr9kaL8UdToBY8e3F8ioJK	1671	1239	47	1	4726	jwq6sjKjZ6QtkvzncV3cdiajoZCFNsgs5Kdy4yEdxLXiUEApEGe	2519	3541	3541	1616576580000
4873	3NLK1YqNzvJM5RkYt1zkevxuUnEataNf6LuRBLMDBtVd4ZXMhjAP	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1607	1348	47	1	4734	jwzUi8PofFgxnuvtfLp3yeC9vHHzumFvxVQx4qfQtg4L366P34U	2523	3545	3545	1616577300000
4874	3NKHtHDKsVkbi47XgcdtMM7JtALcx7pVw6t1FAakRHVHNRpQyWdc	4674	3NLA9361biNfnYoLrUpDa4nZimUowiB3zPfdbSSVBZw6hB5dqcoZ	1607	1348	43	1	4735	jwH8qscEBSsa95miSdfCQqgWGSjuSxJvB8EArMJ8jaSzo6hxjV9	2326	3545	3545	1616577300000
4875	3NKzQKvBe7NZCjWjRdKcnTk1KdXTzgjqxiD1aCt9UA6ivAtYDJV3	4872	3NKnbvGrDEpV3V6LR7f7xnaAdYTj6vv11c9WA59iXY43w7tto6Ca	1406	1393	47	1	4736	jxDmA7QNoohDs2jpdRtDEhDNivVf5roL7KW88BWxMniDjhG8Z6C	2524	3546	3546	1616577480000
4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	4877	3NKSN8uM1jDsmCEVC6Y3qrpaHiMXZNWJoSY87DxYMZJvxMwkDfck	1457	1391	47	1	4739	jwzr31rXg7AV2Udbyd6Q7SwWjEEyavuyiDPvVp6m71totfyQC4w	2527	3549	3549	1616578020000
4883	3NKj6r6spAeWEKuWACr4gxEAaC5ZQkMXcSo7T1STssFa62Djc6y9	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1671	999	47	1	4744	jx3gWHsopoovPfgAsDoMzrdzwenTbMgYpqum7uv9oDTZDdJsW46	2528	3552	3552	1616578560000
4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	1578	1296	47	1	4746	jxttWvDym7KkewHwDmqL88sUimChk6L8CqM464n5ayZhYCjxm9A	2530	3554	3554	1616578920000
4895	3NLFtuaaKTjkYogsQCicf3jWf2nxavoRkZb8fa5YcRcFjUXx7RTj	4843	3NLJt7qodiFFwRVazaib19EmhF3LyAAj6nRkKUBiAmB8HRiZc889	641	1090	41	1	4756	jxQuFNiYsjeHNahZnvRtnp8uMmbS8qm8VXBZv3GR8BdANp6bPSk	2262	3560	3560	1616580000000
4898	3NKKoc57qVMCKtvuaoMYfcFf5sTZpapb4yGvxB4BYSmZGigE3jrw	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jwgC9b363a1YGarj3EkZeNN8jRmjMMHn5SH6JoEhpCCAGV27ekq	2536	3561	3561	1616580180000
4899	3NLZat9yyxmvAyRA9MHVkXX4KDtt8zEDjcymrRcpn5yKtXd2b2s6	4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	563	993	38	1	4758	jxt5BpRs8whkPvsBxBDM79k9Xm5o4j26oi5LuryYM7vGkMeEwMa	2247	3562	3562	1616580360000
4902	3NLWb4aGXaigi9uPgZcN35crAS5Rt28sTbNj9Kq5e4BvkodesEBr	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	563	993	38	1	4761	jxfBnXGHpY4UqfYR8hjR9UHaxJqJeib9vzD75aioLrwD7pXGdqX	2249	3562	3562	1616580430909
4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	1579	1389	47	1	4763	jwj7JoY7SV3aSHGEgWKxsHJL7RD7HuNLgp5B94eGxRRUYkGj4sB	2538	3563	3563	1616580540000
4909	3NLTKEpXpMTVAJ3cVqmqCFM3YvQhsGS8qmdzca6c4fNSN7XBg79j	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1439	1033	48	1	4768	jwxtaivCuXSMM3FMoZdWEBZhRvqKZ96AcVrVNVEnRgvJoK1PyD7	2541	3566	3566	1616581080000
4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	1407	1395	48	1	4774	jxxejvB7won8L2zRnHvbQa7fqciVgoW4YFUyWHoKGmuqxFq9gju	2544	3572	3572	1616582160000
4919	3NKzfk5YAX2E5mj8DuskzBXWNHbLxnTL5xwA9pnCgDLhQh3Corz4	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1555	1347	48	1	4777	jxjgvG7CezBa6fQohN2nd6yQuM1962vPWSK4X27hCv7WfE83aG4	2545	3573	3573	1616582340000
4928	3NKZU75aLBJVBZNsx1dh15epS4hdHgC38rf1GyY6feDM1BT5oxTc	4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	1646	1354	48	1	4786	jy2YWvrHxwRfrLCjH32XXZADkFaSmAZxgjYWEWNu9FBqfMbdNEs	2550	3578	3578	1616583240000
4931	3NKUJtNRS8WHxyCEr9XFwgV8FViWvWSFWsHhNss5sEsiziqaCX3a	4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	1534	57	48	1	4789	jxvPSirVhncMKjoNvNivx8G8hma8xsFczSMPtppdSJXJq3fvwhQ	2552	3583	3583	1616584140000
4932	3NLwjkLroAUXDZddpF9UQ8yyZPRWGQQc9pfK7axqfNG7AKv7aHn8	4931	3NKUJtNRS8WHxyCEr9XFwgV8FViWvWSFWsHhNss5sEsiziqaCX3a	1600	1372	48	1	4790	jw7CFGTKwFXrqci9uJnJUJkHBQJjTEGnaTza3Temh8u3PxxjuPt	2553	3586	3586	1616584680000
4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	4933	3NLjb7acHe7Cupqir896y4ddvBcyVZF236ehB2gNEKMYVob5UNWy	298	1308	48	1	4792	jy1DLQqX7xnfxXftJEXtbCz51GFdbDQR7RcUc9cs4JJH7ZSpF46	2555	3588	3588	1616585040000
4939	3NK46MB9fUcutoikMkWwFV8ZkcubkutnJfkU8ko491jKVRBUcf5H	4694	3NKV7BkTV64aTDKAmR47tPVNAFc2qGayBRaGM6LvEUR1wq7WjnzB	1622	1356	44	1	4797	jxPXPAMZSA3pyeP1b5bFofghEBpCUzbWHUrm8do6rSU5yxGoAnm	2420	3591	3591	1616585580000
4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	1489	1014	48	1	4801	jwrq83UDLje5b8bj3Jr6JS8JaLXBvyjmLJ8zVLYzwmz9hwzn621	2560	3593	3593	1616585940000
4945	3NLL2C4cADqRU5dfiiVVytryVMvkmp4Vb4DUfqAVTZNqUMeeJtSh	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1460	1078	48	1	4803	jx73qs1QXnoKKqKQZUafCahgfyQVEeYRPWtDj5iBPQTapE4sQbW	2561	3594	3594	1616586120000
4905	3NLDigRFAgJ596ydVRrgAyQHGBp7NypbJEVq7BbQppCw4Ebqg3Ta	4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	1585	1366	47	1	4764	jwqvqNLCb94BcSqhDAVCLmHmCGH98tyUvKjSR7iqbNrEvtC6844	2539	3564	3564	1616580720000
4911	3NKVKiAfxje6Csa2cd7h29ujz5uKfx4ZWgPzKiEEQmd3dUSdMWiu	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1578	1296	47	1	4769	jxaCE879F1n1Lh9AYeQhfLTK3wRB68u47aupG7qnPXSrVvFL6Tx	2541	3566	3566	1616581080000
4912	3NKZtcMDKtHKZzdEhph4EZVdX5p4RKbErxM3oRAgpKto2L39huDn	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1406	1393	48	1	4770	jy2vhwfwJeRLnTqg9C7GoRfzqZSBdMECgwnTbtu2hLB43ovFHu3	2542	3567	3567	1616581260000
4914	3NKFvNvF43qdMxWi7b3hd2LPWTC3EmBDsV9QmDPPKxeUfAdjFYjQ	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1461	1271	48	1	4772	jx4iCXd5eizRmGSHQMnEqdB9r9kywQyQweFYkY5yhkBvy6ieM2y	2542	3567	3567	1616581260000
4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	1407	1395	48	1	4780	jwyLLRDgzSNSvCTQmmMEShxvrjMga7xXpUnr77gV4Lwq8Xd7TJf	2547	3575	3575	1616582700000
4924	3NKsy2TrPPrW8hhqSzaAkbfgGtfr2kTEnhuFKLYGc8mjyH2QMeGD	4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	1403	786	48	1	4782	jxxwtfAuFZPUgyyrrEsMnXrNxLEdJ3DQHAUqazPsquTELq68HZE	2548	3576	3576	1616582880000
4930	3NLeu4w5eH1F5MwsiEC1rk5KjK7weqE766FQzPTcR2BUoadUfRPF	4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	1579	1389	48	1	4788	jw873zYpzmjtQS3dGmDvBu2yvrf94N5UJaLs7Lp1SB39v2m1omg	2552	3583	3583	1616584140000
4933	3NLjb7acHe7Cupqir896y4ddvBcyVZF236ehB2gNEKMYVob5UNWy	4932	3NLwjkLroAUXDZddpF9UQ8yyZPRWGQQc9pfK7axqfNG7AKv7aHn8	1549	1236	48	1	4791	jx7fXjQC26XJhR2xZhL5rhFjeGhFgFq4eox3M6UoLdTrURdnJdx	2554	3587	3587	1616584860000
4938	3NLnmrPbLwcRg5KVr7qAHxvUPAQL9KsECqMVHaM8zJ46bH7pUAvC	4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	1637	816	48	1	4796	jwaeCcfnmB9TbdcGDSPjXMJQWB2sbegNmBWyQCP4HbGPu1mj82r	2557	3590	3590	1616585400000
4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	1460	681	48	1	4800	jxWFT1nuTiYVJQNgVahU7pcWpoytZVzDZiGjFtVSU2GQMSE2gHm	2559	3592	3592	1616585760000
4949	3NLFDq1QAXE66dHSNGajAYL6gqWVurGkWifqh6cgLheTAoCHXFXi	4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	1587	1111	48	1	4807	jxDC8uZzh3nvcbN6UYatJJRRHUrTPLW91d7mNPM64hioHEEkt2S	2562	3595	3595	1616586300000
4952	3NLWiMaKMiSYuZ9ZsGzjhwpXECourWjykUBcPHQtXBrBtgDghiXh	4951	3NKdTWWZhZaXHtgqkFPP3hxmRnQNdJARy7AzfzV5Hzx3uBqHUsaC	369	1312	48	1	4810	jwPBe2HbwtzMnK6u9CTGLi23kE6EfDcVNvjt91mReXrWMbM463K	2565	3602	3602	1616587560000
4955	3NK4jPTPeV8dZoWFvK4jtC2zWBTmruNicWidNoNwAyo1HWGj6fxP	4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	1405	849	48	1	4813	jwrN5JR6aHhoUqeJVjPE2Ybif7UvoY9rRtJFJAFdFAXnRRdtZSb	2567	3604	3604	1616587920000
4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	4956	3NL5F8qFwbo8MViZGqhdpTkbapf1VrPNuHEbNL7Sv1T7rNccLaQ8	1519	864	48	1	4815	jwenUpWi1BGwYP1Kf5R5u4MHuPduTYXY2V4KGsAXM7hFHKvyUSh	2569	3606	3606	1616588280000
4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	4959	3NLimEzavz2BkPa5wX2sooMgymjG4pweT2ofSi3LP1QsWp5bMtYq	44	1325	48	1	4818	jwFCPpnM4UuQVpWnhTbvdYPBW6xMXyeViPzEShshqsm45fZSSyx	2571	3609	3609	1616588820000
4965	3NLhszoVv63km68eZtUdKBo16WuzsbiZFqwWxyDkWjPZ7JGUM8gL	4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	1407	1395	48	1	4823	jwT6Ay2iMzhiTqJ4WrSHztQUffwRjvqtuCkoZN67VvMR5aqnxGf	2574	3614	3614	1616589720000
4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	4967	3NLrJYK5ngEvVGcHUET9efMeQxrt1WdbqytYzH2vGfEAbbpD4t4m	152	1084	48	1	4826	jxfFTNtzYNxpr4VJxZYfiaFtr5apa1eYS4oK8QSF4uZaE69LTYx	2576	3616	3616	1616590080000
4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	1675	1342	49	1	4828	jx2vzNPYPcA2uKkMDjxiyJ13svSs1wnuJTRPxdoE9KnDmdK9Fm7	2577	3618	3618	1616590440000
4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	4974	3NK8UQdcazc8AY6XtMQAU1fCvwAEUbqFvzVJrryVKpYHKHhTWFoJ	1629	157	49	1	4833	jxgFMykz25y7fwexJJ7u827ByWBnwLs8ykLQ7T58bu65HyorVvd	2580	3621	3621	1616590980000
4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1647	845	49	1	4835	jw7vUahU2G4btVr4rz3MtyUExXdkDWiRGLw7aa4H1B5FhD8zLec	2581	3624	3624	1616591520000
4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1460	1078	49	1	4838	jxcFP9MJCY1pSdB2m9XHjMGKHJj4BdcA7B2jD8EGtF84Fd1H87b	2582	3627	3627	1616592060000
4991	3NKUjdFgjoLNhA66KzTss6TFFPLBtXyGyopNueGgPaU6VcqDztw6	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1571	1089	49	1	4849	jwAqdQkES4HxXmXb4guhyRBJpbHaSF879p93LJKibCXR2qM1u2h	2587	3635	3635	1616593500000
4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	1588	1146	49	1	4857	jxHVirkar1ny2LS5MDGwAneVbpPUXuiVXqeJE8SJL6MPakiJCRE	2592	3643	3643	1616594940000
5001	3NKSumsEKuKfbKff4FA73qaWLrsXnLRfwDDHEehr8GwFM4eawPHP	4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	1610	1314	49	1	4859	jwayx4SCEDz1oWcguJ5afGMt7jzmNUxqK6JExG9XFdpYcBvEwjf	2593	3644	3644	1616595120000
5002	3NKCXUKxg8v68yo2PvaUN252xDYjD747CfEQaxrBzGuteuHx9HAA	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1444	1381	49	1	4860	jxBwg6c3Rc7pShiNN5QeQTSxqS3XMfGsejtbGWJLewffk9CQgn2	2594	3645	3645	1616595300000
5006	3NLjVnEswF7FthSza1eEmBFnwZGu8NoM7mXBGyf5Pp93NN5vexKJ	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1643	933	49	1	4864	jwBXowEG2bAW3JPHBadC8Sur7dLebt87D52WrnxeUqdM9DX77Aa	2594	3645	3645	1616595300000
5014	3NLhGJEZzN1B7TE25ywQtHS4owE9ubVgjqAKmbGsum3qxQcKQoLY	5013	3NKbAZevFscGJGKJMGs21zhEE7AK9EZca1Z4MiCpobNQfBMeeRGZ	1406	1393	49	1	4872	jwmxqZFWuo589TT95ZV2jy2nB9PiuHqhetEQRr2J4vrMUyDE9ap	2600	3651	3651	1616596380000
5018	3NLc4rbuR2s8dszfj1wwsrSQyUNKfKJGTmFYoth3iGEf76atLaMh	5017	3NKqWQ5n5Cz4PXGtM1azxibLmZynyQ9KL29QooSSFNy7J3xNwcAj	1627	1385	49	1	4876	jwMcwVVoTTK1TG3qAoSL61SD4Upm1h8nDUTzcRaPgKxaQyDnJa4	2604	3656	3656	1616597280000
4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	4906	3NLabGWfnVmeVg4LW2hBQ27ST62B4yWqQCLDpskP1sx3CjLyKZrZ	576	1355	47	1	4766	jxbW7v4U1WAcXUixddYex7AfrfPhdkaT8nVbLrCW1xZVkPsqP6U	2540	3565	3565	1616580900000
4910	3NL4JcbCypAG1QjN1cSeRkxBxH7QN3MwA248xrHSQGiGZrQMwcbg	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1578	1296	48	1	4769	jwYbbqFYMUdoLUMMjURUshcHJAzemrjYCghBiYhvP4pNxqFFGrf	2541	3566	3566	1616581080000
4917	3NKNPEAsKhC7vffAaH98Drnb4x1FfKg4HPC4WwtSJ8kh5EP2w76Z	4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	1403	780	48	1	4775	jwDDaocH6rubZe7Ckc9YfgRVPHuZg8BZQL6hmPjbshqa3UbyVkR	2544	3572	3572	1616582160000
4920	3NKn1VpCmFE3MCworLzsv1KfRNFbrn8sS2utAYASqUeRMzU8hUAK	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1564	1092	48	1	4778	jwYCCXQxkmsPUUjg1tgNXiTv1t2b7B8otHWqQkFX3ojgojg7xVq	2545	3573	3573	1616582340000
4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	4918	3NLQasR69yaCLgpSosZ84va9cviL5YPcpGZ9w147kq9PFgtipBSm	1627	1385	48	1	4779	jy1yUh1pTALqZ59DB43EdKyWarfnmt32x2D3S6yxp364dhsGZTB	2546	3574	3574	1616582520000
4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	4924	3NKsy2TrPPrW8hhqSzaAkbfgGtfr2kTEnhuFKLYGc8mjyH2QMeGD	1423	561	48	1	4784	jxbyAGfhxdnQ6D2AY6rBaj4yWWfS6czbeK8kEY5CqaZGY89CPby	2549	3577	3577	1616583060000
4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	4928	3NKZU75aLBJVBZNsx1dh15epS4hdHgC38rf1GyY6feDM1BT5oxTc	1613	1223	48	1	4787	jwFoeecwNDYMFNTLnJmpgxmJQkjkP9Tx7PSfHZJQm5d8FQwPcA1	2551	3581	3581	1616583780000
4935	3NKWGoo34S53QHcSs5MpBTBepqugNWJ5JwzU6UPQ9gcv4Zg1ZwS7	4811	3NKsEZHapJGZfaHf82eAvyWAPfUJiunNCQxu5kpx2NJPFiQuHMtf	298	1308	44	1	4793	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2396	3588	3588	1616585040000
4937	3NLm7Hho5VTxkZz4UpRBQm3NYLkvPhfCnF75khk6P9zMdqPxDeu7	4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	1407	1395	48	1	4795	jwTGU7VVcdA7dfxcFo2fuFURJ2Scae8UR2gS5Jgaj6sgxeaQhNs	2557	3590	3590	1616585400000
4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	4938	3NLnmrPbLwcRg5KVr7qAHxvUPAQL9KsECqMVHaM8zJ46bH7pUAvC	1622	1356	48	1	4798	jwReFsEtvW9JKNJRNX12ndgk8wUY61gM8wb8VGKxaApAzNu4ztb	2558	3591	3591	1616585580000
4941	3NLgCKEdZM4TiyDE4tPwLz1ewYVv7D2B4zdK6M5TQkVKfankFFwY	4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	1407	1395	48	1	4799	jxuAmWFcRP4xdB6xwp6ifjiFkgP8PM4GHwedyQxnh3Sxh9GfmVM	2559	3592	3592	1616585760000
4944	3NKguuPdt4mj18DCANBb5MLBs8FAykiGkMW1tLJ8AJwS7vBFCJ14	4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	1445	1044	48	1	4802	jxo8sxmuMBsCdWnfm4HtVmG2dqDVNLvwfdvwKVCCRDx2cNmxZWo	2560	3593	3593	1616585940000
4946	3NLsu81QgpjcQFP4BsJLoY6jBMDRvritUrBhUZ1T9eMZZfXM4iCT	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1403	786	48	1	4804	jw9kbmjvSFtX7TEDpgyZNRqeQz5WKEyMTrCBGQK4gSQ5YgcxTGF	2561	3594	3594	1616586120000
4948	3NLDKcFNmejsaXus6AfuSfgRJNao5rz7WDsxvrTjNKT4pK4R8wNK	4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	1649	1383	48	1	4806	jxKhPdTnXqrffHdGVRKvVy4o8QpkaDnAoiDuoiewP9xfUHWWSiJ	2562	3595	3595	1616586300000
4954	3NL4WZZgcK2vAWEJ1Yibj4n2UJN9TzSytrxdYa9Ld4JZoB5KXkia	4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	1407	1395	48	1	4812	jwWu2MVizhfGfoXFxmiehTWEcN6YoS2YskaUEhP26D6QoXNXPtV	2567	3604	3604	1616587920000
4963	3NKENzZAbdjRRSnYKPGEruJ9asNcmCMVc9KCDbPmMexuaFkWrrcc	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	1463	464	48	1	4821	jxQhmPNszoTZbHsHvKtvNsN8dUBJDFP2BN4axNR2Lbs5kDowNDp	2572	3611	3611	1616589180000
4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	4962	3NL5n3UEg6ikU2CMvd6GEfQEWCZKQ65p35zVLMkx1WnMi4QntqR8	1406	1393	48	1	4822	jwuFnmTYB3bAN6AxKi6sDnc6EhAKejLDVpRETaRisVzxWcr9P3R	2573	3612	3612	1616589360000
4967	3NLrJYK5ngEvVGcHUET9efMeQxrt1WdbqytYzH2vGfEAbbpD4t4m	4965	3NLhszoVv63km68eZtUdKBo16WuzsbiZFqwWxyDkWjPZ7JGUM8gL	1440	1377	48	1	4825	jxytTkJ6jzi5RAN5g6bVYSbjnvykSJMsTVsVLJdZBX9f5ox8tPg	2575	3615	3615	1616589900000
4974	3NK8UQdcazc8AY6XtMQAU1fCvwAEUbqFvzVJrryVKpYHKHhTWFoJ	4973	3NKBRtWy5mRxsqtn7uavoheX1RiKior4eD1Ff6n79p8BHof9PMTn	1406	1393	49	1	4832	jxYrMsy2BR2pCz1bfXPPwXcqMTNdK1fHCLxJtyABxh3XFwGfRBm	2579	3620	3620	1616590800000
4983	3NKJd4GQsq5kwCT3WwfNwAy1xkugcFZ8KdZwmWyNFbbhUh5QZE5m	4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	1406	1393	49	1	4841	jwNyzva65bJWWZm9n2dY2ND5YBz1NXSjvcogxVkFMrCbb2VJEaN	2583	3628	3628	1616592240000
4986	3NLiuTjY9juwtnKWzkGwsbsu6MK4zrm3teZnm1ZdKYvbstkz2QZy	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1668	1370	49	1	4844	jxnH49g54av12KJnq8ybhRTv5oBrPme6LScX2DNLuiL6Lk4u5Pd	2584	3631	3631	1616592780000
4990	3NKUXqG8jDoKmY7ovaaoUELQZAyrzx5n5MgoJZoiVtb8Zhq1MC99	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1407	1395	49	1	4848	jxQU1NeeckfzyEjbrBXyfnrAN8NMXg3Kjxix7y2QSyvZZ3WDAXz	2587	3635	3635	1616593500000
4998	3NLjsTbEJU6HxPax9YSqJy7zrFXjuiAmPis6iqror6EGGLYP2AyC	4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	1403	812	49	1	4856	jwiH7ZUr9gBSkBVWFqUNaLccur7D86MeWexHZeh8jKgTGerFxeM	2592	3643	3643	1616594940000
5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	44	1325	49	1	4858	jxkcYkCatBpYWbBsgbiqY86xhRRWULR1WAmfNbGwXEont48yQdf	2593	3644	3644	1616595120000
5005	3NL5gnuoY9yTPsVp8f234dHaSkLNX3GXm8puu7gBBKZiujddk3wY	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1490	1274	49	1	4863	jwdLqDx3NTkzPCANMuv6wGpGJzsjmo9fLTzw8ia8wQbKRnXUHTd	2594	3645	3645	1616595300000
5009	3NLsgH335WcoQYppnxURjh9XjnxNuhZqyCCRFTzqPja7JLRDpvQD	5007	3NLhs5gRTks19PzWr6Sgn7pso5H29J7sLKaxcCLwYcizKQszTZd8	1647	1056	49	1	4867	jxqXqW4m1ADvpPRQ7fcZmYs2g9d77LXo7EEPFx8VjNWZzSdsLHX	2596	3647	3647	1616595660000
5011	3NLdFrnPKnhWT3WJd3QP9BCXTNdcmBTqmdLMoroVK4A6TCjz7qYj	5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	1509	1074	49	1	4869	jwFdh3twkbkcCYFJpToGk5N7mUBtRUtYR9yMidXVoYTZwzvJkhp	2598	3649	3649	1616596020000
5012	3NKFekxKxWgUehhtKi4m3PQoU6cjnGmy15tAsjLm3bQF1sM1dtaY	5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	1406	1393	49	1	4870	jx2YczyzTTgbxV4HLhFWWpuKy2UEfZ3YVzJvJmynuwpmFBYyHuy	2598	3649	3649	1616596020000
5013	3NKbAZevFscGJGKJMGs21zhEE7AK9EZca1Z4MiCpobNQfBMeeRGZ	5012	3NKFekxKxWgUehhtKi4m3PQoU6cjnGmy15tAsjLm3bQF1sM1dtaY	1637	815	49	1	4871	jwowFMyDUna2WbDPKPtgPX4z7jJyVx2Qe7VuTBVRvFu9zucqYQ5	2599	3650	3650	1616596200000
5022	3NK6eFRsJhbqfXSDyALugY9tGv8xrW1dtSeehhwHzTzArdDjrFrF	5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	1657	1344	49	1	4880	jx5S5Pk14izQVXnkyCKhvhSduztiHUZEFqZrXg7Cy2Pwqaq9PhB	2608	3662	3662	1616598360000
4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	1406	1393	48	1	4794	jwe5fTMPrRz8UCe4D7NtNiyCSF8GteanWLLqAfsDYMRwhCHFbyv	2556	3589	3589	1616585220000
4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1602	1123	48	1	4805	jxnzWQx8ZzDkgGD4EaqRzavqeCfgkw8aBrmQogJ2DHMEYbjdNpw	2561	3594	3594	1616586120000
4950	3NKDeJM2MWHUoP7gfvBBiRmFHVTSsx8TaJXzCLpRpr4mCePHg5QU	4949	3NLFDq1QAXE66dHSNGajAYL6gqWVurGkWifqh6cgLheTAoCHXFXi	1447	1345	48	1	4808	jwhaCUZuS1GCRBdkCAS11hQNRaVn4WTdgbGoPLP3VHQ6X6p6Lj2	2563	3600	3600	1616587200000
4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	4952	3NLWiMaKMiSYuZ9ZsGzjhwpXECourWjykUBcPHQtXBrBtgDghiXh	1553	775	48	1	4811	jwkGcfx2bB2FvEAfmNL2LZ4U7SbmbcLSmaogx93Vj1e5x5JoqDg	2566	3603	3603	1616587740000
4958	3NLgfgWxxEAv48HvfTJh5Z1qg1hebdsMBApZ43XVmyQeyBPiXNAC	4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	1500	1051	48	1	4816	jxUcXDXv4Y6VGDYu3emQC51G5UFPuiZVjjTBrtjWBqqUHhhQtBN	2570	3607	3607	1616588460000
4961	3NKbgwZsvoNpecX2rnHUbd8RbcpmsCWZjur5kcrsw44izR4zBQj5	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	632	1256	48	1	4819	jx2qiZ74aQ5X2JnHpCokkaD8ec3UUYDAuqqFaP4aSbUFSNzVDVX	2572	3611	3611	1616589180000
4966	3NKZaoHUrBQ82LCEvv9ApHj5yNT8kFEaEaAgYZUk61owt5c2CKJT	4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	1513	1253	48	1	4824	jwYU8woPNwnyBFwCF5f3wL3bXt2M6ydhZ6e3Zva3RY2actPBhGJ	2574	3614	3614	1616589720000
4971	3NLLHXk2hsucRK8VjMTqX1F1336WiqYonsL7zd8Urd1WZXiw4YSM	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1406	1393	49	1	4829	jwFDQBCJkdqiaaSyssnES4oq5BV63pbiLB4zigs7QK63dhdrErx	2578	3619	3619	1616590620000
4973	3NKBRtWy5mRxsqtn7uavoheX1RiKior4eD1Ff6n79p8BHof9PMTn	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1654	1094	49	1	4831	jx6aA8K558anGeTDfoej6LAGnVrUhRkNqvRs67sXVBGhxrBjRsz	2578	3619	3619	1616590620000
4976	3NLqpRBejUXhiqKQkYGfYVB41yHw6UDfFzBGQN23wUEwi9DFtiYk	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1407	1395	49	1	4834	jx6ikjjuF5kZ7zE94dxw1Nq2cLrr1yJGvVCSAdbwYwKsTfZ3enU	2581	3624	3624	1616591520000
4979	3NKhRJyZCNbFtxwiGUmptvC5pUYbZppJskBprimHjkHiTtxciGK7	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1500	1171	49	1	4837	jwuJGjyDQi3Ye3EvpiHJkfNrAsbDtKeMTQnFJSwP3t2C6aNhrQG	2582	3627	3627	1616592060000
4984	3NKsb82hQ8T9iwHj4rf5DExJoJB4r7cxPcqptq8qhqfdPJvM5yEk	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1406	1393	49	1	4842	jxKd1VMPLQ8LvtkYkzEtsqGxEcXmodntoAt6bRmdLYC39ngSzxp	2584	3631	3631	1616592780000
4987	3NL6uwhEiUn2uTxSGBWYKfqgwvaEwsMFcJ1fRF3cPNNc89iGi4sb	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1637	816	49	1	4845	jxDsgmQmS2huMXm11kiqTp8hiJiYje5HkCLyFE5N9AY1UrG8e3n	2584	3631	3631	1616592780000
4988	3NKwoA455kAsZ2agJG6ZhThtffNDmq2UY9QcmJi6VZKJx5AUyig6	4984	3NKsb82hQ8T9iwHj4rf5DExJoJB4r7cxPcqptq8qhqfdPJvM5yEk	1447	1345	49	1	4846	jxnG5yY8zqcx91Kqa4cM7vXyv1y1MJZw832rqCHjmht8xS5RoqN	2585	3632	3632	1616592960000
4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	4988	3NKwoA455kAsZ2agJG6ZhThtffNDmq2UY9QcmJi6VZKJx5AUyig6	1631	794	49	1	4847	jxLY5ZyXsWTh4DLzfwb4giQ8jJZf8NNM6uy2tuBby3XRAa1FWYk	2586	3634	3634	1616593320000
4992	3NKWuVzJupPAQ9Td9PoFE7xx2ndBT3DzNhrtMLGhvnMrWe5kqw9g	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1501	994	49	1	4850	jwkS1xXeBXH7kuY9EyVFTEBnd2fUNU6Y6aAMhZZf4P9VsjpygWY	2587	3635	3635	1616593500000
4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	4991	3NKUjdFgjoLNhA66KzTss6TFFPLBtXyGyopNueGgPaU6VcqDztw6	1422	1337	49	1	4851	jxw8RRSra3WMdgSJbnKvZYNSXvAqt8h242sWucUFjrhMTKEt5CA	2588	3636	3636	1616593680000
4994	3NKgNbxDT8iWuTNHusKn84XG3i4ULWKmAEpXjKf2gZGAE8QcQrJY	4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	1608	1289	49	1	4852	jx8H8qAscpURUPSzFyu4sfDFrKskZ3G2Gwc7V3c4AmuMR4Pmpmu	2589	3639	3639	1616594220000
4996	3NKnFdzDevLXSfTSVY8qfLwzeD6bwopS3V5icFryKXeKj5h7fieV	4994	3NKgNbxDT8iWuTNHusKn84XG3i4ULWKmAEpXjKf2gZGAE8QcQrJY	641	1210	49	1	4854	jxLTbqtWxNphSRFzjaeqXcRoDSgDbV5zMV6iig9LwnfjX8XwL1D	2590	3640	3640	1616594400000
5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1405	873	49	1	4861	jxspUiYwow6rSJgyto7ZWqduULvhpTW2hvAE9aBoy8VLSpEXNFX	2594	3645	3645	1616595300000
5007	3NLhs5gRTks19PzWr6Sgn7pso5H29J7sLKaxcCLwYcizKQszTZd8	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	1406	1393	49	1	4865	jwHHDiGgRwkvwEgdhYrUt3vLFafr3mpnL1XsBNMmJSomkb1U5Ak	2595	3646	3646	1616595480000
5015	3NL72sy36tt1yeKSJwgy9yAZDRTRSvmXLfvfkrK85zfXssGhebuF	5014	3NLhGJEZzN1B7TE25ywQtHS4owE9ubVgjqAKmbGsum3qxQcKQoLY	1573	1318	49	1	4873	jxW61BZZ3Fqtew9URnihUkMUG88vCJE4E185JWwXQFBQ3zPPVKM	2601	3652	3652	1616596560000
5016	3NL25KChQ61nakaneZWHTB46xqduESbMCSDLPgZtkPRFikUBcqiK	5015	3NL72sy36tt1yeKSJwgy9yAZDRTRSvmXLfvfkrK85zfXssGhebuF	1403	824	49	1	4874	jxZHkaeuuiQH5J7DQDGGMW7HjYTsySFd8Wq3UCb9at8V7NVQAJT	2602	3653	3653	1616596740000
5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	1402	852	49	1	4881	jxYEaaGd6369MYvp5xmxnC2b9MZ6vQyWd5PWJ6oRMjHt7eqFmTw	2608	3662	3662	1616598360000
4951	3NKdTWWZhZaXHtgqkFPP3hxmRnQNdJARy7AzfzV5Hzx3uBqHUsaC	4950	3NKDeJM2MWHUoP7gfvBBiRmFHVTSsx8TaJXzCLpRpr4mCePHg5QU	1460	190	48	1	4809	jxKwwqoU9ba8wzLqZf2qwcZra9gbAG5u1Wr3KeErTdaPPr5zmxU	2564	3601	3601	1616587380000
4956	3NL5F8qFwbo8MViZGqhdpTkbapf1VrPNuHEbNL7Sv1T7rNccLaQ8	4955	3NK4jPTPeV8dZoWFvK4jtC2zWBTmruNicWidNoNwAyo1HWGj6fxP	1405	843	48	1	4814	jxkexorChCh7xow5MCvC2apuFfpqj1mC1QeyqZ54xFSKtpCatid	2568	3605	3605	1616588100000
4959	3NLimEzavz2BkPa5wX2sooMgymjG4pweT2ofSi3LP1QsWp5bMtYq	4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	1407	1395	48	1	4817	jxGWe8AgVVzCv1LBxTmZiV96GzS49ryoU9jBRxwkuJwXMw4PAQg	2570	3607	3607	1616588460000
4962	3NL5n3UEg6ikU2CMvd6GEfQEWCZKQ65p35zVLMkx1WnMi4QntqR8	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	1609	1333	48	1	4820	jxEVGsTL77mzLBW6BVoVuDsBFUQ7Cj5Vch7zDigQvoTugkfkBjG	2572	3611	3611	1616589180000
4969	3NKEJhZc67LmxhKC9g6vYC35AXPgSrdfH82G9TCAwGx9e1bvN1RF	4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	1406	1393	49	1	4827	jxT3B6rZTbCnHEzU1mb7dh7Hqq8o71gAXsYWPHXPbMk86nWC3wV	2577	3618	3618	1616590440000
4972	3NKn44WJFdFkmuZd63P3ExAEBuCaXM45G4uN8i6rt4oh7PFN2yYT	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1460	22	49	1	4830	jwauWDCYyUNLoQsSLoBnR21tGGdizU7448giD3knndwSc14To3W	2578	3619	3619	1616590620000
4978	3NLCBRFWCboaAe21GqnW1tKrEyTj785Xy68B9v37vza4pDcDA1b8	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1403	824	49	1	4836	jwh799zit2nwnWeg2feA5vXVnWSfneSa1YuFNYcizEbfhnDgNrE	2581	3624	3624	1616591520000
4981	3NKgLnhcyGSF9htD63ckkevNfsNkAoJdrs4HfQjfuFGEv7gJh76t	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1457	1391	49	1	4839	jxQpcAw5gNDbhByp2ZMiE38hNiNgRT19G7MjPnaBZjE25eyzS9d	2582	3627	3627	1616592060000
4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	1471	1140	49	1	4840	jwqq74TquLJG3cazqHiQ2DvEQkmEgv1pZgE8E7SuBKeDb9Jdwv4	2583	3628	3628	1616592240000
4985	3NLx6FTZVke8mbizoX9EXcDMEo6uSgTchJHS1WwWFUC8VysEkCrC	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1457	1391	49	1	4843	jxLFUT11zJAhyxiQ3fghKAuZkxp2R578pF9tK5jN5puQpmXPc7k	2584	3631	3631	1616592780000
4995	3NLU9xW55t28sgnxvac23CD48M3Xt9fu8xKCBU6xVQgS5pAaekKu	4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	1460	533	49	1	4853	jxggn7zwe66pd1NKTohrnFXhfgBdYQ3DBKv4UxbURUyzTT5Lnoe	2589	3639	3639	1616594220000
4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	4996	3NKnFdzDevLXSfTSVY8qfLwzeD6bwopS3V5icFryKXeKj5h7fieV	1403	824	49	1	4855	jwHShbp6e5Q1iyJnG9YSTQv52AqJCcEH4YUzJv7xeJgKFtYQhBh	2591	3642	3642	1616594760000
5004	3NLhg9QWFBKjibvtUqPigveUBSERez2v4uWNYxHxwX9AGgrkui68	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	484	1073	49	1	4862	jwohZHcKZXsxkmpoMhwDMQkS75jQ4Pz5D8hJtQyUMkQbECiFPXv	2594	3645	3645	1616595300000
5008	3NLmViWxgTXHAZm18Bicb4JywMn5E2WMutbUghnnSfn1idFnF4u4	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	1637	816	49	1	4866	jx2UUyj1C7VbYHVHsRYEsFeTiek4P1kGQtKdYu8JBzAquQ8QcB4	2595	3646	3646	1616595480000
5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	5009	3NLsgH335WcoQYppnxURjh9XjnxNuhZqyCCRFTzqPja7JLRDpvQD	1623	830	49	1	4868	jx7izLazs4vV3px89zeVS7Mbac38gQPa5QpeHR7nNk6YQFXeJCL	2597	3648	3648	1616595840000
5017	3NKqWQ5n5Cz4PXGtM1azxibLmZynyQ9KL29QooSSFNy7J3xNwcAj	5016	3NL25KChQ61nakaneZWHTB46xqduESbMCSDLPgZtkPRFikUBcqiK	1631	794	49	1	4875	jww6xuyxERfZc1oTzDbvBqiYz8gATkXqqy5o4JayvSXdVwk15Uh	2603	3655	3655	1616597100000
5019	3NKeSydierL3XgPcjE4gCGqe59nt6BxG2eXqaLhuxkE1ETUhFWyo	5018	3NLc4rbuR2s8dszfj1wwsrSQyUNKfKJGTmFYoth3iGEf76atLaMh	1406	1393	49	1	4877	jxk9k66MFeDvLUkKJcbnYKUpr1h2MPKiww9bVHTdq5eZScR53nr	2605	3658	3658	1616597640000
5020	3NLrihRwyc5LTrecU8betsM9T3WvyWEZimHosPLn9av8FyUJ9j3W	5019	3NKeSydierL3XgPcjE4gCGqe59nt6BxG2eXqaLhuxkE1ETUhFWyo	1670	1036	49	1	4878	jxUJ65PDR3Bnwf5evBm932AWYWRPKsCGUgxnZNWh2SBPcBnPN4N	2606	3659	3659	1616597820000
5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	5020	3NLrihRwyc5LTrecU8betsM9T3WvyWEZimHosPLn9av8FyUJ9j3W	1406	1393	49	1	4879	jxN255e9uhXvHXczbXYYQQPBZzTWodLuyNwzqwZJShtc5sL584M	2607	3661	3661	1616598180000
5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1455	1206	49	1	4882	jxrY9UqTvJBEcVMiNKQzV861vwMn6QWaPwACeKjs4tKNCs7u4jW	2609	3663	3663	1616598540000
5025	3NKcaUSRJJEHTFhTshoL5B2vegf2CVHzTG6nFUvBhq1kjvAcZFFc	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1405	843	49	1	4883	jxySFFoG9ow4KHjEYcWmjgnmSvmjqtFqyS9rq2vsyqEpzCugiya	2609	3663	3663	1616598540000
5026	3NL4RN5j5Bx2d3DnenuCgKGAeCmESbFguVM7VejdSW9cU8W8Nim4	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1534	428	49	1	4884	jwZfmKtncmmn2kDogdYR42UWvtn1LWann1kwYkGRGb4bDcrygdb	2609	3663	3663	1616598540000
5027	3NLJVa3Wjt3JLhseoSjHEMTmQkos4zYhpLHMizA6uYDA7R6tTvK1	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1403	824	49	1	4885	jwM7BYY14TYFSfMW8iFvikiDRYLkoRLCdE33H5Twi52dA5QAcni	2609	3663	3663	1616598540000
5028	3NKrLD4AnB1jPuxAL234orb8hMaGMEy5ZEadp28JakJQU7b9bC7R	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1534	428	49	1	4884	jwoWnYqNJhTU7PuGJoFf94arXuJJWHHCL6jCDenZ9RAQYktbFH7	2609	3663	3663	1616598540000
5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	1489	1380	49	1	4886	jxVEN7RJfADXJ97JviZd4HQFD7zUtVfPYebXLKDoPM592oDFqPK	2610	3664	3664	1616598720000
5030	3NK2xSik9J6ViF3axcL7hRTQGLAUCmz8qcAZGNLyWaV1rofYRULr	5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	1406	1393	49	1	4887	jxgmVnqkUYcZ7JQsLYFKiukbdhpzMS5rGiCxqsR4XtKKs9svdmh	2610	3664	3664	1616598720000
5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	1608	1289	49	1	4888	jwgZzij9uLwUDQKGnrer4SCp67AZURFjBGMQGeJFV9B7zsLt88F	2611	3665	3665	1616598900000
5032	3NKDwrLGzygbA31hyMYMiSMV3E2exo3nGUJfwR2hp6j81nQquchy	5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	1405	873	49	1	4889	jw8fYW5sofAj1g839b32Sn5MbQ7nRudSC5ChmWB5q6jz84Fkdkv	2611	3665	3665	1616598900000
5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1622	1356	49	1	4890	jwoAkDVM95dFuBUFcUN9MPbsJ7rx7NFWK25u5jjX5tM8e5JYf6E	2612	3666	3666	1616599080000
5034	3NKnwSd8z3CtHZrS6sDdP1Hxja94oDqtUf1cZGmhBJaA83XkDC55	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1474	1329	49	1	4891	jwaYzobS2ftMVopW4kL8HCY3VQmehueJKW2fNBCQQDe5hn6z8HX	2612	3666	3666	1616599080000
5035	3NKAXFaMFu8Pbzbxm8v8LToc8mthFshaC1eNoDGpQXswNmcrGBuM	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1622	1356	49	1	4890	jxsxQd8Byd5uvogdj73gT577w9Bru8gR2wXkWGynJyW1EhWtVuz	2612	3666	3666	1616599080000
5036	3NLXrkxjVX8xoFNB7mUy7CrzjkQgxfimr93WpEBCeoPDz82LDZNe	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1474	1329	49	1	4891	jwaYzobS2ftMVopW4kL8HCY3VQmehueJKW2fNBCQQDe5hn6z8HX	2612	3666	3666	1616599080000
5037	3NLomjkyGBHLDuNbthwUQ7SEPPXVa2rx3e2YcXkB2ATLrWpnqnb1	5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	1642	1241	50	1	4892	jwWcf8K2oA3pdiKXaChz5EyvjNSF5qtsWyYCLJMS2NtDGCGL5aa	2613	3668	3668	1616599440000
5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	1642	1241	49	1	4892	jwWcf8K2oA3pdiKXaChz5EyvjNSF5qtsWyYCLJMS2NtDGCGL5aa	2613	3668	3668	1616599440000
5039	3NKioXB3KH8AdbiNXNWs2nnVk87YUDhgpwSjjQJz6sypoEXWvjeH	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1642	1367	50	1	4893	jx3XRAFYGykVpdtNeR3L5gYqTQhhmAUi5rqJNX7NnEoJ4r38DHq	2614	3670	3670	1616599800000
5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1642	1367	49	1	4893	jxNiCjsWSVXT8YR4y5c4eet5GDyFs4HwZHDxxWGLyWx1xzBitCe	2614	3670	3670	1616599800000
5045	3NLiA5HcEZyy1cSAi1Bnoif9mGfYR3YCUfohksgv8UG1yvT3RLTc	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1508	1021	50	1	4897	jxfSaBy4LpQ2A1zLsMkbXJWy5NHAN7Pkvuee3iWUQpx8XqoYvGX	2615	3671	3671	1616599980000
5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	1419	814	50	1	4904	jx56jCZAT4yz1w1azCn2jxAU9GDaBF72Bgj5X65GmUoceq8tPGj	2622	3682	3682	1616601960000
5059	3NKN3fK25aVHGstPHjXSVZc3KS2YzsfgtwfRZB1dWxZoHFBo1ewH	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	1643	1053	50	1	4911	jwYbWVAVVYR9j6m8fL56cSi9e7qAoqXB8n6JrqHSjE9LrrKswKa	2625	3685	3685	1616602500000
5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	5060	3NKzo6C1PbX2tmRjNYyQp5CVfMPKTDQBXoau5pCmxfmS6ncN9oxs	1588	1146	50	1	4913	jw9UTdY58hWoYJrB8xbmhDmuNZHcUrNjrf8BFEEnRgQLcTbRUND	2626	3686	3686	1616602680000
5062	3NK8tEAYD1bf9qn1NkJJoPqwEoeKtFqBZzS7MkRqyPk6xa1sjVGi	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1547	1012	50	1	4914	jwJL5pepA4vTshkKN8HJZAvQQ4iXg3wpP3zW3pGkJLiYEn6cDRL	2627	3687	3687	1616602860000
5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	5064	3NLHpFVBtRSV8xTju2pwdupqXqWXfLm8YctaLncUQpqLheRmGLeF	1500	1171	50	1	4918	jwcUcpTt1YnTy6S8hN2YLCMbGs1vjEChZEMgNRnbxrVmtqzgLAH	2628	3689	3689	1616603220000
5069	3NLMddQbWkFYV8a7c1XXMuURU51KptwMjdqMjGihwn5vWSq2nUd2	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1601	1388	50	1	4921	jxEVi6W1UubTsxZrZgTLX8mDt46BvShwZ3dsk5sx2Zd8ggCjevH	2629	3690	3690	1616603400000
5076	3NKoQeeLBYB3przccTe7wpKkGMPDLiuxqvCQ2RLgRQ97aep3wyua	5075	3NLTMigB5744VHtHdqQ89o13d6XcGuS2j4931deVeg7xet3RmXLk	1406	1393	50	1	4928	jxg9gK2cWk7hZxFBj6DLWKqbG3CbNhk6WR4E1aXffXq1WPi6Jrr	2634	3698	3698	1616604840000
5081	3NKQmRkUy3ZU9M832YarrV6wKK6Y9bFKrfRciqd1z8fKLEzs1ncT	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1601	1262	50	1	4933	jxcZrg5ewUvJZYBdtksAY7LJuzEBLudxBeeCpuG9KCJejaYn12f	2636	3700	3700	1616605200000
5082	3NLZo7xqegmkcSYymHeRTTawU1bWH4hCPQ8hRvmH8HMwWbMof71Q	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1403	824	50	1	4934	jxNNKdgQ2F6wYPZFFb3meHy2oCr3Empdgt85KpLBjJAqHTnkfti	2636	3700	3700	1616605200000
5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	5083	3NKEfHxW3zrkx54Jhe5uPMK4arWSPJJdFij1PsXneN8Z4ANHgd9X	1646	988	50	1	4936	jxAWUtUJrCY2YLDL5K5y27RPBNrBeu9qZbUWxdupNLSfaPdQFz7	2638	3702	3702	1616605560000
5087	3NK4ke4ZQfUczFBYgYxg7TDKohSNdHWXkQJEPHiixAXEXJfEht4Q	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1600	1372	50	1	4939	jwF31AiW6uVjJ6t9r3J5ug3rAk8QBgUo41YaZr7TeycRccHpTkU	2639	3704	3704	1616605920000
5090	3NKBa6fZMBVdAPxXf7z1gkYHikW2MNRRgsAzqwF3Ag3TAsERNCp8	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1534	1317	50	1	4942	jwYC65T1Q5PPANdPyDpmqK24mn8WgR5NsDngoe5J1e6b2FX63pb	2641	3707	3707	1616606460000
5095	3NK7ZEo6QVMaBTZadxMoQG8NPSmLEcXrYcyuvdg57iKXapkRzdY1	5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	298	298	50	1	4947	jwUULSRHFQhfEUR29mBr2NokA4p7V9y47E1h5zi2k3ETG7NkmMa	2645	3713	3713	1616607540000
5097	3NKj6nzeDRFUPuWZagYHVbo4qEmor1qBbczu2UyEreWr8B3vvEC1	4935	3NKWGoo34S53QHcSs5MpBTBepqugNWJ5JwzU6UPQ9gcv4Zg1ZwS7	298	298	44	1	4949	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2397	3713	3713	1616607540000
5098	3NLru1xT7rFh3PPZnVPGv2De7Qpa4o9QTUDf7hMsKiHxxSyBrXdX	5096	3NKNCmzZAXFhix51LjgdPXkv1NoqirN1ce48fdGsiRPLK7UCARiV	532	1303	50	1	4950	jxEKRbrVjCUGCAtZRmnq5uR11fKEVu4f5EkebfxE5gvYLofXovz	2646	3716	3716	1616608080000
5103	3NKzpbLYF7XLtbB56GjDz1RUx11z6Z8teNKxgVEkGfgS39PZAx34	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	1631	794	50	1	4955	jwzSjcroxgsoUWnzNanXVSDmpyTBn13tQYJzK1mFdyzWMyVW5nT	2649	3719	3719	1616608620000
5109	3NLWEi5tgvsU57yaWEJ66HUcfNinmW3W4ms5My9FW5caqPpNWY3R	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	1406	1393	51	1	4961	jwwcNzK4MgpAXtXxy8CNJCofxPca3XV4dgqnhLMDhkSDDxnRyAb	2653	3723	3723	1616609340000
5112	3NK5X89a5GDBG1PsYYCUAZGGataDZCV7jNJkAfNgXGBinP7TNKmC	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1607	1222	51	1	4964	jwnkvD83LnaGWftuH5aZWffwftSU3bDuEttRpouRX6FGAyQzu5W	2654	3724	3724	1616609520000
5117	3NLPLQwSRp5jaLBy1or7JXgix5eJzeNtX6kGG68kJ2srtAMpeue6	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1577	1081	51	1	4969	jxK7Q6q5x6oamEAXQ4s3ZmQvqkvCypm7CuzxQ5W4quNfcHHwqgy	2655	3725	3725	1616609700000
5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	1406	1393	51	1	4971	jxorXzJL2JCCHiTP62aiPreodT4wBxowcABBARHbhDMR8dTyBnM	2656	3726	3726	1616609880000
5123	3NLswauRaCDkJ3ZgDKSNSjUfkvAn79ZdTn2GmmXtMHm8FL18RHkr	5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	1627	1385	51	1	4973	jwYha44qGfMpYZWZp1tCR5Y21YWSXraNS4hUNUX4Mx6WsiJfSEy	2657	3728	3728	1616610240000
5126	3NKrvVpjh7wpAZHGvhoJACTddF6SmrPKRnpzpRxWKtJT2JJ6JoLp	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jwopQn3J7bsMkT9HwPE4UEJmXUgGwmD9AUBwf3H9fSxnp91Fkgx	2659	3733	3733	1616611140000
5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	5130	3NKsjNMU7JpkyhARvdoN4nntzQtL6eevcSPhigo2UNwQ1mKkFBEB	149	1283	51	1	4979	jxvF6Zj3nd5RhpsZPozcgnnH71subG5uZyVTWSzXuzvnZFYwN7r	2660	3734	3734	1616611320000
5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	470	1183	51	1	4983	jwEnCBSjGDGYqNXDYdwwCLDwgkChJYZd9bCV1Y5fzrwsYdUWjVx	2662	3739	3739	1616612220000
5139	3NLUesjyuLMA6zz8m1joGGrFNsqb2xEGrbPdhmmrvtyytqrCabwA	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1406	1393	51	1	4986	jw7qhxaKYHUi2auRk8gb6vMdbP71uYWdcLBnARYQnTfakd2Vqsm	2663	3741	3741	1616612580000
5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	5145	3NKpMDbuUCpDD2vMRAjLdYbFcgRUcqbt5ENpPKYQDuEMS73wccCm	1546	973	51	1	4993	jwUAJH8xWD2NQcCgBAW2MpRqCJnkFz4bY3tGQESmVPnUNY4ZyN9	2668	3748	3748	1616613840000
5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	1573	1318	51	1	4995	jwqnXHWMWUXDnJzkvvTL686EkWtyVkUmZuoQz43a8kZUuYUMgcq	2669	3749	3749	1616614020000
5041	3NKgcWhmW1rzajFKygxFCJd6c9gYHzWHzhxMQHjFXcwMQDzL2MwE	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1671	1365	49	1	4894	jwwDomkgddGpuUTCwyuif5DDBKBi1rJHVbc8EoJ3KjNSUeE8iyc	2615	3671	3671	1616599980000
5046	3NK94LDBYnoLDbHKEnBASWyo6nhAtw8bby85QHGYeyF5cuXQWNvg	5045	3NLiA5HcEZyy1cSAi1Bnoif9mGfYR3YCUfohksgv8UG1yvT3RLTc	1553	776	50	1	4898	jxf7adUv2mh4Wz8yLGGQCBtarH4vpvTP16tSzxjyx1WwCK6sudw	2616	3672	3672	1616600160000
5047	3NLL8DiVHorec35toPbV8cvAbAuVC4MCdQVh4jjbbAMeePfkK8o5	5046	3NK94LDBYnoLDbHKEnBASWyo6nhAtw8bby85QHGYeyF5cuXQWNvg	1588	1146	50	1	4899	jxmDceaw5eDtsrzcpEtDsYWYk2Qtq6BdiRpR8qQD4bmLwwi5mAN	2617	3673	3673	1616600340000
5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	5050	3NKQFv9Ds83jNF2o8cmbc9X7rz2KEkvHonw7iQQpjyjrAdpxze5k	1624	1334	50	1	4903	jxYTbrmHCHqYRvr2qmKERt6eXgfa1gzfFa95NXUCncimxwKA2TF	2621	3681	3681	1616601780000
5053	3NKGXXgXkQxzvznZBRrKV8yNwpvRf2fqtyaYB5XYtXRo7Eruz3T8	5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	1511	904	50	1	4905	jxh5xgoaJtVXh89mSE2WqnaAwQet9vvFcx4JnFGWtkoYtLt5TCv	2623	3683	3683	1616602140000
5060	3NKzo6C1PbX2tmRjNYyQp5CVfMPKTDQBXoau5pCmxfmS6ncN9oxs	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	641	1336	50	1	4912	jx1PxENRL8f2Wqs4cYyiWLmuETV9U4ZuvYzna3nVLuTm3RvgbHf	2625	3685	3685	1616602500000
5063	3NKkWmJ5TURxmXxhdFw6wkMaXYeWrrco1C4C6uFQ9tHtEoCVwYYV	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1637	816	50	1	4915	jwUnx23PUQaU1MWC16GtBLEUzNEPmChmXsk4qkFcY5dRwB7zhvE	2627	3687	3687	1616602860000
5067	3NLsQVo9Ws3VJFwLd2S6V4iBdqs88Wv82Ei2KVxhoNaMEZyGkki1	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1500	1051	50	1	4919	jwhFH7hN1QHt1CJxEk2MQpgkSb96hFXGyeegATftorag9hEqR8H	2629	3690	3690	1616603400000
5070	3NLHYuyudtKktcxJ5uajEsXo1HzLZfTzaxJjr8QjT5Jfw9oyB9rC	5065	3NLApzWAgWKNBJWzoWPZxfT368FZFvfykzcEX4pKdAt35MnxD61G	1601	1388	50	1	4922	jxsrQDrxXEmb8EDnJAbNG6f9HFNsZnaKXd6rSYj2Vz4GgLZjDCt	2628	3690	3690	1616603400000
5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	5068	3NK6sNd4JsPy65rtw6LAyW97Qt5Fjvo7khk3dsfg5SmebAoYiqtR	1405	865	50	1	4923	jxCXwWkYeUbpQ4uipGwuLXY3JbHJ36ok2RZcWqthaPZg9ihHPgz	2630	3691	3691	1616603580000
5074	3NK6Lcv9pKPvdiYusR5EsVmsDsDLKahQRSmWbnDWfZtWQbtczmNW	5072	3NKZMtYWEs5gENeMb2bnbMCFiWLBmM4nzCd6dDqk5Josa3kBDWCq	1440	1251	50	1	4926	jxg5cpYf6ACZ89paKcJUSNnzKUwZGyryGGHCoNezPKKRKzYFuBV	2632	3693	3693	1616603940000
5078	3NKgeeLjR8NyFhK2DM77b2kNu5k4kMXTRq542Q7hxeATbKLSvTtJ	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1593	1220	50	1	4930	jwpPpD4fq44RjP87ubjJb87c4bTpCaBkCNqqqhefGfYEniUv9rt	2636	3700	3700	1616605200000
5091	3NKS3UGXKuRWcF8QvbGgr4iqZxkw4oyLyrWWBUW6EzyG9NrECj8d	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1501	994	50	1	4943	jx5DL7kCKrs1kwY1ML6f9eEnkPNDci14hGZpYbZfkKoRUivDStE	2641	3707	3707	1616606460000
5092	3NKLoj2yxFfgzaM4Fh6PtFoeEwLrSSAY4dcCWwyFe3ZGRc7uiD9h	5091	3NKS3UGXKuRWcF8QvbGgr4iqZxkw4oyLyrWWBUW6EzyG9NrECj8d	1406	1393	50	1	4944	jxg5rTJ3RvNPG2EytiUPDYFMgLqbkchjby19xVwbAYyWDujj9So	2642	3708	3708	1616606640000
5093	3NL24WtGzK9ArBAcYuhHDewn6DRVD2oPBp3bFQBwgX11YmovNLZh	5092	3NKLoj2yxFfgzaM4Fh6PtFoeEwLrSSAY4dcCWwyFe3ZGRc7uiD9h	1405	851	50	1	4945	jxLaW5E8imfGggPWRYzjUTxsvMpKbNwqCHtJ751UfWqBsXE4X8b	2643	3709	3709	1616606820000
5096	3NKNCmzZAXFhix51LjgdPXkv1NoqirN1ce48fdGsiRPLK7UCARiV	5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	1444	1381	50	1	4948	jwATKtTjB9xBu7e6RLTnYSoin5JXZffNFhqyUkXEToiRUXVohD1	2645	3713	3713	1616607540000
5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	5099	3NLwkhR6QdzR5HNL3gRacahmQWxFo6X6g6hVaZePPbrm69t2kGqN	1534	1317	50	1	4952	jwyiE3BwB7PDuZ6JhcmkP9W39bM6wtJDBVrNeQAdTjARQZiZ6An	2648	3718	3718	1616608440000
5104	3NKswaFkuW9QrtqTGy5zyefUEHvND3UED1WvMYgHvLsCEdTqugc8	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1571	1335	51	1	4956	jwAKWoy64yFkNHSWucw4Hjk5bTfpaK45cavRQUrCe9NVXXkBAgJ	2650	3720	3720	1616608800000
5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	5107	3NLweXTR5JbM8BvSBfrKgu4xw9sSEaZf1M9SiVW3c9scYAXHbaMC	1581	778	51	1	4960	jwm7QYbjQZrYiNNSXB1LPH2Mb5QTnr3VXhSFi8v8ePhU2htASoo	2652	3722	3722	1616609160000
5115	3NLDyMjX8Ygv61GHbaVDWe78w6gwnj1gaf9vtFkiWfYVKihr4gfR	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1654	1094	51	1	4967	jx9p32XAXYhbfs6hFMCs9ArXbeba1iAc1Lr3PPGi5hcmRcWwyny	2654	3725	3725	1616609700000
5120	3NK7cQrReJgqU6SN3qemSrEiWyAwrFEC16geBFXppZ8tPD1AFrxB	5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	1529	1070	51	1	4970	jwrbj5yhC4PLmhTTxtzXJpq4omwN7nj2PN53z4jv1nw1RsRQ5T6	2656	3726	3726	1616609880000
5127	3NLrbLn9GHmuMr4q3KkJrT8ri6hEEuwYxcHUZHAmscguWDr5vwZv	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1406	1393	51	1	4976	jxAdzzMCZndEAh9RHYvhRiUmCK5kdUnAQsVzGDTkK71AbgwuBmn	2659	3733	3733	1616611140000
5130	3NKsjNMU7JpkyhARvdoN4nntzQtL6eevcSPhigo2UNwQ1mKkFBEB	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1631	794	51	1	4978	jxwWiTBswAD8LxDgDHVDva7THRDZbRzmFMsXVd8NupBZ6BDE2bq	2659	3733	3733	1616611140000
5132	3NKDpZYy7aeKdJqssGp8SowBaG6TxxBCvV6T69qPEbcLXy9v1Xs7	5129	3NLPXSzDyHhQEge54XQTHavm6RqthcaXpDSr43VcXtv4hVA5NYsb	1403	824	51	1	4980	jx1TwYntdXP1VjYjR4AiocoNe5PvjmtJFnyZDmBx6xmFhgF7q5G	2660	3736	3736	1616611680000
5138	3NKnftAmJsBLSZZDprWSSLCGeDLaH4dXHsifUHQn4MBEX639jziz	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1457	1391	51	1	4985	jwGGRhpf79XcqtmRyDNB3axQpSMntrfZgFerymJowUBh39DdB9x	2663	3741	3741	1616612580000
5144	3NKW7x8GQ16ZUMrxtpvMvAvNgomeqkMKUoNearqPgjmsktY4Xghx	5143	3NLHKvSpFXjqqQm37MAD6xx2K2YVJwkmYQZY1kzvLA2DjsCXRgY3	1403	800	51	1	4991	jxSQCcnghEG5UWA6fRNALguFjqHh5Qkr63NrDM5Ew2DjeMNWSMm	2666	3746	3746	1616613480000
5145	3NKpMDbuUCpDD2vMRAjLdYbFcgRUcqbt5ENpPKYQDuEMS73wccCm	5144	3NKW7x8GQ16ZUMrxtpvMvAvNgomeqkMKUoNearqPgjmsktY4Xghx	1405	1	51	1	4992	jwPUbyWvCGJJhqmUS7YRv3Fa6DA1eVZr5LqrZs1YwE3rPYzBx27	2667	3747	3747	1616613660000
5147	3NKmW3BLyWXkntFt77bsEWpwSTjGQoX4BqLk2pmMgGu6dQPPvfih	5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	1541	1052	51	1	4994	jwRvR4kzQXwadVBrn5EC42RicK4Hnz4yupT9Vpmmi7CpS8JxqoB	2669	3749	3749	1616614020000
5149	3NLFa9M158i9s6oggr9DTxP4UyBHuJg6UmV9SNFvhcuoSmcD9mUQ	5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	618	618	51	1	4996	jwLdBbHKv6kFuT1t98rkgpa7zWuqUdyZA2g92TpGxNK2KAqbiCV	2670	3751	3751	1616614380000
5154	3NKQWjyi4ZeCu6p1y1HJn5crwtqtzfzYnC6kN3MqpXu4vjf6ooDu	5153	3NKSdqHqJSzoVXuANQ4cq6MHxKHdEUTEm4VnrF6Kb1vJR5KJLH3A	1637	816	51	1	5001	jxa84KnZU8VpHvWn1axTFC1P5XXF1WphXzhWBsZzbR3qqr2hPNg	2673	3754	3754	1616614920000
5155	3NLGAd1VGzPReWXy9FDn6ucfoUjuQCawcnd5moMKqHx7H93sWU41	5154	3NKQWjyi4ZeCu6p1y1HJn5crwtqtzfzYnC6kN3MqpXu4vjf6ooDu	448	1059	51	1	5002	jx3bBEog7ttqvvVoywUzLDZM2YyrAP1XSdJb2SQVwTKK1T45E61	2674	3755	3755	1616615100000
5168	3NKSwUY5z26UcasD3iFCkRHMMrrvWMfY46kUeZW7XH2kGT6VTqG6	5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	1642	1241	51	1	5015	jxZf7UV4CtaFKBDHkU4wHhnxV4YQn4jcTo3Gq23hqWiicVsXB7A	2683	3766	3766	1616617080000
5042	3NKNZkCQJYsQftFtmakSQPiD4xzr3ARFVrFJy9F4r4b2h65oTx61	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1406	1393	50	1	4895	jwqQm8Fjk831CKaz48uGwKAkN3y3pNLM9MsbNGboR8Wsqzf8Ye5	2615	3671	3671	1616599980000
5044	3NLmmZK8NCWHnoV6Z2R2UADpzRdLzFiTzgejhypBYEkPWU1cANNr	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1508	1021	49	1	4896	jxjmt3cRJ8ncvsCJ6EWbqXD5rhxPJawPEmTSMN8wQgm3V42qSvQ	2614	3671	3671	1616599980000
5048	3NLde94SHjVsssRTN8UdLEyRQxxhSs8mbfBB5Bo29JLUjqCWrm5E	5047	3NLL8DiVHorec35toPbV8cvAbAuVC4MCdQVh4jjbbAMeePfkK8o5	1483	1030	50	1	4900	jwBpZGTCz272ZuScUjVxfsaTYBqJicqNtAfCtkyLCMcEabGxWUa	2618	3677	3677	1616601060000
5054	3NKBsNRTQTxfNKrj8yhSzjdeWnFKwPkS91j15BQXo7nFoT32ZoKa	5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	1426	1118	50	1	4906	jxE2rPDMQG2tHELCW8mBfET2b6gVPAmv56g1NwpmQmu2rhiBu42	2623	3683	3683	1616602140000
5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	5054	3NKBsNRTQTxfNKrj8yhSzjdeWnFKwPkS91j15BQXo7nFoT32ZoKa	1406	1393	50	1	4908	jxzuVNuQts69dyiFkrq6vT5RqUJdntXC1cZXw5keyCtgGiTqbsV	2624	3684	3684	1616602320000
5057	3NLYkG5NVBNWwHhTTsm3wuEFEwzQSrH2vWPBNFpK4MdRiksfreJ2	5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	1451	1292	50	1	4909	jwxiiCoH23BHDJME6xbUxpULoTWQVkDkAKCpxMYPoSqDctsMpnr	2620	3685	3685	1616602500000
5064	3NLHpFVBtRSV8xTju2pwdupqXqWXfLm8YctaLncUQpqLheRmGLeF	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	641	970	50	1	4916	jxM9BxUCkZa3rNQ1eS8vsjzWFHtp4YcwqcKuog9PUY3vKokvPH4	2627	3687	3687	1616602860000
5072	3NKZMtYWEs5gENeMb2bnbMCFiWLBmM4nzCd6dDqk5Josa3kBDWCq	5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	1444	1381	50	1	4924	jwiaRQpQPJBC1UsKKLH2FSnHn3JepNFS6q33M9XDQBXqbJpHEXq	2631	3692	3692	1616603760000
5079	3NKieie77tgjWDa4NoysCirhn5SZinCqBByiZRUQRjsLYLjBK4LG	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1646	1354	50	1	4931	jxfDuPxnJJyvrKf2JQdkYegrZP9w3uDkD1CPHyHRkjkYkwCiRYj	2636	3700	3700	1616605200000
5083	3NKEfHxW3zrkx54Jhe5uPMK4arWSPJJdFij1PsXneN8Z4ANHgd9X	5081	3NKQmRkUy3ZU9M832YarrV6wKK6Y9bFKrfRciqd1z8fKLEzs1ncT	1445	1290	50	1	4935	jwc5Svfv8zUGJY3JQr4mGcCdtpnmbn57x5YyX1VC5g3AHgWevS3	2637	3701	3701	1616605380000
5085	3NK7oGybTKFtYFoi98LSep7e2Rad35q9GtgxX9igB5xJDWB3GXbH	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1406	1393	50	1	4937	jxJJxGREsh3cNENhcbttcCWyR1XurVJrKydUyMThsd56CVN9DXk	2639	3704	3704	1616605920000
5099	3NLwkhR6QdzR5HNL3gRacahmQWxFo6X6g6hVaZePPbrm69t2kGqN	5098	3NLru1xT7rFh3PPZnVPGv2De7Qpa4o9QTUDf7hMsKiHxxSyBrXdX	1542	1058	50	1	4951	jwLtaAFP188T8X1WXk4VEza6uPxhKMFM8ZDjMHJ8MaDqyjKAZzR	2647	3717	3717	1616608260000
5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	484	1073	51	1	4953	jwA4fFkyo5yQgvXa69WKAoTKi45toemq4nEfmKrq2jMdGjsDVKn	2649	3719	3719	1616608620000
5105	3NLkyKNQuU6e3F1kPQ3HNhjtPb8dNUJENWKhZ4Vvcu2m4y4Vo44Y	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1617	1042	51	1	4957	jwrBwMHGeT5rv7Yp2L6ZaDSohayVoFyPMbgQ4zWZqTpQLZUr6Pe	2650	3720	3720	1616608800000
5106	3NLZyXKsnUZHMoog9HFmQ4wunb1yRGGByECMmsrWG8ryKnektRR7	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1461	1271	51	1	4958	jwFxsLQNSqUjCvog698m6TZXEHimSr424KbEPrLRNmuCB9E8ZW3	2650	3720	3720	1616608800000
5107	3NLweXTR5JbM8BvSBfrKgu4xw9sSEaZf1M9SiVW3c9scYAXHbaMC	5106	3NLZyXKsnUZHMoog9HFmQ4wunb1yRGGByECMmsrWG8ryKnektRR7	1560	1291	51	1	4959	jwZBMPeVgtQd9eE3DQ1yHk7qLMzf5cCnxAMUhaS19FEFBbFo1Zv	2651	3721	3721	1616608980000
5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	532	1303	51	1	4963	jwCBcjSLdRmMDi1FeWq1ejg5ZYKJjZFQbvj6GKosaxhvKU7qzPm	2653	3723	3723	1616609340000
5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1536	1313	51	1	4965	jy11wQhWu55Yb5BT9RX1CWEAQsthQNkctLaY79WvbFi5eYB6mGJ	2654	3724	3724	1616609520000
5114	3NLGgjPpNiqjmhguECzetyyGaHWR7VghzBjtMwMTVew256P95zGS	5110	3NLSaHUMHsXvzMNtdLkGXqa2p6vmXwAgnMdWELH2gUzEdYUf6tjp	1607	1222	51	1	4966	jwkWnHYMR884pWcBytBfkRxyrFWcK84RV1tkgYDiarxKWEuq7pj	2654	3724	3724	1616609520000
5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1577	1081	51	1	4969	jxQvjtmZk9gGFYzYamwedpoJdjzbmjqwrcQEAeWwkZ7iuQgQr2j	2655	3725	3725	1616609700000
5119	3NL7vuWQ7WivP8y3LU8aTW8hnP339nHrUBbyFWo8t3WYJnGbzzSF	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1654	1094	51	1	4968	jwEYbC1RKibVg89RXpymi7STHHrGurGNnPW8JobbjTVQHdfDqMT	2655	3725	3725	1616609744270
5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	5123	3NLswauRaCDkJ3ZgDKSNSjUfkvAn79ZdTn2GmmXtMHm8FL18RHkr	1542	938	51	1	4974	jwZscPCgL93VxLTJe18ykXikqaN5xS4jYVL1vgpHMVXTvJ9UA64	2658	3731	3731	1616610780000
5125	3NKiv3g7m124SSW1sRE6oXJaiYM6ksaGj3bF4zpM5iKBqFbVkf7p	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jxpPjfevYhc6DfRVGepSUtqV8He19aQy89EyYKosXftmipRQUDj	2659	3733	3733	1616611140000
5133	3NKGz7mYCazrmfMJUksXGnQ2YAEJfyhZf4cUXGuj9SRmLGeQ91xt	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1402	796	51	1	4981	jwFyxcoyfNf81GmUryMxJHYVtT8xeTUfvghRPU5KSt7u1w1J9D9	2661	3738	3738	1616612040000
5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1577	1081	51	1	4982	jxQ6F3tHuBEMXeEg49PuHWqo8AN6TZjiKJGGejRdVuyjdUCioZW	2661	3738	3738	1616612040000
5137	3NKHGXazAgXdhwPgnvhGuUN3vf7hYxrxX79imDCxTVALp9Aw2ucG	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1542	1304	51	1	4984	jxymLtNx9wACkfdT29nYcKLVEcuyagmSWxe2WXP7kpYxv4a8JT6	2663	3741	3741	1616612580000
5141	3NKr2cYSBN17meCfCka4wVNrhYkh4VJYFiJprjswMVzwxachgnLN	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	641	1336	51	1	4988	jwDeU3MRipjqVnVaP35gdPdub7awz1QcdXHFFHuU6atYZxVgW8z	2663	3741	3741	1616612580000
5142	3NKzhkJdECA55VcBKRFo4K4pV19KX1fr5tzSpbFwYG5MTKourG2k	5137	3NKHGXazAgXdhwPgnvhGuUN3vf7hYxrxX79imDCxTVALp9Aw2ucG	1602	1003	51	1	4989	jxKjrdkqh3aAUhMePToTk7CdD1zP18mzcfNiLadVBZqn9y1WSok	2664	3743	3743	1616612940000
5143	3NLHKvSpFXjqqQm37MAD6xx2K2YVJwkmYQZY1kzvLA2DjsCXRgY3	5142	3NKzhkJdECA55VcBKRFo4K4pV19KX1fr5tzSpbFwYG5MTKourG2k	1623	830	51	1	4990	jwnBFvCrsf9AiTGNrArBwTHYPH7kygVyxSR63jmkXJjgdF39Nsz	2665	3745	3745	1616613300000
5153	3NKSdqHqJSzoVXuANQ4cq6MHxKHdEUTEm4VnrF6Kb1vJR5KJLH3A	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1403	824	51	1	5000	jxFQcAnKCmHS6VZgkEi7fqbKcQvyyhimAJ8w2gDFTTpLYvH3TPV	2672	3753	3753	1616614740000
5159	3NKmaXJtYFA8FgXw6Mum5At5bVNHTu2KuYhonSNbrE2UYX23q6TC	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1541	932	51	1	5006	jwN1DaX79JpD2e4gKRe7wQYXWzmwZZ2R7Wz8JN7xJjfV67gT6XK	2678	3760	3760	1616616000000
5164	3NKY9gNp1G55K9DpP3SnSPgtpvZZa9QYxy3DzcBwsmQtePGujjAA	5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	1637	815	51	1	5011	jxLuVZbCMhADykgmavrXvLn49Thy1XxYSryjdmro2XUGaJDUqPi	2679	3761	3761	1616616180000
5043	3NL1jSWAjogk9NPgxVGi1Jqc2YsyKmCxPhF9iAXwwJnvywWmh8vj	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1671	1365	50	1	4894	jxYjw9uXusHvba4w7Q3rVkN9DoWU5NwcrwJDuHnVkqd2x7iWuno	2615	3671	3671	1616599980000
5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	5048	3NLde94SHjVsssRTN8UdLEyRQxxhSs8mbfBB5Bo29JLUjqCWrm5E	1581	778	50	1	4901	jwB4yCxXBBL4i3bNcrML3VzrXD8tNgVWYNZrbzq5DFC76zT72Pk	2619	3678	3678	1616601240000
5050	3NKQFv9Ds83jNF2o8cmbc9X7rz2KEkvHonw7iQQpjyjrAdpxze5k	5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	1588	1392	50	1	4902	jx5HmTqAfUArnQ4TqWzus3qcZ8spo5fkJqtg2VrqYYX1LXy88zT	2620	3679	3679	1616601420000
5055	3NLxV3DRuApDuHjYevszk4v6RYFTwqeayp7kBQE8wDFhc4bKieqL	5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	1426	1118	50	1	4907	jwARpJMfd1QQ2Mu9pfrnCVkSCA3yLY4tvQwspr9YmzvX8vPaKgD	2622	3683	3683	1616602140000
5058	3NL3HPtjAy6KXr3AQamYExJnW4TUpXGYS3ESPrd1QJncVtTsQZyP	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	1451	1292	50	1	4910	jxHFJ6hzJqQ9rQNZtDxtx24dAcZSCLe1JUWbdzNcUeGgx8qw6zU	2625	3685	3685	1616602500000
5065	3NLApzWAgWKNBJWzoWPZxfT368FZFvfykzcEX4pKdAt35MnxD61G	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1549	1362	50	1	4917	jxFtePPNUfn6dFT9JFySqEbDQPzkmY2aErWoTNE1mFEjPJYz6zG	2627	3687	3687	1616602860000
5068	3NK6sNd4JsPy65rtw6LAyW97Qt5Fjvo7khk3dsfg5SmebAoYiqtR	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1522	1322	50	1	4920	jx1nJqZNqriCEBQesP49t5CW5fM8sSS27qWkh9dk3jugvGGkDpF	2629	3690	3690	1616603400000
5073	3NLuUeq4L4brUB71E7rNQG7cAkgeLSAePZU3gcp7gRighBLSQGGQ	5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	532	1303	50	1	4925	jwXhmQ9mDAFkcWr7xGKum4To3YVLnGN39H9brsE2yCaxCePCE44	2631	3692	3692	1616603760000
5075	3NLTMigB5744VHtHdqQ89o13d6XcGuS2j4931deVeg7xet3RmXLk	5074	3NK6Lcv9pKPvdiYusR5EsVmsDsDLKahQRSmWbnDWfZtWQbtczmNW	1451	1046	50	1	4927	jwBqq6V4GWcMuYHpN2zZvsj3EXUHeH2sgLGCdp6uN4ypVkdXyc1	2633	3696	3696	1616604480000
5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	5076	3NKoQeeLBYB3przccTe7wpKkGMPDLiuxqvCQ2RLgRQ97aep3wyua	1460	664	50	1	4929	jxmGvrHArNw2osDaFv1WMK3CtRpFGSKoLG8Nf1wTfbvhvfpWbJB	2635	3699	3699	1616605020000
5080	3NLoTxZm8fLEzeUmgmsBVeuJTyfLnvRtgevvitWRdE35Q6EMmG6y	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1402	874	50	1	4932	jxiUi2Jt4JE6kxu3BLx89ANgFWMvaseMoUcSJG4cRAoU3FbtREt	2636	3700	3700	1616605200000
5086	3NKVfW8AGgNA2guWz8yeUg9EaX7vqrd7RBQwy6GyNEYA5zzwxyMM	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1634	1331	50	1	4938	jw9Y3bAxgdu5FQkisgkHg9vUcb7eJmM4BgHxNKL16Fs2u3wkaWi	2639	3704	3704	1616605920000
5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	5087	3NK4ke4ZQfUczFBYgYxg7TDKohSNdHWXkQJEPHiixAXEXJfEht4Q	1406	1393	50	1	4940	jxuEVjphtReFAiEQf1kuwfxr5A1rij77qmQgCeQm617xstP7a8C	2640	3705	3705	1616606100000
5089	3NKnnzTsdrJdKe26ZwP3LTjZWCxkJG7tM4UpzoYgpzczoyvsfnTf	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1406	1393	50	1	4941	jwKG7f1tncReSE8xB6YRfYkj2qrNXBScEUr1oq3Zht9asL9fVkx	2641	3707	3707	1616606460000
5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	5093	3NL24WtGzK9ArBAcYuhHDewn6DRVD2oPBp3bFQBwgX11YmovNLZh	1634	1331	50	1	4946	jx5dTAZzxNiPuBXaXUbyKkH769CDLR4wDVyyYdt39NdqS1m3Pfe	2644	3711	3711	1616607180000
5102	3NL3z3gZJvn14L4z5zwWRGLGpW1hrJ3jjZwp6YhGwM7TRgLp8kfi	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	1403	824	51	1	4954	jwZqKTMMZrAS6HAkjxGe6LTVSfnTo3YEQrYFSPbWnU4GZpSHbCC	2649	3719	3719	1616608620000
5110	3NLSaHUMHsXvzMNtdLkGXqa2p6vmXwAgnMdWELH2gUzEdYUf6tjp	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	1564	1338	51	1	4962	jwYzuWxNcvjGeckxxChviiDgQyscaTyEvtqtiWxR4vx54RjLLUB	2653	3723	3723	1616609340000
5116	3NKQHpH4zkNhU4MWuSGz5hwWZW6zv8eZFFyZLRaav3M7aHFz8PTX	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1654	1094	51	1	4968	jwHqbPvK3u43SRSejYtuQVesVQu5ZdF8g3sYaL6jW8TYpuVnBrH	2655	3725	3725	1616609700000
5122	3NKY19eZwY1kwzQEuKmeMQ5iQwSADy9PQ1eqTNqpLBAChiDqhnYi	5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	1406	1393	51	1	4972	jxNwXcEYVGiF6CnPu8P2VcS7uWV7VnuYEnZhiALa7k28pvC6uG5	2657	3728	3728	1616610240000
5128	3NL98HQVpgTrkmzewN1oZwj4YtdzqSh79kWQAiiBd5MV1kn4opeV	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jwZdRjS8ZZS9vEAW5aziWqaiTdvgAfLH59hJDcMhSqS8KMHuD6d	2659	3733	3733	1616611140000
5129	3NLPXSzDyHhQEge54XQTHavm6RqthcaXpDSr43VcXtv4hVA5NYsb	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1403	824	51	1	4977	jxK6sFkGYEAcqtQdNdFyWkWzBaY8iWXARYVbjJE6qaZ7uQekz41	2659	3733	3733	1616611140000
5136	3NKPeSgSTHxcfogkWWsvuBaehULhFg289udFKU2GsRWnB6BT1LCs	5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	470	1183	51	1	4983	jwWDKqLPKSb7Df1jow5PUG72UfAzp6VdPMTj9wccTKcm5KYB1my	2662	3739	3739	1616612220000
5140	3NLNUe2u7BvQhdgtgv6mHyWPEkFunW7DE1ftfXsB4vomtmLGq1Li	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1668	1244	51	1	4987	jx6zAG4w6PxurGM9W517PQFb3oVYbEpDJ13tMAFcYN3sm7om8Mz	2663	3741	3741	1616612580000
5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	1560	1291	51	1	4997	jxb6jYm9DJKHFXEPcrhnywjgRS47f3v2aUm1nyMNWGPhcVkaWLr	2670	3751	3751	1616614380000
5152	3NLVrxyXBHcsVxQPnbqme9yKrd1rpXK6Tc5E3ruDdoLQ7VFd3kSJ	5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	1457	1265	51	1	4999	jwPhv9NmAqmZBvq67zXhFnn9CmzGY1Y95JdUhVwjEhQDJjt5cJi	2671	3752	3752	1616614560000
5156	3NK9C5gn3ZmHHdXd2ToxpKa5znqBRJEv12c591166VQj6YLn9Fvw	5155	3NLGAd1VGzPReWXy9FDn6ucfoUjuQCawcnd5moMKqHx7H93sWU41	69	69	51	1	5003	jwZzpi2NVHvjcGBb2P4PngUcLekWH9svMygEfSJf6wdfFNy8FJw	2675	3756	3756	1616615280000
5160	3NKyCdkbRAXJcQ1TXyauW8QU9cnAfbucCLsJ8KKR4PYZAsFUWeu4	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1516	1294	51	1	5007	jxyDSH4HjcnDoUWTXybinibgvePJ5teDjoPVb3tJEGYgjXX4Fxd	2678	3760	3760	1616616000000
5161	3NKMs4fwfcvJbaQsz2ZFw7X8nVn55qWCGqAPo446Bjq4RG6WtR3s	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1546	973	51	1	5008	jxmT4pkWC8GzQsEWSX6KVjiT6Y2zmzqggEURoA6CiaVu5jUQjg3	2678	3760	3760	1616616000000
5163	3NLvRSpDSykJ6qtdeQrmVxuyMLCG8vwLiq42e6k6VHGC7b6YdJh2	5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	1483	663	51	1	5010	jwat8qCP7omJ8qbheh8SmevsLANZ9AnHPDJRvavEBKF7hHWiHNT	2679	3761	3761	1616616180000
5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1671	1365	51	1	5014	jxV1pUMKfW97dLoaTdGNN5ML3xbGS7DqwEc6aKJy7ae66inYUE1	2682	3765	3765	1616616900000
5170	3NLg6hZNzhGaEHKftxCufogFFMZDxDFZAC5oBUymL7fqbsSt4htN	5168	3NKSwUY5z26UcasD3iFCkRHMMrrvWMfY46kUeZW7XH2kGT6VTqG6	532	1057	51	1	5017	jxtJxFpbQMHhjzuuqPXSpnfcwcftwcdYeiThcAeBNaPmXwDFRHz	2684	3769	3769	1616617620000
5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	5170	3NLg6hZNzhGaEHKftxCufogFFMZDxDFZAC5oBUymL7fqbsSt4htN	1406	1393	51	1	5018	jxf5aEZzQLXuxtg491aAXhhCdrEFgBZ4mRJ8m2eMc9PjyrVADTf	2685	3770	3770	1616617800000
5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	1476	1125	51	1	4998	jxxFgiRZQDxiKnjrKX7i6mkm2SyrT6w2bXVrvJCDfU8UZaDwD3K	2671	3752	3752	1616614560000
5157	3NKuRgNQqnXt76ghrUcUBpujLnrRMmPW6yzW61Hkrj7GFkykNULw	5156	3NK9C5gn3ZmHHdXd2ToxpKa5znqBRJEv12c591166VQj6YLn9Fvw	1406	1393	51	1	5004	jx7GKNtes3Ji5AgxtNRYPHFEpJrhBmVWj1gqkN4xfGFebqNZmoA	2676	3758	3758	1616615640000
5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	5157	3NKuRgNQqnXt76ghrUcUBpujLnrRMmPW6yzW61Hkrj7GFkykNULw	1637	816	51	1	5005	jxzaS1MHWmWvJZrFA2d3RKJ5ujxjx8utJYxcfbBbgev5VZGtun1	2677	3759	3759	1616615820000
5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1578	1050	51	1	5009	jxJMi7GMrf4xNQwvjYaHGVEqm5USFkYhLiJCX9AsThzpCZbZb1K	2678	3760	3760	1616616000000
5165	3NLoPg7KAuaG1E8gChmLHLJxkY8538FgfDx1svFBqR5KYaehJBV6	5163	3NLvRSpDSykJ6qtdeQrmVxuyMLCG8vwLiq42e6k6VHGC7b6YdJh2	1461	1271	51	1	5012	jw9BXvFi9JTtycaSSnFbgoHd2PaPAiFYr7gZEdfRiptRyLvor3d	2680	3762	3762	1616616360000
5169	3NKwqgeE9QStXba2iAENQh7bxSgwb7R78TKsaYc3ThxD7BAVvQam	5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	1581	778	51	1	5016	jxbyF7gsaQx3iNvX9L2gW5mWeiC59zmTxEK7Zg5oPmmZo6JY8zQ	2683	3766	3766	1616617080000
5175	3NK7V74MwZFHGZP7uhKNLjvtTyUC7TaJUjTmMtjFYs52Ms5Yn3d5	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	52	1	5021	jxqr5BmrTx2UHwwPFhdv24h5AtP7PmjFr1rxtQfgQMzmh2VJ1zF	2687	3772	3772	1616618160000
5183	3NKGehcLpk5V9dASRs9stiT26vBtW3Bo8eHqzV1wrvdWwKysZwAQ	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1652	1189	52	1	5027	jxEE6AfjvxfWWiafHxAYMdB71kgV9G9Wo76cTwcR6B3xPg9tw2A	2692	3779	3779	1616619420000
5188	3NLCRFrBfZCkKwuLrFHqPKbxA8cEWrsEBFhqbEkVUZ1nZFJURqwx	5186	3NKgrfKLVqayQLbALoVkYsWEzB62XjKshHrQJW87PAW72qjMsunz	1637	816	52	1	5032	jw7ScoJqL1v7KUP4iM9aoG6LSp8Wrqzx4n8nJzBUsPHF9ZGptQx	2696	3784	3784	1616620320000
5191	3NLpSUpKCxMgP9DtKyTLuB8zj6CaCNhVxsJSuXosemQUn5Xm5zL9	5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	1534	1317	52	1	5035	jxcdts3ad836k4Z2iQwZBPV2yP2h2deuoGBGqx5iaM3ck2wBaL9	2699	3788	3788	1616621040000
5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	1613	1349	52	1	5040	jy3CYZhG1z7zCcdJwFteZhWbMPGbhVUmiEAWA16XV8eN3Kdjxry	2702	3791	3791	1616621580000
5198	3NLtwmsPxhzD2MQ8wVsJ8vh91YNfG1dWhxf9fLL6qWxAheGjWdai	5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	1405	867	52	1	5042	jwsVoP4zmHYDsxbHrbEvs929VTNZGCwH8Bb2aNtxexWG9HDvQkL	2703	3792	3792	1616621760000
5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	5200	3NKqHjYBF5j4t6ZeGfQPz7hChXcTKNnNwiry2srfwM36i2hnSj5N	1403	786	52	1	5047	jx9u9oHgGW6E7A9E35dMG1hqGyM958Ze7PBpuAhXGWxo2cWxWsG	2706	3796	3796	1616622480000
5206	3NLNck4mGGvnD9mvsLZhWe8fvXWSxqdo7wYdhSg2EAHxaBUzF9jf	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	311	1061	49	1	5050	jwijkEbnmpHwgbGH3AZxA97ap6iB3rL3UH8ScCDn5wkG8VcU61R	2595	3797	3797	1616622660000
5208	3NLeKpaztp6HmjMnsqegKGnp7YNt97kZpVyNkG8yzJ4HjRD1c24e	5207	3NKEWqhK9NBr1Jghs1CK7zCCNGDmH8qyGdyE87Wqf3GKssoENRC7	470	1309	52	1	5052	jy3EU7AqHe6qcqAV1zEELvnpnjx27iPh7wUsoM1mwpdo8W2Mq3g	2709	3799	3799	1616623020000
5213	3NKwyozuPkWJqW5JgLKb7rjMeDkYAedMMYGohCUE5zqiGEbRGvBH	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1656	1097	52	1	5057	jxfKwHE26yy59FrvnhvehsikY6XJndRm6MfEboCPj3nyAfKVNxv	2692	3802	3802	1616623660696
5215	3NKzdaXyqsKkXELiXrMZH3bT9vDxDNyiy9QTeEqQWVs5KNf9ZHXn	5209	3NLDQhtvPvZqnnWcZN6e13vtvY2BzMQDPt82tGitP8Wo8ovg4gjp	1560	1291	52	1	5059	jwEXb1nSJ82y2yatkH62kzmVbFvL6dJznfPjY9JZLMPDswqSzsy	2711	3803	3803	1616623740000
5218	3NLsKgiAZuqhXQnL8w4s6VvhAjfz2JL2GGK62BVvAbfUs7fmkFFB	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1509	1320	52	1	5062	jxJiRgvY5SSRXZgzmcpXm73z5PdRnYnFQYg7T1iN9zZMfKi1Zci	2714	3807	3807	1616624460000
5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	1594	1326	52	1	5066	jxM7tYLswbP1VJqU1Sd9yrL8cLf4RRmG72g3W48jvQWggt2Vbst	2715	3808	3808	1616624640000
5225	3NKpyjqjzMrHT5TzZ6XXqxVB9nRDpuX6bGjuz2zN7MnXEoaBdUja	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	576	1229	52	1	5069	jxdn3VcxyzYiaKPBfrWD1My6UZP8MC185w3gs6G5KQ1huxW83tY	2716	3809	3809	1616624820000
5236	3NLBWj4dBMt61s47gJGyQhW95Tu4HygT3JJv3iDc6c7GeUktPpBA	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1406	1393	51	1	5080	jxrtu8YEJ8r6G39LkEPbmEfv2KsP5t3CRHjg4w6UDrjGP2XNkNe	2661	3816	3816	1616626080000
5242	3NKgVms7zJPXEDDovtk1UkkLNTe3aQngqTNarfxChhUEcPV4SkTZ	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1406	1393	51	1	5084	jx1xAnFAsoNdB5T73AQ1zrxycbHqCiNUoHm7MuvTBfqrL5XWGEh	2682	3816	3816	1616626151452
5247	3NKpZgo6D4Dbo6VVJ86Lw5PqEND3NPihBab1RVdAPbZcQmJvkMmN	5245	3NLYe3asF5pBRMSjxw7fg9nZeJksouWXrTyYWrtz5sgWPFNpB4dL	1406	1393	52	1	5089	jwSkQJJDnMuTUHCEdYP98j3AS5FDPu2FBT5ExNByQcuRLTCvrAm	2723	3819	3819	1616626620000
5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jx7viv7xZ5Snc9tpAayyEDe8YPoN2XTgPZT56xYK9ZQRbusoorW	2725	3821	3821	1616626980000
5259	3NLQ6fLJ1NtcbXPPqbkFyG5Nuqs6CuqGTZ6CyMT5vGJVaGSBoxTM	5255	3NLQH69PPEtGfKLWbWUnY1XKxwGqSXXR5K1LqVcr29so68uDk6Dz	43	1310	52	1	5098	jx9eAG2DCQQXboKwEDnzz74PzmsK6BBDucyqYok5GCD3XwT5uoX	2728	3825	3825	1616627700000
5261	3NKSETweEipc3qCnS5K3TT43sNUhAb7nHP2z6esBpYGTV59fTmiq	5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	1633	1390	53	1	5100	jxz8JVHR7UPjndefrKPsVXXcQHFVg4iozvDXX7D2cEZQWtda6HS	2730	3826	3826	1616627880000
5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	5263	3NLYznPXZmKF9LSWv6XgBLtoMUSFMhu77NfwMTamupUVSA1BCBJS	42	1115	53	1	5103	jxys4RqfXRAk46ZQjvUAfQM9uLnvdiN2wXFUPuN4oqTHRC3v8CC	2733	3831	3831	1616628780000
5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	1601	1142	53	1	5105	jxPithZcuTYqTvLqMxrfDz7gQ8WZHWNMSkP8cHTxLFZqJF4RXHP	2734	3832	3832	1616628960000
5269	3NLGquz5LDoLQQE85z6FCxaTQnMj3swscHuFMUNJWePw1ydV5bjS	5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	1529	1070	53	1	5108	jwTmqSem5JkEDXy735Wk5B7ViBgoSVhppMM7aDCe86N8FGdHrCP	2736	3835	3835	1616629500000
5271	3NLK1PgysLqVUKczeiZfNcfDvprEXn9S8NWUUW6DANpCSMSknpmH	5269	3NLGquz5LDoLQQE85z6FCxaTQnMj3swscHuFMUNJWePw1ydV5bjS	1643	1299	53	1	5110	jxy4kqXE1R5TCSLkNNRQ3dGKT9XB4dyGJ6zEX2CTRfaWKchStof	2737	3836	3836	1616629680000
5278	3NLsamoGAFg2xapbs5gNhTArb2zH4SmrZR3YGoLf16swU1RiB3UA	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1508	1141	53	1	5117	jwv1CrS2TBTnRsLCs1rDah2iS6wRUz9oPSu7u98JkWK54n1KKDV	2742	3844	3844	1616631120000
5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	5285	3NKuZE6AxjKYp7hmesaHcmGs3cKGHHwJDz5MhHrLQCceNhwHmULz	1534	1317	53	1	5125	jwr9yfRmW4Y8MJZ66cr27sJZWw6c97AirWPU7SJNr3K5LavyjSe	2746	3848	3848	1616631840000
5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	5165	3NLoPg7KAuaG1E8gChmLHLJxkY8538FgfDx1svFBqR5KYaehJBV6	576	989	51	1	5013	jxmrM8buaK8Ak1pfPwqVuysSt6SLdHuvxvrpiRPs5PrwaiXYfza	2681	3764	3764	1616616720000
5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	1656	1343	51	1	5019	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX	2686	3771	3771	1616617980000
5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	51	1	5021	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX	2687	3772	3772	1616618160000
5179	3NKD2BijBvBEx8yYkMcykvnzKf5FbUQkE3du8YwmvNx4panTbCYC	5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	1675	1216	52	1	5024	jxGvoQhW9SQZztPutEpv3fcWBVcBjxkGmkoMzjfKAFmRoe9DjBg	2689	3775	3775	1616618700000
5181	3NK5DoQtbbmrL5qEV9vLennFidJjsmX2a7xwRE7KmwMbuBsxEL2R	5180	3NLJPo9fcJvmtYBhDS3bJNnvLkPokj8thU6bcAL36isADYtaHi3m	1649	1257	52	1	5025	jwo3N4k5UV5kh4qWLb8aTKKbPqk1sGJ4n6egZvNycfpXXX67EEX	2690	3776	3776	1616618880000
5184	3NLXJtRoSGC9re2whWv4UCHa4kLgnLWzN9JVihoedDSwF495D1UV	5183	3NKGehcLpk5V9dASRs9stiT26vBtW3Bo8eHqzV1wrvdWwKysZwAQ	1577	1327	52	1	5028	jw6zGT3DKGfCni8MmYP8vcfQTxpLRUdA151diyHrhwpfSLY2g2C	2693	3780	3780	1616619600000
5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	5189	3NK4CJupjhsVWSGYb2qrHF433LhhuGiuKWwLQ9W4Eh48LgSxrRYk	1477	1104	52	1	5034	jxbgSmQmJAto8WPUgTbEh1vHgYawEqB5gvb42H5k85hRSmJqcQP	2698	3787	3787	1616620860000
5200	3NKqHjYBF5j4t6ZeGfQPz7hChXcTKNnNwiry2srfwM36i2hnSj5N	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1406	1393	52	1	5044	jxUYj9Z1xQe3QKKces1MoxAqMnDxJWZUohdH2KY3MnNs6ajPAwf	2705	3795	3795	1616622300000
5202	3NKFgx9kXnxjPfC2emkUNmtPQaVRr4s7hH9t4jTjZ99X1pCfkWK7	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1481	790	52	1	5046	jwm8EL1Q5QrStb419injeoafpqUDuU5rXKmKrc4kCfjkjQYuuZR	2705	3795	3795	1616622300000
5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	311	1061	52	1	5049	jxcLR2SyEaE2VV2hMUAUmvKopdAPnZM6WaB1ykvWgEid245cAc2	2707	3797	3797	1616622660000
5214	3NKBeD2rRWyHjL9nxpHJPPgW9kitBY6zeax5bQEaJZCT354APmpC	5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	1656	1097	52	1	5058	jxcAhD22pAqpKxq2FjDpGDkXfHac6origxsVgBdRMvU4k682Nwm	2703	3802	3802	1616623693558
5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	5215	3NKzdaXyqsKkXELiXrMZH3bT9vDxDNyiy9QTeEqQWVs5KNf9ZHXn	1672	1039	52	1	5060	jx9GfVU7SrJ4EHXG2Li1iGyQ2zennhU4iV3QYH4HgDuXvwGmTHN	2712	3804	3804	1616623920000
5220	3NLFp1KtvFV2FpKaQBhWV8VgUbE8aNzDyVYKgx7NZjyrqQhnes1F	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	563	1359	52	1	5064	jxFZUWhxpdWqEMYLvDPaLamzBGaxoFCXrxHfLZ7E6WD7ArXrMtT	2714	3807	3807	1616624460000
5226	3NKpcPhWtxiosJvr8zDSkvA4FYAgn96zCn5dT3gYbYPa8Ux3tW97	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	1637	816	52	1	5070	jwqhk17wCGBVQ4SJqCsJy931LT16wWoL28ic963oW6CyaGzKqBk	2716	3809	3809	1616624820000
5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	5227	3NLUB7WXDqFfoJLq58r8wgAn2an6YpvxEsLy2yrTbGgs9XQNKjGi	1403	782	52	1	5072	jw78MLMaXbma5xDVfi5dKf9uXrMdEDmQpYALMoqCG1kA3bsCu8s	2718	3811	3811	1616625180000
5233	3NLe9n9m4XQ2M8s74vKMhu13toAseURkDY8Novq5P6PD8iHcK3TV	4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	1406	1393	47	1	5077	jwj3rsSvkB3v7C38ZKFfMJcB4uQRTaMWJWF4whc8MmXgXt6Ei7p	2530	3814	3814	1616625753878
5235	3NKvdjWNfC9jKhLFsNdMbnuKMnF43uEEc7vwBn4YKuqzkdpEGPX5	4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	1406	1393	48	1	5079	jwWW4dYzbsLE66LAjk4ZrxeeCghRW1sqY7nVdXKrSgEzrfSoHU3	2556	3814	3814	1616625819999
5237	3NLfpB1esyXHqz6DboHThfuporTNSiC62GGS6Geunva5pEp4zGPg	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jx7LWP4CG2hp9Um95C21BWntXnVzBjcwEByEa8DPus86cNNAqGk	2720	3816	3816	1616626080000
5239	3NK5MqJgs8zjn6e9urcM2rCNWSojaMhipuEuJzarNvUnyRd3wxj1	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1610	1068	52	1	5082	jxvcTW4DQMJkawZKc8mFHaeNaieEzttxX1xVkprruggaH7Q94Wp	2720	3816	3816	1616626080000
5246	3NKUVg7X7djHhT1gGJjtutjUKJRpfao9PGoQ4rFKuCRrNDAGSq5w	5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	1516	1048	52	1	5088	jxUnPEVAM3w6dxWXadRWkvcDZDSdixP4oH5r8QFi5gFseEtiUgA	2722	3818	3818	1616626440000
5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	5247	3NKpZgo6D4Dbo6VVJ86Lw5PqEND3NPihBab1RVdAPbZcQmJvkMmN	1406	1393	52	1	5090	jwLfMmCESAAjsJJb586y4mxp74kqfWqKW5EAg9szhDT9LDDEMAj	2724	3820	3820	1616626800000
5251	3NL5wxaEZrdpeWeqnS71R4Dke5cs7TFj9FPLFetLiuDLKiZnDuyc	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jwdeVE87BUqsJhC2YCCWWRvsbJMjQBJMt11KRFKs23uYRaTXUan	2725	3821	3821	1616626980000
5253	3NKSXjinmeVEGMRGYz1S9UkmQAFD58awZgA2nZUm1moSsxkn4Txw	5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	1634	1331	53	1	5092	jxZFX5jey3Wze7QyULK38SPMJjxyadNvNzEjTPpWVz3K8Q4gcaj	2726	3822	3822	1616627160000
5255	3NLQH69PPEtGfKLWbWUnY1XKxwGqSXXR5K1LqVcr29so68uDk6Dz	5252	3NK8mnaKKkXjfyB3WT1q9sZMghkw1WsD5vf47Evr4mqQeY43d1AH	43	1310	52	1	5094	jxtpLBM5MQpy7haMpS7rkPeMMY1LgP491tNYG4rkRGLvRW4RY1M	2727	3824	3824	1616627520000
5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	1513	1379	53	1	5097	jwnaBpzgMbSDtaex7e5EEAjSDHpYNNiE76cHDucyc3pKye8dTJY	2729	3825	3825	1616627700000
5262	3NL5RJUW7MzpSY1X2iJQK3MGxEns5VkH5JzkUTMocotkg2rKZcyK	5260	3NLawcc73B9cz1pZz2B5kJcvF2oLPrK3YY6D31fN1a6JqCq78fLA	1501	1360	53	1	5101	jxfF6HmdDZw6XEBA9o8iPaNtqG7Vqcu7kHCQuF4rq3rcvpj6N1e	2731	3828	3828	1616628240000
5265	3NKFp3G2oeetagK3WnuNY1ki2JmN3GBw9wCVuF2VatPhg3iSTKU9	5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	1654	1214	53	1	5104	jxuAetGA1sPvZEHxgXu5ipKyxaxUZun5k9q9CEVNLyWBQY3XNXr	2734	3832	3832	1616628960000
5268	3NLL3eCZYw5F6TvTMNarTaeVN4MMpixMHNy4V2f58RKLR4FY1S4M	5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	1513	1379	53	1	5107	jwGyVXFxavC3fpBqv7BdMWYYirXGcBEUwfQBAJbt8dqavrt1Dsn	2735	3833	3833	1616629140000
5273	3NKrNUiSCZCGErVMM6ruGnTvWaxFTNk1HjfS5PqMWzEyL9kW46E8	5272	3NLUX4v48rXUnNjiE51uZ8Cie7qLKdh7zLeG9qpABufZSLYtGt3J	1471	1260	53	1	5112	jxHv5BuWvePDdXPACaQhSJCtsXa2BpLNZ7zxUx7hnhCFicS7zhY	2739	3840	3840	1616630400000
5276	3NK8M7AP8DVhUTVJkpnWXeC4yvLmfdkoU8knTWQd4xCwB6u8WEpc	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1406	1393	53	1	5115	jwRLFpz5V1cgyZo2QtYZkzKS4JWNU1kPtAZfVzFgkhrouLAoWhX	2742	3844	3844	1616631120000
5279	3NLLpPvZfCfQKRrSQtepgAdGGfmU1ivYqHNiQVEeopXAUE7jLAWP	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1516	1048	53	1	5118	jx6dnWHH2tiK7AHr5VG5VNxgM16GM5tCwRLuz6wYgmgVtNzFHDa	2742	3844	3844	1616631120000
5281	3NKZpt9ZwtGTVH8DYbga5RaUWSayGNGBLERAnVHukrDrENwZ7WZT	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	684	1106	53	1	5120	jxxVobbVZpzoBG9G77CSzUGQJX5UjxV18Vza4WP3v7tniJJp8eV	2743	3845	3845	1616631300000
5173	3NKkimQoFFMTFZ9aRjySkPmWiCUGzZkCsvQN2iBmRRUzag7WsVS3	5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	1587	1357	51	1	5020	jy1yoTEQtxuL78vAKhPzivhg1ArjDZyF1f5Cnw28A4NoTRxyVhF	2686	3771	3771	1616617980000
5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	1427	583	51	1	5022	jwTwV3pUeGCfwqU8a7ZEmr7dw6S1jbmbZxHZguGjSEYVknpMB2v	2688	3773	3773	1616618340000
5180	3NLJPo9fcJvmtYBhDS3bJNnvLkPokj8thU6bcAL36isADYtaHi3m	5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	1675	1216	52	1	5024	jxdLFnYd3z2UQc7j9Np8Wa8xsLCKKPCkPY6iFGcztD6qH9PkpYM	2689	3775	3775	1616618700000
5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	5181	3NK5DoQtbbmrL5qEV9vLennFidJjsmX2a7xwRE7KmwMbuBsxEL2R	1460	1078	52	1	5026	jxmNxXMnRaDagujo48qQbQsyL5m9D2ZbpQobwfH9ogBMYz7WXg8	2691	3777	3777	1616619060000
5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	5184	3NLXJtRoSGC9re2whWv4UCHa4kLgnLWzN9JVihoedDSwF495D1UV	1483	322	52	1	5029	jwMbNf82uVR3Rxzhnawk6PMsLaQqbDEYoJRxgYFBdgW1U1VniWr	2694	3781	3781	1616619780000
5187	3NLYFZhcZkbvkcjpjX2rgMfALDutvNE87TzL2Z6Ar3yQeigaq834	5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	1637	816	52	1	5031	jx37jLJ8LveeDkmPY7XyuL9tMfRMN77eeUQukBjwE2SJsk7rZvK	2695	3782	3782	1616619960000
5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	5192	3NLEyFSRxrEJdSfaViNJXEQxzr8mzcux9jR39uoVRtmUxkvu3qZh	1623	839	52	1	5037	jw8Aattc743c6gqNS5JymzVjjJ984PdtAM95h86gFxXwHbAZUBo	2700	3789	3789	1616621220000
5195	3NK8ezgvfQA6QAtuPWHFbCckacZV3qaLE7Ct19AsWXfaCdgWAh79	5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	1490	1148	52	1	5039	jwhdrksnjAnf1bLHJwDKPEbddqFxtSmWwMVPE6TdGb1fK3umF9p	2701	3790	3790	1616621400000
5201	3NKXt8nXExtboZD6XzVheiA9Gc2fcJTNjYLmH6fQ9YnRoLiX4yLz	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1405	905	52	1	5045	jxpSxyoTciGCUHLzhzYP9UM8jerfjEjrwt4ABGk11oVtCcM4amS	2705	3795	3795	1616622300000
5207	3NKEWqhK9NBr1Jghs1CK7zCCNGDmH8qyGdyE87Wqf3GKssoENRC7	5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	1403	786	52	1	5051	jwyiCUbdBDkmNQ3uLV4LmdQDPdPG3Zh3xRF2VoD2HWjk39Vkd2V	2708	3798	3798	1616622840000
5210	3NKvhutyRgz8jgjxqhgo3XcSSu8Dzqc5kJg6jZ1pfuqbb6GWTXBV	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1656	1097	51	1	5054	jxDBHe588VEtQ9UQa7Qtm4JqShnGwzqp1mFXRMUmo3DGwyAaX78	2661	3802	3802	1616623560000
5212	3NLsD5fFhukZ18wc6HTpxfksRXmLoxyMP34Cvf9qMgu9bhAvva78	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1656	1097	51	1	5056	jxKqsMoEFkuMS7RadeGCVtbm2hdfP91mNrLW7zgd7eghdNZz2G4	2682	3802	3802	1616623626911
5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	1611	1341	52	1	5061	jxjdtD8GBtqJymhVDKvyfVYTpp4oHjVNs7XjnhvN76WDKSiSYWS	2713	3805	3805	1616624100000
5224	3NLme9rD42AsEJ7gPnQYNWUs8pBwrUtQVVMUrhPmWcdx1CNTEUz3	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	1406	1393	52	1	5068	jwxBdck7r776Q3WBYUZr3oGSdUNjmQDiCTbmSA7tu9K3sgchyFm	2716	3809	3809	1616624820000
5229	3NL9TnmWK1X13HnfJTvGTUt4cu8TF6SfPaN9hMq7JGra8u9FGE2e	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1451	1292	52	1	5073	jxWpq8sf4z1sRaYTKcuPAtspDhVjpUTaC4RcLYyfcRLdaYb29QH	2719	3813	3813	1616625540000
5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1624	1334	52	1	5075	jwutMrCVsYLASeBxqSAwNcS1McGPw514nUQ8bpnjSAgEH4cWQVN	2719	3813	3813	1616625540000
5238	3NLJXhdEGt4xiSPUwf5mfwpVmYTJyLBeJ7coiQAFt7WMT4k3qUnf	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jwtWYg4e16bWFdEiQgHM4z8BhU5kpgy3T9mUJVuKPKwCKedBMSV	2720	3816	3816	1616626080000
5240	3NLf3ePov32AZLo8wJmEPGaBka2w6NRoxkCx4j2dg1aEpDU59BW9	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1406	1393	51	1	5083	jwKu4HocE4NawzbUpKW1R5Ba4UYgpqjtioGdzf8QBNrm2eXBfH7	2672	3816	3816	1616626116997
5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	5239	3NK5MqJgs8zjn6e9urcM2rCNWSojaMhipuEuJzarNvUnyRd3wxj1	1483	1276	52	1	5086	jxdPDwB26LDBT8Vmp3wRujZ9CVYv4moyuUjDcaZrb34RxztjbF9	2721	3817	3817	1616626260000
5249	3NKQ6MPuUZ7x6xmfMvdzKwwkHTnEv9aTW2c6fCovBKrHhguzEgzU	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jxKuQdqo2hpVT5RGDuzK2o52dGCeiC3jgfr1cf2SHJ2xJR5SdEe	2725	3821	3821	1616626980000
5254	3NLx5WDS97muiDx498i3HGVyYUJpokRtF2ULuxePHAKrQqrvJ7mA	5253	3NKSXjinmeVEGMRGYz1S9UkmQAFD58awZgA2nZUm1moSsxkn4Txw	1477	984	53	1	5093	jxH3YxgAjiRbW7Ytc6hPxcHPWB4HErhFnuUrF57XtA5YHPTdLnQ	2727	3823	3823	1616627340000
5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	5254	3NLx5WDS97muiDx498i3HGVyYUJpokRtF2ULuxePHAKrQqrvJ7mA	43	1310	53	1	5095	jwaT3fLEUDpzKysYSomU9nbSd9oL6jCdzV6vLunSpx8xgJeEgsN	2728	3824	3824	1616627520000
5260	3NLawcc73B9cz1pZz2B5kJcvF2oLPrK3YY6D31fN1a6JqCq78fLA	5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	1405	851	53	1	5099	jxNkFH7rPXJBqjKhvGKNwGQ4T2p8TEMA7bqTnAgUiDfx3pwAsbT	2730	3826	3826	1616627880000
5263	3NLYznPXZmKF9LSWv6XgBLtoMUSFMhu77NfwMTamupUVSA1BCBJS	5262	3NL5RJUW7MzpSY1X2iJQK3MGxEns5VkH5JzkUTMocotkg2rKZcyK	1476	1005	53	1	5102	jwJi3biKcUHawmGUe7YunzMTSagqD3JDQnEu4CJh3BbVN3gKn8f	2732	3830	3830	1616628600000
5274	3NKsvc5CvBBG1jSKx1WzQVdgvV2tUczV9iBbYEBDqJaHgVCQET32	5273	3NKrNUiSCZCGErVMM6ruGnTvWaxFTNk1HjfS5PqMWzEyL9kW46E8	1564	1338	53	1	5113	jx7exE5XqSTStF7VMDWVaSNHqpSc9Unxs4Z9SSC25U9MG3Avu3y	2740	3841	3841	1616630580000
5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1560	1291	53	1	5116	jwu5WDMDprTTbKqfZ4Gg9BZKt3sjxnbwcPdQxZ24bJwct2whPgv	2742	3844	3844	1616631120000
5282	3NKtgfWVJEchC9Gvfxq1xwGaQtZWhzvY2waRP876fnnqcmCc1svc	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	563	993	53	1	5121	jx7ZKhc4ycLcE8uzr6PxJ9c1N8yg1orMCkcGxontmK3dRKmVTdp	2743	3845	3845	1616631300000
5283	3NKP7xTQrMnuUf8fXScAGDY92zmv1hrdZUVpDTqZbC4V4kEVPSb9	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	1631	794	53	1	5122	jwvmD4e6DyGNba4GF8jtpVJwYK4g53E9PkLeFnHFgkZLJ5DrvN9	2743	3845	3845	1616631300000
5293	3NKMPHbMUzJyv5bZe2k5u9uLbysgasgdiHyGDbDn2Cb94QJW7Tax	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1513	1253	53	1	5132	jxkvQGhmhptnYUCTEACxGFjmLDSaav55k8ooav73yquJBUNe8tM	2749	3852	3852	1616632560000
5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	5294	3NL6tPD11NAL1QaXwsSo7U87iUFfECSY6YHndB1muFkmX46pZPfF	1654	1340	53	1	5134	jwfhLMPgH2j6PQay5yusFYAXCQEv147ym1kUtnUuXbtb4YS9qWQ	2751	3854	3854	1616632920000
5298	3NK6XEi8ajPYuN8xfcHSgHPYSvpttZUq3oHEwppij7uYNA11Jt75	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	1670	1036	53	1	5137	jxaGd1MPV3jHfkxeVgXgR48dqdrxUHshTdZNu2nP4y4qcMuDxMR	2752	3855	3855	1616633100000
5305	3NKEthSwkTHuxzAhJt14UkzghpQJEr8YHCBJRcL3KvcBjKfL9c6n	5304	3NKCytV65Kh6GU73Xpg7XbYj8ucmJDXqkD5BMkGdStSbJ1QgMMTZ	1577	1327	53	1	5144	jwYLgka3FrqQ2VrCtWMLit8HMmWwJjcMx88Jgitg3pirKynL5Ab	2757	3862	3862	1616634360000
5176	3NK7hRiuPeEyt2SVGsBE7g1UMwdQGqtZ5xsgRhJLXuyVZy7ZQnci	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	51	1	5021	jwHgU9wyUDPEhiPEbJYYZ9fe7HjwY1MSmf6sxFSsDHnoWqqxdXG	2687	3772	3772	1616618160000
5178	3NLSBtYG39pNjonM5C8MTHzgFCVWACAU5EMHPCxbRTjdY6qH4NFf	5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	1673	1368	52	1	5023	jwmj17BmqZgABgWCY9BvtU7FesHRoG8jwbd5w4jV3YLBz1h5fMz	2688	3773	3773	1616618340000
5186	3NKgrfKLVqayQLbALoVkYsWEzB62XjKshHrQJW87PAW72qjMsunz	5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	1477	984	52	1	5030	jwxvLWTJWLyc9gAxrxZAGQQh3nqvHad2pWQk1xMA8J1Lqnuaiad	2695	3782	3782	1616619960000
5189	3NK4CJupjhsVWSGYb2qrHF433LhhuGiuKWwLQ9W4Eh48LgSxrRYk	5188	3NLCRFrBfZCkKwuLrFHqPKbxA8cEWrsEBFhqbEkVUZ1nZFJURqwx	641	1090	52	1	5033	jxDo2r8EjByry7js9LMDWGdU6dDhLh51aX5JAJbueEYK56h7GKU	2697	3785	3785	1616620500000
5192	3NLEyFSRxrEJdSfaViNJXEQxzr8mzcux9jR39uoVRtmUxkvu3qZh	5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	1631	794	52	1	5036	jxXrTNe5ccGJ3Uh3YhXd94FHbfALG5vqFuAgYB12J9F3teGV4gy	2699	3788	3788	1616621040000
5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	369	946	52	1	5038	jxDYHzEVgtuDs8JruxAd3GNM4ukSpSoUByiGmaDkHHAN46WE6pM	2701	3790	3790	1616621400000
5197	3NKtKRSgQnyMXr1YUMVR3dhDZSCMzY4FwQSr35ZmiZatDJZeSNva	5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	532	1303	52	1	5041	jwXfQwPH5nTsyo7hQhzKAkAjp3mfqHdVMNfCR7eGTZVb9ka1aG5	2702	3791	3791	1616621580000
5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	5198	3NLtwmsPxhzD2MQ8wVsJ8vh91YNfG1dWhxf9fLL6qWxAheGjWdai	576	1355	52	1	5043	jxqKdYxqwnpKBirfjXQiWkP2cs6hGmPfdXRemY57vokF9UFGomj	2704	3793	3793	1616621940000
5204	3NLwHtLk4DyWg2pa2ascsn1KAWwYypiWW75iQo3ZddDd9fDcLEfk	5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	1406	1393	52	1	5048	jwTmyaR1YYw8eh7qwaostykQvxgWyXSvexCjYDE2Zf6wg4XnvSH	2707	3797	3797	1616622660000
5209	3NLDQhtvPvZqnnWcZN6e13vtvY2BzMQDPt82tGitP8Wo8ovg4gjp	5208	3NLeKpaztp6HmjMnsqegKGnp7YNt97kZpVyNkG8yzJ4HjRD1c24e	1622	1356	52	1	5053	jxsUP5PiGEHdjwbSfudDZEKWV6hYLiVi7nvwPCnX6Zn73uEBTyg	2710	3801	3801	1616623380000
5211	3NKXTFTcWUBydLB93djvR1VE1SrEnEWF6Sa7dR4mWMEuWRcavnBU	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1656	1097	51	1	5055	jxVQMpqeCS6haxn19JXfMHQyrztnugpaQkJ8Re48AStZF1c78bH	2672	3802	3802	1616623594118
5219	3NLrsrekBGegZctGwSixhDcmTmBzoSeRSBeeai6bqMPmbMHgqn3b	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1474	1083	52	1	5063	jxkJB3JTn2mbdPPNXydEfArYe7Yk7adeRobvREG7izvFfRRLcro	2714	3807	3807	1616624460000
5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1406	1393	52	1	5065	jxkXqbxSz45NbqqaAZZsmywmRexZinsR54PfXiY2HFtp6MBHnSW	2714	3807	3807	1616624460000
5223	3NLVPJDUpfrw2RoSXAT1y4X66SjFbDjh5r6xdJqM24Er9pzb7L9r	5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	1637	816	52	1	5067	jxAJ5bFwtEM9McBFT7i3s3fANrUSo6EtCGkSehmb2VsZ95Kvvf5	2715	3808	3808	1616624640000
5227	3NLUB7WXDqFfoJLq58r8wgAn2an6YpvxEsLy2yrTbGgs9XQNKjGi	5225	3NKpyjqjzMrHT5TzZ6XXqxVB9nRDpuX6bGjuz2zN7MnXEoaBdUja	1444	1135	52	1	5071	jwHXmZssN9qcmtc5d6YWS2yfpv7ziy7YcUdiPUGUgeMyZhYh3rC	2717	3810	3810	1616625000000
5230	3NLiVfsNhB13CFC1ehpWMEjUvtBR3VDk9qTebKcNSPZcvdGQh3rn	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1646	1354	52	1	5074	jwQ721ihRrRTXezZMkpRqVMiZdf82FMRbN2CYnvES3QQDv5L2Xz	2719	3813	3813	1616625540000
5232	3NLJcM5RxdVMhYvw2HycYxoP2ZVEbo6sphrd46yvTP6bcbBrnpNE	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1406	1393	47	1	5076	jxP4EnWyv5AF2QTMXxjdaZ9AyJsiVJs7dnXpz8s6SToMAjWAYfN	2517	3814	3814	1616625720000
5234	3NLY68wvpPsMhhBDFYGtfUQjCN3XqKBqJgzyFFxHKHCMkpqQtgYW	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1406	1393	48	1	5078	jxbPnkAYHjB2noy9PRbx1EA1DPBohx91tmUTDsWFv16kBefvhRt	2542	3814	3814	1616625786342
5241	3NLK5iDVfHYaWPkvDB8FjVLTZQL63GcP5Juteamg2JLnyzZkoY44	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jxe48eJ5Zokdopu7rWsYw8DhacPerqB6BH1GJu32JVUv2L8a82k	2720	3816	3816	1616626080000
5243	3NLw8kbke5wzFxFeMxADX6hhK4AHoBxHp5vztFTxrhHrwoZoaVjQ	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1406	1393	52	1	5085	jy37frEUeanyxhRkEeakKcBj84TEr3qhAoXsCcjgKQsUQdWVf7H	2692	3816	3816	1616626185793
5245	3NLYe3asF5pBRMSjxw7fg9nZeJksouWXrTyYWrtz5sgWPFNpB4dL	5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	1559	1353	52	1	5087	jxHEAfHKyar8fCGmXp69DfXULTsibV8bUVVwig4wKjQn77EiPZe	2722	3818	3818	1616626440000
5252	3NK8mnaKKkXjfyB3WT1q9sZMghkw1WsD5vf47Evr4mqQeY43d1AH	5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	1634	1331	52	1	5092	jxCi3NqSEHVvmEn4csbopknZHsWB1FcNNyhQ3bPCjB9oV31CMb6	2726	3822	3822	1616627160000
5257	3NKbXGkZaiSkgEPSMNMD6cY69sweenvDDAKgqePbS6Ps9ePFwdzn	5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	43	1310	53	1	5096	jwu6UpxK6wrVTDXXRM5moUR9P4g7hpLxbfw14ta3wvPmTXAbGBd	2729	3825	3825	1616627700000
5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	1633	1264	53	1	5106	jwuGBHEBzziYtE8C6TLbo7a43UPo6ngfndfearLPCBnoZcu4LDJ	2735	3833	3833	1616629140000
5270	3NLTamePjk6RSzc8cJHfbg3pSMqKrmBeomxT3h9t7foNHeCN3LTE	5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	1445	1164	53	1	5109	jxdRw7yT5hD6Bv8TL4nRiZnvSby4HsH5KZ4BZ8ZZhWPTvPCjYdK	2736	3835	3835	1616629500000
5272	3NLUX4v48rXUnNjiE51uZ8Cie7qLKdh7zLeG9qpABufZSLYtGt3J	5271	3NLK1PgysLqVUKczeiZfNcfDvprEXn9S8NWUUW6DANpCSMSknpmH	1521	173	53	1	5111	jxXvUjezk1tNr5QwVH23NSZVd7xwsjmf6RoPrwnw38prKTLi9TX	2738	3838	3838	1616630040000
5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	5274	3NKsvc5CvBBG1jSKx1WzQVdgvV2tUczV9iBbYEBDqJaHgVCQET32	563	1113	53	1	5114	jx7BU4fufBkewJt3uvh1PoaZKgmsg4Eb1T2CabM3Rfwf7magTjP	2741	3842	3842	1616630760000
5280	3NKEhaBjVccwPUGgw16FMLmVK9WUvVhwGsZY5gTNpTWBTv71d1Fa	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	1406	1393	53	1	5119	jwBFDoG4uZUYGGpPrFTcxBzHiDrJRCfJduDvdjUXQNXiyY7fEkQ	2743	3845	3845	1616631300000
5284	3NKuMVz8TP6wUKWNVU3aUEwkJw6YAkgYXAi5wTPPcRfzAKadNJnL	5281	3NKZpt9ZwtGTVH8DYbga5RaUWSayGNGBLERAnVHukrDrENwZ7WZT	1405	851	53	1	5123	jxUhsTuUA7g7sJcsRCrzFKPRHpKmwsZ6MrC2GgKHPciHxsxhedu	2744	3846	3846	1616631480000
5287	3NLTwyCAMypN3q17TmkTHc3shgS356HLpjWSbSjNpssxNHF6jZ9R	5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	1622	1356	53	1	5126	jwaY5CWC4UMRAK9S5NTbHUbY3Uo1ts6BxKJe4bamoHSKAxZkvT9	2747	3850	3850	1616632200000
5292	3NK767BxXnAWc6wDa4fjfYoZUn9e6Q7RkzLrhaYgBBYgagxuNcSg	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1619	1275	53	1	5131	jxPsWyrhbyDhTx3vevupf4CfT2L7whif4M4iKAvCqRi4YLVJMtY	2749	3852	3852	1616632560000
5294	3NL6tPD11NAL1QaXwsSo7U87iUFfECSY6YHndB1muFkmX46pZPfF	5293	3NKMPHbMUzJyv5bZe2k5u9uLbysgasgdiHyGDbDn2Cb94QJW7Tax	1590	1174	53	1	5133	jxa1n5wSDbJFYenU195ovyhEEVaEV9zjP2TYNFQk2koWxnpmHVj	2750	3853	3853	1616632740000
5285	3NKuZE6AxjKYp7hmesaHcmGs3cKGHHwJDz5MhHrLQCceNhwHmULz	5284	3NKuMVz8TP6wUKWNVU3aUEwkJw6YAkgYXAi5wTPPcRfzAKadNJnL	1406	1393	53	1	5124	jxLBxveoq7iJLm71kAsTKJFfwqqjiLysxT5wFzaBQkcLnGemtUn	2745	3847	3847	1616631660000
5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	1406	1393	53	1	5127	jwMEJVRNoyLkL4a6d32sKFhzdSnqQy1AUGR3GPjqp7nadBAvPPW	2747	3850	3850	1616632200000
5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	484	1319	53	1	5129	jxeHY8CPiuQ3xtyi67pVXZNCF5SXA6skTHp8jF89UGwyJSRVJC6	2748	3851	3851	1616632380000
5300	3NLMcghGoPXCVkjckstzmLdjXYomejxrR49pH7TPzSiav2hRD4b5	5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	641	1336	53	1	5139	jwoDoJJrP7Vdp85PGY3GfNmzVnJjvr7ou7oWsKKNSpVeXmYhvsa	2753	3857	3857	1616633460000
5302	3NL5nqybbVrBnn765Db9U5AbrQgVbJwzmLy987ETVM8DPZLG8L4g	5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	1476	1125	53	1	5141	jwo5WQEWsQFY8XgCsmDB321oP6un8XehKkCss6NU9mDDkdB1p6i	2755	3859	3859	1616633820000
5304	3NKCytV65Kh6GU73Xpg7XbYj8ucmJDXqkD5BMkGdStSbJ1QgMMTZ	5303	3NK76hNHsDh8Q9AFaNj6W9aERKHce4gxTKVou6GEeWtBMJQEuM94	1637	816	53	1	5143	jxQKYHnPUCzKd8bX3SXxsAgPkiMX8s6ngex6m5ATqJwGhoNkM3D	2756	3860	3860	1616634000000
5307	3NKuVzPJmdDZFvsWvScaVbpU17i4VNFdZwYBpgCnovCfe52hjo8n	5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	1672	1039	53	1	5146	jxwnnkMQAghwijz9kGL5usPTVMgNDwDxafhRJjqJZS8nVBTrATn	2759	3864	3864	1616634720000
5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	5309	3NL9DM3XYojon7PbpRvSCnhHnHTFmD8JN4G9yZAv7SgcubeJFQ9p	1634	1205	53	1	5149	jwtUvAfjwVfKhkjbv9txutifVt1j2ogZP5wVCcUqCnydttn9iHj	2761	3867	3867	1616635260000
5315	3NKrwNDz2jpxEZWUTDjh88ksfkKKhCAJCfcC7ftyaCP3AEHfkh9M	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1622	1110	53	1	5154	jwbiCVrYWetMjmpJ6BvpSr17bLNM3Kukb7khMLvsHLzvfAox5c1	2763	3869	3869	1616635620000
5324	3NKvRda4VS8ZNBcGaSNdteuAJAzYvnJmadY8Qug1H7pwmUjmDxED	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1564	972	54	1	5161	jy2EoXCYcu4YQRYAPVrA26HEeW1oma6meks5KDym9kQ9CHnMHKy	2765	3871	3871	1616635980000
5325	3NKC3HWaJC6WCrTtKNGrtBwSBZ4pnBGaRCp6QUsVAwnyPoTr4NGC	5116	3NKQHpH4zkNhU4MWuSGz5hwWZW6zv8eZFFyZLRaav3M7aHFz8PTX	1518	788	51	1	5162	jx1AiciCTWTQvphJwx8RELbmu75nEPDctNaF6Y6PScbaAtRnfFG	2656	3871	3871	1616635980000
5327	3NKUcCeKSsNSh3vcCtzNMypaYtjBDgKF9L2iGpmnqm5psQ8KKiVb	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1542	1304	54	1	5164	jwPzy9wG2ueaTXm9Rh4v5tx18J1kPFbapYfffPprQjxGeMNFo3H	2766	3872	3872	1616636160000
5329	3NK7VQ79TAV3QyvGATbhJ22FCPQK282AKWUChuwo9C98sTQ1wbWC	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1406	1393	54	1	5166	jwKyZgu8mGbTZ6cni1FVxEuHDTueGbSFAvXjgQMTMp4hBKiaa2s	2767	3873	3873	1616636340000
5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	5332	3NKtphbEgyDMVJiJcpCn5yGkkZ7733v8NXoWTWQvmiJktfz1HEaN	1585	1240	54	1	5170	jxt1s9yk3Z6Xq4CkrdEcz2paoCkYCFs38hgBVRWdVBxjqPPgjYB	2768	3874	3874	1616636520000
5338	3NKiPreKmXZ9BXkzFh87EAzpFTGDdnqt4abqGNi1ecBsjgSud8hn	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1637	816	54	1	5175	jxgobVbvG7UCoMFwsprM6Siu71tPna4pXGc9uhcGAhxkVeW22bc	2769	3875	3875	1616636700000
5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	1573	1318	54	1	5177	jxpbv6sEPqAbEG5kn5Lj2Q1625oy2UDKvnLm2uouxVwXHwMpqUp	2770	3877	3877	1616637060000
5342	3NKxKDBeuEw9TQees9sxUMmxmULLzgQxuY6YruyZvqkKUZouthzn	5341	3NKueNYRFNkdEreeko5CxLvGvZEwqpmC9mDzbKtJbuBUAWADJQgd	1406	1393	54	1	5179	jxNtYxkSkCXYxDh6ou1653YuSMWMfdW4142sf6yukkCTfJtpNVF	2772	3878	3878	1616637240000
5345	3NKfn98wHEjPePrzkCQ2ZdXbpF7FAHu2GjzxnZZiubgieF6hSb3H	5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	1406	1393	54	1	5182	jx4rjNmyjHS4Zz5RVNHtRdLMn8Ls3eYwtbZpZR8GcLVVmu2bkWZ	2774	3882	3882	1616637960000
5350	3NKMbsJLTcGxJzTGWx8NAwSewNtjzG4q1uV6WquL3W4xpPiRCbGe	5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	470	1309	54	1	5187	jx7JsDQZixPvS9jGJ29k5V7dHiJp2AHKmvEy5R9aEzEAsZ91nKD	2777	3885	3885	1616638500000
5352	3NLQvPaJ8F2UEVtKfXtnF5MXpYkr1x4eeJY6q4xm2TAfNFBbSuTC	5351	3NKLS2csviHuuq3uQENNctmjvbUHQv6DsnTxXL9mmzz3teBW6biV	1637	816	54	1	5189	jwoqSTnd4i97dCZfeo9gWuYDHxKQ7MxpojuJaQFL1c61LaQaLoA	2778	3886	3886	1616638680000
5355	3NK6eMdZd3ogSerJKBcgTMyYSbri24rHqG7qdrnpdJgQaJLEH7nB	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1547	1378	54	1	5192	jwmVxRK5vwXY9UH2HL7XLrW9PT8kju97fZq4ZidV9ao56WGAgm8	2780	3888	3888	1616639040000
5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	5356	3NKPsnC1prwP9ATv6zkmeyKq6hZqcquwxi23AoKg3PXiqNKFnay6	1587	991	54	1	5194	jxcR7xvGgWArn9oSSgZAkrzbfDh5xjprQKYTynxe3S6mxvt2rBS	2781	3890	3890	1616639400000
5360	3NKeYrWciKDUY4AgQT1JD9KFsbfL63S1ULWJT6LNArH8GT6qyoyK	5359	3NKZocHkGDpGWAfUFfNBubfcNuLJ4dAD2F9mog6cSEKP6zvj9jCG	1534	1317	54	1	5197	jwCBwtLJp8Q4bg5ky5LmergkgnbpaurXmqnXZtFwwZmHvMKFZDn	2783	3893	3893	1616639940000
5368	3NLnMx5yAhfpsJKiCtdcPXrGgAxqt7ksRJ4jvTr7tTBXJ412KbBG	5367	3NLSnY4ZjcBEiiCMRE2P3BwxmzCt2Fns982ZVR9aadp4i5hxvjij	1406	1393	54	1	5205	jw9N91WseNBQVV9qHmr52vdMo5s3HkcJSwxsSr86YvCNuU3gmu4	2789	3902	3902	1616641560000
5369	3NLkNqadps92hEDZvJxHY8T892TvA63HY7BCdieccukbFpxrBjgZ	5368	3NLnMx5yAhfpsJKiCtdcPXrGgAxqt7ksRJ4jvTr7tTBXJ412KbBG	1553	776	54	1	5206	jx2JnJs23tjs9foJfeb9EtAQBnf52NabYN6JsXQENYdoEQm9jt7	2790	3904	3904	1616641920000
5371	3NKSwwmMh8jg6dAJ9iEtt2QDsuQRnsLqre8uUCPzL4ei8WmFyQBr	5370	3NKKeyMFkrRVWrLonotARr6tXXxfqewzb8eovrP5vGTPx519x2hN	1633	1144	54	1	5208	jxhRWepjvBbwPvffffypDXM3K8oZWQFufYH1gQWf4Rk6DF4CTtZ	2792	3906	3906	1616642280000
5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	5373	3NLoZUP5JvPmnqCF8YVnQn7iaxKy7Sjn5z5AGgjA2YZpBcY7htVw	1633	1144	54	1	5211	jxmiuS8sNDpbDdD8Jq33UiDYHNog1yZpZRf1Xqqg73BhbKL5vDD	2795	3910	3910	1616643000000
5377	3NKkgm1G1qgLAm1fhUsMjXamjAMQ95ggKc13PG1xd3KmXuAyejfs	5375	3NK57N8Zm1dbJzZsVeU8SXDmtzvRLzerQsW5sGievbw1wTTTPx5s	1536	1067	54	1	5214	jxZUSZWGV4rE22MRvWStSA5p7ayhxacDsYv3TasBuW4YFbrMtko	2797	3913	3913	1616643540000
5382	3NKFgumEn2yNiQgtBbBqfkgsr5ascWEjMeTgwMdVNErc3KC1TidL	5381	3NKkQ5bMb1YdsGHs5BUJo3cdZHBMca7UAsMeX9Rmt6ndj97TVf2Y	1445	1290	54	1	5219	jwqrbKnDAZpArQRmUYrpTemGW7EoPj3pqgeYDCGH84tHHkp3HWw	2801	3917	3917	1616644260000
5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1406	1393	54	1	5222	jwRaWR9z19935vFTUEHoB8aqEfugpgzuFWiRys7HCtJZnV25mSp	2803	3919	3919	1616644620000
5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	1406	1393	54	1	5228	jwoTUN5gvqS194PZ4T55vGVCBmVxiPXESYTFKg6RR2H7zisdQki	2806	3922	3922	1616645160000
5398	3NLiWeMnR5Q5TUwrp7rY9N1A3jtB8UbPPqU5RvTXExfGED25ZLiQ	5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	1637	816	54	1	5235	jwXZxAnMkqtMZ3B33arVJXiUDaLSmhNJWQbUAENPJwBGmsZyPEu	2809	3925	3925	1616645700000
5289	3NLZSKjh5zkZFWEYZozeAkauwYAXq1YNUVFSpqqafEFHBnkPWqbE	5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	1422	1211	53	1	5128	jxEPbqQopdVmCGHHGCq7pLvWtHxzb9HrFJbbeFcbfSMXLTgTrVN	2748	3851	3851	1616632380000
5291	3NLhc55hnKG4GJnTUUS9Ux5fiRGpu1NLiKULhgDxzJ8JArJ7Q9pS	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1460	1324	53	1	5130	jxeYSGqqb44Bophmi7ytWGaktVE9qf3KJZ6MP94Fci6KYzrwpRR	2749	3852	3852	1616632560000
5296	3NLigRQNHFsv9NauKuyW8XM3g2RVMwgUKP5cJE3e2o7VcDcDLaEA	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	448	1059	53	1	5135	jxMC4YQiiBGu18DgxDT2bKHhNPndtJBmLyW5jfQT3tKLjYE8BYr	2752	3855	3855	1616633100000
5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	5300	3NLMcghGoPXCVkjckstzmLdjXYomejxrR49pH7TPzSiav2hRD4b5	1573	1318	53	1	5140	jwcwDkKa6wGX5y8p9StoooqGu1CUGnxTrTF8BVLYQUdmLXTbVNk	2754	3858	3858	1616633640000
5303	3NK76hNHsDh8Q9AFaNj6W9aERKHce4gxTKVou6GEeWtBMJQEuM94	5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	1637	816	53	1	5142	jxupLFs22WyAus1DmRFnJFpkw3dF1k9PLtzdqSi7m6FCS4rneXx	2755	3859	3859	1616633820000
5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	5305	3NKEthSwkTHuxzAhJt14UkzghpQJEr8YHCBJRcL3KvcBjKfL9c6n	1589	1040	53	1	5145	jxrDTJFKY4bLdyFtfhpSxJ1LLyTz89E35UsY4aXaJGEjmZbypR7	2758	3863	3863	1616634540000
5311	3NKEaMfU47WbPXm8H9PnhP8LPmCgiugoBG42urNKyxcrFugyGYi1	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	1447	1345	53	1	5150	jxx5ZsdtXbkz1G7hjdvwAKcEv8uy7RyNibkLkjNrCwAUeAs3TFd	2762	3868	3868	1616635440000
5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	641	970	53	1	5152	jwozbAY9hNB6AwsZn4FSddrh8BcDJwBgGytrst7VChBZB7diVtb	2762	3868	3868	1616635440000
5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1648	918	54	1	5159	jx6gKVrCcw3T5nwUydfMkUQmmS4U6YP6VHXmK7f2d18mHwkenpp	2765	3871	3871	1616635980000
5335	3NKAUUcAx7R9Qcm87YdyYWCdUDMqTqgkDdqMMPnGLTaqovUGwRh5	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1527	1047	54	1	5172	jwv9ofRwvNNkJXyyKHrJXDXneHRPvK9cmuYBywP1bNXynZ2jR24	2769	3875	3875	1616636700000
5337	3NLP237GwYY1F3Z5Lb3P3LzfVzz2wwpU4y9hnCJX6RfCeDSGqKwc	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1581	778	54	1	5174	jxKYNfxax9yRXpKydXEeQ2ZbL1t7HhBJBG8sZ1hRB2NjZUDTmRf	2769	3875	3875	1616636700000
5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	5342	3NKxKDBeuEw9TQees9sxUMmxmULLzgQxuY6YruyZvqkKUZouthzn	1483	691	54	1	5181	jwvYbVnuGzN257qnJubygVv3ai6Hw4TBqVmmMj5EMMZwqqgLMFj	2773	3881	3881	1616637780000
5346	3NLb5nrexXkJjkgm8xkM67WAXqZzDgedhG12Qshc4MgeL2X8qcrn	5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	1637	815	54	1	5183	jwiCaaBHpTTyKX5L5gkENb2cNTwiEgP7yG6sXrUE5zdFN6jEugH	2774	3882	3882	1616637960000
5361	3NLmhuA2cw1aYa6ETizdBacFKeU4r9awn7BTxKMwaU6hLnNdmK1c	5324	3NKvRda4VS8ZNBcGaSNdteuAJAzYvnJmadY8Qug1H7pwmUjmDxED	1534	1317	54	1	5198	jwuv3gvrTSCDoDqcWkL2sQbN4TbTajdP6rjvtYYvhNC7ffV365B	2766	3893	3893	1616639940000
5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	5363	3NLjSXRn7yHe4UxXTVAjQNLxfEbK5TEw3Psv75bGX9PQrePGwcct	596	1306	54	1	5201	jxNJNry1mExp4JH4omLnreDrLD25gCkSRUtukwHWFm337JsGyRn	2786	3898	3898	1616640840000
5367	3NLSnY4ZjcBEiiCMRE2P3BwxmzCt2Fns982ZVR9aadp4i5hxvjij	5366	3NK6H8kuDohAhNNFzRTPRNhpGzZyk7QtbC5duFopPuPF8amR1vaS	1402	880	54	1	5204	jwsHUFBKZqxpe4ugTVAd5dsMrQnE8dnkbkVjqgMss6Y2RyXsR3z	2788	3901	3901	1616641380000
5370	3NKKeyMFkrRVWrLonotARr6tXXxfqewzb8eovrP5vGTPx519x2hN	5369	3NLkNqadps92hEDZvJxHY8T892TvA63HY7BCdieccukbFpxrBjgZ	1581	778	54	1	5207	jxidAjtBByHFLFoC6rt5WiBkq88ZxNqxkvFr1Riv4W5Rvps6YzV	2791	3905	3905	1616642100000
5373	3NLoZUP5JvPmnqCF8YVnQn7iaxKy7Sjn5z5AGgjA2YZpBcY7htVw	5372	3NLWjnZi56HSguMcCromLQpiQQULd1r3V2kiDu7ksPkuQg8knknh	1637	816	54	1	5210	jwZdcushnRAmXYnttW823CnKZmTtPJMzWGrC3kqVjG7ticB8Lxc	2794	3909	3909	1616642820000
5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	5377	3NKkgm1G1qgLAm1fhUsMjXamjAMQ95ggKc13PG1xd3KmXuAyejfs	58	1281	54	1	5215	jx1RFRJqKzXHNHk7jwts1XC3kp7MFvVCozZYoPvFN6ysXCXQGiU	2798	3914	3914	1616643720000
5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	5382	3NKFgumEn2yNiQgtBbBqfkgsr5ascWEjMeTgwMdVNErc3KC1TidL	1541	1298	54	1	5220	jwn4gLgbvSaZTsBZydRkDF76G8vsQNtxH7mckATTSZABrTzw9bn	2802	3918	3918	1616644440000
5388	3NKV11eLomUULL7W7JVLBRjVGXKfLDSB8tGdga1fSoXMCp48G3ah	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1599	921	54	1	5225	jy2YikA5jTkWP5fog1G658hscCnBQYmxGSyg7aXWGRnjoLKNMey	2804	3920	3920	1616644800000
5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	5388	3NKV11eLomUULL7W7JVLBRjVGXKfLDSB8tGdga1fSoXMCp48G3ah	1447	1099	54	1	5227	jwiLZ3HykgLanND63vDL3AXR4hzS7bw7MWvu9pVpBT23Br9bWKA	2805	3921	3921	1616644980000
5397	3NKg9cHtYP1u1zGhr4xifYirhVvRgiVsZedYTrWiyug1zWNyvusx	5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	1623	839	54	1	5234	jwsiyMKDBcf5PXiRFKE6e89LtHgP9hqewYbojEWLmSwb7LsTJFU	2808	3924	3924	1616645520000
5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	1634	1331	54	1	5236	jxi7cXhvmxzni1We5TBfUzXniCd6vPe3x1t6VwfskaUANeaVq4G	2809	3925	3925	1616645700000
5402	3NKzVpJYK7M8Ydf6SCN2bLP348v2ZbEBufvS8Sr9Dwbk93rMcmXj	5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	1581	778	54	1	5239	jxoyTMf3HcDzfgthXju4Sq64TAB8NzUc6SQKioQ7EeVVukk6cPQ	2812	3929	3929	1616646420000
5405	3NKba7XxW5kwy6weg4WAGU8tPczmauwdxvCQNG4BRH3amAHRTkN8	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	80	1147	54	1	5242	jxAdKb9Lvjb3XB8LEczX88pweyiJQMFnY2My3y2WkABGYZUT36F	2814	3931	3931	1616646780000
5409	3NLLbPitDFencJqs2621bcvZCDGbnvUJzYw7rp5jtq4y2Vd6jFam	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1549	1116	54	1	5246	jwyo5Hf6cNBS7FDkdC9bjhwEwAJuuW7qyi3q1Cw7UfQyYxgfGzD	2814	3931	3931	1616646780000
5413	3NKaSsWxzKf9psFX8oG8QdQ4TLmmmrQRzTNr7EMwNmVRzFuWWj2g	5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	43	1184	54	1	5250	jwdqcmDNL7QTSWsRDtfmHGWWdqjoB73aMqB2SM8T9btHjmKqhM3	2817	3937	3937	1616647860000
5417	3NLgRiQ7NU25HNsVgxatGx9JpAQbtJh9s2W7Y4EcdVSj2tEybtQ6	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1460	1324	54	1	5254	jx3735yUyrjKeWC1JUWDQbHz7ewNQnsoc1hh9y5piQJKB68wCzv	2819	3939	3939	1616648220000
5420	3NLJMMXrT2WQKTdaJPKxE37exdbKm2QBTtywfGJEHhEBUvHZsKQD	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	606	1049	54	1	5257	jxb7E31bCAXApsy5C14HojvMh2ebiw3xwoQ7YxNpxN6qvxMzpMh	2819	3939	3939	1616648220000
5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	5427	3NKwJsPNRT4NnJqUkGyKApebdQjJ1WiFjAftCwv6zWp8o66DUMev	1406	1393	55	1	5264	jwQVRzUL4RXNKqzVj3ieo47T43d19ZrNWjMXXXjbnSD5mvXdFRc	2824	3952	3952	1616650560000
5434	3NKRN5vGtNoEHV1nzcy7Pg13YCp8NfgtJW2ow9fyPjxgKwmbsS8a	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1627	1139	55	1	5270	jxkPBdkxjFysBq8WjG3jSHuzLAbG1fHTrzH39zeF8WzKMVqwf7m	2828	3961	3961	1616652180000
5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	1457	1265	53	1	5136	jxnC6d6CKqx9eEDD41xbM3L9Sb985uYbSb5VJWUUPAZxwzf7Eso	2752	3855	3855	1616633100000
5299	3NKS26oonyS5EGf9Yd2V7NWZo9QC3miKZJJyUwYoALKE3Za7uZKA	5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	1403	792	53	1	5138	jxBqkBXshjNAFE1WuKy54fUw8BRcA9xVcDo2E6s8pckYR6ofdez	2753	3857	3857	1616633460000
5309	3NL9DM3XYojon7PbpRvSCnhHnHTFmD8JN4G9yZAv7SgcubeJFQ9p	5308	3NLisrdFZ2ZztSLbjVhrgemoP8DWGPbdddRFbTKNLDso7HtWoKMg	1637	816	53	1	5148	jwpDCFTbfLKSeH1u4p1rsSuXfNmaAMxARggPofrmk2BGVCY2B89	2760	3865	3865	1616634900000
5312	3NLMEJGJMmmwRpgwJ5z342jBtgQvy4JTXrhPLMHrELyRQndpDAtU	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	1402	874	53	1	5151	jwexzLafdRaYbzAEUfbatV6XSyXTgDcbAR6BY6Z1EqjD3fazGmL	2762	3868	3868	1616635440000
5314	3NKf28MjRjHGEZm2irWzbd873obDpu8pCMb3UaGdiReQWJT92oLC	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1593	1346	53	1	5153	jwV2Zah7hK8ggZuxtSGYPPQCKCwL4dp3V8iwd2rXrpfu8D7P4gz	2763	3869	3869	1616635620000
5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1623	830	53	1	5155	jxDV2vp21jRJQUn4QcExXPoAuN5JHLwiKH9MggiuMdxsbc1vLTv	2763	3869	3869	1616635620000
5318	3NLCVirawa5hG6sVYUhXa2BSUjBkTMBNof5HnCeZdo9kMH61ENxx	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	1590	934	53	1	5157	jwPrJNLR6hRnYukH7fiGKVGkAi72U3gLwFE21PTKQZe7kmPp6GD	2764	3870	3870	1616635800000
5321	3NL1JNCCZ1ku3yT728fe9ounZqSqFcJX2NcFnaofHMAH4s4hAL97	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000
5323	3NK9FaNf7zQ3G814TRTj4TPokvs2gJkvWSSXeHDdqLbhCswqtd14	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1518	788	54	1	5160	jweS4vG6Qf6JQGNEQP7EerrP1zE4C1Ce1Nc2bBbT7uitdsteRLd	2765	3871	3871	1616635980000
5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1406	1393	54	1	5163	jxPyrh4VBTtwvWtjjmVaRrEPR9fHvsCuqiAEZrcBXpoffpXPq5V	2766	3872	3872	1616636160000
5328	3NKhaFJCm1Swwr86KYpFmUhsTkitaXTFhfQx8Rm9wD2P7Y6SVu43	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1601	1388	54	1	5165	jxKuPuJnyHSFqHAyA195LWpg5QobJQPrPru9zKnKtwYckjVys8q	2766	3872	3872	1616636160000
5331	3NKC7bihvP2aKa4BhF2Tvrevw3ogyVhaNdvTvcn9FdrJ5HVWoRCR	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1402	796	54	1	5168	jxLCALkN87w9NfTrQjv5KdkNSP9yBw7a9khM9FGUMAn87qd8jaB	2767	3873	3873	1616636340000
5339	3NLjjZ8Ud5qao7eugFuAMjaMnLTQ1WjMXvetED5v3hkprKgy2MxM	5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	1607	372	54	1	5176	jwTNeb1S7qPd1rZ1Rs77sqVZjLTggnnyChn8zyegMpE4qSk8ZY6	2770	3876	3876	1616636880000
5347	3NLn19MXXnPzMGDCro6f7ErQ8MQ438DZeHKKyFbW6MJWWqdjYPRy	5345	3NKfn98wHEjPePrzkCQ2ZdXbpF7FAHu2GjzxnZZiubgieF6hSb3H	1652	1189	54	1	5184	jxFHSDhWp1uSkmm5P6AHhJnq5p4qDwn8TnRKWw5J4uEj8SujD4d	2775	3883	3883	1616638140000
5349	3NKaiV1iQ3i1NQqKTah8ije8QbKE26A7tTkdiRkViX8kPgUYVUgQ	5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	1573	1318	54	1	5186	jwGKQkspkMo6wu8BccUEMHbHTXr5PF9PbY7JXdVwHRGXUEy6vPt	2771	3884	3884	1616638320000
5354	3NKXTGABaRmQrLCy99iBSzDZjt4cBi6UMaioZkuDUHaXacafBbDh	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1671	1239	54	1	5191	jwbXuLw67tbK1aGrB6YPNSBS9UaB7iT8r4hRmPZVpEMMs79tsQx	2780	3888	3888	1616639040000
5356	3NKPsnC1prwP9ATv6zkmeyKq6hZqcquwxi23AoKg3PXiqNKFnay6	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1489	1014	54	1	5193	jxbPneB7GzeD4ixJR9cTT4iUGcL4fDtrqjRqz6ZGQxUusb8z4Rb	2780	3888	3888	1616639040000
5359	3NKZocHkGDpGWAfUFfNBubfcNuLJ4dAD2F9mog6cSEKP6zvj9jCG	5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	1609	967	54	1	5196	jxc594vaXRwjaxCx7uS9Dm1NTVPDfqZRYn3RH1X3dxXW6tQ631R	2782	3891	3891	1616639580000
5362	3NL6G1sLuU6Ua2t5xTTVd4U1CraM5sHxsqcvWYBZuZoL7j3FXbwE	5360	3NKeYrWciKDUY4AgQT1JD9KFsbfL63S1ULWJT6LNArH8GT6qyoyK	448	1305	54	1	5199	jx4A8FB1aHxfrwyHxE9FCBVJ1cC9wDzhnSq4vvJ7pYCw5qg67Lw	2784	3895	3895	1616640300000
5365	3NK84kj7yFZdthd4crb7WJi3vDJbTMkY81Sjs3aUuBdYJYvV9oE6	5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	1406	1393	54	1	5202	jwonpbHTRsKJGHEq5b7JcGt4cZCKYRAE31uVA1Wk3MFQyn2XVia	2787	3899	3899	1616641020000
5376	3NKgHAdqJ1htixnYuXTeW6VxkS5zYAjusqeRRgyQhEcSqEDnJZMt	5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	1631	794	54	1	5213	jx2Qy4JNEDUUXUVhfdGHZi8aowbgNE4cYSYL4GWYP9L982xgHrE	2796	3911	3911	1616643180000
5379	3NLFPMHRNiBLFvYK4VmtGnKw4JWXA1iGYwrHrR2dtDU6VBRjNJ8B	5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	1406	1393	54	1	5216	jwfFonTtVJPWU5MdjyqwXMwz3HE6p3YxX66fxv3wfxYqehEUqDA	2799	3915	3915	1616643900000
5381	3NKkQ5bMb1YdsGHs5BUJo3cdZHBMca7UAsMeX9Rmt6ndj97TVf2Y	5379	3NLFPMHRNiBLFvYK4VmtGnKw4JWXA1iGYwrHrR2dtDU6VBRjNJ8B	1609	967	54	1	5218	jwggKDdHGwmSLaxfbVG5ZTSX8WpejtvaAc3gXsTHirCXWf86TsR	2800	3916	3916	1616644080000
5384	3NKhJjZsQvHTA8Csux3YCLKFuTUeBC55u7ejgmDguyYhnvotixwC	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1483	910	54	1	5221	jwzQ3QErE1mABCzJHf5Ef8F9Y22mfa359vpq9sCZybNoUCqrZh3	2803	3919	3919	1616644620000
5393	3NL2iGUtDVdeewHUnz1ocN1ENAWLZoeSSDwXX1HJifigqm64NKGH	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1608	1163	54	1	5230	jxUmUWgjrSUWDws3daniUS9sw26pBwP5HCebRfbn9u9htFjKHuq	2807	3923	3923	1616645340000
5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1643	1299	54	1	5232	jx2zq8gSm8XHxghhcQK2cDyTMeHmf2H8SYQZYHRGwtipGuzKRBQ	2807	3923	3923	1616645340000
5406	3NKqQc5tHHReEf4FcKEBaLSHGZLPk6vizNH4TGL7kQzFLgQ9s4Ts	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1649	1017	54	1	5243	jw9RzS85QoebrUuTxuFUQmQ1LgJA71TWcQZgFNGuiGznRQZ1PqK	2814	3931	3931	1616646780000
5410	3NKiL14baAWii8MG43qFJiZUivfmk8VHYaqkk59m6vhskKpLwGjb	5405	3NKba7XxW5kwy6weg4WAGU8tPczmauwdxvCQNG4BRH3amAHRTkN8	1448	1311	54	1	5247	jxqqQxDT1TpUBxbQ7dLykApuRzUpmGjPfzHcqdd5W1Yrg2amiBc	2815	3934	3934	1616647320000
5415	3NLF8uU5AzQUdGLP6oZcuLegLVzuZ9DkaCR7gwCbTgfW44r2Vnxc	5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	1402	892	54	1	5252	jwqZCbj6t59wHhXiMqJrwiXTjLt8oGKBMoUYCjKrGuRZqDnosgA	2818	3938	3938	1616648040000
5418	3NL4gbgcRViFY8p6oPpAfTHCqnWQqUQCTJpcZSqs6wVBA4BRyhzX	5387	3NLgEiycytKZSwtJijbt6ZeEdge7wZW264F8bEf8s7QFwNTEMoeG	1460	1324	54	1	5255	jwr64THV35zzHwwJsRqv8gmtzcT5iSgSmx7PkhRcT3YUqmJHuVW	2805	3939	3939	1616648220000
5422	3NKV92j5WbuprD5tQeQHaLaoJoAg1VobC7UXCJ5reZodVu7XrDPf	5417	3NLgRiQ7NU25HNsVgxatGx9JpAQbtJh9s2W7Y4EcdVSj2tEybtQ6	1529	1316	54	1	5259	jxatpB8MVkuWQdwf5cG5gLT14NyhNELLC7zYRYRXC3B3uP9SWHC	2820	3942	3942	1616648760000
5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	5422	3NKV92j5WbuprD5tQeQHaLaoJoAg1VobC7UXCJ5reZodVu7XrDPf	1631	794	54	1	5260	jxbxog1yv7QMCG7z4dxiz7rP3o1KJQNGB2o1GanBDw15SpkhfJc	2821	3945	3945	1616649300000
5308	3NLisrdFZ2ZztSLbjVhrgemoP8DWGPbdddRFbTKNLDso7HtWoKMg	5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	1654	1340	53	1	5147	jxwx9gmxk7TbyfG3x7VqvvvbgkftE53JH7PCaevWkm4gfTgFBNY	2759	3864	3864	1616634720000
5317	3NLN796gZAG1U1vL2ZSkgXnFGSraNsxgQe6AwygvnLfpHj21bYTK	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	1406	1393	53	1	5156	jwrh26Av7XRrepHnLEAj9QLA61ro4SKWRs9jwnrnm9BAzd7MwuT	2764	3870	3870	1616635800000
5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000
5320	3NL4nPTtcPmK8wFUiFxuy1QHeeYgkCW3wmjY1zwJNF52Q1eUC9Jq	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000
5330	3NLhUV9xCoEQwAm6h3tXag9EphnLS2s3mUB4GGrPuaaYCbhTeZPV	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1467	1376	54	1	5167	jwk77FFXy7KQiH2eNFknRTVkhLM1tuMgCkbxPvK52d3Xe4B2Xtp	2767	3873	3873	1616636340000
5332	3NKtphbEgyDMVJiJcpCn5yGkkZ7733v8NXoWTWQvmiJktfz1HEaN	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1455	1332	54	1	5169	jwdVVZjXmaXGiP6eEV8mCCDdDcMrfXogqwXCW8sPavmTk828usb	2767	3873	3873	1616636340000
5334	3NKx9aXBUpVfCotLDqoxjbAVNm7oJhESR6S2pdRi5FD3fmS9ks7S	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1649	1257	54	1	5171	jwDQRa8u96461GG4o9iqBujUcyZ4k6UkFHGidhHcczTtyG3T1iy	2769	3875	3875	1616636700000
5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1501	1360	54	1	5173	jxnNL6wfAorwtGmP6FcniHrkLMozqLUger9tAaifHf2D9f1U6yG	2769	3875	3875	1616636700000
5341	3NKueNYRFNkdEreeko5CxLvGvZEwqpmC9mDzbKtJbuBUAWADJQgd	5339	3NLjjZ8Ud5qao7eugFuAMjaMnLTQ1WjMXvetED5v3hkprKgy2MxM	1650	1375	54	1	5178	jxJ4Vi1iqgAght4NdHkbSL3JWZmRXkt9ZjqjMFbASvkzdiaFWXE	2771	3877	3877	1616637060000
5343	3NK6viyiCTsR1C71DJg3Qm32A2qePjMxoytnTGMtf9htTPjMYA1K	5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	1403	824	54	1	5180	jwhLvVPFKuw1Hy49nnmm928UsYFrUPxecWM9wS3Mf28wY8xGS8T	2771	3880	3880	1616637600000
5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	5347	3NLn19MXXnPzMGDCro6f7ErQ8MQ438DZeHKKyFbW6MJWWqdjYPRy	311	1307	54	1	5185	jxrhTwtKsDUTeh54hzN2SGrt7SsCSG24XFkavC6XojUHQkKfGBw	2776	3884	3884	1616638320000
5351	3NKLS2csviHuuq3uQENNctmjvbUHQv6DsnTxXL9mmzz3teBW6biV	5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	700	832	54	1	5188	jwxBDBL2QLYsvFMbA4acZjZsmUEL3JbViBofsDqN4WisQzYagxv	2777	3885	3885	1616638500000
5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	5352	3NLQvPaJ8F2UEVtKfXtnF5MXpYkr1x4eeJY6q4xm2TAfNFBbSuTC	44	959	54	1	5190	jxz5R83uoXx7e7xR2ENaevkR7NCov5xyBsHbNKukKddN2YE1Jxh	2779	3887	3887	1616638860000
5358	3NKeez4CxYkCBpJc7dxxYnmNFFh4RagphdqMJxFVxmJAnT8fJ8fN	5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	1406	1393	54	1	5195	jxJo3jaGfmzL7wY6v55pR2zcVzUQEy4nP479peKB81o8XQ4PjwW	2782	3891	3891	1616639580000
5363	3NLjSXRn7yHe4UxXTVAjQNLxfEbK5TEw3Psv75bGX9PQrePGwcct	5362	3NL6G1sLuU6Ua2t5xTTVd4U1CraM5sHxsqcvWYBZuZoL7j3FXbwE	1617	1042	54	1	5200	jxVbeq8HLdSwB6XvQQbJdmb85tFLQPoqdtgUuoYjGYzDdmth7gn	2785	3896	3896	1616640480000
5366	3NK6H8kuDohAhNNFzRTPRNhpGzZyk7QtbC5duFopPuPF8amR1vaS	5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	1643	1053	54	1	5203	jwdc3B4XdFBvpYn8k22XymwYybHbHyM6HAvWWPFfivSveVjhiN1	2787	3899	3899	1616641020000
5372	3NLWjnZi56HSguMcCromLQpiQQULd1r3V2kiDu7ksPkuQg8knknh	5371	3NKSwwmMh8jg6dAJ9iEtt2QDsuQRnsLqre8uUCPzL4ei8WmFyQBr	1672	919	54	1	5209	jxxz7NJJDfpVYwmXzdCFr3mVdGPELSko1D2m9TPfU1GjpDu1jnF	2793	3908	3908	1616642640000
5375	3NK57N8Zm1dbJzZsVeU8SXDmtzvRLzerQsW5sGievbw1wTTTPx5s	5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	563	993	54	1	5212	jx9xA1W77m7H4Y45uAUjAdG5ycZ7GZYxtZocq5GiokgJheoxZgG	2796	3911	3911	1616643180000
5380	3NLFNWLmV7skFJsaYRvh3gLYWKKDSGwuCuBnWn5iND9hfkb7xhxP	5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	1637	816	54	1	5217	jwnGxQW4s8zFaMjUw9Z1CWNm33vi19YniS1sp7EeC9iEuzxk1Fk	2799	3915	3915	1616643900000
5386	3NLsMveYea5svBasY9mxzHREM6HCshe3sXR5kpsa99eLFwbRyMuu	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1448	945	54	1	5223	jxR6zCVPhjYczLmH1XNeU7zMfNXv16hNJ2xYxPU4APLqAuVCues	2803	3919	3919	1616644620000
5387	3NLgEiycytKZSwtJijbt6ZeEdge7wZW264F8bEf8s7QFwNTEMoeG	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1627	1139	54	1	5224	jwPZcHXhsnpJXYfsYNfzJyf974rfUcqGiwn9ivTujteb629Fsdw	2804	3920	3920	1616644800000
5389	3NL82VzwCZLdzYUHzpeUYiWyvazuNgsiTv7DmjCu2EhsQMgX2Exu	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1553	776	54	1	5226	jwWV7wKBhGeqJRo9ycta4YXcXzVaRuUnZV5ztX4yLvwPvPWXgMJ	2804	3920	3920	1616644800000
5392	3NKyp9FC8Lzq6DbxJirXf3mqQTG36b6gNt2F68FiumvN115isqQX	5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	484	1319	54	1	5229	jxwPWgji9xHU8pFi36RZb2N9BiJNwefrMez2vmhoTsnS9g6xRT3	2806	3922	3922	1616645160000
5394	3NLRvRXdSo6oKn5AqQG1pQ1VXCU1n367XfAohEoaFhYZgxKMjj4E	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1403	824	54	1	5231	jwgD9uS7ss5tfd77F4aetcNPzLAwTH7fKV5HnKQPDvxMefBxmtv	2807	3923	3923	1616645340000
5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	1590	1054	54	1	5233	jwqqTzxvydpUjyboFcjBo8eQfxwLno9AHHyfStthBEDjt5LUGto	2808	3924	3924	1616645520000
5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	5400	3NLH4tHxjtyCE3mBD4erTMzUHrYyGFJwdkWbabSGaHh5rQaeCQur	1406	1393	54	1	5238	jxnhtuf7Esj9VX5AUcFiDv9FRbKPHwL3s3PsTpQmbAj8b2cR1BZ	2811	3927	3927	1616646060000
5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	5402	3NKzVpJYK7M8Ydf6SCN2bLP348v2ZbEBufvS8Sr9Dwbk93rMcmXj	1589	1040	54	1	5241	jwUGr5npXUu1Dac1HBGV3j4Qhh8YdnHuiwyGzKfVvKbBZ7a2fcw	2813	3930	3930	1616646600000
5408	3NKCT1upPFLyaraEY1Lj23YBT1hJBwpT59NCF8dnuU6ZMuuuUA9U	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1501	1360	54	1	5245	jxidVoHVpG5SGewgugwP7qLMHJ37GKrA2UAEZqdjM8q8fdRibe7	2814	3931	3931	1616646780000
5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	1534	628	54	1	5249	jwmtSoJGjcGihijC31onqLADEHKQVzYYermbE6MDFGwDAo2hwhT	2817	3937	3937	1616647860000
5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	1405	881	54	1	5253	jw7V8kW9ATDfSqTQViiAYd3VwxgLYtoduXFEk5dCXvzxsK43b3o	2818	3938	3938	1616648040000
5419	3NKCdKTJX3P3zX5zYyvDMou8TmXepxDSNQLaEasZqUGcQSRJ7EPg	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1613	1103	54	1	5256	jxYhM5AHtdJGUGzCXJbYWtQuHw7iumyjaaeLnCwFyAeh3stZdqF	2819	3939	3939	1616648220000
5425	3NLjEqY7rgJ5bhXpMjyDvCCZCt54SAcQyjGsGeU97Qsqo6URmUgo	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	43	1064	54	1	5262	jx7hNiSUWwhgnazBXnCLxcG9ZfSmUr2Uewq4csHVx778shfpJHR	2822	3950	3950	1616650200000
5400	3NLH4tHxjtyCE3mBD4erTMzUHrYyGFJwdkWbabSGaHh5rQaeCQur	5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	1590	1054	54	1	5237	jwuZqFvbtDuE2CAAQE4EiDs75ySSDh3Q6ZYLsNYHEGTCUTPV2Pi	2810	3926	3926	1616645880000
5403	3NKN4b17FarqrviBNeMTw4xGuQossD9yWQNGisHjJBu4wNFHFZL1	5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	1403	824	54	1	5240	jxGk2PDdQc5NuWNzP1UjmyjqjM3vJifJPfyThSyYTmJTQe9qAEn	2812	3929	3929	1616646420000
5407	3NKG5MvW8qxxZc3NSYooz8b4nu6LNFqMuhymTrfuKd3ABnF2pzYE	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1593	980	54	1	5244	jwq9MMULxTekkkzrvW3f2do93Wqy433rdQ8V671DYFgmHzGCqXp	2814	3931	3931	1616646780000
5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	5410	3NKiL14baAWii8MG43qFJiZUivfmk8VHYaqkk59m6vhskKpLwGjb	1406	1393	54	1	5248	jwAy9wB7hBS6dXryLZm6hA4v6WMsfQ8hv9wZ3gBHmZHVqUVHxRy	2816	3935	3935	1616647500000
5414	3NKb1nA7iuHzGBG2hu7pT9P1JKwNU3wsoCSVrQ7K9kC56RBJrXTe	5361	3NLmhuA2cw1aYa6ETizdBacFKeU4r9awn7BTxKMwaU6hLnNdmK1c	1534	628	54	1	5251	jwhQctG5v1KwNiWnvFTd6F96hJ3PVV7BW3CuskkmzWdQi6wacGy	2767	3937	3937	1616647860000
5421	3NKL95t3VvzXYWBQxKbj8J3uJpzZfFSRXQ7hKPqaRQqQP24oUW2R	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1549	1116	54	1	5258	jxTu8nb9R5squBsGkokGw57acUrrhpez6PLgJuuumjVQqFPDxx3	2819	3939	3939	1616648220000
5427	3NKwJsPNRT4NnJqUkGyKApebdQjJ1WiFjAftCwv6zWp8o66DUMev	5426	3NKJ5ZFGCxvFPrap3s5DCNJoJh7RX2LVN2MJgvp1ADmKFhvdu9X3	1445	1290	55	1	5263	jxanRak1dAg66Kd6ECXMBEpii16xngqfQLbUK2BRJVkEBkE2tNw	2823	3951	3951	1616650380000
5430	3NK5PXCwU1eDdSSRsyh5SC97Tto58SDDahjiAZ6gryDbpMicxwEM	5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	1403	812	55	1	5266	jxChERuni7RXSuRtdJ5VNK19kezgWFNgZCYikjP1PT3B9z6RSS5	2825	3956	3956	1616651280000
5436	3NK5ctPLxbsgVRg932zfPLxn7iM4vHbsJtZNkAwnfGmaios2JQPC	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1422	1337	55	1	5272	jwcgLCPuJP5YhoxkCwmojuC5YJAdWGBGHsj5xAFs7eKhm7k37qi	2828	3961	3961	1616652180000
5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	5435	3NKNuZbseHvH4D1KmmfYm9pTZJZMSKF1jCtR7gDzbGoqfvJjCDFt	1406	1393	55	1	5273	jwvk9T6FNYLJyGLzNs5ucDEw6sYkNt57HaxSym6HR6a6phd4vXq	2829	3962	3962	1616652360000
5441	3NLNN43wzaNZzKvs59rJdDLPbmt8vSS1ceDruuBXc7HZ9NHNoCC9	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	1581	778	55	1	5277	jxW4FJHrerne6CBzPHw9zAKc5eGBGKxc2QsyLXmFGEfCP3Z6hrn	2831	3966	3966	1616653080000
5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	5443	3NLXxNEaYU5jip6aMtgLEA9SPdpViK45RVJuzBVardCAh9QRFWKQ	369	946	55	1	5281	jx8L2DfYRTgtsrqqKyvwnkrytKr6FELqB6ogX7dp74MTT7gBtWv	2833	3969	3969	1616653620000
5447	3NLNHirkXay7JoH1JLaUH45FztDDd77EqPfbKUdsCrVeVZBBPrkP	5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	1613	1349	55	1	5283	jwUfD3wnY5Y4ME6Sk5dJNrbCauPCyJRd5S86C8Zh4CH4e5swdMK	2834	3970	3970	1616653800000
5451	3NKAf7BAT87eRsmWPjR9DoNfajoym2rvQAY1ck62CTu8LLFpyxaH	5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	1406	1393	55	1	5287	jxWyVT2DXBrEvYixcMSEqzEwJNojktP9LTo4j1pSRSkaACUcDaP	2837	3977	3977	1616655060000
5456	3NL3VhHTe7drWfdrSZeciWSCAPgzTbh51hgq9sk9ToWgjxvdB8tb	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1516	1048	55	1	5292	jxBMA2EoYFGacficagtF2cuYQWrb3sJMsbxZhkwMQwwE7uLUb2o	2839	3979	3979	1616655420000
5461	3NLXYCXs9BbNhKbsMcTS9KYU6p3BBHT1X1md1dBttqncy7DFZzBn	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1590	934	55	1	5297	jwCKo87xV8ZK6jdyYYWXwEASADZC77VwUs9ETs9uUwLmLC2mSfT	2842	3985	3985	1616656500000
5467	3NK3khRnLvdXh9GK2z1Bf7fdYCDstqg1Gy7HSBKfne1Vgngqahkh	5466	3NLgG2LQTe7ipLy1cXTk6U47qR3hBkpGnhbvAhWfVvQ1fbHkVgz2	1402	810	55	1	5303	jxrYsLNaUV1XDxEU2fe83GMii3FrqHjzqqc6zUYD1j7N2kToD33	2847	3993	3993	1616657940000
5470	3NKESc3UJAKBcWi4NKjtgvEsEzh9iR6LjN5Les5buncKmhM5U7s8	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1637	816	55	1	5306	jxBW6RJfn2BXUhapHqGVUBFaUogBU1RTozVWWpwqUQz7P3T5VR7	2849	3996	3996	1616658480000
5475	3NLkqC5NAs5qpY2pyAzvBySrxTrdD3gjL7avNwFbsS8JZfQAEs1S	5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	1605	305	55	1	5311	jw9nTGHyjJYQ6w4c2Znniy1mBZBxyi6PQiXiRQmh7nHfC3rfmaQ	2851	4001	4001	1616659380000
5477	3NKYrA2N4QQSQaVLx2mgZYwtTLX6Ns9hxX599jw7SBP2ZFcmXs7A	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	369	1312	55	1	5313	jxjxkzxqnhV3tRW8v44HJZzuTqvAarZJAc3357sTxsJuCuaFgKY	2852	4002	4002	1616659560000
5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	1508	1021	55	1	5315	jwKwfFhGMmP4LqAwvk71RgukzeZn4HiXPjaZoqQbNYVeVp7YPqA	2852	4002	4002	1616659560000
5482	3NLPeDAmA9co2NjZmPv5rAg6TKp6W7ioygboJosUX4msQJn1RudT	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	95	95	55	1	5318	jwBZDsGVkPQs5ewhR2gvBbTbbuZX3ueNxoVvh623Eh7o6hLf2Vj	2854	4005	4005	1616660100000
5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	1506	1247	55	1	5320	jwRexCeN4uBEwr6f5jX6whJDvPnsk2e4P9fZVb7xQLLobnotBSQ	2854	4005	4005	1616660100000
5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	1611	975	55	1	5322	jwHX7eofJ2iwFTqQemxLPQ1Ejvvfkxu3QigMdR1ay4mJmNWZazc	2855	4006	4006	1616660280000
5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	1553	776	55	1	5329	jwnhx5mmPfRVyLycCbV6rnXi7RQZiPaxS9ear9bbmcbiRURsU8m	2857	4008	4008	1616660640000
5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	1617	1288	55	1	5333	jwFbbT1TVrkgwv1zoVtMPH2iGuUtAf8Wdd1paijsF3NeMwbGoiU	2859	4010	4010	1616661000000
5500	3NKwc3KAvq4QAoNF6A7ygN3HDRMeYWRjiJGvT3tjKdBwR7LeMsFb	5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	1403	824	55	1	5336	jxbsb13svqp4qvhsvRYMbYo7JQcrYhJZ5qmC9AaCXSHqVpyXYj3	2860	4012	4012	1616661360000
5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	1406	1393	55	1	5343	jwq5LG4JpiBfRRCk1xVBdYsZawcgtTEygAMUQ73AHvjLQoPnnct	2866	4018	4018	1616662440000
5510	3NKG4W8CkaPJ7D47nEMLodMVfceXHVUYSpP2Gmaz37UTS56nwqWB	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1600	1246	55	1	5346	jxv1vPvBKNNQC83ofvuuGWVZfEDyaRZbmRsDmUCpvepfMtTPz6u	2867	4019	4019	1616662620000
5512	3NLjregJ5FzAtStLPoYHzAqkCbG7jzQucce73fQ5FaNZ9mkHLkZe	5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	1426	998	55	1	5348	jxJU5QQuxw7ch7APR2cC2ARmyw7UoG33x1F7jSygxAnBtGzo8Rz	2868	4021	4021	1616662980000
5516	3NLsoYy4XatHJJfhJhG7x7EvgKkzjJA4pockBxDXPEoE6mR4nR5T	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1651	1055	55	1	5352	jwe7EnZk2cv5a7kgcFkUJBxz1AnaKuzBCHkRDcbXdVBxNU4msgb	2869	4022	4022	1616663160000
5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	1560	925	55	1	5355	jwTdbMayyLvA6nxxHbWzxbdEyFc6t9atEwkH76AEmEH6YmDdiYu	2872	4029	4029	1616664420000
5424	3NL5nRS5JPhLUCb2kT8DUVvxQeHowoGqFgCNsSuczzGSL1VjrBdK	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	1406	1393	54	1	5261	jwudi3svrEAKpGVKntQJPaRhJf7B6oYoEMpY3bujHnXEAXqgy7p	2822	3950	3950	1616650200000
5426	3NKJ5ZFGCxvFPrap3s5DCNJoJh7RX2LVN2MJgvp1ADmKFhvdu9X3	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	43	1064	55	1	5262	jx7hNiSUWwhgnazBXnCLxcG9ZfSmUr2Uewq4csHVx778shfpJHR	2822	3950	3950	1616650200000
5429	3NKeiz7wXC3xAtx1Fc9xpUGBwme8oc4kfnEAMMuTcqaASmMLBVsd	5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	1458	1197	55	1	5265	jxL9ArhnYabTbbMVJALhtt8vF1rQ3Kx1SGgQJqvKDF69CtYxPMw	2825	3954	3954	1616650920000
5432	3NKyUnZzRaubMhoGE2XMS9qHBfuoXm7eQvuxcbZ4B1H6TLdsbMJF	5403	3NKN4b17FarqrviBNeMTw4xGuQossD9yWQNGisHjJBu4wNFHFZL1	1419	814	54	1	5268	jxzJxSQbEN8MGmdbfHAFtTEZTJKE6yC4mVXS5T54mQfwXZE9TJR	2813	3958	3958	1616651640000
5435	3NKNuZbseHvH4D1KmmfYm9pTZJZMSKF1jCtR7gDzbGoqfvJjCDFt	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1406	1393	55	1	5271	jxQc3usacSGhQEAZeZQ75CN9pLbhUE8TosghHeHMbcZ9J42wcaw	2828	3961	3961	1616652180000
5440	3NKSDgjn8ujnL88mFM88iXVK1SLqETSu7Z3qAD3SGBLdNqCjeMZ1	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	596	1306	55	1	5276	jwyW2GaPx3jdq4bNWxsv7xsyhBUjngV7YPkdHSMnAcGEziFwD3F	2831	3966	3966	1616653080000
5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	1631	794	55	1	5278	jwnSsxCeiAtKv6E8Xzc9yEGd876wsPrH54ANTouhwba2QSiwM57	2831	3966	3966	1616653080000
5453	3NLu6mB9h3gNDRpCAzNXTUNRcBRgiSsFyGqDCg1aumyBuEyvrDpf	5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	1407	1395	52	1	5289	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2713	3979	3979	1616655420000
5458	3NL81aaoReiqgV6yMK4RnzZkeA26mHy2gHc9FqtNvKxmFncViXnt	5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	1600	1372	55	1	5294	jx5bUPPuHxtzKnJ1h64c84j8fDNM3tGsNp4NRneENqL9Q892YRc	2840	3981	3981	1616655780000
5463	3NLY3W8euKPEveHRTDUdFXSM1yxv2nh9LkevqrHAf2WdQmwxWjuR	5462	3NLDs5u67eVE11CKvaLo5GeJQpVZd8TjgnJuSzFyRoCemrfSh83i	1643	1053	55	1	5299	jxrnjCdDZSQScpDb5CvQHQtHqZvpriKuyBVtk3cF2HHSo34D1ix	2843	3986	3986	1616656680000
5466	3NLgG2LQTe7ipLy1cXTk6U47qR3hBkpGnhbvAhWfVvQ1fbHkVgz2	5465	3NLv5B2QCLLSCXUokwURDdVXvkV33HWd8PTftN9hbcWQcXMeBSBU	1405	873	55	1	5302	jx1f8GgH5tKbKLUzNas2P7Lydjy8KzWeZDGoiLS6VYhoDwPWmXA	2846	3991	3991	1616657580000
5469	3NKdDcPALbfYf5tuUHWCgJ58JamkAJsYYmJXFYuKSZ55GBQgDHK1	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1451	1046	55	1	5305	jy1uypDXw1hHiEVbAA9YNWDZQLJ7aUYSo6ovQHj89DMpxRAyV4q	2849	3996	3996	1616658480000
5472	3NKYGomfLDaXjzTPNbB23kE7aHtJ5VtCs4jmPYSw6RTxVH3qtAnW	5471	3NLWetVJXFCkjQD5FK3G8ek6u72pz1vDFd4ndYbBe5CAZMA2egN8	1643	1053	55	1	5308	jxq4TWTG3pzmaZXtHP8eYm361iyQBANzhhZNRZkFifxbQm3z8Ug	2850	3998	3998	1616658840000
5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	5469	3NKdDcPALbfYf5tuUHWCgJ58JamkAJsYYmJXFYuKSZ55GBQgDHK1	1403	812	55	1	5310	jwnXVcQewUa6Ftwut3CLS3J3NFWQfSyWKoBW82tLbVUv5L1gWZv	2850	4000	4000	1616659200000
5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	1549	1362	55	1	5317	jxmMJPcCP9eBkQocRRMYCQgPuHkFmwiS84LJLo3r9goM97wWipC	2853	4003	4003	1616659740000
5489	3NLbEVGnBCaefhY8yz4RMG9zWbFT5TUgVF6kTEiPiLyr8r7pgx8S	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1675	1216	55	1	5325	jwCbEEcmeyovaUyha1n65yJQvRjDBT8KHoRiwKDbN1HiY9XbzNf	2856	4007	4007	1616660460000
5492	3NKNevkTmx4XG7r4dL76HFuP1YARhqGR2zGo9PxDJc1FAsAQaRYq	5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	1402	868	55	1	5328	jxeWBRTqVzhke87cNnqHsiPXEteLBLDyRsND8R3Ax8uwtWB6eyM	2857	4008	4008	1616660640000
5495	3NLsb4j7T3RuvaZwP4J93bf9VSD2SstQYUkQPPVBTA33H4SFsfYu	5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	1637	816	55	1	5331	jx7qhUb3DDwU9CpKbRZuThky9FB9aMWHsACaB8Ef8eHeYrjGk6w	2858	4009	4009	1616660820000
5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	1581	778	55	1	5335	jxrRFfNtGxnqj7TJVLJDAsackHBoHLdCwADTi5goA9v9ZQz2NNB	2860	4012	4012	1616661360000
5502	3NKpFjr9aN7HE6UJ7kedAa31Vqi3UYMHzuqEKseoXPVfuvNkWBh5	5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	1406	1393	55	1	5338	jwXpZEoKPD4UNUCa6e7RrivWzbqoHneTuhwbCTJgEp2QoNXsf4J	2861	4013	4013	1616661540000
5504	3NLhhfQLbuPTRwaNPai2N1N37rN699QmnMCzcemYgxucYe33w3yC	5503	3NL71uLQMeoJWAuD62EVa9HVkNsuB1GnEnDmK8E54XMZnsin7FuW	1483	611	55	1	5340	jxVyeg34mHYd8iRsMkgpuPu2PwaGysq8W6qefW7mt3j7SZArj4Y	2863	4015	4015	1616661900000
5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1672	1039	55	1	5345	jwgMJqjRgap8HAjhftZbhFVh8cD2dxH1a9YKS8u7upPvnm9ztgF	2867	4019	4019	1616662620000
5514	3NLs47DKuENU3YBYC5APNd2wPPEmY22juTEtAcbs7PLi6eWf5MLH	5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	1426	998	52	1	5350	jxa3VJiejgeb73aPfioL1Fyifaw23AT6FvBMFzXfE7LSx1fsXYX	2708	4021	4021	1616662980000
5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	5518	3NLen8L5FnAbGay8cCPyGAFzCQwxvmkzQHEDChYh514y7sBFybb7	1623	830	55	1	5354	jwRaAo4CRJwR66wsvujvZTjuntEnR7zJNqkzi8pmaQcdN1CKz82	2871	4028	4028	1616664240000
5526	3NLm9wFmuSk6WX9mtVS1RFX5o2R3DhUvqZjLZsAnnukAXPTgnVS8	5525	3NKqRzRU1WH9n9fYXBWvuej8wz7prD4an7fgiyhG9VddtgCKm6sw	1406	1393	55	1	5361	jwSXCM6X6VrKJAwGHL9yRBea8KtYghYqohCcEFfBUFLxp2Nktvq	2874	4032	4032	1616664960000
5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	1402	868	55	1	5368	jxH6uv5wtJyjVg832FMeeua7DvTc2rjSS68msLum57tZZXjk2S1	2877	4035	4035	1616665500000
5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	1405	873	55	1	5370	jwudCnTH4Y5tsrE3vGLNyedxCCG9BEi6iJcQb2BthAgQtPYZrGU	2878	4036	4036	1616665680000
5540	3NLH9dJgFi9nsTpV7jDhZbaDKW7UkwME4uoLLkmzQEDiA7reDbPf	5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	1637	816	55	1	5375	jxtvQdxo6ot9tCQgMmRKmbAXJkSNymBy38VD78GQHqyCFf7qsWF	2880	4039	4039	1616666220000
5542	3NKPVHBF9Lpy1YoFyYF14MhWqZgryhacnkCbDV74Gy8XG23v8qjG	5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	1519	860	55	1	5377	jxdDr2VPpX9b6ToPWP8uVdR1F4KshezzNyvpoHu9vxJUaj2RoiK	2881	4040	4040	1616666400000
5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	5541	3NKwPk4kHkbVkHGLQooxBGG679uBr9qTck94nvbw3tdfCU95xGgP	1590	1300	55	1	5378	jxJZJLXH4k2stF6BerhoPJzWBDwUQko3kFAxpTr6Xxf3U2RbGkF	2882	4044	4044	1616667120000
5548	3NLmpYyKmcoTzdkuo55xAiD3rpLWUb7cSiA9tm7UVErxgRJyeP9h	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1534	1071	55	1	5383	jxiiALWHEHm6HyWEopbdtX9DHV766p19G45eUYDtdyhDhN9YZUj	2885	4048	4048	1616667840000
5551	3NK54cFxp3Hyrj967Ci4rftdwwbHgWKtMBotcLk2aurS7dBBt1eG	5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	1642	1367	55	1	5386	jwKYkfpcQjcjmJmBrH2kxWrFtYiHTiY8Q98z8SeUsY7DqwXRTWz	2887	4051	4051	1616668380000
5431	3NL1wELyw8jWskzwnvXvxfyWzGDszrtWpKqeqm8ueDhGDnxjP9v9	5429	3NKeiz7wXC3xAtx1Fc9xpUGBwme8oc4kfnEAMMuTcqaASmMLBVsd	1581	778	55	1	5267	jwUdU2GScMnZJ7zWurRp7j9EpTddNUE5x1r8SEm9Kvjt2ZPrYQg	2826	3957	3957	1616651460000
5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	5431	3NL1wELyw8jWskzwnvXvxfyWzGDszrtWpKqeqm8ueDhGDnxjP9v9	1455	1086	55	1	5269	jwFuyV9Yxfg1WrLyuTAU6B6u1U2RKobeH18Cb5VA7CACQMsy8aC	2827	3959	3959	1616651820000
5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	1406	1393	55	1	5274	jxvaeAgf4sUxXVmzKAGtshJgKT9rPjABMCvrppFhoeS6yaKB9oA	2830	3963	3963	1616652540000
5443	3NLXxNEaYU5jip6aMtgLEA9SPdpViK45RVJuzBVardCAh9QRFWKQ	5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	1671	1365	55	1	5279	jwzSomp8ZBxikFDyXFyy7pyfWHhub8bjHYPY7fF4NfoN1qBCj2j	2832	3968	3968	1616653440000
5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	5447	3NLNHirkXay7JoH1JLaUH45FztDDd77EqPfbKUdsCrVeVZBBPrkP	1631	794	55	1	5284	jxox655TdX3SpyoRnLgH2rt48ptQyCTQi39MS1cKd6aXU39z14Q	2835	3971	3971	1616653980000
5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	1637	816	55	1	5285	jwW5Eck3vCtcuVZE34Fi96jYCGQ9wF8PkdX42YVnRaJMVKj2kkm	2836	3975	3975	1616654700000
5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1406	1393	55	1	5290	jxCk5zvezqxz9SaANFKp4nXc7LzZYyiVhwAbFZvyxeGKNPg2Egr	2839	3979	3979	1616655420000
5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	5458	3NL81aaoReiqgV6yMK4RnzZkeA26mHy2gHc9FqtNvKxmFncViXnt	484	1319	55	1	5295	jwfQcNDRTZsorJJU79qjwsKTpVoWJBhzC8kZZRYjcLPdSEKYiHd	2841	3983	3983	1616656140000
5462	3NLDs5u67eVE11CKvaLo5GeJQpVZd8TjgnJuSzFyRoCemrfSh83i	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1611	975	55	1	5298	jx344ZtGa54o8drB11eQgt9mdo9xAquLvNhMZLpCXo38MmnFUSX	2842	3985	3985	1616656500000
5464	3NKAkn8jBWsDyMErv4Y3w4sTfwzJJxn7ED4byjXvgz6JQxVfGCd9	5463	3NLY3W8euKPEveHRTDUdFXSM1yxv2nh9LkevqrHAf2WdQmwxWjuR	1553	776	55	1	5300	jxEjPZ7eTXkfFwjuAJMFeuwmMPHoMAhKJ3ASPVTAG42NXyVtPrb	2844	3987	3987	1616656860000
5473	3NL6BkFU6Rixp2U5ytKcQ2X8hMyz6atUsZb2LWxvjyJLxDkYyreL	5453	3NLu6mB9h3gNDRpCAzNXTUNRcBRgiSsFyGqDCg1aumyBuEyvrDpf	1407	1395	52	1	5309	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2714	3999	3999	1616659020000
5478	3NKD2MvR1WVbjt3SN4orsky6ogDohvSVJLg1GZ6oFcTZtqePs7hc	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	1406	1393	55	1	5314	jwy5c3nYgrrDga6CzLtokXJrJotBmYyEkajTBr25UggRUVgx6nh	2852	4002	4002	1616659560000
5480	3NL9SJG6dmbmmKVubUvRRvg7NUtgUva7JHEBaQcAvUDY996ymP4A	5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	1648	1284	55	1	5316	jxsv3M87TWwe35A3yoUAjMzUUFUpL4Xj7JtCrr361HCJj2bijYm	2853	4003	4003	1616659740000
5483	3NKoPPRfDhuLGGpGNxZw4kypKQsoaajhMUPrU5PJUk4MmhxhtVpq	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	1403	823	55	1	5319	jxF7DtxJZrU1tXbfJCw5RV5P1pmnfhuoMzR2YWK3PZNSUn6GnB6	2854	4005	4005	1616660100000
5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1406	1393	55	1	5323	jxVNoHCqAH66zJR39EzZTGAt7QJ7oYuMqAwKNfakX5NsRJpgPJM	2856	4007	4007	1616660460000
5490	3NKyUYzSrSAEgrhDG1Wd9c5HvakaZCL2JLZJTNWbzefZDFf3sjA8	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1619	1275	55	1	5326	jxBECm3HXj1JsHx5G9QfT1RGKpV7YvkXXTgGSDhnyVYSE9CNa4b	2856	4007	4007	1616660460000
5491	3NLXoqqPsgPe2DuC6VyhUmEfREjViuDDR6QTzswcjYGMouzzJkf5	5473	3NL6BkFU6Rixp2U5ytKcQ2X8hMyz6atUsZb2LWxvjyJLxDkYyreL	1407	1395	52	1	5327	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2715	4008	4008	1616660640000
5498	3NKpXyZ3zo4GnTgCP84ZUZ9LETrjipeLKdY8PL8eCPWHiyJ4jdWk	5491	3NLXoqqPsgPe2DuC6VyhUmEfREjViuDDR6QTzswcjYGMouzzJkf5	1407	1395	52	1	5334	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2716	4011	4011	1616661180000
5505	3NLAKWE1Vm6ZHAtAfnsgto2ASaRjroTag37Jfpts8dFgAuXvTTSV	5504	3NLhhfQLbuPTRwaNPai2N1N37rN699QmnMCzcemYgxucYe33w3yC	1546	1339	55	1	5341	jwJ3QZzshbJXCyDjNKR6bQdruMikaCCrGCwQtx5x6Ba7LLuNWfQ	2864	4016	4016	1616662080000
5508	3NLURbzbt6itNqVepbVvmBWZC2KeeLrPnRHi6R2TzB2AGA3E3boK	5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	1571	1089	55	1	5344	jximk9495KSsBW3H3XNiCD3xZXBrMDaFv9X9k6AkhW2jyGW8dbY	2866	4018	4018	1616662440000
5511	3NLJTC8jF3FU72dYGzGUbQ7DrKw6ycmJakxS5jmNb5mTdSCKMxEr	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1406	1393	55	1	5347	jxnfb38Nnwe69NrUCZ6YwtFzoVbjBupYFqaPsKfdPEsGbhSz79i	2867	4019	4019	1616662620000
5517	3NLWHHYGauhyS1Pnw5XZFzcL2c4VsYdPosWKNMWig1utu8CDeZsh	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1651	1055	55	1	5352	jxDp2FSQjkrbZa8nzPjppNDJZx17GrDEJztK8abTFeTmwGCAYDJ	2869	4022	4022	1616663160000
5518	3NLen8L5FnAbGay8cCPyGAFzCQwxvmkzQHEDChYh514y7sBFybb7	5516	3NLsoYy4XatHJJfhJhG7x7EvgKkzjJA4pockBxDXPEoE6mR4nR5T	1402	796	55	1	5353	jxUpSfjfcXEFUqcFji7i48mmWb5nE3Zmyq2RPpMo5uzkPGnJY8E	2870	4027	4027	1616664060000
5525	3NKqRzRU1WH9n9fYXBWvuej8wz7prD4an7fgiyhG9VddtgCKm6sw	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1643	1053	55	1	5360	jxRgjn3NDvgbw4x5bTh8hMHMXoGHUR4eSmz6XcHqDS8MxfPaka4	2873	4030	4030	1616664600000
5530	3NKZCiM6J1niMmGuEfFeuoVmWWmULbetTrgo9cYBUbpeEDx49Fuf	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1402	862	55	1	5365	jxfqRwcsGknD4dKvZKwZttZStSPAz3r6sCsr3KKhS236Q7RRVM3	2876	4034	4034	1616665320000
5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	1406	1393	55	1	5374	jwtEMo6Tqoz3CbEmjkmJxTzVt8ZFf3WofpJZvhbzgipxXVVbGmq	2880	4039	4039	1616666220000
5541	3NKwPk4kHkbVkHGLQooxBGG679uBr9qTck94nvbw3tdfCU95xGgP	5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	1534	1071	55	1	5376	jwHHRGHcBdGXdoSu1UXb7x4pGBmhdPE6YAxr8ZE54JrS92V9h4b	2881	4040	4040	1616666400000
5545	3NLEkcqo8sK9Mdd8jEFhTPVdqi2Gxo32ET8nysN696xJ4V8JFrge	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	1673	1002	55	1	5380	jx9JBwiMzHCEk7m8wqAri5HWN2xhnE1ozbEjZPuFs7ZNjp7Bbmt	2883	4046	4046	1616667480000
5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	5546	3NKJgSFtANFfYgHroGJpRvwrR86feJSYUEiGrtSAH6Rc8GHkanJf	1422	1091	55	1	5382	jxA3hJ4csZYYLfQ4tLyKZRyoS7fy1nF4a6wi2XR53bi5aXe9Ga2	2884	4047	4047	1616667660000
5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	5552	3NLqwgW4U8M2YfVsZiMSELLHXBh9dbJMCkZbdwhwmftqxk4hcvQ4	1541	1052	55	1	5389	jwYE4agLd3bEhhK7Nr9wEKzPfqv8AsziZqTYW6RLdwsBYejmtp6	2888	4052	4052	1616668560000
5559	3NLh5u1pNEuFrVmkssceejaK1hS4SQAnMJkdNn6Xu1KhncjfwKVx	5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	311	1061	55	1	5394	jxcGPLqQuer5gYeHWugWEwisw1FSFjCp7UtMDNjyPDEfLZgj7PK	2891	4055	4055	1616669100000
5561	3NLCdBPXjruD7RzoUiJGurk4EJwDwCFwnyHuiXSc2afN29BFVpPu	5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	1611	1341	55	1	5396	jwfVoka2RxKtLnhqw4iFFsKXeJxvaPctWfxTBC7int9YEZg2knj	2891	4055	4055	1616669100000
5439	3NKGoYw4fzAxJs6ddhQV6TYJQ1uGk2yBi7gJFKZkDLBU3wC6Cjhw	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	633	1018	55	1	5275	jwcQoE1fej1iJF1cwzgFjVqksCk3P8eN3bAhGWPGGQwqwCC6Lku	2831	3966	3966	1616653080000
5444	3NKTwJ8ByQuMEVd15vvtqBobVxyG4a7KJnH5uqURkMayQ83GmqAa	5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	1474	1329	55	1	5280	jx4ADhvKvHkZW1kcbNDrveyntcR4RvHXMSo6xzxTvi4m9mUfrLq	2832	3968	3968	1616653440000
5446	3NLv246a1LTXhU9FKmGsRqb6GwqWNwyvCGxYjs6Ua7aBG19JhGGw	5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	1588	1266	55	1	5282	jxkorz1TfzLNwY4VMBKGfA81KfPwA8mFPgpjMGda8zytJCHjAHj	2834	3970	3970	1616653800000
5450	3NL6Fs25KkrgBSorT1zLFf3AVC996Ax42zB8pkQvsXu78V7rsvQa	5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	1559	1353	55	1	5286	jwsJdgeaftJUJG8JxztEKS2Bcz6nZqNfMKomAxAgq5YUTTxYQDm	2836	3975	3975	1616654700000
5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	5451	3NKAf7BAT87eRsmWPjR9DoNfajoym2rvQAY1ck62CTu8LLFpyxaH	1619	1275	55	1	5288	jxcCKDHyfzqr4rhdUGbUHu5u6Ebd5Gb1pVheZHzVk8XkD44Jhjn	2838	3978	3978	1616655240000
5455	3NLYg6NFqRjYzjhPJnEGJD7A4cEXdApFFpUe1VK31AUJzSUmR6ew	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1588	1392	55	1	5291	jwPjjcpJBWHh2ChvQyCtqzWo19RMhcPSXrkSZJ88ekcBREKsGMu	2839	3979	3979	1616655420000
5457	3NK7byjnuNmd1DAaGkN32yV6bC3SNKjUcRHcPaaYU7tEqBu5yU7D	5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	1607	1222	55	1	5293	jxAES6dxjUPemNdXtKPPWh1vwDAwYRJXgdfbmyBoHjopoQfjhBM	2840	3981	3981	1616655780000
5460	3NLa4ZH6Uhmtp9nX1Mu9GUnhcgwsxtqpfXE8SHEPmrQG9Foyh8cU	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1448	1311	55	1	5296	jxFKKN3gVXcD8WYNRMcWGBZKK5Zve2AY3e9i6tdLJDRweX6ATQG	2842	3985	3985	1616656500000
5465	3NLv5B2QCLLSCXUokwURDdVXvkV33HWd8PTftN9hbcWQcXMeBSBU	5464	3NKAkn8jBWsDyMErv4Y3w4sTfwzJJxn7ED4byjXvgz6JQxVfGCd9	1611	1215	55	1	5301	jxfb2MonKAjRqEm6SjJT71bTt9ZYnBnYJQDjDc3P9iLa5AicN6C	2845	3990	3990	1616657400000
5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	5467	3NK3khRnLvdXh9GK2z1Bf7fdYCDstqg1Gy7HSBKfne1Vgngqahkh	1489	501	55	1	5304	jwv2yD3EJ1NHBHcyHLhd1aNyBgsRrqS6KbwjgotiL99N47fxJgz	2848	3994	3994	1616658120000
5471	3NLWetVJXFCkjQD5FK3G8ek6u72pz1vDFd4ndYbBe5CAZMA2egN8	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1631	794	55	1	5307	jxJM22xePWAUCZ1WHZmMuHc11FWwSi7jXVxpWFqnwaa9AgxQvN5	2849	3996	3996	1616658480000
5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	1571	1335	55	1	5312	jx9FeAZbBPAuUfD2g4LKHVDw5pyLu5sHBzgGjrzi9XL89inYHgC	2851	4001	4001	1616659380000
5485	3NKvjeUxQhTVJbhn5R3tWQ52BHyN9Cgei7AhHpu3joLeMVnn7Xi4	5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	1536	1313	55	1	5321	jw7cukZkkkcLuJ6h2vFvuEdsQe6URD2FnLz4B6L8PWhZHaLeGQq	2855	4006	4006	1616660280000
5488	3NLS4QBRsCw6vbDRU9KoZcB9zDJ6J1ncjLTjZT6244onADmRqb1j	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1500	1171	55	1	5324	jy3GfBCBqq2qF5FMsNLFuQgiep9osbW7Woxjb5YYKPXwWFU1JKP	2856	4007	4007	1616660460000
5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	1406	1393	55	1	5330	jwBvseSbFMRJG66Qkus5sSARELJMzCsiapBFpMdCTCrr9Er2d3L	2858	4009	4009	1616660820000
5496	3NLtxE5Fjfg2JAt3ZifMRhmTtm9pTLwHmkCwVxLx5LF4CQ1Jd8nN	5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	1406	1393	55	1	5332	jxLfDgSKauEbkFsnGP75ETPvC1fkQdjykh7GmXEEoZNc8NF3enq	2859	4010	4010	1616661000000
5501	3NLH9c3nSZ2xrnA5izuwN89ovC2wXq71VpJfzGgqpCe1XcFxrMYF	5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	1471	1386	55	1	5337	jx4AHEKXXpfWDvYh1myTHDstfGJdc7U1TVrCzhrz8meggGEPEYd	2861	4013	4013	1616661540000
5503	3NL71uLQMeoJWAuD62EVa9HVkNsuB1GnEnDmK8E54XMZnsin7FuW	5502	3NKpFjr9aN7HE6UJ7kedAa31Vqi3UYMHzuqEKseoXPVfuvNkWBh5	1643	1053	55	1	5339	jx68CjouVhxMqKVfnw668HpubKqFMHUU3mnDUeUufrywjTB2UWo	2862	4014	4014	1616661720000
5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	5505	3NLAKWE1Vm6ZHAtAfnsgto2ASaRjroTag37Jfpts8dFgAuXvTTSV	42	1115	55	1	5342	jx19C4TGutDy8z2haZKvUKMXFjda7gmpmd9TWo8p2Rc9HBhFVEA	2865	4017	4017	1616662260000
5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	1590	1174	55	1	5349	jxS66vRUpk4kAbwdqJ35dVKbL49PoYM3tuUv57jYdVVWPAtECL4	2868	4021	4021	1616662980000
5515	3NKcUiyzhespCz5nzBHWpu8cmYv9Gbyf3P1SkcARe3pFVmwQAqwq	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1477	1224	55	1	5351	jxyeCSgs6MbGMkoKWpkWwTNSKxZDR3piaveQEcy6vp39sfALsca	2869	4022	4022	1616663160000
5521	3NLf21AwQcS2vKNh7WgTdCfaqbbD2xFBk2VmeCGnEQzZ6b6dfsmR	5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	1657	1344	55	1	5356	jxMshZ1ZdQxKc94yFCc5L7WgH75VbzrLZJ1A6oYPgs3Gh3HgKN4	2872	4029	4029	1616664420000
5523	3NKg1knrZiypaqPR4iakHkNydxvGhUpFrsip2yinr9VdBcJEn8cv	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1631	794	55	1	5358	jwc2KKca7wdjiLhbGYWQABTRie6cMKKiA6RNQMZmTxkiFTfmPen	2873	4030	4030	1616664600000
5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	5526	3NLm9wFmuSk6WX9mtVS1RFX5o2R3DhUvqZjLZsAnnukAXPTgnVS8	1637	816	55	1	5363	jxfEzjzZQubYPBaerHQYEtdJQmX2zpfuWEX7qxAHVyVzy2hjB8k	2875	4033	4033	1616665140000
5531	3NKHKVoV9CDM6hsXjzErD4cViN5A7aL5HZ3kG5MzcFmLbKzEot6c	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	563	1359	55	1	5366	jxtPncuwgHwgq2to3PNiyxP92KcyimWuDBUyUxFe6dAPmUhfpct	2876	4034	4034	1616665320000
5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1590	1054	55	1	5367	jwkpVCviFTj8mTRq62Fs2kw8FDB3h44RBdCoXV3SXb5yHKd8nHQ	2876	4034	4034	1616665320000
5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	1587	1111	55	1	5372	jx5C6jK5ybNLEUKt2AE9hYRgoFWzmsMskhKCrMMTu2m81WN3qSU	2879	4037	4037	1616665860000
5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	5548	3NLmpYyKmcoTzdkuo55xAiD3rpLWUb7cSiA9tm7UVErxgRJyeP9h	1581	777	55	1	5385	jwLUyNuTsNecXgSEKrQahhVeHFNH558WebFqi3NN3CWRpb4Es33	2886	4050	4050	1616668200000
5555	3NKxe5v4A9z6EbKoMxXrD6nfvyaDMXszNK1kN6cZdpjQAhYfJmSj	5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	149	1283	55	1	5390	jxxpZVZtttAN9fGkL9qzfxZqAVos7K3bsmEzmGxBd6RuDVQCJk5	2889	4053	4053	1616668740000
5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	684	1352	55	1	5392	jww4X2zSMVH3vhdc9AdX5BQRLfGfcnSJLbARFiLm964QkaoXbFz	2890	4054	4054	1616668920000
5562	3NKhhFbL9KvJza3BshhipMGiNJnhVxyVZr8qXZh9YWduKSfa42WG	5561	3NLCdBPXjruD7RzoUiJGurk4EJwDwCFwnyHuiXSc2afN29BFVpPu	1467	1376	55	1	5397	jxHijewwfsNFPee56y1U4un8SLPLPnx3NF6EHgZpxhyjbvzaSrw	2892	4057	4057	1616669460000
5565	3NKxHMou8QKjpLtuJfcszMd3AC3cMaUh4uXbRiR1LyPoQ5HzWLVf	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	684	1352	55	1	5400	jx2PMwgxyMRY8qEDgfW1HeTc1F2QPbVkMbzym63DaNiGkTJfb3v	2894	4059	4059	1616669820000
5522	3NKnWexJgqaJ4rzAfsXyEZo37A6NGxwbzTPYXzdVfZHsX1XvHxeB	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1406	1393	55	1	5357	jwodi14Y3ekBf3QSEzHqEzxSpbssjxgNsMzjcjVjk9mnFEkELgz	2873	4030	4030	1616664600000
5524	3NKBirhuq6vwpHraVc78aWhU2cfmYXjZpr4YEDPK8cAuzzGpkkph	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1650	1129	55	1	5359	jwky4vVXbjmeAQ8vhYPKZrmp9YaQpcy78yjzxxzm2N7hf1CDYam	2873	4030	4030	1616664600000
5527	3NLa15t7ZXmuWDxibpenYcYtqeozdE6jtutNyviVvkqQHDGTgkUh	5522	3NKnWexJgqaJ4rzAfsXyEZo37A6NGxwbzTPYXzdVfZHsX1XvHxeB	1403	824	55	1	5362	jxVzdpGFSehn12vyrFiafLCqbborfAx9UVWohe8sQqj9bEUvgbn	2874	4033	4033	1616665140000
5529	3NLhzDUMnZvietREQ9rCYfEpCytFEZRTuZEwKfr7cJyhCbtBFnSM	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1483	1150	55	1	5364	jwqMSBHqGoeCSQWx3dzcVFKCqYQAJQh1dt1RX2r2hBBUmQnFWBE	2876	4034	4034	1616665320000
5534	3NL26wZniLDNuJQtPdERyL7UzcgY6NHFBWgAz4zSU4UEaVEtn4tb	5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	1529	1316	55	1	5369	jxbrDES4ibupfyANeFDtuJfRLcitKCLrNFLStehGTZQPiL5xWXf	2877	4035	4035	1616665500000
5536	3NKSLJgVXD9pF6mygYWrBijtK4JwsbENWWuhbYLrELSY3TyWXPYa	5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	1577	1327	55	1	5371	jxRhjDr2yuLTbjypBTckz2BksgpSzdM6pcE8wuThUwboQB2HN4L	2878	4036	4036	1616665680000
5538	3NLj4zZGYMXRXCVap8vXg6Vt3z6YD5BDiTeCLYrf3CknRCQeHj8p	5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	1631	794	55	1	5373	jwHC2hAcq27qNAx7PuhWygcWapmF5f6kES7aXZ2WUNsspaAjNbp	2879	4037	4037	1616665860000
5544	3NKYsKpMSW6d8cEphKxq7cAbxCzNy1YhtXNad7F9QicMfCRP1SrZ	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	1406	1393	55	1	5379	jx8ZtUDEDpZS3ARPmLkUytAuBm1RLrFh4DK9RUs6BcmfyHghbdg	2883	4046	4046	1616667480000
5546	3NKJgSFtANFfYgHroGJpRvwrR86feJSYUEiGrtSAH6Rc8GHkanJf	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	42	1361	55	1	5381	jxdyzdokMgRfqDtyPQtY6MGbfxt5xAiJzdZzJMptxSouYUZBZq5	2883	4046	4046	1616667480000
5549	3NLMEXmxtbKsYorMjmQKe2HutVLZjXM3BjJ9DM4hbTi9seZ5h3Rk	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1402	850	55	1	5384	jwPXrD2gdaUcKDe6KNEctpcVL2RmJYV3fDGj3zAypVPvNmnYKJk	2885	4048	4048	1616667840000
5552	3NLqwgW4U8M2YfVsZiMSELLHXBh9dbJMCkZbdwhwmftqxk4hcvQ4	5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	1553	776	55	1	5387	jwgQFmB85qFcjbwoiaZehRhCJR4PqUQfojFBY5KB5p74KNdQYkg	2887	4051	4051	1616668380000
5558	3NLy2ZkiPqRNRzXtm4vcabqkazMzJUVKJNvCpWhQfWcBT668mr5j	5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	1631	794	55	1	5393	jwcf13AEQGeHfweAZExQ5gBwVf8MDsuGk5iJpDfkKX8Q6N9VX8K	2890	4054	4054	1616668920000
5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	5562	3NKhhFbL9KvJza3BshhipMGiNJnhVxyVZr8qXZh9YWduKSfa42WG	1627	1139	55	1	5398	jxstrTMSQJWsmXU148sMbzXHHiLMD65y2AkCocxyqiPvq2vCGXV	2893	4058	4058	1616669640000
5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1536	1187	55	1	5401	jwrTixRZERDavTcTUiQ5wSwiyP12SHJift148GwbwEV3ySEhuER	2894	4059	4059	1616669820000
5570	3NKZNFNJPzvX26akJz6pxJTxm4wD9NLUcZU5BEykwJbEqMR3jwMW	5530	3NKZCiM6J1niMmGuEfFeuoVmWWmULbetTrgo9cYBUbpeEDx49Fuf	1403	823	55	1	5403	jxnk2pwgUMmRUsF9rakM9bs6tQxcRjqLcKaLngZ1LSVKZiB4bGF	2877	4060	4060	1616670000000
5572	3NLU1FRtYbhytB57dcCqjT3DcKUFdNDMXBdHUwsuMZDy2Bka89mc	5569	3NKVKTWhTCAjP13RptzHEbsYGNV5pmGwQU5LPZNHLEX9mgox3uW4	1553	776	55	1	5405	jwmMNa8AWEVuP3S1LW2NYN535HTxDqasiVVyRXmco4YPmzw5CoQ	2896	4061	4061	1616670180000
5553	3NLa14YXqHhqvUH5gm3rguPWNGXEDYFx5EzCZXYRAN2Dx1FFm9HP	5498	3NKpXyZ3zo4GnTgCP84ZUZ9LETrjipeLKdY8PL8eCPWHiyJ4jdWk	1407	1395	52	1	5388	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2717	4052	4052	1616668560000
5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	1553	776	55	1	5391	jw9QTf8qRQW6rQQymWHHG2x4G15Xei1W4hhMddTa9y646nrprck	2889	4053	4053	1616668740000
5560	3NLTUh4nKguzKb2MmE26MXmJA1jTfTcYLr8CjPP5ufKr7ZpfpAST	5512	3NLjregJ5FzAtStLPoYHzAqkCbG7jzQucce73fQ5FaNZ9mkHLkZe	311	1061	55	1	5395	jwHeX1yhfqmBAcPBMrrksfgPHbmxFYTSzpgCndYkan7yBpPakjJ	2869	4055	4055	1616669100000
5569	3NKVKTWhTCAjP13RptzHEbsYGNV5pmGwQU5LPZNHLEX9mgox3uW4	5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	1406	1393	55	1	5402	jxzEekHsuBZxq6xxDVdzrYk17WBGEi3jVYaiChhmkECcM4JkSUP	2895	4060	4060	1616670000000
5574	3NLHPmX27Aix8JQzpKyiconxZuaprTgRCHVRR7P8nCRkS98JoJLw	5573	3NLWXLahaPB3hGjicU45wSrqdS9HVFKvTYnAD7H4rezBBUntFBY2	1471	1386	55	1	5407	jxmvMZyYjFHANjk7VF9tcQk1rUVZWPSCcyDRRWoHj8VTKcT7AeC	2898	4063	4063	1616670540000
5577	3NK6bQzfeAKMmHGB4VFdi2UjfJaQKCaJNyQnHps567F6ytAfHX1z	5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	1489	1014	55	1	5410	jwGoaHAzBzcZyRovGqsHWqTzw4jm6zp4meK9mx38u9X2dBaSVEd	2900	4067	4067	1616671260000
5564	3NKsarLmXyWGtV2LwCFM61ngDmeyJGGsHsSXfccrYpAWcWdMM3N1	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jxxSDrpQ7qVee4djNq23YR2JYtbSkkMXTYSmejsZHkUNfvWh5Da	2894	4059	4059	1616669820000
5567	3NKENd395sbsrNUkPDmEBYLhaLD8w7Rt39QrmAgYcQTFPxLTLzEZ	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jwG8ZywXo7N8YvnfKhSzHTNYtK1ARoDcndU7zNJzLme7DGWnRJp	2894	4059	4059	1616669820000
5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	5574	3NLHPmX27Aix8JQzpKyiconxZuaprTgRCHVRR7P8nCRkS98JoJLw	1611	1095	55	1	5408	jwGNdEAnfR2b51wsNqXNXvGaHxoxneqAh4kHpjtegtpmYtkTTBX	2899	4064	4064	1616670720000
5576	3NKZgjNyAdcxh9aCc6BYCoafeFuBLtc9kfHFXVrvifAKCD9zx5dN	5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	1455	1206	55	1	5409	jwtpPs6DGkp89WSUgazZLsb9PDfXfH2XQdbbi7TiErzQ2JCouUe	2900	4067	4067	1616671260000
5568	3NLnnGqcW5XkzhxEF2tFVMsU2Jr3Ft7sMvsyS7FtpN388oLrENvB	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jxtm9NDFuRMdWKgMXTNK9PrRUco8zXryVbuyxN58NgSnJsETHWb	2894	4059	4059	1616669820000
5571	3NLQN83qA8TTSGvvP1BA22NfAUBdzhK1PQgWRgWx2HsrpVGfHusR	5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	1581	778	55	1	5404	jxVQEg93MQXXFHaXe7fNpcjnTx8LtaPymQj489h946uooCt9Mnr	2895	4060	4060	1616670000000
5573	3NLWXLahaPB3hGjicU45wSrqdS9HVFKvTYnAD7H4rezBBUntFBY2	5572	3NLU1FRtYbhytB57dcCqjT3DcKUFdNDMXBdHUwsuMZDy2Bka89mc	42	1235	55	1	5406	jwijDvy7aUMpimaAPy31V9X5rs7Ztqr5dh4wXGewHCD966ot5tv	2897	4062	4062	1616670360000
5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	5576	3NKZgjNyAdcxh9aCc6BYCoafeFuBLtc9kfHFXVrvifAKCD9zx5dN	1624	1334	55	1	5411	jx95dqwxT9xAvh2eTvbYEnoYeEhr4ZfxbbiTqKtA8FtR1KSDX4J	2901	4068	4068	1616671440000
5579	3NLJKshRoZEbjzHLjk3KZbfbh1yjiZYEGrj5fKudBCQcD5ah6nDB	5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	1406	1393	55	1	5412	jwAGudB4usjaMoBHbD7d4aQBjSvWUJrYYRNyWcp86g2Fk9MGswW	2902	4070	4070	1616671800000
5580	3NLfXDxkuhWhtfzp7nQBv5EZv2t1fhUPcHit5kC3WmRymiKu8aBZ	5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	1622	1356	55	1	5413	jxJhDCGH5WjNJgKyfkywgeYtwQuPniraGaWK6azQtMSAmowg3qj	2902	4070	4070	1616671800000
5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	5579	3NLJKshRoZEbjzHLjk3KZbfbh1yjiZYEGrj5fKudBCQcD5ah6nDB	1483	1276	55	1	5414	jwuPDibWx1HYAmHhvHUKCm4AxxDUz6AJs7uDY8on5D5M21wJvyf	2903	4072	4072	1616672160000
5582	3NKu4GEtpEZyiKiS2BXYGTEjc4XNHnAc7iaoL3C5aCut4QuNrKuk	5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	1406	1393	55	1	5415	jwAkAu7TGuFSRhVLgdgkMwppBic5SABSFsGXNWfKbn7AFhPwMN3	2904	4074	4074	1616672520000
5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	1588	1392	55	1	5416	jxoJeppz9LjxrJJ4LPS6tUn21vxNmufWanHUVwYzu7inULzZw3n	2904	4074	4074	1616672520000
5584	3NL8jDnbPPmoNYEMNH2L8poRwQUtiyewidYqdcztsQbUxxWexPBp	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jxDc76TMwdEuz1EVgqKyTYVnBaVbwwwsJLFKZ3VEUsrnymE4Nra	2905	4075	4075	1616672700000
5585	3NLgaCPszCCi5axzJcopQHA9YBJv9nT6araanALdyjdsBTTWBZbr	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1402	810	55	1	5418	jx2dyZBvXEK1jM3Ww67AzE4iE2FTipynH9HTvv3uQApc9etKj47	2905	4075	4075	1616672700000
5586	3NKgvLDWGyAGQg1r5sGPzhy8W3nzzDk2Dy4HbRZS2Yd1JMDXwUFR	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1562	492	55	1	5419	jwARkRF8gWAfW3Udzhv8PDZveCms7co1r8JhzhreMgiPSpqBPvH	2905	4075	4075	1616672700000
5587	3NLRfFsQJQpu2pJN5v2f1wcobLZq9XMjLPrqGG37bKTqnuzwj3G2	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jwtFiJj9ycxpY8NajGs8kz7YsUZ8Ju2pXXuGrTmqXEjJHf9FsDT	2905	4075	4075	1616672700000
5588	3NKrY9myfD64mjJ9rtJudfEWJDTRvpJp6ZY4472HEnPSuwDQYzQ7	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1406	1393	55	1	5420	jx9ghWPdyt1hdGw5Fy9xBk7EPf1JRrhp17YN6gjarDXggsSfrxT	2905	4075	4075	1616672700000
5589	3NLpBYNuoRoM8krR2iE2kiwBoC5UdzwiUTZ7bUig6VMWtpTKYxqL	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	576	1109	55	1	5421	jxAyv5WeFP4RiZCxCR5U8F7rdLjHsvq2CWKkpji2Vdp6A3KX6Mb	2905	4075	4075	1616672700000
5590	3NLDbjULhjAPqU1tfydkbPLHc78VTTVvwL58Sy2cqPyyKJyKMZ7M	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1590	1300	55	1	5422	jxW1ygQoNUUrvW6qjPAozNXLyai2w8owngCtiNPFsXuTQKpaJEg	2905	4075	4075	1616672700000
5591	3NL5qkGTF2hfzk1ws2fZCb5quBNQuxqQYcRqt8LY42uMzsCtm2Jc	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jx4H8ivhBMGQ95BqrcANStatjf7VaqqoywSSnEYQQ12wHpx8d5N	2905	4075	4075	1616672700000
5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	5586	3NKgvLDWGyAGQg1r5sGPzhy8W3nzzDk2Dy4HbRZS2Yd1JMDXwUFR	1428	472	55	1	5423	jxVoAT9FpRnLrxo5gdTGiQj7JQL8bhH63FWLQX7c3jxsQhrkiCK	2906	4076	4076	1616672880000
5593	3NKZ45XhJd4TU5f3fSYLHNAoCHnxZQLbbur5kZ9zpzgpBhJBuDWN	5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	1406	1393	55	1	5424	jxAv6iDbffJKYetiK96ur7iY2nsrRv6PHWPzNybBD4qN68wQycF	2907	4077	4077	1616673060000
5594	3NKXHm2T3N5kvZXHPSZ87YhT7hKrwshkwrMVpsqwnaD4gnCaqS7c	5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	1602	1003	55	1	5425	jxAzhFm13eRzckyv8cDjS5YQixVPVffwSz952P6cRk8PbBdXcsw	2907	4077	4077	1616673060000
5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	5593	3NKZ45XhJd4TU5f3fSYLHNAoCHnxZQLbbur5kZ9zpzgpBhJBuDWN	1490	1274	55	1	5426	jwhELnCq9Jpciefuzm12joRaCFXMixRRuKShoLMKCAQAGCCAZrC	2908	4078	4078	1616673240000
5596	3NKJTKonrq4UAT5Nh4VDPbfxvGPgJwCmv7e7b4jMRVfwvNisws4D	5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	1490	1274	55	1	5427	jx2dj7toa7YMbcMaRDFT1Xt6XQ82DcgrPMQYvdyBtUAdrhyQjG1	2837	4078	4078	1616673240000
5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1547	1378	55	1	5428	jx6CFKSqm6dPohvyD4ULTpGjxopA46Y6J4wtnWZDLqJLk7j8LWf	2909	4079	4079	1616673420000
5598	3NKbbdmud51eNTrzefcRBi8319kq27wHURCoEK8WLbqnjPdbR1py	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	684	1352	55	1	5429	jwaiSw2UKp6ajTjRVTyebLkqufX1YGJ77VUiZ79WYbKUJqdPwgQ	2909	4079	4079	1616673420000
5599	3NKGDGnNTfP7hrWKsXQP8o8afuhsspk1LhGxCjXitTbsZUw3zuQN	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1651	1055	55	1	5430	jxxWhUJCGLiZMoTbxJLFKyFnzv97Ki6KVxEJKnUnzwNk8WUyB4X	2909	4079	4079	1616673420000
5600	3NLLyqri54FUE7LdwbGq1jCgx4ZVdEG4BVJchL5uX19AcPTohVJk	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1651	1055	55	1	5430	jwqA5KJoGpikGRzQiModyz8jTE356fGuQnavqvTwYwo46RqVEqo	2909	4079	4079	1616673420000
5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	1402	868	55	1	5431	jwixBXNFZuUzZaiVT6T1uqyxxPtkngKVA1LAPZ3Zq2dvwg4gbrh	2910	4080	4080	1616673600000
5602	3NKUfrgdcX96Q3xDEQWsHwDAnoNm9SqVuKb8EQrrCcfHFQi3NhY5	5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	1637	816	55	1	5432	jxDVPRzeY7G9JRT6A4gkFeyserYZgHBrXUpJ6MR6pn9BTcXAGEW	2910	4080	4080	1616673600000
5603	3NKy5wu4cAhXRxbzrL5yW7cfCFaityD79M3hqDvzNHxPH76DnSeE	5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	1503	1277	55	1	5433	jxN1FLj735PAGVgrwuSEm8ZBQbexxZvgM5wvT971mTqcTab1aHR	2911	4081	4081	1616673780000
5604	3NLSQox8VrnkVPAZmBdTTrGRwZKSJLjEedzmzeSysj83A2nAAsET	5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	633	1384	55	1	5434	jxFZAYj1ea19zCBDReTgfSX1kas6tpHTpj3BtsMweoq2mFfAMUH	2911	4081	4081	1616673780000
5605	3NLSXQjtPLVhGrqgbqdTQhDvmz8iM9yPfKp8tLXPki1pZgx2r9P5	5604	3NLSQox8VrnkVPAZmBdTTrGRwZKSJLjEedzmzeSysj83A2nAAsET	1541	1052	55	1	5435	jxDEbkThbYQJW2QUySGUhVjbPMUvmMrmAaVgU61D4donyPDAzin	2912	4082	4082	1616673960000
5606	3NKXhproXaci144iz8W6aeRyGUhg9vmeF1vwJdjY4ZukeqMTrKGb	5553	3NLa14YXqHhqvUH5gm3rguPWNGXEDYFx5EzCZXYRAN2Dx1FFm9HP	1407	1395	52	1	5436	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2718	4083	4083	1616674140000
5607	3NLDhzyQUuUAAvr5VgdHJAp9cwQUW6FXHxxfXxB3FoQTvow8pfii	5605	3NLSXQjtPLVhGrqgbqdTQhDvmz8iM9yPfKp8tLXPki1pZgx2r9P5	1448	1065	55	1	5437	jw9wMyyxHc1aqfWytE27ysg4WKMdBTZXAUR3RQYZk1ZkER9xH3Z	2913	4083	4083	1616674140000
5614	3NKS4EWdXVXrtzyWa4386WUL2Epnjj7wwiR2udGmZ6unZVutkTLd	5613	3NLRxEWED1GrAzzSvHLysoWkGdMTwwHxJ9yGDLkoUmgz6NVBFp2z	171	1374	55	1	5444	jxoUWdL3fwYhoS7zydzCTj2PCVBEMXunnrwhj461yqGhYSDJTME	2916	4088	4088	1616675040000
5617	3NLMqQuVgZhVyjb7PLTSj1eCbmerRME8gU27hdgLJ7akg3mYgWHQ	5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	1623	839	55	1	5447	jxxaFJgky6ZMKG1XuNnQeFuFWr9hRxJKWwCheQ7UD2wMAGmcdmc	2918	4092	4092	1616675760000
5620	3NKSLUtZ6g189GzDoc1bmi1v5HHXkjRNTX2SBqnNgiL7Mt1sYWch	5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	1553	775	55	1	5450	jwTH3PnfdcAmo9tsNYjjUKQfVhQHQABVoq6hQ1cPbwFdhT3Sps2	2919	4093	4093	1616675940000
5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	5620	3NKSLUtZ6g189GzDoc1bmi1v5HHXkjRNTX2SBqnNgiL7Mt1sYWch	1534	1191	55	1	5452	jxXCzX5oJHqx5XxFqcm4BaMTtQ29azqWJmRfRAAFyBNqV9vD7hZ	2920	4095	4095	1616676300000
5625	3NKkyeYum8Hj6SAJm1gYamLuDuim5jjMJ29UjB1fdjPY6oTebusf	5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	1571	1089	55	1	5455	jxUNdsZjCMKd2CCv6peHvrZLtAMBufFGCyUJBZaRwVdpvv3Zo6y	2921	4097	4097	1616676660000
5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	1637	816	55	1	5459	jxDY5KpvSv5YqDw6e5Xx9xRruRR9au2EnA54rZi32ZoFEbR72WJ	2924	4100	4100	1616677200000
5630	3NKRp1RyPbM3dv8BuiwvcgWGt823rm2ue3uv8HAHMDsuHX7oGmpu	5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	1593	1346	55	1	5460	jwWjFvLmipFYxHiM6JaTp1YHgqh4DawTLpqSYAwbsPFHLrcguxD	2925	4103	4103	1616677740000
5632	3NKhvdBJsH3PQ5kF6r8bMfF8KnWyEQwjWTgrCg5BJHSvWg8nDLVr	5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	42	1361	55	1	5462	jwy2xmeuhGNfZ8FdfSMQkEGV1RoJfBcMHM9PaoDfLSoPNKqfTCS	2926	4104	4104	1616677920000
5638	3NKq6xtzXGZKoGCHJEsk1HSxy88p9n45fw29WigPFEsDYJUGnpaf	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000
5640	3NKmcyb6XtXtonANg1Svn15qLuSspoHVzuWgYr3vWsQtoefr7yZ7	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1594	960	55	1	5466	jxieTMqFFyUJxskeYdQFdWFahsyYphLcPkVNTqJFWZgyrPhewaV	2928	4106	4106	1616678280000
5641	3NLfT14A2iEGzJnWLNuT2wkkXZNgvYwh8HwUtJCyqL6AzXUaRoYK	5626	3NKxxW2eWBmCQSbNcoeCB6VxxVF5ELye28DzGhheYQQenatNDsrd	1407	1395	52	1	5467	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2723	4107	4107	1616678460000
5650	3NLyLBrccqAUUmB2Zk5A6hbocpj4E3wHLJ71YrEUd6GBLG39pLgM	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	298	1182	56	1	5475	jxzRxp9Ez6548E1iKeTdNyc6NaatgxkkHJakK1bbmAY4u54m7jv	2932	4112	4112	1616679360000
5660	3NKG5i3m8Efe7BL5vGAnTWdJnxDDUEtYYFTkxDfd33pEucnbxn7E	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	532	1303	56	1	5484	jxsNSthWdtrPMbZTiJGo4YqmWBpmt6tdA6wd3jEveK41b1LutKE	2935	4118	4118	1616680440000
5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	5659	3NKiA2LHmkUYMyBQ3R57c1gEryURV4kPYejPsEwXtaFz3ngGHBKy	1593	980	56	1	5486	jxWRg9nN35bJv52W4JaKeHAkcej1pCBbpokDudrXssypKcN1nJg	2936	4119	4119	1616680620000
5664	3NLM3bF7d9g12qB4PRvkxTfxX1cuHtz3T3ATnTwbezLybQrQk2Ts	5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	1601	1022	56	1	5488	jwLU52w1Lp5wCY5T48YDakRhUoJTrkPDkxY5BetgioK71yCAwpj	2937	4120	4120	1616680800000
5667	3NKBgzbAJbNG9tJvkrE4KWEj3SPHzssuVW6uTCnrMFQzfmCd63RK	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1581	778	56	1	5491	jxvFCNiLMU2BMt37eYdv1pCHT2F23FQDms4PRA9V6o3hTUAArXN	2939	4123	4123	1616681340000
5671	3NKWYmp6EL8TxCqX7ebjVRqsR1pxbCGZgXwzpz4g2i6XT4YxNCWJ	5667	3NKBgzbAJbNG9tJvkrE4KWEj3SPHzssuVW6uTCnrMFQzfmCd63RK	1602	1243	56	1	5495	jwSDULztAnw7985rGqbSYXqxa84WgRnyQpqyVZWoCvMy7wXhSN5	2940	4124	4124	1616681520000
5682	3NLqhiYKFp3iQNk7fUsd2nGyDxYQwwfjAphYao9oMFd2Zy2aDxvw	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1549	1116	56	1	5506	jy2zL6dkkEPquemvM9ApUHyASWdXwyPbUVUG1oNgipWzFxunGg8	2945	4131	4131	1616682780000
5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	5685	3NKRMwQzTuUE5VSsXMS27tCLUXMNupyPh58dfX8WxCcaDTs9Vfn2	1406	1393	56	1	5510	jwh9LaCnG8PR1akBLobgrSyR1eL6Zsi9XXWk75thMbpqDLyF2ob	2947	4136	4136	1616683680000
5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	5688	3NLPv51x3PaLjj6M4Cd8Sgy4EaQ77TYqzcw2vPAdf9dhBJaM2zjN	1581	778	56	1	5513	jx11dYBYh2RuZJJVXksT1yy6z34C4T8Xv8tm5ybn5AhtHJ1YeBw	2949	4139	4139	1616684220000
5694	3NK3WxXA5jMggKtv878xNgCiaozT54aGvrkYVFwGtNDEFpsUBnub	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1564	1212	56	1	5518	jxhTTnbfFWE8qiryLwgVPsGSUtcdE4YscpxoLe7951v8FKAd5hy	2952	4142	4142	1616684760000
5696	3NLvZGCEWPfDwwGETU1xBT5LfeumUoRMoecUukt13D6NAK8Vm8eN	5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	1534	1071	56	1	5520	jwNnBPpwN23fP5c6oQR1dFVbqmf9Ds4mRJ1Pg8BRFb5LSRvXgmH	2953	4143	4143	1616684940000
5699	3NKoeGngWTqSFKeiFpfm3yQAkzN8Vr81ijqenenmi5Qjgw7Xuqd1	5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	1600	1126	56	1	5523	jx2dHNhH8CiWziqhZBVyPWcaaB4cGDsu9YdRCva4MoUuC9J7WFh	2955	4147	4147	1616685660000
5701	3NLpUCWsyJtkZjarbj6JxjPBfNuqPaaYtLKvCxQFUKb1kzC2i17Q	5699	3NKoeGngWTqSFKeiFpfm3yQAkzN8Vr81ijqenenmi5Qjgw7Xuqd1	1439	1279	56	1	5525	jy1VQWLcZTesetaWGhGjt7AKH449VhR5651BQyFh9oN4v9MwscA	2956	4148	4148	1616685840000
5704	3NKA2m2n9Ms2Zjnqqzrr6oPhH8yxCm3r1znSFgjFt1mFpzvD7LGC	5702	3NLVRhS6294KFXCxC24vGu3TJSsAGpeZa4eLuBucXe1fJRqBgVJH	1601	1388	56	1	5528	jwTu9GZWLSr4oaw4rGaySU3aSZ4bC9Tz5wSXNLiyKXfrAeQsYme	2958	4151	4151	1616686380000
5707	3NLBh7QaziKKnzoe29i8yzihhvqtrBoq1efZ4av3n9V3LMVcpCag	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1448	1311	56	1	5531	jx3v2eMT27J2jtF9VkhrcXpyVXszhxHsaAtFDHxf4LvdGN8PseW	2960	4154	4154	1616686920000
5712	3NLB7gDoKFPcNUVcGtCJotqKo1pqjydwg8Fpv5yYfykF8cBAi3AM	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1648	918	56	1	5536	jwittKgLRymmzPZSkTh2Lte5RPjUWccxoQHfek6AZqvtxymYQCB	2962	4157	4157	1616687460000
5716	3NLpCNmqDi2HQ2UWLDwbLoijfxXBWsCQWEWDDc5wdGvU7veiJngm	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	369	1186	56	1	5540	jwjsJYgREUD1NjLDbQ3kMbsjDs4YMQns9awB9EQ1aHWXRZ92P5h	2964	4160	4160	1616688000000
5721	3NLafBqsf63d1SvjuTftGBcutY8BZq9V9YG6oCa7fH4NwPxKpMk8	5703	3NLgiPedotXbjLfBVF57ke5w1MyHcLWrN6SGtWZEqLQzKxNdv9fx	1407	1395	52	1	5545	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2728	4163	4163	1616688540000
5724	3NKmxd1nkPZaZ9Xpuz4i5sj6CWj8jYg7ETUaDCfnRivbMA9t12Mb	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	171	1374	56	1	5548	jwsJYurYDqkZZPt3bZkZqAj5U9pYAczptLm6nacZ2kH9uUipgTY	2966	4163	4163	1616688540000
5728	3NKFUY9SuMGbykqLrdYQX4uMV1hFnAiQXNbHv4pbX9F8xb3QbQrM	5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	1607	1348	56	1	5552	jxwTPmw1Gi7bERV8hEFYrDNkX1bUGXr8w1eukGG8TvhRWgT9pWe	2968	4167	4167	1616689260000
5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	5607	3NLDhzyQUuUAAvr5VgdHJAp9cwQUW6FXHxxfXxB3FoQTvow8pfii	1637	816	55	1	5438	jy2CBWQiAJiUx5SM74K62EVTR3vefP9S5DLXqYkjznZTUMGc2kC	2914	4086	4086	1616674680000
5611	3NLPVoRf4gmzHxf9KS5fXJSabzusfVNwYsEKbsWGywi95oGXEYYz	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1406	1393	55	1	5441	jxTSpXGdnsNREG4hNMv55gvztpvTuhmpTuaM6qbTqJB7JNRqkrr	2915	4087	4087	1616674860000
5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	5614	3NKS4EWdXVXrtzyWa4386WUL2Epnjj7wwiR2udGmZ6unZVutkTLd	1564	1338	55	1	5445	jxhCJhEP6fD7ajL356LjYXWxn2T7E4kDGNSRBusRTDRD4MzbE7B	2917	4089	4089	1616675220000
5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	1553	776	55	1	5448	jwZbGbAU553butcXfsWmWe8Htva5Ht1R6aH3TDEZQavczYCn6qE	2918	4092	4092	1616675760000
5623	3NL5gXsYQDmCyKzeEjTSXYfrgKHUFFJnRdZpKReRqyaa7oAGaPqw	5621	3NKR8JKbmqqKX8hKXa13uiv65qf15dvnRQjpwCqZ6iv3apUxaEaQ	1407	1395	52	1	5453	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2721	4097	4097	1616676660000
5627	3NKtCgYKaC5Y5fPLxmuvTCA737bDXubRDkdnP4xdeQ3BYu5NbqJ9	5625	3NKkyeYum8Hj6SAJm1gYamLuDuim5jjMJ29UjB1fdjPY6oTebusf	1527	927	55	1	5457	jxWfWttQQSEHKZkS2XXQw7FNKCU3BqGiT4HmVHfo3ha7wm59fPW	2922	4098	4098	1616676840000
5633	3NLcgLKR8RTsp5FPXhPKkZeM8p6u4NHHn56YzhVbkpHAocCJPPn8	5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	1406	1393	55	1	5463	jxH97xNkGbvoEj1KonZ7uURmYjbvinFv9dYkTC55B6J1rNvWWqt	2926	4104	4104	1616677920000
5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000
5644	3NKnGnbNHoASDCwp6DSJEPLudJqXK38AY3vtX57wSZgG2DfQ3YkK	5641	3NLfT14A2iEGzJnWLNuT2wkkXZNgvYwh8HwUtJCyqL6AzXUaRoYK	1407	1395	52	1	5469	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2724	4109	4109	1616678820000
5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	484	1319	56	1	5471	jxRQWkQpbHgZjaCPH3EAmmig56HhSMvxvQ1xvu1TtG6x5v2hbPd	2930	4109	4109	1616678820000
5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1455	1332	56	1	5473	jwM8wvBP2tAm5sV17Q2Zz6EEJt5t3GFjtavU9AQkgMhV5mCUBAr	2931	4110	4110	1616679000000
5651	3NK5cqjn5fxFCjjL3ZLADP6oineJnkXqctpjdbJdvSCsJASKtqKP	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	484	1319	56	1	5476	jwJrVxYhtspM3uLhpNvUmpdnKrRK42WHGFQSnRPQ9GaLPcTB7kF	2932	4112	4112	1616679360000
5653	3NKrFEFPE84auW8iU7hWinSdMPHWsMYJAECA2Uz9UcJeqvjKsRJb	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1651	1301	56	1	5478	jwQD7V3XpkhHUnaLxRcdoA79tGFPMBphjCWz4bLZAYWKAfFrHS2	2933	4114	4114	1616679720000
5658	3NKofkwR6b5vtn76uxg4n7wtVvXHU3PUbyuGaaqQPAaa9fYsikdZ	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	1670	1282	56	1	5482	jxETq66g5KLhvxLCAckCAmWZdAYsG41vago87DmpbZZXd4hWafh	2935	4118	4118	1616680440000
5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	5663	3NLig7x7X2MVhL3cnsRyPLZg8W4H12BuaQ7YBDR1xvip96CHaXvX	1483	1276	56	1	5489	jxBTJH7BZgXNGHYkLSmD17hXDnJLC7izZZsJ3TrV6fhyV9g1qkH	2938	4121	4121	1616680980000
5668	3NKndZ3AK8isADPacEogccfaKzGX1kQacFQLvYTZwWU7FoY4Jv7x	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1616	2	56	1	5492	jwuLGAuDQT8w69LFuavF68BdmP5C9xFCSiGe84ZzbyLQuBzgR4c	2939	4123	4123	1616681340000
5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	5671	3NKWYmp6EL8TxCqX7ebjVRqsR1pxbCGZgXwzpz4g2i6XT4YxNCWJ	152	1204	56	1	5496	jxHo6ixovJ5w3em7cCVc35zrCpDo8SDCvEZqY4PbcDzVfoS3GJE	2941	4125	4125	1616681700000
5674	3NKcSufrh4nAMdTxECqJPXqqa1q2YvPKaLFtBzsuRoXzuJKYTfUo	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1652	1315	56	1	5498	jwKoWoj2m8j9V2Y5VJKR26U7auLBTabRaWudPHh8hx1ka97a9nF	2942	4126	4126	1616681880000
5677	3NL7qtDxtZuciQY1fhyDxtHcpiPXxqCRCSnNnmsS7EX1F1q5Vu4j	5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	1549	996	56	1	5501	jwGUhJNLa87fMY9XsoU2vFoTGKeLeTsa3UPvPrbrNMHEek8jkJ9	2943	4129	4129	1616682420000
5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	5677	3NL7qtDxtZuciQY1fhyDxtHcpiPXxqCRCSnNnmsS7EX1F1q5Vu4j	1529	1316	56	1	5503	jxgegH3QyN1XyjCJ7YASmEpBzeC7tP3waLegaDxTZWdvQYrW5qn	2944	4130	4130	1616682600000
5683	3NLZwHAEkjY5CFzJA3XNJzB6a11YD4gqDCDRv5DCWHk7m7ZTZ19S	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1623	839	56	1	5507	jwicFXnTtdJk3sDUuLWnziWdhmFJef8TwxScKD7qnadQoDapLZT	2945	4131	4131	1616682780000
5687	3NLTU4gAHKvPRt95nBXUdgoDtEPQ5zcFmNyjthJjKSFrhL7rRR2p	5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	1553	776	56	1	5511	jx6YXiMt4nYCr5Xsn4w35xB47tkDDBjsngNRRhNxjPPpvgTVyq7	2948	4138	4138	1616684040000
5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	5690	3NLXYFxMrd81bgHGHxTBWHJADvE8j54icJpsQzR1EsCPYvqJYxJz	1559	1353	56	1	5516	jwCuFtu1GpCvbJKjHbtiaeU1VmS4NpUyA1kTiVvV186ggS33y65	2951	4141	4141	1616684580000
5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1440	1377	56	1	5519	jx3MjstxJubTXLxHT5ZSTR9cQ6udXmMM7nPcUi9Z6164F61ALSr	2952	4142	4142	1616684760000
5697	3NLHEgqWA6HHP64u9PmL49KbFpnuVr73s2fKc1GWU4VqUg487PP8	5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	1673	1122	56	1	5521	jwYSjvgjFRfDUxRTqULyLA1468DsKXa52X2Du43j9UctGSdnGLs	2953	4143	4143	1616684940000
5700	3NLLftA3Ue3tT9pfVtY5tABUX2Qtf1DoqG12tV1qM26iPPiuzQMB	5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	1585	1000	56	1	5524	jx1JA5cJdk1dLQTgVzdES44SMMqanpBxUxGPZFdS4AAKo9LeMa9	2955	4147	4147	1616685660000
5702	3NLVRhS6294KFXCxC24vGu3TJSsAGpeZa4eLuBucXe1fJRqBgVJH	5701	3NLpUCWsyJtkZjarbj6JxjPBfNuqPaaYtLKvCxQFUKb1kzC2i17Q	1406	1393	56	1	5526	jwzV8Qg5Db4gW9QtnECeiL5DcMG1jzPL3jaDStUUiu5nuESSpE1	2957	4149	4149	1616686020000
5708	3NK6u8EsfYWcZJYZnxiJSv9WMu5J1TZqJ5bBUr3FbD2FAA1Re8FM	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1607	1348	56	1	5532	jwk2Qw8Wu7cbDGxEGPY1rJvNv1ZWmcVxRgpCdCGiJwccsZrMoV3	2960	4154	4154	1616686920000
5713	3NKoPLkYSJg5jJj7Q2HF6SZkE5szPEPajwdoDhzFLyHjsdZ4Door	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1600	1246	56	1	5537	jwmTFKvgaWTNMgEfV1BCnfwzheUdwSBJSMTKGq2jx7EVn5zGTi9	2962	4157	4157	1616687460000
5719	3NLdQLExUnfoGZoyYq68cRd84VvM3BgroQiS1DEyvqafMvx9odBZ	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	44	1199	56	1	5543	jxtXyWfMXUvG7dMhDvepfq5cbx2xdhXkk5aMGZG6jtzowdPxH66	2965	4161	4161	1616688180000
5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	1471	1140	56	1	5546	jxFsSDfa2KQupCP9b9NUd5Ko9Nh1sXJe3WHPFQt7yVXBL8oJGZJ	2966	4163	4163	1616688540000
5725	3NKJ7yxUF368DihPkdUwqkk78N54j8eAxTUpkqTwoMrLcHXgquaJ	5656	3NKhcsRjRfsqKmdtwuXUThtiY87ENRapzJ9DvxutDkJkYW9BMDy4	1419	814	54	1	5549	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2815	4163	4163	1616688540000
5609	3NKZgMz5xnPEvrqFzyseZvmNo5VfikC8AQzRczotnEw6kL8w8PVE	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1567	567	55	1	5439	jwiAFw8cuKgEAQpBw9KjKS7WhMRhfU7GrSu8v5jNq4YJrB3w8Ce	2915	4087	4087	1616674860000
5612	3NLwfwYGJG3mD8msBAFzEu8ga7QanHQHHDuT3KJLVpCAWR1yVkSV	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1581	777	55	1	5442	jxdg5XSjqj8QiS6G69qnQ6viAQ9JaSt9gmo5uT5QWLgXq1VqRBz	2915	4087	4087	1616674860000
5616	3NLpsuDpp1P5LnK8zJRC7VsjNfaaNp6BzozbfwKzw7DQK4bfokef	5606	3NKXhproXaci144iz8W6aeRyGUhg9vmeF1vwJdjY4ZukeqMTrKGb	1407	1395	52	1	5446	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2719	4092	4092	1616675760000
5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	5627	3NKtCgYKaC5Y5fPLxmuvTCA737bDXubRDkdnP4xdeQ3BYu5NbqJ9	1406	1393	55	1	5458	jxoVaVVM96B17VAp7zftHwmWjQnVAnE1tS4zwUT4EeeYYRJQFqU	2923	4099	4099	1616677020000
5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	1508	1387	55	1	5461	jwaMpSFNaeVf4myXPi2cKoL6VD7kwzXZ6M6u2ZoMGHgW4yPVzJd	2925	4103	4103	1616677740000
5636	3NKjjLdcV7jTsLkV2gknxZ5Xir9u69HyZcmLfVNZvyBTEM4KVaGj	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000
5639	3NLKeA2Qv2UJVEyaropwLn2j8D3WajjZ5Sc8vZoCW4MNTtxHDxxV	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1594	960	55	1	5466	jxieTMqFFyUJxskeYdQFdWFahsyYphLcPkVNTqJFWZgyrPhewaV	2928	4106	4106	1616678280000
5642	3NKaPnQRDUMejVTRHgZRCHowZzhNeHEe7pZswWQgGWnRUCcmxJzx	5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	684	1352	56	1	5468	jxXJdhpgZAKfCMnYZT13LiMDwHzKtaxdjCEu8mEkbQRZNKH3iN9	2929	4108	4108	1616678640000
5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	684	1352	56	1	5468	jxXJdhpgZAKfCMnYZT13LiMDwHzKtaxdjCEu8mEkbQRZNKH3iN9	2929	4108	4108	1616678640000
5649	3NLU3KshZgw5NJkRhtxMDpcNLEs4rJ3Rp71GyGsme64zm6iYPJv9	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1516	1294	56	1	5474	jxnZ97MMXkA3ytbVV1QhJ51bxMqrhGDEHSjyDqYYw5q1otnYbGc	2931	4110	4110	1616679000000
5654	3NKbFPK4uNFTAyJss1RRcBnNitfnPibaQ3d4t7nsjLXXSSBMzHbt	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1633	1390	56	1	5479	jxgEzBZuAchHsna3gxPdg6TQKCupHX8Y4Y9LorjvzaAAsqXZVTk	2933	4114	4114	1616679720000
5656	3NKhcsRjRfsqKmdtwuXUThtiY87ENRapzJ9DvxutDkJkYW9BMDy4	5432	3NKyUnZzRaubMhoGE2XMS9qHBfuoXm7eQvuxcbZ4B1H6TLdsbMJF	1419	814	54	1	5480	jwDMsobo5StnPM2qzjMWD2hxArETZ8ZL6SPLCcmszinA7g6xZWb	2814	4115	4115	1616679900000
5659	3NKiA2LHmkUYMyBQ3R57c1gEryURV4kPYejPsEwXtaFz3ngGHBKy	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	1457	1391	56	1	5483	jwKj8o3zzgth65RFCU3Ntj9khGLEhxAS6g2XrTGYAFRzgdAyo2w	2935	4118	4118	1616680440000
5661	3NKwxh3mEsg54UYRRJ3NdE1XebGXCuQ8LqquW984bP2uoQaM2ZKf	5644	3NKnGnbNHoASDCwp6DSJEPLudJqXK38AY3vtX57wSZgG2DfQ3YkK	1407	1395	52	1	5485	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2725	4119	4119	1616680620000
5663	3NLig7x7X2MVhL3cnsRyPLZg8W4H12BuaQ7YBDR1xvip96CHaXvX	5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	1406	1393	56	1	5487	jxy2ckjDY51UcSkoX7A8pt32z36mfCppDCQKMsgpJEvxJk5vL6g	2937	4120	4120	1616680800000
5666	3NLS3ZdFh1SvaU1QH9YgjkV3DBFEXzr7CBMyDQ17JLKUyMTs3ctJ	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1587	1231	56	1	5490	jwjuX1JPkmgrznTz4XAGPmsjNFDnhuFXfVZikJkHLoAiTD2soi7	2939	4123	4123	1616681340000
5669	3NLEB7AqdbfPB73dfmRaR33GBYNzu5GhNFP56aBnxQU7e4WAmoWs	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1477	1350	56	1	5493	jxfcJSnv49KyWErqkWYV614gb1ro3v16oRSVDTKMwpWAeRgC1LW	2939	4123	4123	1616681340000
5670	3NLSp8M71A8MsD42tqawBbYn9xGzaqWQFXYgtGtxf1bGbih7Dst9	5661	3NKwxh3mEsg54UYRRJ3NdE1XebGXCuQ8LqquW984bP2uoQaM2ZKf	1407	1395	52	1	5494	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2726	4124	4124	1616681520000
5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1637	816	56	1	5499	jwCpmcVNutbEiJDsvAB3bs5Z1KUinA4iEZLKf8zEzcHkNSSncER	2942	4126	4126	1616681880000
5678	3NL8qySBD5VDwT6yroGeXDb2RiRsWf1mAy8WgFsnV4V229fFXGE1	5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	1401	231	55	1	5502	jxq8Kw92mKtgeyfdEzoN9tsCkgjFmn4e6z8V8tafhq4edJRzAij	2830	4129	4129	1616682420000
5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1403	31	56	1	5504	jxiC6x92L28SuLHQMHRvxVAyVmrGV8WTNehi2iVRAQ1DowwYZfe	2945	4131	4131	1616682780000
5684	3NLrVA5LqDHUPPGVqKYMgJZLfePtA23h5HgBk8xvKimHisDgMpvs	5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	448	939	56	1	5508	jxk96HTDzkyNqdDT4HZmTUrobkgDBzv9swXSY85L4QyB6AeGCrS	2946	4132	4132	1616682960000
5688	3NLPv51x3PaLjj6M4Cd8Sgy4EaQ77TYqzcw2vPAdf9dhBJaM2zjN	5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	1633	1390	56	1	5512	jwdHZMH4dQLtQRjLnG8fgGi83AtFDaMVjBk8DXzhpzk3tGsE4pL	2948	4138	4138	1616684040000
5690	3NLXYFxMrd81bgHGHxTBWHJADvE8j54icJpsQzR1EsCPYvqJYxJz	5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	1589	920	56	1	5514	jwqKSojxLQBBpSGHEeEMkVKB4bqYEHp7KejPUWsM3wqkW8gwY2D	2950	4140	4140	1616684400000
5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	5704	3NKA2m2n9Ms2Zjnqqzrr6oPhH8yxCm3r1znSFgjFt1mFpzvD7LGC	1405	873	56	1	5529	jxWofiuPoKxr74raaDzumPattEtMHEHFcjdUsPzRAicbawE5Crh	2959	4152	4152	1616686560000
5709	3NLdmxjZmM85ACtkLC5cUp86KFw1SNutqeixi27n7yUrWT4TxP5W	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	43	944	56	1	5533	jxEjEex2EDaxzqbABSsJE8fuDt8mbHdWfaEUwXweydCL8tFvZCd	2960	4154	4154	1616686920000
5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	5708	3NK6u8EsfYWcZJYZnxiJSv9WMu5J1TZqJ5bBUr3FbD2FAA1Re8FM	1509	1074	56	1	5534	jxHRbZ98WNJh7TGsvqYvwraHN1pQeKQ4V3TKPB9C91Z9P9yo8Jd	2961	4156	4156	1616687280000
5714	3NKfpXeWgKb78D6FrwRY8sohUkxBWLv3DnfukgWuNffdqWoKPrAV	5596	3NKJTKonrq4UAT5Nh4VDPbfxvGPgJwCmv7e7b4jMRVfwvNisws4D	1490	1028	55	1	5538	jwjU2gDkyiFsRdKrkdxHujWeqeE2XDTTkmCss2cEEqDcPamsf7E	2838	4157	4157	1616687460000
5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	1637	816	56	1	5541	jwYgdgmWm7E5eKcAKd29PE17NCm6LT4xhoV6f159hTnC9Qj2W2i	2964	4160	4160	1616688000000
5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	1613	1223	56	1	5544	jxnwymjPFszdpYB8YwJwkGc35pJxXsD1bYMSrZxNAx2J4F3LSic	2965	4161	4161	1616688180000
5732	3NLLTA5oFS4vMNY9zihayRzhUWAdnQf2uGAdceUoatz3FJM9dpSe	5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	1571	1209	56	1	5556	jxm4BYCnRqKXRUBCkGoi5iVJpx7cfFPudwdVz7fvTefWHhqfFhE	2970	4170	4170	1616689800000
5735	3NK7RHLR2a4bKqaeNVL8XQV8atULddcixtNuWY6GodV4FaJnnMFZ	5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	1649	1137	56	1	5559	jxerZgGkj7GffbGKZre8RgiQN1oR5PeEj3wpirU2qKdrPEqKMQh	2971	4173	4173	1616690340000
5610	3NKihgNdFa7ZZst8Z2to8RCLaD512wgEpGsQd2aGPkdmWmoxwtdJ	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1403	824	55	1	5440	jwZjSmw2fDefFaFPNWjpMbrd8HVBvUPbv5FgCH1ttjJUnuGXHqb	2915	4087	4087	1616674860000
5613	3NLRxEWED1GrAzzSvHLysoWkGdMTwwHxJ9yGDLkoUmgz6NVBFp2z	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1477	1104	55	1	5443	jw9Yfs7DtsFbTg8AJXYFA3qWnV9daFbNUwsXN4KXUxmu2Xnh2R5	2915	4087	4087	1616674860000
5619	3NLfeEFhdsk6wR1XcAXaDanzS5AjqUBu58GpkpDUKXBcx87XgPX9	5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	1440	1131	55	1	5449	jxF7z27gvyx8pQwG8iuYgTqdFwB5AzqHGHimW7D8eMubZ4aG1DX	2919	4093	4093	1616675940000
5621	3NKR8JKbmqqKX8hKXa13uiv65qf15dvnRQjpwCqZ6iv3apUxaEaQ	5616	3NLpsuDpp1P5LnK8zJRC7VsjNfaaNp6BzozbfwKzw7DQK4bfokef	1407	1395	52	1	5451	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2720	4094	4094	1616676120000
5624	3NKkBELERC9AaPZasFbwjmGy4Tnh1kd4iHnVMh8Wy7QtZT5YCJhc	5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	1547	1012	55	1	5454	jy2iXjQburSZPf3ASNQk6SPNCopNbux89uz39AnTktEbLnZXq4q	2921	4097	4097	1616676660000
5626	3NKxxW2eWBmCQSbNcoeCB6VxxVF5ELye28DzGhheYQQenatNDsrd	5623	3NL5gXsYQDmCyKzeEjTSXYfrgKHUFFJnRdZpKReRqyaa7oAGaPqw	1407	1395	52	1	5456	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2722	4098	4098	1616676840000
5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	5633	3NLcgLKR8RTsp5FPXhPKkZeM8p6u4NHHn56YzhVbkpHAocCJPPn8	1406	1393	55	1	5464	jwUYtANhTgoDfSzajLQFL4ZTMrms2bLtVTRH73bsUGdi6XWsRkJ	2927	4105	4105	1616678100000
5637	3NLqpE4qeRNAYLXMxRZHsngF62YsqqtbKWfUiRnjW43NtBW36eBb	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000
5645	3NKhtgmbLYdjJQVypwe8wKw2B4X4ZLN3spCCjV1Qe5giDyo6t8a7	5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	1672	1285	56	1	5470	jwKby7i5PaVqrty6ALU5Jihv5REhD1zZE7bJSTEHp3B9JUehTym	2930	4109	4109	1616678820000
5647	3NLxUqXQ8jjDX4qqcs9pc2vh1hU3F7k2yKqQnh8oBDvNi7vFALWm	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1564	1338	56	1	5472	jwZSdjEEVXLqNqekRvVFLuz4nGAmyBMuwPrTMMdR1YLKtPMVs3j	2931	4110	4110	1616679000000
5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	1455	1086	56	1	5477	jxH5E3dRmUA6oG8qw446eVHXUDjbYbfsoU1S4DU5qTvhvFTjZ86	2932	4112	4112	1616679360000
5655	3NKUHgWR6ztg3jc9LkLqjDvpSWY78zJjEDmpvUrne9uhy6TRJ7Fa	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1651	1301	56	1	5478	jwND723CbneHETYN6WaDqneiQ3WKjaPXivWKcZJRqtwAYhb35y9	2933	4114	4114	1616679720000
5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	5654	3NKbFPK4uNFTAyJss1RRcBnNitfnPibaQ3d4t7nsjLXXSSBMzHbt	1637	816	56	1	5481	jxg7uezT36nsce667geHaDt7josU5BkAps2WFVjuVpnmrbmoNCN	2934	4117	4117	1616680260000
5673	3NLSqsdnsb4ycCviemp6UTaYY6btGMtgQaeuPp8Nd8XA5LMraTj7	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1608	1043	56	1	5497	jx2yY6c9nJvaPFMN5SMpNRsYgSmogqJgENnzZiMtHUPe9ntrUos	2942	4126	4126	1616681880000
5676	3NLMpT2uuH2pYsFBjZt7xLzGLxoJHo2eRz6D5SGVA1JaLf5TsrAg	5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	1422	1211	56	1	5500	jwNQhBzWPGMMrCJFcAjJuLwxUtnK5jhC9kqpTFPByD87weLT6Sy	2943	4129	4129	1616682420000
5681	3NLLn6i8EDFCg3gMeUgniwZT2mDLT2rdNHXoU1yVbRPP3RHN8w3d	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1564	1338	56	1	5505	jxVLb3zXZxNeo9h3K8qk1LdBFYfCY5bkzwwVuVRxJL32orsQfiQ	2945	4131	4131	1616682780000
5685	3NKRMwQzTuUE5VSsXMS27tCLUXMNupyPh58dfX8WxCcaDTs9Vfn2	5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	1447	1099	56	1	5509	jxBhCPF4E8izvjGMerHES1aKh4JM9LJnscP8ofAVmVDJPQqaCMV	2946	4132	4132	1616682960000
5691	3NKdeAvzqUxpGUidQqeFXXFZZGcB7Qhzng1acD3xJKT8iSRqys4d	5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	1451	1046	56	1	5515	jxMPdEfb9QqHJ3P59jMhCZj5MFtBYWGj2FSLZh9gjXdFHK3AGxy	2950	4140	4140	1616684400000
5693	3NLEai6yhBNF62UCTgNzutt9LG7qxsA5r2L162YZsy8Grs2CjVuu	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1547	1378	56	1	5517	jxLf2csnApuDTJjfXaRdKWsXteoaavjQRAE49hzjE3du57FsVP2	2952	4142	4142	1616684760000
5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	5696	3NLvZGCEWPfDwwGETU1xBT5LfeumUoRMoecUukt13D6NAK8Vm8eN	1631	794	56	1	5522	jy1ZSioaPRJE3Kpi1LnGZDra57kWkv6dT3W82U5wuEvALZsukLT	2954	4144	4144	1616685120000
5703	3NLgiPedotXbjLfBVF57ke5w1MyHcLWrN6SGtWZEqLQzKxNdv9fx	5670	3NLSp8M71A8MsD42tqawBbYn9xGzaqWQFXYgtGtxf1bGbih7Dst9	1407	1395	52	1	5527	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2727	4150	4150	1616686200000
5706	3NL94DcqqerrTd4PSB1BYemMkJoob6tUTWweJjUo3mK7PkCmx4yo	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1426	998	56	1	5530	jxn5RZMr3ygKuvQen6dCJPydFJ2bx73CXHo5TktRcXpEf6UzRTt	2960	4154	4154	1616686920000
5711	3NLNPXUhKm55jFSMZR23Vm4tvx95bH1t4XWj1wUxD4gnSLd5cTty	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1490	1028	56	1	5535	jwJ2T5u5zhoBmrBjCTaxsksHb19vsY5aKw4FYZykvzPzcaii4GM	2962	4157	4157	1616687460000
5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	5711	3NLNPXUhKm55jFSMZR23Vm4tvx95bH1t4XWj1wUxD4gnSLd5cTty	1673	1368	56	1	5539	jwxQz1AMbbhFHifXWwhecw11JrzrCCxSMLkHbr8iJrCk1oW7gym	2963	4158	4158	1616687640000
5718	3NKiFcKZRWFuG3LuiQSgCXApiSLHuBfwbtKLQPX2YAB5zE5751yr	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	1528	692	56	1	5542	jxgcMAqUfVjuATyJ4TL76NZoyFkfHKx8uXSjdVyGNDbSzaZMXRe	2964	4160	4160	1616688000000
5723	3NKozSx5jZNHVw71TVtE2yJAuzi51Honud2mQUR2uJ9DQ8h9P5Xa	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	1501	994	56	1	5547	jx4ZyaYU8whTsqEoUZL1Nr3exK8hSfDaUr44YzHAtesb4MfTdaR	2966	4163	4163	1616688540000
5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	1675	1096	56	1	5551	jwBqwo7zCD9syaax5MSmP8auZytuZanL23Zcx9EWLwZVyx2Gu7E	2967	4165	4165	1616688900000
5745	3NKEn9K5PYTxKGdFB9DQ8sQciA6FxK6wxVBg7HPFpPRBhM4FDxLH	5744	3NKGvuQTkxGDLJqNVCrapq1VZh9T7Ersvgm2zVzYz8qFUUy4L7cG	1671	1239	56	1	5569	jwFUtGGpG4wXXYyGnAK8k3NmNyHV8mN3dVUzaC9rrGoLPi2yz8U	2977	4182	4182	1616691960000
5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	1587	1111	56	1	5572	jx7hRKPB3aQidWfvJSViM68zrXaXHD1Q3hBvT1kYZNXgbUTDBPP	2980	4185	4185	1616692500000
5750	3NLY4qa9ByX5JSgsQPanoG3sWDBJaTJNWQQpj2YiGbiDS8QXHiBD	5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	80	1027	56	1	5574	jxWx1T8kG4RZFnfRXckg7twMZCASVJoAyfuHKwHT5cV9JJ174Dm	2981	4186	4186	1616692680000
5753	3NLmbi2aVePxcEDpP4K9NCk9k3ejrbwuHYBoab4d1rPU2Fei7G5s	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1406	1393	56	1	5577	jxj1RVXB4KHUHYa7qppm7xT7nD9SxGATo3av7fpVcJ6WrtmKPED	2983	4190	4190	1616693400000
5758	3NLGsGUtZPtjmYf5XtKrJ1bwuoV5Trqim7Apv9YGiH75DeYX7h84	5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	1439	1279	56	1	5582	jxBYgCJJeyzqjpY2NH7KQHHxQUoeqZC2Gf8bhYPchh6KQ9rqzah	2985	4192	4192	1616693760000
5726	3NL8Q4uZEJEJKCZYokmHrKKkbSbsCEMVyC9sqpMytnSdVJNaC81r	5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	1546	1093	56	1	5550	jxu1Y7JPpj68CAVKEziqJNV5TryFmW4CYhk7cc8Qf7T888umyNL	2967	4165	4165	1616688900000
5729	3NLXCnmjBEJBENuSR2zCSWni174ijHuAXaqv1BFNsptaYbK6haKF	5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	1402	868	56	1	5553	jxYwWFaF3yidsob82PDnr6DegWN2iWkzaosAoQFLQkQz9Q3BRFe	2968	4167	4167	1616689260000
5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	1403	824	56	1	5555	jwvd5PKUnc3fnu85pxyiBSyP3bwNFHU9qyGRev22qXW3f4zV2Ek	2970	4170	4170	1616689800000
5734	3NLYzxBjzqztZEQdRNantYw63V5e4umoZLa7A4nbK2DtCEjqGesj	5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	1403	812	56	1	5558	jxZiLQCETkFjsriM6gNzR8BGYmr397N4tms6Zfg7UFvUGBpKzpE	2971	4173	4173	1616690340000
5739	3NLGiyox4UZy6PzJntCWLLz3T8WS8UWHD95NshH2SMQYrAP7CHpV	5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	1637	816	56	1	5563	jxwEZxJipv2d1vBWw2CsHQbtd6P7SMJExCLhQyvYZbDdVnoWCEm	2974	4178	4178	1616691240000
5742	3NL4G4G5sYB2TYXeMBF7SMpKNgpe6FMekXU4ubs29Zao6wbwdDhQ	5739	3NLGiyox4UZy6PzJntCWLLz3T8WS8UWHD95NshH2SMQYrAP7CHpV	1670	1156	56	1	5566	jx698vnSDmjz5nGWre3cZmiiss8ZQARvbW1RP2wMp5PpvShfnVG	2975	4179	4179	1616691420000
5744	3NKGvuQTkxGDLJqNVCrapq1VZh9T7Ersvgm2zVzYz8qFUUy4L7cG	5741	3NLseHynzg4givDNtwKoBsw92T7upPgJGqrY5qNwf5ars55ffrJP	448	1305	56	1	5568	jx2PkkwEetVrYqNwzRN9jRnjbrbhYws17aNqPSUgUEfwb3ov8iw	2976	4181	4181	1616691780000
5759	3NLFLD34FDDpE4EqENCmdkRsC4PSiwiLfKtEvtGRFGZSCHpHv1wa	5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	1671	1119	56	1	5583	jx364vqfozmvy6bg2PG5EtMYPXndFQ4BwiD6EGjopx4XE8RS9QF	2986	4194	4194	1616694120000
5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	5761	3NKMVeFdHaojYpKxBhHrp87sJdUZyYQuYJjDuJpMPorkjByWLVMZ	1516	928	56	1	5586	jwTpYpgnZKfoNrkta3CJZqHc1ujMdQdzRWEALkYYcihevBawAhv	2988	4197	4197	1616694660000
5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	5765	3NLTx83UNE3zYKATnqCt4HMPFhWDo2SNsvs9A2pVqradwvsNEjpa	1560	1165	56	1	5590	jwsWGHvZxv6SYxUbegRKa3GJccrrBrW2DJmeGQLtEccRrhtxuzS	2991	4205	4205	1616696100000
5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	1624	1088	56	1	5592	jwNZQDb7KFDsbaB14yyZ3mCWTyUP71E9VPdREbJaNR71YKEBeKs	2992	4206	4206	1616696280000
5771	3NKzMGUSK6WQiEW9Nq2BgePhiyasvaDco2ZtCt4jtxovpzgMFRyN	5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	1481	790	56	1	5595	jwUso5khDrSityvKCC8BPf2s2jkxKmi6FC3NjdbrbxpuNZx4EEz	2993	4207	4207	1616696460000
5779	3NKNcxRPf7UGiz4L5EEKPiziDB67ihXhi89i9ESLrAP9RRZGt2nC	5778	3NLsmMKXfF3AoETrSXMH2tJH5HKTVwzHPmspVU8CcDTfavSm5vLA	596	940	57	1	5603	jwxEP7Uu4rnPvXyDHGftYxCG4RhDLnm52JtK2eZrvYSQ89LLQ7M	2998	4218	4218	1616698440000
5783	3NKuPkfChCFMPwfBVGAANaeNYvX2TyLEVbrqvJ6orwa62fMmPNCa	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	532	1303	56	1	5607	jxv7ThP17Sf6NUTXeJqjrgc2V1dwWAbYFHiiAEf2ecvrmL5BZ2z	2945	4225	4225	1616699700000
5785	3NLLHeJcBkcwfNRU99oM1hfrZWDXjCGFzqm621ATkESBc8SWWjQ6	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1405	873	57	1	5609	jxtuCuQBR61fK7YrRHVTJz1JJpPuEFAZ6ftEHkLiPojsEG1E1RM	3003	4226	4226	1616699880000
5790	3NLePbCmFQSJTH8EoC7aFpEP9i1U3Ph6YEzZo12bwnTTZHL3jbzS	5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	1622	1356	57	1	5614	jwNDaaWvYN7MqPyLDqUHCx2CT218VZHUa7sgDDQdow1HneQiXvE	3004	4227	4227	1616700060000
5795	3NKBhuzj35KHHvo6XR7Q8rmcAPuzuExwfALc94uMqSV659JZGnng	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1651	1175	57	1	5619	jwkqf9PmoEBcBUJebp7zruEtAFYwUfijRvvoFNBYsuT3HCApYrU	3006	4230	4230	1616700600000
5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	5794	3NKRjQ6DEqcrJbCBm7VR5kV16QYBdDoHAVEMZAWFcbtYvQ868JKw	1588	1392	57	1	5620	jxscUW3FuiknkrVk48RsqkkYJqUccLKiHUChfxdUu3W8t27hJBj	3007	4231	4231	1616700780000
5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	5799	3NKL1gbCkiP74uk3WTg4uZoZNNc7PUuux8w9tveSxhQMzpD2geFz	1506	1247	57	1	5623	jwhNLTnaYLAEbL2JsNZW2ZzcrDBZg5n5szW2HfgJvqwNWfZJV4X	3009	4235	4235	1616701500000
5805	3NL4n1h9cuhzVK5Sjr9NuqTTzsYQgR26JiLShALHzMsvD8r2VaVV	5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	1445	1164	57	1	5628	jxjEN56DaBsgSKrzFK5vQuFPCudpEQboVUfEK1y3ZDh9BZFM3DY	3012	4239	4239	1616702220000
5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	5805	3NL4n1h9cuhzVK5Sjr9NuqTTzsYQgR26JiLShALHzMsvD8r2VaVV	1483	1276	57	1	5630	jxkoVWGTuZx96WHobQHzVyRP4QgUuxE12sh1xvwz2DF8oR9vsrG	3013	4240	4240	1616702400000
5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	5814	3NKcxtvSRCFnxaKYxHZZLvAs1HvSRobPYMV9Tnfkv8VGEJo8Buhp	1405	851	57	1	5638	jwLf6bZKbFQ5iqGcFDEbAbPDcnCV1uMqSahaXiqJSSYPW94eSks	3018	4247	4247	1616703660000
5820	3NKBz5sq7Chz5fsqDL3PbhHxZ15Jp6JRToNsWZUp46rPEbUbFiLA	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1546	1213	57	1	5643	jy3AngZzT3H3JPAgHUtZpJZ2ofiUZFbhseZuVWbbXdTNkkxZP1i	3021	4251	4251	1616704380000
5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1522	1322	57	1	5647	jwUtn9ncCL6hARcnNhxh6LwcFiccYP5rMNLF6Yr4iWY2qFY3KLT	3022	4252	4252	1616704560000
5829	3NKDaAijpAQEraNQBHrXVaJR37t5Hc5Ad9NaHHNDkvEsm7kAZBpH	5828	3NK9xoe3vEZuBYZskJ9ErLEitE3qk8yk3o35WW7Fjo7MjVNPaS2x	1406	1393	57	1	5650	jwkwomh8Vjpue6UecKEQ87iryMz8zxTBijHQSwfGiahLHXChS1i	3024	4255	4255	1616705100000
5832	3NLY2iZSAfK8dJHMT83oVWXMGqR1HKfZkUY62ugNpHtHj76CUaug	5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	1457	1025	57	1	5653	jwWupMnsEFobY6MMWT5wAgrjabr2vXaZxVmCNRa43MYx2Fyohuh	3026	4257	4257	1616705460000
5834	3NLbKYpnUmZSrcm8ANaG2AxQ4StuJgz5yLpWhbbuNfYSb66FKaWy	5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	596	1306	57	1	5655	jwoAoab1r3sVhJint1qyGPMUE5vmMUeGqbKVxS3HyTZMEXfupYN	3028	4259	4259	1616705820000
5837	3NKKeU5kRXxYiFDjnbAbhEHjDPqzsYZnDyZ1aCZazBXRC3bRgC9U	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jw7CEhvTpKiEyx1EwbF6BSQNCc9F2AjTUjFvcnouTiurca5vsUR	3029	4261	4261	1616706180000
5846	3NLPu6bQhJU77duc1PQpWcGG8hhANKKkn1U6NNP9oNU7uxmh6SLN	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1536	1187	58	1	5665	jxU5PVop18LxaikyA78JxZGvJReSVGwbZqzxrstihCrkXQh27e3	3033	4267	4267	1616707260000
5851	3NLPoSuq3qk37a8KM8Sj9dnU16MKQ4VYx6bxQAbaZDvX5DBEHsfA	5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	1402	810	58	1	5670	jx5G1Rci9fUKSEmXMQwYp4VS2HUrQy51ZQJxpSwbExbhRSYSwSN	3035	4269	4269	1616707620000
5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	5852	3NLf7YJoxYJsLuq67X9P9gUbeTCsPTXHeCJZAM1v3zteHVve49zD	1637	816	58	1	5672	jx6AKUn1o9xQEmyxRfQWVG2diuksQZG3VAaVQFaXb93jxmbfrps	3037	4272	4272	1616708160000
5856	3NKo2irPCiob6Xq4FGZj5gQjogTQ7ek96Niygd54C4WKMNcZzbi3	5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	1407	1395	54	1	5675	jxPVak58f3jjEQJmhWsc7prJbY4QSpA3SUvWe5gNHQtecavKWYk	2810	4275	4275	1616708700000
5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	5728	3NKFUY9SuMGbykqLrdYQX4uMV1hFnAiQXNbHv4pbX9F8xb3QbQrM	1509	1074	56	1	5554	jwVLfE5RsJG16MF3M91qunsY7FcZ9dQQHHTDtagP28mGPqWHx6p	2969	4168	4168	1616689440000
5733	3NLw61fg4tzn4i3UqcMuhBYVijediS3dnnBkmJHCA83QrKHyTo8n	5721	3NLafBqsf63d1SvjuTftGBcutY8BZq9V9YG6oCa7fH4NwPxKpMk8	1407	1395	52	1	5557	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2729	4171	4171	1616689980000
5736	3NL4EjL21Z3adAqg5G1wMn5yYfZwxWWmhHMUvJSt6AWhDbqLE8Ye	5734	3NLYzxBjzqztZEQdRNantYw63V5e4umoZLa7A4nbK2DtCEjqGesj	1617	1042	56	1	5560	jwgop3PXhEbaRafnS1QknzEb2pz8pAAUHTT8kYnWbafnsaAEiTS	2972	4174	4174	1616690520000
5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	5736	3NL4EjL21Z3adAqg5G1wMn5yYfZwxWWmhHMUvJSt6AWhDbqLE8Ye	1464	591	56	1	5562	jxDhFqppEkCi6mE6JM846d9poiDBG771LutbsGaZuBPFbXLUJsX	2973	4176	4176	1616690880000
5741	3NLseHynzg4givDNtwKoBsw92T7upPgJGqrY5qNwf5ars55ffrJP	5740	3NL4oYPDn6UkdZGpMe6ADyaB9iTCepDEzbLPc1s7A8obkN8ReQMz	1670	1156	56	1	5565	jwCsszgMB89WfknYYXkoJXE3ZUXKYqyCffDUzGcdGRbDhZLya9F	2975	4179	4179	1616691420000
5743	3NKQ3HETibhLzpvWiHWrLozKQAyKmKKPcXECgun35AyELYcnSHCE	5737	3NKayafyVEocn4z1xZQPfFuN77qxeeDab1vpEK1mk572MSvU2849	1407	1395	52	1	5567	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2731	4180	4180	1616691600000
5746	3NKxj3aHNT2Eos78KLMDVx7RPxpgNcdi6xTUpgLkSLZPjhFs7s5Q	5745	3NKEn9K5PYTxKGdFB9DQ8sQciA6FxK6wxVBg7HPFpPRBhM4FDxLH	1398	435	56	1	5570	jworP9ReknYVdMHoM5hphxg1i2YzhbbB4KQXfDJRyS3yKThXutS	2978	4183	4183	1616692140000
5749	3NL3HAPuaa1QnWSvBePrbDTNn8ECJFpSjZcAFdJ8LBVmt5JNKSnK	5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	1623	830	56	1	5573	jwvmEQoT1vxatzDiva4Gnk9XioXMoYwnHnE2waiadAtdZgXeWj7	2980	4185	4185	1616692500000
5751	3NLuz8jZh9btjqyG9sXi5Akz1qfkD5an74ZmpAeDgdQQZRrD9CLy	5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	1670	1036	56	1	5575	jx1a4vWEv54K5pQf7xUCvwZi2M4nK6de6JgHtFcuUwvzbgmCaso	2981	4186	4186	1616692680000
5754	3NLpQoJjSrTzktuEyT2qeigCHUhGQqQeV5qgHfgqt3TS9RjJpRo3	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1631	794	56	1	5578	jxVTF1y6NjBAQv8WVUaDdohrrw5yAkG1AYSTLoBE2FsDBy8Y59c	2983	4190	4190	1616693400000
5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	5754	3NLpQoJjSrTzktuEyT2qeigCHUhGQqQeV5qgHfgqt3TS9RjJpRo3	1507	345	56	1	5580	jxFunY3byfsWEXnA4HJTcgsAb64urbyD25m2yW53HgaS7A6EopK	2984	4191	4191	1616693580000
5761	3NKMVeFdHaojYpKxBhHrp87sJdUZyYQuYJjDuJpMPorkjByWLVMZ	5759	3NLFLD34FDDpE4EqENCmdkRsC4PSiwiLfKtEvtGRFGZSCHpHv1wa	1553	776	56	1	5585	jxpmtg1Szt42yUkyBPxBgoSh5WLjkDb9LBbbmVa8MzbGCp5ujgw	2987	4195	4195	1616694300000
5765	3NLTx83UNE3zYKATnqCt4HMPFhWDo2SNsvs9A2pVqradwvsNEjpa	5764	3NKs5TksyX1eSQQ5uiqptXT3fd6kTsQLDfrmU5koPmn4HfWW9ixq	1593	1220	56	1	5589	jwENdC8bgk543XTBPK4wS38cEigJz4Z7vXbyxkX76QBvsWZvpMv	2990	4203	4203	1616695740000
5770	3NLRzW7Cu2eAAmZC3dHcrQZ1aMie26UZDA5Naai1hGkFyi7L6Hgc	5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	1403	823	56	1	5594	jwb9v1oG4act3KHhPQM7GYEe7suhGnEcDmJ9bsFuF7sQ8ygw4qG	2993	4207	4207	1616696460000
5772	3NLBR6DRL9pDcE7MgsRoBrxxnoHTMqYHDVi7H7Hs63PwNgAtFXnX	5755	3NKMxWo145vyGSTjMSZTBBasBtHtZD8p3fjywnJQXM9vV7NgZyhW	1407	1395	52	1	5596	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2733	4208	4208	1616696640000
5775	3NK7jxauQjFMY5UKUTJ212jfQK73WprBozPRubKQUMHT1gF1u9VC	5774	3NKxVcd8DixEjjmuBb2k5xW5RTSMwhNSpRJNJ7KcKL7RW7jAVY2t	1619	1029	57	1	5599	jxEKwNPvCyq29Ny6aVXgvgeCpGVBR379cojBjX7999fZ6xKcWXH	2995	4211	4211	1616697180000
5782	3NLDwWvRszZVWdzpKwbgYogu4dpeHEfez8nXLorogGmvxTmuU5h6	5781	3NLK9CQUuZEkb8YTjE4fr5Mn513TpumRaogY5xcShiWGSKD1nvX6	1483	103	57	1	5606	jwoZwhbNm94HqLMta2R8HpvicMefqRDd37t7HyJc8F8uEM4wxW4	3001	4223	4223	1616699340000
5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1402	892	57	1	5612	jxGnzD6KMWXzCxDf3YaarHp3MTBtmSsFQZB7gbBAeybaN1UG4Dx	3003	4226	4226	1616699880000
5792	3NLo3PZUFtAj2vBN2LhUAsEaiyXQorxT5Tea61kC8uh8ZoMf7ef7	5776	3NKXDgUBbesUevaebiMhngiTQBCWS5qx9fKYDzX7dgDHorXRctRC	1419	814	54	1	5616	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2819	4227	4227	1616700060000
5794	3NKRjQ6DEqcrJbCBm7VR5kV16QYBdDoHAVEMZAWFcbtYvQ868JKw	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1581	778	57	1	5618	jxiEjuAZZEgofsDT1N3EP91xNoNaYjUYtqjiG1GMLkhbbSpxb8b	3006	4230	4230	1616700600000
5802	3NK56QtPUiFSh1fnET8REVmEBdn9nDxMADRJwtTcQ1NuRWxQMQaD	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1657	1098	57	1	5625	jxpmEgifjmb2CFyeAk25q7w7brCHAcVn744AFKkC9QXwq3zFE8k	3010	4236	4236	1616701680000
5810	3NKqAJ76eLafgSV49G7UwmQjcYyYnwEBYHUabUiua4swe3SWoivv	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	1593	1346	57	1	5633	jwSEvzZnugoKMZjBG2zVKwNedkpJnzFikfKX4Qr7MhmGhRM119y	3014	4241	4241	1616702580000
5812	3NK8x2GJASg4kMo1t1GCiZ1VxgJheksTeMyFZteiyVx6oanQPg1C	5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	470	1309	57	1	5635	jxipqYVH8HMhnDsDVEudVJJquNpbPJrJqtM6pm9eqgpqCtnD9kb	3015	4243	4243	1616702940000
5814	3NKcxtvSRCFnxaKYxHZZLvAs1HvSRobPYMV9Tnfkv8VGEJo8Buhp	5813	3NLvHtp1omFjsVyKTUChGMtSFfWDt6yeqAayzMbpTG9h3W1qmihG	1477	1350	57	1	5637	jw6pNtz5nMtjahZRssNDi3u2cxFKMN9TGMMnEcCg3MvsrQiDQ9Q	3017	4245	4245	1616703300000
5819	3NL2QwGmqCWNVxMepua4tknwNjmsuFbxeZMomXH9oeovRhdkNZwr	5806	3NKbBiQ7q5pzpj5MnFE6hPVfNn45DDnFWUWf7kuwGUKr3rL9JGT7	1419	814	54	1	5642	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2822	4250	4250	1616704200000
5824	3NLDS7DWCusXj9yyocVsfeTXkcKnLAuwXM8P1mSBqZf46qHyLQzv	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jx8Ko4HKawSz6vP7YT8vaotxarhq5ChUkVdtJqTxCLQwgaHD2dp	3022	4252	4252	1616704560000
5826	3NLVtpT6CHU5vKkPN4Qi5V4SNW6M2TPSPVq595KRShFSJkPf6bX7	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jy1vcrnDhR4fbhVPPCu7AVMyYe8nai3CvSDvhZ8Serk8CtXB2zD	3022	4252	4252	1616704560000
5831	3NKWP6GUHRwD525NiviAoSJWvo2xUiNvPR3FVFPUDHHeYahTE9Dv	5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	1451	1046	57	1	5652	jwU1Acw7SCgzv2bRMRXyeySryzhgefGusaVt8gHTJgbz1bHZnx6	3026	4257	4257	1616705460000
5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	5831	3NKWP6GUHRwD525NiviAoSJWvo2xUiNvPR3FVFPUDHHeYahTE9Dv	1406	1393	57	1	5654	jwmnCUccHyn5fYazAR1kSK2gGCKVfynxJpokJRReuH85gRQy3FA	3027	4258	4258	1616705640000
5836	3NKiAnUVFFGdFRUv1r7vdWZgAM4rQTq8epCzDWTEj56UiPJSJxHU	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1403	31	57	1	5657	jwMo9Zh54viGGtthRLwjbaav1c5FfQiTMcsJV2EPTwx5oeMpD7f	3029	4261	4261	1616706180000
5850	3NLVp7PdDf9ubyBoBMMhgWz1TqzsRDijhD2HKYKiJvw5Ntziozwj	5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	1483	217	58	1	5669	jxxE9cxyN8Rgg9SSZSHeHBGS1hc9VwSwXj49uErmT9DnheepXzC	3035	4269	4269	1616707620000
5852	3NLf7YJoxYJsLuq67X9P9gUbeTCsPTXHeCJZAM1v3zteHVve49zD	5850	3NLVp7PdDf9ubyBoBMMhgWz1TqzsRDijhD2HKYKiJvw5Ntziozwj	1402	850	58	1	5671	jwJ8Zs27juE9f9DrtfDSZHQ3bQNdGpmZpX9fHkbUJukQ9qn4ofP	3036	4270	4270	1616707800000
5737	3NKayafyVEocn4z1xZQPfFuN77qxeeDab1vpEK1mk572MSvU2849	5733	3NLw61fg4tzn4i3UqcMuhBYVijediS3dnnBkmJHCA83QrKHyTo8n	1407	1395	52	1	5561	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2730	4175	4175	1616690700000
5740	3NL4oYPDn6UkdZGpMe6ADyaB9iTCepDEzbLPc1s7A8obkN8ReQMz	5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	1631	794	56	1	5564	jwoXwuxvB5FMZSVNDCmtGePg5RhsBkQam4U3TdmYMwn8pPJnZPv	2974	4178	4178	1616691240000
5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	5746	3NKxj3aHNT2Eos78KLMDVx7RPxpgNcdi6xTUpgLkSLZPjhFs7s5Q	1406	1393	56	1	5571	jxUvNd9F4NRXqHRw5t3UtSti4hAykTFXF3Uo4HyDCGy932xjwmG	2979	4184	4184	1616692320000
5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	5751	3NLuz8jZh9btjqyG9sXi5Akz1qfkD5an74ZmpAeDgdQQZRrD9CLy	1624	1088	56	1	5576	jxV1Y4Ca3z1eFgQKJ7qMFw8oL6Q28RzXmM3qT5qWMjrvr2cUBoK	2982	4187	4187	1616692860000
5755	3NKMxWo145vyGSTjMSZTBBasBtHtZD8p3fjywnJQXM9vV7NgZyhW	5743	3NKQ3HETibhLzpvWiHWrLozKQAyKmKKPcXECgun35AyELYcnSHCE	1407	1395	52	1	5579	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2732	4191	4191	1616693580000
5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	1406	1393	56	1	5581	jxWX4m8FSA1F58bHHBaXH57cbLppVx21JuSBjpszghZvUXZNUos	2985	4192	4192	1616693760000
5760	3NKvEqc12AdhwvGX3tiNJjqoziZWYshxu8u6PghLQHnQQvYcNCMq	5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	298	1182	56	1	5584	jxkvKLC9t1xtftMRjDrwkKGQSemgrLGpQpuAAZT82KqgPC65ryX	2986	4194	4194	1616694120000
5763	3NL9ehEDrpPdpKbV2WpTqdoZtWoWB2jevDrYQrutzP46UAeVg648	5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	1406	1393	56	1	5587	jxhPDLmYKnH9JHX2LeE4NFqG2NNQywEK4n7KtnHkWsXQ6MArhRM	2989	4200	4200	1616695200000
5767	3NLXFM5p5DeaMTg2xQttfXXUZWHorrk5LBTxKEVPZBPRW6FxiMT7	5725	3NKJ7yxUF368DihPkdUwqkk78N54j8eAxTUpkqTwoMrLcHXgquaJ	1419	813	54	1	5591	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2816	4205	4205	1616696100000
5769	3NLCwq9HZc3TTXZ98L7vy5wvNDmgiFiatcEL9HmPDqLUF4YerxVf	5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	1585	1366	56	1	5593	jxMYfhskexKK7YWn2ibWGx6YCjcbmq2TZ1oF9A1KjwHwJnyx8os	2992	4206	4206	1616696280000
5773	3NLjf3MAcvFZ4cMqnxe9fksZed336dHkBwtboFmDsK5aKhXb5fso	5767	3NLXFM5p5DeaMTg2xQttfXXUZWHorrk5LBTxKEVPZBPRW6FxiMT7	1419	814	54	1	5597	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2817	4208	4208	1616696640000
5776	3NKXDgUBbesUevaebiMhngiTQBCWS5qx9fKYDzX7dgDHorXRctRC	5773	3NLjf3MAcvFZ4cMqnxe9fksZed336dHkBwtboFmDsK5aKhXb5fso	1419	814	54	1	5600	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2818	4212	4212	1616697360000
5777	3NLErCCE1J7Rgww1EcvoMTdLhCrZcMfakt3iDQ29JUCNR6nDPNhi	5775	3NK7jxauQjFMY5UKUTJ212jfQK73WprBozPRubKQUMHT1gF1u9VC	623	623	57	1	5601	jxeUsw2bcQzupowH85SXbTR6HnqGEFuPfpfXHG7MisTgrcTX1pi	2996	4215	4215	1616697900000
5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	5779	3NKNcxRPf7UGiz4L5EEKPiziDB67ihXhi89i9ESLrAP9RRZGt2nC	1594	1080	57	1	5604	jxke3i6JrVcwUG48xYERDAoXdfJvnYPr8eiwMQaXgo3XRG56DN1	2999	4220	4220	1616698800000
5786	3NLtaLTJW2xj9bJrsKGyf2a5paHKjLQ4YHsR1GvUt8T6qE2zfGLU	5772	3NLBR6DRL9pDcE7MgsRoBrxxnoHTMqYHDVi7H7Hs63PwNgAtFXnX	1407	1395	52	1	5610	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2734	4226	4226	1616699880000
5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	5791	3NLni7PWFZXrMsY1NckFUVBYzXNhf5UZDpvTzNi1AK4tR6JdLzQD	1650	1375	57	1	5617	jwkczArng7oTRZACG1QbMsgg67amxSEA1rSa9kMNu9Ew2XSkMnE	3005	4228	4228	1616700240000
5796	3NLQqSMaHuTtt1U3T4A3wo8daPo6tpXiGwNRcTPTQDRkJuroptbD	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1651	1175	57	1	5619	jxaDfXpqbSL2FdZDKikg2ihM7f54ocL5ZvoMT3N9PGa72omU9Tw	3006	4230	4230	1616700600000
5798	3NKnYX4zx76oeJnChwZW7zujUnPC5a38LG2sSGePmD1Z88EKndcS	5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	298	1182	57	1	5621	jw6u259kChLveP2fum9g7xia5GdJrahaRVjUjPXVSq29rrSWaov	3008	4233	4233	1616701140000
5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	5802	3NK56QtPUiFSh1fnET8REVmEBdn9nDxMADRJwtTcQ1NuRWxQMQaD	43	1064	57	1	5626	jxsr2rChcCXUf7TxwFkfQpExRshph4rXJWk1Ck5gKj88aap4F8J	3011	4237	4237	1616701860000
5806	3NKbBiQ7q5pzpj5MnFE6hPVfNn45DDnFWUWf7kuwGUKr3rL9JGT7	5804	3NK6Km3JfBXp49YDGt7oGETASY3iQuPaWwXbjbZu86KZ8CzQhykg	1419	814	54	1	5629	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2821	4239	4239	1616702220000
5808	3NLxxqiR9qvyccKU6Sk1usTAuatTSxxYtukBT5G4VdAndsDD1gih	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	1642	1367	57	1	5631	jwbrSqM1vSkfos5zTyv9UxyeCsrzUBrDtgReWmZWFSek66e4M29	3014	4241	4241	1616702580000
5816	3NKAv6yp5q3NCLSAT9iU7f7vThNjJtnpjLaBHrcTgNMSm9gfzwMA	5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	1460	616	57	1	5639	jxwgq4JDhvuXMXe58iVEcKpnE9wVFaTJvtJVXNF7xtnsR6EEb5R	3019	4249	4249	1616704020000
5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	5817	3NKgKQWW2ZsGdRpcmgeTxmFiHTv1th5PgYaAFQtKpPEGZwbDK3yV	1634	1331	57	1	5641	jxAVQCtmyG5WjYQFKk9uVb6NSC4Kr3pYcH1pF1QFz6u5YCSv3qp	3020	4250	4250	1616704200000
5821	3NLfBAkhAM8pGbkpPuAi7WFmiFmoWxf6WZad7cPqa6ghY4mbztff	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1460	656	57	1	5644	jwLJotUjDYmjQPGnuQuGn5s4eokZaMCgwjjXRF5RxH3ty2pjcpf	3021	4251	4251	1616704380000
5827	3NKmFLcB6qcRBzrajizaQfaGJCqavFhvrLn39HYm4iU8ZakhrTJB	5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	1642	1121	57	1	5648	jwdwwWXHdoYqKAuRCuwbrHAKR7CD7jG67bPVDCmsEN9aGtiAWqd	3023	4253	4253	1616704740000
5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	606	1049	57	1	5656	jxjDu1WkbRjKcc6arhaxSg1FuKkgEvkbnxnDx2S88RZSiu2GNZa	3028	4259	4259	1616705820000
5838	3NLP32vYZmu4zEJ7r2YLcwJ9LuXwrnFvq78Ph7mDS7erJ7tE3u8c	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1406	1393	57	1	5659	jwgPV6se7aeVres1Sg4mLChivNE7NgZjmDRXs9PzBhKxM9NghBq	3029	4261	4261	1616706180000
5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	5838	3NLP32vYZmu4zEJ7r2YLcwJ9LuXwrnFvq78Ph7mDS7erJ7tE3u8c	1422	1091	58	1	5660	jxLKew4LFkXA6rKrESqJ68mpaujARXVh38CDYbNkGEuz1u9iw77	3030	4262	4262	1616706360000
5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	1649	1257	58	1	5661	jx6n1opiTcTLvvWTPFBL55nAS7ywF8xsEyWxDDb6x9rMs73HbGJ	3031	4265	4265	1616706900000
5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	1547	1132	58	1	5663	jxe9qwFBo5df9Dj5Ko89ybxDz8WkBAsTcN1pdTNK26PjnQxtymY	3032	4266	4266	1616707080000
5847	3NKRwRNGFLgee5CrZg7N5eTrvZbataKxDY82VYVX7otampKcnumi	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1555	1347	58	1	5666	jxhSo2fi7VZ7iqjpB5prwXjdFBoMumGk6ihj53g8yCuhghEPhnW	3033	4267	4267	1616707260000
5854	3NLH5cwF5RoPGSmwLx3kbRUoULverU2WRGZVSSWZv5QCT2KnzFWj	5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	298	1308	58	1	5673	jxPhGzFvECzvm2VFyZoSCnodzQs6xTizetKy3kpdBA4DVDKsbSz	3038	4273	4273	1616708340000
5764	3NKs5TksyX1eSQQ5uiqptXT3fd6kTsQLDfrmU5koPmn4HfWW9ixq	5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	1481	790	56	1	5588	jwjUaSdZzvBgWECyXuZj55DUpM7owtcyzpEujEwAa68FBm1Zhcb	2989	4200	4200	1616695200000
5774	3NKxVcd8DixEjjmuBb2k5xW5RTSMwhNSpRJNJ7KcKL7RW7jAVY2t	5771	3NKzMGUSK6WQiEW9Nq2BgePhiyasvaDco2ZtCt4jtxovpzgMFRyN	1637	816	57	1	5598	jxso1KNg9mE3eu36BxwvpnxygrJ4foSPw4APmV4Gyz4kprgpXu7	2994	4209	4209	1616696820000
5778	3NLsmMKXfF3AoETrSXMH2tJH5HKTVwzHPmspVU8CcDTfavSm5vLA	5777	3NLErCCE1J7Rgww1EcvoMTdLhCrZcMfakt3iDQ29JUCNR6nDPNhi	1403	780	57	1	5602	jxjUJ8bkk8yYsGsqk5rDqnBoGR2XvmPnNzXx7zfaVgXGB9cZATZ	2997	4217	4217	1616698260000
5781	3NLK9CQUuZEkb8YTjE4fr5Mn513TpumRaogY5xcShiWGSKD1nvX6	5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	1610	1314	57	1	5605	jwXRiPbrMTuEDAhJ7u2E1ZNpyH1ejJp59e76piif7Ksq5YpHWLj	3000	4221	4221	1616698980000
5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	5782	3NLDwWvRszZVWdzpKwbgYogu4dpeHEfez8nXLorogGmvxTmuU5h6	532	1303	57	1	5608	jxMsHGt3B4T76eGVKh5sTwEEwGpTF8CZHPKkABpMNtvC7gyiGSd	3002	4225	4225	1616699700000
5787	3NL2QU9nHxkFeJ2onbDceqgMPMfkf1Ywe2N1emWEwtNNLhR8caZR	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1403	824	57	1	5611	jxr9wvhGU8QqqxsqVBBj5khwfZQHbebJKQsgcrDUpzzZ2F9txnw	3003	4226	4226	1616699880000
5789	3NKAMvE7RZvT96HgiAmqjUwoFx6bRaztDyTo2sNbc2xDnaEiecHv	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1553	775	57	1	5613	jwhkUE36P4Es6XwS6uuS9ZWcZviP4LfCa9jgJVok7Y9h2La8qzb	3003	4226	4226	1616699880000
5791	3NLni7PWFZXrMsY1NckFUVBYzXNhf5UZDpvTzNi1AK4tR6JdLzQD	5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	1507	1280	57	1	5615	jw9vY7B6LSKqiV9NRiMMwgMvQDEZR5vSXSCW8XbzFArjVwKYq68	3004	4227	4227	1616700060000
5799	3NKL1gbCkiP74uk3WTg4uZoZNNc7PUuux8w9tveSxhQMzpD2geFz	5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	1406	1393	57	1	5622	jwbh2eS1LKU3Dj4qTZKSiPo5hfYijqprLjHfUbTZa1biTUA3do4	3008	4233	4233	1616701140000
5801	3NKJgvNxejf6VAxkjcB9kptveLRBSMYtiW1A6S3yo8ritFJaiC5d	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1403	824	57	1	5624	jxuY8ySspfdjEB4uySqnZJEXPttuEJkfB39CQyWaJaEvoAeDpP2	3010	4236	4236	1616701680000
5804	3NK6Km3JfBXp49YDGt7oGETASY3iQuPaWwXbjbZu86KZ8CzQhykg	5792	3NLo3PZUFtAj2vBN2LhUAsEaiyXQorxT5Tea61kC8uh8ZoMf7ef7	1419	813	54	1	5627	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2820	4237	4237	1616701860000
5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	298	1062	57	1	5632	jxjc2mkSuoW19XEAGkT55vbUCRcBpDwZRvcWMjgBVNbVciFX8go	3014	4241	4241	1616702580000
5811	3NKHdTkv41VrnJy7EddFrZThnWuRgx19hRF5UsujpYY1vZzcUXUj	5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	1406	1393	57	1	5634	jx3WWK7vk4w1j661QrgFdrP9seytGgfwfPdtufovk23uNC5bJA7	3015	4243	4243	1616702940000
5813	3NLvHtp1omFjsVyKTUChGMtSFfWDt6yeqAayzMbpTG9h3W1qmihG	5812	3NK8x2GJASg4kMo1t1GCiZ1VxgJheksTeMyFZteiyVx6oanQPg1C	1503	1151	57	1	5636	jwJQ6EMD1WBmeGpjksPjgWH2ZdQK5TtTXjGRC9cpHkoeAVxiXrq	3016	4244	4244	1616703120000
5817	3NKgKQWW2ZsGdRpcmgeTxmFiHTv1th5PgYaAFQtKpPEGZwbDK3yV	5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	1501	1114	57	1	5640	jxJRpmYU65LMvbFXVAg3cT8LngqzXL4MXXaPZqbMEEqfC6K9xbk	3019	4249	4249	1616704020000
5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1423	234	57	1	5645	jxyySQ5KA9ZmrtAdouZFe8VF13B4jkTj2ewQhDRE4LH7AbjSkw1	3021	4251	4251	1616704380000
5823	3NKf7JM7nkaEzKmtrxGuKvBXiQj3BqHb4kgbcc52chzMjTi1x7nc	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jxEEoMo1Ji6S6BFPLVcxRJqAYjzsotQRr2zN3HEPX9t5kqUr484	3022	4252	4252	1616704560000
5828	3NK9xoe3vEZuBYZskJ9ErLEitE3qk8yk3o35WW7Fjo7MjVNPaS2x	5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	1656	1343	57	1	5649	jxhpaZUau2cRhfdoJvb9b3sgNjatc1prfSJk7xThLYDUC8kkDs4	3023	4253	4253	1616704740000
5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	5829	3NKDaAijpAQEraNQBHrXVaJR37t5Hc5Ad9NaHHNDkvEsm7kAZBpH	80	1027	57	1	5651	jxtvcRS362bYrMSVx6Bhv6o2u3q8eo2eXoQC2LsftQdrHxkjQhX	3025	4256	4256	1616705280000
5839	3NLTq9McW85so8kWR7m2iadmiqyQDXpG8KYvvvvYYnHf28eNXrEF	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jwPCtLMx3tnpGc3kKQanHPwScBxmraE29zwE7CZKHn5mPZN8nkA	3029	4261	4261	1616706180000
5840	3NKbLHmY5jtgtoWQo41umAg741KhRBssTUZsCNS4t17JgFPPnBEn	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jwPCtLMx3tnpGc3kKQanHPwScBxmraE29zwE7CZKHn5mPZN8nkA	3029	4261	4261	1616706180000
5843	3NKrHYJ4SeZvWeBTzB3US62vmKNQSDFj7T7wbG7YFVMPEEqNbDVS	5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	149	1283	58	1	5662	jwg4jsHrRcqrggNftYouGmCgD4mH5G6e5bJYJUj5Kck11Gd51nK	3031	4265	4265	1616706900000
5845	3NLdL9JTo5nPAXXjxdcH7Gfcm28ZFSeAiu7b5YEXRiNFv3Y2HFRH	5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	1403	824	58	1	5664	jwBFhayzNzBE9HyFPWN4qjM5jH6xjFZkkgKubnkM8YoJoDWwJoj	3032	4266	4266	1616707080000
5848	3NKacYD6LHuMXKd1GbogPPdoNK8HCGjq3DghEP3ua1D3NFHMELDy	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1633	1390	58	1	5667	jwbybwkHLM1t4uUpKNXnaF62q38W92m6i99mFEdAMLjfbcxLyRd	3033	4267	4267	1616707260000
5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	5847	3NKRwRNGFLgee5CrZg7N5eTrvZbataKxDY82VYVX7otampKcnumi	1571	1209	58	1	5668	jwn4GvC8xAgMbn2vzEWgi9FqNpDdJSzBYy4JAXVnfR9MtGNTES1	3034	4268	4268	1616707440000
5855	3NL7tBDHTKEejitT19e69waZwqQjUr4wPZCPnPqA4azn3tyaJYv6	5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	1403	824	58	1	5674	jx94CxaBK8hzZZzSYw345XcX1KJg7SZmFd8YACTtdgioaJbL4zh	3038	4273	4273	1616708340000
5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	5854	3NLH5cwF5RoPGSmwLx3kbRUoULverU2WRGZVSSWZv5QCT2KnzFWj	1406	1393	58	1	5676	jxP1yj42FUGenX2W6TdBdcS17ovALdCUKVm2TUEYC877WrZpFtD	3039	4275	4275	1616708700000
5859	3NKkcJY2ZxoXfuUDM9ag3zCZtzndMnYv9vGtXUXFJMcvZa3E464n	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1407	1395	55	1	5678	jxSJB9exrsWwpyKkGuoqwR5N3z5z19nXxnXVjxbjMdkL66sXbfq	2849	4275	4275	1616708766841
5861	3NL5AtamHbfXhKL4m3jBu7r5BV1YYzZfYt4cHB5iP5YrvxXxnTDc	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1407	1395	55	1	5680	jx8hbXaLXePSqEUQc4V3hzCgtGRnanezCwo3v8FpnS42RBVpuzo	2885	4275	4275	1616708830580
5864	3NLCEW8dUnDQNZUp1DqdybcVsD4UerN4pRfJBEm3SprSFoPj6Nou	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1406	1393	58	1	5683	jwz32cFw9NRoa6kSrvxt2bY7gDhw1mDMznJAGb5JBqC3uWVihdq	3040	4277	4277	1616709060000
5867	3NLM7fjaKZqbHiFcbfvTbgNi5EqHsLT8ghaQigd4FLmtSGuLdZ8T	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	532	1303	58	1	5686	jxSqNHP8jFaE4Awgmo51DYnqs3fjj9PL3WtVKsez9yD92jXuvSJ	3040	4277	4277	1616709060000
5868	3NL2EoCER1FQ7yGvZtZ7fD1RnAQ16bqZ59M9TccvXKEfGt1s9iPc	5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	1422	1211	58	1	5687	jwiYtq9HRHLMaRu38KVYy9Swnynqs7mMHcUip2KnUG4fpEYhWvY	3041	4280	4280	1616709600000
5858	3NLmG8G7FgQ69S7CM1SyHvrPUYMUtVdVbYGykSdsrcCebNWkZa3X	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1407	1395	55	1	5677	jw85SNWeLR2gvgTRkEX33EBLcJkcHTbeYbQFEjyMErK7d7yXJmf	2828	4275	4275	1616708734163
5862	3NL2C71gvaFwFRQa6nNdZcZqE9LXs3ZKmMQ7zXPhWppB7K8Qx9bc	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1407	1395	58	1	5681	jwFz1L7eTVxabvVtrr91Y8tGPQY8BuXTqj2xBaQ4UYzePK4Ss4p	3040	4277	4277	1616709060000
5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1501	1360	58	1	5684	jw7g3aa9GuZYC4smxsnr8zCp4Eg3NqkQmUcp3r5SNjurUxHhnk8	3040	4277	4277	1616709060000
5869	3NLXM3TfbntYMYpugBqGfM53kmdRMZHZUsASK6FgYmDMkiRWQtUj	5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	1560	388	58	1	5688	jxSWubbZgV1FAPSfgLKaAU6ggUfxcx9Cr9wF5xWDgNQKqixa6Vf	3041	4280	4280	1616709600000
5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	5871	3NLtErv9ttGYTqJXByEy9Wid3k8nfgZQtGfhDTkrxvKS1E6bFLyM	1609	1087	58	1	5691	jwQKxWtLWWr23kxWq1DE1WYQxSttVhcBjhkFFpXvB9oo2dBXjmE	3044	4285	4285	1616710500000
5880	3NKt7WGcRhMPYywF1hyWVgkzhsEoDptTkz9QYnfNyfsYuTci9Gna	5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	618	618	58	1	5699	jxzCCtKdAJNuEQeMMaZq2iqKcVQ79XdPF3kbFkU6GipFwQSaHtQ	3048	4291	4291	1616711580000
5882	3NLb7iDcek569ohPHdFN31661vagq369FmoUgZsiWWSFKtFHKfyb	5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	633	1138	58	1	5701	jxt4jAa94q6frtX3qzBXT2h7tZ5RdkbfZM7PaFoWr7WKeqe5QYw	3050	4293	4293	1616711940000
5896	3NL8hQ6qvHVC33H1P6RUVnQGxmG3cg7rgubjPhYF82Sc3gK5fypJ	5895	3NLWLvFBthg4Vah4SfD5oB6BCTka5ALG3Lp9S1e54JFafE3Gjrs5	1397	828	58	1	5714	jwMdkpxJ5YZfwSSFAP4hGJhUZGUvDSMVAeYtfmtDGLA5D3hF8R1	3056	4309	4309	1616714820000
5899	3NLYwLVXQTx6zA762KWS1QzNcpEsUq7wPPEmJNYwYnETnXJZ8wUi	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1513	1133	58	1	5717	jy1Vz3wtB69BsMZbxcxTqzto2PSfdy3hozBUpdg1RZbFzSrxYiV	3058	4311	4311	1616715180000
5906	3NLFLPa3tFBv4AZ5w5CeXjnyF6V7SSo5ymNUjeDXMzb36pHJMmgt	5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	1646	1108	57	1	5724	jxV1oF3P5hHA1XZAFUkk4xBCAWKSAjA4Y984ScLFFKmZCkkDLMm	3012	4314	4314	1616715720000
5910	3NL74WyKrrQb8t6cJGzU2a8XmE29GL6nMQw1XQzjm6HG9h1GYZxQ	5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	1634	1331	58	1	5728	jx5xcPxbAauH2fUcwCtU5KfnKiaW3XrLu1BfjSmp81F36wYFw6G	3064	4318	4318	1616716440000
5918	3NLCeEocBgMLUyyHBHGR4Bq5orFQuWTTVrXpedomFmiw7s2cDzTZ	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1611	1341	59	1	5736	jwc6x4VTyF6WaWerY2TzHAiLXxpBjdtkHZnSjVqDypZ4L2EGoup	3067	4323	4323	1616717340000
5922	3NL4JpizrAMq6mn8PkUU4DLJjLZGsta2Bp8SnzfM2nBkJKrLzJrw	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	576	1109	59	1	5740	jxAURUxZxbJs1jwVqtFTnHhZSqZVRkhoJqbSEWu5SNJ9Bn3xS26	3068	4324	4324	1616717520000
5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	5920	3NLj4K9nzbYbmm6qEd4jihFo27FQQh2h6BzZwqc9JE48kkYCTanA	1654	974	59	1	5742	jxbvAng6Xh167PEeSreRAavGNwhBXD1ci29qZUhJ2tpaJ8iJaRY	3069	4325	4325	1616717700000
5930	3NL8YrCcR6jUitqL5jfRo8KPJTZCzrbCrv2ZHmwDqPudyZwywa5n	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1448	1065	59	1	5748	jwvcZRNbYwXzokECscEX4cyE4gMtGYLroxs6WrsvyRwUV2ZzmXZ	3071	4328	4328	1616718240000
5933	3NKJFWBKmYSUf92uwMrMeqVsuQQ4T6wLm2e1iuNnbcnmLR9aPQer	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1451	1166	58	1	5751	jwSGGxfL7aKeXYz2PdXN6m3Zw5qZZ5KfCWUBxBDL8sPhWzTUUhe	3055	4331	4331	1616718780000
5937	3NLSpF7HzHKhn61C7miP6we4etLR2cWkbxbMB1qUwDPPKa7Pkwjs	5936	3NLhYY3V9wbfpMMEh4UCviPzTGyXqcd8uRxsnic6vRCe5v9jZSUS	1406	1393	59	1	5755	jwrSvHj2A4saz7uvtKBUYiSNcD5bUe8APxgnrNt7gVVjGG9XWSo	3075	4333	4333	1616719140000
5941	3NLuDtsZgndLRrs8VoaS2JVgQSTkJmUJCa6vs88okPyTvbnLKjRt	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1509	1320	59	1	5759	jwdupitUQQXQnYwYiJvxR1duqmWBi8qwTQXCea5YaZ8AsuwP2UG	3078	4338	4338	1616720040000
5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	5944	3NLN5ju3kpR4aBFvT7KejjEqHLWGB3AsojwjZkSS52YqNMp7ehKq	1483	894	59	1	5763	jxdcqQiMyP3g1UXdfSmHyT6eVtMWDxWhMAiTGkthDnFZ2HsnReM	3081	4342	4342	1616720760000
5948	3NK6habxNUijmNTKFCwUDpZwC7Wryxbc9f2CmbUT9bgvHTqTAmAA	5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	1589	920	59	1	5766	jwe7M9jadX5Tb6tUJ6oV9bdBCTyXEzkxqsjsMMmpXrTwFpvPKfu	3083	4345	4345	1616721300000
5950	3NLDqbvArSRp5Nt9tT3TLF2kKuG9VV492kbrkankArapdawsb35i	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	1607	982	59	1	5768	jxMLUoRn5gYEBDaiHSyCK9WNBGpxE4wVXrx9pHJ1t1VH6MFsXBz	3084	4346	4346	1616721480000
5952	3NLPtLHeAmRy5KSReNjcurCAEzNcWh8jw2MU9jaquJwYymMu2oTQ	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	1590	1054	59	1	5770	jwyCxsi5EBR5imG74RDnt5yyqqdtq2sN8M3jSsARkpVARN6rNnV	3084	4346	4346	1616721480000
5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	5954	3NK3F48Rg5pXQC6JjRcTuE2zuELD3K6hN2Aduq7pt7iczgzXA3Jr	1623	839	59	1	5773	jwshenG7yQYzXtjfaTJdHH2JTncxDTLnjkU3E6u7gC7RwySHqQm	3087	4350	4350	1616722200000
5958	3NLib11hVTmZ1FCy2zaiQwzpx527kAo5rF81ADUjpYZq7DUvbLjw	5956	3NKQDyDhco9Znyznt9V34r32nAKU9QVn2aQb96XSA7VSvHurB6aN	1573	1072	59	1	5776	jwpnHTAzGHznWKa6ca9gjtt6gwLby3wAKeekkXu5zTkUQU3sMQA	3089	4353	4353	1616722740000
5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	1670	1282	59	1	5779	jxjRt4As839429BhBZwBvD48XMuRJCwyMYZ9sW8yRkz632LXTGh	3092	4357	4357	1616723460000
5964	3NKzPfAHdo8tSmFnveT6FX4VSsrGgmtSbEvFJ3W7RbC4MFPMFLhc	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1609	1333	59	1	5782	jx4pTNyT7wpc6CgQz5V6QyrEBdUw6cFkFtAeVr2AL88su5FDz8J	3093	4358	4358	1616723640000
5971	3NLAJgRwMTnAoEpGxrb4yZHWgBUnyHT4ear5qvVg6giaghosw3bj	5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	1448	1065	59	1	5789	jxoj6VpxgUHkDRyJZ4rLvZ8PU9gp6xaqBDgu1efwrtVnnJJfLSq	3097	4365	4365	1616724900000
5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	5975	3NLkfkPwYeeYwu4k8fa74UYQZ8m1qTjCf6wc1wTsiHhUWt9Q8epk	1609	1333	59	1	5794	jwSF9HBaw9FJvN78Vv8NhXgStaRkbkEJcapSTKmtxHv7YuegUw8	3101	4369	4369	1616725620000
5978	3NLe3APFs7QQFFSWBeCky9f9Ygxsos8FmAAQkczmUvz8mMxNbvWJ	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	643	643	59	1	5796	jxcz2ugsijdeaFP1hYFmjh7xHLL3o5KhxgYzJvGykyvTPLVT4wq	3102	4370	4370	1616725800000
5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	5981	3NKMa1enWLUCQAuecFxpfdcgkQ8bhm5LMi8aNWzZY1LvF7RSyMdn	1578	1296	60	1	5799	jwZhS4WiMBWHo2SRCkozp1DF1WKucFsmtJjXXUjosGgwyW4zzKn	3104	4373	4373	1616726340000
5988	3NLeRHbQa6KyWAyST2fQge49NsvWavV6AJQrU2WsDcwtfyii3V57	5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	1585	1000	60	1	5804	jwYJ79HoiaabDuqDLKR7FECJvfCZGv9ez3HGKiTQse99pdRQL8S	3106	4376	4376	1616726880000
5990	3NKX1SWfQ5AaDT8cPNHkh2BjP98tj4SkoXiPsv2LwaQkFe5TrfaA	5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	1406	1393	60	1	5806	jw9Vba5SzJWthJprczv1kbLdrAAuDqfKZ1ZMJDJAe3zBbhdSNf1	3107	4377	4377	1616727060000
5860	3NLB2T1qSNX3neFWhZP6mtxmYvTb66ZgYteuuijkP2jeRiYSZysS	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1407	1395	55	1	5679	jwnjXcUNbPuWu1b1ks1V2Bd6ynrEaeDshJu3dYHDiNgcMdwe4bL	2867	4275	4275	1616708798173
5863	3NLiqe5aRDTwBoZAzjHKD5dPz9Qb2hLZnqx2VsNB7Zq6Lr6a8Tuy	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1553	776	58	1	5682	jx8yVkWpQNfrcfY3QF3iKyta26d9hmHqFU2rpP77BNfYBjzhMtK	3040	4277	4277	1616709060000
5873	3NK65DXMykeUvJ238pwdQEqZPuBs4wTFLJU8bX3ptHgnpYfyneX4	5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	1571	1209	58	1	5692	jwAcWyxNXWDJK3DvEgU2Zn9Nv5SeVXXRVUBi7kPuKLFUGueg3pZ	3045	4287	4287	1616710860000
5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	5874	3NKHrYRH982pVgZB3jUNpdqrZtm49HyaTmNriLSNFauFUgNMtQYE	1623	830	58	1	5694	jwSkxzPjBQ3iCsWYdMgTmdAiSu3h5g7LKeGUYa3PfNmXX9TgT5t	3046	4288	4288	1616711040000
5883	3NL1TtHsTHHjq3xaro1EVn2MwV4qY4QqEDYZq8Nj8onUqRdvVryN	5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	1407	1395	58	1	5702	jxRTmkjMPdujJ4Wa1hhZbdAcwocauvuHv53x86jjaHpJSpLaqs2	3050	4293	4293	1616711940000
5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1622	990	58	1	5704	jxwECAJP5WXDVwdMWwDQDBm2YLv3PrpHKWvFngBYPbTnY7wJKcr	3052	4296	4296	1616712480000
5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1627	1139	58	1	5710	jxq8RYFhVC3bwfccYyDu8HdYxvBM78hh1EicvU4cou2uUMKfMQc	3054	4303	4303	1616713740000
5895	3NLWLvFBthg4Vah4SfD5oB6BCTka5ALG3Lp9S1e54JFafE3Gjrs5	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1637	816	58	1	5713	jxqaHFf3xEF4adktTvpk8yXQPYUncmh3Se1fRGeTTpnaWNzsJE3	3055	4304	4304	1616713920000
5900	3NL2JU2yhwqRBibvqmEeyZcD6X57GRW53MJDe4yMYcFNzVkvMhgd	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1559	1353	58	1	5718	jxHiP2PSB919ByGqfx6oZHxKZi1uJoEKX771ZaaNaXFsuFRyvdF	3058	4311	4311	1616715180000
5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	5900	3NL2JU2yhwqRBibvqmEeyZcD6X57GRW53MJDe4yMYcFNzVkvMhgd	1637	816	58	1	5719	jwYKcTxn3WgQYj27tFwxb4iobhr2uUr3ZKTCcoQgnEApnSuKz9c	3059	4312	4312	1616715360000
5908	3NKY9nCYK99qjBxYnL2bXq2zjgU6MCT42sjr4HiYeeFw3pPSKxVp	5905	3NKt77k8ye1bFTTWkuDiaum3GEUh2Bv6Zf2zsMFPjWutj6ppP6ZG	1589	1160	58	1	5726	jxULQ4CbQK9sHxrgG2SY1NbHYA8RtgCbYRnswCgn2K1NVTzNBsh	3062	4316	4316	1616716080000
5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	596	1306	58	1	5729	jwbz2ZJEqUmsLtcFaPLTpo9RzFf16puhmiJpP4x4vTsSKJTrzJZ	3064	4318	4318	1616716440000
5915	3NLuohAeuvTbFrwknku46D6bNJ27qQsWWjQqGHVcc2fSjzMMN17o	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1445	1044	59	1	5733	jwMMJZjCPdB8zYkbGgqWCXuS5a8fGciapiqp7xkoxpJYTwn4Jc7	3067	4323	4323	1616717340000
5919	3NL4akQkVaJS8NKjRmHDgY9YrY9SfYiSNa4fAsTv3iiHf8r3yVoG	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	393	393	59	1	5737	jxSHeucsKPp8mYY4AjzMXkYL3u4wAqRN7gLJZ6AZi9TZHzKrCHW	3067	4323	4323	1616717340000
5923	3NLFXUYMYSUKNcWntRr5FZjnwt5W2zfeANPkktW7j6md6ULCPVF4	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1590	1174	59	1	5741	jxZjVCVNQLRDC6LRePwp6G9dRc4vvQUrUm9oQYZfc5Ap1bACidQ	3068	4324	4324	1616717520000
5935	3NL2APngextnQ3q6P1vPUGJehMfyYMFy6HurrphxBtEfThNXR1cE	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	1483	658	59	1	5753	jxAGY59SYtopujSxxPXTewvMKShz1JBLN4paqXYJFfNmVGSp5AU	3074	4332	4332	1616718960000
5938	3NKRitRWe2FnKCF2MUroZxhf9RF9TWtJW6C7F5qBvhvib87vUgUa	5937	3NLSpF7HzHKhn61C7miP6we4etLR2cWkbxbMB1qUwDPPKa7Pkwjs	1403	31	59	1	5756	jxg7PXTxSy7F4rZwXg6YS4LfnxM8MozJe5VBcNFpnWHJ3ThXftX	3076	4334	4334	1616719320000
5940	3NLxYDmLvTyofUHMFggqcFNEYpNmDZog8Dn97dMGPpmV15SMLWT5	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1546	1339	59	1	5758	jwcAoXnuxMYuZHnidVzHxTsUNp9tVEwVcc5XMS7orBjEiGgEsa6	3078	4338	4338	1616720040000
5943	3NLkj9eGXut38aMEn4sGvNVZ4qyYSNZQ9fZ3SXYWmJUAcpGpSiVd	5940	3NLxYDmLvTyofUHMFggqcFNEYpNmDZog8Dn97dMGPpmV15SMLWT5	1460	565	59	1	5761	jwtoma3iggbjmkZsuaxu38UP3BiG6zvatfrBkyy3QPZTseT1Wbw	3079	4339	4339	1616720220000
5946	3NLsUTdwhfaK5bpQQSpFVyaUiUjJg4bPoWRPm7wVTfsBQTy8GFZ3	5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	1647	1302	59	1	5764	jxUDhLdUSD9mfXeuaZpFDEQFDjnx5RG7G5d312CXSKkdkdJQdHD	3082	4344	4344	1616721120000
5951	3NL4NwK4cWvrfS8xa1D9GkBFG3ezXTiM4jHgEjJQLiqEoabbo1R8	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	448	1305	59	1	5769	jw9qt8KuaqDULkvn81Um7a3mmdNjS31GJgHDFvnHuNidUEWM9pu	3084	4346	4346	1616721480000
5953	3NLhVFVjFqrYP2tGojQnn8eYuyMCJUReoat4xX2jC8Ybv2MY9XTW	5950	3NLDqbvArSRp5Nt9tT3TLF2kKuG9VV492kbrkankArapdawsb35i	1637	816	59	1	5771	jxwSrrieNQV8q1hegU9KsyYskXVQzTSfwWDtANLvjoBH4naaKtr	3085	4347	4347	1616721660000
5956	3NKQDyDhco9Znyznt9V34r32nAKU9QVn2aQb96XSA7VSvHurB6aN	5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	1578	1296	59	1	5774	jwqnM7CbhtVQwQa4WTPdhXtVdoUdtY5DcCgF4SiXgdfraKskGei	3088	4351	4351	1616722380000
5959	3NKXzZowXt9wEPFkYCGk1QTS2WS5CuW2cTVwepm68N9q4wv5ZQPN	5958	3NLib11hVTmZ1FCy2zaiQwzpx527kAo5rF81ADUjpYZq7DUvbLjw	1407	1395	59	1	5777	jwp2scdZQh52Kyvn25SmMfGkMoUqkasEnS6kHoRcEkRLFtBSV1H	3090	4355	4355	1616723100000
5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	5962	3NLgB2Uyhn9cLzBHwsqeqHmddKr9Gg5kZySBNv8SVJzGHFGieps9	1560	1165	59	1	5784	jwZhxagfkepC14d7xQ9qb9WzmqTWdJ1XYk9GywVxf9oDSAT7nfk	3094	4359	4359	1616723820000
5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	5967	3NKuPQHqZWLH6JcTerrZyvBdcMDxZM4aAMht3D93KwcMimxZhxvA	1403	824	59	1	5787	jxnuxoTphtRYVcNuJUQ6GMvhFZr6qZabE8P5V5xvedJtUsTRJJP	3096	4363	4363	1616724540000
5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	1601	1142	59	1	5792	jwq9zXentLuvtB4zUJFzXkvfMzxBNA5p2WahirbJqkUrZzyYuH3	3099	4367	4367	1616725260000
5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	643	643	59	1	5796	jxcz2ugsijdeaFP1hYFmjh7xHLL3o5KhxgYzJvGykyvTPLVT4wq	3102	4370	4370	1616725800000
5981	3NKMa1enWLUCQAuecFxpfdcgkQ8bhm5LMi8aNWzZY1LvF7RSyMdn	5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	1439	1153	60	1	5798	jwtMH224dSjHejn1uoZSvmD136VsQGuhHB5CBwEs52t8G3WLcKq	3103	4372	4372	1616726160000
5984	3NKmLSZW7mquSoAx3MS8Q1biGNKcTHNJUiZJB9jG87nLEiMW2SwT	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1467	1250	60	1	5800	jxyFL2kMZkQp3s5ZSFsK4T1mnXqUQh4JaDABx8iohTLRtFCHMzC	3105	4375	4375	1616726700000
5986	3NLYmyYd9DZH95ebRnvmtqGeZeFgwqJq9eom5rr9vVWKizCKLsPX	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1617	922	60	1	5802	jwyCkCrwMxQpf8B9RWqf4kJtbLDamuxWXfUEJHZBuDoeYpTRn3p	3105	4375	4375	1616726700000
5994	3NKbit629GLbstPmgXy3Ccf9bbnwcudQEqhHJNm1w2NeoaeDQmPa	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1602	1123	60	1	5810	jxnTL5cQaZoursTNp4vg4u1H4qcNH2hcqXQnmctrSvweU18rWus	3110	4381	4381	1616727780000
5866	3NLV4n4u9NUJr8HCxnFSbMvtywZSaAzTJyNm7CeBimZeX65Di4ub	5783	3NKuPkfChCFMPwfBVGAANaeNYvX2TyLEVbrqvJ6orwa62fMmPNCa	532	1303	56	1	5685	jxy1Mmeic2bpBr24QAV4qVM2svDqNeteZD5C4KDNujmoDwUZ4QE	2946	4277	4277	1616709060000
5870	3NKDsRVh7gdFGBNLgG2H4LN4AnbNmYtx6QyBM1E7iHX44eMvLZF5	5869	3NLXM3TfbntYMYpugBqGfM53kmdRMZHZUsASK6FgYmDMkiRWQtUj	1467	1250	58	1	5689	jxUYbcnGAzPsWSpGkj5gy2vn1qMbfq4Ky3aqaSk4jg9SAgifAhC	3042	4282	4282	1616709960000
5874	3NKHrYRH982pVgZB3jUNpdqrZtm49HyaTmNriLSNFauFUgNMtQYE	5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	484	1193	58	1	5693	jx9mMyYziHqoAhF9WVu2X6yBn1D9RV1hQmaM9XLvFLaovfWqX2Y	3045	4287	4287	1616710860000
5876	3NLRwcHjQK75mTPMJ1FL4hNymVpVSYxVwqPYnfQZ4TzBS6Ktzyqh	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1407	1395	58	1	5695	jwvQZDq8TQYy8Egh6QoGwmhbZceiEwUnGsKr6pqA8Q1pUgFQKJj	3047	4289	4289	1616711220000
5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1506	1373	58	1	5697	jwSbVuT73GrBNJw4ccgXgSVe7acLDWZfEcMkJspYoGBcshvoBHj	3047	4289	4289	1616711220000
5886	3NLopjKmKtQL3BnK3F4nLfm1FGzS7FvbKvKXcgm1x5YdYjbnbhrm	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1403	823	58	1	5705	jxSbzBg2LWTXtUDic7dMXdnPGafHWEaWrk2heFa1qpcqcvgfFu6	3052	4296	4296	1616712480000
5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	1672	1285	58	1	5707	jxpDVJCvsNbG9uRnCRDeDeNe3cEY8WtnxgJ4yD7TPHr7gfxx2pi	3053	4297	4297	1616712660000
5892	3NLgmPc2o4Jk8gGGLUAtdpaZWPDmPt5uqVPkgeZs2AmS4ZNiqx3D	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1560	925	58	1	5709	jwVNwZq76henfFJTo2MpERtNvUyePMtxtAqsQXHGXtCxMaZt4Rf	3054	4303	4303	1616713740000
5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	5896	3NL8hQ6qvHVC33H1P6RUVnQGxmG3cg7rgubjPhYF82Sc3gK5fypJ	1447	1345	58	1	5715	jxgMKdi3Ry4vAn5tKm9QrBPf2wJhBndbHRk1BoGbJ4nZwtZ6ZwS	3057	4310	4310	1616715000000
5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	80	1273	58	1	5720	jxmBtn6iioCQG1Gebb8Mo32mJeQdsbL8h1wgbQSGYufUAU8xdNy	3060	4313	4313	1616715540000
5904	3NLq8eDk13qvKSQxwH6JaoVudVudLvrbJqMUSyHu7UnhGaX6KDwi	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1407	1395	58	1	5722	jxPMcyXtybi2v6jg6sMuo9WLprz7W2nn6qGKFA5MnDQJnv2a2Gw	3061	4314	4314	1616715720000
5907	3NKhge5CYUf6CD5TTFE4becD3JKe13cVkbZce1wi8bYyxNmxNXoL	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1493	614	58	1	5725	jwo2LxJAomCqbx2kk4B5jqKe7fFmjgAxkcqys1vhUJPi7VdY52c	3061	4314	4314	1616715720000
5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	5908	3NKY9nCYK99qjBxYnL2bXq2zjgU6MCT42sjr4HiYeeFw3pPSKxVp	1648	1284	58	1	5727	jx2rmASXMaWh1oYJCR2zLmmn7WEwQpJBr1mfSS2JiE9ZGjhtBqK	3063	4317	4317	1616716260000
5912	3NLHNmkjkNMZ8P9UrDht89mvcWqeSkoAKz6L3XpNhbRTMXdv1FPE	5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	1448	1311	58	1	5730	jwkqCNHBxWr94mihRKVthrc9DXhfBkYZG3XARyD5hbZzKpQXRPm	3065	4319	4319	1616716620000
5913	3NLnaw6r1Xyr6HAyDyfAWf9X2f5EkS3fUpJwgpk4Eky1d5fpfFYY	5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	1673	144	58	1	5731	jy2qDcvc6XtUWGeaYtQnY7pyAnwSFio7PjK8GgzcSxap12H21tJ	3065	4319	4319	1616716620000
5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	5913	3NLnaw6r1Xyr6HAyDyfAWf9X2f5EkS3fUpJwgpk4Eky1d5fpfFYY	1477	1104	59	1	5732	jwBTExQygjWJjVnLtBA4V23vJBrhdyG7S1GBzNbm4EcA3BAZcgf	3066	4320	4320	1616716800000
5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1601	1388	59	1	5734	jwQd42gMcCmrnSjghbMajbxUmDpYD3V8iHbkGNxkRSgHaManWny	3067	4323	4323	1616717340000
5920	3NLj4K9nzbYbmm6qEd4jihFo27FQQh2h6BzZwqc9JE48kkYCTanA	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1426	1364	59	1	5738	jwgruy5ZtdLHqtYKAqFV7ZwV1DGYLn4kwMgkGiVh9QssoNNMFXG	3068	4324	4324	1616717520000
5927	3NLgXJ1pVu4HWSCF2bfWHLgnwHXWF9yYQXyVxJF1Mh5vKYKpFkQd	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1581	778	59	1	5745	jxU9ZLGnaYtYJsYCUVYgYMJx7g4CsnsTncaZfTjD9FQ3mXdUa2x	3070	4326	4326	1616717880000
5928	3NLczX6M6JFiJM9XnRnsSEd8eQgMx73nDPNXbNpLMEqdpFDYTDD6	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1522	1322	59	1	5746	jxUq9Ckfjsw1Gv8MeVzK2njihUiUtg1dkbMGRvzhg5nkHQrFZmJ	3071	4328	4328	1616718240000
5931	3NKSKuWzVGrxKt9Udw45tt4mMcxy6y7r73Buhy4xheEaziw6t29S	5930	3NL8YrCcR6jUitqL5jfRo8KPJTZCzrbCrv2ZHmwDqPudyZwywa5n	1406	1393	59	1	5749	jwGhJUDZ1MJSUdx9hT7pV362w44q6NXMLVHnk24ijTnkbWtNrNo	3072	4330	4330	1616718600000
5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	1581	777	59	1	5767	jwE9s2dPeq7ejDkCQekrAVNjwQbvyiq23KwaCuoxTtCY5yRvjMa	3083	4345	4345	1616721300000
5954	3NK3F48Rg5pXQC6JjRcTuE2zuELD3K6hN2Aduq7pt7iczgzXA3Jr	5953	3NLhVFVjFqrYP2tGojQnn8eYuyMCJUReoat4xX2jC8Ybv2MY9XTW	1471	1386	59	1	5772	jxMVQ7uT9yhz1LazVRRPvTfwpyXaM1NhtD758p25BZT78x8cwmo	3086	4349	4349	1616722020000
5962	3NLgB2Uyhn9cLzBHwsqeqHmddKr9Gg5kZySBNv8SVJzGHFGieps9	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1407	1395	59	1	5780	jxzWP4DB7MvpLSH3GbpmWjFLKWggCokiCUZD2xoDYUmNixiZzrT	3093	4358	4358	1616723640000
5967	3NKuPQHqZWLH6JcTerrZyvBdcMDxZM4aAMht3D93KwcMimxZhxvA	5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	1483	893	59	1	5785	jwvTRaypfyngyhGQG5BDKpjkySaB9nhfoLscJjTHyFgYoqVtY1k	3095	4361	4361	1616724180000
5970	3NKNpNVhQ3ZaKfRDv5LQZvL6N7qePXDkB6KZKHN2SYvPFFACifAb	5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	1673	1122	59	1	5788	jwNEGMXhech6JKbgy32LTYcpq15hW712sFxSEwk7QPiDrhhuafc	3097	4365	4365	1616724900000
5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	5971	3NLAJgRwMTnAoEpGxrb4yZHWgBUnyHT4ear5qvVg6giaghosw3bj	311	1181	59	1	5790	jxaY5CQbCTotAncKGyjJacjBQ7Bj8K9AqE5FX4GvocCQmDdxo7R	3098	4366	4366	1616725080000
5977	3NLwEUkJDsmPDexvcnXkDhaH5Z83EwejF59aPRc1SirUcULH6rob	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	1564	1212	59	1	5795	jwyyUi71rqqHNGDzZm6foRKrtzhu3HZmwCfU4Qz1MAMYe25MGs2	3102	4370	4370	1616725800000
5982	3NKzEK2WnNHE4QGAQxamyaGQAdVqDsvo7LNehMBy9sMfURCqxaki	5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	1439	1153	60	1	5798	jwtMH224dSjHejn1uoZSvmD136VsQGuhHB5CBwEs52t8G3WLcKq	3103	4372	4372	1616726160000
5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1406	1393	60	1	5801	jwSVK98g3SoUXKJio2tppRoU2XGbXMp31AB26mro8S6CGS1F6UF	3105	4375	4375	1616726700000
5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	1634	203	60	1	5803	jxhhwDDSinTFbYckhZaN8nsNFKRGSYSevhg1QrSXNuR3D4wK3vT	3106	4376	4376	1616726880000
5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	5991	3NK2zkbQa3PnSw2Ea7ZJwX5C23jo2VMpqDjQZMDq21pH7ApB8BY6	1407	1395	60	1	5808	jxJK2cZrSV9rvXsraHVHySeRt9Fw9ahxZciCxG6twRnjPwJPxou	3109	4379	4379	1616727420000
5871	3NLtErv9ttGYTqJXByEy9Wid3k8nfgZQtGfhDTkrxvKS1E6bFLyM	5870	3NKDsRVh7gdFGBNLgG2H4LN4AnbNmYtx6QyBM1E7iHX44eMvLZF5	311	941	58	1	5690	jwfbisg1CpQbJrLUdqYrY3mG92uhrKmLTzo7DaEq4vAUdHEA7AT	3043	4283	4283	1616710140000
5877	3NKViWb9mHyjxJKiDjCAAdjfo6wpe2R7NQ5ZKUZC1mCxiH5cuCZ8	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1675	1342	58	1	5696	jwyQdAyGR6k3Qfn54mKmV5wEWRo4pGT7tR9QBdrbyNN5vnFayia	3047	4289	4289	1616711220000
5879	3NLasypQJm7qzAR11q7BXvzzZWzEUSmjuYrs4uuu5kC6pC8mSkN8	5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	1637	816	58	1	5698	jwFz2RpfomfFrZk6YAe4LDLbfZG5FzEDJUL1q34SAfsXB66XkY7	3048	4291	4291	1616711580000
5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	5879	3NLasypQJm7qzAR11q7BXvzzZWzEUSmjuYrs4uuu5kC6pC8mSkN8	1460	1078	58	1	5700	jx9C5zZR4xBfbtK3hVCu4yARAuGenrWoEarZrJbboNwBbFo47Tk	3049	4292	4292	1616711760000
5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	5882	3NLb7iDcek569ohPHdFN31661vagq369FmoUgZsiWWSFKtFHKfyb	1407	1395	58	1	5703	jww8d7TcZUZhA39GsfCH1g7rJ8VGauYJv9AxhswZ9zjTrW873kH	3051	4295	4295	1616712300000
5887	3NLxLjs5AcwxLz1ufAABQQYG3VF5h13XENudPHFTkS4wVErxQ2V8	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1476	1245	58	1	5706	jwKkXTqjEwGRQG4HMAbBeWGMciu4nRBxUCe51VCV54pJAbfiafF	3052	4296	4296	1616712480000
5889	3NKJBRMiYsSpuXioZ7zYK5JfEGLhBc1iXrLoSy3FvYSRchm8fxeg	5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	1406	1393	58	1	5708	jxCjadRre2kguP92DmsxwE2Jj8EXCdNfTaopyZB3f3WpWGknqNs	3053	4297	4297	1616712660000
5890	3NKSJhGrbdLVfPyZix6p8853mhyhXamjKgFMSDW8GvLfXHFLQNrg	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1560	925	58	1	5709	jx9PDCAiXrYk6CctQCrBkXKeNj2vKWVfpVRCsVrcQJdiTosqh4A	3054	4303	4303	1616713740000
5893	3NLYkRzqaTpPt24aQwfATXZQN83nEfh6KEfJaG5o7rAGdYVxbjbL	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1611	1341	58	1	5711	jx7opdK6cWHnUAtE7pMGqzZxMCXmpYKzDGf8dp5HBJKvpPwFAee	3054	4303	4303	1616713740000
5894	3NKotWuhHQQgxRmcMFxUwcnazcvyqH1Lzr4LKG6hbF5iW9DWBJSr	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1509	1194	58	1	5712	jxZwFsQAFo3FA2PKXh29baJWU3z6qu369pEWAntwWkdjWhQoPJv	3055	4304	4304	1616713920000
5898	3NK8pCzm4ZEXJdEgtQfpza5gn1QXPfM9UwhCkYDbbHPtDmdEwbyq	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1637	816	58	1	5716	jxUcvMmYng5tLTvodUNebXNz7K3n47qSPRJxgfvWH3RJfJRKP8U	3058	4311	4311	1616715180000
5903	3NL1DmsLfBSSDwXMwnyR1DExS8BcdgqiaxQ255BNvBFMErDc1Bqh	5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	1513	1379	58	1	5721	jwNNHajvx7N4a2JUYs8p8oJv2mHr2PnyBRUYDhTTZySGGUcSUra	3060	4313	4313	1616715540000
5905	3NKt77k8ye1bFTTWkuDiaum3GEUh2Bv6Zf2zsMFPjWutj6ppP6ZG	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1646	1108	58	1	5723	jxT5E6HfD4Zof2jaWrFqxLo4FhQ8h89rGFchtma2mdPhtrPVE4v	3061	4314	4314	1616715720000
5917	3NLQoJzg1Csm9TBJTxAZQZaimVvPC9gffkSEUaRBfb3EYKo2caYy	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1573	952	59	1	5735	jwrv9rV7PzfijxXBuo9rvq5kyLAR5DnBUUrMhe8BFn7uEikycPQ	3067	4323	4323	1616717340000
5921	3NLbYsmvQskKhsHtqBwwQyALGmicAsT4Rw2hHScqnPdn9JSzzZ5U	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1657	1098	59	1	5739	jwVK1VuTizPHQRwFnJ75XjaYQyqG5x4ZxVdRaq5q1wAG4aLnTvK	3068	4324	4324	1616717520000
5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1406	1393	59	1	5743	jxrWjB6BZqMwywpuKGgkF2MSBjLep2LZr5K7pwJWG4B2BhqKAek	3070	4326	4326	1616717880000
5926	3NKQH8X8thWsXypMQTqP9RZq8QZYPMEyxs2JrHJ9sHfguQJLwcxU	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1637	816	59	1	5744	jxeyCefgMbzyHtFdadLRcFQNeQnsEJwbkvfr3beMdz7V8bNCmtR	3070	4326	4326	1616717880000
5929	3NKJ7QSW7oReXfdCWw5HsYQDfHPSDtgQjQGUzXKTNGuVsbCRSNXD	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1564	972	59	1	5747	jwxm4jdfDmyVtVCg5PK7DEAmS46N29wSzJcqjfdcEMh8QnUSZ5k	3071	4328	4328	1616718240000
5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	5931	3NKSKuWzVGrxKt9Udw45tt4mMcxy6y7r73Buhy4xheEaziw6t29S	1451	1166	59	1	5750	jw7BsEuK2eArwWuF5J9wFm86QNnDvzdYmn4LnRNtzMZxtWMCiW2	3073	4331	4331	1616718780000
5934	3NKnvtaNWwhNDHrAwAYqPmjWN6q7h7XpaqJ47yF4TWWRr7j2gyJe	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	633	1384	59	1	5752	jwQp7idtYy7EViNkg6RRktfnUVGe8DdRRHKtrpY2Xnpsk2SSC93	3074	4332	4332	1616718960000
5936	3NLhYY3V9wbfpMMEh4UCviPzTGyXqcd8uRxsnic6vRCe5v9jZSUS	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	1529	1316	59	1	5754	jxKuFwYzv3HqzJPPDNwYFsu1ivbCXPBkuLrHfXrgLLchkwtDVbt	3074	4332	4332	1616718960000
5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	5938	3NKRitRWe2FnKCF2MUroZxhf9RF9TWtJW6C7F5qBvhvib87vUgUa	1668	1004	59	1	5757	jxMAsuB7gGGVRDCvF39HSzX2fKsvmP1NN8Tfx94Ffkx7SS51Urh	3077	4335	4335	1616719500000
5942	3NLJoaLZWHXLAXabkhAEAD6ZPtgAyKBeTL49nMAP3yPLPd8D7Cra	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1624	968	59	1	5760	jxQDiZZwVQudRkCZydnDtp8kxSwDxDEtmzpAMs6NjBMR179cPc8	3078	4338	4338	1616720040000
5944	3NLN5ju3kpR4aBFvT7KejjEqHLWGB3AsojwjZkSS52YqNMp7ehKq	5943	3NLkj9eGXut38aMEn4sGvNVZ4qyYSNZQ9fZ3SXYWmJUAcpGpSiVd	684	1352	59	1	5762	jwoqAGGNdXnFpzGYFUayHBHJV8NUPF3YCCLrRA8RCRQoWwDYRH4	3080	4340	4340	1616720400000
5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	243	243	59	1	5765	jwpW861qEs3ejGHFDRrvUtMffenKCwta2kj5q4rhaQfd18YBJmu	3082	4344	4344	1616721120000
5957	3NLLwnm6zjwEAeJkkDybq2jNWTp2UkvaRzhDjE6xACU2Gq2dPtsB	5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	1624	1208	59	1	5775	jw8hTUGu35PB4fxYrcDt3uVjwD7tmnTizSKUTztY3KXJWvCexAL	3088	4351	4351	1616722380000
5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	5959	3NKXzZowXt9wEPFkYCGk1QTS2WS5CuW2cTVwepm68N9q4wv5ZQPN	1581	778	59	1	5778	jwnH4hwk5RjRCiyzpnUdpY7EzeESwjeZNcTSJXeoHMMfdDmXg8J	3091	4356	4356	1616723280000
5963	3NLMXSXiZQDKNMhFjcKSV9GteiDqnGaf3YDQPVHbapNqoKmBbeWd	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1585	1366	59	1	5781	jwipTKibmAmd271U7huSwhtMP9nmNnZPu2QTkKTNWFNHXZcFTZN	3093	4358	4358	1616723640000
5965	3NLMuLgUz9jxXGhUF9NQXeemN3zSYBNfvoZ1BMra11uVYpjAugQf	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1560	1165	59	1	5783	jxfqBRtBBJf26V6EALu7HSmzfjwFs3YoFsJrEniLdGWqdridf3t	3093	4359	4359	1616723820000
5968	3NKtaCWRSrcVkaNvVBQsPCM2EYGn3BSc3SqvkWN8ZxNu8fX537LY	5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	1402	810	59	1	5786	jxnhihHHgZXatjvR1dtz3XVMTTZUDHqVgKrGZ4EhiqwTm2uhDmw	3095	4361	4361	1616724180000
5973	3NL7hgaNxuShKHCMCCnDSRSJVateMEmsizDC9ZSSo53JgprehVny	5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	1406	1393	59	1	5791	jxi8rfMpd24cvnD6Rr5NNF3i9o3LAjMLL6mccAT7MAuuH2KiYnd	3099	4367	4367	1616725260000
5975	3NLkfkPwYeeYwu4k8fa74UYQZ8m1qTjCf6wc1wTsiHhUWt9Q8epk	5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	1406	1393	59	1	5793	jxXhKQe3rpJZt5ParX3vByxLxMVTAzvSfnhsxGDTTkQdL5ihdim	3100	4368	4368	1616725440000
5980	3NLDg39sLStrW7PeuaL1e3w4Yb9oX83i2XbyQWtayzd3gHPFZmJy	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	1457	1025	59	1	5797	jxNtX6o7vvkFtHj1RcDPiDQqvu7yMcBNQzgMQ9p625mYuzrgLF5	3102	4370	4370	1616725800000
5989	3NLJcoChUiQAKfCC1px7vUsRDR6JPQsKxiJiSsKNSDJXq6RrqZK5	5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	1403	824	60	1	5805	jwQ4fndY3FgQwX2fnbCXZEx9ScTyapn6p2VVVz8CAj86c83oPi1	3107	4377	4377	1616727060000
5991	3NK2zkbQa3PnSw2Ea7ZJwX5C23jo2VMpqDjQZMDq21pH7ApB8BY6	5990	3NKX1SWfQ5AaDT8cPNHkh2BjP98tj4SkoXiPsv2LwaQkFe5TrfaA	532	937	60	1	5807	jwuH2rPefHK39LnWarNqUu2iCWZuK6mThLjqesSuB1qiCm1wXDC	3108	4378	4378	1616727240000
5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1563	66	60	1	5811	jwne2tBLpAssduW1gNUtuYbn1SSmUY88St8SVM1525Cog2GJqnE	3110	4381	4381	1616727780000
5997	3NLBt6wmE9AC2cbCavXez4Z1TbS5UoHGEcDcj1caenrHDLYyMPET	5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	1541	1298	60	1	5813	jxULAa2AqbEqWNKBLCzDkdES48wETDkccSpBzSzhWVXBd8yPLZg	3111	4386	4386	1616728680000
6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	1553	776	60	1	5816	jwwyBJPcnqpsf7NCRD9NPcKZ6WTHD95GCFkBn4kmZDyn9cWYuHp	3113	4389	4389	1616729220000
6002	3NLLPkZtDNGuHkk5Knp43R671GS69QUeXJfQGwEyQos4gcuBmRiu	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	1406	1393	60	1	5818	jxfboFAumXRwPoHx18MTpAdb76LvRivLsJd2fsmSamQZyV2HMYN	3114	4390	4390	1616729400000
6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	6006	3NKc882PRKW873MbdJ1vukx1wrm4ENtMyD5diXNoN95AecYh8hbG	1407	1395	60	1	5823	jxbe29UEFbZ8mwtZngHuSaDapNSxR2T35MXq965qMV1YWoLePMr	3117	4394	4394	1616730120000
6016	3NK6Xs3pQkAjVhv7KoVsbN3xrWA7WGxvMFwGDcsCWh615dLbo2hk	6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	1444	1255	60	1	5832	jw9qoQHVdmHqe8zvBUVmohK1ZQdaDQd471VQbX5oSHosWi4Mj6p	3121	4398	4398	1616730840000
6019	3NKbr2Q4yanVdQAud1jGtF6RNXmHDERav2f9C2hsg3ETSHc939xV	6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	1458	1323	60	1	5835	jx6chVMmKWV2EYNASVdS7xmfo5ES2au9RNasufrPEpF18wnje6b	3122	4399	4399	1616731020000
6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	6020	3NLUi98dnPAXMy4DZZF3tyzxxYYkruYkcDzJAiRoJdwACkL6mns9	632	1136	60	1	5837	jxmM5R6pFJS62FDaVJ8Ty8qDhUEQiAgrnBkSqVDaKXGaNxwTnYB	3124	4402	4402	1616731560000
6024	3NLXxFYvsofubBQRF8pscgRA622kAGbVyugZPsQXVFMQGHkSE45S	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1613	503	60	1	5840	jwEPw6nxNoqm3BS6U5o2WVFkN8j42AGZewaVerqxhpN6UdFxsZd	3125	4404	4404	1616731920000
6027	3NK45YBorQXBdopysZrb2irvrx4Xk846TguHyzfsvJscLDHEBtM5	6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	484	1319	60	1	5843	jxAgdsbiZGWAoLSY7EiSpy97No3Tpe2QL1xC9AaDJZUnTuNjNaT	3127	4409	4409	1616732820000
6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	6031	3NLrRJJLHmJtgaaqHCRFNxTEzXPAdRonRWMRhJWzg8q5sSBvhqQU	1589	1286	60	1	5848	jwsT8XXAywXFpWErDc3B81wNFvPmnPVNsa4YT21qKCiGX74ANfy	3130	4414	4414	1616733720000
6037	3NKEWA8xEgowxpUBh97R8C5VEwYzdJZbKohu8HdSGuY979guKLFo	6036	3NLmysbjgBpW4f9WdiNqdrjcQeJY7TVHChvGNnMVpAmQwuRx2vrT	1564	1092	60	1	5853	jwmheRvqYJDRnPgGRHD73tjVCm2JD3EgLCUWDDwa5Gguj6tBCag	3134	4418	4418	1616734440000
6040	3NLDmbSBdkJWVMYhXKNfWovW8UTzr9mMg6AsqR32fTpRS64867Jo	6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	58	1281	60	1	5855	jxDZEtkAaiDr959oqhMUfDida8zknfLjVjL3kc9iv2i4SP1athr	3136	4420	4420	1616734800000
6045	3NKQQ3eGXPx1AR1sdwLcTmtSKraEZSbPUWWT7tEZpj6sxFNN9NBF	6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	1406	1393	61	1	5860	jwTSgvY6hYVudebSaFSU2RuxQAYqRytCt2ByYkRuxUYzwzehHN3	3141	4426	4426	1616735880000
6050	3NKUfm4p7BgXnmHmgrcXk3w2FbQ1M67Cus69PpVTKPTfcnd4doMT	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1647	1302	61	1	5865	jxr9ggxz4GPm1mruBn9331d5t3rSoLqAe8WsHxN8TnYyyLVMsyn	3143	4429	4429	1616736420000
6052	3NLAkLsXtdu1j5DQVuHNJgUMjwAyPSxrYuEn6njjBhLYMVFBVwYU	6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	1637	816	61	1	5867	jwTch8H3WPiPXkCVt999HyjgUGbdeva6TetaYqpKxQfyT6jQXZx	3144	4430	4430	1616736600000
6057	3NKS5amVYFwryRb1cPk3yHDDZUWa8Qm9MqJtPxvV6bpZtZZsR4NM	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1553	776	61	1	5872	jxN4Y87vRDnvgVuqKFLxpLe7MDVHm7kYf4SFSvLY53HxKGZDoC2	3146	4432	4432	1616736960000
6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	1652	1315	61	1	5874	jw6xhqTPsJWcXr5SVB2BVHajavCGsEnHSq4RaL12afxx8RRR64j	3147	4434	4434	1616737320000
6062	3NLBaLnTseiaNrK9SGNq9xwQ3QGFYoXJVyxWWdZrYz3ASn2K4VHt	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	1477	1224	61	1	5877	jwEW9C6raX8MVZNkW8jgLjy86n8fN41pf6VEzPXPAHKNs3ze8K6	3148	4436	4436	1616737680000
6064	3NLSPVbjTnYPocQGLTJwV7Zjwj7Aj2WX7UyeJcvRR3CtUURxoErg	6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	1471	1260	61	1	5879	jwHKcKPc3rdLpSEmAVKC7P2i12dyzYxNeZbEhDGvXYVpA3dKNAq	3149	4437	4437	1616737860000
6070	3NKfKdTEDt12eAAuZtjrYuAzdG4o6LboziGAvxx2Lzh7WTAEyd7s	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1455	1332	61	1	5885	jxhtq4dqwbcmf2xf7YB5MWHRpXEuuNmpyWGcvwwdTwEkca7w3UM	3153	4444	4444	1616739120000
6072	3NLDGZ946xgmF9D17qYrAB4aHg3feRLhdXTEk8VMq41Hfgk1vZ5Z	6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	1407	1395	61	1	5887	jwf2eamt3cHqSMFwMPmor2ZnURVweMQAvJiS52XTw3nqZRajbYr	3154	4445	4445	1616739300000
6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	6072	3NLDGZ946xgmF9D17qYrAB4aHg3feRLhdXTEk8VMq41Hfgk1vZ5Z	1549	996	61	1	5889	jx6LSgRmtnP5uQhi8XHf7J8GC6QvqEcgsT2Ns8KWBSj3YHVrHtC	3155	4446	4446	1616739480000
6079	3NL2bhDLzY5M1QwfcrKa5wYppm5MpeeLY7sxBBPDyVcZaUhDTswZ	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1602	1003	61	1	5894	jwp2CgXQHb9uCXr5TpVMrQtKDBvYMAPLDxd6X9twotshN1jG6hb	3157	4450	4450	1616740200000
6086	3NLYy8odcGRkTVWGfez4sBhRmtyroTx6M2A5LeDztEHpsXmM2NEo	6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	1642	1367	61	1	5901	jwbz3qXpAxRHeMv1UDSio1NmPruTQfBo61zpgKXKsoNZY8eHPyb	3159	4452	4452	1616740560000
6090	3NLiMTVvkBP4i3Dt9ZydDJxDWnyFEHmG2AKKy7UzFu2xPrT64nrf	6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	470	1309	61	1	5905	jwjC1gPhJQjTTU5etbsh6WRoB1g51yo5azLCQF6TrqkC7zBeWxX	3161	4454	4454	1616740920000
6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1671	1365	61	1	5906	jxs9bBHubacCkV2NvFh9nRxepCoNWFCE4DkCuGcCVzrsMFAgTSQ	3162	4457	4457	1616741460000
6093	3NLetrZK9Ce9eNrfRBiyjPAvNcidE67Z8SaxAp2KJTRXQiersfqw	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1581	778	61	1	5908	jwmiMBGdxg3Kdjm39ouTthztxUpPVdhQ79X82NHWu7KQHzxg48F	3162	4457	4457	1616741460000
6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	6094	3NLpMhzxy7MR1MzeCDtvN9vxeTK8jYrxxNo7H9npvsVUGUJCNzT1	1646	1228	61	1	5911	jxUbWJnJc62pdCYV2wG55DGsVWH3DUepUpZLhpBjmqJfPsgPWKW	3164	4462	4462	1616742360000
5993	3NL6JgyHbn8JQeLPp1H1FKRGKvzVkyi9Qi9yeQMqfVAkLWrFHevn	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1407	1395	60	1	5809	jwGDta9dcYjbg2GqAT2g1A6b975T25cWR5JLEakgxcuEbfLjUPN	3110	4381	4381	1616727780000
5996	3NLS4T1wLqicyJpxMeMMsL6PLiVcNuffEdBSJw2HSQSSgrR8Pox9	5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	1403	824	60	1	5812	jx8F7mFsuFM9STJkMseeKnGhnAJE2PMfHXXS7BRxN8UVC4zQWqh	3111	4386	4386	1616728680000
5999	3NKyjasWkdkRuj7yxdacqitEcQbPKfiFdHEQJUnLy3pLZ2iveWHf	5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	1670	1282	60	1	5815	jxRriUmtYPKFRvn6p8kGfSbiYKtScvbqapLXE8jrrWXsQp6QS7k	3113	4389	4389	1616729220000
6001	3NLf4au6pUspSmXuY8bEPvtXNJGu3qRKmPgEujfeh2FiPjtn1TB4	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	1422	1091	60	1	5817	jwg7b8gsmndWR44fyHCkKaNGNvm4NF1u7SdKkhV9rvoJZsWKc9x	3114	4390	4390	1616729400000
6003	3NL5okjVePediTJ9xTipAuoQfRUabutXB9ui32tnoQsYhyZ2GRfE	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	484	1319	60	1	5819	jxai7Wpw1TeActUhH9SzyckDH9QX4ktLKRWE2sXVxqC8sRRREdQ	3114	4390	4390	1616729400000
6013	3NKSpvNLMh6J85MNp4xYfjGiBV4GqrecHgg6sJzo5b3aRmZj498C	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1407	1395	60	1	5829	jy2PiUXGmdWe2YHqXpGV5fwT2taon841ypeZBj3DaYhCbNL7iDY	3120	4397	4397	1616730660000
6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	1651	1301	60	1	5833	jxPj3RRPNZMSfLf2bRqKV4Gp5Bvj6bWqxbwVDr2BfetnYiFQUw1	3121	4398	4398	1616730840000
6023	3NLJ1gWD8zR1tByrfL4rL4qcBYpUvn4zWgJ1vuyXcUWC1BwxoR2T	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1474	1203	60	1	5839	jwuvkChBUJiRYZ3rmmHfBYs1Z14jeyPR5Qqwmmj56Z5BVfJWQVh	3125	4404	4404	1616731920000
6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	1403	786	60	1	5842	jx5nrGYxk29peTwRJjtBqrfE3yVy3vgA4zbqAepUC8XsG4NkB5o	3127	4409	4409	1616732820000
6031	3NLrRJJLHmJtgaaqHCRFNxTEzXPAdRonRWMRhJWzg8q5sSBvhqQU	6030	3NKjVDpkjWWycf9bFzGZ76MAouD5Kb9BBCXuFbbyJ1Fs7LoPMjvg	1581	778	60	1	5847	jxTNhvPmMFzpDfwJWeUueTUDZn2kQDjXs4ATsgK5zSKwQzt3oJ3	3129	4413	4413	1616733540000
6034	3NLebx9k6cuQ6u7kuaWExZFxyAws7zkd6qfAemo2N5K3xjsvjCbb	6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	1564	1212	60	1	5850	jwf717oRmiq4jVRffCwH3ceV4K8fMXRxYMCgRuoy6jJGS8JGWGQ	3131	4415	4415	1616733900000
6036	3NLmysbjgBpW4f9WdiNqdrjcQeJY7TVHChvGNnMVpAmQwuRx2vrT	6035	3NLcowSgMRg9eGF2ksjUQESm1YvJKxJKb3SE7AVKhExZsedmcdHn	1444	1381	60	1	5852	jxvWdjGQQ2VKDGAaZDKvwwnHUzzPeGPPd5RgNww4EnXcTxs3vHB	3133	4417	4417	1616734260000
6041	3NLBxma2KrFtmNKqBm7Xzins5Xii11y7HtiQVbgS2x3nqtVNAYrY	6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	1579	1389	61	1	5856	jwubg1dVDL1U216ymDN9WUNAGGGJAiBnEL86GFFB5PncYeRAgCc	3137	4421	4421	1616734980000
6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	6043	3NKRtEYjkVySbLYBPFoiKT4r4px9LbsGbP2GTrqcf91SuKoSzoUQ	1406	1393	61	1	5859	jxNEHcurzwMe6DV1MrWGjxf5xJZBhDrqVfaEzdfzjFcHFVaiBrA	3140	4425	4425	1616735700000
6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	1581	778	61	1	5861	jxjpUXtBGMiJdbLWuyWJzSGxeXAgPsdCQX4nncJH41bFivtEv54	3141	4426	4426	1616735880000
6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1662	218	61	1	5864	jxUDLoFscbBiapPzwS2BdV7f6zgem3hNjM46osMwvhiqMdAzM6U	3143	4429	4429	1616736420000
6051	3NKW9X8pM9R2hUPnM1hR4ZmvH7nAS81q4AJrfdwWC3jaoHA5ryNT	5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	1647	1302	59	1	5866	jwXEjmgFdbgnfdwEjrM9gEtDsmNEG7eniBEAsEDWjziPXmRydSe	3100	4429	4429	1616736420000
6056	3NL6kRDnTEb1TFrifCSFaPvHhHwqNMXFwjhBJPnNc4wBCc82Vnou	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1600	1126	61	1	5871	jwNoLkjkeWPNuV3cJizDJpDiKVx45mmQsVFEo135Lu3W6rS5efy	3146	4432	4432	1616736960000
6061	3NLfuxbYLrzqZiMgtgQLKQYrcMRpgtbEKpb8FQaSwjDKFSFXuDWw	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	80	907	61	1	5876	jweKvBup833CVxeTKP3T76fjSPQoo9qdCR95HFGVncK2aeHVTFQ	3148	4436	4436	1616737680000
6063	3NKn2dCSNEC9tKkiM39BfjnUidxjCQQ4ms4a6r1jpdQrUbiLEYxX	6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	1406	1393	61	1	5878	jwscnspnsoYxhVpyk7U1CWtPcB82ynM7RVWcTn2D8fiL3G7E4g8	3149	4437	4437	1616737860000
6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	6064	3NLSPVbjTnYPocQGLTJwV7Zjwj7Aj2WX7UyeJcvRR3CtUURxoErg	152	1330	61	1	5880	jwfxv3ireUQRd6tcDcpWzqHy4BSujBnZWqNKfoUh3YivwAwRCYk	3150	4438	4438	1616738040000
6066	3NKfyRNg12g3kq2ViT4e9UZkmFfWhx2ddrAFMaY288iar4bS15uD	6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	1406	1393	61	1	5881	jwqY2FnZgzTrALKjCiQGPqS3qV5g9jjyn9ku6MXkeB2deqYbASV	3151	4441	4441	1616738580000
6073	3NKds9uQc69oM4oK5JDjoh7nqc8iDkfmaggtLoQBBaeuPqsi6Ruk	6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	1648	1038	61	1	5888	jwC4T53k4S4GME4yukdXXgEY3ZnqSqBCBFWLGMTxfTGYJLSitB1	3154	4445	4445	1616739300000
6076	3NL9whgEYHn8G9C9Hj4Q7z9rKS3k9THvDxzCQD315pBy7KCtMUHf	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	633	1384	61	1	5891	jxcgFhnKgbdRm28fYBraJDqaQ5S14HMMcq4NTRp848n6h91W1vi	3156	4448	4448	1616739840000
6078	3NKQzrG922eo9qmHDLNCtvmDdZa65xKFjj9FHABMbmmG4znwqsYb	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1509	1320	61	1	5893	jwFad1fJnCBjoJEuWmVXsNaQzSAqwkA6Qvbt7wU8inN3ht8skpd	3156	4448	4448	1616739840000
6080	3NKMo2yF15mzh1D52d86Vfi3KphzdVpY8iwHS73qS5JF6VAHZWws	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1623	830	61	1	5895	jx3MDcgTgCUZjn2gW7D34WvWntL5vujAV8hfD61Bf8JjvSwKr2L	3157	4450	4450	1616740200000
6087	3NKW6UBzVdkyuqzvyh8nWunsmAQ49MMKNehSvYufCkuSzp64wN6B	6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	1402	868	61	1	5902	jwjgJpdDnpVHUnk9voJtbLGg9syndqmmQGHrnwRK5HoSgQyGHzF	3160	4453	4453	1616740740000
6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	1406	1393	61	1	5904	jxcD2dfuadJrMruEumhp49vgBmZPaFe9L5QSvLLsatB2KvwRP8j	3161	4454	4454	1616740920000
6095	3NL8QZb671JfRMVwX6o3LMJYPqAh7UymXTd4t2GhN4N6EeuY3jnt	6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	1654	1214	61	1	5910	jxY3rijxukKdAXqVCDPaYz5oNiRX3YKyo2MjcRshFYWzKeR9gbb	3163	4460	4460	1616742000000
6098	3NLLhCReZzznqZfJ2TWgf1J61i8nJLGUfNrXRM6zV8Ti3XqrukFV	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1406	1393	61	1	5913	jxETtNVaoWy1qxVzWhDAte4ZkLqCtAs5PTc36MVNYQ8WtCZWeuU	3165	4464	4464	1616742720000
6100	3NLvXvAhojXbkEx9DfBfEmtYAhSDc5N4PYrEppWg4ypwdvA62gSr	6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	1406	1393	61	1	5915	jwkUbbCqYGFaqwLNr1B77Bo4QnnFQn42yFBmfkpPHNwFwbvTmJe	3166	4465	4465	1616742900000
6102	3NK3wBvXFpGfuWW4HaKDNLwoTn9vJZUrte8tWVjGHb5PMRqH4grL	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1529	1316	61	1	5917	jw7XkhbrFRtNTGC8tdgMuaRLfjiuMXk3HaRPC3qXSqRtDzM7Uar	3167	4466	4466	1616743080000
5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	5996	3NLS4T1wLqicyJpxMeMMsL6PLiVcNuffEdBSJw2HSQSSgrR8Pox9	1573	1072	60	1	5814	jx4tn6WHmqeXvv29Uw1oStj4MNDHkMgtvbRbf2DcfE4C7PGefZJ	3112	4387	4387	1616728860000
6005	3NKRVBMjmvpYDRGKPPX3MPoa3LH7n8mNDJDYS2fCXoK3M7NMGFx9	6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	1553	776	60	1	5821	jwGSQXJvNH2ewCB3q6qJv9dPKXidYWy3Eyba38SDK84H1qXfUBL	3116	4392	4392	1616729760000
6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	1673	1122	60	1	5824	jwkqWDDzgU21VLzeSqJ1EnpogpjmtoiGZZCteDsh2m1U9hemBUz	3118	4395	4395	1616730300000
6010	3NLSn6wQTfuouV5aUBwrEG4pLSbNLsE5N5pNMLAGDEd6JJSz11UF	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1508	1021	57	1	5826	jxz82Mz9QnsZ2iW2LRM4AcJ92Pf3WSEAyGCkN1d6mBpfkhRPszY	3010	4395	4395	1616730300000
6012	3NK7o2hSgzV8eFkfZLQ9Q1gecA5DFZF3F5dMHuH2M958rkZZXWNQ	6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	1631	794	60	1	5828	jxt8Hh7SpTg88RDaHjiyNwfVBKocUD6tQbojsv9yTzY8ig4Zdyy	3119	4396	4396	1616730480000
6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1648	918	60	1	5831	jwYVfPr17CA7E8ErMB8AUW5aFGotd6PQwDp49UykybNfx8Si5dC	3120	4397	4397	1616730660000
6022	3NLy6Yc3ZKbPcRACX1rxYfjUSP9Y8PqxPZRb1rABWiwpLAMiZSU2	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1578	1050	60	1	5838	jwXFaLHtjaXFTa2WeH6TQA6BYNesNLnPiorv6T41mZrRYJuVf1k	3125	4404	4404	1616731920000
6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	6023	3NLJ1gWD8zR1tByrfL4rL4qcBYpUvn4zWgJ1vuyXcUWC1BwxoR2T	1407	1395	60	1	5841	jwtNPCdgb67pEemGF83caoRxocy6fk2BGX7kv4jYwbXRTdgzJrh	3126	4408	4408	1616732640000
6028	3NKoZ9KPTqBx79hs9EfZTKvvj5Y8fPwKNxuz9v6PaRFyZuKV92sQ	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1407	1395	60	1	5844	jxMty5Pf59SaApNE4XKVUgmRiTUvbfAZXVAngc5CXcm1GoekG9a	3128	4412	4412	1616733360000
6030	3NKjVDpkjWWycf9bFzGZ76MAouD5Kb9BBCXuFbbyJ1Fs7LoPMjvg	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1419	814	60	1	5846	jxCHv9Mu6MYeFjHThfzVBAPW18uqtgoNEKUH1RaAc5tA8u4rtix	3128	4412	4412	1616733360000
6033	3NKdYCxCDcd5nFVZBcW8ToxC8HYs62FbiwPgr5JiT8f3A4q3E3LM	6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	596	1306	60	1	5849	jwWiYKZLUH9kzJyLYScagmS4DSCi3Twfx1s5tJqFdFtVVdxi42J	3131	4415	4415	1616733900000
6035	3NLcowSgMRg9eGF2ksjUQESm1YvJKxJKb3SE7AVKhExZsedmcdHn	6034	3NLebx9k6cuQ6u7kuaWExZFxyAws7zkd6qfAemo2N5K3xjsvjCbb	1440	1131	60	1	5851	jwDwKyCqRR4qkR6GrepZQ6KwvxvqC4uS226iVX1j8NEZwXjMnKf	3132	4416	4416	1616734080000
6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	6037	3NKEWA8xEgowxpUBh97R8C5VEwYzdJZbKohu8HdSGuY979guKLFo	1447	1099	60	1	5854	jwpsLNkevp8aFPJz36ztDFkY9J4d9WBq6zJ3Ez2HP749xkHMGrZ	3135	4419	4419	1616734620000
6043	3NKRtEYjkVySbLYBPFoiKT4r4px9LbsGbP2GTrqcf91SuKoSzoUQ	6042	3NLNvGToVPiH2ZZo6wC5S3WFGvEXK5tuchnxigSXzQomnCMLQsEG	1596	1363	61	1	5858	jwdsTDYbv92BH8wRkAYPSkV1R1XsAAvYpwv1g3zUHq4PM3MCUJC	3139	4424	4424	1616735520000
6048	3NLtEqF5EGbTne2SBmLqGNJvZPoTf9qsQSfEJpzNekqhRTH7Us5t	6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	685	685	61	1	5863	jxPK4xf4wfPratrtnJ9zJQyCerAYNr1kikcXBfhEuJ1f45Psro8	3142	4427	4427	1616736060000
6053	3NLuyK2R2cojvJpETyeeZ68x92PrHv7E6Um7owqqitSgVM57VCHH	6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	1553	776	61	1	5868	jwFYsseFPZE6JAYEhdd2r9jrKmmxEg7X8eTTkFYX8Ko3UZfY5h2	3144	4430	4430	1616736600000
6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1671	1119	61	1	5870	jwSoCoEacdaWYA9ne9Wq8BbEm9Ci9pBebVDuyyboRp9NoQfXwQ2	3146	4432	4432	1616736960000
6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	44	1325	61	1	5875	jxLAdp4Gu1mwRFt2MyXQ6tHYrDDYhgPrK7qj3amdqftcjRbezzK	3148	4436	4436	1616737680000
6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	6066	3NKfyRNg12g3kq2ViT4e9UZkmFfWhx2ddrAFMaY288iar4bS15uD	1461	1271	61	1	5883	jwdSQcbqhW4kBYiSjdWN5ELv4hYbevsuH5qWRBdqksHT8hrBzAr	3152	4443	4443	1616738940000
6071	3NLv9bGPrsbHqVhVF6am79g6mZL1GXNgpoNQtXGG1FRiyeDfTjDE	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1648	1284	61	1	5886	jxPbpgcjLqBaoE8fguR66oZU54zUSN9ohaemL31xWmoiZVNwauk	3153	4444	4444	1616739120000
6075	3NKbvNn7Dzc2mKF9c9timUFtJdJJ1p8N2U4z8L2fEM3Qfuy5eSaf	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1426	1364	61	1	5890	jwKY8a6ig7P2AC8JZSf2TaAjAAquHqUJZ9CzyfV9QHKesiJKSXy	3156	4448	4448	1616739840000
6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1610	948	61	1	5892	jxuqNEkiFGccxY6JNyriXc5t3TGwi6Z42PRG8uGCAJdGzjuSbMq	3156	4448	4448	1616739840000
6082	3NKMQ4PqUxfKHHetHErQL9uk6gVoPEa2j14CaL1coxBDztENcKCY	6078	3NKQzrG922eo9qmHDLNCtvmDdZa65xKFjj9FHABMbmmG4znwqsYb	1542	1058	61	1	5897	jxhCjCDE2uXwUvney6EHBTPQZ6nooT7GzKoXHQxMR18gcG526Gd	3157	4451	4451	1616740380000
6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	1542	1058	61	1	5899	jwRLPuakfJEdi7fseRinUzieMcCzAtptsPCoyC4dAoPfHn7mhTg	3158	4451	4451	1616740380000
6092	3NKriaWDNQQYu6ghGzA6scQnha527Aiv7dii9pXnM3iCBVDm98eQ	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1657	1098	61	1	5907	jxXgQY9WTLgJNjVte3tVQzPzS28SrCmt94uL9Xig6SKzvGpCwqn	3162	4457	4457	1616741460000
6094	3NLpMhzxy7MR1MzeCDtvN9vxeTK8jYrxxNo7H9npvsVUGUJCNzT1	6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	1458	1323	61	1	5909	jwq1HFNHSecpbbsmvDXpo9ps9NrMCbPKUfTFYwW6LU5cm2CHCUd	3163	4460	4460	1616742000000
6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1403	824	61	1	5912	jwiYHk52ZRGpyBf819yt2689QdouaacHmjccC2ejocSdtzLyGzU	3165	4464	4464	1616742720000
6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	1406	1393	61	1	5930	jwMmKZbEciYuquYZsKkEzkTuyo2RuxJPqzBQVVyvsT3kRWK6E2B	3171	4471	4471	1616743980000
6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	1529	950	61	1	5932	jwgTZYqseFBqMwN8o8bXNeJYtHmRR64hhMPQvVmRutkndM8J5VS	3172	4474	4474	1616744520000
6122	3NLPgiwcx3uAre2QzAsDFHZx4CgdqGzyP1nXKVbgNhxfbCdpT7JH	6119	3NLLoj3sGpPMDyWomWXt3vyJLP94doLPzcEJvzuUTuwFwBCvH7CU	1406	1393	62	1	5934	jxALEnaJKKpB8DdbUZMwCpLUV2jizCs8sULyp9fDoTedhGUGFn6	3174	4476	4476	1616744880000
6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	6124	3NKVjAKrK3SaxmZfZM3RUf8Lg3rg7mMmMpP7jSd1chhK1vU76UBq	1623	830	62	1	5937	jy1Fh8VJRFXkmvkmnaMvrdk7f17zYDpwsKQDrmYSgBqdA59YiPM	3177	4480	4480	1616745600000
6128	3NKspde1cRtTdAHkEQE2AzRt9y8THd6iBqohrGP9pBz8K8sik5C8	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	43	944	62	1	5940	jx24Ee41w69CcMn7zGdWSXnKviPTaPzjsHtm4idTsQYaNi11XkZ	3178	4481	4481	1616745780000
6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	6003	3NL5okjVePediTJ9xTipAuoQfRUabutXB9ui32tnoQsYhyZ2GRfE	1458	957	60	1	5820	jwahhZagbQJf6zS7PaXyeuKCGDkB685tGRbLqBPQkPwHKga8pJT	3115	4391	4391	1616729580000
6006	3NKc882PRKW873MbdJ1vukx1wrm4ENtMyD5diXNoN95AecYh8hbG	6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	1633	1390	60	1	5822	jwD2eAKyKCcuFD3S7Q5Sqcx1Ej54xnsHT6mFknP1qfdzKJqnENJ	3116	4392	4392	1616729760000
6009	3NLfZ6kUwQ9n9pJC8F9DX15g5ZXa6XuRhrGo48NAq13APANr224a	6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	1508	1021	60	1	5825	jxeDMdvDwn8gMhV3U6SANDXxWsAExA6u8tBiKJeURa6spgFUmhJ	3118	4395	4395	1616730300000
6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	1406	1393	60	1	5827	jxTGCHKTVHipNRedn6SgYd3s6uv4uD24HCWVpRZzLJ3eXaaZtTf	3119	4396	4396	1616730480000
6014	3NL8UzJnuQ2NWA9DesXZkYzv5E3jzfJmSUyvwdEbMa3DBen3US8x	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1546	1093	60	1	5830	jxfbk3SiULabMC9NzxBQWo7XQC2qJ8QEV33v5TBSBcdfJ97ZyD2	3120	4397	4397	1616730660000
6018	3NLpPffBW4BZ6LsmJYDGUUhQmygPzj8tGBV27Ag19mo64JTWrVsc	6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	1602	1369	60	1	5834	jxf2zKBj448BiP5XDSRUD4ZTmRQ5ZWWgin1pykomB8xUDW1hxhj	3122	4399	4399	1616731020000
6020	3NLUi98dnPAXMy4DZZF3tyzxxYYkruYkcDzJAiRoJdwACkL6mns9	6018	3NLpPffBW4BZ6LsmJYDGUUhQmygPzj8tGBV27Ag19mo64JTWrVsc	1648	918	60	1	5836	jwjEBYQq5vUjwbfZtGqfRHDqwcdCPAe3xcpANHGdomoAE8mEPws	3123	4400	4400	1616731200000
6029	3NLKXfqJBSGn6oeEUWxw9Vv4bs7Q7TTYsLzH3AHu8HaQqp5exrfB	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1652	1315	60	1	5845	jwG4xbJYeLRAK5b9UdsSahs4Rjezq247NF6WFn7QEh7BjkErgB3	3128	4412	4412	1616733360000
6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	58	1281	60	1	5855	jxDZEtkAaiDr959oqhMUfDida8zknfLjVjL3kc9iv2i4SP1athr	3136	4420	4420	1616734800000
6042	3NLNvGToVPiH2ZZo6wC5S3WFGvEXK5tuchnxigSXzQomnCMLQsEG	6041	3NLBxma2KrFtmNKqBm7Xzins5Xii11y7HtiQVbgS2x3nqtVNAYrY	1481	790	61	1	5857	jwACqmSSKjGwo48etu8RVLWdNosdYhYUkrfSEXheofCqttMtNEG	3138	4423	4423	1616735340000
6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	1458	1197	61	1	5862	jx113vfpatzquUMsLW8dhRBuTNj4pZrX7qkSLQBhaCrDBRAJq8u	3142	4427	4427	1616736060000
6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	6052	3NLAkLsXtdu1j5DQVuHNJgUMjwAyPSxrYuEn6njjBhLYMVFBVwYU	1637	815	61	1	5869	jxrfZW7dJxjS44NSbWX1km3yrLPqskSfDCgtCrnLVne5tYrLcDv	3145	4431	4431	1616736780000
6058	3NKNArAxCh8Fft52UEjbaJqsMst6HxfYQ95cJwJxXFDz131o6caZ	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1617	922	61	1	5873	jwgWmqh6HHv955zL6VBudDz5WAN2rb93huqCMgLpZhrrh7zMsNa	3146	4432	4432	1616736960000
6067	3NLiRDynWu439Nk8a8D5snhvXaxe5UeMgZhKfiDQRpdNd8SMct2T	6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	1675	1216	61	1	5882	jwhosfN4qddvnn3qnspnvMGut87zn33YaBfasQTJ9rjthdpFxWE	3151	4441	4441	1616738580000
6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1451	1292	61	1	5884	jwBag4J1NEaMqYYC5pM7aAsQgmRygKaScTNaR2MWcVZqJ1hYtsH	3153	4444	4444	1616739120000
6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1631	794	61	1	5896	jxCMzhBowi7EeQhkuJh5EmRU1zViVA6Wb2RSy7XD3jrRqfroMbU	3157	4450	4450	1616740200000
6083	3NKhjP4ofMLutfyBSKuJBYgdhueHFtLeDDABaetjE8NaBYKZRLq1	6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	1483	201	61	1	5898	jw9rbgA2ttWt7aYZ9qejoVUgT5FHaeh2cZACqW1Y33AQ9mYV5oB	3158	4451	4451	1616740380000
6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	1507	914	61	1	5900	jy1C86jP5DuFEhBgoVmjHeeMryyiXPLFut5bmViLjgKpoNFQa3x	3159	4452	4452	1616740560000
6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	1407	1395	61	1	5903	jxc4ahiPyoTdrpU4ZaXpJdFcS2acVkWbvWLJfYx9bt2NkztzAiL	3160	4453	4453	1616740740000
6099	3NKQdetShWJ8zn1yWyHkmTE1Qkxho54nXpwRLxH4bk84bp5BdRFR	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1600	1372	61	1	5914	jwrvyA36JVwkxkzkJN5xKDYJzRz2CAiGc85G16eTdtYv68rF4xe	3165	4464	4464	1616742720000
6103	3NLCYoePYeHwyKRve6sFC1Cj7MnmGdB9qaaenuv7YQYBdPrGa7j7	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1445	924	61	1	5918	jxNKm1kK6Zhz89Au7fHeUrgtSxUFygoJxFgns5SnKu5nDsSADb9	3167	4466	4466	1616743080000
6105	3NKooPubRhAQbAJbNrXLSoFr5hB1AJrMMMaLbsRbpPSdfM5E6Gpz	6010	3NLSn6wQTfuouV5aUBwrEG4pLSbNLsE5N5pNMLAGDEd6JJSz11UF	1508	1021	57	1	5920	jwFfsEMXH23e8XDXxMmCJ3McGmPu5stLa6jP7dqf87t8G7v6gVK	3011	4466	4466	1616743080000
6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1471	151	61	1	5922	jxiVBykKDQHL4w5Gj9MHs74orBHUCG2guqcMaMkJ5jFWMPywcgt	3168	4468	4468	1616743440000
6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	43	43	61	1	5927	jwfyYZJVj4mDopu2MRe5N1TaaAbCrVeMJtNxgqTjCGZC17nUqvL	3169	4469	4469	1616743620000
6114	3NLgzPzbAfU9QJJch2szndFemmqzXVNyeAmoxXUjEtM4KqtHP6L3	6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	1406	1393	61	1	5929	jwF3iaX1Dh6G78b8jcFvTJP6tXoERqdMMnJWc14GDGx5LBMhfEK	3170	4470	4470	1616743800000
6119	3NLLoj3sGpPMDyWomWXt3vyJLP94doLPzcEJvzuUTuwFwBCvH7CU	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000
6121	3NKr9wFrBrWsiRzSSeubPiuLGyYQtbutVvjE9gbQsv21HJAbe4VB	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000
6124	3NKVjAKrK3SaxmZfZM3RUf8Lg3rg7mMmMpP7jSd1chhK1vU76UBq	6123	3NLuoxcayj7L1So1WSY23mr8t3UjEKnUNFb2yUhQeaw59ynZnRvW	1529	1316	62	1	5936	jwDRo6kgeVAKMyh8Nc5hDb6Acr66dxrAYTy3PYtqRzswk4RLYK3	3176	4479	4479	1616745420000
6133	3NL7KwH3hvvWv1G2fAXwcgqA7hcmWAhDU3RxnYEoFKKokpnqTp5r	6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	1422	1211	62	1	5944	jwe2bq8BaocGwkBVAuaTmJE2Es2FNrFojbcFhqAztc4qJa5Z3tZ	3180	4483	4483	1616746140000
6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	6133	3NL7KwH3hvvWv1G2fAXwcgqA7hcmWAhDU3RxnYEoFKKokpnqTp5r	1509	1074	62	1	5946	jws4345qP9KhqFnMFr8dE28Cf1tFwqV5SEAvt3XC8mGRRB1Qda4	3181	4484	4484	1616746320000
6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1407	1395	62	1	5951	jxFMwCgyGKCa26hAFooPPHtA8LQrNTKdojArvWADEBoiP1r4hPu	3184	4487	4487	1616746860000
6144	3NL3dDB7KtQwCvYzWk8kZ3RFdtCA3S9cVjd5hxjKFXwpFfsiEJ69	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	1421	508	62	1	5955	jwKc5zMWEwZDWrV2cUEiQT8TzUgMRpnLDVrvNnNisf4mW5FXV9f	3185	4488	4488	1616747040000
6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	1477	1224	61	1	5916	jxCJUpLafVwC3t2za5iua1t7bzwQLPfPW3SJszajDPEpwX6wwT1	3166	4465	4465	1616742900000
6108	3NLjfZ8kChD3W8Y8GBu16aCxXEd2Y4VhbTHiKERM9Q9J4mb1jz6q	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1407	1395	61	1	5923	jxJLwje5r7LDQQprnKwRdz85FXcGNE66Zap691WbGLUtsCh6GzW	3168	4468	4468	1616743440000
6110	3NLc1jcH5JRv2wzWshkQYTfZN1jxjEM2ypa19MCa3ycoJzUNyGrj	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	1406	1393	61	1	5925	jwGpupNCL7bixheEdDu8R7FEBkuqGcD44mVAMspWzHcEoKijCtr	3169	4469	4469	1616743620000
6117	3NLEbdUMDr3iX5MJJz7ctBo5yijr2BhxmegsEPuupdzTq94Q653u	6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	1529	950	61	1	5932	jxkXWhiaJ3PRHnPKPRynzmTaWaPN561iuwRuiBPNEpvghYNHJMM	3172	4474	4474	1616744520000
6120	3NLdrzRDgKFNN6FuoQR2Ap8DqDoNtfz9Ax4V4Vgh9mRg5BQ7bWJt	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000
6127	3NKicyLG3fCyAXdqjM5S7HxTbARkK9Wjty5fH6eZZveD95ZYDSFw	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	1477	984	62	1	5939	jxEFLNC7KEv4ANMQMWmPoTcVYFJnSkX7R6dc1SH7SHPVf7msMrh	3178	4481	4481	1616745780000
6129	3NKGNS2Wre14FYkF8YUtcAKaHiuZDAE3cXWc7KGuRsLrgAnjjK8M	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	152	1330	62	1	5941	jxuBXRjrC8nbNSai7RpVEvdijktevRz3dHkeUDfJj1tRVW9WJdG	3179	4482	4482	1616745960000
6131	3NKwiXKwMMKWkZYyUWZ8y1hHEkdVbCd4ZxrT9s2589ZfayBfaZri	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	470	1309	62	1	5943	jxfwCRe5io9v6aFb1XzNna1k13KTCtunT6EU1DXyW7CZrjtoF6Y	3179	4482	4482	1616745960000
6134	3NKF7bqBfoPjDfs7amC5az1NqyVHcB2iLxJvmaJnYZ6gVrkCBxpL	6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	1541	932	62	1	5945	jxcuZJuxX21uBCbvAiqm6WhD3shFRM6aEV6hqK5FJ6ze4RXBtSZ	3180	4483	4483	1616746140000
6136	3NKdiJuMwgUNwXW5z7sbz9oXHCerMn8VqLrSJgZoTE1vX2R8CDXE	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1405	873	62	1	5947	jwCLgJT5T1WAQKvxDFcCTvUmacMWvJ4auS2szyLS5aRwVkuwPGd	3182	4485	4485	1616746500000
6149	3NKFH4mHrC1TH5RGhLVy3SvLzuXLo4aWRfYVtiC6P52z73SV9qPb	5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	1649	1383	57	1	5960	jxCG923VtVMTYQkikTfyEN7GqrjFN5bZE8dVwFcN46mb7PabQaV	3000	4488	4488	1616747169815
6156	3NLmnUHGnUGqPmMmpdQwPR8fHM74n1QLhWmXm7QdEw4kEEmymamL	6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	1633	1024	62	1	5967	jwsrB3Uhoab1okFbXGoEoxohQV6eXQCVAu2FiSGGPCEWb6bDS6V	3189	4493	4493	1616747940000
6158	3NLfG1xMko7Gf5tmJk2zGyotcseD5VDVCrJYR48ennReQPKioj6b	6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	1587	991	62	1	5969	jxF3sEUGDPyfn2wfzZpqTPAYqfj8JUKkMJcLeSLuzznhqkwSkqA	3190	4494	4494	1616748120000
6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	6162	3NLF5kcYpo3pP1BjPBpz9Uz3Uxuz5vLYTkxf1ZxEA7aqXHBo7GVJ	633	1138	62	1	5974	jxiJNpS3nL3iVoAs8Wx9yR3UMeRp7JS2dzjw3gbLTe5jY4Krn8Z	3192	4498	4498	1616748840000
6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1656	1343	62	1	5979	jwuAmrtHP3qRLxFbVq6wsucuqxo98fHBJTXTEuiFMtf36jPvwbn	3194	4500	4500	1616749200000
6170	3NKr6QrXJ4dVXj8UrNTcEEST6UVrgsuj2VpoJsZdqcF81b3io7PC	6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	1403	823	62	1	5981	jxGjHdNqzRzgiuhq11fRNGV6tuCYaujBnxZKv9wQU74srEGi3YK	3195	4501	4501	1616749380000
6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	6171	3NLqoYtU7MoVbfvYHgyCyfeciNeKcujE3JVrWqWMe9t6AHCpDHV6	532	937	62	1	5983	jxZavoc1aqcfsHihu1X8bTas37ZfKttvPS3KH13xMpoHMpChdPR	3196	4502	4502	1616749560000
6173	3NL65NGc3o497zcyaerPCkB5Mu5EkEmD1kqkQwF4jvdu4zR4DLR6	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1406	1393	62	1	5984	jxwbbjPhn8sxp2PMr5VMNaYAdgdbG7W5T8N2cXYwX1JPFVGHtgo	3197	4506	4506	1616750280000
6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1581	778	62	1	5990	jwp3qF8ZxXNfUnfq1XChrF8EsWKhHzsrQHuhVykGWD62nGPtpzt	3199	4512	4512	1616751360000
6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	1513	1013	62	1	5992	jxgkUsVtvYGp85dguXfFRyGYomESXZJxuG9LYPaAUWET6cKqenE	3200	4513	4513	1616751540000
6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1508	1021	61	1	5919	jwEUwrV2kKUjNS362YV4apAgnTLYsUHb8LNwgu45thFBEQGwUGS	3167	4466	4466	1616743080000
6106	3NLiLUWmSCyfmV8XPnx46DjsxUecpQHbcx8W4tuW7usRWNEcPjj2	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1631	793	61	1	5921	jwAiuUopWnWA1Q6PybCFW8SbATg9WDCp3GgNmniwtCMT4E58Lk9	3167	4466	4466	1616743080000
6109	3NKsjxH43BFueWrqiezrtF1YMEahftxRufKBtpSfmwZkgjy6b7aY	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1445	480	61	1	5924	jxXmHVA94rHR7tkefHkFA4Vb4BrVEjE2ET99bCJZYw4aGpTuJ4U	3168	4468	4468	1616743440000
6111	3NK5w2CcxPWBRyTMxRVqkZvJerdEDbXjRDuWN43iUZAcFsZtkJjS	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	484	1073	61	1	5926	jwSHebcECvZWNdfsyvw6sjCBvYAJL1GGPP9o8FHznuykuEM82i9	3169	4469	4469	1616743620000
6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	1405	851	61	1	5928	jy2ExYizGHRg7EiziaQQ1tn5ShyLXzGLEZ9uj7ji8DkJicsPXaw	3170	4470	4470	1616743800000
6116	3NLZWWvhtfXhUCCZZ4m5v36hGhWG7K1suH7jLCt1iXmaszfB8Ezc	6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	1407	1395	61	1	5931	jx1b8SXT4PtDFoHDJZcktSTf97J3bN2gLASfLo4NwGqGE7UVZA9	3171	4471	4471	1616743980000
6123	3NLuoxcayj7L1So1WSY23mr8t3UjEKnUNFb2yUhQeaw59ynZnRvW	6122	3NLPgiwcx3uAre2QzAsDFHZx4CgdqGzyP1nXKVbgNhxfbCdpT7JH	1406	1393	62	1	5935	jwHs3fjxZYc7rPgwT5KVNM7zKZ2nUK5hpv4v3ThdgD2UoQUf8QF	3175	4477	4477	1616745060000
6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	1407	1395	62	1	5938	jwLaaow7LtvqirfoVQLn52isd5NsRSPZDKdbVRctZTuEMTSsH1M	3178	4481	4481	1616745780000
6138	3NLsyNydR7u45FqUk5E4zSwgJyrsSwenfgoY7PGnsF47JWgTkSH9	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1460	430	62	1	5949	jwYidiepCgMQAgraZLcCKV2mDVoFDYns8p7PoUuyor2MAMtNvcm	3182	4485	4485	1616746500000
6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	6138	3NLsyNydR7u45FqUk5E4zSwgJyrsSwenfgoY7PGnsF47JWgTkSH9	1546	973	62	1	5950	jxRXiQLicJwPqGh1jXt6pXb7Ejz9Wfkazedau8dAvDuRytK8y3D	3183	4486	4486	1616746680000
6142	3NKSMtyM1WwKR87juXriyLwKencZf6qy5yXmSn5j7dBGuiqfaRkJ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1654	1214	62	1	5953	jwbXBR4Bj3t5VG8Cr9bNTMmrC7f2PKKiVsHGyYbiqgSP2QSZMTT	3184	4487	4487	1616746860000
6148	3NLrV6Wqww94g5MMYfxL2X5fvXaVdN5xNMvA7Ab45EJAEEAFczEP	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1649	1383	56	1	5959	jwScSMAR6SjHPt3Nfq9LyugU8a2eUUvLDGMpdKHNFBPAxp5YC7r	2983	4488	4488	1616747137432
6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	6144	3NL3dDB7KtQwCvYzWk8kZ3RFdtCA3S9cVjd5hxjKFXwpFfsiEJ69	1406	1393	62	1	5961	jxfjFRFpWzwwqaaWdQTbx53f8GddcNut9D6a3uPYi7dxgobveCr	3186	4490	4490	1616747400000
6155	3NLnxXckpkoRHeUg12AWdFUSDih8QuHwe6EN5DY9ihnE7uaGUAxe	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1601	1388	62	1	5966	jxP9uXKZLXF7U5sNKK13HULUhiqwtutVBvp8CsoxVqg61ohzovS	3188	4492	4492	1616747760000
6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	470	1063	62	1	5968	jxnKHT1M2GC3pkF3ysXzY1hsf3Q2bE2TcDr9Y8GpDxtZUPicLZS	3189	4493	4493	1616747940000
6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	1445	1290	62	1	5970	jxNWTLTvj1Fz91MGTQ3hQmiwv8AZr85YaVSWS6WDjvtpe7kqwTY	3190	4494	4494	1616748120000
6162	3NLF5kcYpo3pP1BjPBpz9Uz3Uxuz5vLYTkxf1ZxEA7aqXHBo7GVJ	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	1637	816	62	1	5973	jwD4uUKpGmyZMkxruV76u3w1VBkncepU55kWBmALACYgMjaejXZ	3191	4495	4495	1616748300000
6164	3NKVqtetqjmc3giXAudRUECa4wrh89gLkgWe28csLvoCwSncdKqu	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1634	1331	62	1	5975	jxNskcyAguvEMH9eqbZFXeX8V1bHzBhsmEKJKvUFLw47xMKsKRv	3193	4499	4499	1616749020000
6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1457	1145	62	1	5977	jwi4a9GuyT5Lto6VACwEhGEdDaibibyDAE3nv19Jfk9QVTAH1jo	3193	4499	4499	1616749020000
6169	3NKQmV5xE6DVPkUhFfe1ZNLsF814i9z1JCPXUdRytXoD5KNBGw2D	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1593	284	62	1	5980	jxJZ1km4xRsTuftMi45eLFJg5ZXowAooudKSLkSywhFBjP7Z9tN	3194	4500	4500	1616749200000
6174	3NKsQKM1iy5FsTBT8Wufjb3UE3KyZwkfG9bLqEfzvPmJNKhAMwp2	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1402	874	62	1	5985	jwkSqrNshUs5FcfgCAgZNMEghyLUYrYWtVgi7ZFwAn27Uz2PMES	3197	4506	4506	1616750280000
6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	6173	3NL65NGc3o497zcyaerPCkB5Mu5EkEmD1kqkQwF4jvdu4zR4DLR6	1406	1393	62	1	5987	jwcbHfgs9em8MqQ2TFwkJcYezsQfB5E1Qzpmynjq5EwYVXFcKX8	3198	4507	4507	1616750460000
6177	3NLhi6icuKoSkZgY4LKt4CVYnTLiFQErARW1t5bjrWpcLn35FFpU	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1402	796	62	1	5988	jx478PisjzPiAm2Mc5X7EB5UnBXSGJpKRTjjgGGZ9yTKoEfDgoc	3199	4512	4512	1616751360000
6182	3NKbdbQPjC5XKTnsotKyXWzXvwJrArEHp4kp1W8kEke5bkYCvq25	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1403	824	62	1	5993	jxBHC8UQQPTr1zaM2Q6KmnMxHsMKcANYqi9jBbMb4bx23ep5dD9	3201	4515	4515	1616751900000
6184	3NKh3z3yZRPRXcxd6JhD3CuAQG2GyAkbpwT3bndUKSXiFCJDNCAu	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1631	794	62	1	5995	jxLimnig7keYzHhc9hhEGW8vWyoKE3y6HNknXnuZ1Uk8QxCLmNQ	3201	4515	4515	1616751900000
6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	633	1138	62	1	5942	jxXsAXvg3JgNiWoGVqcRrPRuiYhKZ9Swm25E72w1qi4r8eG38rj	3179	4482	4482	1616745960000
6132	3NLq2J3Z1WVcNaZWg9fveyzDYVBk9mEyqFKyzEM2L4taEmdGgwcp	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	470	1309	62	1	5943	jxJqNgue1krrwoGkLbvzYit9MVj7LYDfTRvpCA3MWJTdFGnuprh	3179	4482	4482	1616745960000
6137	3NKaryGAYrxBqs7jjGMtpA9sJTUFxue3jREpU7e5aftVruLrA2hi	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1406	1393	62	1	5948	jwPtT9VprT2iGMNwEpTUFt2rhZWFQS7e3kbXSNN9xwopU1UZ843	3182	4485	4485	1616746500000
6141	3NKydE1GMF38JSdest46AFg1vKzkF9eZGPDMyH5fGE6yV2TtgVnZ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1522	1322	62	1	5952	jwQdKUabyHZd28xz1VEcJFrm58TvnUNhdK2jh17anjgQqYP7qxa	3184	4487	4487	1616746860000
6143	3NLxKMC3czHUrwseSFGkK2fRGZp4uHHSiDfPq2Y9hxt9EvkzWtaC	5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	1649	1383	55	1	5954	jxUgwjevzY76mim3eZybnrdXW7rGmfVJfDWmtPA8ZYjfWAjzvAn	2924	4488	4488	1616747040000
6145	3NLVzp34jKYpQkjsECHdtE2NUnumhnnWqpYnxcSJgXYVEpQ8A9K8	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	1649	1383	62	1	5956	jwn6e8vRazkdXxwxpi3x7bpBnEAm54KjeGXfyGx2gVEiorCtsrT	3185	4488	4488	1616747040000
6147	3NKQW4aJfhcyz1G63oCniLV11uAtHZ3a8p7MJ37P9rt6yhsGATGw	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	1649	1383	56	1	5958	jwgFgFQPJupZG3zhZff1wHBf5Twjh2Bx9d2mbPAeGxzHLvo7odW	2965	4488	4488	1616747105506
6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	1457	1025	62	1	5963	jwWfK6h4oApNgG62yyh1B4EcDaNMJoHwyMdKX1dabHidQ9rVeZx	3187	4491	4491	1616747580000
6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1402	874	62	1	5965	jxaWbTy5QFehvfFQC1Mq4uefWgRyKirvQMdeVYH5vNKqtVsV4tK	3188	4492	4492	1616747760000
6161	3NLUYo9vkQLk9TYdcKX4J66V5AuqxjLtQAu1cDJMTjfqtP3a4PSd	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	298	1308	62	1	5972	jxCHWREsUqC7dkAWdgsAgQs3585qPh1KxwdQVqLTeU4GWmXDfXn	3191	4495	4495	1616748300000
6165	3NKdVMZpLiRY5msJso3kY2tWfgNXXiE9XvkTxzudHRjZZcvB265P	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1529	1070	62	1	5976	jxG7TEQxyVxEh12EKXWKyNiF6R6YyCrM6YBnoWeYEbKtszpRNa5	3193	4499	4499	1616749020000
6171	3NLqoYtU7MoVbfvYHgyCyfeciNeKcujE3JVrWqWMe9t6AHCpDHV6	6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	1581	778	62	1	5982	jy1ebRFxdAnMF7qSB6kuoXuwibJDy72bjTsAEARm5QuSJXN3Rn5	3195	4501	4501	1616749380000
6175	3NKw8vB1BDLCj3gg2L9pccJyU1o54STgu9dgwzSJhiqhjgoqGRsH	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1657	1098	62	1	5986	jwCDcDZXD3XMQzKrRU3Ye9r5QLjqWXVUuqBvnQJpKewNU7sHpqV	3197	4506	4506	1616750280000
6180	3NLnt7UevN7nnK8u9As5tdb5ZtLZUYu8VdSYZP7FFRhguNj42ajx	6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	1637	816	62	1	5991	jxpb4pgKWxzgeFrCDV8uHYNDBjJZsyowuBdumNeoBTV69GSDzi1	3200	4513	4513	1616751540000
6183	3NKqj26xUC9u1HtGkJrC8f1vc2Zt42B2HFjvPJyfoKp9c2kGYnix	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1406	1393	62	1	5994	jxthSw8feaKBTLRurfnegcn5BUt6umgmYQzc1mmUSfjJGSU2UwU	3201	4515	4515	1616751900000
6185	3NKsTiXcuyQcwxYRHkwUtcSzUpnmTyhXyk6XPuyUFuWyvY4ZtgpH	6183	3NKqj26xUC9u1HtGkJrC8f1vc2Zt42B2HFjvPJyfoKp9c2kGYnix	1406	1393	62	1	5996	jxH3QtnAFWvDP6JMCoGvxha1Tkfr8hqcNyn1qWbrVyt2f1R3Coi	3202	4517	4517	1616752260000
6146	3NLFxQFFMo59BombHrSWjVu8jf7gWyX14B82DVA4XyktcDXtbZj8	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1649	1383	56	1	5957	jxyMmy56JLRxfNKndYHwqVM2nbSFSWgDZoD2nfiPRB3dZKTP5Wf	2945	4488	4488	1616747074125
6151	3NK5kacx2eh1C6gnTcMvbq78jDmQvM9Wbw3E3w9DGAa26cc2zjom	6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	1406	1393	62	1	5962	jwfaTjuLv34JCiNVwVbgT4MAVbkZT9xFMjXSUnDXiSwiBSu9SDm	3187	4491	4491	1616747580000
6153	3NKZu7e7upwUyjYG9aKi3guWXC2HuHi1NvLcrNzsr3yno7cm2zKG	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1407	1395	62	1	5964	jx5Jnju1MGerhdnwT5EV5bw3zGoWtpUZSXf1SRga21Yu46cn8YS	3188	4492	4492	1616747760000
6160	3NKJFLZfW3cdyJXbf9auhC73JgtaoFcnSP7SXMWRtLMMKvtZHfcj	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	311	1061	62	1	5971	jxATQjFQAyEMnyfzGHknqsafVsc3tP3dHZEmpGmxCGHoW651oCK	3191	4495	4495	1616748300000
6167	3NLZq2Gn9raNU6kS2jsLWYKsYKcoEv1sRNUwCsUwREB8SSAZGMB5	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1448	1311	62	1	5978	jwJPEg7tLNmWQsVY8fDYCvyfYLhBVW7ZKCDWr3nyV1m1TfdLpmL	3194	4500	4500	1616749200000
6178	3NLycKT3G2ihshRcLYJjp95cxwEzW2u4JATWTHVDKA4QNZZQomV9	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1656	1343	62	1	5989	jxGFEYSebiHFPorJbsA1Mu7pgwJaGLdKtbNAH2YG7wH81FhjpG1	3199	4512	4512	1616751360000
6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	6185	3NKsTiXcuyQcwxYRHkwUtcSzUpnmTyhXyk6XPuyUFuWyvY4ZtgpH	1397	828	62	1	5997	jxMFTyUDiPUQpXNBanJmP5QyDyoNzqsWMDoUq33LQXmLcfEuxT1	3203	4518	4518	1616752440000
6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	1651	1301	62	1	5998	jxj7tCrMTwspnf6nWVa7K6Atd9tWCXFW2vvQ72mRyWqcKHRxD3J	3204	4519	4519	1616752620000
6188	3NLMoLSWXGGeEq1nAti8JftZ7SoRUL8adv2qesfNAw6BfZJrmrTq	6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	1651	1301	62	1	5998	jxEqoffz1efDmA4S6fSFMcJwFhrVVDmN6ydVpmreEtz5qieU8SC	3204	4519	4519	1616752620000
6189	3NLHmQn4Dv7id1WrC5Sy27qu7pgPcvDtRLn2pZbdXGXXjGiAm9PT	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1403	824	62	1	5999	jwhiXXtqm4aT56SvHetZ1rgTijiPtXFkAWnAbcbqDRrBBSFbtAz	3205	4520	4520	1616752800000
6190	3NK3EQCtEgnJ73C2a2iuqRqJxANBLsWBWR8h3ophTjeZkrHrEnRV	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	42	1115	62	1	6000	jwLDbFT6YqRowLhj3hTBTULHfpFfXeE5apcRozL2Nv8iqwDjjHS	3205	4520	4520	1616752800000
6191	3NKJWdij12jDY6vWQCccMRpEvgx6NpU3g15WVQo8wa776rFJJgb6	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1587	1111	62	1	6001	jxH2WBAui99XrdS5Knfaou1nUCP9aVLFE3hSexg2jxxjirT9aUS	3205	4520	4520	1616752800000
6192	3NL9Km16w9br5pUnE2V7F6VtnEXTGtB8AmQp7vzkRVNvRwroa7r7	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1519	863	62	1	6002	jwxQ8mzqp6ugvJ3FFVXk7WSfcvvp32VSf9HmfodFSSt1DjGqdGE	3205	4520	4520	1616752800000
6193	3NKupsT77bfHR4JE6RCJSTpmW966g4yqqJzpHEvWHaQn3KsD6aa6	6189	3NLHmQn4Dv7id1WrC5Sy27qu7pgPcvDtRLn2pZbdXGXXjGiAm9PT	1573	1192	62	1	6003	jxXGGMzBGWgvpCS4UMSRZGeWWBKKd5TCNzUMPbjQ3wAchx6fVrg	3206	4522	4522	1616753160000
6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	6193	3NKupsT77bfHR4JE6RCJSTpmW966g4yqqJzpHEvWHaQn3KsD6aa6	1402	868	62	1	6004	jwL4xFNp13SPc1i6d21apujiD4LMpLKdcpCujZtCj18H96B19Qo	3207	4523	4523	1616753340000
6195	3NKpzmi7ZoZ9B9h9ESp66gup9nGk2MXSfGXwe4L3x6oVDpht6q5n	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1634	1331	62	1	6005	jxDyxkTwz2f8Fb7C8paPVQgo9wkJhTbmxQ8NMPDXyAXLLQTud2s	3208	4524	4524	1616753520000
6196	3NLpWBDeB8p6sFBWEejktj76MVQunCUwCP9D2rzd2939FpTXhoAe	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jxZMjTzMNrXk2tsK4x9reBG7WvBpzt9wVAjwtH2B3vu9YSZCPfv	3208	4524	4524	1616753520000
6197	3NLBtBrCt4Xun2KXDz5gQNRsH2mKZiUV2Fp3jBveudGXMWgQPA9W	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1421	111	62	1	6007	jx5yKxPdC6ghcB5gz3i1wzuyJGfRoDdf2ueyaPa6tMdGD2eBTKi	3208	4524	4524	1616753520000
6198	3NLd3MXjmWVBBZ3kdK2RpgGMmPbywLPFabYWo7habzA8xdVd9fC7	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jxQwJRAbo69nAgUR48AZkD61BooqN4vmX4t6kWxcK83NS9LeECf	3208	4524	4524	1616753520000
6199	3NLqa4P9HB1jZdvTT4vVgsHbEcpduYn4Lzy3jR8tRTCb2oy3b656	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1673	1242	62	1	6008	jwMeFdXmgWSqFP9M7frJKyfu9iBwUSvEi1qDgeFkQFjiwFftY7A	3208	4524	4524	1616753520000
6200	3NLJrrtZ3zeE8v4Q295SHrEXsRK3RDQCwTYwSGzpRcfJh7sagnSC	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jwZ1MubbhvMHA7MJkjjWyMP9BXvUv17qfaKaoAbJhGW3QQJZyck	3208	4524	4524	1616753520000
6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	6195	3NKpzmi7ZoZ9B9h9ESp66gup9nGk2MXSfGXwe4L3x6oVDpht6q5n	1637	816	62	1	6009	jwrfh1wkfErTDCNvdczrrbNYWMcjQkxKNP1KrBgMyg3hjZWid3n	3209	4525	4525	1616753700000
6202	3NLihPoZnKhpzETxbt9e93Ssta1698uNSw9ASXz8LxmnPZc7PPq2	6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	1406	1393	63	1	6010	jxKToN5VrPwn5k9MJZR1ko5UzbJwNR7aRBb6FpSBMk3nBH52FJi	3210	4526	4526	1616753880000
6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	1522	1196	63	1	6011	jxJX5Pb43i7R3p9vLmFrrSPN3rFR5sYLuUKsLKemvuDLUbJBWBZ	3210	4526	4526	1616753880000
6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	1631	794	63	1	6012	jwfEk185zyp3SKJTTzeD5BYNfzYF6Wmw9LaqFUyWDjFoMZu1Kvv	3211	4527	4527	1616754060000
6205	3NLu2rBtb7MjDHT6Gq7X2LJwszWYffSDPDskW57GpNhkLkEpuTRo	6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	1671	1365	63	1	6013	jw9psr9g1daKipjSWBThvy3JVFNqXSVuxUJVY3dc8T3J7XR1RrS	3211	4529	4529	1616754420000
6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	1406	1393	63	1	6014	jwiA9bqTsgiKVPVwMvtfaP5T5cURMwbGKbtaiiVwiKGXC69HbiS	3212	4529	4529	1616754420000
6207	3NLT1VAQoqDe2pLLrD7P9Hi7Aq75kgYAEy4VtgLNE5tFQEw4thwK	6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	1671	1365	63	1	6015	jwM3KwAxQFbxXkUFt97ATN99k6UcXooVtEi9QmmGqwkQg5DDQtb	3212	4529	4529	1616754420000
6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	1403	780	63	1	6016	jxr58e7Tg1uX3xu6LQ65EgAfRmnNQSqtuvi8PW61yEbY2o9QrX6	3213	4530	4530	1616754600000
6209	3NLWYXZtjXT7Yz7RmJpxtp5NHkzYqAb87gwXMzY6TBgdGJsDSw5V	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1502	128	63	1	6017	jwAZW12mhrGLerbGxNH9erA3yhR3NrKKeukVDrFJwoiyi5Ljkt1	3214	4531	4531	1616754780000
6210	3NKrVTYxBZniaZz4Xr9xdPpucpnEypb4iAMKatM5KhuxNke3iJRo	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1461	1271	63	1	6018	jwKfe4u1sUpd5woHvm3nAJPrtbnnduw3YWEAcz52sgKdcamuPHA	3214	4531	4531	1616754780000
6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1593	1346	63	1	6019	jxDzN8nBziesrUh4HxBry2zFmZzi8nUHLgbNx2RjoqeppguWF2L	3214	4531	4531	1616754780000
6212	3NL4h6cbS1ssVV4DzZvHfJFRdHbHzf7cY3a5Tf8SeB4cTYSuznod	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	1407	1395	63	1	6020	jwpVGSMWmK6kL8Wm7BNpfjeFXaMuxe8iAWwreynnDQxYppPe4ck	3215	4534	4534	1616755320000
6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	1406	1393	63	1	6025	jwK2oXbTv1iniQ73u8btrNqSR7WqU7ZLicAjvnnzZvY6Ls2p5n2	3217	4536	4536	1616755680000
6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	6221	3NLUYA2THAWr5PXPVRW2kBzW4FmjDqvQRvC8PR7WYjeXMWR8bonm	1573	952	63	1	6030	jxwhnaFitcnmy6NcNybPAZEUTpwM82eoY8DPL12tWKmtSv3pHag	3220	4542	4542	1616756760000
6227	3NKobJQ5grPA2UVNjj3N9HaEAe8gmVRHECQqzJHrbi7HcrHNyjkv	6226	3NLa6YwEu7rqZ7XJLhQfJktQpzMLaYPWXY7RpmGhp6jCq6TibnWG	1476	1125	63	1	6035	jwNQ1c2cBuyN6rmJ8DYoQCbjUJP1h72mPqUNy4yxt7jW9opsALG	3222	4545	4545	1616757300000
6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	6227	3NKobJQ5grPA2UVNjj3N9HaEAe8gmVRHECQqzJHrbi7HcrHNyjkv	1406	1393	63	1	6037	jxhydKsFNqVrqR716G3ZHdS1aNkpxey1EhAukt4URJCJ1nW7o2k	3223	4546	4546	1616757480000
6230	3NL2G8EYgZ6tULJGCpu8hKXsd1pGqAN9LE6h5p58t1JDPwm7bFph	6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	1490	1274	63	1	6038	jwm1Nw3h4TGoK4F6VEAyWCB4jdPoyTnkhncmSVPwgyEoV9GbAGa	3224	4549	4549	1616758020000
6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	152	1330	63	1	6043	jxo2SpaiPCyacJYmdT1QVGavdEp88uTjsnk2bZihqoRLEGWJNJw	3226	4552	4552	1616758560000
6238	3NKhE8XhYtQmDWcEcbUYUWF8okxQPFo8Tr1ycCSfys8xZNv1GZFk	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1461	1271	63	1	6046	jwmjFEu8C4CiTDwsXHWb7iHAieRHvtER6fjnD1tpiK4HKdTwGNv	3226	4552	4552	1616758560000
6239	3NLbpifbAikAPt4iWWRhef1i8wMxR2kEB9xYtk6oCar736Zg2GrH	6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	1522	1076	63	1	6047	jxH1apkq4z3jRq4wVY2Mr1kVvBiyzpFjdhLxGBjSkZ62v2yY1f5	3227	4554	4554	1616758920000
6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	1406	1393	63	1	6050	jwg71MG6Vx6W6t6pS8CepyHy531kysd7WN4Cb59C23U5HpGRDfk	3229	4557	4557	1616759460000
6244	3NLqGqRDLireLBAoFa67PV7SFeHJzo7MvQ9tVSLLUvhkWRkW8j7K	6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	1403	824	63	1	6052	jwnB42bwGKsRGoTKxD6LpiJigzdZXobiEkhiEPrqebk22Y3Q68j	3230	4558	4558	1616759640000
6249	3NKHEaELvhymPBWg8nXLewcjrmucBKDt8Zm2ZzPujF2rVSREUB3v	6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	1534	951	63	1	6057	jwQNAgQccDmEitXFXSLAPi7fNB3tkSw4dVdAQP1WpEJp1H1RJPk	3233	4562	4562	1616760360000
6252	3NK8V2QJ2Pjt14xYuDsWLFQoxinArkgsu1AoXRZHcsKyPixjwKKa	6251	3NKZUaAYFzrPTZiumYGY84dVX4jsVA61G8qmXCAeHDJcZ8UpxHmv	1637	816	63	1	6060	jwwYReVmd64WK8JDX5YkeK2V3VyXvucEwUThSGvPAscnPLVADLK	3235	4566	4566	1616761080000
6258	3NLtLEb8Pceehao3YJeCjP4zk7D92k7N3nptGPGU1pu6Hqp9y1EH	6257	3NKugA8UpQbA87FxjYAqk5jfESQMneDzmLZbzP3ptqR7Fiyhrgki	1407	1395	63	1	6066	jwgBYhVMYQTCCi17mH2DUfCB16BGXD8pjXAY5wNsee88d2RrKde	3240	4573	4573	1616762340000
6261	3NKk5qK8beYJfCS6ZCmJLXaUtDNNiYnVEc2Vd3cMSZ4WFss21qD1	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	1460	616	64	1	6069	jx6fAUbhs7xbxU5QDXXKCok1f2UoP2i1R3Gh1DyDJiTSNHy1KDJ	3243	4577	4577	1616763060000
6274	3NKURPbvGFTT9gbCjgLToAq8fBmU7GN2VE1fBc4tajNg1te9734Z	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jxYeSwgiQMHaCNxRTXeJWJd4PiLHJQ6Bbr35Qbt1Q29pWwSqoSJ	3250	4591	4591	1616765580000
6277	3NKm7ekEPMvxQRNm7CU5Tc9jm8Zo8GBeRQTWKjQepX6Ew8uRXFCV	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1596	1117	64	1	6083	jxAxukbJZFifKFzqFQfWYfvAVYnMKuEgyewR1xyy8nzMKRy1nZE	3251	4592	4592	1616765760000
6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	6278	3NLJ81bn2B9hXeTm8TGJhRVCtrHLrRDQCSbnsLCyr4XZ58iNm9XV	1513	1133	64	1	6085	jy1kjdHmoYDacFmLnzMGwjJquYdxdea6k1zUSAHYeexwaC7gUCU	3252	4593	4593	1616765940000
6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	1489	1134	64	1	6092	jwbNFeUnGXAFgagkATZZwfvndqZytbFsKx6aR8ZuxXY9yqyGAAA	3256	4597	4597	1616766660000
6288	3NL2e3MCc9oJxxJsqwxDJuL5arV2PzwJufhVMvdeKH4HMhN8iuAo	6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	563	1113	64	1	6094	jxz3jmVnLPGSskQWSEKJqcHzogHDfGPehrxCEPGpfpVjTkNi7Lv	3257	4598	4598	1616766840000
6291	3NL9cHfehf37ooDABXdyb7GwoiUfmgqazGPMkoc1hp2DiiHsxHya	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1406	1393	64	1	6097	jwz732YGhQHvGzMas5fqy5GKFN6vsctWejGxQezEpfv3ysNVvV8	3260	4602	4602	1616767560000
6294	3NKPaGMMdyTSt6ECSc6q7aTuGMJG2ojrST1YCtWCwpedAzhQ8koS	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1622	1110	64	1	6100	jxXWEmZJ4QkmW1x5Kcy3LLpgJSwZ4qoBCE3wkDTUCsJiBg6W5gW	3260	4602	4602	1616767560000
6298	3NKESUn7TendyB5LA9S9qif8MTcrFFTEJyGhcFBAvNTtiwFYrxmk	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	532	1057	64	1	6104	jwhcfq46M9GE3AEEc4Efndrzrhaez9g3hJYLVKToThiAPvJHw27	3261	4603	4603	1616767740000
6302	3NLUanEiPca63XW1UvFK3eB45nZvujhyGUZFvdqnE8mecP3Y7mnV	6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	1508	1261	64	1	6107	jwtvWGvLjacGYxLWLZYgXmCWs5LiJsFQ9ZicfyCzgWwhHTSRbW3	3262	4604	4604	1616767920000
6304	3NLdmGtD6TyAQcunETS94mRMEvjVVCWoQqGFhe1mJ36k4JVNywLY	6301	3NL9w1fhcCx8FeKTbZzDyAVAwrdtyHHN6Q7uyU5cfjUazVJwbgRB	1483	893	64	1	6109	jxQFRE11XxgaiFuJU9mxRRbJi57F5VX5xEmhXGCg9knr3xigTzC	3263	4606	4606	1616768280000
6307	3NKqRLNyMWmYfzUQeh1MkbCyBjhumHJn4j8np1rb82mvndroSaoq	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1610	1314	64	1	6112	jxoHED9MZstRJh6WANNz7YQujYrRCt7CjxV4MyFJ66hxLu7SK2u	3265	4610	4610	1616769000000
6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	1637	816	64	1	6117	jy3BWmLFBV9fkRBGb3TZ2AYxP7wzMyskuPZ2VZPertXL6tt2zPf	3268	4614	4614	1616769720000
6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	1559	1353	64	1	6120	jwbwUrFNjg2uvqzVFXVuYRDqQSbzJbaa3bXazvBqa1vFicDawpH	3269	4617	4617	1616770260000
6324	3NKr4YZuzZAiiRHcCSh9MzXJptKDMNGdA8cftsxCagaztnDUc1HN	6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	1407	1395	64	1	6129	jwvQt6oxDDSz4XdWh68c6rqQENR3Rd7YHdDFUZRz4YQr2mm4D5v	3273	4621	4621	1616770980000
6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	6324	3NKr4YZuzZAiiRHcCSh9MzXJptKDMNGdA8cftsxCagaztnDUc1HN	1581	778	64	1	6131	jy1tg2QyzwXSszd3hfiYJSTyrJ3c4migJWaDfzGpLWmvzCvuVye	3274	4622	4622	1616771160000
6332	3NKw6Xsg4FnpQjhzvrDe59EYi2YXJTLVN3Fu6DzweLmQCYTSr4Tu	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000
6334	3NLXJvBfepFZZD6RXDGxMNA11df276nqMRRwQAFKMX884cRtVAWn	6303	3NL7o18c4EEHYNgJRF6weVqZqjmLvdokPu4sZ3t2mQX2hPTStQyj	1508	1021	57	1	6137	jxbmfBvSqJho6yJwex6fQwkuq1HUNCt2iomyReaiuTPo7EjaDDf	3014	4629	4629	1616772420000
6213	3NLq2UXzsEF1ZXFbDW5rb3B9ES85T97rYV5NU1t9xWupsYkmEUZf	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	44	1325	63	1	6021	jxw8e6ySK5t9w5kuCWsuSAGKbUextpKdPYGVs3RK4HBuchPzXAn	3215	4534	4534	1616755320000
6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	6213	3NLq2UXzsEF1ZXFbDW5rb3B9ES85T97rYV5NU1t9xWupsYkmEUZf	1402	868	63	1	6023	jxcjLZcVJQsZx2f867C9JfJKTaRMEfowQV9ahMS5honzSurfy4S	3216	4535	4535	1616755500000
6220	3NKj1FHzhNyrjqSNewSGV3Ppax17367FLuHuLj31wViYkBfFiqt7	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1647	1302	63	1	6028	jwFWT7hyPQGAohyjXPTDrmCcnFmSieT78RS1pxrgU3Wg5HaoVqW	3218	4537	4537	1616755860000
6223	3NKowfJcLW1gwKD5YYvJipRWHgqkdvjZg9FJKjcME4sHZgw4X9tb	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1451	1046	63	1	6031	jxtrZ2NH43z2dnQ5FyoXR4CWdCpSR9NkE7aTHpf6QyB1ojKGqGQ	3221	4543	4543	1616756940000
6226	3NLa6YwEu7rqZ7XJLhQfJktQpzMLaYPWXY7RpmGhp6jCq6TibnWG	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	532	1303	63	1	6034	jwRb1nJNg2xtQhWTyFrX5ctGDKHsEMGrDcgJyb6HRQZvC7PHVHz	3221	4543	4543	1616756940000
6236	3NLGy5chJT3ycnUKqDzZokxAKWkQnKRX7X1wh26EpyNmQkSDu8jL	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1407	1395	63	1	6044	jxjcabiNVM6bhkg2Cqk7Ea3NawRX5nw7LvJsrXA9TEkm5jChzxh	3226	4552	4552	1616758560000
6240	3NKdpf6ZLSAhHMvGVYjUYt9KNpWuBi6fxG5wmzGt3iN1pEBXbVwS	6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	1547	1378	63	1	6048	jx3cg1g4KLwc1qjiseWTSbtCitXTADrrHPQmyeoJ5B8tMybJdV2	3227	4554	4554	1616758920000
6243	3NLFyxjdWM6KCVci55dFxGQhXQL4692qsMBfdfutaLtzEewymLdW	6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	1407	1395	63	1	6051	jwkqEJejAXpQFi7upw3h4rT61pnzbW39BCv5EUj7ULxGibR6jQi	3229	4557	4557	1616759460000
6245	3NLQa4xQgwNTryuSrZ6CfLBbn7Ysv3UgEtHK5ZynqRgL4wSHiNiP	6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	1675	1342	63	1	6053	jxbLY9NgzftwpzW5TAXZoHGvrXTX12dfqt7K5tTtJqTJbj45oyf	3230	4558	4558	1616759640000
6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	1402	796	63	1	6055	jx6PgeSVgue7uvSPMvXNBK5METisPiaBjRY8oLAnVtP6wzNPvpz	3232	4560	4560	1616760000000
6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	6252	3NK8V2QJ2Pjt14xYuDsWLFQoxinArkgsu1AoXRZHcsKyPixjwKKa	1588	1026	63	1	6061	jwornGbWD8jPbDoYJDPwUFK3pq37XwUBAYKawC16YqrS16jhT6k	3236	4567	4567	1616761260000
6255	3NLBJU5XRGvCkRKTdRw8MZ4Xat8Q2BoiUW5hS4REXiyuvudWkHhZ	6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	1637	816	63	1	6063	jwn3kjo5kF1AQQVQNdyRU4KzPK51sg47NJpafXrMUmRK95h6eJw	3237	4568	4568	1616761440000
6256	3NKiH5YiyuvanxyGLRTvdGTptSeUHXWU4PQ4KFFHkwFr1vyysw92	6254	3NKipoLQwtimM1T2a6f4bw5o6JjmRK5jYEodXxrpc1F3wUDJRVYj	1647	1302	63	1	6064	jxUR51wPFEA6Hs1zV6ZTzbexHGYHasgzVFLWHPwGqh8hHQ3Dekp	3238	4571	4571	1616761980000
6266	3NLyJrDMgRWccszTzmhmTzsAhjG8zw4C3xZWZcFgG1ehFtW7w5w6	6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	1600	1126	64	1	6074	jxGKZ7BywpwmgqrnoxbeVF9o4Cq2kfyzEKGgYjNQRyzkQjyc382	3245	4580	4580	1616763600000
6269	3NKH2GxSoDe7up3DyDNbKWgV3s8vuLzqmuzgZwNM2ZRvmGn67WXa	6268	3NLqrs4qBxgXm6UKxvjFz3yQd6sf4WKY5BxmvG4yYdN8dsgUqgob	606	1295	64	1	6077	jxZ8e7HKqa6Wi6UHTFqTRGgRpvfQP4Sry41x1BhSTmzYnPWVcs2	3248	4584	4584	1616764320000
6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	6269	3NKH2GxSoDe7up3DyDNbKWgV3s8vuLzqmuzgZwNM2ZRvmGn67WXa	1600	1372	64	1	6078	jxiknmnYppECvpY5AwhptqFGYX2xiAHBzH3hspzrJqYsUCegcoy	3249	4587	4587	1616764860000
6271	3NKFRUjpWFhbEughT3ELfyDvHYeSJ91nRuLUbbSDdYTE3CS2Tvo5	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1403	824	64	1	6079	jxsCAo5Tpe7BnNzLo714vnXbGh6xcwfxSS42VfeT7cDDzeaZQG9	3250	4591	4591	1616765580000
6278	3NLJ81bn2B9hXeTm8TGJhRVCtrHLrRDQCSbnsLCyr4XZ58iNm9XV	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1613	1103	64	1	6084	jxyPAURcZ2fax1tMREL3dDLsevKj48oHwj3DUKuDfDeLMnfiXw5	3251	4592	4592	1616765760000
6284	3NKQQ9a6uitRd3UzW54EXyUDwebsAY8A4dvnmbTgS426PMMe3dre	6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	1581	778	64	1	6090	jwUpKtAoGvgQssgcExKmNcU2iBdddYoS5rzYHsGPgCg1Xpgtd6h	3254	4595	4595	1616766300000
6289	3NLgoT7oLHR2FeRP8ocBzdNDPjqeSfdA5odMax52Cw84Jkifz11r	6288	3NL2e3MCc9oJxxJsqwxDJuL5arV2PzwJufhVMvdeKH4HMhN8iuAo	1527	1167	64	1	6095	jwonAB2dThastGQ1pkxLrERXJrMmL9jgervgTQZprDABexwXz3o	3258	4600	4600	1616767200000
6295	3NLfPm9y4SAf6GBFAebexhjeY3KESZCjNZCdRGxDgVmwNrhzmojg	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1481	790	64	1	6101	jx3goTgwRExkahyb8FNScmJcUoTCGUuu6CcdnFZxUjmcKqpZFPR	3260	4602	4602	1616767560000
6296	3NLRnwSvNdzjAiSVuKUvUaZK8eTaQEDy3wDj4QmtzbFZFmY4FbSz	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1672	1285	64	1	6102	jxCk9PpN855GjnfYisycRBZz5MHs2jKXSDGQWRynxsFKzocHkYC	3261	4603	4603	1616767740000
6299	3NLD2tfEi59PwSn4zgmmcxY8Q6cFbyaGHPFW8znzUsRnnx2RfCVF	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1651	462	64	1	6105	jwZHuEkjq57BW7xWzJ9aUG99vnax4oJYnnig9PYHMy3YY2Y8C6b	3261	4603	4603	1616767740000
6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	6304	3NLdmGtD6TyAQcunETS94mRMEvjVVCWoQqGFhe1mJ36k4JVNywLY	1501	1234	64	1	6110	jx1r6BbnXaZdP2Y2zGG5pCCP59ftBkQ4t5YasfW9eh6bGGsLiwU	3264	4607	4607	1616768460000
6310	3NLMTrfPoMwT7t9wH1qPG94oJYtBS2EAj2UvLngRhBryuxmPrqiB	6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	1421	508	64	1	6115	jxz9QryRphTtbGd2pDffskqBjbbsxEYDLbRSJWVbUsgQKHVKfXC	3266	4611	4611	1616769180000
6318	3NKNA2Mw8yL8HRThYSYa8PoCZaMLp3FDsEwEqT7EZ5nLTySgN18n	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1402	866	64	1	6123	jxyUwhfpkfUq7d14Qs5Aw3sCGw4X9BCRXexxMDR39uLm43nuohS	3271	4619	4619	1616770620000
6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1647	1056	64	1	6125	jwJ8YinRnThTsYNtbvjFNNvDRUPMg3A56r1VbT6Yd5PaeVGzyPf	3271	4619	4619	1616770620000
6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	606	1295	64	1	6127	jwegxMF5omFizfjwNzsVDsnrYgSKuS8GrM4uC3P2ub5joDiK6ZW	3272	4620	4620	1616770800000
6325	3NLFjAX38qaT1CkTx2fTT4QDpaGinDfDpmcK8Ga7r5QMd1H6KMLX	6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	1599	1041	64	1	6130	jwkQaCXwjMAuTcobZGnz1HkaxWtw7XHkFdy2KncH1WhdSPrhnKW	3273	4621	4621	1616770980000
6327	3NKCHwB2g8cZjBzVR8S4YYrzGxoC57ZWW1aBTobE6yKhN8nvmmcR	6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	1406	1393	64	1	6132	jw8wHu9a7MRFVJmkU35zSdTD6HqKaL34wUX9oJHq8HBsg6wAT9E	3275	4623	4623	1616771340000
6329	3NKUn8XQ8tikT5wMr2Vy9yWhUnDwfXjmNMpzxgnbDrkqS5YjLffV	6328	3NKZfnnPHnaT89mYxJcbZwk8G7z3ebNYnypSdPWrE6fE9b8nfabq	1471	1386	64	1	6134	jwm6F3xevxTTk7ckHhRqV9d3x3pwP5j5kEQRUJ76JvrPwDRGvti	3276	4624	4624	1616771520000
6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	6329	3NKUn8XQ8tikT5wMr2Vy9yWhUnDwfXjmNMpzxgnbDrkqS5YjLffV	1593	1220	64	1	6135	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX	3277	4627	4627	1616772060000
6214	3NL42K8WFJwChs38ZJJpyzsFy7bmAe2BCxdddMugw6Vm5otxeiWf	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	1406	1393	63	1	6022	jwhpjdpfaj9qBXoGCLtuyfKBBWUjXduwqocE1s9fiWwBsmoLnf4	3215	4534	4534	1616755320000
6216	3NLvFvriweHZ5aNW4rWJCX4QVHSwzDqTWgZ2K4uVyDWzuruQpvaT	6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	1588	1392	63	1	6024	jwtukdttSxVoHPGxCHhV6EpT8NqF6nkWLLbkovLZ4aqJ8sM59Qq	3217	4536	4536	1616755680000
6219	3NK76z6dLKojDfhCMLDxyw2HBq8WU9Xk9i4DbgEdn7RyTp4q2SG2	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1637	816	63	1	6027	jwZ58hQBHxqmUY5Ru1MeLHwwRxUARshMFy7Z3GYhHbsGaZKctJJ	3218	4537	4537	1616755860000
6221	3NLUYA2THAWr5PXPVRW2kBzW4FmjDqvQRvC8PR7WYjeXMWR8bonm	6220	3NKj1FHzhNyrjqSNewSGV3Ppax17367FLuHuLj31wViYkBfFiqt7	152	1330	63	1	6029	jw7bnL4gPAACQyjEPPpUguhAUS6Nx4QrsGoyWpP3kngX9Lx55od	3219	4540	4540	1616756400000
6225	3NKKcRAP1MFUgZnYPnEW2E3m9GrtMeiMnAH6fhoA3Bfk3iw2JfBK	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1553	776	63	1	6033	jwEtPQHwjWHwRj7KoF4tqcGd19p9rYmC4fKWoaKQjfoPCiyLjob	3221	4543	4543	1616756940000
6232	3NKUMxiy6WnQ7nAsv6NUxELnQn4DHwZC43ZvsUc6KU65kD9SGkus	6105	3NKooPubRhAQbAJbNrXLSoFr5hB1AJrMMMaLbsRbpPSdfM5E6Gpz	1508	1141	57	1	6040	jwpB81CVUXPrZhBKGgoFN1GmYR8tdbpWWpg5ai3wh7LWTnCRMeC	3012	4549	4549	1616758020000
6234	3NLnE5GivKiY2jHxiGyYg8YmmSij7o4n5PrgpBb2hLiSob6fQrMv	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1426	998	63	1	6042	jxvejZUZyEdEvJ1538NGnNw2YsvMhChxtnWCL9cfncASgSZ5ZbZ	3226	4552	4552	1616758560000
6237	3NKqejwQFBhatEkTrVhKiNsC7e2iKZAkRwxkKxGnncJNH16X7pKE	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	42	1361	63	1	6045	jwE7sqFSXXR9m6bfmxfFknJyZpsfTY14kNdrcmung6anLPH9dXg	3226	4552	4552	1616758560000
6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	6239	3NLbpifbAikAPt4iWWRhef1i8wMxR2kEB9xYtk6oCar736Zg2GrH	1675	1096	63	1	6049	jwX17joEsPq9GEvEcSvqWj3yfEZwa1BiaNambkNsjUhU35DsNCH	3228	4555	4555	1616759100000
6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	6244	3NLqGqRDLireLBAoFa67PV7SFeHJzo7MvQ9tVSLLUvhkWRkW8j7K	1439	1033	63	1	6054	jwUmLbFgCB3wwXY6MGVfSTSWhyC2866kJEtb9a74LfzGRsKgxNp	3231	4559	4559	1616759820000
6251	3NKZUaAYFzrPTZiumYGY84dVX4jsVA61G8qmXCAeHDJcZ8UpxHmv	6250	3NLxLnVmPRve3aUVyoNswC9DUoy7dKk4o2HthY4AuKGpntQekL89	1467	1376	63	1	6059	jxT8e4WeUBvV9EGb7SeULwvWKJD6t8VdgNsHxZSNe5gDQnH7t4v	3234	4563	4563	1616760540000
6254	3NKipoLQwtimM1T2a6f4bw5o6JjmRK5jYEodXxrpc1F3wUDJRVYj	6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	1407	1395	63	1	6062	jx57ZPt2dK8Yj9pZe4HiTSzPCkaRni4QuC917h1KfRet7DV5h3N	3237	4568	4568	1616761440000
6257	3NKugA8UpQbA87FxjYAqk5jfESQMneDzmLZbzP3ptqR7Fiyhrgki	6256	3NKiH5YiyuvanxyGLRTvdGTptSeUHXWU4PQ4KFFHkwFr1vyysw92	1610	1314	63	1	6065	jxqP1j5ZhcqKzraYg9ZBMHoYWjryRPvSquucLAn8JQRv8gPsNmL	3239	4572	4572	1616762160000
6263	3NLtuBKXvorwEXai8wszm7zYzNZyUwdd17PFALEns5qn11zqiMac	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	1624	1208	64	1	6071	jwuDTj9KvqzumyFA8i4i5stq9qX7u6XfbTVZ4Uvh2QUGMEf9ytz	3243	4577	4577	1616763060000
6265	3NLE8Ntro9GXDioo8pZcKuZCDNM7fPx3RunzPVWFiBLAkaVaY4kD	6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	1406	1393	64	1	6073	jwHyiF49pAwEddiTp18D46K4eCGajCaDwNy58b5eFzeFopjSVa5	3245	4580	4580	1616763600000
6268	3NLqrs4qBxgXm6UKxvjFz3yQd6sf4WKY5BxmvG4yYdN8dsgUqgob	6267	3NKMAgr6cpWujYXSi2ym643LCjd54qT1eFj3r4ZgvA6SPpwh4cAq	1650	1129	64	1	6076	jxwmLSsbickHhbb7d1YJQJD2291fuuMLx7CckndBGbm5MdbfX1d	3247	4583	4583	1616764140000
6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1405	851	64	1	6081	jwZ1a6qr4j4bwSajQsu5qSZKEAcfe6AxBZBY6h4qxTctNfzZa3y	3250	4591	4591	1616765580000
6275	3NKKzMaKgmJsuv1ZjviE142LzDTrqEdKSbxrH32h3w8by4jcX7s4	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jx14Yv34YEGJJSMxpPguD9b3c6Uyk6unE9HGh5s6bCVHSGe4n5k	3250	4591	4591	1616765580000
6276	3NKqm1YFbn927iZhy7ungobJhp2KoK3z63devVVAdJpLsxpnohBd	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1637	816	64	1	6082	jwobXsNSmNK7pCSJK7nXwMf18dhNoGbVLTjwWX7kcGkqYSRYSXK	3251	4592	4592	1616765760000
6281	3NLHqAunKHx876n2qquFpLCgny7vqUKBccSBpGuvMKqgaAVgyqVa	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	1408	72	64	1	6087	jxxR7fof8ZdXgKKuvFNn8rzMfgLr9JEF2u31rkU6goCDoKaEdwT	3253	4594	4594	1616766120000
6283	3NLtzX33uHP1sWtbfdAu5abe4TonvjcK8ZzrF4ewTNzYu3X1gtpp	6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	1623	830	64	1	6089	jwH66Vhh9poqY3mAywt8RarS7LRRvEUg7ppTvKHJKdEDovvDgCN	3254	4595	4595	1616766300000
6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	6284	3NKQQ9a6uitRd3UzW54EXyUDwebsAY8A4dvnmbTgS426PMMe3dre	1581	778	64	1	6091	jwE3QmadkqsMP1LwfBPh3GqKwyWZhMcGU4BUDNRsoTseZgcVCKz	3255	4596	4596	1616766480000
6293	3NLfWFATazJEgTVjfQHCCvxXVEW1wAhquxu9skxzNFgVMT1QnYx9	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1549	1362	64	1	6099	jwNT31nzJj1WZad3rYha8Tt5njCUWcFTGznXmJoNFNKFZ8CSUGx	3260	4602	4602	1616767560000
6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	311	1307	64	1	6103	jxagwfh35uFgWc1onB5QTeMF7PE3nFXVa7a4Se7ChTXTS1NjD5p	3261	4603	4603	1616767740000
6301	3NL9w1fhcCx8FeKTbZzDyAVAwrdtyHHN6Q7uyU5cfjUazVJwbgRB	6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	684	1226	64	1	6106	jwmkhG4w4TLpR3qWQGtmP53cTK5H93gFGnnLw1U6EPe6B8LnXjq	3262	4604	4604	1616767920000
6303	3NL7o18c4EEHYNgJRF6weVqZqjmLvdokPu4sZ3t2mQX2hPTStQyj	6232	3NKUMxiy6WnQ7nAsv6NUxELnQn4DHwZC43ZvsUc6KU65kD9SGkus	1508	1261	57	1	6108	jwr2y4G8bS1EeP42DMgsnxC8yVrKy3pXgZeLsCHEsYDdr9RA28N	3013	4604	4604	1616767920000
6309	3NK32NmdQyi5NLuqnpgph2yuEAJVHxwyhCCiyLj4AehTrUZi5qap	6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	152	1084	64	1	6114	jxt3mt8YvuaSx5cnQjDbiCdGuJwmwzqVUThEd2cHBybjNGwjTyw	3266	4611	4611	1616769180000
6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	1407	1395	64	1	6122	jxjvF4iBE9R94rqUHYooXmGgZG8UENFCGXDYGdn5ebDCPbSVP3b	3270	4618	4618	1616770440000
6321	3NLVqEFpG7LjdZbcCtCiaH9vJpXVviAVy2eoRsW5E6NwyeZDxxfQ	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	1455	1332	64	1	6126	jxFLDg5D7YWXgP1r7cz7F4stYvrgWLz4Yr7GNuDM77rN3L7Ht8G	3272	4620	4620	1616770800000
6328	3NKZfnnPHnaT89mYxJcbZwk8G7z3ebNYnypSdPWrE6fE9b8nfabq	6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	532	937	64	1	6133	jwMAjXRRWxVsH65eyeMnDq5NmZfpvEdXMARdbrtwxEXgkyqAAo7	3275	4623	4623	1616771340000
6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000
6336	3NLKiV6LiXhtZnn8tiYM2sB4rGUwnrRChWCCABYjAXWbqXhbaTSe	6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	1508	1021	65	1	6139	jwPX9PHfZa4cWt2z5yecwqXKLTxBjsC6o7x2495soje3JhbxwwB	3279	4629	4629	1616772420000
6218	3NLTsf7MBcRjKun66RYR7ufhgnCDxDdMgmAAnMB1Y6b9UKx7BXcg	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1490	908	63	1	6026	jxKC9gBj6jMVWQ9ipzd3H3z5sr7FSP3ygGPeU1UoVZscZtN55tw	3218	4537	4537	1616755860000
6224	3NLdoAKoa4NsYaDMVtrvcihyg9w77s2o9FBTpWnwjqyBhkkGBaDB	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1471	1386	63	1	6032	jxMp5ZAQdTDFNbBs7XSZ1Vkf9veF8bP6p3Ue1EKrmyVGb75nQ8K	3221	4543	4543	1616756940000
6228	3NLXsYLKC5kB38wdemjhQPkJWPz4EtDfwXnFgFb6uzKW5jk7roQC	6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	1476	1125	63	1	6036	jwYgRVC5WJ73YpP2jx7rMCppF351drVWdWtGzYbc3NaQmRQ2orf	3213	4545	4545	1616757300000
6231	3NKT53dW5EnfEzKyKU6hEtuTivm62BRsihAxZtSAPWGftJyYngGC	6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	1508	1141	63	1	6039	jwju4JnLz8NQfXzn1i1Heie2A9sz9YMiogLcpt9jTDV1fyitrFo	3224	4549	4549	1616758020000
6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	6231	3NKT53dW5EnfEzKyKU6hEtuTivm62BRsihAxZtSAPWGftJyYngGC	1657	1344	63	1	6041	jx51HBUg5jASETMbrUiBdTeja6pWJ8Hq1wSK3rU6FZ8X3rZMEx9	3225	4550	4550	1616758200000
6248	3NKQmbFGAARvVEx82wp8AYd83hyJMPriAtWMf7PfH1LqDxxd4yhn	6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	1553	776	63	1	6056	jxA8kqKKkvRow2q2LxLGDJk397QYF9zXPQy3SmEGNsphGZuWEf5	3232	4560	4560	1616760000000
6250	3NLxLnVmPRve3aUVyoNswC9DUoy7dKk4o2HthY4AuKGpntQekL89	6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	1657	1344	63	1	6058	jxio5C129tFg1vh6sPM6CJJCBiTKFtsRF3Be2nBmiUnQBE8xBV9	3233	4562	4562	1616760360000
6259	3NKNkU11pDfa89uDikkbyUke4uWnFgMsYU1MENHHWheYsSKNxF3c	6258	3NLtLEb8Pceehao3YJeCjP4zk7D92k7N3nptGPGU1pu6Hqp9y1EH	1457	1391	63	1	6067	jwx6Y6HDHEauayx1NHw2zL3ZSMXgVLTd2xjrDfLVrPYK57C7H56	3241	4574	4574	1616762520000
6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	6259	3NKNkU11pDfa89uDikkbyUke4uWnFgMsYU1MENHHWheYsSKNxF3c	1631	794	64	1	6068	jxrEW7R6bBcHm9F3peLqNZAeQt5P6SXHWXmuyUeTqMwsDt8Bfsb	3242	4576	4576	1616762880000
6262	3NLH6i2zgRBdFfnHRSHgJYiwgcoLCuNgcsPJR4Z8GvpyEqPatb59	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	43	1310	64	1	6070	jwhSE4BGqyrMcopSzD76eAvNUgGtQqGTgqWW2rc11ZXb7bEGn21	3243	4577	4577	1616763060000
6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	6261	3NKk5qK8beYJfCS6ZCmJLXaUtDNNiYnVEc2Vd3cMSZ4WFss21qD1	1596	1117	64	1	6072	jx8J132pwD4jxQSGDYgF5iedLgy5kNSZq94iJH7bxvdf2VUtphF	3244	4578	4578	1616763240000
6267	3NKMAgr6cpWujYXSi2ym643LCjd54qT1eFj3r4ZgvA6SPpwh4cAq	6266	3NLyJrDMgRWccszTzmhmTzsAhjG8zw4C3xZWZcFgG1ehFtW7w5w6	1407	1395	64	1	6075	jxdD3H6VZp3SLpZ5rSy8oCcZnSK2Yp9jbwZS2nE4sfE4VmRWyKH	3246	4581	4581	1616763780000
6272	3NL2HmjtpaJY7UEzNHz87MfcmU1nTwHhTkxPD6e4z8TPZbu52rPF	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jx5YHorGuzqykzBM8ByXrrgZrwMDuX7oT4GGbtNGyStZQgH9cAY	3250	4591	4591	1616765580000
6280	3NLkqoMgguYpkTK5hpUk4RfzVoQsVUyGiaRCgSVrq5EuXqLg36qD	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	58	1155	64	1	6086	jwT71e2VTRxxgcbU5D81B54do2Yu88eqiuQ2np9ehxb3yNN1zUS	3253	4594	4594	1616766120000
6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	171	1008	64	1	6088	jxTjADw2FueGhEaufVap8zDX4K1egaGUobY3MfvKGuvaDjfDSD2	3253	4594	4594	1616766120000
6287	3NLDAk6KpPiGLqWgyqbticFheVtJqFK6pqWtz59zhipQDfTbpN1K	6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	1536	1067	64	1	6093	jw6dyQqay1JcHv5M55kYRvzVtso9o8VBPsFDmK4BiK3YtDpD1WD	3257	4598	4598	1616766840000
6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	6289	3NLgoT7oLHR2FeRP8ocBzdNDPjqeSfdA5odMax52Cw84Jkifz11r	1671	1119	64	1	6096	jwu8fW52oRwGVJAC6ZGDBEXp57gjCKAuMeYfDu6rpgTSFdXEi4u	3259	4601	4601	1616767380000
6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1657	1344	64	1	6098	jwkhiwN6z8r1oUvxq7xPYcDMkpgbGq6KMupGpp6KRhdmbRNrYBD	3260	4602	4602	1616767560000
6300	3NL6rAuNydge9isFNSAWWsJJeWnhGXJh8pTnLQA9hobn2pphveNF	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1651	462	64	1	6105	jx3dnjoCgiFWqya3jzDs911SGhBUmgnaaonPhoCHPQR8LwXPqpE	3261	4603	4603	1616767740000
6306	3NK4nGJUXe4aJoNgEqDqWJvaPr9gKSSo1Rx8PRKnwJJprVzH7hfs	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1649	1137	64	1	6111	jxKFSdRARpfiMLNaGgcSb4VRTYHBGgYSWcYZvdg1JCVzTsfVCy5	3265	4610	4610	1616769000000
6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1601	1388	64	1	6113	jxMKGPmmo51t2CKaQb6Z2hPVur17WeRCvBsHMverjjgqdDDA9bV	3265	4610	4610	1616769000000
6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	6310	3NLMTrfPoMwT7t9wH1qPG94oJYtBS2EAj2UvLngRhBryuxmPrqiB	1555	981	64	1	6116	jxKXDNHzHWwyd6J6YoJncELZVm2Vg9CxVCCV8pRNGk4QEKL8g6K	3267	4613	4613	1616769540000
6313	3NLf7wvJNKoYAMTV7wXDi8Kd5EtKenQWhJ4uf51cuoEvTQeqEBsG	6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	1457	1265	64	1	6118	jwftoDDhyH3pFNeCQ8dTdstqvQ3K1ZJFzSKWqbiJHoZ2E1N5psH	3268	4614	4614	1616769720000
6314	3NLDfiNM1pZ3Mq1jDJr9tH4HLHxaLoz6fvxSfH3myti29cQBhR6m	6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	80	1147	64	1	6119	jxN4M4qzHfwWhm6d2T77GP62N4DCiZedqg1RN8ARXdwhFPv9iZc	3269	4617	4617	1616770260000
6316	3NL2zjmwdaGWsyTxzP5FCMcnPaVoeozV1e6Kozef24VK74XwYEgL	6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	58	915	64	1	6121	jxCiHvBGkaRTvgk5dTch5g9Sw8BSqU75BsQDAE1XTuHEchC7wCp	3270	4618	4618	1616770440000
6319	3NKuaodK7zqCuYvCcsb5Sz1DcFsS7z5CRN1nzxpJhG1jgjpgb36H	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1407	1395	64	1	6124	jwyvW49uaADYbac8shbw37My5HRZnKMLRcUCSL3jJZCBnkNZ4up	3271	4619	4619	1616770620000
6323	3NLLajeEaRLKEVcCJQQULpUizYRSFwhEBru2HceyPgphit6KRxR4	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	1631	794	64	1	6128	jwCHdnaTBEvikpJrmSTTKCdv5cQb56LwDN3YJg8MFBux6sdhNB4	3272	4620	4620	1616770800000
6333	3NLmEajeDYvZGu8DDzLRjFtJsuJNMhLeVNM7p2Sg3uWRyYjQNDxa	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000
6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	6336	3NLKiV6LiXhtZnn8tiYM2sB4rGUwnrRChWCCABYjAXWbqXhbaTSe	1405	867	65	1	6140	jwajgjK9U7mvsdmK4MEGR4kMQHWTBXE5utmAkTVtSGboc95J1fC	3280	4630	4630	1616772600000
6344	3NLHQaz9B9Zy81YbcVkZLiGQ7JtwMiewdVfF83za4DHuyKSkqi6B	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1599	1161	65	1	6147	jxwBBNQkHzDGwTLPn6iL1Zm1nHbZy1XfBVyyDHXTfYFw3uZv3iP	3284	4635	4635	1616773500000
6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1527	1293	65	1	6150	jwdnJbT7h8yxdhrwhFe7CG1oHu9e13UGshjmdVgaEGrk4g1zybo	3284	4635	4635	1616773500000
6348	3NKHAPozXQXFkzKF5t32vUAmwjDckE5w155PJ9nPNWS6gFHWRjLr	6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	1649	1017	65	1	6151	jwdBbgbQYDYKnhDzxKA8h9H8MjQtiTPtGEjmz6NHxrGLWjVVppe	3285	4636	4636	1616773680000
6335	3NKSojAEeb3S8oH2tHP3ohA1G513uUgGH6vtfGpEdueQa1w2pEbM	6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	1594	1326	65	1	6138	jxYmMYhkZ945FUidNnB1oQffqXU9y48m8fXAbR5VWVbpELLdjt2	3279	4629	4629	1616772420000
6339	3NLr2JZAPqhFMV9NG6oJafBPTa5ZJmp4k2kiRWA5ZpoSyJQRB6yQ	5876	3NLRwcHjQK75mTPMJ1FL4hNymVpVSYxVwqPYnfQZ4TzBS6Ktzyqh	1571	1335	58	1	6142	jxauTf5eAhu8cb2VazFgv7wDbHWh2oEkzjNZJdTAjecSNeWXnad	3048	4632	4632	1616772960000
6341	3NLUwUCu9jA9ASNY2RutucRNHZyjXMpGLLi5AqfGW4kiUJbznMS5	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	152	964	65	1	6144	jwFE1hmutTaHK19oXJKxscARnCqQs7wju4NZQVbipcYvqsmpE2C	3282	4633	4633	1616773140000
6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	6341	3NLUwUCu9jA9ASNY2RutucRNHZyjXMpGLLi5AqfGW4kiUJbznMS5	1553	776	65	1	6146	jxwSjUFGnhXU3zNwvRuJuhsFjHvFViJWtgt98p7BCHNJdUyRsMw	3283	4634	4634	1616773320000
6346	3NLf65X5WP51esqP2BythGUQgJm7WQiq4n6vo5SoiXYNNjgqpgvP	6339	3NLr2JZAPqhFMV9NG6oJafBPTa5ZJmp4k2kiRWA5ZpoSyJQRB6yQ	1571	1089	59	1	6149	jx7D9BYBM23WF2r4txdMmz9n3cm97BR65iTHDELiuvYuj8Xaf4V	3049	4635	4635	1616773500000
6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	6348	3NKHAPozXQXFkzKF5t32vUAmwjDckE5w155PJ9nPNWS6gFHWRjLr	1406	1393	65	1	6153	jxnABpeWf55w37ZKvXw3EsXgnnZfbeUTKkcbRdnphtqeyv3CejX	3286	4637	4637	1616773860000
6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	412	412	65	1	6167	jxLTD3xEVBw3fDcxtXt7C6swPVDkKj7VyNA5EMocxndbePUgkpR	3295	4652	4652	1616776560000
6368	3NKzGiDHFi1b1hiAaAQPrwXujiLGppQagRW5bXBQgxQxkmsnQCD7	6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	1585	1366	65	1	6171	jwZeZjrSiqBiqtC1TtNvXhX2KpRhKTYyJQeCMYpFGDN1L6LCECr	3297	4654	4654	1616776920000
6372	3NKVwodYDAMxaVH1df7iTchwkis6joEAJ2Bg6DrE95jdQLLnryCm	6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	44	959	65	1	6175	jxr3jB54pv3LDVgfdoCSkS1FVTUqm6joqUVsXjYpox1gk2HgKdX	3301	4662	4662	1616778360000
6375	3NKbwQGyne9F1w8efMy1Nu44EhmwALuu2tBszDMwoB7yZgZEGSCk	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1407	1395	65	1	6178	jwqpp1ow9QMxCq7gmeeAZD5n163H88BDj73GidEMWmbzCFfhJYL	3302	4663	4663	1616778540000
6379	3NLfNtEVDx7iuJ9YaWdaKNp1vwhXisC2Cj4rTo2meXpTkAgL3D1F	6378	3NLgFMh2KVL9gDnrUs7aM65oFhMSv69P5KmuMuC3dZe447DJ1A5V	1547	1132	65	1	6182	jx3WAXd7vdNPpAMannGNNNVf4ynijMjRJpbqZ1XJBRXAAXsGWR4	3304	4665	4665	1616778900000
6382	3NK7EumQGkB1bRDVG52NaFr2515qQkYcYz1tqQj7aMoR2y5zEzQK	6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	1406	1393	65	1	6185	jxMZLVDiXFTt8pAjeWboKsBeFVd3xEhGY2W1v6ER98HUHueidKv	3307	4669	4669	1616779620000
6384	3NL2ENq5HELiQVVM4Kv3QKu7THgPKCp2RHJqeHRnFQEk2pTzoRyZ	6383	3NL6cx1nTxPBEnoCciFXmDgfQQZdHsXqnmcXhrEkUrzzi5ACRFvB	1406	1393	65	1	6187	jwUGhAVj3sZVM9szvmL1RdwTPLo5qnRMkQsJTi2if1GBMVa1JPM	3308	4670	4670	1616779800000
6387	3NKsj15GhafVbCGAFpzzAMEkbWxW8oKS3G7AJE2dNemT579SAMPR	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1481	790	65	1	6190	jxm9ncDK6x64dDwn6Yh4Erk4iqJbFsT9G4PMwfjDYxSLk2VK3Y4	3310	4672	4672	1616780160000
6392	3NLVAd5CZcLVjdGPMdgyqzRW9U49DQgEHkeNDasi1KdNbrLpLGeW	6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	1513	1253	65	1	6195	jwMGMccqmYEre13sZwxZqDY7UYtEzgPQe5DR3KyQd3j39bcGwfC	3313	4676	4676	1616780880000
6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	1553	775	65	1	6197	jxzUuDpsXu6gSn9M59YAmKGLvSfcT33aKSPy3dH1Ef6bxXdoY4U	3314	4678	4678	1616781240000
6397	3NLhExvvzPizB6Eqk5jmQYH71uidc4PSSNwkRHv5jd87ByXJE88V	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	42	1361	65	1	6200	jxDxnH4FwPDYfDcvScAuf86GjAe6K45zskmhV9VcKaa2VmsudYm	3315	4680	4680	1616781600000
6399	3NK4jMx1DVjpbgp4n5ekfxRYZkWZ4tLUz4Djy9WJmS529iyzSJTV	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	606	1295	66	1	6202	jwWz6WZYAnNFF88qAR64r23zGYGZcPD7F884yGooH8WfeBQbgHn	3316	4681	4681	1616781780000
6401	3NLXG82GPkhHUiEM4GGrfcyqsUMvghPN2jK4swDrkDgAmK4xYdWn	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	1631	793	65	1	6203	jwsLZRThav7AEPJkgRLfqEVAgHxPespbbr7xPmusLHF9cpgZLnR	3316	4681	4681	1616781780000
6408	3NK7e1HGsBahfhLhdKLQ7CGzxbfZjYETm8xRVQ2zv79MPY8v44zZ	6407	3NK4KQrz4GSvPAQVDiekkvqjuiPqEnc7UgrU6agVgsHP35xsKeCs	1405	851	66	1	6210	jwSV8AFdT1zfMVsAFG6cMzknynN144ghGnLoxnGzwKCwUYuBvxw	3320	4693	4693	1616783940000
6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	1500	1297	66	1	6213	jwXpnC4RiybRL67xJabvksxn8MB3Ra5JcRMQZV8XrS7qFT7oQHZ	3323	4698	4698	1616784840000
6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jwicu91aW8UBt7umQN3WYmCa745srJ5Kga7ou7oVDJ3vDMkUPvV	3324	4701	4701	1616785380000
6418	3NLQ1BgsVDvThLDNjerSaDahXicoE1goSxznpF6cmQgazmFtikJq	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1407	1395	66	1	6218	jx65heeoDg9WXLy11ptGz5rRzjTJSbM1nWfMiQtEuzmP6VDS5HT	3325	4702	4702	1616785560000
6427	3NKcqEiLCPLsJbrsJyX61icTcpMhsV7yRjvG4T6ngVb1GyMAyLga	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1403	824	66	1	6227	jwNBx7itpvXdyQMGLP4JsEWN2kopKmujvfSbUCJCFJrwbJ6NehJ	3328	4706	4706	1616786280000
6430	3NLrRjtUiQLSXz9ur1ZcmCmexgyXPGMoTpGE6DaJ2rHUx219oEh5	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1555	1347	66	1	6230	jx4YexZ5bRtpPLbfghnzPvgKyewDpeDDiKNBKNhUrvE8oGDcbEN	3328	4706	4706	1616786280000
6436	3NL8biycUsRsegVGiyMH34BkjrkQrT9Ckjh3Ax4K1LiJ44WkKjUf	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	596	1306	66	1	6236	jx9Rm8Kf7GFriGwnBdWrwoHLnexyAWN3c1VdYmuZMWBgktqGQCz	3331	4709	4709	1616786820000
6442	3NLw2cuKR6f4V2VaaZR35Lsqv8TXTEApz8H9p2SQdR8NmEAJq6qm	6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	1637	816	66	1	6242	jxCUCCSL4Sgg1UtE4R6W8GTZpR3uDuNF8Mzx46uPpuBEb28Pefs	3334	4716	4716	1616788080000
6444	3NLxCMTBhDsww6PD8AjFo5LxFp1uZJqycM691YYzy3SniSf1qguk	6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	1406	1393	66	1	6244	jxKB2QwUbKqW3pmzQBgargMqhAq9h3haXFrKXg3GSfXMztYkmAu	3335	4717	4717	1616788260000
6446	3NK9Fjao522VceumzpUM4hKgKSdgzeKGaVvFnh7ccxDFeX83iQWG	6444	3NLxCMTBhDsww6PD8AjFo5LxFp1uZJqycM691YYzy3SniSf1qguk	1671	1365	66	1	6246	jwjhjjUZ2yKwmLz1gwxR5oqvPd4JDri9w5wwEEbUoszpYDLL7Tt	3336	4718	4718	1616788440000
6449	3NLjoypzBkM1qVPMCrJRy54AqmCzt4Q3qTQmcWzU2GhVdjR3q63Q	6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	1406	1393	66	1	6249	jxhN9xLWVNqBNgynQB1gmGF3Qc9pxnnYChMVc5iiDDed1VZDSNx	3338	4720	4720	1616788800000
6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	6450	3NL3uksTUWALckWZFUtvfhhY4To8HXVrS6TYpf23GhBD2X9vdqD7	1631	794	66	1	6251	jxjT8iaeiXXDVGHDqN35r6aBpjwmwtqrW8jPciyKm7HW13mQ1yp	3340	4722	4722	1616789160000
6456	3NK5FSZHUwoqdCMnPr4fyguQsrqHnFwHpo94jfFYuF8dNMgoNUtu	6455	3NLZ3p2nYjGkqP8sGTbX3w9fF2EGW84rmx8SU5ha2Fw3h1vrRS6V	1600	1126	67	1	6256	jwzChjtirvLunPE2HFk7LRvB1kEmKpaSV2upWFQTyFnn93PXgXD	3344	4726	4726	1616789880000
6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	1406	1393	65	1	6141	jxTqGHrD48dnfaocW8fdpYJLnFoDtvUmEGtbvn78krDoD68JHR3	3281	4632	4632	1616772960000
6340	3NLHDAdUKj5wNmXGruPpRxAwTbdjMvTVJwupFogeYzPCuPSFkX3A	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	1654	974	65	1	6143	jwobhtifbVEUHy2zsaVMsWLSPr5dhHL9hEMRztXo3E8bPzs7Z1i	3282	4633	4633	1616773140000
6342	3NKoNHLpEnN8umcPCyNjhUEvMTRTF5f1CQSVGnBwNV6zf67V42o2	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	1631	794	65	1	6145	jwirejEpLNTS5fYv4HJfDNhCVYoPyUCkh6LCXVvz17c8mV7a3pd	3282	4633	4633	1616773140000
6349	3NLN932n5Jy3a63wJUm6tB4MvBB5ncSCfvprkUGRRGChMNJqGXdw	6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	1403	824	65	1	6152	jxnAVWsSik9vPZmN5v3F4BsqWck7Uk7wX4E2KwtZxMEZk9DzFuW	3285	4636	4636	1616773680000
6354	3NKMQ3br4rDMGSevqrB6bDt5EzPxXjihKFzVxDy9YK2Lk22TCbQP	6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	1516	1048	65	1	6157	jwBLbTsbyKU9cJcNPuVCRJFFv66XTgLzcnmrnfHgnrCFeBZnHsK	3288	4642	4642	1616774760000
6357	3NLTxYGZxrzen5GHAqHmo3ao656GS7XdCCiZBv6kzaGcz7TKGNqn	6356	3NKVxKJ1exsW6prJKp3GyKSTPWExMVCUF8Boy69HzEb6m2h5HYmK	1406	1393	65	1	6160	jx6bWrqvaa4wcJsfzjWPR8Zf8qbd3M4bC28z24gDomC3jyz3Q4n	3290	4645	4645	1616775300000
6360	3NKUPPTYRsf5fwTbXmTHH2aNhPMDE1ZCG3W5fLrHQrZtWd8w78Wp	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	676	676	62	1	6163	jxv3fHxPmAcNi7foTP4WwFHJi9eKnsXT3mTYfcz93KSFnG8mMLz	3185	4650	4650	1616776200000
6365	3NL8s46fo2ERGk2PVJMxSjdHSa6QMJaSBUQzax6Uyv3M7EY91HNa	6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	1426	1118	65	1	6168	jw7DF1PQE8uGsGN7q7W4PTNunLqzBuwdjFMXhDuhWL8ZRVGKPfC	3296	4653	4653	1616776740000
6367	3NKFEpkB1QAL4p1HxkFmVHBB673mMdD3qeDQSUKwnnpaCFbZcm6i	6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	1501	1114	65	1	6170	jxuPNEMsbuDygUSdgYgV396PJGR47FXqu1q1zhXn5ZNvcVqcxph	3297	4654	4654	1616776920000
6370	3NKUaJkcN94jF1EPNovfriCYHfof6sRV9WDp8ZDY4zkQ74e7eFdN	6369	3NLLHq2AUaSbv91ZEqgSmu8Jmp1exjfy8SkCjRJHNQJH1bz9xcNu	1406	1393	65	1	6173	jxhwMxjiCvPqsWSfx6ZzpQ5ViVoUrrBZPrUHYnW4c1tP9E5ieGU	3299	4658	4658	1616777640000
6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	1534	1317	65	1	6176	jwhYzwRaVW9tpBS7r2ugvfTMxWbie2y4vtk6wQCEBWVMZKJCmfh	3301	4662	4662	1616778360000
6383	3NL6cx1nTxPBEnoCciFXmDgfQQZdHsXqnmcXhrEkUrzzi5ACRFvB	6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	96	96	65	1	6186	jwnTXyFwojbiM4sckwJKbKAkYNtmcR5MDGEzXKMkZnYySWFEjHK	3307	4669	4669	1616779620000
6388	3NLRAuRz2CLxFdVH5Ck4g2tYivvHhsykuAMMSUnsgVWk8FzDp3iD	6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	1447	1345	65	1	6191	jwtLpXAdgotKg8kXob873dSjRsDsjFz9rVp33M4pcAhtmgXsNFc	3311	4674	4674	1616780520000
6393	3NKjCUB7DasgEJ3bhVjm2FzVs8bx61NpFCgcbby3mExNrFPS8yDA	6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	1406	1393	65	1	6196	jwjBXVuvCk22b5G2gF8J8BwT3mhNXov1gn8a3ozBfijY2tzKuhi	3314	4678	4678	1616781240000
6396	3NK3UT4FEBbYCr24pqRgTVbHqNv2DUMUr1zc4ay9KRg1Pnq83quM	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1673	1368	65	1	6199	jwEn2UzRq2QkSLjA7tGYhcbLFdkzqZEpYCRhoMoKq9LgwDiebDc	3315	4680	4680	1616781600000
6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	6401	3NLXG82GPkhHUiEM4GGrfcyqsUMvghPN2jK4swDrkDgAmK4xYdWn	1407	1395	66	1	6204	jxp2jQCJ4ZCk7iAhVTpfvQimYjQDryoL8SRLVsGCWkHTcMfWUyu	3317	4682	4682	1616781960000
6403	3NK3aE335M6PusBV89k5hqPvfuvjhHdzkBwQVxnKWnmfbLwjdjWV	6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	1406	1393	66	1	6205	jwSeSWCiV3akayddR7MkxFtD2d3Xu7EVEx49NT2FksB1ti49brN	3318	4686	4686	1616782680000
6406	3NLpzR6iXKeEQ7djrof973yb1BvGv4WXQizTMvxquC2CtNSA2a9d	6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	1403	824	66	1	6208	jwQtrYJzy9upPV3NoXRxTokodDmnbtNe2JdbQzxoH13PG9wDf8K	3319	4689	4689	1616783220000
6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	6409	3NL6prPAFwZWBhSaAxSBVtna1xGjrK6GyX4KvEqrGXMvFCofz7jh	1403	824	66	1	6212	jwcCjnqr5BfMXb54upavQ4FuLadKKEqpZU2PSM4NV7MUwb517wz	3322	4697	4697	1616784660000
6413	3NKicyqi4nsgbmiDjLGxk8ZjkeugbiuSYUyQei4TVwpU3oVKyxgJ	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jwqT6AVLNLAcrdzjXBknvZkKRWz8sZm68rCY9hhr9NEtry3Xx1r	3324	4701	4701	1616785380000
6417	3NLNV8rJGFdyrqustBE8XJC7Bw8JgQGAtnsNoq8iz9P1pYXn6fvd	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1619	1149	66	1	6217	jwwERNzktLq8ZqAYQPjevfXAL1zVbUe7n7dc5Uf1sdwB6cHj4Re	3325	4702	4702	1616785560000
6424	3NKiBRjw7454pd7kRe8f3YiQouMG7LNt3pDfYBj2dbHce3ZTsAgV	6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	1406	1393	66	1	6224	jwzYAANH5Q2QJKFMkL8cRNEYGFqUUZhWRyEwYWXtxeoB5bC5Lxq	3326	4703	4703	1616785740000
6426	3NLk2a63Z3WnfxKaL92EZqt6xxyr5KDjrVHuLAhcSSGfRsQrsdxj	6405	3NLQyLeFAzx4RGFCJi5de8wvUnqNbPdRtdyEvvuJsYZBXmnRGnnv	1623	830	65	1	6226	jxJ2mFAP2Z6fBC9rSRFmNh8TZcXgaTDHS5BHCaF2mL78hpHaFtj	3282	4704	4704	1616785920000
6429	3NLby4XZjRAfa5P6pddydtuAWHnRKvDzaZhWD2zeeKTzbUFtMFcr	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	700	832	66	1	6229	jxr5u1AhHKpPgr7Z9m6GtGwx9pn8i8YDbF7Gxt5JynTgoRRps2p	3328	4706	4706	1616786280000
6438	3NKUbCCkGUoJu7hERWcxpf3YyD9pNRrovFN56ZWwtW7S9bLzSidL	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	700	840	66	1	6238	jxNUmJZd2ga3ruP3QvxvoqPGGWhkgnNWRTLpdGqFnArUByiXjFi	3331	4709	4709	1616786820000
6450	3NL3uksTUWALckWZFUtvfhhY4To8HXVrS6TYpf23GhBD2X9vdqD7	6448	3NKjGB4JbV6StiYs6YNSGr3vcTEfmubkZBjQfqeAJzUPtVk69zdG	1477	1350	66	1	6250	jxkiiTuWLy1fEKe6rnj3rkqnbZM7KLnSSr33UXeH53YiZ8M2TKe	3339	4721	4721	1616788980000
6453	3NKn9iE1iMHGcgNuawqhUjKJ14JEzrik8HABCS6LxGPi48sX38jb	6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	1624	1088	66	1	6253	jxHevuAQetP9Rit16PJWCPBpQXpWnAaERWXTgCXshT79Uer9oAJ	3341	4723	4723	1616789340000
6455	3NLZ3p2nYjGkqP8sGTbX3w9fF2EGW84rmx8SU5ha2Fw3h1vrRS6V	6454	3NLRBSx4dKK4eXRTneU67ZxV2ziwMjFdH1tTVEXdyW2mTYbBe1X5	1637	816	66	1	6255	jxML9o22Asm7s7UtoNYtrfLxku3nMsPbKUa4XNqoUuqjK1dEw1h	3343	4725	4725	1616789700000
6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	1483	421	67	1	6258	jxtCJmNzMBFeGYqb2MEftXrPfNSPTnYd9JP77WzkAgerZqN6FiM	3346	4730	4730	1616790600000
6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	6461	3NKNmdM4HukdHAxrVh4NfxhwtpsydhJ81T4mHw6um2vs2Jn19mYb	1503	1031	67	1	6263	jxjKHVcK2bYjXbeaqLEUVxE7U7cviKCtuimesxzuWbJEjRfjCnR	3348	4733	4733	1616791140000
6466	3NLPfvebAc4CxnedvLgp6nHbcEkgLFhr4e971GVA6StaWYKs3cBU	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	1549	1362	67	1	6266	jwDwbYjzbok6Tg96FKa6PtwJt6GxUuFYDtxbKk3pB5uWzjpDmDR	3350	4736	4736	1616791680000
6468	3NLfLSJD3c2N897x1u9ygzX7Er1rCja8QYPYgUayAe8izt3yG5Mh	6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	448	1179	67	1	6268	jwWbrgui13cPqgZXd881YadLMjkTr7t7yhF56NEUSMxm32vrsWa	3351	4737	4737	1616791860000
6345	3NKP6Z5j3jBZoixePzXXMXCu21evf4dni3NSJHPGepzmrVjs85GW	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1534	951	65	1	6148	jwPaRaJBJt7Yg1jYiTLjZxAsNFoX4DN3YWwE4EwnHtVQvdnV61V	3284	4635	4635	1616773500000
6352	3NLAFMY4w5Dss5JrXTLR7Zce8GnFxLRFAychmVFgvWpgBG4wWbFS	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1458	1077	65	1	6155	jwsyLFDWKLgMqd3pvwGj6JJDJP4kPwmRdhyY38ouYpcoqG2c5gw	3287	4639	4639	1616774220000
6355	3NLhYCrdPRgH4nj7mVDw1L55XSgzqvRGyBY8bNZgAHechruTGf1w	6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	1406	1393	65	1	6158	jx2AFotvvJC9EAtRK9eJ7TpoFHhLrifiNVauWjZVChHaS8GG3Ye	3288	4642	4642	1616774760000
6358	3NLoxcz4NyMHo69yjLmU3F3Fh1EXCKT2r2w3U3RHBrEPYzNbaavt	6357	3NLTxYGZxrzen5GHAqHmo3ao656GS7XdCCiZBv6kzaGcz7TKGNqn	1542	1304	65	1	6161	jy2c4REujvupaYUD5B3Y8mvC9UuacNTngE18ha7quBZBFroGhD9	3291	4647	4647	1616775660000
6361	3NKDP9y25HzzJGKEpmB33qfzxaWhsDrCNUczkzUHEfL3pKaMiEce	6359	3NLmh1gveJ12YFym27LLpugondhLuY6djwqGxGKFBPR9KPuFCnC6	1631	794	65	1	6164	jxntQ8R4dFqba18586uMWv9neQXBkgmswN7YswERGMtAjLxd34z	3293	4650	4650	1616776200000
6363	3NK9KcS55AkNSkiU1AVCWvmV7zo2ypE1DYBYRrU3pJ6M7FXd4uMo	6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	1403	824	65	1	6166	jwfuai1mCbZLZPLCZ5Q65dJL5qNogsF86LKFkuyRmPZdyKsCfaJ	3295	4652	4652	1616776560000
6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	1407	1395	65	1	6169	jwj7iQ4yBRAUaL87dEdzmW4KohEfgCytF2msuqobEmE78RE8VJr	3296	4653	4653	1616776740000
6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	6370	3NKUaJkcN94jF1EPNovfriCYHfof6sRV9WDp8ZDY4zkQ74e7eFdN	1549	1362	65	1	6174	jwuwKCDZfKndMKFGfVdY5ZuzUYP3dc4uRZcUeAKTiqNYvGtLCDR	3300	4659	4659	1616777820000
6374	3NK5aJqZKdDR9P7o6JfGxAYAirfG8KP4eGyLqyhU6Vg5h6KXv9du	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1646	988	65	1	6177	jwtiWDGnbMuPsww3LiUDxnQJBqTsyx7iq547DCew9n7djKomXg2	3302	4663	4663	1616778540000
6378	3NLgFMh2KVL9gDnrUs7aM65oFhMSv69P5KmuMuC3dZe447DJ1A5V	6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	1457	1391	65	1	6181	jxENcp1cjb4NieXN3L1MfGo21qGqyNmw3LrD54PnHVrCPvoUE1B	3303	4664	4664	1616778720000
6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	6380	3NLJxQ84rVUaN6a7XNpVo6xv8MGihWnMCu9BUb2bFK5f4tdx1UNw	1403	824	65	1	6184	jxtCsMDCH5Z1MuvXMkD4bspZW1C5aE2uD83Cg7SfBbTMDA8PJys	3306	4668	4668	1616779440000
6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1403	824	65	1	6189	jwdxobgyZhsK51sa7YEhxmTttosS2murwocsAybDkyyVKXq9uKg	3310	4672	4672	1616780160000
6389	3NKJNpQxfUbCTs3XbFHjQe9PbYmeGTi5YmK58cQzMMH8wTqDM6e5	6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	1448	1311	65	1	6192	jxdGbPBbwRhgs2vNAbJkszoqVFCbPXuVAMQPr6Quq7b91GWysXP	3311	4674	4674	1616780520000
6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	1419	814	65	1	6194	jwRrPtKgtqF61R8qmrYLVLo92yCdDGj3NMtsAi6zLRTdNRAdPJL	3313	4676	4676	1616780880000
6398	3NKYJsLL9Gzy4iPCWHX99VH33vGhqMmkUvbDCatT8bRYsjEMkaY8	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1652	949	65	1	6201	jwu5X8zqHN99itgbbekVu7eKCpeVFPsRWjLKaYdwC7zcRLTHCgu	3315	4680	4680	1616781600000
6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	1407	1395	66	1	6206	jxMuWZH23omERNAnMPyFHLWgUoF8mf21UAvER4Y58hYrCcBQfWw	3318	4686	4686	1616782680000
6407	3NK4KQrz4GSvPAQVDiekkvqjuiPqEnc7UgrU6agVgsHP35xsKeCs	6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	1407	1395	66	1	6209	jxYgBfzGU1b8YEdQQwDwyMqVSihRrKu3ESK5TV8m5cXygtpVnsH	3319	4689	4689	1616783220000
6416	3NLGCCphY4SuqNJ9ZAQ7fqg7HtPHs1ETJdoTywpF28H67fTyFX2Q	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jxmQtAqKdLdYGy9WaHA8QQq313dFJsJHAco5C8bPJaRE9yxcnp7	3324	4701	4701	1616785380000
6420	3NLKnPb6TEXtpUk25p5tfTfGCf36KTAihor7rYF4q7PaiqBcfFBC	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1627	1019	66	1	6220	jxjUVDyMk17rLLtMrTgKWk9cNsJJzHvDFrWfL4mFYpUUro6jLBu	3325	4702	4702	1616785560000
6422	3NKEfbdGktE7Zja2ebAhSyrLGZu1vBhjfdnQWVbNppfPELbJq9vr	6346	3NLf65X5WP51esqP2BythGUQgJm7WQiq4n6vo5SoiXYNNjgqpgvP	1571	1335	60	1	6222	jxhaMpY6W8HoQQYpt7mXHJKK58KEsc33ifoM4xD5VwvXS9iWZB5	3050	4702	4702	1616785560000
6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	6430	3NLrRjtUiQLSXz9ur1ZcmCmexgyXPGMoTpGE6DaJ2rHUx219oEh5	448	1179	66	1	6231	jwBTLVuphZFt3vNUQWJ3Tsgt71ds6LvsCkLwakzoge2PnSPLJ1p	3329	4707	4707	1616786460000
6433	3NLubpB3Lf4Rsw22unATfP5rJ4qRfNBWJspjQmk6htcmA8BjNaSy	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1406	1393	66	1	6233	jwitYnmnY929HuyXPqYa2wKzkAfv1UAHFoYe4ksncKXboPLDAks	3330	4708	4708	1616786640000
6435	3NKKCVkoiAHAuZHCNXHFH5JJJ4JdWhV8bJMXcd89XzjtQW8CzNhU	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1581	778	66	1	6235	jxbxMYPK5Hsg7yYG7ga7JUWGsuY4Y4YXMR9CNMACtXD7apy12hZ	3330	4708	4708	1616786640000
6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	1406	1393	66	1	6241	jxPR82sLJEbGABpQiCKw7iBvHU7697wBbmogVF4xJDRAbY24wa5	3334	4716	4716	1616788080000
6443	3NLgh8WtFr6ovshrG4BMsxdrxN9UQkBR2g8KtsmVA86L7NHCyGT3	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1631	794	64	1	6243	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX	3278	4716	4716	1616788080000
6448	3NKjGB4JbV6StiYs6YNSGr3vcTEfmubkZBjQfqeAJzUPtVk69zdG	6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	1671	550	66	1	6248	jwF7sV6EvvZkZ8jf9chZJ3H29HcgENPuEeUnpMyaJf8pdVQo9U3	3338	4720	4720	1616788800000
6459	3NLk15rwvNYLRaDWvNwdLyUz1jut9xCANSorqDkckBxTcHhdzRz5	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	596	1180	67	1	6259	jwQ6Cum1wUXVZSoqugQsmb7RpSa8ZQZK4PsoASUsovLFrUecMaq	3346	4730	4730	1616790600000
6461	3NKNmdM4HukdHAxrVh4NfxhwtpsydhJ81T4mHw6um2vs2Jn19mYb	6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	1579	195	67	1	6261	jwMXJoDhu4uv5dzyFaEMuKeqxe7akztL6K8VkFq7r3oC5255DCu	3347	4732	4732	1616790960000
6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	563	993	67	1	6264	jx7WXrXQ8Bwamkj7uP6Q7Yygc4iWpDSctJ3TS5MeWzvDYpgAY8H	3349	4735	4735	1616791500000
6475	3NLwBjYrTNBH5SeSrTUCvdCCLarWyk6AUfj3RWgqGv6AsHc7rCbo	6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	298	942	67	1	6275	jxoVzn3c8UDuh9w45Z2AmmzHM3pUeseUX29K1Ynjrj6wxMBBUEk	3356	4743	4743	1616792940000
6477	3NLgTi25PXWLEV33jqeUu1TkuRa8jZZvTYzdpJSfqH5hv9PMFVRt	6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	1549	1362	67	1	6277	jxhgeBWoq9hs7FGpAS2TtugYKgeiqjSPJqE63Aym3MstZqTsokP	3357	4744	4744	1616793120000
6480	3NK43XiwJ8uUVsjD8gWeaYmHLYgF37gdt24tV37Ekp1zGpHxiv9N	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1448	1311	67	1	6280	jwLSDoJ28VWCW446kpvDGDRiDEpjHBGBv64ssaAFmA7gzfvmWok	3359	4747	4747	1616793660000
6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1483	37	65	1	6154	jxhYcfxSvMqYvU5VeXYs2NQBjBaMJetctbs8jaZH7vZwxWKNipF	3287	4639	4639	1616774220000
6353	3NKm7T2Hvqc1QM38WeW8GWR7zpJAevALDLqGhZwfGSfNn6jRny9S	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1637	816	65	1	6156	jwDKHxbrd8MEpJ35nUqnHiS2rVKgfCguyrYD9AHVpiZZNN9ARQa	3287	4639	4639	1616774220000
6356	3NKVxKJ1exsW6prJKp3GyKSTPWExMVCUF8Boy69HzEb6m2h5HYmK	6354	3NKMQ3br4rDMGSevqrB6bDt5EzPxXjihKFzVxDy9YK2Lk22TCbQP	1476	1125	65	1	6159	jwraCPfC13jmS3i7AbD9V3xrmGjf2FUwPpRkjQHUwWdPKS7oWe4	3289	4644	4644	1616775120000
6359	3NLmh1gveJ12YFym27LLpugondhLuY6djwqGxGKFBPR9KPuFCnC6	6358	3NLoxcz4NyMHo69yjLmU3F3Fh1EXCKT2r2w3U3RHBrEPYzNbaavt	1406	1393	65	1	6162	jxJAiZDjdvJQpeEzssJk5evFxucQm4TTw5v8NgHNdAnGJv2K539	3292	4648	4648	1616775840000
6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	6361	3NKDP9y25HzzJGKEpmB33qfzxaWhsDrCNUczkzUHEfL3pKaMiEce	1407	1395	65	1	6165	jwgs2fNT9yAiJDCHRaXNBrHZHQshdEJmub8UKRZfRS7xyc8kZjo	3294	4651	4651	1616776380000
6369	3NLLHq2AUaSbv91ZEqgSmu8Jmp1exjfy8SkCjRJHNQJH1bz9xcNu	6368	3NKzGiDHFi1b1hiAaAQPrwXujiLGppQagRW5bXBQgxQxkmsnQCD7	1483	653	65	1	6172	jwgUGMBfoFmacjFmyvdihpfMYTixCbBP5FHhQxY9NHVigkEZqUy	3298	4655	4655	1616777100000
6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1476	1371	65	1	6179	jxTwAtEr1SXA2Nxgq5heijxKxGStC4iNwj5wjMnynSpbGWcaFu8	3302	4663	4663	1616778540000
6377	3NLAbskzfqheCR45BZ3LPkVw4LM8SgrgzqvJx4xaFZUYBE5J7iMJ	6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	1444	1255	65	1	6180	jwsTATRBrGCv8qdsrn3NcrpCGnD5rnhP3AGDHmcYHpBE6wMtGfH	3303	4664	4664	1616778720000
6380	3NLJxQ84rVUaN6a7XNpVo6xv8MGihWnMCu9BUb2bFK5f4tdx1UNw	6379	3NLfNtEVDx7iuJ9YaWdaKNp1vwhXisC2Cj4rTo2meXpTkAgL3D1F	1501	1360	65	1	6183	jx5TziasHAKKVqC73uaKCrBveFSUVBCDnFecgfZYpm2WnJCvjo1	3305	4667	4667	1616779260000
6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	6384	3NL2ENq5HELiQVVM4Kv3QKu7THgPKCp2RHJqeHRnFQEk2pTzoRyZ	1619	1275	65	1	6188	jwDW1hMNpsE8J1bTtfVPqxafdERfKH5hz6eAMQxMa86q4FiEqiP	3309	4671	4671	1616779980000
6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	6388	3NLRAuRz2CLxFdVH5Ck4g2tYivvHhsykuAMMSUnsgVWk8FzDp3iD	1439	1153	65	1	6193	jw6umCaH66hWM2sMQ3FkiYFh6J8eNS2reAwTXQ2qHhXk8HWgDXZ	3312	4675	4675	1616780700000
6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1402	796	65	1	6198	jxdr4QW3GgMq9JuvrGyauMusz3SDYDkMrKvU7wjkEkanVAiPo6r	3315	4680	4680	1616781600000
6400	3NKtzuXxPGsXaKGEXC6RtcKqJrZkGwSAKVPsJMzsJr6vsZaLbAGK	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	606	1295	66	1	6202	jwE5TJdQB4YoZ7XTJXvQQGePNp2oRR1TE2S8fRRuueiCZsGzcQZ	3316	4681	4681	1616781780000
6405	3NLQyLeFAzx4RGFCJi5de8wvUnqNbPdRtdyEvvuJsYZBXmnRGnnv	6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	1623	839	65	1	6207	jxWXqwhbhbVXA4kRBgrJfFu2siWNgyEADH33YtRtFVseWUta53P	3281	4688	4688	1616783040000
6409	3NL6prPAFwZWBhSaAxSBVtna1xGjrK6GyX4KvEqrGXMvFCofz7jh	6408	3NK7e1HGsBahfhLhdKLQ7CGzxbfZjYETm8xRVQ2zv79MPY8v44zZ	532	937	66	1	6211	jw7REA5BXkC3x6RvJ9Xt6SWWRSAV96gix4iNb9eU3JpAuA7rDCR	3321	4695	4695	1616784300000
6412	3NK8RP6tJcjxQQVi7yKsJSrA1sDtzcSjT9QgT5yWWaKsdd7eZm51	6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	1419	814	66	1	6214	jxgne5xg73peJaeSGAjbPVpuSV35jVHSxR2Zojn59GudtypRorc	3323	4698	4698	1616784840000
6415	3NKhm4DjB85pooTqY3CsBDNgqGSrcuCns7aNsW544my3EfQwEMQZ	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1516	928	66	1	6216	jxRJDKasJkTyrM9b9BjNVkrTFznCenUBE71E7kg7trB7Kn8gZTc	3324	4701	4701	1616785380000
6419	3NKVY7SkQ7X1os1c5bampo84Zzb41HPniTXajT7MPnK6uHJ7GNzf	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1646	988	66	1	6219	jxXohShk9SLL8vAScdQ9ipQZg7D9hRK5fZxiVac9183eF2NdziU	3325	4702	4702	1616785560000
6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1440	1131	66	1	6221	jxzkPVc8RDYaqKMVEsW5SfypyoJiEFugiSPSyBsqHpCBzeoqHus	3325	4702	4702	1616785560000
6423	3NKkrfRFw5FrtUarLvbFEtAaMUpHRLZnakTJydGFSMbqYL2dyeiT	6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	1501	1234	66	1	6223	jxt8e5FjhNpR4Yvr7kTcu88o2hoGxQaHqMr5AzkcLQS83UdxqYe	3326	4703	4703	1616785740000
6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	6423	3NKkrfRFw5FrtUarLvbFEtAaMUpHRLZnakTJydGFSMbqYL2dyeiT	1406	1393	66	1	6225	jwhwSPU5D5V9it6SWjXyLDEcg6rnNYWSgFVEsd2eJeoFZHS1TUE	3327	4704	4704	1616785920000
6428	3NKcXNHzv1D2uGwjVbCbjSkCyy1VP1eLZb8KnKecqqPmAj3ujdYN	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1646	1354	66	1	6228	jwqS6hboNKsN2yEUnCCGkaNRRf3sVgSYR9wPyFbZt4k9LX4SGdo	3328	4706	4706	1616786280000
6432	3NKk6DXk2vHE1ssToe14ta2841iGNL9XpBvSah4e6Z42RNQ5X3ec	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1503	1031	66	1	6232	jxDeBki3chwqJN2EDUyL3LSVJfp18ejdqTQXFvZFyotsS7weHcS	3330	4708	4708	1616786640000
6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1619	1149	66	1	6234	jxtjT96ayDFF7SBiv1Fq8ym9SQuasMwsEQLUU41Ej4HcKtoCYq5	3330	4708	4708	1616786640000
6437	3NKwcdYrsANUdWaATtXB94eJLsNKGSQQ9fmk2mKPL3YKxQvmjVp1	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	1405	851	66	1	6237	jwMQpxNBTkkpiTnownQNK1b57hr6VXVQ3kVNQcB8qeaozvmveMH	3331	4709	4709	1616786820000
6439	3NL8bDW6SzxW5FYam8EnXuxDfQ1qBLPfwG3qVcEEEhTN6ALB52AH	6436	3NL8biycUsRsegVGiyMH34BkjrkQrT9Ckjh3Ax4K1LiJ44WkKjUf	1405	881	66	1	6239	jxFdQwrkDx6Ct9xACx8Gt678yTTdGJL9Q89Wkc98JKzzVjqBKyJ	3332	4712	4712	1616787360000
6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	6439	3NL8bDW6SzxW5FYam8EnXuxDfQ1qBLPfwG3qVcEEEhTN6ALB52AH	576	1355	66	1	6240	jwNn6xpjHD65wYsj9jV4bW7VDUvU8AkJoLhDMUot878owqoT27D	3333	4715	4715	1616787900000
6445	3NLRNdpLzfipRZ8PEtxrkB6X2h5J5oeY4nY5zUWZxjsAKgFKrS6s	6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	1483	150	66	1	6245	jxzoFRV2yLQr8t8E9PDSN8CqMLqmTFrhKhaVXUaRRgw65SbsDAA	3335	4717	4717	1616788260000
6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	6446	3NK9Fjao522VceumzpUM4hKgKSdgzeKGaVvFnh7ccxDFeX83iQWG	1637	816	66	1	6247	jwDccofaB1oW8KdZFRufBS2zHEbGaBf2Q3Wvz4z9H6baFYTx85G	3337	4719	4719	1616788620000
6452	3NLscoxQJkGzQuk1VokMuGAX67aHchztiFna2PxVBGWzWU36tsRK	6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	1637	816	66	1	6252	jxh2U52voharpt7MsAM9NmTkv1bATY5m948d1mP7ayyBqoTDpTF	3341	4723	4723	1616789340000
6454	3NLRBSx4dKK4eXRTneU67ZxV2ziwMjFdH1tTVEXdyW2mTYbBe1X5	6452	3NLscoxQJkGzQuk1VokMuGAX67aHchztiFna2PxVBGWzWU36tsRK	1637	816	66	1	6254	jw8yTSZ7AQ4pzbC5MHqzCrF3s3vCvV7CLSVtexnaWEFbymU1mFV	3342	4724	4724	1616789520000
6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	6456	3NK5FSZHUwoqdCMnPr4fyguQsrqHnFwHpo94jfFYuF8dNMgoNUtu	1506	1373	67	1	6257	jwXhyc9CfeHJXGx7qsxiqH221oLVAoFUCS48ijUMvFr8LM3DDM1	3345	4728	4728	1616790240000
6460	3NKoQGo3oc8rdqdAzYSmu4PwYqiWJ2pTeNpJYY95QLhmk1kRDhQo	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	1490	1148	67	1	6260	jxh5BFxgLihYaYMGbjWPKjucuGwBmuYagnkw5SVA9DZGTCmDU4Z	3346	4730	4730	1616790600000
6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	369	1312	67	1	6265	jxh9GnQWsG2GkGvKzjHqXC6tA6fq25gBzZjexFXTXgQgNNvoJfp	3350	4736	4736	1616791680000
6470	3NKQAeMRDvMcNDC58mB7onQYB6y8hboTCzkcgGm6QgJuPzfPmGwL	6469	3NLRAdACqbBTdZHKSpEKYF2rb7cdVZkx7UefRLBpSH8HTQacdiz4	171	1374	67	1	6270	jxLuCDv9UaJAp7jeVsw7eJbjhxBCifYvN1etiPx4zmx8eXkWVv7	3353	4739	4739	1616792220000
6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	1407	1395	67	1	6274	jwZX6jDNnYtQefhJSYWdiJrnn42Jc9wZgqQNn1AuCayEtQ68NB6	3356	4743	4743	1616792940000
6476	3NLMGEDKoV4Rfhmk8PE5o9g9zmjBJVRvZ4ZWkJfnwyvhwQwJcQQo	6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	1503	1031	67	1	6276	jxJdatp7enkCUpnD3dpGzBstNLGMmYPK4bz9Xyqoo7ugMhqYun4	3357	4744	4744	1616793120000
6479	3NLNnavKdkp5gJ9kZxZHBoRRgD5TLmdDS5J4s9mGfEyULccAD3r5	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1467	1130	67	1	6279	jxuo6YhwjLdUwbRrtbG8p8fDfJ2T3EWfCD8i8b3LQispqLxX3vT	3359	4747	4747	1616793660000
6481	3NKEMM58Bpq5xnSjtc2HuKCmHU3AChKh25eS34PbNgkb85U26sTu	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	171	1374	67	1	6281	jxEPLkscTZsMJq9bkoGjn1FkW9wxq2qrrrziGkWyJGAkf8QcXvt	3359	4747	4747	1616793660000
6483	3NKkLahoxyLrzkSP6uLXGLVH4zKbnB17XFTqdu59uNpx6LHiN3UD	6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	1444	1381	67	1	6283	jwVQ8VQCiG9se36hwReBvuFoQQkevg9eq7Q9KRBLpR66ps6JX3n	3360	4748	4748	1616793840000
6488	3NLRPfcSo6QCA4LmLAZmABVHyFQKX84MGNbTjsJFSC8k14m59H48	6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	689	689	64	1	6288	jwyrVwtfnUm9gAXvQPNFnHkLJJ8XN12io7CTkABC23K8ERzX8DV	3256	4751	4751	1616794380000
6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	1405	851	67	1	6290	jx2KMQyqxNB1ZPF5r1KjGUycYC5WW2DEAiNgwZaDTBzpjyrYgNV	3363	4752	4752	1616794560000
6493	3NLryhwpwJQA7K7qUzuZqQTPxkBKsgYwZaBnBdxZL8nRd2r9ZZwk	6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	311	1307	67	1	6293	jx4DurY5iig3msDMDC39qgCfBvkCTmwcbD8f8cgzRDiBmSyaF9b	3365	4754	4754	1616794920000
6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	576	1355	67	1	6295	jwVYAP8xhaoVkFHCVNZ8qUvuckUE3oJuaznx3guyAF6RDoE6f7T	3366	4755	4755	1616795100000
6500	3NLWRuFB7G8CPkizXnRwpAUcQu5cAS5RTWE5vhWL1XBE47oEJ2kn	6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	1527	1047	67	1	6300	jx9dnFK2jcGhH8RyemzudCPfPQVCLhcZbq4XEgpAvqqLaN4rqnE	3368	4758	4758	1616795640000
6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	6501	3NKcHs6cXJM1BMLPKNpJbEa19VgTAzTnQG23sFdjRUJEULQ3Jc3h	484	1319	67	1	6301	jxQzJN2AEMhXsF62uAHx7zd9wtP2rZrEZWRoqJ6AaVUZEuN7auq	3370	4760	4760	1616796000000
6508	3NKjs8FPhBpBcdrqaZHsLR5cwdD8hPpPrtgruBZbYHKbu18jmsaa	6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	1440	1377	68	1	6301	jxd2vr1J3cRCDz199oUFr8XqjWUGms5hXjASfyYT3WfzmB1epNR	3374	4765	4765	1616796900000
6510	3NLvgYaNaD7tH1y9CXMMkJ2cPH8xNLWud19pn63KkyDDtkZfCh8r	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1451	1166	68	1	6301	jwPwegz32W1WCuELf27F2xkPYRn6d1ZVHZkTgGgtPyfjpTeEsf8	3375	4766	4766	1616797080000
6515	3NLDj7rygXmScBUxEd3joDKKLNUEHJPmsYRD9EHafP8VasV8oCNM	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1553	776	68	1	6301	jwqkdY3Y9xfarcDGzzLh8AUgdqtFdLE91tmckg7oX1QxeLbwZbA	3377	4769	4769	1616797620000
6519	3NLuSCMK996xzop8dEtMzadFq4XvDJfgKzybXrpRr8neb7Y9cQke	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	1476	1245	68	1	6301	jxpr7K5sJYMJ8pvS98TeSYFZJmyAbf7EW3BaqLueU5QBq4pZAM1	3379	4771	4771	1616797980000
6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	641	1336	68	1	6301	jwzz9TN4eYC3ELzUJgyw9DEF9GsNPsigGzh8gdRBUq6RRH9Xtjf	3379	4771	4771	1616797980000
6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1587	1357	68	1	6301	jwcW6MykbeWbHprYbcXHnReiCQXeqsMv52mQrkPLyWW2ue4Rz6X	3384	4776	4776	1616798880000
6533	3NLjY46MidA4gYmZmYHZSckkG39wTbwzDwAuZZT21Y3dRyvfFw9h	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	1631	794	68	1	6301	jwEu6rg3hcRVvgrRAE6DhwUihrymiVAeVbajz6T42RviAhuC8bt	3385	4777	4777	1616799060000
6535	3NLKp3fMzGgutzxjCmHduGkcoN8sQpU4YjkRgq859iWjHw66X6Re	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1406	1393	68	1	6301	jwLSKJJ6WJRT2dSsmzbYHvzYKYtqV5AS1kkPQ6DkAUDAY9gSd2m	3387	4779	4779	1616799420000
6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1508	1387	68	1	6301	jwzvjPx16dgCyvSG9XZueEm8ozxKvUVozeQBCL2qKhyaonMZCL7	3387	4779	4779	1616799420000
6539	3NKZNYJNrWsMiVtPt3xEQ19FMBbDExM7suDRdrwLTUQeSF3jTXwK	6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	1422	1091	68	1	6301	jxup6zLDuuGgzkR83nesEzG8afJWVaz78zcjrThYYV9szQJ3Xuq	3388	4780	4780	1616799600000
6544	3NL68m5yXw12h5zXenskDCxQUbxpwW8D2GuAw1n8AsSAafyZdZij	6543	3NLXfcwuQ7R1mmeU8StXhoBeTEESmtac3T2og4dTq1N7JehVfSk3	1513	1379	68	1	6301	jwVtbwKfEwXDMRVCtBQr3VCApNiGsmwdrLzVLHzirQE3YbHSKvf	3391	4783	4783	1616800140000
6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	6546	3NLJqCQSWxx5AXCinnpmfYZYeiDDYFNWLVgqyizGjyTyvANQMgo5	1668	1004	68	1	6301	jwdBBrGBbALVLbnvUFqSMqfiuTmGgJtMxPGB1VkdbPYJNkLQCn4	3393	4787	4787	1616800860000
6554	3NKdUZ8cwV5MEwU9LTfvZVhUFRaTEoqBJtruukybq1yhXde7zBH7	6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	606	929	68	1	6301	jwjgs7zxQP9ZMKnYbbBKirqmsgtuuqpHFCmMzD3mfaz26GKz6sJ	3396	4790	4790	1616801400000
6556	3NL7gTrtNyXn6XG2NGmxorubHadufF6uduEqZj4BL2dYVdBfjtWX	6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	1527	927	67	1	6290	jwh7udd8nRibaxF8exGz4CYWSXtpt7jtfTgYZuUkM3s68a2N2Yu	3364	4791	4791	1616801580000
6561	3NLXQi7hqVgmsgTN5DNJ6oyvfNg2ggFC86pDz3ik3EuRMaq7tiqJ	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1656	1097	68	1	6301	jxdSdzTaNxxxKjWNm6ttuiaWCh8e4zj7ghdvwA5ZstMUwxT6BUh	3399	4793	4793	1616801940000
6564	3NLUCbRvW9VgdEBqUHjviMHRp7DFydLQS6qbok66r5MTuLoSiWAF	6545	3NLk2rAyR1NLANWPvnpcL7JdQMdpAeypmFDDyycdppTGotRRbw2a	1481	790	68	1	6301	jwqCWe1cZuNh5HH7L9gKij5qYCRZ6sUVx1SUfSK7535tGaS6mi7	3389	4793	4793	1616801940000
6569	3NKi4NVT5xWUTgZfz7MguJqKandtVF94V3HZggHEzHU552JEJ18u	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000
6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	1403	824	69	1	6301	jwHorQiY49mWaJuxM75VUhTGkLSeuZAoofpTjwz6QJ1NXTJwU8k	3404	4799	4799	1616803020000
6462	3NLLaGHBiMBicaNRLbdBayBHtZzGoXPEAcmvJnKHtEkFr1QByq1C	6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	1647	481	67	1	6262	jwrKdW1dgiYj47qtYw1gEDG73PRNA16PUKF5bHCzKZC4xtEPB6t	3347	4732	4732	1616790960000
6467	3NLbLSSezU4RvZbzVitQpugvfscvw4zVckkkHsRFHq7jY4B36g2W	6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	1405	861	67	1	6267	jxpGdFrio47TF9uWHLGGEfc4HTefwicHE8rKLHPQUJq2rWiUUsd	3351	4737	4737	1616791860000
6469	3NLRAdACqbBTdZHKSpEKYF2rb7cdVZkx7UefRLBpSH8HTQacdiz4	6468	3NLfLSJD3c2N897x1u9ygzX7Er1rCja8QYPYgUayAe8izt3yG5Mh	1481	790	67	1	6269	jwKMMKKhf41xEejSxKszU1BhNZQqwDUJwHXAUTwwBxKGHxWzgcw	3352	4738	4738	1616792040000
6472	3NLj5U9CvWDUgw6k6B9wYEabeExrozaoR7h7AyXwwQLDnkiBfGHw	6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	1657	1098	67	1	6272	jwLnszbnW5zWwLLJyjiVfLhf2cSEk4BZ9US8NaKYXUcmUHU1CSL	3355	4742	4742	1616792760000
6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1637	816	67	1	6282	jxGnywfEUxL2KFTBxabe9pg55AEk58ETrRGX4Bno9abRrdo1b74	3359	4747	4747	1616793660000
6486	3NKyVxSkhwZqu1NpBpZSJ6GL2pvo3LzhR51jDTUUczhrnLLZHgyr	6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	1594	960	67	1	6286	jweqW8gL8dNNZXiedv5MZtyy7G1cCjB5AaxUbe6kH5mBi9PjC17	3361	4749	4749	1616794020000
6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	1587	1357	67	1	6291	jxgoji2xv8h6qujtBNbkMM6PwuMV1aZXTbgqwfpkqyeJ7VC9Jia	3364	4753	4753	1616794740000
6496	3NLjggUxaMgJs55BeTgp1XvvKafFBMPcviEqM7NYYXBcgZk9gHV9	6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	1637	816	67	1	6296	jxFRLaySixAWsABBABwKdvGHBe5zoQKUTipFTMwk5P1bNnQs6fR	3367	4757	4757	1616795460000
6498	3NLKMk3VvoA89qr7R2hSFyMriduQg2ojCWEqB6DAALcyrxy1nBmB	6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	1527	1047	67	1	6298	jwYZ9cDraxVdzcgANNkueBvkKR6NbfSZBmq8EV3HTgKKG3NMTPn	3349	4758	4758	1616795640000
6503	3NKEd44xY18FQCPKCTPZFHvkg1GAfSDJrDT4fSYYqoHKbZ8m1evq	6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	1403	786	67	1	6301	jwPmPqWtfiUB28vozq2N4yPgDWRqs1T1EMHatbztmZuTdnZGTa1	3371	4761	4761	1616796180000
6505	3NKWxDHicDNvTN8SapHikwNbjKcn3ihy8ZZ9KVENtABeaykYCXpi	6504	3NLtWzp6fGrxgYicmwa23Vn4dRVobmb9J3E7MeaTyfBvGDsdwEDS	1403	824	67	1	6301	jx7PToA7h9n4RxMgQm4q8appiA8EcqwthLwF1ppkpxgDDo5muVo	3372	4762	4762	1616796360000
6512	3NLpjuZ74pjdN9NSNKVy1Vn9BWd7qzhrn12kBLVeh2MXyVZ3TmPp	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1651	935	68	1	6301	jwW4fyGvczAgphQKW1mdTesfWZ5faBK7xgMrBaRsm63JiNRNEz6	3375	4766	4766	1616797080000
6517	3NKUPTtNzK3p67JWNoqFyQ1WtorivZRJ9qSCJiuP7t6yhK1bhyzR	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1647	1056	68	1	6301	jwavyoSZDHSwULWusrtVvUW1KoewdPPScyZpYw2dmNDyK3JN41o	3377	4769	4769	1616797620000
6520	3NKKbF9ToZjakz8hVhAGwiF674vmY3h7aVsbKzrrbFXAstFmh4ee	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	1407	1395	68	1	6301	jwHx6Zj4shvFoP3g3624kPYF3bvN2R4av9sa5QDHrN6t67nrVFc	3379	4771	4771	1616797980000
6524	3NKVgvz16j9NHiXvDSyVTzM6gcJamH2oQnKMqwSAYBe4cxCfUdPq	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1601	1142	68	1	6301	jwiN35ipuvUq5UNufGT3RoDTAg3EWxFA4zHnjrqYMzCnFe3NeXm	3380	4772	4772	1616798160000
6526	3NKUkJj3HJphJWQCg5ANRwTc1umPi4yDAeBDj3dJYPB1tWBFmoMo	6525	3NKhFaaixn5XVksMcpPVxwVqaTXPXoKzfmq84XtUypKNbFzfCfKa	1619	1149	68	1	6301	jwjfCUXfTdrjmtY8ZMMVfhZmixxYDcqkv71qanN9rE8FdLhiTGR	3382	4774	4774	1616798520000
6529	3NK6kWahdHekNcL92gWnB6LGfiGrp5YrgtJnnsxQCVUoau8iSmzN	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1407	1395	68	1	6301	jxGHqf479ucPC2spaH15sJyU6dzqSMjxNXX9gRVN3KsrpM5oR21	3384	4776	4776	1616798880000
6531	3NKASUV8YCzrJAK9mZAY5nF8yGRbTQRhjU7ZJEXqGRYUNZMZjyhD	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	317	317	68	1	6301	jy2Wou29gZEsNw8vhEpxdFGgTKtqGQaL6xTWxJ4E58u1EWNd7yk	3385	4777	4777	1616799060000
6542	3NLCX7mxvBoUjNk5YV5kxspjKK52UHockmwSPaPoxhPHGjXbkH34	6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	1403	824	68	1	6301	jwVS5hEKiHnDHup8D9w2iiSJifu4KSHS3h1Do3WLPLpQXYvjYsV	3390	4782	4782	1616799960000
6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1444	1015	68	1	6301	jxp8QyYaqKkqtFwZgoL8yDys9VfR19bc7QJ8atQrM1LC9V5cZg8	3395	4789	4789	1616801220000
6567	3NLx3bqz5wS9fvnMeFjGENvKC4bkr4tmhfzwFRcvDDKzmgFCyPF8	6566	3NLmpigAPaCzBGRg3rnVunRGUm66PDhXSQ3Vm4GWa6teiQkszaUa	363	363	68	1	6301	jwAA8oo5PBRmjrpqbSi5SLiXCQ2Xx26uHu4Y4G3WYPtJveHWvFL	3400	4794	4794	1616802120000
6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1406	1393	69	1	6301	jwpjgMLTLANrRXGzNECsAD2panAbGjoMJSNmwESCU7XcfhDm3e9	3403	4798	4798	1616802840000
6574	3NKT5UmJ4o23o86Fymm5Ce2DXRH7kN49DPvjbew6HKCrj5gj57T2	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1631	794	69	1	6301	jwYjYhYGbQPAn23rtWa16nURSjVombFubrhxZZJ7snsyg4NhngW	3403	4798	4798	1616802840000
6586	3NLG7WLem8X2wGd6FSi9exr8FtDjSqp4HEKVh5F1ZxfXR8RmZ1yj	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1407	1395	69	1	6301	jwkrMDUCoSPcNo3LWf3Gjn98YRTJDmR16p6xHbqV8z8JmJFwFa5	3407	4803	4803	1616803740000
6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	6590	3NLB41P4cSxWCEnKp8ZsogmsLEhZ65MxZCS4cqetADfyzj7pwowm	1649	1383	69	1	6301	jwxhwXmrkNAB2wMwwZraVDA2WXu7LfCbHEzQUN4byE6meqcxSSs	3410	4809	4809	1616804820000
6594	3NKWa9WbyuMfQnrcXLzVE1GG3nLN3VHK64LyE1MNaaCrJKfQC6tY	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1541	1298	69	1	6301	jxwtJj7rQMUazNaiVGpRqnxUZ13mMmier6TrpW6xBt4beRCAuLC	3411	4810	4810	1616805000000
6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1622	1356	69	1	6301	jxdtFM95ijuxW4RvpczBhhv4KyoBw3ihAgFZTk3G6hcJ9hiUCQu	3413	4813	4813	1616805540000
6598	3NLqAQZdGHpH9Chx2nr4BduppF37XH8qhzwJaoWTUNyrvFEHTES3	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1489	1254	69	1	6301	jwcAuYnjU1GgZ7GZe8aZLnYcMMsWjWwAnSSvTnwGgk6SCRG5a7Y	3413	4813	4813	1616805540000
6600	3NKxXJ2f5S85dKhWEShjZpa4xGzNmoBKxmNjvmcgWWoYRKj61Xtu	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	43	1184	69	1	6301	jwhPrkCe55hApX7SyeCa3QujDtnfrwKFnuifPd1DGiGQnGtBqhu	3413	4813	4813	1616805540000
6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	311	1061	69	1	6301	jxy1QxpX5dWPxgPW3U2boJtdQKZdbDznSQF6zmAPCCn7dxs5Sff	3414	4814	4814	1616805720000
6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	6603	3NLyQcqnWkSUWho7gUnKEUvjabDMqBtwD3LRL2vpeVQhDRYGKAHc	1513	1379	69	1	6301	jxWgpV9oXx8Auv756Qrof3m2hkC14Fefx8EEcVSaxzNk63MPSpP	3416	4817	4817	1616806260000
6606	3NLrzV4qjtziLGYrhZ7surzrEefcfhpdUv5RTB8BXxBtLR37sz61	6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	1579	1389	69	1	6301	jxJuHGRUpRLW8ufPGiMkxY7z2rLTwSWnV92hCPHw2eTbnHYJwuB	3417	4821	4821	1616806980000
6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	6470	3NKQAeMRDvMcNDC58mB7onQYB6y8hboTCzkcgGm6QgJuPzfPmGwL	1403	782	67	1	6271	jwpVFkRgo1fSr5YndKXo4U3s3pnjrSDcL39pYciTwiPrxBDFLq6	3354	4741	4741	1616792580000
6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	1637	816	67	1	6273	jwKjPvcrM1aVkvT8ATJ63FSn12E24oqNTPfXo5MD5NAvDQQLZkG	3355	4742	4742	1616792760000
6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	6477	3NLgTi25PXWLEV33jqeUu1TkuRa8jZZvTYzdpJSfqH5hv9PMFVRt	1483	1276	67	1	6278	jxsYiwf7r6Hfivbjks5fvAnFbNkdkPefepKfrTmmXJJWnsoqNwD	3358	4746	4746	1616793480000
6485	3NKmLWP64xnTsjuTsGUvx9yubGV6hZg92jqc2XVyLW8BuHydZkFZ	6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	1407	1395	67	1	6285	jxNpZ7TsjRh7i61jQtze3fBGXoXjTEEL7PwZi4b8SKY6wTsPUmL	3361	4749	4749	1616794020000
6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	6485	3NKmLWP64xnTsjuTsGUvx9yubGV6hZg92jqc2XVyLW8BuHydZkFZ	1672	1285	67	1	6287	jwAkctbkvPPvMyfqKvRj4ykQ92ARbFjqR55pnqWUUbUXXMFZofR	3362	4750	4750	1616794200000
6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	1406	1393	67	1	6292	jwaRS4UwcoH9gWgFRy9tW4E95QAAGgkJR9PC8VrJuEayfVDc4Ki	3365	4754	4754	1616794920000
6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	1650	1375	67	1	6297	jx1MgJpZLwyhe8c81KPMFyvoevq1ug11HSNaQ8z2eRJojWEaUM6	3367	4757	4757	1616795460000
6499	3NKKjFcE3NHw4z8gjnFQWeAC8RjopdcCBSs32uwsuTQSM4TePr42	6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	1624	1334	67	1	6299	jxPUrWsNzta1Y97hT3QKhRZWAuAoWvkFoxnVXagez1Tgr27fuzP	3368	4758	4758	1616795640000
6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	1406	1393	68	1	6301	jwmZChXPV3fiNvJvpvCwCHQoosNcoHovXMh75grapXKufYEBAFm	3374	4765	4765	1616796900000
6509	3NKQhv6TMwFju9PD78Jt8RU6538Q4xbRiUYrZ1c7n7EBtWz4jCS7	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1407	1395	68	1	6301	jx5Wv3wmdoRjEXJRjbVW7wpXRCvruGyK22Wvo5Vd5m3wV8tHTzF	3375	4766	4766	1616797080000
6514	3NKmWH6boXyuQ5QpCNwKNvq9RbmdKmUY1GuZTf8U8HnbyfBV7Y4D	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1507	914	68	1	6301	jwG6axBkRQqmiytXfDAVaoC3dTRqmaR8Wdq8jmXBsmMPQhFnZhA	3377	4769	4769	1616797620000
6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	6514	3NKmWH6boXyuQ5QpCNwKNvq9RbmdKmUY1GuZTf8U8HnbyfBV7Y4D	1633	1264	68	1	6301	jwLGpvPLYdCikjdQjTgrcPo4NSpWHWkt7wim77LSNeHS2Ahpeu8	3378	4770	4770	1616797800000
6523	3NKQonVif8rp543zbvVAtSYDtdvxNHxgjpVZ24NMyrNTLLJDQz2L	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1668	1004	68	1	6301	jwJUMfbxx7QntWn2oBDuUxkDVpsE2imViqATACerieJazzpy5yg	3380	4772	4772	1616798160000
6525	3NKhFaaixn5XVksMcpPVxwVqaTXPXoKzfmq84XtUypKNbFzfCfKa	6522	3NLadJxWPH3tuyEZ2cqBpCo12jVSPq2vNyqjhjmN9Q47hoJ315Gu	1405	867	68	1	6301	jxpnYYA1GT3PPPh85VNT8DyKh2hNxYGAHoJvGNpFvBdstCVM3UQ	3381	4773	4773	1616798340000
6532	3NL4fWpNX2xX9eUYhD2DZVwFyWJirH7RDvJGTB2vwHFjosFSHxdV	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	1407	1395	68	1	6301	jxCj745S1mzDzaR8czL1uXyP1aL4QSpHyx5NT55aMUv8u8g1on2	3385	4777	4777	1616799060000
6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	6532	3NL4fWpNX2xX9eUYhD2DZVwFyWJirH7RDvJGTB2vwHFjosFSHxdV	1613	1103	68	1	6301	jwcwQcHkki5XovXpNeuMRTXqj2pbDa5F8acDW46DpJeUJyxpT7A	3386	4778	4778	1616799240000
6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	6539	3NKZNYJNrWsMiVtPt3xEQ19FMBbDExM7suDRdrwLTUQeSF3jTXwK	298	1308	68	1	6301	jwfZLK17vRiCSeR74UKggJDYEUh6abU6DxTbeAYnYQGw6RiCEBB	3389	4781	4781	1616799780000
6546	3NLJqCQSWxx5AXCinnpmfYZYeiDDYFNWLVgqyizGjyTyvANQMgo5	6544	3NL68m5yXw12h5zXenskDCxQUbxpwW8D2GuAw1n8AsSAafyZdZij	43	1064	68	1	6301	jx5YvHKBB8RKYrQZSnxqGuruNMKpvN8Q5VAah7G6maXKEEykJjh	3392	4786	4786	1616800680000
6549	3NLLeagLQsxUH4TviC8T4eQdyh7sKGXwp6aj8BSCvequG2Zgymyv	6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	1444	1015	68	1	6301	jwn79eCzFbKcLEiaUuWAUwfu3JybkY71M45VsjY3y48xZGV68tv	3394	4789	4789	1616801220000
6552	3NK9HqdidkLQRFrWiQumjX3QGYuNCdsJ4dMTB37stb26dh1m6ZDc	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1474	1329	68	1	6301	jxH2wXrCxdYhAXSUYq6PcRZR9PpvAkD7gT7neUerUrcyofPZRDd	3395	4789	4789	1616801220000
6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	1458	1077	68	1	6301	jwMP7VDtuUzgK1tpPVLuQok8K6JuBVvmHESxZNzCU8VzXRiDHkW	3396	4790	4790	1616801400000
6558	3NKEgCfenSfvCQyNFrkBm4vDdiwJERkjyy9sMR13gJNoi2yGwN3H	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1513	1253	68	1	6301	jwi8FTgWX29BjsJ4LYjo7ZhnTPnzwGHsa9q7Wg9argZ9hNMGCiX	3397	4791	4791	1616801580000
6560	3NKbTBZe37fgBrTHUJ18z5u9gqtdsVxX6mUJyyjUvEomSLM9qJHb	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1406	1393	68	1	6301	jxCx6uxPYkK8hSkeWRAgA5VQajZQkS7gqDNV7jBuJ2P91XzHtkq	3399	4793	4793	1616801940000
6563	3NLS7tPK8WEVn9iksLLFFk28f5EsU8Snaw4H6a8b3tbaDw2yM6U8	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1522	1322	68	1	6301	jxw16wdsKUhJzT4dwHGLuRdcJjrR2XmQcRBBeBYg5fCL3ENpJ7Y	3399	4793	4793	1616801940000
6566	3NLmpigAPaCzBGRg3rnVunRGUm66PDhXSQ3Vm4GWa6teiQkszaUa	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1593	1346	68	1	6301	jwNcUsVJtdineGxoxdAFg66qNBN22XsM23wUyASFbbE9pgd1ucr	3399	4793	4793	1616801940000
6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000
6578	3NKo3AJiZLvR7BP5Mx1KfPtKzUaGNmtwfm8nBMAw3nuCkCSRYumZ	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1406	1393	69	1	6301	jx1V2wPPzFXYvHgmAjDRChbAFiwsi49nzTFv2Bdw91cogYR9paT	3405	4800	4800	1616803200000
6582	3NLGL3xZcSwhv8QXe22j424nhPK54gMwPy5Mz4pq1N3LEVLbf1Mg	6556	3NL7gTrtNyXn6XG2NGmxorubHadufF6uduEqZj4BL2dYVdBfjtWX	1581	778	67	1	6290	jwZd8EUZoWqQ3sRQjMPiyUXubqEQVLGMgRq6Kcg7wkYAAMDpJSr	3365	4801	4801	1616803380000
6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1448	1311	69	1	6301	jwn7pG1WvbZ9UmdcERofEN3ryh6PUNP1g57FCWAjn7Jw3kGdcbm	3407	4803	4803	1616803740000
6592	3NLWGct5UR4nm8bne17RBFmghhN9Zrrm8hPRXQoVt63C9Cat8C53	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1406	1393	69	1	6301	jwjByxrc7kh36scrPLFQ9on2X4yXUDoPtyt4d1cBA1KW2877VPU	3411	4810	4810	1616805000000
6597	3NKDJvvv5ZXnnCacg8yxZsm3Juu7yAjGeLm5yRgknC7oAVu3MqoB	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1406	1393	69	1	6301	jxreR3ya3ndNNTHzv5rvmG7ZaJYWKJkFR5qWrbaL4gP8LTTBpDM	3413	4813	4813	1616805540000
6601	3NLZsduatgB2xqXd3eL1YXZoBAY9AUDj7wYgSBuBoquZYKNJtsSt	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1489	1254	66	1	6225	jwvwBkGwfcWRL55JANR5SASj3EsyRYEnPD8BxaEuWYyag6brEN7	3328	4813	4813	1616805540000
6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	1656	1343	67	1	6284	jwfk4dXWgnYFrSXFQT6EG3U3dmqr5GjAfLC57nU3dBm6iSRSwTs	3360	4748	4748	1616793840000
6489	3NLqVdo5WrspVi9vYCRahXWpETeCkhUHGUDSPeDkg9F45Hztcshm	6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	1406	1393	67	1	6289	jwCoBKUPP454TNebY1hVrid4w7u4DgjE2NK9m4riucgziARmN2S	3363	4752	4752	1616794560000
6494	3NKxgRaJcCaMg9ZbHiUBqxgLps8b8Ym6NNS4fzjNezgLiN1jE6ji	6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	1406	1393	67	1	6294	jw7PPDm8NzawUWuPvyyKL3YHddGQUPvrokUi7Qzqex65J7Z7ebn	3366	4755	4755	1616795100000
6501	3NKcHs6cXJM1BMLPKNpJbEa19VgTAzTnQG23sFdjRUJEULQ3Jc3h	6500	3NLWRuFB7G8CPkizXnRwpAUcQu5cAS5RTWE5vhWL1XBE47oEJ2kn	1637	816	67	1	6301	jxobKr3DJzAZm8F2cS3wgKhiUP4RD2Hgz3iakFDx9c5qgCsbMWM	3369	4759	4759	1616795820000
6504	3NLtWzp6fGrxgYicmwa23Vn4dRVobmb9J3E7MeaTyfBvGDsdwEDS	6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	1471	1386	67	1	6301	jwj23MkrqQYkq47L6pt66VdgZNhJ9pwunvvonxLjniTbKjapug9	3371	4761	4761	1616796180000
6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	6505	3NKWxDHicDNvTN8SapHikwNbjKcn3ihy8ZZ9KVENtABeaykYCXpi	1406	1393	68	1	6301	jwDVoLRYRRUtuH4iVpBrvaSCxtzQYCNQttgvuXmkiYgkxtk8ejf	3373	4764	4764	1616796720000
6511	3NKSqEyyCqJdmHKigUXK8j5m4CaXt6nbN5AxsAZ8DCA2dCgftPAN	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1651	935	68	1	6301	jxNuH6yXQ4gCrie1Nx6oskisZfXYV2jugU8EF8f7eSDw3yWnwPu	3375	4766	4766	1616797080000
6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	6509	3NKQhv6TMwFju9PD78Jt8RU6538Q4xbRiUYrZ1c7n7EBtWz4jCS7	1455	1332	68	1	6301	jxEH5JvBT7VbosW3neu3zQFyQYkn6y5C4f8VFXDNDgocVmmuhvq	3376	4767	4767	1616797260000
6516	3NKLHPefwSiCzW38wyHcsF8mxGAW1A3JwqkCbVsyxEyF8mBJeNb1	5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	1647	1056	59	1	5778	jxxAEeyKCdGBEuGvUYkqhBLGF41EcjsTqJrtBCP3WZfCjszf5Au	3092	4769	4769	1616797620000
6522	3NLadJxWPH3tuyEZ2cqBpCo12jVSPq2vNyqjhjmN9Q47hoJ315Gu	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1422	1211	68	1	6301	jwDXKMGcKXWZERnAaZbTLyyf1htDKwox7dAJuPH5kSZNz8SmDp5	3380	4772	4772	1616798160000
6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	6526	3NKUkJj3HJphJWQCg5ANRwTc1umPi4yDAeBDj3dJYPB1tWBFmoMo	1516	928	68	1	6301	jxpgkKiR7APnPNUq5RoqrL5dABKGJDkP544Xdm4mc72bSuERZxu	3383	4775	4775	1616798700000
6530	3NKkCWHojr3utJvj2QHEfDfMMJWi6qUFzaTF8GquRBUK3k6KbKmX	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1553	776	68	1	6301	jwJA5Wau2kUkkQZBpKmumREVuXHQYcFotMa9YnjfQYvgrSBMb8y	3384	4776	4776	1616798880000
6536	3NKLM1XXYAJk3M4Wrniad7r9N7B9DFsUGtFowbhnRpn18zyES4zD	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	1527	1293	67	1	6264	jxE4Emt1DBgedL3a9NPREx4D54fBods5cUqfB3F7okQjhBMGRDj	3350	4779	4779	1616799420000
6538	3NLNp3VCcy2dCtU9pkH8rLuGXyEmXh5wR2VxVSafJSrXpsHKdFCM	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1527	1293	68	1	6301	jwTHLAnNDhHSkzLnACQ9zdavKPCN4LbNui68AMKPDcuM7aiFC2q	3387	4779	4779	1616799420000
6540	3NLcFjVvCrd3YS3z99VGxfMtbdhnemJfaQtHZxKuYxMkPRBF4DG6	6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	1590	934	68	1	6301	jwW7De4L36MrNb8U2WoifuCzuobRL9xJ2xvXYEhS5vVUej3wgS1	3388	4780	4780	1616799600000
6543	3NLXfcwuQ7R1mmeU8StXhoBeTEESmtac3T2og4dTq1N7JehVfSk3	6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	369	1186	68	1	6301	jxsu77VBENNnadj1toPmRT7inUk3zAXEr39jjrRxhHath5eZKZT	3390	4782	4782	1616799960000
6545	3NLk2rAyR1NLANWPvnpcL7JdQMdpAeypmFDDyycdppTGotRRbw2a	6538	3NLNp3VCcy2dCtU9pkH8rLuGXyEmXh5wR2VxVSafJSrXpsHKdFCM	1481	790	68	1	6301	jxCf2QdzFnryq8CJYu6NRepCv7TVfTiJV8e5gFcz8ZmjCdcKuSN	3388	4784	4784	1616800320000
6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	1406	1393	68	1	6301	jxkKaCFa5QCFLCySTd57p7cpDhgk6CNF6Lec5qJpf3zc8qRikdn	3394	4788	4788	1616801040000
6551	3NKqkFpDyUFYr5hiaRYjDnj6eZRih7B7Ciz1C4bYCLEwTCY1BvYg	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1647	846	68	1	6301	jwbiUQqLWmtYBMK4pnWfqRNxZM2ynUhTcgQdG6pKyfdjVH1oTr7	3395	4789	4789	1616801220000
6555	3NKmMNzY4ErnwDc6Fr2xDT7p1bwQhUbzFnEAeGExBAD97KST8b6e	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1448	945	68	1	6301	jxAcUVk7KcTxGg17FVSvmZvxvVtkdCeXZ1QbBw798BGi9QsD49u	3397	4791	4791	1616801580000
6557	3NKVNTqYEu6P3wGHrH3SSAKEPajQRh8WVnGsUT7F4DD83zNPyQ8V	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1527	927	68	1	6301	jxP1pi6LU815nLKZTeGL71GiDRthx845mtVXBAFRgWXikRZwTYT	3397	4791	4791	1616801580000
6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	6557	3NKVNTqYEu6P3wGHrH3SSAKEPajQRh8WVnGsUT7F4DD83zNPyQ8V	1622	1356	68	1	6301	jwgrxLvjhThkcYJEoYBeiCShos7VD4nLcoTgQpyj4gytRA5sthM	3398	4792	4792	1616801760000
6562	3NKV7Sw5Cp8s5SjHD2K7CTi6esqMS5XheftrUxqri5cgpaEZd1cN	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1657	1344	68	1	6301	jxpec9YKaKwp9qJqcrgRANb8ZL115XMofLCzwPHJ6jrfEowH331	3399	4793	4793	1616801940000
6565	3NKqfGwK1rgjKMy8B38pD2oA2vVNAgEZfdt8CfHQsNM9DC7cvsYY	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1631	794	68	1	6301	jxokUXwUrovFXnBHk6pjhmkDkkiDzeLMrsjbuqTKkAkJqMDmuSQ	3399	4793	4793	1616801940000
6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	6567	3NLx3bqz5wS9fvnMeFjGENvKC4bkr4tmhfzwFRcvDDKzmgFCyPF8	1668	1370	68	1	6301	jwxGibwKDSga5qdbzKfRvgDVDZXU5kFs3wbKdztSYX6jAudQ8zw	3401	4795	4795	1616802300000
6570	3NLhiTd56bS6BA8KrdWmq3iNgSStg6SrksZMPzEZj1EnVyf3XUr6	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000
6573	3NLbrZAjnakrFd96tXttGssXxCHtQApkjJKF4XQYnJuFRt7eyJjy	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1560	1045	69	1	6301	jwSAKymRgZpcdSpzL26jwGa99rfoKcvLvhhKgSQDEdDn8uz5aaK	3403	4798	4798	1616802840000
6575	3NKpspF2Ca8FxqJuDjeqd8uDsywbUb3DZQivVoDG279thbTjMxxv	6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	1442	288	69	1	6301	jw9WgHBTQK2pnqi5X8Zb1ZqCjheJMDgPP79hgzkLZQCMJ91BX4o	3404	4799	4799	1616803020000
6577	3NLkisisxDNWAwQRMYcDu64TFG3mJLxrB8Li9hVCKwLJ7doR3eA5	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1467	1376	69	1	6301	jwu3cmoTKs7jxjEVjqe8cPdBkFQKeUo4uLHEvay4ZpAKRN5WtMj	3405	4800	4800	1616803200000
6580	3NLM5GS5vtByLZb35FcVRRrEVrNMKEJnCTSWJNtnVoqRiM2RyBe2	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1546	1093	69	1	6301	jwtqGqhYWhnyxVxU5kfCfg6s5osJ5PuCgzgiDo3Fji4o6GazrKq	3405	4800	4800	1616803200000
6584	3NLGRY5jfqm5qvsRzH5yw2CiEBxh2nARBo8gZcyURgARz5m9a8Wj	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1403	824	69	1	6301	jxeRt9eV32nzHvf4AbiNp9sPxeaRBM93uaaoshRQjSzTUkPgsdy	3407	4803	4803	1616803740000
6589	3NKQbmhjJF5EZqB7PvpsBK3PiDTK6UrVfRoFsBLMq3VTYnWCtZnm	6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	1652	1315	69	1	6301	jwqrLDKsLwX3HPVLa2QYBaNqGt5tvXaUKzU1A6TijrPcToT3efQ	3408	4807	4807	1616804460000
6579	3NKkf3q768NKarGjWxB4YxiB1at5o2qhHAB3PT5taCjTxSbACv7j	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	311	1307	69	1	6301	jwEtDUAzUFsYSmo9Zik2vx8WaNWWip7xyuk8rKT6UkDUJspGNhb	3405	4800	4800	1616803200000
6581	3NKMKPyDwGtQtdip4TEXsKJ1FPsGZqVaU7TG5RpsUq9uyhaHjJXi	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	448	1059	69	1	6301	jw742QNnjfHfyPTKqq9bT8Gco4Z2r6xJe8HnuuSsscPggEKwPh2	3405	4800	4800	1616803200000
6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	6577	3NLkisisxDNWAwQRMYcDu64TFG3mJLxrB8Li9hVCKwLJ7doR3eA5	1506	1127	69	1	6301	jwgKa2E4eJZp666kn4V3hBr7BmycemtJ2AcpYzPm3vairBriCu8	3406	4801	4801	1616803380000
6587	3NLLkT4sJxQhmh2n7dysPTuRthb2HjvwsL8SktYG6PtueUAXyR3S	6582	3NLGL3xZcSwhv8QXe22j424nhPK54gMwPy5Mz4pq1N3LEVLbf1Mg	1581	777	67	1	6290	jwXJVDdi6MeR4doNGfZUfgo6SGa4wTBnZYe7GFYULhTceJtaF2X	3366	4804	4804	1616803920000
6588	3NLgbXtcv1VuaxneYrcVQ1uFW5pJg6tYqnGuxeJNCuvhxahhfeox	6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	1506	1127	69	1	6301	jxvdKmkb16Z4f9EbGhziB3iPe1KVCHiYpox6kyokdpRunHjmUQz	3408	4807	4807	1616804460000
6590	3NLB41P4cSxWCEnKp8ZsogmsLEhZ65MxZCS4cqetADfyzj7pwowm	6589	3NKQbmhjJF5EZqB7PvpsBK3PiDTK6UrVfRoFsBLMq3VTYnWCtZnm	1406	1393	69	1	6301	jxQZWGvgn9jSRQLsNiNeMtQy495XwH4r9nxMW2YcPxc47poSe96	3409	4808	4808	1616804640000
6593	3NKVLq1rNjmF3KRpVdHxr6CPUstuzV2TLPWRf11sQzeQ6DSsLHLv	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1407	1395	69	1	6301	jxgFzyrqmrCJsGa2t9gKA8723sZkaeSitPQixL8oK7ThbijDYwX	3411	4810	4810	1616805000000
6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	6592	3NLWGct5UR4nm8bne17RBFmghhN9Zrrm8hPRXQoVt63C9Cat8C53	1560	1045	69	1	6301	jxQXCqsJ477B6tEngQPwb7JQCuDJuX4jhEMQy919vhFqLGjrB3L	3412	4811	4811	1616805180000
6610	3NLxLBW7Kvts6FeCfZ7SEnUGJkrM4ZGyRrnbbLyRZo1ozoYj46VR	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1489	1380	69	1	6301	jwzPA2edhpjGXfAuTf5SnjZnnWiXmaJHGioVEWpycsf6HmerWok	3419	4823	4823	1616807340000
6614	3NLwPecg4h8X3PJRwQNZZM24CYbwURWUcmgDsPk8DXfzYkawPycU	6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	1579	1263	69	1	6301	jwfpYnPyfN3mzfchsfde1n4z6M4bakqzLYbsu9ds2SraEaWx4rw	3414	4823	4823	1616807391883
6616	3NL9AEGWkqNT7euGTZu2cokH9KmFYsBT97NXwRa2n5fw1RopNV8n	6610	3NLxLBW7Kvts6FeCfZ7SEnUGJkrM4ZGyRrnbbLyRZo1ozoYj46VR	1406	1393	69	1	6301	jx7dyVmF2qvP59y1f3oe7iKNVtoupWBK15pLHoBjLPeRZ3v7Dj4	3420	4824	4824	1616807520000
6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	6618	3NKhPkXgN8fZNqEp13Cu26zHvdtixiZyadf5oejKLaqYZFF5wubS	1483	1276	69	1	6301	jwH9yNkvdZY8rGpYdQTMaqRBiBtPNayTXe1o9xbHyFfYT7Yk5MH	3423	4827	4827	1616808060000
6621	3NLuJck3vnHV46PEtXLgUCApS7dVcTv5uiAnxPNXF8Y6keRatkgJ	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1617	1288	69	1	6301	jxDTEtMb1gHHADzMgLC2QBxUdUo3ePYb28KoBtYgmWmPZJQby7j	3424	4828	4828	1616808240000
6629	3NLrCEmpyGVAsw5FeqgRz4snY1L8pT1a3FCsUyHtDmVx77hLG6e4	6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	1402	874	61	1	5870	jwBfd6rkysdzXjbYLDpQHXaA5RnyxVmsLhV25iNycMnBYxHer9o	3147	4834	4834	1616809461122
6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	1588	1146	69	1	6301	jxFTYoHib3njv2YAcQXKxvJEeQiH4jm1NVpXqYVDWER2RTLAbQH	3427	4835	4835	1616809500000
6633	3NL9bxWW5r8HzaAatEF67Q79dwbiTqTV8YkK3wuKFbtvJacy3zP2	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	1542	1304	70	1	6301	jxi3NrhpL1UgjM1juGnXu84n8NR7239mhFb27SWVSmpqgHyzBBV	3428	4836	4836	1616809680000
6638	3NLMrgLJXWtva7mF13enUVUfizqquBjsNK2wSa1fm8zhXHZiEnHz	6636	3NLGceYz8UqDKkVm5mWQ44go39JFZHZbxLZqtFzaTCKKtZwdpaKe	1564	1338	70	1	6301	jxUsAwTemkdvtMYb1hs9YBTP3YxS2VzVepY4ByWwqRHQSKqFs8h	3430	4840	4840	1616810400000
6642	3NLQtUHtNKsy9b1v71kV33zLrLSaZPsz2yw8H45X3eUcVwhmCdnD	6641	3NK8Be3vwTrjnTpHYA9zqtdWJW3etwzjDwnTJoEJCzhkANkTtdof	1527	1293	70	1	6301	jwBWo5EAFRjTA3gtu8KqLzaNgo4sZHksUTJuhDXqAAgbD66xzYr	3434	4847	4847	1616811660000
6645	3NKDWdR6sPYT5t45yXfL4ALXDdR1ow62mtzeQpNS3J7CvvocCrw9	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1637	816	70	1	6301	jxriEkYGcy7W8yQn8DsYgcsVuXdqXmqwE3FpgjhP4qHagQJG6a1	3436	4849	4849	1616812020000
6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	6647	3NL1Cb3Edwy9JjW7i4VLYhVQgHcP58fHoq5RSMdtcqc54xe3pxAQ	1654	70	70	1	6301	jxEZLUJnzzFjaYcdz1LKmepi8R938ZKHMwBz4zdcC8Ud67UHaac	3438	4852	4852	1616812560000
6657	3NL5EDEaNRJfbmBFSfS88Xa9V5CFo9pjMinA8s1A1WNY2UvaGQcA	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jxq49Va47smD9JFRJ3mqC8XeF5D1uncEGRr5e9GwmKnTC2naxy2	3442	4858	4858	1616813640000
6659	3NKQvJt2eyAHrgtCgBXW1XSgSt69R3KDBvoCVCxVNq53K6oyvJaF	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1397	828	70	1	6301	jwEYqyeYXdCdFgRgpeLMVBDvrXphLUjuENHoAdVSXwXDreZvJy6	3443	4859	4859	1616813820000
6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	1647	1302	70	1	6301	jwCjwuWdNMTrfxEZ9xyjvk6a4uoBQY8DjnkntiWb1S4D6R3hYJZ	3444	4860	4860	1616814000000
6666	3NLSu9FEWErrjsaMnokHYYNc9pKMZhvtKzTfPHsMjLVYPdfLn43e	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1406	1393	70	1	6301	jwM6Wg3hb8yrVAEVz4qn1Ri9cDW3gRPNCi9WagFXSS2RyG2kBYq	3445	4861	4861	1616814180000
6671	3NLptqoXc4UgyzwNcHkopz1aJb8wTfoyajqhb5FN4G66TCC7cKPS	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1613	1223	70	1	6301	jxQ1WBJGDChgvyTLB2Knpubd7gHRZL82BuNvG14kNNvRJMk1dcj	3447	4864	4864	1616814720000
6675	3NKo9xyYv7Qb6mV2ueE1g8oyTwLhUFN9LWMtft19ruSyFZFbBoLX	6587	3NLLkT4sJxQhmh2n7dysPTuRthb2HjvwsL8SktYG6PtueUAXyR3S	1581	778	67	1	6290	jwxs6XDDXo1Pnc6WFufEaWA13VR1pCyrMMRP72cwt2rXg1so2aF	3367	4868	4868	1616815440000
6683	3NLkBRHqRKnnwMBsSx2fPxjZjmauX2JwbufVqcMiGMRio5ar8zvf	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1673	1368	71	1	6301	jxTiGdhiYVr6BhAA3FgUEraYtCEqquRMGsjRoPWdkwKkYU5hnkT	3455	4875	4875	1616816700000
6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	6687	3NKYUhANis3S4PRNKt7SQsu8ViBnMZAJCu7sxAfNaNKPxSjCoQpf	58	1035	71	1	6301	jx36GyjevCYCKdFwYe4i66nqZ3VVWJ8ssb2v158cfDmffyGT9vk	3457	4880	4880	1616817600000
6693	3NLtfUuJGg2qBXxZ2Yimh51vCMpSiUKJpHpC4cXrtLEu6nz6LQ2L	6692	3NLsRnJfcD76aHg9VTFH9oKJegZkpHB665A95dyVCF8sortfg21D	1503	1031	71	1	6301	jwtD9JGnx8zFeiWah1RUtXocieDFezAkpDryAGfrYRWieZADmr2	3459	4883	4883	1616818140000
6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	6693	3NLtfUuJGg2qBXxZ2Yimh51vCMpSiUKJpHpC4cXrtLEu6nz6LQ2L	1590	1174	71	1	6301	jxzyAm2PLMMF8MhhhhkdkBSrjXCFqYaKsMhK76fLMJ6oXTyncde	3460	4886	4886	1616818680000
6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	1406	1393	71	1	6301	jwpQbrngcdvRKRQwo7p8w295DzYYCydgaLpBRjWnMXE6fCt1adK	3461	4888	4888	1616819040000
6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	6697	3NKj3cNkju6TYnnDAiMMUg6mJbZ7Ykt2FrGCvC7iSDLWGAZY5BK6	1508	1387	71	1	6301	jwtuzA4u9YHXNHvxfd4DUJvyJyYpkQmTSEsvw2j8EtckLpMdMWk	3463	4891	4891	1616819580000
6599	3NLopB9G8Lrbmf1Y4tug8jMQdysJ5mDcQ1ozYMytmtpTBQJ1KtSp	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1622	1356	69	1	6301	jx7eopgx2D28JoN17L8ADaAcDdKg7SF67wBgar7zvDAkbxzTtRt	3413	4813	4813	1616805540000
6603	3NLyQcqnWkSUWho7gUnKEUvjabDMqBtwD3LRL2vpeVQhDRYGKAHc	6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	1406	1393	69	1	6301	jwjTrTKznLtGSCGAW78Az2YgbdsMmLYq7Gj2cdcsqPBxuvDRfUG	3415	4816	4816	1616806080000
6609	3NK9fDhRWCMqsW9Lyiw2HUsZBk9VyrCasu1BNSHiKn8s62bNBPot	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1579	1263	69	1	6301	jwjpEPZy3b5zoLqV96SPSmPKpn5TkpHD76yAyvydADAieBKujYA	3419	4823	4823	1616807340000
6612	3NLYULUMrrXWMnNpFLTMNNLocMJAJdrjDJVgwkHhqUGW6EnyF4N5	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1613	983	69	1	6301	jxSM3kdBrK53mtSkXdNvQ3AUsQv7RXJkAP3nxvcDpDjk9TUVgMz	3419	4823	4823	1616807340000
6615	3NLszp1sjHMsVnmKW2DiyvFAyQ2XYcR9nPoEo7KkurRQHHF2ThoT	6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	1579	1263	69	1	6301	jx5CGgtPhjDWGMJAt2bNgqfVn4rWfeewFWecZnGw9B6pkS8gK2j	3418	4823	4823	1616807456519
6620	3NLbDGYUETJv2XbWwK5U4vioKa2KucvromSJ7gi8D81gLmD1QQgh	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1553	776	69	1	6301	jxc27Mez7gtBbp2A2srBKxEcATaMFDwCZm9aFCjAfWRZ53YeVVr	3424	4828	4828	1616808240000
6622	3NKhRxtQTsww8pZjAA7M4aPQXRhDjVKnpo5WBmneAc3HZJDzybtP	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1637	816	69	1	6301	jxZqzEBPfsSxESazGC5zGSYckXex5pfkUB7pCbQm97SjWh6stUK	3424	4828	4828	1616808240000
6628	3NLGTbLxAyRQLECTKXHUGGvA7GCrsh9NMNUTrNDd4aRvB97zzrUf	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1402	874	61	1	5862	jxLRZoM1LoNTBW7M5nb3ovieikwiCJL2DnCaL7PiZMpiRWrf42X	3143	4834	4834	1616809425608
6630	3NKdNiQ2asZXQHt7UKEbkQWEnvAdRmygaWAcfbuWnB3DSDwRMW6X	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	58	1281	69	1	6301	jwvJETNaiP5HHgGvf6tYBvwikNJJHuLSwjHXauv8LPdgSLpwLET	3427	4835	4835	1616809500000
6632	3NKCp85J2feSWeYQMKgL2Ys3kTbgNjMKH8gZtVK1gY3RkstKwLzs	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	58	1281	69	1	6301	jwT5xGgDo8eYbyR71rjz1GwfgH1PJ2K1Nabs7j1PuQok2gJxKBR	3427	4835	4835	1616809500000
6634	3NKCi8KNSWw1kEKyankGGVtQj3Qfg4FqFRkWNeGsdRdN3gMRyFW9	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	697	697	70	1	6301	jxkVhEPLNk51EaZETes7R89q5aXrqar1Jqxj6WKngx5UuiHCeEP	3428	4836	4836	1616809680000
6637	3NLfewWPgbd2gC37RrHFQVBmu7ag9VCUqZxTGTkuUkjVEaw5zUme	6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	1553	776	70	1	6301	jx5YpGgyiKQpSnTkkAKWNKWievTt86i5HaFMrwh8UdT9FQz97HV	3429	4837	4837	1616809860000
6640	3NKKAGumZBtbd8jXdR6XFEYXEAJ6k3SqG1D9jsuTapHGxCLzUpT5	6639	3NKGXzY8Ei8ZLwLjE3Mz49TCEv8teAjdMPGzbrUvJUTzcTKLqPyN	1675	1096	70	1	6301	jwB1UWk2ex7sdjKMscwuwdAuLT92NJnqfsRMnTiSYC7QjGURby5	3432	4843	4843	1616810940000
6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	6642	3NLQtUHtNKsy9b1v71kV33zLrLSaZPsz2yw8H45X3eUcVwhmCdnD	1406	1393	70	1	6301	jxmvz7cJNFuQ71VK3kqV73qeyLiQQ4KViNea9Agc2MocS6hVFRX	3435	4848	4848	1616811840000
6646	3NKT54iidRQPHTTvTyxbe4c7WC8hWRJPfirKktUnzudEfhsFmD8N	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1558	342	70	1	6301	jwEmzy7j9baPRmDxf5ZK2QyU4TsDVjCJ5WvAepYH46EtUiVL8PF	3436	4849	4849	1616812020000
6648	3NKFoVSiC66urALqzh1pYNPxSZS5vgRoy3tYxGTL2mGo1yxVugp5	6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	1577	961	70	1	6301	jxJKGhR1xEBAa5uGPewKCEnc488SnktH1gwtTtx8XoeZ5jfgPZM	3437	4850	4850	1616812200000
6653	3NKdCa1Xx86QvCqUXqM6qHvVGGBdktXBy4gbE5b6mhPG5CUoykhi	6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	1600	1372	70	1	6301	jwZRkNQyAooi5jondX4o2enakjvr1CKr9VyCTa5MjynUfEqX8DB	3440	4854	4854	1616812920000
6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1455	1206	70	1	6301	jwXbjSuRQBV8AaXarP8wURtaBMQc97XJZXrmQtpwTY2PbQUw6NL	3443	4859	4859	1616813820000
6662	3NLcUvrqtXNfxqPEi8KYc4qu2YqfwjNqVkvpxiT7CGC44Vm9abQB	6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	1467	1130	70	1	6301	jxo5YgqzzKVadx9et9ggkrqLMsQAujtH2HTxXXWmH2utPHj2z5i	3444	4860	4860	1616814000000
6669	3NKqoyN66Z7dDHDVo3aPHZaCBLZ7E2cEpBWuihz3qEGYii3o3YmR	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1403	824	70	1	6301	jxCnmAEow2YtdHR98RZKEMdLrcwcea2MwFsr9B3LShpVZ2DiHx8	3447	4864	4864	1616814720000
6674	3NKZbNX2UjpppoYekSA66WNPCUzSXUPzdWMCJBn53JMkEQ5CJyoW	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1667	445	65	1	6188	jxQ8WzKk92aSbnDdnSMZkKw9mc6cajECTnQDAvrJ6Mq7duM41JF	3310	4867	4867	1616815260000
6676	3NLFyVTcARDN2yjWyrviFp511ka6LiGdMaLzTnKHbQvzmAYFWhn2	6673	3NLJvhcPMwFG4MQ9tcjasYHTXp3oQTm6X3TPR3zXL4MRTH5TPQ8M	171	1374	70	1	6301	jwMnKsmdSaVUw3i7uK7z4JjFFxZgLHTwkL48kt2Mmpeed6L9b8p	3450	4868	4868	1616815440000
6679	3NLA6ry8j3Ao2Gz3AgMf88PZkE5aW23D5fuG36hVS8pKuTakEjeV	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1647	1056	70	1	6301	jwbsXp7T8AhFJSpTwDKEuKqkeMPZpE2E5rYUnAz5uwBdU7mM8G7	3453	4872	4872	1616816160000
6684	3NKDQ8mgQgMZdxc4WPQ7LR3EkkXEqydGXMizvhoqZTQQ6EBCRXmB	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1451	1046	71	1	6301	jwvW4dBsGTHLvXny9gqFmQ12KwiCAV3EGy1x5m4RPLzxVT7Fj1Y	3455	4875	4875	1616816700000
6687	3NKYUhANis3S4PRNKt7SQsu8ViBnMZAJCu7sxAfNaNKPxSjCoQpf	6685	3NLwoZhgoqWvXood2QGsvAP7Xo4ymWqyAux8VFnH9QeF1b52gt4G	1406	1393	71	1	6301	jwmKE6X1D9v6UoN6KhDKJfhZPauzpvPq4doXQHtgvHXUB5MicZ1	3456	4878	4878	1616817240000
6692	3NLsRnJfcD76aHg9VTFH9oKJegZkpHB665A95dyVCF8sortfg21D	6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	1565	142	71	1	6301	jw9BCCEcAxeBzvjch9XLRUYnBJq4JkbLCMAcvbeMuKnyhEm3vPw	3458	4882	4882	1616817960000
6695	3NKEui4nrJUGCaJQ7EruQz2Ebr1ZhRtSuvGY6QKcNM9bHJLyLb7m	6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	484	1073	71	1	6301	jxteGRwVDGuWN2WMkna8XcssH1CYv6uqkxkrbb5cSsWN442nf7R	3461	4888	4888	1616819040000
6700	3NKNa7ByBUfqSqEarqMzAwBSg5ivwAZAafynu78GirSKzsiXzcMd	6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	1426	586	71	1	6301	jxkuSRNzCDoTujFNftedJoHgbHW4vpQSNCJgaUPNZjX1R6NsGXU	3464	4892	4892	1616819760000
6706	3NKBDXqYpdvanNdBj3zqEGKqJyCLGrNeJAbmaaACGLqHjfCer7w4	6686	3NKd48XonyZmJjhNvRtwxg6AGA4YETAju3xVMEonj3vRw7r3ciq4	1581	778	67	1	6290	jxRBi32cpWhpafVMkwe5zSJ4ZQgdeZHgojwjZPZWDzBb3RQzV39	3369	4899	4899	1616821020000
6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	1599	1287	71	1	6301	jxAPGhWE3ShQXfhVAu1zoSnX1PMu8Eoyxvat3TeRh9hSminKakk	3470	4903	4903	1616821740000
6711	3NLbkrH574SUd1mtKymbBhop657qq8AXRfSoYV2CrndtW7eTahd7	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1406	1393	71	1	6301	jxsiSPERgBpofHHcAFMtW1vDKoA9U29qexc6X6kR9xYFRc5SwVJ	3471	4904	4904	1616821920000
6716	3NLvyur6iriFfLeEP6vMMh7SRSJEkSGjpMX9NN5pWHrccBJG62SD	6714	3NLqXiCRJL2eVnAAKHa6CDB1nTDN6ur2uGD9CTvt8mcPtAhyU5du	1637	816	71	1	6301	jxwxDhqvHTfP67CsN1mD9TNptbAG259LUW5FZ8nuAMGBXN1hDnK	3474	4908	4908	1616822640000
6604	3NKDYyxiv1xo4f3qH6qUmdTfsYEtyPH57LyTskf5CokENMCzaKwp	6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	1607	982	69	1	6301	jw8LjGH3GLVQDLXeaGLDNUrCf8o482HzpLvZ8geQGBWhj7gK9Do	3415	4816	4816	1616806080000
6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	641	1336	69	1	6301	jxfq3g5xDHiaRNGYSekXquuvQGFUR9DB4cUR4PdxZup7cUba2LN	3417	4821	4821	1616806980000
6618	3NKhPkXgN8fZNqEp13Cu26zHvdtixiZyadf5oejKLaqYZFF5wubS	6617	3NKWnCuoQpKsqVMwW88ncm184X19gowgRAXUR7ctDKJ7jyWUhThG	1406	1393	69	1	6301	jxd26q33VknwQpvT5boDxRWkD8aa8KDbTs6HMNLcUi1tgt6p5dw	3422	4826	4826	1616807880000
6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	6621	3NLuJck3vnHV46PEtXLgUCApS7dVcTv5uiAnxPNXF8Y6keRatkgJ	1483	108	69	1	6301	jxRCm3jGx7RcPACTRy8UyWs5Hy4khgv5XreZJoTUURRVLcjCQLb	3425	4830	4830	1616808600000
6624	3NLg1QhxeVd5KS64NCCcxj5fje7ZMm6DHWg52746Yt42yyTioKdp	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1444	1381	69	1	6301	jxEGYVm81tigFC8n1NmSSHGHqPfrju9TaDKNE4b4nLZyzxTnGcW	3426	4833	4833	1616809140000
6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1611	1095	69	1	6301	jxaCqCPnusP3R6LvjL5qJTkataLPDvVh6A4xaWPvVNXWKd58aZx	3426	4833	4833	1616809140000
6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	1633	1390	70	1	6301	jxmrtPqAM1JhscaY2i6fQNpw3VEqF9h4eXtjsQm8xqm2FsBTuVL	3428	4836	4836	1616809680000
6641	3NK8Be3vwTrjnTpHYA9zqtdWJW3etwzjDwnTJoEJCzhkANkTtdof	6640	3NKKAGumZBtbd8jXdR6XFEYXEAJ6k3SqG1D9jsuTapHGxCLzUpT5	1407	1395	70	1	6301	jy1kpE32K9bazpbQs5jxiA681SYDpqQx5pjktEpsUyY95nTcDSP	3433	4845	4845	1616811300000
6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1403	824	70	1	6301	jx8UZpDKs8qNLDqkkPPxDzRJxn7M79RCEx28LLKeMrJZMhfXuRB	3436	4849	4849	1616812020000
6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	1490	1148	70	1	6301	jwdVbSTDHJ2qc5ZuATWkHBt6mYgSjnFQFEX6w3RWjEzA3UdkQw2	3439	4853	4853	1616812740000
6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	6652	3NKCF6TThgrKtsMyHcQ3vbfb9oGBw9aJ9PSJ2bMTG79u2aaaet6W	1457	1265	70	1	6301	jx9qBLgPg8JzLx9y38RuxdZJoiZ3fgd34QKXoVUkLDTvp7AWZSc	3441	4857	4857	1616813460000
6656	3NKMAAMrz3ggdgiQF7zyF9LYbErW8EsJvnXhMK4w9Kpdgd3miSHJ	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jwVS5TBTwwbGCZHXRRv1dTQq49VYVKLccPgMT3BuNGHhTK63KER	3442	4858	4858	1616813640000
6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1419	814	70	1	6301	jwnxk2MLYyg4s9S5NinEg4JKK7TFVKTc7xeNEZbDofSpk5zhRk8	3442	4858	4858	1616813640000
6661	3NKSLAAJrRF8d1bBYAemtQo8RCCBpmcYVFKHiTKdkqkCkAidTn2b	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1407	1395	70	1	6301	jwTwhMpw6oteot46SfdTUZytDYeYr8yXNfp1Q6N3gRWuejchrWk	3443	4859	4859	1616813820000
6665	3NKGuC8aH9pNWn3f5jTKCTaGe2MMx35LaapjmyFrg94JL4g3HuwB	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1403	823	70	1	6301	jxPW25GwXmUna8aDL7PzDkFAxZTHWVNbMRt6oK6uNRiQyaATGK6	3445	4861	4861	1616814180000
6670	3NKAVDvWSg5tESXfXBV7JEEXSyCT8o8Mrs1uTTGYY7HD5GhjGjXV	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1547	1378	70	1	6301	jxm5hAUXrZYLW1zbQXg6jyixm5gWPLxFFZWqiy2vtnKz2qiaeXz	3447	4864	4864	1616814720000
6672	3NKQdv1zgaTrSoQhcyVwW1gq81nYdEC4gHZ1g4DcU4hWe5xQ1qE5	6670	3NKAVDvWSg5tESXfXBV7JEEXSyCT8o8Mrs1uTTGYY7HD5GhjGjXV	1470	542	70	1	6301	jxFx4GYV1qBkkXWpoQE2R7PGe8vDH4ovAusUPh9juYWpGgHcjW7	3448	4865	4865	1616814900000
6677	3NK7k5YsfKtjXT3CvEEvEFZBaLSVTaKspNEkkQEYJ3m49eFGsLKc	6676	3NLFyVTcARDN2yjWyrviFp511ka6LiGdMaLzTnKHbQvzmAYFWhn2	1406	1393	70	1	6301	jx7jpq6X8KKiPbA6jJZEt24n4pnWdQkjWTsfhTSy51KMT3MQthg	3451	4869	4869	1616815620000
6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1513	1379	70	1	6301	jxRLB87kUxrqqNirDP1iuGQe5YLxd8BbkBMkRiWqb1qz9mcDDN8	3453	4872	4872	1616816160000
6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	1613	1349	71	1	6301	jxYiLRSyXUzxwVU6MVKRgf1hpg35hRGdGfx27rWSiWJ6j2ZnhHh	3454	4873	4873	1616816340000
6685	3NLwoZhgoqWvXood2QGsvAP7Xo4ymWqyAux8VFnH9QeF1b52gt4G	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1670	1282	71	1	6301	jx91boZ9FUYdThz1RuQcgp1uJLhTwotKnqYDnj1SBdTsQwNMFAK	3455	4875	4875	1616816700000
6690	3NKPJG9erNFMqWiVPHCpV92zJcfwoUDPPqNRg5rYwnt3iLqDjbzu	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1650	1375	69	1	6301	jxDDuJJPJdDBAnR9YcrvgWjU5jbNwB92BygMw42AWz6KJzMnQQi	3419	4881	4881	1616817780000
6698	3NKL5QDHb9fUWfTMNfBuDHsWzwRK6UEYVXWEGhqFmQQdP3dS2xAt	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	1637	816	71	1	6301	jwbF8dLopyNTArhmsgDr2gHoMKYjZ3crqD2a2MQXS2ySNwwZVgN	3462	4890	4890	1616819400000
6703	3NL2CxK5C2dc4smwSgnzSHQymx59Xc92eHpdEkpQ4CYrpW4ZZNQD	6701	3NL3zkj85sGdh1m8KHeC33XJY6LwWMywqPPBSdBwDTZmSsDamwiJ	1455	1086	71	1	6301	jxTmwQXpadsgNErEZ3NaWxVHcCxunDcxKQ3zYopwXrtLSB6aTCR	3465	4894	4894	1616820120000
6704	3NLZtMnW4fXx5DbaxCTyQhASB41Y5Uzo6N9onww5VgaW1fJRV4DG	6703	3NL2CxK5C2dc4smwSgnzSHQymx59Xc92eHpdEkpQ4CYrpW4ZZNQD	1673	1122	71	1	6301	jxwZD7TtAWjzTMrJL7jxGDG1DUMDHNqFkpAgW28eh19zM4wE3Az	3466	4897	4897	1616820660000
6707	3NL2iQnB7pNwxEwNd8KwyiBtwKGFkQRoFaAhbkGYKMQQ5gAJrbNK	6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	1407	1395	71	1	6301	jxP8mL2Ft9thsVDXpF8fGrr5JRaLPNBaNdEHDbM9ZPkAmYR4UsV	3468	4901	4901	1616821380000
6714	3NLqXiCRJL2eVnAAKHa6CDB1nTDN6ur2uGD9CTvt8mcPtAhyU5du	6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	1588	1392	71	1	6301	jwvYNUD6wdSQWmHDzQb8Xaxv4WoK4TnCuBjoLPWjGUL2xjEdNKa	3473	4906	4906	1616822280000
6717	3NLpzFn9W11fxkjrAtEMqJHNVqhnaQKarzJQCdyTDmFXH45DYD1e	6716	3NLvyur6iriFfLeEP6vMMh7SRSJEkSGjpMX9NN5pWHrccBJG62SD	1407	1395	71	1	6301	jwtybSvWWnotHzXDYubBBMNHvLpSiYJtjUuCTiVMj7VnvMJnzKM	3475	4909	4909	1616822820000
6720	3NK5pERoyog1nZZaKGyFCVok64W4iMsE2jej1NmcHQJqMmX5DAVS	6564	3NLUCbRvW9VgdEBqUHjviMHRp7DFydLQS6qbok66r5MTuLoSiWAF	1481	790	68	1	6301	jxctEjFLGuVyBd1RE7pgXxwTtwaoH2XXjTqkr68VrqRR86qgS4V	3390	4914	4914	1616823720000
6725	3NLBwdokKukC1ygyv2HmhDhGGehzPXmsrihDKiPRyAo8qjSh1GEH	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jwJNocPEHTCn92eCpLpkuRaP3P4C2CcTjGVckxbuwWSaWTS9hWc	3479	4916	4916	1616824080000
6727	3NLAyCVXE7PPXzXxn5M3aPecmHfNkToK6Qz9kr3zy6qtkN2Xsf3d	6726	3NLVA3E9pGgavEvpLSet6ZyJZvcVUpXB1GeEoQ4YjK5Pf4ZwJFJz	1671	1239	72	1	6301	jxrk488duMJgXCYLymuVLduwqGBtCgM6dC24XAJoa8pgfp3oKQw	3481	4918	4918	1616824440000
6732	3NLUQ4jtKJoFPVEX3NAshtTgdCepYfxwd6YdeJfQdqB4mWHYaBgU	6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	1585	1120	72	1	6301	jwW6opQXP9FJ6znxiDKPN7feSeBd3YrprwELse59QyLoVRC21w5	3484	4922	4922	1616825160000
6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	1405	873	69	1	6301	jwU3XRPqnDe29G26xdfrcWAZm8Wjh1M5nVqNoEf3kMkc94ow4pZ	3418	4822	4822	1616807160000
6611	3NLUoGKutawbW1ujGKwjKSN5GQm91zWSmzwKn4hvxstQnXhfbbDR	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1589	920	69	1	6301	jwd3v2vGgwCvsujAyU59bjKhfQVuvbz49efefcnkTzCBE6cLmpe	3419	4823	4823	1616807340000
6613	3NLGfDuLsTXTsvu6JB1dbGr5UJahkbaAgrquUicaL9VkMztE2h2P	6601	3NLZsduatgB2xqXd3eL1YXZoBAY9AUDj7wYgSBuBoquZYKNJtsSt	1489	1380	66	1	6225	jwv1tzPdSoYt3FuuiwqHLe1GvK5kkXEehTZ4dbK89Qfbf8ZeUYx	3329	4823	4823	1616807340000
6617	3NKWnCuoQpKsqVMwW88ncm184X19gowgRAXUR7ctDKJ7jyWUhThG	6616	3NL9AEGWkqNT7euGTZu2cokH9KmFYsBT97NXwRa2n5fw1RopNV8n	1637	816	69	1	6301	jwJdC6MbNbG36NbnhMZJJh4jVgWMbwuXEoPas17YpHojfyfaVsp	3421	4825	4825	1616807700000
6625	3NKqyCohq7sNJa39LrKHu9FHJbpuSNjjgDVeMJaWEU2GE6FuC71c	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1444	1381	69	1	6301	jxyHz2VzeRJFSERzHT7BZTGQSNV2kArdJHGXMMnRTedUiK6io1f	3426	4833	4833	1616809140000
6627	3NLeC5vnWdW59QzpSkNdEJ46iZ9pgKhwSvNgdqgqwfAQEXsG85EN	6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	1402	874	60	1	5855	jwxZ5yGnHCuCKGCjvBGp8UpMQuGo8awGjr4DqKUGZmR4BbmqLhX	3137	4834	4834	1616809389329
6636	3NLGceYz8UqDKkVm5mWQ44go39JFZHZbxLZqtFzaTCKKtZwdpaKe	6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	1406	1393	70	1	6301	jxuE5c6Lk31hZPUGrfXAAqp7FxeN5wBamswfLnE3JhtwK3F5amV	3429	4837	4837	1616809860000
6639	3NKGXzY8Ei8ZLwLjE3Mz49TCEv8teAjdMPGzbrUvJUTzcTKLqPyN	6638	3NLMrgLJXWtva7mF13enUVUfizqquBjsNK2wSa1fm8zhXHZiEnHz	1477	1224	70	1	6301	jwP2SZxeK2G7D3TJb2Ur4BFiBAnXUf8yvkG81emgGpcgEEbNtmJ	3431	4842	4842	1616810760000
6647	3NL1Cb3Edwy9JjW7i4VLYhVQgHcP58fHoq5RSMdtcqc54xe3pxAQ	6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	1403	792	70	1	6301	jx1ijjH8iVNJt3kXVriYMnZgZzs3i4osTHTyzi7UgnR69mzH6iU	3437	4850	4850	1616812200000
6650	3NKpbwBUYf64EkT6ZJL9rGGupmfVxc1yZQiPoQ15TJA2J4EBqMUv	6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	1553	776	70	1	6301	jwPnU3on7w2CZQBbt8psunDGMTTLGzhXRjSKDUSfogesXKkt5Dy	3439	4853	4853	1616812740000
6652	3NKCF6TThgrKtsMyHcQ3vbfb9oGBw9aJ9PSJ2bMTG79u2aaaet6W	6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	1403	31	70	1	6301	jwxDJQYQeQmvZdJMECfdBjDoVp6aC6iHTMst6gZBsjYBWtrLv6Q	3440	4854	4854	1616812920000
6655	3NLV57f9mSb5tJCRTTZbnZ3Ekh74R4H8u2S1rnertF7Tsj8X1BLN	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jx6RKjMTsbvN3pGnYiL66rGw7jmPJWQzfeDLqrwKZhMTwfmEn6T	3442	4858	4858	1616813640000
6664	3NLZzJk7sSkytaXTy4gvjW8iWMbSGNtm79EYJYB35xL2SpBjiK3f	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1647	1302	70	1	6301	jwyJkfPoX3bKy1rKLs93k5FVLic5QoL8qDJy3o87Yuz1QanUJrd	3443	4860	4860	1616814000000
6667	3NLrok9T9AJN5pHokSnQ8BL3LNQeG8P5wUbSDpt41T1W8k8Xcpqg	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1407	1395	70	1	6301	jxzap5L4jHJED64MwoG32o7npnWfNp2JCzhDzSucg3vUEAguiae	3445	4861	4861	1616814180000
6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	6667	3NLrok9T9AJN5pHokSnQ8BL3LNQeG8P5wUbSDpt41T1W8k8Xcpqg	1656	977	70	1	6301	jwModEC6z4DawFZNTXUNtF3FzcAuaf8PtSBHSDPKL2qgdCGRZZv	3446	4862	4862	1616814360000
6673	3NLJvhcPMwFG4MQ9tcjasYHTXp3oQTm6X3TPR3zXL4MRTH5TPQ8M	6672	3NKQdv1zgaTrSoQhcyVwW1gq81nYdEC4gHZ1g4DcU4hWe5xQ1qE5	1405	1	70	1	6301	jw8JRdFBSKjHAuV3aGo8CJvu51UuUAZ5FUCxso5bapYs83ymaD5	3449	4866	4866	1616815080000
6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	6677	3NK7k5YsfKtjXT3CvEEvEFZBaLSVTaKspNEkkQEYJ3m49eFGsLKc	1529	1070	70	1	6301	jxKVeH1JfBXJkFr4zD2GDuVeWmrXryQ7ppabCVEmKAKk5dy5bpZ	3452	4870	4870	1616815800000
6681	3NLuxp7Hf5tunaZ7FFxFpwUa8pAbbTgwat5VisQZGMroLEmEmNuX	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1647	1056	70	1	6301	jxqgJNZ2voBmcQKAZP5EijdWtNxdS58tPhPyn2HQTALDKowtGC3	3453	4872	4872	1616816160000
6686	3NKd48XonyZmJjhNvRtwxg6AGA4YETAju3xVMEonj3vRw7r3ciq4	6675	3NKo9xyYv7Qb6mV2ueE1g8oyTwLhUFN9LWMtft19ruSyFZFbBoLX	1581	778	67	1	6290	jwxCQ4j8n4Ady1PqBy4MU7aHByB69S6zB6PECAPBkzoWTjdpaP2	3368	4878	4878	1616817240000
6689	3NKrJoEnaVvkoiyk4SMjjH8MRputkwEThybfUZYHTYsVxQsvteUb	6426	3NLk2a63Z3WnfxKaL92EZqt6xxyr5KDjrVHuLAhcSSGfRsQrsdxj	1623	830	65	1	6226	jwFj4BhQaHmDLHfCMkqbfi4fwSPafe36EvALk24kFibViTjFJtx	3283	4881	4881	1616817780000
6691	3NKZosPGtZ3zqzj3zWyqVGEBnZuEfjANiZwcEfwsx2J8VRSo4tCi	6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	1560	1291	71	1	6301	jwDBugjd2S97GC7xFoTzGMyXV4Tun4A7PZoAWPoX67oxv7UTFks	3458	4882	4882	1616817960000
6697	3NKj3cNkju6TYnnDAiMMUg6mJbZ7Ykt2FrGCvC7iSDLWGAZY5BK6	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	1407	1395	71	1	6301	jwUBCwJncpz7hj1iZiPxPGypzJ4YMNwxQKggzHqsFduNPqi7jDb	3462	4890	4890	1616819400000
6702	3NKqxA7uWidJb3jhrS9CWzTVyj2tdvySa6uZQqnffoC5VwH7kToi	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	532	1303	68	1	6301	jxUU6cGB4utq7EqA3VkxUbZa16oFVvP5VhBY6KNCXPr1aJoYbXA	3402	4892	4892	1616819760000
6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	6704	3NLZtMnW4fXx5DbaxCTyQhASB41Y5Uzo6N9onww5VgaW1fJRV4DG	1406	1393	71	1	6301	jwPKjeBCJtv98ZrnuobrUvwdHng1KrWe47hv8BUrhSrh8B98M71	3467	4898	4898	1616820840000
6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	6707	3NL2iQnB7pNwxEwNd8KwyiBtwKGFkQRoFaAhbkGYKMQQ5gAJrbNK	1403	824	71	1	6301	jxHa1CD7Zyz7ggS6NJcF8VPnw6bNz9XDcP6gdq4t2wdqUga5qCB	3469	4902	4902	1616821560000
6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	6710	3NLSpxVWz6sHpfKfoQUiWY9S8zLyep3YwGSVDxBY9xKxn3iTDncm	42	1235	71	1	6301	jwwSYHabs6oTrmk92ehiuaMC5icA1vVbk9GXL6oTywGRUvAqdZC	3472	4905	4905	1616822100000
6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	6718	3NLMeAX5Xepb4dJEf5PEZUF5BMs1tFZgFkFD7FWV6ze9e9n1849y	1422	1337	72	1	6301	jxTmQ5AaGVcnBmnXGJwf7Piz71yVVr3sPH7KVGPmrwqqAyJWeJd	3477	4913	4913	1616823540000
6726	3NLVA3E9pGgavEvpLSet6ZyJZvcVUpXB1GeEoQ4YjK5Pf4ZwJFJz	6724	3NLSBFxTFxm7EfrER33kKaWuu5qqg75Akpz6YS6xEuZjAtwzNXKB	1403	824	72	1	6301	jxwKroT6bTxYAKnfa6vm29a5DVg9pygarynS5pvuatvGTwkxomE	3480	4917	4917	1616824260000
6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	1439	1033	72	1	6301	jxGtTve1ChbZfTUaWmcB58XN729jWzw3ypmkWtHnHhMHfhPjtxA	3483	4920	4920	1616824800000
6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1506	1373	72	1	6301	jwt97QgiUPJhqy2AwiJiG9DYE6CFjqaSmzZqBFm2VwCbSzHdafN	3486	4924	4924	1616825520000
6740	3NL9XF1qKZDtWPVbpZixYdfLXA4xn1dCk8usxTSmdbs58VPtkup5	6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	1651	1301	72	1	6301	jxnpcHxHTxNFT427meLTdCfMqZ79mVFSgZxKiZ4yz19eufaUzrp	3487	4925	4925	1616825700000
6743	3NK6t2d44NJeV6atr3gCTiF1mE7WxPeShqgeSbuhmd9MU8viUtBy	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	298	1062	72	1	6301	jwEbzHLZpa2PhWx2ufXhuUPWuikNtia1xqTQ22YgDPLB4phSHLA	3489	4927	4927	1616826060000
6701	3NL3zkj85sGdh1m8KHeC33XJY6LwWMywqPPBSdBwDTZmSsDamwiJ	6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	532	1303	71	1	6301	jx8roDaQqzHB9vvNBd3irRBqVBrM7dd6sLS9P2MPLyPLMnwQ4yQ	3464	4892	4892	1616819760000
6710	3NLSpxVWz6sHpfKfoQUiWY9S8zLyep3YwGSVDxBY9xKxn3iTDncm	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1657	1218	71	1	6301	jxe785cf89Dn84eYEoFMej6E1YPLWBfN2axhKT9s98AZUPiNv6j	3471	4904	4904	1616821920000
6712	3NLLHSsPTcCPKcEndf9mugqYCqsQvJVuJNvYsnSBKcgUeh4mpeiC	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1490	1274	71	1	6301	jwpW8wnkhM5dVgEc6eYfEacL6QUZX2SY3qoXUzNdWfXX4JeevKa	3471	4904	4904	1616821920000
6715	3NKRaWNhhp55LofGBPJTRyRFrPUw8dcP6TwWfKByWFVQQwhPxEte	6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	1546	1093	71	1	6301	jwgG3NTN5WxNjXMaZYYjt1GsvdSQKH5xxVKyhDGhf8TDgELxAJW	3473	4906	4906	1616822280000
6718	3NLMeAX5Xepb4dJEf5PEZUF5BMs1tFZgFkFD7FWV6ze9e9n1849y	6717	3NLpzFn9W11fxkjrAtEMqJHNVqhnaQKarzJQCdyTDmFXH45DYD1e	1407	1395	72	1	6301	jy2Mb5hxU8kk61aPR4TAR3oTfFcYL37ud51YbAHoSTis5xAFL28	3476	4911	4911	1616823180000
6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1407	1395	72	1	6301	jwyEVUhmtn7XXcbFKQUHsj1Tx4bazuSs7NeGkworcfh8G5qwQuW	3478	4915	4915	1616823900000
6723	3NK4vd3RpDsJgxM7B8KXJvcTDCNNNGZnFqPcFCEdHQbyaVe6qgnq	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jxetvDu5TJMWFwttxRMoWfDxSnbWna7dPBetuhuXsHBGW9PNrST	3479	4916	4916	1616824080000
6728	3NKZThnpm9kzPJtCddbyxpXBXg83X9pnc9LmsqpZfUuHunYGM2JP	6689	3NKrJoEnaVvkoiyk4SMjjH8MRputkwEThybfUZYHTYsVxQsvteUb	1623	830	65	1	6226	jxUUKZAQD5nWHp2Dd4np1dA2YVUCiJZSHxTdkYcKftn8T6kMWMm	3284	4918	4918	1616824440000
6730	3NK9w9ZxUzCuMiiySxoR23hXSAaZJvpzhdGz6NQTtoBJou2rdx29	6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	1458	1323	72	1	6301	jxbqN6dnxNGgpPawpty2Qe9f3Ga4dbzqh8mPPAzK3ty27ndEi1p	3483	4920	4920	1616824800000
6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	1631	794	72	1	6301	jxXfH6PyZm8hM9kLBjZAsg5ckStiMaMrX58urB6DNX7t2LqPTeY	3484	4922	4922	1616825160000
6742	3NLht1sWwSVUFKii8v6fCcchkhrdwFfxgjjPeJP11KKrXUeCMT7B	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	1406	1393	72	1	6301	jx4uXPU3bQoNSV2UoKaiWJFxN8YtFRA9uZPDZLkKV5HuiR7ZNuy	3489	4927	4927	1616826060000
6752	3NLTyk7taDq2xzfRtkboHVVi2cRUvrgwrMjnf5Dm2iL2LQdMscLM	6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	1405	867	72	1	6301	jx85jcQEy7kjBq347uVtqYj7Yu5vvRjHXLqNiFeGcaFjMh8Yw5A	3495	4934	4934	1616827320000
6764	3NLURjpSmPxvYnvqfrs8gHpQPrevdjotDNdys9ZWTHUznNpRTB2C	6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	1406	1393	72	1	6301	jw73pnqAigpfUxATSq28jX7x8RmdwKFnRJwBi6ESWm5eRcwCjRS	3501	4943	4943	1616828940000
6766	3NLfLnBSCJsuyPZjyHtE6SJZeuYExwkS2YndQddQ2s54LQjuzy1L	6765	3NKNA9uFwyxoyTwKkVT4x3EhyvRbC4nd4hdEaRjnpurF6Gx2thdd	1507	1034	72	1	6301	jwfS4p8MHncCtFaSZQ6dHsUW72UVcMfdvXiejrAqapCEKGrS9Mf	3502	4944	4944	1616829120000
6769	3NLNc5XQYUpWx7KbzfwRaUADA33c4xitxsFjKq3UwSgkoxDtjwgC	6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	1406	1393	73	1	6301	jwV24R9QPsj4MHVqH7bgJRjT8spyY9WNE9cBSYLba6Vm7yeNJ9t	3504	4946	4946	1616829480000
6774	3NL4FtnPPguuDaBFN9QcBWSas38nrr1j23gjcUx8fv81FjXAZ4bC	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	115	115	73	1	6301	jxq7GAnpGZnvZ7ZXzMN5FjnmxrnsRnBGadXNHoArQFnjpC46gmZ	3506	4948	4948	1616829840000
6778	3NLMK8wgSSPovGtA5VArL3AWPQTCcCGTH1vcLNzqufdnUw8vK9NE	6777	3NLkoMuMvzqp7uxMtyupqocRQcs9aLTghj25hV44aCJJjgGCCrKp	1578	1170	73	1	6301	jw9Ad7cmscTEH2SdYbxZF4UuSsmAwDyGthiFGd62N6bALzHoV56	3509	4951	4951	1616830380000
6783	3NKnVun43o2AZP6fCmTUrnHb98MZ7YScPD7Qdgw7UAMDnt7eqWNr	6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	58	1281	73	1	6301	jwDwwewDYsiDw7QYsuH59gUv2gn2WyHPwvC1u7oTdem8aHz1aJg	3512	4954	4954	1616830920000
6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	1447	1345	73	1	6301	jy28LprbEA9xErd79fkmN5hw8ShRBRdwenhnn2FGKrMP3TCLhDm	3514	4957	4957	1616831460000
6792	3NKMcxHytidkaFRA59GxD6d9em3k3ZmCwHZycM3KYaKxiEUpr2Hn	6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	1590	1300	73	1	6301	jxKKj4BvqCjdzkQ2TfBtoHLnM7BHyM6Wx5gsowaCETQVLPfpufq	3516	4960	4960	1616832000000
6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	1634	1205	73	1	6301	jxrspKFtkgq3gGA3D7SQ53qtn16JK71TPFaumcoX9N8TKHsyXaf	3522	4968	4968	1616833440000
6803	3NLpJ65Xh8JKK9p8sZG3R2WPdducUkonyYrp4eA7zRicWcEvPToV	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	532	1057	71	1	6301	jwWsPa7ZPKZ5Jmkuc4i5XYPXkUAtF6XGbN8yLNgj9M3MEaQQ45N	3462	4968	4968	1616833440000
6810	3NKgLhrS56hD7yTAYPSRSyNSBy8PUiUmGzGWNc1gn29Teb3APyLc	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1553	776	73	1	6301	jxKjg5HkBmnHiKYoxqJtyqwDQBJuTqZyNTupZYcyB9NHwCSpisT	3524	4971	4971	1616833980000
6811	3NL5CffW1QhnjzA26vTucwNjLPSbD7YhqXPxbxZihVZH7VTZTkTQ	6808	3NLg1cSNtpG1HysDbiruF2xasNmEeFrsDvw9MJ3WfnujiHXwQtUf	1529	1316	73	1	6301	jwEoasYkT8mpFXRqR3ReePNH75fdEioiuvio14d8qXiGAQx5pn6	3525	4972	4972	1616834160000
6814	3NLw1zy9pwDR1mfQymPExF5Eq1GtmZmJUm1sHLcQB6YCeMN8yVzY	6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	1513	1253	73	1	6301	jxA9Ec7z945Xpvh2BuVxrEij3U3ZigTByTUjfCu3q1fi1NRq6nH	3527	4974	4974	1616834520000
6816	3NKbshwMTpVPmvGXRNUqYMF86HqhfxkgjY4P4bP6b8uHa23cMqKg	6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	1405	849	73	1	6301	jxjrxsr4Too6AadteX6NdsXmDXTn3unRkuwTtGEDc8XYjW3uScF	3528	4976	4976	1616834880000
6822	3NLhHKeMJeJiD1YPq6SjyvpAHvThz2Ufwtt4fTby1dSbeF9r5KCQ	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1501	1234	74	1	6301	jwZyYREbupTGpp9qyGWorYKLmAwjjwm7KzXxfuUHFSMNHJtNpQj	3533	4983	4983	1616836140000
6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1668	1370	74	1	6301	jxrChM783uBe1wxdMC6cfne53xhPV3AHTd2bqKm9G1CwkDJSrV7	3533	4983	4983	1616836140000
6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	1647	845	74	1	6301	jwcy2crUfFcJrYfnvrBanNooBDjG2sURKWJWVj238tdsegbkLxe	3534	4984	4984	1616836320000
6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	1542	1304	74	1	6301	jwLrKGvcB29min5TeUV4z9iYSRCeHzSjXrxuybFCr9dcSACoaa5	3535	4988	4988	1616837040000
6830	3NLui6YnNTDvAS8tQQxFvrFgqSJJ3JMr3U7MziHxftcLVjeHpfbB	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1578	930	74	1	6301	jxLUj658kMPu9kF6uYhem7ovqVGyQzUWQwt3PErcPLZeYxw3PSr	3536	4989	4989	1616837220000
6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	6831	3NKcp9CAhajYR3X6aJaNSds7j2mRyZwYhRKerWX1gztdRVthrtbn	1611	1095	74	1	6301	jwWTCpG7KuvTcrXMiQbuceAnf5USWSPnZivs6Hd4jWqAPGKKmeo	3537	4990	4990	1616837400000
6722	3NLWjckAbzM5XE5M6RkZvhdjpG9EAwTqM2wtBf6MLxEbCF7aAJUT	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1419	814	72	1	6301	jxTPpgAmUr89YWMaGhZQ44grcbCZ2XNd3HAC1wEJBz4WE7hCFNn	3478	4915	4915	1616823900000
6724	3NLSBFxTFxm7EfrER33kKaWuu5qqg75Akpz6YS6xEuZjAtwzNXKB	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jxKbLjPBWj1N2HS173iUKVLhcHEQFjKgxdKuiKi8MrJTQSxijCG	3479	4916	4916	1616824080000
6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	6727	3NLAyCVXE7PPXzXxn5M3aPecmHfNkToK6Qz9kr3zy6qtkN2Xsf3d	1553	776	72	1	6301	jxyEYzCrCuCHEBuLZjEje7BcbH5LPxpDLydDVKSC9mr8VSnDZaX	3482	4919	4919	1616824620000
6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	1646	988	72	1	6301	jwbAeRDRpXP6vMFteznMzefQNY3KbEK23gJHs9vdK5dBQ6NvtSQ	3485	4923	4923	1616825340000
6736	3NKgSGua5ue2xP6GoFrspPa6V2NtiH3tHkiNiJGSXoMAcvgPqCz3	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1549	1362	72	1	6301	jwBNKKdAXm8n2F8XBBNYa1FEwPQTRWK7b4zRkTKeVmLbpMshyiQ	3486	4924	4924	1616825520000
6745	3NLxrJyRhKBp4eUU3Qw1DoyMBjAnhzNeRdGbvYC6Nv3zpEmMvn5p	6743	3NK6t2d44NJeV6atr3gCTiF1mE7WxPeShqgeSbuhmd9MU8viUtBy	1536	1313	72	1	6301	jxysbFVWMMNXGtRne4tzBropwfggtzdFDhqdSSXptMhwRCEjFLx	3490	4928	4928	1616826240000
6748	3NKRAeDs8m2KHx2ZLx2PLDYJWQLrF3HwHxAuMRUAY9AU35Yxrpht	6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	1508	1387	72	1	6301	jx7MapMvVP1bFiYRWNiWf2NzWUyoXyFqRCrH9LsMFpcPTKfz2rd	3493	4932	4932	1616826960000
6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	1403	824	72	1	6301	jwpmWmz8dTtVMLzzy6HKwr5PTwooW4kKAjSf31mEXcy8JamX3KL	3496	4935	4935	1616827500000
6755	3NKun55Vmv3VLwaqqR3mt8qcEscWvnP2MyXsMbnLJuasbBpXghY9	6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	1403	824	72	1	6301	jxGmgm9Lzcov4L8CVEewESnZbmWLd728QKNS2wqJ858BaGM3Peq	3497	4936	4936	1616827680000
6765	3NKNA9uFwyxoyTwKkVT4x3EhyvRbC4nd4hdEaRjnpurF6Gx2thdd	6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	1624	1208	72	1	6301	jxQnr3ccEQg1cNP8xKKqnV2vq73yazN8uPtBjfWumAK69CDz6GX	3501	4943	4943	1616828940000
6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	6769	3NLNc5XQYUpWx7KbzfwRaUADA33c4xitxsFjKq3UwSgkoxDtjwgC	1489	1254	73	1	6301	jxQGr5wRL6SDZEoQvsPddYabPPyrVxDEEEyYamgTbFMvjTyHb9g	3505	4947	4947	1616829660000
6772	3NKUxybSQQYzAzKJN64FUahEgEYpTvAJNzJM9MsjX11hDJmhhGZV	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1609	1333	73	1	6301	jwT9sdCKzDbt814ie9Cwwg1DmYGoZaYNVxcNRmEDLHxsu6qESrD	3506	4948	4948	1616829840000
6779	3NKhF5siCyYbewognVco9ugPaXAThWPE1MzuXqcJgSm2hWmxMGKT	6778	3NLMK8wgSSPovGtA5VArL3AWPQTCcCGTH1vcLNzqufdnUw8vK9NE	1549	1362	73	1	6301	jxFSGzdokkBTiGtNVo9VUYimpLGMuH4sieJt97VyNwj45HY6RY9	3510	4952	4952	1616830560000
6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	6783	3NKnVun43o2AZP6fCmTUrnHb98MZ7YScPD7Qdgw7UAMDnt7eqWNr	1455	1086	73	1	6301	jw9Cmf9hhTMCZRzE6T4JJXxNf1k5aKtbUcdWUB8wyWYyaL35q44	3513	4955	4955	1616831100000
6789	3NKpwyokanRuCnaLacz8RSk27vz5gna1GYAWQ6xDE6JaCTbawFUA	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1541	1172	73	1	6301	jwGqP1fdU4gGy28yqkVeBEhY7ir2uFHou5cRdXphFMDxpxcYPCe	3515	4958	4958	1616831640000
6791	3NKp2ZwMJEesYaa3B4wfrCB3Hh1mS68Xky5YsVbSuG6QQfLP2noF	6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	58	1281	73	1	6301	jwReV5i4ABT3C9JHDzu51sYQFgSRTZZdr41ztvz4wVMGhv9r1B1	3516	4960	4960	1616832000000
6796	3NK81jNbWX1wmMN9g7tmeNLUuG8GyNPW4ktvVWpvBXXvxk1XJAdj	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	171	1128	73	1	6301	jwt35ZRvAG3hu2ZnJT7qebvKdo527g2zarVoe5XYAiJFdeYZh9M	3518	4962	4962	1616832360000
6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	6798	3NKbuFUhMtVYbKoxyVGWeYtFk6EVUd4Dd9KeY4te9bKZKk9NXVKX	1471	151	73	1	6301	jxnLsPuSKF42C34j9dW8o2QeMh23qwASYjR1JD7x2eRzK5K5mej	3521	4967	4967	1616833260000
6802	3NLjMEgeSGBDcvbjrKSJV5HvvekcRic8iCot9YxafuJeJh6EsLqi	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	532	1057	73	1	6301	jwKV89DLfytzciPhxD8gHxpdsn8FBZ1evsiEj8HZH9xnfe495y6	3522	4968	4968	1616833440000
6806	3NL6v2MV9Qcx7qCcp5gfFGoV8PRQxeD8U8Fzp57LrLMJbKGobSc1	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1553	776	73	1	6301	jxri4Wtw8nYJBt1cQgz3KpRAY6fF1V1Cr8YQhHrmV2vPcRGkB85	3523	4969	4969	1616833620000
6808	3NLg1cSNtpG1HysDbiruF2xasNmEeFrsDvw9MJ3WfnujiHXwQtUf	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1593	1100	73	1	6301	jx5NAKXr3CKwz24YCufA8Bt3bJfw5ES2YqzJo9te7JBMS2QY6cg	3524	4971	4971	1616833980000
6815	3NLtUPGo9bJax9BQfkP9h49zpK4tFBXSYMP1owMFFHtzxxFLATZz	6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	1403	786	73	1	6301	jw9jQKQtAWA9YL98ab5nxT4R1JZ2y5A2q1ediubyU47n6JoFUB7	3528	4976	4976	1616834880000
6820	3NLUsMXEtcoXmDDVbtUq3tctEDEKA8jRXphjZ3wcAtRs12RxCMgm	6818	3NKCp91cm4fUuxq9dqAtzJczkLaqnLE1XqLSqBiUkitWWcfe8gam	1406	1393	73	1	6301	jwH7JjzJR46WgomYNrfoUTqCU3rWFcT1p3MkyP3rvbWUABoTrSV	3531	4979	4979	1616835420000
6823	3NLbm6F3VnnXw1bTdkfDwxfjSg5t3FNSzpe96rfmpy2cdq8iypuQ	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1549	1116	74	1	6301	jwCeSA9AavDGcqgi5DnjR1HbQ8m95izN9AmffRaqbhBnDHrrLw4	3533	4983	4983	1616836140000
6825	3NKSFdEAib5qXRbyCmJ1PNcnXSjn9kRUvtFBJPEzx2vRRM6rDgcf	6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	700	840	74	1	6301	jxamNyhEymLHuhFEUjCQtLxWvCdFAxeLkVU3tJupDCYxfTECvrM	3534	4984	4984	1616836320000
6833	3NLH1fUHVsGJswaNKkhiybXaky2v1VUAz4aR2DUGMVqLKXJgjT9f	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1541	1298	74	1	6301	jxE2LpEzATWv6XP3bjq7a5CydC7ErphFPHS6Z5PL1YJWVxLuqL6	3536	4989	4989	1616837220000
6835	3NKb7WhLYGHewQGZfwBWWkn8d9QwH5dEHucT6zvdoitQvRFxPZ26	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1402	906	74	1	6301	jxTRRVLViHV1XnH8b52aM487Jp9y7hThsBPn5TsXsTK7ydMrENi	3538	4991	4991	1616837580000
6842	3NLhbtLQHmUwGaqjiRM3t8YgcVAwqf2CvN8vDN9woeT9bTPq7AH2	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1405	867	74	1	6301	jwaNvu6guACKuNAkCSdgcBzSW552oUBDmMWaM7XRZr7xSojWfdF	3540	4994	4994	1616838120000
6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	6843	3NLoyNRsLdumszjhMRHNFjx6zLPbchsHsiS7oUkZkFmuHQY6fQ4t	1406	1393	74	1	6301	jxBZUFCpX6whoLanuSvif25yeqetLic3qmP9XPjJZT9s4yLTcrD	3541	4995	4995	1616838300000
6851	3NLC5GRckhpEWBoZtCjpRdX9gjUoEji3MGNr6wK95cBvBXuRMMam	6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	470	1183	74	1	6301	jxf1dGewLMe9TG9JqdMmpkLbeEw3ARWVhsVAXz7UmePgDDTwZr4	3543	4999	4999	1616839020000
6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	6851	3NLC5GRckhpEWBoZtCjpRdX9gjUoEji3MGNr6wK95cBvBXuRMMam	1652	1315	74	1	6301	jxK2ZPqBLu2CQvs26pHht6nmZXvLgmwJ1qyb51UeX9nu4fJtyx4	3544	5000	5000	1616839200000
6735	3NL8J8Nd24YQvJdS8ovDXhYunjyzVH5pMeW76BzKsoXxC6r3DkZb	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	1406	1393	72	1	6301	jwJj99Yj47UVw3VoLK7YPJ5jpgghP7Df1t3Rkx7EZsfZhYTJSQm	3485	4923	4923	1616825340000
6737	3NKzmNYHArqLxygDgBAv6XBNsW336tCYsxu1TS1dyi8egEW8jFFa	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1406	1393	72	1	6301	jx8fMmGGsTvng7tG78rspMYu7wtKFJQR3BRFoKBfatnnBGdJFkz	3486	4924	4924	1616825520000
6739	3NKUQhUfmTuf6mZCaQKo9mRNnKhQCozgLbqfuNHHbjTZ8isu6fwq	6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	1651	1301	72	1	6301	jxLS3MwoSQY9y2fbz1vhBRt6xpuFCizUtk3j1itdn6BCdJycx3T	3487	4925	4925	1616825700000
6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	6740	3NL9XF1qKZDtWPVbpZixYdfLXA4xn1dCk8usxTSmdbs58VPtkup5	1407	1395	72	1	6301	jxLvoyyaAn6FymqXLTmphTRo16bFTQEDsE46N4xBeDXofjE5Ydx	3488	4926	4926	1616825880000
6744	3NKbsc96d65ge3Vweq4kE2FLrz5BiTLYVioajK4Wr8qyKhcjuUcu	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	526	648	72	1	6301	jwtcAoquWWdeLLcw7tDYDVjqsYKkkoead7SJdHGQRjiFbxokBEU	3489	4927	4927	1616826060000
6746	3NLRo2dirWiNCEz7bA24sGsrKyw9p9iiXcH4jAYRQ9C12L2VKEW8	6745	3NLxrJyRhKBp4eUU3Qw1DoyMBjAnhzNeRdGbvYC6Nv3zpEmMvn5p	1406	1393	72	1	6301	jxN4Xu7yfVrHmZfSk3XgSeVLeojtE3Lc64pVNEsBrotHEPtF3Ee	3491	4929	4929	1616826420000
6749	3NKDfEjBnBsyAjZV2ENucfA8DxjH2KcCPxgTzuFAjPNPYbPL2tUz	6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	344	344	72	1	6301	jwMnMPP5C4KfZWVCob6wXjq9pYg6MfPkdHBgDtDvFstpTjd1y83	3493	4932	4932	1616826960000
6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	1644	544	72	1	6301	jxrxXPr37cwfSCfNTDh5oW9jGSTxm6NfW62JMg2238vUTtZgyrU	3495	4934	4934	1616827320000
6754	3NKWDoQK1wPGSfem2fHQsxra4jHwa2i9TnJSpjGvmwpEZuCzKb6R	6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	152	1084	72	1	6301	jwkzDVCcgsC9ZEX7CnAEvyeHRYZZfbMBnzV75458c5d49pvaT1N	3496	4935	4935	1616827500000
6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	1406	1393	72	1	6301	jxFLPeaToixthzNyjdyxTHPsMVtwjgTnPkHDa9s9JcEwYdwHfsm	3497	4936	4936	1616827680000
6758	3NLgHn2bAyf18QVLEhdxmjZSv9zVGVtpARQCAhJWqzRXHho8pbkj	6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	1405	869	72	1	6301	jwDV5fBc48AwDtj6nVUZs7eUAHdZtuiTLyJtTRMWySHs12MqEWH	3498	4937	4937	1616827860000
6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	484	953	72	1	6301	jxxgEnvvciJw57yFzHAz1fbgzXzCB7Xc2ogZSfs5uL6XWxuMEzk	3499	4941	4941	1616828580000
6761	3NLkN6mrs8v2JxPFJNwuPAPccdWndF6GHBwS3UXEzmEfecbTiEnD	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1624	968	72	1	6301	jwdLhUYr3G9m3ebcqXBsT1mKRfhVmEHDWdFuQ2YE5Dhzr7PqMgM	3499	4941	4941	1616828580000
6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	44	1325	72	1	6301	jwbZLSAbhafPAuTHBaP1ZpVpFH3yGUtBYAxDkHVJLr7XNS1F3VY	3500	4942	4942	1616828760000
6768	3NLiFAZg5B5zQa4j89nybjsFHo6HVwjUxyvz41CQ1xcptFamMmJD	6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	1455	1206	72	1	6301	jwDq6GR7ZtJqVmSwbqyZbjH9MfYTKLjcjf6qNNzRy5Y8pJMsr3t	3504	4946	4946	1616829480000
6771	3NLg2Mzxh8yXfjLyMq3YtF5fzcrerZK9MDxBa5w891BD4JdJkwmY	6732	3NLUQ4jtKJoFPVEX3NAshtTgdCepYfxwd6YdeJfQdqB4mWHYaBgU	1489	1254	72	1	6301	jwBrDBofwMKrfPphsSFKF4qsdFvqj1FB8htuo7zwErF5bsFUL3o	3485	4947	4947	1616829660000
6773	3NKBYSGWoF3zCWBLgEpvagFRLDTGsVh65L5cLwMMXkmRgr14vJz6	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1407	1395	73	1	6301	jxP3psB4nUw73KMBbfLCnwrcwcavtev5pXo4pAw5gHdKKvH7Nf4	3506	4948	4948	1616829840000
6775	3NKTEduFQ1JXxfwYhfZ5kgGGJrRvvqyHJJrd4wVPYMZz5eukY8Jy	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1573	952	73	1	6301	jwGu3aaMpj5chJExAAjzyc8yCiiWqkXjNrmLBhHUqtewRYtfw4C	3506	4948	4948	1616829840000
6777	3NLkoMuMvzqp7uxMtyupqocRQcs9aLTghj25hV44aCJJjgGCCrKp	6776	3NLkp7nLTDNVcFyUNNcv4xCN8R3jMiegnKXbgsqHxs32VWHVQRJS	1406	1393	73	1	6301	jwz9Lx718R5bNVy6Vep9VZRhnWzq2jJKGzZNBhvSJCvK6qRqrbY	3508	4950	4950	1616830200000
6780	3NKjyWymBLm4rmDKyEHaELE8k6pGDgk17kA2G62Z1cn71qqjgLFC	6720	3NK5pERoyog1nZZaKGyFCVok64W4iMsE2jej1NmcHQJqMmX5DAVS	1481	789	68	1	6301	jx1aqDD8Rnq5F4eNzENedivvBquZEiH1U4w93QkZvxgTVZbyZax	3391	4953	4953	1616830740000
6782	3NL32DJeuL5Fyo4K8wyDjH9CB2Rf8mBqJK2WmRrNqSwNr4ciLCXp	6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	1403	782	73	1	6301	jwSoUpSdf2ok3GqyYD5NBfkLijiHArhS9y6j6e2baeinQTW1s12	3512	4954	4954	1616830920000
6785	3NKeBUzSuuvhQrUUK8gNSFYwWXGDh4X8RMVF3i2KyfJFRDb4fe1C	6728	3NKZThnpm9kzPJtCddbyxpXBXg83X9pnc9LmsqpZfUuHunYGM2JP	1623	830	65	1	6226	jwSLeFvkSUYKEzikkChpPHZtcmUp2mARGkaKFSwQjvuaSS3aAZV	3285	4957	4957	1616831460000
6794	3NLnbxzFCCwyy6WGJtyTkSFtnq3tKC1qVaAjh1bFhTrqMk61aBy8	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	1609	1333	73	1	6301	jxv2R4j8wChK7wENM82UsQtocqbN3V9inhd7kawaVFXN3YYgSGW	3518	4962	4962	1616832360000
6797	3NKCbPkkWscVt8Qbyaj7KJuqJBxMXwbw4gnDRVgbbnFM2bgZMVGU	6795	3NLu9oADixjutZtYKdteBr6tBpzs5Z5N4PS3HYnFCNXGc1iF4KFw	1637	816	73	1	6301	jwCZ1pp8T4vXBegUyRRmsFT3JWgcTeBhWYgT5tPNkPEhDpiK97Y	3519	4965	4965	1616832900000
6804	3NKCtAZVoLE92ZWHgKR3keE5LxJJN3kNfwGdxGJLTNmExeDwevps	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	1634	1205	73	1	6301	jwZMW6hZLrKpibzwDyhWvnqiPKW8apJ55b5tHQ2jCzVDkWoJUWy	3522	4968	4968	1616833440000
6809	3NKVvPbXuFyYzXpjuXc1JL94iMiSQ6pciUZ2yqUH45PTr5x752Ty	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1608	1163	73	1	6301	jxoNkah1XWBT6qeADjzaJ4Y5MrsywDUN799wqDjmEZjnJPJbAiQ	3524	4971	4971	1616833980000
6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	1585	1000	73	1	6301	jwzHWzGL4LvyHh2K8di6kccwP2HwQ8EeJeXE46VPuYV7a5BfWxg	3527	4974	4974	1616834520000
6818	3NKCp91cm4fUuxq9dqAtzJczkLaqnLE1XqLSqBiUkitWWcfe8gam	6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	1675	1342	73	1	6301	jxkPXJmgn7vNbZ2R3z5bvvVgsMvx2BjJFAUfyakkX4QBEwrBJJh	3530	4978	4978	1616835240000
6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	6820	3NLUsMXEtcoXmDDVbtUq3tctEDEKA8jRXphjZ3wcAtRs12RxCMgm	1673	1002	74	1	6301	jxHvSnmoWxjXK9CeQHmuhWB3HVxjLKHkw1vHTmc8rDuZAkTKG36	3532	4982	4982	1616835960000
6829	3NKyqAmaXFzC5yad1ZFwFKz6K3ebwBTDpL9Y5EowV5AMiPLkQPaB	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1649	1383	74	1	6301	jxPwggyUiFzrcfybUzkcE1Qic8LX2dZDhQVg5NY957qbWVrCXnY	3536	4989	4989	1616837220000
6831	3NKcp9CAhajYR3X6aJaNSds7j2mRyZwYhRKerWX1gztdRVthrtbn	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1407	1395	74	1	6301	jwazL1hq9iAtb1uzUmr8cno6utcwYyCy2sX8jn7VFmXMr57a5kH	3536	4989	4989	1616837220000
6836	3NKPfqUGfH9a19xaUWjUynXxDVxrv5GeCCGeK5cTWjmNRf3sAZge	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1602	1123	74	1	6301	jx2buVZiEsMWDmZ6YU9BpCkAtTNM55bX2pgtYy2z152Lm4KfT5j	3538	4991	4991	1616837580000
6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	6746	3NLRo2dirWiNCEz7bA24sGsrKyw9p9iiXcH4jAYRQ9C12L2VKEW8	1507	1280	72	1	6301	jwDNPiX1kMw6aho2mcvzr4xfhT22tSkiD1uqKmLsWwCjDecWYPe	3492	4930	4930	1616826600000
6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	6748	3NKRAeDs8m2KHx2ZLx2PLDYJWQLrF3HwHxAuMRUAY9AU35Yxrpht	1402	868	72	1	6301	jx5f6TzymaEhTuwLzycNgxzj2AVS5aWqcuRJQryqrA6m28GiXJW	3494	4933	4933	1616827140000
6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	1503	1277	72	1	6301	jwPDoXJDDVeaAStFyvXsgYqeJnLrGxc8ScX5HqDbc3eX3o4iYn7	3498	4937	4937	1616827860000
6760	3NKLcxpk5X7ExtQLubyGRLMY3ieSK228Fa1Dys9wjqVgCUSEdbv4	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1672	1159	72	1	6301	jxc5YewaLvuznhLV5Md6mgbCKPXHD9WZ3brt1LyGUNVKtDzmk4D	3499	4941	4941	1616828580000
6762	3NKo11apRgwGH4yQkUr99p9NBn1PUF1RRnHJSeBBpWbQVcTbUnNz	6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	1406	1393	72	1	6301	jwDiPb4stwbtuC2BdkXVHXxAuY6qr1Dri6F7tYoJ8NQyvKCxQuT	3500	4942	4942	1616828760000
6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	6766	3NLfLnBSCJsuyPZjyHtE6SJZeuYExwkS2YndQddQ2s54LQjuzy1L	1403	824	72	1	6301	jwqPAqEWsFoy19FHG522MQV6Em4Lz4Sfy2JWonaLk9qwqkSmuvE	3503	4945	4945	1616829300000
6776	3NLkp7nLTDNVcFyUNNcv4xCN8R3jMiegnKXbgsqHxs32VWHVQRJS	6773	3NKBYSGWoF3zCWBLgEpvagFRLDTGsVh65L5cLwMMXkmRgr14vJz6	1499	515	73	1	6301	jwwevAw5pyfQwCs55QYKcPUJrXyH2Cx4aiqme8LNdfnRpqG9sYU	3507	4949	4949	1616830020000
6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	6779	3NKhF5siCyYbewognVco9ugPaXAThWPE1MzuXqcJgSm2hWmxMGKT	1483	146	73	1	6301	jwxE9QSBsZmFf4uyzjAgg2wu1enZAL5f1uuJxYsoTaLm6mGPVTQ	3511	4953	4953	1616830740000
6787	3NKFfkCidmBZ7rcH9izWAAADE8UM9CXrFZzJmjhWaoVnFZABM4h3	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	1599	1287	73	1	6301	jwRZUMsdWTWjbsVNSfz3LFprKZHtoLSNC67WJPGtBGCRBHX3ocU	3514	4957	4957	1616831460000
6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1447	1345	73	1	6301	jwNgYP9cTfPB3zEVHrguhRtwTLyuBdhMXnj4JWNXkhTyKy2cyp1	3515	4958	4958	1616831640000
6790	3NLxrDmCaGhTmfwPkFKfWNYWuvWLoRC8Bg38GLhUdndTqWqfHMwd	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1631	794	73	1	6301	jxeBWfaS2HgQWS8LL6Ypyu9XA1FkrBVED39Foe2KbbnophQ6NR1	3515	4958	4958	1616831640000
6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	6791	3NKp2ZwMJEesYaa3B4wfrCB3Hh1mS68Xky5YsVbSuG6QQfLP2noF	1483	452	73	1	6301	jx8dHNWunzijsLHZMe2w5usyWwxt5U1fqpU8Vk8RjQoJq88AStD	3517	4961	4961	1616832180000
6795	3NLu9oADixjutZtYKdteBr6tBpzs5Z5N4PS3HYnFCNXGc1iF4KFw	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	1553	776	73	1	6301	jxxBFXKMdPZ6Jv9VbKUnjpCDzPaNcA2VEoSy1k2izhtjLRBpo9m	3518	4962	4962	1616832360000
6798	3NKbuFUhMtVYbKoxyVGWeYtFk6EVUd4Dd9KeY4te9bKZKk9NXVKX	6797	3NKCbPkkWscVt8Qbyaj7KJuqJBxMXwbw4gnDRVgbbnFM2bgZMVGU	1406	1393	73	1	6301	jx9qVbv3UReL5Wp19GGKwtkLEYJCtBdUzD9NsNTFdjcsrQZh6Cf	3520	4966	4966	1616833080000
6801	3NLPzbU9HYAbXT8LpR7kQXudEcDTbU9ugNiv1gSXxPsGFadfgSHy	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	532	1057	73	1	6301	jwFaUHtV3z3PWwCMN5qXMShAMLr3bfzmEnsZDiD5GR9veZCX33p	3522	4968	4968	1616833440000
6805	3NKk5M3z5qFxXMW72tbkfDVwQgaw9z1FagD79Acg4x7y1VdQbDSh	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1637	816	73	1	6301	jxWLccTneM7jT8fQUAjsZm7XVMWd6eLvBSwPJRsaiRCX6G1jh7T	3523	4969	4969	1616833620000
6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1508	1141	73	1	6301	jwkSvdhpEygmpLkfFhts9S77nBojDngGKvhuxcq3WVdvuqwXi2F	3523	4969	4969	1616833620000
6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	6811	3NL5CffW1QhnjzA26vTucwNjLPSbD7YhqXPxbxZihVZH7VTZTkTQ	1553	776	73	1	6301	jxKahAkMjsEcNWoVn2KPTMjLUvuzn3UguXWbApNHfM1BYhRXjRM	3526	4973	4973	1616834340000
6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	6816	3NKbshwMTpVPmvGXRNUqYMF86HqhfxkgjY4P4bP6b8uHa23cMqKg	1590	1300	73	1	6301	jwK2VvKpfJBK98J9QCtMt3wHfbtyBB4vHru8RBg8o64fAkqCCnq	3529	4977	4977	1616835060000
6819	3NKVtRGvjmh2vV5fuwWvGgEvyG54jep36LkgUXzqiDcDPnfpz41k	6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	1633	1390	73	1	6301	jxfbw2x3arg8FvhWXSjK1RWwiMepcjhyG65UV9e6Wzp5AApPsMF	3530	4978	4978	1616835240000
6828	3NKXgM8oTMBD9mGo4Y2nf6462MQzCGVa7Nuh7TfbsUiaMDovthDR	6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	1419	814	74	1	6301	jwVeUmndzaeQ96NGramNoP4Tn8ZtRiuFXs1vtATFnut5eusSbnH	3535	4988	4988	1616837040000
6832	3NKyzwwgcYKxYAow4iXd5nrbantNq4SdaxMf6E1sdJxZboZoJrmh	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1541	1298	74	1	6301	jxspR5XdkC7zoa3zSbj4rrrRAujLib9aqv6Aqt9mwhuXRpThfse	3536	4989	4989	1616837220000
6839	3NLTSRunxAMRAhDo89g3C7H8yMEetdE5FDA5LTHjXWepjEmMnt5F	6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	1403	824	74	1	6301	jwxp5duZ45iZmM3sK6GMiSR1zjgJN36d1DCJCyhZT43qtbSBU6h	3539	4993	4993	1616837940000
6841	3NLSQLeie7ZGgw7g6s2cN17XPrgrsyrqBwRzqVLhREgDpw8TTJ4w	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1483	660	74	1	6301	jwii5u1Z8TfsuY9GEAfJYPt67tDNGzzww9oJSrRzfQANkVgD5YR	3540	4994	4994	1616838120000
6846	3NLbVufR6wvnV5GXFB21w6oDWvefLE6bESHuZ2toZ3i8xyJi6Ev7	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	43	1310	74	1	6301	jwqMrbdEfRSBMjt671r9fRWrjaD7qxcWGNTpLuuYiNFy5vZxmBi	3542	4998	4998	1616838840000
6855	3NKj56QwjgvHZGnd8sTuiaEgxdHMhUocJrQ22tbkzzarB7TGcZrR	6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	1553	776	74	1	6301	jxzVxuv5gKi6uFcLVoARFFqsnfuvGEkWjV2qLdykhLuPTE2wmax	3545	5002	5002	1616839560000
6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1622	1110	74	1	6301	jxdLN3xg2NHrv7DjDMc4oYbf3EHycE8FqyH2RrwAdsuAEDFoqgL	3538	4991	4991	1616837580000
6843	3NLoyNRsLdumszjhMRHNFjx6zLPbchsHsiS7oUkZkFmuHQY6fQ4t	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1483	660	74	1	6301	jxxjqFvAktuKZZ5SUuhK9ARpqPc3w4zivdmEnSe8EHTqPfQt4QT	3540	4994	4994	1616838120000
6848	3NKNQmYDTFaL1y8jR5pTNUPuNvEcrDq38BLWwJxDvMiN9cvrcS5i	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	43	1310	74	1	6301	jwWaHmoLNszg5R9XNhH1hRgyQJWjRiYeoVvsPgUsXPgvhmTTELK	3542	4998	4998	1616838840000
6850	3NLiq1k9jF9QHDKHkLRuiyNEW1FECjt821TUUYPnzjhRSaKppN9X	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	470	1309	74	1	6301	jx9TcWaBnsKKJTb78vCxQCmnjXMMdPE77RwdRcBDUDEgaAA99y9	3542	4998	4998	1616838840000
6838	3NKYtp13WEZkqQCZmUSnEE9L6DgSZGbvW8RyA3m81qNH9VwDqzfo	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1549	1236	74	1	6301	jy2C3QJZYd4oLrobMCeGdqQ5UUtTrrmy2shiZjpGk2yKG75RjX5	3538	4991	4991	1616837580000
6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	1419	814	74	1	6301	jxmgTXVKgLzrzn2ywAi4uFDdQhpkp4RKpX1788zAhRrMfot1RhQ	3539	4993	4993	1616837940000
6845	3NKC97pMaURQQPzdgXksDCWhCLJVH6UdQj1ut5oo2uLyBbsXTRMS	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	1671	999	74	1	6301	jwv4uBq6wHp8YhJmkjN5mfuoRxW4ktfA16mxmih7H6xzEQxSxUA	3542	4998	4998	1616838840000
6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	1407	1395	74	1	6301	jwCNkr7sWzEWXZ73VXJCiJHkZz8w4SZ5xURugC9oKdfuDaHrgpq	3542	4998	4998	1616838840000
6849	3NLXbnBwekrAzHxg22AkuKQUixfH4hjnHyQ8qqTdREkH9mLgAWqa	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	470	1309	74	1	6301	jxwJUsPL32wgiqJAzrSZcxZZwuQFvuA332HS9c7ndxUdAF9SjWz	3542	4998	4998	1616838840000
6852	3NKhCrXFKHgXeADuBNzb1CxGJpxQXh58Nqmvi3MddBdZ2G5sFjcx	6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	470	1183	74	1	6301	jxepDfFhVmCrMfCxmfy8AbozP8c8xSMpQD5jT9rus7F5maPnJEb	3543	4999	4999	1616839020000
6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	58	1035	74	1	6301	jxVGoy5RHc2jELMhkqrJ4UWUPnfkzWcyADUt3LS6byPK9X37WKL	3545	5002	5002	1616839560000
6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1649	1383	74	1	6301	jx6TauY7QzvXbEnBmm4uLKGBq5A6oVVVVuaWpEpKYFoMfkUk1Zk	3546	5006	5006	1616840280000
6857	3NKjeBdhewY58TDHGzJKYXHtNAAgfVQYVX81okK3nGkryfUkp3r1	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1405	861	74	1	6301	jwYtsiYyzWVUKya2VUmCkv8bZGvptWqnX59QJEXZqMmEnSkrEfR	3546	5006	5006	1616840280000
6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	58	1281	74	1	6301	jxSg2vvppyQxAiZcCYpha7nuHfytdoWTVtoVBErgrpWnoDtWoU1	3547	5007	5007	1616840460000
6859	3NKNoyFpqvGGS2iS6KxxLSWJERXdEXS7aMLmpyoVjgH4qgnTEmW4	6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	1668	1244	74	1	6301	jx5QyUuPyty7TmdSuKacqHxsyK1bvEUkfueLTXME64DdND4eg2A	3547	5007	5007	1616840460000
6860	3NKKTFjpmAdczJV2Rv3vMsYWDLGvzmKrCyT3k52dkZytrUPgbyzX	6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	1500	1051	74	1	6301	jxq1S3UgS8tAJBkNNVHv9mZKtXcxFNBLjX5HDbxeJRXjYVxouPD	3548	5008	5008	1616840640000
6861	3NKVBSip9LeYqeiioA8Viab8bjhtXdjjvwQWKmTKKddtVnXSjSmr	6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	1407	1395	74	1	6301	jxi4wbqSySUrKYdYfNTBMPn5hturWAf6yy1qpFFw5J1PJQwPmyw	3548	5008	5008	1616840640000
6862	3NKD1VHPSk3FJDkaakSrLoZxcRqXGVWYcRLSkjhyRk8PWyM5bQVt	6860	3NKKTFjpmAdczJV2Rv3vMsYWDLGvzmKrCyT3k52dkZytrUPgbyzX	1406	1393	74	1	6301	jwXrmAvZSGz95TmVpQUSLkr22PqjvxuNwk8n8Zr89PFcK8qa7M2	3549	5010	5010	1616841000000
6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	6862	3NKD1VHPSk3FJDkaakSrLoZxcRqXGVWYcRLSkjhyRk8PWyM5bQVt	1403	824	74	1	6301	jwbBqgpMBFpy4yWaSHkDbLdNZP3b55Qu6Gf3FWvEQmHip8Nn9bt	3550	5011	5011	1616841180000
6864	3NKKkd7vaYeGAdiTzMEX5mGCazTDuN7RhhkDESsdsqsUKxktQAfk	6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	1675	1096	74	1	6301	jwWCp2jKXc8NpaBUWcnZrdshs3H9X7wskjRYEuTyN7kqWGqRv4D	3551	5013	5013	1616841540000
6865	3NL91bgZFhEcza1zPkLKThSj34mjqojpzfggUjLsb1Y9sEeEVkUb	6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	1406	1393	74	1	6301	jxrNxhvTJRZREacSfujYzAiicNhQC3UXjjPCeifxXd1pYQPPe3C	3551	5013	5013	1616841540000
6866	3NLuHx41TAWRmwBFgwQiPB1xMLWNGn4tQRP6ig6NaRq739gydQ9N	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1675	1096	74	1	6301	jxSi2Bxgo8HeKN6WLicmEgmhqQiUVhChwqbFffUS2MWdNKYqVRM	3546	5013	5013	1616841639225
6867	3NLejBKqKCYnDfE9yhaYor6dhtCipSWwG1k2AgTgxyJYcdyNj5nf	6864	3NKKkd7vaYeGAdiTzMEX5mGCazTDuN7RhhkDESsdsqsUKxktQAfk	1406	1393	74	1	6301	jwTjZHnrS28CxrTSkZ9P8SktZHg927bh6g31J4ajG8zMTomQjpq	3552	5014	5014	1616841720000
6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	6867	3NLejBKqKCYnDfE9yhaYor6dhtCipSWwG1k2AgTgxyJYcdyNj5nf	1405	875	74	1	6301	jwjvtGZ2PmxD2B6vgpxEYs3q5pngmMw1sMGxt32G7QYx8AQi4pn	3553	5017	5017	1616842260000
6869	3NKRnfKCKuyEGHLP31aUrPgLThqQhy1aVqR3yVVtGQ2CD8B1m3Cw	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jxJHQ3w5odhQ6HRnGEhN1bjV7F2jmjRXYupxJTuKGqNF5f2ZFam	3554	5018	5018	1616842440000
6870	3NKpsapfeUqArezhgyeyZHhNNNwJGjjPe37d8HK3rP7dz8X62dSC	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1397	828	74	1	6301	jx1h7kAuDcQCmjCFU4fKTJ6hhp4LL6iV2npA7ehYqhiXWTHsDdN	3554	5018	5018	1616842440000
6871	3NKr1ASYcLoDnPunJTENiyKT2UHXn3Ui4JSUQZoUHD6iBPjBjX7i	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jwotF2rpXn4r6h8JiDNLaf2UVP8Qrq5ayotm3hfKG6X6d6Z4Xxd	3554	5018	5018	1616842440000
6872	3NK6XzqsYgYx9o7qCWpesvnKxBAX3vF7vdUfWf4s7es4cVqns4po	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jx9Qr77USa78JJr69Q7w3tQAHAf21uqEe9dV1pETfeH8dp2jPH9	3554	5018	5018	1616842440000
6873	3NKbhKSFN89nsXGAGKBPhRvf2eekbHY9gyAuSvdftZj7ErKFQd5z	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxX9bB9bG9w8L7aLVGm16Ab1vyUwcmhMQU8vXrfuHiQHiSksABQ	3554	5018	5018	1616842440000
6874	3NLVqKTy6us7FmcKFQBRmwgLVUejr9mZ2FHcnxAENFFYsyWy8uys	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxw999zd82pEkrmo51a3DFAenTe3eRDhTJwbwjcQyqQcFfkP4At	3554	5018	5018	1616842440000
6875	3NKsSMCgggff9Q5KHWfUXeC7PqtdAHhDUBz9PbjHJAdJSDLUjErm	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxw999zd82pEkrmo51a3DFAenTe3eRDhTJwbwjcQyqQcFfkP4At	3554	5018	5018	1616842440000
6876	3NLeohMy1sKCvpxRjn8f1eGKMDmQoyxbDZGAKWVep7PTQdyHgWHt	6872	3NK6XzqsYgYx9o7qCWpesvnKxBAX3vF7vdUfWf4s7es4cVqns4po	1460	476	75	1	6301	jwCRpgwkBFwdeejvvxk7Dj5t529JSrGW4s2wmMAfuBNeuYgGmZF	3555	5019	5019	1616842620000
6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	6876	3NLeohMy1sKCvpxRjn8f1eGKMDmQoyxbDZGAKWVep7PTQdyHgWHt	1406	1393	75	1	6301	jwncLTKkdBADcUAZVxovD5bsBfT3enXfE7d8yf7GqznELcZk5Pd	3556	5020	5020	1616842800000
6878	3NLHbZMxpouo56LHC13kzyRknUr6o5mqa91mWD2HJF8EgomPCy8T	6690	3NKPJG9erNFMqWiVPHCpV92zJcfwoUDPPqNRg5rYwnt3iLqDjbzu	1650	1375	70	1	6301	jwBG8T9B6cNWQskXy89gwLgjXCYCRAytdoN2ALpy4ZRrFQp6D9G	3420	5020	5020	1616842800000
6879	3NLwrPE5CyU4YWJXMzv7Zh9MWYv83RR5qWhDrGmsRkQAzmY7Kdyg	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1654	1340	75	1	6301	jwH1nMQScfDr6e6M5D5hNRuZsSEbVB9ajWDeEAmAPRUErqxJdTf	3557	5022	5022	1616843160000
6880	3NLYxMPmsNjdarpjnoFuNAihFftE2dNTyPZnF3DAde9AAsREf8sQ	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1654	1340	75	1	6301	jxZegcj5ubgG3bzT9w46Vw5Y2wMGrfXTjGTQB1ddx5jVG8SVB7j	3557	5022	5022	1616843160000
6881	3NK8bZZiF1NwuDV5YEYaUsdL3NhPiGDcA2N7jnh5EwsTC5ZjWuqq	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jwgimPtkpc5WAXbY7eUT3xGmkLx9Wkgg3oSLU4L9ZPDBdpWLMjY	3557	5022	5022	1616843160000
6885	3NLNTWtkcnWC92SKHUK6sLh5EoKAmzsj6gRpAX893h1UNNBdMqPp	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1577	1081	75	1	6301	jxM1ArfVyWr84oZon11f77CuSGdymwSU2u65MDRESXm7kHr5Dt6	3557	5022	5022	1616843160000
6888	3NKMMdJ5khaKVq8gsWSHazqhSDBkrmNNnUcM9GA6gQWwNs4ERgtU	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1585	1366	75	1	6301	jwa3q2Rkb8rcy9B1q4JX13XcZV4jsADeSMbffvDS1RRhvEtW4e2	3558	5023	5023	1616843340000
6893	3NKnfEVGVmbB45BPwc6JhFSJzp8qmf74FBf39LKNg5DchpEmdtn1	6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	1564	1212	75	1	6301	jwfk2Sy184idmv4UbcviWZN6TukYsgA42f1q3fPe67NLSD6edw4	3561	5027	5027	1616844060000
6895	3NL5t5DZdaY3xVvvTjAHwXWVzU95R3xQpxB91azLubuAJUrphvM3	6892	3NLumyPEsC2cxX88E3Kw69FciHAz9WSDNYfPZ7u7eLRV4AfbNQLY	1457	1145	75	1	6301	jwxjqnbwrwkrgtVxTv8vzYV1YJwdfwpRrgLRznrrPsDoVwWpiZJ	3562	5029	5029	1616844420000
6900	3NKwyyKfbRxFuMB8iryBqAuo9mPofjw3cLuGEQ3V8QGD2ib7mdMv	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1637	816	75	1	6301	jxh7PjnFodJPWAzyAH8dteVZEGK2biG5Wd2WZm5s13qfvtJeQQg	3565	5032	5032	1616844960000
6902	3NLqxvGpWNuRdcze6QN9yEWc8mygPPSD3eApGwiCkB2zRT9Sr8tq	6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	700	700	75	1	6301	jxYNzvcA31bt3smfmvx8myrxQpYMZeaUnFiYQ8kuoXXk5ds7fS6	3566	5033	5033	1616845140000
6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	1461	1271	75	1	6301	jwrQAXj73bhwZCmUoA4mb35SRyFmzsGH2mbcfGJEppT2A4cV5Ff	3569	5037	5037	1616845860000
6909	3NKp8mAnXuSaTguNKAaf8yNubxPgQLDeM7jveozUcwfdT3GJorVi	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	369	1312	75	1	6301	jwBMpK3mrLKNeyDu8x5ciQ3BPmXJKsVHJatWvf4trsmJWH5DyuT	3570	5038	5038	1616846040000
6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	369	1312	75	1	6301	jwQM5ieePL7yvKSJHv34AGs6FUiqXi3avreFmEWHyeN4H5DjxUy	3570	5038	5038	1616846040000
6918	3NK8sVB3F7pKGkhBDi5qvSGHhY7HujyUrVyGWoTyvLKSBcV3AMr8	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1579	1143	75	1	6301	jwgSYdGefmAYJqbSr8Uy4AYVxZaNd2FxCVwavY62LUJA6EdqDyU	3572	5040	5040	1616846400000
6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1624	1334	75	1	6301	jwSVnZ4q8bJSox9P9MPdXEqHnWQPfWeHeaWNgiEfMPQ8Zy9rTG2	3572	5040	5040	1616846400000
6922	3NLZpgiKzimqY2UR3EC6hNdVAXNrecqsrvNe36ddVn4ToRcry5Ts	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1637	816	75	1	6301	jwDBMzSiFL1HUWqHWomJ5Dg6rUQhKorHUendjaNg4mwGNffBmFY	3573	5042	5042	1616846760000
6941	3NL6DMjitK44s9XEkU7L998PdUmaANTVLnNTSdnHoyf9ZTgYTmgJ	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	43	1310	76	1	6301	jwvjrJ8xXxzbrVCZEo6wQEfXvetEwpRftCH4h1QBEgjd7iKZm5x	3583	5054	5054	1616848920000
6946	3NKXnLt8qsppsFjFPP6dch9bbSnbG8udGuCwLNf8NXSPTuBvY9m4	6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	1637	816	76	1	6301	jwf6CoJz4uMQ6krCr91RdTR8NUwH1wVYoLybLyNvQMHXLR8ewYa	3585	5057	5057	1616849460000
6951	3NLD5XFvnu9pjYsDRmNiY485tYYtLjP6SZYFZBvVXf4a5YCGe6jb	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	643	643	76	1	6301	jwdRDfUCrSURUKBmrPX6kJUW6HL6SMPpH6tS8JpSVbPLshRQXpX	3587	5061	5061	1616850180000
6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	6951	3NLD5XFvnu9pjYsDRmNiY485tYYtLjP6SZYFZBvVXf4a5YCGe6jb	1407	1395	76	1	6301	jxbfnLg4sSCAhyW9TxYMqpLXydLPYPrF2pdRQ15E3uNp7javZCs	3588	5062	5062	1616850360000
6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	1670	916	76	1	6301	jxfm77myKy3ixPcSjFHb4YbJwjyEmT12uG32ASxoUr2nBhf9XTm	3591	5065	5065	1616850900000
6967	3NKh3XGiLbU6CAzuWwKt7VtWfm9GvUq1zwXThKuyRJ8j6buUAA51	6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	1637	816	76	1	6301	jwJzsadoprhj23HnwBBeH3MztZ5RMyTEMVkvFKP5tEeLRHTZjK2	3594	5068	5068	1616851440000
6969	3NK4vTGdNzsFSEeCPHrYFQD8ijDHQyS3cVh6urHnfVBH1ZwbC2ze	6968	3NLLv7ffjTCksVQetgxaqdyq4stH7B7ytpGfdEaXR6Yzcb9CtiNW	1406	1393	76	1	6301	jx3TcNFpbqKzZgq2nMDQnwrhNHNU46sxErUdQdAwABH8fb5fste	3596	5070	5070	1616851800000
6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	6969	3NK4vTGdNzsFSEeCPHrYFQD8ijDHQyS3cVh6urHnfVBH1ZwbC2ze	80	1027	76	1	6301	jxh3VynugdsAECRZ2kZ7KghG4LQUS5i22t1g8xEETdHPjcYpvSn	3597	5074	5074	1616852520000
6974	3NL1zDfSrZ7fgdcNtWT9zVDxuZMhz9vwMk4xXKL8LKo4pSFsM4p9	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1407	1395	76	1	6301	jx63Ju5NUgcyoa4zZG56EJGeo3A2XpdNkvE3pT6C5kPF8eEtBvM	3598	5075	5075	1616852700000
6977	3NLySt69yKvQRWVYeZgbGLxhw13iUUCtSiDWYKo5ZV8TkeEUoGM4	6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	1639	250	76	1	6301	jxPNcNyLgGemy8kcfCj2pzg87aBENk8YfitLeNepFQXYsfZPDw5	3599	5076	5076	1616852880000
6979	3NKAnjzFYQGyWSCUegZvgsWYF87CbdEqG5Ug8c8sXGbfSG7RLBGc	6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	1506	598	76	1	6301	jwzuw9XN9p8BjZbccxDAmZ97QybAXfS4fS5KaqNRBrb8KaofiDh	3601	5078	5078	1616853240000
6987	3NKdyugaSZXthNaSfweQJzy3PtiGJnwu8UmbPhbwa6MsbUwpLXf9	6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	1406	1393	76	1	6301	jwvJomFpPmJWgKncYWV8rqmEJ68toKCntAdZguwmhLnDGBUKCD7	3607	5086	5086	1616854680000
6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	1673	1368	76	1	6301	jy1SMr7sy9QAsforJoPzNJaUdZRbFEXfgyGMdYqVe9fXxaXBo6w	3609	5089	5089	1616855220000
6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jx4fBBUxNuoGzANSe7zxXNReWsPjfCcT5Jj89ATxrB3hj8rBQck	3610	5093	5093	1616855940000
6995	3NK39xn3mdtHTNtSSdu74fLWF8VvNfEK4ANxabStbYb7ZLzwV2Mf	6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	1403	824	77	1	6301	jx7red1XuiRjyEGvgpN9rCYpD54tca8zN1mHGKrgMNdBpLXxiRH	3611	5094	5094	1616856120000
7000	3NLHiLvk32jDEmdVC5Xv4JNUQuPBfFbha4fhVRefwsgM4qhAWTXq	6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	311	1307	77	1	6301	jwdP8ZfkUZmav86RWUa9ZF8K8FTHxC2HCoSscXCLeLHFSKcMAha	3613	5096	5096	1616856480000
7004	3NKWFs3wWgMX4yiLx9RpyrViiizGSP9egPXg75zSPP2V2MKUPCnJ	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	311	1307	73	1	6301	jwS68K9KFvWdjyWo2XwCZf422MqaGwcP452AFpDSqyLHjsqn6tb	3514	5096	5096	1616856615534
7006	3NKNqBRcXUz7PQZqWjKAiT4r87ECkUs2oNAAxnpQHtGymQBwvRHv	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	596	1306	77	1	6301	jwFcpxrp3xWrZR69XuG7bH46oM9KT4A5oMVrd5Ev89f3nyafRdT	3614	5097	5097	1616856660000
7011	3NLciVoaV9EmgwWfMpfYvgRrfKfRctFo4bpBgVzC3Dg17GEN4WEY	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1631	793	77	1	6301	jxESouLT9kZ8Ysa6Yo7i5nhxC8T5CTamPCkRWLHSTwRYfR9M316	3615	5099	5099	1616857020000
6882	3NKerzmAf9LQQET1dt7BrzNdzRcBLdFs3EMvpyGAJEL1ZDm29QXK	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jxn7fLL7NGGhjdf8xxEjSKPXHFEAYCV1b498EJ1FRy3rU2Lwa1G	3557	5022	5022	1616843160000
6886	3NLc3y43Vztzzh3zJJrdJxvYnt7WgaMgfaYrhup1fpQyc9EbGtD4	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1403	824	75	1	6301	jxHpLVzBmoaNyFzgrZm3f4rcx6rzCnVXZYa6d5FqJfUp2ZCX7qg	3558	5023	5023	1616843340000
6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	6887	3NKU44rd9gTnZieBjwDjCCkh4EV3CtD1ZBW2rPCozwb8zLaP83t3	1406	1393	75	1	6301	jxaimxZCwTecQa7Y2yYWMbjUqbicMnwYLxGAdwzfe1yuUtg15HG	3559	5024	5024	1616843520000
6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	6896	3NKKqN1X9awF8vuvvCgXHdKFeM2ZtAjNYSnKYkJErR1SteD8A9BJ	44	959	75	1	6301	jwrWM3ukSRRq1BL3jgVQ7MZZ4uQ1uVf4uQcCECvboyyCeg4chDH	3564	5031	5031	1616844780000
6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	1402	882	75	1	6301	jxpXReebAQdcsZNSLdivwSMUYniVqSaEizqMaziqYjVmcLB5BpE	3568	5036	5036	1616845680000
6910	3NKPE1VDet954Nj678k1Keb75Ctxr7Erp6AZGQqipcpdVMY4e77A	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	1403	31	75	1	6301	jwL3fHd9V2ySs13KghrJBtkzBxGEGCz4aG8uSqqPStfaY6FkgPv	3570	5038	5038	1616846040000
6913	3NLAm18exRM3MpQVnwQxsPnPUEXRTMPUGzFH48YngLXotA2pmM9U	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	311	941	75	1	6301	jwp9CdK3UX7pPQGHBTtXVnDJ7uwBkazDDQPPa5LABsUtvpT7sfo	3570	5038	5038	1616846040000
6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	1406	1393	75	1	6301	jxMMD1spZCMAsQHjjrtr3k1hn1XmSta4D2kCyrDSzkgjT7FMp7k	3571	5039	5039	1616846220000
6916	3NLbd1i6AbQvJm4qsqkW3Wk4pQXbbVyMbW6bxpvHF7cpd1g6JDhH	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jx1dAPcDkkRqr4Ns8R8oPVncJQZLZi6WWWxPV2sZLkXqW9VCBFg	3572	5040	5040	1616846400000
6923	3NKbnGHpTcUxauGfuBx71f5RecbakivaBrUk8wXgihdfFWaeZ9Ph	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1483	893	75	1	6301	jxzFUbNT95nhBzgWGnHzJsGhgsNMVzDCKdFLQ46z9ipbSDsxhRQ	3573	5042	5042	1616846760000
6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1542	1304	75	1	6301	jxg1MCFoHWcVwPUejvfEHut2zZquQxx2goX8adEzVvr3a48kouV	3575	5044	5044	1616847120000
6927	3NK8mbWPv9v5wNYHDokGshuh1eYs7zreuy7ertFVy23jdHzzgWQX	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1652	1189	75	1	6301	jxKj127pxfpUVHtnFAdgYKssKmjS9zLjRzkaRV6T4UQrifLDfVN	3575	5044	5044	1616847120000
6930	3NK4Veyk6b3JKCiboFZzSSMQrpETH6Y7AmdN5qDS7uNitDzd3W4U	6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	1403	812	75	1	6301	jx6o6kuUYPFkbjQtM2n1x7YTp43wYV5Mp7hnSVgRcD3d5aWwrUa	3577	5047	5047	1616847660000
6932	3NKfRkJD3JkRmX4YUGD7kbicssAxCorPUk4JaXekbbk7WLwHJEon	6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	1406	1393	71	1	6301	jwodXhxB1UfDos9JdiXw7fULfDnFxUF9trXWpsk7i3aAi3v1dHv	3468	5048	5048	1616847840000
6934	3NLfVj9gq9p6my3CcYY4zWd7rNHSTqHiV7sEaspXSokjP67PoXsA	6931	3NL49iEm62rVwrL9hJ89A61vS6i5egyuviZxR7beDT2yg9Tf62tc	1419	814	75	1	6301	jxAzS7hiyVGxfbFG3GNgGvKXMCkGZX5t97TPHLRT7TAtkEjwGFy	3578	5048	5048	1616847840000
6939	3NLmPT19h4vnLe5acZVYYpaWNzYSTNg1ahJ4Wk5jHqdHtUiYNBeJ	6938	3NL2b6HQn5BKWaBk3mCrPehfsEwg4pbzgik6mN6vLw87WBmMe7Bi	1622	1356	75	1	6301	jxocL8g9gLgNc2pHXrSkw9Q8WUTvR5Xmc1PDxpJQbQWYUym3MW2	3581	5052	5052	1616848560000
6942	3NKAA7x4jSDQMsgMDpLoJnY7X7WRvQnnpQAcdvJjzFAq3henDsYr	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	1541	1298	76	1	6301	jxtXGV9LcUwitBT8TUb7m1d25Yo1rY3czEuniVA313dTNhHq5yP	3583	5054	5054	1616848920000
6944	3NKUmqbHoAcbe6bw32RfUk2WLfNd7wsHqcjbMDTbngzE2d4RoyYB	6897	3NLhPoNsa8aPC2UVzM6juqhrFkNwr1oCgdUgaJxuwVpj6S75iT35	1581	778	67	1	6290	jwbugkmv5RiR86cmK9qrT412NSSGY1EyFkFmh6RdeF7YPagThEa	3373	5056	5056	1616849280000
6947	3NLY4ECy1ngRMGpyHFtwH34dpHnMrkVuxtBnFdwP5zJ6UErTp4Ps	6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	1402	874	76	1	6301	jxaanDWGgoe2RFuv5rWaVa2yNftEQRn2PAujx3dQPqoTbPnRTcw	3585	5057	5057	1616849460000
6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	6947	3NLY4ECy1ngRMGpyHFtwH34dpHnMrkVuxtBnFdwP5zJ6UErTp4Ps	1623	839	76	1	6301	jxtud6c86hadic2aWJmNDcwKYw6DaWyzcTjv9ianJjxdWLoKoSr	3586	5058	5058	1616849640000
6952	3NKfFU1nZKBgmNZbR1pV7taaWcD1ZFFcDvJEmkEHUhxZsVe7jE7o	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1407	1395	76	1	6301	jx8sxZ5as9WDnoPEx99URCzusK3mxXCZa5AQhej7NCcKEHS5pe2	3587	5061	5061	1616850180000
6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	58	1281	76	1	6301	jxbF8TKxaNZeVcg8oQopqyVUucj2wx8CKfjMeRL9he1hZtYY2Lg	3589	5063	5063	1616850540000
6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	42	1361	76	1	6301	jwMdt9ReDSZJRHUpLZ5MikXp1XUJsvGWBM8bAEJ9ryPLiQjqtHR	3590	5064	5064	1616850720000
6963	3NK9WfiJBqozSVF6XdzpJqrRUFez1iGjcU7DYwY8rqVrERJLo3fB	6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	1590	1174	76	1	6301	jxKTYJYjDCT1ucdyEFBY569XHtV4rp8nMvFqXgwAxRLSwxqeiud	3592	5066	5066	1616851080000
6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	6964	3NL3hLYgS9J7e3Y7f6y1vW4DrTjNa1C7ESYjCYJwJuvvPCYAWDYe	1642	1367	76	1	6301	jxmWjarhc68ZsSAaBja22ogJh1GBrf8tmp6wjkxzpvYpHVcDyCn	3593	5067	5067	1616851260000
6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1406	1393	76	1	6301	jwSyPj573Jn83BX3MYym1KjZfSvYv9zgKTgWNbkayVTC7Hk98Jh	3598	5075	5075	1616852700000
6975	3NLx1Sy7N4XFbU6aadj1K5wXeNwphmthPMGLnHk9hx6Aw3Pbgu9t	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1617	1288	76	1	6301	jxoUrbCKsP1k64nLK99XWnHepkCj2rnkBnbhaXQ5VFdiKPQ7J4f	3598	5075	5075	1616852700000
6982	3NL78UnkftL7gxQtNR2L4FJLrTTU5XzE21DWXL9wT8wH4FAbTYUn	6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	1631	794	76	1	6301	jx4tBNWtjRRVf2XE5gi5ZZwfanYvQ5c36iFV97TVHopVxdMfvBq	3602	5080	5080	1616853600000
6985	3NKyopB1QmtDDVtAp8sVXnmwitjQdzULMnp3Aka9aHgo7bn2Rxsz	6984	3NLJ3EaJo8BcKQkF6a6b1yHDeKL4fkGmoFZ1yWfYYscSZcwLJeE7	470	1309	76	1	6301	jx78JFd8kPCcahSHaCwDzjNHEaRVtyNxe9rc4HorS3UNJwTDrt3	3605	5084	5084	1616854320000
6988	3NKmuZQpZLFNYAvfyqeoZBU6CXhmbaNqsh6yPfiQq9sy2hZ2iCeH	6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	1553	776	76	1	6301	jxkJ4Ymmv6GP5k3NpRjePpVgjRAoQB1AG59zL2WL5TxufmsxoBN	3607	5086	5086	1616854680000
6991	3NLcv6MudpiHZM1B3B7uns5Atm52ttRHKx3Qnjh1s3uhGychdYmb	6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	1675	1096	76	1	6301	jxvTKfSwcedFGedSQgs2EcH9pHsH6TUDRSh6b9p5Axx7NsDumRK	3609	5089	5089	1616855220000
6996	3NLbpbXv2gRyuEWewpE3ws41FYEtj4cTsjV6HrPNNpv7Und9MCus	6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	42	995	77	1	6301	jxWmmgNgZaB62pMoxfucRPSLC4WYfrMifUMrAAo916M34PyzvCN	3611	5094	5094	1616856120000
6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jx7ao3JnoGopTz5Ve5L3HDg4dF4TCW1imgtRCCw9nmCabsyMkCY	3557	5022	5022	1616843160000
6884	3NKEcKiSxiZoP5pMyE9RhPjtEYiL8Fh3BkGwKj1i2jGtfgMiPKb4	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1577	1081	75	1	6301	jxQxUn21V3o4Sretu2N8acK27yptokkdN9f6TbP7QWT5D7Svdhm	3557	5022	5022	1616843160000
6889	3NKqAcW6P4kv6a5khfma6PQg1qugt564hH1WQ5XqNMFJhs8nN4QU	6706	3NKBDXqYpdvanNdBj3zqEGKqJyCLGrNeJAbmaaACGLqHjfCer7w4	1581	778	67	1	6290	jxWpqTRKa3Lg3zJ2Fa48Bz47eSgQWBn6HJXaUY7nvEKfzBKAhw7	3370	5024	5024	1616843520000
6892	3NLumyPEsC2cxX88E3Kw69FciHAz9WSDNYfPZ7u7eLRV4AfbNQLY	6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	1405	851	75	1	6301	jxBBj6KZbxMzuLRXNT58TEqkRdcXw4Yp8JSYwKGcLTkV8FnCjDy	3561	5027	5027	1616844060000
6897	3NLhPoNsa8aPC2UVzM6juqhrFkNwr1oCgdUgaJxuwVpj6S75iT35	6894	3NLswoPtQQAheysxfnTzHAuXh1BVcqFJmLtf4VKHVCVCgUjtYX31	1581	778	67	1	6290	jxZX84uFCFAvyFtRfLJ25gcPx5M6vsrHd2UBbSk6pBWy3YYyMT2	3372	5030	5030	1616844600000
6899	3NLYFA4nUy2c1pG1WohzwjWCR5p6Gu2qEBVHPXBkgrDeEq1Exy5Q	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1402	858	75	1	6301	jxZeKF46gHSWGZXHS5kfiFn4EBMVdiaH9xiGzFDaK4rWw4Ybmnz	3565	5032	5032	1616844960000
6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	6903	3NKU5fGmVcVV9HKNQRQ8tAvkXAQAtnvChPWQ1LqqLN1zGgk2hrKD	1546	1339	75	1	6301	jwwytWnQtUWWDf4BjKRiQQACsZX3PAjSZR3uKDm74w1TRrnVvzG	3567	5035	5035	1616845500000
6915	3NLEp4dTK8GVsUnkYCmYpoTYsjgMfTd5aMjd3ZV3sWYB2jgEbYMT	6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	1631	794	75	1	6301	jxkuov8UZ59uoRadqEKDScpQFHUnBN1G4f6Z9c1tySCtjrxP3Lx	3571	5039	5039	1616846220000
6919	3NKNtcuBWQ1FYJgdDSJRaczsF2N8dyi47jNj2RGFZJ3gpZk2iqJ9	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jwhm4AeBCAZvn1qoNJaKjndUDPfcEKGL5RN3xgR3G8a9vogjR3o	3572	5040	5040	1616846400000
6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	6922	3NLZpgiKzimqY2UR3EC6hNdVAXNrecqsrvNe36ddVn4ToRcry5Ts	1406	1393	75	1	6301	jwaLgsKSdMJiDfEugyx4rdpAhAZQzAFqy4SzecxUL9QJfLtJNo8	3574	5043	5043	1616846940000
6929	3NKgaEdzHANkTRLZR88GVbRxneuF1VEU46iRggqonQFCTt7iGQaD	6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	1503	1151	75	1	6301	jxVDb4VeA2w79mTMutYaWGm5ATu9jQXQkZBvgPww9igonC1dYQt	3576	5045	5045	1616847300000
6931	3NL49iEm62rVwrL9hJ89A61vS6i5egyuviZxR7beDT2yg9Tf62tc	6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	576	1109	75	1	6301	jxdKbdFNQ8tnERjiyFVpBKQNiFNsmMPKgWj9BYFhuEueLWfCjAQ	3577	5047	5047	1616847660000
6933	3NKFiFkuabU7zc3DXAEy29c4cDfLBM8gGcYNFQD2Hnhaz9r5wVuj	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1406	1393	72	1	6301	jx5SWSNHKMUuavhpY8EQ27wZ7UEMVJX17775uPcvwN3kBchpjrv	3478	5048	5048	1616847875135
6936	3NLrTHiovaXLCHELPpY5E5PsPhmzUkaHrSFEE6Cme3jNPDfXFA6T	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1406	1393	72	1	6301	jwPPkcKwACWcjV1PoUQDoiGxBakMCxrZ2Ws24DcsL6AZSbdjXJn	3499	5048	5048	1616847945468
6938	3NL2b6HQn5BKWaBk3mCrPehfsEwg4pbzgik6mN6vLw87WBmMe7Bi	6937	3NKdfjTYH4LxLwzramrVvHZmTmUmPaMoXg9P7DBiAJpfY6f34sea	1637	816	75	1	6301	jx2k2HS81dzn4p2JrbQGLQ6qKaKUMAN9sTJyK4m22L41Un8oH2E	3580	5051	5051	1616848380000
6943	3NKYqRLg5kpjjab7AhbRh7x98K6dkTVaipHbGJGQc9CmHRp6U1uM	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	43	1310	76	1	6301	jxVE5pExEPfgcf9EoiCG4jMa9agPMTjixFQkwvHX1LoJW6A3uP5	3583	5054	5054	1616848920000
6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	6941	3NL6DMjitK44s9XEkU7L998PdUmaANTVLnNTSdnHoyf9ZTgYTmgJ	1448	945	76	1	6301	jxTLHXVAy8SUdgUbpfrxhgjNPC97mqasTRv7vjMmwHyKWanczFK	3584	5056	5056	1616849280000
6957	3NK76B7PTzeYWunYQ8g5kRyoMDuHp7YSG4MjtChFeznSGpxw84n9	6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	1598	543	76	1	6301	jxShPt43ewsyj1ZSdxCE21drfX6NU6S8xKCTiyhFy8Ha1jS6ptK	3589	5063	5063	1616850540000
6960	3NLo5rw8grCNKWZGkApaH1fv4vHMawFFyjD9B6Uy81mDqqrBvtGW	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	606	1295	76	1	6301	jxh5jCqB3m1mioJHBSRJMmoLehdhizRYUTeumeBHUxWoGu7UV84	3590	5064	5064	1616850720000
6964	3NL3hLYgS9J7e3Y7f6y1vW4DrTjNa1C7ESYjCYJwJuvvPCYAWDYe	6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	641	1336	76	1	6301	jwAZjPLHVPJ6LLkjHKowVfBnc2fdW83cXgzANMovVdkfx4W1fYR	3592	5066	5066	1616851080000
6966	3NLwtwSMxqgk8FU9HP8stKUC317p4APwGaLdsHtwtV1GnKeDsLr2	6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	684	1352	76	1	6301	jxiRVAgP7ZYZM1yLqB9j2mihiVU22jSQrAw3VWEBbkgyAjMEVJT	3594	5068	5068	1616851440000
6973	3NLvHTn4KGdix2hs1mzi2SyHm767uPQA77xx7CwH4iEzkhZbBuT3	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	58	1281	76	1	6301	jwQR2UoxFTxiF7L2Q7ZemPCjksnByJ3MVVEMAPybh2BpKtVJequ	3598	5075	5075	1616852700000
6976	3NKRPbRm699y1rhosjAfB8zBk2jPe76ipJRqW6ke1gM1dSF2Sd2o	6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	1529	1190	76	1	6301	jwG1PxmCCdvhhRMTWjsFReeSjDyJstTjRvqr5kTgtgcZqcsU4uE	3599	5076	5076	1616852880000
6981	3NLnGyqn8wjhVi3Mn2TDCe2ATSHRPCVuMnpxazW42Jyz951gBKaF	6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	1587	1111	76	1	6301	jxDjvxHgc7uV58xrDCaZk2brJ4BHMHVFYG5bkKtmVHt53jVs6Dk	3602	5080	5080	1616853600000
6984	3NLJ3EaJo8BcKQkF6a6b1yHDeKL4fkGmoFZ1yWfYYscSZcwLJeE7	6983	3NK5bRzxSKrwQ8LkcqQNcE3xbinCxTotr6iGhLzkZogHWTqbok6p	1507	914	76	1	6301	jxbVjiJHQizeRKpZd1h4y4LABcn3YSDqtcVJE4jsnJnYXJ5k4WC	3604	5083	5083	1616854140000
6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	6987	3NKdyugaSZXthNaSfweQJzy3PtiGJnwu8UmbPhbwa6MsbUwpLXf9	1407	1395	76	1	6301	jwJF9cSkrL27gpkbjX389SA2heZA83gyNTmw2B2HTomPg8fsDH1	3608	5087	5087	1616854860000
6993	3NLgEminBPYqHa9nrgNXtpPx3asAwjN8zkVSrVKE7F8gC4EwFikf	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jx4fBBUxNuoGzANSe7zxXNReWsPjfCcT5Jj89ATxrB3hj8rBQck	3610	5093	5093	1616855940000
6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	6996	3NLbpbXv2gRyuEWewpE3ws41FYEtj4cTsjV6HrPNNpv7Und9MCus	1670	1282	77	1	6301	jxdYM199qbhmWBxGAge1JdFjGLdhxP5NkmCu3rKGNhZ6jH4S7q8	3612	5095	5095	1616856300000
6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	1637	816	77	1	6301	jwMcmkSLgg3yNdpBL5P4vAksbq1SQXYTUiKqTNKatB2mhbFpvUz	3613	5096	5096	1616856480000
7008	3NKk2qUZpWHwajeDohxnnu6zrvt5dYjue5UCACiN4oX7PaR7t9kt	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1649	1383	77	1	6301	jxUoHZGGuhyhFPf86vnW1JhCtRopCzHfvM7BXqZjSm1mjiqDrmh	3615	5099	5099	1616857020000
7010	3NLMRG5mByA2ZqYebECAPnRaXDopEFFUdNRuM7bAefP9ZHiNDpH3	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1419	814	77	1	6301	jxFMdrNWMJsFEuoGE5StA82XmAKfr6HC17QWJZy2GEVViq8Keqo	3615	5099	5099	1616857020000
7012	3NKqdBWgd3TNVyrM6QLRh3rLSBejv5S12ofkeX1Hoby3jDQy11qf	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1447	1345	77	1	6301	jxXpQGDVFp1ZXvrB2rfQ4RTefs86cAjNDQPNNyUKAzwZQDRfGv9	3616	5100	5100	1616857200000
6887	3NKU44rd9gTnZieBjwDjCCkh4EV3CtD1ZBW2rPCozwb8zLaP83t3	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1402	870	75	1	6301	jxs1QG56ME2AHXsx2SAA56QHjkWZMsetEdP1HprEJW4zKx1hgvc	3558	5023	5023	1616843340000
6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	1406	1393	75	1	6301	jwYV59Ro7gKnc52vaigFTptt8YmSWUjwdoPkayaXbSYdk9Hprow	3560	5025	5025	1616843700000
6894	3NLswoPtQQAheysxfnTzHAuXh1BVcqFJmLtf4VKHVCVCgUjtYX31	6889	3NKqAcW6P4kv6a5khfma6PQg1qugt564hH1WQ5XqNMFJhs8nN4QU	1581	778	67	1	6290	jxrtePUtSM5nh44iUcNL9HJcdJuXw6ULLuVLLCiNxfmNARnQBk2	3371	5029	5029	1616844420000
6896	3NKKqN1X9awF8vuvvCgXHdKFeM2ZtAjNYSnKYkJErR1SteD8A9BJ	6895	3NL5t5DZdaY3xVvvTjAHwXWVzU95R3xQpxB91azLubuAJUrphvM3	1646	1108	75	1	6301	jxFutnZCBm8Ae5Vn3yNv1teRZVNBvsMDuoejr4otZ9uzRiZuuuS	3563	5030	5030	1616844600000
6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1631	794	75	1	6301	jwjXqs8DRKbsMQRBfxhSxbPHqJ4RXsG2UbkZNHks3coS4K4zAMU	3565	5032	5032	1616844960000
6903	3NKU5fGmVcVV9HKNQRQ8tAvkXAQAtnvChPWQ1LqqLN1zGgk2hrKD	6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	1405	867	75	1	6301	jxpZSPGTwrf4m6dytfEWMWrKuhW33yHJKtMtJDCTWZPe4vazyeo	3566	5033	5033	1616845140000
6906	3NKFYUSE8q8NYgGfgAKsZXpK8CDS4DHBJ2Q8sYiPWtPYrbireGUN	6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	1672	1285	75	1	6301	jx7nxehXnse868nH5ubm3xEx3MRQ9MvLdw1KRuE2EXeVaPnSxKr	3568	5036	5036	1616845680000
6908	3NLJJJEGNYrebdrrtprdhK8gfz6HpkqA6QPPvcj4AWNDX8j8KNhj	6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	1637	816	75	1	6301	jwfh3sqPd2Pvw2w314im6wNNYTyUJfXKwr9ndQFiJDFkRveVRzw	3569	5037	5037	1616845860000
6911	3NLxBjpU7Q2z2h785473QkLubYEJ9fspLqq4EbfQvWcvcBSf475T	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	311	941	75	1	6301	jxpCwk219XRPqkFWRrZuzjryRFwQBakNqtXq6r4r7RE2xWDC5iL	3570	5038	5038	1616846040000
6917	3NKHS2HgsnUafhX1sRvmGVYHCd7ss5LEpX1S4CRtjCoq6BFVKiDd	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jwwBszzrxrsUizyXdWuhdyoUZX7v8j6Bez24Vu6XKr95fpHvoyo	3572	5040	5040	1616846400000
6921	3NKLtkkFJyv2VjwRXVJJaEyMgH85NTQjj4UKL8TSVkKoxYnXukBM	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1483	893	75	1	6301	jwREXJb2eM4gABm8bAkXhP2K7QX8ymUBVyvyAeVmZsgZDSyw83j	3573	5042	5042	1616846760000
6926	3NKRn2cUWZ9FjD2XFbv2ce2npACYqexSbJFDtmuwTscnyxnoZCYv	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1652	1189	75	1	6301	jwBinf51HYGjx5A9ojbn8wApoCNoUtYE7oqp7soyuS1abgd2K4A	3575	5044	5044	1616847120000
6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	1403	823	75	1	6301	jwv2kQJDEzn4DvYDZJ5wsvSN5XbbBxPAd9eWRHP2G8i4TLPUeuf	3576	5045	5045	1616847300000
6935	3NLm8YgGn8T6Bgt8F9YVCdo2PNNugM4B6nzpdMN7eqHtCxu97GtW	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	1406	1393	72	1	6301	jxqvLc8FVVtveCqmY7e9QXi6hazBsEKLXupkoXoaDVxZsEFuUzX	3489	5048	5048	1616847910091
6937	3NKdfjTYH4LxLwzramrVvHZmTmUmPaMoXg9P7DBiAJpfY6f34sea	6934	3NLfVj9gq9p6my3CcYY4zWd7rNHSTqHiV7sEaspXSokjP67PoXsA	1609	1207	75	1	6301	jxDMDQKnkBZfQwd1asiHx5tpoz7Z2UFx4x5rywRyRzroRGGrrAW	3579	5050	5050	1616848200000
6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	6939	3NLmPT19h4vnLe5acZVYYpaWNzYSTNg1ahJ4Wk5jHqdHtUiYNBeJ	1407	1395	75	1	6301	jwaTZ2jVtV5pJXrrxas1QoN7PZhEcHjm752EGuTo288Fy6CrSbQ	3582	5053	5053	1616848740000
6948	3NLk7B3qroqqPJ1r9gdrqBEZ5g7DRwaeotNisWju65cp2F1XstNE	6944	3NKUmqbHoAcbe6bw32RfUk2WLfNd7wsHqcjbMDTbngzE2d4RoyYB	1581	777	67	1	6290	jxCQGbztscYAK67Rh84yK8bXNBRXSY5RJMxYRKBGWLVXtiJZkkt	3374	5057	5057	1616849460000
6950	3NK5H1oiySiFxtL9MWFpR9eUnt4W4TjmUH2fUrcF3cbMnjfeu9zC	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1406	1393	76	1	6301	jxkHxpGSDVuSczhSAeghrY6vYLsdX8egLUrE4w4gterL8Me7X8P	3587	5061	5061	1616850180000
6953	3NKeUhePJ5fT6DA3CMPogviyf7Y3k8tsp7m1Sori6WbgmVAttz3u	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1541	1172	76	1	6301	jwZA4tYMFejzJzFSLMAXLzP4cQwAb5xYAMyZTpZkPFYdMNryL3K	3587	5061	5061	1616850180000
6954	3NLHxnbxZzW5MbpisHSE1MSTDeS8WUgVqeJ4KfwqNy8CwzHtti2a	6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	484	1319	75	1	6301	jwM82qWrm51mqUYV1JE4aHgevVyUehsJK1YX5fzRddNSU25ahLp	3560	5062	5062	1616850360000
6959	3NLxFjnk8kSSWycgM22tjiZPWLRnQqpqZEKGEK5UsSQUNms9eZg3	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	448	1059	76	1	6301	jxphrVWzpnbyywdkoZw9WJSchSDoHJj9jyzwLZAFZLYwqZF9TfW	3590	5064	5064	1616850720000
6961	3NKknuDxY44JSn7Asod7jtjKLcgWFCyrbagGw7VwRZvoXdVTfcBM	6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	1670	916	76	1	6301	jxrGxujrWEjM7V2LobeFrsu7Qd7iUc56ygxvhyGriJ4BfmfcERe	3591	5065	5065	1616850900000
6968	3NLLv7ffjTCksVQetgxaqdyq4stH7B7ytpGfdEaXR6Yzcb9CtiNW	6966	3NLwtwSMxqgk8FU9HP8stKUC317p4APwGaLdsHtwtV1GnKeDsLr2	1553	776	76	1	6301	jxX875mpYsG4oU6jR2cGrYV6N8UNgAtWD5pcN4TyiPq6tKPKvMv	3595	5069	5069	1616851620000
6972	3NKjR87tFZShzAC9BGio3L5Ac7Cqkj65Rrpo4k9yB7abD6h61xbJ	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1529	1316	76	1	6301	jxDPWQEsKHJ1hGUH6bbRw6RErE7HAutYYJraHBaNzxs9aPc7BME	3598	5075	5075	1616852700000
6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	6976	3NKRPbRm699y1rhosjAfB8zBk2jPe76ipJRqW6ke1gM1dSF2Sd2o	1637	816	76	1	6301	jxceKFcbGHHFYdCVgyeVqY9gxUrucrBotSErqYcfv2GdysHfjo3	3600	5077	5077	1616853060000
6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	1490	908	76	1	6301	jxcv35VBSmc8AERq4RGGKC4jLeqiMBvF7ytf2D8hkRRKguUFYAo	3601	5078	5078	1616853240000
6983	3NK5bRzxSKrwQ8LkcqQNcE3xbinCxTotr6iGhLzkZogHWTqbok6p	6981	3NLnGyqn8wjhVi3Mn2TDCe2ATSHRPCVuMnpxazW42Jyz951gBKaF	1607	1348	76	1	6301	jwQnsS5Ru6yvxu5zQVnEJje2SdKVSVbKJjdPZebxD4RFddbsyC1	3603	5081	5081	1616853780000
6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	6985	3NKyopB1QmtDDVtAp8sVXnmwitjQdzULMnp3Aka9aHgo7bn2Rxsz	1403	824	76	1	6301	jwBkGU2Gxfdc8jRV9u2yNP5AecN48Do23fozed1Teq94Wh2XiWL	3606	5085	5085	1616854500000
6992	3NKVrSAbBfqsdQp27EDpkAWz6giW8LFX7TMpZ7cpby1fkFxwqPAi	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jxuzZ9pKr6NtZQA9KVN3XSG2UAZW7b9Shx2AdiuULYcAfoAz7C8	3610	5093	5093	1616855940000
7002	3NKkBm5RKAz91dTd8sWTa8HWf6drtH4VA5d8NrwMHaMhUmRDkctm	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	311	1307	72	1	6301	jxrzjy4VNNs1yCnZXp681jm4ntnAxyWVRfSjgYgwKwn2XSooJ2Q	3485	5096	5096	1616856548677
7003	3NKy6YiNtcyzbb6EVp11CqTU63qUkA71irbXPGB7qEuMuwMCgBHR	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	311	1307	72	1	6301	jwGAeZrA6ZVFRXevfYEHjqhXN1GMwJBx7PqKBjPpWV2PicMsbfX	3499	5096	5096	1616856582178
7005	3NL6kdhy8YgXpHfsnv9KuE4N3RJ1j2i5toKsB6eX8KCPoMEsv6DG	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1447	1345	77	1	6301	jx6HNaEe3pLkpGUHYWjpT4nKTYVHhfYhZWMXpWmEvD8i46FnCVm	3614	5097	5097	1616856660000
6998	3NKmczyChA5qiHiGb9PQ4N9oS8QGBARt22gudtoEbhKobrBJb2KS	6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	311	1307	70	1	6301	jwrXzNDjKo9a7FSKAs7f1eow1K79tEEAjfuxK3h4is4oxXHGD7o	3454	5096	5096	1616856480000
7001	3NKc5yjfrAxi75fktaNaAoXRKZ8hwaCqVj1KvDLYi35cdQijv3sD	6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	311	1307	71	1	6301	jwS1W4RFhJVN3ST33adhXhqHWrKWSarasm6Uj18u2gQVB4ZxU6p	3470	5096	5096	1616856515502
7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1672	1039	77	1	6301	jx3nnd9AvC5gC2Jjhq193Rrt2ofo6D2tw1RSSqpyy3qhg6eFsoJ	3615	5099	5099	1616857020000
7013	3NLW6PBE8JRn6ARPrL7rGSkiZSdsRTCcBf5Jf2QDSQ5EqNwbW27w	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1489	1014	77	1	6301	jxCymDcQzvW3JY5RrbNoo24UnAuPgC5BhkAu6ULvGk64kvqp3Lw	3616	5100	5100	1616857200000
7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	1406	1393	77	1	6301	jxZrT6KgndHFB497vmCjKBwoT3q2ic64XG4Dm9hJ5DF4xrrnAgg	3618	5103	5103	1616857740000
7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	7018	3NLYoQU1G2rRQcCxu4ThvcRC2oUKtrzVwFxr9j3qNgpqvjbvs6qw	1608	1163	77	1	6301	jxghRmroYgGCjxk9bvW1ECpUr21xBD2BDaXHFjGTqJMKGQqnFQV	3620	5107	5107	1616858460000
7024	3NKCbH4qza87pJgFQyvmkvTwdhqsumbrbBSCcS1Tvk64KktqmzfH	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	1406	1393	77	1	6301	jy1Wdvf8LYwo5cBaEUNG8oGwqrycvuZqt9UJEG1X8tVD7nQTupu	3622	5112	5112	1616859360000
7029	3NL3noQkqh9Wfc6fSqdWur1DxJGc99P6z7rP8cSoKCEjsVckfiUM	7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	1403	824	77	1	6301	jxFfN9Zv92zJg8nf5smiwYNV4KJUrRGseU97PGDQPUcXeXnR9zY	3624	5115	5115	1616859900000
7031	3NLhvvEEKBMX4dqvZNZjYwwawozMAxsmph6h8D36uZrt4x1DQ1wt	7029	3NL3noQkqh9Wfc6fSqdWur1DxJGc99P6z7rP8cSoKCEjsVckfiUM	1594	1326	77	1	6301	jxM2WvDbjpGC6XtqUWt6yG8u9UucqyC9Ugnd9z6C1MxdGQx6oVo	3625	5116	5116	1616860080000
7034	3NKcgQvP2xXvmP5Pi4fwdtX9TcneY9Sg4g8ZF6LVctoZQtRbPSan	7033	3NLvTHzuTdi7K45ry49EPvEBoevUKAiZJbrpwhcNkCRkwhxy3KYa	1406	1393	77	1	6301	jy1t949taBhfX7ebmYgqSEoJZox2JmVBnGu1QewY3jHnfSgueGV	3628	5120	5120	1616860800000
7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	7036	3NKoQmmZRuyGWktmitFApKqra9pcrHY63ebtpNnDLDxmoMZCukGd	1455	1086	77	1	6301	jwXvuxk7sxSNxMQy6n4CEynCXiEX9bvP4z55U9LDaCwQ2B4hQk9	3631	5124	5124	1616861520000
7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	7041	3NLPSzroKTWRUK6bDdc3UwjhZ8xzGbxP2noWViPgUUu5upvg4QZF	1402	852	77	1	6301	jww13Vw7whnMaissgDJxp1wqU8E76jfuYYiuDTQGA56ecPuwbfg	3634	5128	5128	1616862240000
7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	7044	3NKo5Mcjzdpp2o3phj1AjD3cMNMw9L748fT91PwVwwqVGnBQ4ZTN	58	915	78	1	6301	jy1EZj474x9rGdKSMWYUrovm143kwShCpDEVFRJPTZd1n94mnH5	3636	5131	5131	1616862780000
7048	3NKuu8zmQfxsBef6Dc3Gr5ZqamosMtasLDnqRz3jaw3vrfQBZM2J	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1613	661	78	1	6301	jxX7xcNj9HiC6ZDhyJPdNCMXGNN2ssR2h5vFMd1N7KJc3g8oWjz	3637	5133	5133	1616863140000
7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	7049	3NKPKAmWhyoDRcy5e2NENcpEnR2fvPoSC3a971zwYzZhvExrdxfj	149	917	78	1	6301	jxvy5QJkwkCUoiS5tXgGs1E5918iTot16eWGHEwGhbcix4Gumcb	3639	5135	5135	1616863500000
7055	3NLmub3w14AH9MB69k7pKt3G7P1w9pat7f8XDCjCddzkUgpLJvwv	7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	1577	1081	78	1	6301	jwf58njkYkMiZYg72oX49pksMmXGpZY2VLmHRwxjQRCkXDPKZh8	3641	5138	5138	1616864040000
7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	7056	3NK3x9MoxZB5ii35zCuoDA4YeCT2AawsUAEQ4akvNGCvFTfZvedX	1534	1317	78	1	6301	jxoVTPqCUHKZZk3xf5d2AQr9rDfms2uRf9MeLRESS95n9FRNXAT	3643	5140	5140	1616864400000
7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	7059	3NKqeugPzCdgCuNpc559bfFp6meKqt2F7u5KPnWNWCi5ZX6Jvxch	1631	794	78	1	6301	jwyywvzaaYAVauEJ5hbM4f3KdCKverZQjnKW8FiCb6GmnMGDkgY	3645	5143	5143	1616864940000
7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	1553	775	78	1	6301	jxuKwDWFghHuCJz8b5qb2R36fMA8PMYT7JjYg9fA3sxKHvaybDY	3647	5146	5146	1616865480000
7069	3NKy3jHRTjSdhgXpCCDNTZ9Sp2k1kSy67FyMwJv4BAtJqrXgTf1T	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1590	1054	78	1	6301	jx1cF5S1ERuiHVUA3XpeL5xtQZfJuF5EDCGziuN4qDTbm8ToLgj	3648	5147	5147	1616865660000
7071	3NKX8nWfoiYj8fjc6Pt5dKD8knKu6xg9WVuk4fkzEsNsWmVuMBag	7069	3NKy3jHRTjSdhgXpCCDNTZ9Sp2k1kSy67FyMwJv4BAtJqrXgTf1T	1553	776	78	1	6301	jxuA8L92KevAPyKTBi7JDgQv9zR5nep9xHr38wTuS7Hx4e4p1nk	3649	5148	5148	1616865840000
7077	3NKhi44P9njEsVaF3vZxWUpTH1GGwTvFGU6LddBLgi7JtVdm6rnk	7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	1474	1329	78	1	6301	jxjHRpvQ7gDR8Qp3eoDNk6xCBN2x4WTP7pFLPouyT1qjwjAHMsW	3652	5155	5155	1616867100000
7087	3NKr1VbSpWnHu43ybyZQ8mNBEvRF12FCFPkQFdzmsPSfxUm28DAx	7085	3NLLoyAcoWbFX2FRYUEeeetmM5BCviKwQkQgh15DvSzNQ4naGPR7	1483	1276	78	1	6301	jw7jJHfZHUAXe1CKNHdVALJF6RjUCfr2qVqdM4TA7bHDpqgFYrP	3657	5163	5163	1616868540000
7090	3NK391NaWMbvbsiptZvWtYEErucNv95z6vSHLJaBchAjGMcTH1QS	7089	3NLuaE6zuhp1sy3yjvdo64wrbMqVgsVhBP1sBFZcnKY2dWu2mRMk	1631	794	79	1	6301	jxPHeuYpboXMXb18RHwTzCJBK9xzftn4AJ9TMrMXVmqHGh9DnLT	3660	5166	5166	1616869080000
7092	3NL4qC9Pi7vh4UfbunkTTKUS3paWEKsBwTw4MyAaFKUqCRgEuSBH	7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	1670	916	79	1	6301	jxz5KALCaTXwh5z79ikCU6LL8ubVWft3XseA3WGSX9npb476bWr	3662	5168	5168	1616869440000
7099	3NKdR8WgU6is6iHstR53AJsDbqC6zQHQGC4vCeyJMZ9tMerSo5ig	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	1402	874	79	1	6301	jxTvxinAFLi1xZ6Pa8Ao1XPg7imMSGZvbwHDBTWmyejWqihEu1e	3665	5171	5171	1616869980000
7103	3NLupQb9oj9Qaz8tzi9HQTo3GaSgap1LY9T3i9kXY31mnwTt9F9i	7101	3NK3SiZyvZe5vPMwYU7ZomZW89GS2gFgUiTBfTN5eN63CaYoHR6J	1407	1395	79	1	6301	jwtWcRminmWG3b7R2JhvJcnacJzsk78EivxLFim1mcoC6qtEWxY	3666	5172	5172	1616870160000
7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	7103	3NLupQb9oj9Qaz8tzi9HQTo3GaSgap1LY9T3i9kXY31mnwTt9F9i	406	406	79	1	6301	jxSSWJ8GkLUcbz2RKgzoAHiDma2ri8izenu32xbx5YwxnSvUKKe	3667	5174	5174	1616870520000
7105	3NKQnYXcujzi2mKrujXp2CCx9zWgPYQbiQvKhmGHt3CU2W5Djumt	7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	1407	1395	79	1	6301	jxDWSmzrM6E7Ux9v2BfzEYqZMRnUYAT8hHiwzsUXh35gys6giT3	3668	5175	5175	1616870700000
7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	7109	3NKfaKUFVrzjqhqNKPgw4r97cCsf3iQLMuUHBCPYvDSSDk8tDair	1619	1275	79	1	6301	jwtq5e8XZBskBFDySw2jPX1XgLkQKvrVViPYcTzLVrwkkXTL6ji	3671	5180	5180	1616871600000
7126	3NKXaVfZkrUQLqwqwicmNYPM9ctaKPn7KKHjhpRt4X3F4DqP8Qxc	7125	3NKgnTomvHuxxyjp9hVBHj45Lzg6HVwHnNsCmXdP8E9xtzgyWun6	532	1303	79	1	6301	jxVvFzJrw35ftiZBzraS8qafJnDLp3BvAwacv7TczWw5EJSWjK4	3682	5203	5203	1616875740000
7131	3NKDBF1U72EKc8KMpawRhzWrDmBKa2XzVXuPmd5eU8CC6Rg7cVdU	7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	1675	1216	80	1	6301	jxaoqG5NXENLMd41SjGNo15t8N9rHRodZbNWEfsXHTE7ieu6pcX	3685	5206	5206	1616876280000
7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1518	788	77	1	6301	jxhPLpeH6wtLj7tyCdAwfcQ2V1XuSCuRJqGAiw9sTdq6NBWQz5j	3614	5097	5097	1616856660000
7014	3NLAZUW6eqnTY5A2DjfHguhe8WS177EAvS3igTuzK7xZu4jiRJps	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1610	1314	77	1	6301	jw7iAbaufx7oj5UC4EjFjMmtMawfJD6zQzG1wGAuGgw1y8KRjF4	3616	5100	5100	1616857200000
7017	3NKAxqw9Zjqn6zLfs4nyNceSq12sU5CtR9qiFSrgfabyccnvaCey	7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	1671	999	77	1	6301	jwKgUJ4knnHjzowoRBc47PbQLwJ5AP36nUh7aFeGNBhxTz6qChr	3618	5103	5103	1616857740000
7019	3NKHR2Ueq6uGTKETCf5bFgKebCJ6HLVtqTEpgApu3nfqwfTczXGp	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1623	839	77	1	6301	jxCWhgD1vzeJgEW6FNNrfoztwe18hDPsaK4nyq1mJVmCJfbA5Fp	3619	5105	5105	1616858100000
7022	3NKpUd8ukrUk1dgamdGvQZWDmJ7pTh7zsEqbA8MpKxg6AY2EWB3c	7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	1560	1291	77	1	6301	jwV97SCd14opw1jDwfchH8X3tVJPLrqbudDf9PWmMzpkHJHdUEo	3621	5110	5110	1616859000000
7027	3NKZNjT7F1LanaFYdU9tJcbkWJ3hGYkTCNDPH6XhSHo1Egj3DxjK	7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	1457	1391	77	1	6301	jx2gFs3BFY7Y7SBavq8KcPPVZrJMmshG3N62yWfrh6HSNy8rHd2	3623	5113	5113	1616859540000
7032	3NK8wDQ2rBqZkGVoBn1SaB9w8DmAc3oJ3Vz3nwhkwX1TkxjuvksY	7031	3NLhvvEEKBMX4dqvZNZjYwwawozMAxsmph6h8D36uZrt4x1DQ1wt	1407	1395	77	1	6301	jwdSyyBnayWt5SYAwsrtooazGUcvakSveXzhMGEjTUZKfvSFEe7	3626	5118	5118	1616860440000
7035	3NLKAV2zwWAJ6pekizPdbXt4aVhM12TSiytmVtGQGjjjXeahRuS9	7034	3NKcgQvP2xXvmP5Pi4fwdtX9TcneY9Sg4g8ZF6LVctoZQtRbPSan	1405	873	77	1	6301	jwrAdMgxuoZFZAUtJiBAXX6fLKc8kQWSbVp4Dgo8s6kfAS8YPER	3629	5122	5122	1616861160000
7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	1455	1332	77	1	6301	jwMjTBWVZVNNembVQ3pnXCBAmSidVgFZKq6vUaExWY19HNoqa7i	3632	5125	5125	1616861700000
7040	3NLgv7LX3JLwKBm2dbZU7BPNHVPnazuuQkP5yg7kixzUc7afAdYM	7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	1654	1340	77	1	6301	jxmdvigR7LJSTLon7hfFuSEeYBy7qSBhVhmFLWRPGkFhZsypAsm	3633	5126	5126	1616861880000
7043	3NKMq7Ti8BzYPJ6xicY8RhfJb7di7Mnq1w5jXi9TeEod5LY9ZDeR	7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	684	1106	78	1	6301	jx6QRkLPaeZMSSuH3Cb8kShFyApEMbMjMrgacpdtNdHKiDxUhJg	3635	5130	5130	1616862600000
7046	3NLMeZBGRqwNthSGtVhtsJGS7q5QGihKoMnVdNxRn4mCyiUgaW8q	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1402	888	78	1	6301	jx5krx881SqwRVs1psMYDxzGQEgVAJeGGqDwQHgkpGE2qg7tKhX	3637	5133	5133	1616863140000
7058	3NKN74p9fTDaRLiExWRstnjgvMD1g3n8LKc8MJRhW245UXAfY7xm	7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	1483	1150	78	1	6301	jxksXei2V16mModxNR8VjAVuhkxy6CrVr5qkFTUVeu33ENVvJEg	3644	5141	5141	1616864580000
7063	3NKS73bzb2oYTpEZayVFdZSTHBuND3q3b6oE3g8mA3cYe61bNATT	6948	3NLk7B3qroqqPJ1r9gdrqBEZ5g7DRwaeotNisWju65cp2F1XstNE	1581	778	67	1	6290	jx7ZZ7pWEFLLb2GjCbcbkXziGEif76hLjfqjn6UsJddSShw9TJp	3375	5145	5145	1616865300000
7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	7071	3NKX8nWfoiYj8fjc6Pt5dKD8knKu6xg9WVuk4fkzEsNsWmVuMBag	1553	776	78	1	6301	jwT4hJZBgFKRPthgcKU4YiHxx6WPW9cUXGvgxcmtPVL9rGsQVaX	3650	5149	5149	1616866020000
7074	3NLer8W2TjnDHxZjcpDt5U6k9mLN52cYzCCyG8R1nH2NTD5NjnCv	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1647	936	78	1	6301	jwau6a8Pc82oErWctJgazxTn1UNEBcua2e5tN4MpQ5yoQtT9x5z	3651	5150	5150	1616866200000
7080	3NKpnKemKiiGofpr4GQ2cAoAHVLvcCexhsXVv3ge8ky8hVVWiXa3	7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	1553	776	78	1	6301	jwvKDAiaqWZB79fN7MzoJQzU8QDz3MV2ZBqQkeUH3VVKjCWgigc	3653	5157	5157	1616867460000
7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1602	1369	78	1	6301	jwC4Swo5ek2uhHDV31PZCsn6TQspT9nbMJwZfpdUobY2LoYDLUL	3655	5161	5161	1616868180000
7085	3NLLoyAcoWbFX2FRYUEeeetmM5BCviKwQkQgh15DvSzNQ4naGPR7	7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	1444	1381	78	1	6301	jxMTfhLw3ZK8zFYcQ5nbRDk8CrsNakattGR846mUqLa8G8jXibT	3656	5162	5162	1616868360000
7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	1448	1311	79	1	6301	jxpGomiRRVgzhuWMVwqcwMNrWGCrGqzNZod5pqYNnCeNH1tsZcQ	3663	5169	5169	1616869620000
7097	3NLv5WZupGB5pa3mx64CvYbRRUZgqnQQZn6vVndMqXQ4BxX75gQJ	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	1529	635	79	1	6301	jxZLpg6r83HfSTBKSU8Qr1sDvso7fEGscK5vghdAAn1WrLwCik9	3664	5170	5170	1616869800000
7100	3NL5G4JtoYqVYer9dvrNjvwiiNhhWDMfxNHR46T7dc5pwUYfXiz9	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	596	940	79	1	6301	jxjhEaLh7GAXfNeRQcnVvKowrUQjZQ6gg2WAhW4TzyiDgZ279td	3665	5171	5171	1616869980000
7106	3NL6f9JuYFpQXSSD4AhKJuoEzsNBLSQA8jAoqguUP3B6ksWD7Lg2	7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	1577	1081	79	1	6301	jxEebHdxLC8Fe86Mm9B6iZTWWjLQuJKiSvUU1AJk3WnbEJCujfY	3668	5175	5175	1616870700000
7111	3NLjKm4DGBbXFDwvhQtUg3NxpDvFLQC9N73rfCt5euMkfroMKYJH	7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	1647	845	79	1	6301	jx4sKbTto5jEWnxuQpcetXSizzzEVNWo2f3XEd6vwFEw486Lwxn	3672	5182	5182	1616871960000
7114	3NLJgHmT2eMZY2J6LvtZcDxiMiZGzhkRQyDGVaoqYVpThVLfRETB	7113	3NKxiQUEAGW4VeKmwmXRFSKijXU87R3Vm48n4ifRyWXHtfNVH6Am	700	700	79	1	6301	jxvbxqE3Vjus7v3CTe7U1eot7Py9fxNfairk7HonEvMnybCvqM4	3674	5186	5186	1616872680000
7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	7120	3NKrCXG5sristNhDMHEWzMgBpvkFd4DjNjLVYjRDSKbUB3KrVSXE	1513	1133	79	1	6301	jwhicpqonHjhaM1kQHQt9h9obYEAYtrVJcnpzq1xqMN5z1uKx2A	3679	5198	5198	1616874840000
7122	3NKBN94xgTtuMBiL3qWEJXZuswNHchiAMxJ7cnEKHEWeuvWyKK1L	7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	1599	921	79	1	6301	jxGvQwe1vW5F67sXRVUoyDX4p5EYnzxs6BUaQFs4M9QFWU5vySL	3680	5201	5201	1616875380000
7124	3NKPpSjnZy9uaq4FtKZF5ZfKeEnDcLLrLceDhbE2DzBPfwjqKLph	7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	1403	824	79	1	6301	jxxZdNaePrvCz3Tv2gUntdB2gyUiKQn6TiyuhfSF3tcve9wUqWi	3681	5202	5202	1616875560000
7129	3NLBkRkasdZueNNEdnbGeRJpQkvZYPzqsZgSM3KY3QXaKkqjeH8d	7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	1663	650	80	1	6301	jxEv2mjFyEmHNhck9SsufDUz1nSAixwxY9tpg6LdRpgPPAFCDCA	3684	5205	5205	1616876100000
7133	3NL71dPEvq5fggASdskQanGG9N2QYaTsAKmxakExT6PCamuoZwxN	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1503	447	80	1	6301	jwa4FEtVMw8HKibo7dq6abhbQWLHPayhqik9kqNyomwmv2R2vVa	3687	5209	5209	1616876820000
7138	3NLgpicmYtuxnTmRefYH3Q2wPCdi9mfMsB9vvwqJDCjkDJ2Caf8q	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	576	1355	80	1	6301	jwHVAVoLY6C54qXznBqJMmmgaMzzrpXhSVfoEx91MXTVzgh39Uj	3688	5211	5211	1616877180000
7140	3NLhbKFV9xH3tYqiZXaW76ZFhuuuXmEsUB35QarFTMRQb2t9k1CN	7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	1403	824	80	1	6301	jx7Jdfqt8xfhXrGZ1MDns3p329f9V727swZLzeVeGy4tYvxZszQ	3690	5213	5213	1616877540000
7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	7013	3NLW6PBE8JRn6ARPrL7rGSkiZSdsRTCcBf5Jf2QDSQ5EqNwbW27w	1406	1393	77	1	6301	jwCumLRS8ETex5s2QuiZsxPEuX8oot9uJYgx26xAAUEchryqY6s	3617	5101	5101	1616857380000
7018	3NLYoQU1G2rRQcCxu4ThvcRC2oUKtrzVwFxr9j3qNgpqvjbvs6qw	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1534	638	77	1	6301	jwZJWaTCG5iagGwJZfJgZAyDWjVZEhKtkGWBZDySwSPQMXwKUYN	3619	5105	5105	1616858100000
7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	1610	1188	77	1	6301	jwhneVfMziFk1uAVJhYwuci2m9kooopEXawp5cixfuwQVg1wgVd	3621	5110	5110	1616859000000
7026	3NK4xQwCP5t2AoChR9uauzPJKv6RgYwNY5cm48qgREuhbtqzihJR	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	470	943	77	1	6301	jxqMGj7admHjr6zfPjohgFhxv9nbjW6wwSwxYrdBXd3dqfLDWRe	3622	5112	5112	1616859360000
7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	1534	1191	77	1	6301	jx6AYyeo3cAu5a1JnRqSEGKEx99YdrHEuJSy4AwSRjeamHd6GRQ	3623	5113	5113	1616859540000
7049	3NKPKAmWhyoDRcy5e2NENcpEnR2fvPoSC3a971zwYzZhvExrdxfj	7046	3NLMeZBGRqwNthSGtVhtsJGS7q5QGihKoMnVdNxRn4mCyiUgaW8q	1623	830	78	1	6301	jwgx51tL2HGfnJvaaCCxQsiqjqF8f1aF5p58DPBDtWAjE8TEkTk	3638	5134	5134	1616863320000
7052	3NLUrSPFkksHjFgLF4SBoWKVQNMb8DPKE5wvuQYxbATj9j29u9Eo	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1439	1279	78	1	6301	jwW3SxrRyzftVh3n6ZdcQW7ULsPUA6wjHEx4VHSS45HgtiZFGfP	3640	5136	5136	1616863680000
7054	3NL2rEf5VDS7gBoYHLBGWQu4uQyuuVQLmgsZ4aqTtqXY3okG1AED	7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	298	1182	78	1	6301	jx8ZTpJ7jythXov3rzS4934T1JNVp4Yi19vCsrismNdEHG6SfFb	3641	5138	5138	1616864040000
7059	3NKqeugPzCdgCuNpc559bfFp6meKqt2F7u5KPnWNWCi5ZX6Jvxch	7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	563	1233	78	1	6301	jwN3Ta7Hsg4wy1ac6BfycUNNt29DoDVms8WXsMN4vU3xFFHtHcS	3644	5141	5141	1616864580000
7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	1489	1380	78	1	6301	jwax7DUPnrch5e9LTrpapFmRaHsZ6BzMWD7Paaj3UmY4WkXq9zp	3646	5144	5144	1616865120000
7064	3NL7HVyGvV1c6gbjKXJxg3ah5VyfcXggv9WAbe6N8MVFK9QT2Teh	7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	1426	1364	78	1	6301	jxDd5E8UdQn9AtyerwgEt1shnMpXu7ARuPDP84YQGpAZ83zJb89	3647	5146	5146	1616865480000
7067	3NKeX26zdKe7kemwCBPuxL2eLX79rbEhULmuj3T1k8MhCLk36SUS	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1403	824	78	1	6301	jwiLwNex3pELbXDBmbf97DoPwiryj6TDB2Cob5SCca1NJxdwjtW	3648	5147	5147	1616865660000
7073	3NLUTKNWzQV1kSRMgdW2i3tvVXVNnZ8Qm45Ta2S3JBkEcWD9ZbSj	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1402	874	78	1	6301	jwfToGKbu6pfwTgoCAVHWx5zGD3d27Cba5F3ZGzdsngpbR7MChr	3651	5150	5150	1616866200000
7079	3NLTGEvHvN4SLVGpuXotjUfeXgdynHn3gFEcbBMQgj72N4rTiq5u	7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	1516	1048	78	1	6301	jxpUfr6pEfK8F5vb1QVX24BDPLTLS17C1p1xqc9RYhS2VdWyoha	3653	5157	5157	1616867460000
7082	3NLb3W5rDLKXWYuczzW49PnRhfsubuh1UZo5VPWKkCTVu29ch6qn	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1406	1393	78	1	6301	jxFQqPhmbgGpm7pQZ1RVrfKbk9bBuaYkwqcKZZWrVJM8YRJMBgf	3655	5161	5161	1616868180000
7084	3NLcbjjVyn2QCzvXSaa2MgJXgop3mGsQDZsnA5FauaGxK85LCVbZ	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1631	794	78	1	6301	jxb7JSSc9gqM6Rj8KSDE8Kq64p9CcW7pCby1xeW6cY8qx2ry4XJ	3655	5161	5161	1616868180000
7089	3NLuaE6zuhp1sy3yjvdo64wrbMqVgsVhBP1sBFZcnKY2dWu2mRMk	7088	3NLQi8j7MLugHyGX6xGo1kAyHHQuD2CCWBWV8rVMMc1Zhf4MtCy1	389	389	78	1	6301	jxSxSW2UHURGoeWfD4qwTupPAR2osVKxLXG8R5hHK7RDNQf3Nc8	3659	5165	5165	1616868900000
7094	3NLnbw6EGNtxi91vZ5JPJCdDMC4pBa4HqNMmjad4RTv8LvAovBhf	7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	1448	1311	79	1	6301	jxAgWAwqchFWGVH4EZGcno3ykAUvFboTmtDBCWEGmBZp8rBcSoS	3663	5169	5169	1616869620000
7096	3NKHrpTW4LFGwvLYLx8YBJdKpGEuYA8agMYniWo3EafUuLae65dn	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	1406	1393	79	1	6301	jwf3TdZ14E3UQ42KovVTKsvkbnRidBGe8tPVmTGamYiJMpyQ8Dp	3664	5170	5170	1616869800000
7102	3NKSYQEzS6bKmsQuMaf9ofpVYFpKstdM7iFbMaARZ1C93Mcx3KgA	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	596	940	79	1	6301	jx57Pb19z3eEfjnLDhFesq1yYyp5TwYqtM8LmkCmnQPMx8o35y6	3665	5171	5171	1616869980000
7113	3NKxiQUEAGW4VeKmwmXRFSKijXU87R3Vm48n4ifRyWXHtfNVH6Am	7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	1407	1395	79	1	6301	jxXVw6VLpHAWHd2XZnY2fDGt1HRmnA2qnqtkc7GBaFkUi4V7mTT	3673	5185	5185	1616872500000
7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	7115	3NKSFNMjgGxZoJY15DBZ5Zpvxu6NuVUyHfxmoJYm6JtBhdNU9FSk	1624	1208	79	1	6301	jwjUforYZKayLJerCDcLvEvN6BEFdq9J71SMt9SSQXv3kS3kGt1	3676	5190	5190	1616873400000
7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	298	942	79	1	6301	jxztpQNoKr6U1WKgjWz1nXZtPUkQ8nG77dtaBtgC762cphbNbdf	3677	5195	5195	1616874300000
7120	3NKrCXG5sristNhDMHEWzMgBpvkFd4DjNjLVYjRDSKbUB3KrVSXE	7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	1673	1368	79	1	6301	jwehUXoceCC76h3CPKgzxefZiJTqJjpKrYHBQ4vRKBNNCtLkkFM	3678	5196	5196	1616874480000
7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	1500	931	79	1	6301	jxuVZLqR98BpQR1MsNsfMxmEzUDySZbvZ2rZtkyfjNSSe2EMb5x	3680	5201	5201	1616875380000
7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	1663	650	80	1	6301	jxEv2mjFyEmHNhck9SsufDUz1nSAixwxY9tpg6LdRpgPPAFCDCA	3684	5205	5205	1616876100000
7130	3NLRFTR69JAoBUWqbBxRx4goTscHsmSBF8X1Q7L2sgLwUyJQ9ZQi	7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	1607	1348	80	1	6301	jxKqUFuHSPWCqotwf9Yzhn4EnPpdTe3VZ8uqvWrn5BaTq73jrhB	3685	5206	5206	1616876280000
7135	3NKJUkd37a3ZQboWx5U4W2uieN6wwTDdnrumc15Hdmnwz9i4yb5R	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1637	816	80	1	6301	jwrWr6QnbB4KwNE2jnw8NqV9ZE8R6RivK4n9DXsnxFtfAXBKW4f	3687	5209	5209	1616876820000
7137	3NKN6qhDiGj5tpgTCwUeJMmKFLVWUbxjpu98zvBfqErGCNXzuH3b	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	1654	1214	80	1	6301	jxPZHgMGDzreMHiKqMivbAEG9qTqfbXdkkvPnm5pqnUAFkzbDSN	3688	5211	5211	1616877180000
7148	3NK44qNPyHD73DPCTR4UeSDqiKUravJWnr2FSpYCRsmdP78spXav	7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	1656	1217	80	1	6301	jweTcY9EaayMy2Z38X4KcsYG2DQ8V4fdrTx4oBXQe4x2EF4UAgk	3694	5218	5218	1616878440000
7150	3NKpwHc3MfLTPFdQiv4ESvfiq5YaoAUkbybVL7FuepYL6wh47YHP	7070	3NKVomCLhoHZ63sShu2A1zLxG87jyT3cS3fq5oUQv1AVwddzQGCp	641	1090	78	1	6301	jwtzAED7yHm3ZMm4esb7f11Kv6S7EHCM6arsNrAPBdCdLomWUnB	3624	5218	5218	1616878440000
7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	1406	1393	80	1	6301	jwgo1uKqpVgHAuSHbma5GLLPG1grrA6PA1v5EcV5pLsN2rwrmKz	3696	5222	5222	1616879160000
7020	3NKp6kucwMpfhTPpJDxqmm35z8srrrCwjf4Pd2WV6iFuRP536954	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1585	1366	77	1	6301	jwwwdhwpWroj5hNGvU9Eb5hDhemHNYdTAFvhdi44XPEhgSRMNR2	3619	5105	5105	1616858100000
7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	152	1330	77	1	6301	jwKPSufvRfVo5LeDc4z9tPJciGF6fj7tmxEBAARcZUnn3dEJTa1	3622	5112	5112	1616859360000
7030	3NKedDpThzwErBv3wFQLumKs2QR3ekWa4BQYqsvtWBy7WoexWAZB	7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	1407	1395	77	1	6301	jxR8gENWWX1NefkvGiCAGavStxiagMxgaaEP1cM3CYRMTerd1zY	3624	5115	5115	1616859900000
7033	3NLvTHzuTdi7K45ry49EPvEBoevUKAiZJbrpwhcNkCRkwhxy3KYa	7032	3NK8wDQ2rBqZkGVoBn1SaB9w8DmAc3oJ3Vz3nwhkwX1TkxjuvksY	1631	794	77	1	6301	jwMGuyhuw9Yx9144QjBXiRXMJqc1akGBw3Nk92diVFNynEr3yvD	3627	5119	5119	1616860620000
7036	3NKoQmmZRuyGWktmitFApKqra9pcrHY63ebtpNnDLDxmoMZCukGd	7035	3NLKAV2zwWAJ6pekizPdbXt4aVhM12TSiytmVtGQGjjjXeahRuS9	1673	1242	77	1	6301	jy1kYosRpBJUK2TNTfznYtXWZh5q7nA5zcAVPrpAP75VZjJ8R9M	3630	5123	5123	1616861340000
7039	3NKJNa4QBBhDkHJLwD3Xocfyz6yqHWnGY3msfYwo8qctJT56oEGr	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	1407	1395	77	1	6301	jw9ibudgc8mN4uk1ECikq8krknNxAAGeC2tsvfCBKtDnhKfTYkr	3632	5125	5125	1616861700000
7041	3NLPSzroKTWRUK6bDdc3UwjhZ8xzGbxP2noWViPgUUu5upvg4QZF	7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	1573	1318	77	1	6301	jx394rKVfaQUgmsmEXJAZYrUuH5LR9vvhK1dNr6G9vH4T8jZE5q	3633	5126	5126	1616861880000
7044	3NKo5Mcjzdpp2o3phj1AjD3cMNMw9L748fT91PwVwwqVGnBQ4ZTN	7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	42	1115	78	1	6301	jxGDRc8zSdXaK34py5xhAXr1FoMz21QtxtJ5CAGzQ7kxXXFektz	3635	5130	5130	1616862600000
7047	3NLuequ6K895FS9cCSbKP8Jsxd7ixaoqCFAFZ5oVurRiaudWXw7H	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1407	1395	78	1	6301	jwtQKiMk4fKcuy9qkCTbD6b6jhzpZ5sebR4BgHa3twjsaYcqPwY	3637	5133	5133	1616863140000
7051	3NKbFAhWQ61yWNvvEMgR6eX71D22UbPGjgV6Djf69kWh5LzcnHHm	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1406	1393	78	1	6301	jwJghKYYWGfj9emuMNe8SD8cqaaSUx2ZwTDhHA5GPZEcSLsdCz3	3640	5136	5136	1616863680000
7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1637	816	78	1	6301	jx4PiZCc3dkiEWTkvU151R3fWLqRAy9k93SkLzE2fS4UAFbjdQg	3640	5136	5136	1616863680000
7056	3NK3x9MoxZB5ii35zCuoDA4YeCT2AawsUAEQ4akvNGCvFTfZvedX	7055	3NLmub3w14AH9MB69k7pKt3G7P1w9pat7f8XDCjCddzkUgpLJvwv	1483	894	78	1	6301	jwEPbbLQ4d2PHRv5fJ8R1aygNgLauF6Cp4H7AbaTqx2GEk1SSQ2	3642	5139	5139	1616864220000
7061	3NLwBTNonj5m6H5rPWrwZVfZn8ZXo7SozoAUPzWiwk6wDwRh2N6L	7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	1489	1380	78	1	6301	jxxdrd8wXTQyRCkX9MPfwKKwqR81iFo7AUxNhHrYiHTmAJV2WVo	3646	5144	5144	1616865120000
7066	3NKqaJd6jnZtCBXGJ29meWFZQKp1amfjz1nb45kLsMpH2F6dVQyn	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1402	852	78	1	6301	jwTxXv92X9vJztfzYEMgTpttBFucX7KqB6NMw4eNuPHWs5apS3r	3648	5147	5147	1616865660000
7068	3NLTECMrKicxzMgjf1nRWSaNk4mRNqqRaRqxvQCXitF8ZQ2recjr	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	641	1336	78	1	6301	jxjqwJiM7vNgANpGTKKE4gy1Jeiu7ZXMc4m7wMFFLVVVr9mSjD9	3648	5147	5147	1616865660000
7070	3NKVomCLhoHZ63sShu2A1zLxG87jyT3cS3fq5oUQv1AVwddzQGCp	7024	3NKCbH4qza87pJgFQyvmkvTwdhqsumbrbBSCcS1Tvk64KktqmzfH	641	1336	77	1	6301	jxrNVMc8h9zV7wCHVkBTEfgo89vaVpKwyT5Kraagfu5wAdzivyx	3623	5147	5147	1616865660000
7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1598	398	78	1	6301	jwkYF2hSmNbKh46fRH12Qvf8FWaGEtM2aMpHcCVMAWhR1esDFfe	3651	5151	5151	1616866380000
7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	1447	1345	78	1	6301	jxkKkEKQx5T2VFXUk4wBbK9S9fVzGoY12VPwEWvBzFjZiXxR4k7	3652	5155	5155	1616867100000
7078	3NLQjZtoTUEfDoyzzDjwkqYBrVTjXA8xdwMsCufPBphYqh5bX7Zb	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1474	1329	77	1	6301	jxMWwwq2Ui7CtAztYYsZ9GDtyAgSPYEbnVENTu1eSLBFYRHXHtQ	3614	5155	5155	1616867100000
7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	7080	3NKpnKemKiiGofpr4GQ2cAoAHVLvcCexhsXVv3ge8ky8hVVWiXa3	1623	830	78	1	6301	jwL3eKxrt3z5DxSqxY3YegZScz1uP9cYDZ9uxaWcrP2ajoXzSTM	3654	5159	5159	1616867820000
7086	3NLrktH5MALUxCpzkVdRyUYCLvm34M5siD2xXQR4svWuB2rnqvxD	7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	1407	1395	78	1	6301	jxdH62AYFDiCtUjrhS6mgw1kyT36jgEBZX4TUFmsN3rPUVT7g57	3656	5162	5162	1616868360000
7088	3NLQi8j7MLugHyGX6xGo1kAyHHQuD2CCWBWV8rVMMc1Zhf4MtCy1	7087	3NKr1VbSpWnHu43ybyZQ8mNBEvRF12FCFPkQFdzmsPSfxUm28DAx	1622	990	78	1	6301	jwH5SCcWu1SUtA1epnf8XZKZcqQ6EGdrDW2gFoEhoHpupzEAbCE	3658	5164	5164	1616868720000
7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	7090	3NK391NaWMbvbsiptZvWtYEErucNv95z6vSHLJaBchAjGMcTH1QS	1578	1296	79	1	6301	jxkgC4dtGDcG7ECPRXXoCe84iw45jrwPBi5sJSDmxpAijXifoAT	3661	5167	5167	1616869260000
7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	1579	291	79	1	6301	jxQDHDP6SBev7Z9Fqyud4c5dmVMhP5vdwCYnzEHVRjoJqqWmPJH	3662	5168	5168	1616869440000
7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	298	942	79	1	6301	jwUyYbyjsKB8P8kKtBUEhRHK2bJ23ygZgP2F3SpsyfcEhEkpquc	3664	5170	5170	1616869800000
7101	3NK3SiZyvZe5vPMwYU7ZomZW89GS2gFgUiTBfTN5eN63CaYoHR6J	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	1407	1395	79	1	6301	jwa7DwTZSwZN5nJHhxjKGCN12WfoC1pQnzV65mfELDrNZsGdmeb	3665	5171	5171	1616869980000
7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	7106	3NL6f9JuYFpQXSSD4AhKJuoEzsNBLSQA8jAoqguUP3B6ksWD7Lg2	633	1384	79	1	6301	jwBvScXDEVRoaqrPcnKim5JL56AncNmQYNGNWk9wCkVeewDaAAL	3669	5176	5176	1616870880000
7108	3NLQkFdD4wePo8LVTYWG8PLWSgxKHynTCynXqpX21x2MPLJT1GQo	7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	1457	1391	79	1	6301	jxNYZ1pNZDwp24Kfc88z7ZB7FnceReM3NKrQ3b1eVV1bqbUWAbE	3670	5178	5178	1616871240000
7109	3NKfaKUFVrzjqhqNKPgw4r97cCsf3iQLMuUHBCPYvDSSDk8tDair	7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	633	1138	79	1	6301	jwexRvxjdvmj7u2br4UGuHBQRQzP3ioVqQgZWVyHKT46Ri8Zqtn	3670	5178	5178	1616871240000
7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	1477	1350	79	1	6301	jx5vtmU1W8o3pZrJnad9UXvvN6eaPFCF93BFNcXYb9JbTem7uyi	3672	5182	5182	1616871960000
7115	3NKSFNMjgGxZoJY15DBZ5Zpvxu6NuVUyHfxmoJYm6JtBhdNU9FSk	7114	3NLJgHmT2eMZY2J6LvtZcDxiMiZGzhkRQyDGVaoqYVpThVLfRETB	1406	1393	79	1	6301	jwRK4zxkRLzSAdmQi29LtHQ5SSjkzhCReAtkboFSPLnBTAtukzs	3675	5188	5188	1616873040000
7117	3NK6nUAaXth23gWXWN4F8jtf1GXKfSB1nXwfXzSgqXUmbyxZmYo3	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	1444	1135	79	1	6301	jwEcBdkkNAaLf9NLiyYMT19Gj1txJWMv5862e5UbnjMZLouqw4q	3677	5195	5195	1616874300000
7119	3NL6x8uZgCR8z9zXcTfkjSfpFupiVsHLJdKnAQAoexA5S2LSQ92j	7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	1627	1259	79	1	6301	jxC2hpxtz2hzW29hvLVvN8Hp9sDQ8YaoYkCfS6tnyk63EL2y1RH	3678	5196	5196	1616874480000
7125	3NKgnTomvHuxxyjp9hVBHj45Lzg6HVwHnNsCmXdP8E9xtzgyWun6	7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	1405	867	79	1	6301	jwdHd17aT7F1ThSNb2UGJegvBFeG8ERaJBoSTUpiVHkdgBW5trr	3681	5202	5202	1616875560000
7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	7126	3NKXaVfZkrUQLqwqwicmNYPM9ctaKPn7KKHjhpRt4X3F4DqP8Qxc	1637	816	79	1	6301	jxCYQJdNHNPvXpeUiSu5Y7DTh5A5umSTHsPs3RCFbtGcuxVSjvA	3683	5204	5204	1616875920000
7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	7130	3NLRFTR69JAoBUWqbBxRx4goTscHsmSBF8X1Q7L2sgLwUyJQ9ZQi	1673	1368	80	1	6301	jwUxfRnpfojKpP5Lx1J2uvhLM2WhmWxUCK5Dv1j2Lhwbssx6Xf9	3686	5207	5207	1616876460000
7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	7138	3NLgpicmYtuxnTmRefYH3Q2wPCdi9mfMsB9vvwqJDCjkDJ2Caf8q	1610	1068	80	1	6301	jwxqRdpnJcnbq2K2iY5MTeEnzQgA83kjDc2QBc8a4URnjAchNRV	3689	5212	5212	1616877360000
7142	3NLBGv5cv6nebzXcTzg3pZTCvtiimyVX9fbYjwmCsEdM3mThvXKt	7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	1402	808	80	1	6301	jwxRStfJn2YxpyeBkUyrsCDSUJ5VJmBoYQZBX9yjCdAi6q5WvsA	3691	5215	5215	1616877900000
7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	7143	3NKDAvax944Tp8KpduNrfBWa4wDivCxzpAkUfJkUwJmWfJ5Zkg1a	1596	1363	80	1	6301	jweB5pxuSKVEFhv3rfC4SbniXn5ZW6mruyjVpuQCwmSVpSNWr7b	3692	5216	5216	1616878080000
7147	3NKZXYTk7Sx7BwpevyEjGSHS6qjSc8yhjt6BhcatrXCQAbM2gDup	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	1611	1095	80	1	6301	jxMq2GJynQXureeFi6EhY2Aep7DfHxSYhfZt82Kqefd6LCzu8Q6	3693	5217	5217	1616878260000
7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	641	1090	80	1	6301	jxnvQzTUPYhAbGUMTXu9SNh6GMwPG9Age9N14jZDaiSCexrzxMo	3694	5218	5218	1616878440000
7153	3NLaQe2279rn6iZTiuQCBBUXfYnWMLf8qewpcyr7p1WHm7Dwn5YC	7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	1490	1028	80	1	6301	jwD4acQ8wjzLxYutdH8fd4bqux7DmMDGET8qRgpXEAvNDCJGSam	3696	5222	5222	1616879160000
7156	3NLaXWtz4bnqgqSD6Jg8LwNBpD1HW3ZJfD6dfJy22DDzbRTyQNNH	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	350	350	80	1	6301	jxaDHpQoc2T8hLfnYK4SnVaqLLSXzmraX9gmHKDVxXvKSzS8Zn6	3697	5223	5223	1616879340000
7158	3NKC61fbEHCAjk1QVbdB2sZ4LGHBF5u2Apkv84NrJrZHnzY4qEFR	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1407	1395	80	1	6301	jxxS6PYzyibVqxDi7B3HTxZg9jzPHju2trQ6px7mn7Hd14o54Xg	3698	5225	5225	1616879700000
7164	3NKq8B6s3zMpZcFCZJ8wAgRiB6BdjPn3gvsDWQ3TRtmgd7vkmDh8	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	470	943	80	1	6301	jxUM8KA4tMFfjq9WjBm9pJZE4PM21SyfvW3VvNfy8isaY3YbWZw	3700	5227	5227	1616880060000
7167	3NLM5AQAP4bVqDnQYNjZZxxQvDhgTZQ3fBmTnsBSWxXpXS6abahH	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	448	1059	80	1	6301	jwNAtgZppdj1JgCPEEBtxYMav2qkH5WCpvnWuk1K5jHE3chX9BM	3701	5228	5228	1616880240000
7169	3NKyq4RpgPk3Dx6DJr2hRSGi3EuJca7UzimHz2qZwZc1CkgLwyWR	7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	1553	776	80	1	6301	jwyDCDCL6XsysCu7dSj6jbTR2GPqDDsWHEpXxaNhFGr2Ay9UB7y	3702	5229	5229	1616880420000
7171	3NL5stnaRCCoyDavkCHUX9YY226xosH5vWS9CqmoMWQBRPZqhsNX	7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	684	1226	80	1	6301	jxFjxa1DcW6AGFRengJgTPGov37hrAp3DZczd2nrQuvVQLGdYWJ	3703	5230	5230	1616880600000
7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	7173	3NK3zUNd2Tyuqm44N4QPs58MDxctAusa4g5FCcDsSeYEw9ednFn7	1607	1348	80	1	6301	jxh17XeZwepHz2ncAP4HTBVfgX1mTAJKC5dyW9fuJ4koY8yh1Cs	3706	5239	5239	1616882220000
7178	3NL12ojuvGyk4ZRHkv75Xtyt52nTPia3YQKEtxaCZvNHo97ywqCj	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1553	776	80	1	6301	jxjsTpTDRVH2mRuUCXuj8ehuqj1psuhHH99H5gYUNBXtEDsfo2X	3707	5240	5240	1616882400000
7182	3NKc59PAMWuwXoHPazzVZV8gStxdp1rGEXfEtSe16XXXKoDb2FDU	7181	3NLPMPFBN235ocvVMPK4PvFN7HACLZjXSfF6Paz3dKatGwjv9R48	1422	1337	80	1	6301	jwM4m9brWXzM3WfHSopGUDuw2CfoYbV7UPrNhuJG111AP1VA7X6	3710	5243	5243	1616882940000
7187	3NLbAyLKcFdk67D7S5CXBZqJKPdFnVxMTPZpHUozG1vmetkLd91Y	7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	1406	1393	80	1	6301	jxPVqvhPfDm4n6jDcxrNiigzYYK1cnrBC3vRaYPjVsmx1dfUuvS	3715	5248	5248	1616883840000
7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1549	1116	81	1	6301	jwqhacdiJfB5iBcEC8wLGXUf1DUMCEhCWEGwDRWsSDw6uS1Eh1e	3722	5259	5259	1616885820000
7203	3NLZ2SAu4VZzWorQpJBh3iFQZvme33AhQ1bWxXoJVuupANcdrJot	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1406	1393	81	1	6301	jwkeUvQ1YURgmz8Murb3C15QMnmMf91uY5huCkBfUKbtRA6ad6j	3723	5261	5261	1616886180000
7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	7208	3NK3WfS4cUyvLZeceYdSdJfdgLP29zXjbPxA6H3ffNHjJyUwniJT	44	1199	81	1	6301	jxtpiAhCb6Ax7G5se6iQMdfwsA9TFMX2rFKVvgQ1PK6Yso6AYz4	3727	5267	5267	1616887260000
7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	1422	1337	81	1	6301	jwTiM5J95iCmxqK64YFPvoK7kZqEvHA29Jk5rvhe74hWTJk7yDh	3731	5273	5273	1616888340000
7218	3NLcm6uoJsFHnKaQdAMfbDa6nPWJLPW9B4mznKd2B7A9wk4e9wNF	7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	1407	1395	81	1	6301	jwWdhinUJpNSggoa1feZsoMKbX6HJXZbYvJf1PvjU7NdKk4ZPAC	3732	5274	5274	1616888520000
7221	3NLWnwV2yexgHu7rvcFUcGg2qrt5SPpE35qosfuHksxUbc577FPW	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1405	855	81	1	6301	jxtcSG2e6uqRuVNh8e1euwCkDdn2EXebkYp8PTKm8Basp4pxd5o	3733	5275	5275	1616888700000
7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	1474	1203	81	1	6301	jwcxedxBsGP4hRWUGfMXiBPcA3TnCGVjFe7BtDXkCvpR4NL9LST	3737	5279	5279	1616889420000
7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	1581	778	81	1	6301	jxjxLMs1L1wELXBu2mrPfX7ngVY5wRXDUZaDt7CN6UDTRpSTPsc	3738	5281	5281	1616889780000
7241	3NKMyjNhe74QjJwXwNCPnVub4LjcygQp8grj3s7Wjy9GHSmELXJf	7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	470	943	81	1	6301	jwZ84TibE1YFkx8on1awDtX9QMxUWVGpsgTh1zDRQhtmTBFzvcz	3742	5286	5286	1616890680000
7257	3NKAe9Ue7rWmUbAVGdUnf11XHE87YVTMNWN4kTvoJSegHWmVMyis	7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	1627	1139	81	1	6301	jxgDTk8APXeCXwZRdNhsiWadhiwy56Sz9PnVLNJjswDENK1z4KR	3753	5301	5301	1616893380000
7259	3NKX4grV9F8518duQ7FoeGdDsrF1hDXcX8emxydLhqa389XSkc5n	7258	3NL66uHLjcxpVwopNFinbqHbYRgoejS7q9fAvbvfjGCSwnbP3UsQ	149	1283	81	1	6301	jxvJWhYrZXyzf8fgmw3nJUAj8YSu3ydPChXDR9QL1HXTAamdwsV	3755	5303	5303	1616893740000
7262	3NLkjrBP9SUS7cvy6sYBoufgrnfgTBY2q4wiizR39wUTzSDXdYpp	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000
7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1602	1369	80	1	6301	jwRM3tTfWmSqGkecTC9uMC5WzxHLzEvfaQc5idbdFisgjnXeA8R	3687	5209	5209	1616876820000
7136	3NK5JveZCh8NanxDufGhofEPFMpxQ6KU8XzS8iEAgiuPohxmX1iM	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	1467	1376	80	1	6301	jxyV6eRCa4YUf2paFmduK1zCCEBC8X4oGFddp8MzYBpWAF1qWbT	3688	5211	5211	1616877180000
7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	1483	877	80	1	6301	jx1FyAawoAb7joTzL2UA4TS2SM7MdefMtPphvHU3QjkyPquvi1e	3690	5213	5213	1616877540000
7146	3NL1x77hgNKLLnrcAqt4pKUQrkmhP26aCwvVw9suXBnj8SUZnkGV	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	1549	1362	80	1	6301	jxbybdXSw7X2Yqd1tcgWW2FDos2v4E27XYSnibmaYm91DV7XrnD	3693	5217	5217	1616878260000
7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	1600	1372	80	1	6301	jwASwvpCRRBn9XEFDkeeZY8KjxDVDDLoSv6Km6mzHz6WSjJEYU2	3695	5220	5220	1616878800000
7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	1607	1348	80	1	6301	jxvAtHGZapSMcSEUgrEvYYzdEMafeqfn4pCownZviofhEGvM6bW	3697	5223	5223	1616879340000
7160	3NLs5x41abTS6B2xmi2onvyFyH6kexwvmmeNN8TtvsmLLm3jwzQm	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1593	1100	80	1	6301	jxbfwsvVqQz7h6SnJezsAGo5Y3KixS77Z3npsAuVpZ1C46F7LVm	3698	5225	5225	1616879700000
7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	1406	1393	80	1	6301	jwHbJ1fpsg6nFPgz6zaLCFxDvfYeeNhsVaAPSStfbbzssQU2eCN	3700	5227	5227	1616880060000
7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	1406	1393	80	1	6301	jxYTMwKiTUDTonQHpxYoLvjyWevpgRksCSHcQzZLqwNbr6Sj2H4	3701	5228	5228	1616880240000
7173	3NK3zUNd2Tyuqm44N4QPs58MDxctAusa4g5FCcDsSeYEw9ednFn7	7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	1564	1212	80	1	6301	jwdhikG9ZL51qo6ehj1piEw9UVsqyjkrVRdYaF6XjsogukcFDt1	3705	5236	5236	1616881680000
7176	3NLdW6kJnbvaFDnvzJW2Z9sYq7XRyHcmZWntULM2APa1QV8HT8ZD	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1426	1364	80	1	6301	jxjGuLbUSr9HgyC7YPqtHEdz2pqCTz7X4Gok8yb6v5tqoF7o9CT	3707	5240	5240	1616882400000
7183	3NKKWQjG5WKkRP5uFJvGaMbQzEksdMbwm8V8jcJxGy7CRAG7oc6n	7182	3NKc59PAMWuwXoHPazzVZV8gStxdp1rGEXfEtSe16XXXKoDb2FDU	1637	816	80	1	6301	jw7zQGE1WZajig9pXs8kE3Djq2nY2YDTALBdZZFDk1d1FBWGkzj	3711	5244	5244	1616883120000
7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	7185	3NKnLAB48QvSiP2XMG4NJFwz41q4cqiJd8qSESeLZjhdrRm7bTkc	1403	824	80	1	6301	jwrB7oEM4GxrHj1CCPWVn5gmQvYihKMS2zHktuTLjm7HJMF4h32	3714	5247	5247	1616883660000
7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	7190	3NLhhraxPYQnZmSKn6DD4nR15wvcv1VjLir7mP1WBqcasAYEMegL	58	1281	80	1	6301	jwqynKd5CciPpukGqLyyWjR2NF5fUccedL2R1Ec5pcSrfYFDJt2	3718	5252	5252	1616884560000
7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1407	1395	80	1	6301	jwrf4i2iBUZkiFo2YVYRDBkLutvsGL2vgLNu49gYzn1Q3c4m1rC	3719	5254	5254	1616884920000
7197	3NLHFDMxLuuq8dtt1y3HL69K1vSRYFoqYh77LbGoyKaMBSCQQ8VR	7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	1451	1046	81	1	6301	jx7a8ZqB9hzYxa8T494AfAV7wK5Qce2zXrcJyE7sTgQyFtF2Zfg	3721	5258	5258	1616885640000
7199	3NKpN3ncYHRXHWhGEuiW3A48szv3ohuSMPZd3z3t4GpRykPsSSfP	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1588	1026	81	1	6301	jwT81eVy6VkYyDbhv63TPBiorRoGqer35UmqJmoKDKCdChsfLVT	3722	5259	5259	1616885820000
7204	3NKvscDufkYwvnbqJy2F118wGZM2ZYQbQ2ENU2cwZhMbncytADct	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1407	1395	81	1	6301	jxdLrgefVyVoUVgcDcZtq67joeFdic9eCo78JEV5RpXMxPPDPVK	3723	5261	5261	1616886180000
7209	3NKMmueZc75qW6Y1Dn2kgKM8B5BePVo8JxNhwhTTcAoHKF5mrQjc	7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	1594	204	81	1	6301	jxrT6CbGwBg1xLt69AQEuALJZaxQGkotSxgBvzZ4vFD2PXceP5p	3726	5266	5266	1616887080000
7211	3NKjMyd1jfWCQnqXqZ2vWmKJQYHqrVLeHYotGxyKqzAw7sf2dijc	7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	1619	1029	81	1	6301	jw95A8JV5sbKQxfFCj2CnjtLvDv1LVCXpULNR3hB96nSYf7knXg	3728	5268	5268	1616887440000
7219	3NLjT1pa2q9ebLBuUcH6AvBQbjXxLfeNEHkX14spUuqEP95Su9NN	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1406	1393	81	1	6301	jwvPPYonqKnetYqQdydt2nan4yTqTUeCiR2WNdaseoAtoDMdPwS	3733	5275	5275	1616888700000
7223	3NLNgdArvXT7xBnr3WyxR5XTvjz42RHVrE63Y87nwYxgK45dAGog	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1607	269	81	1	6301	jxNtZ9EskaFzdhBmfRCtX2Y8NQiesyvkS8jE9AjVfxwfJH2ZM83	3734	5276	5276	1616888880000
7225	3NLY4Es7atoVAToLnez7xUyC1zgq8Eubu53j33jr2YLnMiE9nQoD	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1407	1395	81	1	6301	jwzwEGZG94iGUtKkxoTqar2xX6fmbt4hkR7FdJNbXu57UYhp7hr	3734	5276	5276	1616888880000
7228	3NLf8cHsfjN9wXW4adPPaZjLh89vzS4TQMZaZt4vW3DDtB4NtzEq	7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	1405	865	81	1	6301	jwS8mBseTy8eUcxrjzmso6f7j4eAJtaxCZcd3Fi6YLMphyChWSg	3737	5279	5279	1616889420000
7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	58	1281	81	1	6301	jwd149Yt86TfD4ukw3kXcg3KxF6smEJLEJ2FQ9BvDrYBzq7fcrb	3740	5284	5284	1616890320000
7238	3NKWCyC6A6eJbDvrSwgRwXUDdHTToW9DVZ3ofKS5L8QnZ3U4RKf5	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	1518	787	81	1	6301	jxCRGg5niwMUNTGnn76uFcAiHbAjLTQAVZWYS4nZK7stwVAyX5H	3741	5285	5285	1616890500000
7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	7240	3NLtYLcH2BG1zppRWHbsR7V1TGH4vCou3QfW74pwY5khgNE6Vx9f	1581	778	81	1	6301	jwNZxr6KEVfttTEksyaJJASMYg36VRW5e1yuUnz4DFYqu81T5iP	3743	5287	5287	1616890860000
7245	3NLi3kZzVjircojePqL19YHMiYP69wqQXtSX5PYQPwPYzDFvQKpA	7244	3NL5bSh1Xr5BEwUkq9N4JEAMfxobRzksq2ekUJa6EtAMX4fczKVy	618	618	81	1	6301	jxpxtfwpChd86WDW6a3pZ9mnxjN372bCRARu3UQeUdqCcv3UQ7w	3745	5292	5292	1616891760000
7248	3NLF5rquB6W2hNr8uwSXbD6rPju1FCqWsZQJfjrF3w1FHAND214a	7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	1534	164	81	1	6301	jwxAU2irKFsP9AJtgA6hXC1yQzBQ957Toq3U1U7Yb4hgLVuBLf3	3748	5296	5296	1616892480000
7251	3NKb9fdwkyArMmgbVCvMZNXJReTakeKBGN3YYZvotGJ73yV3SzM7	7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	80	1027	81	1	6301	jxMHDN1NxpAz4cDbczybc2WznbF3Bas43KM7iaH4eo4uw8z6XCv	3749	5297	5297	1616892660000
7253	3NKig7UCMiVjqo5TJGdtPM8mjZefZfyBTMw2EFyaiGnWyVvMVxyY	7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	1406	1393	81	1	6301	jxTkstEmobDT3tig15uZQeKC6cvk2GmFDKqLyB2FHvL3C5ieJkX	3751	5299	5299	1616893020000
7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	7254	3NL8S4Ef4BUEujzRzPh5Q4mjEiwEJKCpHyYN6qSXJgyNiHexmwF9	1542	1178	81	1	6301	jwMqEAJCvnWRcCxjWezUxUHuVASegdszjqSF22coHbPUo2pshhJ	3752	5300	5300	1616893200000
7143	3NKDAvax944Tp8KpduNrfBWa4wDivCxzpAkUfJkUwJmWfJ5Zkg1a	7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	1637	816	80	1	6301	jxMgWxUYm6LSaYkDP6oTvvhvhzY4ubcYPeJUsqGYNZ7bTAgpiBz	3691	5215	5215	1616877900000
7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	311	1061	80	1	6301	jxnem5mKU5TF37ca14QLCa4BmizfTVfWztdEpuUDCZJRDeMZiRH	3693	5217	5217	1616878260000
7159	3NLUJxaLgvzmRCtVMjgPHtcTMEdLLhEnGAMvWCjZpYxBapnJZSmP	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1617	1288	80	1	6301	jxGzZBEBJeC8uvhtaSRkCyV34DPgTbCi1C1RvTrNNmePAV3f3tg	3698	5225	5225	1616879700000
7161	3NK8EHnEPggRREqEk7DurQqtHHFFgAgovpTBj1q5TFfsGxgZhWrQ	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	470	1309	80	1	6301	jxLXZJ9RGty5zYyJBcLroVP4GE3HiTayWMSByTwmB3mEtWHWzqc	3698	5225	5225	1616879700000
7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	7160	3NLs5x41abTS6B2xmi2onvyFyH6kexwvmmeNN8TtvsmLLm3jwzQm	1403	824	80	1	6301	jwADA2MGdpTN4tvxQT9jjSqj9Y6j4b5BpGfrW9MK8Z5Mb36YrxR	3699	5226	5226	1616879880000
7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	7171	3NL5stnaRCCoyDavkCHUX9YY226xosH5vWS9CqmoMWQBRPZqhsNX	1581	778	80	1	6301	jwb77UaCD276QCfVbpSumBCFfUxMQNZ2BEfo27oUijUFnGgG111	3704	5234	5234	1616881320000
7179	3NKthqcN2eaFFmJ4j16QKodewJzX7XXBWj4vuNU4bDFnYcL9up5n	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1577	1081	80	1	6301	jxtykWkSiFefXzoTjCv5crc2dKrMjinYdKd2R9duDwJ3EV8JrzK	3707	5240	5240	1616882400000
7180	3NLc73vXNqoFpAbsZVYhoRC9SYxiLoGRdDcanNrasEXPBBGFLSJb	7177	3NL9tubbZjq2cnSMwk6DZpEjcEFZAGfDneCFfgctxkKRubDXfjuL	1406	1393	80	1	6301	jxKuso75YYxtgURXMhS2P5LDtCXnvxJSiifWEhinMrVddJZXxrf	3708	5241	5241	1616882580000
7185	3NKnLAB48QvSiP2XMG4NJFwz41q4cqiJd8qSESeLZjhdrRm7bTkc	7184	3NKyHpZwPqsaSaBHq835wBKGMAJNCnRrerZABptWjGbWPy4YtK9G	1522	1076	80	1	6301	jxkzTVLewfxLdpVpDmyE79MYp9gpezdLZeTE9zfVpxGdQnjv9Yi	3713	5246	5246	1616883480000
7188	3NKwg1Q3c9qBNCJnPe7fi4AmYtMGCypM8ELM3jGdXgWtij6oAXob	7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	58	1281	80	1	6301	jwXaKRDijet1cE5R9Rha8yFptpzxxtg9YCwjv9QmgN1y3ME1obw	3715	5248	5248	1616883840000
7190	3NLhhraxPYQnZmSKn6DD4nR15wvcv1VjLir7mP1WBqcasAYEMegL	7189	3NLvNnVbWBMtsfVtdNFneNzEN1g2AkNmNRhxT48U3iWgczNA9Nqo	1460	1324	80	1	6301	jxmT9g6PDagy7W22Wdui7u15Yj1U3c7ZByndovRK9D1Pieu4ju6	3717	5250	5250	1616884200000
7193	3NLttd4aBusgCSb2SKUPyBSKiFbnygB4oNCw4b6HehhspniKV139	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1670	1156	80	1	6301	jwA3npuizP1yGxySFddCQfdU8Njo4WZPo9n6eatR4eSKmiRGaQ6	3719	5254	5254	1616884920000
7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	1403	824	81	1	6301	jxnw7imt9AH15PfKuyLv564s8BakeJhrTEwn1w1nDjqNMvgfejn	3721	5258	5258	1616885640000
7198	3NLfvgaNP4JMsj5nB8qM4GuxCFpKf4voqTBVeEco5P11CbogqqPK	7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	1451	1046	81	1	6301	jwFLctdBND7GmscHhpFMJMhYkK713q34mFGJDcfjjkt8Xg8Fg6t	3720	5258	5258	1616885640000
7208	3NK3WfS4cUyvLZeceYdSdJfdgLP29zXjbPxA6H3ffNHjJyUwniJT	7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	1507	1280	81	1	6301	jx8P3cC2L67h4a4iKo9iBP27y6TjdEPWSzmMbz3hzUsBjWwazsQ	3726	5266	5266	1616887080000
7213	3NLsfJmLRDr5XNqr18VnVCRVjbJZCATWh8fgt7AcvfSFQuquDkR1	7211	3NKjMyd1jfWCQnqXqZ2vWmKJQYHqrVLeHYotGxyKqzAw7sf2dijc	1483	878	81	1	6301	jxF5TVy7esVgPRUFBzvzAKg2Q5cTUc6kt5RytaEzvpRjpjeNxVQ	3729	5269	5269	1616887620000
7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1560	1165	81	1	6301	jwGqUARkynEUBvxnwM8ie97YjJvwjE54qcRjkxQHBXeDQSP3h4v	3733	5275	5275	1616888700000
7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	7226	3NLPLbyht5aDpytSVgahFDNUCzrDAPe8w9VxMj3KBk9nMG7MPbiL	633	1258	81	1	6301	jxR3ZTkwEQyp71a782mDB96NX3uzCUXP4kkFyieLKGycEJoyeoP	3736	5278	5278	1616889240000
7230	3NLKnzv2PXSQUe8oDriiL3v65TMUKzQvCqBEQdxGduF6mJSde83B	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1474	1203	77	1	6301	jxcDNK5PiR9Viz3L6GBXiv7q459DACNuy9dBiUEZqCyecwLfkFX	3616	5279	5279	1616889420000
7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	1476	1371	81	1	6301	jxiX1LYiKti1fxARiYMSWjq9dN5mLBszpFa5ERpags3BdpqPra5	3739	5282	5282	1616889960000
7237	3NKNX9pWV5BE7cddqAJuy12uqyDhrdgkh9sszR9XuyiA4xjSn9kf	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	175	175	81	1	6301	jxQAYZs4uPKcZmLyd2rBgwjQxUFVhSThCPkCt9KDbnKX7RFVe94	3741	5285	5285	1616890500000
7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	1513	1133	81	1	6301	jxUoQK3z2kH2DF29i9uEZfXd9T67nEL9PKaoPxzeZwnQhzVyw8M	3741	5285	5285	1616890500000
7244	3NL5bSh1Xr5BEwUkq9N4JEAMfxobRzksq2ekUJa6EtAMX4fczKVy	7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	1577	961	81	1	6301	jxbi1o3rfrtefTTHQFxzwjsxqziXTLzTMfDF38uRNkgrB1tcMhf	3744	5290	5290	1616891400000
7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	7246	3NLGze4bzyX7Ev6vKApGmkDQkT4rutQkqihHSUvoMQCTjkFNJ9Dy	1631	794	81	1	6301	jwZTuaG5ptr1a5VsR8M2LNvsB3oVAT9u3aDrRRXQMB67AyUcEgo	3747	5294	5294	1616892120000
7250	3NKawYmpWVyoZKkFsYBDuGSNq43gMkxHTsQk3RrSRRdZvuYdJ3mZ	7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	1559	1353	81	1	6301	jwsGLuW1u1kSrSGXdKBiUdZgh9X6hvmHixnnfChNDBPDSCVVQKZ	3749	5297	5297	1616892660000
7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	7251	3NKb9fdwkyArMmgbVCvMZNXJReTakeKBGN3YYZvotGJ73yV3SzM7	1407	1395	81	1	6301	jxc9nXLwKbLnJLEqedGPxbVc5nLKeDS7J9GpxyEXiUCswoZ4WEE	3750	5298	5298	1616892840000
7260	3NLqDHQNnw4C7hAE7F5Luan2VKbQgD8fauEumDsADQu4hAR51qo2	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	1633	1390	79	1	6301	jwSbB4bTM5FM93hmiMCH5XjrBTLu3fFaEtaKw4WWHKDUzHvu3Xz	3677	5304	5304	1616893920000
7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1588	1392	82	1	6301	jw96Jengxe5gPJff7J7fzJMnPmcN2PrBZd8nWDZvgPFEo261CTo	3757	5307	5307	1616894460000
7269	3NKJhRdNLYDKFhvF46m2TREEhJ9qMz1FaxDc3k9npr2FmMpHWyFi	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1656	1343	82	1	6301	jy24GhxgWeCPbb12vYT1WM85tQ7mPjthznP2SpnM4nroPUxqVsj	3758	5308	5308	1616894640000
7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	7270	3NLgQjtag6vTdVJPsHrheDQzgQFMoy8LsdoDhnXmA1qPwEPzUdbM	1671	1365	82	1	6301	jwAWRa6txXUtriTHZkB9CDETxayLQ5qwiRHkKeZDEV2WxiftxUf	3759	5310	5310	1616895000000
7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	7273	3NLebos3er8dhcu2wR9UqPp6bsiTeRTNFse1kibw2xnTFADFzF3r	1407	1395	82	1	6301	jxvxCbfj1vhMqxS7AZFYQuz3vWNf8NDhF4BFsevPupHhWmBkB8r	3761	5313	5313	1616895540000
7277	3NKG9ndUmB4xHSmUb6BwsaoaWzYDxJCfw4F7ssGhFGzTrzGdj3tC	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1578	1050	82	1	6301	jx4i9VoZwWKk6U2sVuNZJRbWQSJM5X1dr3VkuvL1zK6UdtLGs4u	3762	5314	5314	1616895720000
7155	3NLVCHa3DWH61gG2qbc4JSAgKA5Q5UDjzRHVhUue9z1yVheYMFA7	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	1407	1395	80	1	6301	jxgM7z4u5nDK1ajZnHTdyv9BidUMKGCcvRhWAsKewSDyTeXvDrP	3697	5223	5223	1616879340000
7157	3NK68hW9oGQHoDn89Qn2TtRg2DGUKGyJWP3KXR4RQ8DXYgGcsA5r	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1587	1357	80	1	6301	jxT4fxKPkmMsR11z5CVaFKrHGM2kQHBQvwBGAQkpbPnjuqvzxGs	3698	5225	5225	1616879700000
7166	3NLSdHSp6Li78GiaSEQkAXBBBjakP9E93HF7cmm7G1rMuSMz1XDb	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	596	1306	80	1	6301	jxCR9EwQxDf8o4XtBLQoVZK9qSf3neruFcNzwqDB2faD6dytbe7	3701	5228	5228	1616880240000
7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	633	1384	80	1	6301	jwiNWUqG1hJ5EigWJGda2TfEWLxzSi35itkmWoS7TX9Bwvhhtv7	3702	5229	5229	1616880420000
7170	3NK6ZaSueMqvraZZJfWphiqqkqpYcN7Ebko7Uc9RmuwvF2aZ3SvK	7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	1546	973	80	1	6301	jwJr1ZVxcGcsoDWPJPvj4ccNgkN9r5JUKrgPtMwbeeRKuXAjJ6A	3703	5230	5230	1616880600000
7174	3NLJg97gSBsaz8dgXxW1ghNrk1MpwVMgaDU24yuMdmHATZ9Qdbx6	7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	563	1233	80	1	6301	jxAAXSdkcdLk4sbmWbUFGpGcq3wQsC6rqaj85uQL48ZYfeY199Z	3705	5236	5236	1616881680000
7177	3NL9tubbZjq2cnSMwk6DZpEjcEFZAGfDneCFfgctxkKRubDXfjuL	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1407	1395	80	1	6301	jwNBMKbmULqDQyUE9Pab4ujqhBLbrxJpKwNt8eEALfTapweuXYU	3707	5240	5240	1616882400000
7181	3NLPMPFBN235ocvVMPK4PvFN7HACLZjXSfF6Paz3dKatGwjv9R48	7180	3NLc73vXNqoFpAbsZVYhoRC9SYxiLoGRdDcanNrasEXPBBGFLSJb	1637	816	80	1	6301	jxSKQQNK49CvejkoQCyJ387GnrWoiekAZiaFzqTMyE9wPGxbSrA	3709	5242	5242	1616882760000
7184	3NKyHpZwPqsaSaBHq835wBKGMAJNCnRrerZABptWjGbWPy4YtK9G	7183	3NKKWQjG5WKkRP5uFJvGaMbQzEksdMbwm8V8jcJxGy7CRAG7oc6n	684	1352	80	1	6301	jxFMWD2cFoPNxaAo9xHyAVDGuSHrtVrsmCocc15BGrtETz1Y6PX	3712	5245	5245	1616883300000
7189	3NLvNnVbWBMtsfVtdNFneNzEN1g2AkNmNRhxT48U3iWgczNA9Nqo	7187	3NLbAyLKcFdk67D7S5CXBZqJKPdFnVxMTPZpHUozG1vmetkLd91Y	1440	1011	80	1	6301	jxBYQFNuLh3RGRQKNsaAZTdHRPPv6mhAzi2452GR17VRpbkaftY	3716	5249	5249	1616884020000
7192	3NLQzbaAi6cfJ9728BF253nA9T4nQhwxJmsHUdU3oVt6LGAQAii2	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1670	1156	80	1	6301	jwA3npuizP1yGxySFddCQfdU8Njo4WZPo9n6eatR4eSKmiRGaQ6	3719	5254	5254	1616884920000
7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	1631	794	81	1	6301	jxTqDGwJcHky6poPZLBjRq6ircmN8XVo8MbsmmbZ1RSzsodeT88	3720	5256	5256	1616885280000
7200	3NKtF8DG1jgsromkCAb2m3RxK5HxGuw25CmyDf7U28EFp3UxK5gz	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1407	1395	81	1	6301	jxPpvv6TiUuH7tRcbAf8kAPHapvJfPDRQbLPw9rWQzKYUoJ1njk	3722	5259	5259	1616885820000
7202	3NKKAnBHrsxKd3QHmdQaiY2jEbSBD4jvu6PaB4iExHtabQ2Yric2	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1503	1031	81	1	6301	jwJBsxGLTHTBfZDvLsTDfiY8pUr8LHCX4BnGFaqxsR127hPkgqt	3723	5261	5261	1616886180000
7205	3NLBuunRVxpqoYdpnVUBakvCed73BepX1bAQYJeedVGYvYM11xuo	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1440	1131	81	1	6301	jxwP9DrRK1fDG2JSCFjddA3xpy3gmyhYK1GN2MDSGngeBPYUQNe	3723	5261	5261	1616886180000
7206	3NLRocEgtYUf2zS8shjwhAai8okUviPP7jBpoPUTU3w5XXavqUG3	7205	3NLBuunRVxpqoYdpnVUBakvCed73BepX1bAQYJeedVGYvYM11xuo	1407	1395	81	1	6301	jxDQmyUqigCfCTAJ6MToXjh43punA9D5V982zoaWkCqdNqf4zC9	3724	5262	5262	1616886360000
7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	7206	3NLRocEgtYUf2zS8shjwhAai8okUviPP7jBpoPUTU3w5XXavqUG3	1675	1342	81	1	6301	jxpwHQAPqQgk3fd3PCnUdaJqn5EetHz7ZFXa8riztKwbYyzzgvL	3725	5265	5265	1616886900000
7212	3NKmNTC4HiJ7MMSdo677PX96KXsTTRQDQ48U6aP5fBwi73MJrYYG	7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	1642	1121	81	1	6301	jxY8vvg2donTSMt7jGZBW4Wk6HLfbcQ3kgeJZ4rVMzsfkefNtiL	3728	5268	5268	1616887440000
7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	7213	3NLsfJmLRDr5XNqr18VnVCRVjbJZCATWh8fgt7AcvfSFQuquDkR1	58	1155	81	1	6301	jwHFVRm1TjqDiVe9Xa7PdS2khg6XDLDBvPZQcVJm5TYedQopyrg	3730	5270	5270	1616887800000
7215	3NKbNqRCSBGJWB19GJy6TnStNdBUWutKHhPUfWvVeaNAucMvPU8Y	7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	1649	1017	81	1	6301	jwHCXjFJiUyzCvzD3jxDc2FvzViqFCbKHBj7jieVStLk11GPcCz	3731	5273	5273	1616888340000
7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	1581	778	81	1	6301	jwkiF9X6T2Z3omJ4SpqxKis1sHnK8dc2zK7fhvqJqUjAh5EF6tQ	3732	5274	5274	1616888520000
7220	3NKxL8E8d2T1wKbBPweVekGFpqhZBuZ2whtiWjBaLMMzCGBcbHER	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1567	567	81	1	6301	jxayVkTdyzwm2dWmNnR5tF4TepyFx444BAiNfWkXN5eWD6FJp7V	3733	5275	5275	1616888700000
7224	3NL6zuRhQzVUyPT2xUFG8n7x9kWDsLYHwqvcA4HG6maGnh8mo2sg	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1593	1346	81	1	6301	jx3ymWBnXW2BuGAdkFRynpHFg7SFWHgReiExg7C1vV4L9yuXBHt	3734	5276	5276	1616888880000
7226	3NLPLbyht5aDpytSVgahFDNUCzrDAPe8w9VxMj3KBk9nMG7MPbiL	7225	3NLY4Es7atoVAToLnez7xUyC1zgq8Eubu53j33jr2YLnMiE9nQoD	1406	1393	81	1	6301	jwetptE33bS5jofFTFUyxHB3DniHT2dcpn3eK61h1zQPGpa9mjc	3735	5277	5277	1616889060000
7231	3NLC88ydWvkF74sbWZ8iG7chko6SpsqzmwqT1TA5SRg5nGgfJe5M	7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	1422	1337	81	1	6301	jx1NQbRvyTfpBNDrAURfNH6yGbh5hXuAPiTQ8nXStQgtGRvh9jw	3738	5281	5281	1616889780000
7233	3NLhqdCcubwaJ3UvnWGuxLyBawaJLzfdNZEpmBzXWC3pAjbzH3t6	7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	1406	1393	81	1	6301	jxb3qoDkiapfhsF32ScMTokjRj3H6HTaJqW33BAANX6Kd7meEiq	3739	5282	5282	1616889960000
7236	3NLJWEv8JK6q3rKA3Qk38aSYycm4LQ6mzmR46ZfsAf1YMqiSP3Rf	7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	1508	1387	81	1	6301	jxx3VFZkenp5YP5f1ZZwAvJhSYxKDcuD1rzuNATNwNeEGBicPnN	3740	5284	5284	1616890320000
7240	3NLtYLcH2BG1zppRWHbsR7V1TGH4vCou3QfW74pwY5khgNE6Vx9f	7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	1426	1118	81	1	6301	jxSujXKhft2dV5hpe9LLepsMYWnsq8KNpo3LYbd5r18t8xo4kcj	3742	5286	5286	1616890680000
7243	3NKyZrr3QpaHyX52dvqySVyYPGGNgJcLsYNNMQ33zhx1MkKYuPdW	7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	1407	1395	81	1	6301	jwjauwUiL2WmhrH69FbicdGommGu4MeHvYm3ZUamknoDWDyTG1c	3744	5290	5290	1616891400000
7246	3NLGze4bzyX7Ev6vKApGmkDQkT4rutQkqihHSUvoMQCTjkFNJ9Dy	7245	3NLi3kZzVjircojePqL19YHMiYP69wqQXtSX5PYQPwPYzDFvQKpA	1402	888	81	1	6301	jxCBb9BofS9e44eQoCPSMmSq6dPYky3LKMTfK6k8WjJaY5nemAQ	3746	5293	5293	1616891940000
7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	1476	1005	81	1	6301	jy1iCBYhBXPRS4Ag1RxKp4U77chWdg2Uzfed69EXJhyBbRgKrC2	3748	5296	5296	1616892480000
7254	3NL8S4Ef4BUEujzRzPh5Q4mjEiwEJKCpHyYN6qSXJgyNiHexmwF9	7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	1529	1316	81	1	6301	jwgMxiWDSrNEoHu3zRGyjvmsYA4Nx5A6LP3i4TsSW5gNsgdmTMx	3751	5299	5299	1616893020000
7256	3NK3GRnjVvjvtCeCKoB3ti96jfGqKK5x71dKjQbnCknp1XJQTbfd	7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	1403	812	81	1	6301	jxBqhucC1sd2BKf2SHhioEVtKjYfykU1w8u2DMAnQ6V468Kztqu	3753	5301	5301	1616893380000
7258	3NL66uHLjcxpVwopNFinbqHbYRgoejS7q9fAvbvfjGCSwnbP3UsQ	7256	3NK3GRnjVvjvtCeCKoB3ti96jfGqKK5x71dKjQbnCknp1XJQTbfd	1627	1259	81	1	6301	jwvGVp4eo6fjGK8LwSBBQHNPUVjqv4xoE1MuskEDTRXya5m5z3V	3754	5302	5302	1616893560000
7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	7259	3NKX4grV9F8518duQ7FoeGdDsrF1hDXcX8emxydLhqa389XSkc5n	1402	854	81	1	6301	jwJgynKJFa2185bk8qYyvjdZoMjevM5ndknEJcGSCeMHYUASc91	3756	5306	5306	1616894280000
7270	3NLgQjtag6vTdVJPsHrheDQzgQFMoy8LsdoDhnXmA1qPwEPzUdbM	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1407	1395	82	1	6301	jxVQzi87LxhfNpnureFe7PEXDWgpUnknvR8hDyY2uvTmc9LxNGw	3758	5308	5308	1616894640000
7273	3NLebos3er8dhcu2wR9UqPp6bsiTeRTNFse1kibw2xnTFADFzF3r	7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	1555	1101	82	1	6301	jxQ9EYmdVPSEGsCNBzk6XiMGrEWJv7PYeBiULG89VkcQozwmYbD	3760	5311	5311	1616895180000
7275	3NL5bPr2R7Qg8GBVDbZBf3aGDAoC655oBheXAqkxiu2HwUbSgBgh	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	152	1084	82	1	6301	jwztCSBYr9h1v8zosaQjqBCNRP7STpdCG7sGQwhR1ooo6BMwdbG	3762	5314	5314	1616895720000
7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1578	1050	82	1	6301	jwL9TLbd9KbR6M9A3Awx5xK7jVDqHPSUXWraRdK3gwxgRKWjfQE	3762	5314	5314	1616895720000
7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	7283	3NKta2dhe6Tj3MYctv23BzaT94ZMWB9ntUGY9Ec34SfeA6tmgBwp	1406	1393	82	1	6301	jwjN227raKoTUMaT3o7RbfqHbF4zNzrGp2BMzpYj5VmYLSkEqQB	3765	5318	5318	1616896440000
7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	1656	580	82	1	6301	jwFGwgyck9j4L9YiiQp5PyZ1j2UsLp9J2suyM6SfVWcNknBpy6Z	3767	5321	5321	1616896980000
7289	3NLW4Ahbb4C3gTNo752ZkMK9Jom29kGC9TgKee9qmbipAUJGkWNn	7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	1403	824	82	1	6301	jxBMUQ3xuUaLCRNYzH81Z2SBDcCLQ3EghtMVtt2gfspjA1Vxu2b	3768	5322	5322	1616897160000
7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	1422	1091	82	1	6301	jwZQMNLbnCpPrTJJbJ6bXpSxAEEspXhc7qeGqNYts9bybZ8YM6h	3769	5323	5323	1616897340000
7295	3NKdFR4hQZfWA8nLELdpFvbsKHXfYKQfYkTRvPqAxpXQr29XTD4o	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1513	1133	82	1	6301	jwTc6cGXVhEs7dLUGmrsaYyngK11gAdzKfFcSnFAA6h2Tepws7j	3770	5325	5325	1616897700000
7299	3NL1DjKSskUdJdMQN9YiEF9kKx3bWJoRpzqftrFDHkFDoK1Sz3JP	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1594	1326	82	1	6301	jxEfB7GkaAEZCWFCBgjXZbnLginMtmNargXGub4mCNCNRZpMJhN	3771	5328	5328	1616898240000
7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	7298	3NKsU2UfzxtWAzj2akTqt3Ji1JhwLsYAF9SMxmJnCRsPzRYDSbAx	1457	1145	82	1	6301	jxYYkxgFHf8SGFSjNCFxL2Een2efbLUs2AjgnDNrR1zPzGMdgsu	3772	5329	5329	1616898420000
7302	3NKf4gwW5vwgjVLQYd2suvYXweppKmxMRSRGhXyrLsm7ZnkiN1iX	7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	1542	1304	82	1	6301	jwiVFps9gcpnYqh9MuzuBpU8Cfr9yoKWVJsD6JaCdqtYCJj8P5o	3773	5334	5334	1616899320000
7307	3NLRzooQAHX5a5N6V5uZ5rP9J4L8qxCtZXVbmwBKomzXPnHE3HnZ	7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	1406	1393	82	1	6301	jwtdVfAPJ5bvttQTGLo7LE72YaVG7nNWqCsESncpXqyy6XgSo7p	3775	5336	5336	1616899680000
7311	3NLAHJYqEaR5fXLTDXphQycTT9regMD2LQBDBzRqFcZ8hWKdF5YF	7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	1651	1175	82	1	6301	jxzbNPuB3Fj3hsbo6Y6KM16S4YdfgYNPNijizMu47S1v4tVg4Lo	3778	5343	5343	1616900940000
7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	1506	1373	82	1	6301	jxib4LXbi5VjsiiH4vzgyLi1Y6ae7oaTKE5VZcM7h4QCHTRFgn1	3779	5344	5344	1616901120000
7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	1467	1010	82	1	6301	jwbGqz6eci6MADoBm85vL2Ntz5FRBuNwiBYbmkRVN81yv7TK8UQ	3781	5347	5347	1616901660000
7324	3NLanDUq1B1NNPBTadv8Nt7Wx5hQm5xXTmAg5DWdYVRZeG6JJPq2	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1407	1395	82	1	6301	jxrBKStSWeuAN15ffsmq96qXNycWALkJVYEYpUBgKL884MsycMw	3785	5353	5353	1616902740000
7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	7322	3NLX8KDpZqtGnoyZrLAKiMtU2qTPPovCmjju55E2QyrDxBSfpVMG	1581	778	82	1	6301	jxBPE9hnmYx8ATWfErvvCYnnjbUhrH9RTurmJsuQ2n8SVMBGdqb	3786	5354	5354	1616902920000
7332	3NKUhDVBkk6fkj8NayrtTJUZioKejkduuZ4eyVWf5C51QDbzgicC	7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	1637	816	82	1	6301	jx2W3DQHFBJeDsoakANgBHAsXW7FjrZASCZ1kt21nctbAgy9nKo	3789	5357	5357	1616903460000
7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	7332	3NKUhDVBkk6fkj8NayrtTJUZioKejkduuZ4eyVWf5C51QDbzgicC	1503	1277	82	1	6301	jxDBT62LSTGhrk2oJTKWMVSy8F3mZUBdcwcak9WExiuyK3Ps74c	3790	5358	5358	1616903640000
7340	3NKL9kQfnQwif4cHRguHzoXVyTZqrLSoUWggrs6vcRMXu1uJrudS	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	641	1336	80	1	6301	jwLWCGmcyrswwDimoXhK7ghGwKCvuCNUsVAnSWQYUwrnDonzdvj	3700	5363	5363	1616904540000
7342	3NKHrtbDhZsCEoDFwxtsuR2w5oWWi2f9aP9vSmodNgdoJpmE2WPm	7339	3NKszrWR2oCP3p5d6eo7WZpc1nSdWT2oCaZMWzQmnBU1Engq8EeY	1406	1393	83	1	6301	jxyusaphgE61P6Mw496JUNVJiGeDiF4LsTbWM2UjwkraeW8zvbr	3794	5366	5366	1616905080000
7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	1631	794	83	1	6301	jxKUkUA395u4EMk5KDPwzxgv8AoVFp6TuGeamLgBmh7MaezmNiA	3796	5368	5368	1616905440000
7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1481	790	83	1	6301	jws16WTankM3Li3wdujZrmgasHqTwWcAVpu2FrggfUkrrY7eU8Y	3799	5371	5371	1616905980000
7358	3NK4nioh4fh7gP93DxH9BLxioJf8z489izPj8o52fm9w5XUCJ4rQ	7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	1481	790	83	1	6301	jxfEBrJEMmJ8YvX7gpx1rEQ2otjHeMRDwJjz2caAsBXKwcg8E8C	3802	5375	5375	1616906700000
7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1536	1313	83	1	6301	jwaaQ7NgJTQjyxZfqXvqZ38rQs3NKq8ZsYTL6EHbxiVXjvG21hM	3803	5376	5376	1616906880000
7362	3NKMDR4PdfmJEQwQHdjxgui4edWq6MRt2Z1wguLSuyHou8yfuXTQ	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	298	942	83	1	6301	jwgcCu6FPxckCbM5XyuaPQLp6sYA8UrmcMZSVMUnVTGno7AYAWS	3804	5377	5377	1616907060000
7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1559	1227	83	1	6301	jwpCGsL8GNfbA9NGSNJY1UipKwkCM2ApYAUifzaZ2dFHd9Wc626	3804	5377	5377	1616907060000
7366	3NLGuTv6PXLSBAY9aHEKjs8ub396AfHHu5MF8ELf1R8zPPz4hb9K	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1451	1046	83	1	6301	jw8RhTBTRyfxWp9oGEHqZigSmmBoaqjfmia9LcSirQS8en3FGP9	3805	5378	5378	1616907240000
7264	3NK5nnmEfdC6HineGXcbEwh6KNScPFvAMYwyGxE4WtqzAkLXFdiH	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000
7266	3NLm1M4V8u7X1LKdBfT9ZvAVWWP7L8Rpcwv6KvfvypCBuekK5Nih	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1600	1372	82	1	6301	jwus4ULKhCXuq5eydu1ojKrHQxzSQgeQ3bMmF8Vjeaj4pP2zdAz	3757	5307	5307	1616894460000
7272	3NLQAKXyJD8gZb7KzyCuACM1PY8RJ7AjdXZz2HocB6j4qftr5ErT	7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	1407	1395	82	1	6301	jxN6fYdrtZZ3yxw9EyGSbc1syAd3azPGiuo1ga9YyJTSioXmDPQ	3760	5311	5311	1616895180000
7279	3NLefJAXZSdmsD8FfjQiRZ9pe5ti4zHCXj5kLCvL3ENSQkbErfcr	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1500	1297	82	1	6301	jwUFhkaiwFu73M93KnwV9UHoHr6sFemqtn48MGRVvdbPEtaSQ3U	3758	5315	5315	1616895900000
7291	3NKVFVGX2oV1Lnexxd75fnCw1PS2czGfXScGZTcwkC4NFG8yyXsA	7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	1668	1124	82	1	6301	jwMMUxUk2BiW6hAt8bLu6CbZGRAjKwUS8BKT9T2Ji9NVLcrnjqd	3769	5323	5323	1616897340000
7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1406	1393	82	1	6301	jwBrX6v2E4AV6nF3HqnPQFTQKD9jEgcdfjc5jFRVXvR8DYMpFXC	3770	5325	5325	1616897700000
7296	3NKCa42bCaCGeoxSs86MUhWqHCDgK5shnHBjgnE2hiEg82JzTLoy	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	55	278	77	1	6301	jwjBg9H4piX6DeB2apHk9viDgKVmvcxBui438id5ADCxTWY6kRg	3614	5327	5327	1616898060000
7298	3NKsU2UfzxtWAzj2akTqt3Ji1JhwLsYAF9SMxmJnCRsPzRYDSbAx	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1516	1294	82	1	6301	jwThwih8gKQLcg6PpJYhcUCMue3rbFAmoNohbVBPUfR1G6gVnjq	3771	5328	5328	1616898240000
7304	3NLXzFaA12Cnr5nWwznA5uWMA2xz9stMeX54UzR92DVgph8hVHYG	7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	1406	1393	82	1	6301	jxznidkzGDs2aTvRYYCS432CygbpqDg6jqfNDCgSf4mhqp5KAhL	3774	5335	5335	1616899500000
7306	3NK5xTTQqfeaXTagMcniLuSvg25L16khDNs5ff7G8RWmxEwi2JQb	7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	1451	1292	82	1	6301	jwNHPA6TFBmwo8uh8qf7L48t4NAxUwne6G8x2RfGB5hdg9Zhcej	3775	5336	5336	1616899680000
7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	7308	3NKUDie7xSndzsUqbKKmCJhkXGmVkFkm6JyBMvNYWrXoCycjSWB7	1397	838	82	1	6301	jwWjiecfWTKdbsmBAzU8QR2WPdo8PuQVGxSoNbQSPgmqhWy7XGd	3777	5340	5340	1616900400000
7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	700	840	82	1	6301	jwS9FuQKzttty5BpgE94atiZzCp6hh9QHTu6hJ97KAEYkNgTZVe	3778	5343	5343	1616900940000
7312	3NLoaPPse9yHRG2pdh1XRCmWyM3QkMBvFB5TSW5t25YMCoyEfzqs	7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	1542	938	82	1	6301	jx9mf7u8xKZ8FiwiM8N1R5C3V659ZHc6ktWw1kXR4FNitECBkFK	3779	5344	5344	1616901120000
7315	3NKoxnp6cJdqLpNXeiQAUT8XzUZ1tYSy6kHPxjwLdiQyk6GpcEA3	7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	1444	1255	82	1	6301	jwaGt3qon7LfLTYW8yBoxs7Ss52BGgzTWR4h4YhqSGPqb9zWxGf	3781	5347	5347	1616901660000
7318	3NLNAAuCQMpyyuy3z5nVtk1KnEtj6jt8UsUN4r7zRisbLezHXHog	7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	1647	1056	82	1	6301	jxK2EYqT56H9QejL96WfMCUxtM9dkBfsdzerUT5MCCmczDvHfG8	3782	5350	5350	1616902200000
7323	3NLxDUJ5D1BmzSp1RUM5z6fx6BxjWtD5Gq5CCsGF1rLuhzgY4rKF	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1508	1141	82	1	6301	jwyAnYFj5WcmHRWE9BRWbetJV4pvcxgQmLKs9q1dLVNCXmw68mV	3785	5353	5353	1616902740000
7330	3NL23SS3EYNWyj93W31AiGpzwgP8BUgkCBX6h1BHYxFg9Nx5oKPN	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1647	1056	82	1	6301	jwKSqWemB25s8eAaxwqzccgF9ZKyueEtoQYUtLXYgKqkLW3oZNd	3788	5356	5356	1616903280000
7331	3NLWyL4MUcPJEdiacHbsFuW12MkktxqJ8biCdPSWMgW1AU1HC25p	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1647	1056	82	1	6301	jws1ou2Dywd3v3xvum9J8Wp2fL6DWs92BnViFhy3EAzniyraEUQ	3788	5356	5356	1616903280000
7337	3NKHraVRpo3DKR3DRRH5eANt8reJYbFBvbEXnADXFh4GJkCB6R6N	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1407	1395	82	1	6301	jwqXJUoRUsSc2tL4NnHDc4uRhzwdujr9HrmxzsLUrEn8ZBxAbAr	3791	5359	5359	1616903820000
7339	3NKszrWR2oCP3p5d6eo7WZpc1nSdWT2oCaZMWzQmnBU1Engq8EeY	7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	1560	1291	83	1	6301	jx4uxwAHatHqUJtaBEPoMuG8qwCjHTzUrdhMQppwJNRaqdojgTj	3793	5363	5363	1616904540000
7341	3NKB7XBfRvaCSVru7xcXHLkgmFxjBeEYFsm7WTrUZGbVAjHHo7ot	7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	641	1336	80	1	6301	jxjcQjyYwjMQaEaBJCUd3cJ7XvaWRCtxhu7KDEFkpcohzUyyaYn	3695	5363	5363	1616904540000
7344	3NKT6u9ribsEQafSicDxGAtp8YdENp5TRFaTQWJs8LVFQYumcMYm	7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	1447	524	83	1	6301	jwvhX6XwkW6KbntXWoMTCAdAhkZ9ALLSUTa7CpK2PguJbQ4Dkaz	3796	5368	5368	1616905440000
7347	3NLnmjBe1QNzs82g8UUJNT1L7gjQYjxstc3PAs7WMt6qLtLrQwym	7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	1457	1391	83	1	6301	jwvLBgDSa8yQQfnEBkc1yBTZS9auZbMtdP3AUdnHFe1XM5mSfRW	3797	5369	5369	1616905620000
7349	3NKpC6MMo8Rdi4op16eFwhNq7LwFXhkWqvSMenRM6gpqgTMynRse	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1500	1171	83	1	6301	jxzh18vamUJTSTWRhpkpSQbbeJkVcTUGU5wA9wXPvUTxjHSYc1m	3799	5371	5371	1616905980000
7354	3NKg2FnBnjtKzydQhn4vajVDiE96S4433ZanSJc3Qvw3RptQ5AgX	7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	1426	1364	82	1	6301	jwjZ4gDsz9WfzTAukzeJM2RnV5jpvqefa4mYBx3v3xmMRZrfKvM	3780	5372	5372	1616906160000
7356	3NLGmrQHZQB2Btn6ZdquZ68pKVVb1R7cfiDPEqXX3xnzpoYZhmC9	7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	58	915	83	1	6301	jxPPxzNk1Lxy1Qn1cCKqU2JmQrxumorq7mJ9y53FHCSrWZTguJW	3801	5373	5373	1616906340000
7364	3NLVEeh7bzGevace3yk7BYA2LXcuZw4VtTZBAFbTz2P4XPwnp3bY	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1647	1302	83	1	6301	jwRFZwWmYhfk5bg9MXXx62EhhTxtvYW1TSyLuXUjzMFPArRowsz	3804	5377	5377	1616907060000
7372	3NLMJV12Ny88ejNeETwZrWcq8eK42Xsi1zeyKHXnFpvbvc7VySWo	7371	3NLXmo8cSieWeETkYtdrdc9jpZTQ5DEx78ReqgCwQ5XCe1r7E6Uf	58	1281	84	1	6301	jwTXJEyu2Vxk1Au3j2HdWuAjF1A8kSoJK1DiMEfvHe5m3RiCN82	3807	5382	5382	1616907960000
7375	3NKpHGDQoN4e75mGcum7TubPZiudQi2TUJj36gxAA2To3tpVj5Zk	7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	58	1035	84	1	6301	jwYwo93JZkhxidut5aCgs15ZTjpzHteK5hHqSS6qATgaVtKorbg	3808	5383	5383	1616908140000
7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	7380	3NLWihzf4gS3LgzrLL2VjxxfrtKEA6beArgcuHzezJCm3LimZJtc	1637	816	84	1	6301	jwydc69ApGPkH7TM1wopbenqjfHHrtdFkiKGgQFCshEkjjXZMHg	3811	5386	5386	1616908680000
7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	7387	3NLppw9FDAkh41x9DypGsKSiV8RKJnwYZt7z89ZyougYnVmx9rpj	1578	556	84	1	6301	jy3Gq2ajkLfbm8PNC1cA2LeZseiQ5wb35kxHzi7RH1xcSDvFNww	3816	5394	5394	1616910120000
7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	7392	3NKCtCmntVqqYikLjgiYL2rJYaBr9sWZcudrWydoF1LZbV9ru9Ak	1407	1395	84	1	6301	jws3E8UgYk6ZtbKVxWZVLV4CBG4jdJxD8qHdbf1zLZbdyjvtm52	3819	5397	5397	1616910660000
7265	3NKbdae5LxQ8XsoAqxZYrrpojsMf9eiWMKhBx9nsBRFcF59dQJ7z	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1407	1395	82	1	6301	jwPjoygPkNo8kcmUgKvkCmtxXsSR5u6h9jB98haw6F2k9AzWLJ6	3757	5307	5307	1616894460000
7267	3NKF6qxs5dJHQY4hvEMhSPY42GLZPnytMK4muLPAoTMbSQmHdyho	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000
7268	3NLr4Rj1BiohJohWA5UafFfQhJk17Bx9VE617mkbNBXQN6Bx3mzp	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1467	1010	82	1	6301	jy215CiAMMWhN4cnx5CMceQr8Zae3HKF2pRZEoB4dE962bBEMK2	3758	5308	5308	1616894640000
7276	3NKCxzZRqSESTgwgwLGriouiqnWyAUwsrjRM5FNz9mwaYH7aaf5W	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1406	1393	82	1	6301	jxwYGhRS8FmatVspLmnRPzP7sqdkrANRWx2FYiqxgfo2fEmWtN8	3762	5314	5314	1616895720000
7280	3NKqRjAEq95sbHaJFzCKCqdkem4dgXFs4s2GJZiotfUX84rq21FY	7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	700	832	82	1	6301	jwMdHzTYcvHy5jiEeqNoaAiwmLvLUi4k5TvSjp6w93ZXvPchJtq	3763	5315	5315	1616895900000
7282	3NKWT724RXu3yBXDTmuQ5NbbjZc8JBKwDEKhJKmYYha8s8hSRy41	7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	311	941	82	1	6301	jxeuGnLpprrjQVbeVUrGp4GeHp4EaCRhN6ZtJyMAoKMavxFf58k	3764	5316	5316	1616896080000
7285	3NKJ3nGjwumEw17P3rVL9cYRxaV5h2e9q237XcgQnSsY2yNMgygj	7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	1407	1395	82	1	6301	jxSiSNfbz9xhNZ2XqqAK3sgJ7WZKKC3fdW1xALTtmM1CxjaFZR5	3766	5319	5319	1616896620000
7288	3NLcVTkAL4RbPF5YGgNn4nKJ9duBQVzgjWDXZHbuUKoSbgaSyMwj	7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	1637	816	82	1	6301	jxcXSHQVKcq2xvSwVJqAdu4MAA9iByGDq7iwCiKe95pzWfgFp9f	3767	5321	5321	1616896980000
7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	1634	1331	82	1	6301	jwVQNjMAZcMpmAPRVK5srWJvufcaotxChhZFWMNGgZcy84yF5uG	3768	5322	5322	1616897160000
7297	3NKKWjMpi514N7cXd2WGCmsrjqRbCnL2117LwRpyXqKr9mfUodgB	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	55	278	77	1	6301	jxi8YFfCWj8zTUQF1RvxoBtnWijnKL2ag5EfJP9WsM5mGGsagfy	3632	5327	5327	1616898115781
7300	3NKSTmCU4SUyqkQssUqQ4yUa7hSqiQaq4LWAX1H93sHgtHWv6iSh	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1594	1326	82	1	6301	jwmH8Zz4omNA25iE3QKQUz6E6KWrAEj3b8aj3Jp3ikESYGcCiMD	3771	5328	5328	1616898240000
7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	1623	839	82	1	6301	jxNmvnY2WjR22T88tbZwAk5WavHsXETMHuuReVvbn9BJ7PmSzog	3773	5334	5334	1616899320000
7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	1631	794	82	1	6301	jy3BynzYRueazgTVEt9Gar1xsFvCPg4wss3R622zhJPJYfeu6o9	3774	5335	5335	1616899500000
7319	3NL2kTHWyZ7D8BAbuxKjPwDs6ZdGTSKkwB5nSf4gKGfKQvUbYpzN	7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	1474	1203	82	1	6301	jxzVdYDthTSE4wUdcvWMMiowUgyymma6jCpghcGuU7uCPZncprS	3783	5351	5351	1616902380000
7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	7319	3NL2kTHWyZ7D8BAbuxKjPwDs6ZdGTSKkwB5nSf4gKGfKQvUbYpzN	1402	850	82	1	6301	jxd5couwakHLWffbfeSpgetcsbz9aKitMhPujbt64zqnqyadL6x	3784	5352	5352	1616902560000
7326	3NL28NM7MLEdbEdeD87DprRFuGuAY5Zqmv5EYHqqLg6gAYB2HKCs	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1407	1395	82	1	6301	jxQSZBUx2WEwoZ9gfNeSA3y8GymKmawMeWd15siGXvuw8JXoQhM	3787	5355	5355	1616903100000
7328	3NLFUfPoUiJrJuYo9LjB15MAD9mbRBT41YkGHBDmzhNr2BFYxJkb	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1657	1218	82	1	6301	jwkep6rHK1h8vxb5NUbwagbkfQbAnEdThvyZ55AcsM9eEaj7aHS	3788	5356	5356	1616903280000
7333	3NKdiLNwNP3kemEUfpzTem1PsS3FUNqfanuLbE4D5m8bYu7r3FSB	7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	1553	776	82	1	6301	jwpM5vtF52eSgSCaiGtgWebnwY8MVU3a358YBx6oCghGKEsi5XZ	3789	5357	5357	1616903460000
7335	3NLaFgBUR1LM1CcdS4anoEisHVxjGMb56hGjHC67V1XxG5tNv3EX	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1671	1239	82	1	6301	jxdfWtxMbSTtfBP4KKpMk5bfuiJV4VgUCBjtVMVX7jXDCCHm72k	3791	5359	5359	1616903820000
7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	7342	3NKHrtbDhZsCEoDFwxtsuR2w5oWWi2f9aP9vSmodNgdoJpmE2WPm	1483	500	83	1	6301	jwRxa4S5U1RB8swyxEc1prmV6CNEtCSB65F4JNgkvg5mLJzaz9J	3795	5367	5367	1616905260000
7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	1426	1364	83	1	6301	jxqpDKr1kF7QRY8ZWtVbchvZBaMHPeAMRrNJT5eJHUnQpQrcra1	3800	5372	5372	1616906160000
7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	1627	1019	83	1	6301	jwpL1BmdAvxUopdb3FZdnLdmYnQtswqQHyWcnJj1Nhnw2nQaRGA	3802	5375	5375	1616906700000
7359	3NKJ5LmX5USkuQz5bcPn68zsqgafuXnPHxrbHNW21HJKN8gRqNLJ	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1460	1078	83	1	6301	jxPUhcfnTQGnCT6hgXmsrrs4d7GbUgxqnKNozKMGPdL3Syj3moc	3803	5376	5376	1616906880000
7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1573	1318	83	1	6301	jxtGxy33RZ28EYefZmkNqQsHvSt3JMNRuFBA77jU3BXavm6g4vr	3805	5378	5378	1616907240000
7370	3NKsukjYeuidr6TDRp19P5BLY1ebZHKzFf6BHVmhJjAYgFbXmwyk	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	606	1049	83	1	6301	jwJasVU6fUMgXzwFckFmCvPRYeBkphUN8tGeTk2TecuNvXn28mc	3806	5379	5379	1616907420000
7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	7370	3NKsukjYeuidr6TDRp19P5BLY1ebZHKzFf6BHVmhJjAYgFbXmwyk	58	1281	84	1	6301	jwy33AmuD35F1SwkkcspBPzYmam73Lvg9KbmArQFC7zQmZNqTU8	3807	5382	5382	1616907960000
7376	3NLrKtDq7GFcpMLuQKyphQ5YnkFrY9miaSCosVh6jiqrhHuwQ4Ek	7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	1536	260	84	1	6301	jxyiBT15DVV8DSL5AvtwtYpdMS5678UWpdjrZbwRJNjfg4xxQnf	3808	5383	5383	1616908140000
7377	3NLqqAT2Cyb1HWV743wzkMkBvT4NFDQ3bj4G3NBSvoXE7wyqg9ZC	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	1657	978	84	1	6301	jwycaqWX3qaW6Va51HCkpAyVDUZwTWWBABKfa6nvDL7ygc8mAWD	3809	5384	5384	1616908320000
7382	3NKthNXpahpm4ie1v4iaZAGopyG7q7z3xQX3jU7pDPU8YNAnPqWn	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jxUkqDNujdRkkdeRbn49BacmeC7CFg28i5xKa52JB3eHNJiWxJQ	3812	5387	5387	1616908860000
7387	3NLppw9FDAkh41x9DypGsKSiV8RKJnwYZt7z89ZyougYnVmx9rpj	7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	1406	1393	84	1	6301	jxq51Dfp1Yq6or31EJgqirwkbVDQbcMWyJVKxKmZ7SzdU9QDzNC	3815	5392	5392	1616909760000
7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	1607	1102	84	1	6301	jxzVwxQmkuJ5qHiuhmF2h3Rh1MTjv65zNc3tBqZH8bqAemHYDjk	3817	5395	5395	1616910300000
7392	3NKCtCmntVqqYikLjgiYL2rJYaBr9sWZcudrWydoF1LZbV9ru9Ak	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1646	1228	84	1	6301	jwJpwKMHp82VGUD1NUnW929sdrxZs2NfSvcDLQveuqbh6Y8xEdB	3818	5396	5396	1616910480000
7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	1500	1297	82	1	6301	jxm97VPdQ3JLwn4rHhYAhS5aNvQmDdjEQFvyhd1wCREEm6GQDCW	3763	5315	5315	1616895900000
7283	3NKta2dhe6Tj3MYctv23BzaT94ZMWB9ntUGY9Ec34SfeA6tmgBwp	7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	1405	865	82	1	6301	jwmnVDtbaemzLveQyYhkd9BmW43xoepA7pd9fbJvHMwjD5Aq1Pe	3764	5316	5316	1616896080000
7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	42	1361	82	1	6301	jxPgtJg8u1ebMr9kTxU9Z8UpdDNtrqxQSSaBmwQcFv7AYcceXh1	3766	5319	5319	1616896620000
7293	3NLmLnfHBULDQfp71Cvsa7XNRBEpfR73scg7ay24h83RxPM7hYDo	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1675	1342	82	1	6301	jxr1nx5TGunEtHUYuUjU52Go94XUKFQg7Gqz5uKnZ1ctt5vRKoZ	3770	5325	5325	1616897700000
7308	3NKUDie7xSndzsUqbKKmCJhkXGmVkFkm6JyBMvNYWrXoCycjSWB7	7307	3NLRzooQAHX5a5N6V5uZ5rP9J4L8qxCtZXVbmwBKomzXPnHE3HnZ	1534	1191	82	1	6301	jx591v1U9awa8iNzfau1h3ospAVkxZf6w4kote4o3vpZ4kwGnEV	3776	5337	5337	1616899860000
7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	700	832	82	1	6301	jxTaR4VbgsyVZKkXxjX6gizuM7RMftsDnJ5wNa8hTV2vtrU41uX	3780	5345	5345	1616901300000
7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	1405	851	82	1	6301	jxYNGR7oyKfixwSTPp7XGkQ2xnFnePYt6hZ7HvMU1AqjxPkyWcU	3782	5350	5350	1616902200000
7320	3NKxr4zN3B67qSyFEwnNjaTm5uVtp19wHNWNW5LX691JdWKEMLKu	7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	1407	1395	82	1	6301	jxEzvVxVLCk4Fj6PNbQnCSM5dckTnHFcN47ad4vov8ZeCWqbSeR	3783	5351	5351	1616902380000
7322	3NLX8KDpZqtGnoyZrLAKiMtU2qTPPovCmjju55E2QyrDxBSfpVMG	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1559	1227	82	1	6301	jxVRFHk2ts5xiZDUnb365MrPnJJBWwwTED85aFLaCmJfr1eEGW8	3785	5353	5353	1616902740000
7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1611	1215	82	1	6301	jwAbZjXD5XqQWv7uN9TSdQDytz6uR6riBgazZstEMiE4243GunF	3787	5355	5355	1616903100000
7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1675	1342	82	1	6301	jwivPfbBKB7izszALAKo46acXAxAU9qJddLJJvbMJUcaRuW3zy8	3788	5356	5356	1616903280000
7336	3NLdqpV96dbCspKEnTn2RiTiFY1E3XRA6nYZ6Uo3kP7ZgGBrKG3v	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1405	873	82	1	6301	jwiPHHVxzAnPuMhPhArdUh6PHbUtPQtjppcU6qXn4kBa1WHPYaT	3791	5359	5359	1616903820000
7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	7336	3NLdqpV96dbCspKEnTn2RiTiFY1E3XRA6nYZ6Uo3kP7ZgGBrKG3v	1406	1393	82	1	6301	jxVX2Hq55QSqUSNMCdckxD9K9T8pUePeJsY3pNQq8LjejABHXfF	3792	5362	5362	1616904360000
7346	3NLZfdsc3xP2quhmfvaCVCvbaPyPsJS895HitRFBacy576jVB7q7	7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	1672	1039	83	1	6301	jwPoZzXSYpukWFq4aqvnA9hshSTvRcangG6LvXUzdxH1YjbEM2D	3797	5369	5369	1616905620000
7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	7346	3NLZfdsc3xP2quhmfvaCVCvbaPyPsJS895HitRFBacy576jVB7q7	1534	371	83	1	6301	jx4jj9x3VKyATh7nLGX2o4dtsqVnStzDmQ58byAdt26MwushTRA	3798	5370	5370	1616905800000
7351	3NLbroFWPVRyt8BGd9TLNM7f2JZen1FhQEZjEqT2Kcui7nzrXYEi	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1577	1081	83	1	6301	jwGcHEBXi5MXGXwUu2CH9X3XGmxrcoUqvmAGU517sdtom4rCF77	3799	5371	5371	1616905980000
7353	3NLdXhqB2z4pk5czxVKVBY5wcNNC5UNCASJTifYjxMCDJVqUVDEt	7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	1642	1121	83	1	6301	jwX41vPxFR8hn3ZBE5qv4NLVcyQ3sguyKvB6CFkMYSJPnBB4nUQ	3800	5372	5372	1616906160000
7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	1402	902	83	1	6301	jwa6mAGvr6joCv6svvzxZPq38Qn1SN5RhH7HiXML5LoWRuEwv42	3801	5373	5373	1616906340000
7361	3NLZ2YMMbfZ877BNyZ4YuTeXc9Ni9d4a1uabGicNkdhYyDn1nNzF	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1642	1001	83	1	6301	jwawRRgfrGA5WBMj1y5tghcJcvM2qvLHkrrskKNf3kmzEAPKfWh	3803	5376	5376	1616906880000
7363	3NL4sf1hyXW41R1WnRu1tF5wMN1ie8rBRtLYFwrhMLQV4aV5oCBt	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1406	1393	83	1	6301	jwNRfqcJc1vbx2YWtMQBJZAA8qgqj1tdUSVrwFruvuHctiseW6Q	3804	5377	5377	1616907060000
7367	3NLJr217Jvi77ArbHHAfAsBTjuLEEKMwyzmyPQu6aYS7MjHG53TP	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1405	851	83	1	6301	jxuzQnoiXu8vQrhrL2qXTzsbP8TBF599uAZgBRmvfDX7xKcZthU	3805	5378	5378	1616907240000
7369	3NKHFdHymtdDD9eaqPyevGfmHmywmvEZmJZ4oYEJNu8sMaKGD7Dv	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	1406	1393	83	1	6301	jxi3GDrsKH7aJf3NMsGhCo9GTrBdZnkVf1yauizvZznADzDVQfn	3806	5379	5379	1616907420000
7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	7372	3NLMJV12Ny88ejNeETwZrWcq8eK42Xsi1zeyKHXnFpvbvc7VySWo	1536	260	84	1	6301	jxDVYYFYtP8BGP1V9QMwfzkPaFgPwB3YpJH9Nu49mhxxf2zPvdV	3808	5383	5383	1616908140000
7379	3NKEWtWoZkmThcv22korFjKYBHme8bAdgp3yKonhZgufXxxsqhhs	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	606	929	84	1	6301	jwmWk1rALkf1cPu2R8KfWXkUKJ2cFuad3ifgPmBrwXDAcib6hFE	3809	5384	5384	1616908320000
7384	3NKVPrHjhLBfeHbryeg8c4rmjrhUN8EdQDsFHqMKWnfLeTCsXQjJ	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jwWWGvFkvhhhrX9taGNANcFqLXEPTuRgDsqDFHydC5WumF5DtoP	3812	5387	5387	1616908860000
7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	7385	3NKZwrAJ2kAfsTLas7FmmiXgXd3oqahVLJaynd51Aty4UtLYbfpw	1619	909	84	1	6301	jxaTBy5THhnjZQNpZH6nr2TGqhthaLjGpadre4njfiqqv2yUsYq	3814	5391	5391	1616909580000
7400	3NLes8Zw36MM5AvQNtpcSZ5nBrDMjw1KndMNra9ueT7ukW2C4t1M	7399	3NLJnYm5NPjYNfMvuDhYHkgZoJNLiiNNNfwpviTwsXDuAxJYYhWr	1588	1146	84	1	6301	jwH6NX6da3jintZGuQ515Z7GQriuSpxZNPUdVMRUhomWq8VnGvF	3823	5407	5407	1616912460000
7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	1560	1291	84	1	6301	jxgpdhFCn57BbnRzE94hKv7xwK2moE7jckKZ4FxojacqZPDj4LQ	3825	5410	5410	1616913000000
7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	7407	3NKZJMytD1HBpHofqL47BqfqcDsAMsx97kXBmmBGEZAyhbi1xyib	1407	1395	84	1	6301	jxZC71ww34ysXWoWXNSePyi77mVLyhjL1TsEq5R5BYtSznPRJ8X	3829	5415	5415	1616913900000
7416	3NK4qC925ztdFGZqYzv5w8oRMVowxgLFjYk6igDmW2EMFvWFQMND	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxNLyHWd1JKo7W87newH787oVh7K2q9eSPfqh69XC8QGnw7qiXJ	3832	5419	5419	1616914620000
7422	3NKRe5JKSQVxZDALtr65SmmXCw4p5h8mBYRzJrdyjhaTJ1UmGshD	7421	3NKtBm2QwFti1WEY71opoSdDH2b7eJ2D6MP7PDUPNW5eCQV8pYG4	1406	1393	85	1	6301	jw6gwwWzgFSgjVms6gGxFgxhrjiR4mBSTDXGraXbANMofs4TqCm	3835	5423	5423	1616915340000
7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	1594	1326	85	1	6301	jxkKJ3jiw9aPmhaWas1HgdTuyQevQFqhFqPw5uK5mP2P3iQqf95	3838	5429	5429	1616916420000
7371	3NLXmo8cSieWeETkYtdrdc9jpZTQ5DEx78ReqgCwQ5XCe1r7E6Uf	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	606	1049	83	1	6301	jxMvVWifAiEAFrwQuFac3x8ThQ6yeUvdYyczpmmwkRCZEVYMykM	3806	5379	5379	1616907420000
7378	3NKuVzbbH61hvfNmQAJzo6g4yi861j6oB4WeCPU6W7dZZmvnxFfR	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	1406	1393	84	1	6301	jxWMB5GL6f4tgRzhhStRC8JWZxWoVioyJ2xiRDZB16voASJPRcF	3809	5384	5384	1616908320000
7380	3NLWihzf4gS3LgzrLL2VjxxfrtKEA6beArgcuHzezJCm3LimZJtc	7377	3NLqqAT2Cyb1HWV743wzkMkBvT4NFDQ3bj4G3NBSvoXE7wyqg9ZC	1581	777	84	1	6301	jxcM3oGQ5MTvLQ6Kwe9VnxQBwtyNZCVciwCYrAHc7L5PDZ63bFq	3810	5385	5385	1616908500000
7383	3NKBiZ5sx7j4XBRwWjNdhEMvRaFcrVDbUGayr9EnAoVQAEdRdZi2	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jxmUvwsmqDzwX48J6JbYjVZTatfy66bsBMSZY553SegdCQrjJJ4	3812	5387	5387	1616908860000
7385	3NKZwrAJ2kAfsTLas7FmmiXgXd3oqahVLJaynd51Aty4UtLYbfpw	7383	3NKBiZ5sx7j4XBRwWjNdhEMvRaFcrVDbUGayr9EnAoVQAEdRdZi2	1407	1395	84	1	6301	jxPsTTp94FKraZzLNcnACcf3QraEudeWXubvkHU35advazMpEvz	3813	5389	5389	1616909220000
7388	3NLBBsdhq57pWe391AapA216cAbSy6x3it6jBjkJJUgQP954nYSm	7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	1578	1296	84	1	6301	jwHAUdkAUprpqYPNDWHkDtrqLy8w7f9HKfb71W7uYxer8ZSyZhU	3815	5392	5392	1616909760000
7391	3NKKDJLRB7SxkApKCtap9bg8nqPH1iJ2cPXYUnDM6zoXvGbK9R35	7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	1407	1395	84	1	6301	jwPvHEvng13kyU57BACEeYPmTbTSHSPWm95214Wcg3KdQqvLVY1	3817	5395	5395	1616910300000
7393	3NLXgr33LPj85DM9VAcPj4YNZX7GzouXRe9LRUE63jTypmWbKAs6	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1555	1221	84	1	6301	jwBZe512u9xNxgLLkXM33LgNC2S3tR342XfTnwv5m3DuR8BWKgC	3818	5396	5396	1616910480000
7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	1406	1393	84	1	6301	jwUWcTSepkjMqbqnG2NwK2T3JMBYrVRzSYgVcqzKXeQkkHFPZ34	3820	5399	5399	1616911020000
7398	3NKTPxcpRLhztyNx8MAvbjevic5uNVn1pK4XHbcYxWHSoYQi3t1h	7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	1623	830	84	1	6301	jy2HRBwdcPpZRADZVY58D4p521d1HvUiu2vBV6tfKSX5TKKWj5P	3821	5400	5400	1616911200000
7402	3NKHrUF8YqcW3DBhGMzcawcUeuNH9PTEyhnehEGHRSVG1gSAkDZw	7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	1406	1393	84	1	6301	jxkk3BA5aSPy7TNDjrg41TvDjTJPd5H63kFeWBdBswHZmaMAK7k	3825	5410	5410	1616913000000
7405	3NK64xVtm8wtTLWKZKBACsQQMuFaN3VWPqQPqKYUQL8174TvMHkN	7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	1407	1395	84	1	6301	jxuDzmWziY6JXAGJWLwoHwf4sAevt51db4PqPSyGLR7rkoyttqk	3826	5411	5411	1616913180000
7407	3NKZJMytD1HBpHofqL47BqfqcDsAMsx97kXBmmBGEZAyhbi1xyib	7406	3NKN1a1V9rWCEfiTSC8axjC5zGQvixxWxjcup4xVfb36EUdVUUfM	1637	816	84	1	6301	jxmYHnwW1tPqP9yGnircQEUW6FiDy9Msew9yuEVqqyoxrzzAmz1	3828	5413	5413	1616913540000
7413	3NLe2exbopR9TYhFUyQamP8E5cwRMT7LK8wcquV4n6GAJpax51cn	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	470	1309	84	1	6301	jwTyZrZHMxCMGFTotondodNv2GX4B7kKSML6xZ32zAJJdDbBCmp	3831	5418	5418	1616914440000
7415	3NKuz3kCa4QLeL7pMxFEkgyT3NzzZ41MokUttefhYB8NYxAX234y	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1589	1040	84	1	6301	jwQgvjKFAWkSmDEB357RWjZvwdiT2GakkFnvjyGtFxX3xch3fns	3832	5419	5419	1616914620000
7421	3NKtBm2QwFti1WEY71opoSdDH2b7eJ2D6MP7PDUPNW5eCQV8pYG4	7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	1506	1373	85	1	6301	jwJbnUSzVLUsut5cUCtzEctp9oopSUW7FgGknEvyzBeZvr9yGcg	3834	5422	5422	1616915160000
7424	3NKuj4zDUxG5ufnrAitzCz5VG6MLBcV98UkjujpoVFJxT2CpmMEH	6954	3NLHxnbxZzW5MbpisHSE1MSTDeS8WUgVqeJ4KfwqNy8CwzHtti2a	484	1319	75	1	6301	jw76DKtdFrA4QwAg7S2qwFvtpgBS2jimj22urrtCthE2mCyRcua	3561	5426	5426	1616915880000
7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	1581	778	85	1	6301	jwVc8vQVV6oPYhC69qPRr9VZY1rgcs1rR1Yb3yhbUAKQoRvQwgU	3837	5427	5427	1616916060000
7436	3NKZT6zWow6vnhZwdsq1R5HR3NXmBHtUozXqGQTH3UmfyXYTTzfF	7435	3NLjrcBFRUueNuzvoqakMfGydhPS1RMzVCcsDqaEqZQRtPNakMiN	1637	816	85	1	6301	jxT9ZYyL37zGoL8nNjQLWJDRvNroXwqZjMp9WeszUEzqjw1pBiK	3843	5435	5435	1616917500000
7439	3NKNd3PByZQw5ta8HS4vDEnSCKnVufRBJrApZKqnugD8a4W64CSG	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	80	1273	85	1	6301	jwx52oixC5STj1k9kGC3PcqZ8qKWiu8C6tSCe2thns2RzpHLQ3P	3845	5437	5437	1616917860000
7443	3NL8sKwy1VrXMJNmmwJpc72Aq6jgBKJR8uz8tuKEQBLkyJ8WwCmm	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	448	939	85	1	6301	jwbT1ApJABepRAyedzQkHS7Xv8WQJwvJMw3Tdnj1GUN1qdrTEpH	3848	5440	5440	1616918400000
7448	3NLQW76dHuxxz2FwY5RWRv1vkY45jBesTRk4EhLcTCcCG8aYLyhk	7447	3NKTpcwkxt5Zq3PTpLbtycgUXcLaXBsp8P7StQ49mtJ4ooxgGq13	470	943	85	1	6301	jwM39vzstdVn5v3yYjvnoJ9hCcjCKGqGqa8rFiVypJUCCug3TAp	3851	5443	5443	1616918940000
7454	3NLnRYtT8B5oZv1ECQuuW3QhT1dM8rQ1Ps386MVeFP7zvnsWHBRi	7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	1455	1332	85	1	6301	jwPZbMAjj2TsRmPSnz1fPok5uDoarmVNTkoHNFNeM9GNXzSUW2W	3856	5452	5452	1616920560000
7457	3NKzr3KQ7DG5e3yX4czvCyERDspLj29FvDu5tkHv5MF5hDs3sGTg	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	43	1310	85	1	6301	jwHgfcCRZAK76VPhRLr5wx23irPorXkvi6zn6dQZow5pGT7gmyy	3857	5453	5453	1616920740000
7462	3NLVCNYa7LMaPinZW4HJxmXjxRvYE8x52sZYAzbqzv4buYHNHMJC	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1407	1395	85	1	6301	jwCyjPwEt8Pp3YWXGUFzxxY4N1ueXaEmoju8AjT3cn1ui6MTm9c	3859	5457	5457	1616921460000
7464	3NKMeLJqVLBW1UUMv5J8UEEfTdcr1yFJwYWyAdxYXNiAYVwPsanJ	7463	3NKQmCJK9Tqh1YXbvH7cUHdBxraAwZatVnSTekxWLUcBq4RXwJfc	1483	322	85	1	6301	jx5dWpyZqBRYCqj6yaBEjLaZaL3s7ckWNJ59E1Z87cf3eHRdSfD	3861	5459	5459	1616921820000
7467	3NLaWzL79oLzmwuontLysWU3ikfwAxe98EM4pYFgHjKMHTP2d2AG	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	679	679	85	1	6301	jwrS2qhY3TPhWBUSi8hJtR9bChedV1akg6Ym9jjp8BWLHYukeRt	3863	5461	5461	1616922180000
7471	3NKCuQFQ6FTzJcJipmeJiZLeao8GrZCztrTvV3QDi4o9xMHbat9C	7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	1672	919	85	1	6301	jxQy5bN6vZgReZa8cyE2WVa2WYNryb6wBwWcWDiC7LCYdHzH1eT	3865	5464	5464	1616922720000
7477	3NL8wncML6yeFscCjjP2sfAwmhLitcUxJ1RWn4JcLg3LiYsfZAfy	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1407	1395	85	1	6301	jxr6qeH7rV17fh4V3XJYTUbKDzUcDwmj7pAHB2PnRdzriJGjZTY	3867	5467	5467	1616923260000
7478	3NLwUsMt7XLfom5Mn6MjBxDzMheymMaVfKZP23Sihb6G8UpS37Pi	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1631	794	85	1	6301	jwNt4Uy8TPrzsj9WaiBK9csSt556LKbth1H4fAs8XcdZ11b7Eth	3867	5467	5467	1616923260000
7483	3NK3RpJ2utGhr6kzVKEXkzEjKrjFNxjV4Fxg4f6VfwTYkPNzSEEh	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	532	937	86	1	6301	jxbQaMoP3hyuotKWm3xpFXA7Z7gw7UmKJckFzQoozWzk7uP4bmu	3870	5470	5470	1616923800000
7488	3NLENm4KKXUnW8LcLFZbtUu9bD2qAMYY8PzGQop9vPL5ZcCxCcNG	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1564	1338	86	1	6301	jwghuLkJFwmgXki5gZqyRjhbCDx7eYe7cfntRHVBK2r6kmbcTaF	3873	5474	5474	1616924520000
7395	3NKiHJLXUFGbbDGFssQVWaApb1srZS4JJ9EccoAqwuXdFKBeD8cK	7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	1587	1357	84	1	6301	jxjCDhKWkxnsf8T84FZL91mMDJobHL3Yh8UCctBDFRdg81cvDBc	3820	5399	5399	1616911020000
7397	3NKBewsRDZSkd9SxogHbMJL6XG6FKecv62UAz6aHhHMbzXCn5NmF	7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	684	1226	84	1	6301	jx3jTg6kc246VUi962C4z4v7QASPjLEzQ8LMLDmpNFSju9s6vV6	3821	5400	5400	1616911200000
7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	7400	3NLes8Zw36MM5AvQNtpcSZ5nBrDMjw1KndMNra9ueT7ukW2C4t1M	1500	1051	84	1	6301	jxD4AHwaWBqSVNbzwwRJBSfWRGH1fEzGkkpo2HVcsADgsJZCBxJ	3824	5408	5408	1616912640000
7404	3NK9Va2Xhcseq9byrYYoszHBmyTkUXccizDWxrw55xiiFzKEWdZS	7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	1637	816	84	1	6301	jxajJT61Ru4UaJ1Yp2cunsqZKH9uWpp8USMw7N712kBu7tpZf2e	3826	5411	5411	1616913180000
7406	3NKN1a1V9rWCEfiTSC8axjC5zGQvixxWxjcup4xVfb36EUdVUUfM	7404	3NK9Va2Xhcseq9byrYYoszHBmyTkUXccizDWxrw55xiiFzKEWdZS	1578	1170	84	1	6301	jwhDy4U3H61qefzyiF2FCqfevSQmB7BqpfG2Muy3BM8aLUCoB3v	3827	5412	5412	1616913360000
7410	3NKBDxGSRA92w26krgtzznGSFvueXmG8DdD7ZyPFgsQYtq3TtWpj	7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	363	363	84	1	6301	jwe3XE9yGKzdcVfZ4DhBxN8ia33icD4ttJAip6VXU7jveQXumcf	3830	5417	5417	1616914260000
7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	470	1309	84	1	6301	jwxz48hpnac4aFvae8eSks35Jy4BxvWsMmdHQUBQauBZzUgMGx3	3831	5418	5418	1616914440000
7414	3NL5mGbd59AUWpgdJ6omVr7PuW1xNJdRm3pzepd1oTvv1k1P3Dzu	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxNLyHWd1JKo7W87newH787oVh7K2q9eSPfqh69XC8QGnw7qiXJ	3832	5419	5419	1616914620000
7418	3NKR3v2AMQz9PmMVV77pst1fjW766X2X9FaHTLczM4TosPHCFUmW	7416	3NK4qC925ztdFGZqYzv5w8oRMVowxgLFjYk6igDmW2EMFvWFQMND	1460	430	85	1	6301	jxtwDdniRpSaziBbzQTWKFp92s6fw1DVwjpgNifk5UrFis7DoBo	3833	5420	5420	1616914800000
7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	7417	3NLfodMP46EP2Y1pZdrwHd7wYMiB87sne73ADoy4xYBHCSKGJUCo	1460	430	85	1	6301	jwCvbuf5Tr9f7CpfUKipE3Y3NtFfcsA1tPAqGwbYoimFmu2m63q	3833	5420	5420	1616914800000
7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	7422	3NKRe5JKSQVxZDALtr65SmmXCw4p5h8mBYRzJrdyjhaTJ1UmGshD	1407	1395	85	1	6301	jxVsjRw4LPjnEKKjLLN8LzqqhAQPMXcEQ8J2BuxwnbZ8co5g6uz	3836	5424	5424	1616915520000
7431	3NKjiqcRVUGBU6eG8jqvpwy4kj7FsmLaHXBioY1TyrywCaskvb9y	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	470	943	85	1	6301	jwrJW6bmfmB9geY3NpGCxTrAPo9NtQHaeCsjwwGHQQ47e88fSaf	3839	5430	5430	1616916600000
7433	3NLBENDzteMPfQQKQHNFW4APnkJam7euy4RqYE8hx473YGk78NBT	7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	1529	1316	85	1	6301	jwHy9rrdNhgJo5qj6yYGCfYi4UKJStD6641Ncf1eNec6Q2SmWTu	3840	5431	5431	1616916780000
7435	3NLjrcBFRUueNuzvoqakMfGydhPS1RMzVCcsDqaEqZQRtPNakMiN	7434	3NLDq7vESa4T27eEJ8eZ73zEetHBzazpexvfvMtmfr1bK4ojieYM	1516	928	85	1	6301	jx8NrhAqiYYKf9wB2CzVU3GRzmZ8w2H6U4Uuj5ZWpayNU6CAWJH	3842	5434	5434	1616917320000
7438	3NLRkBbZZ6Cv4LVPYFGtgBoWk3dLALfGhWwyXrVyBYBpJxg6GKMi	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	1529	1316	85	1	6301	jxj1ErFngeJwzsomyCa9Yjo5cbbCEvf4m1bignRMPEAUDVjteRL	3845	5437	5437	1616917860000
7445	3NLG8La83ECUXjnbhjHrCN6K4vqbpZRAdxdVYBcSmY5urQ7AsXyH	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	1445	1044	85	1	6301	jxLqHqDi7AzoZFg5Hz5beAmze3FK7CUrmWabqBamryGBihwEe31	3848	5440	5440	1616918400000
7447	3NKTpcwkxt5Zq3PTpLbtycgUXcLaXBsp8P7StQ49mtJ4ooxgGq13	7446	3NLQVBgRqwx8MMvyGLRuZgEouD2orhpGE9yg31jcAXrD9A3UuVhv	1527	927	85	1	6301	jwSfLSsgWopPjzJKjUHNbcNvnH5tKr8SWJzsigtQdo2HZ3J6cT9	3850	5442	5442	1616918760000
7451	3NKeb5NTpXiViNXDDFAfmBzHZaE7YPc9QpWy4uVgb6nxn7qHVUSJ	7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	1407	1395	85	1	6301	jxbRpGBnkaopVTLPk5Uf3xJps4iwV3D77XysLkDrhwdp9TKbLDu	3853	5447	5447	1616919660000
7456	3NKwDpiZazmh6tddqPbZPPfthjZpwt6HHkf2MnsHG6ohK8c2KZTo	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	1406	1393	85	1	6301	jxaBvnEXVXk1ohASabzau3Vgh1ipLPhZ5NhYEC4RTj962zwhsBT	3857	5453	5453	1616920740000
7463	3NKQmCJK9Tqh1YXbvH7cUHdBxraAwZatVnSTekxWLUcBq4RXwJfc	7462	3NLVCNYa7LMaPinZW4HJxmXjxRvYE8x52sZYAzbqzv4buYHNHMJC	1637	816	85	1	6301	jwe5MV2NPJSoBbRxBUASrNUFhXL9cmuK6JTH2jx8F3eiBJAMgkc	3860	5458	5458	1616921640000
7466	3NLxPfqnHdu1PHYuzg265qoD8AtDGaQdQey8NPvxmDz2VFyusFVi	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	1466	502	85	1	6301	jwNJyfMGwMFyB3ScQKda3FmRKXX4rG4iifdp7H3x3XVyBCG3Eef	3863	5461	5461	1616922180000
7473	3NLEfXZv6txVuccKGtM6E3xwaxkGRRYKuzJ29E33DE9fsSYAGHo4	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1673	1122	82	1	6301	jxj9CLbopeX8bqriwqwnEH2ePZrnAA2bmcB98QZshasXkjZMr57	3787	5466	5466	1616923080000
7476	3NKwMz9QofxAxhEviWDcXnDihvo3jVENgNACzHPizj6MkupRZGYt	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1507	1280	85	1	6301	jwTf393PdJT7HR5ZyssqewLrR9ntckLdkjHWD1owmjJEktAnAdb	3867	5467	5467	1616923260000
7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	7479	3NKocw5pPntLXbuzK7UmSHXYbzr9vrDJxACzbiMA4cNuyDoWv7oy	1480	659	85	1	6301	jwvvd6xMoYsh3YCu89hB3Yrn66Yjp6FN4pSdVy2FjJHic4T77QV	3869	5469	5469	1616923620000
7482	3NKFwdhjZ35tUvZgdhAfxzLtum8ymD9Zt4VQQ2Cop9cWh5WKLken	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	532	937	86	1	6301	jxbQaMoP3hyuotKWm3xpFXA7Z7gw7UmKJckFzQoozWzk7uP4bmu	3870	5470	5470	1616923800000
7485	3NKQGihGqwaHnfK17NRWm5dCkNckhYLWBRR1SzqPrNDgA5rwZpH8	7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	1490	1274	86	1	6301	jxRTyhCB8UbVK8vSzNhD83fFNrJs8j4mTBVgEL83FsjMya6ASGP	3871	5471	5471	1616923980000
7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1406	1393	86	1	6301	jwjSTVsMqkyjhESyjpmrLVHFnyp98o5R5kM5LzNY2AYJ7ez7h4N	3873	5474	5474	1616924520000
7492	3NLDSun86bLduWB4nXMbfDnHv2xoZ5ooSjYVmqZ3DpChfDXN86qN	7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	1593	1346	86	1	6301	jxNtHX37wm6TQvvPoZzLwc7Y8HFgYwuc2Z8Y6jhFwr8ZQcuQ5Dh	3874	5475	5475	1616924700000
7494	3NKcBvtn6tv1BbXjnzBSwjni9PGcW11M15jVKAmhXRyerruuDJ1y	7493	3NKs5trPKGknFtD58PeytzHpPGT71uG8wkuedYUBDCQTmahUcL1o	1623	830	86	1	6301	jwVK56etpkayVBurdQvk5ujiyCa2S65Hcgcv2gxMpprYPuwtW9E	3876	5477	5477	1616925060000
7497	3NKXBuZSUP6AbhLrMqzdyCLqWdqfZjEujHecRK89nmTYrgEThm72	7496	3NLeXn2MYXX1YqPCmWfgchkyzsxZzYtvXZeQyqnyfT26FwQ2RpTA	1407	1395	86	1	6301	jxao2fQdbmsnZWDNFe75KhvYMzG7GXy7zcorzfjaJ9KKXoVWdBo	3879	5481	5481	1616925780000
7500	3NLFJWuKEU6vATLi9ncHS5pdFf1GafcnYxUPFRi2GDdLKd5ibNSy	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	596	940	86	1	6301	jwZ3GFD8ap5gfzLrL6dopCC3JoNxFA4Th2KX1nuExUohDYxt2uU	3881	5485	5485	1616926500000
7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	7501	3NLfVmN6RURGxBMbFZzqqJxpyFupZ8oZRcpwNxBUVJ7E6R1o8vG6	1439	1279	86	1	6301	jwBwjN8Rne2nVDbaT3J2G3usLee2pfQhAkXpG9zVG617tk1hAwp	3882	5486	5486	1616926680000
7399	3NLJnYm5NPjYNfMvuDhYHkgZoJNLiiNNNfwpviTwsXDuAxJYYhWr	7398	3NKTPxcpRLhztyNx8MAvbjevic5uNVn1pK4XHbcYxWHSoYQi3t1h	1476	1245	84	1	6301	jwFRyaVSRxmi5aF65EWmWEpqPF3QAMRR3JtfGN3phem1SStMDh3	3822	5401	5401	1616911380000
7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	1654	70	84	1	6301	jx8fsGX6atf4buwoAV3JkVJvqdu6MtnhR7MGLAtk1RF8ABYyWsX	3830	5417	5417	1616914260000
7411	3NLWxBN9XKvCiDPvHdUeuboBGgPsTAFNZ39imTEJHHAxYVac43LP	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	1637	816	84	1	6301	jwu2HK2aoUQGbhYzisF6DE9K4vEjc6WdhBR4846Gbs2MKV7uBUj	3831	5418	5418	1616914440000
7417	3NLfodMP46EP2Y1pZdrwHd7wYMiB87sne73ADoy4xYBHCSKGJUCo	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxEtCgukXAF9HfbYdRpuZAUVP4AuV5wbTTLBTnm9PgiuDg9sLrD	3832	5419	5419	1616914620000
7420	3NLvSkhqJYA3rVVmC6xnFAmCaVU6CHjzeUqQrc9kvLZWb7BXbess	7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	1402	868	85	1	6301	jweWY9MDCfsdT3CsLbLU59wGk1L2ghbtiJEUmpHH5DB4iRibfi8	3834	5422	5422	1616915160000
7425	3NLB2fnfJWbtUHeCrF1XT4xUTeDe4KRfCQooVUH8ygE8dM1pgRRT	7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	1403	824	85	1	6301	jx6irNbGhHdSJ32QPGAaxsLzwT9Yvpmo7TugtWnuZwiu2EFU6ZU	3837	5427	5427	1616916060000
7428	3NKVYoPpGeCD4dazdhd23inL4uZxDJk5KJrNx72voZQwCoPxEQWJ	7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	1577	1327	85	1	6301	jwG86EvQX2H6oPj3T4b5gTpbfuUgoUkQ3zbQ5GuWYk5HdrP8LKJ	3838	5429	5429	1616916420000
7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	470	943	85	1	6301	jxJmVXHWgDckqrtHQxmzqHvUwM3h6hwDn9xmaXdf6RSwXst8RLP	3839	5430	5430	1616916600000
7432	3NLh4sY5o2U2zpL6mSACxZosFjZ3asKrDrxt332BRmDkuDvMQ2mB	7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	1483	663	85	1	6301	jwqGdo3pigLCmLvNqdhdZitJ4EHoq45v3GiMTXNmK5sM9aULAe3	3840	5431	5431	1616916780000
7434	3NLDq7vESa4T27eEJ8eZ73zEetHBzazpexvfvMtmfr1bK4ojieYM	7433	3NLBENDzteMPfQQKQHNFW4APnkJam7euy4RqYE8hx473YGk78NBT	1608	1043	85	1	6301	jwMS2NN5EycTa6xnibSdQWwPfJnJvApjgDmJnbtpLxP6vvEbWjG	3841	5432	5432	1616916960000
7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	7436	3NKZT6zWow6vnhZwdsq1R5HR3NXmBHtUozXqGQTH3UmfyXYTTzfF	1631	793	85	1	6301	jwFH5YbAjk6HxBfwWJ3r2m4q7md8KYcdc9Nf5cpvRi5u49UJBkE	3844	5436	5436	1616917680000
7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	7441	3NLmyv1ry8DfmCkuYpY5sR4rZxgUoRswL6TdHQXtwDuTu37v6VZz	1631	794	85	1	6301	jxk9SDenvmMg9Zie5SNhD44mcMsbYEpmbVkYfuLZZy817MEb8JG	3847	5439	5439	1616918220000
7450	3NLgW3azFjS9QzBPGpenvktShjWTBaTAkXNZUEdFJUYjWvsJJGrY	7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	1500	931	85	1	6301	jwbrEVvjKgc4VDvyDqvYB7F8Z7cutmgQ3w7v1iU8dHEXJUALGub	3853	5447	5447	1616919660000
7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	7452	3NLyY7K9p7N9N3W47qs2GcJXekr2sVEFjiES1z8WedNYS4TLrMRS	1617	1162	85	1	6301	jxiL4BceDH8Aqg1DfLPYw1dAYcQXcwSwzoHHDTqYv8zNZ3KLH8s	3855	5451	5451	1616920380000
7461	3NLu42JaN29M16LQc6VhLWdBMo47yme2KgJraNJGJv2ChyzvHYxw	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1578	930	85	1	6301	jxNPJYmwaLNskmHtjR22YKHEBmiHMJFhm2uVggELiJKxUvz9H75	3859	5457	5457	1616921460000
7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	7464	3NKMeLJqVLBW1UUMv5J8UEEfTdcr1yFJwYWyAdxYXNiAYVwPsanJ	1646	1108	85	1	6301	jxM6XAG3pwpS34TmTuUyUHGQBdm4GeAEMHhb8QySBXLkgUHQsYR	3862	5460	5460	1616922000000
7469	3NLXAwJFtheB9n2ED2tfmpGe5h6zeL9ugH1cTCpdyUvqMoQCncgU	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	1407	1395	85	1	6301	jxESPY9HP6xdHK8RtQyFb8bynDLM6MFKyJtKihbAE1Tj1PdWrMr	3863	5461	5461	1616922180000
7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	7466	3NLxPfqnHdu1PHYuzg265qoD8AtDGaQdQey8NPvxmDz2VFyusFVi	448	1059	85	1	6301	jx86iZdcNCiweaKzp3LQKKvBWzjFFppRPEaYBkaStK9M33b2ZyD	3864	5463	5463	1616922540000
7472	3NKE3kGJCoBWD7R4gpC2koRTVJUVUqDr1BwZPLJFi1hL5HjCJhMZ	7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	1446	518	85	1	6301	jxXeLn5TkybdnMZxGw2zoHN8qKjGztctroHZELmVsozJD5ZsFVU	3865	5464	5464	1616922720000
7475	3NKUqKDh3wsLdmzvFwBhAaeXENXRg3mVTiTBfN2QVF59oLTKAwit	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1406	1393	85	1	6301	jwpxi9vGdDMWWf4PsSJiTzwzPzHQzx6ArFXt7sZGqLTy3r7ZWZZ	3867	5467	5467	1616923260000
7479	3NKocw5pPntLXbuzK7UmSHXYbzr9vrDJxACzbiMA4cNuyDoWv7oy	7478	3NLwUsMt7XLfom5Mn6MjBxDzMheymMaVfKZP23Sihb6G8UpS37Pi	1656	1217	85	1	6301	jxx5KX1S44e4bXfNhkzEa6cVQxiuqRzPBeXarRMkv6Lmd2MuAyM	3868	5468	5468	1616923440000
7484	3NLvPghhj9QxtEM9o9oMKumgokGh6Lv7qdoARcaCDiX7PJn6zgxy	7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	1627	1259	86	1	6301	jxSrSdoshMEnbF2Pnq1Ma9jmvZvvGSAEjtUgYA5hJFdiQy3siUi	3871	5471	5471	1616923980000
7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	7484	3NLvPghhj9QxtEM9o9oMKumgokGh6Lv7qdoARcaCDiX7PJn6zgxy	1440	1377	86	1	6301	jxqPw59kVsZVB9bV4PjDC6JqrSiwrVg1zoTTAQxy27vK1koA6vT	3872	5472	5472	1616924160000
7490	3NKsBGBmWLg8GgdQM9F8u3xARJ3fsvLpjUT3DSf9xbfuJUfoJwRY	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1581	778	86	1	6301	jxX5E4QotKKutSQ1FTZFnXQ9gYES7ya2a6nwz4hmvjenTALJNf8	3873	5474	5474	1616924520000
7491	3NKhhiqY6NFpo2FRibraNefHgbwSJKHVKhGHjH39UExCxykXWmbx	7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	1647	1056	86	1	6301	jxEhSJnECMJxKggpVGjEq2buW4RR9gtt6qoXdxpg8oeM666xLM6	3874	5475	5475	1616924700000
7493	3NKs5trPKGknFtD58PeytzHpPGT71uG8wkuedYUBDCQTmahUcL1o	7491	3NKhhiqY6NFpo2FRibraNefHgbwSJKHVKhGHjH39UExCxykXWmbx	1553	776	86	1	6301	jwZu9FYYQZsNKWnriszVirs54JBmtEaZrr7xBQaV56CNQU7ts7q	3875	5476	5476	1616924880000
7496	3NLeXn2MYXX1YqPCmWfgchkyzsxZzYtvXZeQyqnyfT26FwQ2RpTA	7495	3NKxE8fUnfd6ezqyy2vzpaXLWwtVpmfAuTnAVQeL14MDTgDU7Suy	44	1199	86	1	6301	jwjynahXAjFheiesw6r4cmnpBZeiUqaVk5iNzR1hnHaxW4cp9tq	3878	5480	5480	1616925600000
7507	3NLXYLrNuq3mzqxcWTN4D7bWz2ggn5uRJdzi3QVT5vgUoaP3Nj5U	7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	1611	1095	86	1	6301	jwdeekjwauQn2WiWpqqQfmaobUBLNTdDvrzvZuKfeJpbMs9XjNy	3886	5492	5492	1616927760000
7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	1397	828	86	1	6301	jxY4ELe1FJaWUXgRApU2fFZofSb4zgi7q3KA69CXzSBX2tm2mmT	3892	5500	5500	1616929200000
7522	3NKfS5iGu3HdTD5Vf46Ge6Wz79MPHB1HWcxenYZmttnH3bPhHqss	7520	3NKaCDCmx1tXyZazKfWDgVhoNimiHQoLWiBBaeHRn2Cyt8y9W7SX	1553	776	86	1	6301	jx6oJYgx1adcQ3sGapvHWEvzgVvw1BXXa1g3UtYsiVL6QxUeQDC	3894	5504	5504	1616929920000
7525	3NKouQunC6SPyKof1K6pc72Twa4btBBSFbNwMZtknEkHn5UktmdZ	7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	1500	1297	86	1	6301	jy2nKHn26cQzgLPh5SUUYzFmzJPzK95sTEpJp7KSJGTn9bsERxf	3896	5506	5506	1616930280000
7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	7524	3NKjUMSS5s4mchc8VGjcnubgmCYSBQio4DStGFN6zzsaQ5enyyTV	641	1336	86	1	6301	jwuofGjsZe4Axp4YnWJWnF77vuDnLRXfqkF35x1QLLFeRVV7Vtm	3897	5508	5508	1616930640000
7429	3NLtsKX9rLspYFyV8R3cgtmkKB6ShsWv5FEpLawNWyFU2wYcX84N	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	1536	1313	85	1	6301	jxuJqvB5ydxjtPajG9K6yrkZ8oB564E2CmofSETukYK1QU68r1c	3839	5430	5430	1616916600000
7440	3NKKyjYG5NqNnaNhUNTsmCXCNwjZTtfspKnDUY7v7GC6xCj5h9it	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	1593	1100	85	1	6301	jxHFn2cS1NCdQZedehmZyUnbpPDRGwtVhgsi2k8z3HjmWQnCTfE	3845	5437	5437	1616917860000
7441	3NLmyv1ry8DfmCkuYpY5sR4rZxgUoRswL6TdHQXtwDuTu37v6VZz	7439	3NKNd3PByZQw5ta8HS4vDEnSCKnVufRBJrApZKqnugD8a4W64CSG	1406	1393	85	1	6301	jwazB1kckZkqPszatQxfJ9taLLAnkRVRJKWoALCd22Ap97qMyVN	3846	5438	5438	1616918040000
7444	3NLr5hqUHPB38BogTHP5KTypBHbC5xjMvjpSkQvkhDNLU4iEvR7Z	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	1536	1067	85	1	6301	jwbw9NEwhhFfHz4j5ahvPXGw32Dz63YddErSP63u7RvwDEuGaS7	3848	5440	5440	1616918400000
7446	3NLQVBgRqwx8MMvyGLRuZgEouD2orhpGE9yg31jcAXrD9A3UuVhv	7445	3NLG8La83ECUXjnbhjHrCN6K4vqbpZRAdxdVYBcSmY5urQ7AsXyH	1648	1038	85	1	6301	jweA2mLtU2sK2S2GhLCGAqey7rdQxwPdzKRR3nNgG54RopZpuZE	3849	5441	5441	1616918580000
7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	7448	3NLQW76dHuxxz2FwY5RWRv1vkY45jBesTRk4EhLcTCcCG8aYLyhk	1509	1074	85	1	6301	jwJK7XQ7RRpEagS7rBhfapSLc7LoVdf7eWP4qnz28KhKGRtuQHg	3852	5445	5445	1616919300000
7452	3NLyY7K9p7N9N3W47qs2GcJXekr2sVEFjiES1z8WedNYS4TLrMRS	7450	3NLgW3azFjS9QzBPGpenvktShjWTBaTAkXNZUEdFJUYjWvsJJGrY	1637	816	85	1	6301	jxBwQ6b8zKdX1XKaZhoM9dgj5AtURGQUYqfZ4E6uSmsAZn4GQNW	3854	5449	5449	1616920020000
7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	298	1308	85	1	6301	jxbLJX3zWSjni5i577knZV2zMtrtitdba5MKDN2bm7jpJYjSPM4	3856	5452	5452	1616920560000
7458	3NLboADoQ2Ufvepeh1C1myNXjNYKLzjUv6YRzKBiGHrq64C3womz	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	1637	816	85	1	6301	jwfRSNkKYXAdA1btexXAZXj3sE4A9PQh4aZkgLiM9FpDeWxJ5Zo	3857	5453	5453	1616920740000
7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	7457	3NKzr3KQ7DG5e3yX4czvCyERDspLj29FvDu5tkHv5MF5hDs3sGTg	1407	1395	85	1	6301	jx1EkUWLswodhCHvnNLLbsJAxFKmfrzPshU1vmFvriWDHyxq7vs	3858	5454	5454	1616920920000
7460	3NLXuVzqugUR3UZvvwnR251vaaBiy39jjtJJjWYtyE4m96wvxYvb	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1406	1393	85	1	6301	jwU2kMBhRhqXNXJjMF6UncmNZhQJmnjno4EFBmSLgKgmif7rc1S	3859	5457	5457	1616921460000
7468	3NKHq5opSvPgkjvfSy7sNBoQF5eUzbu3rWTBmGcnS79h7hmX2vqA	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	563	1233	85	1	6301	jwti16ZASbV1nzHt1hHcFpQEh76hatGTeJRY3WNp5jA7wxsnnzD	3863	5461	5461	1616922180000
7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	7471	3NKCuQFQ6FTzJcJipmeJiZLeao8GrZCztrTvV3QDi4o9xMHbat9C	1406	1393	85	1	6301	jxSg42PPz6qCc4Ykr47yU4hf6386L3EjrcapLcV6AqS36t8ZUq4	3866	5466	5466	1616923080000
7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	1406	1393	86	1	6301	jxVfjHq9kc3EEC66KpfF69j5Ao4jamYqzAapWmposiKeWQ9K8T9	3870	5470	5470	1616923800000
7489	3NLY6dLyxeYBxGyanCMeMwVJUdV2kdid4d3xyukSYxbbzGjcJt25	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1407	1395	86	1	6301	jxo6tkNYPLpy2VskCfj4DR3JBo84yrYdbzscoDEdgHETdTisHS3	3873	5474	5474	1616924520000
7499	3NLf9K1zLj6QSDz5eHSxzzENZCr8zbayVYkjeQj13sTRJ9ayQJco	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	457	457	86	1	6301	jxoVJRbwdciggJW2bLdJPX9JUGMzDAxWBQCrdFPbuumbNtuAZy4	3881	5485	5485	1616926500000
7504	3NLNEjHx4S82KTEXDkbWmkmERhjapCvgWWeYXYTwQDgwwMXvB7ae	7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	1407	1395	86	1	6301	jxJo1qdwjqRqyHakxWMvL5yf65zScjFwnv86hwHCSLFx2BYF2R9	3883	5488	5488	1616927040000
7509	3NKMQ8ZejP96j8FZW8ufVhykBTcFbnDCNSTiZfF9hmPLbnMEmf3M	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1607	1222	86	1	6301	jwNZgQtbGUvDG6zBd4jbKT3GyCRv7K8WNEazMGV3z6s1Km6fWFs	3888	5496	5496	1616928480000
7512	3NLaNDx6rDxY7ut2KK7NmEyr6gq2VhrGp34HXySw2TiRUeqn67V4	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1407	1395	86	1	6301	jxmQUsYytnKEovufohfME35V5JQEZkACzq4CeaTs9UTqWqGfUNF	3888	5496	5496	1616928480000
7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	7515	3NLcpNtTVVo7vEGPFcgvs5sqKYhuNU2y8saKrTxzobeAr9veNB28	1419	814	86	1	6301	jw9XsvP8D44Jdzr28kMGyZiqN6pc9WrAjVmLkhzQSwPwSP5CU3Y	3891	5499	5499	1616929020000
7519	3NLxuq71NV8PiVJBVoUdeAZgbB2BtM2e78mCPwF2Yi1s4ek4Ec7G	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1483	658	86	1	6301	jx4nMH7uPns6EGF9S73DDtgVKaUd3o8bGGPSQGpmMAJx2bfcCdu	3893	5503	5503	1616929740000
7526	3NLFQmf6v2ig6eXvhTaQgZ4tARp22opUZGzJ7A1cPAwSK62zdPUM	7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	641	1336	79	1	6301	jxDLDZ3FiDgaYbFCcjq8YJerfgQzjyWcpjedLXFHCYGRLWkMEQx	3673	5508	5508	1616930640000
7533	3NK6bFKsrHRH8bU4b128uQHFSmywyo2xKUuxacT6qHS4H9xq72Ae	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1560	400	86	1	6301	jwTwQdgBRbJLEXqStb5nhdXZZuPEvEpLYbGEWBYwedxgJZEcGxf	3898	5510	5510	1616931000000
7535	3NKXFTZqxau3st8qmdYAjug4V6vxPgCdE6YEky7ffowNPyLyHTSQ	7532	3NLMfkkWG9TLK6qDbJsWtE6g6JD1vaVsVJEWfjHYrohi8Aniv6Du	1402	868	86	1	6301	jwZ57A7FcGSUweeBo9ESRt3ZUkQeQd5S9SJMsS8eaPoodDWf1Zj	3900	5511	5511	1616931180000
7538	3NLMu6EWzR1tr2nM2qHTFgUwjtVoEhCKQUG6iAYm7P7NRDhcaQV5	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1609	967	86	1	6301	jxzkta8rfH5pGEkurpjinCcfnLJLZu7vLNcrYsQ74C5Pps23sqJ	3902	5513	5513	1616931540000
7550	3NLcRCmsYFrtpm6fvACHQB4xjCc8qpekziMDiwWQZRKHUjcWXm2V	7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	1406	1393	87	1	6301	jxffZYi7Vy9pBCeid72PrE2Dc1Di252prP9JD7CdHnpvSJ4xY8x	3910	5523	5523	1616933340000
7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	1458	1077	87	1	6301	jxXAUk9zNxxnsnudqwVsTv9T1d9KRTfovaMaT98z6dQGe4Daw3K	3912	5526	5526	1616933880000
7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	1590	1174	87	1	6301	jwy5B8ptaVUe4LqcJoyfdMUkAzn3o7i22zE8ZkbVk8Fq8s96Neg	3913	5527	5527	1616934060000
7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	1516	1168	87	1	6301	jxNYU1iUGccqLSxWDFxVM3JZSb16NKeFoewoW8WM4m2terFeJZS	3918	5532	5532	1616934960000
7571	3NK7ipTCm5H45tmHhUhzfhD6znpKoMXCH85885aeYitaM4QVb6Lt	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	596	1060	87	1	6301	jxvbDbU4FNTzss7JCdBxCeH3TQXS7jjhjARxZ4zXp94FYvyMmvD	3919	5533	5533	1616935140000
7580	3NK8zSr4ayLaRwVDbiLFnrQH21QoZBgTge1Yo5iqxWEYmDN8iCKM	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1406	1393	87	1	6301	jwo4HiVVQvVLXfTa9DHZwwaZLghraUc5PkhuPwVqagUNsF6VNyJ	3921	5535	5535	1616935500000
7582	3NL7yFvUnBx2WydPaRXF5jiNifwgE6rwv8EecE8KCF2DGsF7Bg4X	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1594	1200	87	1	6301	jxEhY3qk9eqMzAGuttAGW7vH7DTzQevAUmTRmKHuHbivT87fWZQ	3921	5535	5535	1616935500000
7495	3NKxE8fUnfd6ezqyy2vzpaXLWwtVpmfAuTnAVQeL14MDTgDU7Suy	7494	3NKcBvtn6tv1BbXjnzBSwjni9PGcW11M15jVKAmhXRyerruuDJ1y	1402	852	86	1	6301	jwcDWKyybG8idC523JbF91rdvk9WMKeub3FANkDkbpY7zivJDex	3877	5479	5479	1616925420000
7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	7497	3NKXBuZSUP6AbhLrMqzdyCLqWdqfZjEujHecRK89nmTYrgEThm72	1406	1393	86	1	6301	jwZ3H1Uxt88u99YzyLnhVJjQ2LgEcMMC59NSymD1CfHqFLzDxNH	3880	5484	5484	1616926320000
7501	3NLfVmN6RURGxBMbFZzqqJxpyFupZ8oZRcpwNxBUVJ7E6R1o8vG6	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	686	686	86	1	6301	jxGj9XHJKpRuP6c2UrWcfAKEi1Y5va7cmDWWe2jPP2WbGs9SNJP	3881	5485	5485	1616926500000
7503	3NKUdPuYdfe2KdeY9aLCRFooabGM29pUdESVJmv5suCQkD3etyci	7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	1637	816	86	1	6301	jw8zfgVyX4gUq3n1hFa9bC1Xxnmzp2N7n3L4GJ2Tq4gLa5XjFyR	3883	5488	5488	1616927040000
7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	7505	3NL9xXqdobL8iTa5aduBCg6ZJ19VKgGnv9Fx1cFqwGMnHGRLRm4o	1423	343	86	1	6301	jxhiK3Hz3NRMNf5AJ7H31NwKdpWnC1gGeA9rMxjqSKqfQuLBqSV	3885	5491	5491	1616927580000
7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	7507	3NLXYLrNuq3mzqxcWTN4D7bWz2ggn5uRJdzi3QVT5vgUoaP3Nj5U	1637	816	86	1	6301	jwvV4pS6NNtUkyvbw9eiRPm5upaUBXyabXBrDFmsrDhdMTHWQqN	3887	5493	5493	1616927940000
7511	3NKDHNLXn1tch9ZAhNDaeJyGy27SQfLYr76icPZ8bPjzGamd4n7S	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1607	1222	84	1	6301	jwWMMTk6BQpMFRdDDkLGdA71ogihAtbkQwu348tFpe74hEJdECg	3818	5496	5496	1616928480000
7515	3NLcpNtTVVo7vEGPFcgvs5sqKYhuNU2y8saKrTxzobeAr9veNB28	7514	3NL6EDuCFpAsrA13qSLa5efc2UhDxVwNUSRnLf8PZo5E1YbBJgnj	1483	600	86	1	6301	jwUxHRv2bd6E7mkYDE35n7eUhPCpZ947ExDBhzAcrdE3kazWHtY	3890	5498	5498	1616928840000
7518	3NLQCndSiyTF1SFgLSNFSRY3JPfd2QL8szUEh7vKtmmPMHhLBetw	7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	1573	1318	86	1	6301	jwGuxjguoZpFtB9cz6s1HGWzdbhqnS7TJ3vRyty4qtqpmak4AfS	3892	5500	5500	1616929200000
7521	3NLeoqY8vuPCnEk4o9JKGedJxGKnynNhZnGQzv7DQKGtYtmLdixM	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1577	1327	86	1	6301	jwQfEicsFkvEksYKZmNCVu6XtsifV7RwbHYgHkK5H8BjLgLRmae	3893	5503	5503	1616929740000
7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	7522	3NKfS5iGu3HdTD5Vf46Ge6Wz79MPHB1HWcxenYZmttnH3bPhHqss	1458	957	86	1	6301	jxRUcUmmxtrS7SSoPAopZko5itttfaQMGokniCEYGKypkn2Ez7Y	3895	5505	5505	1616930100000
7528	3NLe2rT2dx7rMd1nYbZsnkZ8qYRviTRkHzu2jK8cNCV1dpvad1YD	7260	3NLqDHQNnw4C7hAE7F5Luan2VKbQgD8fauEumDsADQu4hAR51qo2	1633	1390	80	1	6301	jwJBc2waSfnt3bCN5cW1HPnCMgYB6xiQhPqGfV2JAsJgquzzkXr	3678	5508	5508	1616930640000
7530	3NKzdVPrYdfCCHu1277VTrqtNLxE3BDfhj3QE1e28Nhe92GfQvbF	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1445	1044	86	1	6301	jwW99Wz2Wi6Ekcwfg87CsdxLaUYHrL8FpMYUazvRvR37pnvj6sn	3898	5509	5509	1616930820000
7532	3NLMfkkWG9TLK6qDbJsWtE6g6JD1vaVsVJEWfjHYrohi8Aniv6Du	7531	3NLjzCy2FKEnF6aSoiCHdEsfbww8sa6j9rTXaZhAd6oYENxeP49s	1560	400	86	1	6301	jwrvf6hRfWuE6QzddU9nyHiFBVnXYHiwJmMsMnqobRkeY53Ng8L	3899	5510	5510	1616931000000
7537	3NKS4qiLMejVt85824HXJijLToeCKiE9cpt1VBNZ8ZTdwJwrWiMc	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1529	950	86	1	6301	jxnyYPYg8yakyqcQuivjV69ZK7k5EApcyRQ2XdVhKkyrNg1Vr8P	3902	5513	5513	1616931540000
7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	1406	1393	86	1	6301	jwPTsxzswgwECixwDEMSp2NrH7VbfFHzgNsBJDqptbKXgd5U7kr	3904	5515	5515	1616931900000
7545	3NKkMhRWYQWahDbzUwEAH2jANijiJ5zm4DNjv42Lg5CVpckx79kw	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1406	1393	86	1	6301	jw8RLLnHaabjjPdprUDnDLzmidYBcbCvyDC94qfq7LdTph6KJBW	3905	5517	5517	1616932260000
7547	3NKBdd3kpQvCJwv9tfsfSgaBevYAfTximigRakSriTibsDLgG5fv	7546	3NKrNHa5wvaSLbaLTTRE7zumUkHRHTC1fksyAhxVVugwYV25B8ij	1419	814	87	1	6301	jwPynvf9wNbvTvDFp2MDhDVXp8U2Ump7YnrifAaBk2Rq3P8tKBc	3907	5520	5520	1616932800000
7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	7548	3NKMBAhLvj5rSF8xi3YBEA7QWGc6fKvMmzGpwSAyxhDHoHydQsGN	1403	782	87	1	6301	jxvBm91PyM1bZYdg2wq4Dy8GNH27iUW2WypyyULxhHnGzwxiw89	3909	5522	5522	1616933160000
7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	7550	3NLcRCmsYFrtpm6fvACHQB4xjCc8qpekziMDiwWQZRKHUjcWXm2V	1406	1393	87	1	6301	jxVA3Nahw8ftrgpMH1ubmYimTrD2bTWKQQWEnYJ65YvS5amxRyP	3911	5525	5525	1616933700000
7554	3NKn8WGu7GMK5wwfYNuEEFPSVLEJEdLi8Gkp5BCREtYhjp2ZivwU	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	43	1064	87	1	6301	jxHfU3fBgwqJmj5axbqJiSwyYEk8ZNpEbCBt3hWdp51Dn5RZvGC	3912	5526	5526	1616933880000
7559	3NKxggrMu4XdCaZrDMbv8DBXM714zwc6ti9YTsNuGLCgpc42SNh2	7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	1593	1220	87	1	6301	jxnb41EPpxwH5BsdrgLPhn4zJWDy5Nbq6Dp8LNjjE599CQg4Z1e	3914	5528	5528	1616934240000
7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	1573	1318	87	1	6301	jwVmxuk9fENDPSzQyXBpkggcTDHYgSmpEpWzY7zNC9bk1BPfbSA	3915	5529	5529	1616934420000
7566	3NLHgjRe2F6VMbTVajAsRKPPMXZcxG6WjCmeAfjLVYAF4vJPGmAz	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1601	1142	87	1	6301	jxmJvxCPqfUXTQbUBj4d58sTCCyyrGGsxjKTMSkGpSieikPjEVJ	3917	5531	5531	1616934780000
7570	3NLZJSZMafS2VETDSXQVTzp58BnjjkrrvwBnt1FRvAY421KPZE7V	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1403	824	87	1	6301	jwZJ5vBi7nkTRtmXCySghfzU6FaNZnhyrUkFUckXmZw6ineumci	3919	5533	5533	1616935140000
7573	3NKx54S7TnSDhLhYLafZdTzEdgM6Cw8HBeXGgQ27jRJu5vsjqnJH	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1553	776	87	1	6301	jx37hCtAaX3cKxhor93n1ThzN9DVcWcBcn5h29AhvwV1wFbTfuN	3919	5533	5533	1616935140000
7579	3NLaEaPBL4Wb3ZfbFfPREvCZZXoMDnwzVGiRCLZHBSgbJW4XzNT2	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	1654	1340	86	1	6301	jy2ohpG4cSZAk4tVNmGY9BEKxVA3PgS7tetYuQNT4MDgDAp7Rgo	3881	5535	5535	1616935500000
7505	3NL9xXqdobL8iTa5aduBCg6ZJ19VKgGnv9Fx1cFqwGMnHGRLRm4o	7503	3NKUdPuYdfe2KdeY9aLCRFooabGM29pUdESVJmv5suCQkD3etyci	1573	1318	86	1	6301	jwEqPVuWPx8r2AQixDRfW3ED1J5XG4uCDDKiXRXE7nMd2o7rEc1	3884	5490	5490	1616927400000
7510	3NL6tugUENf73tRWjhfXF2bJCzoZgtGwYzSMskyi3kGgymNXHgb1	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1406	1393	86	1	6301	jwMcBGVsDg7hGmuVokm6dWGtoP6AajbwH9AKDzt8ZxzhBd2imgZ	3888	5496	5496	1616928480000
7513	3NL14GVJrT9WA3GaybHsVymk3MMH6jvFFkhHTHGuSQ3xe7AjdGdq	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1573	1318	86	1	6301	jxqJC85ye6dt19BipeYuenfS5oBx5WBbUiPCoyeUpnxTfKiFzCB	3888	5496	5496	1616928480000
7514	3NL6EDuCFpAsrA13qSLa5efc2UhDxVwNUSRnLf8PZo5E1YbBJgnj	7512	3NLaNDx6rDxY7ut2KK7NmEyr6gq2VhrGp34HXySw2TiRUeqn67V4	1407	1395	86	1	6301	jxG1pAX5hNUW9rekVyNvdha7kgNF5xionnc5XZrXEyJp4T5ZrLL	3889	5497	5497	1616928660000
7520	3NKaCDCmx1tXyZazKfWDgVhoNimiHQoLWiBBaeHRn2Cyt8y9W7SX	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1501	1360	86	1	6301	jwZYihbrRzDXzZ4N7HY9FyYxVnVgw447gJ6yQeVVE8SAwXcf9jV	3893	5503	5503	1616929740000
7524	3NKjUMSS5s4mchc8VGjcnubgmCYSBQio4DStGFN6zzsaQ5enyyTV	7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	1403	824	86	1	6301	jxBSastAoWBKtckqc8SzUBAS6tYhmqtrZjkioGkEhdReeHFhAFE	3896	5506	5506	1616930280000
7529	3NKVC4jPNwetTR9avr9LMxcazY89WTZz1vGftuNa4En24mKp7DAQ	7341	3NKB7XBfRvaCSVru7xcXHLkgmFxjBeEYFsm7WTrUZGbVAjHHo7ot	641	1336	81	1	6301	jxcWH1GcC9hruDGeTYatwXy3sanVxrgoQnXMdiqFQR4fSGhwyHq	3696	5508	5508	1616930640000
7531	3NLjzCy2FKEnF6aSoiCHdEsfbww8sa6j9rTXaZhAd6oYENxeP49s	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1406	1393	86	1	6301	jwdpBJzayMkC3Jyvn9rKT9Ew2U9ERPeAAbeGaf8cspFbajmj8xR	3898	5509	5509	1616930820000
7539	3NLBTbh3GFcNXEc5rEoWGBs84D4oeprPGL2kP5wq9gi8gZ4Crnoq	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1631	794	86	1	6301	jwNF997x2QQXrcWPMh2i7HvXyyTZbcvLpDv37TeNrbWPsX6Ywfy	3902	5513	5513	1616931540000
7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	7538	3NLMu6EWzR1tr2nM2qHTFgUwjtVoEhCKQUG6iAYm7P7NRDhcaQV5	1445	1290	86	1	6301	jxrqD3vdNN5fNBg6HUAxLsZGGfjbZA3p8FBzfhURdsa8VcXDBNY	3903	5514	5514	1616931720000
7543	3NKamgavRCU1SERKrYd2HG6Y1246i5AZ2QNfUaJW1TmESKtAQBQg	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1589	1286	86	1	6301	jwFq9hRwBKxpsL4DduchMFXkkZiLp4xmW8fwGqPDRZcBnt4YfRk	3905	5517	5517	1616932260000
7548	3NKMBAhLvj5rSF8xi3YBEA7QWGc6fKvMmzGpwSAyxhDHoHydQsGN	7547	3NKBdd3kpQvCJwv9tfsfSgaBevYAfTximigRakSriTibsDLgG5fv	1649	1137	87	1	6301	jwYnX9Ui7ypCC84hKW98NJi1LFPNwiewXhybnyGgMjrVXPJRVva	3908	5521	5521	1616932980000
7551	3NKkSnY9zB5d8AcCGLSAND98WgNFxBy1DNVBPoixMkDVdcfhkHWm	7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	1440	1251	87	1	6301	jwhABJG8cVUYKFHcuopXbRmViXHcb3UJWvZjq8gd1p35vQK9Agb	3910	5523	5523	1616933340000
7553	3NKRXr2VKNEEWUPEZmcLXC9Dwyd9bzw3eoaPpy7EMAysfJvs6ccZ	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	1406	1393	87	1	6301	jxBAePuA3VjUwxXNzbMmjyc2ZjZdv6tkQJ17u4GTa8XtNwBtQUK	3912	5526	5526	1616933880000
7560	3NKNQ6butfZChq5KBdPmEedGJ4hQpBiWhcS1RYtFdbakBwKz8AWQ	7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	1460	670	87	1	6301	jy2Jp5zLafJgFdyEnH4J8VT1MkpLVryJcwiGtLwRfcchmSwbtDX	3915	5529	5529	1616934420000
7562	3NKmJY9HF5ENpDXYHawQ2YpRWBQdzgnwx1PTaGcDGVztDSHXZEmh	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	44	1199	87	1	6301	jwgUikgXSu9JfcQKmCYirrpFSdUQufEYZy5bfhXE63Cev279pG7	3916	5530	5530	1616934600000
7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	1581	778	87	1	6301	jxpswaoUEYir2uVMM4RezRKqRauERyXSymBbJdtMvYY37SZzZnu	3916	5530	5530	1616934600000
7567	3NL8xTpuT6yPwkdkCkYcdje4d3hL4Noeo1KuvubJ9D4QwmVmB5F8	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1513	1013	87	1	6301	jxkFy1X6pPdA32L64ab72FxvmuSBkv9KxZQ8SH3CtC4ARLd3976	3917	5531	5531	1616934780000
7569	3NKtCF72V3HVLEjSFmkUY9PVHTUzockwkYyKDTgn4H48vhwZjGFX	7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	1555	1347	87	1	6301	jxtx5pme77v2AefDZtFsmDQNGckWNMJZ3ydASeTjhi75cvSogpM	3918	5532	5532	1616934960000
7575	3NKUpwoMXBbawdbAM6iWQLd1dG1Zm9jNxhX7kA9ytQKn99iu1mvF	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1445	1164	87	1	6301	jw7Jug2oufio7F6yfvCW4RvHAKNzQ2NHiwqXjsZE71N7KGwkZ9F	3920	5534	5534	1616935320000
7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1553	776	87	1	6301	jwxBgNyHEzn1YmF2RpF4JWKtc1d85YWapdTp9PpqZdTFqUn2amj	3920	5534	5534	1616935320000
7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	7583	3NKoeqhc3UWBbFk1wX45V3q2Yf9hfErwf21GPKeRSwPdXyVtiyzJ	1637	816	87	1	6301	jxSwDwPfGhxHVaRj4amfASiDVw9WLUicu9eFyZzcnaorWbRbTWz	3923	5537	5537	1616935860000
7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	1405	865	87	1	6301	jwJ45fWacjmmcRcWyTTkGNgkepfWiRs3XemGUVVkJjkc76SvLoX	3924	5541	5541	1616936580000
7587	3NKdwjafkTDU82zwB9FsJAQB6Yya1PJSKCHMUpjABrYyHiwSGZ7D	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	1578	1296	87	1	6301	jweiFhW4xzvN7PntMu7deE5W9rDxAWWMhmC6bzjHfj9TvoAv6Lp	3925	5542	5542	1616936760000
7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	470	1063	87	1	6301	jxyCTfZxjagk4G6ePxFiM73EfPjUuLwsAkQ5vgHxp1SVTvcwACD	3925	5542	5542	1616936760000
7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	1507	1034	87	1	6301	jx33pcnXhTtLjU7oSv51LrghtqdDev7UutBW7gj8ZDeAFKJqgip	3926	5543	5543	1616936940000
7534	3NK6fCJnynXY3DWxxhPMFmfaYr4iwbS9MRqAZS8sZpX3WBcMgjCT	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1560	400	86	1	6301	jwbmELtqYY9EGHQcdde78wy89A8BJTmNQNag6krWoCA9ZnKh5wq	3898	5510	5510	1616931073917
7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	7535	3NKXFTZqxau3st8qmdYAjug4V6vxPgCdE6YEky7ffowNPyLyHTSQ	1406	1393	86	1	6301	jwypHD4zQvFgTyc8ZJrjzMVZCDJuBnk51EiJqpgYccUxep1GCPy	3901	5512	5512	1616931360000
7541	3NKzutJ7PqGv5tAasffEAZwbYQpyV75Lxpnz1RELA7wH7g8fTw5R	7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	1457	1391	86	1	6301	jxMX7L3GqNiVBtx9hPz9YdAcMxcLALbfYXn8LZ8qhsNEKRQM6JF	3904	5515	5515	1616931900000
7544	3NKuNSgcNfA4VyTQdD668pbJjWaCSXcnNqFM732t2BoP34W6SGHu	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1402	850	86	1	6301	jy2t399CKkQ7tn6vii5U1oEMP9JUwEuKSousprxDRfXjGr4bbyE	3905	5517	5517	1616932260000
7546	3NKrNHa5wvaSLbaLTTRE7zumUkHRHTC1fksyAhxVVugwYV25B8ij	7543	3NKamgavRCU1SERKrYd2HG6Y1246i5AZ2QNfUaJW1TmESKtAQBQg	1553	776	87	1	6301	jwePLtQAcV6DM4JTJ6iAFdqhECa4h3wWf6gCnuGA26unFDvBjdF	3906	5518	5518	1616932440000
7556	3NKPj5rJVDfFtZ6PTVAXPH7S6huDxWK2Fo7PCti4h5x7K99u9uX7	7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	1406	1393	87	1	6301	jxwMpJvRFWjMmBWL3wjuWhK1ZsmHas6um49i9HkNWmAW13iaPhY	3913	5527	5527	1616934060000
7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	1637	816	87	1	6301	jwYnjiG6P23s1GQjNFoXNqB9w15Tq5qCNurN582VMcZacJE4oQF	3914	5528	5528	1616934240000
7563	3NKS8PhxeqVY8k65ZWfeS9fYyQ6f71YA9UfPPprtfuobvhDy6TG7	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	1675	1342	87	1	6301	jxhxfcxrpNUcZUPRY91d3XVkn5fGctzLG7NhjjuwrgUYGdTbHth	3916	5530	5530	1616934600000
7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1516	1168	87	1	6301	jwoHpkG5hMN3CGjXejs2q34sTAbKW3WAfac9ywmYU7RywPBn8kr	3917	5531	5531	1616934780000
7572	3NKkxyPoJJgmbj47eSHPSyvBbp4VPZc9ub8m55AQRbo5ujruUuiz	7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	596	1060	86	1	6301	jxp1no9DLhNRdBByaDjnD2brGSyVqpmD2k9uLkcmWV1bVzqLhEy	3886	5533	5533	1616935140000
7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1407	1395	87	1	6301	jxAVTAA9UDpTFXYkkJeuH1Y3iaPtFgNHTELBvpaxRYa6iJTn5fa	3919	5533	5533	1616935140000
7576	3NKQNigefmY7tEKExbBpE4DdbTVVcPdsCrbRc3HNa6JNersZUYAW	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1440	1377	87	1	6301	jwBPH4k7Sq7HonJH7ohS1cFesTaYnx7BsjqYoCnPUxoBRgZ5Ppf	3920	5534	5534	1616935320000
7578	3NKeKKhowHworcRAYN4DTShp2D3teLxkDtf5vKpkHAXANB2jUwD2	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	298	1308	87	1	6301	jwSnD1ZbMbR5x3wdgGvBQ9iHGk8ZLt5nMMWWEYUofX7RFs5WdtP	3921	5535	5535	1616935500000
7581	3NKzXESXts54Yz46Cq8SrSKzqcCWtmLm9ysv2cZj9kKipBwk4dsG	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1654	1340	87	1	6301	jxccwjorixxG367ms6bpkjca7Tq5xeizBpLJBrk3QY5gXBRgTJe	3921	5535	5535	1616935500000
7586	3NLfwEFxaATQsVgRtmrpFDMNqWSTWX116b4tYHe4uuvYtCQP2nok	7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	1406	1393	87	1	6301	jwSFEmf3W7LeUynh2S8DvEKit3vYyRi1pn2iRei4rk7A9ZdSBrq	3924	5541	5541	1616936580000
7588	3NLuBR19TMHm9zUPNDDKPPvcMNYW7t6BpSfkGd9qCKZzU4wLSQMV	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	1406	1393	87	1	6301	jxBvEBPuCCG2MUWbjorJMUJJ6u7tCqXKqngjRActEZ4A3Ax6ZHH	3925	5542	5542	1616936760000
7590	3NLw9NZ798ZbFeQ1rphKsPx5LmJMPNHrLgcDCcLxAn5ufEZ5j61D	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	470	1063	87	1	6301	jwJagetucSbfGFzoxiacJEEvc3d2zhnuvMSj3dgBpbbtjP4ohmu	3925	5542	5542	1616936760000
7583	3NKoeqhc3UWBbFk1wX45V3q2Yf9hfErwf21GPKeRSwPdXyVtiyzJ	7582	3NL7yFvUnBx2WydPaRXF5jiNifwgE6rwv8EecE8KCF2DGsF7Bg4X	1406	1393	87	1	6301	jx42j2DH2tYsLiW2QMpE4CGgoRn55zZ9t714J1NgMgPZDsMVDVo	3922	5536	5536	1616935680000
7591	3NLUJZM6NSXz1tECLqXdqvSjTnviQSAqiFxM8VvBa5aLaV9C5wZG	7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	1672	1285	87	1	6301	jwVwJKgFMPkdmkhJjXsBTzxQL6mXHzLZrxdfJWSrFfcnfvC1hay	3926	5543	5543	1616936940000
7593	3NL8EzVHyer9ENQ33df7gLUcZsxxxaySy5TV4qzSqVtffWh866dU	7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	1489	1014	87	1	6301	jwAPxxp22TZppFt9J9pJQEEmv3fXounvfcbByHRfPCRR5DCWQk9	3927	5547	5547	1616937660000
7594	3NLaF6rJWZyqvHsFpsZSzdUkZNqkAfyKij6tfmw4GCEELjKNB5w7	7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	1529	1190	87	1	6301	jwjwSUb3y2mWDQruWTVLnEhiS2qPuxMqiNB8acwxZwe45PDTKac	3927	5547	5547	1616937660000
7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	7593	3NL8EzVHyer9ENQ33df7gLUcZsxxxaySy5TV4qzSqVtffWh866dU	1589	1160	87	1	6301	jxf1LSqYgKVYKtAGSTHeTxQn2GW6vCxRJwWSUKAsQBVoFG913Kn	3928	5548	5548	1616937840000
7596	3NK7jRcDib4sFLCYTk5E6JekWyWHXVFFpPJGuZXXy4wWY8HzmQMU	7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	1622	1356	87	1	6301	jxBiQ7QcAnzEBzkZnhRoyYgu6DYufZ62e7NbQNYJoDFSSGYzKPJ	3929	5549	5549	1616938020000
7597	3NKhwtQtwL8VUNNuyYfSD2QwCphmTw7EXkSxSX2kbYXF9UnTAfnJ	7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	1607	1222	87	1	6301	jxe8QWGpA5QW3pDYjvg6UN5SPpsFSqXyfnLCDMMu7dXftdc2zWd	3929	5549	5549	1616938020000
7598	3NLNG9vMWK4Ge6AsGaZs1avUQPnzGAPXbB4VW6YCaxoNAZist37C	7511	3NKDHNLXn1tch9ZAhNDaeJyGy27SQfLYr76icPZ8bPjzGamd4n7S	1607	1222	85	1	6301	jxt66aep5U6TW8B8zzQEg3M8NpspxanaJ7hKeCsKvzWCnHiQVtX	3819	5549	5549	1616938020000
7599	3NKdXRjajopkuRsW78FvvdX4SsZAWJtZtETDKFQmt3AFM3teqoMY	7597	3NKhwtQtwL8VUNNuyYfSD2QwCphmTw7EXkSxSX2kbYXF9UnTAfnJ	1407	1395	87	1	6301	jxb6sJeTK2xgnE6hxoKCwftYkFKcEbUpAFuQQ54FyxC3BQSoWTS	3930	5550	5550	1616938200000
7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	7599	3NKdXRjajopkuRsW78FvvdX4SsZAWJtZtETDKFQmt3AFM3teqoMY	1593	980	87	1	6301	jxy9isywc7cpEwuxF7KvUqNCXTD7aCoQnUZwJL7zNCwav7bEBYq	3931	5552	5552	1616938560000
7601	3NKZhrPeC2sPu6B2mJjayLdMzXkpzyBnR75f5vYLUnCBbguXfc6r	7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	1406	1393	87	1	6301	jx6Xk2guweBBiS58a8SFdFyhTkfpsx15YUp54r5Ktodh6sUoJs5	3932	5555	5555	1616939100000
7602	3NKkqHDyt6jG8z2ufxioVd9Wi5vAWsYRNUPTsiz5jYQqU92o7LE6	7601	3NKZhrPeC2sPu6B2mJjayLdMzXkpzyBnR75f5vYLUnCBbguXfc6r	1646	1108	87	1	6301	jwmqBw65cLUNnq1MMD7BQNt7upBsBPjxgxqFYbZqxJtGwNhZioC	3933	5556	5556	1616939280000
7603	3NKD9pK8FtjMakxJHjDbKaHaKnM6SpAE71NAz7MJkzrR7vUtFv4x	7602	3NKkqHDyt6jG8z2ufxioVd9Wi5vAWsYRNUPTsiz5jYQqU92o7LE6	1543	695	87	1	6301	jwpS6XXrm7Ef6Pmb7N8A8z7nkCgnjgRTnAwEzuN8fZbusVUqEqo	3934	5557	5557	1616939460000
7604	3NLD5b32t7Yb4DhjHA7pKcsruA6x5AqqDMzzHFjYrAux26kPcAc2	7603	3NKD9pK8FtjMakxJHjDbKaHaKnM6SpAE71NAz7MJkzrR7vUtFv4x	1602	1369	87	1	6301	jxEQxt5xRZYnapo33K6rGnDeKc82uhNQ8KA2Cw9FX55tgNgA46v	3935	5558	5558	1616939640000
7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	7604	3NLD5b32t7Yb4DhjHA7pKcsruA6x5AqqDMzzHFjYrAux26kPcAc2	1419	814	87	1	6301	jxz9buig7Pvrm6jXAbruAfzMaKZ2WqLjnEq4nD8qvpRGYgrPXp1	3936	5559	5559	1616939820000
7606	3NKFwmfjPsXpEWS9Cjf9sL4nxjzj5ion3gbtidR3A5TDSmM6vC2e	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1405	867	87	1	6301	jxcWvPJxNX3pyY4uSFzMT9fMGAT1Zv9betEYCwQZMFYWNoER2Aa	3937	5560	5560	1616940000000
7607	3NKk7M76ViMQGsGMSXTzMyK9PLqRkDeQm8BZBvLxkb7yJpyuJ3fh	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1426	998	87	1	6301	jwZoEABmDDhGakTBaS2ybQbQ8eNfV7P3dC3rmGzFLvxWrXGCV1f	3937	5560	5560	1616940000000
7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1426	998	87	1	6301	jwysh6jU1GjUDn4sjZoJ93Qj3CZFeCndwmEgAjUqNRtexghfAyY	3937	5560	5560	1616940000000
7609	3NK7HmJRsVpJdnLJPCvTmQwQ5sDhqFwNRahZBKqti6piKbKKkcKx	7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	44	1079	87	1	6301	jwyJZbsPeKSjBKJBZQEBS5JwBsWhNs4Rj9qGtYSLo77EwqSgXqS	3932	5562	5562	1616940360000
7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	44	1079	87	1	6301	jxhmAuidgrh9hxvpaKCCaEN1QKe3RRJ18G8Dk4m6LAkboGgPzS6	3938	5562	5562	1616940396498
7611	3NK9B2g7iDAy71s2BYacxeXhQE6JqYpL5KjidAAN7M1GDeYFsUUt	7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	44	1079	87	1	6301	jy1BUJUi7vev6iHsEJUNDGrzt7DVZi3vnp5zTLLTTHLgZJStFyE	3938	5562	5562	1616940360000
7612	3NLN8nLwvM2sKtPhK68Ag3q1WUYWpRrVtEzQLg7HTkFvEorSj7NC	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1579	1143	87	1	6301	jwhwWpkYBQjGeECMDnRwHd169jefGyf2LfT8ZkRRipg7UbU4Gft	3939	5563	5563	1616940540000
7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1651	1055	87	1	6301	jwPQBJHaW8NJpqz3eXpkGhjQSbpkmus9fsEQ5tkqzTXpwihtF2t	3939	5563	5563	1616940540000
7614	3NLLETM1LnUUeLJ6r4kx5bJFo7nTqeNWGpK1YgUQJQ7rZApBwKzN	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1651	1055	87	1	6301	jxucxaQa6kChGdXecRf131dVJMRxSfDQm1ndZ7Lgy4daDYvYv5s	3939	5563	5563	1616940540000
7615	3NKb2djVTa9x74jPEB6jiCABuxtqW874tafJcHqSMJ9csbfHeL86	7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	1637	816	87	1	6301	jwdBuLR1f2tii6cBCeJp4AQyscDiyvrbxP4SUFm6iAtatxEwtqt	3940	5565	5565	1616940900000
7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	1407	1395	87	1	6301	jxY2xGLNQvRRAnF32H5qvqgXt92BJj5gPLPc8biL4c2Q8K5Hjqt	3940	5565	5565	1616940900000
7617	3NLvL1b8Y4929wY6k5zAsppfCbxBrc7DA2BU4rCW9sDcLwe8ZumQ	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1489	1134	87	1	6301	jwaDcpJdag4aVhhFejjUJmPu9B8awHzH5g3v2CwD8yKaehybcLE	3941	5566	5566	1616941080000
7618	3NKE8qLm2jzf31DCrCzsqshBZTuf8vFhW9tKzTLRFoSfuES1RyTp	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1489	1134	87	1	6301	jxrV41B7qZHXRYTeUuFwSeNnDFf5PvD4TfxAzaM87z4giPup8Yh	3941	5566	5566	1616941080000
7619	3NLEPc2PjEFNpUF7jfqVvuwDequvaZpRrLd9YyB8EHkDx9xRWSc3	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1488	458	87	1	6301	jwYhYa7Yj12aBPWNY5jfvAQursuMbHfUxZk2qF3nGuiA51JrFay	3941	5566	5566	1616941080000
7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	7618	3NKE8qLm2jzf31DCrCzsqshBZTuf8vFhW9tKzTLRFoSfuES1RyTp	1589	1040	87	1	6301	jxRB9pJMvJmgj9xCeZv9oQohdKc7MPdRJwZEKiHD3gn3pBQGYE3	3942	5567	5567	1616941260000
7621	3NKh36DwGzNQF8GKZF9jkq6Pr7HJKEaEZqkYW6j3HR77vk3dhM2d	7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	1518	833	87	1	6301	jxEnQe6eFgYxpjQ6eFRZfQdt8scirXSe1qxtgCkPMECczpurBz6	3943	5568	5568	1616941440000
7622	3NKAkPvLuNduNgxB4gNqaCYP5oEkHKuV5hf8PpFxm22bJM5dMP7u	7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	1518	833	87	1	6301	jxEnQe6eFgYxpjQ6eFRZfQdt8scirXSe1qxtgCkPMECczpurBz6	3943	5568	5568	1616941440000
7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	7622	3NKAkPvLuNduNgxB4gNqaCYP5oEkHKuV5hf8PpFxm22bJM5dMP7u	1406	1393	88	1	6301	jxH5uZQmeCFhxw357t2hnD1jbJB85bwmSU148LmrKJUQ8qUtKif	3944	5572	5572	1616942160000
7626	3NLc59DV4p8qR7dj3qoD69Bf3q9kxavgqEeojQvsV9RtbjczWinc	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1610	948	88	1	6301	jxqrCA6Rw58gYNfmMVLSSddQu1u1CoRoeaLXWvCN6ZaEhudLBY8	3945	5574	5574	1616942520000
7629	3NL4dzjdAAMXNnyErnFDnrFFWDRpV4f29J8YiUQquCzzGjp8RZg7	7626	3NLc59DV4p8qR7dj3qoD69Bf3q9kxavgqEeojQvsV9RtbjczWinc	1403	823	88	1	6301	jwoZYwo5ac6xY5EtFddhdk9RVkjR98j9NpwgyFX7XXtTV3TTy2b	3946	5579	5579	1616943420000
7632	3NKRk4kU8SUATocmksPiUbSaXFyoCLQAWiFoYxtaDPUJTPLHUpj8	7631	3NLKyf4mNA9YsCbSFRbbyAcvMeFc1M857LWWi6h9LZ3PBaNZDNDb	1573	1318	88	1	6301	jxAfydhBSzfSBYmk8e894rn5jd1LDfSfMVccYyrEACkticwuFRv	3949	5583	5583	1616944140000
7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1483	1276	88	1	6301	jxQYWG3JjAT6guxoyxezirkXp6Qbb3zPQ9LU3tTHf5Vd4RwBv87	3953	5587	5587	1616944860000
7643	3NKhqQGLChftY1Wxe8fk3rJW26axeK2GGY8uXh16jeyPfXpJWAap	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1476	1245	88	1	6301	jx8thoHPMbAC13VMStRdEzn8b6kH3BihArXcHP9DmMaHtCGku8K	3954	5589	5589	1616945220000
7646	3NKLk9GvMe4LwsN7Css7Ta4T1vX4mK2sQtDWg2f2Hw81hLSULYCt	7645	3NKn99YKQadDG1j9M2L9GwXm751oSFnjVQDkNk4ppLh52MxY8Z58	1608	1289	88	1	6301	jxQa1zhEyEU6ihGxpseEefP7tkMwkVevvfS9TXjQZuK96JRVajs	3956	5592	5592	1616945760000
7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	1631	794	88	1	6301	jxaiAi6wBqRhX6TMgaiAW44i7pE8Ce3RKd6WuL3y2zjKu2XUzcP	3958	5595	5595	1616946300000
7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	7650	3NK3YYuBZocqcU7GSEqDWRsoXbQSVEBbZ9oxUszW6GWVAjyvwyde	1607	1348	88	1	6301	jwKNt7rbXmfQ5E98yoL4JwqysFp7JFiqtD2CKd5iRZN6jijwtDc	3960	5598	5598	1616946840000
7659	3NL4eycTYsQ98gSNNrjvGGb3E9aSqTUEyJ1tqfEANtjBpBrwkCGJ	7656	3NLaowzww3D3q9NQ2hmUbVGtM4rwWrr6pdEqv32p2aLAfd6GokHp	1654	1094	88	1	6301	jwUyKPbQKVre8hTC8ZbYRozBZ8DsM5P5JdU1fyRRxzZsXV76QaU	3964	5604	5604	1616947920000
7664	3NLpZsX4sAYoCoiZwJ3itX2spaAW4etdSH6Qpnmvk76RnKjooqkv	7662	3NLCrqv19naxw74MueonYq2TkBByvTGJeDVh4XHnKhW4BiDXHxHo	1406	1393	88	1	6301	jxXpHTpKCyQkhSB9YuJsupFTghNqrinqtJFu8DtZJwqHHTupMsp	3967	5608	5608	1616948640000
7667	3NLcT2Ek53aP1mh43k1QfHyKPkXtgzQ33QXsjsVwTJgArui9mQEN	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jwdtMjjZq4Mv3QJg6zbKqr6KwZrAb7XhG7wdYPdd5qP27YCfkoM	3969	5610	5610	1616949000000
7671	3NLdy4gfCVaNffUA7JeSJoMYSGqRT6oU4wcAwGcoKJqGj8uHjNYz	7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	1406	1393	88	1	6301	jwVgwoouWpCJ6zZpoEPEyoJ8HMGPUhY5adFLryXtVz8P9uLASLH	3970	5611	5611	1616949180000
7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	1624	1334	89	1	6301	jw89mniZRskTNug99Zve4PbUGGUtVdiaZcyhdMYWQcSEm9kw4v7	3977	5620	5620	1616950800000
7682	3NKLVT1twEobpHnp9zQpG6qYBcTnC5tXNXnourfXYHK3ZpQN6SgS	7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	1406	1393	89	1	6301	jwtqkVoJ7EHoqD9u5ayBDuTufVevj1k7rL9ffggq3VnE1JbZ3CC	3978	5621	5621	1616950980000
7687	3NLmeGwng1pGKbNjjoEW6cViWQ6XvStkpgxSA9ytH7EPtfWvmbai	7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	1657	1098	89	1	6301	jw9NNZobMgaokePdPKEdqRcceZfndv11kp7kj7HPsB8FTtvZWqU	3982	5627	5627	1616952060000
7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	7689	3NLj1FPQhMB5mF9ufzLEiHQ7GX8QrR4UU4VQQEiFRzvHvb5hDx7e	311	1181	89	1	6301	jw6peFrW7k6R31aCK64nEZcALKm1ydTpxFfQBbTdGwECmeQpAem	3984	5631	5631	1616952780000
7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	171	1128	89	1	6301	jxTgCjT15ho1rEGJK8XAbi5MnM1RPuL5ouVj9M5dVibxtWZ8mfP	3987	5634	5634	1616953320000
7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	1573	1192	89	1	6301	jx5My65dnv8yRGdbFjT8akAfEjSRyWErNAT1j76t2GnFJ5DsYH5	3988	5635	5635	1616953500000
7700	3NLn5iZGPE8KDBSyqCVx8qtVdtLy7Xz3AJG4YrkrQnejqqsdbyev	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1406	1393	89	1	6301	jxqyeFHPrLdNcqEvfzaZdXsmDRc697FnaThMyPxdrH7Ebu13SAK	3989	5636	5636	1616953680000
7705	3NKD4D2uANUyFFU95CDfzEX1axYV923LGwp53EACavj5NgbiuKjP	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jwknvjcRx9A7cc7awv29GE6QuKxpt2zxUQ6DRvD46m1wiDBbQQK	3991	5638	5638	1616954040000
7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	7703	3NKYUEts4BPzENowJSRaEjT1tRRQxe8iV84keACM3z2C2ZQrWWLD	1668	1370	89	1	6301	jwkFjJ8MeXrvMAyWmFxLLoc3bbKHSc42mgxfG8JATrotcqe5jQg	3992	5639	5639	1616954220000
7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	1637	815	89	1	6301	jxo7hgoNciRHQ6v7agbpnXW9Pv1jrnJ1u3Up82vxBK7xup6G1eu	3993	5641	5641	1616954580000
7711	3NLtnWUtmiGMNZLvKF2ZQCpAeTnKG5SGj74iEEMvYec8k5j8xwP7	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1405	881	89	1	6301	jx9ncH48nmnL9ou1FCoWkPHVDa2vSf1V6DZrvvfjJFYYP8WkGJe	3994	5642	5642	1616954760000
7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	7711	3NLtnWUtmiGMNZLvKF2ZQCpAeTnKG5SGj74iEEMvYec8k5j8xwP7	1467	1376	89	1	6301	jxWwfr3GFEqYv9R1WB3vnBr6ZNBreXP8my27EycYncaJJJCYjix	3995	5643	5643	1616954940000
7718	3NKLyhiB3FMwF5x429H4w5pDsBRPRERiiK2NC9EG4aH1Cj9RJvvT	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jweajMMEciWGTEGfddc1azX5LkYrBe4NiBc3nA3mT1peEyjmvsH	3998	5646	5646	1616955480000
7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	1405	873	89	1	6301	jxs7JbBVUxgx2RBao5p89QtX1CHWuL4JRRR3A9Z6MPadiC2ndJp	3999	5647	5647	1616955660000
7728	3NLYuVRPS8edVexYe7Gv3HXJcSehBjfwZnW2SeTUJPtH6MsVntb6	7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	1477	1350	89	1	6301	jxKzmVGTXhqgnYsi8JaJ7GaspZgzHVvDbnuuwWPfjVZ5Lkzxc48	4004	5655	5655	1616957100000
7730	3NKPc37W4Vi5m49CQUcStp8T19DZMAhpjNAkKZa3jBxg8KDoSrzR	7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	80	1273	89	1	6301	jwTwB1QAWRWXeeeHWwBs7bBRFpTdv71wxk7niHqmQQwKUHA11jE	4005	5656	5656	1616957280000
7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	7732	3NLTh6rPGbgxvGUPbMKYb9eSqZAFZSYxHugmEQbxu9xyfcnUb9Dq	1500	1297	89	1	6301	jxuYhvfLe3VJ1MU18kDsJyEPALTZ3ikQazSfCXTKEyus26yCBev	4007	5660	5660	1616958000000
7738	3NKwv55s1CQhcvooVsetidQXuQ6pSEWUnQ9CSxAmbHNDoJ3Pucqm	7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	1647	936	89	1	6301	jwgHBhWXnmeJfreThEKApxuQCQx7jwC3VpFCPQsuDAnQ8XSag2W	4010	5664	5664	1616958720000
7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	7741	3NKeFeaLs1qp1n9aoebBLNqst3HpVULix1r5A66HtFc3Dm45NEw3	1407	1395	89	1	6301	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN	4013	5667	5667	1616959260000
7624	3NKypNxFntkuEEKxdtijn1KE2u4KaTkbLeZck27oAWReKJ4X8ibg	7488	3NLENm4KKXUnW8LcLFZbtUu9bD2qAMYY8PzGQop9vPL5ZcCxCcNG	1610	948	86	1	6301	jwddNjLAKtsYsXLfdW6MGdq9AvCALNP2tbPkF9oHzGnfAV5L9jN	3874	5574	5574	1616942520000
7627	3NKx6QkGUWzh3PkECTA2LCqcXCdhAipkocwfZJzgFYnEmBmAkyTz	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1560	1045	88	1	6301	jxT9TGv7UQxLypHH4ixwBjdDRktBpuqHoB3fhpHJzSfWJHochgB	3945	5574	5574	1616942520000
7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	1476	1371	88	1	6301	jwLNLvwwRv878b3u2szK9EtjJJW3fd6nW9JrpnLwsbAeEs1cwQd	3952	5586	5586	1616944680000
7638	3NLhcfJm112NSTj9341Yt5M1b9kBEYdsjKS6XL4uYUzyAKqjVymS	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1608	923	88	1	6301	jwCoLbUJm8T6KkucEtnkmYqat91JdoAJyvAcakdfHKM8ZbpFQKV	3953	5587	5587	1616944860000
7640	3NKYJpETJUVKcgYK4BJfM1zppNGaefteoTMkp56EHKViy3d9zJMZ	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1503	1031	88	1	6301	jx7f2S71TSSiUsL3HsyjdRW5hgNfz9rCH22u66mkXU1gjmnXuEo	3954	5589	5589	1616945220000
7644	3NKq9a8uw3gSWQQ7RnZz7C3BXFBJTytmH7XbkgWNYa7Wr8wLb3oR	7598	3NLNG9vMWK4Ge6AsGaZs1avUQPnzGAPXbB4VW6YCaxoNAZist37C	1607	982	85	1	6301	jxTp2giY8fYxG4wuhzJQ8dKTv49FR6MgJfyd4zEe7udFr232amu	3820	5589	5589	1616945220000
7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	7646	3NKLk9GvMe4LwsN7Css7Ta4T1vX4mK2sQtDWg2f2Hw81hLSULYCt	149	1283	88	1	6301	jwcF6y3qsPFv8kYRe3BJxZVHmUqTbZ16VuUE7tvePHFcjGq8DUr	3957	5593	5593	1616945940000
7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	7653	3NLg2zbrH2qQrN8VQjzz9aGGa1n48ijFt9cz2SAyaRVFfi6wsVrN	1503	1277	88	1	6301	jxHHjUbxNmHj1vK3wya2p4U8bC8BEP53Hw2YoyJ3xiU1cdbpYyQ	3962	5602	5602	1616947560000
7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	7659	3NL4eycTYsQ98gSNNrjvGGb3E9aSqTUEyJ1tqfEANtjBpBrwkCGJ	1402	874	88	1	6301	jw7RQLUPDQxFJx1KSba7fgnDaP5xFkZbNpXAEEGQZ2qimcJ5jtP	3965	5605	5605	1616948100000
7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	7664	3NLpZsX4sAYoCoiZwJ3itX2spaAW4etdSH6Qpnmvk76RnKjooqkv	1596	1363	88	1	6301	jwWKn2SPNopyBPdVG1Kfnt67BFxwcm5P9NyXJqCoEYzkxG8qKs2	3968	5609	5609	1616948820000
7668	3NKVuoEFUa4xAB1cimawi5NFT4DBx18FYsr5XfhaVBafRjVevN4E	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jxKQntZzfpPiQ8UDCHCtgpsKGPWcxryvzgyJUkktStjMgWfNUdb	3969	5610	5610	1616949000000
7674	3NKm5ttUwRAbWSJCQpsE3Dxq5d9nchXQRf4Qs5Jc1LAw7XA2JWzp	7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	1501	1234	88	1	6301	jxhwqnKmo48wskgQWpgXuZyT5UANAV5nKybctRhC3Z2KXUme4Kh	3973	5614	5614	1616949720000
7677	3NLbcNHVNroG6bizfiHye5bLmnx1cmsFnFNJEYgv5gegwVmLBYpA	7676	3NKjiJgvCS1gSoyitVn96PKSVcVLg9TK7A5MsQDHRFpXRiwFBkuA	1467	1250	88	1	6301	jwTtGpN4VtQ9ikSWBD1zMeifBwrRUXJFp7XTx2QUxmm1A6peFde	3975	5618	5618	1616950440000
7685	3NKDzZgG4NupAkULwGSZPBxZKvSefW6X5pPTbmizEaBAL5FxZHHQ	7683	3NKaAgYR6kW2xGZ13jX1xnaJvgNz1SsZ8yVHDLb9v3sZL7wgF8wa	1447	979	89	1	6301	jwpJrFoXQDrsooQtqaUtsFfGHm9o4xcrbvpsz4e4sZRGUZYDeKY	3980	5625	5625	1616951700000
7688	3NKcmJpGYyxihuVm5JzTsnWW3iUxTjtQa6RY4RPDVJ2YVa8k6a2a	7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	1481	790	89	1	6301	jy1JbsaLAxmwvwMHXRpuLyEjPfRoRyLmZo2uFvQfpmiWRra6zVX	3982	5627	5627	1616952060000
7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	7691	3NKmtw9uiWeLg4oSGbbbMurTeZa2iyULrNoxiPwShWDrFpkggAQa	1631	794	89	1	6301	jwYzVLbfEQUpwB1zi13YH74NEYTC88XgTYBxKEEF55cbB45FkoV	3986	5633	5633	1616953140000
7702	3NKs2ak9NJ8LrPVVAfp7YsL4G69Bfap1H37imL3xKDHYs7bMeF5U	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jxpVSaudGFH2vAGCURXmwu86E2Aupx21BmPZFzFStFd4mZPHT4i	3991	5638	5638	1616954040000
7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	7714	3NKpBDEtjHY2wCv3BdnTJ7oGKwsmecVKyYamtq1s6FhmDyccEkLa	1619	1149	89	1	6301	jxspJyLFvkGiqi4itwMSzSNRt7gjKMTvPUT664KNMJdr4EoARKm	3997	5645	5645	1616955300000
7719	3NKv58ptjDqnik6cc5PCVBdHaYVdTf8tgXwF7CKxveGRuAqUNpJa	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1461	1271	89	1	6301	jxKVu5xvJLi68PucWiNMkH1VF4NNeCQJtzX8ueNtgURjkmJvdDY	3998	5646	5646	1616955480000
7723	3NKGrXzsaYPCCs6QSdVzexfvwWBsxmLE8PJvEq6dM61QZz3S1k8g	7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	641	1090	89	1	6301	jwqJvYcx4meBdziNVphHU6NGbYEi26LFZAgTvSJ5RDcKER6EVHQ	3999	5647	5647	1616955660000
7725	3NKv57G44Ao1XY9HazAWDy1fueBecRvkwzv9uCxe7nt4BhMCs1B9	7724	3NKeQrvPeZwY69mECXscxUhWy2f1irWRuWs4MXCpWA2SVDRsNDXr	1403	31	89	1	6301	jx6274zuuKgk1sdqNn1zeXKTxXYftPa9mLinJvLWLNk7XwnG2uL	4001	5650	5650	1616956200000
7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	1613	1103	89	1	6301	jwXFfB8iXNebCVjhL6a4iH9jH396mzxd5eR4nWHj7fFhDh24t5P	4004	5655	5655	1616957100000
7731	3NKyq5oH8jjsZiW23F5wq2gvUfW1arfesKW1xFSD8opqzfQrR7zo	7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	1406	1393	89	1	6301	jx97WgUXUdwTvn1knVPPPXBmgq5N2aonURKRjibMmZ2oKYH879K	4005	5656	5656	1616957280000
7734	3NLZRGKvrkCkU2c3uTJkCuz3okGJYp9YzmJLBo65KnxmhwtTtq9u	7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	1439	1033	89	1	6301	jxCmcxLh4MsRqDYQ7Yg1uzdy2pMkMmUPiU8D6VcumppyGUx6uGF	4008	5661	5661	1616958180000
7739	3NKicgb77cv3k9PqRFDCw6rjauxtewsNf8QtkLESHAuWxjfQnchZ	7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	1406	1393	89	1	6301	jwk2ArMZXyn9mSMHp4KYMBAMp3WbWiUbYaec4TqiaC6btkUfkv9	4010	5665	5665	1616958900000
7741	3NKeFeaLs1qp1n9aoebBLNqst3HpVULix1r5A66HtFc3Dm45NEw3	7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	1407	1395	89	1	6301	jy2SQfq4pnWNN2NEN2eJWsBtzcbJdpPPyxqMomGSvrBw9Zw2EVN	4012	5666	5666	1616959080000
7751	3NLM4254hjJZmSmhqHShVcPLGc4ca7W7u2BpuEik19P9BV8vKqzE	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1547	1132	90	1	6301	jxPTpSayCgMPpuEKecRQ2oBoadoPjqYgEsQHU9tjHvHNAx2hc2B	4019	5674	5674	1616960520000
7758	3NKaLSGgbMytZskTFnQj2fys7kMz26zS9hUPBpNDmMkHPHbfjqfG	7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	1403	824	90	1	6301	jxMn4SS1Q2NdqJwTrFu8pKS4kccniwxveiKMm5ATCd1mNN92ryK	4022	5677	5677	1616961060000
7760	3NLrd63JLGqUFkNeF2Uo9JGGmmLiPykKMaoicZDBhWKs4rHT1owf	7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	58	58	90	1	6301	jwPrUfQaThSTDkbJjomHQsXyQ3HjMrwMgGtZUrLJcuy2hnN15MG	4021	5677	5677	1616961060000
7763	3NLmgXBEPEWj3rAQpALNSSdKDZCvH8R49ixdoGPGm6Fbq1AgXTxu	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1403	802	90	1	6301	jxGrb1Qq5AzDZDde5FDDfCwprfQeZErezNKHwyjvE7WxBxmZQEs	4025	5681	5681	1616961780000
7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	7768	3NKLrhiiJYr8Afukk6xRVsnicbWhCFHm9pDM73nXmVapmRVrHZFe	1631	794	90	1	6301	jxhTsS3yV5XpPCzrALK5mzcaVfcdNm7NLBEQ1hJ6MtqnAqd71uS	4029	5688	5688	1616963040000
7772	3NKkqxPKX4TVKxD2P141KtcEunUQkiRQ6tok6bauyUoBpH9WeuWL	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1675	1342	90	1	6301	jwsTw2reZsgd5iPRtEuKNieNPnfTuL1i54qPqFQZuJfzCrkc3cY	4030	5689	5689	1616963220000
7625	3NKMBZ9GCsw6sp8J4N1NEXf32T2RbdJdnVbUwas7bassS9dWQ5Dp	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1579	1263	88	1	6301	jxgPELWCSyFP7qPn9wrzhkq7CjpUPkv7wYnvnpV2v5dxqUibjvx	3945	5574	5574	1616942520000
7631	3NLKyf4mNA9YsCbSFRbbyAcvMeFc1M857LWWi6h9LZ3PBaNZDNDb	7630	3NKqhaEk59GqSdGwmJtSEQ77rBy7T3JcwsuuedqM5KiPyunR63j8	1579	1389	88	1	6301	jwdSVTtVDKZaoTV9hdGs2qKPu7usfd3EzU3mW4RdaQfnG2Ttnja	3948	5581	5581	1616943780000
7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	7633	3NLy61sAD2TgwN9p5GwsQe59BmsmcsA3TNhkr3bafKocaPhev5pi	1403	782	88	1	6301	jwMjhEvJka3kQ8jicTCxGakw6vN2NwztirKodGECveJrfh8AF91	3951	5585	5585	1616944500000
7642	3NKwMTDe1x8LsbBukK9pdZtXDrqZVxRds4L8dsxfNQKnhoJjDkSs	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1607	982	88	1	6301	jxyehv7VhCiVJ7kGVY7Lqw25e8KWwHs6mKSbZUEtZZGWFzT8Ew7	3954	5589	5589	1616945220000
7645	3NKn99YKQadDG1j9M2L9GwXm751oSFnjVQDkNk4ppLh52MxY8Z58	7640	3NKYJpETJUVKcgYK4BJfM1zppNGaefteoTMkp56EHKViy3d9zJMZ	1406	1393	88	1	6301	jxAz9JUJURPX9g5FZ96L475RL4qc5pgzVgBtmiw12y5shcJqJaJ	3955	5590	5590	1616945400000
7651	3NK8TMUr2nHQbDWkNP7b8UP13sJnr1JtiXpVzjt4UDVGTYkcGAgk	7644	3NKq9a8uw3gSWQQ7RnZz7C3BXFBJTytmH7XbkgWNYa7Wr8wLb3oR	1607	1348	86	1	6301	jxqzQy3metmnrt5isKjC9RQp3Vz1wJTYWQHaLEZHs6STvq1M7ok	3821	5598	5598	1616946840000
7654	3NLrswjomW2xjubFtk23YugkKm9HwkABZBuYNp6o2AGn1bs9eGfs	7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	311	1181	88	1	6301	jxSK8oRMBpNEw29hzn99ssmVRF2mRX1LxxD5BDcgh8z6foxxfxy	3961	5600	5600	1616947200000
7657	3NLUXFc3XWKLfEBH3NsQ9J5xn2VdFG5XNTpxGHPTX7WdWHy8259Z	7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	1406	1393	88	1	6301	jxGDg1nAW3ZQ9mwN2PG3vnKFwiCQ4633GhmEJ1raDHZaUrEZ66D	3963	5603	5603	1616947740000
7662	3NLCrqv19naxw74MueonYq2TkBByvTGJeDVh4XHnKhW4BiDXHxHo	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1549	1116	88	1	6301	jxtKrcA83mmCr6iGBdW89GPkcHRzKuxGmVH1uL2V82cqTFpTCpu	3966	5607	5607	1616948460000
7666	3NLRsv7cnmDivPX1HPKzkBP4iHZ4PRbxzyMZNaUk9XSodSeRPBUw	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jxPMoZbWBayeZVVbs6nBWF5q3dBYPGkyuQKqqUcwigtSHygP9Z5	3969	5610	5610	1616949000000
7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1613	1349	88	1	6301	jxwBeY6T5Sx4fzusJULRYiP1xidyAZu8DDVfnwXAK1AUMb1ou2L	3969	5610	5610	1616949000000
7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	7672	3NLGb78AxKcsEVQYd8vXqXFCvUEYgRuE7FAyDE9SQSjeEzqbJrDm	1447	1345	88	1	6301	jwWtddY6wHVDAK9jHVVqgshXW8XSFMkN61dgsVcLs9G42evn9Jn	3972	5613	5613	1616949540000
7676	3NKjiJgvCS1gSoyitVn96PKSVcVLg9TK7A5MsQDHRFpXRiwFBkuA	7674	3NKm5ttUwRAbWSJCQpsE3Dxq5d9nchXQRf4Qs5Jc1LAw7XA2JWzp	1596	602	88	1	6301	jxWFu9kqMX6EwczGxW8VehLgFrBga1eLxDb4Zm4nfN1nz5wYbs2	3974	5617	5617	1616950260000
7679	3NLsEgNnes7XReGLJ9NjKcTKyPPny9P2RzNLpRdNzcogLjZnEgj3	7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	1637	816	89	1	6301	jwWNtBRTjNdz2z8Y5Jr15mA6JQEMt4VXaJgCp7DaxNUBn2p37L8	3977	5620	5620	1616950800000
7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	1407	1395	89	1	6301	jx4wUKwsYA328G2Sapb7B7e1tyGSws8iajMn6roUEqtncPA8YP2	3978	5621	5621	1616950980000
7684	3NLmLEsUgFsZQ57FDfvjKEoG3EwpMcn2SKZZcgeMZRsF4Z9tuUAy	7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	1637	816	89	1	6301	jxdK5iKLJu5RrjwEo8mji8c7CrAQiBLvzMS8AoEKGXPEXvua3FZ	3979	5623	5623	1616951340000
7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	7685	3NKDzZgG4NupAkULwGSZPBxZKvSefW6X5pPTbmizEaBAL5FxZHHQ	1617	1042	89	1	6301	jwsSNT25BncBLFhcspwpCFXFkF6TaNxzS1M8sSVZQWbSZdV5L5Y	3981	5626	5626	1616951880000
7689	3NLj1FPQhMB5mF9ufzLEiHQ7GX8QrR4UU4VQQEiFRzvHvb5hDx7e	7687	3NLmeGwng1pGKbNjjoEW6cViWQ6XvStkpgxSA9ytH7EPtfWvmbai	1397	828	89	1	6301	jw9Y8Q5tYh7SHM2bu7gZo9DjeRink8qZxGLBzS2LEWnywF44hCc	3983	5630	5630	1616952600000
7692	3NKcNagokH89fBVKRLgAnzKNMCaoVzpu3GtW72wvy2Hd8LiLBpJb	7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	1503	1277	89	1	6301	jwKYe14G3GVSywxqiJAc5airxxV3cPXFcVgKpC7Y1ybwyu1UgQC	3985	5632	5632	1616952960000
7694	3NK8saw2hCMgzNvJrE5kv2UsZ5wF1q4L2BMJZpiYGH2BgUkKjP4j	7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	684	1352	89	1	6301	jxzXtG3MKPGDsPtFr34eT71ktFNeVYV5wFznTj5fYHdBdzFN3yp	3987	5634	5634	1616953320000
7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1585	1240	89	1	6301	jxDicD1po42bXEgeyUZ2uqSdXo4F5hF5JTbkyXmm3CsaxhNsVqP	3989	5636	5636	1616953680000
7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	1546	1339	89	1	6301	jwKL6C3sf2ojgCmfopN4irKgGGfR3sHvZAtciFSzytUowwrg9Y9	3990	5637	5637	1616953860000
7704	3NKRcjBuJUSci1dUnsmkqKdZR9UqEdwKz4Nd4KBfuLDyZGy6pJ3M	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1672	1039	89	1	6301	jwnzupLiXx6dAvvobbRASe9XikGSk3cFWzS7iyzrK5TptXMjZbt	3991	5638	5638	1616954040000
7708	3NKmF1s93XJKqPu96QNQujotta1Suyvj2agKqFnRRtaMTrE6APJk	7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	1419	814	89	1	6301	jxk3fcb6GADMVq7p9thNKvQcgRaotkp9bTszyB7Sc4m7iRUkZ8B	3993	5641	5641	1616954580000
7710	3NKZ2U7kcKJFLWgpTxZxxvVxkKWPQQEHFVRZzoMuWJQmj6E77h7K	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1403	812	89	1	6301	jwcvX1jid8hSP3QdBjkM4iieMhS7eeMad3mB6upQchvL9BFJ71V	3994	5642	5642	1616954760000
7715	3NKqUtBbwzGQWNDZHkWXEx6KDJyjWvoz31DwUwFV1PzgCq4scywu	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1406	1393	89	1	6301	jwvtDkJ4R1xtDmf7BNi7aV7xLH371i39bjg82L7CfdmyD1hvwNQ	3996	5644	5644	1616955120000
7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jxViD4Uk574KVTJXF9eYCfqYCgYKHBGsKcBhSMj6SfnKGgfNWPh	3998	5646	5646	1616955480000
7721	3NKT6obL9FRJekv7gmzm79FZZF5HBuAp2w1zXMFLmT5hcnVvMq9z	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jx7LJwwVCwxw2R1bg628z3FbeUAgzkmDbnoruvsMHKBuJYVLN4H	3998	5646	5646	1616955480000
7724	3NKeQrvPeZwY69mECXscxUhWy2f1irWRuWs4MXCpWA2SVDRsNDXr	7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	1631	794	89	1	6301	jwnwgXoFWHNYTfR9oZkU2isoEuNgxtxqNsoyxRkTRKEF8G5LL76	4000	5649	5649	1616956020000
7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	7726	3NLCJtgusq162pidHAnvJAUxySvPNpZjwCVJkDYRFis1DPVdZTHH	1546	1213	89	1	6301	jwA5zPYTPYcGTbt2jxVR4Z7akX1a9tZXNdnSeJZDqWPwvnR1qyU	4003	5653	5653	1616956740000
7732	3NLTh6rPGbgxvGUPbMKYb9eSqZAFZSYxHugmEQbxu9xyfcnUb9Dq	7730	3NKPc37W4Vi5m49CQUcStp8T19DZMAhpjNAkKZa3jBxg8KDoSrzR	1406	1393	89	1	6301	jxRvmS2husvcNE15FHRCooj6BakxxFujtV4XonjijM3nwHCbze6	4006	5657	5657	1616957460000
7736	3NKfsiovqEQcrtvQL5stiq8HhZERBey9WJwUuP4DXGJk7EtCY9Nc	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1439	1033	89	1	6301	jwiK5aLBwvouz1z7HAL2oW8xNJympN1eWzrPM47uBaz59TPue5z	3996	5661	5661	1616958180000
7628	3NLK58aUowmbyj9NXdgibDZhXkSLZsPkD27q75tgjtj7GXK7h65o	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1560	1045	88	1	6301	jwqqwQTN8jLgzN5GuZ3x5QqR9CKAZ1Yn9CPiPU7UPVJEKJhjr16	3945	5574	5574	1616942520000
7630	3NKqhaEk59GqSdGwmJtSEQ77rBy7T3JcwsuuedqM5KiPyunR63j8	7629	3NL4dzjdAAMXNnyErnFDnrFFWDRpV4f29J8YiUQquCzzGjp8RZg7	1648	1284	88	1	6301	jwz43z5RRiSpnAgtTsR3kNHkWN2KN2xtdfGQALFV6pPGiBnFR7L	3947	5580	5580	1616943600000
7633	3NLy61sAD2TgwN9p5GwsQe59BmsmcsA3TNhkr3bafKocaPhev5pi	7632	3NKRk4kU8SUATocmksPiUbSaXFyoCLQAWiFoYxtaDPUJTPLHUpj8	1637	816	88	1	6301	jxCrhkrHtnRd1MMAczBetEdvNefmroGaLEyUFKKwVPjX3sKGRd4	3950	5584	5584	1616944320000
7636	3NLjigcLvW5nSFsVJ2ki6UE7PnUGipNAodXR2vmng6wDU64t4EbA	7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	1581	778	88	1	6301	jxCGLGXgF3eHwv6EvF16qdcS1PjaB5uBnuNHiUPcnEm5xstNT1r	3952	5586	5586	1616944680000
7639	3NLWavH2x4Vbd5YCmCjke7Fn7Qn8T3knBf3bAkWRv91BGmUSDeXs	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1637	816	88	1	6301	jxFsv2zoED2HFknFT3t6fHoDaRmYAQU1GDCA9qs1pn3Xt6AJPKA	3953	5587	5587	1616944860000
7641	3NKnjCFz4muihCC5vzvhxSuLFEPXEM6Zz5Q78fmCVkEWd8kLrAmz	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1596	997	88	1	6301	jw8hNXKsb4BGMAHgkBN58r8J5fmSfJmPPXKMRaupKCvvRfi1Mrg	3953	5589	5589	1616945220000
7648	3NLwRDeXdoHqCZresqNAxS64eQ9Yj8DzikSFn4j8xdStERoDbaQ8	7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	1559	1107	88	1	6301	jxz8stLSfyT7eoZw2Dg9E1ZmQ6j4Jg7AStkmrtPKCBcGhPM7srT	3958	5595	5595	1616946300000
7650	3NK3YYuBZocqcU7GSEqDWRsoXbQSVEBbZ9oxUszW6GWVAjyvwyde	7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	80	1147	88	1	6301	jxa3pmXyoZo9gBXZjdejuXnYtAtf2t32243v99FnxHcVW7Tzfb6	3959	5596	5596	1616946480000
7653	3NLg2zbrH2qQrN8VQjzz9aGGa1n48ijFt9cz2SAyaRVFfi6wsVrN	7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	1634	965	88	1	6301	jxB3sDiPDhjKYUrEcM9NsA63PmN4Cm33F1ywjxs1kWNw4m2z4nK	3961	5600	5600	1616947200000
7656	3NLaowzww3D3q9NQ2hmUbVGtM4rwWrr6pdEqv32p2aLAfd6GokHp	7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	1617	1042	88	1	6301	jwA9Br28D17BDjaoLaDQobDnWiY7AYgibfmP5JkznNvfcjKWmWZ	3963	5603	5603	1616947740000
7658	3NKskW9N5Q8NQmg2d4SgCYhq9GagHB8hbMTAiP52f9Dnfy6ajHEA	7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	1654	1094	88	1	6301	jxp9aoAhS7S8e17P1zGgQgxGRkaEydLJVjRYpvSzFFNVqdzaM4a	3959	5604	5604	1616947920000
7661	3NLdWoFLxZY5xawgTBgzEWudrzuzXrbTvYG9kKbhHiv89QT7FvtA	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1403	824	88	1	6301	jxWrX9vEPpbJQVGiDDt7mGtLGz8uARF8yLbpj1BzmFaZy57HTcL	3966	5607	5607	1616948460000
7663	3NKVkdZNjJbgMHb7gqRqd3RcB1wDcYigtcjTHxZVwyj7mZSCUmx3	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1467	1376	88	1	6301	jxFBzyiEuVKAoL4bUWHpb2kGBgvCUNVVqcyLSUCeAB3ziFd8gBp	3966	5607	5607	1616948460000
7670	3NL2XX1JcqYSjMdLRPwxiBQvRU359BTtnZdMG28HZa1oApizFpW7	7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	1648	1284	88	1	6301	jxpyt1ygsvBjQiwSPJnNtbzdwqQUzRCFKyYwrnuhixmVREMNVbf	3970	5611	5611	1616949180000
7672	3NLGb78AxKcsEVQYd8vXqXFCvUEYgRuE7FAyDE9SQSjeEzqbJrDm	7671	3NLdy4gfCVaNffUA7JeSJoMYSGqRT6oU4wcAwGcoKJqGj8uHjNYz	1455	1206	88	1	6301	jwFqt3h7M4HYdy9gHCdbbTuQ2NDt4RJEfgrbPC1V37gvW6JDHks	3971	5612	5612	1616949360000
7675	3NKiTmwFgpjfPKjZt6iYkLPTis9ptfNR2H9nddk1n8mECymHjsxU	7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	369	1066	88	1	6301	jxyeeaW4ydCK1hjVstgPpGMgrakBpSHUn2tKzSnjjFtb4n3KpgE	3973	5614	5614	1616949720000
7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	7677	3NLbcNHVNroG6bizfiHye5bLmnx1cmsFnFNJEYgv5gegwVmLBYpA	1406	1393	89	1	6301	jx8R1cWxS1h47RsTpaL5u6QfMTzWE3CqUKHCbjY4XSosDxemfNg	3976	5619	5619	1616950620000
7683	3NKaAgYR6kW2xGZ13jX1xnaJvgNz1SsZ8yVHDLb9v3sZL7wgF8wa	7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	1501	1234	89	1	6301	jwHPHtXhEUcYaNfejrX6LyK18akmXwgTzA8eJe724Zrkg1eZsW6	3979	5623	5623	1616951340000
7691	3NKmtw9uiWeLg4oSGbbbMurTeZa2iyULrNoxiPwShWDrFpkggAQa	7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	1503	1277	89	1	6301	jxv1JXyjgFCgoK3SCv4X2oDXjEdGMf3RhtvdjkRmaKDP2sRebKr	3985	5632	5632	1616952960000
7696	3NLXJi13LLNGrGADZedU1vmr6ygbyvsWTRWNHEDnqe6ZpiMbWbtN	7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	1406	1393	89	1	6301	jwixwcQnmH4Fmj6bhiDdRB2qRisWV3uAzNAAWPpJc3id66Vcetv	3988	5635	5635	1616953500000
7698	3NLyEd47WPKRLaNpUVksg7QWecNqUAsv7cSR1TAANYqAVeEdntQK	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1589	1160	89	1	6301	jwAUsiXftnrUVttfonmVTGjAHUyZnC9y2NdZSbGdXqEu3du54m2	3989	5636	5636	1616953680000
7703	3NKYUEts4BPzENowJSRaEjT1tRRQxe8iV84keACM3z2C2ZQrWWLD	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jxpoLsnMeKshr4pgupkvxfYrrb72KkNwKxAqRL1WmKSdwgEYXpZ	3991	5638	5638	1616954040000
7707	3NKboMgEPoMiK5vfkNrMLERFeb3TKfRqp1iWhRnv8Bg4GmUVUjB1	7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	1668	1370	89	1	6301	jxq3JtYW57sahyv7eQp4GodKKea7wS34EovM8c5gpdwGTbC6Ltn	3990	5639	5639	1616954220000
7712	3NLCy5JAPTXidARvKn1fjnW4uw1KRoUYcbVr7SF2CSRZg6Rm3QnX	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1631	794	89	1	6301	jxmtZxMdMxCUxPuR5HCvtUfCDC5y9Fay9HN4dyPPaXYvE9GtRGH	3994	5642	5642	1616954760000
7714	3NKpBDEtjHY2wCv3BdnTJ7oGKwsmecVKyYamtq1s6FhmDyccEkLa	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1585	1240	89	1	6301	jwHLeHF6LqUNPYz9xMWoqohpjozRbGSrb72NTTF5QRqgQMwh3Rm	3996	5644	5644	1616955120000
7720	3NLkqP9jBGU466eo5w5vyNcAUmsdoU9zAtoyPcCbfyeggDYJMVrt	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1617	1042	89	1	6301	jxjor34z9g1HazUyeTEyMwU2WGsmVivYoZPQuQbdSL6NHcNwJr9	3998	5646	5646	1616955480000
7726	3NLCJtgusq162pidHAnvJAUxySvPNpZjwCVJkDYRFis1DPVdZTHH	7725	3NKv57G44Ao1XY9HazAWDy1fueBecRvkwzv9uCxe7nt4BhMCs1B9	1657	1344	89	1	6301	jxZJgh7pFVGrpscquTsLCYTTJTgFCpVusFxbKMvhVchGozMJ8Ao	4002	5651	5651	1616956380000
7735	3NLgxW2CdVbXx9V63XgdkjYoJe7zFiEd8sSBx3A8GENCHa48Kckn	7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	1555	981	89	1	6301	jwGkgxS8VYwoiKYPLPmbSR16hdg9kACzpr9ZjpoixNkkGCxBbHV	4008	5661	5661	1616958180000
7742	3NK5bbmMNitaiZKqYDXQVE6QwweufoCVaRaioBJzjMd2ATZkq9qU	7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	1553	776	89	1	6301	jwVw98dU8yzzB6rJpSpkNbtmQn1HHXZuEaGAybxomR2xoD2wDwB	4012	5666	5666	1616959080000
7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	1406	1393	90	1	6301	jwE8uc8AM18niYuctj4ofAtrDYYU3DzUfLi8Shhxn3LjEqbv5pM	4014	5668	5668	1616959440000
7749	3NLKANXuPnn3tRMev7UWy1xAu5XGw6mroeLaoEgZDVeB7cR5xAXQ	7747	3NLMbtVWtJiosebZ4fZv5chj4GeRAzK7bpTBNebmudVb8aNEjRqS	1637	816	90	1	6301	jwV9GZE3v8w5auGmYTTn9eUdKyWByB2JADedwjRZKZAtvoqefEn	4017	5671	5671	1616959980000
7752	3NKkWAN5T5mgWLaUoDXpGYeK9JN8yfXiwZWoBzoL43rC26hb5fNW	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1619	1275	90	1	6301	jxPMqRgdwspz3Wf19pagW77QwL4f71NBfCs2gpRcDLNvmSVvGDV	4019	5674	5674	1616960520000
7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	7735	3NLgxW2CdVbXx9V63XgdkjYoJe7zFiEd8sSBx3A8GENCHa48Kckn	1637	816	89	1	6301	jxm1Wc7kXTzv8oyVhyXxa8cLXbeAFXrZFi5rxSLrRNxz2zdLAUt	4009	5662	5662	1616958360000
7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	7738	3NKwv55s1CQhcvooVsetidQXuQ6pSEWUnQ9CSxAmbHNDoJ3Pucqm	1541	932	89	1	6301	jwPaU66xhuHE5hRBDZtd7msYrG3SR82mUknSw4eBFH3dMUxga6v	4011	5665	5665	1616958900000
7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	1564	1338	90	1	6301	jxYfwvdtbAcJpoC1LtnpL6vWkJrPFYJVYnQX5tewoe5JkZFEJoF	4015	5669	5669	1616959620000
7747	3NLMbtVWtJiosebZ4fZv5chj4GeRAzK7bpTBNebmudVb8aNEjRqS	7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	1402	866	90	1	6301	jwwgwPVUP1TPztEMmYKHJNXTibSoDLbEeqqNwyiFNedk76swfyc	4016	5670	5670	1616959800000
7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	7749	3NLKANXuPnn3tRMev7UWy1xAu5XGw6mroeLaoEgZDVeB7cR5xAXQ	42	1361	90	1	6301	jxtE7CsdnCAW2vAFdpn8b3EHKWzo93Xq7NVk91XiWJCLk8Nr26b	4018	5673	5673	1616960340000
7753	3NLK4vH8YdoJtxbkXp5LqF7tf583Jjh4XRfAD4bNNTsaCLPPpp7j	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1613	1103	90	1	6301	jx3bHkb3zgNMhrHC9QJikHGPyHax86wwWhuYD8rfzvfW2k2w8Ex	4019	5674	5674	1616960520000
7755	3NKtYJWegGo4t93S3Ry8rULXxdLYQYGHhqSw6TjFstfB4K9CbApb	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1651	1301	90	1	6301	jwzbzhfCV3hsorcDPKMHMuw2JbnPkMTF4dSsXCe74GnNokzppSg	4019	5674	5674	1616960520000
7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	1581	778	90	1	6301	jwyKFYbzgt7bBDzwqYLdqf6guaAWpd9pKMPWxBLGMEz3a8Sqewt	4021	5676	5676	1616960880000
7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	7764	3NLx5oD5BzPRdDS7hmbdh1KYB3dP5gxgBSUKfD4b3dcdtAiULQcC	1406	1393	90	1	6301	jwm8sVWWnzhaKyDqsGfBJsvCdzcC5Cw2mAvsfdVApPQVre1Kw6s	4026	5682	5682	1616961960000
7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	1631	794	90	1	6301	jxxySKXYs9zMbXasEroYS2TvBvUfhzLRg974QUrLFB2heYHPqcN	4027	5684	5684	1616962320000
7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1406	1393	90	1	6301	jxkWv3gWRsK3478Ah8HmVSRQxC1d2226JCoTacdeMvJsYMKieTM	4030	5689	5689	1616963220000
7774	3NLRtb3mCYmL4PXZwwvYNZDWEuAVjEVTxumiYxaw7rutStDzqa2f	7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	1513	1253	90	1	6301	jxcqQ6aYGckEs5bZvuNfh5PKeG9DMQMXWio9FDzPQuxbLho56K4	4031	5690	5690	1616963400000
7780	3NL3mSBjBnZSkh4ArwCakhPMsryAxakXk9bpTdRaRdfNBB4AzgjK	7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	80	1273	90	1	6301	jwDV4s3m9U2orC1LAArWpLc52sL9Uiwy8FSEWAkRqsorQ8GWfmW	4027	5692	5692	1616963760000
7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	7778	3NKNiE2iQhV51zBqhHx4d32FbjSfRgbR8wLJhLkHyLcX1tinzZQX	1405	849	90	1	6301	jwVyJbuTgDLXvSYdvRAGU1oCzm7pJV746YQinfRvJsnWuoJ786f	4034	5693	5693	1616963940000
7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	1471	1260	90	1	6301	jx7FyR9tiXkdxvQahwkC3H59wVptFGVS55RC57bYnZUUL9yvE77	4035	5694	5694	1616964120000
7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	7785	3NKijXsehWGes5piGJae9L4zAZCuKjHcTAyxQ2FtnkTSgHYJf171	1483	678	90	1	6301	jxaGyAZdhkf3v31x6xNVbZ36eqeAGHNviED7Ph6WbssAgY6D8vt	4037	5698	5698	1616964840000
7794	3NLA52LN8MNLzd6NevUNqC9CtFXs4yGvJeUBa8uxQoiMwzZ9gNyB	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1553	776	90	1	6301	jxAryskn7FT4aZK7H3hkpyA9L1BCHjwsKcYM3aCDEWxBgmTksZk	4041	5702	5702	1616965560000
7798	3NKfk5odkBftrYvS8Wsw4bdCTgeXr71tjwqvfKfEeWH7hEMVAia9	7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	1403	31	90	1	6301	jwH8hDojStPagh5S9Hk4CcdfWyj5SAfKrD3sfaexvdHw21HKSeo	4043	5704	5704	1616965920000
7801	3NLNN3SaLEDBG35ZV7JfjgS8YTu9VAfHRfuuzojPqh5DEJNwD2R8	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	1447	1099	90	1	6301	jxde4YRR31gzQBLhKituinnmgyZjXJv7BjSERYzm1CJ2FVX9B6r	4045	5707	5707	1616966460000
7808	3NKpVsu79r6H14TBYQDpJP19yQq7qQ1XzDBWSyrFc5PGYycg18MN	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1406	1393	90	1	6301	jxD4p6BSbWXNEDBJS8e4NrMBexzQhJMGhg5YWBDPTPNpEx7zzH2	4048	5710	5710	1616967000000
7812	3NKjxRkXreDNP8Jb677eoohwHwJUx7qrGhY3Vs3M8acfGTHRtVVe	7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	1403	824	90	1	6301	jxiwAYiBsSQ9ZvoDj2mLnznH4C2JzNBxFP4vwPZgs85SvggxA1h	4050	5713	5713	1616967540000
7814	3NKvKvff16TmsdQPNzgoPQGibYFeRW7dTNf5bRXHM7HT3tm97A17	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1549	1362	90	1	6301	jw6rfcr5ZYG9QPm9hpp7bdUKfah5gNer6Z12PoU1iPPMqQ1HYU9	4051	5714	5714	1616967720000
7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	44	1325	91	1	6301	jxD5LU1vbAhaRpzNqW3HLWtq55mxPn2jcmSw9ZrDMowFPc2Wtt2	4055	5721	5721	1616968980000
7827	3NLohsRncG1p4L2cXgziVU6SnEFz6qu3JSTwCntqeT6vv6GCWhnP	7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	1624	1088	91	1	6301	jxvBGaaQt5qMNv7c8tpSN2CrB4yHyt5djiqKvYvTjUVxx9XQvjL	4058	5724	5724	1616969520000
7830	3NKPpau9L9VphhqFxpGnDNqUossq3it1DENjYKPYXzduRgBgA3Ur	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	1407	1395	91	1	6301	jwK4DJXAoEKKH6TPU3ifb61omcFtXJXuxnXCdjd9T48FsTjjWz2	4060	5727	5727	1616970060000
7834	3NLirfXjgt649Nth3J24RuaKVsVRPvhUNoSWiZYxP5ummX8bu18f	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1407	1395	91	1	6301	jxxgSJ8KXV3SLPoV3eUUxgo8RDX1LqVt6nk6XUnDb4pinNPFbT1	4062	5729	5729	1616970420000
7838	3NKP3FPV3fAR38KkbySBpZhJJs72wS7NnjWPCsgmsMFgexdwEkCk	7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	532	1303	91	1	6301	jwxNmjuttQP5WAEf1NGuC6ubLYtH9Ugyzr4M6QPbBgjtQtW7eKJ	4063	5730	5730	1616970600000
7842	3NKCQwcTyDtoPhEWeVTkeUepbXyNtQrVC2Raje393PUpL8FKzprn	7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	1651	1301	91	1	6301	jwqx5sH2R6z81ECTMKM9Zo6AXC9tXJoZ21xB47k1cCjAWE5U9u8	4064	5735	5735	1616971500000
7844	3NKezgi6hKv38jrwGnvLcyXZjDX2DEc92hbgbNguEviNJyod3kUK	7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	1407	1395	91	1	6301	jwTdLpGkKWKHeQHF8LutaH5f7jNK6QfSEKxHCce3aY9U2aoqhck	4066	5738	5738	1616972040000
7847	3NLQLAxE4UpMXthYVkotruL2pZ2T8YUyZXTacfgAbXok4xcYADVu	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1529	1316	91	1	6301	jwMRNezQMXvUGu8DUWY99EnNdaRHWYg35BkPGkwBzxCkhz94FT6	4067	5739	5739	1616972220000
7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	7848	3NKQjECHUz5RbSfq4ihAVAnsz7g6E6VNu84PXg1gx9YmdbAV9qpg	1406	1393	91	1	6301	jx5SVQd5d2S3SJzbVtAtpMJXjLUZnBt2nzwtZ9RQjjhGc7kRGbZ	4068	5741	5741	1616972580000
7852	3NLNnp3JrFa5RF9PEZe54tkgDX84BUkun1k8ZVkNxJYir3vHuYRk	7850	3NKrHdbfeRoa2iNPzYRBEokX83W61kUNLSxZuTZbwnA3iqkehwmH	1406	1393	91	1	6301	jx1VaJJsgvKhseG1kRcoPPiZbzsCJzpP9rcy2sYJDL6D7FXTpqR	4070	5745	5745	1616973300000
7746	3NKRrSG7SUXzu2EvwuSNxNttvH5rkr2Cw85qc1wTibwVKhbXAb38	7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	1451	1046	90	1	6301	jxnyezRRyrVknBtxSSGrZV6AyefLsdzSRXb8F3MzSpAJacH2VSf	4015	5669	5669	1616959620000
7748	3NL4LLaCjyXnr5xtfQFnbSrS5RMvRXJgnBzZgEA2ScqLc36G4Jd6	7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	576	1229	90	1	6301	jxm1PHRpWPY4gWKrsW4xtyVmwetreamE5R9jDrXsfQFY4GVrtnf	4016	5670	5670	1616959800000
7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	7761	3NKfdMA3yZCPLcEmEi25PqfyCuzVTuuBdQRK6fiBAJSfXhCexBMr	1553	776	90	1	6301	jwogbnHuWc9hqgwbdQNaCXHKNy1VJDNQ2xDetexVcgMF1M1nZvi	4024	5680	5680	1616961600000
7765	3NKg6QwNgP7xVag1jdJ2hPMDrUTxAkpocyZbipauxWXPcAhwJVDo	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1426	1364	90	1	6301	jwTw41DpPhGjFkApRuaq3yqFMnbGFRfr25PNikdi9cECnPZQvEQ	4025	5681	5681	1616961780000
7768	3NKLrhiiJYr8Afukk6xRVsnicbWhCFHm9pDM73nXmVapmRVrHZFe	7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	1403	824	90	1	6301	jx3SaQvS5EFsjfygAfV7ruabePvXAwGmKVD22cVQGxAedH34fvH	4028	5687	5687	1616962860000
7771	3NKZCaET6VF3J3gHuspLMfdd7MJsG5KFwFDwoMGcjvuGqF2a28eq	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1402	862	90	1	6301	jwadct4PokzJhF7DTsLmLCg53pNCnLtUChn7MyRDc39ZqrpA6pC	4030	5689	5689	1616963220000
7775	3NLbsk6d95cN3CJR5veVYi5TCoUtUJmCHbcVJXfbnir7K4MfGHUN	7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	1406	1393	90	1	6301	jwXpRjhUT1uCJT12X9nQxLancVCGSZyu29pgyvfqC9MYUAw36yB	4032	5691	5691	1616963580000
7777	3NLyYrCM1gwyLaXhMSphVXVecbLSShQqxR5x269APfbCXF2WixYR	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	1444	1135	90	1	6301	jwqbEV6mRg5fXC6vxGHdz66CX6XXUSidnkU6Xu8zCb86FGqqDGY	4033	5692	5692	1616963760000
7784	3NLag5ywoPaiM85uWKwqWcUE89iUJcL2TufLz634cD3apnpp6Edx	7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	1406	1393	90	1	6301	jwfA5QJLchfiJaR1JSxhTdwFdEV66jhSuT5zoXJ8jFodTqW4ojZ	4036	5696	5696	1616964480000
7787	3NKoSuy41nHphxtaPdLeVhjZuWBXnJw8KbCX9M6DCBTDEQpgg4dM	7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	1578	1170	90	1	6301	jxvsfjfeVzYzry6Y9p9Qic72RJWtig7a17TGdoxHsZMgBgknK4v	4038	5699	5699	1616965020000
7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	7787	3NKoSuy41nHphxtaPdLeVhjZuWBXnJw8KbCX9M6DCBTDEQpgg4dM	1448	1065	90	1	6301	jxv3CfN1C3Cck568Xn6P7BwQgy5vSJBtGR97bwbsKTnfWLVQkmD	4039	5700	5700	1616965200000
7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	7793	3NKd3mg8SFA3CuJ4WdozhSMCvDuys8nMAvcfZo1Q2vJK8hiKRcQb	1507	914	90	1	6301	jxdacDpBZVPyVQ4Xwkn1yEAeMpBarHYsq39LBAyDkrVuiPpXu4J	4042	5703	5703	1616965740000
7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	7801	3NLNN3SaLEDBG35ZV7JfjgS8YTu9VAfHRfuuzojPqh5DEJNwD2R8	1607	1348	90	1	6301	jwQrooot9YX4cUEdWQ9FMAgjwg1wtPsL2DEdThrTz2qMYEBdsyL	4046	5708	5708	1616966640000
7810	3NLL6uCZmdgC95shqicGoWyXPgVLtDVSxKQACeZz7zdRkwnBW2SE	7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	1546	1339	90	1	6301	jwLd4qDt6tXVoAUrohrXBLMUVBtCL9d8ZnZPdH5ohVzV4xBYRUL	4049	5712	5712	1616967360000
7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	1637	816	90	1	6301	jwdTCUQCf7JR225EFLR6vaLqSroU4Cf7nmyh6MYaFyZNYEGSxXQ	4050	5713	5713	1616967540000
7815	3NLogcACrDZTuAeFxAvkuJ7PDXDmR1atZCufFYEjkmisVrjkxPFA	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1405	873	90	1	6301	jwndaXj3LkbFuEcpTHNz1hXsCJ58eB238p5XUcobQgK5ZPdo2M3	4051	5714	5714	1616967720000
7817	3NKjd3seJjxy7YNXjhbyn3tcvDwSLzkhPr7dQoGf5hT4eiN7fGnG	7814	3NKvKvff16TmsdQPNzgoPQGibYFeRW7dTNf5bRXHM7HT3tm97A17	1407	1395	90	1	6301	jxyXJoq48ets7Qb2fyexA4jFHJ4Z22aUT8t7DrbeMzjREM2t5yh	4052	5715	5715	1616967900000
7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	1444	1135	91	1	6301	jx2cyzHP6LSehBPKQWRgXBagifzLNXA5ahdAi2qBiJ9ohFTcUDr	4054	5719	5719	1616968620000
7824	3NLJkWGarV8kVvskGtsgMJruYLJ5sYNJ9mdcjSHx4Mxj5u1vK4ew	7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	1405	849	91	1	6301	jwJqHfWrSmSMBce1MM3SzdvSrz6EicCG7WdqHXT2nKnG2p56iuF	4056	5722	5722	1616969160000
7826	3NL1ia312KrMQ8C1k2UUo8CjJJbHCQmgMEjDKCJoLw8Wmmo1AcSW	7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	603	603	91	1	6301	jwyCb4nPhd7kskMQDP8eydAJkESTUCaLb9Ngmh28Up2v3aTeCjY	4058	5724	5724	1616969520000
7829	3NLRRkCh9wH7p1hzJL8ZqXFSTPgB4TQkfSm4VKFvE2bUtUS8Jmcr	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	369	1066	91	1	6301	jxQ6ChcBiC8jBXS17TyPU3Hd8Q1C5QQNNzJyd8UxzD2hhJVvjVK	4060	5727	5727	1616970060000
7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	7830	3NKPpau9L9VphhqFxpGnDNqUossq3it1DENjYKPYXzduRgBgA3Ur	406	406	91	1	6301	jwoDLHPbAbzNTZwYgcPwFe5tZSJQjzheN2qqWHGhvypUrJ54fUE	4061	5728	5728	1616970240000
7837	3NKJ6ZU3ZqLSRRJqYgQTrwaCPiYyQZpLwisVZ4HmGqgaFisBmDH8	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1675	1096	91	1	6301	jw7XB1yx7B5AtJmmyTNAQQ5iQ9B8wgcwLyGx9jBuksDWnDiy5wb	4062	5729	5729	1616970420000
7840	3NLmt5RXVcueE5QXuarYCQsXcG6Gr7w2yGnivP5fk5E9sGXndTnU	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	532	1303	89	1	6301	jxHTK4iKeNP1EsS2J1uM8BqsxPYQG4d1WkkbiFTGUANJw6aEgQw	4014	5730	5730	1616970600000
7841	3NKb1h83nEiEHhbzMb8aVbDbRw67j4JfxYhXoH9aaDJwZcpswaPa	7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	1651	1301	91	1	6301	jwvLNYFkVE7rsumCuXhMjE8MA7EHhxoMmDo5iWmsigbLC8UMQdY	4064	5735	5735	1616971500000
7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	7842	3NKCQwcTyDtoPhEWeVTkeUepbXyNtQrVC2Raje393PUpL8FKzprn	1600	1006	91	1	6301	jwser9RNWsyhsyqoDhcHKd642UQ4wBrC9mYJPTGW5QJnnhvzgKH	4065	5736	5736	1616971680000
7846	3NLP2su761nv1rHu5SaiZrYXB4xVX7DYUc3FHg9zR6vfpxYviNNz	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1406	1393	91	1	6301	jwjUKKqaM4oARqWKfR1ygrLsgg12mBswbtxTY3BvZhhMZtGkvPk	4067	5739	5739	1616972220000
7848	3NKQjECHUz5RbSfq4ihAVAnsz7g6E6VNu84PXg1gx9YmdbAV9qpg	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1517	197	91	1	6301	jw9xS1j1atpz36QpaeQwo195mY3UDMZy3fe3qK4ZCGbSZ1XvYrj	4067	5739	5739	1616972220000
7851	3NKBX9wJkrBbS1cUR15r6CQr8m6zs1JfwzxkuYtdoPB6sSaEZrRT	7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	1460	1324	91	1	6301	jxGk5bvE9XtVcU6LqTiCusofEMTJkjfG9DVUz6WrXATYWiqgWK9	4069	5742	5742	1616972760000
7854	3NLh5tvwRMQyz5BYZmEhB5TomwTsyUTLjavWsYbDevZKzxWvMaBT	7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	1406	1393	91	1	6301	jxzjtzM2VuAaHXSVYc11pAN6WBLFirXUmy2EEKtJfjx1gNXbKF6	4072	5747	5747	1616973660000
7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	7855	3NKPrVmQBSncivM1nuWeUNMiSBi6x3fzHmwzPJkvxNBRRioeQibc	1589	920	91	1	6301	jxKJ6nYCXbJzeUTkCYjTQrHA9onhohX355WQtjBDxR4V6F4J2rc	4073	5748	5748	1616973840000
7861	3NKRAsK6zGXooJXmf6dvMxh2PeV4ArwUakFKVCkdChmANCaYBaJ6	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1406	1393	91	1	6301	jwxN6cCXzjuVGVLY7DuaiTiExPjELyCpR4GSfbyWGvKCF8sZb9W	4076	5751	5751	1616974380000
7754	3NL9ZiL5dp7LwVmevedcUH9GRxBhWyvYcNXE5eV3twJCbBDsuuDZ	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1651	1301	90	1	6301	jxy3Jc9kJjEXpWYbCbwRhhV8opxT7NtzFjo33dmADVosdyTaTWh	4019	5674	5674	1616960520000
7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	7754	3NL9ZiL5dp7LwVmevedcUH9GRxBhWyvYcNXE5eV3twJCbBDsuuDZ	1553	776	90	1	6301	jxo139kLuvKVYHPsgJ3BA1AxDkVAcZAvqCjsdcpgFMe164zeuwo	4020	5675	5675	1616960700000
7759	3NLjm34RLRckM32566NvZffzeTPptofgUAKcrX9mTL8HqaWCNEUG	7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	58	58	90	1	6301	jwoUKbxbmTymKGAL2BXaAJB9ToLiHhMoWkBdXsTeeHvCgjv8AL6	4022	5677	5677	1616961060000
7761	3NKfdMA3yZCPLcEmEi25PqfyCuzVTuuBdQRK6fiBAJSfXhCexBMr	7758	3NKaLSGgbMytZskTFnQj2fys7kMz26zS9hUPBpNDmMkHPHbfjqfG	1407	1395	90	1	6301	jwCMTPgDn1uKSWsujpMp4atkLPa4Ph1eiFdj9q5Wm4pizt6PXZf	4023	5679	5679	1616961420000
7764	3NLx5oD5BzPRdDS7hmbdh1KYB3dP5gxgBSUKfD4b3dcdtAiULQcC	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1451	1292	90	1	6301	jwYK9EJKf1MpgYSeR9hQvRuJFkbHJGkGg8SccTZFToWip7ZPdvG	4025	5681	5681	1616961780000
7779	3NLMYrBgr7XwoYmPvTTDdh9vTFV6wwtZo42trB4P1jQ9s97F4pE1	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	80	1273	90	1	6301	jx5BspWhbbQVuX5M5XyjFPGobmWmnb8UNWpfVRcPpP5mtCW4rVr	4033	5692	5692	1616963760000
7791	3NLEMp2tZ3PovceWdk6ea9pEK8rYBBSTXR3Eb1p1ho5JLABdDm3o	7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	1508	1141	90	1	6301	jwEyVWeamSWgoVNbEsfsmYGiGjTNzUC5PdZQeLSNJV9iUmGqZq8	4040	5701	5701	1616965380000
7793	3NKd3mg8SFA3CuJ4WdozhSMCvDuys8nMAvcfZo1Q2vJK8hiKRcQb	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1549	1116	90	1	6301	jxGqdek7byCG83f5fBkzLoDrahWYeH2NwvJ4wLJv5V4eWAXZZcJ	4041	5702	5702	1616965560000
7797	3NLkmxt6P1gQ3t541hf3x8qosWhezGumCQpVzTuP344hM3voxauo	7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	1670	1036	90	1	6301	jwfDYrocFsRBJ48nPV1SFDipLCt42FqQokgnShjRUPzSMNxsf32	4043	5704	5704	1616965920000
7800	3NL7Lio8pudJJTVW38m3yRpTtP8nrbLsjvQ9RAxfKziVnwsspm4D	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	44	1199	90	1	6301	jxWrpttiiNUuem5C13fNK8AVFwDULLUdPbdhmVWo16mX8N9tKFB	4045	5707	5707	1616966460000
7802	3NLewAoB6MBJmCL1VRXLZWWXEf2Zta9eHjeihJPnY6WhEJu745R1	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	1631	793	90	1	6301	jxLQDr5nqhdkxNhjtRBi5RT3FBF5BwBuZqoZgisi42NdRwTEK8J	4045	5707	5707	1616966460000
7805	3NK6A6PXz9rdzPA2aBbHwaNs2w5gwSDC86CUnoiChouXvP96u2mT	7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	1578	1296	90	1	6301	jxXWBD5MW2A3dq3gRkiEgayJxWLPMBNRXngJBKPmrgkVtzk9UUL	4047	5709	5709	1616966820000
7807	3NKxizqCZT3yDWxc2LxUupLqRqqqs7ghWodiFdf1GAfkKicok2uc	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1421	370	90	1	6301	jwCZVEW7rKCJrx5R6K4MN92mA15EiYd4vAn6Qc1MDSYe4a8aH35	4048	5710	5710	1616967000000
7819	3NKMC95timwrWRPkxnEoRsrXLuYBxoWWqXvnE4BfTBRGzKYCYyn9	7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	1444	1135	91	1	6301	jwimvwxdjU5VJzv43SxdJhz3E8VC3tYAx5Lwou9LVwNQXPttmc9	4054	5719	5719	1616968620000
7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	7824	3NLJkWGarV8kVvskGtsgMJruYLJ5sYNJ9mdcjSHx4Mxj5u1vK4ew	1564	1212	91	1	6301	jxMEG4yfTvVyFoDi8NV5gJQXXabGAL2f5nXTdKNp6ghxAXQQdvv	4057	5723	5723	1616969340000
7831	3NLCPx5iG3KV7M1QiqdNXwKNcdJnNESjbXgAexNAgvd8PZTfohya	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	152	1330	91	1	6301	jxgcBwBbgNFSkHdQYP85sqw6DwpsL6ugAar5de6gNhw4EHb9YES	4060	5727	5727	1616970060000
7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	632	1382	91	1	6301	jwyaY2W2Ny5Nr1VCQTFg28HAk2Uc3M1Pz4wtXDN6F5qJV8BFdxe	4062	5729	5729	1616970420000
7855	3NKPrVmQBSncivM1nuWeUNMiSBi6x3fzHmwzPJkvxNBRRioeQibc	7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	1593	980	91	1	6301	jxujwT1SSErFdp1qvYgrJNxsHVP5EeegUibJsqEmRA2jgAYBmfu	4072	5747	5747	1616973660000
7858	3NKmuy1cpDs9wRXsXuUm8B3VC1PN7YGoDGcAtvxwmzBPUyDkwMtv	7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	1541	1298	91	1	6301	jx8qeAARrQPCsSQMuRhBd1VvmQKb9tbjRd9atiZsSpRA3yMabwB	4074	5749	5749	1616974020000
7860	3NKuHKFoZYX81jHjaWYCwfZsu4RTuaJTdjVj2WBqJmSMjzrSpAT6	7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	684	1106	91	1	6301	jxanh3JWiEYoXEdLK9WzVKVP2F5PeFF8emXe9YCA34v9ZPmby5f	4075	5750	5750	1616974200000
7862	3NKtuZDhzN7rbUeRRpnmfd7kQ1ZRRGQyTLSUsyYcRf7wbqHfpwKf	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1542	1304	91	1	6301	jwCkweVzerMcFgGWKhVLci9sxChz1sEYPrXKQFXb9EyxgCAaJv6	4076	5751	5751	1616974380000
7865	3NKjrXoRw7ZVeQoFe8cWWX15Nu2gkkNUNdDtrtmTV1pH1hJBKXmn	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1601	1022	91	1	6301	jw9ETaaTQMhH2CGMbQojW9pJh2hpn6DZSXsxAXza5eaCs86VeAH	4076	5751	5751	1616974380000
7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1406	1393	91	1	6301	jwC5DMM6TDGCRVNZ1VPBEMTNNHFiPnzdofUmrMGrgGRFf3dLZkR	4079	5755	5755	1616975100000
7872	3NLKib65iEokXDzjJdaJJMmYWFHRAnLaoxSdBfA6SA3u5Zatcosm	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1553	776	91	1	6301	jwD815HBeK6HPkvwVVxrRYCAxTsQiQutSzmKwCF2ZNgDSyWyhJm	4079	5755	5755	1616975100000
7873	3NLx1eY4tn4auVXF8PdeSo5J8Vd5mwTw3eZfbgwWKksfDAarfQoA	7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	1634	1085	91	1	6301	jxFhov1h4GTuvBi6bnk9vAmsZG1qQCPP84gPTK6zAcDNrWqNhZ1	4080	5756	5756	1616975280000
7876	3NLMVrMGABKn3iky2CM5VGQn1CNrmhs9XwTRjW9D2qk9GuRKAf2e	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1506	1247	91	1	6301	jxUmd9Yx7g916U8Xk8sSzARD7rvYFngsLBNstx6KRN1RQ5RBrgj	4081	5758	5758	1616975640000
7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	7875	3NLYNzZ3MJs6jtPjPRLj8NdJkKrWM28Acg6wEoB5TCaknMvHVEpZ	1624	1208	91	1	6301	jxM53azssZLnMHLagxk99cUxXfxapxzEccEXtGn7mZw4YZcWrz1	4082	5760	5760	1616976000000
7883	3NLKNTY7CaV9mQMS2QsQp6ddbtitsidFKe38obQ1g9zZsAPz4ae8	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1406	1393	91	1	6301	jwANA2Lfp5uAWUyvDbVJYAPGZLxrvYiH5SJeQT7v5pfv2qwy5F1	4085	5764	5764	1616976720000
7888	3NKd5ErnFNcmX2r5vTjVUYy1PwxSL2td6iSbEaheWzvifjPGRiTq	7887	3NLvm1LBvvRpd3xgBXTgiAPzy4gDJDHdih1CvZHwTEkv6L7KgR1q	1406	1393	91	1	6301	jwowRf4x1RboW2S7wphowQGnsV9hosMNy2r6EuU8FAUS17ChHnr	4088	5767	5767	1616977260000
7891	3NKx3MXu322Zw6U1ZjwWGjeN4wiQU9v6m6uHj294MgDu5xdToxvi	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1506	1247	91	1	6301	jwKagksDbP22GuypkZSppSGDoVkKUKHrW14ayd3C4te79FJ7k4N	4090	5769	5769	1616977620000
7893	3NLhcpKQKbZBDSrhc1tH2n6uFnYxZsgwHH7BP6deHxCTtk3g8ctF	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1631	794	91	1	6301	jx3NcgE6bD5sG8Fgi5jT1yAXZFdXgUVEdHf3Kdm421kvHjhuBmY	4090	5769	5769	1616977620000
7895	3NKiztAiYFLcQVTaEkjAuUEDGCV9r5EqNfJ6HUg1T2j2NyhRuuK9	7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	1547	1012	92	1	6301	jwitj4fr3xgmMmEuvbGuvvFGXC27CqYNAx5YUb1riyKqRDqZjKX	4091	5770	5770	1616977800000
7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	1403	782	90	1	6301	jwqChgaNkj7q1mqysMwhrqhvLLVZrXoyHaPhH276SnN4s1ZAAe3	4031	5690	5690	1616963400000
7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	1599	1287	90	1	6301	jwQ6urcWcr627oZfxTF4y79PSUMLyWREUfEEMK9x2dmHFGMHDwN	4032	5691	5691	1616963580000
7778	3NKNiE2iQhV51zBqhHx4d32FbjSfRgbR8wLJhLkHyLcX1tinzZQX	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	1406	1393	90	1	6301	jxDMLKWvhphXUHHFWMozQrjEqz1t2TiR5W5UqJXUHJbxVPiNrLh	4033	5692	5692	1616963760000
7782	3NL4gpSGmCWdx8rSHtQ7asySVrVGnyeBn5x1yas6nQsGjHKGmkxR	7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	1648	1284	90	1	6301	jxZnTzrpF2jv2JMqJcdENsaBkdDQvfN5zVDDhHgJ3WoRP6FZfyk	4035	5694	5694	1616964120000
7785	3NKijXsehWGes5piGJae9L4zAZCuKjHcTAyxQ2FtnkTSgHYJf171	7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	1581	778	90	1	6301	jxStGy8LKstUmc8kMsUgervBePXTQMhbXVTAKkYhbjMdrY5EekT	4036	5696	5696	1616964480000
7788	3NLTSaiMxZzkfUYPLejeGdrAGss518gmRzN8VA2TqNgZQCgqEJuf	7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	1657	1344	90	1	6301	jwQz2LREA1pgCcNG4cmi2nZngTJPMxssrCueAw84p5u6E2HUhHo	4038	5699	5699	1616965020000
7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	1527	1293	90	1	6301	jwh2LZpQ24JGnoy5AhkMLHrm4kbsEifkKGhtdmQDGDasTGDDyV6	4040	5701	5701	1616965380000
7792	3NKGZyQ8Epp4hyhRxHFSVmSYkKGUe8GucwASgGKhXBNVy2xLH4Kz	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1600	694	90	1	6301	jxJSbqi29eZfL1rnfzRZU1drWtjpHgebz9Y2CattE7zTMhsxXRY	4041	5702	5702	1616965560000
7795	3NK5sNEApJ7x59evokA1zss9oRr1w5wuG6SKDk1aTEpARJodqW1X	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1419	814	90	1	6301	jxTHz7zbnfvXx2K6xEVy5v3DvsbyHimuT1JRtT9W71xC5L6r6yT	4041	5702	5702	1616965560000
7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	7798	3NKfk5odkBftrYvS8Wsw4bdCTgeXr71tjwqvfKfEeWH7hEMVAia9	641	1210	90	1	6301	jwyU4ffueFQAaLBUEPbbeuDPKL7Q4isQ4EXUjpPtRys5BshnaKp	4044	5706	5706	1616966280000
7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	1646	1354	90	1	6301	jwUF6FwdGBpU5CvGG3vEtsKSkMtHBvrGHiSdjwPxrKSQ8Z51qKL	4047	5709	5709	1616966820000
7806	3NLWE5Qwy3MduYRQ8a7xde7dPpr4uVLhZ5QZYxDvGR953L5aXmp3	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1407	1395	90	1	6301	jwMuwE8HBCM1Z8oGEQHWbMtceduZgHD2bVGcEH92uEFupbczBnT	4048	5710	5710	1616967000000
7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1405	873	90	1	6301	jwAgRU8b6ACRdU8PJWsWVUSDDiDhXF9ufWxzKPHXJFqHvYuVXQE	4048	5710	5710	1616967000000
7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	1631	793	90	1	6301	jx1ZGncjShMPEmMQye5ZXGBRVzmXtYvPeE4P8tL4VTPPwnstaQV	4049	5712	5712	1616967360000
7816	3NKzDbXxuy6kLoWfbKbpbHdKTMi5oUdAM6rAXwhBh5hMh8mbHjwf	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1631	794	90	1	6301	jwVbYXGpZQLJpyd72T8mAE5XnfTyTgHCTtPbzKHr1sDQdhvoT5D	4051	5714	5714	1616967720000
7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	7817	3NKjd3seJjxy7YNXjhbyn3tcvDwSLzkhPr7dQoGf5hT4eiN7fGnG	1447	1345	90	1	6301	jwZwovJFVmYTDTBCS7RJqc13qgGT3pYbd13FB4qQ4sNRwrpmqzw	4053	5717	5717	1616968260000
7821	3NLb5CwSRTzibiHw46QRPq7yot9SjGRMHUUTzva98uAwRjhNTUsk	7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	1406	1393	91	1	6301	jwM6hYYM3VXj65QFzudaXRb87ZbnXUotw27kcDHZnozBKX63ZD4	4055	5721	5721	1616968980000
7823	3NKmRxFnVEw1dxP8rkcCWQkMYm6YjJ8ibYQiVTF2KFxCz4jVz68x	7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	1448	1185	91	1	6301	jxhjfTxrmZMmLYDjT8eBbzmohLkGbGmmQ2HRDfbKzYNyLyddqNt	4056	5722	5722	1616969160000
7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	7827	3NLohsRncG1p4L2cXgziVU6SnEFz6qu3JSTwCntqeT6vv6GCWhnP	1458	1077	91	1	6301	jxyXgCh3jRsgwWVQEp8nQK2PwfRPHtqdEWFy1Uvq6G3znx1CVhw	4059	5726	5726	1616969880000
7832	3NK7pxTTZNz1VEUMwt2FeFPzkPJ2ZDm6sqQXy7yRf4QANNecomLU	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	1508	1387	91	1	6301	jwGu8kTpH2y5vjdtykGzAXBiSQ9rxpq7G3JVsq6EbZxJR6RznnX	4060	5727	5727	1616970060000
7836	3NKDD54Zaka84Vy71hYLrAnZbQG8sYGFwSupExnTHNKKMduN6Yt8	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1406	1393	91	1	6301	jwerLMrZ4KtGexer27A1auz3ctzvSDZtF27nWvYs8kkELLyCkfq	4062	5729	5729	1616970420000
7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	1637	816	91	1	6301	jxqKgGjpwwDAQ3688GqquoGNQEoEFCi6WRUKMriuqGNkM6oZBQk	4063	5730	5730	1616970600000
7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	576	1109	91	1	6301	jxZVtDski5FzV1vANrS5b7Nr73wotCkuFiyhNzDnGN3vqfZvke3	4066	5738	5738	1616972040000
7850	3NKrHdbfeRoa2iNPzYRBEokX83W61kUNLSxZuTZbwnA3iqkehwmH	7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	1637	816	91	1	6301	jwQjoS8msBbwyhutndftcZDoirStUPjm33fkejVCTgEnhGqt5dM	4069	5742	5742	1616972760000
7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	7852	3NLNnp3JrFa5RF9PEZe54tkgDX84BUkun1k8ZVkNxJYir3vHuYRk	1467	1376	91	1	6301	jw734EhW7LEFF4HzVVX16icyWL1sJitk9QqxEcHMSDE6LEdm14u	4071	5746	5746	1616973480000
7863	3NKxhj9dAKBThkAmGUPSh6yR5egpmu9mPuJSb1iv9uWa4z3bJXHF	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1509	1194	91	1	6301	jxbidvqEh3YGRBw7nv6VQC6es7JmA9CgbxrCJWqgZhWcSN47QBH	4076	5751	5751	1616974380000
7866	3NLBZAnUrYn8W4zUZuQ9T2s3qUaXFTnAoRKnT7DBHKvoNA4CYPJg	7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	1542	1304	83	1	6301	jwcT2afRytkX63wGG18frB6WHdza4caNBxbn6B7KLya3sNGDg2L	3793	5751	5751	1616974380000
7870	3NKDUF3emK7nSFUZRbcXwr9Qy4w9bvzqxv4sqhiCsyAnCw9KP3vS	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1457	1145	91	1	6301	jwFvzQMhrRf5dtpLfQRN1ACKmBno8WvxaMDLfVK9dnCY1EtDjJi	4079	5755	5755	1616975100000
7877	3NLw8sLapnSs4wKcds9zJR8PSEpRfpinsgkfrqJomfNkaWT8x6pD	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1405	867	91	1	6301	jx9R9YLkkutTxLFa3BroA6yUgdsNagecK4wtWDUBYXH4xCKqjbs	4081	5758	5758	1616975640000
7879	3NLhHmhHo8nB3WCpWooxkhfj2nPjyGSkRjsmnyehwqth6LxXmzxE	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	684	1106	91	1	6301	jxM7Q8PBw9GS7Vxh6KuqK91RcaqYv6T6Dn3JnwBjNqsV29cHZWP	4083	5761	5761	1616976180000
7886	3NK5UYSCpoHpbtQoZzJEfcheyCXzYVxYL5JCbgU6FnsUuBPJV89A	7884	3NLQ5cNGtNia5jkVPE4xz9Q68SEKH1z18Xk4uNrm7zCn8tXiSMeU	1403	824	91	1	6301	jxxAtK82bnHP9nbzddzcKDUcDwKVDsUY4VU8EAGXno9sZut2YHa	4086	5765	5765	1616976900000
7892	3NKeU4P54McMuFVFB6yeuSgxwQ1yXSiEVfQ5hNza1KsjZUzLFZ2j	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1405	873	91	1	6301	jwaMqUi8SRV2N9UnKWdRnnTBPAAemFscQjiGoA4GfW7DZo4Rjjc	4090	5769	5769	1616977620000
7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	1402	850	91	1	6301	jxaTSHEiYom9NBPgnmsQDx5ZRBWwgCmfwPoihTcyXMuAvS49iLU	4074	5749	5749	1616974020000
7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	1467	1130	91	1	6301	jxNC5AfUzo5MgcRtcLRBeNrVgk14y6gBDqCqc5k9vkjEZZeq2C9	4075	5750	5750	1616974200000
7864	3NKyCA9mocYnzS28feSWTCFsGV6peS5Dy4FDcyyDQkbS17UPbsjA	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1601	1022	91	1	6301	jwpGQpydaLTXf9tgLdRMJPPKGiLMBKC2PmRHbkNuLJroJLwGxmP	4076	5751	5751	1616974380000
7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	7867	3NKG5xECuAo2csnMCEm8HUZGprxcwCKfRZY3AqZWgWDoKhBraEhf	1474	1083	91	1	6301	jwatCxKphrphjfLcFj4B4MdoeAH3adNgpC9Xwp6RvTsbKjSGXTR	4078	5753	5753	1616974740000
7875	3NLYNzZ3MJs6jtPjPRLj8NdJkKrWM28Acg6wEoB5TCaknMvHVEpZ	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1560	1291	91	1	6301	jwaodrdxaBiftZHwDguS8JuRrmorFcmCpA74v18VnXY7nmaeAkS	4081	5758	5758	1616975640000
7881	3NLoNpwZogCTB2neqDuiykfmruh6fLj9yorCrf59uG5TET65LsTg	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	1642	1367	91	1	6301	jxkDUWLVsb9xpNQkfjNELzSPJrBanwyvZkraHu3Q9UDaE6Xc9Ef	4083	5761	5761	1616976180000
7885	3NKeUpQazK83RV41HDZFSwvDTWUB76Pc8EMwRdHEx8dJ22LvLhp4	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1623	830	91	1	6301	jwXQbdx2BAhmVJhkV2sW1KCCxaZhtFEfJRQ1HYJiNw2dvd329CC	4085	5764	5764	1616976720000
7887	3NLvm1LBvvRpd3xgBXTgiAPzy4gDJDHdih1CvZHwTEkv6L7KgR1q	7886	3NK5UYSCpoHpbtQoZzJEfcheyCXzYVxYL5JCbgU6FnsUuBPJV89A	1577	1327	91	1	6301	jx9JWgvJHE7K3aW2uRQweBWZ7GtZYP3k8FSDVggrFPxKkxmbnLk	4087	5766	5766	1616977080000
7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1426	1118	91	1	6301	jxR1biPHRCjJPr2aWoBLp8MPjH9UuQzRJ5LCTUtfQXKZQzY5S8c	4090	5769	5769	1616977620000
7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	1407	1395	92	1	6301	jxU7y1aE3AwBU8rfw9hPVEoaCvejAiZP9fgjmo2geCB8gK68vyJ	4091	5770	5770	1616977800000
7897	3NKQTUCXz1HQ2DCog7qaXa8F7gVzkrYp6mvDv6QGMmugnaHyEuSf	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1559	1227	92	1	6301	jxQZv8o1ZW582sTEzZiuS7j1WD2LUsaaNVUu6fnumJwGsgoKSQu	4092	5771	5771	1616977980000
7899	3NLr1YNGXUEW2SQvWA2ftTY4thg88Xmo5ZLZDzQ7mfwqgsXyiJhZ	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	633	1384	92	1	6301	jx1ZjnLNpDwyqyuDoNiCVSztG6LFHu8diC465bEnyqLgUAdaPwS	4093	5773	5773	1616978340000
7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	1631	794	92	1	6301	jwrcxF8jMVYwf5fPctmwktxnMdjS4ddgGYHzHMiopBHHf89QwX9	4093	5773	5773	1616978340000
7903	3NKBzYPAsx5Sy8Y4Xfz3CrL3LQQSMpKZR7z8ojmgoMZwTg9XbupK	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1448	449	92	1	6301	jwWfo2bucGgnbvhrN2d3mxGSoouszePtrARVZwSGdr4LN924y2Y	4094	5774	5774	1616978520000
7908	3NKFbg4fPLfcsyDJzgeoKosL52YKnrPEKLuHwprmmYBTpW8xuQeg	7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	1536	947	92	1	6301	jxYdjjR8czRUeHg1veJ4SPH478upUSH8syEExFpDtMqqTksWsqU	4097	5777	5777	1616979060000
7910	3NLLjtCzdBL3RqihsofVpnQrgx5nPG9KSJfNEe5X7kjP6EEjZMnr	7909	3NKZqyRq926LLxdLLQdBymKiS6A4PXHxCK8sXCtLfF4zhQmLA9GM	311	1307	92	1	6301	jwEJ7rmz7CT3TrhtZvhZqnXWoyqHJawFA52zWPPPHZVuzn5D9Z2	4098	5778	5778	1616979240000
7913	3NK4S9uRnJTCBRXeKMXpzRJ2b2XCHMgNhRJhjo2FMkwhdvc5bwqT	7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	1403	786	92	1	6301	jxpfFL2keWM7vcYt1r6rENdAupNAPme6TyFqaai7kCNqmSTXhJM	4101	5782	5782	1616979960000
7919	3NK3WGSR8U11TquAcdFn2eiLLUojndpzWvrtPL4Q2KpDWWJpeSS7	7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	1402	868	92	1	6301	jxgxvX6KPmtf8M9GuEfZprn31QiL1o8CqXtGDFYaXsTrsayySQx	4104	5787	5787	1616980860000
7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	1471	1140	92	1	6301	jwsBUZy2wkj4SSM1UhwhMBgVxgJHMSxE7BsP74Hs38kq2SqScfN	4108	5794	5794	1616982120000
7927	3NLbwx5J2dsiVAqu5nCZHdEuNJG1P4WbGPXXnY5ieJofotz8C7KY	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1581	778	92	1	6301	jwNQu1SVEKjZF4BJywcRKWW7yW3wxrXRPgLRxmbcjcpvbXkGd8o	4109	5796	5796	1616982480000
7929	3NK3HQh6s7Hy5DiQ7X2BdbVkm5TzVh6c2jHizwpk8Akmo2x66wUJ	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	576	1355	92	1	6301	jwTr9WjD5jioPWrTmnM6Yp789CtkczN59EufQtaEeFJrU36uaGb	4111	5798	5798	1616982840000
7932	3NKb6KSv7RmbChdyJ5wAzZcTzt2J23JuzDmCz5sSb7gpCnwfKJfJ	7736	3NKfsiovqEQcrtvQL5stiq8HhZERBey9WJwUuP4DXGJk7EtCY9Nc	1439	1279	89	1	6301	jxcpRPxAxoPbgRMhGiHfdSuYNdepEBHUgwiMY1WS1F6PrJU1dys	3997	5798	5798	1616982840000
7936	3NLhwfKmXUtDrVThe8vSeGE5pPsmRp1Emmyh7SLbyJwb2nYunTeA	7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	1457	1265	92	1	6301	jwWp2Ag98UvJgfiXzE1pFjBGbaoKCP5VUHN7JEGMurJ8mRRu7u2	4113	5800	5800	1616983200000
7941	3NK9rkqgCztSPDu3dsMmxQ3LwRW9oWZRCojfQM65Y9uCYWNXAiCv	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1637	816	92	1	6301	jxJDfVnZnBps7ZLvgj8ENP4BxVr4xLNoGc5qKCF8T1QSrHAkhaP	4115	5802	5802	1616983560000
7946	3NKamnkmz8Cq5ixhapMYbCEZ1GYRuXvUGvMZ5jVmGGVQQsn6rBEX	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jwiMBxSgtPhR8ynBKexxqgw23S4sw9KNCCFdDMymxSFFMWdo4nV	4116	5803	5803	1616983740000
7949	3NKyenyUpePwDJrTfjL6txSnSN1GhfqUKFFQsgApe4rCkn6p2wA9	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1516	928	92	1	6301	jxc3nLBLFV87Bs69ESHG9QV2VQorm5aXapdCLc1VyoAehqTk3rN	4118	5805	5805	1616984100000
7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	7950	3NLRvgmpxuUQhQ7sqXEmSXkiKJcaugHMS4Dc4s7QQpDNJGWHN9U4	684	986	92	1	6301	jxH8aq7Z5SusBvqg34b9iqbcAVy8xzGKVrRYAcjRsnnAEC7CK6N	4119	5806	5806	1616984280000
7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	7961	3NLeC1F3zYCczPzi7XjEbeFvfUWAWFkKs7FNYTvcXeHK7DpiCkyv	1406	1393	92	1	6301	jxxEjE58zkJvWfGBMWkuTaNaZHgAx3visDpQpQ6JtHBvWCmNHdW	4126	5818	5818	1616986440000
7967	3NLfZxRkmxbWWBgZb5mHjue3yENgSEXJ6myPoUiFDGoeZ3Rkxucd	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	366	366	92	1	6301	jwN4WtSeQkSmgMWEVmygxzUUNchUe7TPsKMP39fADboNDiUEcyz	4128	5820	5820	1616986800000
7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1652	1069	92	1	6301	jxByh7epLbUxkc1xUJP2LaiaxzGTt66749pQV1pZiugttZqsuv2	4128	5820	5820	1616986800000
7970	3NLw9kXUYTxDF4xeUBsjKmDd3pXFPwWgwM3A2JTqmcB7jpy78Yx9	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1559	1353	93	1	6301	jwaNg3GUFLxMs4KUNiUwW4MAcskZikYAJQnPbBrJQs2HFZu4vJW	4129	5823	5823	1616987340000
7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	7974	3NKc3gqnfFs7AeSKtxumbzoAqWJQZiz2cjUCHoP8VWgYWJLJuwsv	641	1210	93	1	6301	jxy4aTi1Xcgad6kYk9Sfb8DBtev69aLczMJnn1n1yKBqBMiqgA5	4133	5830	5830	1616988600000
7867	3NKG5xECuAo2csnMCEm8HUZGprxcwCKfRZY3AqZWgWDoKhBraEhf	7863	3NKxhj9dAKBThkAmGUPSh6yR5egpmu9mPuJSb1iv9uWa4z3bJXHF	1405	867	91	1	6301	jx8kshjUtLjYseAVu5Yq92V8BZGxTVN9nJUKjgpipfCerQ1UxuZ	4077	5752	5752	1616974560000
7871	3NK34dncNwKDTPmujN1AEYdwWaQ9cDHSY69BCAiXtqGVLjJTXZVX	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1405	891	91	1	6301	jwht39fHtkTDYpeDadL3ahG3MmnDttgWuPzoe38sRMRJaBQZSaA	4079	5755	5755	1616975100000
7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	1553	776	91	1	6301	jxU88HaUGrvMAWQhRURb4H6jYZrJE69xXDGeXEwRBaJbsG9PqoD	4080	5756	5756	1616975280000
7880	3NLuw3f6sNmJuJy9LSrGYaashWKLCoiu687YsUofKWxNUXFTkTfm	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	1675	1342	91	1	6301	jwLQAJLqMntDgL7h7iE6qTH527DtefxGuiCuGWjUtcpgeYPaNRB	4083	5761	5761	1616976180000
7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	7879	3NLhHmhHo8nB3WCpWooxkhfj2nPjyGSkRjsmnyehwqth6LxXmzxE	1419	814	91	1	6301	jwWVqvYyb18k7s4TZ232f6eZRZXo8YoLmgbTytxD8P5royHrhu5	4084	5763	5763	1616976540000
7884	3NLQ5cNGtNia5jkVPE4xz9Q68SEKH1z18Xk4uNrm7zCn8tXiSMeU	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1560	388	91	1	6301	jwXwig5Yiue4xeHYhMV6dA5kL5AzwRoGkVbmnXKDQSP4YrXkQmx	4085	5764	5764	1616976720000
7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	7888	3NKd5ErnFNcmX2r5vTjVUYy1PwxSL2td6iSbEaheWzvifjPGRiTq	1403	824	91	1	6301	jx241MPr4Tz4RwSinhMMGVgQ5M5MtjS3NxCScAwNqnT42QU5YUE	4089	5768	5768	1616977440000
7896	3NK6TfH7L7qCmG1nQcxxKjqfRqN8fczWoM9hDSVchz31FtYGfphx	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1546	1213	92	1	6301	jwCRLzubEbBoXWxudEczDTFSGCqfzMkushG7KWTJLSMJQWqGhr5	4092	5771	5771	1616977980000
7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	7906	3NLeivCZcniPFdhywUy4RuHuGLHQFE8nXJ3wMG9mrmPSWyw9pFtG	1407	1395	92	1	6301	jwszkTc3iC1yNktqbnxAcryirEs4QaCqqKGBtBGtRjJsrSrSwV5	4096	5776	5776	1616978880000
7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	7911	3NK8WCxzP3wb2b5mWFbahYtG91da9ju9zVBhEpCzxWFEUQtPg3QJ	1573	1192	92	1	6301	jxyVSgSKtqBPr8RYGJXsLnFP5fd415gcN2j5eax9ZmCDbcpRsmw	4100	5780	5780	1616979600000
7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	7913	3NK4S9uRnJTCBRXeKMXpzRJ2b2XCHMgNhRJhjo2FMkwhdvc5bwqT	1637	816	92	1	6301	jxFZW75i7aLRf9TVq4CXb1QtJQNB8mLmHXVXFSzrLshHYeipoyC	4102	5783	5783	1616980140000
7918	3NLiVub12qx2jK1prqXA15XbXPRP4JNgH2yVvkk31YCY9Eh9CQvu	7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	1407	1395	92	1	6301	jwWhPP1BJ5oqZ487WLsKyiCS9mETDysYAW51QGmg4zfKpjB4xPP	4104	5787	5787	1616980860000
7921	3NLXg3TRqoaF3PKrYSMsk7hcHXXr41Uvvp5nt9QCN2Zm267dnWuw	7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	1406	1393	92	1	6301	jx9TWXDoNf5LUPSqJHsNsVVskabY7JcCWf4QeakG1jQLdxz8EGC	4106	5791	5791	1616981580000
7926	3NKseYQc4D5Mpv6ZoPdHPmCGEsH8rGNkJrAxFcSsD7DKLVCfwrhR	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1578	1296	92	1	6301	jx6vwnYVo2DbphY697jkKEFqntVKWH6y5pWpicbsG8dUs7G7hij	4109	5796	5796	1616982480000
7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	1407	1395	92	1	6301	jy268KAgrDecrGrbJTtou2P3ExGo8ozh2kEEQHcansdQX5mrgbr	4113	5800	5800	1616983200000
7938	3NLAvXw59xHohoHZ811wFfbwZpq7kLwQZoqMEg8sgU3jotsuC8F7	7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	1642	1121	92	1	6301	jxp5ziQ1M3QQjrYyXk4aNhMZFvFwQFhjRxymjgP3fLxoH1hnDLg	4114	5801	5801	1616983380000
7940	3NKVQziLSPgn8rSPfFuzQWb997PAnoZA6q7L65wEQVD6gkszhFBo	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	532	937	92	1	6301	jxdr4oXvBjehN17qkVKwakV7AdUisduL9SEbDohtE6fJ2CkNzg1	4115	5802	5802	1616983560000
7945	3NKxbE42XuM2WgcqgWsGKwdu9p2vzQW9Vx6YsjLr2kMFZPwnmQKv	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1455	966	92	1	6301	jwUM8z4J87LHwq4sCzEpmADebWNcPHCaeMnU1XLWZDkYXK5LETX	4116	5803	5803	1616983740000
7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	7955	3NKAEGAkYzth1WZkLAYDBGJgLLv5w2NpXqGkJE9Pu4mRarUUdykq	1590	1054	92	1	6301	jx7fkKmT9T2FQjvcbgzzXc79dB4rwZHyqM5NxhYdXYF1aJzqfSJ	4123	5811	5811	1616985180000
7959	3NK5g92ipAeFxJmBjBY5nA5Xo6qQmjTTAA55Ldc8UZfq4pc1Jn6e	7932	3NKb6KSv7RmbChdyJ5wAzZcTzt2J23JuzDmCz5sSb7gpCnwfKJfJ	1439	1033	90	1	6301	jwk1exMMsKTGvLMGmzJzAbs8o3MBDoqDScY5vmXuWv3SiChNwvD	3998	5812	5812	1616985360000
7961	3NLeC1F3zYCczPzi7XjEbeFvfUWAWFkKs7FNYTvcXeHK7DpiCkyv	7960	3NLQWpAvvYaknfPy1NZM3FVmvLcdk7N1dRBgmYDBeKyZrfweyvct	1405	849	92	1	6301	jxfjcNaDQjMGkK7hsYJS43Mpy4ptazGV9FxxUJ2EJqL61s9SL7F	4125	5815	5815	1616985900000
7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	1402	810	92	1	6301	jxt8foCgGvgHq4wXHjQqHS1dMrDxWTX1sLqPvD2VyExdbt3awPZ	4127	5819	5819	1616986620000
7969	3NKJkLjkwZwRYEz4QUaUuuSgbF6wBuSoUoZKebGjkKiNPSFv2RFd	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1559	1353	93	1	6301	jwpsGwRrhMp7GeBrPJ59xYyQfKALb5qptRvSxakiRvT9LsbrAmc	4129	5823	5823	1616987340000
7971	3NKhjepU9MUfJGYMR1vrKJC1XrnLFM7L6tn1Qv37hFdHkkfgM7mw	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1553	776	93	1	6301	jxz4Cu5T7TGH7JXmb4xqM172owkRxvwZUsHaEYPqutg56VzEQPa	4129	5823	5823	1616987340000
7974	3NKc3gqnfFs7AeSKtxumbzoAqWJQZiz2cjUCHoP8VWgYWJLJuwsv	7973	3NKSndqLB6JU12Mm5ycyPA97DLh36BLiKGR7Qk4RjxanAso1R6Cr	1406	1393	93	1	6301	jxwj3xdibuoYmp35niiR4rXmWnfCcjaoj39Q7Gvs7GVVLrs2bic	4132	5827	5827	1616988060000
7979	3NLkhVGHPqQuNjFWGjVyAGjmS3v1gd5ZQEZDZRKLQgVQusE652cg	7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	1593	1346	93	1	6301	jwimCvJKNuDUHe7cvUaKWTohj4iAAs4iSChE1VmVcQ3PdW9mdiW	4135	5832	5832	1616988960000
7985	3NLuYLefecnBBi53dkKf3hoF2XZhuS52tDmwW7BDoGkCqDGUUuZR	7984	3NLi2zVMXrkeWg31HELZr2SACEv16Y8YEepuFRJMikWVYzFZ13dx	1516	479	93	1	6301	jwtn29cEpMQFBNWaDyyLXgiGzRSK9xHBqrCTFD21u7y7BjDfQAo	4139	5839	5839	1616990220000
7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	1577	961	93	1	6301	jxos6hX5JD45zDzKkVRRyriKeDEsmhkaujwUJHfa5mw6S7cmfmE	4141	5844	5844	1616991120000
7991	3NLDgBFCLPDkRVeS1Qzmp5nmJhzP9wvBiE23vm5QsaTZGrJYkppS	7989	3NLjwwtEgHPJ16aWfnAm4cdedsAkdkmhdajTZrPFUtV79JtcNNFD	1406	1393	93	1	6301	jwqfq3NP1PS219A3buu7SPdjMw2Wq9AhTjapmtnHCM78xns2bw4	4143	5847	5847	1616991660000
7994	3NLYWVtBXRHEG2MsF9tFzVbU3zDojTLydqgt93mJ3Cs2bpzjwdbd	7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	1455	1086	93	1	6301	jxrsL8Lr38QLn7JqYUuFyhoC8FeTrTtBZmxgBCAjs4Sm3YBZjgD	4145	5850	5850	1616992200000
7997	3NLcTzXrXzbwvh3uDW5zVdE7Bn7pZ8wZFs7eKeXRB5doRhjz7sb6	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1406	1393	93	1	6301	jxDaceohbbxSWo17UbnQowv7iFTTF34QJxa7ifEFwUBj5WNDFf5	4147	5853	5853	1616992740000
8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1637	816	93	1	6301	jx7Qrxsd1GyRpoyAwdFcqEZ8E8nVFdUTfmHMZhyFmibhu3UxeHA	4147	5853	5853	1616992740000
7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1652	1069	92	1	6301	jwdm5N9iS4Lp3gJTuwQzmEFZMJPdVnwC4quc5zgURkbTjcmXCia	4092	5771	5771	1616977980000
7900	3NKJP7Ye796BcRuyYm82cUKrCgCyn4E3B7myYd8tAMncHbXaKR2W	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	1403	824	92	1	6301	jxcXbb6jU2vqshv3iDUTr1YoEaGN59MWZREivtJXGiJNN3rWzRi	4093	5773	5773	1616978340000
7904	3NLsHWjhKFPEgoHB1KFZUgdYcC7YgtFDXz5G6FvsXyW7MNEjLVqE	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1500	1297	92	1	6301	jwxnDCbkuK3CwcTBWbnHXJRzJ8MkDrmhU2eMKdpjrR8E44rgpZa	4094	5774	5774	1616978520000
7906	3NLeivCZcniPFdhywUy4RuHuGLHQFE8nXJ3wMG9mrmPSWyw9pFtG	7903	3NKBzYPAsx5Sy8Y4Xfz3CrL3LQQSMpKZR7z8ojmgoMZwTg9XbupK	1549	1362	92	1	6301	jxc531J13T5xtE3Ycty2kJuSJNW9AyUy9FnJdCDYXoUtr1RHU6h	4095	5775	5775	1616978700000
7909	3NKZqyRq926LLxdLLQdBymKiS6A4PXHxCK8sXCtLfF4zhQmLA9GM	7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	1637	816	92	1	6301	jwRBm4SJYuwLny53ScyUMHa9vcQuxVXzBw5R1sBVxyZ3Cmmr5ZZ	4097	5777	5777	1616979060000
7911	3NK8WCxzP3wb2b5mWFbahYtG91da9ju9zVBhEpCzxWFEUQtPg3QJ	7910	3NLLjtCzdBL3RqihsofVpnQrgx5nPG9KSJfNEe5X7kjP6EEjZMnr	80	1273	92	1	6301	jxMSfh23EagE1USFSqur6h9Lut4Aos2Q9CabW1QUdMUxQsLLHjV	4099	5779	5779	1616979420000
7914	3NKLpAfhspvn8V7Q3e3GcNC6Bm9g2KdT4KiEunxeStiTPwuAxMGz	7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	1581	778	92	1	6301	jxNuiXszgJ516ieKzsi73mqZdvrdi9zYpCq182myRExjnbTbmrE	4101	5782	5782	1616979960000
7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	1407	1395	92	1	6301	jxXjBBaAZdH6KwBCfowHkZtBQ5YHoqaRAnS94JhyYNXi8VEDbNH	4103	5784	5784	1616980320000
7922	3NKm776GCS6Fqm91YCA8p6agstHnjB3FT9ncB47qX5vsghu3yAhi	7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	1529	1190	92	1	6301	jxBCUjf1dNqwb17hhEtJ49EEF7DuXfqJWcKjFjoJ5B7AiS8Skfh	4106	5791	5791	1616981580000
7925	3NLtNYA7WF2LmYu5Smu99LsAoFJtZRSp55GqjCT4Rk2MC86Xryg3	7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	1440	1011	92	1	6301	jxCqzBrbkr2RzoAZT7hb2W4dw6EynCnTss8QnFnYAc81Re8ZQGQ	4108	5794	5794	1616982120000
7930	3NL2ZEPRjbYHV9wZaroUmRG5hBkWUSkgsv9k4nYSfiDTHz3Fgwwm	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	1439	1279	92	1	6301	jxyJzrPuVAcbMHcyogtWkgkSVrTuew7WTDoP77RETo9NWd8Y53S	4111	5798	5798	1616982840000
7933	3NLZyqKp5oTLCu4ThEUX6DMySWAPAXZVFXUyVzfKpkz4PsqLvsdJ	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1476	1245	92	1	6301	jwcruE5UN74STr6RUz82cwCJuvUgqsKTHUHyEb67McYaZbxdGss	4109	5798	5798	1616982840000
7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	7929	3NK3HQh6s7Hy5DiQ7X2BdbVkm5TzVh6c2jHizwpk8Akmo2x66wUJ	1457	1391	92	1	6301	jx2yYsv2PXU2mBvJfVRc9hDhD2JyJBwm3p3N1FZag3Sdp2GgyUe	4112	5799	5799	1616983020000
7942	3NKLt7CQyC4HdZmUfAfGMoL5XdBfESuPQQ7GPVtHqsoxZG4B1P8t	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1581	778	92	1	6301	jwQDJHqkKtAqdNuC7CiB6onU7gvJzuQhncWEd2k9ErU7oaUNVkz	4115	5802	5802	1616983560000
7943	3NKDQZ5D9nbNuDLT5KShhRLWb3HepTrwRpcXw9dfDGExAJwhiE8k	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jxfqxvjKh4YsY3JZueezSR7KevGSiwhxqBz2eLNEeMi9wtZJqd2	4116	5803	5803	1616983740000
7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	7945	3NKxbE42XuM2WgcqgWsGKwdu9p2vzQW9Vx6YsjLr2kMFZPwnmQKv	1673	1002	92	1	6301	jwHvFUGgDabJ1jpYLD2ZKxG5xYs5exCZrhAmuPR8HTNvUGiDrRK	4117	5804	5804	1616983920000
7952	3NKpNcB19mujF1Eb4g8wZUdehTJmU8beoFeeYfkSsn7E9Magjzmk	7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	1549	1362	92	1	6301	jxDrLXzercvpj3oXPTmJj538PrjpZzWamtoBTGb8U7Xp83z7Wc9	4120	5807	5807	1616984460000
7954	3NKomodL3S4UgDrr97ubx17ut9gGC9KJrm1vsyBiFxonLD8g67BY	7953	3NLnib2yNkLZhSePBiPf9rB4PHRo6K2Eis1Q9AFBXMG8StzHmcuX	497	657	92	1	6301	jwpyQKG86zp3eeAfJWcsfvFTbGFZy1tGB6TPUboqtKp4VkFLvah	4121	5808	5808	1616984640000
7957	3NLjxnTeKh8Xwd4SL9m99X5wHfTb9XeiHRc3aM77Y2NkdfJknccE	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1637	816	92	1	6301	jxGF8JifuwKxCTLVbB3cYoKy26scWXgc7rApZQjrcVaAYvERnR6	4124	5812	5812	1616985360000
7963	3NKKRf6yyRx1XoxVqHAxkTuuMBhxvxWhMQNeqGomsJYFETFue7Qr	7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	1406	1393	92	1	6301	jwTZ7sbPng19iMi18w7iowb8br8jKdsj3NsnySq9yr2gv6E7Ent	4127	5819	5819	1616986620000
7965	3NLybPzHUV5K8txnLyYN3fx9PpFkAA1avPo8BM1gQB8T4xWzzJQ2	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1619	1275	92	1	6301	jwNivj3Ctxf8m3bpM8Gj5AEuxMDbCLbqFb8vPCky68zcyKTzfLR	4128	5820	5820	1616986800000
7972	3NKXdceDGLcz4gHVa1tPSnh29Q1soqbehzVrNubJFepsnqFeNP6C	7971	3NKhjepU9MUfJGYMR1vrKJC1XrnLFM7L6tn1Qv37hFdHkkfgM7mw	1477	1224	93	1	6301	jxKvFUUkApRQtBJedrobyNkbeEPoBeqRmcbk8k9EjaP8ajCH7ea	4130	5824	5824	1616987520000
7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	1407	1395	93	1	6301	jw8HegERzLLGZxZmSZtiB8axA3Wiy8SEcwm7kLXRWWUQL1t77yt	4134	5831	5831	1616988780000
7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	1407	1395	93	1	6301	jwhXSRxsb8SB1SAFtnVENNge5t6KqyuyVYi8aSgEmmTiufWK8do	4135	5832	5832	1616988960000
7981	3NKiewZ7j39nZsqUE3FLNQZiQPSiY8ZBe1BbaeZ6MLTNrAvvtHnf	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1610	1314	93	1	6301	jx88bgfUyCXWgzDm9ZHqsaYmFxp1BbLGvVZUWT6kasrh8TMdNof	4136	5834	5834	1616989320000
7983	3NKpyr8arPvQv3d3fWrtefEA2WLveHK7Eohz5f7YgGEDSBaVMFF6	7982	3NLRzKgenbcigVKTC8MJVecJXmZ9mbd1q6AHXkH8VUqejkAkHtPZ	1631	793	93	1	6301	jy25wypQp57SbTsHVMbgU29Zj7Yp6WTS1uSYY4TcaDKuWfsboRJ	4137	5835	5835	1616989500000
7987	3NLiGJGWJJnoJir2477a7dkek5oTnkds56XPCqkvi1NPUKwZ7pYj	7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	1610	1068	93	1	6301	jwCy6NTp4Rrhra9cSi9EjFv28uKqkG7aotdtAmgi6JUSvQjXpXk	4141	5844	5844	1616991120000
7990	3NLXmK9ZbrmNUUdoMahM3GUnZbi368HLnroKBzPDvK4KzYpM5vgF	7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	1581	778	93	1	6301	jwu9mh1bJWZXtURCAZvuMRyc1o21Gq64Bygr2rtQe75356N2NmN	4142	5846	5846	1616991480000
7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	7991	3NLDgBFCLPDkRVeS1Qzmp5nmJhzP9wvBiE23vm5QsaTZGrJYkppS	1622	990	93	1	6301	jwa8ExmQpPjFjjUkMTrMkzfQnzifuvFF1oJFuSDKrBwNgs3SZaL	4144	5848	5848	1616991840000
7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	7993	3NLpS1NqLMJCN38L6ZWffJu3zJRz9Nc8j69KDoYApvLzpEDqBxSx	1406	1393	93	1	6301	jxivTT5NWANNbvFBzc6PQjFHGJxk9fQkwncpovvsbag9bDF3344	4146	5852	5852	1616992560000
8002	3NLfKQCJSYWQgD2cyLsWXuLtKgovC6kcRDSpjmMeKGE3LpsXLeJX	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	1523	1321	89	1	6301	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN	4014	5853	5853	1616992774455
8004	3NKWkDn4MixL6jECdNMSmWb4eB5dAMwQZXHAAGtn6HdKJsmZk8MS	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	1483	390	93	1	6301	jx3GDVviEFjWzXqgMMKaNgt1EeU9YQzFpo9u9ynjYCmPWDGvU5M	4148	5855	5855	1616993100000
7902	3NLLX2mZTYZV27vzM3SXpcPb7FmLpoCfUZHGKwcxxSooiijB4psK	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1406	1393	92	1	6301	jwg7oMyfWRaZL8ifiEh8yV853actKaWQyam2uj3CwR1u7geNo3F	4094	5774	5774	1616978520000
7905	3NKp9zLw7pMbswwAfTtfVpNY5HkthmBWqw9jp8jYL4FZivWUcJmc	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	171	1374	92	1	6301	jxo9GtTRFx3ZPNW84Ka7zj5mKvPfG4mYzpPTe4oBbkgYTHFoHFK	4094	5774	5774	1616978520000
7917	3NKvysxNPLNJiux5in2WVmSwGKaXSYozJDiQarrRJxHCP4MJ1W4X	7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	1430	296	92	1	6301	jx98UWoqLW4NYVs5NuQKbR7puWgwP3n1wuugqZGmrWD31rfsJyE	4103	5784	5784	1616980320000
7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	7918	3NLiVub12qx2jK1prqXA15XbXPRP4JNgH2yVvkk31YCY9Eh9CQvu	1403	824	92	1	6301	jxjfobwYNN7sBeiVcdpdzwFY2JayMC3vjbrwh5cMqgAG4ABtqHu	4105	5789	5789	1616981220000
7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	7922	3NKm776GCS6Fqm91YCA8p6agstHnjB3FT9ncB47qX5vsghu3yAhi	1490	1028	92	1	6301	jwqua4THMocWGcBxm4gwGmkBUAfDf8e88WeofyZ2YR7vKaJ9zPM	4107	5793	5793	1616981940000
7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	7926	3NKseYQc4D5Mpv6ZoPdHPmCGEsH8rGNkJrAxFcSsD7DKLVCfwrhR	1653	491	92	1	6301	jwTFCS3o5JB8ZfRiYA9YG5nsPxZGPdE3q43fv6JPxArX5ovJNx2	4110	5797	5797	1616982660000
7931	3NKNw3DXU8nhPb75BxP7DXbXCkrvVZpnK6xztQs2pbBCWzJhLPVo	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	1476	1245	92	1	6301	jwrUpjevqLbRjMMrFLLQbzC32TJpFs8H599vWjsRubLtYQDrvW3	4111	5798	5798	1616982840000
7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	1619	1275	92	1	6301	jx6EiGEW28c4t9MhhUbUdVuvbnuPDfLNK97MB9EUH1QfZ4uChSB	4114	5801	5801	1616983380000
7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1407	1395	92	1	6301	jxBRTAwFcHzsMwtCxPoYarWewgtBTG42J4YGXPoFG6xfTDx6b28	4115	5802	5802	1616983560000
7944	3NKKcB7UUiLToB7kwStVgHbZgZ9aCYsPezxcnKtjuZvzZrJ7Cd4A	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jweFf75Ju7kpzVRt741dTBabb29bs3YYh5GrrMJcqN4kHX392pG	4116	5803	5803	1616983740000
7948	3NLF8SL3Ry7JfXUfuzGkAPk66dfNGZwhj9MSijAYfQgA5QYbFWw7	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1406	1393	92	1	6301	jws4drotiiXPZwMukp1imnunV5Wz8GnGsGTy8P42ydjJLzcW6Zk	4118	5805	5805	1616984100000
7950	3NLRvgmpxuUQhQ7sqXEmSXkiKJcaugHMS4Dc4s7QQpDNJGWHN9U4	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1631	794	92	1	6301	jwk9uHvrLgGv4oBCvHW5EQPfqbveSgf8N2s5jxjj2eSJgz9CnDB	4118	5805	5805	1616984100000
7953	3NLnib2yNkLZhSePBiPf9rB4PHRo6K2Eis1Q9AFBXMG8StzHmcuX	7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	1406	1393	92	1	6301	jw8xp4kkaBtD1othExmWJmegZ1MJQstmRfWWba3PsMKWcCFLrDR	4120	5807	5807	1616984460000
7955	3NKAEGAkYzth1WZkLAYDBGJgLLv5w2NpXqGkJE9Pu4mRarUUdykq	7954	3NKomodL3S4UgDrr97ubx17ut9gGC9KJrm1vsyBiFxonLD8g67BY	1460	1078	92	1	6301	jwqEtcSAEwax1FMtX2oiC9aCQARUU9BfuZUs1kH7vx7RFMNZ2QD	4122	5809	5809	1616984820000
7958	3NKpoeZNz4cMjfMzUFbUYxn8rPWUWyLHJKDeDWBwT3uUUeK6z48A	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1439	1033	92	1	6301	jwNGByFwzKX1wNyU6B9XGCPSiohvy5ZMvWwtmy2wa24u6YYy9Po	4124	5812	5812	1616985360000
7960	3NLQWpAvvYaknfPy1NZM3FVmvLcdk7N1dRBgmYDBeKyZrfweyvct	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1553	776	92	1	6301	jwJ1WCnWBXHGdhc5qHn9D1EyaUwV2xmgQu34copE5mdZm5ja49z	4124	5812	5812	1616985360000
7966	3NKrLhDSTEJZL12LhXSz82PN4q7UMnXfJDwGPBqqN2TomTN1Zun1	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1599	1041	92	1	6301	jwgm9eSvoXyJ59CddMhMHYgaiu7rJU6XHomf5HPriD5vGmQVzrz	4128	5820	5820	1616986800000
7973	3NKSndqLB6JU12Mm5ycyPA97DLh36BLiKGR7Qk4RjxanAso1R6Cr	7972	3NKXdceDGLcz4gHVa1tPSnh29Q1soqbehzVrNubJFepsnqFeNP6C	1668	1244	93	1	6301	jxNjS5U9b4yNc8uSHqQPeXSNPR4NuZK6HJZPNxKARhJSjefekAH	4131	5825	5825	1616987700000
7977	3NLuDfFnVqexTh9LuaTH1ebGfHfq8Bq4kHEYFnkSer8JbRYCz6Kx	7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	1534	156	93	1	6301	jxnbrZ3QMSM633fiL4QQYcSuo3hSWdibaUMk4QLk8rLjtxMJ7D4	4134	5831	5831	1616988780000
7982	3NLRzKgenbcigVKTC8MJVecJXmZ9mbd1q6AHXkH8VUqejkAkHtPZ	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1483	252	93	1	6301	jwmDArn87XSPTkZJMxbRGPrq8Aixv9qPJkQDeHY1UiJwQgzW6et	4136	5834	5834	1616989320000
7984	3NLi2zVMXrkeWg31HELZr2SACEv16Y8YEepuFRJMikWVYzFZ13dx	7983	3NKpyr8arPvQv3d3fWrtefEA2WLveHK7Eohz5f7YgGEDSBaVMFF6	1460	1324	93	1	6301	jwF8tM4qf7VK9PgFJHenKBaH7HyK4L3JmbeBQonjRNssYM1ZFZj	4138	5837	5837	1616989860000
7993	3NLpS1NqLMJCN38L6ZWffJu3zJRz9Nc8j69KDoYApvLzpEDqBxSx	7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	1406	1393	93	1	6301	jwkBTKPAnVwxGcxzSmefJmssRYq19ymR2jemcgSVJwr5LjUtHWo	4145	5850	5850	1616992200000
7996	3NKJrDMbJAaRVzFTKJSdHoficRFMmX7HNcRvhFZ3yT2uobWojtcU	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1523	1321	93	1	6301	jxXrrcjMFkDs7TyjrQB762QAFPWtyDB8VsGszAGVkPUMPthMdLo	4147	5853	5853	1616992740000
7999	3NL1y19P8G1dPvGjuJsVu7s6Pq1J75KrMqHpAFNf4gtUjAJ4yMTD	7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	1523	1321	89	1	6301	jx2dqMk5MRxfUATS8x6KQYXNQGPzdrdTHGvXpQp1nH3T1ve42xb	4000	5853	5853	1616992740000
8003	3NK7s7V6W63PjMoWUEB2w1F4ZBzvfg1jFajTMo8q84hxAJP7Vv6X	7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	1523	1321	90	1	6301	jwMe1AqU12ExzA1KaMr7pdEijdmggaq65doMAK2fpaeWFoKrAjX	4028	5853	5853	1616992805961
8007	3NKUsNxYdvmFZ4eHAy7rgRA3EaFgsFdb7DnWskmz31wTAcfQMa8t	8006	3NLhYpKiPELj8YArcR3mokiaCYxPGVrfgdqFfPTz3TjM6KjRynFR	1631	794	93	1	6301	jw7Cjk42wrrCemGr3bJ9QwPMtBFbeSmbYotv2zfMgvvUUYHfojx	4149	5857	5857	1616993460000
8012	3NLoAsKA6qJm5NMHcD8KaMgXb8Wxk35RxwkF72aq7iXrzBFcs4BH	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1673	1368	93	1	6301	jxJGCVtHbGEZVWh238MqNmPjQqGmEo2TaSVdtyqEF5uGsgRiG9g	4153	5861	5861	1616994180000
8015	3NKAvZsZ4gDNZFEDXpZ672wJjy7PDg48hco82cNsJreRC3fvk4Vm	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1440	1251	93	1	6301	jxVQfscs73qzJqjZ9UndpDcD87EWBbUnL3Pcc63RpYpkczd9Kdo	4153	5861	5861	1616994180000
8017	3NLZGH5cWUz6zs3S4bUQikje76VhtuF6jowevdKnQERqMU3Ukzh5	8016	3NLBW3YoAAN42NWspBfFD7uUqgCTuEd2Zr9pRx82XS2jG5KAM7kW	1560	1165	93	1	6301	jwMNiGuu7KG1XByB1p1WQNHBb7qJL8f9q7J81pRkjVtNfhfxZca	4155	5865	5865	1616994900000
8020	3NKtvuhwFGvzCuoYszaTfvZeoMkdKZruFtpXhp8kBNznwtJwum1p	8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	632	1136	93	1	6301	jwHvMmNGpfrsKbdmXpz2PgpYUHk88gpL61Q7f1o4XSoWyc34uHH	4158	5869	5869	1616995620000
8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1637	816	93	1	6301	jwzZsTDthnKoehVKeQwQXH7igtDSR6JoW1KaHYH5b1Uc4MEbwrK	4161	5874	5874	1616996520000
8028	3NKkEh3oof6EaFc9Kti2vYzvFvhk68ooxxnoWMvRpjrXFeHp6S5P	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1601	1388	93	1	6301	jxJan7Gykg4sWBuUiBqcRsCfjwmXJiCQ6ZEHCuxfUtEhrRnp9yH	4162	5875	5875	1616996700000
7980	3NK5FP6w1gJrhNtuMGCFLpwAAN96aRmRRA6XLjSEznawpCxvzsr3	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1407	1395	93	1	6301	jxuwQHC6K3Ev9kjpjeHmc3ni6QXKCtYggDqvXUaooyEfTpzKZe2	4136	5834	5834	1616989320000
7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	7985	3NLuYLefecnBBi53dkKf3hoF2XZhuS52tDmwW7BDoGkCqDGUUuZR	1440	1011	93	1	6301	jxeDWDih8k9edT2CLb6JKNCV3jiufwsNFeYT3wHcQExuCz2tReM	4140	5841	5841	1616990580000
7989	3NLjwwtEgHPJ16aWfnAm4cdedsAkdkmhdajTZrPFUtV79JtcNNFD	7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	1407	1395	93	1	6301	jwZTwry6wy2NNPwkMmP8W8rVzu4WHJCwcYVAzsHGPkh7fWuRDX6	4142	5846	5846	1616991480000
7998	3NKziHm8eiE2AY32tFSjpEgDT36PFd5g7YpPJe2iUo3bYdcSLpZL	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1407	1395	93	1	6301	jwZjFYkodL523ZqRotA57eq4yGxVVWxHNR6YpAhFpRsiqdPmzeY	4147	5853	5853	1616992740000
8001	3NKCLxvSQUAJQd2UR8FRo4BVBaKzCf9mZfjjbGzJBH6zGYSdAVRF	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1523	1321	93	1	6301	jxHGSEsQWmXRHJzzyYPbWS4cwK1dXyaSar9rC7hsCup8ogGdqwG	4147	5853	5853	1616992740000
8006	3NLhYpKiPELj8YArcR3mokiaCYxPGVrfgdqFfPTz3TjM6KjRynFR	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	243	243	93	1	6301	jxoJW8JxTFyLGrjhneEWou9Dec6XV5g5xe828FAfiCeZhLHBdHR	4148	5855	5855	1616993100000
8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	8007	3NKUsNxYdvmFZ4eHAy7rgRA3EaFgsFdb7DnWskmz31wTAcfQMa8t	1608	1289	93	1	6301	jw6nUkV4xyt6JGWkjPX5Dp1P3uCBG8jQ3AqHYkc4eptWCNh5iA9	4150	5858	5858	1616993640000
8014	3NKryhMCPn1FNZoTpSYS45TVdPFbnJjvcLW3yFat66RVrdfurqvj	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1517	197	93	1	6301	jxQn33sJoxFxbwWp8WVi1oez89yC9RavaNNg5SLtHP4FDqsHMZ2	4153	5861	5861	1616994180000
8018	3NKQdnp9xS1oS98byBtkXWLks7cRXchQiZzPmzCiNQPqp8z2toBx	8017	3NLZGH5cWUz6zs3S4bUQikje76VhtuF6jowevdKnQERqMU3Ukzh5	80	907	93	1	6301	jw9DGPdG92uYKT3Ab56VC9tEoxBR9VnjjVTi27WmCK4Bp47oDax	4156	5866	5866	1616995080000
8021	3NKyYM7gGXNWTAXbD19Pj9eERy55gMmEKue1q1CFKK2WpXaDCjzo	8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	1675	1342	93	1	6301	jwfk6Jow2aRcjtXkFMxcLWciDmJNmgRrkewTeCE7ns5sPL25rfi	4158	5869	5869	1616995620000
8024	3NLRU4VrT8RQC5dqoMaLEm359cvCpDLYiNixwsMSvSJg9rEEjGx9	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1509	1320	93	1	6301	jwvQWK6MvxMGRNDpKZqJiZwygegdwzfdPw3DdcARakhi34grxy5	4161	5874	5874	1616996520000
8032	3NLwKL4t5ZaZLE26qmXiXWCSRekEMwUhAm88XyKGTa4gtkn4x8uf	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	94	1	6301	jwaqA3aWKMkbZLWsL2kueUWPwoSPfoqYRCWi1DcB5H18DwtAw5k	4163	5878	5878	1616997240000
8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	8034	3NLD1wo1QhM8Q1ChhRaunKKznTvF8ji8H9Db6dV64hS6cZuLbwBk	1457	1025	94	1	6301	jwaJv8qocdaks9h9S7W5odioNHXqdSLVXT36fK2twip5LQ3k1SL	4165	5881	5881	1616997780000
8043	3NKPmdvB6gGTJeSjvytPx21UK5ZHhkToF9d4Xv3Auun6B9qAW3FP	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1534	1317	94	1	6301	jxY218dQEHsXBmvqAuXEd7G1SkuygUtFBNpSgwefhcBHSyvp7ZU	4168	5884	5884	1616998320000
8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	8056	3NKiASiDTfSALex56aiU9yfh9tcQJXS7NLQQDWwzvnzsxyWYf7zT	1403	812	94	1	6301	jwNPeqytBpRrDLGSen3BYWVaPyGNtJDj27moYDDsrWwkof6ubDA	4175	5894	5894	1617000120000
8062	3NLPDqT9f5p81NeLXwZviisCFCws3oghBH2rNGnmQVP1dcor7BTK	8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	1406	1393	94	1	6301	jw7XmNWT6GU4vtL17doC4CiShQPkXFKNc7MDCmjf51GmegMm95G	4178	5898	5898	1617000840000
8069	3NK6AmVwYuPMwEsMbjonhdqNtvFBp8C6As2N82fXsDuDufd3RsJA	8068	3NL88Nxxirtv8LFg3CuMyy5S5aaN13ggaDvXR6zc6vYWAxv2ny8V	1471	1140	94	1	6301	jwxaUU1xoE5eLhTMfEss1UnvU4VKAcU7vLcvmDpomn4GSntLhnL	4182	5902	5902	1617001560000
8078	3NKq4UDi8AjgvFTc5sMEMz2zsKdUUfLXZH1CYXQ3hrRzmJP6m1TZ	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1534	951	94	1	6301	jxcRAhzqxQyZXxDHoMSfKSrM8QbjVustUctHiHNYqYukWRGVa6q	4188	5912	5912	1617003360000
8080	3NKp442UDLpEjrJ5K6xE6Fi8hHHy1pqstNfgxHPx5pJBhAm6rWUZ	8078	3NKq4UDi8AjgvFTc5sMEMz2zsKdUUfLXZH1CYXQ3hrRzmJP6m1TZ	1407	1395	94	1	6301	jxm559sDVk5MxfqSw46ZLF56r6ii6f6axEmxwWKBfpnuJNxwYGs	4189	5913	5913	1617003540000
8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	8086	3NLp2QnSkhtRpyVm8JoC5jCQEDe8nFjYSxReMQviyjnTD1fcZ1V3	1471	1140	94	1	6301	jwU7XjvLXrqeTYmwRFymz6Teg6Rhc5CHb7NRt9rCsmVDkX4QoVf	4194	5918	5918	1617004440000
8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1402	868	94	1	6301	jwCDovxbpptEf37R6HYbxLycUh8K37vdHQV2YouJvQJuBN3bE2s	4196	5920	5920	1617004800000
8098	3NLEMuZAAEbmZyYC4fginpAdVkm3b4rsMbevFFfZq7sA42qg3pxX	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1631	794	95	1	6301	jwznuLP8HWj5S6u2YQXqAXAwdBBawpWQ9BgoyPjbhGZzPYm2qQW	4197	5921	5921	1617004980000
8101	3NLNcVGTZrQAfJs7rv89wEs9nCTzWQYXx9HiyktQXgYF3dAu4f9F	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1642	1241	95	1	6301	jwS4hBh8jDVrH24BbT365q8wr8G1ZBK59NbWgnGSAsA9diLYfKV	4198	5922	5922	1617005160000
8103	3NKnd4oigxrnaHLjhV63FduuRHAeeAEJ5zMJCdwRj7XTMQ8s28bx	8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	1406	1393	95	1	6301	jxUmf4bWEAj44xRMTxLXfx6bEZUHujnKPPQJ2Lp1N5WFKcPARuG	4200	5925	5925	1617005700000
8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	1541	1298	95	1	6301	jxRpK78mnMe4kyMUyEg1BfMp84wW6xPxrjHg6rQ2bsbF5ybGezv	4201	5926	5926	1617005880000
8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	8111	3NKjsng3xQ6b5HWmiBXBvsirGHWSx6pnz62VT8uq2DSmULwa7dzR	1600	1246	95	1	6301	jxSzjxPzESt8ageQebM6MeCwCHU4KKPGxmfmcv8PYUPuAknrKLP	4207	5938	5938	1617008040000
8119	3NLvqFDfzVj2vaJuBgDqEMQ8ounJFWBsXDqsRWVvHNo6KDYgD8s4	8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	1406	1393	95	1	6301	jwz3firWt1VECWwusL2sWB2Eb6E1A4aVuHQoUmxwAijcnqVMcWF	4210	5941	5941	1617008580000
8122	3NL9Fhow8B1fX2Vde9WREGsU2jgGgFBVhyg7vLFzjA6xKUAxxaie	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1403	782	95	1	6301	jwLpNMC3189iRrF7URKQsg8azsz9s2AcQgt8DF988qrNxmv3kYf	4211	5943	5943	1617008940000
8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	8121	3NLbW8DYUW19N1jXTVbkxyrGRLA8LzMKbGha2K2T6D3qK5nmL1LT	1610	1068	95	1	6301	jwuJQY2V4NQN7BDXjcPqHBWWEP94mgji1hY2y5NUHtCeqtSwG7S	4212	5945	5945	1617009300000
8130	3NKPgS1wKn24tqLUb235qcqBtuyUFVRmRkbpfgeoNmURbtXTLFa4	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1403	824	95	1	6301	jxJShw3afUF3Leqmq92vqc5YtCpc2S9eMdAgTtgXWjh4N6efFgm	4214	5947	5947	1617009660000
8134	3NKsgfTWdh7EpUvV1r6dSQo5poNoGkfM3GM1897fmij1ZiFtRyHT	8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	1631	794	95	1	6301	jxqGC9BkKrekofzbZXqbr9DScvw5DhyrbBCnHPYgN5yy65gR9R4	4217	5952	5952	1617010560000
8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	8135	3NLBTPDRkHPfgvUEhEmAhuN2fxGmTbFHt2HWSppaWNKSJzqXsbak	1656	1097	95	1	6301	jxSuS3NFifdd8kF1cxvKBgidyTfLUC1XwQ5yCCP1pK7WPZniBpy	4219	5954	5954	1617010920000
8005	3NLaYMDA3jcDr4rmsfaQtZp9YgZwJtBB5e598Q6DUVrTvbMrm27Y	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	255	255	93	1	6301	jx5KXtGnMfofqGHnreNRw43pbufYpuxYPFwMQR5H9azSrPB4qzG	4148	5855	5855	1616993100000
8010	3NKaByVoDkgAHjxyS94J18yfm7Th7tcDm1WoYn6viFx9X4Df838t	8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	1613	1103	93	1	6301	jwo3pskNH4etHnErSrvZ83TJoWzNoEkvUf6Lwtn51dJqoUK9jCr	4151	5859	5859	1616993820000
8013	3NLFCrWZFZUEHTGD6tFmX5mW1o8BmFiD3WfXNMBRrELYJ6iY8Lmd	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1460	1324	93	1	6301	jxwZCLGD7ktBGUGeGf1tsZUwMCFvkD6YMoAyAy2SKfE1K9fBJSn	4153	5861	5861	1616994180000
8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	8022	3NLLVfA8ztbpGFxfdRrmmzh99UAXxZHSn46VWiUftaLVo8s3Pwtq	1483	146	93	1	6301	jwR2MTzNxmLwTdqHj9ijnAeYn4hhc7oNCf2he92ybP4aVbBUaRD	4160	5872	5872	1616996160000
8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	93	1	6301	jwVB1gJnYaow96xaPDdYaJDHSccmPC7J7TuJitH4aUrfsTZgvj2	4163	5878	5878	1616997240000
8033	3NKUCKCHhAJFgVTAmzTNakJGMbxwC838ZGUeKRwaTFi4J2xYGE9x	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1407	1395	94	1	6301	jxD8paqT4a7dzVjr7HFDeJaVpDgbjYHn98NeTDHXvdmxnFFYFj4	4164	5880	5880	1616997600000
8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	1405	867	94	1	6301	jxHE1yJNrD7FhBnYHtkbYp7aiDNiiZELn8BMZAzhXQJVrHA53wL	4166	5882	5882	1616997960000
8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	80	1027	94	1	6301	jxYiokxzsB4Q6LiFYfHWBuBunUDoCuMr7T2HG4btmmPgtDAQ3q3	4167	5883	5883	1616998140000
8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1455	1206	94	1	6301	jwjFkiJKK4TH79Uu5cNtUFHRpEpfhtSMwmZ7pU4Bnj5AHaEcbNS	4168	5884	5884	1616998320000
8045	3NKRJ2RftUX8yDJQxiD9XspyzUhBPeVHV8oK96BRR2gKd8xFMrM2	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1513	1133	94	1	6301	jxhrL6TuVd9Ei2ZpAYMbALNb7Qy2ankCYX9Zyvkv2Sb4kQSsuJH	4168	5884	5884	1616998320000
8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	1581	778	94	1	6301	jwTjBEbfY9yaqCJqXfXq9AHr8TjK9L63KdA1uRHgg7M5P4seDPk	4169	5886	5886	1616998680000
8050	3NKhXWq1SMqQedfvsNBehf97UniZ7a3L6ZLTviXnFpzkod7iwSLx	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1402	866	94	1	6301	jxuz9N42kfqinobwGGyrLMZbQETv2xy5e2LdhPW27CzThJzFk8s	4170	5887	5887	1616998860000
8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	1559	1107	94	1	6301	jwXeWU7s1G4JyK5g6mAGnFgrs6LFEndCKTvFoLsZX9ZksfBC448	4171	5890	5890	1616999400000
8060	3NKRicEAwxbEvdYw2vNkqobQ69obRdpCmgaDRRD6NUwkETQ5KtfV	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1553	776	94	1	6301	jxCLNtN6FLALPEy723PQYpagEZY3L4ZVezfWaAaLvJpBqDhLRMS	4176	5896	5896	1617000480000
8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	8062	3NLPDqT9f5p81NeLXwZviisCFCws3oghBH2rNGnmQVP1dcor7BTK	1406	1393	94	1	6301	jxBve6g3tVh51sQTewGyZRR2tPd2zevtm67rCvQ8sVMQuUrXRrz	4179	5899	5899	1617001020000
8067	3NLZNMUm29LZ43cNit8LB3sRq3zPbfAuxirPCsTpYSt4KobWVHef	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1483	910	94	1	6301	jxMV36K8PvXdrGewa59Dfe1rtrBCAoNt4P3aNrwcj2vyLD4yb5d	4180	5900	5900	1617001200000
8072	3NLS9nZm5jUzrAopGQMNkvpPjYxoKVaFtmmBEPbLqRm4ESiL7ukJ	8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	1403	824	94	1	6301	jwL5aq5ixCCwd8kQeedseMj6DBaEyupitVUPzB8AiCLmu3dEEAs	4184	5906	5906	1617002280000
8075	3NK7NnJowaYK1ok6gL6Jer18BwfBCSbntstmjcibn7dFENfALi3d	8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	1657	1344	94	1	6301	jwQEFQxJ9FzgZb8K7NcQFHaQ3iwMFguCZq9B29gsSVE6kzgaWqv	4186	5909	5909	1617002820000
8077	3NLEkmapuzWHYgaQtZdUjP6SBS83aZM1Zm9XYWs5AvL7LK7xr6E4	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1407	1395	94	1	6301	jxWiR2JGuLSycyoeDR7tL9qkbyUU1zU3qY88Te38ZiNVTkBD3zD	4188	5912	5912	1617003360000
8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	8081	3NK5w2Z6pv2B4VaonCSSUGsur2bYofyPTXHpdTWuGpj3jRryZEFU	369	1066	94	1	6301	jxe8vf8ZxGh5GsNzeut2Zj9qkHpKpG9wz1GLnPQskVuJaR3vKPY	4191	5915	5915	1617003900000
8085	3NLefGSrQjhTCx5TNEhyDgN7eB3ZRZ3yv5pjFay8AiEpkrVaSdFv	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jxyTLGzxdr7si1F8o7fnAx93kYpb3ob6rvVtvPUDYLgXDgELf3Y	4192	5916	5916	1617004080000
8090	3NLdsttVs7WMpEQQAU6iHppa3CFPP4XEBLKWGYFdw5DQCjBJdaRv	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	576	1355	94	1	6301	jxRoXxVFsXC1RdhWupfN7qQK4cQvwdUcc1kr9zYHG929yUkyJuZ	4195	5919	5919	1617004620000
8091	3NKvtZk6gQ5QWF5BL1Cxb8MBMoZxHWjV3jaqNrjCKPRj7Ezoc9i3	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1406	1393	94	1	6301	jx6RVNgThu5iKA5Mc4VHTzUJoaAJjULXuGcnMAVrvdo7iPi66bR	4196	5920	5920	1617004800000
8094	3NKqmPgE1mMreksdJctH4moSdUCRnaqVm3RFy6MrWYZV4yJA2tPU	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1490	1274	94	1	6301	jxFTabqWYoMnCNfwr5Rn19kz6DsDupSTDnLtUhRoMVnC6fjLZkZ	4196	5920	5920	1617004800000
8096	3NLBMFy6CBDYjcSXis1WZPKzdti5wo7kzWPFfzUJCLJnpgqFhuc9	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1527	1047	95	1	6301	jxMcoGv8PsJcpxrHrRUjVypdU53f9Yg2UwR4F1FgtwRRLBx1Nsq	4197	5921	5921	1617004980000
8100	3NKXJG9DapZCXgPCN7zwLF5zSuKmvgnyqVHsBDeniwNknqnbFxVw	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1581	778	95	1	6301	jxcstJEk6ykcH88M1F8CiaTrKvSh1i866NhGmwJLfRToGWWKovH	4198	5922	5922	1617005160000
8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	8101	3NLNcVGTZrQAfJs7rv89wEs9nCTzWQYXx9HiyktQXgYF3dAu4f9F	1547	1012	95	1	6301	jx7yv4MLWuAESatCUHtex5yK7u5NtPiHTTS8szFV5Kby83Xqskv	4199	5923	5923	1617005340000
8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	1474	1329	95	1	6301	jxjtoZBY2P8SJ9ZajCeotiFs2Ktu6hFUDXeRYEGtJhmyWPrDT7k	4205	5931	5931	1617006780000
8113	3NKs5yh29ww3z8wwAXdQ3aVBvdb7NRNafcPrU3v5SzpzLy8aCgE1	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	1558	342	95	1	6301	jwGffhrKGbcvXaGeynLSiv3ZsEWb9kFQVt5wBU1dw3f3AtaWy7k	4206	5932	5932	1617006960000
8117	3NLFCZWBVreeCSya9ziiyhp3nYyQ3w53TSEtxg2yirajbaXtkS9x	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1631	794	95	1	6301	jxqPCK6giBsLmy342bcY4Zr3TvZEuZmQaVXp4KQCXPPcLVRbYTB	4208	5939	5939	1617008220000
8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	8115	3NLpDC6CHd47wxDkFVSzD6jSTEaLUptbPXCfMND8xXhZtyHwT9y2	1445	1290	95	1	6301	jxdpkpg6Jh1QUwKLH8io2aNQprLXFG76DyJSKV5fEcsUhC6Xfme	4209	5940	5940	1617008400000
8121	3NLbW8DYUW19N1jXTVbkxyrGRLA8LzMKbGha2K2T6D3qK5nmL1LT	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1578	1296	95	1	6301	jxgfbTV8cdqqYFWtkj6hjDgDUdHYgC1fZrgc49MvgX6pfsbs5E2	4211	5943	5943	1617008940000
8009	3NL3GthpbxQCRjUnjYwR1oHfXGGP7NN3KwDKnbyvn1nbpXAK9B2r	8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	1585	1000	93	1	6301	jxR7fwRABW6ANyREXbDbrTh9GXLuokmLyTNAsC8oNZu4EWMxq7m	4151	5859	5859	1616993820000
8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	8010	3NKaByVoDkgAHjxyS94J18yfm7Th7tcDm1WoYn6viFx9X4Df838t	1671	1365	93	1	6301	jwBht7wN3JX3Uo4gAXqqx5zLFzHSAd1fC9p5A3hmcsBr9eQU5kL	4152	5860	5860	1616994000000
8016	3NLBW3YoAAN42NWspBfFD7uUqgCTuEd2Zr9pRx82XS2jG5KAM7kW	8015	3NKAvZsZ4gDNZFEDXpZ672wJjy7PDg48hco82cNsJreRC3fvk4Vm	563	1233	93	1	6301	jxKsdUNyjL9nbmYUsHYN5TbjBXS69t36YNCfMWDiNT3tjkVgyr3	4154	5864	5864	1616994720000
8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	8018	3NKQdnp9xS1oS98byBtkXWLks7cRXchQiZzPmzCiNQPqp8z2toBx	1406	1393	93	1	6301	jxVZWf7uqcdCgC9L3burWbSpZwfwRRbWJXELeLDWyX4GVaUiQHC	4157	5867	5867	1616995260000
8022	3NLLVfA8ztbpGFxfdRrmmzh99UAXxZHSn46VWiUftaLVo8s3Pwtq	8021	3NKyYM7gGXNWTAXbD19Pj9eERy55gMmEKue1q1CFKK2WpXaDCjzo	1440	1131	93	1	6301	jwKBENW28LqsxF4NDHukLsBZLp1nFR3weM59W7GZFUaDXSjY5gn	4159	5871	5871	1616995980000
8025	3NLUQUmBMYGmwfkAdUDuVUG5AtXsuhLaub49NBNBFUHL7zxhtu16	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1652	1189	93	1	6301	jxskaMoVskBqrFaUVz7BN8ARNgMiEWk9X8Ff9TaWN2E5Qa9yVo9	4161	5874	5874	1616996520000
8027	3NKWKiX8C4vJYyTxX6muZXeu9UmqpAxWQp71zArWfnLekXJ9YxQe	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1546	973	93	1	6301	jw7xUs7rUFfYiRxKbDrZ7JatsodYsecpUUDbFYz6spASiLgfFJd	4162	5875	5875	1616996700000
8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1581	778	93	1	6301	jwfSB2RmJxR337XmbG7i3pNTu6KwNxGtNfctbvJ7Su4LfgpNqUg	4162	5875	5875	1616996700000
8034	3NLD1wo1QhM8Q1ChhRaunKKznTvF8ji8H9Db6dV64hS6cZuLbwBk	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1402	868	94	1	6301	jwnTMxtumkdep5kkpxd2nU7zLVDxJSHP54FpKwK6a7mpxw2Wyh3	4164	5880	5880	1616997600000
8035	3NKFSyrm7FnBgfRwTuZM1F9WMcvb5L2zZ8USyKojMbPaCzZDkgtn	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1508	1141	94	1	6301	jxgmDQa1G1cMrpxaEvCheXnKduUdjPZawJUoZUDARNXgc1PcjMQ	4164	5880	5880	1616997600000
8039	3NK5Jy5KqGfEcjJjmJz35sAsZQnJUJWh2417aksGNaAVRdXWzkTc	8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	1406	1393	94	1	6301	jwbBKo3DyPqqk7c2ZCY7t3L9hENRNXgbgneFsatXYxNJoH6Fwwf	4167	5883	5883	1616998140000
8041	3NK4JBsaqj9PpvgFZYMMNw5j4YtQAitpUipNXgn7YuHrcqsh4x8W	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1406	1393	94	1	6301	jwursEygpNLq5g8FysHDot8EPFUGSdjarcTzaSEYUmwetMGK7BP	4168	5884	5884	1616998320000
8044	3NLCRgTMGidwLE7yoym1Rwe2K63f63z2j5Lo12PAwr21Bc1hmVU1	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	576	1355	94	1	6301	jwKsi1YrH1tBZkk7qwaD8VnEoGKEYUp9Zb9ZCLXiDtAutDGywvJ	4168	5884	5884	1616998320000
8048	3NLW9Z9jHr6Rmf62iRNgszZUpSjiLD9y4hRYFyXLVtTiqb7x4Zyu	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1467	1376	94	1	6301	jxJEQdWnDWCgHvhMZ5nFNb6EZzuG49VJ6y9Nt2722gv5jMwsMvg	4170	5887	5887	1616998860000
8053	3NLhvp6aYvtFDnqwywPxdLiYRsaAnyV4nk3YCZu3eGWC1euJSwuD	8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	1407	1395	94	1	6301	jxswDHhviZ4H4hFAV8hUZoT3gEVHJU7LvDKs4kMKZkzdtG28WpD	4172	5891	5891	1616999580000
8055	3NLqLKpDDy8JaY63p742cGPkr46j1PaGhMziAyLGqtk2PpZAVBeb	8053	3NLhvp6aYvtFDnqwywPxdLiYRsaAnyV4nk3YCZu3eGWC1euJSwuD	1657	1098	94	1	6301	jx1uUcC2XcVyFGY4XUagzy81NLuKLYYL6PLs6N9CpBZ8vvstibZ	4173	5892	5892	1616999760000
8058	3NKYYUFHrMx4D2M348nHkAc8iruxXbAibaRGuts8Whe3qugBaMQM	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1549	1116	94	1	6301	jxC8QRSjkKwAbNBiKqbXfUJdQ69KfSbiteupiTjNWeBppm4g8Jy	4176	5896	5896	1617000480000
8063	3NLwjioEsVvWGanK2B6EqZJ3A7cWtKjRdyoEe6T5Ti9DkJBk6VY2	8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	152	152	94	1	6301	jwTicfyji9an4QbJdAUekyjVn53zjd42ub3yv7NLkadx5VG9Uud	4178	5898	5898	1617000840000
8065	3NKeWBzZAhYxv1KyADNBeACxNqgKx6upbYCo3sEb8uPds9r433Jq	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1406	1393	94	1	6301	jxdAJjpoGaNia7WGeonaM3ZrJZqG6tJsScRa2iPUua7ioyPNvn8	4180	5900	5900	1617001200000
8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	8069	3NK6AmVwYuPMwEsMbjonhdqNtvFBp8C6As2N82fXsDuDufd3RsJA	1564	1338	94	1	6301	jxCVCq8wDVMukJ4TWAxLpaK3YKQ27J1iRXVy6DXMdcHB7TvJnaR	4183	5904	5904	1617001920000
8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	8071	3NKUnpD1GK33dH7dQE9qLuN1VjxUp5aLiZ4oFzaHwyzGhcXZYJCU	1440	1131	94	1	6301	jwfwZQGmL5BirwcdUDtvnKY9aJCByCjWpXmCSQ19pf736oeAaSV	4185	5907	5907	1617002460000
8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	8074	3NKG9nxVwoLrXAmwJKCDTqEZ78e741HMsvxc6UVMTWQRdMeXJBAe	1610	1188	94	1	6301	jwXQCRxAobjQB3Rh8d6hyiLVEF9AzmxMP2BccCHwVh33pS8rzHW	4187	5911	5911	1617003180000
8083	3NLidx2BKZv8ouh6Mw4smGwJuEsyybucpjk43M9gDu3V2Hewc2HX	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jxLdAPpUL16C68kxmZ7S8wCysTnSp4biJ4Cn4MLUpxiuVG44WXG	4192	5916	5916	1617004080000
8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	1460	1324	94	1	6301	jxqUsnRBDGu8RMiheZPJdHoZ1u8zPhuVobPNzwsKuxoYAVYaUoU	4195	5919	5919	1617004620000
8097	3NL5i62cJSvxQhNf3sUmrxJh3HJJaeFZBFw3iiBhWFYXzTfnBru4	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1527	1047	95	1	6301	jxMcoGv8PsJcpxrHrRUjVypdU53f9Yg2UwR4F1FgtwRRLBx1Nsq	4197	5921	5921	1617004980000
8106	3NKkqzzGVgX4HPzdNswXxApgg8nDuUWi9vsfjhwRmpJaBPuBgwHg	8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	1467	1376	95	1	6301	jwTcHWTmhL3xNeEUDy4mcbSk2ddwUHGhwjgvhtRvW6Ac4YYvN36	4202	5927	5927	1617006060000
8108	3NK9oYAdpJBHbM3tT86a9Un9r2zVGZ6TSHhxFAyPhNnNSetnV517	8107	3NKSDnzAMqbU8b45MPnTy4d2mHUxhjyvnMtnaBypXQMdsomq6xr5	1406	1393	95	1	6301	jxnoY5syxmLX83NXjtSEkgTxQhAvMYhaBLMKocgyXbTjRtzLa25	4203	5928	5928	1617006240000
8111	3NKjsng3xQ6b5HWmiBXBvsirGHWSx6pnz62VT8uq2DSmULwa7dzR	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	1403	824	95	1	6301	jwUH8Kjtt9NHNSPFKT6hsZsAGJnxCitHr2CVE3a61X5aBr9XXKP	4206	5932	5932	1617006960000
8115	3NLpDC6CHd47wxDkFVSzD6jSTEaLUptbPXCfMND8xXhZtyHwT9y2	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1489	1254	95	1	6301	jxPvLmPNR6GKSY7unzoyT772GTDQzRwX68W7ShocexKC6e6Mx3A	4208	5939	5939	1617008220000
8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	80	1027	95	1	6301	jxPovfuvmmWGFVzfexAR9nBC5M7KXxciXJw735gMisvsgmkmU2e	4210	5941	5941	1617008580000
8127	3NKHxTfnZ2iQhx8FhUhca64CniYTVehXWyoh5GmMxgyUhozGzE2K	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	369	946	95	1	6301	jxM8VikZRAZyQZAG4oLKgmRy6fWS9RdWQTVfgwNdSPkCMPp2ShY	4214	5947	5947	1617009660000
8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	8127	3NKHxTfnZ2iQhx8FhUhca64CniYTVehXWyoh5GmMxgyUhozGzE2K	1600	1372	95	1	6301	jxFC5uKfe4cS8nQAjJPgL6PpGvu4K5KKtgC6Z7rjA3E3bqFm1Nw	4215	5948	5948	1617009840000
8030	3NKkp1d1WjnbC2y6hp57RuEcV9Syrr7znkyXFfJtPvEm7LifSnSb	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	94	1	6301	jxMfPEueW87pWiqSFWZx2HPgaibaJcqZ4kTKMnbPN3yhBmfJs1v	4163	5878	5878	1616997240000
8037	3NK3vrHNb17QRrTZHzwXZBGYCcLJFG64H2JVaoJxsnGsb6CsKTi8	8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	369	1066	94	1	6301	jwk7vEDZkPZ1ZWdux1g4n9eAHmDgHaNFz9zsaBRjBahGHvxgYe7	4166	5882	5882	1616997960000
8046	3NLj8gALh1mtqYA4xDN1fTadWwDmEXjoyEdFTCiGsXZ1z2iUoFQF	8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	1406	1393	94	1	6301	jwAyZVef8iiHKx158Q8MxrQ1j5WDMpoZt264qYH3zTYHvXLN4Pr	4169	5886	5886	1616998680000
8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1406	1393	94	1	6301	jws45vjwdK9SWJp5JVnLH5nv9D1uw5jH4SAcsQTmCBibVacYPmn	4170	5887	5887	1616998860000
8051	3NLfiz8hBXRUwyP6VYpaesPX7uxYvtQ41nDrkD4eheVFdQJVr9GM	8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	1403	824	94	1	6301	jxnnniDfAXbEqgoPfHQJyT622DLuY9VgB5eJU6K9KJMpUCQbF8R	4171	5890	5890	1616999400000
8054	3NKq5S5HcMdvUGjt2R93cWvFUEB1ucCaCiD5wTUCeAVw5HqxVpRe	8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	606	1295	94	1	6301	jw6htQ1ukyQP15Ksrezbdr68oxtZqYvF9GzyrL9cau5we2ga8Gu	4172	5891	5891	1616999580000
8056	3NKiASiDTfSALex56aiU9yfh9tcQJXS7NLQQDWwzvnzsxyWYf7zT	8055	3NLqLKpDDy8JaY63p742cGPkr46j1PaGhMziAyLGqtk2PpZAVBeb	1610	1068	94	1	6301	jwTH5PGX9vh5MLAyi3G4fmfStrnwLaRYdQEVrEMq43nJZReX91G	4174	5893	5893	1616999940000
8059	3NLnVVXYsyVDCtZkbfhMvn3pR3dQVSzVdY4Y5eDz4v4bRsahEd14	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1458	1323	94	1	6301	jxk7MsNmyTRL7gTZxiNRyJc5mLsPvbT2xj3LhUrw87CVZNRh4jC	4176	5896	5896	1617000480000
8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	8059	3NLnVVXYsyVDCtZkbfhMvn3pR3dQVSzVdY4Y5eDz4v4bRsahEd14	1481	790	94	1	6301	jwMRCo4UtCJL1UK42NmP8wBwJYciQkFjegEesR4nr4JXTz2gMAq	4177	5897	5897	1617000660000
8066	3NKvc19a4gvJKr4vZ7HJc72p2k3Lv9xZxuEeBdG6MobRxLVT5cCj	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1642	1367	94	1	6301	jwR67vATuawT4dmXCcnCToYWqYoWPhFRkzEXUGxmA4Z34csPLkd	4180	5900	5900	1617001200000
8068	3NL88Nxxirtv8LFg3CuMyy5S5aaN13ggaDvXR6zc6vYWAxv2ny8V	8065	3NKeWBzZAhYxv1KyADNBeACxNqgKx6upbYCo3sEb8uPds9r433Jq	1406	1393	94	1	6301	jwjNGqLxDhwK1j7iJ9p9SLMLJL2xHAWdPqTimHxVJumWgwyCgNi	4181	5901	5901	1617001380000
8071	3NKUnpD1GK33dH7dQE9qLuN1VjxUp5aLiZ4oFzaHwyzGhcXZYJCU	8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	1402	888	94	1	6301	jwikacac6vxUXCajc9tvqwZ6QxfKroCR1uJAJqzTCZzjLJaZdnU	4184	5906	5906	1617002280000
8074	3NKG9nxVwoLrXAmwJKCDTqEZ78e741HMsvxc6UVMTWQRdMeXJBAe	8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	632	632	94	1	6301	jwGvM3rSExfFHfyqPcbUbHgF44NC6hVMQv3ieAnxYxXjYradePQ	4186	5909	5909	1617002820000
8079	3NLH3SQjHQXtZbYnJXrbrhTBcP8dWBC6q1oRSdG5ePG3ccVWPRSW	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1623	830	94	1	6301	jxhVYMCga8GiXvDWk59Aafebit5yC1t6ReRzaVzoojZzERhZ8ke	4188	5912	5912	1617003360000
8081	3NK5w2Z6pv2B4VaonCSSUGsur2bYofyPTXHpdTWuGpj3jRryZEFU	8080	3NKp442UDLpEjrJ5K6xE6Fi8hHHy1pqstNfgxHPx5pJBhAm6rWUZ	1444	1255	94	1	6301	jxnrSBZZWrvhphFnHiq8w7cDhY613SyGxHmJTMs4JVJaRgkM7mf	4190	5914	5914	1617003720000
8084	3NLYFDrGQEtS3T2gimgZy6aDZZtqKruMPe2iW1dVLb3WF5eavSEF	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jwf6imAhLB5hYb9RVRLWQ2rCmJGwLSQK1yvBvd8RiFgJXRuxdRn	4192	5916	5916	1617004080000
8086	3NLp2QnSkhtRpyVm8JoC5jCQEDe8nFjYSxReMQviyjnTD1fcZ1V3	8084	3NLYFDrGQEtS3T2gimgZy6aDZZtqKruMPe2iW1dVLb3WF5eavSEF	1593	1100	94	1	6301	jxWu5xQZJQrq5fUrWU2aTSfAvhcMqKNUK8XdkFphZP72DXzRHaA	4193	5917	5917	1617004260000
8089	3NLCQppLNZ7XTKugfhRKhnRnN3RP2N1oQavKoVP5nRQDp7reAXdm	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	1670	1156	94	1	6301	jxKTMmLBnPYLi8dm4yFqGJQMJ3xZAqUbojppJxRcWgNiWZMZZwF	4195	5919	5919	1617004620000
8093	3NLGnyhRU49rfEVCPBDygtWmUthfdFVqCn178WZwE19VzuNPWxQy	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1471	1386	94	1	6301	jwQbwWxH7VuRRjej94gYGJ5S6DbBtTGbBhfreSWve2d4BKJfeGp	4196	5920	5920	1617004800000
8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1406	1393	95	1	6301	jworxzaCEFXvLwftQzmVLknzrwKYvuJbE4LbD9oHWwsKCc7jiL3	4197	5921	5921	1617004980000
8099	3NLYSR7P3pupPVQeZwxbzDNpuai989gDhkbjYdvMawkyuhTjGMp1	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1642	1241	95	1	6301	jxLuJ7j3uuwm4VfNxKDDyBQcaecDJxKxqXAjx8Fpr9bmdk8arkZ	4198	5922	5922	1617005160000
8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	1631	794	95	1	6301	jx3vTtYuuefsspJFcBUAwDBWbQS8CFBFLsgpJwEizfo9UhN3wQ4	4200	5925	5925	1617005700000
8107	3NKSDnzAMqbU8b45MPnTy4d2mHUxhjyvnMtnaBypXQMdsomq6xr5	8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	1477	1350	95	1	6301	jxTQ8EzNN98uXgtEjwK7kFB3NxeSnoXsfKTXcoya7fcGEsEFiQC	4202	5927	5927	1617006060000
8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	8108	3NK9oYAdpJBHbM3tT86a9Un9r2zVGZ6TSHhxFAyPhNnNSetnV517	1637	816	95	1	6301	jxDLwwyJHzjV8joBgLWeawaENeXPVpoK5UCPyXVnLbKrR7SfnyK	4204	5929	5929	1617006420000
8112	3NLVnKUsAdpoLiHjBxCGqJeaxYwYAkeghrXzdXd2PFbDZ14rpZZB	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	58	915	95	1	6301	jxmp5rH9MNGyvNnXE1PBWpAUCf3T8B4heLgGmsbZZhhPvgYzGHH	4206	5932	5932	1617006960000
8116	3NKgryiQ5Ek4YJdhRk8adanRxEByMN72boZ196V3aAvWiBPSTKUL	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1611	1341	95	1	6301	jx721vxk2HEpDpmW9MBQzeWzF4BdbcY5v6GUYje6GTKJ4RyVzmt	4208	5939	5939	1617008220000
8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	1406	1393	95	1	6301	jxgZbKTb3fytzasBxhWeBSAAeBcBECbyykCi5N7Eehkh6vcSkxN	4213	5946	5946	1617009480000
8128	3NLtsVpdaCTcgXi52pwTDkywJ7TKcw3Mk5Hcx6eRh2kPW23ULhqY	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1656	1343	95	1	6301	jw9eqsrX2RSmcjufFre27vdWVm4adJyrN45mtpYvUN9Rv5kqDQH	4214	5947	5947	1617009660000
8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	1601	1142	95	1	6301	jwB59q49afa2ncbE2m2zrBo3miHEZJ9g54nW3xjvnVEocbgsoin	4216	5950	5950	1617010200000
8135	3NLBTPDRkHPfgvUEhEmAhuN2fxGmTbFHt2HWSppaWNKSJzqXsbak	8134	3NKsgfTWdh7EpUvV1r6dSQo5poNoGkfM3GM1897fmij1ZiFtRyHT	1549	1236	95	1	6301	jx39LmYpGF6EXiQMBBdGEN8dotmF9ZZyW7g9Smu9U25eJpoJSf8	4218	5953	5953	1617010740000
8138	3NKJ5sfqf6afxTczAvjKEwo8Kvn6Wz6vQfbaszRHGWJEFwhQ2MMr	8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	1670	1282	95	1	6301	jwYDNy5nSWZ6hHiNNtn8oggF9p6bsvtewc5devVa9KBAG57uRbH	4220	5958	5958	1617011640000
8143	3NLgWHLTDAym6tPoaq5RtcGcNLxJYPcpCPPzM6w1D5saVPXTaiF9	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	1637	816	95	1	6301	jwNDRkSus452eyLMRMurB8iqP2XY9qGRidkYwWhTHDCAiXrriqp	4222	5959	5959	1617011820000
8123	3NKf1ndCxupT9kLcgrfthCjwBk9SBJ9GossUhB4vKDxefZYE98rW	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1578	1296	95	1	6301	jxQAGo9LSmgLPgZkC7hgGLyzju3CgdL41Nhe8SmhX1DSKWqhb7V	4211	5943	5943	1617008940000
8126	3NKb5CnvpqCQZEiBNCJ2MRANhyXhadJBhDoLxsTKFM8Z2e5SFYdA	8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	632	1382	95	1	6301	jxBGDwFrznN98J7GbrEvvH82T5SMj2japgAsAt7Vm8MYyg5UQg5	4213	5946	5946	1617009480000
8129	3NLqyxqbY8KwW56zPjW3oCDFpPDEEsu7jvkyuhNerNw1oLsUm6ML	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1656	1343	95	1	6301	jxLfjW7R3jLXg8zBtMrP9wHYw1fgCkSCLwcuSxLL9fp7NsoZkHK	4214	5947	5947	1617009660000
8133	3NLMCeAjJPaKgkdFBG8w9gnf8UotT96aR3CLM7azSVggcjABAMJe	8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	1406	1393	95	1	6301	jxzi9mNjXovnPMFqrMsF1ZsQFMeGHJTVuMh7mmucAFwYhue3p6v	4217	5952	5952	1617010560000
8141	3NK72q4pGFASkHZNsmYdm3BKmFnL9bfPxduA8Rggb4KDBMFxfRsG	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	448	939	95	1	6301	jx4anu91TdjKwTAuwr11MxwtrVLhwJvViAhTPRhREsBeGS1WMko	4222	5959	5959	1617011820000
8151	3NKVSjyBVMkMXadYVN5XjB5dXf7ThHBmukGdtPrPbkA9Lo7TtkYm	8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	162	162	95	1	6301	jwSPFMXx2VfTT8wtjY5bP7vjqJgiZmx2raT5U6u6vbiC8i3y3Qf	4225	5965	5965	1617012900000
8153	3NLh1BmGjs2z1pLHFk9fuPCjoDMwEQFeX9FbHTfSxjoHLY58nSEz	8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	1657	1344	95	1	6301	jw8Hffv84WpvtpsrdSYwz9FSWbLf9hYfDBsRsRTxXMBQJoXemsx	4201	5966	5966	1617013080000
8157	3NLDmCTjzUVZR8gF8uY58c3WYJhe5cHLfyNnnkBeP3DU9USbnVWQ	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	80	1273	95	1	6301	jwzwZucaJs3BNihRBUFisSF9adZxkUUbzUdfCDFYB9zfFKmFGLM	4228	5968	5968	1617013440000
8159	3NL7nYSihGHKiinCNThcVip5c96sSc2W7VVd9Vh712ZSWedi9qgZ	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1407	1395	95	1	6301	jwpmwHrMfkTvBe69Cwcrd2LGhDGk7GdzzudbXNi2zYZCeof7C1p	4230	5970	5970	1617013800000
8162	3NKgnFq7xjN64JuxV1ZWFKrTqqCQ6snGD6nw6vyEpLscDr37wbK2	8153	3NLh1BmGjs2z1pLHFk9fuPCjoDMwEQFeX9FbHTfSxjoHLY58nSEz	1657	1218	95	1	6301	jxxeC2eBp476afWEs56jT3L8dpKK25zmAokAKfL5Rgzub8rMKgp	4202	5970	5970	1617013800000
8167	3NL6WQF755mfAuhybr3v1DKnTZnU5a8PWvXKKyMgtFVXH4hK6y3g	8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	1646	1354	96	1	6301	jwFreBsFPMEFsnuMjoDRSgS6zwdgoi215N3hTrowxWiTBMuGD97	4233	5975	5975	1617014700000
8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	8165	3NLPDWiJFwDUXyz6PgecZXCN6EQ9cQ4LndsWuDWpSBudeKDy95xp	1609	967	96	1	6301	jwZfCripmeG5nwTCJ6nu5HScgzhE8Kp4ys3a8z2enRBWWJS6uko	4233	5975	5975	1617014700000
8172	3NLD9ny5CZcRR88gZDmX8sdgNwgWJmServKdD2xzSDXjFbH1BGEi	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1481	789	96	1	6301	jwbia1Zbaf22C8JsJnBHeGFXvTsVyvGC917a1hQbWU9FrGSgcCG	4234	5976	5976	1617014880000
8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	8180	3NKBS1LR7dKuHHBEuDjxMJemB3Zqvq3uDVzF86kde6BiMt13famR	632	1382	96	1	6301	jxrt3bCLEPJphC7Xj94Kkm3V1pw8GLijUqob6BkYQ7SHBuYBb53	4239	5984	5984	1617016320000
8182	3NLMzSQ8SoYi6oQ18SCcjtFFxH7YcYrK6dKBJcxhATEJiBbQt3xU	8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	1527	1293	96	1	6301	jxeWwwcfGgpfAX4sDMFFhsbHHY6dDqY9VxYRd8qSjwL7ABvPwEE	4240	5988	5988	1617017040000
8192	3NLRvQ9A4Nky1QnWG8VBvVpEt7ANYdsgVXRUU2F43R6VvPoXGog8	8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	1422	1337	96	1	6301	jw7J4gpGi3hfYTyEBoH13eHQ1wLPxyV8AxQvHj8L52T4oTLx8z3	4247	5996	5996	1617018480000
8195	3NKgV93PwwwvT97JG6NiawqbswZWYtVGG6KBPzWQTz8dRkYsZ7iA	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1652	949	96	1	6301	jwwx7PjSXDQBeCxaR1iUinoESsfDQaoVePa3m2MCj3qCZicHSzd	4248	5997	5997	1617018660000
8199	3NKwAubhEAwzm3vHqXH44kLTD81RjoBXVPjg9ko7T5jQPCdLLUVX	8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	1671	1239	96	1	6301	jxx8jeRrA2ff4xQomCJLW8NC4Lq5Z9fR5krVUxcSYPM47H3iSV8	4250	5999	5999	1617019020000
8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	8200	3NKCZADDSrDixuT3oTncLex1mmhnWD1fQbdGfZyN5HXp8mxrYZ1V	1471	1140	96	1	6301	jxcwHLbstA4BU6ZcN6EZs5oQLvU9dRCvkBxjDy4yXo2Q6EH1j51	4251	6000	6000	1617019200000
8204	3NLi3Ji7V2BLBF9D4GPm4t2rq78JqBSAJuhTwn6VzfC6m75rK2dZ	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1624	1334	96	1	6301	jwWXHG9qcH9RrYeZSmjiTKkE2WPetZLTL8jdMGMpqpgn1rMppdF	4252	6001	6001	1617019380000
8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	8205	3NKVe9xHwxURrwsoKES91wKjvgyiNMEuDPo8JWfUYnw7yfJox993	1553	776	96	1	6301	jwFDkUyyBGFhvqJqtuQth2ACv9gYic4zUsnKVGWhnNcGjx2PG1D	4254	6003	6003	1617019740000
8208	3NLRuywHWQ7cQuzXDAjz4XEev8AjZQBSjLyYm2vp8wHeEhxEKS22	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1460	1324	96	1	6301	jwdAiPhUDYGSdCodhAQBT5aqDBkLEEFoFJjTbJRy8GEgnJMcj3g	4255	6004	6004	1617019920000
8213	3NKfzHzJCknehk6CZb15wPV5pMrt3Ghzbu6wkXpHTaAH8SEmVjrj	8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	1407	1395	96	1	6301	jw8joXXm7m5b3U1NWmWWNjR9kSWceTXrXgLJxkse6ZW3Safurqi	4258	6008	6008	1617020640000
8216	3NLEeSYW3v7vkE2c5pHeJNfc4gHLcuqPg6oAd2LP6j6igTmV7cv2	8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	1623	830	96	1	6301	jwKY8RHWKakc3rkjtF2WFKWi7jc2DbdaNdPWHcjvEFcre8EZwKd	4259	6009	6009	1617020820000
8218	3NKJvaPqMkZYqKXN39xYWEN918AQtBxctScSZiZRWFJ8618hKQ2v	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1407	1395	96	1	6301	jx7cWA9Xn5kQMfpX5dau9tPCCT2yXFHgRfaG62yCtAPi9nrZgMQ	4260	6010	6010	1617021000000
8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	1406	1393	96	1	6301	jxZudmLBF4LV5TwHHUAKvvSB9FSVRP7cVCWBr4fhQgXDrnbSzpe	4262	6012	6012	1617021360000
8227	3NKbxAgd8XwnphqCXrUUKdyU6LM2dtv6YHREJa78F7TqLx4FZwLe	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1637	815	96	1	6301	jxDUwfgjV2kRuM1VTKjTmrvU75ndSE6fTwkeYvprQjjd5ogXJrN	4264	6014	6014	1617021720000
8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	8227	3NKbxAgd8XwnphqCXrUUKdyU6LM2dtv6YHREJa78F7TqLx4FZwLe	1406	1393	96	1	6301	jxfwbKv5S6KAGocucpUtVSdVeT7ScqJoHeDHUKtFCQTZMLWRrkQ	4265	6015	6015	1617021900000
8233	3NLUQCm9SWxbvybQaQMGSBmG52bZDV6WdJ7XFQSbyTQ1VUvPY8z9	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1675	1342	96	1	6301	jwZmsy5mxc1DRzEa4QRDDXg72CjAYUdemfGiAgFPCpYuqZzGCzX	4266	6018	6018	1617022440000
8239	3NL6SqgJbmptoEcRDaTot8HQusP57Yhg4dEaXAfQF24NSpjGDSGh	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1579	1389	96	1	6301	jxCfGD6fPYKnjjppk4nweXJ461FJ1Derd5EJyeFAHPBLCxjJ4qA	4269	6022	6022	1617023160000
8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1406	1393	96	1	6301	jwdWc2zY2KDq6ACB4HTUWnuJPCn7jLWytSfaDvc3WPL3dCLhcue	4270	6024	6024	1617023520000
8250	3NLCFjVaPbikZFCQSE8iqmYPSqJZizAcLxNAmFJ464R2aN9WYEHJ	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1406	1393	97	1	6301	jy3L7fNJrjkfTfpcjPKhhy7ju1JqHmuzc5Lyw459iv19Rskse6D	4273	6027	6027	1617024060000
8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	1402	882	95	1	6301	jxcJJfJtZyuoecPxevQ8Xv2DV4ppRMfuALdboZWusVRKTnHxtD2	4220	5956	5956	1617011280000
8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	1670	1282	95	1	6301	jwg3ERtXtKdjc4o4hUzTC6J666DdcVagUC6ZbcwK7y62fUoy1xG	4221	5958	5958	1617011640000
8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	1489	1134	95	1	6301	jwREwNj8PB1vFM1Ywuk2Qod3uHPBUWrrYY59wLbpCX9fGg7tKyg	4222	5959	5959	1617011820000
8145	3NK3RyMw27tWU3BiQRNDbqMmsUBu6eeX58TvEvShQyuSUQVwqYx1	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1509	1074	95	1	6301	jxNRm8ga1HLDRya64FYmMqthfu41DRZENhSNW1g2Lq2xkx1pUU2	4223	5961	5961	1617012180000
8147	3NK4ZT8VdyQ7TgZ35QjnqnzpP4yL5MRidQG8sshWoLfoP6i24kjF	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1611	1341	95	1	6301	jxAuA5r8G4zMQsgaKJf96jK9PVi8Sy1issdUFCCFM6jgYfjDiFR	4223	5961	5961	1617012180000
8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	8156	3NKc8Ak4nFkR5yBpSsZcs1g1Rr3WuBQjPe1ce9snYBFjqaiemP1m	1579	1143	95	1	6301	jwvYGMSWX1VZF6vAigzEeeip4xpXzU6onqJZZMyKE5fC4JiB46s	4229	5969	5969	1617013620000
8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	8161	3NLJWWhSs6RW3nXCfkz4TouDBkKV2zvaQNTL9fCobC9i27SSzXZB	1406	1393	95	1	6301	jwzxcYQ1Db3v13Yu7UcRAnKpFWUoB2UUbEHPiRCxoqPVchv3nyP	4231	5972	5972	1617014160000
8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1590	1300	96	1	6301	jws8UV4y17eCEJuH7XAEpAwk5p1vH572WxN9sbt6NQLdsg116iV	4232	5973	5973	1617014340000
8170	3NLHyY8ynjDirA5n24uXnPJjMLN3sGEkcQCnxDNYWV8PWVTLHas8	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1549	1116	96	1	6301	jwMjQ1AXcdC2AW4X5VUcnAWk9h3Z8ShDjTYTJG75jwqgxHvXiqF	4234	5976	5976	1617014880000
8173	3NKiZ1VafM7a8UTKj4V8bkNEyRCQ6CKCTy6T3D3HZQ1uo79QZjgE	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1553	776	96	1	6301	jxQTVQsNshsJ9hSvXnC29TA6rLAUDvRHjbT7WigE17m4H4QRnKe	4234	5976	5976	1617014880000
8175	3NKMyLMP4KwFyYCbtw99RHvMdLgzCeCNJUXCnJ76W7pzd5ZZEM3S	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1407	1395	96	1	6301	jxSvCD2TNzehMLi2jph6cz1TwfD37UuxmfP3KfGU4o3LtPM6oMy	4236	5979	5979	1617015420000
8178	3NL7VLf7aUSMcJtUXmZjrPhFzJYg3RzhYRCnBqLG5Ls4p4ePFGK4	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1402	880	96	1	6301	jxmo7e2XDf5BMMHvCCyyRThiLLADLeFvngvL3nGbjjp5WB23BAh	4236	5979	5979	1617015420000
8179	3NLMgUPgT76FPtzDGYoWoPnDmTTWPp7e3WoNWb1TQ3aP4gETG65Y	8178	3NL7VLf7aUSMcJtUXmZjrPhFzJYg3RzhYRCnBqLG5Ls4p4ePFGK4	1656	977	96	1	6301	jxgfiwmxh3uzn1eJJKxTqMzhK3z8CeTeQ5Cr4LXKZMY7r6szRHz	4237	5980	5980	1617015600000
8186	3NKzVaEFbwtzoiRGzkUMPmKDQHgmQrcGobAFBu2cwf5BAfkvd22N	8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	1407	1395	96	1	6301	jxkTHSXEgbfqFmwAV7HGHg6Sn1W737N2NroDvMqt7sK2bAGWzgh	4243	5991	5991	1617017580000
8188	3NLUdnaq8srVtXk6kJdysLE7RqqeZEdDqL663qp8Dk5sr3czd3tN	8187	3NKS3WuHhz2xykrVXMfPwjmipkZozU1WgrXNPJR3FyDwLY65crNm	1624	1088	96	1	6301	jwrybXsb5QhSsGfK6gouXdmpGgPaZKu1XGhPDWuc5owigAdgHGY	4244	5992	5992	1617017760000
8191	3NLYbWGoSkr2hfP8LgcBTetU1ewi7PSF6F1cajjLSsH8aDBc8UUv	8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	1403	824	96	1	6301	jwpackWfyvY6XseLZi6VeVe9WYKASfxzvyxGiX9CBULUDCp2XFy	4246	5994	5994	1617018120000
8198	3NKvz1zoL1WGgp1LBjqNNuvc82z2qjPNppz2jzg2AXVTWn349qWJ	8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	1406	1393	96	1	6301	jwbUBPDZE5Pxj73TPNygkeqCan2cRzeJRNxRxbEPjzbRPaMuapS	4249	5998	5998	1617018840000
8200	3NKCZADDSrDixuT3oTncLex1mmhnWD1fQbdGfZyN5HXp8mxrYZ1V	8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	1573	1318	96	1	6301	jwR7Y7oyLumTcYfLQtMGUEYMTKq3vbhdv6dVffmG61vXADhrBZq	4250	5999	5999	1617019020000
8207	3NLL6LSzXHxYwNYX6dM5NMRNtab4juCG3nUwDYpo9ECNJT8PMMps	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1406	1393	96	1	6301	jwHCU1AfERxFu2c4Dq5LpGRCtakx7hkJwdJdhUYjrqgYvc8VWNB	4255	6004	6004	1617019920000
8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	8211	3NLMEF9u1L2Gse5kad7gKSXyQMjZNy9fYqSRKeP3snZfJKWAKvSc	1553	776	96	1	6301	jxBDvKveHb6iGKcFWkQn3rtCs1isiHQK474nyzMg6Lm76rVwLYG	4257	6007	6007	1617020460000
8220	3NLPAtqmfHJFuyYL5uZM6xrwN5aQybMF1SvSFzbPteqqPLFqUoDp	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	596	1306	96	1	6301	jxy5HGB7SGv5YADy7bYv8U927vvBbvxK7p1b1DH5Uvmw5iEWPqB	4260	6010	6010	1617021000000
8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	8217	3NLmovmWHSjCePL1oUixoWWAW8cFgqeAB7MWsnV3BiJQMbESZECr	1652	1069	96	1	6301	jwoABWuDU1oky9SpRqwnaPRq1rBr4SvBmj6Cggn2hhzz4KSeS3X	4261	6011	6011	1617021180000
8228	3NK65Bc8sznN475VUywb5XAdptD1GCsEYkm7eXmv6J82Y6ifAUWH	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1623	830	96	1	6301	jxezkyudafWD4v6YKHCCVvFafmdkQjsHUMc4BKvFAeDW1REGZqF	4264	6014	6014	1617021720000
8231	3NLy3eMoFz4QAEAHoTZgCpffnJobY2FY55Uw5KXj4HtPgBG4skmc	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1634	965	96	1	6301	jw9WiExEZqyPVBEEwwQNLanVATjV66dVgLV75u9cfgHek9Bbuuj	4266	6018	6018	1617022440000
8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	8230	3NKybhXxKtRnBzHvta6iqiJ3wQw7bz5WUCZkt4TnKALpRSs2vK4D	1407	1395	96	1	6301	jxLeLeA4RQBbSJvoSBuHfki7z62zmuYkg8PAbsVFRHEYUz3H8YE	4267	6020	6020	1617022800000
8242	3NKLUDNr3yvNHToGrav1BGxKGqdu7iRUnGFCEPYPU2fDzf8BySr3	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1553	775	96	1	6301	jwXQLRh5HF8gVwSMfLXroqRBKUR4BTWbf4CuUGgtENLKv5tyGnS	4269	6022	6022	1617023160000
8256	3NKWzTUCUmNULdRdG1JeSTZDpb4HdNYwvRLQuuD99PotDC179LEg	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1631	794	97	1	6301	jx2LQ3esrRXkZqBBpoaqAGCnWu69nPe9oEzPGnhvBzbHVsQ8fHY	4274	6028	6028	1617024240000
8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1448	1065	97	1	6301	jwh9vxGGmVKAzW78Ey8Jszymp1gruiTNDRuBPpU9da3n4r8Yexr	4277	6032	6032	1617024960000
8267	3NKcU1u2AH5Cd8hjutwcqnntXNB69Kd9V4t6UjDPZNFGGwvDTDgF	8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	1426	1118	97	1	6301	jxcWHLY4Pm2BzaNmtWk8xTuDpnCLc9bYeAFUr4MSyR523j5cge9	4281	6042	6042	1617026760000
8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	1619	1149	97	1	6301	jxCJCoVRwNEKLqS6Mj2z7EupekFMZMV6aA8tvLEwfM164a9GiNo	4282	6043	6043	1617026940000
8277	3NKXpWqWhKUn1xzqg8qERtgDx4XgRudfBNScyk5xF5qkuhbFhN3T	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1427	583	97	1	6301	jxH1Nx98w4twHSNM8iaVif333yRKNwDYRW4ECvBgYfxVfGDyY7R	4288	6052	6052	1617028560000
8284	3NKpFtW1wNTUUddqGro4oXg9cUKL9K6G33j1BX8aBLeomqvQWaQb	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1631	794	97	1	6301	jwtzMGv6Ugt7WEzp2Cbgamn2tiADCiHcZtyCaq4rmEr2CVtJ19g	4290	6054	6054	1617028920000
8139	3NK2yyii56WZM7rqvmErDncqBXhigXWZohczSerGG3VBNjVej5mX	8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	1402	850	95	1	6301	jwpaGLQjpH79Zaj2rS9HwvKdBY7KxoPm3ECDUBtHemDJETsBcDm	4221	5958	5958	1617011640000
8144	3NKE65LRMgMAq47akCBZkFHxgn6scsC6qAeEZUfFZSKbfgMeq7Lf	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1634	1205	95	1	6301	jwgW7wR3SkpA6YdaNxYivcagdh65vutnW7TeSbq484Jm4fttFSj	4223	5961	5961	1617012180000
8146	3NKN5utzRRWxMXH6ae718f27YSWpe8iWeE8LAewkbsPtbj6k2Hop	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1631	794	95	1	6301	jxp3cZ4hWM9g5etaASjCTAvtzUqJVzqqYR4p6zKo2PwV5chnBg8	4223	5961	5961	1617012180000
8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	8147	3NK4ZT8VdyQ7TgZ35QjnqnzpP4yL5MRidQG8sshWoLfoP6i24kjF	1403	786	95	1	6301	jxz5LmQdtuz4DgkT47oRiDXHkWymVrXDYxcKJ1pE13rzRifCR5o	4224	5962	5962	1617012360000
8149	3NKkgGSGHP3tgDqZrrzsKzhBSAbZTG3kXTf5rgTv4iaUpUJYmoQL	8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	162	162	95	1	6301	jwn8wLQHNxtaTNvMaeoXSZhXPQXkscCfQNYz9oQ8x9Q77gkrfj2	4205	5965	5965	1617012900000
8155	3NLTBaap5hJ8A8m2KY7AKCUKrRAQmjMwYkk7auv1Utq2Q4hhoB68	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	1406	1393	95	1	6301	jwPgYyYXJ3a3TzdznBRT9Froettaj9ypoyoW5nETte6RyrfKhkg	4228	5968	5968	1617013440000
8160	3NKR7RfBQvt1VwtvpXYmum26X4HwxuJtB3aFxxVaXvQjb8nb5pZi	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1619	909	95	1	6301	jxGLPwZRfhYGBntnvbUSVQQ2rKFnsEmkiJYwHSVJ4VCtxVPMddv	4230	5970	5970	1617013800000
8165	3NLPDWiJFwDUXyz6PgecZXCN6EQ9cQ4LndsWuDWpSBudeKDy95xp	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1483	295	96	1	6301	jwu6gu4s3XSK5sVrtWN4jQ6ikXXhGUpNoD43sstCYtgJrkpwB1Z	4232	5973	5973	1617014340000
8168	3NL5H3StugMNAAa3PC6oJMHBrB6qJ9AejW7SzTvsxwtfqJyEAbvp	8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	1609	967	96	1	6301	jwBvPkhojhqZrHijDTTVCRmmnX1k9yyK3sukapz9Q7FeHMXaHDe	4233	5975	5975	1617014700000
8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	8171	3NKJBSeWqVyfguaZXtef4NpyPXU1P6WhEZwj4iCif2x8qrsTUWEM	1406	1393	96	1	6301	jwMGEo4TqRj1r8AkQ7MHRiVsSkf6UjA2JdNAKJtR7q2BCkegFNt	4235	5977	5977	1617015060000
8177	3NKeyqaKbE7EnNTjExy4uYuHTNj1xKGZbMxL4uFLeoYhxnU81PnR	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1432	109	96	1	6301	jwWNWuguBg9K8sEL179cKcaF9h1bA9pqooVdLhsKqyzgaQeFnG1	4236	5979	5979	1617015420000
8183	3NKTAgoM1eihy3b3FiiPihCzdQ8qtXukXuWsaRUfvwQxnmnRgxw7	8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	1637	816	96	1	6301	jwHPRbGcLuriDFdGvnPmNJZaK6NdeZhbaACpoWepKrnnLuMcSEw	4240	5988	5988	1617017040000
8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	8184	3NKMcj9Dq6VHAtMrMNN5gh63ycpr7PiHZnztrc2z435XCSgrc47p	1458	957	96	1	6301	jwAJ4cMeAMPmDkN9nJKr2UtvCNZ1ww4E27fvRiGZLtZdmKxuoK5	4242	5990	5990	1617017400000
8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	1407	1395	96	1	6301	jxGzEwrFR89j4tLNRWD7rWpZpEtwX1asLqbBf18gZYS56xmZAbL	4246	5994	5994	1617018120000
8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	1422	1337	96	1	6301	jxtmeuXUmE1TQcvtySHXqLeA9W1h9hwjfPswkyAfrSs9jJ5Cy2U	4247	5996	5996	1617018480000
8196	3NL3xA2LhWH8Aq8zvUbZJDEsqqsFTR5PgvtAv1Ld8daYki34CHMC	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1403	812	96	1	6301	jwyxSR5DTDZknCHf2gVHNaP6c5vhT7sFGQcDvdLti1etgAqHxj2	4248	5997	5997	1617018660000
8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	1407	1395	96	1	6301	jxfHbZuCx6MbT7nD5cu2g64o1QhbCMS45Z9PKT4J8C4hiutu6Ti	4249	5998	5998	1617018840000
8202	3NLtpR6vswFDhyzRkE2kGHzR4vEt4PE26BF71x23Tz5PFGKsyv3X	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1654	1214	96	1	6301	jxZ8mYStYvrJt86XL2qL579kHwvNUWkFqVwDWM6JwiZYwtSFUpc	4252	6001	6001	1617019380000
8209	3NK3ai9GBiNWbBcgYNJqpYxaBckAXw5x6kFJjDQ35FGkeqvtkVUt	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1405	873	96	1	6301	jxCWE8wuCU8tXdYta7oZFeVrkSKVMPJTjyrAfik6y9NRGZKSrk5	4255	6004	6004	1617019920000
8210	3NKdNN1mvZMAVYnynJm67CHYcdotvHG9vkAYJCneLmsHMcwhwNbF	8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	1460	1324	95	1	6301	jxY5mviaRHAopTXaLGvqYc6L1wHGf6TSaLwHpcM8meY2a1Ebg9b	4216	6004	6004	1617019920000
8211	3NLMEF9u1L2Gse5kad7gKSXyQMjZNy9fYqSRKeP3snZfJKWAKvSc	8209	3NK3ai9GBiNWbBcgYNJqpYxaBckAXw5x6kFJjDQ35FGkeqvtkVUt	1588	1146	96	1	6301	jxHhWguCv6n85KSD1TsXPfeZ8jc6HSJytUErvN6P1jaU4nmwF7p	4256	6005	6005	1617020100000
8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	1521	233	96	1	6301	jwYw5ynfhNqteVxMqLS12xNTzUK6T1cpj9WfKsoY3NNjTdJ1FQc	4258	6008	6008	1617020640000
8219	3NKRfxMhmNGWYhrGMUqJSKKj68qaqpJ8tHBds3K1QGiZ4fMKfej2	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1619	1275	96	1	6301	jxveZhENKd4AgnAKgSBXFphLuSevHVe6uWbW2TAyiHBLvtvC8vE	4260	6010	6010	1617021000000
8223	3NL7WJqP9X6XbjqWN9CS1S6NMBXep49MBesLA1mH7WcizRhGzr6L	8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	1483	1030	96	1	6301	jxSZS1sJRJCHc5qoBhhWE8dECTe68sz7CsywpqE3zGxY5D4PZBC	4262	6012	6012	1617021360000
8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	1553	776	96	1	6301	jxvc6c9u2Kx7qqNBgz5nEV5XJmBum87zUKo7Qy1cvjxQrbM9Dw7	4263	6013	6013	1617021540000
8230	3NKybhXxKtRnBzHvta6iqiJ3wQw7bz5WUCZkt4TnKALpRSs2vK4D	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jx8fReHUiiarkg5yDMrPthkVCks3Mk98vYrhwzmUoC5xBTn3YtV	4266	6018	6018	1617022440000
8234	3NLi6bS7kkRQD2ekhSmK7zMxdPqzbJqV4SqUrXX5p2SnQxVsFHxV	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jx1SnKv6tF2wPFPesjV3ZtXsgfKVvp1AjESyYRtwXFbfvzbYmeH	4266	6018	6018	1617022440000
8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	1541	1052	96	1	6301	jxiSmDugR9e7PxgZNZi9ZE1mrRgNCCBubUmKJZC2Xm8bXiY5m3u	4268	6021	6021	1617022980000
8240	3NLqNyKxHJs2SVMhjQkUcVTfZGVp2KprLiy6qib3zKcXkTzoJHXz	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	684	1352	96	1	6301	jxHRkbTfEVjF4ZThfC48FoincTs5HSwMZNytYUHQbjnKkJUENpq	4269	6022	6022	1617023160000
8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1560	1291	96	1	6301	jwfc7GCqD6pFojZNhFWjPTMfum7CmNPvvP3FH8Lmto8TUH34qKx	4269	6022	6022	1617023160000
8244	3NLQnbArtu5Qj7UEFKETbftDG3cVPUoC8PWqRrzCEFtfbppE7Cig	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1581	778	96	1	6301	jxJuLbFEyH86euNTDA7RUHxDnBUV7iiJuNEmU8pnGW66bF5kx5U	4270	6024	6024	1617023520000
8246	3NLjzGyQD33NzpMXbFVqWrWauT1MD9JNDYkW6JyuTaSSWprQVNMe	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1553	776	96	1	6301	jw7XKqZKfSxqtQowN3c9r69MFQQLgqmGYMuzMcLPZ6b2QBCTBQh	4270	6024	6024	1617023520000
8150	3NKbQ29heBG7pyLftuZ24P3CJ3R7KV5GL6FwBKWyzzFD4nbzSGd4	8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	1461	1271	95	1	6301	jwnaWptVnXsKSGh28sfmNiVQQfmTPueGJgGWqZpsJhpE9qZZE8o	4225	5965	5965	1617012900000
8152	3NKk5rEAvzY479tx2KHAcSKnG5xkJKCi1V2HhKibztoDCYZ6GXgy	8150	3NKbQ29heBG7pyLftuZ24P3CJ3R7KV5GL6FwBKWyzzFD4nbzSGd4	1657	1344	95	1	6301	jxne43eFodnwAX7xXhVvdG6gZUCFsX3A6H1tKmkgCCpjsWo111o	4226	5966	5966	1617013080000
8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	8152	3NKk5rEAvzY479tx2KHAcSKnG5xkJKCi1V2HhKibztoDCYZ6GXgy	369	1066	95	1	6301	jwxjhGXm81mWC8eGBL2VqeTqFkXCefAezLRUBSBythGA7W32mS5	4227	5967	5967	1617013260000
8156	3NKc8Ak4nFkR5yBpSsZcs1g1Rr3WuBQjPe1ce9snYBFjqaiemP1m	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	1455	1332	95	1	6301	jxP1zjop2czJNpu2kJHyJ98F3UeCYrEdiG7BP1YLrtQXD7sM7nA	4228	5968	5968	1617013440000
8161	3NLJWWhSs6RW3nXCfkz4TouDBkKV2zvaQNTL9fCobC9i27SSzXZB	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1657	1218	95	1	6301	jy2uu3enkpr4AqNvpWeGLmR3pH3iCAWjyLrfy6n2dNZcHHYYQB8	4230	5970	5970	1617013800000
8164	3NKTAw8o2yFV8dgHCMkTcWqVkCo91Wmice8GYuzbA2ViS4qCRCg8	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1483	295	96	1	6301	jw8Dp4ffRVCMQAoqKfmbzNsv1XeaFhNr54SNcBi2qVxX1tbVqH2	4232	5973	5973	1617014340000
8171	3NKJBSeWqVyfguaZXtef4NpyPXU1P6WhEZwj4iCif2x8qrsTUWEM	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1402	868	96	1	6301	jxsNdsFSWaSgwSVGMoBjjmPbuPcWfpJRqa6p3L4dX4jnH5G52z4	4234	5976	5976	1617014880000
8176	3NL4cdJjbQyMQi8wZKpqTZ95F2BULs2XthX9d74xaJDGdM47Cv1d	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	44	1325	96	1	6301	jwZeLGPDdF531BWGrqcJQYKz2RZKd7Nvo25Xc6ekKwua9E4rpEE	4236	5979	5979	1617015420000
8180	3NKBS1LR7dKuHHBEuDjxMJemB3Zqvq3uDVzF86kde6BiMt13famR	8179	3NLMgUPgT76FPtzDGYoWoPnDmTTWPp7e3WoNWb1TQ3aP4gETG65Y	1633	1390	96	1	6301	jwM3ERZY3nKBus7ZSpEKPUt4ibdAt7kr89AN7mPnAHnRgXhU3vP	4238	5982	5982	1617015960000
8184	3NKMcj9Dq6VHAtMrMNN5gh63ycpr7PiHZnztrc2z435XCSgrc47p	8182	3NLMzSQ8SoYi6oQ18SCcjtFFxH7YcYrK6dKBJcxhATEJiBbQt3xU	1406	1393	96	1	6301	jxcwzH9gi2AkJ2s91iShcX72z4Pk13Px4FDynPs6Ew5g5UmyGxR	4241	5989	5989	1617017220000
8187	3NKS3WuHhz2xykrVXMfPwjmipkZozU1WgrXNPJR3FyDwLY65crNm	8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	1406	1393	96	1	6301	jwGUNwLvxZSVDnWVRSCTUNHYVp2nXNrWVSamhWjKxSUSh8zvwVS	4243	5991	5991	1617017580000
8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	8188	3NLUdnaq8srVtXk6kJdysLE7RqqeZEdDqL663qp8Dk5sr3czd3tN	1673	1002	96	1	6301	jwMtJSLAmx3xNboN3aXNTbogpyofaFZPcqbPwK5DprBPaTWj1tj	4245	5993	5993	1617017940000
8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1578	1050	96	1	6301	jwzJfMmzLnqU2hSatcUqJgHvWCSPNy4yEfczJC8S16qJvRv4d5L	4248	5997	5997	1617018660000
8203	3NKZepXEmZ7HnuXU8mdYNNnnt23PxuSY6mAHKk41sr1aLunVZJK2	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1527	1293	96	1	6301	jwr12RqnBdErSYbZEHr3PsTJhw5BVqmWPE9WzzBh2hMjcyWRpLK	4252	6001	6001	1617019380000
8205	3NKVe9xHwxURrwsoKES91wKjvgyiNMEuDPo8JWfUYnw7yfJox993	8203	3NKZepXEmZ7HnuXU8mdYNNnnt23PxuSY6mAHKk41sr1aLunVZJK2	1588	1392	96	1	6301	jwCdqeQ5kJw795Y3ATFp3CgQC3fdH7ejYhJFJXaRKZ76Dq2kYvy	4253	6002	6002	1617019560000
8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	1406	1393	96	1	6301	jxHKGCU2FZjKAjJJkTYcGQbPMoJ1ggQW1othaZeisbwoDpU6FTo	4259	6009	6009	1617020820000
8217	3NLmovmWHSjCePL1oUixoWWAW8cFgqeAB7MWsnV3BiJQMbESZECr	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1503	1031	96	1	6301	jw84R9c86BPjboWtgTMyVs4nzyrD3bzAd7kvKKFLaaw8ekSVvzm	4260	6010	6010	1617021000000
8224	3NK55jJFYojzwQEA1yi3aVtjBVYgJydbUPj5kK8E4UR1b4kYxxw7	8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	1522	956	96	1	6301	jxSVeJqB9cR242VUu939u56PQcHc3gEFnG2J643EzLACRFh4rpr	4263	6013	6013	1617021540000
8226	3NLnB6LMDAQ8WW7EL58KsdLuw4JMRh7eUksVndBTeKMSrPp6CEBB	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1471	1386	96	1	6301	jxJ1NLH6pt9Kgt5VNnrzZq1goZ7Ad6eppcpTGyK1gXKx5rPkT8Y	4264	6014	6014	1617021720000
8232	3NKLy5ic6LzGHA5qBFyoH84tcaX1fVr6k9Goc5o1nZFBsC8WfQwr	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jxPV1kzgHrqiodAVNUPP6hqKjNcDtjvKtt4jPfvp1V2S3ccUoc8	4266	6018	6018	1617022440000
8236	3NKrcBjB7dHMko4QoszUDyZanxgGvqpp1Txz6iDb4GoXHyywoXGq	8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	1541	1052	96	1	6301	jxfkDAKy9NtCSjyw6Ng3gKR177XiZauMMvJyyz14uSqNGKDSG3d	4268	6021	6021	1617022980000
8238	3NLEj37sYmotdy5ZKogdG14cVZK9VEvn9yQF4G31w8MBXMhtjdHN	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1560	1291	96	1	6301	jwbJuJ9AeXoxno8FCUtoK4SxKwvQXFRoYUo5r9ufaMHL5gMR9j2	4269	6022	6022	1617023160000
8245	3NLk5t47fGQXnahnL3nmfaWs7poTrRscDobn2eC8MZXyPMNWwvra	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1516	1294	96	1	6301	jwkEAqcNRJs6SZMX8QY57sGK7ECV1cD4DYe1zKQorsAcoCTaHKc	4270	6024	6024	1617023520000
8247	3NKeQ4vQyzuJ4kUgLCeQGrs3Shx2znkvZcbKoVRu1oFKNR1Nk8wq	8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	1406	1393	97	1	6301	jxMAKydw2kXyMfdjK9eQW5AoNefK2KngYC7xbSEJUcqRBUKLPNG	4271	6025	6025	1617023700000
8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	8247	3NKeQ4vQyzuJ4kUgLCeQGrs3Shx2znkvZcbKoVRu1oFKNR1Nk8wq	1407	1395	97	1	6301	jxCjj1P319e5Wtvydnh7hE2PV4qHrfTDiYDYAkbRPB8NB21Xjxc	4272	6026	6026	1617023880000
8252	3NKThdYq9TJdnEqao8L1oRA5feZrLPF56MxTuh8pNBkgNMoM2PJa	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1402	852	97	1	6301	jxtf4eifWEbdoz5kqkcmgYrfuXVJUDdtAW3jzMjsQ1AZdbGxoyo	4273	6027	6027	1617024060000
8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	8257	3NKaCqXSGYPcTjvZjzSivRTsSdYfApMDjpnv6MSZQz3seQKc7eij	1402	810	97	1	6301	jxNg88Dyn9rYktNKsCS9PGV89vVcio9wv9pS5T9M7qj9jwdC4WV	4276	6030	6030	1617024600000
8261	3NKH5yjCc1zjRQztNh4sX4ABuZ5sYbQtvfNmBzCGaVZKrNnhiVZJ	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1476	1371	97	1	6301	jxZrA9xqZatUHGQr5tgmjQ42PqMmNZyg5vuNmhXbxyVZTdEwwHF	4277	6032	6032	1617024960000
8262	3NLuRKaxTAr6HfFtV9MTpW4y8NqsM7RGUF59J4ejxbeprvZE2UKN	8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	1460	1324	97	1	6301	jxpYCcx1xfEdP9uvBxVmDm4CQ7CF8PqoKsgA3GiHRwFdKWCHM5S	4278	6037	6037	1617025860000
8264	3NKKFYxbKeofhW3LPwt9AcR8a1e9hQn9Yxo9bxrPLJgGk56cvsii	8262	3NLuRKaxTAr6HfFtV9MTpW4y8NqsM7RGUF59J4ejxbeprvZE2UKN	1527	1047	97	1	6301	jx1vaQ24c8q1zpaTLwwNGZxRfBaHYy9Yw1TZK66c4Q4BaXvwcTb	4279	6038	6038	1617026040000
8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	8271	3NLBDo1fJUws5ArEHNEtrHCXhCKZjnu5V7EaizHTCN79wQC87GVy	1564	1092	97	1	6301	jwVsYYe9qiztn7CB4ZXKUc9tzkwx1FntKL32Z3uS8qibsZaNuPX	4284	6045	6045	1617027300000
8275	3NKLYgUa19rZU2CSh3EMsZNVvQ5mBW6zhYY4wX55N1ue9YkECLvG	8273	3NLa49MbjP4iy79hQUwX9ZKETrQyVWAkAvVBvUDm5oZ256MKf5eZ	1589	1286	97	1	6301	jwCSpiAyGWErE4K1wv27S2FqVegWQH4zx9S7jnMvgQJxvrsVTt4	4286	6050	6050	1617028200000
8248	3NKwGsHGwn5uHMMPUddQM9GchAwfFTCbq5zg44NLbE5ZzYNhqiRH	8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	1623	830	97	1	6301	jxNEUQfStzkg3w2GrMW2LEB9ps7GCJriLK3mSUsv6qmvPyQbeiy	4271	6025	6025	1617023700000
8251	3NLidNXAMVZsYtvf5e8FPd28kQCTPfvj7zJuETooNZEBcxCk749A	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1657	1344	97	1	6301	jx3xyRXa5okLnvMSk5r7iCRoCahdY2iEEz4W4tQVNXBYUedXGhK	4273	6027	6027	1617024060000
8255	3NL7hMLMhMCGX5WdNiofVYMP6njJ7RXzG2gwrmQUTddzjrAx4yS9	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1585	1366	97	1	6301	jx4Vo4DCDGro21aPruoypDTqzRR2VmvC4DoDtZ6soD4HTmRkmYN	4274	6028	6028	1617024240000
8257	3NKaCqXSGYPcTjvZjzSivRTsSdYfApMDjpnv6MSZQz3seQKc7eij	8255	3NL7hMLMhMCGX5WdNiofVYMP6njJ7RXzG2gwrmQUTddzjrAx4yS9	1406	1393	97	1	6301	jxoTgLQJqdX8Q3nijL3ihp1LZGNL4DuAnZ9z9fgwcXX4eFQ1RwL	4275	6029	6029	1617024420000
8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	1406	1393	97	1	6301	jwFGTRiLJJv8TYn4Kr7tkTTTt9hpqTeZqERdCZ44gTySo4joHhV	4281	6042	6042	1617026760000
8271	3NLBDo1fJUws5ArEHNEtrHCXhCKZjnu5V7EaizHTCN79wQC87GVy	8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	1631	794	97	1	6301	jwvjMGKieZDq8jTvWsj1vTedfNm9MmsXETH2mLKcK3vAEUWqYDE	4283	6044	6044	1617027120000
8274	3NLwXkpgWkW1Ad82GF8op7uPWPdVtGWHj84Y47oas75s1YDnVnDk	8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	1403	824	97	1	6301	jxbe2Wm4Mxi746kbp2PvURQs67GPMG3HoY5nZys66X96cNxvhWx	4285	6048	6048	1617027840000
8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	8280	3NL2A9m1zLsTVUtMbCNp6cy3rGb3xTtrkRhybhET5voQyNEHFXaG	1419	814	97	1	6301	jxqkpnPhX8fdgCyNteAu5gevPY2xBWXhaoE9tTzjw6mrJxopHUT	4289	6053	6053	1617028740000
8283	3NKNT1PxwvuRDqEvZnY6Lxe8FucMnSvoRvGNo9yTBcfmryMMVtxm	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1633	1390	97	1	6301	jwyL4ij5phMCzNQHXcyJf7ysYtJHbT3kBgt1URLN2QpWj2ZEtnP	4290	6054	6054	1617028920000
8288	3NKhUhkJiu9aSgXbD8h3PSYBCu3hb1F2HNWehKJLYFfsXNyxvUdi	8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	1405	873	97	1	6301	jx6F7fGYknXDbgu7r5eGybfKYT9S4LthJMWuK9NCk4WPoda1PSG	4293	6058	6058	1617029640000
8293	3NLF7VzSNkG4dHkZLeQ6euM5t7KEhRN7gXH33ZpNrxN3tXnhx25D	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1610	948	97	1	6301	jxS4mRqy11aLWdXwESNW6CcN9AaG5u8mZdHRv2XkBTbfSk7amjZ	4295	6062	6062	1617030360000
8302	3NLiuUguXzncE1MazhZ1iZN1L1x75EaXiZDFLsntWQ46WjY568ca	8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	1508	1387	97	1	6301	jwRQjQGbM4HVsnHJWpqXSXxc1Ngh3fVnB8fSPySJE6cDt4Ux6Km	4298	6065	6065	1617030900000
8304	3NLLefSgyZgd11pNSXHhzHKkVzkRPLdAoMVXv6NncBwKfqvV1DrY	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1646	1108	97	1	6301	jwKMELpBKnMVFGmjgPhTDc5a3SkKRQQFZ73BUdQRdAA9uByJ9re	4299	6066	6066	1617031080000
8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1587	1357	97	1	6301	jwkYvrz6xk8Mn6PVHCwCVijsMz9pYYkBtFeXuwBQVXxeNtLwRoD	4299	6066	6066	1617031080000
8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	1490	133	97	1	6301	jwsvKm4MNUWKfrCn23VLMyKFAuWFcg7XWyjaDTE8H5nE4pfvGaE	4300	6067	6067	1617031260000
8311	3NKAHHebZGbGfvqApbafxyfhppysBbhnbR7ELvTUajuMCa3oyjp8	8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	1406	1393	97	1	6301	jxLivx3rSTCLZp9qRjhc6Fpxo2aRkPKsLttGrTPt9mp1f7f8Lkn	4301	6068	6068	1617031440000
8314	3NLupN8KG6vMnwrj3f72YbhPidXYpUpAR7JbwUofg5E28ie7D2yw	8313	3NLXEPeWcfeAQ4kdGZE6W5meKJGTbK4edvmT4fx6CgJTae8JodgT	8	8	97	1	6301	jx4Pt8PxRFCWjmoPHBHtoA4SPKQsH4nDNkaLp6sqry3S4pserzu	4303	6071	6071	1617031980000
8317	3NL684ztSTyTtqyn2Z686LrFVyEuHV3zfz2PG1KyUJfiMhaYh83H	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1559	1353	98	1	6301	jwYpjUtUrscn3FW7fukHL4tprs4Xs6CYFygDqtpkg5vrKu517hc	4305	6074	6074	1617032520000
8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	8316	3NKyF2obwPV6eUHHBhcnZY3mhh2yb2Mivw8PPNJoAq47YVijrC3B	1407	1395	98	1	6301	jxJJ7HiyJTCxKo3HGdWwHFqN7Jh52o42QGWuqrPqjQWBEaCVY9p	4306	6075	6075	1617032700000
8321	3NKhe6fTeUMs15KQPoqgKdNCD5Djj2sKDPNJGBudMHmcMgw5A6TK	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1457	1391	98	1	6301	jxSZkYvY9ErLXddwW4bUVzdcmBGMGsxScW4rCLJp7fREtGFtMzw	4307	6076	6076	1617032880000
8322	3NLmV8V5BWASkqQDs9JEeu5SyxhqxsEUyUV6SXb4wkjcCw53MsGa	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1439	1279	98	1	6301	jwaByz615vjNLYuTNhmCSTuTeXEk9u11phVf1gg8nfdhzD2o6Pt	4307	6076	6076	1617032880000
8324	3NL8wYD9PQr9KztwkoQziJS9xn1arpfYa2WFqfWQbsB767GqXqYD	8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	1406	1393	98	1	6301	jwG8nAdCxxTstT2xdXgSouKHXVXqE2e2FP4dbLPz2ZVSromd3mn	4309	6080	6080	1617033600000
8331	3NLBG4AxqzQWgN2qyp3XA7DeuVa1VZBZ3iwwcGmB5gAMEJYj5aQF	8330	3NLGb5WtrcNAL9W9brvrSeXrbfozqGouM8WP3EpHxE5aisszxjFv	1513	1133	98	1	6301	jxDyvJ2JHVj5aY5Tht2oUMz6vk41RMNJr3ivskttYgcgxVEQU7x	4313	6084	6084	1617034320000
8334	3NLNS5R9j1mj11ieqhu4RMpXtxRW375mcKaykAR3zRsEhEQSxjTy	8333	3NL3PRZ1GywfMYgfbKjxucrqVK5kwCWMtDnV6aYokBGKx4X49hWp	1646	1228	98	1	6301	jwNJqbtiSZC1Cv3hCnupQn3i7NCVzq1ocumYNoAzKjyHrWJG3QM	4316	6087	6087	1617034860000
8337	3NKPCSoTuudPxgVN7zHqJ1JXALQ9M7ZizyuiFtoiNB3JdLNY8eQR	8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	1631	794	98	1	6301	jxnJppcTHuWe9Y233J2qUYfT3BJPtdTEK1PC84P1T6WgbdtCPx6	4318	6090	6090	1617035400000
8340	3NLMFzsDiBCW5FFjQRpYKHzKZ7qE5tyQmyYaGyqetFSrcGGLzPcX	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1637	816	98	1	6301	jwuq6ejqrkczcQA2Ht5DxbMaNmH5ALJjzM6Lvq8ybwjxQP1v45Y	4319	6091	6091	1617035580000
8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	8345	3NKp7GXrgvfpH1teAqrDUxQRgwnELUgSDAfqCtNN2UZE52oju8cQ	80	1027	98	1	6301	jxXpUVUVeKEJW4cKAz7tskMzhkMuBpTCZAcHW5gxem43xvtb1vi	4323	6095	6095	1617036300000
8351	3NLcrMRSLUDAmoE6pK9rwnmGEUSYiBfktzyihXh91EN5Q9sdyrsZ	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1513	1013	98	1	6301	jx1afjeGDUusPpHKa8eSLxputHJciqEBBbs33nfX8psD5a4cSEL	4325	6099	6099	1617037020000
8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	1440	1131	98	1	6301	jxYd9DVVVXeniFm8B5BXRWdwBE8H3qkgM7Tdq1etDZZMYomELUL	4327	6104	6104	1617037920000
8359	3NLvwY1pnyvSGsKREZhcwxR7hGVnSQzMCCKJD8eAoEuJs6X3z99S	8357	3NKzrans7HmZDX4CjGG2vmJu64LKe2yAsSg7pAJY3BXYMoZuh5RY	1503	1031	98	1	6301	jxzCjzgKeDHHmFLZYUFgieiRFqiDkxVpL9CfkVPee3c5bCSwKqb	4329	6107	6107	1617038460000
8362	3NKkDcksAb3UpvM1hgrsgBsWaCUHHuaTU1xqfEDCLEefUNaEutUg	8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	1406	1393	98	1	6301	jwHDJ4iJVmNRBQfrKqtjdJMiKR2jSotsiVFzzGRL2o3Au9HRqgL	4332	6112	6112	1617039360000
8365	3NLAeNmLAEjLppBH21bcK97LDCwszMvpEKQ8PQB2H6ddgD2VBWqd	8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	1490	908	98	1	6301	jwpQPU79EjXRc2YK8QqkDebfVcQf5owUYHekhHwck9ByLqLLjoc	4334	6115	6115	1617039900000
8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1509	1194	97	1	6301	jxFrVjcotuHLnC5W8Kiawre6FPc29KRRjDygQybSsV9WYKqh3He	4273	6027	6027	1617024060000
8254	3NKox4ZBySvFb67oRKWw8HnLghcVxzPuESyLSGmobbHAr9TuBjHB	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1578	1296	97	1	6301	jxdRNNPyw71bmeC6HkWik25ceERBN8Uz8zC7bvuLDjQWD33uBg1	4274	6028	6028	1617024240000
8259	3NKWRoxhXf4Jg88miH2Hrr4HUimNrbHUD4fRx7ZDEp8sPEe3qccC	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1672	1039	97	1	6301	jxpNstS5iCsxBriaBSRMwQwBPud8V6tSPZay3h9s5TfDprev5nr	4277	6032	6032	1617024960000
8263	3NKDoFDboSYGNNoeibmiDmoipVkQMXGUuo3nQTjifyQTNaVNLbJz	8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	1637	816	97	1	6301	jwR1SeKYDpmrMvjKVhUTUNHGsMeCvEHAzAK9tcYFQj53vz6SFVJ	4278	6037	6037	1617025860000
8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	8264	3NKKFYxbKeofhW3LPwt9AcR8a1e9hQn9Yxo9bxrPLJgGk56cvsii	1458	957	97	1	6301	jxdz4961Z7kQjdicNLPdwS7JbeiQzQ5c5wGMXN6ZQjZ4y3iBoe3	4280	6040	6040	1617026400000
8268	3NKSRjhjxv2MYJ2QH3oM9NxZCpnhranevteg8wEJRDyg1apUsRSA	8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	1600	1126	97	1	6301	jxc1nZFzSEYtWZSEtQpghX7EmZMxaFz1h8KpKsMPNp2nbbeMxWf	4282	6043	6043	1617026940000
8270	3NLmwGA5egwgQyNCKjXa7SsUAA2NMLJrNhW5Pk8dDdpqxzB7t7xX	8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	1527	1167	97	1	6301	jx3veG5Wx8S7tzUHHooPvkqV4piYeH8a8BdrHHqggPNp4Uqxx7F	4283	6044	6044	1617027120000
8273	3NLa49MbjP4iy79hQUwX9ZKETrQyVWAkAvVBvUDm5oZ256MKf5eZ	8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	484	1193	97	1	6301	jxUWATLNxp7f5hqW1wYe2LRc5QSAoYUYPGw8tq9nydjBrQj5RBJ	4285	6048	6048	1617027840000
8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	8275	3NKLYgUa19rZU2CSh3EMsZNVvQ5mBW6zhYY4wX55N1ue9YkECLvG	1406	1393	97	1	6301	jx5YJcGQFZcEpwEA3wTjEmsQ5zod4F8mkcnFviHBYgvjHdQw2jD	4287	6051	6051	1617028380000
8279	3NKBt3Dpx1sBjQ8bKGS3GQzwbA9DH2w1vjdbTALQgBZgn43EiYbY	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1474	1329	97	1	6301	jx6spEEckUzZSy7CRFuWGzQLBfDu8G8j7Yi282siRsJkKc4mvas	4288	6052	6052	1617028560000
8280	3NL2A9m1zLsTVUtMbCNp6cy3rGb3xTtrkRhybhET5voQyNEHFXaG	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1637	816	97	1	6301	jwhnZieA1Y3jTWsE7CrKrexjKLqw8pTjvhbNdGu4AjkQ41svyj2	4288	6052	6052	1617028560000
8290	3NK9KaUW4VKw9qWH1tZQggmjELZf7MXetTCgVgiLxCkmQar2jU6X	8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	1607	982	97	1	6301	jxCDxFAtsxSsa4ZBXeSNKEj4i6hwsqFX45UXGCLZwGbo37Y7wcs	4294	6060	6060	1617030000000
8297	3NLcUPQNB6ZzTYKwETyrkT51p3JAKpvh7nx43zhiCpT3uKUiX4dK	8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	356	356	97	1	6301	jxVcEpnRnKxRG7FQQD5Y4cZty4dTEKx6ybFk28mJrmdVHNmjS2v	4296	6063	6063	1617030540000
8299	3NLQPZzBZvmrESt15oHvGKSRJVCG4wtnTeF7rGuk6TqF8mkdNqxp	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	1588	1392	97	1	6301	jxVXJE1o58eQxYLNrCYvsBmVBzXpoK5oX4A95GP1EeT3BUBPQe8	4297	6064	6064	1617030720000
8306	3NLpdEY7LDY48YXfemZ5DyhEpFqhi3qwvTQFAVJF4MHPvWa5rdmH	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1427	583	97	1	6301	jxdHZP8kKnAMA2t6diBJ1gzq7VRhTLnzqkXUpqgtKyYzeLEWV7g	4299	6066	6066	1617031080000
8308	3NLGhrmoQ5XELjRVB3DwuxSmqNxVmPCA7G6HvtDQzcXQgURegNit	8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	80	1273	97	1	6301	jx7u6W2pBae9b85mUbMNLssTKA1jNMuF5BXyoLRDCq3owJDPAkb	4300	6067	6067	1617031260000
8313	3NLXEPeWcfeAQ4kdGZE6W5meKJGTbK4edvmT4fx6CgJTae8JodgT	8312	3NLu21XsAs6pEGks2z8bqzHnbtA9rXvxErynd3ZJNkf9KSUiUpmo	1403	824	97	1	6301	jxQgXiLNU4HiSPonfcreYDxVqjTJitFDoxkyAh6aQGdViwkqkez	4302	6070	6070	1617031800000
8316	3NKyF2obwPV6eUHHBhcnZY3mhh2yb2Mivw8PPNJoAq47YVijrC3B	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1648	1038	98	1	6301	jxbTb832b3gjwFPW6bsoQ1PJ8KCVReAjxJV1Xa1L1P7VUFpvU1b	4305	6074	6074	1617032520000
8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	8321	3NKhe6fTeUMs15KQPoqgKdNCD5Djj2sKDPNJGBudMHmcMgw5A6TK	1405	867	98	1	6301	jwkRRtm5vSEKeXMfFLEZV9B2LcLatACx91nBGdiKorTNibDQeVs	4308	6078	6078	1617033240000
8326	3NK32scBbipLLY7rdiqUBMaVT9ZXpgQjmQ8CRg5QPgB9mr2khrWp	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1406	1393	98	1	6301	jwcLSLvuECjWQvmp3HaqEhu4vCHi34M7QL4xG8fnEpAsmLMEoP6	4310	6081	6081	1617033780000
8333	3NL3PRZ1GywfMYgfbKjxucrqVK5kwCWMtDnV6aYokBGKx4X49hWp	8332	3NKoTNDSLjMsy5cmpGzz27xwShpyMbYLa7mxVgdqde68eyvcY7vZ	1670	916	98	1	6301	jwrbE2TR4UA7ndoyhHtJLQ511fqNiASD1nVr3PDv6AbPvjmUzgB	4315	6086	6086	1617034680000
8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	1534	222	98	1	6301	jxyX7Fo1GFJnyaRKi8DRTa7kA2MdNjvAgFp47jagcXAYT7qw28B	4318	6090	6090	1617035400000
8339	3NKUSmZEj5TWjqdvdCxzCGPrtD2K5oZi9huf44dAVs8wvgnPXgU4	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1420	403	98	1	6301	jwg8JFM3pJWCMeYuT6BYhLHh4ov8pfBjrbYsydEQ5MGcbb962BG	4319	6091	6091	1617035580000
8343	3NKc4vvzay6LanbEmhpi12uKzwwXRq9hXyduqTTiuymhqDx37cNc	8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	55	178	98	1	6301	jxhmMfsQ39nPFNcM5PDuuBievt1SDKLJs1gHhbTyt1vdyfMEt3P	4320	6092	6092	1617035760000
8345	3NKp7GXrgvfpH1teAqrDUxQRgwnELUgSDAfqCtNN2UZE52oju8cQ	8344	3NLeZwvLQbRfU6t5CFB2oP9r16dLWDkocmaePCiRK2emZ1Ms2Lsq	1673	1242	98	1	6301	jx4r1GAGa1Cyx19i7fd5frT8zZ7h3jvah3atD8RrAXGS4v6RDLH	4322	6094	6094	1617036120000
8367	3NK7WSsRZxz8pE6WWWL8hsCYEjcp7hUMqzksnE5mdtLzsg8WVuev	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	1407	1395	98	1	6301	jwPkfCUg7iGSmjtWR6M4jXmsNDFBrcrUhWJqcmHtUuYZb4Rjkhd	4336	6117	6117	1617040260000
8372	3NLnaDmA9pKigRN4NF8ZQcxRHE7DTuUGNSebuKB1QBt8cTFPgfVb	8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	1455	1332	98	1	6301	jwSG79W7TPbEnDgiNZ3e54waN2wHXsV3qgGZcT447ALnPnMpiRF	4338	6120	6120	1617040800000
8374	3NLfrq4cWKGAK4Sn2nJGEEGPth8dH1JHGJHf837YPHYtWknrTLHT	8373	3NLU75wjPNVdMWNhvX9rF7ukAZPMwBra4nPQbjkGPG4LNUYwxtkn	1549	996	99	1	6301	jwDtcFH2ovhJXTXLhCwFmsXgwVc4gejzoVjyxxP4185ctDozaMc	4340	6122	6122	1617041160000
8378	3NLyEN4Vk9fQ8CfY6VJy7qPSe5Y7ZFkw9kYx9WoGK5psfSWMUU8Y	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1527	927	99	1	6301	jwEaCpWTL5TD3v2arJZ2xoh4y8nDVnP3DSfSAk66GZyn4y6RueH	4342	6125	6125	1617041700000
8382	3NKYuroPpwtWUYDZJgzN22mh8BTPXqwA5jheFipo7FkrhbWFf1Jz	8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	632	1136	99	1	6301	jwEaiRw4LScbciMSgCpjNgxhJfqTTjmNwfmcazqyJ1GtWe1HH5u	4343	6127	6127	1617042060000
8387	3NLGKbit7x5KVYyn7ezQ41gc4uKigatqpykqE5orbNkw2yK34hnJ	8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	1613	983	99	1	6301	jwY4iDkS9EqJJuGsoNtysBassjbBR1LjMH1EgxaDfxikMWdHDAQ	4346	6132	6132	1617042960000
8389	3NLgAVqSrtZXEcMPcZkuKvLmNngqx45wiGa7ZaP8H3jaGrQ6i9mf	8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	1634	1085	99	1	6301	jxU89SnDeJBLLKkkRh1tyDQhFeAsUSv1w2CVeM7gGtcCoz23oY1	4347	6133	6133	1617043140000
8278	3NK4KtncCkovvFm14DastRWCMu9ewqnGqtwgFHqyRJ5pMQKhYZ5Y	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1536	1067	97	1	6301	jxWkZ7c9RLBwXBBsm1czveJ6VwnEadnPeBYiDvVham34KNesVQE	4288	6052	6052	1617028560000
8282	3NLQsL226TSboChGdkbiGqASQv5xJ9RN5xCytWL1aw5cZWwDerU2	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1407	1395	97	1	6301	jxiW4HQX4FSGKAXjrJZzh3YQjCirxmsA3B8aXtQd5iekvNmVwzL	4290	6054	6054	1617028920000
8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	8286	3NKBEGkfEVGf8yRQWdwxyS6GxhxytUQavYLHy6UeEbxgpSwTZbuo	1419	814	97	1	6301	jwVVaNKjkqiNrZSxpCbXhBLpDyj4jL8GAThJcFPxyJXoCmgei1X	4292	6057	6057	1617029460000
8292	3NKkXCka9WkAmeqJMHfVwrjx2FjpE6enxEKzmGrF7xi1G3QgwDhG	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1602	1369	97	1	6301	jx4ewMz57aBCDntn35FWJxWmr936UmYNaizH3u19ApDbT9sUkBt	4295	6062	6062	1617030360000
8296	3NK75pdRyoA1fyN33cD38AnKJYp9umpmo62ykE4o3huqroBjFXfv	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	684	1106	97	1	6301	jx8gmYypQG2sHKvEmdNbgzR5q3CSy5wU3iUgsHekL2FUDjW7Ld9	4295	6062	6062	1617030360000
8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	1648	1284	97	1	6301	jwhsMaH2iZMpPK313ca6qK8QZE9eFr5Nkh7rgGm2sgBA97uwUwL	4297	6064	6064	1617030720000
8310	3NKibXVNawXTNRCY9UfMQWu8qJTp1EtmeZMLvbJQxnrGYwAMGF7G	8157	3NLDmCTjzUVZR8gF8uY58c3WYJhe5cHLfyNnnkBeP3DU9USbnVWQ	80	1273	95	1	6301	jwz5CY7jPdS1XoGrqnx3rbY4gSBsZ8zf1q2X7FBhPiLdfEioaSZ	4229	6067	6067	1617031260000
8318	3NL3fbnr5SFJ4HDVr9f4F43TP1UD7Vod3QyD7ijNRcsPZGMtSTdn	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1559	1353	98	1	6301	jwYpjUtUrscn3FW7fukHL4tprs4Xs6CYFygDqtpkg5vrKu517hc	4305	6074	6074	1617032520000
8320	3NKTLHnvDtSQPX6jFdAQUq7of9YLWB2BzheLUCnttFU5hC1sDgLg	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1460	376	98	1	6301	jwrTo8SYRKbbSgJpHHYrikjMevJKG8FJLKgo8DR6RiY8bdP9c77	4307	6076	6076	1617032880000
8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	1637	816	98	1	6301	jxdoViA85HH2qwL2osfWKsWTijnTUPKThszyu64wysK6gNFZED2	4309	6080	6080	1617033600000
8328	3NLAiyGuUp1w59DCxmRDCYBERfEdYCY6zcYZxTK354NgSV5FUXFi	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1631	794	98	1	6301	jxuCWSzJ4u6JtSZB2BxaAUMmMcgXT7J2Vv8AiN11oCt52bZXNw7	4310	6081	6081	1617033780000
8330	3NLGb5WtrcNAL9W9brvrSeXrbfozqGouM8WP3EpHxE5aisszxjFv	8329	3NL4CqDZS5tKB4AH4K16Bz5kH29VY5KpZVV7aPQ67iF2FCf6VZ1b	1637	816	98	1	6301	jwMPx2u2B6A5gPxg67idgqSruhZR1yNP9WJCpZ9xHnNZPQmnMEb	4312	6083	6083	1617034140000
8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1420	403	98	1	6301	jwkE2HtdN9krvxkpV4e4kTPjRKhUexPeHDibmV4aUQTL6L2p5qL	4319	6091	6091	1617035580000
8342	3NL7UEwXBM428KTiMvAtewEKzquaFj1XnuVxaPsoL2KMoaF1ahf1	8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	484	1319	98	1	6301	jwYU2dcuxfFzkoDfnLHGVETib6WR3Wj39Gtw7AjCkJntscaGpaL	4320	6092	6092	1617035760000
8348	3NLqYYeK9QoNovQ48zXnZy83yv2jZPGMhPDENBdLuNQnqGiqWYUV	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1654	1094	98	1	6301	jxdyjVZmQj3xq5FXov87D8cMCrF4k2em8wEDqDkVHLTD6sR5b7b	4324	6097	6097	1617036660000
8350	3NLZvw5L6mGd2SJrygVsHxjwKkPqW3z3i3coAi9WiZ42vSTZFzRR	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1656	1343	98	1	6301	jxcxLF88DStJCyaL6Y5CLyc6L3UA11T58ZmQdcJw3hSJWcEPN8w	4325	6099	6099	1617037020000
8353	3NK36kVitYgBLcjte27Ed1iXjdwfBMTXEPmn8DeLGMtHZRsMa29N	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1581	778	98	1	6301	jwoSPv1U8aUKU9ivYj8paAJwLQk5nd4xxQ9MXzJ5R99EgaaLdqA	4325	6099	6099	1617037020000
8355	3NK42YXYVG4h6db56hKXqre1rPNfA5xYueGK97DomVU6K8LAXjK7	8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	1406	1393	98	1	6301	jwPyhkzWZiPUqGa4arA1Ghb1XS3vv3ppsKDoMwfQv7pwd8MdPyh	4327	6104	6104	1617037920000
8358	3NLF2JAidWT43tiRtUP3jYXqytwgGPRihUipSp3hqAL9RPtKdR8B	8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	1513	1379	98	1	6301	jxWFjskZFkm93kkc8bz4nUFBeAD353NQbzD7hY2P4oBwMY5u5Ei	4328	6105	6105	1617038100000
8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	8360	3NL72jiJEUVxsE1Y6YVXstKSK3ZHJsXfdEncnCAUvhEdrt7B7FSN	1534	1191	98	1	6301	jxXuygW3dZMjyt7qWuf2dhMN3sx3xRDCBdx6PNPX8M46RXTd4sJ	4331	6111	6111	1617039180000
8364	3NKx7rpKjGLHXmkYwfp9TbL1rDp4mXyNTiUzKCjk5N3FQGwDGi57	8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	1397	699	98	1	6301	jxEH54LR6LKW27R7CKBf99FBHwaa6byena9izzgwBZZseuYPKpK	4334	6115	6115	1617039900000
8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	8365	3NLAeNmLAEjLppBH21bcK97LDCwszMvpEKQ8PQB2H6ddgD2VBWqd	1592	592	98	1	6301	jxJ7Z1u4pz5y7DWhebtnPW5XKmkxZGqUbyq7qMaraahWbz9kdcH	4335	6116	6116	1617040080000
8371	3NKw5NtoJrvSpB5tvUpocDGJ9Ge1T7AUSNApCmQtxrvaT6yjFWJU	8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	1588	1392	98	1	6301	jwM7Zb1ExUNWzjB2c8uHm7L3Hbjk8EnXUtG3ncEJpjpG4TqAQBr	4338	6120	6120	1617040800000
8377	3NLspsAXXyBgCTyZkjncLP8AdTkF9NpotNiccRdXhheX6m8XfEDz	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1642	1121	99	1	6301	jwqVVh3gPK6M5D5FMhMHNVHtyp6gkWzeypxs45y7X4oAM289Rpy	4342	6125	6125	1617041700000
8381	3NKdjFR3zz937CASQwaytjKeNE48YiMi9ZvknmTZYL3DA1RoDVei	8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	1460	476	99	1	6301	jx7jiQ2pqLmUwsLBiAmrGkKBFN7uRAV2QRTN2GjmYNcxkgh5MRz	4343	6127	6127	1617042060000
8384	3NKoLRWeib5cUC72MPcjWqpLdKtT8P67ik1gM3n3L7nZyFamRoGZ	8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	1503	1277	99	1	6301	jxUemNZDPe377bAHyxbes95TRAwfg3Wo2q5kVniGEJ9gNubeGwR	4345	6131	6131	1617042780000
8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	633	1384	99	1	6301	jxGMTTpupX3JzxNxKhMhqm9k1kGHeJSqkDWV21JzsLVidKZj1Wr	4346	6132	6132	1617042960000
8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	1590	934	99	1	6301	jxe8jUg1oTrEA81EuspGGwswWNTBj5AgsGY8bUXmqRoUz4LV8BR	4353	6139	6139	1617044220000
8403	3NKUiksJYi2sZcN2yiwoyQC5LquVuxiUdewWEsuFLqo42C3bFhfj	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1624	1334	99	1	6301	jx7B3uFDw6bBEgzbpjR6fq8u3uKrjY8RVD5sf9wexWZrAAgQyDx	4354	6140	6140	1617044400000
8285	3NKt5Wimwka1AfAXnM5z1M4GcEZBR4ESeDjMEVgDL7kdnwxfC6FN	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1611	1215	97	1	6301	jwbPasSaakbseexTzCXe6hRKMC4VBH2LT5AzQWNsXBpAnMnSosQ	4290	6054	6054	1617028920000
8286	3NKBEGkfEVGf8yRQWdwxyS6GxhxytUQavYLHy6UeEbxgpSwTZbuo	8283	3NKNT1PxwvuRDqEvZnY6Lxe8FucMnSvoRvGNo9yTBcfmryMMVtxm	1637	816	97	1	6301	jwtQs5Ghz4BsG6BkVXP433Qx13ucDfmtiLE9ookcAc8msZ621JC	4291	6056	6056	1617029280000
8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	149	1157	97	1	6301	jx8EyM8PLUDGEtyRremLFbixPYEVFKhQs4VxeenNgE9Zory7cS9	4293	6058	6058	1617029640000
8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	1601	1388	97	1	6301	jx8eb8MctPCWYydydPGKyabrB2TK5p1pBbNm9t1hMSzpt2gG2tp	4294	6060	6060	1617030000000
8294	3NLFyvtgThfDhrSA9FcQGwA4hqANHTFfV6d5f3SxcjdQnPiRrtZR	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1602	1369	97	1	6301	jxRnAzaDVz64SBczgF6YSyTNpz8FDpWj5VW87J2L8Y3jwjVYYt4	4295	6062	6062	1617030360000
8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1476	1371	97	1	6301	jy1vpkZAEHySuAghKUJyZRVERuQLadNYXiM7uFBCdmV2iirgQ9G	4295	6062	6062	1617030360000
8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	356	356	97	1	6301	jxGgQz8Jh6tETWRjZb3Z3GAyk69shn4RefVDuLxAntUTYu927Ug	4296	6063	6063	1617030540000
8300	3NL6YXk6ZsZQ3VjCer4HphmHs95PbB4ayuapn8DW7FTbEBLJRmHc	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	632	1256	97	1	6301	jxAobbN3REU3jrvAdmycLFVYyf47k8SKq5KE3EQymgEB1Y3zKCp	4297	6064	6064	1617030720000
8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	1403	824	97	1	6301	jxcC8k4tQ4W3gfQEA5sUW8cHoz5xME22c4b2fB4uYx4GewZwC9B	4298	6065	6065	1617030900000
8305	3NLQnc5C6wwvm5Rr627gtFwCGBhpiKmb5fi1ZNa31dtoFsP4DXwK	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	152	964	97	1	6301	jwRV49htphoYAX3Wc7kbUUTh79K2XbHnjY2aFJcd5o3E7NGeQae	4299	6066	6066	1617031080000
8312	3NLu21XsAs6pEGks2z8bqzHnbtA9rXvxErynd3ZJNkf9KSUiUpmo	8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	633	1384	97	1	6301	jxc6dCXypComYdG6tkDLHhREDrTDJ9UVoD1qM8ENMzAkYqpcBAc	4301	6068	6068	1617031440000
8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	8314	3NLupN8KG6vMnwrj3f72YbhPidXYpUpAR7JbwUofg5E28ie7D2yw	1553	776	97	1	6301	jx4XcYxdqztHEtseaSsEKEst1TJR3UjH8uxozgTUcqfUtCFMK8P	4304	6072	6072	1617032160000
8327	3NL7oKyTLdJtrJXra9aJLWXfKqjY8MpAhmLgAc3LkqtV81JSmTkr	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1403	792	98	1	6301	jwaEBUNsFWd83QFczJ26B8FuTwGfdbpqyZiovSjgtD6dgEhQ4mA	4310	6081	6081	1617033780000
8329	3NL4CqDZS5tKB4AH4K16Bz5kH29VY5KpZVV7aPQ67iF2FCf6VZ1b	8327	3NL7oKyTLdJtrJXra9aJLWXfKqjY8MpAhmLgAc3LkqtV81JSmTkr	1541	1298	98	1	6301	jwykAboPjKXbuvhD1HACE4BT5xVyYHUjRnyAA9mnRBvg5nR81Z5	4311	6082	6082	1617033960000
8332	3NKoTNDSLjMsy5cmpGzz27xwShpyMbYLa7mxVgdqde68eyvcY7vZ	8331	3NLBG4AxqzQWgN2qyp3XA7DeuVa1VZBZ3iwwcGmB5gAMEJYj5aQF	1460	1198	98	1	6301	jxcpVNWESe2XdZxq9mk42FaPBwW3z9Rb4oSqr1v4rHxKWPRgjRf	4314	6085	6085	1617034500000
8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	8334	3NLNS5R9j1mj11ieqhu4RMpXtxRW375mcKaykAR3zRsEhEQSxjTy	1581	778	98	1	6301	jwpCet1g9KcgCHWLzmunvFkt4VBnexeszwVgAdZ8WeVVc25x5HV	4317	6089	6089	1617035220000
8341	3NKHWat8W4JLofAuUuRBTNTJm6siBy9opBnu5wzaMFB1fT8GGjNV	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1581	778	98	1	6301	jxkfgpjCUgeBH79tjyYYnqWNrqwgBBPwMLRBiRBzBxKKiKrCNFP	4319	6091	6091	1617035580000
8344	3NLeZwvLQbRfU6t5CFB2oP9r16dLWDkocmaePCiRK2emZ1Ms2Lsq	8342	3NL7UEwXBM428KTiMvAtewEKzquaFj1XnuVxaPsoL2KMoaF1ahf1	1534	1317	98	1	6301	jwTUo28WKULmtAmPMZphgq19aCB4tyRnX5zMVYkiVmxzHe1Vkek	4321	6093	6093	1617035940000
8347	3NKabXvZUcaGCatdNSFBhXfjCdfhgQcWGTg1kJrpbjphSsEi5arX	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1406	1393	98	1	6301	jxQhZtiF4WmgHkFEWSfCZFiye7fT4uwRfJGMBk89Vro6DTKJiAS	4324	6097	6097	1617036660000
8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1403	824	98	1	6301	jwZJtq8vfQrHFG8tuMZCZF4ppMzQEe5TL7FHecSfk5tLJFunFXf	4324	6097	6097	1617036660000
8352	3NKEoMSQtcAfntiYjNXN794b243ezvfrooqdwCns5gQ7nRESZ6MV	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1637	816	98	1	6301	jw7QzX1xhVpVLtn7TJZtArY4tDyAUxSuUGRc7vahxBoCM9huVoy	4325	6099	6099	1617037020000
8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	8352	3NKEoMSQtcAfntiYjNXN794b243ezvfrooqdwCns5gQ7nRESZ6MV	1407	1395	98	1	6301	jwb58Dd5HHE4WNYvNCbU6WJj7xwFG8FYEs7JBnzWsHdcLUrBp8x	4326	6102	6102	1617037560000
8357	3NKzrans7HmZDX4CjGG2vmJu64LKe2yAsSg7pAJY3BXYMoZuh5RY	8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	1511	904	98	1	6301	jwMB8RoUbevsQo1xBLY47wJrb9nb2mQyDuLeJYALJUm4LX758zY	4328	6105	6105	1617038100000
8360	3NL72jiJEUVxsE1Y6YVXstKSK3ZHJsXfdEncnCAUvhEdrt7B7FSN	8359	3NLvwY1pnyvSGsKREZhcwxR7hGVnSQzMCCKJD8eAoEuJs6X3z99S	1587	319	98	1	6301	jxSKatkhvtF9tuHsMKiSoAgZHheURDZy3eX49YbJvQjtDZntETD	4330	6109	6109	1617038820000
8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	8362	3NKkDcksAb3UpvM1hgrsgBsWaCUHHuaTU1xqfEDCLEefUNaEutUg	1407	1395	98	1	6301	jwnHpE63CvFxUYM8KoaHKwuCJRdR8iav5rk2Y8V5DUoZjmMMbaB	4333	6114	6114	1617039720000
8369	3NLEE1ACAfkWuujjQu1XGGUgFoxNW55rnyKYzkdErPP5TcsV1mEA	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	1403	824	98	1	6301	jwb6PcuHEUgYNbWWjetoqTZUVEQYL4sTosmSpCiG2dGZQQXZZ8b	4336	6117	6117	1617040260000
8373	3NLU75wjPNVdMWNhvX9rF7ukAZPMwBra4nPQbjkGPG4LNUYwxtkn	8371	3NKw5NtoJrvSpB5tvUpocDGJ9Ge1T7AUSNApCmQtxrvaT6yjFWJU	1578	930	99	1	6301	jxpr57tJrchyk6awxA65dEz73Nq4y1CWw5JGwD15oBe3jZdox7e	4339	6121	6121	1617040980000
8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1406	1393	99	1	6301	jwV1Zg5NznJb6n7kThFvYyLiqMyHnT9iMzpRV7rwLADaWD1dPbV	4342	6125	6125	1617041700000
8380	3NKsa14dT4HKwLXGBahPBxM5WeunLWENsUXnHcM4tV7JRcwFwFY5	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1407	1395	99	1	6301	jxhmboYUQRbNizhqWSGfhMjLSTy1SpeyckD17vfMbPoCKTE2SvY	4342	6125	6125	1617041700000
8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	8382	3NKYuroPpwtWUYDZJgzN22mh8BTPXqwA5jheFipo7FkrhbWFf1Jz	1549	1362	99	1	6301	jxdo85wDCjZmqs9eeXEhFYR4zaYcw2gmnNkNQTuA1YjmmGw88PP	4344	6130	6130	1617042600000
8388	3NKjmxcvHv2sp5udikoZEyRvhZUirM8ocR1UKNbsFnVmGa55mHBi	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1613	983	96	1	6301	jwfJ84xRjag8PD4TivLofYQCcHyGC2DPLkViLtQhXP2k9EBDCpK	4232	6132	6132	1617042960000
8393	3NK3q6yG18iSJaLiTDFmEJ5oJJJZr4wX1XCCsMG5ccVGj1NqNyW9	8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	470	1063	99	1	6301	jwNKKLgb8a3JJAKunVdkHjY8AYMo55PMWVGqYBweYMfksGboqPg	4349	6135	6135	1617043500000
8368	3NKEKeuMuUfPyiRPUsP3uNqvtJiASGrxnTRVYBP5cw48xZmKjQYV	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	448	939	98	1	6301	jy3ATaD4HpuJb8DWiwRaiibpCSx2k2kR6nrhJG84dr3SCXNgHk7	4336	6117	6117	1617040260000
8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	8368	3NKEKeuMuUfPyiRPUsP3uNqvtJiASGrxnTRVYBP5cw48xZmKjQYV	1546	1339	98	1	6301	jxc2psJ5zoWWesr5fcd9TKEjya8UweWB3hFfyxpm6wtULvG28WL	4337	6119	6119	1617040620000
8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	8374	3NLfrq4cWKGAK4Sn2nJGEEGPth8dH1JHGJHf837YPHYtWknrTLHT	1643	1299	99	1	6301	jxxCArNv2W3kHk6hQaV1Pw8saTgBLDn18iUpvhj9xVX6xTABAVE	4341	6123	6123	1617041340000
8379	3NKTBrJD5iSptmyNoZ9KDLuZDy28ycPuT3PTg7Sx6kscXDGN5C4z	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1649	1383	99	1	6301	jwNSmzFfrD2Fc9RsMk2N7LDZnSVgeYtNvQzzLoJWKEjVEBsnVaJ	4342	6125	6125	1617041700000
8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	1652	1189	99	1	6301	jx5d2X4kRQePV1XfTWrEgERQcFcagQuouYoZDbDfzNyRmvNFNeH	4345	6131	6131	1617042780000
8390	3NKBdXYrcxsWHZmssfp6zbtyY1pxGXGPtQVCQzA1qHpUxgrATpJB	8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	1405	867	99	1	6301	jxqUYPawyjpnkksvQFMXhBUVu62aTgTMLDKTaLTktx6sJcNj3Qg	4347	6133	6133	1617043140000
8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	55	509	99	1	6301	jwwhYv6ffirDr9ZtsiXRvHYoWQDVgnpQEsi8TbfPYASe8DyqA5N	4349	6135	6135	1617043500000
8394	3NLZYnHR32GsEEPvxdYp7bRfx8qcjvhRhcBu5A3CCAZTaCed1H2y	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1406	1393	99	1	6301	jxnJCDb8u4X3yddinmdQsQ4uNpdqQjL1xkjqqHVCRayDsma5HuD	4350	6136	6136	1617043680000
8396	3NLkQFTCMP5kjJm8yw5TyYVPEvxCbShRVAwHZ6f6QSGCjnN6JJqD	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1407	1395	99	1	6301	jwuKsoNuM33jDuuC3Qr3VqXgeL1HayMQeuf7azEZXX7u8YouH31	4350	6136	6136	1617043680000
8399	3NLMxxmv1CbnGTE5v9dH9G5PqBBaVDoqt9sBhg3a3FJ377vm5sJM	8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	1654	1094	99	1	6301	jxaxU54ChiR1VoxEgo6tgtUcHc8jN8WjTddTGf9dGruVaGXthGj	4353	6139	6139	1617044220000
8401	3NKE5LvoGPpP6n6cBhrRNqskEKEEq8darVAXWUgfR933119xTkMy	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1542	1304	99	1	6301	jxRGBCRQ8yXKvXBpJsxdVG7PHmAUMkNxKTbjfA9UtJG5uqeQ1EY	4354	6140	6140	1617044400000
8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	8389	3NLgAVqSrtZXEcMPcZkuKvLmNngqx45wiGa7ZaP8H3jaGrQ6i9mf	448	1305	99	1	6301	jxqXLkLb2k4qJX2b95aYrUyjZFBv93B7HhL4JVhTAQezpnJG6u9	4348	6134	6134	1617043320000
8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	8397	3NL5YQu2gu89o4oiFDQvU1mTNsyQd4E5XrsBPfs2WEma1h7RXXLm	1675	1342	99	1	6301	jx7yiQQm4eTr8215znFYxwepoq8B9qRsV2qC4YBeM5WujtdFR5M	4352	6138	6138	1617044040000
8395	3NLfciqZvwRZbF7vJeZaXMK3CdbvSPAkeMz4hT1H5kRmAew4ihPp	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1402	796	99	1	6301	jxTSR6TVMJcuwku2WLQNLJAyJFHkQmg49vSD2f8gsgqRjeZiHmx	4350	6136	6136	1617043680000
8397	3NL5YQu2gu89o4oiFDQvU1mTNsyQd4E5XrsBPfs2WEma1h7RXXLm	8396	3NLkQFTCMP5kjJm8yw5TyYVPEvxCbShRVAwHZ6f6QSGCjnN6JJqD	1617	1042	99	1	6301	jwrN2CjpQ36NSQtAG69UgFXBoeXFo6C366ssmeDri2KWXxFVBKV	4351	6137	6137	1617043860000
8402	3NK9fuKzscKZNoiRcb1WXpk662FEb6jFTHVVNjswB2KEWo8vbhgu	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1405	867	99	1	6301	jxZb7RACp1FCKYDyDMNQC8R82NdWKoTJ7RKGKAE7vou1hf4zjJ1	4354	6140	6140	1617044400000
8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	8402	3NK9fuKzscKZNoiRcb1WXpk662FEb6jFTHVVNjswB2KEWo8vbhgu	684	1352	99	1	6301	jxNvrPixaTBLhmHmQs7oTvujhxgWq5dqLPphDYtqeYYJWfoLBhf	4355	6141	6141	1617044580000
8405	3NLwtmAuRANacPKT3yA7gesvk5kkPePaFCqA3XccNyNs3xm8kb34	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1403	824	99	1	6301	jxVSKsNxPQxKFmuVGoTp8cK3aMo6RwURi1cZ2mkDQjNbUJSCRvV	4356	6142	6142	1617044760000
8406	3NKXPGghsiPGqaHvf9EuCuDVuA7F4aQCVPsWksoXxZr6me5Kipij	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1534	1317	99	1	6301	jx6Ky6koUCLowyBqFmb2YjMuhSuWDLz9R5hJNAWCUGSvP8aTL9W	4356	6142	6142	1617044760000
8407	3NKxTNcrAgXUuhFBeLABH1cJNV9tPCu8yMvoioG5cWSQAEz4AEBb	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1631	794	99	1	6301	jxgrMkGrBXTQZDbihz6eq17iiHKUogwSu1RYvUNo6UBZThbXqQj	4356	6142	6142	1617044760000
8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	8406	3NKXPGghsiPGqaHvf9EuCuDVuA7F4aQCVPsWksoXxZr6me5Kipij	1407	1395	99	1	6301	jxUeqNGkU9GTYtwynfSZrLy4EWpMNjqbQM6RdGjF9qN3SyEsDuF	4357	6143	6143	1617044940000
8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	1553	775	99	1	6301	jxqq3xMYgYs834h3rJ7CoHD2s1U9WMezR1772qfwxTmf1TkLZZm	4358	6144	6144	1617045120000
8410	3NLkqUN5YnuiiYNvBfq24KT7BRqZ4d2pUk9pFAQ9T7hRSKdsBhrY	8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	303	303	99	1	6301	jxcNiaVZi7Nhjk5LmZQGCr4RjGeHS3DKBHD8dsxUjtkWcv3fQfn	4358	6144	6144	1617045120000
8411	3NLCcPAvbiW78DMeR8hM6zv1aJvbkPtDSqfma1gkRGpfyXxxXfDe	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1406	1393	99	1	6301	jy1w39XNh4rXGKPeSBCCZ3SDWqgq329BUx4AznX6H8YSHF6yW6U	4359	6146	6146	1617045480000
8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1501	1360	99	1	6301	jxTSLxDPntaws3iZsEByD2Uzc56rVbe8SNNvc6BnZvrpQq71i8F	4359	6146	6146	1617045480000
8413	3NKaWcEyYPBgGX7JWDxYyMjwAU1QtUHMWvcFkfKfmjs5bZgkVUym	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1581	778	99	1	6301	jxgWTyjoNGtFHcQzyLsmUudTcu44EiNy7Wa9F3qGqDpUefFB54R	4359	6146	6146	1617045480000
8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	311	1307	99	1	6301	jwdhhC7r1c713LVsz5XURaNCj4JeP5ZXVfeJKPHAj9QYxoa1YkN	4360	6147	6147	1617045660000
8415	3NLxvdYezt7ZYtQWR1XQdi7UUhTMMn2yFKu85hPkPZ1J9TZPmksA	8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	1631	794	99	1	6301	jxreP5EGfnPX2pbK1GhcdYDPsxfuaHWnmy6Q2DW4uSzbLQzRpDd	4360	6147	6147	1617045660000
8416	3NLCD6WhZggS2cjeWv1PpuSBxpdmLwjipJbeJ7ewhjSZzqLuFTaE	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	1542	938	99	1	6301	jxJPpb19h8zTHXysLgC1cq6DpQHkLZL5tT4RGEwW2Qx4XeTQTAo	4361	6149	6149	1617046020000
8417	3NKWiarbhK8zabTn5YAtEqSZcvss3iAC6sqABQkSz3cVVTXghYZv	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	152	1330	99	1	6301	jxjqWJnQPEmuhMvYLKoVGJpeWYRubMWx6sdhJ2aZZnzAYaM1mkG	4361	6149	6149	1617046020000
8418	3NKEHE7nRnCkhfs9QCC5yD2CcHCBPsaZitQGxUhmTpDUCRRdVRBF	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	171	1008	99	1	6301	jxVhrdNX5ZXsyDqky36kfJB2aqV4ZdBx9xWZYesh7tA2KCVRj5L	4361	6149	6149	1617046020000
8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	8418	3NKEHE7nRnCkhfs9QCC5yD2CcHCBPsaZitQGxUhmTpDUCRRdVRBF	102	102	99	1	6301	jwnGbzFa9t5Ze3iBxo94QkEGLr7pRPPHNUBrqmb7DTAhnXwVvxs	4362	6150	6150	1617046200000
8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	1460	1324	99	1	6301	jwM7CmA8v1oufkZVhFo2kWyDtKwx2mBEdR8TTDMzgL21Ro8safD	4363	6151	6151	1617046380000
8421	3NLLbdrjkAoLHK1nGQJKBpCfz3kS3wQuEZnAs2QGLGaXt1QBwE1V	8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	1407	1395	99	1	6301	jwihaefzq6bFyE8ihXPN7siT1H23p4Ud9H82Yj2JJMizK6LeraN	4363	6151	6151	1617046380000
8422	3NLTe2yb2LhoAqzxU8DukKeit38AkbVxmuwf8sHbPs4rkEB3P8ji	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	1536	1067	99	1	6301	jxJVjqP2oHc3CChwnM2cKoDdCuGEYv6H2ySyiTuHHXWUniwzZgc	4364	6154	6154	1617046920000
8423	3NLuqvvjZUMzVQAYKr2tiY4YHNL1e3aQtcBYaxnor2Exmvt9fxZm	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	1407	1395	99	1	6301	jxxhppnhpDQJhkaz9XpejX4DRCoDBtyiUoxsXDUAsLcWiAgBiJ4	4364	6154	6154	1617046920000
8424	3NL9D48fpZKvd9cDe5ZgDaGVn4UgeFzQYxHzs9FNXSTE8VRu2VLC	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	210	210	99	1	6301	jwTj6k7wAGF3AwSfY1Lkb9d1jAq4Rk42SrdEE716sqdpDEGTHXu	4364	6154	6154	1617046920000
8425	3NLCv1kKoSZdkVvdrAMtBa4Hrxm9thQkvJrCqT1b531KcHzmnGUS	8424	3NL9D48fpZKvd9cDe5ZgDaGVn4UgeFzQYxHzs9FNXSTE8VRu2VLC	1406	1393	99	1	6301	jxnzx9zkRz3F16KgJasosMcq2vp17NT4v4ekNmJTkvujpUoMtEd	4365	6155	6155	1617047100000
8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	8425	3NLCv1kKoSZdkVvdrAMtBa4Hrxm9thQkvJrCqT1b531KcHzmnGUS	1406	1393	99	1	6301	jw8RdFhZFVGpFtWNDGoQfMV63UV2sZ8rsgJUY5MmhjK1bDaT9DH	4366	6156	6156	1617047280000
8427	3NLNPxhhuXUg3s6b4PwPDwXuNQ4hSPv4tuuojLPcnxGySeboFhnT	8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	1671	1365	99	1	6301	jwusM6qqmwQtoQjYYKC14YJUMmVkaixmXis1tNd5g2ZiSRepHME	4367	6157	6157	1617047460000
8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	8427	3NLNPxhhuXUg3s6b4PwPDwXuNQ4hSPv4tuuojLPcnxGySeboFhnT	1534	1317	99	1	6301	jwD9e5ciQyjfCmSFJzDkY6ww2xctoDeaoK3qZLgBcKEkEYMRn4U	4368	6158	6158	1617047640000
8429	3NKSGrb6VxPsVm3uADJ9iCGTLsf8mT6aKCrwBsJDqhLQRes8GdQs	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	1407	1395	99	1	6301	jxyntx6U58f9f7E3o5aA5gDpx1H3vzrF6zvLs6z5yAEt2Tfu38w	4369	6159	6159	1617047820000
8430	3NKJJgxKBQyrFfvcLFSdvR2xgJZC9zRLzGxQj443bSzxn94meyxw	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	1637	815	99	1	6301	jwME7qd4tZm1QWSqb2SwwSsZ4T1fkwTV8KL6G4pZ7Qx1WpGhiqk	4369	6159	6159	1617047820000
8431	3NKmmLYf2udiLEGtw33ofNP2NwsBNoYKqH6bgn2awYLowfJTNvEU	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	606	1049	99	1	6301	jxgRMhaewm8vum7cuVfwoorvjrdptznFzTojhRQbtkA13KHYcr9	4369	6159	6159	1617047820000
8432	3NLyC86PijmyABt5boBeefBd8mxGLkLdcW4BAWnMqJZXfkenkspn	8431	3NKmmLYf2udiLEGtw33ofNP2NwsBNoYKqH6bgn2awYLowfJTNvEU	1406	1393	99	1	6301	jxpciFv61nxuApAXFdA1LX2GEUKqheVt7vj7REQvsDdJSRvHXuQ	4370	6160	6160	1617048000000
8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	8432	3NLyC86PijmyABt5boBeefBd8mxGLkLdcW4BAWnMqJZXfkenkspn	1581	778	99	1	6301	jxJEooukjnfEA4W8o23aZb3rutN5wYy3akAeSXX1rNLkAJwm4DV	4371	6161	6161	1617048180000
8440	3NKX5vUD5Kp8SMLwkt7zjxo3Tu25Ez1ZoDJo85QCKmpbNwoAaK26	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1407	1395	99	1	6301	jwc5oWRz53n7RcVSeWxBzUVN4ugjsDkBYi9x85TkjwQExtBF1kY	4374	6164	6164	1617048720000
8442	3NLb4smTBHxy1qDV7BAGGa4aLMmvnYSdT1vyh2ZWNQzumHaHbSEL	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1542	1304	99	1	6301	jx4GATohZkvngNzDEgbtk7UyFTv8zmaNCgzf2nX4UwFHwzRXvaq	4375	6165	6165	1617048900000
8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	1596	997	99	1	6301	jw7RnbAPiyiEnzK4qy41L5U5J4RhfdLKN6nzE8QqYzetoPFcKW8	4378	6170	6170	1617049800000
8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	1397	828	99	1	6301	jxYfeJnuQTcYnZrxD9kx1NsxPTDWik7f73cxSB6FYgDJ2etZxBi	4379	6171	6171	1617049980000
8456	3NLmHfeuFw65iaS5wsPg3kRpENUMH2EMo96ocbxayFk88RCGcH5d	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1407	1395	99	1	6301	jwLNPgRXjQ3qC7LyEz74SdiZf95iybKZD32v1v2LFy7aZh6PwKd	4382	6174	6174	1617050520000
8459	3NKs3YxGvojaMds74Ytiuo7cZiHs3p1ws8HJ417FiyTUBGuQr9vb	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1481	790	99	1	6301	jx7LwAZiga1a8D5qjQHwRvCqqQmdCenCSdSLzT5z7ACpkEvaxHc	4382	6174	6174	1617050520000
8462	3NKWjvXTnQBM2QhCUMxEWzrwpqbFQrDzABVDsH3KCwkkbT2pNcdE	8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	1637	816	99	1	6301	jw9RqYuLZWaxe4SEpvmXgMFQ19gzqi5LQZkefGxvGoznrTKGALj	4383	6175	6175	1617050700000
8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	603	603	100	1	6301	jwfx9NN9i3zStDttgd3e3F23GJqQJBzxsRJi1j32q7tUQH417M3	4388	6183	6183	1617052140000
8472	3NKB5jhH5D5eCSERKZhzN9Q3juYSe8zALosZWHwZF9ipfDT8S3Px	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1668	1124	100	1	6301	jwsBoEQyHPvwP6H3qzsbsRFjUjqMVuRKosGSJqggHy6nmGeHC95	4389	6184	6184	1617052320000
8474	3NKTFq2eJVMeTaraDnuoC9Qqq9jdyWX5gQxBebe9rhFArD4AZjba	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1611	1095	100	1	6301	jxkqrB6rgcAJWw7oAQNAyUJm2REDyme8BWEpj4eRL8DcgMyga7N	4389	6184	6184	1617052320000
8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1503	1151	100	1	6301	jx83uRSSeVTqZgAyy3C2oV6hCSRTfe4f63RwRa2Lyv7K2nDZJhz	4394	6189	6189	1617053220000
8483	3NLrjxnD1aYrZKuzaXpBjB7Ecu3ibiCfBiAzhqLcoT3RzKhjU5S5	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1553	776	100	1	6301	jwLQPurDLVj3PhTFxgzYg7KPwRQnPKaSepm4uJeV5P7aHoK8VNA	4394	6189	6189	1617053220000
8488	3NKEHB3ZhfAEJWDoM4TgADwGZmLFWZ4BGrt7qqurzJPixUntwuHL	8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	171	1248	100	1	6301	jwLvkcUDS2VhGWEjHRoTps94vtZ7zVQ8FYRLJg2BvG7L4BpsTQX	4396	6192	6192	1617053760000
8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	1457	1391	100	1	6301	jwosGQG7BB9sGH69XcTkuDFUP8jJGceXCKRiekp3T7AruRQrMVG	4398	6195	6195	1617054300000
8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	1406	1393	100	1	6301	jwSS6ztgcMaWERRQFF5ndoYVBb3AD3Z4k2zLxLXc4qUtDpbMtSs	4399	6196	6196	1617054480000
8502	3NLSohKNyDHT3JUyQCsKFod3ZSZm5LkaKAcmRJD544vVHa4SExwq	8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	1581	778	100	1	6301	jwf4uHc5N1XU881Kj9MLE9kaJGhcfPWgGwMySTPXKLyoJUGNbcA	4403	6200	6200	1617055200000
8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	8503	3NLXjF2Nj1kqCA9gcRZioZJv7nvVPnWUe3eCZ9HjauncRhPQaomE	1675	1096	100	1	6301	jwkEcBVmNAiKgdGoYNKLbRT4vAgm1Gz13yPYrhk8rUDJiXPD1N2	4405	6202	6202	1617055560000
8511	3NLEuWnWZDjKHXZP3gswBdUemNeq86BHkotPFq3sJW21uX2Ujm95	8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	1471	1140	100	1	6301	jxZKyHyaLADev7qXEFKi3dvDEbR4rmmUMXgH6pSH9K6TAdUk9DF	4409	6206	6206	1617056280000
8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	1419	814	100	1	6301	jwZiQqRWHziKwe2tcfofhEk3eYjhM4NRM7mLf1sc1xQux6Xv38W	4412	6209	6209	1617056820000
8524	3NKc2Fehmr9mZbnLT3QT5D9FyiBbHoqFLFs8b3F1ytQfr77cTHAq	8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	1602	1369	100	1	6301	jxAnjBRHBVu1rjUkC3n9PWVRv5dSZpNKKnsc75YCtni1L3nXnjL	4417	6217	6217	1617058260000
8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1549	1362	100	1	6301	jwLeCMxsM4EwRunA6xDT3BQ4Bx5bmRVTcpnMtksD2NQg48w4Ax7	4418	6218	6218	1617058440000
8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	1594	1326	100	1	6301	jwwBzFxLzY1zJsqNEA8JYJ4Pkr26mw2ExhC7sPvZURHsG7nM4ft	4419	6220	6220	1617058800000
8533	3NLJ8mzEFXNZEFnnTiyHWzUT9KSFbwvdfV3XdbqBBCXQ8EkEpXX3	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1516	928	100	1	6301	jwS5rgzmWBRSVogcGNp3PzgtSJui9KFMLayZkuQusvWhEDYrB5W	4420	6221	6221	1617058980000
8536	3NLGe2ks2ZPMNeVahqbqzJWeQ5dnauwoMHAwP48AnZR8XPaGfhCn	8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	1403	824	100	1	6301	jw88iCRUeQSbndpsedi5z5aJJbz98tAWAk51gkxoYyW9J8xHHxK	4422	6223	6223	1617059340000
8539	3NKxvje6jBqAkbQV4ZwgU7fNffUXRm8wRJWCegRrf8SY8qUKvW1G	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	632	1382	101	1	6301	jxmUdmZPTkkaqqM5ztQ2rvAzMfvE4ZnzJaCR9vzfseVyw3w6WkC	4424	6228	6228	1617060240000
8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	8540	3NKFANNZiJGdapmsHhzv4gkJKZv7GKW1c86KE2MxmqrRrC8jFPZ5	1402	868	101	1	6301	jxwgmzxJwSTGS1ZqpwvZNkFtbzsv3i5a9vksyVxyjxPzF6KDY5b	4425	6229	6229	1617060420000
8544	3NKgXkYBRLeFPWvKhPkLYV93xTHsp4pxfELoStLGVcTpG9NbxU1c	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1403	31	101	1	6301	jxbYAdZLPvxaaymG4zvXBfFBiRwunZ2KGsgNGPM36v27UUeR9EY	4426	6231	6231	1617060780000
8546	3NKVereYeg2tNLT6D2QExf7X5rFnGtd4DnUMvfb5KuwGTL9kdbgu	8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	1610	948	101	1	6301	jx2EUoEY1SK2c8esLwmTz4RJKqkZLSMnuQHJnRrmFjTy9CiwhNC	4428	6234	6234	1617061320000
8549	3NLJ69RmquQmBp6ZsxRZbp5CRtEuPoagee7dA2FQdmuwP1f1mbih	8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	1406	1393	101	1	6301	jxZn1HgL2jWxw4Q17VFQ33oAAXSjf6JQga8zPEzC1wWrYejRj65	4429	6235	6235	1617061500000
8551	3NKepWzNiDcsYr6EQSx2aVcTJK1Umk3SZKTSXEP2rtDuMdUoyamV	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1553	776	100	1	6301	jxes61RXx8TWBokR7c2YifSjKniNh7J8CTCkThsNjsq7pvcJ8Sg	4420	6237	6237	1617061860000
8553	3NKKdq1pbawrBz7JavxAdeCHA5pX68XKA7532gNJfc98NNFTo5X2	8550	3NLD344Si4NvPZ8MtBfCcjWtDCRYLFmJCywphNATZT3V8pjihuWu	576	1355	101	1	6301	jwgB9y5yJFovvCCRmLdc3igzTafvWa5NMBiPEDDm6zeFHbLkYwA	4431	6237	6237	1617061860000
8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	1668	1124	99	1	6301	jwR31FaFuQ8c5bq7NWigBNJrPiXcYEStqvZBpCz6y7gFmiRfaYo	4372	6162	6162	1617048360000
8437	3NKXw64tBt7D8gT9bnW5uC4xdYYbhaAEXWieKn7SguQmUzsqcxo9	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1578	1296	99	1	6301	jx6n8BNZfUy36sfdW9CKpb3ADS2hkSdTaMuLrSKQWc1wne3FFrg	4373	6163	6163	1617048540000
8444	3NKgm1LoKpVimo6rABnhkAgrMrkLYoSbqRMJcsjCvgeXHhkb65ZQ	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1406	1393	99	1	6301	jwmTf62AmB1J26z7fqT5tf3No67ccuM2qYi8gEJX2TULQNbqYit	4375	6165	6165	1617048900000
8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	8453	3NKimwactNoNA2Bcu1SXhNW6NkBSgAdVc7q4u9T4FyZqzRttn4U8	1578	1296	99	1	6301	jxiuQuKKsCp5uPFZh79eU2C8GvnSKHZLA1B7aarCYiM59vbmZgw	4381	6173	6173	1617050340000
8457	3NL17iDHUbPFF6RQLSL3fARWjbwNwhv3EDw1o6Pih32HjhkK8KgW	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1403	824	99	1	6301	jx1BLue1dx6zasfwMZMPt14G86TeHoCTknsxgtWdZeLZKXdt4aW	4382	6174	6174	1617050520000
8461	3NLNVsCM4TbzKW1K5rgKW9tjq7qJLxGUQhgWiLjYi5vPZZPtp281	8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	1406	1393	99	1	6301	jwgeirMQRf6g87GoyYXfxeiU8WG9uNv2YdBPbN2q8f1QhT9NfKA	4383	6175	6175	1617050700000
8463	3NKoAveXD7UVCPYjxEw4kkiP1DtAfkbnr9RWrxGfHDqy3pSh9qiQ	8462	3NKWjvXTnQBM2QhCUMxEWzrwpqbFQrDzABVDsH3KCwkkbT2pNcdE	1407	1395	99	1	6301	jxfewppteS41bvBRrirCGQcuzRCbcBjQ59H1YbG8K9qwRwSWExe	4384	6176	6176	1617050880000
8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1402	850	99	1	6301	jxN9Di8be29XExdxnZDwEkH49CanYHvzqGLdBo3yt67B1HxwhQy	4386	6178	6178	1617051240000
8469	3NKxotMX3HsVmTCVXtHwGtuQB7Q8vDFkxygPoH6WZkKcrvWiG1s1	8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	576	1109	100	1	6301	jx6k1VNx7bHthrzVdzk1gfFgcXy71Ct5YdhRxEZnmSFQjdnzPqb	4387	6182	6182	1617051960000
8475	3NK4pq1yk3CRc4yvqqmDX5HZFHmiVZ81bZ9dmDqvmyCmFis5A17v	8473	3NKHczTRCmFDNGvFQbe9xw2JLj472c3JK2xP66ULquVEoyiB2PeZ	1489	1134	100	1	6301	jwRyUgAAkqgLb83Ab2E3nzyYgjhvZ6H6Vm9EfeFGrcic9DPzhXK	4390	6185	6185	1617052500000
8478	3NK5Tj1VyU2R2LwFTaZGpCqkko3UkwKoW7jeWdENvEumtWeYCunH	8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	1619	1029	100	1	6301	jwqaevC5om4qjzYzq4q3mRDg1HYz97Cw42iJQjkX8ooBjNUuwej	4392	6187	6187	1617052860000
8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	684	1106	100	1	6301	jxrrmjUpRyGP8QFatnYP8UvtKoZsvAL2Xe3ZHiuWCX2YBSy5ULV	4393	6188	6188	1617053040000
8485	3NKBMyeRBB695dYP6jd374rdnFoakXGHHCr8Ut7SmMT8yc74uEj5	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1648	1158	100	1	6301	jxvKeiqQfM76akRYsAUHAgH7heKePUQE1NikDHw827pCMC64Zd8	4395	6191	6191	1617053580000
8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	8487	3NKrLqg38sPTNR9HEwVFJqXywGvqqz65yTRJdrKnw6p3QQt95zYj	1577	961	100	1	6301	jwbWk3djwoN6K1sQq1vN8xhwwNixTNc8kq6tcwFUvVJYCGyRNH8	4397	6193	6193	1617053940000
8494	3NL6VWo3S8AkpPiuU5dRj5TQJkfraABovnUFDsBhVz6yxcPUGfrq	8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	1656	977	100	1	6301	jwAv16M4qyHEybb97JWhKMxJA2tD4yWyFaSaabo6rJkvi76268k	4400	6197	6197	1617054660000
8496	3NL4AJAF3L1qRgNa79mdjjfs8TJNx5JC94YaQ5gZ5yjxJahL6mLu	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1506	1247	100	1	6301	jwvArcKSMA3NZYDQSGYwoQCySfYXJ9RUAfztmPP5eZFHBF3aMpU	4401	6198	6198	1617054840000
8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1553	776	100	1	6301	jxJriYy9jrZriui38XhebbgQS5durRgXJv967WmjBq8H1KbrCsv	4401	6198	6198	1617054840000
8503	3NLXjF2Nj1kqCA9gcRZioZJv7nvVPnWUe3eCZ9HjauncRhPQaomE	8502	3NLSohKNyDHT3JUyQCsKFod3ZSZm5LkaKAcmRJD544vVHa4SExwq	44	530	100	1	6301	jxuErm53V7an4L64kYhcEcCpS71nvEYh5RQ7fF2GRUV77kWRdbD	4404	6201	6201	1617055380000
8506	3NLi52PZccC4NaJAqT91ZKC1GJRNeCZH3GUY5Ne2rdJLFjXgenqN	8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	1477	1350	100	1	6301	jxa6RjUUnbzizR2afsyTaco9PRHN97xH7xjqQwrddK1UYYTidoU	4406	6203	6203	1617055740000
8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	8507	3NLAthjV5wuH5uXWuSk4KK9wX5pJrfYoVw2w1eUJXSSF8nRbrK2X	1406	1393	100	1	6301	jwTzPNsyeQz91Qjz8Efs7GJHzhj7aFFSgX6X2dLAZACL781YaQT	4408	6205	6205	1617056100000
8515	3NL2cCES6fHqpmv4Lkk1KJCYmfwtgmc7oCnT8z6AkAXCEUWcELwN	8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	1406	1393	100	1	6301	jwxkSZ99DFxZ4GEjehbTKR1d7vzcpBKNTDLXmXGNGVyxP8LL3CJ	4412	6209	6209	1617056820000
8518	3NKCYYrgiLwt3W6Zq6FJiSFHX7tyNCE7xxQVv77h3vhViNqSXStE	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1672	1039	100	1	6301	jxoUNLruB9Tc8nZ9CUeDuBnr8uhpDAptarSedB4BAVdv8ruwBQU	4413	6211	6211	1617057180000
8522	3NKg3GxNL2pjDSRc1ZxDCVYQPoBYopAii42SwGjsd6xJqR16Gtod	8521	3NLeP6so39bvC6WzRc8gGPKd6VjAscPuUJvvqqzE6XGDQD6NWXWY	1587	991	100	1	6301	jx2VPoo5bmGiH8ogzNjum8eaSTxQNpLWGh1wS5GbXjdw66qtMzz	4415	6214	6214	1617057720000
8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	8522	3NKg3GxNL2pjDSRc1ZxDCVYQPoBYopAii42SwGjsd6xJqR16Gtod	1577	1081	100	1	6301	jxBCnQQhTi2BYucTG4SsGsA5BYtCENp3gS8pjgSTGyaGhUFYCpE	4416	6216	6216	1617058080000
8529	3NLLbbpTPtW1v8F8VN1z5EhvLyPkfCeqK69TQZytREH2pCFrSS1J	8524	3NKc2Fehmr9mZbnLT3QT5D9FyiBbHoqFLFs8b3F1ytQfr77cTHAq	1490	908	100	1	6301	jwjDr26fPCREAn1pK2ej7fzM47F1ueDcUvvRFPci1ZvtFGsCt7d	4418	6218	6218	1617058440000
8532	3NK92QJGgJ18d4LqpKKBzKbafy2jz9KDPrusmYimXR75MrwBCYsM	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1406	1393	100	1	6301	jxtpbye61v76GSirseGDNmv5ztaYeQhiKTru2pdtQjFDmY7HCZb	4420	6221	6221	1617058980000
8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	8533	3NLJ8mzEFXNZEFnnTiyHWzUT9KSFbwvdfV3XdbqBBCXQ8EkEpXX3	1613	1349	100	1	6301	jxEp2xEiRB9sVCFWcLbWc3ESDqHVaqHyzjWNgGRpnK92N36j2TA	4421	6222	6222	1617059160000
8540	3NKFANNZiJGdapmsHhzv4gkJKZv7GKW1c86KE2MxmqrRrC8jFPZ5	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	632	1382	101	1	6301	jxmUdmZPTkkaqqM5ztQ2rvAzMfvE4ZnzJaCR9vzfseVyw3w6WkC	4424	6228	6228	1617060240000
8554	3NKF1EfUYcCYtTxgTTmqYuUJdq5Kq7SXo8krLxW4bQ47wrxTCfvY	8553	3NKKdq1pbawrBz7JavxAdeCHA5pX68XKA7532gNJfc98NNFTo5X2	1503	911	101	1	6301	jxb5NZ2PwuZxQvx3nfHT8PUXN78Napp1eVrYVPnL14rmWKpfxR6	4432	6238	6238	1617062040000
8557	3NLXQd1rMyfcb5V9mhzbkCZsrbQCq2YjDpm1DNmaS16rq9KuaKjx	8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	1581	778	101	1	6301	jw7pUyieDduvk1Ug9mSK411TD5czErp5GgaCRa1atR8njFLQGyk	4435	6241	6241	1617062580000
8559	3NKnZUBh38p7mAygxJM7oZSnyuW1n8gjvj6qvd63WWvkoKZ7i7nQ	8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	1407	1395	101	1	6301	jwcoc1gETu3YxEVitJmsC8TVtDhCmxqTE54MwvnFW2eFsB3VXTF	4436	6242	6242	1617062760000
8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	8561	3NKKUnt9WDBPWRuKjBGx1PtbcQLvRkmsJwfF5iySYqpsaJ311ckR	44	1325	101	1	6301	jxjaiF9P5PTdhAypJuQmb3UVKgE9Xtwj5djbWrW74cMiAub9Gjq	4438	6245	6245	1617063300000
8435	3NKwrT3ns86KNh2GxCFACDjK3cSbExEDudgZLAmfxhGiuSdvt5as	8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	1403	824	99	1	6301	jwEbd7FwFxpsfe224sjty2htB8ujmbeJovJssYaR2wjEJ8Ci2jW	4372	6162	6162	1617048360000
8439	3NKMpFrEB3bU9amDy75sM2Hw7QbwwvAHsJdMYTFGpmsqcVFCULLJ	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1547	1378	99	1	6301	jwxurxX229FHYUNi1Ce1mRCAx1L9KSGNYGcTwVbn3HjMwQ2y8vW	4374	6164	6164	1617048720000
8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1581	778	99	1	6301	jy2bCoutdMTU3vbH1GuzBKBdFnLtkrae1E2GpJYQPBm6zGhmfsV	4374	6164	6164	1617048720000
8445	3NLSHcuRu4a2q1guFoC6VTpvnEmRRzTaXm1krvJeeY2iQskDNiLy	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	632	1382	99	1	6301	jwsYi8vtM5xL3XBsKSymLENAuh2LmQxvk2MMvMwvcoDYiHxmv7H	4375	6165	6165	1617048900000
8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	8447	3NKNu1PwTYwjhRSgaQH5KFUnNG1u1u7gGfG5dnb5RQS67C8eJTZ7	149	1283	99	1	6301	jwRveYMFZZAZV8RWkuCEersh9qMC4fsPUiBf1vb2eMsS6WH2b1k	4377	6168	6168	1617049440000
8451	3NLbts27QuethfWj5tJpGZYB5VYT8wPrTbkfDnKbeGgDvBWmgYZP	8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	1599	1287	99	1	6301	jxqXaZ1iZP9XqL4eiQZ8duLQn2t7tM9Xh6GX7LmVJZT4Fpzg9zb	4379	6171	6171	1617049980000
8453	3NKimwactNoNA2Bcu1SXhNW6NkBSgAdVc7q4u9T4FyZqzRttn4U8	8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	1406	1393	99	1	6301	jxbfWKBkuSK2G7Ay7Nz6pkNk35wkGvxHAVP4xFeUnfMj6DZewGk	4380	6172	6172	1617050160000
8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	43	1184	99	1	6301	jwj21MnaRdU32PHMN6e3x7SaarKErW2ZLzayV8k18syes9r9aWC	4382	6174	6174	1617050520000
8460	3NLojLcNpymZQAHTb1dqUFd2o2L4jBaxf99eX54PeJqyFZd7E5ic	8367	3NK7WSsRZxz8pE6WWWL8hsCYEjcp7hUMqzksnE5mdtLzsg8WVuev	43	1184	98	1	6301	jwYpYicNyoKBhD9LHoVhHDJNRc3zQGk9GwshxEaJnbEHdjynx6s	4337	6174	6174	1617050520000
8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	8463	3NKoAveXD7UVCPYjxEw4kkiP1DtAfkbnr9RWrxGfHDqy3pSh9qiQ	1600	1126	99	1	6301	jwXKhdwAKYXjb3uUpp53xo5xGgJSvzzJWvq2ZVs8KZgchFVVyPy	4385	6177	6177	1617051060000
8467	3NL2n8qz76Q77CrhE2F1HTegHeyU7K517DR82w4XanDHbwEiG1q2	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1648	1284	99	1	6301	jxtQpWnsmrzGjYAxiSkr5DpDqYMWb4tM56F2ejWnhukxF7D12gE	4386	6178	6178	1617051240000
8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	8475	3NK4pq1yk3CRc4yvqqmDX5HZFHmiVZ81bZ9dmDqvmyCmFis5A17v	1623	839	100	1	6301	jwqjRqUhF3Ua2JHBm7RGbbs5xhJEjnkfRwWfyn3nEKC34GX3eba	4391	6186	6186	1617052680000
8487	3NKrLqg38sPTNR9HEwVFJqXywGvqqz65yTRJdrKnw6p3QQt95zYj	8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	1534	432	100	1	6301	jxJ4HwaVTX6JCbqHDcm2F3WX9mTvdoLjziJNTHoHaxcmXZg9nUs	4396	6192	6192	1617053760000
8490	3NL4t6zpoad6vLU93EYUQ4C8bU5sZKamLGujA3YFokbic2C9FcLh	8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	1613	1349	100	1	6301	jxSVNwPg5282quM3yL7qf4c6LZKYjmbrB3xzUNEx5RdHgud8eKn	4398	6195	6195	1617054300000
8492	3NKvX3RXV1BsgctLiNTHAFDGA5AAsUHVLYiUS1drwUhiLaZzAYtV	8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	1549	1236	100	1	6301	jx2hB8mCmJWq8eiVYCwpcgdAxwNht43z2tGhUa2GwrDGCQvto4o	4399	6196	6196	1617054480000
8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	1668	1370	100	1	6301	jxkFrcGmaiNwZJdXKLvaA9rjUS5PwDKiVdbALM9dnEeyG6T7YZM	4400	6197	6197	1617054660000
8497	3NLavVMNLTpqig7NBuMMCZhWkfEQuR3H5RAE9pEieELbZBKUBtEp	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1402	868	100	1	6301	jxN7ChzRgJnk7ATdgPGKfw9Q35y8QzoUhdZmdiEkqRHxPg4TeRo	4401	6198	6198	1617054840000
8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	1403	824	100	1	6301	jwLwaRfBC6Lutmtp3GH2cAFgZSGvgsAwrVTLpjtMeY3WZAsJs7J	4402	6199	6199	1617055020000
8501	3NKHwUv24N1FW99gtnnemNUnsyAvLsmVHStpaJqopZUitxWwAjzW	8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	484	1319	100	1	6301	jx7syV9vweVScVcnGvwfMMceVk5N2p4aANhemtTMSCKFX9mmMQs	4403	6200	6200	1617055200000
8508	3NKnSQFCphGh3d6wUiC5RXLGYYHzTe4GJQAfdfRGz12bxYvFkKgg	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1637	816	100	1	6301	jwtZoKb3g2hRS5FUbmUmegbFGYeyYfSWK8U88qAeH2TEaMyaNYi	4407	6204	6204	1617055920000
8513	3NKhCq1Z8jmWXPKXo3gpx9QdpUpXsqCd6YA86dDK8vRwjUtDYejz	8512	3NLRU4bK6JS4n4mDxsRRRzfNi1UCUtgiA5ZnhHxXGVzUwvhrtaWw	1516	1168	100	1	6301	jxkVwi3TzzBrzpmw4SHAyKmicjADoYo4ndmpDUHQHQEsc3HueHf	4410	6207	6207	1617056460000
8519	3NLVx5Ytqm7eYUWkYuD7MJv2q8ACSPLQSfgZdwr7G6KUqsKoUn8c	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1467	1130	100	1	6301	jw6sZeZX5mNAGxkac5ttKfcfw3jM8ehoFkqe8epPXRXUL42QxJg	4413	6211	6211	1617057180000
8528	3NL1zJTUmpyCbGFXTLrdE6XveaJBBFqJPhkj2uwDwZ81KP7RPPiX	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1490	908	100	1	6301	jxnun7x7WBf7XSpQCgWAoK9ixXFxuBY1E584NikDngHXxXLCRuN	4418	6218	6218	1617058440000
8530	3NLdsP6dFDvpNNhCgvQW1cPvA9GREiQAqykjUH3Q8gZ2Z496RbhX	8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	1522	493	100	1	6301	jx4wDMHj7XXPFyGvWsiAYdTvARNhtRkaYzDUNCANJGAhonTsiQi	4419	6220	6220	1617058800000
8535	3NL2viHZBgpsR2pm5CnZ55uHMGFstQqBWxdgDc2ieYU129gNPiFi	8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	1637	816	100	1	6301	jxd5f47UcEbownW34YDP8Z7ELgTkjAf3piyM7CXaKJ7jL6KSBrb	4422	6223	6223	1617059340000
8538	3NKe5teq6aV9GbqGGo74rFDP5nUthHEfC5N8zLt8wGx4XbcbHbHk	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	1406	1393	101	1	6301	jxAEjrhiCc5YDGhTMNHauzxaN8nP7SPujMdstC14eqeMnvEnW7S	4424	6228	6228	1617060240000
8543	3NKZJHindJTZ4xs2K8oxAjB2Rw2TgDs76yf1GpjqsAw2YWFNZrsk	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1513	1379	101	1	6301	jxMinfXbquDZzNmdRdTtiGCt7eGk2iAapkiukCmUkA1djsrVgHH	4426	6231	6231	1617060780000
8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	8543	3NKZJHindJTZ4xs2K8oxAjB2Rw2TgDs76yf1GpjqsAw2YWFNZrsk	470	1309	101	1	6301	jwrnv184FXPHpHWvMLqpGPKpTJKyZScvp4LsfUqNHFjVUeuib93	4427	6232	6232	1617060960000
8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	1506	1127	101	1	6301	jwAYuoCgMns1Er66XtNKZt2hRjQjUQ6a3eCUGvJFFjdzAi45ZHr	4429	6235	6235	1617061500000
8550	3NLD344Si4NvPZ8MtBfCcjWtDCRYLFmJCywphNATZT3V8pjihuWu	8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	1673	1002	101	1	6301	jxwaZVTwUiW5XCXi9JCoEizgDgMRfUkPkXPduxgKV9Nziw6rFZR	4430	6236	6236	1617061680000
8555	3NLTNBWj5ot23MV8iCciYGxoVQN3n4u8WmncaEbX8NFKayhxj3Qy	8554	3NKF1EfUYcCYtTxgTTmqYuUJdq5Kq7SXo8krLxW4bQ47wrxTCfvY	1403	823	101	1	6301	jwfhFQi4amoRkwypALkmNg1Dn6kaVKapamKnLESULpw7pXAnSDd	4433	6239	6239	1617062220000
8560	3NLtt1QG87CPYGn9Rvg1JnEZ2x6ywqkrW4NGwZmNyrNtnuqZ8tK6	8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	1406	1393	101	1	6301	jwttAyBxeCVsucyQppCJpxpcD8y2q4UuZMT2zRRagPLjXF7ZzVN	4436	6242	6242	1617062760000
8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1656	1343	99	1	6301	jwk4sSXamtz2w7x5YgTWfRKZYA1McpAb8NNivDQu5SVE7dmLZGo	4373	6163	6163	1617048540000
8438	3NKZCWNreFsL4YyLs6RSZ5kBV4N7hbYTpTLuNfCvGCh8KqEMnnQ2	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1508	1141	99	1	6301	jx5skoKGu8s4Pw2q61ntfJy2P3syXHVz7REwAvSp4JJ7q7sqCVq	4373	6163	6163	1617048540000
8443	3NLxs1ptiHgR5emiADLrbYHyRjwajDnVSw2ovrfiz2qT4b4UJLGS	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	457	457	99	1	6301	jxS9vJ64vMUsvTrT3WzQcZjxQnjnoumZkx4qGFjYD95nXE6ypa2	4375	6165	6165	1617048900000
8446	3NL4WjiSJbm3oTqUpJVHbQPifkNQ6jNGYygmy9DgXRHKxmBfJxog	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1585	1366	99	1	6301	jxeAaoV7aXDcoXM2k2e5MdQaGz5co8BioYQVtX4mXr3FaHQ6wuE	4375	6165	6165	1617048900000
8447	3NKNu1PwTYwjhRSgaQH5KFUnNG1u1u7gGfG5dnb5RQS67C8eJTZ7	8442	3NLb4smTBHxy1qDV7BAGGa4aLMmvnYSdT1vyh2ZWNQzumHaHbSEL	149	1283	99	1	6301	jxr39QrXXL53A7cV9MXRiKzFSxuqaXywucsXvLRttmxikJVe4Ci	4376	6167	6167	1617049260000
8450	3NLHxGscXucpWZ1XBnhuPFS84R5zGokZboF1pDwrm16kCWnBsrFj	8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	1407	1395	99	1	6301	jw7TkopYV1K61BieCvpPhfjoK4xboiLqabuDLfCct49N45sdi4j	4378	6170	6170	1617049800000
8454	3NLCQvkpubH1nLvpGBS1XGNcGXRji3qkJ7ebbuHsVjRRm4WeUKVW	8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	1448	945	99	1	6301	jx66EfkpgsbebLQ89Fp5zD3Q6womJK1kCuMXfVMLVZTLcKHpdB4	4380	6172	6172	1617050160000
8465	3NLCuwg8a7ySpgdgSGASxDtuxwRWp5x3kcbp4VGJ5TP9EQsBG6Kx	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1646	1354	99	1	6301	jxP5cuzTRfeFrk6NKjSsRmoTYAQF2WwBPgGQLE65UF38La5nD7v	4386	6178	6178	1617051240000
8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	576	1109	100	1	6301	jx6k1VNx7bHthrzVdzk1gfFgcXy71Ct5YdhRxEZnmSFQjdnzPqb	4387	6182	6182	1617051960000
8471	3NKDq2pf9eYkUstQrWxfRjxcdtrAzZAbM8sDSDb4fnd4fo73t4oG	8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	1637	816	100	1	6301	jxUCbvJQPdYzyMTHztm3EAdexcV1xFXzb4AasbjLfYy6k6nsY1Y	4388	6183	6183	1617052140000
8473	3NKHczTRCmFDNGvFQbe9xw2JLj472c3JK2xP66ULquVEoyiB2PeZ	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1467	1376	100	1	6301	jwY335Y2xR4Lhu6PRS7p8oGJXeKdR7VVqe26peXNGwRsUPyxfnc	4389	6184	6184	1617052320000
8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	1634	203	100	1	6301	jxsg8iSdpLf7PxBZqmzLzUjcPAYnnctYCNYZiq33v2J3vJ8bjLB	4392	6187	6187	1617052860000
8479	3NKrhTeDNcdZvMTvqUdGm993fhdWVwMJ3rVD8my2k2DorUAUHNYa	8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	1649	1257	100	1	6301	jwUtMXDg1ZX6CbANvLN5GfSEyPapgkLcgiRgpGm87gbiBuFX3LQ	4393	6188	6188	1617053040000
8482	3NK8bnJMChJZwxz5AFdBRQoVqn4dSKMZkyB1FYzdodwNbAxQzAWS	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1579	1389	100	1	6301	jxEnRkF5qQZdbc27UUvsE2aofLRsP3xQKt2Rvd9hEgGZkQ2m83a	4394	6189	6189	1617053220000
8484	3NKiP9pCEDpXCXn34C7yiwNe4GV8ec1oJwmCiXPyg97CmBjCahoM	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1407	1395	100	1	6301	jw9USgccodKfAWNvku86eEqJEuhdmHYHzC2dLuWFgPjWxLxareS	4395	6191	6191	1617053580000
8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1541	932	100	1	6301	jxJaTV3GrJ4kbFha6nCcbD8LqqpG6YbPY3ffdybJ8swPcieKddv	4395	6191	6191	1617053580000
8500	3NKCjs1VpfxvrLBBgfU2aDSPc9cddmoYQATFjHSVSko7ESpjFZFZ	8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	1611	1341	100	1	6301	jy1mmk3iqaK2s9ykUrd78j792WGqEGZ6GmyWTPEhoYAGtS2CwJx	4402	6199	6199	1617055020000
8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	1483	910	100	1	6301	jwsK8TPuTVdQm4t6eMzt9diernLDB2Xd6piUWbfuZ23CFrE9uxW	4406	6203	6203	1617055740000
8507	3NLAthjV5wuH5uXWuSk4KK9wX5pJrfYoVw2w1eUJXSSF8nRbrK2X	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1406	1393	100	1	6301	jwCaYgF6Ef3EbXG2xyCJGhcMvrNq8HiXpRQkKwwhSbBi8a6ngVb	4407	6204	6204	1617055920000
8509	3NLA7T6RTStHipSu2RdaMvREJofW5d2wR49BYgFTk6xaF3qd7rrB	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1403	782	100	1	6301	jwY1hHrk5JSw7ydPfhZnkZdSEMDjudTFWBSMav5GQTdY75viBaC	4407	6204	6204	1617055920000
8512	3NLRU4bK6JS4n4mDxsRRRzfNi1UCUtgiA5ZnhHxXGVzUwvhrtaWw	8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	1426	998	100	1	6301	jxWSHWF2eJjgEfX7QDjdAukXUdZ69EkRgUhc3n8nYfDM6Mb1Uf1	4409	6206	6206	1617056280000
8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	8513	3NKhCq1Z8jmWXPKXo3gpx9QdpUpXsqCd6YA86dDK8vRwjUtDYejz	1671	1365	100	1	6301	jwbRXdj88BDLzc7LwPwszAzbA1j7UL4kx33KGYqXBsJ5VKCtPCE	4411	6208	6208	1617056640000
8517	3NLJAVuYGtwvWLrpfvH8GrQWbePQj51byvAJCK6gMgJpweVjn86i	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1506	1007	100	1	6301	jwNAPN1waSmAUK3fmKodQnqo3yziBPEe3JXVfyDXT2vquZ3Kf5h	4413	6211	6211	1617057180000
8520	3NKNTFoJ78LNBumSC14YdBFBnKZ7LwpvAJj5XF3kaPgMLuCMWUWD	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1407	1395	100	1	6301	jxqVyPP3jVbBcNo317cyGUvwEEMmXejoy2irNKN5cxpa1wgtzQj	4413	6211	6211	1617057180000
8521	3NLeP6so39bvC6WzRc8gGPKd6VjAscPuUJvvqqzE6XGDQD6NWXWY	8520	3NKNTFoJ78LNBumSC14YdBFBnKZ7LwpvAJj5XF3kaPgMLuCMWUWD	1513	1379	100	1	6301	jxD6X1ctqFRzuoT1Yav23qt23Fa3LBd1paLM2MD7s3Mf8MCrXTx	4414	6212	6212	1617057360000
8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	1483	35	100	1	6301	jx21UFspVhsrVqNBYC3agR1Fh64VyVYZiCxv1oMvn1N1LybaEy5	4417	6217	6217	1617058260000
8527	3NLYwLvicbNi9Se3vPQAxEMrErnMjBLTcfHtueneCxjD5by2yHum	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1407	1395	100	1	6301	jxA8ABLeXoVVPcFrhaQMsvK7mQLhRNAfuYQco6qz8iJ58XtiYgH	4418	6218	6218	1617058440000
8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	8536	3NLGe2ks2ZPMNeVahqbqzJWeQ5dnauwoMHAwP48AnZR8XPaGfhCn	1637	815	100	1	6301	jwt91BWz9iobVKWv5KPjNqc6hDKzuG5eXdU5B9z6Fgq4dv4XYWH	4423	6227	6227	1617060060000
8542	3NLYaEFhMJhMHp8kbNR3ybGjtMUqmsdSFS2mFXMQS1t1A5emcT24	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1671	1119	101	1	6301	jwFGaDPsxYUbB1uTcXoRharazdjW4vShhBSKdk15S1jAfJJWM62	4426	6231	6231	1617060780000
8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	1406	1393	101	1	6301	jwNLHekExn3tNHzxeaKoB32BK9sZN4h1Y7dSWfwufNDEYMoxmGh	4428	6234	6234	1617061320000
8552	3NLwD9zST3HCogLGaSa5dZvD785rCb8CDy7KCfDenu7a1eRuF6AY	8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	1407	1395	101	1	6301	jxUU9Rp5WaQDHUv1dEz5XBy23wDJaHkb9QTqQvVy7AB5kSjyybL	4430	6237	6237	1617061860000
8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	8555	3NLTNBWj5ot23MV8iCciYGxoVQN3n4u8WmncaEbX8NFKayhxj3Qy	632	1136	101	1	6301	jx3PP2FwuDQJcEYNaUUV1kbvD7EA3trgYeeyvfZ1Er8LuYrWWpm	4434	6240	6240	1617062400000
8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	1631	794	101	1	6301	jy2wgLDo3F26QgbiNcJJN2jocAjHA95EwRVYeWqRQY8Xzyt5UuX	4435	6241	6241	1617062580000
8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	1406	1393	101	1	6301	jwqmhpjrhfdpDuQV8oxBqf9to94hZoHA1brnyPXgM8F2pzHCfQp	4439	6247	6247	1617063660000
8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	596	1060	101	1	6301	jxdQridp7RHkNSSKKdsJYtQzRzSknoo7WZfyWij4U1wmWNsEArp	4440	6248	6248	1617063840000
8568	3NL4fd5bBmcTR5yf6Ba3zmBjUHfJdbQu1FPiE9DLN9qJvjbcLgiq	8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	596	1060	101	1	6301	jwHfochuQQuQfrVHGNEqFJpscH74gcN7rKEKk3WGWFRNjbDPdig	4441	6249	6249	1617064020000
8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	1471	1260	101	1	6301	jx3yxPeePqQw6A3kFVv8aVbeozgQanXiFuETkY7JXzjzLyGj87p	4442	6251	6251	1617064380000
8578	3NKgnd1TzwNXmCsz7XCzbEdn8MsZCYRrK7j3jAjNceg6eeAoUVWd	8577	3NL5TNq1XLNi1TYcJwc2VbRdqE4XdYySnaBKyYuu9ZfVQ7keHkvy	1440	1377	101	1	6301	jxmuRyMFctDopXUqNTu9rppM3o1MSmoBQwyFG6PApaBs8e6eCSa	4447	6258	6258	1617065640000
8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1522	1076	101	1	6301	jwT9iarSuCx5pw1tt2g1WZ3W6xAEqGqty5kKVqJ9QCKWqu2GZgK	4449	6260	6260	1617066000000
8583	3NKRUFPEfFmEzM5XxBnHix1UzS7us1KrPxDmfg6oJN86gMcQKW1G	8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	1522	1076	101	1	6301	jwzcNKqUXFNdxcqEWcYNjFKVDuYGP7RqSgbcEFGZd8mstSYDceM	4450	6261	6261	1617066180000
8585	3NLMaFFCY8H8tkhg33kW34KREmPV4ybQYmEF6vwV8c2dhEK7qsct	8583	3NKRUFPEfFmEzM5XxBnHix1UzS7us1KrPxDmfg6oJN86gMcQKW1G	1564	1092	101	1	6301	jwj2fxQam9vPGcaeppc9DoaQN1J92fLbhmXqTLop451XeA2wDrT	4451	6262	6262	1617066360000
8588	3NKNF4YRjZXYq7GYPBFhvC4ABTK78Gn3dTNEibF29A7iuHmgFFAo	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1467	1010	101	1	6301	jwDqMkkzoWL1uo8JQgKDM5vnaj3UgsW2ey6rWGNnoWd9QvbjvEc	4453	6264	6264	1617066720000
8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	8589	3NLhEH2AoKGY3wLCYo2PT11R4djtc17XUBcLMUrMs7xS8JPTB8Lr	1610	1314	101	1	6301	jx54hCFegpFRrt3vf3NsR6P8EpkN3kcsinUC9LpbQiUUsUSbWKd	4454	6266	6266	1617067080000
8597	3NLudkomY83ya8uPG51j6euxAXYSGSUv6ixzzrWEWG5vrXW13jZa	8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	1509	1320	101	1	6301	jxL7BPtwb66j9vkxAt2iBRvGW1wUeXjaPjLGDAk7RTdtihtP6r1	4457	6269	6269	1617067620000
8600	3NLBB6uTeyyCCqNwNdfrFdLRTZfAdryzpGeMgnXs5z1LkUUCGibq	8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	1643	1299	101	1	6301	jx8YJBG5bbErhqxWfmAHAepnMQN8aMbGLZjEDPfMvmETF3HHMhR	4459	6271	6271	1617067980000
8604	3NL8B7ehSyTvdU7u1zgSBsgusJ2MbfjstoEv6gMzKXudNfoqARAb	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxf9CDoqKVL6D4YyvKf8YZhsDnKaKVxEYvdndgbgVNvmaDipi3A	4461	6280	6280	1617069600000
8609	3NKqWz3CcXWzji6djY5cPku3yVvUtyZLRGZGckoRZ9fPm1NXQsyW	8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	58	1281	102	1	6301	jwAUV7DsYLzMXBJvSnmMzqCjcM8GQBZUmXsYD7xTFEwqoAhdkxX	4463	6285	6285	1617070500000
8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	8609	3NKqWz3CcXWzji6djY5cPku3yVvUtyZLRGZGckoRZ9fPm1NXQsyW	1407	1395	102	1	6301	jwB8S2zgetwdhMaPQwhLAZpgwJNizWoGpkFqKAitpYHCCMFdoki	4464	6286	6286	1617070680000
8615	3NKYrhLqVHVww2cHJohc1baBCEiD4aNeHhGb5quUJb3azNto5edr	8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	1407	1395	102	1	6301	jx8WMg3yQuAwLKmk6W4jHxxx1FuRU2oabRZXVT8VCjTqNfRWm8m	4466	6289	6289	1617071220000
8617	3NKcH7fby9nJpKeC9RandY2RvnXU6XCc61fTQyhfcgyE5uePHE2X	8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	1542	1304	102	1	6301	jxCfCK3wHZY5E5js2KAxkzKDU385JPE8CWzbYLcoQTW9t8jyUMV	4467	6290	6290	1617071400000
8622	3NKEiZak8XdKim7iGyVWxSngbdmmG3XKqL7oiXkn8Jk9WarvfNys	8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	1471	1386	102	1	6301	jxr3b1JU5axnv2AVAxFKNDAH125qh1EG9YHpzPKMZUPFywbKj63	4470	6293	6293	1617071940000
8624	3NKEFnoz7egBEUjFECCXygxC6CJNdrN12KrN822Bre7KAnhVBUsK	8622	3NKEiZak8XdKim7iGyVWxSngbdmmG3XKqL7oiXkn8Jk9WarvfNys	349	349	102	1	6301	jw95vdySqMpkGnCAH1S2m5tS9p92GQqSxFptnu3S5By6xDNrhKX	4471	6294	6294	1617072120000
8629	3NKW75ukk7W3SRpKNDWVFb28YDa4sQo7P511t6y98zLco2BqcWA4	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	641	1210	102	1	6301	jxYDpTMYtyvMWPTfzk5qt3hQSSWu5C8UUVEs4ikRxRXGUYprdqn	4472	6296	6296	1617072480000
8631	3NLd5i8xSwuY9DSyRAf9e7YX6D4H51g9qpU8CwSEnfsgN1ZbKqms	8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	1609	1333	102	1	6301	jxCouRCaZk6ZSeywfyrC6m7vaBNsTTbeZuQQAW6bLfcJLNbjqYA	4473	6298	6298	1617072840000
8633	3NKUMAhKJ2bPUDGgNG53bRVYxcEHqy3qbcTxn99bXAVfC3Wi2iRk	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1646	1354	102	1	6301	jx3Wj58wiFX3r5UDuu2XNJXWL9fzxUfTmxEgJ25cgFSuFhm5Aiu	4474	6299	6299	1617073020000
8643	3NKPNFWc1C6sgQKca7jwUsMc4r3heC3G51QuAhTWbUbob95HB2Uq	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1402	808	102	1	6301	jxeVzMsevu3LNPcdn1rrTUyZNJP4XY14yxJQBqQMR8RWJYs4cFD	4477	6302	6302	1617073560000
8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	8640	3NK7tJqSsA7QAgYepy7BLuwpB7rPtEnS4UfB5VyBSict9heGj92C	1406	1393	102	1	6301	jwsJ5foNZXUsJjQZAfa1uWyvFGNWzdcAjmHBqhgR7W17R7J3vuo	4478	6304	6304	1617073920000
8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	8648	3NKkXqWuNGV83B93e1vPDQUXkBVJYfUYGvjrRQnSAuFsgXr7dFk9	1403	824	102	1	6301	jwZ1MdMHvaMEpGdoVT6oqGqSEJCQBY3pFaRuBQDhH39TwSQjtui	4481	6316	6316	1617076080000
8652	3NKmQYtzjDjnb4NAeQFZR1MpgY4XndqqDU5P3mSZ4DpUXpub4Kvr	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1508	1261	102	1	6301	jwtZW46occmFMRuVEswpJVdRQYpE4GC7qa3MTGWreXF3vjPXHKY	4482	6317	6317	1617076260000
8656	3NLsZvQP4rYmgs7Z7Zh5gb7TseX12QK5nuruexKa4UEnRn9TjSGm	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1405	867	102	1	6301	jx2pnBTjjDbkKDpM42GXRXH8kbvbuyuCkpDzsg1vN64PXjJu5Jr	4484	6319	6319	1617076620000
8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	8667	3NKWGMe85ZQmhmrD1b5TPu4TBcDAFVEWZXsaqdojQ84s8ScgeVEz	1527	1167	102	1	6301	jwgziigjgDBS4mLTsk28ziGfPVG1WoxDWmJyqKU6qt9sg7ZH2L6	4489	6328	6328	1617078240000
8673	3NLSz1JrWdT6gKNBP6nFHHBeGUkRkaBgfzWSx6eaL9cKiadqhAki	8672	3NKK2ARxT93gUw9rsoZf35hu6nA1vf1uAVL8Rk1oHg5nDgMhffeY	1460	190	102	1	6301	jwG38WHzTbYhSX9vQurt4KTvWXkdvEdW2gghkdw5dhJXtL2BDg5	4493	6332	6332	1617078960000
8676	3NKZLhhtfXfj7btnEt88MkDZnRywA6rLX5CiPbixob3F8MKLWLhZ	8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	1611	1095	102	1	6301	jw7dWHZcCRHVVzyVBc3iJbzFFMTBCATuLTnVFHVG8BgzBoD7UPM	4495	6334	6334	1617079320000
8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	8677	3NL6JwhxFwGoH8SjTAXHQWzE2NkeTGawsVTGyuLQdTxQoxFPZbuU	1573	1318	103	1	6301	jxSzZvhnGRpcSHWGwjrPZeqC1Hrce4pYD7Lf1nq6PEkarRzqVhG	4497	6336	6336	1617079680000
8561	3NKKUnt9WDBPWRuKjBGx1PtbcQLvRkmsJwfF5iySYqpsaJ311ckR	8560	3NLtt1QG87CPYGn9Rvg1JnEZ2x6ywqkrW4NGwZmNyrNtnuqZ8tK6	1407	1395	101	1	6301	jxS7MXQavVwYD3egJa8Hn3ZyaKDmEnRoQTZxUVFrfGTP7BXAyRb	4437	6243	6243	1617062940000
8576	3NLmBQBYfg84VKAc3jCJkxkGz8Z1GTbjSB6eoqzg2VK1EqRZoNuA	8574	3NLr9yur4fPZC3XBNhpW4sM3teFWB39urV1nPXRP9QCLckYjXcRY	1406	1393	101	1	6301	jxgsxLzPzMe3HCbEgQ4f8R853QoU8dUSeM2iYgNZ78oLkmXi6px	4445	6256	6256	1617065280000
8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	8578	3NKgnd1TzwNXmCsz7XCzbEdn8MsZCYRrK7j3jAjNceg6eeAoUVWd	1406	1393	101	1	6301	jxHochgerCbgqf5v6LZjMNTzJfY9kzcJpF5aBh4v4qHwdMdv6yc	4448	6259	6259	1617065820000
8582	3NLnXQSJLKbX6BFFDL8ByddCmUnCdTczaASv16Ym6Bb2btoQtm8E	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1500	1171	101	1	6301	jx6PYnErLLobSoEALirPY6M2BYEFUMWj2bxacNMuFDKA1UvbT9o	4449	6260	6260	1617066000000
8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	8585	3NLMaFFCY8H8tkhg33kW34KREmPV4ybQYmEF6vwV8c2dhEK7qsct	1564	1092	101	1	6301	jxTnmsAm5WSPEa8T6S1a2KsawkXwb6Pi4FcG7p7ZgmjJoskmjmD	4452	6263	6263	1617066540000
8591	3NKbnfCnkYnZxiADE9y6fqwfVBJ1TjPGXX8ZanhUdVuhAuZMVHyo	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1406	1393	101	1	6301	jwdrq2mk21NUa7BxmZLr3HuCCjsmsL55pLEfjYetVFFazd65oQ9	4455	6267	6267	1617067260000
8593	3NLDDEMmzTKjwdSA8pLMTrZNAPeD5FainCQFYGM31X3QBc8kCrQH	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1623	839	101	1	6301	jwQzq3Ss9DwfzbCoF9YYGw44FGysx5NRFCzNL7mE9VQhqU5ejBR	4455	6267	6267	1617067260000
8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	8591	3NKbnfCnkYnZxiADE9y6fqwfVBJ1TjPGXX8ZanhUdVuhAuZMVHyo	1643	933	101	1	6301	jy1WgnVNtZL4SWsGrYSLbFonWUMSNuPJhaALxKnVkwUc3nFNgK8	4456	6268	6268	1617067440000
8602	3NK9z7CLdi7ptPfHXJaPxUGjxyduUcNkKuTMZ4EREokNtXGV2oZr	8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	1623	830	101	1	6301	jwLYqyeGhQs22BrYxKeRu1qiQDNoSKcTsTVhN4x7P7yogpvRjue	4460	6272	6272	1617068160000
8605	3NL1ey58vtZaBcdmzALAjugLYa6yZU9wBf9Gpf278zXSvb6wHg6z	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxf9CDoqKVL6D4YyvKf8YZhsDnKaKVxEYvdndgbgVNvmaDipi3A	4461	6280	6280	1617069600000
8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	8604	3NL8B7ehSyTvdU7u1zgSBsgusJ2MbfjstoEv6gMzKXudNfoqARAb	1406	1393	102	1	6301	jxxf7izg3qAqr16KbwRS4655AiB8J1pgyL3wEeuu1pHYJJZJnUh	4462	6284	6284	1617070320000
8612	3NLqLee6ktXJwvQVru3HWDKBBCrTsQs7KLPd5c9FpNHKt3bcd6Cy	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1406	1393	102	1	6301	jxn5cZem3jNTf3zBeTpZ5GRXnGkjrqoKBZdqr3gDDwxnq2xGy8V	4465	6288	6288	1617071040000
8614	3NKtQ5egZt7e8yaoPZBprstXnUcH8yutJ14yjZMBAqJRSc48sYtG	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1403	824	102	1	6301	jxV8Rf2QyCCNAJhu1UkTL5aZVLsN3qTkZbfYFG85qiy9uUhA78U	4465	6288	6288	1617071040000
8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	8618	3NLvXn3WqK6cyoJJVVra17UcJtHeQb8djEZSyJBBhzLTWpXXtbrL	1672	1039	102	1	6301	jxjVz6Dgygj9EswxYrJCwfN7xbDTHHoufkbxxJKtHBmA5HW6LXH	4468	6291	6291	1617071580000
8626	3NLikgKjgdb6yCWQVFDDuz4pe4JTQBnGfV7U6Zpvn1S4JpFnbcNg	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	349	349	98	1	6301	jxtgaRw453FzgFbD3mRBFLGAxtTFWZFiTnSNRZT22wd99mXbEC6	4336	6294	6294	1617072120000
8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	1634	1331	102	1	6301	jx2QcbaPkv2NEjV7LZBW9DcJpaomqVzZHQGHbpWaMe7mFijMtBh	4472	6296	6296	1617072480000
8637	3NL9vMaVk57ZUk53go4iPc2LTpXEdvuvXkyUoHyF75vovg5pEjKi	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1534	1191	102	1	6301	jwwfe8Qr15Y7B5xidkSbyLuHvgvmkcFia7ZtzmPH1DvqzYcEbdU	4476	6301	6301	1617073380000
8642	3NLC699cf41ae9DfCHMZChoJJrYjMKoPgY8ssgR592cjsSxzLspZ	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1426	998	102	1	6301	jwhhCXe37J7kwXYUJsXoBYRfwN58FmnkZ2C9ER93ciFRMcvBDp3	4477	6302	6302	1617073560000
8645	3NL5SLwXqG9H25v4taD58hs8j52F57XqFtGM2VNWSmJmYi51Pxug	8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	1642	1121	102	1	6301	jxx8PQMBzDgzRshCtKTq2bAJg3WTDfqk8g8pjKEKrc7bTJvPRSA	4479	6310	6310	1617075000000
8648	3NKkXqWuNGV83B93e1vPDQUXkBVJYfUYGvjrRQnSAuFsgXr7dFk9	8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	1600	1372	102	1	6301	jxGfayUPGq4zMDJ4MNGkqaGUhbj9GyYvwacAaQUWBhsU1mDye2T	4480	6312	6312	1617075360000
8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	1406	1393	102	1	6301	jwE5GRq8EH4bsgzXVEqnnA6RGyJUAACC1n8tFxWvvnQ3rkBN15G	4483	6318	6318	1617076440000
8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	43	1064	102	1	6301	jws8sB5cXTXcGkdv4JH2DrVAPCkPGMYRL8hKmMhHLYCWDQ57Q5K	4484	6319	6319	1617076620000
8660	3NK9mPJ1Eh7R9wvHpQZbu8XwoPG8DjcVmnhq54SfnWz8zk63KDjQ	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	606	1295	102	1	6301	jwCfhfJLfpD7UGNDqi1Fz9zfZRC3iqDRHY572XpyAjT837BPA7c	4484	6319	6319	1617076620000
8662	3NKiiZ5WMKnd9cfdzymKnAT6YsYvgJyLkLYgoePBsAnYAiPHpKVN	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jxmq8gZ8Dqivnya5VyFzhqW19JXmYfU54PxYbxKk6YCZZtnN4Z1	4485	6320	6320	1617076800000
8667	3NKWGMe85ZQmhmrD1b5TPu4TBcDAFVEWZXsaqdojQ84s8ScgeVEz	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	369	946	102	1	6301	jwaSDHi3tVPzvshQSYVWewYTAQozNyaA39QtuqeJhvtGnHDZw7E	4488	6326	6326	1617077880000
8675	3NLCBdJqn8URMtdP3j5YfjVwX6n3MPs1RfYNeKH9y8tNbWNrmagp	8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	1402	866	102	1	6301	jxxsFD23cxX9wt9nEqRhDdEPiKnafDaNRxmGgiYJDWpqrhTs8uQ	4495	6334	6334	1617079320000
8682	3NLjfbFWk3AtNnfCrsVab6XDLQ2kpGdRAcFGifYsWqazG1w36R4v	8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	298	1182	101	1	6301	jw7cNRiTvCqqkRLPrz9KUV1uQFc7RDRzujvSNLsv3qtRaMmydw5	4450	6338	6338	1617080040000
8685	3NKngkJqGAngYLeWXAMbCaDdNB8HSXGqhphiNxmYwobRDh98wU14	8610	3NKEkGjh7NYRs2kzc8pNzRyRP6BHRBNnRnk8W8kMxU4VNjgPshPo	58	1155	98	1	6301	jwyeQ3QhZ6iGnVoNPepiFm3UGMie8Pe99BNrZaC97fhmFZafH14	4333	6340	6340	1617080400000
8692	3NK3SjHgr4QK9RGqD185vaqpnN31zSrbVqNjtQtgWuiWHuAmte2z	8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	1460	1324	103	1	6301	jy1LZVro8jJ1HLe5AM4Lsuo8z1bFNfdL2pLrgWZviSRNYePyaPq	4506	6346	6346	1617081480000
8699	3NLTG4bbAXXiaPj71NsCgzcDcqVKdo3XyyR9dffrLPekTt2JfwnM	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1624	1334	103	1	6301	jwVbYnH1rTz64KxfCLqynGCx8orFUaAGMgnF77tzTkJUZqf1apL	4510	6350	6350	1617082200000
8702	3NKqXdq5EuNCKR4yNwNrcv2AA9bLKkCBACpCRaPyq4BxYhFNpz33	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1422	1211	103	1	6301	jxsFhCEuDoP4gUaHDXsXo2RtcfE8MHHQq7H9Z8etGdotXGgb9J7	4511	6354	6354	1617082920000
8705	3NLQBzV1XSwTehAYRWcdt1wa2vyfJ1kL5LsWL9BsRTqMBVPFbqyX	8704	3NKN2qYCfLWfytPBggU6gW1DpgdPQb82ojt4pAJjpBDijGsd3K25	1560	1165	103	1	6301	jxvA5ugYoEDPCi4mCzmXHCosueJhgU58b1wU1kfoGRHQAYDsJw5	4513	6357	6357	1617083460000
8563	3NKe8DApVMc7ot5yqGctBzx8zPUfAnE9KxiHDHWox6uKkUe19aq7	8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	1426	1118	101	1	6301	jwDgigW9k53hZBWBNDmAEUUG9M2GHV9XqoNATXKqvoEPutwxPAs	4439	6247	6247	1617063660000
8565	3NL2WisGF2RcQ3f9YxmBB6NKJGWZe1P8Q6VTybSxEamx9AkUjRfe	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	1407	1395	101	1	6301	jxVurAEpotait2xzh6yL97DdLWubREZrKPVeyk3UmYR65vvfhG1	4440	6248	6248	1617063840000
8570	3NLwKArL2vP2qQKLXqyHmqwfhMowRERzC3AeG4xeEjRUssfA6PQB	8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	1407	1395	101	1	6301	jwb9gMf4MbMUQvxkJYECoQJYf1zELR8b7MVCqXQuAidsNdBH2zg	4442	6251	6251	1617064380000
8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	1607	1222	101	1	6301	jwTTVeeUx4nHeWkAkvuUWoUwaVkvEcjNp5DPAcUSjCZUVAxsGnH	4443	6253	6253	1617064740000
8575	3NKN5tAhACjZV3CF3K3XMQStPBPdHWB5HLExZadV9rPV2GPKcsWz	8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	448	939	101	1	6301	jwc9XEWianTr4tvy9JKjnxQ5pKCu4VSub7WWqNWD356pkb86tNH	4444	6254	6254	1617064920000
8580	3NL1kK9rvKgqBC2wmugTKexXQNXHQFHity3VmBSvy3CxNoAxW4Ae	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1579	1143	101	1	6301	jxfJjh1UKBaGPUc6vCQKBEHRPCNS5WdVpbqFxFvmuW5nemVp69Z	4449	6260	6260	1617066000000
8587	3NLVmGoHxVsdNBxykHqr3SLNxke4cxpDexaUxo8aZpksyBCS4T2A	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1426	1118	101	1	6301	jwNk9CNfAV7kv6QSmgidAA9W153GJhw5qirdCTgVt4AezU4eWAG	4453	6264	6264	1617066720000
8589	3NLhEH2AoKGY3wLCYo2PT11R4djtc17XUBcLMUrMs7xS8JPTB8Lr	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1481	790	101	1	6301	jw7agkmMLdBsFHK6QXoBJ4cTziP2fLFiMtkDwy9knewvQrPq9Pb	4453	6264	6264	1617066720000
8592	3NKjP7nZ5GE3fUpBUNZykHzechcGgB6UdSqGDaTE39NPexYFWR5j	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1403	824	101	1	6301	jxCCmzXDdrxQYqbLwpQW3Dj5ndBYEE1CppQkKMpTfdjAgx1g7Ag	4455	6267	6267	1617067260000
8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	1648	1158	101	1	6301	jx3KZmgQJgiQrRgzL1eru9gSgVetXTeEGEcKtSjq3FBUQQ6xFeu	4459	6271	6271	1617067980000
8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	1646	1108	101	1	6301	jwDuQX4C8CyUzU1qZhCq5Fa1ASH4dimgthkoRbUjY1pnLHFtdfF	4460	6272	6272	1617068160000
8603	3NKU5qUc4zBxXqTDkCxU14HWeSbB2Z1kLAqvbfJWisvjkqpCzvbr	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxU3jX2EYvnm3h5NVtTBLRVpgprmBEWuu1pP4k5kCnFsNWHwYMB	4461	6280	6280	1617069600000
8606	3NKJjVdW2dyygB7zczk3yypkbJq7fSoQYtbYYHFiWfnVNDEG3QA2	8584	3NK4TqYbw4Kiy1QAxDN51JehHDKxcFT58e2KrZZdmJP1MDrjorPX	1627	1385	100	1	6301	jxvxxNMB2a4ZxYa9NMLyVXMW2ptAiWuRcy7eCB64JHWzUmGyzJH	4368	6283	6283	1617070140000
8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	1631	794	102	1	6301	jwZzHC3mK9zgT74fxVXv4zHcA6sshAMTrHVUd2azLRLxWq7M4de	4469	6292	6292	1617071760000
8623	3NLSwf9VUGxW31X3PiJHVpA4fyBUGi7TP1BtGJ5U9qYh5DruzrVw	8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	1471	1386	102	1	6301	jwUd5CkdunX3wkAqXqUyUz5HPgvx5fJup4QCGFzyTwb6DmQWo4q	4470	6293	6293	1617071940000
8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	1483	92	102	1	6301	jxue1V47AoUfogysFDGvPTZJqTRJt9HnxJWtG93enBdzsHLpr49	4473	6298	6298	1617072840000
8635	3NLwBN4rzMiJR9BJKeNL5sYauH6jko4N4TscNrhcp3Ygs2J3Mm3N	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1419	814	102	1	6301	jxRLQHNfwUDm4Dp5ZeDKbgHMxYz4yFqchxz8uvzHj9J5XqAtD7P	4474	6299	6299	1617073020000
8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	8634	3NLcTYfE4A8w3DqzFHkGRxpLpcpNaBYjKhqerqwniGp6munMKNos	1407	1395	102	1	6301	jxUqUGDiY2JSdLsZbt5eQYKeKdXZ7QcqYNHDX72AiFvsjXCS1zH	4475	6300	6300	1617073200000
8639	3NLNKAXLyudvDFnjkq9qkLzeb6jaBeDBeiTQy3daK2fgPPdzJbuL	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1623	839	102	1	6301	jxQSKp3zAN9vT8Bi4F5Er5jEb8EmKm4u8PGWhKYSFyn77q3i21L	4476	6301	6301	1617073380000
8641	3NKyjDt9xzuzpTex9QUW2aGEjfU584EoRXoKybYfWQDsgG3r7tfs	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	311	1181	102	1	6301	jxgFzQfdnDwUuQtXwN4W5se6ugC4AuGvjLzJwn3h5v15tTXcUct	4477	6302	6302	1617073560000
8647	3NKZuv1TCqWV5DoEsYbkWcsx2mdffpZLN4SmkoRgWaRrimBuZz1Q	8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	1457	1145	102	1	6301	jxjjb3sfKzbrnHfs5dFKfMVzw7NS6ynXdEEc8pmzVssdxXkMrdq	4480	6312	6312	1617075360000
8651	3NKy8Ai6ypoq61aU1N4XgVBVD3gTWu8ox6hEM9sXXBhmWbu1Pfxs	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1406	1393	102	1	6301	jxkQvBbEgTLXutAhz4xLYdcw4YueAUoDYcZH18GU665DBMo1SRo	4482	6317	6317	1617076260000
8655	3NLf8VCBLwaLo1VJyzBqikQ6vBrzNZbH5wEpqZeUSCpwWkFVWM2f	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1402	888	102	1	6301	jwdjqjxPWNJXgWPfhUCyZCu2kMqPmCat8jj4N2qLhfrDuvBkXWu	4484	6319	6319	1617076620000
8658	3NLKRogzoQHNnRV5JVXmvmCZ966Ji5ycTpiB4J9mw3d9nH4PeqRT	8460	3NLojLcNpymZQAHTb1dqUFd2o2L4jBaxf99eX54PeJqyFZd7E5ic	43	1064	98	1	6301	jwYpYicNyoKBhD9LHoVhHDJNRc3zQGk9GwshxEaJnbEHdjynx6s	4338	6319	6319	1617076620000
8661	3NLsxQzHqGoGfw3Gbq2b9z1A9YdDdtnb1enbF9LMnvSXBgTALXta	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jx5eVAvnnk9W495yQ5Bk1ey2ojc3Xycpu82Z53YmPLs5SWFqAu2	4485	6320	6320	1617076800000
8664	3NKikhVffnkV6uBhRykViKeETmCvQc7KwqAQaQHACmGngtse4b5h	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jwLKJZkVZCLyDwgXWSTp4qfNtmpw5ExA33wzFPyqQTXBYxbTwkU	4485	6320	6320	1617076800000
8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	8665	3NLFfsxwGjTYqkjaWHEJonwzArcq9E4fLpGfwsaP9KDQoMvyzNCW	1610	1314	102	1	6301	jwrFEfRsxW56BtWGn8c1WoUnVB2VywryCcNTHKdAw8H9w6BTi9V	4487	6323	6323	1617077340000
8670	3NLdRr37ztbYiDtsMHKkXtDYxY2UrRiubcx2Cce4kjRTtuuj4XZb	8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	1422	1337	102	1	6301	jxizDw1px1asKPcw3ckboZYUvZ68M6V4yjBQ5dHyoGb55ZncAXK	4490	6329	6329	1617078420000
8672	3NKK2ARxT93gUw9rsoZf35hu6nA1vf1uAVL8Rk1oHg5nDgMhffeY	8671	3NLZ6KP1csWxYDPvrjrAtg75Pes6m9xtgU62H98PwJrURvBUTBHt	1483	383	102	1	6301	jwAi8sYPMB1FgBvCPQES6kGRgwoy9KeD3yJsJxAriSKJEwMFTHZ	4492	6331	6331	1617078780000
8677	3NL6JwhxFwGoH8SjTAXHQWzE2NkeTGawsVTGyuLQdTxQoxFPZbuU	8676	3NKZLhhtfXfj7btnEt88MkDZnRywA6rLX5CiPbixob3F8MKLWLhZ	470	943	102	1	6301	jxnsEsr1u8KK4ecmfhiBAd5QVyFs1ztCxYsNoaWZNyw1czdVssS	4496	6335	6335	1617079500000
8680	3NKhKScerycvY1SZnwuTCPkrPH4f6k9ykaPTYw8Uk7RR8NATYA4v	8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	1578	1296	103	1	6301	jxjVFV5eb6fM3dV7VcUKjTUePQvY65s59XffmDUs2vhp1yexe4y	4498	6337	6337	1617079860000
8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	58	1155	103	1	6301	jxp84QpAhFLh2YCm3Hya6cbdNXWv5y3gQK1xKTFGjvtjQwvWdXJ	4501	6340	6340	1617080400000
8567	3NKJ3EVDWRJWV3VQQCFD4tdV63GSTXmySSDhBLqEcyjtBLkNoXWE	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	1631	794	101	1	6301	jx9yFRoqi222sMRyphhZ1hZs325Ya3odPHZNSYC5YwzLK9NyJRV	4440	6248	6248	1617063840000
8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	532	1177	101	1	6301	jxPque7S5Du1F6adSAV2JWDviCibdkpBtKTNewwZEfwT3JbMbaE	4441	6249	6249	1617064020000
8572	3NL5AboN7cHRJEHjzmwiXsVy9A4emB836WknLLbUsu4Estiemyoz	8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	1406	1393	101	1	6301	jxvXE954wutLENeG1yBqJmHca5AkDheLuHPjdNtsHS2xzAChUPE	4443	6253	6253	1617064740000
8574	3NLr9yur4fPZC3XBNhpW4sM3teFWB39urV1nPXRP9QCLckYjXcRY	8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	1607	1348	101	1	6301	jxvoQiNMtneXRzNWizYsX4tuxNNbDu6Zc2oeypy1pM8QMqnhi3e	4444	6254	6254	1617064920000
8577	3NL5TNq1XLNi1TYcJwc2VbRdqE4XdYySnaBKyYuu9ZfVQ7keHkvy	8576	3NLmBQBYfg84VKAc3jCJkxkGz8Z1GTbjSB6eoqzg2VK1EqRZoNuA	684	1352	101	1	6301	jy2Ewyqsx5FSzT91RnCgQ4eCSesEe542KMgrkrzoJiTUdjpF6Eh	4446	6257	6257	1617065460000
8584	3NK4TqYbw4Kiy1QAxDN51JehHDKxcFT58e2KrZZdmJP1MDrjorPX	8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	1627	1385	99	1	6301	jx12MV2wx1Xem1wCRjRKcwoGPWeHsnW5TDDiuqd24JaoKatshw7	4367	6261	6261	1617066180000
8594	3NLaZsFZh6vPsUiCpbZ8RHs7umGNUxaRSFqWhMMY6kzxTow7GnZi	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1577	1201	101	1	6301	jxcRyYmXzTXVgLg23DmaQ6ncLCeGGmByhdNytdqAxTskTkCBvqb	4455	6267	6267	1617067260000
8596	3NLUCkRAGaZ9qcs1BNeBuxe3xt4s4k9prCXVcU62afUJ8n5W2QMP	8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	1406	1393	101	1	6301	jxJuSBxPHxEDFWGr948MQdmFLkv4KNU2D5TzkVpGF1mfL31756j	4457	6269	6269	1617067620000
8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	8597	3NLudkomY83ya8uPG51j6euxAXYSGSUv6ixzzrWEWG5vrXW13jZa	1527	1293	101	1	6301	jwRUYu4jKDGzv5EKbjE6er1rPdqNTiDNyWdSmYLFJNrZgC7BfXr	4458	6270	6270	1617067800000
8608	3NLG59uWCGXrZJSamkyRGBX3EMqsigDWcwgnWapsa873Gzfkmao6	8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	1407	1395	102	1	6301	jwt5S6KBpK2cYbx6DSV2eFWvHDUQvRXZBMpNX8CAgantzSBsJC5	4463	6285	6285	1617070500000
8610	3NKEkGjh7NYRs2kzc8pNzRyRP6BHRBNnRnk8W8kMxU4VNjgPshPo	8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	58	1281	98	1	6301	jwyeQ3QhZ6iGnVoNPepiFm3UGMie8Pe99BNrZaC97fhmFZafH14	4332	6285	6285	1617070500000
8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1513	1379	102	1	6301	jxycVxLbjRkpEqH17hRE55ZMdUSs5RSMEXqQSMQHMCwBBkYzaPY	4465	6288	6288	1617071040000
8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	1402	868	102	1	6301	jwSnacfjxVf8XaGZhD5AhL2RePT8jUjSga1pGXnFfdFmNkRccp4	4466	6289	6289	1617071220000
8618	3NLvXn3WqK6cyoJJVVra17UcJtHeQb8djEZSyJBBhzLTWpXXtbrL	8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	1484	645	102	1	6301	jxLx2N3y1WpLXzyxkLgpZCut7FUrojiz1WEqLrFxWnirbMuHBfa	4467	6290	6290	1617071400000
8620	3NKc1c4ZFEXnrT81D61S4G4GAU3ipfNgrwuNv7KnVB19bdQv5z4u	8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	641	1210	102	1	6301	jxF5pdVMFEuttWKbaanASTsodR2Ww9sTadMHFKiJcSSyWiVBHrP	4469	6292	6292	1617071760000
8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	8623	3NLSwf9VUGxW31X3PiJHVpA4fyBUGi7TP1BtGJ5U9qYh5DruzrVw	349	349	102	1	6301	jxwneVDx96L7Kga7ksrWuCCRoTDoYdzTkehUsM8xcpvQaDBoDrN	4471	6294	6294	1617072120000
8627	3NLhKEg6GirxBcTYm8pegByPUKDXSRYKS2TyrB5bqYUfD6iBDHgS	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	1593	1346	102	1	6301	jxRsqZHGgG4FFjfkPpq5vY13iEKLQhG4ocdmhVWTY6hcKKbq4ro	4472	6296	6296	1617072480000
8632	3NLvYvyVLwh4eQMP6Vd9ieX1MHwx2DNPwqXRg3rumLNovvBZSuJP	8401	3NKE5LvoGPpP6n6cBhrRNqskEKEEq8darVAXWUgfR933119xTkMy	1609	1333	99	1	6301	jwJoTyCnLNyoiEhTPVMaZE8wkpPf5aaAjf8W9CbQhQeUUkfJyFm	4355	6298	6298	1617072840000
8634	3NLcTYfE4A8w3DqzFHkGRxpLpcpNaBYjKhqerqwniGp6munMKNos	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1522	1196	102	1	6301	jw8nHRn2aULsTQRwVmm6f9nupuTMo8MuvxCRtkERD66jNyVdsCr	4474	6299	6299	1617073020000
8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1403	824	102	1	6301	jwtTN3Nkv6MbsEfX9iYdp6BxECJzibLBWc7CfE5yJ66LUHBCHpv	4476	6301	6301	1617073380000
8640	3NK7tJqSsA7QAgYepy7BLuwpB7rPtEnS4UfB5VyBSict9heGj92C	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1397	828	102	1	6301	jxerxQxfqU4iqgqvqbQAPHcjbrfr7EG5sXbczAexadWK5wjP7so	4477	6302	6302	1617073560000
8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	1642	1121	102	1	6301	jxbDwTL7b33b5YZ4u8miFGB5bQfgwL3FcHmP47uezv6nS21WDgn	4479	6310	6310	1617075000000
8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1527	1293	102	1	6301	jwyKHpDiZWZu6c63jSHTEvE5uTQxXQ188FbG8Zs6QQju2tBPoi2	4482	6317	6317	1617076260000
8654	3NLe5dhAC4AapL1AzvXsetXKRaUsS29WGNL9oYSZhe9KrvagJQES	8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	1481	790	102	1	6301	jwiPFyGs2moZnS8HsCTFirEaVDLNYwViNmiYDGw5JKLtsT2dgmR	4483	6318	6318	1617076440000
8657	3NLr95ETtRoLPMcxWJSSFW1ao83RCRjU4HrrDwo56qtqduwdLEEp	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1633	1024	102	1	6301	jwLcRGzpyFyvr3VsDkvyyFFoa6iysdcne9xM5Bgpneb3XP5VsMb	4484	6319	6319	1617076620000
8663	3NLhFQ6E5DTyKuTTWipw3QrW9xDjHtFpb9PTUsrjQkMbFYmsVMNU	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	42	1115	102	1	6301	jwi5d9cSeYJXThGNq5spUePW3jKLghKsDN5t6C1taMukX4FPdQV	4485	6320	6320	1617076800000
8665	3NLFfsxwGjTYqkjaWHEJonwzArcq9E4fLpGfwsaP9KDQoMvyzNCW	8663	3NLhFQ6E5DTyKuTTWipw3QrW9xDjHtFpb9PTUsrjQkMbFYmsVMNU	1477	1104	102	1	6301	jwU5vHngGUQN1eVzZUneSSgPog5ahhyAGyMgbgmZLnKoNadxK4b	4486	6322	6322	1617077160000
8669	3NLWtXVUaREsDCjntpafUtCq9MejNaFVs97GktpRV1S8s3qHeMfd	8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	1422	1337	102	1	6301	jw8PaqJeyadqYRssR7P9TtcWV7hNwYN3JxBajc6hJZauAepkH7z	4490	6329	6329	1617078420000
8671	3NLZ6KP1csWxYDPvrjrAtg75Pes6m9xtgU62H98PwJrURvBUTBHt	8669	3NLWtXVUaREsDCjntpafUtCq9MejNaFVs97GktpRV1S8s3qHeMfd	1506	1373	102	1	6301	jwi6vwVuofaviZQJ5TG9CPEtaGXfatm1yJ5soWpihpwY4DkUeLS	4491	6330	6330	1617078600000
8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	8673	3NLSz1JrWdT6gKNBP6nFHHBeGUkRkaBgfzWSx6eaL9cKiadqhAki	1549	1362	102	1	6301	jwmyaUEAxomq6ZWzFRctP1ouBdhGLLQMqvD1iYJLEdp1YQx4g94	4494	6333	6333	1617079140000
8679	3NLbAGXcLQYpxzd37tfgLM46rP9LRFWLeN3ryfZ6s2JAUSsW2ZkZ	8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	1522	1196	103	1	6301	jwSBxr6rygN957JV6bDhsArf2j6BYDYLi1f3s1qCwbmcJKggSkg	4498	6337	6337	1617079860000
8681	3NLjp7jizUKepY1WiWT4faRpvni5MoT6pV58NJqAGyDNPXESh1sL	8679	3NLbAGXcLQYpxzd37tfgLM46rP9LRFWLeN3ryfZ6s2JAUSsW2ZkZ	298	1182	103	1	6301	jxGRavW7Yhx1MDDn4FCmhqneb8bzZgPnsYYq7jsmigapKpmQfNF	4499	6338	6338	1617080040000
8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	8681	3NLjp7jizUKepY1WiWT4faRpvni5MoT6pV58NJqAGyDNPXESh1sL	1657	1344	103	1	6301	jxPqgS7Wa7VkfAgyyoyUHdRPWrkxHPwoCCb1VwZXDZQMR41x9JJ	4500	6339	6339	1617080220000
8690	3NLbJY1iGuYqgZUNfLr8hpZ6LQPF2MEZzt8gqKo1FpnxN5NedgWu	8689	3NLH3a42wWyPEKGJVURviVwm1jS7yC3HZuat6pQYAXGtorYYEv9V	1402	868	103	1	6301	jxqMyghfP6hCExtgCgZZGwfvY5jYg718v3K2qok5c3ZUrwA5NkT	4504	6343	6343	1617080940000
8695	3NKbi6svExfnSRgdor424GcheGeaFqpwW98tagdkiaAUj82VPn7L	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	596	1180	103	1	6301	jwh9hQ81RV9uEwxhGwfjiGtxsK6wMHgLHsVnNR79SVRkLXnXBj7	4508	6348	6348	1617081840000
8697	3NLdxYWsuEFdehRS48HtGs586ujjCFkCRdPJkiEfmAuxsyn4xzFM	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	1617	1288	103	1	6301	jxbqb4kCnTCLAAa39s1hH3kbgu39oi2rKZv8U6W258XudcZ8aHp	4508	6348	6348	1617081840000
8700	3NLGgV8uwTX5n4pZY8cSdiq1g9qyXPjBRX7zr8sZxtDHbi1sNosq	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1624	1334	103	1	6301	jx5yUXE5jAzsaBsusCCPAUGBkraJkWeHRaYU1MStWSzkwVmPCsB	4510	6350	6350	1617082200000
8703	3NK6H5gYstTDi54LFrdU9ddciwv94caCScuBRvH66f5m5Vw7M2V8	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1547	1378	103	1	6301	jwHvLdVbshwSQ2Mo7JRuRXFbm6foVmm9ZTVU655UenkcJjGabbY	4511	6354	6354	1617082920000
8707	3NLtJiHxvwGFkEUVim3H14vViYZLoJh92PQbJpLCerLkZNmKa6eR	8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	1579	1389	103	1	6301	jxhU9AZApFWF5QGzr87FLhV6LaSw55NTK7aKoBnaZdbWKnxfnmS	4515	6363	6363	1617084540000
8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	44	1199	103	1	6301	jxJbwcziCHLJYJkia7Zc4XYWdNW6bvbM73ExJnXsi1Uk8rBWpDS	4518	6370	6370	1617085800000
8713	3NKbLRN6Zo3yNzwThSwKhgvyQUAAhsfWimM3dHUHcLUyZpGYyBc1	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	406	406	99	1	6301	jxZwQfUKThinGpv7WY1RirNB987n7mwN8iagpsqGFqTauFpkTQ9	4374	6371	6371	1617085980000
8715	3NLrNGVCC8Njb6k1h5MtG36VwtBbyyBJ7VCNBgu1s5Es4CcJrpnC	8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	1476	1125	103	1	6301	jwPPQZbAqp2np1txXZE4DtbmnTaoRYMAr8G6eiebe1hjXBJHyaf	4520	6372	6372	1617086160000
8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	43	1064	103	1	6301	jwAQ8W9XW4pYkW3TZwZw6hN6nQyatsQWtJexiHCv96sLbMCJCTL	4520	6372	6372	1617086160000
8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	8719	3NL7S8wgNKSBGavWgAEFoXJskteieFrzbZj34pu7io6co7cAGXo3	1649	1257	103	1	6301	jwm7RpBaD6a3h2K9RPQqofvqSRUCFh9Z8nEwFitdXtcqhXKayJj	4522	6375	6375	1617086700000
8723	3NKJ6kRziNs8doLT9NmYVrNxpY4RQXcp6rnoPVm5e518sMktaviu	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1451	1292	103	1	6301	jwp5bbCnY7rEg7Phs4uAp7ceNGurGcgcsGVzKqJhgCizUv6uWmy	4523	6377	6377	1617087060000
8726	3NLAY4sW1jFA1J8veZpYiQjZFMwedd7mQNsmYSdiwi6nnBBt9Pwi	8724	3NKyjeKaJ1YW1o62oPeE23gR7c7ZJLMtdpXg8duqgXfczzdbaLdV	1406	1393	103	1	6301	jwHNXxxvup5pokhWTDb2iJAkD1N2UiuP9qBJ4uuc7w5QkAj8jdA	4525	6381	6381	1617087780000
8728	3NKrWcwijk9VrxYUG4MoXx87nqZh2tpxRXvwq7dXpPpHJ4DYDS5B	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1546	1339	103	1	6301	jw9hS5czybRTg5G2SjR3p6gKB662bL2i832YZgCZFUgZYG6Y1dJ	4527	6383	6383	1617088140000
8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1594	1080	104	1	6301	jxXFmQp22uCpzeL8DAxrP6xvwsxXDdgwQk6b4ML58AzXHC4qGtR	4528	6384	6384	1617088320000
8735	3NKjKg7usdUdEfV4HVyxwUuJ6qUHbaXMm2xro3iTjNcrCwg3otVd	8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	1598	543	104	1	6301	jwzxLxTqRbeN8RFAwL4qXbr6iteKztmgJ16641xHRasGza1jhby	4530	6388	6388	1617089040000
8738	3NL73oD8RNUwB9XBP8QC6386vgjVLUMaeso6qMGqEprKE3rukgHq	8737	3NKdkjEDjUSPtuQR3gDHLvw3BCqYPTGW98Fvq7gtoKmsACMa2XNR	1406	1393	104	1	6301	jwFGzWFsKLQntoumLrXaJnpMaqs3wMbotnRZ6g6hvCgFyVM8MGq	4533	6392	6392	1617089760000
8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	1402	888	104	1	6301	jwDjukLBY2tz3JWQTynJyBeGQV8hZKG6Bp4YXZg5cajbDG5JPLS	4536	6396	6396	1617090480000
8744	3NLHoT5wgAnCgDzrG4CwuzQ4NDSkEfAs7oYttGKTLB2CuZ2kArqQ	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1529	1070	104	1	6301	jxRyVhpwurWoyVAxTE6nkN2op2kMigqkENCp5eB7JkDgwyJkK5N	4537	6397	6397	1617090660000
8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	8747	3NLhwo67nsxJQsiJm9UKXGfDwWV23yEMCbAzorsRxTxBGTr4cR5D	1403	782	104	1	6301	jxun4WJYNgQD6J3p1BxTmsbBakhNBFbRRngc9srM2LT5aVV2zMZ	4540	6400	6400	1617091200000
8755	3NK4DExPeQivTBbahFQVhdJjn6EGmV3dK36a12mz1VrTfHCEb7Fo	8754	3NLUrcCw4pHtEwmqgaRH6PdWiqWDYEPTee1nvWxFiZ9txZtSdAqa	1579	1263	104	1	6301	jwLWfSsK8hEND9ZzcZEW5NRj4ycyyQqxpwuQq4DfuCwhsJu8YSX	4543	6403	6403	1617091740000
8758	3NKRGV2u9Sik5nNzcWFgbFdoHNcyrVAkyrTYkz84bDzS3se8XkAd	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1406	1393	104	1	6301	jxWuLtFnyce1cMiErAjQQGrkkRz6SYMzi6xJ4ywwJXyCBWw26Jw	4545	6405	6405	1617092100000
8762	3NLFavijSg3zb42U7cWNDC8Bc6quuTuFc7ohQaykbPFgEVp4jVrb	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1671	1239	104	1	6301	jxp61bTXWDEKuH5KHijFcZXHr4utiUe1NkoWY1hKo61JgWjUV8X	4547	6407	6407	1617092460000
8765	3NLsmK6rhgZAaBhLTXemTW1JkqoLZWSyiKGqZxiSE2Lh8pADX35p	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1406	1393	104	1	6301	jxesBuKZmz1ihQSHCeCHCsHbPpF7TsQBdnzzAWyjen1u4hv4pMR	4547	6407	6407	1617092460000
8767	3NKy9cy9uqQKymdK1FHz3CZStRXS68pD5dDD89TE3c7CJo7mVHL5	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1651	935	104	1	6301	jxhFnTH3jKmtnYfDe2FD3vc1RmMUceRyH96A4Gr78ohcLGbemAp	4547	6407	6407	1617092460000
8770	3NKR2zaiCypee5AcGVPQhKd7nfHDWzQAR4jxqx6Z96F9m2Vg9q1s	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1631	794	104	1	6301	jwWo4PyZubgKXdCDcLhpMRhTbpV6LWt1tLwY9xib2bHUm18TXZz	4548	6408	6408	1617092640000
8781	3NLX9Z5SF3tAVdhdQaTBWsmbfHwdxjVdMWbHRmvNnVzBJHh2kJMG	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	43	1064	104	1	6301	jwCBpMeZSFhFXL9ZYoJoneJ31RToTU2JPyKjYHa83EzXVk6FDJ5	4555	6417	6417	1617094260000
8785	3NK94H9bMEXzUNNkUAhbVCEfbyp8UnDjJajTpLJScFwefB64pKDU	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1474	1083	105	1	6301	jxR71eCaWHwtXPu4323JaXeB4rK7iFpATqAnFeQKZUAS7obzyYj	4556	6418	6418	1617094440000
8789	3NLa1AA5LgJrVMcZcizyvasB36wK2dAvqhhu8fJscSrDYzX6Gqj3	8725	3NKZnSphCvvarHEXUGCPv3vm75XXSdYzuYkEEdaPuKU3fqafgiik	1553	776	100	1	6301	jxjb7bkmwAEd9jqKhLijwNvyD1EmMQxnfK6MQK1xChYqJoHK9Qi	4423	6420	6420	1617094800000
8792	3NLJ2PZqKfAyzZeiMzcT77ye4ktVL7XrHQowTzeBptuUkqr4fKTr	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1402	874	105	1	6301	jxRNcmgFj7afLkLUtu74ScDCDLqKv6FXYpaz1cW9nyyB5ZMStJa	4558	6421	6421	1617094980000
8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	8795	3NLiySTYhNvbRXHQhrh2wJgaYtqgA5EaoqN3xKrPLtVpFUzXKc9V	632	1136	105	1	6301	jy3CcSmTBXZ5fgdsYx7oy81QEBXeeUaU1etiXynkStfjLG78okn	4560	6424	6424	1617095520000
8686	3NKjD4nxUYxEdL8nr9DKmsHxTBoJyh3wvdoviBMeY6wTYDvuJM23	8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	369	1186	103	1	6301	jwvaAnAPeeUwMkKxCp7kkKNoHbc4QZeBLEgpL78rupJPBf39tGR	4502	6341	6341	1617080580000
8688	3NLsDNXagApFN6XzRjoNpmoHJqNudek3abgitrmEK7S9uE5T8YEk	8551	3NKepWzNiDcsYr6EQSx2aVcTJK1Umk3SZKTSXEP2rtDuMdUoyamV	1553	776	100	1	6301	jxWUB7gvmosdNZ3LveqCTc6XY9cfXptyne8sPYNRzKmAA24Tjqo	4421	6342	6342	1617080760000
8693	3NKnzgyJ9c3kEeRSyiCkqXLMF9YTR2on4cPMssUfpD4drAf3T3tW	8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	1405	867	103	1	6301	jxRGW3Sx97vbzqRAX1tkyDmcqycNKZCZZ9njAYhqXBW8YMkH4Ea	4506	6346	6346	1617081480000
8696	3NLAmrH3PmwvguTSUfd2aSaYXhXwkyJBtxEZrRZLraTtpuFc6tuT	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	1407	1395	103	1	6301	jxTZhA583xw24oWiRiHKERczEm9aSPoMsGVseGg4yeSg2WbHCQf	4508	6348	6348	1617081840000
8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	8696	3NLAmrH3PmwvguTSUfd2aSaYXhXwkyJBtxEZrRZLraTtpuFc6tuT	1637	816	103	1	6301	jwxL6y8RK727CvNdYsg4ZAb7SBEm5Jk2PFMgL7CPXbvzH1iLgmq	4509	6349	6349	1617082020000
8714	3NKy4xHRPeE1AMWrr4ThxgnxchiYq25mGhFmEC2T7ZSv9Qt4UJnR	8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	406	406	103	1	6301	jx8kkZU8QGwb9zXbdAetSgwm7rv13JDaaK1ZcWkdgeQTvopLjwY	4519	6371	6371	1617085980000
8716	3NKD3c3ToK7LhBjBYFyRPbCydS31s1eMbBvvLtxB3w7qRpEemmDw	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	43	1064	99	1	6301	jwbqDXRF48PKSAUCwJZKwbrrk13vFzJTVreoXB1uYBYHLZeLa67	4386	6372	6372	1617086160000
8718	3NKJyqaG8ieZvMa2jFfqWKRHfnuAyWNvLa4bVh8eJzD49roz7gVF	8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	1460	958	103	1	6301	jxJaERALnaxjpR84otvdVwBNJarKLN62f6QhdpLUYnbTYCRn2e6	4521	6374	6374	1617086520000
8721	3NLcT3bcGTxULW4SsdbUQQ4VFwitLNZfVXphonTYGnUyHvT8Mtvx	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1406	1393	103	1	6301	jxjxQmvErcHGmu445d2GCr98nVry7FTmbuCPyzTatLTbKeFKQWi	4523	6377	6377	1617087060000
8733	3NKETsxB2H3BjQa5mFyr75picWeGzQfkA4LgDpNTo9vAV6D1hNsA	8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	1407	1395	104	1	6301	jxftaLbPJbPEddFAnWsj8DyJfxmnvSNTiCVNjejJjQuxmX7k6sD	4529	6385	6385	1617088500000
8736	3NKcHfExhE8cnuemHdjDxRUAEB2Jg6SW483pAW4d3Si1MwHwXMpZ	8735	3NKjKg7usdUdEfV4HVyxwUuJ6qUHbaXMm2xro3iTjNcrCwg3otVd	1611	1095	104	1	6301	jwtP7hFiLgSkwbDxYnix7gsistfkym7HvhX6tBybbrUeUqsiAnj	4531	6389	6389	1617089220000
8739	3NKWfZpqevCS1TgzwTx4eSBnrSH7ZYcCAs5ri7CPHHFXWVJ2oqit	8738	3NL73oD8RNUwB9XBP8QC6386vgjVLUMaeso6qMGqEprKE3rukgHq	1657	1344	104	1	6301	jwHuiV1LvudvrmgKuFYm1UF5pG1yEXF6Er5L6LS56VnKf4zenZ7	4534	6394	6394	1617090120000
8742	3NKRy49mtFrPG46KwhVvray73ji8mdW1gVzXtEyZ4bB23kkTiMKR	8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	1406	1393	104	1	6301	jweU3WeaAMK9UF5AnMKEALX9yDF7nRqTC6P1KPXuRZWzfZWSo5W	4536	6396	6396	1617090480000
8745	3NLJ1vjhTeLKyaAm8XRW1Jh3RTSAex5TKkoEkxCXeL569CdFcZwD	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1637	816	104	1	6301	jxo3XnnP3snVJhwJpBwi7gCrbFk85ei58GruJcYTL9zz5GP2Tgm	4537	6397	6397	1617090660000
8746	3NLKfhmrVd96BvNkioebF6cUMZXJJ3ArXF9LAnSdbwNYLTvTEztF	8744	3NLHoT5wgAnCgDzrG4CwuzQ4NDSkEfAs7oYttGKTLB2CuZ2kArqQ	1573	1318	104	1	6301	jxbd3w96kgf3Hkz7b68R4ZyLShZoKnxQ4K7z5LDg35PhC4xotnk	4538	6398	6398	1617090840000
8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	1407	1395	104	1	6301	jwUmFFMHhicUJscTyvdmBrsaTbeSypgKYQtFQ6S7YKG3LK93NsN	4541	6401	6401	1617091380000
8751	3NKpbDBcRngTg8dFsam1sQ7DPZy4zqY9HGrMjHsBGp9gYvJkCvie	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	80	907	104	1	6301	jwDeZQgvKJjw829muj7mR9v9yXfuxWVZTt4A5zn5cPTVjJHastY	4542	6402	6402	1617091560000
8754	3NLUrcCw4pHtEwmqgaRH6PdWiqWDYEPTee1nvWxFiZ9txZtSdAqa	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	80	907	104	1	6301	jxXne8s6t2sjBayf9DxeT1bMB94YHNy1BbwhL52b6xLtcGkNb7f	4542	6402	6402	1617091560000
8760	3NLtF6QroXqbCbu67vxj8nnVWfHuiUpVeadduhP8pY73cDdAJ7hm	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1631	794	104	1	6301	jwZzmga2mAWGeYxv1DAFNSbfURPYpLmsASV5cJ3vZzvpPpuuubt	4545	6405	6405	1617092100000
8763	3NLs7nto4Q9HysQ6YD4SXiyZp3QjVJdDEKYhaLW8xWzbYLpzYmaE	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1402	858	104	1	6301	jwwEApr3ojLsmKB2hVdAZzHPyN1MySnFjUJDNJqix2Nr8VVp3Hc	4547	6407	6407	1617092460000
8766	3NLfUikm6tWP99P4yJb1DM6h6YZiV8HUQt3wrFy8NuV14HJeWqWx	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1405	867	104	1	6301	jwpyGWyit7MHu3BvDm1sEKv6LvAeeDJPZaP5FcqNy3KAAYNsddg	4547	6407	6407	1617092460000
8768	3NL9xq1PgP3kA56Zc4JZ4EXoeUdLh7nxmRuZ5mJE2Az8z5vkxJyZ	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1651	935	104	1	6301	jwa5vUBTp7Fuh1th41T4noxMQ6Mg4nVY9yHD2qvHmV1AAt1L9Ty	4547	6407	6407	1617092460000
8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	8769	3NLXpQqu9posrQZK8JXTiDaGWxq5mRw2JhGwzpzNhLycAosxLFrZ	1406	1393	104	1	6301	jwVn6MZPfjcPp44SrcGJCb3hSLZBWZsfEyHa4shNE3pzg3H2ypw	4549	6409	6409	1617092820000
8774	3NLXzdFj2KKzh6cQtXLPa1GAq3bHDs9hiyt9icGKjjATuFYj4m7m	8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	1406	1393	104	1	6301	jxXsW4G3f9cfJHC31nNK4BXtoQGTJpyjzWkhfEYyiGw2cUHpAgB	4551	6413	6413	1617093540000
8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	8774	3NLXzdFj2KKzh6cQtXLPa1GAq3bHDs9hiyt9icGKjjATuFYj4m7m	1560	1291	104	1	6301	jxTbYBt9eEhfbPWJu8hXjYS3HPMojQWoKrh1Pr8Xu6jXuXbA22p	4552	6414	6414	1617093720000
8783	3NKb6oQgpqS9QeBUM4rWydEArVdHnXsdByNbhiKDwh1uL6YhhxVu	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	606	1295	104	1	6301	jxroQdEhAhs4QzeemsXnqCdBC6jq2rm7LjvSuKsfNn1PHQS8Ucr	4555	6417	6417	1617094260000
8786	3NLF1FuoE7WLSSxdYndWQBJHd9yYfr85ai5tWxiRvoWBABPCfrd6	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1474	1083	105	1	6301	jxqpJCACRH6q6aeebkEcchFTRaPyvC7gkaRDWjWVMGAdxF1Qmd4	4556	6418	6418	1617094440000
8790	3NLQBPSRwPHqsDkoQoKD1bJdtxob51K5Fqa223EqsnsA1EH3CJ6D	8789	3NLa1AA5LgJrVMcZcizyvasB36wK2dAvqhhu8fJscSrDYzX6Gqj3	1553	776	100	1	6301	jxPkpjXHTPsnXGJ9EG9oRe4mgUUDJhDtBre7eV83UcGGxsGyiM8	4424	6421	6421	1617094980000
8793	3NL39ENAnScuaNDF75W5WcC7BLfdYLxhthnSrmkDF6WV1LmPUv9o	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1541	1052	105	1	6301	jw9EfD6k2GZt4QoeJfsLBRgcGWLUXdbQxgsZcwNvRwg3tX8eiw5	4558	6421	6421	1617094980000
8797	3NKL4HCJYSK15unK1A5h5TdSgv6ScrVhomk1gWxF47gQiPaFNXJJ	8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	1581	778	105	1	6301	jxr5XjK9gPPKoeMrQSSef5NriZLT9nQEMAo4SbdFmC5aVuELjUm	4561	6425	6425	1617095700000
8799	3NLL5XLCY4hE3j9YqEKwjFkLxqHnF4gHmKhXXBv1epjW6wwxXwcG	8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	1671	999	105	1	6301	jxiFmjA4rZd78zqKKUsC72S22E5j1a47x9jaWyHEw7VmyDVfo1G	4562	6426	6426	1617095880000
8804	3NLSmQ4U6HfYLwn8zbytMoFW5JC681Mj4VHtuqMqqa8tQkhNAjy8	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	576	1229	105	1	6301	jw7ku8RQji9PP2tcKz27ohJvQGHKPrbAKr4ryUdZXwKVjTrgsGJ	4564	6430	6430	1617096600000
8687	3NKURwodWHPxR1W7TKhAxy6SNnY8uZXd7CAospm37kKYJe2zndoh	8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	1542	1058	103	1	6301	jxBn8EH54ED9P7wASpANQb6BTcXpXtE1mwZ5F3z89eToHJqEutn	4502	6341	6341	1617080580000
8689	3NLH3a42wWyPEKGJVURviVwm1jS7yC3HZuat6pQYAXGtorYYEv9V	8686	3NKjD4nxUYxEdL8nr9DKmsHxTBoJyh3wvdoviBMeY6wTYDvuJM23	1406	1393	103	1	6301	jwhvj35WWKaXZq2VUvzxVyLxYsGtiREdi1YyS5fWBnoYQQ9qvGN	4503	6342	6342	1617080760000
8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	8690	3NLbJY1iGuYqgZUNfLr8hpZ6LQPF2MEZzt8gqKo1FpnxN5NedgWu	1581	778	103	1	6301	jxQFM3fP9AJWKxQMshYaaSzWFFaddimcNWAGU4Ndt96qYWko6yj	4505	6344	6344	1617081120000
8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	8693	3NKnzgyJ9c3kEeRSyiCkqXLMF9YTR2on4cPMssUfpD4drAf3T3tW	1501	1360	103	1	6301	jx4MA6iMzoUSgSEfro2GCoywdTa2Ho7PwX7ZtXJqcDsuNzVpxcp	4507	6347	6347	1617081660000
8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1650	1249	103	1	6301	jxsXt75SLwR23UVjwBiAPqTEmcbU4JxGhzFd3sNQLg3uACKgmEU	4510	6350	6350	1617082200000
8704	3NKN2qYCfLWfytPBggU6gW1DpgdPQb82ojt4pAJjpBDijGsd3K25	8702	3NKqXdq5EuNCKR4yNwNrcv2AA9bLKkCBACpCRaPyq4BxYhFNpz33	448	939	103	1	6301	jxJvSuE3VjeBhRV3UcBBEsCwKLX1zfTdfZE8M2RypenurFvgbhr	4512	6356	6356	1617083280000
8708	3NKyGo5uAnKfzU3vKWhD3Rnf3xgQa6t7kfEEXmjS41R424a6fSdw	8707	3NLtJiHxvwGFkEUVim3H14vViYZLoJh92PQbJpLCerLkZNmKa6eR	596	1306	103	1	6301	jx8r34zAZPrQ8gybqVmEfMzpHM1UidwZ8dn66m711eQgMNu92kn	4516	6364	6364	1617084720000
8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	1501	1114	103	1	6301	jwGjABW6UhtqhVTYYG9UCWeZFPtAnEcgkWD2pn24JJr1L71DADL	4519	6371	6371	1617085980000
8719	3NL7S8wgNKSBGavWgAEFoXJskteieFrzbZj34pu7io6co7cAGXo3	8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	1585	1366	103	1	6301	jxsGVfMjKaFRo7hDK6k1QJtuiwQSKCHpnNqEdzWusETFtSLzuTf	4521	6374	6374	1617086520000
8724	3NKyjeKaJ1YW1o62oPeE23gR7c7ZJLMtdpXg8duqgXfczzdbaLdV	8723	3NKJ6kRziNs8doLT9NmYVrNxpY4RQXcp6rnoPVm5e518sMktaviu	1560	925	103	1	6301	jxBa3xfNvbLf9MsJ8kBKyCpAn1a13H2RgDzJyMRFkiPNucqFNpa	4524	6380	6380	1617087600000
8729	3NKunhhdgRBaosPDLEDmXz7QjoF2UWQ4vYxXjrzTm4QSMaX54zeT	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1403	812	103	1	6301	jxVTJkoW4mm3d1zNCuDAVXCtTJeUe2RoWsRTusvkMzup3JvQyeG	4527	6383	6383	1617088140000
8731	3NL4ojAYsnsfgjBy3SHmpwTwF8YzBToLaYS4r9NSsZtzbdwU4KcQ	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1407	1395	104	1	6301	jxwLdH2qqCgbbNKQ8JqG2xsSqHYNg3So6BN7QE6ZR3eSYrCB7iL	4528	6384	6384	1617088320000
8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	1406	1393	104	1	6301	jxvAHvWXgeKpFLRDUHPi8zk7QggQrkifaehLFXxCh1wXXigFwkS	4529	6385	6385	1617088500000
8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	8739	3NKWfZpqevCS1TgzwTx4eSBnrSH7ZYcCAs5ri7CPHHFXWVJ2oqit	1481	789	104	1	6301	jxpBaZTmzbsh6r3NxwgtPR8YfEpvWtikyPQFrMow3PcayHokSp9	4535	6395	6395	1617090300000
8747	3NLhwo67nsxJQsiJm9UKXGfDwWV23yEMCbAzorsRxTxBGTr4cR5D	8746	3NLKfhmrVd96BvNkioebF6cUMZXJJ3ArXF9LAnSdbwNYLTvTEztF	1406	1393	104	1	6301	jxBJqj8ap1BLBekoj6NAmpsQR9TKagmhYfrjkYFT9MGDEBvSF9W	4539	6399	6399	1617091020000
8752	3NKtDKzwALTYgcJ1o3SSCKzf1Qxi8dowEdhg88fhBKGmdSfgXvm6	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	1407	1395	104	1	6301	jxZLMShFsk9WQJJembRXGYnadpHfwbdKAfhV2a79UoBtJyXdiUY	4542	6402	6402	1617091560000
8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	8755	3NK4DExPeQivTBbahFQVhdJjn6EGmV3dK36a12mz1VrTfHCEb7Fo	1403	824	104	1	6301	jwgyYSwFQQKt8PbKi4KmNFwx1xHiHitGign6gS8UtEVZiGLBjon	4544	6404	6404	1617091920000
8769	3NLXpQqu9posrQZK8JXTiDaGWxq5mRw2JhGwzpzNhLycAosxLFrZ	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1406	1393	104	1	6301	jwhTCz9wnjXvUNDqvhPi8y5NWANNn7Ei7W4nrypE3KzRWyXazG7	4548	6408	6408	1617092640000
8772	3NLsrYuhACJhRAoidVZ1MWVrhcZWH7YV7qSuKDRaeaaUUwRjc1gc	8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	1599	1287	104	1	6301	jwaRvhxJPNW5D62Hrcv9feSa9AExe73duGe8Zdbv6BogTcCpfvD	4550	6412	6412	1617093360000
8777	3NKBRrFxzzGin8LvFJxg6HPN3VvYZW2Nv9m6CKEaCRQDEQDXonxF	8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	576	1355	104	1	6301	jxRedoJDcwugYTin3SPrFjy17d5daSMX5ko3D3FeLE5wVDZ2T3y	4553	6415	6415	1617093900000
8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	8777	3NKBRrFxzzGin8LvFJxg6HPN3VvYZW2Nv9m6CKEaCRQDEQDXonxF	1560	1045	104	1	6301	jxABRBCeBmXhey73PHM3T4v5SFc6xhptdYYyFjBn6LHvTEotXge	4554	6416	6416	1617094080000
8782	3NL2ZE8iZNNsBbxeAGPqEmovSGtA39grKxUVcVFtNfihifHJ2iHm	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	606	1295	104	1	6301	jxroQdEhAhs4QzeemsXnqCdBC6jq2rm7LjvSuKsfNn1PHQS8Ucr	4555	6417	6417	1617094260000
8787	3NLgXpwsskKxjRCR7QjQfNKkBv3uhpvZLNRS5xAZNvZbRhjhUDcR	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1541	1052	105	1	6301	jx6EAaV6eUgYho9fKtt1Vg11vNHoXL3VB2EeTHrp6xnXErcLav5	4556	6418	6418	1617094440000
8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	8784	3NKSoUrfAP9zqe6HP3EGWSrzhnpixbez7Hk7EerXjYpCybwKbdme	1402	906	105	1	6301	jxgs3BS6wVuYTsxbCHUFXufZ9WpZx8baFhbSwxJrXPWZEDHJkb6	4557	6419	6419	1617094620000
8791	3NLvkDbsM96kp7sbzu7UUmVVq8anDWCLzpHvQjC9DM6WWTqQs47B	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1407	1395	105	1	6301	jwvsm34fSzs8wEbwNKZdM5VqchS4JRqk4R8cD9LMFtC5X2ytwto	4558	6421	6421	1617094980000
8794	3NLVLiKHf7vYhp7Tws2dReNGikdjhVcfmD677PugS5fxGRrhNQua	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1500	931	105	1	6301	jxTmp6PEfdFM8b5arAPmLwgH7vLCoxzVXxCFfKGHobTA9wv2vzC	4558	6421	6421	1617094980000
8795	3NLiySTYhNvbRXHQhrh2wJgaYtqgA5EaoqN3xKrPLtVpFUzXKc9V	8791	3NLvkDbsM96kp7sbzu7UUmVVq8anDWCLzpHvQjC9DM6WWTqQs47B	1590	1054	105	1	6301	jwgT3g1ePU9djRMNi5rdTFZBSkU5yJFecE9SR3bpoz9QYwm9AQz	4559	6423	6423	1617095340000
8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	1633	1390	105	1	6301	jwGUkbj3HyTuvgFAUYWgQcc4rLTkNN5onNcRgL8MBcdHUZBZvFo	4561	6425	6425	1617095700000
8802	3NKpZo8Znke6DNadSL9rq1Xc3gWZ35AjPFUVPjpG9VmpMBduncvy	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	171	1374	105	1	6301	jwCTtnWxfeymzMPxxK8JVRZa6UYP5muJCFiA11hbtKMxBNx8MNx	4564	6428	6428	1617096240000
8805	3NLHC9WamYjvvUyW4VfSYQMFm1ZSnn3q5hhRHg6WoAZfxwnBSRNh	8803	3NLsATWUyFNdPh5g4DXBYX11SAAwLtJpffaqdUjjVbcEUGRA3jqv	576	1229	105	1	6301	jxTTW351Gy5Z4VLVZbvyoNQLJQr4FgSTkv52f4aKXPENtCRw1ZL	4565	6430	6430	1617096600000
8807	3NLnb89SL3nimVewtHLVR4nysvsWDZ4oJ6ZbESpsf5EvTXRGp1kX	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	1423	332	105	1	6301	jwvULxeY9vPVWKiswrdYMUr9GaZ8diiB4k4E57Sfr8JZcRdxkPs	4567	6432	6432	1617096960000
8814	3NKGg5C2yb3xuGxYEZJ1pHyLNm4y9PrffqT4uJFV3jd69vxd6L1y	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1529	1316	104	1	6301	jxKyvCXmQNAx5aNyg6qDgYJrze1GYuHY4z23DMzmX4fjCtU3PtU	4548	6435	6435	1617097500000
8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	8705	3NLQBzV1XSwTehAYRWcdt1wa2vyfJ1kL5LsWL9BsRTqMBVPFbqyX	1555	1347	103	1	6301	jxrm4ALxbynosfrSnF3HcmHcRhBTT8NTMKrPaftmVaD3FvHkNHD	4514	6361	6361	1617084180000
8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	8708	3NKyGo5uAnKfzU3vKWhD3Rnf3xgQa6t7kfEEXmjS41R424a6fSdw	1483	1150	103	1	6301	jwmbM8RxvWmfnupwFDi3ErzxvWPwSY8JcDKRoUQMoyUmTtytRe8	4517	6365	6365	1617084900000
8710	3NKBTnvgrX98a3haMpaUBqxn5JRfAz6W2TRb4vdpBd84Qdj89H5i	8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	1407	1395	103	1	6301	jxFn9KjUsFi3vtWVD1J9KjSqKNpgWqBYdBB1EiYRzhRXUfNbRzc	4518	6370	6370	1617085800000
8722	3NLjgwhzvqBaGpojstLRY6diYfkAAuqbRHE9q32t1UHwjh1eMy6D	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1652	1315	103	1	6301	jwtPqgH5ZYmUQzLL9rQ5dQJ6Z3XsXNHjdEE9sMTv8JqpbMgYe7q	4523	6377	6377	1617087060000
8725	3NKZnSphCvvarHEXUGCPv3vm75XXSdYzuYkEEdaPuKU3fqafgiik	8688	3NLsDNXagApFN6XzRjoNpmoHJqNudek3abgitrmEK7S9uE5T8YEk	1553	776	100	1	6301	jx8eg5UXAhCDWreyw6WKsCbgPWLAmcm22gVbG74tfi7r9nUeLmU	4422	6381	6381	1617087780000
8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	8726	3NLAY4sW1jFA1J8veZpYiQjZFMwedd7mQNsmYSdiwi6nnBBt9Pwi	43	1064	103	1	6301	jwAAdu55Q5rXMkCJPmrrn5oAsQK3xxELisGf6u48DvGp6reHcWs	4526	6382	6382	1617087960000
8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1546	1339	103	1	6301	jxSZEVeqPJZngYkTLnuL7GLCQ6f2eQYT4hBvgbyJjH1KKfmRT9y	4527	6383	6383	1617088140000
8737	3NKdkjEDjUSPtuQR3gDHLvw3BCqYPTGW98Fvq7gtoKmsACMa2XNR	8736	3NKcHfExhE8cnuemHdjDxRUAEB2Jg6SW483pAW4d3Si1MwHwXMpZ	1406	1393	104	1	6301	jxByvZRLnA2ATr5hFkb3bHFWzrBn7vipMXqUGUsxk2KNa2omRmt	4532	6390	6390	1617089400000
8743	3NLWcnwui8rRv45ZRoUSJJnToDcNQUbpfmope48QESGGNct6vda6	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1451	1292	104	1	6301	jxUZNZfRhrpL5RVsKVsmNmDqP4A8SDKQQwu4Xk9ecgM4iETL3rt	4537	6397	6397	1617090660000
8750	3NLTWpghAPmCoMKJEUJXv4phFCD77EGrd9QhbY5VFkwsqwn1HPQ3	8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	1631	794	104	1	6301	jxBArAupZcT33vD9nszEfXkk2MrwCWMDrz3S6vm7HNcjSRyfYB3	4541	6401	6401	1617091380000
8753	3NLULdvfAMfG8uyMwpnnSYjn6VeDpKL8Z3PkANMptorHuSgg8uGx	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	1406	1393	104	1	6301	jxvsVxwztNCDD95hEvxK9MHA7dGaJDsAwPhhSAr1pDggasKmLHz	4542	6402	6402	1617091560000
8757	3NLhupHmLTeqo5baYt2PLPBnoLsj7WV77Y3BaGqSoQ6rsoDKXjqD	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1670	1036	104	1	6301	jwFwkEWzgHa2vWWSHxGSWnN4diPSnJ4hjz5oPU3fvN9sGABsqoE	4545	6405	6405	1617092100000
8759	3NKaFZtCy39eZuMhtBkS49zveRMTjXw7FKnJRgPfSu7QcjvJkG4p	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1637	816	104	1	6301	jwkixVgQB1tEpyUgtaVp2FKDu7SHXrGBdvmUwfj4YcJYk4ezs4y	4545	6405	6405	1617092100000
8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	8760	3NLtF6QroXqbCbu67vxj8nnVWfHuiUpVeadduhP8pY73cDdAJ7hm	1500	1297	104	1	6301	jwL9RSe44YCntibyLWtXaSB1wTD21h6BCrqNxfaGrbpYHYhYbe4	4546	6406	6406	1617092280000
8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1407	1395	104	1	6301	jw76Gc3mxD8mLysSjgnxE5qknjwgwP2Dax5BnfdekbWNjtAS7Vp	4547	6407	6407	1617092460000
8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	1619	1029	104	1	6301	jxpHWY7W3sLFpxXnQJ16HdeD9rVRcsKiUmLUUkYKxTJigf3mnFN	4550	6412	6412	1617093360000
8775	3NKzecrDRZCUxWsU1cp8QzYH4QGd78PYJprzgSRb1o3kzFVaKRHi	8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	1631	794	104	1	6301	jxM3Kci2M14F6cAP8NMKhZn4rMrrcB8VAXB3cy5EfjJU74TKJf2	4551	6413	6413	1617093540000
8778	3NL4XHSBymyUTuGRqKDB6M72jP3mt2ZREciTU3HAvjK14Jcz9AFE	8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	1650	1249	104	1	6301	jwSxkNS5QTfCNoq8dwdTxuC8JF5aePTGa6ks2L2jHEqpJSVCCUS	4553	6415	6415	1617093900000
8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	43	1064	104	1	6301	jwW5pD22ChmR48TrRbPUDM7N9nfytbgfEL2xDLD22ZLcfJC778f	4555	6417	6417	1617094260000
8784	3NKSoUrfAP9zqe6HP3EGWSrzhnpixbez7Hk7EerXjYpCybwKbdme	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1541	1052	105	1	6301	jxAVjsd5FP3ZhEJ6ZQMkYEp2KefmgGLULgB8p7n3SaFKEGwHRCj	4556	6418	6418	1617094440000
8800	3NKc17YLXfq9AaDcKYB92fdP7YUafYgaeo47yNYEyaF7YQbWaNgt	8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	1406	1393	105	1	6301	jwgBrWjE4fmYQmfANrMdDJQjS7jAje7kXYDsUFZXziquJFPhFN3	4562	6426	6426	1617095880000
8803	3NLsATWUyFNdPh5g4DXBYX11SAAwLtJpffaqdUjjVbcEUGRA3jqv	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	1631	794	105	1	6301	jwwzg3YBnjMCwwMNCafL6A4QPZdRGUo1gZeQ7b4K8fHcA1KKYVo	4564	6428	6428	1617096240000
8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	8809	3NLDRsFYiafu2mQPjJUWyVPxJzqsTo4P8P6wUixnwjpYEgi98WUG	1490	1274	105	1	6301	jwM4vJthpJwJVrpeyiCq26E4WmNMN9rRuL7KUUc7WG8zFCtP7HC	4568	6433	6433	1617097140000
8812	3NLLcHxEFTurm35BeJuVq6A1DFSXRoZzwS2RkzeLF4zcbKqP9gyf	8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	1406	1393	105	1	6301	jxpFiS5UW3h8hG9KiRzp4bveBVngsZ4u45gDu4PDrfUWW456KHr	4569	6434	6434	1617097320000
8820	3NLfHxTXYmKBFq9aQhDqYCAC3mzoG9bCb9xKiN8aS55qLsY9xn48	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1581	778	105	1	6301	jxFCRCYDGr5m5YLT2wF8jZrsCqLPf6yJfwtFwVnPkBsyDQrGQhF	4572	6437	6437	1617097860000
8821	3NKfZaseBWVbCe7ePCkequNcHFbD1zqgrHKH9HeSW7xy9iRQfoUC	8819	3NLqsG6RsMnkiggR6ctbM2bshM3g5v2KRBjnuQwcRpzdYtA4wiMZ	1616	2	105	1	6301	jwNc3zVqubbC1ZZw9SnHc1FrJxST345pRuVLAgKav8iAxW7UAKa	4573	6438	6438	1617098040000
8837	3NLC9YVeMVHHsbR2NGW5aTZ11R7jGUSgdJNDADsAgRWMmEJHFbtf	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	105	1	6301	jxsJWZ7b9UpcLVKhWHWG8vhrvL5DabknqGQoRYresLQWXDj4WfW	4582	6452	6452	1617100560000
8838	3NKUChGwmcaHu4Tx3sfh4UbF8LU8bn7cgUn1D78kMngKYiVd2vnK	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	106	1	6301	jwtr8BDpSYddb74LAttSTAUHsdhJMoweyYwRC5AVKXHWUpDN3Mx	4582	6452	6452	1617100560000
8844	3NLwAbwZEDySfMidik7qN7fJasr9vPs8CwEfC8uzqpQ4Ma3TrMf1	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	1602	1369	106	1	6301	jweqmbinT6P6sVpHUobEbPwTecDrWsgssQXoYDfchaTrPvhgmjj	4584	6456	6456	1617101280000
8846	3NLHHhzVhhStsS1gtXKbyys1hHd8wGca5GLqBBnopWkbJaM2kC6t	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	643	643	106	1	6301	jwRWBtomjtarJNytz4wKwWnF2MtFbSitQhpLroKxbDxAfq5EJas	4584	6456	6456	1617101280000
8851	3NKDxryr7AXG85HuXnYUoi5PCGnw3u7bxrVwLdb161F7gTkMkiU8	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jwtEMpF9pHZKm5ssjCNUSPfqJnqU1VNADYdZ5FttNUgWcGBrNj1	4587	6459	6459	1617101820000
8855	3NLogt8tx7Njk7eaECnKDNfa7zLp273YK2vyhuAPf7KE56MaQqNG	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jxXu44ShtvTQZEXoQ2qtzKT55cLWGZWU1zsJPe3H4t2droPoW7c	4587	6459	6459	1617101820000
8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	8800	3NKc17YLXfq9AaDcKYB92fdP7YUafYgaeo47yNYEyaF7YQbWaNgt	1578	1296	105	1	6301	jwSsp9E4nNxcmmzHJGEBXqGF3fSYKhvPWAwRcdWcBE1A2DWw12p	4563	6427	6427	1617096060000
8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	8805	3NLHC9WamYjvvUyW4VfSYQMFm1ZSnn3q5hhRHg6WoAZfxwnBSRNh	1422	971	105	1	6301	jxZeYtA8k4QWXqsoFrXtZy7Z1WsYHWLJVPHmgNYHeNCynnfNSrt	4566	6431	6431	1617096780000
8808	3NLPqLytp9DZfkeTrvUNedkQRzGQDuRuY2VoQqo6xqHGxKS9QS4f	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	235	235	105	1	6301	jxCsWCEu6TJ4wbx5PTx12Ncw72U37MM1wJGTVwDf4AnD9CoFuXP	4567	6432	6432	1617097010587
8815	3NLPjsz8WC6i2wxk37Sw3sEmWmJhj6Jv3xV8c3shgKe48X5vGPSi	8813	3NKakBmHufULt5BmD42mesjBbdYieovzLS9e8oz31cEdgKJSpQrt	1529	1316	105	1	6301	jwNPWmtdHnhHb8suMVwQ18MyQNPKQ2G3BZ5NwL64arngw7vj9V2	4570	6435	6435	1617097500000
8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	8815	3NLPjsz8WC6i2wxk37Sw3sEmWmJhj6Jv3xV8c3shgKe48X5vGPSi	1619	1029	105	1	6301	jwV5dvBRAh3DMRdqB4CZCTi4Q9hPkW9FuypCuxEzs1qJHNagY4V	4571	6436	6436	1617097680000
8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	8821	3NKfZaseBWVbCe7ePCkequNcHFbD1zqgrHKH9HeSW7xy9iRQfoUC	1406	1393	105	1	6301	jwenCM9ZxG1GRk5yGw5wu78Yh76AUjFCV7eAAdv7NcTVFtKd3JV	4574	6440	6440	1617098400000
8828	3NLZAteZSHU2MrbMRGpWpsk9Gx7XSCRujMGCdZpUpQadR4Je4SmD	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1648	1038	105	1	6301	jxgZx8zQHHkScF38pZe65b1cXASCNRGTkv14FrW66rHf4gjchBk	4577	6445	6445	1617099300000
8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	1489	1134	105	1	6301	jwyXwP1VLD92StZFjg1on8R1zoRomTRWh4wzpn5Pbmji8f8tAcM	4580	6449	6449	1617100020000
8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	1407	1395	105	1	6301	jxyqZKCVo2RgbGnwzjHb72tPkyuJun5PjLMb4rxyqgxatS5EYjk	4581	6450	6450	1617100200000
8841	3NKGCotvWDVrtKmCVk7FCemMmc9KFDdWHLSZLj4NCRuQR9ttJyZk	8840	3NKfBaTtuvrrboWQuUdbnWAkjqPr5oNuVB4uNsTnHigg6FYDErkZ	1419	814	106	1	6301	jxPxY2mJzbwcaLieNdr3kAayHBXspSm5CCZAC47Dfbb2Zs1r9Kr	4583	6455	6455	1617101100000
8845	3NLowiSoVDtf3cXf9HAwfwiteKLP4xWuM1h4hXSQKa3yKqMui9Ay	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	1602	1369	106	1	6301	jx9byeNPy7UREZsgVkyqCG1baAg3EvnZUpmVFwcaTBjMqNZiki4	4584	6456	6456	1617101280000
8847	3NLCTZZgbJ8y854VBacG3sonCQtPgH53obThkzhYcaLpWoafAN5Y	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	643	643	106	1	6301	jxg3CETLnZ8mqYHRBiaEu5JVk22dceiTaqBRVn1A4FR9zuLr9MF	4584	6456	6456	1617101280000
8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	1501	1114	106	1	6301	jx8n92bT5atgtgrvdsw8AWCC9xBsqGy4t6ubNyHo7QbB1xBanox	4586	6458	6458	1617101640000
8852	3NKepoFo85QWgAoGptNgcAno12haehowcc5DR2cUrrcXW2E7pRse	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jwenG6CRGtE9L49RLk85v8XS1Svp8HizAe1yr9JeKsMMYZ8HsK2	4587	6459	6459	1617101820000
8858	3NLeHVHRXs4ASVh4SgE6aKeX3FBUVMc6tSrYtJ6Vn464xr4HEpDH	8857	3NKU3DMXojtMadWYH2btHYZpiSnZH2wGNUzD2KJG2FjvEpFkizNn	1506	1127	106	1	6301	jxZaB3Dj1pNsPtXEaUa7tbnxisHDKqLztVuXseDJ4dy5nJeXhfN	4590	6462	6462	1617102360000
8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	606	1049	106	1	6301	jxhhj2dKDq4XbvG8fMUxZwgorLteehQuubZ67C1jc7aPRmfaSLv	4592	6464	6464	1617102720000
8864	3NKmoazEPZMq4PshKwymmw2mjCCbhQpwp5cgXBhGtDJ47EHqKGT9	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1402	850	106	1	6301	jxUP3SxvpUuhiFXdzW96bDeW5aBxpjBR9FYbWjB2KvqYCo8DweN	4593	6465	6465	1617102900000
8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	1483	660	106	1	6301	jxL5ectUz3FANqWpVrqWL3dk3NQXXuMo84uCgCCzhhLB48DRg5Q	4594	6466	6466	1617103080000
8868	3NKuLgdwU3f4JmQFwtX5YvXqnhXhuXS9LYyfeihgSwKsq2TnCRNY	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1405	849	106	1	6301	jxsHEsgMsQaEaKoPfgDfXeWnuLfjaYc2tn9bvd9fTMPXEDr7DSX	4595	6467	6467	1617103260000
8870	3NKZVCWzJYEonb75CB724ZxLYSqKRzamcQmA2c4xNVEEZLv3ptyX	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1654	1094	106	1	6301	jwwnPSfepnnQc2vXmBZg9nUMe3kdkhMtHUN8o4fdg9JH3ZP3ndH	4597	6470	6470	1617103800000
8875	3NLNr7YCPyx7cZsUu8jGZWN7Hhy3HgT7nmRrUo5tKmkd6SDjonpZ	8872	3NKwNqMQMdM9uWhUw8FNeWbRGtPVd8MBgvAahNwyW8RjxWhRL62L	1619	909	106	1	6301	jwtBvsFT3qqUCPwjXcgp7hXW4QvxwXFmDrHWnqYQA2FhBPcJzdP	4598	6471	6471	1617103980000
8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	152	1084	106	1	6301	jy1N9jHGx7tYyHGHfKsigp4MpzSbmyYNHZSuz6C1Y3dNYgH7ATP	4599	6474	6474	1617104520000
8879	3NLMPPuTMCsY3fz5hEbSFMmv47oEFGfs88nnapjnUkfPKyZyQvBi	8814	3NKGg5C2yb3xuGxYEZJ1pHyLNm4y9PrffqT4uJFV3jd69vxd6L1y	1529	1316	104	1	6301	jwFWHurifjv1iPnq9nqKJFBb4KGDqyHV2nf5W5ytr2oaAWAT7KN	4549	6474	6474	1617104520000
8882	3NK4kCuEQ5muQRENjWjfoSiEYvrQnHbK2eGCCrBtgY3EcHMW9MYb	8880	3NL9fZ58peZFbmPg4ratUYCNwoVGKM6m4yjH9Jbb2sUzdkw1Wh8q	1460	616	106	1	6301	jwxCyEMLCQNo9vztYX5r3ezGedGYVYcb3jAB2bFUs84b8hs9zs7	4601	6478	6478	1617105240000
8885	3NLNQwPb2ZHhCNp88AxNVDb36U1wunyb3vuYPbWZJDy2tgRqiPeQ	8884	3NKK64XiQ49VkKPFoWqzaahQFCFT5xxD4XYygFa6PYqWfnDEUgRU	1406	1393	106	1	6301	jxFBaAVmbnVFoaobCHyPnX4u5ZL53sjr9qtJamwuCnXd2xW6X3c	4604	6482	6482	1617105960000
8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	8885	3NLNQwPb2ZHhCNp88AxNVDb36U1wunyb3vuYPbWZJDy2tgRqiPeQ	1407	1395	106	1	6301	jxBY5UxWXviG39rsntYAZKufD1SKzHpY27JXpPdeEvVi9tKDsPf	4605	6486	6486	1617106680000
8900	3NKimzuG5uzko7WuTwkbr2J3DCSxovZ2PLf9iaKXUjUrzu1ToxZg	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1523	1075	107	1	6301	jwRgtt7oUCjqG4P5qjy2bLXBm9HdhD5BGzvSdCuKjJdWZ4BV3s8	4611	6493	6493	1617107940000
8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	8906	3NK7pGuKToBXXQPxzodecKFFqQxFoJ5hT3HnDZAMoEi8ik78237V	1406	1393	107	1	6301	jwfs5LynD7Qn7hgFGVeH4M4UeC9QVZJde8wTK5R4LKZcaQrUk2C	4614	6497	6497	1617108660000
8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	8909	3NLdPfKzT4fSjMijmrZf6dEuF23JQwbHzgsXogZrwaZEoCNfnF8m	1406	1393	107	1	6301	jwLSUYKTmBa3BeFY7yqKYR4a8fhLqUAipDPtpx3epQDg9qKgJWE	4616	6501	6501	1617109380000
8915	3NLa8S3fmaQ1Gbqi1PsQm76j8jFG4q84VAxcEdcw4sn6WF3m6SA1	8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	1405	867	107	1	6301	jwdf3wHhqTHKWgdXvBtzWW7ZAgwzfko8BqR2Y46Z3owW8WpDrXK	4619	6504	6504	1617109920000
8923	3NKbWwN4mzn9F15DnhF7LeDHV3JwbFLx8UXoCzmcRjbsoVmV7Bmk	8876	3NKmD3KDk1Gd3kLfheMpqzT5PbmdiznVQAupc7EpDsYeDhvh7spo	1623	839	106	1	6301	jxUi8ka9uYrwCEPMfJtoxt169gs3pzxUCNJKG1UYXGUrtqN5GP9	4596	6511	6511	1617111180000
8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	8924	3NL1s68Qqha5DPf5oR8JCETUcc4p5SMFPikRoAJhgP7mf2kEt2tb	1549	1362	107	1	6301	jxVje1M7sqmkyNm7x5YU291wEoeCFUCTnAcaEGRK1WR9nyyMcCp	4626	6513	6513	1617111540000
8809	3NLDRsFYiafu2mQPjJUWyVPxJzqsTo4P8P6wUixnwjpYEgi98WUG	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	235	235	105	1	6301	jwkLPE9eZB5mKNAhwUJwMoJ7XbD7szY2ZyHi7gRVryM5XXabfki	4567	6432	6432	1617096960000
8811	3NKfQrwWxny6xnTdceG1gqQ8GYgFEhd3pAbmWZXCdXz9kumhiDvY	8808	3NLPqLytp9DZfkeTrvUNedkQRzGQDuRuY2VoQqo6xqHGxKS9QS4f	1490	1274	105	1	6301	jxQ7tvEZY1RbsS6q8tWcqZeVTC7vjyN1Yr9fntWd8TzxvkhWvmQ	4568	6433	6433	1617097140000
8813	3NKakBmHufULt5BmD42mesjBbdYieovzLS9e8oz31cEdgKJSpQrt	8811	3NKfQrwWxny6xnTdceG1gqQ8GYgFEhd3pAbmWZXCdXz9kumhiDvY	1405	865	105	1	6301	jwNrjo8w9DHphCYuXaVpcX7riJkPZhVgFjZTs8Jcsux3dArm4BH	4569	6434	6434	1617097320000
8818	3NLyQfcJTHDauabC5JZX1oB9xLJjzJMp65FsJG38KChQFmLmjf6H	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1608	1163	105	1	6301	jwSUpdnER7BrzhNseCXqT4qcArZfhn9fmvcM3Ke8vFNZCAeCRvZ	4572	6437	6437	1617097860000
8823	3NLbRKqwAUAar83RXAjcW56ANbefypYW66vnQaCufzH6mKm9fkep	8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	1656	977	105	1	6301	jwRPBHDzpbxLi2J6gaKT48CLDhsFVWa6Pyk2fKqGEzEbaV6RJjV	4575	6441	6441	1617098580000
8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	8823	3NLbRKqwAUAar83RXAjcW56ANbefypYW66vnQaCufzH6mKm9fkep	641	1336	105	1	6301	jx3U1DNtQtKCBJCFAcia6LYphjannVEML1JWqPBGucv93wj19KX	4576	6442	6442	1617098760000
8826	3NKhQgBRysGUaD25KnbYnmaubiCErXJLToYLPEb4NBH7RDiVS2zM	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1447	1099	105	1	6301	jwC6xLytXW59rxa37wxJMCp2ADBanXwAGHGSXmvgWD8hSthFdiq	4577	6445	6445	1617099300000
8829	3NKUB54hJZg5QDrKzYAVeHMBnVLjw5de6T7wzFpGPGjJHdXJnc4b	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1405	873	105	1	6301	jxidkX3yXMxuiF2C3QJeprV75DRwRiwdKRiRMqximMyzkezofey	4577	6445	6445	1617099300000
8830	3NKxXp8pJCEvs2PqgquAAYv9YhiVFscfBkLw9mxm1x4At9qq1qNr	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1623	830	105	1	6301	jxxMh13RdEiyP2aUcwPoA3MhnRXb1PLjicoVXwEbPS6h1bykUfe	4577	6445	6445	1617099300000
8834	3NLf6VqiG46f8f38a7fL3uwMHyS1Zfck1uvAX7q96g4sqMu7KufW	8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	1673	1122	105	1	6301	jxYLwG2f8Dvn8PFR9puVGTqkKVjQJ6cA5hG9thK8AgifK32fK2y	4580	6449	6449	1617100020000
8836	3NLn8nBo17AqiEztjH4EsjDpVHJzvct3QvxJe3tArVkcyDoxwYbG	8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	1423	234	105	1	6301	jxjHyBLo8kwwi5zt2iTBfXEm9LeESeEndFixaBQvFMc4gJPCNub	4581	6450	6450	1617100200000
8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	105	1	6301	jwtr8BDpSYddb74LAttSTAUHsdhJMoweyYwRC5AVKXHWUpDN3Mx	4582	6452	6452	1617100560000
8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	1560	202	106	1	6301	jxUAMvLPoTbuhFT4KfEATyQFMrGQ3LJUJcutNXkKTgLzEPgKVqf	4583	6455	6455	1617101100000
8853	3NLRZmrHFqB29ZsEu2L6jRmbVDCMVnH6PnTQd4AcZYBRcUjYsPF8	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1406	1393	106	1	6301	jxhVxuQgYKrNrNAooQjiNbg8KRFoRuU1rAxqAxowEay2n8VhyVf	4587	6459	6459	1617101820000
8856	3NLWswRAkdYmmYudoHcP8NnYEXeyeK1xBTDgRD3CUnM2hJAuhPfM	8853	3NLRZmrHFqB29ZsEu2L6jRmbVDCMVnH6PnTQd4AcZYBRcUjYsPF8	1594	1200	106	1	6301	jxf39pMpFTXP8HgGdgJVjbL3ry8QJHuyJzAGGv7wM2jJq3QFjAv	4588	6460	6460	1617102000000
8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	8858	3NLeHVHRXs4ASVh4SgE6aKeX3FBUVMc6tSrYtJ6Vn464xr4HEpDH	1406	1393	106	1	6301	jwkcKpLtPVQVVWBnJDbwgTYrCKf69AQCqb6PU6yRCCzp9fQbvmL	4591	6463	6463	1617102540000
8866	3NKb1jzWDKur2SNwncCH8nAH37VHGg4tBrMVM39KVV5Q7Vjm2r5a	8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	1627	1385	106	1	6301	jwzo385xHGCAbrvKw9FDUxGL3qQ6z4qFhL7E9yfCnGoNWnDKUbG	4594	6466	6466	1617103080000
8871	3NK81tU6YwSoxXaKPBZnEePXbH6ac2R7zE7NrSsk35FEdemRMvzB	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1534	1071	106	1	6301	jxvB6gpq2dkkKPPDKuiYmzjBqytAyz1gcw3yoZ2DPvvgbykTRSf	4597	6470	6470	1617103800000
8880	3NL9fZ58peZFbmPg4ratUYCNwoVGKM6m4yjH9Jbb2sUzdkw1Wh8q	8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	1601	1262	106	1	6301	jxegeWjZciW8ZkXLWVbDSzXkr61F1zfJNA2F8Hb37BNBANY1W9Z	4600	6476	6476	1617104880000
8883	3NKWApscVy96omguUENX8Bk7LdTEMJSb1dFkNbx3KRmE5ik2DvLd	8882	3NK4kCuEQ5muQRENjWjfoSiEYvrQnHbK2eGCCrBtgY3EcHMW9MYb	1610	1314	106	1	6301	jwhu6eFGSv3WxBjVsvWAxBW68wBeDQhABkzH1QbVwL2bUj9Ehtd	4602	6480	6480	1617105600000
8887	3NLwcsvShfiEKNEECngsYuVk9jm7fGKbXzLeUckfBJ47ivZ5FGRY	8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	1406	1393	106	1	6301	jx8DXoz98rPRGea8PtyKBiGw2XYrxqe1Armpk23RznjfSbkZBKV	4606	6487	6487	1617106860000
8889	3NKivWqE5eE2CzvFgeKem9pkB2rykp7HyvHvbwCqGsMQmA3qipsB	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1599	1161	106	1	6301	jwnHfo2MgqMw4aTG3FbNp7Mj8wB2BYExNnneU6eKfG3nLUB9K86	4607	6488	6488	1617107040000
8892	3NKWhtb99sPpQhZpX22ounhN5AiaBWCZzyfQCY8YKQwRtbqL4XQf	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	563	1359	106	1	6301	jwJ2oisnU7JYNvnmuVR5t6RhNL2ctW5vJgD1wRdcRU65oTHWFqp	4607	6488	6488	1617107040000
8896	3NKxDfYYJBAHzDexNc3JY4jMHVXz1k76VHyvupAspzxTbRyLv1je	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	448	1179	107	1	6301	jxeD935YnKXEQfFK8CmUctBWCT1SvEu16ejdRLTxKSD8CtsmkTB	4610	6492	6492	1617107760000
8901	3NL1PvRdCEUdpmfKvK8SZzUdibKKL4PrVAvy2h1Apwot2S29sC9R	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1403	824	107	1	6301	jxsW3gg4EK2ZfNxW5sSEQPomDRsewmBVT5NDDcgrNGxK7e9YdSQ	4611	6493	6493	1617107940000
8904	3NKCFnpohdC5iS353GiC8Wk9W2SeboHgC3zLF76fuVE7dQ64YV1N	8898	3NLruKxd2ed7UpoquTQW9b51V4MXyitYP5Rnw8Uti8Fj2JtwMZmw	1405	867	107	1	6301	jxTL1eLuEQEWJYHHNXJb1LRWwADEnYBfKGmPgJ9WbR6DAC31GA1	4611	6493	6493	1617107940000
8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	8911	3NKgYk59NL5t9JGriXEWU6QvMXg6U8c2sUZfcsUYrTPv9Aon3eNt	1536	1187	107	1	6301	jxsS4gFqgaJh6dg5MseN1JDC7kyskR7qr7Ds4dYeeDjJ5NgPmMz	4618	6503	6503	1617109740000
8918	3NKHxv7B25mCq7RazxyqDferyMvNunD2zqK8Dk1gha4dAFH1oH7p	8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	1642	1367	107	1	6301	jwXiiDbktvtxi2ppymkKsfFNR4obw8rCoXGCVBJ2NxBhQFBCRWe	4621	6507	6507	1617110460000
8920	3NKAsU6cGoQtVW9WV7Q128ik9N1BQvXPKq9qFpervd7p2F423CJe	8918	3NKHxv7B25mCq7RazxyqDferyMvNunD2zqK8Dk1gha4dAFH1oH7p	684	1352	107	1	6301	jxewLKuQ2oXSuDhNiVNACU6QBbRjV3rpHU2Lyzj8UrqjufZM6Ev	4622	6508	6508	1617110640000
8930	3NKPen8PWGwboGohB6hx18P3KMDaRbf69M2ThWs7uj4tCxLmPRPN	8929	3NKBc2E6fdGfUP5z3ZRTBQta8kUWeQWSpwcpwFYyXK4rDKYFDy9Z	1668	1124	107	1	6301	jxXHfRPtkHx56SFqpjHhYopzZb6iJ8vf8EFenU4BPZMZ5dYBT9L	4629	6516	6516	1617112080000
8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	1541	1172	107	1	6301	jw9dm58rgttat8GMU1A6j7oH5r9G4Zcm7ct5x56uj6oTCAk2z8h	4632	6521	6521	1617112980000
8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	8940	3NKhdjkkmTBwVeD68RtWkHrqcLSUtRdYSdY2rxpnFDwnhaLAbGvH	1559	987	108	1	6301	jx7KbRWdCsxamM9S59cDT1xd9ck1HYaGwiPKfFLTQNriFnr8ksi	4637	6527	6527	1617114060000
8816	3NKrJ2s9cd3Kgsk84yUmmCfi5PgvtFr7FqGC8VDjBJUfTo6G4Hke	8790	3NLQBPSRwPHqsDkoQoKD1bJdtxob51K5Fqa223EqsnsA1EH3CJ6D	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4425	6436	6436	1617097680000
8819	3NLqsG6RsMnkiggR6ctbM2bshM3g5v2KRBjnuQwcRpzdYtA4wiMZ	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1406	1393	105	1	6301	jxBmr7ttkL6qdeFzRpPE85YUky1GASF9eNkYN6KShtH27bHRpVa	4572	6437	6437	1617097860000
8824	3NLbHBEwCALb6Sx75jsh4KcTbX6MYeBfXsnQJVNFphV92hH95LP5	8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	1602	1369	105	1	6301	jx8o8egt5xyysFpWqej9cYDQxfaUZr1WdNuS97PUkRGo3A99wXY	4575	6441	6441	1617098580000
8827	3NKD97hStEo7637Vyc6SQv4s7qmvePMhrdfEap6ZPjre8p8psiuU	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1474	1083	105	1	6301	jwhQifujY2KdUsmREdrJVNz9N3p6nQAAaUzb1byJPjeVZUsd3mB	4577	6445	6445	1617099300000
8831	3NKCXFDY4UhL78xPmSgkfkGQJHv7Zs8sr8nog3XRmWzYGsZSVr9L	8829	3NKUB54hJZg5QDrKzYAVeHMBnVLjw5de6T7wzFpGPGjJHdXJnc4b	632	1256	105	1	6301	jx5HbiviBL2CJ8NGau9wypwukr2gyruUWBK6TZsynVJeofCeBPD	4578	6446	6446	1617099480000
8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	8831	3NKCXFDY4UhL78xPmSgkfkGQJHv7Zs8sr8nog3XRmWzYGsZSVr9L	1611	1341	105	1	6301	jxVQGU8rz8HMMdNTdwBbtugq8nUGrmpSURNjSnU9aDNdKfYFBXv	4579	6448	6448	1617099840000
8840	3NKfBaTtuvrrboWQuUdbnWAkjqPr5oNuVB4uNsTnHigg6FYDErkZ	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	1631	794	106	1	6301	jwbcyPZ5vMCWWDiQNfQv2N28ryzrNcfFT9fNVRKVCfWYN4vJ7zP	4582	6452	6452	1617100560000
8843	3NKfC39jLr7WfMSuUzz2tcifFUqYgPBFsus5r1Gvay3xxyPGmdg6	8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	1633	1144	106	1	6301	jwueruUNd8RXw2Q3kf4qVawyLJE19Jv6h6vA53LAwx763CvVYJX	4583	6455	6455	1617101100000
8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	8846	3NLHHhzVhhStsS1gtXKbyys1hHd8wGca5GLqBBnopWkbJaM2kC6t	1607	577	106	1	6301	jxdDxA2bY5XLrBfS7pRAuJnXCEpc3WJy4jp8i6k8iCJCFqmCBen	4585	6457	6457	1617101460000
8850	3NLTaTv6CAR7fLBFDQJ5ciEn5UdFkm6CepuA7APKmr8KLKBMU8Mj	8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	606	1049	106	1	6301	jwnVLkDdsWcUe6LVR3GddVV7hfWjMejSvs6AZgHSTCSVEvEfuR7	4586	6458	6458	1617101640000
8854	3NKnfdXHDcYY8fDx5kSRPeQBzHs8UzHSRZKmRfNix14ajdYq15hk	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1407	1395	106	1	6301	jwH4gd3ZPrFuYXRQQwpC7qqHFuNz8o31yyRhAK7Mf9k5YKeSAiz	4587	6459	6459	1617101820000
8857	3NKU3DMXojtMadWYH2btHYZpiSnZH2wGNUzD2KJG2FjvEpFkizNn	8856	3NLWswRAkdYmmYudoHcP8NnYEXeyeK1xBTDgRD3CUnM2hJAuhPfM	1581	778	106	1	6301	jxmxPiF2UxeQLUEP9u33mWjsXXG6mqRmeSvQuzUkE784r9gNL3F	4589	6461	6461	1617102180000
8862	3NLUyaKPNt5ENfjW6qiV4cFDNHSBwwjUSc1J8MvRJv3uzFEyLor9	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1403	824	106	1	6301	jxdxGbSU9WU9rCgw2wab8G1ppDdMjew69xEeBKRmZsAnYQBJ8sR	4593	6465	6465	1617102900000
8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	8867	3NLngB4k8LpDqJ3xn3xePWvHYp52L1Hy6oevFoGK6KTngjacYyz6	1407	1395	106	1	6301	jxPLmeK76cUfZA86vnceBVf4e6a7DorRCZoZx6fsnUSydz2LE3j	4596	6469	6469	1617103620000
8878	3NLYnBGxMsUEvzvb3REsBf4jWmwuZdvbNoDMkrTcQXjRDqGiPwux	8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	1529	1316	106	1	6301	jxoYyoprV3F6uUjdRD9fMKfsGSCaLGrnBnQGoue53kcit2DQ5Px	4599	6474	6474	1617104520000
8881	3NLCogj6L9EdCSQQz4SAnPvixxavwhRUJnxTPJjP52rLfijy4py6	8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	243	243	106	1	6301	jxcgQcL4684Uq6fzKq8H5kQsXWiV1BT6NP2SmYuRqWUtUujzmyM	4600	6476	6476	1617104880000
8884	3NKK64XiQ49VkKPFoWqzaahQFCFT5xxD4XYygFa6PYqWfnDEUgRU	8883	3NKWApscVy96omguUENX8Bk7LdTEMJSb1dFkNbx3KRmE5ik2DvLd	484	1319	106	1	6301	jy19MiNBzwEWZ9J9xawEnb5FCDyf76xSirM52nBrwv36oX39Avi	4603	6481	6481	1617105780000
8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	1637	815	106	1	6301	jxmf9m1Vvod59kxpVtDfBFHq4Qd8uoGzKoZjBL499gmDRx4fEBY	4606	6487	6487	1617106860000
8890	3NKKsTDv56kRbaPJi2g9xGB3mCxi2GR7sx9y9cr1sswbs4dcTqKY	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	563	1359	106	1	6301	jwXq7JTsE9NbTEfoRZk7oQMAH9XBayzvStRz2JJeaT2Rv4iABQ4	4607	6488	6488	1617107040000
8893	3NKQXSu1TRUocWuSoFS8zqf1RZ1xnquPYaMQjNcb28FYvzsNF9wE	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1631	794	106	1	6301	jx9rHZr7ZTRaoFuNgEa1ShCKQuLXpaaG4ReKYmVwLWYPZgpXPqd	4607	6488	6488	1617107040000
8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	8893	3NKQXSu1TRUocWuSoFS8zqf1RZ1xnquPYaMQjNcb28FYvzsNF9wE	1673	1368	106	1	6301	jwP9FtjhryvhVU21M51SjXCjMwBR7g7GDbJtw9kKNbuAF1f6X3p	4608	6489	6489	1617107220000
8897	3NK45fEMgv5diUhc3KjsYZR9KQ5iCdTGu4U676ZaBVijcMXZJwaS	8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	448	1179	107	1	6301	jxbsEq2dFcg3xnVKoS6DfkrGPZvmWGbNC8cYqksMWUZSNm1xCpc	4609	6492	6492	1617107760000
8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	171	1128	107	1	6301	jx2zWg36VrE1dyDQP6UMrNnumhwXxjgkH9NjZqhMvmVoCWXmX6k	4610	6492	6492	1617107760000
8902	3NKJmrjKztQCmSEUSgmAWAAbxgUwC723p6sEaZh35gsVbZifHpRc	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1523	1075	107	1	6301	jwAerTT5ivvgc8JnqXJxskPyTXM1JFRAzM1zvdqMq6g3VZQQ4Ms	4611	6493	6493	1617107940000
8905	3NLUL8Tx8SkATp2VjgkpPnvB9ubxBrKSdBAvqgDbVusAd3b3D6fp	8901	3NL1PvRdCEUdpmfKvK8SZzUdibKKL4PrVAvy2h1Apwot2S29sC9R	1406	1393	107	1	6301	jxgNdv1zJupB9qXdS8HsPkjerZ7L5dJpWnDbeAnCZ3zz4mBh9Hq	4612	6494	6494	1617108120000
8908	3NLiiKb8HPixWmx6PKuvD8CMJmUYJBf1GwoLtS1N1ac9HogWkNNK	8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	1407	1395	107	1	6301	jwvG947aUUyu37g8nWtfVvQ4icWc8tgoLGGj4V4ruofEapviBqb	4615	6498	6498	1617108840000
8911	3NKgYk59NL5t9JGriXEWU6QvMXg6U8c2sUZfcsUYrTPv9Aon3eNt	8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	1403	786	107	1	6301	jxeveDP2z8wKRW51icVNSgXen6V19AL6DySabpMiGQ9rxagr6YM	4617	6502	6502	1617109560000
8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	1509	1320	107	1	6301	jwH2RcJ6Ns8Jo9JHnLCnpD3tXVQkcYp8xdcRMjwMX5a2PbZmMPt	4620	6506	6506	1617110280000
8921	3NKU3N5bvAzfp2Z2YtwMRxpwWUSGzTS8XFhDAYF8ENKBgjoB2Tbf	8920	3NKAsU6cGoQtVW9WV7Q128ik9N1BQvXPKq9qFpervd7p2F423CJe	1406	1393	107	1	6301	jwDqodr4tdCKei5Dhq9EuKPfdtWKuGCrsdq1vCCW7trFnPTbzCG	4623	6510	6510	1617111000000
8926	3NKTQrGcptGgqwCYXxaoeUV8q4BKccnoRv5hnbJH8yjaFSFdZYkr	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1406	1393	107	1	6301	jwrmHsdwxVujCS2HT4n7SbrGGYztuxFrPdamj4qaAs5vSg4r6k9	4627	6514	6514	1617111720000
8931	3NKfgSktufykC5FKbcqTmZhCLEu4DLPWq6TSdyeEBU6kMfGDXrra	8930	3NKPen8PWGwboGohB6hx18P3KMDaRbf69M2ThWs7uj4tCxLmPRPN	1406	1393	107	1	6301	jwB4gsApPx4fWYgkX4Hk3h2MQ2NabQFicuGW24MuRzEgeUgkV5q	4630	6518	6518	1617112440000
8936	3NLYVJ78MnwjeptHJtRQFcH7HrP8JdLnJEFaPoM7WZsNbzVfsmtu	8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	1672	1159	107	1	6301	jwxLES9hbd1VpFwEGHxT5kNdaBaNXSjRjVCW9XEcKUvn5LJQ1x3	4633	6522	6522	1617113160000
8860	3NKTrBjC5K17wZK2nBVUCneaeP56TsURB2WXapa7nJv6MotavcYZ	8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	415	415	106	1	6301	jxpRG9dq4E9J9t9saN9wzs9Z9e7USd9X3zAyWfhjn2JxmS8TH2F	4592	6464	6464	1617102720000
8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1406	1393	106	1	6301	jwqLTLkoEDiEXWJqNQDL5ANZfWsqPcx4wEQYzhLQveBBtJCYU5u	4593	6465	6465	1617102900000
8867	3NLngB4k8LpDqJ3xn3xePWvHYp52L1Hy6oevFoGK6KTngjacYyz6	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1474	1083	106	1	6301	jwBeEjP1WRXUzXW5PtqQyiraKbBt8WGHkMhSAt8rk9Go88ZWXJH	4595	6467	6467	1617103260000
8872	3NKwNqMQMdM9uWhUw8FNeWbRGtPVd8MBgvAahNwyW8RjxWhRL62L	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1651	1301	106	1	6301	jxPBrfqah2zXio73apiwnCNnQf4nst5M5KmtUPKzgMoxptvrpnu	4597	6470	6470	1617103800000
8873	3NLQ57ZskB3SwW1yW8qbkanoujiMsrfW6kLczQ7LqFT8wBZWyuqm	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1651	1301	106	1	6301	jx2nVCEZMCCWeYENHE1busFKCEJjB5GqbdwK76SKbBKQhpJ11sk	4597	6470	6470	1617103800000
8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	8873	3NLQ57ZskB3SwW1yW8qbkanoujiMsrfW6kLczQ7LqFT8wBZWyuqm	1619	909	106	1	6301	jxWYuouKYupSJeRXoZ4fyu3Y4Z9qkqQWrqCG59DL8bE8YaYJpEq	4598	6471	6471	1617103980000
8876	3NKmD3KDk1Gd3kLfheMpqzT5PbmdiznVQAupc7EpDsYeDhvh7spo	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1623	830	106	1	6301	jxbpcUHmhbDDyvoDpdmftAf7Y9AKRMqwzPTRX2uZTRmbs5wN7Dh	4595	6472	6472	1617104160000
8891	3NL1ZifYLWdrfxFrvY4dnNL7FBzEx9vAEdtd4sErUksY42AYiPDQ	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1516	1294	106	1	6301	jx3ytfvpg1XqTHwpNvPmiNbmhJoKkgZd21kvRG27GfY1mRe9nmF	4607	6488	6488	1617107040000
8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	1631	794	107	1	6301	jxu1nB1EDAKgwN9zVxfJA4wDtBcD2KZWi6GfzZxY577haL4buGM	4609	6490	6490	1617107400000
8898	3NLruKxd2ed7UpoquTQW9b51V4MXyitYP5Rnw8Uti8Fj2JtwMZmw	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	448	1179	107	1	6301	jwLwSEYVbN7t16T6r9MqxhkgB4ZXN9JMsg3LzYDA2KD4C5ZAhQj	4610	6492	6492	1617107760000
8903	3NL2YLXoRx4CUqwrYLHriZ6cRSw3f8MiAdjJCd991eNTV8SEgYoE	8897	3NK45fEMgv5diUhc3KjsYZR9KQ5iCdTGu4U676ZaBVijcMXZJwaS	1523	1075	107	1	6301	jxkyE5nWb9k3rTp3YfFoDLgjeqWsCVKvE5UG6d4P1s3wXBZYAXQ	4610	6493	6493	1617107940000
8906	3NK7pGuKToBXXQPxzodecKFFqQxFoJ5hT3HnDZAMoEi8ik78237V	8905	3NLUL8Tx8SkATp2VjgkpPnvB9ubxBrKSdBAvqgDbVusAd3b3D6fp	1455	1332	107	1	6301	jwkExVVipygFvst3ejhBLSm3eBrjXYS1vyQGDthMdCyJtuk6vZZ	4613	6495	6495	1617108300000
8909	3NLdPfKzT4fSjMijmrZf6dEuF23JQwbHzgsXogZrwaZEoCNfnF8m	8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	532	937	107	1	6301	jwgQpEEDeKHAJXuMS1Dx8h5LiFgAVux7a4vFBvfsmFKDeGd2HMV	4615	6498	6498	1617108840000
8912	3NKmnxKiszuPBrBf2VA3VtVLxqy2KLaGrHDgjBaeYzZcLgJwbBq5	8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	42	1235	107	1	6301	jxkcPqpNSCr965ckZf2Z8ujmkBS8YCy2uvRTSYXoUeX13JB1U3z	4617	6502	6502	1617109560000
8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	1642	1367	107	1	6301	jxPvMzyS4AGMPsTaBUBMQnGAAw9W2ofke32UFVNHRxewk6AXESa	4619	6504	6504	1617109920000
8917	3NK7DyHrdooFbe6KPeWdoLEi2kmw4C7nNKLfqVtTNYLtD4pTmdPa	8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	1619	1149	107	1	6301	jxkvirj3gHJMYKZuBFfdQ1gbgdg8WLYEh1UGKbTEz4U4Qhaztdz	4620	6506	6506	1617110280000
8919	3NLS8M49zoqALNeBjRHGawfZzeMsJVQBP4FPE7rf5iSySMzUngCT	8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	1616	2	107	1	6301	jwaEZVnkqgQVGVZKB9XTAs5xdtWkRcjfGh1T3daYtn9XhaM1XtT	4621	6507	6507	1617110460000
8922	3NKD57zzqx8ifHwHbJjxzNks1nLvox2xvJsnhz373ioEXmdXmmBL	8921	3NKU3N5bvAzfp2Z2YtwMRxpwWUSGzTS8XFhDAYF8ENKBgjoB2Tbf	1516	1048	107	1	6301	jxKfJNyvxRJJkcKuxwZZHwcpmpwsjnDXL4dzvULCBfdNckVGt5m	4624	6511	6511	1617111180000
8924	3NL1s68Qqha5DPf5oR8JCETUcc4p5SMFPikRoAJhgP7mf2kEt2tb	8922	3NKD57zzqx8ifHwHbJjxzNks1nLvox2xvJsnhz373ioEXmdXmmBL	1656	1097	107	1	6301	jw7QS3HpbFft3xgTQcwwiWpgnwcPDJeJvjZXBSZcu4uQouhutjE	4625	6512	6512	1617111360000
8927	3NKXQKrp6fj8F8V4JyWhVe9pe5DdcyuhDqHc7KBLVthVzFKNNjqF	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1634	965	107	1	6301	jy1fvHRvt5xYGVGf6HsJCiX6xGrYYbb3rRGZsu1yL3SHTzcpj2B	4627	6514	6514	1617111720000
8929	3NKBc2E6fdGfUP5z3ZRTBQta8kUWeQWSpwcpwFYyXK4rDKYFDy9Z	8927	3NKXQKrp6fj8F8V4JyWhVe9pe5DdcyuhDqHc7KBLVthVzFKNNjqF	1419	814	107	1	6301	jwbSwPh9EvZsWkivsQFPDNzxczVMESyoKPh3PkLZPAyxnocqNbj	4628	6515	6515	1617111900000
8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	8931	3NKfgSktufykC5FKbcqTmZhCLEu4DLPWq6TSdyeEBU6kMfGDXrra	596	1306	107	1	6301	jx1hgEGr6dbu2ffg8uBBHFPbLN9GrhD2swyLSso7U5PoNsgDvtR	4631	6519	6519	1617112620000
8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	8936	3NLYVJ78MnwjeptHJtRQFcH7HrP8JdLnJEFaPoM7WZsNbzVfsmtu	1648	918	107	1	6301	jxNfmBwZUv8TkqpG44ahgQ86ZrAJS1EkUqch1QfyfUYD4qh1JU1	4634	6523	6523	1617113340000
8942	3NLRPkDcbFUcYdU9QtMDfgRK7inaXUSjViZLjvavZ65JoTAemriS	8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	80	1147	108	1	6301	jxQZzAnzMJDoZqnb5gfXtQy81kMTSxAYL9jZ3gFBRf23DLm5wge	4638	6528	6528	1617114240000
8945	3NKKTMLvDwY3iZQc6AKW4MvCAsQHMQTQvM6oAgCkSxjGh2ERcffc	8923	3NKbWwN4mzn9F15DnhF7LeDHV3JwbFLx8UXoCzmcRjbsoVmV7Bmk	1623	830	106	1	6301	jxevLF9tWDk3zAPcwsdcRFPEPxiQJi8LJvRaQXZTLJT4jYryUtu	4597	6529	6529	1617114420000
8947	3NL6PYs8mr6TdQcwaK2zQFKyBqQGuSEVH4Qayy2AmDJ4Ms7sa5uN	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1406	1393	108	1	6301	jxDBuvNWC4ZzhpM4B6T6UM2rnDqcy2ACtwU4NbBMazb3w7Zx5fm	4640	6531	6531	1617114780000
8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	8951	3NLxnrpXdUbiGQZJD57jqV44YgnUjEzMWyLP8UiotjtH2YqzURMJ	1406	1393	108	1	6301	jxf9PmaNRakY55wixdWzsnCSbscNwVxqTD9TJEs2nzxB6ynNQYg	4643	6534	6534	1617115320000
8955	3NLP4mKSBojXaRdM1i5rSdXaHx7E6gbyeJ28bD2Evkf4eeQ3GNbT	8945	3NKKTMLvDwY3iZQc6AKW4MvCAsQHMQTQvM6oAgCkSxjGh2ERcffc	1623	829	106	1	6301	jx4Y98WsUQQvBE9b6NrDy7WaDbTBAnxr26vFAd8yvLpcYwZb2SH	4598	6536	6536	1617115680000
8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	1500	1051	108	1	6301	jxR4SCLnT6A8fVkwtvtGXo5Cr7QXDnWAAec398iey4Cy2UMUXL8	4645	6538	6538	1617116040000
8962	3NKanyvpY4jEoGvwcNxc1m5CoTpcZ6VDwAn5Ad2eRByAYHky5DY9	8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	1402	874	108	1	6301	jy2tH8WXbb1KUQ1MMcYq6RwNif9vufFyzLXTpJ3uSmpYQkGi7J3	4647	6541	6541	1617116580000
8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	8964	3NLwCEKa3ZULLUuVAcijcsFe9ok5b5vh3AAq9p8XoH4qmsj2SGPy	1407	1395	108	1	6301	jwphH1TUPJ2zWQgiG2qxhbvyXbYWU79AvbrZ2PP5gfxaE8vbkht	4650	6545	6545	1617117300000
8968	3NKGHW5Eky38Pjbu1h9uZNkwwvr9c8EysGMKDqSyAPkm2UR9PZR5	8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	1596	1237	108	1	6301	jwGSYPWuX2nK6LU9z8DQbURom6HTeHDcr7hyZHXdeB8P2EHFXg2	4651	6547	6547	1617117660000
8928	3NLCxPuWfQsLFda7J2Ne4SXtTs5FvaStDGVCzc7cm1d62ub716UU	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1643	1299	107	1	6301	jweq1sFMKUtPWrqFSUSbZZbJ95e8n3EKbPmv4P4U6KTBEsyvdir	4627	6514	6514	1617111720000
8933	3NKVJNfo5SByUSBtRoGwkL2Q3Riuw76aZSrC6XEgYwzt13S8XPVD	8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	1602	1003	107	1	6301	jxuycDXZ9HXzHAmewSp8SLaWgzXHyBSxbodtjuK1yStSF9RjBUe	4632	6521	6521	1617112980000
8935	3NKh68dzi8x4ekAaMeRxhU2vfQ4mfp2jehA2BuRJJCjBErdMY8vu	8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	1407	1395	107	1	6301	jwviU35S3i3RZqSQ1BHsQVwwf4y2vf9rsSxPJmNR2RpQzxtFrc5	4633	6522	6522	1617113160000
8938	3NKJBRDCp6HLw4c41ba1fiitqxqrCPkXVBmHS5gRmjkT7mFSpuEh	8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	1549	1116	107	1	6301	jxeAfQGzv8zygJbBP57pYtbXxkZ84MWj8keZyiRGGW22xDokKND	4635	6525	6525	1617113700000
8940	3NKhdjkkmTBwVeD68RtWkHrqcLSUtRdYSdY2rxpnFDwnhaLAbGvH	8938	3NKJBRDCp6HLw4c41ba1fiitqxqrCPkXVBmHS5gRmjkT7mFSpuEh	43	43	107	1	6301	jx37ags31UMf9aUn2yLnQr8K4QrCVkCqKApWmCNvmfKL3cuxhvB	4636	6526	6526	1617113880000
8943	3NLyFpbYwfoRGuEMsELaMrwAwNjPeMzsKo8iyFTcgYmN5pkEsC77	8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	1509	1320	108	1	6301	jwB8YM1qdXeWAzdqhb4CPLvxvri6rtGy2Pb3bwMaQmYfNKbvAoG	4638	6528	6528	1617114240000
8950	3NKf6qzwGVuW7sYLhQzMzcxrbBeasQQBAipwShnRwWwQHYTMbXjS	8947	3NL6PYs8mr6TdQcwaK2zQFKyBqQGuSEVH4Qayy2AmDJ4Ms7sa5uN	1599	1161	108	1	6301	jwJbaAzdkQwjqFrCYPSbMABRS16rf8jp3ZJr8jX5urncCGPu4hv	4641	6532	6532	1617114960000
8953	3NKMKCm94qynEx3C92HTMR4UTbm1mXBAjd6c82wftgxLM2dvg2Ab	8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	1608	1163	108	1	6301	jwqt151wuHZhbLYv9bhoTAMwPWxYdpoZ3dJ1Q2toiYTKcLGm64z	4644	6536	6536	1617115680000
8958	3NLxSwKr9J4RLYsprwfnjzZA48L2GwNyuEZhhwyGoT9J5cDmLtdd	8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	1500	1051	105	1	6301	jxVE5XRfrF4ALssbkCgFaex3TXP5UTeAkt8hL1MSUmSKTfMLCDM	4569	6538	6538	1617116040000
8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	1648	1284	108	1	6301	jxBievWAn7xmcPYMyhgXoGq1he86jtaVfF3PN4ZKercLFDbnNRM	4646	6540	6540	1617116400000
8974	3NKCmhFkzQtxHt8UPXEn2jbXmz6N8N4m53YuJsvMCh6cNGrKmrW9	8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	1673	1368	108	1	6301	jx3jFpdppSgwKKjceUE8bFPjF2D27KJdBmkmMrt6TC8AX33fWBA	4655	6554	6554	1617118920000
8976	3NLnyLqnH8B3oiydi6VCY2oBgXCCs6k4edYwGf9VoHBBJ5ZQyUZm	8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	1527	1293	108	1	6301	jxYsx8h8LMXQknzrEq8VKXWuap7DPjjuCNNqAmHygRFX79GnMn7	4656	6555	6555	1617119100000
8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	8976	3NLnyLqnH8B3oiydi6VCY2oBgXCCs6k4edYwGf9VoHBBJ5ZQyUZm	64	64	108	1	6301	jwtSyR11oLVNdqHHtgtN7zcEh1otfvKdrBKfgXF2JJSCywjKPbW	4657	6556	6556	1617119280000
8981	3NLCWDixL2zgPhR2mCtDz4DEEi4VtuJu8yJFQ6FQvWM3umqN4qmh	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1631	794	108	1	6301	jwknpx6QG7L7LDAum6nNAgQvev831Dh6cEU9iBMxemuAMSbGLC6	4658	6557	6557	1617119460000
8983	3NLmQRCb1SVc21rQ9ftPiven4GtgMyWkLguRjbUaxgoqzLrVpD5J	8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	298	1308	108	1	6301	jwcjCBN1V8x8CxHbqVB1bajSa2h1MoKSUNQX53jqDLQQmhgEomV	4659	6558	6558	1617119640000
8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	1405	883	108	1	6301	jxYUPpbAfJ1yfBCbucRvP1HNMgDM73bXy4nuS9dEuNvz81T9CaU	4660	6559	6559	1617119820000
8988	3NKwLxmMma8pEFasWhWMPqDAdN3QLNdJmVxDdn8uvXKzVxD1KPnU	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1647	1302	108	1	6301	jxAxpSQXwSvQXCPmELynucjqsK57YnKcaXvkQw4ijsPFf8Y3BwQ	4661	6561	6561	1617120180000
8990	3NLGL4a3sN1tnFXV1GUxCSwpGNHuH7WXhvxam9y8uoLHWPoiuavh	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1647	1302	108	1	6301	jx2o3zVAJx3roCT1CGnt1dzEGhGqeVatp91Wmhi4gPb2rdnozaG	4661	6561	6561	1617120180000
8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	1460	629	109	1	6301	jwipPcUpBK7YpwWERV5hBEMq9FV3HdnXj7qB785tFeWQG6Rxs5e	4664	6565	6565	1617120900000
8998	3NKbpL6tpRST7L8sm72kBLc7AAFoNd6vtuAd3axYmqCs8HCZYJM8	8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	1406	1393	109	1	6301	jwZYEaKxGLQYRQDbboUyHHYxSkGpbXE8EDuDrPFvzKiR8csV9oF	4665	6568	6568	1617121440000
9005	3NKwFUX6XVvf9jM8N7JwmqHSkr1SSY72ujQjNSL9AKf2pNSBuQ7h	9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	1407	1395	109	1	6301	jxPASnV4BrTHMaAoQS9FhCrQQwJTowaGEy2UivKB9AmH1Rtr8Hb	4668	6572	6572	1617122160000
9010	3NKuFmokKaMWNdKdER2WLYHhpEpkKAocAqRd2Lyx58LuPphZVGNR	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1642	1121	109	1	6301	jxADyJ1waVYDmpa78PMqHrgenwvr5deAzvoh15U9cmZ1DKDdJKN	4670	6575	6575	1617122700000
9017	3NKnCC17nhr7nYv2G1oyw46tovbpGx14HidLDoAE262Q8u4R6yw5	9016	3NLSis826uTJxkWYYFrjpSP58W8bz9UxUiRPhzmo1kmpfris673n	1546	1093	109	1	6301	jxA1bkmXYy249RgYm78Cknmqb9muuBrZBe3YjHNJMUjJeQjQm1H	4675	6582	6582	1617123960000
9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	1407	1395	109	1	6301	jwJH3CTuDysmPiMpugtq46EGnvJZ4CmoMncQtUDeY2KpytvkeGH	4678	6586	6586	1617124680000
9025	3NKn8KQqgX5A33ZAsoDnaiFkgH9jcvM9rcSWkAUsVoBUdYLbrQZe	9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	1403	824	109	1	6301	jwv7e1X5vm6NmhnGH5k9eKgJUsYQrKAvLtWtHTXorizQ3sknhhj	4680	6589	6589	1617125220000
9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	1579	1023	109	1	6301	jxPa3BEJ94PmkJRkWesFMP7D8smqXGDXKuJTBQxAggzKJnxwa4N	4681	6590	6590	1617125400000
9030	3NLJSR7fH3zfJTQY6qZ89yzuungkr83ZitoooRYjXwM2bzxH62FS	9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	1460	1198	109	1	6301	jxQPneMnZChDebKUM2v9J48UEGp1Wvohk2XAZ28YMDodDhnrRqh	4682	6591	6591	1617125580000
9032	3NLq5QJXM5nNpw7JSir8asS944vzGmTkuW6rY2yFfNJtuXHeJeYn	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	1549	1116	109	1	6301	jxANxwEJptiJ7nsa5a6Jso9Lcp5B5uWvTbztLC63UyP1HqY8BVq	4683	6592	6592	1617125760000
9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	9032	3NLq5QJXM5nNpw7JSir8asS944vzGmTkuW6rY2yFfNJtuXHeJeYn	1670	916	109	1	6301	jwhjsCbAd6qVPzRMTCW44Zf9MjPGeegZBLNQpYwcHVXD2wGc6D6	4684	6594	6594	1617126120000
9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	1673	1122	110	1	6301	jwfihkFcGM8pXMRXbKGKvqyRuhHYqKn1jGqe31oXx4cJvv8nvp6	4687	6597	6597	1617126660000
9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1406	1393	110	1	6301	jx4JYTCcKAUCThXZ3tVuKmbPuMxHaSFXZJFs6Nn6445QgW4UqvK	4689	6600	6600	1617127200000
9046	3NLgC5Narzcb1gj5FmLSbX244jw8s5VqmivEhuz1K1s2XtPciC8o	9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	1406	1393	110	1	6301	jxo8V4b81MkXbXTptrNzgBLMPfrgHPHLiBs6tcmsMFwMEs7qdzF	4690	6602	6602	1617127560000
8939	3NKVtq4EjQecqEZNKfuD83B9ANLNM4nJomfZLVxUgdTHtLE4HBB7	8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	149	1283	107	1	6301	jwv4u4iZ4PYuxN6TZbLgS3ADwBMYzPrPgaP2MsWaxPXxWPRLo4x	4635	6525	6525	1617113700000
8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	8942	3NLRPkDcbFUcYdU9QtMDfgRK7inaXUSjViZLjvavZ65JoTAemriS	532	1057	108	1	6301	jwyC2XtcpBUeDi8Cd4JzUt72rDu8CLTet2SoUs9vnGikzx6nFJj	4639	6529	6529	1617114420000
8949	3NLgHZBoxMn9YtPu2Xpb6hVS2VfrvHVnCnHuRruutNi1oyZPRwCj	8816	3NKrJ2s9cd3Kgsk84yUmmCfi5PgvtFr7FqGC8VDjBJUfTo6G4Hke	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4426	6532	6532	1617114960000
8959	3NLS5zq5CEJSENHi1EnApJBCg9GYArcZN5mMfvyMGvdnTUomB46b	8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	1407	1395	108	1	6301	jx4hLfqhu4RFkouNcYcgg76pFkEjotvumPB57mK5rpSgwN5YSSV	4646	6540	6540	1617116400000
8964	3NLwCEKa3ZULLUuVAcijcsFe9ok5b5vh3AAq9p8XoH4qmsj2SGPy	8963	3NKREMpCxKCJd2DL1XtnfMxsg6Bzrwo4WeEaAjwQUCXt4bPqBp7E	1406	1393	108	1	6301	jy3Aumdm6uP4HRV2T6sNT7UrSDTbpVNZpKVmFwVkNKBZmeTq6Gf	4649	6544	6544	1617117120000
8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	1649	1383	108	1	6301	jwHAMXvKSYQTWsGRbJ9JbgcrgfbASy1xrmmpw4LocprJaVaC3JZ	4651	6547	6547	1617117660000
8984	3NLesnc8oGHi7YXGrZVJ5HELqHX42ynUj1MD3fU55vyw736aHQSZ	8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	1406	1393	108	1	6301	jxEdnDWJYocVT1kdcLnJKsGbix5XeUbzkBQthEDJPHFQvnNPEep	4660	6559	6559	1617119820000
8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	1407	1395	109	1	6301	jxvipsKQ2XmfufXXuhXigNEma3aVHxgWqqrr75QHSKyNhXsQ3j8	4663	6563	6563	1617120540000
8996	3NKzZdkWsGbmDfdTg3TU1JwmmimDwtJg14aJ4FR54WyDM2UhkhZD	8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	1599	1041	109	1	6301	jwaXeJirbZxRe56SC2mhqNF3kg7d5ZdKo96DH3KsELECGbnuNWD	4664	6565	6565	1617120900000
9001	3NKHTw76NifWpA6Nq3GErpvwYfYWgASgeG1wfURPheHSboybfLt5	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1455	1086	109	1	6301	jxmHKNnuZERjMKrMyJiHjVUfYGfyd4ui6v2nCHxpRCjNKzixS9x	4667	6571	6571	1617121980000
9008	3NKG9iwc7B6VzgDjmsHdEtooZAQTX9f3soYumitERjBkAg6U81Mo	8949	3NLgHZBoxMn9YtPu2Xpb6hVS2VfrvHVnCnHuRruutNi1oyZPRwCj	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4427	6575	6575	1617122700000
9012	3NLFxvE9nm4BhTgzou3prLEGLSthd3HiSrSnbCmpMmifLJr2L3KW	9010	3NKuFmokKaMWNdKdER2WLYHhpEpkKAocAqRd2Lyx58LuPphZVGNR	1608	1289	109	1	6301	jwZoh14Bwv6bN4UkkJ1VENaRcRi6XKfMzhQSNQCPrjrQp5d2h4r	4671	6576	6576	1617122880000
9015	3NLCRAjwWwjAght6jj8MAdh8LxudDJvF7sjzJSS7JsJpnxJPDMNY	9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	1406	1393	109	1	6301	jxKqnetXjyUtsG1b4DURhUohpaT6RxD9PmqHe48oYahwA6bH3DF	4674	6580	6580	1617123600000
9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	9017	3NKnCC17nhr7nYv2G1oyw46tovbpGx14HidLDoAE262Q8u4R6yw5	1532	253	109	1	6301	jxBc84w8XZQ9rTrqVZdsnMkBFJ8GWa6jy2wbh1SX68YK8d8bA2K	4676	6584	6584	1617124320000
9021	3NL8Zkq1AzMb64V4K2Sp7VCV71HqomkRquQQFNwwbqVbFpHG6KWC	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1657	1344	109	1	6301	jxPqCxgQCcynzNbMCQxomGfDLsoQRBR7tHuGKTrECtyHWbYZ82L	4677	6585	6585	1617124500000
9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	1460	625	109	1	6301	jwSAAWervJdrZ9Tb6keVVMtQxDhPsRzLxppcdVTTU4rq1U1dk64	4679	6588	6588	1617125040000
9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	1407	1395	109	1	6301	jxdKmTa1dMxNcN2qiFyM4yzYx17B6EsZWLf7ctAe94sRafZzkr1	4680	6589	6589	1617125220000
9028	3NLeFEpkxum2jenVAW4ZNF8nZUv9mg4u7giBFPkxSzNyW6Dxq6Yi	9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	1609	1333	109	1	6301	jxJSgC3bJ2diqVnbbpNU7hAkrwQqPhbkB5Mq7G6Rsap6oFxXV6x	4681	6590	6590	1617125400000
9033	3NL1nSNAiqa3f5FutRSGXGRicMCZ9oDWVM46yvMjaWzEzrJgsUMK	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	171	1374	109	1	6301	jxHJHAoqomovibV3TjHwHNUuncqSUcw2LGYt77wcCPF73me5jeS	4683	6592	6592	1617125760000
9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	1489	1254	109	1	6301	jwrsiKgAzgzqivNsBsxEJQbcyw2dbUCc1rNACpderZC4vLtFbNg	4685	6595	6595	1617126300000
9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	1467	1376	109	1	6301	jwdicamFT1fD5reFd54FzWPuG6tYzC7WFhZgkqL4WJj9J4eSxap	4686	6596	6596	1617126480000
9042	3NLgHWZZ4T9BkrJqg5zQuNd7pnYdTwfMDZ7XS2UgQxkUfs9vemyb	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1542	1178	110	1	6301	jxZwgyD3MgFpNEE5p2Pyvbovo3jbb7fHbPeUmPpLFMfnNLv8RGu	4689	6600	6600	1617127200000
9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	1439	1153	110	1	6301	jx3B7j1sDFy38s4KnZMaJ8uUA1tuwjfNN5qMaTWwEKRizaetR6f	4690	6602	6602	1617127560000
9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1467	1376	110	1	6301	jw8ZxLarRGNTw8bUpuEyAnysVFqj8iqgq1eUHJ2EHTRX3Ryf9Tq	4691	6607	6607	1617128460000
9050	3NLVzpuxqdmB6tTnoH7UqMTWno34Mh6eoR7Yt8xr6aN8AUmVbnSg	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1555	981	110	1	6301	jwrt9Q3NwVGYVMDZmJ39fNX8AeX5YdGVY1A49XQ2tdc1T1tn1E2	4691	6607	6607	1617128460000
9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	1672	1285	110	1	6301	jwTRTSRaTiTW8HEmkGxoCNCMperbPS4FawSNZY2yGnLmBMUAHsw	4692	6608	6608	1617128640000
9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	1402	844	110	1	6301	jxnGrYMfoBE4qUejFFphkZeaN8pJBvALpKhDHq6Lu9C2NVk4Ssv	4693	6609	6609	1617128820000
9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	9055	3NLW55yLAdaaYUN3kfFayqcZMfKAoHQK2ToZBtc9hVBdGMaEbjPQ	1403	31	110	1	6301	jx8LjvYA57WmffSxJ1JBRH6rLdC3nLT7oxrMxA7qWoUg7PyFZHZ	4695	6612	6612	1617129360000
9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	1671	1119	110	1	6301	jwKY2E4n3FmS2JS5mrHQHwnraGs8wuvMzDbwYS38S1ZJBG88zi7	4697	6615	6615	1617129900000
9063	3NLQLGpbdKbdU5HsrNKRjf59NXr6TJkPwu2jbJaBrgCTTcu7NbqS	9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	1403	792	110	1	6301	jxY8xB8bMQy2xaARNpahcQyQzS7QbSnz6cSNzfMSu48FgXg8bdZ	4698	6616	6616	1617130080000
9068	3NKB5T56N1kkjECQGYUSY2xBZZ55uo4hM1hgxJ5voRa5pDRAzw98	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1460	958	110	1	6301	jxL2EsbYtfAc9GLGbt7AjcyVvegv7F27uQiP4GgHgMSgBXyJqgV	4701	6620	6620	1617130800000
9072	3NKCDvQSQnLWsoyu9b5yc3oN9B849y4hAqVpAF1iuHhmLbvuay52	9071	3NLhgXZEKBrxwbwNtMKtxudv8cneipQjvgu1BzZk6xTUXfgFQkH5	1406	1393	110	1	6301	jxyQyErVCvZFAkC1ibx67ppLCBWtAFrjjqBtqNWVfDudeMSJa29	4704	6628	6628	1617132240000
8946	3NKQhA9DQprni2wVsoRw2s51L7xJBfLpZ5M3YDuHP8YLZNL5Pqgx	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1611	1341	108	1	6301	jxTV6PEE6evx4LEab1pjdzSiwRwgGSWkopUrcN3Qep3j2Ti62vE	4640	6530	6530	1617114600000
8948	3NKTdggLxpY1NmGV3UZiT61chYADQna5wxYj2F7i2WrswickZaYz	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1631	794	108	1	6301	jxGuv7amHu3YU1sgnEf5iVYpQMDuswuE5dE8sFC3k9gjiszQrf1	4640	6531	6531	1617114780000
8951	3NLxnrpXdUbiGQZJD57jqV44YgnUjEzMWyLP8UiotjtH2YqzURMJ	8950	3NKf6qzwGVuW7sYLhQzMzcxrbBeasQQBAipwShnRwWwQHYTMbXjS	1406	1393	108	1	6301	jwChdb5XZ55kVDevcgoLkH5xN4q53zAqPovKM3xkbQFJSkT72c2	4642	6533	6533	1617115140000
8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	1407	1395	108	1	6301	jwW4QfymNvLr7LfHdVbNDcYPwA6bZEPowTUEo3kF74RAvsoozzW	4644	6536	6536	1617115680000
8956	3NKynACmrWcqy4pYmYP3awekwefKb6kJBokBeUjbXVHF8YbU3PHD	8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	1407	1395	108	1	6301	jwmK8Weym5RETbr821t1fULW5mcgVyMAapLj4cU8iqxxHJPSUHC	4645	6538	6538	1617116040000
8961	3NKcZS3MjRhHp1YvLN4RcJA8cS4U9vxr19JQPiyHVhVCtU36UHKn	8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	1407	1395	108	1	6301	jxHyAmFcr8d2hCvJKXwEmhZ5QAAU2ePsbym9ycwVPFg4NgKfv1K	4647	6541	6541	1617116580000
8963	3NKREMpCxKCJd2DL1XtnfMxsg6Bzrwo4WeEaAjwQUCXt4bPqBp7E	8962	3NKanyvpY4jEoGvwcNxc1m5CoTpcZ6VDwAn5Ad2eRByAYHky5DY9	1407	1395	108	1	6301	jwoaJFL6DxuMovYEeXDHr8UGw1kLueHx63FtTaUGXhnvJQxU5Sw	4648	6542	6542	1617116760000
8966	3NKFJc1RVLZbm1H7HAjX6qU38y1wAaFZSttSmeukzGPwyxS7WtuA	8955	3NLP4mKSBojXaRdM1i5rSdXaHx7E6gbyeJ28bD2Evkf4eeQ3GNbT	1623	830	106	1	6301	jxFKi9bgqYiFWYoD7B5GPzJbeiN5fkpLmqw1YRSPqZhpFwLuHEr	4599	6546	6546	1617117480000
8969	3NKXdWgyU9rDWAxxGDz7Ns1ZZQdY3ZXNzvXvpXL2PF5VJJXt7B7B	8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	1406	1393	108	1	6301	jxmRwb5nZxD6irZDwqkpFw4MeD7awtdvp9WddzR3fvHWEWFiMAj	4652	6549	6549	1617118020000
8971	3NKDYfcVcoeZJyzCVPKx4jtfSR2eEQcxCrkpbCSaeZEY7FyiWBWg	8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	1439	1033	108	1	6301	jwHc4qCGHCimvfKHnQZeTresfzgo6P3pf3oyEveenbnTyHdUgfu	4653	6550	6550	1617118200000
8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	8971	3NKDYfcVcoeZJyzCVPKx4jtfSR2eEQcxCrkpbCSaeZEY7FyiWBWg	1403	780	108	1	6301	jwF7xnpp6yiq5fA2YEXV2CKEsGAiD5xcLTPmUhTMLtSnxZqPWP5	4654	6553	6553	1617118740000
8977	3NLugJPVUv6TbcMM63xMcdqPZGWABrSuAqMnXYF59XWufSremRxY	8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	1407	1395	108	1	6301	jwGbjk6VLDgiNZ5buoC4Fx4pzCPwZpFpiwKFu76RTnZpBVBPgL7	4656	6555	6555	1617119100000
8979	3NLgiL9gWW6oC1Zwxy4btY7NENYCXR4NaB1hJc4cpfyttF2m8k2D	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1651	1175	108	1	6301	jwLS28JaCh6vfHk1acv4Pk3BiBTuUdu7HZWL5ULt6MDvmo8Sgrf	4658	6557	6557	1617119460000
8986	3NKDMEXqte7R9Aq7MZXCrdiBCq7CRcCiieuLEoSXz2qgmhXYF4Gw	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jwU2o6wSZVSasqz5d1gM7jX5Y1LyYLVbMraom6fJKANAUaTBpm8	4661	6561	6561	1617120180000
8989	3NKWjmgtY1fErLpWrL5HnTWYiU8HefLWM25B5eu8xvJSv4Tm4C4g	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1581	778	108	1	6301	jwdE6gLvGeoBNxZNskkgh8hbzybf7oozU9QnnDjsUrciNaZ2FxV	4661	6561	6561	1617120180000
8991	3NKJbqKdPdta8oGM9HGnHEfVua4uh5sNe3ptjuXDMoUdpSrjKySW	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jxmKsrpnj3cAqvEETgjHdYU94jMiMHVeTGTHqUMzEFhPDFUddEH	4661	6561	6561	1617120180000
8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	8990	3NLGL4a3sN1tnFXV1GUxCSwpGNHuH7WXhvxam9y8uoLHWPoiuavh	1637	815	109	1	6301	jxHgstmnMew7kFoyPbSDZVnmxcwEFKWp3QZv84E8qBTvaubG1pm	4662	6562	6562	1617120360000
8994	3NLQMoPHceb6Fahh2Wfn1LVETNv7nGAhfZXBVQrWNioy5ZR1KydN	8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	1673	1002	109	1	6301	jwcEmk7EN6KDXJaAhDFhVW8Tr7uv33tP29gcPEvPGTr29umQ4Kx	4663	6563	6563	1617120540000
8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	1483	339	109	1	6301	jxJvJfB4N3AL9Cys2qXPyobq83bkBPaXuYGsBA4vUFKCo3yje9J	4666	6570	6570	1617121800000
9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1476	1245	109	1	6301	jxmdejavJBFoJayMF3gRwrmxv9DWAVSY9jqtqjSrCtHzfqtp5VG	4667	6571	6571	1617121980000
9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	9004	3NLLDkKKVN9PP3CBUYjpJeFqBMConwmbhNB6ZNbEfsXtMvKnkJ7t	1675	976	109	1	6301	jwjF8EXWT4emYNfAwk3y9NGLF2ggY1QoBVD4uk2YzdRWSmsRkJw	4669	6573	6573	1617122340000
9011	3NK72jtuR4fPFgo76RyXHeoSi8648ivygopvFeAp4YiygRSL8et1	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1483	49	109	1	6301	jw9wZCjqaKa27ramto2taZbT2NQkHdpDd36ipdeMvXQchSzroNh	4670	6575	6575	1617122700000
9013	3NKXCpwTWsDAZrodszDjYNeb2bdrd6hh1c6rk1NthtcbpRbxXTuc	9012	3NLFxvE9nm4BhTgzou3prLEGLSthd3HiSrSnbCmpMmifLJr2L3KW	1546	1339	109	1	6301	jwaqp93WE1g1a5aD5Aydt6asrF2hBCYKNvGS4SJpSQyR9EZqBAk	4672	6578	6578	1617123240000
9019	3NKK3CPVdiQ6ZVVZS6XRZMMvYvwugYsPg5hpgQfmLLhVVD18Ytid	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1579	1263	109	1	6301	jxBNLnzHA98NzfZtp4TLeQn8TZnDJqj5Vt3uBjDzN9Za3nM2Lg5	4677	6585	6585	1617124500000
9024	3NKwtWjCuzryTBEhMnws7UpuCGNSEMPg7pwqGD6AkzwtW2TcZdvx	9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	1670	1036	109	1	6301	jxBzMMwrKPmDyTYvuKK6nccnJytTKS3AFnEMnyYP48TimALJ9kk	4679	6588	6588	1617125040000
9036	3NKN6ze3Wvapn6E9nrNyhGP1XD1xTgFchVcPN7DGBcgvuazvBTS9	9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	1407	1395	109	1	6301	jxT4eeuzqtUUwU9qt9GM5wusgusKwu4vzKWBgUfvCbjKirs1iG3	4685	6595	6595	1617126300000
9038	3NKVkvr67nNSYJhyn5Bh5pA1bV7CWtAkVEw9Z5vQ93JA6urstZ2b	9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	1467	1376	109	1	6301	jx9bcKFXD7oTWY4sPGUauWGpP7H9ftKFDYk9odiLxxUXbAEczdK	4686	6596	6596	1617126480000
9040	3NL7fNWWLK6vk2hS4mSHy92AcCSsup3xtbJU7jpCuuchjtg9maog	9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	1602	1003	110	1	6301	jxvWaCgu3BHFrvt3i5wGBv4RzEGHXHfjA9R9SF9opegCmUtzEcN	4688	6598	6598	1617126840000
9043	3NLkgMLwwDWfXHZKo71p6TWLzSE1nzEvTkxAXz4mDLrjk8DwdtmL	9008	3NKG9iwc7B6VzgDjmsHdEtooZAQTX9f3soYumitERjBkAg6U81Mo	1553	775	100	1	6301	jwck7u7MTw4BYTZ52oCcAiyTVs4UJPxSoniqELXgyYuyTfu6q72	4428	6600	6600	1617127200000
9045	3NLKkzSUi7SmunZezrcwHirFu4b9WUPhzUdxiX5qkMfLjTVYtkae	9043	3NLkgMLwwDWfXHZKo71p6TWLzSE1nzEvTkxAXz4mDLrjk8DwdtmL	1553	776	100	1	6301	jxQTY8GYF6rtBwdGqcjRnLH9zDMrUsQGcfK3XReu2HroUYJ3ZJL	4429	6602	6602	1617127560000
9049	3NLoQ7ZhoXMQ9LoVLn7bu88jWztmQzRow176nDxnBqS9wKm2VfmV	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1407	1395	110	1	6301	jxeYuL1TnZH1yasaiDj1tTjG6KnLPQHg3LoxzHWswJoEVcGtr1k	4691	6607	6607	1617128460000
9053	3NLNtdCoXiWy4atDL4pxq3DKkZZyuSbQjitLam61PSs34DLsYcSo	9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	1489	1254	110	1	6301	jww5cSuAkdLc4oJs7dGrrfhr6xGd8a3QuDVg4XducUwMqmjiFnj	4693	6609	6609	1617128820000
8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	1519	860	108	1	6301	jwahR36W2GuohTxV53drAHFdF6iN3WgSEUy8STeJHNgmG3YTdFn	4652	6549	6549	1617118020000
8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	1675	1342	108	1	6301	jxx9FbaqTzGx14vDDTUW1mkx6ZhCt62UStC7ugPy797x7VomckA	4655	6554	6554	1617118920000
8975	3NLTV6SryxJZTtj8az98fFv2gEhNaUTfQvSa1hbY9Mx4VPLunhdF	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	1675	1342	102	1	6301	jxpPCz1rRpzF21aKhkT3UAmFcw9of6USTKxLYMkd3JmLeecuQLJ	4488	6554	6554	1617118920000
8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1651	1175	108	1	6301	jwcZcoNohQvfDnfzdkjHQGKZ2r27hFbvMrG1iAbPtUyDMRcgD6F	4658	6557	6557	1617119460000
8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	298	1308	108	1	6301	jxdeeie6ZicVUj4PQft8piQFbyr4kGMvAsxJPTdrZ3NTxA5DG9p	4659	6558	6558	1617119640000
8987	3NLnCBQUgYGyXfzx8wPtRxJyz1GqUA89XFr44ydrNuK2JuA1Hw7N	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jxmKsrpnj3cAqvEETgjHdYU94jMiMHVeTGTHqUMzEFhPDFUddEH	4661	6561	6561	1617120180000
8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	1407	1395	109	1	6301	jwFhpEXL3WCfahTXQoqDcYz3sxmtpw3eLWCJqJ8Bt8xReCKLBSi	4665	6568	6568	1617121440000
9000	3NKjJ7upVCfoA2ySPZ2ersHDDEC4dKtPEDqsoRdBr5tSnDZxDcDe	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1589	1286	109	1	6301	jwkGMMSuxianb29YheVy3YSmwWZ7m5CwwgptzHzkvxwS5xYgy5H	4667	6571	6571	1617121980000
9003	3NKJxDpZPUzWtJ3rGSjPMHytgqjCwCS1BroAegEFMguC7UUuWqRY	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1405	873	109	1	6301	jwsY8Vxy8W5YrCF8ZEqJWLqknDyj2GR75sBBPXxAF6oueHejJM1	4667	6571	6571	1617121980000
9004	3NLLDkKKVN9PP3CBUYjpJeFqBMConwmbhNB6ZNbEfsXtMvKnkJ7t	9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	1593	1346	109	1	6301	jxQkjwF2NtUqNn3VLy6ouctQyN1fc1LUVQX8YkQBFTnU5GfFe3k	4668	6572	6572	1617122160000
9007	3NLJbVBZQ52xbMWE7zxMH8jxBzTyz34A4yaf9kFmrsz48NUsGy89	8975	3NLTV6SryxJZTtj8az98fFv2gEhNaUTfQvSa1hbY9Mx4VPLunhdF	1675	976	102	1	6301	jxpPCz1rRpzF21aKhkT3UAmFcw9of6USTKxLYMkd3JmLeecuQLJ	4489	6573	6573	1617122340000
9009	3NKGLfxvtXdt2coZ9sod6DiP9QW1Pc2ZffrGAW41SubuYpkXHHzV	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1403	824	109	1	6301	jxSJDxMGDsKHqXHSZmmEWKshPt4Y2Xf4wvT2P7ydJg5y942YBfq	4670	6575	6575	1617122700000
9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	9013	3NKXCpwTWsDAZrodszDjYNeb2bdrd6hh1c6rk1NthtcbpRbxXTuc	411	411	109	1	6301	jwAv1kEabjUPZ2PREeyWjQ9iKbeYkoF72twPcRW9CTMu16yzemZ	4673	6579	6579	1617123420000
9016	3NLSis826uTJxkWYYFrjpSP58W8bz9UxUiRPhzmo1kmpfris673n	9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	1513	1379	109	1	6301	jx7diZtUw123FC3opbYP6baCNZk8kbVtVuixocksoo2MJihhCzV	4674	6580	6580	1617123600000
9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1657	1344	109	1	6301	jxkW26ttuhnvhx6MD4tRg3VmLvzUpn6afsGaEAC986sMsCyC9tQ	4677	6585	6585	1617124500000
9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	1589	920	109	1	6301	jxmnpU7zKwEdq7nhWtQaKFRKC81RqCBFdE9wZ1q8cbDzRb6fmVR	4682	6591	6591	1617125580000
9031	3NLteqBpuqoy5Nbke7p4UnWPXAx5kQREK16YsPmuZqvSAgJVtcEc	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	311	1307	109	1	6301	jxvYkizEbgMeSuZW9gCqftao8mxWVDfrcpHymPFBn4FK1iu8p5L	4683	6592	6592	1617125760000
9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	1581	778	110	1	6301	jxPBwwDuXqxa6JUmGz17FohJtaftNmSkHQPxx3MLk6pifbLGdsu	4688	6598	6598	1617126840000
9051	3NLNcTWUMPrQdXj9iY2RhjgPh19ff9iGgst4CtpTecGLb2Sr9eN2	9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	1501	1114	110	1	6301	jwYzDoi8fW32DzWaWJGbG8Zk9QsvZ3ebTEJi4nNpospWhXUEfgk	4692	6608	6608	1617128640000
9055	3NLW55yLAdaaYUN3kfFayqcZMfKAoHQK2ToZBtc9hVBdGMaEbjPQ	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1474	1203	110	1	6301	jxw8y8EqcAsBhMZBrQbvho1hg5mypyxdTJ1ay4SirDjfRgfvKyB	4694	6611	6611	1617129180000
9057	3NK3pSFtgEo99Yg8Sgmbs62YzgkPsxbvUqiBsbLXYpxmwXemtqtk	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1508	1387	110	1	6301	jwRhS7NSQs6ccVrEkmr76YzBn9LR5dhVuLwJCRZ2NXMSjZbAWTp	4694	6611	6611	1617129180000
9062	3NKMXWUi5u5M1dHXaUyDS7n4TUMXHPyhGpip95AFjWQotys4Gth3	9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	42	1361	110	1	6301	jw9fh7mfUKGoFqXd7reBeMXveDy5X23iYmHB6UsEMY78iRVcMMu	4697	6615	6615	1617129900000
9064	3NLV249DVpsHRD6czU3oobUcb7PuyEN5BXJYXQ4o6Y9oXBQ7Uv53	9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	393	393	110	1	6301	jxtgvGPoccBNKD5a9Qc16JwhZjm824x4vxCcxXbCMaxfZnJ2EGy	4698	6616	6616	1617130080000
9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	9065	3NLffMY6UqgYTyaMRTm3DecPM43DDSkP3p4Ba7Qw86EezJVs2eo4	1457	1265	110	1	6301	jxvxs8hR7uNCzDjRET5qwChi3PBGyw3NdyEpQHaXYBy1SxYCZ6b	4700	6619	6619	1617130620000
9077	3NKRthyczhPRvKyJdJXSBLKURDFPV4tjs1nY4FYoW3ew5mRnYxeS	9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	1624	1334	110	1	6301	jxgP528RKHToHCpG6A4PwrncamHpRN7aKGQiYDVCrWvNiFEMD8w	4708	6633	6633	1617133140000
9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	1654	1340	111	1	6301	jw8f49RCXe15xKoh1YtoYXYQVwQsiADpfBrjrsdFsfw4p7ybUX8	4709	6634	6634	1617133320000
9082	3NLZhbdbXyWXfSjD8UCPT3eCktQ5UA1ADqXiTm6gGtk13xf4DK5s	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1467	1130	111	1	6301	jx3KgZK8Jj3wc8yri5tFiaFjJfp9ywwSJJWN4d4eBAH92793a3x	4710	6635	6635	1617133500000
9083	3NKBcwf5QA7MsSBa3xBYuWJCkXAqnF1ydGLf2LftdW9vMp9nvdoR	9078	3NLSYdaaF5Psxk1mam22xUaXgHP5XoLEQGpontf6gMP9jo31Gdkr	1617	1042	111	1	6301	jxJXz37EkyuysB2qHN9kikuuaLWgiUfjQeWmQZUXTTENbKTkRjk	4710	6635	6635	1617133500000
9085	3NLRqcvkbpe9xAwzM4eVBmPB3ezDuTKH77BYdXamvVsYwBkkDjbP	9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	149	1283	111	1	6301	jwaGZzoyt19qkg3nXFtGB6E39pdGMEJWEDcXWYwmoydgYyJVt26	4711	6636	6636	1617133680000
9091	3NKVkTm3dJ3JGuuRJ7DR1h3KZRRiHquyXvrMa9hPmS6oQ7oqbJ5Z	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1654	974	111	1	6301	jwu63rBuKvthDAxn65pV4g5Sw2xDdieuMG5MvSNhNb7NFjVPuCF	4713	6641	6641	1617134580000
9094	3NLVSC675EExG5udG7cYuZQqrj5kCEGdy2R4WWyRQs3gZpUYx7hg	8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	1654	974	103	1	6301	jw7SZDvxrxNUTTFy65ehEtzd7UUtDUy41tnFUdETtevGW3XBzxu	4515	6641	6641	1617134649942
9097	3NL9iQRSaLGTtEYSkEc2yjjaNMqmbGLqZyouxDEJruTg2YsuqgkV	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	42	995	111	1	6301	jwzRMbgJcMdEHihziyNYjcnLY9yhQwQ7PwQajgt9EhMSPD9iZja	4714	6642	6642	1617134760000
9056	3NL7EWfKzifFrNq3Lazcb3B6X7VPinwD2vFuKhwTAmpMDKwDDsgb	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1559	1107	110	1	6301	jx5XukvPamyAoh1x1Ro6HCmyyWvB6Xx1eW1VTgiVYcBKGpgu91a	4694	6611	6611	1617129180000
9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	606	1295	110	1	6301	jwscmFJW2uBTLKi4RvxPZ4auNpK7UvFEQyBStA28iQ1NLNAZbUc	4696	6613	6613	1617129540000
9065	3NLffMY6UqgYTyaMRTm3DecPM43DDSkP3p4Ba7Qw86EezJVs2eo4	9064	3NLV249DVpsHRD6czU3oobUcb7PuyEN5BXJYXQ4o6Y9oXBQ7Uv53	1609	1087	110	1	6301	jxe7WE34VQU8F2auBAZbvNUPvWn2ZExZu94o79eV3AMomwwRCuk	4699	6617	6617	1617130260000
9071	3NLhgXZEKBrxwbwNtMKtxudv8cneipQjvgu1BzZk6xTUXfgFQkH5	9070	3NLj7f98uPN1t6iUKCGCauy8ausvN4sCNgmmr5qGmTYhqgF9jR2h	55	62	110	1	6301	jwERajhW8wJUe19BjPU4CTMzRVAVcqe4ubrLhZX7guhnoss35MS	4703	6626	6626	1617131880000
9074	3NL7Lk4mopvXeL7MVELVLK82V4VHGUtqPrUvYJSSPzukx8TJXyDz	9073	3NKwrKhKsTa6sC8njehn9ChbZu4gxhE9as7nm6vihzRkDKQeWDu4	1406	1393	110	1	6301	jxzz54deh9T8c5LHVfBU1w5o7DKkMeniwfafR1Smpx1Bdg6zW7f	4706	6630	6630	1617132600000
9086	3NKqTM86d8bYZRTnrDgsJ3Pcyr82GLGYDUUoKi9Qp11cbbm9UeCn	9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	1611	1341	109	1	6301	jwAzFtszKCxtQZ424NMyNgqLjzmQmJoj3Cg292PqTe2PNTBh9gp	4687	6637	6637	1617133860000
9089	3NKaCGFeit4LqXjgapccDRjXwydAma5KMTbskyiSEJ58VMQ8SUrJ	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1536	1313	111	1	6301	jwKKpsaSgxVXXQ28q9FTWujyq4oaE36Bxb1cFFcHTtzsxxxyQpH	4713	6641	6641	1617134580000
9092	3NKaSkMKfVncDhPKj5b1AW5mHJm4uUYkn8ohVfQL9Q84kSgKjHk3	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1637	816	111	1	6301	jwjHnKL9ojDDUMA8z2w9EAJXVaVZoX8i2wrvvUtUsBWNPMhiDiB	4713	6641	6641	1617134580000
9095	3NL5XqVq627ea3miUeYjFWsQChp5rHoUAd6uZ3bbbHp2MzGny9Ap	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1654	974	103	1	6301	jy2cmTwd6R7326EemkPFCit2rTfRZNjq2UzZ4ie3RaBwz4yYPpF	4528	6641	6641	1617134686884
9098	3NKQG41w9BthjwjxZTGuVNj8oXRRDpPnoS6eYG6eNs934rpUTcN9	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	1581	778	111	1	6301	jwZqVfwHaYiqvKJpfhaqNsNoLv5YiRCFi9PcVBAUeo6WVG6GiaJ	4714	6642	6642	1617134760000
9102	3NLL8dZ4vS5Q4EnzZaEE9n8baJxmuE65DhUtKLfbbXC7mcRDqwmK	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	1627	1385	111	1	6301	jwv4Fd89rRpr1Qnj7WXVdHiYdAcgANr3C9WRJnvWzrrtD9Zvx9a	4717	6645	6645	1617135300000
9107	3NKWsvrqoSjEgbKzLM1F5f37b9Ba5rG61vwVuNd1ZCeepHpyYpbD	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1407	1395	111	1	6301	jxC4hP3e5fa8ry76NCUBtGwEzNfXCEot13WnkLRsZHDjRoTGCSL	4719	6647	6647	1617135660000
9109	3NLUdeQmr668fCkSQsGXaK7GjKK9qmrR4TjhKEHAwwXdicozPwte	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	484	1193	111	1	6301	jwrR12bbJkC1VdTZ3sskR8bAYmxJy9abeW2199FHz6cxhnseMez	4720	6648	6648	1617135840000
9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	9110	3NKqCjQDCHC1caNokBikDbLrFG6iK5NEgbJE9F1PLcoTVFgrsrDG	1637	816	111	1	6301	jwL3CU53UA8TgwjE4bT7TU17mYG6i1nVFncULP8JB6wc5aebv1x	4721	6649	6649	1617136020000
9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	9112	3NKja5Fd7Xy5t5psSv5B752UeZGNN5uacS9HyKTPiKCAhgQ6rwUz	1426	1364	111	1	6301	jwBPoftj2b1qP5b9U988PX6QRH8cJFp9HyjBcASZs8C2hxWHBo1	4723	6653	6653	1617136740000
9117	3NL3VMR2uyHFqQFmChNDs3uqa36Z68BtChz55ibj9HsZ63N5FHZe	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1406	1393	111	1	6301	jwPNayVxi8n7kRPrVXWqLf6XG4kBUTEgAZomNnQcCvX9Z59DKtV	4724	6655	6655	1617137100000
9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	9118	3NLdJRpuZpWBqTr5uUk6sj2ynFxmJN9vDyyzp2UYGwqJku3DBjur	1440	1377	111	1	6301	jwkR2tmgYxgNNqmuMFeLPSsre9fBHUDoKqi85zYNZ8xM2zhfgtK	4725	6656	6656	1617137280000
9128	3NK4gQEVaEFBP8HLgf7GgiFDEvccnLQm7HiN1R2vDMNAZj8DE5jY	8966	3NKFJc1RVLZbm1H7HAjX6qU38y1wAaFZSttSmeukzGPwyxS7WtuA	1623	830	106	1	6301	jwFF6CuSwtf54syp1z2n6NAvPcREfjvn53ci1FPgcQyqJnQ4x57	4600	6659	6659	1617137820000
9130	3NLDgvg3taoZjDWcvjKM2AX2FmTE6QxMRAGKFo8d7FRCJfTn1QVQ	9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	621	621	111	1	6301	jx5ZPNoaRgk5muWUGotGxnHHXAgdNShS247PYrBg81t7fuNFgM6	4729	6662	6662	1617138360000
9133	3NLaQN6sZ8ysfyPZePwbhkJggWbDtDeWkQRUdMfPfnk4Dzn5tASJ	9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	1549	996	111	1	6301	jwPr7MrHzjiBVEAQJBGSe2YF2r9ovK1vX4cVc2hFhnD7XKfbLGK	4730	6663	6663	1617138540000
9135	3NLhEmUeaZH1KVHozfgFecUpb5zKie86Pph7a5tAz9VepqLfDuXF	9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	1594	1080	111	1	6301	jw9Wvkr71BDqGsYcmknGCtMh2aupfStihGXhLdX82yoqfmRMt7n	4732	6665	6665	1617138900000
9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	9135	3NLhEmUeaZH1KVHozfgFecUpb5zKie86Pph7a5tAz9VepqLfDuXF	1405	873	111	1	6301	jwsfc5rxzfFnGojaexzqxKMLq1Z7gPCXrLeqScoNxBcfJ2jufiH	4733	6666	6666	1617139080000
9143	3NKh9FjjDabcfNnWdnEwjm2ghZcxxxsXuM7MM5S3exAUU7dPZTpq	9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	684	1352	112	1	6301	jxhGHcqUok35dFuFp4Nt95P7UqELJBdx9o2RnB5fsnoFWyuznwR	4737	6671	6671	1617139980000
9146	3NLrpUeakmVFUXYmzSTTyW6m3Jdkzspb8DHv8wboX4fKbVSQDKTB	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1619	1275	112	1	6301	jxBWjivNcXRX4Vm1mpqmTeLDhW8q3wcvEDGAviH5Ue22UiVM4Sz	4739	6676	6676	1617140880000
9155	3NLLytvL3fv1QqjXuopwpSB2scXudbgKYfy9224Ms3dU3UUu8C4K	9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	1652	949	112	1	6301	jxeygWVbsyUCBuxzsWA3dCtSG4ZKMrULDEnEzCb6L2ZBvVfFnu9	4743	6681	6681	1617141780000
9160	3NLtWC9HQC9EtF27ooK76Qx5nzVydCbTSRTJumFJPZxQ1kbvgtzg	9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	1406	1393	112	1	6301	jxHPK3APjZkmcMNqN12TJCrwai34grVkyrqhrrNMKcDqZBqjtEW	4746	6684	6684	1617142320000
9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	1610	948	112	1	6301	jxhbcEwWSUw5Yvf3iEsU3ZMy3znpTJ4cKXgAWuhEn7bQLJg8Hbu	4748	6690	6690	1617143400000
9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	1501	1114	112	1	6301	jxzEqpugAyzNZa3XUui94pqZj4e6uPtdz4PNURdH4xXFuGsTUME	4751	6693	6693	1617143940000
9168	3NK78Hauk9ZevktvWurtYJfqszeRCxggaqebTryptEhxq93hs3pT	9167	3NK6Bw5UUWS2SY4d5A2YmRPuqHvLBaaBLSvnf3iYSpXLerpQHfC9	1460	1324	112	1	6301	jwmU7MiNGH2F8UUSos7oXQz1TiBnxbL8Z3JY6AFiYkn5yfocyy1	4752	6694	6694	1617144120000
9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	1581	778	112	1	6301	jxBjrw1PCi68poMmcfPWuj1QRQA6oRGyQsniYrZf1iwYAirZTnQ	4752	6694	6694	1617144120000
9176	3NKDbRvzVQdY6rFZ9su2bgKPs6GJgFzDyqUd6gDQfnrCPQj6XeDd	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1460	190	112	1	6301	jx1d67nwcdswvfcFoXnYEfMfQABLNZKyCGy6kcxnsw9AmD9hoZn	4756	6699	6699	1617145020000
9180	3NK3Kbjht2cTxzAFguoxewgCwVKwME3mWDUvU967SorQ2wm3SEDc	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1489	1380	112	1	6301	jxuN2v4hc8EQYyhHEHjm8gYLdUoG9dNcx2k5qSAc8xGYFAty1v8	4757	6702	6702	1617145560000
9059	3NKMTWfXCpPb85EYm4QFcncKRE6Rxo8u3W2fccYZKQH8i4HXQejt	9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	1458	957	110	1	6301	jx85dYZf513WJwzSEACqggaPVy5QSg5ZHRz4aUcPkbrgAp8kMF3	4696	6613	6613	1617129540000
9066	3NLK1iom9niuuxtNjNuMRqGhyyTxZPinJrSqgi1EaSzSumQQMW2U	9045	3NLKkzSUi7SmunZezrcwHirFu4b9WUPhzUdxiX5qkMfLjTVYtkae	1553	775	100	1	6301	jxPCfw51zcVBLzgKaD7kJgop3qwchuCMaVfgg91cKsDnxXFm7pJ	4430	6618	6618	1617130440000
9069	3NKwDJgxnBpCX2gr7JwL4Si7L1G7RZVXFUjPyUVhGaZu4ptp5RGv	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1426	1364	110	1	6301	jxmXjohTySAYsu5CbF5ryeLwJJdR4kDpEhbuwpkMUt4zxeTA8xC	4701	6620	6620	1617130800000
9070	3NLj7f98uPN1t6iUKCGCauy8ausvN4sCNgmmr5qGmTYhqgF9jR2h	9068	3NKB5T56N1kkjECQGYUSY2xBZZ55uo4hM1hgxJ5voRa5pDRAzw98	1467	1010	110	1	6301	jwkUyytBmQAeVR7XcW9xxDMNSYTwWkcEiua8n85jJ7EsuWSkp3i	4702	6625	6625	1617131700000
9073	3NKwrKhKsTa6sC8njehn9ChbZu4gxhE9as7nm6vihzRkDKQeWDu4	9072	3NKCDvQSQnLWsoyu9b5yc3oN9B849y4hAqVpAF1iuHhmLbvuay52	1474	1329	110	1	6301	jwvxb29JptJZipufJrcLAY8ZEL8rv34694tjMsdjdjumSYsFmaw	4705	6629	6629	1617132420000
9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	1624	1334	110	1	6301	jxp8dv24GjUFA8W9vjFA7E9EKKM3jgm5bse51pv1c19Pjf9fRiQ	4708	6633	6633	1617133140000
9078	3NLSYdaaF5Psxk1mam22xUaXgHP5XoLEQGpontf6gMP9jo31Gdkr	9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	1406	1393	111	1	6301	jwJVfDqpU3e8rYUYUTH3zjTyHyj9yoCfbzqGtorgpok5LJG3wbR	4709	6634	6634	1617133320000
9081	3NKUQsmP7FNsdqc5r4H8Tui5B7ReW7v29j43r5mkv5YCridebTPB	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1467	1130	111	1	6301	jwBavoHk4x472uSwgDwi7KH2TNtvC8DpCA6k77EQoXLTVdLvHbF	4710	6635	6635	1617133500000
9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	9085	3NLRqcvkbpe9xAwzM4eVBmPB3ezDuTKH77BYdXamvVsYwBkkDjbP	311	1307	111	1	6301	jxUV5Fo92zUM2u6ufVqFFuJd2gfNXVBGz5mK5ZoZ6jSnHk43ePs	4712	6638	6638	1617134040000
9088	3NLWJgHtpwrWGq9Hy3HbAR4mZku8RHTraJop5STwqkHvWsMZaC8X	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	1654	974	102	1	6301	jxua3GNCJUAgg3y8tHUfCdkBo6m7f9kiVQKxd5NK4jMVgNY4adr	4488	6641	6641	1617134580000
9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1406	1393	111	1	6301	jxnty4Xcuqr6AVz2qXCxeCzSCfBXq41647Znc7ds5RRnPZ4cq9F	4713	6641	6641	1617134580000
9093	3NKb5Vb5MUEMWsC3XrLEkmGB4omMSnYNoQ8kFJfy4nw1U5gCBzGV	8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	1654	974	103	1	6301	jwypww2Eb9KsJkttkqXmKhaa5Cj9yYseN2xHemCsthUdqFgWRB1	4501	6641	6641	1617134615432
9096	3NKS4p3ndbCCGKszU6DqwmvWHd4gdRFAkQGZ1pzBAYLCwcEjMehi	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	58	1035	111	1	6301	jwCETQjN2xzePZAYrs1uZzNkRbdLz8HKJHHzZeZLUT2PBp9quf7	4714	6642	6642	1617134760000
9101	3NK5ihLzpgdbwFojonDdaMfbgnnDUkbx1SZKgcdzrsqqSZPNHxTQ	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	1448	1185	111	1	6301	jwwfAKLGvtqk1o7LHRvMP11UWLgt14cpQB3nzsWcn93nSVpwX8U	4717	6645	6645	1617135300000
9104	3NLMD3Mu4uENLuwrn9CgtePMbbdBDt4LGYaXd1wVnr7MmvVbNVQX	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	532	1303	111	1	6301	jwRxQdDhrUtdbMv1pmPqJCide3ZaJ9Wvf5nLSh2cQuYPLtU4x8n	4717	6645	6645	1617135300000
9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	9102	3NLL8dZ4vS5Q4EnzZaEE9n8baJxmuE65DhUtKLfbbXC7mcRDqwmK	42	1361	111	1	6301	jwviShE7necfQW4boQKLCjqsQEsrbWA3Vs1JDAnNuvpBCm9cnip	4718	6646	6646	1617135480000
9110	3NKqCjQDCHC1caNokBikDbLrFG6iK5NEgbJE9F1PLcoTVFgrsrDG	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	606	1295	111	1	6301	jxBiUbkdeAHkutmocJf4VuHU8gGZzpHA1sKZ9sDHyznV6kkvHnS	4720	6648	6648	1617135840000
9113	3NKNwGt3qTojZWkTGWd5PrKHa73GNyV6jyVHJERfeLe9BC8WLL8E	9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	1637	816	111	1	6301	jwRe7GGMC76xjNchuPYvakDN6ZEMMjCfQVgiYG9KE9aorMfjFdY	4722	6651	6651	1617136380000
9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1527	1293	111	1	6301	jxKY9PcJwUCywCr7km4JGww7iTTA2dtHE7sgfgkwyLG1BEJfZVu	4724	6655	6655	1617137100000
9119	3NLPgFaPEwwMVeZrmHwsDhQsR95NGmnXJBxn83eyCi6cYk4Usc8y	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1601	1142	111	1	6301	jxs4CDFCtR8Brp1tM45yMAVhXhef7oXW3xHNQ6SvDxqrN8nXtvq	4724	6655	6655	1617137100000
9122	3NKkVwQxGU8MFft4mPPGtN2cH3qwCoqJAB3rBq4Ljwg7zhCBmX2Q	9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	606	929	111	1	6301	jxJWyqMVJjkDX9yusvBidNYste7iMbLgfuqjcY5y2NrYt2cUDWJ	4725	6656	6656	1617137280000
9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	1489	1380	111	1	6301	jxtXqDM2hPShc4a47ycFwArSnegnJpNS5cmnWeDSBrQCokX1q36	4726	6658	6658	1617137640000
9127	3NKp1FmVw86t2gRs1cbPJh1FeK1L9LWDracN53piki92bRyPMFAM	9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	1489	1380	111	1	6301	jxmwzWbbAaCpKYoXmP9RTYhNX3PaftE7FTqqhesG6gSThPwhs7P	4727	6659	6659	1617137820000
9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	9127	3NKp1FmVw86t2gRs1cbPJh1FeK1L9LWDracN53piki92bRyPMFAM	1406	1393	111	1	6301	jxWo4BeiS5iQKS5W59GZWqiCpZNJg8jZVvtmcrEBoy3ZVwDBySt	4728	6661	6661	1617138180000
9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	621	621	111	1	6301	jx197Up9vTucr21SkVtzBwKJzixjgDfB3QZep3NLuPk8LB6Y5fo	4729	6662	6662	1617138360000
9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	9132	3NLwD4EfM3MF1HhzjcRheQvhbnw7Jkhdmk8wbYsQTGo9D2fvFhTQ	1631	794	111	1	6301	jwiCpLWM9NqdEapttnYYZ4w5RHFocAtB5e8Wq67HaTn6BivMkRM	4731	6664	6664	1617138720000
9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	9140	3NLPw5BqwnBDG7ZYyAtqe6D5TiXHGz8rnyB9XNii9XfHZtrMJQ67	1601	1388	112	1	6301	jwYRxKvkurYmRkQaxRktVopRXto9L9JbKN7D5p2uswggYZF2ZPX	4736	6669	6669	1617139620000
9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	9142	3NLXczWqjR13kfAhnPBUtNAL7upmdW2AB6ZejDCQ9q9y2CGcbW9J	1460	1324	112	1	6301	jxFtUvsMpq22isXRLhPDqJmkzLVuZd2Kkmtq3y1ThDaZzux5UAi	4738	6674	6674	1617140520000
9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	1547	1378	112	1	6301	jwVZTAfuH8EnEgCKn3FzdbZXf324eniTfF8bxAMrmSP7JDnfwsQ	4740	6678	6678	1617141240000
9152	3NLJ8zBBaCztB7KPJUi1dFc8kjrEcRwTmy6J8Q5KMu4k8HH3LEGq	9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	484	1319	112	1	6301	jwqddS2nPpDvvsqqBjKyPtNX2ZXdwKd4WeBUVAhuQkTtMZuwZGE	4741	6679	6679	1617141420000
9154	3NLYZgPr5SH9kU8nmPFMeCuQr2hu64EzTvGsDHc4oUpsqDwgC5hy	9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	1596	1117	112	1	6301	jxUAutJPpTvyMxjisWL3gCpEgpFzwA5p3UzVRABC8LKpVwdZdgr	4743	6681	6681	1617141780000
9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	9155	3NLLytvL3fv1QqjXuopwpSB2scXudbgKYfy9224Ms3dU3UUu8C4K	1461	1271	112	1	6301	jxsFN7bcFEPFKpA6DJiZLeTiCnqPWqQ6qTRNBm1L4oJTgH8uMoh	4744	6682	6682	1617141960000
9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	9074	3NL7Lk4mopvXeL7MVELVLK82V4VHGUtqPrUvYJSSPzukx8TJXyDz	1402	810	110	1	6301	jxYGEdNuAhSfU6wwDtSx9cbqo8Hhuc4LbJzfhSPefLhLroirikR	4707	6631	6631	1617132780000
9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1509	1320	111	1	6301	jxZopJaQQKQX89XzboaSFo8181AwaNN6cJiaaZe4h9C3FtcSwEd	4710	6635	6635	1617133500000
9084	3NKdwRMsYegSiWMDP7okNRRpcUg6gkH1syECAS95Kara8WECwumG	9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	1457	1145	111	1	6301	jx1tRemwBuhm9psRzRg1pEvzV6CS99TBYeVJrK8MBhXH85RZyRc	4711	6636	6636	1617133680000
9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	9099	3NLtBRsidHKjHQdbihpsLYH816xZzL4ncWm6FTgJUyW7VRh2j5aD	1451	1292	111	1	6301	jwTk5DvBwhRrDypiYuTVrVDDSPv4KzZbx1eHquiWMwe6J3g94Pb	4716	6644	6644	1617135120000
9103	3NLtEDbDFJJjhkY9W88GVm9HtgB7h5aNTACe2uVhUgVipxG1XYvN	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	632	1382	111	1	6301	jwzUCfDyk2Yxo14CWW9jg8FLYk2GGc5kFqKLCpndxwDKVQSLiVU	4717	6645	6645	1617135300000
9112	3NKja5Fd7Xy5t5psSv5B752UeZGNN5uacS9HyKTPiKCAhgQ6rwUz	9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	1406	1393	111	1	6301	jwnSNFBJiktJcmRaPBFKYRKifNdS7G4pg1d5WqF7DmvSBFdsya4	4722	6651	6651	1617136380000
9115	3NLL9t1Z6USMPT9PYAAwYv2YWgVhiYPBBSZEA8iRKZUqEMo8fPVv	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1553	776	103	1	6301	jx59BCZSmfwhpdRF7ZZ6TyTktroeDhz6UmYdBxt227xRHThSnYf	4511	6655	6655	1617137100000
9118	3NLdJRpuZpWBqTr5uUk6sj2ynFxmJN9vDyyzp2UYGwqJku3DBjur	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1407	1395	111	1	6301	jxQFiiHL9LHENqwq7xyyE4y3q8vKUdvZN2MAwMMNgcpr5AaBxFv	4724	6655	6655	1617137100000
9120	3NKx1dyQz3anZHox1SDjZgDrsMsxtr7hW6QsgaZifRWhfkZTDpSt	8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	1553	776	104	1	6301	jxrycGNDc2SKqWdoNg9iewVTJ9aax1Kh8EsZmY4SkCFHTKtufFU	4530	6655	6655	1617137152383
9121	3NKqFaMvnmuyadgRQqQno7PdUKhXHNMXxR5yjC3trGSeXPSkScdb	9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	1440	1377	111	1	6301	jweBvifPzcA5VUTEpRiBafmKFzozvkpwr1Pmxgcbq8zxmVQkqeE	4725	6656	6656	1617137280000
9126	3NLSNr84q9hdJDhZShCij5e7RDyLcDnrynETzUb3LSCbYQtiXkNg	9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	1447	1099	111	1	6301	jxj7zJpckmSjLmdTCrPR8UgmeATrSXnEiY6HP6AcQWFjtUbSSss	4727	6659	6659	1617137820000
9136	3NLejJUyMhZmrn6dBpARMfjPYGa6q6ks1MmnJfkee9tqyzAfJKeM	9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	1631	794	111	1	6301	jxoqAyX4i8wQdcNQcwT2vJUTqwf8KCDT3CXrXWzuKH7mvcxX91r	4732	6665	6665	1617138900000
9138	3NKew52gVti3dVb3KYPxBLzB6oEPAPQDzCsbFmudTKHP3xMME19f	9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	1637	816	112	1	6301	jw7j28ScoKwRzTcj4QNQVTh3hmprT2HgNbSskovqHbLu3x7eBeq	4734	6667	6667	1617139260000
9140	3NLPw5BqwnBDG7ZYyAtqe6D5TiXHGz8rnyB9XNii9XfHZtrMJQ67	9139	3NLv4BAFpoHSixf8s4aW5rrkRQDt9m6CN2vpVkrzsgXFEjB1VDZy	1536	947	112	1	6301	jwZXSfigJLSimre9H9nfjGqsJG2CWXSGw32bURTEqt9KQVE3F7V	4735	6668	6668	1617139440000
9147	3NKtmwmmkEBA1g29cJeC4CkDdXUvDPy88DnFAhigamCSfgNwoiVa	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1647	936	112	1	6301	jwcD38n4wZnuu7jqSmDCmKyDpGA7mxjERbwSXmm7dGL9BP6Z8zN	4739	6676	6676	1617140880000
9151	3NK4jEH4YyoaZgtozRXjbQy4aWNP46Lhomc6JnWEWS28qScduiPp	9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	1527	1293	112	1	6301	jx6nkPQiG45dcLVucgPWBLk5A8cEX6pBMhYAMstBKkfiuDPjtLq	4741	6679	6679	1617141420000
9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	9151	3NK4jEH4YyoaZgtozRXjbQy4aWNP46Lhomc6JnWEWS28qScduiPp	235	235	112	1	6301	jxn5Pg8Eg2N9VS1X3Vnbysw2poh21gwPVXG2MHUsoR3VTU2yQGu	4742	6680	6680	1617141600000
9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	641	1090	112	1	6301	jxttfrYa18nj83qz7SW5tmJQzaU1ALu6FbieE18K9MrFM22aRB1	4745	6683	6683	1617142140000
9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	9159	3NKXmMJ24WL56jW2NseWKGgMoZaZ6QqKtqLhhxPBFEizhamefwfk	1585	1120	112	1	6301	jwJ5usrCXcakMXKE45Yb4QCmer45qz8u7XkgcGEe8y51XvpsVsh	4747	6688	6688	1617143040000
9164	3NK8vf6c6Rs6waHnjW6KbvfGw9D3uouuzHZHMFaVwgU9TFtKHfjX	9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	1406	1393	112	1	6301	jwjdh1vr21fYQhwwjWCMRKWSPqtBHarLbZH6iWZ3dhw18qTXpu7	4749	6691	6691	1617143580000
9169	3NKRrvGyyT8XXJHzLEFzskeU6TGZdt4akZ1zKk39tgXxaHF36bjL	9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	1460	1324	112	1	6301	jwyPUUQQxcYeZENM2BQ5SDEtcqFiVAD4xVcRJM3qGxHt6ynVfmA	4752	6694	6694	1617144120000
9171	3NKArAA9dJdBeS9c1RoxkbKjtjd2ZCWkk4TZLuq31zmjUcEDKBUF	9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	1407	1395	112	1	6301	jxo5o8QPGiznzZkKJxHBg4aV47Z6SdL26vrV3g7tSYMVTvdvtzW	4753	6695	6695	1617144300000
9173	3NL2MezkPA4PRMhrf5t3qhE5qzNyijQjMQm4nzKUuPxmqVZhJm3s	9171	3NKArAA9dJdBeS9c1RoxkbKjtjd2ZCWkk4TZLuq31zmjUcEDKBUF	1555	1347	112	1	6301	jxFY5DBeHqGD7q787LHfuxWjip1xDXHGbrkhZWmKEaS9bkLWbpv	4754	6696	6696	1617144480000
9177	3NKgHqbW2epcnEuC9o8qKUzv7K3cGkLK6MtY1L9bP3ahvCVLn2Us	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1406	1393	112	1	6301	jxNQTEHhnk8Gdkmk1eSoHas9V221LY3kekxCjrVJG7j62punFJY	4756	6699	6699	1617145020000
9181	3NKVWNwrkJJd26rB5ncBAYhXff6DfbqaBkfcfNgDc5JGVvKuyCBS	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1402	868	112	1	6301	jwu33ZBURQn99G8hAMGQt87PYbFtjqXqCwQkyPThM1uLUbb5PTb	4757	6702	6702	1617145560000
9183	3NLQtmsHCU2q564jb2mxWBRJhbZvtxP73y4zzKaDSfDEcf8R9ZMD	9182	3NKm412uC1YhdicJF4Ar5bWusC8neKpJPMcD4tE5YhV9NzoBiLkE	1406	1393	113	1	6301	jwTBsCSbveLY8ryByKKwA6gZ1hk8Vf5c8V2HLFSBN95ngFYAtww	4759	6704	6704	1617145920000
9184	3NKWkJVvtuUsJWz7rv9dv4NJsQYtBJ66F6Qj6HkM6Xt6ZHVJtm51	9183	3NLQtmsHCU2q564jb2mxWBRJhbZvtxP73y4zzKaDSfDEcf8R9ZMD	1407	1395	113	1	6301	jwBYxuUuBkZ9VPmtqXQXgg2bewMZqiLVHZpN7SxWGsDLjp8mRVS	4760	6707	6707	1617146460000
9187	3NKzfc29YgfnxjAN1LB4hZm5dMKk9VBFN9bbWAUfuvSKLQ68DAuW	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1541	932	113	1	6301	jxucMkPZGPtmeQGiMSFmbJjUfStFx6HEhedRHdWdH41yCWDdrNE	4762	6710	6710	1617147000000
9189	3NKxeGysRw7M9n9U6pPiHE1eh622Z6QAP6pcsHkAbBgDc3DH5wdy	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	369	1312	113	1	6301	jwofYajrASbEzToDgNRn1Fd4pya4wK8c9f1jyRMTviNByjJAurH	4763	6712	6712	1617147360000
9192	3NLBt4Yhr7geg9LviYGCg1ed2qKhMFArWF2Jn1wPSY6cGLG5KQ1a	9128	3NK4gQEVaEFBP8HLgf7GgiFDEvccnLQm7HiN1R2vDMNAZj8DE5jY	1623	830	106	1	6301	jy1dCeJ49qSHGfzT1BVwTq2kThPonh76m7LafTE1CNHYuBXCi3Z	4601	6712	6712	1617147360000
9196	3NLtaV3exWXvxBBNQYoWm8w944EiUqp9DcDyp4MtM3CxAyghYWWe	9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	1500	1297	113	1	6301	jwWT4UxVoZ7k4MAnett4bCfDPt4uoWJ5VhQMvfxir1Ecacg74hF	4766	6715	6715	1617147900000
9198	3NKKL1kTnP7NnhEZ9d29RL8epkzmad7oXbbQ6agPT28nPqdD4rSz	9195	3NLdTVyzLT5VeatmM5Wv7oyGjgyEb21hR4ZWvEjkN76xSkHWU8px	1434	642	113	1	6301	jx816qt69TCbkjzdeNhcWNCXBBKa7HUjRLH17XwQjVcKD7HwD27	4767	6716	6716	1617148080000
9099	3NLtBRsidHKjHQdbihpsLYH816xZzL4ncWm6FTgJUyW7VRh2j5aD	9097	3NL9iQRSaLGTtEYSkEc2yjjaNMqmbGLqZyouxDEJruTg2YsuqgkV	1581	777	111	1	6301	jwFpEXdqabexXKkBKb3LX12dtYGLW9FzJrNsSH55R49eo4icRn7	4715	6643	6643	1617134940000
9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1402	852	111	1	6301	jwWVg78PZdinW7K2mX7ukJtyFq3QgxdwC9RtXvVLuMsgvpC3Vj7	4719	6647	6647	1617135660000
9108	3NKL4rWoh5q9prjB4bMWht1EZpLQDyXPJmxkbVDCzqFhVCUHMxUU	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	1407	1395	111	1	6301	jy34JjvjQrTWTfhgMcZUYK5Qv7iG1YZkjR8HozQGpPpJho87wCr	4720	6648	6648	1617135840000
9125	3NKF2YMX9NQ4PX3GCyVdq8Tq15jnBTCVjJdr1ednDrJRX6pzsbvY	9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	1607	577	111	1	6301	jxZp3PRJnPmNW2AxzM5t6YWug6LmqTDZggr98Z9yBWchVvaJHxj	4726	6658	6658	1617137640000
9132	3NLwD4EfM3MF1HhzjcRheQvhbnw7Jkhdmk8wbYsQTGo9D2fvFhTQ	9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	1406	1393	111	1	6301	jwhhCDXEKzbdK7Kic64TH93Kk3XpsvGQb9t2pwdkckJYemHMVdm	4730	6663	6663	1617138540000
9139	3NLv4BAFpoHSixf8s4aW5rrkRQDt9m6CN2vpVkrzsgXFEjB1VDZy	9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	1407	1395	112	1	6301	jxtcU358BoCe5DuCChG86J75ox7h7UTDkrdHwmaFu3QNmJzo9kR	4734	6667	6667	1617139260000
9142	3NLXczWqjR13kfAhnPBUtNAL7upmdW2AB6ZejDCQ9q9y2CGcbW9J	9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	1643	933	112	1	6301	jwoCMS9SQegZGhrT8EoWhMwUszJveAmZmoeLQevy87qu9FnqdyB	4737	6671	6671	1617139980000
9145	3NL4DvJi4AaJpzfrkUqhhKowxjaDdB78EmTyppxnKX3CLTrXLmw7	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1407	1395	112	1	6301	jwceirZZphKCgGvXwSPN1QLUetBheKgdYHTDrqtmfui5bwfFibA	4739	6676	6676	1617140880000
9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1406	1393	112	1	6301	jxR1iNsu7FnmT5PrGdzKqKZ3uZjmLiLwoEzAqTP78LJ8NkyaXqs	4739	6676	6676	1617140880000
9150	3NKjs75PnUGNg8Bk5UtHZd6Zf1XPqrw7aKsg3ZW2uHbymu2FmGx4	9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	1407	1395	112	1	6301	jxGj8xgTwE3xjySXa1URSCk1YGQiMoPkMTJe3z4aADPRrtAtaPb	4740	6678	6678	1617141240000
9157	3NLD1TEaKLef58K4yixuFqu82QqhNoGe5g5mZz2f6Gr8iMESyt1r	9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	1405	891	112	1	6301	jwD1Hz1vCtvxbfcEFBsigA3iR9sdKwqoBZKZnJ4ZyUexM7UqJ1g	4745	6683	6683	1617142140000
9159	3NKXmMJ24WL56jW2NseWKGgMoZaZ6QqKtqLhhxPBFEizhamefwfk	9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	1403	823	112	1	6301	jxJxZSWvUp2mwCQ8y2WqEht3eMHnSThTVeww3bf4JGZht7CeAqs	4746	6684	6684	1617142320000
9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	9164	3NK8vf6c6Rs6waHnjW6KbvfGw9D3uouuzHZHMFaVwgU9TFtKHfjX	43	1310	112	1	6301	jwUZPab9kji2iVidKAvLF2C3bRoMGP5DxMAMrZ96gf2VkSFfY2i	4750	6692	6692	1617143760000
9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1560	1045	112	1	6301	jxbYyrHTtp4m2Gf2xF4CMXgA7z7mhkVwenUYqCpWKZj4HjFFWuD	4756	6699	6699	1617145020000
9178	3NLE3T63HqzLHxLm5ni4MN31qjU8utbkDAbPvASS6nRsr5w6pgwZ	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1581	778	112	1	6301	jxBTxQXLiLUvn5kYedNaeXx31Tvf4UVzxjUKPbxd4Jf1CFtvxGE	4756	6699	6699	1617145020000
9182	3NKm412uC1YhdicJF4Ar5bWusC8neKpJPMcD4tE5YhV9NzoBiLkE	9179	3NKjsFwQDroJgKn2wHTLKhFqX3QxzbB9fmgMviz1rYbwSYdCN1Tv	563	1359	113	1	6301	jxCNhTxvrLmqRQLKDZnwm6ZoJX8M6rbR6xsenhqCoXAD8sH9Po2	4758	6703	6703	1617145740000
9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	9184	3NKWkJVvtuUsJWz7rv9dv4NJsQYtBJ66F6Qj6HkM6Xt6ZHVJtm51	1501	1360	113	1	6301	jx3mhe6a4jyAdtZ4HnkgdtCCMvJ1iHnXKR1Wa7n2HL5aEJjKjrQ	4761	6708	6708	1617146640000
9190	3NKoG9ZxADkowDUMZ3hmanFvR7zq3xXZiPHnkqFodtfEjfqtugXG	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	1553	776	113	1	6301	jxW1G2unjvTe8qXaBFdLhePGXLeZzmdMvjbbrB1Psgo2ZJcw22w	4763	6712	6712	1617147360000
9195	3NLdTVyzLT5VeatmM5Wv7oyGjgyEb21hR4ZWvEjkN76xSkHWU8px	9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	1451	1292	113	1	6301	jwTkGbMuTNGQgNtK6TNa9DijtG6wJWbqraJa1A6H4LgRLxYpS74	4766	6715	6715	1617147900000
9197	3NLMJHZLjuAHnNRJSgqSFFq65i1KkZdWbMksPoG9xgrq5D3H84so	8958	3NLxSwKr9J4RLYsprwfnjzZA48L2GwNyuEZhhwyGoT9J5cDmLtdd	1500	1297	106	1	6301	jxFoAXs5KBBFHtqQi4PHyURz4KJD9Vm4pZDFx7JVc2i4mbN2FSx	4570	6715	6715	1617147900000
9202	3NKVcbeedJ6tHUb9GAD7hucwK8vfupnTfa9KNpZPWAdjy18aV8AS	9201	3NLkWFNfxJRmKbbh7vVve5mYEPvwKBkQyRQaP8Hz16UVTntuB5Yo	1627	1259	113	1	6301	jwoXJ5isapjSTEe3sDP8CRbtXet9MEFUWiFwfenL5qTsqTXBJBc	4770	6719	6719	1617148620000
9208	3NLVTRP2YpyiFZ1rE7vuD84myiEBwQHxDLrppW48VWGdz9maH9mb	9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	1471	1140	113	1	6301	jwqu5hNyziQ51xMCqf82nba2cDhxcceZfe7WUD1yxMwF2Az7UCB	4775	6727	6727	1617150060000
9211	3NLfyKEJEZ8ceT8HfHA7qencDKMRdKqmC4pVuEwGxDxJS8KLwu6j	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1403	824	113	1	6301	jwqpTqEwZAEa9u7HzeFvenweWH5xx1z1q2gef7mzVBK6KmgNBsC	4778	6731	6731	1617150780000
9216	3NKFP76Ff7WXn6Ys9ApaDQ9TrhHLQ3RYtfg2gToDb1NVKaA9icoq	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1406	1393	113	1	6301	jx9oRq7b8ndgccvzibgh26T4kRMGb8Rt7dcxTDQyRNbGZWTrt1s	4779	6734	6734	1617151320000
9218	3NLWFsn9pfbRFXbNRm6r9GEqMHeXyQ2YH7FD66A9RVSvT14HH8e8	9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	1634	1085	113	1	6301	jwhGJFRwgRj5TdygLqgbhLKaXZWFbnV2g4MpHLr4fF6NYY3qcV8	4780	6736	6736	1617151680000
9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1426	1364	114	1	6301	jxEyKFgZjcnYmJHumU4NCC3M8NcHNMrHphdN5AneYWVBe9u3vyS	4781	6737	6737	1617151860000
9225	3NK7NosCNW594vTcTEV4NiGhgWUgESyg4rrqmfsfBAD2PPqxEnsr	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1587	1357	114	1	6301	jwiUstevJ9qGA4vKdkS3CLKffKjfpSAz7xcY32CyLTEu4oGfDxb	4782	6738	6738	1617152040000
9228	3NKsgTmShxT3MLv2qWU76cD4BRT7SjLZ6SmWkiZgDJtvvdWAkYbi	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1407	1395	114	1	6301	jwSnZiJis3JoByyHGsGsGLwcvtai1YDs3Tg83EBeW1vUKq3z7pu	4783	6739	6739	1617152220000
9229	3NLpNe5f7C3amA7fn1y3aGNxBS3SfM6BpSjQZLiNvxJeRucAJYy9	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1564	1212	114	1	6301	jwtfi8b933H8xFAgSFLWBBVvuVbq2h5xKftBWxDY13WmYY5gnau	4783	6739	6739	1617152220000
9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	9233	3NK9fdnpDNZ1gLLTAyX8gcu2G1Do6x2pZJYRahCgqnt3MDheFeCm	1642	1241	114	1	6301	jwWnG42fLJU2CovhEykA13utwCachVybfwKM7mCUTNeooFiMXqN	4787	6743	6743	1617152940000
9239	3NKGfRZVESfVeXHYBMFpnJEPLvoQFjrQwgVqYNFWvocbix5VYsMQ	9238	3NLeuTsQDQGXBys4tteDWbydzJp2HkXbdVj4NXM8Yf6E8MwdbDfJ	1403	786	114	1	6301	jxxHV5xYVzU5mb9U2jaaATegeeVC52KP9EiBtLiXsXPrejiwgST	4791	6748	6748	1617153840000
9242	3NL5wX9x52GZMqrwJEfiqaLeAUXWw6iT4jGxbqjjQErWUXBkc8UP	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1405	857	114	1	6301	jwSHfQpckYTXzPwBzMpZMHSQGP3s4mWpdYqYgFk3iMpa4q378Wv	4794	6751	6751	1617154380000
9162	3NLGJHYenUGooWnuDT5PwhgvkqBM8xBHAbH5LYkub6BqrVViuwbt	9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	596	1060	112	1	6301	jxFaU7GyenF76Zow6hn19XfRF9o6mH6s5aDUS2EiM7sJi21mhMW	4748	6690	6690	1617143400000
9167	3NK6Bw5UUWS2SY4d5A2YmRPuqHvLBaaBLSvnf3iYSpXLerpQHfC9	9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	1555	1347	112	1	6301	jxCim77t2AxWxDjm2hLEN3S9bHnGM4yqdVT5Ws9BXYsYExW7rp8	4751	6693	6693	1617143940000
9172	3NKPXXAi3no8nLVfdwV1aM58PTHJyobdJ95cBUQ9b56Z7BYCWyTv	9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	1458	1323	112	1	6301	jxuUzdWd6cnPKbxUdGE4oq7tfmeEMycCh8GooAHs5eCA9yYfgpe	4753	6695	6695	1617144300000
9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	9173	3NL2MezkPA4PRMhrf5t3qhE5qzNyijQjMQm4nzKUuPxmqVZhJm3s	1553	776	112	1	6301	jxHwpQoyoyK9UChjXRBvSc1T8fi9NeZ1mWBfWdvbrvCbn3M7hZR	4755	6698	6698	1617144840000
9179	3NKjsFwQDroJgKn2wHTLKhFqX3QxzbB9fmgMviz1rYbwSYdCN1Tv	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1585	1120	112	1	6301	jxAsCTikNwgvqC1575FkAXJkswnA4wRXuVUaWXuXhm6iSrMSKqJ	4757	6702	6702	1617145560000
9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	9193	3NK4YEAghZEK8rfB2gr9k9NaxdyAgpHhU2iRfzTmAfNquiFZkmUC	1406	1393	113	1	6301	jx9Nvgs2EhhhJ4ZmCGa1dMNy42ZbESERzKki299tWrDL9fqAoYi	4765	6714	6714	1617147720000
9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	9198	3NKKL1kTnP7NnhEZ9d29RL8epkzmad7oXbbQ6agPT28nPqdD4rSz	1631	794	113	1	6301	jxW8RgS2YVb8WawDUTvQ7QjxfbPztj2rZtgWDWnwcvycQbBiSZT	4768	6717	6717	1617148260000
9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	9203	3NLjoNzTnTWSB1G4E2Twf9tVhqPicn3K3UsQ8NJmUmFKvpVsU7fe	1670	1156	113	1	6301	jwJyMNSvQw61dGfQZHzZ4VZKZqofhrMxFQRsAUX6RndeuRVtorL	4772	6721	6721	1617148980000
9205	3NLofxQmDYpofVWrgpJeixRj5qKfZza8LTjoVgiJxNNGg4ZnDz6v	9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	1467	1376	113	1	6301	jxHHxwKnjQodwXC8TSEWSrxJ1ccFtEFHNsXPLYErMuATDzYmANT	4773	6725	6725	1617149700000
9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	9206	3NK9drYacgJJKZLuyBkd5wFuBNmqAmTWRs6sNfuB8KfMsJqQAQtW	1553	776	113	1	6301	jxB7zKoaHMWyx3PRvn13zXjZ7AYjkNNdEYh4R47W6i9hf37f75m	4774	6726	6726	1617149880000
9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	9209	3NK8z2vszqRFdnVCoefnZN1b8RQfmyAR5aAN8pqBM7Y7gqQSGbUb	1637	816	113	1	6301	jxqcCUaARyupsSduWkp4KBKWfuMh7wRV2tCwpg1wQpehSMpBVWW	4777	6729	6729	1617150420000
9213	3NKQDs4nqYkgG4FsiQYrNzW8bPftv6DJ7geSZurFuqJBk6kUQH59	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1600	1126	113	1	6301	jwirV1eArc5beGnQe3UwjP1VcS9Z9oX4gY6vSvxPDeUjFwptTCG	4778	6731	6731	1617150780000
9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1403	824	113	1	6301	jwYvecAHeXcUZwLqdQE6Gyi9Lg7RTXPQqUT4x8ZkrYK3efgfMqf	4779	6734	6734	1617151320000
9220	3NLc8d5TAapwJwHffYyvgRmTUCsHvW5Nmkx4crfJ4cznR1Hf6QQf	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1406	1393	114	1	6301	jwiHVEhQJwy2zvqy5uCcV3VfMAdDjQH1VtSte5j1NSdbJc3fJUN	4781	6737	6737	1617151860000
9224	3NKztvMMFkLLQq2ak69XoprBYz7FHJd59oJ91z299MU1iNY5ub5M	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1406	1393	114	1	6301	jxQkJBs5s58nC6riGVHJ9m2mcZfKPp1jM7z3G6scK1wm8ofGyiq	4782	6738	6738	1617152040000
9227	3NKsJty7tVQnMsKapAj57qfmaEi7AU19xp1UWcs6gnVFKo1zMbEH	9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	1542	1058	113	1	6301	jxYdJRyRtDA7zhf4ybWhRtMDCgLooFzr8gZwJLTvPtFazQUQ6UJ	4775	6739	6739	1617152220000
9231	3NLcXcFjb448dyqVkmjuRLVNBsvL1i8fWi1AFPr92Wwd2DQ2VDbG	9230	3NKjsY6zs6fKzL5NoNWUJqHuGV4gedKwnwnviwkNDhoHvF8qUpyH	171	1128	114	1	6301	jxeq9nv5udrUL9brubazXCVZDQaZBVFECinSkUDz3UjhYkXGgR9	4784	6740	6740	1617152400000
9233	3NK9fdnpDNZ1gLLTAyX8gcu2G1Do6x2pZJYRahCgqnt3MDheFeCm	9232	3NKHXrSJsR4qf6pupAYjAeC3SM4r52w6fVgzWPLAvr18tqRb1fKC	1405	849	114	1	6301	jwCf6w5zbNzf1Jp6p49PXqNwzaMdRsifqSdbtCSYLePUECrTcSE	4786	6742	6742	1617152760000
9236	3NKQ9yUxzqRDNKErzcraxQU6YQvDFrAVJyCDRmZcFhfj99J3BYeJ	9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	1406	1393	114	1	6301	jwDPfRRfCcGw4JBHs3VmFQvSZm572jMAbhNaZUBKht4wQQfY8M8	4788	6744	6744	1617153120000
9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	9240	3NKPr6Vnz3kJDziBUCg9hED5bC7SVy4Mvr9aCUzWaf7Ng32jgovJ	641	970	114	1	6301	jxZNErQXyTTeGrmnW2pir1HDt3rSWds57iicvTEyoNyrVsPmypk	4793	6750	6750	1617154200000
9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	9245	3NKvYqYABDtnToo3Pc5PaeMx5FjhTorFNH6kVjHg2ZSMd1oDqUzx	1672	1159	114	1	6301	jwGX7SMQ9JHZ7P8ke7AfEqaKayH3zHoGbKUtMoj7NzFyJrfDkxW	4795	6753	6753	1617154740000
9250	3NKF34hZ3uYPqya1V6CKJdweT9QypD13cb21rHV5WPnMf23mWjJM	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	1608	1289	114	1	6301	jww7LCgHbXYrucDEgCTxo4kWnSe2zvgQcKUhQWbTpY5nDQmdBKF	4799	6762	6762	1617156360000
9255	3NKWSdV898ZQrfvfWsuBZRaDF3CwkYEqNDVoCt4h8wVwwvXg7ZE7	9250	3NKF34hZ3uYPqya1V6CKJdweT9QypD13cb21rHV5WPnMf23mWjJM	448	1179	115	1	6301	jxjHdmwp5tdXNNmTrquasXfmJjiHim9ACufCvLJCiDgQNsgiQzC	4800	6763	6763	1617156540000
9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1654	1340	115	1	6301	jxyXH1BXsXjYhPzfzCiaZiuYmKDCGdRaCUAVN1LMusMUzF9mxUY	4801	6764	6764	1617156720000
9259	3NLyKPsQABRY5GxKFXVXyrRR4Cwm8om2FLZxBNQ2ppEJomSfjFnS	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1581	778	115	1	6301	jxxZu6Wk4S7wLr364jakkWgootXC7HXyWW7rXXWzQ4WGv3puXS7	4801	6764	6764	1617156720000
9264	3NLCEWyTgECgP9Ld2mKkoFJjRNhHDP9cYWgimEyNJtvvvyrVBd5f	9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	1403	40	115	1	6301	jxY1LMxxotsTQBU73zQhsD6F4LH74Fa9iCEpsgzVXvfcMgKpyNw	4804	6768	6768	1617157440000
9268	3NLGYQLMX2UVLJFVjtH3CjRxCEvoW7ux3pr6MLpfZinWDiwD21bi	9264	3NLCEWyTgECgP9Ld2mKkoFJjRNhHDP9cYWgimEyNJtvvvyrVBd5f	1579	1023	115	1	6301	jxcZobCH2T1NDJmYqn3ifvLpeSQBeCtrsRwUVFWMBdAHDNW4jXh	4805	6769	6769	1617157620000
9272	3NLbWyH3Kob8r6ZhiprqrkzxCVZHZ2t2DTZZKNv5ojsDcBR8ZGUt	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1594	960	115	1	6301	jx5amFw5UbKFF1jMxHSkBZkxoZbHB1pxcd9n8bFsWVW7ofU5eqr	4807	6773	6773	1617158340000
9276	3NL5SBRjA8PEbgqozb5RA349wPjB6ipDcFzfBCUKZfTSaRjsKCPF	9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	1652	949	115	1	6301	jxGa8wRg1AsTCuSZ475qkJwo6X9wK2wq3y26MjeinvBUpamtqp4	4809	6775	6775	1617158700000
9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	9277	3NL9R76juiYXWgi1uKCpooEpYeCk18gKECjJ56EJdzb5KHqoGUxy	1403	824	115	1	6301	jx9UmVf24tun7yNzU7KRAX1MHL18Kh8JLfvbCxHP7rAvueaNYqV	4811	6777	6777	1617159060000
9285	3NLQvq3nJnEsCgD4zxbPAzyoaSfSR8awa6edQSJWs7bpNCNQZvh9	9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	1477	1350	116	1	6301	jy2EG7p8XPoUZmBManw7c3dqZHx5B2UaALjWNYF5nBhmUdrMfFQ	4814	6780	6780	1617159600000
9186	3NLhAXKgNKpR7uBXoi16XXUPq6HNYQzz51zZrPbfAdQGKs6FZSGf	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1407	1395	113	1	6301	jwPoj256GTZeJVBsUhJqMFHSR9T93HEVEd8grBf9VckN2rtWVhe	4762	6710	6710	1617147000000
9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1648	918	113	1	6301	jx4YfK3VVmNEcRr1tgbzUmXpnuABKQPhQvkxj7BjH7fwF1WxZch	4762	6710	6710	1617147000000
9191	3NLfcVAjGV7vR8zt4LAFhHmhVKHe9UoMdVwywY1XDQZMs4YuG5du	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	1483	352	113	1	6301	jxUyEcJQthXMZASAe1LDwS6TwPMqBbvCCr73pWD3rZDSxPA1Ve9	4763	6712	6712	1617147360000
9193	3NK4YEAghZEK8rfB2gr9k9NaxdyAgpHhU2iRfzTmAfNquiFZkmUC	9190	3NKoG9ZxADkowDUMZ3hmanFvR7zq3xXZiPHnkqFodtfEjfqtugXG	1406	1393	113	1	6301	jwyBmAQhD9TjjAqJ7norzVC79Qs5f4YQFRNUNoWY2BLZPEXHMre	4764	6713	6713	1617147540000
9200	3NKAwJ711MsCfC3wDsbRiXcftzuvX8evCD6LZEjCdMRFTfNMbGQs	9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	1405	861	113	1	6301	jxajPeagvQeM4iu8KeDDpA1jxdZyJb9cqxpZhKrv4SEsMt9GyWP	4769	6718	6718	1617148440000
9206	3NK9drYacgJJKZLuyBkd5wFuBNmqAmTWRs6sNfuB8KfMsJqQAQtW	9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	1650	1009	113	1	6301	jxCiPp8eyQYcpBJJf6xiHRKr7dydqfcHQNVWLnJX8frqUV9BvCr	4773	6725	6725	1617149700000
9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1451	1292	113	1	6301	jwqydbR3b1VQTwqzTayd52oFpmyWRe1RYKaci3by6RfVphpXUwk	4778	6731	6731	1617150780000
9214	3NKfuURsnn283QxghmFB7tNaxfNfQTbbL7XeR6rzoRSAXTvE34hM	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1594	1326	113	1	6301	jwWJdRxv3CrE4Xwo8gfN2TH4nJwXCRQNcrUNQhqDgABniGjscFi	4778	6731	6731	1617150780000
9217	3NLLHL2NvNyZqLu4XNb8gTTn1FTqwBrzBgJnBvbWsBm7R6uwdbQd	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1601	1022	113	1	6301	jwtpZj4txqQJQuegY9hd5jjBMwnucEKd35ptJpiR6mNBVEeg7KU	4779	6734	6734	1617151320000
9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1675	1342	114	1	6301	jxGfpcgqn1KS7vVsXPW5sbzX3iaU7Sgd3jZCkAUcVvQezj4goYc	4782	6738	6738	1617152040000
9230	3NKjsY6zs6fKzL5NoNWUJqHuGV4gedKwnwnviwkNDhoHvF8qUpyH	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1474	1329	114	1	6301	jx7Do2Kcnff5cR1uVBHhhdUvg4iuPyTUrL3reLSD4hj1wGk22r3	4783	6739	6739	1617152220000
9232	3NKHXrSJsR4qf6pupAYjAeC3SM4r52w6fVgzWPLAvr18tqRb1fKC	9231	3NLcXcFjb448dyqVkmjuRLVNBsvL1i8fWi1AFPr92Wwd2DQ2VDbG	1518	833	114	1	6301	jxEySKGFvomP5ZH4uJ67nTBzNy5xs9JHzRcyzuk14Lwv7c12Yi3	4785	6741	6741	1617152580000
9237	3NLMW7X5ZnX7UftEfbgyx2Yyc74B1ToaVs4HfKgMBbaWthYxK88W	9235	3NLYtW21Jv28gsKs7VbMs9VuTCMxbCSf2v5d1HGEh4J67UdZL7UV	1508	1387	114	1	6301	jxUsGkV3iHvj8cnjYvFe4W4Nw5dSL7Z7dbngjNcqv9MUyJEUaK6	4789	6746	6746	1617153480000
9240	3NKPr6Vnz3kJDziBUCg9hED5bC7SVy4Mvr9aCUzWaf7Ng32jgovJ	9239	3NKGfRZVESfVeXHYBMFpnJEPLvoQFjrQwgVqYNFWvocbix5VYsMQ	1406	1393	114	1	6301	jxowNT14kbtfgmaCy31hMUU5ipQPSWJCHd1a15u7U7ENmSTL3SD	4792	6749	6749	1617154020000
9243	3NL1fwHV9nkXrAcTk4WgCvpjeGoVLNEfMwMTaFCwyv9ebFa9QvZq	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1406	1393	114	1	6301	jwvuX2GTLCpxTzpfo4jbrYGDHW6dLSW8z22tnGrCT6Lg4xjKEue	4794	6751	6751	1617154380000
9245	3NKvYqYABDtnToo3Pc5PaeMx5FjhTorFNH6kVjHg2ZSMd1oDqUzx	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1477	1104	114	1	6301	jy3HM8ZpkR8qKVNFcDmxP2m1vP8WHPaYXSrSYXoJZZJs6WFv9rw	4794	6751	6751	1617154380000
9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	9247	3NLn3vAVaEvckyFbeWdSHUD5baYUQYHazsAET7taLCYjJWkjKPoB	1406	1393	114	1	6301	jwYsA8JJFKPgrBXhdUP8v9W9VJfkiGBrLufF5KvG3CLNA2XcWpV	4797	6757	6757	1617155460000
9251	3NKPNSKcG3JM9HNWZGNTi1fokLuQ7yo1Uc1h8xExZkZVjeMGvbUK	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	1406	1393	114	1	6301	jwNBh5BpVehcsfsztCsxxJKkJ642Z6inJbv6pTFgocrgTt4RPcg	4799	6762	6762	1617156360000
9252	3NK5XU8tTEX3gHufSQ1dXcjtf17hTJA3Sd4weoAvpbgANkiiQGZ3	9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	684	986	112	1	6301	jwPcPrUFTRHgGvo9taVFZoLa2acdduQCraqVjwwEZXXvgZVGVKD	4749	6762	6762	1617156360000
9258	3NL4HyR8ygGcBTifLznU9rdh7sUu76abXqPcmS8z4iQ2hzHcknin	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	448	939	115	1	6301	jxbNZnzSdohmi2y7gMfX6go8UKQLNeEKb84C5BVYKhNG6LEECVu	4801	6764	6764	1617156720000
9260	3NKy5u8FN6PeCjpbc5QdsWcMEz5kdfkyL7seHVL35vEHEnbkwtjX	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1585	1120	115	1	6301	jwUtiWgZkeK8WHowHmahz5DKzHkaYDT6Ue7uZuUqZbxCRLCe5wH	4802	6765	6765	1617156900000
9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	9260	3NKy5u8FN6PeCjpbc5QdsWcMEz5kdfkyL7seHVL35vEHEnbkwtjX	1578	1296	115	1	6301	jxnrhGBnpG7CeaAe2EfZbayiiNDPFVQEZt7494Zaj2vsdkghhTG	4803	6766	6766	1617157080000
9266	3NLFj3ZUfEuwybELECGF1A72wVFZN5mDWtCrofCzZkZYU5gvpHqM	9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	1407	1395	114	1	6301	jxxECGpXGJB7EuhqNbDoiTsG6VofNWZuKDycbi6k4XTuHdhC8vd	4798	6768	6768	1617157486862
9270	3NLrmCxZSz9YHjxgj73JMUVjEeG1ZR9Mf3GXoCjvmu7ptcnGtC5k	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1405	861	115	1	6301	jwEa8RFCFpx3senm7LcLErQrHeAEEa2fwKU8ZLkL35JSCt3bNuy	4807	6773	6773	1617158340000
9273	3NLuUWwcX3AAA3GaMdQj2cnfzuTMHUnnW3vuaFzPb3csYMqe1PVQ	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1534	371	115	1	6301	jxJqnsrBfAh5SViMGtBdRBtr6VXTS3Vp9zfj46P7KAQmCK3jvja	4807	6773	6773	1617158340000
9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	9271	3NLW5ULF9t9gpsm2VwC7aSjHycdEtjQ2v7QQ7ofnLRJckxWPZUzV	1553	776	115	1	6301	jwEaXAq42hp2HoMzZzxqR5vH9xY13NLYBXXcJxnTceoRtCPaZPP	4808	6774	6774	1617158520000
9279	3NLcyrw9YyNCjQKnhcDf6PHpAmnzGXCnG7UENuJJXfb6jfhiRTPp	9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	1564	1338	115	1	6301	jxDv5rMYpMRpqzscuaBfexbJG7nVFchMjGq1FmAYomY7D3MdMMt	4812	6778	6778	1617159240000
9282	3NKVWhytagL94vG3x57VgfSfDmyrJvMCY1p66cYsThViSXVt3jrW	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxuyCTUQmvVW18NzWANDEKfhV5TepSGAnzrZ4USPHiK6EdJ5p4P	4813	6779	6779	1617159420000
9286	3NKcZpSQfqAgpYaygLyupr27QoUm2haRBCyfJ66e5f8PUrFNaekx	9284	3NK3jSaoBCmEviPVEW4jHuy2nmh6MRHq8rncNZWYBtwLobXRZ6og	1406	1393	116	1	6301	jw9t6Lwk437FTncaJkyFREDvihxDEfDiVzQiGfCyR2CQoXEq4y3	4815	6781	6781	1617159780000
9201	3NLkWFNfxJRmKbbh7vVve5mYEPvwKBkQyRQaP8Hz16UVTntuB5Yo	9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	1403	824	113	1	6301	jwfgjdknz1xhZjaWfJDBpac81iioXQr4KBX4X8nCbgd3TpwLGyZ	4769	6718	6718	1617148440000
9203	3NLjoNzTnTWSB1G4E2Twf9tVhqPicn3K3UsQ8NJmUmFKvpVsU7fe	9202	3NKVcbeedJ6tHUb9GAD7hucwK8vfupnTfa9KNpZPWAdjy18aV8AS	171	1008	113	1	6301	jxtvXktisEkg2bFXXHVFrwAY14R9hH3z6ciChjNA5wCiJzVxrNC	4771	6720	6720	1617148800000
9209	3NK8z2vszqRFdnVCoefnZN1b8RQfmyAR5aAN8pqBM7Y7gqQSGbUb	9208	3NLVTRP2YpyiFZ1rE7vuD84myiEBwQHxDLrppW48VWGdz9maH9mb	1460	584	113	1	6301	jxy1Uf3HWDDkVZNYizqsLDQnWy3tuver3LYXA82WhERPQChbyos	4776	6728	6728	1617150240000
9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	42	1115	113	1	6301	jx5BQcjMEHNS1ZMua3Ct2EhVZfEAcEYiJiPBkCaxe8CeP8iHWc7	4780	6736	6736	1617151680000
9222	3NKAY7TVm8RrrksQfgfiRRtHZVztZ4udNKaK1EeE7mbqsdHU3rni	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1426	1364	113	1	6301	jxEyKFgZjcnYmJHumU4NCC3M8NcHNMrHphdN5AneYWVBe9u3vyS	4781	6737	6737	1617151860000
9226	3NLqp9aV1ZvpzJvYsbCF12QZV6MH29aApMPSHhRH5w57WS1KSv7Z	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1542	1058	114	1	6301	jwDEB2d6AQfQtGDndQhwvxsfr2mswnWWbAZiMQq1eRzpi3xZbpk	4783	6739	6739	1617152220000
9235	3NLYtW21Jv28gsKs7VbMs9VuTCMxbCSf2v5d1HGEh4J67UdZL7UV	9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	1407	1395	114	1	6301	jxhobCbrHfQCraBS5NhrttwhEVc4ue9ZXFud2r8yCfWt4yBMan4	4788	6744	6744	1617153120000
9238	3NLeuTsQDQGXBys4tteDWbydzJp2HkXbdVj4NXM8Yf6E8MwdbDfJ	9237	3NLMW7X5ZnX7UftEfbgyx2Yyc74B1ToaVs4HfKgMBbaWthYxK88W	1553	776	114	1	6301	jx9xfNirK2JoLqedZ2MWJhAJHWQiit94XMcmKCfxZzfZyvtnfYM	4790	6747	6747	1617153660000
9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	1609	1333	114	1	6301	jwRn4owRr5W8apqa7YH1NKGDKDEMvR3k7dhyZ63Qta1biHVvmk3	4798	6759	6759	1617155820000
9253	3NLFaqKj77ZRY6nob4C5qp31UohLxiAqCjqnbUPXyw3zdJiDnYhx	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	684	986	114	1	6301	jxNCwi3BmxkEyJpK2r5KCHUoGp7LhLNBfnfCzJsFwcp8cpwc1Ye	4799	6762	6762	1617156360000
9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	9251	3NKPNSKcG3JM9HNWZGNTi1fokLuQ7yo1Uc1h8xExZkZVjeMGvbUK	448	1179	115	1	6301	jxWmDL5WNXYxpkN7SJEuRoJLyPtJzqRtzjuawqtEuEYKub7TB7h	4800	6763	6763	1617156540000
9256	3NLy2YrsojsZfUdDLGdqU1K34yb9XEt1GVTWDEXW8xvioGX47cBj	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1405	867	115	1	6301	jxHG416JzWP2FzaY6bfb2vXjXZCysPhwFLd6XxFtfV52b4yTcyG	4801	6764	6764	1617156720000
9261	3NKH9dVRooWBtjb7H9CraaDP5dCUNwTeVo8PsRSpWSDZw9cSYbdV	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1642	1367	115	1	6301	jxsGDnoWockfceUQk6QvHc9xkJAX15BLyCNmTfXLp2nc7jfaGA7	4802	6765	6765	1617156900000
9263	3NL8EcLdBfd6ENXzXooQiBkSodLP6pVbxhFoM4PQUjCMnPEeLcmE	9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	1406	1393	115	1	6301	jxwG14ae5QKJtvM1Um2dU73khY85DpjH8YMpJRrh5GHv59cPyfU	4804	6768	6768	1617157440000
9271	3NLW5ULF9t9gpsm2VwC7aSjHycdEtjQ2v7QQ7ofnLRJckxWPZUzV	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1403	824	115	1	6301	jwnn45MYR1vnpDEngCE9aDNj338MGrd4Qh7hNGgwvH1qswAk81K	4807	6773	6773	1617158340000
9275	3NLLvx17mphvrW7MSULWsziCT5VYx9HnUvAVGcvvu6gLAv9oAtrf	9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	1445	1290	115	1	6301	jy1hihM2DvYe4p8biuRr8YmGdiMVNBrmwnaKKUPgi4oZqvwxddw	4809	6775	6775	1617158700000
9277	3NL9R76juiYXWgi1uKCpooEpYeCk18gKECjJ56EJdzb5KHqoGUxy	9275	3NLLvx17mphvrW7MSULWsziCT5VYx9HnUvAVGcvvu6gLAv9oAtrf	1547	683	115	1	6301	jwBehGDwpbTVBYYVRMobZX8DYE1oaxY6azyhPmBUwYQxkTFKZWU	4810	6776	6776	1617158880000
9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	1555	981	115	1	6301	jwkbMAEM9oW1N53LkL2Qqrrp2rUQY4kv6jsZFyfwzyTzH2cWECW	4812	6778	6778	1617159240000
9284	3NK3jSaoBCmEviPVEW4jHuy2nmh6MRHq8rncNZWYBtwLobXRZ6og	9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	1549	1236	116	1	6301	jxXS631XqDSx8GpUVe1Az7RsdA3zwzWWPPmyt6B5miu7Zz9pJW4	4814	6780	6780	1617159600000
9287	3NLHaTRadCerw5sKABR4627aNhMb4kWuZho6DvwgJkbwuT4eFNCY	9286	3NKcZpSQfqAgpYaygLyupr27QoUm2haRBCyfJ66e5f8PUrFNaekx	1596	997	116	1	6301	jx1SkiL21dsXvKF6PT8Ph5WvQ2uwUQf1Zos2R32zD6V1oUTgboj	4816	6782	6782	1617159960000
9289	3NLxeSMEHtA2Htf3TuxDUddbuY4NHN1S6bmridzAAV1FfoHezxJd	9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	1405	849	116	1	6301	jwcBMcxhw6vUbBQuo2K4uikt5BshoQRtsx6neNXKds7jrCzTv2u	4818	6784	6784	1617160320000
9292	3NKx5gpXhXGB5UcGK2EXUKpp8JkJYdmUs8Vd9CQEKm43imQBiARy	9290	3NKMRBd3GwniA3RyKXTo8ZPpXBfBdBi9CNvhYkM5yJGZyaixdBUs	1650	1375	116	1	6301	jwt2AuWJS7ThRfsquMBeM5ia3oZHMqh2Vrpyyy2BnkLXQ8dQJs8	4819	6786	6786	1617160680000
9294	3NKaffUMdzy5VQzEuS5wTpyAATtvDML1dEzAXhcUuctcVYnNEaB6	9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	298	1182	116	1	6301	jwhbtkXJdVW1VpCeB2ntAeMWBYhi7RNEB5F85fU3Heov7zHSBNq	4821	6788	6788	1617161040000
9244	3NKMzrzoXL8AAPAAD8tF8xzjjgpRGLkF7Y1W3NLXBV16WPSjHqms	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1553	776	114	1	6301	jxZgjXp4f1zQkvS5piXxkJoUfwD2tiiutWCQncrAT8BJAsJXs4o	4794	6751	6751	1617154380000
9247	3NLn3vAVaEvckyFbeWdSHUD5baYUQYHazsAET7taLCYjJWkjKPoB	9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	1407	1395	114	1	6301	jy2jzNv1uF3z5mRYN2ZY4raJowHtMQiaAtGS4ujXqDPH2KMkaNc	4796	6756	6756	1617155280000
9265	3NL3oE38XuSN3HXXF5UmfYn2Xrj2BJVtyY78GcCiAdhT3kGg7coS	9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	1407	1395	114	1	6301	jxX5aMd9jA78PjpDpahoSRBbyT2UfsPdKR3yD1MXQRxmb9dx3Ax	4796	6768	6768	1617157440000
9267	3NLWKhhn5tEx5zAX7pPf3WC8ALebe8evktD4LyRZ8mxu72JVvgQb	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1407	1395	115	1	6301	jxjhRBtSPPSahPcJU4vEWpE7biD2GnYo8Ne6j1CgZ7QoSfWabJv	4802	6768	6768	1617157544783
9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	9268	3NLGYQLMX2UVLJFVjtH3CjRxCEvoW7ux3pr6MLpfZinWDiwD21bi	1581	778	115	1	6301	jwDUFgbfnEVrevicTHMwkeDbugYGWrrDA3gyFy4ZqRgohQdtwpX	4806	6771	6771	1617157980000
9281	3NLgDgb8VSsZ1GpGZwjacbKZt7aW368X2ZcsujXiQV3c1JmYvYkc	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxDgop7WtejeLz1RbmJnYw3fHRtWTcDgkU7FEedMYDwPmANfY3z	4813	6779	6779	1617159420000
9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxuyCTUQmvVW18NzWANDEKfhV5TepSGAnzrZ4USPHiK6EdJ5p4P	4813	6779	6779	1617159420000
9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	9287	3NLHaTRadCerw5sKABR4627aNhMb4kWuZho6DvwgJkbwuT4eFNCY	1579	1263	116	1	6301	jwPZxNiaFU3GTzu7coP4zVkioBG1RnxZafZsK9GyfCxmS8TkndR	4817	6783	6783	1617160140000
9290	3NKMRBd3GwniA3RyKXTo8ZPpXBfBdBi9CNvhYkM5yJGZyaixdBUs	9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	238	238	116	1	6301	jwr1hvonvN4k6qaAEGS3NJDn3oPopGxXSC5hKtmm3oUvS2YuFAK	4818	6784	6784	1617160320000
9291	3NLw3EMxXgy1RahZ17N88MQmH1wRYLNQbkPgAzmZjUJ98ukRDsM6	9030	3NLJSR7fH3zfJTQY6qZ89yzuungkr83ZitoooRYjXwM2bzxH62FS	238	238	109	1	6301	jwdsXHn6cxvynHR4jcu8EbETH9dvxFAmxsqrTMZ4K2KDGh7VaLA	4683	6784	6784	1617160320000
9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	9292	3NKx5gpXhXGB5UcGK2EXUKpp8JkJYdmUs8Vd9CQEKm43imQBiARy	1444	1135	116	1	6301	jxyy82Cvdyj7Q4YRgAsJFMWzstcjrFSrViWJpV7eahkc7pZFYAF	4820	6787	6787	1617160860000
9295	3NLmJCCr5kCZ8443mJwZcos13yDdBxEQBokxVf9YJL1UuXFk6wUJ	9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	1601	1388	116	1	6301	jxrDatqWgt9LSHFGk2Nv9TY9PigR9fzxajResqHPTPm342UdSXF	4821	6788	6788	1617161040000
9296	3NLb7hvN4yMG9KbyHoeUc18q35qX4c9HRivMFxWsPxMPBN6qBFsq	9295	3NLmJCCr5kCZ8443mJwZcos13yDdBxEQBokxVf9YJL1UuXFk6wUJ	1419	814	116	1	6301	jxKXhZBzfTmSChe6B2iUXNaEaUCkNZqRocwoe8MjqjnPcFZKxSm	4822	6789	6789	1617161220000
9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	9296	3NLb7hvN4yMG9KbyHoeUc18q35qX4c9HRivMFxWsPxMPBN6qBFsq	1590	1054	116	1	6301	jxWvMoH9Qt8njExXF2cgp13VgU5uAyHyAR31N5PxUycDcYw5u8B	4823	6790	6790	1617161400000
9298	3NL32KbLEVM6xqcavLGD2JL2HcJtJY2D16m83qCSMjHMCRPYjYMb	9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	1670	1156	116	1	6301	jwy8mnUHjbQiaSFuMYABKw523bByxXoFFEJRtRuvPz4zJMxirUj	4824	6791	6791	1617161580000
9299	3NKmYXxjn5JThWDLTLDNnczXAumXNs4DsATJuzsLEzASP7vG7hYg	9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	1419	814	116	1	6301	jxyDFWe4y9SLhagKRSwp7QjLDpL81gcBPfJkmGpwAwKcU35URPQ	4824	6791	6791	1617161580000
9300	3NKSZTSkCmJoWd5Mkv4CrrhyFAMt4udQoir43hEdfoGuujGb86ii	9298	3NL32KbLEVM6xqcavLGD2JL2HcJtJY2D16m83qCSMjHMCRPYjYMb	1460	474	116	1	6301	jxA8rdmwDGhFjazkW8UTG5DWBijYnLt1qDbCTpkyYHEuoHPcgVT	4825	6792	6792	1617161760000
9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	9300	3NKSZTSkCmJoWd5Mkv4CrrhyFAMt4udQoir43hEdfoGuujGb86ii	1599	1287	116	1	6301	jwZvGiAQDVXp7Ct84RDxdwkWZFcVwzbU7uGFaJkYSkPR85UP2W1	4826	6795	6795	1617162300000
9302	3NLc6Xm5BeU5qw31LzZxukt1jmzmnskKE8sGdEMDEjNisJsF7imN	9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	1483	6	116	1	6301	jx4e5NmWYNiK3UeKwyZXbowoT5uFFBVo5HWNxy4wBGWxWuHh46H	4827	6796	6796	1617162480000
9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	1476	1125	116	1	6301	jwYewHskz4Nte8knwxKFDo81dhs1f8Ps6GHfaVkofcMCHEY2E7T	4827	6796	6796	1617162480000
9304	3NKGq4kW77C8hpWW7osggByKuE7faCui2Jjjzzbi394kXZv4e97h	9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	1501	1360	116	1	6301	jxfo5WkwqMgtKCdzD5xtrXXRoPinsBVjQbHn4pLftRraP9nPpDj	4828	6800	6800	1617163200000
9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	1643	933	116	1	6301	jwHB8DbDHGm1D7FGL3NN5Tu1hTjJogR4sNUvGbmjBG8Gv8XVaRe	4828	6800	6800	1617163200000
9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	1607	982	116	1	6301	jxg5XW3CwywWUcibZbqWQBnUr1RNmwiD7yhJvj2X2qMusp6oBFR	4829	6802	6802	1617163560000
9307	3NKxEq44mBaaaFuK4QpQTQsY6YmxUjpvCod2WQRLNaYeurCEokyM	9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	563	1113	116	1	6301	jwX25YM8ZTApjwwfGSecw9w2m1dZ5XSMuMdkXraRBQPuLwm9pGu	4829	6802	6802	1617163560000
9308	3NLrMHhBwRdcD9LoaMAQAQXtNibzmPQWSRH98P644WZfAuQkM4D4	9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	1490	1274	116	1	6301	jwfHGbfCCJ6mcv2tuJhuc2snHUfvH8XBsW7KFKZoL84jeni4pSV	4830	6804	6804	1617163920000
9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	1534	638	116	1	6301	jwagNNqq2xvSwRbeqEE4uyVsXfnfBURMEgxabJ6Mcdw9AsJP2if	4830	6804	6804	1617163920000
9310	3NLZX2xzKjfH11BLwg7WDRvXxnzN7HwsmyobNgxexRVRue2UtZNf	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1483	84	116	1	6301	jwXoTbRQzbyY1Ln86vLD3GaVYnCYGJtGeuQSLjnQJVVai1u2XQQ	4831	6805	6805	1617164100000
9311	3NLqr8Nhouh3kCoJYKnGRtPc9BXU6Gvy4RESnXJ9i8hvdGHx6E9j	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1402	852	116	1	6301	jxwav2yKniS7ocJmXFRagqMVvVbM3RT9gyJLdUyJXyW7fmm45go	4831	6805	6805	1617164100000
9312	3NKcsya33uAduYYDbWT1Km87S9hQosQBebvm8NNTL6NtrVJCaUz1	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1440	1131	116	1	6301	jxHJPTgqToNN3tMesZEfTW4Ein3Z5RtDZAcHg79ttzqvrT3XVTF	4831	6805	6805	1617164100000
9313	3NLgdepVKoL3byF72tfpUNpVwfv1R91SsEcq4AKCQMbgfD5X9Kp6	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1631	794	116	1	6301	jx9dmbQng55er3wLytqdQ7qihGPmvUx2cxiuaubxUEpEt2YUyB7	4831	6805	6805	1617164100000
9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1440	1131	116	1	6301	jxCW9mqRYfwrjhCFq7CKn3RVmwnHtLeP2xtc9MMBsv4ocY1jfFK	4831	6805	6805	1617164100000
9315	3NKeTnDb59HiALqFDpJRNw3GW9an9WXkjTHES2rpVFYvmUwmn9KM	9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	1403	812	116	1	6301	jw7v9iidAaVXSUE5W4WxJxGTky8UcDz51VB4kXG41Ah6EVGQwNK	4832	6806	6806	1617164280000
9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	43	1184	116	1	6301	jwAtkWyHVeeoft2rqFTU7a9z5jcyp9Ta2sRFcr7dX1ttZzLtREh	4832	6806	6806	1617164280000
9319	3NKSq2BRpUWn2RGqzwa8zXL36eq9BQ8jqGzVNJsPZbr4L3ki4Rek	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1403	782	116	1	6301	jxpSraN9WdW4XN86HPCc7Nkq4tcFz2Y5onrDgCRnf5MCTjUgbwS	4833	6807	6807	1617164460000
9330	3NKGnC2e3KxFh8yixHLt1vLUmf5yzdChQWVDLxfupgPcrPLC4Qso	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1652	1189	117	1	6301	jx8zkSC82eDb4PRp9M1mnJsPeLzkW5cHTVLmzZEtUJ22UtqGM31	4839	6818	6818	1617166440000
9332	3NKD2duNMwZMg9UUyPwcmjkBpunC1tQ1q1ESdeG87wMWiSs1oPgj	9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	44	1325	117	1	6301	jwEpz4YdBospdd8yY4fgawf6Vxek2jZV9EHzonnkL6cDodq6oxz	4841	6820	6820	1617166800000
9338	3NLVdzcFP5GnLsLrzfXWY4cwN1ApjfbSMngAt27XaFZUnJadwLzN	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	149	1283	117	1	6301	jxq55pT6duWGQa55QW6oERJjAeE4Ny4FvjERrB1fWyazyCUaX8r	4845	6826	6826	1617167880000
9343	3NKxMED7VAuQjepeowYMGDjcynuvPLFk6qo3fiwyWZLX9dSwHYMs	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	532	1303	117	1	6301	jwU8pdabtH8aZYqWvcFWc39TNb2Tmn3BQQpgzYWe3Gyuvvgh2Xx	4848	6829	6829	1617168420000
9347	3NK8hio2z3Rw3fXWq88mKmuLxb3wXPth6kxzmoKhkbaPwfpVhku4	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1406	1393	117	1	6301	jwLS6gW3NPTbacWcEh7VrXSRmkMjB6Rd64wemGGwddYN8GSJ8yS	4850	6831	6831	1617168780000
9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	9349	3NKXEDEHrFyqnw5h8witucJUEg13fWgK8vXt7BrAUxricWymMqWu	1406	1393	117	1	6301	jxCKqn7Wa7ChBqUUgsi3oUEXrHFtfZiXgtHzzHyQDXxaBL6LQqc	4852	6835	6835	1617169500000
9352	3NLJ32n7gcAbzLBz1PNCc2L4HVQDuNipLYEifcCHAY7uDqQmpSaT	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1422	1211	117	1	6301	jx28DQsRmy74ZHtYTcnwoxjzGzNNkdvXrDCrD9KNg2cKr8tYkT1	4853	6836	6836	1617169680000
9357	3NLqqZUrqgyTBRB2AgnQxSd7NTY95xX47jebnHWVpjesaRFHX5py	8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	1403	824	108	1	6301	jw7DEqd2hSLA1V7CgUvswj6tHbrtdDYCLLkSGV8DnwKuhEjhYk6	4653	6839	6839	1617170220000
9361	3NL3KzYTYxidPdn1xb6qD3VQQvfAiNEhJVpeMyu8ZF5xDZoqnfMb	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1403	824	110	1	6301	jxspiuxeTzKsm7TvPv5WLDQxr6M3WDW5ZKdawxqtdJdft39YXrU	4689	6839	6839	1617170324557
9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	9358	3NL78w7jWqWuEtQKb2UkeZUsxdGGyL8FUj4pQLs5pkaMUUb2SfD7	1623	829	117	1	6301	jw8fugKr5qeJwSduhmVLADCPxtmprQyjsEub8GfehRzjrdfc47g	4857	6840	6840	1617170400000
9368	3NK3a7N7GibHSq19PRkC1PEEHMz4B72q8KeYmRnhCpPefWED7QkM	9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	1406	1393	117	1	6301	jwwmvsj7hThPtrcHQf32mPxHQ3CGYxs6o5HQrQZyALNERdSv1Hx	4859	6842	6842	1617170760000
9370	3NKmw5nXUK7eA1YiCh6xTVPChHa98nc2aVJyFyeQGAm8knQqxanX	9369	3NLhaVyMGexQ3c9ZXfxyroGWFmmT9Np6e982LtH6f7nDgKwiGPw4	1577	1327	117	1	6301	jwWVpWWoAo7BLq21SqqxZwikut9YDNn2EbhaDD9eGcSQukxa68n	4861	6844	6844	1617171120000
9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	1407	1395	117	1	6301	jwDwpn1gX9BycioVpTsYnhn26a2G21k6wrtroemNVZPfPnsvR5W	4865	6848	6848	1617171840000
9380	3NLdsnKFYKhnJa4XhY49Cavwppgb19sERJha9NEbxETzBHa23kg5	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	1406	1393	117	1	6301	jwKgHJ3yCuNKx1wTGrZjWrMrWqBnmMfD49UjLoWZYrpUJeKmqYk	4866	6850	6850	1617172200000
9382	3NKkeDxQKcEKQLk5ERwDQ5Zu7StUNn7R5K2mDk4ajpqg1HgJRsWp	9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	1403	824	117	1	6301	jwWzam1sEWRHEMHbjMHf8BzpsXiAfjXYRra8ztYR4k7fK1B9CdF	4867	6851	6851	1617172380000
9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	1445	1044	118	1	6301	jxhmSxrZaFvgXRfb4npVBsrjmoFDSQ4u1Ys8rDd5ZUhrtSSxaHD	4868	6852	6852	1617172560000
9389	3NLPvZnZyVj69Ji8fP4rF5E9X3SqxU3q5YEaPNfuchfxkmReKp7i	9387	3NLQRCJ2tCw5XiGE7irZZ3L9wjvQaeir1FeWS9EDMhsUZwFhSJJd	1406	1393	118	1	6301	jxH2BGWVkrw4SEKYj2xc5pXLMJDjBYpcQuEx8taFckXqY95UhAm	4870	6855	6855	1617173100000
9392	3NLxYbbJEeaB7W415RPL6BoHwCnPzU6mmtoyWDk4QA1vxExZF3kx	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1642	1121	118	1	6301	jwGpyFmi1gc7H5pPyDD4ZmLSXhLpQPS4y8iztkYqjN9ZirHo5TS	4873	6860	6860	1617174000000
9394	3NLJ4soJmYsyubopz4Y49wugG3FXRJEdvtjpzQBbSwC4Gd2zzuvR	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1481	790	118	1	6301	jxFUD3JCcqgjURG368n3BgPJn3AE8jnqutMdEoofSesbMRrAfbX	4873	6860	6860	1617174000000
9398	3NKYEjLGDD6fBaYcrxM7quAr4SRzw7bGrFJ9gC6j1Jj89NSJFMgG	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	152	1084	118	1	6301	jwB4s4iXYLyvx3nxYEwa11Luz6PHrT6pFTmg9vXQFT3aEPLGLfx	4876	6865	6865	1617174900000
9400	3NLnS6wjJYg3vYKbYq7sXLHZeNAx4SzTWuCysfznhxFL6T6pdE4L	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1403	824	118	1	6301	jwjExbth1e4dteAo1YdErxKPAu4VGm3EML1TppaPZuMWqAgNU1N	4877	6867	6867	1617175260000
9406	3NKDQ1yFEqzGg8kJr719Hee41JXZGbZH4jLTnueVoG47XAwbpWnZ	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1600	1372	118	1	6301	jwkkfmJ7ffnVgQ4Q5xj4wW9Go4d1PRaaqBVGht3NAzXXCFmJyQg	4880	6873	6873	1617176340000
9408	3NKR5hsAJe5D7wcTBpHgm5Xo3xstx6vGi527KnGBz8jcTLqN6pHV	9407	3NL3nnRYJeWAchnv6EqpPzw4AcSP18W6YY3xSxfVRjX3H7xSAmoq	1547	683	118	1	6301	jxofVxfEZAXeZAqJn4R6TazKe8HMu1J8rZXQSshvaBGJqZ2PDYp	4882	6875	6875	1617176700000
9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	9408	3NKR5hsAJe5D7wcTBpHgm5Xo3xstx6vGi527KnGBz8jcTLqN6pHV	1406	1393	118	1	6301	jwB8ub5U1toxBHiBx7p23wJmQtAFeMPhYXrV6UKhyFYCCA9Z8dj	4883	6879	6879	1617177420000
9412	3NL4UgPEKe1iPgs6Y9JBa9WtfjzNUto5ubgiuqx3dqbN6UtPoEyM	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1613	1349	118	1	6301	jwvJJ5LKgjxysGJFXJMfw9ygNJLYU4azmzwQLQ7Mm6Y131PK8gh	4884	6880	6880	1617177600000
9421	3NK3YQ5bQ99oKRU79VsAahfmTwWiN4w8p3DLnvHqpYhfqWnEa1DM	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1536	1067	117	1	6301	jwVuhUmyU8WmpMkpDpiJJYdAEi2zud5s3JNA2k4Ceg1jQPhQ5Sy	4843	6886	6886	1617178721307
9423	3NL95rqTta9ytBX8hFyXtX9nke2H5zvRF7wb7MgejLrzKuNDmhdV	9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	1536	1067	117	1	6301	jwkgx4CWEzRRxYkHyS8QFwTByH9nPhqXRM9pc1qcRiB3GovniaP	4847	6886	6886	1617178797600
9427	3NLRW8ck5raT3uuJdtW3HCh79e2t3XfHHitF7EVVHViwqKjEzRhn	9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	1625	161	118	1	6301	jwZHyvbiAoCYZF3Jf8DRLkzYaBKNjJoGmv5RJgSiZchisQLbmmg	4890	6892	6892	1617179760000
9429	3NKak1HxPZBNogDFs4LpBrCf9nH3W9prjJ66PTxa1Q2SGwLQ6fRp	9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	1625	161	119	1	6301	jxCR6wnWgBcgYK6BKpzo4vRPKUKHuba9HiM5RzC1zkgtdREMcV6	4892	6892	6892	1617179788086
9432	3NKtqNwqkpY12sreE86dKCzYBTv3u1ec9dEhsGGvxjHh8UqDPTp9	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1672	1285	119	1	6301	jwVbo6WgeGNroV7RUnFrJanfsZ96P9ZQrL2Spi6EQKd4EwCE543	4893	6893	6893	1617179940000
9317	3NL7ELkZkhWJUCbiRcSn7ZGkJcJrnJaEif7vipLu9e77Ma5xoEAK	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1542	1178	116	1	6301	jwL6c4jRtRP9RwLLfrvjCgJoPjcB33jjAXyuvwYC5hvUmfSXFK9	4833	6807	6807	1617164460000
9320	3NLFBTPQwvo1cRKzRtfJvafzoEgRJobDXFRYwWURJtENpW7AVgxy	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1649	1383	116	1	6301	jwZmPPQEfkDvv6cdbFYSZ6Vcm74W34AntCkFKTW1xvLxuBTEG1z	4833	6807	6807	1617164460000
9322	3NLiVe7XvCjzNcnofi1BugjF6ys2zpgWN5RLucvxsuVNfqvmxAbz	9319	3NKSq2BRpUWn2RGqzwa8zXL36eq9BQ8jqGzVNJsPZbr4L3ki4Rek	1406	1393	116	1	6301	jxngFnCQsqCR88Fs7ykhDxfMgmfdRTVw1wf1WvGa4hHJfW4BPjG	4834	6810	6810	1617165000000
9324	3NLhDUbDB2FTGwN6TkZo8CCMEeEixgLo1MBFsZyMGwLzb5Znr51E	9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	1579	1143	116	1	6301	jww3bJodLtGAGrVTdapurSbBmn8jtGnyLJr8nzDGsdQFQAWXTrM	4836	6813	6813	1617165540000
9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	9326	3NK7UmkkofTR7zjnErnr4XDZq3HDpuLr5MikXu9Tqx6CFncC6Bi1	1553	776	116	1	6301	jwkHXKJ7PuXDEch5toxDyowu7c1zWgaYERt21npY9ghBmZpNjiC	4838	6817	6817	1617166260000
9335	3NLseBG1UnaWrtRUJo36cyuBqABR7wv8iLeNqT4GARgnqBqcWdma	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1403	792	117	1	6301	jxJu1bnnNL9qwyhC9ezidxuN6hsenoEzztmgB7ya8quHeikfqFM	4843	6824	6824	1617167520000
9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	1406	1393	117	1	6301	jwvcVp4E14n7LBrLhcSykxogDUdCz3WnHpWMYYYm5JMZycpiQ3f	4845	6826	6826	1617167880000
9340	3NLmzjzBvrBEDF25X12t3ztGE9HRbuh91KXP68BqLegHey5ViV8c	9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	1451	1292	117	1	6301	jx9g1cyXXrU5K137dmtaz4dBCpiLqU3LhCt9oeNeitKen4eWhEK	4846	6827	6827	1617168060000
9342	3NKKv4etg5dgJ9QbgGWNabJaRDVjgbW6FapjDNwzQqoMBvUySv8M	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	1672	1159	117	1	6301	jxasHDEVoEmTtJ2mnYK1mRt15BLLGSKrJCvnDvcKKwuNCXVpoNe	4848	6829	6829	1617168420000
9349	3NKXEDEHrFyqnw5h8witucJUEg13fWgK8vXt7BrAUxricWymMqWu	9347	3NK8hio2z3Rw3fXWq88mKmuLxb3wXPth6kxzmoKhkbaPwfpVhku4	1623	839	117	1	6301	jwMuZs4cp9BQDHzFMSy9GDdhFn3uRfiBxoS49BKskeYK8p6L7Hn	4851	6834	6834	1617169320000
9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	9352	3NLJ32n7gcAbzLBz1PNCc2L4HVQDuNipLYEifcCHAY7uDqQmpSaT	1581	778	117	1	6301	jwoWTYbvV7RJeUb765XGgoDFJDFw7dc3ubKX3TmnGjokjQtudUp	4854	6837	6837	1617169860000
9359	3NK9KAR8Nsctj15B6JjCG1jCgqd9dppJvw1rk1CadYgPasGGPs79	8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	1403	824	109	1	6301	jxtLD4cCncbeFaY1rDffVbdb3mVQUNkCDM2TeQm4YSvRWoVbtXH	4666	6839	6839	1617170256864
9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1609	1333	117	1	6301	jwhMADabbbak4K8jFw3VSyebuVPKsvMcra8trWwLrJ8zRxtda6Q	4858	6841	6841	1617170580000
9367	3NLbdjUaMVXm5z266jzgzS7PsyhAihxJSStqAhguF1XaACr3hBJw	9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	1613	1103	117	1	6301	jxjezrnrZgTrBFNPoRsEei7Zgn82iSbcekW4TUhGF6Qh6vyx7vz	4859	6842	6842	1617170760000
9372	3NLiepWgqB6XDXQmURCUAGXX5JaeKc9BCFevgWy8iBGKDTczaRkK	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1403	812	117	1	6301	jwAnthCkJVcduHaajnaw3rvsvbyhBmqANqRVTH9sPSy9EDMnGM2	4863	6846	6846	1617171480000
9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	1646	988	117	1	6301	jwKgCYHq7AW4LFuFBHdcAfPnrcX1BPuecRms24Hqqn9SzRcc1s8	4864	6847	6847	1617171660000
9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	369	1066	117	1	6301	jxwDv9qE1rPpwFkTbZwoUz5LYT9hMmkKVSEDrmZoWVcZNcgShNC	4866	6850	6850	1617172200000
9384	3NKdxxnBaQV46BMkC1UEEPVsx6CdZE2ybZiYtNhCfSRPAJnjGKdL	9252	3NK5XU8tTEX3gHufSQ1dXcjtf17hTJA3Sd4weoAvpbgANkiiQGZ3	684	1106	113	1	6301	jx5HDAVZWTcZLyPfXoQjrWSamUDP9mT1f54MVAxJcQZxun1YDTT	4750	6851	6851	1617172380000
9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	9390	3NKaTyeASLSr3KT5TRY7qrFhyudsuxJYMpFoTQbh3jwvDatL27Ee	1529	1190	118	1	6301	jxKK5WXiu4kbZXw6qPY2UhykMscQY4ZdwSddLLJ9srC7RNVJx2q	4872	6858	6858	1617173640000
9397	3NLtGFznXrzVGXqpoHdgq2eBALz19BssHsQSshk5GXgJvWk5LVZc	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	1407	1395	118	1	6301	jwzvSU4KjUuYJPYVY14nxC9wGebLmkSBVVBfM7zWHb6rbKGUrdJ	4876	6865	6865	1617174900000
9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	1426	1238	118	1	6301	jwZhhbHrW7jXgRV2QJGuqycaaDs8w8qWJXneWje2QJBEZTL4fLf	4876	6865	6865	1617174900000
9402	3NLvnFzpUPSyVbriuVFgP8zFHb2gqucDF56uULg3FRmB54f9Fhf9	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1481	790	118	1	6301	jy1ACuHfv5Bu8Hj5cobDBJa3ZACsDAdm9BFopuE8GxQB5WTAV28	4877	6867	6867	1617175260000
9405	3NLkj8b9qmJc35NN7taoygvq5XaqXPufrM46igxRuAqyrXryYjEj	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1623	830	118	1	6301	jwjEifrBEqHrMyPzvBSdYiqFRFNKguY4U8ks3SJMDdps9nthUPv	4880	6873	6873	1617176340000
9407	3NL3nnRYJeWAchnv6EqpPzw4AcSP18W6YY3xSxfVRjX3H7xSAmoq	9406	3NKDQ1yFEqzGg8kJr719Hee41JXZGbZH4jLTnueVoG47XAwbpWnZ	1406	1393	118	1	6301	jwdVjZywKou9FXuHkvXhmMEfppiTcog5mxxDRLZmF77Y2ttLqn7	4881	6874	6874	1617176520000
9411	3NKj9AwN4Xabh4QR3SvXwvvmn7auURoe32aRySRoRoTCFwqQXdqG	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1553	776	118	1	6301	jxom3P7wnUAoh2Gg8rzXorZFgZJxar6nnQKfLstHkbF3Ut9k21D	4884	6880	6880	1617177600000
9418	3NLa6bedE3yQ7N7icWXVyjFx9uqXSn64R2ZVNLGK3Xdcg8GsFoPq	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1581	778	118	1	6301	jwh4Sj1wCbdFQXmAKPe9nJwjvj2smB5RLNXDi8oAaWnG3uQzcTz	4887	6885	6885	1617178500000
9422	3NKLpCQwVLsoc8PdhvgLcR4nrcwGCRV2LB36W8aRhvTo16wJfAtc	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	1536	1067	117	1	6301	jwJUWGwTA6T8JcoTUyH1YU9QGQJgmDtQhZx3M1Jq8idWkbvrku2	4845	6886	6886	1617178759054
9431	3NLin4hju4CkV7WtRh39RwH9g3mYpBTtkpc25V4Y6cvoCPtSvNcD	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1503	1151	119	1	6301	jwCtdANNcjPuXffyAUornpGbc84ARHgRcTErMr8ba3DNQ4ttbpc	4893	6893	6893	1617179940000
9434	3NKCSoVZopom2Fwg4gDKAF4sbLmieGeDhbNuZW3MFST9EDrVrKbf	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1447	1219	119	1	6301	jwwGdbHoYqCdSwwRYjUudDwrhs9TAhJonEVBsNeh9SRVdzLMAuS	4893	6893	6893	1617179940000
9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	9432	3NKtqNwqkpY12sreE86dKCzYBTv3u1ec9dEhsGGvxjHh8UqDPTp9	1467	1130	119	1	6301	jxZSyEM1ueRFSNtgY4igrGApTmASqqB4KnkkbTmiYmeBF9hHDxL	4894	6894	6894	1617180120000
9439	3NKUhaw6ixH1VReNzPza7F7UMDc6MmgP88qQoAjFBbQ4YgrwAGLo	9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	1673	1368	119	1	6301	jwP5Wo1KbJrpiMg1rZo1xb36ME7TK4QqkQmaC9EnaoREywZmJeW	4895	6895	6895	1617180300000
9444	3NKR3qcAcZdtW2rjX3HE8bD3FomKPYqBkAc549sAmgUKjM4weYDR	9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	1460	609	119	1	6301	jxLqdLg9aHkTrecrAmT4aKqir4Z7Q4RpHNhXwEDFy42912mSyxX	4898	6900	6900	1617181200000
9318	3NLfJzzFbpScHf34wQmrCMqsfWSTvDPKq9iQjaB2dnXkz7b2guTJ	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1460	333	116	1	6301	jxkur7DVGmLgHRLaVDkWPsEMedtmF4kUdHwjLp4w1doGfq8b6FY	4833	6807	6807	1617164460000
9321	3NKfxp4Xa3m1nY7nxcTEYhnPJe6gpXeo18WjT1VSzmNViGqE6rjJ	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1649	1383	116	1	6301	jxSi6ZTbE7ER17wjjSbBQGUvzQwhazx1jxn3e5d2GBJpEWhw7pG	4833	6807	6807	1617164460000
9325	3NKJBDm7yd82HqZQDHRhKoNMBRqCXu84b9gTiMZCMbjufWrFzPQw	9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	1555	1101	116	1	6301	jxKB38GChhGCNQNh3VpTZbzxdQQnmbs8LpCztjCXtbM5haz1xNh	4836	6813	6813	1617165540000
9328	3NL1VToHNNUWD64TC7nCnw3hdYECY1VYMFXJEWj7JNNRGxM8CjS6	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1483	1276	116	1	6301	jxXeeJLtGDtrhyggkwNfajje4QD3TZ33rAc6WxmWm3eBfSDaNax	4839	6818	6818	1617166440000
9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	9332	3NKD2duNMwZMg9UUyPwcmjkBpunC1tQ1q1ESdeG87wMWiSs1oPgj	1668	1370	117	1	6301	jxzeoV2u83ed3HPRJGof2spB3UsN4Ev8mLQWwYZPuXHEb4JHuYH	4842	6821	6821	1617166980000
9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	9334	3NKeuCuAZ4TuGasJWmQzRTU7dLcfWPvVz7PxYVNC3aRM8wU7HcCf	1406	1393	117	1	6301	jy29uJDbBznx7JeaMAQRdC2F9Hem343FDJi4kazb5JqvCKGqg3n	4844	6825	6825	1617167700000
9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	1617	922	117	1	6301	jxmoGBEdUGs6BrWGZFk5ZVHdAtvG5H4gNBoxUMhhFZ7HLiw13i6	4847	6828	6828	1617168240000
9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	9344	3NLHHWF8LzXmBrXrq5DMEDYApbbuK1CyUhioyQEYr5snmDM6R2Ne	1602	1123	117	1	6301	jxjCUmXdZnmHVJRGVZT7C7XESbisaAJFQaYmxpAEkFvYCqLE3uv	4849	6830	6830	1617168600000
9348	3NLDKv4fmMpHpSgcp55nrDznbXuC1pe8u7GbeX6ygRWAZJumEkbn	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1631	794	117	1	6301	jwhhTNBRSTch4DFUZYZru9kHHyqmzvrmfrXwx1gVh48FGarFYYx	4850	6831	6831	1617168780000
9353	3NLD6mapAYtvnMSoVSaSx596dWg6QfsRx9fEivJdDkk3woM3xXxh	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1406	1393	117	1	6301	jwd3WK6uwnustKLAyCR2s34zbSXCfQCqqhLHSK82FE1A4jV9XhU	4853	6836	6836	1617169680000
9355	3NKgJgCn8WYp6635vR2aovVnnG7TScuRe4fnaa6jfUTyC1moQBHu	9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	1651	1301	117	1	6301	jwdHBy3B15Wdby33Jbu8RNf2Kd32x5hHfJQxBoMRoPA2L3GF5zf	4855	6838	6838	1617170040000
9356	3NLBE88GMGmM9DSSXHW9b3kaa4rXJnd6ZZMnwQu8otXDeWQYMKab	9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	1651	1301	117	1	6301	jxnD4KfP7vka3EDtdC149E8w4i4W9DHvZe2q9yhRGH7kmoz7rzH	4855	6838	6838	1617170040000
9364	3NLcN2kGcLjk38wrCaqjam4gVts734mopoj3opB6wZ8VHmVuyQYd	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1405	891	117	1	6301	jwbcJP4g8PicExM1g3QqMqe7SkvMumKp39wvyqjFzzQxmkt1ipi	4858	6841	6841	1617170580000
9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	9370	3NKmw5nXUK7eA1YiCh6xTVPChHa98nc2aVJyFyeQGAm8knQqxanX	1560	925	117	1	6301	jxf8V8BUMwrdMGwyUKJt3pe7oAwjUiMPGgYNSR4GaeZNG5fyTJn	4862	6845	6845	1617171300000
9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1483	894	117	1	6301	jxD9LA6TWQU4sxgS42HE9ucpfXt148EWGATtHkayPM41PwVxYXF	4863	6846	6846	1617171480000
9376	3NLMZA8bbLrXyCBCvwAW2Jj1PnR8FYJAkJovvJVSHQeXwrXwaiiK	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	618	618	117	1	6301	jwQLQUsv5ZdVKQh8uQPpfoddAZeX6bc9x721DzHjNB1kAwwL19E	4864	6847	6847	1617171660000
9378	3NKxH6ucbf3K2tXLVk8ao4sJxP4MYpY6HKfnS97TgZkHgQ5P6cgE	9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	1587	1111	117	1	6301	jxD31n82WcDQYHNS7LWR38RiCZt5jgEowH1Ag7HtD52SJ8gdNh5	4865	6848	6848	1617171840000
9387	3NLQRCJ2tCw5XiGE7irZZ3L9wjvQaeir1FeWS9EDMhsUZwFhSJJd	9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	1585	1120	118	1	6301	jxyJsprkn5bZYpFdqKHNAvG6FqjFJ4xZ3A6SwrXL2nSvLM5Vjuy	4869	6853	6853	1617172740000
9393	3NLriz1StJpgR18vBxFc55qkoUzu7YpzSG2KtZriC2FLxfaceFiN	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1405	867	118	1	6301	jxaBFprxK1xq9UbJTG25EM8G12R1x7hyG9UkNLPH22XEKVjHtJm	4873	6860	6860	1617174000000
9395	3NKxxNRiYrZQqLdNXYR9DXZC43gYJ62d7j5kfKNZrZBKvcJRurZ7	9394	3NLJ4soJmYsyubopz4Y49wugG3FXRJEdvtjpzQBbSwC4Gd2zzuvR	1407	1395	118	1	6301	jwpZkueMHGqGvbfd9HebsJ3k3Sv2BUakFkg8TYpCYpTDnnsNAc2	4874	6862	6862	1617174360000
9413	3NLvkzhfzVek6WmVssgEMMyCxDkSp95GJ6mACRRLC9hdYAVKKFYE	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1633	1144	118	1	6301	jxiiPT3YccPdyMhQxsjM18wcRPU1GCosFj4UFZZ8LykN3KJAd1a	4884	6880	6880	1617177600000
9414	3NKjb8QhGZWxF8bKsi1oBByeBtZbV84mDPDHtnkhfYv5ai3fjv65	9410	3NKWEUoNxeAkTP9ZMUzvsZd2YeyizADniMWt4SjsdZkWU2XrSnmP	1631	794	118	1	6301	jxWYaKjHTzf1p7uF5MVBN5LC6n8hA1jygzpj8BWUfQMFz8nLedK	4885	6881	6881	1617177780000
9419	3NLTVTtrM4nFQVgLJk6eWfC8k7cLKrcYAVnV4yb5uLhwHAA97hXJ	9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	1536	1067	117	1	6301	jx24aFNgXZ3actCvwEJy5GhzZ1UnQUQcSeamvJJXwYpBptXR4yD	4841	6886	6886	1617178680000
9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	9420	3NLiF49n66E5QsvXFrGUhwdWvfvqdmcyRhw2xVWJsbqY9YAr4aBp	1407	1395	118	1	6301	jxPfP6UrVJYdc7VdyTmKHousG462HyLK66idXYvhYot29JbF8uk	4889	6887	6887	1617178860000
9425	3NKLyLQY9v9Sp5qnGp2fYbHf3mujsGxJeH36g9cj7uAZrpe5gahS	9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	1406	1393	119	1	6301	jx16Bjk4uZDvY1y5Lncq84nwSPXgUUSuiPa3AcNq1T5eJwRjXM8	4890	6889	6889	1617179220000
9436	3NLTYKgaKCWAMQAnWg2H65QuL9Fg29RNRtXnJ3C2q9bNLyWBUVnU	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1467	1130	118	1	6301	jwqKcW8oiSCDetkr8ym1xhCFnu3nK2NFnjjQYahUwKQefZkt9hv	4880	6894	6894	1617180120000
9440	3NKniw4VVngXcSu9dGz9ShJ1SwWjNE89VLfukeFRkXTVots6kKCz	9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	1610	1188	119	1	6301	jxf1fh6ZFsEc96fXA7tXc21B1GNWdzXWByAps8F3p2jdjrVDnns	4895	6895	6895	1617180300000
9443	3NKDNpS47PFou9tdYnSnAcwTNWW1m3vzpeXtKP4zzcsR87rBf7Kf	9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	563	993	119	1	6301	jwEteHUaSGenLL2jGufJdF5Tnf3xmVqdPm25eRdGrEWurdrks7E	4897	6898	6898	1617180840000
9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	1600	1126	119	1	6301	jy2Htjf9EkYi2HRu8Y5ptgX9AL7QNHcEms4PRpNkGyVqngFDhfh	4898	6900	6900	1617181200000
9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	9448	3NKndyk9oEw3Ai7VQ3YjksCvyrYF4VNTR3EwbfrqKDXdxanmmYVx	1547	1378	119	1	6301	jwMR1isBXuhnTb6HUAGiGq8mkWxcrXxsGJaUrPgKw6Ac42amJiH	4901	6903	6903	1617181740000
9457	3NKuf88S7XyUY35qAkarcMkrWWohUPiJ8aLvA5odSozJe1kfs8Qi	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	1581	778	119	1	6301	jx92mqZxt58nct5zyCVGfJnAUg6MZgZejanAqcaEGpPTQvzx735	4903	6906	6906	1617182280000
9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	1637	816	119	1	6301	jwXx2Cg7CkwdVVUPhiauC4SENuHX9yuhVoXVpwCLnv21kiCEDPg	4904	6907	6907	1617182460000
9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	9322	3NLiVe7XvCjzNcnofi1BugjF6ys2zpgWN5RLucvxsuVNfqvmxAbz	1449	385	116	1	6301	jxqzgNGJoHRdD2hLPqxfEEahfoa4DNmufGexKNmvH2gHze2ixBM	4835	6812	6812	1617165360000
9326	3NK7UmkkofTR7zjnErnr4XDZq3HDpuLr5MikXu9Tqx6CFncC6Bi1	9324	3NLhDUbDB2FTGwN6TkZo8CCMEeEixgLo1MBFsZyMGwLzb5Znr51E	1407	1395	116	1	6301	jwFtB3eMqEe3c7eUg7nqy33CtFACud3LszgnarYC84P9e2V24Ks	4837	6815	6815	1617165900000
9329	3NL7DMVy3biv7e2vSz5Uxsy1K4nQ1LzVPQ5PM4prF8qNtN4yYqzC	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1483	1276	117	1	6301	jxXeeJLtGDtrhyggkwNfajje4QD3TZ33rAc6WxmWm3eBfSDaNax	4839	6818	6818	1617166440000
9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	9330	3NKGnC2e3KxFh8yixHLt1vLUmf5yzdChQWVDLxfupgPcrPLC4Qso	1458	1197	117	1	6301	jxAmGUuq8S33h8jLa22ZUA3Z1ak2BD9S8FNombFZDEywAZxx16t	4840	6819	6819	1617166620000
9334	3NKeuCuAZ4TuGasJWmQzRTU7dLcfWPvVz7PxYVNC3aRM8wU7HcCf	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1627	1019	117	1	6301	jxxFPBXGxMUiNJupzx7n7Y5YD4tosLj2RH5BEUQFzzjh3bMkrVw	4843	6824	6824	1617167520000
9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	1403	824	117	1	6301	jxUgU83zf4hC1F3Ltvp2X7a9EnooCvQLPZ17UyJomWPes5pLDoW	4846	6827	6827	1617168060000
9344	3NLHHWF8LzXmBrXrq5DMEDYApbbuK1CyUhioyQEYr5snmDM6R2Ne	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	1637	816	117	1	6301	jwJS38ai5YsfB6nF8rgZ4HAVrfuzMbGQHHjkHkk88mE1JdaZJqY	4848	6829	6829	1617168420000
9346	3NKQEeUNdJZjJdSMcsnsUJUaFpvtRp7jLRwwDooAAS5U2RoroMU8	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1671	1239	117	1	6301	jxKgMNScsZ6RKGrXMobCDUvAcPBo4rdnBqrwoD8ydWGsc5U9ek7	4850	6831	6831	1617168780000
9351	3NLnC7XKeA3Aw1ToxYyTKNqAaB7AV53WkMtiDoLsRx3oUL4KoGnB	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1407	1395	117	1	6301	jxin24kLxQKq163Lrfu9dbrTGgueoEXFrYkndt3c6P1RJV7tKHT	4853	6836	6836	1617169680000
9358	3NL78w7jWqWuEtQKb2UkeZUsxdGGyL8FUj4pQLs5pkaMUUb2SfD7	9356	3NLBE88GMGmM9DSSXHW9b3kaa4rXJnd6ZZMnwQu8otXDeWQYMKab	1405	851	117	1	6301	jx78K6Y6AF9Q4QfJmNny4JxVTWgLV4rmDzdVsSw6Kqmr8qy9Grr	4856	6839	6839	1617170220000
9360	3NKYLVTxLTo3JyMfWgfEcb4HpzHrX6r3hyhkJXF9yMt5brdrFZnT	9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	1403	824	109	1	6301	jxv5bxyoQV48scxFk3V1o81VDzuCXKbx4gftX6mhL5uZ4VbSU9L	4678	6839	6839	1617170290935
9362	3NLSw2jHtAJYsMLiDW9npEM9ee5oXLeNe68o2pMHAknmTP5fRqJk	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1403	824	110	1	6301	jxwHygQ4U8U9PmfLdM8nJk6r7FiXwkKvEudkedzbS4rBWeSFwjj	4701	6839	6839	1617170359814
9365	3NKYGDThrEo24dtWYrpgHXuZQxtUT77MqLj5BTzA7mD41DmgoNEs	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1623	830	117	1	6301	jy1HTAA27gfCRPkDwCP69da7BExowSYKVnqJFHgFt3smr9Lqsbt	4858	6841	6841	1617170580000
9369	3NLhaVyMGexQ3c9ZXfxyroGWFmmT9Np6e982LtH6f7nDgKwiGPw4	9367	3NLbdjUaMVXm5z266jzgzS7PsyhAihxJSStqAhguF1XaACr3hBJw	484	1319	117	1	6301	jwuzoea4DAiznVh4xJKAKptAVcGWTJ2QJUKUYM32nrX7J6JQNuP	4860	6843	6843	1617170940000
9374	3NKxkXjgw63SKwfqSE8MV9QeVHsdDkASQWuCqJLxioaLSeQMXHdv	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	1623	839	117	1	6301	jx3nUvqkXLtpTagJZEfdmUbYZxBMbihiYGgwpNPZS6p1AFGJkYB	4864	6847	6847	1617171660000
9381	3NLWxwETvhSxfFCViVdQYgakSuDEHLNWib9s5TjhTKPX8WbVkzsa	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	1549	1362	117	1	6301	jwVQsPArij38b9u4hD6ZrjDyEzj1gejeYHLKn3bsFbEbodcvoGR	4866	6850	6850	1617172200000
9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	1407	1395	118	1	6301	jxvrNrjZYwJPP5D8hGaGCthqEdsJ2w89uTMmPyc2pUwzxg6M8gg	4867	6851	6851	1617172380000
9385	3NL7Rg3W2Yi6syoFpdhUvdMSfzkipkkLL73sJko3Ng2P7m2jpDA3	9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	1457	1391	118	1	6301	jwpjxCDPWCBeivqrnuYzMxU4PxPvPK4CVjZqe5cKkugg8p85g1U	4868	6852	6852	1617172560000
9388	3NLZLn6EHfdCmHwNYjXHzHSnJK1zS4D32wFsyHh5dHrtNJewvNhJ	9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	1457	1265	118	1	6301	jxx4YUyUXJUxvBUyP1v9nq1ZLFTsWvzR4DdtA5dvW1AsVLs2udk	4869	6853	6853	1617172740000
9390	3NKaTyeASLSr3KT5TRY7qrFhyudsuxJYMpFoTQbh3jwvDatL27Ee	9389	3NLPvZnZyVj69Ji8fP4rF5E9X3SqxU3q5YEaPNfuchfxkmReKp7i	1594	960	118	1	6301	jwFPwCj1ffqhuE1G2ZGx1Mpr4yxScfEaGAtoqSNreQS581dtMSY	4871	6856	6856	1617173280000
9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	9395	3NKxxNRiYrZQqLdNXYR9DXZC43gYJ62d7j5kfKNZrZBKvcJRurZ7	1633	1390	118	1	6301	jxogx4rfXN3AaeoQ3oHSk55KND626qXuvG5YTjBwRfr2v4A3S8u	4875	6864	6864	1617174720000
9401	3NLqfz6BRi7Ndmrj2aLX5ZDXKpxjpUmPhsAQPqk6kLL1q9YEzFEC	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1407	1395	118	1	6301	jxSXtyzDL194Bp7egDU5LDFK2QTncj1hnory8Sd4Wtt81XWdQKY	4877	6867	6867	1617175260000
9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	9401	3NLqfz6BRi7Ndmrj2aLX5ZDXKpxjpUmPhsAQPqk6kLL1q9YEzFEC	1579	1023	118	1	6301	jw8MFSqnC9jF24stpQdP8w9evAo1ct82TZCGQLMcrgqkiwDGYRY	4878	6868	6868	1617175440000
9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1581	778	118	1	6301	jxkELdeE1PG3epJQLT7K7w2CfCyrYeEbqcatgBr1ckcWvoyh1mr	4879	6872	6872	1617176160000
9410	3NKWEUoNxeAkTP9ZMUzvsZd2YeyizADniMWt4SjsdZkWU2XrSnmP	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	311	1307	118	1	6301	jxVBLwEjnNpnBqG29QjwYrybZcijstHFqCDJvGkGyVPqGrMg9zw	4884	6880	6880	1617177600000
9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	9414	3NKjb8QhGZWxF8bKsi1oBByeBtZbV84mDPDHtnkhfYv5ai3fjv65	1407	1395	118	1	6301	jxByexzB6sjHm9AL8niv5DrfkTmbEVwPTfmDuy7VydZ72EnvA22	4886	6883	6883	1617178140000
9416	3NKk8TLeB9M57zaPWsPhrSqF43g6Xw47yGnZpLj1kaSSYVBJR2A6	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1407	1395	118	1	6301	jwJcQYquCCF9DegciqY31VTsnvTt7DUpYgWeEa5iYpT62BfXr3h	4887	6885	6885	1617178500000
9417	3NLRQBFe2E2qHBrUdusKEkB6aEBFAn7dVJtQVvW8P2RLXuc6oyVm	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1460	1324	118	1	6301	jwtjPWZJpPfu3QoVz7zjRHhcQefN7j3cZY3kQvx7MCgjdo9FdKw	4887	6885	6885	1617178500000
9420	3NLiF49n66E5QsvXFrGUhwdWvfvqdmcyRhw2xVWJsbqY9YAr4aBp	9417	3NLRQBFe2E2qHBrUdusKEkB6aEBFAn7dVJtQVvW8P2RLXuc6oyVm	1536	1067	118	1	6301	jxuLjzK72xMHSWXfjer68DxsxwVmrBMPLm9hu1t9Q8ETPhHjrfT	4888	6886	6886	1617178680000
9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	9425	3NKLyLQY9v9Sp5qnGp2fYbHf3mujsGxJeH36g9cj7uAZrpe5gahS	1585	1366	119	1	6301	jxpVXr3Caco4cRHcyZUjuXF9s1P5BY2uZunPVj8ursdoT7KnbLn	4891	6891	6891	1617179580000
9428	3NKHKncRbBnSuQoNLJB2x8T4BFj3oQRX3YQBt4s5ggL9v72Rv76M	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1603	444	118	1	6301	jy327G9HyKkxfvLDzBo82pvtcxTJDQWSY2R9jUye7w6gBrHGNd6	4879	6892	6892	1617179760000
9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	1625	161	119	1	6301	jwuduTHhmiUENgFtN6NMN62dqdECcaz9RtxDTsmtKJZajtKZoJa	4892	6892	6892	1617179760000
9433	3NLkT5kL35bxohYFoAbkPwVwC4iM4DUK4iUsXqMLFKDb1uG9Ltb9	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1623	830	119	1	6301	jx4USwXghUicwBMeQw8nAXZcdoXKMZECK8jpmCpNEZkCaUYnmuN	4893	6893	6893	1617179940000
9438	3NKzg8aq8hH1Hi7KDn1SKVfxsWbhLSLKpAcAphz7pbigtuYgmvoM	8974	3NKCmhFkzQtxHt8UPXEn2jbXmz6N8N4m53YuJsvMCh6cNGrKmrW9	528	528	108	1	6301	jxVKXcCSiNJZ4JHYd1vRn8Mr4TxGQQosHH8y1aEuug1Q1p7kQV7	4656	6894	6894	1617180120000
9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	9439	3NKUhaw6ixH1VReNzPza7F7UMDc6MmgP88qQoAjFBbQ4YgrwAGLo	1637	816	119	1	6301	jwHs33zhbzgSECqdNmwC8kSMgcGQ4iB4fTcYk3MrEE8ZhMDrxMK	4896	6897	6897	1617180660000
9446	3NLajezVSmKVqRPj1ns1GGuQwGajiokbJK8RL4vwzJ2U8DgPj9mz	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1439	1153	119	1	6301	jxQhxUxhXzHpcnMsSKZKAciKwyLT3S7suCLK6f9UGeRn5D6ciQR	4899	6901	6901	1617181380000
9448	3NKndyk9oEw3Ai7VQ3YjksCvyrYF4VNTR3EwbfrqKDXdxanmmYVx	9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	1422	1337	119	1	6301	jx9KzLRNsmmfQ9CbGi6YBzJZPGhnyrvq8h6W1qoqtmhzxoRLpw1	4900	6902	6902	1617181560000
9451	3NKNdSjQ4Aqw86yFwungZ6fmh2EyLUGyZ6MJZ9U94deCUko4tLsA	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1451	1292	119	1	6301	jxRVArWSB66jT3A9fMkawMJWyjbdjCLMGvpGJEGejgzh9HMavgh	4902	6905	6905	1617182100000
9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	43	1064	119	1	6301	jwCiKQqmNbRncyjYD5gbBwf1rANQQuMtobEQKTm3qMbUffEqsqF	4903	6906	6906	1617182280000
9462	3NK4Mykw1AFE2bXQTp84LLFUJsZGGHonz86umzLoGSodenhCs3S6	9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	1577	1201	119	1	6301	jxejDxmSJvvbHF2Q6WVqy1y4qNWiSzxhKCM9wrSP8eTJtVyAP6T	4906	6909	6909	1617182820000
9464	3NL3qciic4FPkBj43WqFSXwUfsbREvxrfWY8r4ovP6TfycpAkokM	9436	3NLTYKgaKCWAMQAnWg2H65QuL9Fg29RNRtXnJ3C2q9bNLyWBUVnU	1467	1376	118	1	6301	jwj9eVmzz2exC534V32beUJ21rButs6rYnUS82FGGbhZnfNrNhc	4881	6910	6910	1617183000000
9467	3NKLm1JL1jUQruqXCqw28FeaAwrfkGnf2Gifto1gHGhSwvtnPsZu	9466	3NLZLvKTE3DXkL6vQ1iKcJXccYeTuqhGhXJ6mjUSC4CVdf1cGFcx	1440	1011	119	1	6301	jxdC7Qy2fp99GBqJMfAcKntxHsMr8x68mb6XhUd4WNkTS9EYFMB	4909	6913	6913	1617183540000
9470	3NL67aqzY6dKZAPBdE2UdyZ9qS25QXJEj75Xx51BLAHSQ6p31hPS	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1624	1334	119	1	6301	jx3nPs783DyHmKDyg4eBxQB9wav5ik6cZFCWhwMCz8bovQjeUw4	4911	6917	6917	1617184260000
9473	3NLi8MCzzhZWDznLkFb9PagSYLP7oAQhHwjSpVDTqm3frvoHDCFa	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1513	1253	111	1	6301	jwL2mFbrT6jHfng25yPM1fpUSWoA62wdhQx9E7sfzc9Cb8xsgTn	4719	6917	6917	1617184260000
9474	3NKofSpzmwXFqdvGeTtqnHfz3RmM1krsTakv5b7c1ojne6ZdvkTh	9471	3NLCbHZvackZkr3V3iSr2PgNpx3mbGdSk27Gzj5wEKXpphRj64am	1541	1052	119	1	6301	jw8EMQdm1nH7vF8nL5EicxZo52mXarU2Y7dQ9tAXzReav6AEUXp	4912	6918	6918	1617184440000
9480	3NL1LvDv9XEF4fv8wZzsNu1sAdhYzA2LC6tpgcm5VQbv8CfKtEgH	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jwnwKmdxpnKcKV56F9VxMEDazcxL5QHp7BJ7DsfvVyJkxU7LAz3	4916	6923	6923	1617185340000
9487	3NLu924SdkWTE7UA8Fp7CZB2UGmxW1SGLJfPEs68kYXxuXW7A9uP	9486	3NLtdnCTz4z2LzpHFMrEb8NK2ibMSjKjnZ8f9QapD818zZBq7Mqa	1637	816	120	1	6301	jwUML46e99jFBNxc7hFcZkKhBVGrbLSTWW5zi5dVPu2J3DzFsEo	4920	6929	6929	1617186420000
9490	3NL7KjGsXv4Rw92SeSeYCfeHEoCGfcLaRm3fBRG18CdEyknQSXxL	9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	1600	1372	120	1	6301	jwQ8hTz4hYPabLFHrmGudKMmx1jncYrWagwJgUGZ2F9FbKLmUSG	4922	6931	6931	1617186780000
9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	9491	3NLcPWHBuyBjrhKkBhQHnmVdbwaykaJ2LExHTZvsp3rVysseGsgF	1407	1395	120	1	6301	jxe22MvQKaHywwXQzmS5vaaWuEdJhreWCA1FgPbQmAhzWHxw6QJ	4924	6933	6933	1617187140000
9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	9496	3NLPTrC5mb6ortNwvRM7htkEEqKw8CULxwszELqCzX2JySBrz1cz	1407	1395	120	1	6301	jxGjpgp4Yr4VP8TUWxG4myVZ2AJM69nxk2nDMgkstGdi7AqGsbk	4927	6938	6938	1617188040000
9505	3NLUbAmgnTdd4U36VaC9WYoza6FqAQjqXE3xLwuF7vFE4QB8Q193	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jwxS6SbrXWd5djyhf1vZySELT6TZtsEPiYnvwzP4xC6QJj3jVdY	4929	6940	6940	1617188400000
9508	3NKtf37R4WAyCnZwcmwQpJFB59YpEWLXVXLpiZzqvxwpLahHFAod	9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	1637	816	120	1	6301	jxkywbTNzBuD7yQtonbW9owSyq5xwUSSZz1dmLvnHvP1rM7MTaU	4930	6941	6941	1617188580000
9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1406	1393	120	1	6301	jwqDbpSpr1eEzpbKPCq45GnMRzaR2ZCFikyKkdr7XRXdcLJaTY5	4932	6944	6944	1617189120000
9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	1483	1276	120	1	6301	jxLAUGk9XWwmYpyqPUxMQFrhnfv58we4B9AyrUaBJL8g7WseedK	4933	6945	6945	1617189300000
9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	1503	1277	120	1	6301	jwy3zDUxeyCJSyXhZ1tkG3wih4oC28k9HmXvifksPayWH34KbBL	4934	6946	6946	1617189480000
9518	3NLf5JV6xqvF3cddbXPKuvT4bziPbhKczPqF6B97UQhrpUz2otnd	9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	1407	1395	120	1	6301	jwi5xU5p84b6gtSTMryv6eQH8TgTEP918MkLDLbLo8bz8EKpiTh	4935	6947	6947	1617189660000
9520	3NLd6ytKxho88HLP6dsuVmWTzaQxPaEKVeE3V3sp3A72hDeGJr9e	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	700	840	120	1	6301	jxt22EiXgL3zJbe6A2SaTd9cBt8hnduvw3SB77psUqesLm2nJQW	4937	6950	6950	1617190200000
9525	3NKN1s515ne7VfHzyNsawEWx7zspHiFZXsMv7nvPVT3sGcJukeRv	9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	1407	1395	120	1	6301	jx47LaPf5zDMHy9UHMW5Ffrofo8GHjFLhFJc8dVdbiiRabMJ1R6	4938	6952	6952	1617190560000
9527	3NK2wvg2h6qLvnHj57sJc1KKBCdw9zHWQarwbshnwAijiVfwgshg	9526	3NL9pdhD4o9LxKGsdTwc6NnkZKF5bwuwcTryx6ZnjX4g4TwiYjRK	1403	823	120	1	6301	jx6sWhEJSJLteNRrUASobv1aaTuJsQeHZVy5ZALMEhKP5fBsmdZ	4940	6954	6954	1617190920000
9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	1673	1368	121	1	6301	jww6Zeq6zFRfNsfN6DAQKP6o8g3YHeU7aHiQT6XdWLZNHXVGf53	4942	6956	6956	1617191280000
9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	1447	1219	121	1	6301	jxGM8AbchZgyt76BcV5KgLMCfEaaR4oGNsULxqYNjoAAs5ZyV4D	4943	6958	6958	1617191640000
9535	3NKMTM8UsevFsDv9ehvMwM53cANJFDo7toWuE4wRe1mRhCdHg4aK	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1631	793	121	1	6301	jxpuSn4QB6gkTWEPknC9YomuiY1azJrPq8mXUGHZTgg14QM4Dre	4944	6959	6959	1617191820000
9537	3NLJqmfzekfppYeGUv5eA6zfyHc7PLBi1LSWUhoygFUViS7jhy9r	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	1406	1393	121	1	6301	jwboP8DW1pyQfRfCvgeT3TVKa85xdxB6RNSXcFgynvsuPi8kfo1	4945	6960	6960	1617192000000
9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	9537	3NLJqmfzekfppYeGUv5eA6zfyHc7PLBi1LSWUhoygFUViS7jhy9r	1403	823	121	1	6301	jxYDetiw98Ai2mSXEpo92GtQRVvjGBY7zmoabWWV4jVHvoVkxvv	4946	6962	6962	1617192360000
9435	3NLHQDgCQvFouSSTtb4uKvLFTrDxMFAFHqcqkgLjatgkZMaMLe3y	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1600	1246	119	1	6301	jxbmViHyPHhGasdi41TaBT7ow2DJnDkpwTMnbs5xwAfW6U6mzD7	4893	6893	6893	1617179940000
9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	1406	1393	119	1	6301	jwecb4929pozd1ef41kCCMrabGum2ajFY3CVhxuQNRjkJXudnzU	4897	6898	6898	1617180840000
9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1555	1221	119	1	6301	jwHp1aZuWUExxU743FRsE59DH41bMXbbHqcn1Gm7CkGKErEK3bf	4899	6901	6901	1617181380000
9453	3NK6bWB1nByY3YUEbVwv9PbRefL7vM26Tcxs51eW7bmAQyDGBdX6	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1509	1194	119	1	6301	jwR4C7VkeuyPddy1i2mf22eMZqRxmHFCvzwhYaUZfDNLpCGKGUN	4902	6905	6905	1617182100000
9454	3NKXdQpD9ELwhP5bdHMRx11kuT3A9aeB1P32GTfjXBGWCL4W2Nmb	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	632	1136	119	1	6301	jwFXnHPHrHGH7nFFFtzqGhwZsAUzdDD4uWyfWX3yjnV1X83ycPW	4903	6906	6906	1617182280000
9456	3NLT7R18w8yjNb3ZdK1aWtgwm4dLyEFM6oPc8TuVe5BWqQaYvdPj	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	43	1064	119	1	6301	jxCBwDbrwTpaAVX2kq5sTuh44Hk4n3WRcADSDE8ckhzX2TCJbmR	4902	6906	6906	1617182280000
9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	1406	1393	119	1	6301	jwnh18jhRPU2jxBwrp3zEMRqBWuF9FqGN5xYRbxzyjBQuJDGJma	4905	6908	6908	1617182640000
9465	3NK7rMehm2oFF9ijK85XspS5T6PH8LXfGLUHYA8BeWM25hbzdVeq	9462	3NK4Mykw1AFE2bXQTp84LLFUJsZGGHonz86umzLoGSodenhCs3S6	1467	1376	119	1	6301	jxP8c6KTKGoWa69VBm3XApBkVNEdVZUbGSVrGLzAtSAteeoKYMA	4907	6910	6910	1617183000000
9472	3NLpZCP13aYZn3kC7N6ZeBMJVi5iTTnB2Q2fBYbVScSUmEzbgT2W	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1600	1372	119	1	6301	jwsN9a39D9evR3d5KzRT8vdjCFzUtk7QKdZ6aodYjNxLDGVqb98	4911	6917	6917	1617184260000
9476	3NL4fm5ptcssT9S7Xg5WmhAJxwth99G2FTwKw7dG31y7DQa3pV2B	9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	1619	909	119	1	6301	jwbDLjMkhAxcEU2ogzi9JowMeSUVa6otkJX22TYPhehSxnWN2nV	4914	6921	6921	1617184980000
9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	9477	3NLqWzv4YJh4cLA9vnK8w3xLipnqBBsL1sPvYTGDfrfX41aPqWar	1407	1395	119	1	6301	jwjBicRu9SGKMVEyYLo9iYGFF1hiKsaz4QzrY8zu5kEKxgWFYbA	4915	6922	6922	1617185160000
9483	3NKGth6jNVn9RGvzqGCgsWiGnJBwsm3SR6RQmER7P7dzNKpcx8HK	9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	1646	1354	120	1	6301	jxxE8b8S6oM1mQrUR9BnXvCzxjh3PJZrGmoWFTxW54VMqHSNmEv	4917	6924	6924	1617185520000
9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	9487	3NLu924SdkWTE7UA8Fp7CZB2UGmxW1SGLJfPEs68kYXxuXW7A9uP	1403	824	120	1	6301	jxzxLYFQixfkV6nD6BsBkP7PUn2dktyhMS948KxyF4EkuojfFkD	4921	6930	6930	1617186600000
9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	1611	1341	120	1	6301	jwA8qdWL3kTYoAgUUGBBtfffCWfv8BPuvcLpsambTSiPXW1YVpU	4925	6935	6935	1617187500000
9496	3NLPTrC5mb6ortNwvRM7htkEEqKw8CULxwszELqCzX2JySBrz1cz	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1447	1345	120	1	6301	jwzKFBgJcGZ8Ci3LofsrUkYzLytTZDGbZJJE4edAyTZnvQFnh8m	4926	6936	6936	1617187680000
9501	3NLGq85q8eUpBfxSxh8S9vAFhj4gLLgcYh3jngzHBm9M3dmXa8s1	9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	1405	873	120	1	6301	jxu9hCExEG346YC62sQsBrjpw8KQpZ7VWbK5xpqcCLvVALm2fE5	4928	6939	6939	1617188220000
9503	3NLKddJ34omHTPyymRF25XKnqJXeT3PWj7PGbyGSd2FdvVNoFTdg	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	80	1027	120	1	6301	jws1VA73npLeXGYdpqyu3sAopiaKH9HZ7hYCAb33GaFSabQEWvT	4929	6940	6940	1617188400000
9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jxPzDuc9g4jFT82jXmHC9VagM1TDY5kXh2xJicWKvW2K99Rg4Wk	4929	6940	6940	1617188400000
9507	3NL4ag4td87wwKSqvHP9wHxZFHgdax9S4zXm6nbLNaeKq6dW2vME	9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	1407	1395	120	1	6301	jwHJqm1LSFcYoTUSbkcVFLTcP57C5nGPafB2TAJe7TQ1dAYsVEg	4930	6941	6941	1617188580000
9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	9508	3NKtf37R4WAyCnZwcmwQpJFB59YpEWLXVXLpiZzqvxwpLahHFAod	1444	1381	120	1	6301	jxVyuwiETqG7wMcUntpBAEXxP42QWoBmXGd2cPRBBRhqLaBnGzh	4931	6942	6942	1617188760000
9512	3NLjyvei5QbFux6nn9a5UqmC2s2WAGTMJNDKKX2wE6HiWBWMiK5Y	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1637	816	120	1	6301	jwQDGtd6jQWrqTbiq41rggpxyUBoq2zSK3GaE5GX41D5ea5huGb	4932	6944	6944	1617189120000
9522	3NKFRtXMZ67d17H12j5nvTXcdMHu9oGeAn75MPMfdnurv6tM4SV5	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	298	1062	120	1	6301	jwesCPCBrzf63DDwTodbbNREHyZyQn2scun592Xc59jfycjh3uC	4937	6950	6950	1617190200000
9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	1637	816	120	1	6301	jxowAYmWAtRiLmzFKYisn79NAgDgyA55sJhrZEDDziBqyaj6SKP	4937	6950	6950	1617190200000
9526	3NL9pdhD4o9LxKGsdTwc6NnkZKF5bwuwcTryx6ZnjX4g4TwiYjRK	9525	3NKN1s515ne7VfHzyNsawEWx7zspHiFZXsMv7nvPVT3sGcJukeRv	1672	919	120	1	6301	jwSNkqKNAP7m8HJvxnVvN3hfm97s4PNvDLJ2WiNKUyeM7nh8HFM	4939	6953	6953	1617190740000
9531	3NKw3YpbFd3Sr9GNKgj9QHwob9QxSnmZEQpG61EEKM5CTfjbM65B	9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	1451	466	121	1	6301	jwKXwXUk5HUg2YTnHjpZNi78KAUmK6Fn8ZpFBNFmyFPepHSLGGb	4943	6958	6958	1617191640000
9538	3NLsXYbKzwUkDTuBDjv15qrjT4NxeKBPuJXPRkgrboDZvLvwCn1h	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	1637	816	121	1	6301	jwcq7mnTbQSSTpS9wdbz6fCnirNoVEbEkY2bqwno9YS7J54s9wd	4945	6960	6960	1617192000000
9541	3NL8NVPSuyXntkt6Q8TGRgWaLrgmhmePx7cvL6c6JannS7i6VExx	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jxJDpuzFMqXzZfqNBSAdwBp5YopdhxyG8ftdsJfn17uTxBjXoNX	4947	6964	6964	1617192720000
9543	3NLWDCs62HuytfujK59FUfAXTHUphkLbd9G16Zw41cBEDh14o4ds	9540	3NLHTfwxxQL2VYaQCt6KynXatrDN28HhtwtmLMkxoDSFnmEEZSFL	58	1281	121	1	6301	jwL9s482VDxNu1AT93C7wwtzHu9wAih42ogqL2PkgJejrG2sXhS	4948	6965	6965	1617192900000
9546	3NLxGSSJQAr2orgbXixeEQnUc2P6oD4Sai5VtwbwXXjzRmJdBnbz	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1560	382	121	1	6301	jxd29WsbBuAYsamYixq2LzXmTbx5joPmWACSBe8tryfWbGatNCS	4950	6967	6967	1617193260000
9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	9547	3NKuuMjf7iTAGM2jULX3sSBxZ7Q2ksBLEHJavQsrX56ig8FAscGQ	1426	1118	121	1	6301	jx8gqHCkmrMfurDtZqosy3CjsVeB6ypYU8N66CsdUxbPLCvYc1E	4952	6970	6970	1617193800000
9557	3NKpCY62QEB7DyMhCLdeheRKJQAA9pKKhW6fYx5msznpyRT4HdV4	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1654	1340	118	1	6301	jx7sgrVeZh7vw3LqPVLRCvbT4GbAQhKEqK6NdC7zEz7Mj2dDinU	4879	6972	6972	1617194270012
9560	3NLvvFUqjJEu5mzwPvRLYH8X2mLZs9QWPUvkExBbXNbz5c6SJ7nk	9559	3NLQPa3E6hcVo57eUXhGJSkBVXE9XTK45XKpiLtwJQpxEdFnxEL9	1631	794	121	1	6301	jwCdp1xBTwScofT4m1f3ZCupYV44SmRzBS4LYAQKTguMyCR9u6Z	4957	6977	6977	1617195060000
9449	3NLoahW5TWn6MeXACZHSn5QqB5dpS1Gr5d4wkPM3ARFWAx8VUuBE	9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	1585	1000	119	1	6301	jwF849KanjZHxVCr2rj11LvkdELa3MqCQhLoZcU4HshxLzakKTb	4900	6902	6902	1617181560000
9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1403	786	119	1	6301	jxVs8yEMLe7fvuCx7PesWEipq1hjyH1N7oztXJyf41xuq5RcSMr	4902	6905	6905	1617182100000
9458	3NLm9jZoUHT549NvMaMnmg7MzxK5EKCMCo3pAget8xfb9YRYnnx2	9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	1407	1395	119	1	6301	jx2gFuyNpd7P1mrRGn7awCo3V9ywMjTW6BM3FSpsrGkDuqUdqxu	4904	6907	6907	1617182460000
9460	3NK7wtazXnWNCc7pz9ZFL31r7zgbrRrvhU1aTtwmqj7RnoLPuTUz	9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	1501	994	119	1	6301	jwVQ1PbwhBx912SLHfmonngm8BmADikE1iXTHBqBRGkY19apeKY	4905	6908	6908	1617182640000
9463	3NKZoHDnsGViDdZvgJJaYWeAwYVvYwGwrLiZ1hKGA4jyoZv2XTQQ	9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	1577	1201	119	1	6301	jxaCPxcAv3XmaL3D1ND4vcKLL4FJ6X6eF1WyYTqnJWuuMR3AxTk	4906	6909	6909	1617182820000
9468	3NK5pzWjnaSuwAj2ygDJ2fKYN2LJmKYFy6rT4VAHcH66gbZ3EkDf	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1440	1011	119	1	6301	jwJ2QZ3D7CSw9iRCX3hDK5tbXKWGpVfRPq8rBLJ3PmfkEBmAtUm	4899	6913	6913	1617183540000
9471	3NLCbHZvackZkr3V3iSr2PgNpx3mbGdSk27Gzj5wEKXpphRj64am	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1624	1334	119	1	6301	jwzUkZRdMymWoUSpsq18RSr3P6SUs5MnWrNd6dvtAe4gJkns2LD	4911	6917	6917	1617184260000
9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	9474	3NKofSpzmwXFqdvGeTtqnHfz3RmM1krsTakv5b7c1ojne6ZdvkTh	1656	1343	119	1	6301	jwLF3YbKHy4zCpjJkR5x8MvFeKt9hwtho5CKzJcto1KNjNu9tRK	4913	6920	6920	1617184800000
9481	3NL4ynbi2YP2U9mvEL7JN6TfPNHXb6KNEMtCw9aZfNWXJHQ6Lnu5	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jwRP8JmfbevmY88EpAQiY8MTUZ2eYt1scdrHrUrNzNBvGU3oavU	4916	6923	6923	1617185340000
9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	1406	1393	120	1	6301	jxBiQ6DTmwW8XzrhU21i9cavtjjEqoqxSkFXhTwxs4GFes2S86n	4917	6924	6924	1617185520000
9485	3NKawVHcABYZJQfs2uid7bfEvVHUiqFfE3bbpUwr4A1GWPANM9q9	9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	1406	1393	120	1	6301	jxrStdUECewmjCgk9VEFgVc9CDMFL4rLSsx4A9PzvTiFd2shncj	4918	6927	6927	1617186060000
9493	3NK6ErJs9JEtgg6Kr1osgW3zGLQnLh8vFstT9oW1DTS3mpmPpCuf	9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	1447	1345	120	1	6301	jxiBTdRV66KuFrRpy4CKTxae5KRaHvbZnp6aGDdC8NFLoDxy8fZ	4925	6935	6935	1617187500000
9495	3NLTgpeTBs3dPtYXKp7uKVxfUEvtND7VtUnXFmoML9S3MPKst4Rc	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1403	824	120	1	6301	jwpAuWSKpezsfAshe8n9TQH57hHmMfpqgsm52MBxwGp3YdtebSS	4926	6936	6936	1617187680000
9498	3NKwmRr4bvAFxh6E5qSZjX5knotmXCmWnMQwMk5VGNzUG5yLUKqA	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1581	778	120	1	6301	jx7UMd4BCDVaFczPKc8gBEy2UbXh2gMomX6tJiX3dc999JTxpW1	4926	6936	6936	1617187680000
9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	1403	824	120	1	6301	jx9jVjRpRCJVKxis7XCPUHodMjtX8kZ1JpMhMGmmYSWEfEFwEEL	4928	6939	6939	1617188220000
9502	3NKrWvHhmtaeuxyYS5nS3jMAgK9pnWqZDPkQ4xekmsdjMQPhTqJu	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jx5KoWipr8vyMr4KEd5BvJNjdNzsLwQ6WTbo3HL6FFTiuJEbBXp	4929	6940	6940	1617188400000
9514	3NLgKS8osPjSf9Ekgdfiv5FF7MAhMmBjjQAttZkefZGyWzUeXGcn	9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	1490	1274	120	1	6301	jxMDjbvfG1xV7B7VszrxceVBTvRZLHADjYrr3bBfrYj5uf3Lcfq	4933	6945	6945	1617189300000
9516	3NLp1Mq9kMRKZhzwh15mzjAUHJfdYH8aNeRo4mEBPrwHe73XHXgm	9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	1406	1393	120	1	6301	jwJRyrNveF4p3sNLK11yhemgr77Hr3e2xYaenwHRrYm9zAgsqbj	4934	6946	6946	1617189480000
9521	3NLiAYG7p7ZVPFjqLC559xhqKDGNHHAE1a1xaAosAHChFyq1rpa8	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	1474	1329	120	1	6301	jxpzx9fGdPSBPMkCyVPfmf2kZWqxVz3oczfpaLsX3iKnfuBBBiK	4937	6950	6950	1617190200000
9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	9527	3NK2wvg2h6qLvnHj57sJc1KKBCdw9zHWQarwbshnwAijiVfwgshg	1608	1163	120	1	6301	jxNPSG6vSCYmNCZ9TBKRvZF6jR7AyUKBXqiFrWwm1syZGdqdpgF	4941	6955	6955	1617191100000
9533	3NLWzV8HML11G6oJAWR2yfbAWw4NoGDWboL4dTMi2DgxccFiT5v7	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1407	1395	121	1	6301	jxy6iqMtzQoj59D7DL8WGgzoXzjEt928oBVaJdbyrzyE9HqJd7c	4944	6959	6959	1617191820000
9540	3NLHTfwxxQL2VYaQCt6KynXatrDN28HhtwtmLMkxoDSFnmEEZSFL	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jxKfbye5Xoqr9ZgGsEdQef4mtWG9pc7F6w7NGA3E4uDgko43UPa	4947	6964	6964	1617192720000
9545	3NLEA174No6FBACGn2zVtF3tBXoQfiVuV3bGhC9hRfDtQNwQqbkJ	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1529	1316	121	1	6301	jwVYJaBknELbnqXkH7p8MTvmKrgDgVftM1cznrjoNNcwpXLHUgU	4950	6967	6967	1617193260000
9550	3NLPPM89pHTLwbXoeBqHyLC8FHzPGBpWZXPtFuj9MHLcA5v7FFLX	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1560	1291	121	1	6301	jxy5ZAYkpoqZ8nydbaKmNR8vLky6HUT4w1nh5xMDUR4MjetDpbs	4953	6971	6971	1617193980000
9552	3NKPe7FAmagxNPmWemsPUHAQMtj89GvTf2dLSsS8atrVoVdTNj7Z	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1654	1340	117	1	6301	jxem4kEyp8DnjjnTiEf9xQU6fUFNbvyoK8yEh5n7y8ZAFpgn464	4850	6972	6972	1617194160000
9556	3NLNsDzvK9W5fNY3vBMvKjd91jdAvURjW8BaAprvWVeNy4bjU2X1	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1654	1340	118	1	6301	jwhNikUgUQnkuMgBWQ4mocpVfiqreWRuyuMUUDXodPxLKuTiHs9	4877	6972	6972	1617194234287
9559	3NLQPa3E6hcVo57eUXhGJSkBVXE9XTK45XKpiLtwJQpxEdFnxEL9	9558	3NKrJwHc9mg6ioF86mKvtmTNiT2sucQuHPJziXvaJS6oCS2AyHZN	1594	1326	121	1	6301	jxNhaLtBCiBv8TQCpvKTzhkfFsGAu5PaDCvDrrtijh3cwe7bqhM	4956	6976	6976	1617194880000
9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	1402	862	121	1	6301	jwpm93FJ2w6ZzAfXUtyFKwApjh2NDoDVDfdH9U64itXwvFXvWku	4959	6980	6980	1617195600000
9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	1656	977	121	1	6301	jxN8iDrZNBASoeMoNLjavpjz6BnRRG9rXYpeXfqB2y8iAq62ax4	4960	6981	6981	1617195780000
9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	298	1062	121	1	6301	jxd62LPTGjYuQcXUH6dRrRbood6d83nWNiTWrvQ3kiMFWTzAa2M	4961	6982	6982	1617195960000
9572	3NLktzER5aJZGwrCZeoT93U3eUkiiyoaBotS26L33tWiKykTZz4j	9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	1403	824	121	1	6301	jxGctZcaRbM4GPW2t33jhpEQUxsWp6XEitLz6dW9jJnpxirHvBc	4964	6988	6988	1617197040000
9575	3NLeZpvjBbCaVoTGuEsaMhCxdHdK3eUHZuZCUz1xYigUUUHkf9Qr	9574	3NLiJ4giUhxtU5HLwCjs658A4gkk5P82nNEx4M4nxxNNoxbmeYYx	606	929	121	1	6301	jxsbUFkceHDR7PNYkcCqnyk3vUkAmVBvF2JrJ4KFTMBhKSVEouC	4966	6990	6990	1617197400000
9466	3NLZLvKTE3DXkL6vQ1iKcJXccYeTuqhGhXJ6mjUSC4CVdf1cGFcx	9465	3NK7rMehm2oFF9ijK85XspS5T6PH8LXfGLUHYA8BeWM25hbzdVeq	1406	1393	119	1	6301	jwF8NVfFMhDe4mPJWY4vPVi36jpSGx4qfscNMcVfwnckxiiSeDg	4908	6912	6912	1617183360000
9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	9467	3NKLm1JL1jUQruqXCqw28FeaAwrfkGnf2Gifto1gHGhSwvtnPsZu	1403	786	119	1	6301	jxt1NPh7RqA7UxXFTei2kzT4qixSmaHFkTTPo4CP4QzQUQN4JnF	4910	6916	6916	1617184080000
9477	3NLqWzv4YJh4cLA9vnK8w3xLipnqBBsL1sPvYTGDfrfX41aPqWar	9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	1406	1393	119	1	6301	jxwBYWmdLb2tSsYuv3ZprQNFo2TcgR7QDRdLmKG8nJzsg5nSifU	4914	6921	6921	1617184980000
9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jxzEZSWd86YRBVR7FW94iecNmgwLjsv9RSL7YKSJvK9RzbwWA4i	4916	6923	6923	1617185340000
9484	3NLstK1ydLpv4Z8LNX3YzyJDQiMEFAsmVbkepzyfZE4XG1qPdD3b	9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	1403	824	120	1	6301	jxMDbtLXto7opp5YbmnXrvtkLrmVB8YuxEmsbiX1A3936rXYdBf	4918	6927	6927	1617186060000
9486	3NLtdnCTz4z2LzpHFMrEb8NK2ibMSjKjnZ8f9QapD818zZBq7Mqa	9485	3NKawVHcABYZJQfs2uid7bfEvVHUiqFfE3bbpUwr4A1GWPANM9q9	1422	1091	120	1	6301	jxtH7VmD5o6fbVpAa3dYVj6fZ8Bx785sZnF7bQx1zC9igCSiSnA	4919	6928	6928	1617186240000
9489	3NLBVg4y7d9dyzP12yMzTGBaKpPdcyStd6j8k3yzM7eP8dLqYsWd	9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	1609	1333	120	1	6301	jxWt8V9udHNCjtWRKSBHirGe8SN4FzHuT9Cuapz9rgka8epmbmu	4922	6931	6931	1617186780000
9491	3NLcPWHBuyBjrhKkBhQHnmVdbwaykaJ2LExHTZvsp3rVysseGsgF	9490	3NL7KjGsXv4Rw92SeSeYCfeHEoCGfcLaRm3fBRG18CdEyknQSXxL	1419	814	120	1	6301	jwk2e4XQUjkcYpKbR3wSdtvqUiRSWAT1cfzbRW3CLFDLWkQBBh5	4923	6932	6932	1617186960000
9497	3NLEqEYGQA7g6H3d2Rcg5qFpjfp6JLA2uYYw8A1a4Dks1dmUYAYU	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1406	1393	120	1	6301	jweMyJ1v2Wp1Aothst6TJYQ38cFGrBi1YTBNAdtHsCx95ULEkug	4926	6936	6936	1617187680000
9504	3NKbsuSVHhg1Y2UrsrDG9RPFzkE6XqsGPeVtsbPuxYsBsazaNQjg	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1407	1395	120	1	6301	jwjjdZSbkwSC8BUx8fAjX9Vgihm6H7E2cQoc8rxeNA5ZV5pJBhS	4929	6940	6940	1617188400000
9510	3NKbqMgLTZcZWnpzYVbZLr5FH7pdcN52B2QqvCBhe4WR6VHRZ1xZ	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1444	1381	120	1	6301	jxJpRks6WaBcPFYbPSZgZsR1LQ5uT4HZ2mJxyDk5u8tg76wEoiT	4932	6944	6944	1617189120000
9517	3NKiouCKZgChh8k4EVz4yR5AfKCY3Fgw22ctjvFYGBR2dkiatupB	9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	448	1305	120	1	6301	jwEA2H8gqwqQCrorv4MPPBTaSc9dDcvukAKF7r8VDVEX2bMEtT4	4935	6947	6947	1617189660000
9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	9518	3NLf5JV6xqvF3cddbXPKuvT4bziPbhKczPqF6B97UQhrpUz2otnd	1673	1368	120	1	6301	jxFaVMaw568U7vrr6qTHdQ9eJoM6PsPiatHRFpFgoyNGVGUW7gh	4936	6948	6948	1617189840000
9524	3NLwgvb6Xyg9X2VmX5FR9K2KF7oLTWKvCVb9tgFx6Y7dnviX2CMg	9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	1627	1385	120	1	6301	jwrJp37Wnzt5cebkuFwJ5HUPvESsFj8xHgYr2TijWdZrYBYf9Si	4938	6952	6952	1617190560000
9529	3NK5k4bnLLxDM6DNVvMsjqkFNge82U1CAmvgxyXNWdC94G8Dy6ic	9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	1403	824	121	1	6301	jw8ee1MiJwGd7zeV4F2TCEVPzkMjzrwyb1PrAXjsFpLVMB41a3B	4942	6956	6956	1617191280000
9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1594	1200	121	1	6301	jxwQMLkDFmcLrAE1tDzvS6xRDihjNiWvZLP39JZdowZLLL3JYZJ	4944	6959	6959	1617191820000
9536	3NLeQ7RCQ9SGL8ieY2oSzdc1ERBbCDiCmx4KZa9jtLE6qtMwuP3t	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	43	43	121	1	6301	jxGdmZt4WPFnUvetRxuyKWEJzXS6evChtxQdvjHpaZAPSiWUtnR	4945	6960	6960	1617192000000
9542	3NKurrEwNKLALXndMpRjjPF5Xz1oq6HkW43TCA3hqyV8PxXVp2Vh	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jwR1q4HNsPqfFjBMqHVwvkHRKbZBSCeMuzVofNE3M3xfnaWBFuA	4947	6964	6964	1617192720000
9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1608	923	121	1	6301	jxE5XdEKA3stQ7gJTTi9e5BHYZdeuCtcEVpMZsrFCVrHqb43VvE	4953	6971	6971	1617193980000
9551	3NK6DBDTx4nzMF1ZeBW29QvWsydH3k2tk1Q2H2rYyjobsCLngWGM	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1560	1291	121	1	6301	jwy2X3xD19dj197qwfZUM4WPKUQwduv6TQXPstXtJTSpWXN1RAr	4953	6971	6971	1617193980000
9553	3NKAUTetUQzAvPLw2nfyCpu6gNHE422duKo4tKV8QAZrZStMkqm3	9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	1657	1344	121	1	6301	jxBTSvHEAPetXPc3tX73YnKYiCQynMsrkAdLrUBEsoWeucTTtsj	4954	6972	6972	1617194160000
9555	3NL8jkkwW75ViFVFopo6MU2zcK97RAz1mJxrw7w2htsCQZtsCJPQ	9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	1654	1340	121	1	6301	jw9D2h2jJZpKbz1zzSfAe7mMxktYg1pY16UMj5HCVuFv6STQG7z	4954	6972	6972	1617194160000
9563	3NKR3UeTE8cyJLHXNJqfAF5H2M86872FFgxkfxYRs1Gs7VpGvpwf	9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	1406	1393	121	1	6301	jxJyczSnwSdPLwBk3nKgE9pri9MejvoLJXfUxaVHv8tpyGBggpp	4959	6980	6980	1617195600000
9568	3NK8EQnYri9YkBiKwjXeBeFm9S2muM5Fcoae4PNnfcmHJTd6pUtV	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	1581	778	121	1	6301	jxj42tEPLZnKua49525EKubhte7Awi1SAadGS5B4gLpRj1YpqMi	4961	6982	6982	1617195960000
9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	9569	3NKPvCsgvM8QYgJ3iYAwPMNYgfkC8tMyYCt3XCp7yKV8qVbPmimc	1406	1393	121	1	6301	jxHEq6ga4NA5KUtsmEBNPw8k7apd7zVDJFP8cwd9eKd7U2sMuVY	4963	6987	6987	1617196860000
9573	3NLBiUkhvpVsSBdDTaNTiAhVMkDf4RsbB9JjHvRpuypV5BaauncA	9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	1406	1393	121	1	6301	jxGQHurMS9Mc8KunycxTwSqskeQ7ozCRwdYCpMdL7p7C9CBPWze	4964	6988	6988	1617197040000
9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	9575	3NLeZpvjBbCaVoTGuEsaMhCxdHdK3eUHZuZCUz1xYigUUUHkf9Qr	1581	778	122	1	6301	jxkjNuSFn1XcR7sH2wUTsqWPTvRYhKuSB4cC5hPTFxBAiBQVX7V	4967	6991	6991	1617197580000
9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	1407	1395	122	1	6301	jxRXLqYPnZ9NJ6SaNMkKMSzTJpMs53uGFGCR9ySgDzwUmWRZb7H	4972	6997	6997	1617198660000
9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	1547	1252	122	1	6301	jxAvRgr3PkecHiViys5v4utpDw4HL5WHXYMafQ2bXTPQHD7ZFnm	4973	6998	6998	1617198840000
9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1581	777	122	1	6301	jxtL2kAMVKMfXVEYf3E8L2wDjTPXfBMvQ6qopVc9ZGwxdessDfX	4974	6999	6999	1617199020000
9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	1406	1393	122	1	6301	jx8nFYEdBBcUnRcappSSaG7uUFftUzqRs5ns1gRhCo6oBfp7WGo	4975	7000	7000	1617199200000
9593	3NKXja3RQkLuvsJWc7cWfio7phPRCuQq67AoJoQ3fbHNvkMAJFoM	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jxpHHzC9Rw6J35sLeACHjAAF2cP7ERindUbcSk5wJgtxaYc4mhk	4976	7001	7001	1617199380000
9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	9543	3NLWDCs62HuytfujK59FUfAXTHUphkLbd9G16Zw41cBEDh14o4ds	1542	1058	121	1	6301	jwNuwTZqG5QSYaB1mcPLYkSb4ygp3HnZ9uB4jSTF8BeaEMh37Yz	4949	6966	6966	1617193080000
9547	3NKuuMjf7iTAGM2jULX3sSBxZ7Q2ksBLEHJavQsrX56ig8FAscGQ	9545	3NLEA174No6FBACGn2zVtF3tBXoQfiVuV3bGhC9hRfDtQNwQqbkJ	1560	1165	121	1	6301	jxfLYHDMUrbH2HKWu9X5pyVj3BLV8Ki8cUvjn28dQygb7zf1Cov	4951	6969	6969	1617193620000
9554	3NKJuVBRTJ4LDg35HMifidaH3sXDnNyP2rEqFUiVZTJeKxjA1jty	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1654	1340	117	1	6301	jwwXScBPskrQ24LGU9SZhxYNGXQw5QhMbsv4yT23HjvTt7Q48Kb	4863	6972	6972	1617194200048
9558	3NKrJwHc9mg6ioF86mKvtmTNiT2sucQuHPJziXvaJS6oCS2AyHZN	9553	3NKAUTetUQzAvPLw2nfyCpu6gNHE422duKo4tKV8QAZrZStMkqm3	1407	1395	121	1	6301	jxk6EtPh24gHdpHbt5Xy9q692azhcytpDa6LowfrbykRJiV5t5Q	4955	6974	6974	1617194520000
9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	9560	3NLvvFUqjJEu5mzwPvRLYH8X2mLZs9QWPUvkExBbXNbz5c6SJ7nk	1405	867	121	1	6301	jwCPt1UCAmU6joe3X72s6yxygT4f9Udgt3qxedFByyvhhp32Ymp	4958	6978	6978	1617195240000
9564	3NLGbHXraP8qJZPRDzEc9EMiSv7R9JfDjf2GbuHzwTVmqDH8Nvvv	9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	1483	201	121	1	6301	jxGRA2nCSdqS7NtRcsEGneVGDEy7tidTGaVVeZprJHX4UjA42Eu	4960	6981	6981	1617195780000
9566	3NLtX4uuZTc9G7Qow9YWMAyWMWXoCQLWhVnNcRTMNDihuS3uYuFH	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	1609	1087	121	1	6301	jx4UsuRFCr74MEQSh1hb33JzKENuiS5C3fB2LGkKNy8tQy5aFRW	4961	6982	6982	1617195960000
9569	3NKPvCsgvM8QYgJ3iYAwPMNYgfkC8tMyYCt3XCp7yKV8qVbPmimc	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1422	1091	121	1	6301	jwojcpWLpRbJ8eTAd1QZabGXwR8XgvbNJ3tpriKoWtiwwevnZ4a	4962	6986	6986	1617196680000
9574	3NLiJ4giUhxtU5HLwCjs658A4gkk5P82nNEx4M4nxxNNoxbmeYYx	9573	3NLBiUkhvpVsSBdDTaNTiAhVMkDf4RsbB9JjHvRpuypV5BaauncA	1405	873	121	1	6301	jxyvP4a8uqXRySh2Rjs2T8CSZyXkrY3zp2yAfZHzB8dARqhvHX9	4965	6989	6989	1617197220000
9579	3NLHgchu4dMcZfviRufhAFHbXmAc4Re3pSfXwUDzkx8re9BCf7Qw	9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	1406	1393	122	1	6301	jwXCAoaRAzS5xKH8B9rGQAgnWYnrrneixGzhnMEEm44zV9QJYYP	4969	6993	6993	1617197940000
9581	3NK97r7yszRih5N2MReEcE5KxQ74cP8jeth5Noq9x6VnGNNUy52E	9579	3NLHgchu4dMcZfviRufhAFHbXmAc4Re3pSfXwUDzkx8re9BCf7Qw	1588	1392	122	1	6301	jwEf3NjdoW8M8BjSGyoRD3iMn9rs3S7BRhiif7YeVFgQ1U73k6X	4970	6994	6994	1617198120000
9589	3NKA7oq9s1np1sSUumQuG7SiwVerTzjNsj8mLrQ2qWw5uD9JoBx4	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1631	794	122	1	6301	jxvq3M2bkPDVCYu7ErHXoYVtSHnJMUpmxFCpGNJFpxHtTwRnTq1	4974	6999	6999	1617199020000
9591	3NLPtB6hSSRMKaPdEbttBVwoeQiqQ32LBoeauuFNASeHi1vessDy	9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	1593	1346	122	1	6301	jwfniftY8Hnfm9LqYgFtXAVbyFTkuHYnzWyvqATDM6g8q5PNk9j	4975	7000	7000	1617199200000
9594	3NKAUL8GYCWGojqrAP7TTBWunxcYEGSj7F5qoYNSSi1RGCiqpqQW	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jwyS9sMbwGC9D1Q7ks9sUHeiEDnEZ8diER5JZKT2V3atb83jUAa	4976	7001	7001	1617199380000
9598	3NLxpEca3dcQnV1rqWapmrMBJgQzWpuYVvTXvoXXV8VXppJzw22E	9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	1637	816	122	1	6301	jxjJvcTPPFhp2cVacLkzgTTQ9RpiN6jffFYatmn4RehVnmYPrFB	4979	7006	7006	1617200280000
9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	9602	3NLojTgzhMJRSE2f64oUnDt82S5P3QHMNEoCU128hb3uQ1qUJvMF	1407	1395	122	1	6301	jxVYj69Z7teEuoXvXatKY1Ahn41N34VXeNG9TkDq6S11T9SQfqj	4982	7009	7009	1617200820000
9606	3NKbGTpKRKS24KerENHjBN54ejxDwGKhHxWHmQebsXL6PADNTQaE	9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	1403	824	122	1	6301	jwL1Fn2ENtb6GuuDBGaozYTcmP4YYtVEB3ZMKcTktBmgH2hiwvt	4984	7013	7013	1617201540000
9611	3NKk6EB1kqZa56Y9vn9LXsrjxx9n7ZHbqWWdShoRYhG3wjYqpHUF	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1451	1166	122	1	6301	jwS4an99HuCDUXdP4YPGrcbQmwdjxS1yeuvRQkV11xwM2igZTey	4987	7017	7017	1617202260000
9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1637	816	122	1	6301	jxHA84G7vh5LUzEjE2u5DNyyZrbipxum5KVtdfZLs5qHqSF1p1L	4987	7017	7017	1617202260000
9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	9623	3NKcipz589LEJY3a4au67989giUCbgjEcYWfKbeqAS8NXbHSbAvv	1402	868	123	1	6301	jwJB4F8KL5oByUKcnoapKacqT3v8rvnB6REvKDYEhyQNDFLcASF	4993	7030	7030	1617204600000
9627	3NKP8Yx9XwSsSPDA4HLkcKnDnEEewEks4FP6qEx1RvmYgK2upsoi	9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	311	1181	123	1	6301	jxYzm7XyVmi1yTHMGbfQGRYkPJ1DX4gg8T87VghziQePWaHj7X1	4996	7033	7033	1617205140000
9630	3NKeiEhmMXsk2Dz2MWPaPHHxi1Y7AWBduVGwfxevSacKxQobUrbm	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1650	1375	123	1	6301	jxKzpHcXvbqRuXnBRrC1rcfHZQh6uRq19N9oTT1PCNJXuSN2C12	4997	7036	7036	1617205680000
9633	3NL3LNrLxiiTsL4GrGFRwgPZVXVZwaJLBw7Tqc2tAZLeeRYHLsmW	9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	1508	1141	123	1	6301	jwxP8mh5q3ZEdTEFvEy4URwT9cuEVnjBos5JbbvMgNMnYmQBgGv	4999	7039	7039	1617206220000
9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	1516	1294	123	1	6301	jwXcy4BLoEnUKQZfgSw53V67f5svwBhn51f4zG5qBLBEapAJTXy	5001	7044	7044	1617207120000
9638	3NLjdtRWCDzrTNu1kFmsHd5R9fxnzEV2cqvoKQhtWRiTtG56CvLY	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1654	1214	123	1	6301	jxaA2jzgdSeQzCNkR9TphqqCr3LPhKzPD2ZraeZ41sQmsa3PfNn	5002	7045	7045	1617207300000
9641	3NLQp9fMLRbsB7Spzn6DqenPoKvZ79wYStg9BurjHQaZ4wHgEniC	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1483	601	123	1	6301	jxyAPEpYnRPYVAZXAEn9F7m4D1FfMn1WaXs1UzGuCNuqAGKi2mB	5002	7045	7045	1617207300000
9656	3NLfNoXFQGkZocN9R89c13rihe9DwYcVrGFFnmVE6WYYoMzuvdHx	9655	3NKQcZG98Pi5vvjX9SzWNgoiZEf3D9HSuTMPwBidLZmgt6yWuRgs	1447	1345	124	1	6301	jxo6rj6yfjMFg2A9mwvs7yfRap4bzG6qRKoo5yTVT5WWv71CNe9	5011	7054	7054	1617208920000
9664	3NKzCQCETifaw1A5amgyJuDB8Z7tWoXrif7tXW2wT2R8CCuz1dNJ	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1474	963	124	1	6301	jwjYR2FGoDACuagyDA8s5awJpRtM2xcAVY5sTasCNqSjS2tKQFu	5015	7059	7059	1617209820000
9666	3NKSytwnugPDxYvwrTXymN2Ae7CPmaF3jTuMEspDpa57CywTavMr	9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	1402	866	124	1	6301	jxAQH1mSE8TYuGiCdgCLAAiwZkfzNvrRFNBuoJyyJepnbnuZ5ot	5017	7062	7062	1617210360000
9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	58	915	124	1	6301	jxZ1hTbkugGake1LdLqvitr9Qv6BzdJg2VXBkYT65B2CSoQEAaj	5019	7064	7064	1617210720000
9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	9679	3NLUbyaJWdeX9c7jWq2Le4hNPSR7EGBuyaxutq8npyukkkAmft1d	1407	1395	124	1	6301	jwwhfvifJDpbaon4GHg1ML5n2zqeDfFfgLx9vSnZcBkp6bDWuZQ	5023	7069	7069	1617211620000
9686	3NKpwPR3sehfUHR9weW37xABxy8RmW9FohqZUjByPqzQWjhNLQLL	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1637	816	124	1	6301	jxyvvNFWdyaPepLxBTW1vUfPAvAqyoSUgZ8FFUybpLxqg7r3kKV	5024	7070	7070	1617211800000
9570	3NLBZjCasuoz9QTNm8K9YLSHpBa2V4dPzQdRJNGRXSbbdoQVw2tQ	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1611	1341	121	1	6301	jxiPxnULchSfjPSxiZiFrG4nftvqjzH7JKmUDyYECEEAqzWXDqt	4962	6986	6986	1617196680000
9578	3NKbcKDf1uYEnosFVmQEuaevEJkvVQMydoDbuCj27CHdsxrHw6dY	9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	1559	987	122	1	6301	jx9dRpTGZLpxewkbiGNpxcqfGWZAPqd5KZBHDfiX6bXmw2RedVq	4968	6992	6992	1617197760000
9583	3NKLLoAdoJrSMGoHXQP79McMsDdA6opQ2gidSrAAd59ZKzQHyHF6	9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	1527	927	122	1	6301	jwGZguDpyg2c6QxdtLR9rG9SosX8WdjatAWQKnEqme7mB8xuDwJ	4972	6997	6997	1617198660000
9585	3NKHrn73uJHLXDFAhkca4AV456y1CayDzAR3RnLEWj98Nd4tTkUg	9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	80	1273	122	1	6301	jxX99YLvaJS4yF2f524jqMidiSnhmXNMhWBSvdjKLtwUKRuaRcB	4973	6998	6998	1617198840000
9592	3NKVkJdyBEnjWXC2rFA7qaKp6b5mMjLFPEn9Qbf494nwGCPapuZc	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jxr1dGi8oFkDxGQRYuFjZcR46cTvzJQQBoZS8AjUp3sM9opWEM4	4976	7001	7001	1617199380000
9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	1596	1363	122	1	6301	jxzA8CYnf1vV3x6vnuiPfAU8MZoNRprdfagwiGVg79MdXwXtKYQ	4979	7006	7006	1617200280000
9605	3NLdpMZjri53VmPVbMpR1FMJAjcM9iA1FSdCepygSuqhRMgukgsW	9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	1596	1363	122	1	6301	jwffv9KbvFhdHyHX4pPWe9VrjjWbe4MgNpDFg5RfZkWxbRHHrb6	4983	7011	7011	1617201180000
9607	3NKdPieeBAexaiJjCAzGS1Cj1syGJywht2GYaorP8QGLbSQP8Er2	9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	1581	778	122	1	6301	jxTn2FdYFpyNworRafAwkkw4Zhvr8jsAEWmwdQUXpDi3Gvps6fd	4984	7013	7013	1617201540000
9610	3NK9Y2o87xZNzzUwxgw4qtVeGeRbhA2gHUEcfNYPaLvNnHhW8Wv1	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	42	1361	122	1	6301	jxQCSsSYgDETdEGSgJ1T4e7b8aPj3RwiwUbwXdhhkTcBzMA3AP9	4986	7016	7016	1617202080000
9612	3NKGnUPFUjFteYDsN5KVGvDw4pzeaPdgSudrPDvjjpvjDPSfVTSo	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1611	1341	122	1	6301	jwVbJ8E3o1FeN4k74hvLFHuRy6gc3sEvAuhKHRaUV31dwmh1neJ	4987	7017	7017	1617202260000
9614	3NLjxFz6fgqNiFiwWYcdKbRnpBjrxeDeAV8Baqenw86Pbz4tmBj2	9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	1407	1395	122	1	6301	jxZgwVsJdXeknJxVAw875KF22pECHH3GYh5FWjk9tWvuHLjCjoY	4988	7018	7018	1617202440000
9617	3NK2vM4URs644U6EZYeaL78BwYDXHRmZTmXjstYdbdwopK15dRmp	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	44	1325	122	1	6301	jxeAQgEjyJ1ez5pBKTGrV2EKFxQ9uHAot4n6KU46srwqQScanQY	4989	7019	7019	1617202620000
9620	3NKiyxhxfohCGpHkQg7TC1cNxHzAHbcHCUAdSM1aNt2u6dGtVrvC	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1474	1329	122	1	6301	jxVJGp3nnYD1VRDk5ita7ShAC44uYGRTXH3aiXenuYvCrHdwAo2	4990	7023	7023	1617203340000
9622	3NLCgStAZSqfGPZE8N8RYZR1XNjaMzMKnsNu9N8sUu9juRaf7xoZ	9620	3NKiyxhxfohCGpHkQg7TC1cNxHzAHbcHCUAdSM1aNt2u6dGtVrvC	1407	1395	122	1	6301	jxpJG1AYiDYgnBaTEjppfkY3whi5LSM6MtGKcgUX3uuwUY2Cwy3	4991	7026	7026	1617203880000
9623	3NKcipz589LEJY3a4au67989giUCbgjEcYWfKbeqAS8NXbHSbAvv	9622	3NLCgStAZSqfGPZE8N8RYZR1XNjaMzMKnsNu9N8sUu9juRaf7xoZ	1623	839	123	1	6301	jxMoT8D3KacgY75frjQdbJEnoAcj7HkfVH7caJanVKKt1a3dukw	4992	7029	7029	1617204420000
9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	606	1295	123	1	6301	jwjoEKD8Wvw7SSNaEV4iiKHniDgWPZL9TMkMAZgQpsWaTyobnWF	4996	7033	7033	1617205140000
9632	3NKYJR1m2hFXw169JR3gUrxYv6KhG8TFRaidZJb17SXjxBChYfEG	9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	1622	1230	123	1	6301	jwwd4t9pK6EEifWUCPmSNKfVyBKD1kYf4ftpfPeWN8x6LKjFdk5	4999	7039	7039	1617206220000
9635	3NKycYf7KsJnYEjxdhXJhVPEZTnYkuHf3wXEfUQaoyTyTVTyGW15	9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	1607	1348	123	1	6301	jxc1rknTgo8ndYQi8v4WvCEZkqGejfu3XSne9ASxb7rgsJJpD55	5001	7044	7044	1617207120000
9644	3NK6ixgQMyf9c1PVHcXb4DPSZzmf4LEPaxGqxgGSwdtj8RDoqtv5	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1471	1386	123	1	6301	jwgfsvrrN4zLnj3h5mcwY21ToYGtGn4UPi3xN9429uiJRy7qW6W	5002	7045	7045	1617207337553
9646	3NKr8K58vPh4mjrD9tgySSJ4EdsQsT5DQo6FsAysmAtxhfPASxjJ	9645	3NKafhdHewqWDerkSki7BrnfMhvrRsGd77cKYpQVUzCpPskjpKT7	1406	1393	123	1	6301	jxGmwWhXmekBGfTzAaTHWbQ1mwRPMW9mCDsesdyiX6Tpm3ivp2v	5004	7047	7047	1617207660000
9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	1403	824	123	1	6301	jwzwxtWcvjEjch5tqr6rBPUy5ksKjhNGgcD5Yikxfb6kJ2uEGif	5006	7049	7049	1617208020000
9651	3NKSxsJwyNBNJhFkAjgPSEQdLMmRsd8xtF4MZWU39vAihHYyEmBx	9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	1652	1189	123	1	6301	jxh2nep8Nxe4MEHQVbUjT9Hvvi2UTMNMqUAp9wQfThWoFvbKvPf	5007	7050	7050	1617208200000
9659	3NKDE21zX7HH3oBoJrCmj3yK8B3kYGj4bLjWFFSB7BgQxjejE463	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1406	1393	124	1	6301	jxzaaBrAXtMtcoiDRif4PVyuZqj87WnTbQ1qCWrpSm8XbMwybAq	5013	7057	7057	1617209460000
9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	9660	3NKXhTvd9vJWAt3Qc8LZE7rznNoLmywynLg8YJCCTEJQ2KY1PaFE	1631	794	124	1	6301	jxKfY6RMmcnXn6z72SG5YEKx4upVGij78ZWsKEa3woGZEwJYWML	5014	7058	7058	1617209640000
9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	9667	3NLnWvcKvM4BHEXJKbk66a7LXBCHYbHrE3VFN95RHFFJgfnx5uvS	149	1283	124	1	6301	jwrRREfPq8PZQz3CLJSXkMoYmHLCU3TjQk6vAewaPFVzuBSXen4	5018	7063	7063	1617210540000
9673	3NLmrhzdU9iaDPbfiWdYvi61cQ15WxTq1mRMpcFXRnMYXCJepruU	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1406	1393	124	1	6301	jwMa4v1Fdc8XiyJhF2stE7cme8QEdcYKHbg7WGMLTy7KFtZtTeQ	5020	7066	7066	1617211080000
9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	1652	1069	124	1	6301	jwd233ssDhaG63z16N8icHisYatH1ECjm2kHZRKSH7ryq7Cbmyn	5021	7067	7067	1617211260000
9678	3NKjH266m9Nkj4hMpRyoSHxMdvLdMWjpbrQiULPursm1tHVVerZB	9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	1627	1019	124	1	6301	jwmeQv6DUoBBL78TYfk4ULiYiGR1DJyydaD4u4EKNm9e7zMPrcd	5022	7068	7068	1617211440000
9680	3NKK2uS2SRiiP17m25PEo2EXohQv7WyD6ERAu6NvrGZKRwA7tDHP	9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	1577	1327	124	1	6301	jwCSHXGuD4WP43xTPpQP2CnR4gpo59xmd532D7ZZP6U5pvLAKd7	5022	7068	7068	1617211440000
9684	3NKtyATYZ7E6HPkwB7ZKCcFtrbxXknGnrXbCFJEnevbQD4tKs9i7	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1489	1380	124	1	6301	jxogK3oPNBYXUQHHPKCQZxonWxutkv2KUoXojRk8sF7WBVGVHGm	5024	7070	7070	1617211800000
9694	3NK8M4bgeayYT5Ks5P5pbYxGLg1xksxzZVoAsVPRPLrhvesfX3ke	9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	1403	824	124	1	6301	jxY8vp7adD413T8h4oNGCLLps42XKEQmFriq6sLJLFUjairkQEo	5030	7079	7079	1617213420000
9700	3NLtWNxvzfWgi6LaNqbwR8AiGbkLjAmtLKCezuGMWxxMiHdjwmJT	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	1406	1393	124	1	6301	jxGYWAVq8VBpAwqXvL8fupvuaXWLtGFXkExiVmdXc6jebyS8Pp9	5031	7080	7080	1617213600000
9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	1559	987	122	1	6301	jx9oTCw3mUsajZmPsauM2sBqmdTaSTtA76Kk49d7JPi5anFX7uF	4968	6992	6992	1617197760000
9580	3NKCf81p5vnJTphdALd9pJ2PTrQiB6C8LCmaBTqwJFJchgQa1Tdm	9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	1581	778	122	1	6301	jx1fNSBC4TDeGYM7ncfM7se9PgHubB21nHFHFXxM8HmGNzPmNk3	4969	6993	6993	1617197940000
9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	9581	3NK97r7yszRih5N2MReEcE5KxQ74cP8jeth5Noq9x6VnGNNUy52E	1549	494	122	1	6301	jwo76vGVEAx2Wson1JYUqg37qwnSWoFJCLM9ZZG5UmjWUjpwtyY	4971	6995	6995	1617198300000
9587	3NKfWHzsBrVpjjpGtJgiUtBnAv8JdbYRMZihdwEceSCGKrjsC3td	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1553	776	122	1	6301	jxfvCKHcNcmAcAJ5QkrKdYW5yESdjhqe8eeTrycezocUUU7ibuH	4974	6999	6999	1617199020000
9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	9595	3NLktfVoWnDxt56kGdo4HNW9NaCXMoqcYS2XSnN5a8EzE53r6YyB	1579	1389	122	1	6301	jx5ynFYdZaiibLSVsp7dF8TDfAEg9pKG5Dy123wGC9EP6AiRu1L	4978	7004	7004	1617199920000
9599	3NKH8a5AaG8hpjFJRQFrRGZkBB5vtAXcEd4YGCgnQzLyeeVPK4qw	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1599	921	122	1	6301	jwxGLohQMsKezR6wt5fVSXxZMyNtzDKc446kQDCUfKe1rbxQx4C	4980	7007	7007	1617200460000
9601	3NLU52xhGdWqAB8J6wcAawAeg9gU7VPHHb6wx8QBfDLDF8sCkaDF	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1637	816	122	1	6301	jwboXrPtyySM6rQx2dyHEto8b3YHjtghY7PN8Z5WyWUjg2tsTRX	4980	7007	7007	1617200460000
9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	1403	824	122	1	6301	jxUwbgNFA5QHr3CZwxgyKwmfbYik7v85KS9YTEW23nxn4cVYHr8	4983	7011	7011	1617201180000
9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	1490	1028	122	1	6301	jxM95ADPFiNVCdVRcgKikTRrenwiipLQcN7j9eKrJrvRSjbFt8p	4986	7016	7016	1617202080000
9616	3NKSLTM33XdNSHAvZycuAhkaDaNq4fze6oqAXofczDDjJYyGAivv	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	1587	991	122	1	6301	jw93MTbfgzE91x3cP46aegk5dBCbJCT3a4nHhPTD38nFUcsbqej	4989	7019	7019	1617202620000
9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	1637	816	122	1	6301	jxYfEpRzzaRSDohACpgbkvpPY5y5eW4QzhCUikaprmMG2ChYGnx	4989	7019	7019	1617202620000
9619	3NL8Qwi5AYJ2shExsrHziA6xL8nFTyxLausrhuGZsc75CKkhQvgJ	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1501	1360	122	1	6301	jwg6MbhbnETM8nvKRkjdwVvJRFi3N58ZGgKmSb7fThNdfEsan9n	4990	7023	7023	1617203340000
9625	3NKiaQdEvzSvhVwpYavT2oYxGHgqrhkDEuR1xs6wRb9Vri7MtoAB	9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	700	832	123	1	6301	jwunSuvAh3wXhY9gtCQzD2iUWcwXDkepRFhr2MfTQUmEMEt28P9	4994	7031	7031	1617204780000
9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	9629	3NKVX7T9nqFVvWiC8VzVyQm1JtmQwGT6ixDhGM58qhkrQCpW1Pmb	1631	794	123	1	6301	jxBfwUg9Nrmp1LyMUKcYNBXPrDwtozFX1L6T5FFgXrUS6sNeLaq	4998	7038	7038	1617206040000
9639	3NLGmZpWWDymKxEob2UQJSTeXByXzeyxHA8i2asnHKJEy1M6xSbB	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	684	1352	123	1	6301	jwPJj9GesSEzrPZJrZNa5zAcehygUSuNUcydtgTijJvK4Dk4T43	5002	7045	7045	1617207300000
9642	3NLH1pF7pNySYpQFHvKrbeSG4YHcs9p6z1KRaNAFCDT7y3Vt4kmk	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1596	997	123	1	6301	jxBn4sRLuaPDbdhmwjAjBcTjAa2ULCy2RfW4xJQwaXvuisbnHaK	5002	7045	7045	1617207300000
9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	9646	3NKr8K58vPh4mjrD9tgySSJ4EdsQsT5DQo6FsAysmAtxhfPASxjJ	1553	776	123	1	6301	jxQRjAt3geMWzPP6ioNvvF9ZLd47az8hf6EkXuv61URgoSSAov3	5005	7048	7048	1617207840000
9652	3NKMwRpUwbA58yePoJQGfT3iRRZnJdD912NYVT58zPVD3voGE3AU	9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	43	944	123	1	6301	jxdE7sNeVbijC7ixefFxYmGAfYasSPTh1uPYSk5UtFsDhq7KFt8	5008	7051	7051	1617208380000
9654	3NKbLu2FmaF3xvu2mYh4xysydQFCeoLREfXPTGrGwDVa1nxHm2xs	9653	3NL8mPQPCSJV16bqirC2NeWQrAJZcxeZEWmuUCmiYqFXVPWZBXUG	1406	1393	123	1	6301	jxGcBzUMdvJcFc5qvi7kCwq2K1T7KvxP72ZMRSrjAgLeCHjTHdE	5009	7052	7052	1617208560000
9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	9656	3NLfNoXFQGkZocN9R89c13rihe9DwYcVrGFFnmVE6WYYoMzuvdHx	1406	1393	124	1	6301	jwNv72skYNAyhquqx6wfUkH8oGo5keVj2qxdJS7FA5cxdz1Wk9L	5012	7056	7056	1617209280000
9660	3NKXhTvd9vJWAt3Qc8LZE7rznNoLmywynLg8YJCCTEJQ2KY1PaFE	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1581	778	124	1	6301	jwN8ymq6UhVEe9Jeph7QJa2W7ihLzL5ZtMvDcNXmHrBf3xQumNR	5013	7057	7057	1617209460000
9662	3NLKQqRSbQ8ba43P2Gn8yW7E54ot1vJwUaHqVx7ki7us1xARZ3fK	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1451	926	124	1	6301	jwzvVVS9ZABz2t1twtB5RLYkd11uLDNCqtonvXd73jstSSDx6dg	5015	7059	7059	1617209820000
9669	3NLovyrDm29tYLjhBsGPSMNSD4Jhj8LjnZYMDdebGTXUvPJcuie4	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	1402	882	124	1	6301	jwtk8CcsrXQoicWqGA3jjsZFCszBhs8um12FH5SdLqa92mXZ68k	5019	7064	7064	1617210720000
9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	1637	816	124	1	6301	jwqrNGbDM1aCRi6fAxwBowSvUMWiaHAB1L5CoG8VBgyb7A45e5P	5021	7067	7067	1617211260000
9679	3NLUbyaJWdeX9c7jWq2Le4hNPSR7EGBuyaxutq8npyukkkAmft1d	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1546	1339	124	1	6301	jwkYFXhs3V9ZF3UQ5YX7rbWrEtSH441S93FKcF3zWsiyZVZpPxr	5022	7068	7068	1617211440000
9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	9684	3NKtyATYZ7E6HPkwB7ZKCcFtrbxXknGnrXbCFJEnevbQD4tKs9i7	1403	824	124	1	6301	jwokfQWC2QFEYzEpZNk3x8DicmsAPgwak1D2AjebU3QFXqU4VUb	5025	7071	7071	1617211980000
9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	1509	954	124	1	6301	jxz21ueLK3XbTdtGFqZwR92cN3ZR5gJ88TyrVnQZC8JUuxSUh2z	5028	7077	7077	1617213060000
9693	3NLUDLDYZL7uiLz6GYuG8Wu4bHJDVtvWqUq6EWrkWa8HkViRnPpj	9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	1406	1393	124	1	6301	jwjtPU735122PX68m2TSnuNNGXWM7t43Vw9pPvYm7PRAccdtGKR	5029	7078	7078	1617213240000
9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	1406	1393	124	1	6301	jxHWU5SvdHXWP8f6GCvc5EsvwgZMSAz4AVCd3K4UfMx4MSPoHgv	5030	7079	7079	1617213420000
9697	3NKgTrEGAFuooFt8PvPCDJK28Unwdr96wQBByZtjEE78ZrCgdYvo	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	1460	1324	124	1	6301	jxgPdzqXa8Eppi6NFpg8iraFkDYvLiquQQ4YRPJouHVgqfBmgD3	5031	7080	7080	1617213600000
9699	3NLBiGRYitr5XnS8MXceJAyTGPqsChBy78z573R49r57niV3s1LB	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	470	1309	124	1	6301	jy2d5xfkYGjoFpBAnxoJwAefj1EUzD6buAmMQ7tWDEoVwLXy6PP	5031	7080	7080	1617213600000
9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	606	1295	125	1	6301	jxLKkGK4SdLxvvSTWvkdTrpKLVCWT4ZRrknSS8cBKshxLRNS6bG	5033	7082	7082	1617213960000
9595	3NLktfVoWnDxt56kGdo4HNW9NaCXMoqcYS2XSnN5a8EzE53r6YyB	9594	3NKAUL8GYCWGojqrAP7TTBWunxcYEGSj7F5qoYNSSi1RGCiqpqQW	684	1106	122	1	6301	jwn4B1rfba6xWwnER2bcUY2BZ4amD1iAsGmdHt3fP94PjFMWk99	4977	7003	7003	1617199740000
9600	3NKPpyNkfWZ6zt9PH1mfdmCzEEq6jpPFpN7xocWeFNUAzaaQvgVr	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1613	983	122	1	6301	jxJaU92A7TxZTrNdVgGx6jz68Y83AuJ2i3MBXD2RxnSTVdAFstY	4980	7007	7007	1617200460000
9602	3NLojTgzhMJRSE2f64oUnDt82S5P3QHMNEoCU128hb3uQ1qUJvMF	9600	3NKPpyNkfWZ6zt9PH1mfdmCzEEq6jpPFpN7xocWeFNUAzaaQvgVr	1593	1220	122	1	6301	jxKwHiZfuNrE7nik1JvbGdEestVML1duoikgHUgovjVbdLRoVnT	4981	7008	7008	1617200640000
9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	9607	3NKdPieeBAexaiJjCAzGS1Cj1syGJywht2GYaorP8QGLbSQP8Er2	1623	830	122	1	6301	jxZwR6V3z45xqKNkM6R2B3jHfGaiyYQC9pbc2VYspKCnmHvfQxv	4985	7015	7015	1617201900000
9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	1651	1301	122	1	6301	jxFkzEDsNj6wvhuZacK1ETzGQTRVsicMNow9oQrdUBXJAbjAXtd	4988	7018	7018	1617202440000
9621	3NKNL2LQH1rfN8ZfMrBPM4KhfoaJWBSfoAbzWq17KXxwU72TSm1W	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1577	1201	122	1	6301	jwYRDrv9uvjLGTgGwpLHjTYcDKpTTUK4unPrqzGZvUb7Q9pSfyw	4990	7023	7023	1617203340000
9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	9625	3NKiaQdEvzSvhVwpYavT2oYxGHgqrhkDEuR1xs6wRb9Vri7MtoAB	1403	823	123	1	6301	jxVickSjaFkWBZV2m6HYDtgsg2kxqbFKewJGg71ByQ9wWYTfvzb	4995	7032	7032	1617204960000
9629	3NKVX7T9nqFVvWiC8VzVyQm1JtmQwGT6ixDhGM58qhkrQCpW1Pmb	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1553	776	123	1	6301	jwiwvsUZWiozkEep9o3d9hXV3pJ8ukyo2dzppZp52bbTebSVWvi	4997	7036	7036	1617205680000
9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	9632	3NKYJR1m2hFXw169JR3gUrxYv6KhG8TFRaidZJb17SXjxBChYfEG	1516	928	123	1	6301	jwfy3pPMQvnUrtpKSupvYwbx1BPDaghHhsqSd3ZVinVVx9vsKgX	5000	7042	7042	1617206760000
9637	3NKXAckpEE52ojiZ9ndXXLRirmHWZSePVMTUkTzoVnvyF2XpCAKA	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1471	1386	123	1	6301	jxcNbok33WaHMTqbEDQV2jEDfc8y2q3BfDd4jK6ii2fvcoKLVWu	4997	7045	7045	1617207300000
9640	3NL8fLePeq1c1qL6rd1MPtCjyzBE73ZDbc7sVcwaGKMZj7HBptbP	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1471	1386	123	1	6301	jwJNQfw4yp4hiGYhAScR1z8UXgoSWKMhubTx2eR8Jp8jJEgiZi8	5002	7045	7045	1617207300000
9643	3NLMdyXBQLtAFHPfJGatp5b2fs9sY7PhLkz8MN22HnzhTkwQ4Scw	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1560	279	123	1	6301	jwBVPCaXo8yeDBiSbUGsJvVfdTJtFeG9oNXnT9p7Bi1JzTwXq3Q	5002	7045	7045	1617207300000
9645	3NKafhdHewqWDerkSki7BrnfMhvrRsGd77cKYpQVUzCpPskjpKT7	9642	3NLH1pF7pNySYpQFHvKrbeSG4YHcs9p6z1KRaNAFCDT7y3Vt4kmk	1588	1146	123	1	6301	jxG1RiNrDvuLmDWFnd8eSY1MhUioJZG1zTGZkrm6b4S6XoYMXKP	5003	7046	7046	1617207480000
9648	3NLfqtTEXkXSdtNcsEPtobAwFcJey3X7v4hxvJaULCrJgacbqq3K	9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	1649	1383	123	1	6301	jxQEPBCTATXLiSmUEeUBk6zwozT52pP8tMgcySwsuYKkUsBkgdf	5006	7049	7049	1617208020000
9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	1405	869	123	1	6301	jwPAn77Cywd4Bcreyu4WdhutFJgoF3FnR75i77miUDhM7mgTTKb	5007	7050	7050	1617208200000
9653	3NL8mPQPCSJV16bqirC2NeWQrAJZcxeZEWmuUCmiYqFXVPWZBXUG	9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	1672	1039	123	1	6301	jw7JjFNCA38pjyfopneCeeNrJTQVksmPZSFHhGfRe84m5thADfJ	5008	7051	7051	1617208380000
9655	3NKQcZG98Pi5vvjX9SzWNgoiZEf3D9HSuTMPwBidLZmgt6yWuRgs	9654	3NKbLu2FmaF3xvu2mYh4xysydQFCeoLREfXPTGrGwDVa1nxHm2xs	1673	1122	123	1	6301	jxvXxKKzQAoEh74QEJG2yc1CpQxLkoearERg9ZMfdqbNjTjXRE4	5010	7053	7053	1617208740000
9658	3NK3RGxEoEbWt7NNfRxFeUUChSvxYRZu1KHgsjUMmhRvKFxBSqv7	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1407	1395	124	1	6301	jwzoVtt4U6CFMyU2v3zP4EzjmDbicqNLerREsFpXxZf7q1LDJoJ	5013	7057	7057	1617209460000
9663	3NLcpHNgBPHqM5puLqyNya5MYJTaBRgT7yeKz9oTspCqqa2Gn3AS	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1402	874	124	1	6301	jxbbPZ653RAnxzqPFxiNNKNnnD3f4CGbw8FPZBHWLmRvdeW935V	5015	7059	7059	1617209820000
9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	9663	3NLcpHNgBPHqM5puLqyNya5MYJTaBRgT7yeKz9oTspCqqa2Gn3AS	1594	960	124	1	6301	jxAu4fChKe5og5emNjHK8EhcJvnq1zYbGVKTiY4tP4E3b4co4Ba	5016	7061	7061	1617210180000
9667	3NLnWvcKvM4BHEXJKbk66a7LXBCHYbHrE3VFN95RHFFJgfnx5uvS	9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	1406	1393	124	1	6301	jwDL6gagrduQHoqg8i1RsKhqQL366CnP9c7wvgby7sLmiWEiCKr	5017	7062	7062	1617210360000
9670	3NKHJYwqpN4roXvRCk1AeCJiuVHLGw1K6ipsj8WGHtVCQf71QdnR	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	1564	972	124	1	6301	jxL4GvtbPVokDdL9wdw3jhEyChCaFs81yP2uvV9TX7mWYF12n8R	5019	7064	7064	1617210720000
9672	3NKc9U21QRe2WnovfpeHVSe6WQY3Zxkftp7jypk5AmDvHnfu8GcE	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1402	852	124	1	6301	jw7ouhL66s8UzE7EMPbjhRBAPCK5V67Vcz4tgwgrASLkm5qEbBi	5020	7066	7066	1617211080000
9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1631	794	124	1	6301	jwTdZ11hzEBVXJTKZYA5HM25ZuPAGMonLLKVQVSrKTo3EXtYFUu	5020	7066	7066	1617211080000
9677	3NLUMQFf18tsmW8iWDDzFfgSwD4Uixnzdd92erNjn1NjGmnpwoA8	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1527	1167	124	1	6301	jwb7sxreLMcYTHceZWgTbiocizHtfGi9TJA82pXQUiP6VGBW2Fd	5022	7068	7068	1617211440000
9681	3NKsrmLK1xmhqehZ4sw1XcaiyTuQ5tBLaevZt1tUyFaH8bfFVdo4	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1577	1327	124	1	6301	jxt86n28WQ92jmMtEG38HTtpgnvUy8YPhN3rTk7ZEpveNXtCaVs	5022	7068	7068	1617211440000
9683	3NLnUNWregXyZ3TC4tjvf1hiKhhv24PfobsEstV3y6zTgnwn9hib	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1610	1068	124	1	6301	jxDJUjhb134odYHQfGCZMa72qUDvhthJQnUKnY5XBxaePFx7tvM	5024	7070	7070	1617211800000
9685	3NL2QFsvxDRMckHA4sfVBVQjhxz4dHkJxgw3n37ZKx5JdKmjYDZ2	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1406	1393	124	1	6301	jxojkWqZPtwD1P61M6wNXRYQPxexp6GaJmAb3dyMcvWibEbEVUC	5024	7070	7070	1617211800000
9688	3NKqzhNTGR8nQ5JwuQZ4JtTbi7NP3mwDtDEqpAjXo6k7J5qjNeTv	9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	1599	921	124	1	6301	jxwsoCx6aWSoSuJ6uoBdMr65QZFHFrAiCqSfw89yEYVUJkCfS2q	5026	7073	7073	1617212340000
9696	3NKuMSXeYsMMc2QDvwpKuY2ZvWrDiMFdhbxgZma8Byxu7xFt1PkK	9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	1643	1173	124	1	6301	jx2Lsi2fJn48KALeseEbsTbs1nDdPBekZVu9q3F1FweGoCLMG8e	5026	7079	7079	1617213420000
9698	3NLcyURH2WahtyinPeE82C1iQoa8UdDKu2NFvhiTQoAe1xeXDA7d	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	470	1309	124	1	6301	jwPqS8JG4VKw9VSsaZ7SDFQdKHMdY2d2A7aPqMHeo46rQXJxw2m	5031	7080	7080	1617213600000
9705	3NLwjKKEbpH56wCmKyiHj7x9AFPqgqDwToAmxECZ8jNgCTc9hEYo	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1619	1275	125	1	6301	jwFbUmQXZQ7DXsv4iqrzASScVokjJvDNuuYrFYUv1wA91TBnqKR	5034	7084	7084	1617214320000
9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	9688	3NKqzhNTGR8nQ5JwuQZ4JtTbi7NP3mwDtDEqpAjXo6k7J5qjNeTv	1649	1383	124	1	6301	jwSu3zxKxq7GiLGUf7JkiDcCqe2bCiuKcdtFc3kgGZB4gg4x6S1	5027	7074	7074	1617212520000
9690	3NKGQ2XgieWzNkVfhj9USPHKZqHQNQNWRdX9a4QgpmKEJ9Rssy4b	9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	1627	1385	124	1	6301	jwfpYP5bcL9aDaVKpRa1qB4QiGLcWvviyhBJ18puPW2KToR6uhC	5028	7077	7077	1617213060000
9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	1623	839	124	1	6301	jwGZ3jDBYyJBpUkrSZH9pfaiD337LW7QBB9gyxShq5mkcY4uFj7	5029	7078	7078	1617213240000
9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	9700	3NLtWNxvzfWgi6LaNqbwR8AiGbkLjAmtLKCezuGMWxxMiHdjwmJT	1634	1085	124	1	6301	jwjJAeNhvhs3mT1KfCQsLHj8Lv9wKAakpvUW3pgRFKjTof3tS7m	5032	7081	7081	1617213780000
9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1553	776	125	1	6301	jwqRAs9qKMqDvyQ2ojrvoKFsb6GEZgSZcw1euUNZiptduGSmFWJ	5034	7084	7084	1617214320000
9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	1585	1366	125	1	6301	jxYZeqGBgbbPK4sd753y3bqKLsM1zySRas1gj3PJNcjzzPyyZKv	5035	7085	7085	1617214500000
9710	3NL39XFUK5QEMUjuLfLmSeZ1y2amoQtDXYdnrScZqrhh9AZ1z3wW	9709	3NKado77Ur724TvgjcP2RmHNuNipL2DYhnZSbQt9PzwVcq5mhyWF	1501	1360	125	1	6301	jwbu9ivqSZ5N3ZEjM43fkmLAhT5ESBGPSMjRS3qEvySr4sYnAtK	5036	7086	7086	1617214680000
9717	3NL8boZkTbTMQktLFSFnkZ9pJ8SG8EaTUhQ2MJVXxkyRRVNJGCy6	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	684	986	125	1	6301	jxccFjKFSSaBEC4L71rXcsnDg5CtCYP4C4NvkD9X2oSmjXVh3Rq	5038	7089	7089	1617215220000
9719	3NKhpd7pAe4iZ81BE1sfbq5jG4tiLAwGKY9Dsvrst6ApkbeuijEW	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1559	1353	125	1	6301	jxp7pUmunvq9TvTaPvZN2xJSFRG6ZKp4tiT1o3FfdDvbfyZd5jb	5038	7089	7089	1617215220000
9721	3NLipVqLg1Eapc4QL32t6sBoe3sepyKQcHMUXJjYkyPqHjjjW9yM	9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	1402	856	125	1	6301	jwGqbo2s8VEqxK2GPQkQY8457xxS3R5hm7JzFnmkGLPXKXT96Sk	5039	7090	7090	1617215400000
9734	3NKCqN1UPTSfMh1dPQbMnUpGB9bYKv84eCw3JMQvEiNtFP2JbqbX	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1564	972	125	1	6301	jxrTafShvVmTVsN9PG2r5HML2eksB2aAU38uKaG5QMGBMLMY7m5	5043	7099	7099	1617217020000
9741	3NL7Bcs1M81iVDZWpQzYd3VrgM13y9HWoUN1QRgaijUDjage6wMt	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	1406	1393	125	1	6301	jxgLtLk3zFHDgpzU3kFDuF8GfpJ45tk4dZy9wDSo1HhXhG5dfRV	5046	7103	7103	1617217740000
9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	1406	1393	125	1	6301	jx1DyHEFyKHTqJajZfBL9JyE1Rue2G4C2tp4CV2noHjieryCGz2	5048	7106	7106	1617218280000
9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	9748	3NKBt4FcWMcXGBWnAiQY4mY78EwWvJt46VdJcP2QmzrZdD4wbRrz	1559	1353	126	1	6301	jwgTqiqUzxsMTiwD9bNhaEUec42hP7pgnBhRycRy7GyemaSu24e	5051	7109	7109	1617218820000
9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	9754	3NLGBRFQr4kRjuNrVvfXEi1gyohBA9LQtoav9iURVpwmnaVi1wAe	42	995	126	1	6301	jwtaCZwwJhkdFy796dyh9vVQTCu8BTNuyJX5SdBBtkJuDnQY8Ab	5054	7112	7112	1617219360000
9757	3NLA2yCi3qxQanxKKcjJ9om84gbq4TjyEui1G3cG957Y87d9PU77	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1407	1395	126	1	6301	jx5KuFmD83X59g39o87N15LmyhQ53sncCM3RUnYLMXnhaKphZtA	5056	7114	7114	1617219720000
9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	9761	3NLU6yoUtcmJKs4gJ3vMFkKADiN4p7iTJpjPWdQbKXPoNJQRrJqE	42	1361	126	1	6301	jwgcYLJqjj76NLPS174VFumGCPhXWXLPA6Nse81a7pxj4pnqJYo	5059	7118	7118	1617220440000
9765	3NL5d8HsWxA8QmopxWSDPvnksoGNwHaCJbMVgTARxKfbgaiTgMcw	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1608	1043	126	1	6301	jxD53ngvcKQFPpBhssttzpQgSvH9Qkh6TuC2se9pUNdCViDuGgj	5061	7122	7122	1617221160000
9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	1522	956	126	1	6301	jw9pdqc3taBsHLrgeYrJxmK3Fu4sBsgjxym1bySnDDtxdxATscX	5064	7125	7125	1617221700000
9774	3NKxphR7u8KtHXuGDJgBFtvGXqA5qWY7BssaQAjEgtkfUBANTBFp	9723	3NLmyn6RksdUSkKfv9busnKfkg7L5YMoDYHRWNEnirTgvK6hfzJf	1467	1130	118	1	6301	jxpiASVg8W3bxvNwqpkuhRtRdxAHhNaCvkvkXr1uUKoxHeEBs9m	4883	7126	7126	1617221880000
9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	1467	1130	126	1	6301	jwmfpQa5gvgWJ4ZuNy6sm8YGRni6rMpvN7qHaMwktg8ZY1WuKrP	5065	7126	7126	1617221880000
9789	3NKJadufDfqn1N1oemsuGDTkz8sHwkcv6EqEaVjiGMXk43RRfUwQ	9787	3NKSwAt2b5HPXjjLHkEHvGhEfXY2433HzBPqRqYiwfeMWZ45ffJE	149	1283	127	1	6301	jxbtZHM5xCtrqHbzPP5dR8D8b8UnFNEcG62DvT3QBibeP7ZLu7t	5074	7137	7137	1617223860000
9792	3NLZHUGTX9txxn8Mjcwc5oKvrXD5ff59T5kHKyvDTMvYAkLrbgtd	9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	1471	1020	127	6301	6303	jwM6RZq32nnE3CLF9k7ffud3ygvijFHwWnjzGBjPpYcmgwMCWaL	5077	7141	7141	1617224580000
9802	3NKvNTDgXpyviVnFsRSQy6mHXaMnHLP26FQKU9ztJw2uGVMCDJRF	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1407	1395	127	6301	6313	jwmgkVH5i5gzcCa1JyJ64sva2aE2J7ReBAsscZxwsA3ygzooAPx	5082	7148	7148	1617225840000
9804	3NKTJBVhpPYixYZZZ3GB6CFmGBNgJFPEkFaNihhyjWPKNfTt56hw	9802	3NKvNTDgXpyviVnFsRSQy6mHXaMnHLP26FQKU9ztJw2uGVMCDJRF	1483	1276	127	6301	6314	jxwZpCPjZzfuRdF22CQBSSHim7fSJPzN1HYMB1UYMLqJhvstU2h	5083	7149	7149	1617226020000
9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	9805	3NKYkuCaWi2fL7zUBCaEt2wqobA1xzTeQVPCWtvfKW6ABtDwDKLY	1672	1159	127	6301	6316	jxNMbmkuQZ7hHtqy5LUQfZvszxYvZu4s3d3zzmi2KrFmuL82GqF	5084	7150	7150	1617226200000
9809	3NKKJ6j82mMgNHHZgrtcNr4fYMoXNNJcDsT6zuJWvwAtgZqYvcmg	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1668	1370	127	6301	6319	jwz7eCTpL2p2284BtMWsr8DCJwGUSDkBphT7yABBHcdqN4tpdgM	5085	7151	7151	1617226380000
9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	1631	794	127	6301	6321	jxKkjoftkzEYaTLiaaiBqTT6Y46eP9wjDrQUuLFFsYmmkegGs1f	5086	7152	7152	1617226560000
9818	3NL1BDydCxnPLtNfTztzoBVnngJs78GGkfwmaRxHtZcDAbmbnySx	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1406	1393	127	6301	6328	jy1NFT24g8XNwP1TX95VJRBFBE1baD1c45d3LcmEMpqdDAeMxUc	5089	7155	7155	1617227100000
9822	3NKjCTy9XMv7R3rGJFVQdpzVVoY3EgpBfQ3rHs9YrBimKVY1D3gi	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1406	1393	127	6301	6332	jxJJadbw3v5HHo6Vu2KyvBRAd1vyYYR5yhVa2fauosASzst5R24	5090	7156	7156	1617227280000
9828	3NKvgqLAg9D4RjNtxvGnFoe1aPp48XQhdZZjzVYU9S6EVHVcpRgM	9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	1483	551	128	6301	6337	jwYRadBA5TjUh8uhkQkgsYmVL2aGvHsNfFV8qbGU8RpMBvuNNCE	5093	7163	7163	1617228540000
9830	3NKcdqKzUi1qnuYvrSq3iApBQGzp3t4CBmhVfdn8Pnyu2XAn29DZ	9828	3NKvgqLAg9D4RjNtxvGnFoe1aPp48XQhdZZjzVYU9S6EVHVcpRgM	532	1303	128	6301	6339	jy21QGQ9EGUwx2hvizaHCgaUqdr6QinFAHJYRHrvhsiFkLjayfD	5094	7164	7164	1617228720000
9703	3NLd2tqBkB2ShqNz16yvsRVxcgayBuMDTYH7qD6V8o1bx3cu1iBE	9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	1403	824	125	1	6301	jx6DbFMhxJcgErMwKXFAmTTryE3bNEYT6PLRJ2vZrjHRXqkxTod	5033	7083	7083	1617214140000
9712	3NLWzsT84brKzHubZnAMQbW6Vzptgi4QEHxxEaGamt765HABYmzp	9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	1501	1360	125	1	6301	jx4ZhFW5PDBj29U1ov91fDyP26E3dsM4UgdXy8k1RaaJrDNYzNA	5036	7086	7086	1617214680000
9723	3NLmyn6RksdUSkKfv9busnKfkg7L5YMoDYHRWNEnirTgvK6hfzJf	9464	3NL3qciic4FPkBj43WqFSXwUfsbREvxrfWY8r4ovP6TfycpAkokM	1467	1250	118	1	6301	jxirmKcDMwE7caNuYgxQEhRrikzMQ9oYxpQ7cj6jPz5aKCJt6FN	4882	7092	7092	1617215760000
9729	3NK3fozJf6Pi5b7Pxtqw7APfdAgCKVzNQuVMUXYLxwBAejKGTnep	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1594	1326	125	1	6301	jwZPfzbefZbexX2Ry9Eiw9kWveujG1pnWQhGjG5i6BtXVxNdgCB	5041	7095	7095	1617216300000
9730	3NK6FezeXF49EfJBnHHu25pZiayZDn4qgV9USBmctSygtiozynfG	9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	1646	1354	125	1	6301	jxyqVJqPZVEWYHzDHUd8BrP29AraJWHbbm4aQcyxCrpryPsqfun	5042	7096	7096	1617216480000
9733	3NKLYRVL8nK2ND9mxenxbKmSNun3YJvu2EDskKo9KZCMKs9h4eB9	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1656	977	125	1	6301	jwDiWa5JGahJ5WjkaWj2dXzrEuXQF3cCdkCkXvYBSrj8WnbPP4d	5043	7099	7099	1617217020000
9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	1419	814	125	1	6301	jxinWSBP5S77b4nqLmDuove7FdDMYroMCaDw6Lurhd7i3bod9EP	5045	7101	7101	1617217380000
9740	3NLPMwFxuPNieic97PN8qDzjBX4X6we7nNdV45RRNMDMsKDYRtkw	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	43	1310	125	1	6301	jxPA9HtFz8Uau5tch6beBPpQ5awqc7J5a33u2qLojzeKAwSeTvH	5046	7103	7103	1617217740000
9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	1573	1318	125	1	6301	jwGoUkTCaNPUL67t1kVBgB5BvHNPadpZW57Q5WgxCxAGpt1c5rR	5049	7107	7107	1617218460000
9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	1542	1178	126	1	6301	jwDBKeLZixoLN52MoACwhp7ZhATsJUU6vGbTFwJVbABjjR49bQW	5052	7110	7110	1617219000000
9754	3NLGBRFQr4kRjuNrVvfXEi1gyohBA9LQtoav9iURVpwmnaVi1wAe	9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	1406	1393	126	1	6301	jxbrRt1svHy9Z58k35cpxkvPSdGhEYpKKVhuE2N8HgKtLbykLoX	5053	7111	7111	1617219180000
9759	3NKWnw6yQkDQLGaKqPvhbZ2A9uj5YYMJLsxQMAZgQkuTPWMnrEDQ	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1637	816	126	1	6301	jxkgdoEwfkqSBQdak8pwLC2unUki8w2WtotvaoREBxs15iUkL45	5056	7114	7114	1617219720000
9761	3NLU6yoUtcmJKs4gJ3vMFkKADiN4p7iTJpjPWdQbKXPoNJQRrJqE	9760	3NKTo18aiUskzfsuFyV75K3exNXmmvSQ98JdkeBBVeXdjohsQRPa	484	1319	126	1	6301	jwv8GAf3ore2Zf7Z7n1f3U66Aogsomo6iE3MM2ZLAezhDyJsPps	5058	7116	7116	1617220080000
9767	3NK4RdgGjrfEdAQMfSQAhE5agUVAfbaCZmnFFdSwdpDRh8545PTs	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jy1eZ7NYwAWHvUGKt7MgyTZMGkvLUArSRZnvTBHi7ab6Zoe8vbs	5061	7122	7122	1617221160000
9769	3NKwhF3C8A5Nzp5B7E7g5aDs5gBN8J9QrG9Bx6K5En8JaaEcJiWL	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1637	816	126	1	6301	jxjoks22JvYs3HxsHGE8T6weim4aNS15b2XnLDzRLu9LP48MjbN	5061	7122	7122	1617221160000
9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	1542	938	126	1	6301	jwc5E4ByEByAsEPLz6XJcjc8hCbRnNE36TQLVVCp9bERo4iDVJg	5063	7124	7124	1617221520000
9778	3NKdzTrcvLTswosdrxW3QSLs1YHE3i1uunrJPtAifRixi46hHijS	9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	171	1374	126	1	6301	jxiDY8cXNfugCMKt4jFpULAdSTfZGcZwrvqm4Bpuq4y8k9vof8C	5066	7127	7127	1617222060000
9781	3NLqWZFLCNKmw44Ddy68spYvaBRZPYZ2MYkGAEdYHJMQtAW4wJoo	9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	1549	1236	126	1	6301	jwX5F4AAZdQesecXiYeJBSZYdW4cD8ucx738ufjhkiMrkvRU1Np	5068	7129	7129	1617222420000
9783	3NKAUhp19AyDsaWNKZSocJD4XvP46DMJ8pThvcweCsM34jphSpyn	9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	1403	786	126	1	6301	jxnGjZ6pH5CKsL5ijFoAcNYrF2aV2Xz4N64sHqFYrQx5B89h6ws	5069	7131	7131	1617222780000
9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	9785	3NK4jRw2mp3bErPf8X6b16grXi97z4oQca1eQgV68NqChkpE3ofy	1406	1393	126	1	6301	jxd5VPSS5xfSq9yfQ6Q6HDVd1auAPR4miEL5gGSBWTTVFJy4wos	5072	7135	7135	1617223500000
9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	9790	3NKmKfm2RSTfA1w5mNSJRLoyAQgcRhWjH5qdNynchHar4kBmJPbW	1406	1393	127	6301	6302	jxDi1peuLKiuZQojfSqMHM4Yf7aDv3PDt2nvHTFWiS1D8iu5YRr	5076	7140	7140	1617224400000
9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	9792	3NLZHUGTX9txxn8Mjcwc5oKvrXD5ff59T5kHKyvDTMvYAkLrbgtd	1457	1265	127	6301	6305	jx2Zprhy7rpBKYUVjUyRbqpwka1o8YewF6dQhom8rd4zaPQWQ9z	5078	7143	7143	1617224940000
9797	3NL7PVdPq1SjjHpRRaF1NFHUMxk72EcRDHxyuNPo83gBNabaYUhN	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1402	810	127	6301	6308	jwptkKiStNESzw4rpgHmyAF6tBC5XRYTYcFm6w23iAdTWJ7NvLb	5080	7145	7145	1617225300000
9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	9796	3NKsEa4QmijW4SXGK9BU74LaGgCGfQbqjUyeFVWet2ZuZsbty7mt	1637	815	127	6301	6310	jwPwrD1qSUFuu7dwF1eN4twtAUUpzgRFdn76drkLhFpDmXRsJv4	5081	7147	7147	1617225660000
9801	3NK5wJ1CF4PcHrAMZH5GuyabR5QzZxVWuDHNQB3tjtbxrCdWid2E	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1668	1004	127	6301	6312	jwysP3M69ooi2sokcTdJwjZMn3ZwYPH58AJvUpnD5AoDYUeRhH3	5082	7148	7148	1617225840000
9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	1440	1377	127	6301	6320	jy2hzgMGaT8yC35tiXLTcbqTnPPyD7wviMVyg7hCpM7QQiFHi8D	5086	7152	7152	1617226560000
9813	3NLHPpfvAKtxot8AABQa8rW2w4k9xpGXGLqkAFmXtsGs7anxujbX	9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	1402	890	127	6301	6323	jx1vVVyG99GeKFemr8ANP3dQpJ9jzURaR2FAQboCm4WAA7fYJnD	5087	7153	7153	1617226740000
9815	3NK48AtpUMBeyM1aXG9DRJpRoFft88UrJtQj6tthVfo7VYHo7ch6	9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	1407	1395	127	6301	6325	jwW98MHiruC4zjdzFw3SBQFG4Rr2YgSYg6b7gQMD9aUtJgRWZeS	5087	7153	7153	1617226740000
9817	3NL2SAyovGNprxwVmP7wYBZKBgRKxjRRNLe7LWZtUVW4tX62dZTk	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1579	1023	127	6301	6327	jwG9SitY6EwhZngo79DUzMK1MHn7p4vHLspDz9Vopss7V4EsQpB	5089	7155	7155	1617227100000
9820	3NLQWK3VoMX4w4Nq2bwWtukJ9p9aRu2DN4Ka9Y8H6YKc785LUk3Y	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1419	814	127	6301	6330	jxJZjN2G41h4zKY5KXUgENYfEqJGNWgLfWsy35FvX5iGj4USng5	5089	7155	7155	1617227100000
9821	3NK5QLjv5jkxXhBzo8iMBT7h5nEu2SoV4sLcdFJqj7Tvk5j64aeR	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1439	1153	127	6301	6331	jxsB2Uiye7hpwE8RVXnfiaf2Zk3LxZ3J9JKkdKofcXFQiV3JPi9	5090	7156	7156	1617227280000
9824	3NKriBpYYwWMmTRqYo8ojBmy46h9y1Q7Y7BBV7k3D28ygpkUrdQY	9659	3NKDE21zX7HH3oBoJrCmj3yK8B3kYGj4bLjWFFSB7BgQxjejE463	1439	1153	124	6301	6334	jxHkeDAsx1gzZrYyFfyNhWfydrxG8wPzvfEWeWMk4rKuMZ7R3xk	5014	7156	7156	1617227280000
9704	3NKsdRF5Gq2j769MtvweLVP5hkfauzsNQwBNvzpm3NG28gxHdcQh	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1444	1381	125	1	6301	jwQ7xYH1LtwoHHoXukEgi4MMi1VWdhLbtXYoHAK1yzeDQyt8zCZ	5034	7084	7084	1617214320000
9707	3NLu26DCC8FQ6to1eb9gdWvGGKE6UL4wThNRA78JxyrwhghwtFNh	9703	3NLd2tqBkB2ShqNz16yvsRVxcgayBuMDTYH7qD6V8o1bx3cu1iBE	1444	1381	125	1	6301	jxdWzDGhDx3JRKKTDWyzTwusNkvFABVRsNdKR8r6LvXPiofPk9g	5034	7084	7084	1617214320000
9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	1585	1366	125	1	6301	jxS1C6qcm2hP9tdiMoNMcZun3MnNZYeAQx6ij56KWDCuWXAMfEz	5036	7086	7086	1617214680000
9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1451	1292	125	1	6301	jxLWi5hzMg1hGw3D3F9zuQD96SPEin8T9fC6gAoCHUm5VBVt7ET	5037	7087	7087	1617214860000
9715	3NLEz7AbWmguV7pcsKvFXv1as9AMtx85TQqg1jifYND2eMF2Q9fp	9578	3NKbcKDf1uYEnosFVmQEuaevEJkvVQMydoDbuCj27CHdsxrHw6dY	1487	53	122	1	6301	jw7LNqmdj5b4MoM4cgz75cZELbGfankur29xrv81ptKfVKnUfd2	4969	7087	7087	1617214860000
9724	3NKPmgGPCFjBgMYmXz6fWWjtiCCzr9m3M8cbRL4BccoAZcLcjiJz	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1403	824	125	1	6301	jxvkBQXaBLawvnxVdhNwCNcG7bQHGhPNSBUN9a5HRANdDePjgD2	5040	7092	7092	1617215760000
9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1467	1250	125	1	6301	jx9Fpjx3ExYrjJTgxYjfMJtX16YtV84VVqG5eMgXr3niuyXfekr	5040	7092	7092	1617215760000
9727	3NL2aeweB9vDD4QjF8eo5GqoXJfvzt3m4M6YRwtAm7BdTLoKDpRD	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1407	1395	125	1	6301	jxNCkLH3W1YyGy1oZBc5EV4znwDDKJMzZZ8F6hbVxmyh2GgQqyv	5041	7095	7095	1617216300000
9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	1407	1395	125	1	6301	jxtZ3hqpkQfPufeT6hrv4fKysbGsuyWzop6HmJetwRAr886kkpt	5042	7096	7096	1617216480000
9735	3NK9M8S2eqrkLrxV49EFvtwe74qjbR2ZE4HLWWSJuZkBfmyE5B6E	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1406	1393	125	1	6301	jxjzef65DrgyTgjRqxJEt3rcaZ1uthnPhiZP7fgDRxsTz2DaLES	5043	7099	7099	1617217020000
9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	9733	3NKLYRVL8nK2ND9mxenxbKmSNun3YJvu2EDskKo9KZCMKs9h4eB9	1483	1276	125	1	6301	jwsBA5bxssj7gYcHYRZDubAEFHQUV6GauBYhjPfFohR4Livx5S4	5044	7100	7100	1617217200000
9739	3NK5UKqBkjsUxEd3RnTvk42jw9RraBxoujpZTf4kezdEdb5FhsTa	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	43	1310	125	1	6301	jwKSLMU3KkGAHChKVhkuNnUaKpeSKaZ5jsrbmjWPDtgXBGW46De	5041	7103	7103	1617217740000
9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	9741	3NL7Bcs1M81iVDZWpQzYd3VrgM13y9HWoUN1QRgaijUDjage6wMt	1426	1118	125	1	6301	jx4GK4zKZZc4jxnGWZh5kFDDDh132Xb5j1WVWxLDWCnkdDFkvmH	5047	7104	7104	1617217920000
9746	3NLv3amCt2tT5M5uBNeFBLn3KCCYBUZnUyhsJKURcp1skEGRne3b	9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	1403	782	125	1	6301	jxUKbewHr3QbdztCFJKEPmyC6bhzTdXe2MKQn7omDXAnCvPwTEz	5049	7107	7107	1617218460000
9748	3NKBt4FcWMcXGBWnAiQY4mY78EwWvJt46VdJcP2QmzrZdD4wbRrz	9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	1440	1011	125	1	6301	jwZPz5zR8BpudWAfknwtAPQm5AisKZHine8Lid53v1rJXENUc5t	5050	7108	7108	1617218640000
9753	3NLRSSKBcftfG9xCbdRCHu5bFe91TsnLTyfhq3d97jQkLxv8LJG8	9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	1673	1002	126	1	6301	jwvb4v6RwTL33LhChfj2p9kbDauy5ZMDSzforvLNwjEBsKgzGXv	5053	7111	7111	1617219180000
9758	3NLKP7ZZHAVXCN5UEfUPk56fjogvudNzfWPArX6zdGPyM5dtFKJs	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1406	1393	126	1	6301	jxVCDWJPQKGxf6UJRi4xcQVSGtGsLvMBeAYjUZZfLsCtDqMWvTU	5056	7114	7114	1617219720000
9760	3NKTo18aiUskzfsuFyV75K3exNXmmvSQ98JdkeBBVeXdjohsQRPa	9759	3NKWnw6yQkDQLGaKqPvhbZ2A9uj5YYMJLsxQMAZgQkuTPWMnrEDQ	1579	1389	126	1	6301	jwabhrSBzrxfsDg9EzCZFRjFErmxymAWynx5KW786LARa1bjGYb	5057	7115	7115	1617219900000
9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	1405	857	126	1	6301	jxSPhGAxp3uawPJvuShdP28xttSZdjRmrW776vz8FYGsiBE9RfG	5060	7119	7119	1617220620000
9766	3NKLrPQ5VKPtBQXj2vkCtEfauTcaN73W6yZkWGZje8sqLc1x84D6	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jxyuTfetvgwixTncQ9zFSyRLXERG1G9mVqnvhJ24YjRK3gXqRwE	5061	7122	7122	1617221160000
9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	9768	3NLNoyASKuKYPAfjMALGFtdjHgBtjjquSRkU6fXtqgYFwqJmqicJ	1403	824	126	1	6301	jwwYrfCHELgpdnaw6VTjBQEisdcA9n7bV6wvdkCiykXzzpk7ktr	5062	7123	7123	1617221340000
9773	3NKDxfXW5CdVYkTo7irigW3gku2qu2ihP3LyXZJvqwAq13LUWZhh	9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	1406	1393	126	1	6301	jwcuivHsTRDtimWAtkdy2iA74VjBha8RQeLfRLq64oMrJwSRsw5	5064	7125	7125	1617221700000
9777	3NLWBwPVGBDANwiX5o6YaXona1bXgvwoffmx2i1FG6kb6wyvteVY	9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	1407	1395	126	1	6301	jwea92Ash6Y28NWk9hFN1eGe8fHWoWJkic69CREDZ4i9MqvjoaX	5066	7127	7127	1617222060000
9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	9777	3NLWBwPVGBDANwiX5o6YaXona1bXgvwoffmx2i1FG6kb6wyvteVY	1587	1111	126	1	6301	jw8QJ5dSbJokRKaW4SYxPdryHF5MW18FHjU16AvYZA3i4gHCEhx	5067	7128	7128	1617222240000
9782	3NK44xm668zuYRWDDgjLFVHhbgH9dx8W8T3fG1EzbDkFCPeXuW5Y	9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	1588	1146	126	1	6301	jwBFa93VFSLzHoncyv5AmxejNgK9eJ3J66z73wrULL8VBNS5fSu	5069	7131	7131	1617222780000
9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	9783	3NKAUhp19AyDsaWNKZSocJD4XvP46DMJ8pThvcweCsM34jphSpyn	1675	1096	126	1	6301	jwdH6M1P3yZa4xrCC8nUWwu2rLzpm14esn1BGBR6qAy33XjjSyF	5070	7132	7132	1617222960000
9787	3NKSwAt2b5HPXjjLHkEHvGhEfXY2433HzBPqRqYiwfeMWZ45ffJE	9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	643	643	126	1	6301	jwps7g9iToGSZHNZYN1tsCN8D9EML7oJgMhf7Fz2eJQtFH5EZzs	5073	7136	7136	1617223680000
9788	3NKjtUrkTzLJ3KYGoSb6fDHNTRLTwWwJpmxXvY8kXScSG4nabGwm	9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	643	643	126	1	6301	jwps7g9iToGSZHNZYN1tsCN8D9EML7oJgMhf7Fz2eJQtFH5EZzs	5073	7136	7136	1617223680000
9790	3NKmKfm2RSTfA1w5mNSJRLoyAQgcRhWjH5qdNynchHar4kBmJPbW	9789	3NKJadufDfqn1N1oemsuGDTkz8sHwkcv6EqEaVjiGMXk43RRfUwQ	1406	1393	127	1	6301	jwnomvb6fXewHaXcUt4zmCBuHA9oUwG2ERQE5YLzQcrDaBfHXd3	5075	7139	7139	1617224220000
9793	3NKwrCZDQor1eHQkutv9Ep16Di6V4oPuHwxPh4q357xhi7vqWrhA	9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	1529	1190	127	6301	6304	jxPg2MXfy1VNwXc9mYMEv2LpmTVu3RS1M4FoDY6vGSW1k2ayfch	5077	7141	7141	1617224580000
9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	42	995	127	6301	6306	jxof2Fdn3tPpjsXnPWjkGGT1K3DuZbt2GkYx4Bh6ZkmhTmhAiLz	5079	7144	7144	1617225120000
9800	3NLJFhqmfz9KiUKVWbD71Lp3VMJvs5igCX7uiVEW6WBpkCkMDdxa	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1599	1161	127	6301	6311	jxFpA7ThCtoGqPKM3eNBC7yUfawPvhrszx8fsZhYGbU28Yb4c9W	5082	7148	7148	1617225840000
9709	3NKado77Ur724TvgjcP2RmHNuNipL2DYhnZSbQt9PzwVcq5mhyWF	9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	529	529	125	1	6301	jxm7HQ9STyUFUuzJqqbdmitgCTSFYUPpcUw6Bs49QYuhpXW3ATw	5035	7085	7085	1617214500000
9714	3NKSCeEomeWQyWnB3VgjmqF2d9x9TnF6B53pkZLorxegRL5hbS9e	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1634	1205	125	1	6301	jwJG4NBGhVoov5aDAHWDGNZMmA4hg6isjis1aRyMwuE2RDixvvs	5037	7087	7087	1617214860000
9716	3NKetS3F1qhWckfqdTvVD4rkWmEsNwvLBUcvRc8r4mJ5vgecjfm8	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1637	816	125	1	6301	jwHzDdGEUhg8K6fjuSPLTexPim97dZUVGEDjtpF3TtgKSATXxJF	5037	7087	7087	1617214860000
9718	3NL3MHJkjZUqq9JqgUm4NKBBFXBsQyjvdjFqFN3fGgdPpW3L1bC2	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1407	1395	125	1	6301	jxcR9CSM4LZCaoUSHCUCbPDoSVM3qmFpbX5dqVtpii3vFH7fASY	5038	7089	7089	1617215220000
9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1559	1353	125	1	6301	jxAYoAUx2Fczteubkp1fXoc6W7drAWKZQ9Kh39mDBm4wxf1VSB7	5038	7089	7089	1617215220000
9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	1405	881	125	1	6301	jxWi3NpXxLEMHdSM7YyF6NrWQKHQeF7m3JkHn9g52bzpU8QwFDE	5039	7090	7090	1617215400000
9725	3NLf9VZLg2yGYeuM3ygfgAgKLtcCEZypGKTzxB8jrmc8BGckPuH3	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1407	1395	125	1	6301	jw84UVCzhY8HtrSnbHokFhKSUAyAGpZWLQ2AKC4HBBDqvmKDa5c	5040	7092	7092	1617215760000
9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1589	1286	125	1	6301	jxzLgH5KnETm4RQ9o4ciCD3ciMZLEwfgNDx2C25ALg4RFzAYTKv	5041	7095	7095	1617216300000
9732	3NKUrKHFMkx29wF9SwE2kzr1rp42yFqxEm6jCWaV7ZWNtwix6BJJ	9729	3NK3fozJf6Pi5b7Pxtqw7APfdAgCKVzNQuVMUXYLxwBAejKGTnep	1646	1354	125	1	6301	jx2HVzaNVhC64dvksTLKXibbwfBvQEVuRdpMF1oLS5btdw2AXNy	5042	7096	7096	1617216480000
9737	3NLswbgvFReF1rb33qrxCLHc4sWEYMNCnyVBivpaP3XUn1Pg6jCA	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	1609	967	125	1	6301	jwMqTqYy9LJWt66NxgGQyp8Yo43qjY81yEbqCcwuHpAvd68Fv4w	5045	7101	7101	1617217380000
9742	3NLWBX7pwUzFq2PgQetBBzStvXdGUP9MFrH4iqQdbXn9ihrQFZBU	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	43	1310	125	1	6301	jxdC5xG6eikqrnH2Bq6QWyTPRCXv7n92sD5geXHhA4pwyBnxAFZ	5045	7103	7103	1617217803821
9744	3NLfDsVpZpGgixBvRX2Af4MtD2KMVdPSL4N2NQZj2kYyZ1F91ENm	9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	1403	824	125	1	6301	jxXFkUkMf4jYjXWQLLcFUtXnTDpr2PXatM8BQ3iSaaxFVM9f4Xi	5048	7106	7106	1617218280000
9749	3NKUfnDjptihyZ1kZ1d34qo9PYX2NhHJPuocxbw8rjcSj2qQimVw	9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	171	1374	125	1	6301	jy1qAw9nwBfQd6Lo5EwpC1LPyYJ9T64ZQve8tBPsi7Ugn8FSGio	5050	7108	7108	1617218640000
9751	3NLm5JiE6Y8pV54vTUCTqpuWZBJiBPRN7jhALLpZyKQgrpYXdcuF	9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	1460	483	126	1	6301	jxWL8ECcTpdvu4qycqj1fSWK29swvPZh2kmJ18NEYRFDbEPcqPk	5052	7110	7110	1617219000000
9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	1407	1395	126	1	6301	jxPjrT2d83dz64ss2fDJ6JnC1omFi1NoHVzVkkBh5CfepGS3niq	5055	7113	7113	1617219540000
9764	3NLqy1AGUJNTpWMME54yTw8GU2BfZb5THtJkapMxmAEyct6xxaGX	9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	484	953	126	1	6301	jw9S6zbkSQjk7GZiq2c9i3BGUL7E4c4yEuMmyaa5ijMuk3BqSRP	5060	7119	7119	1617220620000
9768	3NLNoyASKuKYPAfjMALGFtdjHgBtjjquSRkU6fXtqgYFwqJmqicJ	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jxLqqwvD8qNRu68MXTLs6iAKJEsdR7tBc19Rjaqd9KcVYYbgK5d	5061	7122	7122	1617221160000
9775	3NLoxpxLLV2dPtaSzHT5yNeEAyWN1HKhTWeReFvhx1vZdatmywYp	9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	80	1027	126	1	6301	jxmXzQ2BghpYEoqFUDt9PHqWbNC7yQXfoDTmRHk9q3Z7JawPWuA	5065	7126	7126	1617221880000
9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	1527	1047	126	1	6301	jwyYHGTHJ2gSJXNx6JbvK7EHvjS2QQzEDMFGTPgNBMqYinXxCu5	5068	7129	7129	1617222420000
9785	3NK4jRw2mp3bErPf8X6b16grXi97z4oQca1eQgV68NqChkpE3ofy	9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	1672	1285	126	1	6301	jxrW2HbGLAyufon3Mj461GiK7Zc3TfQ86Nv7M8iJFb5QeG4xYPK	5071	7133	7133	1617223140000
9796	3NKsEa4QmijW4SXGK9BU74LaGgCGfQbqjUyeFVWet2ZuZsbty7mt	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1403	792	127	6301	6307	jwD5GPdcGMe9obEjUTpfjP3LTK6a4SwWsU5juQPHTdJx5b1agcg	5080	7145	7145	1617225300000
9798	3NLi8vLDtnf8xH9P63zHe9f1hZoezQzaqNymFjhzKDtSVJ4kCarc	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1581	778	127	6301	6309	jx1N9kK41ewUZmqYeBKnoTRPJcMgtnZRroRcNR5fPxnyx4wbCyA	5080	7145	7145	1617225300000
9805	3NKYkuCaWi2fL7zUBCaEt2wqobA1xzTeQVPCWtvfKW6ABtDwDKLY	9803	3NKBWY6KXDDhZwZQaRnC8A7TF472JmoZ9XshLsmSDauebd61YVF3	1483	1276	127	6301	6315	jwy8BUpFAEh6sGsqGFjgPgJbuHvZdiLvs6hxtRLumYTCEs6wX42	5083	7149	7149	1617226020000
9808	3NLjtqes69JnSj7Aw2rB9QnfquUCoifwzVCXNbZzv6EwX5m49dbr	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1656	1097	127	6301	6318	jxXBhJmJWt53wHSLGXxTFZCBkvV9pNQfCqikNUUoTFsbRYKHbqb	5085	7151	7151	1617226380000
9812	3NKoS5GGcrPVM7yjuwzytJHsWUZx8V91L1qWFSHmYxyQzYdgoWMZ	9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	1403	792	127	6301	6322	jxS9rPWdpdhurH1rXJ5RVJie44nMRxTYHHTXk6Ys8tnhERNthmo	5087	7153	7153	1617226740000
9814	3NLq56dYY7oNPMqXqoAxXQEUU21Sb9gqub97mjD9Mi2xRNzbqXBD	9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	1405	873	127	6301	6324	jxBcKzdLZj332JTw6HCJaqbXPua5zesEYfa6qwCJRkNCEkKV6Qg	5087	7153	7153	1617226740000
9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	9815	3NK48AtpUMBeyM1aXG9DRJpRoFft88UrJtQj6tthVfo7VYHo7ch6	1483	377	127	6301	6326	jwxwa6UtMLE5MpvNCqvDRwr5jrwCGN9hHHrnfeHKN791xMh81Xf	5088	7154	7154	1617226920000
9823	3NLF1qqXMwAvAsVrY1GSRxh9uKMaatQSqKiVKUvVpfQdbiYe9AW6	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1581	778	127	6301	6333	jwjWHQaHN1FgemwqCeH87ikdyxoeQcQg1Y3k6S9BnvEdbFJwqHZ	5090	7156	7156	1617227280000
9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	210	210	128	6301	6346	jxTJ8mgT6Jc6a1DuK1gwaxVKBu7qqJYrPKEbkZvansWj5GeCtBD	5100	7177	7177	1617231060000
9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1501	1360	128	6301	6348	jxyigiiRS94eQEzqCbJMgENpF4S6698Zu6PWXg9Vx1D54NaygdA	5101	7178	7178	1617231240000
9842	3NLFoScFqxEr66nFi9WFPpdcmGpYRQPVKsTZdo158MVJFRAF72SD	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1652	949	128	6301	6350	jxB8jf81RrPwMYEQai8ffxDsBK3zYnMgZSZBLC8MauT78UWghjf	5101	7178	7178	1617231240000
9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	9843	3NKvEctL89mFnmYFnvtDeRrMjqfmbTPyZtnxJzy7p7CKCLsUxcz6	1637	816	128	6301	6353	jxzGe74P9XBjHz65L2UptyozzXmTHwcqWuKfgvTUzMVmQHQ9Q8c	5103	7180	7180	1617231600000
9803	3NKBWY6KXDDhZwZQaRnC8A7TF472JmoZ9XshLsmSDauebd61YVF3	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1668	1004	127	6301	6312	jxNLWbEhsJg7hxd4jdwhnRLRyaVJ4ED1eRSfCigt3BD8Bi2sVmi	5082	7148	7148	1617225840000
9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1460	576	127	6301	6317	jwe6Dpjr9w35rya5x2DhjFeW1a77fE6iXiPFgrJjE1vh9kbKf3e	5085	7151	7151	1617226380000
9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1642	1001	127	6301	6329	jxgnShRqyn1vqGF9PdF4K1YwCgu6F2PWHP2yC81TxMGpPjry2LW	5089	7155	7155	1617227100000
9825	3NKkT8BjXizuEuAeNPdFZf3tEkwFzjjYBj8CfJXgBrjDFLxsg4q5	9821	3NK5QLjv5jkxXhBzo8iMBT7h5nEu2SoV4sLcdFJqj7Tvk5j64aeR	1631	794	127	6301	6335	jwdiQx7Rf64t7sGD5NYGdFUvm28oEkY2R2APvQfd3Q3coDtE27r	5091	7159	7159	1617227820000
9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	9830	3NKcdqKzUi1qnuYvrSq3iApBQGzp3t4CBmhVfdn8Pnyu2XAn29DZ	1631	794	128	6301	6340	jwDaE3a7123JLAyQ6d1TANh6HdC6Bj41DnDuuxcyghGJVH6Vjta	5095	7167	7167	1617229260000
9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	9834	3NKmhQYNCDEZdtyGRhpDo2nSL5TXU8mFLncrwThxMoeSjdKP5Lk8	1406	1393	128	6301	6343	jwzDvWeSdLY8L6oykz55n3Remtm2PmSBF1wv9nEFrvxRPVGsLDi	5098	7175	7175	1617230700000
9844	3NKW4qhhwLUCPGDXmbNAuGYMx4DRwLpSPgm8PefcoD4nh17c1YqF	9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	606	1169	128	6301	6352	jxm3oAkHCzhY2BXz8aSPNv3ZGmxDTQ4jMRNn5Au15L27MdAMGZm	5102	7179	7179	1617231420000
9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	470	1309	128	6301	6354	jwpWbt2KUuqpmZheH2p2cDGnGh5z1KVHQqJhMNdUfqSKbcWEDvs	5104	7183	7183	1617232140000
9852	3NLWnFYtNpmXy8uKCLRGnnDJBo4fBfo2qXjBuGNb9ZPwjev9YeHQ	9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	1529	1316	128	6301	6359	jx9TKtYZLtYWCFFk1y8aGhHLWEvv72Tmmu49H98i8uToUyC8ZyR	5108	7188	7188	1617233040000
9855	3NKg8anUxtu6V69JNR5zoK16CCgAaNWbdFcug1uKmCtC5p5WaZGQ	9854	3NK7Grzc2K8bWuMf3k1twak5qf4kx1s7VUb75DMtQDn651Xi59Vt	1407	1395	128	6301	6362	jxuq2mfoAdX5KW4LLbiYzjKwzZFJ3Pyb4nHhsgusU6nxyB61QRo	5110	7191	7191	1617233580000
9858	3NKbL5wHphSTPvTqAgYbxEcy8SRGDd2NsXA8dz7kbSjZ3KibLgQY	9857	3NL3aSjCt254WmJKVQmN7EtM3EMQ8h21vUmqSRBsqnMDXo7oLYnQ	1403	824	129	6301	6365	jxgCLRF1vP14er3Q7vfzmXFRp297LmRoJEGPSTjKiNBLBfFkrZm	5113	7195	7195	1617234300000
9861	3NLjwyZWuDATwi8Pv3z3JB3scaF9cvFv8JSAVzdMv1hLz5H8qAkU	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1607	1222	129	6301	6368	jxxFm3PH4poDQY1Xw2bttAEjXHQk4irBNWPYHRJpPiYnP4zKMs3	5116	7199	7199	1617235020000
9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1405	873	129	6301	6371	jxDFaPxrYjxXczNXT6PB1FwznXTdQtLReVeYoJHGACNwAwcdgbH	5116	7199	7199	1617235020000
9865	3NLchAMNFcn8zHgTv7jjDn6beUh2FzDgAPE5acG9EiaoTCs7b9z8	9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	1647	936	129	6301	6372	jxi7VubeRPVY6ueEpq8Pa9WtoHAYpMMyg5C3pkrG2D4YH8fi7pb	5117	7200	7200	1617235200000
9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	9868	3NK8NEPiHXz3cRSwdKEJegXzh9VevcACX8VG8bXRetQUBQB1XbbD	1402	852	129	6301	6376	jwc7qU2SDwzPrGuYHDn968VmCr1dX4rVyVmuJTxf2wz95oj9cJT	5119	7203	7203	1617235740000
9880	3NKoJCA7UdGMYWgiGaFK1ntzvFjSwnW3gojcaz5ouZpoW9GNXMsp	9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	1642	1367	126	6301	6386	jwyRvTn2jCSvLZ26fDBFjRkXG1AFnhJBiQfoQrX5yjoWJDPpiHW	5055	7210	7210	1617237043876
9889	3NKLZP6U3zNybPsv69QFPEpFGEg8yRqG8yWvBBHmsgMiZZgniQKd	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	152	1330	129	6301	6393	jx1rx9UfYAHYghDMPtwFyTFYCVpa2H6Le3xq6UaQgkoVukzvRrs	5126	7212	7212	1617237360000
9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	9890	3NKQeUvd9dsMiyu7DFoqLiZaj8LyvXCo5jTE1nW7MezpsvmKiAaP	368	368	129	6301	6395	jwXcH3SeMLZcMTLeENFc7xc6DvGWq6y1HZNBkqQNvvrSDKDgR7a	5127	7214	7214	1617237720000
9896	3NKFXJVQf56NjRrv7cdYFCPSAVwLr7xumYyG9WbY1Mhi8mdXNbBR	9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	1403	811	129	6301	6400	jwjYMwy93ptV6xBjgeErvmUc5YqYmTaNjfnbqJshqY3NGeBmC1x	5130	7218	7218	1617238440000
9901	3NL2bhe5iWPdZv8J19Hc92h7VLvYsKUFZCi6jqf8Q288YutkTqYv	9900	3NLWJmYQJP29vtsPifZUkkjPvs8jVpiCDDG2EgAoBjXDzP46mtJS	1407	1395	129	6301	6405	jwWBtLqhNoaqhWXLv3s23C5JQUey13bnnTUs8FBdymjnvuLhdvW	5133	7221	7221	1617238980000
9904	3NK4XNEKBZWyXuZMptJf7byJjUhhLgXVK9Yv864iCrgXcmjijtSB	9903	3NLp4J9oocy8hEUuxKUXR45daGDgGdr52Jnf24WKitu3NQqetdxJ	1657	1344	129	6301	6408	jwn4wJcmTcfHN1avaarqDqxMMehyG2cGAstgiZ3YkecWS6ErJgV	5136	7224	7224	1617239520000
9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	9904	3NK4XNEKBZWyXuZMptJf7byJjUhhLgXVK9Yv864iCrgXcmjijtSB	1571	969	129	6301	6410	jwosTQnd9cXbBt12Kvb6UCJHMdJ7ZEi1vx1snJRXqagPRqzuUNB	5137	7225	7225	1617239700000
9909	3NLWhveK42mynUEMaHLvSuuSYvdkmRPxLZpwYAGaAJf7bBfarz6v	9907	3NLAmp7MmfhhFK223oma2U7CKRGG5fpY2jQW7N14U32GHg5LRksP	1407	1395	130	6301	6413	jwdWpyRfJKXodLco2baby9nQJTqoXwgioUJUfoxmnUKw5ssec4m	5139	7229	7229	1617240420000
9912	3NL7rnmiSE93Kt2BaCMGGVmMfPALBpopHM5atJivUEj1Gh76usL4	9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	1406	1393	130	6301	6416	jxqoVHMb3w1x3f4azFm1cevEU7C2FsR24DxFFwESEptcRDyQVxG	5141	7232	7232	1617240960000
9914	3NLKgozbnph5jUfbz2f3aK2psfJ39J3YcCPvk4JaCXQQ3PZ6PRKy	9913	3NKkJdynCHyVtQvAQ6nUjbfQxgdNVeRrHnU2JXUBLURiFBDJqQFJ	1571	1335	130	6301	6418	jwa2NE1vZCSC45C496SsTgNScdj6UK4nSL3BMgFPPhpqEgE84DL	5143	7234	7234	1617241320000
9917	3NK75sBwSEicdEXTSbAvwvZLqEo3RwaMwAEQcxWfvKeSdFzLfvWZ	9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	448	939	130	6301	6421	jwCF4ZC6Tf75MMYjrFTadzAUDwkZFTg7e72G5FDrzP97qqnmS1J	5146	7238	7238	1617242040000
9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	9919	3NLpBMjhC8Ab1tH6TULipDShRoVvzRLLMMtDEkPjh2cmcG8TdoMr	1506	1373	130	6301	6424	jwDKQnsVbVK638KDm4FkT1E2McBacSy13eQ4nYRUp4uemBH8dJ3	5148	7242	7242	1617242760000
9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	1507	1034	130	6301	6428	jwCXwp4zvM4dKkde9gQ34NHsxGfC91Gh3QowBhSKrAcY1V3pyue	5151	7245	7245	1617243300000
9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	1594	1200	130	6301	6430	jx7YMkepuXxvECd5umb1KvmrzXbwe6vZ6wNez2LYgCj9vPHrP4J	5152	7246	7246	1617243480000
9940	3NLTxQ4GkZ6JQdnzV7YRcfDRYR1g3gU21aZAF318oGS9D5uMb1iC	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1406	1393	130	6301	6442	jwkPBcVPvoPToZ5UVtEBY9cwzJyPvxUJ5w2aETCAK3c3cHBwhhn	5159	7254	7254	1617244920000
9944	3NLu9M8xPzKFgGD6Hzb4TVKXvD8fgRdKjuBcNvRUCjYFq11MqsKe	9943	3NLwRinnMFSAE6AEdW9SGo7zs31juZrUyXJcW6LXCu2TsT1csN8C	1594	1326	130	6301	6446	jwp7fGKQPdBguiNciWEGscR5kAaaAUcZGRtL7YnADJR8oPeubej	5161	7257	7257	1617245460000
9948	3NKwVT9vh7tKvZPCV8hCTYe2hbDoqouKp2AoTCYxpY9gXCNuj5mN	9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	1637	816	130	6301	6450	jwZjhkoXjm9kfotJBnjmQMwCRNz7soKeZMdoqqCSs5fsAVMJC3Y	5164	7264	7264	1617246720000
9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	9825	3NKkT8BjXizuEuAeNPdFZf3tEkwFzjjYBj8CfJXgBrjDFLxsg4q5	1403	824	128	6301	6336	jwQAcbGCE84RjJbaPChhESGX2MLvASakWq1CysZ4wFqVfsA4KHK	5092	7160	7160	1617228000000
9827	3NLNmgRHDgSA3LjqadHLakUVGXuiDZTm4srx49jnM7BNjD8EqtDF	9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	1483	551	128	6301	6337	jwAYaiQs6YGuMSoxYwkn7XCmAZZY3uCqmMxaj1mADPLCxMjAFBV	5093	7163	7163	1617228540000
9829	3NLfmtWkXJWa1sRYQbYnmwDdy7gegKRxpYeSDUqVMG7QeDa6Atjp	9724	3NKPmgGPCFjBgMYmXz6fWWjtiCCzr9m3M8cbRL4BccoAZcLcjiJz	532	1303	125	6301	6338	jy1Fdmxibqkz2EwbNifSzeX4kc6FMAMGpEeVUpKd3dLbtQJjh4m	5041	7164	7164	1617228720000
9832	3NLfvJcNq1HH39hEHooeJ8p58GynKgqJNrHfNUQ9m2rgQ17NVXtR	9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	470	1309	128	6301	6341	jxwWMztK44SLmfjG2ysZ36NWRGaLZyF4icA9Ktk4abGejNV6FKq	5096	7168	7168	1617229440000
9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	1600	1372	128	6301	6344	jwqaGr6EQMHm6E1RkCyRYyP7nhwd4bZ7wRRx31X59E4GWerC4sA	5099	7176	7176	1617230880000
9841	3NKPfiZWUL3KfbXdUTdSxtMUmqFG18knpDNKSgd8rxBbW6VWj1n6	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1471	1386	128	6301	6349	jxaixERbw8Fif4pd1n8A6oLh3vg9xTH5K3yojubQhMfSnZBQGp7	5101	7178	7178	1617231240000
9843	3NKvEctL89mFnmYFnvtDeRrMjqfmbTPyZtnxJzy7p7CKCLsUxcz6	9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	1407	1395	128	6301	6351	jxA4GJ3QKuKnh7g5Wr68RtMZuFVs5x9Vkkgh9GWtktDpaqv268t	5102	7179	7179	1617231420000
9846	3NKxoJHXt5m5SQpGNuPMeuEeGm87eFcpMNS8aUsMm89nHtHaD33i	9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	470	1309	128	6301	6354	jwU3u5PAbkipfdWEpHfcTvMzBZRL4TfjyY9Z2PbaPbad9JxMaix	5104	7183	7183	1617232140000
9848	3NKcCqaVJAMSJpZEqZf37cJiEnDY7JdwLTHavxkJp4xYwPEPtQ7J	9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	1553	776	128	6301	6355	jwSYqAfWL1hMaA3w3AJwabLqdqBmwWtAmNNA1z5CXHdEe4xNV9n	5105	7184	7184	1617232320000
9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	9850	3NLwjgFXHjbn6RMAR6anwBbrKQYpFCfhzCq1DBG9YqDQdyn1bfVe	1405	861	128	6301	6358	jxoRQZf2ByhENmDDhbASiyj8tcmYvKGGTCRtMRxijrRVVxUfFEn	5107	7187	7187	1617232860000
9856	3NKnZY7ZfWAZunc1easwechyB5YqwXdGUar1tc2F55fmSeMHTYFq	9855	3NKg8anUxtu6V69JNR5zoK16CCgAaNWbdFcug1uKmCtC5p5WaZGQ	369	1312	129	6301	6363	jxfP7sm3CNmBHzN4QjrwXi6xyjubyHd4HkrwsNiY476f8CcK4G3	5111	7192	7192	1617233760000
9869	3NKY1bWny3d21xjeJZJwL4y69qsV6HUDYDoEACWQGyeGS6bPeXyW	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1651	1055	129	6301	6375	jxsC7R1hUnPH1wwnaVXeQoAPtgNg7qWmFkZNK22YFiavR5TWxVJ	5118	7202	7202	1617235560000
9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	1522	1322	129	6301	6377	jx39nA9pjfFzAWdbQzvXW9N2gg4vL6hTAiHPEjJ94VQg6caPgn1	5120	7204	7204	1617235920000
9874	3NLKixnh3T7NvEtc9gTL5bKtqMcN7f1wkRnNmzjfyNDjpeBLXUFs	9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	1444	1381	129	6301	6380	jwyLaBmQiXpvQqBXBRHLX9WL9q4titvVwdreyPUnsnHM75B8Zmg	5121	7205	7205	1617236100000
9879	3NLT96y9MEC4kuhkFSB8W46DyXhXJTsAm1xkWab3MFak4dYNi6Zo	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1407	1395	129	6301	6385	jw6t7LCZEjM9mWeyqjHHU7eP8EmPQiryVXPXJkwYYZx91ndL9WF	5124	7210	7210	1617237000000
9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1406	1393	129	6301	6388	jwo6kSgFRmvdNyiRtJSAukLp5y8jHzLE7jte7sJeTKah6n13oXU	5124	7210	7210	1617237000000
9884	3NKTWH559suBaN3FyZohnKRqw4exRfj8Ncw5ewQLVCDgiHBGyhjL	9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	1642	1367	126	6301	6386	jwTc4sQkNtJ8ZCJ4yg3VoktQoLDnwpesioYRbrDp7JaiEjbQdWZ	5071	7210	7210	1617237121650
9886	3NKaZCQH6hFdZqmeds2UWPSwqZK1koRkgnqPwj6KrxV8iUKu2zK4	9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	1652	1315	129	6301	6390	jwwSw3KrJv2w6t4xArPd4snL1Ztj1g6aQHoHWggWZLa7dUUbWSX	5125	7211	7211	1617237180000
9890	3NKQeUvd9dsMiyu7DFoqLiZaj8LyvXCo5jTE1nW7MezpsvmKiAaP	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	1405	905	129	6301	6394	jxztVWQTF71gjuXty7apWDxaViE9gzU2xJzJADH4xfq1Eb4iuFM	5126	7212	7212	1617237360000
9893	3NKJjZiovFhqaCxa4MpMCipzoS3iNMbLHXiUiR7rrU5H1wgEsWVD	9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	1405	875	129	6301	6397	jwDDPHtiP5XHJTBYs4uMStrDvo4utbgqNUGy5jYRy7efHBPo7wd	5128	7215	7215	1617237900000
9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	9892	3NLXwqaEZPk8wb3uKNUB7dNUQJrncW3gRA85oDK87phqxMqNU1hX	1483	1030	129	6301	6399	jxudVGRRjS79sFDPp2WnZ6ZvDUTFghVwzCPz34ATPuGR1bHDwDV	5129	7217	7217	1617238260000
9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	9901	3NL2bhe5iWPdZv8J19Hc92h7VLvYsKUFZCi6jqf8Q288YutkTqYv	1407	1395	129	6301	6406	jxMn5fqgU7hd29rAo4N1J8VR3Nxq9qkREyn4jnDByqdCtu9Kgtn	5134	7222	7222	1617239160000
9908	3NKMRFxbTksx6ueHjKxpdWNmgASc3Vx9dCE85rKLyPrhsYAU7HKV	9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	1547	1012	129	6301	6412	jwjkjoBXEX7kAMvH1s3umvKUQt3XyheUchTeRygjMvnWFB9ESJD	5138	7227	7227	1617240060000
9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	9909	3NLWhveK42mynUEMaHLvSuuSYvdkmRPxLZpwYAGaAJf7bBfarz6v	1445	1290	130	6301	6414	jxSLTrkLb7UGCh2HDtS3Zs7NasTd8sg4uGz9BbStmUSazWbY5Qf	5140	7230	7230	1617240600000
9913	3NKkJdynCHyVtQvAQ6nUjbfQxgdNVeRrHnU2JXUBLURiFBDJqQFJ	9911	3NKMm6kDTeztokSQypvWfuNNrsJRx2Fvur9D5TcRJhTW2uwSr8xe	1406	1393	130	6301	6417	jwCjxM6jTgzbg6st2NsVxn5ApAUCK5K8UtZZPC7Fn3mozUxjoTM	5142	7233	7233	1617241140000
9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	9915	3NLLzced8fUHD72VNcDeUQnTfye1D5jPzED47qDgRyxnhtU8FetV	1637	816	130	6301	6420	jx5j6Mkb7cX1asDwK46cHpUxG8xpWnpiCe9VNGvzg5gks1LyHFo	5145	7237	7237	1617241860000
9918	3NLt8QbvqqGV5vAmQrXFJXzQfRgLNWGQarh3ALaacFgiL12HrUEv	9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	1564	1092	130	6301	6422	jxmBn6H3cabfkKDHaSZm78kbsW3csnp1gvjETtpmXpgqpeChnzb	5146	7238	7238	1617242040000
9919	3NLpBMjhC8Ab1tH6TULipDShRoVvzRLLMMtDEkPjh2cmcG8TdoMr	9918	3NLt8QbvqqGV5vAmQrXFJXzQfRgLNWGQarh3ALaacFgiL12HrUEv	311	1307	130	6301	6423	jwnRH88ENmTm1SDwdJhTbQsBVTkeMu5mddUXTjAgfyDkdxzJQVj	5147	7241	7241	1617242580000
9924	3NKFJUSp53BReHPNHBPqyEC2wU9wCr9bbNywkYTgrC4cT2sDSwEB	9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	1406	1393	130	6301	6427	jxszThjkMXz5C1iusmt96e7d27TYTgCQbpZcQ4Rwa5V4XEYE6Jx	5151	7245	7245	1617243300000
9926	3NKHVG1ztPn5pz74Eaq7Y67Rb4WNhQrr8MS9ktpYWJ5DYSPy4XDB	9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	1596	997	130	6301	6429	jwPtSREb5KSn4bBn1wSV94B68zoPTGSSJ8Q9UQFndXeYNAJT3zK	5152	7246	7246	1617243480000
9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	1529	1316	130	6301	6433	jwwCRSpNGANdmggA8gvALifLFm2joJPb6VrWTFACEzfbU9ScaEY	5155	7249	7249	1617244020000
9934	3NKfB2VzJivsRTWJgnhtvQ1aMGrcgXaqbJN8vzJHNQwF95WfVzBx	9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	1406	1393	130	6301	6436	jwA4CCtxdLGfLzDwuGxVNHLMWSeoGsKfzd3CvURXJTS5JSaDei7	5156	7251	7251	1617244380000
9833	3NKFZK8w9kit3iw6iQB5o4QkYjHQJziTicTsKocdRAuQLhsnz34N	9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	470	1309	128	6301	6341	jwVALr5gxPQhtCCcTxD4bjt15zMrxAwzpDmHfxL7eGSC2ZjNVnz	5096	7168	7168	1617229440000
9834	3NKmhQYNCDEZdtyGRhpDo2nSL5TXU8mFLncrwThxMoeSjdKP5Lk8	9832	3NLfvJcNq1HH39hEHooeJ8p58GynKgqJNrHfNUQ9m2rgQ17NVXtR	80	1147	128	6301	6342	jxLbH3x3qggPEFddydprPY5TxScv1rA8CBC6EnNEQs27DYr14LY	5097	7174	7174	1617230520000
9837	3NLrP7DUjXrE67sXjxECuUSbjQhn3WtZtH5mv25tj3iEAEMTakf9	9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	1581	778	128	6301	6345	jxBbC2iJqndeRnUHC5Gj2J4bDooMRBhjRDqiNT1kqXnkMJJgXbm	5099	7176	7176	1617230880000
9839	3NLLVgjnFJEk45fFEUUxjf2hCfBzCb1aD9e1muUQDSDAyW9sj2gk	9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	1516	1294	128	6301	6347	jxffTjLUwf3wv7WdMTLntgPDKZQMascJ3umdo8oLEhqHF4fccZt	5100	7177	7177	1617231060000
9849	3NKq7opTQ6eofJw8RpKbjovYVB9Lbgvbn61mjv7DwDQfzDmZVJqQ	9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	1481	790	128	6301	6356	jxqVap7NJeecj45pcjrrwF2T9jRDnp38CKkapZytxcLGccdy54J	5105	7184	7184	1617232320000
9854	3NK7Grzc2K8bWuMf3k1twak5qf4kx1s7VUb75DMtQDn651Xi59Vt	9852	3NLWnFYtNpmXy8uKCLRGnnDJBo4fBfo2qXjBuGNb9ZPwjev9YeHQ	1622	1110	128	6301	6361	jwdtq8bUfnfxNig2n44F7kisrZmLpAUroaogoHdGKv3aYZXedw7	5109	7189	7189	1617233220000
9857	3NL3aSjCt254WmJKVQmN7EtM3EMQ8h21vUmqSRBsqnMDXo7oLYnQ	9856	3NKnZY7ZfWAZunc1easwechyB5YqwXdGUar1tc2F55fmSeMHTYFq	1590	1054	129	6301	6364	jwZ6AZqqLoC1zH5Hxb2fcZRjaYFrbuK6bfh9eM1oxYjpE7Ae7Hw	5112	7193	7193	1617233940000
9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	9859	3NLRgi6682FbKDUof6hnU94bY3dYEX9EkT7SeFETpkCiLtTbBt52	1406	1393	129	6301	6367	jxGJfLcQVwXFybD6pFNQzre9ffKhJPUrMBe8arxy6PedzAGKuxk	5115	7198	7198	1617234840000
9863	3NLSf3MfuV4X9QkgHNqod2WBDWsrVVeyvrkXQBYEU79q4Gus2J3S	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	149	1283	129	6301	6370	jwpi2eHrusouLYXDUvGzT9jmgH8GqDxNgCZfjKukwHB8TsaKasu	5116	7199	7199	1617235020000
9867	3NLnWTasw8CtP8ebU8WZLT1mm3iZQPDYLyyYmx4AZ4KvKw1j4tPL	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1444	1255	129	6301	6374	jxm3gdp3Y417jLnyPKjRsj8Wde6UWhwi5575VsBC7PSgYde2zNP	5118	7202	7202	1617235560000
9872	3NLNaahCRk45LHKRSAqVjMeLHM2LE848jqtD9Hyi5SDLQBugcQaC	9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	1622	990	129	6301	6378	jwvH2itVsq6nP6mRoETcUYyQ4eT8zVhXZRwv6QzwKbBjqL4Zxp8	5120	7204	7204	1617235920000
9877	3NKBhYK7Txbu1xCSMjBnLh3HTafvan9Nm38uxPiBFWhggNETmAhT	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	1642	1367	125	6301	6383	jwvCWimFvrjqFa7UjgT6mNyPf4RM8w4XxJVAJvHEUaNhgJyEyTD	5046	7210	7210	1617237000000
9883	3NKfANTNf9VmnQci43sq1hAFGtpk5h7Q3js863Lrmh9cxJxyaXTc	9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	1642	1367	126	6301	6386	jwSCANwXs75WiGj2eL5tNERdw1SK2coS1S1EvStvJMrCEcj7cJ6	5063	7210	7210	1617237081379
9888	3NLCzCsVgbE6aPNFTiuRnooW1LtxvpbKxiCCfjZ8RWRCm87c1jb2	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	1671	1239	129	6301	6392	jwEjE8CHzhbm4HPYJqi9635PLoTywPz2qexywki1CAeNTDnUhnw	5126	7212	7212	1617237360000
9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	9896	3NKFXJVQf56NjRrv7cdYFCPSAVwLr7xumYyG9WbY1Mhi8mdXNbBR	1403	824	129	6301	6402	jwabccPtyPVfGrCVSSpVFVJAMesxd1hyjeMq5PYqtMw3Z78L4kh	5131	7219	7219	1617238620000
9900	3NLWJmYQJP29vtsPifZUkkjPvs8jVpiCDDG2EgAoBjXDzP46mtJS	9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	1573	1318	129	6301	6404	jx57aZZLMr3fVVnmv3y5oWXYsjoamtdNiwN8kvf57JJDecyu8XT	5132	7220	7220	1617238800000
9903	3NLp4J9oocy8hEUuxKUXR45daGDgGdr52Jnf24WKitu3NQqetdxJ	9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	1650	1129	129	6301	6407	jwjJgpVKCg5mNvDPZzqPKyMicGPNbuXxWooB7n6YSB2f8dvfQv4	5135	7223	7223	1617239340000
9911	3NKMm6kDTeztokSQypvWfuNNrsJRx2Fvur9D5TcRJhTW2uwSr8xe	9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	1571	1335	130	6301	6415	jxsuHcg4crMKx83xv7mXXN78VqxZWgC5K9ygniEwzJpyvK1UkPz	5141	7232	7232	1617240960000
9922	3NLZ55iEHv3qaTuDP6RaAzUr8cYEhC6457qcHKJQazeQcipYyz3P	9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	1646	1354	130	6301	6425	jxxSK4p9Hs9TLzp94cYh2Ti3vzG7dGVvgbhfk2xj8dXH14yjCBj	5149	7243	7243	1617242940000
9929	3NLxjtyBa8MjzGqrzZZxp5rswsV76ELpppNN5PESG28ZfQobpZSf	9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	1547	1378	130	6301	6431	jwP2CfZ82Pgf4saqHWe4wjRiafV8GkZif5CCGubbYwLUphFxpVy	5153	7247	7247	1617243660000
9932	3NKKXfR79hiX5Ku2gTkqazG9CtCofE9KCKQRXQ6jFdzrWjZzEydH	9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	1647	936	130	6301	6434	jxieKd44EDa39i2JF9PYnv9Qvzg3ybwiXEufVERRAgkPQoAxdUB	5155	7249	7249	1617244020000
9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	1546	1339	130	6301	6439	jxSTmMjh9QyhGLHehrboYXw6NQ3RnrZnsdxeZkkEt9gt9P2WrAq	5158	7253	7253	1617244740000
9939	3NLruTZ3TGSjFjJs3P5EPbGKZxjpvuaDtdTz1Vmgi8CTDicgnKTs	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1673	1368	130	6301	6441	jxkv3w8sN7yfajRExrw9PLLzMyjbzfemFJ2cXtXFkzrt9HU8x1c	5159	7254	7254	1617244920000
9943	3NLwRinnMFSAE6AEdW9SGo7zs31juZrUyXJcW6LXCu2TsT1csN8C	9942	3NKQG6FvMsChNGaCaTbtLbvK4Fchm8seMDEVjZaBm5rhBnMquVZR	1590	1300	130	6301	6445	jwAh9RvRZiNp7RsMi1cWDHbuYR53Da1HXp8KGg8KFL4NasTeHB9	5160	7256	7256	1617245280000
9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	9949	3NKsEWCWNxNPvGA6Z23FtsQe8ZABMdJ5iqwXqWCwAM2MyCmw4iNC	1633	1390	131	6301	6452	jxjVUci4UNBZgDWSjTFscDWc2Ez8xkTzirzoeSVsuZqErY416Dc	5166	7266	7266	1617247080000
9952	3NKn2VGzPriFWoaZWqxG6Lv5byfsQiUd1RgT17EoUtMAR1WmESpK	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	1619	454	131	6301	6454	jxq7P6MWTM37ewiTVeJ7FwzDZZDrQCqDrQfFNvyGqsqoXUqKzgi	5168	7268	7268	1617247440000
9957	3NK3z8mrme3pc522CGp1gof56JGnGi6vegc4GxjVGAPJ81tPtvVg	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1407	1395	121	6301	6459	jxeqQRmHY8vwSTW4B7mu3zw6iTJuLuciEVfJNsMAdGq4GJjXi3b	4950	7271	7271	1617247980000
9959	3NKUR7jdJnhw8hUVvQP9jGNjZjJQqRAv8AAKc96UxKtCTBf6h4KT	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1407	1395	122	6301	6460	jwKVxrzMzVQxGmzT6PwWkH6548tx3hQoJpAAaZbfJqp64tQuPXe	4974	7271	7271	1617248050191
9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	1581	778	131	6301	6461	jwjXgxJjRqLM7urATqKsj3aR4Pu6fFH7eacgkbPPSXZeVQRksgX	5170	7271	7271	1617247980000
9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1593	1346	131	6301	6466	jxWTUyLjtUVKcXBTra9Ygo75jQp8uw1iXRKDqpqxsceZobWDdjF	5171	7274	7274	1617248520000
9970	3NKKqyj5KMtsc9cgquEGaxLU8dLtrGZistjYyo9SPepRYEieYppD	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	1508	1141	131	6301	6470	jx8J2FEr5K1e3zBVvxmLCej9aeqDXvvAqF9xd8m2bvm8JavAA6m	5172	7275	7275	1617248700000
9975	3NL89UcHGoJGzNYxmWGPv1r1zokJyjRvPbAZ5TkSw3hJyisBJwrt	9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	1407	1395	130	6301	6475	jx6184KSHYr5vEtipma6pSb59PgRbMFRGGh1dtqYZHxKcUMrjdX	5154	7276	7276	1617248880000
9850	3NLwjgFXHjbn6RMAR6anwBbrKQYpFCfhzCq1DBG9YqDQdyn1bfVe	9848	3NKcCqaVJAMSJpZEqZf37cJiEnDY7JdwLTHavxkJp4xYwPEPtQ7J	1458	957	128	6301	6357	jwqgpYc9QUtXN8CKCaZvehqarG7FC4KVeg6Kuwp2a9WrjKcEByS	5106	7185	7185	1617232500000
9853	3NKVkwCJjrPu8BcH26nf248KBqCh1sPyKTArEpbr7rovyp6JgWQq	9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	1536	1187	128	6301	6360	jxFDwFbFqbqTsMvsEvRq9uNe2hZoFm64bNw8eP4PbwSPptM7Wye	5108	7188	7188	1617233040000
9859	3NLRgi6682FbKDUof6hnU94bY3dYEX9EkT7SeFETpkCiLtTbBt52	9858	3NKbL5wHphSTPvTqAgYbxEcy8SRGDd2NsXA8dz7kbSjZ3KibLgQY	1652	1189	129	6301	6366	jwMnb3yuu4d1eP6MR9NuygujkShs5Q3Z4bMLqFTsbPeGqodKShr	5114	7197	7197	1617234660000
9862	3NKpFit4tjWC6LxsyYtGWm9xftRVY4q3zqVa9FCYYoNs7fhBKhyE	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1654	1340	129	6301	6369	jwfimqwxokj3HCbEzsY6PP7K6DRr3RbU5iT54p4HyNeJ5mJEQnp	5116	7199	7199	1617235020000
9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	1406	1393	129	6301	6373	jwSnkqnBwHiqEQJ23mxiJnDbs3K9iyJWpBmfRD4WpkGvmnXjY9H	5117	7200	7200	1617235200000
9868	3NK8NEPiHXz3cRSwdKEJegXzh9VevcACX8VG8bXRetQUBQB1XbbD	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1651	1055	129	6301	6375	jxowzH6GJxz24d1U4wnPxCkF5KzVMxc7YwYGZLrtWDVKPj4TkNj	5118	7202	7202	1617235560000
9873	3NLKP5KHLBgWdKMDy1CwkqZDvr8h1BTg6DYaRT4QgXD5M3d5F3ih	9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	1599	1041	129	6301	6379	jxh8kM8bWYn4wV2zcBKKB6aTHeuiTSXA2P7qfjjG7K7AmEWtQtD	5121	7205	7205	1617236100000
9875	3NKgXg5P2Uo9uDJ6KissF51rA5MmJbXsUszEdNMcc96P5tTE9i9T	9873	3NLKP5KHLBgWdKMDy1CwkqZDvr8h1BTg6DYaRT4QgXD5M3d5F3ih	1406	1393	129	6301	6381	jxsvQ3RogbjDRwVsPUko6p5xGV8vqzkanrBhvcQC4EKfu8Bh3hQ	5122	7206	7206	1617236280000
9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	9875	3NKgXg5P2Uo9uDJ6KissF51rA5MmJbXsUszEdNMcc96P5tTE9i9T	1406	1393	129	6301	6382	jwJXSgLH7znNYAqLrjU3h6B6HzA3Twa7JWRF99pPfTgHrZXLNyY	5123	7209	7209	1617236820000
9878	3NLyZ6ye4wcBkBrmp2ZUB5KN1FeosMHFLuVJ6XVu1E4GRYirX5eC	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1402	892	129	6301	6384	jxBXxGJPY4XbCR4eAJ2YzypswwyGq7UydL7x5YttsRaJJ1bGLYr	5124	7210	7210	1617237000000
9881	3NKNgmkyK15QjiVY1791gB3pisAiCyyWE7NNECuYzmoTGSvGPxZ1	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1642	1367	129	6301	6387	jxXSVsHXzVzCaZGYgQC1tHyM8bLZjeszqN2efAxPtuHHSUF9wap	5124	7210	7210	1617237000000
9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	1407	1395	129	6301	6389	jwwmdgXkQat5GNtFeBoYsWNy9FVaaJ69an7e8NozkiVZPqEaPXC	5125	7211	7211	1617237180000
9887	3NL9bk9ekxZYmdbvLgZV5nnpucS6TcYpVCEfRspGyCxxkCJC8ejk	9879	3NLT96y9MEC4kuhkFSB8W46DyXhXJTsAm1xkWab3MFak4dYNi6Zo	1652	1315	129	6301	6391	jxTjHvKB8yNPqWoFNaEBg1mPPfBG8sRmk2DBoyvszLzM7yMMd2E	5125	7211	7211	1617237180000
9892	3NLXwqaEZPk8wb3uKNUB7dNUQJrncW3gRA85oDK87phqxMqNU1hX	9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	1403	824	129	6301	6396	jwCDjzJvhdkcNuTAvDY4Ra4ynfZSpt5BJ7YvUxx7UCNaYpfDHLZ	5128	7215	7215	1617237900000
9894	3NLUtaco578SxKNJiL9Sms1Vr44QuHttSgxEKDHHdU3pZfGb5UUu	9889	3NKLZP6U3zNybPsv69QFPEpFGEg8yRqG8yWvBBHmsgMiZZgniQKd	1637	816	129	6301	6398	jx4NNn4BR3u1nRtQBvrMWL4qrr91Gnnx9YRbj6PAa3pEnPEhMGZ	5127	7215	7215	1617237900000
9897	3NKMss5rsKoF5yWCKZiBJe5C3ktQ5aTwypWBzTKxpoMrr2QCEzh6	9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	1672	919	129	6301	6401	jxrXStAPhaHko3MLPMzrJoqpRzjQPrNbgBpDWR9pNEzqRpjokez	5130	7218	7218	1617238440000
9899	3NLN135PHWJwQXx6Gm7rmVJFHndafC1Th1P3aCHhqG3tnvBKSZbf	9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	1406	1393	129	6301	6403	jwgtXECgodJtX1uPV1WYvoTd8R9BpZPeNBDo9uYeu4sYLWPDsNj	5132	7220	7220	1617238800000
9905	3NL7Rrg5kyrosG45Brmwr76DzdKt4w1DT8sD5kMCD3twjtpJ6b6R	9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	1657	1344	129	6301	6409	jwMuxiLGk3w7qDeSNMv9pnAwgX8z35KinYiK44Q5C18FaY5JM9j	5135	7224	7224	1617239520000
9907	3NLAmp7MmfhhFK223oma2U7CKRGG5fpY2jQW7N14U32GHg5LRksP	9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	633	1258	129	6301	6411	jxfAt6W91RfEQZWbRQdDZk2fXzcxSniKq7aihfgz1rwzXCwm9Wg	5138	7227	7227	1617240060000
9915	3NLLzced8fUHD72VNcDeUQnTfye1D5jPzED47qDgRyxnhtU8FetV	9914	3NLKgozbnph5jUfbz2f3aK2psfJ39J3YcCPvk4JaCXQQ3PZ6PRKy	1547	1012	130	6301	6419	jwme7SQiZzRmZQMUJqEgLr7KdmFFH3Zh4vT62AyLd4e4nf4fg8Y	5144	7236	7236	1617241680000
9921	3NKTyF9a6cSvSmK1CnA242csbK2c4ZBG88ePun2UsCGaNugsYgSN	9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	1646	1354	130	6301	6425	jwmQ4kc3QqiHCJNTVwttfc2DYytaTNy99hHWnyeFJRH4jQrtqSN	5149	7243	7243	1617242940000
9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	9922	3NLZ55iEHv3qaTuDP6RaAzUr8cYEhC6457qcHKJQazeQcipYyz3P	1407	1395	130	6301	6426	jwGQ4Aa7bLgb8KdbSN6BDL1kvowqJmpN4TdThT6C76xcn15YbXm	5150	7244	7244	1617243120000
9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	1547	1378	130	6301	6431	jwkF7WE3SCMugSshfTkUJdz1oCmdG6hqn4qC2EbALnGbt1XQq6t	5153	7247	7247	1617243660000
9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	1440	1131	130	6301	6432	jwuDC6keaceskG7ShuiymCNqDC79MXCcmqrCxzEH1TwSu27MqZp	5154	7248	7248	1617243840000
9933	3NKGphyZBzjKeaFm8RvMj7eN3rM9rcuBd3ZyjcL17R6gqca1KeWx	9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	1403	824	130	6301	6435	jxLkaxPt99cjNn6phUTF96KUU5XSTQjUhv2cAjrGP3isBmMGTdD	5156	7251	7251	1617244380000
9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	9933	3NKGphyZBzjKeaFm8RvMj7eN3rM9rcuBd3ZyjcL17R6gqca1KeWx	1483	894	130	6301	6437	jwetXZeRh25ATfHJtV1CpK1SHiduWpNp3aPhJdHocze3yTcv92x	5157	7252	7252	1617244560000
9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	9944	3NLu9M8xPzKFgGD6Hzb4TVKXvD8fgRdKjuBcNvRUCjYFq11MqsKe	1581	778	130	6301	6447	jxcqNJq6wQjmycBDKVtUxuk64ZeszrMVYm4TsmfjwZLeuyvUiBi	5162	7258	7258	1617245640000
9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	1549	1362	130	6301	6448	jw6sZE7fNYJ23BvcKc5eJEqk9ZnpcD6jggYryCR3sXJ1T5UyhJk	5163	7263	7263	1617246540000
9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	1397	828	131	6301	6453	jxaVqZSTb14ZnrBohwq6w4J4pQ8XSsgnZ1sFXJeRbQRkMHzeVQG	5167	7267	7267	1617247260000
9954	3NLVjsQZhxQ6TgHPx6dnJvCJTbA2UWSY437LhCjwAfsGtY9VLkYM	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	121	121	131	6301	6456	jxVVKDhepNrRQPL25osKBc4w44tZU8oMzv6QcKZaiS2WCi9Zh1R	5168	7268	7268	1617247440000
9956	3NKG5SZmvhvdwpJeR4QDAtjCuVP1YxNbi4o3A9jbDS8mKF53gpNM	9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	1623	830	131	6301	6458	jwri1ufteEMrtDAsXasUPYtfzixoXaMw13iTSxqubiz21DKSd7w	5169	7270	7270	1617247800000
9958	3NLZYD6zsNCNsnKXtrRMwNjK8cXT4XgJ92HPrUddd4eC829j8Nu7	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1407	1395	121	6301	6459	jxDZWjn8saVmH76rfYpoR6xhdwHQ3XFD7Z9CuTfu1UGCYD42aWp	4962	7271	7271	1617248013957
9936	3NKC3CYzJgmYzUSwxcZZm9j9vemjdbWWSeUQJ2F6mSwst7Uz9wFz	9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	1670	1282	130	6301	6438	jxcDU6t9mgxLwt1ntkdpXhobBNsyZDAGJRKBR4vuGzbN3qdm1gy	5158	7253	7253	1617244740000
9938	3NLvcjUuWJXpvkJurdeB4yACoBPjSw1kRKpqktR8iBUEjGW9GEid	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1564	1338	130	6301	6440	jxPVCfAfzp3hKdi2k22xsmg4CShLTusmbh5wRn3WzDCwixuaSDb	5159	7254	7254	1617244920000
9941	3NLKDvQJ5dh7dPmr7Xm5XbFV3iF7afK3w7rfmmdZXkr3NcKf8LKQ	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1407	1395	130	6301	6443	jwXuutjsaeEFcXLe1QJH7bgquz4N6tprWFXQAJ3JBgkKWodh6FV	5159	7254	7254	1617244920000
9942	3NKQG6FvMsChNGaCaTbtLbvK4Fchm8seMDEVjZaBm5rhBnMquVZR	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1633	1264	130	6301	6444	jwnKjukPXFf814XJwTfQxUFUjVzDt3uMv2eRg19w5TQGYiW82vk	5159	7254	7254	1617244920000
9947	3NKRZ5umTPRCKoFVDHLb9xeiGbMXPGNwnMrcnYt4YL4qSJLR5rCz	9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	1600	410	131	6301	6449	jxPyMnML7mYZ9UxzbDWTfk7pgEiNDVD2axt8VwcQTGJzxEM2zHv	5164	7264	7264	1617246720000
9949	3NKsEWCWNxNPvGA6Z23FtsQe8ZABMdJ5iqwXqWCwAM2MyCmw4iNC	9948	3NKwVT9vh7tKvZPCV8hCTYe2hbDoqouKp2AoTCYxpY9gXCNuj5mN	1553	775	131	6301	6451	jwNWci1xX1xdJxB44PaJZWtisQCMV1jQdu3JV3iigNJvXN93uGL	5165	7265	7265	1617246900000
9963	3NKDEsVTWJfrig6L4R2EDstxxeBEiZL23Gk5fUEozo9VAz1NUkhR	9962	3NKMUg5Z6k9LiPq9qwCpFzkM3dyJdy5eLbqXq5p1WJcwdjStAEbD	1407	1395	123	6301	6463	jxmoKtTgd8dQGsYyFbpUdPZVTcYX69FJESgpXYeJUVVeLW88Z8S	4995	7272	7272	1617248160000
9965	3NKHSaug7HSPmRymvcqy2dxE1FFd9XjU4BAQ83p5L4aA3Jy2zw7T	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1406	1393	131	6301	6465	jxXoVyY2RsBtbjEw1ernYqrMm4WihzpLFLkGby4QGYPdMSJfTbq	5171	7274	7274	1617248520000
9967	3NKHcnDAt19C9mbaorMAH4jYR4kPEVxWcdzL89tHvLxFP5okpVo1	9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	1593	1346	131	6301	6467	jxs4o7YfHZD9AwYdP9eCgXfMyDuroeRBk8vQ7gvWtEhAxeGmwgi	5170	7274	7274	1617248520000
9972	3NLaPbJ8b6mKeN9DeeU4XSNEAAnwh6JT2xHGK372i16YiiR95sCY	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	700	832	131	6301	6472	jwrAkjgyEVp5xrXgoqryTNqSMwi96e1qC2Ckjt4yMMhzz4j8TSm	5172	7275	7275	1617248700000
9974	3NKoxjpFUC4MZug2phNPeZuJBU6Nc3pmoBLViZ1BBGrhEazaQy2M	9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	1407	1395	130	6301	6474	jwAQP5FJoJ2RkVW7vi9hQ6GM3jZ1hCoLMSVD3N1daWrHvdgUU4q	5163	7276	7276	1617248918530
9982	3NL62XypAJyhU1mok3JH3rJFi1x5eB2sJCiDrDnYTCtvmuSRHRwD	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwpRNNeB6HAm4wQAWMh25CDC3tSEsGc8CTezatbK3yQhPDVj4HE	5176	7281	7281	1617249780000
9986	3NL7waZyFEPi8sDo7rAvjcLn3KsMVaxSK55HsmyJi2USLhegrdY2	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1534	1191	131	6301	6484	jwHaJ824BXe9w4WuZkRVG4tnQFKPkRwA1xgVPymjhZbkt9Qx4ys	5178	7285	7285	1617250500000
9988	3NLtSmrZ3o71bDWeRrvpqph5JbYkdf6gBTLDuRpmjsMYN22FSeH1	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1617	1042	131	6301	6486	jwVNH4sdttUfvLnsU5nBwkAGFH1knXn71oqCDMusgBdT8b7ioZ6	5178	7285	7285	1617250500000
9990	3NKCfrDW46LNnag9DneuQvgJDJif9bU4iWutwBPfcSXbUrW5aAuJ	9989	3NLSW94EjXQSFfDRhWRVZkxmJBEN8YibxtHMTWDm8geC4KADvUmY	448	1305	131	6301	6488	jxGCr2rC6NEiNq7W5tcgbXnTRZVZA4NTM3U6qEhJMb6NQP45zNn	5179	7286	7286	1617250680000
9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	9992	3NKxTX88ztW4w4W1TvX7bG5CCnVbZd5nxJ7n9ePdy1iK1VfSWd5s	1654	1094	131	6301	6491	jxxfDgWdmshcHr5zYCT4HuihhRkGTth9Gi8ui9y1YW1d3yaydvG	5182	7290	7290	1617251400000
9996	3NKx8sTVH5qse7JwxjDocmqW3Hzu2eceiFX9pQxCZJXLhoW36my5	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1490	1028	131	6301	6494	jwAAjL5VcqYSi5C3kdinDyBvxMstYPSoxq2EWeBM22H41MdRkz2	5175	7291	7291	1617251580000
10001	3NLP7BhbvwCYfwfKZHz2bJBBbnrNEivym6fYrG1GZZwjhRhzYETd	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	564	564	131	6301	6499	jxPiaBf1rtkAku7BqNvJFPBQsA4qX4APAWvVnvNaE4mFS7MtLEp	5184	7292	7292	1617251760000
10013	3NLBFKgb5pqE4GxwyXuPmGR1cAAa7AgMN5NefgRNNKZ6Vdkus5gj	10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	1406	1393	132	6301	6510	jxoUStEneMfZnvS4GxGKcsc7qt97U8XkjZqqMvVk852qYnLiDem	5191	7302	7302	1617253560000
10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	10015	3NKtRPNomt3haQcDpKGCt3ox8zDk5WxZty2BJXBWeHyYo5KrvBC9	1406	1393	132	6301	6513	jwZkyeW96SCmV9veqCQUYgHcoqnNXa2wGbqb4bozKNFNrp7vUy4	5194	7307	7307	1617254460000
10023	3NLJbaupDLgfUd9zrsXeHfrmZJXW2jC4zmUvj4GJYa5edv8LhfPD	10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	1447	1345	132	6301	6520	jwxa1nw8xPXi6hJfQru2FxQPhMeo4i1iunRBHgQ5ww5ktgBhSmg	5197	7312	7312	1617255360000
10026	3NKbKmb7ZSCsGGGe8niTSHeiY8teyLpSEw3WqEd47Tuc8NjqWbUv	10025	3NL6mvhJHe1ft7Gx4rvY3nSuDNdU1iJ1kgXqyoM8MtEsrpooe9X5	1619	454	132	6301	6523	jxstwb7Sq8P4fdQjL81TyK17ebfnpExpQWnQdvZg7SfaZgpmqGj	5200	7315	7315	1617255900000
10029	3NKEVqxUimSRdx1yyjhgaZfvjTuNcueSqFAtAzQAfgMwp19SEgHB	10028	3NLTqnyMMWUo5G5dxPRSF1hotKGor1HqkLtCavUL1KBi7q2YB5RT	149	1283	132	6301	6526	jwKyN9wDpJJoiFUC4AheGDpbfvpQCKQwfSQLY4hEu23nDPyuhH8	5203	7320	7320	1617256800000
10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	10030	3NKWBfLerUX6HAomdJmeV4guUySnSisBP8jHL9i1sLuWvZXQsMoT	1508	1387	132	6301	6529	jxj3NJnVN3GPU9TwqvCycFFVf6NmTCgBPMxV9nP2NuuvvdPXBbN	5205	7323	7323	1617257340000
10037	3NKGBMgA4KLN8BmuB1ktcCAc7dPoM199uuwLk9gEGMLar9EF6YUK	10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	1654	1094	133	6301	6533	jx14wuN5Mb4c2GRv8y9qiMJxqfpGpqEUhpA6GgEYTst79v5NeYh	5207	7325	7325	1617257700000
10039	3NKzTZhVMaRv8NLCYSdjyom3GrxGVJTaxBgox468Rc6Nom2ktKAj	10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	1609	1087	133	6301	6534	jwUTZsSwvWoTnn6zMYAA83qBSwvbKtfn2NFtuYEAZsJeQxA12yx	5208	7328	7328	1617258240000
10042	3NK6rCPN1Z27Wq9hertVkvypWNKgNyDW5r5amqFLyCRWUqztAS1e	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1439	1279	133	6301	6537	jwijJzu4pvGQe3tvvaRSBX3MyGcmKfBDHio9wcViSrN5LVa3o52	5210	7330	7330	1617258600000
10044	3NLRz7NFHSpxhmsB7ACuS5LDxnWy6P8qvimhAbhDXXoyhZMkAsqQ	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1581	778	133	6301	6539	jxoBzPAGs6d2WpKUhtYDniTNvmAdGreyzR5Bwv8csH8gGrkFumb	5210	7330	7330	1617258600000
10046	3NLWWraawfMitAZvhJXAAkDkjmriTPmPesTqXqqV2Ja6pbQqKZs1	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1560	1045	133	6301	6541	jwDZG9b69CPAYG4dfKVP7dnazwkEYVmW5fjiCw47yNfwQDhnZBn	5211	7331	7331	1617258780000
10050	3NK8BTdkRz2S8e6oK5jNfF6DmvuC4jEykPZrpu4UiFjAPkHxZPd3	10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	1407	1395	133	6301	6545	jwxx1dX4XWA37XmAXzgp5XZ7hhQSZ248D1WGww3P3Ad9X3ojXS2	5212	7332	7332	1617258960000
10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	10054	3NKLwVuCoYvJzGzzPPrW6WWuGv42EvPutixtKDhvFdyxJ7YEV6ws	1405	873	133	6301	6550	jxNeEotJqZrJJmmcq4Z9DXVnaDtFcEGWX7ib5dcfRQPRDPiVRUS	5215	7336	7336	1617259680000
10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	1402	858	133	6301	6555	jwtM5Et8oKfsRxoeVsx6anufVXi56tC2SVGSEC7CRMk35ZHGFf4	5218	7341	7341	1617260580000
9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	1584	208	131	6301	6455	jwFsSooYfh6fm6fZV1xcKu6iz498bxf74WrZMANG1wcfFm9vCqE	5168	7268	7268	1617247440000
9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	1577	1327	131	6301	6457	jwnvL7vGkGQkTacCxWe443s2tAZqD7PntXPUyGPgKJeG2gxoSH1	5169	7270	7270	1617247800000
9964	3NKjKznE1QvrzFidvhbLQYv59LSwQ8MWGNZnkCrgvrXqqLS75Luw	9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	1637	816	131	6301	6464	jxjKsg5wH6A8pj7U5iC9NAc9L5Tg63VLtfieHjV1aTyBJ5ka98F	5167	7273	7273	1617248340000
9968	3NLLysH3sXhCzT3adv27SbLXZvCD97XTbxqsNHNgjaXDz2m1eFUj	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1590	1300	131	6301	6468	jxxRuxGdxT7wnQAHZrbNkamUQhPSzWFSinnft3Z15V6tF8S1uvT	5171	7274	7274	1617248520000
9971	3NLWSKgrtbWHS8ZLEra4cFU8fy6RRnZipPJLapH2an2SUEGU1i5e	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	1406	1393	131	6301	6471	jxCannmsVoLeYVx7dHFLWmSbMW3dGPjyK32Vsay2QBo2Emeq2W3	5172	7275	7275	1617248700000
9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	9973	3NKfRw4SyE9b4MB65F1UwnhuXT6j88dpWiutitrtzB5odtHLS2cf	1627	1139	131	6301	6477	jwJfTpaPiXESqoNgR5nqjNwYooJNdvpWa7x5HYHQj2CbfkytfB5	5174	7278	7278	1617249240000
9980	3NLtUL8mZgytyMjufm1sjBMpxQNUs4ZrUE7J2nyX9Cy1padhPGdd	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwBNaVeJqjxobYfDwVM4XrjaT29MjC3QK2h1cRSjS2PUqbxo6Jf	5176	7281	7281	1617249780000
9983	3NKFaWLJZW9pqHPs69CRS9fw9rFz8kNsUS5dNcFUyrtVCBaX376q	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwAeM47XsFHCX8i55HfJG8BihJmW3T2SsGfFPDm8yRwG8SgV8tZ	5176	7281	7281	1617249780000
9985	3NLaxehn224SzB8pWMFLXPoMF3cov15ZmkCj6oM3DzPru3DLDr87	9964	3NKjKznE1QvrzFidvhbLQYv59LSwQ8MWGNZnkCrgvrXqqLS75Luw	1637	815	131	6301	6483	jw7N6pVArX7weUiZzwApxFvsKAy8jy1Kv4Ufhh2dFuxPWN3kqRX	5168	7283	7283	1617250140000
9989	3NLSW94EjXQSFfDRhWRVZkxmJBEN8YibxtHMTWDm8geC4KADvUmY	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1581	778	131	6301	6487	jxxywcAH96osNMecXAJX6nPrsVU2Qto5gVwaK9jZYsHxxK3xzNc	5178	7285	7285	1617250500000
9997	3NKb5UZ2KM9TrcZR8w19HwnvG2mSk2shqaC4BJsHGKDhyJfxcJPk	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1617	1042	131	6301	6495	jxv7sBrLAkTV8pFmLJyS2nUNcYEeQo2YWafdpQA6TPyKV1Zzi5f	5183	7291	7291	1617251580000
9999	3NLSK7xnyGC9sTMnxrUrbkzvdhRNzwkhjjqC4dhi1ZJJhPDsfu3L	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	1649	1383	131	6301	6497	jwgZv9kxFx9x8P9LYKFqWMnbUnkd7V1CxSvFxLfcr6Jypx2Ujk8	5184	7292	7292	1617251760000
10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	596	1306	131	6301	6502	jx5TGHau85e37EW3woBxa7qGxFuYrsnhBnrsHaAFPCqzn8jVwGn	5186	7294	7294	1617252120000
10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	10008	3NLSNr7w6yHYqFcdcDexph1jfRNpuz1vY5gp186hFXV1XsVFhd8Q	1407	1395	132	6301	6506	jxSenFEq5mxWEcohRm63cGoBks4axrthDEEjx5gieZ6GZhCcv6m	5189	7299	7299	1617253020000
10014	3NLgkkMTDzrcW66a7YUD9twMcwWSDUPX6K6kXYDGqT5Hk3D277M1	10013	3NLBFKgb5pqE4GxwyXuPmGR1cAAa7AgMN5NefgRNNKZ6Vdkus5gj	1481	790	132	6301	6511	jy3KVi7JhJo99cjkdaTwSoz2Hp2oFjjHQkT2gL3ZSfL2RGo3Dyy	5192	7303	7303	1617253740000
10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	1599	1287	132	6301	6514	jwofwqTDn29FBgh1QM38QHb7cYy1wCyhksi8BMLyoVCqpjKApid	5195	7308	7308	1617254640000
10019	3NLrFnjhiDQ8n4GhW5y1UCqFy4ZvjbYoDK9K9xD99tJwYapSJYPR	9985	3NLaxehn224SzB8pWMFLXPoMF3cov15ZmkCj6oM3DzPru3DLDr87	1637	816	131	6301	6516	jwFjTnSNAnd6FpzqX67aCfoLht8yk5ZkoUzFVfxBKYXUa6RL1No	5169	7308	7308	1617254640000
10022	3NK9eR8H2MCwYkaDkKGwHiCriWqogNdrPGoSsia8tv5MdCxUX6Ww	10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	1407	1395	132	6301	6519	jw88yQ9tdN3fYCBZqMcPtBboWqhCsHJvqmxtW2pYGmXCYu9g3Q2	5197	7312	7312	1617255360000
10027	3NLAJb7wHPHKL55FQzYEdS8ycwooL9FEYFUZicHsCvmkizVGo7Gb	10026	3NKbKmb7ZSCsGGGe8niTSHeiY8teyLpSEw3WqEd47Tuc8NjqWbUv	1407	1395	132	6301	6524	jxMAALq62tsbd39MNw56qT36xVpxHChZ6WB9uRiDmAARXeiNCYu	5201	7316	7316	1617256080000
10031	3NKWR7bDArZ413rjsCu9u1wWDnNdeZEGdNkfimJyt5fKs51pBPGo	9969	3NLq7em2KBpik5sLp2pLqCxrJec9btkNRtxB6Jz5MfCbYMHSrGhD	1508	1387	127	6301	6528	jxdCoRncgUcYQEsTB7az1VsUEwy7J5QAAvMSWy4r4hbUHod4fpP	5080	7323	7323	1617257340000
10033	3NL4nM5PtYHWVujuEkc4fDAYpzNzq9bPvKHMM7jSnK1Nmss6uA8w	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1675	1216	132	6301	6530	jwYdCRYsH89H2Tw3WPxPcgoKBu9mzqeSUffuoN5fmdqpW57umAT	5206	7324	7324	1617257520000
10038	3NLNPHyFQjEwD1RfrnkXqczRwyw1o1ZwRFDPQ2oiqNowTjXc1C26	10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	1609	1087	133	6301	6534	jwHFQN5EoGp6cLiza8UWqw6sLXJLTysjR1S6cvTdaUnmmyHo2Bd	5208	7328	7328	1617258240000
10045	3NLT6eKE2wU2WEJZFjR9qdkhJZ8dWmkvYpPFnnYbsaqKN6LwFgEs	9824	3NKriBpYYwWMmTRqYo8ojBmy46h9y1Q7Y7BBV7k3D28ygpkUrdQY	1439	1279	125	6301	6540	jwsBzTJxTyK7fmTJs8vNwuACVL31qbzvRQ6xcpX1xy6hC33GLvx	5015	7330	7330	1617258600000
10051	3NKbFXpvvWi2i2aY51t4PjtJ4Y3GXVtA3qrc7W9rPgYFj6vHTKdt	10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	1631	794	133	6301	6546	jxNiRLekZFUimnqtUMNW1CPsDibVATscG1waRT5r2vkbYWY4hrd	5212	7332	7332	1617258960000
10054	3NKLwVuCoYvJzGzzPPrW6WWuGv42EvPutixtKDhvFdyxJ7YEV6ws	10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	1461	1271	133	6301	6549	jxCTmZjLfn3f3ADRUPRT6HH6KUjfemt4kYget9p14nHQjzGyBAm	5214	7334	7334	1617259320000
10064	3NKP4hS3t9jqVQjKTwzKEQ9H82421mxjsqeT381q8rc9UvGMYegp	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	1631	794	133	6301	6558	jxQDD21kHbMpjp3vFxJELimGeqN1HRaYPxwZPFMQ92PViXcDDnu	5219	7342	7342	1617260760000
10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	1405	873	133	6301	6560	jwrrgQoNUSTYgmxLQg44Cv9GuPAwXYa2BpzJ9BiEFR2zVhUzCof	5220	7343	7343	1617260940000
10068	3NLWUcXA9jz6GLgMV3sgqkCpZptDcdd4mjLwMKMr7xKFf8tmQo5y	10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	1593	1220	133	6301	6562	jwPpipbW5hgWuBMDQGPZ7vCqohGGHmVDPf4vPFWvMP15u5X2guy	5221	7344	7344	1617261120000
10071	3NKDUd5ZkJBDDnsnP8vCa8kTWjpJQaEetYJDTpPLergd5swQR1vk	10069	3NKuJe2GCPMKsDdu21ToTFzynCXGEjKUEDBUJNKHtTfYMh91ecn4	1657	1218	133	6301	6565	jxqRwLqV8CkS7ZPfWFkhJY54Cd9Gtrjr1CxRNax4DdJzGQijEsz	5222	7348	7348	1617261840000
10080	3NKmGtuBGCWvF6LoVKGp3mDaAYaHswGw8KZPhcukxnZ1pVEqWRkn	10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	1581	778	134	6301	6574	jwNzAaaiggKG2ULF7KB8cAi3b5fRx3XuRzfDrDuUeaVKtPKE27h	5228	7358	7358	1617263640000
10082	3NKugM9z4kjex3P18rFvCKoMoqvTSXt3RMYVHLtFYqV5iWvFGg7z	10081	3NLpudzktDM2aQjiXQongx9dPujrUHB5hcopc7H1KKgXVSJLdtHc	1407	1395	134	6301	6576	jy38qHryRxyFUMDj3Abefe76owasTzsVw5KRbVqC4kWVA8dSM9Q	5230	7360	7360	1617264000000
10088	3NL7TMc2w6fSk1dpVjhn2kKK3fVQYz4D3NDEyYUWUEKaDTtaTVbF	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1581	778	134	6301	6582	jw6e5VLjJ5auWvdYof6w1JmFX5Gtcw2nvZE3o2jBFACfk7wgiLn	5233	7366	7366	1617265080000
9960	3NLh8rC7s6VZu46yAnqe3Df6sh18yGtVqLB7k8ruwVzQaL5YbB3t	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	1407	1395	122	6301	6460	jxiy3U7upZL3mJQyVjkCA8gYkRVL8Bp6MDr8GvG4UGKpuu7sbUP	4986	7271	7271	1617248084367
9962	3NKMUg5Z6k9LiPq9qwCpFzkM3dyJdy5eLbqXq5p1WJcwdjStAEbD	9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	1407	1395	123	6301	6462	jxaFCUjUusAt3TM5t16XSRKXUfp3Ecia3sThn7iJS5HrignSYVo	4994	7271	7271	1617248116647
9969	3NLq7em2KBpik5sLp2pLqCxrJec9btkNRtxB6Jz5MfCbYMHSrGhD	9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	1508	1141	127	6301	6469	jxyzq76dC9TRLTFwqGbgz7T4MD1PRQAoPKfPHZWrNjQR9QJ3bj3	5079	7275	7275	1617248700000
9973	3NKfRw4SyE9b4MB65F1UwnhuXT6j88dpWiutitrtzB5odtHLS2cf	9972	3NLaPbJ8b6mKeN9DeeU4XSNEAAnwh6JT2xHGK372i16YiiR95sCY	1672	1285	131	6301	6473	jxXScRNHmLmfiQwM4fHjkHAkgpyvqQ7tbb3h4x8b7sJhgVrzNdY	5173	7276	7276	1617248880000
9976	3NLwS5bys16wf4Z1srkrsisGWUXSbbsVDs6vqL2E8d5VhqEWAAJr	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1407	1395	131	6301	6476	jwXPDhXpHWRRUk8HfYw1oRxVWaJrg1GD6DuthDCELuBf74LS8QJ	5171	7276	7276	1617248960685
9978	3NLu6HBuE91xgTug2ZgJGb5GDQbZcD9EiJ7kDn4k5fDHMXmCnVkQ	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1589	920	131	6301	6478	jxF3yKgUvbcRi3CcU4DLGVYDFxBsEJdwT9cEewnK9wsogxpykMv	5175	7279	7279	1617249420000
9981	3NKwVeANK9XHUm4Lkr72RQcbPqhDh6Eky2WWEYh3LjSJgoU7vNep	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1407	1395	131	6301	6481	jwsjuJFNrcNB6eEp324z3ejfz6a7qyFfJNVbKtyecfnmY7R3Hum	5176	7281	7281	1617249780000
9992	3NKxTX88ztW4w4W1TvX7bG5CCnVbZd5nxJ7n9ePdy1iK1VfSWd5s	9991	3NK5enD2F1SGpDWBNnZh4Ggy8Zz7EtUUPVTc85Q24HtiBsdGGdx5	1445	1044	131	6301	6490	jx2yJbJWUvXoCzJvgCTwxnZhDkroGQEnj7YhQou69fyArQX9s9a	5181	7288	7288	1617251040000
9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1490	1028	131	6301	6493	jxHScLu5CxeL3uVX4nZwgtkv5cx9bpANGTFt6Ai8UQd8fyhXPtV	5183	7291	7291	1617251580000
10000	3NK7eyyaoxycWJ7CR8e9d2Jsjq8SQ4FGPTuCzkbuhXbHXZLmDYE7	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	55	59	131	6301	6498	jxtyZnQizpAmJe7cXXkNvQabsx6XuM52oP2ZXZJsy34GH6ifSmo	5184	7292	7292	1617251760000
10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	10001	3NLP7BhbvwCYfwfKZHz2bJBBbnrNEivym6fYrG1GZZwjhRhzYETd	1406	1393	131	6301	6500	jwxJ43ncefifCLCwbVJ3aVdoBd6Wh9PMcVch1JuUX7PqbNizXE5	5185	7293	7293	1617251940000
10005	3NLkXcwuPQycZSTNqr6FbXVPdessWdUWe24ycTG6NvB6sd7PqAhq	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1656	1097	131	6301	6503	jwmeDYhTF89u86hKofz9rWtVs8odWe8UDQD4rkutWesQc67qCGm	5187	7297	7297	1617252660000
10007	3NKrW5rsrH24pQLnBXryL1VrgYwNCBBWBkRP5X8RuWYbpkSntwRf	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1656	1097	131	6301	6503	jwwYUqKgBEg3xF2EnszVsMUq2EtvAwVGud39rsK39jVfw676vfV	5187	7297	7297	1617252660000
10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	1422	1211	132	6301	6507	jxGhSUyPHYpxDH2J9xym92XUWtkCdmsfGMdVYmLhttV1tbWoirv	5190	7301	7301	1617253380000
10012	3NLnk1T7FxKoMRBRmR3qE2N6oqK2UHNrGhsjBW8uCFX538sKCvMq	10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	298	1308	132	6301	6509	jwCPmgoDV5X2LdiajKzgeZjhthueLBjTxRacrYoj9DkMTTRkErk	5191	7302	7302	1617253560000
10015	3NKtRPNomt3haQcDpKGCt3ox8zDk5WxZty2BJXBWeHyYo5KrvBC9	10014	3NLgkkMTDzrcW66a7YUD9twMcwWSDUPX6K6kXYDGqT5Hk3D277M1	1403	824	132	6301	6512	jwdJjsjrEUAWVbn5eVgTZC8kXWGFCcs4ZertYhPF65joV8KbJEk	5193	7305	7305	1617254100000
10018	3NKYpqKDfmeBC28tgDG4YkkLv8yVKpUHkSR2tPoXXm1sZ6TpQUcV	10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	1506	1127	132	6301	6515	jx3H9FcKQNoeEPjvSRBroVtebSMmr8aApksP1ApyqzsiUXMaWsP	5195	7308	7308	1617254640000
10020	3NKWf1UpFcBp8VoFPdVKbEWGYH8p4NSJV313UA7DEb8dg4khcxmG	10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	1627	1139	132	6301	6517	jxW8GtSyihcCn73yhFNKspFpJBsQmFwUKNyNdnfKfDitG7uN9uZ	5196	7309	7309	1617254820000
10025	3NL6mvhJHe1ft7Gx4rvY3nSuDNdU1iJ1kgXqyoM8MtEsrpooe9X5	10024	3NKRyfQFLrLi7xr7ZtijkUG2dxeaf1GP7szLipyUXDBGoM2u3BKd	1649	1257	132	6301	6522	jwNA5NmECaiMQmqYxq5EZE3nQ7rtaVC2aXYj1t9t9ce13NCSRUM	5199	7314	7314	1617255720000
10028	3NLTqnyMMWUo5G5dxPRSF1hotKGor1HqkLtCavUL1KBi7q2YB5RT	10027	3NLAJb7wHPHKL55FQzYEdS8ycwooL9FEYFUZicHsCvmkizVGo7Gb	1407	1395	132	6301	6525	jwAPu1VaQkFSj698qxGmetr2oXUkjb5VcYQUAQB4JVGLo4u1357	5202	7318	7318	1617256440000
10034	3NKQNLKfgZBZA6aes85nFz4GyMvTyFTn6CNjaXWxSE6WkWxcZRBj	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1675	1216	132	6301	6530	jwYdCRYsH89H2Tw3WPxPcgoKBu9mzqeSUffuoN5fmdqpW57umAT	5206	7324	7324	1617257520000
10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1600	1126	132	6301	6531	jxbG5Pqy4vGdXXzXGVTQa3QfnbDpyScAwmCEaFyCpHQeYx7zfFX	5206	7324	7324	1617257520000
10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	1407	1395	133	6301	6532	jw7zyF5H6pdbTjJgLjYRSgDBdq6cYZfbuxx8MiEmkVP9S14jRjL	5207	7325	7325	1617257700000
10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	311	1307	133	6301	6536	jxUvNv5AieWaAVaXqv33kpE7VwEXxsG2Dkf6CbTcYis57TbM5W8	5210	7330	7330	1617258600000
10048	3NL5az9SgXKpjMkB9vtzdLz2dyiqYnTrcanYe3yhkoDFoYvNWDAU	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1553	776	133	6301	6543	jxU1Xuxq6oBU762FuAxjMh1Ba3berp29i27zCUgEwMquPF5bvzA	5211	7331	7331	1617258780000
10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	10050	3NK8BTdkRz2S8e6oK5jNfF6DmvuC4jEykPZrpu4UiFjAPkHxZPd3	1407	1395	133	6301	6547	jy1vx1ibQyq5RNmzZ7TBaK5JMjEGDpSP1GYTNWbncWhuUyCNCcG	5213	7333	7333	1617259140000
10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	1406	1393	133	6301	6552	jwZTY3zq5FhkKbNAAUK6nLtrPpSbqDBaobDPYiMdzaxGzbkSxUq	5216	7337	7337	1617259860000
10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	1668	1370	133	6301	6553	jxWy39pRvLiD6qG9SmgqakdU5bvfHjoQP8J82qG5LwH1zSNRdgJ	5217	7338	7338	1617260040000
10060	3NLKGfx7zovx7wRZRNwHbhzwdmFTKAXwbD2Jc7AqXTqjPVpR9H96	10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	1599	1041	133	6301	6554	jxRnrKzi5T8PC4owCeiS3UKRKgoUx3S9wBQNq7wdr2LSirmSQ3x	5218	7341	7341	1617260580000
10062	3NLRh2QDK5fJTtiHeh128imcL7UgnL6w1GoUA9xSPjxv9XhseCW7	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	641	1090	126	6301	6556	jwcsv98pNHF4vdS1m9Z99WtstDjMYttssuUxrTehv15MXakkTAA	5056	7342	7342	1617260760000
10072	3NLNrb1KQgv92dj2sG6dNVkYNdgLNMkuvHRPD83jz3T9Rg87bNHR	10071	3NKDUd5ZkJBDDnsnP8vCa8kTWjpJQaEetYJDTpPLergd5swQR1vk	1406	1393	133	6301	6566	jwWv9TbvhoH3sarZAJkgnDBoA7VapZYxRcJ1iKRxJqT1pV6dJm3	5223	7349	7349	1617262020000
10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	10072	3NLNrb1KQgv92dj2sG6dNVkYNdgLNMkuvHRPD83jz3T9Rg87bNHR	1398	435	133	6301	6567	jwWpzYEfbJemtVV7zdVkxDfmrsgPfRL4ZjdAc149JGGC8GnxkDg	5224	7353	7353	1617262740000
9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1541	1172	131	6301	6479	jx3vXdu7racrxcejaEeaVsMDYX7i7ZNryvKnHz5yAfuFHC9Kiiw	5175	7279	7279	1617249420000
9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	9982	3NL62XypAJyhU1mok3JH3rJFi1x5eB2sJCiDrDnYTCtvmuSRHRwD	1601	1388	131	6301	6482	jxALQx1ebr8y3pdpo834NdqypjiS6vuQyTpHPfrMQQy3iXDDLXJ	5177	7283	7283	1617250140000
9987	3NLy7iusvjFeFq4KDkQR7DnNQUVyMEfMMvzrUBGPD8hLHDhrzsDU	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1483	504	131	6301	6485	jxW2FpNZ1aDk1YHDjYwcGeJKXXdYv5xSeRAwgMsP8c3mvm8dGya	5178	7285	7285	1617250500000
9991	3NK5enD2F1SGpDWBNnZh4Ggy8Zz7EtUUPVTc85Q24HtiBsdGGdx5	9990	3NKCfrDW46LNnag9DneuQvgJDJif9bU4iWutwBPfcSXbUrW5aAuJ	1471	1020	131	6301	6489	jwJ7HWuzGEVB4woiLQmaCpPGbZr9jBaSARHUdhybagSu5BG2gjz	5180	7287	7287	1617250860000
9994	3NKiUTV2aJdUCuB3cSZ1dn1fqk3SkpsXh3XpjuKLNSTupMZmbctu	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1549	996	131	6301	6492	jxiPWfizKGdB6QzEdh9xiEcHUJ8qFV2hCreZkFs3aXeBVW88gKZ	5183	7291	7291	1617251580000
9998	3NL2f54NN5uZn34RwwgYJxnu5kbqSGRmQKLdr9yfhHpWnefdS3H8	9696	3NKuMSXeYsMMc2QDvwpKuY2ZvWrDiMFdhbxgZma8Byxu7xFt1PkK	1643	1299	124	6301	6496	jwX3Vs2wmni79fEzpG4op84oCVAVUrX3EojfJ3cso2uryK6ZyJP	5027	7291	7291	1617251580000
10003	3NKrcaLq5nBS9iZDbHrqsyKSSJ9RauEhXkSkUaUhV8yxiJGR12k4	10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	1402	884	131	6301	6501	jxWQXb5ZVEptRmNixEWSx6htRYbEHUZ11wGnPFamoTUaLReD8wm	5186	7294	7294	1617252120000
10006	3NLQn9E5hjaDEbQzXfxcCj1Zdq2JPzf7hxHZhxYfCPsLw7vqwuZ3	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1611	1095	131	6301	6504	jwusWRYdzgPUb4ujxW5nnXX6BL73wFwbWtBZfYeMbYT1CHKXiLc	5187	7297	7297	1617252660000
10008	3NLSNr7w6yHYqFcdcDexph1jfRNpuz1vY5gp186hFXV1XsVFhd8Q	10007	3NKrW5rsrH24pQLnBXryL1VrgYwNCBBWBkRP5X8RuWYbpkSntwRf	1547	1378	132	6301	6505	jxbyCRhKth9VKQbCAiYRFdhg1Dr9medWgytdUBpzbAEXrXzCVqc	5188	7298	7298	1617252840000
10011	3NKLN4jRG7QPWK84yFLAiTR5NZJ3nwpC6K71A2T9uQdaWomApiHx	10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	1406	1393	132	6301	6508	jxQiJ5UUQhu4WiP2K5s9ShPomygbePCkX43QVGUdoZumXr3pLkH	5190	7301	7301	1617253380000
10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	1631	794	132	6301	6518	jxFGQNUpDnBAkSuXXa9jUdgQoovg48Hvz9teqRL89fg3m3YMMnn	5196	7309	7309	1617254820000
10024	3NKRyfQFLrLi7xr7ZtijkUG2dxeaf1GP7szLipyUXDBGoM2u3BKd	10023	3NLJbaupDLgfUd9zrsXeHfrmZJXW2jC4zmUvj4GJYa5edv8LhfPD	1407	1395	132	6301	6521	jxymzq1kmUa8RAbbw8b6ck19VK1qAHWPeBmULkFMWCP7idQuQMg	5198	7313	7313	1617255540000
10030	3NKWBfLerUX6HAomdJmeV4guUySnSisBP8jHL9i1sLuWvZXQsMoT	10029	3NKEVqxUimSRdx1yyjhgaZfvjTuNcueSqFAtAzQAfgMwp19SEgHB	1607	1348	132	6301	6527	jwK8bnrK2XHquHCN37Qw8mLbbwpzgijxyu3ZZrTG3G9hQZPpw1r	5204	7321	7321	1617256980000
10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	10039	3NKzTZhVMaRv8NLCYSdjyom3GrxGVJTaxBgox468Rc6Nom2ktKAj	1407	1395	133	6301	6535	jxLRH65yPcFPg1xd4C3AuzJm7e5pLaQ4TDiPJhyqwNgHcDUu8cs	5209	7329	7329	1617258420000
10043	3NKc2GQtpKJsJLzcMTadt4UdXSSiS4dMAiPBispiL9At3P8dAhqi	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1406	1393	133	6301	6538	jwwK5HxaFdy5x8MoaHWrzwpSogzCzh21oe4RBBXAHS9uG3bHVY4	5210	7330	7330	1617258600000
10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1407	1395	133	6301	6542	jxCwLKm3frarysxZtHf2H5NqyS1TWPMdsjDdu4NvCSZXjEmiCdK	5211	7331	7331	1617258780000
10049	3NKWfmsc4TBo9gbdEbend19pN7QeEwjvFv6uYsm2tbGJ8LL9Qpxu	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1406	1393	133	6301	6544	jw8ZT6xxyAn2b3hff4LsLVkHgxRE6nrXivoYHvdayW4ueSTw8Lh	5211	7331	7331	1617258780000
10053	3NKEvYqaagXER4qsqdQb3kpdM5EzntZ5CQBNKTGSSPFkmUgzxeQS	10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	1440	1131	133	6301	6548	jxYGyVYQ9G1YbSg7ZeJzgpcDKkfLHrbVr9Fcij8qo9BWAtkE2hT	5214	7334	7334	1617259320000
10056	3NLV7CxCbkhdoKmJU4WDQyqTBfBaPDCYt4HGCHf26jwqGMud9oaT	10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	1403	823	133	6301	6551	jx4JByqXfSeqvABPwfF6MF5fQCHEFNhp3myXrC91gXMXHFRjM7C	5216	7337	7337	1617259860000
10058	3NKzxUtUJpnT79qvZbJVzVzhr9iV2cQJrJD4Jtwvm9MuhwW98ZmR	10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	1668	1370	133	6301	6553	jwHa2ZiaqiiD4twEUc5rsbeKLPiN6aex8myYfV7MgoT2Sn9rheM	5217	7338	7338	1617260040000
10070	3NLFPAem3kDMyiDFXaeNHhCep8fvr6ooh2Hw8JovA3S51Bqyfiip	10019	3NLrFnjhiDQ8n4GhW5y1UCqFy4ZvjbYoDK9K9xD99tJwYapSJYPR	1637	816	131	6301	6564	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5170	7345	7345	1617261300000
10074	3NLpJ4Foox1kpraAZ8KdM4K4neNb1AqAvBPrcn1qfGp3Vrz7e18j	10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	1407	1395	133	6301	6568	jwqrDkXtPBx6bWPoMx8UonjuHYgkRcSzzFAhdDTKGnWX3kvfidX	5225	7354	7354	1617262920000
10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	1555	981	134	6301	6571	jwvDBPDpViQNcyZKfnDcTwP8X1TZS1JSaQCrAUwFgzHQkduydXi	5227	7356	7356	1617263280000
10079	3NLXfCbJLsqfqXc8tceFp6i9vCrCpkYSiEz3ZNdRwK9PV38Sxgsf	10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	1673	1242	134	6301	6573	jy1mwYzonQyczkRZVZiiyeC3n4hM3kSZDxFNQeUxNorLuoUyP5m	5228	7358	7358	1617263640000
10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	1405	851	134	6301	6579	jxPLn3vXsjbRtqdRyBJAgkrznfrUq2defUKbYXAXwrsGLMXbqs9	5232	7364	7364	1617264720000
10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000
10097	3NKNmQh3xucq7LAMfiuXiuFipt3tvo2Hngw9GkitzFwddcdrtDbQ	10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	1594	960	135	6301	6587	jwjWbz1aHFFCW6HHK7bUP1XqfESmgep829iJskr3bko46i6eJn8	5237	7371	7371	1617265980000
10100	3NK8ptYjyZkcvdBT7GfWnpBnh9SNqLT9jrhVzmtCTtJzXerBzarm	10070	3NLFPAem3kDMyiDFXaeNHhCep8fvr6ooh2Hw8JovA3S51Bqyfiip	1637	816	131	6301	6590	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5171	7377	7377	1617267060000
10102	3NKTbP1n21KZtji1AL2a1zE8iHqNWzyERYFnwaYNjST4EVimSsaU	10101	3NKvSpqHwT5EfhjdQSBLfwZ9eBEUPKvzbZZTnn6eyRU5B2CnbrMt	1406	1393	135	6301	6592	jy2MZdJhcQoB6E7aLQHzoFPYJTxmrAcPkjPUeuW4szYZHUSqiRp	5241	7378	7378	1617267240000
10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1652	949	135	6301	6595	jxs46NLWEVVXpX2c1FppSac7muZaTuXTEUdoxVA2UM8RM2A6xBd	5243	7381	7381	1617267780000
10107	3NL7NynbchtBjY55LjxKmP8CzaHKazjb9zLT3xCdPUWqxnm32DZd	10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	1407	1395	135	6301	6597	jx7ca8zWCeaTz8oEqzjLwHzYFyir7W1x2P2EVhGFJv87XnC48AM	5244	7382	7382	1617267960000
10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	10116	3NK9i1CD9abxSJqNa5bsQqHnQdsaeTzGd88P9ebEn2r9DnkYbnmC	1660	215	135	6301	6607	jxkAxsM4hoRfxhKzYtvDYKJG2zCfivRrEdK8J2ZarvnKf559zPT	5249	7389	7389	1617269220000
10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	641	1090	133	6301	6557	jwXNTmBpFuf2hwTrSCrJ9kseTfk1B7WNGH8UfYfpaPNh9xTcwSR	5219	7342	7342	1617260760000
10065	3NKAeX6ezwASRto5YwojPLDKNX9DMVrtNQvN4UHisaaknWtFFV9E	10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	1471	1260	133	6301	6559	jxpuLWjJasRocU8c8RmdPeUmam16duWsvSq4s1VnbJmK5fGTEJq	5220	7343	7343	1617260940000
10067	3NKfJhd6gGrcqzkAjUVpZx1j6GncUKVdXPdPdir2Gy9fPXpKKWy1	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	1593	1220	133	6301	6561	jwbMqqMrwXbfYoUv4u4S2qdnhfpEQ4snMu2mdytawdT7KVvLKfN	5219	7344	7344	1617261120000
10069	3NKuJe2GCPMKsDdu21ToTFzynCXGEjKUEDBUJNKHtTfYMh91ecn4	10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	1406	1393	133	6301	6563	jwmZ8M52fzFX62rZGFrwujgyQf4Fcj5sij5r49c3CHTYSTUscD8	5221	7344	7344	1617261120000
10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	10074	3NLpJ4Foox1kpraAZ8KdM4K4neNb1AqAvBPrcn1qfGp3Vrz7e18j	1406	1393	134	6301	6570	jxwBCxPCrR7fUPfxMs5cwUzeXUvt8zKeLFVQKrSzLWLezuU2T9Y	5226	7355	7355	1617263100000
10081	3NLpudzktDM2aQjiXQongx9dPujrUHB5hcopc7H1KKgXVSJLdtHc	10079	3NLXfCbJLsqfqXc8tceFp6i9vCrCpkYSiEz3ZNdRwK9PV38Sxgsf	1422	1337	134	6301	6575	jxGQ8hERpNcEtm2jC5Cwb5f2ECiXJppi8QGAjHhMzMb5nqY3fR4	5229	7359	7359	1617263820000
10084	3NKkxzBuGsTfJ2v1oo7EsMEpo14JNzhFd35MEevaixW1isoFD7uu	10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	1426	1238	134	6301	6578	jy2sUzikHZLW9bW4qdhsqLo23952NeEVffaXpWi6TUTqikMiYPp	5232	7364	7364	1617264720000
10087	3NKQZGA2WdoHuYqbGbtZVbKRFSZ2SvUhvtE7nVJmZwp5H1wc9U9S	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1407	1395	134	6301	6581	jwo8GNc4DRFW9rhswsw42QdhomvCbDCL4J89tzFfsR6cHzD8v8g	5233	7366	7366	1617265080000
10089	3NLJLnVLTmV33UKVrhjqVciYkcc4tBy7z3wBNwG4w97fsv2CxEfS	10088	3NL7TMc2w6fSk1dpVjhn2kKK3fVQYz4D3NDEyYUWUEKaDTtaTVbF	1444	1381	134	6301	6583	jxWWSZoSF7t3rPQzU5ehyoXkDj8i5ZHeRGrvuDUSLrTHqFNq4Pm	5234	7367	7367	1617265260000
10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	10089	3NLJLnVLTmV33UKVrhjqVciYkcc4tBy7z3wBNwG4w97fsv2CxEfS	1518	833	134	6301	6585	jx5x23VcXkMkH4Zk2m3VD6qjykRBPCV1es4XaSafos8utryL15S	5235	7368	7368	1617265440000
10094	3NLA6bhZTpDjcWqQZDQi8pPffkj2i76Bhz24eUMM7GgZJShMnwrw	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtuc1rSneadUAQhNwzSA9KYzdYtYQJdgTMKpQfXXnLxrumJBmr	5236	7370	7370	1617265800000
10095	3NKijV3Xmetv2Re2a32xL36HdkWsYrGMBKWQ98onfw2W5D8YJYMh	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000
10096	3NKUCSy6puR8YJ4KspBLktxDxpj8grhWd6fZNB1q9cPoTjnghY8n	10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	1594	960	134	6301	6587	jxdyWeTpvm4tBs8Rd5bCv5dpuKRiiznURPnKwSYJqRdcYoYSckC	5237	7371	7371	1617265980000
10098	3NK8BKT6K1GTgLW6tpx76HMaBJQTuCcF8rajKy4XQvg6crCeEHJr	10096	3NKUCSy6puR8YJ4KspBLktxDxpj8grhWd6fZNB1q9cPoTjnghY8n	1553	776	135	6301	6588	jw6jEAMKxVFy4FWxFBG33W7uhAtjoh6QboUbMaNRTFgZTKmoZzM	5238	7372	7372	1617266160000
10099	3NLR47q1ZZTZ6iuXEDzHjLTTS4c68j9pENnXkj1JBGGoC45y9p5n	10098	3NK8BKT6K1GTgLW6tpx76HMaBJQTuCcF8rajKy4XQvg6crCeEHJr	1622	1110	135	6301	6589	jxjqkk9vJEoxvYknJkNYLDnsiqbGeLyMk2pBGy2BsaBsX45YtEJ	5239	7376	7376	1617266880000
10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	1406	1393	135	6301	6599	jxHG9vjUa4XRpmgVaPFiANntjpbn5P3EDV3GopfehiiF4X9zdsv	5244	7382	7382	1617267960000
10112	3NKnm3CCxzUn4eSoVet4wBGaYqdJnYnm41ZRFwVDFkQYNXrR94hv	10038	3NLNPHyFQjEwD1RfrnkXqczRwyw1o1ZwRFDPQ2oiqNowTjXc1C26	1646	1354	133	6301	6602	jwpizkyhfcuNRpAT7eYbRyZUPvrDzoeoY3Hb5ZXYtAUj9NupNbA	5209	7384	7384	1617268320000
10114	3NLVdXLS5MtrrUfXdyf4TrwMjBH8Ugm13R5624LJFJaU4CRX9ca1	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1406	1393	135	6301	6604	jwVvasWg84BRUriscGFPcLPirCDmSfXthZiMLZGBJikMcuyLRVN	5246	7386	7386	1617268680000
10116	3NK9i1CD9abxSJqNa5bsQqHnQdsaeTzGd88P9ebEn2r9DnkYbnmC	10115	3NLJnw4RnUhw9MVQPpbp5wB2wWtekfJcA62a4XtZeJqdGnadaZWB	1403	824	135	6301	6606	jwoaw2CFCGAZYrxvQH49f8Hrp69qvS1iw4WZXGtWSejhwoj5N9p	5248	7388	7388	1617269040000
10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	1406	1393	135	6301	6612	jxKFdvARqmxKek3K2FgUDk2nKj7obRU8NTWq2dsLUsvbfdt4TzJ	5251	7394	7394	1617270120000
10125	3NKaED8K1Ucie2Zr3TqLiouanU3VrWoXisLzx7nnYTcrj6e5ECG6	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1646	988	135	6301	6615	jxQsB4dYscyuSi5cDZVdwWYsHC3ctbnpXX9bCSopZnb2PUsJNvy	5252	7395	7395	1617270300000
10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jwMhVVtf7pbqa9cPjFoy6Fz1ZpyK1bDPYPXCZn7oQ3GZGe5Pxhr	5255	7398	7398	1617270840000
10138	3NKLUz1v6jqP7Gdfmyi4ezft6PeDg7giXcZZRukyb2HxtnC8iP49	10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	1581	778	136	6301	6624	jxg118h8Nxs9JRJUYVyTxHiFknKj3XfFKtocz522zLHGefU3xQj	5256	7400	7400	1617271200000
10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	10136	3NLvvkc7fvkwMNWn6tWzczgGNjsATauRhcrmMcUPqDwfrwLK7i5M	1553	776	136	6301	6628	jx6VhS1gYwZw9YTXvHhEUbYdTDjHTCaWKSVTMgoAmxYrL1Unnaa	5258	7402	7402	1617271560000
10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	1447	1219	136	6301	6629	jwPtppwW391nyJJBGPHYgxSnjnb6hbckiAgZwWwp84irMjui11m	5259	7405	7405	1617272100000
10148	3NL8ckJ26VUxdvwMPozkPakJJLHYF4KdKG1VYwGjwnkGF3S4A9Mu	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1501	1360	136	6301	6634	jxFCCQjyZECKuCy2kkHpqCfNcRBofwwvr7aeFU2oxRpidnvqmuU	5261	7407	7407	1617272460000
10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	1447	1345	136	6301	6639	jxsfwoA791dXJXeT99BHCPFVLnBVRtstgYBJLadHLkZWe5TeAek	5263	7409	7409	1617272820000
10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1402	874	136	6301	6644	jwWzGq5PZ9NHbH3nvaZejESMG1X9353qx7kVcvionGehi7LTUYY	5265	7412	7412	1617273360000
10163	3NLRu5cRfmMcC11nxCE267EaqzGXjKbZrbVyKLjr8eF3rsJoNFd6	10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	1402	882	136	6301	6647	jwAXy4usHeCC3FLW4RHMr5S3MtDjRdjUt1jBnCsTCdVui4ApVra	5267	7414	7414	1617273720000
10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1397	828	136	6301	6652	jxFLRuN96mc7umTaWzVfVpYXRMMmsYfty9gzydDgq5L9UnwQR7c	5269	7416	7416	1617274080000
10173	3NKsP1kCBDXCiWTAtMm2gMvgMUqyMtzbtPpkQwnzHdmrsfxdodqm	10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	1553	776	136	6301	6656	jxBRoonQam9VW5FxhukoLqb8i4You95iHZr52pPj1L5y8qzoSFh	5271	7418	7418	1617274440000
10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	10173	3NKsP1kCBDXCiWTAtMm2gMvgMUqyMtzbtPpkQwnzHdmrsfxdodqm	1403	824	136	6301	6657	jwc5mHFzKurwoaNfhLBUnxtyXGaNZog3z2jsiDmTBfa337JTSWh	5272	7419	7419	1617274620000
10075	3NLxccBruesS9VZPraLPgbezVj7JC6NHhQZrWK2zJuQifvx7NUEk	10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	1406	1393	134	6301	6569	jwNdDrd6RQYtMGevGDhNuZ7nvEXyyAn7txjhhzMAoea14cWWX6s	5225	7354	7354	1617262920000
10078	3NKADjnduzqJQ8ydrLLjDu8KLADEXxKdbXVjDLiCR7iNLntqsdoi	10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	1406	1393	134	6301	6572	jxSjP9uc97XiR5hgkar1yKZpG6c5d5qujZC35gYCuhKSt9Y1Hhy	5227	7357	7357	1617263460000
10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	10082	3NKugM9z4kjex3P18rFvCKoMoqvTSXt3RMYVHLtFYqV5iWvFGg7z	1407	1395	134	6301	6577	jxZfvvwTZv11myFW8PwfpsdB1eQdtccvpy1Z5qa8vhWS68NJ5pG	5231	7361	7361	1617264180000
10086	3NLk2UFCvDxWcdVtF7Pn2jUhSUcrm9xgZWej5xkbR2CMpy4RPvgs	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1448	1311	134	6301	6580	jwJTBUioerzzogtk8rmgJdZ2U1FYeHXqip9JL4H5s8TdKeHnQ8Z	5233	7366	7366	1617265080000
10101	3NKvSpqHwT5EfhjdQSBLfwZ9eBEUPKvzbZZTnn6eyRU5B2CnbrMt	10099	3NLR47q1ZZTZ6iuXEDzHjLTTS4c68j9pENnXkj1JBGGoC45y9p5n	1601	1388	135	6301	6591	jx1rAgx4sAtGcyWZCY3Xgyc9W4timDnPBDvzAvvx38LPNorQmUb	5240	7377	7377	1617267060000
10104	3NKqNyCE3vV9DuXnwRQy18Rs4gfEazAT2Pp7ivqgTaQHajn9ALmB	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1483	570	135	6301	6594	jwYuKnEuUvqCGEHGogifzNCCGdfwAA2VBsDnaCTjWdFs3DALbPH	5243	7381	7381	1617267780000
10108	3NKG71X6Ch1cRCHM83NGXY6DWJbZv5Tpf46698WKzXB1XPYYJHP7	10100	3NK8ptYjyZkcvdBT7GfWnpBnh9SNqLT9jrhVzmtCTtJzXerBzarm	1637	816	131	6301	6598	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5172	7382	7382	1617267960000
10111	3NKJtU9xBvAUpGzMbg3Z8KWc7vLch8NGbGJAt7LpF1JHthGpskey	10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	1646	1354	135	6301	6601	jxiw2pREYkqYpLz7reV9i1tGkeVh6vnXRaxSBJwFWGiXAeQExeC	5245	7384	7384	1617268320000
10113	3NKt8K5LsVaCyYUWWcZkTVYzUnRvvdKMYHEkwfBYzPGErsFUioMV	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1593	1346	135	6301	6603	jwk5TLWv6aubUURiF2EbRTC1ojB6qwqj2Mj9aeMFGLH4vr2gsav	5246	7386	7386	1617268680000
10118	3NL6VGHpB5UaqgV2p1WrygCy1hGvnqfd9G3Kau1mhdBXQrKUE4zY	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1460	624	135	6301	6608	jw7XkEDWe5gCQarZYHv2wpQxp1pGPNFA62rQVThhvHfAqHAoE5U	5250	7390	7390	1617269400000
10121	3NKVcFoa11pX8vsWoAtC4Cu8UeLyWLFjqFTrEc7xgFmMCFNnUHpA	10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	1624	1088	135	6301	6611	jxkSrQgJWQSWyVxTgC7tZQVkZaeTF7L2zcNADNHhXe1ybeZv3qg	5251	7394	7394	1617270120000
10124	3NKWSr9qmsXFdfN6Bkms73EefPbob6YQu48o6qTBJpqsSRHipRYJ	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1467	1376	136	6301	6614	jwHqrkewHaa5KFafQqoTkh6G6SVDufkf6fgYbvApV3cnQxxsdvX	5252	7395	7395	1617270300000
10128	3NLC5kiWnsze9T2zDsYwEEttnPfsCZ9qd8muHtUkbRK6E2YRGjva	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	1426	1238	136	6301	6617	jxUvWC25nTAHYvrGoJzgzp7cAZatJywJ5ZwzLVBAdzqHYu2cuhD	5254	7397	7397	1617270660000
10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	329	329	136	6301	6618	jx5y8VUhjDX9pYeANyZKvQcn799aBKeQJfVmgg9K1k6PZzjTkB8	5254	7397	7397	1617270660000
10135	3NLRTW3BVRec4sQd3zi1Qne6nKEFKL7AoxkZt6aZvJjvgRaTM3dE	10090	3NKN9mKLHRH3Rxhw1v9cMzwzmJpfxciYGMx9Ekn9uFQWCqAZMgdk	1578	930	131	6301	6621	jxV1tG39tCQWSN7o9cWvhQ7jwP1HFRsip82RUkkuCUge91GZu7r	5173	7401	7401	1617271380000
10137	3NKu4zLP4vU6h3x1y3W7FDFxp7qVLPrCfi2176ptVntmbHjDEGwo	9998	3NL2f54NN5uZn34RwwgYJxnu5kbqSGRmQKLdr9yfhHpWnefdS3H8	1643	1299	125	6301	6623	jxWp9eBoZtV4oc2UB5XddqmpYBc2UkDbJSRFWWohfLAxXF3ChBM	5028	7401	7401	1617271380000
10141	3NLewUWUjiGRtJB5VWEdjVYqm7qciuAAmRL41mCnKRRYozhssi8t	10140	3NLJFix829nM2DFEjpUJNMenoFEhu5e4jujse37gsowB6orfGxnC	1578	930	124	6301	6627	jwWjo8u1GDhvd9t3ZM9nZBqpaAnjcsqitDSoQKK6Ea1AMRnVYju	5030	7401	7401	1617271380000
10146	3NKFEznqDdpREupbfPgXZ5xVSDVs8eegZc1xW1xMBr97ZFUgMGkr	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	1406	1393	136	6301	6632	jwUNY5nUwSEXnbzqbHxvdq7ktTQNUHYiX5M8npcpbfXCMf5PFvN	5260	7406	7406	1617272280000
10147	3NKwapKgAWCQXsdbSjB2usWoomPfuVfeRcvd1y59YvN8MwBXK9Wj	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1407	1395	136	6301	6633	jxU6mQ1zsZcEZytkguGm3gb2vfhrFuaaEUhSzLPobKQvvKXD51s	5261	7407	7407	1617272460000
10151	3NLXJcfmGAz7gqG97AvpAveMXrHHv6eMxnvmn1UJBpxBAmJd8LFa	10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	1553	776	136	6301	6637	jwGBQrnNzyQLtbSZuPA3vuFeNJezdqRbr7aMEKYjuPWh4tyuCP7	5262	7408	7408	1617272640000
10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	1419	814	136	6301	6638	jx49f88nQvAhK5cJFADNM7kgRbRW3nXmAdfonZ3uyNGrGBo2JB6	5262	7408	7408	1617272640000
10157	3NKPar1Ewwpr3WTnXHnpoiTEJKhezyrZL4vhgbCYGGV4X6Bu9SgA	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jx5dH2fZGThmek2DC8ikMz1PNv4RAvQc4k3jRr3vEofa7AXYzTi	5265	7412	7412	1617273360000
10164	3NLDDELP7GhCWUMhGBPCMkQ7HEQDZxUDT5TVK3P69fHPHsRy1fgA	10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	1506	1127	136	6301	6648	jxqav6sBoFrzqX4cgxjm7hXLxS5aWkRjKGYHAKKYdbey1fcrVnR	5267	7414	7414	1617273720000
10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	10164	3NLDDELP7GhCWUMhGBPCMkQ7HEQDZxUDT5TVK3P69fHPHsRy1fgA	1405	849	136	6301	6649	jxPucDB6egEGGKASbYMa8DKtE54FdG4cLuwpjeKmMSwz4wPwkcH	5268	7415	7415	1617273900000
10169	3NLagyTz5vYmpXop8rqPNzpdAd85xBpTgNirf96VStYsiwXwCPBY	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	43	1064	136	6301	6653	jxq7tBQpWGZpcVLVaUDjnmfg9t3QU9PKCJ8mUGKQysxGU1mBR6o	5269	7416	7416	1617274080000
10175	3NL7ytbE5YPWtyv8eg8pWy75bYuAiHJJgCWYdSwVUYcZuAP1hypa	10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	1534	1191	136	6301	6658	jxtgENMyMTpShmGkXHWrFQ7pXm8zrvi4THt8X27JAkUxY9CmVW2	5273	7420	7420	1617274800000
10181	3NLVShmQggnigHStWFBLCR1zbwwKUELfS2WU1oefqFDxZvCQtCmq	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1608	1043	137	6301	6663	jxZPPKAHripoqtMqceoVx3zQW9Jdw5sAUS5rgfwJDxpu7xLnjao	5275	7422	7422	1617275160000
10185	3NLGsZ7x8Yp2wnJiMTNRSxy11oA3QKQs754QxWorPqFPptywZeek	10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	1422	1091	137	6301	6664	jwSCfLtq7UJVCSFFRZg594ueh4f3Gq76V8VGnKbCLjqnFqwZDju	5276	7423	7423	1617275340000
10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	149	1283	137	6301	6668	jwQvuJRkTHDx9CwdPtJkeriTCWJPDLh2jQL1bevVf7qqNpXfSUC	5277	7425	7425	1617275700000
10191	3NLodCVyJJvRmY8BbNPVURMw6sTm7ChjvPWFEH44CTjZQtZ6dhwS	10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	1609	1207	137	6301	6669	jwHqGkWJFhhvjHwbnpcXT8PS17ot8yQyAFjQ5Z4GKZYznuC1MnZ	5278	7428	7428	1617276240000
10197	3NLpMsyHLfDSVqHttPndJb95sJTjxwqJjsrX87ViAsuqUu6o7vr6	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1670	1282	137	6301	6675	jxmERLuBS51uu7UPrfk8XE88UG6AvtYJR7pcPjhAmdHK5qfFtMd	5280	7431	7431	1617276780000
10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	1405	873	137	6301	6680	jwQKJKUkyaCpZ9CLDYoPxhUnFRc6dmsKYXReEvtxcVdDvuFzkUn	5283	7434	7434	1617277320000
10090	3NKN9mKLHRH3Rxhw1v9cMzwzmJpfxciYGMx9Ekn9uFQWCqAZMgdk	9968	3NLLysH3sXhCzT3adv27SbLXZvCD97XTbxqsNHNgjaXDz2m1eFUj	1578	1296	131	6301	6584	jxV1tG39tCQWSN7o9cWvhQ7jwP1HFRsip82RUkkuCUge91GZu7r	5172	7367	7367	1617265260000
10093	3NKgTM3ZkTM3DhBGe525zuyTPU28D5UWKF31Bxao27u83oowdwGg	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000
10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	10102	3NKTbP1n21KZtji1AL2a1zE8iHqNWzyERYFnwaYNjST4EVimSsaU	1444	1381	135	6301	6593	jxH8qoUm33Ph9XjWSEipKZ4rZRYtzqrcLFSjByLiyhSxf6Txy1s	5242	7380	7380	1617267600000
10106	3NLKZBQ4fBgawEybhsGAurUsxj4UvboXpwMCcHpx4cjYVdTYWzvS	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1476	1005	135	6301	6596	jxyULSMBsva1xeoD81BqSpQPzsS1tzPsia4VoTVx8rB8eo3YsQ4	5243	7381	7381	1617267780000
10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	152	1084	135	6301	6600	jxcjyZU6N1Tui2eSyQRjvkpwpv35WcZLV3zwQBs5r4Vs1w6oCoR	5245	7384	7384	1617268320000
10115	3NLJnw4RnUhw9MVQPpbp5wB2wWtekfJcA62a4XtZeJqdGnadaZWB	10113	3NKt8K5LsVaCyYUWWcZkTVYzUnRvvdKMYHEkwfBYzPGErsFUioMV	1553	776	135	6301	6605	jxgQZtrAAv7yA9J6jQzdLYssyATSw78LFyhXfbeCaiFeDRCCmcX	5247	7387	7387	1617268860000
10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1585	1120	135	6301	6610	jxaY49kWWzAVM1FdLwU78iLACBwUuuJiVxo7KHLVKiWHnEBaMGg	5250	7390	7390	1617269400000
10123	3NLqh713pEKqjobnG71unELMfE7o3T2BggJ9XQEBbeJKfA95TxNm	10112	3NKnm3CCxzUn4eSoVet4wBGaYqdJnYnm41ZRFwVDFkQYNXrR94hv	1646	988	134	6301	6613	jxcQCmQ7JBSdkv4VYQuhphnc5pN5Ng9RE6MRSDFj2jUaXhfXPUX	5210	7395	7395	1617270300000
10126	3NL1FYHiKgR7WKLf9k4WSGbMvVaiPqzKPwcjYpdApD2Ahkagre6n	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1467	1376	136	6301	6614	jwHqrkewHaa5KFafQqoTkh6G6SVDufkf6fgYbvApV3cnQxxsdvX	5252	7395	7395	1617270300000
10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	10124	3NKWSr9qmsXFdfN6Bkms73EefPbob6YQu48o6qTBJpqsSRHipRYJ	1403	824	136	6301	6616	jxgFj1hezFmvZk9SHNPrtisZR1UJF72AfftPfu4GeJcEthmtpdW	5253	7396	7396	1617270480000
10132	3NKyKnLM3NVnEEdHGhsNbJJxwvdfaDQvbZhAX2Z5T6aaqfzZGjVW	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jwKjBum9djVLvKLfmdRVuptjg5SfCpFFksLAFUhysAt6JCW1nXU	5255	7398	7398	1617270840000
10134	3NKMtAYTfSgvXqDfWxxBbKiZ3aZZHXB43A4WcjQKJwBZ5Dqi7HxK	10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	1490	1028	136	6301	6620	jwtggDfFqcaagZXdLsoogWTwocGNVnRyjJNgPw8RzpJ86Fnf3NB	5256	7400	7400	1617271200000
10140	3NLJFix829nM2DFEjpUJNMenoFEhu5e4jujse37gsowB6orfGxnC	9690	3NKGQ2XgieWzNkVfhj9USPHKZqHQNQNWRdX9a4QgpmKEJ9Rssy4b	1578	1296	124	6301	6626	jxEY2u6f5cZF3GX67Sy9Y9ATPVM78LYU4auWQrQHFTdoE9QQNj8	5029	7367	7367	1617265260000
10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	596	1306	136	6301	6631	jwX4Cx48hynG5FzLoeteoFPTFCfawSJZcVN9gNQkW8KEtBdm2i8	5260	7406	7406	1617272280000
10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1406	1393	136	6301	6636	jwzBjwSk1SmiCsYq3vZH5KdxDsM4CjvKmHUNvfoVdYDMyrGzYet	5261	7407	7407	1617272460000
10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	1610	1314	136	6301	6642	jxTdnmnjz3hm6eKy7H6opDfQF7AeRRqyh82SPdzbUUBGs6kg2Qi	5264	7411	7411	1617273180000
10160	3NKTGF57B55vJ6TknWUYEimrbVxDaVhgH89jVcnRpw6fbA1PUZiu	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jwRdxgzPb8dRNYgb3491FTYMG5Uz6KU52TZ3qxqVvjrK6VKr71g	5265	7412	7412	1617273360000
10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	1593	1346	136	6301	6645	jxDqA4VSmrdpPqMgozAYqHTzfjXNuyNSPeRXqBYWfV8RiWriF9u	5266	7413	7413	1617273540000
10166	3NK6wJfxGKHCmcH19LzAwrzq27zPhLHCuFaBVANPBMnuz3LJ1gRs	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1534	1071	136	6301	6650	jwSD7baHirKdsUzbeeDJLf6EXUD6oe1zEKVQidozLhPFPdpcHZn	5269	7416	7416	1617274080000
10170	3NKhxrvx4j1PHbqTMdcmjXXosXGvMEcuyeZVAZYHcqkc2N9ahpxE	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1631	794	136	6301	6654	jx4ZvkSgsbrcPE4hPTtLEfqagm183fAuXaxwB6yGr6s2h9J6EoQ	5269	7416	7416	1617274080000
10171	3NL2BbbwJrjTTWsvwsGGgzS5HC1UU7wLfPrTtjZi5Js3n3nHNQvG	10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	1602	1243	136	6301	6655	jx3d5kga4hpkFd13UhdTxjsLqgGR9PrwFx1P8AUazKkt3SSCtDS	5270	7417	7417	1617274260000
10176	3NK3jDzTPy2RAtedg2eitoaKXG8bvvXJwJMBgbfqv4wooAgVrZBb	10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	1419	814	136	6301	6659	jy13UZfrQipxoJX1wEgV1TQaDqyj8QJfxNQAyga34MTiqQTzPdh	5273	7420	7420	1617274800000
10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	10175	3NL7ytbE5YPWtyv8eg8pWy75bYuAiHJJgCWYdSwVUYcZuAP1hypa	1405	867	136	6301	6660	jwgbJozCSzEgAsfhFjfuRodngtvVRLejBfjENvkrQz6GkFHKFr2	5274	7421	7421	1617274980000
10182	3NKjE9NvJUAS1oXo82KwJ7D4TSJyn6mRLUrgwDHSUAwxWRGURJgA	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1435	665	137	6301	6661	jwSTwqYWAF9o8jXfmTXn5ymbmJ8LBkXELLPVyDsHQ5ihvtuz4bF	5275	7422	7422	1617275160000
10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	10181	3NLVShmQggnigHStWFBLCR1zbwwKUELfS2WU1oefqFDxZvCQtCmq	1422	1091	137	6301	6664	jwSCfLtq7UJVCSFFRZg594ueh4f3Gq76V8VGnKbCLjqnFqwZDju	5276	7423	7423	1617275340000
10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	1403	800	137	6301	6670	jw8eShP4G5ZEi54hGLRi5qfgVFLwgnrQgYcQZxkpKrrgVnZM6E9	5278	7428	7428	1617276240000
10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1403	824	137	6301	6671	jwoDhryyNSUpg2YeeP8xah11WU17N9xYfQ8Z48Hw7YEL9m3pMYh	5279	7430	7430	1617276600000
10198	3NKm9etuQaHXNDMXxF4uxxoRtXeZVdoMbdeopgZhbfgPjMonq9X3	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1549	1116	137	6301	6676	jxQ3VkNE2sCKSfqfrSktkyCHZs8PaaTxmHhjgjFFqJa5Lxq8yp6	5280	7431	7431	1617276780000
10204	3NLEkyeRftSRZX8ZAnr9jxUjRyNPrbjP8eVmp1p6WUPw5okTAAun	10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	1534	628	137	6301	6682	jwWD1pySRnnb6SBCNygyKuT5B5AepZMWz3oZv5ENVsgNPkNFWiG	5284	7435	7435	1617277500000
10209	3NKccQPsBwdmB9rchMLTZ2u5rR3aijPYUUaF9eNw3qGNPKSmbjB8	10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	1602	1243	137	6301	6687	jxFeSHHBc1vG3GrFhmQhPStSsfsBjCamG4FGsJSS2yJGamCNv7T	5287	7438	7438	1617278040000
10215	3NLRzzMW2ALXGsd79oUWHjgvBQoo1ibcn51KyxdanFNbPb3f28Lz	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1656	1097	137	6301	6693	jxVyLRYdcW9o22DpaGVXRrDMyNWRepBadpTWBy7sV1azdmJzbhu	5289	7442	7442	1617278760000
10221	3NLJhc34fqd86Y9TFYxmZWuDTpyG8MGUf9dzJuRUQxkUnmJHa8jG	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1623	839	137	6301	6698	jxHgNd6egE2uSo6ezzCRhyxLjzMJnbzPcKyBbz24SEz8qvUmPe3	5291	7445	7445	1617279300000
10119	3NLpCdw3ZiyrE1362TSk52D9UZ7KLiEQn1GANBKD2nvZ7V4TmGrv	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1406	1393	135	6301	6609	jxuuQgX9FC2Uk5HciE9pTUtaTQfrNtfTCLmHCqKsmYM4PZ1dwnS	5250	7390	7390	1617269400000
10129	3NLh2Xz3wPqa2fmiGUWV9dQPSDBMknagasWtzUoeGXwcLYk9cmeu	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	1426	1238	136	6301	6617	jwWyMCrvnUy2Dx53PDW6Y7xsWaBtKtk6e73tLkMEyWri9PUDzUj	5254	7397	7397	1617270660000
10131	3NK5F9q9Y5CkSaifrDEeGfuESzGa9cK5Yo9snLJbH8nwh9SCuk7s	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jxCjGJeaxCbmhEdygr73D944pkAqbGWcAYGKiaztDpChW9mtRAX	5255	7398	7398	1617270840000
10136	3NLvvkc7fvkwMNWn6tWzczgGNjsATauRhcrmMcUPqDwfrwLK7i5M	10134	3NKMtAYTfSgvXqDfWxxBbKiZ3aZZHXB43A4WcjQKJwBZ5Dqi7HxK	58	1281	136	6301	6622	jwhMKFZ76tkyMhWaUnUAtapLnRyEy5MRA1DjLGbkzYckHXGqXjy	5257	7401	7401	1617271380000
10139	3NLbyA9bX4sPMYh8zh15mzbtyd3chj6qnF5KRVqekGZnQCF4qMo8	10138	3NKLUz1v6jqP7Gdfmyi4ezft6PeDg7giXcZZRukyb2HxtnC8iP49	1397	838	136	6301	6625	jxWKmvz1ydJpP9ARFPgEabLok395XfhVBjGPc7tiKyDEj9jC1Kk	5257	7401	7401	1617271380000
10144	3NLyPqQYJacymWZg1iJVBX8veyMAC9kUuBteEUcCjyYBvhRdb42b	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	1407	1395	136	6301	6630	jwmfPWomW3YtsLugZm7JCvjbPEsD3tDzb52AsfD9Ws1JPNciLVh	5260	7406	7406	1617272280000
10149	3NK5xKhGcvJzdhtzr38isFzqYXcn6fB4FTeRTt2xtDjx1F5Q2kQs	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1553	776	136	6301	6635	jxUw9KEDeu5Ys8BmERZ6YsyCSRAxLrcvBYXHSD1dRG9GqoWi8BE	5261	7407	7407	1617272460000
10154	3NL5oBAnXZqxQ4vGef5osqsXUp1mB38HpVRHLDWMMMaKMB1Xi9e7	10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	1458	1323	136	6301	6640	jxzNnjtk5wKNNJnAnjdEb27EjwSqa8FsGSK1y7EFcsB9XdKTQ57	5263	7409	7409	1617272820000
10155	3NKEXehkgKPk8A4Rxe2MMaQf2etC1eXA6ymBAqAYcrW2LmehGg6W	10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	1460	958	136	6301	6641	jxdKzXPPjJae5Eat5Q88r6L1jMavegN9NDFT3GnYM9RLJNsS2fJ	5264	7411	7411	1617273180000
10159	3NK95PSQcdZyfiEV912niRrjHf7qWoVcjUDot3xYu1oXvtY5GPvm	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jxUKh8WUWNyUVdu4StKz3jcUZ3dw5vDUYuk7D4x4ggwmVqFQPed	5265	7412	7412	1617273360000
10162	3NK82htdQnjd7UKRMQ4mkeT4ArGsNYDce6XfxMxbRMDzMbRnfAPf	10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	1406	1393	136	6301	6646	jwZ8ufhsxxQosd6m94PHLjdytnyfFfn41Etpk3idmUQhfeA4s3h	5266	7413	7413	1617273540000
10167	3NLea2USdEqeboBeQb2aBti2H29Lg7giNHhMtcYuNUvFxKTNXS4J	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	42	1361	136	6301	6651	jxSEeq8ReM7yaSWc8hQ72RYBEx2zvD6akCUA7jdhLbqwj39iwBE	5269	7416	7416	1617274080000
10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	1602	1243	136	6301	6655	jxioX228Z2hYn4Cy4ov8aL3R5qB7o7kHiQ8VNGjsUdaxXY41rad	5270	7417	7417	1617274260000
10178	3NKvZWayuja9fkwxfzT5QNaPiGFpQRb8tejsTkbq2g4ZFfoBwpD7	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1435	665	137	6301	6661	jwSTwqYWAF9o8jXfmTXn5ymbmJ8LBkXELLPVyDsHQ5ihvtuz4bF	5275	7422	7422	1617275160000
10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1608	1043	137	6301	6663	jxZPPKAHripoqtMqceoVx3zQW9Jdw5sAUS5rgfwJDxpu7xLnjao	5275	7422	7422	1617275160000
10187	3NKRy13kEa1B7rq5E4ZvbMHf3Tx3op4GFwwT9K2QNJVs3uKv2Uhb	10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	1623	830	137	6301	6665	jxAf1i7n6Zymqq16Ej81D2L3uL8ny8R6wBNS6EmoTFx6zEgUfCh	5276	7423	7423	1617275340000
10188	3NKAGeqnZR4BNYiLekCd4dGjpJv9zTzKnkLYRbGRd4VYrT4tLBxm	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	1593	1346	137	6301	6666	jwoYBHRnEeSussBBfAV5zz4dDHKoL88YMZ3HLJXyL9bcxC2dFo3	5277	7425	7425	1617275700000
10194	3NLfvChFTnxZc3y9S4cAEuKsbErFHqqnMngXQuSBvmbxmk5CVRza	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1581	778	137	6301	6672	jxHfLw1BbQ5RSbuQRTKfAWQYybhFRAMbd6BGbfCvHQzyC3fQsZE	5279	7430	7430	1617276600000
10199	3NKe1uKsh49G4iiQsM1cHzM3C3y97m24JetuE1MewT7aFjWka5PX	10197	3NLpMsyHLfDSVqHttPndJb95sJTjxwqJjsrX87ViAsuqUu6o7vr6	1407	1395	137	6301	6677	jwvmuw7jCTpN2fxi8UUGGnkNthxUKX28dKfJ1UBXUUV8H6aRcMT	5281	7432	7432	1617276960000
10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	10199	3NKe1uKsh49G4iiQsM1cHzM3C3y97m24JetuE1MewT7aFjWka5PX	1402	906	137	6301	6678	jxNVa6Z2XYcG1bLzWbUk24YvNGFAXFKdfm4jfBBZemeimcBxjNL	5282	7433	7433	1617277140000
10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	171	1374	137	6301	6683	jwETt9vnpDmbf3rz2gqZB2uU1aANR8Z8cY36WTTzFwYT327pg47	5285	7436	7436	1617277680000
10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	1609	1087	137	6301	6688	jwRpihRev541KMzZdna5ejpVdeTe6EikfKfBR2uyd4h2HPMneXc	5287	7438	7438	1617278040000
10211	3NK69hps4Pazp934xLiAa12FizAWScAq25Dja5p2wrizsRzJev1a	10108	3NKG71X6Ch1cRCHM83NGXY6DWJbZv5Tpf46698WKzXB1XPYYJHP7	1637	816	131	6301	6689	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5173	7440	7440	1617278400000
10212	3NKutKS94KKCcq1swMDYuDCwyMk8Z9p4wdEHucm49kkJNyFo1Sv8	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1527	1293	137	6301	6690	jxaG9MKPs7gs1xm8kL2pCdvVv5noVRELGSu3enRqVAH8FNUutjS	5288	7441	7441	1617278580000
10216	3NKnv55KHQcJZDakN1Hvm5ycHAn63RgnohZkh7MxWrwMDEoHeHSg	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1500	1297	137	6301	6694	jxcYjeUEbvxzBmX4M6GCo89TB6Bbee3qMjPYUtZo499ETzQiWbp	5289	7442	7442	1617278760000
10222	3NK3pRiUrZhyvSakaNM88vMXP1vHJmmrCJasFxbpZW3bRTEH3vZM	10211	3NK69hps4Pazp934xLiAa12FizAWScAq25Dja5p2wrizsRzJev1a	1637	816	131	6301	6699	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5174	7446	7446	1617279480000
10228	3NKhWXiRoQnK4tr4fyv698oLQ6gcURWFpy3XHvLCUwFj5Z6Nrb3Y	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	171	1128	137	6301	6705	jwFHmemvXeQEmjvuMARUccrn9XSm67UfpnEoCB9L9Wz3ewaqAQw	5293	7450	7450	1617280200000
10229	3NLGCuMsdbnmd4zeJx8Ne4VRQv9GgixpRNsrB6i2Gr1NqN5z6kgH	10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	411	411	137	6301	6706	jxRWJPDXirSdoePgH9ExFGD6Czp2yzbt3LbZXo3iW7qGmpDsyMz	5294	7452	7452	1617280560000
10230	3NKgAwD9ETY1KGRwKuJi1sCeJawoWZzs2F9mXCyMFAE5VrCZDcb3	9648	3NLfqtTEXkXSdtNcsEPtobAwFcJey3X7v4hxvJaULCrJgacbqq3K	411	411	123	6301	6707	jx9HRKUUxNQ2QJwXP2gkQg3GWBGGC8FBFHeEoLBQv1DSWJ1q417	5007	7452	7452	1617280560000
10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	10229	3NLGCuMsdbnmd4zeJx8Ne4VRQv9GgixpRNsrB6i2Gr1NqN5z6kgH	1590	1300	137	6301	6708	jwtjQY4jrdVXLHctggY73LytPPZ4egKAYRDyhGpCzXMnEDqruFG	5295	7455	7455	1617281100000
10235	3NKPoqbFNSXqcaTHi9mWGxpa3uzAKcviatuDUdNf2Fbj6kU5iNfL	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1652	1069	137	6301	6712	jwPWF5xcVxhkVh32E4WbZqrxy69QGHqbcfwcjvRTPMxZopyA2su	5296	7456	7456	1617281280000
10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	1673	1122	137	6301	6717	jwLsmgRkqjNsibvTwVJdLAhrR17LQGHrq3q9sXXxyZSLJfFcq3Q	5298	7458	7458	1617281640000
10179	3NKFgztRuVqsCa5sG6iXzzptoQyykfAKUhaP8nuAFYkoYx4tC3Je	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	136	6301	6662	jwWsqSduV19SSP2annGdHTmRTtkPZCB8JpR7REykabbTZeiWRoi	5275	7422	7422	1617275160000
10180	3NLdY4CuYMGXrnrPTJxTo7z8h81rvB5wUnLd95rgXgKXJDpNKfkv	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	137	6301	6662	jxG2jEcHHBtZPaec3fa2Gge2DRqYUUzrAFc1cWsTKpn6j5ZBfXo	5275	7422	7422	1617275160000
10184	3NKevPNmiysDqrT1Lqkw7AUGzd5vY3BMDAqAFxTVBUwLkgguifsL	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	136	6301	6662	jxZgN3W9DF9kuWcZTjKSG9HazZwhFagzjFwLRdamD1gtziSZGYE	5275	7422	7422	1617275160000
10189	3NL4p3EgXGvRSJ1AYYxUkSaCRL8ncvqu4PyufVZgDMDBiyPjSPwp	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	1403	823	137	6301	6667	jxnBiRgxArwb8n6gQPyMJSXNaf4tP1G3zTCi2kbTMYkRSQPTRed	5277	7425	7425	1617275700000
10195	3NKQYrJqchuKpV265V9UkGiUWAQQZ55DmmAgSw8Tth44KmdUquDQ	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1573	1072	137	6301	6673	jwN7C2hRuDYHcvsqJRAdLqub1B6qoRbstf8CTFNHYcMD6HzBCzC	5279	7430	7430	1617276600000
10196	3NL7KBV3KRvzFY4Q2nurvKTjSvDN5tRhAK18fjQ3UQDpdVBhgCwT	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1542	1058	137	6301	6674	jxxK1hYydkXfkypTD9LZczqcdUz89FxVjncoLcn6tzLf5D3BMu9	5280	7431	7431	1617276780000
10201	3NKMWpHmHUDgCQPVmZM3FJf9B2MLZhwWz1LmzqgEefjPTkrHruPa	10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	633	1018	137	6301	6679	jy1f1sS12vPDiAc7Zu3mQWUj7TNWth1CxMi2bYNxYE8io5sxp3j	5283	7434	7434	1617277320000
10206	3NLQs6hH8CZsRe2J7CC1Sv2UZVsjXmybnzYmQGjaYTGSPHc5dMpc	10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	1477	1350	137	6301	6684	jxBBcUUu73XmXzGRirhDnJqfs7z8T912HufoAcHECg9dpBbFpPC	5285	7436	7436	1617277680000
10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	1596	1363	137	6301	6685	jxtz3FZ5eAiCpNPkpjCJe1QERYKrTVpJ17EfziRrGjHJxtF98Pb	5286	7437	7437	1617277860000
10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	43	1184	137	6301	6691	jwivBwEPJRobt3Ff6txuHeWNvAu6ZmKddkMH6Ef7YJnWybKZonn	5288	7441	7441	1617278580000
10217	3NKp375co18gjPmkfka9jaDAqv3qniorsofWbtkZB75FCramfQgF	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1500	1297	137	6301	6694	jy2xGqu56jRKHKHZXf6RYv6xx1ep88VQdfjLjVDByL244MiNJ7V	5289	7442	7442	1617278760000
10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	10215	3NLRzzMW2ALXGsd79oUWHjgvBQoo1ibcn51KyxdanFNbPb3f28Lz	1483	408	137	6301	6695	jwBjUtizVsSgUzm26CsEDdM3ArwCfEhhNgaJr82yemyvzydUXyx	5290	7444	7444	1617279120000
10219	3NKpbVK5uMrNKGNhPDAD3WCsyXr17tFb2794WdWG52HkPZ9wNAbV	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1611	1341	137	6301	6696	jwbPyzSuSkcX5K2AfF5dVPnAeysbrQXmdU1FebWTMoaAeRES1x9	5291	7445	7445	1617279300000
10223	3NLnh3VsAzyGobo7mRKkEKhHEAHDiJgzT6CP746oEiugHUDFLrSZ	10137	3NKu4zLP4vU6h3x1y3W7FDFxp7qVLPrCfi2176ptVntmbHjDEGwo	1643	1299	126	6301	6700	jxvPqR4qh2fj4cNsBnJ6YRdirxXUCxuKoi9FV3G2dWADRYxLRJA	5029	7446	7446	1617279480000
10224	3NLThz6QzoXjK4grzsLWPdbRpF9GyJTqwDQ13sJvmtDQ8Do5SK68	10221	3NLJhc34fqd86Y9TFYxmZWuDTpyG8MGUf9dzJuRUQxkUnmJHa8jG	1673	1242	137	6301	6701	jxqxiraAT3NYRT9tV12UY5N4iZwnPkLdvXUZhZthbmg49xv1wii	5292	7448	7448	1617279840000
10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	10219	3NKpbVK5uMrNKGNhPDAD3WCsyXr17tFb2794WdWG52HkPZ9wNAbV	1405	867	137	6301	6702	jxsAihdEiG9iwobpbiYYs8PzJDjehJn2EpT71n1maYbgFcSPMfU	5292	7449	7449	1617280020000
10232	3NLM5gt9YA8WJC5og3yCC2r3BwKctawU9VZxEcXdZh7D2V4495gr	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1656	1097	137	6301	6709	jy2irHR7Q1H6xxvr8AvFqsL9RVL6San6zwhX3fgG6zsZFbue8vv	5296	7456	7456	1617281280000
10236	3NKqjf6Fnjdn9ZWbshxm1hCqNxCiRwCGnWMURsixQVDQtUT7YvjR	10222	3NK3pRiUrZhyvSakaNM88vMXP1vHJmmrCJasFxbpZW3bRTEH3vZM	1637	816	131	6301	6713	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5175	7456	7456	1617281280000
10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	10233	3NLC9CCNaAUVC56qpNZxApYnbPdtWrqBTbboqiMffvhzSVLevtt6	1467	1130	137	6301	6714	jxk2Gj5vN44punU4TwDCA2KKWvq13Pcs7pU1muR5HcfBfR19QyK	5297	7457	7457	1617281460000
10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	1407	1395	138	6301	6719	jw9b5tzPm6b1W2WLf2bVNXKbG9opWiseTA5Q45JY87SSLr4piWh	5299	7460	7460	1617282000000
10247	3NLeENBf1TCP1jh18o8q7v8Jd4BK5sgUNMM3g1KurDRaFsyW6wVh	10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	1419	814	138	6301	6724	jwvMZ4wNayfVat7cwxGkbTMgkSW9CzxzMdGLuxXTLCRXc18LxdW	5300	7461	7461	1617282180000
10248	3NKPKTFNabW1VLArNWKPQxzpVZXxJvMKzbcUt5J9uhNzEPqRdFRa	10247	3NLeENBf1TCP1jh18o8q7v8Jd4BK5sgUNMM3g1KurDRaFsyW6wVh	1599	1041	138	6301	6725	jwmz3kcvWkJQrqVyMksN9kL4neqgVUUueeEqsCfL7F8yAVarvC9	5301	7464	7464	1617282720000
10249	3NKBGbLN3m2c5TFdJNf5X1ZHvJ7dfriXLYZ6CTo2wWVHfWyQpurG	10248	3NKPKTFNabW1VLArNWKPQxzpVZXxJvMKzbcUt5J9uhNzEPqRdFRa	1608	1289	138	6301	6726	jxQT1woPqDzy3WpQ2P1zp26wm5vpnGuaWLvdnrBjvRU8cYTRBDM	5302	7465	7465	1617282900000
10250	3NK5HmrRd4dvADZt5sTWhtAY1RXxEL5nX3TBXRZAcwSvnBtkot5W	10236	3NKqjf6Fnjdn9ZWbshxm1hCqNxCiRwCGnWMURsixQVDQtUT7YvjR	1578	1296	131	6301	6727	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5176	7467	7467	1617283260000
10252	3NKFKbRPVgnbsKx4e9L3jhphSbEYX7phyoUx86JvvMP3RtiLxhux	10249	3NKBGbLN3m2c5TFdJNf5X1ZHvJ7dfriXLYZ6CTo2wWVHfWyQpurG	1507	1280	138	6301	6729	jxmQsgNRB29WR1xeYjpmjcSq62zu5GYvEZqDHeWpcJQAKhjhphd	5303	7468	7468	1617283440000
10255	3NLssdxqLDGQ9UjLipcwexBGRwE1xT34mPN8UjJuXxK8tXhMDmHM	10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	1654	974	138	6301	6732	jxbcPpDXgdu9wuiu64DyxV6zMCyrQS94ASYWWb9CVtWuo4fx21w	5305	7474	7474	1617284520000
10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	10255	3NLssdxqLDGQ9UjLipcwexBGRwE1xT34mPN8UjJuXxK8tXhMDmHM	1559	987	138	6301	6733	jxGS5gYo7G9mBoPFXRuhHG2zQQLqnwSyruczG6DVo7NZC2YbueL	5306	7475	7475	1617284700000
10262	3NLEVovLj6Vv67GdbT9amF1doif9bj6bsZkVi4WNPJRgPze5k8BU	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1407	1395	138	6301	6739	jwvUgZujRVLnCYY6rtGF48TcLbqDY9zDLsam3g9UrH79voYP1rA	5308	7479	7479	1617285420000
10268	3NL66b8xYVgGaRh7aREDuSsCCNM9ZixQYApKYmAaBNFTtwsPYrPh	10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	152	1084	138	6301	6745	jxHPyJeSGCKGqFxmYEAjE6AUY7DBUFQVkuT8WPhPqZUNwd6LauY	5311	7483	7483	1617286140000
10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	1407	1395	137	6301	6681	jxcWgkyCqKRTChXBiRbDqeb87CL7pnPsoJnVzdWDzqjmTPikgaC	5284	7435	7435	1617277500000
10208	3NLV176Xdqsa8ZvYY1T7mLD7aH4D7CWjhrv86ehiNkDWN91jpGqv	10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	152	964	137	6301	6686	jxdksL32FLFbwJz5ZZRbzLKdVfgoFeZmgveXjVxB29qDoFP2xTx	5286	7437	7437	1617277860000
10214	3NKoZbbm3NB6YY74P1DUoRk8ovdYEzkvueDkYPRvnaXvQJrxDSWf	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1631	794	137	6301	6692	jxS2DpjHJ2zxprY2WKtewQwsTDPFndmoQXKxfCZuuodpiRAeY46	5288	7441	7441	1617278580000
10220	3NKmHqt8qQu5k6fyh366FZhvbLdMsEfuVghoWnbMkSmSEVS2HK5f	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1581	778	137	6301	6697	jxBRCEYTvEbVXqCebceMNWpUiaFHrwFNWY6DLZSWE8DMU6eUvz7	5291	7445	7445	1617279300000
10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	1507	1280	137	6301	6703	jx4uniJLKR3rvMoJFshp2FKXQQ4tQmNk5CBYGKejZijV4r1xMgT	5293	7450	7450	1617280200000
10233	3NLC9CCNaAUVC56qpNZxApYnbPdtWrqBTbboqiMffvhzSVLevtt6	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1407	1395	137	6301	6710	jxigELYJnzNNYGBTo2Pq7Qskvx6yHpMHgAtkMUxjs6sD8qXxzxL	5296	7456	7456	1617281280000
10238	3NLUWrxbjoWVRZrRKU3dfLeGVwjZoKwywoDzxFU8ajeCCi9bu6Ga	10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	1467	1130	137	6301	6715	jwM8DrwwQ6JKLDtdyfbK2Fgf4dYmNNJKhfWRgJjcVpDsvKdV8hd	5294	7457	7457	1617281460000
10243	3NKYPzbuYPwiGDLvq7jXqYZ3jtGRJ4fdJhFabjNciBbMHWT64LTy	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1587	319	135	6301	6720	jx1JkqjFc1igJiydv3mb41yVs4eZE7JmJpZ7Y8s3QHCWvdPK7ND	5246	7460	7460	1617282040024
10257	3NKoQhQqo2Bb11CitfWg8MQS6GDLfVHHUT68p3ECunFABf9LbFaN	10250	3NK5HmrRd4dvADZt5sTWhtAY1RXxEL5nX3TBXRZAcwSvnBtkot5W	1637	816	131	6301	6734	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5177	7476	7476	1617284880000
10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1672	1159	138	6301	6735	jwJGr5RqnsYsCtavKtnCCvJUwrTWXe16qbtqrkJNQ1jykzkY8nL	5307	7477	7477	1617285060000
10263	3NKUmYhpRTzzsrZMNfcxXquYicqAbD6MEyTzqsgjYWWgcJi6FnDF	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1601	1388	138	6301	6740	jwgrPpsMuJVw2Nvps1WsAUrbCWyTaayn2R4eCTNzwNGVHzA22Xf	5308	7479	7479	1617285420000
10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	10267	3NL7RsSYCtnfMcBEKuaNkYQfZHKEdgkX8sZ4z1gPLAFCEfEnBzUo	1403	824	138	6301	6746	jwBG5LRdxiLiAvPGqpAJ2Sx3abJahcPHpPhWkBpL8YZgeR5e4Bn	5312	7484	7484	1617286320000
10270	3NKP4HWMSipBx3Ah7CFwU2N7Y9eiN9jL7pNGJT1HN8peM4bMYjGE	10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	1671	1365	138	6301	6747	jxLesrq6pSf42cLDnBaPkKUTEZ1R8N8ZjZXNMGoQSK697dTdyvf	5313	7485	7485	1617286500000
10227	3NLVYR14ELubWJCLvqvKwcaP5n3ZWPDtY5fAkURtDigTTdG4pabA	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	1407	1395	137	6301	6704	jxixhA3c11Fzw5dsUdYsU9B6JMdoUqY6PD6W3PtKzmk3gTtb8u8	5293	7450	7450	1617280200000
10234	3NLCJpUhpF4yoTv5dMqTZYXwPZ6Sz9abikC27K2dzGkZRGgt9jUu	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	149	1283	137	6301	6711	jxm4ppooPegcPKSLFT8rxVBJJQgytDBrnNGog4SSvwD3jokvREP	5296	7456	7456	1617281280000
10239	3NLXp6FMdiUY6nGdwtccBpWbMzjMVNCuEf1skMwrbMDHLqZ7xrHY	10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	1507	1154	137	6301	6716	jw9C2re12kMMV7iafAzve2FnNni2c4RpWgRvfkWPBkuwirsLTKX	5298	7458	7458	1617281640000
10244	3NL9Hrcmbu61n2ySDphNg5RcVaMY4ZUeTCh4fWY2c1BUd3rPvJ1B	10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	1587	319	136	6301	6721	jxiiBTXT6U4nP82aWkd4SPe5n7wp349LwqcYHy8vrQb12C1Ri54	5259	7460	7460	1617282077613
10245	3NLiiNaS8ReqYz8MXNoYvShEMp4RQNaL12qhb1BNSqmryjfTeLWS	10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	1587	319	138	6301	6722	jwmkgiugEkyRtXAAnM1dnvqN9UPqhSfxGiRW3EzsaBh7ww39k3H	5299	7460	7460	1617282000000
10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	10252	3NKFKbRPVgnbsKx4e9L3jhphSbEYX7phyoUx86JvvMP3RtiLxhux	1607	1222	138	6301	6730	jx912f9jTRjH8j8sUMczNwuootuTtDmjNWwcTvua2nrsG3kXMMT	5304	7473	7473	1617284340000
10259	3NKYsH6H44fBx2arj3j1xHQPWcFS5qkpJwCXbBvL1YnmWkGEXXyr	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1547	1378	138	6301	6736	jwWCsxJB3fMchdFsymcZUv68QesjyPkxPheMegUjtsWquoPa2bS	5307	7477	7477	1617285060000
10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	10262	3NLEVovLj6Vv67GdbT9amF1doif9bj6bsZkVi4WNPJRgPze5k8BU	1673	1002	138	6301	6741	jwV8e88DxYXXC8Xoebx3eBezgHuLtFWSWtrUSv3Wh41LfAUuLQj	5309	7480	7480	1617285600000
10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	633	1384	138	6301	6742	jx53g5Rxp2Ruu93iu1GNnhDAHninDH4FinAaLqvSa4PRLc7gFcr	5310	7482	7482	1617285960000
10271	3NKBFhhPMzrvfwri8L7Tvi7QoQnf8crfzGDnBseyXchCjD8S7nFp	10270	3NKP4HWMSipBx3Ah7CFwU2N7Y9eiN9jL7pNGJT1HN8peM4bMYjGE	1403	812	138	6301	6748	jxdHTvXDPWUvTqtLRZ6XfkV2TSZfbgmvW9xJdHgzZpJR9y57RMo	5314	7486	7486	1617286680000
10272	3NKu8jsnzzudqmKme1NoEhGM4kXvnmmoEkZxAqYqju7Ec2prRswd	10271	3NKBFhhPMzrvfwri8L7Tvi7QoQnf8crfzGDnBseyXchCjD8S7nFp	448	1305	138	6301	6749	jxdL6YCsYMcz8GpVx7dN1tuPjNrQsSf1wnV4NGzkadGKaPPY22a	5315	7487	7487	1617286860000
10241	3NKPvCaNeUZaABAWpCktaXvJhRxV6JvTuDTtLTgaJPwPA2UKUQRU	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1587	319	134	6301	6718	jxPSAG8SSRR73tJjuftN9eWcnsG6ShtXXfdcTASERfNTeFiho5q	5233	7460	7460	1617282000000
10246	3NLdcVed6SrjYV3SiK3Xk1ztjF7rPHjoDo8mwKgfaBmPpX6P74gH	10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	1587	319	136	6301	6723	jxAkhRBBZjH7WTctnCm5UNCRZHSwecGkd3xVxyLH34Xroxo5pGM	5271	7460	7460	1617282114664
10251	3NKjsRVcphpQiADVgxRKQpF9B6H1Vhq9ZDjAjq6vkpFDY141cQJm	10141	3NLewUWUjiGRtJB5VWEdjVYqm7qciuAAmRL41mCnKRRYozhssi8t	1578	1296	124	6301	6728	jwWjo8u1GDhvd9t3ZM9nZBqpaAnjcsqitDSoQKK6Ea1AMRnVYju	5031	7467	7467	1617283260000
10254	3NKq2GJHfU1EB9NHf3txbQUtqZWcn4FVhGkFeFuN7x2tFyfLNn13	10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	1407	1395	138	6301	6731	jxU3ywTCp5UfexU2mu59o4fjG9QVvCUWPgto1GVUxafodsoKZYP	5305	7474	7474	1617284520000
10260	3NLdehbiHyAupEPfzj3RhN2sFoLyryeWgZCZNprjBMw3tVG5JY1X	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1406	1393	138	6301	6737	jwfwXjcGfUeKvkyUUdVoimxLeGgSeohbeXkNVjn22yJ1m2QxaJb	5307	7477	7477	1617285060000
10261	3NK4CWv6jjoE15tGqr1n9Xor3dGoJj7bkU65WQ2rF94QiZatMWEu	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1457	1145	138	6301	6738	jwHjAbLNhqg6xarxPasPBTLiVyaHVEdzbKd7tqVwNsf5YxatMtm	5308	7479	7479	1617285420000
10266	3NLfvChn6dBq6h3hhopVnkUpE7cXMCoay2mertYrDfegEN7t1Xbt	10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	1403	824	138	6301	6743	jwQ1RdeoTSSbBuexS3JCRx3cEvbUga2vwiuAESW9juCNSkiU7xG	5310	7482	7482	1617285960000
10267	3NL7RsSYCtnfMcBEKuaNkYQfZHKEdgkX8sZ4z1gPLAFCEfEnBzUo	10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	1422	1337	138	6301	6744	jxq9oudyKyzDSkHHyvZjkrdL7GZfC2s9Xdkf6xN9VxAgWnHgVHT	5311	7483	7483	1617286140000
10273	3NL62QUJm879srXtdnVVHzq5YKeUBXmXUcJU935Z2DHBFh3rPtdD	10272	3NKu8jsnzzudqmKme1NoEhGM4kXvnmmoEkZxAqYqju7Ec2prRswd	1461	1271	138	6301	6750	jwajb4reWYKpdRyQP57TugMz2JNXA7gmUtfjQ64aTRNfY6S4zny	5316	7488	7488	1617287040000
10274	3NLg7yiAcQ3SH918wixFnn13ZToAthswdXkyYbGAZFmzxXZHaB3u	10273	3NL62QUJm879srXtdnVVHzq5YKeUBXmXUcJU935Z2DHBFh3rPtdD	369	1066	138	6301	6751	jwcKicvxf83asL2G98PEfB3xArBBjP9xLiUGKEKwMd2uUnXEgQL	5317	7489	7489	1617287220000
10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	10274	3NLg7yiAcQ3SH918wixFnn13ZToAthswdXkyYbGAZFmzxXZHaB3u	1559	1107	138	6301	6752	jwWcCnuLnNGFdnLomU9aCM2DEXDwpW4baketQNE4y5is7oEmrZE	5318	7492	7492	1617287760000
10276	3NKzyYhNQUidd6YwFkAzhdRP4juXvcaePN2kWxmg4HhUKfeatX4s	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1501	1360	138	6301	6753	jwrxoCtArPp3dK62vUZds9iT36mF35jof6thfk2vgNMuaJVQDEW	5319	7495	7495	1617288300000
10277	3NK4fxVyqcCw8h2qJjcmWvjgfebmhV5JemBjbqr2KPz45EcMTMQZ	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1458	1077	138	6301	6754	jwvgdPRBvwGtAxVL1RyKJ5r5HLrpDRVgfA2xEh4fKjMyYdiVbnt	5319	7495	7495	1617288300000
10278	3NKdiQoNL58iog1hxMyS61GQUK28TVQLYQ226azSHcYVH1mjjb9q	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1501	1360	138	6301	6753	jwuWqMBLcuevpVpRHKacyg4f9Wgh6NaPp8nE59kqJE2UmX9KHFs	5319	7495	7495	1617288300000
10279	3NK9XE49ByFZTe2BZ7Tnif5gLJKXU9DopZScjY63g5L517XKP3UH	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1651	1301	138	6301	6755	jwHZ6SAzmG3xa5oknoBY3EBut6Q8AF7y1uBvR9Ht5WkDQQEBfEu	5319	7495	7495	1617288300000
10280	3NLotSJmHyevhkky9mcTGE4t2ms9FNnBASqwdZSy1vfXuuGKzxRZ	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1651	1301	138	6301	6755	jxpGebePFG7dWcGzYMqJmMgGwkX4pyW9jqQ5sfAbWBDCj8ZvSTk	5319	7495	7495	1617288300000
10281	3NLo4ymEDnybcX5f6TjBBm1EZEToT8NoYqw1Gv8M3rS2dxm2AoKr	10276	3NKzyYhNQUidd6YwFkAzhdRP4juXvcaePN2kWxmg4HhUKfeatX4s	1407	1395	139	6301	6756	jxUR1auayGMK8vNv1k8uUGjHe4FRxnLavuunqUi79rEtf5Z1ywj	5320	7496	7496	1617288480000
10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	10281	3NLo4ymEDnybcX5f6TjBBm1EZEToT8NoYqw1Gv8M3rS2dxm2AoKr	1406	1393	139	6301	6757	jy1yCkvVj5QP4fk3jvaiFeruorLuRcc8GvCr6ynPNqEhEYFMuBf	5321	7498	7498	1617288840000
10283	3NKm95cr2NVmmk4BtDDKkkGXm9vHuyF6ZmcBd7NrsPbQ4UpWizHs	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1527	1047	139	6301	6758	jw8cPp11a1oVQ2Q3dMhLdnEQjAy3Hmr1vYtpeYRAUss4Jg2ivzL	5322	7499	7499	1617289020000
10284	3NKcNPbe5EcN5HMewFXa6vcY9cmToKYGBo73MKpKGTqjDH7QMJsY	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1590	1300	139	6301	6759	jxGzNKzT2SLa27gLEWfgFbnwW92PrggpsjnkaiPRRhvCiUjYXRs	5322	7499	7499	1617289020000
10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1527	1047	139	6301	6758	jxne7p5Jtr1kuJSAapQZXPxcNN27k4QFmT7cDcpDTH1MHrdfVFF	5322	7499	7499	1617289020000
10286	3NKYVwAgK9c7TogcRvBQFc4L7hCfHXMKXssvfJesTYqXBnJKfssZ	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1599	1041	139	6301	6760	jxGs9JHyPpT1U6LRQAtLgHpnDiTCmiK8Wm7DEfKKGMAeKHubi28	5323	7500	7500	1617289200000
10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1457	1391	139	6301	6761	jx5BvDFLRb8RuRVZVhWnGGyLog9bwDewyXfPKTVqzadoXAy6Sk1	5323	7500	7500	1617289200000
10288	3NLTWtSb7MLAjyGnVJCBQSk83QFxsewncsNf1HFt5B2vyLXg42DU	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1407	1395	139	6301	6762	jxtfFFf7B3sZEaVKyvNRssv5GVA7KMi1NgdFKPJcnv7gjWyUUCR	5323	7500	7500	1617289200000
10289	3NKgAwhVuYxQ5d7pCyRR1SNmpPt3DpSVivXpt7M4Lif38TBpmvmw	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1553	776	139	6301	6763	jxYQoDDvmpfsq2QuQJvjV517NZqFY4Q2p8CpB94cUqjpEshynSP	5323	7500	7500	1617289200000
10290	3NKpJEZZd7BR21oYGgiXQR31PBmKmx6pVtE2x5c9yoLaivsaVx7g	10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	1403	824	139	6301	6764	jwyypF3QSEJ2tM3e1fBzRtvQ8a1PuRrLbLKzpvjArXNWyoyN54h	5324	7501	7501	1617289380000
10291	3NKHwa8ZubW8442JfJxt7onoutbnn8GWrxXhucGSmK5YSkqTXRuV	10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	1573	1318	139	6301	6765	jwgLECibF6g1WPPwC6zx5UdAdajh8N6jycLykzxpLQYLY4wGtyJ	5324	7501	7501	1617289380000
10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	10290	3NKpJEZZd7BR21oYGgiXQR31PBmKmx6pVtE2x5c9yoLaivsaVx7g	1407	1395	139	6301	6766	jwobJA6TrGBBWv6jh5VKxDHdKtMekhpjuPZXNrFJnejeaqTo9dZ	5325	7502	7502	1617289560000
10293	3NLu4VxmLDJvHPoroYNhzkM3x61gwLZkUY9PBjNN6Y2pnSDGSsKZ	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1403	786	139	6301	6767	jxGkDuyx5xNJkt4wZceDFdbT8JC9z2QsrmFNdJbgz1nK85Dk4Jh	5326	7504	7504	1617289920000
10294	3NLAJE8BSfzvbEngZyHVjysxQ4Nj8an9t4JiKLTz9Fbm7d6CJP4o	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1541	1172	139	6301	6768	jwRUT6Jfi9fLBC5T6Nrk1racqmmnAxCpYA3vErwwLWGJAp6jLu4	5326	7504	7504	1617289920000
10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1581	778	139	6301	6769	jwByEYnwC7XswxWJM7piwYwgCZt78sc6jyscMttcJooCwUbPFuk	5326	7504	7504	1617289920000
10296	3NKcrxfEgKgCMrtvw3ajFLVHaf7SZdk1DwG6iohkiZyN12rqHWu7	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1407	1395	139	6301	6770	jx6oBnQiGgT17jCuZCMDdzhtCXeMSMgBytJLWfJLnSdVrKkMyi6	5327	7505	7505	1617290100000
10297	3NLSsDJFJyUmGULxrmqhLMhfcJ2FbP9VarZ2b6siMJ4v9RV4yTZk	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1403	824	139	6301	6771	jwJ6cHvckvCJcstNHwxwiEtF4hUkCWvgGjQutz5rX61zmX9DYWX	5327	7505	7505	1617290100000
10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	10303	3NLDeUNa9jaMuNsrKVc7W5czSK15EphURSQxTMeBnxutYL6ntKeS	1553	776	139	6301	6778	jxXNyGNxXNxdSWt4WeZY3346i8EyFzo6eC9UrEWdSVnEWmdx3iu	5331	7512	7512	1617291360000
10305	3NKfzAPgUvDLMPcwFVg6tTfd28qi8AnvU1gvZGfzXqywSh5Skrdq	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	633	1384	139	6301	6779	jxzHMAPGRJraejW9oSQA9SVoZxQEsHVSRGxJeHJ6SogLTu6vR4S	5332	7514	7514	1617291720000
10309	3NKJ6KLyL888muWjVGUpGwSa74vp6V8LaUaLhLujdZdb3wQUBZW7	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1403	31	139	6301	6781	jxS6dbXdyox9Z4tqTvYwPDoXebkTwdM6BB66es6jXJuocAuxtaw	5332	7514	7514	1617291720000
10310	3NL1MG7spLpVBFXkQpwnM9m9UvSmrh4RXJeqSpMK6zYSoGjWmNpZ	10305	3NKfzAPgUvDLMPcwFVg6tTfd28qi8AnvU1gvZGfzXqywSh5Skrdq	1406	1393	139	6301	6782	jwWzaq4MJuAvu5As8yWu3kEuyCNhXTzJFbZkTU8rUvWsPibdN16	5333	7515	7515	1617291900000
10318	3NK8bzDTLwnFnTdjedwKKC7srkbZSJ8ck1BwXuntFA5nLB2Vv3z8	10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	448	1059	139	6301	6789	jx94tfSjeEDNQhrn1t11FRvuYXUgv3NR8zmDXFPJFJYSifSpztq	5338	7524	7524	1617293520000
10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	10317	3NLYnpNToKogfSPTDsehSFEZMVJ14NhMw6mrwg989R1YKbir4kzW	1623	830	139	6301	6790	jx21jPvjNqGtRb2NupwnQjYfTLQNyBWwrgb3bwMLQVXV9JifAWu	5339	7525	7525	1617293700000
10320	3NKnXCDwLeNsbm2TnsajfZxq1eLm3JUyQMJ922GHqCeZRqaXq8zz	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1444	1135	140	6301	6791	jxCqk2nTMSUaSo75TMSSUrZPYACNfHCTmj2zamvEnJY3Bm2SH2b	5340	7527	7527	1617294060000
10325	3NKtLq26RtARCmjsU9nwo7JPk5PbBHBJerDXDNsBen5rnHRaGbxp	10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	1646	1108	140	6301	6794	jwkJ2CBjTnYw1NvgDaeGsSHRkzdQi1yaKt6NGQsDyxxaoBiFisH	5342	7530	7530	1617294600000
10335	3NL6SfuKxPpNEHUVttzHmruZ7fMTEUo3vfa8oxhTuwAGMrqzsQcy	10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	1403	824	140	6301	6804	jwNNy6rq6jv4s7aUgGLHmUisWHCQQm2Gus1VsaAizCMrrNAPXQg	5349	7542	7542	1617296760000
10336	3NK4pDTCwJKi9LdkYhSk1DqzJfC9BQA6uMWZUQ6Eq5bo3nM87M95	10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	1422	971	140	6301	6805	jwUkWh43oFYLGuoyvMqpw6hKrfjTHtPeJN1KhKT3qUdjbTVgSuy	5350	7543	7543	1617296940000
10342	3NKTYFCkrQNxkPbV2UstbYR2YeFLoErNxeMyb5hqTQpdhNEXrcEv	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1509	954	140	6301	6810	jwHt4hfzPUy2CqJaYY9PyWemZXK2GRbtp3pA1WdfVTHvNLdCGWK	5353	7547	7547	1617297660000
10348	3NKZciQVVgErpBxZSx5BTx71Nz924Box66UvBhjvoY7utPd4n2Zr	10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	1637	816	140	6301	6816	jwVzhuGusrBnoEMmBSp8XM9WjdJxsvr4Xqfn4mh6hGYCeQTunXf	5356	7552	7552	1617298560000
10354	3NLX3fZ7vDq8ofVaQvPMUpDAAu9rAEz8rpUsW5dans33WZaUvAD7	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jxvBcLB6iFzo5FmdUjY4H8bTfRPngnDBxPWfEr9tvwbFGChFPns	5358	7555	7555	1617299100000
10358	3NKwg61TwbEn1CKNdJaxESukWCh1SvmWimZuwLfuBpq4mtLj687W	10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	1588	1026	138	6301	6824	jxtPRK1KVe46vjgSXah5UDcx3556EnJ1M3H7PMiri64sQPiuEp8	5300	7556	7556	1617299312303
10363	3NLDh3PUsRPchJRaBkSUWvAADAPi3UgqnbVSp9MEwYMpRjmntcKU	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1588	1026	139	6301	6829	jwEoNK3t2YDduUUMcmpJSVRX89pTmGdFFJQig9QKD1WYi1Zarbo	5340	7556	7556	1617299409142
10369	3NLydQnFz3yqK6JRqEbQ8pYeY83nvc8W4Qx9knGTYiDzoMBr6R33	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	1647	1056	140	6301	6834	jxZRevDtKJLBg5BqXVxg881JjmmRowsv7wrgwSkfmTn2PDaxEA2	5362	7561	7561	1617300180000
10373	3NK7myZhKu2DXc7fCqQWa1za39LS3PY9V9v3FrRxjKNEMiN27ccA	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	301	301	141	6301	6836	jwxF7wgs9AQxZCL95qfxq3FZVX9iXqR3sJMhCMpUpZo2dxGWGtC	5363	7562	7562	1617300360000
10382	3NLay3YE3efeimrm7aYH9goZAcK6KigeKCVVQi4Rqy8XsHGnoFYV	10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	1553	776	141	6301	6845	jx38vkgojDdvQ6EUgLPtR1d4pMvTN3AHMGCrio1ncN9tioVHvnt	5368	7572	7572	1617302160000
10388	3NKvfuMdkNnnZKpU8xL6RmCC6Ffw27DuoCKLS2NmdjqwvhKt9moJ	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	448	939	141	6301	6851	jxdYzFg2RDaBnsrCQzKoMuRTNmYD71zbHFJbs8tyiRwHUa648tR	5371	7575	7575	1617302700000
10392	3NK6DgbdWDTwSNgHaXf5gHy8SZwaGLkS3P7mrxEBXATbJ1CauFxc	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1578	1296	141	6301	6854	jxMS6cLLHEBCKcvxn5VPLbmTdBCBs6zK1kGjnPhVBXR7FQBV237	5373	7578	7578	1617303240000
10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	1471	1260	141	6301	6859	jwTJpahNh1nrh2rQhYoFrYxGMLt4queTbTRtSYNWe72hZWGxfm7	5375	7580	7580	1617303600000
10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	10403	3NLrBmZJxrzENxTgEUC8Tv7spbSrvHgKhHqsyTaPFd63AyhtCzkD	1615	459	141	6301	6866	jxABux9y9DecFDQzroFAso25JNHtyyQ2FoEPhYHuwz9xN9ddXEw	5380	7585	7585	1617304500000
10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	1440	1251	141	6301	6867	jxhBCLnWDhqb6VR2DwQHyGKkqBBfXkx6QFWnwygnzzDDhZZ6pYS	5381	7588	7588	1617305040000
10406	3NKK8uF9GV8kPhXx2Xove7vgSmapVoStDmn5vHkCsRS2mVSJ4yPp	10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	1634	1331	141	6301	6868	jxymrJCvg4N41iZnCfbuqChE2o6Nmgko8PMtndgi6BXwk89RmcV	5382	7589	7589	1617305220000
10413	3NKurFu8PnhyfNHmaB5r8d4RiDNs32MwCnexCifNJDV2JgjCSVeD	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1541	1298	141	6301	6875	jxHjGb5K6ZkA25EvLzEgFB5qQ8CBq3hsVDWnqpst92xsj8oAZ2f	5386	7595	7595	1617306300000
10415	3NLxcJfSk8ti9RK9jjGdcb4G2yJynE4cAw4ipt1yB7FRjRkDwHJe	10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	1622	1356	142	6301	6877	jwQ6CyuurMM8wN6n9NCkFVFQZdphUpSGdG1CJtF24dLkNBfY9D5	5388	7600	7600	1617307200000
10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	10425	3NKHVvb55fK92PivE5e1PZ3qfweJ7r42aPxWR636AvvsTBaFRN5b	1477	1350	142	6301	6888	jxugGsUAN52nPTfRuFwK7XzHFB8saXivaEAdFN385U15EtrBwu7	5393	7608	7608	1617308640000
10427	3NLFr4zDxPBQCby63bgz5zm7Pj1rgjAMbt9E5MknSfvsuUu1RZVW	10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	1490	1274	142	6301	6889	jxQU5q3vF1QngRhtKceRpAAUSnYqCjCY3F7ztkfFnM4oLcDf18s	5394	7611	7611	1617309180000
10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	10428	3NKiYxgemuVdmikdAEzydsaME7DnxRPMRvoHprhKh7PJh6yGcQV2	1407	1395	142	6301	6891	jxNboLaoTeGVfMdvRXUQky9JfQgDdfBWBj83PHgxg5R6B9rXYMh	5395	7612	7612	1617309360000
10449	3NKYcDpkrvD4gucoUxN3Kc3L4YiN2Nvy3KbahZfSZaqa38ak2GBs	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1646	1354	142	6301	6910	jwdVRqUZE9aNdN7tumEunSzdPCKQjfuZU86He44DNjG4A2Lg2Vc	5405	7626	7626	1617311880000
10454	3NKHrx6KuFYwLAwE3FchfhGuC9WHVms6RA3X6DVGK7r4mAkfVcVE	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jx141PrA6LEyNk8Ufbj5vmfktem31PUhEFxwnMk6w9Z5MTB2EJM	5405	7626	7626	1617311880000
10298	3NLJHWea4dmUZAX3Xz6JEsA4vcZVVwKCkL7i24fN9cD2up9BNyWx	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1406	1393	139	6301	6772	jwfPJQbJpnF7tMyra4hpJpQt3xdHJDZ5UeT48GW1BS6XDAtEhE5	5327	7505	7505	1617290100000
10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	10297	3NLSsDJFJyUmGULxrmqhLMhfcJ2FbP9VarZ2b6siMJ4v9RV4yTZk	1593	1100	139	6301	6773	jxNQqi59Wi1D44a9ko3CAEnQxsAxwXizENYRoNgSDdLr7zn7DqV	5328	7508	7508	1617290640000
10300	3NKVsS6v8LqVei6QD356HAgR9XGsWeibanb2wVueyPJcThwWBp2U	10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	1460	511	139	6301	6774	jxr3VbQEt1wBYVR3BFNEJyQ8yrsuPaBF2Afxn3qMkBtzGsYzN3p	5329	7509	7509	1617290820000
10306	3NKfBsESuKaabd7MVzTgrQeoVfQL1F53UAe2EikXoDXgr71pS1PT	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	633	1384	139	6301	6779	jxdDBgr6x7kHJieDpWa4DN7n9gd7NpJc75bgLPZc7Q756tgXVvb	5332	7514	7514	1617291720000
10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	10310	3NL1MG7spLpVBFXkQpwnM9m9UvSmrh4RXJeqSpMK6zYSoGjWmNpZ	1458	1077	139	6301	6783	jxjbhhGt6As2KRw8wNiEjuY8jfVaARWWwWQ5Q7AoSR8XZqPJAb5	5334	7516	7516	1617292080000
10312	3NLWeZuMvGnyYcYHzuMzv3xm9rZteUPx912kqR27kqbhsf5BWBLV	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1483	193	139	6301	6784	jxhiNLMQ1ewt63QxwDEkeFKKEDgZAnmThZZuraYaLZ7n2mzcFDv	5335	7517	7517	1617292260000
10321	3NLt3WEYazTo9XjKqCZjWRkozR7z6oz8dCBPuY2ixDKgNG2RctW7	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1560	925	140	6301	6792	jxShtKXQaQYC8rKnFD7WfkiYEUCX1dvw7WPua2rs3cA6gWK5UuK	5340	7527	7527	1617294060000
10326	3NLQ7WERq5WN6A61B8ixi6pibyb2FMandwPW5NoNSEnpp7pGjG49	10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	1477	1224	140	6301	6795	jxywNsF2uhTrpcmFzzPK113kF9k68FkAHva6EA8zCCgB8Xf76fx	5342	7530	7530	1617294600000
10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	10325	3NKtLq26RtARCmjsU9nwo7JPk5PbBHBJerDXDNsBen5rnHRaGbxp	1405	851	140	6301	6796	jxa7g4mTdvt5fdM7h75DymvBiMxnMvb68yxybL4UTPeVMi7PcnU	5343	7531	7531	1617294780000
10337	3NKyvTqvpareYqnf6rX6F51WbbdkPqigcz27PrNsdqfzUa426TXR	10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	1440	1377	140	6301	6806	jx9tD2pve6zFhALEYCwuMrCCu1ADt5KRoLrKQsHAn8b5nEpvWZo	5350	7543	7543	1617296940000
10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	10337	3NKyvTqvpareYqnf6rX6F51WbbdkPqigcz27PrNsdqfzUa426TXR	1627	1385	140	6301	6807	jxynpXhx1EttyUWkvpPs5gNuQxgY7skTeAmPxqtRnLqwgCbjBkM	5351	7545	7545	1617297300000
10343	3NLpWejJXqUAyoDZXA7EyJtSoaw4v2hsbvouGEfHHmYD2eBdULrv	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1405	865	140	6301	6811	jxHsoE1kb9bY87rt1LSCwtqsqMoNPnCjspFuj1w6W53ygSqQPLZ	5353	7547	7547	1617297660000
10344	3NLuB5fmSGbxUiHHmBve9xt68K9HxuScrH67FtexxTGCLeXvK3Xh	10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	1403	31	140	6301	6812	jxz61v6eAUpECjrgvypqsCMgZKYYFZgp6KPX6byeEKY8XzaP9X5	5354	7550	7550	1617298200000
10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	1406	1393	140	6301	6813	jwamdrJA1tKyuFKDEbqkEAFTbrazYDoAk5o2JLQmmFmpVkvXxLz	5354	7550	7550	1617298200000
10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	1407	1395	140	6301	6817	jxCjuFeZjD1AMnkCGtL6k1NdNqXXgLkXdDNt2bDZQ7372gs6H8f	5356	7552	7552	1617298560000
10350	3NKLV1XdyQmLwg88XzSrZx5L3xqptEKrZEayqAy8f4rTTTgTmHM1	10347	3NLJHZyFkQGFduhmr6ghnLXN2DNJ1WC2Kwh5VmhVYWk8i5GQDcEd	1631	794	140	6301	6818	jxKnJBstuUn9EQSC1QdBLUb4JDS51jpXx5rb18p7xvfeMNcrSVP	5356	7553	7553	1617298740000
10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jxUSksKQKciRjYzoxzMs5HrjDR9SmyZfMwsMggaJFJsUYzzQBUU	5358	7555	7555	1617299100000
10359	3NLBbx3ALCZB4atVx3DvenpjRruo5tPEvp4dsk3cTSGFZN1DYsb6	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1654	1340	140	6301	6825	jxByCbeRMtjjQZeBGk6yBbsRdsWQnYBLwr9kRzhq39NwpY7Fgrk	5359	7556	7556	1617299280000
10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	10359	3NLBbx3ALCZB4atVx3DvenpjRruo5tPEvp4dsk3cTSGFZN1DYsb6	1423	559	140	6301	6830	jx6dFdkyuc6caHC42hBQFu5MHihXbPWTbDFB9srckDoRUxKG7cq	5360	7557	7557	1617299460000
10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	1503	1277	140	6301	6831	jxW2nagMfZ5q844B1iMgpYU5fP6e622QKHMbPeuMeoEC4SmqeWk	5361	7559	7559	1617299820000
10370	3NKvjrXRzNEqYp1R2hCCaEhCCa7taVUeB24tBDgJZ2AaHKngAQex	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	633	1384	140	6301	6835	jx7cMUfuzWUZGwe9Zra5DZEmxsVNtzghVKov97Eq4kt66RPLNNM	5363	7562	7562	1617300360000
10374	3NL7wrhqedQF5SNSBid2rkf1afRPEDVXgMVKRThPENJY6hwUX9Yw	10367	3NKkWM9nqkkJdWKyVDhHQLNf5UMgHQFvvjQs56zujpzkysxuzBdN	301	301	141	6301	6837	jxyVHj9fpQ5reX7mL3okT4JUWU3bZ2airBJy6fS4hdqHZKFrFC2	5363	7562	7562	1617300360000
10375	3NLnGU5pbfXx5yvkqiEMTy4kfVTnEshcy9TaNcTe67RwgwMwhmXE	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	1581	777	141	6301	6838	jwkPhyN8t45nqFgevjYXHaD5H2F2PZbKbKQq76hAGY8fEGPeZxd	5363	7562	7562	1617300360000
10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	10376	3NK9XgWJ42Q4Rv3h4sg3X9p1ci8FxArBJeWZsBB1M4qrFBvy4D8x	1553	776	141	6301	6840	jxLLbsEJzs99Mg1JZvtGcALcqrybrsiUYHa57j7bCdovpZs5Wop	5365	7568	7568	1617301440000
10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	1657	1344	141	6301	6841	jwh1MxM8Sk8VHXuJ3KCRz5qc1BVrTCPRDJdLqPCMhPyHXShGdTQ	5366	7569	7569	1617301620000
10383	3NKXp6EjDuozcqD2YMZu6U9Kw4n7TYNoF85nsawAeVeB5MSzQiyS	10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	1406	1393	141	6301	6846	jw86gtk24MTbqhTL71vXZi5pUXAVHtBeFcnpW5kezTadGVVZADV	5368	7572	7572	1617302160000
10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	10382	3NLay3YE3efeimrm7aYH9goZAcK6KigeKCVVQi4Rqy8XsHGnoFYV	311	941	141	6301	6847	jxB3fbhQkda6G7u79pcK9Qcg2teHPc4c3QsLP27N1uQJdmBBX5Z	5369	7573	7573	1617302340000
10389	3NLTUJhHzJ45V7xom7U499gyQr1di7YF2uHGRSP2rMjFmB9aWGMu	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	448	939	141	6301	6851	jxBFZVWz9QZpDEwbVgNMBaxW3fKTPdGKSKCYcbYgvdtc8uoxh7i	5371	7575	7575	1617302700000
10393	3NKmTS7Bw8eSikotFRMyTksWKDupuYBattBGWXBSyh7DVUbae89C	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1483	893	141	6301	6855	jwQ8uvygUAPY2YyWSkHYRArBFTQipiSu8Nu5Um4sLChvtF32oNt	5373	7578	7578	1617303240000
10398	3NK9uCyNRXDyW167UCy7BBrdfap6vPKuDZWZRrT9tvfkMyviKbW3	10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	1581	778	141	6301	6860	jxXMq4n9LewGJ3B4Ynu7N3udZTeDp9Aaiwq6Mkh1BEbWrShn4Wk	5375	7580	7580	1617303600000
10399	3NLU7fNR5LysYuAdqUK3HgxMSGXna8Ym8YRYRFRWgEgh2kYi47M7	10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	1403	824	141	6301	6861	jxhWvz9FhenGdHtxigB74nfWkSkjyHJHu5nVuB5J8epHYmF3Qhz	5376	7581	7581	1617303780000
10407	3NKkA2Hd9SRDeCWmKNLgwAtUkAkd9d93oxasaEMZHBPK4yytU4qt	10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	1419	814	141	6301	6869	jw8NGjZdRdoUHGtaC7jtqQYyp8htHAYV8NAor1qUCdSMpYEjiZ9	5382	7589	7589	1617305220000
10301	3NKkmMxy5Pm4y9rYR8dBV2W2rRgtV7LtykHshQvBo3rvYesVfBKb	10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	149	1283	139	6301	6775	jwyPPenuv2jqT2TQx9dFmShaNcjNxsT8hXeWmTEvgzsqfmexVqJ	5329	7509	7509	1617290820000
10307	3NLQEHZ1MBtVd4PpDwXBiXifogQ9FM8Mg7vb8KyeNU3qGXG29Rsi	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1602	1369	139	6301	6780	jwDnChFiDgGi2ujRrcpfntJF4YBMhDwjzJepXAxHqx4Uhc21Jap	5332	7514	7514	1617291720000
10313	3NKfcY6B7dgNWpiB1JeQ4FfBDzRPnNnDnJC2z3Nn4wJX3DxRM6tz	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1577	961	139	6301	6785	jxnKtBf4Qcigqx7p4AyWcxTpxPF27VBZJahsw37wonbBWzh8PaB	5335	7517	7517	1617292260000
10322	3NKokCC5gpVDVBKMpGZxazkCddSfpHtWCjwCPJYeXn1DeMAfedqJ	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1444	1135	140	6301	6791	jxpwnkMaUCkprGpWpkSaNbjWMBN2MF48mYCYwsqxRNKENtSdi69	5340	7527	7527	1617294060000
10328	3NLWtnNUzTL4RuGh7w216yf9ASiNSN3dZr7t3UAdCUEDpNTkyvWd	10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	1559	1227	140	6301	6797	jxnmCjXmJAzZpNu7VcaBzxH2muc1pshRuTK3932S11CMszPeXir	5344	7532	7532	1617294960000
10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	10332	3NKtderTbJsoBockC1MDPfLyb8S8xJm6GBxPzj6bE5njvuwnTygC	1671	999	140	6301	6802	jx9ZWJkWDzbKSK1udxYQwhZBWk4MFTWoYtvonTnBkMhAmM1b2p4	5348	7541	7541	1617296580000
10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	470	1063	140	6301	6808	jxb8tXpRg63dJo26o5Awh8Nz3UD3DvVdyNnGhzFZVtA2Z2kYpWz	5352	7546	7546	1617297480000
10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	1553	776	140	6301	6814	jxnS1F7fsJiEKtmaWTg8E9Qma31gXTVELbjp9r6NM5wD5H2MFCY	5355	7551	7551	1617298380000
10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	1549	1362	140	6301	6819	jwbfPTGB7pMFBHGAX8hy7wSvHS1kab9zJhWnY881DqHyHHXGZii	5357	7554	7554	1617298920000
10352	3NKVtjQDvMxZfVPY2Ty1UfZJhyweeDkWfENFmeyJ4SfLFWq97S9M	10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	1406	1393	140	6301	6820	jxBbMgwXkayUhTPC24U2VjJx9uTV1V5E41BFjierMULHfBKtnPg	5357	7554	7554	1617298920000
10356	3NLidbiiduNNXvDaP5ZrCrsZf3nZN7mjyfVPEiU8hAjX9SetFpsW	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1588	1026	137	6301	6822	jwY7qHta23jREQztZFiXB8ZWTEWRgvUKb6hPZQWBULquDdGHX8p	5288	7556	7556	1617299280000
10360	3NKwsYqwwLwo1LbUph9XGpRWG3kTxcapL4ALS9DP6dGJjUJm8ewq	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1534	1317	140	6301	6826	jw8PYPPpkMU45XvaNmpN4Q6SEqC9nQefcXr4Aqs1K8RXLECBCah	5359	7556	7556	1617299280000
10366	3NKCermFEso2zwaHVpWH4Mw7gvHTexNm96KYkwm3jBdAWGe714e5	10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	1407	1395	140	6301	6832	jwn8P68VGkntMBbRsdzwrFxGrYR128oZtP7aqNkNGEZyiiJiMCS	5361	7559	7559	1617299820000
10367	3NKkWM9nqkkJdWKyVDhHQLNf5UMgHQFvvjQs56zujpzkysxuzBdN	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	470	1309	140	6301	6833	jx7NgEBiuiWPPwYobgpo4FDGpjgP77C3KstiWMDZPKyEGoVEQK2	5362	7561	7561	1617300180000
10371	3NKF7Fe4YiuyAgNGpMSKNiyhF49mNguZE8TYBYUcrKAzYVMJeLBL	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	633	1384	141	6301	6835	jy2xUyr9vhrNJUgZCmNjDi2miF2PDReCNpPA7bfLHx2inTQwZSq	5363	7562	7562	1617300360000
10376	3NK9XgWJ42Q4Rv3h4sg3X9p1ci8FxArBJeWZsBB1M4qrFBvy4D8x	10370	3NKvjrXRzNEqYp1R2hCCaEhCCa7taVUeB24tBDgJZ2AaHKngAQex	1564	1338	141	6301	6839	jxPNCRji5KBy6uJnv9MbDFHvYtkgUf49D5sQm2kcC2a31BL8B47	5364	7564	7564	1617300720000
10379	3NKLUxceLzQg6frXmWQzzEGPmATWvigmeoZVfcvKTHecv2tCKcPG	10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	606	1169	141	6301	6842	jwMiyZtkWUrJH2eEnYk597LT8QLcabVLZ3frquGTNHZ88wpYAdE	5366	7569	7569	1617301620000
10380	3NKoLMkkoVNJZy4pDTYxoZVgA274p8mJRAHsGssPVQCKiBNpAfjW	10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	1402	850	141	6301	6843	jwLqYv6p1toiCTWzGdApiCpzMFs9jeZSGSAkBDbeKmx2xsgFL9E	5367	7571	7571	1617301980000
10385	3NK9Bebpfrz9o1asL83P9xb4Qf1rGmogHWbPAvMeTCrW9a8Yriui	10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	1536	1313	141	6301	6848	jx7EehzUNUWz1t9U4nJk77tZCW61RKG5E1Df3eHxSFTSMpdWS1f	5370	7574	7574	1617302520000
10390	3NKZayvxyRT1c16WoYE8RbSG3Y2xQmeEegM5PPw9wrFzqunxP9yW	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	1607	1102	141	6301	6852	jwJBdj3gP2kvicvZSaEjTgyLf2iWUfdw6cgk8cGmKYtV8AGRmjh	5371	7575	7575	1617302700000
10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	10390	3NKZayvxyRT1c16WoYE8RbSG3Y2xQmeEegM5PPw9wrFzqunxP9yW	1536	1313	141	6301	6853	jwgyf2Q1rmAwZ9ZMEbPmQ2NbNmAGPbaTrVC2F2GJSDZ73AuU6iF	5372	7577	7577	1617303060000
10396	3NLKS7rAkfahWbjaNVYN8F76hMhh9xBbGLdzgXuikbpRGx2QRvtk	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1631	793	141	6301	6858	jwWAtRuWqtwyRtSx9ppfFWTK95q5FW5WWHp3XUEqo6QXMnEZfcr	5373	7579	7579	1617303420000
10401	3NLwv7WaJq8tiPZeASuGVXFbTXeGwTDeLhghk1JNDTX3qMurj9R8	10399	3NLU7fNR5LysYuAdqUK3HgxMSGXna8Ym8YRYRFRWgEgh2kYi47M7	1624	1334	141	6301	6863	jx4jAcHTvbGNhdMKTHA8y59GX6gnFG7es88bvfnDgG9DW6UhC9m	5377	7582	7582	1617303960000
10402	3NLVRBZBmJQFLw5NqGWWXp2hNKjkxHqtLXGzVpKxUDjAr8PWmnTQ	10401	3NLwv7WaJq8tiPZeASuGVXFbTXeGwTDeLhghk1JNDTX3qMurj9R8	1476	1125	141	6301	6864	jwe7NWGc1yNoySpKcexBYdv9gMzDJV3TD49PzBjcpr8Hke4XACm	5378	7583	7583	1617304140000
10403	3NLrBmZJxrzENxTgEUC8Tv7spbSrvHgKhHqsyTaPFd63AyhtCzkD	10402	3NLVRBZBmJQFLw5NqGWWXp2hNKjkxHqtLXGzVpKxUDjAr8PWmnTQ	1406	1393	141	6301	6865	jxU8VvdQYZnCjh6h8iJNxCGMLuyqhvvzPpUqs41tuVSqbiHMdbt	5379	7584	7584	1617304320000
10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1407	1395	141	6301	6874	jx7aDyXGZTXAVDeThaw5fgvQ22V9FZAwjTUMJWe1X4xdurWniSZ	5386	7595	7595	1617306300000
10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	1581	778	142	6301	6876	jwawMK3weFdBY3sZtUDTWerHtcJ3agwGawAsSb8uucZ82TA3cRc	5387	7598	7598	1617306840000
10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	1406	1393	142	6301	6881	jxDrRZnkCAYoJhPgT2KxqkvPE7Y8uAGxDFN9sRSopmdccCX9wbG	5389	7601	7601	1617307380000
10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1426	1364	142	6301	6882	jwBoVXs2DzXCXJznSdYQ6ryrBUyW7qP288xoyXBLE7FxDAoHZcP	5390	7605	7605	1617308100000
10421	3NKZN6FRjHxVmUe18qmNkUz3q1rhj8GnspaJPQpK4XU4nnTkLdeG	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1646	1354	142	6301	6883	jxX3u4EPzQMkrVoaYWx4pQBtEsNUETeuZx3QrZVvMEAFKcHJgoX	5390	7605	7605	1617308100000
10423	3NL7ph5y6ze6rAftiskXaREmvPop7mXNzeKDeqxgHB7oHihdvam8	10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	1407	1395	142	6301	6885	jx5Got9EMaTfgMt5ssHfTvYjNnATirRys93D3BxPvXx52XpibRn	5391	7606	7606	1617308280000
10424	3NKwSvhWjZuuKwE2KqDjxfgEWHDdWe5efbAVJjsmuBiHJkTcaBYj	10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	58	1035	142	6301	6886	jxcXNuWA5HLBLkj63C77mmjhwZqY2PDpHqvjWZwdKaqdCsMSUTn	5391	7606	7606	1617308280000
10302	3NLUkFSz3aupdu4Pk68cigEe1ShS3CFRLmDw69nqbuGwyyrUK8ts	10257	3NKoQhQqo2Bb11CitfWg8MQS6GDLfVHHUT68p3ECunFABf9LbFaN	1637	816	131	6301	6776	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5178	7509	7509	1617290820000
10303	3NLDeUNa9jaMuNsrKVc7W5czSK15EphURSQxTMeBnxutYL6ntKeS	10300	3NKVsS6v8LqVei6QD356HAgR9XGsWeibanb2wVueyPJcThwWBp2U	337	337	139	6301	6777	jxgTCbSUCAZaLrD8gD77ENfnXoRvkKDuJDrfsdj1iSwqd75MqQ7	5330	7510	7510	1617291000000
10308	3NKv5gmiTJu5dWvgBsQzn6K3wpudeSHpE6QsUaxCgeCWXcV4iFjk	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1602	1369	139	6301	6780	jxjKn4MsPaXy3xQtBPTLB4i7qg6AuKGUb2tNGmSEsWwU114Fgvn	5332	7514	7514	1617291720000
10314	3NLX6bgLMwrhJ4HZvaAdUjLTKAR8ghZhnqmEQxZGeYxsEKjgSDEr	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1406	1393	139	6301	6786	jxU9Bxvm3GL6RxtRgas9BFnGRdsaMGH2ZaQFFwRq79oMnGPvj86	5335	7517	7517	1617292260000
10315	3NLkZJ3NCnPB35NHpqZ5cSZt7dsDaJkvzFoVjYb25C6uH9c66otn	10312	3NLWeZuMvGnyYcYHzuMzv3xm9rZteUPx912kqR27kqbhsf5BWBLV	1403	824	139	6301	6787	jxsAKssW7X6HFRuBXEmukiQXzQjRoQYHVxcyLRd3KQkpw6TaqCL	5336	7520	7520	1617292800000
10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	10315	3NLkZJ3NCnPB35NHpqZ5cSZt7dsDaJkvzFoVjYb25C6uH9c66otn	1527	1293	139	6301	6788	jx5kQpPD8VrPDXPTe83LrTE1QkVo7xNHtKTuGUpYpC1U2WbqiU6	5337	7522	7522	1617293160000
10317	3NLYnpNToKogfSPTDsehSFEZMVJ14NhMw6mrwg989R1YKbir4kzW	10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	448	1059	139	6301	6789	jwV4cEVDVmWfZRMDJmvhSsy5eamXwyreqLhN9JkefXjSHg2husJ	5338	7524	7524	1617293520000
10323	3NLVTjebRtxQri1ZiHySY23UD5buAis8LL5FyKnAHEZ8ar1g5rqi	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1560	925	140	6301	6792	jxLYPPYJkQ5F5QStNAA1Ld1igze6WQBUr2J3Pv6CHUJLwZ3o6WE	5340	7527	7527	1617294060000
10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	10321	3NLt3WEYazTo9XjKqCZjWRkozR7z6oz8dCBPuY2ixDKgNG2RctW7	1406	1393	140	6301	6793	jxEqEP7u9ZgdPbkb8fxcrppWR1joe3gs6hZwPn9jeYnPGjRsSX8	5341	7528	7528	1617294240000
10329	3NL8ndGDoAoLefDNb96AkVYjHWHbdsfNKArojjCukpxz4GaZcJKa	10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	1406	1393	140	6301	6798	jxVt4jrpMbf5ReujTBkJXmB1bWvzhsQTSSGgAFK5cxZcqmrzXtp	5344	7532	7532	1617294960000
10330	3NKtvU5QDcbVKhWkMjs8ZovgwtqJqeWycBpTTA3ww7uPjULzShMo	10328	3NLWtnNUzTL4RuGh7w216yf9ASiNSN3dZr7t3UAdCUEDpNTkyvWd	1403	824	140	6301	6799	jxLVeaU6so8gB4MTqJj4ACcFrq8iEDK14iaNzyrB7YmtmLVKdM2	5345	7534	7534	1617295320000
10331	3NLiP814DH8VsqacagWNY2cn2r1zw7shpNwAAjqcdHSwGGH1Xta4	10330	3NKtvU5QDcbVKhWkMjs8ZovgwtqJqeWycBpTTA3ww7uPjULzShMo	1637	816	140	6301	6800	jxJVWKh1f31xsSGKLwMfhtwneRCM8v5Jxn6cTifad6JSCscmKmm	5346	7536	7536	1617295680000
10332	3NKtderTbJsoBockC1MDPfLyb8S8xJm6GBxPzj6bE5njvuwnTygC	10331	3NLiP814DH8VsqacagWNY2cn2r1zw7shpNwAAjqcdHSwGGH1Xta4	1483	399	140	6301	6801	jw9oC9bnrQ9MUoA4hiJpTNdVvZETbVXJUnHons7cv2N7WqEuJKX	5347	7538	7538	1617296040000
10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	448	1059	140	6301	6803	jxsDedXk9Hn1N7oUg7M12CCoHYRKus5qiKH7NZCF5WEdGyerDcj	5349	7542	7542	1617296760000
10340	3NLkbHMf4iH8byjrQr62n6nahFE2oJRxsakjA5i2Uhv6qtFULG4E	10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	470	1063	140	6301	6808	jx731Ky4hFtPNhM9uSEMD9vVQpY6AzvAgxCtqeG88kWLRimwjvF	5352	7546	7546	1617297480000
10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1668	1244	140	6301	6809	jxnG122w42LaTUkHVC4t2ee8Hu7TQ9CJopTrVzVhKNqPk6RKLYG	5353	7547	7547	1617297660000
10347	3NLJHZyFkQGFduhmr6ghnLXN2DNJ1WC2Kwh5VmhVYWk8i5GQDcEd	10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	1650	1375	140	6301	6815	jxEHcyAZygPi6Ph7JZxgenpPpWVAUqhhQnR7LzckmxJqsj5xGKP	5355	7551	7551	1617298380000
10353	3NKwcBPahjc2pFhRjFZKEUYTNv2zPKyyygfmGvsE1wGg8qD11Wyn	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jwXo3txXEsyumzrf5ZWvFnJnSQetunkA4HL37inydungvTVAoGW	5358	7555	7555	1617299100000
10357	3NKZrYSbt6Cx3UveZPj5wvpGnyEERSPmAMuXYMAuattPFYQswnxe	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1588	1026	140	6301	6823	jwXfnTUb3PosoniDJJ2F25jcxr7Ny875uB5pASXL3cnZPvQHdrK	5359	7556	7556	1617299280000
10361	3NLHmdub3dqn8gXwYwbmcdXX9i7H2RPLt9qTmtEUrKmWEXM1zT8v	10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	1588	1026	138	6301	6827	jxxdgjHnRq1FjyHYfCmPAGAHAkqbBck6SRtnz77iyL7sQabXaGu	5313	7556	7556	1617299343232
10362	3NLh21pd2UNsKVMDLdJTxqujJPC6SysUYjNt34bu11grimoq6UF7	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1588	1026	139	6301	6828	jwcZ1PXjTenPkW9QPm3fuacBEa451SnsRKr5ZjpqDWpdSo82UKS	5327	7556	7556	1617299376606
10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	1647	1056	140	6301	6834	jxZRevDtKJLBg5BqXVxg881JjmmRowsv7wrgwSkfmTn2PDaxEA2	5362	7561	7561	1617300180000
10372	3NLp5qRLbK7SdnVwaszChmtAj86LGwoSVhRZf6DM17EL2W2gypzP	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	301	301	141	6301	6836	jxr7Aj4Wf3pBX1oLvEvqWnr8pwRZCWnbfkmz9nG5NBoQnmrnpUU	5363	7562	7562	1617300360000
10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	1571	969	141	6301	6844	jwDbsuxF3HHXiZokwztMaV2fkabmqm98VXPQVCfHUyn7UGUjs2e	5367	7571	7571	1617301980000
10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	1467	1130	141	6301	6849	jxziowZwHpfkPCK3F2gWmkN1q7KYnoin5sCC3Yr9sUUrQo8uAp9	5370	7574	7574	1617302520000
10387	3NLJcxdxprpaQSnZ5isVzKwPMZASAryFBgtTWiVr6oUGAeEVnZm2	10238	3NLUWrxbjoWVRZrRKU3dfLeGVwjZoKwywoDzxFU8ajeCCi9bu6Ga	1467	1130	137	6301	6850	jxV15at7KE2BZMPsHDqgDbX7BwcMx8TKrRCRYYB5tfu8GEBDuEh	5295	7574	7574	1617302520000
10394	3NLZpGbfPweMD69aQe5YDgtiu6tS4vo4gRz4FBswmD7e5a9jwHJu	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1403	824	141	6301	6856	jwBYFu5Zgpvk2Sxro3dc8tAiW55VvkBkid7b5mrKQPkj5WgPyzz	5373	7578	7578	1617303240000
10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	10393	3NKmTS7Bw8eSikotFRMyTksWKDupuYBattBGWXBSyh7DVUbae89C	1406	1393	141	6301	6857	jwTq8GsotB3iSX4ZvSaobYobczJEjt51bUCgXu7bPEswnxTsqSz	5374	7579	7579	1617303420000
10400	3NKLsyMkBtjkLQan9NMGcDAybZn6y44u9FECAHU6pVM9iUDgWExk	10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	149	1037	141	6301	6862	jwq9i4nDA2dRveeGQW7nevGcqd87AWQoFjuRQXXJTRh9sHKovu4	5376	7581	7581	1617303780000
10410	3NL8JXYmj6U5e3kQbhKskRX9XHY61oa7khDZtg7JD5dVvpFCCZRb	10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	149	1283	141	6301	6872	jwsKBz4tXvwhBQfGSuYrzbNV4qGHrmzoG8vTCnjXbLmTUZWDrqJ	5384	7593	7593	1617305940000
10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	10410	3NL8JXYmj6U5e3kQbhKskRX9XHY61oa7khDZtg7JD5dVvpFCCZRb	1406	1393	141	6301	6873	jwKdc9EJD9XTe6ZTqks9fsVT3dzYrpvixXcUponpeFYe2DesaWm	5385	7594	7594	1617306120000
10418	3NKox3SadUw2mJpQuyQe2UQQAxfAahPZURNNPxnJCP6qrJxDGZvC	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	1553	776	142	6301	6880	jwEkn88rtGHBdmhsW76kLmbkpPJDBNHvLJqkhPR7ya46qAkrXqz	5389	7601	7601	1617307380000
10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	10406	3NKK8uF9GV8kPhXx2Xove7vgSmapVoStDmn5vHkCsRS2mVSJ4yPp	1633	1390	141	6301	6870	jwaPNDJ3u87BQfZ4ypLj6fWKuEPV7HgUyCYpnCvKDNMXv7gJ52o	5383	7591	7591	1617305580000
10409	3NLEEKMfDwPkbgqn9QT2L2XvPjPRNZ7nL2yunDVFyogRg3wkwJEc	10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	1407	1395	141	6301	6871	jxGZ3cBARRNTYmm4grykaJZHCLnZaxDUdHykVJGivcpJWtDS5hq	5384	7593	7593	1617305940000
10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	1402	906	142	6301	6878	jxSYQtjDtgk5S1Co5MytVjuwMK5C4iFSFQfLqYenbBAr2p16cvW	5388	7600	7600	1617307200000
10417	3NLkGhGHVfhssNuKmtuNEYepv3jbP4uoPPd4yYZpw51WiLEqaPBk	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	43	1184	142	6301	6879	jwPpp5j3uZoGT3wPEdfy7yZKND5RqqYq26gaWcxu4E4uHU84hXN	5389	7601	7601	1617307380000
10430	3NLnY1B6JGAtTUxC3SpMv98ScJGwEKzP9BFMw7iMRBUkKBtVd3bt	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1648	1038	142	6301	6892	jwkE1vyuh7G9wCqC6ZRJ7KVM9KXBQfbhbTnKHpYVe4a4FfnffWn	5396	7613	7613	1617309540000
10434	3NKpy9pEtwJVFZqmFbByCxJZ1Lk39kESvca2c2pc4YjyRpc7k7mX	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	369	1186	142	6301	6896	jxA7wfZfMemRY8mtji6B613ep5G1xvVUHteY2QmCavy1JeEunte	5397	7614	7614	1617309720000
10436	3NKvMWrPvZ356om1apP3qJLyVj7WG3PKc7TYKko3efj7RK74Ry9Y	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	1406	1393	142	6301	6898	jwwgvDiVqpvtZe8kkKfqFVxUq8LtU6qMRa4bAtuBjctfDdxmgGH	5397	7614	7614	1617309720000
10439	3NLyUYzx6NDuPY4dZQyuW3juafVQL6MfDm259sqeMsUBhx4uDtad	10438	3NK7DpHwJL8AhPUo9bcxmv9moCyR63LHZnPt53saNESHohyuSm1b	1654	1094	142	6301	6901	jxbY8QhAYJx5YV5gzCkmopmLywTCH8wP773bEwXe5AeUteuFNRP	5400	7618	7618	1617310440000
10442	3NKarYwKknTaWhgd8L7PZjuZ2jfzTafdmgNLM2UWhrRq2iYampBs	10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	632	1256	142	6301	6903	jx5v7debMZ9zVKqPLoc6pVS8ff86ECFsYHNwhadd1JVA1veQauq	5402	7621	7621	1617310980000
10444	3NLG2ghXvJjXbSjK7dCn3dgaevgmLPPViFzpA1epZQ4HWrUK6ebN	10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	1406	1393	142	6301	6905	jwZKEj6yWJK2tx2kbAHM1vz5sEBvfzu4564AeSWHy2o8bchn2hP	5403	7622	7622	1617311160000
10451	3NLgdofywHC7VfAjwvWiVbX5JhGyzr27nn52QcKDsEpAsYC2N2xX	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1406	1393	142	6301	6911	jwkmao21TFe8qucd1Bwa945FZ7mHfVepPGXxvEB1VFe8f319EqD	5405	7626	7626	1617311880000
10452	3NKBVeiAtxW6mpSFdEVsfnvuKpmbJEBZNLd8pddkXSxYZQQKjyTQ	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jxe7VEqp7qV73Ku82QqeGYd89jmk2iK7cY6AhcpiHFsNrLV5gPK	5405	7626	7626	1617311880000
10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jxb4T249eEDvkCT8aEAqU53vLDk34EFUqgM39W77u3fwQ8QiAn8	5405	7626	7626	1617311880000
10457	3NLMrQk2VY5WXCwcFiYvo81YnvZitrnFmMCQ3YkY2BEqcPqE7MjN	10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	1457	1145	142	6301	6913	jxVxKGDpdY8NM6ervAUj2nA6vtuyKGhxtos7RSTMc2GLeQnppKK	5406	7627	7627	1617312065184
10463	3NLEANgq7nz3i7k6euc7rxB8wrEUpHZSrssz4fY8ZPBkz4icgsCq	10462	3NK8uh1EbVDaGJS7ey89z2BHAHfWR72GMGq2KEg4hpqefaKTCKME	1406	1393	143	6301	6917	jxSzY4CCYKYLgJJX8HiptGBt8r8oZwXtgq5YWATNGnDNZxEuMMY	5407	7628	7628	1617312240000
10468	3NKiJ2DPqND99TYLm65v2X2CFPkoE3D5mg1LC9aQdTR2VHb3Ao98	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1406	1393	143	6301	6922	jwmZSNwAtyuGJ4fSgChQ3q6c4UZK8UmgSrTgvaUzd2NztURcsDX	5409	7633	7633	1617313140000
10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	10469	3NLf1dE695uJJcYrmiSEsVByzyF27w7XK6ncibvTmM5ifnttUbpm	1483	551	143	6301	6924	jxHCPyYQatbHgSwGjX7G6JzzQTnoy7kgyzMCgTtP1txaGE4k8Ak	5411	7637	7637	1617313860000
10475	3NKmxYBtB99uatpSCdxvtBD83YQeadz1gSMxuFfv4vEHp21L1iH9	10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	1650	1009	143	6301	6929	jwp1cYMcK9aiWUzzzB5hJZpirfdvQRo9APtBecfa7sywLZvHgAZ	5415	7641	7641	1617314580000
10481	3NKihxSoWVFYdoyX4ujW6cxjgKmY6C496AJJFeVUjFXZzpRVwN8u	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1516	1294	143	6301	6935	jxDukgZqUT25wGUkKepN1edtbsUZZEPVHJyqmFunRSAWrshjx5D	5418	7647	7647	1617315660000
10484	3NKEJpu3yVLXYsFtGvaLjjyBUdki7JtAQQr8TrEFjDwgDrLcqnub	10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	171	1374	143	6301	6938	jwvZUpYDDr7vfdAHDeAfF6S1GkthtbTicGAF9YhAh296bycEahm	5419	7652	7652	1617316560000
10487	3NLQqURfKMyoahGXBc6kcYKwhrGn1JVvuux3Aw6xwFHUhHtsrHAo	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1542	1058	143	6301	6941	jwCdYad5QfzWXvyxHniwB8A8mHmj9Xqp6DBrDXqfgSenR7RhY4f	5420	7653	7653	1617316740000
10490	3NK3bb8xHyZEA6MzNxLCnLkfRMoz15hPsqaVzU3t6pX6cE7e2ju8	10480	3NKUTrWohXD4w5xPtR1MaqJt9LqYVbQV8qeKodK6MNBQAPsDvxsQ	1602	1243	143	6301	6944	jwgx3ENoEeKuCJvTbGib4KC7xzMHYsZhE52WdiNDiXkofXhY7DW	5419	7653	7653	1617316740000
10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	10487	3NLQqURfKMyoahGXBc6kcYKwhrGn1JVvuux3Aw6xwFHUhHtsrHAo	633	1384	143	6301	6945	jy3EtFht3g8JKhCw6PfWwNR6dMUHSfmeRQRy1JzCL1dwVWLU2V4	5421	7657	7657	1617317460000
10498	3NK5d65FT8xiB7GTnTf7P9ZKfbLj4zLRQpPrLVNFw1YGUNfav4wN	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1594	1080	144	6301	6951	jwkzGdZ7hmVsjgA22VTv18X97hV2Q2XX8CbbCHivye3jLhkqJTK	5424	7660	7660	1617318005022
10500	3NLDtN8ndVozjENHC4JjKBx3q75HH1dmHkDkuhH8NfdLjjGn66Si	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1403	824	144	6301	6952	jxNuHjam1LGThggjEFVktisf5ufXTP2DVyYMG3c8YiHomyPJqTi	5424	7660	7660	1617318000000
10508	3NLPFZwBuCVVndVUHpT87f4gJhtbszBneFmuzJmTYZxgeg8F5w5F	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1588	1266	144	6301	6960	jxJSzFbH297hmm78bnW5H2jjHpApT5ybCC5Sgx7k2g6AxWKyxqa	5429	7670	7670	1617319800000
10523	3NLXFQLASAWjs9waQ1eSmq4SFHxTLCRPhhHWyVfPVaBNRvtuhsyC	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1556	578	144	6301	6972	jwe8TpLcf3sEZNtHhem8EagCnEVajat8rN5KZdweEzUMZS9s6r2	5434	7678	7678	1617321240000
10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	1407	1395	144	6301	6974	jwoZuS4PVJzoi2zsVJyEDYeh5CviuPvP66cqHtdJ6k4mZaQ4rgm	5435	7682	7682	1617321960000
10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	10528	3NKfFgZfgi2XAWr338MdUrgP9BpD3jKT1NDYjysbQvxf6p382UjA	1451	1166	144	6301	6979	jxKzQsaKhpg9jMU6HnW2WwU1x8dmzSj4ywinKtFqpcbognCuydU	5437	7685	7685	1617322500000
10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	10531	3NKgEWPG8Sveb9Cp8h3pWiY1Eju9o6UmZZzWWX3NCmKViGKD8qjf	1406	1393	144	6301	6982	jwgiyywNKK9cpSjyhhzzS7QUmB9MaRzHFGLxkApJ6GsmQDHnQ79	5439	7689	7689	1617323220000
10538	3NLxt8T8GpSWjaSvT3RsKVW73WseUDiBsrXmiiygoKeVQMDeC9hZ	10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	1489	1380	145	6301	6987	jxR3RY1NdmxfaojJ8bcnuMaPasbUZFfAcgAEp9yMSUwVBtwcX5r	5443	7693	7693	1617323940000
10544	3NL32URFRoL9g6RzLA8hoATi7wunaoxp526bmEvhbSKw8MbLRVMd	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1622	1356	145	6301	6993	jxuCrSq3KcP3NzQybQB1EbENYUcfWhqH5Xiba1Jt1RVDDx3HMT9	5446	7696	7696	1617324480000
10422	3NKys5uxvV6c6jiget5qu6GSyYbE7rZM9w2tgPyXmwcpmA8CvuLt	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1403	824	142	6301	6884	jwbCiAo4y9pZeF6pBe56mK7n8eawZhPm1UVDVTQpE6jKsofxSzQ	5390	7605	7605	1617308100000
10425	3NKHVvb55fK92PivE5e1PZ3qfweJ7r42aPxWR636AvvsTBaFRN5b	10424	3NKwSvhWjZuuKwE2KqDjxfgEWHDdWe5efbAVJjsmuBiHJkTcaBYj	641	970	142	6301	6887	jwozB6AndxNH2g1XxzkdW4Tc2w1C6MtEWXevvAakxECmJSdKd7a	5392	7607	7607	1617308460000
10428	3NKiYxgemuVdmikdAEzydsaME7DnxRPMRvoHprhKh7PJh6yGcQV2	10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	1419	814	142	6301	6890	jxXJr4jxZgeL7aCyJsqPkU37vfE7rQQHF9emsPG6Fms5GLDk98a	5394	7611	7611	1617309180000
10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1507	1034	142	6301	6893	jxvdWWALndd5fCNaQkSsctcJkUpHBC6F4tuenkXRfU4zRwVaeNC	5396	7613	7613	1617309540000
10435	3NKHHD8jAc8BqMRCc8pYm8A8aFcwNreW3BWS1oYVRdqWN9hZdWD4	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	1637	815	142	6301	6897	jwU61iDqz9Uy4F2tRE6j6soFhtWR5YnHVYwKVvLy42U5dNKMBa6	5397	7614	7614	1617309720000
10437	3NLJ7h4AepHyriSV3fqK4S1dCTKp14JG7SV6Hb1FqiNfEdThPQ5Z	10436	3NKvMWrPvZ356om1apP3qJLyVj7WG3PKc7TYKko3efj7RK74Ry9Y	1405	869	142	6301	6899	jxSGTiWcMCMtaN7hfxowYbHKHhodGYVBap3HGAUdKvPHV5msEdh	5398	7615	7615	1617309900000
10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	10439	3NLyUYzx6NDuPY4dZQyuW3juafVQL6MfDm259sqeMsUBhx4uDtad	1657	1098	142	6301	6902	jx3yLyLjwmZ5qoXjYuNxZSzBcYqhAdh2G8uCr7DF3LGfMBrtyMC	5401	7620	7620	1617310800000
10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	1602	1369	142	6301	6906	jw8JQi1UrFbBmXS9Jt3P2w8QaReHZgkbmfkY7q22diEqWz1fcCW	5404	7624	7624	1617311520000
10447	3NLcq2s8p5cUbxme6LFv6bnaYu8Mam2B8HJ566wqftuo9ruiSGeD	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1489	1134	135	6301	6908	jwczzZefc9piPYrLjzr46qXoMfCKtC3NQ1f9cS8r6xLdKLUjDUP	5243	7624	7624	1617311520000
10453	3NKSPX6GruAnirooPi6Sefs5y6KCBtXQZjmw1uBeP2gGhTnBzAsa	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jwEM56ipKfcwEPHqqSwi5DeizpW5dqp12odQfRC5ZPuB9UJxdwV	5405	7626	7626	1617311880000
10456	3NL6LAnPiapBQFVA2zKXNVaaHqmA15ZeDgsTMtvo4HAP3nqboATd	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jweZmj3Bq8hnK69rtwR4ZuiDr9mHW99qpSCvkeUyR6ckPABdbgz	5405	7626	7626	1617311880000
10458	3NLY8oFDnccLHXUsVcCsWTuDGi3Xz2xuEhp4YECh2QzYekWJT56T	10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	684	1352	142	6301	6914	jx3dCzRqHg6YL5HRTBjPFPu2dvNLtGG1uerzTbZ4L3r67BZo17p	5406	7627	7627	1617312060000
10473	3NL1NJgukuAENzur5KRrdHvxGEeCJJD6sGbHWqWdDThkae3Gaa7E	10471	3NLkJTVUrFLKaTgHmVFxMxaNG44xEoNy7q717BpiMZ4mPFXPegB8	1406	1393	143	6301	6927	jxu97cUgWKktgMcTRSLUiiL4ZeVByisvgh6izwSHVMzHEoEUgau	5413	7639	7639	1617314220000
10478	3NKECi8WDg766KwrPJJe1H4oyZBMMutUjzx6DgKxqVwFvT8PM6cd	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1654	1094	143	6301	6932	jxRwpDDsDePiQD5Ed8FgxSNmkr9Vf1umNHPjewbqs5B2RVAA5Co	5412	7644	7644	1617315122725
10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1623	839	143	6301	6936	jxTCgpUJLVNzgFRj9yQmaCfwK6VJ3A8cDxnBaDSCsE5xJKipv4v	5418	7647	7647	1617315660000
10488	3NKQFDdhCiVyd9f7iSYyee1DUTSSRETZ1fdcGVfYihKf58JXA4sW	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1501	994	143	6301	6942	jxF4Ugy4Y8v1xs9VEWUVL5EhXng2njuph4gEgJaqa6ixSCbvG6z	5420	7653	7653	1617316740000
10494	3NKBwscEwmU3KaesR7omFtCSk9j34kRr6LwgXT38HX9yW6hFN7R7	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	1611	975	144	6301	6947	jx2xTSFnz7kmGAbjxFxJgmycshqDxjWrjg1LTDcRj6RNTf2vtw5	5422	7658	7658	1617317640000
10496	3NLSqqRiF3z7AP3mdJgRWQGzdDjSfVFPVmX9t14WqZ5HUJt2kAmh	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1503	1277	144	6301	6949	jxUJ9xfzAdoCtiCTHwM5R99i29Hfu4xCy79p12DsJurCnggLzcy	5424	7660	7660	1617318000000
10503	3NKckmqsaATbKjtJq7XNY4sGa9yCy7rezhdPWmQbA6rY4cFDQn48	10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	1656	1217	144	6301	6955	jwyPucJKBwR2LH5oL5xSQsXFLXsFqk5QD37XSHgdESSbxyT4nST	5427	7664	7664	1617318720000
10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1553	776	144	6301	6959	jx4gxgPW9cpCGJhu9bAkWFcaRW4CEHo2UM24ms2StgZKut7aqyP	5428	7669	7669	1617319620000
10509	3NLThNEXBJNyqfxrfBTqgRTHBUuXb6yEUCZC4uZFqvxppzRPpPeM	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1670	1282	144	6301	6961	jxJC18z3oqRyK3ptMacaHQxT9LXNeZopomiUUmPS744dgFYV7Bu	5429	7670	7670	1617319803007
10512	3NKBaKN1skZ8XR2A6d24Aty6YgbmCekQWN9xoQp7F2njeVhEuGtS	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1483	84	144	6301	6962	jxoiUWCLGKarWJMtgopTgyWFRuGVh5rXuS7qfVqQq1mrqyP9GYh	5429	7670	7670	1617319800000
10513	3NLt4H1VQrMLUe5r4BHgJQ3mombnmfbC3zDSsXqc3iPwb7KD2aRa	10505	3NL6ChSvdUAn6Lvf7Dna9UFG8GMA2wEMd1HZb23UFuJRE6XnL5xo	1403	824	144	6301	6963	jwYCSzc6AWj3QNd7Jsbyn9mLdE38EmLRZXT6BjusB3bWXDgDszd	5429	7671	7671	1617319980000
10518	3NLi4Yz9FWb9onoA1ghHDCpdmUiWXUvDmKvtfkXkFw3rkLxwtNsH	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	1601	1262	144	6301	6967	jxRkBahEKiwczUA34SUcV4nT1HMAE7PaZgkFLnGvrHXkSFUNVnA	5432	7675	7675	1617320700000
10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	10519	3NLgH4Tjbs64o69NARJ1TYPWghdJcTYoCyReQ1mXEXWYnKjN2w3h	1402	870	144	6301	6969	jwhzCQFRFUh7khnUV4LnS8eagsZ7UWdk4hThsgcGZ6B9EmZdsrL	5433	7676	7676	1617320880000
10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1397	828	144	6301	6973	jxDJMYqs4kKJ2gtAS6UECG9j7WSrV7vTCXf1XQf9Y9nKCW84aRM	5434	7678	7678	1617321240000
10528	3NKfFgZfgi2XAWr338MdUrgP9BpD3jKT1NDYjysbQvxf6p382UjA	10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	1587	1111	144	6301	6977	jxygsdt8N6ideSvT8XnkPmNfLKHPhvjZAtzppTSAKNPWoGR9XMB	5436	7684	7684	1617322320000
10531	3NKgEWPG8Sveb9Cp8h3pWiY1Eju9o6UmZZzWWX3NCmKViGKD8qjf	10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	1542	1058	144	6301	6980	jwtRM1ywgMKvN7qXEZTbnMQRGSeVog4rimFophpQfUEinJy3m3j	5438	7687	7687	1617322860000
10536	3NLA3ZtgJNiXfTSP55SKHfUnrJD9fVnmTRu39aGHfEPDSHECkCsn	10534	3NKdGh47ie7L9z1Na44SEHuKBqToUCwHzBbrM4cUGYey8swExwsq	1406	1393	145	6301	6985	jw73vGMkvZbFqT3udVcLHVxdr2XJUksyTrZDJ7zp986AcN4wEcM	5441	7691	7691	1617323580000
10541	3NLDtRbPZ7ASsuCh4hyTvCaFPDzZUMYLP5KTBMt4pjCKgB541cSx	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1407	1395	145	6301	6990	jxNDGXz1hQdeXNr3CDAXKeTXzFczcLGN4vLaNHb2ADHfStPqzEt	5446	7696	7696	1617324480000
10548	3NKpP2Xjzw7zDXjigFxubqqKu71BixxAicpqazYjSpp2gHVCSu48	10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	1397	828	145	6301	6997	jx7bXMTZgyo3W7mnhrTWAc3gHS8fwogeuXZGuSEYGRXoXh7Aba1	5447	7698	7698	1617324840000
10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	10549	3NKxc3bvbK2jiLnLLtB4Zc7tABjXASCXMPUka1DRVDKiuRDeZzEj	1650	1249	145	6301	6999	jxrPJoBPRrwrENYZkY8EyZDf3XFSoJAK6AsCjMHxBsgrFhAofmX	5448	7699	7699	1617325020000
10432	3NLH84KKPFHbF9hQ8AZdCsABFiG5nDTPEZSEjMsG9VgHRLQ46HTF	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1553	776	142	6301	6894	jxBq5YoMKSU2ZRpgR1SrjUQeffvRX1vzgCbzKw1M6BgxaJPmZCJ	5396	7613	7613	1617309540000
10433	3NKmF6AJCrY5NYucuriSeEcbqRtcnbUrPV2KqmR5wbwmC4afk41q	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	470	1309	142	6301	6895	jx1DNMxCjuquaxeSunwEKSvmdkMQJDcKV8gf1DEyeUkwXth41xr	5396	7613	7613	1617309540000
10438	3NK7DpHwJL8AhPUo9bcxmv9moCyR63LHZnPt53saNESHohyuSm1b	10437	3NLJ7h4AepHyriSV3fqK4S1dCTKp14JG7SV6Hb1FqiNfEdThPQ5Z	1522	1196	142	6301	6900	jxJ22HSp9YvE4mKkLsWLcV9nrGt7No1eJqVDjUkRoikoeay4voR	5399	7617	7617	1617310260000
10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	632	1256	142	6301	6903	jxupqMBpwrvQcdQFkX3nxMaeocEpqh2iEwLpTPAUziEV3huBVPb	5402	7621	7621	1617310980000
10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	80	1147	142	6301	6904	jxEkReo7GWhvS3FGBr2XJ1RgtWr6152ofh4zw5GaxauBjT4BY5L	5403	7622	7622	1617311160000
10446	3NKx58usebHR731aWAmfiom3SuL4L84rTRumFkSrRiWqnD9w7aen	10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	1489	1134	142	6301	6907	jxrgaP74WVJjTEphmhjyDueaDsu3oiyEusfft3qqfq5fW522X7j	5404	7624	7624	1617311520000
10448	3NKtZrG7u8WHp2951tofy6fwuGyp67K7JgzDrhFBak7XBhoQhA1q	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jx141PrA6LEyNk8Ufbj5vmfktem31PUhEFxwnMk6w9Z5MTB2EJM	5405	7626	7626	1617311880000
10450	3NKmLegsADB6PjkrSARR9vNaBRNCVPzx3zj5REtGzJMiPfVHjSaM	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1646	1354	142	6301	6910	jwdVRqUZE9aNdN7tumEunSzdPCKQjfuZU86He44DNjG4A2Lg2Vc	5405	7626	7626	1617311880000
10459	3NLSzy3ZJ5hD3FvfqbMPW7nyh5GCw1JqDBJUfhemhxq5fDHeDGgY	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jweZmj3Bq8hnK69rtwR4ZuiDr9mHW99qpSCvkeUyR6ckPABdbgz	5405	7626	7626	1617311880000
10461	3NLg7UsEk4f115pBfh21vdeXf23vHG6PQSYTeUHLv8yKxttnKo4Q	10458	3NLY8oFDnccLHXUsVcCsWTuDGi3Xz2xuEhp4YECh2QzYekWJT56T	1407	1395	143	6301	6915	jxUczqT7YYQ6CBmxJo2e2A9HkoGZVDJQSCg57gihBV2DZcdRhBf	5407	7628	7628	1617312240000
10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	10461	3NLg7UsEk4f115pBfh21vdeXf23vHG6PQSYTeUHLv8yKxttnKo4Q	1675	1216	143	6301	6919	jxdXdCYvN9JiGPDTFmNqfmcjN2zWHFkwmzDEPAfYbTmLNNs9w6B	5408	7630	7630	1617312600000
10466	3NKKC1WXyTUXxMymzzfLykqvTgQMYipQ1XVtaxS5L1TdTvLFEnfe	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1617	1042	143	6301	6920	jwuYeQyRE8yB6QJNgkCru2VERpfRDNTnA8XvoQ1nqkBEdXkr36q	5409	7633	7633	1617313140000
10471	3NLkJTVUrFLKaTgHmVFxMxaNG44xEoNy7q717BpiMZ4mPFXPegB8	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1646	988	143	6301	6925	jw7GQXAHoeaFAaauNekPJXyqxJh2pRz5bUjPiWZdoUfhwD5uwSq	5412	7638	7638	1617314040000
10476	3NLEcnh4BHFW5nc1DRwUzjaU6bFD7oHjRdKs61Wan5G5WGDUzVbw	10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	1406	1393	143	6301	6930	jwCBbqNyXduGrG9dCQJEksPuhFwzr2eXtk9JMRYAYNfehDxP6VC	5415	7642	7642	1617314760000
10485	3NKbctAwGdUQmcMUzBad7JnLfR4zbKZXXptcJEjtyGgffFzYN84K	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	633	1258	143	6301	6939	jwPYFfBWue1oUvsybPP6R1M2iZf5WuskBTJkxwwLNsS1k58CxNR	5420	7653	7653	1617316740000
10492	3NLaJdV4dsuKe1F7kVusMMXkBvvVSjywkC5ngSFUizrNaKWa8Lh1	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	369	1312	144	6301	6946	jwWKReFEX8EBhMeT9cjZjcG86qiyzR5i6vTNtWC7DZowbH1BP73	5422	7658	7658	1617317640000
10497	3NKhaZ4CnNMgAe5uFmPCZ6PzjrK8giH1WTajQwNMzY7fboRu7GnM	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1460	490	144	6301	6950	jxTrskS1wiexZbSc6X5xDwJz2LrC7ocn1JRksgQ4jHfEEjLV7J3	5424	7660	7660	1617318000000
10499	3NLbrZtbhukM2SphkqiHpvEVESKqBxQPksxp8rLP5qP53QuPCv1M	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1594	1080	144	6301	6951	jwkzGdZ7hmVsjgA22VTv18X97hV2Q2XX8CbbCHivye3jLhkqJTK	5424	7660	7660	1617318000000
10501	3NKZAmXfqfJNNgVC9LdnPWfFYXqK3n9Qp9FFApBcmRAzo2wSLG2L	10496	3NLSqqRiF3z7AP3mdJgRWQGzdDjSfVFPVmX9t14WqZ5HUJt2kAmh	1508	1387	144	6301	6953	jxV6XHtGRS2awUvjLHhV6xpWdoAaTvf9NxVi64v3R5VsMi1md3t	5425	7661	7661	1617318180000
10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	1675	1342	144	6301	6956	jxJi2vXjkut8cRfsD8qFA1webPCGBQjNdMJGEBYEjXUiVaWai25	5427	7664	7664	1617318720000
10505	3NL6ChSvdUAn6Lvf7Dna9UFG8GMA2wEMd1HZb23UFuJRE6XnL5xo	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1648	1038	144	6301	6957	jxXp5aZxAQbCch9QrdV5MNNeiLjzq1Cei3BBcpUHt6sKnGVGYZV	5428	7669	7669	1617319620000
10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1588	1266	144	6301	6960	jw8hse6cfSmnMGLnnLm7SXPp7eNxVQoYVsT69QdxNNYZyPpDZDc	5429	7670	7670	1617319800000
10514	3NLndAaCpyv5mc31y5xFC3F1Ne46kHE869R7puMmiCvzHsxZkQ7t	10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	1577	961	144	6301	6964	jy3C6MsKh4J9Bq5xBmUek92zySUeMgCFF14SHXUftdtLWQM4A3H	5430	7673	7673	1617320340000
10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	10514	3NLndAaCpyv5mc31y5xFC3F1Ne46kHE869R7puMmiCvzHsxZkQ7t	606	1049	144	6301	6966	jxsexYKteuFmio9wCYsKGudpXQWueprHsWb3oQwKYDSRpWhA6ei	5431	7674	7674	1617320520000
10521	3NKkjSYMLqMrjwdzNQmNLQcJYQResZT4iWufUoPwEw6JJBEnhQ4E	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1627	1139	144	6301	6970	jxboisSQfJxeCKsatf9qsL4bdexcZTBfS86M1e4ixxgXVR6vh4n	5434	7678	7678	1617321240000
10526	3NKPRacKpnyzhAeJ7T4WHU5rpoDQcuNLuYTCtqHjae1ZisNiwnaP	10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	1633	1144	144	6301	6975	jwYbeqpSbTDKUwtmbL4uoWX9Q2zJixugU93sBxLMLJ3MsiXFfce	5435	7682	7682	1617321960000
10529	3NLJojcScXK8mnGbWhpK8qjvg6dw4E8nKcjirUco36SpyrN4wEae	10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	1481	790	144	6301	6978	jxK3iuPadmnGWreMb44Yz4juiD3BS4rEuwdVnbPYcARGumFEn85	5436	7684	7684	1617322320000
10532	3NLqudMfrAs2CpYXNez8So5qMFfseMV8p1XfYFKpEdTThs8fXmfM	10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	448	1059	144	6301	6981	jwRMxqX1CHA7iEsWpCJuhdWCFTcwtqty3PzCwCQYh1sivDskAag	5438	7687	7687	1617322860000
10534	3NKdGh47ie7L9z1Na44SEHuKBqToUCwHzBbrM4cUGYey8swExwsq	10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	484	1193	145	6301	6983	jwVMejXmUMyaGUirGV4213zB17wcpcKzkPwyZw9XAu8j7xpDVwQ	5440	7690	7690	1617323400000
10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	10538	3NLxt8T8GpSWjaSvT3RsKVW73WseUDiBsrXmiiygoKeVQMDeC9hZ	1610	1314	145	6301	6988	jxwgNDsxbzE7gTzfzJ8vpMEenioq25DXCbZp1Mnno9ySQ4DXeRN	5444	7694	7694	1617324120000
10542	3NKv5guuBAohAtG3BpQxWyd3jY44GSP4D1MzHs5Ey5LSaoQYtnMm	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1637	816	145	6301	6991	jwM2NSwDG52W97gEsf3CW5cgG7vKJpbVmx2YA1grfRxVTx6mZ1f	5446	7696	7696	1617324480000
10545	3NKwELKniFZUNxE12W7KWtVEFjvS8JMZg3iTgL73aeKAjhW5TbDR	10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	1622	1356	145	6301	6994	jwoyD5bYYkifNU3EfwQUtbMzy5LKe58jiQ5qZxrQc6CMNqi12kL	5445	7696	7696	1617324480000
10460	3NKqNKJQWb8vAn6B91Ksif961Lp8j2g92nTgbSTaw9iCPXqbE2p2	10456	3NL6LAnPiapBQFVA2zKXNVaaHqmA15ZeDgsTMtvo4HAP3nqboATd	684	1352	143	6301	6914	jwm3iEBsPt6R3MZofaWXpVKAW9uZwT2BZwTnLbgu9f8JSsgnoCo	5406	7627	7627	1617312060000
10462	3NK8uh1EbVDaGJS7ey89z2BHAHfWR72GMGq2KEg4hpqefaKTCKME	10454	3NKHrx6KuFYwLAwE3FchfhGuC9WHVms6RA3X6DVGK7r4mAkfVcVE	1406	1393	143	6301	6916	jwqnAo7RWaDLEXrSWBZB8uLzkKLjpmPDL2yP9jTHyV6WpWQSyZA	5406	7627	7627	1617312060000
10464	3NL9acKsFvzsE9xqRJTnoLmzHTNnts88tPr6b7B1J6d8pT4GNrEZ	10263	3NKUmYhpRTzzsrZMNfcxXquYicqAbD6MEyTzqsgjYWWgcJi6FnDF	1675	1216	138	6301	6918	jx1kvyXGuavK7nby4Y6pBqd4SWhQrfKF1zRbhW5z7sZ5XW5osU8	5309	7630	7630	1617312613904
10467	3NLucWGk2CHzuHrXqNV61tSPbXDMU7cS9VmC3BVNWqTQLzhYsiU1	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1579	1263	143	6301	6921	jxXJ27HkKTjUsw4zBVqHTMQDQmBtekcyTdyUvuoxmg2AWapj238	5409	7633	7633	1617313140000
10469	3NLf1dE695uJJcYrmiSEsVByzyF27w7XK6ncibvTmM5ifnttUbpm	10466	3NKKC1WXyTUXxMymzzfLykqvTgQMYipQ1XVtaxS5L1TdTvLFEnfe	1407	1395	143	6301	6923	jxm8RDu52pbgbRpcJGgUGf1cVvGU6krSqawPAymcaqLvvA3zTkX	5410	7635	7635	1617313500000
10472	3NK9C13QvbxDuHMosZtq96psV9PL8jujeemhx1syRVSgFGfyrh4M	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1509	1320	143	6301	6926	jwZ7MWcJWF9ab46Fcg9qdpyBxFGwYwo7fvRmv87hWVjLLwLd5un	5412	7638	7638	1617314040000
10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	10473	3NL1NJgukuAENzur5KRrdHvxGEeCJJD6sGbHWqWdDThkae3Gaa7E	1553	776	143	6301	6928	jxDZTSnaXQz24pd3qGyATarQ74F4LHmwuBDCBHs2QwVfSsJwNNP	5414	7640	7640	1617314400000
10477	3NLUqSrN6M9egAgBviN8yo9jbm2U1AP3o4CWHGU9e64uBWKDVQbA	10475	3NKmxYBtB99uatpSCdxvtBD83YQeadz1gSMxuFfv4vEHp21L1iH9	1631	794	143	6301	6931	jwvwnYuH3SDi9yLzyzNUzFvSsoYCjKZXpPsfCH9VQvBSdbWUyHG	5416	7643	7643	1617314945866
10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	10477	3NLUqSrN6M9egAgBviN8yo9jbm2U1AP3o4CWHGU9e64uBWKDVQbA	1654	1094	143	6301	6933	jwGzewswB7etJxSmpTMBLgLxFgW9a3sHKZBaDUVScRePqd6AZa3	5417	7644	7644	1617315120000
10480	3NKUTrWohXD4w5xPtR1MaqJt9LqYVbQV8qeKodK6MNBQAPsDvxsQ	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1403	812	143	6301	6934	jx1ypMBLY3F8jD5NiaZQgRBxXffuHWNaWX31bQ14QHcahWg82DZ	5418	7647	7647	1617315660000
10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	1447	1345	143	6301	6937	jxNafYahDymukteeBR1RF1YxPpBP5F2iZCnaXJy4jDzXBBjE8Xa	5419	7652	7652	1617316560000
10486	3NLyTWAWMabHz58xoTcgdErXTdsdWgsAvuXQ2Au7Vs8MeDVcgpa3	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1602	1243	143	6301	6940	jwQ1So3jPRJ7gPnHNvj2sQpcuSudvmsNRNxMaHAxyp4BTbMexrZ	5420	7653	7653	1617316740000
10489	3NLk76977HPAYRumfb5sqwdqvrd3417xdNnVGAag18rSRLhWqn3G	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1406	1393	143	6301	6943	jx41qitg9Enbefgjg2pM4HqyJ31mUpqzuNAgmPNWUjDb7qZaqud	5420	7653	7653	1617316740000
10493	3NLmnirkD37jLUHHPbpdaH12oUie5L7ZFFvCDqAYWShwRvodLgsu	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	369	1312	144	6301	6946	jwWKReFEX8EBhMeT9cjZjcG86qiyzR5i6vTNtWC7DZowbH1BP73	5422	7658	7658	1617317640000
10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	10494	3NKBwscEwmU3KaesR7omFtCSk9j34kRr6LwgXT38HX9yW6hFN7R7	1440	1131	144	6301	6948	jxnoUwd7g7LPz6M15xYhHmvkwA7bjhXZCsAf8WZYQwu1rxs9BAw	5423	7659	7659	1617317820000
10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	10501	3NKZAmXfqfJNNgVC9LdnPWfFYXqK3n9Qp9FFApBcmRAzo2wSLG2L	1608	923	144	6301	6954	jwSvSaJB6x4ZfUVJkRYDjXvT8ZWHTwgPmJM8t12c7wAc8AaJ8tQ	5426	7663	7663	1617318540000
10506	3NLF4Bn95ScGzm4Tdt4SSJYQwnK62GCS1ZVoptJ8J14gnLgK2iVU	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1589	1160	144	6301	6958	jy37MXC5EwmW2Nk4FWM5M7bVtr5m5ujP7oAGQ6Bk4Yw3Mda3RTT	5428	7669	7669	1617319620000
10511	3NLv91UwZzsbPGPq5coxbzbafxHFvx7wiPjNRhUUneokLKLbR8Vy	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1670	1282	144	6301	6961	jxJC18z3oqRyK3ptMacaHQxT9LXNeZopomiUUmPS744dgFYV7Bu	5429	7670	7670	1617319800000
10515	3NL8LFhZDozZb5765iY4zhUHXsLHU9QWre7EjkJVMPzmhFshcNNF	10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	1403	824	144	6301	6965	jwcuBJKpuUk2iPjisXPptDvDU9FpoMbk1kfwXXzdtwsgge1PqPv	5430	7673	7673	1617320340000
10517	3NLMd1oJYcGzCLYavA96RRx43KHxXd8hmQhcbaJ297fMeDiwbhGy	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	1601	1262	144	6301	6967	jxRkBahEKiwczUA34SUcV4nT1HMAE7PaZgkFLnGvrHXkSFUNVnA	5432	7675	7675	1617320703923
10519	3NLgH4Tjbs64o69NARJ1TYPWghdJcTYoCyReQ1mXEXWYnKjN2w3h	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	495	495	144	6301	6968	jwyaB4NehwTxKjEYciubcyFJYjL71GwLqVbQVgXcpCaTJN5UdZb	5432	7675	7675	1617320700000
10522	3NLx7gMYMP5YVtS9pZAPVsXnyLfegBvZYRuYuBeKEDb8H2eBTngQ	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1501	994	144	6301	6971	jxBYBK247EGqhWiLELhcq7RpxubrvQA57FKv7moyWq54qTXNcCK	5434	7678	7678	1617321240000
10527	3NLhMaXdYcyzeUjgbvcRBQEbomh5Ff7EwWMWBpEcwqBr4N6CUnDS	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1587	1111	144	6301	6976	jx3hp9TcEvrpDEk9Cew1iUgdHsVeS1QGQ5CjN2j7AQZwZGLSBpE	5428	7684	7684	1617322320000
10535	3NLH3VWf1Ccxsb4znNKUwvDAH9XaPwaK1E9F1msanjECSSe5F6oP	10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	1481	790	145	6301	6984	jy26CE4UmvzvmTZeYiKLiz7kd2Vb4gSsEHG5nVqMZ1Wc9NT8oSy	5440	7690	7690	1617323400000
10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	10536	3NLA3ZtgJNiXfTSP55SKHfUnrJD9fVnmTRu39aGHfEPDSHECkCsn	1407	1395	145	6301	6986	jxwGZ6Vi4ogidozT6MAmXUDEC4JAXoFaQkMwvASBH7Nv98adTCk	5442	7692	7692	1617323760000
10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	1631	794	145	6301	6989	jxB6ms5NF75B2bDCRLHbr1KUPWyqoHpdJK2Y3NGBW2FjzaYnCWw	5445	7695	7695	1617324300000
10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1483	620	145	6301	6992	jwNZTAgpGMHEHZNTSvzs9V3fDHs5rLjqCdm6NfqfQidoPG1Lbgi	5446	7696	7696	1617324480000
10546	3NKyb9Rgqgg5V4SPkSajD9dDQMQsUjNDVYs3ztXdtgFDyN2ZxZiA	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1613	1349	145	6301	6995	jxoZNtPv66v9sPk86HQtffu2YjLfo5WEtmMLU641tft2A4QRGNW	5446	7696	7696	1617324480000
10549	3NKxc3bvbK2jiLnLLtB4Zc7tABjXASCXMPUka1DRVDKiuRDeZzEj	10542	3NKv5guuBAohAtG3BpQxWyd3jY44GSP4D1MzHs5Ey5LSaoQYtnMm	1403	824	145	6301	6998	jwgxJuoM2BqH92u3Be4Dqzbkh5fN7Bv8qkj4VESWoD4iraAz1ya	5447	7698	7698	1617324840000
10552	3NKP4b8sSBFuVvSwCpcEUfqfVX3qiFU4bvWmvV133STXeZpgv5my	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1549	1362	145	6301	7001	jxuCq3TVmWaxvvb6JALhSCepGPyhyuy3UmSZkf7Ac4AA6mzs46e	5449	7703	7703	1617325740000
10554	3NLaRGPXhTpRrkWgVsdfbLNCGi8A3sxzhfQ1C3T7fhmgBrD2AD7x	10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	1634	1331	145	6301	7003	jwhKnTfEQ223aNUrHwGzUqoqAX5K6ss5xzkM7KP2Sxk9fhpNazZ	5450	7704	7704	1617325920000
10558	3NKWNJBJMRknsmcQuYcystZke3rYgUYmqWT3amfrmK4E7jAavF9w	10387	3NLJcxdxprpaQSnZ5isVzKwPMZASAryFBgtTWiVr6oUGAeEVnZm2	1467	1250	138	6301	7007	jw8CNxs8bHP4QjSpMB422nxBkbtCXTHRpwVpyHHj2EdaVS2KX3a	5296	7706	7706	1617326280000
10547	3NLWUB5bLYG4iWUkATQ6N76E97fHmwwaucuToahYTDx6hpv43uUw	10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	1407	1395	145	6301	6996	jwLNiSozLyuNRMRLkXQkqmhApjzSzticH5MPBjZhepFDgRPNuF6	5447	7698	7698	1617324840000
10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1587	1357	145	6301	7002	jw9kUvfJbsQHg92nAyWzwntZKNM2saCz9cPcpC9ne7cTM5kZkBt	5449	7703	7703	1617325740000
10555	3NL9dLRT2CZghdA275zyQh2wMMG4R9qRcpsjRq2axHE8i1UXR7Ww	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1403	824	145	6301	7004	jxojPueYigoCgdKjvreNvfGFxjCyNKEiELKriVrFRQQApzpJtmv	5449	7704	7704	1617325920000
10557	3NLN9JGfti6wE8SJekeBMUwwmpARcGK78A1EquuXqMno68KfvY8b	10554	3NLaRGPXhTpRrkWgVsdfbLNCGi8A3sxzhfQ1C3T7fhmgBrD2AD7x	1467	1250	145	6301	7006	jxix7L2tFwj1V6AZT1mgko5XQgwKB5xT79qhH8rTu4dJ16UxHCa	5451	7706	7706	1617326280000
10563	3NK83DPSXFaM8ZMgSPVkZbXgC53n1CPaxmRj6asY6is43NgBhx8v	10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	1402	868	145	6301	7012	jwwwPyAN2uR4jxHcoQT2FLnEBKPBRR32RBUkXD2PBW5UFWjJmeK	5454	7710	7710	1617327000000
10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1546	1339	145	6301	7014	jxHTwbySwpMNCwFGdXJu1AF286TAs4NEReqf29rYLiHF1xXn9JR	5457	7712	7712	1617327360000
10567	3NLUA8MQotLuBRiAcR3o7eThKnqErczed1BCQzx4ZERctBkPVstf	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1611	1341	145	6301	7016	jwj8VG2cgLMHX2gxCfbmoDRYqtqRJMzXhc8oUJ7jEQYEuG1z6DV	5457	7712	7712	1617327360000
10569	3NLQfB5pnb3StkQeo5Vpod6xRqgTqy9JGyR2hC7oKpb3MZ7HwxzJ	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1406	1393	145	6301	7018	jwEZ15XMnQFHLnjfaLoMF7TwRZcK49qQTdfcx2X8twG8KHXXjtG	5457	7712	7712	1617327360000
10574	3NKQ3DbCPitNWVACZcKTMtahXsxKNwJkph1dFM1V5yfJThYXPSjb	10573	3NK5ytfJDXg11P49y69Q3mjsio1fQLbWTjjJYMfciTCvdVQMa1Ye	1481	790	145	6301	7022	jwUsvxQEQQ8v8FPWvqJEve7Vp2KuhhJRjDgToGtxQ57oZJFb3pE	5460	7716	7716	1617328080000
10577	3NKgVm5cYorcMMAzYSC4qPR74yvXuSKx6owVL47JgcwVERvfob8n	10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	1624	968	145	6301	7025	jwuQXoBc5XfyUD9KTw6Y1QpNTzoXcb6jnPyQESQJRxPh9SiJVps	5462	7719	7719	1617328620000
10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	1490	1028	145	6301	7028	jxhfaD67V53KKMnddFpWWMSxZg6sRdHftCrSKZJz84edFBnixj4	5465	7724	7724	1617329520000
10583	3NKfhuzYrKmFTMikU7L6d6WGXVBGbSEbZ8prd9yLjJBNeJbSyRfD	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1407	1395	145	6301	7031	jw7bhGVQLvms4nKHYmKCKm1czaTCq3sNmq75sfNeZDyYfmfXCXU	5466	7725	7725	1617329700000
10585	3NK85sn3ncGgxhVsCc1fWjJDuXDZEVXEGEfamghNMYJ2hdvyFryH	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1581	778	145	6301	7033	jy1HmMqGdYx54Jgfi2wgxEdCu1Sq9VMz5VRnHgdjMzdB5voJYXi	5466	7725	7725	1617329700000
10587	3NLwc3iKR4zZhbSDixCKtqv2oJ6zAkVEAM9najCNyPYVMySFEUTQ	10586	3NKCFWFW6HERKXHi63MPr7Vx9b3h2fwhuVev6fCuPFaHdBmdmu66	1403	782	146	6301	7035	jwXD8ekvYZ97QE4ouRXgrWWaTYB6vBQcXWxMmFvHN59FENFrq7w	5468	7727	7727	1617330060000
10590	3NK4nydL9FqAyDQwzZuhEWCYTqmekfq2nK1zdDLsx8kEYUYxq8Gc	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1594	1200	146	6301	7037	jx13Fc9GpEyapgrd3HGsf7CnDuk5E8yVUuPXwuwYUvo5Dow1W9V	5470	7730	7730	1617330600000
10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	1406	1393	146	6301	7041	jxwMgQJEwGXZFGRyFBmB37EES8UQNtfTzqd9tk2yDhiqcQPyRnJ	5471	7731	7731	1617330780000
10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	1555	1347	146	6301	7046	jwd9gb36kiqWRSxcr69Lx22pkeguzNcuJPWJLnoNqXizJXrJVDw	5475	7736	7736	1617331683952
10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1601	1142	146	6301	7049	jwaZ94HzSQgDgn7X7D3G1982ckjtkuiBpMTVZ2KZorM5EJn9vvN	5476	7737	7737	1617331860000
10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	10605	3NLJTLu34kaQTByX3iCRDpMsE857hn6o3N1TGxe25io2DurUKFKC	563	1359	146	6301	7053	jw8qETgtAH9FhuXQgCBKh5vRsQdrjhah8cBVE3Sv6hgVEor9TWv	5478	7739	7739	1617332220000
10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1607	1102	146	6301	7056	jwqV9DCncfR4shVDW9f2SyWaufya9L8RBxFP2BaBHfQG2RAkL6T	5479	7740	7740	1617332400000
10613	3NKHY5RecJrnfk6jjiFzVSodYXh5ZfTKTj1JfWJ9CZf8aFPykPbG	10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	1403	782	146	6301	7060	jy18jAicL1Uoxor7nvUq339gDVBabDQPKVu8pq1xZNm8S6RmKnM	5481	7743	7743	1617332940000
10616	3NKwFnQ81U4MS55Em2MM8wwRbTV2ULuZeejTiGWbd6PsaDhKLYR8	10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	1623	839	146	6301	7063	jwS54iHEMd7tHPRwWNSSYetAvNRkqZrnLXXEU59Zt2w7VEyMFTy	5483	7745	7745	1617333300000
10620	3NLRCLfVBwGj8Ekz4YvGwn7h6XXzVNbyAQjnkrBw9GDzkYPek7LN	10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	1637	816	146	6301	7067	jxWNuKt6424HdPwJG1hotkJXmNtfmnXW9ZkUMdA4aPKcKaASb1o	5485	7748	7748	1617333840000
10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	10629	3NLtbxsk5H4H9SVvBvdS9FoNrC5QA3WnjXh6eC8sbxEpW5sF6Ygj	1406	1393	146	6301	7078	jx1bEXpALptF5GUrpxGgcGxsiPpdr4Fqn4veSYkj999Ritmgkuz	5491	7756	7756	1617335280000
10635	3NLUnanRNqSPh8ikpEbsEBNYfN3QPREXfA7UqWBZHNhYHfLiAVFd	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1542	51	146	6301	7079	jwu6hGypZE8ESexzTzNXFnVULGGQz61w5FFdnXrZ9ATsAGyC81c	5492	7757	7757	1617335460000
10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	10639	3NKHtemDQVjbYiYcck5cjVUJbhmPUw8jDb1qMUxnb5sVeHsAhrro	1406	1393	147	6301	7085	jxzca3UdmUQJF9PuYGgjJamyT8ZY5eejJrFQipadsJzPZp6BaMS	5496	7763	7763	1617336540000
10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	596	1060	147	6301	7090	jwsHocLzP61jqY9MSWXfaCWcum14SK1QjM159HMuQ5kiVsPrYdc	5499	7767	7767	1617337260000
10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1536	1187	147	6301	7092	jwNtgLjhQVdXdhpJDppDSc9nA7Hpkz9XcsDYhrPevT8Fm8EZbjA	5500	7768	7768	1617337442386
10652	3NLvXuRoTGXiA4tbSbax58wBpHUiwRPtpqEXuLHDvK7rg4HL8E5v	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	484	1319	147	6301	7096	jx4RTgpfWXhHjeZZyuBvhqABZidmFNpiweW6aam4HpcTmTSTV7r	5501	7770	7770	1617337800000
10654	3NLhDEbw3ALRtcV1icTYN3oKDtLwaZELnNFVgUJiW9q85jxVFdzm	10653	3NLEMMxqNhMZpXUwj9wV6i16gY36HNrkiKRBp7uJgFV7GybHf248	1406	1393	147	6301	7098	jwoUqTxJGFwhKVjuRfCRTYBMttX7E6acuFyJBmXBq9AJXss19uh	5502	7771	7771	1617337980000
10657	3NLSZPpPyq2hU9g5Apwih9vgcNPgADv4pFeMmVHEdp4JQpNygvR8	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1637	816	147	6301	7101	jw6zDvs1J6KEpFqiGvjor7ASL7dw3YxLkimmVqCELEKT3ETq7EL	5504	7774	7774	1617338520000
10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	10660	3NLDyhS9tRnA7kzahPnboq26Aa4oMiPfuyfvyZu6fJKmL9uZir4P	1599	921	147	6301	7105	jxwqmB8f4nyYTzR82YuT5C3mojy9mVB4UrF9VvUUZgYx4uMB371	5506	7776	7776	1617338880000
10551	3NLRzoNQyTGNMWJygzkNA4bfVPaJZg4y7BVKytdSR4VUR2HVpFRH	10527	3NLhMaXdYcyzeUjgbvcRBQEbomh5Ff7EwWMWBpEcwqBr4N6CUnDS	1587	1357	144	6301	7000	jxJDyC392Aor1odwbN1DpHhhEUcirZpuiZ7B8KSc4YYFCMxwB2s	5429	7703	7703	1617325740000
10561	3NLs28T3at61pTp7Ji5BiwaSoof7HXERZWxrbxQLU8wcxeXR1WPd	10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	1406	1393	145	6301	7010	jxf58yY5bmtyZ8WeJKhmuCKDJm12qydEWd6bDLehX4TZTsFGZoP	5454	7709	7709	1617326820000
10566	3NKVWGqgbKn91hmV4RSC7KKCxUubVXJKc3jGrWviNav9GpQaTQEr	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	576	1355	145	6301	7015	jwoPx2jeyyLoSdDSvQ8Fv2t4sJNiQCPRcwq8kHqjN89YPgmoX8j	5457	7712	7712	1617327360000
10568	3NKjZf3YyuB5Y6b33ieThhzhsbeFfs5fUFuQKpFy2eXm4kX8xXB7	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1631	794	145	6301	7017	jwfThFx5w8XfwAJfsvw4WJbCxz6tETwiR2e5bWf2qTDLWYbrvsf	5457	7712	7712	1617327360000
10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	1444	1381	145	6301	7019	jwcjHtPAPUpqpjNc4uo4x1d37P7SU9aC6eTxYNhwahohAix4hjy	5458	7713	7713	1617327540000
10572	3NKT572cHQSDUdP3nBnRjfrGcuLRvg1g7LpSPwgrQV7LC3jxRXwa	10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	470	1309	145	6301	7021	jx4vRHh7b6A5yRk2KVTLwhkBtfWyPsPLTxFSmQjn6VwhQkyEsUq	5459	7714	7714	1617327720000
10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	10574	3NKQ3DbCPitNWVACZcKTMtahXsxKNwJkph1dFM1V5yfJThYXPSjb	1406	1393	145	6301	7023	jxfXmbVbJ7JKE7fUcfyCDrNDbr4VW1bNjiwDKWgi2UVvtfpqh4B	5461	7718	7718	1617328440000
10578	3NLRMCKyPf2kE2tw6zhCxRUrffafREn4JjKGErxETgjMapTBfYy1	10577	3NKgVm5cYorcMMAzYSC4qPR74yvXuSKx6owVL47JgcwVERvfob8n	1406	1393	145	6301	7026	jwiRmTFxJWaHCios3fNFzCG6srrDtWHfKHnn26QkjDvFfCTtBAd	5463	7722	7722	1617329160000
10581	3NL6H2gWeeXz4F1aBYtVqhuPKFXoXLWfSyZWYHxaNFgLYuVcHQqy	10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	1406	1393	145	6301	7029	jxzkRrruWnWVRiobg9ZqdqtKBHEHujmX7Pe9DWLZw3vUn4UPxWr	5465	7724	7724	1617329520000
10595	3NKRFSBVPKgQRqK1LcHeBsoQq73H6yrvCuq2S98cU3WBWVim1dh4	10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	1402	852	146	6301	7042	jwYvFQEctkm6gPWiXB55DHDeF7jAvbnGLKgunU5CmUGFj9ppbwY	5472	7733	7733	1617331140000
10597	3NKua5kjA72TGpFZH8y1VtmksWZBYFrtvJ4gMqWG1PDvJ9mJrz2F	10595	3NKRFSBVPKgQRqK1LcHeBsoQq73H6yrvCuq2S98cU3WBWVim1dh4	1403	31	146	6301	7044	jwTRuGW6QDYGnipjQyfhkWZeGY2Ksofx9ERArcunags3hGRGwn1	5473	7734	7734	1617331320000
10600	3NLPAwzYdukcT4Wkq6FH9kH53RgzB3dbHFgGpWyKnofYCd9pecqy	10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	1624	968	146	6301	7047	jwiyLH4UwxGP4TuLZAk73RgFJyq6fgWiAHqWKJUaMGJ3RJN2mTU	5475	7736	7736	1617331680000
10604	3NLjnAXvqaf7e3FP9G4xWsXkeZmmmBF8xo5f4J9HZJy7xQwLmiPm	10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	1631	794	146	6301	7051	jwq4NnPmaB2C5cL2VWBrwuPmNW7pm7p3GRYgxRj2gBK7JYwxMmU	5477	7738	7738	1617332040000
10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	1405	869	146	6301	7058	jxYLRpV6s3sDD8VPbMVBRNSCMoTKfAUdjziLVzN6bTiHkfdhU35	5480	7742	7742	1617332760000
10618	3NLX7Ex1PVPAMFX3i6LP3X6rwx9zdbfCMFou3gfLgzJEHPMvicJj	10558	3NKWNJBJMRknsmcQuYcystZke3rYgUYmqWT3amfrmK4E7jAavF9w	1467	1130	139	6301	7065	jxqqqqAaFtepvyAxfuqNngmMVYjKUgzMfZBhzWm22w28ArUtqAD	5297	7746	7746	1617333480000
10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	1627	1385	146	6301	7068	jx78HeUpKudLUMkF71CqXvp7tSb5QUZG627D4GMpFyRk1T2zsuv	5485	7748	7748	1617333840000
10626	3NLHy5h8kEoeQGYvdxrrcUEud3oqkECZcoH1zUkxG8b9G2SwvpUh	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1403	824	146	6301	7073	jwppgkPyzLYuH3HoeB2R4UE8TkvWNUyvUVhw5231pSwfASfX7k2	5487	7752	7752	1617334560000
10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	10627	3NLCcebW6pwnvzc8SNptoLvfWR6c1vaL3np5W8YWcTm2h7Lxj5w9	1403	780	146	6301	7075	jxoDaR4ofRNyh4yy8NeZzKKWizHL6yrHATWU5kvjfE1Hg5V3yTx	5489	7754	7754	1617334920000
10633	3NLemWWMDpR1gvwkRsC3KLEyvoxQbB5czHRGDwVDF2th9Jc3r1o6	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1542	51	146	6301	7079	jwCAfouyZ2HYj3gMcXjXaEVimJBUybKrzCxd4vQ9pEszCv7fu6J	5492	7757	7757	1617335460000
10638	3NK6RhTp6BrVvbaCKaLtxvFQKtk1MDTJDcyRp7Mp96Sko6Kn6iTM	10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	1457	1391	146	6301	7083	jwULnjzQtZKuafmw6Qy4T1nFBEWo8vu79zEZDmdJb2eB157YZza	5495	7762	7762	1617336362449
10643	3NLiXWPiTH2SWbwo4BG6fyhitwd6u5R9Zs4ubakUn3g2XhJcT2BX	10478	3NKECi8WDg766KwrPJJe1H4oyZBMMutUjzx6DgKxqVwFvT8PM6cd	1654	1340	143	6301	7088	jwhLmtraaVy99pPuHU2dRm9tFBHC8cgYHCYE673kHkfd8u9ksEX	5413	7765	7765	1617336900000
10648	3NLWRa7y7rRM94ngMiqhRsaudbsMWWayip1v9C6DhCCmj8w4WVQc	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1646	1108	147	6301	7093	jwcktqmxVngGhQN2EshQ2YfQ2yHnXn9mo6k4ZtN8JZ91nPVHRiY	5500	7768	7768	1617337440000
10653	3NLEMMxqNhMZpXUwj9wV6i16gY36HNrkiKRBp7uJgFV7GybHf248	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	1560	1291	147	6301	7097	jw7RPZ9ByXtMJHXxoBgGt7RA4F1YsJR5o8ZLdsww9MZCxG3uKMe	5501	7770	7770	1617337800000
10658	3NL7kZByJ5fKbmCVWzWoPuFiMQeLtfBcMSepr57LDhqPUia99ffh	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1506	1373	147	6301	7102	jxEJaQeiwr2EBRDvAbhApKqJL5hssKRoh7Ge2zs1Leh4Sjz9JVJ	5504	7774	7774	1617338520000
10662	3NKN6W3rZ76LPPy6vNvtcvdqG21jm91FQ7AqqeoCB714cnxwcdUZ	10643	3NLiXWPiTH2SWbwo4BG6fyhitwd6u5R9Zs4ubakUn3g2XhJcT2BX	1654	1094	143	6301	7106	jwG6F7RyKrBMunVi37HJyApafiEDHV7dKoJ3DyPLdbFCwRuHrfj	5414	7777	7777	1617339060000
10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1623	830	147	6301	7110	jxYSanaCdNYcCd5DMiwSFKqXdWWeyi8HDwfdKyzbKqC5LdPavfu	5507	7777	7777	1617339060000
10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1553	776	147	6301	7113	jxrVEEnkta6anA519dJchwYebyUARkvgurnDASdV6qZBbBemw8r	5508	7780	7780	1617339600000
10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	10671	3NKQHVryTUNmXbCLB3u3SbYcoEkrHHdj7iwM7ovYLY2KrriApJ3h	1634	1331	147	6301	7117	jxt4v1vZmR5kqkFdkVaZFc2XfCbJkdDijmoB9Sw7HsmVbcM3wqP	5510	7785	7785	1617340500000
10677	3NKZiemzFFxdYzPXitzCTvJkuJqQQwvVJSk5egQLT2kHexJWP9bE	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1406	1393	147	6301	7120	jwHyvfswjUjxQ5fEFS1cBdwqdGK9zhEtUbdUG5cZjy6WRGN1VF8	5511	7786	7786	1617340680000
10681	3NLHVQyeceLSteYGRTSuzW9kF5gdomswEarFqRfz97BQCmpLDNzb	10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	1407	1395	147	6301	7124	jw9NRCv75UnVKuRzw2qUZ39C9PNohU2cBy9uj5xKNRzPKZZZjfW	5514	7789	7789	1617341220000
10683	3NKLPRQ4odvDp7tU2nzDCW2rPckDXTEdRTY2vG1dCA6Q85uhSmNj	10682	3NKXKokJJfU1LnjZw8J7iEWvnWtXfeY8PEHh9k9UZUmwbNCnwWAD	1403	824	147	6301	7126	jwpqJnwhkTUzTn6KqYZbXxG2XHAYFfMRH8zj2km4vs6dSqL1WWu	5515	7790	7790	1617341400000
10686	3NLR6ALdCEygpNut5MQa7cqNWduf7nxVv4YXhahh1XCyr3YebFw3	10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	1622	1356	147	6301	7129	jxa1zNN36GEo6ABdzLdx9oxxdCmnGwoJUg1NQLBhHVbYjWipCx2	5517	7792	7792	1617341760000
10556	3NKgCAZFTNC12UZ5GLQwhE9Gjsmbecd8ksFPBSfJ7zT3Hg37adD2	10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	1403	824	145	6301	7005	jx4pExmiDKq4KGLLKxaK4H8kHFNDnAZo4HuZULTCkeMEUTBda2b	5450	7704	7704	1617325993148
10559	3NLwL3pRmoU5DeKhRdf36XzJCRFB71aeAKuwGS8zNL7LNqtDpra8	10557	3NLN9JGfti6wE8SJekeBMUwwmpARcGK78A1EquuXqMno68KfvY8b	1607	1102	145	6301	7008	jxm4GrRbbzyxBBRC87e6ixYEANAzxbnjw91WcJGPW1U2kRKoxD7	5452	7707	7707	1617326460000
10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	10562	3NLA9eGrx5Tt32TT5C5saKrKTBC7Pv9edY7Hvw2oRLpaiykq8cYS	1503	1031	145	6301	7013	jx1xzGfrR14CNFnRWyMWxJk4JxHKxCU3JBXikcPN5C7QaxWioVS	5456	7711	7711	1617327180000
10571	3NL2BdTC1x7kJi8gHyzrromKJGtGgbWusK4BvSH7TLSfUu97hQFi	10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	1553	776	145	6301	7020	jxTvM34P89F1QL5UHk7716QVajd9mn7yU3pEhPr2tFaYWJS8NiY	5458	7713	7713	1617327540000
10573	3NK5ytfJDXg11P49y69Q3mjsio1fQLbWTjjJYMfciTCvdVQMa1Ye	10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	470	1309	145	6301	7021	jxPTpYS4e6Scnv7Vjf65WtgGg2NtjoQURAAfnpCEuV9avmtjT7C	5459	7714	7714	1617327720000
10576	3NLddtcYca7mUVLSF8ozjLxxyvyFUV7wEJG5JMeHhQrJEMgC6kiL	10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	1637	815	145	6301	7024	jwudFMVj3sZAhoDqTf4yeU9MRDf4tbEcrc8VQziM8aJXJ4NAU47	5462	7719	7719	1617328620000
10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	10578	3NLRMCKyPf2kE2tw6zhCxRUrffafREn4JjKGErxETgjMapTBfYy1	1670	1036	145	6301	7027	jxwrgD721XzLbQDRj5Zv5aBy2w1G2NRwa2KyaHmsmNf7JKA68mu	5464	7723	7723	1617329340000
10584	3NLnMyS45fti42hPdQBisYEd5XHp8jxRmU9EurkWgXEFCfWCtHod	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1403	824	145	6301	7032	jwigp4CFk5UUZj8fJeXZLhZQZdGxQhXe6Mkm3dZNLn5we7Y9uGz	5466	7725	7725	1617329700000
10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	10587	3NLwc3iKR4zZhbSDixCKtqv2oJ6zAkVEAM9najCNyPYVMySFEUTQ	1448	1311	146	6301	7036	jwt7aTM9xTrFb63o3yWNNBS5TNX2MM7s3oju6iGGpd8zAcBYF8p	5469	7728	7728	1617330240000
10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1406	1393	146	6301	7038	jxcu5qbDoN46cNEJhtLNdiV82HBPDDpqx5V5f6wukJK2owBScbf	5470	7730	7730	1617330600000
10593	3NLPT2Tyjmc8vyPAxpSULDT14BoSUrRBjeTgQqCV1RrUQi4tFNFC	10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	1407	1395	146	6301	7040	jwbZLcezrMtretgmjHrTLhREwQ8KUJm4XaGxw1pMHuNYgf1zgFP	5471	7731	7731	1617330780000
10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	10597	3NKua5kjA72TGpFZH8y1VtmksWZBYFrtvJ4gMqWG1PDvJ9mJrz2F	1623	830	146	6301	7045	jwU2s7DWTcJ3ALEE9qMkAkw225bF7FeqHvx65cS2HprUrDusYkt	5474	7735	7735	1617331500000
10603	3NLv4GeNdVLQJ4aFP2mRfmDoRg9qi4susitDFp5TmRiupgmgihVF	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1631	794	146	6301	7050	jx3kXgGKsZKFuq5KXfggJ4oTkuPthLU5xTYUfAny4QvaGG49WgN	5476	7737	7737	1617331860000
10605	3NLJTLu34kaQTByX3iCRDpMsE857hn6o3N1TGxe25io2DurUKFKC	10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	1461	1271	146	6301	7052	jxCHUcBYXVhQwQrB6rLdamVr9QU2Xu7Pb9Y28f9zeiiUfriazB1	5477	7738	7738	1617332040000
10607	3NKHh5QfhHWpUtUMnGQzpebEiBieEGsu9vffbFoDXRJsMmg9J554	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1407	1395	146	6301	7054	jwfBUVGSaZpmYkJrSqzw6AbJUqFLXmagG2PNT9HCfkoZ7xLSqQ9	5479	7740	7740	1617332400000
10612	3NKVoMxBnGVhXh3WDpY5zWN2W957GKTyDMGcajP78hwkzx5TviUD	10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	1637	816	146	6301	7059	jxXeMWMbYxQzzEhY9qWu14KrfFzGp1PM9EJ93QuV25f8F21zmkf	5481	7743	7743	1617332940000
10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	10612	3NKVoMxBnGVhXh3WDpY5zWN2W957GKTyDMGcajP78hwkzx5TviUD	1656	1343	146	6301	7061	jwuTHZTi2ympWfuxNJkLzX1dRmiuwxMEWi7XQFecqddHZ8ZgRru	5482	7744	7744	1617333120000
10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	1406	1393	146	6301	7069	jwFyfyQSo5B7uhZBFJF9Won8515XGSWKruBZ7S9UCGQZJHRXzEB	5486	7751	7751	1617334380000
10624	3NLbYDKgpJe1e1FcLq1jiFXp96dxCU1DSXrkxJtWBXqjZSMLVzKh	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1407	1395	146	6301	7071	jxe7YFqokpZi66uZNybN5T7oxE4yDaVUQLvadY14USbG5NR9MYc	5487	7752	7752	1617334560000
10629	3NLtbxsk5H4H9SVvBvdS9FoNrC5QA3WnjXh6eC8sbxEpW5sF6Ygj	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	563	1233	146	6301	7076	jxuxaFJEBXYKidcYkzCg1vz1MEgaSBiywJ9AX5dj6YLvsjqskzi	5490	7755	7755	1617335100000
10631	3NKfDqULh87XQ8kWyvzDSa9Hy7LrcmXzDaWJBgdzxkZH9xNrAn9A	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	563	1233	146	6301	7076	jxWnQWfHNRndJSuhXG7Fi9bB6eDB7BEQoPQFsYHTdJLGs3gbEbj	5490	7755	7755	1617335100000
10639	3NKHtemDQVjbYiYcck5cjVUJbhmPUw8jDb1qMUxnb5sVeHsAhrro	10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	1549	1236	147	6301	7084	jwSkQejyH96yX9hjBm5hx1cycVMc1ifiWTELTSQxwsF319PSMUE	5495	7762	7762	1617336360000
10641	3NKLduQZvLzLZR1STZNWRN5MaykP21dbvEJJBdHtx44LV8mB7sqz	10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	1407	1395	147	6301	7086	jw7SPrHzZu9m6kqs3e53TZk4yqX4qeECmGXWT1ETPxLQBVPqVkW	5497	7764	7764	1617336720000
10646	3NLDqfpuKVKFohtZQFYykGGEZVAaovkqdFQ3CXR2raeKJMgW27Do	10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	1406	1393	147	6301	7091	jwsJxsJN9uJmiprNXFGdP8yUUM3UFUpyaLyRs454pCCVQyLdorc	5499	7767	7767	1617337260000
10649	3NK4FuwBxrkjGshHgBe6AvhjsCUqXie6WJNKwkwS6zyQXY2mGkkC	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1536	1187	147	6301	7092	jwNtgLjhQVdXdhpJDppDSc9nA7Hpkz9XcsDYhrPevT8Fm8EZbjA	5500	7768	7768	1617337440000
10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	10654	3NLhDEbw3ALRtcV1icTYN3oKDtLwaZELnNFVgUJiW9q85jxVFdzm	1600	1006	147	6301	7099	jwm44YieLFmn1RoNBmCoUsZVCdBdWidrCoPHrK6rWceoRkSb8R3	5503	7772	7772	1617338160000
10660	3NLDyhS9tRnA7kzahPnboq26Aa4oMiPfuyfvyZu6fJKmL9uZir4P	10658	3NL7kZByJ5fKbmCVWzWoPuFiMQeLtfBcMSepr57LDhqPUia99ffh	1648	1284	147	6301	7104	jwyA8FuDoXu5DJ2h7ymgGt2Viy8b8rNgKieT2TyVqFCjqc1vRZH	5505	7775	7775	1617338700000
10667	3NLZ8JGad1SDXMuJmUw9nqopK27Kob4sEHf3pcPua9hvNJdnESTe	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1471	1020	147	6301	7111	jx314FmuKpTccebX1pe8pdQzZnRajxWWAwebcw2nYoQqhZYUZ8k	5508	7780	7780	1617339600000
10670	3NLerWk88N8vBAKfMBLiMFQhzi3uA1cyqBpFEFCkvc8QaeRLr7oZ	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	1599	1287	147	6301	7114	jwgzWkkFspuxoWD7ox1T64x7tqPCh2zRFdCVKASbTxRpRx76jZc	5509	7783	7783	1617340140000
10673	3NKa2p8aUgNfUdh3Gpw8bcYRsThjAmnqYcxqCqCgiJea8MAb3x8X	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	470	1309	147	6301	7116	jxSJPbyk4xSW7qQU6wMqhzxkSmwREPrfUMzNV7iyqizdurj7xmo	5509	7783	7783	1617340140000
10679	3NLHPNNcUXdDJ2mRxxQT8nuQzgw4njYF2GAUp9qhN9j693XgVdcY	10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	1506	1007	147	6301	7122	jwtWnN8sP6HPJgYUaYh1CHUTj7FwRhXk9nXVkXzTsoyaMdUHuUw	5513	7788	7788	1617341040000
10682	3NKXKokJJfU1LnjZw8J7iEWvnWtXfeY8PEHh9k9UZUmwbNCnwWAD	10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	1402	850	147	6301	7125	jwM9L5R7ndo8d4xVATgRL2aEMdVmbPxikusmoPgUd3SkwR2hR1X	5514	7789	7789	1617341220000
10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	10559	3NLwL3pRmoU5DeKhRdf36XzJCRFB71aeAKuwGS8zNL7LNqtDpra8	1449	385	145	6301	7009	jxxhqLxzHKqDPQsp56YCDxV19gb1DWDUtcuYFadkm58aBbJhx1p	5453	7708	7708	1617326640000
10562	3NLA9eGrx5Tt32TT5C5saKrKTBC7Pv9edY7Hvw2oRLpaiykq8cYS	10561	3NLs28T3at61pTp7Ji5BiwaSoof7HXERZWxrbxQLU8wcxeXR1WPd	42	1361	145	6301	7011	jwKJRyQyfNv4S1LZi1ivzgXi5r2J8X6wJSXBg7WPGEsGbZHLHku	5455	7710	7710	1617327000000
10582	3NL6eLpKcr9JqYjDVQ4W9MWSHUkxVANbkx6R8zh5U2KEt9jZzcnR	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1451	1292	145	6301	7030	jxrvCymqWwUbVRn7ZM2xSP5tV1r4Zw8oXkjEPfkZiEZGoHf4MgL	5466	7725	7725	1617329700000
10586	3NKCFWFW6HERKXHi63MPr7Vx9b3h2fwhuVev6fCuPFaHdBmdmu66	10583	3NKfhuzYrKmFTMikU7L6d6WGXVBGbSEbZ8prd9yLjJBNeJbSyRfD	1402	890	146	6301	7034	jxJ7pT12SdKEUZ9WR6SQwicxsuACaa2u9vnYuw9fLviBjqDi4dx	5467	7726	7726	1617329880000
10589	3NLxdZfUp6XBYCeLe15E46c3uDVgumPpSaPkGStfRJMjLnztGCHz	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1594	1200	146	6301	7037	jxAaPFJMcAfKShnyuMZnWqmrBQJSCjQ9CSSVBuizFeEeKhfvbqh	5470	7730	7730	1617330600000
10592	3NL8bHuAuVRsmwCXFFJkGmxXyg9JSHnCX7nFi7zdYcNbv4Fa4ob2	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	189	189	146	6301	7039	jwHF2z64nMCB19NMQYcCH9VaiaER1TpTKSE1qj1Y3bASfdSkfG3	5470	7730	7730	1617330600000
10596	3NKUtUsHwAYrKg74D8ddQqBVgf39aKXWTRHNrFkVx7qQP99JuKQR	10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	1406	1393	146	6301	7043	jwYGQWez6E71v3Z3EPkDKqyQzQWuk973GNXhVN6Ekujdfs1sDko	5472	7733	7733	1617331140000
10601	3NLEP9Da8zUyNWjiWRa2EYA8qW5Z2QFaqYM4oUsuWpKAE8NQJs6g	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1407	1395	146	6301	7048	jxxyAQbMnvnWFWc66F6oguwFzNmVb5WSMraSNNsW7x9aMMigper	5476	7737	7737	1617331860000
10608	3NKhEKBMrXLb6AAPsf9FcBcBCpEzP1duuRP34m2A3cvqDu87pPD1	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1447	1219	146	6301	7055	jx7hRo3xLvzzuwEY2TECAdpCh89GX9VkTQGmQbtxhHwpscAbq8f	5479	7740	7740	1617332400000
10610	3NLnQ3NvQAB8FfWThjgd3RMomZUfE6zyKBHaa8xVc2uLcHcsPyCd	10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	1490	1274	146	6301	7057	jxRXYjtWonGAHksMEwpn2rK9eLKcZ1Vi1pXJn9fqH3sd3NPcozf	5480	7742	7742	1617332760000
10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	1407	1395	146	6301	7062	jwwLZz7psVvZqK4jy66PajbBmtvB5iB5fhCDxRi1pKqmRHNwaFi	5483	7745	7745	1617333300000
10617	3NKHZjYZt4ytSbZbyXWyHaTjKPU3nhDjXYjLw7Whnjq5uLUfGzkd	10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	1467	1130	146	6301	7064	jwFqXk59wUGZbZd99861FA7KguzkGunikaVVkvBUmtb4ZTbJ9XW	5484	7746	7746	1617333480000
10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	1476	1005	146	6301	7066	jxt8oGQJFKC3GKLoGATsynAciUKvCQ6gqEDTV3uWwK18sqLn1Bj	5484	7746	7746	1617333480000
10623	3NKMLcYWrcya4MPbgkDmThfnEbmECDXNMJT8HwzA253o2DDibxen	10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	1590	934	146	6301	7070	jxQgRYzXxSMomrMraZtH3iArdgJPPcrvgtgusumAb4e225ZYdQB	5486	7751	7751	1617334380000
10625	3NL5WRH9FkQoY4eKYTiAjymLucVv7G4LJg6kRCzJzgFgroDkR6ZS	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1577	1201	146	6301	7072	jwv8ktQAbgbhhPQpLxeEHhZXpsxJ6RJSJsbeEG3WuKDz6Z1WgAf	5487	7752	7752	1617334560000
10627	3NLCcebW6pwnvzc8SNptoLvfWR6c1vaL3np5W8YWcTm2h7Lxj5w9	10624	3NLbYDKgpJe1e1FcLq1jiFXp96dxCU1DSXrkxJtWBXqjZSMLVzKh	1507	914	146	6301	7074	jwNqEbiNM7wo7BPBP93gXLkiuoECGhQ42tLEFHHiUe5u2C4zRq4	5488	7753	7753	1617334740000
10630	3NKBtZoJ5cdnNrRkiZvwnXp9tpMgoXgdsMf57oAjQWbKs1zaZmqt	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	1403	824	146	6301	7077	jwRqH8GXJqbXg1zDXZ1x8kZS5f5tBzHZqPWR9YJggS51CEFL2pW	5490	7755	7755	1617335100000
10634	3NKe2iveVabJ49ohynM9XHstsNceRd1auSWrUY2gg6AwgM18wfPs	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1477	1350	146	6301	7080	jxyDfojqb8im5RHXPmVspCjGV5tcSXaYdQzzbwEKuQQ5tuvwApH	5492	7757	7757	1617335460000
10636	3NKvWwyEYJiacAE7n5BZursNm6yiJBrykNwEz9PSYU5avVkxiem2	10634	3NKe2iveVabJ49ohynM9XHstsNceRd1auSWrUY2gg6AwgM18wfPs	1560	279	146	6301	7081	jxyiseVA1KpDTEqZ92Hu1aHLJ4EnJEN2ZW5hMcUPzpoqXzLpD9C	5493	7758	7758	1617335640000
10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	10636	3NKvWwyEYJiacAE7n5BZursNm6yiJBrykNwEz9PSYU5avVkxiem2	1637	816	146	6301	7082	jwK8HmTbXFZFMYjfgiuHNmcX9UpjEMfixFC5R4G4DKtUfBeW2da	5494	7761	7761	1617336180000
10642	3NKFnoUs1Ep4M69yDxP1jgMQAtqP79Cq67TFRk2TVQkmPkvKzQLD	10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	1596	1363	147	6301	7087	jw6kRsjj5PbtKymronE8WBToY9UB4wTTDqvCpxmQa32c2msqRR8	5497	7764	7764	1617336720000
10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	10641	3NKLduQZvLzLZR1STZNWRN5MaykP21dbvEJJBdHtx44LV8mB7sqz	1654	1340	147	6301	7089	jwHVcVry4YyFiULtHs8bWwXNPuQockX6KMsFW1MF7PZ1LFnEgXB	5498	7765	7765	1617336900000
10650	3NLfiy2NMpBisyinA6GD1kTrkXuuvNNkHPwcEzcJVwtDovSYomNx	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1402	1267	147	6301	7094	jxT1u6T28pZY2qmMY8xnwMyrwSy4Bf8m8zPsZcHZGwJZ7hvnwdb	5500	7768	7768	1617337440000
10651	3NLnTHeNCVM7re5kwfAMxxr1LiJ1wNvHci85PyNibMJj1cT89Drw	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	1657	978	147	6301	7095	jwZzBWWcALm5tCLzfupc71RLgs8YJT3DhA9XprXZrMBeuTeuZFH	5501	7770	7770	1617337800000
10656	3NL94rvE6kdEJibPwVv8tTJ4wCv2ertJhFhQJdRG1k3sfjW9CAge	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1407	1395	147	6301	7100	jx399Guf7wV9swN5vcpUeGhqBdA8qVmTkyaZ3ZmTXx2Da5hqH34	5504	7774	7774	1617338520000
10659	3NKq8ofAkPupjf3SmHLSmXSam3oGfUTizoySC2P54Ntgc9uiM9uW	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1403	824	147	6301	7103	jwJizc2Lc5zKc4JrE5rZDfGkiWn6qSHtVUMFMvmtGidH5f8UKdx	5504	7774	7774	1617338520000
10663	3NLT7H6AVvt9mnkXsHdy2AW7eX5FNpCtZFWCB15vYjeZRALx5hFP	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1455	1332	147	6301	7107	jxNJo6FA7SVR7gGhFFWFutW4qd9HRUc2VeudzSGxVA2xaqavyaB	5507	7777	7777	1617339062631
10665	3NKm6eMMHk8xoR8JgPR36v3CEEVQTv6HgMGjYwNBEn2ofnd9VRa9	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1461	1271	147	6301	7109	jwJq8zKxLsLD5RBu47cAhvzdtUdE1DqUfo48mp7ftE1TN9K8epR	5507	7777	7777	1617339060000
10671	3NKQHVryTUNmXbCLB3u3SbYcoEkrHHdj7iwM7ovYLY2KrriApJ3h	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	1407	1395	147	6301	7115	jwP4An4ZwFGTQDcJKtJ2UuSHWQXSAvGFwmgjTDVBzWgxYhanm2q	5509	7783	7783	1617340140000
10675	3NKfxRMrFtKqY15ZL1TfwDrLhwAXJZpojymUF3yV8Xst53sViXqQ	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1617	1042	147	6301	7118	jxAYJqA9g86b41nuHZVsSPXaBgYRqJ8eSzFDu2JxJGgkzQMtj2S	5511	7786	7786	1617340680000
10687	3NKZQTzFYhdNBPndPYeNqjXmsZvnirGYHQqVRLFtuVshRCNjbcYN	10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	1594	1326	147	6301	7130	jxJdZjJCWQJdjoXAV5K63evU6YiX3njEmMCYvf7X5wvJANXkrrF	5518	7793	7793	1617341940000
10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	10687	3NKZQTzFYhdNBPndPYeNqjXmsZvnirGYHQqVRLFtuVshRCNjbcYN	606	1049	147	6301	7131	jwAEsT6CRVrpB8NhJJcAWbPnKb5SJjuMGvqpfnzbgDxEy42WFw8	5519	7794	7794	1617342120000
10664	3NKwGzDtMRY8Kx8LdNvsr96FvxjHMuHRx35WRN8pC4Tigs5ewSqu	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1654	1094	147	6301	7108	jxUxhkDP9vppZSu4VNKZ38aGAxtxjS3qTGy5icWYGYqKzvyzu15	5507	7777	7777	1617339060000
10668	3NKWbAodRJ3hYPnHjTw8cvEQvkCEWRUAb1yGTzfvmXjpSnTdFqkw	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1481	790	147	6301	7112	jwAcNJZxQBDTKTknvi7psWC2iadkLhMZxRxsP53uVG9iEuEnyu9	5508	7780	7780	1617339600000
10672	3NK4JtDaQ8JMTPG6bNo3Ye3AMPrwWmp28B59Co8WZPFnVFrNzZ65	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	470	1309	147	6301	7116	jxaQ8qHrTgThh6UAWWeAfCtkRvTWMn8oieRMbyctcTykT9egMLQ	5509	7783	7783	1617340140000
10676	3NKPxqc66X2t2CbfKWuKeVAuAMfNhREpLjpLe98GnnpfP7WkDsNn	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1407	1395	147	6301	7119	jx1yfwDPWmc8s1cLZjgsKtdCeJsKSD6fRaWt1Veop7kbsPdWzhv	5511	7786	7786	1617340680000
10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	10675	3NKfxRMrFtKqY15ZL1TfwDrLhwAXJZpojymUF3yV8Xst53sViXqQ	1407	1395	147	6301	7121	jwPSW1D3sg2emj2HW1pM8SGu3trep2XQaHZcEC8DgEDzuYnNGVs	5512	7787	7787	1617340860000
10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	1406	1393	147	6301	7123	jwKvPewxA5efBTmY2E7fMZb2toWN9YHFZGDjgPBrUAYTmy1CSfq	5513	7788	7788	1617341040000
10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	1637	816	147	6301	7128	jx83WeRHjK9PbyNzyadpY5dUMcEwtRew3eqrBnnXX89rbZMHZJb	5517	7792	7792	1617341760000
10688	3NKtjooSEMTQryssoLnxtoMHhubzmNAScndjhw4LHHpoPMnwtAXv	10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	1594	1326	147	6301	7130	jx2eghqghhx2EWxUKB5QpH7wUh6qrjufTEXCmhgu4urGgtJ9Kvc	5518	7793	7793	1617341940000
10690	3NLbzeJs5kgvztsQToxQzdRAYsvKFizKg2jRftaYE7hUDVGDCSyp	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1542	1058	147	6301	7132	jx5U2NyNqWtKVQNuQZQ75tZo46vpnj3un6xee7DZd46ht9MLf3T	5520	7795	7795	1617342300000
10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1448	945	148	6301	7138	jx6wdQChfv7ae9R3XiyygtbVn1G7wS2Yq4AfZS2kWis9t5reJGd	5524	7802	7802	1617343560000
10702	3NKu9dkqou3AYYqRssxdDvkEShKztc1c12dDmGd4XJjBdFEeX2ZF	10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	171	1374	148	6301	7140	jw9FDGgkj7dopZ7EPytknn2PvNkLb27Mfx53dddiJCp6KrNn4f5	5525	7803	7803	1617343744609
10706	3NKM1j3V74awtQg1U4R4HuWg4o7McMMniBrJV53y4NKsZQyuMdC2	10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	1555	981	148	6301	7144	jxBXyMVRuLEvN9FC72SRUvCB9ysYdFZwvtSvSvkphwyuUyhQjFE	5527	7809	7809	1617344824278
10710	3NKLNPjydR8iKkTgAKLT2sFuAcxk9ueRZap2ZgWnQw1Y1PUqeHsf	10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	1501	994	148	6301	7148	jwtgKfCfdrYEExU1oSYaV1Gmdx7aEfwKDdVoN7PgZ5iwtjm1ijj	5530	7812	7812	1617345360000
10713	3NLuDjMYKP8SY625pvXAo3HJtEfYNT73Es5NPW4tQN3719qc3W2C	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1547	1252	148	6301	7150	jxFeQvEa9QxJKDjRFosNLXCtXezLaCHFRr5nYEU1to96RDLh5qx	5531	7813	7813	1617345544629
10740	3NLo1rhF71rAxdW3vuEtmaXSKhLVPqj6om5LoKvhCaY57cDdPm1n	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	43	1064	148	6301	7173	jxF1KZN9PDos32JAtU3NdeimpBSQPWXNf89xiP8Huc7h4owd6CV	5543	7828	7828	1617348240000
10743	3NKDvZYfXSDM9KRjatv6H7q9qnHkTYQ4HcZCnK2DENp4QtrAPTRC	10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	1637	816	148	6301	7176	jxyerLbwtFUGhyPUF2Vme2oH8jMcBWPnkQaysXaDYTzzRnguoGH	5545	7831	7831	1617348780000
10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	632	1382	149	6301	7180	jxYzy4TRperWg5yjAqaqEH8kjLrfGLGyn4X77rGF1iLNVtPnUHu	5547	7833	7833	1617349140000
10750	3NKC5ACgiT9x7stSXRH5ReQJcmz5XVzppYg23hHMGcNWxnoYSHcB	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1622	990	149	6301	7183	jwyTXPe4okZjwjcYwnVBm4Skk9E9Q7yh3wgo656BSP2ri9Y5DGP	5548	7834	7834	1617349320000
10752	3NL6xL1rRaPveusHcLMvUFJu2VyBJaRL37X4MdgyivMoV6a8Y5Jk	10750	3NKC5ACgiT9x7stSXRH5ReQJcmz5XVzppYg23hHMGcNWxnoYSHcB	1553	776	149	6301	7185	jx3jNPYKJ6uRKCyD1XLFKeeRoR6s9CUQNCAFev8tK3bqaWTNJmR	5549	7837	7837	1617349860000
10757	3NLLtLjM3cVmnhEwcDQBaJMM8NykznVx6jpGKL4Y4hb3wYQgprnE	10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	1516	1294	149	6301	7190	jxdN9uVRzapdL18NDqhvGPxujKxRG2gPMRK3jbQqpvMm1eoPuAZ	5552	7842	7842	1617350760000
10761	3NKpbWUqFCK16XFJEExQMGk6e3MAvyi5GU43kEq7oJAbs1jQh2Dj	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1553	776	149	6301	7194	jxczrfaNpVTmw2PaYh2NEzinUW4KEWrbVodvHHvgNZrspjmpon2	5554	7845	7845	1617351300000
10765	3NKAS24DBmE7rJ5rh2NWyTaGQCgACP762qQFLnWRy22KVbj4qb72	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1397	828	149	6301	7198	jxGqffDY7qfvDNV2FPd2Rg7F5vFNmVdi31Pzaqq68LX6JAmeDvi	5557	7849	7849	1617352020000
10770	3NLDFJuYSEtBWfAL7A6R2JyHzs7V8Z2EwMJAvNjTd4KFuh6Hca4z	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	1422	1337	149	6301	7203	jxEcn4EJQqRZYEMdFXXJGnMVMAy5vhMhssNQJGAQQHtYhemtvTK	5559	7851	7851	1617352382540
10772	3NKEGgQLuTC34nNN7aUmyzwp7XzyCWBNZWuCoLY7zaYxNPaN9tkC	10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	1668	1370	149	6301	7204	jwZwZR2r6JKVt66TktWKsNjX45KynmuxNeAPEjULyUsBjsBTBg7	5560	7853	7853	1617352740000
10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	10773	3NLprWf3UzqkE8s4s3Ruh5yiwxcJjZXTEhgX9zyYdAqqDuNXrzVz	1407	1395	149	6301	7205	jwbZ7X91AjZZDbbGGzEHXUyXC6yRwyubJVPjxo8ihaMeU3B26gF	5561	7854	7854	1617352920000
10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	10776	3NLTvMeFQEg6KAuyTjqfSQ3qEjyUtvAveVW1qWcFq9YLD68Vwmu5	1527	927	149	6301	7208	jxMFHG6UAnjEwv6eyBc25vtQRee6dke9m3UzJTP85VhPrcnCzhm	5563	7857	7857	1617353460000
10782	3NKF422hmbn42QdCvCpA3qcf8Q5iGVr1oD1JyMNQiu5o4Eegam68	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1407	1395	149	6301	7213	jwSL17odGau9iT8CnLVHb4uFH7wcMyxGMbcuKhDLFEha8Lz2kA8	5565	7860	7860	1617354000000
10784	3NLKa6gU4RBJB6QPXGgDmzELGEZ6ypGcU75tNC717HUpuLqp476A	10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	1633	1390	145	6301	7215	jx6a4bQytth6bKxB24uyDgVpZKdBskJQFFKqTdhgm5mGm5zKyNg	5443	7860	7860	1617354000000
10786	3NLLaDsGQwccNh5fYoUzzZa9G2qsDkvyg53nuSwZKp1L5LYZvvbZ	10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	1602	1003	149	6301	7217	jwUDaUi59eMvwYvbx5aKSHdPjResJhv8JHoHeCMej3ncgf8UYdk	5567	7862	7862	1617354360000
10789	3NKJc7tQR9jfg1Gcn6SGKH5EpxTEcTBgAgjjT2ttz85G242TJP87	10788	3NKMpewyVyi9HUFvwSBJWAdgbH3wTJAM8QWa7qySyZVQEUKkiGwC	1555	981	149	6301	7220	jw9TkyXHAQ9XqR32mQiJkZvUoftbMxYUSgSWFCPtReVWvJuXJMz	5569	7865	7865	1617354900000
10798	3NLsv72RhfLWHJGX7s2mNdsTZ7AnKj5XQ5RcRtGm5zryok7qhNNo	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1534	1071	150	6301	7227	jxDUzjnf1kFzhCzrvevWjmaaf9XzqXcRkDiyBK5q7vee5m3A8yU	5573	7873	7873	1617356340000
10802	3NLr1SgutMpkemDNu33uxgQRYDEVsR7FgLCRpKPDvibBVGNBYhkT	10784	3NLKa6gU4RBJB6QPXGgDmzELGEZ6ypGcU75tNC717HUpuLqp476A	1633	1264	146	6301	7230	jwYtysRuocxauNAwdUtvoVFU9o49foZ3NGxcoza3kLuXhDmta78	5444	7877	7877	1617357060000
10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	10683	3NKLPRQ4odvDp7tU2nzDCW2rPckDXTEdRTY2vG1dCA6Q85uhSmNj	1637	816	147	6301	7127	jx8wfjEKnUE4GjdFBUtp34C9KXftzecAmmui9vHt9HpEDftVwi9	5516	7791	7791	1617341580000
10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1439	1279	147	6301	7134	jwqrvqaEXc55bZsPHH7Fk9shYUSeZLDucEbWEMmJDu8WcYPkMnW	5520	7795	7795	1617342300000
10693	3NKtGtUuk7qGztnTVfMmVUhm4pvwd5K5BJGxtWvUWFr1sWTiFYY6	10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	700	840	147	6301	7135	jwdUqobWnHJfFrhxFKAEVWhgAf4nc72UzLUMh7BjpykxMv19dKd	5521	7796	7796	1617342480000
10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	10708	3NKRmGuWX1w12PiUubeP2g31c5oYG4DQcGNpJ76CPBwSTdJndz3z	1536	1313	148	6301	7147	jxobAUEtjEVsrVFmvSFP2xcVHoAuyDHaQ1Wg82XBNHhCUJ3VNSd	5529	7811	7811	1617345180000
10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	641	1336	148	6301	7149	jxcNKK8hmfhVBmvb8ZpRy9qLHYnrA9QEbfPFo8AA8fJpaGZjHSL	5530	7812	7812	1617345360000
10718	3NKFKQcpzmjuDaAG1yCG4YhA3fbtT8caFzjoB3pm3ghBrtLDtd8b	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jxfqCoTju4rjLHWcwLicTT6FE7mznbUh3zXCyptShS4YAhDB3P3	5532	7814	7814	1617345720000
10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	10718	3NKFKQcpzmjuDaAG1yCG4YhA3fbtT8caFzjoB3pm3ghBrtLDtd8b	1637	816	148	6301	7155	jwKaevKzncK7qjvgBE8t6phdq3WoeNGeqV5zc7yoqjbcaiDnXan	5533	7815	7815	1617345900000
10729	3NLyZQjRae4v8VT2kNMPUoaT1wSmJbEqffECNrCqMP8goy9j28MC	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1472	516	148	6301	7164	jxTPZwdE9SFh44qeBZY2evDytZbuuhQJ579TP3Du6oibLGnHLiD	5538	7821	7821	1617346980000
10732	3NLHiterrD8mUgBHoYxRtfngpTBqRjvQdunvDCYvnecnTF8errpw	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1631	794	148	6301	7166	jxv4KAYJ1o12qRCkkYnE5vw5rQZ32T2SGTWdG8LatqUCyLR1SFV	5538	7821	7821	1617346980000
10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	10730	3NLVPQFfdan37PLrtz4xFoXGwkTD4Z8H6LfAjPEYyQ1DXnmD8UfE	1637	816	148	6301	7167	jw7o7FkASttfKich5hSGY2fmzm2NaGNVaXy5HyAiWjLsEFrN2gT	5539	7822	7822	1617347160000
10736	3NKPjdFEnEL8khypKvjQH6Qi47tx22yGNejb6LYDZ7CerJ4yczRp	10734	3NK7Dk3E6Kcp5FJ7YEb6rV9vkA1DZW7KReE82n2mMHnnGw4fJmuX	1406	1393	148	6301	7170	jxDHRBzWDp2LoRShujoizrdrzuuBW8k4YF6x53fv2vLxGYHm3Wt	5541	7825	7825	1617347700000
10739	3NLDWHM9EcnS3C8i3Sk8cEpJRybtQZJrT6wCsSpFEXqcho2tVZBB	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	43	1064	148	6301	7173	jxF1KZN9PDos32JAtU3NdeimpBSQPWXNf89xiP8Huc7h4owd6CV	5543	7828	7828	1617348245113
10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	10740	3NLo1rhF71rAxdW3vuEtmaXSKhLVPqj6om5LoKvhCaY57cDdPm1n	484	1319	148	6301	7174	jxVWbdiRutdjcbVe2iQrrXEtjo42Hjfb4GYFG6cQwzpSVbx3yHh	5544	7830	7830	1617348600000
10746	3NKCs2hDrFWM1spJpvBWR51r9jTPFyMQeHxwgXKyUK5YYD4oPErt	10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	1501	1114	149	6301	7179	jwwtoPaRVHRcHcVJzKxcuaYUaTebBbPRCYP4dQBLWgrdiJgXTsz	5547	7833	7833	1617349140000
10748	3NKsm5gxfC7sQwpgYrpaSxYxnPgSo9M6tVucT7R8YJpoAmBgnxzV	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1483	534	149	6301	7181	jx9DQksmuRzGqyNSb3xZvqmAqQGzrRz3gYURPbxEdVR4F4gJQeM	5548	7834	7834	1617349320000
10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1617	922	149	6301	7187	jwvJTdsbsBPmUo7TFznVuRZhngKw1eRF92fqGeqKp8Qp9gS8Z9u	5551	7841	7841	1617350580000
10756	3NLLEr98Ckm2VG7NYrgb32dhDm937TcvspwLgTyMy2LcjwSavPK5	10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	1594	960	149	6301	7189	jxnZFJtYiJ5qMh1VLEFctogQpAzVw8Bif17PHokGEW7dreJUgcY	5552	7842	7842	1617350760000
10759	3NLa1VoNWP8Upj6xTv3iytNHP1M4iMyM6QBxJVakPNtXVHsBX5m9	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1448	1311	149	6301	7192	jxck4hApYNMNKr4T9fg6Sd3oRXhQqodyG3ctybL1LcKXfMkMVNQ	5554	7845	7845	1617351300000
10762	3NKCtDQYja9A5og5vpm4g2MPCSufPhsJZUnSrySDGfrZ3iV6nEwx	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1581	778	149	6301	7195	jww23BA4kENiTfaSQ1sx4tCjzt2qUyc7WWzbSkoB69nZRs8Du93	5554	7845	7845	1617351300000
10763	3NL83knf7cSqFsc7LddfiV9BjW4vEHiWnFjhGLQVtcfCiNid87gR	10762	3NKCtDQYja9A5og5vpm4g2MPCSufPhsJZUnSrySDGfrZ3iV6nEwx	1407	1395	149	6301	7196	jwJL5w83Z7h53cEwmbevoDMgbMUiuUickuyHhNYar6xLAXYGKGK	5555	7846	7846	1617351480000
10767	3NKB8YVRDRGHQZdZiGJ44BDdGsEVLosrHuDo2USyfh1APWFfQ2uK	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1631	794	149	6301	7200	jxurxWu7jdQtTJJ14koBvrAxXbx3KPssqMpuBtQCdJ2TNcxwDYs	5557	7849	7849	1617352020000
10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	10765	3NKAS24DBmE7rJ5rh2NWyTaGQCgACP762qQFLnWRy22KVbj4qb72	1407	1395	149	6301	7201	jxCa4Hw634HRBFjF1ePYeuL1wqGvmMeZYdbdLaVh65T6RADEqdz	5558	7850	7850	1617352200000
10773	3NLprWf3UzqkE8s4s3Ruh5yiwxcJjZXTEhgX9zyYdAqqDuNXrzVz	10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	1668	1370	149	6301	7204	jwZwZR2r6JKVt66TktWKsNjX45KynmuxNeAPEjULyUsBjsBTBg7	5560	7853	7853	1617352743030
10776	3NLTvMeFQEg6KAuyTjqfSQ3qEjyUtvAveVW1qWcFq9YLD68Vwmu5	10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	1457	1145	149	6301	7207	jwQ7Lf53s4BePFrVZ6ZDVZ724sCQ1xDzFjh87LkLzhjduv3m4Hq	5562	7856	7856	1617353280000
10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1402	852	149	6301	7209	jx269n1k9YiKfXq9XDoBp6WPtDZePxRDouA33oMVouK2HBFSue3	5564	7858	7858	1617353640000
10780	3NKSTM9nsTJJAcKjHgG36jCyFPCUCkt2mQdojuxXnfdgjHSeehe6	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1406	1393	149	6301	7211	jwWxF6njYZZm6r8nRXCJW7Am8fbMtfSTKUxE3cJYWmNQ5BrKQzQ	5564	7858	7858	1617353640000
10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	10781	3NKyW4GBoyVuqNYNjyCcE8sVkzh4nkGFXtXgbWLcjynd7fcuhwpa	1553	776	149	6301	7216	jxVDHs5hR2jMu5nChwZwtnGyJMQqqodDgSg4Nehhk7PVwjWJUmA	5566	7861	7861	1617354180000
10791	3NLcS3zFdu2CBsNgwNLxVLnzqkCdKg7RHiGWP2X5waCgtpbXJEFJ	10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	1405	851	150	6301	7222	jwpUeYffxV1ijxavJq9kRBfn9pAy9psMGKDueVr2t9jpehNbxUb	5571	7870	7870	1617355800000
10794	3NKf8zAwJDjZjLConRLEoqXfqb1jfYmydHhaLFKGXm1vBWLXfpN5	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1672	1159	150	6301	7224	jxB2kZftrRTr8BWyH3DaYVuoZhHAFYpsgLj3ZmSLSNC7rMxGKr6	5572	7872	7872	1617356160000
10796	3NLPBGmoaN2KiLXbFd9bxhC5MHCDU61fGbxf6RhkhgNaVDm4YUsD	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356341727
10799	3NKyFLqkJGb3vSqxUpSmyhTurVcyDmf8ybrebYLv8iQ4nUknBS35	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356340000
10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	10800	3NKbvS1EsmrJXXQpJKqREEFjJvnhbaw1R1K4kLm1WELuDSW3vwAD	606	1169	150	6301	7229	jwCta33zGgr1R3gxVZQ1F3Dcoz8LbZFzt7bX6khYuSNHGSs9bf1	5575	7877	7877	1617357060000
10691	3NKF5iLbtQJWbWWVmoLWsNbpq9x5otjRaM9TQ9goP7QrJzuqtzEH	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1457	1265	147	6301	7133	jw6vJ2Q9NQrfhK8wC4i4QSAt2eUfJpEG8kEZWQ4CV7jNsc2fjgH	5520	7795	7795	1617342300000
10695	3NLHmQggG46EEGbQ8WEgFAic8Y1mLHZfJDtk52F4Giy7Rb2CGLmv	10694	3NKH1ejF2aUzfW5ZQwrh3Wu9jZzi1M8oZoTLwAQJNYULfWRPdwro	1406	1393	147	6301	7136	jw8Ut4C34j2WSN7csXTxEEm1dXusPkPpfo45tmZBn7JRNqDuQho	5522	7797	7797	1617342660000
10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	10695	3NLHmQggG46EEGbQ8WEgFAic8Y1mLHZfJDtk52F4Giy7Rb2CGLmv	1406	1393	147	6301	7137	jxp1p9ESGHc6v32Bknh5xwv21N9sM1iTEgyYwgvHgsFKgKyATbX	5523	7801	7801	1617343380000
10699	3NLK5cYV7Acgfdoec8JrjQ8wxmEY699u8tWUGMjcSoGW2toNYvvq	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	148	6301	7139	jwQVzVLhAodWqxCMkb3Z6W2UdpmEnuHiv4FpY5MGRGpMEqSzrZG	5524	7802	7802	1617343560000
10703	3NKXZrcJXonNHHjbpC4xvmjuvqfKCkgVwXC7zG5xRtsjotcAqZyg	10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	1631	793	148	6301	7141	jxAQ6nrDYFUR5iDF7aLiEMsqDaMsLnad7vP9vMZEykxvwp92bkF	5525	7803	7803	1617343740000
10714	3NKtjPsoy7KEyVXZwYwoaDWYrsfUSiNdcLPSqg5qFDmftDtFgaLf	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1553	776	148	6301	7151	jwjZRyej3RGRkkBHUGdjCC7ur9uJfvJBm7zRrAzcVmSZUwLPqww	5531	7813	7813	1617345540000
10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1589	1286	148	6301	7152	jxXThn5DVpNSp8oj1s1KfwgeSuFYSUNqhVD2JPNXSPAm96xfaRZ	5531	7813	7813	1617345540000
10717	3NKFZ7cHiJFb9NmMVBJZEUhCuC8ET9uc9uyeoGVBs8gEba6EeBL6	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jwoxpr64UpGBpSRsVyQtxdtRyasqYsYKdA1Tq2kRhyn9yPpEUNG	5532	7814	7814	1617345720000
10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	1553	776	148	6301	7157	jwjbFA5e2ry4vCpdUdEAMeC38g2sHD4Pjfm9B1pEuibbvb8czfX	5534	7817	7817	1617346260000
10724	3NKRonVAQFzqCgpjsce9QdgVAEFsUVwsquxkiKG7cGG91k8jt6xX	10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	1579	1389	148	6301	7159	jxBdH1sm8nwro9gGdwM5XMqSae1WX4ZKU5vo7GAfY1PPTj9YYkT	5535	7818	7818	1617346440000
10726	3NLb3N8qtvNYQwzZJv997h6UsA3XTrLy33y3ukL1gWaSL96ynbQT	10724	3NKRonVAQFzqCgpjsce9QdgVAEFsUVwsquxkiKG7cGG91k8jt6xX	1407	1395	148	6301	7161	jwJtUhzFj9ByoyAeJh678rABYo23VgPFJDv8JiuVHRFZd4Exdrh	5536	7819	7819	1617346620000
10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	10726	3NLb3N8qtvNYQwzZJv997h6UsA3XTrLy33y3ukL1gWaSL96ynbQT	1609	1207	148	6301	7163	jxxHRyA3cxf8bX4jbssQ4Kah9YbswBaXbQhtB5AwkeaAuMWMjWu	5537	7820	7820	1617346800000
10731	3NLHHkduynePFkcR2N5E24iQJ7VtCPZxNnUonnyCngZvwng2QxRX	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	576	989	148	6301	7165	jwoqnrRcPBBakLvF8MMXoDCCQKY2bKN7ZPTXxDNUoyfsSXWUShy	5538	7821	7821	1617346980000
10735	3NKfupUptDpf92FfaX6ReF3UfCsyPvAbCidZUYQCNvQYRfWMYZV4	10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	1406	1393	148	6301	7169	jxnSJ4yLNxxbjb4RsHvbmLu9KCWtfDH8PRPATFRKG8RrQTs6MJM	5540	7823	7823	1617347340000
10738	3NLv9ubTFpu7ztZpm8wGZZkG1GshEMXsMu4dRXDLkv33Qy6mL5H8	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	1407	1395	148	6301	7172	jxTwxaPGyF2x7kY6mkzjyN21sELQaXsMS5tBw1MgZGcxxZd1nAF	5543	7828	7828	1617348240000
10751	3NKnFNpfBP1QNsfjEKHpwwPvpbtVpkAnNun94EGz6mY192rRX3U1	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	606	1295	149	6301	7184	jwLqkTf7WnuRjD7SQGp4AKJjW5RCuuvbBb83iH6qHHnVNB3bw45	5548	7834	7834	1617349320000
10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	10752	3NL6xL1rRaPveusHcLMvUFJu2VyBJaRL37X4MdgyivMoV6a8Y5Jk	1541	932	149	6301	7186	jxBAd9oBKXfH9W4guPy1MXNEeSMQ37hVQRDuyj8nBfMpzPwUNY2	5550	7840	7840	1617350400000
10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	10756	3NLLEr98Ckm2VG7NYrgb32dhDm937TcvspwLgTyMy2LcjwSavPK5	563	1113	149	6301	7191	jwAZNhRbnVREK3EGb1FdpwVrrpLnd91E6KX6eVW2Ek1KQha78ZT	5553	7843	7843	1617350940000
10766	3NLtxrrkjQC69R7wCcaGQksgyK8PdTLxtzrumVTgYq3YmQWvKdcR	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1406	1393	149	6301	7199	jwKHpA1xR5S2NRZkogUXF6YZz783dGUpRMd6BVPpv2VmcokLZtR	5557	7849	7849	1617352020000
10771	3NKJMu7wAbwQYtHrigfMWux1ywjeHY3MAkAsUX8FJK3FbcGYcDf4	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	1422	1337	149	6301	7203	jxEcn4EJQqRZYEMdFXXJGnMVMAy5vhMhssNQJGAQQHtYhemtvTK	5559	7851	7851	1617352380000
10775	3NKJoodjsPc2jLXkXx8XqCitJFFYz3sbj48irATvpZn9GxpoqNv8	10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	1602	1369	149	6301	7206	jy2D6ByEJFdfsaJedLX6iVi3v2JCMeVrNBhhrErV7YE7ozAXrp4	5562	7856	7856	1617353280000
10783	3NKxdFknGmy6iGp9zjA8jdJ1Dw1wr1ZVYVSPpVEsx47hcBovkyid	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1610	1314	149	6301	7214	jxxyPLPW8WmhPTv2PYDgDZMWEsna4LCXq8XyVwWDH9kUYFojXPT	5565	7860	7860	1617354000000
10787	3NLnvRXCRBCH2iEWMvFGba5DgBs5tMfv4VqDwLAdBXY1bCtQg1ke	10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	1406	1393	149	6301	7218	jxJjG9uPHMcQDuaThGJpnZsbxGGsMkErVoWdGdUCWPQx32A5MqM	5567	7862	7862	1617354360000
10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	10789	3NKJc7tQR9jfg1Gcn6SGKH5EpxTEcTBgAgjjT2ttz85G242TJP87	1559	1353	150	6301	7221	jwisgfeL1LxBMsTsRiBYAySincAb55ZnJnVPVpAFNjjPRzp2jeS	5570	7867	7867	1617355260000
10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1672	1159	150	6301	7224	jxB2kZftrRTr8BWyH3DaYVuoZhHAFYpsgLj3ZmSLSNC7rMxGKr6	5572	7872	7872	1617356162920
10800	3NKbvS1EsmrJXXQpJKqREEFjJvnhbaw1R1K4kLm1WELuDSW3vwAD	10799	3NKyFLqkJGb3vSqxUpSmyhTurVcyDmf8ybrebYLv8iQ4nUknBS35	576	1229	150	6301	7228	jxbJMU2Bmk9AxH4KkjhJK4fThWjFPuzeTnEss8w1PaMDJR1uZzX	5574	7875	7875	1617356700000
10803	3NKD9j77whMAqsZM3aXxPDsFQKspBczTYNfCyk2E4LsbzufutKgE	10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	1483	352	150	6301	7231	jxq9dtVq8X5VLQWY9AT8A8pAeg1s5ne22ERhHBezDcbyEAQxLZc	5576	7879	7879	1617357423166
10817	3NKmhEtsnuQN5BjWwKsG31A3gAC4x8bTd6fHM7DQSethBykeLYHn	10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	1402	874	150	6301	7243	jxvKc8JskLaC76TFfZdQkCfb2vhFmGqDJ9WfhZi2McX7nFiX97e	5582	7887	7887	1617358860000
10819	3NLyTQfpMPusunNTiW5kLsUDKayBUC1NftpJWc89UVHYjMNVCSv2	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1668	1124	150	6301	7245	jxcr54MEZvxbBeHk3qCSnX3DqviX5LyAcnNupvBSZofkoan9EwM	5583	7888	7888	1617359040000
10824	3NLM9gPD4VL5ftSbwMWh4hAN7EW8BXzohLVqXFjgSd4SCgrQfuu8	10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	1631	794	150	6301	7250	jxmJKSGqKEyfn4Bx2uVyu531cYuN5xsrfmyRmVBvUxha6rS25iF	5585	7890	7890	1617359400000
10834	3NLpjSjM1rLUPYpH5sqCJfqkFFdKQwWaaDPkTUZag9PeseLQ8izD	10833	3NLW6nLkpdTjSC4yDYxErtWSbY14r9fjDYidgEHfkQ4cocCDA7e1	1503	1277	150	6301	7259	jwpL2AUHZRgNiqhyStKKfw1S5j1UAHp4JfG568zSXs3syLkCdhR	5591	7899	7899	1617361020000
10837	3NKC7thfv9fpUYRkJjayaLBLGteKwxRMWwefFdCAGfBw3A2fjovh	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1675	1342	151	6301	7261	jy2a649Q2K8w4nA7Zp3PXcyUpDtHjWigezfr8UfKHDPhY8Tgrm6	5593	7901	7901	1617361380000
10694	3NKH1ejF2aUzfW5ZQwrh3Wu9jZzi1M8oZoTLwAQJNYULfWRPdwro	10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	700	840	147	6301	7135	jxuHoa5PtECt7mV4GC7Dr6pXPxJ6SmvpFnfoiuj5LqUuQfMLHDW	5521	7796	7796	1617342480000
10697	3NKDfXTmkHUzmN9t9uXj4A3uXrVtKzDRsJ9sFLygE6qS2C3fnkNT	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1448	945	148	6301	7138	jx6wdQChfv7ae9R3XiyygtbVn1G7wS2Yq4AfZS2kWis9t5reJGd	5524	7802	7802	1617343560000
10700	3NLmoVbZh2QvUcjgiucnsBbEjHWdWjca24HQenmA5aHL1e8kh1yj	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	148	6301	7139	jwQVzVLhAodWqxCMkb3Z6W2UdpmEnuHiv4FpY5MGRGpMEqSzrZG	5524	7802	7802	1617343560000
10701	3NKRapNhPbDSCVuPn4F5GjhPffYNvkYbfxk9rQwbEXwjqUCqwEdK	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	147	6301	7139	jxUVuumjFDybaWqq7XtE1Lc25E8mrkhgJaJvqmzLpzXm6MCeQ83	5524	7802	7802	1617343560000
10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	10702	3NKu9dkqou3AYYqRssxdDvkEShKztc1c12dDmGd4XJjBdFEeX2ZF	1673	1122	148	6301	7142	jwnqsK62wXd6c8AAzPhsfed4jD1YgExH8RmBhyvCQry5vxVHr3i	5526	7805	7805	1617344100000
10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	1508	1261	148	6301	7143	jwpXRAbE7PqkM4fuGAeM5AWdbQp7BRKLRqwzsSUynLiTZXgNZ77	5527	7809	7809	1617344820000
10707	3NK63gx1Q6PMQD7bpFZByfdWWwW9P6uQf8oiBnAwPa6qH8iyvTRn	10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	1613	1349	148	6301	7145	jxmkPpQ9YaFNrYg5NEYfgtug63NcimHAmcbfrzHT7bQK1LyLz9i	5528	7810	7810	1617345000000
10708	3NKRmGuWX1w12PiUubeP2g31c5oYG4DQcGNpJ76CPBwSTdJndz3z	10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	1406	1393	148	6301	7146	jwpNsPyv5zLaAjc1EHkjJATcHGmS3nyhwGBcNJ9kxRteN6FHwHe	5528	7810	7810	1617345000000
10712	3NLPBCj5BE38q4fbArQPKHvofrThx7FnWB3pMtijfA66HhD7yAPD	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1547	1252	148	6301	7150	jxFeQvEa9QxJKDjRFosNLXCtXezLaCHFRr5nYEU1to96RDLh5qx	5531	7813	7813	1617345540000
10716	3NL9YsXKiBmuDmNgcW5virfpNwNtuQUMtdqfGnaGcHVeL7oH6NXy	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1403	824	148	6301	7153	jxML8HXPDzyQxcDpToDBeYQ7tzvUL8H45ueF2ZSpYD46FrJjUFy	5531	7813	7813	1617345540000
10719	3NLW9KZxFS76E1CQrUXam7dmZdVxReZ22w6ZFCoeGieNWjmtrPAF	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jxDEZsMeXgc44KJoeSJyJqr7mr8o5v8qTwrstL9Pu5rQt87HmaX	5532	7814	7814	1617345720000
10721	3NKAUo6JCvj2f6waa79Q7nnaUBzupdPadXAfTSZz6pxGSCcCxbAP	10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	1518	788	148	6301	7156	jwgqL2UFP6MwpayLB5gxhvJutkh8tj3TE2kzn5rytaDqCk4Jgzv	5534	7817	7817	1617346260000
10723	3NKrXSjuDGGW5Din3BanNeRo6tSx24amkWchy4fcBouTPDU7274B	10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	1593	1100	148	6301	7158	jwvSsGxbsnAFrwtC9ejhub4qqYHnwoAgN2spS3SZPPo2C56vDBk	5535	7818	7818	1617346440000
10725	3NLGvS2qyFZGw9C4gt6RUbGzp8xLHiRs2v6qGpsN912V9foCE3F6	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1593	1100	143	6301	7160	jxPmXEyjysYVYaPeD2s5GrATniFMQan7mPfmW6sv5Zq1J9eETCN	5418	7818	7818	1617346440000
10727	3NK8oB1mHhmzSDPMzFrGxpnty1finbhL2ThxbmFzXsY8xUdmB2Ph	10721	3NKAUo6JCvj2f6waa79Q7nnaUBzupdPadXAfTSZz6pxGSCcCxbAP	1406	1393	148	6301	7162	jy2yYoM3zoWeQ8WijhR5fm1KUMhh3k8hALxZ1gTaefD2P9HjjRt	5535	7819	7819	1617346620000
10730	3NLVPQFfdan37PLrtz4xFoXGwkTD4Z8H6LfAjPEYyQ1DXnmD8UfE	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1472	516	148	6301	7164	jxt1ot3igQHcU2J5kDVHubTVQnCCckBdAuY29bQfkTaEfKQwHje	5538	7821	7821	1617346980000
10734	3NK7Dk3E6Kcp5FJ7YEb6rV9vkA1DZW7KReE82n2mMHnnGw4fJmuX	10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	1458	1077	148	6301	7168	jwtHr1U4fbixooMsC8dHM3pv4FKmnt3sKdrAnvYxYaniNdpfVUi	5540	7823	7823	1617347340000
10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	10736	3NKPjdFEnEL8khypKvjQH6Qi47tx22yGNejb6LYDZ7CerJ4yczRp	1406	1393	148	6301	7171	jxkMswY6gENzArFfBfxoNdz7aBe4GuJKVdDcGiYaE3UA4RTPneg	5542	7827	7827	1617348060000
10742	3NKBLNvTQyaqAk2NWHSamZMTeDXjaFVuku6SYXeCrXjBmYrJuQHc	10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	42	995	148	6301	7175	jxyChKP2VS9DJX9cQxAaPjxRW6r2pjXMUG3oV7MNibe49Dba7TN	5545	7831	7831	1617348780000
10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	10742	3NKBLNvTQyaqAk2NWHSamZMTeDXjaFVuku6SYXeCrXjBmYrJuQHc	1553	776	149	6301	7177	jw9de6694bmkqjofawtSFGLMqW4ge3cXXingsxZMrnspcjFwJH8	5546	7832	7832	1617348960000
10745	3NL5i8QLNHUarHmdB6U3j4apm78cwi1i4jPQz8KtarCfSRiJQu85	10743	3NKDvZYfXSDM9KRjatv6H7q9qnHkTYQ4HcZCnK2DENp4QtrAPTRC	1419	814	149	6301	7178	jw9DRGzVNRPLpgKXE6g3k8vECyvdkEsLYi3dnLxEYbiCL91gTTy	5546	7832	7832	1617348960000
10749	3NKxnsoVCd2hEcnaUDWSCPXyXh35HUtfPj66r3GgWkn2pXkrVW8g	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1657	1098	149	6301	7182	jxXUtrYe97bVDUifo78EmtAqjkVQABxLm8DgGzubb81rAUm9UmJ	5548	7834	7834	1617349320000
10755	3NKLnLjoYTbaMEFAg1pa1JgNxUap9x785K5pR8FeginqmARGgW2Z	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1455	1206	149	6301	7188	jxBxPUtF84RhRPJan3oxuiX3renSeJtWMjbfTpesb1YGRGtqFf9	5551	7841	7841	1617350582979
10760	3NKVko2YQ2VnreqKXnNKLjiMWxWBtRwXfLkrgZktUKpRrP3rFVvm	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1543	695	149	6301	7193	jw7Vob4KqCq8EyAEjWC4kF9BDJ13BRecShQcFbXBs8Qq9YSY4F8	5554	7845	7845	1617351300000
10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	10763	3NL83knf7cSqFsc7LddfiV9BjW4vEHiWnFjhGLQVtcfCiNid87gR	1571	1335	149	6301	7197	jwoY9u7moxQA25z3qVjwzxJMANqPnXHepG2eLcXJBnCbP4wk8WA	5556	7847	7847	1617351660000
10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	80	1027	149	6301	7202	jwqJ3fnFePfgFUHFpptc2sn531acRbnpueEcBdTtZz1smdFxKdP	5559	7851	7851	1617352380000
10779	3NL5WS8ka5FTjCpuSY9BfUuxMiEGgFj64W8D2T3WZsD1UA5VojdX	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1622	1110	149	6301	7210	jwWiuPWYxpP5FWK8NuQVYy8zjrZYyowBJ5YQispcPgHDB4MYX4h	5564	7858	7858	1617353640000
10781	3NKyW4GBoyVuqNYNjyCcE8sVkzh4nkGFXtXgbWLcjynd7fcuhwpa	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1602	1123	149	6301	7212	jxbgifidCtWgumMASM9bGX7qqQrW4xqNsuTX7nXJLbD1y1GJkZP	5565	7860	7860	1617354000000
10788	3NKMpewyVyi9HUFvwSBJWAdgbH3wTJAM8QWa7qySyZVQEUKkiGwC	10787	3NLnvRXCRBCH2iEWMvFGba5DgBs5tMfv4VqDwLAdBXY1bCtQg1ke	1501	1114	149	6301	7219	jwXR8cGBwgL8XrxHqTVtbvoF8KMiPeU4F9yw3WBpMGJd93MwERJ	5568	7864	7864	1617354720000
10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	1406	1393	150	6301	7223	jwTXH1qzykBMG8w2XTpJ2peSbGMxD2s8cSubdFEVbqhHSGprRqz	5571	7870	7870	1617355800000
10795	3NKb6CFQfjrvT4nVC3n3wZ1PpBdoCwSAJJ3tiSKu3m8v5S6jAY5L	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1564	1338	150	6301	7225	jwNZfWkcNwsmADgKaC664gcEg9ZWdcvVGLnMQsE7wiJ3riS3ZPy	5572	7872	7872	1617356160000
10797	3NKnU16LZteTnuFffbAcu1frFsk8vnobMJgUmrCZwYqYQgCA1jYh	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356342847
10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	1483	352	150	6301	7231	jxq9dtVq8X5VLQWY9AT8A8pAeg1s5ne22ERhHBezDcbyEAQxLZc	5576	7879	7879	1617357420000
10806	3NKcqD84kWDV2LjTuikNujAyyYgNugFGfWqX13aUon1vbMjggpv4	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1649	1383	150	6301	7233	jwxb4yqzDGeFKXsgFSXMpuuMqsPTzvUoT8PXM7X9eyKPW53MdXF	5578	7881	7881	1617357782960
10810	3NLuEebmPXk4q9mNYM9LnaNF8Brkkp6R6auuUMaYyVzS3PTX4q7s	10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	1490	1148	150	6301	7236	jwD5sFU245AdPzLwMkjqfkK2RdekhhPP5scQZAqXxPR2WbHxFsY	5579	7882	7882	1617357960000
10812	3NKuPGwSBPEu6a8LjLCYqWLDzY9KPd19oh9r6WeY3M7JSJBKEAT3	10806	3NKcqD84kWDV2LjTuikNujAyyYgNugFGfWqX13aUon1vbMjggpv4	1490	1148	150	6301	7238	jwLWdVyd9sfuVuFUwFVsK7xdq8aUDLVcx1KBy5WdFkd9SApvsUr	5579	7882	7882	1617357960000
10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	1407	1395	150	6301	7244	jxZtqfmQyDN1vGe9QiVsM92sWEizn9LyF7UTBbQepf2Gd6M58Jb	5582	7887	7887	1617358860000
10820	3NL7SvkhpGyQgBHj7MCWxFHJ1xpvKbkeyaEebcG41VhQbrBba4Zg	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1622	1356	150	6301	7246	jxM49NgkhuwvdVE2xdsRUuL9p3xeE9PZqRjm639LYoC9StvaYN7	5583	7888	7888	1617359040000
10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	10820	3NL7SvkhpGyQgBHj7MCWxFHJ1xpvKbkeyaEebcG41VhQbrBba4Zg	1596	1363	150	6301	7248	jxjFnbYf5ut4RPahvEJhKTdRpTBTGoFad9RGScXdf6qTskrZp1E	5584	7889	7889	1617359261109
10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1647	1056	150	6301	7252	jwfQtFvTQWeiXw8CFDkEtgMKt1Noqf1GybxjpLu9aAdJg45eani	5586	7891	7891	1617359580000
10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	10828	3NLfQErvDqwoKW7qCQrHdxipNoLRAJBvYd9mVnuTk3fy1WUSEkzY	1596	1363	150	6301	7254	jxTXErBxZ2v9RrVSqzNfGi3rQqo1vP9y8nzmDbY8M28PtdUmgrG	5588	7894	7894	1617360120000
10838	3NKt2JHsVGypWznDTte91CAHy7ViGfMmNBE7h45AFboQDk1z54to	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1631	794	151	6301	7262	jxDhodQTan5gD8gzB1h8iZEuzLb9ZuymkpvUhckmHCPUvG2WA5K	5593	7901	7901	1617361380000
10839	3NKKrfMEkz22Q3kRt7wjfQeTEaRs3sDQ1Hf3Lu6af3HXKu4czeX5	10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	1402	874	151	6301	7263	jwmYTfBrcRUypcjkjZxyndUz9GvvtdHfLhMKXpAAPMVKzkXoeHk	5594	7902	7902	1617361560000
10842	3NLX39bjYSJ64dHS3kdaCkuugJfLKos4QuAoWjVETBre33GJ58EV	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1457	1391	151	6301	7266	jw79j2VTy4kGZjcLL8Dsz3HbaXqEYtakchw66obArA732L6R5G2	5596	7906	7906	1617362280000
10847	3NK3ToEqLCRU1NM3LvU5LweeBGqJEzYiSMp1GaBFwqSHydT2NU9Y	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1402	874	151	6301	7271	jwDLVmcBY7TqGhGfWEqD1gxkTY59y1XZWbarBPo7dN9zj2wDRNR	5599	7909	7909	1617362820000
10852	3NKV8ZKXdktzDJRxZqLdPWQHKFVXJ2SbQ52CduXagSrM38snoBZf	10850	3NKru5geVTUJE9aossWY9eFtgSGgLn8xzqmC6VgF7spNQ1GXtRv7	1407	1395	151	6301	7276	jwAeLWAFNzkposhRt8vpBy8udbopB7awbrC712449ytMig626Fs	5602	7914	7914	1617363720000
10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	10852	3NKV8ZKXdktzDJRxZqLdPWQHKFVXJ2SbQ52CduXagSrM38snoBZf	1581	778	151	6301	7277	jwuTG1Y41qjuG5fGbXbLvFvfRiWEjEYPYLwUTvvE9qNgYfutQVN	5603	7917	7917	1617364260000
10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1483	1030	151	6301	7280	jwzDUd52aCgnpY12c85FrmkkFJE6rAYVYCXXyV8tKSVcCHnFZEu	5605	7919	7919	1617364620000
10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	369	946	151	6301	7285	jxwRGwF4M5BgqKZF6V8yV1vRR4q8jeNFdqCNsU6H1HbEwL3xgPB	5606	7921	7921	1617364980000
10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	1594	1326	151	6301	7296	jx6uco6yVwcMENssxNrH7NLmjXZUPD2QxtXvf8GVGJ68TL9UnNw	5610	7926	7926	1617365880000
10874	3NKcmgPvn9d9Stmkt7mjTqGHpYXmMfkTMjuHmtJ8mMqYwZGMBFuQ	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	1590	934	151	6301	7298	jx7zCWFDh4TaRD2UmCFhX41swxKPGmJNt2T6nRUGR9Ff8fEgTFz	5610	7926	7926	1617365880000
10881	3NKpYdipmAjA3m74GJn7DXxTebhmN24X4onDxDGmVMpRW6SPQFpH	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jx8QCUkNbe9tJmQYsMxh81mLURsmSBsFN8i4BZHuqvJGcCDQzwE	5613	7930	7930	1617366606915
10884	3NKy5hBKLGr8weJxAv7WCjthTW4pgKzP3jdp7kCY7wTg6xwxKR7T	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366606167
10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366600000
10887	3NKfHYHgjrnR2td1UX8zNe8oGx4gHsCgJxMWBZU49UbcWHnnicay	10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366783496
10889	3NL6TUmRRnVrhQE9Q9XUD7WwPWBCmmbLQ6RWXSViniNM8S6TYKSn	10886	3NKS3DuPxopjWrqYgXt3B1ym7JAwdKCqo4cHPxfrZJWG9JkbYBrH	1649	1137	152	6301	7306	jwDDzUxfzu2xwr8EZXdgg4xtRakizjkgZ3C4A7vEcf9mibgBAdr	5615	7932	7932	1617366960000
10892	3NLhmsu4vYxaREC7HW3rj43a5kLMRsiWUm9xsafiFK5kPqEwSN4Y	10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	1451	1292	152	6301	7308	jwbw9ejWKDhmHUiMccqfrPJPw7S4iis6KxPXyNHypgtEcQ4K8NF	5616	7934	7934	1617367320000
10899	3NKJFcitYt859goJg5C75NegNDGFWpFBDdsjDGnRsUqwRa3VVg4V	10896	3NLujKpczkQ2qrfJw5TxvQHzJvjMPnNqpam4LZBEjDV2c7eCYVZk	1406	1393	152	6301	7315	jxFd93KqEVJcSdmYjaCaX4RFYCJdgEDMhAMWTaD4J5bCDijJfU6	5619	7939	7939	1617368220000
10902	3NKp8aKFgxHYgwXRCWqTjSvC5RFWitDq2wthVmdgPHSuABasaZra	10901	3NK7tX24vkoQiw2AWrsMw496EsP5PEKyyBSkLCgW48ac5nhDG6QZ	448	939	152	6301	7318	jxqeKMiXdXksdsGH74q6zAJjwLNpgt6JPkeSN7Q3iaTyxXaVjvT	5622	7943	7943	1617368940000
10906	3NKyLWJ4C9fKJpo3UTyD5CsyAWMW2V2TwpQsj2qtWqX6wenzDobP	10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	1406	1393	152	6301	7322	jwDgPqMeY7YqFnP7Cdg4G6YUHC1Djud8pyYXsqRtaYADoRzbBey	5625	7950	7950	1617370200000
10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	10908	3NL2GPoXZoR6c8w6sjqdELkVDKRTjURhvX8QbDRxseC39CkiZpn2	1406	1393	152	6301	7325	jxZrQ3danfudPzepFMntEpkP3dQWNyXKMaDdGNS6aoRPGgjRZkE	5628	7953	7953	1617370740000
10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	1406	1393	152	6301	7330	jwczqRqxMvLFxXwS5LEsMcfj4xW7JqxsYTMMUunxtycgMUvNvdP	5630	7956	7956	1617371280000
10917	3NLYHojYRKSavBLvJ8VEkCywgpxF1RpLFmnrLppuSfZp9cdWwYKD	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1403	824	152	6301	7332	jwbWSq1ZR6PwRedvTLggXtz2zKgKoLChTwFmnMg4YcZ9Z9xJ2W9	5631	7957	7957	1617371460000
10920	3NKxNSn8nDuLE9NPCArZP6NqzvFVhrpsyGromot8X9B1dHcxjRsX	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	1476	1371	152	6301	7335	jwum5yW7hKTg32PaxasNP676GZ6fmxWLoc9tLu1KsgTJt9ff9oz	5633	7961	7961	1617372180000
10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	1406	1393	150	6301	7232	jwTwVrK8xmcz7NXZue9udoagnFYPh7FUdjpsD8mvYMhCd6WAG6K	5577	7880	7880	1617357600000
10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1593	980	150	6301	7234	jw8TL2xjYSwQ6nUfSgYAFtsb96Qnc8vGs8niVcNTaFWnZQUFWAV	5578	7881	7881	1617357780000
10809	3NKLYNKvR2fe4JdD5fF1oizqarPLPref4jvettVxHaG387fNjhmr	10725	3NLGvS2qyFZGw9C4gt6RUbGzp8xLHiRs2v6qGpsN912V9foCE3F6	1593	980	144	6301	7235	jw7aWpssRjjTCAV2NFLsm3BgkavshhmLaguLBEpYc3p4tFB6M9j	5419	7881	7881	1617357780000
10814	3NKEgLJsiuJn2fvGC4Das6bqNxCCDPYReMSBDmgsVL86EEHMQGY9	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	1489	1254	150	6301	7240	jwNvVKN55xhn5qvvs4En1iUpTmySFeEtKEjdabAwxYv3JJDpYjj	5580	7883	7883	1617358140000
10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	10814	3NKEgLJsiuJn2fvGC4Das6bqNxCCDPYReMSBDmgsVL86EEHMQGY9	1439	1279	150	6301	7242	jwPSdNuW767Jwj11Ci7qALUPu168mpeYjoSvwfCDecGUAhyK3gt	5581	7886	7886	1617358680000
10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	1596	1237	150	6301	7249	jwQbasyTpXwsYd7sTFFc2hybYrEDjBeR1diSWeDQnwKB31Tz9A5	5585	7890	7890	1617359400000
10826	3NLV2qNAbVK8AxZvMGDAELqkicYh3Ax4HiV43VypcSenWng4zL3R	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1647	1056	150	6301	7252	jwfQtFvTQWeiXw8CFDkEtgMKt1Noqf1GybxjpLu9aAdJg45eani	5586	7891	7891	1617359584554
10828	3NLfQErvDqwoKW7qCQrHdxipNoLRAJBvYd9mVnuTk3fy1WUSEkzY	10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	1458	1197	150	6301	7253	jwSNrvFMZLRYRQ2nPrHstPnCTWPQWpw778PS25GTSuLRy3AxrMF	5587	7893	7893	1617359940000
10831	3NKi5s5GvYFPY21cdZLwEvTQxEcBHRVcbwk86VGTYMms3cQPtuwe	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1509	1320	150	6301	7256	jwVvLFZjc1dRwqBKja4DBeHZr7PrBwhWtDSZDfmRcs43Jj3prd4	5589	7895	7895	1617360300000
10833	3NLW6nLkpdTjSC4yDYxErtWSbY14r9fjDYidgEHfkQ4cocCDA7e1	10830	3NK4cKHuUxC3RCsYC4SJLKePiZHeGmEE5cEVFuJPXE63Z2SgT12o	1503	1151	150	6301	7258	jwxd41kMhDHxzFX5q1i14skGmvMGpzY17WM8gbC2tfNRm1ssK7S	5590	7897	7897	1617360660000
10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1675	1342	151	6301	7261	jxN23dJAmUXztUZEVBeNrW3ovn5HopmHSRLTgdRBK6xcMprZUA6	5593	7901	7901	1617361383154
10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	10840	3NLCJk7JFKJqR2XgrPp11AfRKe6oXUEVAzNyi1GQ1a6H8LnxaEd7	1402	808	151	6301	7265	jwsYRmPQ4khTg3uLaggo5sgyMPwNRnca8UwxMeQ2HfR5zVEbfUo	5595	7905	7905	1617362100000
10844	3NK3BdexpMijsYEsfo8dnzraqPEZ7Y4TcVCHKcghiZyRhtrvgbt3	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1617	1162	151	6301	7268	jwpJxP7cVAmkW4DTYRad2K9qcPJpJq8JEyM3GL6vxtKSsYoFCJB	5596	7906	7906	1617362280000
10851	3NLxq8dcPQoNd2123a8Z7VWcXP11ZvixnBcW9AhHcqt5KgroLLvY	10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	1458	1323	151	6301	7275	jxsswkSVSQigMXAG4uUpWhtQaN19WX5wiHNWGDGBYiBrLWbjrfa	5601	7912	7912	1617363360000
10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	1406	1393	151	6301	7279	jxZqoe1tCvibmr88zhpZs1bBj9R5s5eMqBHX6ZxZX5MMfbn1nym	5604	7918	7918	1617364440000
10858	3NKFEuZbaEgr7VFpgn2D2P9RA1Tnhna8m7jctbdwePKPzmG7GhVo	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1509	1320	151	6301	7282	jxPwMkM8hnouwU57DgUxwyyZvKUUEcykfK1VUgmacFt5UDrun3R	5605	7919	7919	1617364620000
10862	3NKy9rirRWqYva92tLfJyphpxTMiW5zxrLRcyw4zFPSyUsKhB4HB	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1575	473	151	6301	7286	jxngErQuMTwFVftrMXyaHoDgkgVS68avgcYVvgmsKDdSDTWSAhM	5606	7921	7921	1617364980000
10866	3NLoBLXj4xpJggwuwC9ypAnNZdsYKq7WCuTUr53xnKK1QaA7dTcZ	10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	1445	1290	151	6301	7290	jwiukPEq6cYVFgw4fQPtnTPzsnAbiXALb6hSx18Rs8e6UFYRMsB	5608	7923	7923	1617365340000
10869	3NKD3MegHvSLVyJsJ34Cq1JyADcWKB44vEPjxW9GgUZYhu4k1Kf3	10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	1402	870	151	6301	7293	jxnJ52bUAcYwP8KUxPwESgTuB53H5apciwnYcYE7kGrSzNik4j6	5609	7925	7925	1617365700000
10875	3NKURnqB6jWenKyqGRBr6qakYRx9hUt5vGebrAKsZajkBpxU6STD	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	484	1073	151	6301	7299	jwSQ6PWAtJz8d5mLiCwxnXAS2VomsWqpRqgd1oW3moHhKrtv9AT	5611	7928	7928	1617366240000
10877	3NKjeXkQmQ6TYDuBFcDsJiP4axCKT6m5Eg3M7iChyNo256BbMtdw	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	1406	1393	151	6301	7301	jwCan7USY2Xi1sz91BdNs5mXrxgiu97LWRXnPr6GJ2KpQ9ZxwNJ	5611	7928	7928	1617366240000
10886	3NKS3DuPxopjWrqYgXt3B1ym7JAwdKCqo4cHPxfrZJWG9JkbYBrH	10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366780000
10888	3NKysARTaEkVoA5X8zmRVh36Ey3GN6GbVdt8qPKm8cxMP4DvCNev	10880	3NKYPdZBmeZ4vMxae7qYoJni9F4ykaFkrWbXEf1hmBqtWTmEFftx	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366780000
10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	10888	3NKysARTaEkVoA5X8zmRVh36Ey3GN6GbVdt8qPKm8cxMP4DvCNev	1406	1393	152	6301	7307	jxgGWGwo1L5KvYsAtmgXF247oD89usG7kmF2LTSnJhaGZ3sm5M6	5615	7932	7932	1617366960000
10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1564	1338	152	6301	7309	jwLTR2rrztcqCU9PF8Wbs8finpjK1XKz6fQbfdGGsHBmgv1VB9N	5617	7935	7935	1617367500000
10895	3NKnMtVx8AUb7nv6Q12F7WeW7UNUVQjLrXAaU17csiWqWWuchayR	10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	1581	778	151	6301	7311	jwS4u1a257J7jS8Vvya1z2TFeyDwG51d7MQ6C7Vy8mcPZsTQzki	5604	7935	7935	1617367500000
10898	3NLtRH1hNhahuGfvbH5XJDNVyWwCLpB64i2FfXYTphFrjDhfrioW	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	1406	1393	152	6301	7314	jxuxxmZAjwLfWvxyseMC95oHiQNAYdkz3wam3x4oe75qMWEAWqi	5618	7938	7938	1617368040000
10900	3NKzCW3ZvaVg1dYMgFn6qqWemBVp9A8e32oErurpSGbVucTw6skb	10899	3NKJFcitYt859goJg5C75NegNDGFWpFBDdsjDGnRsUqwRa3VVg4V	1637	816	152	6301	7316	jx3a7z8zMu63WR34g8KUmmGEyc6YRGvkVsDF5fVkHuUBcWhsbHD	5620	7940	7940	1617368400000
10901	3NK7tX24vkoQiw2AWrsMw496EsP5PEKyyBSkLCgW48ac5nhDG6QZ	10900	3NKzCW3ZvaVg1dYMgFn6qqWemBVp9A8e32oErurpSGbVucTw6skb	1406	1393	152	6301	7317	jxV6w6jXVY36H5GbAniYV8sPXAaSj4HLEcBvDrQNViQqPfSKaJ1	5621	7942	7942	1617368760000
10908	3NL2GPoXZoR6c8w6sjqdELkVDKRTjURhvX8QbDRxseC39CkiZpn2	10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	1546	1339	152	6301	7324	jxK71GqZ5FvqtHFN5k8RF3DVn68LAWaQ4iitCMjytZLWQ7DqH8Q	5627	7952	7952	1617370562533
10913	3NLEbB5yU7b3g5qVsQGiBCksV8FJrY2Yvdr6LaeQRUexviCRSuGM	10895	3NKnMtVx8AUb7nv6Q12F7WeW7UNUVQjLrXAaU17csiWqWWuchayR	1581	778	151	6301	7328	jxy6eL2rwmX1eASPbLFTbm9NtxShmy8HFM6DihpYuFUqLYFLHbW	5605	7955	7955	1617371100000
10918	3NKSyztCive9Ru5biYVHhyMgCeD5BZrZMArW497YKk5k4mdksjms	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1406	1393	152	6301	7333	jwGHwyf1HvaydgeiQZ6Js3UJ2dWr6FS5Pd71WTaFdJhek1dZJ5Z	5631	7957	7957	1617371460000
10807	3NLgXBdRGbUWNQNER91ZVuUJQ2iPCsBJTDjyhQtPZruv4WoWSxUw	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1649	1383	150	6301	7233	jwxb4yqzDGeFKXsgFSXMpuuMqsPTzvUoT8PXM7X9eyKPW53MdXF	5578	7881	7881	1617357780000
10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	1546	1093	150	6301	7237	jxMqRbFQLW1KxDqkBABNJQuEkxduhKQB1G1MK7b2KbH13w7nR4M	5579	7882	7882	1617357960000
10813	3NKxc6Bi9YZVV2N6RcroaQcrgG2ZduAuiHoWzriccEtTvNE9CyfC	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	484	953	150	6301	7239	jwz1hh92xXUcd6RBNjjC5gU8gw5YFDCtf3dmMqjj8VR585FU2ZG	5580	7883	7883	1617358140000
10815	3NKbJpHvaF4KhUfbnvv8qTJvL7KHpUMRDTuv8myCik3TXWSoGz8g	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	1581	778	150	6301	7241	jwtUJZZicvk22YLtEf79dfGKefhWSsE8U8a9Ap79do5RCQbbkRx	5580	7883	7883	1617358140000
10821	3NLxkyQ81HxbNJrEdeGTCFWAVvRX6i6sWBGjhsRtqdESLdY54sMt	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1555	1347	150	6301	7247	jwhhi8f7MfkNgqhAJXYg3q5RcUtwWciz1kgS5AEwht6RABHHiW1	5583	7888	7888	1617359040000
10825	3NKnqs6pdgyvrhPayfLqrnB1ttedaXUFFVCDWoyGvM7YgqpmoPrH	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1402	850	150	6301	7251	jxyezZohQusC5jGQvR6QfGkHyapSCaLQgytsZy8aptgJR4t8iHc	5586	7891	7891	1617359580000
10830	3NK4cKHuUxC3RCsYC4SJLKePiZHeGmEE5cEVFuJPXE63Z2SgT12o	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1447	1099	150	6301	7255	jxuxcKmque8o1Szs6qxz85bAG8Nvz9yp5GvwVTuPaTVuFbcxnCh	5589	7895	7895	1617360300000
10832	3NLBMrs7tFzATwHa9iLxTG2ULe7STFAbgBfQxSp23KgcTdwnuqRd	10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	1406	1393	150	6301	7257	jxcaANLJCv18RfoFqpb1iQHZrZyGjoTNrGVGXXZnNH16qKNju9g	5587	7895	7895	1617360300000
10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	10834	3NLpjSjM1rLUPYpH5sqCJfqkFFdKQwWaaDPkTUZag9PeseLQ8izD	1407	1395	150	6301	7260	jxPPCRJuXRQh6XT5yyC9WasJu3cBLcZYG5dwEXPjkszN1UXvVMP	5592	7900	7900	1617361200000
10840	3NLCJk7JFKJqR2XgrPp11AfRKe6oXUEVAzNyi1GQ1a6H8LnxaEd7	10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	1406	1393	151	6301	7264	jxHuydnqJwoJJ8RaPqoEB2bB8tNEHgQhcrWHd12jnSwYgS7jZM6	5594	7902	7902	1617361560000
10843	3NKSMQpCzETHBhJTPPRejQL2cAL1wHooL66snMmkPFSVkLykHKSV	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1460	1324	151	6301	7267	jwYE3gtiCvQRTzcnMTszQdxdY2rPtYUSyzhYt5q733EX594wmMZ	5596	7906	7906	1617362280000
10845	3NKNppW1AUUx6u7GTkMSUJJ8H8ooH7Lg38LBromgrCR6fhpMEDpY	10842	3NLX39bjYSJ64dHS3kdaCkuugJfLKos4QuAoWjVETBre33GJ58EV	1642	1367	151	6301	7269	jxWMZzNQ8T4PZTWRi8Yh5vREdkTzZHtgsCBETwDGfG4VvKPxQ8n	5597	7907	7907	1617362460000
10848	3NKNvHhH4U5WtidvWjyAvEkZksazZJj81S2DxXu6YbQ6z4xsxytS	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1603	444	151	6301	7272	jxzAvVoKKZCbVnihgrLfQea5T1cnjnGLn44dgGA75JdUfMFPEky	5599	7909	7909	1617362820000
10850	3NKru5geVTUJE9aossWY9eFtgSGgLn8xzqmC6VgF7spNQ1GXtRv7	10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	1673	1002	151	6301	7274	jx6UYiuxRyp5h9ezW4suhbFUm7VDtEskEpadsrudDi3fcmdRaJP	5601	7912	7912	1617363360000
10859	3NLE63Z6MsWaVW3pqi7HZk1Go3LAEfnYqzWtDJkBYZQR9h9t1f9L	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1627	1385	151	6301	7283	jwtVo8ue132m2vMt2T5ELQRQUWai9pksoHUAw4VQKKcaPEPeBMV	5605	7919	7919	1617364620000
10860	3NLEx4LTiKMfNKnE235fweH5m85pfVA4VjC7BCNXZ2EDQ1WsAPke	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1649	1017	151	6301	7284	jwH2FCSpYpkGsnEC4JW2tuqpAidPxLJMj2opEw2aqwxdYcYeAJH	5606	7921	7921	1617364980000
10863	3NLBmR29BbHxb9PLxsgF26isGLPFEroBG4RTUfNbZrFJ23VJd2mG	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1516	1294	151	6301	7287	jxsMNyUwpjuo5QpXuGHLqAEzSXGW5niV2ARPP28xQJuvhP36FgJ	5606	7921	7921	1617364980000
10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	1407	1395	151	6301	7288	jwAqVGh2Fy89HRQLbXkzdiRZRhizn8846fvyzrMcqHpysY8vtZ5	5607	7922	7922	1617365160000
10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	1477	1104	151	6301	7291	jxfWKJF3Eb6a2XahpHmvStCDzmqNYMqMGGk4KdcCGKiQRuxJNe7	5608	7923	7923	1617365340000
10870	3NLugWGnyYGfFy5zLWKVV3uGRuD9bDAZia5emBUmUvHXtwmotsJE	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1670	1282	151	6301	7294	jxVGsQGaWqyFD2AFDPGHEndp7iSzUjHAa9fRnC81jhyrRLEy48n	5599	7925	7925	1617365700000
10871	3NKiz9EibjdXJnHXePD5jRastiHGRjovaZhMDQcXTFQ7oC9YrktR	10866	3NLoBLXj4xpJggwuwC9ypAnNZdsYKq7WCuTUr53xnKK1QaA7dTcZ	532	1057	151	6301	7295	jxE9scYs1732MpCJDrGzb8njotLX7YaYnbwZQzkDspSVsVPz5B9	5609	7926	7926	1617365880000
10876	3NK6byHuHXw5QGkuytMpe8nSuu2adHyiEENoDkXMvFd2QdTy9Bh3	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	1613	1103	151	6301	7300	jwSw1aBiQem6wJp9AF8JVB1EosFspanSFwBepw4XiC8JhYqzeFd	5611	7928	7928	1617366240000
10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	10875	3NKURnqB6jWenKyqGRBr6qakYRx9hUt5vGebrAKsZajkBpxU6STD	484	1073	151	6301	7302	jwY64YfbaW1LcHhPvhAPqNUddcjpaH1bEmdy8ndJT37oa8aySML	5612	7929	7929	1617366420000
10880	3NKYPdZBmeZ4vMxae7qYoJni9F4ykaFkrWbXEf1hmBqtWTmEFftx	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366603272
10883	3NKTUm5VkRjaT5k1fqx3T7kHjAgZtuYSRJGohmJXUKAaf1rbh8N6	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366604142
10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	1451	1292	152	6301	7308	jwbw9ejWKDhmHUiMccqfrPJPw7S4iis6KxPXyNHypgtEcQ4K8NF	5616	7934	7934	1617367323055
10894	3NL8SqrGJnNeQXv3vYwP2y8WWwCq4LKSk8vgYkdS6AGCAtVVEnBP	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1613	1349	152	6301	7310	jwPN6zPEbJS3nJ8T9GMCZpNewD8ZAv36cg7P3hvMyuW9iNmbks5	5617	7935	7935	1617367500000
10896	3NLujKpczkQ2qrfJw5TxvQHzJvjMPnNqpam4LZBEjDV2c7eCYVZk	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	700	840	152	6301	7312	jwi5XNXF6VxSmbmSvNxr8HKJcpdVW2UNF5V3p3gzYNw1tPFHQSg	5618	7938	7938	1617368040000
10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	10903	3NLU9SZsbYZubBXT7rrohdtpsmgDwy2xNPv4gNYd4hfXDqMA3xQJ	1553	776	152	6301	7320	jwANDCBaFxQTzyfWcBeuv7kLTNKkETdZr2wBDtvmAz8VEuCWJqf	5624	7948	7948	1617369840000
10905	3NLm7cWYozcEfFc3m4g79E8if3omcCcHhetgszDRc6BuaxrPqPBB	10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	1573	1072	152	6301	7321	jx89xxMR8qYQE9EsP6rEcZN9eAvqinWYnVr15DondwwDgNCUAqN	5625	7950	7950	1617370200000
10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	10906	3NKyLWJ4C9fKJpo3UTyD5CsyAWMW2V2TwpQsj2qtWqX6wenzDobP	149	917	152	6301	7323	jxjGvCELfy3EbefbAhsUChV5P6USqYZWxaGwWNQ9tBfRX8ok7qF	5626	7951	7951	1617370380000
10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	1651	1055	152	6301	7327	jwstSsa165XhaTUbLqethVo6ZaGmTnCSXfacyBNX8rTYQ4eCaj3	5629	7954	7954	1617370920000
10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	10845	3NKNppW1AUUx6u7GTkMSUJJ8H8ooH7Lg38LBromgrCR6fhpMEDpY	1407	1395	151	6301	7270	jxRR9guLrW6HMbsspmuPdVviZzMybgc3CNDRwW8aPL3AdZ9efMX	5598	7908	7908	1617362640000
10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	10848	3NKNvHhH4U5WtidvWjyAvEkZksazZJj81S2DxXu6YbQ6z4xsxytS	1623	830	151	6301	7273	jxGHNZ4KqUKNWxH9FtcZNen6sC86dU3AbYu3ZgiW3B42hjfrrCE	5600	7911	7911	1617363180000
10854	3NKnM19fobYXKGu1oBDvWqTTyLppDDzR4EVdiZSAtmrf66cAh54k	10802	3NLr1SgutMpkemDNu33uxgQRYDEVsR7FgLCRpKPDvibBVGNBYhkT	1633	1264	147	6301	7278	jwc4czw9K7UHwWq9q4Mpz2s57NVCKY4fcLBsj1Lx3UTp84Muq6B	5445	7917	7917	1617364260000
10857	3NKtXXLAEDc3h2ZaoWmhrc74Zh165zKSFWR2Td83gGXyDJesZRAc	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1507	1034	151	6301	7281	jxRhPfNu2992iECir6m9dMkk4YZp1UaBQDcBHLu1mUmajMoQLTi	5605	7919	7919	1617364620000
10865	3NKDQKE9srun74ZrXLekdQLub9PeXmEQzzTu29f91k2v87SQHxbk	10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	576	1229	151	6301	7289	jxnHKJZx3vM94Diq2Jyaa1ejj8B9RC3iH8w23WWa2HYoELUyecM	5607	7922	7922	1617365160000
10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	1670	1282	151	6301	7292	jwjEa5o8wPNN1djURtowfjjdrwGXYyHhVgGxh8rA9QNQRfrfvit	5609	7925	7925	1617365700000
10873	3NKJv6DS77H6KvincAfRAXGvjFgaW1QYKMrcRS2fxQiNjF9V4RCM	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	532	1057	151	6301	7297	jwP7pMWwoLkCCB5HCgEwXFhzJ91isJshoFsfPfAXyLELVx2Somv	5610	7926	7926	1617365880000
10879	3NLT6EuLF5MHWQSnXd5xnP2o5Yh3aYvogaQ4cJoNrtSGaN8w8Zng	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	439	439	151	6301	7303	jxDB7TQLQfggKxopg7iw3qt8Kd3Qr83cekom2tk9gs7PaT2dQUD	5605	7930	7930	1617366605050
10882	3NLmuoB9iJYfB97cyx9CTSo84tx8CgSNorv9DdVCyoKXxTif6Ux9	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366600000
10897	3NL2kVf1sS2SH7VczZPwj3sZPxYZMRUkhmkTBKVfAy5mAdj857nh	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	1638	630	152	6301	7313	jxQ9PrEa47h4PYRRuXnhqFzpbdKWrnctuAtMNerdqeGSbCfQKcg	5618	7938	7938	1617368040000
10903	3NLU9SZsbYZubBXT7rrohdtpsmgDwy2xNPv4gNYd4hfXDqMA3xQJ	10902	3NKp8aKFgxHYgwXRCWqTjSvC5RFWitDq2wthVmdgPHSuABasaZra	1657	1344	152	6301	7319	jwcafLFybMeaaFjKXm4BNqowJ69spxWp8mBSEyLmUJMddFdBcj4	5623	7946	7946	1617369480000
10909	3NLGa5rrPwrGM5D35newfLEFoiZwymZ23t1ScGswqZLDjrqY2jtn	10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	1546	1339	152	6301	7324	jxQXCkTc5rQiZSr6JUshYMhaZUJseaq7iKPPuzpgmguBsGfYmjG	5627	7952	7952	1617370560000
10911	3NLwT1w9vqKKAR4NDtJsoGdhCSDkCKg5vDpt6DRCRFbudvEwg9qV	10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	596	1306	152	6301	7326	jxhsvbyt6vPyzhWtPA9E5fYu4N5xUM42SsWSRCNkTjDJrqe5xeV	5629	7954	7954	1617370920000
10916	3NKjpnANyvFCoFGzhX3y8rrusLJLALXp6FYUG2YYuuNzGZeS5t9x	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1673	1122	152	6301	7331	jxeRFksZeEd7vHsHhkpVfEzRcQNkWdKxwhaakum8PcRasbQBa7Q	5631	7957	7957	1617371460000
10923	3NL5uAb9coYYLZ1W9V4R93PgQ55RnCxcVwi21x26W8Wwkv1eeZ4L	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1559	1353	152	6301	7337	jy1ZczXzvGziTWB1hJWKVLVmyk9uJA5fR8wKWfUaWwhCjMNDHWE	5634	7962	7962	1617372360000
10924	3NKoMr1yRbM5HF41BsSRMxH8iqQVvg5gHCA9KNEZWmmvhaX8d4u3	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1553	776	152	6301	7338	jxP6zCgmAVsKqjKYBXizNKmCHg9Lsb2bSA8N6LqN3YET8nTvqLr	5634	7962	7962	1617372360000
10930	3NKVmDrps9as6jKiiKv93LM3J9dL1xXLFJcLuC31qGjw5Gup7u86	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1651	1055	153	6301	7343	jxjppubKqAocxA1iyxFJNuf29Teqtbw7rpzGKaB8CzYnjTnen6E	5636	7964	7964	1617372720000
10933	3NKqQbY9WVPz6VWoAtxmLpqyAsSZxEdnfZywHhwZSzmzsfQC6t5W	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	606	1295	153	6301	7345	jwtKJ77HyCNuY6DwPys9gZv3z7fbbuwrtXcfyhSSKhxkLQ3nk8Y	5636	7964	7964	1617372720000
10936	3NLGn36fKm1jwwTgU4itf7YVzyi1PVUzXHyd4tbUCZeWAZTdqcCb	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1555	1101	153	6301	7348	jweTktaHuvR1uewMjDSg8CHw2H5UxxzzLdyQGdnmzzVKHMV4spv	5636	7965	7965	1617372900000
10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	10934	3NLLrv9NFwTjJjVZD3tZMggxwnYo15EkfP7Zhbo3TGp1tQxoX4i9	1673	1242	153	6301	7349	jwqoEP7BxbumY5yMbpdjuH5r9yAc2V99hE4AuSx566TyLnQpFNB	5638	7966	7966	1617373080000
10940	3NKA2KNCPRBjzTKUkLb1tD119LiadPeTGAzzE4cCjsw2TePAJpSk	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	470	1183	153	6301	7352	jwNt4bhhizTHqhE833iDnt3qbKfoTjsWPWUV638JW9uBdhSeYBt	5639	7967	7967	1617373260000
10942	3NKEVHrWW1qq1bf4AGCX4jA1txaJKHmA4RExeaAo8QtJA8Gk85zg	10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	1549	1362	153	6301	7354	jwDDiZYupfdA2UzpG5aCMd9ZjLZZttZpX5fzcBAxdojyw9vsX4t	5640	7968	7968	1617373440000
10944	3NL5m478uU1NP8FA72E5GUnTDftX3zsxxkq2vPPJma5HFGVMhi9m	10943	3NLbuU5BcGneFBhZDNgm2n6XKse5CkBjicmkdmpscNk1acZCe2rk	1649	1257	153	6301	7356	jxku8nuuywhT9xwbFN6282p8fo52M5P2Psmr6Bd45tDJF3nPy9v	5641	7969	7969	1617373620000
10956	3NLsrkhytcnaxxPjhTD9wNCktTQwBGVMjQktnMm3C4FDRUZAepa7	10954	3NLprCLA6FzRyvP4nNcDvTTFeW5ZL3ciWf2nkeDPpmaWm2eo9KQs	1406	1393	153	6301	7367	jx5rptcsaVG6JPeUzdt4DtPg8FeNytwfhVnFgq3HZaL8RZxXunU	5646	7977	7977	1617375060000
10958	3NK9qSYqL5s4F96M7mc6ZLJuwWLEuFRP8vqRFVRj7VnEA2oZBWRY	10913	3NLEbB5yU7b3g5qVsQGiBCksV8FJrY2Yvdr6LaeQRUexviCRSuGM	1581	778	152	6301	7369	jwqfoZ7tu8Y4rpuUbmoQYzsAHVD9hpyUZAbMogEJKBFWTSSsn8j	5606	7978	7978	1617375240000
10963	3NKxNRKdmnqMMnWUTnjWXnpxSW9UMHPoQXFrdeS6Q1h53imSE9FN	10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	1403	823	153	6301	7374	jwUFJiPpPKKjgxesXrHTsWaFEoWzVxJHiUb1xL1PsUuHcWM5nyr	5650	7982	7982	1617375960000
10969	3NKmkXwt7ZhSYdoropRoY44Yjna2iWaFmWXZctAvMPFxmhtnD9wi	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1619	1275	153	6301	7378	jwX6VPAZDaGEvAmQsfkEakb6vHLmQAEGj4s9kp6SpjfzbmxZP1v	5651	7983	7983	1617376140000
10972	3NLF33XssPw73M1jBW9CiWoghX6d39Mr42vXxvCVfZscgjTwJPrp	10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	470	1309	153	6301	7381	jxYcsNNJBhRCF9PbUDPyL4j8PizADapJufm7Kvm6oDiMqqhezaC	5653	7985	7985	1617376500000
10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	10976	3NKwEq1U2ZAmiVPKrZwYSfdekuccrBzvrvuKJ3KnwYpiGrdta34Y	1474	1083	153	6301	7384	jwpgpzcGuSYcipjDfKohM5cmLGfohQ8hgruEA1tVPaLhdjMwF3A	5656	7989	7989	1617377220000
10982	3NKcx5gRafUimRkihQDdi55DZeG6zatjknJqApRLMbRW2nUm6958	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1594	1326	153	6301	7389	jwyhxGXsTrBBCHXLbcZoGoDm89ddQuq3qombJXVPSjvBW15uPga	5658	7991	7991	1617377580000
10984	3NLrq2Kg1UWj3sShXDbgdaxaUtcRMg9K5SUdD7Hs4GxHSCwigvKe	10981	3NKtJ3HxegK9roYidXouHhU8ohNAfgj7fCLyLz9AjNQQQm7J5mcg	1650	1375	153	6301	7391	jwuoJkAX2s5oQJp9BbK4L3RiHcJ7R2zQNWb6z54k9cN9DEa4eJE	5659	7992	7992	1617377760000
10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	1542	938	153	6301	7393	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9	5661	7996	7996	1617378484039
10914	3NLp3HS4rcW3LvsfjnU1kVDGis7nLz6oAuVHbSVqS4dvkkGEEQVi	10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	1407	1395	152	6301	7329	jx6xRDAWguK2krAmGitC4oWmnuh3SiEzf1b9AcSbz3bT94SakDz	5630	7956	7956	1617371280000
10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	10916	3NKjpnANyvFCoFGzhX3y8rrusLJLALXp6FYUG2YYuuNzGZeS5t9x	1513	1253	152	6301	7334	jwHHc5a1j8zWyNoRusRjs3222gQt17uEF2s2shv3TuP5cuvH1yj	5632	7960	7960	1617372004370
10922	3NKGmJ2HCjb4wVATj3h2iNmr6PZ5ENgeoUQA4xtYJqxfjerHt1Jp	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	1476	1371	152	6301	7335	jwC4fBmThDaN5pTjwW5DuS9iboWK1s9o4RUpoZo2yucDw1WviyL	5633	7961	7961	1617372187768
10925	3NKzvjGrNSrPRcqAecpf3gv2vYF1wMpmT1mv24E4QLLtTjR7UM93	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1403	31	152	6301	7339	jxKWZM46VVUKcwTQ7Z2bu4rkEmYWVc6PnsZgThnBPEQVdiyPydY	5634	7962	7962	1617372360000
10928	3NKmU4DwBFtCtn3BHmBmvS9PjV2qUovYjJSsGsNcyBwUWN4shiiv	10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	1652	1315	152	6301	7341	jxKoNERp1YX6dRoewUhwffPMNcBxQyWNBNWd5FDtgsefJvDVHpr	5635	7964	7964	1617372720000
10931	3NL1mqy56HS7E2nqEtgW6ZKmBFRGh8ks1YBjqR2jKtXvGtzzJgcM	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1652	1315	153	6301	7344	jwEAv9atv8UBD3cW6DDprEdgABvLaog6qMDWbSruffGkfXdWs51	5636	7964	7964	1617372720000
10934	3NLLrv9NFwTjJjVZD3tZMggxwnYo15EkfP7Zhbo3TGp1tQxoX4i9	10931	3NL1mqy56HS7E2nqEtgW6ZKmBFRGh8ks1YBjqR2jKtXvGtzzJgcM	1500	931	153	6301	7346	jxXhhr45qTuD93714DtUdw8JXmu9JPdwRCV6KxVmZ4vkuWXZX1x	5637	7965	7965	1617372900000
10938	3NLHPCDuh75R4WwiBdzCqHKMhRE2CBCo41zAQ6yc1XAzJX38WZve	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	1440	1377	153	6301	7350	jwa5k52CHroVZ2Zh4mUMohq2yfCJQasbqUcJXDxazcUkCV3bexW	5639	7967	7967	1617373260000
10945	3NKw4JyGcbvLfdmptLnm45A5XoUQ6UB9tjbfGRbT6vWe3KMs4J1q	10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	1649	1257	153	6301	7357	jxADNHXA5QGHXL7ZXTheWnNYz6R8T17hQ1HQ4ehPHFaZixaMAxT	5641	7969	7969	1617373620000
10950	3NLe2vTnYgxg4FMPSiwvrhng5BzXDA9yNepEpdJc4codicN1e2gf	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1571	1335	153	6301	7362	jxupvXNFLVHrHKV3Ho1didDnRWwSK7FDRQMaH8nEZErw1AY2A8E	5636	7973	7973	1617374340000
10954	3NLprCLA6FzRyvP4nNcDvTTFeW5ZL3ciWf2nkeDPpmaWm2eo9KQs	10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	1437	155	153	6301	7365	jwNp7aoEyxtJWjypQwB16hRpw3R6BE25prZH7XnabwyNAmf2b4E	5645	7976	7976	1617374880000
10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	10957	3NKEG7v7opNjay5X9oijTpSA3fNz9c2JNCgMYCSRb1HjfC5sNAZW	1647	1056	153	6301	7370	jxLR5GLJWPriRnbbtVb8Hkz7humRwEkSfrwTo369EhncEZ6rZ3V	5648	7979	7979	1617375420000
10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	633	1384	153	6301	7375	jxW7GiwdWvLjDnD3ee6GkvETRHsGGd3tMd2UdULfnjQoPciecRu	5650	7982	7982	1617375960000
10966	3NLq7KfzeMoriDHRKAfFisCPHiaKyxvL5zupb9n5FRCT7gWgjt6f	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1602	1369	153	6301	7377	jwTLFo45RcX8JVhptTGQ7R4nZ6XsR1da8qJB73Yx7S354XQfKd5	5651	7983	7983	1617376140000
10970	3NLYwNBUf5ZjRRtdYF5prqE4Ni3DBxpMe3xG5vuYuQuhyZRwriDe	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	58	1035	153	6301	7379	jwFsRRhr9Fi9tSTdfJX1NB8zTeEMY4MxasbZLjmbTYv7eozWCwH	5651	7983	7983	1617376140000
10975	3NKMjX7KD3CWWfjbMjK2xAX4aT9FyeY1paNS5n4Vx2yNWsCAAxco	10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	1578	930	153	6301	7382	jwvHpHJuzDm2k1P5319B16MekcJvZR9dSg9vNftpfBAi5fdjTqX	5654	7987	7987	1617376860000
10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1407	1395	153	6301	7387	jxUFWyvfTCAi3fmEcaibsjH6oF6RrwnjLmMDBv6P1uUkmNmAx2t	5657	7990	7990	1617377400000
10983	3NLjF51ssva96Sr2ZZqMMp3NujB342zJ16QGHVJjbRVickZuhYJw	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1585	1000	153	6301	7390	jwGjuPPfQDhKb2B1RTY137mfYEFwhka7T59MxsHE9DskG1rYZPH	5658	7991	7991	1617377580000
10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	10984	3NLrq2Kg1UWj3sShXDbgdaxaUtcRMg9K5SUdD7Hs4GxHSCwigvKe	1590	1300	153	6301	7392	jwbYUYii3ATvXaj2JopMbhhR6o2527Fb7bbfs7qiGknEMj1H1LJ	5660	7995	7995	1617378300000
10992	3NKqsoFw6DY25SFpgZa8ivxaCi3HAzLF7pyHkR1WFNHQzB14ZTnx	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	153	6301	7395	jwkmT93U9soPVwVTLMz4CaPoVRrnEbe6FyieumMnhawnttK9jJ5	5663	7999	7999	1617379020000
10999	3NKvccAv4RNC1s6ViFLexAKR8rScK3Xm2B4Q8bDxJVFa8LrtfkXT	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1483	1276	154	6301	7401	jwry4MrAJBto4P1PK3Sc9s8Xu9V8RFpxVLwjxUD5uK6bLC22ej1	5667	8004	8004	1617379920000
11004	3NL2ehh83eiqDfH48k4LzqEifQpEDxFdr7vrRGT7nFo8jkYGh3Sw	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1553	776	154	6301	7406	jxULuuf1UsWMEMyQLX4cQkeCHtG3mpKZDKssAZLP11RnHLFBnkP	5667	8004	8004	1617379920000
11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1646	1228	154	6301	7410	jwEAK8xqQfW3ZZYcP6KbGjyivf4TToXbbxNvgXigVFmuFpB2j3U	5668	8006	8006	1617380280000
11010	3NK4gqb2Ma47UYZGZXgwCs5xDwm16FUQJAJidinNrYSbDsMU6kyt	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	1403	823	154	6301	7412	jxVvmCRuTSMmXwFPDzGC16cmXSmDiH4Z78grNxMf6a5AFcB3pLT	5669	8008	8008	1617380640000
11015	3NLRH3E7h2aDi45joeN3gvyMBGdK5ZQfAbKR3Bi3WZeeNa3QHXcX	11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	1536	947	154	6301	7416	jxUTC5KQUEEwmNZrB9ZxtXpQ9va9g1PJugxPeKhSSp9yqu5CSEv	5671	8010	8010	1617381002951
11017	3NKcQ4qoNg7FSH7nVcxggqxfh7vb6rX8XdTr1ksGAWmhz42emaBU	11016	3NLJpUMEy58ywF8LA5ngHagPMoH2waumEPrBFfvY94srZsXGu3gH	1406	1393	154	6301	7418	jwqRDy9hzkhg3nYQcc6SEU2UD6qP2gCkDgRj7yo37oPkwu4tRhU	5670	8011	8011	1617381180000
11029	3NKWCbwMcebYz3WLdP2KJBZdbLmLwogXuQFWDmCVDc2LX7aR8262	11028	3NLtMiTTfBetGVsj9ojo8Aiar94voRDoi4FuuyzEoT3YCLnDoX4U	1501	1114	154	6301	7430	jwHobcJWZ7etC88FRnbwomVGA9WFwqLYWHA18heaQhuMbrgPhZc	5677	8020	8020	1617382800000
11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	11031	3NKDee3A5U1rKDXWPq6QEyNTKAzVHZUCi7cLQMU4GiXn5z8VrqjC	1440	1011	154	6301	7433	jxnw6MYBHiVizzVJ5vP9DfhqYyka74zLB447gNQXAw1MAfFRUnP	5680	8023	8023	1617383340000
11034	3NKvxDqbPsTYtMrTrdbp3zNXbgPYshm5s1mAT1cm6rHNFeDGMtj4	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	1403	786	154	6301	7435	jxx6k2NSeHTq7Bu2rLHjEstV4MAjcktyi7U2BE898oWAWagP7NS	5681	8024	8024	1617383520000
11037	3NKSYMqn67rJXjjdLCyQ97ksfucrz5jMsE9FyB5N15vGWC9RcN6t	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	43	1064	154	6301	7436	jwaZ8kpbByoAwfSWGk9kjitoRVFnEMcU6xY8uuV8iGRg4YZMZUS	5681	8024	8024	1617383520000
11041	3NKtiY7daqwU8M3erSqQn9uGuxUos7TeVQn4QduXajPr9iWR6SLM	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1672	1039	154	6301	7441	jxgJTogFC6XvsAD2guBzBUcWk1qWzhtjHcFriZetjnznLaZfWH7	5683	8026	8026	1617383883464
11049	3NK46zkysbj7DiuQ3kh9RZffX9e96EiTA9ezfNirFUNoMu3MT9db	11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	1451	1292	154	6301	7446	jwSQjMdutmEeyCY5ehM15ncFSoCBymtgSx58Fxs9CExkUYTvFLL	5685	8028	8028	1617384240000
10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	44	28	152	6301	7336	jwX8z2X8LNQxdd7H467uP6Fk64KnzsqB8wPyNhXt4kC8miaWost	5633	7961	7961	1617372183603
10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1559	1353	152	6301	7337	jxHi92nWyUDSy1KcR6LthFdQanPoJELzK69Ciie6h36X5QN2bS3	5634	7962	7962	1617372360000
10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	10925	3NKzvjGrNSrPRcqAecpf3gv2vYF1wMpmT1mv24E4QLLtTjR7UM93	1406	1393	152	6301	7340	jwaGxbZuKL8iuT3Bbeq2JNfmXvQLuanwGmkQQjLozzqVTzkQfjy	5635	7963	7963	1617372540000
10929	3NKQnLW2fKy3GovFX5gzv1b5yoKyhRvFQbR2GG5EnXJmyYT3L8an	10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	606	1295	153	6301	7342	jxYb7XeZGPNVrbngsFkGHAKwhp6PmjVVb4tZBbf6efKs6eoS4sY	5635	7964	7964	1617372720000
10932	3NKJ4HVbGCwBnFVa5F1FmFdt1PuSgnWbEqxFvfbc4AVtizYXmYr3	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1651	1055	153	6301	7343	jxPFBPYKjmZMvMfNeTDZHa9rtG43vzTdZjr7rjrgAvt6emSepmg	5636	7964	7964	1617372720000
10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	1451	1292	153	6301	7353	jwhxjrFsWPs5qhmuUS63iLbdiHyhHHRGYc5rqW9u2MsjmFtQYkk	5640	7968	7968	1617373440000
10946	3NKR418P1uPqvcjLaD3SPhU7oj4cE8osfYXY1jd8jVvWsw9CDNf5	10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	1637	816	153	6301	7358	jxwLxxST1vu7LG2ixTfouWF1TFp9HkgUDuz4iqf1qW1uB3GcP7w	5641	7969	7969	1617373620000
10949	3NLC58C4Aj95yok737V7byPB8VegyHabQZK1aMeHWn7fJpgEDQWL	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1407	1395	153	6301	7361	jxVpcgmrmmDdaLNeaZQkFc7Yj9s9acFiVX8n6bRtAVgQXZoRiYv	5643	7973	7973	1617374340000
10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	1407	1395	153	6301	7364	jxLhD6SnCBuCDJiiQDJRCb16zgDfKgLMMx4ybHcAn8REEE3sQro	5644	7974	7974	1617374520000
10961	3NLqF9ZFn7qzzyHogdjhevzXKETEQKmBr6ud5J4tMK4xn6xZ8bgi	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1405	851	153	6301	7372	jwvGrMMHN1FL1wL8R9HEXeCwq3M2BFNNmY679phfytcjxwYDm31	5649	7981	7981	1617375780000
10965	3NKkNkUQgMSnDBPULEQ1RK46xPpcLzkeY25iL3BQwTaToQoQTZdZ	10960	3NKx3Qhw9Sbtop8twdEhsr2ZWHHaR6k9ko5Gy2vGNTZakk3vxkQG	1406	1393	153	6301	7376	jx8vSW7uJzzMBvdMj41tzPKjqWaX7pwWh6k3ecee6KY81qGEcj9	5650	7982	7982	1617375960000
10968	3NLsjXBYTk1oEFRb5onRDksNLhCHrJzbDkXmUQ1pSKciXNSg5PgP	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1619	1275	153	6301	7378	jwX6VPAZDaGEvAmQsfkEakb6vHLmQAEGj4s9kp6SpjfzbmxZP1v	5651	7983	7983	1617376142738
10974	3NLqJ3wD9LLdBxygRaSkP7dPKs4sC6CeFaRG9L2hDLza7bfu1YXN	10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	1578	930	153	6301	7382	jwvHpHJuzDm2k1P5319B16MekcJvZR9dSg9vNftpfBAi5fdjTqX	5654	7987	7987	1617376862660
10976	3NKwEq1U2ZAmiVPKrZwYSfdekuccrBzvrvuKJ3KnwYpiGrdta34Y	10974	3NLqJ3wD9LLdBxygRaSkP7dPKs4sC6CeFaRG9L2hDLza7bfu1YXN	1403	824	153	6301	7383	jxLZpe1aqhYP4b6aqH1ax66UZhUqiRDTexrUgpEGVjuhrhEQ75e	5655	7988	7988	1617377040000
10979	3NLLPHGLzY8Re8FMVNcBJJ8DRDVZccesnTWW1HTjppjcUD5VKXfx	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1501	1234	153	6301	7386	jxZKqhHGE2vMJPSAKAAxsVSrG1nAmk8Y2qNKqg9KLuXiGQ2Foor	5657	7990	7990	1617377400000
10981	3NKtJ3HxegK9roYidXouHhU8ohNAfgj7fCLyLz9AjNQQQm7J5mcg	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1509	1320	153	6301	7388	jxMGcjeZsLJ3skpgkeShgrictyQGtYUdHnyVAcmdvSDpFtrDH5B	5658	7991	7991	1617377580000
10986	3NKWVfi2N4kFmatCfRoaKRpUDoj5bF6Hnx7pYYewzbz83Zg1Hriy	10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	1542	938	153	6301	7393	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9	5661	7996	7996	1617378480000
10991	3NKUHZYKcwkhu1q1JWng1PJ1YP9xHhvi2tPxhNH2xpS3tvD84kL9	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	153	6301	7395	jwPwZ1N3K7X2ozyA5Hcu7prJaxw1hUieFt171gsj8jjjxeFVjFf	5663	7999	7999	1617379020000
10996	3NK4WgWooDhM8ZUsYp2WeT32SxMx3SwQDBE4MSrLVhx4Sgev9eaT	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1471	1386	154	6301	7398	jx7MZrRstSVEVr8eTxyPXzazhXFQyjeBSotr7bVNxZgfPY8ByE2	5666	8003	8003	1617379740000
11001	3NKYcHBSRSdmpdhwmTb8crHBaiYuS6rwamPaREK3DnxEyqrq2GTx	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1407	1395	154	6301	7403	jxbXyNzTcFLAAM7Q9q19Repcs42NvsmR4DZaD2L16iYw5P8yoa2	5667	8004	8004	1617379920000
11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1637	816	154	6301	7404	jwF3GE5PVyR4LwYWyeQAcApUoME4t6y9qaRT5CxqHKP8sygWpVt	5667	8004	8004	1617379920000
11009	3NK7sWU6NZBFmCKqXQdG3TCjCeYJaQ9rvPusmm44Wdq1MiTUBLa8	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1448	1185	154	6301	7411	jwByFs4rjKcCjNJ53PaEh55zoEhw4bWqHJ2MGiwHBoUUcKRoChp	5668	8006	8006	1617380280000
11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	11015	3NLRH3E7h2aDi45joeN3gvyMBGdK5ZQfAbKR3Bi3WZeeNa3QHXcX	1649	1383	154	6301	7419	jwStm7fSrnGh32f6gkfvgKWBb7u3pau2bFYqF2W7uzCNaZypVib	5672	8012	8012	1617381360000
11021	3NKkRkmaRKLguGLtW7fP9JTLPFhrhan74JHSC3D8oJLtWFpWTTTg	11017	3NKcQ4qoNg7FSH7nVcxggqxfh7vb6rX8XdTr1ksGAWmhz42emaBU	1406	1393	154	6301	7422	jxUW4MfYy3vBoi3yQEoeeK8MtkrTnwKsX6yu2nNdRApkyDByq5Y	5671	8013	8013	1617381540000
11023	3NKgP59aaHXPDKEZVFQUGFrDryiR5YLi8zL1Ku4SZ8Wqpw6z85aS	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	633	1258	154	6301	7424	jxWH46tzzK9rHnELEuUCiz5rsUqArYyBQrC8wAnjWuLe6cHmUXA	5675	8015	8015	1617381900000
11026	3NL4txCiUvgqNFp1FZb1wNvEuVbiFpEnEkzDZjVDvB7MYfBs2AN9	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1642	1241	154	6301	7427	jwu3mfR4HNmGWD5SbAkw49v8Zi7sCygCEgRxLum3h46szf2qEdV	5676	8019	8019	1617382620000
11033	3NKBVSudxo9EbxXnTNbqB5tuqTdkXwJLSTGr6fcKic4iZtJ2QAzx	10958	3NK9qSYqL5s4F96M7mc6ZLJuwWLEuFRP8vqRFVRj7VnEA2oZBWRY	1581	778	152	6301	7434	jw9gcFjABFLcJ9y7LAx18sAQKsXXkVJEeGSUFncYYb3DR7tT9nA	5607	8023	8023	1617383340000
11043	3NLgMkxsESS3B5VAK3DPitZ7sFsmmddQ2Bqqu2xGiihAYFp6ywsn	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1672	1039	154	6301	7441	jxgJTogFC6XvsAD2guBzBUcWk1qWzhtjHcFriZetjnznLaZfWH7	5683	8026	8026	1617383880000
11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1522	1322	154	6301	7443	jxqcHNHaic2FkLRuLVXv7ByonFoD4UAacvuNbXbVxDNRqQExh5P	5683	8026	8026	1617383880000
11046	3NLaNg4i9qGBC9fydjJc9uzMUMGimWYKppact4ANxtdvni8YYhyL	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jwR91DWzXgjvajRDveHhTtVfKKY74HVySg1pLNMPVyX2m2C76gv	5684	8027	8027	1617384060000
11051	3NLRnUpQ5nEEWi6Ssc2z3zQZzzWyTXKkPFbzLwBSDoEfWScToGfv	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1451	1292	154	6301	7447	jxaPxGf1s5x4mS6C7sUJ53Sg1oCKVmrBjLSSXMMcy6KTZaHaPT9	5684	8028	8028	1617384240000
11053	3NLaCPrfCiTDk9SsLhY3iact9qwpz8QMmkouW7ez1DpJtpULjYUZ	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	1447	701	155	6301	7449	jwNVZ2gmorfvmdEMkqCbge4ZSkEmrGV19qMo9Q8kc636LPyLxd4	5687	8032	8032	1617384960000
10935	3NKSeo1wRi6SJQAwvTDbHxRJwipwJPcLRCasX3BVmxFLBdfiEsDq	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1406	1393	152	6301	7347	jxeZ8FdC135qhBHixq141MSm2MChsk3gBVto5VefZBGitGmD8Y8	5636	7965	7965	1617372900000
10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	1522	1076	153	6301	7351	jwZvAKTc6kGbJJCftbrpreAh6jQgwkD868dH5rorMrsfGRcxDHx	5639	7967	7967	1617373260000
10943	3NLbuU5BcGneFBhZDNgm2n6XKse5CkBjicmkdmpscNk1acZCe2rk	10938	3NLHPCDuh75R4WwiBdzCqHKMhRE2CBCo41zAQ6yc1XAzJX38WZve	1623	830	153	6301	7355	jxdRZGDkWqX8JEFgy2JVDw528KkaShy3bJGmFDWuVbVrJt1XsyV	5640	7968	7968	1617373440000
10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	10946	3NKR418P1uPqvcjLaD3SPhU7oj4cE8osfYXY1jd8jVvWsw9CDNf5	1585	1240	153	6301	7359	jxq1TCwxCL6gFDvxLBunnqSC1NPtWq8rouvzjQuhn9GtPmZCDqk	5642	7970	7970	1617373800000
10948	3NLBPn3pAWeXmC6GG3n8LxkpwfCrcuuoxaUJud9X6RnGVdKwcrwn	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1506	1373	153	6301	7360	jw9jUK2L7UD6X932hhU5Jsw8jzdxYCHK9FekgvNpCfMKw24RiP1	5643	7973	7973	1617374342736
10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1506	1373	153	6301	7360	jw9jUK2L7UD6X932hhU5Jsw8jzdxYCHK9FekgvNpCfMKw24RiP1	5643	7973	7973	1617374344461
10952	3NKZ7upCzyYAwpZ5eL2Z6KLpMp7tx8DxBTCqiRwcc9tYVaPPUJzo	10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	1536	947	153	6301	7363	jxmN7kM8ZeJqVQGtkfebfkf6sUDfYNTu2CvBehrSHyPskHjhfXg	5644	7974	7974	1617374520000
10955	3NLkTJcLgpBL6kPy3qj4TG5HH4nGUhgH16zdQcUE6v41g5zaVmo7	10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	632	1382	153	6301	7366	jxvLv7dtxdfL7t2BqKcX4megyYuw3Ey69hfJQbxZJXVugNrZcEJ	5645	7976	7976	1617374880000
10957	3NKEG7v7opNjay5X9oijTpSA3fNz9c2JNCgMYCSRb1HjfC5sNAZW	10956	3NLsrkhytcnaxxPjhTD9wNCktTQwBGVMjQktnMm3C4FDRUZAepa7	1501	148	153	6301	7368	jwZvPhxqMDcGyR7C7L31PJCEQaSTcteWMxSky2u3MjS58QnmATA	5647	7978	7978	1617375240000
10960	3NKx3Qhw9Sbtop8twdEhsr2ZWHHaR6k9ko5Gy2vGNTZakk3vxkQG	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1483	878	153	6301	7371	jxy24tQfRNMKzGr4yHpCA7JR5LYzi2KNMUss6zKCvDh9jJMMW14	5649	7981	7981	1617375780000
10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1590	1174	153	6301	7373	jx3gJnnQuHVJD6HkNttbfyBdKvift62gMEosP9ueUfJxTJ6aALh	5649	7981	7981	1617375780000
10967	3NLu6SKrw8EvKKDYSADVgsGP5pY6Hiyj7hhFv1r4Gb1tgfrtD4NJ	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1602	1369	153	6301	7377	jwTLFo45RcX8JVhptTGQ7R4nZ6XsR1da8qJB73Yx7S354XQfKd5	5651	7983	7983	1617376142700
10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	10970	3NLYwNBUf5ZjRRtdYF5prqE4Ni3DBxpMe3xG5vuYuQuhyZRwriDe	1419	814	153	6301	7380	jwjfQEW5JGdnUBBAeuvX7qrxWmKfkfkkHhdvqgPZ1ZeCAX3zG2g	5652	7984	7984	1617376320000
10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	470	1309	153	6301	7381	jxbXMNLM76HzgY5awdf4V6rCzJ8gAZRErfwddk8o3KyYHgmSSkD	5653	7985	7985	1617376500000
10978	3NK8XjXCeUqe1bpTvT1tDjzWRBaGqzwvTB6ufCMxotbpfW6ffhiF	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1673	1368	153	6301	7385	jxoLudptYzs5NR9MMW83B4YMF2r71cJLL8vTMNvutckRdsF2DUJ	5657	7990	7990	1617377400000
10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	153	6301	7394	jxebnApDo1RdnuS1vjAtpMeJWRh1RdKd7UtmgETBEu5QaWPTQsA	5662	7997	7997	1617378660000
10990	3NKAiVjJy3R75yC7amU8erEaRYdhdcmeARUdhr6qcyyaEfe6A83p	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	154	6301	7394	jx1YMTLhPMSQKbqdtjdeeGcsTYfeCnL6iNYbtceEhiAr1EZZTyZ	5662	7997	7997	1617378660000
10993	3NKwA9WZeDrXABs8ThiovSRQeAY6aDAPVjSc32Vnw9rLYyXgz2BM	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	154	6301	7395	jwvuGheC4oyA15LwNzUMALS75tp5GQuY8YH3cZ9dUZ1C4rMX5AF	5663	7999	7999	1617379023557
10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	10994	3NKJUf9axu6eRXtpycbkqM5x8i7tLAb4PqeEvV4afMJzmGBZvKUk	1403	824	154	6301	7397	jxKc9Dmn6pFdVL4hcsKnHHEoMwQ4kZgLCsG2ANTH7s9U9bfEWHh	5665	8002	8002	1617379560000
10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1637	816	154	6301	7400	jx6W2LniwCWCNniQeVCdM8DQMjRw794hEMUXcyd6M8QMDbPysRN	5666	8003	8003	1617379740000
11000	3NKv71feUhgv2G2iMcmG7EixBXzT15V4iBc7s1fSL5bw8tQ1fsFZ	10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	1483	1276	141	6301	7402	jxW1tJpXbZ4xMGPy2D3PktRuPUQFp9rkPAN9Lwc3iCz12FHvaAD	5381	8004	8004	1617379920000
11006	3NLWBp2Na2ZK1FFnChdjpT27ZqcBTaWATJ7pVm1aEZKBMhh9JeGu	10996	3NK4WgWooDhM8ZUsYp2WeT32SxMx3SwQDBE4MSrLVhx4Sgev9eaT	1406	1393	154	6301	7408	jxXQ4X5N5ihGDMFrqGFgqcMxGUYZfcGmCp7RW7SyRuFKnGLDcJQ	5667	8005	8005	1617380100000
11011	3NKGaXUqYdLMbR41pbjVCPSjEcgPa7H1J8Dwjr55rUQ1Y6ZFa3EL	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	58	1155	154	6301	7413	jy24izsr3DUBp3g5ZVAmLaFHaxgq3hzDjq2YFxDEyf4VUsBkYsJ	5669	8008	8008	1617380640000
11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	11012	3NLtbMY246oNTLeTv8iuJxwjom1ei5vm5D7vArk6nWCTf52Ew377	149	1157	154	6301	7415	jxois4y34f6Jze3xF4RvmwP9NEjzpfkbT9imRWYWq27ULNSqrRh	5670	8009	8009	1617380820000
11020	3NLVRZW6aXsiAphDCMdTYJVbHZq3p41JT9TT7xN1BFdiD1gwmYN9	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1637	816	154	6301	7421	jx5UGAktCHvLXDLNtzmsNcEBTXgzDjB41tJXC6nWNqGRTsbr9qJ	5673	8013	8013	1617381540000
11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	11020	3NLVRZW6aXsiAphDCMdTYJVbHZq3p41JT9TT7xN1BFdiD1gwmYN9	1649	1137	154	6301	7423	jxyYghBGLEVsWNjHqTdrbzFw4nvjkBsAnp9Y9biRhr4r4yFB7a3	5674	8014	8014	1617381720000
11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	1553	775	154	6301	7426	jxE9ktdE7xdZuSYijDpowuVQLYCBHunQXi4MB4qfBB2Cnmcnuws	5675	8015	8015	1617381900000
11028	3NLtMiTTfBetGVsj9ojo8Aiar94voRDoi4FuuyzEoT3YCLnDoX4U	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1585	1366	154	6301	7429	jwye6swFTn5DPk5ZtY5NGa31HT77DmPqAEhmeqWraArAbptAJzM	5676	8019	8019	1617382620000
11030	3NLfEG95nnuFvffkQZpjcAg1gLQJEiUpuhuEeeZKPhAcPF5rMkgg	11029	3NKWCbwMcebYz3WLdP2KJBZdbLmLwogXuQFWDmCVDc2LX7aR8262	1440	1251	154	6301	7431	jwQdiXqoRF4yw7SANMNXPNKkjyNKJk53BWT4xMi57EeDmC3dX5y	5678	8021	8021	1617382980000
11035	3NLmMvY2ccKCJz3C7Xt6pdtZTRYNxtKMDeq7g23Ad8mB5oF8pSzp	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	43	1064	154	6301	7436	jwUteP71C51TT6eh575HofYKDTnZPHRHEw5emtXAB8MqXXLxUk1	5681	8024	8024	1617383520000
11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	470	1063	154	6301	7439	jwk9TYyk5jxX91sRSMcR5LfigoEp841u9jcYgLq9QPokuwcBGog	5682	8025	8025	1617383700000
11042	3NLUqSFR9zPnwCMK6k7B97YgwMNynmBRUvGrhig8ksNQubDpebhQ	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1656	1097	154	6301	7442	jwfYWWsKT8JtpGNTpcKqPMbwKPM959sfHTcxUEJ2jmdFzZbjRxm	5683	8026	8026	1617383880000
10989	3NKDS5NhRQMZWtQDug6dYqYih8ekVo4H8dP1oMScjnZRjM3KtP29	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	154	6301	7394	jx1YMTLhPMSQKbqdtjdeeGcsTYfeCnL6iNYbtceEhiAr1EZZTyZ	5662	7997	7997	1617378660000
10994	3NKJUf9axu6eRXtpycbkqM5x8i7tLAb4PqeEvV4afMJzmGBZvKUk	10992	3NKqsoFw6DY25SFpgZa8ivxaCi3HAzLF7pyHkR1WFNHQzB14ZTnx	1508	1261	154	6301	7396	jxasPPjzEvQYXVnaLdipj6oZRvxwHY6W4fiyRVsacyWaezgj6Mg	5664	8001	8001	1617379380000
10997	3NLniYeezsrxecjzSaGgeTZNmgwYrzmXLF5R4wxh1kzDDMs86aPt	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1549	1236	154	6301	7399	jwAufJy1Dz1LVfWR5PYNtYxsv8FKuUsFrSKExKpWqRTD849XTrg	5666	8003	8003	1617379740000
11003	3NKdegosEZcwUNrFM1prYBEKzu7qhsjMpMyM4JET6ayzQ3Mdd1kj	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1483	1276	141	6301	7405	jxeY6a5j6X3tBVak2jxkQkU57BcDVEXC4JnAgBfaXn9zwNpsryX	5386	8004	8004	1617379970142
11005	3NKAfzPkvZSHT1SfJ4HmiJEHb9GuQQEybGpz6YtVswwJU4NPiWQr	10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	1483	1276	141	6301	7407	jwiBXjfKLeFD2EBk68S996b8cSjYxGDrPB3NCwvqn76S36VwLoi	5387	8004	8004	1617380017498
11007	3NLmnuuG2k6rTpc12qsFmW3dfqjWwwzXeV9y3srmJZz3piZFWFRa	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1407	1395	154	6301	7409	jwiYHobEEQEwTQjTJTGPXrQnWMJX5LjaUs6B5gNDLhdBHtSydgj	5668	8006	8006	1617380280000
11012	3NLtbMY246oNTLeTv8iuJxwjom1ei5vm5D7vArk6nWCTf52Ew377	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	1458	1077	154	6301	7414	jxFDpcBKu4VZn46vDCGVfv5dNde4RaDbMxCMy21hq9Jnrvv1d3c	5669	8008	8008	1617380640000
11014	3NLc9a6NY8AQ1vuzvWxEUhuAGPmFdfYHWRdii7dQrFbW2jaxuPgC	11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	1536	947	154	6301	7416	jxUTC5KQUEEwmNZrB9ZxtXpQ9va9g1PJugxPeKhSSp9yqu5CSEv	5671	8010	8010	1617381000000
11016	3NLJpUMEy58ywF8LA5ngHagPMoH2waumEPrBFfvY94srZsXGu3gH	11007	3NLmnuuG2k6rTpc12qsFmW3dfqjWwwzXeV9y3srmJZz3piZFWFRa	1406	1393	154	6301	7417	jxLTQojQBCtLn3N5LyigB1enpKJ6USNZbAwWXsBng28ZDqTTn22	5669	8010	8010	1617381000000
11019	3NKWFB4pCuoCxmLAJcaqgFwKwtWvHnt8A8wXbNZJbAvKA4Pw7L7E	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1460	1324	154	6301	7420	jwafU31ERVKbxPTidAKoGcrzF5ftPWbew8EBPWjV6fQK4JnMSba	5673	8013	8013	1617381540000
11024	3NLGD931e4aMGbXVpbYEBPvCujZFfuNxdb9a3iTWr6zN7SBtpVEH	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	1407	1395	154	6301	7425	jxpKMznMK68P3uF9Sj2svoNfkypuAEDvn9Q5YVXt4rJGhHqA8Ux	5675	8015	8015	1617381900000
11027	3NLLAsbaWwmLFfW4etCizPkzYvQc5hr8k24xJBapwdcJXpNNZE4G	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1506	1247	154	6301	7428	jwGWASZK9rytiLHA2h2EkdkQqgabN4gzfbmSYpWTTA1dy4g3Z1d	5676	8019	8019	1617382620000
11031	3NKDee3A5U1rKDXWPq6QEyNTKAzVHZUCi7cLQMU4GiXn5z8VrqjC	11030	3NLfEG95nnuFvffkQZpjcAg1gLQJEiUpuhuEeeZKPhAcPF5rMkgg	1513	1013	154	6301	7432	jxdWscjbpbbRSMJuxptfSkznvjMNhyKi9md9QJ1KbQhJ22tdehz	5679	8022	8022	1617383160000
11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	1397	838	154	6301	7437	jwzgF58Kwg2KbSi8HACdidHJF4MwX3JfhKasqUj3rxpHv4VuoXZ	5681	8024	8024	1617383520000
11038	3NKKkW4p1y3AzhKMYtDWxDMCA1hvXAKcdJJQeDPmMWXMJVCwJo3d	11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	1406	1393	154	6301	7438	jy2rCY8Dr5iS1GR8x7fWdgoYzictVP8caxjvfjBb368NoSK89LH	5682	8025	8025	1617383700000
11040	3NKzUQ2uxT9422BbgdaGUxaqjjJJ381eXz3ji2gc2NEiENUstPh5	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	596	1306	154	6301	7440	jxKaqGpAnwgvkv6Y2PTkVU73WbovrdP87xbEfW1hBW77iTGidg9	5683	8026	8026	1617383880000
11045	3NKQqKaZWAAZzg2hJEH1nYNCBxmvcFawwekmocWqanM4sF7BxCPm	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	238	238	154	6301	7444	jwjuNYXMNXCxM3idRqMUZB7aAEcykhTVQ3awY4nhHmAXGQNqSoQ	5683	8026	8026	1617383880000
11047	3NKMvKoNX5riHdUbKGGZ5QdWz6yZS8GgG6dRCNMHq7qEYivt68UX	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jwDN2c6T2MWh8WwAedcDH2Tu458o16Ft69oYyHhPewCR5i3TwgG	5684	8027	8027	1617384060000
11054	3NLq3iPzZX925cA4zsAvHQR792tGPJeSQEuTU8cwErqVkSMd7dDp	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	1407	1395	155	6301	7450	jxwma8ByUChiKo8dFekPh83coQjBGeSpvyLDjrmgdKNzD157kjU	5687	8032	8032	1617384960000
11056	3NLQdgwdM2Y2XvCu6JDvJPrtAj2u9uBByHYd7AAgAbVoUQ9DbBp5	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	576	1355	155	6301	7452	jxZ5z9oWekrdkeRPuotxjo1NSQbgorNo8uStQhsdzChAEUUHY6w	5687	8032	8032	1617384960000
11057	3NKT1VfFyCRCgst8vT6eGHVmGrowiEp66Gq6gB9j7ViQ4BhtCBTU	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	576	1355	154	6301	7452	jxwDFKpsT1EgBnZYGU8P93bbieVLDReEt5GsfEJYwvCtp4Mi4CL	5687	8032	8032	1617384960000
11058	3NLtBS9CnMvMnLvje8piLBiXRbAc6zoUr2RLAv9sE9H6Dv8jKtPq	11053	3NLaCPrfCiTDk9SsLhY3iact9qwpz8QMmkouW7ez1DpJtpULjYUZ	1673	1122	155	6301	7453	jwj8YzXqt1CsZj21WYBARAdagHd3s8in4DGhBEQrJPE4Ezx3ppS	5688	8033	8033	1617385140000
11066	3NKXaYSjyYCda2nNbsAfWfBujNRahbQo5Vwuy1ScyxAc1rvXvtQe	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1602	1243	155	6301	7461	jwY5kaEVkPxe1nPghshSCw4YHZc59RPpo1NehqfC14B4e4UGLPn	5693	8041	8041	1617386580000
11071	3NLoGh8p9AmwycVMxX71uCCwfT7g9RsJZq4WH8PVEeRSr9eYHmGy	11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	1407	1395	155	6301	7466	jx7R76rt3EXyWrdXtt92Jx4p5EE1dJyZHagHus1rgRE4kuCpDvs	5695	8043	8043	1617386940000
11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	152	1204	155	6301	7468	jwaHsJjtBxLUhR8KnB6mKoeAbHji7fZPpSHPmWwmkToqHnK4Bvp	5697	8045	8045	1617387301774
11075	3NKrxCiih6iYg15mYNG9fWUV465HHCjSAqQbHXWbDBahxatCsksH	11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	1406	1393	155	6301	7470	jxMmQz3dA3LrL2rxuhoU3UwyZdvrzBERjmxWwbSQbKih1UYEhmQ	5698	8046	8046	1617387480000
11080	3NLYFGhpLp6jfdXK2xkMHXhDQucBeJLAx7YgGLkcLs8R4Pd18RrG	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1407	1395	155	6301	7475	jwNsMrxxzUFrabxkCtGHs4Q6kJ7y48xPGmBhmjnjkHx2vrpZ83a	5700	8048	8048	1617387840000
11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	11079	3NLERQFPWrdFoYFY7NwfHrB25Zft6iiqoYjWGwt9pcjZy2oG8u16	1553	776	155	6301	7477	jwcN8JHaUdRJGQFJzDfrVN8uc5syWxxHHxQFuZniRwmntso5JV3	5701	8049	8049	1617388020000
11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	1631	794	155	6301	7479	jxV8q4Nt4sZyGrHkZLGmFBxQP7LJbaJ32GRkwGWNnrYySddMJcC	5702	8050	8050	1617388200000
11087	3NLRxcAdfCSGZjFyjhjuTwbCGxjNRvNM3bme8HMBtTeosoCYrbmg	11085	3NKHUcaf3ZYRR2FnqPmWUUCond4h9rgVDN4UHji68gDfnkkNYRw1	1403	824	155	6301	7482	jwjUz9A6asXTT4oZANq6pNisVevjg7AtcCm5KoqPpPUSjGDmoVy	5704	8053	8053	1617388740000
11095	3NKCmg8pxAFn69E27D4pTbwvGD2d7bgWUg2SAfMiLiysRJgGnuo5	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1403	824	155	6301	7490	jwkU2xvUnSZmkjpE2CJXAfZjuEsQ3awC5BtCgiRqgo62b6aRjYi	5709	8058	8058	1617389640000
11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	1467	1376	155	6301	7493	jxt4BJ7UhqYuAScasGiJyGjwJLc6scJbXDtEt7hpp5K5nh9VZUi	5710	8059	8059	1617389822511
11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jxUG5Gwpx1sa1Qq1zqGrLTFjCaaW1uBRvbku7nvYi7LztbGxgmq	5684	8027	8027	1617384060000
11050	3NLNEzcUtwQRohK3mRHPfhn2Pwrd5MM4GSMxTnvTVPd6Y4GqB2Ym	11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	1451	1292	154	6301	7446	jwSQjMdutmEeyCY5ehM15ncFSoCBymtgSx58Fxs9CExkUYTvFLL	5685	8028	8028	1617384242911
11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	11049	3NK46zkysbj7DiuQ3kh9RZffX9e96EiTA9ezfNirFUNoMu3MT9db	1509	1074	154	6301	7448	jxmxiSNJ9Eb926A5dT7WLNUXHqbTzuYsLre9xeJfFwD8Sbh7mZ1	5686	8030	8030	1617384600000
11055	3NKjE3PsFnpsRrRKxeX6t923q4SExE5TANQLmCDrCigamwPWkk4Z	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1447	701	154	6301	7451	jxtA5RTfuHACSCoCBxMxMysoSgQeARp6SVvvQ4GkAPWBzygNKxF	5673	8032	8032	1617384960000
11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	11058	3NLtBS9CnMvMnLvje8piLBiXRbAc6zoUr2RLAv9sE9H6Dv8jKtPq	1455	1332	155	6301	7454	jwRvZiQHnhpBJDxKvkTj735X8YozBB5fWS9vabGNxxxG9jkxE2d	5689	8034	8034	1617385320000
11060	3NL4uyo18hYhrpKgeWYg9RxkCLoRh3QJrGazTH3mgijJsQNVQWNk	11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	1647	1176	155	6301	7455	jwK6xuu8TH5J7q1Zux6zegPbT3CKVZhabR2dXynT3TrWU5y9Fpq	5690	8037	8037	1617385860000
11063	3NKfTgeALecF3ZGHwXjbk3nDGxnzagzibTBkYxd7eiPD1zaZ1XES	11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	1407	1395	155	6301	7458	jxodHzEm5vFG178ofQ2ZwZEhY8uB3xP68B22pPmjyW5aJD1eMba	5691	8039	8039	1617386220000
11068	3NKtmZk7nd2X4hBA2uQhsTucdVekAcVWHBMZzP4fA6RbXvKJuRaq	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1675	1342	155	6301	7463	jwTXAUT7dmtTJWdnKzU6CuHafrBfV3yxbN6DZ7VotFwvQoSDpzQ	5693	8041	8041	1617386580000
11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	11066	3NKXaYSjyYCda2nNbsAfWfBujNRahbQo5Vwuy1ScyxAc1rvXvtQe	1553	776	155	6301	7464	jy29hEnzxVXujQGkM2M7gqsULTWZEpVxBsBxVXefexBMsNeR9SQ	5694	8042	8042	1617386760000
11074	3NKoSPu9Dqi2scRekdLA5WxHW2zMNsdjRhCQ8r4YSs1FGpCPDQb2	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	152	1204	153	6301	7469	jwNAsC4w9pXEyPNj1RDsa1iSKUZPVo2XZC4vgCrdDmRehT1AxQq	5651	8045	8045	1617387300000
11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	1508	1387	155	6301	7471	jwvwksyY6X4fZyQGzifHXPrXH5eFiPkbKuTrkWLgrttt8gSV8Gw	5698	8046	8046	1617387480000
11081	3NLcjBA88hLC8BRTwVZ1eecDEPypwS69t9NfZwmCiFgK68TcMiMC	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1631	794	155	6301	7476	jx7SGvbjxBk6KoC8RVD6ENnjkWjpNBnifYmfQfCzwyssQqSGqYh	5700	8048	8048	1617387845003
11083	3NK8skEQWEQfntRoiGMaXcHNigSe2oyAydA3v5XAqoT3rHUdP59s	11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	1599	1161	155	6301	7478	jxDAgfPh1zU45sd7eb8T1ma5GmQJSPsbM9Ed5LRP8XToCRiP2Xf	5702	8050	8050	1617388200000
11086	3NKAA15Seyi5fD9NCh3AjU2xiJtQNs1cWXJ59PGmgjaWV3nVM2oV	11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	311	1061	155	6301	7481	jxhHmtPEA9W5q2oJPVJ4stgq7ADXBy7PAHWmKnP2tvW1ocbFQrX	5703	8051	8051	1617388380000
11088	3NKa9QS48ZWo4MFSbUSaBi836xH4rrqUuQtSkQA5EYCaVgU3vqSL	11087	3NLRxcAdfCSGZjFyjhjuTwbCGxjNRvNM3bme8HMBtTeosoCYrbmg	1536	1313	155	6301	7483	jw9CoSv5eMqeLDQ45kgr8pt6cgxnVGV2xqBuijrTAXzVh9Aua8R	5705	8054	8054	1617388920000
11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	1406	1393	155	6301	7486	jx6f7EXk9YjLhNxwYYoCiLFg8TqncGxZub8T4vpkPrveEJzzEVz	5708	8057	8057	1617389460000
11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1622	1356	155	6301	7488	jwa4Ug6L57GjsmTo6sdTLMtyo4YSbUjayBc1VitN8CGuZqirQBi	5709	8058	8058	1617389640000
11097	3NKF4doKa3PvVRSuJ37hTXPqt4crPhHxi6sQckCEz4w9VXTsgD45	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1650	1009	155	6301	7492	jxSck2Pf8MWbYUAqJKH4EfhFVFLTdcUKiyve2X7Qw9FGWNVGd2c	5709	8058	8058	1617389640000
11100	3NLA226SwG599W9MGP41K2bKhat2Eo14tEN3pDyguYQTvUnnnr53	11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	1657	978	155	6301	7494	jxiajczHrdgGCKdHLtf4ZHKNRRbzWktNhUkH5qPprqiUbXBqMB5	5697	8061	8061	1617390180000
11103	3NK4URCqeAnJzEnNU2sLt3rgPpxRdFbhsZZKPiNVkmkBbeJA4Du3	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1631	793	155	6301	7497	jxoooGxRpvCQxxRozFTFQUsLKroUpRGoeDnwGmLDVg9vk9HhMuK	5711	8061	8061	1617390180000
11110	3NLS5hKunveKEZbgBBW8pckj4jyfbLAvYhBkdB6TVX31UPR9XRWc	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1405	851	155	6301	7504	jxNQiib3qi6woSzAWXV3n2tmz7yNkCLiWDobGTer7caJhT8MmKE	5713	8064	8064	1617390720000
11111	3NLeiGvNtAdweBVHEwQsfJm2S6SMb3jf8w2r4Fa4Xb6v2NHR7ov6	11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	1588	1392	156	6301	7505	jwVp8HCUX8D9gqetMPEZTNSjyjyeNaH52oKPRTzqVV9mpAcdDqW	5714	8066	8066	1617391080000
11114	3NLaEkheMkpEH43SJ5U96fDKCkb7XRF6N6eXLDCpw8RUto4bxr4H	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	1553	775	156	6301	7508	jwf6vSjETXswEkyL22fHBtNQJpmfNafgWyrhxtK6zc3ceZ9qFRi	5715	8068	8068	1617391440000
11117	3NKbbKoRTpmxN6ujXiwZ6ju6NXB3iYeeofqCQ9i3npfxdqa1rnQS	11104	3NL9mi69W2e7XnReJshrNC1guhLiHR3nCBYHV13LAsteoaXhCfaF	1581	778	153	6301	7510	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5609	8068	8068	1617391440000
11118	3NKas8tB1kVaqpTLYtwDC7dtdScL6isbcYXXSFyZs1g5EbXwAH1u	11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	1599	1161	156	6301	7511	jwaYv3RafVB2erAsTWGhViJwrFk238qyykkUVyLW6og5xpCwRcT	5716	8070	8070	1617391800000
11123	3NKhC2hjAMeEKta2c51gyodPJnSHYgdg6pdeojR1HBdaj6jRSDG4	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1522	1076	156	6301	7516	jwJuTKJrS8Ngc9xSsZyzJdcc41sT9Z6Vh5EDoTdTa38sG42xErc	5718	8072	8072	1617392160000
11125	3NLJF5aSJy7LC8fmCaqdC58uykQjDgmsCxbZQtnTZ2zUDk7RWDV3	11064	3NLEEuAVGZifHW41AA1bFkd7GUHLtSZBsk8MZnXYYmtfpApUYk9H	55	178	155	6301	7518	jxMSSD8voUEvYtzcZrVC8y5eMEAbC4aCizgU4KkAtzD4ESEMmDb	5693	8073	8073	1617392340000
11128	3NL5AAbGaUErRVJ8QazQgXnhhySZXgHwoaK2kR6qLumQ4fNobiwN	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	1419	813	156	6301	7521	jxCGFGU4Wm72k9z6meA6THKJbRKakyqqqYS8pMxwRocnTqRJ6kx	5720	8074	8074	1617392520000
11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	11130	3NKQtazttHL1R3JKewjs65cTH4ZBY767soB9W11kdxYqMyAdLyHa	1594	1326	156	6301	7525	jwty7yXsWxMDtfBnLrx1nCFmZ89mzNA9seZGaxAxc3jRz8hKgw1	5722	8077	8077	1617393060000
11137	3NLJLpTbY3E1fAAfFA9KfPLTYH6XLriUZhoUzDGCBfM1X7Pim2Hk	11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	1406	1393	156	6301	7528	jwjoup1ZiuhVKEFKr9HD6KTY5LipWpxYBGVxNvCJsVYmNTyEagN	5724	8081	8081	1617393780000
11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	11138	3NLRUs4wh4A5AFeVDpC1XGtTv2jHvzWEHKfsL5LdND6Bwrmm7CUe	1407	1395	156	6301	7530	jxDX8ciGHsvstbFAeDSWhcirLU2TuPfp8YFGecXJEZX792Wd5km	5725	8082	8082	1617393960000
11142	3NKcneNb1kW8eoLtEFcJW4uwnicGLAuCyUCKGUVhzn9ikreUcQS4	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1646	1228	156	6301	7533	jxhxn4utkxQ97JBfbQxbvjvuGfHznqH2f2m4fbvgQ6o8HnTQLGM	5726	8083	8083	1617394140000
11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	1402	906	155	6301	7456	jwVcVmtFoEHPudozSvFveo9FemJTb67MSNNvYKZ5bcxBgNzF9gH	5690	8037	8037	1617385860000
11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	1589	1286	155	6301	7460	jwtvSEK3fVuVCxQ5VVQRyvn1Fm8Nx3N9VMe83EBCHfPBPmoxdTN	5692	8040	8040	1617386400000
11070	3NKbA6byVfQCsNNn2ifHznRomJGQ2g68K3Wm5ntyLgaMhG9XAqap	11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	633	1138	155	6301	7465	jwvYASY2q46riVaQxq8GYLRetPFi3D9JQobMFveA5GKApq8ZKZx	5695	8043	8043	1617386940000
11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	11070	3NKbA6byVfQCsNNn2ifHznRomJGQ2g68K3Wm5ntyLgaMhG9XAqap	1647	1176	155	6301	7467	jy1SJ4AVxCzEUicCzkVQsjb36qGhNiFseJc9EjqfWcSYU86TxNC	5696	8044	8044	1617387120000
11077	3NKfoz1djyCLJXDVC6ShnsBVTBurSUak6u4ZEsFMjHL7niAADHRF	11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	1455	1332	155	6301	7472	jxFnj7GTRhf5uVQ3fuwATD9JGyD5JTNq1JmibbzK1q2HcmJH345	5699	8047	8047	1617387660000
11079	3NLERQFPWrdFoYFY7NwfHrB25Zft6iiqoYjWGwt9pcjZy2oG8u16	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1403	824	155	6301	7474	jx3QrxM6nd1Rj4fg7jsS3kFL1TwxhMYGe3SqaRcaUGZDrTGYyzA	5700	8048	8048	1617387840000
11089	3NKM53M4HkQaCpQVNGqmBtsWLgxvkT5pyAxQ26WXqGx1PqcNY3Ma	11088	3NKa9QS48ZWo4MFSbUSaBi836xH4rrqUuQtSkQA5EYCaVgU3vqSL	1451	1292	155	6301	7484	jwCtmzFSR1EHuNt8oGTJcgezQmVqZVCVg7kXAb65wbKLrm6oUUD	5706	8055	8055	1617389100000
11092	3NLWGYwscRDutkSScCY9sCHMAb2F76aPa9xjennM2jEJAw9HvKJJ	11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	1637	816	155	6301	7487	jwpXUUvpyK4w6BnTca9s1YMtRXJQkCqCyxRSVKAtjijVr34WvWt	5708	8057	8057	1617389460000
11094	3NLmwJxmAmouzn5Y5w3Jt7CSZbn5noQF7CJHn63FdRv5hAdKSvmU	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1642	1121	155	6301	7489	jxDpcWkAbRgWPa3gVyNBvqUrP9DvwxYY6eTbxd3hHGWWYotUg8A	5709	8058	8058	1617389640000
11098	3NLaPHqAVamRsXQ58svkJH2oyUDcaZkzLziFeHkPCh7bEBSpG8dy	11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	1467	1376	155	6301	7493	jxt4BJ7UhqYuAScasGiJyGjwJLc6scJbXDtEt7hpp5K5nh9VZUi	5710	8059	8059	1617389820000
11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1602	1123	155	6301	7495	jwdq7yJYEciL33PknJCbSC2ABmTAtJGiziQTXRwBUBQVeQtpDFF	5711	8061	8061	1617390180000
11105	3NLJMPn7AorxGnif6eXZrM7xnbFLiVLGJmZwNWRZWz9di8UXf8tW	11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	1460	1078	155	6301	7499	jwu88GbZEXU2BEaySqGChWxnNsjcTfGqqtBnnZ5sEFL3Ptb4EEt	5712	8063	8063	1617390540000
11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1578	1296	155	6301	7501	jx91ycdt8T5cCfD79XY8Hpn5xGc4GibkuYZzzrBwfLmT1KN5bGm	5713	8064	8064	1617390720000
11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	1529	1190	156	6301	7506	jwAtFGRS93ckA7MGywYqWw1mL4PY79ZcSFcJh5XAXbGBk9Zf5Lz	5714	8066	8066	1617391080000
11115	3NK3hsWg9g37aBpCMYFq5U5JTVb1Ypg2BZDbNvsQyHRCuhruHrA2	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	563	1359	156	6301	7509	jxvHaSA8K264BBftHEcQdT1TvnmYDTjwXeDnzpqR76dnsS2ULU7	5715	8068	8068	1617391444490
11121	3NKMdBGy5QdGxESCkknLg8xNBVcMeU8xE4hyQbojRPNzXzEVSm69	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1474	1329	156	6301	7514	jxUutsz1t6FvS1BQTRuYZtpwcvrGZMz6BhU5nA1DDjJas5sq9kA	5718	8072	8072	1617392160000
11130	3NKQtazttHL1R3JKewjs65cTH4ZBY767soB9W11kdxYqMyAdLyHa	11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	1637	816	156	6301	7523	jxmGURajW8E8nFhKWebCMDb6gznxbjLTDRriG7iqkC2WL5TAigc	5721	8076	8076	1617392880000
11135	3NKF4vcQXbJoU6BN1rmfcso96dpfzp6kfjV8Up9Cz2id2C5WHxLp	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jwFgycpxc11vu34CvxbwN1dw1w3JiHHDM564yFzQf15AVs2hLi8	5723	8078	8078	1617393240000
11138	3NLRUs4wh4A5AFeVDpC1XGtTv2jHvzWEHKfsL5LdND6Bwrmm7CUe	11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	1426	1364	156	6301	7529	jwfxkHtSNtqzrURTor9pFWY63PjytkoA2Sk11ToWqV63b4zg4p5	5724	8081	8081	1617393780000
11140	3NKaq1TPbyFCvqb51nV57aAEWnxBUbo9fXC7RHBrAgn7VpEsebaK	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1490	1028	156	6301	7531	jwkwWGQUcyrtm7YGf5PEhdVieQrRJR1WU8RbfAsbZTqtjtCWvAy	5726	8083	8083	1617394140000
11149	3NLkfSj4EG4EXwNLLJnmR6bvcwLNEcFpZjbfZAjCKQVcyzKNUFLA	11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	1596	1363	156	6301	7540	jx911accoh5o9LQhtiydh73PCpvdx7qZP1HivCCqs4LDzgP41gS	5729	8088	8088	1617395040000
11152	3NKw6aSEk7WdfXjKEAPfEoAnFDSB6NgcCxYgPJKMbo5GQB4uGjc6	11151	3NLcD9RHURdtouSBAVQvJGTPbrKDiAm4tAYHQMiE5dz5tUXhxdTm	1458	1197	156	6301	7543	jwUCcgNd4MSvcauuZ2VZMWzjpkXykYfJdVVhRnrjUtuP6t3mntW	5732	8091	8091	1617395580000
11157	3NKKVcrGvqGGzDmLDJHyXX7tD3ENkeBoeBHFLsdqerCUXHY3fEwz	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1403	782	148	6301	7548	jwCNyG7zBTgpfStguRo3YAmt32YmSEJMv85vJ4gnMcaGBCvC5kD	5538	8096	8096	1617396480000
11160	3NLZ5qbVG3pT2xDtSXWrvkxnySrZxNTUFGgre3F4rULoVGDyE1LV	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1403	782	149	6301	7551	jwncntuMjrAZi2S1MAdzrW5bxQXfq4ysCH9fiXsLGMUjiLg73uv	5564	8096	8096	1617396546545
11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	11163	3NKiZmGVKuQsqxd5JPBvX3wJa3yWkVj1xYCcuBZGde3FRbrnf1cm	1629	157	156	6301	7555	jwUQAPuqmTvSfcusQVLkG7Um6MwGAZKfvYQHm6nBFfxwuHFV8Z5	5738	8100	8100	1617397200000
11171	3NKXaaR2MAw2rMkWTGcuDaCeeawV4Byyq85J3KicBtisNL6H4qTS	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	157	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000
11174	3NLZsjZ38P2jE62Zp1qLFwAXnuFf6K2EnWaZjfp1B7bFqkBagur4	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	563	1359	157	6301	7563	jxGauD6Gs8ZVErVqeQnPZs5FinzttP3W7fb5379fTQykKtyAa8s	5741	8103	8103	1617397740000
11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	1483	1030	157	6301	7569	jwuGN9DEw4kjxBZmPKvEMEKkHh8fabKWoVLXgM93Bgja1Pwuxpe	5743	8107	8107	1617398460000
11185	3NKnjrTgmf9MPTGLPqL3vCZqUHfHYiq6MKPPG2vaykzX9A5r92uA	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1406	1393	157	6301	7573	jxWpSEAJH4Yt159Zhaf1vM5wfbY455vwJxNJWjiFPbpbHy2VbpS	5744	8108	8108	1617398640000
11188	3NKcKfgaFNmmGkuQkfKk7uCQhKennnXWVrTLD7RvEJubfdmMYB8V	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1534	1191	157	6301	7575	jwCMFzWjTaJE9SY2EgUWTofwh3a2avxvcXMZFkKnxa7eDeSS5oK	5744	8108	8108	1617398640000
11190	3NLUVfTTToUqcAuCNGdZvn8c4y3tHvq4MrvoSonanKAe6SXzryBA	11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	1643	1053	157	6301	7577	jxpDvReyfEhoCvLb7i7TmmwTGyZdgpDvfxtWnQSuUCdDajXRcKe	5745	8110	8110	1617399000000
11200	3NL4rq7nU7QBgNumxh3Nfj3mX14yyaU6L74vNkMurTNf5eG69vdF	11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	1406	1393	157	6301	7587	jximURABzmJyU7rzieiUgkBTxHZht5kzqvhmTZcmDqwg2xx3tVM	5751	8117	8117	1617400260000
11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	1406	1393	155	6301	7457	jx2gZe3pnULyoL6rBaqr5g96hQBYL6uYFzQ3NBSYhSM8ew3tKGh	5691	8039	8039	1617386220000
11064	3NLEEuAVGZifHW41AA1bFkd7GUHLtSZBsk8MZnXYYmtfpApUYk9H	11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	1444	1381	155	6301	7459	jx2WMk3GnB9y37aFepb6eU7mUaADsnMQtrDZhTEcBEwUqa8Dmfx	5692	8040	8040	1617386400000
11067	3NK4oJ5APFfC2Jsm9amffF5PgusPrbhJt2CpMuckDQuDBGs5jT3V	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1609	967	155	6301	7462	jxnQU9SbyPgmf9gWkD9yuq2tyP6JqdcLfkDiQC72pioWiQDewjy	5693	8041	8041	1617386580000
11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	1553	776	155	6301	7473	jx9cCqhE622tDbiEQEyV5yWURYZmkFGxW1NGB5YKrEXxMzALBKe	5699	8047	8047	1617387660000
11085	3NKHUcaf3ZYRR2FnqPmWUUCond4h9rgVDN4UHji68gDfnkkNYRw1	11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	1406	1393	155	6301	7480	jxr9ad5SUsyQdFD9yqnajoJ1PtBw3kiRYDpY7DVqGYex6ACKoaK	5703	8051	8051	1617388380000
11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	11089	3NKM53M4HkQaCpQVNGqmBtsWLgxvkT5pyAxQ26WXqGx1PqcNY3Ma	1553	776	155	6301	7485	jwqReiydt8uG1jU9k9VV3YXgbtxwr4Q2h5PzqQhdesiCGim9E7X	5707	8056	8056	1617389280000
11096	3NKTycJQ7eXo5Dc489VW5Ar8YEkJzZToZBD1BnzQVyKYszmFNf5Y	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1405	867	155	6301	7491	jwb4YeyEaYtTnzWM6uBxUtwzfHNPFaKfLBrKmv6NyEJ12wz1jpC	5709	8058	8058	1617389640000
11102	3NLgPeGVYX2kYAtWH8z3F4PisvVuYdynBrh6Qm1NectYUj2bvG6B	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1657	978	155	6301	7496	jxKNg8YrQ4Xy1wz9UFRd22Vpd28oiAt2cbPStSkA5a371pAtriQ	5711	8061	8061	1617390180000
11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	1631	794	155	6301	7500	jxxAumrUUTWxFrKWcwwVzgpU4E1AHVUUxsmTewPpuQnFzPPKpSY	5712	8063	8063	1617390540000
11109	3NLdyaNUgUeSSkqLdBEAMFQZS1msH27wxwAYcBjd5nGg4ecqYEFL	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1549	1116	155	6301	7503	jwJjZFyYKSaUpenze8vUDGWKpKPtwA2LMTcJuQeT7zr6tsvCm2P	5713	8064	8064	1617390720000
11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	1623	839	156	6301	7507	jx6m96QS73QwWz9Ppe4begtkuGFQQgThgQRB2eXW1RKE88JBYPx	5715	8068	8068	1617391440000
11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	11119	3NKZ2VSkNc8fo1gi8pCkff96Wdc5iM4WrX7HKNnnatLgKQFgBJs3	1506	1127	156	6301	7513	jwLeDmk3bjLWHAf92KCFfXQjqVU3TeJhv3WwkYeewcmBRRuP8vq	5717	8071	8071	1617391980000
11127	3NLCeRY1KBazspGJJXPh4ZaCM35MK9oftAbc8RQTvUcS5T7hPGcA	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	42	995	156	6301	7520	jwQYcALcLiWPYCaBBFY241C2VTLJb4dZogUzk1GJzZC1z3JagMb	5720	8074	8074	1617392520000
11129	3NLjc7L1CW5XmBTrQFZRt2xHRAd3WxDPXJikSygDvs4DKSqBLDem	11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	311	1307	156	6301	7522	jx6ZbbEjNsbZgLSAyx95tNNuPhECsRQViFFjACpSCABseHVDHhx	5721	8076	8076	1617392880000
11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1476	1371	156	6301	7527	jxPJS5TEC4boQkyfZvzZy6zpPF1az1E9mabRgzBo2RTcsWb27VF	5723	8078	8078	1617393240000
11144	3NLKQnbKoWPoSAypGLwT1RW7bpQg4DWeKGdP1MH8LY5SoTbh4zmY	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1406	1393	156	6301	7535	jwUz5wyQ5WbMCyMg94tw3MpQkKvNBieortBzQ6FaQ4F9eEyHhsm	5728	8087	8087	1617394860000
11147	3NLirSwuFDrqhQPy4i4pWR73D1AYnmp3bfuhYu4drsuCHxZQWPPp	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1402	850	156	6301	7538	jx6K3183sjHFBQZbPUZFbrawS1GqN1unwD1agBo7tBBoydq1MD4	5728	8087	8087	1617394860000
11148	3NKzH4eHLsyf5fW2b7adsdNB78jUUyzmLYVpktSaxjSRYpWdfVd2	11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	1407	1395	156	6301	7539	jxS7yLhNWu2zAtAV4Jrrw1boJ6p8xy8q3BTEwfxN5SierZdYt63	5729	8088	8088	1617395040000
11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	11152	3NKw6aSEk7WdfXjKEAPfEoAnFDSB6NgcCxYgPJKMbo5GQB4uGjc6	700	840	156	6301	7544	jx6DuKsePvRZakJhzr7WDBa5aLHGk7HmmruDi9DikeMFEh2pAUP	5733	8092	8092	1617395760000
11156	3NKeSp7sz4QtV6ENiHyn2iaQf5RhXDi8zkeBdUUkj1ym72QBGoeW	11155	3NLhmEpVBVWEmATPDhRwykTaM9Z2RfEHqEXijFs6VHadd46m4VTx	1483	894	156	6301	7547	jxBusdCQJEDVRkZ8wW13PL1Az2hyZLNgF9FJ38LCCz35Cq6zvYz	5735	8095	8095	1617396300000
11158	3NK6iA3wc5fU9pmLrDEUjrGHVCqkEGbHu6cwRb1dtvYK4KEQPzv3	11156	3NKeSp7sz4QtV6ENiHyn2iaQf5RhXDi8zkeBdUUkj1ym72QBGoeW	1402	852	156	6301	7549	jw8pktVvxkoH9T7qE2yVKaqMKgboARjs7UAM86V43AaDhbGNJq1	5736	8096	8096	1617396480000
11163	3NKiZmGVKuQsqxd5JPBvX3wJa3yWkVj1xYCcuBZGde3FRbrnf1cm	11158	3NK6iA3wc5fU9pmLrDEUjrGHVCqkEGbHu6cwRb1dtvYK4KEQPzv3	1455	1332	156	6301	7554	jwjKhJz6KNaCbLZHT227NZuJnodZfAXb9TimsRagSENqA1V7DGj	5737	8099	8099	1617397020000
11166	3NLogaYC93gszc366r8qi8u5UVuAASBpYGAUp7ksR2uuyEVzRgd8	11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	1611	975	156	6301	7557	jxHKNE4Z35kE6ZHrCau2XN6ThdDHcYoGcVzS11vQLoj3nz4Kqvu	5739	8101	8101	1617397385535
11168	3NKMmGZiwBaP6R9L9tVKN17mytFGswEVdW9wFe34nAdjZvoZJJCD	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1406	1393	156	6301	7559	jxSvz3wcNCfQoZHA1MWhEoocdRJEJibq7WSgcASo9Po9hzezwzt	5740	8102	8102	1617397560000
11170	3NLwDUf3pqZEtAafAvPNThwTBhn8VYMeF2CrMSwg4MUFmyVBho1F	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	157	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000
11176	3NLngUC1g2n8TazxJy8FdLfBebj13ZR3Jkm27f2jTENogsEUhan6	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1631	794	157	6301	7564	jxBCUR9i3pLrF3FaVL25gyRciSn98cefAJzbvpCaQvmE8imzqK2	5741	8103	8103	1617397740000
11183	3NLeQ1EfM1aUafcXdVqu86HHVoGwP2co87hAy38yTXHBrugYv8SV	11173	3NKuSX8Wto3CETLzHXat9fHFXWi81m3tMdRNVH5s5uUfBGqgpxRr	1560	1045	157	6301	7571	jx1sq8mGquambbJxxiYmeMDDEEvRrya1fDoisdK8JDmjRj3EWc2	5742	8107	8107	1617398460000
11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	1547	1378	157	6301	7576	jwoShSa8kSumxsXXFmj9hcrFzakfAL73TcFoLZoJMMT3Mn41hPb	5745	8110	8110	1617399000000
11192	3NL2EMbXZKGQL2dWydU7pUwZUju8CGEGTzbuA8MDqwscJhj6ExTn	11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	1405	855	157	6301	7579	jxKLyt85pkw5rvBkLHTZiQ4YiCgxh7kDuW5LVSCdQs7HUgJXkJ7	5746	8111	8111	1617399180000
11194	3NLtmrfLHenfPAJn4uLCtsLibNRznGgmnvAVeCXB8jRsPVgFm134	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	1527	1047	157	6301	7581	jwzWVu11aLZYZHoACaAhTDpbzhNe7ifhUcXHsZ3nH6Q6axiNiLH	5747	8112	8112	1617399360000
11196	3NKAMSNhrVStp6PW5CXed8nKxiUihV1Fkn4RRYMk2bjHHHrnheKe	11193	3NKAg6CBuGTEuH45GXdLHUyceXQJMparXzryUGFsrH7jAixaiyXM	1402	808	157	6301	7583	jwgBvJg4ULFz4Mu3HFF4sTC3hUGM79LTdqWSXcWJGRC7AE6aFp6	5748	8113	8113	1617399540000
11199	3NLojmLKFCH9ZxTSHhfCEwm1wsa41gAPrNFqSx8JmacLQ6PaZSnk	11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	1403	824	157	6301	7586	jxZgi79YQ5wBZHdUm9nfhDeYNLMkWVKWGxeipSiXW9BEjFxpGf6	5751	8117	8117	1617400260000
11104	3NL9mi69W2e7XnReJshrNC1guhLiHR3nCBYHV13LAsteoaXhCfaF	11033	3NKBVSudxo9EbxXnTNbqB5tuqTdkXwJLSTGr6fcKic4iZtJ2QAzx	1581	778	153	6301	7498	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5608	8061	8061	1617390180000
11108	3NLomTsHhe7VoBoxAHucWe57Yrp3szrGbFmVWiK7W235NqyJiEtY	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1402	868	155	6301	7502	jxVVALHGoPSKyUvvmYi9Bnma9vPZrVDeSJWNhXg2S8PMyYm1R4p	5713	8064	8064	1617390720000
11116	3NLp7Cc45aEFnxan5MTCFcgT8KgboDE3SBiYYcvm7NhDFGj3QbFF	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	563	1359	156	6301	7509	jxvHaSA8K264BBftHEcQdT1TvnmYDTjwXeDnzpqR76dnsS2ULU7	5715	8068	8068	1617391440000
11119	3NKZ2VSkNc8fo1gi8pCkff96Wdc5iM4WrX7HKNnnatLgKQFgBJs3	11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	42	1361	156	6301	7512	jxiTXyWcL8AHsLxNZEgxkLqAViCWRZXNhFbeWQKwprWa2yE2LRn	5716	8070	8070	1617391800000
11122	3NLYNQN7Q382utWN5wdho5hvN7wYzfUAzT9aRvTsE2icotVkvkiN	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1407	1395	156	6301	7515	jxrbAjvGv85Xnq8mmGW12dSDAEK1SvTcMFzrW44EQaMMMYPwM3b	5718	8072	8072	1617392160000
11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	11123	3NKhC2hjAMeEKta2c51gyodPJnSHYgdg6pdeojR1HBdaj6jRSDG4	1672	1159	156	6301	7517	jwdHboKRbCtQre8F5zp4nenvABZrxmA8T43UW5PoJdx1nhvZAxB	5719	8073	8073	1617392340000
11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	1402	876	156	6301	7519	jxFNG4i2g3TtfFHpY9fbL99NjYjZcNC52NYLX9z9y54rqt4ABoy	5720	8074	8074	1617392520000
11131	3NLRe47XQT48WF4bUH2JEwgNLoCDuwCR6NkKU2FBzc5xfAPSHU5M	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1590	1300	154	6301	7524	jxZBqvmz9rELx65FRFza5VEHmVntva9q2bjKTKRZBVJSMHaM5wM	5673	8076	8076	1617392880000
11133	3NLuvVXZSMDFcZZDkVF8pPxYnVMyTGSWLGNmxoRNhngnhTtpphTK	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jxJZuepP2qXcUEqeoQhVJj4MUeqjxnm7VGsfJ3DHEeRkjKi2Jvh	5723	8078	8078	1617393240000
11136	3NKts7FHp8ZdYbo65YZdsvj59UetDpbC7n5wb2bkgBQCQCcVeF8C	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jwx5hBrTBaCtya8SQjGohodDgNm5KgXuUe9Gbt3eCPDrdatXnNz	5723	8078	8078	1617393240000
11141	3NK6qg3yTQHCGDZBqnauy7v9BxYL9nhchEVbiRuTfCrwXGka2gEd	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1623	839	156	6301	7532	jx3bqHgpSHf7vU7mwfktJ8tmgYjCY9bgXCv3iKqybdC2DTAnZpJ	5726	8083	8083	1617394140000
11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	11141	3NK6qg3yTQHCGDZBqnauy7v9BxYL9nhchEVbiRuTfCrwXGka2gEd	1403	824	156	6301	7534	jwHD79qt5z7Vx8FxqurW5RYXdhW3NHPuDjxAVusBgsMWdt291fr	5727	8085	8085	1617394500000
11146	3NLiVRC7uFi5ccZoypfzKbTsU3gvhBep9xExsfXEoBM2fSKs788h	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1407	1395	156	6301	7537	jwLixvfJuTP7jTJMhV4tW4Ld9pJP5NknsdyPZfu3PhLeqVZZqLn	5728	8087	8087	1617394860000
11150	3NKadcZAj199meqaUT2Azx2HtigLYo1gLNtmdCzDrypvdwRyVC47	11149	3NLkfSj4EG4EXwNLLJnmR6bvcwLNEcFpZjbfZAjCKQVcyzKNUFLA	1546	1213	156	6301	7541	jwuNzs8361ozjXktMkRJtGF6D2AcrcE8ccvZqmEzYQNPRxPKj6F	5730	8089	8089	1617395220000
11155	3NLhmEpVBVWEmATPDhRwykTaM9Z2RfEHqEXijFs6VHadd46m4VTx	11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	1419	813	156	6301	7546	jxeLoui9kQxakn6huf9nonHuZMRaEhqRn5CGMbhW8pgRKv9kF4y	5734	8093	8093	1617395940000
11162	3NLrt31omU2ra5y656HEPsy8YSf33CKEqNVt9UHRro6eQsKaa4WD	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1403	782	150	6301	7553	jwzj6kwNsUPykbYXLipcnsV25bzNsK8Cmxzbhb9i5JK5JU3ekQt	5589	8096	8096	1617396613207
11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	1610	1068	156	6301	7556	jwPDm4bmcSEjsZjyYXNWhUq299RsarUfvunMW67eBg4VagbkAKV	5739	8101	8101	1617397380000
11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1403	824	156	6301	7558	jxjHffXZvpYikovKPjFAirkdbq7oGr23tJR5G5GSDB9PQzSDSBv	5740	8102	8102	1617397560000
11169	3NKMLke3rb9HtUE7Mcwswm4g3SpLL4fjtsqQTPJjZjiUZW9Ar9CB	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1553	776	156	6301	7560	jwLdtX8knL1RKd4F8p33saRTM25zEK114NY1fGpuH2s5gjY5uTt	5740	8102	8102	1617397560000
11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1479	672	157	6301	7562	jxCrtGKoYVqK5ezigWn81J1zk2wAVm1ahpWEF98XhLsammkThMA	5741	8103	8103	1617397744756
11175	3NLeGmU72QdWxgAYfY7K92EY8WSjVehKUZMDLVNzi59DGGY1DX3W	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	156	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000
11177	3NLqiUa3givU1mZ4i43oiYydwPaphGXqw98G7LMLoTfhrHEmYpGi	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1516	1294	152	6301	7565	jx9iiPgRULiLgbck8oGRtKie26xezzsEfVhA6zLveN6xYj2inRM	5617	8104	8104	1617397920000
11179	3NKM5Skx2VEmBfgTcMDJsmcHGBKSVzwG7kojKMcpNJ3V7vv6Frgk	11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	1652	1315	157	6301	7567	jxuEhW4x1qRU8QUMvbuFq4BSQ6Wpns72jJBYCAoWsBtJFMBhxGQ	5742	8105	8105	1617398100000
11182	3NLYniEih4DZ4cqjDh3qX5VfHoP843YEnoyG19KfQneox6d6S3Jq	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	1560	1045	157	6301	7570	jxgFNUJFN1XAM1JV7W9skVRMJCGMNnJKU4EjMKmaF1r9rdZabeG	5743	8107	8107	1617398460000
11186	3NKwxxJnaEyp8XHQEfonBCU9RFboaPJQxWbGEmYZKJA5fw5uUKbY	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	311	1307	157	6301	7574	jx3Zr5yiKaCn7KbXgzVSwQPCAmiPvTRgh6idDUUw8fDcVzGfzTZ	5744	8108	8108	1617398640000
11197	3NKgyRgjTTphGECkgrdFwYN5u868FL6FYRqo6WZ4KS3uknn21BCw	11196	3NKAMSNhrVStp6PW5CXed8nKxiUihV1Fkn4RRYMk2bjHHHrnheKe	1406	1393	157	6301	7584	jxRnSH9DBRo4Xq1R5cHnKYwVbvK4CRq1qmd4J4gJU4hqMTTjZXp	5749	8114	8114	1617399720000
11203	3NKidZPiQNvx3bjFeRcHeJ4Hg4yTfigbF6fyX47dyUQXvzg7Hsef	11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	412	412	157	6301	7590	jxWep5N9dN1oscj2FPtxXeVTLhTyCX5UsqCTaGAzHwm9Bx9fbb5	5753	8119	8119	1617400620000
11206	3NLepC4DM1qCQVqLCc8734KG4tjuF1RjqKGFgxsNhbZXnXQQkYe3	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jwVtxge67nfxSMWwg4wmGfycnjSv2NfCJP1MjpaUYauAJ71H9rn	5754	8121	8121	1617400980000
11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	11209	3NKFZRRJnsWcGESJin1Rt7A4Hw9hGARrWTXSkiJ374MkEMaY7feh	1637	815	157	6301	7595	jwBrvkrcHXvKiQsAY9aZU6gCScXjjH5CcdBea2LUrZqkcGNiSrv	5757	8125	8125	1617401700000
11212	3NLqK5XQCyh5mpzVW5QPLcVACUq9RaQRVdS2FRypNJb35TyKhbfK	11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	1609	1207	157	6301	7597	jxv8Hy8cqYurg8PNsdm7dHiHNWQE7RjLREybjTs5zqgFWzXoXWB	5758	8126	8126	1617401880000
11214	3NKd8MUFkcZ2KjSEJLBk4fYH8mWgXw1vUcUgxH9UaHR6d7K9iN2F	11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	1407	1395	157	6301	7599	jxGMyNXkx3YuVA7jY1csLH28oJw1JR6p3ckSJxh7xxApRD7vNVk	5760	8133	8133	1617403140000
11216	3NLs8nUAmi93jzpvqwWnLN2aTdQFrCL7byknDHpkM8ChBP82sgCA	11214	3NKd8MUFkcZ2KjSEJLBk4fYH8mWgXw1vUcUgxH9UaHR6d7K9iN2F	596	1060	157	6301	7601	jwLkfZWoJNeQRvUetWpGMyuWgmh9JnbyqP9m96Uvtm8ypWVWZCj	5761	8134	8134	1617403320000
11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	80	1273	156	6301	7536	jxRozMB6QcWfTdPpnCt9AGwphuV5dFB761yaQYvYHVJULnxZGjg	5728	8087	8087	1617394860000
11151	3NLcD9RHURdtouSBAVQvJGTPbrKDiAm4tAYHQMiE5dz5tUXhxdTm	11150	3NKadcZAj199meqaUT2Azx2HtigLYo1gLNtmdCzDrypvdwRyVC47	1536	1313	156	6301	7542	jxAyGvNus7GCJLomgcUQ2s6rNjTMsn1qaGx8QKXP3jzLN3pSFyD	5731	8090	8090	1617395400000
11154	3NLDzkvwb5aapaGF77unvzgw4Arnv59yL3EpvgdhyCtLvQ362ARq	11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	596	1060	156	6301	7545	jxkzzKXC5fVYr8Fd48yzXxTXjkjgnJhvLA2zdFVNDDQY7h49fvX	5734	8093	8093	1617395940000
11159	3NK9VePzdrMQJJAs438Gt5jTmkzio8DXNsNa17yDH8weYt4eD9p4	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1403	782	149	6301	7550	jxRhWbuT4hBtJoqrVYrbxCbXWEiirV2AwUyvmns3Szxw4a7RaX1	5551	8096	8096	1617396513600
11161	3NLcEcTFc4hxyZ8cyY2pFnPX6qTcbJi9jBovg8wSLQNKRKZgQPYZ	10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	1403	782	150	6301	7552	jxmeYMGmxnPZQpCBbBDzmgNM5TwnuVSTSjrzPHEdmfC5aCJ2rxy	5577	8096	8096	1617396580053
11173	3NKuSX8Wto3CETLzHXat9fHFXWi81m3tMdRNVH5s5uUfBGqgpxRr	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	563	1359	157	6301	7563	jxGauD6Gs8ZVErVqeQnPZs5FinzttP3W7fb5379fTQykKtyAa8s	5741	8103	8103	1617397740000
11178	3NK7REqVSeK4vKaj45PZHkgHa1Z6X2qnQka2t1VGj3dtWA16K7Ey	11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	1406	1393	157	6301	7566	jwuAdHkLaq4cNLMnAgF4MJr4a2M47poPghEaXxswzYg9XFue1tP	5742	8105	8105	1617398100000
11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	11176	3NLngUC1g2n8TazxJy8FdLfBebj13ZR3Jkm27f2jTENogsEUhan6	1652	1315	157	6301	7568	jx2GL2ZkMpT95JBuXzeguLFzDr7s7mYw8vSDdB2SRZ5i8MwFShT	5742	8105	8105	1617398100000
11184	3NLsBYdNMXF1BWPZCjc55TxzvgFJGD59SR9DQ7A8X3KDCXfa3Vsy	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	171	1128	157	6301	7572	jxncPgY4xUazribW9wgAUcpujDv9FbNHSWCtAcUXc9ybyxJ9ZnT	5743	8107	8107	1617398463325
11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1534	1191	157	6301	7575	jwCMFzWjTaJE9SY2EgUWTofwh3a2avxvcXMZFkKnxa7eDeSS5oK	5744	8108	8108	1617398642344
11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	1637	816	157	6301	7578	jxR13rtLRkDd6vmYDztyCtBjt2oX8XmLmQ5a5MuirYBqCDKZCig	5746	8111	8111	1617399180000
11193	3NKAg6CBuGTEuH45GXdLHUyceXQJMparXzryUGFsrH7jAixaiyXM	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	311	1307	157	6301	7580	jxCTh29gx3ht6raFaRGiusThAyHnLcn5brFZzTRZyGvPK1UZDDk	5747	8112	8112	1617399360000
11195	3NLxZ1JPLhFPhWCAf24LCBz1XDq73BSi3oFmGhyHnU6M3pBiSD2T	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	1573	952	157	6301	7582	jwEmviyyJhoMFJfmpoGksFLbqT15mFLRqRji7MkgTG1G8KvEQ4b	5747	8112	8112	1617399360000
11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	11197	3NKgyRgjTTphGECkgrdFwYN5u868FL6FYRqo6WZ4KS3uknn21BCw	596	1306	157	6301	7585	jwD4LgFN7qGSGHNMaLDRmFRvjW7pBK7iHju1tvJWsaXZ1kCPWjm	5750	8116	8116	1617400080000
11207	3NLnFnxzJ76ryn1X43z11dH7VJtNF4LL45UMbHcs8zQBpcuZ1V6p	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1617	1288	157	6301	7592	jwydR7m9xY1frUAfm3K17AWYmhk7wWTEa1pQQsdE2VycSSkp6nt	5754	8121	8121	1617400980000
11208	3NLuRdUUbf2YYuSt47MqjiQN3bDerctfZLh7JGHwCEK5x3XXM5b1	11204	3NKZKSSHcv179gsHfpLCFDNWmBbrrxBXHfMmu2ZmJSsfq5vCYAYq	632	1256	157	6301	7593	jxAuVhjBTyT8bAUkYaR26QqAktRm3bUwwTe9sHEwVZVeTDUyahY	5755	8123	8123	1617401340000
11217	3NLj889pt4DCGu712L1iz4vm6zNYyYkSmbwK8nS4y6Vj23BPubC8	11216	3NLs8nUAmi93jzpvqwWnLN2aTdQFrCL7byknDHpkM8ChBP82sgCA	1578	1296	157	6301	7602	jx28ihe3wc9CAchjTKSgQm3d2ZMi1T33k5zwop6juSyWr3GdX8y	5762	8136	8136	1617403680000
11220	3NLsn11uXwJEESWVUZf788E6mnQwyMidLoj44FBbG7dcSxamgEoV	11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	497	590	157	6301	7605	jxY3VDhXxapGTzeLk5GZMDC2MGUVfkHbsbzHedjSUF9KV7sfJjj	5764	8138	8138	1617404040000
11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	11221	3NKvFDd9kZZYEcWwTeEPGZDEqTYdJNT4SdLK1o5zuGV6cYuz4xHT	1507	1034	158	6301	7607	jxTikUT6UKs8kjC8xFJbrEDELAnUb6KyJ29PiPiCSY2SiLTvZko	5766	8140	8140	1617404400000
11225	3NKt4ELZFS9UnmsWcJ4WFZ6GA7Sia2uCs5mMhfXJdB9L8ruyrCAo	11224	3NK67q9ot8SVnJgJAfgg7PYdyLqwXc2NLCGfoVNfA58d9snHXCoy	1407	1395	158	6301	7610	jwUfvfcqB27CNSznTGTvEdLuCiwuc7466DARcbuZ5moxymoRDvd	5768	8143	8143	1617404940000
11228	3NKZtDE2MW8oHueRfcRUr17i7pjjzoFwadWP141FE4nLR9j55Cph	11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	1407	1395	158	6301	7613	jxh9UVRtLzh7PMHvAjmd9XykVsLo89RxaQ5Cfotwyc3V9Y5NDvZ	5770	8146	8146	1617405480000
11233	3NLuCRcriyRjH73eETKoGSTnStqTsaByEodmE6LaU8w9KcQVEisq	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1406	1393	158	6301	7617	jwPL1iAmsSfj7CsNykPexRi2SQ9GCdn3wJAq6p13yhBn2hXis8N	5772	8152	8152	1617406560000
11238	3NLjkEEAhk7ePM7fyRZxfzKqq6qrvwc1UyFbeSFE9x5yRYtu94X8	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1651	1055	158	6301	7622	jwYpzs7uX9NHAeQ2b94Ndzz18N4ToUcaV7JJdhKKAGtMDkZeWqE	5773	8153	8153	1617406740000
11240	3NLGF2PpAKvXKAD72FXVeG3AVctLBZpgfudnS9MUEqAD9Nmwn2gg	11239	3NLJujbqGFJeb8wzqNkFTcb84sTkTtw9q5R3BsPbRbrCqTgoVPkr	1637	815	158	6301	7623	jxW6wEYfRrJ6A63Z6wH5LoMVqARxdef1fTLkiPLryJL6SGMJcKK	5774	8155	8155	1617407100000
11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	11241	3NKM49BehTvTij7BWArGUxvZpr7N4vHrRXV7EUKxMMQciv67ft5w	632	1382	158	6301	7626	jwvzxwFz2pjWx12vxQNyqDSsKkuWu5AC7oa26wrgpS5P32nSwQ1	5776	8159	8159	1617407820000
11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	1447	1345	158	6301	7631	jwSLavM82Hx9GrzdUfYQgzENXhKUxTY9NxUZFTww6MfzJQK3g7v	5779	8164	8164	1617408720000
11251	3NL6mG8uT7uavtZ6gPYDXjXgwginZtwRzcKiRuZkAFaEYmNPJUZt	11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	1587	1111	158	6301	7633	jx4PcLQC4r1CPaVNWGzdUVe2eWCjeHuMJdtqwfQhpFqiY3AYVSD	5780	8166	8166	1617409080000
11253	3NKodVuTpG2CTq3D9pdEH4ddDDmLvsGaApM9aPyCmQi8G8qtpBnv	11252	3NLjnhrFMMfXco6EPLBVgo1ApBxWCVAFMgK5ap8ruCt5Zwa41S3z	1403	824	158	6301	7635	jwMPhi6eH8gQwapqfzC9mMVTDpNra8UoTLT14QRiPqTruDF2w1t	5782	8168	8168	1617409440000
11256	3NLJ1cHc3ActrFzNxc4kmWjuC8psxkwraFjyzFWmPyK13xykYYEw	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1407	1395	158	6301	7638	jwLGaEcSQsebM7L5e5U3oGHrix6M8peDZGDCidsBeYqWG336M9D	5784	8170	8170	1617409800000
11260	3NKAXhABorpdqdzqM928BuSyqtdUJ3rqGUPzJyyzRLU1FGMCYVEF	11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	1564	1338	159	6301	7641	jw6ruppnVHqg9LwmtmhMP3mUbmqAz3SDR4CoeynWwYEmXW7ySjo	5785	8172	8172	1617410160000
11269	3NLjEVCxVTWM5WyFLrcepuXKZmvYhtUkawj7bZNUiKvFeRnL74yc	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1483	373	159	6301	7649	jwXfKcLJRqSsYYXTZTQq6zxM18mQHdC9jHWZ2cb34Xvz1hvGJQ1	5790	8181	8181	1617411780000
11273	3NKG4GuLkUe6wqCijpgHpRpLvwSLrbAtEa5o3rf5wYB2kQ72Bniz	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1513	1379	159	6301	7653	jwXGBzjXzhAmEDvmmxmdnwsKbyKhAvfsFnaqa9bw36za48FCbjW	5791	8182	8182	1617411960000
11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	11199	3NLojmLKFCH9ZxTSHhfCEwm1wsa41gAPrNFqSx8JmacLQ6PaZSnk	532	1057	157	6301	7588	jxKH2fn84o6ca3Ms6LDgjX2ttqfR55aFHndn4kxrQU6K6p2BC7e	5752	8118	8118	1617400440000
11204	3NKZKSSHcv179gsHfpLCFDNWmBbrrxBXHfMmu2ZmJSsfq5vCYAYq	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jxakVZtdoYEFcZBstdvvcEa68wbk9mEFu72TvR4gBktrYcP5rqF	5754	8121	8121	1617400980000
11211	3NKos4yxiVWdVCnSQJTQ3F9EdGcp4xNws2cgNptG6t7APbmQiLzC	11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	1406	1393	157	6301	7596	jxTzEVuL6RAx67yqnvLBT4fJ3K2qbKZiNqbVUwDCuubFzg1XRBv	5758	8126	8126	1617401880000
11215	3NLmDgV9dUci8F12aPywrkWENYDKrkYB64UvNqrjEvNhhQDtEm6D	11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	1594	1200	157	6301	7600	jwc37xuMopeLPNVyronAegSokE2Fb9biiJJr6Y9qD8GhjWtWwzg	5760	8133	8133	1617403140000
11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	11217	3NLj889pt4DCGu712L1iz4vm6zNYyYkSmbwK8nS4y6Vj23BPubC8	1553	776	157	6301	7603	jw7Yu5PTpXJHhrbxj7REZUMmBNTVQRRRzXENmK55PNy8LY6opbx	5763	8137	8137	1617403860000
11223	3NKwG2tCiJFJTbkoNbBCNBQUMZ8NHJ2tMPJ6vkHf6XxtySfXZgpZ	11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	1588	1392	158	6301	7608	jxB4a8QSAwrby4ECmmNhPT3NnWeiHZer4owtUjm8vNqRx7TvAx7	5767	8142	8142	1617404760000
11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1403	824	158	6301	7614	jxVy5cnskM3vpZP4eS6Dwg4AhxdMVEVxGeQKUMKzFyRk8SR2khG	5771	8149	8149	1617406020000
11231	3NKpcPYBApHhBYRNYhCWBj5Pswzuw3TQYH5wkwGqxPbxGs68p2po	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1429	510	158	6301	7615	jxx4kny4RS5RiwTxbpXv4hSA29Mvr84FCv9GiwkViBcvTo5TEnR	5771	8149	8149	1617406020000
11234	3NLCfTbWhp6hy1Lb9gu6NKy6cxWdWwxvL3zmXdonFStfJobxJpwp	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1513	1379	158	6301	7618	jxsd6sRPPeTpLpJnNARo8aphzHSqnzNchvQGpkfzYbS5UA6tdWS	5772	8152	8152	1617406560000
11236	3NL1cTn166124K6utsLLzSrGMJdjEDUSevNhFPPVfErqEMupnsmy	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1536	1313	158	6301	7620	jxTtCf26kmX4vjnRYXPM36ZzzisUQ3RV9pdGuVBgyho5BhHkat6	5773	8153	8153	1617406740000
11241	3NKM49BehTvTij7BWArGUxvZpr7N4vHrRXV7EUKxMMQciv67ft5w	11240	3NLGF2PpAKvXKAD72FXVeG3AVctLBZpgfudnS9MUEqAD9Nmwn2gg	1407	1395	158	6301	7624	jxTm6Jos86nPiE3ABCtK7s7D5RASwFZcxdAjRwC154bvJtfhMuR	5775	8158	8158	1617407640000
11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	1490	1028	158	6301	7627	jxK4pdWzm862GQwXwChEZK5kqhw8Rvr2nuq9gqwB8eL2jeDeKHb	5777	8161	8161	1617408180000
11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	11253	3NKodVuTpG2CTq3D9pdEH4ddDDmLvsGaApM9aPyCmQi8G8qtpBnv	1407	1395	158	6301	7636	jxa9dvrS5YG4x354t95JAExSisxoHeoMc9zLjuskV4w2UxRnUrh	5783	8169	8169	1617409620000
11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	1406	1393	159	6301	7642	jwL5W7D7sXguR8VzNe77W58LTLAePa6u35ChWwGeJrU7kwH1xtC	5786	8173	8173	1617410340000
11263	3NKVLoYwLKpdFj4d61ggkHiUnBDs3BT2tmGytkKYAiSPvo6MUPNZ	11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	470	1183	159	6301	7644	jxy2qV92EGWX1tekjNE3341qVC5Y9NUXKrNtQfSG4PtmWPjUVBb	5787	8174	8174	1617410520000
11264	3NLAvbc9Z76WZLu1FpnqKarDTCXjVEnVLEGfxJMVQk3NemrmAZf9	11242	3NLDpSMN55WikZc6zcCjJhrLs93vAho9CfkMscMrW2YEbbbDt9Kh	1581	778	153	6301	7645	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5611	8177	8177	1617411060000
11274	3NL1LTeWgXsAgf9aDVJgwsFUvFbN6vmULxiTmaabGgGy8AG5ZDFN	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1589	1286	159	6301	7654	jxRjESeQ9Q2qnmD6RDCphJCBw3d5PedRJWR6pgmKuQjRZWTB8A1	5791	8182	8182	1617411960000
11281	3NKgii9hQmrnyz72fwaBet3VKeFnuuxjq5bv9WM4LgfPSPfVhZwy	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1560	279	159	6301	7660	jwGZuiwsEoXs5um9qAKteSUj1Q84Ea1sY9bm6FkFfHARSRyeTsC	5795	8187	8187	1617412860000
11285	3NLGNFPnZkHUW53KCa8eX2kHqbomHZB9dY2rQfBg9msBRJ1c17L8	11280	3NLqrcSgj7L76vMoaHYxx5J6yAz1EQ1BCQKMvegonMD8Rq4FhAc5	80	1027	160	6301	7663	jxmor3Z2iYA9MCguMgQd7TJXnkm7JQEFEaNq2oPgmV8xq3tzgMW	5796	8188	8188	1617413040000
11287	3NKaTr8XLgAhgoGDhjAPrE4GRX66paXnLzGvumg72SopfDvdK5gF	11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	596	1060	160	6301	7665	jwhTHXqaxcvM2aTm5RAjJr8yF6gNTZbPMyUzuwfpumEBp46Na35	5798	8190	8190	1617413400000
11292	3NK7Wo9j9x14RZb3AVbdeRRRSVBtmrZMuyUFCy8TtPnk8B4bgaEd	11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	1555	981	160	6301	7670	jxFvBEm6iLU1H9uUpRj8nLn5adJesf1eT9VMsxA3EhG3xV6eYuV	5800	8192	8192	1617413760000
11295	3NKp5n1fiTY95oghXT6eXgE52KdUq4ZebAxwyPnzG2cZncyY2azB	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1403	824	160	6301	7673	jwn2LiNJWZCi7akbVyih3kD7XV1skSQPniucf1EYD7HvMCD9WJr	5803	8197	8197	1617414660000
11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1474	1329	160	6301	7676	jxg2qRtPsLp6JzC6PRXggDU8hf73EyudZTB9FzVTrqjUNQJYRDm	5803	8197	8197	1617414660000
11300	3NLMQcsUgEDv5JuXJCexePvcP3zXR2DCeLTUYrtDRTAv7vnX8bZ7	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1467	1010	160	6301	7678	jxDtqSaiVRhXQZHRNUFo9y88TZMHmqNy5aUrZK5vrs2Ykk5BgTn	5804	8198	8198	1617414840000
11307	3NKjJ71Amnj7q3iStkYmHRs7Sccg8NwJF2F5nCwfdQhuZydLpodF	11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	1593	1220	160	6301	7685	jxgUq5bFwYdjFQ2NEHmantSoLEf5rJ8oGpKrARvXmrRhethQZLe	5807	8201	8201	1617415380000
11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	1560	1291	160	6301	7687	jxLNVQow4E1CmVk33PgyqjocRPfScsZJoKAxyb8sb1QHgJRH3EF	5809	8203	8203	1617415740000
11311	3NLp7Zvr1HxmAaVVmTQCMxQhBF9douQpu8uTsKmySL6HuuqU8LNU	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	633	1138	160	6301	7689	jwzw38qAHhJ91BzqTLAqRsAfSFAZSGs84bCnVbkbvvWvWmdxwb8	5810	8204	8204	1617415920000
11324	3NLfL8UfTsRHDCABWMR28VnDy5JRRfoCpMuCPKaEM7JDhdrm4nE6	11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	1587	1357	160	6301	7701	jwdAgv7iNezJDXL3QULabse7yvYU4qWiptm3sgVLpFMyVdj9fCi	5815	8209	8209	1617416820000
11326	3NL8jMmandphCce2oT76YHMdpBKW7zi6PuKZSNyeFKJfKuBwa3eG	11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	1670	1282	160	6301	7703	jxZPNjBnfCbL7ZTVDahiQXmapWsbHXjJJfoakXAQdeYypTNPp41	5816	8210	8210	1617417000000
11334	3NKsmshyxYaXxn2kYvUEwL1q6RqUecRDEqTNZgjwG8XteayGdANM	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1397	838	160	6301	7711	jxeSe8vp46urhFM7np9NCTCP35okg4mUn9kFKr16awFWsVe19C7	5822	8218	8218	1617418440000
11344	3NK7r8HckHaj2b4rsH4wEeYcueXocJjad5peVVa3xCwdbi8s8YkS	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1651	462	161	6301	7721	jxQz1HgnvDbYnshk2Y5gK3nj17sYixkGyUtwMNu16MgLT5zL5Gf	5826	8226	8226	1617419880000
11347	3NLnDs2PPh1BmmgmPzp67PhDcTqETD9gr9fHLUCr5Jk4abDviPYC	11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	1447	1099	161	6301	7723	jxgvpUuJEwD92VomNXZfs4zCQdPziBHxZaPtCpxhMVXQJJZnKWD	5828	8229	8229	1617420420000
11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	1534	129	157	6301	7589	jxm5iw4SmTvhbkbTyZKbFnHqtFSyT6cZLskQx58ZtYJf1pzvnjN	5753	8119	8119	1617400620000
11205	3NLhAMJq9cy951WgKhWLbApkjUqMAHLnQSAYqFiUD2AgJNb9Z8t5	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jxy5M41mnD7LZkA5nyEkiqFQXkdZBeJADsCpWQHGRTKcDr6owU8	5754	8121	8121	1617400980000
11209	3NKFZRRJnsWcGESJin1Rt7A4Hw9hGARrWTXSkiJ374MkEMaY7feh	11208	3NLuRdUUbf2YYuSt47MqjiQN3bDerctfZLh7JGHwCEK5x3XXM5b1	1403	31	157	6301	7594	jwEHw42nsEsZ1pTYEwwXPzbkZPnMzpHRoyzpHScSDH7DThfubak	5756	8124	8124	1617401520000
11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	11212	3NLqK5XQCyh5mpzVW5QPLcVACUq9RaQRVdS2FRypNJb35TyKhbfK	684	1352	157	6301	7598	jwo4qdNLqy938v9Wv53HhSEs3UMWKfgNtpMiKZ6XnxFrcmXsLVW	5759	8131	8131	1617402780000
11221	3NKvFDd9kZZYEcWwTeEPGZDEqTYdJNT4SdLK1o5zuGV6cYuz4xHT	11219	3NL6HPR4qQCbxZoKxMAcQe36pYckb4DJm1tY7a5g9Y6pcQS2aT3X	1407	1395	157	6301	7606	jxh55YcoggYzDpMwJd2EsRKYbFYHADqAZt6seu8vqFeZQT5Fb2f	5765	8139	8139	1617404220000
11224	3NK67q9ot8SVnJgJAfgg7PYdyLqwXc2NLCGfoVNfA58d9snHXCoy	11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	484	1073	158	6301	7609	jxf5DzroEN2w6KPpFdrf3251ZHMgs8fxA5YtwUsBmW7KUP689NU	5767	8142	8142	1617404760000
11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	11225	3NKt4ELZFS9UnmsWcJ4WFZ6GA7Sia2uCs5mMhfXJdB9L8ruyrCAo	1406	1393	158	6301	7611	jws6WNbG5KA5b1NuAKFmHuBJdpPpTjEEyaNwTu6mgafXG488UkX	5769	8144	8144	1617405120000
11230	3NK8MotkiRoFZx7ee4vmwwnCPLRYNVsJ1eBox2ET9B19zQa6M1SC	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1429	510	158	6301	7615	jxYk3aPQuakjvnZpCgan3nQUcmj5Nit14KKVjfgfWFXTnjCBi1y	5771	8149	8149	1617406020000
11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1460	1324	158	6301	7619	jxQrjADyPBkJ7JJswMLhV4NXScWN7veBDYcYHHDQuk8Qwriyv8w	5772	8152	8152	1617406560000
11237	3NK71yNV4ZqhTpgtE3tEDJxTh6H8eMgYmF2K5wRdjNviSSZ8bNX1	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	448	1179	158	6301	7621	jw7wnV6yCaQ2NZcdyEoNyjkGPxVamXxzD5NfGwvz3ksHhYCGSbw	5773	8153	8153	1617406740000
11239	3NLJujbqGFJeb8wzqNkFTcb84sTkTtw9q5R3BsPbRbrCqTgoVPkr	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1651	1055	158	6301	7622	jxnhFxQzR2Eeazg2Xcz5AnmvzzUXCwj6gNgAuSpXJzGSzNxRcmE	5773	8153	8153	1617406740000
11245	3NLbLD1uFuXuJP7p2B8BYiCT76MDnCXPUXVNpLpUvzFVMPu5PpSt	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1460	1078	158	6301	7628	jwHFGaFBmWt1LfALbdpXEHtiH3UmRjWcXMEBveoTab5bnsvQuwv	5778	8163	8163	1617408540000
11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1627	1385	158	6301	7630	jx2GjTH2HMWap6GAx3PJCnbN7k1rPkkvNgRAYtqsW2bG2uWMPVZ	5778	8163	8163	1617408540000
11249	3NKntAdYUaemKuFE4UXeJmRfKX8o4PyynA9ZdneuA5iajiFzjChx	11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	1553	776	158	6301	7632	jwTTZPYsz6WC7yfwvD9pkmkL6CArb9e94vTrT1X7SJMdLGqru9v	5779	8164	8164	1617408720000
11252	3NLjnhrFMMfXco6EPLBVgo1ApBxWCVAFMgK5ap8ruCt5Zwa41S3z	11251	3NL6mG8uT7uavtZ6gPYDXjXgwginZtwRzcKiRuZkAFaEYmNPJUZt	1402	868	158	6301	7634	jxWjmUMXA3QMbhS4yZzyxqzbmz8JRXPBtGHGqPoFjdLttJayyhX	5781	8167	8167	1617409260000
11257	3NKUbw3gUiLmvxipCfdSfFvBuBcKNESA8zgj5njp4WDrFYCVVdMU	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1651	1301	158	6301	7639	jwMMaQDveNvCMsG2CcYCmpFyvMPkYwqG9kPR78YXe1oWdGBzJRq	5784	8170	8170	1617409800000
11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	1406	1393	159	6301	7640	jxdhQtVHYQiSParh9qGTKWD8UQza7VygUzc9MiJGFPhHkyeBq7N	5785	8172	8172	1617410160000
11265	3NLsZ2D2EnGRzS4PpFWzRoTj8NXae37je7efPu88zCEw18X4U9Z1	11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	470	1183	159	6301	7644	jxHJ3woBfiGBQtJXuAZ928FoB2a1xHFJQUCdLk7QdErYCngFBN8	5787	8174	8174	1617410520000
11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	11266	3NLH28QpCjsZsrawanme79Kvyrr1YC3hp2bxvLYVqTexXKBAqtPJ	1596	1237	159	6301	7647	jwNp4Vg9oxo9X9SVKnbogcMKPr9wNRzyZunDKL3faBLs5UmLEW9	5789	8180	8180	1617411600000
11268	3NKXxu5Dn42wuR4rUj64Z8hCaPifmqYMu2prgk9W5JAr2rTiuYMw	11264	3NLAvbc9Z76WZLu1FpnqKarDTCXjVEnVLEGfxJMVQk3NemrmAZf9	1581	778	153	6301	7648	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5612	8180	8180	1617411600000
11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1402	852	159	6301	7650	jxzSJdHxQ4LjBatv99xG25roN5ZjGDqk5Dw8qGaJGeY629CPPdR	5790	8181	8181	1617411780000
11272	3NL8TxfBvrEz6QGXUt5y7RGie94MVZXvYbzYwnYr6WmkfZUhmic7	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1649	1137	159	6301	7652	jx81ocRtdaTq54M6HZoELStnjh8Dj7gk9LV7MULTpvCRwgBB5ji	5791	8182	8182	1617411960000
11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	152	1084	159	6301	7657	jxAejPSmJbK3yQ4Tqm7yn39SKcDCrvWkkxXP5rGo64SATtTYd1z	5794	8186	8186	1617412680000
11279	3NLhCQotr9CjuzhEnvgB7Jg8gWH65sPc3XVw9fBc4uGJ2u7DG6pe	11074	3NKoSPu9Dqi2scRekdLA5WxHW2zMNsdjRhCQ8r4YSs1FGpCPDQb2	152	1084	154	6301	7659	jwnhYDGrzJLhY7vyhZRVf3UKgKDd9AAEUgJtivNNerMgA1QKpf5	5652	8186	8186	1617412680000
11283	3NLgGidzLgyBCYXsjmUzCcj3HoxBczcPA96zaHvvzVnEGGzzFVXp	11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	80	1027	160	6301	7662	jxdCLzbK3vPVA6fYfMnVZaTdXt9AqhKcGgXq5h7oYQRJrS3F1j2	5796	8188	8188	1617413040000
11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	1631	794	160	6301	7666	jx8yBuQJXDLcBkVEWsUCDvzLiPB6UcSeoUziCCDLt4wguBcK1wx	5798	8190	8190	1617413400000
11290	3NKiCvY1JrGHFJCJWHqJsujHqsoqEtM7TBybnD3JL7G9GbNSdVcH	11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	1419	814	160	6301	7668	jxMDAMigHYUEhecNikATKhmhTa3YZGwMRi9kjGbHUutkHeXoPuR	5799	8191	8191	1617413580000
11296	3NLqiRz8aTfiJsgYqAa3vGkGhNLvHTyDPUVPD1UkrHS1hiqdRZZs	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	152	1084	160	6301	7674	jwRnqsbvrY91P3KRbpaDhdpgxPCaVhTmZzuZhAui3zSoVgT1e3X	5803	8197	8197	1617414660000
11299	3NL36mMNFstQUmyX1RzLk6CDjKL7ic8eXyMugvMBc5pQzEXVjkPg	11279	3NLhCQotr9CjuzhEnvgB7Jg8gWH65sPc3XVw9fBc4uGJ2u7DG6pe	152	1084	154	6301	7677	jwnhYDGrzJLhY7vyhZRVf3UKgKDd9AAEUgJtivNNerMgA1QKpf5	5653	8197	8197	1617414660000
11301	3NKwNCEm1epSrxW6iUBjKopVyMRxaG9rY6rfY2YkoYJNCD5E3ZBr	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1617	1288	160	6301	7679	jweDGNWnLUNvkXj5FyuUxFUnpsY9zpq8Crv5naX6ZoR9Let9Mb1	5804	8198	8198	1617414840000
11310	3NLr8VmDP2VWRiLMr8Z1CUw2rSrCt8wLdU9cxFhQKGAsLbvSpsu3	11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	1474	1329	160	6301	7688	jxCUf3fTJLSwn1N6cVY4ipJSD8qvCj392SJGB13YBgUz6nVUmnQ	5809	8203	8203	1617415740000
11312	3NK7ZiiQx4egAjKkXfLyKWUCHcYtVAr5HXVwaPWGLkxWYb8WWNeR	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	1458	1197	160	6301	7690	jwAwcmxkgqcWRQifCBFq5BD5iuhSFB1CLj2vkUCQHSaNFWsT92w	5810	8204	8204	1617415920000
11219	3NL6HPR4qQCbxZoKxMAcQe36pYckb4DJm1tY7a5g9Y6pcQS2aT3X	11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	1647	1056	157	6301	7604	jxRjpaYRiucLSTeeV13c186p3YtppCEhwadLiJYDk81jXSXfM1i	5764	8138	8138	1617404040000
11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	1564	1338	158	6301	7612	jxXJGJhqHsB16QUAMGKktrv1mGiRySu9HFupBGJKa9PbbpUZYjW	5770	8146	8146	1617405480000
11232	3NLSgpbYY32Yn68sS3kXF8NARXhGBV9rZ8pmDwDbZRtbA2ZebJVd	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1419	814	158	6301	7616	jw9gK5czEsg5CxyqpF4TCG6b6GU1HKLgFQhVqSekRCQLmbcFvLG	5771	8149	8149	1617406020000
11242	3NLDpSMN55WikZc6zcCjJhrLs93vAho9CfkMscMrW2YEbbbDt9Kh	11117	3NKbbKoRTpmxN6ujXiwZ6ju6NXB3iYeeofqCQ9i3npfxdqa1rnQS	1581	778	153	6301	7625	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5610	8158	8158	1617407640000
11246	3NKakZ7iKXwTd9KvQBYn4hSnMNR5SMAWPd4Z993JBnb3LnFD2EpD	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1455	1206	158	6301	7629	jxprZCY7vw2zwL1W1rgPE3hy6PZUJxkbeZcXC4GkmDK433DvjpX	5778	8163	8163	1617408540000
11250	3NKXNJ6k5pirw6av32FavuPyhddpnqg1dct16VXTRzf4QgoXhMnq	11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	1587	1111	158	6301	7633	jx4PcLQC4r1CPaVNWGzdUVe2eWCjeHuMJdtqwfQhpFqiY3AYVSD	5780	8166	8166	1617409083244
11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1406	1393	158	6301	7637	jwucVwAmrz8KaP7BXGGkGXdsvCwyi9vKQfsKbH7aRGzCHPfsqLk	5784	8170	8170	1617409800000
11258	3NKMZdsTbbWKKg77DBYGebKoE2PXBXz8aZn3hJApCDjwSpFbpBMW	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1651	1301	158	6301	7639	jxMm97LuNikiVCmRbcHqyxBxbJ4fQ7sFEffSLZD9QKw3evEfp1H	5784	8170	8170	1617409800000
11262	3NKqNZAEkNg8e5LWtWBfq1eRnWBqDJLxiK4zE7FbE4peVZtghFPx	11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	1650	1375	159	6301	7643	jw8DyFpZbz6qJrDkEdq3eb9sDukFvZbUgNtLUBbpx8hcdDeRPxF	5786	8173	8173	1617410340000
11266	3NLH28QpCjsZsrawanme79Kvyrr1YC3hp2bxvLYVqTexXKBAqtPJ	11265	3NLsZ2D2EnGRzS4PpFWzRoTj8NXae37je7efPu88zCEw18X4U9Z1	1509	1320	159	6301	7646	jwqXJmJz6UvZNYyuZCd5mU2TCn3qptouh8ittVkKVkPcRxgzNmH	5788	8179	8179	1617411420000
11271	3NKAXEoxfSsxMHiE5JduuTVLsmP8e3gSXfqkNkDY7RQ3LFehy6Ho	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1611	1095	159	6301	7651	jwogCHiGgbcgQQ8qnXaC7wk13EasKDPG2hVKTFhNQVwWucubsFF	5790	8181	8181	1617411780000
11275	3NKyPThHKua9GY4RdKsi2s6kXUb42JvnnR9zDpKgqoQMsRiG3BJR	11273	3NKG4GuLkUe6wqCijpgHpRpLvwSLrbAtEa5o3rf5wYB2kQ72Bniz	1483	421	159	6301	7655	jwe2po4NCp5Ng1UeWmPFLEsXTrhxt3g1ZAMuL8qfiz4gJeAH11d	5792	8183	8183	1617412140000
11284	3NLwnjGUu1UFhbVB1nwXch5bos1tHgAx9Sr4pQXDdBQp92knPNfw	11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	80	1027	159	6301	7662	jwzn8C3ZX5j33X4ZiUc2dVkfvxitcirbGYvx6E9f66ZBP6HtjZY	5796	8188	8188	1617413040000
11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	11283	3NLgGidzLgyBCYXsjmUzCcj3HoxBczcPA96zaHvvzVnEGGzzFVXp	1403	824	160	6301	7664	jw8vKdvLut9oLwghH2wbrcSVRFS2icvLgvHwYTS4x59P3duttmT	5797	8189	8189	1617413220000
11293	3NLcBPkV8wsff5B2vr3Ycm6B5aoWf6cGYT3wx2wUsNjh8ip4pZzs	11291	3NKBLSZoeq8RScjGyBko7CHWDLUjz5fGviGZdHKtXuia4HKWSGSC	1483	6	160	6301	7671	jxrVdn68Aa1y26dzpEXQjWkWR25gVLehVMf3BTRXYjhaJbeNgEB	5801	8194	8194	1617414120000
11297	3NKpVUKefLFVgkknMWf7rAcUarUGGF8Xsevfvx61fmGpbqForFhG	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1407	1395	160	6301	7675	jwZZy61PNBYZbGEVYtsLQvS315bwoZ2ZDwC9iFe7U36C4i9exAR	5803	8197	8197	1617414660000
11303	3NKHud9upvJVXqiiy2z2HPk7RZd6ja9wf5jgXSM8C74XJdPkd3on	11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	1471	1020	160	6301	7681	jwiZ9NszJviXioR5EL8m7NHZNwgFcwQzqwRt7FRsjtA46gh1fRx	5805	8199	8199	1617415020000
11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	11304	3NKTDfn5a8zhTohtbmo8FNcj78cnTz3jxdGif9URaJTsfNjNKzM6	1467	1376	160	6301	7683	jxcyC3jVcpNqr3aA6yEHDhH73r9As4fPqKqMx4n7J9mDtUk28FB	5806	8200	8200	1617415200000
11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	1536	947	160	6301	7691	jw9A1CQjYvaas62FQUTWCVYyDi2Q7Mwvfnt2HVr5hgXaFMTcLng	5810	8204	8204	1617415920000
11315	3NKyq5hkroHMMieHBhGDDeSpMCMsByVWHFS7viK5BBBJoJ9EWotT	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1406	1393	160	6301	7693	jwNVnAQhiAqAShqihTgBeUmXMJtKPiSJTyuF1JKC8NC6BFHNn95	5811	8205	8205	1617416100000
11318	3NL8XvCjgT3ZFT2dzouBzSvJaSFTGb4a6hsuXa5EWj35EuaAAqQs	11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	1668	1370	160	6301	7696	jwmDnJbMGuXhfiL2A2eiZbuf8exWb8tpbw5vCi8cmtr25AAkMcV	5812	8206	8206	1617416280000
11321	3NLf6kePGQmcdJRKNAZFZmd8CQgMTTS6MjKEfvki2oP1Z27U5qwe	11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	1647	846	160	6301	7699	jwVCv8Gi2eXD2juujpXXx1Pqi6jmCeJGQygPjfJXDipYtUoegxN	5813	8207	8207	1617416460000
11327	3NKFvFMLb8jLcKre2vJmaCp1JwnntLucjf98tQaC8WvR2tziSLSq	11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	1590	1054	160	6301	7704	jwNHY8gmPnk6Wuk1oYwaCwhonavGy9oJQqLHaEkRHRvJUQmQbim	5816	8210	8210	1617417000000
11330	3NKg5irx9fcWs8EQSfCjseByXh9HG4onp1GZNbU8u4AHtShbVove	11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	1460	1198	160	6301	7707	jwNw6EjvxFw2d5QKXUkRa4n12PMbNVcEExfNfuRLj6KqDHR1D5g	5819	8213	8213	1617417540000
11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	11332	3NLLW8FoMMPLYBQxyiF75yTMNRssqBDrsXQ9a5hF5d4jw22LsZFD	1546	973	160	6301	7710	jx64ox2FYUsUNeVu8q9KaYcaRJ1tYxvPPWCTThmYwzZ559Cnk8Y	5821	8217	8217	1617418260000
11338	3NLbBmtQivK7MaShf3B32JinQo8vMVHEJFJ3VHE28ZGn5qSHy5kz	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	1483	910	160	6301	7715	jwYNpMgwhhyCBu4kj73Uo4HyNNvL3QUo7FmedGAbxXpEraUnjUV	5823	8220	8220	1617418800000
11340	3NKzpMPKHFqNGzouTMQTCj6Dod9XKLK2pdo8QagV4cvVhtaD4MuY	11339	3NKhARy2YW8druNm8VpfeJcMDionEGicSirGsWZdp4yFFC4fXg9J	1587	1357	160	6301	7717	jw97Zcx1rGLoauxtRA99tMwtKYxDUaB2rHgtd2YphPQVEAP1yAo	5824	8221	8221	1617418980000
11343	3NLYkqQ4AuCY8WXD7cwqYADK8N2J8KH7wZ8JqpXkTGgN3n4vS8qV	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1403	792	161	6301	7720	jwcdT1qNZPKiYHc3Xz9t5ESq37EJ8ra27WFqLo4rmVobKABGX9N	5826	8226	8226	1617419880000
11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1407	1395	161	6301	7727	jwiJjdoxBuz46L8BeXrKQ6YJjv6ChgcDyF32uSyPmAujzsndohH	5829	8230	8230	1617420600000
11353	3NL1mZ2BDWmJALZ4eQu1HjgNaJrmGzTdcUexiqgYAG8SSp66SCPa	11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	1507	1154	161	6301	7729	jxoHRkAxmsyMsL4unMY6USnkLyVDGyrcQhuahLWUNhV6QBpfvj5	5830	8231	8231	1617420780000
11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	11275	3NKyPThHKua9GY4RdKsi2s6kXUb42JvnnR9zDpKgqoQMsRiG3BJR	1407	1395	159	6301	7656	jxHfyXBBkP53oG7AZFByaTBvcKz1aNhchGoMVnAY9pUUNj5Yqew	5793	8185	8185	1617412500000
11278	3NLgqqn2r1gaoR4VJP8hYkXwj9aUQQNfqVReF5RWRXsMA1VomkA6	11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	606	929	159	6301	7658	jxkLF5dkVCnHy4umci1Tri6Juo5kQyjkrBKTiyErQV4rr5eyhyR	5794	8186	8186	1617412680000
11280	3NLqrcSgj7L76vMoaHYxx5J6yAz1EQ1BCQKMvegonMD8Rq4FhAc5	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1560	279	159	6301	7660	jxynsu3VVHPP2DowSVVAAbvSacZE52Spg2j59Vw3RxdECyPuJF8	5795	8187	8187	1617412860000
11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1477	1224	159	6301	7661	jxiM98seVoNQZ6qJXpsdxuC6eSwMKy1ob2tRC2rYAeWmbyvU3b8	5795	8187	8187	1617412860000
11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	58	1281	160	6301	7667	jxNj4pkHf7WFi9Va3Um5GR37JJMzTWBC5WScN2TCgwsz8EG3fbk	5799	8191	8191	1617413580000
11291	3NKBLSZoeq8RScjGyBko7CHWDLUjz5fGviGZdHKtXuia4HKWSGSC	11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	1471	1386	160	6301	7669	jwumSUmyVRSuxAjp8LdbV5UnCYWYQNqHAuP1nzSMXtaEfcJhzNt	5800	8192	8192	1617413760000
11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	11293	3NLcBPkV8wsff5B2vr3Ycm6B5aoWf6cGYT3wx2wUsNjh8ip4pZzs	1536	1187	160	6301	7672	jxn3MUJLKfjCh2snoTpQKtZbiY8PzNpbtiZoHXDnY8E4o8oQJzb	5802	8196	8196	1617414480000
11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1585	1240	160	6301	7680	jw8C3hDhRK4htXw1CsowRFPLaEJ2zdFEmncwmfkuHvexXNrqdkE	5804	8198	8198	1617414840000
11304	3NKTDfn5a8zhTohtbmo8FNcj78cnTz3jxdGif9URaJTsfNjNKzM6	11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	1451	1292	160	6301	7682	jxaCZJ5va44RDnxKtLkAMBNb2gGdugzJmLwmqsfAWhappw5kVKM	5805	8199	8199	1617415020000
11306	3NKMuAuLTkPdewUJjhdfGHwufb4Yjicdhr4wgh73dcEW9tnbwM7k	11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	1637	816	160	6301	7684	jxozjLv431VhM4KXC7C7G3ShkLzN9kVDSHXLiZVpPLmFD2Kx4tr	5807	8201	8201	1617415380000
11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	11307	3NKjJ71Amnj7q3iStkYmHRs7Sccg8NwJF2F5nCwfdQhuZydLpodF	1637	816	160	6301	7686	jxp15LXEJxCC9DCwCFkfVeYckB112ANTtPc8NJX46BVw6Rsk3LD	5808	8202	8202	1617415560000
11316	3NKDKKFz7Gqoehq7T9sPegSsVccsNvDVtCeGPmC1jB6pvchmAZYz	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1637	816	160	6301	7694	jxjjS8HBDp6TYqRcUpEgNWUUUNF1gF2Z3YMBWKy2SiYpAzqQJkz	5811	8205	8205	1617416100000
11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	1593	1100	160	6301	7697	jwKJnbLweA2GAWRGHZMcdtcTt5EtS5vdXVA6Wt1dHs4t2DyaRRG	5812	8206	8206	1617416280000
11323	3NKxtYZEYvXPjPB8vSTM6ysPSSFES866q25Mg4LdgN6HM8S6NQdv	11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	1634	1085	160	6301	7700	jy1psSYLyCXmmrFdpFRZSkoBJYLaZbLMDKShMLaex3uxeefJmVh	5814	8208	8208	1617416645623
11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	11327	3NKFvFMLb8jLcKre2vJmaCp1JwnntLucjf98tQaC8WvR2tziSLSq	633	1018	160	6301	7705	jxKwWK1yTQ5gb5vAbkDaTC9BZqPFXLQBqcPqYUPh4U6wAgy8ztN	5817	8211	8211	1617417180000
11331	3NLiWmk9Xkvmd1mzdZYkBYFEyWYZ2y8JAJp17Au7FuhG61HzgW2K	11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	1407	1395	160	6301	7708	jxiwZdXkzVTgrS4GJmw4LTZDhJrLXqpPdVWdstn6BdtPi3NyK5E	5819	8213	8213	1617417540000
11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1611	1095	160	6301	7713	jwh7zL89Ho1HZxE5ZpmFkxLECqjFQeqXNocTyqdTUJVHMc2wxhE	5822	8218	8218	1617418440000
11339	3NKhARy2YW8druNm8VpfeJcMDionEGicSirGsWZdp4yFFC4fXg9J	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	1627	1139	160	6301	7716	jx8pYyvtyGYnmEiq9Zow1Fe233wLwZSACBEGR6FS3tszSmzFFWA	5823	8220	8220	1617418800000
11341	3NKCmcRh79FSYeSUvHaeRCU7cK4MwCHedMsM82bWLtngmhTk5uBw	11317	3NLPL8p9hH5ix3dm1RGUTdA2r9LqzLfXVw7gQmdKYaKTMgDdo4GP	1581	778	153	6301	7718	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5614	8221	8221	1617418980000
11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	11344	3NK7r8HckHaj2b4rsH4wEeYcueXocJjad5peVVa3xCwdbi8s8YkS	1594	1326	161	6301	7722	jwprnzNTAqFYHJ9a3MFuqvz3RSkuEL2MgdSVKDo9bavBtmQB2vX	5827	8227	8227	1617420060000
11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1403	823	160	6301	7692	jwiLQFVzb1SasPkQPeGqvN8KYghnjAEuAjXf3uMfwEu1V4Rsneo	5811	8205	8205	1617416100000
11317	3NLPL8p9hH5ix3dm1RGUTdA2r9LqzLfXVw7gQmdKYaKTMgDdo4GP	11268	3NKXxu5Dn42wuR4rUj64Z8hCaPifmqYMu2prgk9W5JAr2rTiuYMw	1581	777	153	6301	7695	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5613	8205	8205	1617416100000
11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	1439	1033	160	6301	7698	jy34Bfo4gszirbBxKB5U9Jce67zRfKZr9Q8pkYtzAtRXtBhReYs	5813	8207	8207	1617416460000
11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	1634	1085	160	6301	7700	jy1psSYLyCXmmrFdpFRZSkoBJYLaZbLMDKShMLaex3uxeefJmVh	5814	8208	8208	1617416642637
11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	1407	1395	160	6301	7702	jxpLXyZNjykjVpTDJbxPVRhHsJM3RN4LnHkSd6JN6PTiGnafwGs	5815	8209	8209	1617416820000
11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	1406	1393	160	6301	7706	jxeQq7jiRbF6JJd4MeJR3xTwcgNKCP9HD3vYB3hJUQyhj4SPdyy	5818	8212	8212	1617417360000
11332	3NLLW8FoMMPLYBQxyiF75yTMNRssqBDrsXQ9a5hF5d4jw22LsZFD	11331	3NLiWmk9Xkvmd1mzdZYkBYFEyWYZ2y8JAJp17Au7FuhG61HzgW2K	1406	1393	160	6301	7709	jwJpmWyLhRUkPudzxHpf64xMe6vzueTHNQNzZbByU9eSdXbyh7C	5820	8215	8215	1617417900000
11335	3NLtoYzCfBhQjBGPbG1fH5ZBftYty4izdomb9bNq53UHZhxMHHoS	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1631	794	160	6301	7712	jwiytgcjcZrxbi4FS5NawrmTmkYzbcVfKJuZBdrW753yqELLS1m	5822	8218	8218	1617418440000
11337	3NKAJqHgS1EM6DBWUxsRqgDY78FihQAZz2RPnWTME5eBWfGJJafL	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	311	1307	160	6301	7714	jxpWtXZHJ7mpV8f34upUEZPGsqdWSzbwGRD1dq4igK3YWZNw5P8	5823	8220	8220	1617418800000
11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	11340	3NKzpMPKHFqNGzouTMQTCj6Dod9XKLK2pdo8QagV4cvVhtaD4MuY	1648	918	161	6301	7719	jwfojof6PzaizPdEPuoHZeM1jhEktsB8ncCqAaVYVg6DZwLzd6V	5825	8223	8223	1617419340000
11345	3NKGKVSJHhZci3aEKM3XRsWgT94SmE6MdxuoG8AZbFu52GfVmrkA	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1651	462	161	6301	7721	jwNkrryivh77vrWHiobtZDLxKXD12nPj9z69caV35ftkr1wCwGo	5826	8226	8226	1617419880000
11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	1445	1290	161	6301	7724	jxneazwPaamhnavR1XayJdtj6kFwt5rsVWWvMQCAJoEr8S1cwhb	5828	8229	8229	1617420420000
11350	3NLJojtNqvUynPEVdowV7rN2JPkq8iZyLWY5ekUk2gmoqb2yNWcN	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1406	1393	161	6301	7726	jwshKb3sJubfS12pNwA3yokWDs8aX5vJGL871cqwbGnvBJ7rGYu	5829	8230	8230	1617420600000
11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	1578	1170	161	6301	7728	jxH9UN4UMWX5JJNeL1M8YeHn5vLJFCntxaZGYT9p5UptdqBCsWH	5830	8231	8231	1617420780000
11349	3NLjFfqZMdCRqBHufyYRYG18s36Ey5EjLWX2VFEgNatVPLE7dGef	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1445	1044	161	6301	7725	jxP4wiyRuKQ423LoV8gKcgbDnGXbDCKoZAtZexsgNYYgB3VcZE1	5829	8230	8230	1617420600000
11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	1426	1238	161	6301	7730	jwbtw7tEi6s8VZz6BoXhoY6WNun95b7YYkf9djZNujkNahx33Yd	5831	8232	8232	1617420960000
11355	3NKNFkUxo2MLwTuGDGrQCB6bwz76pTxC8sgeby3yFZ22Z5JPq8oU	11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	1483	1276	161	6301	7731	jxwZUKUzdMrJyTMA7Ly8CUD9HiK4wQwBKXqaNRvJTuRQbuxtW3Z	5832	8233	8233	1617421140000
11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	1587	1357	161	6301	7732	jxE8KgLw3dbEW9ZjPxgoxRNoaccJTH3XTHyG5a2unsUcpD196Vq	5832	8233	8233	1617421140000
11357	3NLUV1RG6e4GJofUrn2Y5REkjj3Lp2RjYSw3GYBenbWfCTQQTAYH	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1637	816	161	6301	7733	jxrdp5mqjS4wTxgaGwrfsD5Ha42bHn7tiYGRg4TgNj7zeRa6qTc	5833	8234	8234	1617421320000
11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1609	1333	161	6301	7734	jxLxm7nJ8Njv9sasCh7e1JLN26WXzerkLMEG9Jc5TWVMXJYWYGs	5833	8234	8234	1617421320000
11359	3NKi3x1c7xhYGyn2W7LhBRLax1fDTcDBfXHqc7HvjJTcg4EWUf7A	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1611	1215	161	6301	7735	jxRvPhnVAN7gF6aH37EKRbgmAtgpUgCMzZxu57AhT3n8rHHUSpn	5833	8234	8234	1617421320000
11360	3NLm3YQ7eQ3F4KhyWr9gdB5yyUw1yZ25dzxkxdJsiTSgZPjr6W1E	11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	1534	371	161	6301	7736	jxf7Tf2Gm1uyKqiYUNfygdQA41KX4rX9Dr2m1rJYN9iSa5TZdH4	5834	8239	8239	1617422220000
11361	3NLqtzST6PG6MKKeRtqFGFyeJ7671Xa7KpMmSS8dU4erYutS3BAq	11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	1402	874	161	6301	7737	jwo1KnVvkq9iSFYeinQwU83WewuSLCkEkHq6ShyvtH83j4rpaMf	5834	8239	8239	1617422220000
11362	3NK9p5ARwYZ7ZpnGfohyMeKQkdcykqKYcHAiqFr5idfdSu8eHxFc	11361	3NLqtzST6PG6MKKeRtqFGFyeJ7671Xa7KpMmSS8dU4erYutS3BAq	1547	1132	161	6301	7738	jw6pYrmdoXS3MakCHBnXMR17tduFBzXfiLKV6vaCso2PFxKgcnb	5835	8240	8240	1617422400000
11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	11362	3NK9p5ARwYZ7ZpnGfohyMeKQkdcykqKYcHAiqFr5idfdSu8eHxFc	1405	857	161	6301	7739	jx1s68kn4jzKd4z8HCLsNbx7tVfn8zeJjoNAcDMXV68HMJMEpkb	5836	8241	8241	1617422580000
11364	3NKPCfLokF357EThocwC1AzhRDbKouKgrLYkeoifqKCpREwLCcrf	11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	1406	1393	161	6301	7740	jwvRZjZvYA72wdv4Bg5TZ6Cv1NW1ddJ7UxM7vCUtQRy5CwfQTis	5837	8243	8243	1617422940000
11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	1585	1120	161	6301	7741	jw9Ctp1Qa3csCZqw8bnQ5MRA116miNiPR51TJWNvYaY99uE5H29	5837	8243	8243	1617422940000
11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	1402	852	161	6301	7742	jxHrZEbzCnhTkWg1fLWx8jb2FYbAQSakpcVmFtHVYGaTVwmGQij	5838	8244	8244	1617423120000
11367	3NLfbqMtxTbUEnJshhptS2aeULRayS1cD4wQvsF39oQRUVmKdPU2	11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	1564	1338	161	6301	7743	jwT3uzcuo87LytL7KYweXS9TL4tKxmY2diMYzDHXr4WaaEaZJW3	5838	8244	8244	1617423120000
11368	3NL55x9THeM1qwgbxDpswRZ5u8C61BJivwFf8i8SG7s2seKeErrK	11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	1599	1287	161	6301	7744	jwNQuvs1uh6ad1D3EAyTU9D1jbRGuTQphAecYQr7F2NKpFB3d2Z	5839	8247	8247	1617423660000
11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	1673	1122	161	6301	7745	jx5xUU1xDhVc5P4kMvZAAhvjgthk2ipeZ7ij7Du6rWpBMmTjvbH	5839	8247	8247	1617423660000
11370	3NLmScxzCvbTpZsfH2PNcZ7BWLqu2uyGhhBsK4ihV9J23Ephjj2X	11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	1637	816	161	6301	7746	jxQsMQ2Vj2xoEAvJMDFURXsZxp4UGpRo1UUVqH6eo3gu8aierJi	5840	8248	8248	1617423840000
11371	3NL77tLhYDdvuZjk2MaJ2E3zE9dQSYEvhXG2m96GYUA6gR1c5k3v	11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	1623	839	161	6301	7747	jxLsqg96WU86wbK4rHZ62RXqKaGMi4gZFak1VGUBsi4sDjsAHKq	5840	8248	8248	1617423840000
11372	3NKuTJ9gfB85TBBvC96nz7ctgMQz1gM8CofRUrFv4Az9B52S6dSz	11370	3NLmScxzCvbTpZsfH2PNcZ7BWLqu2uyGhhBsK4ihV9J23Ephjj2X	1553	776	161	6301	7748	jxc1e4RqaP54xsGoJU7bAX4S6CBgncPE9PLdGtADtH6Z4j6Txa7	5841	8249	8249	1617424020000
11373	3NKqZ4RUUL5XdRhUSLP6ynwe17441ZHU7nCmSepAVudL5hZ4DF7m	11372	3NKuTJ9gfB85TBBvC96nz7ctgMQz1gM8CofRUrFv4Az9B52S6dSz	1403	824	161	6301	7749	jwm5K89XdpQjsPQEuc2jhM3Yk1SCteQRYVcwoj4gMDQz3nD1q2N	5842	8251	8251	1617424380000
11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	11373	3NKqZ4RUUL5XdRhUSLP6ynwe17441ZHU7nCmSepAVudL5hZ4DF7m	1406	1393	161	6301	7750	jwcxcQyRpAyTizbNn9SggtKC8gRM6hpXxLT8uUUvVQFKUxwJm2g	5843	8252	8252	1617424560000
11375	3NLAeApa99VtepUxL7Ji9hSUUheaFgJ5qMJyK1Du7bdy8ztnF4Gx	11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	1406	1393	161	6301	7751	jxKHk9gZkX59xod7ynh4T766L4CRENKBdbyoC7vScEB5zFQ1T8t	5844	8253	8253	1617424740000
11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	1489	1380	161	6301	7752	jwDcjmPwki69AW38AQeSdgVG9Q1HLEMc3w611TKubsGE2Y2uYz6	5844	8253	8253	1617424740000
11377	3NKKAfr68NWNKfNXLUdLbHUpqNMx9CiMb7nYGGT4FqHBhFcBapEi	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1503	1151	161	6301	7753	jwwHDZdLbfr2PsnUgyktngpz6D3dKK82s5BaTbFt5HCkFUsSKyB	5845	8255	8255	1617425100000
11378	3NL2r7vhKxeJBMC44JF3aKnUJD5yak6T3CnP7J1rJMUj2AVT2RWR	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1654	974	161	6301	7754	jwDW1RiHTmDd6UaY8hL64BL9snZ2VjKCYAPqox3H45tmVNWJMzA	5845	8255	8255	1617425100000
11379	3NKKv33bSxxND9YWC1ae7WdAtihGUW2sgihTKWh19mGS47tPoFBn	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1503	1151	161	6301	7753	jwwHDZdLbfr2PsnUgyktngpz6D3dKK82s5BaTbFt5HCkFUsSKyB	5845	8255	8255	1617425103519
11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	11378	3NL2r7vhKxeJBMC44JF3aKnUJD5yak6T3CnP7J1rJMUj2AVT2RWR	1648	1284	161	6301	7755	jwQrEXgLqAMj1U8wkQX2of9Mouiyd1Vn7Afq8N5DDZzz9yyCLP2	5846	8256	8256	1617425280000
11381	3NLCqphSqtVzLBwKaPhQRLA6vZcGy8TT4kCurK5dw1aVDPhmbqaJ	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1467	1250	161	6301	7756	jwA5FL9SEWo8zws8pCmSYNAer4MRThnaaiditg8dpraxjazvAQU	5847	8257	8257	1617425460000
11382	3NKXWSMUiiotvNc1Xm1vS64isTfyAmUeR1RJ7Qxr3ADDN283Amg3	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1534	68	161	6301	7757	jxcv2Qidc5Jz87Tg3SPQN5VZgpruUQ2YiTVq723ZYxXDLtFRq9Z	5847	8257	8257	1617425460000
11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1529	1070	161	6301	7758	jxnpLAF7uq7x6ZBwXxQXsLjxeyz1eK9hqypoMZpc5UcoszXTwYk	5847	8257	8257	1617425460000
11384	3NLqtdjwvj3qyKH7w6hk7RzTHAg3wBHz616c1DCoKp9wmz1CToMm	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1670	1282	161	6301	7759	jxTuNjpGKM1SMHGD5LYarqDnFPaLLp1szmnEmtR7kcNPRfMYQtw	5848	8258	8258	1617425640000
11385	3NKjsDfhfyWuCgAt9k74PKvpqbypJ4WH6ubarQBVCUGVqMvd3sqw	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1472	516	161	6301	7760	jxv2t8Y2i46iUHtdv14PcMriUEkVMjHm2RZWZLj9J9TJ52VGzaS	5848	8258	8258	1617425640000
11387	3NKLY2VXq8YKS4p2V1bP5KgW4pDAUdoNmbeiAwaFTcjdqSav6kt9	11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	1406	1393	161	6301	7761	jwhbEMJVzu2nLKGMjxM7RzRSw3BJe3hkZ56vpPqbaAohbbUPGRP	5849	8259	8259	1617425820000
11390	3NKxkFG9nCQ4JBvUZwVUF7YciBx8HBdjuzHJTo41z22C5Z6xoGPy	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1649	1137	161	6301	7764	jwKSeCeQz62F1bw9q29zx5frQ9Cp7Nc86jS5hzufTxLfNCAmZcX	5850	8261	8261	1617426180000
11397	3NK77EidoQ4c1rXZiKRhStFYPQUogTcngr1kh6QkCGh9addeLj2y	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	1407	1395	162	6301	7769	jx1jh6J2GAm3vkpbHMKFt7Xwv1bm4s5v3sML4TywHYGKYnCZpTn	5852	8263	8263	1617426540000
11398	3NKqeM6JSNdR26yuyJfYNErhC3QuaFa1jcuVb9QHtGCEAnPr4PGU	11395	3NKaMJf33KpmFpS9G1o5q8QM1Pt2RV9Wu7XMqWePjWLZsBxJSsnX	1407	1395	162	6301	7770	jwRrnrLtbf2GAHzNHZAx5x7HhdrngQoiU7DHCv7QzajNBAy4Dn1	5853	8264	8264	1617426720000
11404	3NL8T2CGR4Hd61wYaT856aud817zb8dj5ShD8cU3Svmfru7PdYNS	11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	1577	1201	162	6301	7776	jwE5NFJBGe9x4yBE4SYCRvuCHCBPVpBJngc6eANcdazq5L52naA	5857	8269	8269	1617427620000
11409	3NLnENWtQ94bjrobu4AQUuvMVhFp3wfyZeLXaUAoF2PYgDRq7CRX	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	43	1184	162	6301	7781	jxqkFBFUAAw7WbUAzQH6dCoCvVZa2xbVTdQtqw13QqDmPS76wwE	5861	8276	8276	1617428880000
11414	3NKLL1MUaGUPsscqjyeoXBKRFBHbnqWEuwoa7cCBgd2324tGdy4Z	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1403	824	162	6301	7786	jwmcWtp1Z7QZW7hgn4GZpo7DdcyovbKcv6bWY35tmZkRqQPfnsR	5863	8278	8278	1617429240000
11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	11415	3NKSHu4y1inERdE9saUCqiDd6RytEu5fgVYBrHJwpNsEhDcnN5YZ	1477	984	162	6301	7788	jwMKirGZtoDsuSyfrBsJF7snmmocB8CVmfWgJCN32E6fnTPZfU5	5864	8279	8279	1617429420000
11418	3NLNzDNKXBATVzo4j4quu2pAxs99TnyEgjfCMQfTYXbhp58N65hT	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1406	1393	162	6301	7790	jwPERmHPoCaYrSSqXagQsmtFoSFd9maEkrg1t3VdaZgChLzWnsE	5865	8280	8280	1617429600000
11421	3NLTQVTzkHEYYTj6EWXNPGsBW9BzRxKXvvVBsGiJUWntaxjfHEef	11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	1407	1395	162	6301	7793	jxYaUE2KDLEjRQT99B9KruppBr8MM93ujaFFDpFLKUbMTh3tevW	5867	8283	8283	1617430140000
11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	11421	3NLTQVTzkHEYYTj6EWXNPGsBW9BzRxKXvvVBsGiJUWntaxjfHEef	1483	452	162	6301	7795	jwhaLgWCaPMiYtrVCo7BLUPpo6vJifsg2UtS5oCBzJCTEfDE8pZ	5868	8284	8284	1617430320000
11426	3NKYwRrR4a1eQdVbz3orankYWMQpfuei8CEeYydB5LkH9mePZECo	11272	3NL8TxfBvrEz6QGXUt5y7RGie94MVZXvYbzYwnYr6WmkfZUhmic7	1527	1293	159	6301	7798	jy2z31DNi3Y13H3LVEDm53cQWmQfS5F6chZDW3zckJcwqQ61hc4	5792	8285	8285	1617430500000
11428	3NKbfAMfknnpGMrmpisxf4bYeEeCvEySQDwetwXop982dnvb7zPK	11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	369	1312	162	6301	7800	jwsUGgSkmN9ZC1QgEQEZ8MTEPexFubpmFWuZHy4SHktUUJYYuwS	5870	8288	8288	1617431040000
11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	11430	3NKtjJdau3nYwKarab4CYAqqoYFvvnLbevsfHF16LckFSDtq1JDT	1634	1085	162	6301	7803	jxjP18gyGNUXUFzXkKVSjcUdrwRzvZE2qSwC2FVfDyWcA5AG5kw	5872	8291	8291	1617431580000
11433	3NKkWUrX9ZicBrxud7uhfDRApDeT71yaGZz3UPngqCvzzf9xueU4	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1402	852	162	6301	7805	jw8rewFafoognXGbzaRAWMf3CjmEREcLkJRNGAtPqoPJhFfsEhD	5873	8292	8292	1617431760000
11438	3NKFnah4AoKJ1FJEZqATDdgzGSZrnBJQXeYaweSNc3HGZ2pEHmfy	11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	369	1312	162	6301	7810	jx97Aoyv12xuovjVtkWK3usSFYvC4Sp7KeLY9rTkcjrRZUGwnzh	5876	8295	8295	1617432300000
11441	3NKaUVLTMsRAtQeZzfzDEFNagW9gVj2YEVPiArMdCcBshpEwZt5t	11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	1657	1218	161	6301	7813	jxhaiS4rXsAth5Z7mKrbaDc1cbykfP6b1kr2BfK9zN2NFdRrZJm	5831	8299	8299	1617433020000
11447	3NKhCQ1Lg1Cf8pTooiyjk33eHWmzWi4WqEhmLFYkEHnt7itDyBTb	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1460	558	163	6301	7819	jxEiTZP1emLxdReWprysG9zcnJc5mYzHcQVdtsYknXBjSaYVRcH	5880	8303	8303	1617433740000
11451	3NK9Y3cGPNVWEXz8xmrmiNC6KgPWxemBN41XYoYF897wmtADGutd	11450	3NLRvCGNR5HoHDBDPKySq2vBacdRaGAmkVDgFN5DnNsYbB7tqUoi	1403	824	163	6301	7823	jxM1Uh4J1yaBuTaTaURNj5ZcgUKWCvkf6A2Tkodf2uCm2MkCf6L	5882	8306	8306	1617434280000
11454	3NL3dL355rk41WT2kJMmaE1tDMdXKdzAND3PErnUVkTpSehLVP5K	11453	3NLZXAgKM9kgVcaTz8m5ZmqmidaMLpww1hCmm4uUUf7xprdivcrB	1435	665	163	6301	7826	jxHGFWoSMBeoS49jifp5LPW4iggv55RK9uhZChhVUiwVshA6exu	5885	8310	8310	1617435000000
11460	3NK6EsbsdHv426jFWuE2NcBGQXdFpBFrVKw2YSuuDSARxru8eQak	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	1406	1393	163	6301	7832	jxnaxxfrVJMBT8AEx17F6znw1KMNzFqGTW6PdyRpauMaUC4kMBo	5888	8313	8313	1617435540000
11461	3NKg2tnigsij6AwWmWHFuZAjP2T9QkLg541twmsgFJU2gpALun9c	11459	3NLucjt37BVhQJ8MZKpUmgnduFGP2wsWsXTz3oVWyLpt6nWVsjak	1483	421	163	6301	7833	jwTdz9mT85jKErgoarGrTdYehMdkgJpg4dUERyf9fB42rYFmZu2	5889	8314	8314	1617435720000
11464	3NKvAnRfNVVKeMHEbNPx9pmNKX8qQZFewy8S23xfMa2dwaWiXc1L	11463	3NL2Vq1hSjCDGYUgpbPAtnmeWWvHBPSEJ8UfZUjv94gV6EBK8LtZ	1403	786	163	6301	7836	jxC917k37sFJvZ8FmdtX2tszGDSR1dXGPMNW7vCxp3KM2DVcwzM	5892	8317	8317	1617436260000
11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	1407	1395	163	6301	7839	jxrUtcD1afuZx5PtbGXUgWXVs1LEj6S6CMVvWWuekahQDHNqS4i	5894	8319	8319	1617436620000
11469	3NKdQqM78NDKkvvWZUnsnXc4iDhovgPVfs97xtmG9yGoKNhZAxDf	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	1675	1216	163	6301	7841	jxrd8BBicFiJsWkL52s6XK6ye6hnc9MHruciCBtZK3CnKLYnc2A	5895	8320	8320	1617436800000
11472	3NKin1YYhV6urz2AV4W4oXSiEkGcccKBwvM14p7opDw4ZZCcWvZZ	11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	1402	874	163	6301	7844	jwmMUp5bPkTuMsQWDrqthGVEPpxZeEH9sonsjTvnabHCv7nRkkW	5896	8324	8324	1617437520000
11474	3NKD35iAh8duyj91uqyDWL5kb4p6GG4XB3qLsEK73TeWgMnfSKZQ	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1403	824	163	6301	7846	jwsqTA8p3KK2uGC5B3w9RD3ezEnkHrYrQ2GqSRo5yGCnHWR3CeR	5898	8326	8326	1617437880000
11484	3NL1MytHhg6B5HXk2X9y6rkjt7jN22RnU1du33k5w9CcdRxjnQtH	11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	596	1306	163	6301	7856	jxier4RGCA8C1ABKFzQzZVkH9iU1XQeritJpMWHihMNnJX5uisa	5902	8331	8331	1617438780000
11486	3NLfajf4zKXeDAp6vnfMvvvPPV7XETw3Eqdbb1awgGCNpDpa1YRH	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1675	1342	163	6301	7858	jxEPW9diwhhmYxVuGfzowquexqxBNUDSTYLqct6qhh5G1mpPmEE	5903	8332	8332	1617438960000
11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1670	916	163	6301	7860	jwcKuYJqaBEx6ZVC1pnB9QddqgXqkj4qTukn6y3vuGXAyWAfpZj	5903	8332	8332	1617438960000
11493	3NLqCHPeVEtRdqWTa6XWZszw7s5Ntbp8ShWxhv1nPb2iW3yLyWu3	11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	1585	1366	163	6301	7864	jwmfSZaQ5JS1smeYwKNhfYEhm1kvSwh74cGkPrDERBcrnXEZ2pz	5904	8335	8335	1617439500000
11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1472	516	161	6301	7760	jxa27nP9G1PA8vVKziTkJUAwzqcABY3eqS3Nk4weGWEY2ccryGe	5848	8258	8258	1617425640000
11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	1617	1162	161	6301	7762	jx1AHRs2ENVcvZyrBj2zVnTAo3eKNJRrDWXPv76NJdGEED7js8q	5849	8259	8259	1617425820000
11393	3NK3ugXRzi8oyH5d5XgTzGPvtSeHkK5sjx2FgRTDR3FcrFxYMN8g	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1601	1262	162	6301	7766	jxxVfoNxN9nrCey12N4c7P19eABF4qGzheSyFLL7PCWFFBCrBs2	5851	8262	8262	1617426360000
11395	3NKaMJf33KpmFpS9G1o5q8QM1Pt2RV9Wu7XMqWePjWLZsBxJSsnX	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	1460	1198	162	6301	7767	jwyuvnYFYLBVS88VQBdfc4yVmF8HwzxcFRWbesEEj1Z6ATwidrx	5852	8263	8263	1617426540000
11400	3NK6ud8CDTzPgWiFRuZXfxxKUFXLtpJ1Wg8yXwpA3AAhhkeZ5ort	11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	1608	1043	162	6301	7772	jxxf1EohEkc95pjDYc2J1zNjftsGZgTr8Kn5EBseND3nNiKTXJh	5855	8267	8267	1617427260000
11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	11400	3NK6ud8CDTzPgWiFRuZXfxxKUFXLtpJ1Wg8yXwpA3AAhhkeZ5ort	1560	1045	162	6301	7774	jwungFPHFJmRanoJGsQM21P3q171nBNoUnpDEkPcEcopgZm9YNB	5856	8268	8268	1617427440000
11405	3NL3zoPw6AxHikYoHDy6FctDawv89LMF8UcePHBKdPZ1htj54ibu	11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	1406	1393	162	6301	7777	jxzSdgL7kbsPMPN4x2asXXj6tWwmhfxui3dwHiM3xLC36fvMtuY	5858	8271	8271	1617427980000
11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	11407	3NLdawetrV19UJeEy17qBDHD14SJQcQsNXEi57XVtuteXZvkBNBc	1403	824	162	6301	7780	jwxLacTkNYSoqfTZVQLpDnoFwwLemgdZXMAX4KfWHuiSD3gLPTj	5860	8275	8275	1617428700000
11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	1577	1327	162	6301	7782	jwxroa9URhK8CY6tT2VtuPVzvkFaLFa6eSBRpXQMz41aNYtf4eL	5861	8276	8276	1617428880000
11415	3NKSHu4y1inERdE9saUCqiDd6RytEu5fgVYBrHJwpNsEhDcnN5YZ	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1405	905	162	6301	7787	jxikrJJUtz8Sn1ekNTV5LXfXnyWmNhmjVyFzpZJU3Pbuz6UGCUT	5863	8278	8278	1617429240000
11417	3NKf1Az3sLNREwdMeMnBSmjG6AAfKeawevCZHztogJ9FgvKyNTVB	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1534	1071	162	6301	7789	jxdgUWrdcny7CRXsRdezVChx6pzGEG9tFhvm9CskyhegDj7xQxJ	5865	8280	8280	1617429600000
11422	3NKvhzWM9E3drxej1K3mHiiF4ofCdivySDXpSd9cSPovn2gNDBsx	11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	1636	140	162	6301	7794	jwLU1a3oJmNYWLjGFoT6AaDYGT1vZ6CUbXMw6QzWG1L5qYTLfyT	5867	8283	8283	1617430140000
11425	3NL6APGHZPrSuUsfPKoUo7wjEWzWvascrP5mbH1FzKiE1E3SGwFQ	11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	1407	1395	162	6301	7797	jx3Wtf3V59em3AaNUxsfcweY28uc57aErD5iteYnj4yWtSqh7uL	5869	8285	8285	1617430500000
11427	3NKrVfiQDgHbPMkNmXgS1cgsMxgPqowcyq7iSLnNmnBKY5fLPWvy	11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	1401	4	162	6301	7799	jxdUHh71c6tqk9uYuyJGmUzT73ZktMHY9W6PN6aBvkjWjdosWUQ	5862	8287	8287	1617430860000
11429	3NKmZc3GmStizrtQNAg1TZs3LRFe52HzyVZMD9N6mb2SxUxug4vk	11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	1656	1343	162	6301	7801	jwVz3Ws6jw97idJwTWgeNzzCM5hBNgxFLtvvSKZSUttWBH5d5AE	5870	8288	8288	1617431040000
11432	3NKD1u6zCx6espmUg4JPsnshN5cfArEYKrane7FqpgTURkd7EBTY	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1406	1393	162	6301	7804	jx4kV5suhzoGzWsS5naj5BwkWm45zyiXn2969ghcd9WxgymJNfu	5873	8292	8292	1617431760000
11435	3NKD8kaeSQwC826qRMxscWqbaWvjd2jX2EAzbUaVMaQt5FmGnQYR	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1631	794	162	6301	7807	jxKTeSAsPbyXadwQcJZ2nXWufQuyrETUuD9LkG4DciL6Zn6re3C	5873	8292	8292	1617431760000
11442	3NKmiDuFE9KAgLyH4wUtGDRsSQoWLe67Q9jxrBFW2uLqznjnSoQo	11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	1657	1218	163	6301	7814	jwNECtHG5EfkUwE63EKYdzLmHEJRtuEBfPkHAyks8W8D1NaSHTK	5878	8299	8299	1617433020000
11445	3NKEheBMgqBW9RdMpcBoKrxWCiKSQVJEjzDtKbphdfiZ9zJ1qVQR	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1403	812	163	6301	7817	jwdQGfmDU4h17LwKNjg8qf8sgQG85pq3acbxNeLsSc5WtEzDJq3	5880	8303	8303	1617433740000
11453	3NLZXAgKM9kgVcaTz8m5ZmqmidaMLpww1hCmm4uUUf7xprdivcrB	11452	3NLLbvxa3sgBgjSBABKUuGA6DYfNAnB1BJVdE92kxai25J3eYgbR	1406	1393	163	6301	7825	jxhqztY5Bp3m9bpveXzZnMzid87qPttPEjnpRaWkLCPmcAAXLjs	5884	8309	8309	1617434820000
11456	3NKo78gFSjPSgmjQXtqkhZpQJsqLUrBYVtprxatTmFrTckovfU1E	11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	298	942	158	6301	7828	jxxYn15kX29yRiTia7teBpMGTXv4fkC9A5LVaAeQ3qtN8wE2HVc	5777	8311	8311	1617435180000
11458	3NKB8CLGnJ4PKoKikJ685RDWcN5mnXhxsXibEDz1JvAd2yADUNHV	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	1536	1313	163	6301	7830	jxFD5S6wvHoPP3KYgHKhgqAiJEBBaafXVk1ikEwpmSRaSQBhnrL	5888	8313	8313	1617435540000
11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	11464	3NKvAnRfNVVKeMHEbNPx9pmNKX8qQZFewy8S23xfMa2dwaWiXc1L	1670	1282	163	6301	7837	jwRaiqGAjytVYBtcp5R1KMJJwggZ8vJGaeFFLARwJGHVvHpgLKp	5893	8318	8318	1617436440000
11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	11471	3NL6NGU9sPseitRas1AxSeiLS5gSmcB8yxX1hE4exnRBcE7Zi4HL	1407	1395	163	6301	7845	jwPub9Sh77yZhjWTa4FdWSRd4GdQwFuEErKouUrjxHVV2a8MBzb	5897	8325	8325	1617437700000
11478	3NKZvPjru51s5orvYcfFhczsNmQDvbCMLn2Rk4Sz4NpwithohHVV	11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	1501	994	163	6301	7850	jxvH94ErAwTKN7Bm5DB63ATTsHbuinDk5PebZU1ecaBBjUi7aLQ	5900	8329	8329	1617438420000
11480	3NLLRrg9iULfUKT63CAM5HYujNXrpLhZ4Tz5D8ZZovUzRTHZurdX	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1445	1290	163	6301	7852	jxP6PpTxS411owdM7MPpNSAGvBQSMWEH18vbVfNU4jmn2n3mGNu	5901	8330	8330	1617438600000
11482	3NLWhXRDuH9HefLUyC45umNev1xGanfpVn4haav8VjBhcoSjVft4	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1406	1393	163	6301	7854	jwrwom4tLppLPfyrUwBEuZNrNsMqVT8eQbbCEXFhvpmDWQyWE4c	5901	8330	8330	1617438600000
11487	3NLCP18A25BPqc2k6tQBoxwdL3GrdQckmNu6cDu4m8R2Wv3bY5ZY	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1407	1395	163	6301	7859	jxJv97aBNjXpBtBQKT5cVcK4qvXFBkHXFPSrZmeHoysrP4vyjt8	5903	8332	8332	1617438960000
11489	3NK3Ujv96B54thFVEYU3r2DyBnQsi3LjMXB3gaKgF3JduQEJ3nCH	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1448	1065	163	6301	7861	jwgwh4EfESPQ2bi1wL8mVSaZ3Ls3wCX8YUUMqKQQRLtST7pWLub	5903	8332	8332	1617438960000
11494	3NKtz9SbjahZh3tAg9pDqDk9qXXdHJdwykP1HHc5HKETB6e2VGNt	11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	1509	1074	164	6301	7865	jwerVVriYfxzEveg5pGdXr8JGEzteByiGAqnLC1m9jTGmCACkQd	5905	8337	8337	1617439860000
11496	3NLUpU2g5H633Q4VB3k1u8LQwHDknhNrjVYCSJQHtcnGi7Hdmrx2	11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	1447	1345	164	6301	7867	jxi9WZy1c1BUWcoKBJxe42vWjwrtXHtNyKPZHiTMMUBysnKwRoz	5906	8338	8338	1617440040000
11501	3NLNRGxNTueGz6Z5VFcqxSC7DxwHvifJ1i8P6z9pCwS3Z6VKdZXS	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1405	851	164	6301	7872	jwxPuUqXDue53ocLsFeSkYRZFZCqkHYNgEZiNet3WWRqNpwzB47	5908	8340	8340	1617440400000
11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1403	786	161	6301	7763	jwUc8JyGghE7h9kGBr8tEywQNobAWuQDNvb2ze9Ct1TiNcStDSw	5850	8261	8261	1617426180000
11394	3NKxwzyTYwuhYbNnV4Dsu5dEuxMfBSZxm4LsycjSE92m7W5Augc5	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1601	1262	162	6301	7766	jxxVfoNxN9nrCey12N4c7P19eABF4qGzheSyFLL7PCWFFBCrBs2	5851	8262	8262	1617426364096
11396	3NLBCHdn3HdUaxgFt1dwDX4z7VdkVNhaveMfXsqH6X2JF2RNRQ5B	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	43	944	162	6301	7768	jxBdpYnrU7rjhbTuzGGBD9wwNy4KGEdquKGgpqU8GqdwxzC19op	5852	8263	8263	1617426540000
11401	3NKUN6GyM3XTMc12DXoBmPpjvMZ9yhRSmRDrtM3xHZjX4Zvj3Q9L	11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	1609	967	162	6301	7773	jwsqKh7bxVGLgDt7QCJ1ahoLxExiCoUmqurBbYS8RP1DqvteAQb	5855	8267	8267	1617427260000
11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	532	1057	162	6301	7775	jx4jUyLhhdYDkBQHo9jq8ce86hJx3Zg5CgWorDodLGLWzW7ntSG	5857	8269	8269	1617427620000
11406	3NL5BAz15jVKm9tHZynAmkpTxBzzHECkbG9fUTjtZtR4A1PZu3oL	11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	1481	790	162	6301	7778	jwsNoRaUAXBMtunZbnE4yzC2Aknp1Scg6stjkMDipWNUXKkTvvM	5858	8271	8271	1617427980000
11411	3NLb7a1knyRUAehA9Qcv6EPz3CsFD4ynCqT2yWYdXKLemqRedZef	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	1405	873	162	6301	7783	jwUSjHjmDxsVSVQk4oNhwERkqhXg1nrEbDhW6e8MHyaobrrHaAw	5861	8276	8276	1617428880000
11413	3NKWj4Tmp2ffpX2in1KTGTDg1nsSTQUYB1JkBPFEvPZTx6SA4Ncj	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1610	1068	162	6301	7785	jy27U3AAxdgFMkFhDLbHyaTqEHGKKH6uVMWwtct2nwhMta2TyaZ	5863	8278	8278	1617429240000
11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	11419	3NKzdJy7S5CpUhSFXsmKGwhEvDxFBQdswroyTJzPyX6ryyhVjCqX	1619	1029	162	6301	7792	jwXjEyKfhZczFapZ2r8BfiAS7KGPxwEV1hmNyPZ56YSt9FgEUAX	5866	8281	8281	1617429780000
11430	3NKtjJdau3nYwKarab4CYAqqoYFvvnLbevsfHF16LckFSDtq1JDT	11429	3NKmZc3GmStizrtQNAg1TZs3LRFe52HzyVZMD9N6mb2SxUxug4vk	1406	1393	162	6301	7802	jwPeBfHh5LvdfdVxDA9FMAot4CoA31vDDLfzcruEUuhJfwnMoF5	5871	8289	8289	1617431220000
11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	11436	3NLPRgAXJpr1Z7MsPMWjSBDjBskJXciiE6Fr1ZUMzT6sHp6MWEmG	1402	874	162	6301	7809	jwa8qiAmztzpretAW9KZeX4BJEDmc4QGCwKi83GT8aa99xJnNNG	5875	8294	8294	1617432120000
11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	11438	3NKFnah4AoKJ1FJEZqATDdgzGSZrnBJQXeYaweSNc3HGZ2pEHmfy	149	1283	162	6301	7812	jwvKyZC3way7jyXiDaKo7r9Bp2SSyU2fTJZpjPuEUFdoC6qi1nf	5877	8297	8297	1617432660000
11443	3NKav5WZYjvGSv6gFcyPiddeGrj3dDGfwXaXtat2Nzm7uWjB29mV	11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	1587	1357	163	6301	7815	jx7XrbpeaaDPEzG46ftydVVihhBeD8zF9yB7B1EBSTGAuwNkFaT	5878	8299	8299	1617433020000
11446	3NKee2tuk4so583T6St13USrufh6andXeihBH2knxyzFUE84r5Cc	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1406	1393	163	6301	7818	jx8DEUXCrD4A6CJNHzRrB8Xdjk1fJ2Rv1mHA7tce7hzYHQ3jLt7	5880	8303	8303	1617433740000
11449	3NL6iHDbeCEgALKtZnLojNrVdRrPTNV9UvnrEUEWviE9AG3Bsd7k	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1623	839	163	6301	7821	jx7RvWo69G1PbYKgGMUdryTVsV6BFTfi7Ry8ZtEhDG3oyvnVX2r	5880	8303	8303	1617433740000
11450	3NLRvCGNR5HoHDBDPKySq2vBacdRaGAmkVDgFN5DnNsYbB7tqUoi	11446	3NKee2tuk4so583T6St13USrufh6andXeihBH2knxyzFUE84r5Cc	1549	1362	163	6301	7822	jwW8WfY3jepYTkBnaTJktLh1TnqU3piLDizZAXyM2tf3enExuPp	5881	8304	8304	1617433920000
11459	3NLucjt37BVhQJ8MZKpUmgnduFGP2wsWsXTz3oVWyLpt6nWVsjak	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	44	1325	163	6301	7831	jxkQAukWxPkvAYe91N9MjhaddGsD5qGdmZvDs9U57DQpqfzrTaA	5888	8313	8313	1617435540000
11463	3NL2Vq1hSjCDGYUgpbPAtnmeWWvHBPSEJ8UfZUjv94gV6EBK8LtZ	11462	3NL5rmQm7Fq3nD72ri6fiHESiHBb714Qx1DvPzSUvTrbBXxJXDjB	171	1008	163	6301	7835	jxSE5AR3DBfZpsqAUMZDiBiNz5yVVSn5uQrqzpp8savkWVasDik	5891	8316	8316	1617436080000
11466	3NLy7wDq4ZSXJW6k8wNH8m5mbcPZNHznVScv3PJtyo36KRh24HZn	11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	1403	782	163	6301	7838	jwo83NTWbXDBLaMhZW7RUXMJSBatwinG58oGYSuWV4awHLbpxWC	5894	8319	8319	1617436620000
11468	3NK5gHHMQXF1zJ6nApmy4Ue5DvzFTe3EjrfPRtG6PXZ32K1Mkhay	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	44	1325	163	6301	7840	jwpKKrnRSFGtdYBvB1JxeCsJHwERrCCE5qQEbT8YEzX9PSg3GtL	5895	8320	8320	1617436800000
11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	1590	934	163	6301	7842	jxvHVWa1EVGLLzdVy7RcR7cH6Lk8UFHvWYtduT61M84RmqVzVgV	5895	8320	8320	1617436800000
11471	3NL6NGU9sPseitRas1AxSeiLS5gSmcB8yxX1hE4exnRBcE7Zi4HL	11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	700	840	163	6301	7843	jwDCmYUSnYxoseeqSQ6QpnUxCWb4uYpv7QK4NMa2839M4PAvWHd	5896	8324	8324	1617437520000
11476	3NL2AMqTpcASko1VJA4n1wKgDs6PoAzRtKRqJUgtyxd6fTLKiByY	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1564	1092	163	6301	7848	jwRjPfWFQin9MGekGrhgP8dWjHgZQkifqCYUGKXgWRZhPGG6WYR	5898	8326	8326	1617437880000
11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	1608	1289	163	6301	7851	jxfZhndK51tZrckYUCqwpFbNEUAfdhGt9ntDgWrja4QRXrpfTVJ	5900	8329	8329	1617438420000
11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1637	816	163	6301	7853	jwaQkURxq668PnHmoGvBvK89t4paQphkXHKndwdpEcaXHre6hJ3	5901	8330	8330	1617438600000
11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	1656	1343	163	6301	7855	jwvxovRczjj9peQKu4VCWDuezagSYVx7vBAwxngcCdgRSxRF4VE	5902	8331	8331	1617438780000
11485	3NLT1BdrxP3CoCXUaD3d3ZDhRQJHBeExzAtsrZVJjvKUJ8U9CBR2	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1599	1041	163	6301	7857	jxfhibhNCU4emGVNJMHeAqN2vXgsVVDPzRKddxZDH2kA633WaKu	5903	8332	8332	1617438960000
11490	3NKXKMnGhmtE8WXrYdEeJkBTBs9hqGvxCH67nYNqN5KZEk1USa5Y	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1439	1279	163	6301	7862	jwiQuDwdHxaYyKjWMYhWimXcrZ9F7zXS2KJccF3AmVsDqmAXqra	5903	8332	8332	1617438960000
11491	3NKQP26tyqKBhSagGAWqrnE6fZfCsfF6h6LiXnzrwoaiFP3ZFDWN	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1675	1342	163	6301	7858	jxPYtuPfD2B8zhsHrnYbi5crHijRqWNfd4SqXL7z925WAz9isuG	5903	8332	8332	1617438960000
11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	1617	1288	163	6301	7863	jxWZznQUvAji3Gh1Qvm5E1bLtagwAXcGuoWPMFSfzxTpkx8LBUd	5904	8335	8335	1617439500000
11497	3NLHtet9HCFzysaS7TDseHd3LwcsArQfK8Lcq6xE6X1z3wL7pQKR	11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	1657	1344	164	6301	7868	jwZkSZysso22Ug7P3AaTcE29PZQMQw4RQoQBMihobceiAixpDrS	5906	8338	8338	1617440040000
11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	11496	3NLUpU2g5H633Q4VB3k1u8LQwHDknhNrjVYCSJQHtcnGi7Hdmrx2	1440	1131	164	6301	7870	jy258WxbMAvZSr2d7xu8MzfnPnNpE7hV7MpQjAhu73EXZjyzonU	5907	8339	8339	1617440220000
11391	3NLeznMevvkXYu34Xip4ExpJ6eMjns93N52om3YAC2aYJVQ55sJN	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1649	1137	161	6301	7764	jwKSeCeQz62F1bw9q29zx5frQ9Cp7Nc86jS5hzufTxLfNCAmZcX	5850	8261	8261	1617426180000
11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1637	816	162	6301	7765	jxCzbvQFbWicHNcnkQjqVYLPtPQCkGkkwXFqii9FwVPWfCR2BXz	5851	8262	8262	1617426360000
11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	11398	3NKqeM6JSNdR26yuyJfYNErhC3QuaFa1jcuVb9QHtGCEAnPr4PGU	1477	1350	162	6301	7771	jwK242CQX8WVDbaT5TWGe8oaMGwb1CXcvY2uognZj3GnfTr7YtP	5854	8265	8265	1617426900000
11407	3NLdawetrV19UJeEy17qBDHD14SJQcQsNXEi57XVtuteXZvkBNBc	11405	3NL3zoPw6AxHikYoHDy6FctDawv89LMF8UcePHBKdPZ1htj54ibu	1507	1280	162	6301	7779	jxPwFdwYZyQ1QvHSGQi7A8mAKeWsqqYWuGMmFZ8sNNhpmPgtqXX	5859	8273	8273	1617428340000
11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	1631	794	162	6301	7784	jw9xv3mKT9eHqAbSA6A1QbzPmL6ukya9Wz6MwsWbT1QVYnSzF4L	5862	8277	8277	1617429060000
11419	3NKzdJy7S5CpUhSFXsmKGwhEvDxFBQdswroyTJzPyX6ryyhVjCqX	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1673	1122	162	6301	7791	jwfP7di15erw5FDYFBvVVA3efANYQd197YgiRqhuLk6CgCDkAVM	5865	8280	8280	1617429600000
11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	1527	1293	162	6301	7796	jxRyztMWwxa7tuBXKneQ7Ci5MNQ1mvAY56JLHpyJAa18shX2eu1	5869	8285	8285	1617430500000
11434	3NKeKS4ZPYkKWng5SeUVtzk3ncyxNokWfpM2ZBn1NTkeJxsWU9VR	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1671	1365	162	6301	7806	jw7qyvyrhHwBM8BWFHWh7Zm8NUPc1m8HvRumTZWafDdHoBfUfKV	5873	8292	8292	1617431760000
11436	3NLPRgAXJpr1Z7MsPMWjSBDjBskJXciiE6Fr1ZUMzT6sHp6MWEmG	11435	3NKD8kaeSQwC826qRMxscWqbaWvjd2jX2EAzbUaVMaQt5FmGnQYR	1634	965	162	6301	7808	jxS7ZKZbW7Tp3WjCqb9pqG9kmW7zmyFBjZBvrHcZoWCbrQVzc8m	5874	8293	8293	1617431940000
11439	3NLKUWgS4X2bzMVvr3ehmfNZkx3fFSDdshRoRxaVjvxnqHmd1y6s	11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	1406	1393	162	6301	7811	jwJy7dMmjAafcrqzq6s5CFKmLhvueui6p1ZtQj1Wg9gFt4Wo9zA	5876	8295	8295	1617432300000
11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	11442	3NKmiDuFE9KAgLyH4wUtGDRsSQoWLe67Q9jxrBFW2uLqznjnSoQo	606	1049	163	6301	7816	jwhLw4zzYMvtogYkUt1USKuKghbc2hsb2YkWu1Fo8VwwgiNWhmH	5879	8302	8302	1617433560000
11448	3NLjGynwJeUvNqj1n2TZfxLT2EhtUEkmAR8uaLf8UyXRmKHB3Dmj	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1407	1395	163	6301	7820	jxzEazwhV6M79nw3XKoM5YNXYDRtUwv9vTxw9ckCqJoCJ1nhxr2	5880	8303	8303	1617433740000
11452	3NLLbvxa3sgBgjSBABKUuGA6DYfNAnB1BJVdE92kxai25J3eYgbR	11451	3NK9Y3cGPNVWEXz8xmrmiNC6KgPWxemBN41XYoYF897wmtADGutd	1405	873	163	6301	7824	jx4vsjngoKrhLttcsCzLf2CZTE1oKHfqNaMrNQ954gTbw9PUx78	5883	8308	8308	1617434640000
11455	3NKw1sLFnAZENVNQyrKmUFzeVvfAiK3oX97MirZoyucZb9oThD3K	11454	3NL3dL355rk41WT2kJMmaE1tDMdXKdzAND3PErnUVkTpSehLVP5K	298	942	163	6301	7827	jxEoGFbBTenuj2H1mShQr62DNZJ82V3JuJkYpv4kdKx3oaGA1pg	5886	8311	8311	1617435180000
11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	11455	3NKw1sLFnAZENVNQyrKmUFzeVvfAiK3oX97MirZoyucZb9oThD3K	1406	1393	163	6301	7829	jxRSEmYJk58YEUfF2pVzgJxyiyhsqQvASNkhyLnwstMhKp7yu3A	5887	8312	8312	1617435360000
11462	3NL5rmQm7Fq3nD72ri6fiHESiHBb714Qx1DvPzSUvTrbBXxJXDjB	11461	3NKg2tnigsij6AwWmWHFuZAjP2T9QkLg541twmsgFJU2gpALun9c	1405	867	163	6301	7834	jwEFreqkrzXzBdJdd8uGDBG48zhVTCrB58K4vJnWkYKsDX9uwaw	5890	8315	8315	1617435900000
11475	3NKyrLDumNYFmRHXBBc4k1HRy3xCGrynWLLV6knKnocsLs3gJxER	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1637	816	163	6301	7847	jx9ga8b5NQnnXBXowves7LxadCnScXtcaTXHdHnYNmwcJPbmGvb	5898	8326	8326	1617437880000
11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	11476	3NL2AMqTpcASko1VJA4n1wKgDs6PoAzRtKRqJUgtyxd6fTLKiByY	42	1361	163	6301	7849	jx3iex7sqsEUWn5EaUoVUx9xbwcaq5dPspiWHrV5LuGbtuoNNoC	5899	8327	8327	1617438060000
11498	3NKY17hQZkvgRVfJsiZ3iuneuyJktcEAvrjMLbcRmVoYr73qdUCV	11441	3NKaUVLTMsRAtQeZzfzDEFNagW9gVj2YEVPiArMdCcBshpEwZt5t	1657	1344	162	6301	7869	jwMf58WBV2NDyLg1q4696xHufwaXrs8Fi8x2UBPCqysi4suDTfY	5832	8338	8338	1617440040000
11500	3NLiF5RfsppQmCfHbN8DEMtE3pxDMToA13k8sgPeY4XAzHgRw8sG	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1673	1242	164	6301	7871	jwxiy7hWQMroaSoWJFo1kMdCfwwMtCgf9D6TmAS3qiZFkLyojVq	5908	8340	8340	1617440400000
11505	3NLaH4QSqrVoBH1duPZ83EcLh3H7nGwCcr6e3JbtdbXYTDDKYXu9	11503	3NLUx69JquAFqP4M2i5gBDknJtK8dFfpzLkJZMsQgAyuqj9iE3jv	1623	830	164	6301	7876	jxy7nAhyPn7t7xc38zqY44jeyLYopF1w3yfEB7ji9qL97weJ3rV	5910	8343	8343	1617440940000
11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	1439	1033	164	6301	7879	jxgHKBGpJgjKYcmhAKNhir37b9nqLXrF8RfCoJrLvWzA4FgXQxG	5912	8346	8346	1617441480000
11515	3NLJr31vpSNBxXkzqQRsmWLLBpdLaCa1zvAshkqF6hXUEU12fcs9	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1507	1280	164	6301	7885	jwfgKP5mMsaqWrrkMTSLLfoarqoRucvmmECu2EmXZLhVjp3i2gu	5914	8348	8348	1617441840000
11517	3NLuduP2yMrufw17WXtiGoUsjCahmJCJ4BGwji57jDN79MGhN2Ry	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1471	1020	164	6301	7887	jwzyQZgiVZath3PFfiGW8agHWznS9Ae6romhkPR9UjqMLVRKygi	5915	8349	8349	1617442020000
11521	3NKFFS3kuerKNV4trMAWbYeutN8opc8TjkGkEF2MZGfxwCgDDjPF	11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	1407	1395	164	6301	7891	jxEf67F7tk18jUpcKj39q4icJRKzysuBkSv9AUVSSm6DYj3AdgF	5917	8352	8352	1617442560000
11525	3NLMDsUXoA39XKh9yYvbvKcvGo2idTpRs7uQLwH74w8i42dbbWUT	10950	3NLe2vTnYgxg4FMPSiwvrhng5BzXDA9yNepEpdJc4codicN1e2gf	1571	1335	153	6301	7895	jwFKn5JiHRiXDZJ9HLJeE71ey4UfXcAYBxjtE8ZJwfWBz3GkFkv	5637	8359	8359	1617443820000
11528	3NKS14q2XfLi2YqqYoc6dtRFgzrDZCzEEjzKVdDsMf1prSsq4GxC	11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	1407	1395	164	6301	7898	jwq93a5f6j6qTEHatRNaiy4eTehbn8bxKrVGRp5Szuqow9Rw2gr	5921	8362	8362	1617444360000
11530	3NK55Bwr9EaVoYhDUpe5XH5UmKJTYoet3czw3SE2ajVFMgBPykeM	11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	1403	31	164	6301	7900	jwrdjUefqDTQREXLiJP9QrNa8rGxB6skG3G2bVhKFgrmdrssgY1	5923	8364	8364	1617444720000
11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	11532	3NKcAx7KcsJX6jFLTK5z1K796teBzNKEbDAhSVnNCfyBziZKhjp1	1608	1289	164	6301	7903	jwAqKgx4vEKLBxdWdhSuKHTBKV4iRhw7uN9R7G1rQjcEBVWbh4z	5926	8367	8367	1617445260000
11536	3NKTr7kA2qHMDBRyYpToQgScjvP62JvUwgUnNtg96xL5zFFxVuVx	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1642	1241	165	6301	7906	jxZkxteqvQpkJTU5rfg5fxHqk7CWwiseSGG5v7MFrFeWdRMd3cz	5928	8371	8371	1617445980000
11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1564	972	165	6301	7909	jwioRNQLtvwN2ReWEukBZi8mNL24mDRtMcZNNGuURLKEWGjcmKK	5928	8371	8371	1617445980000
11542	3NK2upcz2s6BmmoD6btjtJqSw1wNdyM9H5tXSD9nmN91mQMe4vH8	11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	1406	1393	165	6301	7911	jwhJG6EuEWqR7RrHjfaYxasxs6Fs8b1nnGhL38QU67upZ4uoSQX	5929	8372	8372	1617446160000
11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	1477	984	164	6301	7866	jxKGZEaPHQW3BXAH4zaJgdkvse5QuEyrdxto5Vhxj792zdcei97	5905	8337	8337	1617439860000
11507	3NLeqJFanP3idA3RoBexjMmCNK5BakonZ11q37s3WvHoscoQXonJ	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	1403	782	164	6301	7878	jwShwEwPGGZbGuk25rCk8XFMuLDmHgsuHCvFsDT6F4aycoTojZ3	5912	8346	8346	1617441480000
11510	3NKhmSmfCtaysDv7XEjVpCEEoggNynDS5PbPHXo7cMma51DumxAP	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	448	1305	164	6301	7880	jxtfa41SeBuR7ke84tVySJuKJCBqy3G1CnZgjnQn7vW6rzgMaLA	5912	8346	8346	1617441480000
11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	1549	1116	164	6301	7882	jwHfCWW3YUyoi86hSWPNuoLxnLEt6ZPD4KmtUTh6H76CzFNLjT2	5913	8347	8347	1617441660000
11514	3NKUqLq3enFiAM6R6pAFNrchQFKAtVM6A2Fady8t1CNxdRnGQBK7	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1448	1065	164	6301	7884	jwWPiKqRym91QXLizKwgnYmbdJUiNq165sTQqtPmvLxq8MqxL3F	5914	8348	8348	1617441840000
11516	3NKFg74XZSPAfCwmsC27eJtqiegQuZZ6LJ1Y2kEXPFiEM4tc71X8	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1403	824	164	6301	7886	jxUFyK4ot9QuXMYMNLZdaAVVdgRRdvBwgD4M4qcpxTqJfngdL48	5915	8349	8349	1617442020000
11527	3NKea4DNqk1SDkCnoqSYXsH72GhDzGGi9hUpfoHyqer5FtcSN2gZ	11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	1403	824	164	6301	7897	jxSHJhXbxbF2ygnzgKmNraCrWtJTiiTfHowpJqAiVrKg9LEDDH9	5921	8362	8362	1617444360000
11532	3NKcAx7KcsJX6jFLTK5z1K796teBzNKEbDAhSVnNCfyBziZKhjp1	11531	3NKJCwBGAVgRqqqtqc1WRi4RkMeLJNJdfQLdmuB1PBeA8MkaH1Da	1553	776	164	6301	7902	jxaFnbFzaPHMxia8xLipkA8vgCxx5KjkVGgPwwgHUaiSP3q13yF	5925	8366	8366	1617445080000
11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	1577	1327	164	6301	7905	jwWyK66pvxoTTCQn5Hq8WRcPsMQaKypvYbJqsERJNGCyFJ1cxCk	5927	8368	8368	1617445440000
11539	3NLwmefiLM5aUiU7KZg5pjh82mjzxeFzhytmkJ1r728fcbZR3Wt1	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1518	788	165	6301	7908	jwrF9zVd5LDzje7mBgAc2s9A5khMLP4toQFZMGv3DNxerkCAzHh	5928	8371	8371	1617445980000
11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	1490	1274	165	6301	7913	jxoy1bCNhqbn7WXkpWLozhrg7pja3o8uw3wweKCW6hfAdPZU3Ep	5930	8373	8373	1617446340000
11546	3NLqT1VmRtenoSvMGgvamGBLKampVLMouBtQR5josHq257Crt2Kw	11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	1402	888	165	6301	7915	jx8ahbRb9uiBW2AvaK3oU1zbrikEogfv6GNWsucCnxVdqmQeQKM	5931	8374	8374	1617446520000
11551	3NKvMpMsNJR75riRJfFrkTBkESXhaoQbhMGeVjUXZhnJhnwDEvcw	11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	1670	1282	165	6301	7920	jxQTBSbKTk9C8UNqNAe4xpXPX7BkmgFdrkkncTj91bcTZD66Q4L	5935	8378	8378	1617447240000
11554	3NLCvDS7GPzzRMfPs97JvTwtkB25j8zJuv4vV3yokt8E8VUSo5zz	11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	1406	1393	165	6301	7923	jxtyMWSbjGfqa9Gfy1MeDUfgfNEx8Eg492sStDRMGXzVH6M6gQ6	5937	8381	8381	1617447780000
11556	3NKtjXRbs32dyb4vk2XzTbjPGiLgts46kFpuZ6BYFihkAR8qgdGo	11554	3NLCvDS7GPzzRMfPs97JvTwtkB25j8zJuv4vV3yokt8E8VUSo5zz	1403	824	165	6301	7925	jwUhFMYoB2qYwLudW43Z82N2S4npjA9mHx91UKfXLadtMbbbyLV	5938	8382	8382	1617447960000
11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	11559	3NL4KMGE2q5NxAxAMJgvaX71BiChpKpNk37QngAiGFHM13GnYbkW	1406	1393	165	6301	7929	jwU9VtKxDTzPAogz3T5rf5XdSEVkSgBMABxQuRCMVj2WNiqeQj2	5942	8389	8389	1617449220000
11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1518	833	165	6301	7934	jwfw13nL2ghMt6E6LTWSM8XR92ACz9BEFwx2Kym1TNfJXzGwQaD	5945	8393	8393	1617449940000
11567	3NL6p9tCgS9FG1MdUwwVzmxeNTxi8zYWr73JXmappXXgSX6FJgAz	11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	152	1330	165	6301	7936	jwrUbiR3fYPZ1gm1mAgY9PZx4xaUuV66cr2bH6uBhC1piqVdJth	5946	8394	8394	1617450120000
11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	11570	3NKbPaHK3m6DyaoTMyiJzVDRjhZqFaKsxSAQgeE9YcKe5ag9yTmq	1627	1139	165	6301	7941	jxDZUWdYLkTN35aBBo3VSLS9DwvHPH6mmPfjzuQ79rafdCXys1c	5949	8397	8397	1617450660000
11577	3NKZSwwW2BVqStXadrEDkz1ipaFyunAP65hdKg6X4CgmifDrDddc	11576	3NKCtz5AgqGC549Hiv3cKuzykrST4tj4ZENFXQQ4RbLuXrgekDJV	1617	1042	165	6301	7946	jxvjFWgFPzufrJcXLrqL5tX8vdEzFjqsvgX1PVHGSBF7DJPcXuR	5953	8402	8402	1617451560000
11580	3NKsTmCfUaY9RTNG69bzqekkuCRi96pUW6MkSpHNSxugeSqZXs7S	11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	43	1310	165	6301	7949	jxTv8RcBhq6sd5xYG8s6m7tekFogTmwyeGJQQkt4THKQfuFQTyP	5956	8406	8406	1617452280000
11583	3NKkr1UmQvDJSabN41QUHda8SqaECVBa4SDPWC2tx86FnotZd9dY	11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	1403	812	165	6301	7952	jwpy4XY2VQZYckzYpyf6VBV7ubp3822DsbrL46GENnWb76RV723	5957	8407	8407	1617452460000
11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	11586	3NL4SKoVhAQu1SXdQm1iUX4VuhQH6E5unwQngsyWvGZVjKvgYkQy	1617	1042	165	6301	7956	jxetfyuY76P8qbWf1MxqvLvRRqKfKoJQBFwXYXrxa2WNb8yrRmt	5960	8410	8410	1617453000000
11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	1460	1324	165	6301	7961	jxeqiXVsmyLSrSmYkvfkuMSj7CTfdtxxTFfoVCcABotDTSQW1ap	5963	8413	8413	1617453540000
11598	3NLLwp1cDU3ebAMe2M9AypxrXGqtVZBtNNLdjUyTJnTKBGtXsm5m	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000
11599	3NLHnyuHtB5Wuf9oZ1WupSh57kcVdQHGCrbfbk5DPwGerNRrxZyi	11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	1599	1161	166	6301	7966	jxseZHqncQx1vbL9aM5bHXhpjLnYR8cV63M8i8NAJWySzT3wAC8	5966	8418	8418	1617454440000
11602	3NLcGRnXYKRurt2nsh98eZep1NMT5sefzoXahmmeaCsmGVw1qhRV	11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	1637	815	166	6301	7968	jwLQa6pfPWz2Uc7RxFNPnmCF3GbSsBrVFiKp8qpiwALH5VaVnjh	5968	8421	8421	1617454980000
11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	11611	3NK8fhusfNnzT1VHP1NUXTedhpvPwKsaSQfPGobfwEzRWwN7jDPf	1555	1101	166	6301	7978	jxW6k6MEBP6j1YXx93NbUL8tgUYuZSwMJzJU7F75HG5S7Y1CPay	5975	8437	8437	1617457860000
11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	1407	1395	166	6301	7980	jxyw5THM9DAJAdgUkFd35TUnxLSgH6xLuHokbeGTsvSYGFK4UDN	5976	8438	8438	1617458040000
11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	632	1382	166	6301	7987	jxHo5rRvpBzGuexDonU6tUe5WR396WGhbbf5ELEHuhKbq1s8Nor	5981	8445	8445	1617459300000
11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	11625	3NKyyBtmpMKDG3ihbGq61qc5zTQ9iqAEqVMrqmUaepSMf1E1vtxG	1397	828	166	6301	7991	jxhoyPKn83h1heHmKsGL64geN9sReJ5UVCEiPxLTfhAwNv4RsqK	5984	8453	8453	1617460740000
11629	3NLefDVnhMcy8pHPgytFga9uv88PoxajCNGYNdjvq1h7ts8cztTh	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	606	929	166	6301	7994	jxNhsZHz8Uyd4rJ58z3vtH8nis6Gh97aNja9WDV4mykMhCZLPsr	5985	8454	8454	1617460920000
11502	3NKbzzmKKBedmcto7s4jvkRkemmJ46xjfVNjFSeemBGEh6nLc7H3	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1631	794	164	6301	7873	jxVG8uNffVJcKcuSKYLeK3EGtZfCqG28KStGTp5iN6u8xBSNVcU	5908	8340	8340	1617440400000
11504	3NKpFttN7k4ZZyUA8NxTWchovckzXauGrEmrZPdFo3nS4FWXH4qG	11426	3NKYwRrR4a1eQdVbz3orankYWMQpfuei8CEeYydB5LkH9mePZECo	1527	1047	160	6301	7875	jx9jgBsQnhrR8M2fKr6nMZbt5cT5Q2RZE2H1iKeXDzJgMF4UuNn	5793	8342	8342	1617440760000
11509	3NLPbCHQX38zU3Um2Nuw3PuChXcYf9NMUBDJNZHMAKgMCEPDLLU1	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	448	1305	164	6301	7880	jwimx1AAfyvDaG8QYkaHi4yvZHvyHqxSY8CzTioqnEdAzHaysi9	5912	8346	8346	1617441480000
11511	3NKcdBJQdsDoKn1trJhX2Yce61kotrS5eYRDCDKx69dbuK4ZVYMG	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	55	59	164	6301	7881	jwcF5j5VsLmPfgWPCs8KsyFuEGLrA5pSb9xxdnNpYEzgBvEMdc7	5913	8347	8347	1617441660000
11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1426	1364	164	6301	7883	jwjRsRsr3bpD1dPNjwUS7cbv57TZhgJzwiBZXhCj3R1a9MaBFQX	5914	8348	8348	1617441840000
11518	3NL68wR1Z1yEtHyNtE3hdUChCe8ibaoofb6UPSchPgop8YcqLeDK	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1419	814	164	6301	7888	jxidLpjBTJFq79YthAwFmm7o7xhUqA1HK4VWkaCKdBVqF9Q2KPT	5915	8349	8349	1617442020000
11520	3NLqDXU8YtvPu7GKmnEFvwNK6pUkB5D6B6dcUfvxN5mA69inwYtZ	11494	3NKtz9SbjahZh3tAg9pDqDk9qXXdHJdwykP1HHc5HKETB6e2VGNt	1458	1077	164	6301	7890	jxRidqPb1H2EeUAiSDGg5FSzs2m6X6sTDjCCGgiRWVQ7ihfJs1u	5906	8350	8350	1617442200000
11524	3NKrJa1seRRyPQ1diKTbs73zbnuTATrMDakZUxjfiYFuZh3MF9JT	11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	1654	1340	164	6301	7894	jw8S4g3pH2acZTt9Jg1BDffWP9aEtaV3xdU2G8Dho4DEh8Bk3Tn	5917	8357	8357	1617443460000
11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	11523	3NKKFU9mAuapfKzXJbEwzpP9FbTh4cF3GDhykLB2nFKtLszQ64h6	1601	1388	164	6301	7896	jx1MYbiLQ8ayGEfnYJKe9qoCiKxs7wiRkf5VowjmJbVXsq5fyMb	5920	8360	8360	1617444000000
11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	11527	3NKea4DNqk1SDkCnoqSYXsH72GhDzGGi9hUpfoHyqer5FtcSN2gZ	1624	1208	164	6301	7899	jwieRTMNUbXqLM9XZiP46ej178b8YF2WpDkRQxLeVMPX9nyPnFa	5922	8363	8363	1617444540000
11534	3NLU7QPwMuQ6MaB8KbQoRrceSpLxFi7scvegbSJYK8bRLxqRYi98	11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	1407	1395	164	6301	7904	jwDCre3vZWE1KJS3HZuVELQhPtDjPuqVYQBXcoCHqXruCeqQciC	5927	8368	8368	1617445440000
11538	3NKfqamq4p9XjFEZaYhYxLBKJiTaWwKn7FeTRTn3L9boGgm5CPL2	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1407	1395	165	6301	7907	jx8WGnpzVMj3HW4QvkucYN3TKbCctJSAMvo24emDR3qUqfhQqSv	5928	8371	8371	1617445980000
11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	1407	1395	165	6301	7912	jxgpRAir2JF2TwgaFwZyneU65TUYp7BDq9gkjhYTc3eRDk7sLEh	5929	8372	8372	1617446160000
11548	3NL6NcYtE6NXLbDtwbGCiz2ir3H3rRp5ah9WsSQi3RmqVgKgeZZD	11546	3NLqT1VmRtenoSvMGgvamGBLKampVLMouBtQR5josHq257Crt2Kw	1647	846	165	6301	7917	jy1k3PzLREQXijVAvhYwAoDx8eTabEwwGEsegMqVMhDhxBgmdTW	5932	8375	8375	1617446700000
11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	11551	3NKvMpMsNJR75riRJfFrkTBkESXhaoQbhMGeVjUXZhnJhnwDEvcw	1457	1391	165	6301	7922	jx5T6nByBjGcUG2ngSvVU6xBYQkPpTYVZ6V9Mf2FCsGkgzvXnxr	5936	8379	8379	1617447420000
11559	3NL4KMGE2q5NxAxAMJgvaX71BiChpKpNk37QngAiGFHM13GnYbkW	11558	3NKeNpDM5qTXrYQUk1KacL94CBZSU4FRkbbDBTeiWsFQDuQUTXjj	1673	1368	165	6301	7928	jwPmh7Z27ki5AjA5FkQf6LrQXyCCoXkVPLWQbrGgwamYbGG2WZw	5941	8387	8387	1617448860000
11562	3NKMVLMPqKSnp6b4CbwPFT9tKetEqxtzDV7rXkWbAP9xqVoSqzRj	11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	1631	794	165	6301	7931	jwY833owVtp5B3NeaY85o2KRuPkeeqcZU3bzAMHHLMZaLBJmKAq	5943	8390	8390	1617449400000
11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	11568	3NK3N36wt3HZXNRSjiWsUbRbi1H1mzZ8FyXRWCUy6iPvZ5FxwRfm	1534	1317	165	6301	7938	jxP4hVq5sZX5q8Bz9WS9pjyrjRZFZkvN22bRCiPG46zV9Cw5v9E	5947	8395	8395	1617450300000
11574	3NKKKtsLzvp24Fc4fiRW7Y8WWSGghvkX2mLeRtrUAV31gZkseUmF	11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	1579	117	165	6301	7943	jwKME8mJRg1fiCYJXj63ppGyKPj43Y1XmgRkZgftKoYZLtnohiT	5950	8398	8398	1617450840000
11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	1406	1393	165	6301	7951	jxtcoXvBogAUNk61wtrmGu9d25VW4YCqNgGKemwCEbyLPnHk8VV	5957	8407	8407	1617452460000
11584	3NK45ebuCBHGDzn5VNnrrZubV1grq3oQDTaES8SaX2bDiRGDHsgx	11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	1406	1393	165	6301	7953	jwsEHkazdrRoTu3cjziyjUQYHCZQrdEh975dCfYoAdrCGSaZYwc	5958	8408	8408	1617452640000
11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	1403	786	165	6301	7960	jwxKii1f5HpXyC2SgiNzMFoCLMmgjmJsZRwb79wqcsMTjDo89rq	5962	8412	8412	1617453360000
11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	1489	1254	165	6301	7963	jxLUmVDFySB3tgZsiDaUq9qS1RJ9eQXTmuPoRmFL3vFGb1BTsv2	5964	8414	8414	1617453720000
11597	3NLg9CLE3zLzZGoADAmwEL5b7QLTdUHP8kFt3W5KonSd86BGN5h6	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000
11604	3NK85Y125yTDYhW77QuCUG6etPVmDZwHFkp5znXbgL15A49hZ49o	11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	1573	952	160	6301	7970	jwiQaNw2wjPi3FYgTb6RiTZXtuxskV35SgsfGbU2vZnrvZ3r8fY	5818	8421	8421	1617454980000
11607	3NLRMVN5PXpbjG6NpNcX91RaBvBPDkqQxF3cx6tqx88CUeSHrYab	11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	1607	1348	166	6301	7973	jx4vyNNCkaX532NrzSQbknRPqfCCQC9PwQQiLqseREwGqnZqCk7	5971	8428	8428	1617456240000
11610	3NK5X1RvTzKyXbDDKYypWXLoteBVxoQeA93CeNfvEUX4u1bteqf1	11609	3NLKQ95aLbYbFvDMq5e7yuZEqGNwvUGKbjxPs16mkVWDBhrb9Kv8	1529	1070	166	6301	7976	jxsDd6EXJKUL5RJPycpaTvzvdfH5kvZY6xD5Uwum1iQsTnbTxjp	5973	8432	8432	1617456960000
11611	3NK8fhusfNnzT1VHP1NUXTedhpvPwKsaSQfPGobfwEzRWwN7jDPf	11610	3NK5X1RvTzKyXbDDKYypWXLoteBVxoQeA93CeNfvEUX4u1bteqf1	1509	1074	166	6301	7977	jxaAovessCCdLcScVQcqZ6FkxsQpa5HxREsKXNfayrcm2MXBL3d	5974	8435	8435	1617457500000
11616	3NLMeQYwqQChz2hK84vWLBuE6LK5PKzbmP9xFxeATLGnFUJypGL8	11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	596	1060	166	6301	7982	jxfyJBgFr1qed33LFxaXVt5s8DdLdvRWfT5xfCNQJgz1E6y595t	5977	8439	8439	1617458220000
11619	3NKfMZq5RQ7rQf1ziXXkHKJ4QTCkVETHrZZeWU4JupxHMqFRgAdz	11617	3NKjknW994x4ziAkzY4W9X2vwGtGtpB3AyTkKnQ6fH8YFpHoHqyE	633	1384	166	6301	7985	jxCJirC3k4Zt5BEigv8oLSf9fwCvCgsdMDzDdXtebYnBa5iFrGs	5979	8443	8443	1617458940000
11624	3NLkoTp6A6YV6nyqMuaURy8MMKTr7xPjCes8hpC9kHJtFLfv5geL	11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	1406	1393	166	6301	7989	jwmTYuYB2Sy74gutmcPpup69Kz73JufyNnHJenrktF9gP5pATxi	5982	8447	8447	1617459660000
11625	3NKyyBtmpMKDG3ihbGq61qc5zTQ9iqAEqVMrqmUaepSMf1E1vtxG	11624	3NLkoTp6A6YV6nyqMuaURy8MMKTr7xPjCes8hpC9kHJtFLfv5geL	1513	1379	166	6301	7990	jxXAaagQG2Uv9cLGJq7JXFHrKHw4evYFqKAcNRzS7WcSx2DStUU	5983	8451	8451	1617460380000
11503	3NLUx69JquAFqP4M2i5gBDknJtK8dFfpzLkJZMsQgAyuqj9iE3jv	11501	3NLNRGxNTueGz6Z5VFcqxSC7DxwHvifJ1i8P6z9pCwS3Z6VKdZXS	1527	1047	164	6301	7874	jwQNEkKjLwS4EqYPfKjq7gwnyu1F94Cx4KC9R6DgsE6CSKU7T3a	5909	8342	8342	1617440760000
11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	11505	3NLaH4QSqrVoBH1duPZ83EcLh3H7nGwCcr6e3JbtdbXYTDDKYXu9	1445	1290	164	6301	7877	jxH9guCcTzTqWmz5BU3ukvANKhjZPkZj2Psh5givoZCBGz5KH2L	5911	8345	8345	1617441300000
11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	11517	3NLuduP2yMrufw17WXtiGoUsjCahmJCJ4BGwji57jDN79MGhN2Ry	1458	1077	164	6301	7889	jwJc9xppaoBbosk1FdnYGi311LrU6J4GezyUkEjuWFh25XBknZY	5916	8350	8350	1617442200000
11522	3NL43wobX3syU3SiajooxkLiMNQGh1ERJARHDiTgHVzL296SChaE	11521	3NKFFS3kuerKNV4trMAWbYeutN8opc8TjkGkEF2MZGfxwCgDDjPF	1407	1395	164	6301	7892	jw82AeiJJxK6cF5WVmGbjS1DyyT7tUm3tUuZ95FRVeVKPrZTW4v	5918	8353	8353	1617442740000
11523	3NKKFU9mAuapfKzXJbEwzpP9FbTh4cF3GDhykLB2nFKtLszQ64h6	11522	3NL43wobX3syU3SiajooxkLiMNQGh1ERJARHDiTgHVzL296SChaE	1654	1340	164	6301	7893	jwpcNW2Csj5WidJ3R8iiVJiLyLvC7nUUn1FXZJPJuz6TALmDG8Q	5919	8357	8357	1617443460000
11531	3NKJCwBGAVgRqqqtqc1WRi4RkMeLJNJdfQLdmuB1PBeA8MkaH1Da	11530	3NK55Bwr9EaVoYhDUpe5XH5UmKJTYoet3czw3SE2ajVFMgBPykeM	1609	967	164	6301	7901	jwzM8pM46kt37fvuqWfeUmU1ETeBsn5g5e5j3dgNxEFKoTrdF8E	5924	8365	8365	1617444900000
11537	3NK9gGNzD6krwEt21eCUZENup2jnh1t1ceh6oC5DBbSHUYb1xGXk	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1642	1241	165	6301	7906	jxVfDkQMbMM47HZP7AYLjpta5HLNfMSLYXLZgwVSufKLaLrdyo3	5928	8371	8371	1617445980000
11541	3NLXWPr1XZpS9CX2mnCBoFqHmUM1RSv9RoTUxnRERA2YXY17Weda	11534	3NLU7QPwMuQ6MaB8KbQoRrceSpLxFi7scvegbSJYK8bRLxqRYi98	1518	788	165	6301	7910	jwop9VX6BRP9y1V7UHitFrJXxm6kxgdJjm9cPCCnE2AKCZ5xNKV	5928	8371	8371	1617445980000
11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	11549	3NKVb6jfKRAuwBxcXUcBbQiKHcw1u2dSUh8SZpFMvgZVLqwDDofq	1403	824	165	6301	7919	jxDoUAeV7fZ4magEM1vFkPkmhkL56gVH4ex4eaRntBKeLieyemh	5934	8377	8377	1617447060000
11558	3NKeNpDM5qTXrYQUk1KacL94CBZSU4FRkbbDBTeiWsFQDuQUTXjj	11557	3NLp1VkLzdLhMyJuvBPFMSKaGpf7NEvHHbDdiqt2iBHFLch367c7	1622	1230	165	6301	7927	jwJGBPH2z4bD6dKeHXwYxUUVveiaDsbPrjQNNsYHRtMaH8zzACy	5940	8385	8385	1617448500000
11561	3NLffmAVEstfV1GW2vGHmS6opCqn3RhEUjtrfThH7U5RkM42JKyF	11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	1483	910	165	6301	7930	jwMXiynE2yvJCKCbEPwHVPsbXRBzJD8mQTwsnSZufVvJ77mYvFa	5943	8390	8390	1617449400000
11564	3NKpwvRQV2eyayKoow87UDLwKfu6Qxq4asNxrJEyxA9e4PtybFYt	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1406	1393	165	6301	7933	jxT64e8g9SLnJG14DGLbS7f1dcEegstJkyVYRmqdr6A7Pt8P4wz	5945	8393	8393	1617449940000
11568	3NK3N36wt3HZXNRSjiWsUbRbi1H1mzZ8FyXRWCUy6iPvZ5FxwRfm	11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	1637	815	165	6301	7937	jwfmYyVZL2KPcva7f3iqaRFbpeTmsFwLidX2R9LMEadjW2yUthr	5946	8394	8394	1617450120000
11571	3NLTowh3NHPndRZe6n8mgCJzdvmQ6NURodjrZbq92nWUC5fqC2nf	11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	1631	794	165	6301	7940	jxPGmDmLJB97QJkQjMFkvN4gncxAhWescF4eHdmd36iNmFPFp2u	5948	8396	8396	1617450480000
11573	3NLDbpV3sC6RNYi7iWMou4qURPsxSeEbJ2fC9UrNGoL8TaJHSErS	11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	1649	1383	165	6301	7942	jwNY3SXjsLtJjHgdWLgTgUD5yn4VJnbBoTgoUf25AUrwBepRFH4	5950	8398	8398	1617450840000
11576	3NKCtz5AgqGC549Hiv3cKuzykrST4tj4ZENFXQQ4RbLuXrgekDJV	11575	3NL8ua9XF41u8yED4YtUVfoC6cppMNsaB6Ts76uKouUXEAQ57ArL	1476	1125	165	6301	7945	jwjRPcRypJq3CrrErw13AKvL7CUtJ4WK4Cx7kFP7uFBfDErbpqn	5952	8401	8401	1617451380000
11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	11578	3NL3EcoGCE5B8VjWerRz88cSUWUd1o8kUX5Ba5pWcrowBqC88jQ7	1407	1395	165	6301	7948	jw9NKfPno8AmC1mZ258jUpBjXoPajisgpiUNXyzorAfi8NXnM1g	5955	8405	8405	1617452100000
11586	3NL4SKoVhAQu1SXdQm1iUX4VuhQH6E5unwQngsyWvGZVjKvgYkQy	11585	3NLgCU6ZVXFqUzqrEtb1XCgTgg1AHu65zVeSh7wYcsWLm8zHYVf1	1406	1393	165	6301	7955	jwAejpFKyXYxuZSX18qKMmGb2GWav7DfFQnES9JepRMpwpGeEsg	5959	8409	8409	1617452820000
11589	3NL4XRwmuY7Jb43Ao528aANrAEmuAESFghkHXhFcDMCK23a5Pkpf	11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	1476	1005	165	6301	7958	jwajt3UJXi2fA2sSxtihd7AFo3YHXSRjKZ6hxiZBuCJiG5venF5	5961	8411	8411	1617453180000
11593	3NKcTBiFERPykAm8Nq1MLsmJsTHrpnBp8f3V6hZuwAEtNK1ChuJm	11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	311	1061	165	6301	7962	jxkGA7esM78dHYAdMXn5zJ2cLgcT7dVAs4gK41MPBgWXEeXHzXb	5964	8414	8414	1617453720000
11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000
11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	11600	3NL5AEXkAF2Pz4mzSRHNFgQdv1goUumr4g9TZNKyq6EY7Zv9rReS	1553	776	166	6301	7967	jxZeMou3k5KUk4j5KBjtF1o4MonzkKyWHH4v5kjGbNKeS3o4oFD	5967	8420	8420	1617454800000
11603	3NKXmEVJ3xydkW7KmS3tuFBiqjVfsZ9MjhxMbghtabNELwaiCUwS	11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	1501	1234	166	6301	7969	jwUyQhNF36T282Agh2RdQkN2nWhriTW9fJteTjEo7USbmwTJ49e	5968	8421	8421	1617454980000
11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	11605	3NLvAvR3143DdVdBn3WpKaNdw2xbNBxMfKoUXdYuxckMzJP3aQj6	152	1204	166	6301	7972	jxXdBXEQKUhDvKmoSS4s1yqSeah96TrZfueqRv6LuVuAMwhrcmv	5970	8426	8426	1617455880000
11615	3NKJHtruoL799iQoqJmRL5yBafC5F9cqUBSk5KYjzZhPJTtburdB	11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	1589	920	166	6301	7981	jwigKMZFHVvCZoDqTHHniVoakXEi2e8vpvUsV5T1Kn1fYtf28dy	5976	8438	8438	1617458040000
11618	3NL68o4ghwuus2NGuQvZkbY4N6Uqubn669NEuEzQrAJfNHEcEfuW	11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	1419	814	166	6301	7984	jxnQdcFkf1wbUpZxfEcSdRKHaQkGvPJKmStYh3LZpms4v2PMXQU	5977	8440	8440	1617458400000
11621	3NLEw4qonPzpbjHL5s8YRyeCmrQvbnuRhnpteeU3Xca4ewE82Wo4	11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	632	1382	166	6301	7987	jxWKA85U1r4U5JtruQDJswnvSHeBVbKix28NbRK7CE6gmM4snyc	5981	8445	8445	1617459300000
11632	3NK3Pvk8m9CrF8XDT5KWQ6tPPbTonR8G6AejVLhSeeSUYc11pbw9	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1611	1341	166	6301	7997	jwrJzTYMDykuXhf8asfDrvQUTN2XHihCUFqjcystpskA3DhBaJm	5986	8455	8455	1617461100000
11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	11630	3NKxYYHGgrw3DhG3hUzvAPcGjGQ7F3n1ZGrKerakwFDFtU5qSzfx	1458	1077	166	6301	7998	jxQfyKdS7AXVk9vi4GH9EB5CL7X6EQhCwetYEQodCKNX5FD1cWM	5987	8456	8456	1617461280000
11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	1541	610	166	6301	8001	jxPbR1Qd2A9PFUh7piYxbuL514X2KY3Ab9ngQyhoiCwkF7aEc6q	5988	8460	8460	1617462000000
11644	3NKkUNuKaHDbjHhRVWTZREa4TMAFDhzeuwfqxN9ahQ7CgY2B5pW8	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1451	1292	166	6301	8009	jwLjMeg7qdNq3HtPwYcTbGf4EcpqQvS99ZwadHhhwXp2cwwjVVa	5992	8465	8465	1617462900000
11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1609	967	166	6301	8011	jwnEcr8tK9gfyk4tYHSvzTVFqEoXHaVgakNhj8xb7ZdnCKuNFaF	5992	8465	8465	1617462900000
11545	3NKoUKftpYBHz3sA21VKoXPFVpoBRurRLMWxBa8QwM5dHn1RmqwL	11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	1402	852	165	6301	7914	jxqTXRRwxVk3wJ7JRyG68raQcGcryVV3qwXzvQuEfZD3e2vPgZV	5930	8373	8373	1617446340000
11547	3NKuundzfRqhZ3Azn85BkCREbXox5T7Zh6hRoyezs2DY5xmvMMmi	11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	1577	1201	165	6301	7916	jwMHH9YBrjkfd7KtT5jfQh4sqRZhyfStwHPuNQwGdeMMawqDatP	5931	8374	8374	1617446520000
11549	3NKVb6jfKRAuwBxcXUcBbQiKHcw1u2dSUh8SZpFMvgZVLqwDDofq	11548	3NL6NcYtE6NXLbDtwbGCiz2ir3H3rRp5ah9WsSQi3RmqVgKgeZZD	1602	1369	165	6301	7918	jxWxFg8Facwj5tDDz7kVG9ihxNN5rcLEhTdhTAAJapgCxbU2RxR	5933	8376	8376	1617446880000
11552	3NKB19tMzbhVmHyV2aqbFH4mB6oyLsVHxpynZ4iyg1SohDjn5Pzu	11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	1407	1395	165	6301	7921	jwx7sbuzjj42vmZ8AmXsX6HKNt6CsTLwprw24qu4p7a4Az5zUrW	5935	8378	8378	1617447240000
11555	3NKxiMb4r9PSfAPnVgnY1qE37pWtsK2MN7syvBnaAsByyuUDVJwX	11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	1461	1271	165	6301	7924	jwV3wucmtD8pGpavKY6iRE5VQzgP4wTGunFDUKueWr26YZjwdG6	5937	8381	8381	1617447780000
11557	3NLp1VkLzdLhMyJuvBPFMSKaGpf7NEvHHbDdiqt2iBHFLch367c7	11556	3NKtjXRbs32dyb4vk2XzTbjPGiLgts46kFpuZ6BYFihkAR8qgdGo	1451	1292	165	6301	7926	jwQS681W9s8Dw7wFpFZkHpqohKL63pHF7mN4fncshxbJfJJ88Lt	5939	8383	8383	1617448140000
11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	11562	3NKMVLMPqKSnp6b4CbwPFT9tKetEqxtzDV7rXkWbAP9xqVoSqzRj	1525	310	165	6301	7932	jwU7wL8CEPHBfDoo2fe1pPbvtdhgFzTyainwAuv4ZT4DV7ah3Uz	5944	8392	8392	1617449760000
11566	3NLE3CgUDHdFE1Gz9Q1cVrneh7Cuu6drM5w485LBCbDGCCcfZdPu	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1631	794	165	6301	7935	jwoC5GepnJJDWS2dsN7MjRmBg5PSJHyhtQxDJj5idQd2jeJbX51	5945	8393	8393	1617449940000
11570	3NKbPaHK3m6DyaoTMyiJzVDRjhZqFaKsxSAQgeE9YcKe5ag9yTmq	11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	1613	1103	165	6301	7939	jxBRp6CPctEbA9uTWwtDCzzrcLw7ptXPzhJvsRTgnqoxqJARoeQ	5948	8396	8396	1617450480000
11575	3NL8ua9XF41u8yED4YtUVfoC6cppMNsaB6Ts76uKouUXEAQ57ArL	11573	3NLDbpV3sC6RNYi7iWMou4qURPsxSeEbJ2fC9UrNGoL8TaJHSErS	1611	975	165	6301	7944	jwRYNpTRtSrAGLR59ufX2RatNcwighzHYxyYkZDSCJpmxdrRy62	5951	8399	8399	1617451020000
11578	3NL3EcoGCE5B8VjWerRz88cSUWUd1o8kUX5Ba5pWcrowBqC88jQ7	11577	3NKZSwwW2BVqStXadrEDkz1ipaFyunAP65hdKg6X4CgmifDrDddc	1406	1393	165	6301	7947	jwoPkN1zruqRViKktecMNcDcFu5G1fYHTi6J9nb5sHZPeWDTRDE	5954	8404	8404	1617451920000
11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	1509	1320	165	6301	7950	jw7ZjDfN5ApYh5KmumJSBdnoK7XDVDjjYYjnYcUwm4uooiBraji	5956	8406	8406	1617452280000
11585	3NLgCU6ZVXFqUzqrEtb1XCgTgg1AHu65zVeSh7wYcsWLm8zHYVf1	11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	1471	1020	165	6301	7954	jwb7JeMN8EGeLodRgZYB93aLV5evC94aiJ7yG93eDubfb4CP16b	5958	8408	8408	1617452640000
11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	1473	185	165	6301	7957	jxUbc7CfFKzpGkfhEDd1yw15QPGj6KUUXjnvBFJ4qGDXfUmmxDt	5961	8411	8411	1617453180000
11590	3NLvh9BZ32wHBeR1N4RJkRBBwFgGCKaWrL1GSKWzkQPz9udfQ2CC	11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	1649	1383	165	6301	7959	jxmwnfFNs4sXWigY3XrrLu55v9nedgLaSk5rovQe4NjnTaPwMoe	5962	8412	8412	1617453360000
11595	3NLVk3L8UzXjSqtN9VDcM6HjkQ8nWA565LbGM5fYSifEHbqVY8Yg	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1406	1393	165	6301	7964	jxuAKU2mKyDzQksj1hhtKyqEzhGpqEEcKrkPtZfKnrR1MencPXG	5965	8416	8416	1617454080000
11600	3NL5AEXkAF2Pz4mzSRHNFgQdv1goUumr4g9TZNKyq6EY7Zv9rReS	11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	1599	1161	166	6301	7966	jwYrNT45J346YLPvihkX8oprde5yRBpTmq1cfhJDpxZocPTB3U6	5966	8418	8418	1617454440000
11605	3NLvAvR3143DdVdBn3WpKaNdw2xbNBxMfKoUXdYuxckMzJP3aQj6	11603	3NKXmEVJ3xydkW7KmS3tuFBiqjVfsZ9MjhxMbghtabNELwaiCUwS	1406	1393	166	6301	7971	jxzz5dhJH32buy4JN6nhoSjZrX3wdfGooxYoknk7dNBeDjb2j14	5969	8424	8424	1617455520000
11608	3NLSALLUHZDjusCLi8g6TMTUis5cugUQBkcwsxm2nsdAPTyYMW89	11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	1602	552	166	6301	7974	jxMEoNVawJ9UvsXttHtp6HfrAow3BeuH8qb5PrBnSGbJC1eZ8sJ	5971	8428	8428	1617456240000
11609	3NLKQ95aLbYbFvDMq5e7yuZEqGNwvUGKbjxPs16mkVWDBhrb9Kv8	11608	3NLSALLUHZDjusCLi8g6TMTUis5cugUQBkcwsxm2nsdAPTyYMW89	1637	816	166	6301	7975	jxNM6M4xUr9demFaASHrr954ArHzbtUxUfG9nv8B2eisuujFeoF	5972	8431	8431	1617456780000
11613	3NLei58q5i8p9AGVMJdPJTfKPEQvLw85vcZuEdarfQTiQDZ2wR9a	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1585	1000	165	6301	7979	jx45fT5fdzMM5UEfqcuF3ABDyx9vyt4yEeAu1sx6ykbqpFaZL4S	5928	8437	8437	1617457860000
11617	3NKjknW994x4ziAkzY4W9X2vwGtGtpB3AyTkKnQ6fH8YFpHoHqyE	11616	3NLMeQYwqQChz2hK84vWLBuE6LK5PKzbmP9xFxeATLGnFUJypGL8	1642	1241	166	6301	7983	jxW3Yz5z2iDK45Novrjt4ygCLZTBNQaSYM1jjDVErZhaezKHCT8	5978	8440	8440	1617458400000
11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	11619	3NKfMZq5RQ7rQf1ziXXkHKJ4QTCkVETHrZZeWU4JupxHMqFRgAdz	1407	1395	166	6301	7986	jw9MoC7pDJ46zLy4K5aUC3KpyXCCM6UGe5GwnaQqCTFNNaLRL5e	5980	8444	8444	1617459120000
11623	3NLEAn7EzAz5ayi3ZbNLUPo88kNrbd6MXaFkFtZh4tqd1EbgzwDi	11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	1407	1395	166	6301	7988	jxZzm1XZiQKaX59u8Fh2MDfkQVQYrJT43cWkcyVz7vRvfdxfBQU	5982	8447	8447	1617459660000
11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	1668	1370	166	6301	7992	jwZSoUgWAGzgWT6Rxp2nzAQ6WiTdQtdpabzeVveQA87faYqyNte	5985	8454	8454	1617460920000
11637	3NKpCw9DTarE7VhFatwMgbDbMzNYvQpZec9XoHBvJi3XdSnuVunu	11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	1406	1393	166	6301	8002	jxVQ5hQGar1D1jMAgvCdazpY5uBeP6EFnYKoiUtSrcnCQW9YxAq	5989	8461	8461	1617462180000
11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	11638	3NL5ixrNBYfSq3nfjGHPtRjJ7mwTLe6gxG5zJgn9apbjSFmwftk2	1594	1200	166	6301	8004	jxLj75womHa5abWMmArR6wJvr7Kehu8ZPUbgAk76qRGaNN3cNGU	5990	8462	8462	1617462360000
11642	3NKxTTJGHnZXUK8DsAnUtRRaDaRMLnqF4aKdJCSxpGYDgqSK9pGf	11632	3NK3Pvk8m9CrF8XDT5KWQ6tPPbTonR8G6AejVLhSeeSUYc11pbw9	1451	1292	166	6301	8007	jxhLRaS6eTzxrF2vSLiK19YvZrTH76z5U6AD8T8TFCarBrPraqx	5987	8465	8465	1617462900000
11645	3NKCLG86TRcXJtvoF727NKKVLiUaY7h9m6fBecySN4ms2YqDwrVA	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1624	1334	166	6301	8010	jwYLGHmQjFVx65huyo5U5jVYhDgA6dzyVzAhWbZ2oXTambsajgC	5992	8465	8465	1617462900000
11650	3NKEqqKVT5CJPqRjuoek4min3rMHCKP4HMAv6gdYXuTEZk1AYypd	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1476	1371	166	6301	8013	jwLQj8LnbaSzV11SeqMWd5cApyvKeKV8rZ9vTiAMDVHZj619BLD	5993	8467	8467	1617463260000
11655	3NKnJKWptRuN52Lir8NxvhWjNXf7nrndrM5TLNbZtxc4i3MDL2rL	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1631	794	166	6301	8018	jwLXLbsyyiZweXkqkrNTULF8k5wWjWmxUMPrdUTwWranazN8CqB	5994	8468	8468	1617463440000
11662	3NKG7bg2iZJqQ5eMEagT4wZfmNqeJBDpfUWVhF56fDoZpCY1o9id	11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	1623	839	166	6301	8025	jxnZaaKqogvEUtQSDYXzHnYydPNd6mTioX6Wcpc7HKPyuiw27Rq	5997	8471	8471	1617463980000
11628	3NKsitUgm8GQ1qneYueSjkDxAmq4dFWnc9xoZprec74CgRcBtqLs	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	1444	1135	166	6301	7993	jxnPzmXVzYEdz2WuY6VwfZqBnpymTMFNMsYyTes51HRidBcq83Q	5985	8454	8454	1617460920000
11630	3NKxYYHGgrw3DhG3hUzvAPcGjGQ7F3n1ZGrKerakwFDFtU5qSzfx	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1447	1345	166	6301	7995	jwNJg7FHk2qNFA4saaYneMcJV1FKbfaGx9cihiiy7aaE9wQgfTb	5986	8455	8455	1617461100000
11634	3NKjX2arrZwCiyoG2N4E3r9Z4GhnnzFBJr4HDp8WBBYf4yrUHVBB	11520	3NLqDXU8YtvPu7GKmnEFvwNK6pUkB5D6B6dcUfvxN5mA69inwYtZ	1458	1077	164	6301	7999	jwkCaXyWxRSeXdzyQ5oiA4uP1x3rXzpLPtgpA7joT63CmjYfVqG	5907	8456	8456	1617461280000
11635	3NLp7ewDp4RFjTy6vD2BvjaJfm79MNCxXkcrygUoq5saZheZh44n	11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	1508	1141	166	6301	8000	jwFoHjebgGZWYWnpvKAGfbQPsqPwri9UEyyH4FdcVzpdortBTwT	5988	8460	8460	1617462000000
11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	1649	1017	166	6301	8005	jwPZRKsn2hAsgQaSwEBMbtGRjx1Ga2WJAhe7ZBCirdWqtktqFs1	5991	8464	8464	1617462720000
11647	3NLoc55eZQKWyeRMJhMJUQZaPLzoR1RwxT83ymzphgP3MwhdVwgD	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jwusx4NdUC6M8Ft2rDVwpSsWTXvJwQH1LD7yAzQNx1iXZx68Sfg	5993	8467	8467	1617463260000
11653	3NLhtz9vfXnpjQJNwRRNBTHxgpPwB55zJW2rbbehmqCNwf8hjf1x	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1406	1393	166	6301	8016	jwRMFhpwacCZKtwai7rAZEUfYVVEfZC4pfjqNRcL68EFTAXS5yi	5994	8468	8468	1617463440000
11660	3NKnkLnUkvZUQXWBaGoqHmVFDh1QUc9xiokmVtdHkE2FUNsNRNwS	11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	1458	957	166	6301	8023	jxA6Wmk9TLLZesy299CHyhBEpipFdWig6nUgUQvCgBhDUQgtjvD	5997	8471	8471	1617463980000
11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	11662	3NKG7bg2iZJqQ5eMEagT4wZfmNqeJBDpfUWVhF56fDoZpCY1o9id	1508	1021	166	6301	8026	jxppAeC7fMqii28iUUZ9VcUSf53SMAEKgzgqL9hRaMf57wSkk8A	5998	8476	8476	1617464880000
11670	3NLB5N3J1YRfqwixWGmMiYPMNcRCR6u7as6VAXW8XnXVpubMWhA6	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1407	1395	166	6301	8031	jwJrupFrxrJth2UWR7aTKBthRCeg9tucudb9oahueFTREm64qh7	5999	8477	8477	1617465060000
11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	11672	3NKXfDdNo4Qs34MgxUVEwKq5gxPgxExLD8aSVU3gasXfxetAZ2Bq	1406	1393	166	6301	8034	jxem7Jw6o8L7JFbcGmKgGggSTRDBWMsL9zBhQiXFgnWGHN19A23	6000	8478	8478	1617465240000
11675	3NKYQRPcvRzfdxYTve2moiYVdEFHKw3K259MYQZZTA18V85N9b8u	11674	3NLWnzv1geb6JZ9s54qiSe6afSyAmGrjpkgmLeCUVtf7iUhWHG78	1407	1395	167	6301	8036	jy1QBPxQqUJbA2nLjrnBYs1VXK6TxBEq5v4R4tGowNNt3zbzasm	6002	8480	8480	1617465600000
11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	11680	3NLQ4ZWZWnWK3wE7YtM4zVhVLQbAEEyD33gh5zvdaQ7HKREKySch	1407	1395	167	6301	8042	jxdrboJw7faeK7be2bQeTYr4kRrTQQzryrLwtd87uSUmmgY3TLN	6006	8488	8488	1617467040000
11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1588	1026	167	6301	8043	jxf949Mwi8aQP2Kcy3cmwvbaF8GzD5PdFomMD7ugiyM7u8unjzA	6007	8492	8492	1617467760000
11687	3NLnpL84TZMLcNsRYaxSNAFDa1VHFygBYoSkRLc9QRkFstPXTr7X	11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	1402	852	167	6301	8048	jxArLb9TGq6G8iTgcFXZGFPySFNcN73iu9CQcN18gmz5bweH6ES	6008	8494	8494	1617468120000
11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1622	1356	167	6301	8050	jwsFcC6NqUNbQ6c2fhmUJH45Wc136LpY8f5ZEs7Pi6YKXGiMqjx	6010	8496	8496	1617468480000
11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1407	1395	167	6301	8068	jwD9HSj2J8CSoerS2mdhTSqbACStG9ExUaVsryxJBPWmuGUjHFe	6020	8507	8507	1617470460000
11708	3NLSb4kBdFC3bxSjDmi95H8s8y14GjCH13Bdw9sfrDUghG5Ko2CQ	11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	369	1066	165	6301	8069	jwhC6qMAF3Sdr8KPkxCY9kABYuPG9Tgm5dGdxydtg9V67YheePs	5963	8508	8508	1617470640000
11713	3NKHBzuP7tnH2YVWCNoX9ySKxkinYB8VyPd4BFypG135LXQbhudU	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1656	1343	167	6301	8074	jwJjqnsnVAyHVebSpadgQFktjYaqQz92KRbBhcoMdYoGzyyXnMa	6024	8512	8512	1617471360000
11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1656	1343	167	6301	8074	jwt5HC6R2UfioqevRz1wBvYsfGST6FEqkaX9SWsGNrEC6eP8Gce	6024	8512	8512	1617471360000
11724	3NLvRJRk7uMeNRJcw37Wr1wqdSfxi9G83ooze5uP92a5RPqq3WDD	11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	1483	1030	167	6301	8084	jxCuFtjtQu6UVcxej4zQgFuXB4awiFphEctUHv6xJBne7TkBFkP	6023	8514	8514	1617471851738
11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1652	1189	167	6301	8091	jwAyadPvXUShs2KPfW7ToW1191Y1iQVZ3mGuBLQpeN9t8bkmpWo	6029	8517	8517	1617472260000
11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	1631	793	167	6301	8093	jwZ5x1AtUz2Ezmmx54QkmKqtHNjK3oN6P9yDSyC4KyJGwKK6Jsg	6030	8518	8518	1617472440000
11737	3NLEs2kMrrK52VijfYyCAdKCqnEpWyCjRnZogV41JM2FyXaYVb87	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	532	937	167	6301	8095	jw7fCzksG9msi6L5KyGgUE5KjaKw9MxLmu8iQgkgY8bAV55BnDF	6031	8521	8521	1617472980000
11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	11739	3NKERoZW6X2szR6MNv6JXmf9qHXtTfxStnvBjb5sxzQhfLbW6xi2	1407	1395	167	6301	8098	jwxnx58RoyjExEmgM6fagqsf4TuRQMgLSyKgqMEPXdgsceAeExn	6033	8523	8523	1617473340000
11750	3NLjVzKJSpBfVCMXrrHgNxvpfmkJtbVUNGfGvETZ3VFeTwrhtRzh	11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	1553	776	168	6301	8108	jxcczPSYmZJQA1hh87ooSUKrEUxTaycaz69ij5DQF11QhmpeSBo	6039	8531	8531	1617474780000
11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	11754	3NLrBdeL9XfZdcu7iKxvSbJ2ecLeEnFWR5ioPtTjSmugkbkRxTSY	1631	794	168	6301	8113	jxfPZWTNnhnipCCzVxkFrdanMi7Mn8oGuqC1Hh7dvUWRxcGDc3o	6043	8535	8535	1617475500000
11760	3NKQ7x6YgecSY9hFD4dXLLUuDbJT1rFS6MHNyxmTGJfkUutUvE6p	11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	1405	861	168	6301	8118	jxzcDPRchfBG233EczAYPMP6i2ErmoU6h7TmcjsB6qYFs62LxLu	6046	8540	8540	1617476400000
11763	3NKpSWpJ8sqpv2Qugg81DdbqDWtog8TWHtWagkXa7FnjuQoa1yq9	11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	1631	793	168	6301	8121	jw9tuZbPVA2vDTM8KNBLjh7w2MddiuAyaivBfPtwbN9QP54kgcn	6047	8542	8542	1617476760000
11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1513	1379	168	6301	8126	jwr9DiZaR8xYfPALUoumiEpjMv2Ki8xez4SNxjEgMuj6V8efcEy	6050	8546	8546	1617477480000
11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	1406	1393	168	6301	8128	jwxJCbetKifb4jLGMsLd2kDy3UtoEqzN8cctvvSrtB5wqpe6gZe	6051	8548	8548	1617477840000
11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1609	967	168	6301	8137	jxhL2Hy35QwtPeG9nNwQMAMvHZuiv5cLVATQSUt4snH9mEcCk5H	6056	8554	8554	1617478920000
11631	3NLycTxLyMBazf7NkQr69uJd78cCos3zh6asNvwRH2UwtBxGnCqQ	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1403	782	166	6301	7996	jwVds8N7Gyr9ih4cM7XZovz4e2txdyeYAttkBPuidtLv25STcEe	5986	8455	8455	1617461100000
11638	3NL5ixrNBYfSq3nfjGHPtRjJ7mwTLe6gxG5zJgn9apbjSFmwftk2	11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	1407	1395	166	6301	8003	jwmrFfZrnX8Wvc2w8QXM9faxRLbQ6H6oaHVywq2A3w5fbegCsoD	5989	8461	8461	1617462180000
11641	3NKWr89rZne5PKuQNoFBP7ZHjhvi1bcttfKCWZxrFgsYbDVWDQsm	11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	1670	1282	166	6301	8006	jwQE2gKhaLj2aoWTH34jjSvsk9SHFGeU7wk2zMevzE4u3vKcj66	5991	8464	8464	1617462720000
11643	3NKVZx7P38FhdFe1pAW8Qd84othfwjjt5iZQVSfUuTC22gnPfrFg	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1467	1130	166	6301	8008	jwYUe1hVt3GFUkiKZ9uk123KBfhskVS43Fj1AEyYmGCKJihbJSj	5992	8465	8465	1617462900000
11648	3NLB55ng7sfkarYFzM115GPoaXA5qzdhh69Hpi8zKamaYqjSn9zq	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jwuRjd3RDMFtqhtcYjedAzAwABzdiyV8CPwxGuhAZLo1XiCgUGP	5993	8467	8467	1617463260000
11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1406	1393	166	6301	8014	jxjhAiTmUZ8UBBDqSTySZ19nZhevGMyYyF616SjrsyC1fuvq5xX	5993	8467	8467	1617463260000
11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	1483	1276	166	6301	8019	jx92y9gJdA2VfcpjBLoip93A9HuFGsBT1sPwqhr2uoqvEWJ6NGX	5995	8469	8469	1617463620000
11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	1460	523	166	6301	8021	jxFg4Jey9JgBG2TEWznwP8YdaTGvAAMH2ECSa2xSuHeL18ZZPW1	5996	8470	8470	1617463800000
11661	3NKCgYrZyPWYwmzq4eSKPrLqcGHVt1frKR4izfzuoCyYhBE4zn9A	11634	3NKjX2arrZwCiyoG2N4E3r9Z4GhnnzFBJr4HDp8WBBYf4yrUHVBB	1458	957	164	6301	8024	jxfmLtKyo6zLCqZcqtyKKeaUKn6jhpgN6DeXyQeC2iU3WnmLPAt	5908	8471	8471	1617463980000
11664	3NKJ5pK9rggjPWVEFcifJXA3uqkKNwEsxZSB9PE8wpof5cpqeyYD	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jxHLb4WVLamf6jcsuG5BQjqk2BXZnPDHpcYzZSZH1ngKXw8DYnj	5999	8477	8477	1617465060000
11667	3NKT4H3QGzFDZxW5bBjdPB5ZnEYmtQ5L3n2htVKNX5Uu5KoC9AyC	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1445	1044	166	6301	8028	jxQJdSHuxA6d45zZ8oHwEdP7KbGJg1L4322S5r5BCb4MjuWXwsB	5999	8477	8477	1617465060000
11671	3NKukFN4KCwAiadPdnYDaQwi795s5NFG8xDoqrjPceU6tXzn1Nvp	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1633	1144	166	6301	8032	jxJGftyLtzvoSgr4eG2vs74a4ifBaaKDBo2q9ojQ5veQdMJDbjo	5999	8477	8477	1617465060000
11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	11675	3NKYQRPcvRzfdxYTve2moiYVdEFHKw3K259MYQZZTA18V85N9b8u	1460	958	167	6301	8037	jwbUpMCCdpr65cH343sMbFgx9kU7pdknHcDgvAXBerTVyWS8sR4	6003	8481	8481	1617465780000
11683	3NLoDNunfth2i4GskCARzQx7Z9Vx3VKZP94fkAzDv5mLgsDUiAup	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1593	1220	167	6301	8044	jwY29x7twXVHfYs7owBVyrdskPV8U29sWyhdB6nmnegbXR6Vac8	6007	8492	8492	1617467760000
11690	3NLFySRYAetLu8QUpM623yrc2KFBbtMHog12dgF93TDeheCJ4bv5	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1673	1122	167	6301	8051	jwfcJLxyaPfSvNdod1TsJSUZ4CmbiCqSwSf6hjWi3qMGqxgyVRt	6010	8496	8496	1617468480000
11692	3NKLViEw6ynXFxLRGNbXa4t8CGng3PG3B1sxkdXPz2yY1g6TJiyX	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1405	1	167	6301	8053	jxdx1AhNT3REhZyVgDjVtsg6aaT8Eu7Q9XyXHJGXbYcsqzSLi8Y	6011	8497	8497	1617468660000
11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	11693	3NLWksgMViKHt6xHbat1KTgUuuhsNk17VmQBKQ5d7HGCdQwyXL9X	1588	1392	167	6301	8055	jxvC7VDK1HBuoYow1hWxf9bAZ7h1HzWuEiqVHaJG7bBtZEZaBCM	6012	8498	8498	1617468840000
11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	11695	3NLHHQohSNZ6pkjECridW2gKZptn98is3gAUE9RTHgsRbmKm9ia4	152	1330	167	6301	8058	jwwuBmfXATnVzNZ1hRpwisofXdaKWu7BLxMy6FZ54PX4Q3cU8C1	6014	8501	8501	1617469380000
11699	3NLbYiHnUVgDL7nhXFEbgY5ojSrv5ecuiFLDeBfPiUpU6NpdoVu5	11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	1577	961	167	6301	8060	jwkDHzUd3TkaGvxn4DLV3Ma11cqT6XPWJkvQWhgN7ZeSwKZxq2v	6015	8502	8502	1617469560000
11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	11703	3NKUMVSTCuKvR66ZK49zhL3MkoBDy6YEWV5rnivJWkym4fRVGW17	1652	1189	167	6301	8065	jx6zm5hJCiSiJ6WT9Ca7HrniN2JGvLUFit6FuH2fbuXgg1TvkJ7	6019	8506	8506	1617470280000
11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	11709	3NLvBWNsdeqGj785BDSQH4XR4dBedRzqtEDxewNboVDGYMaXGKfh	1637	815	167	6301	8072	jxK1wgpy5UL1qk2wK8gHzCQVi5D3DoTbHUXxZiBTxtNxuBpm1jG	6022	8510	8510	1617471000000
11714	3NLUoCTbpooN7kDerBVXCGbbYjtoLfUwJUg9BTR5B4PhWeHmRivg	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1483	1150	167	6301	8075	jxcbQddvAhB4HJquCsCE5keG2PDYtJPHyorHXNk8KBq5ce3f18k	6024	8512	8512	1617471360000
11716	3NKq5n1Gak2ezbmasEfjQhh4DGqMeFATLAucKin6m4wauQmCBaPT	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	1483	1150	164	6301	8076	jwjgU9JtBGP4HoQCjsd2Tom4iSXKeT7GADZBDJpQSVdvMJeJ3Zy	5913	8512	8512	1617471360000
11718	3NLtPvhyfAscZgtRcxd3yEF32z785YwbC8eGcWASjigYQXgJ6mHq	11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	679	679	167	6301	8078	jx3CH4r6RvJWp98zpraHYZbYRSREDEEut4Z4VHE2q2M7AQNQGPG	6025	8513	8513	1617471540000
11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	11718	3NLtPvhyfAscZgtRcxd3yEF32z785YwbC8eGcWASjigYQXgJ6mHq	1483	1030	167	6301	8080	jwhEPK22Qt3Y5mMWwhxnKojT7nfea4MnUAxGmv2AwmN4rvYhQid	6026	8514	8514	1617471720000
11729	3NLS49mqJRifhahiS2BzrBx9a8rhS4vV23FUDye9mxQYi3QaZs47	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1467	1010	167	6301	8089	jwopCuNPvZgqJPvkVDBVKv3vYbR3dTNrXwJnmHCyqjJshohsUzT	6029	8517	8517	1617472260000
11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	1405	887	167	6301	8094	jwK8ik5QDZSxgNsfBi1bknzzZam8dBHP4QTEoZk53icn5YyVA2e	6031	8521	8521	1617472980000
11738	3NKtXn5rwsxKx9qz5LB2qubcmF3cMEA3RQnfCRdfVnR36mmUr4Gc	11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	641	1336	167	6301	8097	jxnfHhpGsT6w533iC6FkYp3JJ7Wpkz8dkwuXrGz743LoriCmaet	6032	8522	8522	1617473160000
11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	1490	1028	167	6301	8101	jxttVRtomEBh3KGsEFHKjRrc3ozoTEeGACiRQXaN8c5sXxJQzoD	6035	8525	8525	1617473700000
11748	3NL5bRYPowr7H3mKT2RpAbg5ecVa6iFXokHBGeKgnyudtGrVDyU9	11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	1477	1350	168	6301	8106	jxXugAYztBtPSxETrGnxYFbLCATmGofsL1XKo3BAFEJppFiFE4Q	6038	8529	8529	1617474420000
11753	3NKNK2du7ofksgCirT126jXjB1cQ6c9UvUa8HCWRuRzmN3DpcQUw	11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	1403	782	168	6301	8111	jxPBJKJhqruCmKSiXLjzUXXFKRuzmjc3GVasokAecZcb6np5UVa	6042	8534	8534	1617475320000
11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	1608	1289	168	6301	8116	jxLAv1uxMYZoaKcemYsUVQP9VgVFRhh9QjCyQHZzij4fX6Zjjj1	6045	8538	8538	1617476040000
11649	3NKHNXp6uQrzAa4J2x9i8538NMtbFEKeAjbfiXaawtHN21QpnNSt	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jw7c4LaMxTxip9qDGd9H2eFNJdyciSr58FX4tE4tvez9TBJYNXh	5993	8467	8467	1617463260000
11652	3NKGiq2vutHuXh54nTSQSBHuDwUwWjBtsBL2BDuiBFiMjQm6Q1zf	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1407	1395	166	6301	8015	jxGte7reuMbo9sbcYYnsmkcbc8Mq4QH6eFKWV1ZKFzsqnwiy1fy	5993	8467	8467	1617463260000
11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1596	1237	166	6301	8017	jw9LC5SXoiEkCkorXqfHDeM1gEuKu71zzXN5M1PMRwFjgu5jguo	5994	8468	8468	1617463440000
11657	3NL5MUyTCBLX7uTHWtBrSiWndV2QdhE3382LeU1yuTTnAPU16DZX	11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	1536	1067	166	6301	8020	jxUv4thz2oAwhrnJmPnEr6wMHvHh84vvxT4aVdmT4hWL2ppRDyC	5995	8469	8469	1617463620000
11659	3NLuJzMVEWwsyMz8oFZ5XNftiSLL9rJDccbUgJW4J29drDBu1SXi	11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	1594	1326	166	6301	8022	jxCkYQD7VUNo4jeBxRt5FRfu8pgmZhLXLTXxAZBZm87BcFSyEA1	5996	8470	8470	1617463800000
11665	3NLYS6pDqui7wHRN1MTM9Mgs6qtRwLCPWc8uiisUZK9jMRNsJAxY	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jx6nX1JpMArjSxADAfSLbDct5FZQfC8Y3wr3XU8wcoXJKZyGHUa	5999	8477	8477	1617465060000
11668	3NKC1Z3QRamePNCJ1LBw8yvo2yFfHaXdSK15J4fXE5HEZqhnSL7e	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1483	601	166	6301	8029	jwVdv4kgR7cCNMnuALt11Xq6MLFgoHmfukHYQPqep2ttxSmAhuq	5999	8477	8477	1617465060000
11674	3NLWnzv1geb6JZ9s54qiSe6afSyAmGrjpkgmLeCUVtf7iUhWHG78	11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	1536	1067	167	6301	8035	jwaFDGWWTb63yEkLJ1dfWvxW5DvZVkdvcSptVCRcwfnSZFNMybQ	6001	8479	8479	1617465420000
11677	3NLUEFNQ1eaY9oCf5JftxHuzdDcY2JTWQ4aMZbxUVh8L1XicSvhq	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	632	1136	167	6301	8038	jx27KtqFDzKMaoyCHmhnmX6pYMe898czNKDzfkiZDtoo6kLrR1g	6004	8483	8483	1617466140000
11679	3NKVxY7pjEkRecqUNjLM56KbXxwAUWBAwy1kQvcKdhFJUHCRAV8G	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	1631	794	167	6301	8040	jweg3XAvP5Cu4DvtBosTrsFDszvR23tqKKm6ppe59gZfySyhGMK	6004	8483	8483	1617466140000
11684	3NKVAXJ9vaVeXfKfgjkDoQniH2mq5zN3KPSw1L3EVBtKYdmMEVwz	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1501	1234	167	6301	8045	jxJhsXXFGWWDMWHAHa1ovqPr5u5eKgp2SnEjNahoWmt8hmHGeLo	6007	8492	8492	1617467760000
11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	11686	3NKbFoqg2xXNa3t6u2XMD6a49SeZ98vpXii6suwVcz7C4BVkmYQ7	1483	1276	167	6301	8049	jwLertNiduTd2gS2o7Mzadx7Ztd8PSm3u1CoTGBG1jAQi2wh7Mx	6009	8495	8495	1617468300000
11691	3NK5DWpksVf9jC7Q4WLixPoP3ycYewwo3Vs8NKJszxYWjjPmDPUz	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1608	1289	167	6301	8052	jwNqFfVt79dW6ULYoNF91GQW75tpMFW6kmmjXpt3YScMU55ZXu8	6010	8496	8496	1617468480000
11695	3NLHHQohSNZ6pkjECridW2gKZptn98is3gAUE9RTHgsRbmKm9ia4	11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	1406	1393	167	6301	8056	jxKAMgnNdvHovAkbnu6gwwwse8PBRV4VaRfy28mQo9EdUuwvpSW	6013	8500	8500	1617469200000
11700	3NLhqeTih5DQaUvdvqKFW464bpTpCzyCNGPT32fHaVgwij7zfGdm	11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	596	1180	167	6301	8061	jxXSzxDDaqAniGy6j9PGFoKiWVU75XQC8qRMA5AUXD8RS1FDzFN	6016	8503	8503	1617469740000
11702	3NKBei8VZ2GKYjMeAJuTLBUxHofiFWq3zTzZgrZLLAAVFjJM6NkY	11700	3NLhqeTih5DQaUvdvqKFW464bpTpCzyCNGPT32fHaVgwij7zfGdm	1637	816	167	6301	8063	jwngJ1ZQPTWB5Ug22azSGXPnFnbBZHRbtT9o72fYx8reLP4uLDF	6017	8504	8504	1617469920000
11705	3NK3ash2vdAT4M6fPRe5nziBTWoymgDCq9RCzwGWn4opKDRcs3NA	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1406	1393	167	6301	8066	jwrEykGBiPVAPXJ3UtovhBBhbmJ9ArYN1gyGJkbq9NzCmPf48Jh	6020	8507	8507	1617470460000
11709	3NLvBWNsdeqGj785BDSQH4XR4dBedRzqtEDxewNboVDGYMaXGKfh	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	369	1066	167	6301	8070	jwyVgUA3398yNWSLc3YChfsKKu6qqAwbSaWmYgxnD1P9Lia7QeM	6021	8508	8508	1617470640000
11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	1668	1244	167	6301	8073	jwHqoLyFV4j3g39KQ5xb8pqvS6Jeqyn87mGzqFiw7ezrp1o58XD	6023	8511	8511	1617471180000
11717	3NKkGRiDXJLPFAYjZiN9JYsLCTFk7U8QBVz5pjbHCGCJDFEVBfVN	11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	1483	1150	164	6301	8077	jxADMDHT12nR1FAeZzREK2CyRxjYc2viRY3ogHRqzNgvKJTz3Ei	5923	8512	8512	1617471403026
11719	3NL2cvgDhBNrb9HqMjnyRNZ4UpvwVxSpPopq8dBAcBBstQZyP1b7	11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	1506	1127	167	6301	8079	jwhTDXRdCPj25wXG4WNjvDSLHrTap9EmPk6G447HmDfpXu391LY	6025	8513	8513	1617471540000
11721	3NKnZVaygom1ohNcVCwqsdMPQsJUf8jn3AA3guyEe9JcL8qDFyat	11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	1483	1030	166	6301	8081	jxoVbt9QnjnbuecE7KgQo3yXDbWTKYRLMHwHBTZdZ8ScZpvXK3X	6001	8514	8514	1617471720000
11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	1405	873	167	6301	8085	jxa2v5XC2ac3zjkk8iWZTCxB6mJdrwYijudpmg2dDQW1YYmDQRq	6027	8515	8515	1617471900000
11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	1601	1142	167	6301	8087	jwyFbsdftHH4dJgbKZgcrtEitVE69VUxxGezRtciQ8gbxXWAVXc	6028	8516	8516	1617472080000
11730	3NLcGQ3BJ15vBrvshPwi4XCsvULr1pALErAmWWmjm1LeqvowJ7bz	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1403	824	167	6301	8090	jwAC9ciDF28JHEjJpb6P7sW1vGKVC1iwqSK9Us6BtBA9wKqHE8K	6029	8517	8517	1617472260000
11735	3NK7Y4YURdpZEGyvGJiAMguJKo2wwfgFtF9agLgvnzRB7ywsEvcy	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	532	937	167	6301	8095	jwi5nNd5jH99aJgEsoMKfjzyYYpgPVFMJmoZWsK4bERFFK6wV1E	6031	8521	8521	1617472980000
11739	3NKERoZW6X2szR6MNv6JXmf9qHXtTfxStnvBjb5sxzQhfLbW6xi2	11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	641	1336	167	6301	8097	jxjfjCE7u1paFU7pFmUj5yx91siMxQvveKumLVUEaiA7qTsZbfr	6032	8522	8522	1617473160000
11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	1593	1100	167	6301	8099	jxzBcbYW9TV7xezEsqvsLFKo3fyanc7M5tBMZFGKXKryvB3qAEN	6034	8524	8524	1617473520000
11744	3NK8HaMYcqeS6VQM69fk2kgPepSUXV77p3cMVjQm4TGTTFFe6vXL	11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	1646	1108	167	6301	8102	jwykZNEvX2ysWhQj6V1TLRc9cVjo1pMNZUymxw7WFpNU8rPpAjL	6036	8527	8527	1617474060000
11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	11744	3NK8HaMYcqeS6VQM69fk2kgPepSUXV77p3cMVjQm4TGTTFFe6vXL	1549	1362	168	6301	8104	jy29LZCWaGsULDMZitPdfr6vT2mt5BvWFPX16iBrgSJDcG2uxEm	6037	8528	8528	1617474240000
11749	3NLDH5GvNaro4wB3VSF88ZPvNaEGQrR2teZEkvTxZW7ev5CpqR9w	11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	1461	1271	168	6301	8107	jxGHnv7QvMUNdtigeJTy8JgDMZnsh54MX9L7t6mx1N7r9yNT1cJ	6039	8531	8531	1617474780000
11751	3NL661TjLc4U9d8RnwKYxCDP8R1Y9bh4L2gytYcgpvWSKD3kyf3M	11750	3NLjVzKJSpBfVCMXrrHgNxvpfmkJtbVUNGfGvETZ3VFeTwrhtRzh	1407	1395	168	6301	8109	jxfPfXYzrHsYTZJbHqDoqUTpcBb4Ze9o2CBefw3WB5oa3quskVu	6040	8532	8532	1617474960000
11666	3NKx84QLiqoR6W32xg9JdgJygQ2QtpC4YbapWeycArPEPi2CNoh8	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jwQZHK8PRU9JViazXHnPMVQwoapUMiiQP3twtyU4MffKPW3ejxr	5999	8477	8477	1617465060000
11669	3NKi1riwwLmEYBVmzx34HuUAPPZkeE1kbhKkNeEQGecvEsfwPiJH	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1647	481	166	6301	8030	jwCWXqmQVevuxG1tg7VeqAM8LYh3EXTojsgk3tCXhexEVaBgdMA	5999	8477	8477	1617465060000
11672	3NKXfDdNo4Qs34MgxUVEwKq5gxPgxExLD8aSVU3gasXfxetAZ2Bq	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1476	1371	166	6301	8033	jx8Qz5hNnXJnPfJNXZnxmMKdRJqrcqXeFc3ViNa5n5HqCohVr5r	5999	8477	8477	1617465060000
11678	3NLY1o8mL65WXujpfb3RDFzFLk8mm7UBpMP6CnQpdAHdyKLUL5Pm	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	1406	1393	167	6301	8039	jxJ4vvP2AUrBxc8tTofZ4YSAZstQet5hNei87RdmQDwQPo58n39	6004	8483	8483	1617466140000
11680	3NLQ4ZWZWnWK3wE7YtM4zVhVLQbAEEyD33gh5zvdaQ7HKREKySch	11677	3NLUEFNQ1eaY9oCf5JftxHuzdDcY2JTWQ4aMZbxUVh8L1XicSvhq	1577	1327	167	6301	8041	jxLDk7UMRxu6TWq4WHuFg17CixsTRU6Z2KeVs8rhYzm9hdreWts	6005	8486	8486	1617466680000
11685	3NLew8yZeY9XzctTA6Yg2eSKZMTdrvWfuVRkUt6oHKFugCPzvKFC	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1407	1395	167	6301	8046	jxA12pKur86GbaAixVaB2Nr1eAZgBJy1EuAz3CKwkrJyAxz8TFq	6007	8492	8492	1617467760000
11686	3NKbFoqg2xXNa3t6u2XMD6a49SeZ98vpXii6suwVcz7C4BVkmYQ7	11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	152	1330	167	6301	8047	jx1dGJ7mUFKwjC28Ns3HSgF4PkkVrsYCzuqmhmd43u12z7LrnZQ	6008	8494	8494	1617468120000
11693	3NLWksgMViKHt6xHbat1KTgUuuhsNk17VmQBKQ5d7HGCdQwyXL9X	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1553	776	167	6301	8054	jwBBLjQi1cDifM1dX3dTHiASy2GSrBzf9n2FtKUGd1LdxCJm28S	6011	8497	8497	1617468660000
11696	3NLaqXueZicfyQhBKZxgtdr8HwKq88see28mjXaS54zFbWjtrTJv	11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	1617	1042	167	6301	8057	jwhv2zspn7bcQa892ig3R6QyDA8ytFmoH1AXNbhwQcUFWJddsyh	6013	8500	8500	1617469200000
11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	1407	1395	167	6301	8059	jx8SgEmA5BJqk3wp2D8Q7q9qrU8WBi2nM9XVbrDBaPWr8upDGjd	6015	8502	8502	1617469560000
11701	3NLve95FQnVDZVJFeNLvWhkjfTFyvfeMjJ5zqxLLz19NFkzz7ZEr	11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	1578	1170	167	6301	8062	jxhy1oUszFZyp5J8ozhxcyf5W568iLQLMkU2dxaX1ad74xLd9Ji	6016	8503	8503	1617469740000
11703	3NKUMVSTCuKvR66ZK49zhL3MkoBDy6YEWV5rnivJWkym4fRVGW17	11702	3NKBei8VZ2GKYjMeAJuTLBUxHofiFWq3zTzZgrZLLAAVFjJM6NkY	1403	824	167	6301	8064	jwaYeALmwmrmdJ5GKe9984uugWE882CUNSLJ7vqoamW7rp9kHAt	6018	8505	8505	1617470100000
11706	3NLXRqaCfiZPvcd35GLEGRqy7dXjqdUrZE3LRYkXi5t1vnfrWr4a	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1507	1280	167	6301	8067	jwR9uGdRQoLZnyBTFyQXZsQniCqEfSQThH7VpYyKA6yaAeptuss	6020	8507	8507	1617470460000
11710	3NKar8xEzrd6gQJJfvFe3EBAboT7toCH8KChPQfjHnJ5jHYcaWmw	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	1406	1393	167	6301	8071	jwtn6x1XiiwZAfSX8HLLs7icinexmqZiU3efcLGwzH828xMhQ4L	6021	8508	8508	1617470640000
11722	3NLjTpyj8fMqFkru465NjpFpUNXDga5otxzomfHMhjy54tBV28kR	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1483	1030	167	6301	8082	jwfY6cM9KeGBnw2PTPH4bwvcmXHfHZ4LW1fxrPnaGbZvWzh2FGF	6011	8514	8514	1617471765595
11723	3NKUmpi9Mhhapr5Qoop5DkzZzJD8a6684YTB725GicTXgHWHJNxk	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	1483	1030	167	6301	8083	jxmp4cqGmKwhanz7ti61idCjBmHkwrzj4dugVbGd5GQmKfufNmh	6021	8514	8514	1617471811555
11726	3NLWY6vZFX7wjcdS5JXNwudajy2PRS8TtbUi7Gwn6x1ZU8nw9qbU	11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	1467	1376	167	6301	8086	jwpTSawMsMc2BF3GYfSvAabptrrciiYAqqJBiQCQdgjDrdbF37g	6027	8515	8515	1617471900000
11728	3NL76cqVYYeu5mSEVahUcqFoB7ajKp4APvcsVf22Wk8JWrFYiBKf	11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	1513	1013	167	6301	8088	jxdkvbjdm7yFYc6rgj11w7S1qH5k8KQWG9MaWrs5KWJKDSCGRyP	6028	8516	8516	1617472080000
11732	3NKBj6LhtRVsoRNkV5sjaVFbG2ftyyykQnxPyGqyTXSMVFaRMAPU	11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	1406	1393	167	6301	8092	jwT9AqbHY1Cb4Q1pdfbriPszQ3WrffLnyHMBbvkEBCjfUKBDfYt	6030	8518	8518	1617472440000
11736	3NKqQJuoeVgr1nFqRgfkJ6LvF5TG9pHMDEqju2ru4UouVTi86mkT	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	1407	1395	167	6301	8096	jx6k5cdrb6mkbfXnqW37gAYiYHXf7m8iX5Jvzq3bkmzz6ZsNzBU	6031	8521	8521	1617472980000
11742	3NKgg8fXvikaprxagepdR7dFaynRwdk6hxVn2mewmg6A2bzRdQB7	11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	1406	1393	167	6301	8100	jy28xWxmxAcbtfwMcdrHeJZFgahgDRAviEN9rriZ2aPqbMo4Z47	6034	8524	8524	1617473520000
11745	3NL6pM8mERGeScSHp8naep6bcUcskJKLBUAwSw4uc8fbv3BRUTZT	11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	1448	1311	167	6301	8103	jwLFUFWjXc8MRA6vufRjnemL9TF1oxcXdv9tCkuqvnzmShFfo73	6036	8527	8527	1617474060000
11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	633	1384	168	6301	8105	jwfhnYeLwdNrxC1XTVaVJjoEXXb1jKkH1iDJmKTR6hY4sYZ3S9R	6038	8529	8529	1617474420000
11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	11751	3NL661TjLc4U9d8RnwKYxCDP8R1Y9bh4L2gytYcgpvWSKD3kyf3M	1622	990	168	6301	8110	jwa6o5ZgHcNRhJtS19sQSZ5P1HKSJMKc5nDuVCLfuC6xxE3TddQ	6041	8533	8533	1617475140000
11754	3NLrBdeL9XfZdcu7iKxvSbJ2ecLeEnFWR5ioPtTjSmugkbkRxTSY	11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	1406	1393	168	6301	8112	jwv7WtF2xcWh23v6Z4uSqhKEMCbqHN5cgMpgZeSPbY6WJvAcUdd	6042	8534	8534	1617475320000
11757	3NLrgwebp47N2Mn2HYYjbPfCTBB5KZZLVPmktKswCrERr3kEU3SQ	11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	1476	1125	168	6301	8115	jwGBaxmUJ7CarTSFCsWRgX6NqYYqPJZjU1hyPo4HGznXKkq45W5	6044	8536	8536	1617475680000
11759	3NLY3Yu1HY5nwNPBWLsXcuSpTcbNVGUvkTWq3MpdvfsLK5aP3Rs5	11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	1631	794	168	6301	8117	jx6e829tnwACwDPMTjjM7mUkU3UdRJBnUXbumMJqHdDQ37Wjh63	6045	8538	8538	1617476040000
11762	3NLsJ3vh5kDAss1wCx2MKLuMDz9ByJD1g8kiPWyZxD3T3ix96Yap	11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	1555	1347	168	6301	8120	jwKg7mKcgLpmgBJ6LCyZUUdx7vELWMovbZ2r5Ctvz2sFQmeb4Yb	6047	8542	8542	1617476760000
11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	11764	3NL2ZUBjfq5kLNiDVABMF2mGGjN4HQ5ogYi884S4oE8peie919SF	1670	1156	168	6301	8123	jwbLxiSRVUSWKkVsLphkU14zVAgonaygLXwLUWbigdNxa3pCo3k	6049	8545	8545	1617477300000
11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	11776	3NLf2HyLBkDAKY9ayjFanukqT4Xd8ZVDNUqKUEctY3fGCsB4PirZ	1474	1329	168	6301	8134	jw8PrgLrc8RcTaX3CC4JcmgbZdZWLdzaaEr7tyTcv5hwiM1CcB9	6055	8553	8553	1617478740000
11782	3NKhowUBNF5pJTJHn6MWBgXPcwtcRtLhu5EXYsEmrywtrFBnHoq6	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1622	1110	168	6301	8139	jxjEMjWF4mMtyze2wgJtxkdfC5Yj3a35mC9Qx2VvssxWf7UKQQR	6057	8555	8555	1617479100000
11787	3NK3SUMvQt49yX6YfKKcT1LKCLFSv4ETkUTaPJqkevRJA5yoZo5s	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jwE8zGeErieu4GzTgNWikBciWzzMQH6EkpgBt5U3JJ97VcjcN2t	6058	8557	8557	1617479460000
11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	1406	1393	168	6301	8114	jwyuLFV22JdkvnJxy3x2azdUHSFQr9vwjyqD2pwBpy2t5tZAKCo	6044	8536	8536	1617475680000
11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	1564	1092	168	6301	8119	jwwUqg5DpnEH1akP53W6BLFQCoBEAxUFf64z7rc4PfznP9DPS9f	6046	8540	8540	1617476400000
11764	3NL2ZUBjfq5kLNiDVABMF2mGGjN4HQ5ogYi884S4oE8peie919SF	11763	3NKpSWpJ8sqpv2Qugg81DdbqDWtog8TWHtWagkXa7FnjuQoa1yq9	1426	1118	168	6301	8122	jxQ468PYjyW1L9RRkPwuyAJEUZ85PoTGL7FZ29ReUEJdXKrbXLp	6048	8544	8544	1617477120000
11767	3NLh8ixhmNjmy9kszD9sTBLrjqGAT3tQjpYRLXXTa54LYmB1rU2z	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1407	1395	168	6301	8125	jxu93kKcf79Rts3pbstJTUwWdnquVSYat98gmpezvcVFVWryaiU	6050	8546	8546	1617477480000
11769	3NLepjWJSg4jpRsc1NxiLZbhkfE68s5JRCvD9zpAH7QvZuJvtY8c	11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	1407	1395	168	6301	8127	jxRLn2MUGoxXDDniJrEbxmG8qWxQrvuUvtpzg1BWBYtzC5eNXYP	6051	8548	8548	1617477840000
11772	3NLaaui157vWtCef1WeU9dzmPxtCHzGSxBFcWSw3jyEWbGUECKfM	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	470	1309	168	6301	8130	jxoWMAAXTshHWJ3nPDNSDqqsg54LPtg5tyZ3JHxNxKGLPpUx4ks	6052	8549	8549	1617478020000
11774	3NKiXpikVvaNxziaFSdXBabQAPVmz8H55Tm6fb5xHAh4Lr5wsnY2	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	470	1309	168	6301	8130	jxL4EPUipRovTwmB5YpPkLQ3H72drKvExYhGgkF7S44XfnYD6AE	6052	8549	8549	1617478020000
11779	3NKbbXMtts7uj1b8JdRTqcNtwZMtoTQZcfWX7TGFLsTHLWkGpGKM	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1460	958	168	6301	8136	jwbih7U8BWH8Zggak8YZXmr6XVQgp1PWdsRNg5WfEHtvQcAdViP	6056	8554	8554	1617478920000
11781	3NKQPi4haNd8mFKvhzi2pbd8AwPQs4VJb9WNtfxiUd8bavEdB22z	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1668	1370	168	6301	8138	jwraYEjwC5o7crcm5eSDzFiXvzs4zQ4JuY7d4cqWvuB3LqzVtN1	6057	8555	8555	1617479100000
11786	3NKPXpMmRrY4FeCGyMs49v3aoiyE2EAwjAXz12ugprQwE2iNYY53	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jwj4PK9Q5e1iVFhvvGf35qJmt2N5EBJmp6ZGaKR4SSqLqWr9yhw	6058	8557	8557	1617479460000
11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	11798	3NKPtbmoUZZpgWb9y2MDdE8xWkqhaUEWyRdsjoiMvR8E43EoWL4E	43	1064	168	6301	8154	jwA51ZJM59WfeuzN7v9CrwAbH6sQkEsgF3BRpH1qbPXtpzsxyb9	6064	8564	8564	1617480720000
11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	11801	3NK8tgNa8BQ4eKV5KYbWKqhzV8UoAQxp7uiEgW6VjAcAVuauEij4	1501	1360	168	6301	8157	jwDbniKXpKHNUBC4pQLvQwuWTyym2MJGeYnZodE39oT4BqmVpHT	6066	8567	8567	1617481260000
11805	3NLXyYgQm6UdqAwwfi13opBtsYDtExjRhP3gmRKNvsaecutDSrze	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jwNWmmFKVv1Txp1nNCgMnNwBrUybTC8eAc7kP4jtaTD8x6anKrn	6067	8568	8568	1617481440000
11806	3NL2YGKfMwDTzg4oBEufKagCq6JpC9E3YzFhpwcDk5s7vAujFDao	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1637	816	168	6301	8159	jy1Y27tzzN7e9RQcRCjDPAwVZNZ8pU2eBiroobGoB86fZr5BM5D	6067	8568	8568	1617481440000
11814	3NLLg7qyEfZzcctPmR4uvBYpnPrg3f3DCGxRQC5pdHVmoNuw1n5b	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	1407	1395	168	6301	8167	jwytFFuzytxoiJzwfnLDNxBscAMLVHFRrXr86s5XUaqvpn5Xk9z	6070	8571	8571	1617481980000
11819	3NKD4GMzBWdKERV2stPimjv9WLAuLNMpUg7LoXNtuEfjfqmg92S3	11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	1656	1343	168	6301	8170	jx82K3fXaPVmeT77vJawfyTvVVUjTvsc68WRzNNY6XNwfJBvJwz	6073	8577	8577	1617483060000
11821	3NKuRhdNSgfmEdQ1UzpnEQR5FPw7USAvETxRWVJvDPHPx47hme1w	11820	3NL9tme3azTVHfrV1aKrpxuUEQqYSiZWwZLUTnF3nd2yGvjak4XC	1406	1393	169	6301	8172	jwmKE74XGS16L8pQAowAh8RgDVU7GHL7zya9DNae5ynZD29tbRm	6075	8580	8580	1617483600000
11826	3NLL9Q4twXKnjqv2wUmyXcLezLvuSADa9dQ3vQKPmMnhKkjzJjg6	11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	1610	1068	169	6301	8177	jxk861XQ8GP1fuoHanCTwAw37CnAxwbhuL2eKXTpcVqr18SCqmn	6078	8584	8584	1617484320000
11829	3NLCKVnVSsJgKXvFJJex9gUhU6Z5qyDE2eA69JFuXyn693T4Pf3x	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	1594	1326	169	6301	8180	jxCvcViLwuW8UvDkeK4epP8vP6NVHK547tQbAkr9qfgarVBc5Jy	6080	8587	8587	1617484860000
11833	3NLKDU996CuseidynBm9tMEH92oKhHe5ZxpQpR16Vyor8DsEjmzA	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1467	1250	169	6301	8184	jwJ34GBxbNYjSHca1u8ZULyH1Exz9qnTfCM85uroKkdZa2ufr1P	6082	8594	8594	1617486120000
11836	3NKhECZsdHVBQQZRkLuXuzJYGspL1EmfqN7nUfqxWciyezQmrfAa	11835	3NLKCGZCXz1QYkcmzMm7UfLgigry3Aw7DqRxtY3dWwxB1W9p6Y32	1529	950	169	6301	8187	jxgsGPmuqKMai3WmiXbBkND3woCHFMMsoo7ESTFSG1hGz25HJRZ	6084	8599	8599	1617487020000
11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	11840	3NK7RGHyPrP6rtmkgJqhAnDvrd6d1AKdQSnxpuihzdfjrgMBS611	1403	824	169	6301	8192	jwC3JsZ3kxQwnZpi93R9e2LjoxobVZXFtxP5mraNaxJPj6kNmhz	6088	8604	8604	1617487920000
11846	3NLde3KF4k3QqjBcxZ299paTPB1SL3L9PyhQUogKuiri1oz3GM5G	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1476	1245	169	6301	8197	jwi5ZyxCmB5fGGbknaRgxwR9fZ31Z5QtcAqCqHCx61eNEa9eW3T	6091	8607	8607	1617488460000
11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	596	1060	169	6301	8204	jw7KkN9hNm1JCiHSQtY5tjuLuQeT3hSRetet3jF8ypo6AbzYVQm	6093	8610	8610	1617489000000
11858	3NLuZDn8P6YiKj3pDde2gXka5P6NfgeXuroEpFqrnux7hUsW3CaU	11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	1445	1290	169	6301	8209	jxUQytR5Muf5QDHScQnDuF82fn1xS4ccTDou6XsuG4QhRb6kYQC	6095	8613	8613	1617489540000
11860	3NL39gxPzHDKMqxLYfKY5Qt5wmUBEqGMxbyCbeMe8oQNJq5nEzd8	11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	1607	1102	169	6301	8210	jwhvBMkS8anV5hg5L4K454jLbRN8obLmWqxBvWxJBx9ssEPPJaZ	6096	8614	8614	1617489720000
11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	1406	1393	169	6301	8215	jxo8qi6aNt674S9AEE428m3ymzEcjYP6TvcS8tSmTmKjz131fuY	6098	8617	8617	1617490260000
11867	3NLsm7UkMawEgihb4VRtrJFhefbw3uriYQWYodmQ98xMECUE1fjY	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1649	1257	169	6301	8217	jwwE2LKgjcASELLeaeGReDn3RMJnDViPXbiYwQc3VG61Yw4m4FF	6099	8618	8618	1617490440000
11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	11876	3NKoJJcBApFyopjvUouwWdXHHo5kJTz5NRGSM6UKJBM85Ar8MwbV	1406	1393	169	6301	8227	jw8V1QFqvTbXNEWihVCuXC7yBsrjPXJgsnF3AZJhusCfxn4kcn9	6104	8626	8626	1617491880000
11880	3NKV9ygWApZ47p26eTff2DaR3kkYmTAxE8qE8WfpbCWTxV3Bsf6T	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1593	1346	169	6301	8230	jxDdL3h54KrSMxv6vU5gPsvWJsWHhEJUHJQANz1NCL5PyCxe7C9	6105	8627	8627	1617492060000
11892	3NK7mdW5bxNULKUPNSCyccT98TCr1FoNujhk7ziqjKztfhmFUrxT	11891	3NKSMiEeQGixYNddoRYrd2SxJD5JRzXCxPUs85Ap6etPUXHh8MJk	1619	1275	170	6301	8241	jwPt6tpuUGoiR3FUD3raF7L5rqHu7XnJQqcTwt6XhSdbRnNsh4A	6112	8637	8637	1617493860000
11895	3NLDnBxh219VwdW5iq9r1PNFm5jFtH6cVHdJErcnqt9hEd2u9uaM	11893	3NLg6wvu817hbxUmccwVQLGT5VafogRhMkZ7w1irhxKoYs7yiSAi	1546	1339	170	6301	8244	jxpK4Brg8yZK1XkVWWDVd7rE9wUhfaucZEUGKvAxs31sTosKH1V	6114	8641	8641	1617494580000
11766	3NKXh7rjQefAkGasbzE3n4rV6UPhTY13pPoG8778U3nJnWkerEQb	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1474	1203	168	6301	8124	jwfiXxurVXhNaCHGSN7hcQpdjNzpwyYWXmvuXW7Y9EcLRGX11Tn	6050	8546	8546	1617477480000
11771	3NLjY6R1dWC2XG3pfkWaSi3Nu2aWt6RfHk398vTckZDsNfgeMSAM	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	1406	1393	168	6301	8129	jwzrkJKDincW8AxaHUbHsXfbRDpktGnabFuqYYdCJRRSnFzzfRU	6052	8549	8549	1617478020000
11773	3NLxWCmYzrGcyqTge1ETGdCeoBnRpP3fHojRvFzi3LdNxiG9DaBx	11613	3NLei58q5i8p9AGVMJdPJTfKPEQvLw85vcZuEdarfQTiQDZ2wR9a	1585	1000	165	6301	8131	jxk51coLX7KBrJJH5YZTzqe2HyiNxic5rk2SZiBndQfdXde7buB	5929	8549	8549	1617478020000
11775	3NLuswMKHCceTFP3ydsz2d4LLFAx8B72RX24cDdVAE6rokmtK992	11771	3NLjY6R1dWC2XG3pfkWaSi3Nu2aWt6RfHk398vTckZDsNfgeMSAM	632	1382	168	6301	8132	jwh2EzekaecrPHiXV8FS95bZyFHRdypsbJcMWtAVjVcP2ZVBjVt	6053	8550	8550	1617478200000
11776	3NLf2HyLBkDAKY9ayjFanukqT4Xd8ZVDNUqKUEctY3fGCsB4PirZ	11775	3NLuswMKHCceTFP3ydsz2d4LLFAx8B72RX24cDdVAE6rokmtK992	1631	794	168	6301	8133	jxAH3wwXEPvUj399p63tkSD8z4nMUHUa9EhNmsAMegJpnB7gRez	6054	8552	8552	1617478560000
11778	3NLsf6KBE5vHSAGgMoRgdXCxsj1gv2SHafXANqLgPp6epwenNMNa	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1534	1317	168	6301	8135	jwWkLU3u78GFYmXBMEQwSZS6xt2QBSziBopH71nr4aDBzfdMFwn	6056	8554	8554	1617478920000
11785	3NL2iDCv5d1kshYoDrMJ54xVpcyF9vFkGg3eZGCi9NYc3sSLMBS2	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	1405	867	168	6301	8142	jwCK1V31xkqvEqgLYwhmZj1JdtT8Q9Vx4mRKsDUHjrsfUyFFxvK	6058	8557	8557	1617479460000
11789	3NLARBR6vc9W92D9RmR9Bi6QDM3nyZD58Te9eqe5zWiLunWsL76P	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	42	1115	165	6301	8144	jxapfav7fbkGt16kLkHPfkCzkKYPCy8S9xjpFWKWX8VUwJ7tNYx	5945	8557	8557	1617479460000
11792	3NKUXDW8U5xyg5FQfyEAYUUwJCo885z9xWFnD7td4RgFZW3asCrA	11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	1672	1039	168	6301	8147	jxFbKkY488w4menh7u3Eh29t5DSvu1u5VXwW3MghRhcqcofVFyb	6060	8560	8560	1617480000000
11796	3NKqmFKkwm7S1ZyNz6HDSkQcWYLWrCJiW1UC2MDmZd4iCeQNwy4T	11604	3NK85Y125yTDYhW77QuCUG6etPVmDZwHFkp5znXbgL15A49hZ49o	1559	1353	161	6301	8151	jxi5jW99aMRV4k4CAcy7Amb7K8HHUAjAq1Uea8bGRHsEDMjub2N	5819	8561	8561	1617480180000
11801	3NK8tgNa8BQ4eKV5KYbWKqhzV8UoAQxp7uiEgW6VjAcAVuauEij4	11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	171	1374	168	6301	8156	jwPHnxKw4Txf9dcmZqmPYqzPmsZkkxMmQS7RX3qwtkf1gnZmqRs	6065	8566	8566	1617481080000
11804	3NLBYtDZkiEz6MQCMz3HcBfb2XfRKQqiZuJjHjxkaH3hjQ7SUCbb	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jxVm9w3LtKnhpYgt3GhLQXZHFQ8gYSqh7HzG97MZUstA1jccsfu	6067	8568	8568	1617481440000
11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	11807	3NLtFX7SEbRKZVZ4fjLxBeEJavhqAnXZpt8e8QvDXW45dTAS2aN7	1444	1255	168	6301	8161	jxjZAoEqehR3kpdYvF8aNPSPtfBjy3CbqG9GbFfYQbWZfkqtcPz	6068	8569	8569	1617481620000
11811	3NKApMrPaShuvosLwRVzf75kN5sCZyerKo3jvqBZVUc8XPZZNE97	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	1589	1286	168	6301	8164	jxBdMoboY18cxLZ5bCPqZrGaZJHkfVTLELwtVtDYvckRfTg3vDJ	6069	8570	8570	1617481800000
11813	3NLLTjhKur3tGqpQxccLhUCXMCuXcyuFFDdTsDZb5j9W5WXyecgL	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	532	1177	168	6301	8166	jxMZZSYdiwGYUYWGEauDRcezwdcPjufk5sj1QPTwXzocLBvAfnw	6070	8571	8571	1617481980000
11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	11816	3NLGyhCJouXEQxNtHQyw8WZeD4cSJJSeFgGAk7ig296FSsxM17DY	1406	1393	168	6301	8169	jxV7YWtXMDsUqaYnRn5woU6K8h35XMCKR4CPFTxYaGracazQ3FL	6072	8574	8574	1617482520000
11818	3NLV6V7RHEBN3VDDQ3YsiYnp2nRkPsR1zk6BSt6yNn5PQsAhCUCu	11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	1656	1343	168	6301	8170	jxbcjFsCJjEm73WBEgLoBCM1obodiPmTRgRTwNTEEkrgiK3VzB2	6073	8577	8577	1617483060000
11823	3NKVZKe8AGUpp7YvZaofUL9WybNk7ypbngS3K5Z7wNd5a5ASWF99	11708	3NLSb4kBdFC3bxSjDmi95H8s8y14GjCH13Bdw9sfrDUghG5Ko2CQ	369	1312	165	6301	8174	jx44EGJTj9jeszpkdj8cNzyvXD1DaKCFkwsYB1FHXKG86JPbtNV	5964	8582	8582	1617483960000
11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	11829	3NLCKVnVSsJgKXvFJJex9gUhU6Z5qyDE2eA69JFuXyn693T4Pf3x	43	1310	169	6301	8182	jxVM1tMWiU754yiw5xNLajo3wgTXqsuxbA4s397vAWfPMTvgrVZ	6081	8589	8589	1617485220000
11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1405	861	169	6301	8183	jwcKUKNBarSyn8VyCBKEH953YSynjPpqivsHXn7e5PybwXDWA6c	6082	8594	8594	1617486120000
11835	3NLKCGZCXz1QYkcmzMm7UfLgigry3Aw7DqRxtY3dWwxB1W9p6Y32	11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	1406	1393	169	6301	8186	jx5YbDDKUmhgcFNHARiRjquBHX2TQPUxE2Xq7RZJYp6r8ZdyETX	6083	8598	8598	1617486840000
11838	3NK2uW3FRRtCHGxzNYA5P8vyy5NcxhtnQnxSfQXLuU93tDQuhjKs	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	58	915	169	6301	8189	jy2F26RH59kjU6g3s2VmiWHbgNVAm4fnwZgoFDkdmbLiamh8g3v	6086	8601	8601	1617487380000
11840	3NK7RGHyPrP6rtmkgJqhAnDvrd6d1AKdQSnxpuihzdfjrgMBS611	11839	3NKee1ANVGYro8D3LPzZ1fpQcwaUbk4YcjARdHb6ptpfc2vAFym2	1457	1145	169	6301	8191	jwT6sdX3M6Nj77fddcJB5j1GNe8XwENjSHEmRqpu4rqJbigBT4Q	6087	8602	8602	1617487560000
11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1648	1158	169	6301	8199	jwM4YJeVBhkRFuokcRBC7qtzUxiX2REnUHciurKqLyrr9GnaxBr	6091	8607	8607	1617488460000
11850	3NLkTAoxYsTEDeTT8N2Te9a781UidR2enBLj66Nc7v7woK4wzhPi	11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	1445	1044	169	6301	8201	jxwqGvbnfAqJpQXBaso6zTy6ScEdjLfeGmWNLHvzhogJp4NewXK	6092	8609	8609	1617488820000
11862	3NLSVygdQzPzLp8ngEQ2xAnVTe9LhG2Vg9FrMg5tGP6UQL9JMTdj	11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	1587	1231	169	6301	8212	jwzPapXfVUTJAUcaDQ6VSiKVdWKRDReDtiNf58EkNz5rRKyAmR3	6097	8616	8616	1617490080000
11869	3NLtoyTXzcJB37sN9vXoXfjyJk9GanPuvUYf5uYqjL15WSaD7BBq	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1623	839	169	6301	8219	jxTXQK33dbKfhiV9XuZ9v4PzUkYsmGXjKA6vK6Z4WWZet3ApS8k	6099	8618	8618	1617490440000
11872	3NL5H9RVA599NSaEKwbQCKvyukBhjscXEmK4BhSjH8ntf615nK6R	11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	1406	1393	169	6301	8222	jxDJuqwowGA3LEGyoGYVpXemrb7rvsu3Sngmwwcd4gNthEXsxew	6101	8622	8622	1617491160000
11875	3NKbAjiNzT79UTPbhMrtUW4ojQhThGpzKg8irFcFED6AxXMbPFp7	11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	1439	913	168	6301	8225	jwbx4YnWQVrz9jCHRWVp58VpG3jQsNjxSQvrC1Jh1YmADauevby	6071	8625	8625	1617491700000
11879	3NKu82MFgNxmeLudhYjNHo8jhtesQjFKVX8SiBK7guSzyZjd3kno	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1542	1304	169	6301	8229	jwEUbriFv2G9vpryDgpWhcHqdvTv9SNpxxw8UxJpRZFn8mRuQJi	6105	8627	8627	1617492060000
11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1406	1393	169	6301	8231	jwL6pP1yDsSsMR2bGUp3HUuqRJwa3KoQvLUgpFJx2HfkJqqTpHv	6105	8627	8627	1617492060000
11882	3NLZHfDM4qVCQs2LkrEJ6o1PBFCuDgre7aRv8CQLVTfCLmF59FK2	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1619	1275	169	6301	8232	jxk2KpJBER3YitW9mkoc7RhFMVJWMYkdyWWQef9U3DDPYzXWcJD	6106	8631	8631	1617492780000
11783	3NL65b6UdcPrWzwzdRxkbkNRcWTwFQ4XRTtjVun4bh9N3Wyjv3ks	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1506	1247	168	6301	8140	jwZBCZpTCNxPhnHHYSgMkVvX74VDjnfnTvZRHYhpuiKgpdrLBrk	6057	8555	8555	1617479100000
11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	171	1374	168	6301	8141	jwkAgxwJjnSKDe6oDqScxszczgFPz6Meekguinc2NrUL68fCDny	6057	8555	8555	1617479100000
11788	3NKuorYtumcZVJWMNQp2n39nnvX6j28JRD2tjdrrUxDUJvzh9A2q	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jxXFt4Dgdy98G9Lt2R8vBrTo22dPGyJKdbKSFxLXvajXnan68FK	6058	8557	8557	1617479460000
11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	1655	682	168	6301	8146	jxxx9DeGUWMv5fnprjoMLAb4oi5oko5BaKnGJQE4iwQ5U6zGTmr	6060	8560	8560	1617480000000
11794	3NKWBZdBm4TMxcCUBr5tJM7vT89gNfweHTVDNEaJ56fkgD5bVXYA	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1407	1395	168	6301	8149	jwPPXC8uqs99D78XsUjCgq8Z1Ukco486hSnh8XbKfR6gRTGvido	6061	8561	8561	1617480180000
11798	3NKPtbmoUZZpgWb9y2MDdE8xWkqhaUEWyRdsjoiMvR8E43EoWL4E	11797	3NLueF4obDZzkXQrGSVgzHcVJJBfEHWchqVy6oPLNiScjB6H2KPZ	1403	824	168	6301	8153	jxiQraiRD3ifcNe77vSE7XweVtVXsqtT4Cq8YetLZzqTdLSYtn3	6063	8563	8563	1617480540000
11803	3NKJ9JEqbzR6SiaVBUY2fB7BMT7idWTSDeBs1gk1ys1mEFNzFa7h	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jxKNxAFryrq7xG6ShXGFdaMZyPkrcvygzwFDXhZyyQhWQxPxxZy	6067	8568	8568	1617481440000
11810	3NLg5BzAHjdkSnTT827V2KF2ofDAbwojbMUwoyxkc79Td6waVU1c	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	1673	1368	168	6301	8163	jwm5HaRxTzgmioBrkhemavtqxaGJpo9hcuR7aPpRXu5DLVsFKkG	6069	8570	8570	1617481800000
11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	1668	1370	168	6301	8165	jxhobdmdXseExLi4DFUETbJcr2PhET3UPQT9xfWRwSbvxgVXJfv	6070	8571	8571	1617481980000
11816	3NLGyhCJouXEQxNtHQyw8WZeD4cSJJSeFgGAk7ig296FSsxM17DY	11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	1406	1393	168	6301	8168	jwYfPQytqYKRTfKj6awvEPPqsAbEqWrtcBKf8iKH2Uc2QeoibUJ	6071	8572	8572	1617482160000
11820	3NL9tme3azTVHfrV1aKrpxuUEQqYSiZWwZLUTnF3nd2yGvjak4XC	11818	3NLV6V7RHEBN3VDDQ3YsiYnp2nRkPsR1zk6BSt6yNn5PQsAhCUCu	365	365	168	6301	8171	jwgN77SCwV3ruuPKMJbr7jgmBFjB2eC9BiwGAYJaZ3PJ6pVqkFG	6074	8578	8578	1617483240000
11825	3NLJD23RhJrXimsUwM5zyxt5qttQbRbgTgSNS5gSvfPVd9uj7HhD	11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	369	1312	169	6301	8176	jwJ7pRETLDFPQcxjLrKy9qYKvWFKEGM4BKP98gCQm2619tT7i2J	6077	8582	8582	1617483960000
11828	3NLKoU2wQLRDsfLr26rSvDcFTPftJPxeBGAESct4Rmtm3dLZ5wav	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	298	1308	169	6301	8179	jxn9VfGTyjvp9fJ5aoK2JA4FoA3vinNnasKNpeaievoTFvPCdVu	6080	8587	8587	1617484860000
11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	11836	3NKhECZsdHVBQQZRkLuXuzJYGspL1EmfqN7nUfqxWciyezQmrfAa	1508	1387	169	6301	8188	jw9ogdELNouh8UZuPmM3UXK5VCuW51okLfM1fiDjeBC5A1mZWQ6	6085	8600	8600	1617487200000
11843	3NLhFSzkn7SArmU1f6QHvkyZGMVUf1NvfBv272bHUeHEotiTt5Hn	11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	1652	949	169	6301	8194	jxZhespZPSEkwMgZhs4iraTnhBY1HvwEVoVDbXyJpc6pCeSdCXa	6089	8605	8605	1617488100000
11845	3NLwrQxx73UArq4jAM3PTc3o9TDFFrRP8z53g2AJ85mD41cXyCWA	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1656	1343	169	6301	8196	jxwxmUGsx5ZA3o7XorK5UirwTATgJadN1TMeMVb1v95v8RocXMB	6091	8607	8607	1617488460000
11852	3NKPDrFGDi1nzWXmuibnCWWgE7jaCXsgQ8su5nvhNxPpV1HLmTJJ	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	1445	1044	169	6301	8203	jwptFaHke5p1ScPsxthCCLbbGhKFZtSX2MebeYUnP41xmjG2PyU	6086	8609	8609	1617488883603
11855	3NLM7fHZWmhcSvU9e7TD3X9TkupRmHFYc4FyApqhFV3j7k87qugL	11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	1631	794	169	6301	8206	jxofGAhKznAgajVFy417SWw8tRtHZ2D95izLef9h7BPud4jPLb4	6093	8610	8610	1617489000000
11857	3NLnyn9ujRR8SLhDLa6rBujUG66JR6af1xmxVJKJutgZrbudcjhU	11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	1613	983	169	6301	8208	jwMSo7Ptkc3kXBCcTCxUc5qiMc7jqC9xD5dCjsCHJHXeexxgKLQ	6094	8612	8612	1617489360000
11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	1445	1290	169	6301	8209	jxawyRLZQNZDKWKJffTYj9qUTJkX2D7HHpkbsQwWSzFwQhcNyj4	6095	8613	8613	1617489540000
11864	3NKg81rmiHcEr57ehKwmh8Wb3YScbRK7QsDjrWy2G1eioJnKzdaS	11524	3NKrJa1seRRyPQ1diKTbs73zbnuTATrMDakZUxjfiYFuZh3MF9JT	1654	1340	164	6301	8214	jwyPEtt9FeQmgnnVTGNUoXam1d5wrMCG2nRJFMJJBVCNpkDXgAU	5918	8616	8616	1617490080000
11871	3NLW7jFTSJfnYtJpUfAPK2hR1No78qsKu5CmxRHRfq2enhV5N8RB	11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	1610	1068	169	6301	8221	jwLY6SSnCT6DuTFWK6QK4U129L3rp4JpVAwbvSDGgHB147mCRqL	6101	8622	8622	1617491160000
11874	3NLR5XMpgManuddmwfP9BDXi4ugyLTDYTND2CS3vuXGV2tqC7awb	11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	1439	913	169	6301	8224	jwuEQ9XU883XAQF97ZV2eLsBhWdbu6KEFCRQGYENvSfpdbXzr6n	6103	8625	8625	1617491700000
11884	3NLj7uxNWyJ3ATJ6AGLaMJBXB7Z2HWo9t4ZGQDZD6ScNCoy5NCcg	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1455	1206	170	6301	8233	jwdQobgiQ8CZwpXbZrkwJJs3fUXndzj8fbgdD5hnnBGFSBdLXye	6106	8631	8631	1617492780000
11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	1403	782	170	6301	8235	jwUmY2TDDSKJMWHA8Ksk5b2JJSx9UMVwCpRWk4H3oqHa2UDNxkZ	6108	8633	8633	1617493140000
11888	3NLft7Y6WDV7YHVtep9rg43EehFWvPfNhgwNBz6iwzVygYBEcS6Y	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1481	790	170	6301	8237	jxk7MCZHHKzwRC6FqMTByva8KJDNbXCiTzcL6HqYYtbzDs7Wp9C	6109	8634	8634	1617493320000
11896	3NKomrH8iAyqMfziJsERLB8rHQ1YhJLa4c6mWJMbXaPtgTrLH1sw	11895	3NLDnBxh219VwdW5iq9r1PNFm5jFtH6cVHdJErcnqt9hEd2u9uaM	406	406	170	6301	8245	jxWUt76ePaSRjiTL1H99Bh82U4gPan1Dfy1oN9TGSJVpkEUWEGa	6115	8642	8642	1617494760000
11900	3NKqykdFAEUQTSLoxWcqGZdS19gSMLPUPBF89yP1DSFTE4hic8kL	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1631	793	170	6301	8249	jxVSQZo8Udd1yrNUySYQDnX9apZHPNcfqYevNT4She6oPkbmvXd	6118	8647	8647	1617495660000
11902	3NKvuhZzuwLcXd8Zrx61WyAUHrfLvWuz94N3fKJ78KyqmJ2xt2rU	11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	1403	824	170	6301	8251	jxaNSUxF9WXt7NB6aP2DHsRN1iJmp86Sdnff21HECD4zmzFZMBs	6120	8650	8650	1617496200000
11905	3NKyjgp3XpSexYWmke4F5ABNYV3fjqtja4nwzBFTx35xN7ZuDHRr	11904	3NLAUtWvnUR8XyvcVc3aMALR1W2CEytEEufsvbRLtQuGukGZciHN	1631	793	170	6301	8254	jwbo5tkxbF8SJsFVYCy6LNKE4QEVQodzXXi2xABJzUzRGnLjrMT	6122	8652	8652	1617496560000
11907	3NKbRv1y1UkrqqCpMyymJJKw2ccf658Anqt3emVkDpe8na8EmXVd	11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	1609	1087	170	6301	8256	jxLxq1rNKKLaJv7L4vAncgu2CymDi5B7TjwvXD2A8BSKav9hAZP	6124	8654	8654	1617496920000
11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	11909	3NLrBWPcmTR1nQP4969AHwgvHFyzDb21XyYLnyAPPp78PHf4uuPp	1578	1170	170	6301	8259	jwE7YNi8h5ftyDByzxMZdqQDs3Hrt9G9CzjjY6L5JSQyUzXe94H	6127	8657	8657	1617497460000
11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	11785	3NL2iDCv5d1kshYoDrMJ54xVpcyF9vFkGg3eZGCi9NYc3sSLMBS2	1440	1011	168	6301	8145	jwgAtwnXRy9o2XeitfdvV1QvdpUX75GaNvcXE9SJ64e13Wwi174	6059	8558	8558	1617479640000
11793	3NKPh9BBawkQsL1E25yoCCgV8Di9wbtEB1xBQTmXa2jGaELqo327	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1559	1353	168	6301	8148	jxoecKUA7TgzpYAsuKCWxRDoD9ZBeB4oGM5iMVwPuuoWoqGKhAb	6061	8561	8561	1617480180000
11795	3NLK9VsX8HKD1SwXKvnKXWZ5qpP2ev3HFpiwQGngHCEdtyVX1cdV	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1631	794	168	6301	8150	jxitiCGLqnt7qxMd8y4tkdVgttSuSm5f8ZQNohCMPnKAzqdVSNc	6061	8561	8561	1617480180000
11797	3NLueF4obDZzkXQrGSVgzHcVJJBfEHWchqVy6oPLNiScjB6H2KPZ	11794	3NKWBZdBm4TMxcCUBr5tJM7vT89gNfweHTVDNEaJ56fkgD5bVXYA	1403	31	168	6301	8152	jwpYsS9xmYu5nswUK8yU7jcYYpSKUcpSDygf2tCG4eoExTnPMVb	6062	8562	8562	1617480360000
11800	3NLLaoHqNceu1m2uS9PWiTEeqMLD8zQUag3x3eWFUp9NbHtbaadK	11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	1534	1317	168	6301	8155	jwm2xxdU8zbFXGjdraYGDhkUKDHtnBXggdmh6NY5HgiKUEV9bjX	6065	8566	8566	1617481080000
11807	3NLtFX7SEbRKZVZ4fjLxBeEJavhqAnXZpt8e8QvDXW45dTAS2aN7	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1477	1350	168	6301	8160	jxEFfL8vBEFEs5FD2rKiArcL5ar84i3Wqg62EFjM4kYh4iSe9fC	6067	8568	8568	1617481440000
11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	115	115	168	6301	8162	jw9fjLHG99WfsW4tou4PLzN5gG7f3gW52nVkKu2x1qvQPnro2LL	6069	8570	8570	1617481800000
11815	3NLn1UtHkBBLgvtk1oBkwpjW3XKrRs5hbnmJkHnbYB4VoToZfKXs	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	532	1177	168	6301	8166	jw83CtCsnSGF3gTaUvq3kyvbcow2sxR1dBUQU6ePBk2voWGjNZk	6070	8571	8571	1617481980000
11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	11821	3NKuRhdNSgfmEdQ1UzpnEQR5FPw7USAvETxRWVJvDPHPx47hme1w	1402	874	169	6301	8173	jwRJUvQ6ivibWiDDe1G1Je6pizVxhd4TqjpPKQ2omQN5CTHAzwB	6076	8581	8581	1617483780000
11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	1422	971	169	6301	8175	jxdfhASMB1N8GxWx1M2n7FzhYg9dK7aAMeXSa1wftLM7tuiJtuS	6077	8582	8582	1617483960000
11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	11826	3NLL9Q4twXKnjqv2wUmyXcLezLvuSADa9dQ3vQKPmMnhKkjzJjg6	1637	816	169	6301	8178	jxweGiJhrC27rxWtunUYDf2xYuqfRnZfz366JKcJBMyYE7TysRY	6079	8585	8585	1617484500000
11830	3NLU1PDJyJucF3TJS91nbHNPHML4Js8KoeWqc8W8wq8MnWvHVPq4	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	606	1049	169	6301	8181	jxJRsG2eVyhtC4NyowyHAhDXj4VsAE3w7KMHxxmeZ8ReY6UtFtT	6080	8587	8587	1617484860000
11834	3NKnv8bTM9ZcDHPYhyBTkLg59XjBA17Cq8V3dW5Uf9hkKahNEsnv	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1637	816	169	6301	8185	jxkXuniDcVgCvnSCsiuLVRHm9mhAQPfJASPSGrww8qoWA87rDFu	6082	8594	8594	1617486120000
11839	3NKee1ANVGYro8D3LPzZ1fpQcwaUbk4YcjARdHb6ptpfc2vAFym2	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	1406	1393	169	6301	8190	jwjurzwt3cT5eXhjNn2BnpUbc57sDRyqvc8xCXYk8vJer6z9yP1	6086	8601	8601	1617487380000
11842	3NLFbYKRTc267peAoUjFCvugtiwkSDzu1W9PiD3B8qQomQTciFne	11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	1490	1274	169	6301	8193	jxYKRprCtShmb3CjsevfkeUzkxb2ZBGKzo63NFCwrWRjaZ67Lyh	6089	8605	8605	1617488100000
11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	11842	3NLFbYKRTc267peAoUjFCvugtiwkSDzu1W9PiD3B8qQomQTciFne	1403	786	169	6301	8195	jwNxqoEjSu9An7fbGoHUemgyvb2hSApquP4jMM1NrK5cq8uQYMH	6090	8606	8606	1617488280000
11847	3NKJFXBAs5LrqDWEhPNiuE5uxqUpmnXLy8RZo7ZzhmKLasoAjQNs	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1489	1380	169	6301	8198	jwrLGYqWsGWxcyyyLDMUPAzWSBsrejSMHLCjx9NAvuBqU1Wnhbh	6091	8607	8607	1617488460000
11849	3NLRb6ZbymkMnH8qJzMTqqPs6xvVxqU9XJBb28Mzo52BioQSjqu4	11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	1445	1044	169	6301	8200	jxZUVHWZAcHkWve3XWQfk7uPza4vPG5uaxcaX7mnockKTfw9MVZ	6083	8609	8609	1617488820000
11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	684	986	169	6301	8202	jwsonvnEB9RDRxabW7Kb4Y2nA1aqtZPFAEsPLmKDELERcfoWpfx	6092	8609	8609	1617488820000
11854	3NKQvzqVwRt6mpuB86tyR9GW24rGHGiL5ga3wyLjdGhSKdZqXW2F	11806	3NL2YGKfMwDTzg4oBEufKagCq6JpC9E3YzFhpwcDk5s7vAujFDao	596	1060	168	6301	8205	jwY5x7KxynMuz2nSvafieZsLhY2vvRu4obrCV9DEq6qaNmHQXS7	6068	8610	8610	1617489000000
11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	58	1035	169	6301	8207	jxtrH7uuqT9KsYJtWjFf7CrbmnynXZ5RQxa9dSEKNKdzWjJwWh4	6094	8612	8612	1617489360000
11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	1553	776	169	6301	8211	jwy69v7CKVNewbwj8UWbGJSQ2oCt5MJjrpXxhYq2NaysTmQx5uF	6096	8614	8614	1617489720000
11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	1654	1340	169	6301	8213	jxEf1s9tPeUeHzJSMZbgaRYwZHeoyMpwnY5efwuLtg3TXo2gugC	6097	8616	8616	1617490080000
11866	3NLMZ65ttefAbaaarzSKgc924KzdAZYpDEzzQGuw9Bd5273fJPPW	11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	1561	3	169	6301	8216	jxbSpNXnPkV9UGB9KFeWnCLmgq22nzqzNUSuZyXThwk9kv7Etjx	6098	8617	8617	1617490260000
11868	3NL7P5Y1EihkwmfQqgBoAqU6XzwD1qaCNmDpUWJcLFFVBG2Ae4Nm	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1403	824	169	6301	8218	jxrHRjGU9PT2myWEKG48YPZkfcvSiNCbe862KiTkyFypWoKF4tc	6099	8618	8618	1617490440000
11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	11869	3NLtoyTXzcJB37sN9vXoXfjyJk9GanPuvUYf5uYqjL15WSaD7BBq	1406	1393	169	6301	8220	jxddZiAn3xWeP4uYx12C4ybVwQrtw3mmPZ8mKHmsNbUNeitsWcu	6100	8619	8619	1617490620000
11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	11871	3NLW7jFTSJfnYtJpUfAPK2hR1No78qsKu5CmxRHRfq2enhV5N8RB	1657	1344	169	6301	8223	jx6rsvoUMnWSEigCHZLyUqHj45oQDskM1CWzXuNr1vZ9VzDy2nv	6102	8624	8624	1617491520000
11876	3NKoJJcBApFyopjvUouwWdXHHo5kJTz5NRGSM6UKJBM85Ar8MwbV	11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	1407	1395	169	6301	8226	jx9u95voafNhurveH2b7sdNGu9x94rjGDXEg6zvPDYdSLtgsEjE	6103	8625	8625	1617491700000
11878	3NLGY75wkHzeXm8vmpE7qcz3WSdnjzAtcbUSr297AXya3QS3QSeT	11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	1542	1304	167	6301	8228	jwpj1ZqgAcPm7VnzPUQsTRBXVuDcNhJqj9h6yAz7hNtwKXUzET2	6035	8627	8627	1617492060000
11883	3NLLS73noAyv2XT4gL3jBrSg6kTPdQNTKSWpd6Sv6EFdJUSuDE5A	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1619	1275	170	6301	8232	jwD6tBp8yMhFXFHdd2AhzYqe6TX4yGg5tdck7v47tqsXjV8zF9A	6106	8631	8631	1617492780000
11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	11884	3NLj7uxNWyJ3ATJ6AGLaMJBXB7Z2HWo9t4ZGQDZD6ScNCoy5NCcg	1643	933	170	6301	8234	jxFnTKYJG5y3A5yFmy4mFoWB4GdTeUkK8VpdarqSwFD3B7HeqAo	6107	8632	8632	1617492960000
11890	3NLEYoysrjbK1L1oAroYFoyK4Z58WuC1x1opKuPZmBmmeR7WVLvF	11888	3NLft7Y6WDV7YHVtep9rg43EehFWvPfNhgwNBz6iwzVygYBEcS6Y	1506	1007	170	6301	8239	jwcCbCURxcEjyMqmnCxj7XWkwHwPXfAqVM5vAqsGGwH8myVtcBK	6110	8635	8635	1617493500000
11887	3NKHzF7dZNNWbPxfTKU9GipiqYSVELo8kWCxyYe4SYXhtMvs4bsu	11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	1507	1034	170	6301	8236	jxNS6apQPAAUJu2b6E2qGaftDx6DgdLt7PgYDnnq4CxDrTRydCj	6108	8633	8633	1617493140000
11889	3NKkR7ZBM9PqfHzaH9ZDPcFFXK4fHbGzWZ2aKZ1EbHJ3vC6iPjeb	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1564	972	170	6301	8238	jwfjscgxuVtL6TjnynVPoWhtqymeiwqq37DopYCqGf4YeSwUgGU	6109	8634	8634	1617493320000
11891	3NKSMiEeQGixYNddoRYrd2SxJD5JRzXCxPUs85Ap6etPUXHh8MJk	11890	3NLEYoysrjbK1L1oAroYFoyK4Z58WuC1x1opKuPZmBmmeR7WVLvF	1406	1393	170	6301	8240	jxKYrGnuDsZgRvMi4E62C4tvugBCjMxbgeB7vXkP4fxTuEiniEv	6111	8636	8636	1617493680000
11894	3NL7x7XQXvusWTDdZKvJBQnYJS2euW9gLRzw7of45ANyNmRVKLDV	11661	3NKCgYrZyPWYwmzq4eSKPrLqcGHVt1frKR4izfzuoCyYhBE4zn9A	1458	1197	165	6301	8243	jwi9CwprJ3xQeDruseoUhEJCoLkQDh3aSeezET13LcTZbCyzFTq	5909	8639	8639	1617494220000
11897	3NKeD75G5ScPJR3faWpGeQ1WH6GGgMfA9KKt7DTbcv6jW3uz95uZ	11896	3NKomrH8iAyqMfziJsERLB8rHQ1YhJLa4c6mWJMbXaPtgTrLH1sw	576	1355	170	6301	8246	jwWgXmNDMW7wC5KmEVuBwTkS3FrkqNe96tLoARgTEjx8nhUtb2E	6116	8644	8644	1617495120000
11903	3NLH82pSMqNgfGd1TUTimr7QPFQCAyteZWjV3HxKw6VYXTrNn7zR	11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	606	1295	170	6301	8252	jwa3pbJrmbYho1SxLZVN6uMUrfNtVNqXSuM9b11MmtvMMTHBtLJ	6120	8650	8650	1617496200000
11908	3NLeNVDg13D4Bypju6Xyn675dAkocsfECLz91TBcjkfK4XAb2J6j	11907	3NKbRv1y1UkrqqCpMyymJJKw2ccf658Anqt3emVkDpe8na8EmXVd	1549	996	170	6301	8257	jx2zjcpNWEVyazARjqUT2V3tjiUfMHAzChCyvhmzXhjvmcpHGGM	6125	8655	8655	1617497100000
11913	3NKzHpw5vxkZrpaktaSdoZmW5EdzAiKTz2LVd1E4sTsjix7Miqz9	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1611	1341	170	6301	8262	jxjFC3mujf4X48v2bnQ4KZxsz3ucA9EjYfbM8vnTrfVCFaVwMso	6128	8658	8658	1617497640000
11915	3NLoZMvMty2djY1r2GD4WeS1BgDe734cd9qZBq5ngsdCN9vgMCRV	11724	3NLvRJRk7uMeNRJcw37Wr1wqdSfxi9G83ooze5uP92a5RPqq3WDD	1483	520	167	6301	8264	jxjG2h9SQ5g9tLnqdih8k4CXjGB46C9mwnU9S3UQpvSh1CW7pVo	6024	8660	8660	1617498000000
11917	3NKzu5SRegrUw65bVyDamhw6gw2f9fnSBTtFV78e8beq7Ac3CrCV	11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	1483	520	170	6301	8266	jwz1hvcGB5muFa5VV3zsYfJ5326iDMxYY2g1xbPjZmyRz9GhVgn	6130	8660	8660	1617498000000
11920	3NLC6WGHC5SZaggiXFS1vk8CUoutvkQKLfcmm4SYzBEP6SCGqbbk	11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	1489	1254	170	6301	8269	jx8bSTksga45zHJfgU9D35XxRzHQ8CbkkBbxFmMgmpwchdqYkQr	6132	8662	8662	1617498360000
11935	3NKp5hVDRPUG3QwCzjT5kZSwGVX6hgF4gZ9x63fPMhSusLrW86QM	11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	1657	1344	170	6301	8284	jwBV3ZWKjBqFFtyavdY2qeUx1Pu9MBKGrNmizALziZjV6iPHCCx	6143	8677	8677	1617501060000
11937	3NLHhLPoq31Pe86T1b6rDxQYDwHo6D1jAmmowxPvvKZEaDnqvE5W	11935	3NKp5hVDRPUG3QwCzjT5kZSwGVX6hgF4gZ9x63fPMhSusLrW86QM	1405	873	170	6301	8286	jwXpb5kpaaxWC1L4oet8UinnNVZ6EAaEq8VKn29JvhXQ4PmxhwE	6144	8678	8678	1617501240000
11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	11939	3NL2gF22hM2EFDdU3dPf6r9fJx7piGioqnJbsjLS6Pv4JA6VR3Xx	1619	1275	171	6301	8289	jxqDqft4y2ru99cx87W4suTKw212fZRiVTSJgQ3Nr88kWwyJzkv	6147	8682	8682	1617501960000
11941	3NKnWwFxWxYS8a7JGBF2xLepXGLxxW9J3YfUpJjoN9odsiRFsqcu	11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	1403	824	171	6301	8290	jxstbAXoA4pxSfQ9twFW8etAJMEZxzPaERT3R7J1qHLkJ3zp7D3	6148	8686	8686	1617502680000
11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	11945	3NLPjmmbaJiR8caF5FRAmLHLGksTtievNbeQvAmrZYbGQ6YJADNp	1407	1395	171	6301	8295	jxwzGvcY12zmrgCzQpHhnNdBQwRGah5A7aQw8pC6LttNt4zrUaj	6151	8689	8689	1617503220000
11949	3NL8RhToXcKE2o5jmUrvP1JMemf4EMG4DUqc5qHVUGShYdSuzP1r	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jwtmPuRXbew8t8h7VYtMpLfX85w1pt2yrT2QBezPjSJ8hLfykGx	6152	8691	8691	1617503580000
11951	3NLaxhW4r8PYtDu1g2nZ1ndQxwpYHxmWD1yt7FXGF2XfPdhnHziw	11894	3NL7x7XQXvusWTDdZKvJBQnYJS2euW9gLRzw7of45ANyNmRVKLDV	1458	1077	165	6301	8298	jwSyqP1bXT6H45qcJoCZr55hDBGzkYvGWafRVRBe2egXv3HjwyQ	5910	8691	8691	1617503580000
11953	3NLgQ9C1DL2d58Z5gLqPvoQgAaMtqvJpCNhmeMkvvUGhaL3aKhnw	11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	1649	1383	171	6301	8300	jwxHXqeP3sVCveJSGuwp13nWXVSeUM6DqdMkggT5qvDiqWCeRV6	6153	8693	8693	1617503940000
11958	3NLW2fQC3VonbCsRM7Dn8775tN8wMa1ZJLNWyeK58VZXN5RwsaSj	11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	1406	1393	171	6301	8305	jwzxb4VGCn7d3RbXghpx3NG1sDMw9wjUTkLBHcSk9Sz81vuyVjn	6155	8696	8696	1617504480000
11961	3NLTwnZLr3m9HFF5G8vgqTTKGmGiMi7zr1umXF2RFUWG2TvyVJPz	11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	1560	1291	171	6301	8308	jwjr4rvjPpyh259JxdRnnieZmCGADkjSwpVoMnczcyib1ZLYDZR	6157	8700	8700	1617505200000
11963	3NLrajBnjUAzTSppifnEcty453v15kMzKWNBf6MysfMMYj5asPKe	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1670	1156	171	6301	8310	jwXBc8KPG8gAih7FY82MkEQboodA28uiLougNkraRYgTdSExpF6	6158	8701	8701	1617505380000
11966	3NKugE5DbRDmUc3QjXrTLz2diiHYmpSag64LoG1JXp5E4H8W1AbJ	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1600	1126	171	6301	8313	jxR9hrxVF9tujFMEXytEEpGVz6Tk4X8VVKXbKpmG6VrNKDsfsWU	6158	8701	8701	1617505380000
11970	3NKEag4Wk3Qc5MLKPr3RY5dN2Ktji3ZhAXyxj987C6pd1WSzh54p	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1651	935	171	6301	8317	jxccbnfsSfnbiKtaLiQDgi7TRjsYcpwVMMyxBoo2rkrwMbct7u4	6160	8704	8704	1617505920000
11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	11971	3NKNzNthP2HKqvA1KpLdnSdGiAnmN1yYrHUNhGN3N8hLerDXDd3M	1444	1381	171	6301	8318	jxC2g8R2PSPRdUdkkzbb2aSAs5mu4Cu7iujVfz7q4g5mSvxvJcc	6161	8706	8706	1617506280000
11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	11981	3NKuUe69bw2D4cAPVaZCNKsPEynwVuwjurcJruFqESDK9RuHG27Z	1588	1392	171	6301	8327	jwJpvfjF2TxkyvTcVUDqf2ejQobmQrcU9Um1bhNYk2p6pfDnY6q	6167	8713	8713	1617507540000
11984	3NL5oqnfSQjkcVgb5agxzJZYJS1jjQuom9tH5MfUa8dCTEYZVmAa	11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	1406	1393	171	6301	8329	jwx99sY8Dx7HXEXWn1m5XSaToJ5AWUQFc4wfS18eMkb5tdjM2am	6168	8714	8714	1617507720000
11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1623	839	171	6301	8334	jxQvnLCbGgJ7GNJFjgpiqunUDqAKzAMp6zyVAAvtm4So8QQrEhN	6170	8716	8716	1617508080000
11991	3NKqYJmtY7hWGJDVpjc8HxdJweEfY3ACbPEiUfzxnp1MR95gB7e9	11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	576	1229	171	6301	8336	jxi1NSLaApcXhEPnBs8uW315SPaJ26nJscCWfLjNK3yGpdDg1ZJ	6171	8718	8718	1617508440000
11994	3NLcF9GLdjbtntQGQBaMSfHrCZc69FAR6882SWmJqxJdsKicS2h3	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1406	1393	171	6301	8339	jxajWFy3vgrjnyvQDPMr9hS72Gixt8vky7aXr3byKX6GadcDYJW	6173	8720	8720	1617508800000
11996	3NLQXqPE8eB1or3ADe4B1tVguEWLuuYifim8EqJ3TJCboV2EJYww	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	1397	838	171	6301	8341	jxwBrxwubcVHcRt1CCWWFbS2HfY7pcjHCRh67CZiWeCcmiZH2sX	6174	8721	8721	1617508980000
11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	686	686	171	6301	8343	jwbTJ55WipKQceLewKRQbaAow1sYHt4RHWJneX1fwkj9MGQxWSD	6174	8721	8721	1617508984364
11893	3NLg6wvu817hbxUmccwVQLGT5VafogRhMkZ7w1irhxKoYs7yiSAi	11892	3NK7mdW5bxNULKUPNSCyccT98TCr1FoNujhk7ziqjKztfhmFUrxT	1458	1197	170	6301	8242	jwGgcobdy1WiFvcT41TwBpJReFkhRWfLh7fz8BKHHNJw1BPvLkM	6113	8639	8639	1617494220000
11899	3NLTJP1FfikK6J8X5amHUbKJ9vW3oi2xBRcH2ERLWgotYigW5Aaz	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1649	1383	170	6301	8248	jxRZLwR2nBQ3KJzvwBAnMaC1BUcbv2eZ5UHC4GG6rjYeTyFvN4f	6118	8647	8647	1617495660000
11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	11899	3NLTJP1FfikK6J8X5amHUbKJ9vW3oi2xBRcH2ERLWgotYigW5Aaz	1406	1393	170	6301	8250	jx4vi6SDya3WjHZYKs2FE83QyihMEZjhp4t6xrMaGeHaG4Zg78x	6119	8648	8648	1617495840000
11904	3NLAUtWvnUR8XyvcVc3aMALR1W2CEytEEufsvbRLtQuGukGZciHN	11902	3NKvuhZzuwLcXd8Zrx61WyAUHrfLvWuz94N3fKJ78KyqmJ2xt2rU	43	1310	170	6301	8253	jxoDiVDxZujYgMFVyFuVKUqe65rJQM1HFmXnGubdmPpYk4BFPhm	6121	8651	8651	1617496380000
11912	3NLVgYbAxzRSdQDACfKnoem8JijcMv2E84LCHRVKYkbj62xFRVxz	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1637	816	170	6301	8261	jx8heanz4f7xhGeThJS2chc71eAKRrjhEVrG9bcrafAbg59VyV8	6128	8658	8658	1617497640000
11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	11913	3NKzHpw5vxkZrpaktaSdoZmW5EdzAiKTz2LVd1E4sTsjix7Miqz9	1608	1043	170	6301	8263	jy2doMkg2BftvPSHgg8ifv1jZQa5S6E4anPuWgKzkFjYygY3yhc	6129	8659	8659	1617497820000
11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	11919	3NLYMQcUh92CCu9LiyNMxA9VQnFRjPgLydPLtbRKVcv6Wb1sPJkA	1500	1297	170	6301	8270	jxQsQC69teDkTvMnCoYhY8eyBZBc4ULRn9A3sm5dk6yvBe9uEGA	6133	8664	8664	1617498720000
11924	3NKVk1s3cShYBFtXciquA8wKocGkN9YZQZade2rdBpzsuShSdXvd	11923	3NK42XPgzt1LM5PuDmFtcoEhNtA2yT4hMfoaT8u1uyXf99nvQzJy	1406	1393	170	6301	8273	jxX79i9FFTtgk5Ke4KownPQRoyqS1m6CTtXPJHjqCgTUXaHGBVX	6136	8667	8667	1617499260000
11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	11926	3NKAqiE1Tkp3nG1eeACXzGvWaYmyVn1MaZ6cpBgEYNMGHr3KxsPL	1599	1041	170	6301	8276	jxcPecfFoQpMUhJkNw7V4tcqVUgZWdshEt6PWQv5xCjfC8dXgNb	6139	8671	8671	1617499980000
11930	3NKoXDDPDroznKzrgYdKPkbV4Qd5C1hTTP3X39FZgBf6GhypZtNj	11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	1506	1373	170	6301	8279	jwMmJEHNnH2vE6xUndd4kukTv6uRZ49JyYHuy5An9jmBVTCniNT	6141	8675	8675	1617500700000
11932	3NKvtnY3e2odmMuFZbmpeJKuDrJwXavNY6tHrxaQBKJnq895Xra1	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1607	269	170	6301	8281	jxm7SRRQoETALL378g6juFWyWbzWbf2NCDzpgiqK9U6WzaFLmRa	6142	8676	8676	1617500880000
11943	3NLX6b4RkCcWFgUy8PgrixMN23cMu65KpGga44CRdbrP1yQfUhYa	11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	1619	1029	171	6301	8292	jxvFdLf7ZhaeT6toz7JSkPD7RR6U2JXtRpZ5U81P2yUUNPawFLe	6149	8687	8687	1617502860000
11945	3NLPjmmbaJiR8caF5FRAmLHLGksTtievNbeQvAmrZYbGQ6YJADNp	11944	3NLQJ44N43FpJdKoiHoY93bsJ5YnSQGQqFyuYpT1ZUGEJSUwWKbP	1609	1087	171	6301	8294	jxT1PT4j65vpbNtmQaEHH3xC3Ehhkezh9z9MJ8DcrEYphT3f54C	6150	8688	8688	1617503040000
11948	3NKmG6BRCFWSKeUMP8kiQiZv6HS3TbShqqNy6xmmyfRGjeWxYDBM	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jx8UbxRJrxV6v9oAyxAT4ty8ub84Cr1wbmpMSrmRcM2HeJhePRJ	6152	8691	8691	1617503580000
11952	3NLxwtsp2zFAAs6FptYd5byrNXxWPC68qgCM2iHzacKhftQPDnFK	11934	3NLofsZnCCXEV62aByXNsrQSTPRymBhz9gnuSKZapY8MpWyo5qUR	1593	1346	170	6301	8299	jxejEr4JpcNP2rUvm5Y1cU3qajiMdE1sQSD4tpXdhs37uuCCrVB	6119	8692	8692	1617503760000
11955	3NKrimRpkQn4QqA11zJ6LjEWqn1F2D7TcewJP1mm8CQobYXpXCgY	11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	1610	1314	171	6301	8302	jwUjsz6QRaPXmVkShXXiDedh5pUzN7trw9scZ21FRJcJxaMEdLw	6154	8695	8695	1617504300000
11957	3NLpwFN8pkhz1C74XNiwWFgYMRinGZrFtsUyh1jQcj7i2ojcKYrq	11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	1403	824	171	6301	8304	jwFHgQKhe8Aaf87RiyqFCD5pE5f2VUSxrkUhXK6mQvBmPrUF9kF	6155	8696	8696	1617504480000
11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	1549	1116	171	6301	8307	jxTUn9boLdnwCjH1hqgHb5iFW1ewZ7MXYohqncwsjqEVduDF3J3	6157	8700	8700	1617505200000
11965	3NLkUhcccmtV17w4x4KpHwUJw3nijovRfcdrKDTsRjtcg4d1ZJRC	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1672	1285	171	6301	8312	jxvGpm8UFgeWKUZHFYW1zaFj6gyfmyFW71KutXki4FkoYzwdrCS	6158	8701	8701	1617505380000
11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1406	1393	171	6301	8314	jwYYEBG4pHnQ4EyDXhW2DjH1xXxjFmCScNvxaytLEPs6KoMzHbS	6158	8701	8701	1617505380000
11969	3NKkujAAGEg32vVPGjbpGkDQY691NuwmeRRm55nE6rpcEfZH94yq	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1403	31	171	6301	8316	jxXiz1MpZHKARDWJV9mQviPK6HWVNtWBMEqV16vMJFj8Gzibitp	6160	8704	8704	1617505920000
11978	3NK6rK9V7TVZdEXLwaV1uFqfysGYikTYPUV4Pj8KzPv24AkpLYSq	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1651	1301	171	6301	8323	jwxm8mPsBfLuSiMZNFbLukBBRc9YHrta1WFZEiefn9ufo124ExU	6164	8710	8710	1617507000000
11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	11976	3NKoKkwQa6dSczpTnurza4eR7v4eRX9cgz8GrrFRdEmSoMGTr6RL	607	607	171	6301	8324	jwd5R5Kxi5EyFy8cMgEVHmpLsbYg7Z9hq84ZvqFEWnvqGrf3gem	6165	8711	8711	1617507180000
11986	3NLXszToZENoiRUAMvsvDX6YJb1sXAAPpjqEyPkrWEYsBgsc39Ys	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1448	945	171	6301	8331	jxnvrGXVDmZnwREoxzxVry33hTPg2opw9pFbUDZVdowXF3t4WXN	6170	8716	8716	1617508080000
11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1637	816	171	6301	8338	jwsrsP3emqQ1rznjPjFddzAkxtzkzn8AGqimWAnXoa95vwBVu4n	6173	8720	8720	1617508800000
12000	3NLAZHHPjYT5RJq54EH1sNTa89La2PxnLiPiUny2m3DE8bVeudvv	11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	1522	1322	171	6301	8345	jxyu7wVrc6KNjyY5Mj7sKngN5Ytr2ZUdAGiZyPeQvbbgN5YwgX2	6176	8723	8723	1617509340000
12002	3NKep4D3gGjhcRqjeyP2C7zYzjpGdz9Vwo8JRWzhMgMkdsyx4TZU	12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	470	1063	171	6301	8347	jx7bAcTpBnTgkUDs1cBKkhUToJSAZ88BC4fgJ8MB8h7mfTTxEYF	6177	8724	8724	1617509520000
12010	3NLpMFrGq9Hb4YmptAy8drkdDcxeggBVhATeafEi7hPeLsPqy26b	12008	3NKZe4u1NPTHvUfhKnmzptqoCvY6i915iXW8PfC8XVnhdwpNQJkT	1406	1393	172	6301	8355	jxdii97zmrdTVg7osYbcnvxqgMWSfppJWaPkmgNKBJ3VFfMwe5o	6181	8731	8731	1617510780000
12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	12010	3NLpMFrGq9Hb4YmptAy8drkdDcxeggBVhATeafEi7hPeLsPqy26b	641	1336	172	6301	8356	jxtNKcy2yoYQ6nnEpZaarUH6UrYWpvZj92URGVKuFy3dAttroyS	6182	8735	8735	1617511500000
12019	3NLbZ6DUeNSr6TJQuBhBSwAhs7d7B4NSUdWSHtzDXrJTUsWA4nrV	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	58	1281	172	6301	8364	jwmzuP3kG1KkTBynJonbv4bV7BaFhWJaeepBjUV4Tqz9DRNLesN	6186	8740	8740	1617512400000
12027	3NKqox4ec8fNmWTiJHUkGx48wbwDNNVaLpikeEnP5u9fPS6ng9eZ	11962	3NLLEdVeYRP8ohr8NXeV6BQT9MDZ9pABXbNj2TyyGwkuVWfHp1gw	1422	1211	170	6301	8372	jwvnSSg8RZwcrNgTF7CLEpMF2KhnX6kyaAyj1HorQPuggXkLu7D	6125	8747	8747	1617513660000
12029	3NKiFTUF2yyCK2FopvxZFu6CDXXbqdkuwu2JNF3cJa7QJjfNdQLt	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1422	1211	172	6301	8374	jwG3g7q7u7UeCQrqE95Stq9nkZxzh5gyMZ1LeA2YqPWqKHN9sU9	6191	8747	8747	1617513660000
11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	11897	3NKeD75G5ScPJR3faWpGeQ1WH6GGgMfA9KKt7DTbcv6jW3uz95uZ	1573	1318	170	6301	8247	jwzraetQi2JNkdSpmsBFT2CSEKyMGsw616tsiPh79Uu2kQBJQQu	6117	8645	8645	1617495300000
11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	11905	3NKyjgp3XpSexYWmke4F5ABNYV3fjqtja4nwzBFTx35xN7ZuDHRr	1588	1392	170	6301	8255	jxwyWMM1uJjq54ZJ78Gn9pgKDos1BYuRBAHSEgEMnDrKDuCToof	6123	8653	8653	1617496740000
11909	3NLrBWPcmTR1nQP4969AHwgvHFyzDb21XyYLnyAPPp78PHf4uuPp	11908	3NLeNVDg13D4Bypju6Xyn675dAkocsfECLz91TBcjkfK4XAb2J6j	1631	794	170	6301	8258	jxa612prRVn5VbfRFJDNvMv8uwNDXji4awTxHzC5c8nUG6hfNRz	6126	8656	8656	1617497280000
11911	3NLtn5T6z9LGR3Xiq2RUoomRc4UjC5Cga1i4jWNY6CeCDCMmffKm	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1619	1275	170	6301	8260	jx4Mvtj3UVKzxw9Hqh6m57UvKd5XSm2rjBRTHRR8MVNEnKbU2VZ	6128	8658	8658	1617497640000
11916	3NL4jKTFMHC6MDHdLKLgxH2T84BGZGF8DnsYBdGefo9NX8iFBKGF	11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	1444	1255	170	6301	8265	jxfVzWTCVbumoPFgUqX9vafJ6MFSWH6dBvVYGXGisZAwXe6Ew8q	6130	8660	8660	1617498000000
11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	11917	3NKzu5SRegrUw65bVyDamhw6gw2f9fnSBTtFV78e8beq7Ac3CrCV	1507	1280	170	6301	8267	jwvznNA5CKHHJyvxqEHG6tu22eyM2FxZL2rSHVPY3mmXgWi8t4N	6131	8661	8661	1617498180000
11923	3NK42XPgzt1LM5PuDmFtcoEhNtA2yT4hMfoaT8u1uyXf99nvQzJy	11922	3NLSssZtrfVoeby2My7xzL9W85a4DmAT3gEJEDJZ9F6VRg4mpe4W	1637	816	170	6301	8272	jwSMxgHHSgTp2vJpyQk4JZWy5Xv1cKFiXjddq5z95Lza4JrqyjM	6135	8666	8666	1617499080000
11926	3NKAqiE1Tkp3nG1eeACXzGvWaYmyVn1MaZ6cpBgEYNMGHr3KxsPL	11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	633	1384	170	6301	8275	jwtubXTntTwF9ESAkd5RUvAYQ9bjraRHJWZwUzBCbGTXo5VmDaf	6138	8670	8670	1617499800000
11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	1623	830	170	6301	8277	jwC7gjikNKoURcmWgz6tSyfiFZviswZsxgiyrXydsaFFNpotiw5	6140	8672	8672	1617500160000
11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	1673	1368	170	6301	8280	jxjcbwFhvmgPhF9zrV1Rsxn66upr4DpB7XgN3aovBp25yDwvPfh	6141	8675	8675	1617500700000
11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1406	1393	170	6301	8282	jxQRwD5pYrcJKCQfMFEfw8uygPzc52MJt4VaDg8VzBbd5ANpfL9	6142	8676	8676	1617500880000
11936	3NKMBCh7QAWDDs5u2HtVJJQ11VbDNi7uDeVsz29xCRYEHX4qz9rm	11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	171	1374	170	6301	8285	jwKhBMAaCD6HsVAimUUpQam71W8nNG5wDr1nQypVB7pEknyn9uv	6143	8677	8677	1617501060000
11938	3NKKqhnRaGoYMRi8QaSue7omytXe8AcSHakz56Vmr2Q4MH2RxuFF	11937	3NLHhLPoq31Pe86T1b6rDxQYDwHo6D1jAmmowxPvvKZEaDnqvE5W	1406	1393	171	6301	8287	jwde1s89RKkuumcMUddYJJjgD6Cia4y2roV2MkERzfedEV49iQa	6145	8680	8680	1617501600000
11944	3NLQJ44N43FpJdKoiHoY93bsJ5YnSQGQqFyuYpT1ZUGEJSUwWKbP	11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	1406	1393	171	6301	8293	jwCKPDwkw5pnVzBvVe1C5fTjhLjEJCj4FfdndLUUpiMGaNdBXD6	6149	8687	8687	1617502860000
11947	3NKwJ2tNCudvi8r8PjZp9cuH4uzToFEoScWwJs9H39QePJRNfBUz	11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	1458	1077	170	6301	8296	jx8ve9y6U2j3LvdEJX75nU5QBEfLoUuK9DBS1cPRbyZ17NXP2zm	6138	8691	8691	1617503580000
11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	1460	1324	171	6301	8301	jx8G81Xb2XCP2WpAzhzVBcrzvYwdLDBeUSjELa1gdJbSVqbEiXC	6153	8693	8693	1617503940000
11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	1476	1245	171	6301	8303	jwTaatzsrv49xefgKJ3G27CpMUtQeUFjvmcCqBQwGmvMKquFss1	6154	8695	8695	1617504300000
11971	3NKNzNthP2HKqvA1KpLdnSdGiAnmN1yYrHUNhGN3N8hLerDXDd3M	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1651	935	171	6301	8317	jwPiuHKAd5NysAfAiqZMsqVRvHboaGUQsH9AYfvnmsxAbYiLpfu	6160	8704	8704	1617505920000
11973	3NKdd5UDZ2GEQmB2F4Z28dCRKDm8dx2Jkx6EyQZen3BBwMHwqwCi	11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	1637	816	171	6301	8319	jx7sK9DyCCV7m7WSDi4jJiTj4J8QXQ37oZNn36YXZbrixnW8r8J	6162	8707	8707	1617506460000
11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	11974	3NKZ3GEFc98gUdyJreymfhYaqQrMg9NDr5n25aDTLWGHaraYBoF9	1624	1334	171	6301	8321	jwDB1vfs1eyyK9XPfkszexyg2ECn511xx1VUPkwU7SMzxQSW4be	6163	8708	8708	1617506640000
11980	3NKSfJtGmZgAgGhiFpGhTyZDKAXqBBYQGtVdQ6wMYyLwSDBErgBs	11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	1637	816	171	6301	8325	jxd1ur5ZSwa7hSLZ4JwiaLt967QtWtDUWrcxXcY12WgLdFdAtbT	6166	8712	8712	1617507360000
11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	11984	3NL5oqnfSQjkcVgb5agxzJZYJS1jjQuom9tH5MfUa8dCTEYZVmAa	1536	947	171	6301	8330	jw8CJ3BDmaUoJUFZqCY8D2jg7ytHv374qEJEmqRW8oQ11vGhv6u	6169	8715	8715	1617507900000
11987	3NKquzqqWKwVvvm31dE4hwnG32rhLvUwHxSQG9D9iDpbNvRcRQvd	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1460	376	171	6301	8332	jxsPgWP2K9wUPGiNDeWp1rnNCciwxJsPj4K5BTHqvueu4ZaqZwX	6170	8716	8716	1617508080000
11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	11991	3NKqYJmtY7hWGJDVpjc8HxdJweEfY3ACbPEiUfzxnp1MR95gB7e9	1555	1101	171	6301	8337	jxXPbhVPr19JVHPw3R1pKsTX1qPm9SYLAUMes15JNPhhKCAam61	6172	8719	8719	1617508620000
11995	3NKHXEFja1xGbxGQHpKzX4x9yrUVqGHtrxJCKccj3GRfanbHLbw7	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1675	976	171	6301	8340	jxATkXHHWupFaQdqrHm5iQKoUrfHdPeCAG6qt2XWnSNJ3UpzKCJ	6173	8720	8720	1617508800000
11997	3NKKXW85LY896NSDFkBqFEZ3Bcd6MQDqeVZc6RnP3RxZDt78AYPU	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	1403	824	171	6301	8342	jxiGeDhJn1ow46dqjnTrtrHiAPc17X2nUR3tKuJjFckYKVDYXcR	6174	8721	8721	1617508980000
12004	3NK8gpMsMsd3dyhpncPvsfNKteqXhFn47U6rXMYf8SariG87qTpL	12002	3NKep4D3gGjhcRqjeyP2C7zYzjpGdz9Vwo8JRWzhMgMkdsyx4TZU	1656	1217	171	6301	8349	jxwnCyUGj2aqrtsLX9GBnWgXzYLNksiVPXSFVCggoJ1sQJ5R4H5	6178	8728	8728	1617510240000
12012	3NLHsX1itdffYo1HVsygshW51xWu94nfgNtDtfnr1maZjK5naNGf	12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	1622	990	172	6301	8357	jwvrqd2M3iyEabZc2zGndmfQskPZkViNYn56a9XoRyuECFv1JSz	6183	8736	8736	1617511680000
12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	12016	3NLaCHnQ391xMMGQ5kQdM6UTqhvbvJGuCHtekj5UZ59MzzMWdTai	1483	620	172	6301	8362	jxnEZQNb463jkWcH1gR51KAew3fCxbAAjn7EFTSYypz96X1b1iq	6185	8739	8739	1617512220000
12021	3NKmmZhsPPvSNjtpHmL1UFdhaEMBpiNZkiQSHxPL1QHF7NhynkEi	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1624	1088	172	6301	8366	jxTgW8ePAQbkGF7888uzujUdoHX6isHUB5BLqAYCQYKav2porrJ	6186	8740	8740	1617512400000
12022	3NKD3sku8SYZXe1GJjPKHArVTsEgJQbovr8KCTGAbE6ev6veE4PY	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1541	1298	172	6301	8367	jxLmBd7YAHSfEbqWvTPoNrso4MiyLQ4NhkRqRfq6mtWCNnyfusc	6186	8740	8740	1617512400000
12025	3NKZEb51jEBcGjs5HFHJaA3SRonQ3p4fsQ67u92k2cBaTRPHvQtS	12024	3NLrsy9ruRm49MKBPNTCP7ZcfHwteL16yz1JtL2JRfpKPxB3eVSQ	684	1352	172	6301	8370	jwExn6rJpXLSv6YKXmZJRfzLL2nFtXYnoCV3CzHcunz2NLiYT4j	6189	8744	8744	1617513120000
11919	3NLYMQcUh92CCu9LiyNMxA9VQnFRjPgLydPLtbRKVcv6Wb1sPJkA	11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	1403	40	170	6301	8268	jwVwp8xESRX3wGQUr5FCDSRx13bCmh7Mo83PH8J5Jngvh3JdZxE	6132	8662	8662	1617498360000
11922	3NLSssZtrfVoeby2My7xzL9W85a4DmAT3gEJEDJZ9F6VRg4mpe4W	11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	1407	1395	170	6301	8271	jx4oAiofDED8JY7xD8z2DEtnTdP2FcwwjKXXPhtoWUbPAvF75be	6134	8665	8665	1617498900000
11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	11924	3NKVk1s3cShYBFtXciquA8wKocGkN9YZQZade2rdBpzsuShSdXvd	1407	1395	170	6301	8274	jwo5DNGfL3Bwa4cU2oSgMf3K5CinoRcB69GioZukAik2nRGskrt	6137	8669	8669	1617499620000
11929	3NLBXmaz9yVyALnY3Dvk9KwQzpdcyh88zrsz1i8qk1fscxKh9Nct	11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	1631	794	170	6301	8278	jwTGUaPowMhFNfhq59UnwyKoCEEbyipXdC9qYw4pYCtYMcoyH8X	6140	8672	8672	1617500160000
11934	3NLofsZnCCXEV62aByXNsrQSTPRymBhz9gnuSKZapY8MpWyo5qUR	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1593	1100	170	6301	8283	jx3eHkT1Z1pDfmXeuLHtCrVsDSSBhuQTbmXi5ZxT5GFdnYXWz9H	6118	8677	8677	1617501060000
11939	3NL2gF22hM2EFDdU3dPf6r9fJx7piGioqnJbsjLS6Pv4JA6VR3Xx	11938	3NKKqhnRaGoYMRi8QaSue7omytXe8AcSHakz56Vmr2Q4MH2RxuFF	1405	861	171	6301	8288	jwQe483cVCXk2uHB12RsYEcyZragUyQTgmu3rKUqS9bVg6WDwU9	6146	8681	8681	1617501780000
11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	1624	968	171	6301	8291	jxr5TBTFxyPch28nVe1so3bUr6urWgTiMhJyYHqrJG9TvR1ovXD	6148	8686	8686	1617502680000
11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jwLoCrgnK11jGsBqvNJyzEPMpAef1TefWJoL8fZJvJqLL9Tv9z1	6152	8691	8691	1617503580000
11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	11957	3NLpwFN8pkhz1C74XNiwWFgYMRinGZrFtsUyh1jQcj7i2ojcKYrq	1602	1369	171	6301	8306	jwTVn3aAfoqERJVx9HBhpuTwXYFPGXU9czbsZvoEUcM4dU1PJJm	6156	8698	8698	1617504840000
11962	3NLLEdVeYRP8ohr8NXeV6BQT9MDZ9pABXbNj2TyyGwkuVWfHp1gw	11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	1422	1091	170	6301	8309	jwCQrTqrVW2tiCFN16qFd5cUC3Dxkf49H4zsyXAJnWkj53MttJn	6124	8701	8701	1617505380000
11964	3NK64MKbd5PUJFbLCJ6UpDAfqaxNLNczYLTKKEw68QW2EMYNqJZe	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1422	1091	171	6301	8311	jxbxZmSWhzitFXpUDZnGkxdN87tBy3FK4Ur7DHJ4VW1cDqoCo6J	6158	8701	8701	1617505380000
11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	1481	790	171	6301	8315	jwwYtT4Pcy2fy9Q3ggV6mnGmFqtiBQxhQUeUpBd15sftVwzadAq	6159	8702	8702	1617505560000
11974	3NKZ3GEFc98gUdyJreymfhYaqQrMg9NDr5n25aDTLWGHaraYBoF9	11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	1403	824	171	6301	8320	jwUAt4a8a3EBBF4oZLa8JecCpUPZtTsa1BhenyoWMnrbcAPRcvm	6162	8707	8707	1617506460000
11976	3NKoKkwQa6dSczpTnurza4eR7v4eRX9cgz8GrrFRdEmSoMGTr6RL	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	606	1295	171	6301	8322	jwxMDDL5dmBEtW2ZRufWr6VfZa3rZs5NQUmFbpDVcrh1oe5H173	6164	8710	8710	1617507000000
11977	3NL7huqXeJLdEsee3r42WrkkHdYy1knhj45GfJHmkYT3CBmK1K4z	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1651	1301	171	6301	8323	jwYHWbFtXU6eSERdTAbfM9YGXvqpGhmxfNTvtfVodeb6FiQrtFY	6164	8710	8710	1617507000000
11981	3NKuUe69bw2D4cAPVaZCNKsPEynwVuwjurcJruFqESDK9RuHG27Z	11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	1560	1045	171	6301	8326	jxuD6rdD8gTDiJ3M926syXTajkVLrBKjrJK9pRSvDKGXRvwNx5d	6166	8712	8712	1617507360000
11983	3NKggBnKa56tLYdUBqz4mUyH3MzWZrkJsk4U5VLXLN65pyTp2QbY	11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	1672	1039	171	6301	8328	jwWPGGivj6qUocajwPKfkBXq9fEfQH8DP9k9MpsErcWXUtTJo5p	6168	8714	8714	1617507720000
11988	3NLoi6DgPYDn3BcpCp49oPr8LufVAprmJsxTbWDn3FuGdomZb3kM	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1406	1393	171	6301	8333	jwXEw2dnU7jotEXcPMsx8BZp4vT1Sv2SmHCxfVKsZQwn1eGNPme	6170	8716	8716	1617508080000
11990	3NLgov4BzYESpvL8hinQRniiRL6hrhkpPdytJHSTsNohj8HdTBzB	11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	1501	1114	171	6301	8335	jwx7ZWhJqBojinGV8hxYuwXS1MJXn5LMzvfPgyUHw2mmV6tg9CQ	6171	8718	8718	1617508440000
11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	448	1179	171	6301	8344	jwDD331METaUutz8NUZvG5a3rLurztwo7NuArAXXdm1vA5NkFL1	6175	8722	8722	1617509160000
12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	12004	3NK8gpMsMsd3dyhpncPvsfNKteqXhFn47U6rXMYf8SariG87qTpL	1483	105	171	6301	8350	jwxvaATS8oF5CUMsvdEb6mR9uBKHgS7EuzMYyTFSCRVRbLPCQBU	6179	8729	8729	1617510420000
12007	3NL8UcVPqys9NjuXSwzuGvKndDRq4zi9j3K64nQM74L7ULcu4QJh	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	1675	1342	171	6301	8352	jxjpCL4p2sukq1rAtBXHqbhVF1uP2TPARqqv4VM7DRfrW5xEt6V	6180	8730	8730	1617510600000
12008	3NKZe4u1NPTHvUfhKnmzptqoCvY6i915iXW8PfC8XVnhdwpNQJkT	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	360	360	171	6301	8353	jxo5vjTHJPGzyvq68NKstPhDKTCVBsKdZfM2f6huoLrWmR1BX5k	6180	8730	8730	1617510600000
12013	3NKhrqGDGf71NkoBdXrwmQUZihEr39NXR3hAhQSEBkMUegaXxBaG	11875	3NKbAjiNzT79UTPbhMrtUW4ojQhThGpzKg8irFcFED6AxXMbPFp7	1439	1033	169	6301	8358	jwcr2VMjWWxHzYGbg7LD7GzSSvutAq9rnKVXtyUBmwSz4Xrj3qL	6072	8736	8736	1617511680000
12015	3NKnr8ffDttC5Z1zZXhhcwkhT436X5fmqyQxi4Wx7FHTX4MbrJ1s	11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	1439	1033	170	6301	8360	jxcpGdWChHKhPGNGx4P6ApFzPi6NrtmaweVVmmViYYydMnYWumz	6134	8736	8736	1617511680000
12018	3NLU39FzFq2Xct37fmRM6CamzfL6Wgdi9ppsqUnxbPNsV8zQucB1	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1471	1386	172	6301	8363	jxamhqAkukMExtDcwvn8YfksZfezYPoNUh58RqLcWxZaFXRdwXG	6186	8740	8740	1617512400000
12023	3NLvJ1RvFcodD6y9qnvS4LKYRc26zfvA2zTBRqnnFvisKKB9zeXp	12022	3NKD3sku8SYZXe1GJjPKHArVTsEgJQbovr8KCTGAbE6ev6veE4PY	1656	1343	172	6301	8368	jxbXrugbNPdPh2zYBaWyFL7FwHSQz3brB3PoujaeXnBeP9cs5UY	6187	8742	8742	1617512760000
12024	3NLrsy9ruRm49MKBPNTCP7ZcfHwteL16yz1JtL2JRfpKPxB3eVSQ	12023	3NLvJ1RvFcodD6y9qnvS4LKYRc26zfvA2zTBRqnnFvisKKB9zeXp	1447	1099	172	6301	8369	jy2AR58ibuowudJkBv4De44bN3bE31GPnJwLx5fhUuhb6XNeQvB	6188	8743	8743	1617512940000
12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	12025	3NKZEb51jEBcGjs5HFHJaA3SRonQ3p4fsQ67u92k2cBaTRPHvQtS	1555	1347	172	6301	8371	jxiXN655QRcKBAw14EDARdeG4uwoEZfeNXUgwDrSVvjVxLH38Qb	6190	8746	8746	1617513480000
12028	3NLWtKTrHLZC8vMcT42J1zwJ9JT19c3vW77eNzrycCsSx2j4LfPM	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	80	907	172	6301	8373	jwo2WUrq2HKpT77DMQb6QtDEoRc5CJS8moFS9qiY1u2UApBskfC	6191	8747	8747	1617513660000
12032	3NLs259XMpif1yA8HvCdJKriJa4sKVFwzKp1sxBTKs6YcdiatwSY	12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	1646	1354	172	6301	8377	jwEKCHgCacayVmwoykdyACSfGWWtKxT2B5oHEvnuvhRpVnh1Mog	6192	8748	8748	1617513840000
12035	3NKBc2M1oeoysDkeeXMaqQmEKhX3KhrKEpa6iB7AvHvSFdf2xM44	12034	3NK6kZp8ZmUAkL84nLWmbDYDe6ysxZWvD336aqvjDhNX7D5ZTHrA	1553	776	172	6301	8380	jxiZLj3Lkt81qrhejKySc5PJLU4rPP5hawi8r1ggpbKpernEuYw	6195	8751	8751	1617514380000
12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	58	1281	171	6301	8346	jwF7th4Ny3keUgAckyociN1Xw4zLfNLXdtNU21EpdT9S6DZcCq7	6176	8723	8723	1617509340000
12003	3NKR3wP3Z914LC6e47KfMZUfhF3rLGQaqRDCxRPsFfvgWwdVV2kL	12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	1631	794	171	6301	8348	jwGBzAv57KpyuRBGxaXYJ6qgCwiWMnNQ7JG5vh2ZTo4eetp4FQT	6177	8724	8724	1617509520000
12006	3NKQDM48uvixa915pkddVA8eX72qSuwJgyMSqKR5r6riHgZqGZJA	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	1403	824	171	6301	8351	jy1madhbt7cBYrkBkZPnWyHiCbfDC55Wms5HvryzT4voH8LhsAA	6180	8730	8730	1617510600000
12009	3NL15pEm9r43Xo2Aexf1EEfyaaj51zfaj5hGVc8F8dQuNRutYiPn	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	171	1374	171	6301	8354	jx57NaEp6zdZ9auCpvV7zRgoHf2pbE76vcVGzx3Ku9VwE1YABds	6180	8730	8730	1617510600000
12014	3NKijbkdx9AuQN3NnVKezd1WtPec7JBe78MSeSsV8Ewm4wJ4ur6n	12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	1439	1033	172	6301	8359	jwdckbtr2HwSw9n8kxUp98KfzEvx1D9oSbBWKWkhJ3PAq1GCq81	6183	8736	8736	1617511680000
12016	3NLaCHnQ391xMMGQ5kQdM6UTqhvbvJGuCHtekj5UZ59MzzMWdTai	12012	3NLHsX1itdffYo1HVsygshW51xWu94nfgNtDtfnr1maZjK5naNGf	1507	914	172	6301	8361	jweWsaT32ExKrPasdYNYfypFFkMdfDzPCywVWzU8MD51RpnyCHH	6184	8738	8738	1617512040000
12020	3NLMG8tcXVgUTXpcJ35gy5ZKsyqyPNntyqk9wuqb4DJaxo3dVqjn	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1407	1395	172	6301	8365	jxdzdHoNGLUiRPRw293dMBBpX2LgR9i2oaRR6s87p773azVBk4R	6186	8740	8740	1617512400000
12030	3NKwM4kmEu3qXNYz2dUd9erFxuRJ9wXWjoMkjKKKYrTxP91qHf5Y	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1403	824	172	6301	8375	jxpS2qHz4vvXzSb5SpsARoB3Bcy97CKGSAmmtFkhbFqz3aL8gJv	6191	8747	8747	1617513660000
12041	3NKjWHFPzoJVdYjVvtBgkK9zauSi1rqPe7beezTwChfacLQb9N8x	12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	1419	814	172	6301	8386	jw9NsqqbjjsWKEkYJQKt1x7GXch4M3krtA3bzpsZ1aJonHJZNHS	6198	8755	8755	1617515100000
12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	632	1016	172	6301	8389	jx7JJ3fr7HAtJaMQCzcx3s4SFytKoNwZfrqsqVmaLreXTbotPr7	6200	8757	8757	1617515460000
12048	3NKYWxKRKzvUsAw8KuAiVnsugrEuzKtUQQcCG9YUPu3P92G2yH59	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1460	1078	172	6301	8393	jwyFdSGrVkmFR3XycctyomxZXApudwWnwjoDUg73TAYzCGBfWnV	6202	8759	8759	1617515820000
12051	3NLEBcv2CuJgJxhEa1G7TKifTLRcfyCPMNpvFnv6aBoefn5cJFoF	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1553	776	172	6301	8396	jwsNYMKTFgUkky8fAK2Ku1bHx8LEnSYvcoowTDo1dV1vYUhfXgg	6202	8759	8759	1617515820000
12052	3NKevjRx9qQszAqnUrEzhwWkcHZr6GNeMm8xrAcaxFk8eMcrXTPh	12049	3NLpZuWfovesbNYSiS67fvR41jqCRVskazRMuRYUN6DtssJ3Nv8r	1622	1356	172	6301	8397	jxVzFXXVD8fepdoPaidXqTnhhBfxV9m5Ew772EU7pv2UcgoSihx	6203	8760	8760	1617516000000
12054	3NK4LY61rh7fWjhNQP2D3doRkEXXcHiTxZSjWJMvKYQdtuZBosdd	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1445	1290	172	6301	8399	jwyg9KrVKWBDMBawnVpwWsxFAbaf18uEPst21GXqXhp9L9Kj3Pb	6205	8763	8763	1617516540000
12058	3NKfP3i6FguUU7YKAXZrX9RWuz5RTm455mstAKCB26hr8m3AEoaZ	12056	3NKrJCtLxGfbQrL7nxAyG5TBkVdtzFzgNzoWvWFunSiLcKwneR2b	1596	1237	172	6301	8403	jxWLKCUsVb4dVrv2bV1RWAACPznMSsYDG7eT4fPe66XosrfiW4L	6206	8764	8764	1617516720000
12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	1402	882	172	6301	8408	jwqomcG2TUGxmpan7rN29Yv9687hC2zirdouVQHiNBEtHpG54Hi	6209	8768	8768	1617517440000
12066	3NLAnHxhNjqbKjgnYfh7MmLoqefsLSF54EB6o54Lx9BE9BPJ4x1C	12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	1601	1262	172	6301	8411	jwGRH47goHya2vcKoNxJatV2AACqkSB13TJ345AtWvLL8aANaVo	6210	8769	8769	1617517620000
12072	3NLq5Lbd3JEc1reWTYLPBEHE16abg38BAFFYnqK9iRF6cm8aVQwa	12071	3NL5Zw6tjg1XSXT7HpQRyy479FkSUpSC9WWLK6hvqc6vcdZrvBK8	1527	1167	172	6301	8417	jx6cWaCfPxFk5Rc4RqYXY8c9CHsbco3jG1J3UHBCJ2RPunitg5E	6215	8776	8776	1617518880000
12075	3NKRRMkdVSnVWr4TkW2LzhAQ3ova4QFXs75aRVHt7MZUZPboMaEW	12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	1406	1393	173	6301	8420	jwNvz2N1rnX5Ehx6rr7WJ3Y6gV8QVWtLHk2D6MfdLNbW8Cp2X8C	6217	8780	8780	1617519600000
12078	3NLPFvkdanQYL1k4N9oSqV8uMHsieHTAmBVHiskeHdj5YEUvewv1	12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	1573	1318	173	6301	8423	jxDzss1fRdQepWDZ1Sbj3S2mYNJWgNTPSWAXG3MfE3WPZNcy9Qg	6219	8782	8782	1617519960000
12083	3NL2qF8BdEFVpipyD457Ea4tGAQTR6k46N3mqgrDXdPYqwHoBUh8	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1675	1096	173	6301	8428	jwCQAJ9Jp8MfyRmqkP6thCHuvd1JbcJSa5Jxh4qu9ZkJXi6Efay	6222	8788	8788	1617521040000
12096	3NKFk1XZ1ycpXmtuy4jXkx4rSifBzGFmDQ4DXtgz1U26Q1J4QALB	12095	3NLfPeNUa4ySkeFcPG3xqPQx5vvTezpa4ad6LmMZ9FJeq9XQzg66	1419	813	173	6301	8441	jx13DhSkqonRVz7zfSqpDXMTZKQeWuvxFBpicFBW6EsLRfQoop5	6228	8799	8799	1617523020000
12099	3NKFddBajGC3skrvUDoUbFKxU2XmPvF82kgWnKVyBrnUwwcLrvwn	12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	1651	935	173	6301	8443	jxXSYQLv3meQtE9EDDih2ZLxhxGfFku1wMgmsW8y8578sUEYsJo	6230	8802	8802	1617523560000
12106	3NLm4rcvccB64Jsdz5ngHaDh58Ebcwqkds55YyDQYzcBhGyxySKs	12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	689	689	173	6301	8450	jwSYEdfgEMrwTsjfhXaRfsZoMkGbELcJjxuXJ8B6u13wzb2B2jC	6234	8807	8807	1617524460000
12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	12107	3NKVmy7vwivUTjxxmjZop2u8hTSoYN7pJAPNpNN1rRAqA5kirqgv	1643	1053	173	6301	8452	jwF2MZBahJBku8NCowfVrb9zBJtFmQXANYCtxrdbdE1G9BhWc8e	6235	8808	8808	1617524640000
12114	3NL7eWEnKcWPN6SMtvu5PV2cfU3RqerJcg4hb7JJphQ25SquwkwS	12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	1610	1188	173	6301	8458	jxYj9ynqaLxn5mXu9wYLV6eFn8x7xuV8zm1y2kFz5Ns2K6LqM6R	6239	8813	8813	1617525540000
12116	3NLpbW2Dk6HA9tDbH99H745dHtPzHicGDnxT67v7hvqq2TAnWPAM	12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	1549	1362	173	6301	8460	jxw1QbAkAEbRT9tx5sJuFvWYAwEqbQKh8t7Go7uuVJEHGrjkeNo	6240	8814	8814	1617525720000
12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	12117	3NL6uBAUmVNf1aCA6dBaoy5LhLK4vREBWN3DLPLtTEq88UUFkka1	1598	514	173	6301	8462	jwG5KmrQPJWEThRc6tE3xVBd1ZdR1vY8qSoEnPH782NwqXVC5Bx	6242	8816	8816	1617526080000
12125	3NKLtEBLjRvijamaeFPwQddTYQVuFgvNQNPqKQ3rm2QAbEiDbTZa	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1564	1212	173	6301	8468	jy2T9dMq32iRAuMdRK5BZd3P38ineq85rP5ejPHCm8hrLfRDGCQ	6245	8819	8819	1617526620000
12131	3NK4SjDExWbw9CAn3Ua8bhuSRknQokdURAwVcG1euyzamxmHg8Vr	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1578	1050	173	6301	8474	jx9GDzXahr8VduGYFjNZzWiU5fzLGin6UJwG4q5tsH11Kfjd83M	6248	8825	8825	1617527700000
12137	3NKHgHPGgb325foGeofiRetCLHNHDUA5N241XtdLaLszjPrd7PYW	12136	3NKLm2Nrm3evQTfzVePZA79223UJ1Ca3zd8t6Xdkzvt1ppRcCtts	1534	73	173	6301	8479	jwk861KDo1okkBwWhdza8anWbZdhYFcEEKmTV5zRJWJfBRLo42z	6251	8828	8828	1617528240000
12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	1407	1395	173	6301	8482	jweyZ49f1aFhG4ass8ePnwxtus9geW2ck3YNsAqRjDiHPaJREHk	6253	8830	8830	1617528600000
12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1406	1393	172	6301	8376	jwwUMCwk9AkfXmLQGzGKxXyz2yjdQ3AySpxmabDwy86yUCT5ojV	6191	8747	8747	1617513660000
12033	3NKt497xpvqqnCT4iJK5SaxoDq7PSgDXLKxX8WoqF6JqoiFPBfXn	12032	3NLs259XMpif1yA8HvCdJKriJa4sKVFwzKp1sxBTKs6YcdiatwSY	1553	776	172	6301	8378	jwckJCf4deqJeyuALyF87Qvg9EHrnFbbqssPcL55BqyxzhFiLqt	6193	8749	8749	1617514020000
12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	12035	3NKBc2M1oeoysDkeeXMaqQmEKhX3KhrKEpa6iB7AvHvSFdf2xM44	1637	816	172	6301	8381	jxdALZvhohupUNd95wshZ8jATSBh8VZtFmFP3qwMzoDT6WtXhhJ	6196	8753	8753	1617514740000
12043	3NKEFX5LxPnF9pbXxE1NuksFsQHcj64ZNwFZzeBRnermpWtYYJMf	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	1588	1146	172	6301	8388	jwym1NJxpgVq3EsgxsXTGCAVQ7DKc7HdWis92aGjMsbxNvFcpdZ	6200	8757	8757	1617515460000
12055	3NLP7k8Farfy7fDLdYjvJ7wqJ46Sb9Mxeu6F5dcbGTXxVZtBPEMg	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1647	846	172	6301	8400	jwGJ4a1ddXMGv1fAqBUfvouJ2J5VfPDYpN5DGUZHSEJKjHTEayD	6205	8763	8763	1617516540000
12059	3NK4ptGY7tzWL1DppKUJeTtJbsFQkY2b9q3G48sfdtMA5eefaGC8	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1440	1011	171	6301	8404	jxAtqCqP1fq5SnZtFz1PExUjF6tGrjdM6ZoEa9DoYC9Ar1qpW99	6164	8765	8765	1617516900000
12061	3NKkv76T8senu1pZXCMMbq6uv63cSYKgrH9W7VsBPBvpsdJMZCdw	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1440	1011	170	6301	8406	jwUFHjGAcpXkwsZ9w5HMChqumEcdeNZiYGbwN3Gc9y2vbY8xZva	6109	8765	8765	1617516900000
12064	3NKTLt4nU7u54pZo7FCjhTBNhBBmz3ghKfNvuTkxoWDDDDa3YHeA	12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	1623	830	172	6301	8409	jy2ijf42a1K5N2oU6oXmiP5wRBxFa2CabuS6viByyqbeJWotWAz	6209	8768	8768	1617517440000
12070	3NL4pri2UPJUrL4GYjapGTpprPgcpFuYHkwYuKY7iAVxJ2Do3Qat	12069	3NLaq76qBYr7aWgVeEtYxmJ1T5NyypV2w1kD57hHsM5pG1DPT3z3	1407	1395	172	6301	8415	jwMjWgAHy41FKFnLNNjKRYT78siK7qwS4KP7uZ3oUXVAcnk5kPh	6213	8774	8774	1617518520000
12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	12072	3NLq5Lbd3JEc1reWTYLPBEHE16abg38BAFFYnqK9iRF6cm8aVQwa	1407	1395	172	6301	8418	jxUt37hoHCEQVVHSqfWu3WimnWFMtpL2XbDT9WpZVU6gb9CRZYv	6216	8778	8778	1617519240000
12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	12075	3NKRRMkdVSnVWr4TkW2LzhAQ3ova4QFXs75aRVHt7MZUZPboMaEW	684	1352	173	6301	8421	jxJFrBcvf1fq1j2PHupEqMWbrRHVyJSuj9ruEYjSWhry95B91SX	6218	8781	8781	1617519780000
12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	12080	3NKPnFkZGBxz27Ua3iA1LHFffysf2Ny2TJhEMwdEQJWH7MfeCoid	1649	1383	173	6301	8426	jxfL3CkSWu5kNgHVZCXuYqC9JrRz8vtG84QoHXfgGzW7tEMRXUF	6221	8786	8786	1617520680000
12084	3NLDF7nx5AFGdT4m5HzfiW5L5823hsceSf73iGbCGQN5icWYDtBD	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1509	1320	173	6301	8429	jxR9B28pbR7dDq9ixZ591dkY1dnXerRkyQpsTBkSRhCfSCZNwch	6222	8788	8788	1617521040000
12088	3NKnoVZ4Wycizq4YEcHmL7QivnB129aqCCSKgeE1QgU7BrrwtHbf	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1490	1028	173	6301	8433	jxVyeMumKaT3GrBJFYC5sbaVFisSmq5SuaeBz8t4rmHMdtNSgNU	6224	8790	8790	1617521400000
12090	3NKDUKvftxR5qBriNWcix6Qj53m5iCasHPktbmgCt1oow9YuLSHT	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1419	814	173	6301	8435	jxDp9ztfUrtztJ4T5ELuVcrshJacrJyziNe5ZZxxkQquH8KazEH	6224	8790	8790	1617521400000
12093	3NL4Azx5aXj1ykBt12zcvt4UZYBdXgmiNi2VyBQeTDUqte4Uqtvm	12040	3NK9QfDtNj4PgGLGzDtiJsyT9RMDUWG2rKAWzxzqZxMJE32zig15	1556	578	172	6301	8438	jxpgZM4HoktEKa9aeSHpabKgz44qpGCdYG77JyzrVWwsYdLEcf5	6199	8792	8792	1617521760000
12102	3NLA9Bha6AGTWtjMAngSF3i1GVmiXxq4dC97qUB6DxC8GrnmtDzT	12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	1455	1332	173	6301	8446	jwZs22mycPChG1hSfeH5HLNea8yPBdajUDJZk5Ne2dn9jCQQsW5	6232	8805	8805	1617524100000
12104	3NLC8wErqeY9TRzMBWR9UJMrtqAEUPnizS8iQziFeQfbbDVNFQZy	12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	1406	1393	173	6301	8448	jxg3oHYmQm1k5UDND9dFTBS7cp1CdaWKq1NerbjAYttsYcy7LfZ	6233	8806	8806	1617524280000
12107	3NKVmy7vwivUTjxxmjZop2u8hTSoYN7pJAPNpNN1rRAqA5kirqgv	12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	1407	1395	173	6301	8451	jx6UtTWMfdJqDabegJbqFCSyaU6CgYUcPXbs62aKq1HFYZNmxpH	6234	8807	8807	1617524460000
12109	3NKDSSwcKMZHphYA1viqMXVkwtGDD3ymdpWXiocHrudL9i5zFaG4	12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	1506	1373	173	6301	8453	jwEusNpZ5wW2B7GwmEF2FCq4DbbdLc74s7ha6z5Byev5Wz9Vnhk	6236	8809	8809	1617524820000
12111	3NLHxxNMASphwXEK9eX1cfn4hmwUuhXCsUJqt3BAawBYVxbWXEjP	12110	3NKRprD763T1dGD6JtKtaARVFmciPL6iXv1FVLwa4n5NHo8sHqHv	1406	1393	173	6301	8455	jxUWWRMVTaCoWW19RJurcts8cPQtdcC5raFC69AUHwVN39FDcW6	6237	8810	8810	1617525000000
12119	3NLSB7bsn9Gabm7zbFmR8BRYWUufboWZdM5fZzvWqjHjHY5Qo6mu	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	1405	873	173	6301	8463	jxAbDWVZsJxQBKa4yPV3LAATYxY1a6JeVGbNjA73T3eQURwNoSc	6243	8817	8817	1617526260000
12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	641	1336	173	6301	8464	jwf5m5YAUW96HcGseb2bSFC91oij9wgscqAXu9LLboREEk1b4sU	6243	8817	8817	1617526260000
12123	3NKCsEtMRiZjzu1dCnmeP2fTmKWZh9Uk94LgcLQSRHZj2yNz1yE2	12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	1631	794	173	6301	8466	jwwmT2751dLPJrwuknuSEXKfvESfquRKZLbXP6DcFHzFfXePdcn	6244	8818	8818	1617526440000
12126	3NLZbYwSvoJ1Rmbpf3S2P7JAFhCkakarxTUhNx23xgxUH2AHUd5T	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1407	1395	173	6301	8469	jwuPwt7zAtwMUuGqD3Q79MnznmbQ9SstK5iHXgJf5PeiKJTUvA2	6245	8819	8819	1617526620000
12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	1599	1287	173	6301	8471	jwrzvFH7wGvTHcotUfzVsVoH95QiNxg9cst43yq19VWsf8Zj9P9	6247	8822	8822	1617527160000
12132	3NKRDQe4akSCTTRAwiU1jFKZqvCqSPeYGSh18UEUuCtrYLFfCokQ	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1649	1257	173	6301	8475	jxQwTeJsCXT3diC8Buae6dWgnprFHxxJ5R1UC5tKJdxn2Yda49f	6248	8825	8825	1617527700000
12135	3NLREMHc7LhPPJogsDURYXvLydWAxnygb3EqWTSwFLN7Sr6WdpRK	12134	3NKYvRZi3biP4GEtoxadxoREsrkoeTG8JZqgCbbTtprKicJFfrwy	1670	1036	173	6301	8477	jxYEX5GcE4XYTsV4Y87154wQ6jVTqwBXUUr6BeszBKHA8RAuDtt	6249	8826	8826	1617527880000
12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	12137	3NKHgHPGgb325foGeofiRetCLHNHDUA5N241XtdLaLszjPrd7PYW	1648	1158	173	6301	8480	jxgSLc4WCLWcx6WxmbdTAHSWxoY7zFTo18vUVe75Am7GTBWt4DJ	6252	8829	8829	1617528420000
12143	3NLpWW35wPrJT1W4yaiRDb3tiemJTVUgg2DHUHGHF89fSuSawAPz	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	1529	1316	174	6301	8483	jy2omBwX9MhZgEvdenoby4ChBu2WdooK78qBqthr1MSGM83xZaY	6254	8831	8831	1617528780000
12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	12146	3NLtMmK2qNmwopvzCSsMMgzMTZAY5cRBBXTpgyD3fhpbaNm1Lpiz	1406	1393	174	6301	8487	jwDnm1kDtnkTcrbCax7dyTkiqt5vxaNr56DSNckjhqF6onrszND	6257	8834	8834	1617529320000
12150	3NLChXN8FX37BViEouQCgmJifPyrq1PK3hhAUxGhq2g7kB3dwwWA	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1419	814	174	6301	8489	jwLTmBat73GPF3v6qmhUWvHj2gk9CSstC541bF7HJwxb6Qceoi4	6258	8835	8835	1617529500000
12034	3NK6kZp8ZmUAkL84nLWmbDYDe6ysxZWvD336aqvjDhNX7D5ZTHrA	12033	3NKt497xpvqqnCT4iJK5SaxoDq7PSgDXLKxX8WoqF6JqoiFPBfXn	1403	824	172	6301	8379	jwxCWj8vgzuzWWtHnVnTX11xNR4uGGjUV4w91BuZctKhqm2rJvT	6194	8750	8750	1617514200000
12037	3NKD9RxUAdBNXWYnGgDysJ7tPC1xQG9mvWZcjBB53CSyYnTS5tJf	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1447	1219	172	6301	8382	jw9A7yw83yQ3g6rqgBwQivK8YbUfVc6APvqSix2ysBH2C3qGohU	6197	8754	8754	1617514920000
12039	3NLEiuVCk1nuLM56BJuPhthxdrDj3aN25J3ypgMUvAaFv1oUDjhp	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1590	934	172	6301	8384	jwENQp9kEAPn5ZUnHeEfVRzL64uDdHZq95D3FCo3M4ZCdYWpBXh	6197	8754	8754	1617514920000
12045	3NLqfohb2BACiLMWwQN7SSDyXhg4dkjhpAQbP64i5F2YbSHhjkLe	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	1522	1322	172	6301	8390	jxo26BhCSHx2sSZDPnQzdSsJT2Rq9GMTzhowpH81iWwhd6oZauU	6200	8757	8757	1617515460000
12046	3NKLbzerkdsPULT6PQQ42nf1P2ttvg1dKMR2M6QxpKy9WDuoH9m3	12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	1403	812	172	6301	8391	jwKvYSH7ikBGB3y4j1482nsDW7KhWXnHhUWWEkUgD1vNBNqUf25	6201	8758	8758	1617515640000
12049	3NLpZuWfovesbNYSiS67fvR41jqCRVskazRMuRYUN6DtssJ3Nv8r	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1474	1329	172	6301	8394	jwFm4yjc5keNgsewircvZmfmiGnHJ28m5ghE2eBzRLSzcGwxYeg	6202	8759	8759	1617515820000
12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	12052	3NKevjRx9qQszAqnUrEzhwWkcHZr6GNeMm8xrAcaxFk8eMcrXTPh	1637	816	172	6301	8398	jwe6k2RNb4AouteX3PBrowBmCTZ3dbvyxWz1bfoxouWsRaLKS2K	6204	8762	8762	1617516360000
12057	3NLoTFe8GsWEkqjMAPR2m9sZ1xzAt6fT4DXvvxtimVza99UsehCu	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1671	1365	172	6301	8402	jxSf92Vqs52zFdZcTv7edqhGpjQFCJF9uzzQJRuqWpr5RFMe529	6205	8763	8763	1617516540000
12060	3NLZx4uxhXMGSb7NW1SgHTDTdt4dG1KLCVvky5bcnnc8GJRJQ3Se	12058	3NKfP3i6FguUU7YKAXZrX9RWuz5RTm455mstAKCB26hr8m3AEoaZ	1402	874	172	6301	8405	jxeQP93kJufA5yjWA9Dwh9LtMZdE1jXHfZS9NT9hrhMLi2uW46z	6207	8765	8765	1617516900000
12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	12060	3NLZx4uxhXMGSb7NW1SgHTDTdt4dG1KLCVvky5bcnnc8GJRJQ3Se	1613	1349	172	6301	8407	jxAcfnGahW9rR2KiB2fiAjfW6ZK8Wt9k7x7AKH7wwxWiRh1JEUZ	6208	8766	8766	1617517080000
12065	3NLwUrahMUbgyjfrnM39NkNZVg24xJyi3mW9ZZT5WoPLtFyfW4Ju	12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	1403	824	172	6301	8410	jwGR9d5tqftkqKrFZpPLYkxvVqBF1rk2Yx521sx9A4sJQXWC1hm	6210	8769	8769	1617517620000
12069	3NLaq76qBYr7aWgVeEtYxmJ1T5NyypV2w1kD57hHsM5pG1DPT3z3	12068	3NLEMvmmZGH6Umn7ynUiQWSzQ1QzLjUc5QHLZ8ARHgzoj4EzXymr	80	1147	172	6301	8414	jwRCjy3NR54LDrzXnDMVVhkWTLuEd9jvgb88iwsjVsHniBrmL3A	6212	8773	8773	1617518340000
12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	1547	1252	173	6301	8422	jwg8QVP2MeeeU9g4F8JLcyfRHuKfZP2SxfjeNLyGabXdyj2AgWU	6219	8782	8782	1617519960000
12080	3NKPnFkZGBxz27Ua3iA1LHFffysf2Ny2TJhEMwdEQJWH7MfeCoid	12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	1646	1354	173	6301	8425	jwmfedrXf6RU7MwNZv8FyRfE95gnwbNzJAXTLSGCd7USm3JDRMj	6220	8783	8783	1617520140000
12086	3NKvfHyfSQYeDRQdePsVyMoh5pzYx4NtgAdjWfdaV1xRzpi4kREL	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1407	1395	173	6301	8431	jxCWZRhSdP5Zo31GB33WAR6kDjTSa39YzAo7GrJAiyfMTaMR87M	6222	8788	8788	1617521040000
12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	12086	3NKvfHyfSQYeDRQdePsVyMoh5pzYx4NtgAdjWfdaV1xRzpi4kREL	1508	1141	173	6301	8432	jxT3Fy5iafcDiPEaUoFwwopM6Jc1mUFPipwoBQmrPj2K2sYvvza	6223	8789	8789	1617521220000
12092	3NLcNiXEx8pAsvF9YckyBegYMVxoxKcqU8TAS8P8QTUVXMqwCKVw	12090	3NKDUKvftxR5qBriNWcix6Qj53m5iCasHPktbmgCt1oow9YuLSHT	1556	578	173	6301	8437	jwWSfVKCafMncRcmAFhrgGYXDmqQ6s8VaJiB6zLuYcsceJ5SKuZ	6225	8792	8792	1617521760000
12095	3NLfPeNUa4ySkeFcPG3xqPQx5vvTezpa4ad6LmMZ9FJeq9XQzg66	12094	3NL6wYQoKmtM92LQopfFtUwPzQYw1Z1ctRpffQwnBMbC6KStbzJQ	1407	1395	173	6301	8440	jwmqYLcKLroaifxUyBU6bW1UV1r5Yj7Hoth1YFJcx6PdJw8jrX6	6227	8798	8798	1617522840000
12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	1651	935	173	6301	8443	jxvrhNs2AL8Fc4JbgPaQUFhTZqFGhdR1wu224NfdDCwsWfbgm53	6230	8802	8802	1617523560000
12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	43	1310	173	6301	8445	jxmLcBLUm7gZJdg3G4LZTeieQvMZSGNCYKbJnU4Wbx6zvvCmzVH	6231	8804	8804	1617523920000
12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	1402	852	173	6301	8447	jxa9vHWpPHBBUC84URQFYCy1AXbWm1HNk8bP37saB61WGiGAi84	6232	8805	8805	1617524100000
12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	1403	824	173	6301	8457	jwjigcNT5DVTpvZBbsvi1wKRaU3oXaEbfEVxsUP94DuKFGakzgd	6239	8813	8813	1617525540000
12115	3NKX8vy7X9Emsq1vALHNW7t5Ky2MkgE4xAnmXmfJLQdYKXr4Geks	12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	1529	1316	173	6301	8459	jwuU1X6d6puTAxnUZrSNX4tJm2BJWexvD52MyBRj8MFfoLqvm7i	6240	8814	8814	1617525720000
12120	3NK49Z4NK2Qjmv6ctrpZvmMx5GSsCmThcMt5VA4aMmz73C1ufiVH	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	641	1336	173	6301	8464	jxvTWWwWhr2ENVpvbXjdTVXadPC9wHWeD6CaAyrpbMfFhVkCsSd	6243	8817	8817	1617526260000
12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	1637	816	173	6301	8465	jwN7nxVH97vz88AQefSGtF2Pv1FPz6RQJ6NhvqF1nqgY7KVNwjs	6244	8818	8818	1617526440000
12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	12126	3NLZbYwSvoJ1Rmbpf3S2P7JAFhCkakarxTUhNx23xgxUH2AHUd5T	1402	874	173	6301	8470	jw7SCs9A3R3oEtsYmRQQHCdCmrYt9Z3F4vRVfaHQkpJf4MNDiDc	6246	8821	8821	1617526980000
12130	3NLBLnAjZKh8gknZYbnujZKnVWNvchnq6Ac8cnwmMBj7L2sDYWuN	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	633	1258	173	6301	8473	jwtrUopBDC5e5m2TV4xRWW6Q4tvzu6xV8QHLPXHbiF1zTb12sS6	6248	8825	8825	1617527700000
12133	3NKVZRsGEcSLCAWVDyq5ogiLBzbcGLifvKPnPk9GxDRHt1xzb5oA	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1578	1050	173	6301	8474	jxSfPorHuEFgHDzbB5VnMZPxEuihmvqCuXvG6pBSCbpbwKguzse	6248	8825	8825	1617527700000
12139	3NLdeA9fyBXVR1AQ5vULgVUELh4YzzeSGtDtDRKyW7hKfk1x3yVC	12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	1508	1387	173	6301	8481	jxfKYuQGsxgSww1gRxzkfPmCBVyWDjKAL1T9NugUsXTBMexwmJM	6253	8830	8830	1617528600000
12146	3NLtMmK2qNmwopvzCSsMMgzMTZAY5cRBBXTpgyD3fhpbaNm1Lpiz	12145	3NKdZLHCPhRZ5T9PyoqhHy18GRjc3JAGcFnXWXVBEUWBugYJb7XW	298	1062	174	6301	8486	jxQwBQofKwBUBb748JtAccDxQ7PTgVvyTzMNCq8yDHzw16BoCy9	6256	8833	8833	1617529140000
12153	3NLHF81pi49rQA9TT7uGvrk32ZS338sSesh1xiZ9wVfWA93i65Jo	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	1649	1137	174	6301	8492	jx5M1QARtMD4GEez7ZDip3HLh9o9ifUWox67NtVhh2GFFd2URFa	6260	8837	8837	1617529860000
12158	3NLepVYar6nBMkrAibhfxmcBHDLttD4hG6fUV4EGDcT2KNjqo22s	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	606	1049	174	6301	8496	jxYN6PueH2YNqFy9kMrxbUcT9oetoyM1z3uq1dqThBgxWJ9noqZ	6261	8838	8838	1617530040000
12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1585	1120	172	6301	8383	jwk4KKVSzWZNNPz5yHBtDP7dfnRvrkNVv79LhLD5yKgjPffdHLq	6197	8754	8754	1617514920000
12040	3NK9QfDtNj4PgGLGzDtiJsyT9RMDUWG2rKAWzxzqZxMJE32zig15	12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	1447	979	172	6301	8385	jxgiWc9VHzHScKQy8eo8Gu8uKuX8vWAsoVqGe2Sjj8uaxThC42i	6198	8755	8755	1617515100000
12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	12041	3NKjWHFPzoJVdYjVvtBgkK9zauSi1rqPe7beezTwChfacLQb9N8x	1406	1393	172	6301	8387	jw9eW7o6JejXCVTdLoqbgp3nbemo5Mxxs2TeJApPV2ru3kn5cwM	6199	8756	8756	1617515280000
12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	1402	868	172	6301	8392	jxGQcQQU7t6TH9Vsdd1tdLLdDzdpc4u6PPSa4KNdyw1nSNx1cvV	6201	8758	8758	1617515640000
12050	3NLLJjMP2PtJEGH83a2ksLRZhwzt3LzU5pnY62b9y6NSr1RLSuDy	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1596	997	172	6301	8395	jxiBParrJ9SLm4KZDDWpaAwYvKwqmrf8pPJJwPtPMNhy19HhDpE	6202	8759	8759	1617515820000
12056	3NKrJCtLxGfbQrL7nxAyG5TBkVdtzFzgNzoWvWFunSiLcKwneR2b	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1623	839	172	6301	8401	jxhw2N8cUPxgxp5xPu8bfcwjUuTEB2ZB5WWD7Cfmy7ZaHGteZTJ	6205	8763	8763	1617516540000
12067	3NKVkUmBqX5XDejwUB4GYMqsu7ZSurY5LxejwM6MXpUGBNamYWFJ	11952	3NLxwtsp2zFAAs6FptYd5byrNXxWPC68qgCM2iHzacKhftQPDnFK	1593	1220	170	6301	8412	jwULyuCBfms91zfRUipr8fRDXXHw9ahQN4yo4LgPL3shqxXabKE	6120	8771	8771	1617517980000
12068	3NLEMvmmZGH6Umn7ynUiQWSzQ1QzLjUc5QHLZ8ARHgzoj4EzXymr	12065	3NLwUrahMUbgyjfrnM39NkNZVg24xJyi3mW9ZZT5WoPLtFyfW4Ju	1553	776	172	6301	8413	jx9cWorsVHjcCtqemG5GSGFCNxdTRmGNk7GoRGLTRMRue4C2iMQ	6211	8772	8772	1617518160000
12071	3NL5Zw6tjg1XSXT7HpQRyy479FkSUpSC9WWLK6hvqc6vcdZrvBK8	12070	3NL4pri2UPJUrL4GYjapGTpprPgcpFuYHkwYuKY7iAVxJ2Do3Qat	1573	1318	172	6301	8416	jwiAdSpcK7ajdH3stQzm3RcfPTMkCo29afCJCHanvTWDF9NAm8W	6214	8775	8775	1617518700000
12074	3NK9CF8HyBwvXmBQJWxreTF2oSX7nVGyvtC9R71amCJAqvFoxh6F	12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	1405	867	173	6301	8419	jwg5n5YFmF6CvP6v1Nzk4dCuayCW8bgNMcy4idgRXEUUwWbDQTQ	6217	8780	8780	1617519600000
12079	3NKZr2R1xFpWwhadDHReJUowkYRURW6LPCAkXYQBxNdRcDDDu2Xs	12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	1406	1393	173	6301	8424	jwbTFaTw695q8syksnsyFeJhti2GzZXPBALJsM5JpGCQBHazsjt	6220	8783	8783	1617520140000
12082	3NKaiC2RDT82Yc1bFAkUgLA4jYBFHLvEqpsbDWsZy8nKZA4uE7sc	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1585	1366	173	6301	8427	jwPkCgRz8me99vtavFrC7RbHJegKCKox1ZMQ4wh64d9Uwrexm7S	6222	8788	8788	1617521040000
12085	3NKABGR3DgJ64JTzPzD8333zgsnJSbU3bMAUvxEsLAyhB9TsgdAt	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1555	981	173	6301	8430	jxtcphkZk7atVcQnWAnVjtTJEHcKo1xXEDuaWJAVELfR2F55nM6	6222	8788	8788	1617521040000
12089	3NLfw9ajspsPJHGbQsGShoPWASp59zVBvdG9JE2YM8zYpfLTV6Ve	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1407	1395	173	6301	8434	jx3yttA6ftVqLdRzh7LeEvqjvSJZdAaoxz89NyRzNeVaauLXdaY	6224	8790	8790	1617521400000
12091	3NKDEbntnCXHe1tXYgbBrTYFxigkH1eGR1m6xMZ5V97LPsSBvnJn	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1556	578	167	6301	8436	jxscg8eMRfHRzWZoybx55cFTopA3JFP7T7Wb8YpHutt9mZgqNDS	6029	8792	8792	1617521760000
12094	3NL6wYQoKmtM92LQopfFtUwPzQYw1Z1ctRpffQwnBMbC6KStbzJQ	12092	3NLcNiXEx8pAsvF9YckyBegYMVxoxKcqU8TAS8P8QTUVXMqwCKVw	1631	794	173	6301	8439	jxtndxbUc2WUvm5YBkc39qKBb1gp3LixzaTAAvZZnBFudQ5owqt	6226	8795	8795	1617522300000
12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	12096	3NKFk1XZ1ycpXmtuy4jXkx4rSifBzGFmDQ4DXtgz1U26Q1J4QALB	1451	1292	173	6301	8442	jxRBGid3CJ21qX3ccYgTU8CdzmbTS6NWjAhsqftzvQPLgFtqesq	6229	8800	8800	1617523200000
12100	3NLMDkyzANtQoEveYhrdz37nVzz4ZwLQ4G2TvvpnjvNt5HfqvPM5	12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	1637	816	173	6301	8444	jxJpwR8wMpA6YY6x31jGzUaXzQ5PSCfHrs6WsdUif2sFs192cY7	6231	8804	8804	1617523920000
12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	149	1037	173	6301	8449	jwz13AGfNYQ77D77bqjHRm89RA9FMT6pJ9kyvWLsXAceyguyG6E	6233	8806	8806	1617524280000
12110	3NKRprD763T1dGD6JtKtaARVFmciPL6iXv1FVLwa4n5NHo8sHqHv	12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	1624	1208	173	6301	8454	jwhHwP9uRJ19LKsKUvtdwJNR8oBzUAkTvMHxXV3Yf3aqtERYDL8	6236	8809	8809	1617524820000
12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	12111	3NLHxxNMASphwXEK9eX1cfn4hmwUuhXCsUJqt3BAawBYVxbWXEjP	1587	991	173	6301	8456	jwgSFUzsowEPKgjbkCUoAW1XwUKiedvXc4jQFi8n64Kwp6gG7Us	6238	8812	8812	1617525360000
12117	3NL6uBAUmVNf1aCA6dBaoy5LhLK4vREBWN3DLPLtTEq88UUFkka1	12116	3NLpbW2Dk6HA9tDbH99H745dHtPzHicGDnxT67v7hvqq2TAnWPAM	1654	1340	173	6301	8461	jwA9N17VkND3rZibFoyiSJQ2RmShfGeHL4gniuu1zzG1oD7CHb3	6241	8815	8815	1617525900000
12124	3NKNmdJ6wMuoxBYh7uE8ULjPk9obH7MRnFw9PiGszK97BbLuqpiP	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1522	1322	173	6301	8467	jxBYJRwJthzCprRzekcUHFVFPZm2jE71FJ6PQxkNNY2nA5uNJes	6245	8819	8819	1617526620000
12129	3NKi1KomQgh1spw1pkah5NPXx5m1NGk4hyp7ezyUPx2G6k8i4hYQ	12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	115	115	173	6301	8472	jxCvWuf4vkJLYTWyzTut7LAuNMZMtfxt9xB7HKhkP5yDRRZSqoX	6247	8822	8822	1617527160000
12134	3NKYvRZi3biP4GEtoxadxoREsrkoeTG8JZqgCbbTtprKicJFfrwy	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1407	1395	173	6301	8476	jxdt2W2sM9td4pLuhQ4qJwFcrJ79UKZA4vWGGpb9yhxKBGonjs1	6248	8825	8825	1617527700000
12136	3NKLm2Nrm3evQTfzVePZA79223UJ1Ca3zd8t6Xdkzvt1ppRcCtts	12135	3NLREMHc7LhPPJogsDURYXvLydWAxnygb3EqWTSwFLN7Sr6WdpRK	1451	926	173	6301	8478	jwkDZZ1eXV3ba3t3uV7pjkbvtriwAby4XQdDKhfnZMxqD8JZimT	6250	8827	8827	1617528060000
12141	3NLAxY57HVtKBZSg339y3waNAjGcnwBdyfUZPcFnVCKqmzyJYkML	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	1529	1316	173	6301	8483	jwtMGf2WsdkXx85MmzRYdLDg8FK1KndmHQ4ipncx2jwRn6jfgnw	6254	8831	8831	1617528780000
12145	3NKdZLHCPhRZ5T9PyoqhHy18GRjc3JAGcFnXWXVBEUWBugYJb7XW	12142	3NKpSf3WdRgmQktQGWN8jFniWckBEYLqRs33U3HfgvK7SeWHJ2RY	1406	1393	174	6301	8485	jwFDzFzVpDDKxkM39PMtupKXd6H4HUkwzcWqWAg7J4NitvN1fWG	6255	8832	8832	1617528960000
12148	3NK7cEMkG9jXD9vv3V2XosrpXVSBXThsmKoJf4n9x6QXABcf47TC	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1671	1365	174	6301	8488	jwgQkhB1jvEQrvogCz3JVDhbnPX3S6J8B48XBtQeBJCNVVbZqyY	6258	8835	8835	1617529500000
12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	1407	1395	174	6301	8491	jxqaguu54dQQffbNTWxkj2AVKLNem8uwCcSMkL1TKnt5bzZ1Pnz	6259	8836	8836	1617529680000
12157	3NK6YAHhgy4rZXMNQjssUapeNpcxJE2yNAErV9GnYSns5JTWxpcM	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	1610	1314	174	6301	8495	jxbdXBu1AGVmUFn9Bb6PSC7HBREcRSBLijk2T3uJvdJTGPFGwN1	6261	8838	8838	1617530040000
12160	3NL7bPdxK9gmgrx97zCr94LMBBQSvCUZiNJ3gA3ywrfnfhpMafZg	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1629	157	174	6301	8497	jwoFo8SfV2uzx6znL1SrT2eTEHcpevn7xFXuCXaBiaf6D84xQ34	6262	8843	8843	1617530940000
12142	3NKpSf3WdRgmQktQGWN8jFniWckBEYLqRs33U3HfgvK7SeWHJ2RY	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	532	1177	174	6301	8484	jwAdExdroPCzMyC49THTSkM6YGZ22fR1fPJDPWPWxR23wGWXoKR	6254	8831	8831	1617528780000
12144	3NKccDhQ1jt4nchHZSAcQDgTiQBbvvNddq6XXVd8bwPHXQMZcfRu	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	532	1177	174	6301	8484	jwtG3ekJiCyU19RXq4zXM7nrnwLT4Nunic8AfiGxfXN2gbanuWe	6254	8831	8831	1617528780000
12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1671	1365	174	6301	8488	jx1tudnTU54YB4p1KYVgdFXhe9LsqjDvGAohPuXC7riGD3kYsfE	6258	8835	8835	1617529500000
12151	3NLw4GDyJXNFzu7pULcRDjnr1uXyFnd4UZbpX6YN1zPzhFJhi9zx	12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	1406	1393	174	6301	8490	jw92JryAD6xcgNeRaM7fA59WpgGNkGb9U3sAu6oCh7WPdqs8F9g	6259	8836	8836	1617529680000
12154	3NLRC35xzDEVD7CuZ73pxkKUXVAx8mKyfuPc55Ranj4uwu2pdeUW	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	1506	1373	174	6301	8493	jx4tYAae7VPBeHRhDx4aEMG9kWWBkGRQ3bjMxKYA91GgG45gRKX	6260	8837	8837	1617529860000
12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	1596	997	174	6301	8503	jxNpwAgLnrCJizTtNQGXM5CVajZApWGVtVuGusGQazxZx2rCwZy	6264	8848	8848	1617531840000
12171	3NKkEo6zVWSup2g9yQYZQKHEN51QBiAbXFQBGxuPyRFMvraM2twh	12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	1489	1134	174	6301	8507	jwyJGeCs88FtxHLtzBtbwmFH8JwUgiqa6XsjrJtpgo39WEorxyn	6266	8850	8850	1617532200000
12177	3NKr28M8W8k8Wwmy8P4CE24NqJq2X6WnMvdC8i3o7utBcrQ8gpHH	12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	1634	1331	174	6301	8513	jwYD8fj5fLMjrz1XeBcp5mjjJXeKbfwCZ8qYUmMbMCTjgsaoqo1	6270	8859	8859	1617533820000
12181	3NLCWmRH9GanQAoVB5yjcsBTcPsLYVQwMGnmNFNuJmRog18rkUNr	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1426	1238	174	6301	8517	jxVGrSur6ZjpLXazBs81q1zLHT2Nzkt4tn5E1z5FmMG1BLBA6au	6271	8863	8863	1617534540000
12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	12179	3NKBhaLRVq4qLaSt5vD5UGbtMxkeGVVKyjFwFE4G7TziyngurnjK	1649	1137	174	6301	8518	jxTJGzoZzdGwQzWFyNy7RNBWXnDyz68b23jnJ5b77izMnrXFYSV	6272	8864	8864	1617534720000
12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	1489	1380	174	6301	8523	jwQJYHKEJyXdoV5YEAXEAMLLS8W82Cbt28QH92J1TMYxvds1JhX	6275	8868	8868	1617535440000
12192	3NKBDrw6rLn7tXdSJMYwsJFBzS7AUY4Lu5eX8BK57EnjEGJwjV19	12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	1518	788	174	6301	8528	jxHAYkM9dBgd7L79V2LpVUowttfHtGvqdDToxsrsVpKseomcjRh	6264	8871	8871	1617535980000
12197	3NKahgU55hiSbYUMioKtTq5fYixWWcTQmosLcNQuqRHWrX4qbxAC	12196	3NKDRJJGJrKDHgEzCQV2nVgftWU5FPFr6Bt4kWEkEhzjjN5dTJnU	1403	40	174	6301	8533	jwNMNknu3kCxm35SieZkovPsxeyf8M5iViTnEtPmeN67QdY7s3X	6280	8876	8876	1617536880000
12200	3NKHCsUCkYxhaapJLqu5UamCwH57t2idtQ87CAq2gy1t26udo3mX	12199	3NK6tt7GHxFwCWat5xZDGPXMA5ppefBzFb65czwHmrd5HhLcvFvz	58	1281	174	6301	8536	jwRqCG9zRqpUEMSwEZnKUSJmQLQhfdJb5eYN9QgVszL9GJXkVho	6283	8880	8880	1617537600000
12203	3NLhzgCtDzrSw9nbqu1SnMTZ2QzaVZXYbBE4xrG8rAzKnGgZe7QH	12202	3NKWQ9cG2FPep7it3uzgSo6qLSV3ghKP92NZW39LkXivGEUDQNCJ	1513	1379	174	6301	8539	jwDNue33wJ1aVf2PXzYoTBenEfn5kaisvo1NbiaErbC38ZjNpeP	6286	8884	8884	1617538320000
12206	3NKJ5GvttepZWQtCsJpjFFgrf2Jddufbv8eGqFKsauYPHsKxk1ng	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jxMKnyumjSRKfCz5KdqPsT2NmhqgR7Tawo5MHbx6rwkdynqZ59M	6289	8887	8887	1617538860000
12213	3NKUwp9J1xy8LQBq6s12qN2ebcL7M9NAqc5QnZnmVo24GwFb88s5	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	301	301	175	6301	8547	jwndhChB8N1xsLxQbytFKLa7BWYcR8iDNS2DvJabivEwZKJHXPd	6291	8890	8890	1617539400000
12216	3NLwhFZGDhxMfg8At9p16MNAgPtuEHt2mdbkzSw5AcVdCj76ykVw	12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	1536	1313	175	6301	8550	jy2j9oLfc5fJDL9csAFdpdso5feRT7bCBytBPa6JNGzu9vbdSjm	6293	8893	8893	1617539940000
12218	3NL2mUBbVkdiHSaKrYpksiRgugMhKgwrvA4YHKsJRvDgTrWu4MEc	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1457	1265	175	6301	8552	jwP8btSJUQtkyjqzZYQadtuccSqTpseBmoDA64vUANQvVN6virg	6294	8895	8895	1617540300000
12221	3NLHsx9BW93GzwcHmkQ6wDLMiF3mt1w5uSBJV9AZpyYSo19Ss8zz	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1631	794	175	6301	8555	jxc7zWJLMqKk72tHiWoQrrhpjSF4gCbNGc9kF3fzLTF4E3AsD1F	6294	8895	8895	1617540300000
12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	12218	3NL2mUBbVkdiHSaKrYpksiRgugMhKgwrvA4YHKsJRvDgTrWu4MEc	1406	1393	175	6301	8556	jwXi4abrQcMf7su7d6HnJbSwSN6DgFCTTiAkb9eby4tC6GWmTmg	6295	8896	8896	1617540480000
12225	3NKsaek2PghUy2iWVzsGKMkCvzTcUjw4KJs4UQNpqsgLi5f9WYHL	12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	1549	1236	175	6301	8559	jxLTqmav7boAE6hGhPE3jRgREj1jaQdrDVN8WwnKGCB7kV8ov2M	6297	8900	8900	1617541200000
12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	12230	3NKjHc8ZRQ5hyaiyyS88uvpuiYVfKXLDdfaRPHH4CuDSaPiSjXTQ	596	1060	175	6301	8565	jwXt8r6VuFLqiTb6Z21PSNHyrCabM9nuinGfhhodwxZ1hnN14SV	6300	8904	8904	1617541920000
12236	3NLFvjVNgLkmtBiCyF8rK3YyPpLXMtZYtZDCJVamCgSn2xJb35JX	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jxd8bYbdGuGDZmxgkdZK4txrCTBneuu6husEJqmUqPHqzfdR61G	6301	8905	8905	1617542100000
12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1607	1102	175	6301	8570	jx8DU3oWd1Z4QHPeWk1wBTinQFzkPvDRJGrV6dwHbGZNC63uBDv	6302	8906	8906	1617542280000
12241	3NLQsV46rnZ2agccAgXBdTaUqPKhoA1wKHkBRGtGZW4xb4UAUrif	12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	1642	1121	175	6301	8572	jxTGGsht7RWwY4ziHoFJW3owWQ9gyT4iy7C5qGtvpMFfybJ3stx	6303	8907	8907	1617542460000
12243	3NLHkeDxmK2cwHcr75eM5Pr3iaGkfPsnLJMYmZntYVgqQqAB5CvX	12241	3NLQsV46rnZ2agccAgXBdTaUqPKhoA1wKHkBRGtGZW4xb4UAUrif	1407	1395	175	6301	8574	jxPXu8kVRWeWBLX1vgBFDaGuJBAVAYZaPXnaSq8pkXr45X9QH6V	6304	8908	8908	1617542640000
12246	3NKHAM2QzhUg5cvdJ3FctBRenRVsLKcPvR2fpyePU8YWJtMEywai	12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	1534	1317	175	6301	8577	jxnzcJGgm7Uz7J5QPRnDCYLsWHdkvKvx2zjebtc23awWgvzwDQY	6307	8912	8912	1617543360000
12249	3NKEGb3F9k8NrCAt2hpVm9DjaAjzm32Nz88EpqmxwvBvKuvoZCgc	12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	1579	1389	175	6301	8580	jwTUBCBFZ8rotPzoanV5Ris5qzwgaaigjQGMn94KKGR9Pu7ENTH	6308	8914	8914	1617543720000
12251	3NKYeUEkADDACNT5fK8VLQTkqBpvMSVPcse7E6M9tWYagRvxpzex	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1403	782	175	6301	8582	jxZe14SjsFqzbYPgZhvKSfAoeJCsYELqve3mNENZaA5uyjmgwhH	6309	8915	8915	1617543900000
12264	3NKTkU3e9TSkmtaST9i1itibk4hNtUnAH17uARBQVJJAhpxiPVb1	12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	1407	1395	175	6301	8595	jxu2crZ8KkWzWfCDGu9k2CdZxxjJvHt9jYKGm8q456oJAVTK2ZW	6314	8922	8922	1617545160000
12269	3NKn6fCb3PCh2Dz8wb9aRibL3uyLshbQjuk4rTPxLR94Mkt2JrR5	12268	3NKjr3qzU5LQpr1r36hc9phDL1M3pnuEurgEWCQTR165WiUDGo5n	1406	1393	175	6301	8600	jxji4JNtcQNrxrkLGL6mwuJ62jDpmeiBrXKTETbv6qnBnNbUdVA	6317	8925	8925	1617545700000
12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	149	1037	174	6301	8494	jxbzEZvaoyAArVshGi3i2Kkdf7UKYZ1cgbduSQ6CVrV5Dp9h17L	6260	8837	8837	1617529860000
12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	1610	1314	174	6301	8495	jwyYg76nZzXGKYXsMRn8G8AxgQsKsFW7kdVvMfYwMLwQuyCBvZF	6261	8838	8838	1617530040000
12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1623	830	174	6301	8499	jwTzeYidiPdHx3XKsgBsfVFTAXg7KER4nPyhpJWDieCVRoEibAP	6262	8843	8843	1617530940000
12167	3NKgLEQkWM8FeUH7YEsjGEUAJHRhY9FHeRtsCk3MMNynUMGnYfhA	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	43	1064	174	6301	8504	jwnGDkSvGQeXugLYUgqcF6vspq4iT8Ls5d1ujMc7feNUUccKsD5	6265	8849	8849	1617532020000
12175	3NKLLfEuxWVNrbjZraQab4KgmGw3WUg3thmCkPespX6jaigi976y	12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	1622	1356	174	6301	8511	jy14AYHW8BR9HrsqS7m92XCkUtmYfgQ6fA8vGmkVbfFjCJ3WCwu	6269	8858	8858	1617533640000
12183	3NKh7oguDvzcAvcNVi4Y69qcEEva8XFWdkk1BzBtTBZ6kCAw31Pu	12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	1668	1124	174	6301	8519	jxkJbHBgznAkKEdRN7zgZGa3W4YKj5VjXNkB8ptJcLietxffgrt	6273	8865	8865	1617534900000
12185	3NKZmCddKuALssgCLrkkmbnkqas947xqCgpvnDU6nSLzzpLo17sq	12067	3NKVkUmBqX5XDejwUB4GYMqsu7ZSurY5LxejwM6MXpUGBNamYWFJ	1593	1220	171	6301	8521	jxT9ZgUN3eSExAPLbULj2ftQVDfPDqqsJ3qVHSnqiQTC7cfJ66B	6121	8866	8866	1617535080000
12188	3NLZRjtfJyo6PyLy8jdsumfc77HmaoPukZqofXoVSRyotLKYwLmt	12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	1500	1297	174	6301	8524	jwmYprb9sqocQ7igLNThDSKiin6vD6MGGx9ZthLNBPorVfyPyP2	6275	8868	8868	1617535440000
12191	3NK4ZawbZJTsoZtWqWojPh7gqpQPA6omE5rwumdjW5kQtsx6P58y	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1406	1393	174	6301	8527	jxsRvfs3ivk9d4zeXccBZcVr7MiccUAD4Mhmd78kJb78MYB1pdh	6276	8871	8871	1617535980000
12195	3NKVFEAjMLhqUX4NHAC3BcdQRhPuwL5PzUK4awYSRGsQWJk6VvD9	12193	3NKJch77h22pHdHNemMmAijM5AajpEDWjUCLJ1fqGLC9GxrRvri8	1426	1118	174	6301	8531	jwNoa3SzY2ZBxJN9zBvmPTbP3J3AgVexNSvZdq1WqEUsphnhfob	6278	8873	8873	1617536340000
12198	3NLvRWL94odHkBrkT4c5mswrXvAob65FnArLd71KcMqQ1yja5ZEq	12197	3NKahgU55hiSbYUMioKtTq5fYixWWcTQmosLcNQuqRHWrX4qbxAC	1406	1393	174	6301	8534	jwjpeeX9V9rXSraQ6rgtUoFgqVCfc7xAwKkhveNEK6FMw1TvLzy	6281	8877	8877	1617537060000
12201	3NLgWw6J1d6XsGWDNrXoeCNuyWJoNg1qeGTm7nBkmWJwFDa1BRSP	12200	3NKHCsUCkYxhaapJLqu5UamCwH57t2idtQ87CAq2gy1t26udo3mX	1406	1393	174	6301	8537	jwcbdSn7UrKrhQYr4wLBwH2MTQ1T4GQkTDToPWTw4miZrtfvXo4	6284	8881	8881	1617537780000
12204	3NLmAkdFi25aBP7BtU5J8eeV5saxJztqP2UShpFzwPTJpRmbwDiM	12203	3NLhzgCtDzrSw9nbqu1SnMTZ2QzaVZXYbBE4xrG8rAzKnGgZe7QH	1507	1154	175	6301	8540	jxDJJAduvE17x7EuvATRkzD1jWZuQh1u68c6zWXtnoBAGr9Qpy5	6287	8885	8885	1617538500000
12207	3NLhj4TUfrCqQPV7A7io2i4hxCHzSyxMKgu5NpYx4jXnDzMci4A3	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jxVVVTcr8xYpsWeuNn5RNq7A3bmm1N5SBMv76TcFBF8iLMa3Z6X	6289	8887	8887	1617538860000
12209	3NKq2PXkLsaE4RLvPxZGkLBNYxZspk8wi4eKfhgcbQaQ3Hreh4dm	12174	3NLe2Q15CQskZzCAZv3MWojfP27kTTKY4hn5dRXruzxDBNQC8BPZ	55	517	174	6301	8543	jwjt35kH1Qfq8Vxat3f6gsPjNbSPB8cQLTKFY8cRfcyZEKBLAj7	6269	8889	8889	1617539220000
12211	3NLHmNdzkuC5iFsBCq41fhXg9eCeadciwEvEP2VAYP3Ju8BjmUmT	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	1588	1146	175	6301	8545	jwmxm3yjoA8126ZNFfvvsn25DiBrDYwBanEdFAvATGH37yCT3ts	6291	8890	8890	1617539400000
12217	3NLNmB43aSf6igZUAmZo5Ai2He6BGwikzHcV8BW3DrcEkuCU2FHv	11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	1423	104	169	6301	8551	jwSukvAjkFM2RvmJdPmNR2uKrZYSmGU9H4uapGwfCuLrPNsxRaL	6078	8893	8893	1617539940000
12219	3NKrn9irp5ymv4WEZSJFXMJusYv1VfVXhJjBVeLZXsRMZTvLHAjX	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1483	893	175	6301	8553	jwqcJbT8Wt8Gea6cQEKWG8tmrGmJZFjK7nTriGuevDqfFPAgn7w	6294	8895	8895	1617540300000
12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	1407	1395	175	6301	8557	jwrqyJASfEGY5YqkynsYtWc5Le2VtM9S9GBbZUbCPubLurwoxBy	6296	8897	8897	1617540660000
12226	3NLsLui7bp33q8sefUadSmNNDXpV5f5b9vGwqDtgCtbpHaUjtfL4	12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	1513	1379	175	6301	8560	jxVqwpkpvrMH8nBSmwoRQ9pKtrsFx1jB1PziPerDksxD8UzPVCg	6297	8900	8900	1617541200000
12228	3NLiMmd3DaYHsTE8ng6szTTup1gdXbLskqiJn3zGqu4fS5Xdh5kU	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1599	1287	175	6301	8562	jwmJwvUEmGoKPnYZr4zWREfgpUwjx7BgpHkdNAWKo2d9BmMpvds	6299	8902	8902	1617541560000
12231	3NKzEALpiPDEnUAb7BYo7sFpodXr81vt6Aq8i2NTgLvYf9hBQqRW	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1419	814	175	6301	8564	jxQKV1bNFkwBD2j4qrKA1FFuhSCohDHhkYQPfcwZjaYowBqpE9F	6299	8902	8902	1617541560000
12233	3NKRyhpjLCiehMjiB21NcxGMJwmCFWsGC8cUsrgfavT3X1mTWJvN	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jxMBFPYm7UjVdU1N6R6Tz4D4dhx1RxNSqV7gvJdWUJ7zsuKFt11	6301	8905	8905	1617542100000
12237	3NKWU5ASkQbBe38kXudMX9QnRCrim1qaodr1xVbU78PbWkAWsb9B	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jwmKvZo8C4hFE1qnYMsUXjv8ScR91SJhRcTNpn6f618dLXb2o3D	6301	8905	8905	1617542100000
12240	3NLFvof4mAbtr81cH91Zs4efx5XtnYMXjUqFnwjAPmKUmPD2DoJq	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1675	1342	175	6301	8571	jx1SB1wU4P3MqVbq1xacwSvkuHn1M9bbMXTEnrL7m14EbWsPFU2	6302	8906	8906	1617542280000
12242	3NKKjuXpT9hKa9oHkcZCgwA3SFonCB4xzVWnYuyZBEGQxkcAA3oc	12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	1624	1334	175	6301	8573	jw83u572y6m6fJLKKdvvhvtEFiBifPu9LhMctAZaBEB7AGaEUTL	6303	8907	8907	1617542460000
12244	3NLMcXg7X2CZpiPNJYZP3JU3ww1h9CANW2LLuAWjomQJVvtRgvr9	12243	3NLHkeDxmK2cwHcr75eM5Pr3iaGkfPsnLJMYmZntYVgqQqAB5CvX	484	1073	175	6301	8575	jwMqqs2T2fvZsbp7AvfwjUckJxsnkGGEJiF3QNW5GyuieuBVtJe	6305	8910	8910	1617543000000
12252	3NKqGTMoHXisjBiYhctCDPWYPkTEJQ72J98wjRj6h7GZ2uofTK26	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1419	814	175	6301	8583	jxQa3WyyWcKJLx9oqv8n2MdgbVkVFPisfVXMs7QujhPbmacJwsZ	6309	8915	8915	1617543900000
12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	12257	3NKYgSvm385jNyBPu8PmDt77fAvVtL32toqZEpGrCvTxq7pc2uAA	1407	1395	175	6301	8589	jxEKCVPeBqs36bwTDvcDpqpwJYhuWpQ2Pxge6LAVGkRBxLpqwBy	6312	8918	8918	1617544440000
12259	3NKkb3nLVXckS4yneh8YhVMKwKeUw7viuNgRKjchv2GgyRn36PJZ	12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	369	1312	175	6301	8590	jxyauvmWF46s65rkQQATGaPdj3JeVYtywbZCba7yf5DczZ7ey6p	6313	8921	8921	1617544980000
12261	3NLPG7x4jCHPUnpk3NHefcuN3obBzWFWyT87Vs6bpfxV2ydGZGwh	12115	3NKX8vy7X9Emsq1vALHNW7t5Ky2MkgE4xAnmXmfJLQdYKXr4Geks	369	1312	173	6301	8592	jwVEdfAyiCXApu53TraBFEsY6eyEUmV4iRnYmKCW5w4FaAcCkbZ	6241	8921	8921	1617544980000
12263	3NLM6TuezPBwMKerW4Svy5eZYNJmoit7HrQjzGEAF1qf5xXGLJiB	11878	3NLGY75wkHzeXm8vmpE7qcz3WSdnjzAtcbUSr297AXya3QS3QSeT	1542	1304	167	6301	8594	jxF2pGoyELQc8DHPiAX5JtJaLZ15njMXs8DJPpHFFcuWjjtQjGU	6036	8922	8922	1617545160000
12159	3NLwd6tQyphbtj7a1p96HoJdRgbZNMb9PS7mszBabtEY8VMF4Nxh	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	606	1049	174	6301	8496	jwxcn2Bf453G9GaaQ385BAZhjnFzAd9nuXnMcHXve6YLibk7hcR	6261	8838	8838	1617530040000
12161	3NLgjQo8CZEqDoAg2eNqLpVsHeA1Nji2c1dw1pchEUz1knqq9FiF	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1501	1360	174	6301	8498	jwk4wZ2Fihqu7eD3ekrDirrPs1bCfTjX6CC2GBehFf4MWU6DUAU	6262	8843	8843	1617530940000
12163	3NLQZwCgWkNQ86qwsbsESgLrBAQwnBBxYNDZAdvot9Px6YHssPXD	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1407	1395	174	6301	8500	jxvtjWrtnyvVK4XaaHMpNvSXDZDZmEpPxYfFDbCg8zLRrQv9bUT	6262	8843	8843	1617530940000
12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	1406	1393	174	6301	8502	jw6wJ7bCD9KyAUpDKNVVUZ3uFNpY1c844kUA5aqMTymwh6rrUsE	6263	8844	8844	1617531120000
12169	3NKS8MayPWhAKvYE6MwHWwzMBwngy1ArLysx6eGoxEb8jc2jNHJD	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	43	1064	174	6301	8504	jwr3wqpckqE1ihqqcoUXFc96xZHUYgfj69bgg23JpQ5KcX3TDep	6265	8849	8849	1617532020000
12170	3NLnB6ozynfDQdk2ZYzB3R1HryiuYbDfHCvwVoeUasT6WtaKvzuW	12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	1536	1313	174	6301	8506	jwkKQcFh9DLVgQG9YL5cCFLECPxHvf1WnLM1DAKwW6kG6FXEyUt	6266	8850	8850	1617532200000
12174	3NLe2Q15CQskZzCAZv3MWojfP27kTTKY4hn5dRXruzxDBNQC8BPZ	12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	1407	1395	174	6301	8510	jwN2QeEHE2qVx3yLStGARnqgF73LUuZhLStTxwYjWyjNkU8ZcmF	6268	8855	8855	1617533100000
12180	3NK5kE6K4JAGxP2LwAcHGZutmbbAH69xZL6CEVAnZBYAuktffyoh	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1609	967	174	6301	8516	jxS6b8uZFHS1GJVhgDGXBW2t67UVSdebm8iVFT9mFJs6vkvNozs	6271	8863	8863	1617534540000
12184	3NKaLKHikVorDTc7gaAEzXny7akZxMRfNiEpWcuToVw1hHVNo4pQ	12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	1623	830	174	6301	8520	jxiiL54G3JWBYZFUDwG5KRGFCh9immVmZZ6BrLQRZHNj3cGPgQi	6273	8865	8865	1617534900000
12190	3NLE9unEW28pWWvyYozpoxMjcUVRvS2zD8qNFJkTjXoki5xCVahk	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1518	788	174	6301	8526	jwZnMHx3QntsVwrkWeiqRUGgeme3QHYmJPxTggnFgs3cTszBKff	6276	8871	8871	1617535980000
12194	3NLeTcXcFQGYVhTsTVEnACj1Rn862qQM1YpB78Pe9RsjA5NVwPq4	12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	1590	1300	174	6301	8530	jwAayPxTAV71Vx5yiWzVVA74JmzhStEWgaTXA7snEvRjgTQs7gA	6277	8872	8872	1617536160000
12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	12204	3NLmAkdFi25aBP7BtU5J8eeV5saxJztqP2UShpFzwPTJpRmbwDiM	1405	905	175	6301	8541	jwux2K8ynhWBYesPdUFoobsZXo6joYtrWeno82ERGRBgHrmrq77	6288	8886	8886	1617538680000
12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	12206	3NKJ5GvttepZWQtCsJpjFFgrf2Jddufbv8eGqFKsauYPHsKxk1ng	1406	1393	175	6301	8544	jxnMMUbgV21VWtfWFpkBUKGbHSAKEozt6ec7333maKKZ46WLgnp	6290	8889	8889	1617539220000
12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	1423	104	175	6301	8549	jxxpE5pKVNpqMd1cawGkXhn7J77CsAyrsKsbWuMHYrPfpuPLdwU	6293	8893	8893	1617539940000
12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	12225	3NKsaek2PghUy2iWVzsGKMkCvzTcUjw4KJs4UQNpqsgLi5f9WYHL	1407	1395	175	6301	8561	jwir2yUB4mub8kyZk6QvMGoJRnB3a7aDeecz9zVXbuYNHimXcF5	6298	8901	8901	1617541380000
12230	3NKjHc8ZRQ5hyaiyyS88uvpuiYVfKXLDdfaRPHH4CuDSaPiSjXTQ	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1600	1372	175	6301	8563	jxD1G8BFximXzpXm8BdPW3bupUAKJV7w2vp3J2DrqDf8eFTQTeE	6299	8902	8902	1617541560000
12235	3NLPTJ6sC4xYJF9u82BhdZ7g3RezHnpvupR2kx2GEMn3tWfqwcVu	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	684	1352	175	6301	8568	jwe6poEV2P6N3FePFttEGViBMLsi1LkvTaRfJgebjHMvJ5KDJfY	6301	8905	8905	1617542100000
12238	3NLJfYzQ5P8SrK6VvHj9tVYLEaX7RGEmwXVn5FkV48U5oxouhJGn	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1444	1255	175	6301	8569	jxpJuw3FuWYkWGuQv7wFCsQYYpG4fd5yT88huNCYShM1tFRGzdL	6302	8906	8906	1617542280000
12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	58	1035	175	6301	8579	jxk2jUWpPkU5roYxnYPqWceZpguhzKLYfv3tn7EydZTSEaUG8wG	6308	8914	8914	1617543720000
12250	3NK7Fc9CXhzEzG2DWDi4ZcbfELKUXFn6hkJsc6Em6iekWa8rrfdt	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	1579	1389	175	6301	8581	jxmsVNXrpBaTanTV3hfPrgtWHX3hJC2sUVEmuBRwxDUWmhXmfkw	6301	8914	8914	1617543720000
12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1407	1395	175	6301	8584	jwbQDLMqnQ2L2hTHTrewm9pFV6jurUa3LKcpL4FD3cQskrzHr2o	6309	8915	8915	1617543900000
12255	3NKXHLjVLc2fH7XJVki1uian1FHHt2yiyyPd1JirLjYZMYqyiMxu	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1643	1299	175	6301	8586	jxFGr2L1WtdB4HtXhkSmStbMLDw3ikRZ6bYFscJt5KVXPjbs26R	6310	8916	8916	1617544080000
12257	3NKYgSvm385jNyBPu8PmDt77fAvVtL32toqZEpGrCvTxq7pc2uAA	12254	3NLjwybu4EB64EqMhhfm2SiwXtb9FLghgoz2F84PPq2HE5qiCmYZ	1647	1056	175	6301	8588	jwEvsBxkomgzfwsGWabeRUEeiY1MPwyzzvMjkBCpTqJZ3iGMLVg	6311	8917	8917	1617544260000
12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	1542	1304	175	6301	8593	jxPZg3VoAfxUvN1k3yTD9ymhSCzpx35KaFWub15gyiswdFLe2dQ	6314	8922	8922	1617545160000
12271	3NKN5tsSumJW91aHZ9Xpzo8xGeTptDerzjF7hFZR6ZhtVi29s14X	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1460	617	170	6301	8602	jxwpFjP89nvFYm1TruhcC1fdTojHpaWs4kF2HGrMGHU16WTk2zS	6142	8928	8928	1617546240000
12274	3NKXVGgQXFugoyKuf27iK5EXCgTseaJKwxgsPxShrijR2heC6hrA	11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	1460	617	171	6301	8605	jxTYmXUA7EtAmcvLoRdk1XxZwJfg67mUSitjuEvwxjs2w7ozPDP	6159	8928	8928	1617546276807
12282	3NLr2nN9zFhaeqSX4CSrraKATPU47htPhL4MXtAjkAtntpFCq4vc	12281	3NLBKAokjpaYGeAeqi9HFm5g9nRiDxnhNhPs3KoMHbqbem6yRTV8	1406	1393	176	6301	8612	jw811uoKPiuJvxm8LrZXAtqT6QmCyZgPHaEjMfebSyWWA98LzTW	6322	8931	8931	1617546780000
12285	3NKdJkkJ5M26mv1sNcMayiaViKBZygmgs1JVHwZGg36Vg7vHKH8M	12284	3NKZEm7NcJBCjYBunhU9YPs73icUg3KUPh2sntevpSPNCSiyfgnG	1675	1342	176	6301	8615	jxZRrMW9vRcdS8LJCLitRfpmThnmrFwVsVWhxd6QSENEnNaFa2T	6325	8935	8935	1617547500000
12288	3NLANkFQhMTy1b2C61s5f2GficVpKv6oyE7VV1bRj2f6Qr93qJpa	12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	1520	48	176	6301	8618	jx7ssG6w7SXVB9UkfMcmVXnwhv5K6aj9MQU4Jqrpzv9EoWW2mc7	6327	8937	8937	1617547860000
12292	3NLSKnUhygmSSaKc2BUGVuNMxChaMCqAYVfRjE18fzLaDT4L5hPF	12291	3NKX2TfipbMFsKwCBPeAifAH5Eri1NYh9ntsE4AUwpny3B5k4Y7X	1623	839	176	6301	8622	jwnGTa2e2sDRmL8FKvHEytKqR3fbCCfcbeDPfJUbyi1ZuNUt2Jv	6330	8941	8941	1617548580000
12295	3NLGMjuLf22okW5iAxtcMAAVqjuhL2uQew7dWWDpKJxBwmSHCVR8	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	1672	1285	176	6301	8625	jxEa2nZdSEkee3r7qQBupx81yQmUo4RRY1GKANemthjmePjqsdX	6332	8944	8944	1617549120000
12297	3NLxBe7ozF9ofpL7APtwHM4j29s6nVgBTv7npop6Nd4EUt2esJPR	12295	3NLGMjuLf22okW5iAxtcMAAVqjuhL2uQew7dWWDpKJxBwmSHCVR8	1460	1324	176	6301	8627	jxqWJ3dtHqrv3Si9HeJm7CKTY8UEac4ZZ9TxV9M6e9b9B23orgd	6333	8945	8945	1617549300000
12164	3NKe88JJzL57HggkjedTG8WAzGTebLHtaUEpNNhC7B9s3Dycwj2K	12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	1536	1313	174	6301	8501	jxARp9vaBM3sqA4jhiQajfPyot1HNWgvwLFJSGkqAwvW2gSXAKh	6263	8844	8844	1617531120000
12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	1406	1393	174	6301	8505	jw73gAzM9ga1VbrudzKVq8qnU25x5o83i35Yy9jzcZeoNZ95L9S	6265	8849	8849	1617532020000
12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	12170	3NLnB6ozynfDQdk2ZYzB3R1HryiuYbDfHCvwVoeUasT6WtaKvzuW	1481	790	174	6301	8508	jxBE8XfB5YLGzWz1qeV4iERXveU3wbCGtEp9XG7wfnY5eBEtNHy	6267	8852	8852	1617532560000
12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	1405	849	174	6301	8509	jwDfm4RFJ6ZpwFocaAWv5xWBdJEqJGtbcm5xveu4ioc2xhi8zy7	6268	8855	8855	1617533100000
12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	1546	1339	174	6301	8512	jy1AK5UtLgQc5Uo5CUdiSxTXT7s7UzjR36zuFrzi6mZtJG9Ekbp	6269	8858	8858	1617533640000
12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	1623	839	174	6301	8514	jwg6mhfxYEwqYbesdkSxYXsmbdGAF9wZYZjGgnTehNYwUZ1yJYw	6270	8859	8859	1617533820000
12179	3NKBhaLRVq4qLaSt5vD5UGbtMxkeGVVKyjFwFE4G7TziyngurnjK	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1607	1222	174	6301	8515	jxwQedXhoL2uXgkawaFGEBLhNuydtuu6n7jaRMXd594N3bLjhhH	6271	8863	8863	1617534540000
12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	12184	3NKaLKHikVorDTc7gaAEzXny7akZxMRfNiEpWcuToVw1hHVNo4pQ	1647	1176	174	6301	8522	jy2FNyEaMgwP1qx31DY3t2SqLjv2wqfK5o8Z3dMfRBX5QYrK7qe	6274	8867	8867	1617535260000
12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1529	1190	174	6301	8525	jxrUzXDQWmvBu4yTdi7m3Aub4bxtQTUDjggFhdNqgC2s9yTrmmv	6276	8871	8871	1617535980000
12193	3NKJch77h22pHdHNemMmAijM5AajpEDWjUCLJ1fqGLC9GxrRvri8	12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	1406	1393	174	6301	8529	jxTpAXHFfX4tJaCio4AgsrLiBY2FqfGDJQrcYiYVMJTD3Enez3B	6277	8872	8872	1617536160000
12196	3NKDRJJGJrKDHgEzCQV2nVgftWU5FPFr6Bt4kWEkEhzjjN5dTJnU	12195	3NKVFEAjMLhqUX4NHAC3BcdQRhPuwL5PzUK4awYSRGsQWJk6VvD9	1637	816	174	6301	8532	jwFQEGFAP7Eej1n96h9kyYh1Njt7Ug4G18PdYc3jiTUV7EHGbw9	6279	8875	8875	1617536700000
12199	3NK6tt7GHxFwCWat5xZDGPXMA5ppefBzFb65czwHmrd5HhLcvFvz	12198	3NLvRWL94odHkBrkT4c5mswrXvAob65FnArLd71KcMqQ1yja5ZEq	1407	1395	174	6301	8535	jx18TAtb7YwMTLzekgUcH1erzWebdUq4tphK2E8WZQzTcUuvndo	6282	8879	8879	1617537420000
12202	3NKWQ9cG2FPep7it3uzgSo6qLSV3ghKP92NZW39LkXivGEUDQNCJ	12201	3NLgWw6J1d6XsGWDNrXoeCNuyWJoNg1qeGTm7nBkmWJwFDa1BRSP	1578	1050	174	6301	8538	jwQvupqxHYSge2eKYHk1BbiAHRAiyazCrHad43SHbWBiNwQhjXp	6285	8883	8883	1617538140000
12208	3NKMgsbSd9WN15932sfzJWsnZFS2vJsvA1GwNDNDQZYDXY7zyfni	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jwPdpTmBy6QdzRXGkVNhhX7mZkHMcbXs1vxJtwoKEZffctbFmE1	6289	8887	8887	1617538860000
12212	3NKdy712vSBwPTd6jj8xLobsfGQvo87cJTVpYicqjrFP2rXwqbQ7	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	1549	996	175	6301	8546	jwXDcjqcqcjd6xyquY3XpPfyo2Mq9zFfH2XxiFnq7QeQwzK4mcd	6291	8890	8890	1617539400000
12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	12213	3NKUwp9J1xy8LQBq6s12qN2ebcL7M9NAqc5QnZnmVo24GwFb88s5	1407	1395	175	6301	8548	jxnb18rokFR31j1J25Nah6ixMEXtBCVZY7auNMa4dYXmoZmBW43	6292	8891	8891	1617539580000
12220	3NKacsMzQEoN77B9aeq6N5ERMXRtt6G8bqbC3Nf5djBagELLsWmL	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1406	1393	175	6301	8554	jxUotp33xa67NVejpWSVv3K4wkzjyFZZTsk1R9yfsC1NiqGHb6T	6294	8895	8895	1617540300000
12224	3NLZ6qNHmqzHx4PfTHUkeJkNFVXxfs76oKEgQCYT2cXMsPwiZmUv	12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	1631	794	175	6301	8558	jwjMPZ2cVsmLvH83scGWJapFn9XtUxc4pWnYakuqDHCEjhL12ji	6296	8897	8897	1617540660000
12229	3NKRPRKPwBYWhG1yyR5TVHmMvoAYJViC1BBfsAiKHVE5oE1W3AzW	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1599	1287	175	6301	8562	jwJnNzkC6dtUV8SrwwFyXtqy7ntXH9aY8bNm2q6Dav4qZnQFqNT	6299	8902	8902	1617541560000
12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	1406	1393	175	6301	8567	jxUq83BpWUtWj8FvNKkMv1QXRKhx9QH8Z697Wnnsz4JJaH7tYuk	6301	8905	8905	1617542100000
12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	12244	3NLMcXg7X2CZpiPNJYZP3JU3ww1h9CANW2LLuAWjomQJVvtRgvr9	1631	794	175	6301	8576	jxVyPZ9Jdafsmw1TcW6gyfj2PDuW26t6Q61nLdbye34KXdywhR6	6306	8911	8911	1617543180000
12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	684	1352	175	6301	8578	jxVg5LFEQCDd9wj2AxVWKDKUsEH27MRmyyoowY9VxqRqW1qtvER	6307	8912	8912	1617543360000
12254	3NLjwybu4EB64EqMhhfm2SiwXtb9FLghgoz2F84PPq2HE5qiCmYZ	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1444	1381	175	6301	8585	jwyNRgt1J4bv2cLYnzBEdWy5NgwTct2SQbTsjQbc9spbTkPWq94	6310	8916	8916	1617544080000
12256	3NKWGgEFz5eg3MZqYr8JK732LwKdNiPUFYQmrLo9FdqfpcPBB5hF	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1553	776	175	6301	8587	jwscgWLymK7LvdKbkR1fWLnD7n6xcrFE6GDAuu5TrefU7zoPeF2	6310	8916	8916	1617544080000
12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	1457	1025	175	6301	8591	jxpsuXdbUcd4RobLLGNAEqVHT1ERY3MRpiBJSn8BuQRudWbuPVG	6313	8921	8921	1617544980000
12266	3NLn2awJVqADmUNus3mR2ht9zTMtEJbWstXUWcEPGhxKeD4kAFuk	12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	1406	1393	175	6301	8597	jwRSUruLvUDpog7c5xKHiry2BkEGDcWhcHth1b9bhoSh8yGoqpe	6315	8923	8923	1617545340000
12268	3NKjr3qzU5LQpr1r36hc9phDL1M3pnuEurgEWCQTR165WiUDGo5n	12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	1637	816	175	6301	8599	jwUxLBvCZpeEGTjiatNPgsT5fnNu7yUCFexs4P89eFs3oGdrxY6	6316	8924	8924	1617545520000
12273	3NKJBmjBKMCF72yMZTJN7RSG6zjMPzv8af3A5Y2DtpKdcoPEg7yD	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1460	617	175	6301	8604	jxru3hvvx2K96P8sTu8ZUHXYKyqdV85B2LvRGEaUGiTSzAafbzh	6319	8928	8928	1617546240000
12277	3NLvJ7ogpGFcNe4SteAyh756zEDAf91NRKhBdUPLLVtk5am1zdtN	12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	1460	617	172	6301	8608	jxiR4hrhjQ74uEJXoj2KgKthnB357fosMQzKxYK9TtM9LWjdqkv	6192	8928	8928	1617546349773
12284	3NKZEm7NcJBCjYBunhU9YPs73icUg3KUPh2sntevpSPNCSiyfgnG	12283	3NKSwYGMMZMMN7sc6Pb2ieyrrU8rKTvRE6kJwzmkEMB48zj6kW2A	1481	790	176	6301	8614	jxGoPYKMHx79tm3xK9TSSvnCsn1BedpHScpBZU4xwv2zPR3MG67	6324	8934	8934	1617547320000
12287	3NKNYRLvmnJKAsCLTrrUdwJCfk6k9yFUdfWEDCez85E1MX2K7qAC	12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	1422	1091	176	6301	8617	jwdhdsNUQ6y2fauohMr7kyW85B2W6fcSEgaSQwcXMBTqU1BAEWT	6327	8937	8937	1617547860000
12289	3NLYgmuXpbEVqND9xeCNmgyJkGFeqPKmLo1Kfgyd1A9GefpMsbUc	12287	3NKNYRLvmnJKAsCLTrrUdwJCfk6k9yFUdfWEDCez85E1MX2K7qAC	1467	1376	176	6301	8619	jwE8xodBVHBExygyz3ak3errHMY7jMj4udiEpu6ohzt7e5KcsCJ	6328	8938	8938	1617548040000
12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	1637	816	175	6301	8596	jw89BsQjXvM6gzFqTWZtc3SUB8UQqJQ3SA7xcZQNxFdc8ruVMWD	6315	8923	8923	1617545340000
12267	3NLgJgasAxGH5VfyhmUqzrLHCbyVuLrHvVWfyRWQN35bADsJHS1G	12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	1603	444	175	6301	8598	jwXztSBrD72DaJRQ4YSB94qhP86rVkwnq3ovnnjqyL3mT4A7N9W	6316	8924	8924	1617545520000
12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	12269	3NKn6fCb3PCh2Dz8wb9aRibL3uyLshbQjuk4rTPxLR94Mkt2JrR5	1631	794	175	6301	8601	jww4nbdX9Kf2Jtg3sgprrANBcYJWRaoBqqiL1fN21WNYZZJkEV9	6318	8927	8927	1617546060000
12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1588	1026	175	6301	8603	jxdeMDXuP1EMS8phh2Fn2FfHBcExd4N6Py25KFm5CbdiH3Ueapq	6319	8928	8928	1617546240000
12276	3NLgrRB9RffjFnXD8wRBvRipYhX24xcRxLtFqBMYCdpnTSbTk6Wa	11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	1460	617	171	6301	8607	jwLEeviDwm6WjkkdLSNqwssDphoNKBUWqemA2Zng3qY3UwwaSXW	6175	8928	8928	1617546312985
12279	3NLeGsvxSrLNhxPj3nbmv699cxcVuFk2wn9G8mnLcbqp412GLw6a	12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	44	1199	176	6301	8609	jxhLwrUYmcUUHAkhEUcw4GGXFnL3B535eqbFKW7atm71dgWASYX	6320	8929	8929	1617546420000
12281	3NLBKAokjpaYGeAeqi9HFm5g9nRiDxnhNhPs3KoMHbqbem6yRTV8	12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	149	1283	176	6301	8611	jxRoQBRMnTqXDAbpiRYqfs3wgSahcP8cRJALshUG2QZKaNBRaCh	6321	8930	8930	1617546600000
12283	3NKSwYGMMZMMN7sc6Pb2ieyrrU8rKTvRE6kJwzmkEMB48zj6kW2A	12282	3NLr2nN9zFhaeqSX4CSrraKATPU47htPhL4MXtAjkAtntpFCq4vc	1407	1395	176	6301	8613	jxaa5iSTyXebuRgZQiJ4rG1uSdQDqYZHMmGcjdcWJcBVmkYyrLQ	6323	8932	8932	1617546960000
12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	12285	3NKdJkkJ5M26mv1sNcMayiaViKBZygmgs1JVHwZGg36Vg7vHKH8M	1471	1020	176	6301	8616	jwPJ93zsxAyLZ2HSqdRrH2iCWYG4QFW3eZ8fdsnVbBHpzjDxLhW	6326	8936	8936	1617547680000
12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	12292	3NLSKnUhygmSSaKc2BUGVuNMxChaMCqAYVfRjE18fzLaDT4L5hPF	1406	1393	176	6301	8623	jxJUYe7SMkcSUHk2SsV2Byz2cW7d9BVtPuN3tJtiqP42FJhZBbR	6331	8942	8942	1617548760000
12296	3NKcmkKSJV34x2qipWogedjByFNJMBvHLk6UyRbdpxSJMuwpnZEg	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	1407	1395	176	6301	8626	jxSppohjy2t3oXDsDVGHg5aCr882NPGqqRnxhASeCCxXaJ5B4zt	6332	8944	8944	1617549120000
12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	12297	3NLxBe7ozF9ofpL7APtwHM4j29s6nVgBTv7npop6Nd4EUt2esJPR	1553	776	176	6301	8628	jxy855g66Qeb5DDSgKajj6xpAmk6aiLaUBZwCvBK5BsHnpK5RCc	6334	8946	8946	1617549480000
12308	3NLEprVH5gzTCuNYETsyGeBUFia2TQgBXHWfVW1ZdX3sCsDCfJKB	12307	3NLctvYWfxMqR1rcm2Juik4jy1XfyBqdKudq2PcFZSZk1mKXzuj3	1596	1117	176	6301	8638	jxrJf9rPgHcrz5uUxwAs2odZDvx2uJpugViSZVfZbUMw2ucrqUg	6340	8954	8954	1617550920000
12311	3NKey31c9G9o7N8CaRZ5VazXy5di8v9xZrLbhzoifjh7YU4m6XHC	12310	3NLX94nMi9R6t1TgATMnGsis2aRDTfk15GE4LFMcrrt5Ab8rdU4A	1622	1110	176	6301	8641	jxzPxEPFAXMxwqsWKBNotqa75cYEbydQUg22Q4ENMYQPD9ZBgSH	6343	8957	8957	1617551460000
12314	3NKejtMhZq4KitP4D9rzBa17ZiXw9Vc7jpsU2mPwQNW51JmppZj8	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	448	939	176	6301	8644	jwVN4pRdKB9nDEM7wD2ZR44HgsbnUDnE6p4NLVoKWECcBvv6bkv	6346	8961	8961	1617552180000
12316	3NL3AXYKzQ72QPZpQ35p1Ngaa9nvtUqumzrvrR9NHqDvR3hffSeC	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	1406	1393	176	6301	8646	jxKT5MeX6cVCUYR4hgoUhqnhHbjJJKeVmprhT19XmfSY7WRfb6s	6347	8962	8962	1617552360000
12321	3NKGkLxdJLgFsxZNgQ3uK6PfVBFd7EB7Ta31d9cx5dwH52JTbGw3	12250	3NK7Fc9CXhzEzG2DWDi4ZcbfELKUXFn6hkJsc6Em6iekWa8rrfdt	1579	1263	175	6301	8651	jwZM4GK9HAD1tRmVWxTPSqM6Ez9GVUnDTSuNzTZavdUfmr24ECg	6302	8965	8965	1617552900000
12326	3NKopCqiq8pr8P3BdsfCJhWdD7AwSjKjrcvEDLGXLCEJfHfei1BD	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	298	1062	177	6301	8656	jxCQBS52aSg4SkfpwfyEiwGfLj2z6wSFr8XvmAshxEipEVPbtVL	6353	8975	8975	1617554700000
12330	3NL84msvQLh512TXqnvDtjRkmTA7ChMKidGYW3MCo2ZtraBnUott	12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	1637	816	177	6301	8659	jwEU8CFVRKTXkUMxgAuCAgDkLa2fA2XRwUQPK7EKj3ZfEaBC4Xu	6354	8976	8976	1617554880000
12332	3NLDQTLasbcm2qKCAt14saqKfBAjhtGxiyJ5JFEXq9Kr2kJucq6H	12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	1426	1118	177	6301	8661	jwcmbjSaTEDF2Y61xfe6zgGyU8vGdRHLSj48btHvTAr8beSkrqD	6356	8978	8978	1617555240000
12337	3NLxBj9KzEszPiWnt4ZT91Xt65jRXCSC7MvmSJaFXwqhzqqeFara	12336	3NLrSJQj3vN1xxYycj69t94UW8APatind1SKicptBiMkGpnwqnFM	1560	925	177	6301	8666	jxZb1BW1K1SgdKkKPMCSj8rLUBCtXRHqLNbhLcCnxmC8jaSvJck	6359	8981	8981	1617555780000
12340	3NKwMqLNukUDkBBszwoPQEx6F3HTKyJJTAqBTFtEDzL8BJ5mSPRs	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1422	1337	177	6301	8669	jwEJYnyBYqck7tyraAxhUpvGBed9hHcMyTkPiCWXY65omiXbpth	6361	8985	8985	1617556500000
12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1407	1395	177	6301	8671	jxUsTqjmCFiZFigqcFwUTKAXbPiBnekc5WAuk94hTKUMP1UVfrz	6361	8985	8985	1617556500000
12343	3NL5fRBseknr9Bk1236ENQQqTrRzk11k9dBqBFwC5hyuzSmzTRi6	12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	44	1325	177	6301	8672	jy1eqaHXZzKhnxQXnM9mVwrp379a2QfnvT6pTbmy4TUv7SKrbi3	6362	8989	8989	1617557220000
12345	3NKyf4kphAK4DwHiCWVAAj7PrGzfH2xnc24EC2fSNSF1VRxK9DUh	12343	3NL5fRBseknr9Bk1236ENQQqTrRzk11k9dBqBFwC5hyuzSmzTRi6	1426	1238	177	6301	8674	jxVX1QDdscTbE3UZqedSrD5ASMLJ2xn81Gi5Y8in1sNcQdRxg8j	6363	8990	8990	1617557400000
12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	12347	3NLXeFDAd4EwLUe7fhfVkT3AjEXxoPBZ5M2toQZxhvdi3MDHaddG	633	1384	177	6301	8677	jwsKmF8mYkeN5byFZqnEnPcRuDFUogt9mm7tUxgPaCPYGLcqehc	6366	8993	8993	1617557940000
12354	3NKucfYfyfbnMs9irSb41vN9mt8Wb77rEoXfjH2jfvBv5h6imssH	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jwvQSCSBbcp9sfZ1NGajE8PF67zo8g9iqRJmngSPQ1wcqauYmhd	6369	8997	8997	1617558660000
12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	1652	1315	177	6301	8683	jxe5ZemNRysJPyFDiHvLVfAmr4oaaQFXeDYnY1ETXNGgHwBshMj	6371	9001	9001	1617559380000
12361	3NKWnjDRm9GeoPHmv7JLby7KLSg8FsSrJsNSDhAHM6xzvAUSp5F4	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1507	1280	177	6301	8688	jwT7hT42CCLDGWmV1fSAXncL1BUiTLXRNPJ7SLnrdsa7Hx5NhYm	6374	9004	9004	1617559920000
12366	3NKz4guaKEqPseVc4XGD27fsnM1uFTKnRJrd2Y2AYguU6CHHNngH	12365	3NK7Bc1E91spSm2FNBySvCbari8mFwU8Hw7VFeKkTyJdggajedPD	1474	1329	177	6301	8693	jwvuMSsKTUK6HkzJ8d2LTjHCbCC38U59ECLK3A5A7jPacJzaqFb	6377	9009	9009	1617560820000
12370	3NLEKMmAjrF5RqLWa6N7nDEnx7uE9xbfSMtskH86tVP8s92bzUTV	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1646	1354	177	6301	8697	jxE2iidXJi8hfxAWxe4UDRxHmYefKzqhh4o3n4dc2dseiKr15Yq	6379	9013	9013	1617561540000
12372	3NKw34rKwHDh3JoQCwg8c64HsoTeY1yAWixhir2TaBqR6sERXLTR	12015	3NKnr8ffDttC5Z1zZXhhcwkhT436X5fmqyQxi4Wx7FHTX4MbrJ1s	1439	1279	171	6301	8699	jxeThJakGgVT6KE1EbCPBhxYjFAxXCPZtegeya5GdvsQR3nkuHc	6135	9015	9015	1617561900000
12275	3NKzK9kEWcFEARjKxuU3joh5YoC8pkpKB2mxGD7cDi9YtHsuVHny	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1406	1393	175	6301	8606	jxe9t6RdrCNBBPWyR2jAkukd51QtQ5pFf2BwExZKgTvTmDKvjea	6319	8928	8928	1617546240000
12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	44	1199	176	6301	8609	jxhLwrUYmcUUHAkhEUcw4GGXFnL3B535eqbFKW7atm71dgWASYX	6320	8929	8929	1617546420000
12280	3NLQx53KCpX3Pb95hUSzST59Zs6VsqKSPx3FQZSPUdHheT5ganp2	12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	1406	1393	176	6301	8610	jxFxtptUdp1HP364JGUa3hkwLB4NDSqxLTDoG19FXPm59Aim485	6321	8930	8930	1617546600000
12290	3NL7AjZXdYxrQaj5tHvxrTBShvKzDehikyfZzSA8i6st13xpVZtq	11947	3NKwJ2tNCudvi8r8PjZp9cuH4uzToFEoScWwJs9H39QePJRNfBUz	1458	957	170	6301	8620	jxuF5vbgxowCPyQFCY2riUY8Ar1CQ7aYG1uAucp7uHGvHoLhK4Q	6139	8938	8938	1617548040000
12303	3NKXuDX6fmRZYmWpFq3EDpikdip17BqSbeyCyDyZr96NsJwHA6T8	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1406	1393	176	6301	8633	jxfp2Ug2z8vbx4oUrqokEiVAd3YfsY2jEyWkkKWBAFY5Cc2EjTc	6336	8948	8948	1617549840000
12305	3NK7CG2pvWk885nJnpfAJw1sgo7mZ4QrjZ1M59gzwvLHWpV2fvof	12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	1522	1322	176	6301	8635	jxaGArd7RRWjijnTRgeoWQPePDjiprJsg9pMsetpg1uX3PgmpDL	6338	8952	8952	1617550560000
12310	3NLX94nMi9R6t1TgATMnGsis2aRDTfk15GE4LFMcrrt5Ab8rdU4A	12309	3NLQ3WSfTMfWatWRcnRW58RJgZygsK1BkuKbC1VBRgdmvLYn4sFs	1406	1393	176	6301	8640	jwnmx2wiBWaAGAopjvziDDjP7pBayHgyPVafD7DnxYw7xL55opp	6342	8956	8956	1617551280000
12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	12312	3NKQzGbu6zWdqkG8M2p8eaQZSPRRKtRc3B1v6FAZzrSyH4v5ov7M	700	840	176	6301	8643	jxKnDQhAWQBe4C8JLB3KQkFxmc8NVR6urzwPcQ8Ecte4NpGqp8E	6345	8960	8960	1617552000000
12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	1447	1345	176	6301	8654	jxJFmtYaoMKvRi7iYGy5vRyhTZELkpdcDM9rsvdu4f6i58mSCG2	6352	8971	8971	1617553980000
12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	1405	865	177	6301	8655	jwaBgNRn3KfVVyopMWpQajtYbFifQ1FMKw47DZqqW3tawphGMzf	6353	8975	8975	1617554700000
12328	3NKsR786gMEymBT88AGGTYXTgpeGyT75ibFfRJqh9MNkbvERsSNp	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	298	1062	177	6301	8656	jxCQBS52aSg4SkfpwfyEiwGfLj2z6wSFr8XvmAshxEipEVPbtVL	6353	8975	8975	1617554700000
12329	3NK3Mk1u8UeqcQPy1d82DjMn6utWBQuNgU2jEZZJdNP5B8vK5yQz	12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	1406	1393	177	6301	8658	jwXLc4FUPfvuZqJTFnAZ42hn1qbUN2Z9e7pLqw3S9YynEXKphk1	6354	8976	8976	1617554880000
12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	12332	3NLDQTLasbcm2qKCAt14saqKfBAjhtGxiyJ5JFEXq9Kr2kJucq6H	1407	1395	177	6301	8663	jwNZFaJWTQAX1CJht42KRRuYwW33VRjg9eT2P3pCnzz95SHvwrq	6357	8979	8979	1617555420000
12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	12337	3NLxBj9KzEszPiWnt4ZT91Xt65jRXCSC7MvmSJaFXwqhzqqeFara	1642	1367	177	6301	8668	jwmYLJwEAAVSt29psSitSKwmxEXqQVUtBGyka413ohmuckZcnsv	6360	8983	8983	1617556140000
12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jxiGj2Q1vGqpQNnBfhwH18RnymQ4wiJkBBiyK2ptjPPijW68BUW	6369	8997	8997	1617558660000
12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	298	1308	177	6301	8682	jw85U27UgD3BCMjii3Z9m8Mw9nh8XoX3BvYK31VcfLgCVQ822kb	6370	8999	8999	1617559020000
12358	3NKdKs7UjJNWRugGMUwFmDVg2Je1XSfbsw7JPApdkPov5cMGdPWi	12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	1652	1315	177	6301	8685	jwHGFngLRD9T16KQBSxwVq26461DhryMFjK79Uax41NQ4yM7f4Q	6372	9002	9002	1617559560000
12360	3NKM2sALnxjPesJkQN11RKTsJR4KRx9MdNAeXsvEGZBfG5VnAXvd	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1467	1376	177	6301	8687	jwS5gmEg98V3kU96cjwPKKBKbSoXVK7vK3Wsg1TTtTV9jaBQe7T	6374	9004	9004	1617559920000
12363	3NLsYmow9Vwcd6rtyB52BWzxJqWLc73XnsZGcz1z5vHX6siqLfPH	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1407	1395	177	6301	8690	jxNMLphju6Vmn1aDpkyGFUWbPqjGfAb1rmTuxgU4ae3Tgb9cpsE	6374	9004	9004	1617559920000
12365	3NK7Bc1E91spSm2FNBySvCbari8mFwU8Hw7VFeKkTyJdggajedPD	12364	3NL833vFg1dwkTNpfjxeo8uemESdZexdyzo73XiFUYfnqqpDoC5T	1407	1395	177	6301	8692	jxjYkL2Ji6Du67E5hLDeb9iPADgTkgUs5854MjeePDvAyunhwBK	6376	9008	9008	1617560640000
12369	3NLhzFVWmgipjKpVjvihCCYAcroQXoU1hhpa1HWdTvx8fPVMD1Yx	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1403	824	177	6301	8696	jxEDASdth5TC8LMkK4qojV1XsDmpw4YscA2dNJGVdQ1Bo9DgRDA	6379	9013	9013	1617561540000
12371	3NKPpuMegA43hAaUzuB7LCqCdANVuGbAr1L5pgPpwUFQfg2H3Skr	12369	3NLhzFVWmgipjKpVjvihCCYAcroQXoU1hhpa1HWdTvx8fPVMD1Yx	1439	1279	177	6301	8698	jweqCtxWvN4yqaWP6MuQE5sSCHcpnNPjcF5sE9viZ3LxSdaKT9q	6380	9015	9015	1617561900000
12377	3NLJ37BbHdF3S6zwdNXNQgQZ2uE4TZ8zDWvKgdqhTog49AJeBa6F	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1601	1388	177	6301	8704	jxKvLSq9eb71GxRoZz9LnANS7Y4vo6ttzGg3Nfnnk78sepzxz2v	6383	9018	9018	1617562440000
12382	3NK4omhco9dPfy2WVSNgK4XU2uD99r2xTiMuuJ6huXucSNh3yVVd	12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	1500	931	177	6301	8709	jx4srfzCtAKGCUiThD5zmP3XTHY8RzA8yCwYX8wzEUQi7toyBJB	6386	9021	9021	1617562980000
12385	3NLGqnRrWDG6UcnAXHwPiH6Q2fJ9CS1doUKnTUbuVFYSEA2CYio7	12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	1553	776	177	6301	8712	jx1X6DXxgPEr6uVHiDd988dRQZ8wo8Pxn7fAqpQE7gAiEp8UYiE	6388	9023	9023	1617563340000
12387	3NKeroGaYMYLaPKWZTaZHyT1kwkxBPE8sSJ3CKftaE6xBE8Ca69Q	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	532	1303	177	6301	8714	jwQUG9ibRoMapTLCudGyNPr3oBSEFbbcsYiHLZRF2SGEuJqsDCh	6390	9025	9025	1617563700000
12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	1631	794	178	6301	8719	jx1XfevKmMYktK2tk2y9jtZyFgqbzB8LMgPYANV6UnsQjXPq5F4	6393	9029	9029	1617564420000
12404	3NKoru1bz9naMB3KCPHeEVppP4axBRAG37mxo1ccfuYkxKzqMS3L	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1460	615	178	6301	8729	jwU7CqJBbVwJn4nCvRZPti7Kv2V4F8t6gcwUsqxaJer1kfeSr5L	6399	9037	9037	1617565860000
12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1406	1393	178	6301	8735	jwWM3fS3wAPoch3yrHGZiw8EkSmrgyUx5Pnw73XDxduBEsAmCrj	6401	9040	9040	1617566400000
12411	3NKr9k3Td2jq33TAaqNL2FmEsri5G6N4QcmB4bcAP8v8CyG9oQCx	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1467	1250	178	6301	8736	jxCshTYCNEJ74hY7PHyWV4Lds1iAYJLq5pZEpVgRewHzeGa8eas	6402	9041	9041	1617566580000
12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1609	1333	178	6301	8740	jwoVTUXDJHjSMc8q5rDsVGeR9bJDQbZ9m5uW129aGgkQbx6hG9S	6403	9042	9042	1617566760000
12420	3NLCEpT82TvCWUownBay9tzfyKVApxWrFh9vtSSxqrkUtW9JAbEm	12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	1403	824	178	6301	8744	jxQoLVmrZ4rQqCALNbJFqnmGkC2DDNzWbeG4gYiRMMyqLM9CfbX	6404	9044	9044	1617567120000
12291	3NKX2TfipbMFsKwCBPeAifAH5Eri1NYh9ntsE4AUwpny3B5k4Y7X	12289	3NLYgmuXpbEVqND9xeCNmgyJkGFeqPKmLo1Kfgyd1A9GefpMsbUc	1648	1284	176	6301	8621	jxQb17sC9MWDBptwnQoU5MUiW7zNEz4zt59MzxTH57VRmV6bzfE	6329	8939	8939	1617548220000
12294	3NL2xmi2FAb6WqepePgUERcPrpbxRQ9bvKn7BhTC4Up5RB1wNcFA	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	633	1138	176	6301	8624	jwDMYrGmzhqTs8Jj37tDNJuGGMwKLXKNxE53Q4sTgxPTSXJy4NB	6332	8944	8944	1617549120000
12299	3NKznkZ3dQS3Dk7gyzQy6hbLex34JeNEPNhPwyGwH8Cyb7JkGPg5	12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	1467	1376	176	6301	8629	jxMxwx46UfsecA13rcPkKjZDpk9eYv7AShCNQdE1WZtGTxxSERy	6335	8947	8947	1617549660000
12301	3NKpKeDy14vFxDAoKweMtM3gCo1JrWGctRzRwU17H3ktaTxHSWec	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1448	1311	176	6301	8631	jxrbAxSkiCrvRCsnEJSfbhz1aEg783rCH1GFqW87VzTPAyVoaiN	6336	8948	8948	1617549840000
12306	3NLqRwvZjX4sK8gAvi4yAfskgrxTZ7UPbngdYS7n9diE7mSuX8Cy	12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	1553	776	176	6301	8636	jxEcab9XtuZcdwnFf7pN27RqkRWukEhamwVoBdpWEyvTnawgCxs	6338	8952	8952	1617550560000
12309	3NLQ3WSfTMfWatWRcnRW58RJgZygsK1BkuKbC1VBRgdmvLYn4sFs	12308	3NLEprVH5gzTCuNYETsyGeBUFia2TQgBXHWfVW1ZdX3sCsDCfJKB	631	631	176	6301	8639	jxx7RvECWTZgEEoyzduv3XMojdCDfLMuqV48J1gA1B5jhEQHYFh	6341	8955	8955	1617551100000
12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	1402	874	176	6301	8645	jxTFQAPL57QYF3SQKZGqbjTcqKao1Tyuh3N2mMZ9LQpdeW58Xz2	6346	8961	8961	1617552180000
12317	3NLELJ5gvVN2h1izSenXjZt1372Ks4RZJFqF3T5qqEeptrKWG8d6	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	684	986	176	6301	8647	jwV9FMda7XpbNnzYaAc8UwmrqV911WcQyigvNX4zTtPkKWoMvZG	6347	8962	8962	1617552360000
12319	3NLRknxvyTjA6cL12jnkQjLgietoboKdcXPi7XJhF9NrpJ8PLw4C	12318	3NKu6QQGK6jDaWv7EVJG4raDN8bB1g4uVp1QULcsmehgNc2pztHU	1501	1234	176	6301	8649	jxB6cZAmRq9BS4Zv2xWcicimrfCiL5xQ42udVqtP61QAbBod2d4	6348	8964	8964	1617552720000
12322	3NLV8ru2SF9E9hX4w5cSsgWfst1FWeeyhoLpQ7WgntFn7BgGjrzC	12320	3NLtnq2s1kFGTRUkR2DPLqCxYuzPYPsZdwArtL7KYcSKMACZPtFG	700	832	176	6301	8652	jxxbgy1wn5meYz9eqAbnyuBeXW1tY3sNg54wXiq1eYTgCUo1ZbD	6350	8967	8967	1617553260000
12327	3NKesjAocjmcd48Rhrwi32EFj9DwGroCgTSwBzgr9BTf9tAGXNNb	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	1637	816	177	6301	8657	jy1kW8TFmzYjR4fgq7HABfcbhTVWw5adVhcAtqCrwuA5fE3unwe	6353	8975	8975	1617554700000
12333	3NLvY3BtdgfcPK2DTDfbAFGAXykMJseaExuQxtdS6w3ioLvSXeFt	12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	149	1283	177	6301	8662	jxtfdSCy98eJ2gKQdXyTRRHbLCdZ73Z2sC55VwCZa8fWRSc58Nf	6356	8978	8978	1617555240000
12335	3NKm1yoGYMGEAFApEayhAi3demWqjW8odag1q7wpPgopN3d1Sd6n	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1637	816	177	6301	8664	jwgxzZUQtE3tm4PgaLzq9pZuUGmwktpSTTCboSCMSGknXbQxoE8	6358	8980	8980	1617555600000
12341	3NLU9g3QXfDc5CCFXxccXGuCy8RFM1xbLapHPDLcPTqQSRVbjhHA	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1483	252	177	6301	8670	jwpGQnvPmoRH3ErigtbhLZ2vyBrBnP1RmTdjvCCnoqjN3mGpJK7	6361	8985	8985	1617556500000
12344	3NK9yRwZYgadWG7YcLeEerzCkgnjoBsvyhLRFCY4SPfHf8KL1PAz	12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	1585	1366	177	6301	8673	jwKXVw8wF3RFL32BKwc7wptmvJUzEPZHiW1eCoQqfgqR5NuZcJw	6362	8989	8989	1617557220000
12346	3NKsiSB6C5W15tbkDzca7YRysrpnZdQoXEsXRMTH4dg61zgy37Us	12345	3NKyf4kphAK4DwHiCWVAAj7PrGzfH2xnc24EC2fSNSF1VRxK9DUh	311	1181	177	6301	8675	jxZDZvntUiRjFCPu8dXAqFQM5iqSJWQJqvYY5fxp4RTBf4mKJbk	6364	8991	8991	1617557580000
12349	3NL3YBPT2TeLsB2jbutMiQyLRT9dPuB85kjFyqKedKvL7hXf8Dts	12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	1402	868	177	6301	8678	jxtqbHBGRxuwdegx4Hru5DwiY3obd3T2TU5nhXmDEaohWQomYCa	6367	8995	8995	1617558300000
12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	12349	3NL3YBPT2TeLsB2jbutMiQyLRT9dPuB85kjFyqKedKvL7hXf8Dts	1447	1219	177	6301	8680	jwGtxGqN5kxfBQbptMJUwLFuBh5gC5sdZ3QbfVzf8TYu1FA8pa4	6368	8996	8996	1617558480000
12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	12357	3NKpxSUMPgEVPfPEz7U1SZGHjEysThTakMTrS58PmH5YdXx1kh8y	1467	1376	177	6301	8686	jwnF3L6NYuHAv6ywCasZ3QwSxhuNiYNfgsLnYp1YkFtFkT3LhSY	6373	9003	9003	1617559740000
12362	3NL3eobUHTf8F5pazWbVNmcRcRnMjbdBHmNrnEgmynT1R5fpqwtJ	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1637	815	177	6301	8689	jwCY4xYvcSgCuWSoUFJzGuryttwWohWckLBDYQB58zf17Gafx14	6374	9004	9004	1617559920000
12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	12366	3NKz4guaKEqPseVc4XGD27fsnM1uFTKnRJrd2Y2AYguU6CHHNngH	1594	1200	177	6301	8694	jxGRSp8Hrj61bCeGA49wY9eQBfdA64CcRqMm8b6VgEv9S8PprPi	6378	9012	9012	1617561360000
12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1637	816	177	6301	8701	jxC2V3G79sAX5tCChD6tuUAQFZU3MX3Pnokg5XoU7FJeZLetnNo	6382	9017	9017	1617562260000
12379	3NKp8b5kzvU8jeXtxKbTBWYSXt1SKPYEKfaCaS61m48rB55SyDH3	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1594	1080	177	6301	8706	jwBvd4yAs2Dx8NaQGp2SoPocSAC5YyVx2AcoiGkvs9RFMDJ9SFm	6383	9018	9018	1617562440000
12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	12382	3NK4omhco9dPfy2WVSNgK4XU2uD99r2xTiMuuJ6huXucSNh3yVVd	470	1183	177	6301	8710	jx8jNGP2ETUWqApYy5uWb59MyRq3GcNVn3CQgzbXStnAHHsYFbV	6387	9022	9022	1617563160000
12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	532	1303	177	6301	8714	jxPMA5CwnjSrjX8sKdmNjmFsFozJhJfnaf3zLDxuhA79tk3krEW	6390	9025	9025	1617563700000
12396	3NKW6bCi87s8pPuQLgUWZadJy3XK8yAD6oHMyLkVBvzF5ankEYyM	12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	1500	1051	178	6301	8721	jxnxTENHkULkeBtFRoxoPbfCygS9ugjaJPtdk1VgMWZeFwTALpm	6394	9031	9031	1617564780000
12398	3NLhnQFU9NTo2qe4MvUjbenY8skY1RyUGGD25iyfmbLq7cVxvP8o	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1451	1292	178	6301	8723	jxzB92WWF8CkixdQqS5AkeURcZsEptPLAEXeiLEVwchgGarcChf	6396	9034	9034	1617565320000
12408	3NKhF9H2zcwKqkQrt5eH5pvV8w5qF3q9dvpztXzhyFLtqgn1bExV	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1610	1314	178	6301	8733	jwCwJRmLkgThP3DrHq9v3CQPHA5ZLUfmLFWHc3FDz6K74WaNDHQ	6401	9040	9040	1617566400000
12413	3NKJfFpZP6NnipJFBUXJHfzVb7L27y46xEi9WjyPpHsWvpnNYuJW	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1481	790	178	6301	8738	jwB4bRTN3x68PgKEiPMaYpvxXo2od22MEF73jSYXG3gsaoJRpnP	6402	9041	9041	1617566580000
12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	576	989	178	6301	8739	jxBcZ9P4Z9GkTpoVQzKZSoDY3eenCncc28vophj9VBgV4km5m2Z	6402	9041	9041	1617566580000
12417	3NKMwUiuWwodS3DFdoFKgKVArWaGGF4j8Ch47vuS6HJvWRoDMBkj	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1500	1051	178	6301	8742	jxbfSSr1JgFdSxD9oWVgk7aFBjVGXxWqFBXeVBW69RETXRygfwF	6403	9042	9042	1617566760000
12422	3NK7vuV46n3skVoXgdasaZKSz4PnJFzWSYWUaxw27NJTh2zbTurw	12421	3NKMgyn1svwMnA67oRCHpK4KWn4edHGk8DZJrmqndCuXqNZX8LMs	1407	1395	178	6301	8746	jxPf1A2E8TVq8NC5di84vbJyQyuJEfcvjUbMBAXN5iwdUo3rxji	6400	9049	9049	1617568020000
12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	1642	1121	176	6301	8630	jxZi479dFx6JL1BEH3fnMrqZ46wNtuHQAAuaP58zXvZGEd2UHCU	6335	8947	8947	1617549660000
12302	3NKm1v435EYdWU7jRF9gUt884tbxo9R7NTXq4iruJfUGjxBedP4J	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1419	813	176	6301	8632	jxiyVDRx6kbtjpZPaVSTsSwSzAdeaznUabRFrhpfWbZYoxh6N8A	6336	8948	8948	1617549840000
12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	12302	3NKm1v435EYdWU7jRF9gUt884tbxo9R7NTXq4iruJfUGjxBedP4J	1406	1393	176	6301	8634	jwRF72GEt1bfXiTgdWqxcBFChYtZ27Zorezkf2rA34BVuN7ExjT	6337	8950	8950	1617550200000
12307	3NLctvYWfxMqR1rcm2Juik4jy1XfyBqdKudq2PcFZSZk1mKXzuj3	12306	3NLqRwvZjX4sK8gAvi4yAfskgrxTZ7UPbngdYS7n9diE7mSuX8Cy	1631	794	176	6301	8637	jxkbxABk9QhnG9tdrAXUFyhNqAZJrsfunFE92vRreYt5g8ZDuDv	6339	8953	8953	1617550740000
12312	3NKQzGbu6zWdqkG8M2p8eaQZSPRRKtRc3B1v6FAZzrSyH4v5ov7M	12311	3NKey31c9G9o7N8CaRZ5VazXy5di8v9xZrLbhzoifjh7YU4m6XHC	1560	1165	176	6301	8642	jxXMZPaMMQEGVUNnKkWvE2bNkyio8CiV4n12WSzbDPAk3kyiq6F	6344	8958	8958	1617551640000
12318	3NKu6QQGK6jDaWv7EVJG4raDN8bB1g4uVp1QULcsmehgNc2pztHU	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	576	1355	176	6301	8648	jwn9ATbEfLFpV4EQ52jtHZgAiPsS2HNwzhh4X6kzaob6jGp2VCE	6347	8962	8962	1617552360000
12320	3NLtnq2s1kFGTRUkR2DPLqCxYuzPYPsZdwArtL7KYcSKMACZPtFG	12319	3NLRknxvyTjA6cL12jnkQjLgietoboKdcXPi7XJhF9NrpJ8PLw4C	1579	1263	176	6301	8650	jwdMsvoiPa4dffWBw7NRKC5BiZ3PTbWJeGy5XtAQgNwtfLb5Vp2	6349	8965	8965	1617552900000
12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	12322	3NLV8ru2SF9E9hX4w5cSsgWfst1FWeeyhoLpQ7WgntFn7BgGjrzC	1601	1022	176	6301	8653	jwzHP4CwviRm6w8Red9DetJnDg4EUxP9v9wnN4UjSrfFwyf3HmM	6351	8969	8969	1617553620000
12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	12330	3NL84msvQLh512TXqnvDtjRkmTA7ChMKidGYW3MCo2ZtraBnUott	1509	1320	177	6301	8660	jwuu5qVeuceZQnK3BACruLkLUoQZUjm41aAB5zsrAo7mjHoC9rs	6355	8977	8977	1617555060000
12336	3NLrSJQj3vN1xxYycj69t94UW8APatind1SKicptBiMkGpnwqnFM	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1643	1053	177	6301	8665	jwBbCkVUsfMakUF3ZMMdTTn1wLuwtJhDiiEKogQDFZHMpTfuf98	6358	8980	8980	1617555600000
12338	3NKsjSqKPau3SozWmA3GfahYtmueF95L43ihbbE7gE5Ez2gCxEeU	12335	3NKm1yoGYMGEAFApEayhAi3demWqjW8odag1q7wpPgopN3d1Sd6n	1560	925	177	6301	8667	jwXwmxrUbs66zDgVy2Zx5QdW4bikUsPaPYVMi14NR1gg3E2AqhR	6359	8981	8981	1617555780000
12347	3NLXeFDAd4EwLUe7fhfVkT3AjEXxoPBZ5M2toQZxhvdi3MDHaddG	12346	3NKsiSB6C5W15tbkDzca7YRysrpnZdQoXEsXRMTH4dg61zgy37Us	1631	794	177	6301	8676	jwoAJoEpkyQEXetoVCNpBqAeKDCbS1KwAaSjFe2yCzn9DHXWJ9z	6365	8992	8992	1617557760000
12350	3NKURxi9R98rkGJ64Enq2PHMkPrHG7dT6EMq97RHLw4WV7yrSBee	12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	149	917	177	6301	8679	jxvimUKViRR5qKr8H3fteM6vRnVpyjmq4LoNNbCXk9MBDR531kT	6367	8995	8995	1617558300000
12352	3NLkDYzTGTsne8jfgA37fGgoTAi3vmZCutnRoLudycPUSgYEKAAj	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jwqdffawuxhVbU1rxYeJ4WSgjKTsoGZszZM4Diw92nU8ufjBTEM	6369	8997	8997	1617558660000
12357	3NKpxSUMPgEVPfPEz7U1SZGHjEysThTakMTrS58PmH5YdXx1kh8y	12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	1654	1214	177	6301	8684	jx3EhTfm4Nu6vfkBKZ5qoM9cgKTjWT3n4Z6WY7Sy9UkgGMUrU1G	6372	9002	9002	1617559560000
12364	3NL833vFg1dwkTNpfjxeo8uemESdZexdyzo73XiFUYfnqqpDoC5T	12360	3NKM2sALnxjPesJkQN11RKTsJR4KRx9MdNAeXsvEGZBfG5VnAXvd	1522	1322	177	6301	8691	jwFuLT6eqKjdTwprx3BGPNfkv2KA1hU56aDVoK4AwvzDNj7us3b	6375	9006	9006	1617560280000
12368	3NKPLW7Ku8YSDgbBThdJ5H8Wi4gsC3pSbxCXwdwwR6J9YEDmPx4b	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1501	1114	177	6301	8695	jxYdtCYmvYU54nskKerAfU3F5CswRaoNHZbaVEBAXT8xdGv18ts	6379	9013	9013	1617561540000
12375	3NK9p75BjVpqDNuk18xrnJnKtaFLMZ2ozGCnK5yEpvPPK6kHwxZK	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1407	1395	177	6301	8702	jwTsXpmHYkd92yukQKCWu7igKpgbaioiQkCMUJcL8tqbn9JSyxf	6382	9017	9017	1617562260000
12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	12380	3NKzbgNqGeMztBrqrep18Afo1WQiwSjcagvNj35STKaN5b16YxU4	1609	1207	177	6301	8708	jxDm8XznyiM7jxyhtWnrjLujMnaEExkNeVkeMNWcMmsmDPXEtxR	6385	9020	9020	1617562800000
12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	1509	1320	177	6301	8711	jwxCMRGMcGVQtCWDKpZZwSPk37YC8BA4bH4xB8kwQVXFwdF9tus	6388	9023	9023	1617563340000
12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	1637	816	177	6301	8713	jws6Hv2VpD7XFRricNjek75hNBy7dD1p8d4AyG28v1bZ7uxMAq2	6389	9024	9024	1617563520000
12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	1407	1395	177	6301	8717	jxrrSDzTtJZVKBPRu2mSdxx9fAhswW3BEZA9khPMJB7fQKZWi7B	6391	9027	9027	1617564060000
12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	1547	1378	178	6301	8718	jwUYXXGmPku5FsboubzRs3EbLPHUVrokBmprcN81PnUM4jX5gLs	6392	9028	9028	1617564240000
12399	3NLg6M36TGYj4UDF4kfKEFuA4dhs6VXirG1d5XXVmTLVNe16xWPM	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1403	824	178	6301	8724	jxJbB8coGae4kjRnpaiPR1s41WTDr4o7618nYf6NX49VK5WH8X5	6396	9034	9034	1617565320000
12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	12400	3NLAMAyvcnkgE4eZQTsqaxfyMmM3JjXfer7tFb6D78GcMKEvNNVv	1402	852	178	6301	8726	jwZGYokLoDCftsT835pw2gsdkSVXYWZcdCBCVRc9836oKWf8S3A	6397	9035	9035	1617565500000
12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	641	1336	178	6301	8728	jx2xr6fjuJVSrao7YzKwiTCbasYAfQHn5HqUWp3KFqKmfGQbqoV	6398	9036	9036	1617565680000
12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	12405	3NKF2stM3ztueAsuLzAEgRf5gB4RrrXrhQHortGGmUcwnQTnVdHG	1627	1385	178	6301	8731	jx6wEPqio7Esu3g7nRTpiBByYn3Y6YbM3gMAJsKGxwmKjRtSZBr	6400	9039	9039	1617566220000
12409	3NLFjmpSAqu7c6LwtPnMQfu8pLDSz2yAhmKnKCnkGsJzmBhS1Ati	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	684	986	178	6301	8734	jxGhiEwqz9ovtk4Svxz4GSTJLxWA6xCYPfFBnrVwL7dpCU8g23Y	6401	9040	9040	1617566400000
12418	3NKMK3FGjAEf6yfQHFnC3veYSabZ41AJv2uCw57YHMHyPgnBh8ke	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1500	1051	178	6301	8742	jwNbMmqxsYzkboskUAy5mS5oQGpX9KQrtpGA5gT5eHrQYpyTQiM	6403	9042	9042	1617566760000
12419	3NKw2RLBmrX23Mw6Um1ji4iGgJpb6sQbpE5JEWpxVJTCvaTVSAsc	12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	44	1325	178	6301	8743	jwvDQQiBhezjpYNugR2om7VPCc3kfkKQHzkEphHaHfaLUv4CkYR	6404	9044	9044	1617567120000
12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	12424	3NL1M3Qm9Dg19e83Xnfd9jwEiEgyjP3PgqQtQ9HFB3f8FbcA8fJw	1402	868	178	6301	8749	jwuoJf2s9vfxzam9xWNUianH2ray6b93RKEoAUFjKC7ic8LpJ1f	6406	9052	9052	1617568560000
12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	75	75	178	6301	8752	jx7syLLwxNvTuhfAiVRNa6BUNvDfKfNdb4esfdD8RBypVKbhDjo	6407	9053	9053	1617568740000
12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	12371	3NKPpuMegA43hAaUzuB7LCqCdANVuGbAr1L5pgPpwUFQfg2H3Skr	1671	1119	177	6301	8700	jwxemvpSnax3Urcx1c1KKHj3asU7Ajk8Uij1KnmzWn9JMhbnga6	6381	9016	9016	1617562080000
12376	3NL5Y9bBwTL8Eb51iM6z1x78hMjPkZErJ5Z1xgxyZbQoDxQU9cgu	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1553	776	177	6301	8703	jwdLNWCqRhRs8iR7jV4AXZv4XnotrCrLwy8C1WQQNMdv3bJVmdk	6382	9017	9017	1617562260000
12378	3NK6mYJFKwN9Z3g8cGiBxJaEUsnC9H68tGtyBzgyLkKmaMjJj2Yk	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1406	1393	177	6301	8705	jw8jUqzxKZJ7Ch1D646gtj9hZShFVoyfjPtEb6oA6ybfP8mv5S1	6383	9018	9018	1617562440000
12380	3NKzbgNqGeMztBrqrep18Afo1WQiwSjcagvNj35STKaN5b16YxU4	12378	3NK6mYJFKwN9Z3g8cGiBxJaEUsnC9H68tGtyBzgyLkKmaMjJj2Yk	1455	1332	177	6301	8707	jwe15UiB3s682MtUAJJm8ogvZjwWCCXjFb4qmYyqvPxb1MKVavh	6384	9019	9019	1617562620000
12388	3NKjb5ZHhDB7ZWvsuzPKkKktuEu1BzdkSVr7zKgmvCyd5pEFviDM	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	1407	1395	177	6301	8715	jwU2AhZfdf12CW7QhHCcMMg69dvzq7L6vK9isR27RF1i9AdaGrX	6390	9025	9025	1617563700000
12390	3NK83HdN2utNXzt1osBtyzaKNKWBMPj2Z3wQGX9VvMfK39ygYPMH	12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	1553	776	177	6301	8716	jwkWqpkXdSB7jrwDVZ1o6nec8Hr2JUNG7iBhU4x8ErB1FeByLP1	6391	9026	9026	1617563880000
12392	3NL4P1n2tRyUfJ2odkFLgSHRVTT11g7ftK3o3gNcYxCsfARC23JF	12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	1547	1378	178	6301	8718	jwUYXXGmPku5FsboubzRs3EbLPHUVrokBmprcN81PnUM4jX5gLs	6392	9028	9028	1617564240000
12395	3NKKFoXZXtsWUXQ27BWaq4EBdHfPfRua7eE7iHFaznz6S7S5MMHV	12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	1587	1231	178	6301	8720	jwRpTGEmtiJhANSzxcAHDAqLG3iURVnFwRe4eU9ULaL1tuB1tc6	6394	9031	9031	1617564780000
12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	12396	3NKW6bCi87s8pPuQLgUWZadJy3XK8yAD6oHMyLkVBvzF5ankEYyM	1652	1069	178	6301	8722	jxtAm5X6uzwAwjmN6omRtP7F4FCCgiTZLmmHgUn57dCfQik4jQC	6395	9032	9032	1617564960000
12400	3NLAMAyvcnkgE4eZQTsqaxfyMmM3JjXfer7tFb6D78GcMKEvNNVv	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1406	1393	178	6301	8725	jxQd3xmVf9gD4jfeRNQ8qBqqGagtm9XMLTCkxADsE1YcMW1Z1NJ	6396	9034	9034	1617565320000
12402	3NLRg4xzcK76UGUJtTkPkwScWzhwDqJB3qmszxSAjinFFUtxTbQB	12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	1670	1282	178	6301	8727	jwyTzHpgU4FDpYwrLED8TGPqVaBGX1eM7dnkJUN6vyHH4FGXyMJ	6398	9036	9036	1617565680000
12405	3NKF2stM3ztueAsuLzAEgRf5gB4RrrXrhQHortGGmUcwnQTnVdHG	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1642	1367	178	6301	8730	jxRt6WPSvKde3y7cpYCMn2sQBeB6EazZTW8hByMg9d7QAdD1onu	6399	9037	9037	1617565860000
12407	3NKTGzf4YG2n76vNbe3aPD9VVgZ8fx66r3Q7cecbp9F8uS5zdnCV	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1483	1276	178	6301	8732	jxkUYvWTGt2EhMyjDmFJyshivyQMnDWWMvAn5rb7jC1txbZ97yX	6401	9040	9040	1617566400000
12412	3NKNXsktydsyJ4grb71iG7QgxAHbECFKhf98vna7nZ4aBGpCcT5g	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1547	1378	178	6301	8737	jw799g2MibK8WYQ92ecfRHJiJTwqU87Nf31fxpEt4GXjruML9BR	6402	9041	9041	1617566580000
12416	3NLPiSffCrZeimS1ASAqMfo2X7fGGKmUM3rBwLoR4W8ewnPrBgun	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1559	1353	178	6301	8741	jxDnj1Q6QKQhJtPpgWWfNySRbqVa7bFHjkofSbEzZ3bnhmWRbZP	6403	9042	9042	1617566760000
12421	3NKMgyn1svwMnA67oRCHpK4KWn4edHGk8DZJrmqndCuXqNZX8LMs	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1407	1395	178	6301	8745	jxL8JpZdgxfZaXBAh1GwbGEmmnZ5PugWQR314PVzBF6oNDRCsfu	6399	9048	9048	1617567840000
12427	3NLbSHJB9k7UBjnWeqUxH78GPBc9qxxHuqfg4gQFNEu5LTNpNrkq	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	1406	1393	178	6301	8751	jwTMo7SXHswRqH2FCrXtupsKza6BP3vDVHd15afUAL7pJkTY5ng	6407	9053	9053	1617568740000
12429	3NKSLZqe6wSZSXphcujBu3kUyuUctXJkSm2hoTuN5cPiJChkvWQU	12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	1573	1072	178	6301	8753	jwvs6Ff6cuaJQrd61bNDSV8dFw1XQ8QWR2MGaDcZ6fAQAzZPLPy	6408	9055	9055	1617569100000
12431	3NKSjfQ7MKbvjwF64VSTie2SFsgMXRhnPzym68Th1R3Se1VZgokY	12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	606	1049	178	6301	8755	jwMEHxor9EavVEbNwnhkmfxKuq6qePgBTBW4PGb1eyqTsQktzXf	6409	9056	9056	1617569280000
12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	12432	3NLqvioLef1c1xWdF6WddBHh1w49seGJ351U7RooeXTYL11LVfFX	1480	659	178	6301	8758	jxXj34q2GfkGRdEX9oDqPHsPfXPjbpxD7UTvyJvqnXEEH9WcLZ8	6410	9058	9058	1617569640000
12439	3NLfZ4LD1nuJ5DnMiNqXRUX3FChQdAZ3wnMte7A9yQWCEjutge9J	12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	470	1063	178	6301	8763	jxXRBH1KhkTV1BWHRsK3gy3DqW3umMm3yWLyEUiLMTcDyKTUuT5	6413	9061	9061	1617570180000
12441	3NKWMoV696D9dSvye2YNhoqH7SFzYPAHLpZEqoRhNNRnqc1Rmm4W	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1671	1365	178	6301	8765	jxoyyNqAkH51KVR9Wtdt2RFsLs7sehn2Q1GrzFC8FjASgV5okRN	6414	9062	9062	1617570360000
12450	3NLi48iaGn7BvhrcYombxpa1TQNmhfsxVf2Tedm8c5RmxRe1JGGR	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1648	1038	178	6301	8774	jxSYoEwbraZKviiipWHmwAgaaGzYX5NF1V1pzmrDBNKs79m3MeB	6416	9064	9064	1617570720000
12452	3NKrd8EiJzN6KZfDADN8GpejGhuPkhCVQhwuSXjn2GMPmoYuNxzY	12439	3NLfZ4LD1nuJ5DnMiNqXRUX3FChQdAZ3wnMte7A9yQWCEjutge9J	1406	1393	178	6301	8776	jwHoExNBbyzai1oW46i5T6i2ocR8ehRdTwhP8Aoj1eSJokSbW4b	6414	9065	9065	1617570900000
12455	3NLw1aHWqNXABDj1HY8hvwZWRe3Dz6S6CEC9zrPrjA1DsAiZ49Uc	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	1585	1240	178	6301	8779	jwBMrZQnMnPbBXmseUXN8tFVBPrAcx2e7zAwxtLh1U92JUk8FAb	6418	9070	9070	1617571800000
12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	298	1308	178	6301	8784	jwQFKKHBAgC13KmrM2r21JkEtbyHYjGyEoYnAhwzEi4GBQf94tD	6420	9074	9074	1617572520000
12463	3NKnPBK1VWDiGXSmvwhN5Nhd2y19GcoAmvihXVrn8Mjr34Kj6jPb	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1654	1340	178	6301	8787	jxvHkEawps1qF9wH8RizSZE63xjGAn2i6fAfpH3TkB4x5jNNx7o	6421	9075	9075	1617572700000
12465	3NLhMse6WoEgiTb48PudBaeXDqMrWLFgPd8sAPCcWnLzhCdmgtuo	12464	3NKYXTMgpumn4wpt1GBjFZv3gvBSfxMtEUi1V9JWQoH1LESpmYqQ	1631	794	178	6301	8789	jxeSDkjfJfVFAy8xcEA4QnEqgUHAkUnFUx7gaXMjyfp6yjCjse2	6422	9077	9077	1617573060000
12468	3NKsCSzXMo2re3UjUBNqcEzQqUBiTFneZHDYLZkzr18LunsttgJP	12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	1637	816	178	6301	8792	jwfCcvMT7yzYGygTVGdAcb71w3anw75aV54U4Sx54mKCr8PFfQ4	6424	9080	9080	1617573600000
12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	12469	3NKGPSHwX4DWyssXM6kW54UtiAfXUG3RbusF3VAmTPgpDf8ubL1P	1633	1144	178	6301	8794	jwRRmwSaSM2x7UmLah8AriKqSJ7878gjEEH5TmzufiLErbtqT1E	6426	9082	9082	1617573960000
12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	1476	1371	178	6301	8797	jwV8sk3sLEXudzLmz5Bzk3pgEzeA7KPwzwp2e4rSirQbFTL6rwF	6427	9083	9083	1617574140000
12475	3NKrEhRXuYtoB8fxiG38NKkaCQdRk4cxhGmuNqHQycDrFbAXJTs3	12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	1675	1342	178	6301	8799	jwErACxxDRxCA1B7xPDA4CPbU4B4vrAxNpbE1ZBtiDmMmWWWrdx	6428	9084	9084	1617574320000
12423	3NLFwUZyMgN7c8ySNcaYxWaSKQkWm26LsSYDBP6NxdC6rgK3kZzN	12422	3NK7vuV46n3skVoXgdasaZKSz4PnJFzWSYWUaxw27NJTh2zbTurw	1407	1395	178	6301	8747	jwXmktr1zaTbdMKk9PknYqNXt5CwP8BkR1YhyNSn4sugKDpuELQ	6401	9050	9050	1617568200000
12426	3NL4hFowmB3JD2tMYJTkNNLNLPMgV2kdcmLh13c6Qydhi6PvrVL2	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	1654	1340	178	6301	8750	jwzn3X4GmF7gLtzAKAVMBEdey3vKaTGP8LLciQnVTzKA9o7kGe7	6407	9053	9053	1617568740000
12445	3NKqpL93JYVfKFwNLWsgbm6F1HA7uZN6j183fshHcd8y9o7NGFBS	12192	3NKBDrw6rLn7tXdSJMYwsJFBzS7AUY4Lu5eX8BK57EnjEGJwjV19	1518	788	174	6301	8769	jxHkKbCtsDEph3qFhBmWERQ7LB8Wg6v9zLig6YswxUKHxsksZL9	6265	9062	9062	1617570360000
12454	3NLCHceeP9ZdadZVsowfGndos25BeC8ffCyRXLyueKj8kMDtnzYj	12431	3NKSjfQ7MKbvjwF64VSTie2SFsgMXRhnPzym68Th1R3Se1VZgokY	1477	1350	178	6301	8778	jy3DXNSYaYP46iEtxZMpm2ZocSvjxys7SokSepUwMjeu4Cd6s6S	6410	9068	9068	1617571440000
12457	3NKMMQ6BxpjPskf8c8vaGfDyRb83xLUPyXt3PDeZDBKxQSRSHJAG	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	606	1169	178	6301	8781	jwXsquKQ7WP7QB4RNfFtrtmS1rtY3VTCKkQpLMhbfaJ52E4Sk9A	6418	9070	9070	1617571800000
12462	3NLNuhq37AUfw1urrjTTd9rSAaABaBPe3FNzGzFroYkHXQWFHsq7	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1455	1206	178	6301	8786	jwEyG4b7RA6gNAf9FafqsSE3Vz6WxnAAkNAvcn87Yeo8v7yFkFm	6421	9075	9075	1617572700000
12467	3NKxMx3S2JtZ8X2Ve6YJPAU1gA2LaRJt36qTyAsdYNcyDDQjkdWN	12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	1578	1296	178	6301	8791	jwiy8KdUeHv8LWDPqudgNmfRfLHCw7H34xJ9W1FYeWgKNjbS2uR	6424	9080	9080	1617573600000
12474	3NKo7PZy34c5LKCJxHUGJZ6VJXgkAL7UuHsm3Ac7SH2wAvPhVocu	12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	1403	824	178	6301	8798	jxSSD4FJgQ2Zz6Ym14rSuqDjbNQ5NddtDTgjoZ5q5Ytr3g9JWx2	6428	9084	9084	1617574320000
12481	3NLsxaJgQDtcHHDB8x4jK2SVbP9rfRJfcvmwBZTyAzpEejC6Wk1H	12480	3NLHCEDnmYW4gAegnDGPSw45YWM5i635FPL8ag6dh8sipAJbyJq1	1407	1395	178	6301	8805	jy2Ue5MEw2LvHJkVL9WCHSC9KLKYHd6b5PYTdiUxii3rtX3725h	6432	9088	9088	1617575040000
12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	12483	3NLEEEdD5M2zw1NoSXKG5GffnrUumLrXoEo5id3oFjFCt4QtjfMw	1672	1285	178	6301	8808	jwzGPbazXyzTbuWyVCeudA7e7xCL3B3X9RSY14w9fVZ7Cp7Wi3P	6435	9091	9091	1617575580000
12485	3NKXerTWVfZ2ZDJDXbuCxNDG1Mi8p9WUTpcU5dVLwPHBAd6iJXMT	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1447	1345	178	6301	8809	jxAcTXqQDJ6MtexkinhtuLoDX85fyHcvxix8Law9PGqBBfEm6MX	6436	9095	9095	1617576300000
12492	3NKPXwSxWuDdCHExHwcU4FLmBK81B3nBo4CFZHKZBwsLjBRyL6b8	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	596	1306	178	6301	8816	jxXUh5ubd9NTjk52XDN4LtoERX8J6ogZbSUZzea64eQy3yh8aBe	6438	9097	9097	1617576660000
12498	3NKLwfqKVaFTvE7NFJZY9eYVhQBaiYk2wMTQYKuoJafpswnTJCnw	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1403	782	178	6301	8821	jxFXE2Wh6EMkiTvKvbqP6sCyfoDhWUJ8UpGLjbb1hyfAv2i6CyD	6440	9099	9099	1617577020000
12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1407	1395	178	6301	8823	jx7QrEWkCHThjCMoUTxu4gqST7C8pggpxej2U7jmVt2SRD7PXq8	6440	9099	9099	1617577020000
12508	3NK7JsHgWSACxWbkXEou9SNEHXbXgEP4kEnqAWEa2AhqT39zJi3B	12507	3NLMrMSBFwDDmEn1AwayHq45V13gjBuPboUd872as9ZtRp3LCnnJ	1589	920	179	6301	8829	jwTjBStqPKQANyyQFzZQn7ZpobV5t44TgLu8x5VdMQFC8rFPAU9	6444	9107	9107	1617578460000
12511	3NLQMNZL1hvs7zEbADyWaEmmSt6RMt4qrNftWUq2No7Hg8qWWRgh	12510	3NKhsMQJxJw3WGGiSqMH5ZxSMoL6i9XBcGZkXAPJeMwgBeBfPky5	632	1382	179	6301	8832	jw7zbdJLvajr38nyQtUSSL6kdBqrYpfaG6t5xX8huYrvQXGTZeQ	6447	9111	9111	1617579180000
12516	3NLNknkk46sW6Hn1XfxmULmHB7vgNRnQGF41DE2LTcnwxZitENvt	12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	1455	1332	179	6301	8837	jxSAow61kJRR3dzWUTXLDpf85SY4V7rVBuBPnHnxipDWi6HYKL3	6451	9116	9116	1617580080000
12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1407	1395	179	6301	8840	jw9RZwGBd8c9faGydXxKjPurab2e7RyNpNMAYgvKsPKw4A2mzM7	6452	9117	9117	1617580260000
12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	1406	1393	179	6301	8842	jxksUaZpZHtSddfZBztQqm6Gz4ksfBT6SbK3szevfxik6HxtSwZ	6453	9119	9119	1617580620000
12524	3NKWyx7YroiVMeQEL4175vv9sYKf4vtZMcNy27nhSuUjaBfcRpg6	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1476	1371	179	6301	8845	jwCp8T8CTCTsmeeb6DEEAyG96qbECr7LCd3Dvvwkw76n2L8fd2e	6454	9122	9122	1617581160000
12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	12523	3NKWtmAw824orwRmafPHFGv3GJqyYwD1Wxjg9UUTqZj41bNAuySF	1402	868	179	6301	8847	jxJy1ppw8wdUxp3i9Ca5YDox4BigrPGEVg9czg1SSV4GPAC5Wfn	6455	9123	9123	1617581340000
12531	3NLJStLR98NYwp2Ww6XL3DGJMgnVFZM9481FCyP4oLHWGAy3KLqH	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1605	305	179	6301	8852	jxQHQJJ3ELcSw8skAbS1zsjp48rfNvnggZS9qu68qv2oondkA3H	6459	9127	9127	1617582060000
12534	3NKJWEjZibfrrHp7WtX7kmnxZgCUSWxmtZBXBEhzisTTRQZA11fk	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1500	1297	179	6301	8855	jy1RTUJsSBxVGCUDHAp8JMyjmDqSHj3jaK8tL9av8TEvN63LboA	6459	9127	9127	1617582060000
12535	3NLwoAwncnK6qijdnhKX4REBMX1AozErdtuqG8iHPJaiR2eL8dyh	12534	3NKJWEjZibfrrHp7WtX7kmnxZgCUSWxmtZBXBEhzisTTRQZA11fk	632	1136	179	6301	8856	jwFCZ2sSbfFJUmkrqukgm1PKVpe3hZLVG6xEvgMBXULNK7KjW3i	6460	9128	9128	1617582240000
12424	3NL1M3Qm9Dg19e83Xnfd9jwEiEgyjP3PgqQtQ9HFB3f8FbcA8fJw	12420	3NLCEpT82TvCWUownBay9tzfyKVApxWrFh9vtSSxqrkUtW9JAbEm	1402	882	178	6301	8748	jx7fQ5SEu1kupTrd8wD9P1s7uo18kcHR3TjnnRfsa2ekZ8Bnhje	6405	9050	9050	1617568200000
12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	1407	1395	178	6301	8754	jw9FhjU78mAwiBJKmhQhDeStT5z9LvVTMj7YqVH8SVEPBzNi3ri	6408	9055	9055	1617569100000
12432	3NLqvioLef1c1xWdF6WddBHh1w49seGJ351U7RooeXTYL11LVfFX	12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	1631	794	178	6301	8756	jwBMAaWUVqiiVuguFCWWyyk4zXto8gzS3YofmZHHERLVwXj1LDB	6409	9056	9056	1617569280000
12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	1402	810	178	6301	8759	jwHcj37o4czM7s55yjRwnm9te6Q6NeLdnrfxRchURTMztWmBQVx	6411	9059	9059	1617569820000
12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	1402	868	178	6301	8761	jxusR88YjAwQ94E4cavxR77SDVuLsmtmHyUri6bgzpx4ovSiR6D	6412	9060	9060	1617570000000
12442	3NL2kjKgmkAY2sFRytXmmt4fTA7kTw2EyuKnZdXbK9UkSDSHnvLU	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1657	1344	178	6301	8766	jwGUFU5bRjoLtLim8vsMv7mnybU9CgdMgHLadrtNohbZ8hnqHgC	6414	9062	9062	1617570360000
12444	3NLsYM91Sy7AsuV9T1BGjoe9qacwgYNSiRrFozZmuHeHJtUhZbVn	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1407	1395	178	6301	8768	jxzTE5Aivt8r8w4uba6YDgSo6tr2svKU1Kxf84QVbV2DmUb8LoZ	6414	9062	9062	1617570360000
12446	3NLQyz9orbiizM4quPMkWhM5Q8uMUxcaUm8Q2xE9Ez9BmGRWN3ka	12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	1402	844	178	6301	8770	jw9FPrjU5yP4N8whYdRN8EF4PHaCH8UNJearmHxbYUDRxzn3gSi	6415	9063	9063	1617570540000
12448	3NLDvo6UU6hFW8qEF65yJF5qhHmPmDbJD3gwQ1EcXwrdbpoQg9QP	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1467	1250	178	6301	8772	jxL7iT7fTVLEp8XB2VVuCJg56onZD9Z6WzARXRNtqQCqVhTf4J5	6416	9064	9064	1617570720000
12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	12456	3NKyrkftB3Dz3DS1eyL5ZdG2A2coDfBHxPDRUoCtb5pADACa8JCd	1406	1393	178	6301	8782	jxnfWGrtFdw8GL3JKNocpUk56U5iDMAXoPaoGjRf5m4sQh3VDi8	6419	9071	9071	1617571980000
12461	3NKASQHZAhEW77Whz6DJBgVMiQXLjQuj1UUEHqjZeYLmdKXsNEGu	12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	1407	1395	178	6301	8785	jwigwkqJBABKQazeYZQJt4tMJLqhJo4djmBD9jQrqdqJ65cLZmt	6420	9074	9074	1617572520000
12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	12465	3NLhMse6WoEgiTb48PudBaeXDqMrWLFgPd8sAPCcWnLzhCdmgtuo	405	405	178	6301	8790	jwJ8TZpAtxj1N9mAFFk32qBJhJVcjoFK9Dwm2cFmhr4LhvmmPCL	6423	9079	9079	1617573420000
12471	3NLJVjWpFpckUfvqwuzKxoPqJLUqNCu356NZHQniJeuCeZdFdNJN	12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	1546	973	178	6301	8795	jwbETZ1a34H4rCBe4cU8JuQbt2ZEUv6AFrLoVrbKDbE8Bhi8T44	6427	9083	9083	1617574140000
12478	3NLqS4dMQDQqZzs5ZCuh7kCgNSkXTChvsCXJpi7V3Z7Uiiiazj9e	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	632	1256	178	6301	8802	jxaHef53wxWgvAeu4cKZFZ5hB5VQSzYwpUjbiqGstwohVdExW6q	6430	9086	9086	1617574680000
12480	3NLHCEDnmYW4gAegnDGPSw45YWM5i635FPL8ag6dh8sipAJbyJq1	12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	1652	949	178	6301	8804	jxoJmqNoXqt7bmsVHH2HXcQFfmEnU8Ze68JSUTxq2gwsU2XArwY	6431	9087	9087	1617574860000
12486	3NKDaZmUJERaoMubdWj645XjrzG2DFfmhMmRU4mnjjgY3im3CrDJ	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1553	776	178	6301	8810	jxTK6NokmViwVL3ZaQkrjGaSLAu5x6t7D8e9ESPdkHKFfjyViRC	6436	9095	9095	1617576300000
12488	3NLFQeori8ZGkkeP4hPizVfQ6nAkxNAomw1cXpXpUZqu4o3Z7suA	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	58	1035	178	6301	8812	jxm1UjcXa6yRjLFEYw6chrc5Enh4exJMUAhVqMoG8zb2cHJticq	6437	9096	9096	1617576480000
12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	1619	1275	178	6301	8824	jwsc65Kt8jKgp7VpRVvYU7rCYUiGuyAuhjUcQb6e8deNXrt52Ud	6441	9100	9100	1617577200000
12504	3NKbPwTgJZa9m1HBrHKThud2mFe71hki2dZiTBUH2znkJsxXa7S6	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	448	1305	178	6301	8826	jwsfEaoFBKC4tECw3ZTxhodnkEBoWbFo3XaZHwFcLuWh6ezWWAd	6442	9101	9101	1617577380000
12509	3NLTe8vGq8NQAcKcnYFtdUYEwv4qzJ9YdPu6tc78rypDL76QLFs2	12508	3NK7JsHgWSACxWbkXEou9SNEHXbXgEP4kEnqAWEa2AhqT39zJi3B	1549	1116	179	6301	8830	jxDd2XeTMqmw7xsHFWQKxEaPciPSCuRM91hFfeCCL72vo2EPT84	6445	9109	9109	1617578820000
12514	3NLVRf6gjcssbven6ZhiZTJqDLwdqSzeGFWgVqQuEcqASkBt2iXJ	12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	1407	1395	179	6301	8835	jxjv1LBP998jqPcu1XC5ADacmZZSYm5Y99hq9xdT2Zd8UbVQcZN	6449	9114	9114	1617579720000
12518	3NLwxYK3HoNJM6Lu2A6744mNXxwGkVEh8RUNZa2ehc6ULdWwP8LF	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1406	1393	179	6301	8839	jwVWoTTDmdisqUymoSNtdQCT6xY1X5bF6YE4JSKKFd7gx6okkP5	6452	9117	9117	1617580260000
12523	3NKWtmAw824orwRmafPHFGv3GJqyYwD1Wxjg9UUTqZj41bNAuySF	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1403	824	179	6301	8844	jxsGFEAgS2WeCpvQUAp1vmgSLWjj1kFxTvkLopeCh51A6CDUbff	6454	9122	9122	1617581160000
12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	1623	830	179	6301	8849	jx849qKs7EJ2jnKWbgQduEoa5K2Pvj2x6ubR7ThNL1EvnTQtC3F	6456	9124	9124	1617581520000
12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	12529	3NKkDN2hoRUJErTNKEU4KYQ3DC3KegPsK1aqamq5HxsTWcyeksAe	1633	1144	179	6301	8851	jx7E44u92kqMrExdMT2CkUoLPcDTvP6GjxbGeU6i8EBB9oDDp3S	6458	9126	9126	1617581880000
12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1406	1393	179	6301	8859	jx1fqqV75pHvqrEUVVh5v81WXT4qBWE5SYz4Ch76ANpUumr36CS	6462	9131	9131	1617582780000
12433	3NLQL2nmS7oxgDk1nCmhYENV2SEzaLhDX2MF3f23tCcXCbKK8jVE	12429	3NKSLZqe6wSZSXphcujBu3kUyuUctXJkSm2hoTuN5cPiJChkvWQU	606	1049	178	6301	8757	jxkKShKURGzyugBg3MtnLBYdL5mtgF6h4yg1fVtX7nxpvrFcXpX	6409	9056	9056	1617569280000
12436	3NKK1XJSAmh8zBdZhZ6Ry9VaGVAAmgiQUaLWsXMtZGuXf641rk1J	12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	1594	1326	178	6301	8760	jwu7tt21tjhAFY8Jd2ycupX5JtYHFnXpZVgstFUvcv7ZmQ5NoTq	6411	9059	9059	1617569820000
12438	3NKfrYVQvgfUwNNxtrPuFQRXfJHXz8HDW5dQSUyPyYvd1gVnMycD	12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	1564	1092	178	6301	8762	jx3mgswTPkBidg4M6KrVSFedVen47CMvjodHybDQ2396FduUzZX	6412	9060	9060	1617570000000
12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	1555	1347	178	6301	8764	jxHYNZ3KSf5Rv1kuBQrK8eWL2QeNdJ2amTgyM98Cm9YTDzAWy2N	6413	9061	9061	1617570180000
12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1518	788	178	6301	8767	jxDYRMYMcekC5sJrVir5tAq5FnbYtj7oSWWTjxE4Htt7mzPFywe	6414	9062	9062	1617570360000
12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	1637	816	178	6301	8771	jw7VxQ8bFLRA6ij5J3B3ftAAKpde7vL7JFf4eJbZXpa1s5Mqn7d	6415	9063	9063	1617570540000
12449	3NL4MUMN1U6DVNGca4Pn78st4wD6mty5Qr6AboGCzf9N7YbRBZdj	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1501	1360	178	6301	8773	jwbBJZNfyXyUqi99evVnjrA1iTTcj7SvZ1tkZFCon1qLt4phRra	6416	9064	9064	1617570720000
12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	12450	3NLi48iaGn7BvhrcYombxpa1TQNmhfsxVf2Tedm8c5RmxRe1JGGR	1407	1395	178	6301	8775	jxvWdvLwVMJg6qxdiR8ZGEV3kM5XRGUU5fD4pNc4HkALsfE6y7J	6417	9065	9065	1617570900000
12453	3NKAAMyjGAcSJqS8XQGzAq8XkjgJQULyHrSUBWgR5Xq2C6QNVBrQ	12444	3NLsYM91Sy7AsuV9T1BGjoe9qacwgYNSiRrFozZmuHeHJtUhZbVn	1406	1393	178	6301	8777	jxERN41GKaquE7LChnMzpQ8SntbhBhAVy93jWRFjqE1PBEEdEgi	6415	9065	9065	1617570969865
12456	3NKyrkftB3Dz3DS1eyL5ZdG2A2coDfBHxPDRUoCtb5pADACa8JCd	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	1611	1341	178	6301	8780	jxbNbv9MBf6nzAiQzoX46ghBFvfZyUTDvreserLcgJMthmRLasB	6418	9070	9070	1617571800000
12459	3NLGsHJjgk4uLifTtrpZkeKfAxgkiBZUMLphNyaFfzmAC1ot9vsA	12290	3NL7AjZXdYxrQaj5tHvxrTBShvKzDehikyfZzSA8i6st13xpVZtq	1458	1077	170	6301	8783	jxygW7V3iBvTsWz8M2nmR6TT9DfZG73aXYZJDgLCARKRLLYkbgX	6140	9073	9073	1617572340000
12464	3NKYXTMgpumn4wpt1GBjFZv3gvBSfxMtEUi1V9JWQoH1LESpmYqQ	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1553	776	178	6301	8788	jwR2wQSgdhcMHdHhk792rHsHxgtucvDEH8r3EnqGqpCR9VFaqMt	6421	9075	9075	1617572700000
12469	3NKGPSHwX4DWyssXM6kW54UtiAfXUG3RbusF3VAmTPgpDf8ubL1P	12467	3NKxMx3S2JtZ8X2Ve6YJPAU1gA2LaRJt36qTyAsdYNcyDDQjkdWN	1656	1343	178	6301	8793	jwzsmaFcbS3dWyFmbv2YDRoWbXtJ1Wqd3yM4Eqd4MPDq2xbXSjp	6425	9081	9081	1617573780000
12472	3NLfcUTnZYVxLcKhhrPncioGHpwxiT1r7BTpuFA4VDpydbNMKMjJ	12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	1546	973	177	6301	8796	jwiBKHFSdXQvx5vXQQyTTGLKZghyZRHH6fLPYFTQcSuXRDPQkSk	6389	9083	9083	1617574140000
12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	12475	3NKrEhRXuYtoB8fxiG38NKkaCQdRk4cxhGmuNqHQycDrFbAXJTs3	1406	1393	178	6301	8800	jxfKKLkTHaCzjGGUG388wd4b34Us6ab4yXw2XMwYXYMLSP2G7bp	6429	9085	9085	1617574500000
12483	3NLEEEdD5M2zw1NoSXKG5GffnrUumLrXoEo5id3oFjFCt4QtjfMw	12482	3NKDFstEMxNCCxaNJeoWmB8ud9hHwnpVxFkzjCgiNSBRpBRt6u1b	1611	1095	178	6301	8807	jwWzeksPv4DhjfHWLioHGaCgeWTbWycPCJ5WbGhcGFuJfvbYTpy	6434	9090	9090	1617575400000
12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1406	1393	178	6301	8811	jwa87i3cT5wDdeRsSTHJ8as8gGwuFGcmbgLrqqez2DzWEocMFjz	6436	9095	9095	1617576300000
12489	3NLHwpi5Kj8rtqrVmNCM9cQKKmecNogcCPKeX2ttqj4X9Vz76TXS	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	563	1359	178	6301	8813	jwFGiD689X4AxbqD2Yrvf7F66HXuPtSeKCgUNYKmyVNxSdS5Kw2	6437	9096	9096	1617576480000
12491	3NKUqadg7zvJwZZji3cNhdT2cz2tSnBA8s66fa165V5ZrRCu3jfn	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1671	1119	178	6301	8815	jwttjruVhmCzcRSFSNDxuFEPAfGBqnTTWBhDjA2aPFuNQjNmTak	6438	9097	9097	1617576660000
12495	3NKuW9CNa8TRredGtCZUyzQBgFpifXe5Rit9VH4URvMm9tA7XprF	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1651	1301	178	6301	8819	jxdEDJcD4ZqESWoshZKdNXhTrtshe2Tg29DTm6CxMrL4y2tjiCH	6438	9097	9097	1617576660000
12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	12493	3NKfmkSww42LBsdnLfQ53wiweabW2EKGWY7e5M8RChTAX9vVYMYA	1637	816	178	6301	8820	jwQyGhfiSLCjg4FrNWBrW55xo7FRTB6rnuRBuUjgdivd5Ea5vg7	6439	9098	9098	1617576840000
12502	3NLwCXzFVhauroTJ9Tu1zW6XnT1JmtVrjc1qVZighdSGfSzLJx92	12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	1619	1275	179	6301	8824	jy2Nz8hi6YAHb3E2BwhrSoAnjKE96UYvTYyLB7HHbdU8JkpaKa6	6441	9100	9100	1617577200000
12506	3NKdG4X9fJjf8Svdx9BNj89CzyjEPHJmyA56GdfGUCKzBX3ddWp7	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	448	1305	179	6301	8826	jy2JKWibkSAqtoRrrKhzaYjjNo9PabgjogEgRAHbMZnZkmZRs1J	6442	9101	9101	1617577380000
12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	12511	3NLQMNZL1hvs7zEbADyWaEmmSt6RMt4qrNftWUq2No7Hg8qWWRgh	1464	591	179	6301	8833	jxmyXwvvAfVRBwbPP3Hn5qnw7VPHxRppbHVVCG4bfTzGbVNu9sT	6448	9113	9113	1617579540000
12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	1637	816	179	6301	8838	jwG6W7d3sc8GJMDj77PfYkdnhRYrURrfqBsn1Jr7RXMCVJ5CHRr	6451	9116	9116	1617580080000
12520	3NKm1BNqr2edRM8zuyUkASjUtXcJS8ynxeGWwQu2R67ryUao1PH1	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1624	1088	179	6301	8841	jwY6nUEfNVkJenH2zENiED2XVHrnE8NQB7bVcuBgDFvP7DRTnBQ	6452	9117	9117	1617580260000
12522	3NLb49T1CjoaV3QtRn9bR4XmCPDdVKJwHofekds4kirYUdm2detr	12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	1481	790	179	6301	8843	jxaUDT2z1PFuEzvwvFiTmJysWrKDH1XEhLQ9NLQxfMeqsBTiT3q	6453	9119	9119	1617580620000
12529	3NKkDN2hoRUJErTNKEU4KYQ3DC3KegPsK1aqamq5HxsTWcyeksAe	12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	1407	1395	179	6301	8850	jxT2hJLStJWHfdTxGxeLUbSwss2JQs9i4xhivpUxwZrh97V1x2t	6457	9125	9125	1617581700000
12532	3NKjGzxZoe94c1Quxz1WfZeG6bprRpFcMgZdkX6WAghi3ZV1w5KK	12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	1500	1297	179	6301	8853	jwRGn6Y7rgoz7SbVMbNFocd2EJTML98gGsxUzPLUv4qE1ZCZuPg	6457	9127	9127	1617582060000
12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	12535	3NLwoAwncnK6qijdnhKX4REBMX1AozErdtuqG8iHPJaiR2eL8dyh	1610	1314	179	6301	8857	jwSpVZwzLnZuJknH2QL4G5HfUhdxLK7b1PDd5obFwZ1WTTVchhg	6461	9130	9130	1617582600000
12539	3NLweKK9TUoQqGkhwUAeGEFwAMhsMY9L53pAyFP2NYF2ymapcZcw	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1631	794	179	6301	8860	jwZhposEkirDBq38xiefYKTeJZSbE9E66Gsd83faHBnqsKymj8g	6462	9131	9131	1617582780000
12477	3NLsAxE22cVhxBjK24EkxLokQZX51RWrpqfBMJ7hiNFHvpD5517i	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	1422	1337	178	6301	8801	jxPnFKuf4ejBfQhpAiodPHiKk4pkLF6JJy6Q6YgnHfpgri9EKWr	6430	9086	9086	1617574680000
12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	1553	776	178	6301	8803	jxGzQfnipnZD22DvehaHwNCnEuneS7gC69GiLfiPstpF4LySL68	6430	9086	9086	1617574680000
12482	3NKDFstEMxNCCxaNJeoWmB8ud9hHwnpVxFkzjCgiNSBRpBRt6u1b	12481	3NLsxaJgQDtcHHDB8x4jK2SVbP9rfRJfcvmwBZTyAzpEejC6Wk1H	1422	1337	178	6301	8806	jxcLe4GqtnbkbaTQCS1SKu8eaQDZufoF5pDc6BX7MLF2Uiomwd6	6433	9089	9089	1617575220000
12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	1637	816	178	6301	8814	jwGtGuzpj3bQNZy6V1mCRbAwhXCfrqCAVQwQTu9jXHVVEPaxxov	6437	9096	9096	1617576480000
12493	3NKfmkSww42LBsdnLfQ53wiweabW2EKGWY7e5M8RChTAX9vVYMYA	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1587	1357	178	6301	8817	jxZ2Giu8cdr2vvFhiJ2s8iNnbuXAVspRZqmRFQNzEoLiVYWRyqi	6438	9097	9097	1617576660000
12494	3NKPFb6cotgJb96UrRXep4QNtkqHq6auvGd7zzcomMJTPwmYmQCn	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1406	1393	178	6301	8818	jwg3foWy2ejsz93guHreVjwRJr74sURY653tVzURbWFzYZUNgyQ	6438	9097	9097	1617576660000
12496	3NLcC6W5YpkBRnAbQ2LNENhCLZphEWCKooAN1Rr1a8YXq7yd6MLN	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1651	1301	178	6301	8819	jwmJM78NKTBPtE9vVWbTprs2mnj2KKqFQRBxi5aZ3fqpG9qBQNi	6438	9097	9097	1617576660000
12499	3NKK7HoRqL9xYh6irG2pMXrcH7EWPKdzDRqsxpg3QEC5svrsfTVk	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1549	1116	178	6301	8822	jxWvnakvfnyY279VVBNYcrWt4Ritcf74Hx7jd6U4vbdAtzrpCRw	6440	9099	9099	1617577020000
12503	3NKg9mqAsZuoWWv9md1ijwEGo8La5hDHc9zdi1k6QwhrMdKUBLet	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	1403	31	178	6301	8825	jwemBSGwAF6zTghLb6cZVEHz38YJ8yv9wvLn4WP3csPaDHWSdVB	6442	9101	9101	1617577380000
12505	3NLW5EyotQjzgcUEj5BaEuyRRyqbRG3ySorvFVTRx8LwrnUA3f3g	12488	3NLFQeori8ZGkkeP4hPizVfQ6nAkxNAomw1cXpXpUZqu4o3Z7suA	448	1305	178	6301	8827	jwwAhURKuN9AztaMybu5ZV7tSoqYfBVJc6rXUDqnPYpE1ma4M39	6438	9101	9101	1617577380000
12507	3NLMrMSBFwDDmEn1AwayHq45V13gjBuPboUd872as9ZtRp3LCnnJ	12506	3NKdG4X9fJjf8Svdx9BNj89CzyjEPHJmyA56GdfGUCKzBX3ddWp7	1407	1395	179	6301	8828	jwzwxHiBsXmwzmverNtfDJrPZwqeskhXYHS1gTfwmLDv1FU8cQZ	6443	9102	9102	1617577560000
12510	3NKhsMQJxJw3WGGiSqMH5ZxSMoL6i9XBcGZkXAPJeMwgBeBfPky5	12509	3NLTe8vGq8NQAcKcnYFtdUYEwv4qzJ9YdPu6tc78rypDL76QLFs2	1406	1393	179	6301	8831	jxTgw2wX1Wy3gxkX9o2KTYB82GWNc3WG9ctuhR1riVN8mnaYA56	6446	9110	9110	1617579000000
12513	3NK57NiUfcQ8HpzKwWUMJ9qhTqrxpb1VZqjv4rctVRtDZKLxyAF8	12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	1455	1332	179	6301	8834	jwxG1fJc8s9HEb5umX74EUeHzDgqi5xJ6KkZa3xQpfRLf6dWrA3	6449	9114	9114	1617579720000
12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	12514	3NLVRf6gjcssbven6ZhiZTJqDLwdqSzeGFWgVqQuEcqASkBt2iXJ	1407	1395	179	6301	8836	jxqEUTBMTzMTHec7sKxqMDwoTuzHc54VZc1SJxafs8u7QVCHW9u	6450	9115	9115	1617579900000
12525	3NLTeJrauBeun7cfyr4YonNPACksrFo5mSi9hhx5TeLe8yGhsovW	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1623	830	179	6301	8846	jwEvQwPWwhfeRmDXSrHcCRmGPSUmgPLF4x1N5cjGeErYpPbVhNJ	6454	9122	9122	1617581160000
12527	3NKuZZWJH4PDXvNSS8SWSswpJ4TeMA2QQ8mFZEs555k36rMr6H75	12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	1406	1393	179	6301	8848	jwN9ZRs1UAB8z653qbPcZz2YK8Pp4e2jvuvhLzrgmFCNQmGLxh3	6456	9124	9124	1617581520000
12533	3NLTnWMKjhbA9phaYqeHSNhpc4kkePzSvU6t7sAquV1rJnkLTexw	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1406	1393	179	6301	8854	jxZaNobK8PieaCwxjnjri1Q1DS8yNh6QSQWdZcGQQSgKdQdDQAK	6459	9127	9127	1617582060000
12537	3NKAneWkAZvbFVj1qFR16ySDGouGKQEZkTaEkE94GeSB84oDCiPK	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1609	1333	179	6301	8858	jxyYGVY4hGqYGs2Bu84uX1WLBYyDXDyRCfEwGngpeDhD5LJbNX5	6462	9131	9131	1617582780000
12540	3NKhQdPh7xP2dm8EKAjXD9ntAeqEbFVprqjqPhAxuK9owduuTziA	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1615	459	179	6301	8861	jwMqMuy5btHVNgWixcUNm2K9ctY8QNuafV5Ca2mcjqkvDAdEMun	6463	9133	9133	1617583140000
12541	3NL7K4woZtbYzh6wTz4E5wmSifCU7aXP8vC4F4aJbRu9htTsYDgm	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1455	966	179	6301	8862	jxmih5auuLZHP9MHVN4FcVs1Trg2rJEYfZVf5GKtpopa6Eh3a47	6463	9133	9133	1617583140000
12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1445	924	179	6301	8863	jxvt7sJfrrmgH23VYXiimStFKkJVP3L6qrbcnEjTxMP1gKdWjjN	6463	9133	9133	1617583140000
12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	1588	1392	179	6301	8864	jwbHLgDooTGF7nPo87GsFHSveV7PjGpaU9mhtPUixtg6hQuKmjN	6464	9135	9135	1617583500000
12544	3NLN1tprHTtt66HgSqu4S46QAmyGdPitF62NJgRPC39bJznCfWyC	12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	1467	1376	179	6301	8865	jwKHvpMDS2wpCwfhhngNhLJP7BhmXDhEzJiyTYofjut5eeaFsXx	6464	9135	9135	1617583500000
12545	3NKvdaaYRyixnHDJ5KW4FbqkruFq6wwZgDAH4npPyXpMQhcsjGPJ	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jwYhD5ZCAVko7GPjacxmw1kL1XAaf6Y2rjXWj4Ypku6GcKzFV9c	6465	9136	9136	1617583680000
12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jxtSRpyDipsKZcAeALTWdNziH9vDsSFigZyTzgS3kD9p4jg428U	6465	9136	9136	1617583680000
12547	3NLd2YBy6VD3x6Gc3CBiMQzQuZTP233wGUmV8AyqTE2wswPZYEPi	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jwN5FEJB2XrCvRWWjnKu5N1Kr7CHK8gp8skRg45B3J89A5K9tfp	6465	9136	9136	1617583680000
12548	3NKVAePo3i4kitq2rw1jCQTNjzB7eBvJxk8ZES6g1GBsXMj4tFnK	12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	1619	1275	179	6301	8867	jwHLbwLsmT3EenbQjZiNPrgvPNEfHAWVa3PqjjheJDyp6pqRhay	6466	9137	9137	1617583860000
12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	1611	1215	179	6301	8868	jxd9X191om2CEZcdTHR2PHd3EbnJicXanVKBSHdkgf6hQfdeJnZ	6466	9137	9137	1617583860000
12550	3NLYRJiJxtRpaaeo7c4A7JnBJ9vE9qd3frAf3RNx6TQ6Fz35SGRJ	12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	1488	458	179	6301	8869	jxM9zrppMjbZb3dBvJgj3bkXVbUrnA4c9mN59wpJMkEfJQppXc3	6467	9138	9138	1617584040000
12551	3NKpkbteT8umxTTXZnEUijY7fcP5VqpxQhrKUN9uwBSg5DWzbrgQ	12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	1488	458	180	6301	8869	jwzD3sccZdPTGaMsDXjXKeJ12Qk9GxnwfcUCfZKcvbwhrYKkjEk	6467	9138	9138	1617584040000
12552	3NKKybAVAQbWhzqZRCkUDoS7FJNTsKqy2ovPxrgz4wQA4WQATo3c	12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	1613	1103	176	6301	8870	jxQu1xckKufi9eBxPbc82ENwbZZ5NNaL8kjBQD9emRy5gyZMttT	6352	9139	9139	1617584220000
12553	3NLTRc8Z68iDu3tx5J8dUKiytBjKNPo5BtjbsYRTPxobgRp5inwv	12550	3NLYRJiJxtRpaaeo7c4A7JnBJ9vE9qd3frAf3RNx6TQ6Fz35SGRJ	1613	1103	180	6301	8871	jxYQ11gtznwkMWQiqruHEHHym8hPv6ZLXZ1BBXHppHLvpLHnFnp	6468	9139	9139	1617584220000
12554	3NLVuZTej2PnGLCwKnvqLe5xGpCk1kutyaqisY1Bvz87Gg1dJVUr	12553	3NLTRc8Z68iDu3tx5J8dUKiytBjKNPo5BtjbsYRTPxobgRp5inwv	1406	1393	180	6301	8872	jwnFiJEWXGjCU34cJ9kqxGy9nfcHxBkZUhVVGz9JVXSyhLYxWRu	6469	9140	9140	1617584400000
12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	12554	3NLVuZTej2PnGLCwKnvqLe5xGpCk1kutyaqisY1Bvz87Gg1dJVUr	1406	1393	180	6301	8873	jwRR72HVdypXw1par6nNYurpoQDtxsnYsEzD78bMB9wH1CmzcSA	6470	9143	9143	1617584940000
12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	149	1283	180	6301	8876	jxZCfcYUvNtRSYjFvbv6k6QY7YoHtRsSxyM3k5o3yaE1M9uk9Li	6471	9144	9144	1617585120000
12560	3NLXZqhKo62kqdWQKwNJHky42j9nT8kfBmXqsWzJ2SBw6qai6ZP8	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1675	1216	180	6301	8878	jws9TEyxUDXAnqdDbMoAhM51o9ymtbKYAERrNz8PRrvLPSmNDVE	6472	9146	9146	1617585480000
12562	3NLYymTHZExDpZ4qn88wQVE2vLhJrwkeK3MFWsaoc8zmarQdnBeo	12561	3NKdqjtqyC3RhzYbxdWUZnqRL7qWRYgxQeZih9eZt5x7cFkz6oyg	1671	1365	180	6301	8880	jxjKL5odGJtEszb7CZmo6Nsj5DNSEkers9QFTHY2ihfmiGiFvK1	6473	9147	9147	1617585660000
12564	3NLcnLxiGyr246gFJW1cbpYbsD6u9ENuhvjTb9pvekWtngK9ZjTN	12562	3NLYymTHZExDpZ4qn88wQVE2vLhJrwkeK3MFWsaoc8zmarQdnBeo	1419	814	180	6301	8882	jwUodK6LQyQrTrtLVaVswud7mZ5wjmgKJVauLJQMhpjeuWcTmbJ	6474	9148	9148	1617585840000
12567	3NKKqjyTfRAPcD6FUL3WyzVZY459fri449gc6RXuUGizGp8yBziD	12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	300	300	180	6301	8885	jxsTRBpK1M85XngGHVGUqovT7GVmUDEnnB3UJpgmJeAtMbL5uvZ	6476	9150	9150	1617586200000
12571	3NKREj5W1L87ynQ1LUc3dnmRYVW8zMosX1unNrogZa4bhQGeTp6G	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1407	1395	180	6301	8889	jwaGLFZdE7g5tcYAnkwuUjbqKgZr6G14X93nYmjJDbdfSq8AW66	6478	9155	9155	1617587100000
12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	12571	3NKREj5W1L87ynQ1LUc3dnmRYVW8zMosX1unNrogZa4bhQGeTp6G	1668	1370	180	6301	8890	jxEdgc2iNJsWBXa9mSt3xYcfPLH7o8sKftBY38mE6nvoAiSmRNG	6479	9156	9156	1617587280000
12581	3NLTsNk2eF1n6c6chuX9SiVnp2dWvX755hYhkyKGNWwggy6dVtkq	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1448	1065	180	6301	8899	jxbcjbVYY3LNXXRHiqdafDzm1RKpAQNhrKvzxNq8eSXaHnhRJLC	6485	9163	9163	1617588540000
12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1406	1393	180	6301	8901	jxwph3HG7HFWJ4WrvVye5Daf4Lp7xLmdGZrnLrzMxXKjbqjTGT4	6485	9163	9163	1617588540000
12587	3NLxden6bnPM725WHBLCj9oekGsua9fRozLyb6UB2T3VBa3rnsTA	12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	1643	1299	180	6301	8905	jwQhMba9jbBKbB2yErjnYWAEsQGmzhHgxYSPTspjDzZL3qhRsnn	6488	9170	9170	1617589800000
12588	3NLvFDZofsNt4DY2FDXVEMoHwRQr8nSyTQ7DHY5zBZGAtTDeUFNN	12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	1672	1159	180	6301	8906	jwJ8TVyeG5fdVqKNSozn26qiPQnEUn43LdeuPQXGJ79WUcYoWRN	6486	9171	9171	1617589980000
12593	3NKiogDPf58CdF5BoYVZ5tiqMRRGsT5bau1Aatw8xWaKbcKTTCDq	12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	684	1106	181	6301	8911	jw9tTUV2YZvaCyLG14peFwrCa4XgeKMT3MC6osvEdz61xTdd689	6492	9174	9174	1617590520000
12595	3NLa5ChtMoK5c4rqWxRBbUkdZ368Uq4ai2xswTR3HjZ4Ryqd5w52	12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	1634	1331	181	6301	8912	jxA3rc3JFsshwMyyxVKrZg17Ah55G7Q2UJHkKoQm3NDLKtFcNwp	6493	9175	9175	1617590700000
12599	3NLMfiPGRZ2SqNKaWZLstXKksT7J76VdWTYMhdXHLY8iaJ4J1XZG	12598	3NKU1zgKSXTuyFEZnwpE54NXC4sQ9M9JHo3tN4t1uNLCXukKep4m	1397	838	181	6301	8916	jwQQrNrZPioyfXe2T6L2cdgWcM1qWyvCWEn95aA4dZK83Tn6G8c	6497	9182	9182	1617591960000
12602	3NLDPseKcHbAe9s3Nvi3eCFZAcGbGGPbyVCCRad1QawWdpeh93Pb	12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	1627	1259	181	6301	8919	jxm3iv7UuGrmtjoM8kzLnY3AQHPMAq7x71n6MEjeLsDw5eEGrnK	6499	9184	9184	1617592320000
12610	3NKA3xxxkPwRCJDmWC3aTesbQo511VFnGgNsnp6VyhJu5FKuWPhx	12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	563	993	181	6301	8927	jwraAQqfBvDNnY8KPiCoPRaZr8cstYuNKaHKNpsECGNABPAjS7h	6504	9191	9191	1617593580000
12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	12611	3NKfYZ4h8iq6wtkukjgXrYZ7SEpuhLGuCaALVTtMMJsAMsGMVBhc	1650	1375	181	6301	8929	jxWajJgA7e5MVky9a5tGyuLMFwRfUcp3TiCzTkN6Mz3e9n2PVX9	6506	9193	9193	1617593940000
12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	12613	3NL7pLW882K6WPyMNiZNgb4s6Mc3qgXsXDbYZhoJNoa68Je59EHJ	1536	1313	181	6301	8932	jxPR3wNm1aEHoZ7zWXNVEweA4r2N4GBzDSWJf6k9UQ5MuF8hRii	6508	9197	9197	1617594660000
12621	3NKh2mvpyh4ZyMDagVhc1ax5kV2FdYChaQbqsyFBAMDVkXN19QnF	12620	3NKqmh1z1N2egXBoHcQ59U4oPLfXqHNMEmDJ1eQwVsqVGrL5KBQX	1477	1350	181	6301	8938	jwnjhcJn2uuYWRKWA9ykWa8DaLGSgDk9YjKSqw4poZ9mj7VRihM	6513	9206	9206	1617596280000
12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	12622	3NL8RBwzikFtfzXJh5Syek9YvfqeiKZjgijqakc6w3j4bzhVyUVE	1406	1393	181	6301	8940	jx1JneHCdMAahHvG1ogrHTfWdJ1V24j27V8BJ5Qhnx7WqXKsfjH	6515	9209	9209	1617596820000
12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	1622	1356	181	6301	8942	jwLQeHUgbrcrKkoxXwvD7NPQe4vixTfojSjL3qSLitFzaQERL1n	6516	9210	9210	1617597000000
12628	3NKx8SqTzhbvgJ1ZUTJ3ecFLf1ZSPLUVN3csw1hHMeUmUSZ4A9Mj	12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	1622	1356	177	6301	8945	jwjWp6aALuBiLQ3RARy7GgdY3eSRZoPJGGRx9cAUZVR271xVQKu	6371	9210	9210	1617597067051
12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	58	915	182	6301	8948	jwFjw9g3nGTEEsLCsy6eJogz8ynhAbNwW3VWx11nt1HjFYJFwoj	6517	9211	9211	1617597180000
12636	3NKrLdLNopc6eSXwf6U9NZmQbBTSFe5Wt5A1YZktmevMR2V9mnhA	12631	3NL33z214cMAkgrPxyL5gRTvzZ4stWhm6E2CkEhwX7e2scJQMdDV	80	1273	182	6301	8950	jx95Bu7JGYdynJUgAm1WqSkbedshjFAoNGvqYhL9Md5nGQuBJ54	6518	9212	9212	1617597360000
12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	12646	3NKebYx4y8gxHSNiH4NRma4UKssA7nZh2ru6JJWh2zDRUDKk4UdZ	1406	1393	182	6301	8963	jxTAWbCi8vRBBHqPz2PVPDG7Djmbz41ahVYJmHTSBRDaCKTCZmr	6524	9222	9222	1617599160000
12650	3NLi1CP8uk48QpLsKgeEKmQoK2JYfUmgKq1StiphNwhFvUCpUbnM	12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	1407	1395	182	6301	8964	jwFkCCtXtNZ9QQgbFsKutNZFN5ECHau4T5sT47yAposJraEM9xx	6525	9225	9225	1617599700000
12652	3NLXjYFt73WgbZ3Q9t151hBnd6M2JVLL48LnTLYtJYcLEzhP3Uu4	12650	3NLi1CP8uk48QpLsKgeEKmQoK2JYfUmgKq1StiphNwhFvUCpUbnM	1508	1021	182	6301	8966	jwAfin3YU4AapTygZmZhhDs1EeN1HpPcayFznsSh1dGpiDujcxr	6526	9226	9226	1617599880000
12656	3NL1QRNeZKo7rbeswDCEvFy4YpDaBVSwdhUiMuhbCKtbdrd3hoGV	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1406	1393	182	6301	8970	jxzoxGQb63zkjhLUCpeKV3RWf1kZDyLuYBiPbt4gGaANjTv75sD	6528	9230	9230	1617600600000
12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	1507	1280	182	6301	8972	jwjk95SMSyGWRmwnHXfP2ADsg8etALccdJgx6d7KywP1DiGRzZV	6529	9231	9231	1617600780000
12660	3NLKw3mZVQYfrSDKSXmgkWZfnLzv2UYm72UKzKZfCCMJCz6KPCPC	12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	1406	1393	182	6301	8974	jwegFeoJSYSNtWFUKCdr6cMG9AptzURYEGGkhNSWq7iHsQQ6KEC	6530	9232	9232	1617600960000
12556	3NKidq4nSNpZm4TYs4iEx2z3WQ9wNyqrQzwDqQb84rE9DNirCPkM	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	1406	1393	180	6301	8874	jxjK39Ve8MwBWUd4MvBq8wzuxoCwHSnm5Qc1ZGhTK5J4Unjdkwn	6471	9144	9144	1617585120000
12563	3NLtx5UPEEUnm79BmLXmpKpNQL1f43uYGieqcv7fB8wRh45bpg5d	12544	3NLN1tprHTtt66HgSqu4S46QAmyGdPitF62NJgRPC39bJznCfWyC	1671	1365	179	6301	8881	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6465	9147	9147	1617585660000
12569	3NLq7SG2Xi85zRsiCy1tECMmNGw9G1uKhzxXYKFTKzdEDPcC6gFw	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1490	1028	180	6301	8887	jwvfFY7mx1iM1zc5ejejmMsMMcHmPXy9e1BALkAHoj8E9a7odVi	6478	9155	9155	1617587100000
12576	3NKhKGnWr7HZq2bWqnY8qgcJGSKZujkFu1VFL9mNQbSdnakSyYDn	12574	3NLoShqbfBrp2fW5qav3e3MStWrGJbaE2qZpkEFp31eV5RP6T15C	633	1138	180	6301	8894	jx71fY5AUNiC1SPPpUHyiCikAXMrLJNs9b4oDP8XceMUGWyidhH	6482	9160	9160	1617588000000
12578	3NLsJWXzomvMQhQPgC3CyRuRmNMKtR5i1zX3saTGfroUymQmjo2K	12321	3NKGkLxdJLgFsxZNgQ3uK6PfVBFd7EB7Ta31d9cx5dwH52JTbGw3	1579	1389	175	6301	8896	jxVvkGMYhGTXBcAGCyujySeo83sG1gC9YHAEWYsRJ8cKKdZYVUR	6303	9161	9161	1617588180000
12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	1631	794	180	6301	8898	jxhJzBhFUkUbwkFqUcWLXb2aknbX4yWDX6kcVmEQxVjTjWNz5yD	6484	9162	9162	1617588360000
12584	3NL56v1JoNKWxqWHGnQk3WvhE38HjeWBP1ovhBBFk4oXT3P6aTnz	12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	1619	1029	180	6301	8902	jxqwgGaTFGEkUSJ9JUpsaGMtWSKLg1ic5KxnGiPgKCw5nHihWLd	6486	9164	9164	1617588720000
12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	12584	3NL56v1JoNKWxqWHGnQk3WvhE38HjeWBP1ovhBBFk4oXT3P6aTnz	1585	1120	180	6301	8903	jwVxoFvvE2Vn9uM6MX5uFDfhwyYTqQnVFT32WbbMtkjDtDRWTHL	6487	9168	9168	1617589440000
12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	1406	1393	180	6301	8910	jwn8SNCYhT8ZTDJnfYfojG4ZWgYkcwK9sj12uknMcQyUC7q5r6j	6492	9174	9174	1617590520000
12598	3NKU1zgKSXTuyFEZnwpE54NXC4sQ9M9JHo3tN4t1uNLCXukKep4m	12597	3NLrDkiTDwjr8gFrzq4wM51aiMLTGJeRa2QSqpyPaG6aP94WyEDo	1553	776	181	6301	8915	jwEw1Ep8nZTE3eSxuyJnyRPoYmdsP6tj1mf4Z2KggHaZHYaiF7r	6496	9181	9181	1617591780000
12604	3NK5YhjqRJFTukdj6BZiJ6t5zuCkR3UN8TH6rJVpdE9SivQSPqAX	12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	1564	1338	181	6301	8921	jxD2PABSMEFyKNhMhLnHJBkaea1T7Ma9V1Y51izF39iqhQE3ToU	6500	9187	9187	1617592860000
12606	3NLcVojSdSM1yyswF5a8XH9LmoxGpK2CGWVQWhsyZjmSD28ch2wq	12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	1483	309	181	6301	8923	jw8PV9ZU6gsYsBsJVincmu5Nfq4Z5coFM31rYmDQiR4naohgA8W	6502	9189	9189	1617593220000
12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	12607	3NLoPmPUt1SiNkcsp7e8rPnHJyW4VhMjznFwHsjDn7Y8h3Sqccdt	1657	1098	181	6301	8925	jxtGFAMrVbzzDF8xoMStgqrJnD6sxnwHMDhZ5v22mFpsbHXcVjH	6503	9190	9190	1617593400000
12614	3NKqWRAnuy9SxVzqox8TZdR9NvVxWSNJjqjVLGjABcQUpH7NWjwh	12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	1406	1393	181	6301	8931	jwNcEnqEsXJw2n95pootXa8EBoho3eDdDnMKGNJz9SZ33DMbZja	6507	9196	9196	1617594480000
12616	3NKATSRWLbbCAbuu3ermbcrxYLapKpCwVBGTJjHCPbLQ64eQb5hc	12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	1527	1293	181	6301	8933	jxmiJCHWRRVGCAFq1ZQg3ATkcL7rotxp6MkyLWa9AR3maLgQoxe	6509	9198	9198	1617594840000
12619	3NKkvCWNvCyQzDxqwtLY7Xy55iYyDhYMicA3xM6BQQWKAWL4m65Z	12618	3NLMHzMdeAAYPQEAj6dPnqRKqYTRWkGATSwX9krmY11FCNXvPmy7	1624	1208	181	6301	8936	jwhrEZ2cCPnvwzoBTRCmaMeciphk3z2NPCp7Pob6APKMX3PY5hg	6511	9202	9202	1617595560000
12626	3NLw5tUghbtJRapiKW2P2WiCbTV1N8D33Knv5WfjRsmGv1py7NMz	12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	1529	1190	181	6301	8943	jwHdrKGN99hUirvnp1452g31mxc2S2FbjTw1LsrGv1eQPnT4kBZ	6516	9210	9210	1617597000000
12629	3NKTQowWJ6jQibfSYkRZRYKf2h6EgZfNrVYa3Na2Htmujz4yYYkp	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1622	1356	177	6301	8946	jxBw7cm5khzXQkvp6RXsss8Fb79n9m557JwwuMSkh6oyTGRmkhg	6382	9210	9210	1617597099245
12630	3NLbgueBUh74acgUJH1EuEojWUyB3E7wWNwAfvkoDyTYVVJTVv95	12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	1622	1356	178	6301	8947	jxMqAE8wX9UHuw6iKjaUEdH6Rot5rSjtdUrbnL1HusxXRwPx6As	6393	9210	9210	1617597132707
12634	3NLZQ1vNRVJ6PEUs8hZZxSPYtSgYsufzSTXQWXPMu6Duw4A8F7TX	12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	80	1273	182	6301	8950	jx95Bu7JGYdynJUgAm1WqSkbedshjFAoNGvqYhL9Md5nGQuBJ54	6518	9212	9212	1617597360000
12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	12635	3NLPmq3CtKjgTCHZUdWJYXVghRFXrFmU1DjFamLYb5GDz64CJdmX	632	1382	182	6301	8952	jwgh6gZAiQ22UyxZDATTVb5F58V8CTuEvHjpYJcup8w1frsCBex	6519	9215	9215	1617597900000
12641	3NKWyYe9HymUoNAcKgPQ3xUdbvWegRkdY4vRgaMPkZGV566hzowA	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	1458	1077	182	6301	8956	jx5TYSVcrXoayPSnszafungUh2wc1rf5PGiPneWtPD4BbBTypnz	6521	9219	9219	1617598620000
12644	3NK5MyrRa2ky82hvaJJZHoTc69fANu6mm8bauU9A3kEF7jG1NBNF	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	470	1063	182	6301	8958	jwa2YtWZdHY9vCK9FPA3t6ucP338VtqQywr3RdgiTYD7mGrQM83	6521	9219	9219	1617598620000
12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	12641	3NKWyYe9HymUoNAcKgPQ3xUdbvWegRkdY4vRgaMPkZGV566hzowA	1646	1354	182	6301	8959	jxagQyQS5zZbUYCCNAMK8Q7uZyggWYvLsw4L6aJ2WcjBiHdNFPe	6522	9220	9220	1617598800000
12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	12652	3NLXjYFt73WgbZ3Q9t151hBnd6M2JVLL48LnTLYtJYcLEzhP3Uu4	1588	1392	182	6301	8967	jxUDRuzUBPAs9mTEAJ87ZLSScCkCkrxwuBZbBEFhCbAbWBzunzL	6527	9227	9227	1617600060000
12663	3NKzSv8ia7QJezE2iN9mgLV14Sn5rQcaEGYHt8GhVQh9N6tsN5Je	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1422	971	182	6301	8977	jwXzqyw867vZXXwmyjVLcxpwD458xVWgWazv91hHEudhqonTEwa	6532	9234	9234	1617601320000
12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	12662	3NK5rzVtyxLi4wUr4j2iAD9jq1v5VpRpiHM5GVTPc1nAK6Fidz8q	1483	1276	182	6301	8978	jxUmUJc48RrA2R1Qyk1r1zifs3bZ4PvTcrXVrLJYHbiXGLW9aLM	6533	9236	9236	1617601680000
12669	3NK3iczmFnnusyneCnjBCydmtmpEWN2MT3k7HfceYz8NamCV5XxC	12563	3NLtx5UPEEUnm79BmLXmpKpNQL1f43uYGieqcv7fB8wRh45bpg5d	1671	1365	179	6301	8982	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6466	9237	9237	1617601860000
12672	3NLEoeWncoFULuvAs3JEdC12EW6VkE4jMag8uecof7JqjAtScrDL	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1651	1301	182	6301	8985	jwgutgEGWubzHsRAJSuj1SQbiMzsLqXwGdUQygUj3KANSMoYN6D	6536	9240	9240	1617602400000
12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	298	1308	182	6301	8986	jxgPHv5GvrRzuJy9HT8QR8emVNR4mBJKqAHNYrGeNSD1ubBQyrM	6537	9241	9241	1617602580000
12679	3NL8FGyJ7DjCoZxzfTU5Vwh4UA28nbB95r14ovFaCZv7wUQQi7Je	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1406	1393	182	6301	8991	jwLEDLP8154e3AYp75jvsFUw5TgHu7iX9NEs5XaTzzky7r1EEXZ	6539	9244	9244	1617603120000
12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	12678	3NLb7ytJwUdeNYWBn2J4Wb7vAty7yUJzkVHg324FfdgiDWFMsyZ7	1407	1395	182	6301	8993	jw9NdDmPXpLzEntknH2Wqs1xGZp7qdzJB1XFAPXGtgFDhj9aN8t	6540	9246	9246	1617603480000
12557	3NKsnBXHTFhLvnVXprAdQBhburZCVgfyjukpNv5qXoKdoQ1eaLq3	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	1419	814	180	6301	8875	jxM5xwBztuTSsqChKL9zuzKkogLEWGyE2wpoq74gv9UTbunLAUY	6471	9144	9144	1617585120000
12559	3NLTcj9RZBw4oPDovjVrtmvDW2w1EMxmxBNmKNrQWtgriMDVwfW6	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1419	814	180	6301	8877	jxErAvdSJs1wB9ksPSQLiqBTjPxPQyNTywMmUPYfs5hj7ins7bs	6472	9146	9146	1617585480000
12566	3NKsbbKkuBUDaKohaK7Cs8UZfkdCn8NEuMm3crB8YhT1EZYYMzte	12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	1407	1395	180	6301	8884	jxBeJNMv3cr4rLCMTnSrwZoB5nBxaCVN1W58DVhiy1PP6j2NXNy	6476	9150	9150	1617586200000
12570	3NLb6HB52Wm92bjz189Stw4DT9AX3zczVg7t46RZMTN1PMTd1nTL	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1402	850	180	6301	8888	jxeu7pdd5ReKxmHWvtUkTW2u1eXY3BTDwLhsNQokGQ5szce59zP	6478	9155	9155	1617587100000
12574	3NLoShqbfBrp2fW5qav3e3MStWrGJbaE2qZpkEFp31eV5RP6T15C	12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	1406	1393	180	6301	8892	jwypZbPpgN3wBA4ysmAfoNe2rpCFXCnjey4JmHE7qvCV7tfSZHZ	6481	9158	9158	1617587640000
12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	12576	3NKhKGnWr7HZq2bWqnY8qgcJGSKZujkFu1VFL9mNQbSdnakSyYDn	1579	1389	180	6301	8895	jxwGxC7N2UHHidgSYr2prwBYoVn4Bwy7JgBJdbsNn8thgcrqe7K	6483	9161	9161	1617588180000
12586	3NKJgnDPceJ8uai5Qakm3eCejD1LZjKefwktg2zDYCqKLdKrnD22	12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	1483	1276	180	6301	8904	jxS5C64PMNJu9NeLBpnfjzjY96Jz5M4ktax9k7iNuBvayJgm5Mw	6488	9170	9170	1617589800000
12596	3NK2xEkRQMsYVjATie7Eh3zzw6Wsvq7pGREA3FsK5nTfqgEJ3zKu	12594	3NKx7NF4sbjV6Si9FagoUn7mE7ekLu2cBWu3pVobosWgjCtcFjeF	1506	1127	181	6301	8913	jwMG6d2suBU7iPnCU3yDX3y83ZQwAYq78xDBMgxEbNiTKHoZCJ7	6494	9179	9179	1617591420000
12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	1673	1002	181	6301	8918	jwMaHQGZEMv1Mkd7a4uYYN3DwyDSfs8Zo3yLaWAX4yzxQLHYe9Y	6499	9184	9184	1617592320000
12607	3NLoPmPUt1SiNkcsp7e8rPnHJyW4VhMjznFwHsjDn7Y8h3Sqccdt	12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	1406	1393	181	6301	8924	jxYj8xMJnsJF6qfRoWuS7vAwVDLpKt51d6E9GBwCVRwA9yHNKSi	6502	9189	9189	1617593220000
12609	3NLVY5ekmrm8VPGBszfa1u2nM9Xx1rdowjSq14zsCCoD19hdUfK7	12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	1637	816	181	6301	8926	jwbgkSVTYavXrLAifJyG2pQVo6HbLf82zDPiGfGyqXL5ivzowSk	6504	9191	9191	1617593580000
12611	3NKfYZ4h8iq6wtkukjgXrYZ7SEpuhLGuCaALVTtMMJsAMsGMVBhc	12609	3NLVY5ekmrm8VPGBszfa1u2nM9Xx1rdowjSq14zsCCoD19hdUfK7	1407	1395	181	6301	8928	jwEFbuRqiLxxRoMiawmPEeVEKZPPMaX19hFq84HuEWbPhpyejKQ	6505	9192	9192	1617593760000
12617	3NKxZs5RoS5jkFsrS4p1gLMYz5tBMoQToonn7W2WViTyhbuHrDU9	12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	1419	814	181	6301	8934	jxjN8eW3bDwRkyerx1qwLsEoSkPU1TSLxJg9sSxcz7q2nsCF21Y	6509	9198	9198	1617594840000
12620	3NKqmh1z1N2egXBoHcQ59U4oPLfXqHNMEmDJ1eQwVsqVGrL5KBQX	12619	3NKkvCWNvCyQzDxqwtLY7Xy55iYyDhYMicA3xM6BQQWKAWL4m65Z	1601	1388	181	6301	8937	jxiypN6Pyk4aZkhyYKpiNbMtHhTYgprq3pidVq5zzHAPeCuHXeo	6512	9203	9203	1617595740000
12624	3NLg643UmaW8KwLVGmSuhZaR5qbRi6pfoksRhMs4JnUWoHhCv2e5	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	1622	1356	176	6301	8941	jxh1BnQoB6NEXPJgjRkkuQqTwPBPhG6fEppZvG3qddDNcxiP1vE	6346	9210	9210	1617597000000
12627	3NLMPRs1uaqSyiCbdTwotUvE1izaYCzmURJob6PUfpzSSy5GckbX	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1622	1356	177	6301	8944	jx5owXdnY8KwuYYpGWyAbNyjqSKHyFziajJx8N3N7hzdK7gpwUR	6358	9210	9210	1617597033249
12633	3NKH9BuA6WzF6CnDYAwaL24SjJcZ7BaYHGqbfdAXQL7XLNsgjsr5	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	1631	794	181	6301	8949	jxoDei6AtsrxvPq4fh1cFyZqzjQWvPEcU4Ta764ypNwXBmc1754	6517	9211	9211	1617597180000
12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	1503	1277	182	6301	8953	jwUkwb66PogB9kFbTYSSMduJ9si5bsrczg8FPBS42fUo4GbxvBD	6520	9218	9218	1617598440000
12640	3NLhSBBXGx6AJuM1o6okM4iMSHULBFYrertkJoQPrvqt4LGusvCE	12261	3NLPG7x4jCHPUnpk3NHefcuN3obBzWFWyT87Vs6bpfxV2ydGZGwh	369	1186	174	6301	8955	jwf88gCJZcGukvRminA88BDLqyeHoiueX5cs8KcV4yWFh6QKNKY	6242	9218	9218	1617598440000
12642	3NKG4iDtgB1KDu3TRSrESmWBFi9ZC4ruAzZ14qikbtNLaejGUdTp	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	1637	816	182	6301	8957	jwLJetKTF4YLhHEHa7LsWyxWhePh68cCy2hJXNPJZAs5sgvQcnZ	6521	9219	9219	1617598620000
12646	3NKebYx4y8gxHSNiH4NRma4UKssA7nZh2ru6JJWh2zDRUDKk4UdZ	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	576	1109	182	6301	8960	jxGYG8PEPuJ16CFcg27QD7DCPLav6Qh45Tik8FZi9EgWzdSFXwG	6523	9221	9221	1617598980000
12648	3NL8DTwCUFaCUdMyNCA3JSkPGyUmnLRzWcTiSDY2j6Zk2KoXUCFB	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	1631	794	182	6301	8962	jwUEnGeifzQLTGnShjZSthv8wRFB8zT4h2V67nGcfZ2ZWh6ywxL	6523	9221	9221	1617598980000
12651	3NL8ESkLgAkXyH9MpsF2LD3CozTVNYS1PthCd6Y3tetZpmuj7ZMe	12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	1631	794	182	6301	8965	jwwArMfZ8aX38YmbVMfTRm9dMW2HCpq1udFhejWdSyp931SQHuD	6525	9225	9225	1617599700000
12654	3NLMgZnUg6nT5fdSYwD6BL31s9XKJKbG3pqvUZyPdKE4rfnQboHN	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1527	1047	182	6301	8968	jxWfwB3vGGnLfbv634r35f6Kds8FWejXVdjgSBKhVdioAtTtChg	6528	9230	9230	1617600600000
12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	12659	3NKF1hYBKGn5xs194TqPyYuZzDvKiNuNVxVT5gnRiuFS9YqTg4pj	1406	1393	182	6301	8975	jweuDTWCVgzA7xEBuqG6BQWqfwXbKBCb8N2NM97oHHvyk3yJ4vV	6531	9233	9233	1617601140000
12664	3NL6rzv1KvGGzbKXbA265fjQiJvWHC16cAQprm56mL64pG4PLaij	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1422	971	182	6301	8977	jxqYiP8XrQgaq1r4uY7HHsTpvjz6WKizkxdR8iZVPxssK64N8bg	6532	9234	9234	1617601320000
12666	3NLgFSPAcMqVsE1dc4nQCUc1SqvFmxcQtdzEzeAjf4UX2HHg5Ue3	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1671	1365	182	6301	8979	jwLxDXYHyTbefFKGthcGsPj9eHgnUhwKTW4XBWXARgtQTEMZXnJ	6534	9237	9237	1617601860000
12675	3NLFDjjjLJA71uC9yLQWhbp1yaHadY2K27N6ksYf19vjE9THiFRf	12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	1560	1291	182	6301	8987	jxZsLgv6hnDnxwuFbSKvrong5Ka63gSt39WmLuFiNkvT4BLcSMQ	6537	9241	9241	1617602580000
12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	1611	1095	182	6301	8989	jwx3ZuYDpAJrKx6boZizRHfEuL6PnVfNa99P9QwpEjW6K8TYydG	6538	9243	9243	1617602940000
12680	3NKFngGgxm6cLDdRHUL5LhRHrarRKiCtQPYvvU3zAt4E4FAb29HE	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1407	1395	182	6301	8992	jxDmYsbthusJdsuvJQtVvZF1bjYdkTbYSBhQ9nYkfjBYwsg4zXq	6539	9244	9244	1617603120000
12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	1426	1238	183	6301	8994	jwMGjFUufSQysCmGgJN7tRdKCFordHBdo9wxfgjjJzSuWGbibJC	6541	9247	9247	1617603660000
12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1672	1285	183	6301	8996	jwdgDU2FqPUnLbnAwUYtkUXZ6CbV3A66WVGSxeBFkYZrf6AFgow	6542	9248	9248	1617603840000
12561	3NKdqjtqyC3RhzYbxdWUZnqRL7qWRYgxQeZih9eZt5x7cFkz6oyg	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1406	1393	180	6301	8879	jxVhY2ChcgG9ThmzS6Nx8P2TPze9DigHg8SRDANcP5zLVckLkMs	6472	9146	9146	1617585480000
12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	12564	3NLcnLxiGyr246gFJW1cbpYbsD6u9ENuhvjTb9pvekWtngK9ZjTN	1489	1134	180	6301	8883	jxN6RgW65Xp4kAknmZzAUX81kGh6Lj6ZXCEp4AYsyebySVEmvoz	6475	9149	9149	1617586020000
12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	12566	3NKsbbKkuBUDaKohaK7Cs8UZfkdCn8NEuMm3crB8YhT1EZYYMzte	1406	1393	180	6301	8886	jxYtT3G4J8ZwEXfzQ3JA52DFtUye5UX7D38XBrrpvs6aXTewBXL	6477	9154	9154	1617586920000
12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	1617	922	180	6301	8891	jwP2tet2MY2gYYsddt9LZYUGZ1QBPHZA9ptnwrY5oDvRGB5GnTY	6480	9157	9157	1617587460000
12575	3NKFUn1DEjx9THdZ7XT7VtzMMtRXZb5XQzvFQQ72mSTa7V88rq5P	12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	1439	1033	180	6301	8893	jwmbF1Y9fEodZRLt3BY1bwDcRuLRg1SfTDSVnfDmthiZFiAP23q	6481	9158	9158	1617587640000
12579	3NLQegvMrhA2YUbiZdVgZLRTGf65iAjGGq1viudq6nFzmnqmgQ7q	12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	1647	936	180	6301	8897	jw7UWVGZ1q3GWsK3yZufgFCMSNTKgxhoDC6qtCGoaETriYvUova	6484	9162	9162	1617588360000
12582	3NLhZY261PkPE6TaDP718cBWNtppq6hexjK99rDQypYmYGW9JTXS	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1422	1211	180	6301	8900	jw7jnEHbWwnP3Xq3BxSH2P63BDRJinKRprVeAhvmfW9UzSqni32	6485	9163	9163	1617588540000
12589	3NKfM8pjDxn8yE766Zrwvqy4C4sdxBjTSwF8krknLMtyPxfzxCfU	12586	3NKJgnDPceJ8uai5Qakm3eCejD1LZjKefwktg2zDYCqKLdKrnD22	1672	1159	180	6301	8907	jx9k91fJ3nzGHnwGp2gq9gtaymvH3LU3nW88mufNx4BpEVTLFbz	6489	9171	9171	1617589980000
12590	3NLDiwowvQzjNLTeGbkGdErkPjRworFRWZ3q8aEYqcZJ35ZpaxtF	12589	3NKfM8pjDxn8yE766Zrwvqy4C4sdxBjTSwF8krknLMtyPxfzxCfU	1633	1264	180	6301	8908	jwgYQXr3KfsVwF8GGm6zqZzLcqY1dgDf12Uj7j1TB1Ywfis73bX	6490	9172	9172	1617590160000
12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	12590	3NLDiwowvQzjNLTeGbkGdErkPjRworFRWZ3q8aEYqcZJ35ZpaxtF	1406	1393	180	6301	8909	jxF8NiEyUe4rnysWfqFkjY56jPiuvMNS2ewo8KPd4yqg62xRKTr	6491	9173	9173	1617590340000
12594	3NKx7NF4sbjV6Si9FagoUn7mE7ekLu2cBWu3pVobosWgjCtcFjeF	12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	1634	1331	181	6301	8912	jwNKjo5aX4vkxKaLjh1wPXeViLs6oJwVCMR1NvZwJWLQkNYsnxG	6493	9175	9175	1617590700000
12597	3NLrDkiTDwjr8gFrzq4wM51aiMLTGJeRa2QSqpyPaG6aP94WyEDo	12596	3NK2xEkRQMsYVjATie7Eh3zzw6Wsvq7pGREA3FsK5nTfqgEJ3zKu	1407	1395	181	6301	8914	jx4MjPptwg9n1UFiZU2qGsPCGa8CHjFuKEED3bwFyWQUhpjwTsU	6495	9180	9180	1617591600000
12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	12599	3NLMfiPGRZ2SqNKaWZLstXKksT7J76VdWTYMhdXHLY8iaJ4J1XZG	1407	1395	181	6301	8917	jxZayZqa1hXAj7zsKtdoEZoWLT5yjM2doR3aVmQYMNuFvCzHGCm	6498	9183	9183	1617592140000
12603	3NLZcmiQedN2VCnzFEKj8f2JVPdfzkx8E3eURafBhPdDUNRoBRLr	12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	1509	1194	181	6301	8920	jwXLcHBufF9kwSgHS3DtEJdJmawjQSWFCNnTbM5y6HxhEgKV9BD	6500	9187	9187	1617592860000
12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	12604	3NK5YhjqRJFTukdj6BZiJ6t5zuCkR3UN8TH6rJVpdE9SivQSPqAX	311	1307	181	6301	8922	jwTkJkMhyaKqscA8Wqeee8Zi4SRUvmQNr1d2gfNhwGaU63EH6UK	6501	9188	9188	1617593040000
12613	3NL7pLW882K6WPyMNiZNgb4s6Mc3qgXsXDbYZhoJNoa68Je59EHJ	12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	1529	950	181	6301	8930	jwt2t6uLjbq36eucaGqtHggFWgsA2G3ASH2KoNzHQaQ6wBS62HH	6507	9196	9196	1617594480000
12618	3NLMHzMdeAAYPQEAj6dPnqRKqYTRWkGATSwX9krmY11FCNXvPmy7	12617	3NKxZs5RoS5jkFsrS4p1gLMYz5tBMoQToonn7W2WViTyhbuHrDU9	1627	1385	181	6301	8935	jwGZ8GVXTVTsH55HDjyw8DUVXDL4hdHa8asGFVYfg4Vo74Cfpam	6510	9200	9200	1617595200000
12622	3NL8RBwzikFtfzXJh5Syek9YvfqeiKZjgijqakc6w3j4bzhVyUVE	12621	3NKh2mvpyh4ZyMDagVhc1ax5kV2FdYChaQbqsyFBAMDVkXN19QnF	1587	1111	181	6301	8939	jxnnqPkNmywum5MUwkwcCfh6hvdi8ygHwDkcihc3q98KiV1GZM2	6514	9208	9208	1617596640000
12631	3NL33z214cMAkgrPxyL5gRTvzZ4stWhm6E2CkEhwX7e2scJQMdDV	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	58	915	182	6301	8948	jwFjw9g3nGTEEsLCsy6eJogz8ynhAbNwW3VWx11nt1HjFYJFwoj	6517	9211	9211	1617597180000
12635	3NLPmq3CtKjgTCHZUdWJYXVghRFXrFmU1DjFamLYb5GDz64CJdmX	12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	1509	1320	182	6301	8951	jwGnmS2UFk4nqkbh9xsKeYhQ471eXFoXank8JFtnjqSoQAsAXES	6518	9212	9212	1617597360000
12639	3NL6oCKLZD2wT5Lr4RLod3EteB7gXZZEhk57pURpTEZDymRszx1m	12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	369	1186	182	6301	8954	jwsL2jsKKQ6E2Ncitg8juyiLTK4FkK1TAU999qZ34uzB1LbpP1p	6520	9218	9218	1617598440000
12643	3NL5xcWvHkvQC49okDpfbaYsZp2JwBgR7JiGoGd5TnvA3SHnnhrJ	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	470	1063	182	6301	8958	jxFcj6jsU2KzWuvC7fhHFR98ibnaoQfSEMpncuGSLaNS4EmdFzs	6521	9219	9219	1617598620000
12647	3NKZawCDef2DhhzqP41G7AK1u5h4VGu7ZMyXAB3XXPW9UaPzMSjU	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	1407	1395	182	6301	8961	jwrQtkRWCA8vWnPzwhQV5m94Tb6PQAFqBwjvEu1Rc3YaCH4skjH	6523	9221	9221	1617598980000
12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1402	874	182	6301	8969	jxteJ1HaGtMDpP1TCHYoqcUw3kPdk9eyQKK2vwaCsLgXXFPDDFy	6528	9230	9230	1617600600000
12657	3NKvuAMqcBuSYxNeYp5rxUErZUJmRFLr7Mo8LHqvdUyXeLZCapxu	12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	1510	167	182	6301	8971	jxHVDJrzfGcnzoLjwz7iHcUgMiC2sAAKT9bvLzX6MGmY8qafA4e	6529	9231	9231	1617600780000
12659	3NKF1hYBKGn5xs194TqPyYuZzDvKiNuNVxVT5gnRiuFS9YqTg4pj	12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	1508	1387	182	6301	8973	jxJYqp3KM9KakUxthrK6g4J72TpjZmNbNwUCNNeDpgo2eg6XnAC	6530	9232	9232	1617600960000
12667	3NK5qexJf77TXnixTd5dbt6Gj91dDtQHRqkGwdRmAA4jeXoKKrVR	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1471	1020	182	6301	8980	jwaY66d7SLVUCQrWTDpZZuLSHfeWvCJ3YgiSn8MxLeLhsANX81x	6534	9237	9237	1617601860000
12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	12667	3NK5qexJf77TXnixTd5dbt6Gj91dDtQHRqkGwdRmAA4jeXoKKrVR	1426	1118	182	6301	8983	jxUFarCPhRpqvSNDWpHejVd1a3TWUCwFp54spcSKdBHZJa572dL	6535	9238	9238	1617602040000
12683	3NLfP9qdfGRF7BXRh6Tj2NmGgSymMaTy2p4dSNnFwfdFTQHQ5Ttw	12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	632	1016	183	6301	8995	jwBMVKWnsQwgL5V2qGrukLvfB5gKtgoVhTvS7vcPRDZydwi3e2e	6541	9247	9247	1617603660000
12685	3NLWPa32JgA3UWKbLWr343bMK5PGnumDdoZ6mxpXUEmRhTHJ2gGT	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1670	1156	183	6301	8997	jwDdNJqM8pZxsYy2bV88MfJyHs3ZwyDsmfXM91wFPA5vL7Lh5fs	6542	9248	9248	1617603840000
12687	3NLdjmkEHNo8xAZKy8S9XFguVuN5XpEnDv21gRV3X24uWVfAM3me	12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	1647	1056	183	6301	8999	jxDj5GxUZDFErHs446YQffMzDqMH9pNG1YS3jVr2D55EerUragt	6543	9249	9249	1617604020000
12689	3NK9jDT5gwG8PeEzoNDj8mEYCcbcKkKjsFg61V1FvBxDUNcYu3Hd	12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	1602	1123	183	6301	9001	jxAxh5BuiCDaWd7vYC7f7V526XWnFRec9bfE84LUzmqKGrew71m	6544	9250	9250	1617604200000
12662	3NK5rzVtyxLi4wUr4j2iAD9jq1v5VpRpiHM5GVTPc1nAK6Fidz8q	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1500	931	182	6301	8976	jxmx8RZ9NN2gymDMffWTPdcXN3fvyx4NnB6ZA8E7ZfWYxtPKbwx	6532	9234	9234	1617601320000
12668	3NKyAoeYKWv6eXrGb4nhhu2Nx59aZNZTqdneMegpAPiz8FfkB3sR	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1547	1378	182	6301	8981	jy1Djm7ZRFBpiDmiz2bGxarx8FnxrCv2FvAWT2fmd39tQNSCArv	6534	9237	9237	1617601860000
12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1608	923	182	6301	8984	jwbgPN8CDqrAjvHf2SrEHoeWwmgF7NdsbRzfCuwpZ4hFuTzkAB1	6536	9240	9240	1617602400000
12673	3NKxBvcUn6ThgSzQnw1jwjXBUSzAgKu3xcfPcEKgZDXJaYNmHgsM	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1651	1301	182	6301	8985	jxaVFRqGbZ3sT5TQTej5EQuCbXpFiX27efF8ifeHbxTfz9GGbDq	6536	9240	9240	1617602400000
12676	3NK6oVUaUSJ9JNT4T91dEZ7vEFgLvPDvrPenR82fLfDr3gZmUHJ9	12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	633	1384	182	6301	8988	jxQRwUPkAEzEKcgsjy3wB9F7AGzzdi2hf9MHH45dFk2P1BQ2YhQ	6538	9243	9243	1617602940000
12678	3NLb7ytJwUdeNYWBn2J4Wb7vAty7yUJzkVHg324FfdgiDWFMsyZ7	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1637	815	182	6301	8990	jwmY5Bvm2WsqfNd7ccPpvBVNpDdfze6M91U1vfgXn89YVoBXZDc	6539	9244	9244	1617603120000
12686	3NLW6e3HsnoE5pqjkVKiuNRJsrFTT1dWFgT2676TJW5taNXqWLyS	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1673	1122	183	6301	8998	jxUF7Cke32XzanPLMCVnQfBoxP4Ngn8PwwTTYay9rKrz11KgcKC	6542	9248	9248	1617603840000
12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	1406	1393	183	6301	9000	jwiH2U8B9SK8dRygBHRj8cGCRfFPC2FiVc76S1yniB5mfg7Fcyk	6543	9249	9249	1617604020000
12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	1406	1393	183	6301	9002	jwxh21zn8feoj1dXDnPPJpKxeJT3JeMXk9hgpdKCowa8H8uLUVP	6544	9250	9250	1617604200000
12694	3NLSs5axTQPZKRGSSyfUoFjzyCeX4uwhRaGDeWzrdYf3z46K532Q	12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	1447	1345	183	6301	9006	jwMtWrYfBxkPhuwShvQ569uupXNjCNECnCiyokhPVcfEVx5gonc	6546	9252	9252	1617604560000
12697	3NLU6ZvKguTexcPfZAtL353nZJwsGYoJct9n43DYMKW7biDG8gGg	12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	1654	1214	183	6301	9009	jwHmy7DYA1iBLRP3yNipG1JDM5tsqP8nxRcfv49v16gKohyZzPD	6548	9255	9255	1617605100000
12699	3NLDdWus1nqi45ZVr5bkXDVmix8bLmp4vGkGQMWjGQvBZUMWumjQ	12698	3NL1TG5u3MKuia3x9XTTHbDMvSJN4cVTWtAmNvyrP4HvhLYpfeLQ	1406	1393	183	6301	9011	jwqaz7CgGgSKNXfyZ82M7BKBZiDjyA4mgM8VFoC3YAnpbNtFe5a	6549	9256	9256	1617605280000
12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	171	1008	183	6301	9021	jxc12dt3nRJawTemVGPJxMZ6aUtESY4fUBmABnCTFejnPaHq9zJ	6554	9263	9263	1617606540000
12714	3NLLKqVt2qTA4Q1DU4WzjPMKawRUEVBxPTsnY6sRs3TJMbdAodwW	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	311	1181	183	6301	9026	jxjFb9Um3y9Exh7eLJAWDZginD4UiqBP5rkK5GRLhE5f4dMyV1n	6556	9267	9267	1617607260000
12725	3NKQKSUVxRKLVTwQ5n69uik77FHHiqyvyJBWpWZyugym79wMfMWw	12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	1542	1178	178	6301	9037	jx4S3o7QRnBAJVsuqGHgfTcBFpGZfumoApQUSmkDqUbUTfnw6dG	6431	9278	9278	1617609240000
12728	3NK5SugZBBG3QfkstZSuooQy1oHw4v8fAA2GSY9kKxN7nMCrKgai	12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	1675	1096	183	6301	9040	jxcEh5na2smouAU8HK8YVaEVQojncMd9cgvsayfSqfpHGk8x3AY	6564	9282	9282	1617609960000
12737	3NLUccXCGXfk7PUfGyvjKyx3m1KZysaSK5isvBKFvxrs9W3DNXfJ	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	1403	782	184	6301	9048	jxFcMmNDFgchwTzy6DrMuzfNr61PUG2vtDTsuSSo4uVDnQHLogk	6568	9286	9286	1617610680000
12744	3NLpwVXpuDALu2HgBWh8trDuNvubAbFhqQMuXcw2JH7PxFFPppcM	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1649	1137	184	6301	9054	jwDNE4JP6E9zxNSSsb9FrYGAuJsYmeoQh5Hwv44A8Vfveb6hHe3	6571	9289	9289	1617611220000
12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1406	1393	184	6301	9056	jxAMJVqMpRve8agZrq6kdoSyeHToS8kiF7zqpMpv5dut4xUowSi	6571	9289	9289	1617611220000
12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1613	1223	184	6301	9061	jwMtY7YZw1JB6ZhkDa5q7oECsHxZ1gxkpi78yAU7f3joPZ7NQw1	6574	9297	9297	1617612660000
12755	3NLcoKBSaWKEec8Y9iK5fEN39Y71YPWB28W1EK7idihN4hKNK3N6	12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	1637	816	184	6301	9063	jwEsMk5VmQqKzQgG7YHs326b15ywJzUxQ9dpJqU8xsJyuBHqMyj	6575	9299	9299	1617613020000
12758	3NLaHE7eaeGe8nry8h51KSCkoHyvp6mJqjgbac5pWrLSSfj7x4jk	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1647	1302	184	6301	9066	jw8cajzLXYk8weQbrzm1JQvZCVwWJ32JMPYvcTzbGaLiJifJeFC	6577	9303	9303	1617613740000
12760	3NL6wcFzMhvC5igvJ8eZDogmeRLRufXRipHxKbSuXEeLgvSnbbtw	12757	3NKUR2bPz2PYdMLSiJ9mrvb8jj26QtirfSJRnSFGoJc1L8eD1ctE	1448	1065	184	6301	9068	jwsE2gKUS9za8jFZUAqzdbC8aw37g6oH63fEuw1rBsHu8qcXYox	6578	9305	9305	1617614100000
12763	3NKfBrmuGxNLaFFujy148icjRbiyhFW92hGcBLDpJBbeHGhKUF8o	12762	3NL7dFCGK2bEj7CZfxdYV3e7ZgvuxZJqGwwLLLeAH5F6hjaWTXA3	1439	913	184	6301	9071	jxMYhUTRhuLumdrv82ioxEU1cGTVZBgFZh44nc8wJ2SoAm4ri5E	6581	9309	9309	1617614820000
12768	3NLjZGLP7VAJzu5JZZMp8SaQJZL34TFcrhb61prt6RvT3qdka7mJ	12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	532	1303	184	6301	9076	jwJDBTx5n2pvZMaBEDL3CBxU83CGPiQhPVKMbZb5fNxdGEQbLu6	6584	9314	9314	1617615720000
12774	3NKbMYKaHm2aEUgcbXNPo3sqnU1srb81jWxD5oE6tswXkRFeb7zQ	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	532	1303	184	6301	9081	jxaR8qsnC1iWC9Skjw9wKcP5RAagPq7VjK5otwkp5SiGRL31C9c	6586	9316	9316	1617616080000
12776	3NK97twoskxZdiLCkq4MaSNjo3ZsvdVySC9CozmqsGXqRbU1LLuW	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	532	1303	184	6301	9081	jwTMT7wzuQyPQBd1FHh6nJr4oZcsBDkk6gratfbeC622xbJSRZi	6586	9316	9316	1617616080000
12777	3NK7ZLvPVoMaMaV1ajFtG9a79J1tNV2XSzHNMZsFc2NWVZfKbgow	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1406	1393	184	6301	9083	jwLpssPD6vJQZEUWQnGJ4dzbEAvdMdDFdj9SuUpW6Zz6QGf6BKZ	6587	9317	9317	1617616260000
12779	3NKi64p8iocdfgNPN9wsshNjWUAfYSDTX7omkTf18xG2VGkVyq3q	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1631	794	184	6301	9085	jwiHvQTYD1LXH7rbgMiHm4UgbqExpAjLuf4SB78vMueTQTjsbBj	6587	9317	9317	1617616260000
12785	3NLk6HGfMH938pqJEeDRoDmTcJWhfJQUNX9yuF2x2ESDJ6t4ReYW	12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	563	1113	185	6301	9090	jx7XCiW29Zu3tj6cCdSPUsfHZ79EpWNfv943Zf9uRS9D2V9Tscx	6591	9325	9325	1617617700000
12787	3NLudJwCNb7eLHZGnMr32YZ5PZEp6izXVW2HhxyfrKJcaUP4uQJz	12786	3NKk33agmDXpxN4xgMw2qapbGo36KuKrFhn7rF8qq1Uvepmz9VwX	1596	1363	185	6301	9092	jxewKpgLiX9tZ5rY2ekPdviYSQc9Xe8bqZZAc644nbA5xB6inZc	6592	9326	9326	1617617880000
12790	3NLh73xwLdL2acAMHn3DXCKsNeXzkYxQwAiKpg1xhJ53m3UdaMZb	12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	1422	1337	185	6301	9094	jwfMJJU8PyyGecAcgsiT2VwhU5KPdnsaiRp3mBYfQKbnsLj7iaC	6594	9328	9328	1617618240000
12691	3NLJX5RAmZnM5fEqouCWTjbN4fd2npgQYJH398qg6D7VGtFxbRUj	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1654	1340	183	6301	9003	jwYDCSDNiSqV5tEePjWMhucGmBe5rep6Vxh5xS3TvkjTXYru2AY	6545	9251	9251	1617604380000
12701	3NL2JHqkxogcqEMkiwM14q5LTnkpn1kQkNTBm3ZGtxzwGT34xSUY	12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	1402	890	183	6301	9013	jwdL8c4VJy8Koqqwisk1jCo5ddmTB6LHBiQu498X7QSj6NxBBoL	6551	9259	9259	1617605820000
12703	3NKyP9nJQAWAQnnHhAQ5AziaMq8RsaotjEPg9fQcJ4FN5WvNrpag	12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	1458	1323	183	6301	9015	jwZAFutsbY2G8dHvHfF5zXnboPymbRM5hbgcmSirgZ1C1nt8Hge	6552	9260	9260	1617606000000
12706	3NLKm9fodUpukJy2TUwDq7Waikpuj442VsJDhkyvMC6XJCqC6iKh	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1403	824	183	6301	9018	jwQSrNZnUcDy7nLdJgxFyRADz5Wnw8Fk4HPJrpgZdyujfm8wnVL	6553	9261	9261	1617606180000
12708	3NL8eZwT926r9zAU7uhdhqBUpQihVb8W2PxGUnDgtyASyBF8N2vB	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1623	830	183	6301	9020	jxMffGcKmeMpSLrJwM7UW7YuuFN8M1W85x2pcvm3Th8RFXzpCsk	6553	9261	9261	1617606180000
12711	3NKvTP9nUjtrUKUwQxqSJ1yc3RAGMWCZpRnWPxvtsTa42mwcaA44	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	1617	1042	183	6301	9023	jxcaMDkCF3NJYSosY31jNUfzWXXRigBx23wQ77mHxCWePFzB2Bu	6554	9263	9263	1617606540000
12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	1483	1276	183	6301	9024	jwwyXowryKKx4CtmdvbQpmMyJY2pJfM7ijbECwvpa9EyXpu8A8j	6555	9264	9264	1617606720000
12716	3NLoyVPppk2AiC1JULhrRw9Kh23AtJh9TXUNVx4ovHnn8UaiTtND	12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	1675	1342	180	6301	9028	jxQEabBbbNoEocc91auF5pf3mtwQUUAmVUDbABwogUfTfsJV6y9	6480	9267	9267	1617607260000
12718	3NKJLbxgDEP5Mqf3h6cNMCkesGtyiMZvJwN3FtX4JkNifL1PQNy8	12715	3NKUw2JUADonxPgtf41CkGmDfiGTW9TWY8S12HyihC2RjucJejdW	1600	1126	183	6301	9030	jwSCu8PD2C6tNom68bRHnD9p98JoWZ9eiCUwCAWQsTEeGKcPjqw	6557	9269	9269	1617607620000
12722	3NL3CJchsxRuQRyFh7RUi6Kx3StW2xz1U9LAwhhBNyBYXm62AWBw	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1507	1280	183	6301	9034	jwYrcuKVPrZaMUqBUkounuBPFpaGq8SKuTMKwEdfv4SbGo1WTWh	6561	9277	9277	1617609060000
12726	3NK4JoRqDYTSy5otgoLxiWwqjdB6dpXTnkXpUyKMB2JqhVRk62HK	12724	3NKb5pr2oALX4mCS6pV53XDLbSoX4JrpUpnN7bGiHN5j7yCxYaue	1542	1178	183	6301	9038	jxEzwRLvgHbf2ww4ddWBdNHVJbjjGhQ18TisjLKv55dwXyS84vn	6562	9278	9278	1617609240000
12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	12726	3NK4JoRqDYTSy5otgoLxiWwqjdB6dpXTnkXpUyKMB2JqhVRk62HK	1609	1087	183	6301	9039	jwc1g6Ag1Ef8hhiNhAMfyyYJVTJ2vD9yDtL7dMTksPionhF3yY1	6563	9281	9281	1617609780000
12732	3NK9Uhg6fcPacQtcFHb7mKJi7Gk2qMHBzeSWncRyqexvyQ9mP9cp	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1503	1031	183	6301	9043	jwWoYkxQnE53B6q8UvdKb8goW9rFfPPNRouPmx8u3QSDEFhwLCz	6565	9283	9283	1617610140000
12734	3NLGkiQfhgewrjHMtPMjixU7G4zZyy9Vb44humPsw3XWo53eeWeH	12728	3NK5SugZBBG3QfkstZSuooQy1oHw4v8fAA2GSY9kKxN7nMCrKgai	1407	1395	183	6301	9045	jwBCiu49UepXsVTjvFo3so49h1RNci3p92iHSBzb6ALXMd9WF3q	6565	9283	9283	1617610140000
12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	12735	3NKbvVL9JSG3oXz8rowv6MTDFtA33UTEGpNFyGqPdSg5uVs6tqkM	1637	816	184	6301	9047	jxpcjcCVhvkHxyQ7BkGUph2jyr4RqQdjZunZo6zuWL5Wg9vy3fe	6567	9285	9285	1617610500000
12739	3NKMBQZPE5jYziuu5yuwJ8qksy7fBa7kQQZHkVm6TpmV52jtorGS	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	448	1305	184	6301	9049	jwi6oPUarEtCHxjDh1tFBCnt6Kq7P3VirxskCMqo1BiHNRwwM5C	6568	9286	9286	1617610680000
12743	3NLq3JVXC17Hs6JVQzHvqD3CZypNL3MAz5tDcYUpHXbTiWPgPnSW	12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	1611	1215	184	6301	9053	jxwYZ7LeZS2rkRgqgkKxT4rHYVm9C988fDaNea2zCFA5du5xUKp	6570	9288	9288	1617611040000
12748	3NLtGuTPokToXeH29oaWHu2ENzkAyGGp9UPKyNiG8Y9ZmUx9VFEM	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1407	1395	184	6301	9058	jwoigYbMhbqqUUnbKyVuaMUJFtv6VKkzXjfMtQRWi5ZKJQhNFHj	6572	9291	9291	1617611580000
12751	3NLfQXTAZNHyyenLuhmZo37xhDkdddXgRXJAE3d3pW1rdCiNfjhj	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1503	1277	184	6301	9060	jwsDNfVV3heoEwTxktjjEGhYn8ChbzoLB4ZPRyJfEBVshsdsk6U	6574	9297	9297	1617612660000
12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	12755	3NLcoKBSaWKEec8Y9iK5fEN39Y71YPWB28W1EK7idihN4hKNK3N6	1445	1044	184	6301	9064	jxGWxjbhqmJBAkuTkSwFPFjPa92jY22G8GHGXwwwKbFV8b5QVBS	6576	9301	9301	1617613380000
12765	3NLUp9pFLysxP4EQAQDzmh7x4mUWKt3KjZQySoVc3io9VFb2aZo4	12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	1643	1299	177	6301	9073	jxPn8NeEhVSSSFXFGQdXB1cFicRiej7trB97NqwQPTkAQqfWAAe	6370	9312	9312	1617615360000
12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	12764	3NKMpAChr4YyzfshgxgF2Wyh7h9KLFZXxdY8XMYNTBXKTGPj4TQN	1407	1395	184	6301	9075	jwrjHYiS85rQBu5RpLNZeucwqwqeKGT6MEmaQjh5io5Gw69Qx8S	6583	9313	9313	1617615540000
12772	3NK8Ypi61CiaRmWHZ6uDxjFV2d9CTEbgDKwWUKUQHacCcLbZ45sA	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1403	824	184	6301	9079	jwW7c87CHfQDiw7EesVyYB8kxtZ6mXT3Xvwe7JaANSfhDmRJeCr	6586	9316	9316	1617616080000
12775	3NLSYYwnLmb2chrwDgcz1XzaSJDgxNiQW92w1vcePXgAUNc1bJAf	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1560	1045	184	6301	9082	jxcxDJBY9ZPPKREtKnPDzEuFp47753rfuzFsj7Jz6zoGCkYg6fU	6586	9316	9316	1617616080000
12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	12778	3NK5BWz53wfNwrYBPnRr2qpdanLTP7PaW5Vw98ghCvYLkXHnB3tD	1407	1395	184	6301	9086	jx11eHuiuzXvrsTKZ1S5a77wd3FX9tNbBrv3PgHzVgtiV7bxArR	6588	9318	9318	1617616440000
12781	3NLKDzsiUci4w7dRF2HjfGnCMF3RuLGF6y7X9iXh3C8sXUcrVvmq	12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	1672	1159	184	6301	9087	jwEYeAG49xTmKnX83UTCJGk4EtortczJPpx6VvrRfzpvJQExtvG	6589	9321	9321	1617616980000
12784	3NKGsZsmRQAWM9ZeP4itYmEeHqr6SbPaiX1v6Eawu5Hyfg3HAtTA	12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	1405	889	185	6301	9089	jwwNiBRw4eiAkNqjXLkJD2FkTbX24EqfG9rXGdLKJ1KQJHrTAck	6590	9323	9323	1617617340000
12786	3NKk33agmDXpxN4xgMw2qapbGo36KuKrFhn7rF8qq1Uvepmz9VwX	12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	1650	1129	185	6301	9091	jwDL5KC6vWxoWEejRUNi9uWLpKjEmWQfuCsRacQCqzZ9hR1bMhP	6591	9325	9325	1617617700000
12792	3NL6MgLYEkorhzMSnYWehazyEguhWzHVa8FUrmqvhfwboteKAcUf	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	311	1307	185	6301	9095	jx55sBSFRde42p1HXtwQJTLa9wDoDniAjwbo9mA8F9RfXD4P8f4	6595	9331	9331	1617618780000
12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	80	1147	185	6301	9096	jxyFtBYMAXU9Vux9sWEPD4mA5ExWGgAamgQFUX2UNKDWtfJwLU9	6596	9332	9332	1617618960000
12796	3NLov9PoSkmQgqiDYBZR9CKJ59o6WjHDfUtMZiV1EDQRWqj75MSR	12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	1553	776	185	6301	9098	jwUnm3jJ9mwoyK6BV3coWRMxKoKEF8P1RWVxhZQQ67UDD151jaU	6597	9333	9333	1617619140000
12801	3NKjUjmMBGwA8L2TD2mRGW9e1rHrxjtHauP4YazAdtm2sXxb477h	12799	3NL2AKBC5skTSQ3C48VKf1Qmvvtpeg4sVoYKtm5zAotZBhKVTmGt	1588	1392	185	6301	9103	jxjUmXoo8jrZzFQHx6TV7DZxxyTLV7jiK8VVUUpCfyY29z9xd3k	6601	9337	9337	1617619860000
12692	3NKpK3BWfPKeiGFBMS6L2MpUCZ8pkXFG8NMX2gpyJAT443LDKvzA	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1474	1083	183	6301	9004	jwXmNZ5nAtL4xpY14Ux312nhDkgHshCfyc6gzTXdxy17xCdcWEz	6545	9251	9251	1617604380000
12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	12695	3NKiunS8BgXV957UFmBThiHsvD98TzdghsKVrR3nPFXq9AiXKNhj	1622	1356	183	6301	9008	jxHcEeuo9hdLgzbKxFiZQLQdmZGyEbwJ3RvfgiquN4n72wiKVzc	6547	9254	9254	1617604920000
12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	1439	1033	183	6301	9014	jxfwJA1f5fs8GpYqZGRuvVabK8v3j27J7xG17hakA5uegQR29T4	6551	9259	9259	1617605820000
12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	1634	965	183	6301	9016	jxhD8w99zGK6tUhta9fAnQQmH5TaA8S4uVvmyFndnfGHLcAfmbo	6552	9260	9260	1617606000000
12707	3NLxayE1QSKNXv3T32jbNGUBEf4M2XNohuTDrU7tsMBXTJH4ZoBA	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1637	816	183	6301	9019	jwcmFhppN57RjnDTbdeVKCHkQW73EMgqPq5Gq27t7fCX7eg3FTn	6553	9261	9261	1617606180000
12713	3NLLTx11568xdmy87Xb9qAbyMR6qPK8kYTzNAKgCCHRFiTL3RWRx	12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	1407	1395	183	6301	9025	jx4SCuvXshL3A2k8DJ9KrFkZ4SYqYYgGmyRd2baV5ygLi4qPByg	6555	9264	9264	1617606720000
12719	3NLPEDBF1ywuU2K6Zd9TMbJbSqSo1pVtVKsQCUk6caNqT8JBfrhD	12718	3NKJLbxgDEP5Mqf3h6cNMCkesGtyiMZvJwN3FtX4JkNifL1PQNy8	1406	1393	183	6301	9031	jwqirvcwnf4RW8MkgBEZtR9PZjKxPrJ6zGXbKN1t9MJ1Vj5DhP2	6558	9271	9271	1617607980000
12720	3NKemCJ6Zg48AJAwPwXjRRQXJy7C1zXjvQ3yBFeZbPm3Fio664D6	12719	3NLPEDBF1ywuU2K6Zd9TMbJbSqSo1pVtVKsQCUk6caNqT8JBfrhD	1631	794	183	6301	9032	jwY28PyGEnd9o4KUrEtcezbPpy966NGSNxiLdL9nrNanwozpaRu	6559	9274	9274	1617608520000
12723	3NLr61qQ9Fa1vxusLFYQyDC46VMmANzead3GpRk9WjDgaYnPYC7c	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1508	1387	183	6301	9035	jwGfw9AQigPgws7JEXVGDD5dbv1qk32YCW45apuLtD3Pe7QBAZ1	6561	9277	9277	1617609060000
12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	1631	794	183	6301	9042	jxmyukcUtTyrbqMeRkUW9w585AtbPCZwbZ2Xoz8KwKPWmVDrPu4	6564	9282	9282	1617609960000
12740	3NKyNudip3zyTjpGU8hB5FPnba1iFcJYPfkmKb3CS7vpqtvteka7	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	171	1374	184	6301	9050	jwAmQiB6RJdhpajqWD8hkD4WVMtGqwfDpgk6WUAUAU8SBfmjazm	6568	9286	9286	1617610680000
12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	12737	3NLUccXCGXfk7PUfGyvjKyx3m1KZysaSK5isvBKFvxrs9W3DNXfJ	1577	1327	184	6301	9051	jxVcdaLeUzYnchZEBYUKTcmmcMnkNJ6hAqWvfrKkHgnVp2EtB5j	6569	9287	9287	1617610860000
12752	3NLCsUMfkh2GmmSP35Muj941m1tftcgP9SaSQ6Ad2iWCq48p1sL9	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1503	1277	184	6301	9060	jwVjuAC2DNYAoiiLFproSWb15LxmHJXAxUv4Cpt97ixpC3H9YNc	6574	9297	9297	1617612660000
12754	3NKFiF8hLaTrkkMPHmniJ59E4wFLx2thx373iz9BjqrjsqjQPSNe	12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	1407	1395	184	6301	9062	jwhdQAVbcvPHwYU3s9USQGuhwnXB8H2LkXGSggVFcUmrmFa8aeP	6575	9299	9299	1617613020000
12757	3NKUR2bPz2PYdMLSiJ9mrvb8jj26QtirfSJRnSFGoJc1L8eD1ctE	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1588	1392	184	6301	9065	jxeT9seNNJWQCK76RwbdDbGm5UhzSdkDeQSDjKHaoyyvHdgfrUP	6577	9303	9303	1617613740000
12762	3NL7dFCGK2bEj7CZfxdYV3e7ZgvuxZJqGwwLLLeAH5F6hjaWTXA3	12761	3NLeMVRU8UmWEouJ6jQkwgctLHmmHxurx36LRrFupNkX98Xk5TtQ	1403	786	184	6301	9070	jwWjGgg9cRpyz8Abk727Ya4RsMg9rXgW5LzhiEcqWZiBWPNAGEq	6580	9308	9308	1617614640000
12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	1442	288	184	6301	9077	jwt9e7wxAHTwVQMhiLRr9zLe4m2MnxaxmSJgxPWAWjrVcnXTt8U	6585	9315	9315	1617615900000
12773	3NKEPD4RtrbpAuvNwn1p2qdnqYJCaTHGQ2nECJ4jZpU8o1muW8Fe	12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	1560	1045	184	6301	9080	jxMcfXRJ9UoLVjNLe7ccMEFjDZLriUbU1igDy29uQxMauLcq5mt	6585	9316	9316	1617616080000
12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	1672	1159	184	6301	9087	jxQHnfsqPY3nGAVhvfvUUHwChnZQgxVKXhDufofbHnLJYQrnibU	6589	9321	9321	1617616980000
12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	1422	1337	185	6301	9094	jy3GijGGNTG1JsHjNMkE3fFiRpYVENFcZM7FFSHyvMS9EpAJ6f7	6594	9328	9328	1617618240000
12799	3NL2AKBC5skTSQ3C48VKf1Qmvvtpeg4sVoYKtm5zAotZBhKVTmGt	12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	1601	1262	185	6301	9101	jxgNo4p272yvdisTXAZx5WBMynPic2hA4qwveaLKfoqU2Yf3w2T	6600	9336	9336	1617619680000
12805	3NLopu7F3Wet6xFY63XSXb1pxVJ8qM4cn4oj9M29gCfAdJt9mbEo	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1407	1395	185	6301	9106	jwGzGoSUYZwRTd9e715yzqrwva7vfBfpusFCJwRdDZQ5iUZJRKx	6603	9339	9339	1617620220000
12806	3NKtqw5VYiawKYWrTYuW1UyaUd2mYTecrGHjFYbaP3Xs1dzuweDD	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1402	868	185	6301	9107	jwxFZnsrg1DrjvTD21LcPqfbSFARS2wqaU1nfQVyaTEvpjiGcs8	6604	9340	9340	1617620400000
12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	1403	824	185	6301	9112	jwrcEmuxt5KMpVHT4eGvUSvmApbxj4ycPQer1t8kzp5og8nZoqQ	6606	9342	9342	1617620760000
12816	3NLWdCVUtAKEYf9cqecJigYeX1Mfr7omW31UhdSzTJi7dxm4aBYA	12815	3NKdVJm1PKNabnqDcqEevJkKohJVS2xWS1FpiAikCwSAZYDZ7S5T	1406	1393	185	6301	9117	jwjhSB1HJoSQabE5tqAn9C6sqracnKGNzdLQ7fg9FBuWKHfBZt1	6609	9348	9348	1617621840000
12824	3NLuoJawByuwTcm61fGBwNWTzdbNfMvqSTPckbasPZpcAfMbDwbw	12823	3NKYUJtvvfaoT8jjDy7gzvbFfdfrihnemtTuKVWUegqdGYgz4m27	1637	816	185	6301	9125	jxQdGAGWC7EPMCxpV3jRoGER9sgmATg6PVrmaeGYdrMEKRPEGB5	6615	9355	9355	1617623100000
12827	3NLhaBZdXDcb7HGDUL6vBDHL2iabBTDSYPxZgkboMSLB9ViAPdGg	12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	1673	1368	185	6301	9128	jxE9fvbi8g1QvLN2fx2CNQR9jjh6Ls8fBqLycqe6d9TMZwb2A3f	6617	9357	9357	1617623460000
12829	3NLcwL3DZBrKkUwcdXnwBp4Tka3LEAcDwAiQ51yGqVPpZqGgKBJf	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	1624	1208	185	6301	9130	jx1EXdJE3rpXaNkY9W7TU5pANzL6XKNFWweqVKJ2n9TUj78zFdA	6595	9358	9358	1617623640000
12831	3NKfn5ZxFE672Sx9mw5o9XHvnahPkuhjn9TfRKy3nkzeSfzS5x18	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1467	1376	185	6301	9132	jwpEGtdo1c4prYE2k3kc3m9BnVVjLb9nf5GhucXaPPQE6gj8e8A	6619	9359	9359	1617623820000
12834	3NKsoeVVeLXyBgRcmdEL1bMNw1BCpjfx5rYZP3h9B7fesbTSiGXy	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	470	1183	185	6301	9135	jwPg1sfS5jFRG1SvtbGcbq65ZjQJYdijmdVwLEjU1f3aESwT1JS	6619	9359	9359	1617623820000
12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1406	1393	186	6301	9141	jwv1evdryYjrsxqoUbrwH6s4WkyrmCEfZpAdNUTtVVoNyocZ456	6623	9363	9363	1617624540000
12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	1672	1285	186	6301	9150	jxyL5HLsUPHtSUyArqPFUarQufiLjHySwBkRAozi81WyZi8PdVy	6627	9367	9367	1617625260000
12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1407	1395	183	6301	9005	jxz51k78uW19o5ppjqHp8CwHM7aZtYPpS2PvsKdeWbmHn4ujs73	6545	9251	9251	1617604380000
12695	3NKiunS8BgXV957UFmBThiHsvD98TzdghsKVrR3nPFXq9AiXKNhj	12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	1619	1275	183	6301	9007	jwxwvchJqqgni5mMLTJF3XxgPkiQYxJzgcYKEkju7p5Z87HMyRc	6546	9252	9252	1617604560000
12698	3NL1TG5u3MKuia3x9XTTHbDMvSJN4cVTWtAmNvyrP4HvhLYpfeLQ	12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	1406	1393	183	6301	9010	jxWFWhAAn7f3Rn77f9zQ8f5ySCm5ifMmYFsobvGL51PpiBLFNUu	6548	9255	9255	1617605100000
12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	12699	3NLDdWus1nqi45ZVr5bkXDVmix8bLmp4vGkGQMWjGQvBZUMWumjQ	1455	1332	183	6301	9012	jwjPswZ1FRBthRMw2bby3gfmSLY3QULtMxsG5UHmu4S9aZbvVGs	6550	9257	9257	1617605460000
12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1402	868	183	6301	9017	jxw213g2NkET16az8q8iGBnNmGuENyXYbGc4LYz9UnXgnT29xnW	6553	9261	9261	1617606180000
12710	3NKQB4MNzAYaooz4p2wSSXy8ggo1yJcWV1cqo6rZuujNtH9kUzQp	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	1601	1142	183	6301	9022	jxigSvzUVS9s4gkAParhqg5Q29ucr2ZxfNiwYj9CueSNGz5aN43	6554	9263	9263	1617606540000
12715	3NKUw2JUADonxPgtf41CkGmDfiGTW9TWY8S12HyihC2RjucJejdW	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	1675	1342	183	6301	9027	jwPzpEGFRGtW6Lwu35L1Zr9XbVpjggc7AFWtPGqPjsQDdGYy6W3	6556	9267	9267	1617607260000
12717	3NLSuwTVXfvEcp2B6U58tKMo5PtMguQaD5h7Z1Dk4a1z8qx4RiJ8	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	1631	794	183	6301	9029	jw7RC8Ds3C85FTVdLCEojVvVe8JT5aEb6TNsQr4iweCxeDWNHZw	6556	9267	9267	1617607260000
12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	12720	3NKemCJ6Zg48AJAwPwXjRRQXJy7C1zXjvQ3yBFeZbPm3Fio664D6	1588	1026	183	6301	9033	jwRL9VR7mcXuHwj57hLpSDyGpewmXbN8oUjeA365n3iwxh33JLK	6560	9275	9275	1617608700000
12724	3NKb5pr2oALX4mCS6pV53XDLbSoX4JrpUpnN7bGiHN5j7yCxYaue	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1406	1393	183	6301	9036	jxjS2fwFs8ZbZX5KPffE3HcLawWSQGzEMvZBJgsdGo3UMH4JeTS	6561	9277	9277	1617609060000
12729	3NKxodu4r5RtssNAF16SxiuVUV9y7aZ11oky2c6Vnf9XxZKSp286	12716	3NLoyVPppk2AiC1JULhrRw9Kh23AtJh9TXUNVx4ovHnn8UaiTtND	1675	1096	181	6301	9041	jwK8NXW3DBbsvcnJ5o7GEKma71hLtPBr4jyiqWC8H5bBougLZgT	6481	9282	9282	1617609960000
12731	3NKoxqKimx684QLUpPJdr1tU22BL9uvw5WHbkf4ySUu95H1nckBJ	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1503	1031	183	6301	9043	jw8PgLdwq3pG39W3JBprDdv2pZHN1zNe8gsjnf5ZfwcBocpjCjL	6565	9283	9283	1617610140000
12733	3NKRZLMDiHJThFTCtj55snZuEj8CVUBvoSwE7qhHkWzTcdQN8RUW	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1650	1375	183	6301	9044	jxLWwVAaW4A2M2e48BoCfGKAbqYeB55pkJbadCMQeZTkUbRMt45	6565	9283	9283	1617610140000
12735	3NKbvVL9JSG3oXz8rowv6MTDFtA33UTEGpNFyGqPdSg5uVs6tqkM	12731	3NKoxqKimx684QLUpPJdr1tU22BL9uvw5WHbkf4ySUu95H1nckBJ	1406	1393	183	6301	9046	jwKCoN4qCvTGduQdfFKRc3Mkuhzfm54VgDE1arEdZcMY5L8SnBT	6566	9284	9284	1617610320000
12738	3NKJ7UxmYYdGCoLos1YhhDDdWkh8naqSdV2RgQx8RCGLzD9tj7Jb	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	448	1305	184	6301	9049	jwuBmcVJhLPXVH4AXmxwtkwAbjbLvamWsn5nu2MyLr9biKFSBEz	6568	9286	9286	1617610680000
12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	1608	1289	184	6301	9052	jxWQfGTXfS6E8Vg43xwTbribo8XthUNTNRTh2DjtYgCgXoKjtpd	6570	9288	9288	1617611040000
12745	3NKjY36zWgafE4cwCoKNiF4yjWhJNBwZXcwZFo48eTwqi2Xus2B2	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1403	824	184	6301	9055	jxZ7FuakYmWzsQXFtWQapuGhMJkQCdmBZ4WuUh1oqqhjsk75kF2	6571	9289	9289	1617611220000
12747	3NLXqzJZMG9aW4NYk2gMAX8TihV3AJmnorHyyRPGaKkzfiKgHTAT	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1609	1207	184	6301	9057	jwTgqNfjKBR4dUraBbWuR919w1iW8H69xHTYAY8HDJSbQztdNG3	6572	9291	9291	1617611580000
12749	3NL4ZWnwJ8zw6B7f8ZKYX4PAwNkq27zCn7oQ7oUHyn3VDPYZWLiJ	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1609	1207	184	6301	9057	jwVGpGevWs5MkdR1aeHwfZzLjzcEv2pXeaBrcV7ZPXeKXVuugA4	6572	9291	9291	1617611580000
12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	12749	3NL4ZWnwJ8zw6B7f8ZKYX4PAwNkq27zCn7oQ7oUHyn3VDPYZWLiJ	1553	776	184	6301	9059	jweA2CcFGJzcxWaz9rwcW6X6amg4RTHfxbwzPDRyPKUcwg8URtV	6573	9294	9294	1617612120000
12759	3NLazsJQ5caoteqQ2xhB4cuN8KTs13d8SEeWJoz8tphBdb6UmBgc	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1481	790	184	6301	9067	jwdw3P5XFtPPd8SiExye8hY4jXHMccq2HJ34SD8VoX2CxktWVWh	6577	9303	9303	1617613740000
12761	3NLeMVRU8UmWEouJ6jQkwgctLHmmHxurx36LRrFupNkX98Xk5TtQ	12760	3NL6wcFzMhvC5igvJ8eZDogmeRLRufXRipHxKbSuXEeLgvSnbbtw	1590	1054	184	6301	9069	jxTJbDMrgsQZ1sumDGX5JgZiQeCum8Yhin1QVmhmwaGLxXQZeK2	6579	9307	9307	1617614460000
12764	3NKMpAChr4YyzfshgxgF2Wyh7h9KLFZXxdY8XMYNTBXKTGPj4TQN	12763	3NKfBrmuGxNLaFFujy148icjRbiyhFW92hGcBLDpJBbeHGhKUF8o	1451	926	184	6301	9072	jxSxf6PdreNGbybkftLzGZvZ7UurYXwjrD69gjnUpBjtdyWbcCR	6582	9312	9312	1617615360000
12766	3NLY8VNtzTU7nZTMLD94sbwXtbThdwZfD4fK2qouvFi5SFeYAxFy	12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	1643	1299	177	6301	9074	jx5HH8WMkejQn3pP1D51QC8fjkSFDonqhSH326qLe7dd48CQVF8	6386	9312	9312	1617615421170
12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	532	1303	184	6301	9076	jwUGg7USsbvn68Bvj4fHCbTEzDSSkSBxYRGy3AvwFqt4pw56Fgc	6584	9314	9314	1617615720000
12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1467	1130	184	6301	9078	jwoWrJtQDYbKS9gArbhpMxEibEujTwexpA6pC8T59eP5sDgK6GZ	6586	9316	9316	1617616080000
12778	3NK5BWz53wfNwrYBPnRr2qpdanLTP7PaW5Vw98ghCvYLkXHnB3tD	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1407	1395	184	6301	9084	jwwNiHoe935fmYpDtgcp28jX6g9Yi7Eb99qkdFfCATFuZUtGWEb	6587	9317	9317	1617616260000
12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	1589	1286	185	6301	9088	jwni51xoKtBKzfgx3ZVrvtiGbSNBoWxMWGSgesPkvynLNCDP6wq	6590	9323	9323	1617617340000
12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	12787	3NLudJwCNb7eLHZGnMr32YZ5PZEp6izXVW2HhxyfrKJcaUP4uQJz	1407	1395	185	6301	9093	jxUtLRmokt9fuPmyzsEajq62WXMhwPeCtGunw7m26uqNe2pCGc6	6593	9327	9327	1617618060000
12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	311	1307	185	6301	9095	jx4rRDP9vfgKmsMUg8nwzvGZoh5H68Dh2RQ5dQpKKNkpj7Rp3C3	6595	9331	9331	1617618780000
12793	3NLPw6jVXTjdxZmz8V3QaddoEVAx9mSV3nZ58GyMATdijPL6xQxw	12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	80	1147	185	6301	9096	jxgMsucfqBkpRqpTFojk3yYhhhAz3M5QctFBLfL5fAKKN4eFH6u	6596	9332	9332	1617618960000
12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	12797	3NKpebfjFSaFB8zcZRLrPMERaKq9b7ovXpRCvstHiG2fF58bogSi	1637	816	185	6301	9100	jwDB7LJwnnT7z6G8ggPxwPmNrjLpgjPDTxapX4h8r2R4jnSNHDo	6599	9335	9335	1617619500000
12795	3NKz97txVcYDpDBCyjsm44b1bfpbPConcaTYT32TbdWujmsdmCNa	12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	1600	1372	185	6301	9097	jxmyGZBpqrVAoUqfTd52p7VPewko6fJEDihMdvaszxv1EhEHKa1	6597	9333	9333	1617619140000
12797	3NKpebfjFSaFB8zcZRLrPMERaKq9b7ovXpRCvstHiG2fF58bogSi	12795	3NKz97txVcYDpDBCyjsm44b1bfpbPConcaTYT32TbdWujmsdmCNa	1600	1372	185	6301	9099	jxVv3cWagHnEhj2TcshjcmAjj3WhkUjhCfnZXNK9LpYdWGeyyiT	6598	9334	9334	1617619320000
12800	3NLJ6gA3T3nxWtL3nMLx8tbasZk8kj7vj1zcScpujJTQdmbr5L6i	12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	1407	1395	185	6301	9102	jxobjaFKCAdwHAdRQi86vYrq63MMtjFU5uEtnMCkjRW4pWjA6Mm	6600	9336	9336	1617619680000
12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	12801	3NKjUjmMBGwA8L2TD2mRGW9e1rHrxjtHauP4YazAdtm2sXxb477h	1596	1363	185	6301	9104	jxKCaSem5EJPfzHJRfjT8Vkf3zZ6SAgUN5VCPeJm1s98bPkVzG2	6602	9338	9338	1617620040000
12807	3NLCrFDVi6ca1ANsBRKzsZ7QPZ9nfDPUz8uZcHMChcxU6xTEptYJ	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1657	1218	185	6301	9108	jwcw96jCfntdthEz2t3i1PjEF7o67aFoSQSQVtERK9Z5oggeAQ4	6604	9340	9340	1617620400000
12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	12808	3NLcytqAatgzBePHPeJw4bwbDEoBdJQQmVH7hoYRB1YhVTtQuhQR	1513	1379	185	6301	9110	jxMBQXMYtgBtBm9zZirpqUR58KJXZ2MkRR2KAGuCm8jnVRK9hG1	6605	9341	9341	1617620580000
12812	3NKJ3brEiuPCsDNREqwZHSetvVCWy5Puj74RGmo92x6gCVG2oFzV	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	1458	1323	185	6301	9113	jwpbMWSFWMffjLL3ydXCrh4TSmFGYgHoY4hYas14GgUz7FGFkgz	6607	9345	9345	1617621300000
12817	3NK9suBainM83RWgpe4va3PNvXwc4hxcAka5E1UqmfrrVsbpHcmJ	12729	3NKxodu4r5RtssNAF16SxiuVUV9y7aZ11oky2c6Vnf9XxZKSp286	1675	1096	181	6301	9118	jwztKN7A7EZegDdJP4Ek6Bw687FGpZgjHBdtyvg9D3TqV5hzJVj	6482	9349	9349	1617622020000
12819	3NKPdEy4Cpu3wPL3JkQJuhWNQfAAM2KMVTtHqrSkVCJLxkTvdMxf	12818	3NLyYSa9abQLuHzTdzoDxekkzu2LkQ5uf1hLsjM5CLWhxkNMfvzj	1507	1280	185	6301	9120	jxtiHrk9L7H1Fsyk8cLJyQUvznvzcfsu2dxUApE3HtQ8CCpZVMp	6611	9350	9350	1617622200000
12822	3NKRk7XX4FKsyEwjANRvEV4v4Z7b9dd9fkgF194o1zJSrWAUAAFS	12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	1622	169	185	6301	9123	jxWCH4CwidJjRSS9Q4NnR4sb32CWjVTVVgf4XigZtK1aDxCSMv5	6614	9354	9354	1617622920000
12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1589	1160	185	6301	9133	jx73KzUrqoVaKZURspSM97hCWxDvHTVDKA2bwV5isDSi4Xo2sFW	6619	9359	9359	1617623820000
12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	1451	1292	186	6301	9139	jxuPwHyrrP7vVzhcyF3RyH9cg1pBqW9rJSePKa4szfPqE18aTBy	6622	9362	9362	1617624360000
12843	3NLE6vi8Suv3yicHagfegk57haKBi9Sy6FK7ZUj6JtpM23oMM9r9	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1403	786	186	6301	9142	jx4gFwzup3fdk3Mg4ivdjDj2JV9RYnN7wor77E2k92vdV1P9Y1d	6623	9363	9363	1617624540000
12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	12846	3NKxucCvLLKBkijVCPboWESrRoyuhptezt3Eeyq9fLvi4nv4TF3n	58	1155	186	6301	9146	jxhpUoJcQNNNTxkRXDpYwWyAkb1MC9chMsvaY2f2qnLMPCk9Dy9	6625	9365	9365	1617624900000
12849	3NLgu6T8zbaFBAiok5TCa6L9jNXA5Gj69KTm8EPCBMD6hq2U16sL	12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	1483	205	186	6301	9148	jxRqTQR71cJB2G9MuCbFh5LyhGFfZiLvzkn2QNQcPLJPmhynEwr	6626	9366	9366	1617625080000
12852	3NKMEDSMhexNKftXc3GaPdkkZ1BPEeZ8DwWpnE2BXshk4BHP6t71	12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	1589	1160	186	6301	9151	jxmwiPyhGX5GoeQZQb7JHb3iGWmhPY6qksqDBC7Fnw7zZnMr1Wj	6627	9367	9367	1617625260000
12854	3NLQ16hRFEnY3xq2rqTbLurtoB1eKQ2aWyR7spG5nrTPLG7jQKk5	12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	1637	816	186	6301	9153	jwW69Pf9k1mcEsFoyapKn98fDf3vLj8FQyyLtNKk3Yzr38zGeoQ	6628	9368	9368	1617625440000
12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	1403	824	186	6301	9156	jy2Y9JDNiKpWVSBtMZTLz3jDQpa1u27oTYtvsN8Vy353CvuRiSG	6630	9371	9371	1617625980000
12859	3NL69wSaCCErKJWQyoAhXDDoo4Uop5B36vrKzPpqpBy3WYh18qWV	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	1646	451	186	6301	9158	jwkbvsoUawu8dvRJfvpwxwf89k3ptppLdfHrV8Siumxkk4F5iCH	6631	9372	9372	1617626160000
12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	12865	3NKx3TNCMfeLN9K3hYcvSjA6xABnynLYcQ7SniYJgk8nbfoetiKQ	1553	776	186	6301	9165	jxic3sEHdpT67vB27ztbeEmJ2mRi7bCaUYbJxp65sFihf7cYjMY	6634	9381	9381	1617627780000
12867	3NKWJXeVHPdEr928DRrYyyk1USmDkyaT6jDPmGrjyz3g5LhY6SVn	12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	1467	1130	186	6301	9166	jwALn2QWCwRa6BiZxMVFgF5jg3yzur8rZ4aY4vSqV7ryw5CjXYE	6635	9385	9385	1617628500000
12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	12869	3NLTL9TxEQKo4gapqzy1QQsuQjnKV96aNETTsoofYqsJSaXDTJ2U	1407	1395	186	6301	9169	jx1L6pFRQvTjEqq5sdgEV5EmgBVGS8zypdpt4hhnFrJE5EwC6qH	6637	9390	9390	1617629400000
12873	3NKNKZynpBAsiK7xeXwbxCZdRyXSZGNzuxhw4fXwX45cNfcQBXGs	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1637	816	186	6301	9172	jwTnRAu2cCLUPGj5jefzec2STGnHe53yA6dSBCJ3bwQceziSXxA	6638	9391	9391	1617629580000
12876	3NLiHnSapJaZtQL8KwxpQyHyqe3zSyfmNiL79dwLapMMjZiMF86R	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	1596	1117	186	6301	9175	jwr4p6sJFz9zkfh1fmTkNXhugd51MHRmc2Wf2kHYtaYsUubwcX1	6639	9393	9393	1617629940000
12877	3NLEc3ywQa8fAXXyC6rBS71tgrTw88P9DVrAwTbMvbrYf1eFGKag	12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	152	1330	186	6301	9176	jxdPAYMHhgZxUBFYQtKzZ5hNh7vLNcTv35Gwzoo1bdyz77pxMDc	6640	9394	9394	1617630120000
12880	3NLkJYvm5kzgHM4oE7S2zLZiAdmWRbQRnWuV4c7BFPzrboHxJ7i5	12848	3NKPF33CfH3URkMP9PeuYmrN3cLR14MsBgGphJCLjjUL3s9WCGan	58	1281	185	6301	9179	jx5YU4tmNGrBrLHNTvhf29v64xr1Z1UtvfJjBa3zKD1fUmSpSAV	6586	9395	9395	1617630300000
12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1671	1239	186	6301	9181	jxzatUsuYXqsFu67huUAFAcTENpMJ21rPBb1b8hnk1p9sJFZbwn	6642	9396	9396	1617630480000
12884	3NKY391eoM6aQuNk6FeuYGLqUefabuBafnvbv85GmxnXxRWYfnKC	12669	3NK3iczmFnnusyneCnjBCydmtmpEWN2MT3k7HfceYz8NamCV5XxC	1671	1239	179	6301	9183	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6467	9396	9396	1617630480000
12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1622	1356	186	6301	9185	jxKdLGRzgHaT3fGxPGsKtPoZpssrWbCq4SKmojjMwLoaA2NRHMp	6643	9397	9397	1617630660000
12888	3NKWnuzRY3XfLaNS3bEWGy6AdM696wy5dmVEsqzGxUJj3oRSYfZi	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000
12890	3NKSZpP8j1uWQ1sHmkNdi1UkTeDbMm8NQwkJJp8xtLKY1D17BKk1	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000
12891	3NKJbeRdngViVPqFHt68zedab3xrW2pZJs8eadfvF6w6dYxqADaC	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	162	162	187	6301	9186	jxfPRvqYppCL3tyN7kPDvmJN63Vqqb1op8rED4bLVWpJNb6jxth	6644	9398	9398	1617630840000
12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1503	911	185	6301	9105	jxUCPMWJJq1q8q8oaNqiLNh52fdsSaACSX3Z7SrvbkYwP5GEifv	6603	9339	9339	1617620220000
12813	3NKtp3KMkqSq5ZXjqZk6wNF6Y3Lwjc9sSJ5d4anT8wqMqz78BwMw	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	1501	1360	185	6301	9114	jwfbkhtG3ctQrwmZEvuKjQfMnnRWL7UEbjjzrgESxVBDaXoQ4DG	6607	9345	9345	1617621300000
12815	3NKdVJm1PKNabnqDcqEevJkKohJVS2xWS1FpiAikCwSAZYDZ7S5T	12813	3NKtp3KMkqSq5ZXjqZk6wNF6Y3Lwjc9sSJ5d4anT8wqMqz78BwMw	1451	1292	185	6301	9116	jwDtFak6DLidwY2dsUjoqAB8FBgCeKkM9Qph6CbREuBh3EdouJP	6608	9347	9347	1617621660000
12818	3NLyYSa9abQLuHzTdzoDxekkzu2LkQ5uf1hLsjM5CLWhxkNMfvzj	12816	3NLWdCVUtAKEYf9cqecJigYeX1Mfr7omW31UhdSzTJi7dxm4aBYA	1675	1096	185	6301	9119	jxJ3eBftBt2JvAAQgeEQHLyVxTNwqrqxaQfEPESb7gh9qocN1Dd	6610	9349	9349	1617622020000
12820	3NKwQBMh9EXSKg4NCaXNFKxFXBPQYhE7fiUsVye6iqBwHdfWm9Yj	12819	3NKPdEy4Cpu3wPL3JkQJuhWNQfAAM2KMVTtHqrSkVCJLxkTvdMxf	1648	918	185	6301	9121	jxFKJBLYAf9vcGPettv2Dvtm3BFDkm2cfmgcTBdXbp4tLmcLJn4	6612	9351	9351	1617622380000
12823	3NKYUJtvvfaoT8jjDy7gzvbFfdfrihnemtTuKVWUegqdGYgz4m27	12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	1560	331	185	6301	9124	jxzSGf7ktjVE54u25tC768XDomwgXnVHEFF2QsUUeg62J5Y8392	6614	9354	9354	1617622920000
12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	12824	3NLuoJawByuwTcm61fGBwNWTzdbNfMvqSTPckbasPZpcAfMbDwbw	1546	1339	185	6301	9126	jwvqwsbukGWt7LLmRgHQ5MQV1FfCtGSj8tmT42wQNrAx5AJbBb7	6616	9356	9356	1617623280000
12833	3NLZ2x8TsXV6QxUyavW4g7UcHVpQGBzJcNjphv3ZZ7kkZ44v6bE9	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1407	1395	185	6301	9134	jxL4wJK4HuM1HJEYXduzKz17g79G6gf8sGkY8vVqoyZCZ9iZLXC	6619	9359	9359	1617623820000
12835	3NKJB3xuLgqiAYSzvyN2LsCW9cawUpRTA2RoKd4CGvVQAyNXYc6D	12830	3NKdqdpNdX44AjAQn2P98mxLspN1w6vq2iVRpiBZF5GguVXm2TkA	470	1183	185	6301	9136	jwKMtHEG5zgU1KBqCUwBJ7KSKHdE8kCgiieCw9xrh9D7ZXmPYzW	6619	9359	9359	1617623820000
12836	3NLU8ujHn3Tu9mmEz416fThjQmATrqZaePFZgzazofJgKqZwmGVx	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	186	6301	9137	jwSBSRivyczVyWE92LRbHkXgj7zVSqvnrZ4MszkHawZm67My9D9	6620	9360	9360	1617624000000
12838	3NKNGvstYHMgMBAHubmfbiq4pTe9LbZdeYuCStcMahzaXLMXtgrr	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	186	6301	9137	jx4uChEm2kzVHfSqdGLVctTV34rxS3CcoedJqYhFWW3wghbXpjQ	6620	9360	9360	1617624000000
12841	3NLnp7QJhXNp761MeByrCk3USxxLDSinHWc7oUjqfpKDupWYm8Tb	12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	171	1374	186	6301	9140	jwRoimPa5TWJbRGXHchyWmhETSDx3f1WzPTYpaHoafn1JvZ6kbr	6622	9362	9362	1617624360000
12844	3NL3S2DTcPbDNAMZpipDgJktSoTJGjenfXmYPGX7PuqBiTbYfu7o	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1407	1395	186	6301	9143	jwox9Fhe9hifwBfvAfzAupuLVEsGSYjUNJXnmuojFNX2VJ4Agrm	6623	9363	9363	1617624540000
12845	3NLCknUgzXoQFP9CtUbk7BUJYHGVikzMFt1JyxtyqdmGYXC294J3	12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	1657	1098	186	6301	9144	jwtqcPu9K9QQp2PoAhXKGFmUHvLSSuB7BHAL24P1U8iZ2Kcjoz2	6624	9364	9364	1617624720000
12862	3NLcXdTJHBboVhKzeBMhCzxCJc1ddvQX8UYvQZiGZiMB6NoRZi6N	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	1553	776	186	6301	9161	jxki947MJ5djmxdpkR7aHczuEygkpXbWm6nDnTQTbYnSpNpKM8T	6631	9372	9372	1617626160000
12868	3NLUnWdMUt6DzYL1F9rs75qaBxFHZXe9dTaXuMPHYZQfi84o6Pac	12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	633	1384	186	6301	9167	jwd5U4qJD9uw1dud3RmFE9H7ojEF1rGnnhjAtd3FU1thJ67WzrW	6635	9385	9385	1617628500000
12871	3NKYTBwPoi7yrYDcgfNqWrukKcAJeFRyBea5LSDMd8CwVa2i8MrL	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1406	1393	186	6301	9170	jwQMzF6KdLYoa79vgWjgwew2CbcZYhJMGzrWyWzW1durYN7Kd62	6638	9391	9391	1617629580000
12878	3NLg8udHQGQbRQL6FhX2dRkELegpBZFXNAykyfMyiFDvyyVgGA89	12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	1594	960	186	6301	9177	jwjdHHVpQHkFAGM8KXwLnw2xvQGWUW2GSRuVtKVNuRzqLMSvzYs	6640	9394	9394	1617630120000
12889	3NK6HCEAXaeePHpbVjh9b1DVCsmxnRyF8R3QyHstmyqenSmEb4g7	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000
12892	3NKfsT4VzRP1aegCM4MFEn5davd6kXQJvipNFQ1ddwhcyYQA6ERq	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	1627	1385	186	6301	9188	jxXd3SLavN1o4jDjiVKGj7SH4AoBgHgtxE8Q6yGnmyC4UdvdVqF	6644	9398	9398	1617630840000
12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	12888	3NKWnuzRY3XfLaNS3bEWGy6AdM696wy5dmVEsqzGxUJj3oRSYfZi	1509	1194	187	6301	9189	jxhUy7DjP2UgCMXS1TmkUNvT4sovFtdVKDjXxi7xePwjEg34Lu5	6645	9399	9399	1617631020000
12900	3NLpGpaEgfSQJzLcBDewKCifaNqkn9ks3Kf6nt7TEAhppXfWXaG7	12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	1406	1393	187	6301	9196	jxDWMts6RWKaBnBaVxyS3f7HpcktF3De11V191vrM7xCs72hEE8	6649	9403	9403	1617631740000
12903	3NK7bb9N72hGUP6jhMoHrSp5oTczcXqKJw5UZkPSzmWep8325H6z	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1509	1074	187	6301	9199	jxWUnBdGEE2Bd5v82BbKAdyeGWKqdyoJnv7B6zwG1AVwgeQYVf5	6650	9405	9405	1617632100000
12913	3NLg6DyA9YskYcAQtvryxHjUAS9WVWjgRyukve1JJRCLWLFxdrAL	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1553	776	187	6301	9209	jwFRZJFGBnu8tWiP7qwhLnDJJuVvchiYgb4B6yRs3KC9oQnDoQd	6655	9414	9414	1617633720000
12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	1560	1291	187	6301	9211	jxcmpHgzBduMBjTjjbpXwaZR2jvZasQjdHumQ2evFimRc9Vtsh7	6656	9415	9415	1617633900000
12921	3NLFDqRYurAE5u9cbc5oSBbeC5thGP9nEpJZFyQc9hWQ3yYGnLSX	12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	1407	1395	187	6301	9217	jwGPCx1J3tn8qtiGH6AkRhWFTqKuM5CM8sCZj29KUGcKXNsNX3w	6659	9419	9419	1617634620000
12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	1406	1393	187	6301	9219	jxoZ9PMxDvaz56a2UY7e2oD85sU2kNieCWLYR1FZQDW5nMk84im	6661	9421	9421	1617634980000
12926	3NK63grYAof2QwaSv96BT2idZ8dRsZQKXx6r8zZ2oU74C7o5XEn6	12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	641	1336	187	6301	9222	jwNPnXH1qN785WMCLQKqUZZCcHoB247XRWaU68L5WYRgmoh5jNY	6662	9423	9423	1617635340000
12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	58	1281	187	6301	9224	jwQUBgpmcx2nYnscHQfTpC8XKtVEqtBgvXWV4SC2e7hf9v5GBxW	6664	9425	9425	1617635700000
12932	3NLbiT82NQYKZFawdAptQzGJ3sqQwACAHcvQorfDEkZMkK3pmUjn	12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	1608	1043	187	6301	9228	jxbrD9KJMmYcA7sc6RwTEZxakQF2tRqwfr7TMmTytNB7q5sGQKE	6665	9426	9426	1617635880000
12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	1651	1301	187	6301	9235	jw8Kou9KwY4tGzX4zqTVEGuxB5nAvmVgttBtMe9o2qpYeT1F5Fe	6669	9433	9433	1617637140000
12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	1602	1243	187	6301	9236	jxxAHipHg6c7huCaxDu7aZdTfkEznj4GMK59t4g1DJGq5UtNNJ1	6670	9434	9434	1617637320000
12804	3NLtMMbHrG6TLiDv1PT7nRiAY6fpPfaeE6YbVJ5C9i7xkD1RPkdn	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1503	911	185	6301	9105	jwsAETfDaKqN4DaxkQ6NTTr9bwadGoWmvDHonrddvnAbrrbvehA	6603	9339	9339	1617620220000
12808	3NLcytqAatgzBePHPeJw4bwbDEoBdJQQmVH7hoYRB1YhVTtQuhQR	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1553	776	185	6301	9109	jwY8RTt6qEK9u8yqkJ3boBjNb73mLJPmnVpXrYoxiQokRQVxYq6	6604	9340	9340	1617620400000
12810	3NKGtrEo8xKpk9Qvbmije1S9GjVcHMbJ4iAFk5cMEi9L6CcqysfX	12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	1406	1393	185	6301	9111	jxMFH7WYDqYhTQwEdCfuJqLPUPdVESELZbruqJEeRRGX6h8MXWD	6606	9342	9342	1617620760000
12814	3NKVnDVifL4WqjcPj5QiTmD2LdChzNXZxAVZeH5P4pSMJ4eEd8Wx	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	149	1157	185	6301	9115	jwNBCZH64Fni1WyW9JyGYZ4CcUrfC6mKGYeAkKCrRUAu3abjx4Z	6607	9345	9345	1617621300000
12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	12820	3NKwQBMh9EXSKg4NCaXNFKxFXBPQYhE7fiUsVye6iqBwHdfWm9Yj	1407	1395	185	6301	9122	jwVPPFSxirCDBVUoJos6Vwi2h8TPatt8TKyMU5tNTtQj3vojp77	6613	9353	9353	1617622740000
12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	1403	824	185	6301	9127	jwvSXTa8QD34177eQumcjUnhkLWuHmwPAe1AQxMAsubSqWPsZXy	6617	9357	9357	1617623460000
12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	1406	1393	185	6301	9129	jwaW78PEAy7WBToACKNotVJJ6VX2cwvGm7QXTMwkQyPHyxbPQoP	6618	9358	9358	1617623640000
12830	3NKdqdpNdX44AjAQn2P98mxLspN1w6vq2iVRpiBZF5GguVXm2TkA	12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	1624	1208	185	6301	9131	jxH3fA6TriYM3kpnHiefHMCyBNvgWbiJHBU1sQD1LRxctZ6n4ej	6618	9358	9358	1617623640000
12837	3NLAhmQdt71XXxFWVoDLuGx3bDeSe3yTSayuTP1M3KayGujNnX7i	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	185	6301	9137	jxNXnyS6rPirbEyjeEsLrQN9Yo56EqWwfmrRoBGLSMXjAUKMS7K	6620	9360	9360	1617624000000
12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	12837	3NLAhmQdt71XXxFWVoDLuGx3bDeSe3yTSayuTP1M3KayGujNnX7i	1405	867	186	6301	9138	jxk8FYXDi6YfZS6QvgDQfqAxAsDg5SETof9p11XftXyivkvDcmM	6621	9361	9361	1617624180000
12846	3NKxucCvLLKBkijVCPboWESrRoyuhptezt3Eeyq9fLvi4nv4TF3n	12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	1403	824	186	6301	9145	jxiA9nSxuJJQgK4YnRv3QiwHwUwJHMFCNAtLVkUWhE1KvMinTES	6624	9364	9364	1617624720000
12848	3NKPF33CfH3URkMP9PeuYmrN3cLR14MsBgGphJCLjjUL3s9WCGan	12768	3NLjZGLP7VAJzu5JZZMp8SaQJZL34TFcrhb61prt6RvT3qdka7mJ	58	1155	184	6301	9147	jx1NC7NDwL3DRPUgt64bjbnsf67C2KCgpL6nMsqiGEntZ2DHhcZ	6585	9365	9365	1617624900000
12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	1481	790	186	6301	9149	jwzNUgS1hSWji6YsLZsXvt5KfjtuscccD7MeKPhMP46BtTMzSXw	6626	9366	9366	1617625080000
12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	12853	3NLHUfuQzD8r8s3EJnLCMfA5KF9U9psNkP7AdXNd6jcVXGNYpWPE	1637	816	186	6301	9154	jxCwzK1gg8JUCTGZgoh6vgn8SDHr7xKVZczWByDmWHtkatob62W	6629	9369	9369	1617625620000
12860	3NL2FAVcDmqFTuB4txAuF5TbGR6nEjXWGbYcH84ng81bBhPwfybz	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	470	943	186	6301	9159	jxjQX1GcQkHNGePhE6nyprmhQF9ULUE8XEhGMgLk7kvfUDYEu4R	6631	9372	9372	1617626160000
12863	3NK7QW9r3LvjHb3eDP3dA8xEYZeXsULtqnCCttyY18C5bUUrUP1Y	12862	3NLcXdTJHBboVhKzeBMhCzxCJc1ddvQX8UYvQZiGZiMB6NoRZi6N	1553	776	186	6301	9162	jx8wa8tKDsvcuAZc33RGSfArTjGMQ3kjyEoiZT9md4Yx7PA6QSN	6632	9375	9375	1617626700000
12864	3NKUYWJcvkuPwSQLyydPStFDTkGLoziCUa3i44ECL47TVf1MAhCz	12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	1447	1345	186	6301	9163	jxH5L3vVyWmWRpvtYUoiVozg5PYVHypmb2Eo3dDtchJNrWE4mUB	6633	9378	9378	1617627240000
12869	3NLTL9TxEQKo4gapqzy1QQsuQjnKV96aNETTsoofYqsJSaXDTJ2U	12867	3NKWJXeVHPdEr928DRrYyyk1USmDkyaT6jDPmGrjyz3g5LhY6SVn	684	1226	186	6301	9168	jxD7SqzPxbJqegrmmSKtZ4JEa6KT4bUUXpsYFaFjDFp6r2JMkqu	6636	9389	9389	1617629220000
12874	3NKRUM8mTMobcsUWYATdQXgy7FxfB2qTqHHKZxZvjQt3ivyX1gZw	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	1402	874	186	6301	9173	jwpeZXvpqPA1xP7FnWtgtWtiDEd8jQt8UrPHpk6kfvU3HVKmHMC	6639	9393	9393	1617629940000
12883	3NL1D9jfyqRMgJpgYEi5tVyN9exd579Juc1jBd3swp2PE3s4qZ1o	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1590	1300	186	6301	9182	jwg6E5fSzwuoEtXPpKJsCPRxSkMJYavcmLCXS1S9W6g2MBtyS24	6642	9396	9396	1617630480000
12885	3NK9549QRTLQX4o71FzFFBT9n2a91B1TqaDAJzbHg5w5ZvdNM8mj	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1406	1393	186	6301	9184	jxQt5JckRSZ38kxPTTnMYA79ebbYS36ggo4QDUU8QJisbu8Y5cn	6643	9397	9397	1617630660000
12887	3NK9Pt5gdWZZfbMBcLSJGMb9HtUtVfmbqjYoJ5F9gasja2dxiDN5	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	162	162	187	6301	9186	jxfPRvqYppCL3tyN7kPDvmJN63Vqqb1op8rED4bLVWpJNb6jxth	6644	9398	9398	1617630840000
12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	1672	919	187	6301	9194	jxoWaWeJa2EZDnPJVqtTPioJU7xLK5BYJLZYpi8KZvUk1cgzpoV	6648	9402	9402	1617631560000
12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	1460	523	187	6301	9197	jxNHh1nEkFxwtoT9sDBSSYeyYJJMz5NNvCEBD3Zd94Qd6mHHFtT	6649	9403	9403	1617631740000
12904	3NKdW3mDUf3HAnzkoZ3ttdpHbGTAQ5xQJNvm6MAiNMRyCCuJgLtG	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1673	1002	187	6301	9200	jx22xii3heqsXgq8xsLuGBNLf52zChhNnzg3dvKaRY17sx9V9xt	6650	9405	9405	1617632100000
12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	12903	3NK7bb9N72hGUP6jhMoHrSp5oTczcXqKJw5UZkPSzmWep8325H6z	1668	1244	187	6301	9201	jwRWWFPH3cZiFKeCdgEDZ7gQofsP6kYdAqcScg1QktSyTJXsTR2	6651	9406	9406	1617632280000
12908	3NLGfrsq96zeAQGKz5YbMgFqv5788jSHDVGb9ruXDur5m2vQPeFf	12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	1656	977	187	6301	9204	jxCrsexjvxAyt58y5BmNVKNDtCqS6g5eeM8x7e7GD4Dqgewuzfj	6653	9409	9409	1617632820000
12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	12908	3NLGfrsq96zeAQGKz5YbMgFqv5788jSHDVGb9ruXDur5m2vQPeFf	1458	1323	187	6301	9206	jxb83xeF7kj2frrzaBizS6A2cWDsyosaXvatGLF5btBV15G1WN9	6654	9410	9410	1617633000000
12911	3NLxhh1N6dFg8kzpr3XMx4HG22EL755JfTYuFZmoWpx7hiUZ4YUM	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1546	973	187	6301	9207	jxPAghzELos3XiApPK8e2kjEn26QBjcrtaU16vwptBtYUQ1hkzw	6655	9414	9414	1617633720000
12924	3NLpEcdkdNhh1hqfWSAGU1GbQa3Mb9tgygSyuGCmemFREpouQa5o	12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	1637	816	187	6301	9220	jwXZ3Akhm7ELDqNqGQhzeW734qbRvYnzzdgJTTejwdJ41vw9Z6F	6661	9421	9421	1617634980000
12929	3NLhQ1n3th6wkQ9LBg7X3NrVBdzVQ8tuShwU5RMU2WUoUX6CEokF	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	1508	1021	187	6301	9225	jwdQhFt27LnBzc5ApMCX7WrQjmeCDfwA6s9H32mNh51BCfxLC8N	6664	9425	9425	1617635700000
12931	3NLPVdwYuqKMhTXrdFCe3trgPD9dCmTsHVbscPtHGrAqNVzaJbZ3	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	1631	794	187	6301	9227	jxQySiSmWH1LuKGcyLpJpumyYU3q4JPWVSxxQPMZwmrNvCUDjZx	6664	9425	9425	1617635700000
12853	3NLHUfuQzD8r8s3EJnLCMfA5KF9U9psNkP7AdXNd6jcVXGNYpWPE	12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	1406	1393	186	6301	9152	jxyTsMH3FriEBvtiNWCrUeo5cYVqgY1dY5ahxJKonxuRaT2KYRw	6628	9368	9368	1617625440000
12856	3NLNyqAPwz3bUWKFXbsQzxTsutYDuAmRaTdxCzh5Afyv6GTexejn	12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	1406	1393	186	6301	9155	jxud8fkHz2Y3SYtDJTZCU3gPbhX6MpDu4wTHcAfQ54sjvUC3C26	6630	9371	9371	1617625980000
12858	3NLFodCz1FwYv5d2kMFYuLRRwo97cWcbhLPvwHfhJ6Xd8URcCmy7	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	684	1352	186	6301	9157	jwPHfd9KZUuh6BaHzfjjoqMsjZStX7oNqBFBRS4rCXNW8BhMTuh	6631	9372	9372	1617626160000
12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	12860	3NL2FAVcDmqFTuB4txAuF5TbGR6nEjXWGbYcH84ng81bBhPwfybz	1596	1237	186	6301	9160	jxK3JcNcDyUx5yYRQ9VKGKEbPcRs3YYALM2kZEhWac9TtgyN3Br	6632	9375	9375	1617626700000
12865	3NKx3TNCMfeLN9K3hYcvSjA6xABnynLYcQ7SniYJgk8nbfoetiKQ	12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	1585	1120	186	6301	9164	jxwD8huFD69RdFkfemKL4GGrNCwXHcyvK3S7uecYyo3K4JK7hJa	6633	9378	9378	1617627240000
12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1646	1228	186	6301	9171	jwGmx1M2Dfi3zUHsaU2s3YoeVj7189YUv8N8LorebbjPWrEXxX6	6638	9391	9391	1617629580000
12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	632	1016	186	6301	9174	jwW3sdkQiU3PHXiooSXQo5pPM11GGPmPxdahdroj4dwUTngKihP	6639	9393	9393	1617629940000
12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	12877	3NLEc3ywQa8fAXXyC6rBS71tgrTw88P9DVrAwTbMvbrYf1eFGKag	58	1281	186	6301	9178	jwKssBW9tsyEV6XVndy93A324GxmAGPDaQJ5jeGonovVUbdauNi	6641	9395	9395	1617630300000
12881	3NKwcmoQzbmh98ApAkuTaUgv1uHWoEH8Q1MBG6oyfLbJAbtpNVHf	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1402	852	186	6301	9180	jwSBZPpmvmQGUt6rFzpHKape57kU2MWpd4jGMQnwwHcNCA6Jd8Q	6642	9396	9396	1617630480000
12895	3NKyhuCtGordXujvEaBPcpWkn6gVHwusFbcbLykMyFk64EU9f9va	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	700	840	187	6301	9191	jw6tMKRxx79nPW2dmXN6U7HJQcjKYPHgZrpxdq3Zgxk9ExuAmhX	6646	9400	9400	1617631200000
12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	12896	3NLRdvNWeveqHhzbBjMwCm4B4QMuzYdLGfcpqHUiuPfLoy9327wb	1666	669	187	6301	9193	jw6wDfPJctkB7TsJ1L4tGxU1gDdaa3XXr75c113auxTntSZrRxS	6647	9401	9401	1617631380000
12902	3NKfPzdcgbFSh47ekXu1dCK6hxcj7z3UR2TcSBVMQbLQEADLg6ZA	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1503	1277	187	6301	9198	jwm5rKKcbnGf6j3BJpmkeG9dPAnTU2cQMHgEmqqoqvvQEqvEeXT	6650	9405	9405	1617632100000
12907	3NLWRhZt3C63oN5LhWYPEcGp27E5CbMF4HTw5TVr3Zj6WBDdi9un	12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	1555	1347	187	6301	9203	jwycRdijhhbWfMDZvZUrxLqkWS7ncHXnwJbAV9MaA4PZE2URtYc	6652	9408	9408	1617632640000
12909	3NLuBtESa8Ycj1B8VoJWwKaN12N3K7U99peF5ijVaz7x67qdMWNC	12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	1617	1288	187	6301	9205	jxswVJtRt7PV8d2kSLzANTLSgFpLYzD3sS9iefYhBySVBdcrgTm	6653	9409	9409	1617632820000
12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1407	1395	187	6301	9208	jxzshuZHZunQ2vs3Rw9N9zqm1wnCR61d8CtRRbwgMJiE7kWLq1E	6655	9414	9414	1617633720000
12918	3NLSCn3HcevBsAq3vCrNt2ryfVDkG1NHYutw857X53NvvyyARUjH	12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	1405	873	187	6301	9214	jxMqJDhjkAGLs4HaEBcBGbsffafD5dV5p3VupiUytBCrrvDLy4p	6657	9417	9417	1617634260000
12920	3NKU63PFJ8t7AZeibTq4PgMPMHQp3DvaLqaCohXjdfeDCz3eAoGH	12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	1406	1393	187	6301	9216	jwUowNMS1nFuh1ZKFJr1vG1oP8k2oTKzsRn5suxUqC6YXF3tYA1	6659	9419	9419	1617634620000
12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	12920	3NKU63PFJ8t7AZeibTq4PgMPMHQp3DvaLqaCohXjdfeDCz3eAoGH	1406	1393	187	6301	9218	jwfz7BKRWJ9YMkDG18GAvnbDUvaieMVd3tuqAvWDvLuz7YfcnfV	6660	9420	9420	1617634800000
12925	3NL1hhThYtt5nN6hio1DDBBU7a4qWUw2GArh8VAKaVMFUshAQqjw	12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	1613	1349	187	6301	9221	jxnE6PZCPFxQfZTRRVCZPt7XL2zCu8pkSAqkCaT8QmSX3YP8yDB	6662	9423	9423	1617635340000
12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	12925	3NL1hhThYtt5nN6hio1DDBBU7a4qWUw2GArh8VAKaVMFUshAQqjw	1402	870	187	6301	9223	jwN4iWQ6FcobaZuYZsNsZWKuaeHZBwSy7oGNA7JgNYHbJL9ThSn	6663	9424	9424	1617635520000
12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	12933	3NLY1j7DtAczCbEAKL4bWf2UAXykMZkhKZ2wCWrNC7oFZ6hnsthb	1588	1392	187	6301	9230	jwRUvjFEkGFRheP69MXJB8SATPKkrx8prp9t54WXfYF1rYk8wGi	6666	9427	9427	1617636060000
12935	3NLmw8qWwkoqANYe5sT5BNSogG8NceCpxvo7fpsswJ4BmYE82on3	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1403	824	187	6301	9231	jxpa6ooDKyVZQTdjocvgCrmWFyHb9vvqe9Lf34jfpMDbhScMisE	6667	9431	9431	1617636780000
12937	3NKRBk3a7nBq1Sg3rLaCHgBt8MsTyFcfVU4gJ2bgRdJjm6JvGR1f	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1631	793	187	6301	9233	jxR5vLv5u7HTh9r3NLR4b9yTAn3jqeVayvfDDXRBZuxFyf93L1U	6667	9431	9431	1617636780000
12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	1623	830	187	6301	9238	jxpT45SeKoa6SCEeYZTqrA1M6DRtTPZ4FN9q11pVcyrRqXXYBPt	6671	9435	9435	1617637500000
12950	3NLf2p4QGLMkh5nTUu5aGNZHhChdWzDedt83ajkMSAZC8uPG3HU9	12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	1406	1393	188	6301	9243	jxtGQWMmG1JMezAKN1U8FnHPo5BG9mrazbbB4heBK46UxFSpRgP	6676	9441	9441	1617638580000
12952	3NKS7BFYM7g4MedWFhSmpi5AUDiTPZzytBraC49RvCZTbe224NrT	12951	3NL2PeuXYoS4666U614TSpeoMUZYTEQqz3YKC7NCmJeo8KXLZULf	1613	1349	188	6301	9245	jxemvzeqG1Xv3eXsc6hf12K1Y3FiU9BzBGnhqsDibt4VZ5dmm1p	6677	9442	9442	1617638760000
12955	3NLANfBCC5HvBKbqoSZmP76BvusAxS51vqsw7WyYofVR5isXD7ZK	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	80	1147	188	6301	9248	jwZGxpBo7Un6EuPAyVjHhsDh5uEr6yuro8xhwDftm1hV1YoZgUQ	6680	9445	9445	1617639300000
12963	3NKhqfz7ti424EGu3UdHH4QAVAxw1zujhK8yydV1v2o89ejYb7jP	12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	1671	1365	188	6301	9255	jwjZLrtkTLQKEH5Eet3XCw46UuqbLdZVsCwLnfu8iTUktbjj3fZ	6685	9454	9454	1617640920000
12970	3NK91zKu6tLDTUgX5G8CeLsQsEjjfNdi221wwAXZCxCJ4igpyQzo	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jwJptg5hTCFxUZSgZVKnNWknmb39KtLLGhQyP9Rp6ousRCKDNz3	6689	9458	9458	1617641640000
12974	3NKweTz7AakvBZrrg9WnFuzvjMnGTf2LX1wzJTuKhaXjyssWPpPC	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jxnEv7QLiDyCBwQCQFevsGaeA5X3ykCBiS59XR8GfRjCZXzvYET	6689	9458	9458	1617641640000
12977	3NKJvAK6ViFj2zPEqw5zTw1YP7YoSYUBfdpAcDD4khZ4UKh1gDYG	12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	1476	1125	188	6301	9267	jxfFACeiQdqTc6pjjxmKs2cfbVtwG2rayd68Wz2gnVLbZmBtCTa	6691	9461	9461	1617642180000
12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	12977	3NKJvAK6ViFj2zPEqw5zTw1YP7YoSYUBfdpAcDD4khZ4UKh1gDYG	1559	1107	188	6301	9269	jwBdHGcZCwKP5KfuP6eTxsca5BkDreaqc48x1J99BehWsCAFvxP	6692	9462	9462	1617642360000
12894	3NLVqELsng16F6YKMnXsWdQor2gRd4FUquoFqrPdJKoMuBZ7fKRe	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	1406	1393	187	6301	9190	jwquJVYMn1JZXKpdfhx4DwCxisRDDhAPeMajGHBbnhgkwS6DmDr	6646	9400	9400	1617631200000
12896	3NLRdvNWeveqHhzbBjMwCm4B4QMuzYdLGfcpqHUiuPfLoy9327wb	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	1601	1388	187	6301	9192	jwtKBBPWctLEzpiUpiMiykcrH9JTaAZZ3L7CdqZd9wzuLGMLrSA	6646	9400	9400	1617631200000
12899	3NLbtXVY2u6VUzWvRQ7hXvvwpLPphUbSzodL33piXs1macng3dfw	12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	1407	1395	187	6301	9195	jwZzLbtVzBYmePbeYppU9LUurkGX6p34aKpAcbZTMdaQTaZtRni	6648	9402	9402	1617631560000
12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	1541	1052	187	6301	9202	jwMEbbkUKs35Lt8kS2NeihMnJTvRQ7UTTNFzhisiAKTd5cNjgen	6652	9408	9408	1617632640000
12914	3NL9fbuNX66xSeKXo7j3fnoaHpt9CFKWKCHh5h4EH9YsqfchGmSm	12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	1406	1393	187	6301	9210	jwSwgP1jG9KgyBWKDeVmNLYs2mAsyxwKFahh2yYwbySPGSQvxYE	6656	9415	9415	1617633900000
12916	3NLuNaE7WCxxjP5AtdazNL3Kng1E2b7wN8a1Q3ZnecUWCh9SL5j8	12874	3NKRUM8mTMobcsUWYATdQXgy7FxfB2qTqHHKZxZvjQt3ivyX1gZw	1560	1291	186	6301	9212	jwYC84433wcQTk1Dkxrd8VxKqekPBreNF9ehPqrpXv5hFQ6UF1N	6640	9415	9415	1617633900000
12917	3NKf4BF31zm773shyMta7Em5KxBrmytVkuQKNCwbmWxtvukevJSw	12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	1536	1313	187	6301	9213	jwxstdU4xpKNkPQh8J8jxxvoXPkrEm4FMt6s9eb3KRtVEmVPRgv	6657	9417	9417	1617634260000
12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	12917	3NKf4BF31zm773shyMta7Em5KxBrmytVkuQKNCwbmWxtvukevJSw	1637	816	187	6301	9215	jxQh5pZF5nwtzdrutuZDFSEMSVWMk4F5n87x6ecAmE6KTtM5EqN	6658	9418	9418	1617634440000
12930	3NLBxxMYKUv8vNhwxMUDNhxk2GnK4C3huMuqGQz9xyeXsStbS5pT	12880	3NLkJYvm5kzgHM4oE7S2zLZiAdmWRbQRnWuV4c7BFPzrboHxJ7i5	58	1281	186	6301	9226	jxTYDo2VMhzr19EgBumXA1swFeVtEfdTcm9ENV4UdFWJ36NGieL	6587	9425	9425	1617635700000
12939	3NLmqhqCrdKdbif6NB9N89YQwnhk9iMdwuiTCYj63xMSnSPZCNGK	12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	1651	1301	187	6301	9235	jxzgZEQg2HUyctk2o55dQCTMQV1Bot13PS1E9oZtcz9CJvPYcuw	6669	9433	9433	1617637140000
12941	3NLebavyCGJqh28zpiMordBAKvzcy4mzuQVi9XGKvxur2tyUo2Si	12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	1602	1243	187	6301	9236	jx1SM9owBu6tDhv99WunszMuKo4JtN28cWcocTpETaGKium5bD4	6670	9434	9434	1617637320000
12946	3NLRixZMj6G7HUM2Xp5VGGvgSvzJDRAhpLAJHEZaW67wc8t8eEH6	12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	1534	1071	188	6301	9239	jwNpggzcW1ZFgPwpCW157D7CYpAU1YVkKWAyBWBiMqA64mqvyJi	6672	9436	9436	1617637680000
12948	3NKRZgfLBRKdYDvnGrMD548xTnCHYBRtHpggfjgaF4xW8ooXt9kJ	12947	3NKNhxxh8y7zk4AzHQkwczhSWDV4tKGe5fqqcrTaesFFaSWmdU81	606	1169	188	6301	9241	jy166ZM6Eym7ULjWmDDYXYEjhvFbxparCRnHaKSpgDyepVWWuFk	6674	9438	9438	1617638040000
12957	3NKEhcJsThrWpXzoqSKvR6DifeiJNNGdm8MCcFz8XMsRdiVakVmq	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	1536	1313	188	6301	9249	jwkg7Gp57mwXbb7BZvzbyNTDyzXFQyiNYr6XciMwUoWk6EQnY6g	6680	9445	9445	1617639300000
12958	3NKSiGeUR48j1LuPxv7iDAJtfCpbaDRNiUm1bcnnSaLV1JeBmUUs	12955	3NLANfBCC5HvBKbqoSZmP76BvusAxS51vqsw7WyYofVR5isXD7ZK	1507	1154	188	6301	9250	jxZjabxAQuYGHEjpSsPdFmfwhfCNg9aiMSyU52KtRzRNqZabVq9	6681	9446	9446	1617639480000
12961	3NLZ8twpMCJKrS66XD2EpsoiwfmB4RcffX76B5q9W8krBdg8W2ee	12959	3NLfg6EeUWNfWi5TMncyET5o5iXQTKtDdLDauR9ytuuHXtzGzbTt	1406	1393	188	6301	9253	jwpGAfTvdxbfM66Gzg2bhhCiqBZku7m4SaxtRt2wkcQdKCszDKs	6683	9450	9450	1617640200000
12967	3NLRzkyCdMkKntzsUSSrp6Wur8ayX86TMnDZ35J8CsSYk2ewd12Y	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1406	1393	188	6301	9259	jxtyqxfvSX7vLY6N2Tvt4tb2dVSfZDssAPURkdUGjQYfwDtQcVG	6688	9457	9457	1617641460000
12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1637	816	188	6301	9261	jxoRhrWKgPzetCMwfXKija2TZR1ZoxeD5d7KpXAC6CAJRmkMum8	6688	9457	9457	1617641460000
12972	3NLDbAxzeXFBBRTA3qdhEEaBzBMVyeXKM7y3hUQVpDVmgJHGTrSP	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1406	1393	188	6301	9264	jwZwadAYZCW3gGg32XRk79Rc63MHcq4kirBoWfqPyuAUXNA8RR3	6689	9458	9458	1617641640000
12981	3NLZS1KHBd2UYJA1mxgMgDoyyt3m2hNr7TUB8d9wMJTysNGZAqA6	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1448	945	188	6301	9271	jxbzgLHYoYuksVXTHuRH6TVbz1DGK19bJD6ortEN4ZMLny9uUsn	6693	9463	9463	1617642540000
12985	3NL3hhHnov6gx4gjVPY68CLFv2KDvy2szRnmLrh17BYi67XSHoBK	12817	3NK9suBainM83RWgpe4va3PNvXwc4hxcAka5E1UqmfrrVsbpHcmJ	1675	976	181	6301	9274	jwBTuc5J9TUnUT4cULDs1kN7CsbDneNpNxYpUqNNhiPnyA6yD9A	6483	9465	9465	1617642900000
12992	3NKfHUJFoCPNqLLgxG48os4vo2M7Xi83h6sVfG7n3Thwr6sn5XqK	12991	3NLT8Gsz8YK7MhfY94NuaGHLUKHq2GzJSqo5m6KndMc5LLpCcvrH	1633	1390	188	6301	9281	jwUztWmS3B5NttnxtGDm1etrNznKzLVuSymKpoUvNeHVn2cb39o	6698	9470	9470	1617643800000
12995	3NKibK1jyC9fkJbXQMWi8fPi91NsrHK3QpfKLJ7VsGzsZX6VPGU7	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1536	1313	189	6301	9283	jwVRRVPqXFBPvgr9Qa3gMQUxYwp25Qdhf5KJTVYpC3VjNZXX22L	6700	9472	9472	1617644160000
12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1599	1041	189	6301	9286	jxttoVDfXagXPjvANRKXMW7AMcWgHAhb3JQiRk4JbZ6atxH7xDo	6701	9473	9473	1617644340000
13003	3NLncQhJ33qzUp2Wdydmwx1BKQ6pRB71oTz3qS2m1RDVtSZmk1Tn	13002	3NLTZritb4EqKEhAck8CHwgXrxHPokg8cp5XnSx4bk6XM1ua5Mad	43	1310	189	6301	9289	jxLYEKkmsci3FzZJsWwBi54NG46CcBq8Eabp3SLhApSgH6igrzb	6703	9476	9476	1617644880000
13005	3NKfhHU282jei11hjB8sD9DFqMmqCentygiFU8noERgK9Dp5vEim	13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	43	1310	189	6301	9291	jxk7uagBWPy4fPNzfFVbKVtoEupX2rWMWZNiDPGCH2BpeiW6nQF	6703	9476	9476	1617644880000
13006	3NLsR5JuQGPM1Vm7Yc5xFdPULDpaFrvoDMH2W3YXXxWSXcDT4BpX	13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	1637	815	189	6301	9292	jy2FgE7XixQiNsd8K8SWAJrTb1XrjGTJKFuayFsXwuxBANoKzha	6703	9476	9476	1617644880000
13009	3NLR7LMqswnuPGxa86mPPjSiJpRiEdN1w1gVwCjbhWsuvdgchDTp	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1508	1387	189	6301	9295	jxiVJEfH1NCxF5vCsM6U6Zn2559kCYM2nULJA6caBtqKr7qM5TP	6706	9481	9481	1617645780000
13016	3NLAF4xB5AvvaJ3nCrP96eRYD6beUCJX93v7NAwUzWSj23P48CKx	13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	1588	1146	189	6301	9302	jwUmS4owhLyjrQmbLLRWNdXzyFTgcep7ovSEuWB4cuV3eS2FbBj	6710	9486	9486	1617646680000
13019	3NLdVYsKcBShimYXWe5bYkKbGVgqe5R2JZvQJnUUJK7FDLZEEAZD	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	1642	1121	189	6301	9305	jwwrd1oQQ1UUqAa3feoYrGyZeQ2LRLSLD5hijTJLf5DVsLDqEsd	6712	9489	9489	1617647220000
13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	13027	3NKG5aSR5GB2yP5pFA2M7MrwWypQBVYeU2Rgt6UwvtvYLzz7XrJH	555	555	189	6301	9314	jwgLFY2WUaG3jQq6j9pnfDV81quTrexwFvajYHoKL1EGdE9F2zi	6716	9493	9493	1617647940000
13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	13030	3NKKHPqPKPSrftNKC6hR4T3yCJuKE9BvnJv5WYKzQxiNHUXbVzqB	1467	1376	189	6301	9317	jwPemzSmNfFakUXnM7L27QUniFFmtrTYHKW7GVA1pHGG8sE9zky	6718	9498	9498	1617648840000
12933	3NLY1j7DtAczCbEAKL4bWf2UAXykMZkhKZ2wCWrNC7oFZ6hnsthb	12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	1610	1188	187	6301	9229	jxP3CL2kBTCdLsbgwkctKqDEm8spBG9nYxWXkizSB7ExxSytHGd	6665	9426	9426	1617635880000
12936	3NLRErF9CFvdHR3M4Nv5yDD8QhxAdtdriHeg6zXMN1osKotnweJa	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1407	1395	187	6301	9232	jxfAjHaQAEuUSEqHmjJFgpaVw3hpkUGi55FbmTmmPe3R5bgB8ns	6667	9431	9431	1617636780000
12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	12936	3NLRErF9CFvdHR3M4Nv5yDD8QhxAdtdriHeg6zXMN1osKotnweJa	1656	1343	187	6301	9234	jwntoFNdVMPQYNfg3J9KavzwM2oww6xAfQSZeq6hnVXW4MLCRHQ	6668	9432	9432	1617636960000
12943	3NLRf7JpbvPLumDZv4JbGS4w1wUtQGubxkjA2EH1Xe9gKHh2CP9T	12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	1634	1085	187	6301	9237	jxRQj3Z431tJHLhUY6rNwMiwqvi2L4LGwX3b7Sgef1w8hG68H1j	6671	9435	9435	1617637500000
12945	3NKMhgM2S5YSnVL1F3teQ4ZebpLHWJsUzFgpVqCaWCw9QQdMBRGa	12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	1534	1071	188	6301	9239	jwNpggzcW1ZFgPwpCW157D7CYpAU1YVkKWAyBWBiMqA64mqvyJi	6672	9436	9436	1617637680000
12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	12948	3NKRZgfLBRKdYDvnGrMD548xTnCHYBRtHpggfjgaF4xW8ooXt9kJ	641	1336	188	6301	9242	jwhuJ6kCKJKtKKYiYnagazw7cfqeAQsFpqF4R3Qyh6aCB1BxS3p	6675	9439	9439	1617638220000
12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	12953	3NLaPzUp185HqseqToVeT1Ph1b9reXM1UuNZC8nDBkXmxWSXSss5	1673	1002	188	6301	9247	jxXpBByzgrW62wJgJYjnriyWN6cgCsqE66ThDxSBqy3E1HAgTHe	6679	9444	9444	1617639120000
12959	3NLfg6EeUWNfWi5TMncyET5o5iXQTKtDdLDauR9ytuuHXtzGzbTt	12958	3NKSiGeUR48j1LuPxv7iDAJtfCpbaDRNiUm1bcnnSaLV1JeBmUUs	1403	824	188	6301	9251	jwGDXnrdAvanyQf3gtFVb8RBQEpZGQAzqBgojc5fzActc8iHpHR	6682	9447	9447	1617639660000
12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	12961	3NLZ8twpMCJKrS66XD2EpsoiwfmB4RcffX76B5q9W8krBdg8W2ee	1579	1389	188	6301	9254	jwKmCkqpSdp2s9LxfVRiakME6p2uus9AVMcZ2BvjmqUuCQ1yK2s	6684	9451	9451	1617640380000
12965	3NL7bVGNFBZGQePDS6bJmr7422AZRm1FQvMibBhvHhiwZuN9d5P6	12964	3NKCrk5c97jEu1SvoRWjr6gt8jHXcehxV5vsxswrcA1UxpM5hTDr	1407	1395	188	6301	9257	jwh8qc23yqV2DH8NTvPn7TnWDCiQ7GnxLhR4CPagTq9E4WfpAUc	6686	9455	9455	1617641100000
12968	3NLKpE25VAuBLeL5oKR7Yo1jKzT7Pr1RLMy7eUMpxW6g6gZnaXbh	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1405	1	188	6301	9260	jxxEP6ewHgypCeupWaJzdV2cAE9X7gqEWSybBqH2SzDCujmrwHw	6688	9457	9457	1617641460000
12973	3NKZVkKKEXzW4hE99HHYYVUaT6KvEChRMHxotqm3UjtjjHfRbS64	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jwgGtDEpwBGDSvTo5mbHHGdthfFFnna3ZruxzbtPvsKCFxjKtVK	6689	9458	9458	1617641640000
12976	3NKfLMzWNoLUEoYt9HAtK2TgsBnasLcbgj5JCbsU9R9aS6U9EDY2	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1631	794	188	6301	9266	jwPsg8jnekcAeiMauE79dTUfEBG7MECUhzrMWw5xsUxWevEEd3a	6689	9459	9459	1617641820000
12982	3NKzSvNqwtvpVtMGxSZaVNZQKpheR6htyrbeJTTBvt8SeG69AfvF	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1573	1072	188	6301	9272	jxjSzGApjngu7ct9WQraNSyaN932aTwFFuhBG1DVdEKtMnFnzPj	6693	9463	9463	1617642540000
12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	1585	1366	188	6301	9275	jwWTiMHWd8qw23mub7pfUayikc2hf5z84yYvirMa7CTqipZ4hD9	6695	9465	9465	1617642900000
12988	3NLcYG2edvxwFpdcwDNaEqRkc3jNmBcNpwbriat12tH4oa8ubaMJ	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1406	1393	188	6301	9277	jxT2cKYHpTvGYt6qMrimwFHezAFwqhqjFnR7JdPV1WJBuWYrLAL	6696	9467	9467	1617643260000
12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	12992	3NKfHUJFoCPNqLLgxG48os4vo2M7Xi83h6sVfG7n3Thwr6sn5XqK	1642	1241	188	6301	9282	jxrqkhbbKnrKkqXFcQTMTvQjQUy4ScPR6k8hSUU3enbHYcGUQbB	6699	9471	9471	1617643980000
12996	3NL4EcNbzHk3uZ9EB83vb3wBZfBx6FWo9q1U9CaiJVYWfM2vxGLw	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	632	1382	189	6301	9284	jwPFKuEB4LJxVfgCyMQxZt38Ym9jWN6T4gGH5NF9K4WgzVYzQiT	6700	9472	9472	1617644160000
12997	3NL8dKFb5WD4jYCaYjZ6ogk3U4SjgJWfjwjULXNbQftrVSCdE5qC	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	632	1382	189	6301	9284	jwPFKuEB4LJxVfgCyMQxZt38Ym9jWN6T4gGH5NF9K4WgzVYzQiT	6700	9472	9472	1617644160000
13000	3NLfbcCmAxDhY6cfoMnikq9AKU9RLHRGaKH1urvx5Ev8yDYHog2Z	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1599	1041	189	6301	9286	jxttoVDfXagXPjvANRKXMW7AMcWgHAhb3JQiRk4JbZ6atxH7xDo	6701	9473	9473	1617644340000
13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	689	689	189	6301	9290	jxNvPwrVAsJTSoDeRavhy9HJQ2YF3irk2CL9KeJG4dv4MM8RRKz	6702	9474	9474	1617644520000
13007	3NK5mV9tbxkaT5fsaZFJB7S7FYmpso4AKuKCZ7axQmRUVYxPRGJ1	13005	3NKfhHU282jei11hjB8sD9DFqMmqCentygiFU8noERgK9Dp5vEim	1403	824	189	6301	9293	jxgCP4qv58a1So6PhehMBZjsbovyZTzbh4sAxHf69n1k7BP2X4r	6704	9479	9479	1617645420000
13010	3NKUTYNGQCS2rBCq1UJTuoXvWr9zxcxLfLfAT5m4pLSo6eVKEAoA	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1638	630	189	6301	9296	jwgzs4Sv7zmmYeaCqFkKw9NfXgHbrr3BtRcHAZxyTsxJgdfNcV5	6706	9481	9481	1617645780000
13014	3NLiYymNjFuA8DiXeYWcajHDLbd3MqCXMGcGoRhWEYhfmMHHuJZU	13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	1622	1356	189	6301	9300	jwgwmV1tuR22NCuPHgnGVfS8oZCn8Gtx5wMFHbbtrSUVgEuE65Q	6709	9484	9484	1617646320000
13017	3NKvFU7U2K4DswnikiA6CxCR5KRZFCQsMCaMfuaDbQmcnkbU5kUY	13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	43	1310	189	6301	9303	jxyHcuCsr9sf2NEsRi5gTaHijfp54tNCYU9h4Qh348idH9farDA	6710	9486	9486	1617646680000
13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	1483	63	189	6301	9306	jxHiyD3AXip3mv8BixL5iGwuSnMrzxdtt4ojyaD9GnT2Te9fp9R	6712	9489	9489	1617647220000
13024	3NKahGRqzM2n1gaB9Jp94hoY6cTYdVzGLhA9WkAfXdSAqUc1QAUo	13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	1579	1389	189	6301	9310	jwxB3kwzfvA3R6Ls9dL4ydMSGmmEVtbCkPr8EEqEFxxX4uS4dT4	6714	9491	9491	1617647580000
13026	3NLsv7rpdQ6eEnZnD7E1eMxX7oewP1wSBuFNREafNMG6W4BxPXUM	13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	1619	1275	189	6301	9312	jxwaRTBt4ZyhjK3bWU1a8YPVqB8Zq7efcUVE9PhVgiiudSZ9FLY	6715	9492	9492	1617647760000
13029	3NKbsX86UW8DmtRVJ16nPn3XUhB3CYo6E7LdSBKKGjA1JcEXvvu2	13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	1403	786	189	6301	9315	jwk4fNT1JC1v2nbTug6aDUjwHUB14993MCoXgp1Q3sHh5VX95A3	6717	9495	9495	1617648300000
13032	3NKUAwYwttDSa2UHwzgsfu7doFuHzFptEE3arTwQTNMUMDxMEJQj	13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	1633	1390	189	6301	9318	jxABdaLRze1f8xNJiVX1SBAFNEvtNw92TvAXgrhxGpJy9k9UW7U	6719	9499	9499	1617649020000
13035	3NLgMTyhWWm3YwEdKCyq8bA7Dh5cjB9AcbtrPoxhmUjYMyh8cVfj	13033	3NL1SBBqp2eyynqLLQi8cDwDYLYR6ikEYRMMcwmrravzjzryyzrH	1403	824	189	6301	9321	jxF65SWKEVpyPM8Cnb47GHBf7c9x2QzZ9YLiENUmhLFFH5BepQn	6720	9504	9504	1617649920000
13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	1403	824	190	6301	9324	jx3i8V7bPSa42Lz4VzBmVYF1sGhrSScggbMR7ZxK8aVfZZd2rWa	6722	9506	9506	1617650280000
12947	3NKNhxxh8y7zk4AzHQkwczhSWDV4tKGe5fqqcrTaesFFaSWmdU81	12946	3NLRixZMj6G7HUM2Xp5VGGvgSvzJDRAhpLAJHEZaW67wc8t8eEH6	1503	1277	188	6301	9240	jxreBzL11h2kHxoWR86RvJgE5mtqTBmK1qgG3aMzkPcRa6PX3mi	6673	9437	9437	1617637860000
12951	3NL2PeuXYoS4666U614TSpeoMUZYTEQqz3YKC7NCmJeo8KXLZULf	12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	1634	1205	188	6301	9244	jxyRosZuNAtjJvrru9pnFZkgLqK8PbkTwZ2jmLc7RZBeNqmLPvk	6676	9441	9441	1617638580000
12953	3NLaPzUp185HqseqToVeT1Ph1b9reXM1UuNZC8nDBkXmxWSXSss5	12952	3NKS7BFYM7g4MedWFhSmpi5AUDiTPZzytBraC49RvCZTbe224NrT	641	970	188	6301	9246	jxsTi25Y4W9Wwz5zdBLk35mg1vc11GgSELesBQGdoxLdHjUZxGM	6678	9443	9443	1617638940000
12956	3NKYyr9hRUfS53PrG9nK1MiPpgi5rr8X5apqRkJT2WUEdHJn2hVa	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	1536	1313	188	6301	9249	jwpj5PGUoiEZAFp9J3eK9pj3NzugREQE6CHmXR1kWixPp3r3nCk	6680	9445	9445	1617639300000
12960	3NLps8WQUWDZg7bCU9Z3kyqVFAyt9jhocR53YXpkCqJVS9dDVti2	12950	3NLf2p4QGLMkh5nTUu5aGNZHhChdWzDedt83ajkMSAZC8uPG3HU9	1577	961	188	6301	9252	jxgqwAnEKCiLoqXrhRsNV1ZL3QpQCGaYBuGxk7vbMVLaKTjZNnd	6677	9448	9448	1617639840000
12964	3NKCrk5c97jEu1SvoRWjr6gt8jHXcehxV5vsxswrcA1UxpM5hTDr	12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	1403	824	188	6301	9256	jxj2r5B6PYBRrXcJSLfmAvCTzAiKyzQtZxxr1HEffA7AYyU51sy	6685	9454	9454	1617640920000
12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	12965	3NL7bVGNFBZGQePDS6bJmr7422AZRm1FQvMibBhvHhiwZuN9d5P6	684	1352	188	6301	9258	jwhtFi1dK6EfoeYR6SooRcqyosryvKVedxwEeKcN9LRMMc5HGvK	6687	9456	9456	1617641280000
12971	3NLQnVVcxUXo7fMquma6q77aqPMaDmqvW6NEMhfZScqT9HVjarWZ	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1670	1156	188	6301	9263	jwZiqZpbDmRvbbw9vr7Z8hdMv2CRm9JEgr3NRptPSbUKxxvCzwT	6689	9458	9458	1617641640000
12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	12970	3NK91zKu6tLDTUgX5G8CeLsQsEjjfNdi221wwAXZCxCJ4igpyQzo	1406	1393	188	6301	9265	jxCTfdUQ4WVHYZUQTTaaq3cKyT7RvHoyPVfYK2gQUwvuqpyMkdw	6690	9459	9459	1617641820000
12978	3NLn5z4xGv4Lrsp4RhVcy57HzFT8RNQegdZFiVof3SfJJX3qtYsd	12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	1637	816	188	6301	9268	jwoBuwWb77i99UC5E1KJxVVcpoq3GxUGVqY7HHa55DC4gPFQwjT	6691	9461	9461	1617642180000
12980	3NLvWLTWo4brjAaxRU7WepZWANX9rZtrfQ7JduF8rsPDPS8Y3DdD	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1668	1124	188	6301	9270	jxmR2FmvcykaSvK4VhEm1UcSGnZLgVg681jLuYVrT8w2k3oaGyT	6693	9463	9463	1617642540000
12983	3NKPqZ8mWf5aDjjXeMko9hj8d6VzZbG9L7wvWa9WqCUcceDFt6Md	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1448	945	188	6301	9271	jxRoqaHqMoxeXqjJwMPTgFBNtV3AZ93agdWAWNsrdw1R8TvioGK	6693	9463	9463	1617642540000
12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	12980	3NLvWLTWo4brjAaxRU7WepZWANX9rZtrfQ7JduF8rsPDPS8Y3DdD	1587	1111	188	6301	9273	jwKgnwuxPRQPz2kj2NwW8fFzqcAieKKyDndA6CinGHadUzad2kT	6694	9464	9464	1617642720000
12990	3NKb5vgP2uQngE2kxMmtgSjXbPnUMjbNqPkh6HQ4QZHiQRVDx4AA	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1522	1076	188	6301	9279	jwhrE4RErWYkHRPvyb6tG1PzTy64xEiLH8NLejAhH9vqPRszDci	6696	9467	9467	1617643260000
12991	3NLT8Gsz8YK7MhfY94NuaGHLUKHq2GzJSqo5m6KndMc5LLpCcvrH	12988	3NLcYG2edvxwFpdcwDNaEqRkc3jNmBcNpwbriat12tH4oa8ubaMJ	1402	874	188	6301	9280	jx1bA4Tuy3QsWitEH2a5f24J7Wo8W6WUv5NcALBtiPTUD4iy2Rb	6697	9468	9468	1617643440000
12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1536	1313	188	6301	9283	jxqTB8wpaZprMuM3nbRdsPaTwpKAAqWMgydD9Z6WbfdK8S3xwVi	6700	9472	9472	1617644160000
13011	3NL9qTNsNX1nnh4D8uqgTRdTA6dQzZjujTfdZr7aLpqLuAhmQk1P	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1564	1338	189	6301	9297	jxAxYWL1bfhT4hCnt88Nq7ZpaLEcfQDKUUEvb6WQNgKxtHMajF1	6706	9481	9481	1617645780000
13012	3NKwBfdQoFwwC6ytckL8MZmiCjvNka5CFSKwDaCWDNqurEtAFXDW	13009	3NLR7LMqswnuPGxa86mPPjSiJpRiEdN1w1gVwCjbhWsuvdgchDTp	1402	809	189	6301	9298	jxir3pVvzCbiYhRLYAFHQajrd5Qx6s5dvFq2YFjWXkPmBAemJSs	6707	9482	9482	1617645960000
13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	1508	1387	189	6301	9301	jwecVuvv8UJXuyUb34AMcuNrdVbySgwwBf5QDbYy2TNcM8xYy1q	6709	9484	9484	1617646320000
13022	3NLTEdcGZcESsvgW4wg87DJaz7t3vWkyPiwUgH4P9Ast2uUgjN8d	13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	1536	1067	189	6301	9308	jxjzvVNrUgpK5X6Jo5BQgEke2SwBaPX95AhBHfgfpKQMx8PXPto	6713	9490	9490	1617647400000
13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	1637	816	189	6301	9311	jx6rR5Rr59riRVPNC5kpzZ56r3Qt2MtcqDqKpJPe86gFxCWyvXC	6714	9491	9491	1617647580000
13027	3NKG5aSR5GB2yP5pFA2M7MrwWypQBVYeU2Rgt6UwvtvYLzz7XrJH	13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	596	1060	189	6301	9313	jxwqRgvZZQbvX9LnYZZWupNGMLA12ydf7ymHU1FkLvNXjLyjHq7	6715	9492	9492	1617647760000
13030	3NKKHPqPKPSrftNKC6hR4T3yCJuKE9BvnJv5WYKzQxiNHUXbVzqB	13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	1477	1104	189	6301	9316	jxnkDbk8XGkYfo3t2cU8uMaXyhJHoLKwaG2YV5nMWoDCn2XaNoV	6717	9495	9495	1617648300000
13033	3NL1SBBqp2eyynqLLQi8cDwDYLYR6ikEYRMMcwmrravzjzryyzrH	13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	1407	1395	189	6301	9319	jwQ2dpjMr17HqEzrd1CJv4hJmgR7gMy1PML9q9ERLWvzxV5SK7p	6719	9499	9499	1617649020000
13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	13035	3NLgMTyhWWm3YwEdKCyq8bA7Dh5cjB9AcbtrPoxhmUjYMyh8cVfj	1402	868	189	6301	9322	jxJANro45yjoM1P7SkWGHZKn9vzUUMhh4PjxmZvD7WYix1VxC2c	6721	9505	9505	1617650100000
13039	3NLmd3AuyQnth9gK4VWXNae3FHzAfmGvymveMPoRde9yuC8BQaHW	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	44	959	190	6301	9323	jxArBPFH9zZ9EYvkXTYpWwcniLZZwTwyu4x3k83hJqByGq5v6aa	6722	9506	9506	1617650280000
13043	3NKGCASwmAomTryuNucHdPKUyMYh34eyrGEqj57NhYQPxVtFVyqj	13041	3NLBNBoJ7SMYHxtTWzL4LJG3Lye1JYLvJkhrMxvdvLDMX8VtdoKZ	1403	824	190	6301	9328	jwreS9GWc4ycEsGBFLXuLhuWRvRXXXyKsJm8i6AmgcNa5hzCnsH	6724	9510	9510	1617651000000
13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	13045	3NLjihs4uSUxVLLPrxrUMwmweYeQby12h9vAohVzAYAT98qm3aVL	149	1037	190	6301	9331	jxUZNobDnSK2mCYLxXnjRCy6tjDLCf5R2SwvWNb6hfYzCq9nZfX	6727	9513	9513	1617651540000
13048	3NKYdcvnoZaQStqgwqwbu9NaKQErbnk4YggGsYTnNotXiiCKgX73	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1402	868	190	6301	9333	jwD9ApYHytbZn472rwEKvxQvymUfyQd8u5wqVtPvQveJTqURQkr	6728	9514	9514	1617651720000
13052	3NLRSkqRxSyxm7bNgU2D835C7QWniQtDrujPNvnyjw7Swma61qAX	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1637	816	190	6301	9337	jwNWCRA3LuNNz9BMzfRjaYL9mcEbEwSKnsJ6Ee9eHLKgArc6qq3	6728	9514	9514	1617651720000
13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1407	1395	190	6301	9340	jwjmeUnnkuGS9woo4eXaHr5cUCa3rfgHfXPMGHpX3mhasQnf7vb	6731	9517	9517	1617652260000
13058	3NKdYs9GgarwNV8vYp68qJo1xktdY3nc5d1j7J3DVXAUg3Rhy2Zo	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jw94sHQrphvCUVL2Nwq8y43rps3sJ1fyjZZu87Eh5wejRK5ZjMF	6732	9519	9519	1617652620000
12987	3NKckbozqXhT6qkyqAfGYbdpVWfE65ggVxdfevEUL36SxzNTCtAQ	12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	1675	976	188	6301	9276	jxjWwPdfrepbxLFwBya2pkbvQNPDXQTLaXdYzbQNDniDXYVf3B9	6695	9465	9465	1617642900000
12989	3NK7TydgeWeuC4KhxXDkU1XKdKaETfai6r11VXGdQFFRdhGcQYMt	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1483	1030	188	6301	9278	jxbjH8FUJrfybGetnaRhYWcMiP9k6wG554WjgEdpfsrB8LCinoX	6696	9467	9467	1617643260000
12998	3NKusMtov1qMFv4HtLACzr7fY3ni7kMP4mdpa6FRCBX2pmCVA7iH	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1631	794	188	6301	9285	jwVAVxymMScH6GT24aZAkfJtzgmNR55ErTsedrVn6tzqkLkv1Mw	6700	9472	9472	1617644160000
13001	3NLNJHtb1xdPCJ4YRg5ekQBpyPiGDsSLHXcqiTVwgoJyqjTg6SZa	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1596	1363	189	6301	9287	jxt7Sm18pf1TzGbwP2LwQronxcfFzRuNpyXzA6GqU47USFogksk	6701	9473	9473	1617644340000
13002	3NLTZritb4EqKEhAck8CHwgXrxHPokg8cp5XnSx4bk6XM1ua5Mad	12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	1673	23	189	6301	9288	jwnX2g4nDYo4BZ5tsukKTgKfrStD8gstxmWLJEXvZ38NKJ3Y4yL	6702	9474	9474	1617644520000
13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	13007	3NK5mV9tbxkaT5fsaZFJB7S7FYmpso4AKuKCZ7axQmRUVYxPRGJ1	1573	1318	189	6301	9294	jwAbucbBGE2pxSPxGBDeyjFzYoLhzPzEKzsuRxHexWNaquGWN6v	6705	9480	9480	1617645600000
13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	13012	3NKwBfdQoFwwC6ytckL8MZmiCjvNka5CFSKwDaCWDNqurEtAFXDW	1476	1371	189	6301	9299	jxnuNCnjZ4S6A3kbTzMjXdjokTV7GFLiNJZ2Xvq2XjDcExnrZKi	6708	9483	9483	1617646140000
13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	13017	3NKvFU7U2K4DswnikiA6CxCR5KRZFCQsMCaMfuaDbQmcnkbU5kUY	1601	1142	189	6301	9304	jwqvAGMDYDjsMrjmLeFmvxuJyrBdnbRFmAfG6im5Hc6T1bGepCf	6711	9488	9488	1617647040000
13021	3NLmnHvkdzFS8KVizfy87ZbHiwpQJEBo4U2By3fLx1teWK8g7fRF	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	686	686	189	6301	9307	jx5mGpQxDE9NRVv9mg95jbR9BjnBWTWjftHz5bxWYu4bSVycctT	6712	9489	9489	1617647220000
13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	149	1283	189	6301	9309	jy2YbTNiZvrnAqe5kCKiWm5TyWTCZkMZSqwaV9oGMaFxrk5xeSU	6713	9490	9490	1617647400000
13034	3NLGiMkXNLb2nMQfrZ2A8Wo89QLZED8uamoehooJMj61LX9GvSjv	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1455	1206	186	6301	9320	jwnxsJecAbyBEpw9ZNMK39L6PovtzDEbBc1SqFDdJ3vGEHipvqj	6643	9503	9503	1617649740000
13041	3NLBNBoJ7SMYHxtTWzL4LJG3Lye1JYLvJkhrMxvdvLDMX8VtdoKZ	13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	1407	1395	190	6301	9326	jx5dBvcpfsPJxXBHBSasvxYSzGafX8uhU8dW64jeXsjHRYoEuaX	6723	9508	9508	1617650640000
13044	3NKhuNhwFnuPwtMEjUUpgkzrrG2bPwvu9DyGmLohBP4MGL93gPwt	13043	3NKGCASwmAomTryuNucHdPKUyMYh34eyrGEqj57NhYQPxVtFVyqj	1444	1381	190	6301	9329	jwBMR9jMZK5sD5yReHdVEeNSDfeyGm1BsMabjxk1cahcz3zvqQZ	6725	9511	9511	1617651180000
13049	3NKfqtqxRrXfnDmumAWVZyBCRPsLNVCvDU4T5ArHFSxrc6q2aidc	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	44	1325	190	6301	9334	jw9AYBCA6BV6anafQ4xQfsEMgxgxABjnUuTbP2mR3ymfun8nmSd	6728	9514	9514	1617651720000
13053	3NKbq2JRAr9WySv9VNXxGxq1yCXs9miZuxGETFWsa6nDc4n68JzY	13049	3NKfqtqxRrXfnDmumAWVZyBCRPsLNVCvDU4T5ArHFSxrc6q2aidc	1623	830	190	6301	9338	jxhps4mSwNAQSM5BdeeLqnqcLVrtBEfnDRp13d8PKEu3qzgaSzs	6729	9515	9515	1617651900000
13056	3NL7P4UizU3qhanrziyDTsWTob3f1HuCuH1gL4TQHJeVT65JjGfD	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1617	922	190	6301	9341	jxnohFmcrK7LoGBnYdF3vzxi3hbPoWG6TPyzjxmc2XQNYYshRtJ	6731	9517	9517	1617652260000
13059	3NKtT2p6gtPNaXmHoUdpwtTQ6Unn2DZ24qP9TQL4unDJU66B3ppb	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jxH2zzZ8QC7tX2KhRfPVQo8mufMq46TnHxaJns1b1NNeVNDKJ8c	6732	9519	9519	1617652620000
13063	3NKA8WSWMrGXvZTEcNqGHgVMpr6bxxnUogGUMjqeHdew9kyRHLwp	13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	1654	1094	190	6301	9346	jwePEVkPEFtdLqRXAwhzButLVQ7DSZ2h8f33sjyEb1A9JKHjMeD	6734	9522	9522	1617653160000
13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1477	1104	190	6301	9349	jxAvBt3SQpUYZstbsJjbAAEymVMTARipahvf3PQCHeq5jp7ptrF	6735	9523	9523	1617653340000
13072	3NKh6mwqahtf79vRWPRbQGPLL6szKSzduXoDyui8LzA2FHvpwVoA	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	606	1049	190	6301	9355	jwTnfdXT5cbHNWLCnGvKCvwPGEwp8oup2Qsk37rQjt25NWRSX65	6737	9526	9526	1617653880000
13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	1406	1393	191	6301	9358	jwjiVuYGL5AkDP1W9UDBguyAm7nscBWFBvmUBNjyjPRECAprh3b	6739	9528	9528	1617654240000
13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1601	1262	191	6301	9361	jwQ34tqxsM9mS1sZsWDZM8YCYaLb4fDt5bFWvmQmbZM8Sd88zaK	6740	9529	9529	1617654420000
13083	3NLSXWdf3XtPE6dK1eiUZoerH3QLcdqsCWyQTkBdYcSJu82mr8ND	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1657	1344	191	6301	9365	jxypZTz6FLjJ9EBy6VXXpUQFAV3BEZAa1mGMwR5N1FoK5Vmid5Z	6741	9530	9530	1617654600000
13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	13086	3NK42Q8sogk48iAPZ7xMNNzxQjuqrauP8tAgqb2oCU5XqENYAUDQ	1403	824	191	6301	9368	jwX38M4a5ezxid1cP4rB1r1AGMvHTwD6JxmCaoH99LFdsGQhFQr	6742	9532	9532	1617654960000
13090	3NKqZzRZs9qHV7QNycE9E3izY4vncKKgANFhrYw3GRknnZq9U4CF	13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	1406	1393	191	6301	9371	jx8uskRdZP7hYbks5pN6qCMDPE65X9mcXCrGXxDuBR8EYH7E65C	6744	9534	9534	1617655320000
13092	3NKkhuychnjTWvGVUz5oVh4ae2CtMAEKLp3qRhHMVgb1vrtfLyU5	13091	3NL25t4iZVda7QmJDPRRwjTfJgyM6eBMwjsyxfRcrcb6vTPYfmvf	1654	1094	191	6301	9373	jxWE3fhAdcVWLu6DPCDQeZxPtc1mSkhVn1Lg1J9dFCX5eoJRM5t	6746	9536	9536	1617655680000
13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	13094	3NLFUZfFzAv5Z1HupSLGoC7Q2MVtzBGu3GAGZZX2zopusx8f8TSf	298	1308	191	6301	9376	jxULM6jwz94BEWDPGWDzsaB7TtYzLJvt8hWR1r4uFDbh8TPMFHs	6749	9540	9540	1617656400000
13100	3NLphz2EmCRpahndbRZfJKEkPkvGz9158vksyqCCFBgijiKVi78v	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1670	1156	191	6301	9381	jwmVKF9mZaE31BiboHypJtXWQJ1QUAARVggxqgtnUNwnq4VWVP8	6752	9543	9543	1617656940000
13108	3NKNVH3Qhp5RCaKjHaqYvFcBmTBoZqk8pJwLbdZXUL3Krbke9oqi	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1508	478	191	6301	9388	jwh9LsH1cCmDB67H74B7P6u1ANsKE9D7sUCwGWBccZLYMVVVHzb	6755	9546	9546	1617657480000
13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	13108	3NKNVH3Qhp5RCaKjHaqYvFcBmTBoZqk8pJwLbdZXUL3Krbke9oqi	563	1359	191	6301	9389	jxvSLTapXr7efwFWWrUQCU5bCvhRrAjzKqxhNNKkkJFH7Pi5y8w	6756	9548	9548	1617657840000
13114	3NLgWVXf9wBHi2tmYQQEj3KQKAs2MnYFzKrLGiQ65uho5mx3kec5	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1619	1149	191	6301	9394	jwjT2YKR7b4jyt7nHwe4vdtkES9V2UEQ1ACdGKG8qcZaNiX1Dq8	6759	9552	9552	1617658560000
13116	3NKLS2B3PjVTEpd7YaxM8UafyTxfWgiYC4oaWLvznuW1zWXSxzJv	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1579	1389	192	6301	9395	jwdUL2VQcAS1yRJbz7Fq1PnC3mTksqAfFbhZkw2z1ceFCpdfuro	6759	9552	9552	1617658560000
13037	3NKGX6m9WtrGbWVGF72JoSuQzAxr6gfQ1gYWBf6YBfvt566wUWem	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	44	959	190	6301	9323	jxArBPFH9zZ9EYvkXTYpWwcniLZZwTwyu4x3k83hJqByGq5v6aa	6722	9506	9506	1617650280000
13042	3NKYkcuRemSjdnpwFWjAC9SNbdmDfBoi3viACwFahd3CMnhryVh6	13039	3NLmd3AuyQnth9gK4VWXNae3FHzAfmGvymveMPoRde9yuC8BQaHW	1546	1339	190	6301	9327	jxpWSFxgaLZkVVgg66DGdaqDfQ6rx9moQtzjbqf4Xu8EJPjG2Xu	6723	9508	9508	1617650640000
13047	3NLGE4dSKt3B9RqqGepiaFoQYEL81nnYPgRszWrVkk1JL2Ax3NMq	13034	3NLGiMkXNLb2nMQfrZ2A8Wo89QLZED8uamoehooJMj61LX9GvSjv	1455	966	186	6301	9332	jwnxsJecAbyBEpw9ZNMK39L6PovtzDEbBc1SqFDdJ3vGEHipvqj	6644	9514	9514	1617651720000
13050	3NK6MDby9XHUALGrYUMnMdTcoMQauwiJxDZQabTCo5oma1SGMMmv	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1406	1393	190	6301	9335	jx4BUL2DhoCrnHiBgcsRna4jg8rfDJeFaEfT2mns7EQCf6eiHzw	6728	9514	9514	1617651720000
13067	3NLELMG6st7KFTv7UyhLGRmgd1coVmKwrcUJzMBpN5tKmWHYuXRL	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	298	1308	190	6301	9350	jwGkeCMw2EKsaqLd44i4WxoADNZ9FK41vqgj4SqK7nEy8qYUti4	6735	9523	9523	1617653340000
13068	3NL7w52gz5upcNL7RQoJxs8Aa5k7V6btG6amvaBRoC7yG8WAUFb1	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1460	1324	190	6301	9351	jxq17AtsFNHMADTQKWyDxCJSBmTiHeerZzwTaxemuC7zJLF5fQz	6736	9525	9525	1617653700000
13073	3NKWJY8PJELmXHzWUBoXAmCVJQjkL7DRgGseeYq17iYGsVyWGnfK	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	1407	1395	190	6301	9356	jwdF6vFzsiockRh9qsZNYJ65eZGFFSPbfKLD3dsxKeEX2QXG8fp	6737	9526	9526	1617653880000
13077	3NKExwQiJ7AdBNBEhGMHpJghtKKmnUaYMWCitHkNMyPjf1vsLm1u	13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	596	1180	191	6301	9359	jwxA59WyhX3JRrZEBs7nGJBP2H6bwENXSAYrEY5vc5GLVQQjrY4	6739	9528	9528	1617654240000
13084	3NKu91kuBJc5y6yjTYjSsqAThatin7ECFvgyw3xrcbYqkKX5vJHT	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	532	937	191	6301	9366	jxNEK73UtEPkkMQtEWJTJ1nF9p9WQtBSWJsb1NG676xxb6UtWEB	6741	9530	9530	1617654600000
13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	1481	790	191	6301	9369	jwyx7zRrF3NStkti4Mi2qvM1nksFg5dbEdW8oBNRVcAFAJNRJ4U	6743	9533	9533	1617655140000
13093	3NLFMLZEWUtvko2p8XeLfRxd5FaSVJC4VxCAR4p8mQsaA8Epgq3t	13092	3NKkhuychnjTWvGVUz5oVh4ae2CtMAEKLp3qRhHMVgb1vrtfLyU5	1657	1344	191	6301	9374	jwqTpniGxGWN61BYsV2g96P5xWFRdUnCix9ReVPDWa54G3mZjgy	6747	9537	9537	1617655860000
13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	1403	782	191	6301	9377	jw7aS8AZjwSfTEu4peuMSc3xAWFqUjMKkPYiBzGc4CG6iDAcz3r	6750	9541	9541	1617656580000
13098	3NLx5F5ntu3qPz7GCUegSbdQKFspEPZgt5bv6A6iD6p8fhYcpjoL	13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	1611	1341	191	6301	9379	jxS5qwTsJANCARiyqr7J2yVnwfB2VK8j9bHCkX4zgp8sX4A8xhL	6751	9542	9542	1617656760000
13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	1590	1174	191	6301	9380	jwjhwDmuoeTKUswk2swNMJSksAaK7nCUnAUanDYMim9fgphCPuQ	6751	9542	9542	1617656760000
13101	3NLMzCxkcEAQPN25M9kSjursjVNB4x45zgXU8Gf28Rnxc9XxJBKV	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1406	1393	191	6301	9382	jxL9JU6CoCjQYo7LP6uFjxNJAdFQgHwt3bvDpi23cscYskq83d2	6752	9543	9543	1617656940000
13105	3NKPtCG5ULtpR2isLZbKaCziHihcEAnTu7ZkCN3VT8ui9b3xGjgp	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1527	1293	191	6301	9386	jwfT1QdioaEMo4Eot1XaC4UbtXCAEHqG1PdphKs9MtXy11GQ155	6755	9546	9546	1617657480000
13110	3NK9GTJFCh4SxDoUKW5UCxQR4Yz5ApveUg9MDBZrAZwvGGDK7jyR	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	1402	874	191	6301	9390	jxtNVUUebRt3pxxBDgQ9CMd3GVjHJ2R93dPUACG7GWGELQDmRMy	6757	9550	9550	1617658200000
13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	303	303	191	6301	9392	jwJ9G3WLF4Zi41DxtWsb7dUbD4vndZsZg22JRd1946nvDkRUNKE	6757	9550	9550	1617658200000
13115	3NKLUshKEjPcEwrLuBgvZRXtYf2iMeaxt6f3HKvciSDZswfs2tH8	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1619	1149	192	6301	9394	jwi9tm4KtZSwAr7boYZFLjQQfDKXUNhkQ2frUf2MPJkFjuGstxk	6759	9552	9552	1617658560000
13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	13116	3NKLS2B3PjVTEpd7YaxM8UafyTxfWgiYC4oaWLvznuW1zWXSxzJv	1406	1393	192	6301	9396	jwNVRZefUKjFe6SjK9N5hWTnrAsZamH1FK64FiUzdCK4whTiAm2	6760	9553	9553	1617658740000
13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	13122	3NK9TKC2sPxFa9Yud1UAmgNyYoHDGYo4fBs12BZVurq45JYbQ1Fh	1518	788	192	6301	9402	jwhDX5P4ekmzK7Pt3pwbDZFRYoeBhH3efnns44PaYFiy6e9cqzx	6765	9561	9561	1617660180000
13126	3NLEwjUSdf6ZaV8W99sGH3a6YiHf6TXYVJcjWyn7ZqCxeY2nwfZL	13106	3NK8BvshvDnNsH57hsaYXbh823xSbwNmdSdX4SeRxSLyhPQJzZrC	1455	1332	186	6301	9405	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6646	9565	9565	1617660900000
13131	3NKa9tb1Z3mPn1dAnYrQEYDAS4MYymP2rsEzJfB1c82KDEAeCC7p	13126	3NLEwjUSdf6ZaV8W99sGH3a6YiHf6TXYVJcjWyn7ZqCxeY2nwfZL	1455	966	186	6301	9410	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6647	9570	9570	1617661800000
13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	1581	778	192	6301	9413	jx65mraUxsdFq7ru9PASaSRmNPMyRRjcGHarmRk8yEqH8co1Vbp	6770	9573	9573	1617662340000
13139	3NKtJ8aE92pjRLvRdPLfNgoPz8oygbY5n1Pb1HfvHfrMDnqrgYhX	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	632	1382	192	6301	9418	jwk1uEvKcvwU6JsRFWLg161kS1tqds5d92tnaN6SH8zHnc79dQt	6772	9575	9575	1617662700000
13141	3NKsv5Lxt9zHq4uA4jBt9sNEo7ciQ3x7KjuEW5SRckB8SkEokTiM	13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	1652	1069	192	6301	9420	jxMMAMdxsFXRCMV4tXT7ko6nM6M5HBdCnZLx3qrtKGdzHZBHrVU	6773	9577	9577	1617663060000
13143	3NLJ7WwPvREqoPvEjcvXoe8TgXTH2FyA54tXjEgty65SMdh9mfkT	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1405	867	193	6301	9421	jx2ZqJZXzWFdRsVAGe98zwg4M3UeACH7ARhs4AGgZZVjWvoAMKG	6774	9578	9578	1617663240000
13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	1553	776	193	6301	9424	jxXnpa23KAfqao9r3EA5MVLVy1hcBNGRQFxKz4tNxVh8kSzH59w	6775	9584	9584	1617664320000
13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	1553	776	193	6301	9426	jwe2XxkUwaWDestaEQD2Ae7ard5Ck7CLDcr6XAokHSHqdsHMc1k	6776	9585	9585	1617664500000
13152	3NLT1Szkwpkv9NSnLoFdE9mEEcZ7JFAuEfPzmuKwF1CE8W45qyoi	13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	298	1182	193	6301	9429	jxcDYdELgDLG3CGBicquzXxaQAJKcBheebAB9cq9zeP7EnJCMXH	6777	9586	9586	1617664680000
13156	3NL1qWPyLTNmmjZqK6e3j3WpogCJYkFVJst9rHuqe7kSnRNFqxTd	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1483	1276	193	6301	9433	jwhJK9wLgnkkuAe3MLJMGQ7tbbVHoARGDwz38VxrBaFUGweRu6y	6779	9589	9589	1617665220000
13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	13162	3NKG8FrVveA8UYAjjGPZfP5nb9eGin395jm8usuiWRzwzZUDZ45u	1407	1395	193	6301	9439	jxqJw386GmKH6mVnmkSAbghBSXf4URKTihnBMgs7MpW1vqYawDU	6782	9594	9594	1617666120000
13040	3NLR1rL1xgVR8M4DvUSWnFNbdCepNAJEvWppzq2UTuCTf4k82nbp	13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	1546	1339	190	6301	9325	jwQ9aXokDcVZL6i9THTucsPHmsGXTZZ4auJbkGp3e9cgbhph9Zk	6723	9508	9508	1617650640000
13045	3NLjihs4uSUxVLLPrxrUMwmweYeQby12h9vAohVzAYAT98qm3aVL	13044	3NKhuNhwFnuPwtMEjUUpgkzrrG2bPwvu9DyGmLohBP4MGL93gPwt	1507	1280	190	6301	9330	jwSohW5FtBVfbPe3hTtVFEUy6qQBtP1CE7k8HZSvGeiPgqq73jK	6726	9512	9512	1617651360000
13051	3NK32ZDS299H7guFjv8uUwbQh9KekmK34hhCYQmwVLdpMedfKzes	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1547	1012	190	6301	9336	jxMjQ92DpruVsj8jMsqokJrZ7fHpZJ8mwdYVc1L29Dpne9H6WjB	6728	9514	9514	1617651720000
13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	13053	3NKbq2JRAr9WySv9VNXxGxq1yCXs9miZuxGETFWsa6nDc4n68JzY	1407	1395	190	6301	9339	jxeArqnYkH1dDQW8UDZovCX234EeB2nLns6d3srhJnKrBnzQyM6	6730	9516	9516	1617652080000
13057	3NKMQy9ViAieDs5uVgp1N4XmkmT1sZE9wimw4iZgWB8h5oTSf1CL	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jxZdktCmsv1yhBYBE9mLmpDQDmku6wJPejcafXc21fphLjaw4xC	6732	9519	9519	1617652620000
13060	3NKBvPtjcoTixnWUGgrmRmA2S4oviv3KF4nS7EZhk1YnXbWgx7Sq	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1637	816	190	6301	9343	jwwxQ4BrrDPtpajFyNR4efsdDnMbFKmWt6Uk2eruqEEZsdYt58b	6732	9519	9519	1617652620000
13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	13060	3NKBvPtjcoTixnWUGgrmRmA2S4oviv3KF4nS7EZhk1YnXbWgx7Sq	1489	1380	190	6301	9344	jxHp6GwqRoBHRMbUwT89dMNn4Fj4RZrie4xRhPzm7jHNeCWLzoR	6733	9520	9520	1617652800000
13064	3NLMBoyE9sbPxuv1fC4aAMgWjZKyDv8YMox3FhaWMybV3cCRRJ2B	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1474	1329	190	6301	9347	jwKzyJ6wf6yw5TL2Bs9thfGrA78mc1tXavusKFsjwDMTyeWokqy	6735	9523	9523	1617653340000
13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1406	1393	190	6301	9352	jwkeoU5WmBmHGW8zQZy3sjCASw2NgKTCTLFRMPco88jA3JHjFiw	6736	9525	9525	1617653700000
13074	3NLkt8r5bpg46iPhC1g8WSJVrdps1pfsA7ebwN9Tfmc37wdY3fFm	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	606	1049	190	6301	9355	jwXadpnuJfpy625riAoXmFSNcsXMEw9L45CCw5skoonYm7F1uyK	6737	9526	9526	1617653880000
13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	13073	3NKWJY8PJELmXHzWUBoXAmCVJQjkL7DRgGseeYq17iYGsVyWGnfK	1406	1393	191	6301	9357	jwt1EUWnpQ1mVFbqXkKM8xdMqPrPQxNUyymHZNweRNas2uPmcq2	6738	9527	9527	1617654060000
13080	3NKEdximvsE7cpgtmifKn7tFKVGN6AWvdWP5DJ3EXi6YydBDBeY7	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1590	934	191	6301	9362	jxTshS8oKd7wGYrrGdLbvLXENokkpGRGmWgbCCZiTrNPw8D38Bh	6740	9529	9529	1617654420000
13091	3NL25t4iZVda7QmJDPRRwjTfJgyM6eBMwjsyxfRcrcb6vTPYfmvf	13089	3NKTxhp44B17QMwk3YhfeWayR5iBC6G4PDNz8QnRELSrpj7C3W9c	1407	1395	191	6301	9372	jy33fD9T71zaZxS8GyjWBQL9FQsy27WRLFKcrHjPHRDzmGrF6FX	6745	9535	9535	1617655500000
13097	3NLBg8MdYM9siUoc8HE7dgpEbAiex1f5FfKm2UxoKxk6aLr9DKQ5	13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	1405	867	191	6301	9378	jwqUXfKuR4U7vPDz2v6ZJanWfqWDurmzPSqrmEshm7wDii9eo4R	6750	9541	9541	1617656580000
13103	3NKUY95jQwVkj8on8g5U93oVTiPV5NLWKeV6H83NXyGXVVwrovzB	13102	3NKuEux8fTKzUeyCbwzcUKZpVda6nDEpsH1AwSbwbQ6v79XxgQyH	171	1248	191	6301	9384	jxopDsCwE9PX1gnYQoXNiMAvNCUqWx5QogLkrSJ38M16sJXcG4f	6753	9544	9544	1617657120000
13106	3NK8BvshvDnNsH57hsaYXbh823xSbwNmdSdX4SeRxSLyhPQJzZrC	13047	3NLGE4dSKt3B9RqqGepiaFoQYEL81nnYPgRszWrVkk1JL2Ax3NMq	1455	966	186	6301	9387	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6645	9546	9546	1617657480000
13111	3NLQpgbQxJh1K7TkHRwhW79o1pSD1XMGoqdweD1gESQDJvLca4e9	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	1407	1395	191	6301	9391	jx2MYp7VYt1Jxcv8mYWQ2inZjpgHndVgDbygvXCyYWZmGGvnizr	6757	9550	9550	1617658200000
13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	1481	790	191	6301	9393	jxpk5aR1unmSh3XwKJ8tx5FE8aTNnnS9btJRMQ9QQrKCWkKbV4Z	6758	9551	9551	1617658380000
13118	3NL7xU9ANh9AbevD5ueBn97sDyemKeaPoQM2cY1VP3gAm2ZgsLLk	13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	389	389	192	6301	9397	jxi5xpDdRwedNsWEi2qkeqvo1hau7AYWnw43BY4LnisW3FtB3Ma	6761	9555	9555	1617659100000
13120	3NLS4aKQkhJZR95yXgnZDjqwLBCSxFHxsMStWvdvMdsyos43bCY5	13118	3NL7xU9ANh9AbevD5ueBn97sDyemKeaPoQM2cY1VP3gAm2ZgsLLk	1642	1001	192	6301	9399	jwNrkKGKEfKMNh2WE6uZf9udzS41JhHmaCZyynvoz5BDeLPtxcY	6762	9556	9556	1617659280000
13121	3NLV9aDPVveFdCQg8FHBXcTPoK2ux3eLrGqrPS52BaNWyPSxmqVg	13120	3NLS4aKQkhJZR95yXgnZDjqwLBCSxFHxsMStWvdvMdsyos43bCY5	1420	403	192	6301	9400	jwidJKxuNrS1gSUPN8j57vxd8mkbMhjSikxY5xWpUYfoR6VuPDG	6763	9559	9559	1617659820000
13127	3NLZQ29z2ivxbVioEBTwcmC2xdxn4RRwPmxFnsuPU3AWNc3AGNM4	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1507	914	192	6301	9406	jxNsAHh4JBvzoJequN2VVHnFXBxw6B9py8npet2hoG3Kp4tJ6MA	6767	9565	9565	1617660900000
13129	3NLeSm2BadX7EWzK9fFGJHrzh9PHQpinCpqCZFc5hfeNThBeKfeq	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1553	776	192	6301	9408	jxcb9mkgEZYpQCtdNccEsGyFgzrg1Say5wVSFehT2vatcPpb7LY	6767	9565	9565	1617660900000
13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	13130	3NKieB1T2x1BCh4TSbcJfGmJCFLnTFnY2QRgYf5YqhjzT7Gq9Zn1	1513	1379	192	6301	9411	jxDrcg9T15TrkcF4FUS2zXVcLUfMcerXKTPwuNeWSMkm1VZjZzt	6769	9572	9572	1617662160000
13137	3NKykzkjLprQs8C2Ckv9aFsmm2fdTmKg21H9tvabvodhTuaffW95	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1407	1395	192	6301	9416	jxob66BQ8qPySwTi2PWMutuyg6ZKGkyLa78CcLnf1drf3SLCiwY	6771	9574	9574	1617662520000
13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	1652	1069	192	6301	9420	jxMMAMdxsFXRCMV4tXT7ko6nM6M5HBdCnZLx3qrtKGdzHZBHrVU	6773	9577	9577	1617663060000
13144	3NLYtNG4eosnMDmt4iYp8FKD7imVnYLT1LMBMCKSPS6LerkFYEvM	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1577	1081	192	6301	9422	jwQBLSUejZ4kMdEkgyJTZWyFsL5ATkfybAnkyhViiu3rRKNEjDv	6774	9578	9578	1617663240000
13153	3NLJXvF7Z8J3vkZawufNnyb3ahhxksdrx34th4kYf6kM4jiinZpF	13148	3NK91zKPwhy3dbohW5QLfbuRYbxvH2fVdXRaYUuN6nMS1PN4BV9z	298	1182	193	6301	9430	jwioYuNWWyvRKpVv6k5tegvyMwyx1EGdjSwih3fr86fE4kHSpHr	6777	9586	9586	1617664680000
13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1402	852	193	6301	9431	jxsd1TXBWcFQarLDUdiw8mEBREqaFv96F5BxbhDDkKmQsno25zc	6778	9588	9588	1617665040000
13157	3NLrm1wYzQoipL59nyuhLwtvYU6LPa9TL7z6mQ5QynPVTFfHupPt	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1507	1034	193	6301	9434	jxjDRFkF9FznJdvXQkDqDhh491q7kBsNi7VxuVHDPnee4bLx6gb	6779	9589	9589	1617665220000
13164	3NKpyBCa119qefFgwMPxmsCy48NYZShKsHz4uqZxBTvwKGd7HkeA	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1402	874	193	6301	9440	jw9dC4NjU5HkoZVEZaf3otBn1p4XhipwcQibLRPpMRVbmosnYsb	6783	9595	9595	1617666300000
13169	3NLUVhXgTpANqKSFxHjcvqutx8g9SHKZJEYcqpPFeayDskDMuQJC	13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	80	1027	193	6301	9445	jx86LNNBENo6FdoFgUUcc7dUkoJnJfUdmUvTCCzbRQoZXoxkhBj	6785	9597	9597	1617666660000
13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	1397	699	190	6301	9345	jwoYHJkRvbWM4zcZoGUzdmZBXqvPnebXPKPHsgF4HdbDEE63waP	6734	9522	9522	1617653160000
13065	3NLGaqsR7Qui5Pke24dPHhvqsqA4n3BHsyaARKZ9HZ73YboJPrem	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1581	777	190	6301	9348	jxHYC4BpMP9sgCRt3C2b1nbV4HA823m6Jm2LByUzwjqFXr2MRVJ	6735	9523	9523	1617653340000
13070	3NLBdsEg1q8oF4qj3CCtEr6YY7U73SffQtVKTZfwS9Khtd3YaHsC	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1654	1094	190	6301	9353	jxFxidZYPDBVGDtBxzWyCuBcHeuuuVeGVWFvFr4yUVYqmqsPFMU	6736	9525	9525	1617653700000
13071	3NKwRoBQUtxLzkPVz8jn1RKVb2Rku5ZfjLXwbuxXmT3Q5E4oiFdh	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	1419	814	190	6301	9354	jxRazDmdyB1hdaW2urTZEr4r8vaiwgUX1cH5mJegkL6inLMDdcw	6737	9526	9526	1617653880000
13078	3NLd7bZgNRT3utrtPpb3XkMCzVPQ5xiL6Mj6jg95atEQYprhS9CB	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1577	1201	191	6301	9360	jw8K29zJgrGhaQjm2g5gBM3C3LTDjmmzr6WuGX7Zc31Ws16mUNR	6740	9529	9529	1617654420000
13081	3NLhLfqZ3BraDWXetQkBdG8BqHR6AMFqPhc3nKezeTD6G7Tz2uPo	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1579	1143	191	6301	9363	jxyDkHgPVQG1Ajt58APj9noFChvg7k8XkJQSVgPU5mGoAnRy769	6740	9529	9529	1617654420000
13082	3NKHcCnyaQ7Xr1A3pp6YaxoZoqYc8hC9TDLuMBW7pFFjbP48L5mN	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1460	1078	191	6301	9364	jxt8eeAT53uGzG4VeXq9uZG1XjeAgxd3mQBUPSxnJ7PtCaPg5EV	6741	9530	9530	1617654600000
13085	3NKKZpkxGmTHHQmYBWcJg3iiRF8d6cbPBRxcYRxU1bf5QHcCPNtR	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	532	937	191	6301	9366	jwQYy3ubVWscBS2WUvCry5KDeygdAgiyF8GtWuMRbw56AbXaiCA	6741	9530	9530	1617654600000
13086	3NK42Q8sogk48iAPZ7xMNNzxQjuqrauP8tAgqb2oCU5XqENYAUDQ	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1541	1298	191	6301	9367	jxi5ykhvFzM6SuQg9DnAqaLmLCumgBaoofTLaaMbi6Q3LbDbnSn	6741	9530	9530	1617654600000
13089	3NKTxhp44B17QMwk3YhfeWayR5iBC6G4PDNz8QnRELSrpj7C3W9c	13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	1497	654	191	6301	9370	jwS8pCX2uS5pTt6apA6DWApuxkAB5HnKPEjSf4nDhfS3VCbMpAe	6744	9534	9534	1617655320000
13094	3NLFUZfFzAv5Z1HupSLGoC7Q2MVtzBGu3GAGZZX2zopusx8f8TSf	13093	3NLFMLZEWUtvko2p8XeLfRxd5FaSVJC4VxCAR4p8mQsaA8Epgq3t	1596	1363	191	6301	9375	jx5HY3KCkrRngUqnAujfj7umxxBSrdNytTgThemMta3DxxrRSXD	6748	9538	9538	1617656040000
13102	3NKuEux8fTKzUeyCbwzcUKZpVda6nDEpsH1AwSbwbQ6v79XxgQyH	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1403	40	191	6301	9383	jwXtvgYqmBiSdsWC1WPC7pJY5hmJKUq8F6J4RGznqX5BzJYx78i	6752	9543	9543	1617656940000
13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	13103	3NKUY95jQwVkj8on8g5U93oVTiPV5NLWKeV6H83NXyGXVVwrovzB	1649	1257	191	6301	9385	jwGdhiW3S3zVnTUfxcQs8qqqm3g4TYxdc8mrAwEiQ3pEvqNJbhN	6754	9545	9545	1617657300000
13107	3NL9h3xkswwYwbfXazLckLhhUBKC49k7x6i1qZxmNBGQrkbYMqq5	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1527	1293	191	6301	9386	jwmGCAwpUTSLgu8TMnNTB3w4fHLWwqDBevbXHVGuKRAsszQASWH	6755	9546	9546	1617657480000
13119	3NKiLxjbcsLwzGfutv88NGHJfCssr24qCE3kAgUmJ1F31Nb3q7qN	13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	1610	1188	192	6301	9398	jwwHeexjyaG3Ecafyn4UoeMvx9PniV5gzSybMmDB2Ns9TrYHHGc	6761	9555	9555	1617659100000
13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	1642	1367	192	6301	9403	jwP58rTwbDyBGasCAEMrY7c85wnXpdvHsPbrJ34E6ShW8xEFFpS	6766	9562	9562	1617660360000
13128	3NLBw8Kdr7SAxY8wDxob7rYQNwpKeBRNA7nz4sb41tgLLXcjfdCn	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1405	851	192	6301	9407	jwQiF8SnLwVXzcoLVEMKvSeDCGsaxdrwJS5x3j3Krqa5mdbwsei	6767	9565	9565	1617660900000
13133	3NKMhvtx4KUKeMeEVCU661NcJYC1FRQdScJ9n7Mmk7TmhURefMxM	13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	1527	1293	192	6301	9412	jwn7z3NG2VGWvvsYRxFmRS1BTuBt7QLDV2pQgXG6oJJiZdmP49Z	6770	9573	9573	1617662340000
13135	3NLB8osbwSdGkRMVFBhmuYmw2Qgrn1rnyPpbQVj2osGn8TQW4dYX	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1460	523	192	6301	9414	jx5doCPpHAa7jbhaH9Lep2LjPobZ8WztDzhVLpq4vmSBPPDYWAB	6771	9574	9574	1617662520000
13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	1637	816	192	6301	9419	jxLVhthZpm94m6EDKTvyn83S5Y4yKCCBUETdV5WqZ3NGcRAy61C	6772	9575	9575	1617662700000
13148	3NK91zKPwhy3dbohW5QLfbuRYbxvH2fVdXRaYUuN6nMS1PN4BV9z	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	1581	777	193	6301	9425	jxPg943mzG3ZVxo2UUBn73Y8aDKCHmKaZqdNRv17vJYiFnsgFb3	6776	9585	9585	1617664500000
13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	1587	1111	193	6301	9427	jw7wVEytvbmCNzpz4TQRrWXhJJVLFViRUncuwsCqhrJv32U2pd2	6777	9586	9586	1617664680000
13155	3NKAtE4AcAcRjy6odXxfctn44KUsMSAh9eNcSWz1iqApgYxH33vk	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1407	1395	193	6301	9432	jxrqAGkAc2GMDqTTdjp42LMyAskQLMzavc6hMp51vMmvfdPtBUY	6778	9588	9588	1617665040000
13159	3NKDLXgnRGm9Z7mRsHCptDuKed7hcMsPguYmc7U3z7ZvJpUbVG5X	13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	1506	1247	193	6301	9435	jwZWsQiKWTTDoWbaMLm4wu8RwJd7kmNcMbemM2QEB83E1VwtSRQ	6780	9590	9590	1617665400000
13161	3NLLjhskXwzz4G4Zg3nrEmR55RWDaHZdzHiiQZeS1TEEnypjBoZd	13156	3NL1qWPyLTNmmjZqK6e3j3WpogCJYkFVJst9rHuqe7kSnRNFqxTd	1553	776	193	6301	9437	jwnTQNWaHkoXd4yxogjWp56afMXFCxEu9jiakG2t6KWwgzQSPRd	6780	9590	9590	1617665400000
13162	3NKG8FrVveA8UYAjjGPZfP5nb9eGin395jm8usuiWRzwzZUDZ45u	13159	3NKDLXgnRGm9Z7mRsHCptDuKed7hcMsPguYmc7U3z7ZvJpUbVG5X	1471	1140	193	6301	9438	jwRDFNZjXzopffsg3n5ThM8R1TVSALdNfZKKtd7ZBNFUGYfUukg	6781	9593	9593	1617665940000
13165	3NLc6MWzZDD3s6U8UQ8CdMbiMNKk8uXRRQwdVfx5t8p8ii82y9Ux	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1458	1323	193	6301	9441	jxa17aSd4mCrXNyvrbyCYaid2KzinA1RFybDiM8hhgHFxAxYZuG	6783	9595	9595	1617666300000
13170	3NLZXSbDCUfQHitjDb7Zh414WPBaqKhyC3AMybQ8qcMsnzKiewWa	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1509	1194	191	6301	9446	jwJMC9jnkuH6f3J2fotmAmZZQwL5Q4hVWymCdC64V5qR9PTqStH	6752	9597	9597	1617666660000
13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	13168	3NLt1LKm2NH62itzZHhJ5hRjmSYykwgCpDdvoKosFwg9x1iFFTr6	632	1382	193	6301	9447	jwHsJtaPu28RgipFoMEenPnMG8heZDvK1mJhzjdfokojxPUsju1	6786	9598	9598	1617666840000
13177	3NKTi716amya5mHiFcqEwB6VXSpaAqfZMdR2fxWw2e74aXq8U61s	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	1588	1266	193	6301	9453	jx1wcNo2g7cfpEzFVXN9CHsEEDmjupYWKXgHftiAxWCfCHiN5uf	6789	9605	9605	1617668100000
13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	13181	3NKGcTmdZY5HaXSKVoTZMNVXXPEJG5MdchVu62ZxejWG9iAsPY3J	1542	1304	194	6301	9458	jxqy7aNKJPygrggjPBpJnr8Q1P2mxCa1RW1Gif1R3qp42dGAbWJ	6792	9610	9610	1617669000000
13185	3NKGAjiufvJG8zRAPc9mLJiA9UBkduz5vapX4WgT3gfhNjEWjv1U	13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	1407	1395	194	6301	9461	jxhxarigN6wv8XhT6neAsMsayWaTTCMxzfLJx4FEHnV6BpXUbA7	6793	9612	9612	1617669360000
13122	3NK9TKC2sPxFa9Yud1UAmgNyYoHDGYo4fBs12BZVurq45JYbQ1Fh	13121	3NLV9aDPVveFdCQg8FHBXcTPoK2ux3eLrGqrPS52BaNWyPSxmqVg	1406	1393	192	6301	9401	jxSC7gPqWKqxYAjEn6trk8hTxaJuu8qQm7dmGpph4G5R6p7WqHi	6764	9560	9560	1617660000000
13125	3NLxhnA9WjJLL9ezDEx53rWwcstcE1gtwXe4NBcvpVo96iHQXpKk	13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	1623	830	192	6301	9404	jxxWubAdY3SzT558u5HQ2ttAQYcsMtJKZweeFga7zQhstCPpaNg	6766	9562	9562	1617660360000
13130	3NKieB1T2x1BCh4TSbcJfGmJCFLnTFnY2QRgYf5YqhjzT7Gq9Zn1	13127	3NLZQ29z2ivxbVioEBTwcmC2xdxn4RRwPmxFnsuPU3AWNc3AGNM4	1553	776	192	6301	9409	jwqBRyLT7zfhPknKdeYpGvCnqm3oG3m81WjGLnDvziAMRnbHsnL	6768	9567	9567	1617661260000
13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1587	272	192	6301	9415	jxPqUkCtmjaXNA45NeusWa5VwEKLeVq2Mpa1VyaNB9gWCpWv8tC	6771	9574	9574	1617662520000
13138	3NKGtCbMicDUgzaHymSPZqyo8xZsx1C5MG98EKZ21fyJ7RYzuxci	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	1406	1393	192	6301	9417	jwUru4vdH9rrPS9WGNovLRB9ZMVyysT6EsmHmKy9ZgHKQNjv1RL	6772	9575	9575	1617662700000
13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1577	1081	193	6301	9422	jwQBLSUejZ4kMdEkgyJTZWyFsL5ATkfybAnkyhViiu3rRKNEjDv	6774	9578	9578	1617663240000
13146	3NLttvBj8EFBskKBd8RgVDenCpfiPMqec8uVuzRNgMyGGuT2m6Ze	13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	1407	1395	193	6301	9423	jwHquAUv6TepijwtK4ihPycSsDMe1fwEYFpfYKB97GRVgWpRnuv	6775	9584	9584	1617664320000
13151	3NL522V1mjFAg6784AubPUgL5owzuF9RSKD3TWJMpm1WNZzTr2ay	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	298	1182	193	6301	9428	jwF6EZGmEa4JmjFmQEq4zYpSb5nSfiQedCi7LEwSeESrJNGy1fj	6776	9586	9586	1617664680000
13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1483	1276	193	6301	9433	jxzBJjgYCARMDs5XRshqmepMdV6ZTJiMUh6T3r7avytShHeoeLz	6779	9589	9589	1617665220000
13160	3NKTY3YK6uiZ4iHK7a9x6e1dvD1u9J7wXWgv8oHbJtwJyu3e52kN	13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	298	1308	193	6301	9436	jwoKdqUU1sUMzKtGbEcQHfYiHCAxbHeAtFbv9TJSfjXsfwfMkim	6780	9590	9590	1617665400000
13166	3NL9YBBRJZoamB7FkzQduMF2MTWbEXzEcKe7cqWDtu2JWcFXbVdQ	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1671	1119	193	6301	9442	jwhqNq82pj1e2hfhcmnZsNXtb7Yr3h97qHEgeLT4VYsaWWGgxmH	6783	9595	9595	1617666300000
13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	13165	3NLc6MWzZDD3s6U8UQ8CdMbiMNKk8uXRRQwdVfx5t8p8ii82y9Ux	1600	1246	193	6301	9443	jxECM31z69A8jeFjrJoVcJMKShvLvXBzJ8ac1uoo4Apxhdf33yP	6784	9596	9596	1617666480000
13172	3NKdfVtt9TqUiQdrY9inhfUTbYLQdRooFS43MubQQeWmnzkxwoqq	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1602	1369	193	6301	9448	jxFUiWFyvoM3H2htSfG2B4Ec284A7vvrNjcAgpYJ19W3yrx8AqJ	6787	9599	9599	1617667020000
13178	3NKN5P1K1nwThLE55G45MAjLfbn94dLye2jEqgZLhbLEHaiYcrhH	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	1622	1110	193	6301	9454	jwze17MWTNjrpGHirAzoKk89EmJQaYrg18jchRwWzUtB4A6coDV	6789	9605	9605	1617668100000
13180	3NKSHFhYrv4JwLE185MpmALuMtaNRXHf1RnHz4CcZxHXvS1DWBQd	13177	3NKTi716amya5mHiFcqEwB6VXSpaAqfZMdR2fxWw2e74aXq8U61s	576	1109	194	6301	9456	jxPqvMLp9cGrnSb6D8uQa3rUXgreR5LfVMfT6bEqS8JVz4gH7mU	6790	9608	9608	1617668640000
13189	3NLAJ66fzGH8CTNWWrdSC35Qg7AuGm64tHUqqYj5iUDCvf2vUido	13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	1406	1393	194	6301	9465	jweJ12TQ5Nyyedb4tH7hCtHqAwRb1GavQWFz4AenM4pdmmkY6hP	6797	9620	9620	1617670800000
13192	3NK4DGoP9KgvViuargtKGwosGUusrLBVd69Ez9bB6ohjjBRgX2u6	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1577	1327	194	6301	9467	jwpVWK39DRBW3BfpkKPSK3Khz5bNwh9s3aK6JSapvsAemUUYXaU	6798	9621	9621	1617670980000
13196	3NLKDLPG2oqjucuZsHq7cWkRAwi2eNNuBxErqjA85QWec6NGb61B	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1560	1165	194	6301	9470	jwh99AJQeZnBtgLw9ZXMKU41d1jL4W9ypVj5q2keSxV99yP1dX1	6799	9622	9622	1617671160000
13198	3NKkJnfnWBgYZMPyqKPNyH2ahiKm1UE3xPADJbiJbK2opAUuxAZf	13197	3NKwsrZAyKuCXRGTkNfhG6RBZoaJLk7agKa71MMnQURa4Z21NtwJ	1546	1213	194	6301	9472	jxeGtxDSyw3jmV3cx9TgsnguJCu5b4Lq7PZTD4QdUGRq43Kks88	6800	9623	9623	1617671340000
13203	3NKQyaMExat1G3SetuDsdqqhCpx2aK4yjWnXBiBvivEumnFepZa7	13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	484	1073	194	6301	9477	jxKxJLdynzQi7iDCYgfRx3U3544UtufEmA6htZtyNuPRWPkPrM4	6803	9628	9628	1617672240000
13208	3NKELNcGjgMFp6E22j1XXLa8UKy5cWRKdXvBnLnA9k8XpPovTfkM	13207	3NLmRWWiVi19zPn9WU2GNTASGCMAS3jwFMy4n6DU9X3yex72zTGL	1481	790	194	6301	9481	jwPmisS6AY4sFhXHQsCwa92zk93KvUV4wVXKA9vX1a6pgDb5ChP	6806	9631	9631	1617672780000
13211	3NKyraYKU93pT7jMuk5K3AeoWbSXHYr383BH9DsE37ip2CEtVtyK	13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	1407	1395	194	6301	9484	jx5VwsM8DZYqbtoyfNtry5Js81zwYXyyTDPbLt1SHoMYDFEb51D	6808	9634	9634	1617673320000
13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	13215	3NKF1sLbGrS5KMpJ4HwsjHHjNiHU7f6fFnmz2iLxMnhFuoqwbDFy	1542	1304	195	6301	9489	jxiuieqiDJY2g9BGjf3zwL4DUJ3ZVWysxRkFsNwYnqrdjGtZWnC	6812	9639	9639	1617674220000
13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	1610	1314	195	6301	9497	jwzszpyy5TJmwQswhJN9rRDGwrJx6XMSWDCtGH7nGpBLC3LoBVR	6815	9643	9643	1617674940000
13233	3NKBXL28qg5mZEsqFXzxs6YwMDAg9cQYq1aKH7FgzQUV52EwnnDu	13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	1542	1178	195	6301	9505	jxzzAPBo52b2MvZUYTWhzW5cr2VsekcDoRFVcdnTg1SzYKHd6AA	6817	9646	9646	1617675480000
13237	3NLDS4zxNjYxgmQW9bRmdhGzRU7xP3CueLUeV4NKdsi3So7wcKim	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	58	1035	195	6301	9507	jwCc9KPfcX1k9fvuXjUyKCbusbKqbup3XfCrxyASrMtgQsMSaKQ	6819	9647	9647	1617675660000
13240	3NL6DvLcwiFBHvPnbxxgdyZZSsvK4Gu92YCteEzCddjmnxsEYdzL	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1555	1221	195	6301	9510	jxT7kbUBDMHUqiSpsBpnhw24zNY4t7d84fezuLi9B2rU8uiyfCq	6819	9647	9647	1617675660000
13247	3NLixJuyn8arbx7YKRnfy2fGuGrZTVW3dFhWuZjEHPYTZ5SnSPqJ	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	44	1199	195	6301	9517	jwt5aN5zvUWEpywwZvmHRngS5BXJBGGLmzF6nqnebpsNHci6Yts	6823	9651	9651	1617676380000
13254	3NLaxcNk89jMPjPh4f9hby3upmnhHkPD27UEsFxruzPga2ZRkyXQ	13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	1471	1386	195	6301	9523	jwAxpVGc1tsgunBAp38gkkk3eQtYqt1HMy5PVM1akU2w36S2bDu	6827	9656	9656	1617677280000
13257	3NKiFnphbZPyWCYdXMXXNfeT3UyiwZbuyEB4m3ZYzyv8x1bTBy1x	13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	1451	1292	195	6301	9526	jwgnTbF2S7d9fARKAyAsrPruQc12aQpf8TVH6uVLhbVWNXhdzup	6829	9659	9659	1617677820000
13259	3NK3HACXe5HPbnQdjm8Loy8p5HQvRjWgVSZFsRRJBteUZ1fTdKK2	13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	1623	830	195	6301	9527	jxurtGYsWVtKkt8iZXdr6XjCYDL8dmoGPwMY5cScmp3Wjo8n8Es	6830	9660	9660	1617678000000
13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	1407	1395	196	6301	9530	jwpj66pcqATkMSovmEqYNKw2A1YttxaKikSqZbN5XeCbfvhe6w6	6832	9663	9663	1617678540000
13168	3NLt1LKm2NH62itzZHhJ5hRjmSYykwgCpDdvoKosFwg9x1iFFTr6	13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	1460	612	193	6301	9444	jwNkV2PD5vLV9hnYerD7Ldzk1kVKtWedFicbLGCXdkf98t8pvFe	6785	9597	9597	1617666660000
13173	3NLd314XFewtMzs1yeFLc5eCTemz4AjTeiUSbWE9ripb7c1933Mk	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1397	838	193	6301	9449	jwbF9oep7gywXpuy4sn8yqAgG6YRRCKErocdao93zc4oX9Uxa33	6787	9599	9599	1617667020000
13175	3NKb8YvEBhrvEwTidzeYxjv14ftGKuz75KPWVyBMfLVKFnA9frE5	13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	1403	786	193	6301	9451	jxd4GAhR7dUdUQLa7HhR1xLmMZdG7vPXpfyDyvTmZPQgp2t6Jtv	6788	9602	9602	1617667560000
13179	3NLDXYmu4WHuVGwwBRbgdJqDsNg1kQoAKjJG6DA7prebB44sFKUH	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	633	1384	193	6301	9455	jwzGsRjHYvCopXbf6p2pA93mdZsLEs4Vicbmg9td1yiHxmyCbG1	6789	9605	9605	1617668100000
13181	3NKGcTmdZY5HaXSKVoTZMNVXXPEJG5MdchVu62ZxejWG9iAsPY3J	13180	3NKSHFhYrv4JwLE185MpmALuMtaNRXHf1RnHz4CcZxHXvS1DWBQd	1407	1395	194	6301	9457	jxYWzzqmhTMYm5y1AJZEbgBNjf2cZ8p6bk1ubUqXeSjWXURGNgB	6791	9609	9609	1617668820000
13183	3NLG3JE5NCXoHci3CJ65XPnikMGhQP6w4YNJ47yrisZgWXujZq97	13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	1542	1304	192	6301	9459	jwbUEmdMjovXQ7f2FgLnjzcfYfsTKHJxgRAsytULtkRmjdoiGJs	6758	9610	9610	1617669000000
13186	3NKgbeajxdPUsZaSDWuQXt8dPoEyFusc8EmNypirK5bS1xijUWgS	13184	3NK3e1z4xPrKGcp5eyBRiqiFdbLvFczhwXHypYdHRnTP5pFCKYsW	1407	1395	194	6301	9462	jxz1Wh4wTZF5mTKQfzRWjDXqrK9RzthcaF572NpHrxGSkB6BDbH	6794	9614	9614	1617669720000
13193	3NKSeNyBCjaQxKKpCv6fkqhczk3WzFhUinMKK6PQsP1iU1XfCTN8	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	484	1193	194	6301	9468	jwfzDeeFWRBedymAhSPaT3CP1AtaB4E3EnXQLFFTRK9YCLLZ261	6798	9621	9621	1617670980000
13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	13198	3NKkJnfnWBgYZMPyqKPNyH2ahiKm1UE3xPADJbiJbK2opAUuxAZf	1670	1282	194	6301	9473	jxAYuGubaJkjHbNKj3iETAJFpfkrw1Tfe3YCrSwSUUX1Y9fNT2U	6801	9625	9625	1617671700000
13204	3NLFFpKdVKrfMxVXWXxdB7wv4ynzq3xjjjf5NLf8M5xLDb6DzMUT	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	1461	1271	194	6301	9478	jx2jyiCai3JMh227ZuJm3CnzMSMsMBVoTSmGJ1vb3d1zPtUygas	6804	9629	9629	1617672420000
13214	3NK9P8KFt3nZzBgaGa78SH696zWydUWiKQ7mypR7KtyPqaG5jmGc	13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	1581	778	195	6301	9487	jxMR4g9c9KuQvUBCbyG6YMjxzEQJWvWjd6dvPuaUvV4AMuykvpT	6810	9637	9637	1617673860000
13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	1407	1395	195	6301	9492	jxFmxzvMByAVdJSviCAuetgvXZAEJBbj8WkEPtb2YgF7HuC9sie	6813	9641	9641	1617674580000
13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	1549	1362	195	6301	9494	jxodKzV8hEvEd4XGLR37mRT82B5hh3RMjrdP9iwprSiHnmqnX9e	6814	9642	9642	1617674760000
13225	3NLqwvtpsvX2jjEzPbuedCVj7cX1LfswWzZDGzTyUQX1kdvq4Lpa	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	311	1307	195	6301	9496	jwNWRVcqTZYKRMS3TFeYaLNBjBqrKjcAHyVi1zSbVRdNELhRjHW	6815	9643	9643	1617674940000
13226	3NKqWAjraKRYDuyykDJCT6T1kudRttNTpsMFrMXmhNkKNczFVBaY	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1610	1314	193	6301	9498	jxZT46J2aEdb73aB5AomWMH5KQY7UsHCSAL77jDg4pD1CmeFu5m	6778	9643	9643	1617674940000
13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	1457	1265	195	6301	9500	jwzb7mozcMHpLTdVJVvDaMEPXyoJfPzNG16ScgHJnL7nrqxKfhw	6816	9645	9645	1617675300000
13230	3NKc9yhsjCuHC8vzPeEpv69a7D2Q5vgUahA46Xn3cpu6sRHHNn1P	13227	3NKeksNaEC7NWcVSAm2ayFPnW9pKbdXrfSgsBVxyLGVHpVP7HYt3	1573	1072	195	6301	9502	jxGv9Y6TGKG3JsVaM4EEjbtEVu4GvBotu4APqJxZTaj1eqK5DGA	6817	9645	9645	1617675365015
13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	13239	3NKqS2BETkHvTLSRHdXSV26uyhzW22eScZrZSek6rtqTJccqmpCs	1457	1145	195	6301	9511	jwoehE5a6DFyqivK1V31A2SQxXnoHCB7p1asuvvxq3LF8L2GcgW	6820	9648	9648	1617675840000
13243	3NL4mdw9Jk5hGJohvLKSAPbX4ijsgQ7sMnYoh96P9nGynPc3xHrx	13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	1471	1386	195	6301	9513	jw7wDgZ7a9uQ1JWzNt4RDi3cnJpzxhbWcMgrWVFQHLbJ3UsJ8r1	6821	9649	9649	1617676020000
13245	3NLdauunvauzNKYsMYhTmoMC88deFAvh42BTT9DcBemMPTQPHH83	13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	1506	1247	195	6301	9515	jwLhZ7FFHGokcy3chdSZegXAxh9HRD5BBJ7KpQbjrhz2oPnhYzM	6822	9650	9650	1617676200000
13248	3NLhSgkd6Tmr64AgPsifNU6akWFvDWhhgQeKsZusmBLLhFJ3FhZd	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	44	1199	195	6301	9517	jxTq6M49J26pEZGCMrdmdE9sQB8NidnHRCfL4KWj7h9qvGtMZ7K	6823	9651	9651	1617676380000
13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	13251	3NK4txS45Dje5Qq2xQMs8CLA2YjdwWHE2vKmKb8BrGTirC18Fd41	1581	778	195	6301	9521	jwVQWzfzJXYSxpCW7bn4HSVYg5i6EFf7tbQKYHGbaU4WrbD4oVS	6826	9654	9654	1617676920000
13255	3NKxveJeQNoUUH5zz6sktjgvuCJL1qAtkc1px7LG6rmKdMr96pUJ	13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	1407	1395	195	6301	9524	jxYsC65xcUbE2gZx9MX6b3TeFCoyVP25e1Z6pZ6N1ntorfNB6Rp	6827	9656	9656	1617677280000
13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	1451	1292	195	6301	9526	jxLunb4CqrRVK7CmsK9b4TkxJoN97NJsT3ywomH85Sw4LgLeLjr	6829	9659	9659	1617677820000
13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	13259	3NK3HACXe5HPbnQdjm8Loy8p5HQvRjWgVSZFsRRJBteUZ1fTdKK2	1637	816	195	6301	9528	jxcweaqTA3sHuMnajHxXe49oetQqDXbLT9LhZtxJpMPU4VpXfv7	6831	9661	9661	1617678180000
13266	3NLCkucKArb7261V85rPhzxK8wUj85GQzCyfo6LwTdmmC9mZMVaB	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1407	1395	196	6301	9532	jwtSyULf2wM7zx3Qpw8j1pgDfK7h7FgHSvP32bTLwwXTzHQAbWL	6833	9664	9664	1617678720000
13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	13263	3NKJBT16kFScC8C1abNVs2CuNZjnG49YLmXxUUWS1wdaCtivHLJC	1406	1393	196	6301	9533	jy2ySrvtYT74Hn9n6ku775dLST4nknSLYUaMP5oUPFFW5fCRy1B	6834	9665	9665	1617678900000
13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1594	1326	196	6301	9536	jwmTHUBLDE2TdG818gFzx8McHPmyssyBTwenrVm8SgovUCEGqAg	6835	9666	9666	1617679080000
13282	3NLtjqLSx5cgTMjQKMefH3gNwS199eECX6MdUSZtFwUnMf9FKYUr	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	1581	778	196	6301	9547	jwYjKQnpHk5M1ADehMoHZoA7sHNybQ8SfonEUoDx4xvsKCAzYVW	6841	9673	9673	1617680340000
13286	3NKimTMmfjzyVqgUmhG6Qwiy7aM6yaoT2EK1pfGJCbgaY3Tcc7gL	13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	1406	1393	196	6301	9550	jx1s3FVzxpCYJUSNYWSnVitzLGf1v7LYkYHndPAF7VbgXmXAzst	6843	9676	9676	1617680880000
13288	3NKbBRSpjpX7JSPzGr1RXceFmcXSpmDqjRAfFcWu5J1MDX6UEEPg	13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	1649	1383	196	6301	9552	jwPXLMQhwG5QcJSk8jYrnYxiaDmVhUTaDuMF4Y1bRvHRX1hKHR2	6845	9678	9678	1617681240000
13291	3NKaVHQFbaryjB7Jt9vendVvzSQUcUZX8ciFXS8V9Jqdah5cAHek	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jwCxao7vU2z7ofnATYZKjzfYJZxk3EN9aiyisX6qX4asow5BYLA	6847	9681	9681	1617681780000
13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1507	914	193	6301	9450	jwnf27KgNKx6v1CZJVZ5c1FmjtyW6BvRG52FpVDC28dYorTCwTy	6787	9599	9599	1617667020000
13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	1594	1080	193	6301	9452	jw6f9dPG4uMQawSn3NXFMihaQF21qzoyrsSRu7A1qEoSMfkRHH3	6788	9602	9602	1617667560000
13184	3NK3e1z4xPrKGcp5eyBRiqiFdbLvFczhwXHypYdHRnTP5pFCKYsW	13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	1447	1345	194	6301	9460	jwieW2EP2XajA4yx3pnUGwdGUdtFd6S2VzV3VJfnbnmQLjh6k85	6793	9612	9612	1617669360000
13187	3NLAcbdJpiMrwqhkut7ZSD9k5pUrwU57UbTt5hmrjDVSe4S9Auig	13186	3NKgbeajxdPUsZaSDWuQXt8dPoEyFusc8EmNypirK5bS1xijUWgS	1594	1080	194	6301	9463	jwxK1ffzThFDZezorjdWV3mqQs7Qq22eZRuf7hZibUZFM91ZBoW	6795	9615	9615	1617669900000
13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	1564	1338	194	6301	9466	jwfhpf711F8Gh6g4gsimhUqWJFWG99XBEoS45V2zdbNga7t3iMr	6797	9620	9620	1617670800000
13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1407	1395	194	6301	9469	jxvXECnzG1Qcd32YJ87hr63ewnxq1wa4L6UnJzAYbZWTFP1eMkp	6798	9621	9621	1617670980000
13197	3NKwsrZAyKuCXRGTkNfhG6RBZoaJLk7agKa71MMnQURa4Z21NtwJ	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1481	790	194	6301	9471	jwB4MER7aTYkKHpmyS58nET7RxdhnoTcVDCpYvJqxtecHFjkCcS	6799	9622	9622	1617671160000
13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	1578	1296	194	6301	9474	jxRYhsr5yDUuZJrq2zsuGDUih13RGAiG3p31sNVyLUfHbdVonTM	6802	9627	9627	1617672060000
13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	1406	1393	194	6301	9476	jxCfWG9381jNtqxzt7AH1xULKurNYHn7FqJRekeypWGzfp16yCs	6803	9628	9628	1617672240000
13205	3NKBZYZK4c9QByeQqgmwyCiucr4VEbMJUu5WTzfivPWjdU8KyXi2	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	470	943	194	6301	9479	jwtEbvHTsZVSdarpzPUwv4JyvSz8c2gVAn2T6EJ6NG9NtkfTHVr	6804	9629	9629	1617672420000
13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	13208	3NKELNcGjgMFp6E22j1XXLa8UKy5cWRKdXvBnLnA9k8XpPovTfkM	298	942	194	6301	9482	jxN9tmD5Da6pTPJG7covZq9a2TQJ4Pv9ZyskwbRfDrUy2vqboy2	6807	9632	9632	1617672960000
13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	13211	3NKyraYKU93pT7jMuk5K3AeoWbSXHYr383BH9DsE37ip2CEtVtyK	1403	824	195	6301	9485	jwK58kU1c975vhKtazvB5t8rZCDZtGu7mKXmMabfXrjBpWqBdiC	6809	9635	9635	1617673500000
13217	3NLLvYR94XtKs9kbnrC47dNEZjw3rBxRDJfQ2WqdiT9WW3MwbaTk	13183	3NLG3JE5NCXoHci3CJ65XPnikMGhQP6w4YNJ47yrisZgWXujZq97	1542	1304	193	6301	9490	jwZioJqRGhiSWEMjLKwd37ri9CrkPvoZJVXBruj7m7ry7SqLuVF	6759	9639	9639	1617674220000
13222	3NLy5Kz8CAJkwFJx5d2GjcAG1ctH4KiQwaY8tMwB5zx8FWCUKkyn	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	1670	916	195	6301	9495	jxrG7rbjugqBHabVdPRSmf1nPqNePKyEUm3jyZGz7BoYoUJ69YF	6815	9643	9643	1617674940000
13229	3NKjRw4b9LMDQGgtVg64giXMmivyMD4T5uqHTwUrbG4SFaRTYC5g	13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	1573	1072	195	6301	9501	jwAQi8Y8w1DMdAyZinfUrHo9kwupnk3j5KhXr62TANN5HWxTtW6	6816	9645	9645	1617675300000
13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	13230	3NKc9yhsjCuHC8vzPeEpv69a7D2Q5vgUahA46Xn3cpu6sRHHNn1P	1542	1178	195	6301	9503	jwMDp7kvpAdweiEYRMxQ4FaPeeDc1npAgnYZG4giN5rAEJgrWd9	6818	9646	9646	1617675480000
13234	3NLwF1hJSSVsaEHg7P5VPsSLxBaZ8coDvoZSrdUX6uo9B4GneSET	13217	3NLLvYR94XtKs9kbnrC47dNEZjw3rBxRDJfQ2WqdiT9WW3MwbaTk	1542	1178	193	6301	9506	jx6qwVS1EJ678SQaJA8W8u7ZSaWg14FGZHNauvXjwi4DXNjAzsy	6760	9646	9646	1617675480000
13235	3NKcVsJJLL9hJjvgF7PsG3XSArndEgPNMfX686qpqqsUGzyMsbpG	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	58	1035	195	6301	9507	jxVRiqd4L6LqgUuLt4NCyQ3KjM9HvDaJMCoNTniQnCCLCUeok79	6819	9647	9647	1617675660000
13238	3NLGZE9utWLEQYxe2Bywt8RtHU2YeuvHaar4pvwcfWxVqcsJrFsw	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1624	1208	195	6301	9509	jxfLRfiC56R8e5ffhx8TiHAC1zomU836pYZCBDqjGjg7n9owE3v	6819	9647	9647	1617675660000
13249	3NLwhySMbeYL76n4kFwqbkvmbAKXQghCmnYVpMQXeL2Y5FZTJajn	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	1652	1315	195	6301	9518	jxax47vmJX9bNNPFSiE2cWR5viCN7cn6QsKMGY4i2vsZ3xwi9L7	6823	9651	9651	1617676380000
13250	3NK6gBH4KspY76G2RHuvqR5PqgLimftuinFHtm3EmYGCdH9eB7HW	13247	3NLixJuyn8arbx7YKRnfy2fGuGrZTVW3dFhWuZjEHPYTZ5SnSPqJ	1444	1255	195	6301	9519	jw84pqy1aAKZWwKe1gJo7iA115J2zZn8VYzyTifGAHU14kYE2MJ	6824	9652	9652	1617676560000
13253	3NKZtCon6RWwEscVNQ4a5Q1kUq8H6ne2SpQmiTLkTtcRSGvw7gXv	13242	3NL7mbWHMWDfJpp6Hidq3C6xF3ecxCAEt1RSaLddN9Sy4fQJ7nad	1471	1386	193	6301	9522	jxe8YcLDz1Uc13YTnUMmETefQFDtstt4azKDxSKAhP3hydn2RDr	6788	9656	9656	1617677280000
13261	3NLCDXz2HrxqBAuHBStcj8KUKGAhe9xmcZF4eLgBUEG2XDMXoPaa	13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	1405	857	196	6301	9529	jxsPzZyUmGibkV3waUL2f8ke21S3fa8NYK43syK6fkpzvfaFf91	6832	9663	9663	1617678540000
13263	3NKJBT16kFScC8C1abNVs2CuNZjnG49YLmXxUUWS1wdaCtivHLJC	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jwsY4CcvbCkfSAQFxMBqE3UPBLT3CNAdGu2TmYRAwfcknHbpwwc	6833	9664	9664	1617678720000
13271	3NLSpkf3tVdeBv6MHJVmc7r7tKbQv8qr1XNWWPxuDixvb2Rt3svd	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1651	1301	196	6301	9534	jxdCywHrUkkWwxY59Nj2rUVudLV1vg9ZgN71PhBrDaxwzudySEe	6835	9666	9666	1617679080000
13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1600	1126	196	6301	9537	jxZGtpA3hG4xAZ4qTf1FhgTDKKFusX2PnrTiJASa4kH4RzDMsNH	6836	9667	9667	1617679260000
13276	3NLYrnpjJpMMJq8JVoY1cMDkwZbzxxMkZig2Pe5E3zmVAhuzXmFJ	13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	1637	815	196	6301	9541	jwjcy1Sz3i3cZWArSviyaYRZY92uYhYRRZXpPZ2YMQXTrc7xL8M	6837	9668	9668	1617679440000
13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	13278	3NK658VsxQBX9SANW86AuqHj1yLnS14HSMLfxZ2SUCdrfD2itJyk	1637	816	196	6301	9544	jxMNXffBUqvhz8ukXRiXjkwAJubXkn5WxNHVJDKE6DomxSkkhAg	6840	9672	9672	1617680160000
13283	3NKVyxVAMCHMPYrnbXR3dLpATaZgPi6wpm5GvqfjbFY7YY19iqUd	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	644	644	196	6301	9545	jwpiBJ7DFjLbYX8MvRmMSFADJwfN3YfdGwo8VnR4cCF6dxzwf8Z	6841	9673	9673	1617680340000
13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	13283	3NKVyxVAMCHMPYrnbXR3dLpATaZgPi6wpm5GvqfjbFY7YY19iqUd	1506	1373	196	6301	9548	jwxdbQdqdcUV8expeJtPy2uVEjNHLhBbRxocz6DLEygdBQxvSdX	6842	9675	9675	1617680700000
13289	3NLVWGtJkUr2V614wr7jA3HfywqCrYT9YwCh6tb7vi3Fa11Psf2S	13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	1513	1013	196	6301	9553	jwcCBj7CC4kERnnGWyD3FndQKweh9EioNpttku2d5WTtR1acm7V	6845	9678	9678	1617681240000
13292	3NKzwzWK1YuTAt5pcfKAwkBjB4zYyLT8tHPJVgm4RXMvteKXBcqi	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jwt7x5pSZNRn3XRHShxsbcQu9444Wca3FtiWWLfRUiH57ciCBfB	6847	9681	9681	1617681780000
13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	13187	3NLAcbdJpiMrwqhkut7ZSD9k5pUrwU57UbTt5hmrjDVSe4S9Auig	1609	1207	194	6301	9464	jxdop6uZRvgTEKYPRWPz9X4uthEY9opKkXD7vRvSTmgRpjQbxVg	6796	9617	9617	1617670260000
13191	3NLLL5b2VWhB6kWbw5wPM7hFJ1E7kvcZHawo74WteGGSgTTQDwwp	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1577	1327	194	6301	9467	jxfmBM1FQrZS5UZtpunstcyi4JxD43hd58FCxKevgYFADzuri8S	6798	9621	9621	1617670980000
13195	3NLeazoAkrCEUeqqWvNwhjFqoUgmMqVuvEKUbMiazDSArhJVdeXa	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1560	1165	194	6301	9470	jxQHvJgk6Sxt2JarzEszaAgkn1TVtVMgXZrY2fnvshruYLTbCxU	6799	9622	9622	1617671160000
13201	3NKcxscmBCyiLJAMbRFRvskK3LGiUGdWkrj4kTAG31yXvNqsBu39	13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	1657	1344	194	6301	9475	jxGdXKd3aBo35dz6mXa4HUsijbLdPTyqruoRgrTtRdrh6ZUdDMg	6802	9627	9627	1617672060000
13206	3NKJN6uBDuq1dVx14QxWKuJeu56pkUAeNLgVVj5ndbbXbykhLTac	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	470	943	194	6301	9479	jxRkiG61UsakgG54c8BYBzYpMw5vhisZhxisemmnfyextejabJ2	6804	9629	9629	1617672420000
13207	3NLmRWWiVi19zPn9WU2GNTASGCMAS3jwFMy4n6DU9X3yex72zTGL	13204	3NLFFpKdVKrfMxVXWXxdB7wv4ynzq3xjjjf5NLf8M5xLDb6DzMUT	1405	855	194	6301	9480	jxy8UWeVVwwftvdwrG5z4zxu87GnkXpuL6LwU9oP5nCGJbE9q2F	6805	9630	9630	1617672600000
13210	3NK8qcuYPceK7J3gaQvMzx1fe6c11YngDQ2GHUuNVnmk2q6NdEdL	13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	1406	1393	194	6301	9483	jxsd6Dr6MsSGmrqNdDM1SrZ3E3tB3UUXTTtms3iowcrhkzZtxs5	6808	9634	9634	1617673320000
13213	3NKioz9HCaV5dTjXMrSXtMoNf4uQMvcD9NcAXLMUxJS3WcRp8APX	13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	1609	1087	195	6301	9486	jwWgDsN59vbvRGHrvKYg8WvYVzbtzsixGnVTUsNDwutQ5b42Rq1	6810	9637	9637	1617673860000
13215	3NKF1sLbGrS5KMpJ4HwsjHHjNiHU7f6fFnmz2iLxMnhFuoqwbDFy	13214	3NK9P8KFt3nZzBgaGa78SH696zWydUWiKQ7mypR7KtyPqaG5jmGc	1608	1043	195	6301	9488	jwqhQnnjGaDq5rQLpD2WVi5upvsfX59ppYdDNGrGnRnHPPTrZvb	6811	9638	9638	1617674040000
13218	3NLiyeS7n33vneBWoH7VFS5gtCgcW7aVQJjbitWsGd58Cj8WPJKz	13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	1406	1393	195	6301	9491	jxtnR19mDrD7N2xJVDqQ3kJS4F8MrhTWWPWdvxLP32gLoCCsUTj	6813	9641	9641	1617674580000
13220	3NK52AxtwLJpToHd28CkNovhJUAAY7TDDUMHkpRwoaG27bnsvFkt	13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	1593	1346	195	6301	9493	jxwaVZHJJ36dXBMTUvYt3GwTQaErWRVPmzsoRzeRw6eac4XTtow	6814	9642	9642	1617674760000
13223	3NLx7NATMPkncEAv3c6nd1Rt9mayAZY619igGsfdQMmqWX5u2QJL	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	311	1307	195	6301	9496	jxzqzdhba5z8JN4YbpF4d9VmdCu3d2qBpYKDqyEFZjCQwddbn3c	6815	9643	9643	1617674940000
13227	3NKeksNaEC7NWcVSAm2ayFPnW9pKbdXrfSgsBVxyLGVHpVP7HYt3	13222	3NLy5Kz8CAJkwFJx5d2GjcAG1ctH4KiQwaY8tMwB5zx8FWCUKkyn	1407	1395	195	6301	9499	jwupEAP3GKZ5BddaLjU9LN2jQTkKh3EiQkRvj4EVdfi6QfJ8F3V	6816	9644	9644	1617675120000
13232	3NLD7CMMjJ6TRkSE4ALsYZehPddAqF8FS7zHh5RTTrL5Bb4c6LFM	13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	1405	851	195	6301	9504	jxWrevYo3rjV8S8gfkzXxBwywexSiwn7MNPWUEV9pUaW1aMzE8o	6817	9646	9646	1617675480000
13236	3NKmLuj7j5DD2ByxXQ97nUqCtvwct6p8vHzfeHNiXXSowrrjejkW	13233	3NKBXL28qg5mZEsqFXzxs6YwMDAg9cQYq1aKH7FgzQUV52EwnnDu	1648	1284	195	6301	9508	jwuH2y5zDmk1L1KNaLiZVnVpATu4i3uPeeeBeMsqcqUZ7oBbVdh	6818	9647	9647	1617675660000
13239	3NKqS2BETkHvTLSRHdXSV26uyhzW22eScZrZSek6rtqTJccqmpCs	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1624	1208	195	6301	9509	jw7cNc1RbcDGbfTAMRRmBEskRxNmh6ixZmKYST4AySho5M4NzA3	6819	9647	9647	1617675660000
13242	3NL7mbWHMWDfJpp6Hidq3C6xF3ecxCAEt1RSaLddN9Sy4fQJ7nad	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1471	1386	193	6301	9512	jxiX3oVD6hdN4dx35imTP2LV96GtmckdDVD8Y47T9NhoF2rQ1vk	6787	9649	9649	1617676020000
13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	1579	1389	195	6301	9514	jwWzcifQbZxuYnHNJ3xUtNKDgEaaPbxBMkfdpWidh3UZYhFNp6h	6821	9649	9649	1617676020000
13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	1623	839	195	6301	9516	jwSVAuntF3f9z4EfinobXWzbYdpRFYK8C5XWa2EDDBsfZcB3Kmy	6822	9650	9650	1617676200000
13251	3NK4txS45Dje5Qq2xQMs8CLA2YjdwWHE2vKmKb8BrGTirC18Fd41	13250	3NK6gBH4KspY76G2RHuvqR5PqgLimftuinFHtm3EmYGCdH9eB7HW	1578	1296	195	6301	9520	jxqYHxgbAr8cdLubHip6RxeLJCJsyt1PhVnEC9UpuRwz2cdbELx	6825	9653	9653	1617676740000
13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	13254	3NLaxcNk89jMPjPh4f9hby3upmnhHkPD27UEsFxruzPga2ZRkyXQ	1585	1366	195	6301	9525	jwcKD33fJ923N4XTnV8S3mLvU1vPACkFaVBV1owRiuiX6VuRrsN	6828	9658	9658	1617677640000
13264	3NK5EDoBFGF22HhVCqDXEsn3XwWFyGBzukh5nraeEUhawEFtZBbS	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jxQ9sdCruozbEgdvdxjV8D2HX9VpZPBa2HriCXkXJxxxEDpgoEG	6833	9664	9664	1617678720000
13268	3NKC9HdcxCU4pU7bGNAw5gYDzbBX8oazEETZ2C7p4HKyyo2rfGMo	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1651	1301	196	6301	9534	jwEBvTeQ5MUWkA4mqihuw1swB2uhJfygvEteFGr6xteJwDgBuSV	6835	9666	9666	1617679080000
13273	3NLS48HN6zNzyKuW5CJyeMXE3SUt2f8FdJKfJcAu56HZHzkZoX1g	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1406	1393	196	6301	9538	jwwSWpJNNw5uc9VaFchgnrN2znToATeb26ybxfjZaC7n3MbkmwW	6836	9667	9667	1617679260000
13277	3NLQfH35k1b9ZKn9GncFm9mSuSDTSaiF2zxPtTmRdpGyEHqJLLip	13276	3NLYrnpjJpMMJq8JVoY1cMDkwZbzxxMkZig2Pe5E3zmVAhuzXmFJ	1536	947	196	6301	9542	jxhusFrdSmTd8MKa2rWug8eWfFjS9ewmzAk9XMUp4LjXo4c65NF	6838	9669	9669	1617679620000
13280	3NKNBCL4tb8sRTiYwNhq9ps7c7uoJDmQWAK8KseG7MWBRzbbShyc	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	644	644	196	6301	9545	jx8UJmvxHj18KDdY4uAVxPmSgndFPuKnqP8DghDZxAHwfyk8TUd	6841	9673	9673	1617680340000
13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	13285	3NLk8BscW1MT4sUwjPeUEwt6wR64a2j8G4pVH696r3rJRyw63fbC	1506	1127	196	6301	9551	jwsdKe3SjoxGiKJoeSegevp4muyiJZTPEBgwU8RWonPCJT3J97n	6844	9677	9677	1617681060000
13293	3NLd9F3XuoCn1vYHAc8L9f83NqWaveFEv7pQRobB9sWByojPd2xW	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jxtiKiUjdhVWb1WYHjYWPseNEnJVxWNnoDqydGAgd1XRxnxK6N6	6847	9681	9681	1617681780000
13300	3NLLPxxxKCSsLetW9PajV6GJjc5ESeRfwSAT6iYnhbG7eBBkS7zX	13299	3NKTzSDkFFWVqj4N6Nk5iU8fatPNe91V9kfBikxUxD8rWDYbKtMo	1607	1348	196	6301	9562	jwV6dizWYP8cwc2pq395six4MLktXEvXpH4ViyGbn1PRdirSzUg	6853	9689	9689	1617683220000
13305	3NLnwzWyFdB62VeczGXg4UX82XrdeSGpT4LztNGUFuDuZyWf1MT8	13301	3NKQV5qA4UWK35Cqu9gb66h5KDrUxtM5hMfh2NqmV2Ui59kW69Ko	1458	1197	196	6301	9567	jxHHHZwN8fLMoLXxhX7H1DHuSd3etAaw7L8w4M9nYSZE77CNgCz	6831	9693	9693	1617683940000
13307	3NKHN4mmYtUNtdvYprqoAK4FBpJfiX4WoLXAQWrHa1FvQT132GkV	13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	1483	499	197	6301	9569	jwHt4zBc2zRenWuEqFqQUe12VcJV9w9KrMMWefvHzmP7zWSMBXb	6857	9694	9694	1617684120000
13312	3NLeFMh5xG8gZiDP3vrWEN1tG9TEzMQiFPNscGGDpSmZTQkGnVXg	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jxdsZ2kAfnVbXee5SxvPqg45Miq1ZqTZ3xyQc5KyC6anynhHoXd	6859	9696	9696	1617684480000
13265	3NKF2EKV3TS4jhs3nFoYMwomG4nT6hewtivzuuT5khvWjPCmQytj	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jwpHh9tNjVT1bmjt5mB95WKmUKrmXyk7vzss93PdUVbwuKVMauR	6833	9664	9664	1617678720000
13269	3NKgT3PPRDXdXBNgV1m6uknfAW57Am2CTcZNDfpz6mnKbrDTQyCw	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1474	1329	196	6301	9535	jwRjfVxr4Rzr2m5R3kiVMEsy1fFzFapAEj2iseJBjDUduFjuoGN	6835	9666	9666	1617679080000
13274	3NLp7dqzGERRYfgFa8FDHoM2xxk96QZYFFDviZWDxvP1yo56EVzg	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1581	778	196	6301	9539	jxKY3qttftsq85fy81m87ZfUKeaJu7ri8ep3ervqKn4DeyyFTxA	6836	9667	9667	1617679260000
13275	3NKRxbEBdXydg2mM4vCAfQNRAQMELLhYT16w3GgRdKtm9V222uvP	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1555	1101	196	6301	9540	jwKxGJyvnBXQcwxTMdFRzuEwnxnjDopFFjBx6dkCesWY8iskJGz	6836	9667	9667	1617679260000
13278	3NK658VsxQBX9SANW86AuqHj1yLnS14HSMLfxZ2SUCdrfD2itJyk	13277	3NLQfH35k1b9ZKn9GncFm9mSuSDTSaiF2zxPtTmRdpGyEHqJLLip	1407	1395	196	6301	9543	jwzzTvoRn4vWXgaA2DaDbPVQVuka4mh5q2sAeUG2nUvYB3pY7qP	6839	9671	9671	1617679980000
13281	3NKdDsC6xfF6MoqLra7m3tp9as3pYHd6QKve2ageKjA73So1wWf3	13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	644	644	196	6301	9546	jwnatXoEn9z4SEwC1BJuFVTPC5KxynMiHSJCeeQfrT2F2M4z2XD	6837	9673	9673	1617680340000
13285	3NLk8BscW1MT4sUwjPeUEwt6wR64a2j8G4pVH696r3rJRyw63fbC	13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	1589	1160	196	6301	9549	jwXx3qW1fpPs5RBTt7YATK9FHkNGxXZ7Y67zpBAXnRnUJKwhC8M	6843	9676	9676	1617680880000
13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	13288	3NKbBRSpjpX7JSPzGr1RXceFmcXSpmDqjRAfFcWu5J1MDX6UEEPg	1541	1172	196	6301	9554	jwNfpE5YszmCaNfodvsZXSoaUm7LE5H65hkG8UTcj6SHRgeNvRX	6846	9679	9679	1617681420000
13295	3NKt4WbkF2atVaBfVv95EAfAikxw7YnmsLET9gNWSv7AQt5H2SuS	13294	3NKQYm6a8vgz9ZwLBRXjGTTzXMzU7acHKWCn9m2ixywrPuiwqaB1	1405	867	196	6301	9557	jwJx4MJZBu4FCJBnNL6FEGfR5gzdPtNeQFtrQgKPgKggnzNrZXL	6849	9684	9684	1617682320000
13298	3NL3toXJ1rGh7DuycfH8JyE82mnNdoGXYoyygELpVKpnWi4bWr6C	13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	1405	851	196	6301	9560	jwN1KSTZb3L5ZMfVADnNSJ3X71Xk42utYQDwgtbYa7CHC38H448	6852	9688	9688	1617683040000
13301	3NKQV5qA4UWK35Cqu9gb66h5KDrUxtM5hMfh2NqmV2Ui59kW69Ko	13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	1458	1077	195	6301	9563	jwNpSutyPhzun75ysiwFqoPr6MF6T8YdPnJUpYvQ8wd4JddGi8a	6830	9691	9691	1617683580000
13303	3NKGgWXgaMwPKmNZawoFaFSj6BWgnUAnX4K2DfGFGUFRsB38X8gh	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	1600	1372	197	6301	9565	jwiLQ9SNvzcx7ruiU7DTvDwL94uoJMWAuaXCB3czZ8ZYsbJf26p	6855	9692	9692	1617683760000
13310	3NKnm2PG4dVWNuA58mVJpu3SmnmA8wRkgd2WnvvSGvNbuYzfiKpw	13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	1650	1375	197	6301	9572	jwWo3cvQxkribRx69VbhPo4Ho28pkR6ozVUPkNJYn6CxaAdSiUv	6858	9695	9695	1617684300000
13313	3NKB8R9qLut6eeeZUyW6CfyTmUMABtADMsoUMrzmrBk3iKeHAngR	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1534	1191	197	6301	9575	jwTB8XFhATTwCyqhHSzLgfHAuj8FrUBuZtr9iPFiPQZWK8owVC7	6859	9696	9696	1617684480000
13319	3NKM6o2DVEjYZ4iMDShhxRUW9Diw8MsFhArESgvQNvmYfTTisQER	13318	3NK6GfyT99L3Wpd9ST9pExjhKNeyLptq1oh7EWkeYKuLgBzzMzEx	1445	1290	197	6301	9579	jxowAi4Nc5UrbFQfDab623iPauX7cVh71Y8gmFnfmrbh4XMB5Rw	6862	9699	9699	1617685020000
13322	3NLkYRW62VWm2WPZ2d2PH4H8HVS3KHivcLpNh9TTXVf6iFsHRGXN	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	633	1258	197	6301	9582	jy1kH4vYuPocXmxk2YA4QfYmEkdkuJfo4Wedq7PisYwvB7aaBWr	6855	9704	9704	1617685920000
13327	3NKm5UUmyc6reg5v8TfNh5GgDwWHRqYChBY7wmybpYH6VMAiJJUY	13178	3NKN5P1K1nwThLE55G45MAjLfbn94dLye2jEqgZLhbLEHaiYcrhH	1553	776	194	6301	9587	jwC2sK8G6aaZRDiwUc9u6fo48sTqDFYFiibqsXgdkfBrAfCKhpx	6790	9708	9708	1617686640000
13333	3NLnw1S5re45muKFWbLYqALvpoD2cfvj1HFJnGnj8hPAuKx7Bk2u	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jwE7z2JSeoFmSMVkZyTiaEA9mBjKvNfCM1z4b29y29Lh6pSe2nn	6872	9713	9713	1617687540000
13349	3NKGAPQ8C1RxaQ3oKBirnYbbQmPgyRGUbnepPRzhnNBY4Qnz7Bcc	13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	298	1308	198	6301	9605	jwcyft9iongKSi4WupVdF6KmdPtei1142EbuZFFWJSNuoXcCMyM	6881	9723	9723	1617689340000
13351	3NLPuWfgnzh3jmnU8n6mk8F7Tzx7g3quhXm8zes7KX5g7CuWvsvM	13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	298	1308	198	6301	9605	jxyAyorEctxvL97UVdEx9oXSWW3mrtK13aZf8DYXZQUw6DodwVt	6881	9723	9723	1617689340000
13359	3NKS1h1f3n3tmJKm3BcRRtUpSm6cFAtNi6TaVJinwcAqPZ7BqStr	13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	1652	1069	198	6301	9609	jxTrdh1nHgt2hRhZbEHtHUqAEJCZ1XV7tJNYjPDd4g9sUDsJUzR	6883	9725	9725	1617689700000
13360	3NLGsPFPn3LPoodLghYi5DcFrBJg5DWdzbFzCMUBNizCSUkjAtpM	13355	3NKr1Q61FbJbyPFeGLvmD6J8rc6msW3Z46yhL6sGGPtJATfBZWDS	1654	974	198	6301	9611	jx3UGgDUhrgTHV448zcMBTsFCLNkEVx2TxWTc92JNJupkQjuGEC	6884	9726	9726	1617689880000
13364	3NLEGykfBGQJngKD4sLpxB7gJdB823qjK42CqYeBE1EJDh2XcWNt	13363	3NKm2nBsgMxkEeq3Hpznh6kdavxp52iJp3CBwX4W1j7JZbbCemP3	1481	790	198	6301	9615	jxAoub89yM5zP95VdhK4kU15Wrg8oqXUwRuAMEGQ3t6dv4zyVho	6886	9728	9728	1617690240000
13377	3NK8AMb6R9XWuxEBbmELBaWx23febcH9eegQLmGf2ttgp4c42Svc	13376	3NLabnTFEbVusrWYYkgkE9r6oH5esccpomB1EpzMx5y8k6o1mRpa	1637	816	198	6301	9627	jxM3a5KzFxBqoHD2kM4GA4AN3xnispE77EQ9AsoZkqunrcAJdFc	6893	9739	9739	1617692220000
13380	3NKpzRNAsvq9AXCxGWLfSsQCTRnv2DRcS2z4fNqKf8zn15KmDcfb	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1513	1253	199	6301	9630	jxEbcM6cVsjya46ZDahCxAQU2sVSA7jtT1CV3VxGK83NEEuHgrP	6895	9741	9741	1617692580000
13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	13383	3NL6oEczUJiS686PC3MkLm5By6y4R5JZAyLpsG15cS1DZXXyCdPe	1518	833	199	6301	9635	jxydPZF5hG9V9BFG7BgpZZgdRDZQsvdSbqzN2zkQ9KQTXRk7pfo	6898	9747	9747	1617693660000
13397	3NKgtyc2pdFeUhwCtwfPVcKJZKiWXkX4DfdLVCQRiWn6nxPKxreC	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	1419	814	199	6301	9647	jwnYATR4cgG1skouYv6Ev6sXh2GsB5DW5Lavd9uMd6GEfLJDYvg	6903	9754	9754	1617694920000
13399	3NK45j4YaLBuvdJFu8SKuhP9ddirzxo2A8aXNHHMnM9eoXP6JWUT	13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	1602	1243	199	6301	9649	jxM1YoxfkuGpZ8gpLJb42dUd1A4yBio2Y4HgnpL25G2nNYTR1sP	6904	9756	9756	1617695280000
13402	3NKQmW89d1Y22mUfRJBVajwvqZZbYTDsZu3nNbC7stovUX8GCRGN	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	641	1336	199	6301	9652	jwNHb3uV1ztV4JbwXtZuezvESBjYoUyHUsNVktiVDtJvEGiup3b	6905	9758	9758	1617695640000
13406	3NKJVmkzN1ah1ojm2g9Sswrxm8uZUTGvwzXUqi8XeLRYnG6ytLNi	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1647	1176	199	6301	9654	jwDPPybNhVaTkeQvtqcCjDNVYV2GxZxf2HMJbfvVwWFzz4EWszX	6906	9759	9759	1617695820000
13419	3NLH9r8APXbEYa7pxVvDhPEdNDkiSjJJVKTQbny7vSet67wegCTb	13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	1654	1094	200	6301	9666	jwXoZH5qsJoUY1iwt1aVd1U7RTBaQRcY4Jo4vnSm6qnHkd4iTSJ	6914	9772	9772	1617698160000
13423	3NKSz3M3WbNz8hFMsMWb3LmB2RXSKtNJ3ekBEyE1ySGCgwjcL3pJ	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1500	1297	200	6301	9668	jwKyZqrS7f1cJ7D2reuXFdZkCuFERfUQFvHqFro1GFxHDXzSnp3	6916	9776	9776	1617698880000
13294	3NKQYm6a8vgz9ZwLBRXjGTTzXMzU7acHKWCn9m2ixywrPuiwqaB1	13292	3NKzwzWK1YuTAt5pcfKAwkBjB4zYyLT8tHPJVgm4RXMvteKXBcqi	1637	816	196	6301	9556	jwJ6zthSfoGpewYf5UNy9XPTPNBj5uMi8sppBXoBDku76rzW8ic	6848	9683	9683	1617682140000
13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	13296	3NLoCQuvVvcucn2R3PupziajKZqjWZPYvbw9UfNSr13NGRMVZTFV	1403	824	196	6301	9559	jwsr7xyt3JxGYgXCzyhoNZx52FWzdFqDQ2NSgD5tyv9St6Decmt	6851	9687	9687	1617682860000
13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	13300	3NLLPxxxKCSsLetW9PajV6GJjc5ESeRfwSAT6iYnhbG7eBBkS7zX	1407	1395	196	6301	9564	jx4j1ZrCpN9sPkzSe4bcmpupwpmGZVWXHsCwLaSNjpVQMuvP1gj	6854	9691	9691	1617683580000
13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	1642	1367	197	6301	9571	jwVUD621NWi6yZVSYthULnuukDSAa2vy8gLxhXJQdmXKri5opDz	6858	9695	9695	1617684300000
13311	3NLG1LCZohd4o8iFMHFhNC1eAHk4q2A4ywA8JfWyGK1tRRHVgV7r	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	369	1186	197	6301	9573	jw93ZWPFBs6dgjkbkDfJXJu7HnyDs34KVbEELkhce6LNTE9xUtF	6859	9696	9696	1617684480000
13315	3NLSCnRGaUSYUbLxJXcka78g72vrfN4kBNtFsnx3NA6dF89B9Cwv	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	58	1155	197	6301	9576	jwsXauHh6vFSZqogoN7ZBCxcV6Y1KrN3RhLiHXiV2358mAs3ffi	6859	9696	9696	1617684480000
13320	3NLKhYadQv5W8yQCbDfojCFBoDv2T1MrnC3GZaqfB7fsU8hYm2ba	13319	3NKM6o2DVEjYZ4iMDShhxRUW9Diw8MsFhArESgvQNvmYfTTisQER	1402	854	197	6301	9580	jxjAihLVVwzJrfF548tQ9ESa4xpUDH9Mbnq6pWLF9qp4Du1ihg9	6863	9700	9700	1617685200000
13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	13325	3NLqkSZuTb4BPJHpQ4cqV69GmBakLshdPnThzJXmrk91Ai3kMiE9	1402	844	197	6301	9586	jwp2vQiojbR59ZnndTgwzQoQGbK1WFQnT3iJQeTc9NBSqVbg55w	6868	9708	9708	1617686640000
13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	13330	3NL8A2huFdoS3SVAsMQPNmttrruJaiFGdn8eeMrhz7nLYrNMPeh1	1619	1029	197	6301	9591	jxrZcGdRTRcKKMXinFbSpP62AnGnkdGyiaG5HXrAKxpZajRzX9t	6871	9711	9711	1617687180000
13335	3NKd5nJnkSYCxorJumVbFgNUaTGzoSSdv7a1uwQwt55AvcE5FF6S	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jxoiY1duS7dS6frmaG2JLUanTCpFeuXQi3DaBnjzw5Jeo2qeNwf	6872	9713	9713	1617687540000
13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	1668	1370	197	6301	9595	jxS1u4ccRkL5YVRjTPDdkjiW4sGMBtFkgcKBnGgN57XwEHqsvqb	6874	9715	9715	1617687900000
13341	3NKjmfFarrJ6DjJmQ2SDs3sKvCjQENGeQBCCFZ32dgJaUSZoQEwD	13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	1406	1393	197	6301	9598	jwX11o7EKbGFXoWrgPSHqaqY7uV5Ev3x5AWJo7XwKdjr5GrNuic	6875	9717	9717	1617688260000
13343	3NKpHzk4j9jZapoAHwG276sNSJcVyf2WR2WsX1hBeSKPeXb54DRF	13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	1483	92	198	6301	9600	jxPLqegWNW5r3FPesL97qMAeBCTCXChVTaoiYAdVWYT6m2pTVXi	6877	9719	9719	1617688620000
13345	3NLtYT2i5QhcVwt1sJ35r2b4YCbBCLPfK8yxX3bqDs5VphGRsLn7	13343	3NKpHzk4j9jZapoAHwG276sNSJcVyf2WR2WsX1hBeSKPeXb54DRF	1406	1393	198	6301	9602	jxcnDXFNRRGrfqYef3EHVS7y5ngkEGHVMYSm1yoZrh4DjqA7jof	6878	9720	9720	1617688800000
13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	13351	3NLPuWfgnzh3jmnU8n6mk8F7Tzx7g3quhXm8zes7KX5g7CuWvsvM	1483	601	198	6301	9606	jwWM8YM1RqErQN1ZzpEeKbiiAtcGRmNcoUYv8h1UnoUY39f92NK	6882	9724	9724	1617689520000
13355	3NKr1Q61FbJbyPFeGLvmD6J8rc6msW3Z46yhL6sGGPtJATfBZWDS	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	576	1355	198	6301	9608	jxUeYsT8iocSDtXXTCpE9qTH5mSwKp2tjuWztXHoVndCevFaavd	6883	9725	9725	1617689700000
13357	3NLg8fJRDezEsjE1emcmjUCP9UPDPxr8P11otqgvETPj1iLpgnnD	13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	1594	1326	198	6301	9610	jxriAybZGiokkoRtBaLjf9kCLK7wpYrZEHh95SRK2V53PF2NBam	6883	9725	9725	1617689700000
13362	3NLZNSAbpFyMQrKkqMqwd4gH3C4j24Jf8jhyEkVqT7jdhemv3qyV	13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	1627	1385	191	6301	9613	jx52Et3Xu8ji8wFVVYiVftbHJv6G7sjHMzFhKUhRTo56AhuBrA9	6743	9726	9726	1617689880000
13363	3NKm2nBsgMxkEeq3Hpznh6kdavxp52iJp3CBwX4W1j7JZbbCemP3	13360	3NLGsPFPn3LPoodLghYi5DcFrBJg5DWdzbFzCMUBNizCSUkjAtpM	1407	1395	198	6301	9614	jwNwM9eKFGRXicXaXkfsaWNSLtKN4zbHMDawDDrhFxRJ7chxgKt	6885	9727	9727	1617690060000
13366	3NKwpHXMMMi5JWFHifo6meuyFtFzFYveA49zpRWQGqZQ1Yw8DJGA	13160	3NKTY3YK6uiZ4iHK7a9x6e1dvD1u9J7wXWgv8oHbJtwJyu3e52kN	1569	485	193	6301	9617	jwsWqRhG2BWw6ZQYDDm4NTbbbiJqhR9twJcrAqXScYHV6mXWSCt	6781	9731	9731	1617690780000
13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	1647	1056	198	6301	9622	jxh6dEW324beZFsuaENmpS3jUFtgfQSRMqa7mCEa6HiE7zrwcMT	6890	9736	9736	1617691680000
13374	3NLMenaor5TzFatCS8uR6HsnuKAsZTdAGg5SXfGRnYpJVLdSETzN	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1651	1301	198	6301	9625	jwwgKnKRcPQqPyHhwQbto22Lb35tehqSQeTEReh7sVPeUBJZPS9	6891	9737	9737	1617691860000
13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	13377	3NK8AMb6R9XWuxEBbmELBaWx23febcH9eegQLmGf2ttgp4c42Svc	1649	1383	199	6301	9628	jxAUqBz9GkyQD7veXgsDuYKqoyNw2P1RnyhrRJvuXdrwKg8QzCo	6894	9740	9740	1617692400000
13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	13380	3NKpzRNAsvq9AXCxGWLfSsQCTRnv2DRcS2z4fNqKf8zn15KmDcfb	1457	1025	199	6301	9631	jxwt22RXwzF6VKde6g9tbWvrAEWwgB75XmiSw4TBAaGKZuBSQMt	6896	9744	9744	1617693120000
13384	3NLqiHWRpA8DC7ga74dpZKMXBndSVxE5KPYmYqCGVnz8LC1uf8VE	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	1439	1279	199	6301	9634	jwjgZU7KG2F6C33VduG6Tfgv4ZU3JAFpYsbPKF7jqcCqvfvBU4b	6897	9746	9746	1617693480000
13386	3NKwQHk3GmBDUxFnUjsgMjaWS7udc7VWvo4XUeYXXu1p7tc29zNp	13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	1637	816	199	6301	9636	jxT7Ddemoaic9Z8AewRqvykc7Gzh9TGBwEwPqMa7y8PHnBc7fca	6899	9748	9748	1617693840000
13389	3NLKCAEUYdiSEmpkp5NbGqHRtJMgNYJuwXi1vF7L9y73HwccsUJ6	13370	3NL5uvtjVU3spG6eVGK7Pz8wrkcJXHp2H8ptZaWEUVQaXroYRip4	1553	776	194	6301	9639	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6792	9749	9749	1617694020000
13391	3NKCHUZQ7HCUKFEwAQRDCkdF9LC36uxTgZcNu1Lis9jXPs9zaURj	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1448	1311	199	6301	9641	jwv3hAngujTZ7TAAPJ8Y5xF4kUhYM3uKMEQF97S5ynLfoNnb6KR	6901	9750	9750	1617694200000
13393	3NKqNR7BDPo3nNoEcySEcq8Y1b4szkGrGKJ58cxaVms82wxS15Mn	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	1406	1393	199	6301	9643	jwioZZTUHXH1DcRWJ1vxf1dvhrebkShfZZ4L4xxm4vZ69fTZCSG	6902	9752	9752	1617694560000
13404	3NLcAad2Z8GDgUDymvyiyLpT6PbcUbm9KUYE6iR9tcc7qVbAH7An	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	1647	1176	199	6301	9653	jxpeVcSLoZJgdHCsZzkDQeNdzAu1gV2dY8zQYpU7oCpka6MUFdJ	6905	9758	9758	1617695640000
13408	3NK5budLHpEau5pHtKbTprFB4Hqhv6a7jqAh3S3RqKJNQeM5y7Xs	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1647	1176	199	6301	9654	jxfnGqXJZrWsqMxWEemaJLfQJkFsJpJA53v1SkCtRHmmVa3Bnki	6906	9759	9759	1617695820000
13410	3NLsYLNGvH5duNUQFyMu41diehVozZbTPfjqv4kALJUDuR9MxaoY	13389	3NLKCAEUYdiSEmpkp5NbGqHRtJMgNYJuwXi1vF7L9y73HwccsUJ6	1553	776	194	6301	9657	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6793	9761	9761	1617696180000
13296	3NLoCQuvVvcucn2R3PupziajKZqjWZPYvbw9UfNSr13NGRMVZTFV	13295	3NKt4WbkF2atVaBfVv95EAfAikxw7YnmsLET9gNWSv7AQt5H2SuS	1673	1122	196	6301	9558	jy1KGN7J4F6kbyL6sZmhrUkAaXvUz8JVTP7qzofiFzkzu5QUzRD	6850	9685	9685	1617682500000
13299	3NKTzSDkFFWVqj4N6Nk5iU8fatPNe91V9kfBikxUxD8rWDYbKtMo	13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	1634	965	196	6301	9561	jwVTHH3KVCVavzxR8z5weHe5A8xYshEMv4VH7Cub4yRhUd9J65y	6852	9688	9688	1617683040000
13304	3NLCJK1wWVzLdL9GewN2knNCHraEAS5pqezBky1E2Lj6Lnf1zpjR	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	1405	881	197	6301	9566	jwV8jWAtSjCTJb4Gf5RMS5BtS9tTeWRkFnrw5DjCSKsEncn4PET	6855	9692	9692	1617683760000
13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	13304	3NLCJK1wWVzLdL9GewN2knNCHraEAS5pqezBky1E2Lj6Lnf1zpjR	311	1307	197	6301	9568	jwCetfhDDL7tvn1wZyNjzJ9vKcX3gRTVrT1kPxLHiGhfB2tcszH	6856	9693	9693	1617683940000
13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	1652	949	197	6301	9570	jwi5XYbPu2jT6QFjUCTxg2zw9ewE1viZHzDX7Mh16T6XqhJQEva	6857	9694	9694	1617684120000
13314	3NKpM4ZJoUUXdD24mtTt9SQRfxLx18rG9PG89LFndGVB5vWHkVCQ	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jxmwaAESiij8nsm9w6Eqk6BDDxYVRnjpYwsmDprmykH1bdJ56Dj	6859	9696	9696	1617684480000
13316	3NKto9JrwES2gAcQaaWwhEwbxQi1m2aUaZfwKTU4FaACb6AF1LLG	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jwQvqkikJEmrN5JVrN1TNvsVeHG2tPGD8jFBoD6QrvcxxWjNECy	6859	9696	9696	1617684480000
13317	3NLejpeZ5TrXDuJsomJmtReyfXR3hfcAgAtUwgvbEUSpoHEXLw4d	13316	3NKto9JrwES2gAcQaaWwhEwbxQi1m2aUaZfwKTU4FaACb6AF1LLG	1609	1333	197	6301	9577	jwaEbqPVxPb2Uwn8PHAYU7oWPrehtKj8LbMHpLZsTSmUZDpa2sm	6860	9697	9697	1617684660000
13323	3NKeoTcbeU41wV5iTosWYpmVqESqPpvsTJ3zEptJxbWhfeziR9Pz	13321	3NKmYikUXYNNajpFYM7WrBFyXGvAUx19SJqPnYbnAHPdBjRw4R2P	633	1258	197	6301	9583	jwPLynFkFMxDXY2pGrD5ZEZBj4zeWZmkSCXkbjYbYH5tqnMe7xp	6865	9704	9704	1617685920000
13325	3NLqkSZuTb4BPJHpQ4cqV69GmBakLshdPnThzJXmrk91Ai3kMiE9	13324	3NKTWMsESNuKhQom9xc6APM6je2XkNgVbyv7kFtPWoDYrKpXj7qS	1407	1395	197	6301	9585	jxiaNNaawyeD9W2T8ANSYKT859WQebVfTAScwX5um8zcMu5u6TB	6867	9706	9706	1617686280000
13328	3NK4SEP9A9q5NkvAPKV3GfLV8c8kwV2VdyrnKhUj4r5YcfVFMSxB	13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	1447	1219	197	6301	9588	jxEWNLJbavfTjGJiAvcAJDZSdmAnpHB7sM9Q5wHyi2g2GHYm5ct	6869	9709	9709	1617686820000
13330	3NL8A2huFdoS3SVAsMQPNmttrruJaiFGdn8eeMrhz7nLYrNMPeh1	13329	3NL7hkDJYBMjoynvRCyrckQ9tySM46wM2HytEBaZs8Jpdsc1R5Xf	563	1359	197	6301	9590	jxPyWRUPUZeaT5AjofDXaYviWmqBFAtvNQYP8bVCqcp1KwRqfKg	6870	9710	9710	1617687000000
13334	3NLMqUo2jhkh8TTb6nhWGV8gv9wUc3FXKMeEQo7x83Lb5z8sMkaZ	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jxfdx4g3D5NwMLob8dMnpLaaWxGqaYbTsuNyEUokZEf8GcG6WDR	6872	9713	9713	1617687540000
13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	13332	3NL2HreiZLPCyFp38D7LV26AYYNwQzHLDC7jScAxftxJtTCQ6Asp	1647	846	197	6301	9594	jwKXayyNgTf6dxPestwUWuh1a1YjPcBP9fH6upRt3fpQ8ZB2mDm	6873	9714	9714	1617687720000
13340	3NK7Y2E7Qn5tGnkAQBQ8QCP2qppQqACxMPjGPMVbSFfeV2Nyt1uB	13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	1587	1357	197	6301	9597	jx33q8Sxd8kYEJ765Gag5kujc9cQxs7jTStue2PksizDVromoVz	6875	9717	9717	1617688260000
13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	13340	3NK7Y2E7Qn5tGnkAQBQ8QCP2qppQqACxMPjGPMVbSFfeV2Nyt1uB	1578	1050	198	6301	9599	jxQWJ2r6YHR1XR5kw1UnVhGk3Thr81puksKvE1dQUWM8zv74NyF	6876	9718	9718	1617688440000
13347	3NLZ4ZXBAkadtXyxMVuG7fv5eVBhWE3eMU9xKafcYD4RTUJ7pexK	13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	532	1303	198	6301	9604	jy36Ns6BcZp7qF9fR5e22LoeYt2yiddXgnyaXpVHccnxCKqrU2Q	6880	9722	9722	1617689160000
13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	532	1303	198	6301	9604	jxVxBvPbhXcm7g39CmfbXjw8A5p8YfEzxveErHETaAQv7eUgR2q	6880	9722	9722	1617689160000
13350	3NLPF3U6V3qPVTY9yJ4QtwUpJB7kApq8EbY7Y46ERneQfuqyufv1	13347	3NLZ4ZXBAkadtXyxMVuG7fv5eVBhWE3eMU9xKafcYD4RTUJ7pexK	298	1308	198	6301	9605	jwd3MMyHhX97YGnQyZBDefpcMaRqkoNsofCE92xnuxpJjhKstZ2	6881	9723	9723	1617689340000
13354	3NKBUhv453VBYVkWjg4Nco29gDotuZFnyxRejch5RVaWSL3rG8mZ	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1589	920	198	6301	9607	jwBHYio5zxyDk48wCwLaind7hWQ6gVNDPQJN5Vhjqthw52Te1ta	6883	9725	9725	1617689700000
13361	3NL9SAFBZeuZ47nCdLpLrgbpfHadhHaM2na1WjVbQbtbUXYxjhqU	13357	3NLg8fJRDezEsjE1emcmjUCP9UPDPxr8P11otqgvETPj1iLpgnnD	1403	824	198	6301	9612	jwUpgxyDL2Hh6VtU5x8KnWMrLvE8zdzaCxBdB9Aps1wLJtY1D7x	6884	9726	9726	1617689880000
13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	13364	3NLEGykfBGQJngKD4sLpxB7gJdB823qjK42CqYeBE1EJDh2XcWNt	1403	823	198	6301	9616	jxFFGjWywvMaJbkEqs966YdPkKGj1zM3PUKPtGEua5mctp2by4f	6887	9729	9729	1617690420000
13368	3NKZzMLH1ucDgzhyrpePVVUyAPamd78u9q2aQBoJiTfTPqAMpNwe	13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	1569	485	198	6301	9619	jxHtubcVhkHpUyETiUUyianD8RdzXyGTVFmJMkSfbyCeJpDRZbV	6888	9731	9731	1617690780000
13370	3NL5uvtjVU3spG6eVGK7Pz8wrkcJXHp2H8ptZaWEUVQaXroYRip4	13327	3NKm5UUmyc6reg5v8TfNh5GgDwWHRqYChBY7wmybpYH6VMAiJJUY	1553	776	194	6301	9621	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6791	9734	9734	1617691320000
13373	3NLLHMDMHMxTNj4gYD1FUSKEC4SmHeejRhCq5kh4zAWJAB6MXsM8	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1649	1383	198	6301	9624	jx7mtkTXBM61xmr9yKE9dx9etTunwBgsG1vCiRDvkeJiVd1456a	6891	9737	9737	1617691860000
13383	3NL6oEczUJiS686PC3MkLm5By6y4R5JZAyLpsG15cS1DZXXyCdPe	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	1483	601	199	6301	9633	jw8jy3sDDxWNfe1wJ9GtgQxya6AcfSTznmHiQxd5iHNEw3KFEAM	6897	9746	9746	1617693480000
13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	13386	3NKwQHk3GmBDUxFnUjsgMjaWS7udc7VWvo4XUeYXXu1p7tc29zNp	1637	816	199	6301	9638	jxk1BkjNeujdYzQHTSkNp7rPxuLbh25QpiUt8rQQxDJAgMsfrs1	6900	9749	9749	1617694020000
13390	3NK7jSCk4ENWcb6R2YD8KhGHTZH12SmjurKctMi5Gaj3mD2H3PNX	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1608	1289	199	6301	9640	jxsYyuSgwRsbLB8eqn8V7ywfQb13RKyFBsp1Gqh4Hjhh9zkGouS	6901	9750	9750	1617694200000
13395	3NL2Jjj6SJSqFBaWWpTgbfpCUJikQZjcEmqPnnSUZBHkMCHF5zaN	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	1541	1172	199	6301	9645	jwX7LzPSorjoFZFoJpLr9wmm3NoE5w8gpSubcfb5sYF12mFT1iC	6902	9752	9752	1617694560000
13398	3NLwNRTST7vMrgYwtDSAvwdXBGk4efLrJMGTaE1nmaVsxJSg8o95	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	470	1063	199	6301	9648	jxSaobuGwS3Fw2fxwU929W5sWk35KGGvBKK9jYt9C3sCszgcLuU	6903	9754	9754	1617694920000
13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	1406	1393	199	6301	9650	jxxb4k3HEk3eoboDFb1MS2owS5iCiVGqZt7XQf2U8JhRG8b5MiS	6904	9756	9756	1617695280000
13403	3NLMwAS7mG8eWHn7urH1qxqSBJEHLtakHRqvdkLzEMw9KohkxsuG	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	1647	1176	199	6301	9653	jw7kVpr8kpj8Sv7x4KR2cVZ8E3vehpj2ZVZispBUCvq11hBAqao	6905	9758	9758	1617695640000
13318	3NK6GfyT99L3Wpd9ST9pExjhKNeyLptq1oh7EWkeYKuLgBzzMzEx	13317	3NLejpeZ5TrXDuJsomJmtReyfXR3hfcAgAtUwgvbEUSpoHEXLw4d	1419	814	197	6301	9578	jwBynTdpac9uRMtJWGWfWjKZmMEm37iM4CshoL8ZyVx12EY5Wyv	6861	9698	9698	1617684840000
13321	3NKmYikUXYNNajpFYM7WrBFyXGvAUx19SJqPnYbnAHPdBjRw4R2P	13320	3NLKhYadQv5W8yQCbDfojCFBoDv2T1MrnC3GZaqfB7fsU8hYm2ba	1445	1290	197	6301	9581	jwXsncJYWtQ31YyXDP5BPwxKR8mRfbyZQq7Qz9EyFxXrMq5iJmg	6864	9701	9701	1617685380000
13324	3NKTWMsESNuKhQom9xc6APM6je2XkNgVbyv7kFtPWoDYrKpXj7qS	13323	3NKeoTcbeU41wV5iTosWYpmVqESqPpvsTJ3zEptJxbWhfeziR9Pz	1403	824	197	6301	9584	jwuqFCW4kv6kzbegfSKuNYYdDcpbmoVnByeW1bKW8R9LZp2nyvM	6866	9705	9705	1617686100000
13329	3NL7hkDJYBMjoynvRCyrckQ9tySM46wM2HytEBaZs8Jpdsc1R5Xf	13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	1623	839	197	6301	9589	jy2cckHh4RBYrnQWCXTMjUNLTHH5nsVSje8yKqDgw83pjHKJXrx	6869	9709	9709	1617686820000
13332	3NL2HreiZLPCyFp38D7LV26AYYNwQzHLDC7jScAxftxJtTCQ6Asp	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1602	1369	197	6301	9592	jwZS44BM1uSYiNHQ1MChHHgJ7jbmviwnKq1HA4xg5AbHbij9MPN	6872	9713	9713	1617687540000
13336	3NLvZbkwbzvCNjegu9ryVmKiH2pm1YdowDjB1LtFhrxBUp6LmTdo	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1602	1369	197	6301	9592	jxy1pWpbEJ2Etu7VgprM5yRQ5jhMx1r5pvDjdghZD5XwutmPJcz	6872	9713	9713	1617687540000
13339	3NL4NNVEQdQYE2bWdHnpVBjwap6Z6nbeH8V1kdBpDbiMHggRxvkU	13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	684	1352	197	6301	9596	jxtqpPBwain155acy4jAxHpowMEdkjJ26MhJHmsS5Vw1ZokZZB5	6874	9715	9715	1617687900000
13344	3NLGLFiho3JEjtFPWyfdnufuoHt44CQychtTYrWrwznB8MiqSCDd	13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	576	1109	198	6301	9601	jxj36hBTJfuGd1jna4gwR31sSypArfR1LmF7nNdY8fmUZRf7CDw	6877	9719	9719	1617688620000
13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	13345	3NLtYT2i5QhcVwt1sJ35r2b4YCbBCLPfK8yxX3bqDs5VphGRsLn7	1406	1393	198	6301	9603	jwvhNVfa3meiDLte4on1V9JdS4JV2NRaUJdLYXuCcZZvxBhu4D5	6879	9721	9721	1617688980000
13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	13350	3NLPF3U6V3qPVTY9yJ4QtwUpJB7kApq8EbY7Y46ERneQfuqyufv1	1483	601	198	6301	9606	jxo6gzRpqcZE6k6ntRNQyg1abZZwPM3Gt1nWfdhtHXeZdrxSyfE	6882	9724	9724	1617689520000
13356	3NLZf2V4YGd4EDKytYBPKsuMw1872z3g3gLuPT4awgW3qUwqX3er	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1652	1069	198	6301	9609	jwKqwjNhb9UFRma2BT3ZyddtPXTpUngcQpGN9KEskh59kFXyvtz	6883	9725	9725	1617689700000
13358	3NLTFnRLPDEUEb3JwAN6dEcuFwD9qpSsMJDGm8k9JTSZyMR4dNwf	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1594	1326	198	6301	9610	jwjd99bHcHTqr5rJmazLBoxv1r4twyviowwgMQGz7yNNwTpvCcc	6883	9725	9725	1617689700000
13367	3NLo1oyCaD3D8VtmAS4QNBx1i5N8CHAGCk5d3xARa3ckvn2ewy2X	13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	1588	1392	198	6301	9618	jxLRZTbwyRDHMk34oJn3xU9Jo8UZ7VaydpEK5Hig35yxib3dNqZ	6888	9731	9731	1617690780000
13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	13368	3NKZzMLH1ucDgzhyrpePVVUyAPamd78u9q2aQBoJiTfTPqAMpNwe	1623	830	198	6301	9620	jwcyaTebUTZFufs5TKosSPsccNhEBTA4ZQixEZNaCXxymeGyVJf	6889	9733	9733	1617691140000
13372	3NKqv4rri2vE4aPApXgMAUANav6t4ceCw1fNgKYdEg3y6ro9z2nH	13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	1407	1395	198	6301	9623	jwBjtJBV9p6Q2ahgBVWrWiQVR4wQNcGyoqLJX7Me7dbdiN7DAfE	6890	9736	9736	1617691680000
13375	3NLTe4p2oQoojTDmoNtvbs5CwgkBzzX1UisoUfD3nT7tXUX85SyE	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1651	1301	198	6301	9625	jwi3tWDHu586SEVCvW4WNYr7naESvnoH6769XBNeTc4WCxA9CPm	6891	9737	9737	1617691860000
13376	3NLabnTFEbVusrWYYkgkE9r6oH5esccpomB1EpzMx5y8k6o1mRpa	13373	3NLLHMDMHMxTNj4gYD1FUSKEC4SmHeejRhCq5kh4zAWJAB6MXsM8	1406	1393	198	6301	9626	jxjEVumAXk5nUQgQHb99DbniZWFauARWhGXV9DsFsQ6hB9SVJc2	6892	9738	9738	1617692040000
13379	3NL3vWP1GrjBiXJXhxn6re8FJeti7QGzqCuvcEwqJY5Su4tNA5uK	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1406	1393	199	6301	9629	jxGB7Add6EQUvEL4u5jXLBNz6VTNPV6kfqR4Sc6vfagsiVUsXYJ	6895	9741	9741	1617692580000
13382	3NL1afnZYUyAdssgzYZfgtX2qS7t1r6qwYcoBdRdLyn82kTUHqhf	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	44	1325	199	6301	9632	jwzuZb7WKutwpMLvJ86MScgmdgVHQbgayqk7X8z9wJV7awoFZQr	6897	9746	9746	1617693480000
13387	3NKQuYyt3DScGLVGEncy6az72jSPwnAQkfyHrvF8pN22kCXm4asP	13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	1594	1080	199	6301	9637	jxAqcAPR76jQi71WX4rFT59sQWvanDk6UddkUx45bxdpd2sfsrS	6899	9748	9748	1617693840000
13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1560	331	199	6301	9642	jwoWZdU9utqbe1URCxkXvrcxjwosmGGLy5wsaAzP3pwJDra6Dks	6901	9750	9750	1617694200000
13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	43	1184	199	6301	9644	jwsxBZgcySBa561spjbnZySMMcYUpU7WrHcVxH6EmUfpbe1Jsnm	6902	9752	9752	1617694560000
13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	1518	787	199	6301	9646	jwMT9aqpqE8iVQhrKo6PuPmcMxZauXZphkun8fhWEcQndJvWihH	6903	9754	9754	1617694920000
13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	58	1155	199	6301	9651	jws1TAw78zNy2dDFPurFdmWVqF5MKeGCXA3R56nULzPYi56CR72	6905	9758	9758	1617695640000
13405	3NLNNvYuA8NfTW4amjCg7LZmzQ1nUntFsee6od9Cff5N4YM1KLDm	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	641	1336	199	6301	9652	jwjm35agQ7QR1Q6EbCbPevX6dhjiuseoYi916V6H3Rg4A4KiL6K	6905	9758	9758	1617695640000
13413	3NKLPub7XUTn63k7qfxmr2joG2gNmWb1Jzd9Su5THHdPfjn3hEc9	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1627	1019	199	6301	9660	jwD8QHT4CrwMi5gdMNMtDk7jrA4EkqphcxGCzAbggmh5H2yVtrf	6910	9766	9766	1617697080000
13416	3NKdbYpJZv4hJsVZ24CpjftJ4xfufKvpACTsMF6CV1vYAAAA3kj7	13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	43	1310	200	6301	9663	jwenzLH7g1qvCRX47SX1tJVEBeuceHZxGvrX9EKb1Lx1x55qWVG	6912	9770	9770	1617697800000
13422	3NK8M3StjDDrxo33CZqdp6e67itc8a5V4gVyJPtuPBRiUTSPVk3K	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1447	1345	200	6301	9669	jwRTDRXYMo54ygSZW7T6diXauDCX2WzcLBtx73TRLfYhbXQJoqh	6916	9776	9776	1617698880000
13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	13421	3NLQc9z2NYtWy1bq7YB6kZ9MsaQU5B6EbmKUVGxNJMbY1tGp1o42	1601	1388	200	6301	9670	jxTudxfSc3hx4eHf3Kgu2nQodfT8igTcDLNL4TXo8nivYQ5qZti	6917	9777	9777	1617699060000
13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	684	1226	200	6301	9673	jwJGmUKqyUVjwbCr8tpP97j8CxjuiM34Czfv24apdBaen8KAzA3	6918	9778	9778	1617699240000
13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	1613	983	200	6301	9680	jwZqicCHCnEnVFA6s1iS1q4daNUzupQ9S6k1jUaxG5RMDxKnsfC	6923	9785	9785	1617700500000
13436	3NLH77jNxQmNTHRvFLHHXEH193We2bMh3CxCff23Fziop21RafsJ	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jwk6k3EegsnxW5YA549jQnsryzKkqc4v6QuV8jjkDVznk4FxbGN	6924	9786	9786	1617700680000
13407	3NKSNXN5EJKDj1BS5WtHCwqrfcmKodwX33ubkzGdp1euvX194Tvp	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1419	814	199	6301	9655	jwyCWnxESpxNGehY7VdTVu3FkHguFemvDDSWtTRj3en86vJn2Xg	6906	9759	9759	1617695820000
13409	3NLjun4jRRgPuVyuxzKxE2DkZ2JayqWCNV3gE7Qr6N3oYjMFKM4Q	13407	3NKSNXN5EJKDj1BS5WtHCwqrfcmKodwX33ubkzGdp1euvX194Tvp	1403	824	199	6301	9656	jwGKxkg8R3PecYeCQHejVbATV8fkRo4JZS78ApnTL2oKkR4KdSA	6907	9761	9761	1617696180000
13411	3NK9aCwSZcgAmJSfR3GTcxpWyEZ3vNfgTy1g8Awy2CPBshrET9Y9	13409	3NLjun4jRRgPuVyuxzKxE2DkZ2JayqWCNV3gE7Qr6N3oYjMFKM4Q	1403	824	199	6301	9658	jwDYjb3ji3NYhF7riimkiZY1hkcbAWo1phop9r7qB42QjARHziu	6908	9762	9762	1617696360000
13414	3NLyaniA73pd2sDNm1h14jsjEctrJcCY1RWSHTEJA4pSQRuFk7Xu	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1406	1393	199	6301	9661	jxuoyNjz4mfhJV8eUkq7CCRHZZCjsPMz9UStioE8epBhWPmhnJ8	6910	9766	9766	1617697080000
13417	3NKR4bs7JEM6DYEHyJYHaQSEhWPm5bodCv6GEoXA9A4MN1uw5PPg	13410	3NLsYLNGvH5duNUQFyMu41diehVozZbTPfjqv4kALJUDuR9MxaoY	1553	776	194	6301	9664	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6794	9770	9770	1617697800000
13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	13419	3NLH9r8APXbEYa7pxVvDhPEdNDkiSjJJVKTQbny7vSet67wegCTb	1642	1121	200	6301	9667	jxyH2T8pBSrLS6gn1yHYCbwrCwhTQychX3mcNpY4tkVXxqHx4zX	6915	9774	9774	1617698520000
13425	3NLoCfg6BUhxZiTMVuaJUX8d2WVbbXqdoG3gcJoyUcFnESt13eoc	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	1670	1282	200	6301	9671	jxHLv9vUtzkHWUJjTK7Eu7w2Zo4NpMDZSu1t8b4Y9zbPP7cJ8BJ	6918	9778	9778	1617699240000
13428	3NKx5Sgk34t6xqjMvn7wiR9rhfjCwgyyMGFLrgH5o7k7QvzDisb9	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	1407	1395	200	6301	9674	jwNPpf4BrhtnZMMh1wj3cYKnXfRfJ9f6WvMTNjg4M9WVrDGFG1X	6918	9778	9778	1617699240000
13430	3NKVQx3DSteKFShS4JiwBLJrsw3VorbM2sRQwHcihESFKpgFgJQY	13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	1405	1	200	6301	9676	jwRfbRm9y3TYPiCbuAaQ63t9TAbeRwX9p8tqPDUwe9EPLLnJuvj	6919	9779	9779	1617699420000
13438	3NL8T82WkRQUQdhpp7rGWGEJxT7eGBS8V2WzDyHFEMYVqEsHA1Rr	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jwRjJUWUr1FDenNtDtrHpCZkx25RjbHkKjPtEhfM4MRq5idizgA	6924	9786	9786	1617700680000
13443	3NK33U3d2sVtGq1WX2T8gGVoa8jpRVsyvawLmW6vA9N22yMDz6jy	13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	1597	274	200	6301	9687	jwEDAXpaVDVwKzKMyyGEC3MnC2KHWaMismQTzPpDCFFHcEvAF1D	6927	9792	9792	1617701760000
13446	3NKALH5hr6sLb4be8aQYk5K6JktXc3Kotfj5VEN5f2tFGR3Tu5fc	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1609	1333	200	6301	9689	jy1bbMpYif7HSZ5VFSWL3hJPyiEY76m8KJLAkRLwQnJqwfd2TyM	6928	9793	9793	1617701940000
13451	3NKM2nbUhoFXn6q6PbYT4eyS13TW9KsJM5iAN3rFDVqT2JadQcA3	13446	3NKALH5hr6sLb4be8aQYk5K6JktXc3Kotfj5VEN5f2tFGR3Tu5fc	298	1308	201	6301	9691	jxGC5zQE5sFVeWyYFePrSffEn3wSUtGqN9yzFPh7B6AXmNNC2C2	6929	9794	9794	1617702120000
13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	311	941	201	6301	9692	jwGuHcLeWLudSJrBrk3Qt6JL3YvWerd74MPXYeM2EY1Ag3gizuy	6930	9795	9795	1617702300000
13457	3NK91rDUs2cRVZiD2rnHBbk3QfeQLmtL7SZogKjfEdaATj5AQnoD	13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	58	1035	201	6301	9696	jxdderksTPexUKgk1tfrA38HX5XTzBMqYc62eq3YvjNs2Ug9X7Z	6933	9799	9799	1617703020000
13460	3NLEoQ3Eprdkgkx2yxFq2ihJCcE3V23ncEsPNJXjDRzkcXG8x3YZ	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1588	1266	198	6301	9699	jxNSn52QhqZzrnrWtPYR79WjSARrAqRdxJNcr1sJUQj1R9DtHFu	6891	9799	9799	1617703020000
13463	3NKP7fnkgkjmvMLxu55BQ1U5JNiCDTZv9LJ5tya6ZueT7pW6WNe1	13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	1637	816	201	6301	9702	jxYHob2cKmR2CzDF1qjez6kE8SXummRargXzrm7QBr6rzvi3Zvi	6935	9801	9801	1617703380000
13465	3NLk9ZzjKSpW2aYCmzwFSDT54hbVZuCYpFYBZdaT5A5EMd6XGymY	13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	576	1229	201	6301	9704	jxrMmjovEfhMdWcH4gGJs8w1ykGLSza4swHNEUZvgLLtu7tMZT2	6936	9802	9802	1617703560000
13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	13464	3NK7tce8ujnKPUq9xg66xuwARgpPH6Z9g9QuDTiz2yuxvdbAMbTB	1573	1318	201	6301	9706	jxRASiC13cKdFZQUtEXMP52Ea2x6RTQgrcA7gKy6wuwu9XoVcDE	6937	9803	9803	1617703740000
13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	13469	3NKXPvE2XcHFpmxRYspz7oRHFkmP3EV1mCGcXtKq7zCcBoHKwv9T	1649	1383	201	6301	9710	jwUPJ6zQMUMtyJVcrnnCWvUcZSmEy55GiisKUKF5pcUZscBLDcg	6939	9806	9806	1617704280000
13479	3NKTFAnELN8jKXdxTUECW2mWbwCjJPwEXyMoJWLrzQKEtuMNnAgu	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jwe2aUMhgPqF38RtPC9GnrxrDxgujrMZQmqrLFw46nxEdy6b2sR	6941	9808	9808	1617704640000
13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	13480	3NLPsRy2oTmV4rPqi5LRdvL68BeiMqr3CBUXU3r3buPJD8Ke2y5X	1634	1331	201	6301	9717	jwE2grfw5YLHBUNnt6sDpxMw4cBWo2NaKZ4ErVqZtoWYRGhFdQq	6942	9813	9813	1617705540000
13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	1500	1171	201	6301	9723	jwPpwHyQGwgvWgRY6sgimTKLLDyZVACEvshxAFskxQ28bbgpgRV	6946	9824	9824	1617707520000
13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	1490	908	202	6301	9727	jwRxsbcWvotyEt6fk57BK5Rc5xiYw5eaM2cqYAxWLQFk587Zj3i	6949	9829	9829	1617708420000
13498	3NKeRsSNfB8cwYVhGVqb5tx5oQk7aqXhctHJvLGMAdU7czwvyTBf	13494	3NL7W7BXLZUFE5KcSSddfkUx9qTnKydz87XC6WGnQoLQepWn9kAy	1407	1395	202	6301	9730	jwNnQQJnjT5swKz9S2btTov9v7WS3iEt1UvAiQ2mnAEo7zbULXE	6950	9830	9830	1617708600000
13500	3NKZqWNx7tukhU3LQARB9wmxSr5MqpnAz2wNiEa18UeF8LuJDZbd	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1648	1284	202	6301	9732	jxcMAQmS5EoeWHjTLBsKDEJRTb6kjgtWtFNPy2Qyea2oy5c2B34	6951	9831	9831	1617708780000
13507	3NLV84D32YRYvVJq4Le1uSx2uCpjbuF1mwnAM65Zi3adUDMzxfeV	13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	1547	1252	202	6301	9739	jwcCYkogxXJmdv5hzQG1XW6ipqT92V1wmMKUi3FHt8wgiehBWoH	6954	9836	9836	1617709680000
13509	3NLMY9HDSdhrS9PdFXAgzzJSbdmXGWiGHJLzruymsoVw5eHTovfq	13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	298	311	202	6301	9741	jxygLfvLK8aRj2AuDzytwAm4gHaaR5Ga6BDgGupPeQd42mepjQT	6954	9838	9838	1617710040000
13511	3NKZNTbXnr4mNCoceu6pnwfuBHhNKTJrfFsTNfCoNQ7ARM2vj4e5	13508	3NLRTBLaawfFhrPCHTzrAwE7fUNVjU4tH8iSrWu7dWEwqqaCjjMM	298	311	202	6301	9743	jxdKLf4jx1SbGdNNyeQetMD3wxD7pgv6oUdYBpiVqBkrKpG4y3C	6956	9838	9838	1617710040000
13514	3NKuYyoR4fvP3YHHKyUP9G7xyfDpaYfP1PPZf9MvYAf6MVLfiaCB	13468	3NLhMsrUgpVUmX15f6V1137ReoNhcRRYyxZvXMhJJJRwPQ8n5rhH	1553	776	194	6301	9746	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6797	9841	9841	1617710580000
13516	3NKFx4i1ZzfBgiJxXavQxvUVt7n3AYwvN9jD7DuUjkcUDbDMfy8L	13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	1471	1386	202	6301	9748	jwjDQmXBmdStYPwSc2ZTWHVeAMdsPDB5EJsFV2sahsyPr6V3We2	6959	9842	9842	1617710760000
13523	3NKDaKaKxB8ta3YbgDjfh96XwLkzkhgkTNtCNXuQBC3ePyvouWpT	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1648	1284	202	6301	9754	jxM9E7pBFoeJRgB3q3czjbRFzgq6VPQz23ghxN6uLrxKDbBB81b	6963	9846	9846	1617711480000
13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	13411	3NK9aCwSZcgAmJSfR3GTcxpWyEZ3vNfgTy1g8Awy2CPBshrET9Y9	1652	1189	199	6301	9659	jxupBcDYm5PurY6fwW8TN1F6aWH8XBGRxrbVfwP9WTpWwNQTDd3	6909	9764	9764	1617696720000
13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	13414	3NLyaniA73pd2sDNm1h14jsjEctrJcCY1RWSHTEJA4pSQRuFk7Xu	1407	1395	200	6301	9662	jwcWT5RbKQsfh2yP7HcF91X6taTPz9Z1LYmjosqAfTVvypyhgQP	6911	9768	9768	1617697440000
13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	13416	3NKdbYpJZv4hJsVZ24CpjftJ4xfufKvpACTsMF6CV1vYAAAA3kj7	1637	816	200	6301	9665	jwtjzZfzwBq2dsGeAqTuHXypwuduFKNrkG1Fv8gZfV3ph5441N9	6913	9771	9771	1617697980000
13421	3NLQc9z2NYtWy1bq7YB6kZ9MsaQU5B6EbmKUVGxNJMbY1tGp1o42	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1500	1297	200	6301	9668	jwHZC5YXXMvygVrKKzjKxBo4Xf3UUZ4EJERw1jwFQ1orhQWyMDs	6916	9776	9776	1617698880000
13426	3NLAzMYysosfx1Yc5prP8ngZ29ogH6pmfPdbCHwpzt7y7YR3y4mx	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	506	506	200	6301	9672	jxsRsNo8wvXoEXit95PB4RJYaAx6p3p4yD28gxv4rDPKy1y51WX	6918	9778	9778	1617699240000
13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	13432	3NLcDz215yAMVD1ENw67QDNNBXbazb91DXXd9R9KmTgZwMx9Q1Ls	1403	824	200	6301	9679	jwbNVY6KpBAigbAfUD658MfMPCRwERymGFAf99PLity9txN6RYQ	6922	9784	9784	1617700320000
13439	3NKzLvSHLcoQFSfmeF913jSd5bkzNJXHBbr4275qsuE4HMgkhEPo	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jxT18adE93xZ62synz8t7cMg4Swek4wNV1F8ZmSG5AuDwppqsjW	6924	9786	9786	1617700680000
13440	3NKeNK9ikZZfVSMFLB9iXyqVt5cLQtg2umumaXTtEodUYq67Hv48	13417	3NKR4bs7JEM6DYEHyJYHaQSEhWPm5bodCv6GEoXA9A4MN1uw5PPg	1553	776	194	6301	9684	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6795	9786	9786	1617700680000
13441	3NLDZtq14an7Lk1PLAbCa59We47EGWHwq4Co2eFpb6BToQK2ZTha	13437	3NLSTxvv42YwequoPD5fNL88QPrzpxUMr6Z1kuJj99b2bDHzoUZt	1406	1393	200	6301	9685	jwMuGjSrqCdWobGjNQbfYp1gmVFZi6soigHZgwKrMnBoSCNxqYg	6925	9790	9790	1617701400000
13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	1403	824	200	6301	9688	jxWPp7E9tJNijncfT8RjvcDAuAKUmyc8A6hnvAVzzdJU4oCskbx	6927	9792	9792	1617701760000
13453	3NKHaRV5cHawPqB8DMhDAT4UBJCVtXi8EmByhpxopsD9nHD7no9f	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	563	1359	201	6301	9693	jxKoo8tESupxn6nKKQY49XsbJa6oWVWU4ArsUd32k78xKChUJVJ	6930	9795	9795	1617702300000
13458	3NKF7FUBmrHFYm7soTcSvdsSQiYsesnqauYxFWv4SYP595EWFTKZ	13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	1588	1266	201	6301	9697	jxs4RuJFSrrxMu8GmDM3W7gryUj5xiXTyYKqPZTUXTaHJw326P4	6933	9799	9799	1617703020000
13466	3NKFZXZaJPHKaPJqQeWeegT4o7xSCETYYNzH9S8Z8bAkuWbN1n5m	13170	3NLZXSbDCUfQHitjDb7Zh414WPBaqKhyC3AMybQ8qcMsnzKiewWa	1509	1320	192	6301	9705	jxpt19ZhLsJS37CPKi9u6Tj36spXJqZfCxXJWZiQEVK7bxbykm8	6753	9802	9802	1617703560000
13468	3NLhMsrUgpVUmX15f6V1137ReoNhcRRYyxZvXMhJJJRwPQ8n5rhH	13440	3NKeNK9ikZZfVSMFLB9iXyqVt5cLQtg2umumaXTtEodUYq67Hv48	1553	776	194	6301	9707	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6796	9803	9803	1617703740000
13469	3NKXPvE2XcHFpmxRYspz7oRHFkmP3EV1mCGcXtKq7zCcBoHKwv9T	13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	1654	1340	201	6301	9708	jxEMPZ1xRWr9jbKrc5rXnNkLwJLRJxnXoSjRGwaC9JVunWPkjzp	6938	9804	9804	1617703920000
13472	3NKrLtikxFjCi5q31ycTjvFM8xr4JZ54eNWVcwWWr7f45iC4D8BR	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1607	1102	201	6301	9711	jxa27tBq7oKgMLUGcoR7szH7MLPeRWLc9Js31NAy1w4Z4g3Unr4	6940	9807	9807	1617704460000
13476	3NL7BgW1GLT3qT2VF13m5AZoLaEWzYccaLmJG97E7v9UZ9um1qZr	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	1448	945	201	6301	9714	jwHZje1NRxm5xR8HzW5ZAU3mbk3vJLs5NNuzVX9Ad6a4tmsqntP	6941	9808	9808	1617704640000
13480	3NLPsRy2oTmV4rPqi5LRdvL68BeiMqr3CBUXU3r3buPJD8Ke2y5X	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jxReiHPhBEQRvX4f3RUpAM8kEi9ffDdxb6EdKQnHg7ATAx9bwiv	6941	9808	9808	1617704640000
13482	3NKUzQ3CQgZjCz6YsE2pnBYCkBT5GCMMmp82SxSyVhECfxPKsXAs	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1447	1345	201	6301	9718	jx2vaVpV1RUVxPb43zWUSYnHsJ9JWiQCwTi7uDhCifG4RVZaqra	6943	9816	9816	1617706080000
13485	3NLdKCpW1hw5BoRGoW8HBRx3DLTjCPYPch1xGnjxdTsjX98v2EBD	13483	3NKrgg5FwoqC3HWfqFTNqkHPqpr4RbqKtNe4DtbP1QjxtbNaAQmV	1483	245	201	6301	9721	jwwLvdBGug8BESErAsx6uszSNZQqZzr8TtRyQ51aPREZRYcGCz7	6944	9819	9819	1617706620000
13491	3NL9ab6WvV6MbRGxX8wk5DLCmnmrJEEwYYwSiMGwXFwmLdX2jtxu	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	606	1295	202	6301	9725	jxZ8GVC69W573GnjiVZ3DbwTEpfsHPWAgSXzijv5n67TCUUqQLM	6948	9828	9828	1617708240000
13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	1474	963	202	6301	9726	jxkxzcHqX7eL9qLLsoLXBNnXMS88YMKfykcuTizmwANfykdV685	6948	9828	9828	1617708240000
13501	3NKryqkjMxkwMPrgUNo7h3xx7aV1BXX7TuPBEusq2M4vLvKs9Lt9	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1403	782	202	6301	9733	jxFRSnsT4goUSPW9jQZWH7FJr1XvXbk6rsaLVivhRiTCqih1K79	6951	9831	9831	1617708780000
13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	13499	3NKKAJXUDiYCfZcYYkNYHJ7J6XGBtRiYmuebsqhTrxFf1zUPMaaS	1589	1160	202	6301	9734	jwMHkaW2ERbvMid2CqAkpvMUptzp9ZHGBWAuruaRXs8BK716opf	6952	9832	9832	1617708960000
13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1406	1393	202	6301	9737	jxzsUrVqKdtrNCm1yD9Bxz6yx1uPYTU9wSywmwgL394WMc7C6Le	6953	9833	9833	1617709140000
13512	3NKrpHYf89WsYDqNftKckvr8bn32HdPJr44qux6ExCuzWq8KL36w	13511	3NKZNTbXnr4mNCoceu6pnwfuBHhNKTJrfFsTNfCoNQ7ARM2vj4e5	1406	1393	202	6301	9744	jwyMefEmxgzf9viBUnMijyQ1jSb9ZshyYT57hZwKTDSpAvxLJuN	6957	9839	9839	1617710220000
13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	1471	1386	202	6301	9748	jwVHoP7YhUbgGF8XD2qvVTb1EsmKVd3nGUwzqo35b4D4U2CHZSb	6959	9842	9842	1617710760000
13519	3NK6mYs2wj1gyQKao5PySNypL8CUwvS5HCYU5kZJJnCqF4DYJu81	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	152	964	202	6301	9750	jxz72ZtHgwnDm51ZLVqpYkZQQkCjeqP76Nijkb3B1D8grcp3xUt	6961	9844	9844	1617711120000
13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1406	1393	202	6301	9755	jxyGHCo4pNeLxZNBqwLX9dUxHkkwUXTQ7rRAC58Nuhby2TAWP4T	6963	9846	9846	1617711480000
13526	3NKSNjEuqTcpyQwVfcahC4VFZ9j4po6AHxHEgkTW2AG8JQSPCsN4	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1522	956	202	6301	9757	jwrwVc8VFCSgeLLaMgquhibzy8x6q1iVgGn4xqg1B1otrneHLgu	6961	9848	9848	1617711840000
13528	3NKocv2SWkSNxMHrmyWmazNzj4y41DhseUrC3epca32WAzJfqC7D	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	44	1199	202	6301	9758	jxSzXvQvqBXGaCXvGY6NnfEq8CaKeqsy3ksRaq69WfyZRtc8iR3	6964	9848	9848	1617711840000
13529	3NKnV1ZkNe8g3UV18d47mG8SmsiAzpfR2pXoDHKkZDxpSQMhmdit	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	1522	956	202	6301	9759	jwfkv1EVDSRiCw5NxCX6ZBKbsd3MCEbCtkg9YWCcpsUJdRz56u5	6964	9848	9848	1617711840000
13429	3NL35MZ3QrLRDsrJ7Ae3aznihcCZRZvs5FUuXshTSrxYpj1gidWr	13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	1600	1372	200	6301	9675	jw78kUtvL6FtA3jb8jiFe2Da4SDiyeo2cymK9HEAK9aEkKKs912	6919	9779	9779	1617699420000
13431	3NLb6kxoA1iVAyPRDjR5BUrNWTxjd3mNwqXD6eUsXMnNdgAEpsYr	13429	3NL35MZ3QrLRDsrJ7Ae3aznihcCZRZvs5FUuXshTSrxYpj1gidWr	1419	814	200	6301	9677	jxwZJaYMZRXvz3yVoEWVXA12Z8GtzvWHgYLo7WZbXgLg4Z4YVC4	6920	9780	9780	1617699600000
13432	3NLcDz215yAMVD1ENw67QDNNBXbazb91DXXd9R9KmTgZwMx9Q1Ls	13431	3NLb6kxoA1iVAyPRDjR5BUrNWTxjd3mNwqXD6eUsXMnNdgAEpsYr	1406	1393	200	6301	9678	jwD7AMYLuuiJvjRukKZ32ACESjeQuECxcBo4VFcmjpJL7XPqkWS	6921	9783	9783	1617700140000
13435	3NLB3V9cB5KKzPvKCCyHG1i8mQS9fQ1bzgJkacFQiQFpZxeYuYo9	13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	1506	1373	200	6301	9681	jwEnp5VqvidHhQJ7ytu4matucd1RvhX6y2LET2mbX7gvnopQbpp	6923	9785	9785	1617700500000
13437	3NLSTxvv42YwequoPD5fNL88QPrzpxUMr6Z1kuJj99b2bDHzoUZt	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1649	1137	200	6301	9683	jy1NQiuccYYuDh6EHfZKqmddFx7dD2pSbUcMCosG9TsEFJzrmC2	6924	9786	9786	1617700680000
13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1609	1333	200	6301	9689	jy1bbMpYif7HSZ5VFSWL3hJPyiEY76m8KJLAkRLwQnJqwfd2TyM	6928	9793	9793	1617701940000
13448	3NLZaeT9DAd3LmAeem1BRbCWCKXW97DfFsukEEWzSd8tLLhkhU4r	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1651	1175	200	6301	9690	jxnBPXFRDCsLo8jM6yXySa47nAbUasbEDeyf48YoLfeThTGMeLF	6928	9793	9793	1617701940000
13450	3NLhHsoP25WVyrpGgVmbJJrFvi8w2iCyFZZ9YVExWTdXHkmg6M3m	13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	298	1308	201	6301	9691	jwvcsFtcAsM9z4ysM3nGgJNwGsjUhPbczXmpT99v6c39dxEk9YR	6929	9794	9794	1617702120000
13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	13455	3NLcYsgW1B5AGnGQ9qoH18a5MJ7NJz67MHfXWnEAqusJ3e1TVQo2	1627	1259	201	6301	9695	jxEHG4Am5ddVNFq24j1efDjzJBHdqcax8CtWgZUEyCctZUXCgRP	6932	9797	9797	1617702660000
13459	3NL7LkarJKwezi4vaDht6JdqT861Rmz6wnC18ouiBYw4vSmVTewk	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1588	1266	199	6301	9698	jwi8gSJWA52mLbcnJXW1iasL2NfUdeJpief9QNyRd9LwYyk5CzZ	6895	9799	9799	1617703090544
13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	1426	1364	201	6301	9701	jxAsGpWCAhx4GCqVUGmb8vFybg4R9YqFHu19NRZfxmZQrgA7xVF	6935	9801	9801	1617703380000
13464	3NK7tce8ujnKPUq9xg66xuwARgpPH6Z9g9QuDTiz2yuxvdbAMbTB	13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	1406	1393	201	6301	9703	jwSL1mWowdB86pi6GBZqUpqAB1ApSz7EJpcrU54DzKANvctEiJA	6936	9802	9802	1617703560000
13474	3NKCJiqTPaLm2Jz2iStoBLLDY8H2TQovPSiCzE3MKMebVyPXVma3	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1607	1102	201	6301	9711	jwLCQSfoJd53SDC6ctzCfrq8L3oZCLRrQq4S297BwHpFxdtZvHe	6940	9807	9807	1617704460000
13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1407	1395	201	6301	9713	jwBEyAR9AHMnx1CQefmkugKG2Jqx8uiqRPaUMG31M93exG6f1gB	6940	9807	9807	1617704460000
13478	3NLWtGzYV3iChStKMwwNuCqz5vAJXKabvVLMbWP8H4w7m2cZbEh5	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	1407	1395	201	6301	9716	jwQme9ZV5wzqyVbxUGabTVSUYXRRjrs3vLTLMB3GDcfSJMkRhkp	6941	9808	9808	1617704640000
13484	3NKxbsM2buC8k5cMBHkW5texBgN111FE71AP67kGx6V5P3EZR3u8	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1506	1127	201	6301	9720	jwvJyqbm8UXdrpS5WFcQR5o5Pt9L3ooxADfWy2dTABEkSiUDGMJ	6943	9816	9816	1617706080000
13487	3NKMYQKdgmVVET3zFykiLZVZc76Pzaf9y4zdf8nJUU7YRdM57TsX	13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	1500	1171	202	6301	9723	jxtrRFGjZ9aC7kzM1zfLVWRCwJbkXKf4DttJukSDzWGgb7qkMhm	6946	9824	9824	1617707520000
13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	1647	481	202	6301	9724	jwQZhf7rgwcgu3hCyY9SwYtmNHJTKc7tduxPpmjG47wWtdQcjij	6947	9825	9825	1617707700000
13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	311	1061	202	6301	9729	jxT6rPWZS9TPrZRsNDcivNycm8FjaHiqfSi5pWzycPHidVQ6uLH	6950	9830	9830	1617708600000
13499	3NKKAJXUDiYCfZcYYkNYHJ7J6XGBtRiYmuebsqhTrxFf1zUPMaaS	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	596	940	202	6301	9731	jxDQzK4SquJqjyrAjADNG5DQuC7BLD6HQQpKvU3vSuLkXyaGtuQ	6951	9831	9831	1617708780000
13504	3NKgVJ5odoEZiU7Sh36VeAuMKctKF74z7XUaTtNgkRG9LkPYTLJh	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1440	1377	202	6301	9736	jxKMKnMRF1PE2X4Bt7JKRZLiKz7cRfzihkVQv4JV6vvQB3rA4Lo	6953	9833	9833	1617709140000
13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	1448	1311	202	6301	9749	jwbbxc28XMvHxUG8kBv5VH4EKWhj1GpFoHjrY5eHR4W6MkM9raA	6960	9843	9843	1617710940000
13521	3NLmUpQzSfGyddXvEvfWgTfmB8zCYsNi3rtXKu2RTJY49meNKcUD	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1633	1144	202	6301	9752	jxm4jmt9t7gGwX6tN4GRLV9EDpXdT5Ers1QB1vVB9CNUZFSuBQ3	6961	9844	9844	1617711120000
13525	3NLYsn2gjG2tCGBiXYH5FysPcyyHR3EVRTAfVFnTW22oBM2tSQjR	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1581	778	202	6301	9756	jxmWCFVUabs5Q2rKECULuMbq7oWSgyGsN7iLcsSELk34CGP1LK9	6963	9846	9846	1617711480000
13527	3NKbMW1R9iuhZuT8NpYkkfrrA6isJmr5JhHqDnkPutEgXpjbkBLk	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	44	1199	202	6301	9758	jxSzXvQvqBXGaCXvGY6NnfEq8CaKeqsy3ksRaq69WfyZRtc8iR3	6964	9848	9848	1617711840000
13532	3NL6byUDsLRk9mg81PqH3Zmz9GrvaWTa95zXdKnxoe4L92yumaWb	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	1637	816	203	6301	9762	jx2R6AEsTTQyXv3fGsHhEU2Sd7e4rTtkPtjBKigwZun2MBYfpFC	6967	9851	9851	1617712380000
13537	3NKWC8xqmzDzQjnn6prm2FmQxG5y3z2FW8KBmhco1VHjBMozto9h	13234	3NLwF1hJSSVsaEHg7P5VPsSLxBaZ8coDvoZSrdUX6uo9B4GneSET	1542	1178	193	6301	9766	jx6qwVS1EJ678SQaJA8W8u7ZSaWg14FGZHNauvXjwi4DXNjAzsy	6761	9852	9852	1617712560000
13543	3NLZF9GhPy6ucV71w2NYayS1vvapQ3LiCAyPsKLE55B8Nw6ViWbW	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jxNTNdwmDabvPNcZCECqJCjrRL7PTQWAHKzE9mmauAHt9weTgrd	6970	9854	9854	1617712920000
13545	3NKxC8nuZFkoNik3ZwMZJAJE3wvRqeae5f8PFNs7oesSeNFb4R79	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1447	1345	203	6301	9771	jwH47FpNgLCpg1AGSGt5F4qFTDB3TvXF377fnRhG9FxDANGVTKt	6971	9855	9855	1617713100000
13549	3NKtMXvTBvKY7jAjzEVKyLWk2kBXTqLZApgAivm2NKJLCSPAKc69	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1578	930	203	6301	9773	jwjqQEQdw82FGBzFaHjhAhQGsM4qCvavZXqAeCzrMmkDwYC9ZTL	6972	9856	9856	1617713280000
13553	3NL9gYS1QzPZ6RhpcDdiYQAMEB97M1EHPi6niE73HY1X42jPrbGP	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1588	1392	199	6301	9777	jxvHK4dh1PnkBHVSyEn9hqGQdntVzvHkyR166NM6y4ydfV1diVm	6910	9856	9856	1617713339779
13556	3NKA7MUyL2cLk7ow5eCGSR2UFagYK7VKSFc8p8BdsSTjy79MPSvj	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jwQpsrVHem2NBoeZ8QHM9ZH5riHABV2M3MNRzBYu5NUEdo7iDVG	6973	9857	9857	1617713460000
13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	13441	3NLDZtq14an7Lk1PLAbCa59We47EGWHwq4Co2eFpb6BToQK2ZTha	1403	824	200	6301	9686	jxFTLy3zg7JJZ3SyfcwTgB5svRGKGNe1dn9jXX98rX1H454Tgk9	6926	9791	9791	1617701580000
13447	3NLshFJq6dgHTivsSE5Va6mNKV2T6Riq8UQSLpSWbAEo2Z9A8f65	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1651	1175	200	6301	9690	jwLhHHesS8diTkZyfPx4R627fnUHFRFJSMa3wZ8RsUzWzBNnQ9n	6928	9793	9793	1617701940000
13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	298	1308	201	6301	9691	jxGC5zQE5sFVeWyYFePrSffEn3wSUtGqN9yzFPh7B6AXmNNC2C2	6929	9794	9794	1617702120000
13454	3NK6eBw6YdMBd8tFAYPr18EC49kLLsCa384HSQYSSP3E1B21RveM	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	563	1359	201	6301	9693	jx3TEYpvT41rAUWTDsh49WDFCCX4ZSiwfrmaEEADSWCJQTtugzp	6930	9795	9795	1617702300000
13455	3NLcYsgW1B5AGnGQ9qoH18a5MJ7NJz67MHfXWnEAqusJ3e1TVQo2	13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	1581	778	201	6301	9694	jwAkRmtwLVjZN77tQrvqdoRJ6aCZLRfyJesZdTwER9Wrw5pSLw4	6931	9796	9796	1617702480000
13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	13457	3NK91rDUs2cRVZiD2rnHBbk3QfeQLmtL7SZogKjfEdaATj5AQnoD	1622	1110	201	6301	9700	jwSNHza4xf2m45zfdyeRDiseYGEmJpVhExaCteHUaiGokSz6V6Z	6934	9800	9800	1617703200000
13470	3NLrt3iE2bK2Rp1Tdt9ihPurzzkfGVtjN7XiAcsRDy2FKmGV95Nh	13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	1581	778	201	6301	9709	jwgQU64wpdGuAmgMYRYUrRVS1WwdL2cSvUx7rgXy3h6nh8vfJcc	6938	9804	9804	1617703920000
13473	3NKbuFPDAc55VCodpuE8eyU23wReXVxbpkeLSj15cQjsArhCm26H	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1406	1393	201	6301	9712	jwJnCPQ1codJcY9KHzPUuTHmPqQLsMWKMPo5h8NrmF3B4VM9qS1	6940	9807	9807	1617704460000
13477	3NK4kAe4iyrY2BJiCAyeAU667wqg3B2gfgi7xmMjJ6gDRYrEso4g	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jxhPsTdXPwow5zHMo1G1cihYzDF5QUvX7ZzDAHsCi6cb46LtDgH	6941	9808	9808	1617704640000
13483	3NKrgg5FwoqC3HWfqFTNqkHPqpr4RbqKtNe4DtbP1QjxtbNaAQmV	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1673	1122	201	6301	9719	jwxM9gwRPpmLSVmE3K8t6cGH2h5bN6EtbE1uz6xSURG1nHDTsGL	6943	9816	9816	1617706080000
13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	13485	3NLdKCpW1hw5BoRGoW8HBRx3DLTjCPYPch1xGnjxdTsjX98v2EBD	1406	1393	201	6301	9722	jwyHakycDGCDCM9vbpHTTUp4UiHwGDJZ24otueP4uhzzkSERa8q	6945	9822	9822	1617707160000
13489	3NLvLjuvE1F6dnqLpFYVk3oLcDe6XY4KmUd9zQxrNmSdoeLj2WS3	13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	1647	481	202	6301	9724	jwBQK61AiMZT6mUF4Cu4hEfveofPZkM8SWadSyamTRPgrBvzQcS	6947	9825	9825	1617707700000
13492	3NKGSGdmE4RfmgVEh6AUkvvVPKPQEN42WvB7qPx6WnNbwQ22pD6j	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	606	1295	202	6301	9725	jxeNM2C7njCxg6wayip4k53ocd35662t753aw2CWQUnKnZjmgGs	6948	9828	9828	1617708240000
13494	3NL7W7BXLZUFE5KcSSddfkUx9qTnKydz87XC6WGnQoLQepWn9kAy	13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	1490	908	202	6301	9727	jxR9v9UFL79bvpiKLCy7YdY5EA33gzgcCUsGkCLJTsnzVeuK3JP	6949	9829	9829	1617708420000
13496	3NKEiqETKyqMdzcgmok6V2HhM8hnd6Zuf5pcrZCmz4Ktgp2FCuhN	13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	407	407	202	6301	9728	jxHpNLQxTUCGeGEaSpVF3TWA1bscnWb29CKhgjV8GNLBk8ZkRGa	6950	9830	9830	1617708600000
13503	3NKYCrjgDS99Z792BsNkNW6C9Zh3JXMGk9EHn69wcXodkAnigYqB	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1600	1372	202	6301	9735	jwVpsG1azDJCBBGW9HuaYPBgLy2xfcEaQ1rRKtacxXVPydvaF7u	6953	9833	9833	1617709140000
13506	3NLn22ebxUAAqzTBeUWszLzKxQhUPN3HN5JJPmrhzYUnjJfpDMvL	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1403	824	202	6301	9738	jwzkH4VVbaDiS7KYtYcVX8G5wBjhpbTQfVuGeuBjRsx8tggLsZb	6953	9833	9833	1617709140000
13508	3NLRTBLaawfFhrPCHTzrAwE7fUNVjU4tH8iSrWu7dWEwqqaCjjMM	13507	3NLV84D32YRYvVJq4Le1uSx2uCpjbuF1mwnAM65Zi3adUDMzxfeV	1634	1085	202	6301	9740	jwpygEioWmdsEVTm9REnoYLoXgSBJDE1iw2CjA1rBugpBicbDXc	6955	9837	9837	1617709860000
13510	3NKsP2zMQJWdZkYuRUgHN8mjNcW74uy6Eokm7ckWWNiy4FjMMBgi	13454	3NK6eBw6YdMBd8tFAYPr18EC49kLLsCa384HSQYSSP3E1B21RveM	298	311	201	6301	9742	jxQoRFm3ZggMWE77JrQEpzPjN4i6hL2RhiKAkKkmDoFVieHyRGq	6931	9838	9838	1617710040000
13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	13512	3NKrpHYf89WsYDqNftKckvr8bn32HdPJr44qux6ExCuzWq8KL36w	1406	1393	202	6301	9745	jxT55bqSqP8A8SiKEJ2GPvMpamNR1h96RtwcXXai7bM7rgmZC29	6958	9841	9841	1617710580000
13515	3NK8Sqk3SyxzpK68pLCppT6EYYsLwRxjhVvBSVPUC5XjUHHAXFrr	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1471	1386	199	6301	9747	jwSnYJh4TV74BJWaMDEuViREr5uK1P6eQJqXwtMCoJDKTzZxrzY	6906	9842	9842	1617710760000
13520	3NLhfgf7yskffDHntoRkTTguf4toiKKQ32aGjD9U6V3qDZqBcNDS	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1589	1160	202	6301	9751	jwerok3Dev5sus1fkx7qXE9chNqQHWTJpykFLC5bXUUP3LiTzWQ	6961	9844	9844	1617711120000
13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	13521	3NLmUpQzSfGyddXvEvfWgTfmB8zCYsNi3rtXKu2RTJY49meNKcUD	1622	1356	202	6301	9753	jx9dcgeSapLAQp2w7cXN1JrMBLX2HoW7wHsd7Wv4gQRaFaz9ERm	6962	9845	9845	1617711300000
13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	13530	3NKkEL4UXsiyJWFxa9Kj4S6cvTFCz9KYZanPdWqqzDpPCRzQDpkB	1406	1393	203	6301	9761	jwoxt6BozDqQBqewiSrC5tb8J4xjmjEFci4zFhCDkvGEoHSq9q1	6966	9850	9850	1617712200000
13534	3NLDKskXWeXw9REkB2HANCVTQK4mPadwkkusnn1HX3hPtwcqfYqt	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	641	1210	203	6301	9763	jwQVM6Q6UwwwNZBHncYQGsvDW755G9wWUV1zz6GMeZfHe1mJDAc	6967	9851	9851	1617712380000
13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	13533	3NLdeWMvDfwWwKu8TnvouUJcpjA6BGYyotHfBRTmQMMgL7vJGGLj	1654	1094	203	6301	9765	jxCC34aiFhzNRJM8VrrX4XKbeAqSGN1fmDZRwfhRTaty834YBpW	6968	9852	9852	1617712560000
13548	3NL8LyepaPBHXniWNY6K7CA7ZYNUu2dhEqR8akYXfLZSsj8TJcY3	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1476	1371	203	6301	9772	jxkJzprGMTw8Uk3gPD1RYYNdEsYeSUECbH1YS49cjhCJG9qUtfr	6971	9855	9855	1617713100000
13552	3NLTT3Evb8V4SWpwFZRpfA6saYfB4bomyRNPbMvPFQ4JUxEFiAd1	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1407	1395	203	6301	9776	jxHaD9oy4P5AuaxsRdvGf2MyAyuy7ZLm9vP4ym2hRJa4J7RBqgY	6971	9856	9856	1617713280000
13557	3NLRnFaCLZpdG18AsY59zP5UNHpga5tqPzY6g4faj8B7WaJfXtG9	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jx2haRvrVgnG7Ei8DKKY1LVqbXw5ZUncS1XZDYpgmGGHJ2Q16f8	6973	9857	9857	1617713460000
13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	13563	3NLHJUpXZvgS2cLN68PNdC6qa69PUPUnV9zt4sT5mry98fxhAE5w	1406	1393	203	6301	9785	jwGvaxdcDxeSjfgzQzHnCg9BS4sFmMKAdVpAVj9xEXcxpB2WPyC	6977	9863	9863	1617714540000
13567	3NKdrNZYyGEt8eFt4n4BvLd5H4jmtC939TFk6chjrMzKEiM71p5V	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	632	1256	203	6301	9788	jwDa3fBHzmuuHxk3eG6r6yMe1VHruBy61kz2Gv2PFJxUsSASZHB	6978	9864	9864	1617714720000
13572	3NKyXdt3xbXpZAUVcfMPoTQ9SXrF637UfKyGUfTn9RDtijWfpGkr	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	298	1182	203	6301	9793	jxtqYTsvzrTzqvqo8WEPmVMot6cBQzfm74HRwFhmtHMCqcEqbKs	6979	9865	9865	1617714900000
13530	3NKkEL4UXsiyJWFxa9Kj4S6cvTFCz9KYZanPdWqqzDpPCRzQDpkB	13529	3NKnV1ZkNe8g3UV18d47mG8SmsiAzpfR2pXoDHKkZDxpSQMhmdit	1581	778	203	6301	9760	jxitEhVySsPbA9x8M2jaEdW1HWcyJQ8j1BB42b83FmnvewRrWQp	6965	9849	9849	1617712020000
13533	3NLdeWMvDfwWwKu8TnvouUJcpjA6BGYyotHfBRTmQMMgL7vJGGLj	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	641	1210	203	6301	9763	jwejCWu9J8jZmyuKvssxVQeQXQ5XedSSC446xgLKFbHc74UFrTb	6967	9851	9851	1617712380000
13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	1651	935	203	6301	9768	jwpG3bDC9ed7SsdentJTSfD46zeXWsEpb7jHpdsWCAkWuzm7t46	6969	9853	9853	1617712740000
13541	3NLf3sDpqLdsyYaS4bWYEei7qfjfR3EcfiNTArjs6MWiuas7DNEj	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jwGaPRybG9WLQvQZ9Z8DRe7HQoeeeD8oGu6BR92jbmnsHbWs5mu	6970	9854	9854	1617712920000
13546	3NKNXvaKBuE1LUCUs9SmYTraryJzFyvFs262TCxixDz8wFyGAbVZ	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1447	1345	203	6301	9771	jwR6U9z2xbRa1ZcpyVQ4TedNEyobfvgji5LPJDRGSqiPaa9mhMB	6971	9855	9855	1617713100000
13550	3NLoYXJJwZQVZKbccFdEBxZbvr3nf8QLJCuoWwWpBJ2jsSudp61r	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1654	1340	203	6301	9774	jxyFrjn1Lmrg1xRZV8vB3q8W6UTx9hdxMWfxL61vc1ereEaCxZ6	6972	9856	9856	1617713280000
13554	3NLWxhdLcAco5k8Ex9AWr4UYraZ1fA7Aisj8xAUFJFqXuteS4HRK	13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	1588	1392	200	6301	9778	jw7nPLwXe7c9SwQL8LG9idPjLF7Mg8iXieZ1sb6CYdNAdAeTdqE	6912	9856	9856	1617713367329
13560	3NLyYomKNc4v9iNKxY6p21KN8SqQq8kzcEpRvwRtbS4QReY8CxLa	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1483	878	203	6301	9782	jxbYYnGbHa1vS6yzRHwYvJgj9Z4zyCTEJX8MQF3FDQcoV95T8FK	6974	9858	9858	1617713640000
13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	1406	1393	203	6301	9786	jxzxVyWGkurRpB7KNoGy85bK2rTKF3EYirKzDeHKyTodYAjvmnR	6978	9864	9864	1617714720000
13570	3NLj7aUxo9iSyzDB3XXKrPJcMPSZxqNgFU2EUh1GTUg8Dc7FKdaL	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	1589	1286	203	6301	9791	jwR9w1BQ2iBwNgsm7f8wxfSNCqoqhH2aSPRpLgchv1wRSAL9B36	6979	9865	9865	1617714900000
13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	576	1355	203	6301	9795	jwxC24vhrC3Qgquo7soLNjgqhgtf4xLyBogXfizozMUj2KcCguc	6980	9866	9866	1617715080000
13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	13579	3NKMCwpVbk2ewtDH3cmQWkQrtgcwntKdP5M9JeQJ7RVmdXG7bfFs	1649	571	203	6301	9801	jwrZPHSsKd6fcw61yTY7N5gs1V4zVBQMYwQ3yNWeuCW9UAaDsYp	6985	9876	9876	1617716880000
13583	3NKBKxQyu7V28pcUvD4QPfw4teFHo3vD4taevxQsChx1MnVyVht5	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jxVcSAEDD2Pu6SzkEnKrWpxHpAUJNQ7EJnSo7m8Zj1YmX67o9Jh	6986	9877	9877	1617717060000
13585	3NKQcMBGFJFvHbZEkmMiHajCXkSMNqv8UQTAEz97rQP7dCHEHpvP	13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	1508	1387	204	6301	9804	jxAJVQgfMMUrotEJVhG3dp1D94iC3cfrSDY9rqye5v6nFmdim9R	6987	9878	9878	1617717240000
13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	1601	1022	204	6301	9806	jx3DNkWf5rz9Rk7MwboVK3YFAjnosmQt43CtVz6rkzgdpCySmwx	6988	9879	9879	1617717420000
13590	3NKSZzUx2Mm34cY8mRTzhLA5XTkpbvo6tPTPiAdewzzyGsk3HnGy	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	44	1325	204	6301	9809	jwttwUDCQrAxR7TU5ypCVGxt5EEtQFHc7yopZkFXaWq1G98oUfH	6989	9880	9880	1617717600000
13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	632	632	204	6301	9811	jwV7TL7wBvgeorTYiNfwS4XqhxdWsBSkxeeimw9Fzp8w3KsyiDm	6990	9881	9881	1617717780000
13594	3NLRkA18deDkca2D2NgdMRZQEsTzPaDrA8BMxHY6SV86qbzaqqcy	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1642	1121	204	6301	9813	jxMkd3kSWiECNhHuSqMnj4QxedyXrkRCp7nYYSsLeSgueyYX6jF	6991	9882	9882	1617717960000
13596	3NKy2TwxuoA8hhwyZs2orY2WCaZ94drWDUH1to1gyt59GNxroPXU	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1467	1376	204	6301	9815	jwPVD1yFMZF8EFbAkJfJCBuQKKpPyjd7cNnzDGjjgYkzST7NAqJ	6992	9883	9883	1617718140000
13599	3NLXMHp2ksitdBh26brZedu5ex7g5dmzAFw1zVZskskAUKqGVJ12	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1608	1163	204	6301	9818	jwVBYpyRPpSDFDNSwb9HfSYh4xreRy9Raorfr21i1KaxFhkLTsZ	6992	9883	9883	1617718140000
13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	1529	1316	204	6301	9828	jxniWwLr3HXMMZ7zLZ6inVS33ttfe99NBHvjq8kCRspBUJ9nEyG	6998	9896	9896	1617720480000
13614	3NKNfAjNp1yJ7BPdtV1PbK3iCjjcinwTTP4c6YZcM22YbxwrPsXY	13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	1577	1201	204	6301	9831	jxJCPw4n93UXhAGnhjmnrs1CSrdY4niVzCHdR7ZRj8qeH1j5NYi	6999	9897	9897	1617720660000
13616	3NLkhmXBWW93esUDfaEBuEFvxSUudXtUQ4avTmrNUtwUJXmRA8Rm	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1622	1230	204	6301	9833	jx865Z6Y9G78gvUtnBwYh8txB7yxwvRDut5tQ4Hm2ML27fruk2S	7001	9899	9899	1617721020000
13618	3NLi8iare32Pn4zaxLeFyC8rcoMvyMvGPfRrbv14XoCVZ8CcEgjt	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1581	778	204	6301	9834	jxiMTCTjezXrnnktEWAuCkNqLekTy32QQ1TpEAQZCzdmtXAAaRr	7001	9899	9899	1617721020000
13621	3NKP8fBGfNHBztcW6VDgzUaVq9Twus776Mdn3vxL2hgqMwpKx6cu	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1599	1287	205	6301	9837	jx38CMVJgiochLVRzpC2Bbqp1Y4F46SS99shDVWWVnY67NuPdCZ	7003	9901	9901	1617721380000
13625	3NLcNH7dEFDP7U9LUwz8kPN8fnExC39DJAWLaoPwmseGbh92WefB	13621	3NKP8fBGfNHBztcW6VDgzUaVq9Twus776Mdn3vxL2hgqMwpKx6cu	1651	1301	205	6301	9841	jwsnmfodLXCF38NDGW64wTHLvLQrPvr8yibwiJatfq3bvzj1tRZ	7004	9902	9902	1617721560000
13626	3NL666bhFHNeorQqXT7iv7g2p22GuokBeHEGWUzbFusnza3EoPfY	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1542	1304	205	6301	9842	jxXWeKncyfzq5vjkd7oZ83ecujf54vbugF7NbTb3LNN3nURox7n	7005	9905	9905	1617722100000
13630	3NL6THtBcDqDyJCeaavfirtXhiURijhtQVr7s92QEEcWcBg7ZS9q	13629	3NLRLqkbL6ienaG346gaU57RopTTK2w2HHnZLFXMJwRXhWGzshLz	1534	1071	205	6301	9845	jxf45QDrWud3WnwZNCpRivXBKzuAGevvBbRKWLn4dDZUuZQL8Js	7006	9906	9906	1617722280000
13637	3NKXJnmr8buAkVvEHzULQS5H41N8WLCyVjp6kQfJ4NLSK2UoPaWF	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jwwz6VtwPfT4pqpC6qt4UCCeq99HBoW4gZoziH3YyhQ2YwCd1NK	7010	9912	9912	1617723360000
13641	3NLLZxyFJGk6FHPN571MymRmKaVNwJx1TCgr1NR8D7q5juCKbEgR	13640	3NLiLivstUVPJwhJ3MDhSgPn7vhrZsZsu2Ee71eqCcLnbAmRyT9o	1406	1393	205	6301	9854	jwjNKKc9c4AH6k85h9g2MnmBxbPZV8uE6FxnMKhigqLLSPj32vS	7012	9917	9917	1617724260000
13644	3NKkAmsdmLdyzBAoUUAP63yHGsxV9UKp7At9w21vYgTNXLyZrYNh	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	152	1330	205	6301	9857	jx2YM2o3KCUXrWEEih61cQoJRNoERYBou4wm5KBCijucpcEPoPz	7014	9919	9919	1617724620000
13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	13647	3NLbuZbnWa6wHvGdcFc3gxHzEm5ZtNR8YHKMK1TvTTuDzNwpnf81	1503	1277	205	6301	9861	jxYsjjMtFQtjZ9SMaefpVzGNWRKyRwgBv2FdrqzD2wKPVr9Z5MN	7015	9920	9920	1617724800000
13535	3NL6ouWWkspiAekMzLo2LZepxpEmEb7ittan46yJ5PSaEu494Hp9	13534	3NLDKskXWeXw9REkB2HANCVTQK4mPadwkkusnn1HX3hPtwcqfYqt	1542	1178	203	6301	9764	jxre9sfeGKnwCqgbJfaEgkMYozvnecKKkuw6PPdxqqTruJ8nour	6968	9852	9852	1617712560000
13538	3NKrzW1mYEiWd13MiXfDJbfjes7d83CetyWaKPxj4tMcKwRLV6Hp	13532	3NL6byUDsLRk9mg81PqH3Zmz9GrvaWTa95zXdKnxoe4L92yumaWb	1542	1178	203	6301	9767	jwPhbYPtpuiMruvt5cPqtnQLrjontqUU7G3aedUqPNwTum2Jz1A	6968	9852	9852	1617712560000
13540	3NLdBUYQKNxDZex4CkSdx3HdvPYupq6RHmcaswDFmiasUbinwkBe	13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	1651	935	203	6301	9768	jwZSNBbBEosQjHdRoz5afoiasbh6ASUyXzoBohCdTFi86ZC8BY6	6969	9853	9853	1617712740000
13542	3NL3Vuvczy5sgZqUSa6Mfuzn5gNU24XKoDdznzAiB6NN5gXmCMXm	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jwv4jPGXbmHWPq5BydMcEhhs5kpvvDhDAqfXzFMgUvgS68egjei	6970	9854	9854	1617712920000
13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1609	1207	203	6301	9770	jx7JDc3Cxjeuuedo9x6YYdzG4X3md4D2TGMqN2bdc9VG62Zii2U	6970	9854	9854	1617712920000
13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1476	1371	203	6301	9772	jxHF9ir48WVht1QeeaeXVySxVuyZgoRneut2yJamNvrQcQ872d6	6971	9855	9855	1617713100000
13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1588	1392	203	6301	9775	jw8qja9C56PBV7MGnUeQ5sY2KajrGmqBTfDzykSoz835hnBLGLN	6972	9856	9856	1617713280000
13555	3NKjpCpxFDqLxYdoJ4dGxYMedsvzwbeFpaBUPptUFAapEosQysoL	13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	1588	1392	200	6301	9779	jxu1A75PQMVTjV7CEB8ZTxfxaVUUcCCfAAr86nA1ZDhjB7K43xB	6914	9856	9856	1617713405201
13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jwuxyi1bazXMntdE4d2E2Cwk95HtwjrztsEXHdrSZaXkhdrVKDt	6973	9857	9857	1617713460000
13561	3NKe7P2A81WFdbvbLxLJ9e9Pxv1nzcTfSV9bWwXoy4E6taPFwcnh	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1483	878	203	6301	9782	jwnpe1boytzvL2etfrkssW1k4zWWjzHfHzpCAmyvnombFaXL4EL	6974	9858	9858	1617713640000
13563	3NLHJUpXZvgS2cLN68PNdC6qa69PUPUnV9zt4sT5mry98fxhAE5w	13562	3NKSDhyiCPb2eNKEkWh2XFsgZstVHve4wHzdT6wNAR66YFgSc7Pp	633	1018	203	6301	9784	jxK8sS3rrEvsU1m42PJ2nRSxTvrUP2enTQpFwxSKakfp8fxKZyk	6976	9862	9862	1617714360000
13566	3NKQb3L8RVdssjvuJyDFUFe8h64QgiMnsBxUcSoj2Zbsa93RNQYe	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	152	1084	203	6301	9787	jxeoorTdnCcSGXtv6DdqFSVqxu9fbcgqhwEiSQfPLHWyyZwHWLp	6978	9864	9864	1617714720000
13571	3NLfEjcMoCVBb1eTZFBc7MBhB3MeNA3UZnGLaWATA6M9ULbAZd6j	13510	3NKsP2zMQJWdZkYuRUgHN8mjNcW74uy6Eokm7ckWWNiy4FjMMBgi	298	1182	201	6301	9792	jwQExhKyX9P2cE4jL9RRjBuT9pgq36sjAfBH5baVLkYAm2sMRaV	6932	9865	9865	1617714900000
13577	3NKKLPc4sg7QamFW2gwTZs4C7hLHK8CoLpuHUzfBVsus8YBoWXsh	13576	3NLZrSZgupc1bQWuTvJymKBCYWHVK1V46XovL7kAaenf2yM79Cpu	1668	1370	203	6301	9798	jxQAh6Hmr4jemur1nC457nxh4GM8VVb6JdwL8CytoV5NoncSntt	6982	9870	9870	1617715800000
13581	3NLkxdkMPzisvHBE8xrEkwVXeRdZGLocXffk1LkfXGzacXU1gTWU	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jwEjxL6XuiyJd1m97sBywQwbEC7Ehv4T5HQFWVNvrnz64xZexf9	6986	9877	9877	1617717060000
13595	3NLupsgEHoaawFG9NKVB7cBYhRhJ7xNqFQiCt8moarn3gRZzreqL	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1637	816	204	6301	9814	jwW1E22ZCLQ6qRn4hLTXm1DgwaxfDUfj8SYhyrH61HaBuk7Ah4N	6991	9882	9882	1617717960000
13597	3NKtg4ddZsaAsoT5pu3XP9t4L5ozGfJKDBYrtWSrYd3kFTaEZ8U2	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1600	1372	204	6301	9816	jwzoCVU1hJZFeNgZtJxoPAzihwzYoKtnzPLb5dbENBDkypnbKnU	6992	9883	9883	1617718140000
13607	3NLuNQT3bvKPNqHSwrdXU5bBKfwT7a8ZD4TaFbZnhVb4CsBkvm6t	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1671	1365	204	6301	9824	jxT4E4fHBL77hYeemBCh2eGuLfXr9ToHNHRzFZYErjawChgMcJv	6996	9893	9893	1617719940000
13612	3NLptxZTybhiTwZgoXqgGjeJWgUuJXYfBHdwAXBMpRbfwBmAy5Ec	13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	484	1193	204	6301	9829	jxaHKh2UHpzZLT4wouNoVUKfpkkhVS3rUSvzvxvwtrm3HwxYeHC	6998	9896	9896	1617720480000
13617	3NKtZDyXiNJAjTjRcFXvbpdujKTn7XhReUYHBs3zKw7pb27c9ZBj	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1622	1230	204	6301	9833	jx865Z6Y9G78gvUtnBwYh8txB7yxwvRDut5tQ4Hm2ML27fruk2S	7001	9899	9899	1617721020000
13627	3NKgxfCfXCPs288mqZkpqzTGB2G9axwMd82pS84orVvuR2GXNqYy	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1419	814	205	6301	9843	jwQFGf5YX4RR7RnQuykJ6iHX8hq9tNX3YKGujZuFaueiRPgsv55	7005	9905	9905	1617722100000
13631	3NLZ9P9BXrYHQszXVhaC7FpqnYBhYYbfqKYBU3mzeHgcFdvdDMfE	13630	3NL6THtBcDqDyJCeaavfirtXhiURijhtQVr7s92QEEcWcBg7ZS9q	1457	1145	205	6301	9846	jwtM3nDxgNhBpPnkREg2F36cHtuG1LjkoB8KuiTKyZXeCDTXcjr	7007	9907	9907	1617722460000
13634	3NKfpMrrUv5TUcvWwdAJLizRnTfrpwBYjaVXwMFcj7BEmCSZNLA5	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	1555	1101	205	6301	9849	jwLnozMeAF5sBcvG6eCNtEKSFyAF7vDwcp1JuJqZsYYt4E1C7t6	7010	9912	9912	1617723360000
13638	3NLNJpQ6PEbL8Hw3oKx9n8dqJekzuG7Yne4VpkRpuJ1sSadszqQ4	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jxvb6PyUN8Jn3FmCHhQe8iKUrWespSYeb8dMcG3yFprSXzxXct6	7010	9912	9912	1617723360000
13639	3NKiKdXiqAvpoJ34UokTPkS99rXKnAWrNLbZB7RDzJEnoQ4te9uL	13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	1627	1139	205	6301	9852	jwVhEgsZRAkASRpiaRLawer7rcssjKAMd2w3PpqVo6C6doZ47ns	7011	9916	9916	1617724080000
13647	3NLbuZbnWa6wHvGdcFc3gxHzEm5ZtNR8YHKMK1TvTTuDzNwpnf81	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1403	824	205	6301	9860	jwDG4D59A3boEyQVNsPEvJEMz2Q1DSBGEgYYQXy4xaU6VAE45Uw	7014	9919	9919	1617724620000
13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	1651	1301	205	6301	9862	jxtCuxEuzgM6AawTSSTRenPYw82NEmJL8JY2DBY9G2jgk1NYjoT	7016	9921	9921	1617724980000
13651	3NKKyKL1ddaPBiWWf5RkR1RDCsHDNk4tf8KDB16VU5LqXFGEHYbu	13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	633	1018	205	6301	9863	jwijFkWsgJ6xRSPW7ciaUrucCBFAhNAsTofz4LkT9ysL4WEviwv	7017	9922	9922	1617725160000
13657	3NKZbDyaUcfx192AbGiZfdahwgL5YiyWEtkkJDtdPuTJbu3TDADn	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1646	1354	190	6301	9869	jwmHkLDDhuKyNjjVBHdmyiW4Copr45ZJaBAyCuqrYNAQNtQRkNm	6731	9927	9927	1617726060000
13661	3NKzQ7cA7G8MtRY8qbHaVbvD1bf5T1Kzb6nvbmvArQxjokM8i3r9	13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	1616	2	206	6301	9872	jxzQeEoJuuYabNU76odZjkwkzkgpTLnS5Xhp7N6iG6JSauNKg11	7021	9928	9928	1617726240000
13662	3NLw637io8ndTdfdGPb6Dc7Rw8ENiRT8x3MDgRqmKvLsQygvFBy4	13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	1670	1036	206	6301	9873	jxA1eQUrq5ZD5f8th9uBJm5PFDoZxFYRSptimnb75TuQnA2aKcu	7022	9932	9932	1617726960000
13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1588	1146	206	6301	9877	jwqn8vnwmQFA5Vk91xG4gzZsHq6GudT632qdfCNyN6qz9crXyzQ	7023	9933	9933	1617727140000
13559	3NKa43fRaryZw88PX8xmRVFdqsnBkiT2mcrX7cx87DUfPXQ3yYGb	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1467	1376	203	6301	9781	jxrFYZmnjZJXQit8HdFFJ8ppXMaALmgkBtYdYzWnhcHkLxqa1Rb	6974	9858	9858	1617713640000
13562	3NKSDhyiCPb2eNKEkWh2XFsgZstVHve4wHzdT6wNAR66YFgSc7Pp	13560	3NLyYomKNc4v9iNKxY6p21KN8SqQq8kzcEpRvwRtbS4QReY8CxLa	1501	1360	203	6301	9783	jwiiRuVCQ8fiCJChCTessWUxXCcwhq6oiLAhnhW9xXzWrMo3dar	6975	9859	9859	1617713820000
13568	3NL3wCa6m342LdMrW9oBF6pmraxiM9w48yCBpJSq5gQVg3WLeGJC	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1564	1338	202	6301	9789	jxfsFgUdKzMoETSnvEVetc6NJFiFGa6kXgS3b1hfHbzBf49p1a7	6951	9864	9864	1617714720000
13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	1457	1265	203	6301	9790	jxgjDq28RDz7pAAX3iEvWKXxz8ARXjLbhG3zKLUy9uDY7Cu3349	6979	9865	9865	1617714900000
13573	3NL8azPP5kkmwzta3Nqb77ibCq6KsSHV3LBAoMxByhJuaZxz2cZq	13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	1619	1275	203	6301	9794	jwKV26gBYn3teBZTh9KLYTUQaDydPgi4q8G6iYRLzy2YPTZK23D	6980	9866	9866	1617715080000
13576	3NLZrSZgupc1bQWuTvJymKBCYWHVK1V46XovL7kAaenf2yM79Cpu	13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	1587	1111	203	6301	9797	jwcRtjik5iWQ7nuA3ph2umx4o8n7hyYnmgCgUoaSdeSQ2coKxNA	6981	9867	9867	1617715260000
13579	3NKMCwpVbk2ewtDH3cmQWkQrtgcwntKdP5M9JeQJ7RVmdXG7bfFs	13578	3NLws1vCNcE15CrA6mHHaekQYFJfME6QParmweNihAj5vfjz57Cs	1624	1334	203	6301	9800	jxAP2TVLkiFSwE6Qy3Wk8utmvr27p64xvrq1NNgGfv4dosZ2vgb	6984	9873	9873	1617716340000
13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jwhgXVFMUkihwn7TXZWQH1aCgDPd3YKwRPmyzLAuxBdw537dADD	6986	9877	9877	1617717060000
13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	369	946	204	6301	9803	jx9L6Pb37UudmJACGjVx9D5jpQKD9cbRN94HExfpoccQtL9RmAE	6987	9878	9878	1617717240000
13589	3NKEbRwnvdyJQbBSRNGJ36Wx2pyecgbRXGCadBHHx5aEs7RSyjCv	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	1593	1346	204	6301	9808	jxWVkGkg58LDGijsPqPs31ik7yWWgXJNkqWBhpoFF7D54R2hq3a	6989	9880	9880	1617717600000
13591	3NKfGSC3MBeCBnErBu8jbYo3L2rqzkYgbXwfRdEpKikN4rfhD6va	13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	1402	852	204	6301	9810	jwzyBzTWNc2CH3TSJV6Nma8tmdbpnDPz5KjbuQbBczdVgN6UkYD	6990	9881	9881	1617717780000
13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1534	1317	204	6301	9812	jwQfSxbkM2v1GZ2jjFU9mCSAptK32gyr9utgfkRwWgkTBa8wzmZ	6991	9882	9882	1617717960000
13601	3NLpM46DtgsrptqtfEsXrxiTaWVzWM68r5KbKzdBFc7kqLvZVhB4	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1608	1163	204	6301	9818	jxvBZuUfaAcFz5oEQqDWbK4WWcevhjz4fuTMLfzmx5WyShPu4LK	6992	9883	9883	1617718140000
13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	13599	3NLXMHp2ksitdBh26brZedu5ex7g5dmzAFw1zVZskskAUKqGVJ12	1637	816	204	6301	9820	jwEh11rq9rC4bsdYknT9sW8MKD3U6F9ttKqjeWn388PGvJGzcRf	6993	9884	9884	1617718320000
13603	3NKqVWzwPkc9eX8v24hCR1zscQsJxfiF35froKT2oapRH9poZsoq	13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	1426	1364	204	6301	9821	jwPqrWTiWsG565GDgnH66SPEZRaKDGSYuUA4KCYkcAjQEHCXczf	6994	9891	9891	1617719580000
13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	576	1355	204	6301	9823	jwv9xk2A54qLq1XwhEazCpCLE2W3SJNumYse6gXZ6tcpDVV8P2i	6995	9892	9892	1617719760000
13608	3NKtBr5soQhnGyCJ1n4wie2CGDE5QKLMfb7QnJwd8eSMqu1qQUfz	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1503	1277	204	6301	9825	jxsJfPo2Quc8vipWYT19BsreZ6owC1pMTNCuZsrTT2PKn4PNaAs	6996	9893	9893	1617719940000
13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	13607	3NLuNQT3bvKPNqHSwrdXU5bBKfwT7a8ZD4TaFbZnhVb4CsBkvm6t	1656	977	204	6301	9827	jxTG79fq9jFiCCCW9ENAWmBZppXimPb2vDcQihyJSxC7FtWpA45	6997	9895	9895	1617720300000
13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	13618	3NLi8iare32Pn4zaxLeFyC8rcoMvyMvGPfRrbv14XoCVZ8CcEgjt	1407	1395	204	6301	9835	jwKaLsbVArLxh2NN17zYWC45hidnc2myY6FJmtKGuhskPbAQtqb	7002	9900	9900	1617721200000
13622	3NK6QWRkjY5MLmAKomm2tjHYWtNUz6178Rui8L75KPr6z9V32nM4	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1631	794	204	6301	9838	jxGH8mEaDp8A9pmAGi5PAzehvQ4jVgiRvxmzMeCKrmotKjwzqJS	7003	9901	9901	1617721380000
13628	3NL1aUUvobveDsXwrJdP2r4FLFEzPCTQuNXxsnjLTC1mCZZGHmRb	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1581	778	205	6301	9844	jxLwERLfyifsYMAVzJtNCLadMzuXRAUoF7AeL7cZXEDQ9DMRCtD	7005	9905	9905	1617722100000
13629	3NLRLqkbL6ienaG346gaU57RopTTK2w2HHnZLFXMJwRXhWGzshLz	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1542	1304	205	6301	9842	jwtMKyjYxTG3gmoePcXkPyuMvNQ8HiQihX3UJwWgYByGTdynufN	7005	9905	9905	1617722100000
13635	3NKiq5Pfs1vNcaLeZkArz45ehnHcEtNiZeGb8C5zZNPjYxT9Qr8j	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jwF2BfRAWSqhv9w3C5TTHeX8pj8GiEbNBBPFeFPpZ5EqzT1DZ5o	7010	9912	9912	1617723360000
13640	3NLiLivstUVPJwhJ3MDhSgPn7vhrZsZsu2Ee71eqCcLnbAmRyT9o	13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	1407	1395	205	6301	9853	jxk6LjYWSLVVcUWRc735aSCZtN77En7Rg6FrdsnQZ9RWoS5Td1j	7011	9916	9916	1617724080000
13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	13641	3NLLZxyFJGk6FHPN571MymRmKaVNwJx1TCgr1NR8D7q5juCKbEgR	369	946	205	6301	9855	jxr3UhFU8vEMuDNaYv1WupiRFqrmmauwDGZbsTUy5Tm87EwgUQs	7013	9918	9918	1617724440000
13645	3NLsuReMeF8LEJMLhjn9r3aoRJdDCHzXkVJRYu2ynwyTmgCBRVH1	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	80	1147	205	6301	9858	jx9ZMuKMytfXJRXb6cTrnYfCoDZzRh7FbAicaWyrTRNkj4Uf2J9	7014	9919	9919	1617724620000
13650	3NK7aVnU34xxArcR1Z5wVsgdrf2jyvzWsXsVSiUaQLFfj3dyfD1x	13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	1651	1301	205	6301	9862	jwrNWJSwDStKQSuPXPBp2mmkw3p7yyc4ZDMyaDZFW4kasYXcfB2	7016	9921	9921	1617724980000
13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	13651	3NKKyKL1ddaPBiWWf5RkR1RDCsHDNk4tf8KDB16VU5LqXFGEHYbu	1581	778	205	6301	9864	jwFjB9eumNXr9hLcjn56GEoRrw5VPFDe3RL3DCKV3FZXj3c4sDz	7018	9923	9923	1617725340000
13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1403	824	205	6301	9866	jwwCMgngqdcFa5D77mXdYHuFJkpdJc8brcsupgCJae6pAQt1PNd	7019	9924	9924	1617725520000
13659	3NK6nFSGDZ8nwqk1swak9ePkGoiieuGdGwc6hdfjvKQcjCJFnwVX	13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	1406	1393	206	6301	9870	jwyrGDVNn9CbJqYAyDfKJYCxuJc7GjUzNEkdnh8BGGw2QQhbp34	7021	9928	9928	1617726240000
13663	3NKpNop5hZ8HjTaTc58nDzTzuQsWRJsEeQkrgcAud8mvWuJXZpGg	13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	1490	1274	206	6301	9874	jx7rtmQTirKAGRzYKbhjL8UQYqKtYC1NkLKTrCeDkkX8tBKqgVV	7022	9932	9932	1617726960000
13667	3NKZ7d2WBL3dA1tX6vwFw6VRpUK5uWiddAmMypED7SYr13YNYmEv	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1642	1241	206	6301	9878	jxcNhUwS5SxyEJ7QS14ErkRQgJtemm1AzpNcHN1Y5m2RCv9MtPu	7023	9933	9933	1617727140000
13575	3NL92p9TX4bRdTCx8LYnd9v1ZiRwdXxq9CaAPJm5t62NxF1RWQcF	13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	1406	1393	203	6301	9796	jxEuMx8UprLH4TJ1BRaCYFBcsU5mNi4wxQ5dbvQdVuWwzbfhcPc	6981	9867	9867	1617715260000
13578	3NLws1vCNcE15CrA6mHHaekQYFJfME6QParmweNihAj5vfjz57Cs	13577	3NKKLPc4sg7QamFW2gwTZs4C7hLHK8CoLpuHUzfBVsus8YBoWXsh	1403	824	203	6301	9799	jxxudWiPVbvdo5hMFyzA16FBry6DPsPR2WdL5UfeEkGhtNUXkWd	6983	9871	9871	1617715980000
13586	3NKSGnMqTAwcR8hNGKA1SsM14ZFryAK9GRwp9PGq6nTNuRthXHVE	13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	1610	1068	204	6301	9805	jxZNafMmxYjoiw3sEWNu7N3rbwUvZLxKRtzS9WGDsaoLVGroQoD	6988	9879	9879	1617717420000
13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	1670	1282	204	6301	9807	jwsYcgJ9eNF6FLdWy2Z5b7H2jVHM2oE2QzRnjESnF4b4L4Win1o	6989	9880	9880	1617717600000
13598	3NKzWKp5JoMhKaAMwZy5TxfArrM4PSwYJAWN1KqxNtoBQKXP7xUW	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1406	1393	204	6301	9817	jwt4TZF3bjEdXiXeawahZQ4gsLxuXPqwqZMiRwqbJXip2ZxRoWr	6992	9883	9883	1617718140000
13600	3NL2YZRpct2fqLxNPgiL9Q9UxLWdeDtbqra1JiN418PACceNGL2V	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1642	1241	204	6301	9819	jxVEsVkhBrZFiSkbp5cUBuYj3RYPUd9LHyYeD3towioipHZaGk8	6992	9883	9883	1617718140000
13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	1585	1240	204	6301	9822	jxxvUbGry3emcPNgdMtfLbu6JpNFLxZ9pJDxnvkV23SeEzGeijd	6994	9891	9891	1617719580000
13606	3NKyeYsn8P2U86MbTvgBKdX9AtChUXSxYSgd3qc5UxefYBnQUrmm	13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	576	1355	204	6301	9823	jwC1aEpWvSySgnGedkmBNzc77nAVcCtJCfBdiciirXGFJvqg4BF	6995	9892	9892	1617719760000
13609	3NLWGrxhYoTKX88TvrfRHzJjCKE41bJqnRYV6uZ1tYWx3SHPFZBL	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1631	794	204	6301	9826	jxGu8MD8jdJdBrWSQe4LptTJVFN2JTjRvea7yoRMDEjXbSNsp9r	6996	9893	9893	1617719940000
13613	3NLpE7TwRLL4yKjiud8cnUzgMiDrDwrYK2SghHg1isF4SdMfggXU	13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	1406	1393	204	6301	9830	jxXNvfuP5cYN2gBJ7YTYh7Pz8oVAcnVnwmZU3w6C2e5JJA7WNdt	6999	9897	9897	1617720660000
13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	13613	3NLpE7TwRLL4yKjiud8cnUzgMiDrDwrYK2SghHg1isF4SdMfggXU	1406	1393	204	6301	9832	jwnWwKi2aGMr88QGfUTDsVmsHNkx66fvDEcehA16DTZNZectUPH	7000	9898	9898	1617720840000
13620	3NKHHcq1yztqBNejpzij4cMY6SvSgzmTDLGatGJhBhPQxfYdtBSy	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1600	1006	205	6301	9836	jxV1CHeFrKEivxPBGtLtu3E8QRdNTjZmFEoWPZF767qrT4UspnH	7003	9901	9901	1617721380000
13623	3NK319reFKwib1d1dVyxcMM2xCuFmMkRfjqmqajvYr1z5y7jquBd	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1643	1299	205	6301	9839	jx9L3rUncWWZwCKbWT6jfcC7Y2Uqt76LzKshFp6SvBvMUY95x9a	7003	9901	9901	1617721380000
13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	13623	3NK319reFKwib1d1dVyxcMM2xCuFmMkRfjqmqajvYr1z5y7jquBd	1651	1301	205	6301	9840	jwtgkhKFG2GQyUi7fTXCcFojJw9iCdnt2CgW9n3H7uu1tTEfnRM	7004	9902	9902	1617721560000
13632	3NKkLgfPtJLXmWAuRrZf7EhcL1fiEdaZi1FSNm6dbeoB2RtJStRQ	13631	3NLZ9P9BXrYHQszXVhaC7FpqnYBhYYbfqKYBU3mzeHgcFdvdDMfE	1406	1393	205	6301	9847	jx2MDht5iaCHiEnthb31jAUw9ysV24yQnb1y8AwT6DkBiYygCA5	7008	9908	9908	1617722640000
13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	13632	3NKkLgfPtJLXmWAuRrZf7EhcL1fiEdaZi1FSNm6dbeoB2RtJStRQ	1623	839	205	6301	9848	jxhKNDGSasmugmrFK1u8L79wkbgRoorrWK1LW3Cnw1QRWEGkpZf	7009	9910	9910	1617723000000
13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	1419	814	205	6301	9851	jw7Du5Dg2P3Q4f86uynhpvS3F5GvcDhERKjdNQsqdbi7BjGue9a	7010	9912	9912	1617723360000
13643	3NLkN5yPudXyo1F25aGVaDMMuVxY1Anw2ECRZUKuoDPph6qdRYYJ	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1407	1395	205	6301	9856	jx9vLF67WLYTKdb2QS7dD8w2NcVB9CMnZdKqJHZ3hWfPGPMEhWV	7014	9919	9919	1617724620000
13646	3NLG6QprGtJR1Pn3VqRNSMVv6odQBvDu6pZTNupLdPtdyRsAnHnC	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1406	1393	205	6301	9859	jxKzjxtsyBBJsb2ujVbDmUqt7vGd8ZRGrXMycTVHvsMPs5ipfQA	7014	9919	9919	1617724620000
13655	3NL2NmZXY1S6vKKuq7mCKCrkJkq2QJHsqgwg1sAtLj8Z11oHNkR3	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1581	778	205	6301	9867	jxVWyMR8oA47BiWYPFf2hRFhBt7SM7PfGcyB3WgYafbmGvmW2sa	7019	9924	9924	1617725520000
13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	13658	3NLCp51JurJpVTT1DLFA8eDFXEFBiQatXR4RET6xMBJAty4HxbHM	1490	908	206	6301	9871	jxzQwZZRTUZBj9DmgD1QP1dELjESB9sBT8f83NGQCuH9DoUPnPF	7021	9928	9928	1617726240000
13665	3NLnEJEVVXMiVTsQ4WhrdLmNzHdxDXMfhY86QYFMGsXVkPzFzmce	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1588	1146	205	6301	9876	jwG6bNb7jtcu3cx4cAv8c6KqmHzugLtVprQQYpdbZ3XruBCBmFN	7019	9933	9933	1617727140000
13668	3NL1M2xYR22S6gyzmutK6L2JbMXphD1mcLsHoEn4t2EF2xZVYM5m	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1642	1241	206	6301	9878	jxUTWrzJzwFD6cmkiusAWCLZuVY2gQ47wdFACSfwozLSePvU4bp	7023	9933	9933	1617727140000
13669	3NLDQn71ueXdxND72rcMv1UzxXghR7j2AmtZEPX8u3Lzgf1T5SEU	13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	1444	1381	206	6301	9879	jwRyVbf1CsSwqY2xHAVT2Ppmw5SB4xyAD93rYDXhjKwMgrk42LP	7024	9934	9934	1617727320000
13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	13670	3NLs7dYQwvUaPZuiDuw5PHUZ311t3Z5RUBqifYKHpjRjBuKcUUR1	1534	1071	206	6301	9882	jwU1mcGKwixvbkrdCsMkm61Mv2o3RHdF2LqCAJQuQygeEqhQZB3	7025	9935	9935	1617727500000
13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	1631	794	206	6301	9889	jxGcARFKPKXihh8xdv9qse5KrtiU1aaqaPTnvA1AGSpNTW2RDWQ	7029	9939	9939	1617728220000
13682	3NKBc5XG2pQUiPBZAEdnFWftoN1G1rfnJwGbT91MvKJsK8jZF838	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	563	1359	206	6301	9892	jwyfYV7QEJAYf8PZasCKJXhdzYXwAXePU1ERcFuNnUDQJhgbg55	7030	9940	9940	1617728400000
13684	3NLxSwW6hoZodkc1UEo7CpBgjpYiWUapGA19rvNtg73EUVBXQK6W	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	149	1037	206	6301	9894	jxirCm5Rv8Fyv7oxQJwvvSVDHR9s5KfKCvXDUFuXgHtQr2mYKx1	7032	9944	9944	1617729120000
13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	1559	1227	206	6301	9899	jwEojLUohR9NC3dDTgAN9z1LPDMA2UUFmfcDyypwbzmqz7j7Trt	7034	9946	9946	1617729480000
13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	1637	816	206	6301	9901	jxXfRa4Ctk11DmgrPEnTUDDf26v8jJqRzSYZHLvEVeTSSzWzzWi	7035	9948	9948	1617729840000
13696	3NKqK4KJyoq5rUYAghTsBnvghTDSVRXo436hQTM6kkUJYG97qGGw	13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	1407	1395	206	6301	9904	jxijhRsCqT8tzp2XAi44GeuNmp4BFZR8cDaBhSwrUJk6g6TqeL6	7037	9952	9952	1617730560000
13702	3NKziwSkEbVWSHVj9QEYQqXsfFGsU6xiQBq7Ng61ijwc1W14LRHb	13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	1549	1236	206	6301	9909	jxmnHpUbWgd4PJFLAxs9VaANfHpifpN2sMcSEamWBUB3mKk788D	7041	9957	9957	1617731460000
13653	3NLdG3aFjUgCzc6SCsJFnDzMnwW5LnpU4ER2G4dQpXkK2K42apRB	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1407	1395	205	6301	9865	jx2Y2Pq1uy1sijpGjHBm9pqR4gTM9dJ1WTH7ey2qvKZ8XrNTB1J	7019	9924	9924	1617725520000
13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	1646	1354	205	6301	9868	jxWfk9JuU4Rq4utcFqhGKB3oR3zS5ZENUirFYXXPv5o2GsUbsVd	7020	9927	9927	1617726060000
13658	3NLCp51JurJpVTT1DLFA8eDFXEFBiQatXR4RET6xMBJAty4HxbHM	13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	1646	1354	205	6301	9868	jwojoi8eNDY9Fftow1PaDFNUeLP62HEVaeQ6fsi9VaF7uoTzdtX	7020	9927	9927	1617726060000
13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	13661	3NKzQ7cA7G8MtRY8qbHaVbvD1bf5T1Kzb6nvbmvArQxjokM8i3r9	1670	1036	206	6301	9875	jwYDiq7uqiFgmM1PUHEkZA6dqomKv6aKaxdcTqydZ8CtEn5ozy3	7022	9932	9932	1617726960000
13670	3NLs7dYQwvUaPZuiDuw5PHUZ311t3Z5RUBqifYKHpjRjBuKcUUR1	13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	1652	1315	206	6301	9880	jxhMwYRkxVzq8cp87cLeFxBRfkebwxaacfUmajySPLoegwHMYdK	7024	9934	9934	1617727320000
13675	3NLqWKyRSLodQ8SWcspRteo3VDwxSgoFDjNd7g3bTWo5vVASJU38	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	1536	1313	206	6301	9885	jwaNqAVyDShFps3rHtC5zfv1fE8UrxNaJfBC6gXmQ7BRk6QRzaG	7027	9937	9937	1617727860000
13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	13676	3NLCVSFEh3SzY37Szqrp6SoGX1iNsnhzgackT9CX4RqZ6xyPtEcB	1466	502	206	6301	9887	jw8VQ8fmNBrdfQ3GUfss6T4sZ9Lo6jNRrCt2iqwvnVyvmwKGroq	7028	9938	9938	1617728040000
13685	3NLjdgQRa6WsUiGP5s6go4ohgYGqvgEqLEAWMdjeTxey4iRtaixb	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1490	1274	206	6301	9895	jxp1uzDWAYZ68MkrK2AxNauLHTsc4cCUWphJPK4McjYDhF95ASt	7032	9944	9944	1617729120000
13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1651	1301	206	6301	9896	jwx69FzZV4E4uMKtSNviqSjbYsjtpFW6xV5mQMKNqpHti11PGx2	7032	9944	9944	1617729120000
13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	532	1303	206	6301	9897	jxH6bMxHXGSpKRamgg2G7vBSgNXscYRV7e1r5xoR8AVvro8kQaY	7033	9945	9945	1617729300000
13694	3NK75QdjQtbK2JZ6TDCgu7H5NKjHETjJ2nRQc6a9xFZ1LEApL6A9	13568	3NL3wCa6m342LdMrW9oBF6pmraxiM9w48yCBpJSq5gQVg3WLeGJC	1564	972	202	6301	9902	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6952	9950	9950	1617730200000
13697	3NLDCzFrgrajNJY8wUBkWbSSouKhU36sYDFsk6fq3aYZQLpsP1cV	13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	149	1037	206	6301	9905	jwHYng394nvWyzJuqaB8wSLJC8pGBB1Xrm1ZcdPpRmzoWnoHtDQ	7037	9952	9952	1617730560000
13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	13698	3NKPiHAruBL5KVLbx1qavqnsKm1RX4H9ppSPckYd7GFbLcndWr1b	1423	332	206	6301	9907	jwQk3gYmLJhVxC1ZDE3QoiJEwZ3FhtaGJMaS3z59KxT6Vm1tVnG	7039	9954	9954	1617730920000
13703	3NKHge5oczsPsdhq6TZ8btKd8ejYVeybRcG3cCASU2U42VFCzW6r	13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	1549	1236	206	6301	9909	jxmnHpUbWgd4PJFLAxs9VaANfHpifpN2sMcSEamWBUB3mKk788D	7041	9957	9957	1617731460000
13711	3NLDqQefFEGHxg5uQKNGfbSMkJyEL4VbWKtAGy9TZDujQgZNmKxR	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1506	1007	207	6301	9917	jwUxCZ1ghYWGCn8HWkB3vEKzBEduVzWBbwJBH9WYvoDqts9atZv	7046	9963	9963	1617732540000
13715	3NKaoiPTLzRaQVmbdFxkT5fGNABxKe6h9ETuFtMT4FPMsYUrDSCX	13713	3NK7Ny3TEvsvAMBCMhinyHwCr6bdiBv8crbsU4EzwM2emzudmuAF	1467	1250	207	6301	9921	jwRoBNjHBHRxocecPK46aS8RyBFSw9p89Aaz3J1UX9XzEapwJam	7048	9967	9967	1617733260000
13718	3NLHk82kqXSu7rti1FpLcVConFnmXqrccRLm3qtEvVorZPUpE53w	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1571	1335	207	6301	9924	jx2AEBna58tufhwvJsksGWrefd5BdgZLUkNiSCvhuymHZsiSr7W	7051	9972	9972	1617734160000
13721	3NKsAyJm5Tc2XuscVpZHf5h7CnyvKKhd6FbfCDeoArkDw64j2PmA	13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	1407	1395	207	6301	9927	jwC7KciouvskwzLz2WoPG133rbsrkNqYE1w2LtxMPUTGoYgF4cn	7052	9973	9973	1617734340000
13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	13722	3NLdSxdiyT1pCJNVotBUXw1tbZDLpZ6LMLReaEkEATJAD36HkhMS	1423	334	207	6301	9929	jwU7YGXjiqrARc2u7twTP89GXCDyFii2qmNajwNKYHv68DHbX6m	7053	9974	9974	1617734520000
13728	3NKRNyxUeEzN28gMpwoojog8i7Z1HaPnYfberQDjJhLudbqk8rqu	13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	1599	1287	207	6301	9933	jwdtqiwLdxNrXToiCHynBNA1mFZ8dKP75kXXJcRm1V1yWh2zCEh	7056	9977	9977	1617735060000
13730	3NKxhxq1rVDBPzLVgj8NsxLUzLb7BQE2WLHeN13ntoHxNPEmNpi1	13728	3NKRNyxUeEzN28gMpwoojog8i7Z1HaPnYfberQDjJhLudbqk8rqu	1406	1393	207	6301	9935	jwEekJPib7PoT6eN7eSfmv7KZYR6eBdFDanNm3KUsgnQod11Gdf	7057	9978	9978	1617735240000
13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	13730	3NKxhxq1rVDBPzLVgj8NsxLUzLb7BQE2WLHeN13ntoHxNPEmNpi1	1591	281	207	6301	9936	jxgvV9xUw9HTkm2UHabVr21VYSfympnFL9NZtKx3FLUZV9wK7H1	7058	9979	9979	1617735420000
13735	3NLkatTGZqfgM8HGfzZvpsn3r1TgXjyNwF7hkdNnJoJdSpim7xxt	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1506	1127	207	6301	9939	jxPpPX6Bj625kHAWfwZ9P5DLWpT8mSybrXYmifEtGH9JZNGVerr	7059	9980	9980	1617735600000
13736	3NLPC5pnq97VVVxxVENJxBLzjtxZQJsAbdoCo2FuYgLJj9m1SJha	13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	1406	1393	207	6301	9940	jwWeXWAPdjP6oJEJE1KqfJKjWQK8vbBf57w4yaz8iu6rzHWnP6V	7060	9981	9981	1617735780000
13740	3NKvhGWsq6kp6kEfBFqEzpn2JmnsoDS6EJ1xML7RexL3dQFSJ97a	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	208	6301	9942	jw86BDjannSmjsLU1nuaiZcsQujYNBU5u3t5WtT1LruMKoEm4Wn	7061	9982	9982	1617735960000
13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	171	1374	208	6301	9949	jwSuURQy8EKyT9c9nkyjgLaWWQHamNatU7CMqTMVjhT4X1GLjDM	7064	9990	9990	1617737400000
13750	3NLqG4oRPaZ5fehsvs6jLxJstmsvKfcxXroVKc9orZZoy4fcYgfz	13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	1542	1178	208	6301	9950	jwtrUPSArVcVF579mjHQx5A64uW2tcWzo2Dbs4MpvrbYqcYDakJ	7065	9992	9992	1617737760000
13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1406	1393	208	6301	9957	jxGVYCAXDUNN7wK6yYRSVTntr5Pw8S8jQdTNJP42hobcEBJUhcx	7069	9997	9997	1617738660000
13761	3NLiQAhfStXtZ6g9fcqH2hKvzMh2NzuLi93J6KNNcf5UiQdLdg9K	13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	114	114	208	6301	9960	jxveCRp1kV1FmYTFcjopvp3YUMzzz5w2mWLmVbUsL4cUV9J9Ttu	7070	9998	9998	1617738840000
13766	3NLF43sxy562kx8trKUKT9YDNo7XEi2uSh7TJSXePQsMKZVQEhvH	13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	1634	1205	208	6301	9964	jwvCkSzJiVDmF1znCe8CkZq6Ef6Gf6me5UCBHZeCr5QUJsZrt6x	7072	10000	10000	1617739200000
13769	3NLbiSPCmioCPCigjW8DwXWFrii273EAQCJSRsoJkx32xeFPqKWb	13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	1403	824	208	6301	9967	jxVQRzEq1e3XaizswGfNUbLN4cmVPsdATzuYuN1WehLnXnh5jhD	7074	10003	10003	1617739740000
13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	1649	1017	208	6301	9968	jwMkAaatqGTWpqzpKaHa2MyDs3amv5ZDeCp7mELwMNtaYrYtDFD	7075	10004	10004	1617739920000
13671	3NKi8TSNdNWrxTMpt7hReCuZTnVzNmurNkbaXkLq3JWYWttu3vdC	13668	3NL1M2xYR22S6gyzmutK6L2JbMXphD1mcLsHoEn4t2EF2xZVYM5m	1444	1381	206	6301	9881	jwLYwsHoUZVH2BEHuom3FizKGk4HCuezmcr95VjsVMpR13LLzz1	7024	9934	9934	1617727320000
13674	3NKRVdX869SZndhVKCoSqFb8rnc2AsmWXsmyUyVUkhwk9Q9k434a	13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	1541	932	206	6301	9884	jxHGyweJf132phYq4csv4T1dhRy3oTewXS6AyNQqrjmwHVBPXsT	7026	9936	9936	1617727680000
13676	3NLCVSFEh3SzY37Szqrp6SoGX1iNsnhzgackT9CX4RqZ6xyPtEcB	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	311	1061	206	6301	9886	jwe1a5n1sU9FJWg3rGs37QgbWDNSTZ6aZKFmpQswfMTBcXCyTup	7027	9937	9937	1617727860000
13681	3NLiWPMGEoVhw3WAUpmjNj4bmi9KM8MY1KEqkCn1X9DHcWrgEVYf	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	1553	775	206	6301	9891	jwvKU4fCu2hpggeKcjvCbmGmHCHnXJ5ha82bnHaxpBotuYnpN1E	7030	9940	9940	1617728400000
13687	3NKv4KESR6VUXWtWHSdGX7bxZKkTRUS1tmaGykMjvnC1aYnUdnzA	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1651	1301	206	6301	9896	jwmvHUgHG96c6np2wCfCg57HdDKF4fHAcq8EERqXiHtqE48HDEQ	7032	9944	9944	1617729120000
13688	3NKTqVY3Csw5QRuD4tdZ4oUSYexLwxh8xYBb6gTNMpKU9XGSW33o	13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	532	1303	206	6301	9897	jwisLQSvuggzAXajn8bgtpSzSCGG6uwwwN1PJCPMqhJDdcHRgCQ	7033	9945	9945	1617729300000
13690	3NKfU9kjSShuL4kQaDmmbcWWWvty3NWAUgYYD6zF4YFCXnnjk6i6	13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	1642	1367	206	6301	9898	jwZ3mvRxhQ9eomw1di4SMBtKpKvuTqhC86aZoxFeQbysNvkmiUS	7034	9946	9946	1617729480000
13698	3NKPiHAruBL5KVLbx1qavqnsKm1RX4H9ppSPckYd7GFbLcndWr1b	13697	3NLDCzFrgrajNJY8wUBkWbSSouKhU36sYDFsk6fq3aYZQLpsP1cV	1407	1395	206	6301	9906	jwcQt64zDMPidBG78gzbzysGdigPSVKuzMktm27QQ1pzjzWv76N	7038	9953	9953	1617730740000
13701	3NLMfcHFRDswoCdTruprRdh5F84fHshZtwt1HRgwn14hzQP9v3Nd	13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	1651	935	206	6301	9908	jwCbuEdCf6CYWbhFfxwnniHBvBY7WHEyhfppHXJqhH5fJdMtJmv	7040	9955	9955	1617731100000
13706	3NKp5GWMTz6mPp9QCrp2yPL2LArEzoVeDAmxGAQRdG6wJx3BKvQz	13705	3NKt4su5DQeABTJcCBAnGUkGKLvAvK7LfHtTTAzkLBdPGtBt1vqf	1407	1395	207	6301	9912	jwgoWLDDgSRBDH988nM62vSkG95iKyBS7VA73pRkkq7E1Q28Hk4	7043	9960	9960	1617732000000
13709	3NLm6CSdWcZBZaSE8on97EdzwCCi4bwDMWz6V9ZyPeewDahNEPUY	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1406	1393	207	6301	9915	jwpf99aSg1ntKDKNJCQsm6iPreoqrue3Xno8hMmNe2Q7GQyG53H	7046	9963	9963	1617732540000
13714	3NKY6N9oEFZQUr5TgQ7kK5S2BJBLCTv2hsBiTAQRWa5nj5jEDSWQ	13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	1617	1288	207	6301	9920	jwpNoxkga9bg7ks3JFZ8eQAvLiYAvSRkdfY5up1bvSV7DPCXay7	7047	9965	9965	1617732900000
13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	13716	3NLLQoo8zZx7gi2knnHTmsquzcxwMu8DMgB5CwMT5SYC2Bx3kHXg	1585	1120	207	6301	9923	jxQGfLceDjhHi2eFyJK2jJdUuWR7zmerhMb5ntsUxx4EfXybvFF	7050	9971	9971	1617733980000
13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1407	1395	207	6301	9925	jxzXsGF1RHVFziMVUigNrotoaSmaX6T2ieBewNeNWrxNEkUjYZp	7051	9972	9972	1617734160000
13722	3NLdSxdiyT1pCJNVotBUXw1tbZDLpZ6LMLReaEkEATJAD36HkhMS	13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	1406	1393	207	6301	9928	jxzGkUQ321bFxVenCq6hituyYQLmmA6eyNpxUtQHb5U6xXvrQ7V	7052	9973	9973	1617734340000
13725	3NKhK4WAKBbNAMTj4qhMZqfDrfnAA4JXvNt33v4zLCSVPKSHg5vR	13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	1467	1130	207	6301	9931	jwqtivWFCshGAFA1Z7kHa83UuvLAj5XzX2f4PGftqsQRNxzaLi7	7054	9975	9975	1617734700000
13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	1445	1290	207	6301	9932	jxAAqoPoqvnHjm8LqBo1CkDqJhRkVtqNM5W5vUFEhUfFj57io8Y	7055	9976	9976	1617734880000
13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1553	776	207	6301	9938	jx9hCpTCrkfD9X7FeUeeQPDTraQsa48Z8N4Y8upVxQNk3vxdmRD	7059	9980	9980	1617735600000
13738	3NLPHLdVWZPqqNtcYdV19mpJjgfgp9LAoNNs5hFLchUUFLXDtXwp	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	208	6301	9942	jxhi59CQc8wJaSkqsEhVKCZT6RzXscsiF6R1JX9Dv259cLRVL3c	7061	9982	9982	1617735960000
13742	3NKjVr1yEctV9ZFTRrc6oSnxpPWA3myM1qGSeoHeU3MKAWFctpa8	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	207	6301	9944	jwuqPi1tJ99m7sgSkokbbg52udetW1Z9iYP38tk6LbV7gY3pTtH	7062	9987	9987	1617736860000
13743	3NLYmCi4UEiL3Kwut2R9icLiJLde2kdvmZNzCTaGpF27YkhNeiHz	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1406	1393	208	6301	9945	jwQwmaEsWEyGsxUkQj1RbVAK6ZF2CFRQXfSWJFMGhTJy4R328KX	7062	9987	9987	1617736860000
13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	1406	1393	208	6301	9946	jxrDKCW3dfRWFLhLqQxVX2LjCLGyLWQzEiw28wKn9vb45Bo97gk	7063	9988	9988	1617737040000
13753	3NLPsM4spYfT68mUQPqHptKbKsX3dSqKYYT951hepQ2MMQyLP12X	13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	311	1061	208	6301	9953	jwHutY3ckMnvrFJEwmNjadzYtoaTM91eAT6fXUVKkuqTRVDhjNd	7067	9994	9994	1617738120000
13759	3NLd7ejZ4T2KFcncM69Wh2HxY96iuPu15aVc1MrYHmUgAbwi6SEy	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1560	279	208	6301	9959	jxucQ8Zcod96ygnjgTJNentdz33Cd4PYavZqqyEHWe8fWixYCsQ	7069	9997	9997	1617738660000
13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	13765	3NL4pixUFZ4W9xEGHDT3Wpt6ZTMobqfAvg4qc2NfgyhP59g9oPHR	1529	1316	208	6301	9965	jxNwDzg1bPmBwcj94ETFJdQtYhNSdCvBDw8uAWYswDnVrZ1Ega5	7073	10001	10001	1617739380000
13772	3NLFLTjeViMkcMJpEfgmjexn1t8oyYbNJUMXPwNWJYjCaSexVqba	13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	1587	1231	208	6301	9969	jx2Dw2DZpXprrdVGCu8ezDatSyh8mKXRNYpebdDtgk1zcTcGwTR	7076	10005	10005	1617740100000
13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	13772	3NLFLTjeViMkcMJpEfgmjexn1t8oyYbNJUMXPwNWJYjCaSexVqba	1617	1162	208	6301	9971	jwL5jyoZf8svasNCzE8DC248qfsJ2zTsX9VVDLHKVwDE3CDAMtq	7077	10006	10006	1617740280000
13775	3NKK7ETsTdLqsb6qB26BcSCqt5hf5LyiXTaCSyK2zyMuvVHNj5rx	13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	1522	1322	205	6301	9972	jxFmVsFBTVbmj8sqHrn5E1WuB31tFk2cQEUL19tFpbsCDV95wiy	7017	10009	10009	1617740820000
13778	3NKsMhCgbu36DEE7jTMhTwXfEE9ZvyEUD4s1hrvce5mRhKy8cqUz	13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	1522	1322	209	6301	9975	jwn3VGrVwjCsbYJMFLKtXPKc1zMc7PVav8vMgBvND78BZgLn91a	7078	10009	10009	1617740820000
13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	13778	3NKsMhCgbu36DEE7jTMhTwXfEE9ZvyEUD4s1hrvce5mRhKy8cqUz	700	840	209	6301	9979	jwcDkjLwxNdFh429BqvSWsBfUHNTZYnDs9XLr65wpuGe853Uq5c	7079	10010	10010	1617741000000
13788	3NLcrrwKTRa2C7NrCQ66Ri6YKyEnHYAxnsj1rCC8dxMhn6meP8Yc	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1622	1110	209	6301	9985	jwAQ19Vgf9F43dNvneJT1p7UvresWxZbKo1zAp1PZdv6r9AG84n	7082	10015	10015	1617741900000
13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1633	1390	209	6301	9986	jxyHmYPZ6sgpJsbwQxcwN9L6EAnqfFKZNLt7aeeXLoPTRFCNw6N	7082	10015	10015	1617741900000
13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	44	1079	206	6301	9883	jxdqCDdkCr1hzc8UKnMLPrP2LDgmFmcFrhL4cDVWQZwd87D9Mg5	7026	9936	9936	1617727680000
13678	3NL6cYV8r3Z48vqx3FVQxeBJUAEAXq4XCAETjbmQpfv4JCrUnkgC	13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	1426	1118	206	6301	9888	jxZ5RBmE9wbCknbnVEDertGjDkaonRBaiquUTMmVe6BJrxkgi19	7029	9939	9939	1617728220000
13680	3NLvy7ZBEDYudWKHYKKr4wHAiWg5GuBpCEcHGiM7HULVjzHDLg3Y	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	1407	1395	206	6301	9890	jwzB9cRUqQ92cBCKnfUpbWXYWJAkq6MLnmc5q33RjrLufsxnZ11	7030	9940	9940	1617728400000
13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	13680	3NLvy7ZBEDYudWKHYKKr4wHAiWg5GuBpCEcHGiM7HULVjzHDLg3Y	1406	1393	206	6301	9893	jwgchbNL8C3WxLMY7mnvM3yMtxnfTioeurSDoiJe3DP8p41UeQM	7031	9943	9943	1617728940000
13692	3NKkqT46vCSZogUeV58qLSwbvbXybCwv88t77TASHpSkPvBr7Toa	13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	1457	1391	206	6301	9900	jwiL8RjafNN7HXS3dZ12wDLmMzrwXRwBAkgtSCiBunLzSqTEMkN	7035	9948	9948	1617729840000
13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	1403	824	206	6301	9903	jxeFKUG46U36gUjjjNSUw8aLJkp8G5EZTj51ShzKXiUiTCF7Jf6	7036	9951	9951	1617730380000
13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	1651	935	206	6301	9908	jwQ8ZjoSoJa9KFtAxkyyTVMNVEAgi8FXjHx38ySnYxJmQqXdsKa	7040	9955	9955	1617731100000
13705	3NKt4su5DQeABTJcCBAnGUkGKLvAvK7LfHtTTAzkLBdPGtBt1vqf	13702	3NKziwSkEbVWSHVj9QEYQqXsfFGsU6xiQBq7Ng61ijwc1W14LRHb	1471	1140	207	6301	9911	jwrA4gETn6A7wLVzqfnhMztsw5hDULmD2XCaNQCYgjwLxRGvXd1	7042	9958	9958	1617731640000
13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	13707	3NLQ2gVZPpvytFuQxo8J27J6nbCUpVZvurpgbPmgi45fGSBG4a9f	1406	1393	207	6301	9914	jxSj2bSpMciUtnh7fR3jxLXFfHfNyykfKAwfz6frmp2kwb3emMv	7045	9962	9962	1617732360000
13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1405	867	207	6301	9918	jwVDtsz5kLg38nBps3na7Jx5XSPnS7PLAYqt7PLAVhEdnfY7eny	7046	9963	9963	1617732540000
13713	3NK7Ny3TEvsvAMBCMhinyHwCr6bdiBv8crbsU4EzwM2emzudmuAF	13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	1649	1383	207	6301	9919	jxhmWseDwoCxFGHXuaNMwjAh8gEocsHfiRuhVo2SHkjDVN1cuej	7047	9965	9965	1617732900000
13716	3NLLQoo8zZx7gi2knnHTmsquzcxwMu8DMgB5CwMT5SYC2Bx3kHXg	13715	3NKaoiPTLzRaQVmbdFxkT5fGNABxKe6h9ETuFtMT4FPMsYUrDSCX	484	1073	207	6301	9922	jxsnxsfmGAkpFvZmCaU1FyWqyXKjTYzGZLBVRuTcZ8FwZ5doopV	7049	9969	9969	1617733620000
13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	1670	916	207	6301	9930	jxP8HfWVG433TEowdmmRHBnsczM9TSnWUeRbWNt4Ch1fScswC9R	7054	9975	9975	1617734700000
13726	3NKUDUeaE3UDieJcmBGhsg1a7jzrTSUNx4KEudWrxv9KmdStiB4S	13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	1445	1290	207	6301	9932	jwFRkM5zRr8SiCcCpyDAwnpKujES3yyzqBgxavYzNgP2QL1CnKP	7055	9976	9976	1617734880000
13729	3NLRCuA31YwFufcpysE8pjFA3Xkz4E43UDWrC5uoDERs3Jxxdc5c	13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	1553	776	207	6301	9934	jxgLSuxZmz6bHJTfjGUdysF15MV2y7dyVfPsarnVWaxKsVy3Whs	7056	9977	9977	1617735060000
13732	3NKxv3WmScAQzfuMWWeKbhZ1HD4LCzryaWWRhmUCaKu2qf9sf8ab	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1406	1393	207	6301	9937	jwxLZ1TQJrWAZi1mL8mQVSP3XTPse2qw4H64sz3C6tKBefVBKuX	7059	9980	9980	1617735600000
13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	1403	782	207	6301	9941	jwYXusME3DqVcoSeti1EWhhB3xvyjFc64ABHRAnw9d642wSjnH5	7060	9981	9981	1617735780000
13744	3NKKww7VaneCRV1pW32QRqMwRryA8NxabN4LC1RAvzh6KGnCVACZ	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	208	6301	9944	jwuqPi1tJ99m7sgSkokbbg52udetW1Z9iYP38tk6LbV7gY3pTtH	7062	9987	9987	1617736860000
13745	3NLJFa5VZJRZsHBeYzFo4mftF64etPiWGU5jvqrYTkZHagdnNbvm	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	208	6301	9944	jxARw2t4evEVxswGYXAEXdxQuepc8ymJV42RwTCyhcJNFSdH2Rn	7062	9987	9987	1617736860000
13751	3NL2kuDQWf64BugcV4rqDYpvsyiVjbn8d6B9d7HnGSRMqWmAUE4U	13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	1596	1117	208	6301	9951	jwWq4C4Zj7kRA8zqQvRjxeGJ42tKCf5fdoEGbq4drSrjhZFK3SQ	7065	9992	9992	1617737760000
13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	13751	3NL2kuDQWf64BugcV4rqDYpvsyiVjbn8d6B9d7HnGSRMqWmAUE4U	1581	778	208	6301	9952	jxWouUUfzQfT173Cy6UDk1t3ybVmcDSJg9XjQ2cQMVrRi2Armkv	7066	9993	9993	1617737940000
13756	3NKHaR6pR7sA5kfWaturJBPrDknKb5veF2VPdK8gDiuptJKbQMus	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1587	991	208	6301	9956	jx9ZnREUUGjpZL3V1hKRoKySiTX6C7Gqge4ce49J7EjsVEKtgDJ	7069	9997	9997	1617738660000
13758	3NLsrX467frx3tXpY3jGJsT6SjDkbc31EhMdNtGTTKdgXUkfNhfW	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1403	782	208	6301	9958	jwtiKNzaUCgEx4J9AgVd3Lxe7MxryKEzTGiSFAfat4dZMSnuK3k	7069	9997	9997	1617738660000
13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	114	114	208	6301	9960	jwdTxVACHYZ2NAhwJcm9wWYyyci6NdwpvvX2Avz2GFcvnskE8YM	7070	9998	9998	1617738840000
13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	1405	867	208	6301	9962	jwdWNkPSNTrmJf2faVTKBaArPNLFX6s9USzP98QGQfymKZsboAr	7071	9999	9999	1617739020000
13777	3NKUJKjLxkV4uFjCJ1pETm56Kwa1KztwLEmvVGP5MwsVmi6k2kZM	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	1522	1322	206	6301	9974	jwaNLnxkuk3CB13yTT8apaficAhtZvAzbXLwv1jiQjGEZnpbpTx	7027	10009	10009	1617740862439
13781	3NKHx984A8MMwzocXxvLyabhnTYh9unWCqRBTJ1Amd3BREkhYjmw	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	700	840	206	6301	9978	jwqJ1UQqiTLCYgKKukjwQWZTwF2kSvdttSmAH1LC2eCj9XWPPKy	7030	10010	10010	1617741000000
13784	3NKRwZRY4Ln4hnkwrXm4FgUWwB2Nvxy5YBxLDn8KBHbRsu1BvLsL	13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	1402	874	209	6301	9981	jwQC5yiZav4kvoTcNqE5prpu3zMGFv6pY9jRxh1yLkukhaTTmtT	7080	10012	10012	1617741360000
13787	3NLkaXbvVMPVgs1V8JpSEXqfhPpowAaQp5mrDXj5xb7BJqs29rZm	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1646	1108	209	6301	9984	jxwZD5zJzbvWbLNMBt6oHiYD7ULV79Ns44f1xzbxNqHAnciAUQ7	7082	10015	10015	1617741900000
13791	3NL2hbVS3jbkAzwAXdG1aBoH1CvyjpXBNJB93ZubnkuyCRyYzBJL	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1534	1317	209	6301	9987	jwZuLCXUXhGTAggAJ3d7KmEJ9pE4Zhun52Qvfts7GyqTGPMBdaN	7083	10016	10016	1617742080000
13793	3NKHeKX2oLqkLekx4GhDwuke9MNobExocRck5qrYguy77mUDx8NT	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1583	286	209	6301	9989	jw9nNdwkDQ2brqK2PMapvqcwvgx821u23H7pYtDpahCGHiyGMuJ	7084	10017	10017	1617742260000
13798	3NLTaSoCFiman6fod6PEFPtedjunFCZ7RG9fq8DVA8yyHjx9Xbj4	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	684	1106	209	6301	9991	jxvzVCc71Nxk2S3EttWcGsSexCW3oAQcrRsipFpQXKW3wRc2AGb	7085	10018	10018	1617742440000
13704	3NLr7r4q47utdzrZ8KjRLKFXC6fxTF1WzWsGpTccsHLuJy8LrVas	13515	3NK8Sqk3SyxzpK68pLCppT6EYYsLwRxjhVvBSVPUC5XjUHHAXFrr	1471	1140	199	6301	9910	jwgiBQz6wgxMnDyK67eoDSHor1zThqUyAbgFtohjbprfZGmAPHV	6907	9958	9958	1617731640000
13707	3NLQ2gVZPpvytFuQxo8J27J6nbCUpVZvurpgbPmgi45fGSBG4a9f	13706	3NKp5GWMTz6mPp9QCrp2yPL2LArEzoVeDAmxGAQRdG6wJx3BKvQz	1647	845	207	6301	9913	jwbJg811ro3AP3w2GV7sDww1FCJcFeG5sVZvyxBjbqKXgWHBRXy	7044	9961	9961	1617732180000
13710	3NL9p9Q73dyUJMxg8zr9Udd39ysKCqofGHBFx9HQKmgtCGYxswfm	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	44	1079	207	6301	9916	jxGupFmozvxz3vznMrTEPEnUS1f8yhXFevMtnBa2STVgL1fv2vs	7046	9963	9963	1617732540000
13720	3NLbf8jpoVCxxesNhoNjRZFJNRmvK8EV1xsRnStgkvaJW9tu62JW	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1561	3	207	6301	9926	jwWx4AtLEG4sSypSdYnDYPivK6CAFHwiPdKruYsHm5Vn4PcXKkw	7051	9972	9972	1617734160000
13734	3NKTKrgZnfxJ1bCzrXWEZBR4fkpZJXpHSHoBdKkug64aoKJnYDE4	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1506	1127	207	6301	9939	jxc9yAmht3Sr2MhSGt13iTxvehKwgVcAcH1rwk6M5hRLT2mF1yG	7059	9980	9980	1617735600000
13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	207	6301	9942	jxmYB51PLjCQBAgTTJFzvG5LWbKTi4MXaXaXXVT5BxU8NcNk2aR	7061	9982	9982	1617735960000
13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1670	1156	208	6301	9943	jwBBnwkCmQbA7BAhWeMxdUynuMY2frGnYpS6NtMWcJJqGk8TC65	7062	9987	9987	1617736860000
13747	3NLxHT5vYVKrH46qyAPxccCfoN9MWxvktEwpEWhKTUH7H1DtdMex	13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	1637	816	208	6301	9947	jwjrRPCRjfv2GqymDEwt87cSAspAT8iLpqeY3Cn79wGHnLGUQh1	7063	9988	9988	1617737040000
13748	3NK5MuZvQBvs3LJ4UCKqh1qVR3sxZLnhtNdAf8qLjKiGY9tdPp15	13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	1460	664	208	6301	9948	jx5kVzg3efjCPGrBmByEhu57536ztEaanWdB4NJcECuSPfVi8mi	7064	9990	9990	1617737400000
13754	3NLZLk4q96sgPwvXYiBBaMVYjs4i9AxrxS71H1CMk47SLC3sx6J5	13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	1581	778	208	6301	9954	jwG41PSAiXQyP1bRNTSjNq8Ah2pcG1Ppe7jEvVhqMUUy5bJUs54	7067	9994	9994	1617738120000
13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	13753	3NLPsM4spYfT68mUQPqHptKbKsX3dSqKYYT951hepQ2MMQyLP12X	1648	918	208	6301	9955	jxDPVxRcGyXCCzUXVjG7gPaoZ4dE3Eaob7rcRTGUX8gVDwARcXk	7068	9995	9995	1617738300000
13760	3NKKZg8R9dKhTFetnxPYa3xdawaGAAmUs8SM9Rw2gNTNBJj96i8F	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1560	279	208	6301	9959	jxJvVfZMApYcdrxPk2eZYAMtH2XiSJ5iUeJczBT7wLy2sXNJnp9	7069	9997	9997	1617738660000
13763	3NLxY5Ah8ZEzY7Rn7vkBgsdLKZfQcmZxNvGD7Jigadhp7N5Pm5jr	13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	1546	1339	208	6301	9961	jxSYTawdQcKZrcMErNUno6hcSGEazMTR536MZoxo3rnWTQwndJz	7071	9999	9999	1617739020000
13765	3NL4pixUFZ4W9xEGHDT3Wpt6ZTMobqfAvg4qc2NfgyhP59g9oPHR	13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	1467	1130	208	6301	9963	jwXyEnY4kPUE6WzRhRV1dh7oRcLe55nHL5ThFgndTS1uNzgM88M	7072	10000	10000	1617739200000
13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	1406	1393	208	6301	9966	jw7Pfz8Y8FYCjp4kysxuCpz7ba6dGgZhsENok8eRT6dBAbAZvUN	7074	10003	10003	1617739740000
13770	3NLm7Y9Dp8YoAMueJ3Y56CRuikU1SrQyLm4cGGTr1ZMrG6Q6DPYF	13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	1649	1017	208	6301	9968	jxG3VhMtDfFiUaBzanDeLW3ZRY1VzJ4ZVUyCQG2CRXCjgpR3tVS	7075	10004	10004	1617739920000
13773	3NKH35mGUrvcbLNnZjw7ToFeBZinsDiPX72nB7Gxe9waJHaVLbHr	13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	1406	1393	208	6301	9970	jxjR6qcrXzmULBjQ541VoxznSUybJC8uSNsf12ah2cqnHRBz3NY	7076	10005	10005	1617740100000
13779	3NKFBNe33Ua8GhaoGHN5DbNRzRSuv6T3AoNkBN2xSjdWjTDfZLwt	13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	1522	1322	206	6301	9976	jwENw12uqfQfCdh4DenXzSpsTJufbSxBjjvYLFxZdBmGEPWANdW	7036	10009	10009	1617740901788
13780	3NKck4Cdcri8RZbtR3hesSzs39P4TGeQ553LETrtKMEaErEW64WN	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1522	1322	207	6301	9977	jxgMMQUEf8pPEiwbpYcEsQZRS11YAJ2xhVy41cqVAm8bGRHUK2x	7046	10009	10009	1617740940784
13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	13784	3NKRwZRY4Ln4hnkwrXm4FgUWwB2Nvxy5YBxLDn8KBHbRsu1BvLsL	1670	1282	209	6301	9982	jxcDK7FuLhw1AcH3ENzKDw2MVtH1FtVZsWooV7vF2kihcGmuYgM	7081	10013	10013	1617741540000
13794	3NKJN5nYtKbJSLDicVJ9PDRGsDceKTDmn7unF4mKaM1X1RsLwwRx	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1559	1353	209	6301	9990	jwcm1JxNaDZsSvzaSKZcqQjHMgKwMTqRqzoy6GtQeEhsWeuauAp	7084	10017	10017	1617742260000
13796	3NKx29ynZuMmEFPUDaXPeZCXQZGfzp1GZkmYpaJ84sFViLGkoXKA	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	684	1106	209	6301	9991	jwrQ7PXqJ1AQPJkPxHv8ZvStaZMiziv9bpjM9hQvBvGKiN2pgzE	7085	10018	10018	1617742440000
13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	13799	3NKqYDt3aMDkjXKiVhKoiEyCgywEy1jPLX2fgvAQvFUaSuyYovqy	1407	1395	209	6301	9995	jwFDMbSGTe3ctLSmEup3rQzMHSamZqct94MuRjT1Qu5PWztzNu8	7087	10021	10021	1617742980000
13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	1668	1004	209	6301	9997	jwaySP4pLubyxtUEF84ScSiqrYgpYycPstZH4X5rLfMEQGQ7ZUo	7088	10022	10022	1617743160000
13806	3NLuvZjtSLtoezVrNAMN6pQGYTrf8f7MwQ4EnSyht96csYr9bxhH	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1649	1383	209	6301	9999	jwB6mrYqFg9wmzo59yXBh8APPD1BBcPCuEjNwfHankJefdj33gC	7090	10025	10025	1617743700000
13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	149	1283	209	6301	10002	jwTFvMQAyNMr85JbYZ48HsJomL8f8BaErDokufUbgbp9cbWyo4x	7091	10026	10026	1617743880000
13813	3NLb8yNgADmdGLWUhdHnHmHyVH3F9Pj4xNri7c1qFogRAcLT56TR	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1490	1028	209	6301	10005	jwC7kBFQmZYZ9Lk4HKRqDg8dmgnoFdFRVNEVMJW8L7QqwZsJ7tp	7092	10028	10028	1617744240000
13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	1590	934	209	6301	10006	jxwP78vrfrCfYEGe6gCwWdAzhETN68hnA5VEGqsFdK4hqFVKeCs	7093	10029	10029	1617744420000
13821	3NLH6knF3NoAQqnvGnD4Yka337cZFDEA9MrTdz4T9pndcFMsmyFG	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1549	1362	210	6301	10012	jwyPHd3VSTGd13e39DA549vvz37v5TRs4nAstFxi2pKWTcFrEez	7096	10035	10035	1617745500000
13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	13822	3NKTz821KDRsZm3Pkw67fTBWNdr9d82qAQkhJjMnwzoTFg7YDZuX	1419	814	210	6301	10014	jwhWKnct67jia3HRa4b8NsHLJn5uBemPNmLkAQgHdadsVfgYHRm	7097	10037	10037	1617745860000
13834	3NKLYc9zbM7NFscYMiafrGZKa45WWGHE8C4vphzaGvRfkSenaqpu	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1397	699	210	6301	10024	jxYpxb6Mc9m6vZG9jmc2hfCkcsRTXECTZn6b6L4LzQnMF8kPuf8	7103	10052	10052	1617748560000
13841	3NLtidEugpULcMTf1x46t5wtiugyPZRJ1GguAxhcezd6chatHQYV	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000
13776	3NKzNJ9oyivBMMUFeH5NbPUfktfJnzXpaR8rYcVeatjV9h3wMoij	13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	1406	1393	209	6301	9973	jxKrWZ8a5WvewVjyKRzqdMZPZYcF1jSWEmFMpYv6zy6smR7UfBn	7078	10009	10009	1617740820000
13783	3NL4yA3XVxxpRCSyW1JPnDhAaFYYyt1uvhZLvSww2RGUNb5PxNkR	13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	684	1226	209	6301	9980	jxT6yoJgvHAH5uuaoMnyg99sHebcYTwbfHCsZE21XNRPFLfsBHs	7080	10012	10012	1617741360000
13786	3NLGnjSrQYgcEXrTHaQiqUyJGNcH6Y1SPH5CyJKNk2Lf8yMWguWn	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1483	1030	209	6301	9983	jxNRAugU1EnqM1ySZXvRgY9qHa2LLqSDukmPxyUAGcV9xvNQtCV	7082	10015	10015	1617741900000
13790	3NKuhxAKqWa9j5gyTCN7yvdk8J8jRNBVQRs22k4FigHBiH7jLHA4	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1534	1317	209	6301	9987	jwMR8RMeg8DfyDemvgR7aqV3xA7PK5uz11Xb9DqPq63aF347JCF	7083	10016	10016	1617742080000
13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1559	1353	209	6301	9990	jxtQ9cy8m9GmAPJV3LszvWPRKkeA6qUuf6MTS6uyZSp6mooCJBS	7084	10017	10017	1617742260000
13797	3NKpvB5j7qTUWaNRSfr6hySPkHXfXmg595viwf2kgveMdt84xZhy	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	1402	808	209	6301	9992	jwwDrLZRSWrU8KDQvUCAsSgjr3oYanNDM8PPLgLGvDrfks423Nk	7085	10018	10018	1617742440000
13799	3NKqYDt3aMDkjXKiVhKoiEyCgywEy1jPLX2fgvAQvFUaSuyYovqy	13796	3NKx29ynZuMmEFPUDaXPeZCXQZGfzp1GZkmYpaJ84sFViLGkoXKA	1406	1393	209	6301	9993	jxYu4fhbh8qbWHbyJz4eqrkRTE9i75KTswAQZM5P5RceSr3iECb	7086	10019	10019	1617742620000
13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	470	1309	209	6301	9998	jw9JVL9Lm6r9RV7YTpCUJb2YPe4ksUJ8WKUhGcaep2KK9DrpzjY	7089	10023	10023	1617743340000
13807	3NLnTVLGJsUPVr1Rmh7gEpzb6i8cSXjJNfNCEw6usjadQjJ2RiVA	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1649	1383	209	6301	9999	jxLQsxj4YiAMboNWRpLfkzUCXRrfvACorrbjVmRGiNtqmkmCPWG	7090	10025	10025	1617743700000
13811	3NLqJP36HvtN3sRfM4x816jf1nDtb6bLBZ1hWtQYpXbBU1itPV4M	13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	1633	1390	209	6301	10003	jxyHgtPB1Fdgh1QWnxTyUkfpvp4uN673X8kTNQU6iwRfxNSiNSe	7091	10026	10026	1617743880000
13816	3NKyAyNDnUkdwGChNiCm8FHzRrDEVB35dRyxYamKQQzJsVEwXGBn	13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	1403	824	209	6301	10007	jwie7KnkxtxQLpPufp4Qik2ATSK5vzkMozw88By3nW8G4RZZVB3	7093	10032	10032	1617744960000
13824	3NKBdHYRz6Kmp3KAhWLF2dxKNACyQiBcRWMMjnGhLXuhmcSq3D2W	13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	1406	1393	210	6301	10015	jwFiq6Eybe52tG35R63PatnGmzi2ucFXF2hRwJu9ZgW9uwjTVTa	7098	10040	10040	1617746400000
13826	3NLLewAfgDEKeyswB5tLuPdZh6RowMHPo9n7HWKbwstyZCMAjKXC	13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	563	993	210	6301	10017	jxncfs7xWb8aE7BuVK3gqaLFosJRwE5fBBV4cKyoKn47mYRoK32	7098	10040	10040	1617746400000
13827	3NK52oXcjBFLcXHMyLMZMcJaczjUc8ak3hx4QzWRB4XnyB8EegeB	13826	3NLLewAfgDEKeyswB5tLuPdZh6RowMHPo9n7HWKbwstyZCMAjKXC	1553	776	210	6301	10018	jwwaGc8tGvc2CW9bSkz8dHwuApQSziegycDVZJLPJW7Z18U4yer	7099	10044	10044	1617747120000
13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	470	1063	210	6301	10022	jwFeyjBdrxqzMqZ2WxfX1fipvkGH7Q6yJzbVCpaXPhWZMLBn9fp	7102	10051	10051	1617748380000
13836	3NKCFAoTMuxpvhdaCUsv5rnEf5oyjhzKFZwW4hFTbM6Loo56KEyF	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1474	1329	210	6301	10026	jxm6Hh3iWubvQUPWXBm1oj3UsRVRbMwZSDWZxd3jTH3tayymr6C	7103	10052	10052	1617748560000
13846	3NKLYZvJqttJoToH4HVK8jv1Krjomr8YAfEVjJFh2Yx1xi8kqB9r	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1581	778	211	6301	10033	jxnEUMkygwNok5q9jwtQGKtnoUD3VHYJwK4u3tuHztBriZjuDmc	7106	10060	10060	1617750000000
13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1440	1011	209	6301	9988	jxDsq519CfWbMtqN7c9ybfckZfUD3qigPcqvzDDR3oKcjfsdkGW	7083	10016	10016	1617742080000
13800	3NK8mVyLaGXKbgUVLGE8uXyMS2LwBHu7XKeynXfFfUrDjrSg392m	13786	3NLGnjSrQYgcEXrTHaQiqUyJGNcH6Y1SPH5CyJKNk2Lf8yMWguWn	1405	851	209	6301	9994	jxqUaBnooJ7XAZZR3yeBd5UniipmZdcgjJhaurCgxErwrVZKUBs	7083	10019	10019	1617742620000
13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1402	810	209	6301	10004	jxuXxbkLxG1SCmn2GERftxhffc9nH1tBnGPqj4NWsuyK4YjRxzY	7092	10028	10028	1617744240000
13814	3NL2TEicM9DunXPDBqDBxnU5JCDnxk3zP5pPy2wQ6vRPv8h8SApT	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1490	1028	209	6301	10005	jxCHBWz38599M9rTG4QoY9ZHLxenu7RGQnCjKTEBC21VUWjFidZ	7092	10028	10028	1617744240000
13818	3NKygvNTvFoxScgEkKBfQ13TTHeWsTNJWekPYgwQEbPUCLH7YiNS	13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	1440	1251	210	6301	10009	jwKtvzcmqq4zN2n7xc1cYMvZkzLP3ijxza2awwMRUsvG95GtJGJ	7094	10033	10033	1617745140000
13820	3NL49QwRB8d7pRh4xU9JfEcYFQBA4MCZSYVmuqziQ15bWGrqqJgx	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1402	796	210	6301	10011	jxPsrJc8yWCik9yhCicmMLB9n1kn5cNae9sJygAYbCZeuaLDK2B	7096	10035	10035	1617745500000
13822	3NKTz821KDRsZm3Pkw67fTBWNdr9d82qAQkhJjMnwzoTFg7YDZuX	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1631	794	210	6301	10013	jxRRgg79JFguJ2gk8RyKWVrtiLVabymfeM1Rmuima3tXKKRpH4x	7096	10035	10035	1617745500000
13825	3NK8wimMm8E8b4UcaZPegZmfjLPZTc6sNJB5vxH4CP79qap1V9Qt	13773	3NKH35mGUrvcbLNnZjw7ToFeBZinsDiPX72nB7Gxe9waJHaVLbHr	563	993	208	6301	10016	jw6x5kq2nAL2yBHC8wQz9FtkRuFkK3DMvPACVJoa8jwbZQqJxB1	7077	10040	10040	1617746400000
13829	3NLnp5pKnGsoqL5VUF7Foz45QpY5s6Jrt7txAVZeRkNUpFyvcun9	13694	3NK75QdjQtbK2JZ6TDCgu7H5NKjHETjJ2nRQc6a9xFZ1LEApL6A9	1564	1092	202	6301	10020	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6953	10047	10047	1617747660000
13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	1651	935	210	6301	10021	jxEN4FCkw9h6SfJe8nYvLtEodSf8cZBqzAZd96pQyWgE2hvyfpT	7101	10050	10050	1617748200000
13833	3NKu9pRAhjGedbjDETxJThkyytLjJPWWD2Mipq5K2iNX8JheiMx6	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1589	1286	210	6301	10023	jxyhuuytXWsXojxMJ7Mg11NnMENG1J2sDMEJ7bx4KHiAANozRpW	7103	10052	10052	1617748560000
13835	3NLVMf7YK8iryFBuFdzexNYTw15SWgrpn1JjSL4fjTh5qyVWJouF	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	563	1113	210	6301	10025	jwvq897N2jgDAy6HfkSphVMK9nc4tC6YUZNmPLKDCr7rhHLXcNe	7103	10052	10052	1617748560000
13838	3NKiZ3pghUUHRsT2p7zXkKaWewgaGk2XBUpKtMJqmZ27CwvAEFBe	13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	1474	1329	210	6301	10028	jxcBzbr9YhitHnUKHVyYHvvehTJPYfEk4TP2TqLz365i3gpiawc	7102	10052	10052	1617748560000
13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000
13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1403	31	211	6301	10032	jxeye3jAnMBt1Tk9aZneZz2cjGcCXcjwBFWHqQc49GA6MRLqG2w	7106	10060	10060	1617750000000
13802	3NLMrSFf5dgroM69to6jcQCkUrzv83DADGgLP7yDsfna6heBpdkf	13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	1407	1395	209	6301	9996	jwAZVvTVZzzGFKd5wgdyxLXJJzMCCS7MieZdcbDnY2T5vpcaxtQ	7088	10022	10022	1617743160000
13805	3NL1EKe48gequYecqs7uP1WzrvLhr9ZwVdTZ3wZ92feeeT5k5BJR	13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	470	1309	209	6301	9998	jww9LDMuL96ZjZqUshNu8hUEQwv8qDSzveb1qLbBQgFVTcJsPPB	7089	10023	10023	1617743340000
13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1673	1002	209	6301	10000	jxWxRYAz8nH5veRs5SjsA85Qgu3zWNY1xsaC3NnLEo77n1kVbiy	7090	10025	10025	1617743700000
13809	3NKwQRQVtu1qbAGKJ1TDnATE2HX5hUf7WJZA1PYYYziVyPoJCZBr	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1439	1033	209	6301	10001	jwqQsw3KWabCVhtMxKYUYCTFKAtEP7dj4utYSyh2SgGNdaJFnYL	7090	10025	10025	1617743700000
13817	3NKHLoGjRVP14CNL1Agrgpy4RoHNshGxJebeXMAvjTNheas2EweE	13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	1673	1368	210	6301	10008	jy1aH5cQXVyFYZqmVshTNpbK2pAp9KweQY1rohzXigev6Ewr1Wb	7094	10033	10033	1617745140000
13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	13817	3NKHLoGjRVP14CNL1Agrgpy4RoHNshGxJebeXMAvjTNheas2EweE	1406	1393	210	6301	10010	jxsBkzU4qSDGguxoD8XynTu2cPpXUsddZAxB8mob3Tre9QsvAw9	7095	10034	10034	1617745320000
13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	13827	3NK52oXcjBFLcXHMyLMZMcJaczjUc8ak3hx4QzWRB4XnyB8EegeB	1406	1393	210	6301	10019	jxdew61YGX6LpsHqWLAaw4ppPPkT6GbMuZzDMbcntsKVR4CNATP	7100	10045	10045	1617747300000
13830	3NKAvW3oUFj6S3usWKzbkV6zS1bLeYJkHW2wsuWxqZxgdQC1ad2Q	13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	1651	935	210	6301	10021	jw9vEmtAZCo3rwnfr8D7UMXzYQE3exncYAoybNWUy7jDfmZmWc4	7101	10050	10050	1617748200000
13837	3NKa5i2fYijJgdjPNXbGnMenYi27kDqHevR7v6jiGvGZ6Z6X6vay	13825	3NK8wimMm8E8b4UcaZPegZmfjLPZTc6sNJB5vxH4CP79qap1V9Qt	563	1113	209	6301	10027	jxSh66XzVH5ddZGoN3LfrbWSHPC6nQuURZWSfXXYGSz3jqEJHXk	7078	10052	10052	1617748560000
13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	13836	3NKCFAoTMuxpvhdaCUsv5rnEf5oyjhzKFZwW4hFTbM6Loo56KEyF	1581	777	210	6301	10029	jw8vj26QV4VCN6b7tkhc1poJcW14o59wCFstKnKpRvhKQpYE7cM	7104	10054	10054	1617748920000
13842	3NLE2s23rJFnEQrPw163tfyivBh4txguofMNrux6f6Av64HA7cNp	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000
13843	3NLuo8EShtnRaZHtsGCU1GFCgdJTiAfCiKyjF998TWGP6Ravfp7K	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1560	1291	211	6301	10031	jxzw8EL1MJGLd667zcxU9ApSCs5qadtvp5iWwaBWc4GNLw364kv	7106	10060	10060	1617750000000
13845	3NL1QbPdXSdtPsxGRshKFSAfGYYBy9FyrC6TFY1mBHmddkptSJaH	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1560	1291	211	6301	10031	jwD2v3GnHdCMziBMX5RFxSGdL8Jsw2PedpPCULnHtEMWoh6HvMF	7106	10060	10060	1617750000000
13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1406	1393	211	6301	10034	jxGV1GfrUrbh2azRxnzByzFFNmzaY5pM3LhMRJDGZaeahuhFV7o	7107	10061	10061	1617750180000
13848	3NKhLQzL5PPckf53kKoW8uTo1N23K1YA5GMRrgDsuDZE1UFVfv1K	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1513	1253	211	6301	10035	jxzTiujy1vBjGdSSXK9YJFAsku6iRvH9rpkFC2C6tmN12hoePc8	7107	10061	10061	1617750180000
13849	3NL15N13U4crz925yCyz4m2uHznDiYcMeV3RfcC8nYufvdxSLeFJ	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1405	851	211	6301	10036	jx38kHH9Cd2d8AMwQdqTje18aifC7qAACpoeRpwtL299QWbJNbt	7107	10061	10061	1617750180000
13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1458	1077	211	6301	10037	jwhCXdF2pCecGoLqrUWhUmxF8NMZ6NEHEWJQDe8ZcmGPsxN6Uks	7108	10062	10062	1617750360000
13851	3NKeSAFRM9fFQcurSAe9tRKwCUHAhZQLQVNyWHUNPbuCm5TJyaF3	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1483	910	211	6301	10038	jx3wpkin5G6JhrA97AFyiQbabmkCQqZ2afyznDgXbWXxvckHsLA	7108	10062	10062	1617750360000
13852	3NLkVgRgJv2fDAcyHP21jPYfuBWXQjL9TZz2nosZC4zoBSyDkviq	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1458	1077	211	6301	10037	jwwyMDVjew92YvPGwD6jVwvLRtVGWzuPHtjNcYgpKn2YVJmy6ca	7108	10062	10062	1617750360000
13853	3NKdAsV31VSEjXdUnxbVQCVeJL4BwN2eeWqLqRxJGTzCUzmTv6F3	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1483	910	211	6301	10038	jxfruC3gwd1r9ztYDvZz3U94qKKzEydZKbYdFfbXQA726sL55eT	7108	10062	10062	1617750360000
13854	3NKrpLY5jRyR5TCrDyFGHruUYwSnuGK4bQeCeseY7yiJ3avbs2YB	13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	1610	1068	211	6301	10039	jxAXUrezhGkNcBW2vxaEhgabweRQfEMEJ2LSL6DRn2Paf4zqL8G	7109	10063	10063	1617750540000
13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	1631	794	211	6301	10040	jwbejb7Jt3GMjZbK3cfXoQJecYqusjV9t1h5CC7vapQTu54dNcf	7109	10063	10063	1617750540000
13856	3NKcagfsAE5RrFZuvFuFhZiULe7M2Csy2utT2amCVKP1kyKdE7Qa	13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	1407	1395	211	6301	10041	jw82E8cKBkidwVfdkqvLncLMzBiYD7CY1G4YqfbQf1qc6n69aSQ	7110	10065	10065	1617750900000
13857	3NKhk5Z9JXgbXE4DN5ib55KmqXvA2PbtFhTQFt1UdhPcdyWk12Kr	13856	3NKcagfsAE5RrFZuvFuFhZiULe7M2Csy2utT2amCVKP1kyKdE7Qa	1588	1146	211	6301	10042	jwvZ46Somw13thvZp9vLrM4CueUSQKPdBp7bmsdPP5pwupjFjdX	7111	10066	10066	1617751080000
13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	13857	3NKhk5Z9JXgbXE4DN5ib55KmqXvA2PbtFhTQFt1UdhPcdyWk12Kr	1407	1395	211	6301	10043	jwYSVRoYm1tGYdyiLpmabCNsbMiw5mFyutUy3HAcuLmAyEnSJp9	7112	10067	10067	1617751260000
13859	3NLZxX9cexZ6ZU5dMmtuc6eyeKL7nPjm4Qwj3mQdvduSeY91vgc9	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1402	874	211	6301	10044	jwvdXRg6EBwadG6bGS3hjp94ViNUkTvMuhKxTo77faKRCcfnSyG	7113	10068	10068	1617751440000
13860	3NLgUwjSt1zLV8nFLWWZ1yC66PKNUih6xrWZES4hFeTS2HcxzwMa	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1581	778	211	6301	10045	jxQbynxSoSzWPVWD98t3QxRqs8XacMj1nzhS2fkHDngKVJgxcuu	7113	10068	10068	1617751440000
13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1403	824	211	6301	10046	jxuY65AJSinwU6bijT28ZNRk5HadFpKe6b3RGf3fJTkBZeP43gw	7113	10068	10068	1617751440000
13862	3NKnUY2gxesx4aVCFXnHoHoojPeLKq6z83wv9eUCGKXP236Y7dQR	13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	369	1066	211	6301	10047	jwvjuMrA8tUYUNwEgftViKzm3jCDa43Mpn4575V8ZdEGCv7hR2s	7114	10069	10069	1617751620000
13863	3NLjsBwYTbfXKm2fRwKud6LhbNFMVFMMfV2NHgnfkHAjLPAHGXxd	13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	1403	786	211	6301	10048	jwZxTf2mpbKpdHSRs9z5zFMGiEZv5peUtP1TRBK5BCD8UQ8wQhH	7114	10069	10069	1617751620000
13864	3NK91UGpMapsu1kVaPANxGeZ54VFDumvMeNqZpf71mv7dDimrMCF	13863	3NLjsBwYTbfXKm2fRwKud6LhbNFMVFMMfV2NHgnfkHAjLPAHGXxd	1585	1366	211	6301	10049	jx7hy9GsqfQiRivPYXH7gAjeRPRmASJyMYc9hpbPEXdwnghqJwR	7115	10070	10070	1617751800000
13865	3NL5r7T8SUmreJ8zDRHZgtdVM9k9xeFP4UUeXFeg57HnQ2vw3PfG	13864	3NK91UGpMapsu1kVaPANxGeZ54VFDumvMeNqZpf71mv7dDimrMCF	1522	1076	211	6301	10050	jxYe2WSpWddBiVzhC95PFpgdzR331nnKYZq63ugLKuGisPQZ7gy	7116	10071	10071	1617751980000
13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	13865	3NL5r7T8SUmreJ8zDRHZgtdVM9k9xeFP4UUeXFeg57HnQ2vw3PfG	1407	1395	211	6301	10051	jxBDYi65k695ArQgFdsTNNyhjZ7JWWYwTByyvNMZrcBHzRyEpsA	7117	10073	10073	1617752340000
13867	3NLvFgVhCb3m7U96NidjCYetunn9XPutHmNcUNfaUuDy5LBr3KUm	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1407	1395	211	6301	10052	jwVob6xx5jb7SomJ5cvXKwafiqs4iu8YMmNECcSTgX8PtiZKgAp	7118	10075	10075	1617752700000
13868	3NLtW7Bo7hDg6mAAujjFaqbawayjDQqpARC3cNnGnrALcyxqFrD5	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1672	1285	211	6301	10053	jwcbH5mnH2nH2LA8omG4xK1fZSvmSa8JeVpJkU4CgbcSfpqQkwb	7118	10075	10075	1617752700000
13869	3NLWaQfYK9dSaRbALhWcM5QPoCxYYEftRcigjQb4o35HiEN4niSF	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1672	1285	211	6301	10053	jxgfMmPatgX4ZRkFd9fLtAGeCyHuegSr9GQE1sUCLiUDdnh5tdn	7118	10075	10075	1617752700000
13870	3NLpysRVy9symc7kpPmHjW1UNVKqiHh7VNuSagpuWmJgoWeqEgky	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	641	1336	211	6301	10054	jwJraRicHNranVQPbSvvDB9KguFjSbWeWWtM3uvxnku2322HWDV	7118	10075	10075	1617752700000
13871	3NLEVu95841FB3HnmLhWLF98FiCan6ChakJLf5qXppHirgjTBEgG	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	641	1336	211	6301	10054	jwGq3BNBgVxzTT5rDuMS4r7tnfUXS3cRv8GtNKEg9TZ82CEXvvy	7118	10075	10075	1617752700000
13872	3NLqMtQqfJzh2rGx5X9BEGtSQ9zgsBZUgCvxCSMPQW9bG62vmrPo	13869	3NLWaQfYK9dSaRbALhWcM5QPoCxYYEftRcigjQb4o35HiEN4niSF	1672	1285	211	6301	10055	jxg41GqhgFsaKupcn7rGSa3LgSXEB7CtnNP9f6DzcjNzesa18Sh	7119	10076	10076	1617752880000
13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	13872	3NLqMtQqfJzh2rGx5X9BEGtSQ9zgsBZUgCvxCSMPQW9bG62vmrPo	1631	794	211	6301	10056	jwyfydkRiLeNqPm7VxFUX5yFcZirNPMc6PswQGRPq9JaA88uoA8	7120	10078	10078	1617753240000
13874	3NLjDL7vVje9fXbqnJpuhEMsDECKJjUxBf2so2R46XdhSAhLRRQA	13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	1481	790	211	6301	10057	jw7nkJ3HiqSrhXaUMozGDQZdrrbBjNnYd2ocwaiJaxdqtLyhffp	7121	10081	10081	1617753780000
13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	1631	794	211	6301	10058	jy31P5SvNowVVjRoVVTpXDHs4axFRM2hYfnhRnT7HoCNKMab2Vp	7121	10081	10081	1617753780000
13876	3NKnysMq2h8aXtFuMYtjw3GACsCwdBkZsdYeNqf9oacPauP3wHK7	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	1406	1393	212	6301	10059	jwWdUUL1dhh7R2RAFou7qahqjgLYXuaxBqLUqKJ36D5cTAxZpXu	7122	10083	10083	1617754140000
13877	3NKEjUWZ7XicHrs5kaXgCfG8MKECULZVkyUdcmMi6HmHDq6epmVo	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	632	1136	200	6301	10060	jxoZJt1ULRcU93RBnxXeNSLK68fB9tnGuvJoxnN9yJBVwvRSdMk	6918	10083	10083	1617754140000
13878	3NL9SWn6DsMYPAz5D1AgbTxFkEv9eMpD8KuNTkHgs4SGh5MxAo1x	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	1656	1097	212	6301	10061	jwW6EJWC8TqthTjsx3S7LLY5gX4jFWqzutGw5B6uBGbrdo6SHET	7122	10083	10083	1617754140000
13880	3NLjjT4krFu7emEL6zAMsVkUwTUap4XqFHd71BxWU82V3GVVZDDz	13874	3NLjDL7vVje9fXbqnJpuhEMsDECKJjUxBf2so2R46XdhSAhLRRQA	1477	1350	212	6301	10063	jxW89Ss6f4C1rhAkeYAWHg7vZbCgqobRzL789YcnXsASofXdwAD	7122	10083	10083	1617754140000
13884	3NL5jVmqh18z2oEJtz7u43472HVkbedhjtxz4QDQ2yjwAH3TSBor	13883	3NKXqdL5VqJ7e6vPGudA6nUvoUBFLYNR7ULzrF5hmac13tYXK4GH	576	1229	212	6301	10067	jwf83YGdDCbeG7w3AdZCgVyWtBdBTcr27BHTMBvL3nacrHFhaXE	7124	10087	10087	1617754860000
13887	3NKsoEyw1jM3rVTvhjE5AQNQG5LjVLgNZMEsdsV9GddNy4M4u3T6	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	576	1109	212	6301	10070	jx1X9YPJytPECXWZ4yP7WCs9qB9tN8DWoZKMsJaX8JjbQgYG6ex	7126	10089	10089	1617755220000
13891	3NLrMaLbBH4jYESqQ9HLKFgYkNmpg5fjALX8nRTtinZ1tgtrQh5b	13886	3NLYtPH9YFXRzSHcnGAsjBmz95FerXpthqj9GHs59qEGVPuXSppf	1403	824	212	6301	10073	jxWDNswBawmfDGTvDvWMUiZtLM1JXhSRj1XXXkCNb53JfTrW4SA	7127	10090	10090	1617755400000
13894	3NKNGFtzCa4wkT1pf5KSz6UWsXMVDMc5quqmqWbNnBAwC6VQi9rx	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1455	966	212	6301	10076	jwmRBMXFEEuwFN4Qk8AKzUzZTqQZT4xspBu8cA2EQBEgtEeTTiE	7129	10093	10093	1617755940000
13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1403	824	212	6301	10079	jwAnLFoByAAjrrL1S6yy9bS6hYpgA7Ffxs3p9wnhLQrhhp3AF4z	7129	10093	10093	1617755940000
13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1460	666	212	6301	10081	jxpjRAGreZg75G8Jn56yhuK96XyBNnQ2wjXeqmLEc5fpCGiFc3D	7130	10098	10098	1617756840000
13905	3NK8yZxwDJEMjRiYk13DHkSJp9LS6C4GVYXm1sBQTXWBWKhQqEFn	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1631	794	212	6301	10085	jxRH1WfApzgbUjZD6svoGMMaM4GruiDELZ4cU6GFzZsJ4DQvdmE	7131	10099	10099	1617757020000
13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1444	1135	212	6301	10088	jwJVJPVkTdLrA7ysrDQbgbsC4rVcyExtBCgYBvTym8xU7sFqrHr	7133	10102	10102	1617757560000
13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	311	1307	212	6301	10089	jxxfj4i6c2sajRD4cyByAms6Mh3A2wwD3FXHjzRz7iZDJGRkRhM	7134	10103	10103	1617757740000
13915	3NLQc4BpZpa1y9P9JYqMn9AdkgRZ1pYhwB7qWXLnV7J6SBtHZTHH	13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	58	1155	212	6301	10093	jxrci6rnRwUPiw1h4RLVuu7yCyq7E1zMZ5aWk2pyCPKLaYnqUfh	7127	10104	10104	1617757920000
13921	3NLZ6FmUfQcdKgorqSg1uF2GcZjKUC4ePzY7Yg2QkUNAPi4kxB6V	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwb3GMokrmcyaNXuRGZjtdhei9DbfT766PBHtiiAWs7sQJyNYM1	7138	10107	10107	1617758460000
13925	3NL993dSFoe7WCFyFx5mu5ZWgXRDeZ1mN89zmefoHoKWLa1dAUV6	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1642	1121	213	6301	10100	jwFKmDXrqgfXoe9ss4ywM1iUVJrDPKT6Vyq2s18SYuY6M6R5bHW	7138	10107	10107	1617758460000
13927	3NKe3R18sZFKFAHoU3d4jVR59AYgZmssZdYkKJay9a5KyDBUojKF	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	632	1382	213	6301	10101	jxcYjtUzhMh1vzoXc5LCFgVyCurXjAXrQ5jnnYnhZx5D3SgPezr	7139	10108	10108	1617758640000
13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	13930	3NKxC9XAQypCv7KvDT7XQbeEfztkwNXcGkwuX3Z4p5NGpTB6FP53	149	1157	213	6301	10105	jxZrroidXKq1aH8mGznK2xbSzu5YVoU8fDezBRoDpiAz9LVXu33	7141	10112	10112	1617759360000
13938	3NL9gqoGHvfmiZZDEjBmWsunAhcuN5fhY5K9Nyo76VRwa9HATyWa	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1508	1387	213	6301	10107	jxXXocmEoRVU3iiY6R3eLFxYafbXh1cvKa4PrUrCG5yAznJACiz	7142	10113	10113	1617759540000
13941	3NLTVYL5bmX3KNvULi8vkVa2zpnc8xu9VidQL88QYTAsitnUnuui	13936	3NKVtC6e9HDRcC1H8AegeanTcMsyzv5eiHkgg69MmfQewha9EFbh	1672	1285	213	6301	10112	jwLedmFwKqkx8d2sVDgLyTGwrugCytDWW2re9HpqeD4qQuPsEh8	7143	10114	10114	1617759720000
13946	3NLZALhaXkvunU6q6PSHBH7AVbG8QGbezPLSBmf9kLy2teyQtFLf	13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	1407	1395	213	6301	10117	jwJLEgXi2cxcTgdVhC4erQpTNSykJtCNwhYTgFAtnHmD9t2q2yb	7146	10117	10117	1617760260000
13950	3NKi4GpwpPsRHTFZiYgVC2EbaLFiGn9Laxze9rz6Zap2GA4CbNVo	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	44	1325	213	6301	10120	jxda2utxJEr6KZ17fqRuKGF4H8R3NvC5wZqu9RfravawcAL7Vh8	7149	10120	10120	1617760800000
13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	13954	3NL2XdGzQFNMKoAwDMUyABUkMF7hqdnuc16CdUbezCP4Trx8MaVy	1631	794	213	6301	10124	jwFSxPd1HzhmbBV4iE57Fi6P1E3Vzm9AYcqoYggUCDmCCoHevnZ	7152	10124	10124	1617761520000
13964	3NLgdu99ZtcaY5j4HSy6B92ovMsjFA5GCXRmdni36npSTwHxzqmi	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	1654	1340	214	6301	10132	jxqYgpLCHSog8NcVyKMoz9qrSZs2R3E4vrc5hVy6jyWcgTUiM7c	7156	10134	10134	1617763320000
13966	3NLB4MYcLnX1CeZuXdTrTzXM97J6mdv9ZAxqSTf7ZY1UXMdEwedn	13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	1607	1102	214	6301	10133	jxTTmHkDaoCY16TQ1PsHaeC2mKRYsQqwuvbpyE5CgTzXsi2iPq2	7157	10135	10135	1617763500000
13971	3NKjK5Tnn7yN6CayVbkzwWHk3zwtDcEawbjAtSTFsgfh6h5yTwyE	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1419	814	214	6301	10137	jxSnrmQAZXgUR8Az1T6nYePh1ArN3djSiVvxdPNotpSx9F6r5FT	7159	10138	10138	1617764040000
13973	3NLcXeA5mFgHidr8Tz4EqGoGVuFPpYC15LBG9Hkgfza27586TvBF	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	43	1064	214	6301	10138	jwzFvwaBoAPGLYTBGMfesamwvAFSksFyPSGL3SVNftdKYhM67oU	7160	10140	10140	1617764400000
13976	3NLqQyxckHyMBbJwKEKbsXfJVQSda3RBohPFJ55obnkaySsAip49	13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	1523	1195	214	6301	10141	jxf6FFGSnNwLNMB1tVrnyh8i8nxjWWHmXKfQj6AGxoPch7S8gc2	7161	10141	10141	1617764580000
13978	3NLkm5VggrMgcPnDQb8BJzRTKsgjmDm6fykbVhabvREHXFmiBmbL	13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	1406	1393	214	6301	10142	jwpP5kzhKURAuFVYXHRYbcCMKLD9aGTrgsVAnoEs9nqb4yn1f7P	7162	10144	10144	1617765120000
13981	3NLV9jM2VN7b7fkQXxLb9YfBPyKGvjtQHAZMXTssoQoEvadgSQYs	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	1513	1379	214	6301	10145	jw7UWd4MHpAaN7UGtPuddsaYhjm9rgZE47WuvPPkseUp4yoEJQG	7163	10146	10146	1617765480000
13983	3NLu5eGPC9nNC6qvdFEBYMRAwgJ34w49FRsEUJVHFPo8Q1BckowZ	13981	3NLV9jM2VN7b7fkQXxLb9YfBPyKGvjtQHAZMXTssoQoEvadgSQYs	641	1210	214	6301	10147	jwjZNUo1xwFJuCWcoSNa3hyXLW5hFEE5uxiHYYotYDjsUxoAzUS	7164	10147	10147	1617765660000
13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1506	1127	215	6301	10155	jxFLh4DghUfityAjF884yas3oNNvvmdYeBiZHPnYKPiafun1dBP	7169	10154	10154	1617766920000
13995	3NL9pqUJm9QmvpovjAocUDjnXnt2JXmXnNWFShBMxUcaum9Bz9bo	13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	1403	824	215	6301	10157	jxdsrdiaRVUkZdoQNpdxeS49ebhDwEnQDPGa7hgFmDpxMEKeWJx	7170	10155	10155	1617767100000
14003	3NKfcLCaxD75q7476hpFcSWyVt8maPVyNmw2AwDwFotkEj28Tuhz	14002	3NKU97f89fAapQ7qzkfTWmNJduBscyMRoGRtQ78JDjVihGzAn4T2	1637	816	215	6301	10165	jwu4rmuQCGQdnT7tF8twxGX3t34Hdtkzoj2y8Ws1kBFg8Fo4pWw	7175	10163	10163	1617768540000
13879	3NLmcvvV1n9Mw4wN179dJWx7qSsq964KevsuctJijpXsR6eq52nw	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	632	1136	212	6301	10062	jwuunfaH6y3A8oporirK5z1R7jhhTyfsTX4CrTqDMSM4k7o2dWG	7122	10083	10083	1617754140000
13886	3NLYtPH9YFXRzSHcnGAsjBmz95FerXpthqj9GHs59qEGVPuXSppf	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1634	1331	212	6301	10069	jy1Cgs8joBMHdLeJ2dw4FoRDmx52cFBUNKrDyDFusHU3wm8N85X	7126	10089	10089	1617755220000
13888	3NLxQWkArakuaDeV5fNq3p78XAPLtpuUUDa695eUmAnpxnFSMCZo	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1631	794	212	6301	10071	jxD1EK6Y4x8qbpNYmopN4sgo74rWPW3uHHgJnWngMPq8rW1HRZB	7126	10089	10089	1617755220000
13890	3NKUZZuP1iauZnFkNMMgLxVRGz8cjrrWxXFSspvvqmrx5h37aMxy	13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	1643	1173	212	6301	10072	jxoytUCMpfSj3WieBEnb9ApTfK9hG5EH3TMg3kyWNwVR9bmRr3C	7127	10090	10090	1617755400000
13893	3NKQoP2SGzj1Gtfz3JV1vVT1riZCNLJmjMtb93SWoPMPQemj2fhp	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1672	1159	212	6301	10075	jxhxhYS3w5WzszvY7zZPiECppx9ML2bv42K4fFH5nvSYQXvceVp	7129	10093	10093	1617755940000
13896	3NKpN468143CDPoBCntfU4ngjh5q8h6M9y3TaL22CoFvjvr5DqFr	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1581	778	212	6301	10078	jxbM23Lte1G9T4HchoQtu16o17bPCqbJt9nhyNdpprmbWgJcrGd	7129	10093	10093	1617755940000
13898	3NLT5MgoNbjaRWqd9w2bQNPsbeJrA4GHjWhLwfUKLscdSgR1u8ej	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1407	1395	212	6301	10080	jxxJDL7pbNWgRwLyHSCfg35wb7NF4J1eayFaXg9ivMw9GXQBn8p	7130	10098	10098	1617756840000
13901	3NKqyS7rAarmj6ycf3HmrjP21TtHKTQvkp8TtEB18d6LN6HqeTHw	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1542	1058	212	6301	10082	jxrfDpUdMcHTSunYpdxkcEnnHhbtqNtMvNyezCCrJmbVc6EPbDJ	7130	10098	10098	1617756840000
13907	3NL3QzRr2EghK47oSMgyBbSn26eGUGq1rNMXWqo6SfVZ7Etf2nPY	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1608	923	212	6301	10087	jxcdN6W48RwB8vVYjXi94Xi1SRhL8bJ2u7YdmdaNxrNnha3dCFk	7133	10102	10102	1617757560000
13909	3NK7J5o6RUSxgyGFZmJVwZhYVZL2FqXEYT4cLmP3VUUgANckojQm	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1444	1135	212	6301	10088	jy32YVJepgZksDet5LBNx8nV7VjzvKLgvjxx3N3rSLQkRGd7PoB	7133	10102	10102	1617757560000
13912	3NLNak4exA5wbXPXXmh8JcSMnaS9tF8rUjJLYPgqsya2NSUCz4i8	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	311	1307	212	6301	10089	jxU4o777mScMBx7RPdy2ySLen6bviRvcC38rkeao5k5ScqkUohF	7134	10103	10103	1617757740000
13914	3NLiTJEm9oA7zLpUSWoEJVh81CuUi56UvuxT6godnBCGnfNKKRkf	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1609	1333	212	6301	10092	jx6oD5gLp4uhkiryJ9qWEFNxH9fwnXJbCBMbKs1ZVqRv6GA54Np	7135	10104	10104	1617757920000
13918	3NLrEksXbrzvFeedRWT1bsqK6FMmLz9EC6ZtA8NkhJfx3m7EKHA5	13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	1406	1393	212	6301	10095	jxWhZvHnE1Y96qLUprCmRypY9WtsShDX7NKqJ9k7i9LfNQ758oL	7136	10105	10105	1617758100000
13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	13919	3NLnD4KWL1iMNMiJsJ5RzWdpWgMaj18EejgE7SutjXRvRGhucjd3	1406	1393	213	6301	10097	jxiRurKUv7PVEs1P1dpCF8zZzzG8PDjfXo82g7MkrevAZaRR4yD	7137	10106	10106	1617758280000
13924	3NLjzq1iwC3Gww6S1cENqtW9j9W1ATqTcQo5eLFg5DdeowUUx8Gj	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwYJaH3uFjjeXbsmvQcrcahu2HADPEg8tL3kuJ96GTyB2N3uRHN	7138	10107	10107	1617758460000
13937	3NL7fsVkxJeFA7uwcxtrc5t6FuySx3NQttDw1M7EtSmLMnAU7BwL	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1578	930	213	6301	10109	jx8eVhxdzPks9TRDkHpKn9Fr7shHTEak6yXxuVPdAPkQ6ShwTgp	7142	10113	10113	1617759540000
13943	3NKpwZpRPDN2VkRLeSJNfiwJk6SWAUc2yyLGvQhFsT8cKHrbwFHo	13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	1534	1071	213	6301	10114	jwhZvPQ8sZkZNq5t9mqMZhjoTC5rH4rc7qnRD6gqkuMNpzQ9nvB	7144	10115	10115	1617759900000
13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	152	1330	213	6301	10116	jxJoiFpii7ASkBLXbenWhq9DWyHXaCo8bs13rP35rHHM1A69DAp	7146	10117	10117	1617760260000
13947	3NKp8iPH44NXRKWJyqPPi5A1ZhdG4pbqrnwtfikdwEFrNPB1n7Bc	13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	1670	916	213	6301	10118	jxoTM1R3AYpeZ8FcVxFvcx13nNAsCGoSafg4p4eACC9vKRVZ6nG	7147	10118	10118	1617760440000
13954	3NL2XdGzQFNMKoAwDMUyABUkMF7hqdnuc16CdUbezCP4Trx8MaVy	13953	3NLSTSpm5VNBPn8kwsbYt93ABEF88H2HXQmbRq3b5E7FZjFiSp5L	1571	969	213	6301	10123	jx3FgpyBFrB6FRRtUE7hRfjWA41sRJAzRVad5E2WJJMKZd3yYA4	7151	10122	10122	1617761160000
13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	1403	786	213	6301	10126	jxtVStZ2LwF75VZfbYdwbXYfe3JZhtCCfwaQkK1F7zcjYspHGjc	7153	10125	10125	1617761700000
13960	3NLrPghEp7qiyBckrkWnxhYJzAERzCAx3VLno4ovT3vySnkmniVQ	13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	1594	1326	213	6301	10129	jwcx9L4AEEDZBpssmmMiy1ewHRn7Yj7x4GwJdEkD5chHYVyhJMt	7154	10127	10127	1617762060000
13963	3NKHvLPT97PMGqhEepEe1DGiNG37RhUhaxZPG4A4PFweKt6dj6MT	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	44	959	214	6301	10131	jwmdMLt7qHmBjh3rmFddZa1YKjp4h9dwom7t2bit1cNPmkAdFao	7156	10134	10134	1617763320000
13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	44	1325	214	6301	10134	jwWv3jrCb9CFhC3Dx74Hm1iFFn3S8paUJsC412YoGkh9YuLCgHX	7158	10136	10136	1617763680000
13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	13972	3NKMbPTRKxp441vbQogp9Jqp7ktUxj5ouj4L63eZtEqXKPs6w6K4	1523	1195	214	6301	10140	jwFLtXd5ErFM4bySgsbd5Uax2kQqPt7X8ZR6UGQgTs2TqnSXQUS	7161	10141	10141	1617764580000
13980	3NKwEaA822ksueAhSwKBFHgW7c2zPWqHPu7rhpQoptmVTtGk1TDq	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	1407	1395	214	6301	10144	jwBh9QRk8CkJAqXkCCUjSVc1eYFn1G7QBrucqsHA51T8UcwARvy	7163	10146	10146	1617765480000
13985	3NLcncJXouBf6ChLWrygXCo5yU4pmvJBTRYtZpnafuSTihKJ8B2S	13983	3NLu5eGPC9nNC6qvdFEBYMRAwgJ34w49FRsEUJVHFPo8Q1BckowZ	58	1281	214	6301	10149	jwz48XebadPHeUECktm3wdECyBtrJDqd6B56gGN3TLfpcX1virn	7165	10149	10149	1617766020000
13988	3NLt9z5PQr3JKogoeGm3dFLGJXukfaadd2VwpdStoz5UNUQLV9yB	13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	1672	1039	214	6301	10152	jwFjk4gXJvgkouoekopu4kWGCtvnAUjrbBubqGGiddweeT2fDoB	7167	10151	10151	1617766380000
13990	3NLCiVSaBGz1qNBM6VGz9Sn9WVBbBycNGSWhoRpYNNwysYJ2W7no	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1670	1036	214	6301	10154	jw9M1GprAXyqvdSwKXnG41JQixASPtSoMCDsdjeTcFdAHQeGxVr	7169	10154	10154	1617766920000
13992	3NKvePJpNSheHo7LZJ7msEUJebqdHcu3HHzWjiyWxo92KRjNvJaa	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1506	1127	215	6301	10155	jweWHnXNUaGHeSaoog2CZamwAko9TncfA9sJXBdBdToZ6G6JKYv	7169	10154	10154	1617766920000
13997	3NKuXob8VUEihNQP8xKYodg71TuV1vnwgC46jdPvQz8JyuFMDqPp	13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	1581	778	215	6301	10159	jwxm9fg27kHvpNyznHqorxHQPoMkDMQRn4AsuGcW26jFgrVZZeA	7171	10157	10157	1617767460000
13999	3NKdNBamjGaSiDVomVHkadzMJX74qJ7pNZQT9iiWSWwvuNGCYQpV	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1403	824	215	6301	10161	jwAN9tqoT1e8dXeUvAK6xnUb29PE5j4BAN79UbRd3Qj87oirRQh	7172	10158	10158	1617767640000
13881	3NKTgscXfCjHxyd78fFxGRD5y4uqhDtwGG3d8XMoyQ2UJHUA2cZM	13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	632	1136	201	6301	10064	jxv9E8sgic1KtcJ3ZNzxS4u4kqKyHBirzMHARJekRT45JujY6ge	6931	10083	10083	1617754198770
13882	3NKoGkSEEpb6LCckwd2Lb3NLjFr1qQZ1FUASeU3dT2bPwNchuqH5	13880	3NLjjT4krFu7emEL6zAMsVkUwTUap4XqFHd71BxWU82V3GVVZDDz	1609	1333	212	6301	10065	jxSAvKiuAXmeMLm4ZeFtFqhBxpbWuEh2QeUsoS8Pxi9pEVvcqsg	7123	10085	10085	1617754500000
13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1634	1331	212	6301	10069	jxo963j1UQW5JWntJJCu1WSpkZuUyNyaWNYkPszhMicLbjhJYmy	7126	10089	10089	1617755220000
13895	3NKxWMkMMwquPYZSBKDjFQhX8UTQD4wr3fZ91U2tAvoJ6yBxn9A3	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	684	1226	212	6301	10077	jwvNuc2mnpM3XEQP2pehPxXHn3zgd6qFDTX4w7JTjHQgUv6fvFd	7129	10093	10093	1617755940000
13900	3NKhWaT1PEAEgUr8h7FhEiWYHfRLuQp3KRajwFcaDVMMrXDJywCe	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1460	666	212	6301	10081	jwrvhfNuJ7ahK4iKAFMq6gyYo6kSxrxeqhytt6wQj7VyNxYRxSZ	7130	10098	10098	1617756840000
13903	3NKh2R5yY74pVxzCvdRuhmRU9T7wp18qWfsKVvR8DYzEiiZbD7VL	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1651	935	212	6301	10083	jxvM1KUNZwVzTnyngUqhQgmV1JpLP57hmxS3bgeEfR8CdFdpsqo	7130	10098	10098	1617756840000
13911	3NLC97ZT7Shnj1jnyJAk2GCRXZYdESpi7BkB4zuHYU5NSUtQSt1K	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	1589	1160	212	6301	10090	jweQaSSAH6vAR8yZNAVGK24MpZLfAyJnTr9XAWYCA6i2MjjEaK9	7134	10103	10103	1617757740000
13917	3NLXRkuri7NbcetZNbfs7mL9nhPuJq3q6MSLXura4NR9m4izfjgo	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	58	1155	212	6301	10094	jx22QwpaE92YPPgJ3WQ2wBFwji7yxXZgA2ZpS7bVG6MkPgLmzcw	7135	10104	10104	1617757920000
13919	3NLnD4KWL1iMNMiJsJ5RzWdpWgMaj18EejgE7SutjXRvRGhucjd3	13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	1623	839	212	6301	10096	jwwk1DyiRFz4MpKsiAeNcQLtgCJVXt3W6UdTQKYeBFc9byjQppX	7136	10105	10105	1617758100000
13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwgNMgHXP4QTU5P3VznyiyaSJ1sEa5oYem5Tgdfdc7F864RVJec	7138	10107	10107	1617758460000
13928	3NLgzq4uG4HDUKqaqph66zFuCAj5KTcaCs9YPP3PYahyUSKovsQE	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	1513	1253	213	6301	10102	jwHXeR3DpaEWHT4ViEigyQAGHNpnigSExU3CfzqB3N7qtZawi4N	7139	10108	10108	1617758640000
13930	3NKxC9XAQypCv7KvDT7XQbeEfztkwNXcGkwuX3Z4p5NGpTB6FP53	13927	3NKe3R18sZFKFAHoU3d4jVR59AYgZmssZdYkKJay9a5KyDBUojKF	1643	1053	213	6301	10103	jwbznnfvuTbB46FneR2EoRyZhHzDE8rMkE4mLkLbqaqpx19pUYx	7140	10109	10109	1617758820000
13933	3NKgyu4H4NtpiHkzF8pEsZLwYAdh4gyJv2chdxkB5w6yCn8hMfk3	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1588	1392	213	6301	10106	jxXQjW7qBsVA5b7o2J4xNY64Ggj8Rjqfou8RBxHAUTaBXVo1PR8	7142	10113	10113	1617759540000
13935	3NKaRgrmrza35EEcNxqN2EAP22LimZVbJ4ZY87pXmBWDcXGoZNxe	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1508	1387	213	6301	10107	jxxeYbksqyn6AEXj2o8rHzSLCi2jMrTt7o8avWRw2mJUZizF6uc	7142	10113	10113	1617759540000
13939	3NKDSjxjuEAfL7qvVU1JKRZEZz9NVAgCY9uMfPkHQCZPQwCeAfVr	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1590	1174	212	6301	10110	jxwDsvp7AX2WBfX13XtUaWiXgifpQcY2GjqD3gGUZW5CwNJf297	7131	10113	10113	1617759540000
13948	3NLpXdAdbhnaU3VbUCthxuPehF2GupMkhdTubRK7bJhyt3iw8Ft7	13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	1670	916	213	6301	10118	jwdGx7kXe7gLnnFdS8qPG3GQCaw1msSzUjSEL7XSwCAZwbKxKp4	7147	10118	10118	1617760440000
13951	3NLa2cx3cfmjT3SWjpzQjbXWowNg7MsUqnPFMHRZMhtrVAJX8Sjq	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	44	1325	213	6301	10120	jxNcp3k53aeQkyTgm9S1Qn3jWeUQXnyaNxBmduZmrdzdsxkGvTd	7149	10120	10120	1617760800000
13953	3NLSTSpm5VNBPn8kwsbYt93ABEF88H2HXQmbRq3b5E7FZjFiSp5L	13951	3NLa2cx3cfmjT3SWjpzQjbXWowNg7MsUqnPFMHRZMhtrVAJX8Sjq	1637	815	213	6301	10122	jxEhJe8q8tJkuwStGjFj1MM1Pj89JUZgyXaZgwDDGfx9bagmz8K	7150	10121	10121	1617760980000
13956	3NLgnS2PkPCPaK94XByXFtZVZuxTBPK89K333kWbKgiKtv3TKDTT	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	1407	1395	213	6301	10125	jw81PYqFF18TP5fFBD3ffi9qQLgtiSCKH89hbDVKjMJ6bpCCdvj	7153	10125	10125	1617761700000
13958	3NKVgdztsVMPVzsoDEHsQQWWYv1eKGu8q2LR3VGdC6pofBSQ75v4	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	484	1073	213	6301	10127	jx29goHtF8Km9SBsAES4Eg6VFaaE4NfyB69C79FPuNfofatc3v4	7153	10125	10125	1617761700000
13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	13960	3NLrPghEp7qiyBckrkWnxhYJzAERzCAx3VLno4ovT3vySnkmniVQ	1483	304	213	6301	10130	jww52gyeBpfmGxPHCpC2of2WndDavc5JPWuVz3hgPiQbd7DW2xT	7155	10129	10129	1617762420000
13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	44	959	214	6301	10131	jwLzNgL1JE4H394M1SH4ySVqeSUeBfWg7KfUPRrUTHQ3urXZsn9	7156	10134	10134	1617763320000
13969	3NLFr7WmtqPFUCMUP9bfvShuFs8vtNMj8g8BjeK29WsAt2AEwu7t	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1406	1393	214	6301	10135	jxo2tENifa3XTiRTuDsZz1kZWSgEnrvSjNXu6jCtQVP5TqVbayr	7159	10138	10138	1617764040000
13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	1461	1271	214	6301	10139	jx327xHXFcvifDYxsQCWw7Bu9oKMJVzBv9ji6DdbHWGJHVuq3Ve	7160	10140	10140	1617764400000
13977	3NLQUHLX4Nwggch8yMVwuwJYFtV8YL8HANNPwo8VL4WCxKnqTVZE	13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	1523	1195	214	6301	10141	jwTv6CCdNmbDRZYpxoJ3hsgndbPuj89SxpLDYjs6zjtji4uXfR6	7161	10141	10141	1617764580000
13984	3NKvzzWYUzdiV5hwUgfz8SqVN3nqnRbnYGek8sJ9Xt5j8AWKneie	13915	3NLQc4BpZpa1y9P9JYqMn9AdkgRZ1pYhwB7qWXLnV7J6SBtHZTHH	58	1281	212	6301	10148	jwVhciLVppFsgYXusffQfdAMUmG99PtB4eWguh2ApUwWjHuPXmg	7128	10149	10149	1617766020000
13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	13985	3NLcncJXouBf6ChLWrygXCo5yU4pmvJBTRYtZpnafuSTihKJ8B2S	1647	1302	214	6301	10150	jwSb5FwMuUxs5ajWUsw34gJb9U5L6nPRsQrCvHKRWGHPMzWG6kM	7166	10150	10150	1617766200000
13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	13988	3NLt9z5PQr3JKogoeGm3dFLGJXukfaadd2VwpdStoz5UNUQLV9yB	1406	1393	214	6301	10153	jwkxGPkyFjCqz9oj9HiHnNzEa3eNu8tYnN54KTbWzVhzVezFZAj	7168	10153	10153	1617766740000
13991	3NL7d1FfzBD9Xe4fu4YEz37EVrg4QoHCf7QMDZp9heLmr1JKtWUg	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1670	1036	215	6301	10154	jxrrCZXswrU1iJcSYycxDMjuhijfSWAGqU5GY29kFzEHZ5tRbhc	7169	10154	10154	1617766920000
13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	1406	1393	215	6301	10158	jxiGi9wxR8bjPMEvzZVzkEVEpdZgr17rGem3rjvwvb6TE1HgCGE	7171	10157	10157	1617767460000
13998	3NLMdWZK8Ek3TV5M3uULxHgC31zkdKMFNQWL7mh4o5RLBiRKy7B2	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1406	1393	215	6301	10160	jxWSBLhMBrgyy9bzgUSgcDfx72wMhAPYt8AWzYXtoUD3a5u7SQ7	7172	10158	10158	1617767640000
14001	3NKFVZCRjezd97fEo1ahXFtKpjGwUDS31kLvdhZuY159WHv3MUK7	13999	3NKdNBamjGaSiDVomVHkadzMJX74qJ7pNZQT9iiWSWwvuNGCYQpV	58	1155	215	6301	10163	jwC2LNdiz58e5hNgsh1yxo748eWZkkb4rXRJshwFrH7va5bK1wQ	7173	10161	10161	1617768180000
13883	3NKXqdL5VqJ7e6vPGudA6nUvoUBFLYNR7ULzrF5hmac13tYXK4GH	13879	3NLmcvvV1n9Mw4wN179dJWx7qSsq964KevsuctJijpXsR6eq52nw	1609	1333	212	6301	10066	jwK3qEcnebZAfCzmfT4LDkBhtmnJWhHM847qC6vyihCQPsQJZSs	7123	10085	10085	1617754500000
13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	13884	3NL5jVmqh18z2oEJtz7u43472HVkbedhjtxz4QDQ2yjwAH3TSBor	1631	794	212	6301	10068	jwp75Y1CzH4JUwczS7YVoVFgZnYUotLJSuA3c7bCRCQUayfx3FY	7125	10088	10088	1617755040000
13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	13891	3NLrMaLbBH4jYESqQ9HLKFgYkNmpg5fjALX8nRTtinZ1tgtrQh5b	1637	816	212	6301	10074	jwugFJBPGWkvGiRfiUGD75NRpuJVoiuo85QBBNGk8DB8doZhw2B	7128	10091	10091	1617755580000
13902	3NLd3kyXXKTArHXpSjs2jXNnWPmKXh4q7LQA4o9cYXkkqUn2CUWN	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1651	935	212	6301	10083	jxwzsE2AKARTHVsZnFeZWJhWyMUY723Cqu3pFbAnSj7MqSHcHci	7130	10098	10098	1617756840000
13904	3NKFQZVdak3JoaiKgDXEC5cCHwpLNcyPcNtxwoDRpDH8ScvofKMJ	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1407	1395	212	6301	10084	jwrZFS856fvHAMh56aZtGz9Y3dFYXKg17XeCNTYQ3eydziZ3T4V	7131	10099	10099	1617757020000
13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	13904	3NKFQZVdak3JoaiKgDXEC5cCHwpLNcyPcNtxwoDRpDH8ScvofKMJ	1406	1393	212	6301	10086	jwh8XGBysxceoibDBRK12G2ReAWTqfLBiSeL5exFyNLcneSsTXD	7132	10100	10100	1617757200000
13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1405	843	212	6301	10091	jxDH31t9wJ4G7B7mYLjdd1ro1tS61VXPdyictrbFHqXAw52Lc8C	7135	10104	10104	1617757920000
13916	3NKMrFH95ndQXH7J8trBRXHz3B87zfj7YNDrdssmHwLTgQWBBreU	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1609	1333	212	6301	10092	jxUtF2rEhNTvGVkNEZXo8asKWoXw9pizg2k6KTUvme1EePXxmyo	7135	10104	10104	1617757920000
13923	3NLCT6Hv7JFdkUZrsLUbdWjRqN4dF543zPJtSe7xM4rxnun4J4aa	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1619	909	213	6301	10099	jx5ZcuCJvftCXu9retQUrdGKZkfXTWKMmfvJtgG5fCPsjytvRGd	7138	10107	10107	1617758460000
13926	3NK9MxLbfues9apFELYEobF2qzpBzjCe4KfCQNFZnMAVzhkizgSN	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1642	1121	213	6301	10100	jxidoj9xoFrkZQ2vZwS2Ho3jRwHFw5eGdQo42WBEzCLuLhqKQD6	7138	10107	10107	1617758460000
13929	3NLVbdM1juVw8FTqxTy9wP5x8Yq6PHyKQuCzd2yb58VAfT3JfC4E	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	632	1382	213	6301	10101	jxLkhEPn4pRXw7eLLwk1oFUAh7bT8MxYqJgtwQexjr3Et4zNj42	7139	10108	10108	1617758640000
13931	3NK9NpxRqH5QheJLXJ6JctqQ3FF4SPkx2JNi2VoMGNpRcchqr142	13893	3NKQoP2SGzj1Gtfz3JV1vVT1riZCNLJmjMtb93SWoPMPQemj2fhp	1650	1375	212	6301	10104	jxyyLCTAkqQGx5w75A7y9aTYeJC6gb3Z2jNCm246NNzVozrEhs4	7130	10111	10111	1617759180000
13934	3NLwzYQUDRLyjkJWuat5KVwc4X6ZYnKRVgFwPCV1B5fvfdcmQXQx	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1588	1392	213	6301	10106	jwBXv5ACWADbKVNJkf6jNXuejjX8QMJspbbicEP2jGiFDAnZk4w	7142	10113	10113	1617759540000
13936	3NKVtC6e9HDRcC1H8AegeanTcMsyzv5eiHkgg69MmfQewha9EFbh	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1419	814	213	6301	10108	jxu3zU3D6Yqi7XKwD5SZi4Ke2sjp3xNSCwcvmxPnw6byR7szyRb	7142	10113	10113	1617759540000
13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	13935	3NKaRgrmrza35EEcNxqN2EAP22LimZVbJ4ZY87pXmBWDcXGoZNxe	1672	1285	213	6301	10111	jwtp75ShuqZTT9XUBebMjSNdSCb22vFCh1oFaGkfF5u1kRwntUN	7143	10114	10114	1617759720000
13942	3NKgPtmoycE3zXdaNsotU9nuVZFi22qM3fpd9k9r2qSu1UzGibFx	13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	1402	866	213	6301	10113	jwTWq9ChNkHzTL7Pu7qwWNSPjoCKcavL5PiKWxZCFw3S2872PCF	7144	10115	10115	1617759900000
13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	13942	3NKgPtmoycE3zXdaNsotU9nuVZFi22qM3fpd9k9r2qSu1UzGibFx	1613	1103	213	6301	10115	jwoWKWJgarmru8T5BrQY2Hqq6d1sF6ouTFkFzBDirWT1MDGD41R	7145	10116	10116	1617760080000
13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	13948	3NLpXdAdbhnaU3VbUCthxuPehF2GupMkhdTubRK7bJhyt3iw8Ft7	1458	1077	213	6301	10119	jxJiuQfiZotFakFBth5qBTkBS7NjwcNfDsJA8raGLpibhHoKF4f	7148	10119	10119	1617760620000
13952	3NLJFfVQaRsn2Z45oBqFhq45Zrr7r8cVjeeRhWowu671anHU3YNH	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	1403	786	213	6301	10121	jwcVjUcEgFrNjVo1YPTwjebQHewJd6sBhJu459dfg3bW7AZzuV2	7149	10120	10120	1617760800000
13959	3NLQ5d4Lf1xmMDvRhafcrCR8BEU9zqXRKouKesmavAMFgjvig7ss	13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	1406	1393	213	6301	10128	jxj8o1rwticSHdtGrBcX6wK7v5MT1nSnhvrxP51dBgS8DXy3e9g	7154	10127	10127	1617762060000
13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	1607	1102	214	6301	10133	jxKAhWezJPubSrrLzx6H9vavYwCoBziCj2R2iP2SJVw5761HrQN	7157	10135	10135	1617763500000
13967	3NLm1Rf8Cj637ge2v2v5V2jyXZEcbydea9ZCZX9TNyBU1VEMWJpV	13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	44	1325	214	6301	10134	jxBkDf722ofsomVYQVr6wdXDuBNASpX1DdMCJSV88PXCEpF7sHX	7158	10136	10136	1617763680000
13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1397	828	214	6301	10136	jx5Nu1uCr8ncH3FH5eyZW2LK6q2bHZ41Ly9qX2dty4jc9X6qpCf	7159	10138	10138	1617764040000
13972	3NKMbPTRKxp441vbQogp9Jqp7ktUxj5ouj4L63eZtEqXKPs6w6K4	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	43	1064	214	6301	10138	jwkxNouVoCQhz66z5AzuNkVAkMKUqYGn2B7JxmYHT1E2v8SxLWg	7160	10140	10140	1617764400000
13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	1474	1083	214	6301	10143	jx5jYn8epugYWpTuDeMCHBQM4J3mqTYCCyYyZzMh6gg8XuMNGZJ	7162	10144	10144	1617765120000
13982	3NLY6TTRPCFR4spZU9fub5V7HuGA29aD3x782MeRZYwvaFHfid4q	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	641	1210	214	6301	10146	jwxFo1qZsBmFnY8NKietBV7NqqMxYU1QoLD8PUTVMdaqcSFrY4u	7163	10147	10147	1617765660000
13987	3NLazT68txmf7FnaekH2PbDpifAhyCcQio1P1dNZjiZoo3UNDjXw	13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	1656	1343	214	6301	10151	jwi8cGprYDTFZbgF6qYkdXvrmtTqWRnytpYafLVSdcmyqCRHm9q	7167	10151	10151	1617766380000
13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	1607	1222	215	6301	10156	jxCv8eBiXnyWnsLuQCvCB4Z7fvztqXUYujMHXaXf1fh5XG8a6HQ	7170	10155	10155	1617767100000
14005	3NK87G1tsPqaWfr54ETor1Gup8fHVuW7XPwtdTqdwsRj3LpXPEpw	14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	369	1312	215	6301	10167	jwF7GjcsPkLLwYqipRY75e8Q7jHMBQVDJfwBGC8ZpLyH8T64ZYV	7177	10168	10168	1617769440000
14010	3NLSa9eSYXrS6bBDTr2iZK7J5BqXZCR8M8eK9mjrzW2ffRVmGtvW	14009	3NLj3vmhLk8mFqTZfrtp4aEVH5zH5oX59xAMrz6xqL7238N3NmH2	1593	980	215	6301	10172	jxbLEdreaJtUpYqzxMM3SpW3qe7MTvYoLkQSbenQVbyKiaYjuKG	7180	10171	10171	1617769980000
14021	3NLYrKSHGx7jarct1YHtY9R6qeamg2WGJsrPdAYBtgvbXadzpDkt	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	700	832	215	6301	10182	jwzN36xiaUXSe66WGwGXGW4ULXJEU7cQrjEazhdwfdNnjm3Ny1S	7185	10177	10177	1617771060000
14025	3NKspJokL8XAFg9qc35ZciK5vE3BWJvyXdJWb238hZC7HCDHHy1n	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	114	10	216	6301	10183	jxpk9veD79EcmjS2MQcoeHBcnt5sN38R6u1LmkBztDoyFAGXD1U	7185	10177	10177	1617771060000
14000	3NKX5s792zci5Zroq4e98hWjzgNLiY6JDsVvuedsACv3wCzz8dYV	13984	3NKvzzWYUzdiV5hwUgfz8SqVN3nqnRbnYGek8sJ9Xt5j8AWKneie	58	1155	212	6301	10162	jwJQx2DbKULzC4UXy2vTTgQsVVxYzC41Qfqpn866q8WfGunZhyY	7129	10161	10161	1617768180000
14002	3NKU97f89fAapQ7qzkfTWmNJduBscyMRoGRtQ78JDjVihGzAn4T2	14001	3NKFVZCRjezd97fEo1ahXFtKpjGwUDS31kLvdhZuY159WHv3MUK7	1419	814	215	6301	10164	jxiPf9d79qag1U9RQNwiuNwF4gPqCVPnwFkWBxSpApJBB1uyLxh	7174	10162	10162	1617768360000
14008	3NLtaxsckw89FAksjha1hUTduvofQG4qb3qxWdPuipuuU5jv5VDw	14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	1500	1297	215	6301	10170	jwzUcrqwKwGro95Yx7egNGawCKmuPZBXYNHssr9UPN46bToF7B8	7179	10170	10170	1617769800000
14013	3NKfGg4RARyLAmzDsvN18x3NQmzmQj2csJkzbd5f2fYPg3tXeK38	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	1476	1371	215	6301	10174	jx4ievuwDN3qP1cXpuQg97nM1os81dx7hWP19hcBE4kB1kQMp1u	7182	10173	10173	1617770340000
14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1581	777	215	6301	10177	jxaUbLZSbRN7SrHYhusHDJvuZaiZuBDBM4dyv9Z3HDVKcEFUs1f	7183	10174	10174	1617770520000
14018	3NK3RZQo1Tu4fXgxK8Xp8P29x3KUxPi7YiDMDVsDCteNR65L24ii	13931	3NK9NpxRqH5QheJLXJ6JctqQ3FF4SPkx2JNi2VoMGNpRcchqr142	1650	1129	212	6301	10179	jwtkCfM9ZYuJcyuf4sDvzy5crqZm28gn6pCfw6XFZdGu2ScfLMW	7131	10176	10176	1617770880000
14022	3NLRzVk4SXdwqJMFKSJghiw6nmumJ34obH7Ve2rwEzAjZ8uwGbRm	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	700	832	215	6301	10182	jxdAfhezCEMjWYcBGEm79nhkS7sBhiCKu3ybqrRTiKk5F2Wfdp6	7185	10177	10177	1617771060000
14026	3NLS4EoVJE1gfZkhdQx6GyoQK9dspvfuDFsgkYFJwPuMS49jK4Pt	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1634	1331	216	6301	10180	jwUBpPSMUnryevUpNWnFXrAJT69vT64MC5nZUHfXQTd9Dic1uoG	7185	10177	10177	1617771060000
14029	3NLueTiYZp8pnpkMN19JNFZbUgZDtfoGa3J5wRSzjpX5bAxyU4RB	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1560	1291	216	6301	10186	jwvScn5kYXjmLbvvtWtVwwgUVdfe9Sgj71qVWmDaNzCezNAnCpU	7188	10180	10180	1617771600000
14034	3NLC8tvoLB3x6kQcnjmECk2wfsWBPpGmhqtStmZhPJXemXRACEep	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1444	1135	216	6301	10190	jx77d9M9YR4UU8enX6rHseD4CH45fEuQ5o5JRe8sZqCt2H74pMY	7189	10181	10181	1617771780000
14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1402	874	216	6301	10191	jxUYdwmEQhHB55iG1EUdGPzAPypfucRgqRfV7b1tEDYXqQ2Dn7f	7189	10181	10181	1617771780000
14042	3NLVSyst7YiPjZ8x2jzWQbKiN5o8rVyM38WJ8wtMbdNnwrp3YEJH	14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	1506	1127	216	6301	10198	jwYtPxhwmskSAngu2s3t6MeapBG7bUb1WPFf2kPBfp3Jnjps5pG	7192	10187	10187	1617772860000
14044	3NKTdCrKNnZFqB5MrWMJ1i3h7XsYkhDXthZE31TYq9v8vnKwt965	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1634	313	216	6301	10199	jxMX1BBmbS2AaP1N8NGuXrVtYrTpvPyPoQ8mZ7TrByfVXm7Dp2P	7193	10188	10188	1617773040000
14047	3NKGZNQLcLbsMs3MQzjPCBNiD183YmDifEx2hueEafbRWcgTZcmN	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1534	1191	216	6301	10200	jwn46o1FihKwabhnyc3bjMdABqK72esGNueCi8NuxvdC8SncBUN	7193	10188	10188	1617773040000
14053	3NKeGGf83sMrDDVFSiakqhUXR6NVDWwxBHjsfvD2GTH6qBnM7akK	14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	1474	1329	216	6301	10205	jx9CdWiAAUmKqGQcYPpDPkwXde1KRGNxuxGwJUN8Edh76dXeyyX	7195	10191	10191	1617773580000
14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	1587	991	216	6301	10206	jwHv7LN9GwR9hXiuYkyKhRQgxBYC9veJDKUC3f7C7Vo19TAvuBp	7196	10192	10192	1617773760000
14060	3NLoYCqS5bU4argT8v5SJqxkycHaBeieDGhQBHi5H4MpvSxVqFmD	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1522	956	216	6301	10209	jwNVk5znwZ859mD67sRRmUvWSTNavBAz4fP2nyjR78Gjn3uc6qn	7197	10194	10194	1617774120000
14067	3NLEGGyZBsUGADKy49zqrTLApvoHFW34bUD6xzrGCx7NjwZ5cSWN	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1602	1369	216	6301	10214	jwSEYXEk2RXGUmMpBAKDUPCtXybfw2JfDEtjYNjMuP1TSrLN1XF	7200	10197	10197	1617774660000
14070	3NL5oMtehYzbKTdPvj9VQvHJdiCv41Jn9taDbwLzokG2L1YqHCXw	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	58	1035	216	6301	10216	jxY1smWV2tfjaYHVjPLGq6F8yAG52SqbhFZsvS5iKa3UXGQWxJj	7200	10197	10197	1617774660000
14074	3NLcjrgQgoNBXUmih7tT3uY5cHykSaXJA727U8vLPEtPbaJdj2VJ	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1608	923	216	6301	10220	jxM5zgA26KGXPtJtjn3Qp5wbz3UagoqUBFFsmfj1oT7gxpHJ5Tk	7202	10199	10199	1617775020000
14076	3NKGUkCka6Cq1tuMh4TjSK4fHwuRoDVBdorQ91eKyN2kyANkbgmF	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1637	816	216	6301	10222	jwuYVxHyXXQkAPt5yGpPLmJg1tD61WYZAB8ogWcdYWJumFNKVx9	7202	10199	10199	1617775020000
14079	3NKEdYLHMjU3J9veb4McCpKZZp3V8xr4mcgP1Q9wG5vwkCzxNTii	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1405	855	215	6301	10225	jx4E4p787ovxag62pKdojbQ1y9o9kT5eHNkWRTvKqtV5PwLZAK5	7172	10200	10200	1617775233350
14085	3NKWzLGnNRyubThhXL3Z39UFD9mbUyQpz6NxmgidyxVLN2rKa9aw	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	607	607	217	6301	10231	jxB1TbW6NPfuvAYXuXpw1VE6ntsZwEyG7yLkhLLSXJ4Qx1Eizkd	7205	10203	10203	1617775740000
14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1402	906	217	6301	10235	jw7TX4vpkXZRw7mjo7dw2XAX8FGH7XMUAFWhUy9VhVJRuR4v8ue	7206	10204	10204	1617775920000
14098	3NLhbhLgdSPNqDVnsFg735TS89JJSMzHk4mDDVURbi6ZEfn9Mc2u	14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	1406	1393	217	6301	10243	jxCczszbPPo9j5QmYc7MK2egT42D5QoYY8cZbG1J5bpBFVpJewH	7208	10206	10206	1617776280000
14105	3NKQ1bmMPZkVSbsRnHF3LGgqXrNHr94VqFZ7NoDxaz2r9Q1Wkc7v	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1652	1315	217	6301	10249	jwCdZn2LnV2bPUS8xrpXqXjkwQnN3HmWZ4oyz9JBAhKgmAqpSV9	7211	10209	10209	1617776820000
14111	3NL1X4PTYutXKyr3wY6YEvtxMKw6EyJxP215B8joKxxdZtS4dzdq	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1471	1020	217	6301	10253	jxq2vzQe6zJzRhgPZhQfkYJqxemos7C6tXzwdCTTJoYNJqxNtrG	7213	10211	10211	1617777180000
14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1471	1020	217	6301	10253	jxMsfiqrK9KcaxZNr18KqAdz6NNce6NbeKEZYsCQm8RAZLwNp8P	7213	10211	10211	1617777180000
14116	3NLBaSgQqDJpYot4dLXjroeyMLfhAkQFjMmqr3ZXdB3FZfx7oSQy	14115	3NLJBYsK7YnMWxMe9SSvTSSzHdhW2VmtMody1LcJvr3oYRWpcdBC	43	1310	217	6301	10257	jwMc7p2BAFxUxJF8t84J4Je6QkGhFE3CJyuLFnetSr5YUfjU3w3	7215	10215	10215	1617777900000
14125	3NLgr39HsdGjS8FY1KgecuV7SkF5BCxMXaYoRNygq7C61HvHC2TA	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1422	1211	217	6301	10265	jxVqtXqvwdaZ3oSL72pXxcYQ2Qu3uUZwQYg9iSPFCkmQoWS3nqr	7219	10219	10219	1617778620000
14129	3NKdZDged1WQjxpms1E4BrSRNQa7keixY58NfcDyr7ZpM17zyQGM	14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	1406	1393	217	6301	10268	jxmQER5r6S3zjz78aQoVsWCrVoGE2Xr4jFbZgyohPZTYyiQUusc	7214	10220	10220	1617778800000
14132	3NLoeQjhCyFKfJ4PRrkmHkCqPm2ViYmfCPz2p1LrbfauLN7Pwvaa	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1407	1395	217	6301	10271	jwN2eT8V6h1LMaRWnNA4QpVkjmQv5pdnbXhwzD4cqfRopqzsDi6	7220	10222	10222	1617779160000
14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	14003	3NKfcLCaxD75q7476hpFcSWyVt8maPVyNmw2AwDwFotkEj28Tuhz	1577	1081	215	6301	10166	jwiqBHEty2WbfYCPYX1DaTubfgs6uvFrJNYBn7shPrTCLQRinZi	7176	10165	10165	1617768900000
14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	14006	3NL2PK4BzDcPqTCo2zQp1mpyf8vLfZ6QwTgHiJ499WjCY4c4k2xa	1513	1379	215	6301	10169	jxMEsicaLoLYMjeQJc2HFmveUueFVDybEYGqYMNZhCzLGkXmSP9	7178	10169	10169	1617769620000
14009	3NLj3vmhLk8mFqTZfrtp4aEVH5zH5oX59xAMrz6xqL7238N3NmH2	14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	1403	824	215	6301	10171	jwdcuEKoUMqa3mXU8LcNFJbXhCfugW4tX6XbBrSJ2HyzUi3UjLH	7179	10170	10170	1617769800000
14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	1476	1371	215	6301	10174	jwJb5CeZBUCavo8zrvs8md56ypcaKQLVgTYf7AT35N5iUUEtNaJ	7182	10173	10173	1617770340000
14015	3NLJk97eWfsWNoYqWyXawM5muNM2X6BpsHa5WbjWyPDhW81Y7Nmf	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1406	1393	215	6301	10176	jwMC1qGNcoK9HZzmbqQkZRG2KHt21p9MFmRJPYXJhQQQzQ1Ea5s	7183	10174	10174	1617770520000
14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	1585	1000	215	6301	10178	jwVSvxN8BGRJTMPJZKqMNfmGXYQjiaritVVWSvzDtTu39YPHikC	7184	10175	10175	1617770700000
14020	3NLJYpKcCtaHwaVcdR9GCvg1GCQAj3xecTm3fqSrcnnb4w2kBLkD	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1444	1381	216	6301	10181	jxszv57vDZWJSZVGKhBDvD1nDHikb28HKkJMeLMjnZcbFFS7Z99	7185	10177	10177	1617771060000
14024	3NLvXQXHiJ81aRMV2kBws2r3e2jJzkosSthzNCxpWN76ThVq7sRK	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	114	10	215	6301	10183	jwsnTFCFCKvZRXdBhodSdypv1n4TVBRhf9U1aukeLor9cZQnCSN	7185	10177	10177	1617771060000
14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	43	1310	216	6301	10187	jwM6FM1hKmK1YPEWgtUvNAnvhENRtLhAEZ7x3tzqni29tuUbcXf	7188	10180	10180	1617771600000
14032	3NL42xqiUijUMyShDvrCmkTYgp4UiiWcCyHCn1QKWS4dEnwfFZFj	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1560	1291	216	6301	10186	jxjrYKY11xdHQBGJmpvEW3FsLcb8u2Kz3L3tNz7SEhhU1kyJ4kc	7188	10180	10180	1617771600000
14036	3NLXeqsKy8gvS34JyyNKPnr3C4gBdUXbj6uYP7BXu2ZjtW3W3VW7	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1509	1320	216	6301	10192	jwxhgzgchnrgXD8hETdVvmLKkc758yTQq9ridzSJSP6XUimSvUX	7189	10181	10181	1617771780000
14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	1513	1133	216	6301	10197	jwRwxrGthBPWCYuzwm2xg88PUVBv2eCSPbFrkUjJd95b2BREygn	7191	10185	10185	1617772500000
14046	3NK8v8xMfskKR1gdiUTz7deaFkmdBaLwyMLaa5uhu9yz2iZiraMn	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1601	1262	216	6301	10201	jwqFB283BVXcRgTybbnJfRzAUWUEFAT6FWNNSJBtvwEfZeMTmKQ	7193	10188	10188	1617773040000
14049	3NKc62nciA327DhBuaPUgGM7NZe9CxFaRPvvWzt4V9zBRqgdsjoN	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1601	1262	216	6301	10201	jx94uzq782Wjx9GUZ7Ww1pH2iBmsdAeaHJWVUU2GNtZBU63XkgQ	7193	10188	10188	1617773040000
14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	1474	1329	216	6301	10205	jxFZLHF8aLX85uiSQPNLaHyXbSAKZusotw4hEUi1fbPCsMYhhNL	7195	10191	10191	1617773580000
14057	3NLvzDafpY95zPijQVJ7yAri2EsBwhr7sPCTbD4XkPzeLmaZEmF1	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	684	1226	216	6301	10207	jxymzqibCt2U6xUHbV6t4QCJ6i8C64Lry9jiTuNHaiagxf3dYuA	7196	10192	10192	1617773760000
14058	3NK92FDcKznQpA8fwiPvXww1MGpLmbFisX1nV3j9E9xVMGgqn6fS	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	1587	991	216	6301	10206	jy1H8YTLYqFqzRrKdyaTwrioLNBSDiwNWNqWcZ82sGqbtFziCAE	7196	10192	10192	1617773760000
14061	3NLdAMusm5yXZtvnq6L8ynkRhrUHZJPhZ1FFWFTr7fvPJ5wdRMBH	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1542	1304	216	6301	10210	jx5wUtZk1GgRBkD57U9T8qpZRzcf4htnFLy5V9LBN2rWJN9aN4t	7198	10195	10195	1617774300000
14063	3NKEkuPqhKmot8hPEMJwYwLLuPQ9u1eBVrBcKTu7jpGP3EKLrQuh	13829	3NLnp5pKnGsoqL5VUF7Foz45QpY5s6Jrt7txAVZeRkNUpFyvcun9	1564	1338	202	6301	10211	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6954	10195	10195	1617774300000
14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1483	1276	216	6301	10215	jx1oTLQo8BZuqTKJVeZzGuhvWNMwxmYvoDdR4yUe42ko8zv9QtP	7200	10197	10197	1617774660000
14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	1406	1393	216	6301	10219	jx83rrqEQJaHGomMWjyXSsBUuHZ8f5PCk5QW4ySGn1RvgKzFEhn	7201	10198	10198	1617774840000
14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	14074	3NLcjrgQgoNBXUmih7tT3uY5cHykSaXJA727U8vLPEtPbaJdj2VJ	1406	1393	217	6301	10223	jwoat6nMAcaqJ2uWQ37471khCLbjDBmzZHudVoVan3Zg4Ftqyjm	7203	10200	10200	1617775200000
14084	3NLKcnuASLkHmY9JLi2miCpyfm1iTk81xEoQisY8a1ihawUhd4Yz	14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	1624	1208	217	6301	10230	jxNZ4G6bTahwHH3mC17f5pmaaJzNXMJAzKQdSNLTZgVoBJJfGu4	7204	10201	10201	1617775380000
14091	3NKVsY7N9JARvYrwCdnfn8oLjSdjmrcsjVEjTDSb56EPoEBkxTCE	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1509	954	217	6301	10237	jxnoan73uiyUEQEk2YNSNhnU9jyvmdi4m18tLwBXqQqwzm7sZdv	7206	10204	10204	1617775920000
14095	3NKsysc8xEuYzmvrabk69FfzErT8ASH2AX9PCtgtYYihE9yEm1t5	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1549	1116	217	6301	10240	jxBWQzRC2GwmMG6oeV4KjY4c9dw9rkQtfx9VNQatA8nTYBS2hBq	7207	10205	10205	1617776100000
14099	3NLazUZW9Govqtza9znGJVhBZrK99vPJbx2sNs4xXgi8LQ1pZyWR	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1622	1356	217	6301	10244	jwXCmY5gHmtpEp5Bwd9u6fj5XjWRoJ7LgdFWm5hFHF6BNysKur4	7209	10207	10207	1617776460000
14101	3NKoFXpri7232Ei173vrp3nFWbyDXtXdrR7VW3wUt15GoC515GAr	13959	3NLQ5d4Lf1xmMDvRhafcrCR8BEU9zqXRKouKesmavAMFgjvig7ss	639	639	213	6301	10245	jxn2dByWsLS2E67HqLpaPRwzigCFaU7wimNHHE8hH1Sr8fEmFMN	7155	10207	10207	1617776460000
14108	3NLknQp1UaWwgA9HDk1Qc2EF42bm49EJDidN4RBVc3vmAkVcxisc	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	576	1355	217	6301	10251	jxDe8kCNyJgNJziPXoQqn3S7Ls7H5DRcWPmLBf8n6UMN7jAzDqG	7212	10210	10210	1617777000000
14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	14116	3NLBaSgQqDJpYot4dLXjroeyMLfhAkQFjMmqr3ZXdB3FZfx7oSQy	1407	1395	217	6301	10258	jwgFX8gT9dEEKCYCGg3TsX5FminAVxQroyq7tprjZdpUXTfDL7x	7216	10216	10216	1617778080000
14120	3NK5UeogWiexwKJ3NXeHHby5DiiQG9vPbJtjM6zXwdi2LhV1mat6	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1651	935	217	6301	10260	jwKrLa3pF3DTCnGBgDRZAJERfXCiDJ8iRWwM8zEn5ZBPZ4qyjPw	7217	10217	10217	1617778260000
14122	3NKHpGQxDE5SLsagBtt8Axr28wgoWVPSiHfUrGzdro4Lf9mP6dP1	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1589	1160	217	6301	10262	jwHHW5r3ZtdKDH5f27hZA55EfnfuUpjGi3oNbMLBJm3EcsceLYr	7218	10218	10218	1617778440000
14124	3NKDe9ukEpcmo5Ha45kBFty4MhR9MRsH47mqvpMtjVqkVSt3XrPY	14063	3NKEkuPqhKmot8hPEMJwYwLLuPQ9u1eBVrBcKTu7jpGP3EKLrQuh	1564	1092	202	6301	10264	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6955	10218	10218	1617778440000
14006	3NL2PK4BzDcPqTCo2zQp1mpyf8vLfZ6QwTgHiJ499WjCY4c4k2xa	14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	1403	782	215	6301	10168	jwoEAuMcoNVVAuR8K9qheZSfhP52FA1C14nQwsyzwcMUo9RBySC	7177	10168	10168	1617769440000
14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	14010	3NLSa9eSYXrS6bBDTr2iZK7J5BqXZCR8M8eK9mjrzW2ffRVmGtvW	149	1037	215	6301	10173	jwBZsZdZRsxVCN1sfcuGw5p94pvoYBDG3YGpqEHuk4aWkX1vZGB	7181	10172	10172	1617770160000
14014	3NKvySwBPX77Li4ctGi8kfaFLoWGF1tqvkY58Rs1jmFmDwe5FPmV	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1407	1395	215	6301	10175	jxprsE8mGKhR2e5biKPrjoCbWu3shKnM75td5NXksBFRXc12tM3	7183	10174	10174	1617770520000
14019	3NKMrfCzErKww3DzhJekQfuKFtjLhcz5YS6oAAoastMQLPs2ZPdH	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1634	1331	215	6301	10180	jxZuRERBB2zmv6Luk936nBcBjaHu15x7jFjSeFuzBJ54quPvmUG	7185	10177	10177	1617771060000
14023	3NK8mxPy5rH5g87PXH6Q4chmXiwrPkHNgx16XyYSa9wGL6aBtZMw	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1444	1381	215	6301	10181	jxMgGU21ehvcxcB4bfgBF12uQwze7PnCayKNPy7hNTcwj37dGgt	7185	10177	10177	1617771060000
14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	14020	3NLJYpKcCtaHwaVcdR9GCvg1GCQAj3xecTm3fqSrcnnb4w2kBLkD	1672	1285	216	6301	10184	jwTeSdKK31oYyCA8vuQRPZ2YXuL9AYL1ZLoAHrw6PBZ6JiFDDNM	7186	10178	10178	1617771240000
14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	1637	816	216	6301	10185	jxUR28yUMqjAqYRfzE8UCowB3LgDZh1vv8FXvhWU4rT357qLpzs	7187	10179	10179	1617771420000
14038	3NLAFptvuYYvzXSwqUTTtBSp39oerWFcmHFGjbEh9pxou6wsAsVi	14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	1607	1348	216	6301	10194	jx4a2WuNA4r86eqfgSWZV2tDVxjDChyqrgn6eR7TerqpBWzz9QV	7190	10183	10183	1617772140000
14040	3NKaZNFGFeEcn7eDqA7nQUV6tdDmv2DFJpahfEJRKwhD6ESTDFpU	14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	1406	1393	216	6301	10196	jwR1SKpg6ovX2DDpaG5gRgHwo4gw2jSQNW7tNwhFe2fkTMfR8T9	7191	10185	10185	1617772500000
14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	1506	1127	216	6301	10198	jwSAGBuHxzjHAaJxDZSRWyfd1kaecJaQsYyhkJKD6FHPHJDRHhX	7192	10187	10187	1617772860000
14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1534	1191	216	6301	10200	jxK89pmATR6AMHTfeedDb6hVCWkuBEhmSuuAwfEhpvwuVwB9TdY	7193	10188	10188	1617773040000
14048	3NL1XgrqZwWw98Cspf7wLULACCj3dS6Wj9rtzo62fgPfK1Mbfpnp	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1613	1349	216	6301	10202	jxJcQxKV68bT88KjKX24VxSDvEoE1MchWpohudfRnJvep7GC5vP	7193	10188	10188	1617773040000
14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	1648	1284	216	6301	10203	jxiziyPhVWkLGp6S7dG5cZ8BdiMmxStQqtJpzNZqB3H9qfjwexK	7194	10189	10189	1617773220000
14056	3NLTa3XsoMmQxEgVfZHPM2QeDyYXpjE2TuFzTTE8YQ73qdyGrJgn	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	684	1226	216	6301	10207	jwziUe86M4zo2VXv2aFeEGsmpCSKx1zkMmS8mD1rcFrMSHZz8my	7196	10192	10192	1617773760000
14065	3NKS5V6Sr3EfFKm5B1pFDCf1dPM45NzZ85x8ev3zq9W2Du5LAKUZ	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1593	284	216	6301	10213	jwu3DHUfWFYHUqvxN6yWGSZofaLdWApxDet8kRYgS6LrfhspdsJ	7199	10196	10196	1617774480000
14068	3NLDvFEcYJJ6SCyjB9ikXwACPEztuTfjG8kVFhKVtFbPdCJcENym	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1602	1369	216	6301	10214	jxsHQG2jwFyQoKwCVpsqaPJb2FveMxn8tzu9CasEGVXJnFufFGd	7200	10197	10197	1617774660000
14071	3NKqVBdm9j8NpfrRC7vUPHnbrSMtWGdErGVYaXdgQGG9xX6yFTAV	14000	3NKX5s792zci5Zroq4e98hWjzgNLiY6JDsVvuedsACv3wCzz8dYV	58	1035	212	6301	10217	jwf5qCFzV7SNvnQo6rHUxfEu6xGnT2Robus4FV9dfwwcUjmaDVK	7130	10197	10197	1617774660000
14072	3NKf6r8cMwMTQYoEwmhsM1mAGfM9KVNW53NCqq4QB42tCjbCdS9M	14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	43	944	216	6301	10218	jwibHVP4Twfmbqg6F6fwHDSdG1AGfeET7jF111ToeVJ1aGeWKi1	7201	10198	10198	1617774840000
14075	3NLPd62fqXDdpREzv6Laa3N9zRQePaMRjchgbMeMCKsNeLG6RR1v	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1536	1313	216	6301	10221	jxyHSQMjx2qzRGvtzn2DpKN9x5mn1mvhRgZTDoJZb67WPqxJeDQ	7202	10199	10199	1617775020000
14080	3NKbyfJvgJm43KYzTg5qAb28cuRdfJrupXEVxzWHFdUQTThTLmaf	14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	1405	855	215	6301	10226	jwFyniGK5hmoHgyA2k8GboccUcnuGHbYHghRTbNj2vQ7Xy6ZvS5	7184	10200	10200	1617775267232
14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	1407	1395	217	6301	10229	jw8D6o3zdsEwzMqnrEdpB7KJarn9RniXHZeDjjo6Ne9fG5ZphGM	7204	10201	10201	1617775380000
14086	3NKPAs7iejeHvYSS9DTHN87JNmGpGXpD5C5foDD6QYe3t4xxfAaj	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1406	1393	217	6301	10232	jwAJubshAdtGtWWSdqcN7q7T6VqpFPJX6sPXPB5pdUADhWC1JW3	7205	10203	10203	1617775740000
14088	3NLiYVguaYUtXDFkwT4bcXfzbxYLMqeRPnXeHAPBYPFJauxyyBma	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1581	778	217	6301	10234	jx3gFrg9gJWK4cs4TzaDKrLW5uxudKuUSRRJF8UbmzguXnSx7ti	7205	10203	10203	1617775740000
14090	3NLtanB4xYueuLfaRDGbZo8QcgTkQmzuwZ88j49UozNuEphV1mqM	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1589	1286	217	6301	10236	jwAg3uQjzvinihxMbpRXSHrhTBGiuq66RryRb7kvfigtehqVzpJ	7206	10204	10204	1617775920000
14093	3NKwCgZT2mVMVwkADHR4F2Ncyu49khRh7Mfgdt4zgq5zbxmAhQqG	14086	3NKPAs7iejeHvYSS9DTHN87JNmGpGXpD5C5foDD6QYe3t4xxfAaj	633	1018	217	6301	10239	jxdDQ2STpPs2ATRS6uGimSrhxvptSdhoAqaqLaGSkrAZeR35WiB	7206	10204	10204	1617775920000
14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1549	1116	217	6301	10240	jxUFoEDuC17a3pkNYcs7nnBjMv1AR5zoqMg2HHZZjB2ETqT5nVg	7207	10205	10205	1617776100000
14096	3NKPDTwYWrgEK3enpZwLvG6Q8MUy7dA4NciXshcFcACbhmXY6dH2	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1631	794	217	6301	10241	jwoxNhYSftkJq67h4aYKjv68HKQmYXuvHGRSdVc98RzJK6Exqaw	7207	10205	10205	1617776100000
14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	14099	3NLazUZW9Govqtza9znGJVhBZrK99vPJbx2sNs4xXgi8LQ1pZyWR	1594	1080	217	6301	10246	jx8HiLxbFxBgfiefmo5hFDo6pYzXQ6KEeTWR3g6gkfwJHxch9Pq	7210	10208	10208	1617776640000
14106	3NLKWX4x6CwAcxi8Lv3GNyDDhMgW4U7TXRcb3VVLwruPhZYFwgLt	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1652	1315	217	6301	10249	jxXZkTostWT9pbY3ys37M9R676WVsqLqRfZc5vKGRQDay8a9tfZ	7211	10209	10209	1617776820000
14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	1600	1372	217	6301	10250	jx4QovGaKSGd3fQumKcufDVG4ekb6NLpXSVg9k22ym2YDnfmz1t	7212	10210	10210	1617777000000
14110	3NLf5ntSo3bu9HazaxcMfJxkAsCcAWWwbmSB9iVYLxRhBfV4Kc1h	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	470	1309	217	6301	10252	jwc8rB5T3bDCvFQYcAS6GJ4QePUfEDAJfhhC59bPDuhRMehne4e	7212	10210	10210	1617777000000
14112	3NKCbVhcEa4p9Js4cphrnr2eErTMN8n84uULPxMdZXbLSrexBJ7E	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1617	922	217	6301	10254	jx27USunXr157nKt9C2jYoM4xFrJ9EcFWjJyFRx5ABgSr4RYRLx	7213	10211	10211	1617777180000
14031	3NLsWjBfKEiZJfEbkC8pUEPu2p2pVroYtby6K6M3BYFgRmXhwZXq	14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	1403	824	216	6301	10188	jxPKxSZzsRCaAVNnoxZFtNVJjjfGi6RzqgckeUq2zFDUFA4TnbA	7187	10180	10180	1617771600000
14033	3NK3APUPxtuWakMeeFQ1qzYdAJX25Xs4W2TSrn9YpAegNt6SMUpz	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1403	824	216	6301	10189	jy2A6WjU3nxUrgCKMsMAbmLSYTRvijZWgP3JTCth1H5HcETeJGg	7188	10180	10180	1617771668545
14037	3NLQwiZoYueLP1HH9yN5QxMEKmmdp8tsLrQTw5po72k7D8437UVA	14029	3NLueTiYZp8pnpkMN19JNFZbUgZDtfoGa3J5wRSzjpX5bAxyU4RB	1444	1135	216	6301	10193	jwh5z63pBQf8zxaKAUCpgurW36U1Jv8ERj69aaqykmwTxAKpJxg	7189	10181	10181	1617771780000
14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	1631	794	216	6301	10195	jx8DSTLHpqMfLJKVDHQL4FMkGb5hvMV7LfqCm6jg5mxsD9dfETF	7190	10183	10183	1617772140000
14050	3NLfaKNXaXVESgk352cN5FcEt1DnmHU633ZNs1senBbihmJqVKWb	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1634	313	216	6301	10199	jxQT98S89ZUY2DPDW7mF6gdt5aJ6hYvcqWjd1pS68vkvbnqiTYt	7193	10188	10188	1617773040000
14052	3NKuuDLdXQMwwgBZCxNWq6cSFvFYsghSZ7uaPdwiaU4pNS3M4B3X	14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	1631	794	216	6301	10204	jx5PGoxQQFAs3GQQHMjokyJjpLB632RbupUDyBfzWpvVcj7yUzs	7194	10189	10189	1617773220000
14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1649	1383	216	6301	10208	jwpPZ19MNRnpJzBcAGZVyzCtRUxSc36vwyoDei77L87YQWH8kro	7197	10194	10194	1617774120000
14062	3NLdfdgARLyQP5AdRVeNUiraXjahG4A9SUpvtFB42Kg8quBvTY7p	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1542	1304	216	6301	10210	jwBrk4jkYACo12Hram4w9quaVXh8h6oSALd2bPR5DfUc7PygcfB	7198	10195	10195	1617774300000
14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1631	794	216	6301	10212	jwGWhotqhJJSHzARUhQ5wcH5J1nHD2NuL4onDi1RsKWU6xNPv6F	7198	10195	10195	1617774300000
14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1593	284	216	6301	10213	jwPMo8yAjGy4TZjTSkSLCEdwAca127AdJcx3S8z4aAu3udCSMT3	7199	10196	10196	1617774480000
14078	3NLr1Kju9iLAfq5Uz3d4Eam1zvXighGZHo9mutPmnopdEaJBffS3	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	1405	855	214	6301	10224	jxEip17XsPXcPuq1kARTVbqksHfkeqVQo3dQUQpVhNE5DznHwia	7160	10200	10200	1617775200000
14081	3NK6yGRzHNUbFf4rYAD7QTpFwZR27V5y4ynyxtcqTE55v6XJN8tQ	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1405	855	216	6301	10227	jxTFAZxc1meyozuCRqZBrmmKirktJBRza8knnEEWma9eX6ezYp6	7197	10200	10200	1617775302004
14082	3NKtZpgvpjD4pJX1WrKcaFp1Vxw7TT7gYxE1X7m2gLbNVMK2kNJL	14072	3NKf6r8cMwMTQYoEwmhsM1mAGfM9KVNW53NCqq4QB42tCjbCdS9M	1405	855	216	6301	10228	jwtoTDAR8BvH9PvpnhXFUPASSdu7xH1reeGqKB3KDnyeJYXnvuF	7202	10200	10200	1617775334868
14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1624	1088	217	6301	10233	jxQwJZvunwwNuNE4h3pXvrkZ1jpJN42EifShEBBsfinMoPWuDCi	7205	10203	10203	1617775740000
14092	3NKzwNwJXptHojhjYmnNz56FvLdBvh3KD3p5zBt2tzekgXFayMk2	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	633	1018	217	6301	10238	jxQJSdG6us5zUZxrtMYj2o5yBwKZVA9JGtoUGaoNFcbUkiaci2R	7206	10204	10204	1617775920000
14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	1407	1395	217	6301	10242	jxRjDRGubBMMzYbb65FFrYmtqhED3cXmY9yjYGmyyH8RWRanhkr	7208	10206	10206	1617776280000
14100	3NLudZvrxqyC5Jf4uDpXSovEjQ2Re4oD9ST7VKHhk2EqhJezrkn7	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1622	1356	217	6301	10244	jxb4nZEq9rcAoqC498PfQwQDWJdGpRibnvmRAVWKWu84tmpfvYo	7209	10207	10207	1617776460000
14103	3NLWLMyvB9ago5pi5BFLHaCMM2rPvj9W8YtGpUdUymhEiV1FCzEF	14018	3NK3RZQo1Tu4fXgxK8Xp8P29x3KUxPi7YiDMDVsDCteNR65L24ii	1650	1249	212	6301	10247	jw7pSrFAnMJnzLeM9RQQkPchhukq3JgYj4KRKzcyBcGUymBEFi4	7132	10208	10208	1617776640000
14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1406	1393	217	6301	10248	jwxVnAabEpGAgtD4Mz3Y9Qua3NDM4SwMoxBZnPDzTMpDS2uNWao	7211	10209	10209	1617776820000
14109	3NKMWhBHaEGN1eQFDpj8z6zPGPLQaFAnCR91PzaiXwDT5yrCGDTw	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	470	1309	217	6301	10252	jxhs22VB6CFWn4X5dbQDN7s6vZfkKehSzjLupFtMxFXjt69NaxY	7212	10210	10210	1617777000000
14115	3NLJBYsK7YnMWxMe9SSvTSSzHdhW2VmtMody1LcJvr3oYRWpcdBC	14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	1559	1107	217	6301	10256	jxJQfFQ1UXtSYSgsnvcUt4SM43dcXJUU5eouR9iSodrUUjBceyX	7214	10214	10214	1617777720000
14118	3NL9qXCekv3ft7dM2dqGsfMZxjV1wGuzXQGeAirPbSWDdBwSE6BG	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1627	1385	217	6301	10259	jxd6j6tJDbPRnitJdVoLyFSBibYeWNXN4Yqnsq3WkVXpzTrji7C	7217	10217	10217	1617778260000
14123	3NLQRj8psG9iEH2yicViietBLJ6SNpW55nbvokMbcvPJJeFJvr4M	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1594	1080	217	6301	10263	jxepivmdoSagLurSUG4WpL7gJyA2t3noQu4i5henUA7yS1rdAd8	7218	10218	10218	1617778440000
14141	3NKJ4513fR1bbVmWQf91m9tmubZNNCL5BZ6f8E2gcJBuMQDz91bJ	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1642	1001	218	6301	10277	jxpedXPg8zbmq33mBThGT6nvTJhJFxfWgnMhhSq4GbMfkR5erB4	7222	10225	10225	1617779700000
14145	3NLsDcR5r1hyD7YtzYALBz8Yj7nT9L7rqndZaj2LXKX8uou5wgHd	14133	3NKTWHPLf5c3af12HdDP2ojhUN4WWzZd6BcF6CMbMPpU3kAKTPKw	1508	1021	218	6301	10280	jxR64G7vJrfyna4jvd5HBk6656GWK2QDUDrnhiqzjAVnhP2NWin	7221	10225	10225	1617779700000
14146	3NL77c1uJ1Q5WavHbPhrKBgpk3HuWYFiXhCtEmKRqer9tQqFmwH7	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1444	1135	218	6301	10281	jwC27PPix6Rc831QUCXUB2AqSgddLJXaUsfYtVynyE8jWLJWzHF	7223	10226	10226	1617779880000
14149	3NLm26Pz39y3omqckgeqcdqudPcb87F7taTGYFPAGL7J54k62Ahz	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1541	1298	218	6301	10283	jwLKRrJACVdxBZKgK1emxXf1RJNz8Lhjt3DoaZbqGawCXxD6fTo	7223	10226	10226	1617779880000
14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	14152	3NKZG2wUiphir5Muc8VQ6tBFHfK8sBR3c2GMHb23TCdSiWiT4a3g	1652	949	218	6301	10287	jwoY5ByGP18LK42fWtefBDnAHwhm3jifNAZdVSUgExWpBVSihP8	7225	10229	10229	1617780420000
14156	3NLgm85QFn5MV9c8ASHGfrCDuQdgkupFWy4DbVsf3vUAiE5Uk9oj	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1451	1046	217	6301	10290	jx8EeS17qN757JmHkh2nBa3pxzpae4m6oe26pHp61EmaigLEcQy	7209	10230	10230	1617780643035
14162	3NLvWUXFwZQyAL3ZVcbbSASVa9WWAYP1bdpXtAdzzdRnijwcnimH	14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	44	1199	218	6301	10295	jxFV5J7hvqZafGaQsbjvAGpd9cd6jN22x95jLkdea12D9D9w6gj	7228	10232	10232	1617780960000
14165	3NKY3CZVqC121G4nRSFuqDX1Wnsh955vriBj6NqAVxXMmVJiswgn	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1407	1395	218	6301	10298	jwK7nbVkitJQrtZbkCffyaTJK1C1cFyWWgm4wRD1xLnFdjewLwQ	7230	10235	10235	1617781500000
14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	14169	3NKvJ7H6yoqjTi1rVqdP9BZuXpQ75KRfoB2UYpQFjzMiKfGAGxni	1619	1275	218	6301	10303	jwJRki13dXRXJ1CiaJJbWcQVtJmL4PybgSrZ3TtACXcNDG3X6Ad	7234	10241	10241	1617782580000
14114	3NKkx8wruPCgHyWrBZKCWVHATmk4RYpDweF2W8yT3kcYRyjAuAsd	13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	1559	1107	202	6301	10255	jxHTrz3kjZ3LSfGFCp891NQuiy6oVfLowQG72aVrr6tvQcAB7r7	6960	10214	10214	1617777720000
14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1651	935	217	6301	10260	jwWyGCHDRwNQQsgA5XsFK58k7SFj4V66Pr3kc8oSEsK4QLySdED	7217	10217	10217	1617778260000
14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1547	1378	217	6301	10261	jw7QUXwGwKaxwfSK2cpPv8uSMy1xrgeZXUFerdg6mUJTckvF7wL	7218	10218	10218	1617778440000
14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1402	852	217	6301	10266	jw6hfFR1XgYZv1YroYz4wCuxxywvFXtaDq931uaUJFn5Mg5DAWW	7219	10219	10219	1617778620000
14128	3NLDR6az15bMDghzQpytyNdUorP2QdCNf4jzwRoA5S417MJyGRW2	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1637	816	217	6301	10267	jxHR6ch8eeA9tbbM5HDAhb4HPcXE4pTLTp6dqS5PJn39GXmV1jF	7219	10219	10219	1617778620000
14130	3NLQWf4emsoWqnL8pxHu95fmXCRpg4EswJaZ2qQNW8w3CHuNshba	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1445	1290	217	6301	10269	jxPoosRkUp3ZeyaHekS9q7LAfkbnLejdYvXsgnwSmfc7z1XxQSZ	7220	10222	10222	1617779160000
14133	3NKTWHPLf5c3af12HdDP2ojhUN4WWzZd6BcF6CMbMPpU3kAKTPKw	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1483	551	217	6301	10270	jxRfK7XsizCLndd2ENU6TLGX7j26FygeiLaaDSA9eCHynwhXvWu	7220	10222	10222	1617779160000
14136	3NL8fL2p373ja4xeqwp9MgNd1tMWbSG4CGi4jU1rC1V1hXSM1RRU	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	1607	1222	217	6301	10273	jxFaqiWGh4DzmgNwNwJ5APTWuVkeQJMBYhM2bMFQAu3sYjDSKqV	7221	10223	10223	1617779340000
14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1451	1292	218	6301	10275	jx97LaFdKPiokHToR3G2t2BYoy8KLms39qTWKAMtijtqXxcfRJm	7222	10225	10225	1617779700000
14143	3NKFuJzskg8AdWLxnuXT4dCfG9PTgbzDhZHSxgvEEYpCSD83Jdfk	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1539	325	218	6301	10279	jxoSnth78HyMNFPnccSdJaZczU31rUxWrxQKrKSpW8PZohin2xm	7222	10225	10225	1617779700000
14144	3NKWwsD1zVjjh5e35JADFbosFHRWxWAhh7eCdyimYTjnwPzxxA2K	14136	3NL8fL2p373ja4xeqwp9MgNd1tMWbSG4CGi4jU1rC1V1hXSM1RRU	1508	1021	218	6301	10278	jx6DBLpyxAuAmzp729YfHaag5deomrjZeR29szdLPdnYNCULCFF	7222	10225	10225	1617779700000
14147	3NKUSyeiECef6YSrQrjj2xn95nQQg42WfZDVtM794Af5ZUXNLui9	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1613	1103	218	6301	10282	jx9oujs8jfSEd2BxXvZ1zRFuC9TrStJDZhmgS4CeBndUXk8GbAh	7223	10226	10226	1617779880000
14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	1451	1046	218	6301	10288	jwoQKKGstHwDDvMTvYqF5GAwT5hvFzxLxivpNj9at6seH1Vu5sr	7226	10230	10230	1617780600000
14158	3NLqBzu24iYsyAjxuY7ZkNxhmWX58FeTBep2xTJMjJnB6s87SHYv	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1451	1046	217	6301	10292	jxknQAum81FTCrtRR6iBtZ1dRXkvRx5aZYcvp8kyChDeHuAZcrp	7219	10230	10230	1617780684715
14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	14162	3NLvWUXFwZQyAL3ZVcbbSASVa9WWAYP1bdpXtAdzzdRnijwcnimH	298	357	218	6301	10296	jx2X1vo1BwysFQs7MNbnWkjKz9Ms6GjfAGZedkqZpCbKCuUfj9S	7229	10234	10234	1617781320000
14168	3NLeEbK171dHWMHcw6HGyJro5rzeCtBUsM5iNdHbxiEk6XnPtvaj	14167	3NKRQRFtQKH2s31MEBpHgnNMfBjY1yUbxUXcmGnEyk9S8SXiLd7g	1668	1004	218	6301	10301	jwz4UPjmqADq3mo2V1kLFkStopXTBipBwEfTDa8Az4Lnf5KXSMi	7232	10238	10238	1617782040000
14171	3NKfaie7MAUF8BUsDBx99hx26rCiZaMEB2M6FjuPyFpLoYxBJvsX	14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	311	1307	218	6301	10304	jxLykon3Et2UHqZag9iBAkz5s3Fe4G5Dk7han9LQJ8FxkbUCiE4	7235	10242	10242	1617782760000
14174	3NL9gFLXpNB4Nv7NTHPREw1juF4z7BfzaPFWofBRVkiZPdj5pNCS	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	576	1355	218	6301	10307	jxoEu4J5bRrjhPPCtpwvk1z1tybxcd7fcQnnx3i2qj8XKcvQBSd	7237	10245	10245	1617783300000
14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1471	1140	218	6301	10311	jwBHqMYMYcJnfFXCfJTNV1uRf823XJaAVZq71JpxLPu4THAQAtb	7238	10247	10247	1617783660000
14188	3NLYZJGaZd2jWZxLv3afExveDEXWUfUPz2zJG2qjZDwkRVYmB1qe	14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	1403	824	218	6301	10318	jwXyqHCy6jATkZn9roToFhwSpzAz7Y5ta79BXUk18iQUkGtpECQ	7239	10249	10249	1617784020000
14190	3NLWsVfKBdLgVuQSbgntjfwAaGyZKPjVesaLpeKXQpKni4KbaxFi	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1448	1311	219	6301	10320	jwxye9H6Nwi3kt8whWKsJ1eqsMpnE3dEWHLrPuLSUWaAqjuKAbi	7242	10251	10251	1617784380000
14197	3NLENQ4NZrrX3zGaKv3ZW88ooKZvAkSEpGCSHmJbtdxUcuh9yoFp	14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	1670	1282	219	6301	10324	jwiWeA4EQGNbre5VPRwD1X4h5tVAiY12CHsuDuHWtSVUzsmj2ai	7244	10254	10254	1617784920000
14200	3NK4oPEiQhhzVEe83jJaR6ktvd6grqspF7vFJnxJofgsVDWPZM3c	14199	3NLsrqcBQTGx91EPPVmxbBEMySwBs6EdFavFMrpi99RNn9QxXPMM	1407	1395	219	6301	10326	jwySc7Zi3VGWrpL7PQqtFewgYmepAEN1y3AqxcKaRYScn8eXEJk	7246	10257	10257	1617785460000
14203	3NLT1U4TEoUdEf3pHBLKkePohb8nfDNkzc3EeU9rW4J8rkVJGuED	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	1406	1393	219	6301	10329	jx2XgU4Qdosnwng7qDFGo9FY8jyDV1XqJrNSeTY8xvH23jKTn8Q	7249	10261	10261	1617786180000
14215	3NL6AndpkNFRosoyLmYeYsbZXZJgbDSbthCAeevg4srEPKMxcwLA	14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	149	1037	219	6301	10341	jxRS82KkU2Y6Kr9jHMpRgui7iuMbPCt5CpSw8YEmSGoVAnSGpio	7256	10268	10268	1617787440000
14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	14219	3NKMBfVKYFbyT75eKcq7rBNFpxsorgjWs52SvvYqE7AzoL8uruKB	1403	782	220	6301	10348	jwFpdvoZxZhrS3vktZY3W5uFXq45wK2dr95BMFZqbg4bYT4YDgi	7260	10274	10274	1617788520000
14225	3NLDfmpdLgtiJtg8YcoQCVyeKU3oU4QsodZpvZU6xtKvTP4z1aPf	14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	1403	824	220	6301	10351	jwKJtbdCee3AFhhkKYSdkkpdSvDcwTr8E9zBdot82Jm4wfhkZi6	7261	10277	10277	1617789060000
14235	3NLvj97BWHDzhDaFGKh4Mg6rvWZkZ4Hb2C4QcB8vg5AvuqSWN5L3	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	1406	1393	220	6301	10360	jxWBGb6GKte42ZM7WfyMxNqTXMeW1NPaAejz4ZqhXVkB2Gtzs2T	7267	10282	10282	1617789960000
14239	3NK3BcU44ZLyxoKTfaqAusvp8SU3RLrtnMkdzGG5VSfQdE8gofd8	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1506	1127	220	6301	10364	jwbTq2k2fNywLy3Sppv83vP3b9mySfpv6s1MUEgusxBU7Ap7Xmn	7268	10284	10284	1617790320000
14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	14240	3NKYNBHvoAG5UHZvPHPwMMJrbqmhhYVGYwS1VnrQjeXn3cwFoV5o	1402	850	220	6301	10365	jwAoVmYkzgg93Dx4H2Uuse9D7bkezAYGzh9Z45CTSZRwCFybQbL	7269	10286	10286	1617790680000
14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	14248	3NLfna9q1Q8EY6iuqv2kPdR2meMFT7FBrL9mXcBPdNzYRDFDECQX	1581	778	220	6301	10373	jwAnJvpWLQDg1JZvazfFHkxcMNNY7yGnAi593dEQBkjuuqxniKX	7275	10293	10293	1617791940000
14252	3NKjJHQWcrs6X9e1vGXZtBfduByqCv6i3TMrXA7tAZdUQNmXxzwV	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1490	1274	220	6301	10376	jwzaNgVvNm8acJqXJYWxPj5ScCjyb7FwEq8Ybnv9BRcynxJpqE9	7277	10296	10296	1617792480000
14127	3NLLH34oVUEHfetyVKCgP57grjfjMx2DywWwm1eGR7j4W5fB7Bfb	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1422	1211	217	6301	10265	jwrKJgouqgsakpNcisDNMPH9mCJQvSWVqThkCsigktRF8DKuLpV	7219	10219	10219	1617778620000
14131	3NL1c7rydVZu84mc6NmZhutUjTaeBu2xhnL5n8KYSKUFLgLgmca4	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1483	551	217	6301	10270	jxRfK7XsizCLndd2ENU6TLGX7j26FygeiLaaDSA9eCHynwhXvWu	7220	10222	10222	1617779160000
14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1577	1327	217	6301	10272	jwU7gnEgdeF5fkGNsbFd3SmzhW9t1aC2xiQwPy8cMQXyVtaE1RY	7220	10222	10222	1617779160000
14137	3NKtyFEoEPWKtCvJM4jVxfKphxdH6ovAfvMNWPyzn7Z4WiwKFsis	14129	3NKdZDged1WQjxpms1E4BrSRNQa7keixY58NfcDyr7ZpM17zyQGM	1406	1393	217	6301	10274	jwwSUhQv3441gswPMehKX7R2SBdRHfuWjDtxjzsS3nFv7VBnX7b	7215	10223	10223	1617779340000
14140	3NLbpPvULJfqdHrzkMnJWgDEBJ66dZdp9iWWh9Je3fUtukBgH7Kc	13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	1451	1292	211	6301	10276	jxHVKyiMs4UEqH9eFsYNzc1R73kHctaVw8q8hkSemHeix4t45e6	7110	10225	10225	1617779700000
14148	3NKnYb7yuGaPvT2f1HpjKQJA7yyW5ZxWj45WgAnDjr9PRvgyR8od	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1444	1135	218	6301	10281	jxJ3ZTE94nLfqgNM69AsF3x6kRH9PRw7GteHdYfcWG2WpLFpcjf	7223	10226	10226	1617779880000
14152	3NKZG2wUiphir5Muc8VQ6tBFHfK8sBR3c2GMHb23TCdSiWiT4a3g	14147	3NKUSyeiECef6YSrQrjj2xn95nQQg42WfZDVtM794Af5ZUXNLui9	1637	816	218	6301	10286	jxmNH6vAQbiogndbxBAppDQys6eYiYGJbuAf21uqWn53W8CkRQ7	7224	10227	10227	1617780060000
14155	3NKobMTu6iyc6S2ic3jStuo5GFxzy4gc1ckxbodRAxpNsVBV9cMi	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1451	1046	216	6301	10289	jxEVMfh7duA7bXB4eMVeJJSAuzuVcD84ufvVTaAHekD4Q9YHsjN	7199	10230	10230	1617780600000
14159	3NLaMdhCnuzj3KMg7UKDhSu2snaWE1cRHtJxuWAk1Wv47d8RYMMX	14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	1673	1122	218	6301	10293	jx7hj5gebekBLsmwG8taPXt51uvqKpC6BBArWwo3s43gRqw3TZb	7227	10231	10231	1617780780000
14161	3NKzdaKqTXXoGra6AAJowKjHf7Lu86k9mQjGW1KEsDve5AfmvQfS	14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	44	1199	218	6301	10295	jxVpTwxVxMpoCqqqJD2pR4EjMjPMp6h3o18Ht5DaJqFkrv93RkQ	7228	10232	10232	1617780960000
14164	3NL3NTHGDJ18yaAARzhBdNcShueY2V8SU38gDicBxTjUbatiqMBT	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1546	1213	218	6301	10297	jwba3rwNTgRoUbdob3maF8ASexiWbNPTGXTQxP6yVTAenfsDCZW	7230	10235	10235	1617781500000
14169	3NKvJ7H6yoqjTi1rVqdP9BZuXpQ75KRfoB2UYpQFjzMiKfGAGxni	14168	3NLeEbK171dHWMHcw6HGyJro5rzeCtBUsM5iNdHbxiEk6XnPtvaj	1637	816	218	6301	10302	jwPpZ3PifQ5hhEF6vUdyybyAHowd47boLxqf7CMNCoRMu2pDj6w	7233	10239	10239	1617782220000
14172	3NL5un3Co8P1G2S8LMhgRHhcF8UGZbCj21JfQy19VD7RS8FCwswu	14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	1524	119	218	6301	10305	jwDcFKkKWZuPWo56TwNf6mqcnLbgsVxzmWPGqGS1UmbGKQJbxqF	7235	10242	10242	1617782760000
14177	3NLWehuDvNo9g9u79xTUq59mFEymxA11sbrLs1iY53oAF3ZH1Tv8	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	1471	1140	202	6301	10309	jwe5VhALRpqPDc9jS1gMbzoARZ1jDHZt3EhA5snEJuMum34woCa	6948	10247	10247	1617783660000
14181	3NKdJZN9oLwBU45TLotTsRBZg2Aim46sCwuozYAvB2ZznyFqgwFu	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1599	921	218	6301	10312	jxvsaiBCKtJnhsdtwPvEP9SHMWu9eTLu4KKtgjwYyYQokPdpWdH	7238	10247	10247	1617783660000
14184	3NLKN3SMQat8i6cnvtDbLmaHt5cYMayqRmcSuni8BjPiWuKF5Rys	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1637	815	218	6301	10314	jwzRowgzc1fpwKG4dqYjmnBun6kGHjaZNgaE5aELhGxD9QmbdVn	7238	10247	10247	1617783660000
14191	3NLw5XXzW6ZawbZZt6UrzbYndrBGtn8Gv6ex3Hfukt1eM21XeF65	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1448	1311	219	6301	10320	jxpTew9Nb5XZE2twSWVDYsmA7DbnZ73bJZ52DN4MNZNq41G92uK	7242	10251	10251	1617784380000
14194	3NLLUU7VKgDBJcgxJTfytPn5QZoP8NJ4uTrGFyjPAcKZQC9z4Fff	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1622	1110	219	6301	10321	jxpC3fxAb6QCJEKsCcgWwxTcwGfz3HeBRDZFVTsKy4DHj6GKWU8	7242	10251	10251	1617784380000
14198	3NLiZggj5xRjP1PUyad1YWxUKJHz6KMkMfDgHYKLidkvHicqSYAW	14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	1670	1282	219	6301	10324	jxACjuYP8L6xqw7jkK3a5stDWqDPEBAptHc63SmkRwXyTBTEJoi	7244	10254	10254	1617784920000
14204	3NKwHhfgkwbJydy4Qxa9m992Um3GKnje48STuFNPdGFTTE9rizxn	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	606	1295	219	6301	10330	jx6Sguv5EiQ8u1nzQWXgYAq9EimJS7VyRZg9oS7MgFJ9tsWTRnd	7249	10261	10261	1617786180000
14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	14207	3NKscVJ91xsHoNoD5nNmaftaJnJmuENqGpZme3AtVR9NhTSwA3ai	1407	1395	219	6301	10334	jwaJdUsCNLKsoVBUzaARN6q28rXnsDpJ56qnSQfGhVQR52oiVsL	7252	10264	10264	1617786720000
14213	3NLWxyzZ2hAyBjhmbFkYpdtxFQn9NkwQdDUzknvj685MmB8kygf4	14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	1444	1381	218	6301	10339	jwBiDov7yFuwP62jMviRPtrqwXJxq5UUj6dsLNr6DHnaMxVH5Qj	7239	10267	10267	1617787260000
14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	14216	3NKyxbUhVxzM1hHnFgkrfH7zEUzwPpAYqeMYHoSamCHiCUh8bmf1	1406	1393	219	6301	10344	jwL17BGDVN9NqURzSG4TbVejJ4jFAbjKAMYyjdD9Cw8RCbT5FZL	7258	10272	10272	1617788160000
14221	3NLKJrmWrMNXoVuC4GdsNsnchLQF8Wvgye4gozQ2EYeBKWw2pSVJ	14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	1637	816	219	6301	10347	jxZ9oByXHqa41Ht52euG7iaw3QEb4ysbPwdStZP9vxyP3Ti4gGx	7259	10273	10273	1617788340000
14223	3NLK85dNgMMvH2UX8hfxkwgtgZH15PgceXNbYy4oQVzs5zgZapNp	14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	1637	816	220	6301	10349	jx5RnfSao5GsJY5JtyJQ7BEWgXLKiPH87JtsRHiMbWPNPqtuUK8	7261	10276	10276	1617788880000
14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1440	1377	220	6301	10354	jwu5QLdEeEeKF9HyPCMFzuZULfjQrhdiebd8quoMC3SgSKjytQ2	7265	10280	10280	1617789600000
14237	3NKsENGLhzeguB58zrqMZ9zF899RGVFEjVvxasFtxL5oTbdcdxt4	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1593	1220	220	6301	10362	jwyQeJ6eLHvm1XfLcyB5cjvtR6YdDxysrv6kYYpUkPng5Xuv8VJ	7268	10284	10284	1617790320000
14243	3NKUMmBSqDatmYyMAD8rGvnimYtSu1avNmcJxrsesAGqTRbm3whD	14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	1637	815	220	6301	10367	jxZ2AVxkzC6eczXN9hbsm7ewjuqHnLZmR8pE33Ri3J43i2bn3EJ	7270	10287	10287	1617790860000
14246	3NKXYndrD1pT4c145UswvtdwAET4hXyRpCoqmkL4f8nNuRQHQUAD	14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	1553	776	220	6301	10370	jxnKqViHMhUWB9eKgCYrULQdnKzvpWkqLynRkX6tthJdQ8NUseG	7272	10289	10289	1617791220000
14248	3NLfna9q1Q8EY6iuqv2kPdR2meMFT7FBrL9mXcBPdNzYRDFDECQX	14247	3NL2d5GYZs1ZKCXZV5YRBs2t8VzNVoBF3K61a5KTQtPe9EjSoGiq	1407	1395	220	6301	10372	jx4WtQ9aobZvTni8K4VhvfSGSQdTAH34xpugq5tfg1odbYtQGqt	7274	10292	10292	1617791760000
14251	3NLcjZ8nego175Jhg9eywbuRJH1UyepJsTJEskbtQM3MZgZhrZbN	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1407	1395	220	6301	10375	jwqbPMK9Hgna2ZorLyua9eqMJHemk3om49UgrtJZLFmbhBG5nns	7277	10296	10296	1617792480000
14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	1622	1230	221	6301	10381	jxDypYHYg2gEULSbdcszMC3rU7mUU3Hex5RGLxfWrxoFL1sQsKp	7280	10300	10300	1617793200000
14135	3NLMZ6iNo4KffTNK8Q8XKpgA5DftCyyskfA7BAsHaBYShpjv17EV	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1577	1327	217	6301	10272	jwU7gnEgdeF5fkGNsbFd3SmzhW9t1aC2xiQwPy8cMQXyVtaE1RY	7220	10222	10222	1617779160000
14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	1607	1222	218	6301	10273	jxFaqiWGh4DzmgNwNwJ5APTWuVkeQJMBYhM2bMFQAu3sYjDSKqV	7221	10223	10223	1617779340000
14142	3NLrN3B45v9SkSzkxyTqJg6TMG2f6MVKN4K3akoZNLxCoxF7NN2p	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1508	1021	218	6301	10278	jx6DBLpyxAuAmzp729YfHaag5deomrjZeR29szdLPdnYNCULCFF	7222	10225	10225	1617779700000
14150	3NKtMwmMfKJU22qN62tJpcoHRtJ29ew2sEK95zv4GdPLESAyenbk	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1633	1024	218	6301	10284	jx1Lp6THRzWmBQd7NgL9g5B6u7goQVpQeShmtasy5a1nwVjRR6t	7223	10226	10226	1617779880000
14151	3NKqNwjHy94vqrFrw2FH6f9fD7keWC61YzV3rsfDVcg39GMsMFeW	14149	3NLm26Pz39y3omqckgeqcdqudPcb87F7taTGYFPAGL7J54k62Ahz	1402	874	218	6301	10285	jwXcfnmtMWEVEvfMmVK27hv1xk3uaJNUVPSqMAULmXCUE53Div1	7224	10227	10227	1617780060000
14157	3NLZXP4mtfQhZLGwSjGiV8ZMpbwszoaXNHPEREa579fwRtqnZSsY	14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	1581	777	218	6301	10291	jxxC6HwgNSsPkcG7uZicx17uNHGxymc26FnY5L1DQxB91yoQKT8	7226	10230	10230	1617780600000
14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	1581	778	218	6301	10294	jxHoH3Vtwefu97suvJg12FcSrBNiioobJ1bK5BNvjxRqnu8eStf	7227	10231	10231	1617780780000
14166	3NKnt7Zobxn22MjiV5QgKF3SafcJY2h7Syn55viyubfvQAc23A7x	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1573	1318	218	6301	10299	jxrVnomK3cyku3CyLs46agD4nXKDBUJkzCHzBCifXA1zPEdEiJm	7230	10235	10235	1617781500000
14167	3NKRQRFtQKH2s31MEBpHgnNMfBjY1yUbxUXcmGnEyk9S8SXiLd7g	14165	3NKY3CZVqC121G4nRSFuqDX1Wnsh955vriBj6NqAVxXMmVJiswgn	152	1330	218	6301	10300	jwA9xFRMxdQrrRrUnReSpqDFDpRdkvKhAgh28isiooUv4v4P8kg	7231	10236	10236	1617781680000
14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	14171	3NKfaie7MAUF8BUsDBx99hx26rCiZaMEB2M6FjuPyFpLoYxBJvsX	1549	1116	218	6301	10306	jwRo8yjvBFxcXqHTwxvYy4YPKvLXR8wf3x5SoZGCUSjnJVDiypW	7236	10243	10243	1617782940000
14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	1461	1271	218	6301	10308	jxebi3og3j3mt77g45uXKkeuAqkus5yzoiPpgGR6qsAKBs3sBAg	7237	10245	10245	1617783300000
14179	3NKdPaUbEFNdCFMJ3o5W5Smrby8iXN6AG8LaEfdr32rCHCK4zU2G	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1602	1243	218	6301	10310	jwMXqHMF3o4vis3tzVH4bKwC5Gsj3eAG3pXyrdCBPi4XB7TCN3W	7238	10247	10247	1617783660000
14183	3NL1HingZAnuuag3Vx9h4cwqQ4s6VxnQ7p19iLRcD9hyenycRfr5	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1599	921	218	6301	10312	jxrAfTvVuvAe3McPasRutppw4e9899dt18yTTVrRNbe6ZFSLoCw	7238	10247	10247	1617783660000
14187	3NKtpp4Pxzk6qtKE3eGhnFZaFCFuC8QcgX6mJXGzY6gXPDSsYDZ2	14186	3NKtiVJhuhppz6NZM5vovKdg794rai2n7eru3TaHuCyREY5nF4av	1406	1393	219	6301	10317	jx93jDkRzHB5iZpZYWmPZcKTqZJSN22RKkuYah6wGPkcwBebege	7240	10249	10249	1617784020000
14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	14187	3NKtpp4Pxzk6qtKE3eGhnFZaFCFuC8QcgX6mJXGzY6gXPDSsYDZ2	1407	1395	219	6301	10319	jx1sjTy2NA4Jfy55ePTAQo6SkkTPUvJC8XoeZCMTzRcuJVnCk1u	7241	10250	10250	1617784200000
14193	3NKitN2W9S6JSqdwZ7qKN96HZo8AGds4oo1CFW3GkiCPZgCQYxRH	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1440	1131	219	6301	10322	jwJBsE7kxBfhvMRJ1aQX4S8R5J2PDFfFYJL8B8pLgwuBBKxX8d7	7242	10251	10251	1617784380000
14199	3NLsrqcBQTGx91EPPVmxbBEMySwBs6EdFavFMrpi99RNn9QxXPMM	14198	3NLiZggj5xRjP1PUyad1YWxUKJHz6KMkMfDgHYKLidkvHicqSYAW	1654	1094	219	6301	10325	jxve7V6Qj3u1mqBKdoMx7Aj6fjCVASnr4NqJVKznwwZiuo7MvMV	7245	10255	10255	1617785100000
14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	14201	3NL79Garmviry9UdHWaVBwKNhpFr9rhha2GYkXWLqNE8TZePEzzM	1397	838	219	6301	10328	jxZXBz4vSMqTfpU6v8bwtThcND4tX34ykFrwaNpwGE3i18CZHpN	7248	10259	10259	1617785820000
14207	3NKscVJ91xsHoNoD5nNmaftaJnJmuENqGpZme3AtVR9NhTSwA3ai	14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	1610	1188	219	6301	10333	jwGHZQzQJKqGQYdNsbpvFbRmGERQANHDhpn9ipzLbamhyG1qHk7	7251	10263	10263	1617786540000
14210	3NKU7PH8nurKTAFkwRPbDkU1GTqDSgpz72TMP4XnuVoFV6WsZJsc	14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	1406	1393	219	6301	10336	jwxMeep5Q72PPwUbufv7oYaPQSbYFrvPQo53Ek8AtuVRa3CVat5	7253	10265	10265	1617786900000
14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	14211	3NKzgrKQEGqZyAie6EKKfMgbU2kQRqZbK92QDVscQLQ4hZ2WKsqC	1444	1381	219	6301	10338	jxY2oGiTNL7TCVyEomNCVhRait5H5wLDArsy1u24KFNpKjkduGP	7255	10267	10267	1617787260000
14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	448	1305	219	6301	10340	jwppH9hwU9E4qtxEysGFjjyxp2EDd19uFcwcas2pnaYnT4vQMSe	7256	10268	10268	1617787440000
14217	3NK7a2KpYuVM6cX3mGTPBREEVjkXACSpFUp8quzbEky9gNemyzSL	14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	1406	1393	219	6301	10343	jwGQ5XXUaJd8a1L9PdwxCLTAyBZWAt5jq6Lr99bysedq9HV2xSP	7257	10269	10269	1617787620000
14220	3NLM1DDeY3i1PmVYXDYQFSvR8ZgHaGHDvDKWTuaFiCPXh3QyKzxi	14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	1623	829	219	6301	10346	jwiRLLR8zT4SUSf9DwbSkGkqvTRXinT8vvPT9rgDctbJ8hsKV5e	7251	10273	10273	1617788340000
14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	14226	3NLjn3VgyTkBrWoPqEwQ4oXqRNqZikJmRUVpxRKQxu8Uax93r6QA	1513	1013	220	6301	10353	jxTB5BPh8ipzpq44Hkd6h3uTc2ByDTfzayRDMZCY3YvqcwpJVXG	7264	10279	10279	1617789420000
14230	3NKLRirJmV8GFyfcWWzKeNgNToBGkaE16En5uvAnFHrd6qKmbemy	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1651	1301	220	6301	10355	jxv99ZxFfq3CCfqqM9by3WnMsPCnnYuuakZtErphjEUePf9qdD6	7265	10280	10280	1617789600000
14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	1406	1393	220	6301	10357	jwmUt67y7SEendZ2GDFmCSw1aEYQSBw1VFAtPLCcNP1T8YsHZ3c	7266	10281	10281	1617789780000
14234	3NL4EXhqxDpW7JU9Amy2JMTVC4ru64z9vjzBJR2QkmuRwmz74ks4	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	58	915	220	6301	10359	jx4AhzyoiNAJWW5BsSFEVSyUCUkGJgFA9xXS4CzCw42wq1PUosR	7267	10282	10282	1617789960000
14238	3NLYg7gvjviziGeo9CLsejZ3RfGKp6FDqEKbAQhS6GvpoB9jEM1g	14235	3NLvj97BWHDzhDaFGKh4Mg6rvWZkZ4Hb2C4QcB8vg5AvuqSWN5L3	1506	1127	220	6301	10363	jxZEQCUH59bsXvomg3qLwKd5sZR8MHpJMwCuKYXfwiYKpGbcMvS	7268	10284	10284	1617790320000
14240	3NKYNBHvoAG5UHZvPHPwMMJrbqmhhYVGYwS1VnrQjeXn3cwFoV5o	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1593	1220	220	6301	10362	jxo8ffD3ShrenjFwU6aGAPPbMfoqjSqvoLzu4C78xiQktCxZuSH	7268	10284	10284	1617790320000
14245	3NKKnYc5hNt6c9mVfEQiXGz3WHhkdGi2yrH78bhSbNUmESihzViE	14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	1619	1029	220	6301	10369	jxtA6e1cuZqvACNy9rHaCsEQ4MdmpUwxBrmGBsYTug8xwmBRfYH	7272	10289	10289	1617791220000
14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	1631	794	220	6301	10374	jxry9rv9E55Xb2mXXfeebjv5whh5TPyGNbAQuYEYdJj29v4W4VN	7276	10294	10294	1617792120000
14175	3NLvgYoWacZZtiYQtyMEghk7gejrLpRXuZj6y5TuxQETU7hfP9sZ	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	576	1355	218	6301	10307	jwE7H73Rfqa5USy9Hsv9SP8yf3msWV7MM5o6CYuska6BwXJrcgn	7237	10245	10245	1617783300000
14178	3NLEr8SkHsrodmMESug3NidQdqVK91hfruykYMEgXwdAP3sUwwSr	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1602	1243	218	6301	10310	jxNtFMzyRxQVyFe8vnAbbXAiA4SUKur7ijuixaktqejcgQVmbTk	7238	10247	10247	1617783660000
14182	3NKzuBh9AsrR5Rimwdn89B7d4yZX836wQctgBG13JQ74q1txy9KQ	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	42	1361	218	6301	10313	jxvbYmeMgJYuUUnjFL1QAhNV9SZkAWPB3TCyiKMn82gXqZBJ7ji	7238	10247	10247	1617783660000
14185	3NKM4h6kHGhiPooGzMeMkbf2CjJPQfpJauPdeMJEfdkQfGLVZ2Lb	14174	3NL9gFLXpNB4Nv7NTHPREw1juF4z7BfzaPFWofBRVkiZPdj5pNCS	1471	1140	218	6301	10315	jxCFjpxXrYJSUeAZWPJpVZk4kTWRjb348Az9ZypeUJUeMaBjFGS	7238	10247	10247	1617783660000
14186	3NKtiVJhuhppz6NZM5vovKdg794rai2n7eru3TaHuCyREY5nF4av	14185	3NKM4h6kHGhiPooGzMeMkbf2CjJPQfpJauPdeMJEfdkQfGLVZ2Lb	1476	1125	218	6301	10316	jwMUiKuFUszF3ieHwnncWQ1jUZfRKLcyRysvFpEWV91gSebWvtT	7239	10248	10248	1617783840000
14192	3NKxykhzfyERQtfsLtXyRngaHHRhd3ePg87ytwmXrtoRXT41S5yu	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1622	1110	219	6301	10321	jxdqrgUSpdyVb1suXxfgcfgHGMvotzYCRRH53yVrSHnCCZBA7fD	7242	10251	10251	1617784380000
14195	3NLTKMqSgGZVmU3bAPBSPNGajkC9B1Z6ZLkCBPA7V9hUR4BBKcmd	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1440	1131	219	6301	10322	jxzL1V7eoBoQQLnURzXhqup9Zp2HKXE5f5wECiAQyCGtBET9J2F	7242	10251	10251	1617784380000
14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	14194	3NLLUU7VKgDBJcgxJTfytPn5QZoP8NJ4uTrGFyjPAcKZQC9z4Fff	1675	1216	219	6301	10323	jwvemak4oQ9bsgXivQ8uUzr7GBqiUUzZzSYDnVKVF3Q6NUdHnhQ	7243	10253	10253	1617784740000
14201	3NL79Garmviry9UdHWaVBwKNhpFr9rhha2GYkXWLqNE8TZePEzzM	14200	3NK4oPEiQhhzVEe83jJaR6ktvd6grqspF7vFJnxJofgsVDWPZM3c	1406	1393	219	6301	10327	jwpu553QfwQUu8zxWUFS96cqh2EStxZ2EseqGxQ9eH6UnV7m9bi	7247	10258	10258	1617785640000
14205	3NKp56XgjhVETHYrJuwP8AimU6ubbJ55LouT36dBEHc8JLMzotkv	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	1439	913	219	6301	10331	jxDbbGLmMwAYbqygKbFUNRCmsMPuqfL5iJpQH6w9i63B2DVzHXE	7249	10261	10261	1617786180000
14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	14203	3NLT1U4TEoUdEf3pHBLKkePohb8nfDNkzc3EeU9rW4J8rkVJGuED	1585	1366	219	6301	10332	jweQ2QmaCRcNVa9PK28pCXT4vmH3g1UZKviGVU8tdWxdCicuecD	7250	10262	10262	1617786360000
14209	3NLvJratuWYgUNbfy81DSuVGHtARSjuDrX6teLWaAXkpNUYLRrps	14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	1402	854	219	6301	10335	jxQkY7Np9MzT16cW5TdRyMQZpfHKeu52SbzeYkMjevFcEMqxJvb	7253	10265	10265	1617786900000
14211	3NKzgrKQEGqZyAie6EKKfMgbU2kQRqZbK92QDVscQLQ4hZ2WKsqC	14210	3NKU7PH8nurKTAFkwRPbDkU1GTqDSgpz72TMP4XnuVoFV6WsZJsc	1513	1013	219	6301	10337	jwtyxD4iGdyG9kb6xCL8WnjuDh6gY2RfwniGzqWrKTCsa4fscpg	7254	10266	10266	1617787080000
14216	3NKyxbUhVxzM1hHnFgkrfH7zEUzwPpAYqeMYHoSamCHiCUh8bmf1	14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	1483	304	219	6301	10342	jwgcumqrPr7ZuQ9wWpGTTzStyUSqT9W4gRAhy59eioAM92TZitr	7257	10269	10269	1617787620000
14219	3NKMBfVKYFbyT75eKcq7rBNFpxsorgjWs52SvvYqE7AzoL8uruKB	14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	1553	776	219	6301	10345	jxnuVMRqgs1CjLuMriH6Dnyokh7uAMJcejY7K8f5LwL8ZJejdY8	7259	10273	10273	1617788340000
14224	3NK7kGooSB3ivkZq52HMDK2vU4VTX4qNcJKKCqNKwx7iTCeUgTrV	14223	3NLK85dNgMMvH2UX8hfxkwgtgZH15PgceXNbYy4oQVzs5zgZapNp	1579	1389	220	6301	10350	jwsmBhays7Me5ErduoSeitDCfLQTLSL5tAktmV95fP3eK5U8B49	7262	10277	10277	1617789060000
14226	3NLjn3VgyTkBrWoPqEwQ4oXqRNqZikJmRUVpxRKQxu8Uax93r6QA	14224	3NK7kGooSB3ivkZq52HMDK2vU4VTX4qNcJKKCqNKwx7iTCeUgTrV	1407	1395	220	6301	10352	jwC5Ju38WMSxe9oPLGrzKU4XPHv1hGyTNDvdjXhPrAtB6E1GTme	7263	10278	10278	1617789240000
14229	3NLC4KZ5r4cwJ4KPCNX89r5crHULDEYaFjW2BeeZzWKr642iSKn2	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1651	1301	220	6301	10355	jwAczxGzfYwpLSGKZGYyamecDkcqo1fGE36cp9mqfp4qE9JCn1H	7265	10280	10280	1617789600000
14231	3NLTWw9vhmqeqpmoUBTJaHboFH8A4Z1oPNRXkCFsY9SSxgqUDpgC	14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	1407	1395	220	6301	10356	jxzCmhXw77JV3uTbukmhYqmtbsNBntbmbBAmjqBoM4zfEEEKGSw	7266	10281	10281	1617789780000
14233	3NLhpHQVA5L5XuFFzBj6AgwwuezzRvj4NrpNqiaEY4U7kcpdJRjG	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	1405	873	220	6301	10358	jwJNucKLcHGCfNJzzY6UeggjeoVZgAauDHUEDGncXwhdsoYEEbw	7267	10282	10282	1617789960000
14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	633	1018	220	6301	10361	jwSjUtUqtWzoFZv8kEmd4wLkn72CbXuuj2epfUAAWxsetce4hiK	7267	10282	10282	1617789960000
14242	3NLc1jJnhc5Xp5Bu2TMPpii8ebEFG87KokmdfR2kozCW1CbWYxvt	14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	1675	1342	220	6301	10366	jwQvQFf3bC49KciMHLKnuWA97Cb2bEgHJfiE8rAj75s2S6jYB7y	7270	10287	10287	1617790860000
14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	14242	3NLc1jJnhc5Xp5Bu2TMPpii8ebEFG87KokmdfR2kozCW1CbWYxvt	632	1382	220	6301	10368	jwpxg7rZ6vaGThhVVB7DWcqfuMqCRtyUpnG5pPFLXUskDKkLC1F	7271	10288	10288	1617791040000
14247	3NL2d5GYZs1ZKCXZV5YRBs2t8VzNVoBF3K61a5KTQtPe9EjSoGiq	14245	3NKKnYc5hNt6c9mVfEQiXGz3WHhkdGi2yrH78bhSbNUmESihzViE	1518	833	220	6301	10371	jxCkaZTuwNXqKmX7bb4tm4azRp6nmr5aTVcgjbLYfHvRNoxKjJr	7273	10291	10291	1617791580000
14255	3NLY9QcwNyUtAczZiYYvVoXqsDCrLEDA3p2PHZCnS3vt7qpyqt5W	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1613	983	220	6301	10378	jx3XqmezCkMHxQjAyawxU3SGTGdyQWNmjhvH9pzbjp2SipYRGUw	7277	10296	10296	1617792480000
14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	14256	3NKDQgvjUZM98hgjAyQdyxTavnzpCPcAi5i4Fx9HFrpsHFcj5KrM	58	1281	220	6301	10380	jwfCC8VSZQbJzJ48WLDQSKk4Ce4ULkaEa7mhehWuzQm9LQs9Yf5	7279	10299	10299	1617793020000
14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	1471	1260	221	6301	10387	jwBER1EvyYfEfPpgUTFuMFqtXnEgLUYvwAY9FPihywz6Zyvwq6H	7283	10303	10303	1617793740000
14267	3NKfueYDTqpEVBz2SxqyE7q6EzwtdGFanebSaLpe7Hz55y9GGLYY	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1407	1395	221	6301	10390	jxwFBaJhbJEoA5zzPp6KXYQeZNQBK3KumKSGEuKofFMPHAuzatf	7284	10306	10306	1617794280000
14269	3NKSuSaj9FvdYqm4SLecHjvcMgErBSu3zeVoAu9qexqByNyFZpoY	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	606	1169	221	6301	10392	jwCTP4P2JpqFKaVFVX9ToatEvxE5tQ3CzZdyu59UUccS7K8NG9w	7285	10307	10307	1617794460000
14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	1581	778	221	6301	10394	jwqh33Yi845FebeRm67wfNEds6A7rtWRzVJrXVCWMAGdrC3Ke5e	7285	10307	10307	1617794460000
14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	1534	1071	221	6301	10398	jwft1aYa278pP4PB7mTjfMPu1T2VoXAfgFWehieXQxBJddRbxz3	7288	10312	10312	1617795360000
14279	3NKswhS6qbpM95u4KAiCvB6TfdaYmfZr2wbuwfdoA5NJg1Z4h6oi	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1599	1287	221	6301	10400	jxmnxbQ9FnD9oVSiRq4idCfPhvkoXb7v6fFNNDT5uF8kc2HP5k8	7290	10315	10315	1617795900000
14253	3NKU1GsC9md67GPdKEzf37kKmLBfVRp7DMFQQARYdgHC4kB4ApVx	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1647	1056	220	6301	10377	jxVUddvt7PeYH2L72fCpkjLprDvNGfsLsCc8Tw2axVWAKGjeSzD	7277	10296	10296	1617792480000
14260	3NKYx1yZBnSwzYMQb2QNFjqdpzMXk5JRBc3UEiw3ziqumyxWVbQ3	14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	80	1273	221	6301	10383	jwxCfQsUkvsRM51hFtTvUVYyjm7zzG2npkCLwQfRj9zoNiNAfLd	7281	10301	10301	1617793380000
14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	14260	3NKYx1yZBnSwzYMQb2QNFjqdpzMXk5JRBc3UEiw3ziqumyxWVbQ3	1474	1329	221	6301	10385	jwacpnp5mwGb28LLtRga69vZQjTEXZSjjS6unnMoJGxNFpMje8L	7282	10302	10302	1617793560000
14268	3NKunZoGnXiB9MfrFUMqC68L83iPVYRWo5buV1uPBxk56ePrZnjz	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1422	971	221	6301	10391	jwz79tLi78LLCFgyF4YkvbVkFEGZ8UiHRSEyVNt4Y1V5TRF9qjX	7284	10306	10306	1617794280000
14270	3NL2xd2Wo2TZgqWTBhFfNhxeAehLUDyDxi4yYgoR5zdkfNvaMpjs	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	1631	794	221	6301	10393	jxJAuDLu8WKCvY7yEtmHa6NwduMcrZGCy1Vz3amMSAAWdmkj7ni	7285	10307	10307	1617794460000
14272	3NLGukMq3NsiyE5b9o2zMa4Y1cRSUP7YQNfjuKALzcudykzWFkpj	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1483	1276	221	6301	10395	jxzo7Dz46N5Hc251Az2aZJwBtYSBojtHNSksRGu5Wxj1pf5scx9	7286	10309	10309	1617794820000
14277	3NLLMHjvR3itDfwLAP9SyrdNGX6SDzZo3fwyNRiSvXrBysSMU4qK	14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	1534	1071	221	6301	10398	jwt4JQgjbbfwoQkNvvpyLDPFHYurJTNZSfDyVWZj9zyMmg5JrbU	7288	10312	10312	1617795360000
14280	3NLXsrZyVsG1zm1CxQCaYhKu8uqzbe6G3iBcf6c3UT14MC3WHEsH	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1599	1287	221	6301	10400	jwfqdepqj7tX2JcC8tfWjQRGX9eEAQaGKGBNqhLxKGMUMQmTtVF	7290	10315	10315	1617795900000
14285	3NKCmBDay77AVPLHm3vziZ2zaEFiCavi3oSuGWgkgLTSAuPZmGPy	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1402	874	221	6301	10405	jwqLiqefVhJQjLFcxsdSnqRrnXwm9vFfFuSYxtieibBoEkdWd7w	7292	10318	10318	1617796440000
14289	3NK5WCyonSzmd5mUNmbnEaYznXN1m8nFtXwEfdN4b7v6yxT8Fj2a	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1407	1395	221	6301	10408	jxKzR8fvRRhw8LjNtHJ8dPS9Zcb6pXtiM3P5z8nwHsEpS7Knoxf	7293	10320	10320	1617796800000
14294	3NKB87SzCa2kdaGDpbJBmzTFRYqziEijssKc4HT6E585iZFEryJc	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1406	1393	221	6301	10412	jxqery8wFQ87o8bAPK1kja1gvxjQT61UX8QuvD3cead7Czp5pq1	7294	10321	10321	1617796980000
14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	14298	3NLAzhHeNME57BFuQYinf3MvoZwpoWZx5BB44UqXxZdDGT5W6nJC	1407	1395	222	6301	10416	jxf4G6LxKy7MY3jYazqm6ZVEj6gpMionZo4UeocxrHvyMJnGRu7	7298	10327	10327	1617798060000
14302	3NL8DnApsb19BjvUCqNN6RukKfaJjEErGXy3jayJD2pjgxwMP9kC	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1529	1070	222	6301	10418	jwvHrQWLdskq9PHTGFc7HZBHAG3gt7MXcm9j8mrwL31LdTvAJHj	7299	10330	10330	1617798600000
14307	3NK7tyLNmF1GFtohGqdWs5Kb7oRBRboPKBEzxgTzt7uCCZnNBv6T	14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	1579	1143	222	6301	10423	jx89boqcSzfaK7sWMhgFYBKPfE9n2bKJ96dP2m6rj8Fn9FssTxW	7301	10334	10334	1617799320000
14312	3NK7oHKRdysE3vPdFeBBmzzEaAieMWaiTmrnSB3HAZy76769fauK	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1407	1395	222	6301	10428	jxuV7MsfxVq3EJK5tZvQPuko5upFgd2sLHWP1rwsV28tb7Lmwh9	7304	10337	10337	1617799860000
14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jwuLyKMDzXuXpRe2y93pxE6ooGMPys27JUACWZTYCBUwE7Uh72p	7305	10338	10338	1617800040000
14323	3NLuixbnXu9HaWWHc8cX9DV9N9dz6Hv4WZwDFeUmWVUeWZ7CiRg3	14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	1529	1070	222	6301	10435	jwE6yf1gtoLBQxsosJCggmDaAVh1YQXQAMk3XcL7DqLSZwZBELg	7308	10342	10342	1617800760000
14331	3NLEEbkRqZnPKwVsEjSw4o8bUHruau9uWWtKjnnTUtuNXA3EFYEJ	14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	1406	1393	223	6301	10441	jwzMrvuNKKakQEek7HTX8imuKWpPFuJsvAWDb2wZgThBLBcKfMa	7313	10347	10347	1617801660000
14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	14337	3NLE9aQsKhD3AKoHZSp1AjFXdpyNkqM1JmQeLKr56fXvqUdMAj8S	1402	874	223	6301	10449	jwgdSN1zDASATRfY6FXBcLJJ9az2vMTgW8u1KPyPRbv4yzRwS3g	7319	10356	10356	1617803280000
14342	3NKbS85unzF6WdZm7casVFeCwxJYnYuuKU5KYXUYvtu4eWgqNxnq	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	684	986	223	6301	10452	jxmspC3adYtH778ADDV46Yqe5KTCLLp59dobr83MM5utexEUYNa	7321	10359	10359	1617803820000
14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	14347	3NKkgck1ifzLuLHcsYSM1hmLfm9HrdWetxcF8wfZMZ23Be2ioJjo	576	1229	223	6301	10459	jxEjLR1wfX6SgdDMH7eYBytCgXEwRvGfBvPWwjD6f1HqsDsJNys	7324	10363	10363	1617804540000
14359	3NKgUjzBSsvxopNnzgmN1zYfx18Gxm5scpLcn6i2pAABLzGZ4MaX	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1549	996	224	6301	10469	jxvpJTjCfy2DqMiCvYvyn149NiekVERegp93wmRb6xLPLpjsEGu	7330	10370	10370	1617805800000
14363	3NKCEZ1vECkn312JKwgEYqGG9aLUSMw43XjijyFzvLd1CLn4Bg6i	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	341	341	224	6301	10471	jwsMvHcRbB39YFZEfN62dpR2uUUnoSB3yps2VwouYBGPuctTgNQ	7330	10370	10370	1617805800000
14368	3NKse3FhvpfsdJgTqGa86iXwHdqDuSuK5zUXXjd76mq8ZSncTX3m	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1651	935	224	6301	10477	jxAkXcUaKe2ZbX4yyVQEosPY3o3M93JJ2sV4mwJaHEAinDkvAi4	7332	10372	10372	1617806160000
14376	3NLTMCnL6wSN8CjdnkWbE9oX8KQRge5XjT57mgj6BjBMfyJMTFn7	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	641	1210	218	6301	10484	jwbEiKrWZQzxVhz9xMPVYsT8b3nWkAfcX88E7zm38vb4ADzYoQL	7222	10375	10375	1617806700000
14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	14375	3NKKqMpSAgFmq1mKuB2rgEcRUEmGdec4c7iYqtC9kvoKwv7wF3sc	1406	1393	224	6301	10486	jwnzYgrbXf9CMTgv9XHNznTHPV3ru9xrjz8F7FeRF4JHDkGfZwy	7336	10377	10377	1617807060000
14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	14382	3NLArFJcm2EkusyvyL16zxz35YKJYuq6ve7rQmY15Tih9CkY5zwQ	1672	919	224	6301	10491	jwMgCa6zcrAX9RefeCSfoJcEPxVkFHZZEBVSm4TrxUMrf2UK4wq	7339	10381	10381	1617807780000
14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	14386	3NLqgX7JPuFAXf4vcYE7ieXu5nYTEeU78Pui5EHX6E2JZyzKwhxc	1673	1368	224	6301	10497	jxhrfeZMeh75HY3V8g6PjGpHxv9FPscN9WqyzBmQkKB4qXm6d7X	7342	10389	10389	1617809220000
14396	3NKtUZSMbj5YZyh2Wzynp9jC38h9Nqu9k74tLr41CRjUVznNqZgV	14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	1637	816	224	6301	10504	jxBPvdDNV5vRzSHjbbRkEkFyfYmBNQvrqBTseX2KyT3oGtGBgXq	7346	10393	10393	1617809940000
14399	3NLVmM1uXGerMj4Wx4CGLfLMKvZHQyPfpxSoHu6J1nsrCGHgiqqL	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1483	878	224	6301	10507	jwH9kqo7DvjJaGxDtMaeXPjvzww4Tgn3hFMGYjvR95eUdoK58VF	7347	10394	10394	1617810120000
14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	1518	788	224	6301	10511	jwYbgFV8qAHSZfXmUDAohufjrQZUCwsYigmx8eX9EBVsREWsFfb	7349	10396	10396	1617810480000
14405	3NKF7X8UqktC1thmCWMbdK8M8Zc1pTMe21z8TRrRDZ87r23on4LD	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1536	1313	224	6301	10513	jw8Qv3bWpNuwmzH3pU6XD1j3kTxxDxkzNfZ892aobdCtHAVYLqw	7350	10397	10397	1617810660000
14254	3NLZcLkZQJ32FC2yuJUUACSYw53fyCjWWUSbMMUBSiHKWAwdwGM7	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1613	983	220	6301	10378	jxNY6N7kMc7SiSYR3CvM3rLNQrZnmrmG2txQDPZT6LBEYNxa8wf	7277	10296	10296	1617792480000
14256	3NKDQgvjUZM98hgjAyQdyxTavnzpCPcAi5i4Fx9HFrpsHFcj5KrM	14255	3NLY9QcwNyUtAczZiYYvVoXqsDCrLEDA3p2PHZCnS3vt7qpyqt5W	1673	1368	220	6301	10379	jwWfqXQasZtEXM9o978183uFVwRMhw19yddUuwyGm3nAbVkt6hH	7278	10298	10298	1617792840000
14259	3NKWg7pA38498JBNxhrYnj5M9zKm4YkrMzJY2HD43vctMnLL5J7X	14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	1508	1141	221	6301	10382	jxUMN32HeTBHsPMXZxDKji5iVZEXca45ZroL7Ft7xnE9r128hL1	7280	10300	10300	1617793200000
14263	3NKAD2sofjTjgYWj8tXfNYYsepAbNdKD94KwoTadxoL4gdMCcXuq	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1474	1329	217	6301	10386	jx78E8CMK3c85ttXLeauiiwQ3zWRx9dFfynRCRY94mZVqu4hgPJ	7205	10302	10302	1617793560000
14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1426	1364	221	6301	10389	jxR3445gTVV74fFDhu3AJewc3Qt9yCnq4sK7Vtg6Q12jQzejToj	7284	10306	10306	1617794280000
14273	3NKKsuuaKY79MmFHxLHC1sq5rBzo3GQssa4oBEH477THDyqBd2cL	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1642	1367	221	6301	10396	jwBCU8oDfTWSr9enFw1NsDdNFBanPpHfxH2c8SMyUJYAiiY6R9Q	7286	10309	10309	1617794820000
14281	3NLDEJKj3pU5P3RZFvBMfA7W3HdTsS6j584PdKoxkZkCxRDgQifu	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1637	816	221	6301	10401	jxbvc5KoYiiNkDuebXGuY8F7sm4bwNVdKkuKNRTNQ1DsDYtYQ6U	7290	10315	10315	1617795900000
14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	14279	3NKswhS6qbpM95u4KAiCvB6TfdaYmfZr2wbuwfdoA5NJg1Z4h6oi	1609	1333	221	6301	10403	jwwJ4ybKcwU7AjcmbnhWiSr446Cd7g7zojtUcYq53fxr46BajZV	7291	10317	10317	1617796260000
14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1406	1393	221	6301	10406	jxdLaiRDFyvpss9RZBfexuGDVXeV4mWdheqVoL3gREELjBCN5q2	7292	10318	10318	1617796440000
14290	3NLe3giykBqP5EkxVA9Je4LuAqGNDkHaAWwCuK9sSQDRiS26QGuN	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1627	1385	221	6301	10409	jxTFNfnXRd5R5WK1ufbXGJ1veSY3VuvKR4A1jmKj72ZA7C1hATp	7293	10320	10320	1617796800000
14292	3NLy8pKGLKvdycgvoWC7z4oqqz75jD986zmgujonCVPpFkvredw4	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jxqj9Sts2F5qjay4PWw4UsQnD4EicBnrWbLaYpa92Cuz7XrDfca	7294	10321	10321	1617796980000
14295	3NLAdQwjnyt8SbKNSjF3LJ6sKkHemiG8PEzdeCnvspGykH3vThDU	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jwuuJy7pRNodsfYwTWijvWUUAiQCmVEsmKDDvCBNxvf36Bnsw3x	7294	10321	10321	1617796980000
14296	3NKVjupfM82ckRDcxVjemFKEkzmYNiNcUP6J1bkbTAyiP5wKTr8X	14294	3NKB87SzCa2kdaGDpbJBmzTFRYqziEijssKc4HT6E585iZFEryJc	1407	1395	222	6301	10413	jxPSDF7ZnEAUBscQ1Wytn8rLuCMQtfxiEnQuWbzHNqUYsRKd5i9	7295	10322	10322	1617797160000
14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	1405	851	222	6301	10421	jxS4rVMH7p2H7pe8xhuropbyzAQdafkMH8aFoZiynJYQFfakjYa	7300	10332	10332	1617798960000
14308	3NKcXsw9ShauWUP5QxgjCdHFVGSauSb9zzNS9dHFy2NsUZd2FUeq	14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	1509	1074	222	6301	10424	jxKLjUUYds6tkkg8cdtzE9ezbLaf6tbLmigmArK8ejLjjus1gWN	7301	10334	10334	1617799320000
14310	3NKyXuv6rbmLyu6C699pnXuZzScbUVmhkNDSV5SAkdhHqfCZR9SS	14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	1559	1353	222	6301	10426	jxq6Fn2m97czhTLrhtaB3kTrb1WQU9vwdGQyUwQr5LiLb1RPVxM	7303	10336	10336	1617799680000
14313	3NLu8j5xSTmBd1MEag6VDPnGTBUAFeX4eNtViZsYHxxk15kcuTrR	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1646	1354	222	6301	10429	jxirJ21x7VTWNRmvFmEgw7sd9xLUCp9sQwnskgajXscT6cWW3FT	7304	10337	10337	1617799860000
14318	3NKRiwtCANbtywRuXwzJj4DXQjgjZeEKAyNnBeu47eRmpmhPLNdk	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1406	1393	222	6301	10432	jxrVgdvQgcr61Uw8a1trMTnc14VEkg9TnH2n4XHANzMQwQTf6a5	7305	10338	10338	1617800040000
14319	3NKcUqHHmF3oihmTSSumngo7SQeQAETwKPKnVK7fUBsY4BnU7DNj	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jwB7rq4zhSYSD8mDV5fHzg2rkfitgFAEaXZci9iRZEbovWM4Fqt	7306	10339	10339	1617800220000
14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	1610	1188	222	6301	10436	jweuSMwAzyazhMCH3SHazpPsirXuTo8xoSKQSnEW42vsEY7F8gJ	7308	10342	10342	1617800760000
14326	3NKSoC9ZKCJ1qTMTnEiefYqrR1pj1tVnpqVZgtDfVNtwTb7LNw2m	14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	1508	1021	222	6301	10437	jweaRK8fQxKnMGeBq321LPrrVD5bTJtxpBkewkM9sBqZJ8eCvfp	7309	10343	10343	1617800940000
14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	1587	1231	223	6301	10440	jwATAUZpgQ4GzGzEzom1bb5LsAMHPVZsN5VvATR6wm5xG3bRENo	7312	10346	10346	1617801480000
14334	3NKrgnqH3BkfgnJrgMaJeFPYw7aiQ67VZ4XavkGZNQtiJmh9uFnT	14333	3NLupc159jPs2RUJTH5BgU1cqvPu2XDer6v6aC4EgCJW7NLdVPBW	1402	856	223	6301	10444	jxhWsofAenek2SGZKPABFFy1zhCdTQQ6GSAG1hexNexb8VMJxMV	7315	10350	10350	1617802200000
14337	3NLE9aQsKhD3AKoHZSp1AjFXdpyNkqM1JmQeLKr56fXvqUdMAj8S	14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	1571	1089	223	6301	10447	jwa3tMVjKDqkC95vDMJmeNgV5fxDn6HjCQ8eddGjXXUNw1XpkmA	7318	10354	10354	1617802920000
14340	3NLw6mjE446t8nmpH2JZiFCjqwxCYueimPLa8ETZ4GLn2Qavvrys	14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	1406	1393	223	6301	10450	jx58xYEiKD5DjNuYmYTNiw3W6wbM7nKvZ8g9o2Em3iv5yw2KgKq	7320	10357	10357	1617803460000
14343	3NLKAcRTKyjXzqEA7xei2NHUWGmw391sEgrLVXuzUu8zWzDNn5cg	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	1609	1087	223	6301	10453	jxPy9ryVk1oZQt88GWRQBS3LgZxdyAB7iQHeQAcQKKAw78SfXLQ	7321	10359	10359	1617803820000
14345	3NKFSSpMrsvRkAgG1EeLZ8XKxLwjwoGLKVnS2ejDKXHC7Pw9VjWG	14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	1536	260	223	6301	10455	jx7Nt5qhJuRBrpwp9348zDoBxJALZC8EM7xYbAMJRK6m2s1XnEE	7322	10361	10361	1617804180000
14347	3NKkgck1ifzLuLHcsYSM1hmLfm9HrdWetxcF8wfZMZ23Be2ioJjo	14345	3NKFSSpMrsvRkAgG1EeLZ8XKxLwjwoGLKVnS2ejDKXHC7Pw9VjWG	369	1312	223	6301	10457	jwSHH9hDbBGFiNHeREEqkGPj3nAR6BQt51iSfkbap3A98GJhPfZ	7323	10362	10362	1617804360000
14350	3NLtzVfGipRBgRivM8xGh15ChnFZwPuKkk2bvXzcbiy2ZRa9h4wg	14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	1407	1395	223	6301	10460	jwqGScGLvvBzQpikHFNxSGL7CNMxzAwbWgh5LAhLmzkdZPwgq6j	7325	10365	10365	1617804900000
14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	14350	3NLtzVfGipRBgRivM8xGh15ChnFZwPuKkk2bvXzcbiy2ZRa9h4wg	700	840	223	6301	10462	jxkw5u3wEJMbxMWh6B2d49MmBa1YmLnWJ6v8czSW3rs4tBk5dW9	7326	10366	10366	1617805080000
14357	3NLY4CD4UDRXgpLfCDhQWssnFzDoU3JaKMrcNFMwAUAPAtWAFXNJ	14157	3NLZXP4mtfQhZLGwSjGiV8ZMpbwszoaXNHPEREa579fwRtqnZSsY	1624	1208	218	6301	10467	jxS6F1fF6ayy6dgt2JcLswPBLvAqdqtJuKtFZhdnreUj8r9uCR9	7227	10370	10370	1617805800000
14360	3NL8L2Hf93hMzEMvja5UtCig8CJDK1CeMRLq5UZCaYaneo2QJmFy	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1624	1208	224	6301	10470	jxKV6PwF3tX2zCumBukLRzD2KsvEXe1tEPHrW7UAiFvVgadUqV7	7330	10370	10370	1617805800000
14261	3NLUE98UjRkc9AvvjmLLQGQ8dtDAJt9HYhWJ5pKuDDNrZWfiXN7c	14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	1547	1252	221	6301	10384	jxkCfg7q3379RYK2RTP4xKjn5KAVAcSPLFXkrCHuNXZxPrb2rHS	7281	10301	10301	1617793380000
14265	3NKWzra6hfDXeBaD52KcHzbxi1ScdLAYYtCDcD3JVQtKFCKWfLpi	14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	1631	794	221	6301	10388	jwp3bgs4C6GE5YbvVhVXeqJsfDpsY4WQrj7fU844cy1NuzUjnDM	7283	10303	10303	1617793740000
14274	3NKekgxMUiA8kyXuDonwU2x1AEr6unUMwnkGukW13zKKqMSYqTF3	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1642	1367	221	6301	10396	jxLGht5LijENQ21nujx7db3urKv52b5Z3WLCj8QqN2W4k5nse4j	7286	10309	10309	1617794820000
14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	14272	3NLGukMq3NsiyE5b9o2zMa4Y1cRSUP7YQNfjuKALzcudykzWFkpj	1406	1393	221	6301	10397	jxKb5uQkdfjApVuqmMF71FFfYFbmdSrZWwCzVQhWW7dqJZsWjJh	7287	10310	10310	1617795000000
14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	149	1283	221	6301	10399	jwSPi6yH3Jzr7bEkcDp2gXXCWPWRWKcQSQoiK6Ek59A7GQWuYDv	7289	10313	10313	1617795540000
14287	3NK6DexHrJ9QCgFWP3NRAssbu1Ko6SpLMkAiMH4w98G8cTYSGDmd	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	470	1183	221	6301	10407	jxJkLQwMSqEvyzrDwVdWXvL1LFsYxofg2tFaBJAbSzEfSMTzmaN	7292	10318	10318	1617796440000
14288	3NLwGxJALEFY6MUr76fwGaRFpTMvBMUftRLRUVHDKy2gS7B3YRWN	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	470	1183	221	6301	10407	jxqjJpiLVk9A6pu1BCc5EDYngf8pQL5KMJ9ZbEEiPsFTnCBRxPD	7292	10318	10318	1617796440000
14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1631	794	221	6301	10410	jxwxrXBxrA9mbGmbh7EJUwXAiUji2tGsp182ywarKhuNHofmxrE	7293	10320	10320	1617796800000
14297	3NKTjLUGdN3X6mAZcjFwj6Trak6gXHT77PgzR4q6xzCPy2wgwaKy	14296	3NKVjupfM82ckRDcxVjemFKEkzmYNiNcUP6J1bkbTAyiP5wKTr8X	1673	1122	222	6301	10414	jwGQvcqdqZAq7mLt75TVw4edWpNv4taPGTdumeefT4XcanBFFCK	7296	10324	10324	1617797520000
14300	3NLQZzePxe44Ka54dNuKsN5MZY6FHjWWSZbMsqZecZJ7kFN2TYFd	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	686	686	218	6301	10417	jwYuSj8CkL8Tn1Bdf8VvKN9wGXyeMHhxmpoFD3gQ9An9rnHsV7v	7221	10327	10327	1617798060000
14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1474	1083	222	6301	10419	jximdCxSrVxjAVPUaaAPddciejixDKBjsJ6H8eWVmCWTRDJswAg	7299	10330	10330	1617798600000
14306	3NL5aDKRXXfVESr7tBU2DQDFSyu6SUtGatTWVxUbSFGByUMbFSZh	14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	1577	961	222	6301	10422	jwodaWobV9mqKfNs3sTahJYr4zxeVEuQmwbHUyYrQPCYsbQsMVZ	7300	10332	10332	1617798960000
14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	1513	1013	222	6301	10427	jworKRY23BL67xjQQ1Tn9XjybzSLadBK5LthfjVqUHZWQdZiLVP	7303	10336	10336	1617799680000
14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1599	1287	222	6301	10430	jwov8G6QPcJmmJJrcfT7ZF4ron1GSPbEisQjHthWxGbqKoJwGVV	7304	10337	10337	1617799860000
14315	3NKqzLtdeUTLCDL7euppTC2oxHbo3JSuGzD3HzUHZ7k74g8D1ZaJ	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jxTPpfSM57r8t4iUTTWeAWAaspsmD28U6qW656CVtaGzUiCeY7K	7305	10338	10338	1617800040000
14320	3NLvPES8QPJuxi3ZetYQhE8PCm7MVXddaceCQbhP2E24Y6sPqbYf	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jxvBKCxkeb62zhuZ4tZrV1CYT6BuBXcrRuiN9bGeSAEYVhgvQgM	7306	10339	10339	1617800220000
14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	14320	3NLvPES8QPJuxi3ZetYQhE8PCm7MVXddaceCQbhP2E24Y6sPqbYf	1407	1395	222	6301	10434	jxc3Yon2krQD8CWcJettMCZXTEdiV9maduw6VCLpY1QC181UZU1	7307	10341	10341	1617800580000
14327	3NLPr6hDrKRLMyFD5VZVqySCxQu3voYYSNQagSMY29dwxcegGjqN	14325	3NKkGQspF5GPEura7mWToxdohJB2if42HUQG7NofER77UgTuc6jL	1581	778	222	6301	10438	jxp4Lwv6WiU7gqWFwYQpuTdJtdLgDnV98TNenT7gwEYEWF1FXg7	7310	10344	10344	1617801120000
14330	3NLtR2W6yPLu8sUySHAd6q8jDnHnarUHQEYXaBip96zZD4x2pQFw	14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	1587	1231	222	6301	10440	jxDhUpMRjM53gLXswBXeN11N4RadgUdDxsx6ZmYjfxvpBxvuM9x	7312	10346	10346	1617801480000
14332	3NLtP4pP5sCmpbWAesWnKo8ZdcESCGTvRHDgsvE2ieCYd4ykg4zR	14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	1481	790	223	6301	10442	jxiEUrYwbhchzxwU8PLfb7guZYe4UWdy5636H2aXQUFWUnmwkDK	7313	10347	10347	1617801660000
14335	3NLTnppnbzV7DnX3Q9DFjGFFzfc7PA6JGWujpmLXSxXpPsAD6yRp	14334	3NKrgnqH3BkfgnJrgMaJeFPYw7aiQ67VZ4XavkGZNQtiJmh9uFnT	1573	1192	223	6301	10445	jwsHHtTVNjvSr389tVFznic6UZGz8taE9i9DSTeBW65TDG88Kg1	7316	10352	10352	1617802560000
14338	3NL9DAoh15pAzi9Pppg4zNhSg2XTKYp8mDki8Jsv9NzhkzkuHS8F	14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	1560	1165	223	6301	10448	jx2m8qaBMf12q78UF2zXChUVCqCFgeRy1CUcgJ4jTaTEvKE5HS3	7318	10354	10354	1617802920000
14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	1553	776	223	6301	10451	jxYG673va3nWHsWuosLh2korgHdGcSMxYdNtquvTicyeHNhPjjq	7320	10357	10357	1617803460000
14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	1587	1357	223	6301	10454	jxpjCEuWWpsxmEWf338A55dxFFapizUbtQ8cMZ9D8L7ZqxEHHgk	7321	10359	10359	1617803820000
14346	3NL2pT8Jg7D2G7rzXR12qWLPpq5H6A4C9jndTYiFtnrxf4CrpL1L	14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	632	1016	223	6301	10456	jwvGG3PyxTRhyXAZq7Q6KG8Fzww1zPFqB3DM43HNecKDjPFigpk	7322	10361	10361	1617804180000
14348	3NKwEkfPYW4htZjqJQ2pjkfJjjzitcRkhu4GkjcYcKvZcVSsEg9m	14040	3NKaZNFGFeEcn7eDqA7nQUV6tdDmv2DFJpahfEJRKwhD6ESTDFpU	369	1312	216	6301	10458	jxHb7gjZDgmyqX6wiDH7ywSp1d8iqECqBdoH7r2DRkE7hQSSNWa	7192	10362	10362	1617804360000
14351	3NKopMvRsZwNcQhd6fpFkehm1fTSALB3gFoK4sBvmZ6jCbx3CAp6	14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	1540	229	223	6301	10461	jxqYtJ4VYwQksY7YRu3YdyG9JoVqPuKBXXLuBpTXciE7V9cBSbq	7325	10365	10365	1617804900000
14353	3NKauqYdsBXcB9MPs9TFaC4Mo9mztvMhJT1BKLjWUQ5cNGUFjvSZ	14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	1670	916	223	6301	10463	jxxEvEbcCtZLjfBsw7XMJTw2vZ64pNeGnQduHMxkrHzvcFSxnV8	7327	10367	10367	1617805260000
14355	3NLSSwuGKqsf6ASY8UE3UTqp3wfHpqAd2wGpdtEeCybnucfS7WMK	14354	3NL4jCuP32JhkKcRrXhZbP2mu94rukujNuTq9o6gSy7TeCgtJzTu	1405	873	223	6301	10465	jwUaA7CAbCCsKSCYgX7g9MfzjQBXjeDZWnFy18kqN3pcner68pU	7328	10368	10368	1617805440000
14361	3NLKoUoV9iLRg1q1ghnrVhBb1DFTayFCzSvenkcFM8EQHSZ4jhWt	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	341	341	223	6301	10471	jxvpgTemym9RegLiiHTCJVQPKxphVbqWteia7yViqyrvxEboHPK	7330	10370	10370	1617805800000
14364	3NLCzs6vtegxXawpYfmh73x1u7w2wQT8bnjcnX7YpaRp3WqchYYi	14348	3NKwEkfPYW4htZjqJQ2pjkfJjjzitcRkhu4GkjcYcKvZcVSsEg9m	369	1312	217	6301	10473	jxPyGnNyws8WkgeMChYYJTme3huJeJswmLvrqQ4QUL45sdVxPqL	7193	10371	10371	1617805980000
14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1617	1042	224	6301	10475	jwkyVYxBL58PF9LvWsficmRXFo4tA3VLz5ftfJdeTKZZcaaMPtg	7332	10372	10372	1617806160000
14282	3NKiAbRkeCy8McCsUkLvPTyzgDmBefNSZA1DB9b9VNHMh1qn3mVX	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	484	953	217	6301	10402	jwgP3pYZmLAL6FMSod5oDYe1P5ERPEuU937ftAkCFscznKs3mQR	7207	10315	10315	1617795900000
14284	3NKXodLNskAsTNtVUy5GgueLuRmyKPfH3YY6jpTdJjf1jvLq5aht	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1407	1395	221	6301	10404	jwwT462qjbpBNwhR4h4GoLo7weUgnV9aAd81dvKyjdnCNSdSMri	7292	10318	10318	1617796440000
14293	3NKMvKQunzXcRgQK3qFNFdfYayq4pYQUZNhSKNzmQMtZjDouqspL	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jxBgC6GLGuK44vupJbWdGokH4LhvK5ww6siftfFmVYeo8xiwkm1	7294	10321	10321	1617796980000
14298	3NLAzhHeNME57BFuQYinf3MvoZwpoWZx5BB44UqXxZdDGT5W6nJC	14297	3NKTjLUGdN3X6mAZcjFwj6Trak6gXHT77PgzR4q6xzCPy2wgwaKy	311	1307	222	6301	10415	jxo1mwwWLgBebTfk8swbe6MrzxDiCdCQgaC3tAh6dxGsouXsrME	7297	10325	10325	1617797700000
14301	3NKBEpYFuuyAT5Ekq8sNx7wGH37pyd2pB3MZbWP879iA7FNUxRoF	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1529	1070	222	6301	10418	jxGvyaffLSzaRkMNsdsTonHnAUMNP31h4Mrb26Jh8sRFbkkjsvV	7299	10330	10330	1617798600000
14304	3NKS62uRAJEpUNz7SNBekFQWuMpcAHJ45JYrnJfhhBwhEHSPYjrx	14263	3NKAD2sofjTjgYWj8tXfNYYsepAbNdKD94KwoTadxoL4gdMCcXuq	1474	1083	218	6301	10420	jxm8oFMYrAmf7j2uMKig6FRrNVCTjKdpC1YaxqwYUDHuhRmVS7u	7206	10330	10330	1617798600000
14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	14307	3NK7tyLNmF1GFtohGqdWs5Kb7oRBRboPKBEzxgTzt7uCCZnNBv6T	1406	1393	222	6301	10425	jxz4KkZJJcNGCmdvPYNafuCaYfESmLjkZuJ2EWrcDoxNg83yH12	7302	10335	10335	1617799500000
14316	3NLJjZJsQcNmYkgyi56xA8vcs5REXP8G5VFuptQZX9id1zyLgxYF	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jws9rWPugZYt8etHWoWso4Ak7Jkcc2nn3Tf7tt2TSHxncf97TX1	7305	10338	10338	1617800040000
14321	3NKERpaT2xBTEZXqKnSeEYoLetWnsze7VLnuP5VTRLMFVuviYoH4	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jxSTxBoWL6LAnJWmD3q8ANZ1oyMwD3VCuyHHGvzQcFukuDBbZBf	7306	10339	10339	1617800220000
14325	3NKkGQspF5GPEura7mWToxdohJB2if42HUQG7NofER77UgTuc6jL	14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	1508	1021	222	6301	10437	jxQQqHw6wa7p42r7TRGXSZM1Atqb9KZN37Gtz99x7x9Jzi4e3hC	7309	10343	10343	1617800940000
14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	14327	3NLPr6hDrKRLMyFD5VZVqySCxQu3voYYSNQagSMY29dwxcegGjqN	1581	778	222	6301	10439	jwpsVgSY8TE7yGPzUpUoR8Fytkz8fNncNJxWtuD5G3uHzxaZP9P	7311	10345	10345	1617801300000
14333	3NLupc159jPs2RUJTH5BgU1cqvPu2XDer6v6aC4EgCJW7NLdVPBW	14331	3NLEEbkRqZnPKwVsEjSw4o8bUHruau9uWWtKjnnTUtuNXA3EFYEJ	1553	776	223	6301	10443	jxpvxvrp6zBoexqBDBDgsjSUcRNQtBJi1mdJeRcHGjkaT7e6Pj8	7314	10349	10349	1617802020000
14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	14335	3NLTnppnbzV7DnX3Q9DFjGFFzfc7PA6JGWujpmLXSxXpPsAD6yRp	1407	1395	223	6301	10446	jxawW7TZR56NbYd84FHxJ4VaZrLUUS6e5aWAjHCkq5iAUb4ZTt7	7317	10353	10353	1617802740000
14354	3NL4jCuP32JhkKcRrXhZbP2mu94rukujNuTq9o6gSy7TeCgtJzTu	14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	1406	1393	223	6301	10464	jwaVdwR5BSNCwWt6FPxH9rwXvj7mkL6ZXFobHmeQKoj2FxjFNmB	7327	10367	10367	1617805260000
14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	14355	3NLSSwuGKqsf6ASY8UE3UTqp3wfHpqAd2wGpdtEeCybnucfS7WMK	1476	1005	223	6301	10466	jx7kmLE674UDejdPC3ZUHUSbGcMkakj3QqTZMKQRVFJguayH78t	7329	10369	10369	1617805620000
14358	3NKnt83uDkLsPfhV7Zmu3n4Gq6Th1hQ93euXFvCNw14GiTRd7kjA	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1406	1393	224	6301	10468	jxTBkWMB95cNzGsvpjPAJedwj1R7V267vFuBckq9ABWJzTE5Tqf	7330	10370	10370	1617805800000
14362	3NKnoPk9LmAhNE4CRDWKYMGQESFMAXi9M5aAg1GNvKjmcWKPGCBb	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1549	996	218	6301	10472	jwbm9x3dz9ewmxrDNxs3ejCS4a7yttiYTEqyyADV1HZJGwjrFQN	7238	10370	10370	1617805800000
14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	14358	3NKnt83uDkLsPfhV7Zmu3n4Gq6Th1hQ93euXFvCNw14GiTRd7kjA	369	1312	224	6301	10474	jwCzqhizBGyUPcEgDyaCtDApaiQxUfse3AyxEEN79YyuxozTSj2	7331	10371	10371	1617805980000
14367	3NLfRRRcoSJBPGLcGAkPfbahtWfRUR6xyLjXW8TXZ6k1M6dMri9z	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1507	1280	224	6301	10476	jwdh26WDdj9ioBdTeyqz5ydGHatBm5AgsKrYkPtgf1D9Hw6Xr1o	7332	10372	10372	1617806160000
14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	1631	794	224	6301	10479	jx3dPDjbSqa3y5XvDT5uewqKLyuKYYu2bvdrmVqTEgDPe23dxCr	7333	10373	10373	1617806340000
14374	3NLyB3sUxFFHHdBgSrZoFioRtiPZzLCvSPi8esj1hTtbf8hz22E4	14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	1402	868	224	6301	10482	jxpA2shWLYR4yrDM6f177eHdBS2w5iZ6mApvuM8jUaaxk2ZhD3J	7334	10374	10374	1617806520000
14380	3NL8GAAVCaAakFiywGssqSu7xp5zPpWkqR9PtmqADaxEbBEss8vn	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1555	1347	224	6301	10488	jxrKZQteR817QySbMXomVDdTDpwKDuQ17mQydQX1nRxVbJ6pEEP	7337	10378	10378	1617807240000
14382	3NLArFJcm2EkusyvyL16zxz35YKJYuq6ve7rQmY15Tih9CkY5zwQ	14381	3NKvuYNJ9vxu4TwCBSZxRTXa114M6QD8g3NHQTZJVYsiuRnVUanb	1581	778	224	6301	10490	jxjsQBbLAkMKXmSbdrJBhv4Z7CmyQimzPbbAiMAkZ6sr14u7Zbv	7338	10380	10380	1617807600000
14385	3NL6brMZKzdR8pBvxKHx7AcVy9XCeYXHxoHkVqoi8qc8n42UNWWg	14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	171	1374	224	6301	10493	jwzX8QzELvHb74xJhevHGvDkPFakEWkoAtphpej8YMgRNxP8q9y	7340	10383	10383	1617808140000
14387	3NLhjobMpxPYLNCnv2sv6bN3bBuKBPzVHt76mnNjEMZJFF2RytQy	14377	3NLtMVqeHo1uiX8gxApUfJwByjxSNcm1sf1tDGwGKMed43aDCKGq	641	1336	214	6301	10495	jxRfgCgCZh6SzmkiD9UkcCdwrXbGjNXuLSnFByVNMUCryMajqHC	7165	10384	10384	1617808320000
14388	3NLHsP6PQaKtLpDbx4pK3UxJftPou7jzXmKa6zk5nUVbRSNviDMv	14103	3NLWLMyvB9ago5pi5BFLHaCMM2rPvj9W8YtGpUdUymhEiV1FCzEF	1650	1375	212	6301	10496	jwbf5mtHmWM5nAik7nD2zCzSTN7wTKu2Jjc8RL7XFWhQAvAWyLM	7133	10388	10388	1617809040000
14391	3NKnYZBvjzPw5v7p7gzh3NPde4Ji592eeYu2uVA6GXkToG1efZeX	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	149	917	224	6301	10499	jwnQ7FwSYY5eApciiioCySm3Z1nX2GiAeJZBhbgib6bBAjEV8gW	7343	10390	10390	1617809400000
14393	3NLjxTy1ZAxQA45tPZUTEhSNpLePbThNxtZywaXNiEu56MW3vxJr	14390	3NLFiqUJ3jRwSpBXHQJ8BvSLZRSjRH6GMCco1ccZYpLznnjxHXqt	1581	778	224	6301	10501	jxQfL6JEcuqT2HRFFsGdDxhEVJFWr9QqRfJYMpQbM2V9QDghF7f	7344	10391	10391	1617809580000
14398	3NKdghLzHFxL2MD3yPcyiQqqZBtY1jVBE3Hw67i5o7BswFu2j3tb	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1675	1342	224	6301	10506	jwk8UpCXPckMh7hUWCwSZLNzn5r7iJEm2YbosVsmDynDecvLswz	7347	10394	10394	1617810120000
14402	3NK6yxdPACVKK1514e2veBDzQBbiojdUTVDK2gYRNo4tA2sd2TB7	14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	43	1310	224	6301	10510	jw9oV1DnWEPExscPUN2PdY7c2Ei9wErYA6gRMCaBtsRAmBSXchJ	7349	10396	10396	1617810480000
14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	14411	3NKrQRTZyaGvbtsZzSWoHvFqfDqALFdSpptmrLuXy4SePTynX59g	1407	1395	225	6301	10520	jxZsGJTcvJJvjvh66ueheCFoy1eHnnpHYXqoKwnpu7DoF6tYkHh	7352	10403	10403	1617811740000
14418	3NLfYBmuJBKPmAom3xJbvqSasm88QjdQChRrjSpUwcUmJVYyfJbR	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1419	814	225	6301	10526	jxwcQbvumZUcXjsYwmV3qg5ZV5ZeqTcKEcEqBLsQJhWhv5GU9XQ	7355	10407	10407	1617812460000
14369	3NL2RW5VPLPUHFxNRgXnbHvdv7gWSS8hu6nNnWH4JjQj92vvY4eP	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1651	935	224	6301	10477	jx7FPFEdbjESwufir3JLTwLsTpVPQMRdK6L4yA2n6zFMDz6UhFy	7332	10372	10372	1617806160000
14373	3NLk8nbqQVDJp6KsgQfy2yL5KgTRCQsVoUB7mn6gQQfe3MwUvfw6	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1407	1395	224	6301	10481	jx1kfbBG1FCVYfp5GypeUv1oAubeMqNwQTngnwaCdvwCmKrRdNm	7332	10374	10374	1617806520000
14375	3NKKqMpSAgFmq1mKuB2rgEcRUEmGdec4c7iYqtC9kvoKwv7wF3sc	14372	3NLbeg8PxxYiCfALmRwU66kV6wX32HwkR2wwvRQLRPDwin8G7aEZ	1403	824	224	6301	10483	jxQsy2Fe5fmhnLhqNXgdQaF5mY6c53KvVvdfPwNvCCXoUjBgPb8	7335	10375	10375	1617806700000
14377	3NLtMVqeHo1uiX8gxApUfJwByjxSNcm1sf1tDGwGKMed43aDCKGq	13982	3NLY6TTRPCFR4spZU9fub5V7HuGA29aD3x782MeRZYwvaFHfid4q	641	1210	214	6301	10485	jxFQ56LenRs6XkMR2kzkVfX8MYDvjy7fnEeWQmFncjcSTB3BySG	7164	10375	10375	1617806700000
14379	3NK3rBUfJTyrYZ8fK48JUqwxdhNygG2ChjLf9f2mnewDPFdmrLR7	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1522	956	224	6301	10487	jwpoQWBc9u3CB53ZbhTbJpFvNPRVWzrdzRgKukSuiDGoxmh3Tzm	7337	10378	10378	1617807240000
14381	3NKvuYNJ9vxu4TwCBSZxRTXa114M6QD8g3NHQTZJVYsiuRnVUanb	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1581	778	224	6301	10489	jwq3o1xBVhvreYauNHUpBJZL1JotFXDEh7vPVMiie2sFZ9qqUNv	7337	10378	10378	1617807240000
14390	3NLFiqUJ3jRwSpBXHQJ8BvSLZRSjRH6GMCco1ccZYpLznnjxHXqt	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	1593	1346	224	6301	10498	jwP7rzyoSJudUqzay8x7zAiBtzNvtkYWvZDev6xwuUBqDiMtkin	7343	10390	10390	1617809400000
14392	3NL9f2PzpPi7SCVoqbbSDCaKYndhxiqU5hod4GC41wSHMHZvYCuz	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	1611	1215	224	6301	10500	jw9YXVk4Chiobo1fyDUicioz6XefT5xjru1vDhC2rmUXw5jSuH3	7343	10390	10390	1617809400000
14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	162	162	224	6301	10503	jwcZhmT2shuJysCu5DVdjXCs3tDYXHV3LiCPjoEUh8qbpe2fUPB	7346	10393	10393	1617809940000
14397	3NKxjoiEs3J6N6N7SfjWmiUg6YPL2gjtbPxBet2xSD4GXTjU17pq	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1407	1395	224	6301	10505	jxRCC1q1amQSZJjWTstUdp6FJikkLoihX5GMyWLDoEMkeTv3PVA	7347	10394	10394	1617810120000
14407	3NKrFKe7geJpF7162t14mJP9kTmkAnTU1zeLiRbZyeR6oQuySW9z	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1457	1265	224	6301	10515	jxCAxk9XP9V3XTtAoAdp7vMudGuWjNbUA2Z7iYyVCyny5c8ktc7	7350	10397	10397	1617810660000
14410	3NKgREYgoBpgyV3wRjyNMosCebZS3wCtYxWK8hK1HpY3GgCmxgsB	14388	3NLHsP6PQaKtLpDbx4pK3UxJftPou7jzXmKa6zk5nUVbRSNviDMv	1650	1249	212	6301	10518	jwhC485HBfGapU7BgBBfX5PAAsBwiNUjj9hWo6aoHn5geEMMJGZ	7134	10398	10398	1617810840000
14411	3NKrQRTZyaGvbtsZzSWoHvFqfDqALFdSpptmrLuXy4SePTynX59g	14407	3NKrFKe7geJpF7162t14mJP9kTmkAnTU1zeLiRbZyeR6oQuySW9z	1419	814	224	6301	10519	jxNgQXQ8r28NMq52D85KhsAx2oJqF3DSoaVE3GBDWSsANiWte9Z	7351	10402	10402	1617811560000
14417	3NKp7DvFtYbYraVN3xLrin7bEZh5CH4gkQ2SwvEPCNganpNVyu36	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1471	1386	225	6301	10525	jwmgjfjeQB4n9n8YqzJGJtbBVNt1cmeq8UwYd18UWbPNEkrToYj	7355	10407	10407	1617812460000
14421	3NKmxUt7KSGrhXaxrurSYhi6RWVrWzjNXgucwy7RQpktZ99aQ2Rx	14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	1406	1393	225	6301	10529	jwXACftE56eugwEkcjffJfngroFYR1NTLaNfMz3WM6q3B4L4k8L	7357	10409	10409	1617812820000
14423	3NKKDU3XwR3cbtbiuEAF9v7etZNBBisf5syjwtG2DDTjDxEWG2fZ	14422	3NKEtLRPdye2noVkcY5pzz9mixL7w4jTD2ggZHAQeww2TT459njD	1631	794	225	6301	10531	jxsJoWggTS5o9NcXfoyaatxxQ4FnwqHEhSksyZNUCbmzeEqHeUw	7358	10410	10410	1617813000000
14428	3NKDYEWNhYMnkWr3PunMEJqV728LctekjzJwPMWBAP9nKzEkJTmc	14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	1646	1108	225	6301	10536	jxRfGmfg4TzH1uLMatd62bW6JwcfBVAoc5bHFoeuB5DPFjJA5u8	7361	10414	10414	1617813720000
14433	3NLbUuvmiyhNL2xMAycTLQB63EjDEdgD2YshmGqNhZ3EVwLPEd7X	14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	1647	845	225	6301	10541	jy1H1NafRdtyNbSgrLgVL9KgTiPhy8PaXZ45yV8VDtSqEQ5i1W5	7364	10418	10418	1617814440000
14434	3NK3Ka6LM3cxhZgdnZiY7EokZKSAwEGRTEDVN1Awo6SHsTLzfK7S	14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	1647	845	225	6301	10541	jwm2CsHMjA9zrPqykLRRJy62NpWyaMiixGZYYrUshtrzyDsQqvi	7364	10418	10418	1617814440000
14436	3NLV5PdLmGHPiJbagfDyRnYpYBsr6K4yc3ymfaHtwR3o2SReTe26	14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	1406	1393	225	6301	10543	jwr3unZaQXEoVMzBEPijxQLX7iGETMX5EnCsHXmecx3tDLtBZgL	7366	10421	10421	1617814980000
14438	3NL98ZNCoWGjFNsx3HRvqqgKac4yRx2FmFKK2cA616PskB29x8sy	14437	3NKZfAnC6oryCuu3pGuqEthwjS5pAqUsbNBfYXZBsgsiUv8Z3XrJ	470	1309	225	6301	10545	jwqceU5H9TLBVb8udVLHmZBdrg1nDtevy6ywp1zru3Gc3nfyyWa	7367	10422	10422	1617815160000
14441	3NLaSgzViMZVcHyod8fBBdB8Af5oB3CcregPkr8PPwWP7BagHbd2	14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	1447	1099	226	6301	10548	jxP4uUc6ysytR7WZMruuLaQDVBanWGGowoLyYpzLFFtjACwGeAq	7370	10426	10426	1617815880000
14446	3NLGMisqNgGYed26oNiHk3pnodn8yhDptMLhU2cByqHpqi2G3CtT	14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	1642	280	226	6301	10553	jw8WAzbL7utUDSxbzHvkAQ1q9SC74EdQV51uX2wRRUtbqbk5Gnj	7373	10429	10429	1617816420000
14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	14450	3NLS4x29stoogXb9vKsfEQDRqKwMHJ3PgpuZGGuvnDrs9Nb9P51n	1560	1291	226	6301	10558	jxyAnVDdMbpohWT74aZkECsPM1Cru7hBBYnviYNzU85szUUuqXr	7376	10433	10433	1617817140000
14456	3NL6hxcXR3iphtAuQCSyKSgymzyGQk6ErUFt83VismNKveDUeFdc	14454	3NLiDFWrGJi2Mq3u9LPjLyht3HmyVoNnTajqH5qH3LaWW1nSaGAD	1406	1393	226	6301	10563	jxg68beP7Q27HWXBuE649yZ3cgv5qmPG62mVgssJ1gfRq2pxWwz	7379	10437	10437	1617817860000
14459	3NKm4qMAsqULNnXTN253n8AeGiJRsGHC6N88RmVC2w2E4mWvt8Bi	14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	1542	1304	226	6301	10566	jwiZ3eN7R8VMZXpsu8AjHSiBAGoXpCvEDmPDBQDbnvyoqsLYDys	7382	10441	10441	1617818580000
14461	3NLoaHgNuRpDyaAwusa21Yoa1n9mPNPGm2Zi8WAdwbmcBMPJF6dQ	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	633	1138	226	6301	10568	jxC7SLTi4cqcH5yFG5YbuKbLwLd2FZVquxErdybiMpbrzR1U6Hp	7383	10442	10442	1617818760000
14464	3NKsJENgY9qHcp4onjDBKrpdZGgjF3bAiPWLbvhwJZZA7vurCLQf	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	563	1113	226	6301	10571	jwBt3rJqdm38pToscakbD14jXrMwEu4jruuY7eDsJRc966fnzdd	7383	10442	10442	1617818760000
14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	1602	1369	226	6301	10578	jw77cHouaRaYzRNFbTAU1crzsMFe73yKbbmeg27KDXFrvmdC8Wd	7387	10447	10447	1617819660000
14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	1671	999	227	6301	10583	jxqNBo4jnq6VZfkNbWk1qX5QKyCysPAxLBrcEJuc9edeJ9ZTc2B	7389	10453	10453	1617820740000
14481	3NKgiysWzqxmDZ2GkpPUffMoE5ukZR5SZyRwLXe163dDmEJjbfpE	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1405	873	227	6301	10586	jwH6c9FkB7Chyo9inhvbb5bkdxjHByqUgua79LMaMyDEzQ4vq6X	7391	10457	10457	1617821460000
14485	3NK4jFasyMz9nbZCtBpKuR4Uvb5xdQwZonGZFCJM53WNkRNVDZtu	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1578	1050	227	6301	10590	jwoPWQS6WsuTT4Gx8pnkcqjcQvV8rVAjMTuGgxFpGshY4qM6onM	7392	10458	10458	1617821640000
14370	3NL1LnsHRGYi1N1zSaPAkbtSMntk5FoQkFxhkVSABeRdWbpDxbsU	14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	1422	1091	224	6301	10478	jw9QKXNnTyGwhADxyz1jYTkCVZFwcsPq57KNMF8BhbKu7exkp99	7333	10373	10373	1617806340000
14372	3NLbeg8PxxYiCfALmRwU66kV6wX32HwkR2wwvRQLRPDwin8G7aEZ	14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	1405	867	224	6301	10480	jwuWW3EPZJiCnRgv2GVKpFbT2b2hKpmC9SW43vRyed9NuPcZrye	7334	10374	10374	1617806520000
14384	3NLGsQ4fBku7EXSaguj7b6RecXbxTQCmTRsV33GSZzCXCGggPTjd	14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	1672	1285	224	6301	10492	jxzPNpTPWFAhMQDQ8y1w5EuFzXi1urMhZyyvxv4u4865k3JVmW6	7340	10383	10383	1617808140000
14386	3NLqgX7JPuFAXf4vcYE7ieXu5nYTEeU78Pui5EHX6E2JZyzKwhxc	14385	3NL6brMZKzdR8pBvxKHx7AcVy9XCeYXHxoHkVqoi8qc8n42UNWWg	1627	1385	224	6301	10494	jxPpfQbazguieh29961bjHcd4gNyreh6FoduMhidBHq8jyptkCZ	7341	10384	10384	1617808320000
14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	14393	3NLjxTy1ZAxQA45tPZUTEhSNpLePbThNxtZywaXNiEu56MW3vxJr	1631	794	224	6301	10502	jwm3YhFRcVep5nF81C5uMLXTdKdTFTzrh8BxhQMqsuWqdBiQaLy	7345	10392	10392	1617809760000
14400	3NLFLrcVn3mY9piPRhRymanDoEQ3WAc8yMdSzz9Ta1BAtK7JJFWV	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1652	949	224	6301	10508	jxL2Qj1zFicJVtsW7k6dqsgLP4YqujNk7jciwSSxtSjXXKCWLr5	7347	10394	10394	1617810120000
14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	14399	3NLVmM1uXGerMj4Wx4CGLfLMKvZHQyPfpxSoHu6J1nsrCGHgiqqL	1593	980	224	6301	10509	jwrSmZkxbQcS95Js1sFEPfssHMfiHwMTZT3d7dM1DNZHJNJBNSs	7348	10395	10395	1617810300000
14404	3NLbVQQbDYsHe43Ge9GRDJPJpTxPxryuY8aBmFXF8vaCuyjPMXyW	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	43	1310	218	6301	10512	jxyGDCwfukW7jGUzD2DbHzXxgPfxMpchBuExjCwef88r6XN7aXv	7230	10396	10396	1617810480000
14406	3NKtREMXLdQgmYTspZayaVJHAtR43VV5HdhrJgdexWLCApWuxBqg	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1553	776	224	6301	10514	jwsGB2tvLyhR7JVjmoVtPpHQhgSmq7WmaN9yi496CcToT7xaR7o	7350	10397	10397	1617810660000
14409	3NK8KTz2qREmKm1qyupFHRqRmsB9Ks6fKoYft9EQd1Nj5zCKMMJH	14402	3NK6yxdPACVKK1514e2veBDzQBbiojdUTVDK2gYRNo4tA2sd2TB7	1506	1373	224	6301	10517	jwsj4Woxbsbe94vaNs7nuWYqJMWUecZBhinwmpokF1A1sB3pXAK	7350	10397	10397	1617810660000
14414	3NKNLxSJggUutHbFSDWT3mfJgfoLmMZy9V6rceWHB99Ld8n9Efdm	14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	1600	1246	225	6301	10522	jw8xtMTQWD4B5KkoLyw7wejGF25dVyG4TWBZF8fJYhA1dPAVtQm	7353	10405	10405	1617812100000
14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1534	1317	225	6301	10524	jw9GRVxptYY396ezd7xiWFLS1dq5SFrdJN6vhSBse9CgH7J1P33	7355	10407	10407	1617812460000
14420	3NLmyX8jAwEEhSM9F7KjQ3pEUX282MvaefP2HhJ4Y7PDdr24PK4d	14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	1637	816	225	6301	10528	jwZYteJJtNJ1fUhNsTX7DCwBRhgdhJwNxfz1Q9P5TECkVcAYgw6	7356	10408	10408	1617812640000
14425	3NLyC33j639CwngrdThH6iLyXgzYoApzFvT41jciobhbC2nnnWcs	14404	3NLbVQQbDYsHe43Ge9GRDJPJpTxPxryuY8aBmFXF8vaCuyjPMXyW	43	1310	218	6301	10533	jxeXryFEDRqzPgCpGgFVAwjTsYkT6sM51NoPBBr7emqmRkD96jh	7231	10411	10411	1617813180000
14430	3NLgLuwXPnFce1tgtGLrqdF6W2AcUEg7SiJJUJ28NrEDVUtaKqZU	14387	3NLhjobMpxPYLNCnv2sv6bN3bBuKBPzVHt76mnNjEMZJFF2RytQy	641	970	214	6301	10538	jxJnWMfpip4uEJD8Wb3wepy6UGPXyDW7dNK68L1nAgehfA6J2bp	7166	10415	10415	1617813900000
14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	14434	3NK3Ka6LM3cxhZgdnZiY7EokZKSAwEGRTEDVN1Awo6SHsTLzfK7S	1426	998	225	6301	10542	jwu7FZYoWuYH2DRh8Rngow8cFLQkP7xVJVwA1Ps8yFXC1r6RCAi	7365	10420	10420	1617814800000
14443	3NLSUip2x7ovUJQmvBHzLz3ya7zfHQMEjknLm84MRQXVwKBbDqV1	14442	3NLHG45LQ23M4SM5MMwVNWwXXY1orEWPuQECmm2R4ikVHA7iRYRR	1489	1254	226	6301	10550	jxAJbGaYUvWnLSrC8FYDpdrnUf5HdMun1GSpaK8HP4y9GFZQRQo	7371	10427	10427	1617816060000
14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	14443	3NLSUip2x7ovUJQmvBHzLz3ya7zfHQMEjknLm84MRQXVwKBbDqV1	1406	1393	226	6301	10552	jxNM2KLzeeQGS77b4ea22QNgq18mgYzcYrtrsf5f5ER7tWc34XV	7372	10428	10428	1617816240000
14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	14447	3NKHg4Pxsb1jj4zrzqGPgyZfk13AXPZkzQpx76HuQ18oK8dUJ5a3	1671	1365	226	6301	10555	jwMspkDs21qgEpKhSVSg4TRVS3bDde7BbXdaAyWt6aT93gxYs5D	7374	10431	10431	1617816780000
14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	1559	987	226	6301	10560	jwHVzT54CXzvB7y4AGno2YYm7PudPnm9ajfDf5cibP1LcaswqMC	7377	10434	10434	1617817320000
14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	14457	3NLX3zJhrVamwC68PmmZSfTxaqG6x1iTuD6iqQtar5JktQVmw3C1	1631	794	226	6301	10565	jxdonqqa1LUjhAYw4jtNceTrjc9V7Cjsavdy28QEFz1H2QHcRnS	7381	10440	10440	1617818400000
14468	3NK7VwnBVRmAS1BMKs2WJx4YX2cbn7z9nGYt9ndvTgBXC1WJxed7	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1406	1393	226	6301	10574	jwTJQN1Dr1fJ6758MzsgjuPnhknuyQP7ocKmPa4LxhuRkau9rpF	7385	10445	10445	1617819300000
14470	3NKPeYTs36KSxtJsZ6HpAnDv5TRUHRG2h5mkxjZd9SUhXeAAhYVM	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1613	1223	226	6301	10576	jwHSSsQkHtMPrm19qr9P6FunEDFc3gZYvw87H4nbsiDeGDpjEpf	7383	10445	10445	1617819300000
14472	3NLZB5PAjn7WRWPhYHMVH56Bb3icCzmZkH1Ta3ipE9ZUHbg4A9Lc	14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	1602	1369	226	6301	10578	jxfR4BwyGNqNfSbLKeJYthUiCT5yhMD1UEUXjkcysKztSDb57ET	7387	10447	10447	1617819660000
14476	3NLubvzZGKVTM5VJ8ZhrpuQN9Ck4gbQJrHyR5dfxHmGeYjCGyGL9	14430	3NLgLuwXPnFce1tgtGLrqdF6W2AcUEg7SiJJUJ28NrEDVUtaKqZU	641	970	214	6301	10581	jxJnWMfpip4uEJD8Wb3wepy6UGPXyDW7dNK68L1nAgehfA6J2bp	7167	10451	10451	1617820380000
14477	3NL5f6cK8L7u32tfqYChCpZebqJCf8RQYdGw29SEfN4sp7k7GYgW	14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	641	970	226	6301	10582	jxVQyeziaPnZrPTJccav5DQqSASi6NfDUzHMfBmH2yagiUidrMy	7388	10451	10451	1617820380000
14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	1403	786	227	6301	10585	jxLYFE8g2HDERDy3Z3YjkmgbmADrQA5CUtj4RGytZeiTjXdcJL4	7390	10456	10456	1617821280000
14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	1555	981	227	6301	10596	jxNRmAbU924xG4FFhFcLt4xEr3TrbsXgmADVrRzu1vrD42nREcr	7394	10464	10464	1617822720000
14497	3NLbmAvxW1aDHGFm3XuYKafutZNz9rEJepToCVD2Nz1tHES3Yx1f	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxbyFj4bitjK8wHBeaxMXzpTDK6khqmXsF5WnXdUSCWPHCJEDx7	7396	10466	10466	1617823080000
14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxr73UCqfmjA9CFAwdcH9KMbjEuYUJ3UogCuiBKzRz32PvHRMTs	7396	10466	10466	1617823080000
14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1483	1030	227	6301	10602	jxeSPcXr29Yxd6QeeQmS6WqsJET43VCHqde6vJAj4woti4D3Bfq	7397	10468	10468	1617823440000
14504	3NLLLcLRysy8aHnPNk4KdVS5myGeiitpMZn2jRQEQjjadrBx96ie	14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	1406	1393	227	6301	10605	jxn496zeGhf6Tqt2BJC2hDvapV3VsE1W6RqMEn93yCKnPDyrQpP	7398	10469	10469	1617823620000
14408	3NLw2gnavQw2Mqy6xPaWG4K24tigvCm7ef31ADJYvxrap6dLtNxz	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1506	1373	224	6301	10516	jwidKcKT5Q2svHpdAoi36dqzwMTyu9H98vkL1ikmR78sZKNdg6L	7350	10397	10397	1617810660000
14413	3NKLGJDUD9x8oyX6GhHCkyLd4bkgSN5UenFW5vHqBF2MX73bqQ1P	14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	1407	1395	225	6301	10521	jxwfgnQMSsY16BgtVtihB9cPamjnfNmUwGbZQSeD6pbQ5cM5YSo	7353	10405	10405	1617812100000
14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	14413	3NKLGJDUD9x8oyX6GhHCkyLd4bkgSN5UenFW5vHqBF2MX73bqQ1P	1627	1385	225	6301	10523	jxVQAgoNPtHTFHi2E3azumffXCPGUkwo8VLW2AYbsp2Y4TVZD8Z	7354	10406	10406	1617812280000
14422	3NKEtLRPdye2noVkcY5pzz9mixL7w4jTD2ggZHAQeww2TT459njD	14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	1647	846	225	6301	10530	jwMuPwSX6bReW6cECbwmtxAPJYWDaUK6U6tkoEoCTV5oxjsLy49	7357	10409	10409	1617812820000
14427	3NL94iMMmZjLoBDwkFuRTxPxxhxVfcLy5emEyc4i2rKQu58Dns83	14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	1631	794	225	6301	10535	jwnL9MQv1qsxxWLxvozwb3ZjNPuEJADZgJXBDMjN4ZfZCKcdbUx	7360	10412	10412	1617813360000
14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	14431	3NL8ng8byGvvrHL7YPTVfMVp7xL1h9L7rKv5LjVHB4YsQJPT6gLN	1631	794	225	6301	10540	jwLLdCgWqyXVkqow9X74zCAgc2vyB6SQqvrKpBzXLfVuDESFckq	7363	10417	10417	1617814260000
14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	14439	3NKwHoEMXT7hzVsrVAYNhsSEuyhGtYvLwBQupceVGzFzPGb2qtjt	1460	440	225	6301	10547	jwFTvtGEbDKaLnnxFqRrywmCN7MQL5YqN9PxczWbxJAseX8EWev	7369	10425	10425	1617815700000
14450	3NLS4x29stoogXb9vKsfEQDRqKwMHJ3PgpuZGGuvnDrs9Nb9P51n	14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	1560	925	226	6301	10557	jxruFEWj9aE323pHwYAfMRAs9H2UDcHRg5WgA8UakYRAoNKNoo6	7375	10432	10432	1617816960000
14452	3NK36pYbDf8krnNkTcNF1P4yvPQq2paQA5htwVJgRrrzn4svTh4G	14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	1547	1378	226	6301	10559	jwJTbgtjbk746VPGyuziFrf6yHUmGtTB28wUeQkoTitz8WWncfN	7377	10434	10434	1617817320000
14455	3NKKidQ53vscWzs85sKBGdSv8DaT77nAf67DX4xYRoHGgkvieAv1	14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	1633	1144	226	6301	10562	jxTmppPVnaii3VSfGT23xsSfGTdYrz2H1aGo5NGgYkL9xzWKLtj	7378	10435	10435	1617817500000
14457	3NLX3zJhrVamwC68PmmZSfTxaqG6x1iTuD6iqQtar5JktQVmw3C1	14456	3NL6hxcXR3iphtAuQCSyKSgymzyGQk6ErUFt83VismNKveDUeFdc	1407	1395	226	6301	10564	jxYNRX6GYetpsJAYmmTAhptbTTs56oGgUuKkkSyxafJZumnL4P3	7380	10438	10438	1617818040000
14463	3NK689Mb2cEoxBkm2x2ehH1RUeARS6VeVcktVNKXg9MxtuiEVNqb	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1600	1246	226	6301	10570	jxz4kenpEFS841gRXvQBjzQS4jjeh6rT4UmKn6G5qLhrb3ZfnLJ	7383	10442	10442	1617818760000
14465	3NLec1F8SydjYEwhjoiDU6gkbBRnPL9tQwWeyHRUnSBqWz1dvDXv	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	563	1113	226	6301	10571	jwVq234kP13AmWGYT8SiCS3aU4dP1vva2c97knDLTXTK61Wqmbr	7383	10442	10442	1617818760000
14467	3NLaHvQQryQXXvafYwoZmo3uM4pk3NpPtSmeR8ppMQ6ifpXLpWF1	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1403	824	226	6301	10573	jwtp7UAHGoohADEcjHjucUQQyBFcd4kkqnDyTt4ajWoccXge84U	7385	10445	10445	1617819300000
14469	3NKKpVG5n2cNin6uAWDpxSD3LHTP2FAonxrtC6sY75nDBTvZuWMe	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1613	1223	226	6301	10575	jxqXpQ6U86VENxpXegqFjm4WLUxKA6cffqNiyoTUcfb91zcEB5s	7385	10445	10445	1617819300000
14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	14469	3NKKpVG5n2cNin6uAWDpxSD3LHTP2FAonxrtC6sY75nDBTvZuWMe	1619	909	226	6301	10577	jwVP8UqAG8B1mbvVuqUAGPjTjUcF47MaqooV1s76rUBsW4b3oh6	7386	10446	10446	1617819480000
14475	3NL4JRUwo1K6DHKbiUaGA8GDu6a3ngHPD2HgLNhV8ZPuVXAGU9Zg	14429	3NKdzLYCwfcmy1bkgeoniHziwLuXFPfngL5GpRAvkS1q9FvjYKxZ	641	970	224	6301	10580	jw7DyLHCeZ3SaANPzv4cjGQBEKQm3pLQE9HevF8qgSF6erF9Nm3	7351	10451	10451	1617820380000
14483	3NKMTGc37bWH6mUrYsGAaUU8qBpiw88ENDH5zTjnkRUUEZjtAgfj	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1609	1333	227	6301	10588	jxkKu4SmCC4aoFcZZ2eJQopgA1F5Q7PMn7MwHZao7sD7N2pVnjU	7391	10457	10457	1617821460000
14487	3NLTpaoyKcoPn7gSaRMXp4UD9JP5TaGZ7C7GDi4bzbTN6VuRwAXz	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1407	1395	227	6301	10592	jwLUaXoGgQZV6mmC5tToJjXyhnBAkFsSorf6TjvATjxLSWCm3fF	7392	10458	10458	1617821640000
14490	3NLPZwNkf8ivd7jtXu2pRiCjvfW7qHmpLCy4RwHL7TydtkMNWawM	14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	1549	1116	227	6301	10595	jy1Xu33GK7SDUwMWpQNoMrrirhp3zhrFdBdae6Wzc8sN4YekHSq	7394	10464	10464	1617822720000
14492	3NKXq5FqaiPwUdesPaikqp6Ro7Mw1QUTka7w2rMHdva7VfbxL3F4	14362	3NKnoPk9LmAhNE4CRDWKYMGQESFMAXi9M5aAg1GNvKjmcWKPGCBb	1549	1116	219	6301	10597	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7239	10464	10464	1617822720000
14495	3NLv9CrQ6aeFRW7Z2a27ddxziFshVKAHnwSyM3EqQEf9Hmfwzt9F	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1607	1348	227	6301	10598	jxdhWsM4PXP9AnHKuZ52rCiE5hm5T9vKh64uNMX5kznNtRcyJSd	7395	10465	10465	1617822900000
14496	3NK5F3aVirWc41U91YPcKgHteQ5j5dSFQN2NceiwjKcTnZb799Sr	14357	3NLY4CD4UDRXgpLfCDhQWssnFzDoU3JaKMrcNFMwAUAPAtWAFXNJ	1624	1088	218	6301	10600	jxtMX39QqqPQSrGtZXnWQyCe5nKv8z2EPFMMUQy6164naaEu6Si	7228	10466	10466	1617823080000
14501	3NL9UtTSKttZ1xhc6qGUkL2GBuiVsS3u5r3trm6ymqytPttUtRNn	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1406	1393	227	6301	10603	jwUSwrvTR2PUkpTLwUP2XzF9WzH16eZFuWbmzrKHkgmFY4HwRp1	7397	10468	10468	1617823440000
14503	3NLNnY73iBR8RRAXqroGinKmFPHQ61ybcMYHUG9uCMVvHituMoWh	14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	1553	775	227	6301	10604	jxu2729MvrGFP1voUUwARc8W6wnnhHsww7rjs881DKPcZdptvQk	7398	10469	10469	1617823620000
14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	14506	3NKgEQwYQDweZbSSvLqfWzGYLHMwiygmx1eB741YE6c9crHL9Gcc	1637	815	227	6301	10608	jxy5xYbbJSvzy9RGTz3bUBSeoxPgXWR2P7Jiz9AH2xmvo2BfQaW	7401	10477	10477	1617825060000
14515	3NKjSKm3XsR7N1M3GPkijFxPNdJiUcU8tfyPnbDtmkHTQFP9PLPA	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jwabUEe69ZqdRhPdeVfxjrKRZULSo4BiJaTLBkVwHw5o97eGA9m	7403	10480	10480	1617825600000
14516	3NLhxCvEFZmJeA4mhQ9TVN6Zd9unfVSYDdjN9tpWx7Hf2wEqYm7Z	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1403	824	228	6301	10613	jw9xx4pKv5ABiw8TEYJsYvGuALxkoRT4mdv1WGFHzbQ2mRAi5E2	7404	10481	10481	1617825780000
14519	3NKEPzSMw7ZKRkdRrhiD5JzU2mF9v2HwoHoFDRBDxJ1sPGpv3KfQ	14492	3NKXq5FqaiPwUdesPaikqp6Ro7Mw1QUTka7w2rMHdva7VfbxL3F4	1549	1362	219	6301	10616	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7240	10481	10481	1617825780000
14521	3NKmA62eqX42eWtAwjzMuc439mYEB4f3GQWi9gMmqDSnhcgEdxFj	14520	3NKeSX6Dr94Jmsat9MTpT9xFajAcsvWLXGd2zoYHzD4R9ZPLyLwE	606	1295	228	6301	10618	jxWN2XRZqYZWHbXMXNeBbsDWaNkzqdNm8PfdDPP5ME3DHWoPYV8	7405	10483	10483	1617826140000
14523	3NLf5Aa2raeiaixdXTtRaMRLD5Qj27Bmc8MgPYhEn5AS36zdUP9D	14522	3NLDweopypXEqekt2fmutdBF8oMPA3nidQhHrKcPy4XGFw2yBT6G	1406	1393	228	6301	10620	jxyKfvSDzXMKf5RtMRwS5BE3q2RQYqxcXjFWJmjaJqzZCREnCnw	7407	10485	10485	1617826500000
14526	3NKPRcBABK4K7xkF65hyKyxFBwGQUfGCaYsiJDuB5cCXmwuUKbXg	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1406	1393	228	6301	10623	jwzsm8hxhDn6VTsJ9nGL4pkgSHxBrM95Ex9Rkxkz9pGEmQHf2kN	7410	10490	10490	1617827400000
14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	1407	1395	225	6301	10527	jwTaFVLHwks6rUZxM7d4xML5JtvJMq6THz6WdN8L9rNced8epHG	7356	10408	10408	1617812640000
14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	14423	3NKKDU3XwR3cbtbiuEAF9v7etZNBBisf5syjwtG2DDTjDxEWG2fZ	43	1310	225	6301	10532	jwCyJoHYhyNmMizkx8YcK91WWdCdRG3iRZWgSmZ4J5Yo9Pc4Vap	7359	10411	10411	1617813180000
14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	1406	1393	225	6301	10534	jxevrMSV3DXXoa7gU7F7Rg2VG8f5BbmXhNRrsC7qaDYFoQv9HPc	7360	10412	10412	1617813360000
14429	3NKdzLYCwfcmy1bkgeoniHziwLuXFPfngL5GpRAvkS1q9FvjYKxZ	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	641	970	224	6301	10537	jwpK88AFdQBsU4CGK8uKfvYx9hqNjDEZrFxi3E52hK1K8xHBkzP	7350	10415	10415	1617813900000
14431	3NL8ng8byGvvrHL7YPTVfMVp7xL1h9L7rKv5LjVHB4YsQJPT6gLN	14428	3NKDYEWNhYMnkWr3PunMEJqV728LctekjzJwPMWBAP9nKzEkJTmc	641	970	225	6301	10539	jxYukPfjPiS9PmNdT912doKX8ih7uDNDzMUoDK53ZVjHACfo8Gh	7362	10415	10415	1617813900000
14437	3NKZfAnC6oryCuu3pGuqEthwjS5pAqUsbNBfYXZBsgsiUv8Z3XrJ	14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	1547	1378	225	6301	10544	jwPa9M4pB2MbY5fJVMPh5kAwSSimxySMtxXxUMP1AKznCW9s1x6	7366	10421	10421	1617814980000
14439	3NKwHoEMXT7hzVsrVAYNhsSEuyhGtYvLwBQupceVGzFzPGb2qtjt	14438	3NL98ZNCoWGjFNsx3HRvqqgKac4yRx2FmFKK2cA616PskB29x8sy	1589	1286	225	6301	10546	jxztMaD61a5jiVhBXzwyuaUr9hH6JPfDnEeUrGwg9HhZ1fag18N	7368	10424	10424	1617815520000
14442	3NLHG45LQ23M4SM5MMwVNWwXXY1orEWPuQECmm2R4ikVHA7iRYRR	14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	1642	1241	226	6301	10549	jwJeK7MRtmoF7PoYBD9iLdVqkB6W2UEsppHURgHPEGHRHopxAuc	7370	10426	10426	1617815880000
14444	3NKRhPKew1azQU7aX7hauWZgU1Hpf7yXxAeBhQQ9ygsETnuV5nYU	14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	1455	1332	221	6301	10551	jxbgUCmM5Sw16nvgL68e9Dd1HMo7cQ3taEx8PSrKwm4bxr9HEyf	7289	10428	10428	1617816240000
14447	3NKHg4Pxsb1jj4zrzqGPgyZfk13AXPZkzQpx76HuQ18oK8dUJ5a3	14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	1622	990	226	6301	10554	jwA4JyAYxWTkdAoDTVWatXAm8UmPvtgjuTmDFa7ZxSbMrW2ThpL	7373	10429	10429	1617816420000
14449	3NKoDd4HqLpt59y76yBUYxnLEvJMPGTKouWhPerzF3KwyyacxsjV	14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	1403	824	226	6301	10556	jwmVNdeo3HYgZLvPpXnCwDTV9cLf3scVVayveVKTWjfac6z4T4u	7375	10432	10432	1617816960000
14454	3NLiDFWrGJi2Mq3u9LPjLyht3HmyVoNnTajqH5qH3LaWW1nSaGAD	14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	1648	1284	226	6301	10561	jwWqntdRQpmxmm6JsPBRuahfqSKdY5dZaR77apWnKdwgJHkz3d9	7378	10435	10435	1617817500000
14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	1445	1044	226	6301	10567	jx5G4Bu2Mhs9gC2pwjCck9vRQg5GRqALk4oFYuVy7PXn4JpJLXz	7382	10441	10441	1617818580000
14462	3NLsMQGmeVJC3VCdhNKfqmzd8iSrb3WnQkLfHDzmQ1yUaCmtGa6v	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1522	1322	226	6301	10569	jwx9FqgVp2h41vRP714sDe2YucokAmEzfVVwdY1JK49wqBi9Xqa	7383	10442	10442	1617818760000
14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	14463	3NK689Mb2cEoxBkm2x2ehH1RUeARS6VeVcktVNKXg9MxtuiEVNqb	152	1084	226	6301	10572	jy1m3mBDxYdHNZpYuyD8FxadsfPoHVVqHh9ML3A24wfCM1sUBg5	7384	10444	10444	1617819120000
14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	1617	1042	226	6301	10579	jxcxurQeCwQguzT9sCbhFnCkRxnqbFmLUzQZeA5xZ8AJWhfUQ5S	7388	10451	10451	1617820380000
14479	3NLHqzSeha2MWKiN6mh9Y7GWpz9yD61pZcGB5dVvjnkboLpaVT78	14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	1631	794	227	6301	10584	jwh2TgpawHHG5KsLakbR3ofZqA6qbzt1Bnp92bd8wmEUHoUB225	7389	10453	10453	1617820740000
14482	3NKUDKBUPY11EDcTXLfKftCN5Ex8ApfKYZabzw5vaaoiBiwcxqYN	14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	1609	1333	227	6301	10587	jwWQVhttnAQzqHs85NRnmFKVMUqNfuZmA7dTrKeWq2hwmerJfP4	7390	10457	10457	1617821460000
14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1506	1127	227	6301	10589	jxToQ4kUTFRQx3Px9EffB7HcLUXcKomkqXuR3JkNS9uSxjtSdsQ	7391	10457	10457	1617821460000
14486	3NKHBXyqF7BFdGUp7Yq85iJDtKvQy51bpDjbcRLtjUE9myfvZnhp	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1403	782	227	6301	10591	jwSzitqWE2LQVon9XwaDvUX6PDSTccLoTjF1bhz2Asez61F2ZHe	7392	10458	10458	1617821640000
14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1407	1395	227	6301	10599	jxd54mgJUbXwZ9xhunwJ2yCQZngQJpDentLNpizfotwkPNyg6Q8	7395	10465	10465	1617822900000
14498	3NKYS228TfHuhA6w5W6aUdYHkePevyQWu6oVvnouVKSKJeuKQszq	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxSEQVQkrfv1DuasB46bC2zu6Zrw7dBgkrb2QGh3ULTr4mcVgVe	7396	10466	10466	1617823080000
14500	3NLHaWM4EQJvnXcGrJ7VXwh79CkfmCsCEUrfXUnAXLWpJqA2Fx4N	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1483	1030	227	6301	10602	jwoogcpszdfoeksubB6MQSoW5eLFbGb2fh5BZ7YJuojBANDpuvo	7397	10468	10468	1617823440000
14506	3NKgEQwYQDweZbSSvLqfWzGYLHMwiygmx1eB741YE6c9crHL9Gcc	14505	3NKSmqZT1jEdo1ruGH9stJ7kT8hj8HGmfixsdnMoAyqKBzXqoAfu	298	1308	227	6301	10607	jxuwmRYEoZDuahAEz5mFhwDxpk1D9XkJScZUKvgqYbZmHd1WxJq	7400	10475	10475	1617824700000
14509	3NKkaXrcqHZ9mzYnf9DdqmcPJEuCYd4VFPHQevigJuVeF5xwJhM8	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1483	261	228	6301	10610	jxfc7c1GVETfyeXJMoQLJ2LwGDB67WeZknpGAGbUZddPJJRWooh	7402	10478	10478	1617825240000
14514	3NK3DwerPa9q4v37iQEhNSxWZoLfzoyBKXkNoRE6VoE91f4gFFMW	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jxA7g6qYYn3fFmhBCrPYxNQLyUsaucgoJxNgH34sX7xt6uSUmTR	7403	10480	10480	1617825600000
14522	3NLDweopypXEqekt2fmutdBF8oMPA3nidQhHrKcPy4XGFw2yBT6G	14521	3NKmA62eqX42eWtAwjzMuc439mYEB4f3GQWi9gMmqDSnhcgEdxFj	1585	1120	228	6301	10619	jxRfiBThXoPSQLMWXWtJYoJKoHpnwzBUDuNz13FkJej5aLVoqQ2	7406	10484	10484	1617826320000
14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	149	1157	228	6301	10628	jwbeJavy9TaPABNAW454gNH1C4f6teC8PFU1otk64qC7c5YpqGM	7411	10491	10491	1617827580000
14533	3NKaZdgChgdxBXR6y1upNbYgG1dzyT1zKzrp6DwHgRgUi4WuHwU7	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1402	874	228	6301	10630	jwyCAxGpFPUnZLLtvwT3KmNjoAEe2KD6kJa6F6CDHN36KeD1iua	7412	10492	10492	1617827760000
14538	3NLbiYr1tZrk9piHbnMJ86jZgV6GZ3SwsE4iwJJtLCfbwoEt7ri5	14537	3NLdmwBepUoDv8mMR1gexAj7rJYBCdF8SiddzM8A6vpexgFhE8DY	1407	1395	228	6301	10635	jwx9QF5m1e6af2KsSQdKeLRZqbdkwrNEZ4CwPvonMdQxmwEDpvy	7415	10497	10497	1617828660000
14541	3NKD97g5GghYhmTpXWYjs3mJ6oyHEKY4ybPVMU7wUS3vPa27SWuy	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1403	823	228	6301	10638	jxX5G8Bb9dV6bziiUGWumVv1kww4dqceMNLoEdPcPpLydPjE4mn	7418	10502	10502	1617829560000
14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	1672	1159	228	6301	10644	jwPyh3GvfM7pjH1W2FwFV6QY2osvGydQDPb2k8QPTR2Ccs6iUQc	7421	10509	10509	1617830820000
14488	3NLEhTXfeLno4gLQmRihePtzdjk9P6Fq7ziLnkurezk1RFfAAfms	14220	3NLM1DDeY3i1PmVYXDYQFSvR8ZgHaGHDvDKWTuaFiCPXh3QyKzxi	1623	830	219	6301	10593	jwwLyb87HhobSiE1rjjGZ6kFDGTGJKUGmeSUZpiLqCQgqiUCyh4	7252	10458	10458	1617821640000
14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	14485	3NK4jFasyMz9nbZCtBpKuR4Uvb5xdQwZonGZFCJM53WNkRNVDZtu	1490	1274	227	6301	10594	jxu8Qa38pfYnm1pxMCMn55Ha698V3WoJY89mFQq94jhA3ALZ8h6	7393	10463	10463	1617822540000
14493	3NLjuhaAhuHyBPhBk7MxatFcqLXFaSrpeneQANDELEMon9SmGTUF	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1607	1348	227	6301	10598	jx3mdMxoZXodUWxhnriPFAFZgaAFVp2hTyPxjX8kSWBaLmnSe9Q	7395	10465	10465	1617822900000
14505	3NKSmqZT1jEdo1ruGH9stJ7kT8hj8HGmfixsdnMoAyqKBzXqoAfu	14503	3NLNnY73iBR8RRAXqroGinKmFPHQ61ybcMYHUG9uCMVvHituMoWh	1439	913	227	6301	10606	jwxoEjs4W88b45CbCNDpA2nrNrqfpjELRnFGa3pfaWu8GiJyNEV	7399	10473	10473	1617824340000
14508	3NKtJjXPVKa8dxQZuF8DmVGMrQgoHxZEc81R1PpAPBmhBfPodySS	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1622	1356	227	6301	10609	jxyBYdN5iPCQf94BWrHbvbAJdgjPUpaovu7QCUGExsZPuih75VV	7402	10478	10478	1617825240000
14511	3NK4HDmHArXt5Noap7SqSEV9jHknWMDmXdfD8CXdcAVjxB1rP4vt	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1483	261	228	6301	10610	jxCF1C1CBwq4TERiaGdwHE1jL37QF4Rigfrr2RBsMQ2JkAdCfor	7402	10478	10478	1617825240000
14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1407	1395	228	6301	10612	jxm9kvrLB2wFaAFo4RNGzwsSMMGKe8yVUMjH3bVFYE9nfLEKDZj	7403	10480	10480	1617825600000
14518	3NL3zcZgKrZkx3aBFHuX611Vir53bosF5r6FRUy8G3dUTdzSJ3FP	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1549	1362	228	6301	10615	jwLXEsauuAYNVQ4SwPq2D7MnVy1G7AgBK7tn32CNXZNZA1j4XAZ	7404	10481	10481	1617825780000
14520	3NKeSX6Dr94Jmsat9MTpT9xFajAcsvWLXGd2zoYHzD4R9ZPLyLwE	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1594	1080	228	6301	10617	jwPDppth3f6shhG1pb4gt9Qfr7K4QDvL1oYi6HmyGJgr3p2M5pz	7404	10481	10481	1617825780000
14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	14524	3NKLwcZdUCdAJoHBnzDPBdbWeyN9rQiX2W7VhPA1J58wugaDAEYw	1406	1393	228	6301	10622	jxKuyu9q28MCdMFut4YH7b35Ecf9WzjyxFFexrw3V59Yq1m7KKz	7409	10489	10489	1617827220000
14528	3NLP8EAEjKMw1fGBRwR4qKGAgnuh1cVaTMtCcusPS3C9RPhrETbs	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	448	1305	228	6301	10625	jwXXPi4P98vMrwUEn8qYhiKZvpx7LnioFsirqPWCSggDypuMbZH	7410	10490	10490	1617827400000
14530	3NLp4S9wVSEd9YAiD6avpYyxsTPL2mywBStuGNK4eSH12s7KqbwQ	14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	58	915	228	6301	10627	jxX5j6zrQHW22T6pRMEsJzXdCkCB1est44zx6Wtj4EXp57z29Dq	7411	10491	10491	1617827580000
14537	3NLdmwBepUoDv8mMR1gexAj7rJYBCdF8SiddzM8A6vpexgFhE8DY	14536	3NLK1knJ26qe2Hg9KgkyGsNziHRekNCjcNYSqHcoPabZxh8KpNnW	1594	1080	228	6301	10634	jwFEwQdu1shiCk7yd3AgSbcRq4FLh4cq3xq3APVQXV2XwdWzL4e	7414	10495	10495	1617828300000
14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	14539	3NLcUuSYkKbrVsson8faVsM8VCHAh9f8X1NdoA2Hq79TTMvEq6iN	1522	1196	228	6301	10637	jxLCegAQ3DQrFrS8vyJXq5Bont76RFw7u7sN63rXR1Um7Au2B4C	7417	10500	10500	1617829200000
14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	1657	1098	228	6301	10643	jwtshCKfLKQBP4Qoiq8AibqLLHjYcBZMLcXC4DVu3WotAQ3ozg7	7420	10505	10505	1617830100000
14549	3NKdSMntRKe3V785AzjbGBHAsUhoFiKEXxnWZZcf7hGuPRaA8PMa	14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	1611	1095	228	6301	10646	jxJs3UEAk8UR5G97ecZo6vW96EHn479D6EP8mb9yF9hGApCFrnb	7419	10511	10511	1617831180000
14554	3NL5Ubb3TYCmc4kyorLF9ucaSLtjaKod888rKALLtZ3Y5Htm2LpJ	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1489	1380	229	6301	10650	jwHeudThk4HbXrQ9bjvYo9eqkpNtADSTQaeXNZGdhYNMnARfdn3	7423	10513	10513	1617831540000
14557	3NLCchX4etVC62vdBZZmappmfZN7WcV9bE25uZw49JBqK1QmY5FU	14550	3NKL2m3D5FG2WfNzmGwyRiQcDXzozB1aVVdi6jpiurRGcPr2szX2	1594	1080	229	6301	10652	jxJqq8ZtoxQKAzZxqUriYvxbuS7cECr9V5V5WLZ63SpcAwcHU2A	7423	10513	10513	1617831540000
14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	14565	3NKWqo4G1Q5ym4M2Jx389srXywHkufoR2BKTQnb7BMU1C4dcHvhq	1506	1247	229	6301	10661	jwfSmNetet9QfPoD7ppeEkmFhXkSxKWcFfe1VWmEECqo873vZHF	7428	10519	10519	1617832620000
14571	3NKsrSXuNu9TJ7pozT1Gcbk4pr7UNhFnZyZLFkBKRiavzp6n9y7r	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1631	794	229	6301	10665	jxwdoCrV8TYtKawRv6s7uTAiBnL5B8VGndVzRPpzV4Dq4ffF6G2	7429	10522	10522	1617833160000
14572	3NLLrecye59C9Fg94B6zezad2aSX8QZQU9Sgmh9wnW9BVofymB44	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1646	988	229	6301	10666	jxDvrirjUHPwhGqHqrSDwwL47PfrYNzRwAmhFgMMUz9PEAAcRNC	7430	10523	10523	1617833340000
14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1646	988	229	6301	10666	jxoJGRX8oXPSqVu3mVu5j8kBfvR29z8X3wUWrcN2ez8pYwjzEQM	7430	10523	10523	1617833340000
14581	3NKSWctdKzQSxds2hibkKGR4LT89M8CThReJKKY5c1ZpghSESkZE	14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	1473	185	229	6301	10674	jxgBMW5gB3fdhuHL6APLfqcxkhSG4bm4yXf7qZftZVgU637idEJ	7435	10528	10528	1617834240000
14584	3NLTg6eEQJUnHPCnkqwtCZtR7xUDi8EuXQwDaeMNJtiJwc5tNWQQ	14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	1637	816	229	6301	10677	jxJj7qkJNbvSeKH8h2j9BUccqmPrNzcib4PAjU6mT8MgVC3hJ5a	7436	10529	10529	1617834420000
14586	3NLAetfeiKZiUA88pDj7NX9ZNHynSPNL13MsWdQ6Gnv1Ahttz2E7	14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	152	1084	229	6301	10679	jwFCnrCXUXEyriwicykPizaBd2GGEx7N8SWYuPfWLZYw1KiwBKo	7438	10531	10531	1617834780000
14588	3NLbPbv3HhLQxmscM1jKxnPmbpVzrB5Y69rkChETHHXqXcTAVXzU	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1403	824	229	6301	10681	jwEsG7GQcWk9WWiVpXzuR9wJBCUUS5NvQXu7xUWvchsyoesYkL8	7439	10532	10532	1617834960000
14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	69	69	229	6301	10686	jwL4BUAPpdVcaB9uuKqG182ZnUezyKhaJfFsuXDbajj84PuH8Kq	7442	10535	10535	1617835500000
14597	3NLCnsm7KFZFBia1btVa46JEVfxMLnhrg2PDazByrqfejU7rKfxL	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	298	1182	229	6301	10690	jxRSEzQoFKBc5Ko5tTunzEpudhSx7gKQL1RdB4rdLaziPZEBuDa	7443	10536	10536	1617835680000
14602	3NKBpAQi1ps3y3boEDvbQRnoiCAjr3hXLTsH4sLWwggMbZWNHGVA	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	506	506	229	6301	10694	jwU8m7CLdv2NWBqqqkv2LzRA62xHoTjxrUkRbfsa3soyxMFAo3E	7444	10537	10537	1617835860000
14606	3NKWBaShBhs6WNPLEhZPyKmbRahww85SiquXsRpcfDiZtBgkR1qL	14496	3NK5F3aVirWc41U91YPcKgHteQ5j5dSFQN2NceiwjKcTnZb799Sr	1624	1334	218	6301	10698	jwSebM5tbr1DKcYM4JLMHi6TKhpgnKNvCTkTj8uTVKwSueeYDgU	7229	10540	10540	1617836400000
14609	3NK6RCLfFSqpSQiAbZ2xziRYVFWZBiqPAniUCm7sZnTFHCXJZRMU	14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	1458	1323	230	6301	10701	jxWhFaXX8VHk6NE64HBoYpYjEyy8qUMFQWDSyKWi1PKknrPf3yo	7448	10544	10544	1617837120000
14614	3NKDAM11jJEHFR7Wc6GFN9XHGNEVjv1CCDZ3PSfGRGxfY2epxqzJ	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1651	1055	230	6301	10706	jwyuMcjy7RsvYEgfcmW2M5JSVZG1raAWuVdF3AtRbJKm2s9t4QM	7450	10546	10546	1617837480000
14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1622	1356	228	6301	10609	jxb4AZjxLwTTdGk9HyvVYohXgrAtLigfcwjrSN3VL4Z9dFUrwaQ	7402	10478	10478	1617825240000
14512	3NLZgC6WH4AjHUzRAdrSXmrnkfs8msjqUNCbQLRJA9yqF4VGsMmB	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jxQcsnkJhn3ouCdJQ3TVqKXgz4rgsnZuBdgYxU4peJa4AH3xB7n	7403	10480	10480	1617825600000
14517	3NKSoYrund9QwiTAKhZLEn8BGmJ4KxegQmo8UcErVWnkMKvTNKK9	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1406	1393	228	6301	10614	jxE9K5cabsEoQu9LVsbpX7tEPeq7ntXZSsvjt6xrnAwEc1swoTp	7404	10481	10481	1617825780000
14524	3NKLwcZdUCdAJoHBnzDPBdbWeyN9rQiX2W7VhPA1J58wugaDAEYw	14523	3NLf5Aa2raeiaixdXTtRaMRLD5Qj27Bmc8MgPYhEn5AS36zdUP9D	1589	1040	228	6301	10621	jy33u4m54kzkr6Xh49Fh6Tf2PQYFRfgH1ZNkf7Fh8cg9Gixzgzp	7408	10487	10487	1617826860000
14527	3NLxf3ohg7ZHhyPYDt6SJcYeQRFeXg5RGXEekj3arRX1bS6yacJa	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1407	1395	228	6301	10624	jxnxevdQ9cxknnxPwgoL8pHxx3vQVyi1CZkPkscXpUqPvwze4nX	7410	10490	10490	1617827400000
14532	3NLyV9roNLwxn9Ti9DbcmsqmMUHjZ48YuHH19wm229QqcA3ru7MY	14528	3NLP8EAEjKMw1fGBRwR4qKGAgnuh1cVaTMtCcusPS3C9RPhrETbs	44	1325	228	6301	10629	jwxy2a2L954oBUNenmEMNJKi9bvKbcubF5tG3b4yxkNfptu6GYZ	7411	10491	10491	1617827580000
14535	3NK7gwzepEvvUX8zhBsSgjXj57zLN7XvHiRG9bskcZxNCMEbJoUB	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1406	1393	228	6301	10632	jwvwmZ9WjahJcGBvhYptxXZt9KKNUKfETwR6JhAarhSgGHgFQFs	7412	10492	10492	1617827760000
14536	3NLK1knJ26qe2Hg9KgkyGsNziHRekNCjcNYSqHcoPabZxh8KpNnW	14534	3NLWt48q7MninuPrCosS8bqJKmNSFeY7boYqQRboQoP7gPpYWizR	1407	1395	228	6301	10633	jxx2Lmxa7tpPXTjSfLyzjPDtn1RVKQLwU2SsjgmhU7CXUoEBzaN	7413	10493	10493	1617827940000
14543	3NL39U4QNLHqnn3pNXzDssWs8SDPx1iNYJuE2aMVzNj6ybBfhYXN	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1587	1357	228	6301	10640	jxERCNtDkujRqVxyXdGK4ZajAzqDi9f3WDrYxaYjg4mBjn33Ect	7418	10502	10502	1617829560000
14545	3NLLtvR5Eht5xVUGBrAzNNMXT5VoLwrH6JzNPAx94AuwBZYVUcE8	14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	1503	1277	228	6301	10642	jxYYDaaeBeKUhVJ6N37N5BtfJsgtqY8con2wufWFLuMn5HoBR5d	7420	10505	10505	1617830100000
14551	3NKbEzeKk8FyjADnb9MGs2Ph9Q16LuYdyGzEdRhBo176qpR4kAtX	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1555	1101	229	6301	10648	jxuEtFTgZmVUwsec6V39oQ2MDRgH4QTqDyfSoaSukfp25nY2xRi	7422	10512	10512	1617831360000
14553	3NLvERoM2uKx4ynYNBS4FDsZ7Z5e2mGKB8LTmMLtTxUihY1EPVr2	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1403	824	229	6301	10649	jxjPFm6iJrVqdXVWvPJc2nLVnye8oHUuKdhyHqWQSEarRf5j2tD	7423	10513	10513	1617831540000
14556	3NKcsc9D3ZkfJXtAgAQtqk53yyQVKs8VVhkGzf1gxHyjYSM26zjV	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1594	1080	229	6301	10652	jxJqq8ZtoxQKAzZxqUriYvxbuS7cECr9V5V5WLZ63SpcAwcHU2A	7423	10513	10513	1617831540000
14560	3NKYq94XTtsqmfcS98fNJdia3iXQqdChqdhHE6scLudTXVK2D6un	14519	3NKEPzSMw7ZKRkdRrhiD5JzU2mF9v2HwoHoFDRBDxJ1sPGpv3KfQ	1549	996	219	6301	10655	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7241	10515	10515	1617831900000
14565	3NKWqo4G1Q5ym4M2Jx389srXywHkufoR2BKTQnb7BMU1C4dcHvhq	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	44	1079	229	6301	10660	jy15aBBDYBpZ71wakZtn22spXNzVmFxCHqTLBKVNaML1cuhnnbk	7427	10517	10517	1617832260000
14570	3NK4N2bAP3QjodLtoqfy492xbs4jWju1uiyQiLvUH6baM3YeSgKM	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	42	1115	229	6301	10664	jwNczgfSszSHfbY3J94DbXcgu4H3FG2ecPpVx49PPBVTNtFeFwq	7429	10522	10522	1617833160000
14576	3NLprTib3yy27pZ1aQhM8rF2mBZKP2tcjUnBtddZ3MxAbvKhaBH6	14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	1647	1056	229	6301	10669	jwDtr5tXDDKrovmWD8wumdJX2KShsRKFpiY48k3zr3fa5BjVeHJ	7431	10524	10524	1617833520000
14583	3NL6DxzUQU1uyEpaFPFWtfWvdeFy44UugNRrao47m98e7djiBWnP	14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	1534	67	229	6301	10676	jwZgisVBpcVKk1P4zikverdJbkk7GQRE7XimTExdLpZEZyS8X7E	7436	10529	10529	1617834420000
14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	14584	3NLTg6eEQJUnHPCnkqwtCZtR7xUDi8EuXQwDaeMNJtiJwc5tNWQQ	1581	778	229	6301	10678	jwjhaThwruFWpEXjedDxk2XcwtDJot9tbECWyQdiK6RPrRywECy	7437	10530	10530	1617834600000
14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	1608	1289	229	6301	10685	jxk1YabQzygZ4mjK6VJqWp3Fq9G5xdHa7FjeowtSp6MUyLB9GZM	7441	10534	10534	1617835320000
14596	3NKo7S2Pz6HpecFb9FNDkxjGTFoZfpgnNxbk7YLNJUpUg1WozGuD	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1559	1353	229	6301	10689	jxfTwo5Vnh7XR1mnDfSZUiJnEvRoisC24HcNU6eR7pGXc9z58ya	7442	10535	10535	1617835500000
14601	3NL7nPu4zAdLjH7bEqjgrukYiX3qwY765zWL2SGaCqKVfSUdqXTv	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	633	1384	229	6301	10693	jy1jpbMSBYdttKxHEQLSk1MvpWm1AsCdw8yWe2VYGSwHixLrJgQ	7444	10537	10537	1617835860000
14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	1624	1334	229	6301	10700	jwrg7qVC1jRY7UPHJEM1YkaAogj5r6seEvbaCShZ7YceNEuMiV9	7447	10540	10540	1617836400000
14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	14609	3NK6RCLfFSqpSQiAbZ2xziRYVFWZBiqPAniUCm7sZnTFHCXJZRMU	1483	680	230	6301	10703	jy2rpFym2aT24hDbJSiSRDVuiiBEqVFUdNGKSZ4sS2gvB7DTsc1	7449	10545	10545	1617837300000
14619	3NKKWxrbXXVUWzkxjEMHY1ELnQwmEoGFuYcY7ytjGsHv1KPaaHDj	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	576	1355	228	6301	10710	jxuLSEkZX22qMvXsCPtqakDSCZY3vnx2wzGHsYTAquh9JhDwhB2	7418	10551	10551	1617838380000
14626	3NKUiVLVJYct8MHtJmbPUvRbjGurcd35wQet3AGHdiTnQbEuRUsa	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1406	1393	230	6301	10717	jwofyZVUs7vmo1DQxS6P4aH4eKLh98H2PYtRR57uG55FPNEDq6f	7455	10553	10553	1617838740000
14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	563	1113	230	6301	10724	jx8zHt3btaJ8TKrR8aJzufsnZrKwevKxu9S7qUPfLdDGpdS1f5D	7459	10560	10560	1617840000000
14635	3NK5ajHJn4NkzRXZg5c6uuBz6yJmFunUhzESqSqre3md67XFcBbL	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1594	1326	221	6301	10726	jwdUjhVqsRqqDURBZP1jUwpoHYawzzTZN7mCcrzhjjkDrTxpnj1	7290	10561	10561	1617840253355
14641	3NLdGENPaSN917uNbnqfYi5VtKdGUxj6JhvuDMwwBvYNpVNimqbT	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	1601	1022	230	6301	10732	jwK5eQE5zv7db7DwPWDZm7fDKxXqb4vQs66ATE7s3pL5S27fcAv	7461	10563	10563	1617840540000
14646	3NLQjQaoN7KZqUSsbovjayYbVtWSyzQzjGyDh97QB1jx8VerdcCs	14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	1406	1393	230	6301	10737	jwbyX7wpZtkRsMHWmzvqvucgKBZATNwBVJ13qgF721y5nKz8kuo	7465	10571	10571	1617841980000
14651	3NLwSipKiyazwRUqkTWKhM9NVDEJVd6hwT3ftA3ZW8FR18jFBh1Y	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1407	1395	231	6301	10742	jxrbXBLPHRHckP1cRWAWEvgrFiyVJeNhm782QaEcPneubEAanyA	7467	10574	10574	1617842520000
14654	3NKwWKDKBJkPz7xAzeZuWzdwnXv9cW4ZUb6cinPfCfL7aagnVKV8	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1631	794	231	6301	10745	jwafqP6TCwKBXarrRsL99xJSMrR9FdYSUEMVowtaZBZfZfznVy3	7467	10574	10574	1617842520000
14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1631	794	228	6301	10626	jxBim3CZ6FhZb7zYSyfrjMdeQhvzvy9hvpz9T5GM6p2Vr41Teyy	7410	10490	10490	1617827400000
14534	3NLWt48q7MninuPrCosS8bqJKmNSFeY7boYqQRboQoP7gPpYWizR	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1509	1194	228	6301	10631	jwn5FoAgyPUP1VpUiTvXbgpYhJuoSAwLZfoHEcGsXfZFathz2m3	7412	10492	10492	1617827760000
14539	3NLcUuSYkKbrVsson8faVsM8VCHAh9f8X1NdoA2Hq79TTMvEq6iN	14538	3NLbiYr1tZrk9piHbnMJ86jZgV6GZ3SwsE4iwJJtLCfbwoEt7ri5	1483	91	228	6301	10636	jwfQUTUy2kAdF318Bo5d7oBzRy3fB97B6civt88nUNejwwq7QAy	7416	10499	10499	1617829020000
14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1627	1385	228	6301	10639	jwdxET9T7Cwnu1dGHexXUioygMCuHpn9BGJDzDyu7sLBBKeetaV	7418	10502	10502	1617829560000
14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	14543	3NL39U4QNLHqnn3pNXzDssWs8SDPx1iNYJuE2aMVzNj6ybBfhYXN	1407	1395	228	6301	10641	jwjzG6QmCvFZFwfVvQfyH4bavUjZ5AnNWWqtkC3b2yAfk7HaF8X	7419	10503	10503	1617829740000
14548	3NLijV5SoxCNPKaJj4ZfTWh9Q1b5uTyQ5i7pmbQp8bZ6Lbvz65At	14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	1553	776	228	6301	10645	jwippGmHdKSk3XU4GHeyrkAVxdvrQF9DDg1e7fEfCbWMdR6RvJY	7421	10509	10509	1617830820000
14550	3NKL2m3D5FG2WfNzmGwyRiQcDXzozB1aVVdi6jpiurRGcPr2szX2	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1546	1093	229	6301	10647	jwu8fWmKCi5xqPGcqc6bycn6cmFt74LBfmZtcwbsE4qLciuQquP	7422	10512	10512	1617831360000
14559	3NLqFggrBFGgf5VuM9pWKfNwabX11S6mscNJ3bi5MSGhNoDTPe1b	14558	3NLeNbAZv9LpwWVsciw5CUXyBV5i387fdpefecgPZBQpmqu8hQRT	1549	996	229	6301	10654	jy1qZuBygQwLJTqDuNEG24Lnwj2DszYgqYtho9QdPEgwj4FaqTw	7425	10515	10515	1617831900000
14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	14559	3NLqFggrBFGgf5VuM9pWKfNwabX11S6mscNJ3bi5MSGhNoDTPe1b	1613	661	229	6301	10656	jwYAExwdvAMfQfu9Up3ALE6wcBRABL6PaDRhkjZFqirJighvkm7	7426	10516	10516	1617832080000
14562	3NLZqPyhzE8vf2us7ujKYZk8sbZhAStSehYJMm5kxB2YRUt7VgVV	14470	3NKPeYTs36KSxtJsZ6HpAnDv5TRUHRG2h5mkxjZd9SUhXeAAhYVM	1613	661	226	6301	10657	jwFirkcSibGTGA9s3WDrXkXT4CkPLv8ykTxZfAwCF6uwYCxekUC	7384	10516	10516	1617832080000
14564	3NLrXGqgTQZTRPrjoj4Q8c5He8eFJE9CS21b8KQmMGqZ8bAefBSR	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1651	1301	229	6301	10659	jwHPyAzwPvVGTLo2U52fg1Lfxs7HbzbM5jeEQqf9frsRLABAKLq	7427	10517	10517	1617832260000
14569	3NKQvZeC4G1hDbUzKtmzELBLq9HQCGQb3spDmjtxEntzpw6WPj68	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1588	1266	229	6301	10663	jw7M97n4tzdBEtaUUA4sdMYxM4Lrneb3dtveMGHciE7ehUdChCa	7429	10522	10522	1617833160000
14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	1649	1383	229	6301	10668	jwisccBT5CCRT1B5RCuX4pJgrJ3s95DjpFfD2bpJMp7SEWRHmyS	7431	10524	10524	1617833520000
14578	3NLTTFMJmHdD6mXMMH5ojejFZ1CcpkuhK9xWVsbfZTvvzZj3C7R3	14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	1407	1395	229	6301	10671	jxbm7s7V6pQthS7fgdZakp4bzzSjGbRmW6qQsrZKUsaNqVTzL9p	7432	10525	10525	1617833700000
14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	14579	3NKKzB6HFqyrYUiVnBh2P17dPhWzwbgeX8XPMjioLjdW2hfBpEkX	632	1136	229	6301	10673	jxtMMGqs9caqBgmaez3mjUJZ1j9i4hP6aDq3LW7TP5dGT4UR5b2	7434	10527	10527	1617834060000
14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	1406	1393	229	6301	10680	jwm37VjyVKedZrFJbjoN65ZjL9Hfr3rWFJW3fqt38FKCHaPYDHo	7438	10531	10531	1617834780000
14590	3NLPU8NaoJLBw54VdzubDKSHTX6N94H41idxpdkkuu4AtqLM27Yk	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1637	816	229	6301	10683	jwtf21vp8QwKpax7nbEMTj5FauUB7Lhm9UCvnCyPV5hPvKcoXdU	7439	10532	10532	1617834960000
14595	3NKB861EadhDt8NKhmNbHRuChaPjY3mExUutxQDdCsfyEUpBxguK	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1600	1372	229	6301	10688	jxCrB33htvUX3YjRoAh3GusFeWcpuFNCnS6wY8FjNzoiLgLN7Gj	7442	10535	10535	1617835500000
14599	3NLXpZmHDrLhaXedG25nYor72R4W2wic75D4GQZxbrZnawpZnmnN	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	497	657	229	6301	10692	jwWyS94XHmVjvf1jgEb7CtEYB1DBx1QMpUWBHfSNHm9BJUpiBQi	7443	10536	10536	1617835680000
14600	3NLNnzU39BhqwWXArZ3VH5kpN1DRkJLBRCD4yyZBkVcAQTa295js	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	497	657	229	6301	10692	jwsKN736kQ16aM93yXAbT6YSxhMmMmUweFqHKtS21GxVGAyhMXA	7443	10536	10536	1617835680000
14603	3NLUEk5tWnGDmRArGQ5fCxdALgdhwWkxCCEs5emeaqzPVk2bPUHR	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	1631	794	229	6301	10695	jwM1xV4x6W9msYWboxRFgFH4Va1H5UARvGmrvM2kY7ELbKxxpXC	7444	10537	10537	1617835860000
14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	14604	3NKofUKEcQ9vNVVhewY2YmjLGfrzyEFCm6LkdzxpG8484bqb6Tnu	1637	816	229	6301	10697	jwzGKS6Qh8G3c6LGb1tqzGbfDk8hUTFD8LauiSPXNGG9GS2y4yk	7446	10539	10539	1617836220000
14613	3NKVdbgFoVSPiBXTRgejuSt15HJ89GDLR7Cuki4FidrTJu8RjwXb	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	42	995	230	6301	10705	jwHPjrYkEGbD4tvyTF6rtPb42n6R6yoLua9izL1jyLX8rp2q8xq	7450	10546	10546	1617837480000
14618	3NKxEdPF9wJSnP8xGxzz4r3aQ547Wn21boa5Gk6WWACAHNUxSJH4	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	633	1018	230	6301	10709	jwNLNhUUoosbi8cLREiVv3AbWqCHSyRAFtry6rSi8dvFGJts1wN	7453	10551	10551	1617838380000
14625	3NLWhv17hq4aUdqDPVCJNeRNjFdZFEZqSSLiYMAFEAaSJH1uaHqZ	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1587	1231	230	6301	10716	jx1PZ1APudRcpNtcqKawTdGtzofhbWxvS7cwJMwq6Qug5FvdpNJ	7455	10553	10553	1617838740000
14627	3NLYY6yDTyTqCWHfu8TtfpnRuR8fuEQtGVsmHE1cS3kGizwWSrZM	14626	3NKUiVLVJYct8MHtJmbPUvRbjGurcd35wQet3AGHdiTnQbEuRUsa	58	1035	230	6301	10718	jxbhrVF6mrtjMZ9tE34QopKbpzQdHhPH5H1h3zF6XH4RkVcnRya	7456	10555	10555	1617839100000
14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1457	1391	230	6301	10721	jwsF8vtBc2cX3E2SNBxfLKN6Pg4L5ZDjxR5714W6W7SBmjz2ewF	7458	10557	10557	1617839460000
14632	3NL2BxgrB89CVpasCFcuqNK6ECBtUbvt3mY63YgLFN2GNpk3fPLb	14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	1439	1279	230	6301	10723	jxkuGrPViQdcU78RanfuVo7uvgf5qZgeUzaTpVpE5UCMBYBK8Ny	7459	10560	10560	1617840000000
14638	3NKfU72JNrfsoDvohUCVL5k8xBVoCvEedjSz2WFghxoWU3QXJjo3	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1406	1393	230	6301	10729	jwf61NeMeiyafr2sAH8XgCBtNRuvrEvz5DVHmTLSxmeu2SNw6nv	7460	10562	10562	1617840360000
14640	3NK64m7tAYL8274o8CyoufTT1fCiT89Sy42QxVYeWZhhVQJnwpdG	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	298	1308	230	6301	10731	jxCqVoAxnWKAp5EKQ8Fa6ZYcu6KJ4qAyDH5T1WAcDuNpT4LsA2L	7461	10563	10563	1617840540000
14642	3NKMZLiYb5Q9xmTqzD7kNQkRxDcB7bBqy8367PaonhwCLsLHg66j	14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	1601	1022	225	6301	10733	jwPhGTGfPHrqhkMmJCuaAaG7xoFzEUpyFpG17BmaCZ42MDXVKLi	7361	10563	10563	1617840540000
14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	14644	3NL8Z44E24zGm2YkLop8enBZuAmLdZUTpRCNYWX6Eeh9BjB11qEq	1553	776	230	6301	10736	jwxNi8uvjq5Mh5ivgMNeSKuE2cgH9Pud9JkJ9MA7jgrL1Fnvaug	7464	10570	10570	1617841800000
14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1546	1093	229	6301	10647	jwu8fWmKCi5xqPGcqc6bycn6cmFt74LBfmZtcwbsE4qLciuQquP	7422	10512	10512	1617831360000
14555	3NKcq3Nyn1af2jCRint47bWunNafKdokgkCQoFrcUefE2iAS4Foe	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1439	1033	229	6301	10651	jwNZrdPa73sLjWxaPXPN6F1mp6JLS6jLrxWTDeXfkJUmCEzLJT9	7423	10513	10513	1617831540000
14558	3NLeNbAZv9LpwWVsciw5CUXyBV5i387fdpefecgPZBQpmqu8hQRT	14555	3NKcq3Nyn1af2jCRint47bWunNafKdokgkCQoFrcUefE2iAS4Foe	1536	947	229	6301	10653	jxvhgYEAqqjDbLTDBRwMZTk4W8iexKR5tS5Ti3NFpxQF2UnFpdy	7424	10514	10514	1617831720000
14563	3NLm28ewgd6irz3r9cowDrCE46hovVyzTRXF1EJn3rFFW8bBZgEd	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1489	1380	229	6301	10658	jxtNiiTnPYaLF1VDzWHi8LUfyJcTjtqo3Emt3SbvQks3hzsDLTF	7427	10517	10517	1617832260000
14566	3NLBKka2kvwwfSpcH21wsBnw67kfm8CAmDSFQm9XjdJSPTqCcH1k	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1651	1301	229	6301	10659	jxrq3BDyQ2q8wwC2CF1wxQRTBwu6UVM6qS5NXLEyjFVweziVQWo	7427	10517	10517	1617832260000
14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1671	1365	229	6301	10662	jwHfAhumHVonuhLkbq53sqrNP6QSBsgq5iBnbKokV4rTCs5XJ7P	7429	10522	10522	1617833160000
14573	3NKfLTSzU3nm2emLoQUBJa7vrRESydTQzcun4acRsDZLTMBNRCv3	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1594	1080	229	6301	10667	jwDS1QvGqgLSU3niVBHvwZxgadsLmj8mAXyPF8tVSkxzXXAcZCA	7430	10523	10523	1617833340000
14577	3NKujRpwDiAkGYZZBSjkf4yPTU5K2oSEzVHLRhVyCv6fE62EgERZ	14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	1403	823	229	6301	10670	jwK9kSFqHbMnRTbcvmjhyLwvrzPTeGfwoAf1DXZ6bUnZU8Mdrjp	7432	10525	10525	1617833700000
14579	3NKKzB6HFqyrYUiVnBh2P17dPhWzwbgeX8XPMjioLjdW2hfBpEkX	14577	3NKujRpwDiAkGYZZBSjkf4yPTU5K2oSEzVHLRhVyCv6fE62EgERZ	448	1305	229	6301	10672	jwMa1ASJxkh8dN5CU8HYQrv4PHYZSCek3LybjKyMhBwGmvoDjwT	7433	10526	10526	1617833880000
14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	1508	1387	229	6301	10675	jxeCvihViD9aAHaUbear9f9hEhCRdkkMW85Ty9Jo7uLouFfJgQM	7435	10528	10528	1617834240000
14589	3NKYr8cQzFphtjBWffLD5atJK8Q32nowd8tQNj6CQzKE4ZSoeHP1	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1642	1367	229	6301	10682	jxnio9rrhBUaD8TRULBpncJZivgZdGWKvMxHDBzdvh6BhdcMosW	7439	10532	10532	1617834960000
14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	14588	3NLbPbv3HhLQxmscM1jKxnPmbpVzrB5Y69rkChETHHXqXcTAVXzU	1547	1252	229	6301	10684	jxcJ84ZTCMpmmp1g7363K1RvHexo1c3D6WFJwrKxaC1UJxsHkdy	7440	10533	10533	1617835140000
14594	3NKW6biJNekoYLXnJRDuPdg9FRc3vdEckLbrRtWFZxpTHDeRVc3N	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1460	1324	229	6301	10687	jxwNEG9fU8H7KT3uECymu9Hsq8xEyzTiB8mNqAjY2sSARmTuAkk	7442	10535	10535	1617835500000
14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	369	1312	229	6301	10691	jxkjd5QABf1GuoUoYsnm5p6oKsYVt58XzjLkBxcAN2KBCyUVw15	7443	10536	10536	1617835680000
14604	3NKofUKEcQ9vNVVhewY2YmjLGfrzyEFCm6LkdzxpG8484bqb6Tnu	14602	3NKBpAQi1ps3y3boEDvbQRnoiCAjr3hXLTsH4sLWwggMbZWNHGVA	1407	1395	229	6301	10696	jwxsHFw1Kwe8bBcM7RdKX6qvXuxitTgAUC453Lfu7tSe37Yxm6u	7445	10538	10538	1617836040000
14607	3NLvPFWne7CFLu2g6HW95Z81kRcpa2bSAJYqjjmgt9snkuo9AqY4	14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	1406	1393	229	6301	10699	jxeVs67pnU2V4W4j6No84KDpjQB2acNLjyE7vZ8hpWX8JiywqFV	7447	10540	10540	1617836400000
14610	3NLTotp87tYYXQ6vtYvvrZbgUPvN9VNfgLhbCkNnMYdMznwPgKKt	14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	1594	1200	230	6301	10702	jx2sPVn1PA8LiSdt82K9ffLqZx4Lhff4seTsXWJp6QetZma7JXW	7448	10544	10544	1617837120000
14612	3NKCrNLhBQA2fvLLCChWv6ZjgEG5etAAcCRodGFDpYyQx86qvxet	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1407	1395	230	6301	10704	jx3MRZMtfizW6HtRS7PNqKHiKFCph3Nhi1mB1jEetqudmCrbKRd	7450	10546	10546	1617837480000
14615	3NKuSB2p9FmSeK73A4X9674shmUk6T1UeYqgz4RCR7N5vHGgXDp6	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1651	1055	230	6301	10706	jwEyUFS1qe4ZxNJPmWY9TujwyTdNHHpWT6PkJjd3ejuhEKWeczR	7450	10546	10546	1617837480000
14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	14616	3NKKHWqzSZ7ZHPEzCVsZjmrMkFeYEtjGN4VMYExjjjjdy3LQRNK1	1585	1366	230	6301	10708	jw9ZibWkKckzJmo8tCoQqGCgiVgmqpokr61ES55mRBhhuPfz3Ux	7452	10550	10550	1617838200000
14621	3NLSAw2aGhCHP2JaehF8murieF1CFYCHCnD9HWFgU6JYmtg5ATNc	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	563	993	230	6301	10712	jwjeQApBNteFzdoikjnWRSrtEB3aSEPN7eFRBQXVA3TorGT8zCg	7453	10551	10551	1617838380000
14624	3NLGQ4oaptLoTou7AQTpk3MUPF9ZoRQgrkWtJVzap9aJmtbcLSG9	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1403	786	230	6301	10715	jwk4x5pcYZfRpMWpJxRDh8nbNVj1KYkH5GN16h8BkdAmTu2bao8	7455	10553	10553	1617838740000
14629	3NLgXtLsPW8us9gzhbHpobq7u2wNYRQJtvAHdmfoY5Pdb8KrPA3T	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1405	891	230	6301	10720	jxP2xCnTsUU4PUR8jUBfNmheyiy6hFmi8VCH3LE5GRWvG7DQ2n1	7458	10557	10557	1617839460000
14634	3NLy6rXqSVpBpLTMvW4yofW1mrFLWUxNG6rmWMZQiJd1Urwh63Jm	14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	1594	1326	220	6301	10725	jweNYkjMdEW6gSj37Nv7HwczvwrnnPzuUeurzbLMmZBmfwSc1Mf	7276	10561	10561	1617840180000
14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1637	816	230	6301	10728	jxb5kFLy2S14Hh3FtTFV2f43xWmvBi9DdUdmgLkEPXKDJ9sZ5Q9	7460	10562	10562	1617840360000
14639	3NLDr1MyeTgLG7oUuc8bxWUiyN2yuUAuxXjmKzLxynszQwpp2uGS	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	684	1352	230	6301	10730	jwDnGCzKNAGe9kHbJnuDAPfhTspvWCGRFYnSrwNVuAGiYJbz1c3	7461	10563	10563	1617840540000
14643	3NKcdp2NbPMbxTL4SV7BdGVWG1Cx2viW63R7vVhRhWzwG9oUGzDC	14640	3NK64m7tAYL8274o8CyoufTT1fCiT89Sy42QxVYeWZhhVQJnwpdG	1407	1395	230	6301	10734	jxa8V6utz8kqQ4wfjXYJqLivWRJfWu2spg2HEkXxbBgwhU2okci	7462	10564	10564	1617840720000
14653	3NKstPasuHEQgzFmdAqtsErHRWoh3Hfw9mzQCX8oWbJy7N7jwG8h	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1481	790	231	6301	10744	jxJ9AprExwY9mEhu4WxoPZuxtz3BVu7oTZ8dcLuMSauZSjgDx31	7467	10574	10574	1617842520000
14656	3NLTq9MPrgf5nE9UrSyp8Cu55W2oAkQUTBdbMTqtthpPk5fp19E6	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	641	1090	230	6301	10747	jxUJFJRo6ANpfF6nnyuQ3BQyqVP9hHFmtCg2tT6n83BfQ2gcFkt	7467	10574	10574	1617842520000
14657	3NLdAwgna7VW7NoMQx2wwt6DjyjYgA9FC3iP7JNQnqBLj9yx9U6L	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1460	483	231	6301	10748	jwKMHvSF16wecAyfYb7M9PgjYtVaCjiLe6d5JtqgdpYB4Svze6g	7468	10575	10575	1617842700000
14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1483	1030	231	6301	10753	jxoVAjjRKeqAv1rHAaReYP1n23fAHZxUkrRmvRsNykzabiWgbqL	7469	10577	10577	1617843060000
14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	1407	1395	231	6301	10755	jwSnxGXPQ8d5DeUVwVdy429ib1iYdHiDrzzNivC6SMbzgnLA8zg	7470	10578	10578	1617843240000
14616	3NKKHWqzSZ7ZHPEzCVsZjmrMkFeYEtjGN4VMYExjjjjdy3LQRNK1	14614	3NKDAM11jJEHFR7Wc6GFN9XHGNEVjv1CCDZ3PSfGRGxfY2epxqzJ	1403	786	230	6301	10707	jxwKW8GLdAsvyhkPTnC19bNEB4RotSps8fAqPmq1Tztf5fdEzoe	7451	10547	10547	1617837660000
14620	3NKbhC2mL6NWTQUdm4kGgYrSFe4KUD7MHk14zWeprVUzdN3TLvqg	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	576	1355	230	6301	10711	jwLBrAU1L91VZzZoZf2yjnEyaHEStYmyRK4C9zdYdjajJzLMoH5	7453	10551	10551	1617838380000
14622	3NLsHuKRhwcctaYotngQtxq4Mxx7AS5qGcGDvaMcCmRaAwvMsoiX	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	1581	778	230	6301	10713	jwZfRfco18qJ7su41v5u5gEsLNiHYf7JZFNsBWqQJVfdLS2yUyy	7453	10551	10551	1617838380000
14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	14618	3NKxEdPF9wJSnP8xGxzz4r3aQ547Wn21boa5Gk6WWACAHNUxSJH4	1406	1393	230	6301	10714	jw8mW7RCHF1wRmEQxqVowmua8tLsXNvAQ7cCcQTT6pvPVcnD8zE	7454	10552	10552	1617838560000
14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	14627	3NLYY6yDTyTqCWHfu8TtfpnRuR8fuEQtGVsmHE1cS3kGizwWSrZM	1529	950	230	6301	10719	jwPz9HF642NjD827iZRzEgXFGGQGLtPNFsxFTzdp9iLmac1hUag	7457	10556	10556	1617839280000
14631	3NLDRtfJtPeSLU5HxXGNgR4XHeVxirYX6omSkv4dAfwaygF6voMK	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1581	778	230	6301	10722	jxRNaXe7iRnJnHGG65E7SbF11pDmRpue4nQ7rjBa3g7SJSkntRe	7458	10557	10557	1617839460000
14636	3NKsX67qitSFjVuyc3F8hPmdHL8HA5aWsaJUZFqrXXHHjEf1k7ey	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1457	1145	230	6301	10727	jwoY7DapmoiqKqQJT6yeuxqcJUVf6xoDM4wSU6Ui7m3Gvvuf963	7460	10562	10562	1617840360000
14644	3NL8Z44E24zGm2YkLop8enBZuAmLdZUTpRCNYWX6Eeh9BjB11qEq	14643	3NKcdp2NbPMbxTL4SV7BdGVWG1Cx2viW63R7vVhRhWzwG9oUGzDC	1402	868	230	6301	10735	jwCZYR7ztDLWNsb9ckW7CE26gmSbsDBym8QR6tYWgeBuybZg3VR	7463	10569	10569	1617841620000
14647	3NLkJXV45YeSyA2fptEXKgCPmNAR6rvDiTUBwD4JtiPNfN2DtyVf	14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	1601	1262	230	6301	10738	jwuoXqrWK9AVpx4LFJDdDTi3KRWTg9xnJncpSb1TgY7YmSWJbt5	7465	10571	10571	1617841980000
14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	14647	3NLkJXV45YeSyA2fptEXKgCPmNAR6rvDiTUBwD4JtiPNfN2DtyVf	1648	1038	230	6301	10740	jxuMT4fvC949v1HNWfyA8fM7tq8YscumksHyfJgTABicja5UayP	7466	10573	10573	1617842340000
14652	3NKDgwgkdZWZG8FiNewCXw6Vymr8jspF1Uc5KHvKjSzNQNpUG6To	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	171	1008	230	6301	10743	jwx65U8RCrMQjGhRcMhVj81m7YanTv2fDomVgzYTEGx5yi6mZRQ	7467	10574	10574	1617842520000
14655	3NKD1iDUcAoVYM5W78XZuaEoz9LPtoFKoAfCpuPGR48Njosm34MN	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	641	1090	215	6301	10746	jx2eDyEspBt2sv3LQUfMauGWxrMbQZacCqHHjQkXWnSUFRcS5j9	7182	10574	10574	1617842520000
14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1500	931	231	6301	10750	jx7ZgonAkkHnWYvXzS4Gqg2tS1QkF566ApVxLtV4zHmhWNb21VM	7468	10575	10575	1617842700000
14663	3NKpE6Lm6frnuG59NSDVnqWj68iR4isQ2xH6E2Bj5k4Lh2wW8n6x	14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	1637	816	231	6301	10754	jxLWhyMxLqpYGg3nUVohqyQGGaeQFdi711EkhfCesdeMbWUnTru	7470	10578	10578	1617843240000
14675	3NLA28yhFXgsz4dwvP1D5fhfe55GMZc9iXViiVsfoiGfodJLASS5	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1405	881	231	6301	10765	jxGz46GYJyNfrh5P9jLnnyaM26qNohJ3dtMeiKuv3Vh93iM7yZz	7476	10588	10588	1617845040000
14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	14677	3NLTLfowssixGA5v35krWvzRvdRRjCxvKNnVvWGwLDh84kWqNg83	1403	824	231	6301	10767	jxbsLVS1q1njNwqc33Xx1a5Jvj6c37bw6fWpeTcqjv1qQGkVUeV	7477	10590	10590	1617845400000
14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1654	1340	232	6301	10768	jxgxncRe1EGjoNoKjKho9ocF3WzcSrXjWRdE4QBFuYGkZtnb1hJ	7478	10593	10593	1617845940000
14683	3NLQc1yX65ZuYYUFFaxgPyYWSGEJabHTwm2UUeQSpB2UNB1rr55B	14619	3NKKWxrbXXVUWzkxjEMHY1ELnQwmEoGFuYcY7ytjGsHv1KPaaHDj	576	1355	228	6301	10771	jxETZM8mq5W346tYHNePZxR2wo5CL3JYFiRijh71o2RpH2zCJFf	7419	10594	10594	1617846120000
14686	3NLq3MeAWxdXk1cBb9s9k3xuW2v62aMjfLsmixzcXd3kqcBmxWzc	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	576	1355	232	6301	10774	jxJhoTDggnZGGFVQADtJP5eQEFAitXYYigmqLNSvo2gFHSQarV7	7479	10594	10594	1617846120000
14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	1490	1274	232	6301	10776	jxTyQFd7VrwVNBMJoWwZ6voyDvVkVUtNpGBTjcCRZXcphWx2UmF	7480	10595	10595	1617846300000
14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1535	93	232	6301	10778	jy2QGvushXXUpfqEaRTejT7UA2mZ8AHETkpxVBrYfaCt3PW7k7P	7481	10596	10596	1617846480000
14692	3NL3YH3kFGaqiNtyXs6j3vS6ZfT9Fq6Dq7UpsH8abnahx6q9Sb61	14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	700	840	232	6301	10780	jxevab7uT8Mipm7LY7nbda5Ne5UD2dXC9ngcZLsozAg6Z3VhMjR	7482	10597	10597	1617846660000
14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	58	1035	232	6301	10783	jwNHy7qY74UxrgK3kA4ztAzt8HGJLSLkfNXhPDN1R1RdmxLwtWZ	7483	10599	10599	1617847020000
14700	3NL2QuCP54SdqFfzyDoFQseLYm4qVfbvjcrAkabgoQxB9eR1LWj8	14606	3NKWBaShBhs6WNPLEhZPyKmbRahww85SiquXsRpcfDiZtBgkR1qL	1624	1334	218	6301	10788	jxjTSP3nxeNyiEKsuLxWVkEkTq5w4WcR9E6JT33gwfmeH37h6Ye	7230	10601	10601	1617847380000
14702	3NL9ijcLwNLyDFR9bigvdwYhy9hBr6yc5HcbCT5VVF8LPJikGLc9	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1406	1393	232	6301	10790	jwWFun6AUHJEaQp5fRpzhk1iskiWtemgQtE9r4cJT6mBBpSB6eA	7486	10603	10603	1617847740000
14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	1460	617	232	6301	10796	jx2Nf1wPEY9YUKxpt3TokT4Ezke9njempoDhL36rUp1aSiDFMfR	7490	10610	10610	1617849000000
14715	3NLX8MSpgaaTfCY65BcPJdd2Nnyifn3MMQvJxWmY9EmbkFGD9jPJ	14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	1547	1132	232	6301	10802	jwtMryGAEkiLU4oHQTbDmpHqKdZhsQdUZi9GN9XqBbcqkbj1CmE	7491	10615	10615	1617849900000
14717	3NLy88qMYPsQytn4XpXeQ4s2b8wsHdJSfpD65oV4zqswpJcUDZbb	14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	1507	1280	232	6301	10804	jwnzLoYY8oQy6orb876wheD4ghw37PUPDvo1av7eLn68bgoiFH7	7493	10617	10617	1617850260000
14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	14718	3NKyZPWwx3uM3EtwT42FkHJWkFncEUqpRLqqCHA12tchd7EEnKgs	1657	978	233	6301	10806	jwkDFZXSQ6gaoRMouEYYLxgNCUSkTdWzanzXUqTKEcJibnQREH9	7494	10618	10618	1617850440000
14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	58	1281	233	6301	10809	jxekoXaBoSVKdoJqV4fQYbVQH9NERpSEk2uunHVsXhu4HPGopWb	7497	10622	10622	1617851160000
14727	3NLKPMxQ1o14ergJUXLYMBvFgMmw6sDSF79VrPmuFQqVT3v8otXq	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1560	925	233	6301	10814	jwEoZwDp67egGRAfhEWVYfavnyra4DPDmEpWVJmLxHrA54sKpKQ	7498	10624	10624	1617851520000
14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	1608	1043	233	6301	10816	jww6HGMMK9Cs78h9h5CvZWG1sp3btnxTrW7J1uBXiifJDwbVZSb	7499	10625	10625	1617851700000
14648	3NKhrNTEp3PncMV1Y5XNzeQdDaQRSTAk1CuSZNJsBGoTVBy5LgAo	14642	3NKMZLiYb5Q9xmTqzD7kNQkRxDcB7bBqy8367PaonhwCLsLHg66j	1601	1262	226	6301	10739	jxfMmnwEMzRNLfaxtwmvQ3M4hypTQdhxss3cB5NL5y1WrxduNxX	7362	10571	10571	1617841980000
14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	633	1258	231	6301	10741	jxcLxmEDaVrJq44jsWtUL2jbZVjjpjXENFbJB4YbSQcSsxfzb6X	7467	10574	10574	1617842520000
14658	3NL8tgEf9uQaDRXxBURNpahzu1jGqBA3ppd7t5CmKpfnBgzH4Myc	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1407	1395	231	6301	10749	jxMrfzWuWgFmnTYDWPykk6dhJikge3ipDVQs15VF8nEeBvSwRdE	7468	10575	10575	1617842700000
14660	3NLtwesUKKFGwJF7meRT1ahJKTx5FgyhJAfSEUAHwwSDhUeQtjpv	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1501	1360	231	6301	10751	jxceMhk3xxQqCopLxwYn4BR1AoX919mS1jzj6Hc6GGGaVQPXjUZ	7469	10577	10577	1617843060000
14670	3NLx18jahxuE8JrSsVCTvU97f1yKNkwmMBXot6CFqgbkCSwss1HR	14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	606	1295	231	6301	10760	jwrH4FTS7c8HKc2neSvwNoGbadcFwaDdBV3JY2rW4X6ARLU3sAX	7475	10585	10585	1617844500000
14673	3NKs1NHhb9xhodsQga1C2em1FVT9boQTknq6P8XDkwj2pi8vj24v	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1426	1118	231	6301	10763	jxrxVH2D49An1XLRN6LtoYMHz1oqemWousToh4ZGXhRmdahtkat	7476	10588	10588	1617845040000
14676	3NLNRr3BxU88FGRN9fBacqZgQRKanyL1dQoAcPfoNaL3Hjg7pc8R	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1451	1292	231	6301	10762	jxoe6N7zjZoXRoBb8aQe3vkXqYUJe4pG6Cm9WmXXb1UYcNo6NFj	7476	10588	10588	1617845040000
14677	3NLTLfowssixGA5v35krWvzRvdRRjCxvKNnVvWGwLDh84kWqNg83	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1445	1164	231	6301	10766	jx1cGMo43sk8qLQghJfoJLbM9hfhTbqvwXEWDcVZYEtXd6qXKTZ	7476	10588	10588	1617845040000
14681	3NLkagAcMW2fwVyP21XN5pMmY2JoeBvDwQ1xZMz4cBYHP9qb13YV	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1654	1340	232	6301	10768	jxeNTKaEa9Kw1ymvbPgnBfWPVss93Fgk2ysTQzURyU7BX2Bwa2L	7478	10593	10593	1617845940000
14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	1451	1292	232	6301	10786	jxwoTq6BAHwGVHGKQobWprJsxcpnpemKzNhPZ5VSRocSrQp2991	7485	10601	10601	1617847380000
14705	3NLDWcfXQteGD2cqpyke9ueA8DRdarmPiXX16fJmtrGABBJuz9UP	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1422	1337	232	6301	10793	jxMXE2PNm8NpxLBbSqBrq6ZTdwwSzonFTr5QSsiQxKt2zxvZPaL	7488	10605	10605	1617848100000
14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	14720	3NKCLgF2ZqmdZTY1nYCBfH7iz4hiiwfsPskG9REbxmdXjat31HXd	1617	1042	233	6301	10808	jwEuYHwNy8rjpchBreM6Cs6i3dAktsTeNbLMKdJ394PVCUvLipN	7496	10621	10621	1617850980000
14724	3NLs5inZdSdm9ytojfX9DFd3eUz4hppzt7EF9eaiYNSBXYSACn3Q	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	1506	1007	233	6301	10811	jxkppbZQe4KbzvdKHtZMeDS5HQbb5tqVrJmMqBuvrEymLCnaf34	7497	10622	10622	1617851160000
14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1596	1117	233	6301	10815	jwKW2iEt7F4DjGF4xLUv8BxSBm88gjwq2CiduBVKtn68aKxCwzf	7498	10624	10624	1617851520000
14731	3NLiEJbfNo9fWibgvhryaxJRYMBRm2Sj8nrpefGcQeiVoGGzttPr	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1467	1250	233	6301	10818	jx3Xo4WBaYU6z6wmSEVGjobvjME6Huom1zQJncwefn1xNgqwM2u	7500	10629	10629	1617852420000
14734	3NKBmP2PCFJCiBfQ2vnvC2Nh3Dty1WEKeMsxacBMcMB6X5Svgxrg	14712	3NKE2aTTB9a7sBVpamfyEnUQATHhWjC5d6inV2Ku5oVeshuwSJy5	1455	1332	221	6301	10821	jy2hMDQmD4F8VvYfBnLGZScvVWvCMZ2pMb1vQZXhLYAJZm2RqVD	7291	10633	10633	1617853140000
14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	14732	3NKjGvTWYvPVmUZqiW6QQMEC4YpxGRuyzwq9fskMCXQQUuMjdbKG	1675	1216	233	6301	10823	jwqEHssYv6pyLSz7ozq4PeeQXDeb7m63sHpMrRDNWP6QeRBxSkA	7501	10633	10633	1617853140000
14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	1481	790	233	6301	10825	jxt2ti1p7EuAFjpuHwfxaRk3DeGZ3DtTCrxTXAVrzUZheBpMaFD	7502	10634	10634	1617853320000
14741	3NKRoSy4xDKyszezvuCni38dt4hjkAUGVCqsGPmS4biA9E5wwJsE	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1534	1317	233	6301	10828	jwDvUKmCPhABLB5QrJ2NdRDWZwTrEZFr8EgUb6hojNhongKnUvJ	7504	10637	10637	1617853860000
14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	14746	3NL3kmB1364ahxmhzNfsinPNT28x4C8yie16yKUo5Z8tGD5iVtpi	448	939	233	6301	10833	jw89nNsoA1sNG9FUB2MLCwVyjH9PwqvnfM5UYC9VAK6EDqPvSPQ	7507	10641	10641	1617854580000
14752	3NKQgpt2jLVnifxdEniaDtmPZ2segU9etBP7TB5MrQZoNBmRGDBp	14751	3NKqnYEo2owzYCkt9529VHbt2Ph32FnRszEM42CbBJaUKo4iAB4y	633	1384	233	6301	10837	jxsgGV4afvfDa1D28UhVUSL7FF8QvmJeGHwD9fxio5pwJR6ca7h	7511	10645	10645	1617855300000
14757	3NLkTjZAgzRKXLTdLRyLC7TfxmvGpNkExeGqjeSbLjtYDa51ziPD	14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	1403	782	233	6301	10842	jxvaCGzcaJ7XZbxGqiSQzyofHtad8dkLx3fNQxRVqygKUiB8rFk	7515	10649	10649	1617856020000
14759	3NKrsWSn3Ph1gtV544qpEiFF1vATGWhMrB9VMwksobetbsmvRWSC	14758	3NKYpPmRCXoyisxLYkMsgZw4dLeLjLtcPkphhbp6qRbN3BM9E2MZ	1403	824	233	6301	10844	jwp7kwiSKFJZN2f7Eb93GtrtDrgZKG1W7shjak1gctWTGtGTo2y	7516	10650	10650	1617856200000
14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	1631	794	233	6301	10847	jwB64r8TkjwVbuzxVTiJXWCTYya1TgH5KKSfHxi7DWYaKFPF1qf	7518	10652	10652	1617856560000
14765	3NLHF1Jz6fkJ5oH1b81YxXzSRmLZDgfnfS4oRkKSRhK9bYYotef8	14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	1671	1119	233	6301	10850	jwKDKMyJq2wvdCRBvXLEE84RiE7jL17NjojacU1qyyKdG2hUpjq	7520	10657	10657	1617857460000
14767	3NLrEAbsVEsma6NGaeuC5hjrzisTCuv3XotqUjD3R5Sgh9c8ZXSn	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jwjBrTyaGAVShEek9gAoaLExAA86VkeE73rkVay5pRCpfnkfZgb	7521	10658	10658	1617857640000
14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	14771	3NLiNawpFZVskCYU6rBFev86dtPvUmV4kvvBRNbAdVLUdffLVh7J	1406	1393	234	6301	10854	jxQewRM4T55o4P7qeWEiVk8U3CF5JkYwLHaq5gKujAQ2Lj1hqUy	7524	10662	10662	1617858360000
14775	3NLPjss3TqmqjqDzFF5PeXNmZC8ox4ZjFycPPHJgc3KvADgdJEyV	14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	1405	851	233	6301	10857	jy2wxYGygw23PzMmfGREscLaPcntCeRyfH6TwvZ4jVRA9oZTyc9	7508	10662	10662	1617858429362
14777	3NLyKKYkb965txvEk79tuPT9QEpxP93Ws68sukk54ALFX9ab5rGV	14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	1402	868	234	6301	10859	jwj1pK7Pk1zUp2KoTiJHtFkyDkDC72yzv4hssCyM1McZtBsX8KT	7525	10665	10665	1617858900000
14779	3NKQKqd5bG8ZP7GC5ETbCYCBenZPDHJ3VpVxFVread9PimLpZDgf	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1403	824	234	6301	10861	jwGGLSkjPNgh1nrhXLxVvFATJZk3Tdfn7wH1KVECKLoZe32QDqn	7526	10666	10666	1617859080000
14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	1610	1068	234	6301	10865	jwD8Jeo3J5wm8zMTFiSsoJRZ23GBuzxFHAxs1Zp28E62seXEnJF	7529	10670	10670	1617859800000
14787	3NLKX2kvYSkrmaj16Jnrv9DtG7fEXACYBbAx4L8JebuRBZFJCPzD	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1637	816	234	6301	10868	jx3adybjYHNn8S2D1FqmhaiDXmGEezXi7h7dk6M1UWHcwKGF94P	7530	10671	10671	1617859980000
14661	3NLQmgKHMCCsWex1LK9umQ2k9jtPYRmFTHnxJNRWSrdrxWsnCabs	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1644	544	231	6301	10752	jxHSz545TKV2M54PMNa6WzbuTaGVpWrimNngsQan33WoemQ1yCj	7469	10577	10577	1617843060000
14665	3NK33aBrbLfeJocKS1f7o3qwUHdyzUipSPAwypnpZpBPiYtu8gbS	14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	1406	1393	231	6301	10756	jxy5ox9bBCsBeT8eaiqK1p2qb19jPh6jPbgBWUVwUjCVHCq99Fo	7471	10579	10579	1617843420000
14668	3NKZpVKfa6frBTP4D8LcbwrSXr9PaGjsdzMrMpfAHwKbRGJY5X3s	14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	1593	1346	231	6301	10759	jwG7PPzdY1b5MGoJTWiUYxyfCePPHaeawR48jEo8EN4XTJ6YKk6	7474	10584	10584	1617844320000
14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	1649	1137	231	6301	10761	jxpYQwnyYMFs6Q2aHsyvSwe9T1hyVTTN2HyZoMeoBcVYdmEHoZx	7475	10585	10585	1617844500000
14674	3NKwpKc9NU6kS74GSfqwGGMsNn4qyFLkmj3zo5qh6zsrQBnvaRWD	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1419	814	231	6301	10764	jwBcpHpvQv66e9Pt5JrS1t7Mzz3KKSGvytZUuWVH2TnJUaqXP1m	7476	10588	10588	1617845040000
14682	3NKCAeruuMQQ1kS1w8AcRr1wWrHRRVMNEQwAKopTfAtjtYeo35a3	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1675	1342	232	6301	10770	jy1P9Mea6YxDXwGXeFh2g5gKH3Qbs8rMRvvYHTvtGZKKCpQgKxy	7478	10593	10593	1617845940000
14685	3NLb4YiP1oGB6FzCN4ESWkEu2aZ6DnKdEwVThtrVQK7FdnmaZKDS	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	1406	1393	232	6301	10773	jwpWe56aChZhqz1Rj9o5zUf9GEXkuvoMyRwqzAXKr7gv1fGkHeM	7479	10594	10594	1617846120000
14687	3NLKhrnwktEL9dPR4DonJ8nYdi8ao4xfScmjozF5UR3rEQEfWJaG	14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	1444	1381	232	6301	10775	jw9t38Y86qDjp1mEudufdgqybCxUFbGbR53u6koGGcsX8n4YUig	7480	10595	10595	1617846300000
14689	3NKM2jSDn865AuApyaRMfoTyZiPXx9872BBZ76afwmRGuBDZGi7Z	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1490	1028	232	6301	10777	jxrRyTt2S6DbtuLjGNAhTRW54jTTKCuxLAD6skrYFX71dj9jpC9	7481	10596	10596	1617846480000
14694	3NKpvTfD82VG6dttBTD79SdaEH24iPxu8aHD6RBt6z7rmzqpN7qg	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	1608	1289	232	6301	10782	jwgiXQMbRqYtbMBzpDTDpdFULU7cniesyU3NFNndun454zJDtqd	7483	10599	10599	1617847020000
14696	3NLsyCHCMQYVcwvdGDEvnVauzgBd5N4cj168chwJ22RnkFW5ShTK	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1529	1316	232	6301	10784	jxKUGjZhK4ABVJZF4FWvRbLXPyUiwtvXHPmcKFamh8WdawUUcU3	7484	10600	10600	1617847200000
14699	3NLNgGe336HKH7MaWzgJ9UFgDTHiSxHYdBNKimnRpJBBAFTgguYK	14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	1624	1334	232	6301	10787	jxxD4RZqRyDeFswQQukdt4fzmQAAXXEZd88dWbz7wBZGP5EBnBE	7485	10601	10601	1617847380000
14701	3NLyWMsmCLbSsnxN1DSjYakbat3aCRm6LJEW3k9UNs7YxRwf4JoP	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1670	1156	232	6301	10789	jx6oXrdTXWcsDGR5o6z5Ejh6eEZEdA1Ms8oJ4SQYbxweLsabWEU	7486	10603	10603	1617847740000
14706	3NKZyjEKbV5xUMppdAWCHVAw7HD6jkphoUdqcpgbPnyXLonTyLKQ	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1448	1065	232	6301	10794	jw6xUWynLrA25EvhhL6Wsq8P6f5c3GxVBDGJCWMSmguMhhgBTEy	7488	10605	10605	1617848100000
14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	14706	3NKZyjEKbV5xUMppdAWCHVAw7HD6jkphoUdqcpgbPnyXLonTyLKQ	1406	1393	232	6301	10795	jwrvbU9jaanQpaZNJpwCmcohTB2F4HbNha7ZTLtk4q2w8msMzfE	7489	10607	10607	1617848460000
14711	3NLRj73zuK69GJDrCKMUJh7qMiE8nZULdNpA2SbhNgL1sfptcAth	14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	1634	1331	228	6301	10798	jwfu56UQzjWRFnXRQwLSCTo8vX8dcY8W7MVK3S3rsxVQ9t4Bcmc	7419	10610	10610	1617849000000
14714	3NKtePdiTeHf4ScW8JUDo2ESWq6jLhTifuoRLFE6FQXWMN3SfdQR	14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	1675	1342	232	6301	10801	jxmVroo7d7uBu4eWykdsUnQb1LK2GTGkWxdaTA9GCB4jaHZEixZ	7491	10615	10615	1617849900000
14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	14714	3NKtePdiTeHf4ScW8JUDo2ESWq6jLhTifuoRLFE6FQXWMN3SfdQR	414	414	232	6301	10803	jwu8tuYaenDxpUCjDnQSRxCKV2AEGMapeVs2xXoaGSDjcAGBk5V	7492	10616	10616	1617850080000
14725	3NKJbtz8J4ecaL5Qxno6Mbf6ehMawyVRmQkgEQgR7yWbfLyWkzyx	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	563	1359	233	6301	10812	jxuqePeqJJW5ezqCRQMLQQNPjAUYPf8hVPSNDE7bjos3HX3vnfX	7497	10622	10622	1617851160000
14726	3NK6PpXrTpQTLi2d3PAVmPSrAMLffdgCU6jNM9sWdrcRpvWomDyz	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1529	1070	233	6301	10813	jy1jMcyVitzjUpf3bzhtzeypRfQXB9r8ZpNCcmyuLGF5dGo4Vis	7498	10624	10624	1617851520000
14732	3NKjGvTWYvPVmUZqiW6QQMEC4YpxGRuyzwq9fskMCXQQUuMjdbKG	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1671	1365	233	6301	10819	jwM928BHx4TzRv1RrDxHoKyUmWkt5hLm15sQnUh1GMz9PffkNxo	7500	10629	10629	1617852420000
14735	3NKwQKT4oAz2XxR1MuroWq1KTHmnmbK6V8X6rzCfemH5KWxF8CjQ	14713	3NKFdqZ1BbTEHJMhjarB92aLEviGCCozK3CtuywXX1k1nvEHph9S	1675	1216	229	6301	10822	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7443	10633	10633	1617853140000
14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	1529	1316	233	6301	10826	jwFqfM3ZMG9XxLUyabcEmDzT4xFzPRi5yphoBMrwgFVsiZknMiW	7503	10635	10635	1617853500000
14742	3NLU3ioVRq8WmSfAahNKmCqY2jxY4NVkbNCQeKrHuaMsdkrkq5VR	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1651	1175	233	6301	10829	jxS8D2dRobVUnf6mkYDZeBc5kBS3gYqFrr4Trk3BBmccpJXG9SC	7504	10637	10637	1617853860000
14745	3NLhJZnb97dJcR5eKkXjZ2D5G7LCMcrcxg7MNQaBGcqYDwHwiF2e	14488	3NLEhTXfeLno4gLQmRihePtzdjk9P6Fq7ziLnkurezk1RFfAAfms	1623	830	219	6301	10831	jwoMYu26MWTVqqVbvVCfPMvnMVyv6Kgpe4xj1xcUWxyg2TeUE46	7253	10638	10638	1617854040000
14750	3NLZiXHmSasAWqQoecAMEsVbNdzft467nQ3iNqpcWW54NocrnSkw	14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	1448	1311	233	6301	10836	jwUjuuoWhKfkgz2yqJXY9aCQ5B9ueqAqXFwtVMi4RiAKgrZsmEk	7510	10644	10644	1617855120000
14755	3NLw6SD9HKfNdrPSMGxNfc2mb24UZUkkbD3FuiTeJcw8NXaruUZL	14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	1581	778	233	6301	10840	jxwN4JNvcKdfTymmkzLHwoCBe1BZpJ9YUCR7TNzi1nxHBapLS1k	7513	10647	10647	1617855660000
14758	3NKYpPmRCXoyisxLYkMsgZw4dLeLjLtcPkphhbp6qRbN3BM9E2MZ	14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	44	1325	233	6301	10843	jwrscR7cww8TMYPmynHhy7QonLRYNbyeaAHstLKC8gYrf1QpJHs	7515	10649	10649	1617856020000
14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	14759	3NKrsWSn3Ph1gtV544qpEiFF1vATGWhMrB9VMwksobetbsmvRWSC	1419	814	233	6301	10845	jxnSuEzmjmwh74LGVBesozfCjcoZffi35wJVPMB84up3UoXE3JC	7517	10651	10651	1617856380000
14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1516	1294	233	6301	10848	jwnbUb64Habe1pcZ8JUDz3NnL2FMgc2FenJFieL9kST2ZrZhxUL	7519	10655	10655	1617857100000
14768	3NKHsnm3eegjPnWAVZ9U3NUpT5dpitxoj4xynezn19hsdcKL5Sph	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jwAcohc5fRBum2yuAQf5vYXGWGRKmqNcb3FJbdLsCo3nqiNKGnr	7521	10658	10658	1617857640000
14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	14768	3NKHsnm3eegjPnWAVZ9U3NUpT5dpitxoj4xynezn19hsdcKL5Sph	1668	1124	234	6301	10852	jwmyvNMbzDnmtqA1vDytq4YKjXtnMXgQRLWGucXazqLxBMyXxiJ	7522	10660	10660	1617858000000
14666	3NKaspPbe46atu5UYBCNxHGwTeWv6LtjZsuJf1Du1aoE2owRrWAP	14665	3NK33aBrbLfeJocKS1f7o3qwUHdyzUipSPAwypnpZpBPiYtu8gbS	1406	1393	231	6301	10757	jwE9FGv9QjtVxBGuN9aezSoqZaABAymH2WH1K2DuydwnFi9nK6W	7472	10580	10580	1617843600000
14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	14666	3NKaspPbe46atu5UYBCNxHGwTeWv6LtjZsuJf1Du1aoE2owRrWAP	1406	1393	231	6301	10758	jwLVBiq5tMQUpdmAwuV3TapLDVsxthz2q6pmZREnABSDWcMT4sc	7473	10583	10583	1617844140000
14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	1593	1346	231	6301	10759	jwC9HASs2r4tynXqykBdop1WAtmsGDBJdwGmKY8JJwGgKKftLKL	7474	10584	10584	1617844320000
14672	3NLYcQiYCEDxaty8Fd6U2X6HGJNDdcRQtsEngXgQK5cQzBHnrQa8	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1451	1292	231	6301	10762	jwz7XmavCmBx4UsT26tyEcfoeAyqxhGuefxyatM7jfTmN3XpeGS	7476	10588	10588	1617845040000
14680	3NKScPsiY42qLMcVn8Sqw9iKSHgoZRHci47Zw2Hkh4Fu6odH71L4	14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	1675	1342	229	6301	10769	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7441	10593	10593	1617845940000
14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	1609	1207	232	6301	10772	jxk1B5ghoVNn8K23wPgcgga6pcuMizd3zRxFbyrtDPkS1DBi9Ph	7479	10594	10594	1617846120000
14691	3NLxcniCu9VEUFCoHpp1YFuhqJU7Q3bWGvCMBJvXVu7omiFxA3sm	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1481	790	232	6301	10779	jxoGNhhAknp4TbbdxL2LbLSuD5icRCVCFn989LURk9MwxHcnnNf	7481	10596	10596	1617846480000
14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	1407	1395	232	6301	10781	jxppTDn3Pym3vkkNVYhWY5CGPzEQHzBWQ4b6KL6hu2MetxzVF28	7482	10597	10597	1617846660000
14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1513	1379	232	6301	10785	jwKCH8r5eYvJHcYGVHb4PvStPq1gZ3XARHbMmNA5sZjaMqSKVck	7484	10600	10600	1617847200000
14703	3NKcep78ocDmpVvBZhiVmhnMnMmTec8cCG3LGiFUme6ZFVxnrHTc	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1407	1395	232	6301	10791	jwmoLUxxGE9RfhieE3LH5szXaAkXHCs7WJzPCtqrYPxT813cHfC	7486	10603	10603	1617847740000
14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	14703	3NKcep78ocDmpVvBZhiVmhnMnMmTec8cCG3LGiFUme6ZFVxnrHTc	1564	1092	232	6301	10792	jxYoVmoMVYrKBYtYoMTn85wbCpAdBLKN7WsfY6bkfiAyJV8uHuh	7487	10604	10604	1617847920000
14707	3NLUSbvBms9MWHrm57kGNgok9BsQ1HygmdqP2iNdg8HpRmDTXvsP	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1448	1065	232	6301	10794	jwkQfpgHZETEELUXtShyM65mKikWpJPx48CyP4xYPP9845gS5qm	7488	10605	10605	1617848100000
14710	3NK9SB9wSFkBaiPphchzsUCqaM4d1LHkvAaS1cNk6jT9gQQCmRZo	14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	1634	1331	232	6301	10797	jxj2VAzTZaFXMBZiwH1eVoUqo2HuxqxKTsS4pHezV5qaW14nBNK	7490	10610	10610	1617849000000
14712	3NKE2aTTB9a7sBVpamfyEnUQATHhWjC5d6inV2Ku5oVeshuwSJy5	14444	3NKRhPKew1azQU7aX7hauWZgU1Hpf7yXxAeBhQQ9ygsETnuV5nYU	1455	966	221	6301	10799	jw91r539jwan5vraMi7aZ6r7AxEFyy6TYaUb3e5SVqMmM3d1p5a	7290	10612	10612	1617849360000
14713	3NKFdqZ1BbTEHJMhjarB92aLEviGCCozK3CtuywXX1k1nvEHph9S	14680	3NKScPsiY42qLMcVn8Sqw9iKSHgoZRHci47Zw2Hkh4Fu6odH71L4	1675	1342	229	6301	10800	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7442	10615	10615	1617849900000
14718	3NKyZPWwx3uM3EtwT42FkHJWkFncEUqpRLqqCHA12tchd7EEnKgs	14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	554	554	232	6301	10805	jxozNdoX9TEKJh29Kgez8B5PkuoMyTeWf9QC1smLYDv9bS9Lo96	7493	10617	10617	1617850260000
14720	3NKCLgF2ZqmdZTY1nYCBfH7iz4hiiwfsPskG9REbxmdXjat31HXd	14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	596	1180	233	6301	10807	jxZHCNq1zoBgHUq3uBcwwRY6po9dGXrey8ktWQFcnEhaWRnZqYr	7495	10620	10620	1617850800000
14723	3NLtbrriEFJpaLKgMWka5pJKoCM3ikgGosVBbLpxbvNpYs6KNqav	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	1490	1274	233	6301	10810	jxpgsNLjSRRrXfh18843F33BBwGuttP2D4QxSRqFjeB1CkChMBJ	7497	10622	10622	1617851160000
14730	3NKwBKGXjxXWUvhrDvX7kH5Q3FrudK14nDvH8jXDRHU2baFKUXqY	14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	1560	1291	233	6301	10817	jwsqDeoydyUgZE7YJVEqng9K7cxb47TnLuXtooZezmDfe9ynVmK	7499	10625	10625	1617851700000
14740	3NK3YREPZ65f8obvcMEx2fxb7iFaabbDwZEEmcDLMe4jSQPtcCPJ	14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	1581	778	233	6301	10827	jwvUDTxAJn5rWRMRDhsmQb1T17iEQpLWamwbcic4DCPg7kXeS7C	7503	10635	10635	1617853500000
14746	3NL3kmB1364ahxmhzNfsinPNT28x4C8yie16yKUo5Z8tGD5iVtpi	14744	3NK7Rm8Bw2uX92ETnCHsLgmrvtR8nrNZnXUSpJ3vENHVkoWR1KFo	1637	816	233	6301	10832	jwXwyQoPbJTbsfkC6epJWfbw347JGJDWVW1KFmyhhxadoTmuvgW	7506	10639	10639	1617854220000
14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	14748	3NKoe4E71kMUM8fbFYrBN7hWyxnb5QpxAgNmLeeNqQjJVEBYTApW	1405	873	233	6301	10835	jwk8cTwUQ6BH4xtDLFPDiXwhHJr1kd6MoFTDL7bqxcZ3PtS7tjs	7509	10643	10643	1617854940000
14754	3NKPmKHHTqUPB32p1uXmppfeiqyhFvootLtbm8zCJc5Xh5hqi8kt	14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	1460	666	233	6301	10839	jwyrnaToiE2HzqujKjGtXG6t8xfux1pmnkibC5bkFbp3iDSKmcL	7513	10647	10647	1617855660000
14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	14755	3NLw6SD9HKfNdrPSMGxNfc2mb24UZUkkbD3FuiTeJcw8NXaruUZL	1406	1393	233	6301	10841	jxZnrdGrEwcbWkKWC6nUm3zzTSbzuMVeqpNeokPmrymvY7hn7jj	7514	10648	10648	1617855840000
14761	3NKdkR3CpUEBR7RirGUqJPN9DWLDhY1kb8WdKUVLBLSSFWEijmUj	14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	1406	1393	233	6301	10846	jxjAj441uihs5ezXYk5cUh9yAVq6ukdi2Pc8gp1xGJZNgHwdpiQ	7518	10652	10652	1617856560000
14769	3NKbobLftdyL7eUAJsJF4N83X9EMD9sdzZaYoHfmxD92u3rZ2WQH	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jx1oceVc6weQ9xNRdWiF7HcxGwXhXEJGgWtQbwR1WqwLP92mXQQ	7521	10658	10658	1617857640000
14774	3NKdDQoDgq3c5kCpndeMpoBgy8sKSE6neksxVppyBgsQ2oiCN6N4	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	1405	851	232	6301	10856	jx8qTa29PCSmAgugCRYeQjTBonWDzUP63771kShVRCYRyFvoqHV	7483	10662	10662	1617858360000
14776	3NKruEgcRHECjpoZ2F6iPRAw5NCP8qG1YcdzLit1V9BCafZZm4eg	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1405	851	233	6301	10858	jxNafLh3voD1FLhtJ825fdEcopbfgNJCXeRArYBc9LrzJst9Hsu	7519	10662	10662	1617858462724
14781	3NKA6uLEpzcx1WkDVqKN8GWxkzjecHTjpC2QVvVZxTiqJZ8JYJcK	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1652	1069	234	6301	10862	jwB1ogJtG1DHhaRyQK54mzFu4jFvbhfTTvbEshK3D3LiLueDPap	7526	10666	10666	1617859080000
14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	14782	3NKB4w38KXGKbJf3p4rhDNt6EBCpXCEmKq2PwqJkTSjvvcztyzCz	1571	1335	234	6301	10864	jxAgtnhpjKFa1QYgjEfdEv88XFT3VoLY3mjQkTjisyHPiVixUf8	7528	10668	10668	1617859440000
14786	3NKdeUZNjurFRm6prJTBwVYoxR8vxdSxbJdXiVdf2UVHSJpmpxkc	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1610	948	234	6301	10867	jxbCN9KMpNJpcG6Lf3mZRe6XJBCi42RGQdNrP3MD9hV5qs4zb2h	7530	10671	10671	1617859980000
14788	3NLvK85ZhPSBr4M9JTtL53S5nRvYaVR9g8LcgskYhNUMu5dNfdmK	14786	3NKdeUZNjurFRm6prJTBwVYoxR8vxdSxbJdXiVdf2UVHSJpmpxkc	1509	1320	234	6301	10869	jxcZ9APMZiEehxEzwLQomf42ZUpcBWWKt2H67GSNpngmsXd5MhE	7531	10672	10672	1617860160000
14733	3NL4d97xxg3eu62zzBBq3JvfDPeB2tTdCXmgFtvyHBR9K6ocb8zf	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1407	1395	233	6301	10820	jxSrS8xvyRKB16r7KRFMXx8naCL1vqZCew9GwS3m2AHn6rbbSYV	7500	10629	10629	1617852420000
14737	3NLNu6hJa5cP4HAcktMmGEeWYNMziBRDqh6xtWP69oiWejdc35SG	14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	44	380	233	6301	10824	jxJCapWZn11qrxL7EG9bndki5GJWmVRVQg1DsgsnYesndtrh3et	7502	10634	10634	1617853320000
14743	3NLyS7F4d4z6BHeZ6zgvp7im7WFGbF8bVuDvzeQqimSRA7GnYdL3	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1651	1175	233	6301	10829	jxNBTAmZLTxLoJvpJH1H4DPQUn5Spa5xyY6X76PKvUyVxy7BX9W	7504	10637	10637	1617853860000
14744	3NK7Rm8Bw2uX92ETnCHsLgmrvtR8nrNZnXUSpJ3vENHVkoWR1KFo	14741	3NKRoSy4xDKyszezvuCni38dt4hjkAUGVCqsGPmS4biA9E5wwJsE	1406	1393	233	6301	10830	jwtatzjw2DhnEnqLxRogpWwoj32RHLHQxf4WnYrZ2nZFmntYt9w	7505	10638	10638	1617854040000
14748	3NKoe4E71kMUM8fbFYrBN7hWyxnb5QpxAgNmLeeNqQjJVEBYTApW	14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	1471	1386	233	6301	10834	jwmWCPD9EwKaAG4cZQnvdS8XPRF67xQ9yjNZKuAtzZUiEAdUK1F	7508	10642	10642	1617854760000
14751	3NKqnYEo2owzYCkt9529VHbt2Ph32FnRszEM42CbBJaUKo4iAB4y	14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	1448	1311	233	6301	10836	jx8UwKVMg7K9gEjouZ2HQfgmBzBawKEP2PYkS7aNxmFxfJoVm1p	7510	10644	10644	1617855120000
14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	14752	3NKQgpt2jLVnifxdEniaDtmPZ2segU9etBP7TB5MrQZoNBmRGDBp	1656	1343	233	6301	10838	jxr8gjysdGufwFKhkBGfjKATUNn43Taet9RqA5XsYDge8DeN1Vq	7512	10646	10646	1617855480000
14764	3NKJ5ynUKFDrVrzMtLCtRubWJUeMzBNudXKt2wRkBQCvRm9g9eUK	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1406	1393	233	6301	10849	jxRbfYNFDK3YwwLBY63Ekuv86VTFNWsPTQiTrq7RmJimJCCygpk	7519	10655	10655	1617857100000
14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	1671	1119	233	6301	10850	jwKDKMyJq2wvdCRBvXLEE84RiE7jL17NjojacU1qyyKdG2hUpjq	7520	10657	10657	1617857460000
14771	3NLiNawpFZVskCYU6rBFev86dtPvUmV4kvvBRNbAdVLUdffLVh7J	14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	1407	1395	234	6301	10853	jxFe4pUgRxrpNnxKLCofqjhSGvQuMZy1J9N4FhRLLKp22DMCBkQ	7523	10661	10661	1617858180000
14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	641	1210	234	6301	10860	jwP1yBW8GTBeSbrYCLN5VMZB97C7nsVe82RW9h2h6dYZQUcB4wB	7525	10665	10665	1617858900000
14785	3NL1ZMNZ8iMpLHVzoPjjD54dx9DWJNGA53yvU1xD98nQRT2cQLCS	14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	1590	934	234	6301	10866	jxZD9zYckLTgCf4g6YrdfUWtrTD2yzfxAGLLVK2a9PNULWHBFqU	7529	10670	10670	1617859800000
14794	3NKnamkeEHfDmiAxzVfhu2pr9eVk3RMzTvB1LVjcf64PHoKUProS	14734	3NKBmP2PCFJCiBfQ2vnvC2Nh3Dty1WEKeMsxacBMcMB6X5Svgxrg	1455	1206	221	6301	10875	jx3hUZbvKszBT1j1ZJaJJPZfqXTmpJfg7fFinSbA6NohgeKSAcq	7292	10681	10681	1617861780000
14796	3NLgDkaT58b6Mfr9nfeN1hYw3RpQDqCFU51y7aFwi1ioMjCjbQTf	14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	1609	1087	234	6301	10877	jx5xzNp8MjqyjoDuqnuhsNvQj13Wm4BsHUEKTNU4NkLxoTpXfvM	7538	10682	10682	1617861960000
14801	3NL65NwJtJ9uGHQz7s1urjo9jh8eJJPSN2RTLzT9fRQD8UP7gr3m	14800	3NKvMWGLpmybGFPRCRD7sfNmU5F5KZgSE1YL4SWYCKq8isPb697y	641	1336	234	6301	10882	jxsJ6YGdaYqqBGN5hskgoHLxABE8WPzro28D9G8K8rmWBtT18Dx	7541	10686	10686	1617862680000
14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	1656	1343	234	6301	10885	jxnCbQWc6QSnt6xbRzeMKK6keM6aWRLomWAQd3Ut1p8YyP8ASGF	7543	10689	10689	1617863220000
14830	3NKBK18Sx5HS4RykD9gh1KFgSx6XaqFG2UfhBHsQCbEnbWfT1gD2	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jwDo163shFTt9zwHwFVdgnJTtNmgsAAprXaGpEgLq9oC4soE7dd	7559	10712	10712	1617867360000
14832	3NLkQD4641g41tC9JMEM9qcMmn8521Ce83DJoE2Yek5czRsgVu9h	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1426	1364	235	6301	10908	jwxzadC2s61KAs4D9YJpLYEwD2ayCeqrXacCBiktZ732CFeP3wv	7560	10713	10713	1617867540000
14835	3NKoasyXq1Z5LL4AHvn21HMeacvm8RsB1YXTGRVoMsC6Qqi4436v	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1637	816	235	6301	10910	jxCTUkSgDhzmCs2wDuba1SZZWWrjeK2ceT2FTiYQsfaQwdGL3TS	7560	10713	10713	1617867540000
14840	3NLAmaS58pj9jdGxzu5CeQ4FaMjHGwgy8QQPuXkU62DRHAEPg8rL	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	1637	816	235	6301	10915	jx8xNVSFpawJ9rfT6qwctJvxgX96fMETABoyf2bGJCfmcdXfpv8	7563	10719	10719	1617868620000
14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	14838	3NKtonFUJNuNurGJHPMHZ8jShB2VCcNgnHeJ4e6SkqZTZznGc8D1	44	83	235	6301	10916	jxoywj1ipTM3mKWoAFeM4cn31YcDAC5QdLLffkjRBFjg5MQYLRM	7564	10720	10720	1617868800000
14844	3NLvfyFV8rnft6iUUk4UED9xrdEiMFnoYhBpxpCx1zx9Mk9B4cWD	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	1507	1280	235	6301	10919	jwMBPormy26Dvvs5m8iWM9JcS9wcHzXw3e1ZYpNB5GGTbCYZD3w	7565	10721	10721	1617868980000
14846	3NL8MyRKqskvEd8vdzJ1ijmXbsyyJPGyQjePSgCNftCauHGCwSK4	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1508	1261	229	6301	10921	jxDEe1oJq5XtydyXCuoaqeBoxWA741w8qGMFuPcwvvDMaxHWZ45	7430	10722	10722	1617869160000
14849	3NLFRTjHqSZAK2AR9ZvchVKnpgZrFJxhdKGrDqLU6st5Lfi8qA1R	14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	1406	1393	235	6301	10924	jwYQeWE7wMjYpGGrKiW5GuiWGSGR91Xe4VNPQkXvjbQSmZKBe91	7567	10725	10725	1617869700000
14851	3NKqcmbeTbYzx9JfJ57dZwtVFJcY3SUK3fVou2iGMQAZ4bboZhW4	14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	1619	1275	235	6301	10926	jx91Z1Zn4MeHCS3gXBTuupHd4abZcwrhqow3z1Y5AgfwZncSPj8	7569	10727	10727	1617870060000
14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	14851	3NKqcmbeTbYzx9JfJ57dZwtVFJcY3SUK3fVou2iGMQAZ4bboZhW4	1407	1395	235	6301	10928	jwXS8EFnRWi3BcHBvSxRbprEnQ6ixSaDmMV7msQ2fgk5qNn7DVQ	7570	10728	10728	1617870240000
14854	3NLqY6DHgFB2U1G3RNRoeTjKFpx6b1b5bqdgReUko28LHyzXqKn2	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jxZ1dRHCqun25Bjw6zJvcvUyyZucxVYBQdjVYdZVUTyuq6LeY9z	7571	10732	10732	1617870960000
14859	3NK6XzKzUqydoyR8fvrE32SPvKUav9czhKJ5M43mZDXLjEA1ZD3z	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1619	909	236	6301	10932	jwRTTrZLSgVJmrrwMJdbrXzcXwTk87oqT32aNV94evNm1AGsjFY	7572	10733	10733	1617871140000
14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jxupU81sKbKkrE6cFx4UEZNATkndKWX8ZDMCWewuqK1SeSEL8je	7571	10732	10732	1617870960000
14864	3NLr23qpfTKMM37foXJLpumKsYPSdNyvpA7knvtEKLsuVa1hNSBD	14862	3NKymcYKhBM79SRt8k2HVyQEDRyNCQJWyzfF6o1vd1S4DTaEXn2i	1406	1393	236	6301	10934	jx9G1W8PXuP5hSzqG9xUAhSV4DT9rufbghGMVemAGQMb9vFLJdJ	7573	10734	10734	1617871320000
14869	3NKKkkr5yYejjN6SFLq8EAeVksTwsNPMAj8ZUhVXK2ysp9PWhzLS	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1406	1393	236	6301	10939	jwkvcTfQtkZx3Yj2TCXXDeaDhHcMojDDtnrWXibMXPgYvhsGKYV	7575	10736	10736	1617871680000
14871	3NKTXeB1eojR5aJoQdSuBT7sVZXgR6tzbyD182opR4hZXkkJ4Fga	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1403	824	236	6301	10941	jxFGJi9b88i6kgSCLmd2RAoKFA7557zj7hxggcPsBhBpWb7AsFa	7576	10739	10739	1617872220000
14773	3NLmyRPJkNz5nkKWNih32NRTopd7zMUGu9xbHazEyznZAyn5HiUP	14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	1405	851	233	6301	10855	jwQaMF9CZ9nkbu3rSDV7HXuc5mBeFZrTXtWXKoQRoS6f2M5QGnR	7495	10662	10662	1617858395724
14780	3NK99WnBMZZWELW2i2NVLSu3PmDKXi3EMjbTyMLcJNYnNkeFsRo4	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1652	1069	234	6301	10862	jwbsctFMjR7CcVkvTwMsjHYNLeAfg9fQZkUib55gm5irBWSZy3c	7526	10666	10666	1617859080000
14782	3NKB4w38KXGKbJf3p4rhDNt6EBCpXCEmKq2PwqJkTSjvvcztyzCz	14781	3NKA6uLEpzcx1WkDVqKN8GWxkzjecHTjpC2QVvVZxTiqJZ8JYJcK	1642	1367	234	6301	10863	jxUueJ6DtjEJR96jnExGcVFo3tQ2JYhJ86Ju3feGVkG8cKs6Qax	7527	10667	10667	1617859260000
14790	3NLesXwMfbX1PNp1mfGEJr3GsZ4jiGhQVK6XnJX5sv6u7HBJRkSD	14789	3NKFsUuqDdHWCJTdYN1GmEywmJttYhGnBZ5Eyt5W8kWoFAWcoE6u	1631	794	234	6301	10871	jwhG4yCXNNji7YQZBy4aZVu8mR1o8gQMrjB1dLPfdWyq1V6pYJf	7533	10675	10675	1617860700000
14793	3NL4YsaMFTVwQMHMCB3vm3zGxoFq5Y9gF41byLmdAaEHn8LP4cRY	14792	3NKfDGjMXZ1uXoviRGB9o3TFpcmMbE1F6iGxarivTWFjtfNnTprn	1407	1395	234	6301	10874	jwxNVAuWnKzTxcyvEFyHdjYwhK8DScHbREDXRS4p4erG6ZxSz7S	7536	10680	10680	1617861600000
14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	14797	3NLGSzLhdbr1szwKnv5Z2iaZAJTKPVALfoCBj3wcN3uW3wHuZDdX	1672	1285	234	6301	10879	jxRZkJa1H7uLNETkjKrE1ZRiQWPscxWGNNTwD8w3Xu6CXPcLibn	7539	10683	10683	1617862140000
14800	3NKvMWGLpmybGFPRCRD7sfNmU5F5KZgSE1YL4SWYCKq8isPb697y	14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	1553	776	234	6301	10881	jw9dNR3SyZZ4Dj4p9spQBu3Z8QZuyAHvDrAJgDnDrBuEbnB1CRa	7540	10684	10684	1617862320000
14806	3NLSxF66n3gs7cbS6TyBg7r83TVeYVbh19srV8DqoprrCv5CWXgC	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1624	1088	234	6301	10887	jwzqEpuezpPMgJwsshLnKhr7rAckN9yxREWvfddauwSp7qrBQa6	7544	10690	10690	1617863400000
14811	3NKazSHkPmktTU8Ecd6xHf8RGb1DG1xvozFFwwEU8DyS8AYcx7GP	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	234	6301	10891	jx9mfi21SiM6TDDVkn9ZyPAW3UrgzErvBLqEht71NfkynjCutAp	7547	10695	10695	1617864300000
14817	3NLcPzf5YAGiNGF533mi9Nz3Zf5L8Vks3Jbk6yauaiL8GiDwNbgG	14816	3NKrSnJA2YzWvz5fhHSMCnEPk54V9LXc92to2eKDCtYfLkAqmyQe	1587	991	235	6301	10895	jwTBezztB9gpz1iGkKpMErmjeTRhkaEkGRmZB6hTmQkodvCx8MX	7551	10699	10699	1617865020000
14820	3NKKuBHFSiW7aR8FE88BP8o8hhnkeqs1cD1GiXaEnMtgMrbfUJHo	14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	1643	933	235	6301	10898	jx7nCDU2sm1d2R98TteXEDtUAcxqL21dnX49KV74gVyjyD7g39c	7554	10703	10703	1617865740000
14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	1624	1334	235	6301	10900	jxqvnfyAoFoSLfvfV9k8hbc2URuUWqrTJZPA1B9Y6N14NaNn6dL	7555	10704	10704	1617865920000
14825	3NL2c9kt9P7tARzyYnWxYmFQjcQtUtsQKZavE3Np7KSREAsh5nzD	14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	1407	1395	235	6301	10903	jxAK6nWLerEw1ZUp8Sr6in2gURDmdfj5ooY6FbEBiNjjBHxFKdp	7556	10706	10706	1617866280000
14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jxmWHNMJ8TmW2VXyCmSBSoYyvuUeDqk2BUmUAdRGViwd9ifUhfC	7559	10712	10712	1617867360000
14833	3NKHxPvtazUsycSTeCjHuyR8axTGagnKYQLimdZFGQHacZtzjGZ4	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1602	1123	235	6301	10909	jxwMMHifdTdxmcYHqVDqVNcbmwa3mgDDxtALLNWAVqj8GfQfmEz	7560	10713	10713	1617867540000
14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	14836	3NLv6iPQLb9mwrGUPXF9Bh3Ke15qDeBc3fS5GimRbRjXNSN38o9d	1439	1279	235	6301	10912	jxkb1uRVPnKLPVHLvK6fc8Xjjo9VWMCdvzLRsmSqmFKG3zYeS9r	7562	10715	10715	1617867900000
14838	3NKtonFUJNuNurGJHPMHZ8jShB2VCcNgnHeJ4e6SkqZTZznGc8D1	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	80	1273	235	6301	10913	jwJaNJLLtagVoQGwGBZkap2C54V6FsHBhyxtuVaCxe1ENdFeEkE	7563	10719	10719	1617868620000
14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	298	1308	235	6301	10918	jx71QjvyD3zANw9dbESCDt6bGEDDxjLXSsKDtzSVMy68NC9uPkV	7565	10721	10721	1617868980000
14856	3NKPN588iCjRARm8PMXotPhAcKZmKEd8NeoJL7DxEnQbovT7GECQ	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	1419	814	235	6301	10930	jwxhZhmT26JomZWFCtvCNSR1oUU1JLvpBB6GtGr5sacasHnYXdF	7571	10732	10732	1617870960000
14863	3NLZsom7eD2v4YEQ6AMYonmebhB27hAvk8D9KHThZGfejZLbMX6P	14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	1619	909	236	6301	10932	jwwXV4mteW95A37zkPs6fmEWQhvVt4vujXinWHSYHQQ41nuKsHu	7572	10733	10733	1617871140000
14867	3NLk67R2yWTkAojWRBz39uB2GMSmYMmd5yotZCQM3eJNLCFbjmJp	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1407	1395	236	6301	10937	jxp5oRwyTgLWWcebPDJ6nbvja1PdBsR96inWL3gmJeEkXzCi87R	7575	10736	10736	1617871680000
14872	3NKExzkZ6RiDVy7uaQXYApVNuGYSDPj6AF1KDYb5zw2QVUkbEUqT	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1633	1144	236	6301	10942	jwxBK1Sc6T1QTxRzodfri8EwUUny3eV4tWJ47TtSqzB7FPe6zdm	7576	10739	10739	1617872220000
14875	3NKzSpsWwL86RXXgez6qC3gMVGtbKjspG826ZVxfkjbR8s19AZcz	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1407	1395	236	6301	10944	jwSD2A8s7V9UenjtF2MznXdduH88vJXBBFz8yYpime7uT5qAwvw	7577	10740	10740	1617872400000
14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	14878	3NLKttNg8j9WHKiPd2H5jErzzEDgeg6XrYNVb6BTauBK8xGBzAtz	1406	1393	236	6301	10947	jxPZuDBo7fKJjSG8ouFMrPSzGzg1BwmDBpffG8kL3xGdWtphRnF	7580	10744	10744	1617873120000
14882	3NLMxn146rYN33yAmL5zMC2wpLRvGS3Jpxz21SJQvbjeWuqyzd8H	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1490	1028	236	6301	10950	jwyC5yoFZJbzBWGpwjc9p6fyiser7S9fzfp3KtotVaHEiH13bub	7581	10746	10746	1617873480000
14884	3NKFnvKfg2JAkdKoFMueJi7SdXENmGcSA4tFGK8yasgJjE6debNM	14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	1407	1395	236	6301	10952	jxYtrZT9svBqdQchvvWX7ThsHkp57jfKhfeZrNaa3uLjk5U7zyF	7583	10748	10748	1617873840000
14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	14887	3NK6HMgSzsZx9VJ1M7H9qWWfBVjBvADrnoZY6EKazGEaTq7ovwY4	1402	868	236	6301	10956	jwDHCCtCFJJTaKpmdx3wTgeLumtAXSB5UTXsLJGcaeXtn9u6nnD	7586	10755	10755	1617875100000
14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	1581	778	236	6301	10961	jxiiQzL3BSybDVu3PfaHkUEd54JEuohMqZrvnc64DeFqUCwstjC	7589	10759	10759	1617875820000
14896	3NKHvyXqVHoU8XQwgqb98hx1H8GJaavDpdW4EWxgotnLGbfySTk5	14711	3NLRj73zuK69GJDrCKMUJh7qMiE8nZULdNpA2SbhNgL1sfptcAth	576	1229	228	6301	10962	jy2PdfHab8WJ4T9uLHMhmW8kxqU7F57LULnnfBdiDBmeq2c9Ku6	7420	10760	10760	1617876000000
14899	3NKoB8o3YvdgVrPLdXEfCS3kBQeetH5ofQyH8SYuUCDcE1gPEAZy	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	1406	1393	237	6301	10965	jxpcmadzoLqjpz7ugEgd2aKPWFANRGB7xJDS9bM1ahFQiakGZxp	7590	10760	10760	1617876000000
14910	3NK4w9WM7jC7MGDht2dLDc19UkZuqC2MYr9qeHL4nvxm5fyhbzti	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	1403	824	237	6301	10976	jwMQ3YNuQRQ9exVhQwKXfaeaytqWei9cpDCg8Gu51ZJhZwg8AMi	7597	10767	10767	1617877260000
14919	3NKQ6onLr4WbMypNZYMympmWSbSGVm2E3UaSouwLABatgxfL6U63	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	1406	1393	237	6301	10985	jwEjvStR6X72NnY9suimbpW5abyawwbydL2WbNFboMHWNz2MhpJ	7601	10776	10776	1617878880000
14789	3NKFsUuqDdHWCJTdYN1GmEywmJttYhGnBZ5Eyt5W8kWoFAWcoE6u	14788	3NLvK85ZhPSBr4M9JTtL53S5nRvYaVR9g8LcgskYhNUMu5dNfdmK	1587	1111	234	6301	10870	jwP92B4sWihq4pPHkoyFjfAHrE4zbqbAzr4dRstz4BS7ESjuDYU	7532	10674	10674	1617860520000
14792	3NKfDGjMXZ1uXoviRGB9o3TFpcmMbE1F6iGxarivTWFjtfNnTprn	14791	3NLQys99Zp3RoU7eLDCXScHGTzATq41suYJMDdVSskNYSKFvtCNa	1668	1124	234	6301	10873	jxDk9eBMc8F2yweQRyXhekXPqW7HX2WvPXbBvDexFRHR4vGsyDx	7535	10677	10677	1617861060000
14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	14793	3NL4YsaMFTVwQMHMCB3vm3zGxoFq5Y9gF41byLmdAaEHn8LP4cRY	1419	814	234	6301	10876	jxAs8QP771jT16BGzS2wcke1a4ww7pDEWBL74nZZQrZHDixChWX	7537	10681	10681	1617861780000
14803	3NKT6TdomB6c4SovroB2tyBAegUh3apzuoYr1rxwyhzYcrjbdiMn	14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	1585	1000	234	6301	10884	jxi4WZUHWJd9sHkZ9cWXK33rXCed6ds9g9AAXR92YfNz7sj8Z7u	7543	10689	10689	1617863220000
14805	3NLfMX8XKEkDWt63ddcKRp2aj4PNtcjuVzwyBm7quXZ42d7jLLT9	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1589	920	234	6301	10886	jxeDdTjpfVYk6jTnsVRmH9uHiLFzi1ndCJkz3LuA65uTQ4qVCRg	7544	10690	10690	1617863400000
14808	3NKk6cMezV8CPy726X5fuc31rNB1tAeC8EqfQqwpmJuGevK459qp	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1624	1088	234	6301	10887	jxRmEGzRshRAdQfhn4L3Vf5EfciH5bS69AozzAUS84ixwE7bZVH	7544	10690	10690	1617863400000
14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	14809	3NKoiTda5WdKv4fj9fG2u1DWZzjtaqZebrbgy1druHgA6m8VGh4L	470	943	234	6301	10890	jx9SU9en9kDwbHZng5s7p9vFbRitdvhdBp9Hj9QEVo6ZPBuPRGE	7546	10694	10694	1617864120000
14813	3NKxMWpUkAX7FGLJTGzXpJLwhShX3a2hsrAKgF7XttkqfDjR6Hjk	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	235	6301	10891	jwGTALXqnAkhqVR17jWS56V6u4FE9WJh5BnjJhS7A7hVd59svZ7	7547	10695	10695	1617864300000
14815	3NLqF7SL5hWuyvxFmfdjB9gV37YYWX1qTFCcKGNTzFZJGgLwjZyv	14814	3NLCcqKF7HhEUEW8PZvn8zDNSyhpLvhbZfgBKQ6RRXBVqjLUP22R	1483	127	235	6301	10893	jwx3FTRJkdwB4yh8tw22RPdt3zSjqRjvaz9cwXEqG3j7NsP9iZt	7549	10697	10697	1617864660000
14818	3NKx42ohk7icJpYpVo6rd1vzbwuyrLSBcSLqqjtHwaydyiGrDGKN	14817	3NLcPzf5YAGiNGF533mi9Nz3Zf5L8Vks3Jbk6yauaiL8GiDwNbgG	369	1066	235	6301	10896	jwTDxWbp6RV87B1Jjih5ARAcKHqDQx6UxTt8jbDMNTzrCT7nWnu	7552	10701	10701	1617865380000
14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	149	1037	235	6301	10899	jwZ9TCpu9dx7aAqGYVoPsT22xy9uR641xESxpPoQW8NpDwLWuCq	7554	10703	10703	1617865740000
14823	3NL3MyrXDjJ1wQQjFaWpgpA5g2LxVvXeK153957Vx19TN7FMNQEF	14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	1581	777	235	6301	10901	jx6P58dmhUzDNnD8nU6P9WuX1NGw5hLTH7J4WTb7CD7njqsjeyy	7555	10704	10704	1617865920000
14826	3NKz8Nqoqmb3Lq9cDetkRPcvyX5z7sF5BEtf21Pg9VoXC16XZrV4	14824	3NK9eWtTQQDQeh6JetKeHLhGk2EZWNztH4LL67dNAG9eoKzZkSN7	632	1256	235	6301	10904	jxnxRRuKLmLBjK7PsFeDqxquZkuK9ZMQsqeMctKdSrsQebwZDth	7557	10709	10709	1617866820000
14829	3NKZLj6ECqssXactQeNU7ohSUYEHCnQBgabtKAZcME7yuFmWnYoY	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jwHyzHAkPoAbwY3WXzYjqFPzLgY5HUbC592ENySTDuvAeFVhpcP	7559	10712	10712	1617867360000
14831	3NKbn3mND4hfMtdiGD3j6G59amiwuniJdwmgNrT1Ca7fT1qjBqd2	14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	1602	1123	234	6301	10907	jwyBvm2x37kCeaxrZi191XoZ5VCm7f7GmWvoGuiDXHZQGdY33q4	7523	10713	10713	1617867540000
14834	3NLaxjxkgtsXeFnsfChDooTWyzMEMjq3Hied2FBDVhfPGXmRMAmp	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1602	1123	235	6301	10909	jwtKsy6uSvZrJA72jToRCRVSnV1JKZw19sUqmnYpVLyUCFfiJc6	7560	10713	10713	1617867540000
14839	3NKaaKojq3E8LbEKXn5tzeht8F3F9WshXGkpbkydg3EQAr4A1ooJ	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	1516	1294	235	6301	10914	jxUHiCXDgGzVKG5r57QFdM9v7rXLh6VRt7tozNXrxjpLFfm2qY7	7563	10719	10719	1617868620000
14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	42	1235	235	6301	10920	jwpdF6AwNiZyYasVkiVr3MiuTKnivnW72vxiM48Ag4sLkgLNtjQ	7566	10722	10722	1617869160000
14848	3NLvpk7mECqxtAXLimGmKzbWk2JJTGjJo6DpLNuCDiWJBeBjDB3i	14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	1516	1048	235	6301	10923	jwfQk8CVqYMBZBua9aBdwnC7dnZrMSLR9Zw8CTELqD6JY4kJsav	7567	10725	10725	1617869700000
14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	14849	3NLFRTjHqSZAK2AR9ZvchVKnpgZrFJxhdKGrDqLU6st5Lfi8qA1R	1647	1302	235	6301	10925	jxfARuzFmAdN68peAY23135u1xxpbHeVVzKuJzF9Ahc9bYV7jP6	7568	10726	10726	1617869880000
14858	3NLZ3jaMzpcETqa7V2CaQBWm1mKkVThkE3wh4gWzEAJxVMiRmmMS	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1471	1140	236	6301	10931	jwn4VEFm1bSBC9a5pXCyajwrjohfNc8bJmvat5F8G3DY3axkUZR	7572	10733	10733	1617871140000
14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	14864	3NLr23qpfTKMM37foXJLpumKsYPSdNyvpA7knvtEKLsuVa1hNSBD	1553	776	236	6301	10935	jwJnemCEkAUTa5suyRJzE3CiNRpk6aF7yk3jTPmgHcfCm7jn3vu	7574	10735	10735	1617871500000
14868	3NL9x5Xyp1L6DCRHMhGNzvuquVBw38Zz6H1LmwUxQsyLue2xKr4m	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1581	778	236	6301	10938	jxXaqWKKHvaMLSCsjfXJujDu3tXbeNUdWDSmfBK1qFVREtbQHAU	7575	10736	10736	1617871680000
14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1467	1376	236	6301	10940	jwtzGamHdnJods7gQtukRLAdhPwQdDdkTdRwDhisLzBm5f8YxvL	7576	10739	10739	1617872220000
14876	3NLjhoGxTu3BtTPLycEbTw8X6oXsvLrAhTDP7hnKceJ3Hb9YFjfe	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jxGgmKmGnSbaS83EQpd3rrfYVyjS69LmsemQAz7V62zv2zWsVqp	7577	10740	10740	1617872400000
14877	3NKcBMXaXgY2vwh562PoWmv3xcRTksVFTekmYDBSvncydvV2vfnc	14873	3NLCdDxWFPUPdtmkHyLkXWAevVCEyPq6cJKKsQrYGruo5bbBY3j4	1406	1393	236	6301	10945	jwzeXGrPtGJDrp4ge6aZWkFDYH9Pt2f4jWx7miRRQhbGxKMnKui	7578	10742	10742	1617872760000
14880	3NKHJmZS8t3QA5DfaDABoMWWQ1LN1tY3FyjhDnEKDWSmvSuo2KUe	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1403	824	236	6301	10948	jwEeavE74PSbSjBkPMsWbQhmbguWeL7gTNuZWEkY8o9UMaAdXxR	7581	10746	10746	1617873480000
14885	3NL8KeVn47MzSastUUzUwanZLRB9onWhvGdV6y1nMutfhejXz2Eu	14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	1553	776	236	6301	10953	jx1BTNZKPPxMAVPn9dK95YNScedNPPGrgCTrvAqE52xiaKCQej5	7583	10748	10748	1617873840000
14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	14890	3NKVADskzT5ZBfgDv7RmCwsAxCbozB5VoubtryvbTSygPbLsJT3a	1406	1393	236	6301	10959	jxMgSPHTNCNE4w2Diik2iaEMEu2EcZHq843kxq7rDZGY8uS3fAj	7588	10757	10757	1617875460000
14894	3NKoDU5DgVttR1dMEBeKun441e17mcd6NJvheaFQWxCJDxKLEZj4	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000
14897	3NK9n4SVshN21dRjhjfeM6R9XUaDkKKmgkc1njHhVdWB5bVCQxay	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	1637	816	237	6301	10963	jwfPTCA2STmNUH9eGS6kjGGdw4uiVR24tC96R9QAThju4ooRqcH	7590	10760	10760	1617876000000
14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	14900	3NLkhH6tAdEoTfi3q8j86HLoU8LApG5DQccbxbC2uQzxvQD1JKUQ	1609	1087	237	6301	10967	jxXB1FNkgvvY5RvdVnNrKZQPvRJbeMfA649WCRfdUJxpaxSHKx7	7592	10762	10762	1617876360000
14791	3NLQys99Zp3RoU7eLDCXScHGTzATq41suYJMDdVSskNYSKFvtCNa	14790	3NLesXwMfbX1PNp1mfGEJr3GsZ4jiGhQVK6XnJX5sv6u7HBJRkSD	1406	1393	234	6301	10872	jxZ8EYM2YAXuCs8An5c8H73d5ZmPW3JepvMbEpNneMyA86KLuPV	7534	10676	10676	1617860880000
14797	3NLGSzLhdbr1szwKnv5Z2iaZAJTKPVALfoCBj3wcN3uW3wHuZDdX	14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	484	1193	234	6301	10878	jxpzU94iRhZgM2SSHb8MVCxS4gNibJy27xByYrWkEL1jd7BNavQ	7538	10682	10682	1617861960000
14799	3NLbjv6YFko98kTwhg9iRMbUBtkjdkTfVYQYXyfBaaEEj4F6SmD6	14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	1403	824	234	6301	10880	jxcMKUzVpEpLc19nrYroVEY1XeZyoeDhAjHiZYx5gzkZebMzYUD	7540	10684	10684	1617862320000
14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	14801	3NL65NwJtJ9uGHQz7s1urjo9jh8eJJPSN2RTLzT9fRQD8UP7gr3m	1406	1393	234	6301	10883	jy3Kyd9p5BZwtEM9PCNyTxHrUTxjWGyNzCL1iduzdaUxhKX1UQJ	7542	10688	10688	1617863040000
14807	3NKt7DS55ySCrVxYVmEo2T2rXuhhYMmvD53n3cV9VUb3qXB9Ejgk	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1637	816	234	6301	10888	jwSmnUtLU4diKaAvKaMNDMpV6S8Yk6xZXVqrv9yEzWKCYW1NpCr	7544	10690	10690	1617863400000
14809	3NKoiTda5WdKv4fj9fG2u1DWZzjtaqZebrbgy1druHgA6m8VGh4L	14807	3NKt7DS55ySCrVxYVmEo2T2rXuhhYMmvD53n3cV9VUb3qXB9Ejgk	1471	1140	234	6301	10889	jxdN23VyjVqnDP6nGNefeZ9x9o5nNRb169HGewBZ4LP4AmHzYHW	7545	10691	10691	1617863580000
14812	3NLtFYuEoCoJg6szxqn1MkNKALMSy2AmJhHJkm97HrLbLyjhQdBb	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	235	6301	10891	jwGTALXqnAkhqVR17jWS56V6u4FE9WJh5BnjJhS7A7hVd59svZ7	7547	10695	10695	1617864300000
14814	3NLCcqKF7HhEUEW8PZvn8zDNSyhpLvhbZfgBKQ6RRXBVqjLUP22R	14812	3NLtFYuEoCoJg6szxqn1MkNKALMSy2AmJhHJkm97HrLbLyjhQdBb	1406	1393	235	6301	10892	jw8sszYoFjYBoTE8RUtAQLfGMHBfW8fNcrUb2CA5345oiqj2EJ4	7548	10696	10696	1617864480000
14816	3NKrSnJA2YzWvz5fhHSMCnEPk54V9LXc92to2eKDCtYfLkAqmyQe	14815	3NLqF7SL5hWuyvxFmfdjB9gV37YYWX1qTFCcKGNTzFZJGgLwjZyv	1637	816	235	6301	10894	jwfmo1kf1Kigf1NE91b4T9tFhBTS91moJKVU9oLTsCb6HrxPRDp	7550	10698	10698	1617864840000
14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	14818	3NKx42ohk7icJpYpVo6rd1vzbwuyrLSBcSLqqjtHwaydyiGrDGKN	1671	1365	235	6301	10897	jxjgmjZYjqGJv89sXYUDJmN4bEMnGj7j294v6gZjscM3tPnRCkQ	7553	10702	10702	1617865560000
14824	3NK9eWtTQQDQeh6JetKeHLhGk2EZWNztH4LL67dNAG9eoKzZkSN7	14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	1648	1038	235	6301	10902	jxHbUtGCMgs1D3esthB6LcC7Z2rRLfoXHk3AJcGa63oTW6T9ES6	7556	10706	10706	1617866280000
14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	14826	3NKz8Nqoqmb3Lq9cDetkRPcvyX5z7sF5BEtf21Pg9VoXC16XZrV4	1406	1393	235	6301	10905	jwbFTVB5rWCpHaLhiGKHNPyv6xSQ9nkUwozVw8G9v4ywcFiHFTY	7558	10710	10710	1617867000000
14836	3NLv6iPQLb9mwrGUPXF9Bh3Ke15qDeBc3fS5GimRbRjXNSN38o9d	14833	3NKHxPvtazUsycSTeCjHuyR8axTGagnKYQLimdZFGQHacZtzjGZ4	1406	1393	235	6301	10911	jx2xjgjj3UvaxKGkqDiqYZbYzjxX72soFD8J416T6MHCfUGcvHg	7561	10714	10714	1617867720000
14842	3NKBC1j8UQtXpDT8DfcizbY8Nng2naVqQVZdnymKbo3PmWH8HgN7	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	152	1330	235	6301	10917	jxCjfeg8kaKagUHYGL8LqxK1xX4DtwKdx1NxRtRcZYkyVS5paQT	7565	10721	10721	1617868980000
14847	3NLLDhEaAqcQNW3e9juAxJAnyRdWSUHZVsnCT8s5zW3KJJhPsCWo	14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	1508	1261	235	6301	10922	jxYbiwhvom594iU1Gq3PgrANa64C6dVPTgdmG3mM4h41eYkJTwi	7566	10722	10722	1617869160000
14852	3NKphdGn1UiU9SGmRQFyEVEBggrJvSRwmUReXbp4U48LS4BS7shj	14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	1406	1393	235	6301	10927	jwDx9r5cCLnRzXKYV65D2dYmnNeGpRyDdyUpJfXDLvyacSNnXRX	7569	10727	10727	1617870060000
14855	3NKPoEGMLkruq3a9X2ys8KdfRG7pD2wkicMsFjSzRvLF6nydaTKt	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	1419	814	235	6301	10930	jwuAqfshprakp34meQ54sBYCuxHzcJwrCykqJV9VXavG3Fhm5Kj	7571	10732	10732	1617870960000
14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jwRWwoLv3z8UTBZbqChoXSBpWifPu4FoA33bMED5jm4ao7pZDy4	7571	10732	10732	1617870960000
14860	3NKdP4rEjwA73P2ztcgdZd18HG93HHNu2GvmoqypqEaBk6Qjc5SF	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1619	909	236	6301	10932	jwr9BMyuhNL5mJzAKgmWz5CZ2XDmXTeWakhCUZ2yKycdm4cKhXV	7572	10733	10733	1617871140000
14862	3NKymcYKhBM79SRt8k2HVyQEDRyNCQJWyzfF6o1vd1S4DTaEXn2i	14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	1571	1335	236	6301	10933	jxQDbG3Qz4a5z9jpi6bbZdmFfThFjHxC2dg7evSHd6UVJQxLEZz	7572	10733	10733	1617871140000
14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1403	823	236	6301	10936	jxb56TW21wThxampNAAQkFKRgsKY7A3GuLmn434MUfiaTCGSZYw	7575	10736	10736	1617871680000
14874	3NKnW4Yh3yUCCuJRCA83SfemwemFWxf74Z8Bm16F59fS1EwMfwRY	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jwuAa7cddUo6WBSxmSUH5Bb8JaUYMYjM96brnZMbUTcLnjxpUT5	7577	10740	10740	1617872400000
14881	3NK8bxJ7ojJ7o3AarH2haF1h4bmgfmtNsJzE5vnETQ3SRrbWJw5x	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1422	971	236	6301	10949	jw9R8MVsojkr8BEDncqzuh1WXXrXLWpSoZPLkJGVDz3RJNHBeWV	7581	10746	10746	1617873480000
14887	3NK6HMgSzsZx9VJ1M7H9qWWfBVjBvADrnoZY6EKazGEaTq7ovwY4	14886	3NKMSmQaje1VxvHwkf9twxdcq3cqRWBuqwi75426tH4f4ZFeNvSw	1403	824	236	6301	10955	jwHG5uuTqKdiVG6xvyYuEgGL7u1fJdCntV7LpALWmdUdPc48qDY	7585	10754	10754	1617874920000
14890	3NKVADskzT5ZBfgDv7RmCwsAxCbozB5VoubtryvbTSygPbLsJT3a	14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	1406	1393	236	6301	10958	jwYN28kyVJdfyi8Q44A7s3JK1bQD2WqRbSQgie9j2TPDQkfUiWM	7587	10756	10756	1617875280000
14900	3NLkhH6tAdEoTfi3q8j86HLoU8LApG5DQccbxbC2uQzxvQD1JKUQ	14897	3NK9n4SVshN21dRjhjfeM6R9XUaDkKKmgkc1njHhVdWB5bVCQxay	1549	1362	237	6301	10966	jxWT112Q4n2R36pU5iBDrxo3XD3sv2xrjzkKV375gDnuq14E4ax	7591	10761	10761	1617876180000
14903	3NLdQeyENgC2xemkvLf9hvgw4h998D2dGtA4xG1AdxvMyoKCT1GL	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1455	1086	237	6301	10969	jxfbCJ3xuhMQorEanaaN1yM15ARQHuWJZCQMEx5CRRvMr8b7ds1	7593	10763	10763	1617876540000
14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	14906	3NKmVh36MistMLzhGtEVdZAwNiLE5qGXaAp6TkCGCMoixeN1ZaFi	1407	1395	237	6301	10973	jwpJNaHDAVjhXEB1aQqfA7GVBFFPM82d36e5kRpKUbVxdJqQMCw	7595	10765	10765	1617876900000
14912	3NLhtghAL5HnZcTmD3rsBgHHHVTnsWcJ7xD6uT7CBXxupzL7vNne	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	1405	849	237	6301	10978	jwShwa7wmkzaCq3BxjD3Kgg1JeTSyFv5f8ZKnhbfUS2tBGSMRt7	7597	10767	10767	1617877260000
14916	3NLMPgN6bznKibuM78h8zEdXYJsyAe5C4FzDXZGzUUoYSwrEWAUG	14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	1406	1393	237	6301	10982	jx3ALhdgszG4FGwFChuyqtNp4pbcdWAEwue55v7vjiVnB1WCttp	7600	10775	10775	1617878700000
14918	3NLCbYrzQHqDskA9FoQigE6VS1EfTMpVodM2HagmcMxXqcwzAFAS	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	1637	816	237	6301	10984	jxkwAy1RuCTyzk4szh89X5jFYU4hcrxi45QTkbiYMNVyBgFuWwH	7601	10776	10776	1617878880000
14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	1522	1196	237	6301	10986	jxxjtvciurUrgYS6LQVAynzrjJoyYweDW9asM8jfaModBhfGmaj	7602	10777	10777	1617879060000
14873	3NLCdDxWFPUPdtmkHyLkXWAevVCEyPq6cJKKsQrYGruo5bbBY3j4	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jx2Afnb7BekM6qdrUXtbWmgZyc5kht35xFp3diQWVdKqhvpmZyX	7577	10740	10740	1617872400000
14878	3NLKttNg8j9WHKiPd2H5jErzzEDgeg6XrYNVb6BTauBK8xGBzAtz	14877	3NKcBMXaXgY2vwh562PoWmv3xcRTksVFTekmYDBSvncydvV2vfnc	80	1273	236	6301	10946	jwXbR7eBFaN2NRHUmVfg1zZQyULHLpsE6Lr5iHeDTZBYvaL1ZjG	7579	10743	10743	1617872940000
14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	14881	3NK8bxJ7ojJ7o3AarH2haF1h4bmgfmtNsJzE5vnETQ3SRrbWJw5x	152	1330	236	6301	10951	jxECmXrDFfTKREs7TNr8gcbFPDLc1JudYAf95t5GCdavdWLHybD	7582	10747	10747	1617873660000
14886	3NKMSmQaje1VxvHwkf9twxdcq3cqRWBuqwi75426tH4f4ZFeNvSw	14884	3NKFnvKfg2JAkdKoFMueJi7SdXENmGcSA4tFGK8yasgJjE6debNM	1455	1086	236	6301	10954	jxKY4J2AtX9hbg9cjEGUV5qB1zvY9TpoQYGyaPX4xGNvHonm8j9	7584	10752	10752	1617874560000
14889	3NKkkyKhdLWFoFf18dQRB9xuxDNt2CjJ87dKnLBz9fyfGRAQsV64	14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	1407	1395	236	6301	10957	jwRZtnqq9gxcoEBFa9CGks9yc4JxUo82uztwLcfs33cziTyMfDa	7587	10756	10756	1617875280000
14892	3NKBEPGwWxAowQ4P9dM3kaZbXKENf39nPkuCiLqyQxAhmjbcq4vh	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000
14895	3NKM8k4suhroKxiCJ8Yq7DSGGB2qLUXVYCTtm24tu6hy4EGUY54f	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000
14898	3NKsnehF3BqTt6Ca4xF3kjxWZSKBxFD8fRGqrogteMXmFJUFXTjk	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	576	1229	236	6301	10964	jxvUnp45B2esSSvHK1Z48bCxWpi1DeMsZcC7bcxZYosTQ73n8VJ	7590	10760	10760	1617876000000
14902	3NLNEXHocbCcy7B8UJFpRPx4a334kR7MFPgAwY7akwLfzJuYtpsb	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1444	1255	237	6301	10968	jwJZA6ssz4BKS4gxKF4nGy54bN85k5AvABBF5ryaBgDYWqqA4wD	7593	10763	10763	1617876540000
14905	3NKhfH2FaMRWdJnmEwK3PQ14z338xq6ZwRmgtMEAqWUywCo2keFz	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1600	1246	237	6301	10971	jwvN3ks42MD335BVamWYt5B88x8uVmfXFrKpnJNR9Pp5TfLMPeJ	7593	10763	10763	1617876540000
14906	3NKmVh36MistMLzhGtEVdZAwNiLE5qGXaAp6TkCGCMoixeN1ZaFi	14903	3NLdQeyENgC2xemkvLf9hvgw4h998D2dGtA4xG1AdxvMyoKCT1GL	1458	1323	237	6301	10972	jxq62CLg3Q9WUM8yVKYTHoCTP5wwC4apTnQFHyX5BeHXtqzZU6Q	7594	10764	10764	1617876720000
14909	3NKgFxyyHVxvyJUWKi9cRcrwML5HJjaQPVCLhTN7kAEHAUwG8NxE	14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	44	1325	237	6301	10975	jwAxnWcUuuDht9z5JXQNKxovE9AGqYrKZ5C1p6XQx1G6Lb7LVVn	7596	10766	10766	1617877080000
14911	3NLgcx95yDUJ1jgeeTvad47QPteHDcxVuNtmREiF8Ns4wjchQZXq	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	684	1106	237	6301	10977	jwJyk58FTrgNCRUw8pCmVnigKpdAtYEZukNCmz9cohu6BB3qxsw	7597	10767	10767	1617877260000
14913	3NL6owY6FSwF8YLukhfUUKqAAFEEWvUV5iFcgNAGBgJdJkhGRfi1	14911	3NLgcx95yDUJ1jgeeTvad47QPteHDcxVuNtmREiF8Ns4wjchQZXq	1673	1368	237	6301	10979	jxJ7Hep6qgnURbAqoqYpQZSqNNVY2zU1yzMaRAsepf4cwea4gfD	7598	10768	10768	1617877440000
14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	1405	851	237	6301	10981	jxQtCjcoTJTLrd29JraUvNjaUxBoScTeRmNzTEyg2ox6mhUfpEH	7600	10775	10775	1617878700000
14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	298	1062	237	6301	10983	jxyJJiRM9GmGvHz4wcvbhJFdG4qsVKkJfc6TeT9kfdYCPVZcLSF	7601	10776	10776	1617878880000
14926	3NL4wJnAwTeyLwdwTga2CVpaL1hESZuPrFsJNkvBpc84G8CPPBAH	14925	3NLebMDzHbnZUiMAa3KTda2voNuzVR6Hybi3croZ87n5zofmwUch	1553	776	237	6301	10992	jxc4QsakJD43H5fG3Zp6sHqzavLjCH2ccdh7aWxCqbA1uL9cbjw	7605	10780	10780	1617879600000
14929	3NKGoCwTUzNzHKJ8dqdDV4UfpUXYKZVdHn1tL2Kw8mTJCya7h9Sd	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	1407	1395	237	6301	10995	jxjiNnEjX3PfT8LWezNuwLXpsZxDUeKR8VoRDJau4aFppPz5Cfx	7608	10783	10783	1617880140000
14935	3NKVGw6FuLEqa642aFxkgUzzQcynNFpTsiBPnqGki8kWWtrSuPoH	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	576	989	237	6301	11001	jxvKESiuu7FFsR7JBgK1Q5pgtJQ2R8Hxw13C9EXbDa2HCibtjoT	7609	10785	10785	1617880500000
14940	3NLp6CnSwSXvVW12WZ6G6U6kawjBwphArBfxhc3NYTLknsxJs8wk	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	1407	1395	237	6301	11006	jxPSLRkoahCBtVFEeDTns86DyUYPXiyu8CRiXGUgCigGovUtJ1v	7610	10786	10786	1617880680000
14942	3NLtaepQGFpsCRcEEuMT5oMtiUEQSVzcEXzhg67DyybpPnW4CPx2	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1474	1329	237	6301	11008	jwaFWJkoFXZdbuYenQ3qsAYPLtcDC8fVWZgBb3eX7oPjqMoHKtm	7611	10787	10787	1617880860000
14944	3NLcryMXWcPB4bkvpGnZbxpoVpt2zmSydUVkkLLqQRZYX8ZAXARM	14943	3NLW7KfbSw1t52GxJELqdPF4fEpVcBaDfw8t7iTUpBNXHCWNKX1R	633	1384	237	6301	11009	jwyMcFkPptSgXpXBzNNTZzJhFt4EdFN9WDUBCydRoEDfkbhVCTy	7612	10788	10788	1617881040000
14948	3NL18yP9SHdHZR84KZBfFrRrmtcGvfpwB3qcybBxGPxjRkY4GKk3	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1610	948	238	6301	11013	jxmE152mEJqokyzuo3VLCD2btoa1Tc7vFxgeiePpLKfU52Gng97	7615	10796	10796	1617882480000
14954	3NKFr3f65w5k4vig28Qso6YYDQ25uENfxSnpKJ199GDBQCefrrAZ	14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	1406	1393	238	6301	11019	jwppCtdnRsppAS4XUCPtpnakjjmH6PgXvY1WL4wyhVSs7y5HDqQ	7616	10797	10797	1617882660000
14956	3NLbwjkGPgzPACQFyp2tof83YuUyLh7o1gUPUw3HBqpp6HxfZT6N	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	44	348	238	6301	11021	jxyzNZitzyEcZ3rxa5B7esq9FSrZiNERJSheqxgvS8cGkQsa5CS	7618	10799	10799	1617883020000
14959	3NKwMqUoHUMc7ve84cMBzHFv45qFdR3co49n5ZQ5u84pDGEjDPC7	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1627	1259	238	6301	11024	jxxBw7PvngfHWaubKku2WUPEjewpbKhEwBqLNuAKELoizKKSXAu	7618	10799	10799	1617883020000
14963	3NLRK3wNxpyAjfdyd1X2JowowDRwcx26tXfAC5GgmSBxDFW98yuZ	14961	3NLSzibWJH1ZP8H9pQwVDbabUjNxZqZqn2AHchA3p3vaL2rPmCHE	1602	1369	238	6301	11028	jxQnpMutR9dkgVeYM6myE8yYJ5SFH6sGEWR2s3PzgBnGs9fA2Uu	7621	10803	10803	1617883740000
14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	1440	1131	238	6301	11041	jwDiQNxZjhbcsauVYdFeku2kXtwgwH3tJhDfRrDg7WnbtQ7wc1U	7631	10815	10815	1617885900000
14978	3NKNVCFaQU2o1Ntb7W7iqjGBG1qeaTuRLAedt4sHjunA3WBLMZYD	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1448	1185	238	6301	11043	jwk8HCjaTx5YkUhYLQ559mcThBMKZmh3MUk32DQ1uyxUvqJLgJv	7632	10816	10816	1617886080000
14981	3NKqD2QsMtrzvyWKW3v1RcXejMhMin31Zi2r9xMvKHL1v5Mmnx7P	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1448	1185	238	6301	11043	jwttTJtPuLNHmeRJjXjSeQ9SmT4ekQCX7A9V71Rh7FqJRdCcfsP	7632	10816	10816	1617886080000
14990	3NKgniUmThCB91xqs12THjUeJHosvLL6jLihBXxM94Ye1BBeP4zH	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	596	1180	238	6301	11054	jxK7hus9xUU39sdCFvQRaBhWBk52Jr6mtBSu98dZ9AGyBPgwjFp	7636	10820	10820	1617886800000
14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	1502	128	239	6301	11063	jwwKVFzhv1vMb9m4kmsVt6yJY66mNivJDqddQqmRwYGXJCaewWy	7641	10826	10826	1617887880000
14904	3NKPWf7wJzsZXCFUZotpSpmE4gf1SiXquurM5R9Ex4kEqfYAs9EL	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1460	647	237	6301	10970	jwecUFPWhmB9ffPrr1NoYttnKtNyMBzTaYGDz2ntnWKrSjN5oU5	7593	10763	10763	1617876540000
14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	1403	824	237	6301	10974	jwmsGmvUwfa9vzD9WS11mZJnFSziMqYPrfVhhX8U2xz2JDkqNwy	7596	10766	10766	1617877080000
14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	14913	3NL6owY6FSwF8YLukhfUUKqAAFEEWvUV5iFcgNAGBgJdJkhGRfi1	1406	1393	237	6301	10980	jx87WDQdjveQWRdUznmuhWPpBzpKqXFJ2s4JvJujKkUZTUticJE	7599	10774	10774	1617878520000
14924	3NL9GifSBBfP4qoFLKPdKedY8wdR7zftqYpNFVxZ3pAVrdsxv6XN	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	171	1128	237	6301	10990	jxCYupZi8wKfG7NQ3AGMjxN36U4GBcHe7tH3GN3rds7N4ssxVmp	7603	10778	10778	1617879240000
14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	14927	3NKMb6CGiTs4RbYoChWQd8NB3wrked96TX8exM3iearix6brLpSG	1407	1395	237	6301	10994	jxSR3DxN8Dy19G5NMHLFxpayvaXKMDXc5YWmDV5sfg3fEjqHte1	7607	10782	10782	1617879960000
14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	171	1374	237	6301	10997	jwMfWxT4RDbABZeaJsVtpXwAUhEe9xAvwh91hMrmJwos2MU4kMz	7608	10783	10783	1617880140000
14934	3NLocjF7XRS4Zw1BiQC9TxpN68ywdwsZoixtr2iF1o9gbE8t63nM	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1642	1367	237	6301	11000	jx2Rfs7Enga51JtWFJhB1b8FfoUpd9zYaujig9HJS2hmfNnhfh4	7609	10785	10785	1617880500000
14938	3NLMQ7SJKnHpznbRY5WDk9rcXrmLyAnMtBgu8i4GYadJXf1pSA3b	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1407	1395	237	6301	11004	jxSA2JawGf1ZGqBgUwx8dSRDHzLy46AAM5gNWU3aibzm5ZPkWTi	7609	10785	10785	1617880500000
14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	684	1226	237	6301	11005	jwTtEt1gnVoRZyfgWZ1tcqy1aZX9UqKxto1it1gXn4f42pHXBmb	7610	10786	10786	1617880680000
14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	14944	3NLcryMXWcPB4bkvpGnZbxpoVpt2zmSydUVkkLLqQRZYX8ZAXARM	1611	1215	238	6301	11010	jwqger5e5kD4ACHRWvHtSQEvkcALLnHat7adpXMNtJHGJC8vCuf	7613	10793	10793	1617881940000
14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	171	1008	238	6301	11012	jwZvynRn7YtJ4NcKs6E9zsirej5jA5uXLYRQEWBDr3arxVrKn4H	7614	10794	10794	1617882120000
14953	3NLrX2a3tCgEL61jEfpK2bP28LiMMhqyncX6dV3m8uZCmQiZ7Gnw	14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	1476	1125	238	6301	11018	jxzLif5NZLtRwCRUDhDjfgkWoCXAvT7T6TqyL7EyQcyED6B6z3X	7616	10797	10797	1617882660000
14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	14953	3NLrX2a3tCgEL61jEfpK2bP28LiMMhqyncX6dV3m8uZCmQiZ7Gnw	1672	1159	238	6301	11020	jwYY2DYdoM8GWHpzYMx4fxS43B3cgdSjE11Ntc8G2XkCTg37wDS	7617	10798	10798	1617882840000
14958	3NK34Jy2JTGCkhysYdMqGBjw1J6ynXGo8wG4vQeZDuZZB17ERJqf	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1406	1393	238	6301	11023	jxyYoSbMjzUNBrNBXFUa4doNyGY62KJTeFtQ55EgG53xAeodWM3	7618	10799	10799	1617883020000
14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	14957	3NKzxPXvCv2SkRkCyQcQkAR5PXNXJWpr4YURZNA6L8p4QNzrf197	1547	1378	238	6301	11025	jxAmK3gsCs3maNdWNr6f3ZPQb4RoZkQ8juQ4oBEq3PNF6tBWp3K	7619	10801	10801	1617883380000
14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	1652	1315	238	6301	11030	jwpLuFhjXYQo5UTZewdVQ3xrbVmj41YStvi4eSwz8HKS47ESYGa	7623	10805	10805	1617884100000
14968	3NLMpAzb4zYWEjFn3L6G4jcuUACbYtwBKHNE2YBdwAju32u5ZWff	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1553	776	238	6301	11033	jws8yQaP7QL33BqZQkGtPRdVF8FLAtBDixFGG34oQJ96E4j7ofS	7624	10806	10806	1617884280000
14970	3NKYJ2Nz1n5ccAUG2Arhj2KMs8EaUXSJQX2K1sPPEsMSJTWaNGRk	14969	3NKGENvHF2zjuSRz3KzmUbnknachzunysZc81G2bKYxPULgx49bQ	1613	1349	238	6301	11035	jwza1eZ8Mf5ckpYsidRtEq9yAhL8ofi86F8eUF5xvwbZ21pbYuJ	7626	10809	10809	1617884820000
14973	3NLxK1iEsXoR2Uwg6huhyopzDFAcrwVeVUSBJk26WycbomhTJTDU	14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	1594	1326	238	6301	11038	jxZVcAyyCYD9yJDaKKgN1HL3YEkFdec4W92Y8WgmxKn9SqWNm8d	7628	10811	10811	1617885180000
14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	14974	3NLmKT3pyyV2rvXgPh3KpX2AVbuK8ykn2EEKhN59t7kRsNf2VdgM	1407	1395	238	6301	11040	jxfuHuT4S7ya3mv4pcywa262PnEDwYUfQTWDuAreD6q6U1uZJf8	7630	10814	10814	1617885720000
14980	3NLsZFoonqzLTm1aBaANvEWXkyp5RZNR5bAUR51adACu66x3EF6d	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1407	1395	238	6301	11045	jwyWpqD2xHdCZj8GZWUKx2qLc8mwzPVMcu5dnjZ5EcqXYzdmSQt	7632	10816	10816	1617886080000
14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	14980	3NLsZFoonqzLTm1aBaANvEWXkyp5RZNR5bAUR51adACu66x3EF6d	1609	1333	238	6301	11046	jx8SXFQuYqWSqUd5unyTA3CGkk8E8BPt7zaew7b2GbRS7C71j39	7633	10817	10817	1617886260000
14985	3NKyZwrHLDS9V5NZ674hXVhuLCDP7Bkpj8NPHEHAQ7Kjy3ofZ3Gy	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1445	1044	238	6301	11049	jwUTx8yVLFPfUD7cJZiJNSaGrZWZePVC2vwqfe9gFXisSHqdNA4	7634	10818	10818	1617886440000
14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	14986	3NKR6kTgaKDcWXzRT7Jp9VRhbTJoA5tH1oSPkj5oyAMLV5kuTPR8	1672	1285	238	6301	11051	jxwDtgTb9ak7jLG83MMePwWbVGx9zRsaZJj75LppYBYVW3ZCRDs	7635	10819	10819	1617886620000
14989	3NKZMBM5E3skcfPS9o9BoLit9dxxoS9mxibR5VBqHLWSRyHF7vhb	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1672	1285	238	6301	11053	jwGNmxYtxv75ahAsL7wgKkpNtFetY1iQfrdWKHQZSvLa3F4VKAb	7636	10820	10820	1617886800000
14994	3NLZoCRjRKkCNzTJ4dGpDPcCskaQ1vDziPMdiNqiczDz5hTqBSVC	14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	1440	1011	239	6301	11058	jwnTxBymz2YaayghGDPSaf5dQtDAa1ecvJ5niC6xUajx5gP5MpG	7638	10823	10823	1617887340000
14996	3NLiTwLbE4ACZenHGhgbKLT2bWHnp5Ur1zZgLG3Fgc8aTw9DAM7P	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	1553	776	239	6301	11060	jxYAnwTr3A2YQvGeTuhReEYfXocucBLLjBGoEERuMZd558m75tw	7639	10824	10824	1617887520000
14998	3NLT7TbGgrpDFQ43ruzVnEw4c4qUwaa9Gb9WKtNUnzd2iwoYhpYV	14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	1500	1297	239	6301	11062	jw8trCW6NcpVPs2w4KpvnVnDgbBct7xheVXs2dooRbNFJqtVGC7	7641	10826	10826	1617887880000
15005	3NK6L2K5XAw6Ty3hY81KgCQpSdHLBnTAkmZdEdb58ibVSfF1qY8y	15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	1406	1393	239	6301	11069	jwHkjLz9tBAp5FUbDqTZSjtGLcesQdgo19L3bXwQsqXbvSzN5Bq	7644	10830	10830	1617888600000
15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	1406	1393	239	6301	11072	jwL2w7w5qcrnHZg994vB5cPKJGEUGR6tNq67kiREhz4pBc8a794	7645	10831	10831	1617888780000
15010	3NLEzQkFt2ayKepGnZHYA5EBYoMPZ38pZQSCK8ditjxzRS5XoBs7	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	171	1374	239	6301	11074	jxTCrBXVJftncgYdZAteSryQ6wdTyjMxjEEzMUVV8ech5Hy5zgB	7646	10832	10832	1617888960000
15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	15011	3NKT6bjvnNokUC9oac2BZDvLZ7fSyG7djqi8noRduhsArW64MYZx	1522	1322	239	6301	11076	jwy3RyAwtjhKJCyTuZVMWUJ3uNr1uoaFn1DKowbeTC8ds9S237j	7648	10834	10834	1617889320000
14921	3NLLDnhhpP3XeX8bwM7XTNEzM5k5qbrZcoXDRHJEAu2FLfMYoAQ6	14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	1553	776	237	6301	10987	jxsWX2ZEYaTtT2xoC226y9b4hytXxBq5BjBsRiwrBd73hMSAhms	7602	10777	10777	1617879060000
14923	3NKyH12zkbsi1XEF3ZU1ccHNL6xvuY69gtDeRsgq1Xwfy6Q7WzVy	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	1471	1386	237	6301	10989	jwStPhAUyRXUtmzMuJaDw5v9UMbXaKxxtJ9R5BPVzQaGM9Dg3YY	7603	10778	10778	1617879240000
14925	3NLebMDzHbnZUiMAa3KTda2voNuzVR6Hybi3croZ87n5zofmwUch	14922	3NKhSuHFX1bPUQs7rYZBh1uQeL3Dv2YtHrMko8xFCqAVcbcgeRZb	1581	778	237	6301	10991	jxKzGz5zwSywWxa4FpNShVwVpoThVzFQhUX36Q3iqWcUqRbzcxv	7604	10779	10779	1617879420000
14930	3NKRqiAwmAX6qcam6pGzFXF5TTLLSALKHJ6TkirPrzhWtKXVhaoX	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	1460	576	237	6301	10996	jwfcHY3iYDWEZ7UX6G19eoZfUmsznFadsvBRZL42erwjMdkqLm3	7608	10783	10783	1617880140000
14933	3NLoLcNchVNqWYna4ykB6y4Wwfo6CR8ySyj7dsjo8VhDoWrEzk3L	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1483	910	237	6301	10999	jy2iQk9H2yKLi9zz69YQuJg3BxM2aGoWo5MvPPaEiHuTd9BH1c4	7609	10785	10785	1617880500000
14937	3NL1p6yrj2HPwApaSQm9RGvARpr6rPeR2UdGsZRSkUwxebiucpQP	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1490	908	237	6301	11003	jxS7yBZf4GcWEMp392dwfQvcL9VA7YWTvDc66m7armujSVadboG	7609	10785	10785	1617880500000
14950	3NLBt8KgA6joc2GzKGdaG6SB9n4MfFTgibf5XaaB9UGy2b1ckqJM	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1624	1334	237	6301	11015	jxbxiDdL67Mjz1r7KCwJwdPE2r45UW6cr612fcct4jmV9mzSSZy	7611	10796	10796	1617882480000
14962	3NKCti9eFsTomntuDAB2FtLjWeaPgj5aAKHtYH8CKoQiudgBYS8L	14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	1481	790	238	6301	11027	jxvJ1uJBcXC7gYBU13pqH8LvyZ7MBAgxgzWgjE8junCAMwANb4k	7620	10802	10802	1617883560000
14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	14963	3NLRK3wNxpyAjfdyd1X2JowowDRwcx26tXfAC5GgmSBxDFW98yuZ	175	175	238	6301	11029	jxDkwqPnbsPtxSzWv8xDSNhjjA6v4oqNxzfQ72TZVq8ePZXP1Mj	7622	10804	10804	1617883920000
14967	3NLdhdHdyoWKKDF2DddZkBcwMHxcb7M9rgrLsXzyEbH18fgbArWY	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1594	1200	238	6301	11032	jxwco8ZSRaxA5sy6WjfuXyBTGmB8bZhxogc4MJ1wiwxUEpiHzAR	7624	10806	10806	1617884280000
14969	3NKGENvHF2zjuSRz3KzmUbnknachzunysZc81G2bKYxPULgx49bQ	14966	3NKhsXuk2HUwGdzKfZirqF8XoxfAwZTouRWad19b3U5MEmJFi67s	1631	794	238	6301	11034	jxGSVx6Vy9ZkxMMa8vV5A6xchsi9zpbGXYmey4DZxcvJZjkGZm5	7625	10807	10807	1617884460000
14972	3NKRUuE4dMwox9gdxN7ap1wx135EeFwkBDhrDhb8AhqikE9nNrQp	14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	1587	1231	238	6301	11037	jxnxgHxLUcBxmyhbmyJ4wvLT5xwPzdc12Bwao9Cd9jon1VAWUvd	7628	10811	10811	1617885180000
14974	3NLmKT3pyyV2rvXgPh3KpX2AVbuK8ykn2EEKhN59t7kRsNf2VdgM	14973	3NLxK1iEsXoR2Uwg6huhyopzDFAcrwVeVUSBJk26WycbomhTJTDU	1426	1118	238	6301	11039	jwRC3Ne35YU4T9w2Ry41jSdNQcy1uqnoQRfT5AdZ7rwKb6HF8Tf	7629	10812	10812	1617885360000
14984	3NKy21LE2EB9vXThzNfQtxUT8sBidEWUpNpZ9AUUbzNutCvisjEr	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	42	1235	238	6301	11048	jwG9rugU8ieP8adnWbszuFhjwwFVr2o3bP3Hq1W2ne8hNkFxMw1	7634	10818	10818	1617886440000
14986	3NKR6kTgaKDcWXzRT7Jp9VRhbTJoA5tH1oSPkj5oyAMLV5kuTPR8	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1633	1390	238	6301	11050	jxCEwtAWnBW9kFcdDBy4vjMNJhFviKpZBLoL4ZA7tsqaRH76w2c	7634	10818	10818	1617886440000
14988	3NKpe6Yudy76PxCicWjpuav9QoM6bdeA8iTubk1XV2ZVRkx1xYgD	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1607	1348	238	6301	11052	jwTkJvqnN99w4FnAzHbv18RpsybjNxotuda651jPJ3ejXCW72rb	7636	10820	10820	1617886800000
14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	1673	1242	239	6301	11057	jxqsjeS4TQ6KRxRppGudbUMQb4TLPtDkDfMquC798L9TmtvjbPB	7638	10823	10823	1617887340000
14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	369	1312	239	6301	11059	jxYfSiU5TrnYGcZEMq7MkSt9m7dcPMKFZJGhcp4YEqWwZXzKaLh	7639	10824	10824	1617887520000
15000	3NLcjgzG8H9uwJGzu9i3WCUC67Mnwu7FvzdF7RJarG1G3ErJby5S	14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	1553	776	239	6301	11064	jwjzz62T9LhVTyd3asNVS2piMpGgsFSzA5fcuqmr1UaSHdjKhoL	7642	10827	10827	1617888060000
15007	3NKs1HeVhpjNxZKvmGNVVtJCCPKXA8jvUUubpZcY9wG5mrqg6B78	15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	1490	1274	239	6301	11071	jwwgBeLJK6TvADyjE5FuDSAkUDqxMzpq8dTi5Fv2oePaedM2qsx	7645	10831	10831	1617888780000
15009	3NLEEVf5CsjCjxXyiDCfWksb5WRgzEFVa3H1xUL4NX4eDUPsJyh1	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	1407	1395	239	6301	11073	jxa6Sw89m45cS2fxkBJRxouSkRT7WnqwnhRCaSW4beUJoSxpkqq	7646	10832	10832	1617888960000
15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	58	1281	239	6301	11081	jwy7ppN7j7ygjdFD1upiMZPMTJcKz844PeqdPDkWeDcmpEipjQZ	7652	10839	10839	1617890220000
15020	3NKKXPqTsQ9MhaMhXXVehxHWLurqq1sMn41931Njt1S8uKHJyXv5	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwXc2EpTbRT8idCoRAMZMAdE69af8Yb2xVqtDZUdj8ax9Fe5VqZ	7653	10840	10840	1617890400000
15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	1516	1168	239	6301	11084	jwUu5VBNj4Prxfdt2npoGV1ptxUTGL4qGo2fh1jvZNQxdkz9mo9	7654	10841	10841	1617890580000
15027	3NLGW6QTT1XGLMJyshtdT4TP59Z5xG67JSsf62KyDDr2cF1EKHVL	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1507	1154	239	6301	11089	jwe3171udJdLFDZggayFw4PqkwQT2HTASdpo9a4zuz9pnfWhuWM	7657	10847	10847	1617891660000
15029	3NLtiE1BgMhseV2QfcF735yp5uFhRevMG85BSV2oSAVJC98SoDDM	15028	3NLrz9mzKeiC9MqFVpf85nZXQZwpges2jBjysP56NE8uJ9HNMVLF	1407	1395	239	6301	11091	jwHPg1TiNpsckimaHBPWjNtiPhGmSB1qdz8gX7wGoD31XATnGwB	7658	10848	10848	1617891840000
15034	3NK3gpkfUmeWNUA2J9RuR3Skqv3bPrfAY8gNhPuyad3NpNbjsqa6	15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	1448	1185	239	6301	11096	jwB3R9ZL4u31otZMwqQ6E2derAdiYtNJW4SMhxgxFFtfvjujFtR	7661	10852	10852	1617892560000
15037	3NLoXxQeeYm8sVpY2c77oSpJKMdqEJGW2Sj1QBRb6YxJEfcNTJdW	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jx8Kk5vL9ShSVCfyrCeGJMftfNSZfFpqfK27qSuTB6wYMars2xx	7662	10853	10853	1617892740000
15041	3NLgu2yGGzC2BYExQCAM2SaJ2Gj1PyafXrbB2e5hJM1C2sDgkcmh	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1553	776	239	6301	11100	jwVntDEBNiK4suLL8Rnq1ooFBXkDtiDY87As2icpnvPwWn34yuZ	7663	10854	10854	1617892920000
15045	3NLUsFa8xpf9JCRY5UpfRS2fBQLZCXj9wZsMzAUMu6EXiW38dKSc	15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	1611	1215	240	6301	11104	jwRdStZFe2GC2ENXqABLTEP2unHVfQTv4k5JZJ6iMCNtNmMST3A	7664	10855	10855	1617893100000
15048	3NL27Fk441ruh3XGfDHBbqdAesCxdXSizLbpSfTii6rRP2ibFHzt	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1634	1205	240	6301	11107	jxRNDKqBpt1ZcRFo35AUcvuD3d3RF5LjzKby9qxYfvfkf8LfjsC	7666	10857	10857	1617893460000
15052	3NLfeLWBW7s5wQaC3mA9sKX4AQKxe56UfAzZ8Z9VnNiHpQPP4kF1	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1402	810	240	6301	11111	jx2fCE1C6Xfx4VERySGKVX45H1FVVULGLwgq2sNkAyjjwtbJ9dt	7666	10859	10859	1617893820000
14922	3NKhSuHFX1bPUQs7rYZBh1uQeL3Dv2YtHrMko8xFCqAVcbcgeRZb	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	1585	1120	237	6301	10988	jxM9RYGFV72SeopU3LUPBcebGoFkoUbUVpXA1Yvyo52w75zS1BM	7603	10778	10778	1617879240000
14927	3NKMb6CGiTs4RbYoChWQd8NB3wrked96TX8exM3iearix6brLpSG	14926	3NL4wJnAwTeyLwdwTga2CVpaL1hESZuPrFsJNkvBpc84G8CPPBAH	1643	1299	237	6301	10993	jxhSDbYrRCPAhAk7hG6QEB5Vx9tPnB7v1Gx2X4cZ7jZvc67vfrB	7606	10781	10781	1617879780000
14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1397	838	237	6301	10998	jwYKjaxdSd4KSGGAgbPuqDKF2aaFw5XETYRSe22fAf3wCQfp2U3	7609	10785	10785	1617880500000
14936	3NKc4ieeCKpJh5Q7w41qusgsyTNGgDdQm3tcjU4rGGJsPQAeDHxa	14896	3NKHvyXqVHoU8XQwgqb98hx1H8GJaavDpdW4EWxgotnLGbfySTk5	576	989	228	6301	11002	jy2PdfHab8WJ4T9uLHMhmW8kxqU7F57LULnnfBdiDBmeq2c9Ku6	7421	10785	10785	1617880500000
14941	3NKpRzWSwCWiPYbSJDUqqo3voyn9CFPLkk9TkEDaVr3yHvWSyAJ2	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	1637	815	237	6301	11007	jxqtB8xxJxzUG8xGQtNn4n1T5WnyzbZLRZeTprEvk3TKJgPRN9B	7610	10786	10786	1617880680000
14943	3NLW7KfbSw1t52GxJELqdPF4fEpVcBaDfw8t7iTUpBNXHCWNKX1R	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1474	1329	237	6301	11008	jwNZNGdf8P5V79BzmbJTqP9VaYYKuSLWgkBRtNS4Wx3khNiZxDB	7611	10787	10787	1617880860000
14946	3NKyHnuxDx87T1o4KnXpzysBb29vVQZmYiqaEr5NUJRCsJMWw5Ce	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	1522	1076	238	6301	11011	jwBySNmJV28cn3abDCAuTQ6tkcJsnSbGLChbEySbzCZZDmKTo2s	7614	10794	10794	1617882120000
14949	3NKMT4KDjGKncrEH8PK6ZMnnF4VDq1fPEnXHewMsPKbtbdQMWFLa	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1624	1334	238	6301	11014	jxHSd4FtL8dUKvpCDoaeCXktxcFNpjbP1uo4NDzbf2C7bkHWb2a	7615	10796	10796	1617882480000
14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1541	1298	238	6301	11016	jwzn9dX1jHpgmB8cxepyxfFdDhaxBtiTYXQsZ62FG64xresGY1G	7615	10796	10796	1617882480000
14952	3NLdr3hvgVxcZzVN5tbyzooMbnHnD58afSVQCSZ9xZN6osczv8CZ	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	1624	1334	238	6301	11017	jxY4ed9UKPSGEQEWzGMRYdyzND7o19ygMabVa5DHMip6AqU6RAJ	7614	10796	10796	1617882562649
14957	3NKzxPXvCv2SkRkCyQcQkAR5PXNXJWpr4YURZNA6L8p4QNzrf197	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1649	1383	238	6301	11022	jxSNXc4XXiWAvxiacpyAWNo9rtCe7mmZgKPoNiyeZrRX8xsEfgw	7618	10799	10799	1617883020000
14961	3NLSzibWJH1ZP8H9pQwVDbabUjNxZqZqn2AHchA3p3vaL2rPmCHE	14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	1406	1393	238	6301	11026	jxJfvWZ1LgSdJuRYXQTUieP1nRri9qBBWN8LKfaG3bfTjuxUwDh	7620	10802	10802	1617883560000
14966	3NKhsXuk2HUwGdzKfZirqF8XoxfAwZTouRWad19b3U5MEmJFi67s	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1483	352	238	6301	11031	jwHaBnUP1sLcPcbUydcpc1bku1exbFbvVkDEbfnno6hivHyMRaS	7624	10806	10806	1617884280000
14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	14970	3NKYJ2Nz1n5ccAUG2Arhj2KMs8EaUXSJQX2K1sPPEsMSJTWaNGRk	1445	1164	238	6301	11036	jwte2KMRpiVur7Z3Nirj1LHDysH9fEYN8TXxEM4q27UmU3uPEgC	7627	10810	10810	1617885000000
14977	3NLmKVGwRp1v8RtdiDvEcQYE5ZHXgWvNNFwxj1TrpeayCSSqngZa	14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	1631	794	238	6301	11042	jwfo4yuKQqYUjsPPpxnkXk9krFdryh4e5HEkw9AvENmauyRjjbr	7631	10815	10815	1617885900000
14979	3NLV3yPncVGo7ciq7v91L9wXbdbqP4xydA7QdNAAGdyEyAZaYH7d	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1596	1363	238	6301	11044	jxuc84CEF9BTUr1TdULigrB7vxGebut2r9g7RGcuoFQDgyfz6Cw	7632	10816	10816	1617886080000
14983	3NKMbrgpp9AUy75xntnjNzLYjei8U9hmC7M8xtgfJaaPnFmiPjjd	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1607	372	238	6301	11047	jxzMYTjYRVYdnHtyMkhBppRqoVa3hN458UoTY4uvPpxoUJuma3W	7634	10818	10818	1617886440000
14991	3NKGqiSrtR3z57BdBP8hYFqiYnpAnrrvi3a6K3vswVXkPy8noYPC	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1553	775	238	6301	11055	jxwYvygTFRnfa1ZbtzuuGcLrVNRyqkwnYdwYBuJ26FKA52SpG4M	7636	10820	10820	1617886800000
14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	14988	3NKpe6Yudy76PxCicWjpuav9QoM6bdeA8iTubk1XV2ZVRkx1xYgD	1594	960	238	6301	11056	jxqPEaH6VGdqjnFayWbsVdXyu8fUgi8StEmMTF5QJzb4GwnJCqT	7637	10821	10821	1617886980000
14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	1637	816	239	6301	11061	jxHDn42Bj8F21iBziLSkSPf4qYr6YDeLTrh8Z69jywT1DHXcCxY	7640	10825	10825	1617887700000
15002	3NKhYBA7GiwiKQbL2MF5EVUjaPJ5k2bYTQwKDbDaLenrGx5khDa1	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	563	1359	235	6301	11066	jwY5irAGFCD3TkDLgqE3N159weyw9kJTuwiAQwP9JgttD6na5yv	7547	10827	10827	1617888060000
15004	3NLusySXoLtFRi67W6FGpfqiUJNQzoBVQ4tJhm4C3WKnRo8NqrBU	15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	369	1186	239	6301	11068	jxhRAszaXJz5qLb2RFZMznqdhTWDqZYDPLhYEkQYJxbrcSrQK1f	7643	10828	10828	1617888240000
15011	3NKT6bjvnNokUC9oac2BZDvLZ7fSyG7djqi8noRduhsArW64MYZx	15009	3NLEEVf5CsjCjxXyiDCfWksb5WRgzEFVa3H1xUL4NX4eDUPsJyh1	1403	824	239	6301	11075	jww9xYnZDA1hLHAseVtG48P5sd17rmBAQjxbsyTuUuzTdiCGKzC	7647	10833	10833	1617889140000
15014	3NLV8eZCHRtMPkcKaQHHPk8EiCUwHVk5RFhm6MWeERAPDoMmA7c1	15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	1406	1393	239	6301	11078	jxesPhTcDv9RXjzvhzCuCvfNik8jzXsKRXD8QMUjeAT7poXkeGF	7649	10835	10835	1617889500000
15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	15015	3NLaYgNzCQpPDAnrCibaw6tMCYXZNuScpQvmHSvMo4M3b8Bqoxkk	43	1310	239	6301	11080	jwscTDSAik55rx3gRfGZ9PyMzybRky2f4bSHr6dpXuRsDstaPVp	7651	10838	10838	1617890040000
15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwM8MEWS9C51BPt93Sr5LiLaWvcpV8qg1kbS3fYbYhNUcMmyYSz	7653	10840	10840	1617890400000
15021	3NKf2FyCLCH4WJTVay8feje14rtrBxxEZ4aTXmfhJGAc6cYLyea8	15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	1405	849	239	6301	11083	jxrhcHUe2JMaJXAYRupPAzoWVJY84ucPQA3EM4hthwwwb6mT9Y1	7654	10841	10841	1617890580000
15031	3NKXCEEzSEayBrqdhSfuUiM3tGa3a739jy2TCChYjcrMTUEeMsfv	14823	3NL3MyrXDjJ1wQQjFaWpgpA5g2LxVvXeK153957Vx19TN7FMNQEF	1593	1100	235	6301	11093	jxcRridsXqPMPqXje1tHLQM8V3GQwBJvgphUVTnBYDhXLn3NhDM	7556	10850	10850	1617892200000
15036	3NKAdPJBoJhVPwdgbKjfkuhLEG98r4BXkDyjYpXPDgsHYixfyYsf	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jxZf8CuCYQ5mHWGyvy9gZJnJoufz9Jienw1RwvRKmVRLMNAgCsB	7662	10853	10853	1617892740000
15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1445	1044	239	6301	11098	jxXiVGbCBMF7rWZySq1oqc6JosjFmTMmWxLEJDXNAQKoAwwCoda	7662	10853	10853	1617892740000
15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1455	1332	239	6301	11099	jwgcB2wny8YnyRRMmdLn1ocnZzw5FV5nkcZ3HRsjkh8gDSKvjih	7663	10854	10854	1617892920000
15047	3NKWmjDK3YccKamwEdR3atTxqXoqMRWqjUr137tYaQ41SBsahFbz	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1675	1216	240	6301	11106	jxhRhEh3qTbpCKkqY8c8yfQV87ved1kYGSHa1VntdNatkxZ9zoA	7666	10857	10857	1617893460000
15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	563	1359	239	6301	11065	jwubGixhfat75iSvnLf7mYesNHNqJdPs1VTcv4ArHSd9FcWt7YD	7642	10827	10827	1617888060000
15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	1578	1296	239	6301	11067	jxQJ3Jh6f2AjSdJS4ostQzX98qXZwpCYmXLWwCcLyXceoHVMCXz	7643	10828	10828	1617888240000
15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	448	1059	239	6301	11070	jx6twRLtqrKyCc5S4o6LBnTNSZV8zcQrXeMoACc4wR6x1UfhgPv	7644	10830	10830	1617888600000
15013	3NLKhSyt7gRdgY98rrdBZGuugqSoievgeC7W8VbagGMUuJcbPU8b	15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	700	832	239	6301	11077	jwybVdDuDeLftmX9EJ2CVE8yvFPKz8Hy9F4vXGFXHtDu1y4QuC3	7649	10835	10835	1617889500000
15018	3NKqkN1j24QnHWS6FHND2RF4okiXGFAbFivZHh93fmSLcjdCcXGz	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwSHAbzbGawa1f1jNqrouBgsMDpaKb7q62XCWTqQh4qZ2z8uAog	7653	10840	10840	1617890400000
15024	3NLXdPHELKeS9wh4Rv77beWVjEMRnNQBNbpfi7uypo6so1fqE5pZ	15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	1633	1144	239	6301	11086	jxwRq7L25ckpZLToQtADLE1e7MT6ptPxPb3MfrRxFSgjmyurf5e	7655	10845	10845	1617891300000
15026	3NKe32vasnuzPsNkfjE33b3BH6d9TFmz6gRcp1tba5MSMJL64QXT	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1403	785	239	6301	11088	jw9Fx9QyZt2w1tDrWL6MwYogeXsXkrnN2XUYgQ59XaSdwLUkJr7	7657	10847	10847	1617891660000
15033	3NL6ottfeBnqyapaUsWJpjT1KxkniKbubTKwywSXp9nHawj56RCF	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	1593	1100	239	6301	11095	jwmw15DUwZvK1xBm9VN7hukPaU5Pd4s1Btxcic9t4BxSzdbaREM	7646	10850	10850	1617892200000
15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	1448	1185	239	6301	11096	jxup76W4ABXof33mDppDQFm5yU8BYzuFm2mu5pEzKmSMwY8abGq	7661	10852	10852	1617892560000
15043	3NK6M7BguF2A2yAJKiVi9qdf815zAABacYExJ99P1QWqAQACQACU	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1631	794	239	6301	11102	jxpx6zkU1cCWDd8iXH2TwkK9D8uPwoiQGwXHGBw2H7NihEZ255N	7663	10854	10854	1617892920000
15044	3NLRuQszF8xe2BtCVWKAPLCyw3SVaHcys88ZMvxQk62K98ck9jgJ	15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	1406	1393	240	6301	11103	jw8fvb6rMutwCHinn3pUQDkbsk9EGEMJjUuZEoTz2VbNAmK8M4M	7664	10855	10855	1617893100000
15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	15045	3NLUsFa8xpf9JCRY5UpfRS2fBQLZCXj9wZsMzAUMu6EXiW38dKSc	43	1184	240	6301	11105	jwQ21YcAb6ivG611q3D186MiWWdtnb7bq2FfZivUgZBuXQ9UQov	7665	10856	10856	1617893280000
15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1406	1393	240	6301	11108	jxNHAwzunBhXLsoMCkkKSnzC89q8aouP1nPKbRM2TuSXeax7wJV	7666	10857	10857	1617893460000
15051	3NLUGKtCKAHUZpKxcmpYH9ttjxL4MrTFtqyugcZGJzzEZtcYBFxB	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1581	777	240	6301	11110	jwP8EYnsjhc7jwT19MNweoEiwcuoJTFN3LhXXbrn7wd74hn4eFw	7667	10858	10858	1617893640000
15053	3NLdY6NNwGKGU2Kpu28MsCHJuMR9ghD5tFqGSBL2Urj4XeEQQFC9	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1402	810	240	6301	11112	jxeRKFbsWxtbNZNnUk5M1wDRG7AGXmGoc2qSPSGKSsxtGVxZXWK	7667	10859	10859	1617893854028
15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jxoYZT8EVjj9iP18EYD1Zy88BmE7hEWfbiz6WpVFpBpYvD5VXgB	7671	10865	10865	1617894900000
15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	1589	1286	240	6301	11124	jxc3UibsSSRh1pR46YcYXnSJmoTmtUVUBamk98NjaSjJQPHpMBN	7673	10867	10867	1617895260000
15069	3NK3NhDFRga9f2wZeRCEP8Zwmpyb98GeoVAJuWi6PeLGa4gpmNBJ	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1490	1274	240	6301	11126	jwBkHY2yZJcSLn9TSK1JHxQtNq7tQXPp7WzfGE2StbdVdmj8qqM	7674	10868	10868	1617895440000
15074	3NLtkxWD5U6LExhyHLx6FMaW29FY2JctxCoXcBQrbqrVikzCRsKg	15073	3NLfs4JWsfHGrASY1m4VBhr1u1TSRBaE4B8Uxu2eQUgjLpyCe57c	1542	1304	240	6301	11131	jwSmYydjwpz3UVy7o2Ws1zy4gLycfhY1uncEzX3L1kCLiADqjea	7677	10871	10871	1617895980000
15077	3NL4ZuKMZHKGmvQv6aBgFfqADrw27TyEEhvguKs3aQSrZax3eg25	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1600	1006	240	6301	11134	jx7kFRyPbQKsN5v79ki4GvJnFGAWEwsWBHxozMkaU1gi3yY3yiK	7680	10876	10876	1617896880000
15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	15084	3NLZGaVNChBbXSwT971duN5PJ1qyqsmWxyr44Rjsp6g6JohdFqKR	1501	1234	240	6301	11142	jxLyCqxikJ7ZcZo5c1ZNt1fzVsF8rYaecdyVfDirQM5PjRWU4ja	7685	10883	10883	1617898140000
15092	3NKVQPmwvfgMnSKfghio1uKY6cmGUuoL1U8mwFFyhWge4anz3zju	15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	1407	1395	240	6301	11149	jxcdk5Q7a5FjaacRrrVBtqyUZASkLce6GDhexzAz8a3hpK8WQsZ	7690	10888	10888	1617899040000
15095	3NKcmcDDiDUNFoiqo6xAwSszkG3quTnbU6VmVZzBXAtDkP5KcXNr	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1654	1340	240	6301	11152	jwH3aL7tN74DfRdURJzPQDtfzgUt96WuRzkjNZ3qcbr7pTYv8ZR	7691	10889	10889	1617899220000
15099	3NKMAgBWvFQXEX8EDod9HRWxempzyeFr1PDQB2LRaaGgWcwtmR6s	15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	1455	1206	240	6301	11156	jxNFYcJXoNMECcue8PXYmZkvVRcPtXraaGZFb2bGCVDNSYmtqse	7694	10892	10892	1617899760000
15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	15103	3NLGVHACtcPNjqgbwxnRv4Z31YuoTwbVid7hi17cMQeKMe3K4cQA	1402	852	240	6301	11161	jxKKpEcJacu8EAzu49MaADCLTMSiDWYouTpo99jgW4FppMfeVa4	7696	10895	10895	1617900300000
15113	3NLv6cKL9S9AUAYCbkPUZQYdn1vf7kTTQ6zBpeDSw5GvZr6mAzrd	15111	3NLcB2y7YSzd9g5NfgE6YBBA2gmc6PJYe4XdrobhJxJASX3ZihQa	1624	1334	241	6301	11169	jwqe8osHEXpYdB91cSVdHtVaKWUefqkR7GypyzKLEVr23hJip9r	7701	10901	10901	1617901380000
15118	3NLGFDEooVxbxV1RRhqFgjqGkofzoCR1iLrdovSFAEUMpzX6Esvv	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1477	1350	241	6301	11174	jx8dhiUGcDYUhFHtvmcmB5AbhzK1UjirqzhS9dyZr9Wf78SYH6p	7706	10906	10906	1617902280000
15123	3NKCNfR2d6wiDMfavbbpCGxqUDpuoZKHT9utzuidDsRjdAJFGSkJ	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jwW1eu1pssYxyarET4gHhnhL5jWb5Ley9Y6a3jmuWrTEWV3WWn1	7708	10908	10908	1617902640000
15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	15126	3NLQhTvSS3xJpjR36JqPe1ayfAAbJNqTQ3eKFdmnsCnWTX7AEzEj	1631	794	241	6301	11182	jwpzQX9pcdFGLYSFVcWZBEffaK5mhpsitZyk8okv8uQYQV3Q9gR	7710	10911	10911	1617903180000
15132	3NKzbqu9STcrVARBqNnqm3ZY6dwXsgaDzwLVZpJxq2BTrg5zo1HP	15131	3NKpVBwWpYnQPj7YCGNc4LkY5zta8dw8zKTHGgXeWU1VncJEL34h	1649	1017	241	6301	11186	jxb92sEZiJV5pvzJuoN5UCqriE5g3yQ6ZmAJQ3ExpoyW3TGmGyT	7713	10916	10916	1617904080000
15135	3NLFCHP1VX7KGVuC8kvDWowGcyuHcZyaXfwTLBS9XbwYP18QJmMH	15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	1467	1376	241	6301	11189	jwCqHe3JFZ9D8WsENhivrfzVKSVoCqwdeB5Q3Zo7KWNfoCGzncQ	7715	10919	10919	1617904620000
15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1542	1304	241	6301	11195	jxUWs1oxP66GUPQYeighdRNFSGxQu7hjFy5FJPMoHCkK6USWfs3	7719	10923	10923	1617905340000
15015	3NLaYgNzCQpPDAnrCibaw6tMCYXZNuScpQvmHSvMo4M3b8Bqoxkk	15014	3NLV8eZCHRtMPkcKaQHHPk8EiCUwHVk5RFhm6MWeERAPDoMmA7c1	1581	778	239	6301	11079	jxbg15tjoJHHkV38e8RSaZK1cnJ1y1FhS79fug89vF6nbG7nSxr	7650	10837	10837	1617889860000
15023	3NKQdVBroQBTdtJa3Heqs8JrMYdJsrfWcPsxTdiUDMDAMWk6Kwex	15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	1581	778	239	6301	11085	jw9SHTjuo8Jtk91s8q3k9taRuF9eztui2LX6DKDt8Y2GTkCjhg1	7655	10845	10845	1617891300000
15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	15023	3NKQdVBroQBTdtJa3Heqs8JrMYdJsrfWcPsxTdiUDMDAMWk6Kwex	1477	1350	239	6301	11087	jwXsWM6y9W51aPurQoqcFBGxUgQVCbWYimyfNm6ERU9nBkn8E9j	7656	10846	10846	1617891480000
15028	3NLrz9mzKeiC9MqFVpf85nZXQZwpges2jBjysP56NE8uJ9HNMVLF	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1407	1395	239	6301	11090	jwHwWQz7zP4Xz1SFgEgcgy922bV7VVBMWCHv2yvCyJJU2KFZF8m	7657	10847	10847	1617891660000
15030	3NK8s9Ag5RYHCVNjWVWLhBDjeWG6phCQoHxhc4xCvwi7g27kTaD1	15029	3NLtiE1BgMhseV2QfcF735yp5uFhRevMG85BSV2oSAVJC98SoDDM	369	1312	239	6301	11092	jwC8csUePcF1WCappaLGyfADjNhQDmdqnNgRmPPhhGbVNKdgAEy	7659	10849	10849	1617892020000
15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	15030	3NK8s9Ag5RYHCVNjWVWLhBDjeWG6phCQoHxhc4xCvwi7g27kTaD1	1406	1393	239	6301	11094	jwvCJSPDU28J6VAtrbdGL3meg3cxbS7ztDcSU8sT7sEbcJHRYYm	7660	10850	10850	1617892200000
15038	3NLerUqr26PxXRJKmC1ZTvNu8sLKrPEb7PdDLoQxn1QZ1JNM8epF	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jxSFad2GhaHMDsyW1AZgRPNoqkHsZkQ5atcAAZqHSYhmTXMyWVK	7662	10853	10853	1617892740000
15042	3NKGp8zh1H8wFFScU4KcRx2zDFWPbR6tCZWZTX2ebxErrX3chQm1	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1407	1395	239	6301	11101	jwKw4Zd2tGwcxx9FxtuaG1hZ8TedMAXTsH4gzzZw13qGw8otxSs	7663	10854	10854	1617892920000
15050	3NKcipdzyoFVArgTcbsaVekRuxDuNiuyejYh4WQm7fZ66SEFLqQp	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1457	1145	240	6301	11109	jwC8nyA8MKS7CQnMjbxVxTHAgCvWn3gJevUR7sqfAzB4Va5TLsR	7667	10858	10858	1617893640000
15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	15050	3NKcipdzyoFVArgTcbsaVekRuxDuNiuyejYh4WQm7fZ66SEFLqQp	1647	1176	240	6301	11114	jwNR5SmBwED3NyfjJuwp9s8tjRVDXE9RJpeG6aCN6Bm4shpcVp9	7668	10859	10859	1617893820000
15060	3NK5GgTyoDcGemsGQ7oUE4HQ9By2c8hs1ztBqUneb7p6R56XwVsi	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jwn6YWuSFHSQhzaGbEPTMB8tmfGeEAfm2dYmpAPGATC6HEWTXQJ	7671	10865	10865	1617894900000
15063	3NLv11odijAh9YqPyBYy6bWbgMqwEj9ji52niG3k7u3sVRkTaq2W	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	632	1382	240	6301	11121	jwSVb6jgzaWUbk9Yo7zZmn42xstiurrfoL68yw7H6PkbxkRGTs6	7671	10865	10865	1617894900000
15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	298	1308	240	6301	11123	jwcGBNBiZKBjPxrZecQZCQEJx4Xo1Ksut3qYfEm1EhWDVGCvsjK	7672	10866	10866	1617895080000
15071	3NKzntTZdZGebFkE1kvH5RzbafDyC8J3gXCbNA6LMxVFTGjXvRzf	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1489	1380	240	6301	11128	jw7qyBX6w9eg1cJhdYBrM3BqnBs2ctFCd15kCDCsYFE4YZ88xQY	7674	10868	10868	1617895440000
15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	15075	3NLi1gLdwgKFMKwSencx3mtBFbgJFe2fHq3v8nCTQGTwGiwrNdGt	1507	1280	240	6301	11133	jwr32yrrLTmHtWFpHVc1xuqVWHA7Byb4hyyCNE3VNohSEYmJbP8	7679	10873	10873	1617896340000
15079	3NKUTUb8JqYMMZuzuAniJnes4rgWUFrHj7KFiuPh4qTPsXrLxkM9	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1581	778	240	6301	11136	jx3VV6iap7Ak2RT6mMc5538ixB83TQpkHXk89maaerFPtjy6A64	7680	10876	10876	1617896880000
15082	3NLVBWkq55DsHQp2iwQHghijsb5QFMZgSrKrFDPhCWBKG7NLcmZ3	15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	1407	1395	240	6301	11139	jw8uPi4i5ow7GoJ1A6kVR5e35pHoMwN62qxb2FEJChh422noKZY	7682	10880	10880	1617897600000
15084	3NLZGaVNChBbXSwT971duN5PJ1qyqsmWxyr44Rjsp6g6JohdFqKR	15083	3NLW38otQEwnvzBDP99UdqCdv2ABJt5QL66aFGXJKK5hEeappsBr	1643	1299	240	6301	11141	jxKXZ2qPj6HwTCowMgFzE3tsriZkq2BYAWuJg78e1xz7LCjQkWN	7684	10882	10882	1617897960000
15087	3NLRNmRScttNzeX4mjK3h6gLeF5mm9PWdta8EnL33oivp1ukSDrE	15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	42	1115	240	6301	11144	jwvVQH7AuvbPxKYAQWxbWcYAYbHkQhReU5viSkvaymSox3n8E1X	7686	10884	10884	1617898320000
15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	1406	1393	240	6301	11146	jxP4zNfRJ87uHKYdbZy8nmz9kNe5Syoso43S4BPkzB2m6NiHn3H	7687	10885	10885	1617898500000
15094	3NLkf4g3mteyfFWp5q89fhq75ZPNctCwPmfuT5o4jhCNZJ5reFZB	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1476	1371	240	6301	11151	jxefB4T42k7RbG8ohWxjEaqhBGrtof9EkyZ5jYokpr21YatxQcu	7691	10889	10889	1617899220000
15101	3NLYSVSkncqbaXWWo6jHtAhBVFvwa5xjKMsRms4exXoqGzi6Lpj3	14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	1407	1395	231	6301	11158	jxg8orPbi1towXzgMf94KCSkngvq3F6Z3mj2KSibRPev7FdTYTG	7471	10893	10893	1617899940000
15103	3NLGVHACtcPNjqgbwxnRv4Z31YuoTwbVid7hi17cMQeKMe3K4cQA	15100	3NL6radojmkEqXugSeXJAAtnD5VcRSmBuNUrEshwGaCQ1nMd9SXq	1405	865	240	6301	11160	jwhGFAn9a4GhW1NsxrwZBYLQQBCmrk2EjG3Ao4WvUvN4TpJnnNh	7695	10894	10894	1617900120000
15106	3NKDVFGZXMF1w8ESMKS7WHDcTYPWKgPJWMFbiuEHPwNnBLEh5qwz	15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	1599	1287	241	6301	11163	jwwC7mzMhP82fHiNcPEn28V4Y2KQjDj3hvj9SBp2PnW5Bp3XPSn	7697	10897	10897	1617900660000
15109	3NKNFR2XMCTNHAWqcgeX1GVrXJnyDiWHqUWWMXBcSfYa81whjcGg	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1599	1287	241	6301	11165	jxbvEEoJtLHzZGe7BTbBEkBhNSMgPDWK17MU8n9qVBxR54SjU8k	7698	10897	10897	1617900729619
15111	3NLcB2y7YSzd9g5NfgE6YBBA2gmc6PJYe4XdrobhJxJASX3ZihQa	15110	3NLc8qk7HicSr1haYzHsDm4sRWdE7ZsNsk8giPEHpkTPpGK8EfXy	1534	1191	241	6301	11167	jxHytWbFXZVPgxiRMKzBEZQiaDHoiG7LwYzGyHwjkL4img2yWXx	7700	10900	10900	1617901200000
15112	3NL1mY1VvUZMCFt15ZAcYdhBsFtCvzZXsHN4AUe4dhuYbCFsN1fu	15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	1624	1334	240	6301	11168	jy2sQZZjs3anMEW5pTUZYK1XT95nXi8YqrnuXf2HugP4tFppZg6	7688	10901	10901	1617901380000
15114	3NKALLjEDSsEt4v92THMaWhsHEsXYpWkdDTmfaJSDWHrSzKMwTU5	15113	3NLv6cKL9S9AUAYCbkPUZQYdn1vf7kTTQ6zBpeDSw5GvZr6mAzrd	1657	1344	241	6301	11170	jxgRa7zGcrg3VomTTHbBXup5d9vy8iippE4kGaCCBsGXv4bB4hb	7702	10902	10902	1617901560000
15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	15116	3NLBCTa92ETwSoL32dkog2xoTxgi7wrVLd4ARsnqciRNcj319jeU	1407	1395	241	6301	11173	jxit6h1C7R9K9zH2AKjz4TStuUJCzZ2vTGj7uuSUfT2dyFVnL62	7705	10905	10905	1617902100000
15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1481	790	241	6301	11179	jwyzXUVVS9tRT4wU3i8imnZJPfWqB6HXcg7ceyS1jonkQXyeQWf	7708	10908	10908	1617902640000
15129	3NKZbXe74t7P7K6Ub72ogZnVtxsWe6J9PaRjteU6sxZWNEZwKmvi	15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	1489	1380	241	6301	11183	jx32BNNZEXopSLPkwS3MR4YDo1V5qFmxVsfoWjxQaVtXL5HkkBF	7711	10914	10914	1617903720000
15136	3NKWHufVp2CYUssgpUYuUTLX32uLaLyaySDJS5zoi5N9TxFC43SU	15112	3NL1mY1VvUZMCFt15ZAcYdhBsFtCvzZXsHN4AUe4dhuYbCFsN1fu	1624	968	240	6301	11190	jxHJDUgTm3GAT2KVuW9EvxDxXqRe9hKRcSejfoZ1rQ62QvbePoy	7689	10920	10920	1617904800000
15054	3NKUyDaQCV73p88ySPZxbFyroc8WxXRvNHPrVHo8pPc6ARj1AdQa	14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	1647	1176	239	6301	11113	jxcfaQqPGzSsFrdZYF58a9RQAA7fTEbMPYWY2kHVKfgAbaYMP6g	7640	10859	10859	1617893820000
15057	3NL6soo7HckySQwwp4bkoGY7dsBY7DY3VxjSTYYABuVQiNQfkH4o	15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	1406	1393	240	6301	11116	jxmmobZXjyCSSZcFkRAqN7HxYZyH9qgiy1B64nd3fo1eWEHw2n8	7669	10861	10861	1617894180000
15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	1444	207	240	6301	11118	jxLUQ2q1MDMDkvQK1PCEJsn6eyLBtASVYWzXTjm5pzDAoaqNN7L	7670	10862	10862	1617894360000
15062	3NLempH9idCbQvzT7QQxDJ2T1KQLTb7x1z2f4vkKpZsnGjrZ4z32	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1671	1365	240	6301	11120	jx7At5xF5VsqTmfXVNsZh7c9J7JfDmnbdExKTC8mv1dEV2vUSZN	7671	10865	10865	1617894900000
15070	3NLt6ePLt1i5rpmcZH8vAUSLxtVy6Mt9Q2HtrDLUgcvS3nsKiCkG	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1642	1121	240	6301	11127	jwEfMczUobyw5jDgTotkCugiYfix6fKsjPBZK2wLZQ3QpKE1h39	7674	10868	10868	1617895440000
15073	3NLfs4JWsfHGrASY1m4VBhr1u1TSRBaE4B8Uxu2eQUgjLpyCe57c	15072	3NLammVhcnFZUnQDmskN9Dr9QdpVpuftWHZ2ak2uMg83DYNAPcyF	1631	794	240	6301	11130	jxyjmxBCTfpeshxz8fYX7Y4ZyMHcWXTMh5jAJTQdGG6LczK39se	7676	10870	10870	1617895800000
15075	3NLi1gLdwgKFMKwSencx3mtBFbgJFe2fHq3v8nCTQGTwGiwrNdGt	15074	3NLtkxWD5U6LExhyHLx6FMaW29FY2JctxCoXcBQrbqrVikzCRsKg	1426	1364	240	6301	11132	jw8oZtUKVwia4pRibpVz9YXt9q9c6WvpMGCkrE7MaLAr7ww1aFX	7678	10872	10872	1617896160000
15081	3NK35RbhMWe3U1rNhLzKYCQWx2Rywuj8siTUfT1VmYPhXrBN2CaB	15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	152	1330	240	6301	11138	jxZZ81QxeHny1NRV8bWSVKY5BGukMsodrup7aB87871FQfezS4t	7682	10880	10880	1617897600000
15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	1585	1120	240	6301	11143	jxLZ3Ejc3ThHNCHLETfpNWjfUy6fXgX94eRzG3KDdgjhFq7opVk	7686	10884	10884	1617898320000
15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	15090	3NKG7e21Gu8TqG9UufG6KPai1zqCQSfDGMAocaVvjaSREsp9PL3r	1500	1297	240	6301	11148	jwAR75ZNXr34iaWQ3W9w5uczchDyMS3EWT6XokbUiKeSP5gTVKD	7689	10887	10887	1617898860000
15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	1656	1343	240	6301	11155	jxa37zkwceQYJnqmM6jbgkpjc7MHvm1baYsy8zEoonzHuXUMBaC	7693	10891	10891	1617899580000
15100	3NL6radojmkEqXugSeXJAAtnD5VcRSmBuNUrEshwGaCQ1nMd9SXq	15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	1406	1393	240	6301	11157	jxnYkJUMiji3RdqymDN27R7DWoBPwggsBWxQKh4UdA6fahdrqpd	7694	10892	10892	1617899760000
15108	3NLCXQxMegXdjKhiuKNpUKoFZG7uGVnsgrt5iYm9qbNmXgdN3q9x	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1599	1287	241	6301	11165	jxbvEEoJtLHzZGe7BTbBEkBhNSMgPDWK17MU8n9qVBxR54SjU8k	7698	10897	10897	1617900660000
15116	3NLBCTa92ETwSoL32dkog2xoTxgi7wrVLd4ARsnqciRNcj319jeU	15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	1405	867	241	6301	11172	jxGKtLiJuLEbkHaVgsDw7Ku4LU5cVqLzUY88jYNsjbQCP6FwsQ7	7704	10904	10904	1617901920000
15120	3NKCkjxLQwYE5gtncsuurSQNEtZrL9odtmKT2D3MDAhNJPF7f3YE	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1559	1353	241	6301	11176	jxqpPHKnqK7aovXF9Yg7xJmN3UJgwqaTc9qWxhasDsmorxcduNS	7706	10906	10906	1617902280000
15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	15118	3NLGFDEooVxbxV1RRhqFgjqGkofzoCR1iLrdovSFAEUMpzX6Esvv	1637	816	241	6301	11177	jwJSmnaCEb6qsgnPueS6PSyhNWnR1k4FYSHWUSgiSDpxnCFm2tw	7707	10907	10907	1617902460000
15126	3NLQhTvSS3xJpjR36JqPe1ayfAAbJNqTQ3eKFdmnsCnWTX7AEzEj	15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	1529	1316	241	6301	11180	jwmHxQ5ypp8Hu7QrnzkJkVHEp7SVjuzDSmDKMTKijAkawmC1Ftf	7709	10910	10910	1617903000000
15127	3NKvo2oBVirJt3TvdGFtDtRmu4yCVTb8qqHLMMpzvVmvvoNwZGij	15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	1553	776	241	6301	11181	jx1E7h4vr5GYonBcKQeSMQ8zvfFX21y2CK1XPtXgYzdcDtApi7x	7704	10904	10904	1617901920000
15131	3NKpVBwWpYnQPj7YCGNc4LkY5zta8dw8zKTHGgXeWU1VncJEL34h	15129	3NKZbXe74t7P7K6Ub72ogZnVtxsWe6J9PaRjteU6sxZWNEZwKmvi	1673	1122	241	6301	11185	jwvYd2oenTHYJVESK9zVyjKcktgMqZD6aUxBKKBhKXb4mEnkWio	7712	10915	10915	1617903900000
15134	3NLfkeUXsQUexmCnjE1JbYoAggTiQDaT17YwpqWRzEK8rrCC1FuG	15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	1407	1395	241	6301	11188	jxKyiwBphZegwNax3jW7bxhtyab9KLfmD3cdLvu9VzMPFfXkoZ4	7715	10919	10919	1617904620000
15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	15134	3NLfkeUXsQUexmCnjE1JbYoAggTiQDaT17YwpqWRzEK8rrCC1FuG	171	1248	241	6301	11191	jxKo4NUmjHMW934HPqU7pbdU3UZ4pedpCaSURVdDpmUU2Thy2Ct	7716	10920	10920	1617904800000
15144	3NLwfbrDxPyFit1cDcS37PhVrRcZsKA15ueaRp62JrhfXQVfsHKF	15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	1522	1322	241	6301	11198	jxL6CEpsEjqp9hTL1aPGnPyNCCpwa7PZVFVKQMZ6DtDZ9TmrTiG	7720	10924	10924	1617905520000
15146	3NL6waza7nrf3Y7xmMGWaVHSRfSGutU38y2pxQEnHiUKic1sih6W	15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	606	1049	241	6301	11200	jwDrAqFzZCjGpDRmCVA4WJeJdetdxRYbzq7cTTRsii6R8vFz1LX	7709	10924	10924	1617905520000
15147	3NKgvDiVShGDGyEZNJKn63kxGFSsidd5xV8MVr662u5VV5j3hEHN	15144	3NLwfbrDxPyFit1cDcS37PhVrRcZsKA15ueaRp62JrhfXQVfsHKF	1581	778	241	6301	11201	jxRAaoRcmpH8fmw24Pz8LJc8HGu3871xWivSPpNRdgCcTk6LYdo	7721	10927	10927	1617906060000
15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	15155	3NKbDDAPFnvWn6jDxfaqVWwRFhkGDEtwvErFfRRUjUNts7s8BnsC	1534	1317	242	6301	11209	jxjKZ4SUuj15cm2wiPGtZHKVDrsQTtYxdr9js4AixQury96WweW	7726	10935	10935	1617907500000
15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	1577	1327	242	6301	11218	jwGPo8d83Ba3uCXKU67BtnKDREfCG4eijeaXZdyBLgynqvqytmk	7730	10939	10939	1617908220000
15177	3NL7tsB9LafB1MSERDqsJmnqdsfwaFPHx6tbgdk4BqpcXpuyAQNh	15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	1445	1044	242	6301	11229	jxiCoqg6KGCZGWQnQrULM23Gfy1hJoAtoApAcYrovtWyc1uULfs	7733	10943	10943	1617908940000
15179	3NK34W9VZpDTpS3mBuq9AtuZr4SHyL1SnY7aBniokZPyncCP3dyu	15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	1607	1348	242	6301	11231	jwrFxquDpSK8e5SutbffXxJd6RKfJTG7dHVDXpV5V3aqM23BNuT	7734	10944	10944	1617909120000
15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1483	1030	242	6301	11234	jxntHSbGd37UZdEeD6ZcLneCzeQtEQrsc1v7DYKrh1S8VjthYey	7736	10948	10948	1617909840000
15184	3NKrpmh9RxCQV5HD7A9cvVHADbpb2dV6jzuRnVNu7sQ2wkN8JzJ9	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1406	1393	242	6301	11236	jy1Zeiyd2kwXmkjiirPfjNcfkEq7R6mTqtpJZHGBB4WtWwb7EpF	7736	10948	10948	1617909840000
15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	15191	3NLUZJWpZPhPAdxDAGjZAxYK6F2LLe9m6kAgEMDqeQnerbeUCPFi	1407	1395	242	6301	11244	jxmutssaD9xbsPBFbE6jNzmw811bHWZWTppf45FFUeCyMU6xUPx	7741	10955	10955	1617911100000
15194	3NLwuWHbBZQ5VYH6fnss6LBFMZpP6LJxK4DxTVDNWLXaFQgHoWAF	15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	1509	1194	242	6301	11246	jxvPZkdDfExBqb1U2B8Vzka1AvXDscyWQox89Xc4KNNYeGgpDy3	7742	10956	10956	1617911280000
15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	1407	1395	240	6301	11115	jwEAvvaHw9qPcGsQybUzoeMJXNF4UchZHjgptZCwQhVAoNAcFWw	7669	10861	10861	1617894180000
15058	3NKFcGwDeozYSEP21jHziACfA6YZGPf9WeJ6mS1de5q4hhRzo6tB	15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	1619	1149	240	6301	11117	jxcAcBCPTciTa8vL1DrVLwJqK1DgGdmKbVpt6gymnQJPDutYJ4Y	7670	10862	10862	1617894360000
15064	3NL5ebPZL4c823C7vi7QFLvC2Na6NciKf6ZCjfBoeGwfaaHRSKJz	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jwCuQs5GPFsMKMAeaJ5yHE1n39xviyFPvoKE4z4TKdiewefxAkG	7671	10865	10865	1617894900000
15065	3NKiVMz5pMxnWRccdc8RUggP2pBBEy93babBRiqXPH4jPcRBHdsz	15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	1403	823	240	6301	11122	jwDGsSbpCD3wg1Axj5gQ33WpJRK8xFYoshCn8nthvTLxnT3Yatn	7672	10866	10866	1617895080000
15068	3NLEg4vVM6QSYJWKhjPV5rPTf4WwiUxrW76zZLCATHDRj1ZGDH4n	15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	633	1384	240	6301	11125	jxdpBrSbcruTjBsYzNSC6sTdwcrYWRg8ovWxWmPL2whF4jjCiNx	7673	10867	10867	1617895260000
15072	3NLammVhcnFZUnQDmskN9Dr9QdpVpuftWHZ2ak2uMg83DYNAPcyF	15070	3NLt6ePLt1i5rpmcZH8vAUSLxtVy6Mt9Q2HtrDLUgcvS3nsKiCkG	1402	852	240	6301	11129	jxjgcUnH2ChyqZ9r76XHo54qFhJKSE58cbmBRSEgeamnZGwDDfo	7675	10869	10869	1617895620000
15078	3NL22Q6twbXJokeeVyboNGWDgC4Nfnvjjiya926xjNqEn75vDr7w	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1516	1048	240	6301	11135	jxux1gr4kmx1b4w91LYsevNMzrsNE1V9C4vb3gwAASnbNtFwipx	7680	10876	10876	1617896880000
15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	15079	3NKUTUb8JqYMMZuzuAniJnes4rgWUFrHj7KFiuPh4qTPsXrLxkM9	1467	1376	240	6301	11137	jwCQrGcoBbg6jdDRvjjnAuaKzzyHhrZFMqURfKNpTDBNnpZQW82	7681	10878	10878	1617897240000
15083	3NLW38otQEwnvzBDP99UdqCdv2ABJt5QL66aFGXJKK5hEeappsBr	15082	3NLVBWkq55DsHQp2iwQHghijsb5QFMZgSrKrFDPhCWBKG7NLcmZ3	1406	1393	240	6301	11140	jwnnj9M5gYyckRHnNW69CeGWFBE29XnDCo6Mj66PY6XMcf1WZMp	7683	10881	10881	1617897780000
15088	3NKbpYwFsttVUg4nCpSnXe2oSEZizJ5Y4ifMKcnvSyUxCuWWxfpi	15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	1467	1376	240	6301	11145	jwNECjUnSEDceyT3uW2jR9WugBnaEkTGbE1V6Rbu31BtGLvbdBZ	7687	10885	10885	1617898500000
15090	3NKG7e21Gu8TqG9UufG6KPai1zqCQSfDGMAocaVvjaSREsp9PL3r	15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	1610	1068	240	6301	11147	jxrbuUznc25FCGX6pw15dNhEkMAuSFUQF8SgiSabycuYyYGUzaZ	7688	10886	10886	1617898680000
15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	1526	290	240	6301	11150	jwLwFHUNpnoQ5FVf3NvPckKodgt6bPgqtNziNLjpZrSZKt2e7GD	7690	10888	10888	1617899040000
15096	3NKh5AiZT1w8qbbnFKGgZq3K7iq7nQQYeHv4e4xXDUGkTRGeR7Xy	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1463	464	240	6301	11153	jw8CyRJrv5b4s8RvPm5zpxmuH9KeBxhoMN5u4Nnw2nrQs6qWkBn	7691	10889	10889	1617899220000
15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	15094	3NLkf4g3mteyfFWp5q89fhq75ZPNctCwPmfuT5o4jhCNZJ5reFZB	1406	1393	240	6301	11154	jxLSQSLkcxNuDWyb5ZPTSTpAVevR2dn4GKdsLVwH6NvBLZvNx8x	7692	10890	10890	1617899400000
15102	3NLJZ3evzSDmbWAb8wzxiTHcpjxHc4ACghSQc5z8Xa7u4WUqMfdS	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1407	1395	232	6301	11159	jwdLTUnDk5N85xgxxPdYuoZCsDKCanqjactiNxo3mjJAwtFb3oP	7484	10893	10893	1617899975257
15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	1631	793	241	6301	11162	jwq7ALCqJTh6KYhF7vCSxLoSxnTeyNi1G4UExT8ZHq4rzAnvnG4	7697	10896	10896	1617900480000
15107	3NKPvuBV8jL3YaFLUyL3w4UU3h5r7NKpU6e5K1KoX4azpYM1jQuq	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1652	949	241	6301	11164	jwbyVmsmJq43FDPwJEmYh8DDc5MgwcackKrvDD6xNr1FKRj6682	7698	10897	10897	1617900660000
15110	3NLc8qk7HicSr1haYzHsDm4sRWdE7ZsNsk8giPEHpkTPpGK8EfXy	15108	3NLCXQxMegXdjKhiuKNpUKoFZG7uGVnsgrt5iYm9qbNmXgdN3q9x	1405	873	241	6301	11166	jxhXAsL5CxZ4VZz9uSRL3eAuzCyjJdwTtDvmv6ARKzFfeVf7Wwy	7699	10898	10898	1617900840000
15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	15114	3NKALLjEDSsEt4v92THMaWhsHEsXYpWkdDTmfaJSDWHrSzKMwTU5	1426	1364	241	6301	11171	jwPim5TS7zM2QKexjhZRhDkKYdg1LqSvtCBqzwqTWGCPmCKMEad	7703	10903	10903	1617901740000
15119	3NLcsyWY1id3MeMob3EbHipdtmZcpyZbnB9t6tFjVttN5yDgvGhb	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1642	1241	241	6301	11175	jwZvKxWpLPhUrp2xyMsH7ZgT7pg5Zr2o3M8ximyZQUKfh77PfaT	7706	10906	10906	1617902280000
15122	3NLt7JzS8eBLvteaDcLL79TrRgysK3yJMzoCJtb9rsDYvQNDjSQN	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jxZMSxF4mg5kSJoUMzKkSCqr7skdrhjfJcuxPqt1DemqC2YAXBE	7708	10908	10908	1617902640000
15124	3NKVx7Xpi777wH7CYAxtymJCV82FWbD2wRXc63WEL5LVMNUV3Thy	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jxYENBNGLzKypGJRtGHmUfsAiGRqYtCn7oMMvurGR5tmTDA9rez	7708	10908	10908	1617902640000
15130	3NLmRr8G1jAk5gs9Y3W9R4PBAWoyQqmx5bo25yTbEuakmhuoQxEK	15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	1419	814	241	6301	11184	jxYR96Zasp4gmbKVVur3ZMzzntcsZ99QJi5eptj7xaDhSfiHngU	7711	10914	10914	1617903720000
15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	15132	3NKzbqu9STcrVARBqNnqm3ZY6dwXsgaDzwLVZpJxq2BTrg5zo1HP	1627	1385	241	6301	11187	jxPzvre6LXbNnH4kMGyayZZvQE2KCUhsktrPSQF82Pv8tJiUgbp	7714	10917	10917	1617904260000
15139	3NKoukRg3a2KAhmAVa7p2NCGTHzCguupxTU6AufSXmk5xJfbgB5H	15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	1402	850	241	6301	11193	jxucd8RRTP25QmHf9H1ACuzNaqf86ZdwnykZfBLSpSaFw9u6jjj	7717	10921	10921	1617904980000
15142	3NKxnG6pQLRXxWiu7nvYR1ybCdFKq6R9mTXF9RDZCR51bVmJdbP7	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1668	1124	241	6301	11196	jwvm3PNUznHv1ZeM6dRkqpXBp7L1fcRazSVDBgVkhibhwRXRDqA	7719	10923	10923	1617905340000
15150	3NLUrLFWWtmMyV2rwTVRRGX1h6vN8eQxVvb4cXNvEG9VDTrhjPmN	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1474	1329	241	6301	11204	jwH8FSiSNo43VGGRg1n8ezjb7iSN9s9BiV6eiKNjhs7AzjjWDpZ	7723	10932	10932	1617906960000
15152	3NKn9LWw6pjwuQ2wk2nU8SQpJixsVdtFtR9hgXwhtWsANQApT6Sn	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1579	1389	242	6301	11205	jwxtu2doYQevUxkKw3e2cY9NfWGQQZjN11HFrRri1RvV4KkogL1	7724	10933	10933	1617907140000
15154	3NLoQMLjKWKtoZp6cubGpsJovLNUPbLr1rS89Sng5wBJYzqwkPd5	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1601	1388	242	6301	11206	jwa8ZkGf9S5yz5dKgsJFizvxb69pKzPb55N4k2N5b6ZGKRhNKkF	7724	10933	10933	1617907140000
15156	3NKMym4DkrbbTwXHyhf69VeYreTPK3JYGaHr45pyvWmfja8vWJnz	15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	171	1374	242	6301	11208	jw9acYfsiM6Psy4hx81HfM4PWW84ysgVto1qQrD2hCVGULhWPYW	7725	10934	10934	1617907320000
15159	3NKCCWjvxDNw4qWaz9WvRBtHWB1CmPStFb3q6ZFg2EYmgg2w9pzz	15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	484	1193	242	6301	11211	jwDyP1is62ZEQWAeu7DVza9x6GJhfrNH3VdoPwzN1wjEfxLQhv4	7727	10936	10936	1617907680000
15161	3NLq9QBYt8upMGp1C1qxb2QqYC3b7HQ6PCPXhy9t4ZfS56w8HkBq	15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	1602	1123	240	6301	11213	jxZz9QYbS83exM7JXmNQspXJujDKuFhcNm5LtzCPNHj11pKY6xs	7693	10938	10938	1617908040000
15138	3NLTam9hcujem7N6Ms9TfFeJ1QjU9EzDZFnuVh5xn2FaGBRQ6CRh	15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	1444	1255	241	6301	11192	jwMGF2nkHtMcBq35DERhzbZhaCtNnfhoqsvFJsrR7WEpBRDyAcq	7717	10921	10921	1617904980000
15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	15138	3NLTam9hcujem7N6Ms9TfFeJ1QjU9EzDZFnuVh5xn2FaGBRQ6CRh	1652	1315	241	6301	11194	jxFAivMEyZPDduti7EUeNTfqngkTGRodhei77BZ7djBELR23hzm	7718	10922	10922	1617905160000
15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	15147	3NKgvDiVShGDGyEZNJKn63kxGFSsidd5xV8MVr662u5VV5j3hEHN	632	1382	241	6301	11202	jxEtRNjwCmQxBiCb2cwLkj2LXEh24DH2x25vfoVWid841zZFVAK	7722	10930	10930	1617906600000
15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1601	1388	242	6301	11206	jwLhd2ZHAr6mLigJF5MeKhBnSLseeYUJu3dLCRd3XrbVhw7Yh8D	7724	10933	10933	1617907140000
15155	3NKbDDAPFnvWn6jDxfaqVWwRFhkGDEtwvErFfRRUjUNts7s8BnsC	15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	1406	1393	242	6301	11207	jwdqZA7t8JjJQfEajL5DNcdrkCVBtDJ37WyW3DUckpRvpFVgy6A	7725	10934	10934	1617907320000
15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	1406	1393	242	6301	11210	jwk9nT3kS4BcBe7q4mJuh6DMDK5b618NzyBGRggVQu2akrnRqiv	7727	10936	10936	1617907680000
15165	3NL8ErsuE3ViDjupYJSFJSKjsQZkSENqWABfHpDQDYqF16xg93QJ	15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	1406	1393	242	6301	11217	jwPmGPEVV9npN9zvDfhZYjkxD2SEssRW6Pj4p1351tNJ9TgTsk1	7730	10939	10939	1617908220000
15168	3NKweDQbtDLN4aQWdQ2kuBw4BQB6sxPGfWVBbStw5coLp2pvpiHz	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1407	1395	242	6301	11220	jwV8dJmLvshfm7YHoLTXLW6PG9ub8ok2DQBnmvPHc3ihqAJ5Lg9	7731	10941	10941	1617908580000
15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	448	1179	242	6301	11228	jwaKs1oEfaxNnS572mE2f2FFUvKvpdgsuH5zqXJmnKrabSGFa93	7733	10943	10943	1617908940000
15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	1587	1357	242	6301	11230	jx8AVhCBwaQSwRxZEXNUGtya1ss4XG4nkGbvXkuRhsRv9KsfH1R	7734	10944	10944	1617909120000
15183	3NK3Ash6bi1v3RYGN3vJTrT7tQ3KZ98ShrA2WU2VEz7ir71dP4kQ	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1560	331	242	6301	11235	jwafPCnyfGtCs39dNwCKctequAUkNkGhxxU2vov1C5ZqBDNcakE	7736	10948	10948	1617909840000
15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	369	1186	242	6301	11245	jwP5apmeJEqocZeqmLnbYXkXjfA4NGaBYbFhybookvfy7G3Pbqr	7742	10956	10956	1617911280000
15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	1445	1290	242	6301	11252	jw9tchaxJCVyfoBMaQsMXoBPkjfsytvYWbUsZX39WNQkZczTiAy	7745	10959	10959	1617911820000
15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	44	1325	242	6301	11254	jwq1TpjFMuvYZSQ6dw7kHA57Y1VvpqJYX4M87DgykjqF55CoirL	7746	10960	10960	1617912000000
15209	3NL5AmpCmcwq3iBULGSvDvXvXXyx9xRBPrWrajBayMEPVq6i2vk8	15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	1471	1140	242	6301	11260	jxoMfpoLLFBJRhHwCU5ntBxxUqSppw27xDAFR2m1o8SHnPJEzHd	7748	10963	10963	1617912540000
15216	3NLQZNHLoAov3xDYpe8WQFX6ZiG9kGyB1T8YGfrH92RYqJJtcbvT	15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	1406	1393	243	6301	11267	jx98ZjWetbFjQDEdd9BiREGEMAznAdqEowRUXKzv25fTkd34wwv	7752	10967	10967	1617913260000
15225	3NKcHqtxyUmdQ8s99hiisHDFfnrwJ6U3CnGs8bhFRjN8kA48KLz1	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1406	1393	243	6301	11274	jx5isk3duuYdzBCVzGxbhC1Qj9rHpzrG3e6XxbrJjsEPkV19kpY	7756	10973	10973	1617914340000
15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1581	778	243	6301	11276	jxTeCn28oVW5JuhCcxWWpRdDqXj8QteR6ekeHuznwZFrCtgwMBd	7756	10973	10973	1617914340000
15229	3NKv9vF2qDs9s7VynXqVZCrKgKSDHRGnJqL5rzinbCtVoy4yqiSh	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1609	967	243	6301	11278	jxnLFaMt2DJj7jsdJjfWN68CY6LCq1rWnzmrqXtYRQKSRYKGaid	7757	10974	10974	1617914520000
15236	3NLDoNzYb6km9wCYTwGX3n3ozc8X7Acv3Lx6KCdHs3jGpVNuzYaM	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1508	1141	243	6301	11285	jxaxqaWeAJNzF5FmntrqK4p93ULHpuvLtYohSxGYD6TSoZ5TqhR	7760	10977	10977	1617915060000
15238	3NLE8GW5Zx19EPGmu7zvKss3xVuM152WwpXYP5L2F8xmK8xxkJM5	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1536	947	243	6301	11287	jwiqMNbFRdkdZx1CiXRbYFUFJ2S6vXZLVufhZoZEtZELPNANXzQ	7760	10977	10977	1617915060000
15241	3NLgqZTbg82suQcv2EFJww5JtRGGXoVoZc2eoJ33ttK9Hg2wxrdz	15240	3NKjr32HD9UVfHHmoNDFL8WBy73uT3qUbd5zWT2niBxFLSwZAn7m	1673	1368	243	6301	11290	jx1JaLTn4LY3KqUBDD4mFC4zzqcKw7aACEHyF9QSjSCxKRf4FZb	7763	10982	10982	1617915960000
15247	3NLvf3aAMkx2zoo837bXGCLpUUycvzj7j61RwTABUZ5MAu6gvFik	15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	1403	824	243	6301	11296	jw9DtYpdmjX3JQKzRfh5Du5S88m7ttVNzVBwaNePfGeV9Z8nDUp	7768	10990	10990	1617917400000
15252	3NK8fL16G3cGXdTfG97k83cDxYLSdhHKxtDDUeKrRANDvG3cNvoT	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1589	1286	243	6301	11300	jxSdi2yWjyYaRMveuNWtbR4v1KkTnzk2ZrQK4XZG6kd9k17g19J	7771	10994	10994	1617918120000
15254	3NKC4nytfW9SfjXQw54iKR6tUk6vPkSCjc83b8cVo4hh9duYGfCk	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	43	1064	243	6301	11302	jxTuPvCsJfBqjEXxHbXDDBuLsXKbRuw49nRnH9axbpdGvqKG4Bx	7771	10994	10994	1617918120000
15257	3NKkXJ5ZfLYLSWMwtNAKF3qvgtm2FWzdGr5jnkDzbycQxbkoPsSA	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jxe9naWE9SYKGXZxEXHjryfjFNqwfZwxjs6ZMcQ3jSNTW6xFQ91	7772	10998	10998	1617918840000
15264	3NKuGbMUHc5N8aFmEUVWuVR9rLKw9ZHbYWeXhLXEorJtk2A5KWcS	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1483	1150	244	6301	11310	jx1mK8CytSGjYeEWFH15gHi9hZcVEaMA3D68HaHDfnHysz6ToSG	7776	11002	11002	1617919560000
15269	3NKfHaTR4wYNuLksATbCc3hvvdiJVjNrr8aCBnDTTUPPaLpzcy7f	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1407	1395	244	6301	11315	jx3UPqnifKXa6RdHyqfnacX78GbJAjrboMZTgCrqhgSCmC6wSZ1	7777	11004	11004	1617919920000
15271	3NLFVSMLyhFSdaShqD7aVGCSM3JTqgGeKdMy54BZpWHvfPUuqCH5	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	1513	1379	244	6301	11317	jxU9qHozdbDxkwCJ5pvyoNubpqLRfZEsXPuReecAbwiLjcjRiQR	7778	11005	11005	1617920100000
15274	3NKE8hSCweXU8vhKZM81dAJirpvFnNNRQSorrogUj5gqMgZ3gDok	15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	1481	790	244	6301	11320	jw6xuj92BVYCudKFNddCxrRVBzsSWBVJdtaJtCnqo42aJC6QcMw	7780	11009	11009	1617920820000
15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	15279	3NKBfE5HW3tKHuKqSCvAy2BP1bWbS3fTJpERwCcuzA9DAzrQJNWs	1596	997	244	6301	11327	jxPca2pHPyTS5XGeUykn51MUxLmNLUHZ1fYuU5WGpuzTqMGUAys	7783	11013	11013	1617921540000
15143	3NKkahYvt1KemuM7cRYTGwFNRRsdHjYuK4n3sWZjchg8f1QepTqk	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1406	1393	241	6301	11197	jwD1J7GnUDK2XtCGTVH7jD4ZQMdj8j8XUYdyzoCC6kWMNidQijC	7719	10923	10923	1617905340000
15145	3NKvwdJhYASYvVkyN5eXtSurSEFgGRGatAAor62JJ3GzxwiDU75o	15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	606	1049	241	6301	11199	jx5rCcHaVMoePNZTA1nnySFvdQb8NfPcWhdWTrcsnKf28NuhtVk	7720	10924	10924	1617905520000
15149	3NK6NigYLexktbcK55YUj7CUdg5LVRYbrZxC1Ke57yNw4x8XSXqU	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1406	1393	241	6301	11203	jx5eso1T1kcN4QS11BqTKk8if7D6b8GwtnUNRwK55m8JqiXyhXN	7723	10932	10932	1617906960000
15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1474	1329	241	6301	11204	jxCFSm69gMKMRiKu5VJaaKdR9YmsffvaaTV6kLk5nNDhdbjTGpW	7723	10932	10932	1617906960000
15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	1406	1393	242	6301	11212	jxuXrfjURYSvfJYD4xpJMqupjY2foDUeu9PNHsyZhpJFmro1beY	7728	10937	10937	1617907860000
15162	3NLHJGKt42FRDShRzKTgUib4dxBa57ozH4AT7nGbb63BJxLYtCHJ	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1602	1123	242	6301	11214	jwoExKAukVVBCrddetxw3JaxhDJsdkAucSc2kPK58z59vi1VBBP	7729	10938	10938	1617908040000
15164	3NKD4R9hw42QZAjPii98AeUMYe1MyRcFLr83wtbFieLeVCSftkks	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1631	793	242	6301	11216	jwcq5AJ1uUbPjAcpy872bVpfD9tvdGM4pNcgktSjdisHQz7nMXH	7729	10938	10938	1617908040000
15167	3NK4KvdJpy8ZzfYU8grUpsqDrNanapjvJ8HFFoi6AtiCWUSnmeUm	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1455	1086	242	6301	11219	jwbfxLwZTvYPyf3duS5QJ5CKX4DBdJvVLs8V4WXtR66awTyjT1D	7731	10941	10941	1617908580000
15170	3NKBcSPuYLsVL5HmSrRHDdWFK4ry2EMSd668Sx3tZrgkwmCJTQ75	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1610	1314	242	6301	11222	jwdWkd8qUdc8D6Epyx4y3wV3Nm3sS7pGKVaxXibwPuDJGFHSZ9p	7731	10941	10941	1617908580000
15171	3NL5SpMM3C8WaWmTWjnbAU4WCgeJqDKNu8hZJ3bmTEmnXDLGbAdB	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1609	1333	242	6301	11223	jwgKS2MueSMz85cTbhyZDzFoRJHpGyZTZ4ihjdk2vXkzxK9wEgv	7731	10941	10941	1617908580000
15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	632	1382	242	6301	11225	jxqgpxVPvnccaLxWG3PBHq4WHE1wfFFKL5UYEPe6ApGCkpqZ56T	7731	10941	10941	1617908580000
15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	1611	1341	242	6301	11227	jxXzLrc2w6jB4ekhuBtb2QqR55p9tUVijghLXFeUYYHNDN7vP7G	7732	10942	10942	1617908760000
15180	3NK5uUFni9GJpjG8cu8JeydJAL54EvzGicbm2eL1ihweTBgQ3EgA	15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	1613	1349	242	6301	11232	jwD92qzTnfMmkUb5s3RQ4bZ5YrSUAY2oRojGyeuJyPQFdv3q9EF	7735	10946	10946	1617909480000
15185	3NKCbG3ZZLQUfB4WKWJcNnfA2Rv3HkMN2t8CgnNDYX66sCVYacF7	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	1402	868	242	6301	11237	jwbCdLFyaWqUj6yc3ZWjRdYXsUeceveDmRwn8NtMgpeyuNMBtS1	7737	10949	10949	1617910020000
15187	3NL26ByJk91rF8j521dCyUkpekuFgEFBJ3k3DUvGEzJHQTwXdcj7	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	641	1210	242	6301	11239	jwq7a9czyiG2TnrnJBbJ3DMwhTD2vSEMaVVg2ZKdtdGAiKoFd7N	7737	10949	10949	1617910020000
15190	3NK9vLom3dZcanLKS3n5icd6ZthXYPtaS9ajdcEDhR66uv8UwLup	15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	1402	862	242	6301	11242	jwvz4n8gX95izB2vaUhqUp2sfG71MnQveiGUmfBrF1Q4PUUzUS4	7739	10953	10953	1617910740000
15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	606	1295	242	6301	11247	jxcG6avUvQGsZeo7Z6dKwGiE2YSGjEKowiCTNjkQX5XkKhCHaJc	7743	10957	10957	1617911460000
15197	3NLTzTrvNHJrWZDn9VqzimCyUgAs4EfrVDBHQyjWPktsXiXYkCVN	15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	1457	1391	242	6301	11249	jwG5LpaED2SdRr5Tx7rA3cr9rhcba4hsTqLxEUy6pZRuWttb6fK	7744	10958	10958	1617911640000
15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	1673	1368	242	6301	11257	jxx1uAen9Rd5MbSMgqkhRGfhB5udSXNpsAkFpPqbfH45U2tJC3S	7747	10961	10961	1617912180000
15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	15210	3NLahnWkKneGhEf5nBxUZ796dcwUqo7GJ5SVYFa2dC9HgzNF57bN	1507	1280	243	6301	11262	jwZVsH8VeabZAuGk4Hcc6mgRifVUxeoC3S1H4bgA7uX6zb4vj3J	7750	10965	10965	1617912900000
15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1406	1393	243	6301	11264	jww24Ssu5TcCyQupD9fJSQhKcyenjE1KdZw8Qhz5xoqKZsHWuUJ	7751	10966	10966	1617913080000
15219	3NKGRUPiTEDunZurZ7E5YWmikKMK8QdR2zBcGY6b6BAaQbEoGUZh	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jxxptVhvi462rMFNfqotvK11VCFmcnCDkDYnHsvQEwAc6G35HTa	7754	10971	10971	1617913980000
15221	3NK5G6YL61tZA1XmhxZbAA933mxvQvnQo2stLRGNvJobYy5jVyWu	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1631	794	243	6301	11270	jwS6WuED4eNfoTeLPRWGUf26VBGyEGzB6cRa5xn9d6MhkRjkMVq	7754	10971	10971	1617913980000
15223	3NKqeyuXpi8TcfzTWyBGZSdGc8VPW9A8uMbRbjWVCGispj4xyedo	15221	3NK5G6YL61tZA1XmhxZbAA933mxvQvnQo2stLRGNvJobYy5jVyWu	1613	1103	243	6301	11272	jwwA4NdsUSU3Wh51D5bbcrtKf5QZvyN5dfMBqb8v2E4Lxd3cp8m	7755	10972	10972	1617914160000
15226	3NKcqnRDZZLmVfNGRm92XFaZPDFSakAiAhL1iYvg9BEDzKeKyLW5	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1489	1380	243	6301	11275	jx7pJ1u9c2XgM5CJ1rF1cFu729wiykjBktQHov2poe12MKKYDGY	7756	10973	10973	1617914340000
15232	3NLJwvqFZBYG4uxz7majWjA83Z17dZaQ9gnvZUTuAbSUixAYTTsz	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	1407	1395	243	6301	11281	jxHAGMXdD6gUfu7XqZYHpJxajaMKDTRsjSXDWsTDd8cvKtTL6gM	7759	10976	10976	1617914880000
15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	1536	1067	243	6301	11283	jw6nTMV23eSsFRxRdwM1RCwsAN9BtXLj5ernbVcoj9jFZMHeHQr	7759	10976	10976	1617914880000
15237	3NLPv12LM5fthLv6X2KzPb8rki5qUfGyYVY5MibCmArmLsVpmpgw	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1406	1393	243	6301	11286	jwufZSbc9QBFjRALdZCa3ZamSSHMiqBxXMHwzvsFTPDBAdqgK9c	7760	10977	10977	1617915060000
15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	15241	3NLgqZTbg82suQcv2EFJww5JtRGGXoVoZc2eoJ33ttK9Hg2wxrdz	1407	1395	243	6301	11291	jxu3qnsypYPpYstZkT3DUPQHncRHL8d242sQ781QwsBkYcczFfJ	7764	10983	10983	1617916140000
15244	3NLcnKLayVAwWzxvgfviu8Q2Vz7zEMX3D6vEbMCaNR7YwSZVHQkD	15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	1513	1379	243	6301	11293	jwv1SjdiqKkgkL3LKcwXD22iGDTKbGJpoAaZRx3Y5BDAHExRi4J	7765	10984	10984	1617916320000
15250	3NKcipSnd4fWKyRBjiyopnReBQiLppSQKvrfSAt2ZS4cwcwpmq6C	15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	1541	1172	243	6301	11298	jxN1fkC7DDCUiFt7HZ7vbARVkkzJa1Em9CD2QGC8WdYJfFWEtnC	7769	10991	10991	1617917580000
15260	3NKSgFVcwLD7XhadPvZfWarTS2nR7xAMfmXBjNXyEwirXAghHqQp	15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	1594	1080	244	6301	11306	jwN3udZmY5P5D8sWnKnJLwDRsywZzpaUQUDS4YK9htzimYV87ai	7773	10999	10999	1617919020000
15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1675	1216	242	6301	11215	jxvbt7NYuWZXPehRUeQwUPVq81GLNCVyMtFrvwnN6kM8mwGJuQe	7729	10938	10938	1617908040000
15169	3NKJPiqEg4U1qTN4BiicAh5VPErUMQZEnK1RdkpXvG8fZqhCP4RB	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1403	824	242	6301	11221	jxbNGG6ETv7ZBWCzZDVF8hQrZAysbsp22sGzYWKEZjsmBaGiURT	7731	10941	10941	1617908580000
15172	3NLW2e7eqN14uxg7KXrLtRR93uELssmUpVJABiKwqY89ZhxsAWjR	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1509	1320	242	6301	11224	jwknoESeMs3jBRQz7PhHb4jJjEDKZHgfPqWej7voV3MW4EeSuGL	7731	10941	10941	1617908580000
15174	3NKzaKyFzNxSELVsz9fnYqh4XPymoTP7Rha54eJDQiMWzSPZ8SFw	15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	1578	1050	242	6301	11226	jwrBntdoVuL5UTPExpKdetxgBSpJ4ou21ABh9BnbUQdjaJebR6T	7732	10942	10942	1617908760000
15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	1461	1271	242	6301	11233	jwAizW2JzNRDwwUK7mrvwJrJRM5brsw3UKBT5DP11uJ1yDrXYvd	7735	10946	10946	1617909480000
15186	3NKQ9PnvivNjKauTv8qJeH91U378ooJRhG6WAWsRp4V3pYG9jozW	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	684	1226	242	6301	11238	jwe3zShS44pFeCsaY5kaHCGwaudgz7RpEpQ7z2xcJUQ1SWKhfFu	7737	10949	10949	1617910020000
15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	15186	3NKQ9PnvivNjKauTv8qJeH91U378ooJRhG6WAWsRp4V3pYG9jozW	1637	815	242	6301	11240	jwP6qXPtfKNCaRgFC4L796cm7CyHK8BDC9UDUH7UbmF7LXkUbEr	7738	10950	10950	1617910200000
15189	3NLLKu7t6MzubxxZrqq25DsQ5axNjC737cZfsiog7eB6fhPHwqm7	15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	1407	1395	242	6301	11241	jwBMxNSScm5p11spKp5kZHtRZdewxDvqgQ1FTtWpVumaCHgabAd	7739	10953	10953	1617910740000
15191	3NLUZJWpZPhPAdxDAGjZAxYK6F2LLe9m6kAgEMDqeQnerbeUCPFi	15190	3NK9vLom3dZcanLKS3n5icd6ZthXYPtaS9ajdcEDhR66uv8UwLup	1593	980	242	6301	11243	jxVBkDiZJuFXvVaNz5enpwcF1npUMxfjcD9CQxU8ArwX49ku9ux	7740	10954	10954	1617910920000
15196	3NL8cFzaMW4acaXXtT5gRXoxuYNGqD4tfQFtxouyyUMJFbAGW6qA	15146	3NL6waza7nrf3Y7xmMGWaVHSRfSGutU38y2pxQEnHiUKic1sih6W	606	1295	241	6301	11248	jws8juJYd7PH2TJySdNsNoy1x6Lh31vvQbeVdE9nKgdUEbt5cBG	7710	10957	10957	1617911460000
15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	1405	887	242	6301	11250	jxhJZa9jfF31emQg3jsMpQ13e9cGyTYHeoE1pdae9QZoA1NArs6	7744	10958	10958	1617911640000
15203	3NLSWh9Bv48A7qJmTUykEmbb5JzWtaHXrmapQuJbG1u719DmgfPV	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	1534	951	242	6301	11255	jwKpUZTGzcwgKUMmMf9hPXLGDbddbo6cPhgS86x8cohCata52C7	7747	10961	10961	1617912180000
15205	3NLxHZxK3fjYci2oCHLPMFAzuZAw9D8xmzZivbZY5rBpdL2WpLrk	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	733	640	242	6301	11256	jxpPhpgQybsweYXzoCGQVqEATkWbkNXfB3h6vio5XbtxsfNjRFF	7747	10961	10961	1617912180000
15207	3NLZc4C4rNiUhVuyCaRdct39ctAWqYTEFzyydk9KfK1hEXcdvU2v	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	641	1336	242	6301	11258	jwYH8GmCupEVcSQERWoEVrPidPscjBzZSjWa3d3U9rq4L2Hm6Th	7747	10961	10961	1617912180000
15212	3NKVGWX9KKSa55KTZ1vgeZQ3TNeEuXu94RCmhLS6jYMG1yHdL1RL	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1547	1378	243	6301	11263	jwuzkvxnEa1RcLRxDms5ccVFFtWU4jzipyje2pjtSd6aahBW6T2	7751	10966	10966	1617913080000
15214	3NLEd7FupbANu5odu4ejTqh8KzeQzFCQLrofDRdhTffc6cRMEMfA	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1481	790	243	6301	11265	jwx3qyFWRbbiocEwJi3J4XnhmtheuK5g1VEJpNgArhC1JTn7CVg	7751	10966	10966	1617913080000
15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	1542	1304	243	6301	11268	jxXo6eZ86qmqK9Lu7WbDUFaK6g5WPBgsY3sGgfrK86so4p2xJqM	7753	10969	10969	1617913620000
15228	3NKk9kkog2mtfJ2dYcPhMkbRQqr7NGSzthQ392WG9R7JWF9yygCY	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1403	812	243	6301	11277	jwQvZAZ14jBFdBqYzM3jpoRxYnjmVtfPkf2HeXDF747xLXznMWs	7757	10974	10974	1617914520000
15230	3NL19JjUEmfT88fgNaTALH9eN1NCy8M6gpzhgGqfmG5bME4w1ayv	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1590	1300	243	6301	11279	jxExiYHUft1hjYLLLbzD7psqiC9da4hKS7BRxxDVNaRikRmbkoP	7757	10974	10974	1617914520000
15235	3NLmg3iLTKrHFsojU8bF1V7HVShRFwXpvVnPs3qzbTpNdw8WSNKp	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1483	1276	243	6301	11284	jxKo8KrrW1AJ3joiQT4AAEe9wRvhaBdccJ1kH71SkLUWEuMfABM	7760	10977	10977	1617915060000
15239	3NKH6eWzMytfBnT7bxBQs69pBzexJZShZma6EYgm28FaxNkuikrG	15236	3NLDoNzYb6km9wCYTwGX3n3ozc8X7Acv3Lx6KCdHs3jGpVNuzYaM	1501	1234	243	6301	11288	jw9uKeZxRRs9BQpHn5uF4K3TnpKCRyyf8eTfTyqzouNXiMr18fe	7761	10978	10978	1617915240000
15245	3NK7THX1zyNcGbxuTUmHGQibH5nAyBYqChRW8cDsy1LdA3LpySqs	15243	3NLpuggKkeqG33pV1LGfSErA5mdvHpAugcER3zYq6cFQvScD1Jfm	1451	926	243	6301	11294	jwwAyaPx6cABqMQLpB7xLpBter2NQ1cWQRvHruiq5SsfeLdGiN3	7766	10986	10986	1617916680000
15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	311	1061	243	6301	11297	jxZc7iEn7WhShpWKgUD1T6cHHGMqVHYYdfgDPesXTM3Awuu9eqq	7768	10990	10990	1617917400000
15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1455	1332	243	6301	11301	jxqhjeph45dNntRbEntQCAo9JJJ9c94c1HFQzBrWAuV1XH9HGJi	7771	10994	10994	1617918120000
15255	3NLX28h99YkAo3gRa3ety3pwikXyHryv8ARUcaPptqYeHskD7P5L	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1419	814	243	6301	11303	jwbTXQ81uoULiGPsWmnPcSTa2iVZ3p3L21nYp8ijSJZBw4uKUXQ	7771	10994	10994	1617918120000
15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jxe9naWE9SYKGXZxEXHjryfjFNqwfZwxjs6ZMcQ3jSNTW6xFQ91	7772	10998	10998	1617918840000
15258	3NK8RsopNKu8PECZpwWbgW21sD4NQuLSNT49QDBD9kMDTeq22DLq	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jx8SoUcaaWXjiXv6GBzV12EZkGsbY2w93eH7AvhHNRSGiXdM1un	7772	10998	10998	1617918840000
15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	15262	3NLDNdgogrbaFUtMzgqKPHy5TSrzrmR2pxizcVNq2WR6upch8jgj	1656	1097	244	6301	11309	jwmo4YVG7qEvVkUrNBMwnyoShwXY8dz8w2GRwMNEWAN3871Jyek	7775	11001	11001	1617919380000
15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1671	1119	244	6301	11314	jxrxFKYpdV49vVAih14pveguL2xaAfWtpue456gGkkQPjsUpMoV	7777	11004	11004	1617919920000
15270	3NKPNeBsDTojt7tQ4pJZnfKNErbDMTe2N6ngvenZqgoLeZs2ByQh	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	1631	794	244	6301	11316	jwVhHLE1z9DFhDSW798H7CvYn9FfYhVkpFvSjpExVBtHhMNnMQ6	7778	11005	11005	1617920100000
15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	15271	3NLFVSMLyhFSdaShqD7aVGCSM3JTqgGeKdMy54BZpWHvfPUuqCH5	1529	1316	244	6301	11318	jxSSnoB9Kfc1eU13qUx83jE51uTbWc14zWpz3FzYRTswi4biJzt	7779	11006	11006	1617920280000
15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	1406	1393	244	6301	11319	jxoaJPTgp27QpdXKFdtbw6BCkxVSfHbmUyzhof996szE67Z8ggx	7780	11009	11009	1617920820000
15199	3NLhepFjYFY8FP4TME5yPMkZ4WSLgyeY1Cy623YvjCYXgBaejTDc	15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	1407	1395	242	6301	11251	jxiWZVqm26Uy1ThRCvnv3TbWena63exG6f874jBVSg6Rs6ayagm	7745	10959	10959	1617911820000
15201	3NLn1oqx2X9o52DWznMqC8cSmNd18b9VKmNtAxFUn1c9dh7HkhKV	15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	1407	1395	242	6301	11253	jxYX5ZphLL3dyGWDkfVV1pRQFbMfgGNCKQnMWDTBH4JT2hmngbC	7746	10960	10960	1617912000000
15204	3NK715qcJes7KG9n9C42GQhjeptA7339dMWLfY66HfaneZEsaweN	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	733	640	242	6301	11256	jxETPRLp7YnzveRtwWzJRkzh4Wb9NJrTEnbA9TmPW75reVU1oEf	7747	10961	10961	1617912180000
15208	3NKDKkuUaG355XtExorJyjmVRVVQpqSfd6uNZsb2oxdYajFmSP9Q	15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	1407	1395	242	6301	11259	jwHJ2zVPhGnfrwG5nTww6AKcVGPgqT7nXsYd3wWDYNBUhjDLLDZ	7748	10963	10963	1617912540000
15210	3NLahnWkKneGhEf5nBxUZ796dcwUqo7GJ5SVYFa2dC9HgzNF57bN	15209	3NL5AmpCmcwq3iBULGSvDvXvXXyx9xRBPrWrajBayMEPVq6i2vk8	1403	786	243	6301	11261	jxexdwL9Pf3kKHoyb4p7QnY2BBLDCzCL37Cs4cAMKMuVjS7B72z	7749	10964	10964	1617912720000
15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	1483	1030	243	6301	11266	jxSURBxLCQFHTytRbsftRpCpDkd2X8GAMebZMKphReuENh5aEEc	7752	10967	10967	1617913260000
15218	3NLZQjQcyxC5j2tVKxVfUFtQe98c2BRqgaS4ZbnDM78rYttaVgY6	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jxmCLaVwemmMVwDdqXmjvWjWBCn2ReDHaHAA6qxXTRBSJxxmTgt	7754	10971	10971	1617913980000
15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jwBKMUnCyvdm2ZAS24WTufoVb3V5PhGEBsnWMnCEAaNDKCbJ85L	7754	10971	10971	1617913980000
15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	1613	1103	243	6301	11271	jwRRwH7V16AhdSwJeaUUv8ygFBwrLDat6MLq36AKGHYqhN5WbME	7755	10972	10972	1617914160000
15224	3NKhQ87ws45W8d1dwhpboCbFP63vCS9m1PNX4Lm9bBefRPZrAHo2	15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	1633	1144	243	6301	11273	jx7qzf6tEPpD514n6NfAGLzetZ7BQyZPr6rTrke2uxSzkTtfLgM	7755	10972	10972	1617914160000
15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	15228	3NKk9kkog2mtfJ2dYcPhMkbRQqr7NGSzthQ392WG9R7JWF9yygCY	1578	930	243	6301	11280	jxMDJD7mkhWyQx3PNgvKsg8Bqh9u2ZfhU5YJLmfjoLaRzgsj3Wb	7758	10975	10975	1617914700000
15233	3NKA8CA3BihS7cF9zNtAVALX7GKLbEMmg2rDtTWybEvhGNuvjGrd	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	484	1073	243	6301	11282	jwPtkAbgnmwkCVGArPu7rG4HBaUktbLK8D2tJa7b5yx9UdvvHqF	7759	10976	10976	1617914880000
15240	3NKjr32HD9UVfHHmoNDFL8WBy73uT3qUbd5zWT2niBxFLSwZAn7m	15239	3NKH6eWzMytfBnT7bxBQs69pBzexJZShZma6EYgm28FaxNkuikrG	1403	824	243	6301	11289	jwsnJVaUMsn1aSrvsmqTUm9ioUXreGrEwmrrqGQbFAqtyftkCV2	7762	10979	10979	1617915420000
15243	3NLpuggKkeqG33pV1LGfSErA5mdvHpAugcER3zYq6cFQvScD1Jfm	15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	1553	776	243	6301	11292	jwJYFWt8n8d6ktHHcwXEVPuXYw5KSfjunQc3zzCiQB1wBtaUN2V	7765	10984	10984	1617916320000
15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	15245	3NK7THX1zyNcGbxuTUmHGQibH5nAyBYqChRW8cDsy1LdA3LpySqs	633	1258	243	6301	11295	jxSE3bqBuHs11U8zeohiuY7KgaBGCHY1bcDyP2kVAr28RwS7dQM	7767	10987	10987	1617916860000
15249	3NKYCCTZWYnPi2HJ69u8kX62AMZUrhQvMQk5GUQ1vAqmJ9KR8kfi	15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	1541	1172	243	6301	11298	jx3Z7fNjQAXep3xwowTfsp4D5VHQMHfAuvtW3tWoFxUxWDNEDXh	7769	10991	10991	1617917580000
15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	15250	3NKcipSnd4fWKyRBjiyopnReBQiLppSQKvrfSAt2ZS4cwcwpmq6C	311	1061	243	6301	11299	jxRcEYgHKvQ1rgcEN4B3fF1iq8KZAWErsauqssNWZCE7kkcb4EK	7770	10992	10992	1617917760000
15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	1637	816	244	6301	11305	jwRkwUQNWyYoM9Dn9aD2hv9QnCQvZbmuX8Au6ch5VJjuLBXqGHW	7773	10999	10999	1617919020000
15261	3NLwdxbCH5EgEdmjB28txQE5G4LyCywks8saSSqzcXDbVfjfKSud	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1407	1395	244	6301	11307	jws3zR9BXzcgvejo6WihnN57o4yUNhxumR2KAi7cpQ3h471eHjB	7774	11000	11000	1617919200000
15266	3NKsVJpgWrzRAwMD2CNcfy25abiq1xZbLCSw7pvE511eJqkHWUsW	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1406	1393	244	6301	11312	jxvahkffu1jPhVtr2SyXm4acPJ7vE3AMFJ9vpvfUtdENhErz8th	7776	11002	11002	1617919560000
15276	3NLpvTkUjvcqEn3L7wqy1qcQpZQqXKsE984uAQicbqV7oxVXSxP2	15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	1439	1033	244	6301	11322	jy1DfL4avPH8RHHHU3WNXG8Hv9JuCkXUaYGF93EPjzWRWYvW1G7	7781	11011	11011	1617921180000
15278	3NKHHVJi8A6wbYcNYcHnRQDtFukZPT453yoCWFvMEKMxt28EEkMj	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1522	1076	244	6301	11324	jxKoFXjdsy7vY3wt1Z65wxyEkQ7zzaePtcjcJUQ7mP946hyMAUP	7782	11012	11012	1617921360000
15262	3NLDNdgogrbaFUtMzgqKPHy5TSrzrmR2pxizcVNq2WR6upch8jgj	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1426	1238	244	6301	11308	jwTgKBRr9u8nez9bCccLyPfZje4dhXkmgB4GpvkG6aap36P8nvN	7774	11000	11000	1617919200000
15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1613	1349	244	6301	11311	jwH58jBVr5sbG6kt2SXJPszu4XkzUGZ6R5vePxCZkuR31xCEdU6	7776	11002	11002	1617919560000
15267	3NLDkKVY5x9jETed3fW1pdTMNzz1kQkS32TragzbspoiuTSA8eKS	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1593	1346	244	6301	11313	jwbgoNyDk84nWfm3FtLFadRfMFBaQd3ASnwnoLy7mD1qYUCRCVc	7777	11004	11004	1617919920000
15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	1406	1393	244	6301	11321	jxwwwuZmBbeu2wZZumQhtEwc3iGfMMxQgo99AJi33NogL1kvfkB	7781	11011	11011	1617921180000
15277	3NKuwb3LywU5C6PEETLUbz4WRf3w7Tqc69w5359EwoK9g15iiBYV	15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	1522	1076	243	6301	11323	jx4SmSNMbH4Cqr1qwscmQDrERohP7iyQ9VqhJ8jHJnozEYaTt8q	7753	11012	11012	1617921360000
15279	3NKBfE5HW3tKHuKqSCvAy2BP1bWbS3fTJpERwCcuzA9DAzrQJNWs	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1406	1393	244	6301	11325	jwcH5gsQcTLsLGMj3qbENbZVKJt4E6oHNf4N96n4MKfmAApxarM	7782	11012	11012	1617921360000
15280	3NLEVvaetQpgvh9uz5egcBnjkFH1i4sSA6qbS9eiJ6xZhoJhariM	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1652	1315	244	6301	11326	jxJWWE3UodvBDgmyUpoqAgRfvKbD8eC8DWR89ZeyzzkcTs9apug	7782	11012	11012	1617921360000
15282	3NLsiYeUaWxFme8fo2DgTqdCHnVJgHiERKJhFVzYMYcVMS8WaveS	15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	1503	1151	244	6301	11328	jx2v372E5aC4VrVkLUG4gaiyZ1XfLX8stS7DbAvFWvTg7p1VGP5	7784	11014	11014	1617921720000
15283	3NLWKGArDejyBUXyr9B6VvcamHH1sSUKdrpWanJb9aoBnveWrpfB	15282	3NLsiYeUaWxFme8fo2DgTqdCHnVJgHiERKJhFVzYMYcVMS8WaveS	1406	1393	244	6301	11329	jwQFkWF4DsC5hyN3XMLR5FpHW2pDoeSRp7Eu7eETNiqm9RU9KsQ	7785	11015	11015	1617921900000
15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	15283	3NLWKGArDejyBUXyr9B6VvcamHH1sSUKdrpWanJb9aoBnveWrpfB	1577	1081	244	6301	11330	jwDYK4rUu4KMHYK283miq6s9RP9ExYzBExq24C3D5HtLoJiF43N	7786	11016	11016	1617922080000
15285	3NLEnSWkFzxuzBctHTZtsEhmf7Gi1eahRVfQvkY3E4MmESTseec7	15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	1407	1395	244	6301	11331	jwbYvxxMHH66vFdjgkxXb6YNL9UEekTrK2P7bY3z2PYdCEJBXQz	7787	11020	11020	1617922800000
15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	1529	1316	244	6301	11332	jwj2JnC3LzHmokUjzrFpKkLQZ85SuGHYJpD6UUi3NdAMfK5RFz4	7787	11020	11020	1617922800000
15287	3NK9NKrofqoiScuVc9xm1aWFVes68br2hT5Tkur5zaDxAPBx5Hab	15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	1500	931	244	6301	11333	jxNNHKSoKkJeTp86VzFmignRxNTdGVjp6ZbHra1cExyy6t1PDyA	7788	11021	11021	1617922980000
15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	15287	3NK9NKrofqoiScuVc9xm1aWFVes68br2hT5Tkur5zaDxAPBx5Hab	1406	1393	244	6301	11334	jx9AdAnHSsLuhyvQkFB4LZTjMKVQU8kQ9kSHq2W6GgikA1qM3iK	7789	11023	11023	1617923340000
15289	3NKVMezU9uRHq97z96ZPXiHo7EQuipVvk9533LiFB6UehZgKJzSi	15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	1407	1395	244	6301	11335	jwUVaVc6dfNbsqTnFEqkGxcYPm6zGghDeR6rmE3EvdU63KoyXLw	7790	11024	11024	1617923520000
15290	3NKg7vfpQY3hUFSN2wNnWQJ6Z2qXvhvwmAwPdTkwonxoXE1oUnA1	15289	3NKVMezU9uRHq97z96ZPXiHo7EQuipVvk9533LiFB6UehZgKJzSi	1444	1255	244	6301	11336	jw7Hg2Fdi9LdftdmK6cdc7xgu9cVMduXGsBqmt3XhtTX5tWAgLj	7791	11025	11025	1617923700000
15291	3NLmjPnydJBKnmLEBJhaMPbdPd5iKFwkNRLGUrMVXWyNKxzCx4kk	15290	3NKg7vfpQY3hUFSN2wNnWQJ6Z2qXvhvwmAwPdTkwonxoXE1oUnA1	1445	924	244	6301	11337	jxNrQMX6FVFdvdfL7QZAWTBgdHsZzg7p91y4wHaWbssPYMaicfS	7792	11026	11026	1617923880000
15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	15291	3NLmjPnydJBKnmLEBJhaMPbdPd5iKFwkNRLGUrMVXWyNKxzCx4kk	1406	1393	244	6301	11338	jwSoi9nWvn5yEsRusQnF8SuwHQUijCo1AgbHiaxdT1ziisVYV2b	7793	11027	11027	1617924060000
15293	3NLQbPnB5V8Y4A7mU1zaqxt845RZq1DmcepS6GKouWhrTFxF1nHR	15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	684	1226	244	6301	11339	jwPjzuMTvgjRGy927VfrGv1UiCMBi3qvt9SAiEyevS9377X6mHa	7794	11028	11028	1617924240000
15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	1513	1379	244	6301	11340	jxQM88KRz2aquUnDGyXnCYYJ6VBBAfjQKJXBPKhyBazckA5epRw	7794	11028	11028	1617924240000
15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	1451	1292	244	6301	11341	jxFcTgbnu6ZH9GertyLA6keGaH1uKtKFFXHCpfAUA4BV1nSaT8v	7795	11029	11029	1617924420000
15296	3NLg9jRhjTTjzdvHsvWJqYF8g1ejjZoa4NpfMHh6gohCAx4usuFB	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1588	1146	234	6301	11342	jxbf1D4vSr2yFh4HbrJVKA4gbDcQczEcEgUaD25kGjTVAPGBLUG	7530	11030	11030	1617924600000
15297	3NLu1WaoK66KA6zPLtnC686YDgtNd3HD9P3Awx9zaUAtmb1rcVbz	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1588	1146	244	6301	11343	jxoRv66NQ3Rtj8XPpnw8Yn7PdsqaWwkTDJXKd9cxFb6jTDpWWxS	7796	11030	11030	1617924600000
15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1447	1345	244	6301	11344	jwj23nxMxdS3UbPz8u7Q9pXXHX5rGQGFHc17xDP6txVri7wpdnD	7796	11030	11030	1617924600000
15299	3NLfAzDgJFt6e6GUMFBWgELtJWWZ2niaaUuZgZLxknJwpCqekNAL	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1534	1317	244	6301	11345	jwCyebHKbuTsoRFKCAx8xCQYgky1zxqz1ZqqNVzBFQFb9EHoMjk	7796	11030	11030	1617924600000
15300	3NKyqs8JSuhtMYodwi4KAF74XNFjnz87qUmJ2PLaYASnkuR3rPgB	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1407	1395	244	6301	11346	jwtyBHMJJFdw4ZE5jzUFCQUfPFXZdZ7DXKaXHytkLw7frr8Xuex	7797	11031	11031	1617924780000
15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1647	1056	244	6301	11347	jxLfnKKJVhG5Yr99HdqAvxwviBAkEKL3f5ZNB6CrTYbfrHNh86K	7797	11031	11031	1617924780000
15302	3NKBEvJNpvBPYAWbVGjLZDpkzgGQvT1dfpfx65SfMLnpPdwF3kvW	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1509	1194	244	6301	11348	jx9ytSx4FSjjieCGwofxisnroCZ5RyMbgqGU5CcUZyAsFGw9D74	7798	11033	11033	1617925140000
15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1407	1395	245	6301	11349	jxLpSP2QxUrB7xRudPkefK4odbKVPD41HEMwxej1p4ZdzRw7wMw	7798	11033	11033	1617925140000
15304	3NKYEyYthqDijndoNeT2RbteRWzjbX6T8krRQ4vvPMsjq6NoEnwW	15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	1509	1194	244	6301	11350	jxu1FwKvJeBknQXz4x84yPm1E2ULVh9ZSp99RKMX8HhMW3nWihV	7784	11033	11033	1617925140000
15305	3NKw4HzuYSbvg8U7WmXpCuSsGmYpEo7xVUppt8yQjLxWCmEPxYcF	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1509	1194	245	6301	11348	jwqneEBYpKB5DMVLu57mMLPTCMWQjjHzYTkrMCsu26f5cqwQDuT	7798	11033	11033	1617925140000
15306	3NKxi9kaREwDMxw8rSDXNKGFBJnzgC68nHqRrNn1ednbD8C4nugc	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1406	1393	245	6301	11351	jxKmgQCpgpf4ZLpjD56Gxgjq2nFhFEN4X6KUNNnWfAerHJcJhT1	7798	11033	11033	1617925140000
15307	3NKwHv3tGpj2sVk7yHMRxQuUA9CcR7j5KEtmi2MQWaRqfDixu4Uh	15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	1405	891	245	6301	11352	jwq2sV9217zCACvhKX1qgW1Yy1uaGCqkBhgKCmVfZLeCo5TJSnF	7799	11034	11034	1617925320000
15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	1634	241	245	6301	11353	jwmpDVugLeUpDjT27VfxsrGrtqKKJ3oVHKgN51x2wpuZ2AwnCdQ	7799	11034	11034	1617925320000
15309	3NLp4thdyUTAy1DkjtFiS7UWw36aRXEz3JzURNV2NLWNUwgzStse	15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	1407	1395	245	6301	11354	jxd8mVXZeQnapAB6Jzb4gKJX4tmSyeg2LDk5taUgaAdHfNcWKke	7800	11035	11035	1617925500000
15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	1406	1393	245	6301	11355	jxPygRye36rrQZJJrK8KmCZGxSYcFRGwRdDfhkRdtRdkZS4s2Ei	7800	11035	11035	1617925500000
15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1600	1372	245	6301	11356	jwhYqskXhKNdxzTSoFtvJet52bU2a7wPH6y1kqhSDDJVwqmbWRU	7801	11036	11036	1617925680000
15312	3NKoZt42F2joitBzyz8Ckig6WWt2WSXJWshBBcvWxAj474QzzgSA	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1477	1104	245	6301	11357	jxWoLpNepCMxYYgqmGGa2DWABHXgQNAzammqLKHibWsHno6fPhn	7801	11036	11036	1617925680000
15313	3NLdzVAByva6e8nzz5c8c9ahoT6GYok2SUtJXqyL5YuXWZPkrdfz	15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	1402	874	245	6301	11358	jwYz2skuJBMgDYHayxtem2W6Z71cphxeqYjcUtG8G46QsfWBL5r	7802	11037	11037	1617925860000
15318	3NKP2Pe8kAo8oZvc38EU893os16Mpj7i7sJgTbJMDrHtQzPXLvD5	15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	1403	824	245	6301	11363	jxksyFmdzqPoCBYRPF3wzkNbHoT8f1dgzqVeGgV7zCTgEq4pUfT	7805	11041	11041	1617926580000
15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	15320	3NL1TF1vfuErubaMHG9VrVzxvLhkBxsSM2gEtDJS2ioba8zrLRCF	1608	1289	245	6301	11366	jxh8bLQHiZFysNzFu6eSFjyPpECXWxqFMAvjdoV6VGiD9w6uWbd	7808	11045	11045	1617927300000
15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	1559	1353	245	6301	11368	jwri5DzGePERXtwZ6M6hEnXVQQpXixgJvL1fzFgXrbLC5oM5Pkj	7809	11046	11046	1617927480000
15328	3NKSWAvHD7zSdsSm736Y3eRuUmgHkn3CZG6GWMMKNX6KYTDZPbT7	15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	1406	1393	245	6301	11373	jx9bp76vLBfWgMqb9gauf5DqtQEvxbtv8cNMb3LpBRaeHu2cZbA	7812	11049	11049	1617928020000
15331	3NKB8dmXZmR1R66RLY8PK7JPw1tSPTskyE4XzVvhFYVm5eNfkgTt	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1596	1117	245	6301	11376	jxXLTczihRkd8jrqnaTQphnns893w515qpVCHU4g5L6xDwtnK5c	7814	11053	11053	1617928740000
15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1474	1083	245	6301	11382	jxUVLYFxCiqRctTDeQpdp5nQ61VrCLaVuehDfYnYQgokSyEuL4J	7817	11059	11059	1617929820000
15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1506	1127	245	6301	11387	jxuo36myK59KWHtTRpb46M5AmvkHC7zLiVVyg1agWPc2TW8vtBQ	7820	11064	11064	1617930720000
15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	1602	1243	245	6301	11389	jxpm3PuwE1Fdo5gfafHxD8jjBpmLVBBthrPFfn1m1q9Cz9CXeyS	7821	11065	11065	1617930900000
15348	3NL4mgj3dBVQ5JndqABWpJsQn6pEEZZ1zUjMPmcW3fpurTM6YPtr	15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	1542	1058	246	6301	11391	jwM1yFtjiM3U9W9WNoGcptUNj6b3aeiovNbfgqAdsVPc5XsMt5w	7822	11066	11066	1617931080000
15355	3NKcQJTrrg1pvmt7zrtFN7k4DUcexvvjeuRgYx1bVLWGzG6tw6T4	15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	1448	1185	246	6301	11396	jwJUgeM24fGoVrjugdGNMphHqouK49J74B6tTbDM7x1XGYosuz7	7824	11069	11069	1617931663532
15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	1589	1040	246	6301	11404	jxF2Czs7yPVwqGbDzxgnKA674Us6Rna4vz4XU74NuPHpxQaYyza	7828	11073	11073	1617932340000
15366	3NKcm25XtoUCwFqNpN3pChAfJusPP5UgABxK5dBJUTXMsrR8g2uo	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	1406	1393	246	6301	11406	jy3DW9DnhS41o23m7ma5uo43JF1fZhMLTpP7DwTohE7oJCk5p1o	7828	11073	11073	1617932340000
15371	3NLDBkZUfw6svhEu6ivr4LBpAhuFvuMc7rPBKmAnbXixMDiqkF98	15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	1534	1191	246	6301	11410	jxF28f2WaEskSqJisvfit8ChUYSWbwdD2p39ngJasE7e2LfHQeF	7831	11077	11077	1617933060000
15373	3NKespijr3RMDqVVq6Zwy3m5epRYBNHZsq2eUsgYJMMGkY44c3vp	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	1634	1085	246	6301	11412	jwEAwVaKaVTyyp69BakrM2F14C4ihp9fnB5Ead8BJzVvxZc77Ha	7832	11078	11078	1617933240000
15375	3NLkUXjmn1nKgLsPYh1pWWgY7XRiW17G8hsF6yK7P9cB3Uu7rL7K	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	1547	1378	246	6301	11414	jxCYTo4My2ubVzYLH2tNW1BoJrK7bkRbQkvji78jKY9YP4vfX6x	7832	11078	11078	1617933240000
15381	3NLjAtSbeZLp1GgKwvUaGDoZ6jfPozsNreGFJCjJymCGRep4emYA	15379	3NL64LRubqoENJmkRVpBnkxpHzTUkqntkYacSRpANEHRGiUi6cot	1403	824	246	6301	11419	jxmALC51zC7CDmh4an77Hmt6d5JxwxvSb3HjdNYaSWxePu5M6CL	7835	11085	11085	1617934500000
15383	3NKggisTYtqptKiqRgGJNpX1QCtidx8SEymcFeqd8NUVzJMfYUjy	15381	3NLjAtSbeZLp1GgKwvUaGDoZ6jfPozsNreGFJCjJymCGRep4emYA	1406	1393	246	6301	11421	jxUgS2mDw6hrxm7d5jjHxMMupxpk3wjj8xYLPfudeRG3npZAYuB	7836	11086	11086	1617934680000
15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	80	1027	246	6301	11430	jxAK85f9P5vN5RYjxmsZN1LFK3UMXs7iHzQuAkG8ZBubG5E5z1D	7840	11090	11090	1617935400000
15394	3NKdEfmAuQCykAq6xfENyEZpy7fvEWE4gfruKkZLTjQct8dL3RAW	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	1541	1172	246	6301	11431	jwLjFe6YNGBeZnoKuykEfk9A4mikTwQbCFsxewsTfdQQ7CmADY7	7840	11090	11090	1617935400000
15400	3NKkNLVKYN3rbGEg3qsVEdGXkEyftTQpMqX4XDo7Nmxabc6q4375	15399	3NLindUULaGhTCF5WELC5uryCD4fi8wSVHQ2nYSsy2bB55GZTauw	1476	1371	246	6301	11437	jxC7xEwtZwQPjQzfvnGNgzHjXHRZfGW8btREvVBF5Qqa4j3sksj	7844	11094	11094	1617936120000
15405	3NLWaUqfj7jB6CHb8wT3UoNsgUQNyy7dKUvSe4C6EFNrd8M17Xo7	15403	3NLTi1SPmixX6A9BFGRMpyNfnfx3fv4ucXHh4L5BGxPu3UeAPoTM	1407	1395	247	6301	11442	jxasomkJKe2rGqSCPLpw95v3nUkTeGWRep9H3Sv7F3374BS1pw6	7847	11098	11098	1617936840000
15417	3NLujZRKNWqgoMyHpcJHTypLDu1AJ7G2bGMiRG7TKDrq2GGWQ21L	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1652	1315	247	6301	11454	jwGfVUmZHkfb8jiVdsKZ1et6CchSFtU9QaS5YjuMWyDhiBLgZer	7853	11105	11105	1617938100000
15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1631	794	247	6301	11459	jwocRNjEoALf46E5wRAmR89YRznqe6yWLTSNLZBDS22jeVQDffz	7855	11108	11108	1617938640000
15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	1613	1349	247	6301	11461	jwfd9dzd1SwNE8tRLNCmVPzYTV4X4ZfwEysNmdKQuNGmL5m1zAF	7856	11109	11109	1617938820000
15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	15432	3NKy7UtMhJBXhMFhGwi2gnWrb5mp5AaxHTp6pjo1syGpZgLAcS3s	1483	399	247	6301	11470	jxTUeUAfE9WSfRCGMba4xSHnWb32VW6J8tCKiLaeFkPBGjtrz1V	7861	11117	11117	1617940260000
15437	3NKk23Pa6D9n5STtKUtgDwAsTTz3GdtEmzkbckkP94Av7RoRycpX	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	1406	1393	247	6301	11473	jxs58snxoJYXKVukZfsjCNfk3srYXoNag4r8QP2zYutKmre4oki	7863	11121	11121	1617940980000
15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	641	970	247	6301	11475	jxWaferqm619mBxHMyTWuN8fQBGLzbSvJHW1MWECsVkVKVuJJTG	7863	11121	11121	1617940980000
15441	3NLi6gw44rXAvCDovS62QNDzChG9K9pZDPFRoyrdnoy6cu31K4a9	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1447	1099	247	6301	11477	jxvY2fFRzYKUvrNFtAXoM4qAUcse8A8u373oY9DnXrmttURy4Rx	7864	11122	11122	1617941160000
15443	3NLX5YZJQAAkrZB5jrPBfRJxSeJHSsh5orw5bqYHuvSUXRaBxU2y	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1529	1070	247	6301	11479	jwfVFv7LrgDGLn16zdpmC7LW8de71KHdhwPFWmPCKwQNsTgF9hU	7864	11122	11122	1617941160000
15446	3NLBqkTMooxzUVsmh6UJiYzYUEiuNx8Cp2auZaGdHYNv7fT6XPuX	15445	3NKLiDpK29tqabXJ2GBc9Ce3GZDZnngCBYgEJ8mokzxPX9Uui6Cj	1407	1395	247	6301	11482	jwwp6o6Loz6pYk38G6GR2u4LLBGPMNKq7sBrrZLtacoFeFfka5Y	7866	11125	11125	1617941700000
15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	1406	1393	247	6301	11485	jxKwiXcmS4RsM5ZSEoUYvhh3EwfpD8KCR92LKggpvWJc8Mv5cLz	7868	11129	11129	1617942420000
15314	3NKi69QMXyCrmViawpT1PMcdqXAvSTpdar3YSptQSuPnmAQJSq5P	15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	1648	1284	245	6301	11359	jxoSWKsHDk8UryqHgjLfXUmSRgq8x7sm2WMe2K7q6o1KskNA76g	7802	11037	11037	1617925860000
15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	15315	3NKkyXUaV9KgtB8nEnj1D1sHHDyXcJoj7RFKkr2TxLJsufDuw4ye	1613	1349	245	6301	11361	jwJUd4GDisXuq7UgJd6iX23tfBZdrHRev2GAymRgbxBGsUFZPYK	7804	11040	11040	1617926400000
15324	3NLxz2VbEUFNR9xtFornX4NTTa74nXbkQRfbQugiqvnPpqbaadUh	15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	1637	816	245	6301	11369	jwMGFL9oq3zvcBfTF2MD2spZ49Pihe1DXVWVU2VywxJNHpnY1Fn	7810	11047	11047	1617927660000
15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	1402	852	245	6301	11371	jwcqmUQ5uLKoA5G6ZgmqV39n1Fg8hNPw3LxhuGMxagrdmHPi12t	7811	11048	11048	1617927840000
15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	1637	816	245	6301	11374	jwuuXuwaJ3ytShesorJrxecQNBFMs9GnHXPWYaYJbvpjwcWz5MA	7813	11052	11052	1617928560000
15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	1609	1333	245	6301	11378	jwpjpDAVHiEvNSMQUFTBdRVVXugzk4k6gkUq63o3B9vwyHp1eYW	7816	11056	11056	1617929280000
15337	3NKTNVb9uomhogcRu6JGPveU7LCufCeYGvhDKMpvdJ3C8SJ1ztaf	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1406	1393	245	6301	11381	jx1ovr58S2pRocR8RhHdKK8yfqxbvvxUSkcf5NSv12qgq4zp7QN	7817	11059	11059	1617929820000
15342	3NLUVv44XCYM2Brn3y6FXxbVaDmaesqDmpSWgU5wYAPj9X8ekArC	15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	1406	1393	245	6301	11385	jwderXq2R4ser4GKcN3YUV9FGDVHkSjm67D1FDXhoQCsSDvGU6d	7819	11063	11063	1617930540000
15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	532	1177	246	6301	11392	jwjcF9kGJX6zZg2pjHwo2pic75h5aZtGaC4o1GjQPwXqY4hBrYv	7823	11067	11067	1617931260000
15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1600	1126	246	6301	11394	jxwvmWpbaexyFKgqHLpQuMsxk4iGXuVabWXNcyADYhKLH6uEsSJ	7824	11068	11068	1617931440000
15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	1670	1282	246	6301	11400	jx4wAEgSg8RdaQ9ExpmhmaJwegv6ae3ZSJv88Ky6P9HekoHYmVc	7827	11071	11071	1617931980000
15362	3NLezAVdkpn6aGTPGnQqqMNt6hHW7ZiHWw8rbnZ8N7xTSoprC291	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1402	796	245	6301	11402	jx1G9yJK8B59SZm36TYfrJjKCfMrwSRpMTXiP7LANN5qsZLt9rG	7820	11071	11071	1617932012903
15365	3NKSaLKCY7vxX6pZtpvNMPepucs6QzsraSAThAQzYnjK3uvXbTmm	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	532	1057	246	6301	11405	jw9nzHXUYEhaTgG1DWHr8JhTfoRxw7KDUXu5DA9qENGqupNZWDd	7828	11073	11073	1617932340000
15369	3NLi78ycS42uXGmThQqN4VMPjxRmxEFn9wtQrEt1LZ17RvFzgPWr	15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	1406	1393	246	6301	11408	jwhvXzaoAUHfLrLMLWu4pwmoJD8G6w2YWkKqYhkVi12ywzNxsZj	7829	11075	11075	1617932700000
15378	3NLfoJTPg8wGxMUVDRYBSiMu69S7NQWVqdDfBJJf1Sd8ZLEiDcgr	15373	3NKespijr3RMDqVVq6Zwy3m5epRYBNHZsq2eUsgYJMMGkY44c3vp	525	525	246	6301	11416	jxGcyPZSqtWS5dfnAeULDQfScBBUahHrJ1FW1kVnhub8H48Ljsc	7833	11080	11080	1617933600000
15379	3NL64LRubqoENJmkRVpBnkxpHzTUkqntkYacSRpANEHRGiUi6cot	15378	3NLfoJTPg8wGxMUVDRYBSiMu69S7NQWVqdDfBJJf1Sd8ZLEiDcgr	80	1147	246	6301	11417	jwRTUmnavjpMPZxtX7g6guLdFEovHqmgYAvsAsFx4fAA26xd9q3	7834	11083	11083	1617934140000
15386	3NLwCiumnEd8rNyXhPBjUbdTwPZkCNC3MmgTRYGvK5Bs6rb4UxhD	15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	171	1128	242	6301	11424	jxPQRLdFzwpWF6PBgEPbtgBbTt9o4DhZ8ECwNYLQL1pKVTnFuPs	7728	11088	11088	1617935040000
15388	3NLZoNFaFT5pJir7M4EeqTRMsSTGGhqAwCVZ7tPwasUY2oi8FJZJ	15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	1643	933	246	6301	11426	jwSAn8u9NBDd71Uj4gSGioigpxdocyLprXQHpeXndBXPfmNNjCM	7838	11088	11088	1617935040000
15390	3NKDZtSXivG1v8FZ9wAQHr7xK8mjVBNxGrW8of51DKXG2MEFn7PD	15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	171	1128	242	6301	11428	jxcJ6EWS2hfLk5MWsvaM4bqVeeHtsUuMfjoRRPdQfEuj77tcTYz	7743	11088	11088	1617935109325
15397	3NK7tgRMvmSNd7uSrcp999g8kmQPVtdVw6BgN4iTNnDmqM1VV46t	15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	632	1136	246	6301	11434	jxfoPbn1Vtjz3vuMrKgu4GLagyttq3r3F6coJZ9JUDFvQ2JWW2z	7841	11091	11091	1617935580000
15403	3NLTi1SPmixX6A9BFGRMpyNfnfx3fv4ucXHh4L5BGxPu3UeAPoTM	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1406	1393	246	6301	11440	jwQkd7QMjso8sN522xeJQ3NbZKYLASaCJwKmxxPxovqontAckWN	7846	11097	11097	1617936660000
15408	3NKHKbHdmRftAL5Y3YcPdaH2zdi55DdaT3mhn4kULsTaFj2e9DA9	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1668	1124	247	6301	11445	jxTTxbvzJAD7K5DECBbvvohxFkMsPTRnaxznyfT3uNMuECQgeHP	7849	11101	11101	1617937380000
15410	3NLNSmTpZwXLdZVCaQejeZK8wPDDAWko4GJnYxVUq51v1D5DLcBd	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1675	1342	247	6301	11447	jwiavU7Gs7iKS5GFMuBr3CzjVNMzYpLRU3BDXX6iFyaKPb8SCeu	7849	11101	11101	1617937380000
15412	3NLLZdr13fb9EuPTZAGv81QH313EE3C3bn4X9fuKmRUgsbUSWbNX	15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	80	1027	247	6301	11449	jwssdzpuX6pcMT1L4UoYx165wvMPbgj27pBmKPprxsh7xpRqisH	7851	11103	11103	1617937740000
15414	3NLtD2Jf3w13xi96gz7BmfooVGQkfNvDENk6rxxUBEQ4M62yijAF	15395	3NKDasDzrVo5ZEi59fJLE7MMqVuggY9o8bFDhiFL7s7QzFzf3XCH	80	1027	239	6301	11451	jwcWDL7TQ2M3cjd82ucF7AxkJjRoJC1eye6PB5fiGdot3bnkiQA	7654	11103	11103	1617937740000
15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	15418	3NKty5dYKWugFY5A3RApzGJkDZpXoFHi59wwmew1FrFJczcHonc1	1577	1081	247	6301	11456	jwquDM8wdzPZDJsuhj6zLV53p7YNhpbcRKVuEKyCE4Ggr5o2WUm	7854	11107	11107	1617938460000
15421	3NLC45tkeqcHG2yHTomt2pu2wRXtyBYMhxmgLxqB3Zqe5wHUrKFX	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1501	1360	247	6301	11458	jwrzvu2s5VcniZhwTR8Wo8ugPjq4jbfDuLcmaJ9s83z2AEvDae3	7855	11108	11108	1617938640000
15426	3NLrvL8i8N5JbGVig4m6PcqwWQRTDPrNJPYR1F5xK9UShSNWezQP	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1403	824	247	6301	11463	jxYLpXPKDbbfvQ3uw2627ij84G4jBU3WkbHdoJbPA9V1k3DR1BJ	7858	11111	11111	1617939180000
15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1617	1288	247	6301	11465	jxXtnZSXpvYzQaZH2tHoNNc3wCEzusnSkXuDseeyEtgTqA47MBy	7858	11111	11111	1617939180000
15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	1426	1118	247	6301	11466	jwgMw3gdma8kLXAB5GDEBTYgfXmpMLgegsAomUk6KLZfdrVFio2	7859	11112	11112	1617939360000
15436	3NLrwDvAAQDWFHHrCeNKqYeEqCYZ25MDZzz2jfVqnRQHXxiujCGp	15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	1406	1393	247	6301	11472	jwwjRtDtJsa9WJTYPc7NN4jfRbz8AYrmd2Vep4AJsAirZP2qXXL	7862	11119	11119	1617940620000
15445	3NKLiDpK29tqabXJ2GBc9Ce3GZDZnngCBYgEJ8mokzxPX9Uui6Cj	15441	3NLi6gw44rXAvCDovS62QNDzChG9K9pZDPFRoyrdnoy6cu31K4a9	1439	913	247	6301	11481	jwbVe9dQFhY9B9P48j2947riD7qj8oWkkXcSE77F6W8WcPiAk3G	7865	11124	11124	1617941520000
15315	3NKkyXUaV9KgtB8nEnj1D1sHHDyXcJoj7RFKkr2TxLJsufDuw4ye	15314	3NKi69QMXyCrmViawpT1PMcdqXAvSTpdar3YSptQSuPnmAQJSq5P	1553	776	245	6301	11360	jwNxTbptEBJCWdYAgFsPeMxgtyqX74aCfy45gtZyEpBUGVnWBZM	7803	11039	11039	1617926220000
15320	3NL1TF1vfuErubaMHG9VrVzxvLhkBxsSM2gEtDJS2ioba8zrLRCF	15319	3NL4WPHx7TWRdZgKU3id7b43zQNhwFew8CAAAGsDUAuLkWfM2g8K	1589	1286	245	6301	11365	jxRSEDo2gHP7QGgK9WoBUAi8yD17otLUfmyNU82NcmdSwkjM15n	7807	11044	11044	1617927120000
15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	1627	1259	245	6301	11370	jxfwhcm8Z5orduKcDg7ftutCAd9z47tVTwHzRKt6TEhrkV6weCT	7810	11047	11047	1617927660000
15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	15331	3NKB8dmXZmR1R66RLY8PK7JPw1tSPTskyE4XzVvhFYVm5eNfkgTt	1440	1131	245	6301	11377	jxvTjvTxp6t1hZwFUf44hag2MCTj2kgzLADkxEhgRxVCGBijycE	7815	11055	11055	1617929100000
15335	3NKLzS6H9i3GQ3QTvitKq4dhE5ntu8gYJ7DKKQ1iLrER69PUkfMB	15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	1553	776	245	6301	11379	jwjYaDJUsVMM2zHPPaWm8xzmCEMR21SSLbgy9eR6UVwFAa1B4pd	7816	11056	11056	1617929280000
15336	3NKWGR1Vj4KtWpMg8QWL69azUMUSr4SDqhzRkghnX4Wpyykohtrm	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1648	1284	245	6301	11380	jx3GVpbMhkjEU5uboiQ9hoqUx5DuAK4Y9q5UVKM1Hzj71aTWpMS	7817	11059	11059	1617929820000
15338	3NLejz2o5AFNrAHsAg2cbFvTqtquJTL7xHyby2mYZT3YKciBaQdv	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1474	1083	245	6301	11382	jxQ6Jgtmomb8qPF64dfMHvMDNhxvEZxabHPveFBCMshwE4raWjp	7817	11059	11059	1617929820000
15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	1622	1356	245	6301	11384	jwVwMdZnoyU3FNmW4PqPDnYht9B8AnQ26GH6WkzUpGvqjktKevU	7819	11063	11063	1617930540000
15343	3NKtAWzKar68HC4PSam2mSq1NPfqocNQXvL5zriFEgLBkF5TRnyU	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1407	1395	245	6301	11386	jxq6DuSQcGdZDGTRVpJbmuEPiWAShkpRvNHDKMpwJ4JK6oLZky5	7820	11064	11064	1617930720000
15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	532	1177	246	6301	11392	jxCtkQoXHK4CotCUxVp3w71L3wMwiwYxP3ieHGpYQ84NmWh7HQe	7823	11067	11067	1617931260000
15352	3NLQUwXHQjsPa33t1CEWtkPawn67mUMkW79YfvNjGtaiMY5PZHbX	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1460	647	246	6301	11393	jwHFKjLtMpEsWsrsSF2Tynq7oAiC82tyZ18TXkzmqbvhopk5Erj	7824	11068	11068	1617931440000
15357	3NLppi4GZnA8Rykn5jJt9rYVWjuJWdVyLMWnBPcbKK6eV41MntGg	15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	1448	1185	246	6301	11397	jwXjkwbMzqUB5p3LZSmUkAXt79hzvAEbAPU4W8KmUo2wWoQmKXa	7825	11069	11069	1617931620000
15359	3NKMDL8U7DbckmetdYPJaePeoGqzvc396bqNoH9cp3Px1pdaXLYx	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1670	1282	244	6301	11399	jxcmMpyEJ2AdQHLesWQfsFmvBrUbUVkWy77G4xi4LJ2ZPr2vsLC	7797	11071	11071	1617931980000
15361	3NLJwxc7j9BZCRRqReQn7M8tHPMyQw6pUUUfb86yFfNx5a3HFwVz	15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	1581	778	246	6301	11401	jwKsjKy8DRnKXTA7bTfkpeYZRS7geZDpFdsQH7NT7nuzDERrVhZ	7827	11071	11071	1617931980000
15363	3NKUux9w2eDmKCk8iwZpqhB8od6Cu8vs1FzEHB1nB9NviAsv4pEt	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1402	796	246	6301	11403	jwYHzhMeSubGCPx1kATb7qB1HHW5EHNoXLnKR2uny1AYpL16NZS	7824	11071	11071	1617932054627
15368	3NKvaXEcr2PaZhHhN2JTYCnhRBhRiGU5sVk6gNUZA4pzx4qtZ3kj	15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	1607	577	246	6301	11407	jxw5tZV4XGqkcSCb9qyBoBWt7U27nR5VdLgjV86wuygu5sunzp4	7829	11075	11075	1617932700000
15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	15369	3NLi78ycS42uXGmThQqN4VMPjxRmxEFn9wtQrEt1LZ17RvFzgPWr	1631	794	246	6301	11409	jwgjehhpno43PssXScFhFTzkK6TijxUeSgCP2rWsUXJsJNCrtRr	7830	11076	11076	1617932880000
15377	3NLMTYhpaFbrR4wNMjK3gx7da2f47KegLBnWXdBhmDFqkGSYKY1k	15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	1513	1379	246	6301	11415	jxLiy89vm9qpCerbQzmRPBJBmfeuByx8dbgX4WEn6Q9Mtqn9NVq	7824	11080	11080	1617933600000
15380	3NLwPQczAE6CrHuff8qHPE7JAAQ4r3RKWzVxnQNcp5rqe8XZvx5L	15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	80	1147	239	6301	11418	jwnTD4qEoCzoNDmKs4GokBwSHqL2VHPW6qo4NJ82SiNXJ4yJAr9	7652	11083	11083	1617934140000
15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	15383	3NKggisTYtqptKiqRgGJNpX1QCtidx8SEymcFeqd8NUVzJMfYUjy	1489	1380	246	6301	11423	jxzB2okUfF6PAHr2qYvCSxjzm6TzxbJQHzJSdQ5ogh6eAEdLoZS	7837	11087	11087	1617934860000
15387	3NLQvvHZLnkiKNVqr4SZesWSL1xnD7pWcNuwrCqsz7nCGbg9tLy1	15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	210	210	246	6301	11425	jwCporX4NGH3MKZD8t1TP7WUgWtGkY7eKpySzKBSpMCiAHjfc5J	7838	11088	11088	1617935040000
15389	3NK4sgxu4LcqXMsvtX9YyQqx3DBZ5PqLv8eTS856t2vBhaNHUe6k	15300	3NKyqs8JSuhtMYodwi4KAF74XNFjnz87qUmJ2PLaYASnkuR3rPgB	1590	934	244	6301	11427	jwtyBHMJJFdw4ZE5jzUFCQUfPFXZdZ7DXKaXHytkLw7frr8Xuex	7798	11088	11088	1617935040000
15396	3NLuURAL6PBo77hQzDoVyZEwsqENiK9AvK8RyrUf8Hy6P1X7nntt	15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	1407	1395	246	6301	11433	jxirpQnHhaCdmqx6yEcdwwCCafyZ76j7fnJsERZm6vExUgTWANY	7841	11091	11091	1617935580000
15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	15396	3NLuURAL6PBo77hQzDoVyZEwsqENiK9AvK8RyrUf8Hy6P1X7nntt	1406	1393	246	6301	11435	jwVCQ1kNz9DfFd5Ar4Abj731hvdQKFp9TvBbCEHzPhHMDiASq1z	7842	11092	11092	1617935760000
15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	15400	3NKkNLVKYN3rbGEg3qsVEdGXkEyftTQpMqX4XDo7Nmxabc6q4375	1602	1369	246	6301	11438	jwxTqyeS76cAXLtWLpTZBKE9z7Ed3hifkDVXvoqL8CwJkEPtPDu	7845	11096	11096	1617936480000
15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	15405	3NLWaUqfj7jB6CHb8wT3UoNsgUQNyy7dKUvSe4C6EFNrd8M17Xo7	1403	824	247	6301	11443	jwVjcHfKiyYcp6z5tYLipaGR8gMCxowZWe45pLXumMZswmrAiDX	7848	11100	11100	1617937200000
15409	3NKeqYCipGLd68CBWifTxazEBwXhHRUjkdGuw923yphPZhZqQzQM	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1585	1240	247	6301	11446	jxgxL74PdAYShP2DsuhWmwySnAXxsesRYBci5UgLzkdFhUkQgbN	7849	11101	11101	1617937380000
15413	3NKwgkyhsNjSXGqZLBV6vpuh7wCAtcXEe3NGTBhh6HoZkLFRt8dS	15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	596	1306	247	6301	11450	jwKzmJ6twRMjPZXmYXYyr9ihwtrDARMhYWB6mA9HeWLR7Hh1Mif	7851	11103	11103	1617937740000
15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	15413	3NKwgkyhsNjSXGqZLBV6vpuh7wCAtcXEe3NGTBhh6HoZkLFRt8dS	1406	1393	247	6301	11452	jxxh6xVPxaEnC8iu4UqCfJQrFAHPektBzJYu6SfFXThLzK54u7p	7852	11104	11104	1617937920000
15420	3NLuXgTY9YntdAk8F1TpkscTn62FCg4Y8LsmbpVMMh2amvmjXT6p	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1654	1094	247	6301	11457	jxA2eDpTSincze8JBVNfz272vBEniM3sdxewwCTNTCcSsYRxj6U	7855	11108	11108	1617938640000
15427	3NKkxPmRHT2Tzw9JKmLqS7KcjFPBsDGoRtuKGV2UuZyQ9KFnwPrP	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1448	1065	247	6301	11464	jwRWu7ewXYy1a5rkDnvVL6Rv9hGz8xQXwNHKvwWbq1nKrj7Nqak	7858	11111	11111	1617939180000
15429	3NKqQUFaKJJQXii4zivBeC6QLJvn761FcCc5DCyhWmiYhb1pv2m8	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1448	1065	247	6301	11464	jxiueYET7WZn5x4MUz5gcwyAfzAXoDYgSkh9h5sdX9jSb3zwhea	7858	11111	11111	1617939180000
15317	3NL9HdJH1VpHJKoxf9TNZACK55Yx95SsX9zz7xpUEp8SpgzaGihK	15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	1578	930	245	6301	11362	jxuRY1KfvCfMvsLyUCKCW3S8ZhdaHeqACYKppy8w8nLEJwfWEwA	7805	11041	11041	1617926580000
15319	3NL4WPHx7TWRdZgKU3id7b43zQNhwFew8CAAAGsDUAuLkWfM2g8K	15318	3NKP2Pe8kAo8oZvc38EU893os16Mpj7i7sJgTbJMDrHtQzPXLvD5	1596	1237	245	6301	11364	jwXrUwk9QCchfxLa6T8Fqs8WFAMF132vUMXpzzztp5N37Nw5zSV	7806	11042	11042	1617926760000
15322	3NLd9bwpwVFnGpUEQjRCfVJGK9eV5B8GSPyPuhdTzJJgQrARWmwi	15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	1522	1322	245	6301	11367	jwjJyp2BmuAQV51Y5cztYbwF3Gh9uj9z6aC1iE6cMH5gmsHSUu7	7809	11046	11046	1617927480000
15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	1608	1289	245	6301	11372	jwcUermV5gzJvmkbbPg9WgVskAuHowZdoF1xerz1dsSLV9ZjnJz	7812	11049	11049	1617928020000
15330	3NKuzASHYBXXuMLSUuwuFDyytrGTGWk3faweScP8Fjxk1aTUAC68	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1448	945	245	6301	11375	jwWJY1bMvc2GUSkYU363c6PUsmVAuDNHPAVW23AvHMkQqjWZVCa	7814	11053	11053	1617928740000
15332	3NLmWxBoNjUfGeKSpeMPv9o9BFqivM19esiMsdKJ3eQJFt4Mme2i	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1448	945	245	6301	11375	jxMtGCCvSEiLrpXJsZjx91pWSHVsxeKwtYTaHtg9X3yQ3pzYDm2	7814	11053	11053	1617928740000
15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	1553	776	245	6301	11383	jwimpZwHmWipJsggDeXMDDUTaxennaLHwpE6DVme5f4qd1Sguaz	7818	11062	11062	1617930360000
15345	3NKbDk5YvhaTBAdzJg6LXkowFuQLVj57x1s1BwQ1c4uFiucAMMAt	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1623	830	245	6301	11388	jxEsZ3Ud318nHLcp8noE7MVjwxe7pAqTQLEouAJvqtQAUGK1655	7820	11064	11064	1617930720000
15347	3NKYYir1zNa9Jt8Z4C5uVH78dHwSA4eD7yjDZBFQUURdLGYPFW78	15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	1405	875	245	6301	11390	jwFK3pfx3xPauWQMBzcC6mGKTNtu376vVnfEpekEHhzxk4SarKh	7821	11065	11065	1617930900000
15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	1542	1058	246	6301	11391	jwRuRS7xwSYG1QvSaRhSwfwnPjbvzUfMq7LkpDRXmXPcRmu9R7g	7822	11066	11066	1617931080000
15354	3NLqH2UtmgX1knowmupCtVdaYmzXMcXWdfP7MtjiC3z6tdypEz8C	15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	1448	1185	245	6301	11395	jwkEENVKdFBk4AWZDXPc9e1Vv5Vv1iR285cm3faZ3Ukj3x44Xr3	7818	11069	11069	1617931620000
15356	3NLxXmvMpYshdZMm6PSCfA4ZkaSaHmv7a6QVJs9j3ZJZCB6mnSVw	15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	1448	1185	246	6301	11397	jwRi4F9dXXb3YpXoqdz4CU566vVfTndux9coznAHgUV4mg3UzKr	7825	11069	11069	1617931620000
15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	15356	3NLxXmvMpYshdZMm6PSCfA4ZkaSaHmv7a6QVJs9j3ZJZCB6mnSVw	1637	816	246	6301	11398	jwpYchToJ61LHmCnr9QzEhu6vuta6hPLkDP3MoAMti6JxXZqgwc	7826	11070	11070	1617931800000
15367	3NKdeextEFD8E3j16jreneWD2LztUP7b8JPPFkpZy8R8CPTV9WXK	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	532	1057	246	6301	11405	jx753dQpsRJWVp5xRS1R8UoGAq6xsjE99pMS9Mu7shESSYnF45A	7828	11073	11073	1617932340000
15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	1577	1081	246	6301	11411	jxV76zKwA52xyNYajFHzmnnHhFSkc7oWX1AvGHFhFCwFqbSF37u	7831	11077	11077	1617933060000
15374	3NLmrmgGZnXXv1B59TaygRwzq6ezv3ZfGtTB3z2UPJBR6WPRd27j	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	44	1079	246	6301	11413	jxvVYcsn9o3EJMhbpVL9ueivjPAdbA6uNQHMbYurRsCXo98yoth	7832	11078	11078	1617933240000
15376	3NLjWPjTzZZYNiontvbFjL7T69X5qVF68767v4WxN3RoR165XN4u	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	44	1079	246	6301	11413	jxTyaRQ7ULR85TxDPc6powKqP4zZFx3sJFhiRPXu7wqiTXQRyLw	7832	11078	11078	1617933240000
15382	3NKFh1k6n21ssy9mYSByeGfvpywG42V8NNEk4zfWCj6sbZHcHAzG	14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	171	1374	238	6301	11420	jwwXqc8y3FonQt86AGB31TTfkuPjEYSJQ5H4wdQWKAW3XgFYr6A	7623	11086	11086	1617934680000
15384	3NKDBAMj6yKyzm2GziW8Eoke1sWawC4raF6tTEmKkwiNgTWQJsac	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	171	1374	239	6301	11422	jwYBx1eHmq2KAu7y9B7y43TE7fdaBz2yK7W8fpBShCrSfvfTewx	7639	11086	11086	1617934743913
15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	15387	3NLQvvHZLnkiKNVqr4SZesWSL1xnD7pWcNuwrCqsz7nCGbg9tLy1	1546	1093	246	6301	11429	jxzx86RLsWURLEFi4oi9SkzCsT4Tk59i9iQ4CQgEX3h9rEo3XyR	7839	11089	11089	1617935220000
15393	3NL3nuXTmrsLZpYAGA1dqXph1pckkk9J3Uwi5JBzv22fQCpKBnQM	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	1541	1172	246	6301	11431	jwc2twvKLYB2aaajGUXDVj8D2ZFq7f3VHPGzdVsXPwoN3FsNsWs	7840	11090	11090	1617935400000
15395	3NKDasDzrVo5ZEi59fJLE7MMqVuggY9o8bFDhiFL7s7QzFzf3XCH	15380	3NLwPQczAE6CrHuff8qHPE7JAAQ4r3RKWzVxnQNcp5rqe8XZvx5L	80	1027	239	6301	11432	jxfyzxwvXARCjGWhBw8jGfXesisz2eEZFhA8kgTu7gdN5c5FS7D	7653	11090	11090	1617935400000
15399	3NLindUULaGhTCF5WELC5uryCD4fi8wSVHQ2nYSsy2bB55GZTauw	15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	1589	1286	246	6301	11436	jxLAxNRev4r3KPUsoEiPAxViMyca6nvWZHvD9fY8V47m4zLbUDJ	7843	11093	11093	1617935940000
15402	3NKpGCaCWS94N88d2SLtc4NXrR7ZRuGg6mD3Vr9SM9krmDPS8sR9	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1647	1056	246	6301	11439	jxDf4GBcCcjGqHHx8Ua4zeMyH4R5tfB4vFWZfHFDjBbH1iHoo5n	7846	11097	11097	1617936660000
15404	3NLAC6VKdxkKZ9SWViY1UytdRGtkmoj7YTvmj77wwBqSwZyg8MwS	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1643	1299	246	6301	11441	jx7HLJYRp7ZjM2zJ8GjL1eYSrD6Y1EWjdq4U9xQPT8nLH8LnC9E	7846	11097	11097	1617936660000
15407	3NKvUwitB3rpdQh4cjJCXAE3VyKB5YB4srKe2u9FYZiZLvrV2G2B	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1476	1005	247	6301	11444	jwtKLyMwVaZGV7jQCnd7GXnghiyGkrXffqh44gLkqLP8i9oLvBK	7849	11101	11101	1617937380000
15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	15410	3NLNSmTpZwXLdZVCaQejeZK8wPDDAWko4GJnYxVUq51v1D5DLcBd	1407	1395	247	6301	11448	jwpKzSCAn4EhsdS2bVy6yahNHxu5xoB8Srf84fAPbosbs7BZ5Yi	7850	11102	11102	1617937560000
15416	3NKkV61TAwQUAEYhMbdUpVPd7BCCakHukyZuYQBWDAqyuRd8JL7L	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1406	1393	247	6301	11453	jwfULJZBWrHFjCG6ox9Dc12Qnz586HtqCQfBE5fKQ5Sz7uaCRkn	7853	11105	11105	1617938100000
15418	3NKty5dYKWugFY5A3RApzGJkDZpXoFHi59wwmew1FrFJczcHonc1	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1481	790	247	6301	11455	jwS22xtQm7gtqaHQwvxv2bSFYA1hQd8Fk4QZyfhDG5zL5n2skNH	7853	11105	11105	1617938100000
15423	3NKtz1NS5EMAyrUtbGm1WHHEh5DnBvHhWZauAvzQMgQECA9u4Nqy	15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	1602	1243	247	6301	11460	jwqvDxxsPgDKygr4VuxpjqrDx4HTyUypUy3rYAHSbgzszFTUKAp	7856	11109	11109	1617938820000
15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	1637	816	247	6301	11462	jwQSTcAthZ54tpnFod4nwZbKTzSXykgLk5sQpcTmZn8c35csLbA	7857	11110	11110	1617939000000
15433	3NLcvk1oWcfMhXAowNohd3kTi7Kye7uW66BZghANfYJNwwv1uAve	15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	1581	778	247	6301	11469	jx5K7UDAjz1Nyj4HWy8DmX7aYKCV1ZEm4dhHMomc2C9AUBn6nhr	7860	11115	11115	1617939900000
15431	3NKkU2ReyUYMBDarf6E21kpTH3Vy3MzNMHitaKWguYV8ux8xcGKY	15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	1406	1393	247	6301	11467	jwzah7WPhBp3sKvLBskacdmZFuCpoC6qSowHhR7QwuoMnuUb7wB	7859	11112	11112	1617939360000
15432	3NKy7UtMhJBXhMFhGwi2gnWrb5mp5AaxHTp6pjo1syGpZgLAcS3s	15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	1407	1395	247	6301	11468	jxUvD3YMog7NhhmRXUegpc5BNaC3HFWqxTrKjvF4hsCKWKpN7ov	7860	11115	11115	1617939900000
15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	1403	824	247	6301	11471	jwtdKoNC8NrfNQhLWStHLKcMF4T6zDhENwZ8X5XpqJCMgHghnBR	7862	11119	11119	1617940620000
15438	3NKVfQL35ihAzA3V4ynkuWBeBwYopKcHqionMDKJ6QCCntF2MEDe	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	606	1295	247	6301	11474	jwemZuMapKWrKaJJ8DRkLMRWftN3PR2Vymv6Hta8gJXsthQ8iib	7863	11121	11121	1617940980000
15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	15446	3NLBqkTMooxzUVsmh6UJiYzYUEiuNx8Cp2auZaGdHYNv7fT6XPuX	1406	1393	247	6301	11483	jwDgQp1i6BU1cPCLdaHPdcE2x2hpSCyUAs53X54JB2qgdqq3Re2	7867	11128	11128	1617942240000
15452	3NKx6npQKVGrZk5cpPkMtbK1rsYNww5y5ynXKWCZMg1P6XFGsmfD	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000
15454	3NLMAW4XV6XfFizBkBraEQeByiiDGW8QbnNbY8JsWRW3UEs3koAY	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000
15459	3NKjHK6Nym4eCwZiKFEqJbpC2yufQ6YMPa8SSt3LxoSyFAVghZiX	15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	1509	1074	248	6301	11493	jwiSx7RrG8tu5xJ3jdXmGvLzutukwsrEGatU69gF1GWFckK2WJM	7873	11135	11135	1617943500000
15461	3NLZiKdhLxiimGK3qt41FmD74DBvcctPQhdUdoum6p6gH1aF5n94	15304	3NKYEyYthqDijndoNeT2RbteRWzjbX6T8krRQ4vvPMsjq6NoEnwW	1509	1074	244	6301	11495	jwifwAQtuTkYyZa4szkqfUomyNhrxs8SwjPBpTm7irn4SzH6BrU	7785	11135	11135	1617943500000
15463	3NLCpjP2gg7jkaoFyQ7FCm3HgQdhaD8fpGiUqsXRUEonJwWp2MDW	15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	1573	1318	248	6301	11497	jxBnmc89ND4g4aCChdpVzib9U4FDZtgv8R3aZDYgGw8tYhZzbMR	7874	11136	11136	1617943680000
15465	3NKRj198wXbPE599AXc3cZTNxZszHNrStbfQsHJKN4RhgbnjegEr	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1403	824	245	6301	11499	jxuz79S4yV3LrB1CAoVJNzaZFSwBRqp2CFZZ6rETZBhSByenDbP	7801	11136	11136	1617943748149
15468	3NL1MtoWHiaKYvuPAJQiz3t51QHAH1TUbG9cb1mbnEGCHqDPirim	15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	1407	1395	248	6301	11502	jwB8WZ3TuxqayDjDpn4Kf5g6XhGsscYzVQyiDPkdhTJ8A4BSRwd	7876	11139	11139	1617944220000
15470	3NKMVCA5w8oUFcT5rhotXY3Z6sdydPcSo5dFyfQG2Aq7eYvNCgSk	15469	3NL3DRvGShxbeC1Hun5otuNxRos3EkoTm116dMieYkYQVoopH9yh	1406	1393	248	6301	11504	jxTJvhhZFarQYZrErAFPaZ9oB7M28CNQfrBqiS31GucF3qCWNZ1	7877	11140	11140	1617944400000
15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	1623	830	248	6301	11509	jwasfRZNxitRUYk2hTEV1a8vmfV1rkFc1zeZMd2yJYuPvadAS8k	7880	11144	11144	1617945120000
15482	3NLAmzi2u4yDj9au6jtt3pKsuAezzgbLp3c8oY3VGGqD2ktagd6y	15481	3NLQjsbt3c5AL1SfNGkUsBz2pTo5qqVsDU2aPuQYVvpn7jMh8MhB	1444	1255	248	6301	11514	jwXDH1qvhB1t1uqkHL4qbNFa38v3TLyJWddJs35km1BjrpcSVfn	7882	11147	11147	1617945660000
15493	3NKYPeTAfpPiShW5WrwxiHWorvp1tB7chSDxpwEtgJqcYKXE9oRm	15388	3NLZoNFaFT5pJir7M4EeqTRMsSTGGhqAwCVZ7tPwasUY2oi8FJZJ	171	1374	246	6301	11525	jxKmNJLyNDEu9FeeqDihLhQCRzqoYMUbk6EkrPRc5Y9S5t8j8qG	7839	11152	11152	1617946560000
15497	3NKUNFMYLMUKvF5WGj6NJyf6zsNCs6HPKR9q3P6uz6KqfQxHLWoZ	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1405	889	248	6301	11529	jwxfgNtVpx2mqWp6hcwijDG3oaWrzHc4Ewr5kGi5VHT1Jqmyp4m	7887	11155	11155	1617947100000
15498	3NKoFDVLXa3samJ89T4FoimMY8MqaerA4oy8kMhwq81XNtv3jfyx	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1643	1173	248	6301	11530	jwuKZn6x9uLDQqwww6k365uvgPitiP9i97ZUYuA4TtoYPnRknWP	7884	11156	11156	1617947280000
15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	1637	816	248	6301	11532	jwve1w8gZm1m6GJD8YaaHv11L5seB8i1kxm5aWsrngiVzBnf4Pb	7888	11156	11156	1617947280000
15510	3NLqsRNqcujzK3v7zWphZ6GYjvxos92kvRkFQcUYek5qfeoaTNkU	15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	1590	1300	248	6301	11540	jwEJorj7Fv8smGVmzAMaseUdQ9mDTXGRuHVrLcPaWeWZH72S5Wk	7893	11163	11163	1617948540000
15512	3NKpXUhvjEToVZtieDKFrooDSJnjoXXiCHgRTKBLM1MEN72jvV5n	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	1483	1276	248	6301	11542	jwECMatyJknh6aF6YLyMiA1dStsXamBS4g9C5EByo2utM8HcXy6	7894	11164	11164	1617948720000
15514	3NKDFSHWaKGMTYxop7UZWQ4yd4hdeUSVkW27fWgnosuBxedL2MBw	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	470	1309	248	6301	11543	jwA8oZirtqEBU4vYP9b8UG7WHEw49rZ9WA5gavcnQfRkdt1rkKT	7894	11164	11164	1617948720000
15517	3NL3a5qhMNpTwV2cJVuQETcSrHELTY1YVkdCdhd1qrF5CtaJiUhP	15516	3NKTxsQ9BXMnFgAncUz9pgoHHzPKWCfrNUYqRSPDWNGURUhvGGfh	448	1305	249	6301	11545	jxgyjStQxY2BT4J7DaxiEoCDrD33knM61SEZ6oECWJf9zr97b6J	7896	11167	11167	1617949260000
15520	3NKkjvtgmJwEPDuLpEcQP8iLJeDQEYQyXhfHv9mZRiyoG8jrwTs6	15389	3NK4sgxu4LcqXMsvtX9YyQqx3DBZ5PqLv8eTS856t2vBhaNHUe6k	1670	1156	244	6301	11548	jxvxmmuwcrHiNRpxdfkkXJ1L26UXhWugJ1Z3pWKDiCyfyHpLhLG	7799	11171	11171	1617949980000
15532	3NLogBPb5FVkerp6sbaQ6P311U3fkaTozUqDhFRpCEoK6yqUW6Yw	15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	641	1210	249	6301	11560	jx6Vsux4KapZ3YUvTV54aBKkjaZsMLBAMPLAcE8f8hucrFNLRWs	7904	11179	11179	1617951420000
15537	3NLT9CUM4n3u1ZHU9UPytusZ2aX6jYhkfk6pK75bZpPWQ9ULp4dh	15536	3NLk9UHXSMZnBtuXLkpitXng2QaW7mM8Mv9MCYuiaMD3AP5HxjP5	1406	1393	249	6301	11564	jxidgmrfYWnbBQN6E68WTX5zQpzWhBGgaePGjNbd9RAHaQTj64K	7907	11184	11184	1617952320000
15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	15539	3NKvvoACrXQVAewubwhrtzXTSDhtuVVjChWwQuAfPgYYfcmJAdTA	1451	1166	249	6301	11567	jx1GVbsp4DcxxEmxe8UGFhYfJb2ygC8y1vZxrZEsy2BHhBHoGgu	7910	11188	11188	1617953040000
15545	3NKTgJxmcj5wCmBWzxQKPZh8vRQEpA5DE2u2G7SifzRHUUSjZDzR	15543	3NLhZiMCSzRetndFVFD4yWRYokzjB21Tz5xePEwXaj11fwbYCDrz	1634	1085	249	6301	11572	jxi69FuQ5kkK99iQsHbkw9yvAHFy79BhaXwqDkpm7ydWy46q5SV	7912	11191	11191	1617953580000
15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	15545	3NKTgJxmcj5wCmBWzxQKPZh8vRQEpA5DE2u2G7SifzRHUUSjZDzR	1585	1240	249	6301	11573	jxMXMfjyxS7zDRpAEdmDCPLub3z2ByfxtvHFRW6mY7gqf1gjYAf	7913	11195	11195	1617954300000
15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	1579	1389	250	6301	11581	jwn3g4umvyuxQp1UqQcQMXGN9ioaN8TUYEdTmxLH2JvmPqidnWN	7918	11204	11204	1617955920000
15562	3NKWX6rZ7tfcnN3o2oixRJiEx3bNWwwaP8DGczxUyLbgRSaPMNEx	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1483	1030	249	6301	11589	jxcPedSetgbK7LVV4Q4YtBNTLKobQHwQooDsgcMG2Y2GT611aNu	7905	11211	11211	1617957180000
15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	15566	3NLYmZJ77Dx1MBcjZien2BJgkbr4zwxxSES5Qo2g9zKvCjNMtgV5	1613	1349	250	6301	11594	jwfqmmr8aq9KYuYJX14uUuwjb76zxZAoeWZprKEYsXD8QR2xGL7	7923	11215	11215	1617957900000
15440	3NKpGGyxA4ZmaFjttKYKBLiWCWB51sdHqWCFq1QQNW2EPKubZyRF	15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	606	1295	247	6301	11476	jxZFBmqt8skdy5MQsjQR2o1ER8nN2Jh45NT9B24Sqasn7ZPmUk6	7857	11121	11121	1617940980000
15442	3NL8WaaFGVvfchPiEWzLyR3h1gX6FLDUcG5CToAzJEA9qrwsAMHB	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1407	1395	247	6301	11478	jwTiCCNNGBNqPCp1sdrNatR4VrRWSg9JX36mgSHGyK9mKdcxdiV	7864	11122	11122	1617941160000
15444	3NLrKTFYCxe4tuVXxfJoSr4hzDUKvTSYkYasWDSoxeKAYgimAJ5w	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1642	1121	247	6301	11480	jwZkPaHsSPVL4dfWt2r6JwVBV5Tv6Mb344hSqC9gPLqbdnfJENb	7864	11122	11122	1617941160000
15448	3NLcgsWr4Ai8vVQZe9sRWdH5E57CqvFBM97Mu6dNKqbDyhLewYDZ	15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	1439	1033	247	6301	11484	jw73Q6got84nU7uREXzzvtjqxu66pDiNS6dJSp7G2GxDtQM5HUX	7868	11129	11129	1617942420000
15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	448	1305	247	6301	11486	jwnyTuE1yEkMf8qpt7YJSxts28XP9fgY3n3K9PdnotRgKwHqBaL	7869	11130	11130	1617942600000
15457	3NLZQ7Ncz7wnKomtL2wvZ91LhwM5PP5SdLeW5cvwM8EkyokcYUVC	15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	1439	1279	248	6301	11491	jwT2YFjTiqQEEY3xfVLWg7Vwk1ftFFrFURd4bGR4GFUZrN26d97	7871	11133	11133	1617943140000
15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	1593	1220	248	6301	11494	jx7cdyZPFWaYDfDibvAXUejrNTLrMYbT1VP9TPseZk7u27WSHyU	7873	11135	11135	1617943500000
15466	3NK2xkwnfq22cL3jPwyMS9C9QM1CrTGvXBrfUm6SM6Fgi47eeRWP	15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	1403	824	244	6301	11500	jxUXSvQLFU3sYSVkKPXJGsMpWWCpwne6o76rbMHowu3QqxCPFsv	7788	11136	11136	1617943714550
15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	15470	3NKMVCA5w8oUFcT5rhotXY3Z6sdydPcSo5dFyfQG2Aq7eYvNCgSk	1549	1362	248	6301	11505	jxozJ9unot314mbZ1mVYK9XVB8SLZ1BBtJQvQwS2qrhsjqRbwDG	7878	11141	11141	1617944580000
15473	3NKMJb9RpaULsNRbDNoUHpe7CJG2K8fEbWbUJZxSHqQUrYs8nrQA	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jwMwA3rDceKiBCc2iUuSnNyZ3Uc56qnGQr4uFrDPqyEYmgAyQTY	7879	11142	11142	1617944760000
15475	3NKeHYoEJaJNiouVfnL28nwPoqANG3MsmxVzcSPtZQi24AdzvErF	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jxyCktdUgzSwDzpceYm18GZPNiomQmqVgUdYBdbHzBr5f3RW9M7	7879	11142	11142	1617944760000
15478	3NLXLwFHynX4YAuhrZbzb27kBcJgntS9uHLGWQqdRdGMTFqb6wui	15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	1406	1393	248	6301	11510	jxsu9mq511J52WoKVWZKHpyKrzRSVxM7kAuRZ3LTBQpzWQHwGUG	7880	11144	11144	1617945120000
15480	3NLVTCJziaYMigVfkewGAn8LcJwbtyR5pD4HoDTdrDbddowzMKCs	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	1406	1393	248	6301	11512	jxQH7Jj5JQUwvVvC2fy8pYoSPTA74mdfoCsPHjnnpn1o4mkBRz9	7881	11146	11146	1617945480000
15485	3NKHVNNeoKjicZBkL148aLmveVqjYseNv2q3JKrBYzoDjofu7f7k	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	58	1281	248	6301	11517	jwd3d7dBjRdiyY8witeUf6TR18eQoutH2WMuZNSMsSGnVq1jc3B	7884	11149	11149	1617946020000
15487	3NLcztnvwUP86WSLiSk5DodgQ9qG5DMFUNSijYNijRfEmzmpD3VM	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1622	1230	248	6301	11519	jwpo33Qhg9CKzHU8CiNFJGkcPYbYFWTGSr2kuUgLzpTdanrgD8t	7884	11149	11149	1617946020000
15489	3NLVjybCtLEHw2ypx6BRcgmwUiUruP6WKbopvBe4rEa6FgvWcSWZ	15484	3NLZ7fhphCnDe7t95cPQqi6VKUgBkzyhiPW3gPC2wZEq7CGqaASu	369	1312	248	6301	11521	jxBoJqkwqgBysnwqEQtWVjSEykKZseakVjawXLtyYYKiES3aguj	7885	11150	11150	1617946200000
15491	3NKpNc3XPwWrAgucvzuJY661AKcSBFYTyNkD1p6qfVRS2aNygEN9	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	369	1312	245	6301	11523	jwe9vSJqrwjBKQ5QSUmcoUp5NVHv778Xk8MCMHwieKJdWPiFFjk	7801	11150	11150	1617946273208
15499	3NL7GYCbnbFaZccZSQtdNjTyywdNC3XAQUnagAFUgah4LEnpEPji	15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	1516	1294	248	6301	11531	jxrzDpdpBwkS3yFGBTUC4PEbsiZbomyWyZz7ZcUtTnXWMJa2Fo1	7888	11156	11156	1617947280000
15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	1405	849	248	6301	11533	jx8FAEupSEoQLQoGnqGkLLuGkCMjsjRSVwGaWxrATxBNkbCpwhS	7889	11157	11157	1617947460000
15503	3NLNboMMNNYanmZzy6FocjtyYFr82GdmmokrqbY4SbYTMSGSAPTB	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1634	1331	248	6301	11535	jwjd4vUoXWgCmRXXZRGMWeAt3PG3momSEnhzyxCGRnxoehjA37L	7890	11158	11158	1617947640000
15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	15503	3NLNboMMNNYanmZzy6FocjtyYFr82GdmmokrqbY4SbYTMSGSAPTB	1483	569	248	6301	11536	jxuLYPjUJ35dKQPELEKPMXtSe93P4uSgVr3jXCnBzX68yYJd3rM	7891	11161	11161	1617948180000
15506	3NKewNUeRz8fBFzi9Btv1Vn7QyM8zK1bui12PY7CR15nFtpQcB2e	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jwHxHKMHmCZS93w7rjVZuC6BgTbpiro7pigzQTamx9TQu1NeVBQ	7892	11162	11162	1617948385602
15508	3NKDGzZbeW7cy68ZQ2K1uSWnvFZ2MEfFNswxb41akgU7Dh6jybRX	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jxNjxWb1356fWKox2eigGqLqjXxHhetv7MZqu4DWc98E2ZsKvxn	7892	11162	11162	1617948360000
15515	3NL2nsfGfmWdGJq95r9gJ237BMQ7od1gESk8HNHXJ848jQ7CL1kD	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	1483	1276	248	6301	11542	jwpPPr3e8p6HyZpWphsUeEXfuFDnWSFFJAx27ebMV7TvFytarA9	7894	11164	11164	1617948720000
15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	15519	3NLE7RvwSrKmXvwNXLPk7zzXMG8srXUjs7QuKwPQXKDauZaSppN9	1670	1156	249	6301	11549	jwcBBv9CifiqzPBP1byppEGdq3HCoxkPfJRDrEfJCWX84yrm8xA	7899	11171	11171	1617949980000
15523	3NKrShmhWYAmDWuiNiqMUz47pDpTBSs6xCg9QBAMSjxRYmbVJTfT	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1608	1289	249	6301	11551	jxfSHsisdP7iDesbsw1qpMqTW2A3kUcAzon9QJZJe4cxLed81dY	7900	11173	11173	1617950340000
15525	3NKSz6CCsvF84fQw9rN3MoCRN3Hc8KzBJFJxuiiipgg1rRwMJ1Fn	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1549	1362	249	6301	11553	jxgyuh9bJFByWgiKK6kqrXHumbQXhJcXyis3u6vxQF1YFZTuJbU	7901	11174	11174	1617950520000
15527	3NKhv97EPJ68DoCVNyt7F3B7uksdLYTb36BubG3dNfY9UAN2sia2	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1631	793	249	6301	11555	jxaVYhjYp12FBoqhBgxv3B91iTgmsqB1hBZwrFPcXogzivN95hY	7901	11174	11174	1617950520000
15530	3NL9CiNBFeTw1gdLdTxuoFWAdrtJVADaC2VupHuqpg8UaW9V1AwD	15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	1419	814	249	6301	11558	jwSoqU9peEbHha5HPxCtwCrz3ufrT9JV6MHcoNp3YYj1dUoFgQx	7903	11178	11178	1617951240000
15533	3NL9thkbvHqSVmaBzdhathveJt14k8Ua7b16CnefPBL1ThYkH3Es	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1610	1068	249	6301	11561	jx7pxjqJrY2TPB6W1EbNg4uYsEwDFG3dogkJKWDw8oV7Uagnjfm	7905	11181	11181	1617951780000
15535	3NLZ2DzvUK81yFdWDptMSc7tbpnujyhjs8VZ5nM2twW4DKxbtzeG	15520	3NKkjvtgmJwEPDuLpEcQP8iLJeDQEYQyXhfHv9mZRiyoG8jrwTs6	1670	1282	244	6301	11562	jwQTHbiqx8pG2MMKQFjVnYepC3puuj4zGujNBR8Qo6XCFJCjJvK	7800	11182	11182	1617951960000
15538	3NKeTsySP8JtuBG61MaoXqe9on9V3in4tbpwQsxrSfmTRy8HCV8a	15537	3NLT9CUM4n3u1ZHU9UPytusZ2aX6jYhkfk6pK75bZpPWQ9ULp4dh	632	1382	249	6301	11565	jwWvXr38Jwy23VEJFiyjtyUZRFeJXKBjGR4CA1MGWR3va3Foko1	7908	11185	11185	1617952500000
15451	3NKRCbah1XxLXhY6trheaeyP9A24mXNUNvjyBP9T6EGPSUXscoLo	15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	1406	1393	247	6301	11487	jwVeDAn2CWd4uhawcvL2Dr26KFpc9YsztTaJzyeYsmxATSXKqUu	7869	11130	11130	1617942600000
15456	3NLxB17TSFNvZkT1byE1aYAj4rGL7rw8rsJxRCHpCdtzGCupeuGV	15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	1490	908	248	6301	11490	jxCYvcPuoXBSzNxqqEGtzwbGxrscjnuhCDbAw2c6wtDCUAJycVd	7871	11133	11133	1617943140000
15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	15457	3NLZQ7Ncz7wnKomtL2wvZ91LhwM5PP5SdLeW5cvwM8EkyokcYUVC	1546	1339	248	6301	11492	jx8jcNMyRUWxya3Vq5rD81XKjsWUZoNECWyxJ2djE9vZby8n7Fd	7872	11134	11134	1617943320000
15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	15462	3NKvwGbBmQXiKi7Q3rLm1QFjoSCKN1copCjhA97fujQopZ1ibqUE	1589	1286	248	6301	11501	jwEkCUzqgrsKW8EpUgKq4gvU9eScauyoN7vThG2abN9vZGHmvqt	7875	11138	11138	1617944040000
15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jxXJRdePAeJkanyZUQWFcRvsr7T58nWCrWtBnrcAuHkoYGrMLTL	7879	11142	11142	1617944760000
15476	3NKhKRmgu9JF3SzxcugEEivYgtHCvALDLPz4n46iQgcZrzMEHZRn	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1406	1393	248	6301	11508	jwA45et14eHFiNDFofv7GQ2QJZM7Xk37sXwGskbXnjzHhXKCPqD	7879	11142	11142	1617944760000
15479	3NKFkmL1Ai6WoDyoLReqZ8qN9cY6xJCGtMMpzU8kBxcSn18tQ6uU	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	1457	1145	248	6301	11511	jxTKPdz8qhCgjYWfeBUrfBW81idBZrVQHMVTvNRDtHjzFAe1CaD	7881	11146	11146	1617945480000
15481	3NLQjsbt3c5AL1SfNGkUsBz2pTo5qqVsDU2aPuQYVvpn7jMh8MhB	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	641	1090	248	6301	11513	jxGdgutVeuA9WyKj28SdbsKqiJFxuY5ERo2R6RHW1i9arbnWdJT	7881	11146	11146	1617945480000
15484	3NLZ7fhphCnDe7t95cPQqi6VKUgBkzyhiPW3gPC2wZEq7CGqaASu	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1407	1395	248	6301	11516	jwxbUp8MArBufVTNxGXGMUu95uEsqLiU87ekxL32dGmW1HSE6pq	7884	11149	11149	1617946020000
15488	3NKWuXcPwf8GRpsWL6XKz6MgRLKCW2eXKD65kBssxyFvnBgPuup5	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	369	1312	244	6301	11520	jwjNHPB72Ss4hNdM9fVMbfUKbgGcjvBJ1Zm6sQEa7iMovubBe1z	7778	11150	11150	1617946200000
15490	3NLgsfGjJFpJwff12rLZro8EjK87q2XY9dDeovBStDxqBW6VDX4v	15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	369	1312	244	6301	11522	jx8zCDDcv6KneRAWFDpXDPEnh9LYhq1KqKdxxEinVUTaQBEL2oS	7790	11150	11150	1617946237203
15492	3NLNVyEwA273kygnTv8BojXBnabr7uVYmURXsxLqPzwNHmQgETFn	15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	369	1312	245	6301	11524	jwEwVZW6ib5NoycZsAUma3LgspiodZmfJ4nZckjMwDwiVSJAehw	7813	11150	11150	1617946311294
15496	3NLg1wt56rA87BGNinE1n87ZvqiJvLZ7YeXpyPaqeLvJPn4Y94wN	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1634	1205	248	6301	11528	jwHkFriNptAFf3Hzp1KbrQyKtSkXQJmrcmqitPzhEZFHvQC74x5	7887	11155	11155	1617947100000
15502	3NKq6K9jv6yCrEP9EhaXBtF8U9K2FNDTr3BgNVz3gm5Jme1mL3TS	15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	1553	776	248	6301	11534	jxpfxbGW8yptuWJaLC6f42x3erhmTJ5q47dgayCXwiHg8G7t9Br	7889	11157	11157	1617947460000
15505	3NLqBu2WKHLYRA1FMvVcD28tbqtf9T9dLth7B3X3ncXtV8YcBpDN	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1527	927	248	6301	11537	jw7MNaiWc3mztThDMjJ4dvCS7Z3zWyfCziksv8RFASiCuadvDZw	7890	11162	11162	1617948360000
15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1560	925	248	6301	11539	jwtegXuzQ6z7RAsCZjE5qjWXPKbj5Sr3mgbwWLrLKyY2JZAgVf4	7892	11162	11162	1617948360000
15516	3NKTxsQ9BXMnFgAncUz9pgoHHzPKWCfrNUYqRSPDWNGURUhvGGfh	15515	3NL2nsfGfmWdGJq95r9gJ237BMQ7od1gESk8HNHXJ848jQ7CL1kD	1600	1126	249	6301	11544	jxK4e5bk2KBqxzd4qdAiN6myciqqB6NeVb6v2KzP9C2QJw7FY2d	7895	11165	11165	1617948900000
15519	3NLE7RvwSrKmXvwNXLPk7zzXMG8srXUjs7QuKwPQXKDauZaSppN9	15518	3NKQqNS5Fc87x1bCAySKTBnNG1vYLq7rAH7En4PpcMahoMecKJwj	1407	1395	249	6301	11547	jwHJzvwcCAaQ9JPHXUCaHEkZ1EUV5aJcJEVtLDMmHCdF7twoMwr	7898	11169	11169	1617949620000
15522	3NLfR9YSpfRs3d5VVMLmzC74rUwoYYhCBZTKWsJWDLWhvkkt7fwT	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1407	1395	249	6301	11550	jxQub8jnGmHaoxChQHujzBRwg2pdjUSDzxzgLbv63zYdAURDa1n	7900	11173	11173	1617950340000
15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1642	1367	249	6301	11552	jx1qkjVMoDacUovTqLTrdsjqBjhbBXMEZNGMeZmozQjDavymbK6	7900	11173	11173	1617950340000
15526	3NLxyJcEC9xmBxP6LSorh7BE3GRwgwXtXQb74P1Zn6azUmnMaxAW	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1596	1237	249	6301	11554	jx3f61iCSXaoEqMjbrR5PeFRV2srqr8MvbaxS6p82VRZ3nzSb8B	7901	11174	11174	1617950520000
15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	1673	1242	249	6301	11557	jx6cS5pBUqKQ293sEwDVLPQWL1dmhCeYL9pLhxAGtqNHF9qSGfw	7903	11178	11178	1617951240000
15534	3NKiUJYqWfZBgnmBD9Z3Tdftxunr6GTErwq5KRmFYUfdh47PBx4q	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1610	1068	249	6301	11561	jxQLFYhTte5rhD6AFv5PJUwNVHKiCCsA4hZfCzCxz5Wofs9kmSq	7905	11181	11181	1617951780000
15536	3NLk9UHXSMZnBtuXLkpitXng2QaW7mM8Mv9MCYuiaMD3AP5HxjP5	15533	3NL9thkbvHqSVmaBzdhathveJt14k8Ua7b16CnefPBL1ThYkH3Es	1670	1282	249	6301	11563	jwfTP3JiPSx6DhLXBs2SAVyeqDx88KdsMZL1W143pzzbz8gj7bQ	7906	11182	11182	1617951960000
15542	3NLPvjyRHUzGMkoATxNyMA8twpavMv816mk68ekaAXR9A3h6aQtY	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1407	1395	249	6301	11569	jxtga2fdvXrsyZEPucT1sGb1XV7Gi2h6qu6Zb2A3Xr55G668HcE	7911	11190	11190	1617953400000
15544	3NKHn3HwZHjfVmuFbrs3HcgE5WLKroGrjUxrEiTxeAYBgSVFBCp6	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1419	814	249	6301	11571	jwA8kkmPh2CjSvBpFJtvXB6z4gsUamNnWxsEZvbPKDXDjARMqsd	7911	11190	11190	1617953400000
15548	3NKzXkWmsjGfNWhmthZxcg7aKRwvXhdfhHsK2kBrnBCnwEM4WUFX	15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	1590	198	249	6301	11575	jwfJbMse3DnvL8oe4PeYjf4rmaD41X7usD4yLSTiBLFRho9cXNj	7914	11197	11197	1617954660000
15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	15549	3NLcHroop6vfDan6DeCVLGNvr5gEG2uMYprpBkevT7jgogYxH6GG	1407	1395	249	6301	11578	jxwebC2GuVp4HoQNTVnRw6vhdNEDUJVAkiZw62g8REXEDfJJebu	7916	11201	11201	1617955380000
15553	3NLEQirzQa1Mocij4zpAeAeU4WjR5mgdWbka7rAfiUF9svWt4K3e	15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	1581	778	250	6301	11580	jwpzJZv1nvB7cjChJFBDg5QmupSDRxumQv8G73nghbrJ6iKwkSH	7917	11202	11202	1617955560000
15556	3NLv4WpcfynBu9KcX1Vk7axi3AhaFpBjRuEkELsJuKkLSdjzZeBc	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1460	1324	250	6301	11583	jxG3HtJsRnbpHA4KPC2DN7yDzdPuqWoFcMiN8NHRYeReau4zxiL	7919	11206	11206	1617956280000
15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1555	1221	250	6301	11585	jwP9Vg5Vjda4BySWEZZYSpkdMycLDB5ZnfbZhUcGQPxE9zRQi1S	7919	11206	11206	1617956280000
15559	3NKvmoNKFsKTiHYb1dHGvNNtTUzB2vzHoo7dws4uSqPasA1uG6Ez	15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	1507	1280	246	6301	11586	jwCyVJ9zQnD8t9eKZxGzNL1ebwWyXrJhDfXicNN5Swvvw9b3Sut	7843	11209	11209	1617956820000
15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1407	1395	248	6301	11489	jwHdjehXkMgtzbSZ2RdcXSpXopUpTCSo5LDtxE1XfdoJbYNEFFv	7870	11132	11132	1617942960000
15455	3NKZDEXrV7iep3z15Q8Df9jntkCFQN3hy28exn6ex7e9ShVsdDrL	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000
15462	3NKvwGbBmQXiKi7Q3rLm1QFjoSCKN1copCjhA97fujQopZ1ibqUE	15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	1407	1395	248	6301	11496	jxHy6ixto4qS5qUpR4aKhTGJjJLYaCYDDuXCuCYL78VBP72R5YS	7874	11136	11136	1617943680000
15464	3NKjo8Hp2mSTjC2wNMvDMpVMeyLTENhfhbM1r64aY17mKgZc7r7Z	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1403	824	244	6301	11498	jxR8nVnV7ckixkmz4mUR7Fiz4qQKLd4jHFXQhBWWqyvNcq4iAJK	7774	11136	11136	1617943680000
15469	3NL3DRvGShxbeC1Hun5otuNxRos3EkoTm116dMieYkYQVoopH9yh	15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	1581	778	248	6301	11503	jxweRdxUwq8K6XL6XocJzqNhnpoazQGp8bnWsE9QpLmX2kLVWWh	7876	11139	11139	1617944220000
15474	3NK8VXQBUoboXxKj6Uzunt74AenvTiJbkVmAuJTh99bndAHVVShP	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1405	851	248	6301	11507	jxGTXUAji2aZUjxggBUR8ME3HKFp6FJDJuiDZEBjkPXbTXYzyDe	7879	11142	11142	1617944760000
15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	15482	3NLAmzi2u4yDj9au6jtt3pKsuAezzgbLp3c8oY3VGGqD2ktagd6y	1581	778	248	6301	11515	jxHw4sWK39Y6fuxYrX7oMpA9ZJtMLJ15mJ8VQTFsxSmE9f8u7KL	7883	11148	11148	1617945840000
15486	3NLrBZQE2SGq7XGQzNSffT5TZe8wSL86kec2z6HShsqRJ232Km3y	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	58	1281	248	6301	11518	jxP49tSVCAH4DdcJSqLqPz78VBLp1d8RSknbFJvLYoR3Nb6FPo3	7879	11149	11149	1617946020000
15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	15489	3NLVjybCtLEHw2ypx6BRcgmwUiUruP6WKbopvBe4rEa6FgvWcSWZ	1577	1201	248	6301	11526	jxWrAjbNZupszn6CiD64fFcUjPkSNerMJT1KFAvgUfGUqvptt6f	7886	11152	11152	1617946560000
15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1672	1039	248	6301	11527	jxEAechti7ttejbuz9KtNP8Dh1BHHcvwbWXJacbSnWBZamN3232	7887	11155	11155	1617947100000
15507	3NLD7W5uG92VXxFxfTpvoXwEMANH8wF5n5Q2jF8P5hN2Q23RTWqh	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jx2xYQpBNyWbfPHW9TEeBUxwaxgXuceGmnHWENpcHzdUinRgZKL	7892	11162	11162	1617948360000
15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	1406	1393	248	6301	11541	jwZ7Qvti9uo3qowcH11EHehRmx7Q4H561BGzkPLnue9wDEphorB	7893	11163	11163	1617948540000
15513	3NLGyfnAyQNq6gbvuos47YWejkG6RWro1HvxBA14rrFQ8KJLShJU	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	470	1309	248	6301	11543	jwYC9tohj9YybTU9nZ7eKVQNcYzMgzYbrZ7WWSyPK2EmunfJjmu	7894	11164	11164	1617948720000
15518	3NKQqNS5Fc87x1bCAySKTBnNG1vYLq7rAH7En4PpcMahoMecKJwj	15517	3NL3a5qhMNpTwV2cJVuQETcSrHELTY1YVkdCdhd1qrF5CtaJiUhP	1672	919	249	6301	11546	jxrJLTUFBvef6yCbcxhfgpyhGHqL9As1BswANGycqT8X3ypG54f	7897	11168	11168	1617949440000
15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	15525	3NKSz6CCsvF84fQw9rN3MoCRN3Hc8KzBJFJxuiiipgg1rRwMJ1Fn	1405	873	249	6301	11556	jwhKJ6oL5UtWG5GfG1642DASj37EZueY5SS6AjpeUq8K2TX2icd	7902	11175	11175	1617950700000
15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	1407	1395	249	6301	11559	jwLCYMUqzEbaHrPcqz2EkxgvG7H4MUXrTUavzee5HqFp3o6u6DZ	7904	11179	11179	1617951420000
15539	3NKvvoACrXQVAewubwhrtzXTSDhtuVVjChWwQuAfPgYYfcmJAdTA	15538	3NKeTsySP8JtuBG61MaoXqe9on9V3in4tbpwQsxrSfmTRy8HCV8a	149	1283	249	6301	11566	jwv2ufdufZRWAZdRYQuo43c3qacmUkvQqQc2Uirhc2iejbCKDD8	7909	11187	11187	1617952860000
15550	3NLk461QnyM3afHmcpBKGw7tkwYyJALgeFtC57NRVonqzVGsQb56	15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	1534	1071	249	6301	11577	jwRtMF1R2AuNa8Fw72umqoc7zuW5ex55jBv5dq8fUVMcDTWCoVD	7915	11198	11198	1617954840000
15563	3NLwYH3zP6VifK2rqeFxvea7ctMgDuwVEZ6WJX6zqaaMZZRW1h8Q	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1483	1030	250	6301	11590	jxSVopXJ4TNCDAJTYiSpYmVPsdg3GULjhhmYtyS45pVDzChWnoy	7921	11211	11211	1617957180000
15565	3NKPMzciqk8t1kvcBrMvbinAAC9NG4j6CxJpEtFgCHnZury8P4jR	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1445	1164	250	6301	11592	jwbpC3donCjaVybSFQKpYUCsvnYmvCGN7h2gy2RDKj3ei6QDevu	7921	11211	11211	1617957180000
15571	3NLTyjye6yeAZ8vtvhL9Rc5AA7e9FeBRcN2rcgJrpfbz9oJBPx4b	15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	641	970	250	6301	11598	jwxkLnVE9goV7MrygPGo89GymRnopQvoLqtv65WFuu4H3dKmkH5	7926	11220	11220	1617958800000
15573	3NKwDq5jDNLkAmAAkASKkp5eDr4PodeKX36JbAuSQ6dnFiggpJdb	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jw7Yhq1BECibziz7Ca1k6VfDcodTKnDWG9zNEjp6jcqjUnq3m1d	7928	11222	11222	1617959160000
15575	3NKmhfVauXptPQidKSLnMaMmpaMXTtbY8R9BSAFsJFjViNGL5AK7	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jxqfMQr8umkbDaoY93FRnsr5b9JMsPN3g5Xm9dMb8FhjhPTs5id	7928	11222	11222	1617959160000
15578	3NKFes11qGb7uP9vMgbQFdpBvPejqt9A6sqeh6hctoqHQMU9sNVX	15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	1403	785	250	6301	11603	jxP3LftTvcsXKRaeZnA9DKjVRRFDqsXe4SuW8F1h5nyk4MUxgCZ	7930	11225	11225	1617959700000
15582	3NLSC2sUCKhDgX7teRBww5YFuf2Q2gAGHG8VLqCWVgXpT7b7Aw1S	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	43	1064	250	6301	11607	jxVAerYYkVaj1HopVW2cAowdxPNFZbvroz46xNAPCP1bGCjYfK4	7932	11231	11231	1617960780000
15586	3NLJ53ir6h5PrKZorv44km1HWEpXuQxASdNWt5rbWWnUzTuAnt22	15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	1419	814	250	6301	11611	jxJJ6hPtkANrMhLFUzNM1AzTR1oTfJcaGkdVBsqMsDKXmvdTfRJ	7934	11234	11234	1617961320000
15589	3NLL1TmjmBg41EQnmob5kWgU1x5aStbvQgkwNuvhs2pmqRrx7EMU	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1476	1371	250	6301	11614	jwyzDZGDb4vpBM8M8M3MrNZ2GMSNYquzSAUaEE8D6TuLW6nT54o	7936	11238	11238	1617962040000
15591	3NKoh1xb8PRXKwEKxaaYCzFgMnT7bmf5QGN4gJNscLhKVYxiAQNB	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1673	1122	250	6301	11616	jxYXA3DYqxA4cc6WidTGLCTsEaJezAUGhZ7w4QotMCxu8p6nzij	7936	11238	11238	1617962040000
15597	3NL1Qz1PFisS92onc5e9fkk36Wd6GXjouFcgcEHhZX9ExHo8ySaM	15596	3NK9t8cR3io8VcCQrpJRhSBVvpiHttq1zXv38Nooyf5s1QK9nTrQ	1590	1300	250	6301	11621	jwQ2q9NboVga75FvYAzkdZaGen9mQuyi2ZKi4REPwtm5gYTGpQe	7939	11245	11245	1617963300000
15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	1405	857	251	6301	11627	jwcBtKK1suzcuFFWrvNSuyaxz26m2YwjCeC7nXdaJgqZUKrvUvw	7943	11249	11249	1617964020000
15606	3NL1BwqZK76wHPunNTCEQToYmLFdyuNJmZ4cV2r3qRUnmWE3Zk8k	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1609	1333	251	6301	11629	jxXAs2ZS4NeNCXjzyaT7ZM1NoSwp1DxDLyCzMvavEVKpJAnqmJE	7944	11250	11250	1617964200000
15609	3NKJrM1UBWmsrxKZaWphHyzv2G35D11mTxNGWZ2s9Xw2idC3RG2L	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1403	824	251	6301	11632	jxG34GS2kciWR1dJk2uD1z36zTqd6KB8R3aEKRjQ1UPnpTvrpVj	7946	11254	11254	1617964920000
15541	3NKGVY5nVLKCotsLPrDdyk8cvgd9bB6hKptPUqnPshZvhJtJaohp	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1403	782	249	6301	11568	jwLnaC51jcppciefZHaUkPXhnuz2B5tzLkh6MMcp6YX6vKMUVvS	7911	11190	11190	1617953400000
15543	3NLhZiMCSzRetndFVFD4yWRYokzjB21Tz5xePEwXaj11fwbYCDrz	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1622	1110	249	6301	11570	jxomXc8GAVzdKGHsVDwfTae2cb92k7SmhcpkszBkZedhVaFt6VC	7911	11190	11190	1617953400000
15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	1407	1395	249	6301	11574	jwQE21hjC1kucCKCc5i2qHBBsKknoKKJmaQY2yjVHVA7prKmzPY	7914	11197	11197	1617954660000
15549	3NLcHroop6vfDan6DeCVLGNvr5gEG2uMYprpBkevT7jgogYxH6GG	15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	1500	1171	249	6301	11576	jwvn4L74VgF9yi2xW6Ra5DxxZ3Qktooy8qfWWzko6DfQDwKrKmv	7915	11198	11198	1617954840000
15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	1642	1121	250	6301	11579	jwHhvCXEtNVSgzbX7cTMsLehXe22z1dnHM98gcBRgW49bjr4baF	7917	11202	11202	1617955560000
15555	3NKzKoQe6H6FDKMXuBt3zXKHxA4TNfpuAnks1XQj9KjMfPvyxKTX	15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	1581	778	250	6301	11582	jxBJcHnWAHR62GRNuMfxQCiu1F5cqDQqmaxBrfQ3XscQbmhDmEZ	7918	11204	11204	1617955920000
15557	3NL34hpbp3oJjYtCpGUQxWDryrqP83ZLvNZMdeuNbsuAVW3Jq7X5	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1581	778	250	6301	11584	jw9hepWpvZ7VhS1AznWZn9KKbZAioXW143ekPaaEp53dSnGTp7J	7919	11206	11206	1617956280000
15560	3NKu4Vb6XVEK2uEsQBgSosHvvYQG7PgQYcx9KA1GEXNcikHVENAX	15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	1610	948	250	6301	11587	jy11HKz4ahBszJRtaSv1dhGqGmYcfN34P1VdJewAGPFyGXtbLcp	7920	11210	11210	1617957000000
15568	3NL8MDLm6ttJ8so2Kqz7YxgoFfs1EBKYryqD6sRFegc7eMfXCf79	15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	1623	830	250	6301	11595	jwKKbqhTyfGe8yhM8Zh7Uh9YnnpnTpiB1hM48hjjeZsBznXPxMD	7924	11218	11218	1617958440000
15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	15576	3NLuKYh4KYFs3jUMH1VkyNiqoHBJs5JerawyuKL3m2EWfEwQDhEh	1587	1357	250	6301	11602	jxhyVRZhETRE8WZ8s8cr2UiZodw2XcqexwJ8UqyP8wrvmq2ZYDM	7929	11223	11223	1617959340000
15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	1405	889	250	6301	11606	jwL7zMqfT1FYKddT6GXKnjGeq2Kruai2N8GKzXGtVFWpCzKai6N	7932	11231	11231	1617960780000
15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	15586	3NLJ53ir6h5PrKZorv44km1HWEpXuQxASdNWt5rbWWnUzTuAnt22	1406	1393	250	6301	11613	jxntren4Jy2ZJarVVZ6NL6tPB51VFoPSykGKV8nXAiBBHDRxXYi	7935	11235	11235	1617961500000
15594	3NLXUM2xgnqmopAxnwqhfp5gDQYJJLuyy5uX2woiwL2w6BXFDK7n	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1407	1395	250	6301	11619	jxBVZhzEXzXq5SLsXdKSWmWya9zRiW9iKJEniuGNFWxJG4K4Zoy	7938	11243	11243	1617962940000
15596	3NK9t8cR3io8VcCQrpJRhSBVvpiHttq1zXv38Nooyf5s1QK9nTrQ	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1646	988	250	6301	11618	jwMi5CFC2LGLyH8vPA7XNiGh7GsRErnMgGD5xGa29aVzy2cF59Y	7938	11243	11243	1617962940000
15599	3NKX6QNVYG9deSuA3o3QrXab54Z3QfkLxhTurqrFEEaRvdWUxGbE	15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	1579	1143	250	6301	11623	jy3FSLnWwKodRqPHTizzWBCrtGGFEkw7LouWdTqAG8WcCZLrTUy	7941	11247	11247	1617963660000
15601	3NLHCexo4kk7utmJeRzL6hqXgudQHPzKE4jgYHbZPWg87DQd5LTP	15600	3NKxJg72avRiiMXnxnHaroaj5ATsK7cGq5hhfn1bdzp9u7F8FbmR	1407	1395	251	6301	11624	jwb1yES62JAhDCem3N11FEsBbtbAg1k2jipScmQS52oxdqDyjDc	7942	11248	11248	1617963840000
15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	15610	3NLm5tXS9CP6zX3ve4TJXWC2DPyAFPLEUnjXVyWhqX7Z2wwpwPdF	1407	1395	251	6301	11636	jxZCibMKamwMEckeDqfebZkDJVBfDZnG8g65ZgnYkhWiMyuAr2H	7947	11255	11255	1617965100000
15615	3NK44mJqHik4Ji8yM41XmNgMBXiWX6GcSHzpYhQtQ5cQFMYg6M8L	15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	152	1204	251	6301	11638	jx4Fp45BMdpZ911VHaytx7pBocDpQZwjHgstPmLwoYwqQGU2x6G	7948	11256	11256	1617965280000
15618	3NLe6sQJUeGCrryiKZU3smGNxg8U4qnewcikgwuPPvJ1GUbdyBGH	15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	1406	1393	251	6301	11641	jwaUyGaUwg25iwxpWdGf3VHC7PUcHT6nV3dTCLPLmYGKZpuGL6r	7950	11259	11259	1617965820000
15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	1587	1357	251	6301	11645	jwuL5cUZvbcqYk8QPcGZ21CML18348y76tyLGZYan7uA53abmYT	7953	11263	11263	1617966540000
15625	3NKNHp6EaWH3vjiKUJPTkPC9yXtKumcMhhy6mdt3U9EezoyAieUa	15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	1406	1393	251	6301	11647	jwgCsWpc8JvhEVS12hsd4s4AQU1avMfkAYcWnrSv6B66bsXRLkW	7954	11264	11264	1617966720000
15630	3NLNqYL8KLdRh1KqqHqdyp8Zqhh38qZxQEmCKH12FQJ5ynWdJ9B1	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1610	1188	251	6301	11652	jwQbVyhhRoJDg1rBbaJnCGwjGLwAoLXy7NYCpPPKNCmZJ2x2Ydx	7957	11267	11267	1617967260000
15632	3NKttiXq3q9gCYwDrYC8aHtbtWUrgyvDs6kM1niHgzz6yn6Asxjr	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1672	1039	251	6301	11654	jx7bBrRxjPrZBnWpwR3MGaRn6ciFSNi9MYDteWYFgWyEhuFpBXn	7957	11267	11267	1617967260000
15634	3NLKEYRRBtY3PTWkJBNTTQPKRj4dWfYHdPPA2opvEZMBCVoB3Eh3	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1448	945	251	6301	11656	jx7CQs2MGAraS192eT3utokFdQYcsSxgXgNkkBpEiQ9TNHyBGZA	7958	11268	11268	1617967440000
15636	3NLV3Q5aj5Lax4pcNDUSreUF5e2ZsYEunMssAcytCkg6mwrzsi4u	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1534	1191	251	6301	11657	jwKPrN93wLJ9xys3GoFBQHu9Mx5AffuVwvhDBBJV9CsNH48Jb22	7958	11268	11268	1617967440000
15638	3NL6B4gKdnA6fwMHMujmxme7C6cSrFSv85vx55fRxCCTwhvMJStD	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1555	1347	251	6301	11659	jwtngxATEMTkpDbK2ZfZrHNem8LQYBdkWotKGczSCrsZqrGMnSY	7958	11268	11268	1617967440000
15643	3NKsuND9K9emqKy4Sp2pnJbzrDMuZLhYdftZjDWdytJMWxj6KdQ5	15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	1536	1313	251	6301	11664	jwM39usDe6iTkuwbrgehLcDbY1AiXM14fpEaMXkVEjgAMXLJgG7	7960	11270	11270	1617967800000
15645	3NLEN4uD2nQJ6TfEVScdJ9UepD79AyE2ci78bRL8ZZV5nyf9bVKQ	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	1407	1395	251	6301	11666	jw7WwgjewSwPYD8sSEztwdCRMWXQocD37uFsNY7DBzz784h6rBi	7961	11271	11271	1617967980000
15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	15649	3NLssDMMfKXoXE23qXLuvC4NLamrKTrgkdwPXrg5ujmjwVmLqERQ	1555	1347	251	6301	11671	jwRFCQD5uh74iYtZLpXXQkcNRqVL7jWKfLeEmN4E6U972zmUSP4	7964	11276	11276	1617968880000
15653	3NK3T3UdMsLYXGEsiC3BpFQ8wgSzCSv38L3v2Ey44EfH45ax8jsw	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1649	1137	251	6301	11672	jxDeuqgwPfJgknvHwzYJcipiCtu9FJZkANB6V8th1mgRD9yaHjB	7965	11277	11277	1617969060000
15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	1549	1362	252	6301	11675	jxmZ55ZL2BNuCdVxpUEzFTQLjaoga2FXzK1saC9Pds629ZGkLeq	7967	11279	11279	1617969420000
15658	3NLQrmCm1rz8a95wgsPB4kYeNixu7jEdBwco5fUGSGxBMwmE3DYE	15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	1652	1315	252	6301	11678	jx1baprwveUthpZDEJrY9euhUvKHke6aGB1JmNsbaH9h1fHBbJa	7968	11281	11281	1617969780000
15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	1406	1393	250	6301	11588	jwjjnYvVJ96WGHP4mfATSctohLvoCCA5113QhADaUyJv1fpYEcL	7920	11210	11210	1617957000000
15564	3NL71R28hjvQ3wojw7WESphsdm2gvG4h6nsrqGCnTRnVeeawP8pj	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1467	1130	250	6301	11591	jwS5FvpNpeRViVbfkoqqfiFXD1zSchusopabz3Ci938ekm5A8Mx	7921	11211	11211	1617957180000
15566	3NLYmZJ77Dx1MBcjZien2BJgkbr4zwxxSES5Qo2g9zKvCjNMtgV5	15565	3NKPMzciqk8t1kvcBrMvbinAAC9NG4j6CxJpEtFgCHnZury8P4jR	1634	1331	250	6301	11593	jx9DhsM7EPYm1GrcRwVPxrDtd2pumy9wbMS8nvi4u3SMD3hAn3D	7922	11213	11213	1617957540000
15569	3NKbPtsqN629iFE8naDisiiKD92BxXUJCZMk2pvJUTtsVPFTEsK6	15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	1594	1200	250	6301	11596	jwrNa57zpPU2xmNNLJC79XQ3NP9m3gkQJjWMEemvLL7HiV6gK5a	7924	11218	11218	1617958440000
15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	15571	3NLTyjye6yeAZ8vtvhL9Rc5AA7e9FeBRcN2rcgJrpfbz9oJBPx4b	369	1186	250	6301	11599	jwhvJ1MkXZxfEsvmXhjf7SmTS2HwAiRFy7httTfnJPK56SnhUkv	7927	11221	11221	1617958980000
15574	3NKZvr9zvm7XKAPTBu2Bjb3PnroAA7tqEWTK7vjWHEf6sc3vqiW1	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jwM6iXV1Bm3TVtvXTGMLRgNsetCzLZLAhH7FVR63cYX4RRsPUuC	7928	11222	11222	1617959160000
15576	3NLuKYh4KYFs3jUMH1VkyNiqoHBJs5JerawyuKL3m2EWfEwQDhEh	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1631	794	250	6301	11601	jy1xc2HBRapaTFxRS4ztFf9ouqUfrB1CJ1H6VDbicXG6mKXZHTi	7928	11222	11222	1617959160000
15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	15578	3NKFes11qGb7uP9vMgbQFdpBvPejqt9A6sqeh6hctoqHQMU9sNVX	1426	1364	250	6301	11605	jx9XXxus2vTsCFaNzZ7hcSR6HmUCguBU3VEH3vtpgffbdWG2yUj	7931	11230	11230	1617960600000
15583	3NLxhrY4FpDbjvfbhmc2xj3uFL6dt3ABREF1ii5WnUpDCBM5WTeQ	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	1553	776	250	6301	11608	jxjNHhuTqHgyjm3aNHKsPj1F3oeCBN9BCFrs59xgTYckbQSbwZr	7932	11231	11231	1617960780000
15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	1440	1011	250	6301	11610	jwd9Bbxc42rQK79zznNumZ9nWEC3CHdm65NtG2nh23KDktkHczZ	7933	11232	11232	1617960960000
15590	3NLo7aBy7YjbsFqnWrLfqwNxVFW89izjndV2AQ1zW9VZMQbomoxm	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1457	1265	250	6301	11615	jxQdExi92Jd8uifpHVJqtVMMjPPZcLbTFWSq9c5JPhU7E9vtDd9	7936	11238	11238	1617962040000
15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	15597	3NL1Qz1PFisS92onc5e9fkk36Wd6GXjouFcgcEHhZX9ExHo8ySaM	1590	934	250	6301	11622	jwoyVhhhWcbtYDt7Aq9fjg7zvQw7QvFsEkHFKnppdKXdcxWLjER	7940	11246	11246	1617963480000
15603	3NL9kfdFjqAaXWaJu3GfxJ2vpfXaUyfY6jqfKc9JJRQryMYLvQf5	15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	1642	1367	251	6301	11626	jxzAsaCwMBVkzcfr4HCg78x3DRdoEq8e9EGkRWfHmPa4HFWWGTW	7943	11249	11249	1617964020000
15605	3NKoWc9JRBYBKjFTT3KTQYRnXf6TScn9R9Eb3BJQ2t95D2spBHJQ	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1602	1123	251	6301	11628	jwBT3Q1W2Bi3gVS6mbUsqv2a9KDggsDWej3svH5mLVt8yy9smkL	7944	11250	11250	1617964200000
15607	3NLr7EBtkQdeeeFDRABsbc47w1fRMuGMG7z6yDWEeV1QqoJJZMWD	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1406	1393	251	6301	11630	jxwzvc6Fj5FuoKNbnx1znbRU9GtEMXKDTf9HJfDpWpQ6kFLxhfL	7944	11250	11250	1617964200000
15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	15605	3NKoWc9JRBYBKjFTT3KTQYRnXf6TScn9R9Eb3BJQ2t95D2spBHJQ	1406	1393	251	6301	11631	jxjqnmF9e2uPorxrCRQ1rfzWKv9ztxxEbeMQW2vZf4ctMwS9ycJ	7945	11253	11253	1617964740000
15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	606	1295	251	6301	11643	jx8dBoJK6Cxy34Hiiy4uJf2LG4ViHGdxu29y2Lg879W2XKLjEKe	7951	11260	11260	1617966000000
15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	1448	1311	251	6301	11644	jx96drUtVEmYVkn3jJMf7SXEe1uBpppajram6qU9ToJtjz6qTkj	7952	11261	11261	1617966180000
15627	3NKRRajueveQjX9kwcAwujnNRitEjZcZkBubNnsPUp34LfiS2Ngi	15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	1569	485	250	6301	11649	jwdi8vzHxSW8d7YPAsFtEwVgC5S72mxq6N2ty14UTzR85gvHS1J	7926	11266	11266	1617967080000
15629	3NLKNiUR27pm6iBa4YmHuGnDHS1nwePDguXErP3agRUHYgNyCJMR	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1516	1168	251	6301	11651	jwyoKPRTQex6zmBtwFErQmKMHcRE91dSckoYu58a2yYyQkJZ1iN	7956	11266	11266	1617967080000
15640	3NKowRhHG1vHNFtHgqR56jdiyGXfwNFknphfcrdaadPrjVgk9cS4	15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	1585	1240	251	6301	11661	jxr8DK2CDjdhNUwgavju6QL9vppaAECoRNCibEdUpYUA1VccPuh	7959	11269	11269	1617967620000
15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	1619	1149	251	6301	11663	jxzHhubcS784sxDCpgZk7m8CQfNqpmgrsToXCiCsbb7UPSPUFWj	7960	11270	11270	1617967800000
15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	15646	3NK336W2tEYF62Hop9pzPVCqJ9e1t7HATMwH1wRULHMYVuQuWnkF	1407	1395	251	6301	11668	jxik8rMmMNQRCxcf9JdfygpJhG33BASKeXY5K8rVqfcjyfXr1Cq	7962	11273	11273	1617968340000
15649	3NLssDMMfKXoXE23qXLuvC4NLamrKTrgkdwPXrg5ujmjwVmLqERQ	15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	1590	1054	251	6301	11670	jx33bcgzwjKigqNURmwtx4mqC9vCvfYFt8TKEn21pnkzpFr1YNA	7963	11274	11274	1617968520000
15652	3NLAs36ANXo9WqY5zXBxhRGyTpRk1rJNktvh9imTcGK6WmcmL6DG	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1407	1395	252	6301	11673	jwrZmaGm46hzyxzZtD6E7duN2R8a1UaLTRpcRS8jM3qzniET65A	7965	11277	11277	1617969060000
15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	15652	3NLAs36ANXo9WqY5zXBxhRGyTpRk1rJNktvh9imTcGK6WmcmL6DG	1553	776	252	6301	11674	jy2srkrL1ffbUYsvxmdo5Hb68uG6xJbTLUGETEdYezUzskGBBfp	7966	11278	11278	1617969240000
15657	3NKyvxAX9yYK2tFWUkFNicEUA2G8phVp3Uxx92rbr9Ekk3cQbjSW	15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	1600	1372	252	6301	11677	jxYu8HGxy7TFhyqshgKxUc3oepcxfuHPA1o3YzhkWkVTcLaommt	7968	11281	11281	1617969780000
15659	3NKUVp5JSAixcGijMMDJzca222ZFvojcgPJWxQFQ2JPC9ZkRzLFr	15657	3NKyvxAX9yYK2tFWUkFNicEUA2G8phVp3Uxx92rbr9Ekk3cQbjSW	1637	815	252	6301	11679	jwBBhhHBzQzeCDAU5YnCb6NcAn7V1joFF2PyWq8LXRC8o7wkqBQ	7969	11282	11282	1617969960000
15662	3NKRArpz74TgR32bzXLG8mLR2LW3j8uXUJiBDzRfsN53SESwua4Y	15661	3NKonKZXavXtvK4HMLhqFj7AQi5rdeq7MH5ojQWHzFKzmcZo1Mqq	1637	816	252	6301	11682	jxPpHVEc4e5cjWkDq9KHufhPagiPCATWVHUHfMrnZokESq5THY1	7972	11286	11286	1617970680000
15665	3NKRZkeX8HDjTAXEGH3TsRvcWsVScp5TpDMhc1qJRAxVuLK7Y7xn	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1634	1331	252	6301	11685	jx9TunjDe2UTmz6c3sSnwGDvRbfgkAkLC1XAPzfWZV8ctJQGtZL	7975	11290	11290	1617971400000
15667	3NLsbgbE5unwi8FKJMcXeDzZ4r9TzbbRgMeFDNwdf2vpUTVBqHe9	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1675	976	252	6301	11687	jwHq8HGuBX9EonV2XsZT279kyNsLs72opGhcexXKXP4g9NADirh	7975	11290	11290	1617971400000
15669	3NL7gjnKTg3XLRhTsYRu2LVqosbWDYPbYiCcJZrUGz4FhMCDYt6a	15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	1631	793	252	6301	11689	jwdCmRc4rSgmP9SFG5uCT2S8njZNL9Rjdtn24NwrnJPeNaryS71	7974	11288	11288	1617971040000
15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	15569	3NKbPtsqN629iFE8naDisiiKD92BxXUJCZMk2pvJUTtsVPFTEsK6	470	1063	250	6301	11597	jxhoR6K9dCGQu2QX15bJrG1eb8yupVPnpmocsxGKBuh2yBfdbXw	7925	11219	11219	1617958620000
15579	3NKHT3sH9NRZcNnc9d5765vjs1XcEswtFzEkZExmeZP7EtcEY6ni	15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	152	1330	250	6301	11604	jx1197ncZssExgiy6DP9d5AdJGVD57u6qnm4q21sdLmwza6iZxj	7930	11225	11225	1617959700000
15584	3NKKgyGGu5fNpfkveC2C4w89rUQZSoBvKVg1XLAMCiVtxxg76zJD	15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	1652	1315	250	6301	11609	jx9vKC33QqWQWw2CRWcLV9VNwf54wUTrLLHSUxRvvKv8nwHRnTS	7933	11232	11232	1617960960000
15587	3NLV1ssopA3gpN5EvBZairhkLgYVRj8RJmRS6gVLRJC3HwV1TZ9P	15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	1406	1393	250	6301	11612	jxzAcZTFGCVqz9Cu6mwfof8gXAayqMdsfZvsJEEpfxzXhvvEeo9	7934	11234	11234	1617961320000
15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	15591	3NKoh1xb8PRXKwEKxaaYCzFgMnT7bmf5QGN4gJNscLhKVYxiAQNB	1506	1247	250	6301	11617	jx4atHHQNY2eb42JsNkzyeH5xZFujR3zH8ncRnFymQQ9bZ2LCHm	7937	11240	11240	1617962400000
15593	3NLZS7WcsneAJWhmQiStW19chEkpdXrAF4wmYn9Cp67BcoqvyPA8	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1646	988	250	6301	11618	jxPZNw6YWN8v9syo6twmwbYUsGxSTxcgrCpWFEntDowiYbYXo4y	7938	11243	11243	1617962940000
15595	3NLikWozSeV3nG3BeeyYZ7ijMf4ijfYZuNt5AWwsZBUnBrJrqB3m	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	152	1084	250	6301	11620	jwuNTdpWkuMLv6FjucFoGx9XgtEhqZ5TabNyY2HPfwxvnFfC5xy	7938	11243	11243	1617962940000
15600	3NKxJg72avRiiMXnxnHaroaj5ATsK7cGq5hhfn1bdzp9u7F8FbmR	15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	1579	1143	250	6301	11623	jy3FSLnWwKodRqPHTizzWBCrtGGFEkw7LouWdTqAG8WcCZLrTUy	7941	11247	11247	1617963660000
15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	15599	3NKX6QNVYG9deSuA3o3QrXab54Z3QfkLxhTurqrFEEaRvdWUxGbE	1406	1393	251	6301	11625	jxbYNYe5dCj713cKR1NhRL3PaxSRvT3jw1ykZC4mj1cja76L7kr	7942	11248	11248	1617963840000
15610	3NLm5tXS9CP6zX3ve4TJXWC2DPyAFPLEUnjXVyWhqX7Z2wwpwPdF	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1578	1050	251	6301	11633	jxzVdjnT91dQaXUf69UozeXSqH5VBFrBKFh3iXRCwSC6DfVxtqz	7946	11254	11254	1617964920000
15612	3NKEDn2nnPi9DmwwweoLFriL51potoAwtbGnhCzEdaC7yrdkkFi1	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1508	1261	251	6301	11635	jwnBdQSvSUPvFjC66A7nBkS1283poCU4MCTjuiCWCASiwWu3dU3	7946	11254	11254	1617964920000
15614	3NLy3fbSTW73TmRip3uEzrRmjCq8GfuMpFY1QQHjdwmWPhpaSNMo	15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	1403	782	251	6301	11637	jxXvwyZttgVCQKhUSrLFpmdjgdXypxU3mgXaKHdUTZMArk64PnR	7948	11256	11256	1617965280000
15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	1506	1007	251	6301	11640	jxE6qfBbJtggUkVwwe4eHzzWGhKbCVJKMCzNMNVdV3wnoPfMtJU	7950	11259	11259	1617965820000
15619	3NKY2r4J6WdVtEzDpy2NPWkBVWp5yCq2mY2irHBjLU8EuRJ8TMbM	15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	1406	1393	251	6301	11642	jxY3EDK5A1zUXt7REkAeywaAbgS7V3e8V7tg3BcrMc1uZcmzm6c	7951	11260	11260	1617966000000
15624	3NKrHoUZH6yQMiCqBVfnwTvC79Q86q99eveG1KZgFkCQhRzLePGt	15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	1599	1041	251	6301	11646	jwS6mgGoqMyyk5fuNJWqw4EAsXuvGvmkqppVzFsNFjsBMtatAEF	7954	11264	11264	1617966720000
15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1581	778	251	6301	11655	jx1r96t2ktyde6EwXkPJy8novBTQmUxavkWohrYNuHXvGypmLHj	7957	11267	11267	1617967260000
15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1448	945	251	6301	11656	jwPz5YgKu9HKq2ECHmYX7UvU7njfoTBmrkCbt28Kje5FSBGnmGM	7958	11268	11268	1617967440000
15637	3NLDjLWXRZh319hasEKfKfqBMDeUh5PRR3YTwmfyYr8wtiS29b8K	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	641	1090	251	6301	11658	jwqTpdEuYtRkJCvjLHpsQ4swc2d6vUhsm8xUzovPhss5VvFJQ5T	7958	11268	11268	1617967440000
15639	3NKQaqma3f2YUfzPTZc67ecRB8qmrnmytBzs372gFRRiQyXJApbA	15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	1448	945	251	6301	11660	jwYbc1xAEYYShrgudFYg5ANsfqM2LXDHJUH2XQUzE6uFPQm8fRZ	7953	11268	11268	1617967440000
15644	3NLwNvvvRFT8WuzfH2VFmDqfbxb4xcrmXjAxgeZ24Q51ddLzuYJY	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	1445	1290	251	6301	11665	jwExHhcxDVFtpjtoapNSpDMZPFf4sHgFYL28gGgpANj4hDLqEpn	7961	11271	11271	1617967980000
15646	3NK336W2tEYF62Hop9pzPVCqJ9e1t7HATMwH1wRULHMYVuQuWnkF	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	75	75	251	6301	11667	jwdzJHGYi1ZhFysH7EtACgsZcNk2kBEymBKGUQvGHdJabXjmPfE	7961	11271	11271	1617967980000
15661	3NKonKZXavXtvK4HMLhqFj7AQi5rdeq7MH5ojQWHzFKzmcZo1Mqq	15660	3NLhvj5N5kqCHvePbTs5swsfH9d1jpAqUFAa3uWPFotvBkJkQNGY	1440	1377	252	6301	11681	jwHdxRtcFroKhgaCCYzVpeYBD35JmCzkWzPM1uMnN2nazBHp4b3	7971	11284	11284	1617970320000
15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	684	986	252	6301	11684	jxm2KTAhaTAoUPpCYadiUvLqeFpRUZhqYvpPsSrbHnMosdPvtez	7974	11288	11288	1617971040000
15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1646	988	252	6301	11691	jwV28D3p2xe14CH43R4CSVYPhyLtVTkEsP3vX2pLYdyE4KRBwn5	7976	11292	11292	1617971760000
15673	3NLFCxYD9uzTZMCMNDMpR14XuJakARKdpTnudgVTWkHPGjxP24p9	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1646	988	252	6301	11691	jwkPS6J8kSjB1f95wgY3BZXYCgGrqS5ey5KHgv9DhHMyPjmBVY3	7976	11292	11292	1617971760000
15678	3NL8iTwGsG8ey1k3gLBxdhLB39k3UNY6nALxPK1v9CDoFbokQLXy	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jwiXAgHGt448KpMZuua7JUYdrk3B3vyQ5zAC8y1H434ARXGKjte	7978	11294	11294	1617972120000
15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	633	1138	252	6301	11699	jxpzsp4QmrbKyevhwe12kWTVzyPxFewZ2oeBDrCMHin2UqQAQL7	7979	11295	11295	1617972300000
15684	3NKZdqHwGTWCVWG9VGnLrBZsme3DuYmTkLkLYSKX9u9LGd4pxvrX	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1445	1290	252	6301	11701	jxs2kzN1hRgynYzaF2giTz3fo8HJNTKXomxusCqEZAfmZGAUn72	7980	11296	11296	1617972480000
15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1594	1326	252	6301	11704	jwsvHykCxxMobXaBZry2w7qgbJZ8oZ2eajWRZb9bu59AqeM7i6d	7980	11296	11296	1617972480000
15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	15691	3NKxU1viFMkeRD6UZDaLDWsDZDVy7fHX3LGYU7qjqBezRp8VMEKj	1593	980	252	6301	11708	jy17dPmr7nhFeBUj9TM5pu2x2hJUP3t8y4u4VbNobrfBzt8Xtrt	7982	11299	11299	1617973020000
15698	3NLJBndbSvxH4y7cR9UipsZmcvtVNbN68AXnyrGv86oKBBKmYypB	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1627	1385	252	6301	11712	jwVqgi4WAAmKE4YiZph2H6S4G7yrq1WaFe7DrFXmpB1K1VVcxa1	7984	11301	11301	1617973380000
15700	3NLfmu5KksCZSWXyndf2uTV79UwUmzHDaqW7riLE3rDRwmcdCHAj	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jwfRqWtDWQcMthevJDSmX8eZBAXwUJJ7Gx7Ntbfkrb7c2k76U4B	7985	11303	11303	1617973740000
15611	3NKunhEWZezNgNjtAtU6Vhz7QNRNyRyZb9DKFMXEXCBGiR4BnMS7	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1553	776	251	6301	11634	jy1BBnSx1dFsdc8ncYsD5hCowet1K8f9qCZL19XARTRekEAaEhf	7946	11254	11254	1617964920000
15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	15615	3NK44mJqHik4Ji8yM41XmNgMBXiWX6GcSHzpYhQtQ5cQFMYg6M8L	1500	1051	251	6301	11639	jxwKNrQhydTNNHeygH1pNeHWJd6eCMcaV1dbxqWqvkW1oQrY661	7949	11257	11257	1617965460000
15621	3NKQNqsPWBK4srMk8Lh8pXJQh5Hdd2DUAst67EZLtfK17jrmTc1N	15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	1448	1311	251	6301	11644	jxkKDHbqNvE4FMXaE924xahfzK5EfnHXkbg6Mx68ycHdPTKWLWK	7952	11261	11261	1617966180000
15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	15625	3NKNHp6EaWH3vjiKUJPTkPC9yXtKumcMhhy6mdt3U9EezoyAieUa	1460	1198	251	6301	11648	jx98fYPb2DkDmEEJ3Q1F6W6SWWsrvGA69Jp2zWxcQoVbZSdhrH4	7955	11265	11265	1617966900000
15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1569	485	251	6301	11650	jxDr9T3rbRejPfMPNp6M7qHnuu5sNYHEHstHzU9asyEvJZFSJC1	7956	11266	11266	1617967080000
15631	3NL7NYkmnQeUsBuJXjKhze1emZCqbvAhBUqQsTE3YTPURzvNmRom	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1503	1031	251	6301	11653	jwDWCtfhz4TCXEZF7nL6kmjgsTGSNiE7WppxqXSHmGPykqbnvVq	7957	11267	11267	1617967260000
15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	1611	1095	251	6301	11662	jwBsNA1xZU9RmhL8sxtW7RjjpRE2uNrZimDYuLsj9SuKzUvwkS2	7959	11269	11269	1617967620000
15648	3NL1mHswvpWr28bxLhAQroDLx6fz2bLE1ySTY8fda2BWV6KkHYHj	15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	1675	1216	251	6301	11669	jxQvN5mSBoNBgHk9uu772BnUGVuza3bEtR2PpyicLGA8zUmjHRE	7963	11274	11274	1617968520000
15651	3NKPLumCf3AGV1Je6P47SpJ5psCwYvN4aze4nvrRiLJhGafXNLud	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1649	1137	252	6301	11672	jw9Nb8S6jCdLxBCnGJK2GTCZ6sf2CdDdZwNWkZFBNNXWDy2GXFU	7965	11277	11277	1617969060000
15656	3NLxFCsBVayqtgXuDrWfwSo6RRTj7ish92ty3s6Xp95rhGKYWoyv	15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	152	1330	252	6301	11676	jxDmcUv9seYVco6QPfvAMizFmRngz9in9RbHerQcQzHtECHQq3s	7967	11279	11279	1617969420000
15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	1501	1234	252	6301	11694	jx5KD5VSJHypTbnUmju6mhpGNk1hLHDz1d9RHVvaEvjXFvU8Lij	7977	11293	11293	1617971940000
15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1467	1010	252	6301	11696	jxAnZnQcB6kYFKqn8TZVee4VrXT4RvNuCDA1x67n5JbGQXu3iGT	7978	11294	11294	1617972120000
15680	3NLqpaKfXbs9SKDdRFQGX8RSWs5ME3xodx9Q3dWkaRmxY9bCgevF	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jxLEreSQzEzqNN4gkYxyzWmp4iLA6jFjLimraJJm4exSQNGzdhC	7978	11294	11294	1617972120000
15686	3NLSk4LGSja7eLgFvEG9YawjLVdLsQtwzzM5gU43LAKRcGXYikXM	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	42	1115	252	6301	11703	jxmN7b12mMFuyoJ6VTcKsQyyQLSYRUf3RrSxD7ZGMy2ohqujyDG	7980	11296	11296	1617972480000
15688	3NKJZwPq3m1Ld2bV4UP86H7xEjis6RbV2gPqN29C82mhK1Y91NMM	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1445	1290	252	6301	11701	jwLzrrYSG7NmbtE37gdFkdKYmF4BKcWwvj4s2BReULwwyQoDPWM	7980	11296	11296	1617972480000
15695	3NLYQTPkZC4dpvig8RskoWLgtMwqGXnBBmz8dWdrokbcf1koU31D	15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	1651	1175	252	6301	11709	jx4ugzLsmUBEKCHVR8nFXUZe5bSUwEnuMf8qozQD1inPA7FfRFW	7983	11300	11300	1617973200000
15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1553	776	252	6301	11711	jy2V5mC5RadvjhGV4rqEcadQ7WWxCyAYhEE9z8HrKJ1KcctrEio	7984	11301	11301	1617973380000
15699	3NKNhNrcNb1MEcQBh2u2bATuADHHcjJzSFTXMWKNedW7wZBYx4L8	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1631	794	252	6301	11713	jxHtiafpDxBcN9KLBMJuWhThP2VX5DBUoYLwe4Ptvze9gsACEtL	7984	11301	11301	1617973380000
15708	3NL5FQ4zfkwVCrSZoLHuXg9pBTdBXvKwaAgEgeHhGKD2dY9JYzVo	15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	1588	1392	253	6301	11718	jy34gFkDqTxrKzoKSQYSXn1NXHikvRGvSRvSgWKQJJ8T4qwvGSM	7988	11306	11306	1617974280000
15711	3NKUtn2J1gmwEaN6n5fUuyqCHWniR2LSQw2DPM18Pv8cdDBcLq9A	15527	3NKhv97EPJ68DoCVNyt7F3B7uksdLYTb36BubG3dNfY9UAN2sia2	1444	1381	249	6301	11720	jwanMum7TrQmVVgGJTTP1jEDEPtB2UaEr95kb1F8r3ZGV9V3G8P	7902	11310	11310	1617975000000
15718	3NLahEoULqLiPqTt9HmQURPHUcoQW7jN93LAytiNjYCVNBJcq118	15715	3NKuP4NAdPQwztr8Ry1GrkrQe26UWEjVZVBJvHyQyjwz993BWdzh	1505	276	253	6301	11727	jwrYtumxRygC2BLVSor9M6FoxccUrNkqbU45fiUhoWtYYnjcKnN	7992	11314	11314	1617975720000
15723	3NKcNUC8MRRQTCiDaqyxwRtKW22E4tWT3wTuBzHEUQKToxd3QMZN	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1407	1395	253	6301	11732	jxWGkRXx3MghroNZTu8Atr3p621VRoCBcm1vhEC451DsBsMVNgz	7995	11317	11317	1617976260000
15730	3NKP3RXW9oTkkBdEfpiw2BHHryTWuV7Qhdc2SzPGkK8mrNoeajwN	15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	1516	1294	253	6301	11739	jx9S9kxCDhd6bGQpcjiMr9ns1LN9X3y5vS843Q19DQd9XmAAFtT	7998	11320	11320	1617976800000
15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	15732	3NKgGoLv6UES5d6EDtVuUoVo81okGe6saSZxUyYbqaqUHh3XibTp	1406	1393	253	6301	11742	jxFfFDi4hnHRCZaXjbQh69WZt85NXFLF5zgFgCjPuYRxJb4Ryrg	8001	11325	11325	1617977700000
15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	1564	1092	253	6301	11744	jxRoZdsHk5Wdtb7CfZuC1gV5W5KfdsMqUMhxejHserZPBbnDYVw	8002	11326	11326	1617977880000
15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	1455	966	253	6301	11745	jxaj8opmWCFdEwz47CELMcYzVhRWvsR15AyPEzBdj8iaDvZRJSX	8003	11329	11329	1617978420000
15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	1642	280	254	6301	11747	jxPv1au6njMZ2ACiD25thaFmPKkSxBm47GdMoDF1HQS47F1BBz4	8004	11330	11330	1617978600000
15743	3NKr8cFvp2mCSbGn6EKnyXomY6bnVL2gQwyYSXia4u1mF1Fotxfz	15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	1406	1393	254	6301	11751	jwG8CMpmzhxjNN4F1w3vXUYuYLYTYPUjypG7oGnSdMYrKzFAdPU	8006	11333	11333	1617979140000
15749	3NKjAyzAXDaMxneAoCB9WbYtGGTggxkThWvNEjAmcuBTCH4CqCmp	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	1542	1304	254	6301	11757	jxLj67HDdV1sacG9f2YyGYQcJwFmsqMgEdVEYht5Mc3YKti1gRs	8009	11340	11340	1617980400000
15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	15750	3NKQtfG9qamY7DW7KLmqCFFBHqJgE5HzbAMb8k1RjCNx4HuGBz7B	1577	1201	254	6301	11759	jxVJTvMb38PLwgaXw4Qq3wEYWcGNPNZR4tWa4H93QMKBA6cJdUE	8010	11342	11342	1617980760000
15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	1402	892	254	6301	11763	jxg9Cx3c27xPnoHwDaV1NWr3sV9TmgpBKQYvSmiYeWdFSkGCnCh	8012	11346	11346	1617981480000
15764	3NLbrH2m69MrzPBNrV56fs2YZtPjQrb2LKxdpnVgZatDB5UV8wwn	15762	3NLYBSuK8Dtw66x4nBwqYCRDj2BaHs1ubyCU9nbC6pcDS9RV9GHM	1407	1395	254	6301	11771	jx2u4PMy7VQ4MskBnM8GUyKkB67khJ2NpwkAwyZU7itmPFAFPqu	8017	11353	11353	1617982740000
15660	3NLhvj5N5kqCHvePbTs5swsfH9d1jpAqUFAa3uWPFotvBkJkQNGY	15659	3NKUVp5JSAixcGijMMDJzca222ZFvojcgPJWxQFQ2JPC9ZkRzLFr	1402	796	252	6301	11680	jx2DJ2P7KZar2n2Xu5Yzf4bJYWW5hvP2WDovJLyPJtUaxxyM9MX	7970	11283	11283	1617970140000
15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	15662	3NKRArpz74TgR32bzXLG8mLR2LW3j8uXUJiBDzRfsN53SESwua4Y	1581	778	252	6301	11683	jxwBx17yGh5Vkr5kTgRutXTxr7rSVEhBM68q9GHe1D2nwFNW5tK	7973	11287	11287	1617970860000
15666	3NL8GScXe71PQrxhjBpniRxRaZNhUrSiiFrRSoqrbnQey7nudZ9M	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1407	1395	252	6301	11686	jwhWFvE55FSibf6B3qtyraQ3LXD9XaihDw9dM2oi9tGf1ir7Y2S	7975	11290	11290	1617971400000
15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	42	1361	252	6301	11688	jx8HZj2c3PrtWyXDfHf9rWtybgxrfQVTrg9pdqRKRBRJwkrbHga	7975	11290	11290	1617971400000
15670	3NLRPFtfg4PK8Fq2DnnWCKgzXB65oc9i7JasKJ1Mn9zvXxEzj6Vc	15669	3NL7gjnKTg3XLRhTsYRu2LVqosbWDYPbYiCcJZrUGz4FhMCDYt6a	1675	976	252	6301	11690	jwQxnzHkBeDbe7ux4M6UfFkdjUaEcCr6uPRLnLitAGokpJcWJv8	7975	11290	11290	1617971400000
15679	3NLu3mUjaDprmM2z7q1wY6E7MWKpP9VYHwrG8SUeq4dRrEoWotga	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1402	796	252	6301	11697	jxQhjrvhX8LbgEXT6GwZXK3yeGhq6jnJEr9EdKxu5Jw1UnRkZfn	7978	11294	11294	1617972120000
15681	3NLRNGvK9gotitM2wbDK6sbYn3iRmoHnrem4ZaQFYRwaPBBr2uSM	15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	298	1308	252	6301	11698	jxykVw3UCpejF1Q3fUPbLwJRhR4188mqjBx41jTekYwvns3UVnK	7979	11295	11295	1617972300000
15683	3NKcsi7oqmX2KMnsTaNgtbDiaDQ71eb5pcyC5ymW5aDiLWcsEoqq	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1447	701	252	6301	11700	jxbKZRsQjeds9wWH2pftMWFqAoeKFa3jvrqarFP1yMZhwu3AinE	7980	11296	11296	1617972480000
15685	3NLyJy9x9SajyUcDNC5eaKxto4j1nhoUyC5mtD7kjRJhWs42KTdC	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1547	1012	252	6301	11702	jwm794mwQmihwPq5HyWwwGDY7mTksAJ7o9SgU6xmtq7X1em24aJ	7980	11296	11296	1617972480000
15690	3NKR1f3kFFsrteQQhcpS3XoV4qEtapZKGM2LUqCMF7RUigfuZSCp	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1500	1297	252	6301	11705	jxc1zryAZAerEcgbgPzT7wPmB4bwrdU65oM17bxzoFvNPdFsKMy	7981	11298	11298	1617972840000
15692	3NKsdyg5dWZgUQrroyzUaFS54GgMH8JKDq4L2nszqhkz81inZyp8	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1593	980	251	6301	11707	jxh1rEMKQXxto43tpWDkJ8oBwnGd5jVVWkptuRNTtjcXEJFHjhV	7956	11299	11299	1617973020000
15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	1651	1175	252	6301	11709	jxRujxkwhP9u7REAqPkVRqcJtHJTSwZ6og7WnGKhjazWsWn4byd	7983	11300	11300	1617973200000
15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jxH6vqjoAxQYf8R4vJNDBRsdwstSg2C1GdXj9M14UNQaAwwLASD	7985	11303	11303	1617973740000
15703	3NKUNzi9dBANL5Bxd2VCWjSQqY9dWVePoGFV9rmfwfLKMqcmzJpU	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jxCdLWV8k2fUtj797EBEBdqMaDeEFXq1rD1KAeCm368VHYPDjW4	7985	11303	11303	1617973740000
15705	3NLDBqDvy3Gzv5aPfZSaRQnWGFdse52DD8zHQrHc2Hpwk1F1ADXu	15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	1637	816	253	6301	11716	jxJqYnEgiPnGWNotoeBaG6k44N5sMMgnEuincNuCkcrCV581U4v	7986	11304	11304	1617973920000
15713	3NK6eUxisftMJe4N8opGk3b5Qjm1cXRvUNM1CdLdLGFiFCMraA93	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1460	1198	253	6301	11722	jwrYmqeLvoaG4eTuZcTXdQ3ZNjc6yp6UAbXjFdiGWQwrsTztiqm	7990	11310	11310	1617975000000
15715	3NKuP4NAdPQwztr8Ry1GrkrQe26UWEjVZVBJvHyQyjwz993BWdzh	15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	1405	851	253	6301	11724	jwgd2fxQmCTvakKPGFnA6vkTrgCFLSoCqgz3hsT4qN6qBtDHzM6	7991	11311	11311	1617975180000
15717	3NKoqAuw2HhM9dW6kgbtVsHTNBCZmZYaVf4ywg2UjNx7z1QVWU5Z	15559	3NKvmoNKFsKTiHYb1dHGvNNtTUzB2vzHoo7dws4uSqPasA1uG6Ez	1507	1034	247	6301	11726	jxuk67cj6mfSMF1DeZW5YtvGyqN3mvBNNs1XzkSNDG6ch6tZdwB	7844	11312	11312	1617975360000
15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	15719	3NKkgXocgPZDCKyyPQqKhYTbWs7VuBA3w4bUioc4e6UecMDCczY8	1451	1292	253	6301	11729	jxEkyA23pt98rAxXwaAMhQwCz5y7PukhZfc3nK6HXJN7GD1Acnc	7993	11315	11315	1617975900000
15722	3NLYd2QePV8nxav3KCGcnZgyBgmLE42yjVuwuJK1Rm2ccDs9j2sE	15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	1611	975	253	6301	11731	jxgHx89zEnuk6UYMzrgxJd2ccxTDEUFnB9eBP5dFm4AuDURKG3X	7994	11316	11316	1617976080000
15725	3NLCBM2tdE2KQKhCqxBbC7a3UpA5iVdoWoZo6dmG8FKSAAe1ynUw	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1406	1393	253	6301	11734	jxD5wVmeVggeAKGiHDBE35EPNzuv67HYV6Z7cGpc8JYRVuB8BzK	7995	11317	11317	1617976260000
15727	3NLxWDca7EqfRJCq6VRxz9ge6F1szYmjzd6qTALSvP9DrZbW8RCY	15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	606	1169	253	6301	11736	jwhedv8Uz2xeaGaTyFNyfgFfofwWEujiArvv4WYjA7eBMwYRMbw	7996	11318	11318	1617976440000
15729	3NLBHZ7CcFeMtskpPBr4eLt9sXtK24m1Kqx1MdpZvQhRWQAUQ1mj	15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	1467	1250	253	6301	11738	jxJiTaMxPUVkt8Q5GEH57A9EJU2F3gqDDJCZNLb5b6zR5nH6QXb	7998	11320	11320	1617976800000
15732	3NKgGoLv6UES5d6EDtVuUoVo81okGe6saSZxUyYbqaqUHh3XibTp	15731	3NLByzjNML2Ya2mRHBYvKiv9rwTA1NZJB7FrJkrbBsrpWs8S9KDm	1668	1244	253	6301	11741	jwMo4P8QviC8n5y8WWRAfvZ1Wg3f6ksvVUbjwHLAuhF4KGugCzJ	8000	11324	11324	1617977520000
15740	3NK3aap9ithYtays6P7RCAsSNgfFtwdK5T8jXGZ9o8ruqDRB4oQB	15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	1546	1093	254	6301	11748	jwWQsiDAPgiFR2FWEnkqsQ1RMqYjqe8URppFKmB6ktzLfs4fCSv	8005	11332	11332	1617978960000
15745	3NLPtKydjYLUess249CGpatCJ2kTJFEfqLGFBkBZWDrf8gKiCSvw	15711	3NKUtn2J1gmwEaN6n5fUuyqCHWniR2LSQw2DPM18Pv8cdDBcLq9A	1444	1135	249	6301	11753	jxnPoqNJqa3GWpJacubYXrP1UuETTUq4mWc6aBBcfMQaNG9Rbm7	7903	11336	11336	1617979680000
15747	3NKx4yav31DHPYq8o5CWQL1r5Q97UpayuWQHyi2C5Rum5dubeYBm	15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	1518	788	254	6301	11755	jxJRAesGuAg3DQWt5pX2QsJ1dg5TdXfcPcPgR9s4bWnVouFUFoV	8008	11336	11336	1617979680000
15748	3NKWemd9MJnXS1kZvtzpWkXp9Z8vT65wS5iyncZ2fWGqp4xatxi1	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	58	1281	254	6301	11756	jxnYC5pLsCgodya53XRbWVxzMkft9LyHPCQcYLfSRdEFenKTG45	8009	11340	11340	1617980400000
15750	3NKQtfG9qamY7DW7KLmqCFFBHqJgE5HzbAMb8k1RjCNx4HuGBz7B	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	1633	1144	254	6301	11758	jxsUs4rRPNkyKXqResANfSML1RPzsGP9jFLLMVo4rTt84AhSNRA	8009	11340	11340	1617980400000
15753	3NKXgcAKTtCbZyHwkYKALxtipA7ptKwsmYaD8VA4d7uyeDWttRYk	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	470	1309	254	6301	11761	jxB5b9CQYKNHG7mynzXcWkVS6mxXc4P9h21LK6TQfkZ9FeuprLK	8011	11344	11344	1617981120000
15755	3NKmqHdKW719DWPm1FuzBr7789CajngRKazFj2AS9fRiTDpUH5B3	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	470	1309	254	6301	11761	jxdXGPstuk3zzvesLsXaUDYUT7eMyvvdb9vTwtrjuAFJgn3DMYF	8011	11344	11344	1617981120000
15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	15759	3NL6M93bLyvEG8Y3FhT2ZYdxVRCVLwVoUwghy5mZ5F6LdVZXt8oV	1587	1111	254	6301	11768	jxiEACom1meoegkxr6FGDANpXmksMbBwuuKqXSa9qixzsX7hnNG	8015	11351	11351	1617982380000
15672	3NLsyFx8VkrXjDtP8LMwLCY99sc9npYLFYw69tK23CjFm2PNhnVe	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1590	1300	252	6301	11692	jxU45k2wghk3Z2Hqw9mbEqvVunEnXw8oWeUSmeAe74wozKxvAaZ	7976	11292	11292	1617971760000
15674	3NL82WnwV3aCcNDGzaBLi5Am8UKPvjCo6umonhiZzC3CnWyWWmBe	15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	1634	965	252	6301	11693	jy1bHYcjb7VB135quT55zezVNFunSE1KBiF3kZSQc3vxgGiVbgD	7977	11293	11293	1617971940000
15676	3NKgjwwuM2pruYLQHpDyVdoBrQAc8e13UYA8BNrJzBkudtiGPEXm	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jx2swvqsJoa4QTVY8uMzKxKgFJXeB34eHCNakk436Q8yirCfQxB	7978	11294	11294	1617972120000
15689	3NKcHhjNLRxr1S9KSKVpzFMd4769qJCyMuYCwUeCZL3QJ7RqsVJ2	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1500	1297	252	6301	11705	jxxzAkj6WbrRMgnQ8rcUGXW51uKPr1rpp1hq3nNy2HWLHRrHJ8j	7981	11298	11298	1617972840000
15691	3NKxU1viFMkeRD6UZDaLDWsDZDVy7fHX3LGYU7qjqBezRp8VMEKj	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1573	1318	252	6301	11706	jxfe2RJPzdiZtZBX2535JHWvRjhSdskyjpB76L44KvD5KgfJTxQ	7981	11298	11298	1617972840000
15696	3NK33LZzi3bohgur6y8UddiYufqQfKksinSN4WjjEueRS8Gv6GVJ	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1403	780	252	6301	11710	jwvkPzw6ghZQSAE9BsJMfkBpeD3n59s9AAZhJuuiyYjj1VkeEwo	7984	11301	11301	1617973380000
15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	15705	3NLDBqDvy3Gzv5aPfZSaRQnWGFdse52DD8zHQrHc2Hpwk1F1ADXu	484	1073	253	6301	11717	jxiLGt2WDUcoLEY4vtjqEstD8yCJ9SGn6bA1YV7FU8w1bChUguY	7987	11305	11305	1617974100000
15709	3NKrVvdwYNgg1UzZwfe9mFi1CSmfNPC4T5m8QjUwJyRKh76jb5Mn	15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	1588	1392	253	6301	11718	jwKYTqqyYzvPhxFV8bnDj8Qxx5epVTgCMKUB3EFaWtmWqompyzR	7988	11306	11306	1617974280000
15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	15708	3NL5FQ4zfkwVCrSZoLHuXg9pBTdBXvKwaAgEgeHhGKD2dY9JYzVo	1553	776	253	6301	11719	jwXsfu7SteR5eSHrg1mG67zixXudcgyMyd3GNN1qxsFGbKQR4r9	7989	11309	11309	1617974820000
15712	3NKmZTNUZfgWo6DV1bBtcZLLz4ewBfvvAfsD5HEPmLJTbS7RZdU4	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1444	1381	253	6301	11721	jwEeS6o8WyC8eMk2fuXLexqRyAkpHXXmw1zpKtpnVnMBWZVcLpc	7990	11310	11310	1617975000000
15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1577	1081	253	6301	11723	jwCig2Fo7dDx9BNkfsERgxGgV1bFAuf3PCjcrZRP2hTwQqetCHH	7990	11310	11310	1617975000000
15719	3NKkgXocgPZDCKyyPQqKhYTbWs7VuBA3w4bUioc4e6UecMDCczY8	15716	3NKT2TJcLkvftuwU8XKGaH5UNpDsSe33o6tbUBrg34Sfw1wFCDFS	1505	276	253	6301	11728	jxder4Todqz92tPGLZkUhF1KmyhiAd8L54cyR4G9uoRTrGnpjzi	7992	11314	11314	1617975720000
15726	3NKVn4ZjcDzB5RtwcVLPvzmeoRSdeiFgAyRHuQkU5sK5nVAcaidy	15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	1406	1393	253	6301	11735	jx2q9vZTgtCAGedJQyRr7yN5aWeADzMHWMVUZZCm2prmangbwvQ	7996	11318	11318	1617976440000
15731	3NLByzjNML2Ya2mRHBYvKiv9rwTA1NZJB7FrJkrbBsrpWs8S9KDm	15729	3NLBHZ7CcFeMtskpPBr4eLt9sXtK24m1Kqx1MdpZvQhRWQAUQ1mj	1633	1390	253	6301	11740	jxA2JRWFVU566YsYoq8ijUZEappFYXGD16Hw55vKJYoVZkT3HkA	7999	11322	11322	1617977160000
15734	3NLSSBwFuerh1Kx72axeZJDdsdfJTFKu7cP176tyBasJpmgSVVmM	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	1403	824	253	6301	11743	jwigcMQ463VeMxj975Ym7BQgrAXq5yzUKVFWAAagbq96wFtMLKS	8002	11326	11326	1617977880000
15739	3NLjJZmJQ34f7m23RyknYEVgn4xzGLXomTXnxZ8tiM21Sp1hqrw1	15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	1642	280	254	6301	11747	jwknzY2S7D27m1b2K1bdPvpEVxVQAYW36pbMqJowhUjCQSqdjqF	8004	11330	11330	1617978600000
15742	3NKU2PxatxRa2KNHUA7X4U5K4JYnMEnAWmWE8rWvScD4cm8Y6Edy	15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	1460	1324	254	6301	11750	jxfAn65Hc39Jg9uBE3kjLTrdTyZTPbEuh2id2GAysoizTnN9x7Z	8006	11333	11333	1617979140000
15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	15742	3NKU2PxatxRa2KNHUA7X4U5K4JYnMEnAWmWE8rWvScD4cm8Y6Edy	1578	1296	254	6301	11752	jx55qxMDEER9rxcQP8BJRvYVNzfkcjYxQw61RR6GPekqNpWtESR	8007	11334	11334	1617979320000
15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	1654	1340	254	6301	11765	jy1D516nFkyjNKgQLvoFWEhP6PafGnz7MsxJEGZ1iY7thHXj3ay	8013	11347	11347	1617981660000
15760	3NLhovWtYDDjkHMgDcwnhqkXxXwEAvWG9dQvASzLMbpup2C4tejW	15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	1648	1284	254	6301	11767	jxKqWnXazpz27B5efs3KUoC2R8hU5n9uxgvs99c4RAxR3krgUDD	8014	11348	11348	1617981840000
15763	3NLtFaAnvaK5swxf9RrrTrmCmCtUKkNngvT3Zjdkkp41CeeXBmoy	15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	1508	1021	254	6301	11770	jxXgL3uwjzhTjY3M1LadnMkeahNqgPbRURkuA7yyfEayMNKKUG6	8016	11352	11352	1617982560000
15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	15764	3NLbrH2m69MrzPBNrV56fs2YZtPjQrb2LKxdpnVgZatDB5UV8wwn	1642	1367	254	6301	11772	jxiGRLVBmPmYDw59LfncohLW1fxzTZDT5btPBYgLppoUhEgW6xk	8018	11354	11354	1617982920000
15770	3NK79GGFU5uST55AaVshrhLgZFsQVv9Bw3MvET4xiqtbyztY2upp	15769	3NL8TNQvFgg4fYERwPSCHxEtixGVr34cndaGRT4GTs1yCfRKW4Wf	1560	1291	255	6301	11777	jxjAg49jqKBVWJPwtTADDxHN6WyJD87amnMCLzVvKNHsq1ZUamY	8021	11358	11358	1617983640000
15776	3NK6Pvf4BYenJLa9LchHTVvbqmAytWazjVJ3Wf68qmRRzdP7TDVp	15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	1421	136	255	6301	11782	jwKSec2WkZxGfx7m8uEVDsx6nTNViLbwfpYQeYVKLyqMue9a8HJ	8025	11365	11365	1617984900000
15778	3NKqhD4rthvigk5ymYdx379WoTiNvh1h1rnm2rurFkhE744Kpird	15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	1507	1280	255	6301	11784	jwiBBcoN7QChqXca15caob35EQSeicgzJ6YH5BmytX7PUB8Rs84	8026	11366	11366	1617985080000
15785	3NKVFXAjqzavMgBGTEDqfkqtP9yid5yqkmkcrEkjgWsJXy96PRG6	15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	1402	868	255	6301	11791	jwRmpHHaBvVtML8NEymoR68aG4fRu2asAYjmojq5jArbdiYjsjr	8029	11370	11370	1617985800000
15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	15790	3NLQDJW6mEFHgS4HjaNP3ZSS1gQoM371w9PPAWLRkGDomUbiG3d7	1671	1365	255	6301	11797	jxEu8iTXj5MivtjvoVJa1oEGQ98KBJQv2YFs6PdM1P8ALNpxZ7q	8034	11377	11377	1617987060000
15793	3NKFZZQ8W8m4SQFajYPvqE3FKYHLqWGzcN3Z3sGYwswpsv5Vs919	15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	1668	1370	255	6301	11799	jxWJWMVrWxzoKmnrpNFhK6TccwMCENGtM8dyitqYu6uNioJ5m58	8035	11378	11378	1617987240000
15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	15795	3NKhQ36hFWttyBHNHCa87zbbYFZEM6BwTR5ZJtUo1Mq3rA2apHQ4	576	989	255	6301	11802	jxvgQCFqHpej9WiyahZc9G5EefbpkGsrRWJ3itSr4cSEWbDHveZ	8038	11386	11386	1617988680000
15801	3NLctYrdFcsR78MkMznQFMHemCc8VwR2CqAERTtyFG3JmeJay5g7	15800	3NKiyocfyj5v3WWEU1iaDjCePnoRoruJT3HA9rgEM68MBCUfywzi	1507	1154	256	6301	11807	jwBudhYUf3BSQPSb8jRLYoWXhj7EGJDVFBESQXZf9LvKPvuPSV3	8042	11390	11390	1617989400000
15804	3NKUjwr3K7K1fqSZv2CWMc9A5CvJKJwrQEbemd1ruATwXRp1hLf1	15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	1647	1176	256	6301	11809	jx2ZJFF44gbPB1GUZAdxQtWGnWHocDJzwGffTsXJsMdq65E1dbR	8044	11392	11392	1617989760000
15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	1647	1302	256	6301	11811	jwpYWQPv73DfTbpD5dhMriPrdTMJgFeQipPKA5cVzYf1qY9JLjc	8046	11394	11394	1617990120000
15702	3NLXGBvDXXTRNdfuaFgar74nfF3nHUArwQWqNUp5mmw2zM7oGPJu	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jwgw8DRF46Eti2prL7j81L84HeoaRH32rwsFzELGqpFnKf7AXCa	7985	11303	11303	1617973740000
15704	3NLEFH7LSnm8sKCPhRbtMJC2R2AyvjYLFeYpD2tvYuiPgJiWSe3t	15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	1542	1058	253	6301	11715	jxpHyzGRJsfTpdao7Ea9iAouFXWuy6peEjD2BmB6QKNV2CfFVeo	7986	11304	11304	1617973920000
15706	3NKT5GFuBfTmnzpdpu8XHyzoZrWV55k7NuSYFhjEK24RhKJZxtpF	15700	3NLfmu5KksCZSWXyndf2uTV79UwUmzHDaqW7riLE3rDRwmcdCHAj	1542	1058	253	6301	11715	jwctv3yazDh6tkXerJLp9zXsoHo3ESw1frAG1vTa36PhLCxUMsb	7986	11304	11304	1617973920000
15716	3NKT2TJcLkvftuwU8XKGaH5UNpDsSe33o6tbUBrg34Sfw1wFCDFS	15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	1457	1025	253	6301	11725	jxZoyG3y6BM9D8YsTJu7mAZRvmaKy1chsAKqEWViQwiSe3KKDVU	7991	11311	11311	1617975180000
15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	1406	1393	253	6301	11730	jwB36eWrtck9sp9G7mSU42ZVhuE149KWPBKpvc88YFfT2hpsdd9	7994	11316	11316	1617976080000
15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1402	808	253	6301	11733	jwwBe7iQKkd9QwVpXneM6ggrgLcW764iiWmQbm6qT1heD3bbUSx	7995	11317	11317	1617976260000
15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	15726	3NKVn4ZjcDzB5RtwcVLPvzmeoRSdeiFgAyRHuQkU5sK5nVAcaidy	1489	1134	253	6301	11737	jwYso1DmH8h58uVRctg731sjnhdjxuYv4Jd9JHe7PuDBZfr5XL4	7997	11319	11319	1617976620000
15737	3NLhWQ7HYfG9ydg2V43bAzXUjEUhJiC3PKeK2FQb8V5M1whXACFz	15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	1553	776	253	6301	11746	jxBZtPHLqvu3e5L7C7rZV7pVAPTamYSPQ2oRnzMwS2BYuHsLb8y	8003	11329	11329	1617978420000
15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	1407	1395	254	6301	11749	jxJ7GCrTr93rCQgQGF7LsT6FLSVhbGA3zhREhi8eVpMP87LXu9D	8005	11332	11332	1617978960000
15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	1444	1135	254	6301	11754	jxLK2RWM8NHBXk1M7n1ad8YYEYoZwNvZoToqFDZk2reZsekijcj	8008	11336	11336	1617979680000
15752	3NKhsreSXBt1HyeNEeFq8kYLXVUe78U3dpZ6gzALKBG9UUy5xGYo	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	1407	1395	254	6301	11760	jx3VosHfBF7prHYTH7MazVWmVDVCacBJyzy7BpqU5g2wg44Jyun	8011	11344	11344	1617981120000
15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	1406	1393	254	6301	11762	jxMiEo73iDmhs1L6jaJYD4v5RZCbwkFJyFoYEqcd61NZV31cWnY	8011	11344	11344	1617981120000
15757	3NKiYFyZ8MejPCcQ3qMyEMjWTyxYPQLfUf2oGcMNXpwHVUzvDJwR	15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	1455	1332	254	6301	11764	jwdE7HquVByBhhwPhSgqpM63TejggfNvHQFu14jEs2V5ykBKxG6	8013	11347	11347	1617981660000
15759	3NL6M93bLyvEG8Y3FhT2ZYdxVRCVLwVoUwghy5mZ5F6LdVZXt8oV	15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	1529	1190	254	6301	11766	jxwyWRb4336QCBp1wR2cFBTnRSfK95XoZvTXDs92nY7krhK1ifC	8014	11348	11348	1617981840000
15762	3NLYBSuK8Dtw66x4nBwqYCRDj2BaHs1ubyCU9nbC6pcDS9RV9GHM	15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	389	389	254	6301	11769	jwEBJt4sF2DTmrr1xqVMpsLbJiS8NgMBQfdqYgFqnKbNh4ipEhV	8016	11352	11352	1617982560000
15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1579	1143	254	6301	11774	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA	8019	11356	11356	1617983280000
15775	3NLARTnD1E7GPcg4w97meXBngFmhacQkNy88umhG9GDbBY8N7SQA	15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	369	1312	255	6301	11781	jwndP9KSRUQ66cHGACLdycUkKQ1mDBAzd9CwXeWnAWVCvoP59Gj	8024	11364	11364	1617984720000
15780	3NKbhsyMnrh4AFoYooSn69gAZmKBXJ3DhuXYhBVw3YjzVty9q9Fx	15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	1670	1282	255	6301	11786	jxKnYeSTWNkT9suFmKNEFMBazTLyjqrYc9z1Q4511CTaHLbPVJ8	8027	11367	11367	1617985260000
15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1403	824	255	6301	11788	jwKDQ9CGgpqD4Jvr1MBFWmHkA8oUM8JEgp2hgGZiyHMJdKH5a9T	8028	11368	11368	1617985440000
15784	3NKkQFAGwKCd1ya7wUoeY3wiEGhajxo5h2LoWVAFn4LhjNdgTu7Y	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1631	794	255	6301	11790	jwP1z5X1hNSJcpgAuSFV7n5esnu92vE9AWw96y9ek2knJqpdxJY	8028	11368	11368	1617985440000
15788	3NLRC9pH8fULSdMFxXLiiuFHMFvaZu7iCRQbsKQPVNxU6aM2Q1VC	15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	1581	778	255	6301	11794	jxUGq6h4GgvGuHhc9MhkXXWBJYrQVbGsz9Pgwuw25euUeAVUGVp	8032	11375	11375	1617986700000
15790	3NLQDJW6mEFHgS4HjaNP3ZSS1gQoM371w9PPAWLRkGDomUbiG3d7	15788	3NLRC9pH8fULSdMFxXLiiuFHMFvaZu7iCRQbsKQPVNxU6aM2Q1VC	1407	1395	255	6301	11796	jy2A8sy3BcA68HjpwKjohaTk4Ba8hS8yZvApYKG21GARC2y5ubu	8033	11376	11376	1617986880000
15795	3NKhQ36hFWttyBHNHCa87zbbYFZEM6BwTR5ZJtUo1Mq3rA2apHQ4	15794	3NLZ14x4RyPyppnWTEk7ghX9MNWpcBqArLW8vXWyov8q2heKn8rH	1406	1393	255	6301	11801	jx1gb9wFYZxiz2VSUtfeeJEc7gkRjgf6Shh1cwWSvtnFWBWimgt	8037	11381	11381	1617987780000
15803	3NK6nqaTaVipEWGHUmy1HEYULtjmYFDBYSPAhbPy6Mux1FEWXfZt	15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	1647	1176	256	6301	11809	jxzQrxVUhTt9uqkggJibRyxppjkiiUVgzBeCXigFqPeqEZgZNwL	8044	11392	11392	1617989760000
15808	3NLU6TknSjeDmtygBfGvxdrg1FW2nurhHpcNhwwMcUZqXDmb8YYT	15692	3NKsdyg5dWZgUQrroyzUaFS54GgMH8JKDq4L2nszqhkz81inZyp8	1593	284	251	6301	11812	jx3vriLQ3uM6Zjn6PqMBacLxQxo25aAbBmUNj893vaHfaLBFBXZ	7957	11395	11395	1617990300000
15810	3NKMp9WJzsH6ULrJPGGex1RoHykg4q92WLBscgKqWtJQioy29fkd	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jy1Srzy67pfFHQVEtYooJUgenqYnbqBrgv7rffa9jpYkR9212Zo	8048	11398	11398	1617990840000
15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	15813	3NLDpekXqQFwqUhxqA4rCYRfk8fqnNoDQiero8ctibXq6qLEpnNL	700	832	256	6301	11817	jwesbJJgsZJBWWbTazo9xudnV77sEt5ga3yEYWqW2niAHMMtb22	8049	11401	11401	1617991380000
15819	3NLQEyATusavLjNq5N1m7Cn4eAkmFft89Kr37xgjMZR1iXMpQQTK	15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	1631	794	256	6301	11819	jwfQc1KWCUnweXTufXiFgkkDLruJ8412m87tNFJttzSjJR5K8K5	8050	11402	11402	1617991560000
15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	15818	3NKf8CMiUw7z4j1JWJJwNPUkBC285stiBvnmsZiUSRZyG7yABHww	1407	1395	256	6301	11820	jwMT5xVNcAD44YDW7cmbARLp4uSV8VTPNHZnX3xUHg8AtWEcbrB	8051	11405	11405	1617992100000
15823	3NKQZ8vwYsGA4rs6trW7qDYFa7hZS1hJ49Uw2AjKsGtKHzJAVtto	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1403	824	256	6301	11823	jw8BgyaqwBVESJfxr955M76r5kep3hVz3LgXJBCm8yqXc2bNJwE	8052	11408	11408	1617992640000
15829	3NK5oeyiXBoPoEKH8tRj4XiMCtG5PFKXqYd2FmZ7TmQbTLpgfbtV	15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	1407	1395	257	6301	11826	jxeB6TDz2ZRtan1HEfARMfzayMAeWgiK9EHqjoHNUCcghHbVBJB	8053	11409	11409	1617992820000
15831	3NLdaN6ZPLXsBWFcFjAR2pKh9yKw2kwUteqo4egbMdwFkx5caMM3	15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	1623	830	257	6301	11828	jxZzt1JBkSy961GmDQ8vdV96zkTiyfC9u6uHSh1KMA2nt5FHz6M	8054	11410	11410	1617993000000
15766	3NLdiMyiAy6rRCqtwugz5CV21ZvRBKFFUAC9SbifVgwkX4eRc9is	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1599	921	254	6301	11773	jxh5jUehvmK5gSnx9ixbtR1dPyzMFSKU7FLJ8WHKJvsk5o2mfUS	8019	11356	11356	1617983280000
15768	3NLk6VpFaLn4VVxfeh8DrRQLvDe7g2FyEprD3mshR9PrufFT87kr	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1406	1393	254	6301	11775	jwG1RB3sEdTKBCc7jWuRPQWGtUMJdi29aCZnfKyWM7bHK8nbCzk	8019	11356	11356	1617983280000
15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	15770	3NK79GGFU5uST55AaVshrhLgZFsQVv9Bw3MvET4xiqtbyztY2upp	1560	1045	255	6301	11778	jxQBhAk4jG9A35PpGaPfu5H8HFJpFUUwKjki5A9nttQN9UzwdLv	8022	11359	11359	1617983820000
15772	3NLNm72kxeoZXgzUnBkDJvJfNE82MqF1tiHn7r5yoELD3xg3JqKz	15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	149	1037	255	6301	11779	jwqw4JF5ksMmymCm4Bd8ijTbq8qWtmZYK2AUjrLJHTiu6bVnyxg	8023	11363	11363	1617984540000
15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	369	1312	255	6301	11781	jxthVZdvfYgwD6isPcSRd3P9Qrpysv14savCW5mWd6df6orWfJT	8024	11364	11364	1617984720000
15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	1407	1395	255	6301	11787	jwF47UzsAd4qD4iUwcggHvCEG3oDdhD2g7XTUPxx6zaXroGUqdT	8027	11367	11367	1617985260000
15783	3NKEmHmrfLhL8yBZt2JFMJTNbe9cC6c4XqLRZmR96HZZQNCRfBxs	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1555	981	255	6301	11789	jx2zL5jqUaDkHrrNmsXYCyvRkp6Q2XTmKCVJojgaKZD8ddDvpw7	8028	11368	11368	1617985440000
15786	3NK5reFGqMwVZkb7RWkWrDrJrdBap5cEiHcQx4iNzv2fAjKxQgjY	15785	3NKVFXAjqzavMgBGTEDqfkqtP9yid5yqkmkcrEkjgWsJXy96PRG6	1407	1395	255	6301	11792	jxZJXRMHSW6np6iy4E4fpy3XDxN2MYQqoaTRKxmdcfpsjpKEUvY	8030	11371	11371	1617985980000
15789	3NKffJEY9FTmnAgr5KGn2oBwkc97uS7rZ8jaTxS4LKhAzQTqWZsH	15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	149	1283	255	6301	11795	jxtGyUcoKxCvmGjpoSQ6aZGy7dkRkQqkk17LuJ4JCU1QTPS8YVy	8032	11375	11375	1617986700000
15797	3NL2b5z24LHKXPkQDjuonw9BscqXQquLmWSsT93hP8HiuAUhwChP	15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	1648	1158	256	6301	11803	jxhgrcD9eYmuASCP7Rtxw7e4QCMsA7jftZEH6RgDtH9oCooHzYh	8039	11387	11387	1617988860000
15799	3NKYWhUsBH22P8CGTqZF4zeZdMHxNfK5cGDnQHNf4nX6Kz4L4dJp	15797	3NL2b5z24LHKXPkQDjuonw9BscqXQquLmWSsT93hP8HiuAUhwChP	497	590	256	6301	11805	jwNX2bqidmyXWkEPxejsERqQh7QGtEprd8HkQzguA9RNdna1iRE	8040	11388	11388	1617989040000
15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	15801	3NLctYrdFcsR78MkMznQFMHemCc8VwR2CqAERTtyFG3JmeJay5g7	1407	1395	256	6301	11808	jy2qD6oJtSzouEbpC6qbnAfthK4hAYHkbMmSmwE8DvkAdnGDDLZ	8043	11391	11391	1617989580000
15807	3NL99ngjM3mJtgNNYjeuCixSrpG1swJAiCwhqiEdBMwU2FFFp2qd	15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	1647	1302	256	6301	11811	jwbib6u3HuTUdVfYdWWR5sVsvqAY5iTLfoeMVgKxbTWQzQjbWJ8	8046	11394	11394	1617990120000
15812	3NLcZQbZfk78WdA7x4wkmCGxJnnVkZf4YarPkN7q3ZFF3gVk9wBp	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jx3L6Bh3yUs8fb5cSWMYn6yvrPAHriYBHSca4hZMAqaZxY3vhcb	8048	11398	11398	1617990840000
15816	3NLfQx57TnSf16CLeUPcbzuPUuPKHdR2W14ma5D9vDb7sAQwUuWG	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jwyzDQd12va1ni3gMEyhgpPvqvJeDqbKML6i3a1p7uHLxAS8rck	8048	11398	11398	1617990840000
15818	3NKf8CMiUw7z4j1JWJJwNPUkBC285stiBvnmsZiUSRZyG7yABHww	15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	1407	1395	256	6301	11818	jxVPez9gqDiCAao2NoeQpAokaZD2VdzDvDGzeTQvXNeQh85B4QQ	8050	11402	11402	1617991560000
15822	3NLvqLaGNSjNisqoFnh5NbZuUsBL28JrsUiTR6tMHGHiMY44FUoe	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1506	1007	256	6301	11822	jwTpERpsf6MMUiCWGr4Hfem6cS3u2BuDSFDX4Twvhc9RFwH5JTY	8052	11408	11408	1617992640000
15824	3NL9Bv9SKc8Xbe1NExEBZzhWKtxeTQPDJ6PtDrbwwbfW4BDjW2Sr	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1506	1007	256	6301	11822	jwTpERpsf6MMUiCWGr4Hfem6cS3u2BuDSFDX4Twvhc9RFwH5JTY	8052	11408	11408	1617992640000
15827	3NKQkndWi8AQrapLQXsf7hk15nBxBzyqEavkRXNKxs8qB5q7jEc3	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1581	778	256	6301	11825	jwXoi2ev6uT9DtmAYfpKYNDDZdCxNQ9TwRTY76Ca2opZCGwqCoB	8052	11408	11408	1617992640000
15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	311	941	257	6301	11836	jwqqgwsfJzvV14NfPhMqTwQYxyjoEWxrLKiahbNwMyriPsk4mZW	8058	11417	11417	1617994260000
15842	3NLpJp373sJu4YA1CcCwyRoVJNW3HRTmjgRYgQRATjR6Cm7KzyCx	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1553	775	257	6301	11838	jwcGsq1ZcQqe9MUJtJ3Nf2Kx7mc9Lf14UKgWyHTDHKvQDr4dN3b	8059	11418	11418	1617994440000
15847	3NKF2WZxRYWXue85KpR3FXdFgHLiBfRoGycqrs5bU1AKd5mkdnT8	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1619	1275	257	6301	11843	jwnij8dXgWtquwBFESzyPaxy9AqX2R8duG95PNE4GCtD6jkg4pk	8061	11422	11422	1617995160000
15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1590	1174	257	6301	11848	jxhmYPzhMDPqM4UpRCMqL2wWJambp2L1Uyy4FEz5ZXfHdkX226L	8062	11423	11423	1617995340000
15854	3NKFXtc1UdQYFBmFXFebzDyD7A6tUjH3No1z6e7q9rEgXGGpm6vb	15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	1467	1376	257	6301	11849	jwehpnL2SUk4mQV4gWJ3NHjz5eviyMjU3mjfHJGnxTXhSJmQQJn	8063	11425	11425	1617995700000
15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	15854	3NKFXtc1UdQYFBmFXFebzDyD7A6tUjH3No1z6e7q9rEgXGGpm6vb	1553	776	257	6301	11851	jwN3B6mLF88BFFKwiMoGkGYXEUiUGZtKpSwiBzdzEF71tftoGnD	8064	11426	11426	1617995880000
15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	15860	3NLmd5yESP81CwMKvw8xnT1mQdd3ZTTEH2SF8SyKgDmrP5Xfbkdx	1581	778	257	6301	11858	jwAcQNZLTU5prNSYXkb3piASUwE7Hr4AFdGTaWtixfW1w9YSo4Y	8067	11430	11430	1617996600000
15866	3NKMvMdj52X3npgPx4mB2SiAz3rPooVvxUbKwxkpzZucJtDDKtB6	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1623	830	258	6301	11860	jy1SV6U98tcLWRkScMVijJor9tj1Zf8L5kMAy8jYbyep7pQ1jMB	8068	11431	11431	1617996780000
15868	3NLqu8WroFqNGbrCh71UngPK3f5s4jeK56WziP6GCMqpRGAgpow2	15867	3NKqW4drVe7MU5GfGFAH83jfWpU4oor6pdkptsAmzdXJ6KLcandB	1637	816	258	6301	11862	jwBZyyKmSBNYmaxewyo1fYmQYS488rkzVKJgkZSRK59ZYp4HfSN	8070	11433	11433	1617997140000
15873	3NKjCoH2ccMskYEvaJPuhbBTFdWRBxF8jRCgYVan9VFcBwhsVKGk	15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	1422	1211	258	6301	11867	jwpaMzvUNQTEhU395nGmMeGonDmnxS8FBr2ajzdMcxF7g5xDHv3	8074	11437	11437	1617997860000
15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	1646	1354	258	6301	11869	jwrBu3hYaR3Dnb949ZUE2gbX5KFdia72YESTH86q3fPjUKCxHGi	8075	11438	11438	1617998040000
15883	3NK9xqvKA44YLcwdpsa7tjAyjSahLzu5vn5X8Vp3KwEs2nrLv99V	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1611	1215	258	6301	11877	jwPFjEmu8M1LBA4F4FhPbvLY1hDjNKcWKm14hWRmQoo47Vcr6Zb	8076	11439	11439	1617998220000
15892	3NL6MiuNV1hrwxhqvaen3imxJbNr2kY2atKEx7AhBxG4yWps5WM8	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	1668	1244	258	6301	11886	jw949j6kdiiYFNwjoA53AexXbc8T8MWsAmRn6rBkD4JgPiMsR13	8079	11445	11445	1617999300000
15769	3NL8TNQvFgg4fYERwPSCHxEtixGVr34cndaGRT4GTs1yCfRKW4Wf	15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	1573	1318	255	6301	11776	jwDe8yBqjwXTm3q74gJTAawPvvVQ1rfsvSUEquG3ue1wEohbdHt	8020	11357	11357	1617983460000
15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	1631	794	255	6301	11780	jxdSoh5cXnrWYKPir2xLsA5bYg8eTkdHP7xyVbUmLcXA4YLh7jE	8023	11363	11363	1617984540000
15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	563	1113	255	6301	11783	jwYiJESqMLywChPmjmkm9xBaUW9MbL5z9GDHZG4zW8mYUpbNL79	8025	11365	11365	1617984900000
15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	1637	816	255	6301	11785	jwqKhUbzBDFqjTgVA5hZXvzRgY2CYZTpmiMXoTXzbL1kCfjxU1j	8026	11366	11366	1617985080000
15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	15786	3NK5reFGqMwVZkb7RWkWrDrJrdBap5cEiHcQx4iNzv2fAjKxQgjY	1579	1389	255	6301	11793	jxYvcnXBikZYVQiger6Smf6uSP7Qy9qbW3xa2xYXCGySx3SuLJ9	8031	11373	11373	1617986340000
15792	3NLM9V4YNVoH5n7sT9CAHZ4A8s2SpaUHqeHLARMpaX4P77qi3Jyi	15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	1457	1391	255	6301	11798	jxRwC7FA2ffbCssFcp2HnCVGixBWRDTWsmhg4naLruqwXHFNToz	8035	11378	11378	1617987240000
15794	3NLZ14x4RyPyppnWTEk7ghX9MNWpcBqArLW8vXWyov8q2heKn8rH	15793	3NKFZZQ8W8m4SQFajYPvqE3FKYHLqWGzcN3Z3sGYwswpsv5Vs919	1403	823	255	6301	11800	jwyZY75QrLM3xBV4NXDR55BrqHQQRUrWhVBjLjZhCFxpDjoHMJS	8036	11380	11380	1617987600000
15798	3NKEq81jShjvFgo1Mvpo5nhgRZvfRZ8TA4NhCt3cfA46WsNLxjfx	15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	1407	1395	256	6301	11804	jy14BdTiL678pLHMuFvmNfLBG3qBrKcUPCYhgjodf1WM31WFjLE	8039	11387	11387	1617988860000
15800	3NKiyocfyj5v3WWEU1iaDjCePnoRoruJT3HA9rgEM68MBCUfywzi	15799	3NKYWhUsBH22P8CGTqZF4zeZdMHxNfK5cGDnQHNf4nX6Kz4L4dJp	1602	1243	256	6301	11806	jxyFdaciz4QiEh97XUmToKku87uUPBnVNZcCmSwAVK17V4sXqLb	8041	11389	11389	1617989220000
15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	15803	3NK6nqaTaVipEWGHUmy1HEYULtjmYFDBYSPAhbPy6Mux1FEWXfZt	1406	1393	256	6301	11810	jwpvG8mdMTSTMwogYWBoJURpnD1wT3kXSsB6RbiCAjjtbtTGbgX	8045	11393	11393	1617989940000
15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	1593	284	256	6301	11813	jx7gCszQUuy9fwYkg7tAo68fXvKQ8ZhGpuDGmE8MCW8YuvKJXwN	8047	11395	11395	1617990300000
15813	3NLDpekXqQFwqUhxqA4rCYRfk8fqnNoDQiero8ctibXq6qLEpnNL	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1490	1148	256	6301	11816	jwBRQVHecXM46CW4pi7ghTQCo75xzPRTdihEraJCTFCGxUXGdiP	8048	11398	11398	1617990840000
15814	3NKpdeRq9U5h7SqQnPrYWrze94EoeqULxsanKZzzKtzNDrCxtxdZ	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jxLZn34XX5uBtuMJuVotAtFwZ55pb8hxunAeHHaUvHzmLdn7SPS	8048	11398	11398	1617990840000
15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwfBMG8S5EhdTPqgsi6tJmLoJPSFgK1TvYSnmtk2K5tsMTYgPov	8052	11408	11408	1617992640000
15833	3NLnLcTcmFAqd3H2NhWg9tsWC9rGmePVe6b4q6nRvRXatMrYa8U8	15832	3NKczHMAEDtBnBCQwMcp8ChnTFxJGL56jfQCCMTRELAAXEYxoeuw	1403	824	257	6301	11830	jwoqPxMRupwPuPREa2EJQsSGzsqKn2vEzNADUHpvbN9zYMRMBRy	8055	11411	11411	1617993180000
15835	3NKyzeCPMAPwcn4erX5aCaZRic2EMKeytaiTWKy9nL1mqFkjLP7m	15834	3NLf9vbytu8NQaFPo9WmguX5D5nANoqXy6xJS2W2JsSTZB1rGWTm	1594	1326	257	6301	11832	jwsqxFXdyMcDZqG9kancRBeGDqMcbBKE1DhJFeTJcMLVte7A7v8	8056	11412	11412	1617993360000
15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	15835	3NKyzeCPMAPwcn4erX5aCaZRic2EMKeytaiTWKy9nL1mqFkjLP7m	1637	816	257	6301	11833	jxPB3xmqAJTQM59KzQXvJBtChpM3tUGgyvysy4baa3ux7rtayXN	8057	11416	11416	1617994080000
15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	1600	1126	257	6301	11841	jxcisVNgZqmkseFuQxqhNUXe3jBc922x49pDq6RJWV6CjyLxBqJ	8060	11419	11419	1617994620000
15850	3NLPUPjmATDCYieU9qDk8rnjRfr9w15px7Ce6bhv1MHJpcyTLAhW	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1406	1393	257	6301	11846	jwMf1aa64EsYGYGdd3iSmNgfZ4rh7cXop3KGLuctdiD4tPMZAjX	8061	11422	11422	1617995160000
15853	3NLJFgTvoqgRE9qtjC2fpsb1tY8qkhbiFcoVgpxF99CoUajoGiVp	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1651	1301	257	6301	11847	jxba9S4P2vPV8xUHN3cfxoGajVJv1wvHpcejwW42SseNB2fjzE5	8062	11423	11423	1617995340000
15855	3NLpHAv4NY4Rh7Gkzvfjdy2sySvGXCQ4KBTo16rYFWM3M64DNaBs	15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	606	1295	257	6301	11850	jwB6SatwgsN3C2KYekyT5AGvtwW9f8m7LGXX9N5vBCUx6wSQ1QZ	8063	11425	11425	1617995700000
15857	3NKATrik11t5Z3At1H2KQ2WYfhsfzKdkRVFwmXKopHqtKPA1WWfp	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	1657	1218	257	6301	11852	jwpPbvUY7Bm4nB2tnBjeU1ZmT7eswytdebmvjkz9iVfp4KBkXhF	8065	11427	11427	1617996060000
15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	568	568	257	6301	11854	jwnq1oNUNpqpMpuLHacQtdpDz6pS6o3fB2mYjn34AyQLGAQNStH	8065	11427	11427	1617996060000
15864	3NLRekTCvhy3z6bVTPVxKuDPQfyvB7XXKX8AWuxDcjfiut1UzzyE	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1537	227	257	6301	11859	jwf543ZohqY3ijHCow3F2QsvpWdH75tSEUaGwNbdwX5ozUSGEie	8068	11431	11431	1617996780000
15871	3NKbD1HYcBo9XnT6wwj7F7Ua2UeFTiNbLSvB6Qiet72xSQFztQyL	15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	1406	1393	258	6301	11865	jxpNSf6cKjpUB5UQutG3vSzUGJdS77mbnQZ7EaNRDpftXvWEU6P	8072	11435	11435	1617997500000
15878	3NLUMjdvaoD8DAVWCgVacrc62VS7QSb7GYN7JXi55nwVFrUVMsWC	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	470	1309	253	6301	11872	jxTJC2Lafnpu6dQBPfc3CixNANcZroMsd4gqNef3ZuE6zGiLdfL	8002	11439	11439	1617998220000
15880	3NKawEjdB7EY2DEUk74PNMCp6sgJ8WjmkePNGvaXqKwpPmivQUgn	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1406	1393	258	6301	11874	jxYThKZKiZNy27GWZ46Bihj93Tv1QoCg7g9kojz6pMtmaovJukh	8076	11439	11439	1617998220000
15886	3NK3xDXMmTCTq4QFGoJs4MAQuV4RVPydg25TkasCT8yTF4v49zcw	15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	470	1309	255	6301	11880	jxtE2VMVT2tPJTL29hLooH2WdmqjF3gmqSwDWWMy9E9wVG5a2yZ	8029	11439	11439	1617998340216
15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	15888	3NKWVFM6CpjkWyfAgjYWqvcmfgjFwqLnRHvoHNnB256AyvWqdPYU	1406	1393	258	6301	11883	jw9cJtm8JgFDyMwfzNKxxTovm3JSU5G7tghvGPD7pZX2WrKyAJk	8078	11444	11444	1617999120000
15894	3NKAD28dh1rkj74hWKfbbz256QQcJjLUReUb17RvzW2g9xma4Uxk	15893	3NLDtkZ6f4zCtWjiLCR2u2rSCyDezxFsp4wi3mtjoiH2D2eEXBWT	1460	523	258	6301	11888	jxMhfmBJvYmon2tSsBnmuGRy2yPvw15rkbBP9HpswdzdWyuXmfE	8081	11447	11447	1617999660000
15898	3NLZWhsDbvwZyUfLMoXbekaKAuLzek27RVyxcR75uenuG8rf77vk	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1637	816	258	6301	11892	jxqVpZhefmSxbAZv2RSd1HbUr2Mpe3UCesyFisXP2TQW9gXGGeW	8083	11451	11451	1618000380000
15899	3NKS3Hx2pGBXCfaduQDCBoUASUtTkQEgdsYhJxzgGCqtA8PZvkX2	15896	3NK6C5sjEfv2Vu4CLCtE6bLnZV2jdBULgMPpSVsX72uefdg4rsUf	1649	1137	258	6301	11893	jw73R4DbABwVAoeFSKLfeF4HA1JWwipyx1MBTA7GVova5RtREGE	8084	11452	11452	1618000560000
15811	3NLw1kRPBU2Ww8oSXqrWx1qSU7NinFkxmtLqPVosuBuGW9biwYjf	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jxMrAfuSfU84Lobex4n1L25Ng1JkvneyuPpssJ639b5G8bM8Cb8	8048	11398	11398	1617990840000
15815	3NKfw76h9gQVjo3fXec7244iZ9rXfDCdAJojXhBCH7FH7yC5DAr3	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jweyCybf2RMhXiVbTdvGUVQ8VoQAUZ9xNsbzPDYkU64DZ6b91ui	8048	11398	11398	1617990840000
15821	3NLbNRKqoYAazH2uvbdp744gYdmk7pfZrEGnEAwhs7rUmWp5JHu7	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwzPDpNc3p6pg6RRJGMU1noL9hcqzSEimLFvUfDqHsMb7hhnMk4	8052	11408	11408	1617992640000
15826	3NKTKeuu4kaE7DwWip1zAPC943opTM239XpXpZaDhbhcMDwdS2fm	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1508	1387	256	6301	11824	jxWoFDcQxhD4E6bVNMp9BMwHpxj1iqAnhcCrcLWPmrTC1fahjPa	8052	11408	11408	1617992640000
15828	3NK79gE25xBPKML5Snv3FaFzNqwZgC7v2Ko4uxg7ZN1SxKry4Dvs	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwfBMG8S5EhdTPqgsi6tJmLoJPSFgK1TvYSnmtk2K5tsMTYgPov	8052	11408	11408	1617992640000
15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	1637	816	257	6301	11827	jxDyy1hWqfjQm4Zf1h1EEUgRRYD1zn2SSry743qb7hHH4vscimP	8053	11409	11409	1617992820000
15832	3NKczHMAEDtBnBCQwMcp8ChnTFxJGL56jfQCCMTRELAAXEYxoeuw	15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	1581	778	257	6301	11829	jxdexrBej5amGbGSGeFhCpzbCinv6EAne1hg862zXXHpfSZSscL	8054	11410	11410	1617993000000
15834	3NLf9vbytu8NQaFPo9WmguX5D5nANoqXy6xJS2W2JsSTZB1rGWTm	15831	3NLdaN6ZPLXsBWFcFjAR2pKh9yKw2kwUteqo4egbMdwFkx5caMM3	1406	1393	257	6301	11831	jwpdvKFWdLAz9RmxDRwYmVW7TLz2X9x5ybUucpMZRJ4cgwRjnPg	8055	11411	11411	1617993180000
15838	3NLefTMo8ifiucCSq6f8XPQdubCK8FNm3FSWnxHP8XYvNg2ViHHz	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1489	1380	257	6301	11835	jwZGPinKme8xvjxQyGdN9eia2GNFUeqoYPLFNU5rKi4taSJTwqF	8058	11417	11417	1617994260000
15844	3NKDt418vWzQgwDPabexUSJwYtc2eQQ2C33bzEuY72yRRF8PbVJ5	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1560	202	257	6301	11840	jwBYK93gJucAhaoVSM2K9nLHH7ZoVJMqANRNWCTQ2DwGNsmEqv7	8059	11418	11418	1617994440000
15849	3NLFi4kFzuQTDi5hyfwehBe7G27ni8HtN8PZ9PGF4GYhACJkYYj7	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	43	1064	257	6301	11845	jxpLCruGKNqJzvYGacN3GYR6kTxtRzr5zRdjeH7pefFAPeJKUfD	8061	11422	11422	1617995160000
15851	3NL9uiVAWjHGhZjh2roupQjvpuWpFtZhQexdTVoHYzndxaumPpsv	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1651	1301	257	6301	11847	jwP9Rvf6ymiPtRFrCx12rBb1dE6xfJA9mJ7sxxFtEp2Gr5UXkmH	8062	11423	11423	1617995340000
15858	3NK7zDUUXQoW2VYrJY9F1iWQqW4Ew5kmJiDYjpFGYmGzUMTiFpma	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	484	1319	257	6301	11853	jy2c1vvofGCAiSnJwPxjfGMvmCbnnGLjwf6qYnjZi63k9PnXKiv	8065	11427	11427	1617996060000
15861	3NLMvY1V3hd94SKr1XayCiK8QsHYAGZwcrqvWbxKNEJbxGbKJuNv	15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	1407	1395	257	6301	11856	jxeCkdaS3dbH8VStTTg5m9M2GKGmmBCBh93NM9SDP47ysXFpwk6	8066	11429	11429	1617996420000
15865	3NKNnGiq9oJgMmjS48XTDpRi2UdmDqEwoeFMeWUmToP2XWrbRKiY	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1537	227	258	6301	11859	jxWUu55n46WSyxH86fMYAJ2qYTqdXnL9PVTMa7rYYjrZABmgLtf	8068	11431	11431	1617996780000
15867	3NKqW4drVe7MU5GfGFAH83jfWpU4oor6pdkptsAmzdXJ6KLcandB	15866	3NKMvMdj52X3npgPx4mB2SiAz3rPooVvxUbKwxkpzZucJtDDKtB6	1456	244	258	6301	11861	jwaKbF7tp7NrssvADVFhDMfeE5b4auFotF8qD9sMaoToNa93wBm	8069	11432	11432	1617996960000
15870	3NKUhRG4d3MUMDajdBe8eeyhPS7KPRAp1F42SeeNNtpn2KgzkFGm	15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	1460	1324	258	6301	11864	jwedqe1vk7UdKqbmha7z59kqZirkW7sds1mN1f6LSHAqTwWuiKh	8072	11435	11435	1617997500000
15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	15870	3NKUhRG4d3MUMDajdBe8eeyhPS7KPRAp1F42SeeNNtpn2KgzkFGm	1403	786	258	6301	11866	jx6cMgHXuayNNBiD4bLGGfYhLKsQuDf2hGwgqTdHERZZfMsJNb4	8073	11436	11436	1617997680000
15877	3NLHSHV6WRK4kH4Mzoy9K8LqS6vZsznAc195mA2XgXsJ262jtb2x	15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	1407	1395	244	6301	11871	jwh7TVvKhUZEZNaVUuDhpSrcwSFskxshkSBVgwRpccWfka1WV9G	7795	11439	11439	1617998220000
15879	3NLBrZGT5iay21bN5L81HwGyXjUzTDsChPoePj6qp85PXXvSqSqH	15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	470	1309	254	6301	11873	jwAtFy8sDPGXYC6FuRy7sqPcGA2P4busV3Y38jXHJdS7A6ZdqV3	8012	11439	11439	1617998263274
15882	3NLuucPMBrYLCshvdeVx3wqsfA4J1hFDqPFBd5iZLeuzm2e2A9m7	15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	1407	1395	245	6301	11876	jxtogzWgL6i9XhDtAeABUE5N6urAVqf6s6eGbt6giLSHRfeZPgA	7811	11439	11439	1617998256947
15885	3NKyiqmE64ruQmx2YPofrXEL6yPxHkSsR3V4u3Xi3LMRMPQyEXW7	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	470	1309	258	6301	11879	jwKofdWT3wBZb5mrs8NaCFaa8e85V7qmAjeFu63xRqEEboVEJhy	8076	11439	11439	1617998220000
15888	3NKWVFM6CpjkWyfAgjYWqvcmfgjFwqLnRHvoHNnB256AyvWqdPYU	15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	1601	1388	258	6301	11882	jwxvBCXhE2MU4D2L4Mt5QAojnQTqRzp4GT8ZwGJD3faQuYL1p7C	8077	11441	11441	1617998580000
15891	3NKRAQQ2sP5JZgpzE2jXZywiJZ9mH53714P2YyuevCKkpdxRgWHq	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	152	964	258	6301	11885	jx11tJAv8ZUG4Aqwcgm8qrCXk1aE3sTmhDs6RqvVzhx3HCSJv6R	8079	11445	11445	1617999300000
15896	3NK6C5sjEfv2Vu4CLCtE6bLnZV2jdBULgMPpSVsX72uefdg4rsUf	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1402	874	258	6301	11890	jx83PVVktjcg6MFc7BBZZ88rkLzXPz6jXYyGFsbW8oybR5G5pfk	8083	11451	11451	1618000380000
15901	3NLmQq1PY74ypPDmNrLWGjcAdGxu2VT8uELMnMCXFeEKGYiWUyqz	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1483	1030	258	6301	11895	jxQzYEszeHmbmVHMzDZbFYsxn4gTNrHP1EH3cEeATBwDNp1nEFf	8086	11455	11455	1618001100000
15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1637	816	258	6301	11897	jwaJ6g9XBArAAsuo4iN5ZNLYbehHcbG1TpgMpTuSzW4F3K7MEPc	8086	11455	11455	1618001100000
15910	3NKKGErrthrV4725MgGcUPVzZRWavvwCRmsDUYJutCAnkpnaSLno	15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	1405	861	259	6301	11902	jwK5vWwPRZeYFmWfwK4u2iDqfpRnUa1asg1rHfLTHtFbZjE33Fo	8089	11459	11459	1618001820000
15912	3NK8w91zsbuF8puFvH3nseAn6QfWaViVUbjyEojH5w2PLWVE3J73	15911	3NLb3uR9fYfjT4QZ9wEKU6KnrgFiUKMuBDx52onFQMK2j5V7kzP5	1578	1050	259	6301	11904	jx9EFK72HkV6CBGPQ98RPriRmuuiUg5w6nvZX5sUGyiePCcqf1A	8090	11460	11460	1618002000000
15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	606	1295	259	6301	11920	jxcuG76XMhhT1UXzHKWBKULkCqHMcHoxoDLXAA6byjMaES7Aeew	8098	11471	11471	1618003980000
15932	3NKKynnSRHWifn8bhcSE7fN3tV2Eafeku5CZn6xPyk2xcNyN7HB2	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1587	1231	259	6301	11923	jwbFMDzYKF2JE5mY1BtdWi1zGv5Qw9NqKE6tJUWMsRjyRGd5dTL	8100	11475	11475	1618004700000
15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	1573	1192	259	6301	11927	jxC6BSE1LN2H7cnXQqopB7rfzje7PvL2mjHBL786SxMPX7AMLut	8101	11476	11476	1618004880000
15837	3NK8T5DJHCPcJ4DWymiSjUq6rymNMWqHjx5m7m7LUXYDGy6h1Mhg	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1460	474	257	6301	11834	jwAhWiNKoWB8Sxxso9NtFHDScfpMJNYqURdponZ728qodDZGo75	8058	11417	11417	1617994260000
15840	3NLioeZJk9yoQpP1jQwyMLf6u7yUghcRR3GMW3ENFR1s94JLFBSb	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1489	1380	257	6301	11835	jw92hA5Gb3ebwcBvS1JhupW1KdEv4pCPWyP5AV4JJtw7M7J6c1L	8058	11417	11417	1617994260000
15841	3NLUto4n9nGuSCBTERWEm6VQV8o4iUkByaE3tUkcE61qjx6H4qpJ	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1599	921	257	6301	11837	jxc5on9x3AN9CbaaiNrEVL3WRJMrRQLqktny49VirZ8TjqrKmBJ	8059	11418	11418	1617994440000
15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	58	1281	257	6301	11839	jxHKedcdgTqTMziTzmDPFYepoAbyMuRBqHnzgjZjMYhjf7DnNsa	8059	11418	11418	1617994440000
15846	3NLB6QaWN2hEeLaq9dra6gjKU5pw48kPk7gGeseWJ6WxpPYRjUQy	15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	1407	1395	257	6301	11842	jwYBDezK4SGwHMXpGh2zapJ3jhzqKXfUtjsfNAdBVY3U6RJHthU	8060	11419	11419	1617994620000
15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1407	1395	257	6301	11844	jxAwYUqagafrX3R1VKTAzZf13LTJUXN8pAf8GJtrtvpm6eHEFtw	8061	11422	11422	1617995160000
15860	3NLmd5yESP81CwMKvw8xnT1mQdd3ZTTEH2SF8SyKgDmrP5Xfbkdx	15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	1501	1360	257	6301	11855	jxoBnfZJkkmDh4WB7xnSXCq4HU3HpnRbD96Nd2YybPYPhDmki6K	8066	11429	11429	1617996420000
15862	3NLMSnHXDhyEHWL4eYink9C1uXRh7NLWrWWjWKjXHZtLQEetyfGX	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	171	1374	252	6301	11857	jxjj4PJTHYNAkm2MLQwLndKfqF6GwebmcDna8NP9QfaonssEvh8	7978	11429	11429	1617996420000
15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	15868	3NLqu8WroFqNGbrCh71UngPK3f5s4jeK56WziP6GCMqpRGAgpow2	1483	106	258	6301	11863	jw7bdnppm6CMU15AzpDcka6EhU7dRaV6Qe8kubuYzE78QbAAwmP	8071	11434	11434	1617997320000
15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	1403	824	258	6301	11868	jxXGGVQE4cwc42dPkBgmpkbu9RQgZcBYoQwa9NAW7Ja9kEKHD31	8074	11437	11437	1617997860000
15876	3NKHHrDM6n1mfwzGkxe656ogmy7QBawYd1XMNLzoKZqE3jUZqMaK	15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	1594	1326	258	6301	11870	jwwJEpTXADbjuhA7DeyVmENpu5EBKLRapXU711TweBd6tKcEFC5	8075	11438	11438	1617998040000
15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1581	778	258	6301	11875	jxZpinGSVMgQ6tcEE1sroR6hKPzqBadAAoKFVykbFPVzzuN8kah	8076	11439	11439	1617998220000
15884	3NLCKvGHTNxZEVSLo8gGugpcMubyhUnTjzSfLYcAAgyNExjypVGE	15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	470	1309	254	6301	11878	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA	8020	11439	11439	1617998300614
15887	3NLQ8sJFba9TY4GFA5paXFr8wj9bx16aKozSutB61qdC3FMJqcro	15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	1402	868	258	6301	11881	jxbj3zmKXrp5Bd32FWUM2iwVkLjSm9XayJtHDorC14xZ528jpeT	8077	11441	11441	1617998580000
15890	3NKQudvzqLnTTgNKUx8G1NfF3pnqgtLt8Y2ZZQjG39rMiVLpAwWQ	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	1507	1280	258	6301	11884	jxfm5NViHZwJy3GEnZgYxHTW724xVeXEP3pJVKAmEiCLtPQZnhi	8079	11445	11445	1617999300000
15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	15894	3NKAD28dh1rkj74hWKfbbz256QQcJjLUReUb17RvzW2g9xma4Uxk	1631	794	258	6301	11889	jxkB3Ei5jib4umZAr6XtFczrnZxY6o8bLkXZz6NzibLYPJmLKnZ	8082	11450	11450	1618000200000
15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	15899	3NKS3Hx2pGBXCfaduQDCBoUASUtTkQEgdsYhJxzgGCqtA8PZvkX2	1672	1285	258	6301	11894	jxw7r4sHxRHSAmSuseCe599j4T7AEs7opuNSMx5gerdJsxRuboT	8085	11453	11453	1618000740000
15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	1581	778	258	6301	11899	jwnbhuyPYonNCiwGzHCjrx8FTXDUYn9XFwUTLeM7zA1tDNRYyaU	8087	11457	11457	1618001460000
15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	1624	1208	259	6301	11907	jxaWQqJV8ntZKFnGej98fNkzyB3yjrjvCWxUDV4yMEQXPiENZoX	8092	11463	11463	1618002540000
15918	3NKitEFyTPsSBBjtjdaQuPaFD3wqETRGXSWHwLevaWAa2RDyi9JZ	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1419	814	259	6301	11909	jxwGfMWdLiPdLFgeThA2Nj6ULGCzNXzxib8XkSPZ2ui57ywGpMj	8093	11465	11465	1618002900000
15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	576	1355	259	6301	11913	jwbWbCpQaGLp2fyR6QXr5s82WjM65L8KtcHS7CaEaGaEpuTxCtT	8095	11467	11467	1618003260000
15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	606	1049	259	6301	11915	jwfbu7QkfCYzwNLzzMmJrm73QSGUy5y7hynzwfXCFX77oyuoiUK	8096	11469	11469	1618003620000
15927	3NKt4BoEMyYmt8FYQGvWCt3zW3N2vfUbDoXA4V6YYCdyEwJN8uLF	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1631	794	259	6301	11918	jxtsYJwnTPYAqnxeRxto5VkmB9tVTbwTbQmhuWodnq22BYwWSnR	8097	11470	11470	1618003800000
15940	3NLJv2uH5P3jx5SS26acHR58BGSXRTSvWgJL75k5Y3HvanMUVK7C	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1654	1340	259	6301	11931	jwosNY9NkJQiSqdfocyRRa7x8Q7wk4buUFsZifs2Lf1ZgJmBZUb	8103	11478	11478	1618005240000
15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	15942	3NKTSZKgvMDrSmyvCpdFTWte5UaBBMEgxifG8iWEo37qB8yo9tTX	1489	1380	259	6301	11934	jwvsAPvuJndHSVLkrtvPAxuet6SSYSXFxUWh71jSg9WsM5dCCNB	8105	11482	11482	1618005960000
15948	3NLn92MctcjWD4W2diyZa6YRB9fT9JzgBEspw17hzQyrDMqvFmw8	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1481	790	248	6301	11939	jwxYc9WPwaa1nEr1wq9BJKzoPykP5t56ijWSZbwG6amUuzhH5ja	7890	11485	11485	1618006500000
15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	15952	3NKumYNNhYbtkLmzhUJnQvGJBXMu37YDuaGXDuKx6nHR2Wmwe735	1617	1288	260	6301	11944	jxxU9cwBnEenqZizQV361Ja62xUJBohkdGxtP3ao9ZLyrdgPJA8	8111	11489	11489	1618007220000
15955	3NLvZtsG2GhAAZFoMyv1vedfN4E26PCEaxGtdjqpUGGySoy5qUww	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jxAG4y8HW5ZXXEFwzCRgc4Mc4JMaNPwVgqYVqziijKupiCBn2xd	8112	11490	11490	1618007400000
15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1587	1111	260	6301	11947	jxS1fkCVxRjTt76ZjfqiCztJGq6ghYAUZE1TVRyFEzFJWnka74p	8113	11491	11491	1618007580000
15962	3NK4E147zXkFJiTaBmNjmsw5ypif7yNyQq2obPDfQHHzm14N38GW	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1471	1386	260	6301	11951	jwHKe7K6xWRtQJNgE6VWAnmHmVnLmRVwpvDSJVp9gj9Cpa19bVL	8114	11493	11493	1618007940000
15964	3NLE8PJum9J3BDxJ9Z49vAGbrku8kE8Uc8d3bb5XvDp39BVzC7Ct	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1652	1069	260	6301	11953	jwS4TCHCoRCZ2Nd974aJatMutVFAUeiJJnqDcyG3KRFi8A1NU9D	8114	11493	11493	1618007940000
15970	3NKfPDa6wdT9Maf27DA14WWXybBAgXZQKPL56GGTrimRkMSMn6og	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwKX47YisXUAWR4VwSQCoXQkqBgygafLiMyKdcuS9fzrQT1yCmq	8117	11496	11496	1618008480000
15893	3NLDtkZ6f4zCtWjiLCR2u2rSCyDezxFsp4wi3mtjoiH2D2eEXBWT	15892	3NL6MiuNV1hrwxhqvaen3imxJbNr2kY2atKEx7AhBxG4yWps5WM8	554	554	258	6301	11887	jxuyMzC9hNi6ppZm6eHKs69tj2rskecWT7AAk8gZHiFP473VzEf	8080	11446	11446	1617999480000
15897	3NKr7Q9bLG3g3HajdugyffQ7CnDz1rvh4aKRhr8PnejCcyiynU95	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1607	1348	258	6301	11891	jwqqeekBCx3xgwcpvXPk8Cs1b5sJArdHyvnU8fgGSzfrXntL4bG	8083	11451	11451	1618000380000
15904	3NKSRprKbCzpxgHVDLqsR4cQCbr5gPCcDrwoQv1UzAZgNRJjUGuw	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000
15907	3NKHDedFH7D4e22gdyXtGAhPTcpq3dCmpo3BTV5UYo7AgiNAdNAc	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000
15908	3NKWPrd8BwxVULhxFfWJefjvMBhV2rY84Mg2cd9VB1Azy2Eby6Df	15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	1637	816	259	6301	11900	jxYsiwwspcaQCw7ZppTUm7A9H1W3jBtYn2TkmhXnHX6knyKzWq9	8088	11458	11458	1618001640000
15911	3NLb3uR9fYfjT4QZ9wEKU6KnrgFiUKMuBDx52onFQMK2j5V7kzP5	15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	1534	1317	259	6301	11903	jwhLjr8XfkHkAakVrtAZ64rW8h4NHuVmo62YJUqNtSNDHFSgYy1	8089	11459	11459	1618001820000
15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	15912	3NK8w91zsbuF8puFvH3nseAn6QfWaViVUbjyEojH5w2PLWVE3J73	1546	1339	259	6301	11905	jwYZxjWdBNgw9gEH4nnpdgJyHE3FHWqNEJ2zREPRLgwVwUGrJWh	8091	11461	11461	1618002180000
15916	3NLmeM9W7wcZzhCHrqVoLQtwQ8zBFhKPkEz5hZVJdkdAyGEKHJoK	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1505	276	259	6301	11908	jx1ZCojYy7jHRQegEd3usNhrbxF8HEJsvJRppeMFU1Ry1eCU6Ry	8093	11465	11465	1618002900000
15919	3NKF1cfHaU9RgDZ9ttPkSVqufQn5cLrCRTjmj2RuM2bwPbfVUYc5	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1637	816	259	6301	11910	jxHYAymf4g5KjnyKnUZYe5LtkpwfHY5Xwb9gQABZprCtFS8ho4w	8093	11465	11465	1618002900000
15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	15919	3NKF1cfHaU9RgDZ9ttPkSVqufQn5cLrCRTjmj2RuM2bwPbfVUYc5	1600	1126	259	6301	11911	jxhrGRcJdbS4wogpA7hzzGCVPQV4sqDseYMpqWZ64EEcEznrzW3	8094	11466	11466	1618003080000
15923	3NKmbwY8sHkc9MvqfTxD7XWLexaMcHBW42SBEnN7r89vxqcnZkvc	15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	1516	1294	259	6301	11914	jwoJBojK6kuHDH2MU763R3iJeCMTzx5QZo6eZ4obfFUZHz9x74u	8096	11469	11469	1618003620000
15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1553	776	259	6301	11916	jxgVtCFk4xQ3WDpcvbsbWAQTkpCWjLUbjKefghtAHhgL6oWg3ag	8097	11470	11470	1618003800000
15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	1534	1191	259	6301	11921	jx9DGCr6TQJhHvSjNMMRtvney1vWgU4rmoi8iApSQU96ypexW1D	8099	11474	11474	1618004520000
15933	3NKy3Mp4oQGqyh6qEnJKj66DxK12wGJbijJUDFZsS5ZPkEFdbFsx	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1407	1395	259	6301	11924	jwc3ninJhvx8umfcnvtCrwxmhekHByziqmZaQu4U2q6x6WZYHzy	8100	11475	11475	1618004700000
15937	3NLVLCL4q6obLajYYWF1wLYXyCqcMkQusLpzAjMZWYQfNHRNMK3X	15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	1406	1393	259	6301	11928	jwtZASTzZ2cgAEpySvNBneW6NyvJ2FMy5w2a83anNm37Jirj7fy	8102	11477	11477	1618005060000
15939	3NKLQesdg7As9viWZZymAtaXTek7YADFiQyQLmcFJok7p3WG2q1o	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1407	1395	259	6301	11930	jxAbUR1aWp2svAKB9sfBKZSipS6xz1qFnSigVvRZTyFBEXzXe9x	8103	11478	11478	1618005240000
15947	3NL6mRaUqbsZNtWfHrxKyZLAgYdyyCKWvbSsEwsn5FfN79v9gSeT	15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	1407	1395	259	6301	11938	jxpDqQGMaJXw1ASCZj2KDAxXyfrxNsSQH8PrLH29jDY52c4R1VN	8107	11484	11484	1618006320000
15949	3NLqueQojxJ7EZHQc5N7kTnuuj78xn1ZBYFo15aPBYQXct5wKBub	15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	1631	794	259	6301	11940	jwNiC72AnZJimaMiHzdyHovf9KcZ1kjYL4k5GTXDSiYo9FEm6av	8108	11486	11486	1618006680000
15954	3NKwTch9NZSdhkmPybcJpjVAJgduQ7LkxgoGY2bAUHyeXQuJMR2H	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jwp4DR6iv9K7RhJ44xWU43mhpRqFp72KtSUH6cuc3CzFJXhrRb9	8112	11490	11490	1618007400000
15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jxAwx2SPAXa35jJBPPodCJzVzY98es52s91jyJr9CwyTwUQ2KhY	8112	11490	11490	1618007400000
15965	3NLbm6EXTKiRGfRSRehDjCTkZdPbN3XPKwoi28HwvAUd6sy7aMZF	15964	3NLE8PJum9J3BDxJ9Z49vAGbrku8kE8Uc8d3bb5XvDp39BVzC7Ct	1426	1364	260	6301	11954	jwkL1TpzjmzYDt1FSW33fZRbEDb5A9sj6jnG9j6TwixZsvpfuQ6	8115	11494	11494	1618008120000
15968	3NLCZKbjXa78AcAXxJpPVDe78TpaR1xavJypKbuPHWQdzQwwyxtv	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1407	1395	260	6301	11957	jxS1fH8ZesUCo6YwH3sXXJdRaWi8uprMySTNQkRAp65vfGEa3yw	8117	11496	11496	1618008480000
15972	3NLhsUKZiRhXhuso7k464oDRGXv6ZS3YAAUV84EWC8hA98nRTrr1	15969	3NLm44feNh2KhP2o6SnmZy9Srni7paQXvYUBQhXGMLJu4gVYtzrn	1458	1323	260	6301	11959	jwxFhE79nPCj5b9CU3YB61ea1ScfSKH3GTPrT6816pKZJcXS91K	8118	11497	11497	1618008660000
15975	3NLHaEJ2sT8hCY2kj9EeokaacB7FQ7Aw3vYGemuFtLVH9FutvQNx	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	484	1319	260	6301	11962	jxPP3VUDkRCDSH22Sy3rAKAQLZNVXyEVY142NfZfkqwgbPLzGNZ	8120	11499	11499	1618009020000
15978	3NKA14mWs4XBEHQ4Bj3cMxv52A71VtyoTqsz3rqqVXak355mfVRG	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1422	971	260	6301	11965	jxckAAeLkiULsTQxbq2vXqhoN4DHWNStGQHmpLTxKhUnxfDAZ27	8122	11505	11505	1618010100000
15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	15982	3NKfzysfSbJSdkh7EGP9n16PqyK5eCZaSiP7NfqhBCQL6thcAaCn	96	96	260	6301	11970	jwNpCk14cGg2HcePftfWgQFEheUEjovbbK1Y2xhNdnhS1dL8KfU	8125	11509	11509	1618010820000
15986	3NK5Jnc6VaK2gay8eBKzumVgSwVEJLKvfy9tfwUrdJ6h8Yr2AWoT	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1402	796	260	6301	11973	jwNSUE3CNaFZW1hH8bRVCbqPuXzf7cg7MbUY4MVt1u2CVXrXHUH	8126	11510	11510	1618011000000
15988	3NLW3H55GcjDU3D7aJPRjt6dbdwtv3t7Cs3pHFjB6vcRQ89bkRgf	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jxASoSjvZXkXefiERzyjht2N2bFVSCxkwnAtxah1Zx83KwDjrQU	8128	11513	11513	1618011540000
15990	3NLjJJSgxXWEXnoFD4JZ7t82kjb2AmKRSyj6MUeMCuEg81s3Ywhz	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jwdrt6TsqawPaASvHxSACBMk22BtBCRF6mGLDuL3A4T5saH1fnZ	8128	11513	11513	1618011540000
15995	3NLtGJe7kVKhDDJE9tPvNNiFwNzJ1QBviJQSfRRQhL5E2PH4vj2Y	15993	3NKxhA5UYyFbEmG4GyjK42HfE3P3iNYB7CPWVwSmPWUV9RFboaBh	1406	1393	261	6301	11980	jxRPuLCgGQFMzG95J21VpFyRnGx7jxqMxFPR93tGydKmY7cUR4M	8132	11517	11517	1618012260000
15998	3NLqqQ2SZiwWonZXw9hYA5acdov4Cze6aovYPTd8BRwetu1YB4g4	15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	1651	1301	261	6301	11983	jxHL9bZm6VMrnspVfpxFZJMJmGTehr1dwA9mtiXCxymC8zovDxT	8135	11522	11522	1618013160000
16001	3NK339cMGouMJQz9wBJJdniksks75gs1yvgwKkdjH6aKT1PDRMWb	16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	152	1084	261	6301	11985	jxPBAqFJPps6AUijxUCMy4Ukeb23zejVX2wmiZcGAFc8VYZ6Ywg	8137	11526	11526	1618013880000
15902	3NKCymMYK1hXqRR6vtavMgKNMpjSEbzFSWCs9wJHsjYBxhSsvXMW	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1402	906	258	6301	11896	jwKn4p5DbXCQG6DeEh8zm9754LAnXbYrjUFVStbTk9nsbxJs7Qx	8086	11455	11455	1618001100000
15905	3NKxn2ESvefkRswsix73ar2QuEG3pVUqvFhBokXLBEaoJWQifkBo	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000
15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	1419	814	259	6301	11901	jwsVFYLrNPZTkeiug9di6W8Z98NdbXfsHC5zFECe99Sf99vZM5U	8088	11458	11458	1618001640000
15914	3NK9cLQMp9nuodPdTAbgExDwNjVeY5Lqqf3t6asrXkN5U8waegrS	15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	1581	778	259	6301	11906	jwuYg5xuincu4DqtSvvkJ7jGSDzGtrLosLFbiX5HcwtVF6qq8vr	8092	11463	11463	1618002540000
15917	3NL7w1DNHjePvRJNwXBkgmSwNS8KdjoYjzijBuo1JZ5kJWVy24LC	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1505	276	259	6301	11908	jx5RNAZamUYyRdJ4aghR8Z3oqJF7NCipnyi5kmjx1H5eWN2rbkH	8093	11465	11465	1618002900000
15921	3NLtPzqpxENUk1eoyzPyfo9ZftSQshdM2u8h2feEa8tPHmxmNz9o	15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	44	1079	259	6301	11912	jwpVdMrYfVBVVkjB48jxXSBu3Rrc4iESBKMh8EHGLr5SS4RCAo9	8095	11467	11467	1618003260000
15926	3NKr1G1XNiHDYGnLEeZa8vqoTF1ubqTMCL6JPd8KzNiZMEkeCJQk	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1405	861	259	6301	11917	jwjJYsbiUp6oEx6sFCEKbF2WEnyafcZshrap8rZT88yKi6eEnGz	8097	11470	11470	1618003800000
15928	3NLJXgrT3Dk9QiB8iGHQTujDi2scQ87oFdSBeh5TEmLk8iiMyFt1	15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	1407	1395	259	6301	11919	jwLUqdfMyv2iQxUbSERW1p2P1XZNAFLKAGhGhdhbmngqZVHz6Sg	8098	11471	11471	1618003980000
15931	3NKmtkGz7EWUgzZYeW5jR17rnpqUjYMZMwEjrH7PB7ZCEVdLTKdv	15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	1585	1240	259	6301	11922	jxcbYBfdinEwxUDkmdzF6ZBk3Btqj8DwQc3YGK877zLME1Cx8AM	8099	11474	11474	1618004520000
15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1649	1257	259	6301	11925	jwZVCjUL9JsbhpsxDMTTdf6y2uqtXHtkYjCtidKDdnCwofQgMnX	8100	11475	11475	1618004700000
15935	3NLQURGSQVct9jMNziLWKTmfCVhga44pBAhE6HpWvon8noLPcgFP	15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	1407	1395	259	6301	11926	jwot935CHaNiH8rU7hW3qcyptmvCLsEqZUDpNHfLUZyxWbJq4TS	8101	11476	11476	1618004880000
15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	1407	1395	259	6301	11929	jxwoyoQwExSkqnPhZgKFzTPXojEBy28Ye71tsnyX29vD2NRbtXJ	8102	11477	11477	1618005060000
15942	3NKTSZKgvMDrSmyvCpdFTWte5UaBBMEgxifG8iWEo37qB8yo9tTX	15941	3NLRmoP8gkNVjKpY5EgpXG2HYz4ggGGrx39fAzBaUuqedVsC6mib	1406	1393	259	6301	11933	jxTmXpZWXYS4u83sraGdYWvqwNJwrQWLfJHgyrzMo3JdrnYhBUu	8104	11480	11480	1618005600000
15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	1637	816	259	6301	11936	jwoLbjR1mCQ3u5Jpq4FYEq76Y2HQ2GKuC2rNAW2uQGAaRrkK2Dq	8106	11483	11483	1618006140000
15950	3NKbV7BgUPF15uvvL38YDDJ7QLsq61o6xNnyBDNnnf7k9wUd1r6Q	15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	641	1090	259	6301	11941	jwQwixtL8DzrvkrdP1vNLwopFkCU8pEjmrTfZVThenfjBz4n9ay	8108	11486	11486	1618006680000
15952	3NKumYNNhYbtkLmzhUJnQvGJBXMu37YDuaGXDuKx6nHR2Wmwe735	15951	3NKQjDDnKaaP6cPYmtwRdejbZJuPPZKFfDr13wuhYQvyH5FHcCdp	1440	1377	260	6301	11943	jwjJYzAgKt5RrNChjp4F93x2J5ApHupL3Q7uEUqhxsczMVkfLMZ	8110	11488	11488	1618007040000
15957	3NKrX7sqy8LDTo3v7oyRW2Di8pX2psCkncPbdCaPkZEyF9DYrqKP	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1406	1393	260	6301	11946	jxFgEerDiyV9rxVZNGPppxHMnw3oSNxED2eaFD12t9iUESV5jvK	8113	11491	11491	1618007580000
15960	3NLmU1LcsDjNemzNRLT4GkdTncBqHQxQASZ1P31P3Gr5zPfN12Wm	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1504	113	260	6301	11949	jxsniUKCU5q7WUL7Hfhsp3qMiRdqahub6FjEkmqV5GtPkNH4Ge1	8113	11491	11491	1618007580000
15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	15965	3NLbm6EXTKiRGfRSRehDjCTkZdPbN3XPKwoi28HwvAUd6sy7aMZF	1481	790	260	6301	11955	jxC99EZUB2QkRrMZZVgcKfiEKugp9z5cbwkhTkroKPcyQNFoRXG	8116	11495	11495	1618008300000
15969	3NLm44feNh2KhP2o6SnmZy9Srni7paQXvYUBQhXGMLJu4gVYtzrn	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwbpUz8suANWRtwM9Kt6fWYjH2soVWXnHLfxy3qaLDyJw8dKKVC	8117	11496	11496	1618008480000
15971	3NKqWqAkH7NDrFeQCkmdJSnZtUAS1ejrZ8SYfYbZtPAvJYhqQZFV	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1403	824	260	6301	11958	jxzXGAUu5fRn9H8wY1sbir2c73Jx9dPWjLyAALpUGr4u6Edyy5f	8117	11496	11496	1618008480000
15979	3NLFsuyHzBGBbArRrEhJuX9F5gHdsbsAmP3ppw5DyQt7Zt6uFzun	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1483	1030	260	6301	11966	jx8oBzpJCR43gEQaazWkbEPZeABkNbEUx3asSfkXEQLdYjbtj6Q	8122	11505	11505	1618010100000
15989	3NLXRs1nhqaCDtvzLWV5iE2tyftqQEUMJqZd3YgPYjfbRV4wG2aZ	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jxrjiAzPeyaAnCkJySuc11kYvUGM9xmNBx6uQsjEqkQQYdUhm8H	8128	11513	11513	1618011540000
15993	3NKxhA5UYyFbEmG4GyjK42HfE3P3iNYB7CPWVwSmPWUV9RFboaBh	15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	1407	1395	261	6301	11978	jxHmYrw4aaNWfec4fdHjj9sgCUkVLZiHhFFPhLr4vnCcUTCWfEM	8131	11516	11516	1618012080000
15999	3NKNU3S7KNfsBuX9vp6x4mTaoc3kLZTafiG3GwMvVNsXt97EawJf	15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	1651	1301	261	6301	11983	jwGU4zS4EDYPC5hYAUz41dGjKapqVqVBYHZciRys6EnUprVhXGK	8135	11522	11522	1618013160000
16002	3NKJJ2t6hFSoUa8YCcBy4owSYwBVh4zRQYiSyw8PjSFCUFPGfdLe	16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	1581	778	261	6301	11986	jww2NqT63vfxTvk5CzG6XQrQEicDUdwEJPHvAUrULcgJBcJJvxF	8137	11526	11526	1618013880000
16005	3NKx8VqESRytWnUbhrCe7TKKN173Bqn4fWbPBQ1xjPtnD3MY1Dzm	16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	1483	910	261	6301	11989	jwGNLcmbQngd1Z8XuCvLLDpcFDnWt8hM546CgX1sKHgrEMMcMAy	8139	11530	11530	1618014600000
16009	3NKSuWfxpoCZhNKxmbcoovVzaYKuBjtot1HphstCkkE88vJWW34a	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1553	776	261	6301	11993	jxkSYkaM5d929yrFDJ7FzkiXxNbeoxwcSEjU1NU8zpuZA4j3nam	8141	11536	11536	1618015680000
16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	1522	1322	261	6301	11995	jwjGHH3cgXUsy1Unmo1uKqMo2vg71RhPu7LLuo4DgQg1St2jKUh	8142	11537	11537	1618015860000
16017	3NLemKk576u7NxKp57DDAUT7U54CngAoEusu1WRP3pYVAE3b8TKa	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	1503	1031	261	6301	12001	jx8NP8icdNakSzec2JnWYtNTCEDrwdh4gguHC8b38zstwvLeBcM	8144	11539	11539	1618016220000
16027	3NKq8efsnWmbZ5F8yamDj4bwKtpcwdtgqpzmJgnwG5AemLQGGsC2	16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	1405	889	262	6301	12010	jxmnGe16RZ61QgdWuHqV2VmX9rfdVHqrL8ACHB6oYVPKs7H6TS9	8149	11546	11546	1618017480000
16029	3NKAfZmkkCstd6wxM41QvrF3WrH3SGF9g81wVPPhhJa4KDKAbjgD	16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	1406	1393	262	6301	12012	jxKZbnecjuPPPr6hX7wgmiw9UEmGDvPfcEG3ehbvjR9Kp2zGxr9	8151	11548	11548	1618017840000
15941	3NLRmoP8gkNVjKpY5EgpXG2HYz4ggGGrx39fAzBaUuqedVsC6mib	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1403	824	259	6301	11932	jwEN6i9DVTWDLB9L6bJf8m2ENWh98kAeroTUnKsWqzS7tzDCvbz	8103	11478	11478	1618005240000
15944	3NKsqjiy1EbikkC9nUYT6HZfPVm1pDRpccbCbCtKZwzvGCiRedXG	15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	1406	1393	259	6301	11935	jwmTFQwnN1FQAGejrqYUBciJQt2N9t4BxkLMLREtakPTNGVTZ4y	8106	11483	11483	1618006140000
15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	1529	1316	259	6301	11937	jwLAjho1W4in6zLrN8Mu1ZKRiXBA5vdAuBAttXPuYYn532rfngo	8107	11484	11484	1618006320000
15951	3NKQjDDnKaaP6cPYmtwRdejbZJuPPZKFfDr13wuhYQvyH5FHcCdp	15949	3NLqueQojxJ7EZHQc5N7kTnuuj78xn1ZBYFo15aPBYQXct5wKBub	1637	816	260	6301	11942	jxudzvD6UwRZRfzxQeKXBi7kHbMHgF9nxZdj7VWrCY3nWdevB3b	8109	11487	11487	1618006860000
15959	3NK7LkMRE8T7PftamyRjXJSDiZTF8At5p3MgTAqKykWmfQ9po59v	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1405	851	260	6301	11948	jwS8cX9oCwU6bdq5psty888W52zNVsoBjnToCTrm4uyaqvwqJiG	8113	11491	11491	1618007580000
15961	3NKVxtb1mtxF4d4K29PkPZYWaABkLkuTwZ5WL7bKzVRr4U6W4VrX	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1637	816	260	6301	11950	jwXT9XKuDjrQzBFBd1r7fiMz85VfXwPsrPPzYjn7dHLVF8GDpqd	8113	11491	11491	1618007580000
15963	3NLLGNNGbLDhj2qRC2kEqUSZ2CGjVXGbKPmRLoKxQGZrjEUQdMrw	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1623	830	260	6301	11952	jxn2pXcLZKDqctLweAaQgnNx6rQ6cKCQ8YaMUYz839QaActcnCW	8114	11493	11493	1618007940000
15967	3NLFU2j6kUFu5gQaxq2UfoWJyL74rAn4sbvnK8ciYyCfSri5Ru9n	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwyQif6ff2U6sV8icEFzt1g3nfJUfgz7BUA2kNv4QZNYQm1TtgP	8117	11496	11496	1618008480000
15974	3NKKz1NbgcYDgxHdHYTUSwYFMtZiLDyHgqktGxi3yEXYeWP6HvL9	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	1553	776	260	6301	11961	jxkKjYQdqG86KcGQb7AyVXm3gbuKhZxAYCMH3LQkwbseSddsVUM	8120	11499	11499	1618009020000
15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	15974	3NKKz1NbgcYDgxHdHYTUSwYFMtZiLDyHgqktGxi3yEXYeWP6HvL9	1573	1192	260	6301	11964	jwYun8ip19pn6otHTV4owbmB6aDbG9C8ECbSzYdzuKK6XQiqbVp	8121	11504	11504	1618009920000
15982	3NKfzysfSbJSdkh7EGP9n16PqyK5eCZaSiP7NfqhBCQL6thcAaCn	15981	3NL2iaz48Pe2gyDasZW2JyC4TBKqhZPXH9frvHgoiKqVkRQARLKE	1507	1280	260	6301	11969	jwLeG2KymzPvNf1KehLNbiXpMkQf8gVkvSrFHq2Lx1n1Yk9HLK6	8124	11508	11508	1618010640000
15985	3NLCnjSPW6A7wfqXFAtwuAcWUB8zcMEXSFcZHnqTL568AdFqWRNT	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1619	1275	260	6301	11972	jwtvHN7bbxz68duXDSPrKFmwaV1WDBsytXtnH6GEQ5U1MXKwJkZ	8126	11510	11510	1618011000000
15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	15985	3NLCnjSPW6A7wfqXFAtwuAcWUB8zcMEXSFcZHnqTL568AdFqWRNT	1553	776	260	6301	11974	jxzGfSi58gFLR4vWtvhLn4aViYXhcfe61xtogvKw2RkXiBvtMbG	8127	11512	11512	1618011360000
15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	15991	3NKXKidvarFMkZHz76PtzGEEWVuQkehxoWE8x94aA1N37kVtXXK2	1553	776	260	6301	11977	jweZLAfwAXfT8NsHuvLXKjmuXF3UKJUrV7NhFE6s5RqRzjfuaNe	8130	11515	11515	1618011900000
15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	15996	3NLgERvybuNL1ScjHmrJwqD1ZrWdwFM7LJQ5FZ4UeX815wu8BKZq	484	1193	261	6301	11982	jwFmrZSVtp8sc8MvY6WTEH7fgH2YVXiPNy2NhYV62bEXAtiSkPK	8134	11519	11519	1618012620000
16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	16001	3NK339cMGouMJQz9wBJJdniksks75gs1yvgwKkdjH6aKT1PDRMWb	1631	793	261	6301	11987	jxcrXGPhd7hmKE252nNrUHweNiVDXSEGzzVucLN9KEF4uiJjND2	8138	11527	11527	1618014060000
16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	1585	1000	261	6301	11990	jwpcbwxcjZ5J4vohuz1FhodHGSdZk7LaY3bdKPXgo9UhUQrgT4Y	8140	11531	11531	1618014780000
16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1406	1393	261	6301	11991	jwRny6meXwRS2UqCwmQRu6j6FyYTmJGnSY6LE9i8SuY2yrZzLXz	8141	11536	11536	1618015680000
16020	3NLSKKosWff5dQdCwtVXV93acPiyGD7dan2nVYDpFi13E5wvGKzH	16018	3NLhSUHkxUCGx7zSsRyqwEKebqUFpc9QLXnu4sL4BTi7oZVrbof5	632	1382	261	6301	12004	jx7fqW69QJMRg5oed4DVm8DYMCvzRCQJGNREw12vRwQbW9yhTQL	8145	11540	11540	1618016400000
16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	596	940	261	6301	12007	jxBXDc2c9rf84qw5c8hoq7f5j1oaoNdrTY2S28TqWofMVsCMcvg	8148	11543	11543	1618016940000
16025	3NLTLys3JpAmXbbWFZ3WjeFJPE3WkjJTEU5ekyC4sCqo5YRqkwnn	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	596	940	261	6301	12007	jxBXDc2c9rf84qw5c8hoq7f5j1oaoNdrTY2S28TqWofMVsCMcvg	8148	11543	11543	1618016940000
16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	16027	3NKq8efsnWmbZ5F8yamDj4bwKtpcwdtgqpzmJgnwG5AemLQGGsC2	1553	776	262	6301	12011	jwqoUowLV2rRR76JHLNbyunmRjfj21msDqEjWG8AGBdynyjunWN	8150	11547	11547	1618017660000
16030	3NL7WJFsGUekhEHRpa5SqRyxcep8qhuGAymY1Fys27qL2gyoQ1vt	16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	1637	816	262	6301	12013	jxAkqQSi6jJr7MibcHtpB8BydgX1NSANzz18E9bJsZA5CJRtEwY	8151	11548	11548	1618017840000
16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	16031	3NLojjtyC9hFMJFhzxbYjRBdDnmyMghgQ5ZpsRYsbWwhYcTMRRrg	1588	1146	262	6301	12016	jxiDrY1aNoSxvbWAKpH1RoErhS6aBoyABdJDi1HQUbzgSK5pgdF	8153	11551	11551	1618018380000
16036	3NLxthGvGNwU1vQMDgyZog7CeQtQnPc594jaGoFDhfGLCaX8K2fZ	16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	1419	814	262	6301	12019	jxwZDBz7JW7EDiUGPwvZ792L6MYDmokUcLTTNRXzc5ci8e9PXVD	8155	11555	11555	1618019100000
16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	16037	3NLXwuMhMfTEfTRhjDFn4Yfsx4LzteVCbkVZaR2qZFwgSiELUNxn	1440	1377	262	6301	12020	jy3C7fwo1QySEwYBMWBPmMNxGVQR1ZMVRcVjqheSGSW755ZSNyt	8156	11556	11556	1618019280000
16041	3NKKyp4AsBkrwXVJ4TYoKaKPEj2Q8adS6jpo1b4QAnMtL4DzvGcj	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1631	794	262	6301	12023	jwaLhnLENU2YcnMDX7dWXJ3DwNABc4RqzYgcHPyKRyG18FqVNm9	8157	11557	11557	1618019460000
16045	3NLBToHXDm3PkiC1HhSWykCdQe9k8BBm33EjVEyna51RDmrRdCiA	16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	1406	1393	262	6301	12027	jwhcg9ZfhZPdUgDa8N6u1Jey8H8hDVHMZmfJzZkKubFfSBJZnkL	8160	11560	11560	1618020000000
16050	3NKGWvBDRUHAqB2SLs8okS36DAv6UDqWP9vqrE3L8GSdzuBSX3tJ	16048	3NKv3ovbKTbPKPTF92YSTvFkWVw6F81HmvEEE6y6oQKeonaV4EG6	369	1066	262	6301	12032	jxTvQQ9AczzfKVj7q2D12Z6gyqgdgTe3yTMSmT86cafPTUaCHC8	8163	11563	11563	1618020540000
16053	3NLTQUmob4yYXty5VC8c1JrSit1hvmGbSFSWksPmXtnkaDnjKVmk	16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	58	915	262	6301	12035	jxaTDcbupKBQiVR9c2CY1Eg1JnoENrHHDc3LssGAkoKw15c9NwZ	8165	11566	11566	1618021080000
16055	3NK4R6Fi4bm5xG87K6bv983RXai9Ja2AbDzkSk7g2i4R7wKQschy	16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	1406	1393	262	6301	12037	jwUJ24sXqk7Yi2fLGEgKYuHCtgtUptK8Uii1oaY5BDfNCybw5pf	8166	11567	11567	1618021260000
16058	3NKyDTkzjE4Qb5994fBhikK1th8PVt9GSNgWrxzRwQmJP2JqHZkP	16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	80	1273	262	6301	12040	jxiH6QB5TmmAZoVVdXTnA6JVn1esPczXypZtpVEfy55yUcm6hmt	8167	11569	11569	1618021620000
15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	15972	3NLhsUKZiRhXhuso7k464oDRGXv6ZS3YAAUV84EWC8hA98nRTrr1	1445	1290	260	6301	11960	jxo4LxctUoQi6Hu5GeoMt2xQnPzfNQLbRvStw4BzBtwpMz92d4g	8119	11498	11498	1618008840000
15976	3NKMth3LhQmgsDcZLAni2D2CXCiqRoq6uG8EwejqnHnBB1hGgGzL	15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	1596	1363	256	6301	11963	jwpM99SJwE5YBUbYGfr1epeZWJYRst8EMPqsFkYCjJe6UptfzM6	8047	11501	11501	1618009380000
15980	3NKkgueHStfivcr1sLHGWKorima9nuLADVTYYPQtVYD9bmSUme9F	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1447	1219	260	6301	11967	jxLPLNWBwWhzZuTgubQDkevfBsaWsg3tc3DhHR8gdWY8NbYULxo	8122	11505	11505	1618010100000
15981	3NL2iaz48Pe2gyDasZW2JyC4TBKqhZPXH9frvHgoiKqVkRQARLKE	15978	3NKA14mWs4XBEHQ4Bj3cMxv52A71VtyoTqsz3rqqVXak355mfVRG	1445	1290	260	6301	11968	jwWF6L5YGt9s5DzfnMhHZxBx5BYf48aWSKPJfNVsuVthzy4PzaM	8123	11506	11506	1618010280000
15984	3NKcW2zwejCWNfcnz4MRLsR8PRiPhvNPyvgYNqFGfr4DYwhbsqHz	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1458	1197	260	6301	11971	jy2u5B5QYQfLPtqTbsMbb2GjmchzHi8ufTJfkrnVzZn8iY7AFqZ	8126	11510	11510	1618011000000
15991	3NKXKidvarFMkZHz76PtzGEEWVuQkehxoWE8x94aA1N37kVtXXK2	15990	3NLjJJSgxXWEXnoFD4JZ7t82kjb2AmKRSyj6MUeMCuEg81s3Ywhz	1631	794	260	6301	11976	jx1iqpp6UTpL1uR1VSC4TgJ5thZXwPAsQm1qLiq8TkF3HwMD2Ze	8129	11514	11514	1618011720000
15994	3NLVWi2Sg9AHfjufyZ7K6XhnbFxnUmmQvaaVMUchdpsvz2cEJZXy	15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	1602	552	261	6301	11979	jwaBXHfTneEwCon7J3H2RMhHRPGRMkhebL2kexquKEV5os2NJvd	8131	11516	11516	1618012080000
15996	3NLgERvybuNL1ScjHmrJwqD1ZrWdwFM7LJQ5FZ4UeX815wu8BKZq	15995	3NLtGJe7kVKhDDJE9tPvNNiFwNzJ1QBviJQSfRRQhL5E2PH4vj2Y	1675	1342	261	6301	11981	jxanYBVWpfwh6MxQVebxEjy2ZXNV2PHg9NvgYzHTEFw17qA2q8z	8133	11518	11518	1618012440000
16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	15998	3NLqqQ2SZiwWonZXw9hYA5acdov4Cze6aovYPTd8BRwetu1YB4g4	1451	1166	261	6301	11984	jx2TPR8yZtzY18nZoLNv8e4hnndwaJbfVY8baDexV8tQ7B68iob	8136	11525	11525	1618013700000
16012	3NLQb3hskVyWy6sVyNrWjRLM5FB3ujyPvUfUggH5EtyADVbG66eC	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	80	1273	261	6301	11996	jxb4v6HohsCTKy6BJE6xjtwDwF5YpGxBLDzspnbtkqdknNQSNeH	8142	11537	11537	1618015860000
16015	3NKpfRxUifxwyZrywRBrxX6zSPNdpx5bQ4hLU7Z3HvdZP1HKnvVo	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1647	1302	261	6301	11999	jx9EqVy8stS6EJqkcJH6B9YhW8tAsm987m3Tr4gTBVCKyVQLwWP	8143	11538	11538	1618016040000
16018	3NLhSUHkxUCGx7zSsRyqwEKebqUFpc9QLXnu4sL4BTi7oZVrbof5	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	171	1374	261	6301	12002	jx111BLCLYW2QY6MB2Utfke7RK3CELQcYrRWpDkvKjww81rwDXG	8144	11539	11539	1618016220000
16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	16021	3NK3an3TY2m6oKfasjL922voB4oR9ivVMME3MG7cSL7UbQ4eap5c	1656	1097	261	6301	12006	jwvhH6qHZoUwR57j41wLmwwyB7qrvSG8hRkNFbjcN6AwaMXj7si	8147	11542	11542	1618016760000
16032	3NKC8CEgXHpqxYyWp9tiMkeh4DmYZMwc1A97rKztKgRsvyCLSkfy	16029	3NKAfZmkkCstd6wxM41QvrF3WrH3SGF9g81wVPPhhJa4KDKAbjgD	1467	1376	262	6301	12015	jwbvYF7rwE8DMLKMurtseoMsoAnDuberfcLDpcnxoPiDDhoybhA	8152	11550	11550	1618018307528
16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	16045	3NLBToHXDm3PkiC1HhSWykCdQe9k8BBm33EjVEyna51RDmrRdCiA	1559	1353	262	6301	12029	jxzLdfwj5TTLPnGZh4ra8qY92ZWcDkahiUsSuMePmcJFP8AN8Ai	8161	11561	11561	1618020180000
16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	1599	1041	262	6301	12034	jwAuJ7RQNjp1jArn1cRVUC2RgcDFvESiLuJvxWFj4e9mT6eFisR	8165	11566	11566	1618021080000
16054	3NLKVjAX2ditw7R7bw7k316MfirCXHY2XZxuvq3zoDo5xpVhNTy4	15908	3NKWPrd8BwxVULhxFfWJefjvMBhV2rY84Mg2cd9VB1Azy2Eby6Df	1599	1041	259	6301	12036	jwK9JXzvo2mepz87oU9fVsPmS983yVpqLmP76Qkn32Ybd2i8p6m	8089	11566	11566	1618021080000
16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	1546	1339	262	6301	12039	jxF1jDHXwtjRN7odvK8F7dJWRaZxDWptU6ppn24TghccygQdkoM	8167	11569	11569	1618021620000
16059	3NLr9ZA9989MVbUqrsWLN51AGMVvB57N7rhUgDvEFZh2HsQYSP4r	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1406	1393	263	6301	12041	jwtNxPSh2RzdEs3KJDpzZuWsBYkHRsHfYt5oDJBXDFkai8JeNg5	8168	11570	11570	1618021800000
16062	3NKUtuGf26CMGyqzcrzdFR9r6roHDFp1CUhcRTtyjgS4AtHkMvhL	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1483	193	263	6301	12042	jwGHG6hP7UiSAeyuP1ggTfwbK2mL48QWHZQvPKLC9wjPd1qjPQ5	8168	11570	11570	1618021800000
16066	3NLaeiVnaGHfVVYLRiHUzUivY6WGhWNp7SRv5iRZaWougZhSA4TE	16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	1646	1354	263	6301	12046	jxNTPfqiGDSxUkrvSCKCLsDfPRKb5RejrWPxWZnmdhsNSVxDG5D	8170	11573	11573	1618022340000
16078	3NLLe42y8dij5mLEy3a88FTpUKQ1K7vWTqekXQw8icKgtkzSCvru	16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	58	1281	263	6301	12056	jwJdkkgH1Q5z4nqSQm7RLNdTCdgK8iRptjHmdcVJvdtoPZBzqio	8173	11578	11578	1618023240000
16080	3NLKuA3G9ASTSDH8zQEhdPyktWKwpq66dqakxRHLsV7jUiThGhEo	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	80	1027	263	6301	12058	jxtcqtF452PXT8MMbWELwjRjAh4anXKwrLueA6k7HLkPDqg61ry	8174	11579	11579	1618023420000
16084	3NKhsAvCotjejXg5DeLGzZez2B3caQaJkHvZMaBgvbcygX4Bujxn	16079	3NKXLwQNhhy7Kcy2CSkZKaBMPVn8DzueP5sw7EMR6JVyJWeDFr4R	149	1283	263	6301	12062	jwXYcCX2FiF8k2LxLJZa2gfNopFFJq9an7Uc4S1KaU18xmiqJQn	8175	11580	11580	1618023600000
16087	3NLWJGTbQxgEEUn78mGZEXeN5P1iN5KxASaKXKxMEdFtuqdBv9df	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1522	1196	263	6301	12065	jxL7WRxkYdMLYsXGp2PXhkH91fvYMrfANriRWbaL3sXehwMiYfS	8176	11581	11581	1618023780000
16088	3NLvuhmK9QURWwBVzYWLXvsauviRPSb2mKbA2iyqx8GwtEpBr8d4	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1490	1274	263	6301	12066	jwhmRNgBHoEBDxJHP5mepF6EbALCjTJpK1mg3Af3wnabeHwjNc5	8175	11581	11581	1618023780000
16090	3NKbvhyfKi1WipAdAMJteA33ogQCBXV4RhFKwK54gNuetfHE2WER	16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	1406	1393	263	6301	12068	jx6qzZAZkR4qEvxSWnXipTENXJZWmbjm4cMdR48iUVgLzRJCmz7	8178	11589	11589	1618025220000
16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000
16107	3NK6SUribEqrdmZKQKPn3dvopxzVz5zHEi222L9DPNTG4hddEF25	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1609	1333	264	6301	12083	jwMSM8uQLzGkEdxg7co4dmkvCx3DZXMAd87pHmMddpotmoSDR1T	8187	11601	11601	1618027380000
16109	3NKJmAcuo6rGkaZ63Nk3fNYcPL688uTdPFrzq2pML5pH5yHt7tnA	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1601	1142	264	6301	12085	jwpy9siMTkSmVayVpmT44PCR5VvDVufGZFxajE6z75XfChiQu9w	8187	11601	11601	1618027380000
16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	16113	3NLeP5MhauCV5ByraDTTMzThH4Wse8Siec3gfGS6oopVTF6tknSw	1623	839	264	6301	12091	jxFbiuTq1GqeGBS6PQ8u6fRqhginjJ7epQ6yXCR5F4PJJoVaoqr	8192	11609	11609	1618028820000
16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	16119	3NLe85sd1U2YQ3kAasijpJ7g9zUJpa1Y7MrjAAShTtDUDakHaQ8g	1458	1323	264	6301	12096	jwf32WQqRg4YSM5BfRfsfo8vq81kcowZjfJ1SXzbScXh596xkVv	8195	11613	11613	1618029540000
16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	1406	1393	261	6301	11988	jxN2pdBYQF9Y9E1Ab7xp8kaEPXZRhtK2wadmHL3qM1YsU7vx3ai	8139	11530	11530	1618014600000
16008	3NKCAGL4jeG2iVHv8XRg7kJYsc2P7o5SAKhnAZRDwzZ8GQZNGd9u	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1451	1292	261	6301	11992	jxmukmxaQPbXLfaYtZUrq2yFzRyGVAnNueYhFDhYQAzEh6vSbwG	8141	11536	11536	1618015680000
16010	3NLsrgQkNveHTU1dxQ7z4yjrMYQqajEjZkKW3ik1FxJ1zZKqMFg3	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	684	684	261	6301	11994	jxTMrWNQnFvciGuBL1GVwBzry8o12Mx1qmiqxTakZ1YZ5rVLkhK	8142	11537	11537	1618015860000
16013	3NLhJWwPX8px9wfnJcVVCbbeRafQhtyyHfMdgunAfzyPHeeqhehv	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	606	1295	261	6301	11997	jw9GXtMtjFe21kFN7aw2iX7Ru5bP3TgQyYwXTjcekvsFeixpfaC	8142	11537	11537	1618015860000
16014	3NLJnNu243zvM6avdiHShSoSwXFKW2tPrnk49acGa4j5gumihNwY	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1503	1031	261	6301	11998	jw6sZ9o11X9sDfB2j3t2jmVR1u2wuvAVd1gguMHujP5uyFAKUFH	8143	11538	11538	1618016040000
16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1603	444	261	6301	12000	jxoQX9mQC77cdbqSjoAmKqK4MpsBo2x2oGczzUd3Y26Hkif5gqG	8143	11538	11538	1618016040000
16019	3NKXqbh7CqQBKisbDXESXLhpD5ExG8XCtTK7dPudKrNxWTjEhxv3	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	1633	1144	261	6301	12003	jxt4J1GGQdaU9U3taiTcekzFcs7ef23Am2FTdCCmwtkKmWqRBiq	8144	11539	11539	1618016220000
16021	3NK3an3TY2m6oKfasjL922voB4oR9ivVMME3MG7cSL7UbQ4eap5c	16020	3NLSKKosWff5dQdCwtVXV93acPiyGD7dan2nVYDpFi13E5wvGKzH	1405	891	261	6301	12005	jw7NpGqERw5ZLwWnKQZasPTvQBL6htLenzuoK4VTbwJAArC17ib	8146	11541	11541	1618016580000
16024	3NLgEs1NGEmAKtKcFvTeK1TjHTQF19di7grJqgBbzQ8Rdj2MPNru	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	1564	972	261	6301	12008	jwsrVuwxsUpbEax1eLsZGrskS9zxF1o7coS9zJMJ6XbjXdo37zT	8148	11543	11543	1618016940000
16026	3NLr68L6kz8pdpyapQ4WP5phvSk9zbkC5PangtydWtMjFBfzqGXC	16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	1403	782	262	6301	12009	jwDxK2nvjdcsA9uwDfTZ5oLY8iy7gH3iNG9URtAPrX9DYmFQ5ca	8149	11546	11546	1618017480000
16031	3NLojjtyC9hFMJFhzxbYjRBdDnmyMghgQ5ZpsRYsbWwhYcTMRRrg	16030	3NL7WJFsGUekhEHRpa5SqRyxcep8qhuGAymY1Fys27qL2gyoQ1vt	1467	1376	262	6301	12014	jwuMi5ECi1hQajniLFPHxWAx4XJvUhV8oTSyndmbYKCKAc3q2mC	8152	11550	11550	1618018200000
16034	3NKZtCDDbjB6XALHaNDtE6V4omsxwi9U3EcDENwMyYkfdJnbaDNn	16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	1656	1097	262	6301	12017	jxyeavMTL64vx3MA3kxzyA6YkxKyTyG3TZHLVJdsGjWSeqK4o2L	8154	11553	11553	1618018740000
16039	3NKvExQtzD6ZuawWJmzGEQoQsL3fBQhBYfRUy9rr3fsfFRZwKVW2	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1407	1395	262	6301	12021	jxqJSPNqVnUVdc1mXELmEX4697BDUjmC1Z9edfETQ4CkRciYFeT	8157	11557	11557	1618019460000
16042	3NK8ANCQMf4Gt52vB7pHBePnW6Z6X8ijbyoBNGZbNbCZoghmjniC	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	43	1310	262	6301	12024	jxbM2jGVm5BApfJzMWdyJC8CyHjxwmxCUwd18VNd46j8ZAQoU3j	8157	11557	11557	1618019460000
16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	16040	3NLBVEQtcZjJNLgKTXuNknnbHxaERkKeWemyA9TmzjxnCiXAUkmL	1602	1369	262	6301	12025	jxHrfR7JPdsH3HRrT82tbKUWAfi2TfDaxbVfD9AtrG3uHKBYXXR	8158	11558	11558	1618019640000
16046	3NLCQPZ82FMPLWpLFVf5GEwJpFvayoHkPyirSWk61dFrJNoYZHtA	16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	1654	1340	262	6301	12028	jwc64jhdSQNGYzLMHPJLXHoFRQhnVBqbgML6pNYpa1PBbmvNWFE	8160	11560	11560	1618020000000
16048	3NKv3ovbKTbPKPTF92YSTvFkWVw6F81HmvEEE6y6oQKeonaV4EG6	16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	448	1305	262	6301	12030	jwM5s2Fbocgj5f9ShcdZz4VoCvsXpsXfPuwGkY282CDoZXV41wJ	8162	11562	11562	1618020360000
16063	3NKG5MhfGf5XR1D84zvFD8wXM3mhrN48fvNA9dkMJH6PAFE2eh5F	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1581	778	263	6301	12044	jwj9oykK3iW5zA4c22uDXhbcrktBSVYGZ1a5VoSikWStvvGXTdf	8168	11570	11570	1618021800000
16067	3NLE4efoZ874b7GBDSFFVZNMazH4Aj6nngPYPfpYkuqsE6SKaZNY	16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	1648	1038	263	6301	12047	jxSkaQSMezCV1G4QRehoaohSB75Je7AYi5MnNhrDCqAhFgcq3T9	8170	11573	11573	1618022340000
16070	3NK9fYV3wVPr28QfVHKF6XU242PRrEaKjaX663dngitvs8woAY3P	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1617	1162	263	6301	12050	jwYWPtQQdRp97PRTcgGr3aQveoTibXpoza8fg6GNYJpt2MkHjTH	8172	11577	11577	1618023060000
16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1651	935	263	6301	12052	jx6JGpkqfZ1ef7AZP4anJWKuaDUnuNB4yyvP2p1mJ119CbvYWgk	8172	11577	11577	1618023060000
16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	1579	1143	263	6301	12054	jy2jEzeTQS2qnrEPrWStrHzDJCAczCTdAV8wyv4L5waE6ERQkFr	8173	11578	11578	1618023240000
16083	3NKgyC8xPCZrqBZCeavWkMeyrfmnahxPSSMxyaCXYmpktq8UPj2N	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1426	1364	263	6301	12061	jwjZTgejupgzUQH533haEatFKnxPabKnaw635uFUKRgfRpBwtbK	8175	11580	11580	1618023600000
16085	3NLM5Q8u7UWo912RzBNG3zp9zvc8w5vo4dJwKBDpYypfoBi7am1o	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1406	1393	263	6301	12063	jwGkY5fTsgAd3VheY6MAkVL7ms8DcLTarYdCAhqykRVet44sLcs	8176	11581	11581	1618023780000
16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	16085	3NLM5Q8u7UWo912RzBNG3zp9zvc8w5vo4dJwKBDpYypfoBi7am1o	1670	1282	263	6301	12067	jxq7RaFgHv85CkMA1b9KvchfcTZU7ohgEsyNhG4CNFmM18Ed2mc	8177	11582	11582	1618023960000
16094	3NKxp4cZSwN1CKtoPXScMjwKydJ7uD9LJ3MR8nJKQixbYZw1mfD4	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1553	776	263	6301	12072	jxMKVdvVu4SUNESYr9bmYq5cYXVX4YBgf9CJbEi3B2FYaSt9Wjd	8180	11592	11592	1618025760000
16096	3NKzaUPTYtpPvE9QukjzZhUD3eyQZeLntBUWnzmifHhdL8Ev1iv8	16093	3NLELrD6KXpW1MUoa8ccY5W67WEzdmuGK7E6Zoi2NJEWMUF6tkzv	1406	1393	263	6301	12074	jwqBaBf73hM8WvyRf5DwdaXCfsXufe4x8LcEc44KCJsbECyi5kU	8181	11593	11593	1618025940000
16099	3NLLzJGmqKd15Tzpz36nPezSpzuL77yQueKAGo3LjwuZYnAGN4Fe	16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	152	1204	263	6301	12077	jxvEXFVqsoN8CDdy27nqhR7AKHfAAVAwGx7V9i9VZRrJ3QuM2oj	8183	11596	11596	1618026480000
16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	16098	3NLFLsricPrYrVyHqzcVbyUE7eVYXRB8xRifR9zaHHyrb645CKNm	1402	858	263	6301	12079	jxav2BeeA1ZTvxSu5ZyPSZgX3WuwuTVfzvEQQ8ofsDxGByvX7Z5	8184	11597	11597	1618026660000
16106	3NKBnzzMPH8fUrRLHWspK3XWa1RhHsR3MUQHDnGKTyZ1H8x6FomN	16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	1403	824	264	6301	12082	jxrb96uZfLMHf48nYXKUXWUptJ13DifX4ZhjHeFrsHeBkZNip4z	8186	11600	11600	1618027200000
16110	3NLhBd4V928eSZU7pGtewWhciUhLY7bFf3qaHabY6btXMBMtxFDY	16109	3NKJmAcuo6rGkaZ63Nk3fNYcPL688uTdPFrzq2pML5pH5yHt7tnA	1406	1393	264	6301	12086	jwKANat1F1X5jeQHvgLnaM5aMv2NVayDHcSH71RDsvEgZpXpSGX	8188	11602	11602	1618027560000
16114	3NKLAEXinDik5hRcxAWUdfvonxKx5EHmxFhCvVfcMrAZWfF7ET2o	16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	1458	1323	264	6301	12090	jxHitRxarm8xwVuSYyoWDkB8YDmSS9npnsH6wRPVfvDnLeS8g2R	8191	11608	11608	1618028640000
16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	1406	1393	262	6301	12018	jx8Z2oXP12SjPRBq3FsfmvkzHNz5j5wuqsLSiBFwsAZprfmcVhb	8154	11553	11553	1618018740000
16037	3NLXwuMhMfTEfTRhjDFn4Yfsx4LzteVCbkVZaR2qZFwgSiELUNxn	16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	1419	814	262	6301	12019	jx6frjbLBKV1UK1DCo3bGpwgLU6LNXLutgmb8NxD2q4uaf78Eed	8155	11555	11555	1618019100000
16040	3NLBVEQtcZjJNLgKTXuNknnbHxaERkKeWemyA9TmzjxnCiXAUkmL	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1578	930	262	6301	12022	jw9zBCLztPkqALX46vfKe1GJ85ixyRq5JnzQN2iCzU23AFjHMGo	8157	11557	11557	1618019460000
16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	1406	1393	262	6301	12026	jwXBr3ZAFmu8uBC9hquVUDvQrhacXH8zfXVRvqjZGejHZ3eqxsU	8159	11559	11559	1618019820000
16049	3NKyihJaX6TkhxHD3K3g4CXgbxJw9ABWb9d7M5uKy7viS1FbWk7a	16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	1403	824	262	6301	12031	jxR914DFCC1hR1RfK3Ar1mNMy7AAq5ti3PGZP6zohKQCqFHDsJu	8162	11562	11562	1618020360000
16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	16050	3NKGWvBDRUHAqB2SLs8okS36DAv6UDqWP9vqrE3L8GSdzuBSX3tJ	1405	873	262	6301	12033	jwVsLC91o9qAi7R4o5dN8w4Pom3LWa1R5z3Bom1CfS7c2BPD8qG	8164	11564	11564	1618020720000
16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	641	1336	262	6301	12038	jxWkcLr6MhyyCrSnE9t299Syo9Dy3BPyMmVLbDieFVArJGy2JJc	8166	11567	11567	1618021260000
16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1457	1391	263	6301	12043	jwSc7bst7jNBxN6SNwW4J6XHRmKg9T73LuNnyifhX61eD3vt5yP	8168	11570	11570	1618021800000
16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	1419	814	263	6301	12045	jwwSibgVDcgsQnTyzippsaVeB6GeA6DzgyNLE7r2sdZEFLsoAvk	8169	11572	11572	1618022160000
16068	3NLKwcJ8FFzyeta9Sd47GoHfSAXNY4UEzHStsAMvkVyFdGnbgrxP	16064	3NK8e1vbcYvsCvTrUsghkx2HK21KYDRR7TCZGxqvGeVCf5PrbfWv	1403	800	263	6301	12048	jxgK8U6T6HUerg449d2Lw18KEK8DLu55S9H9LS6qXckZ2P62XxK	8170	11573	11573	1618022340000
16071	3NLLZWUQF8P1Hvn2H61aY2W6chP8HS8WrHUzxYTABg2PpjixcGVZ	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1474	1203	263	6301	12051	jwhdZvRQ4iYqRSKa23Fa9ft7wuhz5q6yyz49SvbVEmRYShD64em	8172	11577	11577	1618023060000
16074	3NL6VKhFyQBtSgteuC3yPmmcfpmpwosF7T3ZDFaxhXnMuX2y5pXN	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1637	816	263	6301	12053	jxxR4pygnErgB6UhkAeLsNLau6FmaPTyU3ZaGT2K6TsbuHtHnqK	8172	11577	11577	1618023060000
16077	3NLPoWNmeMuu21xgUm2BNrhX5XsdGqbbFReJvYWwokmVLivLhbxV	16074	3NL6VKhFyQBtSgteuC3yPmmcfpmpwosF7T3ZDFaxhXnMuX2y5pXN	58	1281	263	6301	12055	jxK1fv1RTPrSxRc5jnZhZhA6n2TrsYGharQg26MLTXdPJx5uFQ4	8173	11578	11578	1618023240000
16079	3NKXLwQNhhy7Kcy2CSkZKaBMPVn8DzueP5sw7EMR6JVyJWeDFr4R	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	1406	1393	263	6301	12057	jwrzFjCXecVLwvfUuLj1t3BgS3DMZm141EmjhU6J8cGEGB2BSSB	8174	11579	11579	1618023420000
16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	632	1382	263	6301	12059	jxJGUMNbHbejxaMKSEDCvXu7mC9q6NWCbQnx4HphdHFNbUSjcAU	8174	11579	11579	1618023420000
16086	3NLLxrTobXpUCZFEzc4zqyk4XFaZ9RBm25T43Sjn2t7TVKbK6JAM	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1490	1274	263	6301	12064	jwD5pp9aWLJCDyWz2Db7X3NpqSgdKtefaPxSTJRusJ8qfeqdHyg	8176	11581	11581	1618023780000
16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	16091	3NL3N3NNpmiiwsJVkStofrU1eHXi2LWv2qxdP8Sxpa1QYr7fEE13	1407	1395	263	6301	12070	jwxrD9nvAeNoVcaaGPS33PFVd7bytwDVJGweRGGRX6PdHVUinCC	8179	11591	11591	1618025580000
16095	3NLXagY3fh5NJBeEN24LiLnoDfHHine9Xs7oTYVmSvv8oQesrMV7	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1403	824	263	6301	12073	jx2MeGRLVoA2Bpvof94mLBHoff6JZMgU9SuJBdjJ9DRzhJnVyKi	8180	11592	11592	1618025760000
16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	16096	3NKzaUPTYtpPvE9QukjzZhUD3eyQZeLntBUWnzmifHhdL8Ev1iv8	1631	794	263	6301	12075	jxcoqkfL5QZEeMXS86yCeuYGZCrQ4Jg5ghKp8pJ79sXhXYxmhNe	8182	11595	11595	1618026300000
16104	3NL95K81h9uiTe1cqVjuwLvmxLtkYULz1PFA2go8Dg5UocpFPPZN	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000
16111	3NLoeawWXQiFBo1ez6NkWGj1ea8QYHSJuZWhWZKFuxiqBkWViu5j	16110	3NLhBd4V928eSZU7pGtewWhciUhLY7bFf3qaHabY6btXMBMtxFDY	1403	824	264	6301	12087	jxFuLoGvkA4QXgxXz2ZWHtN1XULhM761xm8eayheQie8j3BKVwU	8189	11603	11603	1618027740000
16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	16111	3NLoeawWXQiFBo1ez6NkWGj1ea8QYHSJuZWhWZKFuxiqBkWViu5j	1581	778	264	6301	12088	jwvQnZRxV9ubp3DtixEtZCfkSY3M4caCG1mDDZxX4i4x5vWiWT2	8190	11607	11607	1618028460000
16117	3NLi4i9ZD16YTcZYyX2KWk9jTkPbnGRGT4enwDvZn7T9ta3uqdDm	16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	311	1181	264	6301	12093	jxuX6PWDMjZdqe4JhKpphh97ydQEsUouVjucxowbYbs4Br9HGZ7	8193	11610	11610	1618029000000
16119	3NLe85sd1U2YQ3kAasijpJ7g9zUJpa1Y7MrjAAShTtDUDakHaQ8g	16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	171	1008	264	6301	12095	jwpTe55UXjeMkeGo9NvwibfuN6guMcjUbtRpZxpXMXgXaHggfTd	8194	11612	11612	1618029360000
16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	1397	838	264	6301	12103	jwiYfPBKGLde1VURSqEVWd4xFyfZRHzY8wx2hB1tRLAKdX2PBJf	8200	11619	11619	1618030620000
16129	3NLXxCy5oVyTpoQ6dGoGKtJdVkHhCVn3MKnK6ozXwsWRNVKYDKZk	15954	3NKwTch9NZSdhkmPybcJpjVAJgduQ7LkxgoGY2bAUHyeXQuJMR2H	1500	931	260	6301	12105	jxF5oo1JZjkHg8nB5oBzVY4G7gpLWz1ABxg5BnktwrByL5GYviG	8113	11620	11620	1618030800000
16134	3NLMcKitfmQiKkXqqANSxmzSCLPLww4cpFyiVkmQjmwuhWDHZFYx	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1402	868	264	6301	12110	jxPE5ukJ2gmbHTh7uPDUNDk8Z6a6jZ6pdRBD97jXGJGBVFYzCoc	8203	11623	11623	1618031340000
16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1631	794	264	6301	12112	jxZdsMmCeVCBS41hGkTMkrUoAKW1gkWDrs5icevRbQxGQLbQZyU	8203	11623	11623	1618031340000
16139	3NKiwwkQwpVpspWUkVihZXDUt7MC27J1Wox9b715nsjYCW1NtWTs	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1402	874	264	6301	12115	jw8k3Qv8YHuBzTQJYWxR9VNv3vtfhD9mKRJa4nssbYtSoseS2wr	8204	11625	11625	1618031700000
16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	16140	3NK5G6mV7YtUuFeC7iD7grswFfZr2GZKQhKVgKAfyxY6CpYRiEP3	1581	778	265	6301	12117	jwAQCKnXbFTXkTHuZnA9Dc2N1NRYJPLU5GhNmtogf38TtF1o46N	8205	11627	11627	1618032060000
16146	3NLjYyzCESRuuZzc6Ruc4PaSEcQnVabcR8sMxi69hH7yzhpHHnb6	16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	1593	1346	265	6301	12122	jwe3hUGqUpb8tEY1jMtAxbApvyXfaiQxfz22ezamDXNyEZWWXzD	8208	11631	11631	1618032780000
16148	3NLnL31RCAZZfXMvoADSTVnAbSGLESj2VPQY44GmkqgRhRgxMZfj	16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	1406	1393	265	6301	12124	jw9LupNFRs6V5zo1HzbrYggHTYunadYXdmqZohn4vRN6odTAA9q	8209	11632	11632	1618032960000
16060	3NL9jnq4FqmuxYdMGRfBCgx4jJSwJF4S9R4gbwVs231HTukNsehs	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1483	193	263	6301	12042	jwGHG6hP7UiSAeyuP1ggTfwbK2mL48QWHZQvPKLC9wjPd1qjPQ5	8168	11570	11570	1618021800000
16064	3NK8e1vbcYvsCvTrUsghkx2HK21KYDRR7TCZGxqvGeVCf5PrbfWv	16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	1419	814	263	6301	12045	jxq7PHLddxLBG6N6r5ZS2fK4ZTr3TopSm2bQsUwGKFV439ACgua	8169	11572	11572	1618022160000
16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	16067	3NLE4efoZ874b7GBDSFFVZNMazH4Aj6nngPYPfpYkuqsE6SKaZNY	1403	824	263	6301	12049	jwRJPWbMTjV2EVed3RwSqoha6RA9QCoqsi4xyh4ktWx3gRxPPc4	8171	11575	11575	1618022700000
16072	3NKaFWteCH3vyL96kdtsRBbctWaiwuG4bBocRgu2qsZma49NgcEt	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1651	935	263	6301	12052	jwZMWsb2Mvsk7BeMB18QahL6ta5Ldk6sVS78RgGTjd1dqGWtsN1	8172	11577	11577	1618023060000
16075	3NKsd2gVfHuBoaQxaFAZgvLUGSDs3J6abKm45UrYaYCSNZ5Nhn2T	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1474	1203	263	6301	12051	jxm5hquZUj5VjDmsD7GgSxrZCrmCzG6Ak1bpaHDtu3K1o2zi1Q1	8172	11577	11577	1618023060000
16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1516	928	263	6301	12060	jweuuwhiZU1NUgCudXgvi253PPWYbYETXs6YJuj6AFX74AcTHqm	8175	11580	11580	1618023600000
16091	3NL3N3NNpmiiwsJVkStofrU1eHXi2LWv2qxdP8Sxpa1QYr7fEE13	16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	700	840	263	6301	12069	jxgF9NBbeRUuveJJy9c6LjuzDoSQ7yiVZZhMx5ALZ2v3ffaWDrF	8178	11589	11589	1618025220000
16093	3NLELrD6KXpW1MUoa8ccY5W67WEzdmuGK7E6Zoi2NJEWMUF6tkzv	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1407	1395	263	6301	12071	jxQLmVJDUCvNKzwPWdKpcqBcdBbVHv3u4yiPUP4M7dEaZjVaKaV	8180	11592	11592	1618025760000
16098	3NLFLsricPrYrVyHqzcVbyUE7eVYXRB8xRifR9zaHHyrb645CKNm	16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	1406	1393	263	6301	12076	jxTqtmgUZp3xPuCv5JReavAT5Xjc8BHTzYJCpWiDpAaidxpJvAM	8183	11596	11596	1618026480000
16100	3NK4UEdfpvQiX6X8bJ1Zycjiy2edbv2PFNWHLEq5qt6bP8i9KDTQ	16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	152	1204	261	6301	12078	jwffFsRrrP6p2zGyV7w9zCM1FzdGguQyFN6VMa3GTTfTZ5MbnZB	8140	11596	11596	1618026480000
16103	3NL3TmkX5PSSDyBid9pCqE5nwUewJeE9XDQ1Zfioy9AT7CNX3Vw5	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000
16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	1564	1212	264	6301	12081	jwDoJDdGtkzP4mjDmnwLsByNgL55sLprwu27TmzbE5cuf2vBHkK	8186	11600	11600	1618027200000
16108	3NKFSnT12b2qieaPNNaVuQgJgUzo7cuQEkad3dUbh5mxN8aqqufZ	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1637	816	264	6301	12084	jx6RZrb8xbqgnLMREy4JhsBJhYkyoqwgBbbXh3J6v3Ex71T1w5u	8187	11601	11601	1618027380000
16113	3NLeP5MhauCV5ByraDTTMzThH4Wse8Siec3gfGS6oopVTF6tknSw	16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	1406	1393	264	6301	12089	jxLbAAgX1MawWtDGzqsiRR1V8JQbLTvJYpc9at5H5icV28gqNCu	8191	11608	11608	1618028640000
16118	3NKT4GgtFjY5oWhTpKsVD4g6fuNVNfWmhAhmGSB7WQLDM4kkDzX4	16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	1406	1393	264	6301	12094	jxjpS56YtF7bMnH11te3xK3hmPonBAwQLDKvnGAR6VEDNxFoPyn	8194	11612	11612	1618029360000
16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	16121	3NLYXpWQG8TPhN5FzSWjybZNx8A5AmKnb78HeVVHbYgsrjEZmpX3	1627	1259	264	6301	12099	jx4LXtFB9vSbjcHRrTLYQ4JbNT7iuFc2Z5orsHGM6h4BRvMZ9Jc	8197	11615	11615	1618029900000
16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	1500	931	264	6301	12106	jwtRANxrRf34AAv9xCFyY5KWENaF59QgTzeX7FiNaU1t4CXQ9WD	8201	11620	11620	1618030800000
16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	1637	816	264	6301	12109	jwSt2gTTgkCXbkf3xjRMUw973q3j1WL6JABkyAHNjbWqePGSBH4	8202	11621	11621	1618030980000
16135	3NLiJj86CBrcpksZQpT5HCUhbw45n2aGf1TqzAT7wchVd8H3bqBt	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1619	1029	264	6301	12111	jxEAgFcBtiKjGDZeuG1n9Ayr4Amp7CMdJpX5kiTs2ZoSyofqZPq	8203	11623	11623	1618031340000
16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	1552	513	265	6301	12118	jxKD8iEU8NGEvXJh3fVtnU6tZEaM9voAtKxa7htbDFyZDDt3Fjz	8206	11628	11628	1618032240000
16145	3NLfeijqYEd7hsNxod9WiA3zap1xnKEkKHak5bkuoPgYp36CqAmn	16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	1634	1331	265	6301	12121	jxkeFme9sGeTyVWYTbSrfAbYdBNC4d9h9pUxw5G78Cyj3JPiacy	8207	11629	11629	1618032420000
16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	1648	1038	265	6301	12123	jwYZEdy1PMPJYc3ajrTThgttUJwYZ6b1fTv3dgboJs4UMqdzqpn	8208	11631	11631	1618032780000
16159	3NKtkjYS84hR7rEzDvfcCAVF8mXR4y3mGhcKoGVo6wvoTL74ZVCH	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1476	1371	265	6301	12135	jwdomiAkp8PMrZfnXFJh1QKBPhe6Rks3F3FQ3E27HxkwpM5Fj45	8213	11636	11636	1618033680000
16160	3NL7EDvGT7CFrbBkAYT1BXF3NDpzfhGGaaNRLF7pxqZDfTnSTnbD	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	58	1155	265	6301	12136	jy1migP9MNRA3a3uvqrJ5FTSYLg8PdRpEfgivLn7snfBz2Y8d5S	8213	11636	11636	1618033680000
16165	3NLkt8w9HXezo55WSfgkyphC1J98SFRJhTSmc5PAQXZxVsiizJvK	16164	3NLEwJYMyKUpatAPCkdJsxNtFYczvaDUMgAxyZMo3P8dSk4ScND4	1549	1236	265	6301	12141	jwFoRXuL6q9f3dW8R3G3pinHX3J6hZrujTv55Wt7fCFzxzZvqsN	8217	11640	11640	1618034400000
16168	3NL66fy4Nc5trdZTJyxDgGeb3B2wEfu1k67YQjUCSddWLZrQPvRn	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1577	1327	265	6301	12144	jx6qaxaLG2MwVZH2hpNHmGCBi4E2JJUxgZ9oVjCpjPXy8Zxd3Sw	8219	11642	11642	1618034760000
16170	3NLVumNtRgCrDUb4a1nFoa6grFdFjoqPLeV6oDtQKCq23zkn4gL4	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jxzHDcMfW4ofrJbixzCBgyE5LTe2aiRaSbBFG3veD22ZDYaF1HV	8220	11643	11643	1618034940000
16173	3NK7fxBmZqfb5WpJqimfdgpHhahcrhyorTm4672NKxrxvBt3taDL	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1577	1201	265	6301	12147	jwh8VaEXA7K9M1735niVtkuWgHMCXS6A5Y1PGtK9ficvvL1DUQp	8220	11643	11643	1618034940000
16174	3NL3Qv38PPXYjcTunHZGp7SEepy6Vwo82mY7D5gxNJSMrWbb4h1g	16171	3NKG5sfi2rMNozvCF3M5nzJ1ZH7vFUYpdmHxc5WmJG4P4n1dL8eX	152	1330	265	6301	12148	jwZ8Fkn2TbirPRoJM4jhUWkcf47XjpFSySnnrmRXurf8Rt6UG1t	8221	11644	11644	1618035120000
16179	3NL55qE62ifApVh2HxHfRLLwpycdCR9DXQuvG1UcKxPQXvjvR14y	16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	1589	1040	265	6301	12153	jxyWwxGq29GbHVixt54Qh62suzQN7aahJYM9ixgYLjMhnBjbAmd	8224	11647	11647	1618035660000
16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	16180	3NK9pf5qeLkpfvYtkaAhDyCiL5dAjsLgvDCoCj6YVy4woLci1MZp	1601	1142	265	6301	12155	jwRawA46ZamomoGeiyZnhzJZvKuPoxtwT5KDzPDuDWVH8yfRW5S	8225	11648	11648	1618035840000
16182	3NLdbF3DwNeE1nfvA5s7x5i7exEHSnC4u3H4VTL5R8LiTfeswcG7	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jxoSA5o42RkHYxSwyvpM4SJX2oHbBuW9ef1V7szVESat4Zfuou1	8226	11651	11651	1618036380000
16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	1451	1292	264	6301	12092	jxqRo9aTNM2VZB5qrMDLAZZ2D1N7DrhECRvWZQZq9RZ7AFkQoX6	8193	11610	11610	1618029000000
16121	3NLYXpWQG8TPhN5FzSWjybZNx8A5AmKnb78HeVVHbYgsrjEZmpX3	16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	1467	1010	264	6301	12097	jwqU1Ahwy2yooXtM4RkkCQRRMLyzagsjDJhhA9F56uC4Jfge9jw	8196	11614	11614	1618029720000
16124	3NKcoSSRaFe1a8BPzDd5xBwJ9Rs7uEBnwKPCVEEoMhfCJnLsF1hD	16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	1407	1395	264	6301	12100	jwhgq1c8LaBhbo4PbTV43N6oonBxj6RsCUMLqYb8tZ8GsQWT3MR	8198	11617	11617	1618030260000
16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	16125	3NKST4JHteH8q9jgTcA1raQFXeCL9XA3xg5VB9Lv6PofVdZpikQU	1503	1277	264	6301	12102	jw7K1U1uzVnFEviLZ5zF2miwYmzeGNQrrMvGafdVK9AcUYpB9x6	8199	11618	11618	1618030440000
16131	3NKvYgLtnfoVSWzpWCw31fwoEyCCGkSWTRdS5w5jVNJDfvnqPAuo	16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	1406	1393	264	6301	12107	jwzHo2f1VcwFYyxwVyzKdYrRfwzkDUb8N17vz1F3khrtMHhX8cG	8201	11620	11620	1618030800000
16138	3NLvasWRbQu9DaBjZdVaPjHf1EdRZZoriTzDzrTj1bXsG3HoTMa3	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1407	1395	264	6301	12114	jxFFRS9ecmHR8C3jHiwVbuyTtP9FPa9MiZvMWgpm124cFPHPFyr	8204	11625	11625	1618031700000
16140	3NK5G6mV7YtUuFeC7iD7grswFfZr2GZKQhKVgKAfyxY6CpYRiEP3	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1461	1271	264	6301	12116	jwgvJmEPiyfYfJc8sJ6tWfdELbtoHjnsr5avGkGzjGS3PwU7fzD	8204	11625	11625	1618031700000
16143	3NLHJviGARhUhiiPuQN7Y7BGL17wpSPnsR53dnCKUofopoUvWMbf	16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	1471	1140	265	6301	12119	jxDe7hFaJdB9XZ5EDr1kgrZ7PASbTcmA8tJvbiYToNYSLtcsyMC	8206	11628	11628	1618032240000
16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1407	1395	265	6301	12126	jy3ArFyBKgKdf9KuDdMrVXJEEEeopTg5i9Bi5p48tJEt4VJSGxz	8210	11633	11633	1618033140000
16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	1407	1395	265	6301	12128	jwUf917wNYYpoJbnkWM41iDJmP6Bi5E5qXLKtHkM7NPy6WGwST6	8211	11634	11634	1618033320000
16154	3NLoZ1p9U9KcGLSb9SEHjepMKu4Ku3vjo9ZxFwcapUPCek5ZsVb6	16138	3NLvasWRbQu9DaBjZdVaPjHf1EdRZZoriTzDzrTj1bXsG3HoTMa3	149	917	265	6301	12130	jxA5xBo3Vpz8ARQEjUZTtoC1EztXM9iDgShBwYWAW129BM3VwAi	8205	11634	11634	1618033320000
16163	3NKt8rVzb5rEYw6Q8Qx8wkCPCTsdLrBvWd7VMtiohb9qTPhEWk1x	16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	1624	968	265	6301	12139	jwMrNSXSD7wh21w8UZiWt9WKJRqThEamCLyaNAzHttwSiqcQ7tW	8215	11638	11638	1618034040000
16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	16165	3NLkt8w9HXezo55WSfgkyphC1J98SFRJhTSmc5PAQXZxVsiizJvK	1407	1395	265	6301	12142	jw8325bR1eBMAE1TEcghgtuzS1bDr15BsRVxYNKn6jEEvEP6nvh	8218	11641	11641	1618034580000
16169	3NKmqiCMXfQH93HabCwTufyAzXMES2QtatqgMWjEg4ERWoq1UDGr	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1633	1144	265	6301	12145	jxE6qHpw5GTPQWDi2MnWswG1fS7MHnbWHoPHmRzp4Ma3ov2Y2u8	8219	11642	11642	1618034760000
16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	1445	1044	265	6301	12151	jwY872woyUQ45qGjrqHM4M34bQZvQaqZUKMxL695Z3SMHm9jVgm	8223	11646	11646	1618035480000
16183	3NKwiUUdYbzMegeVhjfzZio2YBqhRKAJhkzNPgj8ZW8HNWzpQLhU	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jxfsNqdKYvbEA9cVg5gBKrqvtD6k4bXeWBx6PEoHp1jCiPtv2UV	8226	11651	11651	1618036380000
16189	3NKiuiCjeFcHGP7Nk8JAaxCgYEYEb66RShLxfvgBdj8dVEYwabXH	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000
16191	3NKhKD5vSHt9edS6qc5otL68tf3D17N8CAdnTcgnU4E74ZP985tE	16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	1509	1074	266	6301	12161	jxKJa7xXJhDUBpUJatG1sPK1S6RWFucZQfvZykMjUxKNmhTtwce	8228	11654	11654	1618036920000
16197	3NLXNuYSEdPyLanWZEqMn3Lv79YiWZvHLcy2Y973g34mvVpo6GKp	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	311	1307	266	6301	12167	jxbHXD2U3bDS1DhnjwVDCMhtorMBx4xEwRRvL9LHzzJxo14wt7k	8233	11661	11661	1618038180000
16201	3NKCzEy5M7V7s3qBRJtAktsWtouKd6CGcvYYGvRGVV7gxikUDS4S	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1670	1282	266	6301	12171	jwpY6BWeDv2FXmxH6FeND7kBGpSLhqHPKgjf2TEHXpSJxAckXaH	8234	11662	11662	1618038360000
16218	3NK86eGTdaDbsf12GNymZKaF4WnjbX9kx19g7d1hQirZif2uuGGh	16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	1406	1393	266	6301	12186	jxncQRcp1Tu3QTXBe8xKxCcLSAHjRJdQ3RYCDwMv9Wzcgc319Lh	8242	11673	11673	1618040340000
16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	16218	3NK86eGTdaDbsf12GNymZKaF4WnjbX9kx19g7d1hQirZif2uuGGh	1650	1129	266	6301	12188	jxhuHZmSDkUMTiQMnYNmK8QL5U62o7AbvPNPeQqHSHuweLFcjnz	8243	11674	11674	1618040520000
16223	3NKLmHEvt7S8fBH9syESCVZzy1huCRqm5TT8ypRTgmKVC9sM63PH	16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	470	1309	266	6301	12190	jx3FZkSL67aHWHfpSXDodLDshLMZk5xQbjUkU9RvktkPypZsZyu	8245	11676	11676	1618040880000
16227	3NL8aJzaJYR31tgeWcMURytxbu2Aq36CPB5YWZM4CiD2KW8W4BHt	16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	1447	1345	267	6301	12194	jwpY52sVpVqQimCq8FWQApjnzN2bxSp9Ndk3UPWqSeYJFDK18kP	8248	11681	11681	1618041780000
16233	3NKkC96V9yX3zzG7wA59nTuCKfwsC3nQWdHPA9kSfMg3H8uAxooa	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1511	904	267	6301	12200	jxyBQHSrmqUWdTAD65eqSBKbgqbvPs3LKeFewJ74GXnDK3FJ6Qg	8252	11685	11685	1618042500000
16235	3NKTEBWZktuZPt1uK99KE4UzZF7cq8EDVLr7L3UCNw5KUekH7EH9	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1455	1332	265	6301	12201	jwqZVnxwHMTqAXWkKKZdM4XH33NNFFsLY7eE83frUGAa4rM98Nx	8210	11686	11686	1618042680000
16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	1547	1378	267	6301	12204	jxNhTmMHg7vVf9SLGoCQLCb5uv1akSGEHLa5kQcqc5obwUqbbzm	8254	11687	11687	1618042860000
16240	3NKeDPXLd6a3juchSozfv4357hLv4K68b44Vwp12qxTadsXwWc9P	16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	1476	1371	266	6301	12206	jxFFK4tQSeR4GzDUv9qhQENr6n4QkZyPVLPbHb9XGrL8HSdbgyB	8244	11687	11687	1618042860000
16242	3NLEhYK7SmAty4KLCifLg98sZ2RTGdtE6EVwUWBqbMvTuwhGpJWb	16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	1631	794	267	6301	12208	jxyedaK8kXMsMJLZ2G7pUSfSsigvajhQoDS6MXoNSGFEVf2ZazG	8255	11688	11688	1618043040000
16244	3NKvffaKr6bKpQqSWZ8vjujGXgcfjxJDLh7pjDxNEBSpHxyXJzSs	16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	149	917	267	6301	12210	jxxpBqhf3SxB65sD8YnkZPpuX4PKiA8tkT5WWT3zDB1zfeR6V8N	8257	11690	11690	1618043400000
16249	3NKH1m5f3it3uMD1aKEGUKcXGf4ceDtKmRPdehFWLTFVom1udqw6	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1541	1298	267	6301	12215	jxCzAGxmxCnTnc4uLvrnsyMNAK6hQpU3LFBwEneFdQhK9wtHESp	8258	11691	11691	1618043580000
16253	3NLCuyGd83Exxgjpd8uSML76yzdyZo7tidGV2KL9UowPFYGmxd4r	16252	3NKdNfVkQEibT9j8o2ndXgcAfZwyMqLNcSFEJ1oTpa48DG5WExGR	1483	560	267	6301	12218	jwWxehBDgpWDpPvx9VDZxj8jD2sx5hb3c1gt7cCnCwuLwLP5Vbm	8260	11693	11693	1618043940000
16122	3NLH9iapwhfxmXx3p2Uf7TPVMaghALHeWoyeq249Agt5uTVikX8Z	16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	1547	1378	264	6301	12098	jwr5WKZHVG4oKY5pHDqTud6kRdSXi2n4AEXTWrzLrTt7Y3GZy7s	8196	11614	11614	1618029720000
16125	3NKST4JHteH8q9jgTcA1raQFXeCL9XA3xg5VB9Lv6PofVdZpikQU	16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	1631	794	264	6301	12101	jxihQ1s9TvCXxMjE7t43mWpzSazoz2KhkxHRgQwfRF2NTqot2hp	8198	11617	11617	1618030260000
16128	3NLdAokqQ6oAQJmu8BqHxc7edDrU7gsRo3zA9xT82cysEawTxCLV	16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	1648	1284	264	6301	12104	jxJHxZz3VyCg2TkpRZ3Fasg4M5vYuBsQaiS9BH8Fb6FtmeWd8pT	8200	11619	11619	1618030620000
16132	3NKG2PGqArv827XYjQqNviFt3E6mVng8p9zsA6q4YEonGnw5EbzS	16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	576	1355	264	6301	12108	jxUNVwAPoPPnbfyxFnKmP1p2ckMceeQkDwV2RUmFndqDsYfSMWi	8202	11621	11621	1618030980000
16137	3NLv4F7h6Vu24fhaGUCZjihYV4bMYcLdis5havbvidSgtXsBePCJ	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1553	776	264	6301	12113	jxZ6budv3wKgjNiyj9U1PJZTheQcEswtcEkd5v7zzX6gar4HUdX	8203	11625	11625	1618031700000
16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	1406	1393	265	6301	12120	jwSZjfHaCTK2ioHYTf3wPudqtw9Jozfgq5Wut9shtSQDUa3Lr5m	8207	11629	11629	1618032420000
16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	1460	475	265	6301	12125	jwDW9Zy8TMpY1S5oB9aVgvSKThSpK36jemnfauEiKPiRDPvZ8sS	8209	11632	11632	1618032960000
16156	3NL2EnSK5QnkBQqTsiUx2ZUzk26E6MBwGWL3ZmXjWydw8jxwS6GJ	16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	1637	816	265	6301	12132	jxEjuBr5XTZP2Nt1owyZUtj1JvYSxR5vEB9rJnkTCnMouRieZjt	8212	11635	11635	1618033500000
16158	3NLDZq8FjWMCn8cDjBune96iHmZ4BGm4b6iyB1SNAjASsMZoVjiq	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1407	1395	265	6301	12134	jx9qHXMyw4EiHmFirtny2kUgmm2FSXbbaSKMnRicf8cbjnE3EZc	8213	11636	11636	1618033680000
16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	16161	3NKnE5qUbFHQjGZkA6NxCFMHvjrTRyP5LUzS8bXqdkyVXYMgZ6w3	1407	1395	265	6301	12138	jwThv3r7ZHB1RvhPhvkZN77Z9siDrJtzvMki6K9rQ25TrynTRWH	8214	11637	11637	1618033860000
16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1476	1245	265	6301	12143	jwNjEPYUZLxNEgrCfn7uaydKrmDTLSVktugMSgdd4VVQxKocsM8	8219	11642	11642	1618034760000
16172	3NLkANLCpiVuwcf8GnLrzksAPEmSEBihbVmhwY9W62oeDW8L9g4X	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jxya8nqoNEttRaJjLEFTjCNwxKn158Fz27WmDKZ71Cb1kmkPgPE	8220	11643	11643	1618034940000
16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	16174	3NL3Qv38PPXYjcTunHZGp7SEepy6Vwo82mY7D5gxNJSMrWbb4h1g	1581	778	265	6301	12150	jxv6FqpMaRDwYhyHvS7N9T37HJ6p59CFM6GWxT2Bu3H2fDKE1wZ	8222	11645	11645	1618035300000
16186	3NKmic7WCGSC4sNn3UfNMFSwavKv6Wvgj7TKJAPBGYPj2bUeR19V	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	43	1184	265	6301	12158	jxYFo5LaJxaH1zZJTvKZC6jtPZQAzhTTZs67rCG8owuV5ojDRrB	8226	11651	11651	1618036380000
16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000
16190	3NLBpMc4YGSMgbh2zeb1saGgn7FmVeehZSxKmKskFoB7NmTcF2um	16178	3NK9xg99C772UHSnUB26J68hVEcMVLNSLwAWhTULs8Bt5McW6JRa	1509	1074	265	6301	12160	jwAtLjP5wBELESGrtmsf2bXsRNj3U7HM7rPmyZTpAjrMF8LvcAH	8224	11654	11654	1618036920000
16193	3NL2N9bE35FA8Ky7CsbEKHh6LzySgDgW8wWNqKTmcJLL2bYrzZ9t	16192	3NL1GTeCRA6WbcRVzgQWcTgR6V4xfon3S7fcZHX7UmZTmcEmitPD	1405	867	266	6301	12163	jw7CxL17Dkmo7xnSA8uSMi7wgiG2kWV7SL3tTFkosP9H1ZJeSAt	8230	11657	11657	1618037460000
16200	3NL5vzahqv6JkAKZqXkiMLqmHBWp7hdwyLmLSP3rjNpdKoY7WJ8j	16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	311	1307	266	6301	12170	jxafrf8phKB2ZZ29jVXPYfoD1mu7dwuUSoxWDqTyiiJyTXSBkua	8233	11661	11661	1618038180000
16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1596	1237	266	6301	12172	jxYffQwGngtrxk2cU7BruEPsBimogYqbU2QZcitg6QJLfd5JXwL	8234	11662	11662	1618038360000
16205	3NKHsnHXwptECrc2b4L2MVHt8f8Fb99FG177kqfjNnLW5kit5gdU	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1407	1395	266	6301	12175	jwt63mSvmZTCGqU9698ax6j2GRUXUAz7cvsGsTBJoi293bLrxAZ	8235	11663	11663	1618038540000
16209	3NKiGW8Cm3K7VNKTwZXydz3sn5LJRLGoW9jGZ84Y5FkwSpGMWk78	16208	3NLK7shaFP42Yj1AujKVEYPmz7sjxGCkpVWG33KC737bUAUXwhLZ	1444	1381	266	6301	12178	jwGUqBKFy1PYHJmQt1wgATzwfFGwa7vauCtcaeKiKH8Rcnhweaa	8237	11665	11665	1618038900000
16212	3NL5H8sZ1hjYd9Z6UhXE4WpagCUyFyHHL9jdM8chaoNqkFSQoap1	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	1406	1393	266	6301	12181	jxpyL5GDvdQxzswjs8Y3fpe6NSTc96gdPHJKFD5VibxtL5D7PC2	8239	11669	11669	1618039620000
16214	3NLXrhfpyWW3SoKV3iaConM9Yk6XpLq8qq3bs2eXm81CyCBgkpeo	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	470	1309	266	6301	12182	jwA4qn4ZpafCKurKjMExAA1SnfT942E2cMD6GDZzQAkA4Yy4Bcx	8239	11669	11669	1618039620000
16217	3NKejUzcGQ6zqMRfdAXLFhnMFjdX3eCV4rW2MEn1f3NToAxwNGjp	16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	358	358	266	6301	12185	jxF9sDA259rKTZBr755LpsPjyVLqDWEmhX9ppL5RLiNFH1o4Chw	8241	11672	11672	1618040160000
16219	3NKZjRHDXY7wRNMBX5L32MHsGGubpDvptstDE72EJKQJxx6xUrUN	16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	1637	815	266	6301	12187	jxLYXUb5gZXursVdP89AofSHVd8iSg8i7SXAU1aGyi57N83fizC	8242	11673	11673	1618040340000
16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	16222	3NLjNG59BeZzfyeBcYSzid38Jd2RUUKfiwJq7BfxVq13jjA5Ea6n	1650	1249	266	6301	12191	jxCifevP4PU9R6TeJE6uAx8WmDjAWUrZ5bquCnSXaaVcN4AbCzn	8246	11678	11678	1618041240000
16229	3NK4TwPypcbPifkb1p1E6yi8CwgqL7xA8xJNUuDnWc1ADkyDritS	16226	3NKB2qegWUXHzw3VfCahe4go3Br2NyEx9iGLfEbFzSRjYMsHoapC	1607	242	267	6301	12196	jwrTMC6fcUAtkfLfumEzv57h7xuBsxgXGq1L27YTWXjppzwDfGe	8249	11682	11682	1618041960000
16232	3NKcynFn1XwihayPcDnK42oKTPXC7uJNtep9J6mfDgkWg2fszjhC	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1600	1372	267	6301	12199	jxLC8sv2fE1hA9mASbGpyc7hiMp1puMxdHKuna4ktmtR8oeSgvs	8252	11685	11685	1618042500000
16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	16233	3NKkC96V9yX3zzG7wA59nTuCKfwsC3nQWdHPA9kSfMg3H8uAxooa	1426	1364	267	6301	12202	jxH4tgFCgdDdCgo2F7HBTVv5cgHg4ddUzyxXiERvjU8q2Nvhtxb	8253	11686	11686	1618042680000
16239	3NLvoWfsb3FfLe5S5dckf5khPEosCzCeLYUBdnP9vjByrM5on5TT	16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	1547	1378	266	6301	12205	jwiDUQmEEcNu1fFcju8oRaLrKfzqZTQQEWq5xVoxXJb68HHAagZ	8228	11687	11687	1618042860000
16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	16241	3NKVJGw39pLaRzrWwLA73uupdxvz1RWMav11BVeUxK6CunZkAmn4	1406	1393	267	6301	12209	jweu2hEtSw4Rp9S18BvfBZxea5XMNbKU6ugJSQfut4wWV5BmoQf	8256	11689	11689	1618043220000
16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	1581	778	267	6301	12211	jwNeMDUKouFRnhPKDYmz3uu8cCE7ADTr6F8GE3mqMM2R3LUwyN9	8257	11690	11690	1618043400000
16151	3NKGGehkjNgUztVcaKoB1XdG2PqwPBhtcoHpbm2dVWmFAsdsLriH	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1637	816	265	6301	12127	jwXc7jxDW1UZxHfY1iRpZmgxrKHuUBSKUwpvy3MogUcq2LBdrb5	8210	11633	11633	1618033140000
16153	3NKJHfSv5HkNHn4cr14i3mtkJY8ej7HSpD2S9t7XsGSWRfCogNUg	16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	1476	1371	265	6301	12129	jwJ47qkmtbCWuLvkX68jnKi4p1ZyXb4fkKg3RjYqkoosCg6Mw5V	8211	11634	11634	1618033320000
16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	1439	1033	265	6301	12131	jxDDRLD3kSH3bWpFJNvSSi2wfaK6AW5W1NjYxi46fPK8y5bgegX	8212	11635	11635	1618033500000
16157	3NL7PnpU8cjTebaWh5XRczQw87fu5KMKKhPknbQmCYKqKmRt8s9n	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1672	1285	265	6301	12133	jwxtXKbdeaacfWoaQrcPubGvjTWhpiPJc3sKYysn6cUGhdo3KMT	8213	11636	11636	1618033680000
16161	3NKnE5qUbFHQjGZkA6NxCFMHvjrTRyP5LUzS8bXqdkyVXYMgZ6w3	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1405	867	265	6301	12137	jxqcTfS6r9xYLdvCB55EAboC5ZqeVhyKC35LjEE97Y5q16TEe2w	8213	11636	11636	1618033680000
16164	3NLEwJYMyKUpatAPCkdJsxNtFYczvaDUMgAxyZMo3P8dSk4ScND4	16163	3NKt8rVzb5rEYw6Q8Qx8wkCPCTsdLrBvWd7VMtiohb9qTPhEWk1x	1553	776	265	6301	12140	jxnES2WarhxSoKda4xNXciNvMK8iRoTow5kugEnBUiyCaPMMDhP	8216	11639	11639	1618034220000
16171	3NKG5sfi2rMNozvCF3M5nzJ1ZH7vFUYpdmHxc5WmJG4P4n1dL8eX	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jwap8z689ZaHjBePdj892oE9ZMyB3jf44JEddim56HbawwTp6oS	8220	11643	11643	1618034940000
16175	3NKrVAhybhRW6omfEDnmwwPmAvhYZzMALmWKyjPAyDeWAX6vLXcd	16100	3NK4UEdfpvQiX6X8bJ1Zycjiy2edbv2PFNWHLEq5qt6bP8i9KDTQ	152	1330	262	6301	12149	jxyVTe4K42Eq3e7sFCeF1MTjBSSsyBmy5ZXoUtdTNm1rLDQdwy6	8141	11644	11644	1618035120000
16178	3NK9xg99C772UHSnUB26J68hVEcMVLNSLwAWhTULs8Bt5McW6JRa	16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	1581	778	265	6301	12152	jxJSCnGQVary5KC2VYptQjr3hvWxJufTAucWHBKbVKkTUeREhSi	8223	11646	11646	1618035480000
16180	3NK9pf5qeLkpfvYtkaAhDyCiL5dAjsLgvDCoCj6YVy4woLci1MZp	16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	1419	814	265	6301	12154	jxyGKohw2E72WCHd27xdBASbpopjLMP9kUtEdDDZZZTm1HxFfTx	8224	11647	11647	1618035660000
16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1598	543	265	6301	12157	jxcpqva1oEmD4StXX3zeMhM3ZFLiLVmK2opccnqqyXe5s5gCb9e	8226	11651	11651	1618036380000
16187	3NKVYUmenvnSAtpXwBTNbJhNNdpC168FfLFgiDWPcrfps883HH52	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000
16192	3NL1GTeCRA6WbcRVzgQWcTgR6V4xfon3S7fcZHX7UmZTmcEmitPD	16191	3NKhKD5vSHt9edS6qc5otL68tf3D17N8CAdnTcgnU4E74ZP985tE	1406	1393	266	6301	12162	jxHGZEUhX2vxNvdnpFHCassH1M3ucqXsfRxHonwFN3cutV1ptjw	8229	11656	11656	1618037280000
16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	1516	1168	266	6301	12165	jwSfWuXfCik7Vzzu1Gi8GVbJiJMJyyFyPNrFgeLNsRX1QEUp1DR	8232	11660	11660	1618038000000
16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	1657	1218	266	6301	12168	jxfWMwxa3er4PqeQVLhkEbovkJP1iuwDJsqSoenKRvkp5NMeLVC	8233	11661	11661	1618038180000
16204	3NLuAg8Nr7i9fUjGkKXWfoiKkEwUdh7G75EZpKPsMMdcKtJ5jHus	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1490	908	266	6301	12174	jwVpXuJsXuPGcLqccAY6ite7hRcVLFuvJUNUqSKHPPRXMzadS96	8235	11663	11663	1618038540000
16207	3NKZG3GNF1stFnLAduKBSatCUS3XvzmAg6k1fjzkiRgFaPSq65ws	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1489	1254	266	6301	12176	jxXwwh1GwWaQDsYKWnCL7tZGH6h3aXDpVvHzkb5HqnBQfDbE2qU	8235	11663	11663	1618038540000
16208	3NLK7shaFP42Yj1AujKVEYPmz7sjxGCkpVWG33KC737bUAUXwhLZ	16204	3NLuAg8Nr7i9fUjGkKXWfoiKkEwUdh7G75EZpKPsMMdcKtJ5jHus	684	1106	266	6301	12177	jwDfvTGwpMFJH1D791zcCnDmvU5wPDN1j7eSNvMNGrsgfCbEkvD	8236	11664	11664	1618038720000
16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	16209	3NKiGW8Cm3K7VNKTwZXydz3sn5LJRLGoW9jGZ84Y5FkwSpGMWk78	1509	1320	266	6301	12180	jxvUAKyb5tMTwJ1C2YSRGR9AJ11GpWH7dgHct4edykEQvoUf7j9	8238	11667	11667	1618039260000
16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	1529	1190	266	6301	12184	jweaQuJUbwYfKcWa9fv27t3ZARvZHEBzLm3uVKNy92zM16rqDxR	8241	11672	11672	1618040160000
16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	1581	778	266	6301	12189	jwQMmW5r65uKvwAaEAXYsTpkyxsK2GevfYoq8McapArjmK9ECMt	8244	11675	11675	1618040700000
16228	3NKyEeMfUmng7wBdXjU5ZWojfZyTRnZviwpiRjFKRhiqeYAmAvGS	16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	1447	1345	267	6301	12195	jwmcmQDo5W9UTAuFkV65Pkys7W6VV7f1ntM9FHxWyLPchjaA5h8	8247	11681	11681	1618041780000
16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	16230	3NKKwZ2TzNtHKXx8gjzchsWCot2qPX87HQW2Mbk8D5BfeSzFB5Hp	1407	1395	267	6301	12198	jwVKvvJ41FfL2WS4VP3F7JThVDGhz7fz94VBwyPFvgr1sr6yGQj	8251	11684	11684	1618042320000
16234	3NKiudPuufxUWPu4oSYjQ8FvLJjFfWjgBEKLDoPGbvWfRyoPzjn4	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1511	904	267	6301	12200	jwFQyKJToZkxmaDpbrBPcx9omiESiRjnVRMT9iM4btbE8YxFF58	8252	11685	11685	1618042500000
16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1536	1187	267	6301	12213	jxwcAL1qgYns87mAPEqSe2eGBXNUva74v7xBgqJPtSesoMFVXcq	8258	11691	11691	1618043580000
16250	3NLZwinVuUTtR1eeC24GbrwTcXZ5WoqhaTxc5gGz7aAhp7JKY99V	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	484	1073	267	6301	12216	jxJn1wNBkfeyNiYeB58Lm9NYy8Apmbbz6oHWnykVz3ncu4ZWHAp	8258	11691	11691	1618043580000
16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	16255	3NLJbiVCNnHjRYhEQZTSPFueu3H6Qazy9N7uK9VoBd875GxQtpCA	1403	824	267	6301	12225	jw9KRRHFYnyiGBHASaxEatbwjcrjtTgaiAza31ZdiCCrRQg538e	8263	11696	11696	1618044480000
16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	16262	3NLybzf6ExjtKWYndKMhsTF3ZafmwTXpzbWot16rCgiPonnMNXfr	1518	833	267	6301	12227	jwrx1NXESdUzH3TaCFBLbuh5AMxwSPtXHGRXBjhZoQBp2a52znN	8265	11700	11700	1618045200000
16268	3NKbAgfr45fscgoSFD5YgVcond7FsymKzseX7D1YLfWjwxxeovcu	16267	3NKQLXb3HQDVsjwx9WTRTER96MfVVZh3WAo5ijGtEDBR1QoKyATd	1407	1395	268	6301	12232	jxn6neWNFy3yLbqG7hMmxzD73PioVZ3Zg6FaNybvpcAZY7xRKSB	8268	11703	11703	1618045740000
16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jwwYUQXiuDKYKM7KsFcv5P9uUfS3Ha89ZcsSNJkWWc3BsghKTWy	8274	11713	11713	1618047540000
16281	3NLhqmVatzzAoGbCQFCUz6rFUywjyK38Zyr8AjfxHBVhAHpECTND	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	311	1181	268	6301	12243	jwiu5SxuVv5oFbp5WgRTdZL43SucVhNyFGBCy6EuB4GeK1nPYXr	8275	11714	11714	1618047720000
16284	3NLvoXpZSsL6CmJa4eTAJRghdUd8RhEcYhehJuqiVSiCgd9b4XXT	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1596	1363	268	6301	12245	jwoN4Kpr2QfvkZwHtLnCfHV8MpKSnazLsLr4vpancSNeDvnkdvi	8275	11714	11714	1618047720000
16184	3NKkdqr4brRfLvWvi8gmkwTqzJj5MNJ1dngtU3hKuTimkqvgHnho	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jwZ2AxAcywwUNwfWgTougfAY2Mn5FGJXaeqdfuMpnGWgw4XnT5V	8226	11651	11651	1618036380000
16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	16193	3NL2N9bE35FA8Ky7CsbEKHh6LzySgDgW8wWNqKTmcJLL2bYrzZ9t	1560	925	266	6301	12164	jwmeT92FgVMppxeSqS8ceRhfZw7XUyZ1KRSG9tSxekpSc4a8FQe	8231	11659	11659	1618037820000
16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	1403	824	266	6301	12166	jwvFviysxeCiqBR4B5MJYc8kxpXoHd97Efii58tdUX78gttqQUa	8232	11660	11660	1618038000000
16199	3NL8u1rA92ePDdztuY13vA3k7w1eL3mr1XPCXMd88p5TSZj1F8z4	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	1549	996	266	6301	12169	jxNe3uEw5Y8YbjT56LkgdWqxpNxPQfh5EZeacBdHcGUEVCT1UMX	8233	11661	11661	1618038180000
16203	3NLDgV54Qfoca8CytpG4RPn9ZEaJBM3Aj76Au7MEnSTrsMtBrcvt	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1631	793	266	6301	12173	jxMWENnLeCqFU2xNA7grzHEYY6UAFuMxFpouo9vYNPZjFCT2sue	8234	11662	11662	1618038360000
16206	3NLcAmVYyUq2mC3udeBiHpayHDj49cdbkMXrGPQvymGHDXtjGsF8	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1489	1254	266	6301	12176	jwwchjNkZYMBviQk1a6hni3pL6WY485r521ceceqBQMCYeqAjW8	8235	11663	11663	1618038540000
16210	3NLHzj9o6LNqyVVoHhNXcm2ezPtEnXnnpmTHvk52MENedEbnyffx	16190	3NLBpMc4YGSMgbh2zeb1saGgn7FmVeehZSxKmKskFoB7NmTcF2um	1509	1320	265	6301	12179	jwjLpK6mY2Fj9vCf3QGD2a9iC1nFpssaUvyFk63mWKGbjs629oT	8225	11667	11667	1618039260000
16213	3NKgqdKpb4ZgR8p9sGfmk8yu6BG19Zzztt2cExeFvcsdgcA77MkX	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	470	1309	266	6301	12182	jxYj4M5Pbm3FPKwjgMw4jYozJS4FzsvpN61BCJ7w5GKCidyYatX	8239	11669	11669	1618039620000
16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	16213	3NKgqdKpb4ZgR8p9sGfmk8yu6BG19Zzztt2cExeFvcsdgcA77MkX	633	1018	266	6301	12183	jxvbWV1zzZuFQK3KzEYrk28FsJYoppq7tNAWTMBCnuBYFbSdRV3	8240	11671	11671	1618039980000
16222	3NLjNG59BeZzfyeBcYSzid38Jd2RUUKfiwJq7BfxVq13jjA5Ea6n	16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	470	1309	266	6301	12190	jxxA65SLhLGu32ko2ZhMBDpsk2cqBaiiWLyvFKiYGrgNdR522kp	8245	11676	11676	1618040880000
16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	1616	116	267	6301	12192	jxQ6mDtG8H8TaHcCp4B3489toPk6XYZNctTFmZnXCCvpU1Rbzug	8247	11679	11679	1618041420000
16226	3NKB2qegWUXHzw3VfCahe4go3Br2NyEx9iGLfEbFzSRjYMsHoapC	16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	1402	866	267	6301	12193	jx2SUZo1R1ARY1Uijbc3knacibNuxhYiPab8GDorShqeSrWrKTn	8248	11681	11681	1618041780000
16230	3NKKwZ2TzNtHKXx8gjzchsWCot2qPX87HQW2Mbk8D5BfeSzFB5Hp	16229	3NK4TwPypcbPifkb1p1E6yi8CwgqL7xA8xJNUuDnWc1ADkyDritS	1643	1299	267	6301	12197	jwG89b7eAGHZyfabv5Q3fwsaYwEtjradLQtjbpsMZDEf2z1HBLq	8250	11683	11683	1618042140000
16237	3NLKTGNUAtsuzu2PYCtQw23mLcy5QLhC1Heu3gQYTrFWsWU2YY4t	16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	1476	1371	267	6301	12203	jwhB3FjWY8SMpJeTCmeBcQ72DZV8xyoQjV34YuMYAbBH5VZ5F5e	8254	11687	11687	1618042860000
16241	3NKVJGw39pLaRzrWwLA73uupdxvz1RWMav11BVeUxK6CunZkAmn4	16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	1585	1366	267	6301	12207	jwop7WNaZ8mqpPo5VNSvyuevoCj2PeWfr6LYNGjC6U5a89hKQRT	8255	11688	11688	1618043040000
16246	3NKizkKUTtrfK62rgUz2KeDqztK8j63CYf5rbd75fktA8jgvB6iy	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1406	1393	267	6301	12212	jw7uYE9itY4782P7j1yJeMD8MVwakDBoUsWQb5Lka5r3H84UXKf	8258	11691	11691	1618043580000
16252	3NKdNfVkQEibT9j8o2ndXgcAfZwyMqLNcSFEJ1oTpa48DG5WExGR	16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	1559	1353	267	6301	12217	jxLj18eq3BDTq1kzg3aKWnxn8q5wybccXS85N3VSkATjruzFuV3	8259	11692	11692	1618043760000
16255	3NLJbiVCNnHjRYhEQZTSPFueu3H6Qazy9N7uK9VoBd875GxQtpCA	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	563	1359	267	6301	12220	jxF57XBVf8SBcYe9DaHtQgtC4BoJsXdAyuucgradNxkVim9mjNB	8262	11695	11695	1618044300000
16259	3NLMQqbTj42XWRocQLozjmsb8SRdQV879X9djWM9KvqYnV1yvDWo	16257	3NL6fxPiF2zUDUY6tqnkuNdz5TZdttEEwzCfMpmH9qjJyeVX4bpk	1407	1395	267	6301	12224	jxokGHVcY9vzAiLYwgBDAhQYzHeRuc9ADfKkwFMaJXzneoMrtAA	8263	11696	11696	1618044480000
16269	3NKHdL3CuswnwG3YhkGtq4shgJCXV7m7KxsWCSZyfm2tAWq7BCMT	16268	3NKbAgfr45fscgoSFD5YgVcond7FsymKzseX7D1YLfWjwxxeovcu	1637	816	268	6301	12233	jwkeAyL5xctBi5g83NEEFsMjByzhxJwVwXqS8kBPVCatHhbfyzs	8269	11704	11704	1618045920000
16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	16269	3NKHdL3CuswnwG3YhkGtq4shgJCXV7m7KxsWCSZyfm2tAWq7BCMT	1406	1393	268	6301	12234	jxad4RypFcAMWrLJmn9vdWDXoicdtKpSQCgvF44TdauKKw2eSDg	8270	11708	11708	1618046640000
16273	3NLcCDvGDKYKzX2ZJikdpdXqwen2hmfhVwdP6NT72no86iCXbBgD	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	1477	984	268	6301	12237	jxKMWyxgTsmXTrHbYRTe2WKBhAFruyCEuxWiKC7smG6Ri8F5MFv	8271	11710	11710	1618047000000
16276	3NKQwKHViepjL1xryEeqN3KwMDNkyMYMMK6bpWLyujGxtmaFYjPF	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1422	1337	268	6301	12240	jwuA7Eyw877BWbgUUxeksGVjRb2hipiGxeUuQFt3d4f3orxFeyG	8274	11713	11713	1618047540000
16279	3NKsAsFJVuYA1ELxLVstx9DQZBfKGgHajQQze1hsW2iA8NpZu7vS	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1403	823	268	6301	12242	jxwWqvz1jgehrVm82zyoWPcdqr8y8cawL8wLQ3okk9ok617bn2p	8274	11713	11713	1618047540000
16283	3NL9DzZDGrZ78QLo85ASZeg5EFcetiy7qrw9oXLf13VYwxPkVfVC	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	311	1181	268	6301	12243	jwqXVbMtB66Kh2jaAzNPkstZ8UfRQafnCFAtxYzqm6sH9s31YtX	8275	11714	11714	1618047720000
16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1476	1125	268	6301	12246	jxEPXSwYp7oNcdiLWD5hrZ3GrwCX95oowK6bWCAU2fgp2QM7JmJ	8275	11714	11714	1618047720000
16293	3NLZ12QKAjUX3aJqL2r5Uf6W1BMXyuNw9Rkg7eUozqybtxx5XLpP	16258	3NKknitVeqWXbEA43h9CQwkTPn2z7eE1HWsMqKft8eVGEEHmppt5	563	563	263	6301	12252	jwUxC4u4E7Wbu9nfXvChofZYxY9yLqzeg5ggPHkBbMVeVJKGdHE	8160	11717	11717	1618048260000
16298	3NLM9dNdmwE9kXM1HaZp8bQ3GguGZomjUbMfAV9qM46iSiuv2TNy	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1447	1219	268	6301	12257	jxW4oYaJ2Ff5YY6xVGRccgUiG4ZzTsdtxHiHx46YQD7uu7BK3sP	8282	11722	11722	1618049160000
16300	3NKvG7xiUan6LwDyrTnFRJAVCdYADHFANrRfNYunjnFJzx1RPeS4	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1581	778	268	6301	12259	jxJUuDtLGb63T1Eb755ZWZaLSorLeYo1Wd4ezLSUM7aCoEXawso	8282	11722	11722	1618049160000
16303	3NLQPgWxzYjF73dG78FoJ5AaYZvfLWSLfQaNh82oBATbJ9sQAiA6	16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	1623	839	268	6301	12262	jwdkKhx23R2NqEri6sBufN45FAP5N925xb4PRefxQpHsujSLCkh	8284	11724	11724	1618049520000
16305	3NKn7KXAEADiYq3KDKXK6riYTLK4yFKjUp7Uog6kLwa5QYVj2UBA	16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	1613	983	268	6301	12264	jxDh7tkVdxCEsyMQwvaFR3f8Ht9ehjypvMTya7iYpSbyaeb9Vsn	8285	11725	11725	1618049700000
16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	16305	3NKn7KXAEADiYq3KDKXK6riYTLK4yFKjUp7Uog6kLwa5QYVj2UBA	1407	1395	268	6301	12266	jwgTo6HVkkNJWRpSUff3W9x28xU8VRmzbGGRMXBCFHWx9Ms6Fk4	8286	11726	11726	1618049880000
16248	3NKHkEmNq7t46oZw7wNFmsFDRzp2A82fTQppDbU2LkFkNLFHjaq2	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1483	1030	267	6301	12214	jwccxLduPkpxVwJFFjwSyM39hD1wStW7XNQZmxbcJ45KeWkH58N	8258	11691	11691	1618043580000
16251	3NLdwYGRNHpC8yiZe7XuZAxLFPV7tJDGKCsj3QtzQmVGUFC4DbT5	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1541	1298	267	6301	12215	jwXQZ9XPdweTfDZvrMvdjs7N8Egue7aEVywiP3LChERriK99qMc	8258	11691	11691	1618043580000
16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	16253	3NLCuyGd83Exxgjpd8uSML76yzdyZo7tidGV2KL9UowPFYGmxd4r	1437	155	267	6301	12219	jxhPdYX1c3a3vPzy9QpDJrGQd69fJXJ4WydwzFJRkMEa4s7NXjw	8261	11694	11694	1618044120000
16257	3NL6fxPiF2zUDUY6tqnkuNdz5TZdttEEwzCfMpmH9qjJyeVX4bpk	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	606	1295	267	6301	12222	jx6A9MysXuRqZKABU7EEAAMDMFXXigHb8y2cEmPWKHmoaPfJaaF	8262	11695	11695	1618044300000
16261	3NKpTLGarpB3b7ji3NRSsJT4qKvXCi3HaX7Vyb9NLoomKxQMe1rv	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1547	1252	267	6301	12226	jx1wUjpwJY6JHrYDuDnL8qrTJAo7GuwZmjXdV1DqHxJ9vdFTsLC	8264	11698	11698	1618044840000
16264	3NKwNso4MtB7LByHCdfKZHff8Vd8X8HgcNcapMCbJroEG4zRgztk	16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	1547	1252	267	6301	12228	jxepd2cta5VPYtMuHzGiegJSoipwYK3Qnx4ugwhXe2BPtsx7PRG	8266	11701	11701	1618045380000
16266	3NKL4paL53Yp47dPk8NUcEa2Wkjtp4PkT542zMfVJt4NGCqs3DtR	16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	298	1182	267	6301	12230	jxTuBr97eUgAbGsgk8grmWCMUtwyUTjck1Nw4Xon7F1WwjBqYyE	8267	11702	11702	1618045560000
16272	3NKzwHkEyByQYRVQsxd3qk8M4zpGcuZMGyNN2vc1FT61biigB9mS	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	1519	859	268	6301	12236	jxaMpoTEUW5NKqAD5ePFMHEw7CXoBurkvTajbECdJtKzqzSELjc	8271	11710	11710	1618047000000
16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	16274	3NKxJeRkB1hoL3rdBucP9CXduTBVci9PXA9hy1dxy1NWpr4fA8s7	1673	1368	268	6301	12239	jwNbsqTEYSLz64yWk61J4eBDSvwbYDreUT31Rf5BtXo1JHhD84S	8273	11712	11712	1618047360000
16278	3NKe1kDtdrbEbSsrmaZCxdMWLifbc5tAphM8J4po27MSsaCk4Jzr	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jxT1HuTkzqoWoqZGAzA3Ng945gjpGV4qWDkA9QxobGpJ2euoiVE	8274	11713	11713	1618047540000
16282	3NLEJhST6PUcr3pV31a2p37Q2emyRjevzES6SmefgTNhmtwyGBzY	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1560	1291	268	6301	12244	jx8bZaWqbWBUTjtbsnXbEy752UK8ddmDFaP2kD72i6Zck66s1YE	8275	11714	11714	1618047720000
16295	3NLWfN7hD8xpTL4SkGRsWCyThLuRseYJFREZq1VmQFQaAyGfPezF	16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	1622	1356	268	6301	12254	jwMmijUsU5vUW6siDxK1C7AybDqzjb1hWGskUG52rX4nsYYpYdK	8280	11720	11720	1618048800000
16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	1403	824	268	6301	12261	jxg1QnN7Yz2bdJsUjzZnzBdTdJ7rqa8RkKtzByHU9ufkv1RB83r	8284	11724	11724	1618049520000
16312	3NK4xSVTtdVeFXQ8WwhHuPNA5kUw98mkNkvcSJrWsZhmWMMHni58	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	563	1359	268	6301	12271	jxscuHSNg3z6Q9tYjSCrG7tpRwHeN3nkWebHfLGdUEPpzV9XnM4	8287	11728	11728	1618050240000
16321	3NLY1dC376kKPeLQKgqkTvYBA4hfM71e1YMpjrkNMZEzmBjLk1r5	16320	3NKEFTA6BGYt84fedi1n8SRuziS6ioHsVyDV8DaviqY6TCnvvRKu	1460	573	269	6301	12279	jxgCUy8pc1sYfQtobXCAGGQFZzjXP8sgwGsFKEBVJxqc6i8ge8x	8293	11735	11735	1618051500000
16326	3NKChFeEimnjCUgowPKai1irr8WPdLEGo7jR66bo9hHUW61iS4Vh	16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	484	1193	269	6301	12284	jwaW8MJKDCzWVd8peHhfFd5H91etKoDSD23c3RDu3rAnC9W52CS	8298	11740	11740	1618052400000
16333	3NKg4mFaWaokVjLFNDBAG57sXZgD8Ttw4NxaZ5GY7ofqWpYXtRai	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	1406	1393	269	6301	12291	jxdrr4JSiQSUiUwbAaGns9RnnFUzK5X7ttGVwddJZcQzPt5YEeb	8302	11750	11750	1618054200000
16335	3NL7BWhmoES8Jw9FvDQxjjHVoziP9vkf5afYJB7uUHFS7bzZho7T	16334	3NLv6V6HvCHPUqhzgYMVF89kgNuEtMHJQ4E3WJySitxdNp2d6EFe	1406	1393	269	6301	12293	jxiAtVcUx7AoVSQzfBJ782Xo5kneZ8hGc4rKuSJ6ijv5rqKxFzX	8303	11752	11752	1618054560000
16338	3NKLNnA7xxuo7UCVCPKvSzm6ELYR56NHcBThN4dLsDBSky3NPvRs	16337	3NLGpLsYMpLgaUtAnttGakZKPnzKjncetgasjzqcToamPxCjjdqn	44	1325	269	6301	12296	jw9WwH7o38VzAgX5rJjQnVeKPWtuMKM8LJCNfZBXCwxtwEgnjjd	8306	11755	11755	1618055100000
16346	3NLKyJY7LVuMTLR7VDdAv85gssERhQXQaCdLMRTU5dQ4225zSRzB	16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	1542	1304	270	6301	12304	jxz6rkknGMrrYF1DDXY6fxRfnbxF2WDcrxtyJE1WyaXCBdAaMKd	8312	11761	11761	1618056180000
16348	3NLWKcKKzfCK6t3YMk85cfg8bZRTz8J7mrHeTqUSAEMstguovwkk	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1536	1067	270	6301	12306	jwJrCMzR86CiEnBGPiJ7eSEQmUM7S3zUaMRq4PGRYV86si6njxr	8313	11762	11762	1618056360000
16350	3NLdhbLwznc9chCqNZgZqj5gwhgZSRUafKSNjUvMsL1h6YPNtihJ	16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	1670	1282	270	6301	12308	jwwor11HpETbtSt9MtZCpfujSYnLFWNTs6twa3jiePZwSehXPbU	8314	11763	11763	1618056540000
16354	3NLZ1Lg7ERh29GhoZCkRLuXLw8pxFEiF8Y9HYRyrfP6uHKCvnYbZ	16353	3NLFmrsXARCdrQEqPderF9fZcifZ7GbKpX9UEg3qumeF5znLTb2v	1440	1377	270	6301	12312	jwenrpUQTX3Zr81buimAXeuct5jU27CDqvR9WVbfjKv5iuaKDon	8317	11772	11772	1618058160000
16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	16358	3NKFuZaqJyBJFeQuHqdPKWhSUezW1YsxqvzTZT2Ufa3uYUvWYVNm	1407	1395	270	6301	12317	jwhgu9BNtCfpEyMWRYrtjLwkFP8aesT87GDMh9xWeZhqHVbhXZh	8320	11776	11776	1618058880000
16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	80	1147	270	6301	12321	jwZ178YrJjJyu9UgBAwFQLZaegXf5hbhMNSafMfxbqPPVUA7VWz	8323	11779	11779	1618059420000
16369	3NKT8KfoeBSoF19tVtXBq2ySAoKMvUktWyhwGNdVGeoSTM3mbV3K	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000
16374	3NKuAakpjeRyjZpznKfn9FXjoEFyVRz7xgiJqHCcvL3SgZgdCmxf	16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	1513	1133	266	6301	12328	jw7pEnadrH1KzMRRn38nW8LhE839uSKjDnQmzHu2Moea2Na7CXw	8233	11787	11787	1618060860000
16377	3NKWmcxnPGv92fpxiaabGbT5GTrhKBjrfqRdTvjBVHp5hXuWKJhP	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1560	1045	271	6301	12331	jy2ooxZ2dNZcq1BSL2q4ZqaRXPzvsGU76xxoveaSXniLmWhAe2W	8330	11789	11789	1618061220000
16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	16380	3NLsmZoLNd5ZisrqjC9r4gDTxb2T514grwP9ipkwgh2NectyrFMH	1406	1393	271	6301	12335	jxA5SBmZmuWR266iQmVfk7vcJp4oennKSjCEX6FczoQ2QPGfEzZ	8332	11792	11792	1618061760000
16384	3NKnfRbVXHk523FGCh96m6GufY1xuUqp9hpRjLYLqQXQt7gobSqy	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	171	1374	271	6301	12338	jxFtf3QM5vMjzced2XcrUK1UHi6Gg2pSfSPScyUBfyj1eqVPxV4	8333	11793	11793	1618061940000
16386	3NLeRaaDoYjPPMTbNCPZAFEu1X9Bkak3ZYm1YxrJPWC6tuBzveDe	16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	80	1027	271	6301	12340	jwAxokUDEq44A7gnax57U1CifefPiLuYNZDJ5Fd247MZWiqbCuA	8335	11795	11795	1618062300000
16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	1536	1067	271	6301	12343	jwNtdYCZP5mRZ1We1f1pMEQhHxT1vQASTx4Btw5QFqx4JPYTwDS	8337	11800	11800	1618063200000
16256	3NK3eUHkNWjCsdeahuVmbbDjtFAkgCcwLWvqWBx7bY1PBgC7sj8F	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	1458	1197	267	6301	12221	jwboqhDUqzjcUPgspJRVFWbruRLUd59DFU8XwJiHc1bsJj8pUdq	8262	11695	11695	1618044300000
16258	3NKknitVeqWXbEA43h9CQwkTPn2z7eE1HWsMqKft8eVGEEHmppt5	16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	563	1359	262	6301	12223	jxzbQuQ1fkzKxbmBjcgtdtpU7bmPQvDZ7KRa23TizdZzEdmdVpy	8159	11695	11695	1618044300000
16262	3NLybzf6ExjtKWYndKMhsTF3ZafmwTXpzbWot16rCgiPonnMNXfr	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1547	1252	267	6301	12226	jxAvFRhwmhxTDtn8cwaaG27hRQk7sEnjhmDVcb4S2usva1DnQ6U	8264	11698	11698	1618044840000
16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	1581	778	267	6301	12229	jwgMHe11zGTB4DvCYY1ARPhiQCSUXS1c8dhWLBoCyxeV9YF5S6i	8266	11701	11701	1618045380000
16267	3NKQLXb3HQDVsjwx9WTRTER96MfVVZh3WAo5ijGtEDBR1QoKyATd	16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	1559	1353	267	6301	12231	jxUuXSyYg1JqNKDC6PoD2oSYjhoDaBJytRRb7uZYmn4yErMgKXe	8267	11702	11702	1618045560000
16271	3NLDcqWt6YrBZR442LY5tJ16qEPGsxQcqy5crQnREmLrXVPDc1mz	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	606	1295	268	6301	12235	jwdMfdcmyE7tsdABDsE5MvqaTcdhAqipcDjzMiESc9jTcPH7d9U	8271	11710	11710	1618047000000
16274	3NKxJeRkB1hoL3rdBucP9CXduTBVci9PXA9hy1dxy1NWpr4fA8s7	16272	3NKzwHkEyByQYRVQsxd3qk8M4zpGcuZMGyNN2vc1FT61biigB9mS	1402	874	268	6301	12238	jwD9cHWkzsNeDqxffhPX82nHSKfWZU43RXd5muMvEynDcLWouoF	8272	11711	11711	1618047180000
16280	3NLTnXRMXMoJnBDp61RWCiVBvwwEDdxf7kz1mm6E618f8mQ2LKJa	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jx5Vmbqx8nJR2LJcHAiQXGZYJzPEjYrRLtfrkJoSfzLc86kJTbN	8274	11713	11713	1618047540000
16286	3NKBqZgScTQJWTjYgbm5uthbntFiLnM2aySSw7trLhuwCDwghUER	16240	3NKeDPXLd6a3juchSozfv4357hLv4K68b44Vwp12qxTadsXwWc9P	1476	1125	266	6301	12247	jxFFK4tQSeR4GzDUv9qhQENr6n4QkZyPVLPbHb9XGrL8HSdbgyB	8245	11714	11714	1618047720000
16287	3NKLLikmxp8ADfyGskYVTWNesmEb9iR4tquvMsZQL3dRuUUHPQZQ	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jxgPpxe6KGpw9wn51f17r58ueVvakmNWXnWavCnTZXURv2x6xmb	8276	11715	11715	1618047900000
16289	3NLnozxkUcToZUctgqhnCe5bo5E5vmdNDUi75pW6HafnjgswCavC	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jwH4gWbzd4yKPiuf5wr218LQUmKSGQxoLak7PfvQSKRZrMcnfWc	8276	11715	11715	1618047900000
16291	3NLt1CYA6khFdADs3V8mfMgSxLZhfraF2pomWZZAwbjmmwe5FdPp	16290	3NKTeQ32sQfgXfFRKx1JWfAsJjbtVVDCSawQ4NR2px7opLxdCEz9	298	942	268	6301	12250	jxCS845NEim6qBnutxp6DpKZR4juyskAfAGyKKQQMaEwZNB6rCR	8277	11716	11716	1618048080000
16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	16292	3NLdgf33vyUCr9WWRBLqkjzv4kEk6pr73uwEyeFZRm7xDHSuRVQw	1634	1331	268	6301	12253	jxNitNGa1Ytu2sjXrGutG3hmdjVYbLy86EeNtA66vCoiQCm8Fme	8279	11719	11719	1618048620000
16296	3NLkWCgcECPhSX2Hht7BTr8skAQFNt8epdbg7eZAxPLGXE1vSGAR	16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	1440	1377	268	6301	12255	jxm52adJv1nW4MANnZms7Tj7bd7tww5X6KHdMnQC3mK4bqoQVAf	8280	11720	11720	1618048800000
16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	16300	3NKvG7xiUan6LwDyrTnFRJAVCdYADHFANrRfNYunjnFJzx1RPeS4	1601	1388	268	6301	12260	jxeuKS4Day9RxBXNxeiP2LEz6Yonb6MU5f5kED2xtT9Ddy4Pcij	8283	11723	11723	1618049340000
16306	3NLQZu4GhbFzR5A5B68pmJmfz2GtPjCYBnK5igsDfeTtcasfUnom	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1613	983	267	6301	12265	jy2Nkq7tVg37wecwyBodMAs7D64yS1qH7votuHD8cha6hSyQnqD	8264	11725	11725	1618049700000
16308	3NK6vgPRdxDVUvEdjHw57bct2DPZKvLcHAtGgMiMCyjCdK5YHXBp	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1460	625	268	6301	12267	jx9RJikVggr6wTSGAGCLhYPNvs96BJvV5RM95UseyWXnupjngAN	8287	11728	11728	1618050240000
16311	3NLJPdsYDPhcyEgMtoeXNDweuo6JofnB8HEwEHR6D8qd1Xps6ZuU	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1648	918	268	6301	12270	jwnk6c5pea66u3ns2UvaQCAKShBC5zHkdEodDKp1y6Ur3yYwX6L	8287	11728	11728	1618050240000
16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	16314	3NK69mLomM8vk6QiixVb1RHCDvEiDRkrMZJwXQECwcCkFFnaPgT9	700	832	269	6301	12274	jxfVdsbvAntRQopi9yoHT81WCqqkMSeJqLAwtKnTLW38sGeYsZk	8290	11732	11732	1618050960000
16318	3NKcNDWPvkLZS6EyV8jsVdsCwpE4u6t1WYWRaxRWpu1oWgtMjzSh	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	42	995	269	6301	12277	jxtcVPrRqi7k9SvBQA4YYLzgV3fz7VtoEaVxxrAjQfPaod9ZeJE	8291	11733	11733	1618051140000
16322	3NKKZqrC1GBRuTtUPcxWLXroZbtFbiYrsTgtNWLmPzpzRye4GtCs	16321	3NLY1dC376kKPeLQKgqkTvYBA4hfM71e1YMpjrkNMZEzmBjLk1r5	1581	778	269	6301	12280	jxdVpXoDrxcq6va4bzQ8pBXy3cWFeYMiAu7FmwX3LPKaJ5E2V1S	8294	11736	11736	1618051680000
16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	16324	3NK3Z8bkRzdeKPWSkRiYbgegdrs5dRCoX5ZeBFZY4corHs1xbasz	1637	816	269	6301	12283	jx9MeRnQ2fJ6wcn4XKSfDdgyqNYzaVwW8MJYmGoaTkHjTRQp4Se	8297	11739	11739	1618052220000
16329	3NLa9PNaNZauHX1HozLCP1DfY1N72wkiDMaaAwHELcD8EcroZME6	16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	1406	1393	269	6301	12287	jwGv7d9YC1q4fPHrLzG6mUwdX3yrcCnndGN6mV4o8MjdVW1fkaG	8300	11748	11748	1618053840000
16334	3NLv6V6HvCHPUqhzgYMVF89kgNuEtMHJQ4E3WJySitxdNp2d6EFe	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	1490	133	269	6301	12292	jxN3vV8tYwejoy8pmXBgDkPVYXyU2e21rP2myggzA3MBpMrPEpB	8302	11750	11750	1618054200000
16339	3NKxDidZ2Ein8CiVjBsFQtp8HQmXRvNS5uZPKBp1fGyksjqbvJGx	16338	3NKLNnA7xxuo7UCVCPKvSzm6ELYR56NHcBThN4dLsDBSky3NPvRs	1406	1393	270	6301	12297	jxsP69KD6ci2EhGww8rVvdzSNjb23dpmMcghF1QohPsTKr98YFJ	8307	11756	11756	1618055280000
16342	3NLdUwcKjPMkUCcpksCLRCJ6uS5cHiE9uv7aLji49SbL2j2Ncka5	16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	1406	1393	270	6301	12300	jwmmBgvLyP4QNe4QAUfB147jWmK8eyjQ9rcQ3BgDfjzZVEe1Rv4	8310	11759	11759	1618055820000
16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	16342	3NLdUwcKjPMkUCcpksCLRCJ6uS5cHiE9uv7aLji49SbL2j2Ncka5	1671	1119	270	6301	12302	jx1CXuBeHNusHXkCGr4i1zUmMzVfnv8vRG6uQQVjkhETL45zVjV	8311	11760	11760	1618056000000
16352	3NLvCn5wCbAnT116xAtVZx1iCqym27mmjfCj4nYRLhLFWH26Yo9R	16350	3NLdhbLwznc9chCqNZgZqj5gwhgZSRUafKSNjUvMsL1h6YPNtihJ	1617	1162	270	6301	12310	jwrBY2LJHusghK7di9o3wZqH3cy6aXd91siZbidMfH3D43efYMh	8315	11767	11767	1618057260000
16363	3NKmuwptLy2HxwkX6Jvhm5mBa4933qums8aTzH2XHyUhFQB1ePUU	16360	3NL6RAy8ZTAxeFTpbsBwVofQqWCh1hYCcdyHfDooXjbDwhKg6ge6	1403	824	270	6301	12320	jxNMNEqWS7LnUfUuMGaZxbMoS53DVr6RamLgGHSXViEixm6GjZS	8322	11778	11778	1618059240000
16365	3NLf9rfW7kCdhr8PXfyrJYY7GZz385qPsvNvm6mfWg2djADR9LHP	16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	1403	824	270	6301	12322	jwTdfjsmJTSVuuVu9cU8Dg5PjSjvoB4CXuGjAf3j3dQVpiirshM	8323	11780	11780	1618059600000
16370	3NKZKBqmH4eXYedKzkgZbMvDaLALrqA2hKPLqsuTTZXHfyqpdxQL	16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	1675	1342	271	6301	12325	jxnUB5uBcCMvd5Hx7eA6dmU7RLJ7kVe59yXscqURGCb4WHen7GN	8326	11783	11783	1618060140000
16372	3NKck8WfyKCuTcxGESr46ikEhooxiMbMHei9UKCN5HbzM1EynGy8	16370	3NKZKBqmH4eXYedKzkgZbMvDaLALrqA2hKPLqsuTTZXHfyqpdxQL	1619	1029	271	6301	12326	jwE5oLhXYWuTnT8WMj5eQWZgr7W5Mm9LUbNKLt5YU8ZZBBhnUPz	8327	11784	11784	1618060320000
16288	3NLrNo2r6meH5pW3ATV7ALKfyXCP6DKrf2cTG68QNTznBii3ezjZ	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1483	1150	268	6301	12249	jw9yiGXnoyaYgZyWY7eADrVGCRc2BJRVq1q14oTRdRj6FuE2HzF	8276	11715	11715	1618047900000
16290	3NKTeQ32sQfgXfFRKx1JWfAsJjbtVVDCSawQ4NR2px7opLxdCEz9	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jxX8Ton7mx6c2Dkg8bBxQ78RZhmXTYKMXt7QympajVmx75vrUVb	8276	11715	11715	1618047900000
16292	3NLdgf33vyUCr9WWRBLqkjzv4kEk6pr73uwEyeFZRm7xDHSuRVQw	16291	3NLt1CYA6khFdADs3V8mfMgSxLZhfraF2pomWZZAwbjmmwe5FdPp	563	563	268	6301	12251	jwoB8a5y6YT77YHYU5VHoHcSuSqj6inNjaw5PbdquoKhamhQaUj	8278	11717	11717	1618048260000
16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	16296	3NLkWCgcECPhSX2Hht7BTr8skAQFNt8epdbg7eZAxPLGXE1vSGAR	1623	839	268	6301	12256	jxvGcV7kQHU84ZsnzQ6SfD6wpQQMipt3gzMy5BRMM52JhJQpGjs	8281	11721	11721	1618048980000
16299	3NLbi7kKkzJHdeEJZF1JETVgHnZVGS814eG8CBYDeYVvkLwydmsW	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1609	967	268	6301	12258	jxGXpDkxLaYoyXDApPzgndegE6Utr2QiMLExQQhqes3aLUV5jYR	8282	11722	11722	1618049160000
16304	3NKvSLwqZqUQyamEkeTg2fwrxB9ySqK6avNYV6aJD3p6ESfaCN4s	16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	1610	1314	268	6301	12263	jwec4wnVqKPjN5FQVq63Ayxh8zpFDvr4FQkdG7C1TeUrZAPCeXy	8285	11725	11725	1618049700000
16309	3NKup3cR9ZtTg6d4G6ZFKo7VR2AeTzizyKgTHbPX1kFxYmB7JZV9	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1553	776	268	6301	12268	jw9rKYyM5RoSFaQydiYkwZ8A8aSL5y8DHVetjwfPTjR9THgoJKe	8287	11728	11728	1618050240000
16313	3NLXrNDSQcfEPvuKT2KKpkd1QtMaJJwdeHsxiSymTAPx3qhD2ktF	16312	3NK4xSVTtdVeFXQ8WwhHuPNA5kUw98mkNkvcSJrWsZhmWMMHni58	1406	1393	269	6301	12272	jx6EPvib2aeZa4v7BJq56wG7KqNUV4v9hpyZ4nbkeG1pGuPxYTH	8288	11729	11729	1618050420000
16316	3NKcr7BjVEp1QK841JT8KHdf7ugW6TZV9K7bwmGKebJeU6Dv7zCm	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1448	1065	269	6301	12275	jwTE1qkeJvF61PfZ4g9wDhUA4RTAetyPE9GaYSet4LfRA6wmDQs	8291	11733	11733	1618051140000
16319	3NLKfqccDoNoUG8B2jarsEP2bv23yLM3pCDMBxfPZSNF71ACLtmi	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1448	1065	269	6301	12275	jwMEdJTwsz5RbpGD1MqYmUobM7TUhnVm2M2ScqR5ho1wnjcqQN9	8291	11733	11733	1618051140000
16320	3NKEFTA6BGYt84fedi1n8SRuziS6ioHsVyDV8DaviqY6TCnvvRKu	16318	3NKcNDWPvkLZS6EyV8jsVdsCwpE4u6t1WYWRaxRWpu1oWgtMjzSh	1406	1393	269	6301	12278	jwRkujqAn8qr5Fm8ovUb981KQhfpih8WFDHBYihVzmbkjECe6Dn	8292	11734	11734	1618051320000
16323	3NKVii5rCjkbwFTcmrWumEYwxijT29UEqxYbsGbDDQgc3DER6kmH	16322	3NKKZqrC1GBRuTtUPcxWLXroZbtFbiYrsTgtNWLmPzpzRye4GtCs	1516	479	269	6301	12281	jxqoTGQojKfCWS91Luf6DJU4LLaNLGYoBJ5zYRgd3nd67G3HyW2	8295	11737	11737	1618051860000
16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	16327	3NLPbRWoyjrKCvYXogui4peZk1m6YCuwtzZHyZVuqh8Agbv6EVEQ	1529	1316	269	6301	12286	jxJE93h7u1wxkiEgL2sFb5Av6nyEfv6toneLHPq1P6Xss3pGRuf	8299	11742	11742	1618052760000
16330	3NKBAAGpMcKGHnJhL6xSSAAv2NUJukuweXMn7yqrDHzPJjxipHMP	16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	1407	1395	269	6301	12288	jwowQy6WAVvTKcBhaTyXmSUkgx2ceEwmLGvCWGq7jpk6BjcX4YU	8300	11748	11748	1618053840000
16332	3NL55ikRfpFJgGMGXJFtdUyS3D27c7Licv4cgsSQ2iMZXAgW4Kgw	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	596	1060	269	6301	12290	jxcxyZ3MhuaVYM5ni39rjTwtVtiEU3qAphr9Zqy2gxwEdQazcJU	8302	11750	11750	1618054200000
16337	3NLGpLsYMpLgaUtAnttGakZKPnzKjncetgasjzqcToamPxCjjdqn	16336	3NKcW5E5k1JikCgG571rBv1ETP3Qe6CweyDF7aWFQDHTSwmeUE49	1649	1383	269	6301	12295	jwWnNi8cFuZwtTerTSuQXG4rKdpdnc5yP1gW8a1XWCsyfLWVAqS	8305	11754	11754	1618054920000
16340	3NLpVkYE42tpgS3NESp1Htp5FAxZzgLkPgBW9YuA5XUx5fzcrWq4	16339	3NKxDidZ2Ein8CiVjBsFQtp8HQmXRvNS5uZPKBp1fGyksjqbvJGx	1578	1296	270	6301	12298	jxXbJGXzCdHfNKJB5LNevYFWBd9ibuiiRYv7gf2sdt2YD5gdiji	8308	11757	11757	1618055460000
16343	3NLR6efMMzEm1DHHviG2hqqfe3NP1Fc1CGMqBTAxJ5i5HyxxYKQN	16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	1426	1364	270	6301	12301	jwMQG1FF6NbSksfEnjFikC2rzK55AqNZZsRbxihcSxanGLP1veJ	8310	11759	11759	1618055820000
16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	1406	1393	270	6301	12303	jxofRDvLkH9T49T8U5P54E6eEbFYWhMRsFMiXcXPbYpyLTVEk65	8312	11761	11761	1618056180000
16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1529	1316	270	6301	12305	jwF88LFudAeRTzuWG3b8Y9b7CyTivoqszSA92iKzg4RtYRXEsUp	8313	11762	11762	1618056360000
16349	3NK5i3Pg6w7qJJNfN32VL5iyRLxWjMDLr9mXaCYZi2QaRTmqQ9wA	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1650	1129	270	6301	12307	jx798SWSi6RGBHt3hrDE5BZnK9yTTshWTjmnFwrVRzmq3Htp46N	8313	11762	11762	1618056360000
16353	3NLFmrsXARCdrQEqPderF9fZcifZ7GbKpX9UEg3qumeF5znLTb2v	16352	3NLvCn5wCbAnT116xAtVZx1iCqym27mmjfCj4nYRLhLFWH26Yo9R	563	1359	270	6301	12311	jxeFvPpBVWSXyCnA2n1ZYBbn3k7qvwE1dGWqovyz9dAwcfH4zvm	8316	11770	11770	1618057800000
16356	3NLHzKe9KcU8JzSQCXzs28JYtYUHbsJ5ht4NcVwPaFEPjryMdTa1	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	80	1273	270	6301	12314	jwHCsi81eAaQN4UMHK4qF1LVYPvnhgreXHjAoDpw35XEk3YmMyV	8319	11774	11774	1618058520000
16358	3NKFuZaqJyBJFeQuHqdPKWhSUezW1YsxqvzTZT2Ufa3uYUvWYVNm	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	1403	824	270	6301	12316	jxF5q6NpTwt7tjBbXhwvkVVWa3Rn2yDHN86VaX78g21XhGXzujy	8319	11774	11774	1618058520000
16361	3NK6FAztUEAHGZPT59MQ7eYkbdSzNj4RX1qhSvXSscKFUnk3nQsm	16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	1511	903	270	6301	12318	jx2NQiuScmVvBjQLncibVve3SNZvFwhL5XGuzDmYcvWTa5MwrhL	8321	11777	11777	1618059060000
16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	1599	1041	270	6301	12323	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK	8324	11781	11781	1618059780000
16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000
16371	3NKHg3tSoaLpZtK5KyP9PMveZXhvWQw2KD9QCxgQeEF9bkRVzWAS	16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	1675	1342	271	6301	12325	jy1MX8r3mbaCTnhkiKCp1NvxC4gh5zFGEGTA7ud8NB195MTBdXA	8326	11783	11783	1618060140000
16373	3NKLEJj5erVTbe1DWm4iD7jqJfy6CaqhSAFVwet35DtB7urYE9Ty	16372	3NKck8WfyKCuTcxGESr46ikEhooxiMbMHei9UKCN5HbzM1EynGy8	1419	814	271	6301	12327	jwuuBMtfmdnw8y6nj4U7oK58fm5svEGcZQy2oEFLsShmUbW9Jga	8328	11786	11786	1618060680000
16376	3NLjj2PUZpSzXRhXGUsRedHQ5rob5PAXb8Xbr7pHsGEZ8nJXjPgo	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1599	921	271	6301	12330	jxbdpAxxPr5ypqBBxp5kgE1KFAMKbyj4hzfkDFAsKTBKdx6VU5u	8330	11789	11789	1618061220000
16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	1668	1370	271	6301	12339	jx5NJdjUwLdU3n3mBEhPYrxtdM8TJ2kC9DnzZp2ERCsNXxiuCaY	8334	11794	11794	1618062120000
16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	16386	3NLeRaaDoYjPPMTbNCPZAFEu1X9Bkak3ZYm1YxrJPWC6tuBzveDe	1637	816	271	6301	12342	jwRsJyYzytvvANEAZAkXKLkwqcYH7MqnpgjaHmR9suSoTGan7sK	8336	11797	11797	1618062660000
16310	3NKcvB2ffrNSHMk2WRB72SnYk5fy6sqRkE9jiKfkxj9d3fw8CmgG	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	576	1109	268	6301	12269	jwRNR7UsqUpKaprwAXvptmMUL7yo4QSZi4FfmGbWYmbH6ZPfDdY	8287	11728	11728	1618050240000
16314	3NK69mLomM8vk6QiixVb1RHCDvEiDRkrMZJwXQECwcCkFFnaPgT9	16313	3NLXrNDSQcfEPvuKT2KKpkd1QtMaJJwdeHsxiSymTAPx3qhD2ktF	1477	1350	269	6301	12273	jwoMY1WpLMZZVxn71sfvqRmfzNs4qpB6VAKLiur8XDgRLNgGydC	8289	11730	11730	1618050600000
16317	3NKadT9KXmVBK3o5TRmjLYLR8sfJdkDCQQMdFfewyV8qsu9W1BuE	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1457	1391	269	6301	12276	jwWouobGsVGT6gi8YHgfMztKbXciboE3M2un4skycfKUJRkpSQX	8291	11733	11733	1618051140000
16324	3NK3Z8bkRzdeKPWSkRiYbgegdrs5dRCoX5ZeBFZY4corHs1xbasz	16323	3NKVii5rCjkbwFTcmrWumEYwxijT29UEqxYbsGbDDQgc3DER6kmH	1637	816	269	6301	12282	jxduRZLK82bo5MC8BTVap1Xf2U3iycF7NYHDyksbxnmS2b9HHzG	8296	11738	11738	1618052040000
16327	3NLPbRWoyjrKCvYXogui4peZk1m6YCuwtzZHyZVuqh8Agbv6EVEQ	16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	1559	1353	269	6301	12285	jwXxDuPB4c2w4RtjwLqKmpLcun2hMB7hH4ANuzcRW5WpJ1VBEza	8298	11740	11740	1618052400000
16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	16329	3NLa9PNaNZauHX1HozLCP1DfY1N72wkiDMaaAwHELcD8EcroZME6	1406	1393	269	6301	12289	jx6GCNW3g27PJp5RcJvmH9QatUzeH981bTwjFsZrsEbQZ4dzKpR	8301	11749	11749	1618054020000
16336	3NKcW5E5k1JikCgG571rBv1ETP3Qe6CweyDF7aWFQDHTSwmeUE49	16335	3NL7BWhmoES8Jw9FvDQxjjHVoziP9vkf5afYJB7uUHFS7bzZho7T	1508	1387	269	6301	12294	jwZNroX6zNg1h1s7QvaraPUbp3UxmRp7yUmeu6pkkN3Zm4eLgYf	8304	11753	11753	1618054740000
16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	16340	3NLpVkYE42tpgS3NESp1Htp5FAxZzgLkPgBW9YuA5XUx5fzcrWq4	1560	1045	270	6301	12299	jwQqJRhoUt271qmDFVh7SzEHaavhasmBRtGEgTxkf4NW7j27P8R	8309	11758	11758	1618055640000
16351	3NKsgwuTpnCkofhtP51ruVVg2tKVFc7zgUVufMQLvDqFVjbNHv7K	16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	152	1330	270	6301	12309	jwP2YXkgEo6pNqX7fonCKsBaxGJe19GKS97oq4iaRyqYkTrtAvy	8314	11763	11763	1618056540000
16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	16354	3NLZ1Lg7ERh29GhoZCkRLuXLw8pxFEiF8Y9HYRyrfP6uHKCvnYbZ	1406	1393	270	6301	12313	jwipt29zBLPmVDFzndNCTvJ2xrYpZi5jrnbfMT9B87Yc1PupQL8	8318	11773	11773	1618058340000
16357	3NKuyTU4P1bXottYGtPuMxxsLjarUjeMWbF5pc36EMc4NFqrBLur	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	298	1182	270	6301	12315	jxvfigMgwfpof3S9VeoyeTqxyzpX6XnAx4TfDVacLTDHxPt8dxj	8319	11774	11774	1618058520000
16360	3NL6RAy8ZTAxeFTpbsBwVofQqWCh1hYCcdyHfDooXjbDwhKg6ge6	16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	1511	903	270	6301	12318	jxBLvDTGG9LPjuEBYeAyWbp8NTayhhsFWc9tSPci2ZxRMrEPxoy	8321	11777	11777	1618059060000
16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	16361	3NK6FAztUEAHGZPT59MQ7eYkbdSzNj4RX1qhSvXSscKFUnk3nQsm	1581	778	270	6301	12319	jx1bHhUyA9LKW8Zg4x7mQ1TGq1k9Pn12H5Zg61qnh3hVsagy6XQ	8322	11778	11778	1618059240000
16367	3NLA8scY7cE8Y2yNbeXA65CXAnNLeYnzj7pinEKmeS5jKkHNDupG	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000
16379	3NLZ9gfDUteBzshVhGFaHQ8wmQoXrAUcmASSs6mSAD544Rwt367K	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1633	1390	271	6301	12333	jxmWRTyfYGW6onMxsAHc2nnTga3BhV4GBbEZGXtBQ4eia6wAnht	8330	11789	11789	1618061220000
16382	3NLfnc8WtPrPuxeaUj9StHvJsQGxW6yXvWKHGsMNxD5eo9VGyLwN	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	596	1060	271	6301	12336	jxemBCpPrsMYoB3A9zbZeifxLsCZnFA3skuD6P3UxZc9uduT7BQ	8333	11793	11793	1618061940000
16387	3NKZBxcdBV1soZW7jbTzQaScp7RAd1T4RYMpVv6vh5ctmSaN7Whk	16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	1549	1362	271	6301	12341	jwsVwfcuvJwbWtcoe2jN78YTHmpVodUnJU5T25Byf37gC5QE2C7	8335	11795	11795	1618062300000
16390	3NLcPbqm1YSpo6hBS5PArCg3kE1GatbGbBuEinEmtwVpFNRTPX9n	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	80	1273	271	6301	12344	jx4z4wK7oQemywKCkMJohpNpKV7Kvwk4Ey4QYyDT26c8qVxu5dP	8338	11801	11801	1618063380000
16392	3NKLGZ7niZf4ufiiyZQmpuXbYyGkHHnN26BrKft23UwJyLkMLdic	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1627	1385	271	6301	12346	jxF2L53ZQkCaTnBwyRMvidmfqWr4CGy7mCxrLGyNx5Mz4zpfeVn	8338	11802	11802	1618063560000
16395	3NLWo7jyoEk4Q3Dbvdm9PK5S8VS3f97ueSybkysKDyhudRCKbEzr	16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	1611	1095	271	6301	12349	jx9DbuUKmmE31AfMnreqhwfgSh4zMgCQDwE5zUoRHKHRR1dCnUN	8339	11804	11804	1618063920000
16397	3NLHd7Qhe1TqwKkFW8MSu7SwvaBZ2N7Lipc5jBuzJBvsSTDhTuNv	16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	1581	778	271	6301	12351	jwUdqnrBZhVUuFwNrfr5F7RYRXMrSjBPtsd1TFtN4QP5S8QUuHo	8340	11805	11805	1618064100000
16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	58	1281	271	6301	12355	jy1JM37ZtcmEBbJrinCzSw2tc1yYPqH8gfgb11G4Qt1WCxQByxW	8343	11810	11810	1618065000000
16407	3NKgyMLTXuJysFEJjsYMo3N2YfTyoCXooDLeUinY6jWKs5hidfXL	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jxfjwMTNyRT3mzs2LhPzPrS81LwURjeKvE4gLNs6LYs8oEbaBGe	8347	11814	11814	1618065720000
16410	3NKncKtqjFH9mP44eKSf2LVTYGYwgW6RPuFoVxLkagxZEAagfhVK	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jwHUsxq7PHv3cGtijWgJK5fdcc2T75X293U9x1xvg7i3RgirTiA	8347	11814	11814	1618065720000
16412	3NKEGgBavXMT13KvmRTJoaW4tf22YdVw7rXt21hnG7smsykETHtY	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1407	1395	272	6301	12363	jxUxs1pJk3bczwgH5qtrxZkDbmsgBsWBFCKhqfJE8w4SJTu6jj1	8349	11817	11817	1618066260000
16414	3NKdqzgMrWfpw3XaFVWWodSYbNqbXaM49x1yt1pfBbnFbCckYX8Q	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1419	814	272	6301	12365	jxbAe4ysS3WrHmz8Yv33AhiJCb3s55zWifGJTA95bf5r1Du7qWa	8349	11817	11817	1618066260000
16416	3NKS8BzMAY4vdynP9rmwdNXJAVCijiFj8FnmY8A3KvcTMfinL4wp	16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	1483	690	272	6301	12367	jwocPacXSxTfcKAi9PZLDa7uempPp3GmrthqtS1xUJkNtJThGXW	8350	11818	11818	1618066440000
16418	3NLm7rFFMH3tP5fD1KvxPaNVdS3h5mf1mWRP7QbND8s8xpopgdni	16414	3NKdqzgMrWfpw3XaFVWWodSYbNqbXaM49x1yt1pfBbnFbCckYX8Q	1477	1350	272	6301	12368	jxAiLjthTE5wAFChv7HKB915as51CfJBLdmqd1rpANb5ZLU73Zi	8350	11818	11818	1618066440000
16423	3NL6v5Rq74aebcVBjiZuKzcCMjK4TXsgNQsbQvBLXjht23X9btzH	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1439	482	272	6301	12373	jx9ecRQHfDkh6AirwEgDjdzQTGUkPf7UEonzTR7CZkRc2EAjHZi	8353	11822	11822	1618067160000
16430	3NLGY9yKqusMEjYj7Q7TMkEHvScmnW1Bqg6ecMkxWngTtbbXkWth	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1407	1395	272	6301	12380	jxinNjxyoRbHmQDhEDHcZjFMinMTnvhByTaiQZoepYtz7DQRzkB	8355	11824	11824	1618067520000
16435	3NLov1TwHwRJWjkS22yzzFgsiqyXDQsCvaAGrqwBVmrYJBN6HUd2	16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	1588	1146	272	6301	12385	jwBeNRepDrkEpiM4xnz59HeLontLDFMoq9KuUFHSWYCc1LqmAUn	8358	11830	11830	1618068600000
16442	3NLrzvHeMHsi1qJjyo4XtFmfNMFD2zYAkyTQthuYwLMzGBtMerPb	16440	3NL5GA4PD3psp2q4UY8tzvxYGHDuHqv97gnAcnUf9o435NNZRVAq	1637	816	272	6301	12390	jwSzvTMrfaX2FJER8qUMN3iG9fZBUtaNwEMDk2neXuHFFDa7M2k	8361	11833	11833	1618069140000
16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	16373	3NKLEJj5erVTbe1DWm4iD7jqJfy6CaqhSAFVwet35DtB7urYE9Ty	1402	852	271	6301	12329	jxXu2kWR9XrGU4XTqazn6rZZKtT7zAh17XeQx6pHagRrY7y7aMh	8329	11788	11788	1618061040000
16378	3NLENGH2CcH8uW6nAbadGSG6RKNc2hF8dHzca9N2oBUWEw2JCffM	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1631	794	271	6301	12332	jwxsoS1TuLQAo3hamxERvivNQqddM7KYJrg9cKxXwKSVxAzqRQB	8330	11789	11789	1618061220000
16380	3NLsmZoLNd5ZisrqjC9r4gDTxb2T514grwP9ipkwgh2NectyrFMH	16376	3NLjj2PUZpSzXRhXGUsRedHQ5rob5PAXb8Xbr7pHsGEZ8nJXjPgo	1407	1395	271	6301	12334	jxhj7nLpJM2cTyCJqLyvtGapa59v1t2hc5HC1TAPGECtRFtqdWZ	8331	11791	11791	1618061580000
16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	1406	1393	271	6301	12337	jwc7Hzy3Gt14JKn5887Uw9h6G5NXbKqaLBcmEzbKR3mJ1dJdTht	8333	11793	11793	1618061940000
16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1657	978	271	6301	12345	jxe3kQdqaRpyhTqt7mcmsDowQ4B3xzTdvWn3S7MdrQUt8eq2zZ5	8338	11801	11801	1618063380000
16393	3NK4MoPRUHCJk3kX3ugmhGzynTABhDJU9HV9mFMCZNwND5v8GKmE	16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	576	1355	271	6301	12347	jxQVc4Bz2ZZdMegfTqcigcQGSNWMyUhF8F5RvhhNAugxeMcZBzJ	8334	11804	11804	1618063920000
16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	16397	3NLHd7Qhe1TqwKkFW8MSu7SwvaBZ2N7Lipc5jBuzJBvsSTDhTuNv	1447	1345	271	6301	12352	jxuar7RTN4ZYq5PTEt13MVCjMQ56nujq74BfF8KFU6d8qFndznL	8341	11807	11807	1618064460000
16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	1564	1338	271	6301	12354	jwop4wXPjakEhuBirSW7PbWVdB9xSgsMfzUrYsT951usoaMPGmU	8342	11808	11808	1618064640000
16403	3NKbok9CphKpetLcXVKBLcdvwXt2LLnyQcoMwLkPN8ZBFmEDm7n8	16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	1407	1395	272	6301	12356	jwnAmng1nsmz6sUQzQXakhHHQchqYrgEYXEkixTnKNRijoDYYaS	8344	11811	11811	1618065180000
16405	3NKB9MmT3xswMc7N3CnYLoa4UqCe5N1FY1U4UmFRHrG94twZiR9j	16403	3NKbok9CphKpetLcXVKBLcdvwXt2LLnyQcoMwLkPN8ZBFmEDm7n8	1483	252	272	6301	12358	jwnxehatfrKstu9M76SCZF1K1nUnDApv1PcbDECSidrL9ekEZgx	8345	11812	11812	1618065360000
16408	3NLRurUdghPbtLtVXHpubzci92u1Pc9wgNAXXW3h2JSRDxxskPdF	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1547	1378	272	6301	12361	jy19zSc1pPaxQEp8xoWNtTDGNgJ8KCLwHQWkb2uGSXNHpqh3qJu	8347	11814	11814	1618065720000
16413	3NLudT5vCJJmPcefjthebm7rtfEXZmLKKzQhgherJUE5odUU2ksB	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1406	1393	272	6301	12364	jx4SA7VGcRXYwgW3tdM9PdPTy6YMYtGhPh1LhP5T4hfW2V659S5	8349	11817	11817	1618066260000
16417	3NKruSpF17XB8Uzvup5jAuX6qfxj17dTKabCYRm3bWzRBY9Cvgjg	16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	1483	690	272	6301	12367	jwYjbM27giXPxeVBLMjUTJpfYTWdwfSws3QEWewdFPjfCaBCU8N	8350	11818	11818	1618066440000
16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	16417	3NKruSpF17XB8Uzvup5jAuX6qfxj17dTKabCYRm3bWzRBY9Cvgjg	1407	1395	272	6301	12369	jxsLucd4npMMtQhSpJg6uxMLxCqprqBhdeZsHJmzA8GxHLPgozT	8351	11819	11819	1618066620000
16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1601	1262	272	6301	12371	jy3748icKxAwpzqJavrEyv9gPpfvfgAZnqJvfGxNZFPnwTcamL4	8352	11820	11820	1618066800000
16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	1406	1393	272	6301	12376	jx2hr6fFTyc8RTgaXEuXwoxrhNF3PnTKqwko8WSDm8ExWDKk882	8354	11823	11823	1618067340000
16428	3NLjhuix2EMqY9m1Ba9e8XrabvPSoFkdLVSLWmNcYx647FPibaGa	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1405	873	272	6301	12378	jxAkKzWr34hXhUBs4Cyy9wrSyXGrVbogfjwbfLRhaRH1u4F3zM3	8355	11824	11824	1618067520000
16433	3NLnkZrgNbdvXCRPnX4fTozx6WnakYhnJbHJrEeKdhGACDjRAbni	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	1643	1299	272	6301	12383	jwtSZM1czgpG4NgdeoEwztwtTnw41PkZA4YG2greUxzrChmnSvh	8356	11826	11826	1618067880000
16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	1542	1304	272	6301	12387	jxPmqW8KRxkq7iSdvbnLiU6ocExm2zU2NaTn8RFU4f1SGLG11ay	8359	11831	11831	1618068780000
16440	3NL5GA4PD3psp2q4UY8tzvxYGHDuHqv97gnAcnUf9o435NNZRVAq	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1633	1264	272	6301	12389	jx91SdTEJ88NbtgEzGf1RPDcQZDjv25yPuULpresCNBjWx4Xnet	8360	11832	11832	1618068960000
16446	3NLWNrV1EWDcUL38kfm8pEdTeCRP69XGfLZiNkUFZztVKJmb1K4k	16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	1647	1302	273	6301	12394	jxijUwN6tCvwo9U6Mjwqebo6Z2XtQgsRpsKm6dcCjws3JbRg6kP	8364	11838	11838	1618070040000
16449	3NLYdXTDx1eRrwUVZDCRBifKW5NYey3SnFmiSP6MZMnrVwtyDv9v	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1581	778	273	6301	12397	jxkwsWKkDnHAQMcyXjcGvnoBEEkRi5qpxp6D5MEBpdNy2yEFrSo	8366	11841	11841	1618070580000
16451	3NKiViU4C4dyp6QNphYSHo8JCHMt23CPsSCeetJmxnWbpdyrPDWq	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1406	1393	273	6301	12399	jy2okcuRyj4f3EyHca8ea2ud8KyZ9G7jpCqJiYejqb6aJDN5hsD	8368	11844	11844	1618071120000
16461	3NKRD74aJkbcP4wqpvurpkm6rbag2TdyLnsCNwrXxVwGMnF2VuNb	16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	1600	1126	273	6301	12409	jxn92Ys8VV9wmSWBxFCH32jRqDwj9U3nQESq4ZLBPoV2VVuubga	8373	11851	11851	1618072380000
16463	3NLgQZpMYuV9SRZBjtjr2UhwZWH2gzBoDrjJeAsUR25PCpeR3Kqn	16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	532	1177	273	6301	12411	jwwivDWXugyhMK41eHUq6bujbGR5CcAxJBf5JH1LyzKzjLrvLzj	8374	11852	11852	1618072560000
16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	1406	1393	273	6301	12416	jwXiBdhXjjPDdm1HEKmQqmd3Q82mVsLktYqz9p74jbZk6A2JU8b	8377	11855	11855	1618073100000
16472	3NLgTUqUhd4Zypv4SuTS95vCD9W5D25T1Q1LmeJ2BNMEZcz9ruFT	16378	3NLENGH2CcH8uW6nAbadGSG6RKNc2hF8dHzca9N2oBUWEw2JCffM	1580	423	271	6301	12418	jxLZuFpRqChHCpRNJAbuYXntmZpDYmEJWBoc8hgp5kurvWoSiXV	8331	11856	11856	1618073280000
16479	3NKvgzVjthFXjFVzSCc67MAegXvx1HzpL1gpmCRmuhAjCUHbXKrS	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jwDttm7LzsEfHbjpMZi77QiQUmkUqD3tdgLnRcn73SMh3JkGLV9	8381	11859	11859	1618073820000
16485	3NKeUfLmFcS1tES8JfhrgdhLK6PLD3Xb5rkjVbZXmjdRrEtUsU3R	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	274	6301	12428	jxwG8gxnfpRbFU1diuHFV4Nbw9ycmJth9oZ3kG26euRbVDpLniS	8384	11865	11865	1618074900000
16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	1406	1393	274	6301	12433	jwuNsDFuAcwgb8ps4vDVv1YNKu9etmUofwCTr5L88SzJKoWCNFk	8387	11868	11868	1618075440000
16494	3NLYTrvGBNoRLAebegeDRvyr3yhJamEVFdbtxgPa5DSZ58RF2d5Y	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	1589	1286	274	6301	12436	jweGfHQwXUKcU2GLSMJ8wungABmv87Y5tYdgusvfbCbASAvQHZT	8389	11871	11871	1618075980000
16497	3NKVCCwWDYGuRTsLVZdGcvbuWQCmSitS4TPutgUGDzvEJ8GVjLhb	16496	3NLsBfAruM575veXPAdmiq1pjgPxauWjpcGqWqswQy4pihd828p9	43	1310	274	6301	12439	jwe4b24hkbi9r1Hxqq6jmhPDeEYYpPdyhDsvxbpvWsaYmDeUnu5	8391	11876	11876	1618076880000
16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	576	1355	271	6301	12348	jwg2KtVQVemBh5P7C1pWDqje1HeEuHxB1CRvg4Da6MPrwhUhBp2	8339	11804	11804	1618063920000
16399	3NKijJMmqiWQUhzZ2sWDLS386wp7ACpeNGDv7kNkEXXDfoukkx4W	16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	1588	1026	271	6301	12353	jxRxE1VJvJr7scpReFUJVFLPniFrPARyvJQLz4oXXCP3jE7kacJ	8342	11808	11808	1618064640000
16409	3NK4SaPQ3g2S7Bhrzu8SqEcgayDHd76axBcPunxMGAL4etfgJFFk	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jxVUv4ypX5RpBdoc4mmcnM6k3t5EfKd3Q9FSLC1HERF38wpBbJK	8347	11814	11814	1618065720000
16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	16409	3NK4SaPQ3g2S7Bhrzu8SqEcgayDHd76axBcPunxMGAL4etfgJFFk	1597	274	272	6301	12362	jw9epRMYQ3yE4bt5YAb7MMvC56HRecgLEwYnpGeeyPMmYgj3M1c	8348	11816	11816	1618066080000
16420	3NL8LBkNkVAgWYJUnhQ3uE2njzVoER5s41WD3pRWbNGoJKxbntJw	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1406	1393	272	6301	12370	jxxWQ9SXria7fpTtwWh5NSLiptW4b2HLwiSLrn6Ves574GZmNun	8352	11820	11820	1618066800000
16425	3NKJtUNWjRnCU63cjn3SfxhZ9Tf6vfcFhcPAvRok8dz2h8FQZTis	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1637	816	272	6301	12375	jxmJGnSXgnJVSQdgbTy5oJMpvsnNWQUwNiB5TVjkXhH1xdHqmYN	8353	11822	11822	1618067160000
16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1406	1393	272	6301	12379	jw8fNCVHZKeSfVbwgDbDZNrCepfiomTZ2bqCQWsqMABMjHTTzvM	8355	11824	11824	1618067520000
16432	3NL6cueoUf2wdf6e8b8wGKqorGd1UwkpiTAEjrMjyKa9aibBMHvG	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	1406	1393	272	6301	12382	jxeZJDPXeXZs2AaaYVNmrcXHfBN1bsfh3hZmakv4UukaNvcbfKe	8356	11826	11826	1618067880000
16437	3NL8iwjyL6h7jm61uqsfBRAWyWDiv7ENCAnWx4yBPcA2gievqvjw	16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	1542	1304	272	6301	12387	jxqoNUwmg34XrowfHLiav82PwdTQLj6U5wchL6pTf6iceSVpHjH	8359	11831	11831	1618068780000
16439	3NKiisTTxQuKKTs6aiqtFduUehRt3cQ2wsjnek6ej7wegpgPKuAr	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1490	1028	272	6301	12388	jwzDQVVPeffaSSjnbzdVJkAQhLS1eYBDuQvCbBsoqZD6THRojou	8360	11832	11832	1618068960000
16441	3NKb3WRrApDUvmQ3QJ5mh53cezrmJSkYJWcx2uR91VboNF1cXxbk	16437	3NL8iwjyL6h7jm61uqsfBRAWyWDiv7ENCAnWx4yBPcA2gievqvjw	1490	1028	272	6301	12388	jwSfKR6Quv7Khmuyby3kai7gV9ra3DnoPPoB8ULrVjaZCjhAND9	8360	11832	11832	1618068960000
16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	16443	3NLpL7gvamg9KdHpu2tPn4sg4whonbNmSqxXBg1hAECqY8njtysH	1406	1393	272	6301	12392	jxhnwVYPXwA3KpN4wX3wA3KuVkuwBJkBMzKLXtZ3JkZ28mPMiHD	8363	11835	11835	1618069500000
16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	16445	3NKsg6kh7hfBefeLcSDSRfA75qiPr42m26PkYr13sMG8yZEnK5en	1397	828	273	6301	12395	jxSv4oXiLxGESMCkSNGFNu4cRMFmFUehR4ibFUmfvV9xCb6k3hh	8365	11839	11839	1618070220000
16457	3NLu3hUtSp617MWURR18bq3sktvYAeDurgg64xmYHu3XnjFpdPTd	16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	1542	1304	273	6301	12405	jx2XcCFKKf4dqkE49n4DKaBQ6aW5EjCqrp5opptJnXo31hYha7K	8370	11846	11846	1618071480000
16460	3NKZCdZsLASba8gZV6sLG8RrREigsHxSUFKj2n45WrUAq7FtJ6jb	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1637	816	273	6301	12408	jxsb36aDV7MHTdni4dpVCbTFkKU7VAtUMh2v4nHciH2QHs2bN2N	8372	11850	11850	1618072200000
16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	1403	823	273	6301	12410	jwac2pWxC8ejeD859cqkXudvFRL4vtXfVWxkqUB7w5T12wZ9rvA	8373	11851	11851	1618072380000
16469	3NL5qLcd4UMiiWTB9C6t1H1LoFGyR5g982jz6Stepbaf5CfZGpca	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1474	1083	273	6301	12414	jxPE7Xm4aGqq8jjzmADD4zt3hvU9BNfqdV16e9C1FAUnbRYvwWg	8376	11854	11854	1618072920000
16473	3NKrczaf2hEVNbopmqrSYQaQ4UZ7iuChcvtCGvasrCGYz9SYNXjm	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1581	778	273	6301	12419	jxFGzdNEeVWEwiudgw6CQ96ypyneqxmbgXjLqcGeV6MYawtavsW	8378	11856	11856	1618073280000
16475	3NK92TxYUQZ9Uf1Yg6pVqqJcVYwhG7nKAiTvHK8KZQ2ds3eMysRs	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1580	423	273	6301	12421	jxAQ1cLGV9UjTqkNqdbSwytS4ViCywhPsKVhaMF1sGWKyRkWkRv	8378	11856	11856	1618073280000
16478	3NK9AccikSkGjsTW29PxBBeR2gN8CkpUCJcm2QqTptNgV3SmAABq	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jxvXDz9TH3gbEYc2FeSycQv8gvo8jYMTGBJ2cA9dKRbdwUrBSXA	8381	11859	11859	1618073820000
16481	3NKcpPtoU5bcf6UgnHqdkv8DFDyCeDqyorf5sZdn89CVTBHsJnYA	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	606	1049	273	6301	12425	jy1zdWSfiPrUUnCgotWuGDB39jBuo8Hx1qBtXgrWT6NMVLS2MfN	8381	11859	11859	1618073820000
16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	16479	3NKvgzVjthFXjFVzSCc67MAegXvx1HzpL1gpmCRmuhAjCUHbXKrS	1515	287	273	6301	12426	jxyNBihtgzjGp5a7pSYqDtDMdERmTnNv5XXiCRAapVR8VNQuEGC	8382	11860	11860	1618074000000
16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	1406	1393	273	6301	12427	jxR4g732bDw6xmHGndRqP3pGW2AyB6RzDKXe5ETfPgoEAmmAbLn	8383	11864	11864	1618074720000
16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	16489	3NKF33YBCZbrsfPu94cxrGwQhmhC5EmtWBcS4PYDiu5HEF3E4f6h	1422	1091	274	6301	12432	jwwdkhxXShQ29pdQGsNDXpbKXhB4a7TsJmy6m2CKXdfnJ49JphK	8386	11867	11867	1618075260000
16496	3NLsBfAruM575veXPAdmiq1pjgPxauWjpcGqWqswQy4pihd828p9	16495	3NL51GCvqQ3PuQM7vzWUWbs9udsTnaoWbEN7HKhranS3Tj8RDrks	1610	1314	274	6301	12438	jxo5ez2nQs7EfZ3GFb2AMyzCTpbKWtPjk49sdLRWBpywVCLMA76	8390	11875	11875	1618076700000
16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	1406	1393	274	6301	12443	jwWbm5oKSpWo6vTVGeoqoj8jrYqrQNEiiKY3PyD1kbbSY7NN126	8394	11879	11879	1618077420000
16504	3NKjXkGLs2DFHK8NH4HdX7LB4P9DiqhxmmrxGjh3kFdxqwQ8oqZi	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1403	824	274	6301	12446	jxWUY8YJdpAvr2e9HfoUgCapETc2pZHmFyKDWBnoJvD1pb3vyiK	8395	11882	11882	1618077960000
16506	3NLcgrDuEwV2mwJuQ2xocVMRH2B81w2BPmiQBTEdQi2j9oazWZw7	16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	1581	778	274	6301	12448	jw8XmQK5uPFUqDrnKRZTgTHvkhMudPSi95kFDMWoUuYEM6WM2nu	8396	11883	11883	1618078140000
16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	1483	1276	275	6301	12453	jxmM4uWSTmHiu5ocWE1BTRm77VW5mdjZPUwmhz7SkiKDcKKjaQg	8400	11894	11894	1618080120000
16519	3NLjAMHJLuxomNyV22XGzrNrmVMhr1m63Cu9t7KzYdhMHc1YcnHi	16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	1483	691	275	6301	12457	jxvmyyd4WxWv7KRFymZJ3gTr7eTEN61U5JZN5DGCXQhAmxEtqbK	8402	11896	11896	1618080480000
16522	3NLVjLQDzibPgof69uS4gaZQn6cDuDUsHDCHEtikLffuak3CNAj6	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1407	1395	275	6301	12460	jxksXMHB6JhAB5jshonEYgACeNUJ5npR2NASNDS5xUxZ7WRxqFN	8403	11897	11897	1618080660000
16526	3NKkWrwvz6jwNSQFjkXDvXUoX1rTv857WJaGu5e88Ejf4iNj3gCR	16525	3NKPWNFFny8dXd3ubnHcLrg85AFbZPprqoZkEXzswNYJYZUgfw57	1634	1331	275	6301	12463	jwq55ESVtQWDPK4b91iW4CJHcajyN8By6i3WnXTRTjzKbNYx9AG	8405	11900	11900	1618081200000
16396	3NLxAWhetg7Ty8J1VwLCzE1cBBADUQpHE5bxwmdoPnNQq8WUsAdh	16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	1407	1395	271	6301	12350	jwmZjPwk832RSxRssBtUhs4W3EEryfFyuvNGV6176TvCGF4vkrx	8340	11805	11805	1618064100000
16401	3NLCcMTpcQwGLkagfra2maiu8Uc81zJNwDsAZDQyDtxDKc7byWcg	16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	58	1281	271	6301	12355	jy1JM37ZtcmEBbJrinCzSw2tc1yYPqH8gfgb11G4Qt1WCxQByxW	8343	11810	11810	1618065000000
16404	3NKGLFkxz7ewL156vAekG6X4ANfJLyjK3VJAGvitZ6eYsV76SaAW	16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	1585	1120	272	6301	12357	jw8dNhUi7Wt68AWhtmbDQtkeSCbztJ24bECz4H52qrg4mTMohs8	8344	11811	11811	1618065180000
16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	16405	3NKB9MmT3xswMc7N3CnYLoa4UqCe5N1FY1U4UmFRHrG94twZiR9j	1643	933	272	6301	12359	jwTLjMtN1YpvR6DqMprnGvZAbfHLNMKubUYUcsRw92ip7FN31jz	8346	11813	11813	1618065540000
16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1559	1107	272	6301	12366	jxzufYsKi8ZHaGQMwZNRfaR8xs6tvNe9vWiDSq9Z7NpUMiczqZz	8349	11817	11817	1618066260000
16422	3NLrxSWzyDQvW2T1tqYbzYDQvDPycCwMW3q2RnTBtyWQjkdDVq96	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1631	794	272	6301	12372	jxtzDKX9Sw3UX6hBynZJoAvcJD3GNPfdhKkU2KAnYYH5FtYcG3U	8352	11820	11820	1618066800000
16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1405	855	272	6301	12374	jxgsSijbjykGsfvvFNsHtLQtex7UrryTRMQE2qkdZHbX4x9yWAV	8353	11822	11822	1618067160000
16427	3NKLtMru2iwFbqFHp3aSbSdmmz627JD28zk37Hq7YKcMJx4qvnVG	16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	1631	794	272	6301	12377	jwYwQQnGKGrzLchFi5LcpVdhmcNJqi4kYhxydPAKPyGbYnLyuS5	8354	11823	11823	1618067340000
16431	3NK9Zbow87rtqKKTQtPcGpgNQLhncMcxrJjkekSCxubXkNDvyoxb	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	152	1330	272	6301	12381	jxmZRn2sAAYweTUAfgdahhxPtrHaSPPHBAmX4AgDEF5up71YGmB	8356	11826	11826	1618067880000
16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	16433	3NLnkZrgNbdvXCRPnX4fTozx6WnakYhnJbHJrEeKdhGACDjRAbni	1534	1071	272	6301	12384	jxjvbDGARLxxTJRMTjbbutmorSTK1kfX99zXhNUfQkLi98nbWm5	8357	11829	11829	1618068420000
16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	1619	1275	272	6301	12386	jxS9YXRMeN9PeG25dwpviXyjuLFxBYqmeHEf6oZSeArrV3p9Edi	8358	11830	11830	1618068600000
16443	3NLpL7gvamg9KdHpu2tPn4sg4whonbNmSqxXBg1hAECqY8njtysH	16442	3NLrzvHeMHsi1qJjyo4XtFmfNMFD2zYAkyTQthuYwLMzGBtMerPb	1581	778	272	6301	12391	jwM62KwqA3E2RLcmQFKzBXc2uiQnNhMxaegkubaXh8JnfExk269	8362	11834	11834	1618069320000
16452	3NLLiMvsfXZ73eGT5iJ7be1YaM8m8y2phTT4wNgTC4or2yD4K1Uu	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1402	852	273	6301	12400	jxLaeiTwoiXLYGnEiz25oBwLFdNGoQwjSuX2oejDEbmMgPkgFhf	8368	11844	11844	1618071120000
16454	3NKMBb7fGTHH8N9gmSyuzyceruzoir3cQpoamkJ5Zv45hXTY5TPY	16392	3NKLGZ7niZf4ufiiyZQmpuXbYyGkHHnN26BrKft23UwJyLkMLdic	1627	1259	271	6301	12402	jwSWLXoQemkpnur6hsaHk63oN16gtWp3mSzMXCVdeLtefRGVXx8	8339	11844	11844	1618071120000
16456	3NKEkgTbJj9t7y3NULXhqfZfQGu3t41T8y5edyrRWc7Jp8CwP8jN	16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	1649	1257	273	6301	12404	jx3Hq4JN5CTqPxMqoH8fC68V6yCUgPCgVLkyqbY81iJbBwCe4b4	8370	11846	11846	1618071480000
16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1613	983	273	6301	12407	jwFunR8oiNY1wJo6mhoLnbADvjx4TeAr9nFkrsLFRD2rbNvvsVR	8372	11850	11850	1618072200000
16464	3NKmU383pAkouEx826TXY3NiwdywH7LLSACq8wxGG3PKUqp9agWK	16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	532	1177	273	6301	12411	jwxpU8PuzYJoFLdenUgeWEZjLraky5YD9dQjvc2SEyAVTH2FeMM	8374	11852	11852	1618072560000
16466	3NK8zJAjGNGR1qSKzEaisVmjcDGhX8awjAL64i7HcvEzFAc8b9Ry	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1467	1376	273	6301	12413	jwu7i76F14zkDUGhYFtPfLtSwoyLR73pwdPaFDnptJt2WXHkvy2	8376	11854	11854	1618072920000
16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1553	776	273	6301	12415	jxFkv286LffxKMBStcfECkYPNaSn9KxD4B1PiJFPwmQMv2HuXJp	8376	11854	11854	1618072920000
16471	3NLoBtD1AWRbtiYcc4jA8a62VaYnkqTowL45XzR3EnJjah4GGFSi	16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	1631	794	273	6301	12417	jwZSM8N4awqRXzLrQwhr88trt9tCFdMQ45GtE99KZSWadEFgBee	8377	11855	11855	1618073100000
16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	1407	1395	273	6301	12423	jxbER8UCzwS4ANPqsvRxyPbXpoyqqAZnBXEEzYWXqmdrVQgfFri	8380	11858	11858	1618073640000
16480	3NKgPTjtJWeZskHYG7MDXEwADvBGxXvaKchJnT1RHNfH6C9kUJo6	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jw6tc6sadX8xUb4vvno2wPUF6tr8YHTcmXK5EWdjcxeTxusnucB	8381	11859	11859	1618073820000
16486	3NLuWyWnW2m4Cv8bscdfQvzB3paJixwW6qTHumuCp6GP3cNAPUuS	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1579	1263	274	6301	12429	jxr4uggKtWAk6iJZk5kMTEFZvTXv1pgbkTjoetX7FtuWXgmQgxJ	8384	11865	11865	1618074900000
16488	3NLFjRompA3PBpdabJxxF3U18DD2tCBCcxFMNT5mqeKnsdyytBVV	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1406	1393	274	6301	12430	jwm5t74eNwZ7hmu8gCw2cW8Z55RPoNU2eHRzSJNxLeimKWUvSt9	8384	11865	11865	1618074900000
16489	3NKF33YBCZbrsfPu94cxrGwQhmhC5EmtWBcS4PYDiu5HEF3E4f6h	16488	3NLFjRompA3PBpdabJxxF3U18DD2tCBCcxFMNT5mqeKnsdyytBVV	1506	1127	274	6301	12431	jwkYJMhi7gN6pbwKhgWqYEjtHi5PefBD973ruJejtCz9StU9d2S	8385	11866	11866	1618075080000
16492	3NLoUD1tbg1rokRSzKoMrKU8Zc1WVHV9qjrRU4rBKaiFdYfcwJ8H	16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	1403	782	274	6301	12434	jxa1RXraHb4gFRVzcoNiSiBUonY5QGrCZDRaGmDsB8jWm9zDjdM	8387	11868	11868	1618075440000
16495	3NL51GCvqQ3PuQM7vzWUWbs9udsTnaoWbEN7HKhranS3Tj8RDrks	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	1489	1134	274	6301	12437	jwmBaSP6EaWzspBRVDk6HqRzfWhuSzSfUepPTZCbT8oEkbJ5oKk	8389	11871	11871	1618075980000
16498	3NLFUgAGKUk2DaMfxx3Y19xRa6DR3awQUdwHw8mJcBvJFdQZnsQt	16497	3NKVCCwWDYGuRTsLVZdGcvbuWQCmSitS4TPutgUGDzvEJ8GVjLhb	1618	527	274	6301	12440	jxu8CU9RP9Z12QsE7GmR8onMTaCjr1FEb3VjRyTAdL6ydH7Pipn	8392	11877	11877	1618077060000
16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1406	1393	274	6301	12445	jxjnzGvMvxiaTxqwGtnQU6Z7gYwbrvGR3K9HvB5X6AMhfXrSeoV	8395	11882	11882	1618077960000
16509	3NLiuWUjSihJZAgzC8koUApi8vNppYuV1rnhWZ2DTZN1chZYJG2C	16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	1613	1349	274	6301	12451	jxLgY3U7wJZXWDSj1p2EYbfhgoGrmFHFCSz4wzMzk6913wZ9tU2	8398	11888	11888	1618079040000
16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	16508	3NKEYWMaMgVnpYjcUvJ3rtMLap1VPFTkDBq2DwP8F8Fcu6kSsgEw	1406	1393	274	6301	12452	jwqzVreRk4YkKnQrQyYPcPbnYmtwF4V5SwcdRuQ8YBTFZhu9iqQ	8399	11893	11893	1618079940000
16515	3NKrTHHSyMj2rwA2pPgupd9hxeVHuJgsTk66UYyx4ZGLffuCwosx	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jxCpc5ZJLb39CNMuzig1XMeCmFUXhSadJ4FZgnMKQYiwCknoN8s	8400	11894	11894	1618080120000
16445	3NKsg6kh7hfBefeLcSDSRfA75qiPr42m26PkYr13sMG8yZEnK5en	16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	1549	1362	273	6301	12393	jxjb6hmz3b5viaPWgrhQ3wwYzsq58QX31vggfTJPZ6EtTtqHXop	8364	11838	11838	1618070040000
16448	3NKZdFCE9WSHEGkozNmWSAYBgLTqgdANdYzh2uofNdrXGzDvYVwi	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1406	1393	273	6301	12396	jwvVACNQMP5iudNNN2dkhJTAFvxsxPFPyizJ65xSXgPa7a1fZY2	8366	11841	11841	1618070580000
16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	16448	3NKZdFCE9WSHEGkozNmWSAYBgLTqgdANdYzh2uofNdrXGzDvYVwi	1407	1395	273	6301	12398	jxczbVPDhho5Dgm94LymJ7gor8VgPkLwstiGG8SanBxBetc413p	8367	11842	11842	1618070760000
16453	3NKEncJTHfTCwUWDgf4HK2U7jfaXRRLVBKySmY5ZMDPR2pYvrn2E	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1555	1101	273	6301	12401	jwkrstGxmaVh13PUqBA56ng9RthVUbNa8gtXLLy3ppKXzEsyWJp	8368	11844	11844	1618071120000
16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	16451	3NKiViU4C4dyp6QNphYSHo8JCHMt23CPsSCeetJmxnWbpdyrPDWq	1406	1393	273	6301	12403	jx8AkiiugGisGfwTsJ9GxQ6MvK5JMr5RRenEjvhd2xB7LwRrwMz	8369	11845	11845	1618071300000
16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	16456	3NKEkgTbJj9t7y3NULXhqfZfQGu3t41T8y5edyrRWc7Jp8CwP8jN	1637	816	273	6301	12406	jxy6HTXN47nToDKmVcn4WAmdx7f8cpynQbRyrVW6AAzSbfWvUuX	8371	11849	11849	1618072020000
16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	16463	3NLgQZpMYuV9SRZBjtjr2UhwZWH2gzBoDrjJeAsUR25PCpeR3Kqn	1406	1393	273	6301	12412	jxF24c8tHfmNKGQ1xVJeZxBD1AsTYq7VHcjF8rxCHX9x1bv9Be5	8375	11853	11853	1618072740000
16467	3NKfAunMUwxUSmCboYxdZdTVGxJsLgPf3AqxihEiDK8G9zKMEAoy	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1474	1083	273	6301	12414	jxbX25K7ebym9cVBNxWnJqoF9PjVR6dP3FZpFpYDNYcwvweJQU6	8376	11854	11854	1618072920000
16474	3NLC25kemC8LfhnidkC5MfZ1nMWUnAmHNVRiaiUbQhCHZiD9kgST	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1549	996	273	6301	12420	jxYowAFsxLaoiaxeYVqbLYV8y3QgmkYzpNw5xHjcQYPbToi1ZcC	8378	11856	11856	1618073280000
16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	16474	3NLC25kemC8LfhnidkC5MfZ1nMWUnAmHNVRiaiUbQhCHZiD9kgST	1648	1038	273	6301	12422	jxvdFPTgwQ8BU15f9EjZPbgn88TWGkwC66SuJQsTEoNotpqxnXM	8379	11857	11857	1618073460000
16484	3NKn5HpehzvF45ytspFioBwdU5pzTGP5ejkSr7xzpzX4xtpACMJf	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	273	6301	12428	jxwG8gxnfpRbFU1diuHFV4Nbw9ycmJth9oZ3kG26euRbVDpLniS	8384	11865	11865	1618074900000
16487	3NLi1rtf9brvpuQ9Cxx58RJF5FjQhx748Euwf51nbH5ECUTYfsE1	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	274	6301	12428	jx44BwaquWvKX9NLK7a43S9ozsizVbBGGCBVW9A3jWNayonDjpK	8384	11865	11865	1618074900000
16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	1579	1389	274	6301	12435	jxkJzio4twcqY5TDn9Ut4Z7es5kFDVHQhqzDCFb9hqfuNNibXtt	8388	11870	11870	1618075800000
16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	16498	3NLFUgAGKUk2DaMfxx3Y19xRa6DR3awQUdwHw8mJcBvJFdQZnsQt	1609	1333	274	6301	12441	jy1ft5hevJqKSzrfDkmwN2qtBBuWkpvhtKMs5HaZQbDhSrbadnu	8393	11878	11878	1618077240000
16502	3NLbTHdUAvT65Def7BuGXr84xgqkkhukZwcQYBT2cSurrHeNBFBm	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1402	906	274	6301	12444	jxitXxA3DwiZfrcsZ9MQynfX3ugyfjuXeuvcKBGXoHEFNGcSVGg	8395	11882	11882	1618077960000
16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	16506	3NLcgrDuEwV2mwJuQ2xocVMRH2B81w2BPmiQBTEdQi2j9oazWZw7	1633	1144	274	6301	12449	jwcNZfiLDBQkgJnTrkDRii4ERNyxvSK8caMYjicd3uYAiF56U7u	8397	11886	11886	1618078680000
16511	3NKL3268KjEB1krnHZQmxbH7dVBKNCAMiYTKEzoKvL9UNY7osNUL	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	1483	1276	274	6301	12453	jwChc7iAQAVqPzrE5izgrcZ5FgWRyeBBT8dd34aY4UvWz3LDzg4	8400	11894	11894	1618080120000
16514	3NKxFiPU9SX4uBynwL48MLpSfWZnrUdXT1mHCHXNQ8VLEFH8DhH4	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jxqfphB5crCaWGsBP8XJEwtb2DACrJLgEufQX2KKdxPS1xWAy3X	8400	11894	11894	1618080120000
16523	3NLu4ykxmyBoN7A25Mef1nPZuQJmS2ra4KW9KWqLrNCCDj8BLds1	16374	3NKuAakpjeRyjZpznKfn9FXjoEFyVRz7xgiJqHCcvL3SgZgdCmxf	1513	1013	266	6301	12461	jxQvwh4dKM8UVSLvewSJn5wAHsaN3iWi6CFoBBcb9qRxU4Rhpbj	8234	11897	11897	1618080660000
16524	3NLcK7FaLXfdSJ81RUdeVFcbSJTWvYvfxaZ2YCy74SYv7vb5WiPb	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1403	824	275	6301	12462	jy2vLsfecSpzThEsF9raCWZoZvZXFiaM43txpSerEvjFxCgQaeH	8403	11897	11897	1618080660000
16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	16526	3NKkWrwvz6jwNSQFjkXDvXUoX1rTv857WJaGu5e88Ejf4iNj3gCR	1483	1276	275	6301	12463	jxK7FUP2euSdzCb3eZR5BhSmWkb2avVnByzDZmVVJGjdrazj37m	8406	11902	11902	1618081560000
16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	1637	816	275	6301	12463	jx1uDwX3a4yVZwrvcVgW3J5DiheW3K99sw25wXPQAMBazE65C8S	8408	11905	11905	1618082100000
16535	3NLgGUuwrYGLSKysffuS357Ef5W1kdyMh3ZjnYnmpvXev7nLDRmq	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1579	1389	275	6301	12463	jxziL15pr5cJQtmyY4E9sWhGpEhC7hiNn3ykjfg1Ho2KFWSMv5d	8409	11906	11906	1618082280000
16538	3NKdtVuiVTdmoPQg16XUUqsvM7YxVtCxsD979jzxzAEYxnf7aajk	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1440	1131	275	6301	12463	jxa8qgVD6SyZ2SdTH9kiY1cPsVEahyeF23UH4bFFpQ1LxSY1UGu	8409	11906	11906	1618082280000
16544	3NLmxZgsHyhSpaMdTT38g7UDrS2QTqZh72dCBdzQf6kX66fPj1u7	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1406	1393	275	6301	12463	jwALhkDgxKHZ1cga8qVHeMyP4H9AJE34GBj5wz6HGiKnPV93r2W	8410	11910	11910	1618083000000
16547	3NLW93ztdnC4SUQM5rTsv8hTngVT6H4L2AtdMyeg4nCaUGbmikPF	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1611	1095	275	6301	12463	jwgHcu2UMZJvnjLjTuxn75HbQreJwmWx282y2ArHyTTSH8hZyku	8410	11910	11910	1618083000000
16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	44	1079	275	6301	12463	jwHaRj8mUnKkrpxS6uUCDDVpXEjH2TSggz2aUSPgadnJCASko6g	8415	11918	11918	1618084440000
16569	3NKaFgzE4GdZfEX3WSsTGm4qSXiGdp4S66RmPhtZU2xtdqzVGCLU	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1651	462	276	6301	12463	jxtyDd1v6xC89pwYLdW9iVkVHMJpjG7oMdXTLVpFxLcptMLz7uz	8422	11927	11927	1618086060000
16571	3NL2GhmVK2iKPyouXvpZsNH5G21Fcgj2DQsDkf3Cx9y6d3dZnbzP	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	484	1319	276	6301	12463	jwqy5QPXCkQn5gs9w4YxjYU9a9vD5HQfZraNLqBy7uWfRruwwZQ	8423	11929	11929	1618086420000
16574	3NLgeR5iNamwqmDpTLQidLkSfSvBYqqGSPACLgQ7cWS4TMzxSF5Y	16573	3NLapShqFoCgJ62ySmDqRFXUUBN7xYJUwq444h8o8rG2CvSAkpe1	1403	823	276	6301	12463	jwaSdr1ZdZG2MiVayV3VYjtMmJNEGADXexTEzLo6B9r7yQEp8EF	8424	11930	11930	1618086600000
16579	3NLLEyw6U64J4kHEJkNPvrJoy4UMpPJVHymjGABoYCqthWJezUXc	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1631	794	276	6301	12463	jxxYrpRhUKF8BmXLtX48Mo9dqRCW9HgKwvg8LT6WCNLQzU6EyYg	8426	11934	11934	1618087320000
16581	3NKEiE6gmAGT68zhXzq57Q12q5kkwsDJS9Q9LhExSVi3pymazNgE	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1426	1364	276	6301	12463	jwDF9HQqcYCxNfY6tPLh2cuxM9QSMvHi9YoLRKMB83MU4rJqMaE	8427	11936	11936	1618087680000
16500	3NK7eYEeq6kRnCBBBjB2K3B2Ye9Ps8WqQyWReE6ATwicuqNa6yhf	16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	1460	637	274	6301	12442	jxm99KLWG3JDDpdEGTYt17WgdvLo7XPpMbSAQds1vbrUmZLXtM3	8394	11879	11879	1618077420000
16505	3NKgEWCsEoc8YY1maLqYUZB37gfBNQXhkFgWoZZdacT1gEfXBytG	16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	1406	1393	274	6301	12447	jxwnG3HcF21uX6JF8viSdsmc9AWK6ewEheHpKCGGNh9ScZgSN9K	8396	11883	11883	1618078140000
16508	3NKEYWMaMgVnpYjcUvJ3rtMLap1VPFTkDBq2DwP8F8Fcu6kSsgEw	16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	1406	1393	274	6301	12450	jwafUVg3Est6WHP5oX4rqsT2PJvLRFYdzBNhHLFSqKfjWGfN71r	8398	11888	11888	1618079040000
16512	3NLFoSkxhPuyKLgS4u8LNRUmfzjYoU8eWpy6P8Y86dVmL8nnsen1	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jwc6r3B2Ci4k7ConK3qXC4txGHYjySeAxhJSNnByrfioXZr91TF	8400	11894	11894	1618080120000
16516	3NLJTBemQSKPj1vFj7DARia9wBexNYoHfQxVCSrk7Fgf7ZAt8dgN	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1668	1370	275	6301	12455	jy22h7ucqp8WCducUXd5XDhH2oKhtLRfVeUeKKNhKDhrYkaxCk8	8401	11895	11895	1618080300000
16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1668	1370	275	6301	12455	jxsTKbq3mMkw9mp5CT1AmWWQSfNzQ7DcGyXtmHDjA3BJxwepymP	8401	11895	11895	1618080300000
16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	1608	1289	275	6301	12458	jxf91Vm2oWbewPpvdfqPBrEcBQJyHpmACaNrSZf5R1u8m99sJib	8402	11896	11896	1618080480000
16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1509	1320	275	6301	12463	jxMEJwsbPu6VDeUXLP8iTNfJb5pKnpNMMea6uuie4ePE3UfDeBA	8407	11903	11903	1618081740000
16539	3NL4bNTngbpPEz5rYAFMCgRHGjmMPNUxYaadYAqFxtWQaYyxLbm4	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	1590	934	260	6301	11960	jwEmxuKRCTuxXuq77ezmZweF7uLGqKxgKj7Tkj2yZC1SV6CrPaA	8120	11908	11908	1618082640000
16541	3NLmnXUp1TBwEZicdbXXuKvGhtQfdyS3xDigS6MGRUqSjUYEY8iF	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1590	934	260	6301	11964	jwSmxj2Ukx3nYVQiCJhBm1mc1F8opYwspABNkRqzZpJGGS2YECJ	8122	11908	11908	1618082709570
16545	3NLBPM6SpyHedsDmr1hAzbnx2Ldpn6BRzrfGkXNjUjZjKdSnX9Ev	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1451	1166	275	6301	12463	jwUBmKpr9xJrjgqY7PN4yraFS9uxRZUwf9MffVNMtDEgysH4XJY	8410	11910	11910	1618083000000
16548	3NK71LHt949XAte2pzHeZpVNuYTuu8qTYz2wzEgbcREq8g75JU26	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1451	1166	270	6301	12303	jxgexqeW6Y7VdhV2hvrBbEA4Px6nBDuyJMYFSWgxkKT3ckyy7US	8313	11910	11910	1618083000000
16551	3NKV5aruKkLmSgCRDUav4Wc5uhTGxrs8jNrSWZPNx4Y4ZiAYSiGi	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1651	1175	275	6301	12463	jxjH9awkgehWVTU13DsR3cSL3JQHbpKwKCa1QZdCVuqB9ikENYY	8411	11911	11911	1618083180000
16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	16552	3NKHDaytkuZmoQXyfcQi9ksQtVodqDNsC2V5NAkW5qzyJqJGnPPj	1637	816	275	6301	12463	jwFxVKa25zsgM35VMd7pJDaBUg3Aes7uTLBYJ1sEe94ysUfsrsu	8412	11912	11912	1618083360000
16557	3NLPzxLeboc3GxQawEnHrws1FJt1rkFxwrWnJQSAFoMFMcrDYoca	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	1403	824	275	6301	12463	jxzuPw9DVNHPSGP1maAw2Vsnv1ExKPczRcyjntBAJiAyezqeU2N	8415	11918	11918	1618084440000
16559	3NL6RjEBecoEtjurEoEbkub5nVgfnWMA3XBMZyNYZzx9bEu4emnU	16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	1501	1234	276	6301	12463	jxBh11DWtMbFSabcX99yDncJcYo4KeVJFhgVJ6iKZfbw3ZVvfWS	8416	11919	11919	1618084620000
16561	3NKWaiyZtiurss8wjZWC4gxvfgfTMvbvNwN48iPHsCaG8XATUfs3	16559	3NL6RjEBecoEtjurEoEbkub5nVgfnWMA3XBMZyNYZzx9bEu4emnU	1611	1215	276	6301	12463	jwmoGuVhFb8N6MkAGbi9p7QQ8KknZHVX69t4o2VecgvoCDuweP7	8417	11920	11920	1618084800000
16564	3NKkUGh4nWczD56aoRvrJPS7MrzRY3r5oskbDa16PQspZ7n5qvyG	16529	3NLCciucR5NYWkbjDD4V87H2DXeC9BCojWmsSBwSNutViXpZPsrN	1508	1387	275	6301	12463	jxriosAaJyd4BGobn55UzhCNtjBBH7igGspiLptcojpsnshLRjm	8408	11924	11924	1618085520000
16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1407	1395	276	6301	12463	jwLwBGtTfiFeoQUHwRc19Faex5uyr1MUbPCwt2woq6XPeqbz15p	8422	11927	11927	1618086060000
16576	3NLhPA57toFu5ZLDNRTfyd1yCCddF37VRyWjEs1QdSS21N3CHdFA	16235	3NKTEBWZktuZPt1uK99KE4UzZF7cq8EDVLr7L3UCNw5KUekH7EH9	1455	1332	265	6301	12201	jxXsKhaFVE2tNCoYwbJ9kxxardwaGX1SDCCasS1ug9P8cVh3563	8211	11932	11932	1618086960000
16582	3NKDbtSZPzwfV2dAQjBfcAZMSkXm19Ep7XBVNAsfvxNu9bnuNQ3v	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1490	908	276	6301	12463	jxD84qyPQNKLqNXPzaieoL9xBWW1JQdJqePGYvruZkYX9kNuCRu	8427	11936	11936	1618087680000
16586	3NKToPnVubDrqiWSpw5XK27MyQDF2Tnxdq5uM2rwxnjPX6KzPibu	16287	3NKLLikmxp8ADfyGskYVTWNesmEb9iR4tquvMsZQL3dRuUUHPQZQ	238	238	268	6301	12248	jxpPZuuHAM2SgFG9GJkYyaPXcWu7HMU8GmGZLGYRS15rBCfHjhV	8277	11938	11938	1618088040000
16588	3NKGfoi29fXLMPKQdSVwnak5s3i4PvsLyzYMfL29Xqb57kWaNfow	16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	1581	778	276	6301	12463	jwXgBLqERHEHKRAVbvBSrjvGjWnK6WohULNprUrVFWm6CqvKmSX	8429	11940	11940	1618088400000
16591	3NKWLCZcXyRwRB1KvnZahc2MxwfQSRMQah4qcbDH8jRySFxDJhX8	16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	684	684	276	6301	12463	jxxoM2pe2dghvxVXZCFEECY1AeTVeFu4sxzX1urZT4aceStBV9W	8431	11942	11942	1618088760000
16594	3NLLkvHgb7vJBnNoY7sdu7kGcLoVjZpFt7zp8MPVCy8vf4wyqSJg	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	448	1059	276	6301	12463	jws4WTztBzBTemtUS9NJ5HQ2iKKdcBHN3Urpf7RTCfnK5r9Gf3B	8432	11943	11943	1618088940000
16595	3NKtAv3YUC5TSe89KCjEKaQFK5SwXN7BDnpEeXjacnzN74TchTh3	16576	3NLhPA57toFu5ZLDNRTfyd1yCCddF37VRyWjEs1QdSS21N3CHdFA	1455	1332	265	6301	12201	jxq9QwWfu4sNv179JscuT1FgzKNFWsJFdLrEop9HCzJELTwRdoS	8212	11944	11944	1618089120000
16602	3NLNN8FUu35niVhLULzJ1gAAHmvGbr9CgwHZFhkVSTw4J4NEGSLD	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	684	1226	277	6301	12463	jwNHQdcDsitLktHnG7zF35PGuXx7AfVikN8qpAuCbcksbGLWE31	8436	11947	11947	1618089660000
16610	3NLmFa4oMfms2iFHwd1n7oXgM1HeP1EwwNAXR3mDrziCihGidBzx	16584	3NKfTBS1FvrZTTdu9g5fY8kzuKD6NmgKW9cWgHdg1Wk7aycxcZf8	1490	1274	276	6301	12463	jxyW5mdWZmjqLLLBCGop49KG5biZqtHEywLs6D9ig1Lmc6Q5RgJ	8427	11947	11947	1618089660000
16615	3NLB4XqWgRSkfzUEGvBzv4k8wjDrohZM5s2coFETST98wbyHr4f1	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1560	1045	271	6301	12343	jxxrbKv5Gd5xSgSpbsKGUsNKMPSWj8a7j7C15jhgj8xy8pJRmjr	8338	11952	11952	1618090560000
16622	3NKsSkx3kW5UaDd4i5KYjcpLQA8GwbQ5dYy4JfjRh7fftVGsFmWM	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	1623	830	277	6301	12463	jx18XvuTLyAQpbuYHUifiuvziFJW3jZQBSRJUA6Cjo8SJwzcVir	8443	11954	11954	1618090920000
16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	16621	3NLC5Q61EkwrAdXgg7A9wSarwFNLixGmZ9rkyQriE9bYhMCcSN5Z	1578	1050	277	6301	12463	jxiAYwpSQUJoDXdn1rRHmDT35fcYysLPxoyS2Xz9H8iADyAbj4C	8444	11955	11955	1618091100000
16626	3NKZxGHbjos2sW2AfUqnpxhj17HqMVEuVFVL2Usf9eCepWQ6Nyfs	16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	1581	777	277	6301	12463	jwuDQ5dUD6abqzBsbpGqDjvC2psaJBy8QnDvTddt372BV8hAT2b	8445	11956	11956	1618091280000
16517	3NLxw7RztqBdv5Ek9PjxMpq3QGtDJkQSbXB5EcUsTmQQTaTzMp5Y	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1440	1377	275	6301	12456	jwLrZ4Dp7e3QK3yuLuhQZyh5rWPPLcS8pFuw66b4U2nQNYYGr4x	8401	11895	11895	1618080300000
16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1483	245	275	6301	12459	jxothbq8EcA3fDqD66rykkY1GbSXar2CWwUM6SHyDh8G2SVQ1Zy	8403	11897	11897	1618080660000
16525	3NKPWNFFny8dXd3ubnHcLrg85AFbZPprqoZkEXzswNYJYZUgfw57	16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	1419	814	275	6301	12463	jxw8hjJBzJbgWKNw4qeFb9Engts36c5DBb8Cg1Cge3ZdLVAvAt2	8404	11898	11898	1618080840000
16529	3NLCciucR5NYWkbjDD4V87H2DXeC9BCojWmsSBwSNutViXpZPsrN	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1560	925	275	6301	12463	jwc8cU95yzFkN7skpUiSxYJjkkD5pVdA9Y5jdq6i1A8i7r6u2Xh	8407	11903	11903	1618081740000
16531	3NK9a8ecRQfacNUdjQMjzTL8arMmwZQJZGxm6tx1w6GNsmZVgnJU	16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	1571	1089	275	6301	12463	jwvKXDNSMNdASoeBVDZoB5VuFuCkodutYN6Fw2ttKZdcJbEhLEd	8408	11905	11905	1618082100000
16533	3NKJinzKZBeV8Z2qdaKjMa7xS7jrZv8wBMNdZbB5GyuhoHsLTVPR	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1448	1185	275	6301	12463	jxxUbPmfcYT8ArgQPwyRNjimrK9tLwDVt2ew5xA6DCvoTWLt4fu	8409	11906	11906	1618082280000
16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1448	1185	275	6301	12463	jw84U6Ww2a5bqqeB2Au7kj2ydUGAth8p5nGr6gkUwDQQR7FGg4i	8409	11906	11906	1618082280000
16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1444	1381	275	6301	12463	jwDaKUmkL8Zr4TkZAGf7Zg6XhnowHJiCFCEQ4vptWFaRr26aKzu	8410	11910	11910	1618083000000
16549	3NKfZNM6cmMN5ycaDqPEMg7QwcGbeVH228Mxph14UfxY62G5Usqw	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	1451	1166	270	6301	12323	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK	8325	11910	11910	1618083037752
16552	3NKHDaytkuZmoQXyfcQi9ksQtVodqDNsC2V5NAkW5qzyJqJGnPPj	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1651	1175	275	6301	12463	jwxss3wfaLCGCxtQ6mRD7GngfYk8WceuvsHUJ9daRZK8qfDro1z	8411	11911	11911	1618083180000
16554	3NKTg7R24LJg5xSqR3LvxbV6Q5nfhYwDYX39mXuRaXjYS1y8fdF1	16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	1406	1393	275	6301	12463	jx2A7qkrenkr2kH3mKodeR7bRBJPE52DiMwufJULHiCwXPw7K9q	8413	11913	11913	1618083540000
16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	16554	3NKTg7R24LJg5xSqR3LvxbV6Q5nfhYwDYX39mXuRaXjYS1y8fdF1	1622	990	275	6301	12463	jxgJSmkXb3d9SHCV9s3ZiLa1pX2KjcEXeGnp1BMfYsUxSbEwCqB	8414	11917	11917	1618084260000
16560	3NLbEqpH3aDyeq59Y5UkwkDfavHcX6BSMiWRa8phyLxk6T8rjq8b	16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	1617	1042	276	6301	12463	jwgRN5KDXpBXrRef4VcKNxJR19rNoFqYdVmv6fUMnDE1mkXS8E9	8416	11919	11919	1618084620000
16562	3NKqSAnJfK2ZotvsA29EQYTjCNDPmwZwxv3drGjdhybGYdBSPLYx	16561	3NKWaiyZtiurss8wjZWC4gxvfgfTMvbvNwN48iPHsCaG8XATUfs3	1406	1393	276	6301	12463	jwzn42i3M11wD6LN56UdoV1gSpeQAXmvhWqytVkKSQiEVj4MBho	8418	11922	11922	1618085160000
16568	3NKp2hnXtdEQxDa1PfxnSwKbZJKfZjmbWGGFPs6n7pzVRo55hVX2	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1651	462	276	6301	12463	jxLv84JNNPxF28EwAAzx8nq4gAw486D4TejfTCabDLD2d25j5BD	8422	11927	11927	1618086060000
16572	3NLrYqC5vExP5VeCJMyhGKc53eVMAukMtQEHCjye5q3uDcRt6sfz	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	1407	1395	276	6301	12463	jwvfyTqTir9LDdSvffcDAt6HJjmJYAMgcyQ738G6QCjZw7Yfc3N	8423	11929	11929	1618086420000
16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1619	1029	276	6301	12463	jwNN9v6CEt9pq8FdsJEAY1UzVN3icUSMqHfLKgQinp2qqvMCsrJ	8426	11934	11934	1618087320000
16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	16588	3NKGfoi29fXLMPKQdSVwnak5s3i4PvsLyzYMfL29Xqb57kWaNfow	1406	1393	276	6301	12463	jwmhFVDpSkB5Dkh8XYwtEMEmkH4Kh28DQrd7LD9JBKfCqQtfFuw	8430	11941	11941	1618088580000
16598	3NKpuYsqv8DjSV5iHwPuyDeN7VU54Qzq6yKT79T1kCQ73dkygpyA	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1406	1393	276	6301	12463	jwXJXKdJeKfyxxQuzojyx9eGDNxQ6F3JpBdarFMzn7BnUTW6Kfh	8434	11945	11945	1618089300000
16600	3NLvzt17BqsovyHiC7ShQAF5noQp67NHY121qQHsABK84cEbtfzQ	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1522	956	276	6301	12463	jwJd1v9UHRgQ8N1cxntfWX2Qv9sui64HkcakrudSt3SDpRNCzor	8434	11945	11945	1618089300000
16603	3NKFoHdxibYkBAXquXuFJgSbYJqiYXt5uLhVx1am1TgquXxF4T7N	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	684	1226	277	6301	12463	jwBNtChAbrSrHor4D6vyDM62CcFbM6yLaCG8dwyQhrjcuWCNm7v	8436	11947	11947	1618089660000
16606	3NKnHEG67HudcZYMK3djZ7Qx3DQQxgUDeGMRnGqkG8os9TfcfnNw	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1609	1333	277	6301	12463	jwgEGNyULyTa1B6FzGZ6MQ5zodU3LZ5JC32V38A1ngBvhsEhDWd	8436	11947	11947	1618089660000
16609	3NLNGYT9DaSPFYkqafSvhRTtqZi8XagBeEqEEdPzfAaRGhQURA7k	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1573	1072	277	6301	12463	jxouyj7x46FBnUyAQXf9LVV8m8EMvRuXo7mmJcDdwGHMGVB7AMm	8436	11947	11947	1618089660000
16613	3NKv4vF6TXfaZxggiYaJxQBWy2pm3ULwwrvJUvuTUv3FHUW2o2fy	16612	3NLkBNM8roKm1CPw8jnXXDvdWFba3nLvHaRdM81ij9V51sJ6RhQn	1406	1393	277	6301	12463	jwCWrx5VPCnFgN2xhxTSYvhUpcRNNQ9KP1eGxJ8sCyg8T4PNfkq	8439	11950	11950	1618090200000
16616	3NL4e9Z8quqUjMdm9N6RogRxSH9mdLjgY7DSTRF2V1Y7UtrGu7xQ	16614	3NLopZiJNuAqGcqhYVR61u2dhejKa8AafPRA58kmwBBXCLsH5Nqk	1560	1045	277	6301	12463	jwwuHVGCbQPgUG12mFN46hoA8cyMj86VLPgbvAmTntCdyVTVWBP	8441	11952	11952	1618090560000
16620	3NLBpu9wSazZdspETaXp3YBnnigAnTwzuXjJhvMU1d6eK9EB5djf	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	1547	1132	277	6301	12463	jwFV16pVHUFWrQzz4pa7xnPEqyjHfkF1mKBGZjWzUGb43G98iho	8443	11954	11954	1618090920000
16623	3NKwghUapCHoxRaghsWjNHZ8eRFku1TZi6Mgebfsqg1NicY2nmzr	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	667	667	274	6301	12435	jx68Sbf5ZcaRnBerBiCdwA45HoepdDxezsppkTJSiqK7ZU4M4Sw	8389	11954	11954	1618090920000
16627	3NLcTFewKGW4GMGvBH8JaVBjGjbrVt4gN3hoAAEZYcEzBoM1xGFT	16626	3NKZxGHbjos2sW2AfUqnpxhj17HqMVEuVFVL2Usf9eCepWQ6Nyfs	1460	627	277	6301	12463	jxTrxRrUttb2JCPpaj5KrUUvg95gecULRGQwoAeDRKyUNEyqmfa	8446	11958	11958	1618091640000
16632	3NLY8pXP6Y3o6bXC19nukbgbKegX1jSLvsMRBKSwpxQUDDrsWqHY	16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	606	1295	277	6301	12463	jxaTSgUgVhbbU9ahfubQ8Uvj9vbQZ5XKnBcBUTNF6YYhrcKf6oT	8449	11961	11961	1618092180000
16634	3NLRcV1YHTmyRLnpBz6aRhCK21gEYuMKt75uDvyeWD9B95mwc1J9	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1407	1395	277	6301	12463	jxXaGhn7uKm4aLwGT4KkN6f9dqrrpKFad4GThXfgoLQFg3puDyS	8450	11962	11962	1618092360000
16642	3NLunpLZ9f8ar2bVnPx67mkZRcUm4recK8CV289gsmS1P99Pjy39	16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	596	940	277	6301	12463	jwGDLEJmdYMXm2KRch4cpgaMeS2gDyok7GCU9pBZwFAjAZnMr7W	8456	11970	11970	1618093800000
16645	3NLvkUAGAC6CMFbGU32UcLHpzkndr4vacdjkSvJYdoRePY1ZoG3F	16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	1406	1393	278	6301	12463	jxWsLJXed9MgHYKh5TDfXpiVinV2ji8PcuhiMT7mWFdRj12z9Yk	8457	11973	11973	1618094340000
16530	3NLtgmifFVUkUSLD5jtMr9x4XwPGutJMxfy3M3hu4D8TCH7EX92t	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1471	1386	275	6301	12463	jxcWhayvhkcLHGMCATgUh9qTAD1UycwNttiZ22iG6z6HYZaBQhq	8407	11903	11903	1618081740000
16534	3NL8xySs6NYoP5HWdtiUdUqERmfHrEA2pVDbx7MUvWZAtwXRfX7u	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1534	1317	275	6301	12463	jwBL1UGsAPGVs3ASdnLjjRhWnT4229Rnf83399vuttqL7ZiwMBr	8409	11906	11906	1618082280000
16537	3NKMah83dxD232idYLSvFgyQW2uuSRJFMK6TCDwUyCWHSRDWV82c	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1440	1131	275	6301	12463	jwhPkv4Z98J9ixbkpYwv1jYkCNKBPFis4kypq9hRFGyRFepZmc1	8409	11906	11906	1618082280000
16540	3NKJCSraNtz2NCsk1owJAaxSyySAkNjsw7LUZ41bpR7Dg8rnD433	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1590	934	275	6301	12453	jxpzhj2uQPdcRz2yYhpR24QwPFtjKGXeM4xzdp2Fe7fzjx6odjo	8401	11908	11908	1618082640000
16543	3NKjHWUZKSKH1juZk4CLb5zvQF1QGePxRtXUQusWWQDyzNiYmeQL	16533	3NKJinzKZBeV8Z2qdaKjMa7xS7jrZv8wBMNdZbB5GyuhoHsLTVPR	1451	1166	275	6301	12463	jwtJq4rETW3KYvZMYtNDEAvHwrqJtmzAqcj2Je7JcG36tSiCKbV	8410	11910	11910	1618083000000
16546	3NKLhLZnKyhUX6ZPDRBdXpo8JaxQzM1Cy6pRYrvgu8qKHKhvxEbD	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	58	1281	275	6301	12463	jxB8DFcY5nRYQMiRVkrvHkjMNXpE7jpBg8gYjTCvZqzpr8Hu7SG	8410	11910	11910	1618083000000
16550	3NKN3vwusipSahvsKHHVFZRrLNVm1wwycwSjnQwuXti9ze9Sx9RU	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1406	1393	275	6301	12463	jy1vvjeNF7Bg3XxvgtRUReK3E3XNGxQmSGvBFSbAGkCs1uyynxM	8411	11911	11911	1618083180000
16558	3NKkEfgNu58XbNrPvhMKmWUGJeFpvxZxB4k6hNsbXsjAwiXUDq93	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	1631	794	275	6301	12463	jxobEtZSDHoZEaPU2gFKJgkgAodG6WFRjWNxP8Qrgsg8Hstxf6d	8415	11918	11918	1618084440000
16563	3NK8aVqxBRYdV9MKvSiDQ7d7LBgtHK7SL992ZyaEN64urdQuSgfX	16562	3NKqSAnJfK2ZotvsA29EQYTjCNDPmwZwxv3drGjdhybGYdBSPLYx	298	1182	276	6301	12463	jx1QKQP1LudWJB3UuMhVUuZxhLD4VVrWWqJHjXsoxfqRxWucoPr	8419	11923	11923	1618085340000
16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	16563	3NK8aVqxBRYdV9MKvSiDQ7d7LBgtHK7SL992ZyaEN64urdQuSgfX	1631	794	276	6301	12463	jxALw9Cin442mFiKYRCpbP8M8aNedtRrgKFvfa6fb7SA38svzR3	8420	11924	11924	1618085520000
16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	1616	116	276	6301	12463	jxSZPfyTwfHLXyjWz8P2TMy5Gboh2HdxeurgYsH7ZquMR2rmnwK	8421	11926	11926	1618085880000
16570	3NKVQWND7R3PnqDnrtv6d3zuBRn2s71R4vTu2gnN8LEnqXnKYTWc	16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	1403	782	276	6301	12463	jxEYz5njeev1uPk3N3SdL9R8WZJ9czUUmMZMrdrm8swwFY1Jmqf	8421	11928	11928	1618086240000
16573	3NLapShqFoCgJ62ySmDqRFXUUBN7xYJUwq444h8o8rG2CvSAkpe1	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	1403	782	276	6301	12463	jwKWhh6YimoktMvj9Ws5Jj3NnzhnBwxK9gKNaxVwE8sycawa7Fn	8423	11928	11928	1618086327117
16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	16574	3NLgeR5iNamwqmDpTLQidLkSfSvBYqqGSPACLgQ7cWS4TMzxSF5Y	1403	812	276	6301	12463	jxZoVAJnCFaWC8VCjTYoA28UAKdAnHDpfDVx781sz9Z4Ubr8JRj	8425	11931	11931	1618086780000
16578	3NLxU48ay37Bu8RkqvZmwv2x5QhVYX1EBiigXTht9MJZBdaNZddh	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1406	1393	276	6301	12463	jwf56gESUJPRHbEXSnoXwSwVMkTZLzjiTTp5rwKhaR6rZQ9kDVL	8426	11934	11934	1618087320000
16580	3NL33eP7ysnervmRtixU3Co3AyRdb8PVPPRzxvnvdbNSWjhCtU7q	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1426	1364	276	6301	12463	jxhe7hmdmrMQVF2yVo46ghaNcc7yy2p5WppgoeYaMoARXz3ZJWE	8427	11936	11936	1618087680000
16583	3NLrg7WAY1yMQsSRoNqUZaEqW42Cs97dC8AjLUZFjMbdDXhia5aZ	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1581	778	276	6301	12463	jxLHmrmvSAAutt9N7pB6z5qs5ZU2vVU3wZUuoPY9ySWwYdTtKCx	8427	11936	11936	1618087680000
16587	3NLRxjJm6EAEQ9p5H7ERrVckHqnXteaKZVPRfF3e6Xe5fWbngaMx	16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	1602	1003	276	6301	12463	jxq2cRZ6KSq1TTGkSL9oBd7cANQqjgoDTiEZZGu7PbrumWKCfSM	8429	11940	11940	1618088400000
16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	1405	867	276	6301	12463	jxUe811PLS4Ha5Rmq3x2yUhmBrKw1x8VCjxozD7QBwAbJa6Z4iS	8432	11943	11943	1618088940000
16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	1460	1324	276	6301	12463	jwdMpp3hvXKJ17Dor5Uv5eK6hCQQUnvYjFr3WE57K4w1mM1Bh9e	8433	11944	11944	1618089120000
16599	3NKR7eqEL1LPQiWPLGvrWAqYWRTpBTd9fV39hn3GJ9Mz2MucwgAa	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1522	956	276	6301	12463	jwJd1v9UHRgQ8N1cxntfWX2Qv9sui64HkcakrudSt3SDpRNCzor	8434	11945	11945	1618089300000
16604	3NK5BWh6vCfaEGFagpJ9NvmfidDEh1VwjgjPUgrM6YPoVEq3KgsB	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1490	1274	277	6301	12463	jwjwuzWJ9AUmZWXXL4Z5LiQJfzYBqzqXSCN93krksz8JgzmrKVt	8436	11947	11947	1618089660000
16607	3NKZc32murLvrxzGJ48EYMy3nvtM7ahCNrnn3X8oE2VL1guFGyrY	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1522	1322	277	6301	12463	jwwcBX8MW5NppNkrJgtxRx6LPej2cC7ifSbRDcUKndpZ9Tyq3bt	8436	11947	11947	1618089660000
16611	3NKXviatc5HxtwC3Aj54xS59C9N4vsmgXSDVsbzbvDJrmMhQqyA4	16602	3NLNN8FUu35niVhLULzJ1gAAHmvGbr9CgwHZFhkVSTw4J4NEGSLD	1406	1393	277	6301	12463	jwGZWpD5asjNRBr9hHDg1QV5P9iuz8tEMhUW4rJrwdxYHiCn15L	8437	11948	11948	1618089840000
16614	3NLopZiJNuAqGcqhYVR61u2dhejKa8AafPRA58kmwBBXCLsH5Nqk	16613	3NKv4vF6TXfaZxggiYaJxQBWy2pm3ULwwrvJUvuTUv3FHUW2o2fy	1622	1356	277	6301	12463	jxZMhYSgP8kgUGybpCz32p6ShSXzi6ddBMW8UiScCm5ujzsTMRX	8440	11951	11951	1618090380000
16618	3NL2KS2Ruh2NK7S9Qa6ie1eDntCBizLJgoLfzPBouZ7xqFB2pRBv	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1560	1045	273	6301	12395	jxv5Sj9oHsT8W75ppgwEZbottzEX1YVTeCQjVd1k16drbzCVDF3	8366	11952	11952	1618090644744
16625	3NLGzreTjX2uggQWsc3mRVu9RmahwYqZVJmdwLGQgfQ89Lrwr1yS	16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	563	1359	277	6301	12463	jwVUbdEXLWL8sh8mzmXkUbevACwJ8Ugqv8f47MMtQ54GpqevoTm	8445	11956	11956	1618091280000
16628	3NKQLFy8TVz1i2LiAcBB295Wjm6ih5C3DspgP2JBib1kmz89gMVm	16627	3NLcTFewKGW4GMGvBH8JaVBjGjbrVt4gN3hoAAEZYcEzBoM1xGFT	44	1325	277	6301	12463	jxKZq573TsnqkHCRj2vt911SdXX7gMs312mkbqQjXd3vMiAm7h9	8447	11959	11959	1618091820000
16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	16628	3NKQLFy8TVz1i2LiAcBB295Wjm6ih5C3DspgP2JBib1kmz89gMVm	1403	812	277	6301	12463	jwVGbWu9puQ1P7hQbMGSJwV98b4Me6n8xKimGaqYZ9kXMzmkPXL	8448	11960	11960	1618092000000
16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	16636	3NL2ea3mSh7rpawYwJUbB2qhrJ5TVW4QhrLjpk4W8Jmr1YVinvAh	1407	1395	277	6301	12463	jw8PwFDMXeXqpmMZiDvHa6PNRQFnZdrxDfwUW6u2iZSp1PB4YJW	8452	11964	11964	1618092720000
16640	3NLRcRZ9EZ29wWUDdXHR46o3kCnDRmx3mYuQZNY1vF1vb2qUy2PQ	16638	3NK811nG1hSP9MDGKfcU1Ve5oLBA8jHJGy85Qw98qfgDBmmM4iAm	1670	1282	277	6301	12463	jx6Up4gsuzV5sqVybjjcgnFiVx49G4ScacA3rNYmoQiLaTzCBp2	8454	11967	11967	1618093260000
16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1581	778	278	6301	12463	jwi3BfDKkYoJtBpgJGfh6zU5YH5KUbMakqoBvnJYkUEBfG4jP1U	8460	11976	11976	1618094880000
16584	3NKfTBS1FvrZTTdu9g5fY8kzuKD6NmgKW9cWgHdg1Wk7aycxcZf8	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1490	908	276	6301	12463	jwPFob1sYVPR4pNrZnajXHSq1gt1wwUsEn594bkpg28CgKW1hum	8426	11936	11936	1618087680000
16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	16580	3NL33eP7ysnervmRtixU3Co3AyRdb8PVPPRzxvnvdbNSWjhCtU7q	238	238	276	6301	12463	jxCzZjf689NRpTzsPDc7ncKxhz7rkg4gvuYCPfL1pY8XXEMT9DY	8428	11938	11938	1618088040000
16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	684	684	276	6301	12463	jxEiPHZ8m7tsNgyA7PhTkYVsohEKyudzLp749cNDWEdswsvuD4U	8431	11942	11942	1618088760000
16593	3NLZCVsv6QLLttmyt3mPTibUVmdQnKcf84ZAKEkruUytezNKXW29	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	1657	1344	276	6301	12463	jwD7PWiVfzddFbJiHdEFQ5DubQZjnzHvCM2JW974TRgxZFQfSHc	8432	11943	11943	1618088940000
16597	3NKnuQ5CUfZfrfYexmbms8jbGoKjoHudo9AtzBJ9tHEZQ6AfZgip	16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	1649	1383	276	6301	12463	jxmZWDAz1ufUegdF2TxjvfwWRCWSdFZQDEGJBGsmHGar3TBbLMS	8433	11944	11944	1618089120000
16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	16600	3NLvzt17BqsovyHiC7ShQAF5noQp67NHY121qQHsABK84cEbtfzQ	1608	1163	277	6301	12463	jwgfSh65Z7bDhPGobE3VafLSRt3G2USBGbDUSLPRcKiUNoBx7Qg	8435	11946	11946	1618089480000
16605	3NLfFB2LBge32F7ocCrtkRrgTHuicHWtWexYKYf1HSERosmP8nUH	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1407	1395	277	6301	12463	jxy7kacyQ1V5iD24TiKtNAVSBqzmtiZfSeFyTPkBCANPRq92xND	8436	11947	11947	1618089660000
16608	3NLBNnetgNJjNvDaY26J8fUeSxhVZ23RPUiQ1WaqMWUxwXQMjFSY	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1553	776	277	6301	12463	jxaGHLPEeuu8Fhku6Aw2ZYSQH2r4pRMEMrLNgQYHNswYQrdJ7Qt	8436	11947	11947	1618089660000
16612	3NLkBNM8roKm1CPw8jnXXDvdWFba3nLvHaRdM81ij9V51sJ6RhQn	16611	3NKXviatc5HxtwC3Aj54xS59C9N4vsmgXSDVsbzbvDJrmMhQqyA4	1657	1218	277	6301	12463	jwah4V7Tbb4rbofPFeMiZL9eanSjUAaNQsFxkMNKbH2vUJ52wDq	8438	11949	11949	1618090020000
16617	3NKs7GJwtfjEygz2eFejpCH85jf7n5y9vk7rs8wEf3bR4LSDWkVr	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1560	1045	272	6301	12371	jwXRG4TNrC75Srn8phGcvFJKjNuBrgRcfR95j66D5bBW82zZ1ZA	8353	11952	11952	1618090607348
16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	16616	3NL4e9Z8quqUjMdm9N6RogRxSH9mdLjgY7DSTRF2V1Y7UtrGu7xQ	1553	775	277	6301	12463	jxndRA5ZcMJNsqnCCYrRTCFdKenwgGtSaNtnYS2TcprXaDsDsP1	8442	11953	11953	1618090740000
16621	3NLC5Q61EkwrAdXgg7A9wSarwFNLixGmZ9rkyQriE9bYhMCcSN5Z	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	667	667	277	6301	12463	jxZhHL2FGyfYs5XsuRhdgKLDhDP2Fa5Z73CGNbaBzFyRGYsSjo1	8443	11954	11954	1618090920000
16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	606	1295	277	6301	12463	jx67QuY2sYaN7ss3omMgiWLoHSY5YKQMYpWgYHNNWMokw5kRM2M	8449	11961	11961	1618092180000
16633	3NK93cLoGmmzue724tj4k4n3kx5R8cD51FK2hfWiSrnwXqzyLu4n	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1546	973	277	6301	12463	jwWV74RRKw54eS2boYMBvaqucaagsw9SiwGrB5N6MzFcRJZj6oJ	8450	11962	11962	1618092360000
16635	3NKAeu1iWLbgKZ8HVqY81haSJgnb3tbsaAbbzpRfVUEDGRnpxKwV	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1549	1236	277	6301	12463	jwWif5sxGjJ9qbjMXvGVsaP7ZL2VfMsqzJA1QT3jkP5TxTmstFz	8450	11962	11962	1618092360000
16638	3NK811nG1hSP9MDGKfcU1Ve5oLBA8jHJGy85Qw98qfgDBmmM4iAm	16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	1406	1393	277	6301	12463	jwH8vUUa4tFNipJPTVojeoq6QJaavJH91h3PdgS99keBvpASiQE	8453	11966	11966	1618093080000
16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	1406	1393	277	6301	12463	jwCQN84D9sgr98kQn57PE4wPfemDe73xXUgjvFofn5kQsrKKSeB	8456	11970	11970	1618093800000
16644	3NLAH26x6zZsM9K7WztnjWLRXHNT81Tt7i17VQB4bWxvj7wfXjbS	16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	1637	816	278	6301	12463	jx7DoXQNmHuAsSPLaEaB1V4zGyW9DyRJJHKGM63PWuJt2DmnMPy	8457	11972	11972	1618094160000
16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	16644	3NLAH26x6zZsM9K7WztnjWLRXHNT81Tt7i17VQB4bWxvj7wfXjbS	1406	1393	278	6301	12463	jwHJrE6eRedVopkXEo1eWBgvq9P2XeKHgfsEqHuKv6DR1DRhSnT	8458	11973	11973	1618094375206
16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	1407	1395	278	6301	12463	jx6L4Rik68ZJWe3qQhzK7McdzaJy3yqvBMd7v9cpmq95RKopAdb	8459	11974	11974	1618094520000
16651	3NLJQBWRaP6VWXLgzPHWB8rokFmePgkTJseRXpuMgwz1S5Z8Pd3M	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1553	776	278	6301	12463	jxq4sfckFLCBoQu8SVaX7zRthzpFw6CNzocwrBJwPiKdn5dXTgp	8460	11976	11976	1618094880000
16653	3NKmFB1B7UkmdeqNkf4E3dzMkiKVCnEFBFxAZ23jszknzSni2Vgt	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1588	1392	278	6301	12463	jx9TowEdjHhYSizXJ7LDtrGqTp9tWhwFfUG1WxBCjFFuh3XTwzJ	8461	11978	11978	1618095240000
16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	1635	321	278	6301	12463	jwGXxymnjcfLKDh91aYCh7qZTxJek3BSMYgBYeEvBwjKtrt3rcK	8465	11984	11984	1618096320000
16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	16666	3NKJ47hnEojCY85cqQf82X4jBzzw1B8Fks2wugmJjHBZaSdZvex8	1509	1074	278	6301	12463	jxAWHZnTBGx1CWARUJ7yMHohfw97CzeByxBJ7DMF7BRKRrEx1D5	8467	11986	11986	1618096680000
16672	3NKg7fyTWmuRspRnLcKmc6pai6XGEdKePoKSEWsd8p551MKfuzBY	16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	1553	776	278	6301	12463	jwXLTqXoHY7rF7dKPba7Y1aJUWSjJwWFks5GeFJWQz34ZQZ9CpV	8469	11989	11989	1618097220000
16675	3NL8HCauwHB2fBpC4gpwqKc515BnqM2sygUanA5xcHVSpiVYpTDV	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1439	1279	278	6301	12463	jxtznad1jJQpf6SHEKtS181MXYkXD5j3VjL1Yjj7aTroBcoCj35	8470	11991	11991	1618097580000
16677	3NLspqhjPHr3mQaKLBRnewJu2dHtceHeKmoBBNamrtnPE4ahv4CU	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1631	794	278	6301	12463	jxAnEJ69tjphWyc364eZZx9M4rteuAxGpsXkkwR5i7q9nRt8NJg	8470	11991	11991	1618097580000
16682	3NLvW6PTVRT2Mfo8PdhSgS7MZUqB41VfdemHhtFXy7Gw9AwvGJDC	16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	1407	1395	278	6301	12463	jwh1JnTofa7xYmYoEcfERpVhyS8RF2ko3PUxC4pgWgMVyW7euvq	8474	11998	11998	1618098840000
16688	3NL96KTnD3d1bTgvUjNdWa1X9qs6KE3geufQR4SXhVRksSTiWS6p	16685	3NL2t8M22gEdhWjCAD4ZRGos1rZbhHv3w5WH9mmq778E1daLbr5x	643	643	279	6301	12463	jwUhjiQXd829im16q2QCGuvQXG9XWSDxQtXzAFr8RQKG96KbKjf	8476	12004	12004	1618099920000
16691	3NKeh1CZorqsb9TUcmuG6CkCSGP6bivCNFnMgEHqLQpDWWkPXJbX	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1578	1050	279	6301	12463	jxm6Ypr6wmvs4uDKWnUwBtyEJWakckMgqySH9snBXP1QcPNvKem	8478	12008	12008	1618100640000
16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	16692	3NKkiw4i441mAXeGncQa1h1UtwgErRY99DTBzMvweENRHvETyVUc	1397	838	279	6301	12463	jxpKsNmGXnjRStLn3MB8GjjjQnKYBLSE8qFAdtqVjQ71zj7AvWK	8479	12009	12009	1618100820000
16695	3NLK4gK8QSAHc2thbrWo8SYYQboCfKJrj1PhQAP3MAQjXcSc96Qf	16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	1403	824	279	6301	12463	jwhbbaerY2D6PQ6qX7LU1nubgu7CCUvr5wp9Uh2JytteN69JaqY	8480	12010	12010	1618101000000
16629	3NKMbEZgiaZPsdaUJoTcuobmKPaZFVZjQmEJYxMxjTATAFFu2AeL	16564	3NKkUGh4nWczD56aoRvrJPS7MrzRY3r5oskbDa16PQspZ7n5qvyG	1508	1141	276	6301	12463	jx6bdSXp6ewie8VxRGvC1EhKAagJkLGupxyAKSDH7RJut1Mjgyw	8409	11960	11960	1618092000000
16636	3NL2ea3mSh7rpawYwJUbB2qhrJ5TVW4QhrLjpk4W8Jmr1YVinvAh	16635	3NKAeu1iWLbgKZ8HVqY81haSJgnb3tbsaAbbzpRfVUEDGRnpxKwV	1571	1335	277	6301	12463	jwm7CmVY9dUUuj46N91WaUFrSHHiJSJaAjkqWgFLE2gFYrG53Tw	8451	11963	11963	1618092540000
16639	3NKHThymNh5pgM33obYThH6y9oGYR1ReBUffGkWBq9QYGb5uLtSQ	16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	1553	776	277	6301	12463	jwGHGPiLYNbsHuXgR4ZXNVLd7qH5QR4sw2CPwiduuemB96yTBmj	8453	11966	11966	1618093080000
16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	16640	3NLRcRZ9EZ29wWUDdXHR46o3kCnDRmx3mYuQZNY1vF1vb2qUy2PQ	1419	814	277	6301	12463	jxeM1DHVWR61v9r7ucCn9ohqLgQmwA91v5ospRveZXoSDLiNySJ	8455	11968	11968	1618093440000
16649	3NKHuVxtAAantxExA4QgwTR9iKz6xqK12NSdeGYX5E9MRapr7nGT	16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	1634	1331	278	6301	12463	jwsLACyqwxitwru5JVGEL1Nt8DJHa8YnzN8F2orMeNebxfc2YAg	8459	11974	11974	1618094520000
16654	3NKTEPYPhHZjXBTtBou5zQvXSFLktZKYmxFnwUfRiLB1dEzztJpK	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxT5C3xfLonAKpLZCwACmfrwM5fckqZEnYjZ6WthS9BiHXnXzc7	8461	11978	11978	1618095240000
16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	16657	3NKdCnwPENrToUYsPYoBfa8QDjGDFCjW8kexhJuEp4n3VbjKczFP	1402	876	278	6301	12463	jweHhJ3bPM73vaZcXhygQE4pFVSHuzEUUoVB9U6UG8RpKYMrwt6	8463	11980	11980	1618095600000
16659	3NLt9p4b5EUYA3wJo3SAoqtx8YEvoH8DRYUuNRW6czvZ1E5axFKt	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1541	1298	278	6301	12463	jw6jFUuj7aGWoKqHJm5yvLuC55YVwhriJAVb3kieCuiKYEJ4oJm	8464	11983	11983	1618096140000
16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1643	1299	278	6301	12463	jx1EvFvLsPvXF81bFjnB2HdyeB7q6WqHnJUY58auXrhPdDX39YV	8464	11983	11983	1618096140000
16663	3NKyifpPBkTyeSGuZStQJ99G4DnDxbSLdpDGExLKbbYZ9Gd2m1Dx	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	1406	1393	278	6301	12463	jxsmDmKu2HbBz9XrMeWeALp8Kfdcp7DGtiTYfiYy3FsYqaDX1TE	8465	11984	11984	1618096320000
16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1407	1395	278	6301	12463	jwre8pHMiUTtfTxrGXvyNWCV11b5GLbxBKVfzEUrrBTbwqGHkM7	8468	11987	11987	1618096860000
16679	3NLwkjqrPY4ETBxJmuatvWKnhEv7XvjrBJNiRqxcmDXbLP64aV2y	16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	1403	824	278	6301	12463	jxXfunyccm3MZLnMyd1BFqV82jMQWBe9UKu4hW5LXadM18J5pXZ	8471	11992	11992	1618097760000
16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	1457	1391	278	6301	12463	jxTvAV1rkvXCNMe3hMNu9rNCS46VwXs2jGy174WoKmA4kCRRPrg	8474	11998	11998	1618098840000
16685	3NL2t8M22gEdhWjCAD4ZRGos1rZbhHv3w5WH9mmq778E1daLbr5x	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	1541	1298	279	6301	12463	jy1dyrQC4aLoder34jEVUi3yNhZmDqrNDiyeoxyeMLE77C9EwmN	8475	11999	11999	1618099020000
16686	3NLXkRo4s7WPW3iSauoQBDp3PjFZkzoaLCwXZ24zdN57RT5coc7k	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	643	643	279	6301	12463	jwuS73DuN8mRJJPnfmom3KnapvUg3s1Db1rpWjkxuLFXazbNmea	8475	12004	12004	1618099920000
16699	3NLf2oGXeP65JeAq5FExUcCV87PJ9ktU6TagLPNLPA5aNGZMtz5F	16698	3NKnggaMX155tU6pbP7brrpr5CTDfa3fi4UdqfCVqYoWWCoSef8r	1419	814	279	6301	12463	jwCAvLxQdDn8dfxgX6QdkwYe6strTC8evPSvBJgu4mF1hU32xpr	8484	12016	12016	1618102080000
16702	3NL3rAGZpibddVNymzGZbwiiRBjSr37Ctg2udDGJksPGpn9NXL3R	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1555	1347	279	6301	12463	jxYAUiXqebb5UwpEum2bkovrwmLqYQJddKUWxUYCGhVfGfrSYUt	8486	12018	12018	1618102440000
16708	3NLS4pzeBrEyYgBZpNpk7onauYXEGMqQRKj4uw319rDeLRH8bQQg	16705	3NLTLsjf7BV2hivQ3hzeMUKoc5dS1oNNb2P7nELRsAHN29zAoieH	1471	1386	279	6301	12463	jwmhN9pgyn9MeGFLsK797TZ6MBVKNtif2Xv7uNeAqSqowxVim5M	8489	12022	12022	1618103160000
16709	3NKqte8h5ynaoh1BAoWf6vKG5Fm7RbxL2spFXRka5juCBxrPBNCF	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1471	1386	276	6301	12463	jxrYMsPYnLhytyxPVZiLExz2hq7GtcGP6XXR1i1xzocnCbQCEW4	8426	12022	12022	1618103160000
16713	3NK66deqAEaM7wbmsZuzTHau5VC2PyXxQRVGWDQPj98KCaNPwE4v	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jxrCVSPu6kBDw3AVbDiF1Kww32WWcMyARY7sTbeph2APdCAu1cp	8492	12027	12027	1618104060000
16715	3NL6ta4tTmGD2FuyETpkRR7GBhMVcdB6Urm7yPm8kc71fKnumpSh	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jx517uQPoEHZUaZdbRajgQfhLypwAUy3or6wT3LBF3xxgzK6zo9	8492	12027	12027	1618104060000
16718	3NLSoVk9Ku63NqPvRSTNo2ztLwuuMKwLSaUAZJ58ULqg3Q1CPPdY	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1440	1131	279	6301	12463	jwHZUCs5TpT5yGLMznCe3Jvesxqn2oeCnpXV8CDFBGgu6fyWV3r	8492	12027	12027	1618104060000
16727	3NLWTiKb3WSpE3Tv341uRvNkzb6pouiHycQ2oyuDKxqtLrbbZJsj	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1407	1395	280	6301	12463	jy2qQBshtJF77Ym3sFAoFw83cK2o27VRgapQUyN5oDa9tX8k1aV	8495	12033	12033	1618105140000
16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	16726	3NKaD4HZBF2iUyHZpJYpPDgeqUBZmtsFNxsi3EC93r5N1JYimS8q	1553	776	280	6301	12463	jwgN2SAaz7HfS5X5Kz4iTNwMe4g3etcDMGX6P3CRX6FvaVrAaHu	8496	12034	12034	1618105320000
16734	3NLf45CMjQcjZAd9HPDdGQQZaxukrezmtbqfhydfHrY6Ji3gFw51	16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	1447	1345	280	6301	12463	jwLrs1zsTWZmhaMuCUj1q1C8AQ3AkqDBSFfqLJS7t7AS1ZhTRWA	8499	12037	12037	1618105860000
16736	3NL5j7TEJuMTnK9RiVMyfwaWuQPDdf2cWoJY3Z2vz97VvQnkQ3Nm	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jwTRupadyRkjyiqPqsAobPNd6ubNetcnXVWqvRAbgaJdQCxwxAF	8500	12038	12038	1618106040000
16741	3NKybSVGQERdS25GAGvygn1WRuhrwgvyHCxcHqHycxNjdn1BHkKz	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1600	1372	280	6301	12463	jxBbbeY8T2dqfeDmdkKkVXWBf68hNZKBgN3P4ZtdARHLD3VdYoA	8501	12040	12040	1618106400000
16744	3NLVHjwLrcn2p1nKmnUfQ6y86wXNGW5ckwtSyWZiMohBgJHjMga1	16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	1430	296	275	6301	12459	jwBR9NX7M9P9UpXNP2Soo3Syb2HEkhUSruYpNq7QXNLjJu7g2LP	8404	12040	12040	1618106400000
16746	3NLJyDB7S9DXUi2Jca8oQVUXSicCgsEbuqGaTXjrfQviGmJAW6uK	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1407	1395	280	6301	12463	jy2WR9brcEyxa5x17vgNdR2TvEkDxpnQU5EnMqLfT3jTfbNWGfi	8502	12043	12043	1618106940000
16750	3NLFBs178ezZWv3ZAQjm38dUAhqjYRmCzXvChvQGwNe2kTKZM2BN	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1460	1324	280	6301	12463	jxjc9enQYFJUzatAGKXuhZnuDbtC1gukvPLQSAEg7X93TBfqFQ6	8503	12044	12044	1618107120000
16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	16751	3NLvAcTBsRW9u5uo7RWRoTwEkD4fGE2AaDvtB1NkupsGgUdWVsDd	311	1181	280	6301	12463	jxsRLuKitYxKyEpogAqeMnzJmQxpGwRrHMqL9xBguSNqgurWhmy	8504	12045	12045	1618107300000
16756	3NK6VgufhrQiM22hY99r7whXsteGgeCC4tRggEHWC3v98ZExCFCk	16687	3NLc2SWcwke8uFTYABaZ311tv4hqckPWuyiukfYZL1zWW8EKD9oX	1564	1338	274	6301	12426	jwx2Xm616EADkikJRhUMUPCixEtzcK4xe6xzZBhWk3NbDExLwC9	8384	12047	12047	1618107660000
16647	3NLFxaz9fPqs9Yvsf3ihd3moyPKaHMKmdcunVsJq98vu9C3XHFdX	16645	3NLvkUAGAC6CMFbGU32UcLHpzkndr4vacdjkSvJYdoRePY1ZoG3F	1403	824	278	6301	12463	jwAETPSScguyQUNXeoEVbn7RnfNpNN36L2Whm5DRWU2SDRrdSkj	8458	11974	11974	1618094520000
16652	3NKmf6axuZANzcLKdKKrb8czYyXXN1PChPYnS5AQZGCmWusxdeko	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxcKgrrEGFwHy5xcojrqCk3Uf9S8a75Ev5kfx45TuND2QrTbQie	8461	11978	11978	1618095240000
16655	3NK4J2ocfsGTsLbpLJDm51VXnj47S3D46xiT8iL1r2rwr8hXpTx1	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxL8Ed72iAWoefuMtuFYUSNeYTf7ioHcJGjTi5i8n6PbzuaxVZg	8461	11978	11978	1618095240000
16656	3NLBRyYU166BjBoys7DL5DqHehy1HNzXc5Xh8hwN4MLeSTDocfrU	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1650	1249	278	6301	12463	jxivRLNodbb8uoXi2Je6gxUP4c1pPdup3wqTPBcShXJyv69e3ia	8461	11978	11978	1618095240000
16660	3NLeDtTDgvBh4fej4FtxNAWGduLnsu5AprFKeWj16o6KCRmntbwn	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1541	1298	278	6301	12463	jxJGpfgpt36sUrg9CXY5BLaV3kiQNxUyz8YAmszMDEKmKKFy5oY	8464	11983	11983	1618096140000
16666	3NKJ47hnEojCY85cqQf82X4jBzzw1B8Fks2wugmJjHBZaSdZvex8	16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	1445	1164	278	6301	12463	jwGvnCZ5JpQoix4ZwhX1ABRFRRi3S15s6NgsUMS5LKGTswDzcEr	8466	11985	11985	1618096500000
16668	3NLStL4DhMs5dT6DwvpekH9BQwXzGpgEVkfSnFpASs8Pj1kB7xge	16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	1403	824	278	6301	12463	jwArwWjKvSR1kdUH12k8sKLy6X2sciWCrEHNyZCybFsS92sQS7E	8466	11986	11986	1618096680000
16671	3NKR5GMBxVfqA2tABAyVGuQY1huFKnJGowHv5cMmVbUWraumQzHd	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1590	1054	278	6301	12463	jxWsAqg9tLEJGtse5ajHmUa8kdcoqScyxdVEW5bey4JQARq1314	8468	11987	11987	1618096860000
16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	1652	1315	278	6301	12463	jwPqEBiqaJRxBeaxody1eQBcR257tH3p1hPFSpwSpy18bNYyQQn	8469	11989	11989	1618097220000
16680	3NK9RTkLs8R3dK5iqFMQghXtFbysBLpuQFZPiT29E4Ngdq6sUVni	16679	3NLwkjqrPY4ETBxJmuatvWKnhEv7XvjrBJNiRqxcmDXbLP64aV2y	1573	1318	278	6301	12463	jwjrK6sePdwzzxrCjnfy93QPArDwF3NkG71TdVjHCn2xjRTjXgL	8472	11993	11993	1618097940000
16687	3NLc2SWcwke8uFTYABaZ311tv4hqckPWuyiukfYZL1zWW8EKD9oX	16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	1564	1212	273	6301	12426	jwumo2sKkztXXrx82m16gi38bvwT2czYsnbAQaED1AvKhF2k9yN	8383	12004	12004	1618099920000
16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	16688	3NL96KTnD3d1bTgvUjNdWa1X9qs6KE3geufQR4SXhVRksSTiWS6p	1419	814	279	6301	12463	jxnVWFsfWKShve5rvkfzQ5AdQQhtJPKR5qKb7yAqshbC2H9Y4mm	8477	12006	12006	1618100280000
16694	3NKZranY1JZa3R8daEd8Nj2cHF2b22AMHSW2FReZPZAk2GmqaUZr	16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	1483	201	279	6301	12463	jwbeg7bC4r6Eoddduc51twotmusYufe8E7VKzy5e5nC42PHkv8U	8480	12010	12010	1618101000000
16697	3NKYaYgs2qh5qjxEV7PSDNs8AVPxJ4ZbgVfK8pyQSFtHWRf8pyZs	16696	3NKWmF3LkGn7cEFMdD5nFbfvx2iFEnnELHPGmSZ1iU8mZngcA14B	1675	1096	279	6301	12463	jwf2BUVUwHFYBoPbft4ymQ9da5VHkWB9XcupKKbW2E6Q8Haq6u1	8482	12014	12014	1618101720000
16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	16699	3NLf2oGXeP65JeAq5FExUcCV87PJ9ktU6TagLPNLPA5aNGZMtz5F	1587	1357	279	6301	12463	jx8S2vNz9VyLtvLvfYHSR8iZd44oUz1zSgB97TLVU7bsw56yjTy	8485	12017	12017	1618102260000
16707	3NLnWeR7qdKmNFEFMLKjRrU4TH1LY1Q9sgENKK2QZNk5JpaFumiW	16610	3NLmFa4oMfms2iFHwd1n7oXgM1HeP1EwwNAXR3mDrziCihGidBzx	1490	1028	276	6301	12463	jxi3aCU9HTiRrmTj2bCtT8ajtgGZ4Y455ttPaPBBeTic5TurEhJ	8428	12021	12021	1618102980000
16710	3NLqki3JsEUrWmFn698Hkz5yVcxBeLjb7WjiuWgSmxfsw3Hqkru2	16708	3NLS4pzeBrEyYgBZpNpk7onauYXEGMqQRKj4uw319rDeLRH8bQQg	1581	778	279	6301	12463	jwn9vgJ6EY1AkZ65cJuE8HgNYqpikaKF6YnqHFfcmkqpaN4CaZD	8490	12025	12025	1618103700000
16719	3NLfEZKFXzjGFiswRJmR3SjQ8172A2HvRHu9ssXHjs7DkgW1aSdP	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jx517uQPoEHZUaZdbRajgQfhLypwAUy3or6wT3LBF3xxgzK6zo9	8492	12027	12027	1618104060000
16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	641	1336	280	6301	12463	jx1Npi6BgTrPqvhtJsDMtqnTH6djeF4XvE3s4QAS6q4GY1ye96J	8494	12031	12031	1618104780000
16729	3NKdAACyLUNj7mefSnSPgk5wj2AkqjBB63VMyf6dS14sx2Wommjb	16662	3NKch96WaqyYa7eapYa7hsZs92aWUfZqCGBq9bue8A7hecRZ6B9u	576	1355	271	6301	12347	jxQ7VLqsKKARDXvdyPCQGGqZ7moXgKMcc2ogMTnqQnbQ895NGra	8336	12035	12035	1618105500000
16730	3NKL5mFzqPJ6YD5Ur3DDR8uMoZL9dnh3RgsBhN8t1ZQacQ8NeQEY	16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	1406	1393	280	6301	12463	jwCLZAdbsYrToaoMKYhowErW3uTF5XN5H3xoYKtaDrAAGo4S7nW	8497	12035	12035	1618105500000
16732	3NKbmQyP8eKdxBTzqM8YgKUksDbUKA77Qy91C92YkfVZdUNe2MLB	16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	1460	565	280	6301	12463	jwpxCuABSBm6jc3Jf9MawMoaTe3SvG2KEV6ZseVWz1utQEvT1ES	8498	12036	12036	1618105680000
16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	1406	1393	280	6301	12463	jy1XjqfC5q8ZY2J1xTxZv4SxqptqXz7TFbT7rKvUTEmtcYYhr54	8499	12037	12037	1618105860000
16737	3NLpbnAP1hKhsMxFmKZYGg3rnGCypaizZf5FgARryqWeqQcFH8V9	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jx289HbD2nPcKEWhRktanY3DEcM4czkZuXAt2ush8sR8AsyiFvM	8500	12038	12038	1618106040000
16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1571	1089	280	6301	12463	jxxnnm3MuLXkdhxq3fTQjWNtskzxdBuoj3Nzan8kFX1CRAGFJL3	8501	12040	12040	1618106400000
16747	3NLYM9RG9qyka769MjsBFuVC8sDYKHkc8dWEG1Hp7SxhmtdGyF7T	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jwozEp4gL4aPy6SU94cUK1LZtaicszn2GnF3EbgYsS1rXzdNk1d	8502	12043	12043	1618106940000
16751	3NLvAcTBsRW9u5uo7RWRoTwEkD4fGE2AaDvtB1NkupsGgUdWVsDd	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1406	1393	280	6301	12463	jwqKzCAyp32b96Npsz5SsPnMY5BNCdM9H59zXAw41umwkCX9PZn	8503	12044	12044	1618107120000
16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	16753	3NKL5EA1EJJbo4UdTZ5Ww5KFYmr8sBQnhNKHULUEZP6g8nnpmqV9	369	1066	280	6301	12463	jxthKnz2JBEfZXktu4bfF6wZSZQqCWsYAws6JMSrqkxC8TNViHu	8506	12047	12047	1618107660000
16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1406	1393	280	6301	12463	jxZYDtqwtPaaEzh25pjMFJfct3KzuZNdXBuP8oykGmgMGHKZFMa	8507	12048	12048	1618107840000
16761	3NKavbJcvNj6cC82v2NxangxyqeDGc6nJCSzsJeVcwE5t92tr567	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1503	1031	280	6301	12463	jxhDxjDHgnu8yn9N2F1hPE9AkMnGYaMYRn4isVyuTiTPt63nGrt	8508	12049	12049	1618108020000
16766	3NKcYYyA8EDT5yyyt64KXdDr1HGj7Js3A3gcAZK6No66e2EGf2fu	16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	1602	1369	280	6301	12463	jx7GxMyWBSSrC8ptRtewv4ybLvHwxcPVATr69LGAmT2HYxS74Z9	8510	12051	12051	1618108380000
16771	3NLvSHQBD26JHzxGyjgSeuwr8mHb7vKxegzVdFJkWn36Nwvi7t59	16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	1508	1387	281	6301	12463	jwYsK9r8MrvqGAYV9EuD5b7SLonVgKWqLFiPCnimzf1qmpM6VXr	8513	12055	12055	1618109100000
16657	3NKdCnwPENrToUYsPYoBfa8QDjGDFCjW8kexhJuEp4n3VbjKczFP	16656	3NLBRyYU166BjBoys7DL5DqHehy1HNzXc5Xh8hwN4MLeSTDocfrU	1506	1127	278	6301	12463	jwqwMKujfK5gZrmWT1rEUHm2LxU5kAK9dBjzZTA77LARyah9BGa	8462	11979	11979	1618095420000
16662	3NKch96WaqyYa7eapYa7hsZs92aWUfZqCGBq9bue8A7hecRZ6B9u	16393	3NK4MoPRUHCJk3kX3ugmhGzynTABhDJU9HV9mFMCZNwND5v8GKmE	576	1109	271	6301	12347	jxY1o7y4fQKVxTwHho3FpDPEbg3sww2bFnAZMaM9ve5aFLqJVmW	8335	11984	11984	1618096320000
16664	3NKDYTx2Yyr955LpXM1YBa85UTtzEnxfRCcnTTv55Qn8Qgxq8d4h	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	576	1109	278	6301	12463	jwGZUVc35RJvLwLsgEENUcFy1P5nxcswdxjrkSoXLXM6RcDYizR	8465	11984	11984	1618096320000
16669	3NKGDzp1uiVtWjzXeUhqcsg8J7ZHdjmTKCapkX7HAshtX2eLk889	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1406	1393	278	6301	12463	jxYHU65UiG7A7zuAUYcBiDMrKMoYau7m3TXSAVqsr3cydarPV7P	8468	11987	11987	1618096860000
16674	3NKgHAV1bjjteHJKjkgMjVhw7DgnNL5U9H1CYEN6hTspP8VnJfki	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1668	1124	278	6301	12463	jxNEmeyX6MnNts3JnQFitfEbb4RRubJK7rEgQYtaeCMASUsJVTS	8470	11991	11991	1618097580000
16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	152	1330	278	6301	12463	jwRYeoYjmp2FNmGVmo9gckDopWAwYh7Jt1M1h7At1oLPnQpmxvC	8470	11991	11991	1618097580000
16678	3NLTXotFbpYwQdBiDrh3Q2zb9CXvcRy8h4yN2mopAbzHJpNY9ioH	16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	1407	1395	278	6301	12463	jwHyhPub1rrAv9whjX9WfbGUkj345qbgBFHMLgBgGAi32Dbi5vH	8471	11992	11992	1618097760000
16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	16680	3NK9RTkLs8R3dK5iqFMQghXtFbysBLpuQFZPiT29E4Ngdq6sUVni	1547	1378	278	6301	12463	jwFEYEryRH3ZkR1uhvmZw93bM9Fq3TrexMmFT7Zydyngvmesx1G	8473	11996	11996	1618098480000
16684	3NKv9greAF4qS2Z27ij9CMREtdmzA4YGDdkpzqLWA95YkKs89Ut6	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	1541	1298	279	6301	12463	jxafjFPfhQb3NvHV8J2Y9xsqJov4YSXTW1ff5ANSJiJ6ufxk8bC	8475	11999	11999	1618099020000
16690	3NKDSpkT6VU4YdTeKW3Hk859YzPqbbkh1M2B1cGcN234X4epy6Jo	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1422	1091	279	6301	12463	jwRwh3psTsCgm6GmeNBAwXM2KLc6yQnA4x4Ur8EHqfesz7dpcm8	8478	12008	12008	1618100640000
16692	3NKkiw4i441mAXeGncQa1h1UtwgErRY99DTBzMvweENRHvETyVUc	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1407	1395	279	6301	12463	jx2FXxvN5SwxfDFGmfRYcb3iZYmwGDGWAuJcJNN7jGWAXb3sR9F	8478	12008	12008	1618100640000
16698	3NKnggaMX155tU6pbP7brrpr5CTDfa3fi4UdqfCVqYoWWCoSef8r	16697	3NKYaYgs2qh5qjxEV7PSDNs8AVPxJ4ZbgVfK8pyQSFtHWRf8pyZs	1406	1393	279	6301	12463	jxjUFCXkwkScSJhx8pBDeJCBrUkwUPZ43yBppYmqHhdwQD4CLgo	8483	12015	12015	1618101900000
16703	3NKNZ32Ane7ZQ4qbYo24mvnC1qg4au3Q8BzxPjgd71Rj4TSkTftt	16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	1571	1335	279	6301	12463	jxjg92wEu1y2hmhfgSGhkFToAh658JxnuEfGu3TDwpmerd5r4Mn	8487	12019	12019	1618102620000
16705	3NLTLsjf7BV2hivQ3hzeMUKoc5dS1oNNb2P7nELRsAHN29zAoieH	16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	1490	1028	279	6301	12463	jxXiwjF2BP6efjvcmt6z9QAghAqemtfeyaK12y2yZ2vqdphRREV	8488	12021	12021	1618102980000
16706	3NLjheEzzbHABKpNc6KiWtXste769EVYC3jEz2GCgL9Ni4pW2VaN	16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	1406	1393	279	6301	12463	jxg7TUe8TbRNGytaeFkgWhahUsr2ojD19RNu5ihapjwjwiTo3rR	8488	12021	12021	1618102980000
16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	16710	3NLqki3JsEUrWmFn698Hkz5yVcxBeLjb7WjiuWgSmxfsw3Hqkru2	1579	1389	279	6301	12463	jwZhvFShgcMShCBhk4ZwNFc5BpiqH8YnYFG5h68iSvshf48gKZV	8491	12026	12026	1618103880000
16714	3NLJGNBruFEkeMTtuJw7f1a9icVS6QaEv48zqfSeD445vL7wNikY	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1440	1131	279	6301	12463	jwHZUCs5TpT5yGLMznCe3Jvesxqn2oeCnpXV8CDFBGgu6fyWV3r	8492	12027	12027	1618104060000
16716	3NKycQGxcStoVqi9rfFu8PPv2H35jrdUkSprGhQL5Z5th46HaL5Y	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000
16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	16718	3NLSoVk9Ku63NqPvRSTNo2ztLwuuMKwLSaUAZJ58ULqg3Q1CPPdY	1654	1094	280	6301	12463	jwxGEDFmMRZrqLNMSqvpMYrUCzRBrr3SWDFEaAL29Fu3oBUaQq4	8493	12029	12029	1618104420000
16722	3NL4EUnS8TAeCUHePueaDyCsdVZCNmK1yg7cqmttCj7g5cyvkTN9	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1589	1040	279	6301	12463	jwYuWuCaNGoWmR1wtMq9VQZbzFLY2qHaSPTNePYgyR7byVmjiBi	8486	12030	12030	1618104600000
16725	3NKK91uJ7rYfkfJjeEHrd32PNrbJWL1v2krZSUg2qMnXbADNJqUa	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1619	909	280	6301	12463	jxhmePpzvnZW7jMUnC7TUavQ9CKMCZt5rsLWvPdU9rBYZ23bgqB	8495	12033	12033	1618105140000
16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	576	1355	280	6301	12463	jwv9xjiNit1T2wem3FfiAXXGDpbUgRdfmfsFT1XaStyMJiHQhdG	8497	12035	12035	1618105500000
16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	1406	1393	280	6301	12463	jwE6B7HeJC3SzzdpgHpsjWH2Cc4USJHYuTvb8Jc8VorGBBV3vzp	8498	12036	12036	1618105680000
16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1587	1357	280	6301	12463	jxBQDFHvf4SNqzyDs2uM83KgabiLLMbiCZ7gewS7iGtMz1xzkro	8500	12038	12038	1618106040000
16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jxDtfr1od3n55xq3EZVfkftStgWtHc3ZK2Aw59JzxRcr8eYGZNG	8502	12043	12043	1618106940000
16753	3NKL5EA1EJJbo4UdTZ5Ww5KFYmr8sBQnhNKHULUEZP6g8nnpmqV9	16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	1426	1118	280	6301	12463	jxm2tKq8ifvXTtsXFQx1YJvuCLh1S2WF7sf3CUZAskZQV1kuPhJ	8505	12046	12046	1618107480000
16757	3NKhkb4fibjVzsdfNJoNkMV7UNUCy9Kf8sqgK4UUJmuUneW4kZaW	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1472	516	280	6301	12463	jwLr9B2SmCiMgTAB2nEcsSQLn36TZrZ2NAYRC7kAPaiCED2v55o	8507	12048	12048	1618107840000
16762	3NLu2JtBJY3tpKZZssKReA9MAhcibrETCqxN3ePteKS36FVryvNz	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1607	242	280	6301	12463	jy2ek5VsxmMRrDaJkU4N6yrs1mZEonxJrYuPyNR6anxLEUQQouB	8508	12049	12049	1618108020000
16768	3NKnUGryTpGCe2pp9PxU3SzPQdQopLzjEG36pPGwP2aULScWEthv	16765	3NLdTJN8vMd2VuzakuNePQPro1iyxPk4248GagJCyHeeD18T56Rx	149	1157	280	6301	12463	jxmLQQAxvBucsf3CNbLQ7ASpzz55iCBeqKZCVR3jinu3p5M8Pgn	8511	12052	12052	1618108560000
16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	16775	3NLKo3cw9pbQHLwzYSZvBHQ7da5BXxmLjdBspBURkyJWMiTpmNok	1578	1296	281	6301	12463	jxYRC631EfJwkvC8eKDfiLbjMHDErqb7TMf7r6ihkMw3daQaw7q	8516	12062	12062	1618110360000
16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1490	1274	281	6301	12463	jxeUWW44rVws793bnNyVHm8FEjvYPrCe2z5KZDRYufADvghyp8M	8519	12066	12066	1618111080000
16785	3NK5o2UZANTDAuVkPyYhwaQEdzRKeg19hcafJkcPsQAHiz7294BY	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1578	1296	281	6301	12463	jxfqN11oJ4uoV5xKrPogz4aiHZgNU7xfqgnpeLQSJpDCyJLpTVN	8520	12067	12067	1618111260000
16696	3NKWmF3LkGn7cEFMdD5nFbfvx2iFEnnELHPGmSZ1iU8mZngcA14B	16695	3NLK4gK8QSAHc2thbrWo8SYYQboCfKJrj1PhQAP3MAQjXcSc96Qf	1555	1347	279	6301	12463	jxZLFEVCYC4JxBq9ae1fSCFtacFZMwpiDopnrTJwFKXdGu6s7Yp	8481	12013	12013	1618101540000
16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1407	1395	279	6301	12463	jxpg6f2117zK8cbAQguyZ48rZtSJDrCUpaJ9a4xvii5cXe5mbZM	8486	12018	12018	1618102440000
16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	1403	824	279	6301	12463	jwFjJbc8Kgd8tggCwCkWvEPDqBTFhsEvV2fG21wmr156ArPHTzx	8487	12019	12019	1618102620000
16712	3NL62wDdG3rik3DDuphjrHXpebSjTWcWuMBvUDALPrzvzN7DwGJF	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000
16717	3NKYmkAayR6H6W3cKK2rw6V7xRcb9nEL7J6sPJYuKwc9j9xjkyaq	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000
16721	3NKW8nkRBwiXdL2KYokicTwxnEjJbPsptimTtCn83NyFd4Qf8zyh	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1654	1094	272	6301	12376	jwguFivK42kuqkPQcr9oByLQBeyERnBLJo2dgFnqHXJXQoLRMFx	8355	12029	12029	1618104420000
16723	3NKGVpy85MDx9g7wvdtpSS9BB5XxyugoGDMYU9u95tpythxwF7Qf	16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	149	1037	280	6301	12463	jw8vnHNyfTBjRe2ENx4qxdNi3yhDkj5K5yHKooXE49GcJ5DWHRh	8494	12031	12031	1618104780000
16726	3NKaD4HZBF2iUyHZpJYpPDgeqUBZmtsFNxsi3EC93r5N1JYimS8q	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1439	1033	280	6301	12463	jxa5ftV9eWHLu914HtpQUx9eX9u1c392HM2ja376q3RxsvFcLfX	8495	12033	12033	1618105140000
16739	3NLvH6scustopRhGD3cFCwtF7zTYJJhEDRAkK5cJ77bkBJXnQgpE	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jwNFfU78dR2QzQ76UZxqEHaFtgpmQ2btcNXbN41cS7cRPsSk7NY	8500	12038	12038	1618106040000
16740	3NLMPnjcwZuBp83KAsLqHVnRRTsiTqkcPazTZa7Xqeavtbu4EKVy	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1509	1074	280	6301	12463	jxCKoBD3zCXrbSJkceUYA8TgUnhzvgcg83Rh7GqovS43xYLBW2R	8501	12040	12040	1618106400000
16743	3NKSa81b5HjDP5xcNiUJsHitiACyU6ydYPN7rKzkXMPYzFtzCpwN	16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	1430	296	265	6301	12138	jwRuji9YwmSzGBEU1TjbyKJkJW3Uo78XM3UTwZvmNMjwandG9Tr	8215	12040	12040	1618106400000
16745	3NKGxrtjkA1FshAXnxoWZ7BNnhhypnGAComQUrf8f3AxLv2ZJEQh	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jxSghqoFPnhz97VAPpkt6ebr3RUGEk6RfNk1RcLbsB8njW9WMJ6	8502	12043	12043	1618106940000
16749	3NL6JnXHDXJDnW1ReQvC659v6hJGs8owrxyLVPrExgs9TkpindD7	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1439	1279	280	6301	12463	jwGYdzzmKBempNSQ2W8TuyaE8qo2nwGAvkCRVnXsFi3hVCjEwKw	8503	12044	12044	1618107120000
16754	3NKyFgmhcf5UpZ4d4xDWCXn2bHM1SzkEdrU3kbqz27bj9DzVj48C	16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	1407	1395	280	6301	12463	jxab2KunE525xHpMtxBS8K9HtrEgHfXqdVeaSCRuFjWt42jCpt5	8505	12046	12046	1618107480000
16758	3NKXheVytDyVZRnLTmmmnJrrmFjVKyx1z7J77ebBprNVhCqwN7ZL	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1472	516	280	6301	12463	jy3Hpp91kBxXyHiMPJbD4xidsi6KUqJMebquNUGhnsD1a8q6pjy	8507	12048	12048	1618107840000
16763	3NLVLJj6UnVQwhmeWV1C5NbkQxXioD7siYH4ERD3ZTJP1F9hFYNb	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1406	1393	280	6301	12463	jwsyrC1ngrE25dccovKFyDziT9kp4Kse2pGiPeqKH4Khad1EQg3	8508	12049	12049	1618108020000
16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	16762	3NLu2JtBJY3tpKZZssKReA9MAhcibrETCqxN3ePteKS36FVryvNz	1406	1393	280	6301	12463	jxT4EJgnWq62XxV7ZzgEqHo9FWGd3YvFmTwHG5RCVbLFd4m7vPf	8509	12050	12050	1618108200000
16767	3NKjJskkTp3uvhtrFaYfCFwhxT9QR29WFZDpn6GGEjDvnqaxLzNQ	16756	3NK6VgufhrQiM22hY99r7whXsteGgeCC4tRggEHWC3v98ZExCFCk	1564	1212	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8385	12051	12051	1618108380000
16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	16768	3NKnUGryTpGCe2pp9PxU3SzPQdQopLzjEG36pPGwP2aULScWEthv	1432	109	280	6301	12463	jwXWVdk3sgJNXhHxNPSNsTeQMvqvjai1yPGC3LmsyuX9VxsNJDx	8512	12053	12053	1618108740000
16773	3NK7j3JumFVNzq7B1S3yLxBZaFwme4sPayAao7D9iqmNxT4z6d4i	16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	1406	1393	281	6301	12463	jwWPfGziPiYbxQ4p2CbyqHz3oTagocsZQa3pK8e5BZJpssPijnF	8514	12059	12059	1618109820000
16775	3NLKo3cw9pbQHLwzYSZvBHQ7da5BXxmLjdBspBURkyJWMiTpmNok	16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	1593	1100	281	6301	12463	jxAB9mzWqyTaLAksxKpVhB2BGEp6tm7LV1eM5RgvFUNtp5bzXeh	8515	12060	12060	1618110000000
16778	3NKqajKVrZfB1sAeokkwdr53LgJcAFFfGk8jFm78qW4gmdqh6XCi	16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	1579	1143	281	6301	12463	jxppsNKk86rkZ8q2eX2at2xViVugj3uutmqvsL4JgMCgByEo7oK	8517	12063	12063	1618110540000
16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	16778	3NKqajKVrZfB1sAeokkwdr53LgJcAFFfGk8jFm78qW4gmdqh6XCi	1596	1363	281	6301	12463	jxhuMaDSrVSPk3BKmK4USgAZcKqbi99EpESFcvAVt5KEShsw6so	8518	12064	12064	1618110720000
16789	3NL99Z15VL6jBFiepBemNUr7ykt2sThhpDiCsDBcnx92WMteAWcg	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1651	1301	281	6301	12463	jxUg4UneNi2uyXuTHUX2Pqss1LdFRTySgiqCLGc7a678Xpc96Zo	8520	12067	12067	1618111260000
16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	1402	866	281	6301	12463	jxxxyCTVH7bPaGBYusrb1MzKCAwSwS5F8KbHywEHvLE3birdPhQ	8522	12069	12069	1618111620000
16793	3NLmfnpq1dgrJiUsoYHNe5dMHoyyLiQf8Dh18s5fARWHtm3qoEzv	16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	1581	778	281	6301	12463	jxBa28WDtoqjEtgk3fNux99RGWK9bwPFWyej6qzrzqnSfSWCgxj	8523	12070	12070	1618111800000
16796	3NKAzmWbBKpvGmyP8bDXurfcErfgu5iSEdJfQPVo86ABGSbJ8n8o	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	80	1027	281	6301	12463	jx1WaRRVrJ37ut6ocK5wsD6tXYKUr7kmmjSoNmHLDRJZtoVyus6	8525	12073	12073	1618112340000
16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	1489	1014	281	6301	12463	jxNr3wf1MYUXGTSc3pf9UkCQyQ51qGLnMz9AQLsawS7rXTGBUpY	8527	12075	12075	1618112700000
16803	3NKcab1M2vF5GxNn4YdHcYUnXZqxSZQuuHwUrrxodSm1aRXeGyMa	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	1476	1125	281	6301	12463	jwqVTU6Q8gAFyS9EoynCN3mDd4azMEHiiY8pJXmg8j5HHsHRHjj	8528	12076	12076	1618112880000
16810	3NLqPKHtNMnRX3xSQAhtp5iW7zVDN5Ku21pJPjVJUGbWPHPC9tkg	16729	3NKdAACyLUNj7mefSnSPgk5wj2AkqjBB63VMyf6dS14sx2Wommjb	576	1229	271	6301	12347	jwKSMDSQBHF1WoYTZZPicxLHpQYgfL6JW1H5N2CuSTYWCas9mMU	8337	12080	12080	1618113600000
16812	3NL1Ft489YtY3cxM6TM98B9kHbXMjR8z4sV6DikqcSUi3PveBXqr	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	281	6301	12463	jxVnYH2FGzgQAwj9YqZMXhi4TuxMoU4Py9vp2B3HwZsUfTf4Hfv	8533	12082	12082	1618113960000
16815	3NKWZhVuRZSPJwcMxPFmNRstLKwBB63dwHnt1q6gL5ZHbUv2vSHL	16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	1402	852	282	6301	12463	jxQENZCdar1qLFmetLAud676QhmDZC58FM3VEcgazSLGGX2APKd	8534	12083	12083	1618114140000
16759	3NKjnGus3NuuHriinbEMNHJ6gNiCDsKbC3rpzTtfUiZfw8Jm4ehP	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1407	1395	280	6301	12463	jwQksU2y25t6ZK2VVy7oVURua5qXdeajquKvAv26zgDRRKDQcKe	8507	12048	12048	1618107840000
16765	3NLdTJN8vMd2VuzakuNePQPro1iyxPk4248GagJCyHeeD18T56Rx	16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	1509	1194	280	6301	12463	jwDATE74XRGVARVAc1upeMW9cG783mDH86g1cJgsjiRvvqwAQdt	8510	12051	12051	1618108380000
16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	651	651	281	6301	12463	jwJwbQee6UpeZpEfNhFUapi5wQffAvR8tRrRGPY48eStephFqFA	8513	12055	12055	1618109100000
16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	1534	1071	281	6301	12463	jwGhokZr4CFXxhUnvT1XQxGXyuvgLZK4znhhEtFUE4bJowbzoaP	8514	12059	12059	1618109820000
16776	3NKqK2dSCMJvkoNYgTpkLExxGGn4Pw3KYgZpT95CYxLdM3H3ihdx	16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	1553	776	281	6301	12463	jwPd71fqotrhWGZik6Au5orcgSN7NnycLPia33HGGhtkDGH4WGj	8515	12060	12060	1618110000000
16779	3NKeS6k4BzJL3aWP35Ee8qEHdaYzZCyvXfGTdfAq6ZvYRpnKEpm2	16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	1407	1395	281	6301	12463	jxxLVA8nohjjMpZLSs97jKtSVbUCj3C5u2CaaC64fx34Qt8smpA	8517	12063	12063	1618110540000
16781	3NLF1BwYJUXxNaDQJke6F8TZukoaJ5kroH8g8x6xb7K64nm9GHsg	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1534	1317	281	6301	12463	jxNdD8WjoMkyQKE6mc2z8dsMXssruJoPEL9QC3AmMG5MJQ2A4V8	8519	12066	12066	1618111080000
16787	3NLcZhwbKd53yEUaoKy9eNpEZT8UYRUckA9bZA2ypQbfBMzL4Hwo	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1651	1301	281	6301	12463	jxtHSATG4nzKthVuB9MYkZq83wwZ4WQWJGNJUqwGS4vCnnSSZRp	8520	12067	12067	1618111260000
16792	3NKGgydFyjwKYHuP1JrReo4583qezmoBbc6orCHnabxLJc7fBobj	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	1440	1251	281	6301	12463	jwbwsuc451t9yfvLZg5C6MrV4njdLodLvbkMscjX5RtjjedzT5i	8522	12069	12069	1618111620000
16794	3NL19daf2upubJcCucXRX3znSiqXvT8M5xN3mQztao8Mb1er2Tj6	16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	1555	1347	281	6301	12463	jwTr6HLBE7dfQMxUetquKvjw57ngGjnMZ5RRzH6mn196ZQSVXPD	8523	12070	12070	1618111800000
16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	16807	3NKVnG3Ku4b9fCdmz25ZGhJ2KRRPYjiUFw2Cen6vT114Lugkctbt	1599	1287	281	6301	12463	jwpRnRmtz1ebXxvhQdjVaewrZk6vQU1Zbc4v2WuC3pAvBFZSYo1	8531	12079	12079	1618113420000
16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	576	1229	281	6301	12463	jwWhNiwpKDLm82eUSQfu1jEiH48zgxQD2NwyVunsXMNq56gJUfR	8532	12080	12080	1618113600000
16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	281	6301	12463	jwmd8iLFMds4NrHQR9iMYeYpyhFDX53ihNy4i4uDc1MJGraj48N	8533	12082	12082	1618113960000
16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	16817	3NLkKgayRj5nJDvf9AEFjogAxejXdE9vkF53bNAH5WNDNz322kwr	1407	1395	282	6301	12463	jxsPVndKs17qDAnsZpS1RJmViUQgcojU4tifddhG3XijBdpiZGS	8536	12085	12085	1618114500000
16827	3NLRrMCYwFpYyXXbyN7XXc3n8QWqCVf1BttcPNoWP9WfTQaTVBXe	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1503	1031	282	6301	12463	jxK1uXsDokFVH9A6JKzGCmYZUQ8iHMDEQZEh9imyPnxaLEsoA8D	8541	12090	12090	1618115400000
16839	3NKhEpqCWi7i1oUezrDLuwg2koFhpmL2p2nEppnPpVrEC4kHRZRZ	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	1601	1022	282	6301	12463	jwGLtCLcDCeGoPTp3cD7fnKe9xraTXYoLsEhHximjjTRAY5eZpS	8544	12093	12093	1618115940000
16840	3NK5XDcsYskmtHbCuAUCUmDyencqzwoxKTZ4thRSp1GWWYb68EVe	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	44	959	282	6301	12463	jx2S3SXdX7DyciCWUmd9XctL4NaTDSbS4a6tfZaoda8YH6eFM2W	8545	12094	12094	1618116120000
16850	3NKq2tixfCCXA8AkTrUs1UjHA4LCnLPuJemDhSjexsFHDucZzdXR	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jxJkXV6Y4ZErKV2jSUXF7iYv5XCoxfL1qDgUu2KQd5d3j1a8csy	8551	12101	12101	1618117380000
16854	3NKAZ9ihE3pnDYu9KRrMkSo3SoMmaZHhiZyQsfr8Nbf4qy9AVW2j	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	606	1049	282	6301	12463	jwygMBFDUJRx99xhk9h9V1YR6CUZNvEjwWYoqnFos1KaUuNH1Dh	8551	12101	12101	1618117380000
16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	16854	3NKAZ9ihE3pnDYu9KRrMkSo3SoMmaZHhiZyQsfr8Nbf4qy9AVW2j	1447	1219	282	6301	12463	jwEkhMEVtaHazXWYsbk4LVG7sVn88J3xHm8WK6zttijZZrRj8SB	8552	12103	12103	1618117740000
16861	3NLmx48Adpc6HV9Jw3AXH3eKpyEf2A6KZnNBHUDCgF2s41ytjMsY	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1646	1354	272	6301	12387	jxD5CBebZEVQ1c3ohc1N8CeZRkuZhYvTw4b4VZiqP5Se51R683o	8360	12103	12103	1618117844479
16772	3NKqwZjPAHEdqEqkGeNMokrGcyrjfWuCPLjJd2c6dTQ2rESn5Q6V	16629	3NKMbEZgiaZPsdaUJoTcuobmKPaZFVZjQmEJYxMxjTATAFFu2AeL	1508	1387	277	6301	12463	jxjAcF7orRXa4SbyWzEUf5J3Kuyv84qMMTSYeggoJi5Bn3yw9Qk	8410	12055	12055	1618109100000
16782	3NKFhn5uMJfQGqAungcHCwC9nMA5HsrM1psfS2ZyMXBNhvfNBxoP	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1407	1395	281	6301	12463	jxBsQXopVPuk3am8aiGrzQbu6ycDgP4snjARhuvF5ua737Wx4gD	8519	12066	12066	1618111080000
16784	3NKXP61KBLST9kGEAcMcU2y3CJ8g2w61pkVnxUFNBajJgWfcMp46	16707	3NLnWeR7qdKmNFEFMLKjRrU4TH1LY1Q9sgENKK2QZNk5JpaFumiW	1490	1274	277	6301	12463	jxiTrn38DeKvFRNhVfg9yER9ywcu82WnTJ28pCM2WJkg6tZz9kf	8429	12066	12066	1618111080000
16797	3NLvjjGUCsMf9Ui5HAamqp78cJ7RkttHBCPBUCUL16Bzk1W3LD7K	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	1406	1393	281	6301	12463	jwED3ytaECa6uNEjhe9VifJk388n7RtB675vwSGrWp81m79G5UY	8525	12073	12073	1618112340000
16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	16798	3NLUM6frJYMUascAcvpHJfmCTymzoHacU8CNnP37jodeedocw6zc	1670	1036	281	6301	12463	jwTuY4Fw174mmaR36mm26UUPF2VUJp7tJ75ibf8RcrkRjssTdgQ	8526	12074	12074	1618112520000
16804	3NLZEDESvbrCfMjBkcM424urPbyCvcXtsSA9mhPJWZmA9ZNT5hvg	16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	80	907	281	6301	12463	jwuW83ZFKbLChjqZwpGwLyBnXgyey6hvhB5wM7hFW8BWpgYP6x9	8529	12077	12077	1618113060000
16806	3NKUVkup1QFJ18b4YqwQtqTWzLqjf6zPK5LJgBBYSF18rLcsr4ub	16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	1648	918	281	6301	12463	jwjwi2Fgd3D6BoSzRiFjWG8AUxVejDUqqwDp4VUCVMt18S67sZ2	8530	12078	12078	1618113240000
16816	3NKXuUbEekLgwi4m8rJGw5DhqYP6ff19e7ALmnTM1TSYLQHMZdC8	16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	1611	1341	282	6301	12463	jwbxd6tuMuPMgczpD2gPNbxeaL7oxZN3V4F74gTBLvX6wo4Sb4S	8534	12083	12083	1618114140000
16821	3NKmgLysM8egxLdNrUzoGqe29jmXoRNMX2avpRdvqpnPgmWZjC6K	16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	1406	1393	282	6301	12463	jx2GXgB8BvdHbhwdnG9Vt4TwnreWEbBke7pfxiUjAse3ndazRWx	8538	12087	12087	1618114860000
16823	3NKRSooWcBPByjTTFqK9ha7JiZ91xLJM1QL7MABpjnuPVE3BVv5w	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	1587	991	282	6301	12463	jwkVgemHJTAwZTtE51mMDwLUMyfdrog9ATXuu4SNQqtXkKC13xR	8539	12088	12088	1618115040000
16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1627	1385	282	6301	12463	jy2mhYj57sAzaedV6XvQE6XnCSz5kyRGxMmaq77WkzE2Nk9Lw9T	8541	12090	12090	1618115400000
16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1448	945	282	6301	12463	jwAgvBR5mY7GTbhH3MgLnF7Djx8gf6RQEMSjWd1E4gxzzQcnGgn	8542	12091	12091	1618115580000
16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	1668	1370	282	6301	12463	jwDocYRTnWsEHAmd7bV7LC5CSZXcA5hq3S1S5LkguCzL3yc9dut	8543	12092	12092	1618115760000
16836	3NKRddawB3Dq2V1yvmd9KaD1Vgoz43F1AGdF1aHm3FxkfUSWVuz1	16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	1646	1228	275	6301	12463	jxhsDe8raDuJwtJzak2n5RMf3T9hkhNd4by46NQ48kwDJ8EPBSC	8413	12092	12092	1618115760000
16841	3NLtGfxwWpCEGEJ3rAbMWpHNzmcEuL9jk3GtoJCAcysRzjw3YhLg	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	152	964	282	6301	12463	jwNQEzv4Tga5VPzmSK5pdhipk6kQdag4Fj6BDKFH8RajT1Wu4Cw	8545	12094	12094	1618116120000
16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	16842	3NLX36LD5E3dbuwDv915qA95dycPJY3t34S9LVx3BqZJBbWTq5xU	1670	1036	282	6301	12463	jwBkrL4P9RxSPvPwbSwjjCNAiDrjvsUJuUnNUcJ8VbdDZV8L4Fr	8546	12096	12096	1618116480000
16848	3NLDyUkLDCHmEaw3SZbXH1CB7zYasZ22cN6xMakeAja9U6kMXt4b	16847	3NLsJ23ZidsRkxYJQaBMWeK4vQ95md5E4Fdwt75DMPPsTo1K17P4	1581	778	282	6301	12463	jxS3aou4iRQCFCR9sCLwYANmM9qxr2qrNLQV8yY9fRUAUQCpUVX	8549	12099	12099	1618117020000
16851	3NLpaqrxMMdTMDwWfr6HZJuRKcBMsTWzwrZFP5qsNaPnJ1EqDuic	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1407	1395	282	6301	12463	jwjtTaDG4H8PzN8AmMDYEsUcsHUkiym87FupE3jRBArKuTnYefW	8551	12101	12101	1618117380000
16858	3NKRLuh44FgcPK6NYPiw6k5Xe4FivQyZseCaoUehni4BAdoGtpCe	16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	1646	1354	271	6301	12342	jx5WcEyRwgxFdbav7F522y6CP5SqhFDztmcba8K2ReDQoDkmXYg	8337	12103	12103	1618117775582
16786	3NLC18CiXSMRiPNCejBDqJXBWTnqazk9pgfSs8YmumH77Qqg4xDJ	16523	3NLu4ykxmyBoN7A25Mef1nPZuQJmS2ra4KW9KWqLrNCCDj8BLds1	1513	1133	266	6301	12461	jxUsLJafQoFA69yzM4xGXWXtd8syZFzd42cPDdKiT9RrnqZTQRV	8235	12067	12067	1618111260000
16788	3NKMfhd4kpm1UgV317UL9wBEvKUdpWZ1RxpReCqUoMTTi2HMVm2f	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1633	1390	281	6301	12463	jwBZNEtBtV1ianrmYHQvaGXqGQKCVu9THG1ShRgxg1QPqB7DFQc	8520	12067	12067	1618111260000
16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	16787	3NLcZhwbKd53yEUaoKy9eNpEZT8UYRUckA9bZA2ypQbfBMzL4Hwo	1522	1196	281	6301	12463	jwkwBXozP9Rkwca4fXiv2XjQCw3rhrQ9M8aR5BtAnPrqWdrCFYC	8521	12068	12068	1618111440000
16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	16794	3NL19daf2upubJcCucXRX3znSiqXvT8M5xN3mQztao8Mb1er2Tj6	1483	1150	281	6301	12463	jwPWbEhuCGKhhGjFREoFrUa9Embaf875dGRCpMJDZJSeMvnJ2JB	8524	12071	12071	1618111980000
16798	3NLUM6frJYMUascAcvpHJfmCTymzoHacU8CNnP37jodeedocw6zc	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	1553	776	281	6301	12463	jw8H6S146BjRun4Pt4HFJ6dYtM2Rz9onWUTa6iVBTgtCL28JnPu	8525	12073	12073	1618112340000
16800	3NK6C1gDU8L4mhtViL5ijQ1Ggg3Gc1oLKqkyfvgr2HECsrj5UxSJ	16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	152	1330	281	6301	12463	jxAuAHYk6cNm2Xa7aDbo1ba1CM5W9nckyAJ7Jdk6Ew5Lgp5YYef	8527	12075	12075	1618112700000
16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	1407	1395	281	6301	12463	jwomKo3YTi2gVa6qHdiqKapasGnyRFYXoX8cqp3etTcBDgmpZs2	8528	12076	12076	1618112880000
16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	1458	1323	281	6301	12463	jwMpCE1V2QgNNedtQ9vXMfrnZ6kAaaERidxkadaMvSnBfwhksNN	8529	12077	12077	1618113060000
16807	3NKVnG3Ku4b9fCdmz25ZGhJ2KRRPYjiUFw2Cen6vT114Lugkctbt	16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	1573	1318	281	6301	12463	jx7Xxbegjc9arTNMwEkoQazJGHoqkTSkvrQBy57nrmjbyhBmogC	8530	12078	12078	1618113240000
16809	3NLv4iuXKXn6tt4PZQwpwTYmeyMwcJLJL2idgUL3gf88i5JnBHfK	16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	1637	816	281	6301	12463	jwAWpnpkDeivUGcPW5biEV7aRYhZWahWSB72eqtEq3vAjq5fgmM	8532	12080	12080	1618113600000
16814	3NKm7t2RcuTyRfDn63X9djRy26CWGQNbs5pFe2UyABHr96H9CYuq	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	282	6301	12463	jwwFoZFyJCcrMoiDaFnTUzx9UAtkv6ka2kpqANuyRgtEbFxSZkp	8533	12082	12082	1618113960000
16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1407	1395	282	6301	12463	jwHiEHAjp939WA74ewxngpwUHXw1r8zpj7x17hLixe2eFsoTYAP	8537	12086	12086	1618114680000
16824	3NL44DpnF73cH6JMtiiRLNH7mGkHdQ6atb7QjCSaKaoLm4kxiKQp	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	1402	880	282	6301	12463	jwXshaKrwNqmZBpimrFyBp3FpD6mfNedZZB25Y9g4FsRhX1hzmM	8539	12088	12088	1618115040000
16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	16824	3NL44DpnF73cH6JMtiiRLNH7mGkHdQ6atb7QjCSaKaoLm4kxiKQp	1643	1299	282	6301	12463	jxUbbuUApC3wLiGamnwaLLboBnLCqF8P5oo5vWdtEazMkbTzSro	8540	12089	12089	1618115220000
16831	3NKGCfuxN25dhbuQAJeSQyW2JuFduGNLhx2b2rtuy3BR3TuMrmUu	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1439	913	282	6301	12463	jwdkWN9msyjC8uzghLgm2tP7mvvxQTxQwGN6bxixtDh6kFj1oVn	8542	12091	12091	1618115580000
16835	3NKVZCjKyWEZmtFG7fXd43QZakNoZaD7eReGUpBLTxW3sy4SzPnD	16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	1406	1393	282	6301	12463	jwgmaZDroVzGCfYV3urfRZ6hwsHdVFSbUwTq5oxx7oqweqtzKYK	8543	12092	12092	1618115760000
16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	80	1273	282	6301	12463	jwLYQrH7eRLX1q7FDrCzESU8mZvBhhfxU8cXH6snAbBoBeG8oF5	8544	12093	12093	1618115940000
16842	3NLX36LD5E3dbuwDv915qA95dycPJY3t34S9LVx3BqZJBbWTq5xU	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	1406	1393	282	6301	12463	jxJUMzRqW7DM7XazPCVBi6ZQf4GgA5dzQqzVEJEVydnN6AW1VWP	8545	12094	12094	1618116120000
16844	3NKGWUBfJcuSbqpA8XJBCeLZdNudDGf1RHVVv1wjSy2dQRrgRQkt	16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	1613	1103	282	6301	12463	jxWdQiwszh6NMn7eDpWrHfDb3Pqs974NxSbE1JSUeULcdzMMi3A	8547	12097	12097	1618116660000
16846	3NKpQjKQum2zQxfbCWkTmKMPzSfaJDfNTWyZQpwD8ggiNHU6URVa	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	1596	1363	282	6301	12463	jwhWoUgMSi5E3EUTodpLLiAV2PjpaRzR3khb26kwjio9WiV3upR	8548	12098	12098	1618116840000
16852	3NKDaLCS398L5suxUhQSP8zTJ65utPN8QDGmyCH6cwzYjiU993nC	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jx569EazUcuAQcEKKTHUrGP2v4SBu7CerHXcMS5pf1YmuJZb681	8551	12101	12101	1618117380000
16855	3NKyjYMBtDPk58Zt77NYv2YKyQQhBkdC89ySACepGoCZMdk8pwuP	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	606	1049	281	6301	12463	jwAuEBKxgzafeTPHxYxnvpFj7CF6uwwAy8kt7qDfnZVAojUU8ge	8528	12101	12101	1618117380000
16856	3NKCZGBBMQwMHVPCqx3qPtQbtgFQqkNzV8LG2D1rZ9C44zwg1yVv	16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	1646	1354	270	6301	12321	jwQHc6nChGFbG2YjYHCmWTX7bvBUbrEF5fWHk31h8wph2pey1RY	8324	12103	12103	1618117740000
16859	3NLQppTj8jhJe64feokC9xCYaxdLQvCevpAyCwzg2GMfF88QUf4Q	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1646	1354	272	6301	12362	jxXtQrVYSHG4uZxysA1uVFkt7CtqkNoYChz37Hj3uTaU7PreNrX	8349	12103	12103	1618117810466
16860	3NLJTV6Fqz3ZAAgm3qsFhvr52By2j5FWvGcxuGsU427bv3nTXYeW	16836	3NKRddawB3Dq2V1yvmd9KaD1Vgoz43F1AGdF1aHm3FxkfUSWVuz1	1646	1354	275	6301	12463	jxhsDe8raDuJwtJzak2n5RMf3T9hkhNd4by46NQ48kwDJ8EPBSC	8414	12103	12103	1618117740000
16862	3NLD7WnBwmDiQ9L57nQuXC3vhLtQ9wWvvHSSFKC4v3JmNG5mGLKZ	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1646	1354	273	6301	12406	jxJfFv43wAfsKJiFfDu4XbbaqeFiXTYwzY7T851JY29UdADr1sR	8372	12103	12103	1618117880291
16817	3NLkKgayRj5nJDvf9AEFjogAxejXdE9vkF53bNAH5WNDNz322kwr	16816	3NKXuUbEekLgwi4m8rJGw5DhqYP6ff19e7ALmnTM1TSYLQHMZdC8	1461	1271	282	6301	12463	jweQfiTDvGKDotU5Z1E6tx2ttUYKd41Jw2v3krYyebvBqkw9xJX	8535	12084	12084	1618114320000
16820	3NLjF7TuA1eoANd1x55jUv6XdSc3XHnca54XR3UJDG9WbWrMtPRb	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1440	1377	282	6301	12463	jxw6HdysbFDkSwVxWBNx3JnEagcMC2oGqsiHzYn4buvHMTc7BcA	8537	12086	12086	1618114680000
16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	1631	794	282	6301	12463	jwH4SJYcZxYLXW43kbYy4H6jwXP4aEYWwFvnwVyDC4krguRWP6F	8538	12087	12087	1618114860000
16825	3NKP8EbGRupJ8onNGpvwEHG7ev1JJGv5YgNw1BK3oVX7qQUb7wru	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	171	1374	282	6301	12463	jxc8fmcAjBtRmbkCrY5jMtiuQfXFuHnkZk7yTy7bLzuD5SABduc	8539	12088	12088	1618115040000
16829	3NLiUbuHGv9PKPAzmdMTcjxEvFXJaJgNsLEU8hGnMpYrrt8VxZJA	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1611	1341	282	6301	12463	jwXmkhZy5HVioL1XXTGXzNXKGt3gDpsW1g5ckp92jozgPD7PziR	8541	12090	12090	1618115400000
16832	3NKdzSrGEkChjEVuZMgvCaYtmvhYThHckPg8NBfEdPuzYR4PDnh7	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1448	945	282	6301	12463	jy1wP25su7vRnrXScsTiVYGmZ6c1RVjhXWzDryPKgnMGR9ezdwx	8542	12091	12091	1618115580000
16833	3NLHMD2zxkp3xLFJK7VgidziWQw7wxofxhoBq3Q59PbwoyeUeXXX	16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	1646	1228	267	6301	12213	jxhQQLkRoFU8EKjw6v7YojKbiEN2N67oTieDmM5NoSYDPCHWr8g	8259	12092	12092	1618115760000
16838	3NKgKqnSyoSRt7whuX52fTDyfjhUNh3jq7QwQbkMaQrPg8vxSnWh	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	1506	1127	282	6301	12463	jwkEKdBSECKubX5vgYMS1xc67RemoHxmX8zG48n46MYbUdNZHMD	8544	12093	12093	1618115940000
16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	1672	1159	282	6301	12463	jx1mdPQmwxhfzcJCsmDAFeGvWXoS1TQiRSUyrXFYsYuqCSbzdZZ	8547	12097	12097	1618116660000
16847	3NLsJ23ZidsRkxYJQaBMWeK4vQ95md5E4Fdwt75DMPPsTo1K17P4	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	1634	1085	282	6301	12463	jxDrtB6nVWZfRhK9aDF575g6znrtAMudpTcWE2a9b74nSSyUruX	8548	12098	12098	1618116840000
16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	16848	3NLDyUkLDCHmEaw3SZbXH1CB7zYasZ22cN6xMakeAja9U6kMXt4b	1610	1314	282	6301	12463	jwYGqNGPfASqsgfqXewPtj2yu8J5bqYxQRxRUk9Y9TcQ2u4ZzUC	8550	12100	12100	1618117200000
16853	3NKuw3guPncyJ39QvnBt1WJvYWHwa18aRnWCgZNDmPb2mTcopwCz	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jw9hevqJbTG9oeLrHAiapUXJKsydL3hF15hHjsHtks5Tck5EZXV	8551	12101	12101	1618117380000
16863	3NKkvJekcJnn51efqjp7GxMAsCbXLgwDsLJCPcKtcA84T1fQNb8T	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	1654	1340	282	6301	12463	jxDDrNUqRpvxLzAXguEkG59NDUTMBcqsZPqAiQV6r3ED5BfGPyB	8553	12104	12104	1618117920000
16864	3NLgziZh2vDLQ5Rwme4jPesw47CPK2a18gsYkB4H6KqExLocymVJ	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	311	1307	282	6301	12463	jwnLgwvgC7hUPKzQX4U9kYqVERZjxHuWFnfNYTjLxNML3NwCD7o	8553	12104	12104	1618117920000
16865	3NKqSatPNgcyPbznsAGAaNbVnd8FhnHk9Y2yzWf2ZrW89xvWJBYL	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	1633	1144	282	6301	12463	jwz73VoHW5n45QXJve17uhsSvnNqNadnAGGdG9uRMnRzSkSDZxj	8553	12104	12104	1618117920000
16866	3NLMqnWKEiEHQwVMacyx44DgVxt6mjqw7Xn9Hrt2ysXszY6w1mJQ	16864	3NLgziZh2vDLQ5Rwme4jPesw47CPK2a18gsYkB4H6KqExLocymVJ	1406	1393	282	6301	12463	jxTUDFkoLL5MKFpSu5fALJmm89edgWHoqmnqjbgN9DBDDECkUg1	8554	12105	12105	1618118100000
16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	16866	3NLMqnWKEiEHQwVMacyx44DgVxt6mjqw7Xn9Hrt2ysXszY6w1mJQ	1631	794	282	6301	12463	jwH6EPqwP5Veefkoriok6WKcFwEWqVUdH4hSUc34HduVceST7Mw	8555	12106	12106	1618118280000
16868	3NL4dFLh1mizK4CAB2jCx3BEiDqMCzLa7Surnsb3Txcaicmumq4J	16709	3NKqte8h5ynaoh1BAoWf6vKG5Fm7RbxL2spFXRka5juCBxrPBNCF	1471	1386	277	6301	12463	jwT8QM4VqLhNsp4Ht5JaxmTbYsdGqj4HK5dXZKt5MgjrXuiGXEn	8427	12109	12109	1618118820000
16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1581	778	283	6301	12463	jwxfeabRrzU8cD6qX8mLMp7T2A1ekq8uEkzHMR9cXfWUJWJZ699	8556	12109	12109	1618118820000
16870	3NLjf2CY3PChZteqzyo2boVGV5GMiDpe8622tqhFb7b3GVybvV3x	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1471	1386	283	6301	12463	jwEnP2CNxGD9yzE36f9fmUpJjrQVPXzZtjo6vB9AdD2Z8GmdY7f	8556	12109	12109	1618118820000
16871	3NLSg1LR2TfmCKEuEHHwhExddaEeYit26m8W6XuVzmDEsQ8y5TbR	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1471	1386	283	6301	12463	jxkunzaoHhZLdLHmaYgqL4GSDX8eZuG9hg44LEYi15wPu1t2M51	8556	12109	12109	1618118820000
16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	1407	1395	283	6301	12463	jwUKsEiH5gKpC8Sky6fpmFDUWZwdWAA3prpXcenzbiQq3UVQaAb	8557	12110	12110	1618119000000
16873	3NLSdRczbhvmTWu8pH7PFQiRoqERrtWd2SBDnQHNHdKtqtAuupsB	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	1444	1135	283	6301	12463	jxbjnhe36fuQY8ZZEn215QCi12zsmF14UXTRywCNeDAK1nDNzmQ	8558	12111	12111	1618119180000
16874	3NK3qGWkacZ6kQNSoFj7inHXQEYPg6z1ZtteLzmPtzwi8iBQEf2F	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	1578	1296	283	6301	12463	jwPygmumLVh87kUsjKGbAxxwojWbDtHvN1gwCwsFrgT3RjY2pGp	8558	12111	12111	1618119180000
16875	3NLBQb14oLpNauVCrhALrugbfdPorYQCZqNH5BJbiHy2togJsA85	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	152	1204	283	6301	12463	jwA6oNvJhyAyptdJPUWAx7tJLqWyzX8ZVX7CWgUo7ELW4nC7yiP	8558	12111	12111	1618119180000
16876	3NKgLbgFuAFnQAJMHU98zCg4gPYP6GrLF1XpTGdSrr3ZXgQKjt3Y	16875	3NLBQb14oLpNauVCrhALrugbfdPorYQCZqNH5BJbiHy2togJsA85	1407	1395	283	6301	12463	jwayqpmKc5559D3vxKktsyaSJ9djvX1dtxDJBu6PwfEoMAusGoe	8559	12114	12114	1618119720000
16877	3NKLaD6CmL5ragGd4P6bAryrHjPQmS7BczGVpnkD3Jdtt3CY3VG7	16876	3NKgLbgFuAFnQAJMHU98zCg4gPYP6GrLF1XpTGdSrr3ZXgQKjt3Y	1407	1395	283	6301	12463	jxHTU2oPE5SZBSqbsFgebRDtXWKFU3aMwHTse27WdTMCEHyqVy3	8560	12115	12115	1618119900000
16878	3NLaFpH3NgMCBT8TPqjc5hKr8j68mz9rz5z67Ea2Rhv5PDCg9X9X	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1542	17	282	6301	12463	jwcLrNiiEPkFXAyPCSkygNhn4UaQjHMk5HbXud2ETMo36t5K7aY	8537	12119	12119	1618120620000
16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	16877	3NKLaD6CmL5ragGd4P6bAryrHjPQmS7BczGVpnkD3Jdtt3CY3VG7	1542	17	283	6301	12463	jxSaF1RLABjqWfmu5WWLX9m3FufiwnvSFCJV4FAtAAmPaNvcuEC	8561	12119	12119	1618120620000
16880	3NK6wnnLv3V6t2gBmogMCGjhQbZVpet8ty4enYsEyowyw1pW77PT	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1549	1362	283	6301	12463	jwNYqyvg6eyXzfQDZZVPYtNTBP8mx7GGZAj22w6b2DRxJVwmNtH	8562	12120	12120	1618120800000
16881	3NLrVfpphT5gcndPqgJ64Pvw2sToMfPsc3HxevpUfGxTS7px9tjt	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1501	1360	283	6301	12463	jx2FBrm6fGUYtQmfLgQKiWmji9Evpsk7NMyPsVLdCUsccZ2fsuz	8562	12120	12120	1618120800000
16882	3NKhyVbGRyeAfQJX4En623KK8QQQsY3gb5SShpasFUovyEsdMnSp	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1553	776	283	6301	12463	jwywhwzp3KUFafWvAC7kSGwUL38xKXWuaM8XYKRJL2c1X9Rm3im	8562	12120	12120	1618120800000
16883	3NKb33ge66ZDrNGVxTWd6hvc4ARcBRdo4XC72ZuyNVzFQxoCSoVX	16881	3NLrVfpphT5gcndPqgJ64Pvw2sToMfPsc3HxevpUfGxTS7px9tjt	1534	1317	283	6301	12463	jwNNdNLqmgW89mrBZZ1Mv9MGsUhH9C3QBmDC2spWKeXEpXxx1aN	8563	12121	12121	1618120980000
16890	3NKPkfWUrxwbdSgZAMmPh4M9KtUZ6nKdSEaCxhVdZiqPdoY7gccV	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1419	814	283	6301	12463	jwk7FkyGya94xBzE66BoaEJ6wS6W56fWyyhkA3mNyngJTfk3eVt	8566	12124	12124	1618121520000
16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	1656	1343	283	6301	12463	jxXFPYb91tj16iE2m8hiQVcJQX5hSsx2YqW96et13JGB3mYswRs	8567	12125	12125	1618121700000
16895	3NLWEjnRzbDvfL8SSVj531hzMo9NfV5eE8vrGXhZJa6o6mP63xFP	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1581	778	283	6301	12463	jwNebTQorfUPW3v95okSnuiFD1HtSZWD3ZjUbUnkSwhDECCHkiq	8568	12126	12126	1618121880000
16897	3NLu9kHE92mTHCULBZaxd6dFrLws7tPhF4j88ztbZv4ad2QRAKGr	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	596	1306	283	6301	12463	jwey6dv2a1MH6NrRtf4ZAZ2DFFZJVFnhnXKiojrpmNfHoxnt3CC	8569	12128	12128	1618122240000
16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	298	1308	283	6301	12463	jwe5EFzKFS6SxLTzAsaBKb735omUbxap5Z3A98JY7MhFy4yHYxs	8571	12130	12130	1618122600000
16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1579	1263	284	6301	12463	jxoAvSanHbV7YE1cM6kFqYkKa9Hv4au5XEHa8EyN1Ecm4VARcEb	8574	12136	12136	1618123680000
16912	3NLxJ2NNnixSHJoEdPitiAKidHCtNLboxoJj5NHMqehrZWRWznpb	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	58	1035	284	6301	12463	jxahaMNniBMDutAneXrgjvnX8obsoXuftTcs2mSJDmsgmC6LyVQ	8574	12136	12136	1618123680000
16914	3NLAeGmpviVNzbp5UHjYwRdxEgcepoeQGPPZhGqVQspddxi6zVmW	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1516	1168	284	6301	12463	jx7jSsQKkLLZmn6gdw8t38hfmXhZnm9DaWPiSNXPAyivxAae1Bb	8575	12137	12137	1618123860000
16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	1577	1327	284	6301	12463	jxsqwAAeUKexivJLHwiqUkQuYbbppXFjeQ4BTiaAcozF53QKwfQ	8576	12138	12138	1618124040000
16920	3NLGMMQJpmLJaJU8hzszrdEA3QP3ZQw7s4U7DWSKjC1bk46sAda8	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1406	1393	284	6301	12463	jwbgFD6MjGNAx5mkxc8wfFy8pSipJdu8rCSC2VGBhC4LgewuWR7	8577	12139	12139	1618124220000
16923	3NL9dwJeRcWjdGjnrybSeKDG8y85gLWjkasc7CQJP8kWook6JxrG	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1633	1390	284	6301	12463	jxE3eLeMwrDUt4N5iResch9JdMaz5rAGAdayDpj6ViZvqdax4tU	8577	12139	12139	1618124220000
16928	3NLBoyaXMDKtxpjLUWZVCZJT7zDLJVUzta2dUdppkqgd5NAqf2Rz	16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	1553	776	284	6301	12463	jxEVB8CHznfUrwgnQDdUBy9ba2hcwvRLQM4GdXV4cco3vyWK5j2	8580	12145	12145	1618125300000
16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	16928	3NLBoyaXMDKtxpjLUWZVCZJT7zDLJVUzta2dUdppkqgd5NAqf2Rz	1601	1262	284	6301	12463	jwAw34LvwxkRvtNSqGrNhrD3u3XjvUNrN3H8yHorXvSxYDQxvMQ	8581	12146	12146	1618125480000
16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	16933	3NKSUogbTJ6mwb6RAJ52CefuGWEnHE9A1cPAuJTRxRwgfRZ4Rju3	1451	926	284	6301	12463	jwAUEa1VQRt4SRTN17EEkaqoCQFrGgLRhTXVzRRepjsMhh3GiL1	8584	12149	12149	1618126020000
16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	1407	1395	284	6301	12463	jxAf1A2LZgvduCUtytbEL2jEyLk5UAqdv45DAJFxK6c7sLUTefW	8587	12153	12153	1618126740000
16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	1406	1393	284	6301	12463	jxoW2wdCA8jo94X35jf54sk83jQMJHAbhe8MZCM2Asp6KBsFbgL	8588	12154	12154	1618126920000
16945	3NLBXCGmjVdDuQz5MV7aXRFVVRqrnUCeoWuztP8L1X1bTQpNmMfs	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1407	1395	284	6301	12463	jxPGMgopi1Ku8sPF5hgWgTT2Ka2ELydMELDYCUzjQvXe15T5W84	8589	12155	12155	1618127100000
16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	1406	1393	284	6301	12463	jxmvD96upcMfb9fSzfJ6cJadu57z8xJma5Z7QWVXLoZd2jfrb9D	8591	12157	12157	1618127460000
16958	3NKSqPJP5mCFshdHa1utkc5prxfB3NScYbcjdNnLzqHdvwSUh7KA	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1406	1393	284	6301	12463	jxuuhJghG3J6nhmgtygpgy1JipVhVNa3345H5ZuWDqiNvUfeeYb	8594	12163	12163	1618128540000
16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1613	1103	285	6301	12463	jwq6q4Lox7YLTjLYRwqGy46fuzSsLEe7zbJeB6eJwyA1Mmxnu5d	8597	12166	12166	1618129080000
16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	1542	1304	285	6301	12463	jxsUEzpD7DouPcdgjeTjrkxM9JhXWtqvuKbRxNTTHVdU1SbWpZb	8599	12170	12170	1618129800000
16973	3NLwYLW2LoQcvSrQFrPn7Z31EjxRYMU35a4bmXrPW1J9oWcWkkHm	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1610	1068	285	6301	12463	jx6ah7wsDPp8b3w8qEfDsg2NgNFBa6XFXtHMSEPcHFTXb3PSDLq	8600	12171	12171	1618129980000
16978	3NLidSiqUJASzsfFbBuBywj66rwqKSYh5ngbZFd9Ntf8mZDTnt9q	16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	1581	778	285	6301	12463	jwTjSdvymmNfwXapoVzg8CerfDtCkN6nX7y26oC5AhCjMrEPUoz	8601	12172	12172	1618130160000
16981	3NLZ2LPogsaceW9iUV5z3nUUqjFjNkaKeTEcmQUiLttHg1ETf4s6	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jwEoZj5itw3P6ARjhsoVfZw43nA88GwcKxAefdyMojvt2cAwuiQ	8603	12175	12175	1618130700000
16988	3NLhT4iuNaW5wuwQ8dsLSyzzGvgib8oj7BE2NdH3vVDdgrpW1YYz	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jxxhi1yv9udB8oi8k2PquErEPTei2x1L6Kxk6s7zt5YZbvBgkpo	8605	12178	12178	1618131240000
16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	58	1281	285	6301	12463	jxtRb9KwiQqmoozBxUyGqg1AnyGfF6NCncaE4C3Z3H1DsFyBaHV	8606	12179	12179	1618131420000
16999	3NKk6sXqpthU93nxkQVmzs1x9dCTniyww9giLx3gEcGzmf8FpA9a	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1483	504	285	6301	12463	jxEsoRrHQ5vyRFWP9RbLJ4AgPZ65xVUMZ951FuXcjqqzcWVL6zT	8610	12184	12184	1618132320000
17001	3NLnMyWGRhhrRjU47kAb18fyeLktD1d4vRVCAuxXy76SviWUhPu3	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1651	1055	285	6301	12463	jwvYjiVEZ9TnJqRgGjRGAuLrqLZ6zG4ffuNmBmzoY8D7qyYQJ4i	8610	12184	12184	1618132320000
17004	3NKjzRWQT4sEVxSLHmXCwM3NKJwy6Um9awH6K96mGkG52P149ybj	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1573	1318	285	6301	12463	jwWtwku6UxvWHqEY8sJXbbtDuBQiK5CrAG1gcehC4FR7KpbHXRh	8613	12188	12188	1618133040000
17012	3NKxMRHJBc1bigjbNTsKQY84mPf1YA8T3V5KyJEgXqW1oGD2Nggg	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	1581	778	285	6301	12463	jw7sznoNPCdRysTm3LnAUBuNHJEeCfqr4tDmt5ReWxX1PyE9rJg	8618	12195	12195	1618134300000
17017	3NLB3iAAxSahcunXYrYd9ojX1uXG6JcY3r32CoYwGjPU7Asv6Y5M	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1637	816	286	6301	12463	jwZ2gQXbxcEQEKE8wTC7q5xbNE7H7SBWYqNytJe7QfwD3uypWz4	8621	12199	12199	1618135020000
16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	16883	3NKb33ge66ZDrNGVxTWd6hvc4ARcBRdo4XC72ZuyNVzFQxoCSoVX	1457	1025	283	6301	12463	jxUajeVNDtrzbBfoESYdyuT45gkrwM4zVFTGE1npoQWsE2Jj1R3	8564	12122	12122	1618121160000
16887	3NKicx2tznWyYGrqKXmVxE1VXtw49XE8z8PstdVG1nbmskGpGzrZ	16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	1627	1385	283	6301	12463	jwVGpyojMe87ozYtZrbKNuQdRcRQzY94AhCRFTDV6TX1H8wMffw	8565	12123	12123	1618121340000
16889	3NLmbfHQBBF7abanzLhifTT6mvs9nxSUYg1agrGFxnZtsFyPZvaG	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1642	1367	278	6301	12463	jxCwdvk91ZtajQ1PCkttLEUj6epWRsWdhSvt5pfRxqP1KEyptCC	8460	12124	12124	1618121520000
16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1588	1146	283	6301	12463	jwupgeM7NB9qPKuPkh6SBqVFrqF9Kq5DyPrXxiKh5jAMGkSR3Lm	8568	12126	12126	1618121880000
16899	3NLTY8EYd8KdrGWcwPXGrAcPwPJfmGVWHToSMuE1sMoFG1pfRZuP	16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	596	1306	283	6301	12463	jxC2Cc5EwgTDCKUo1ENQiBYBQkNd2CFjFGSmC5VPTJxdDgWi65W	8557	12128	12128	1618122277492
16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	16897	3NLu9kHE92mTHCULBZaxd6dFrLws7tPhF4j88ztbZv4ad2QRAKGr	1631	794	283	6301	12463	jwob4K13c7PX3cdw4TCejRdN7qqVQykdumRpzdYY17vfQNiK8aA	8570	12129	12129	1618122420000
16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	16906	3NKyijw446tcafkoVgrf5ojDka4NKh6qLx4pwa8CFk1stHNFKdvv	1500	1297	283	6301	12463	jxAJ1Ak3MHH5RSoHKeujJn9ZRpbWXmag6HQ5jQwdZviuJKdowAo	8573	12134	12134	1618123320000
16911	3NKViQLdJMXrnm4bceWTPiHCrNNnr4PgQk1L1WTeKP47D88heT3X	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1555	1101	284	6301	12463	jwV6BTD7xhvRoiwdy4Wf5TMB8bsq4987Kb9ZMGWxKrSqSiFG1FJ	8574	12136	12136	1618123680000
16913	3NKAp9TjkJH53Nuae7ps4JRTYRzA8oVGqMENy12ChNbKUa6LCpKa	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1588	1026	284	6301	12463	jxz5ceybAY1VQWZHTzsqB4YnUM7HDyvfHrRwZ6JvEdQqp5qNbKq	8575	12137	12137	1618123860000
16915	3NKhfNjWw58uht8tpf7mUDRz8izZZGkM1EfdsXbCfXFCb8VSkhLs	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1406	1393	284	6301	12463	jwAD8XvXYrz6iKSFewmN5RFkAdBihWn6qM6cnc6nvwm4C8ZGfcG	8575	12137	12137	1618123860000
16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1553	776	284	6301	12463	jwCfVxChgguShyMDHNH48atViVPCvGzxdxkE5PhEWsg9rkRuYHL	8577	12139	12139	1618124220000
16925	3NLoBSQq8kbVZWjWUm69KSjqvFJHHehRCTtavPdEeKYYZFig9zL2	16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	1458	1323	284	6301	12463	jxuZQ41gtX6G1o129ZkuXDBe8Z5u1WBqHTBmjEm5MdpB2u5GoEn	8578	12143	12143	1618124940000
16927	3NLMWVqwSbVxgjLD6hNpfM4SDzvsgjUVundrTjPVsDVvgkWXCAvi	16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	1522	1196	284	6301	12463	jwmjAV9BL1jFXJz2Q5TSVLyepXZpetCHUzwxsD443aEx931RWvB	8580	12145	12145	1618125300000
16929	3NLBSJibx2VpPmVbZtBqEQkZjiktLmvsB4i75vmLjaJwcCt2dJug	16919	3NLuEgs43gBNcXcWa3z5zHtsiXLyi6DxzsajKH3jbzoBSxsQaYEc	1601	1262	284	6301	12463	jwKC5LKs6jGpwJErXgEroAdckyknnfUKBjptAhLzYN8oDBsR56m	8578	12146	12146	1618125480000
16934	3NL8pcM7XuzmZmk5saGs9mzNgBpCNCKaP2PziNY5GkNnhVcwY5Bw	16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	1467	1376	284	6301	12463	jwiYyE5saef7UtfkKFrATqDLeaCme1YXxY71GbihjbudCod568K	8583	12148	12148	1618125840000
16937	3NKG4z4qM2aSMXHa2YmLzMX876TCicYFYNjWoVjDcv8gPgHRPNpf	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1406	1393	284	6301	12463	jxnNspraqaZfR3mP32yUMft718FrhRrWV5C1SJe4uaXiU6D5ce7	8585	12151	12151	1618126380000
16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	1560	1045	284	6301	12463	jwHBYcYBiKRqt2g1z459GvrKUefWxn2zxL1v8jkEVczeUGNGRdi	8592	12159	12159	1618127820000
16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	1403	786	284	6301	12463	jxdygPA1MhYzSTypt7kQoM1Tq7Np1VDpnnp2P515U2posx35jig	8593	12161	12161	1618128180000
16956	3NKc2wFzh8h8r2gscQ14R1EHdaN3Z52KkipMfed8v5zsAsnhQgt3	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	101	101	284	6301	12463	jwnuhwPgwjRZRjg4p3oJvwAvXB2hcKtjHjZEfssgvDcD3qhetDD	8594	12163	12163	1618128540000
16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	152	1084	285	6301	12463	jwJ31MSWcCdcmhzBxJWgdjkVxJs4Phx8X12xkV6TFm2veVTChew	8596	12165	12165	1618128900000
16963	3NKQ11UaSR6FGacFiSDVC82QZRuPQ8oS3VVVPonvbXDjqVMhGmKs	16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	1672	1285	285	6301	12463	jx2vWFtThbNfszTK18kxnydBu2GzizXtbrbotdKKTiFD4xowDWL	8598	12169	12169	1618129620000
16966	3NLMZRJ8izxJmweovygbPYqmYC2Y43fgV63Newv27PSbwmecKV3x	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1571	1209	285	6301	12463	jw9RKMX9Jotwb1onn2kPkyRstNe9YMT6zGoXKbvfrf2PQK9wn56	8598	12169	12169	1618129620000
16969	3NKUSXhxj8mqYUhxBVK7e4perbRwxoFAfM8WArcQ93Sw4mVpxvec	16878	3NLaFpH3NgMCBT8TPqjc5hKr8j68mz9rz5z67Ea2Rhv5PDCg9X9X	1542	1304	282	6301	12463	jwx8oCyHqsRVynjhN9KhMLo9i5b6WkyTEToXESXaskhakRSECFJ	8538	12170	12170	1618129800000
16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jxrkSfyw5QDXwwhdEFw29UyoMQ15xBokTqB8zTLHvwUSd2njLiY	8600	12171	12171	1618129980000
16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1599	1041	285	6301	12463	jxGsEUAZDrLvv38DA6XpMFnA9iLsGN5LrmUwUKQDR6fnf86yKvT	8604	12177	12177	1618131060000
16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	42	1361	285	6301	12463	jxD1j7NotC9bTnLkqNLY2vfPhQhHXu3LBspALXY26Xs4k9Yyins	8607	12180	12180	1618131600000
16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	16994	3NKatsiuk1qJL2vkH5oYqGnMWJwz2zWZnhhzDUGHYqa3fGRZRvZn	1547	1012	285	6301	12463	jxfcfEwLjf24HAK33zfem66VHDhja8wCGSbKXdxj1uCwk4NjYQG	8609	12183	12183	1618132140000
17006	3NLiGhqZfuE4w6SCRULtURPRZ2dPPmS6xkfW79Bc8tdgRqf4xPoM	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1651	1301	285	6301	12463	jwoxvrsoddmTfMwiLQRFXZHcRCXh92pk9oUSpwBZSoPxXUsye7g	8613	12188	12188	1618133040000
17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	17007	3NLZZ3b9TA25mTG7yPeVVTNLDNhDW3Tw5Hx42VoPBHk53yz448Vq	1559	1107	285	6301	12463	jwKXwAdxQ1As3Te6ziBszsxRb6mV9U7mMdAjmStv9tRrMbSzKZw	8615	12191	12191	1618133580000
17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	1407	1395	285	6301	12463	jxveE6CGbBq5CUvke5Lpq7n99L9XaUivdspUDzca6MKENa8hdrk	8620	12198	12198	1618134840000
17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1406	1393	286	6301	12463	jxvtRooZwqC39e6pRVxamySGTGfEmdjCXaqVPvwT3imsF384THL	8621	12199	12199	1618135020000
17021	3NK5grZfudmv2ufT26rMY16tyTKo72w3D5ayVa6JpiVyK9usd2fU	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1403	812	286	6301	12463	jxoj3FCZbiy8v6go6TEFRNTop39HtbVHmcLqdcYreoWgtzGiWn2	8622	12201	12201	1618135380000
16885	3NKU7iVib4Nur9D9aGSQHRfJDN3V9pP5s4L7fWoHy4xuNSuAm2KY	16722	3NL4EUnS8TAeCUHePueaDyCsdVZCNmK1yg7cqmttCj7g5cyvkTN9	1589	1286	280	6301	12463	jwc2RBTPjrwpQhCLrYEBsbMv1cac8SvgGQ6rHbKcrMiNxtu6VVg	8487	12122	12122	1618121160000
16894	3NKph8Hsh1UoK7yZeQhVwMtbZirKJTiWhD21HmHJVYixAP86VMns	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1407	1395	283	6301	12463	jxKjAagzfAFL8p6y4TnMNE3Gm3fcRiUYDsMg37AYtmuPvWFC6ZE	8568	12126	12126	1618121880000
16896	3NLp4W98un16HSCR7PcWj8qDSxCrorTcV43z7guacsoxeVHuCPje	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	1457	1025	283	6301	12463	jwYsF8bm84XuQYe3qWt9P3B5b2YW1KKshN89jhRoECfQwUu4kHM	8569	12128	12128	1618122240000
16900	3NLaZZ4YHMrHtqfUEVKJu2rWEbsyzswt9gtTpBeE7jCtDTKknYE7	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	596	1306	283	6301	12463	jwTq84D2kURy3PP5GeQjSr2JruN8a7PkZR99KfULTmKSavvLNVM	8569	12128	12128	1618122240000
16905	3NL2aE35T3PY29W5V5HcNsrgwGpHzCTViueAHUQ495YStZu582nk	16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	1522	1322	283	6301	12463	jxpztJsoXEpqp2Htpu8mULgwND2s9nCTZZhq7HAa2UAhJiVkm7W	8572	12131	12131	1618122780000
16908	3NK4i1NTTy9qSAumARQwDRSkkhMPoiskrNdfS9r3bXQs3GiKKG3F	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1579	1263	284	6301	12463	jxoAvSanHbV7YE1cM6kFqYkKa9Hv4au5XEHa8EyN1Ecm4VARcEb	8574	12136	12136	1618123680000
16919	3NLuEgs43gBNcXcWa3z5zHtsiXLyi6DxzsajKH3jbzoBSxsQaYEc	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	684	1106	284	6301	12463	jx7FTTXs6qKmcAWKD6piaTkBzw8PvAarZF4ncw5z6MfSyrsSbU6	8577	12139	12139	1618124220000
16922	3NK9EZfhPSBNK6LTFb7Zd2zt8exzBWTayvEhymL6cXp6Q2yMbcDG	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1623	830	284	6301	12463	jxN8Pub6fb3EugJ47X5jA4EcfoAwaLtizXcfE2JRoGHMUNxjZGf	8577	12139	12139	1618124220000
16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	641	1336	284	6301	12463	jxmK22WyNKG59tipbrtYctBjCf2xaT4Ljpzbw5YhdnR3dSWaXAS	8582	12147	12147	1618125660000
16938	3NKBMDxy2m5CXhYyB39iMsUZhaxbYsPJ1p8xrmoTy6giF7cF8XgY	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1573	1072	284	6301	12463	jwZ79VPE448mKsTfdtE6BjyTGQCZ7FKHzJtzzypahuKZmZaz3GM	8585	12151	12151	1618126380000
16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	1500	1297	284	6301	12463	jwi5WBFwfK7WpCip8JQBab9FQarHf2EqZsrHYL4yF5iM3cG3gx5	8586	12152	12152	1618126560000
16944	3NKcCZTahaFa8NsiRdBXviuHccSSnbYWyaeffH71exeHAUurCHuy	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1642	1001	284	6301	12463	jxPE3oVBQJisCSVYrFpKavSky5NfzsLwdDDage7eFFJTmb5eTe6	8589	12155	12155	1618127100000
16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	16944	3NKcCZTahaFa8NsiRdBXviuHccSSnbYWyaeffH71exeHAUurCHuy	1647	845	284	6301	12463	jxCtCYQxLFx5sfdWMECy7dikz3MM2ozR3Mx92FNZS7Ne3Lfv6Qx	8590	12156	12156	1618127280000
16954	3NKcSKGD2c1VPw7DEwagNaESdrsZpwCcR4fTd2XaQBPJnGK6Y3ct	16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	58	1281	284	6301	12463	jxk5Mf1Ui1ARJoTc3CNP3KxNTcu4j8X8CRJXMXcp7Rd1pM2e3n9	8593	12161	12161	1618128180000
16957	3NKTtkAY69H4zQux5br2pb4MPjvPnxUdU5YQvoMP6v75FhTiQXi3	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1509	299	284	6301	12463	jxxknsvezndaUuga8nLe6qspeZ2mtvimPAB7XYACKWvFbbda6V1	8594	12163	12163	1618128540000
16964	3NLT4r9Xrvow13UgTCUFHiKrVEcFkkLAmUTasx9ni2ZgsKevctM2	16792	3NKGgydFyjwKYHuP1JrReo4583qezmoBbc6orCHnabxLJc7fBobj	1474	1083	281	6301	12463	jw6sJtwK6gMZdDamYLCAdEwBcc1Vk5eVaGLFGQdyCGtU4BuCqo4	8523	12169	12169	1618129620000
16967	3NKhWoKX1gRM5EUN1zxhsZxvqCifwbHjxTAbKjdsipTqaHWyDZ4G	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1474	1083	285	6301	12463	jw8h1qzkhP8dEaYyRnoGQgFmty6sb5KD26isaee6e4crhn3DjJb	8598	12169	12169	1618129620000
16972	3NKhu4jByJWLe56rXqKP8AtTUXwLiVe93JttBmZzoG79dWgVncCF	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jwWgREDmPg6YN1mLXc4ZQxixepmDbeaetMS1Jf5mhUZno5udtbP	8600	12171	12171	1618129980000
16976	3NKQBP22ifpiNoJRDskMZmn3VNdVmq6bD9qHMyJMGVhNXn7K9VyL	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1406	1393	285	6301	12463	jxGcuDraCLmEdjYobh2iUEYeRcopXtxhhrKTVaKygs1DM3cGBsZ	8600	12171	12171	1618129980000
16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	16979	3NLUvhAJErLBzqWre8N4htkFkH3pqNVfS7Phc6yEz39ZQSnnaZW1	1403	31	285	6301	12463	jxz9P6a3MC2zyQMwxEfjtvqCohGS4PuA8w8utQ6DWZCyeeYD5zf	8602	12174	12174	1618130520000
16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jxwRhEX8gSQSJsizzCC7K5KW3ZpAgeG5LDQkjtoYAiDQ958aDLv	8603	12175	12175	1618130700000
16986	3NKbQDWrKin89117DRM25Qe6hQNHuLWidvuqxzzuDyHnraqGx8xV	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1406	1393	285	6301	12463	jxsKZfYpU1V1fMVuU7T5eU8GMBr7HwQYfaryJXhQfk5aSJETqGP	8604	12177	12177	1618131060000
16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jwpNvxDewGJBcjbG3qZfQxnx5oS7MjWxjpVJVunfYDPqueiJVG1	8605	12178	12178	1618131240000
16992	3NLLUDjGtBHMVccARBoRndiLTcEsBgMRwjBoGgxpSYBbC6QWDvXZ	16767	3NKjJskkTp3uvhtrFaYfCFwhxT9QR29WFZDpn6GGEjDvnqaxLzNQ	1564	1338	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8386	12180	12180	1618131600000
16994	3NKatsiuk1qJL2vkH5oYqGnMWJwz2zWZnhhzDUGHYqa3fGRZRvZn	16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	1553	776	285	6301	12463	jww2TUH8R52pG7isEVkvJHa9J9FKBCpz7dVCbpZ9noqY2VafW2y	8608	12181	12181	1618131780000
16996	3NLSMh7MXjJMcv6gQhPexjaUiJnE6rJDEFAVUWiECwALYMRTP4Ho	16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	1589	1160	285	6301	12463	jwJL6jGjwaQDeE5JRQUaZKJfzTzwHYjuC8gmU2EFwUsigbBu1Db	8606	12182	12182	1618131990288
17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	17002	3NLUrsxP3ofZZLvmN9guf7AMPzZoKQyKFb28QJpC6TbVAbHdCbX8	1627	1385	285	6301	12463	jxJSLMHEUztq1rMqE81eMbYAWwC9qZ2bGPHGtLjLuAtoieFpPVT	8612	12186	12186	1618132680000
17009	3NKyscZ7BEfivycYb7HZ9vnzequ44hL72PwJCHdyGgryYmrLE3hC	17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	58	58	285	6301	12463	jxDZPBH4Zgz5tRC7KJ74AMTxEAayaFBZyQizWtH6N4kkTRAWJ8h	8616	12193	12193	1618133940000
17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	17009	3NKyscZ7BEfivycYb7HZ9vnzequ44hL72PwJCHdyGgryYmrLE3hC	632	1382	285	6301	12463	jwChjArHgkMuAs7Pw9v8E2Zt91QkFA898CL2BVgBNjkfy58FJAD	8617	12194	12194	1618134120000
17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	17012	3NKxMRHJBc1bigjbNTsKQY84mPf1YA8T3V5KyJEgXqW1oGD2Nggg	1610	1068	285	6301	12463	jwfA8kKC2Rc48kDLMTdFo1xKXCqgEJ4PayJLVhzRraA6nsPn4WT	8619	12197	12197	1618134660000
17022	3NLiHkHuUUyCFaWppWkrHTeCbDTMMk7XA2qm3qcZTAVRino5Afnu	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1637	816	286	6301	12463	jwphRpWnC4Ync1qJ9gDzqtfe2pMr6WAPTt8iPurbywWFTsGsy9Z	8622	12201	12201	1618135380000
17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1623	830	286	6301	12463	jwyJ7hrWhEN4H1eJaVUZ63KPbRvJ2n24JQAAYVr8uyuxMUsWcDL	8622	12201	12201	1618135380000
16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	1654	1340	283	6301	12463	jxbkUnfnefqjuFgQ32dtM4YY2myys6GE72dwBiA9tkdvxGLUo8a	8565	12123	12123	1618121340000
16888	3NLrfxj2cjGvKVAmpeFTTFWGd7QowRkSjXM1VXZKib32yd4XxmnA	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1642	1367	283	6301	12463	jxw3W9BNC9EnM91fLB7SXY4DrTGaLegCiFATjSXtPe7jJtx3Ucc	8566	12124	12124	1618121520000
16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1631	794	283	6301	12463	jxGhoNQEuyomHXBA4GemrjwNyFB5oEdmBvCmdyE1Jxxv4EHjC38	8566	12124	12124	1618121520000
16898	3NLT8QpppKM7VzrpAwbrMX7QfdWqN2JYe5gNX5wRhF3d4PodSD1p	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	596	1306	282	6301	12463	jxxCgF55FYeJfs3dnMepiK3oBTKzaD9MUT4141SfuxC8Jya337t	8548	12128	12128	1618122240000
16901	3NKiGHbPG6NbUxmoTbDGievedxqtBw3n12FX9UxbpAuzzTf7Z161	16887	3NKicx2tznWyYGrqKXmVxE1VXtw49XE8z8PstdVG1nbmskGpGzrZ	596	1306	283	6301	12463	jxCQXGiaNpdkwhz4yNLZhMGraUZviQixMW6HP1NkesTc7iT6mR9	8566	12128	12128	1618122313595
16904	3NLF7NSyMfu2Eu7ynLSojNdxscJ8hMk9kkFVDQnwaK6XZbKWHCDU	16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	1623	830	283	6301	12463	jwXwC9BSPtBV9HDunwhLP1s4k5P9mt9YR3BxcSC4z3Koh9PRbUh	8571	12130	12130	1618122600000
16906	3NKyijw446tcafkoVgrf5ojDka4NKh6qLx4pwa8CFk1stHNFKdvv	16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	1648	1284	283	6301	12463	jxVbK9WkbELkZJkeTZxnPdf6iJMhyrC7uyWYKUxcddmn8RoqYK5	8572	12131	12131	1618122780000
16910	3NKz6Y92qaKUtumgpvxsJojRMV9F3gEMo8uAXU7h9XYSJYhCjqiL	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	58	1035	284	6301	12463	jxahaMNniBMDutAneXrgjvnX8obsoXuftTcs2mSJDmsgmC6LyVQ	8574	12136	12136	1618123680000
16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	16908	3NK4i1NTTy9qSAumARQwDRSkkhMPoiskrNdfS9r3bXQs3GiKKG3F	1588	1026	284	6301	12463	jxz5ceybAY1VQWZHTzsqB4YnUM7HDyvfHrRwZ6JvEdQqp5qNbKq	8575	12137	12137	1618123860000
16918	3NKWESWx8AkbSiRERQmdKP8gXP45PTHKZxwBcriVDbpZZn71b7Pd	16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	1581	778	284	6301	12463	jwFHCYMuL2M6dHqdCxLKYMSwnpTdLAGFwg1sXZr1xAJ57kPuYxa	8576	12138	12138	1618124040000
16924	3NKZP7G57Hck8t5RWfKq4usgqkwsCFXwXckmz7oo9d7Socv33QNt	16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	1513	1133	284	6301	12463	jwYMwqNXAtEM2ifGNoTjPfv6TUz4BWKCXsz3sJY14CZjJPcTXS8	8578	12143	12143	1618124940000
16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	16925	3NLoBSQq8kbVZWjWUm69KSjqvFJHHehRCTtavPdEeKYYZFig9zL2	1610	948	284	6301	12463	jx7sMbc7TqCPretx8H2wHLHxB3izDpabNkjFiXrXLq97PDbWNf4	8579	12144	12144	1618125120000
16931	3NLhbUbfytP5xkQUzPiciBUbhzBEtdnDo3F5ctgJbtXPegGQS2iU	16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	1405	873	284	6301	12463	jxFwL96QB6vonjD6okDMWGKx3Rosn7RAr884brEfQrjaKAfcqiN	8582	12147	12147	1618125660000
16933	3NKSUogbTJ6mwb6RAJ52CefuGWEnHE9A1cPAuJTRxRwgfRZ4Rju3	16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	1637	816	284	6301	12463	jxLPbSnmi8Gwq8ijNxgF9zgAuR5QFDxwHSmgELXchk2MUo65uqN	8583	12148	12148	1618125840000
16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1534	1071	284	6301	12463	jw97wF7GDKgK1CUkTmd8yfNr5pbNuJhQQRAYY6Jimf94az9N6Yr	8585	12151	12151	1618126380000
16941	3NKkwK6zuPneoBRFBQL7oQCSgRTDPr3JgrstZ9acdfRN1jahGeA8	16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	1581	778	284	6301	12463	jwRDSRYyHkPyQY1nrrP3PRTeWkQpSHjgiNnzZX9Tx1j5ZQLfoeB	8587	12153	12153	1618126740000
16943	3NKgBczWv2TFgRgWW7EsC3Hhs5ofgB361afbzbN7vYHredQKfjxX	16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	1650	1129	284	6301	12463	jwAxUUhLc5ry4ApytiPN2g5CHKVngiYiBs7FTV2qxYEf4YedJkE	8588	12154	12154	1618126920000
16946	3NK7zmNXG1SDUNwGepRUqyuNRySWDCcAX3RbQ7UK9rFSW3ysP68E	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1406	1393	284	6301	12463	jwUDVGa15YJM1GGJ9FtxQPJoBYumFpDjcGFSsCiuNyRBp7ZzYFW	8589	12155	12155	1618127100000
16947	3NKxdjatChYKGsjbWgB3HdJ77haZN5GtFmF6KCRHd2YEsFP9Ggvx	16889	3NLmbfHQBBF7abanzLhifTT6mvs9nxSUYg1agrGFxnZtsFyPZvaG	1642	1001	279	6301	12463	jwsZuQwaw2gUBhU4W2yvJGzaNbYwaBdogRkkt5XdKYPmodoaBEi	8461	12155	12155	1618127100000
16950	3NKhka82CHcTB4Cry8HWQBrj65LJNLoeWkJwQLuDUAYipTtf3VDG	16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	1560	1045	273	6301	12422	jxjG4Xq9Z5NBipFKY5dBscv46BW8NSLA4CuYmrXMJNsSPLspMas	8380	12159	12159	1618127820000
16952	3NKUGCPmAX8E8UAg24azmWMMaBQoHABD5PiJvBxf3rTtbCCtW9oJ	16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	1560	1045	274	6301	12433	jxdR6ZzAA3D8ycftzbJ3PJjn43okFVqN9AmkyVz3gDBSaX7TU7y	8388	12159	12159	1618127878038
16955	3NLLJ6hpvH47roGfmfBzY1Vw6brUyK9XjSARLLGHujdQeQzNixnw	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1403	824	284	6301	12463	jxPBUxi7scJhMZHwZngY9Hu59wHy9pEzgPb1iSH52soy91TrDUv	8594	12163	12163	1618128540000
16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	16958	3NKSqPJP5mCFshdHa1utkc5prxfB3NScYbcjdNnLzqHdvwSUh7KA	1516	1168	284	6301	12463	jw9ZwaNuAqpVdw3N3TUbGV87pB9vfb8wdLfurdLp1dkXmPGv2F3	8595	12164	12164	1618128720000
16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1631	794	285	6301	12463	jwLpEG2g9SptFwz3YCSSdLBvnSHiYF5ESBWvRgoZ1A8vmr7YnA9	8597	12166	12166	1618129080000
16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	1483	6	285	6301	12463	jwwRvUTZJRbYmX1QgxLo3WcdvSreJVKnQHYpTSeybmnXmY8nZ83	8598	12169	12169	1618129620000
16968	3NKNPtZVNZoZShkX5UCVSf9KNWJqUo3CcGtGjzMFHBaaUZLVjJa2	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1672	1285	285	6301	12463	jwZfCgcAuzfXGuW99A6SPm9yBUTQkt6MnmYVkJ4nin9bMv4qS5M	8598	12169	12169	1618129620000
16971	3NKghnwv7aTmV7sDhv8SquX12PRYbcdowuNqJXpHWGD9NvNE6iLp	16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	1587	272	285	6301	12463	jwnkBaUvpVjsBGH5xJUDfNjC5Vyazr6WmzjTZzLmzhWt5DqbNG5	8599	12170	12170	1618129800000
16974	3NLZAag2tpiehFA1xfLfxZX8sLKroCRfWBuXTHC3gBpamjbWuwp7	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jwhayrKzpmuSyaTjLLxMeoJ9hyKUnzHNK8teLwaZYZkVzEjJUyY	8600	12171	12171	1618129980000
16977	3NLXLpgovW2vtvZZLgkp48uESFZLzc69Sryeo1LYftZVDrG5UpNw	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1555	1101	285	6301	12463	jwC1KD7Lg8y4H7QZZAFdQsRmtShAHDcpc6G9ybBv5eUEjS8ahQ6	8600	12171	12171	1618129980000
16979	3NLUvhAJErLBzqWre8N4htkFkH3pqNVfS7Phc6yEz39ZQSnnaZW1	16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	1477	1350	285	6301	12463	jwku5JnsnbYFvQdpkCyxCUczzZZiP8GeYCEr3QJ655j3QMf1CcZ	8601	12172	12172	1618130160000
16982	3NKkmbdxqM1EW59LsFg8oQw7Cs1Az5XSUt1ErvqBk9xcV5nsbiUy	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jwN6Z5c3sxmsLwDBV4c7F666fFvVwqb4kNQU4UXVSAHLFg32apA	8603	12175	12175	1618130700000
16984	3NK9HqQF2iH66LfwRDg8z7tFpjJ77ThtAY2dkb422dwRAse813zS	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1588	1392	285	6301	12463	jweHzUqudYJRyqaiZui7YhYN23DbJwHgXCM8eAu6BikePrVJJYw	8604	12177	12177	1618131060000
16989	3NLB7vNKCiNwHZ1YfYgD8yZWWghdKYzFAQbAWjY5NyP1pFi5mheu	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jxgsoFhYpT2LdHtHQczn4VMNLxKqLgjCuYTdeimdm3aQw2Qf4Aq	8605	12178	12178	1618131240000
16993	3NLrUb5c86vHmLEuvJcvw6m4AKqcjE1hQWu8uXTHvDqMitq4w1Yp	16992	3NLLUDjGtBHMVccARBoRndiLTcEsBgMRwjBoGgxpSYBbC6QWDvXZ	1564	588	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8387	12181	12181	1618131780000
16995	3NKD4me6N39beAM3KVj5AYiFxhkzDukEvq7UKgm6iP7Rwx32KsjE	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1589	1160	285	6301	12463	jy251vnYNsvJvdwzSs4oK9M5ACkY3ujUDbw1MtttdXzUQbgXmrc	8597	12182	12182	1618131960000
16997	3NLdFbATG5arw6AKnYrGt552kAAuFUEJvqMw5e8hGNb1k4x4UqZd	16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	1589	1160	285	6301	12463	jxQ6r3K5k5taAyqsmHAe5YXPRZ7Hfnt9Vuw5XiiVTHWFVjEBk4B	8607	12182	12182	1618132023463
17000	3NLJES7HCQqbhMsaz95KYSpx3bxhsvf7shUBGPcyUgyt1SAcxGXp	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1651	1055	285	6301	12463	jw7gefB2pvKRmHX9arFqmPUH65oNjXHBMubDa5bpCpq1UtXtbWD	8610	12184	12184	1618132320000
17002	3NLUrsxP3ofZZLvmN9guf7AMPzZoKQyKFb28QJpC6TbVAbHdCbX8	16999	3NKk6sXqpthU93nxkQVmzs1x9dCTniyww9giLx3gEcGzmf8FpA9a	1631	794	285	6301	12463	jxc3cKC9AosjEFCS4tKhnD8oaFwyG6Rw5p1gTdUBBiJAG9k3nXT	8611	12185	12185	1618132500000
17005	3NKgQ6AWFXUqieSP8qNFYxnZ7k7DUFyMEYHGRsACuuc2BhEourb9	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1651	1301	285	6301	12463	jxvtHDw1QGtcgKKWsi7f8TUTcQkQL7KPEg2CZEkBK8UdnHuSwTn	8613	12188	12188	1618133040000
17007	3NLZZ3b9TA25mTG7yPeVVTNLDNhDW3Tw5Hx42VoPBHk53yz448Vq	17004	3NKjzRWQT4sEVxSLHmXCwM3NKJwy6Um9awH6K96mGkG52P149ybj	1587	1357	285	6301	12463	jwEaAbgFUEkhC45TdYqpkev9ChjntuFUk55rkoqc9QztdE1AdDL	8614	12190	12190	1618133400000
17010	3NL3azM3x8SPBo3pApb9SSCrUF3B9oyhtvT9vqM7Tkwaa6JLmi5B	17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	1631	793	285	6301	12463	jxRWHFjXzA97YFU5wTiv7ac3Adye1vRhV3eX1KeHscFYhcfaGvA	8616	12193	12193	1618133940000
17013	3NKfmFxdowvWnjNSpjCVNmachgcCPNSkLH9fHw9AK6rRVFwaunrb	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	1631	794	285	6301	12463	jxmV9kPE5XiXor15CF5ZgPPgt5icEeoVUydpHKY2oaQCb7CufgW	8618	12195	12195	1618134300000
17015	3NKVUZbtmWgQsnbmz4mv4cSE2MriQKXwgkWM5g7CDYoymkGphXWi	17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	1458	1077	285	6301	12463	jwcVsiEcjDY2udof4DPRvRBTC1qCqKU2YA1Y6zqaxc6gTZdJ6bp	8620	12198	12198	1618134840000
17018	3NLByjNjgrtZ8aWegAvRmQznCZ6cYV2udBrmn8dRk668RhSaFB2T	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1476	1371	286	6301	12463	jxGMURFJtB6q8vfNwgV7FXMGXdCNknxZnPh8GZBsHsKVpfRHqLN	8621	12199	12199	1618135020000
17020	3NKVSZuLLz1o8ma8AGjxiV1itP5BRXKHXYZPSM8uZjfY7yMLyNhV	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1402	870	286	6301	12463	jxo9riYHTQ2fMtidtAe8vtpYdVZTPnfF8yMrtqtScTYmGd26623	8622	12201	12201	1618135380000
17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	563	1113	286	6301	12463	jy2LXEA42jHjJmKfVEyXdNpM2k3UiCJCp8fLtTV3EUKtvDsPz5S	8623	12202	12202	1618135560000
17027	3NKvNQoucp75MCs9zLDvtXEmWik9wJVRFkaHkkvzyZrmmVJmFHC3	16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	1489	1380	284	6301	12463	jwpVC73AaAjAwCLbKZvb1BMwSm5mbgxBaK5oUrVytjVrojYBMCC	8592	12202	12202	1618135560000
17030	3NL2dQmReLWCFAX89SLLyZ3Yb4KzsM5D3DEi1xFqbvHFucq67jcE	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	1407	1395	286	6301	12463	jwKw1f39CFvmDrNjY6z4BNivKCqGxp7iu5ALRVd7TtxHJzcovVC	8623	12203	12203	1618135740000
17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	17029	3NL6q9ALL1r2WE2hfjV8b2ASMVxRd8gKXkM1CPyqf3vNedBBZxzR	1633	1144	286	6301	12463	jxbLNMoE1Zidy9QCvcaqhPNxczMEdzh6vRmnB4HiVBkvxaWCp6h	8625	12204	12204	1618135920000
17041	3NKHWMSC7QzAGjKmrL5wtCtghyoBDe98AZHSiQPBkiKXgY7nj4D8	17040	3NKLCvh2GVZYhAx8RZnjZLygP2BQmm9C7BAc4K4V1qb1VzjpCm63	1631	794	286	6301	12463	jxST75dvhRisjcCcTLoqbBR25qynQxuUAfkW1z4wmhsPddHnu3G	8630	12209	12209	1618136820000
17044	3NKfXStn1jrReGxETVp8yuCrNSERQCbd1M2xdrp5mDc895zsvMy5	17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	1445	1290	286	6301	12463	jwyk19KStRAHHnHDx61yKcmbcwZ43scVJKMK22U8MEjY3n6G6nd	8632	12212	12212	1618137360000
17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	1637	816	286	6301	12463	jwPnRKLm2R7qNBS2hsWQW6rEgyHTL5K61ef8jHz4TBx4zarJdkK	8633	12213	12213	1618137540000
17048	3NKQsdnjX3Nz1HgUsuNvDQ8yfcpXv3UaLyqzDDKo9vvhD5WinqkK	17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	1407	1395	286	6301	12463	jxgoQ3ku2h84kMzeGUCUwkWavnvJ5Pw9zuBF7mCiS1GwwWkGjti	8634	12214	12214	1618137720000
17053	3NLjvxtwxiuZvtqheDgLhL7UG94McuKvBn2Cgrrpr1JWd8b8fpXV	16969	3NKUSXhxj8mqYUhxBVK7e4perbRwxoFAfM8WArcQ93Sw4mVpxvec	1542	1058	282	6301	12463	jw85uwcNhNH9Ds8ScvUw45mdeQc7hP6BKLgaFSMYt9RMo6VK5jn	8539	12217	12217	1618138260000
17056	3NLdGcFDyk2ydpuPBYfSKRP9yuAix283EJdrD392tar3LLSArFu7	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	42	1361	286	6301	12463	jwDJ26Q3nMsyDHdRQGSPnEMWxrk75uMGbTqy8mfGnoHHrFczNQ9	8637	12217	12217	1618138260000
17057	3NLTxVHweZAkCvWKYb1VewJkdovQ7moYy8QD4weP7YYKAs3WnzXT	17056	3NLdGcFDyk2ydpuPBYfSKRP9yuAix283EJdrD392tar3LLSArFu7	1445	924	286	6301	12463	jw9Xr9kc6DA4RMdJGV6BEaFT6RFw3Lu3VHqA8pWScuJGvVcUwt2	8638	12218	12218	1618138440000
17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	17059	3NKAYTEBybbGQdt5EzY56yEUigWY3SrbXnCATmSv8unf7CB11Bui	684	1106	286	6301	12463	jxWAYPTeD7BNNkiv1b1B6BKQX7MJYQLBPpxo5EhK13KbZmUaYeT	8641	12222	12222	1618139160000
17063	3NLaMFabzyvHDEKKxdvbSinwBfFcCnkpSTagbr2q94scuHR788GN	16772	3NKqwZjPAHEdqEqkGeNMokrGcyrjfWuCPLjJd2c6dTQ2rESn5Q6V	1508	1261	277	6301	12463	jxipqSFNX7fnBQcxRWs5e2NcnXuqWUd7LTL6KwxCuFGmWmyYMDa	8411	12223	12223	1618139340000
17070	3NKBNdYW2GBkERuHfQKoc9huzquNgNgAQiLXLhymoiijvh5hbck3	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	1403	782	287	6301	12463	jwo8s4Rt2UggJCipsAH4vP3jMkXDyrZYcu8EA8U8sFsDqqPDQtV	8647	12230	12230	1618140600000
17077	3NKUW7qA45C3zsKCb3c5kzpsFX3xGC5V1gNN1qJSt6B4yAGqXj2b	17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	1634	1085	287	6301	12463	jx2B7oqj1kL8r19GGHWG8shEE7w7nMxvsnas8fH7P74PA2nTFQy	8649	12232	12232	1618140960000
17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	17079	3NKGNx7wr9Yh1u7NFfE5yp1YMBN6oMTvdptV27xc1X3nyhsnWkJL	1490	1028	287	6301	12463	jxwGG6ACmbBMGQzGJRycaWsWsteJcS43MkZP6ESgoJ4hnAkZbpu	8652	12238	12238	1618142040000
17087	3NLFgPJC5oTJJPAZYG7LyTjA2ExPu6944b5kAyMoQMBdan4mn1dq	17085	3NK7GnkmqJGT1J8uZuJBAieiaGvZs3R2PK1ypDT6ZUBLN9ZMjHHE	1406	1393	287	6301	12463	jxCoAvJSeeUqYe6mMj3HfCvxKwaCi4BpyuNK51YgSW1FJANfg9q	8657	12244	12244	1618143120000
17090	3NKQxCY84TnH16EK78HTpDTpe2F1vvfiGHaBRx1fZEcn5gufHEg4	17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	1637	816	287	6301	12463	jxUPxEDAVddA3W6frESzDbYSDjhuRQ9nZW2NR8gDzjfWNE98YYX	8659	12246	12246	1618143480000
17095	3NLu9d5pMU32uNPwzUmtRdfJJ7nNBKxBe63Fm98PVFmZmoVSthQv	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1596	1363	287	6301	12463	jxDsCRTv8urs68kn2jZdipC1V81aJM7aC1KmR78pwU2WZcCv9nL	8663	12251	12251	1618144380000
17025	3NLunpMJknEJk1EwVTL3Hf1YQ3TFxdM6rbgdTex5LbBsMSNYw7HF	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	563	1113	286	6301	12463	jy2ndvUKfyFa8JHh6vXtLr17GHoAJV5RPD6cANtdjHcamH93fxB	8623	12202	12202	1618135560000
17031	3NLhmD12qJvr8oLx4byJ6ZYM7bUcFmowKujq8ZRP8TkxJtZ1QG9P	17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	1593	1346	286	6301	12463	jwDMmKFkceMspPDHDD1bqqcWyB5QosAEUrGaQ91Tm2i4CEWKsJC	8624	12203	12203	1618135740000
17039	3NLf6knir91yfMNLt9vxkLE8PQ9tkZ5qCdiWwX4wi8N2GxojvEbT	17037	3NLvhrUJR3GDyGvpkXj7Sch9vAEvbATXAhRX5uAi8kMBZU3QvZGN	1589	1040	286	6301	12463	jwqcNfCaWMyyiPBXbQUctUqzqqrqTEkaLGYBK87NkU8CFgGURxW	8628	12207	12207	1618136460000
17047	3NLQDpvxchPJP4DNyuNDtafVcAAhzeUdTBpukgxgaefiduiXdU4j	17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	1608	1043	286	6301	12463	jxArEd35KanTMJXuSu1QU8u6632Pfc9EEcUZ9xYvQFHBoAZWEHo	8633	12213	12213	1618137540000
17049	3NKQm99Z79EfS297nhrVjDSRu82N2w5E1rsh76dUGeyKPHdbv75c	17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	1611	1095	286	6301	12463	jwT7xvmrzuZedT7PWVy6uhJvyuJWJtN5CXpgzMzdvd2MrmA64AN	8634	12214	12214	1618137720000
17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	17050	3NKZhVBVGGeDfVCCphEFPJ9Kbge2FtoxacZDcVVYyed3skUBZrZi	1585	1120	286	6301	12463	jwaJVxq8HmurPSjXJ6fWARv23wPjzpYvKSwr8XejyKSn6wyRjCU	8636	12216	12216	1618138080000
17058	3NLm9gwrtXC96zwCFbgfetswZUJvxTNqp58WbCyJzBNtTVt27Shu	17057	3NLTxVHweZAkCvWKYb1VewJkdovQ7moYy8QD4weP7YYKAs3WnzXT	563	1359	286	6301	12463	jwzo2WHNkGV64Tun9eiUCFmrHM8x692g9hQEwnAyfNzfaRv9krM	8639	12220	12220	1618138800000
17061	3NL21QHJixP3bKLJwMkz86PVKpghxj6XEbbuTbYjrYxNfewGtm6K	17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	1647	846	286	6301	12463	jxEnsMPbmf2poGP9uNKcPEsjngsxg3Hv2v1yZZz1nHPqA8Eu7Bo	8642	12223	12223	1618139340000
17066	3NKG5sRewYxbzh4D89htneg3F3YmyCXUN96oNPhANMXED1HeD8PR	17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	1440	1251	287	6301	12463	jwhy1xHgAymK6WWRW8fGEEpycPndAVLrH2YZrMvznto79hDDNch	8644	12227	12227	1618140060000
17068	3NK42jfsarr8p8bRNVBCBtrtzJGW4xjKewokskEwYwLZErBGeCoR	17066	3NKG5sRewYxbzh4D89htneg3F3YmyCXUN96oNPhANMXED1HeD8PR	329	329	287	6301	12463	jxSJCqddpoJzGpsJJPqqiF8KJcWxBytst7brVcBb4Hii7FTtZdc	8645	12228	12228	1618140240000
17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	149	1283	287	6301	12463	jwavZAHyVCU3hrmkYKx1nb6jZrxbDiXRyyXoJZ4AhCGgKdHL1PH	8647	12230	12230	1618140600000
17073	3NKTPj99enaLpsT1R6kgRvrf9yJkXRhehshD6ghNMTipqcQoX2a8	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1546	1093	287	6301	12463	jwrdg9H6MNhBHCM6bpyqheHLR2RZRPxb8E7Tc5Ji8AubTvibEcR	8648	12231	12231	1618140780000
17081	3NLQuUT8dAXq3dA3QkP6jPFGJTmYXsZfcaZRDmFc4JJ4cYjDqAp7	17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	1564	1338	287	6301	12463	jwyoq7s8yZ2YFyFBUoHTiN2NoAw6EQZ6a78uRVyJ3CDYkDHmBju	8653	12239	12239	1618142220000
17083	3NLJY88HipcVJfHraNmxrVoyKcsEWPCcRDVwhswwtVbQ5eqLG1GJ	17081	3NLQuUT8dAXq3dA3QkP6jPFGJTmYXsZfcaZRDmFc4JJ4cYjDqAp7	1516	1168	287	6301	12463	jxuEhnTF4xZGvKPpKw3FYe71VWgg8ebxQfWur6GReNkVZu8ZWmU	8654	12240	12240	1618142400000
17086	3NK7Zu3osh3uGZJRdPe2kyYTo1g4QsWQKD7tWbaBkatouYLnS9wA	17027	3NKvNQoucp75MCs9zLDvtXEmWik9wJVRFkaHkkvzyZrmmVJmFHC3	1489	1014	285	6301	12463	jxudtR23fAfLS1vk1r9WZXSy5yea1cj1F4pcguQ27foHEuYyK5o	8593	12243	12243	1618142940000
17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	17087	3NLFgPJC5oTJJPAZYG7LyTjA2ExPu6944b5kAyMoQMBdan4mn1dq	1406	1393	287	6301	12463	jwkBiYMpK1FjTfvPWv3u4qRsTR3Mdqhex65TvKANXWF8gQ5FayS	8658	12245	12245	1618143300000
17096	3NKZfEqcJo2Wd2PPf6Qc3ravPAQHGz7zahEMtVbGsnPB4m7ZbbRA	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1489	1380	287	6301	12463	jxoCFXM6Kw8Kagm6yP5w6raQvwfUftm94D5kCVXfAFKi2k4feDu	8663	12251	12251	1618144380000
17100	3NL9RfGBT8ZRUuZkMtpPuC5mfLA7opZuriU9mtCQaXHMH6C3t8vb	17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	1513	1379	288	6301	12463	jxwqRvbv2L8U7CELWfhtB77h7RAagxhWj7jGQjrymm9QpGsEPho	8664	12252	12252	1618144560000
17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	17105	3NKnrNZ9soE6PXRgdpJ9gfamjwiBDXMiT45MBJ3P7WsY9ZFLEDMU	1637	816	288	6301	12463	jxYC6XTCkfUFYRLCQwoSog2dGWUzrbpE3mSAyz9zyVZV5tzEUWA	8667	12255	12255	1618145100000
17114	3NL3h4n12poVuSHJGfpfRTRubnX3Gd3gWxzhSYGEez4MESe8pzhQ	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	311	1307	288	6301	12463	jwQfzXrfHFk3R9qV85Cz11e42GR5rAV2CJkgDgtcCjarKzpyKTr	8671	12259	12259	1618145820000
17120	3NKR7nQsoTR6T2hHoULHEazRPDby97CA6HNaFsHFNWA7BSEprwLH	17119	3NLo31p3qPdkW7QRBe3iJhzAzFQzSfjDWJyUYXKFsoFixKdTLFV5	1476	1005	288	6301	12463	jwzBW5EqGwoUkuigh9ku6jq8Q3VjQKEmEgoWK1qSnwwyHEe8aNb	8674	12263	12263	1618146540000
17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	1670	1282	288	6301	12463	jy1f6uuwKbfhWRGD6USU76g1qYquyeKXZi7k9jWtht31s6p1BSQ	8676	12265	12265	1618146900000
17125	3NLBcx5TtYPMyYTpXx5PTtPahV8jW6eijbb8W8KnLZh9soHB7mso	17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	1647	1056	288	6301	12463	jxYorkYgoZ8F6sQHiwEUpECBFkRmESwnLnRtzstd3LuhjB8zFHZ	8677	12266	12266	1618147080000
17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	17141	3NLiSperQxM59fXF8MNcYx8zrifRJqZBsobwiDnALptxLi1mKzLy	1608	1043	288	6301	12463	jw9yPHLDZmChQMuwAwKDz1wTVzBVqFs8mWW119EvCtrhszfUCPi	8688	12280	12280	1618149600000
17144	3NL5x2de632bcojhU5UEKUwBX6g8ceoASkqS7xJRagEra6yBLFMW	17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	1458	351	288	6301	12463	jwibBVSNdWD62zfdizkYTbn9tEMtrmwg1kds15q5n2KXwMnMF2F	8689	12281	12281	1618149780000
17150	3NL7pucqc9mnMFRKf1KeqfGsCVFmKVGA7deNy8WRaJ9BgFYRnn6F	17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	1609	1207	289	6301	12463	jy1NEu6KHrTnbvdGaLZFRB4pACjzXeDMyqkFQo7gNDLH6v4GT2Q	8694	12287	12287	1618150860000
17156	3NKevaTPGyjURyC5pybH7HEp9BmAzhZwtzqnDDoPbgvEpBiwSxnX	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1455	1206	289	6301	12463	jxtCyUuCLYiQ26yyaprTExWMcAuGAvDZDpmd6FUjaFTqutbbof2	8696	12291	12291	1618151580000
17157	3NLAL2NRDfmAeXutss19e1p6TiUkbGx5FP7rHDXtAwG2Uc3R5cvR	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1448	1185	286	6301	12463	jxqwsKYKjk9hJMeMFfyQZWZUfjCitS9jGq2Z7uRZx2TWaXoCFx8	8627	12293	12293	1618151940000
17160	3NKxu11uUmHbtdj1TeEuNaArmwCPkuQyS9dMziNsevkWpy9r7NC2	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1448	1185	289	6301	12463	jwdXdV2ynJnW2dQXkeWvSYWjLWySCn7Fjed9RaH9FYfdGMiZKd8	8697	12293	12293	1618151940000
17164	3NLkAye8RFbFNRJ4bQ6FNW3JDtXWXkd4T5eEPpfDZKvtRkx9sN1M	17163	3NLMadn3Zr7BcCwJXVQ3PSndujfk3zyetz1GLjTSjNhZwqMzurro	1580	422	289	6301	12463	jx6NuP8JN92X5MLj6fknGqFWiw2V1EeJsV9WeveUMmGc9n6LhpD	8700	12298	12298	1618152840000
17167	3NLhHZPhXVgusjvM7NJkgUsD4THkUvqe5PsGwMBWN6LDD6QmwHmi	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	1596	1363	289	6301	12463	jx1zhvsw3VAFKXnN2rjRMxCvs3YgrHck1fykdSgCJSJoLr72Ukk	8702	12302	12302	1618153560000
17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1627	1385	289	6301	12463	jwK4s4mrCXCdvWJ2BzcwBsPtvSzcFDSeoLbmYN3hVQF4KPoRts4	8706	12307	12307	1618154460000
17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	17022	3NLiHkHuUUyCFaWppWkrHTeCbDTMMk7XA2qm3qcZTAVRino5Afnu	1489	1380	286	6301	12463	jwwdcs92KTQDcduVeG3WSeUZ4RUDE83DxShgNrbFynWMqmSeiGd	8623	12202	12202	1618135560000
17028	3NKkr5wDnR6UCztqYyFBURckh1L13q2rJAc8U6etmhX77V8ohtvs	17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	1593	1346	286	6301	12463	jwuaCo5g4MAxdZh6Wtr5cJUpvXyuKkg3EzsA5DyWrup9Amg8zwE	8624	12203	12203	1618135740000
17032	3NL7BYFUh54C8LP24eY5ZLjfo6uvxvsfW228oJutM1QEhGYmxNjg	17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	1649	1383	286	6301	12463	jwezvFxwoKwLbvmu9nqTwnZWbS4HsE3UM8hWRHt2b5uKqqp3Nkm	8624	12203	12203	1618135740000
17035	3NKGm19xyNn2WwUbDwBgPunjtXVnvTT27us4CumXrZgkCjzJYrnx	17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	1599	1041	286	6301	12463	jxRsTThrbJW7NiMBGU1kQkYCoaLNuP8KGTSPJpBeHpdtDs9BdWs	8626	12205	12205	1618136100000
17037	3NLvhrUJR3GDyGvpkXj7Sch9vAEvbATXAhRX5uAi8kMBZU3QvZGN	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1637	816	286	6301	12463	jwK5SaNx6ctLzgUoymKi3vBCSuiHNYacPubTjFtSPrR91oCEw1c	8627	12206	12206	1618136280000
17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	17041	3NKHWMSC7QzAGjKmrL5wtCtghyoBDe98AZHSiQPBkiKXgY7nj4D8	1602	1243	286	6301	12463	jwjPeKrF57npQU9Ws9AXybAkKzKoQFDYUuMnd8y6DSuiZKUr9bK	8631	12210	12210	1618137000000
17045	3NLmgWHipZhKGv8MFaEpCqj92XQ23TF4n4RPLheho1kNt55RqaXn	16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	1672	1285	285	6301	12463	jx5Tku8wnyfFYyQELpQe9oSF3bNS2Hm16cMEStwRQjqiRFXvc99	8596	12212	12212	1618137415315
17054	3NLYp8UBM1ZSGJXXmSxk27p6RvaHNVs75ZwNwYWvQLRG3Gwd1zeA	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	1542	1058	286	6301	12463	jxgkYjDDXo2M8znsgYnD3e9Xv3WjVcrzk3HgXDT6YUgjAW2nbo2	8637	12217	12217	1618138260000
17059	3NKAYTEBybbGQdt5EzY56yEUigWY3SrbXnCATmSv8unf7CB11Bui	17058	3NLm9gwrtXC96zwCFbgfetswZUJvxTNqp58WbCyJzBNtTVt27Shu	1403	824	286	6301	12463	jwKNi5BXRnAS22a5N12cZima4duAQByMygmZuC8gCAgzWdn3mys	8640	12221	12221	1618138980000
17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	1508	1261	286	6301	12463	jwmnrBw9tZjpy9Fh6XSXQJSkYYbXXSHSZLpesiv5CSDDYKh7ZMq	8642	12223	12223	1618139340000
17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	17068	3NK42jfsarr8p8bRNVBCBtrtzJGW4xjKewokskEwYwLZErBGeCoR	1444	1135	287	6301	12463	jxzXcKG4annGymq3S8hhvnE4yPNbXXtEbe3Hb1s84rmiMSVTvLA	8646	12229	12229	1618140420000
17072	3NLoc9R4aZwk5vssVSZ4mmpn73kZLNKkJwj121vrCCVm3PX94XpY	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	1601	1142	287	6301	12463	jwamcSesHEUf7fDdp1Jx58Cpt6Tftj3z74D7r53kNBBLpDH7esc	8647	12230	12230	1618140600000
17074	3NLkkMbKPcbam7fKRvEa4DJX1w1b4RVZHDgrFrjHiDboQKgk5SjX	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1444	1381	287	6301	12463	jxjvzDSbZ3JRpFUfb19DtAxvWQfQTMhreAiq9a9qE65F88bqqmF	8648	12231	12231	1618140780000
17078	3NK7bQaFC6e3qYsRjtx1DYtkVsx4heb3y2Ex6UFP99A4k9gY3NQc	17076	3NL3XWfuhR5MdM6VTan3Axmp8Gzb4T5FcNFB1QrNHkQ4w5o2a9Yr	1637	815	287	6301	12463	jwy8TVDtyj4Q5YSFWJn92gFsPPcmaUfFzhms4MNL2khBcuUWLiP	8650	12233	12233	1618141140000
17082	3NKUZpZGcWNPPQiJL4L61ESQwhcKrrgSAc2rJAdo2pFM3y8LADAk	17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	1536	1313	287	6301	12463	jwkdkZUyxp56SyAAAMMvkD3ekD99UTV6N3691RCMW6yT6Tw3Dqw	8653	12239	12239	1618142220000
17084	3NKtoj54tMtBbWi3s3C2SACRGjpUYwurUdxuLLvX1Gqb1qC9YK1Y	17083	3NLJY88HipcVJfHraNmxrVoyKcsEWPCcRDVwhswwtVbQ5eqLG1GJ	1407	1395	287	6301	12463	jx8tq6ryWxLcVWyWiD1b8SJknEds1iGbMKvpW7sxTorQsWYUx2c	8655	12241	12241	1618142580000
17091	3NLeLrfuTQwv589aWJHWzVxbeGJYjGxdgwmHcUsqf1AHTmpPyTZX	17089	3NKnrN9qohgHqLokxDZsaaSXydfHqbXhhTB1BhFRhRrD2qKrffqj	641	1336	287	6301	12463	jxWra21X9ZsNfvtyv7goMocY4ekmktHJoiZtXkTdnLdNs7R9RmS	8660	12247	12247	1618143660000
17093	3NLUouUJXpqpMRZAEUGFrSCoLrThw3L3aRRnxxbiB2C1hgMzdFGM	17091	3NLeLrfuTQwv589aWJHWzVxbeGJYjGxdgwmHcUsqf1AHTmpPyTZX	1600	1126	287	6301	12463	jw9Viiks7pywm7DFRfDH8dMwUgAoKd7Rcrmf8335yfeKgYGnnKx	8661	12248	12248	1618143840000
17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1657	1344	287	6301	12463	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH	8663	12251	12251	1618144380000
17103	3NKMBh5WhBGQf4DstoGr8932e3Ro8c2n5x877Ey1dJXNK5ZvUFmr	17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	152	1204	288	6301	12463	jwmVQXvP7J87agbcJnTG48S78fCu6LLcfTFpgVtL38hAJUfkT3c	8665	12253	12253	1618144740000
17105	3NKnrNZ9soE6PXRgdpJ9gfamjwiBDXMiT45MBJ3P7WsY9ZFLEDMU	17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	1553	776	288	6301	12463	jx9hwAkQb4G639KMzJ65FUh5NggLBBWdjUFNtEa1CLKbGHCQauD	8666	12254	12254	1618144920000
17107	3NK3VmTACTseigeSWvduhkMY8vR3Lm9PYKD7obi6JYpFMXWGYtzM	17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	369	1312	288	6301	12463	jxxbz5LknJZmXdWwa2hx7mrts5hh6Rnnzp7H6gVGfBx8r9G6rya	8668	12256	12256	1618145280000
17110	3NLDTRG7ZLVB8bgjqs9SbMAf141ira3eSxi76q42HgrBKAUVDrUh	17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	1633	1390	288	6301	12463	jwa3B2Z8VkJrQGRxqXvrMFo6K2ue8De4qM4ZKFVEFkWGHRC87DD	8669	12257	12257	1618145460000
17112	3NLCyxw3rhQRMx5e3zFofRUBzuNKtiAaGFAFNvTiHCPY8bgaPGqF	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	1610	1314	288	6301	12463	jwv6mVxiYd25ajtPTtZCYky1sL93fyoLudcTBt8UUXbVR8NTWv1	8671	12259	12259	1618145820000
17116	3NK7u31aFSnjYH5JriPUKaPjynRdQ645Vbn3eL4NV6keC18EHYMw	17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	1571	1335	286	6301	12463	jxQJ6gTFdLVCjgXAmF7WMfE88tjghLDXTBkQ1CiGf4KScW8A8VY	8643	12259	12259	1618145820000
17119	3NLo31p3qPdkW7QRBe3iJhzAzFQzSfjDWJyUYXKFsoFixKdTLFV5	17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	563	1359	288	6301	12463	jy2w589K5SfQHmeMxuhbCkrc5ftWniYokkPsWKASTVfgDFxG37W	8673	12262	12262	1618146360000
17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	17120	3NKR7nQsoTR6T2hHoULHEazRPDby97CA6HNaFsHFNWA7BSEprwLH	1406	1393	288	6301	12463	jwfGqtamgzFX8g2W8RaUKi6Ube8s8tKoze6kf1E743BRsHCSpkJ	8675	12264	12264	1618146720000
17126	3NLe5k4m1XC5ayRXiip7kXTeJt79gZZUNmRTFur6D7RnPzaqYouv	17124	3NKE96Me2khRDyVzjTzN6sMsW58RwWUSA67k7cAJ4wcx2SvRGFCB	1489	1254	288	6301	12463	jy2iWF2Gpvd9yAatvg45f2X8we9MzNu1MDeLbGvmba8H7AH4mGw	8678	12267	12267	1618147260000
17128	3NLo9H2r6Si6KxqrAezHQeucRgz4h7PwfQBogQkSqFnDceaWbnkR	17126	3NLe5k4m1XC5ayRXiip7kXTeJt79gZZUNmRTFur6D7RnPzaqYouv	1406	1393	288	6301	12463	jwxKneEMYmvYPJ1Rfehc2C2zeTDVYKCnxKn79jouZQvWeBN38uQ	8679	12268	12268	1618147440000
17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1421	375	288	6301	12463	jwmsQ51nb2xbtS9X9MCqhSvXQw29ps7SAq3PzjnjUvqkkNaLFmF	8681	12270	12270	1618147800000
17133	3NLgGr8VNGbpE3XptUQySSLPnF1wWnecr74BtBPrJ3TccVWDkz9k	17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	1513	1379	288	6301	12463	jx3UXNMoPy5rs3oY6amZRVaHr9cK4MtAWq6bq9B9pCriwZWRHuu	8682	12272	12272	1618148160000
17136	3NKR9HqMf3RHYPkCLKRWox8QUeYXTArUjU7WYpmGdW1tcv728UeA	17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	1403	824	288	6301	12463	jxrEcDjRBA93vHSw63bZWc31SjwQ1xg6vVTBroGQqUbwiGjPBGb	8683	12273	12273	1618148340000
17029	3NL6q9ALL1r2WE2hfjV8b2ASMVxRd8gKXkM1CPyqf3vNedBBZxzR	17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	1649	1383	286	6301	12463	jwzv3r5AvHdewdso13JU43J6NRAFz33CBmzLRBTuBo6mjos9CR7	8624	12203	12203	1618135740000
17033	3NLDyvNxYchatGZFUvkX56pGyrD1dEqD6AwJ6miqXpR3CTrN75sM	17032	3NL7BYFUh54C8LP24eY5ZLjfo6uvxvsfW228oJutM1QEhGYmxNjg	1516	928	286	6301	12463	jwfDuapKDfUF5K59WkDnkh4JedP8zxvzTHj5nSFkEvutLDbxhhk	8625	12204	12204	1618135920000
17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	1406	1393	286	6301	12463	jwL9T82rUgyMTBsuhwDCWAZYsGZ4ANZ4hC4ctPxxy1FhtE3kAea	8626	12205	12205	1618136100000
17038	3NLCCQVJvijDTGyoupqzr6seEEEy4u8RHn3E8au6ukABWACqUDHR	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1407	1395	286	6301	12463	jwBuHZDPesjx1H5xy1oU6gFyqt1RcrwqHi93QBTKU7x25py8QY8	8627	12206	12206	1618136280000
17040	3NKLCvh2GVZYhAx8RZnjZLygP2BQmm9C7BAc4K4V1qb1VzjpCm63	17039	3NLf6knir91yfMNLt9vxkLE8PQ9tkZ5qCdiWwX4wi8N2GxojvEbT	1529	1070	286	6301	12463	jw9k59GLnCsKTjsQnRXzCLVUBroqikY4W9Ax8mma7othrVaiqW2	8629	12208	12208	1618136640000
17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	1672	1285	286	6301	12463	jwogSJXcrUHqZMFwHRBV9f2hZ497z4wuyMQdLtABNA1JRD1xJHo	8632	12212	12212	1618137360000
17050	3NKZhVBVGGeDfVCCphEFPJ9Kbge2FtoxacZDcVVYyed3skUBZrZi	17048	3NKQsdnjX3Nz1HgUsuNvDQ8yfcpXv3UaLyqzDDKo9vvhD5WinqkK	1406	1393	286	6301	12463	jwWD8ABfwZc1E6bcqPYKutu7T2pEyuGuhXtjey8GVjJg3eB1zQE	8635	12215	12215	1618137900000
17052	3NLpitDQKKuUFatogn9FwkPWaAXVMt62Pp7QgpoG1q5KakJgQUiE	16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	700	840	283	6301	12463	jy3HsuCjP4gQZWYhDVxpGg8BsRneLNh5jKCL23JvRJ9VQcAQyMs	8567	12216	12216	1618138080000
17055	3NKoAQj1JNXBnXQXPVBZfeqoknb4dEdJt5kvfDk4mUbB5YD6APCd	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	1542	1058	286	6301	12463	jw83jTBC4sEnwBqXj1HxPrw2zUDQaCVVJ2hDGcdzxM4wRWTMMcp	8637	12217	12217	1618138260000
17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	58	149	286	6301	12463	jxHFKFsCcztSoFUiukRtXVugcDMeMMTwDGawv5GbErSTtBwfBNT	8643	12224	12224	1618139520000
17065	3NKswBnAxntSwqgHYoc5RYSG1hTPxNKrVAWGxYnLshvYwSC36Ykb	17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	1440	1251	286	6301	12463	jxKxhU8RF9QwHKTzXxdU1botmdhxT6rN3q9GwgUvqMgXVRZ3drM	8644	12227	12227	1618140060000
17067	3NLtdPydZV8oLQon2pXf4XkTGNAeLfNRCc4ybvrufn9zywZargoN	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	329	329	282	6301	12463	jy34iAGKvMQdpH74KpNcHnhiEd2F3a64qyZPtnpxDS8iQ2HPCg5	8541	12228	12228	1618140240000
17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1546	1093	287	6301	12463	jwNxtWVDvzWh7RN3KMzwVSGwwJWGEon9QMeLWmnReBhQ361m1hQ	8648	12231	12231	1618140780000
17076	3NL3XWfuhR5MdM6VTan3Axmp8Gzb4T5FcNFB1QrNHkQ4w5o2a9Yr	17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	1668	1244	287	6301	12463	jxZ4nBJZA3uq5Vuye7FuBXVyPE9ZCisqYBKZWLUKXAJ2avFmH4J	8649	12232	12232	1618140960000
17079	3NKGNx7wr9Yh1u7NFfE5yp1YMBN6oMTvdptV27xc1X3nyhsnWkJL	17078	3NK7bQaFC6e3qYsRjtx1DYtkVsx4heb3y2Ex6UFP99A4k9gY3NQc	1407	1395	287	6301	12463	jxEkDqkQUdsgqbPFXV7bBeSduiFqubfsYwcRagWAyyxuGKbV6w3	8651	12235	12235	1618141500000
17085	3NK7GnkmqJGT1J8uZuJBAieiaGvZs3R2PK1ypDT6ZUBLN9ZMjHHE	17084	3NKtoj54tMtBbWi3s3C2SACRGjpUYwurUdxuLLvX1Gqb1qC9YK1Y	1489	1014	287	6301	12463	jwYi1im54LFdyZrTfPNLxV4xjCUwubPLbJfT8rurkr7vJLxF8nz	8656	12243	12243	1618142940000
17089	3NKnrN9qohgHqLokxDZsaaSXydfHqbXhhTB1BhFRhRrD2qKrffqj	17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	1467	1376	287	6301	12463	jwmByctHGW7ULYoGiJSqJSDigNYi1P9nierEHi5kwogAU1gNVAK	8659	12246	12246	1618143480000
17092	3NLH4QgVtSTY9vcQ53kDMXDwtV3fhJZrR5Wbq7jcWBZni4MynwQo	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	641	1336	281	6301	12463	jxhbJ9mZJ6Pk1XRgpWyJtZPctjjxGG2amPSUjhPsafPYAkXXAiR	8522	12247	12247	1618143660000
17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	17093	3NLUouUJXpqpMRZAEUGFrSCoLrThw3L3aRRnxxbiB2C1hgMzdFGM	1627	1385	287	6301	12463	jwVr5ns37C5QrHG6t1PfRLwr8tApCpQSCSmvNrVU8j6AsqJzMk6	8662	12249	12249	1618144020000
17101	3NKgbYxLKhUJz2AgfbkGgim2tYT3yQZAV2YQ8Jq63pL2kJ8JHKB8	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	152	1204	285	6301	12463	jxxKhC7XDmHFWYyxiu5fDqHirZFAEBbcdPzDfsQnkxFxo57dxrV	8618	12253	12253	1618144740000
17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	1590	1300	288	6301	12463	jxAc56dsrzueS1iAZGNC4gutttyzGbcMRVbV18nQJd6YPUbUTaz	8668	12256	12256	1618145280000
17113	3NLPGpnXwL7AQVHbCxWTeNEd5qbXxtauLAmB43v7ygRHDGtFs7xM	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	1637	816	288	6301	12463	jy17mY3yUwPG5vQHvCWEXADvf52P2SbvYLAgPTokd43aMCBoqS5	8671	12259	12259	1618145820000
17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	17114	3NL3h4n12poVuSHJGfpfRTRubnX3Gd3gWxzhSYGEez4MESe8pzhQ	1673	1122	288	6301	12463	jwVvi3VwsjweW3ymWhwaFLrMAcaTY7ZFd8Pvv7ipA1qWwp7VbCo	8672	12261	12261	1618146180000
17122	3NKW6UqDD6TUiKx4c9JA6bRL3VkCqZYrT1K5pGmn22FYk3H19pia	17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	1522	956	288	6301	12463	jwdeHpKTMP3gguws3HBLthzJx7SnGeyznBn48g9aD61c7HbFSvY	8676	12265	12265	1618146900000
17124	3NKE96Me2khRDyVzjTzN6sMsW58RwWUSA67k7cAJ4wcx2SvRGFCB	17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	448	1179	288	6301	12463	jwg17AVB2G6xjKRwsw3yMbL6ek6D4YEWevZoQ4CkxuHcLm22Lx3	8677	12266	12266	1618147080000
17127	3NLFPzQvWamJ4FDotiZwvHeWLM9MhbrthEeqw2SnTUvRz5JHELtg	17098	3NKdQafoPV6pzEUHn2fXQXwpGF5e3Fjy2X5h7KpkVrmFqejWkJ9F	1489	1254	286	6301	12463	jxoLvYXuvsgPXR1mkUMgei15TmGvhhWfGxpdJMwxaoxgkyV1ZgM	8595	12267	12267	1618147260000
17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	17128	3NLo9H2r6Si6KxqrAezHQeucRgz4h7PwfQBogQkSqFnDceaWbnkR	1503	1277	288	6301	12463	jxxushMmGkdtQGoMJEQP3KpJWyyt7XSGfcQVJDKQjdxj2EgRCse	8680	12269	12269	1618147620000
17132	3NLfrYDgJ8ySAWMuo6gHcQrHbYCZDSEMoQqsnQxZfmhFnhBMfWnz	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1406	1393	288	6301	12463	jwKAu3M8KRdNHNZgj2Hsfkm9y3Da1NENms1q1KZFiMsYto87gtJ	8681	12270	12270	1618147800000
17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	1633	1264	288	6301	12463	jxbxJuVRuRa9e8Q83jy9VDzWbpaf6tZbifXLHedh1hogqAJ77WE	8682	12272	12272	1618148160000
17139	3NLdHQYuHyNGuVttJTEL6f8XAFoV5xEq9ZC12tMQbCVnQyvMfnz8	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1611	1341	288	6301	12463	jxrsqqZkXAUh4xLYGBCPuyhg4wj4xdDUH2KYnjjaMM5XTW2oZm4	8685	12275	12275	1618148700000
17141	3NLiSperQxM59fXF8MNcYx8zrifRJqZBsobwiDnALptxLi1mKzLy	17140	3NLKN5jkaimpamcnSAZApoQnJMfX9MGBsbMCgcXe5oMC7U9mz33J	563	993	288	6301	12463	jwRke6Zi6HRHofoG5ZPC7PdqBqQCfnXmV6QovN4R7ARQNnnLTLu	8687	12277	12277	1618149060000
17146	3NKMkQj9Nwj5fBeq8tn1yJkTXFLTJWhvKWmhWfrxrrbpL3DLRUoN	17145	3NKKwyameAyKRATVLUtZQUxkBZmZMEvrsd5Y7ehfk1TYAyMAaVYb	1406	1393	288	6301	12463	jwfyTP7iQ5AKxBC17w1MkninmzweeEp43ZxjvJd4LT9bLdBgWVL	8691	12283	12283	1618150140000
17098	3NKdQafoPV6pzEUHn2fXQXwpGF5e3Fjy2X5h7KpkVrmFqejWkJ9F	17086	3NK7Zu3osh3uGZJRdPe2kyYTo1g4QsWQKD7tWbaBkatouYLnS9wA	1489	1380	286	6301	12463	jxSEL9rsP6wy7yT6jQgGM3dXqDtwitDfny8PkcJFogA2CYVUscW	8594	12251	12251	1618144380000
17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	42	1361	287	6301	12463	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH	8664	12252	12252	1618144560000
17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	684	1226	288	6301	12463	jx7nz9cuUAZ6f1K35aSbjHK1U3K3i2h5CT733DBjyWaMwMUc9sa	8665	12253	12253	1618144740000
17104	3NK3z7aygsKbwHTMuTsrxHDmH4RZJckkiJ6qh8xYTkSccA3NSMBe	17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	1637	816	288	6301	12463	jxjeb8ojaNCYushxTdvkQ65xQ2S3WKvuPjJjYMtXn7iC78t5o72	8666	12254	12254	1618144920000
17109	3NKtMLGdueXSYsjbVXLao7y566wKJt5qVG6rhiydY9mR9fxVZ3M2	17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	1419	814	288	6301	12463	jxBwAj3j59P5MMiJG8jSxy9hvcoeSeAEj6BZ96NQ6TSBdoswzGM	8669	12257	12257	1618145460000
17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	17109	3NKtMLGdueXSYsjbVXLao7y566wKJt5qVG6rhiydY9mR9fxVZ3M2	1406	1393	288	6301	12463	jwawoEC7ViiitqdLSANZgatVAHS7ZrSXp58FddwoZJd4NNRHf6Q	8670	12258	12258	1618145640000
17115	3NKEUWyGk3u2b1uVEAjaS5SLeBXWQPMiC2gRUvSDKCpT9udreCgK	17070	3NKBNdYW2GBkERuHfQKoc9huzquNgNgAQiLXLhymoiijvh5hbck3	1610	1314	287	6301	12463	jwBq98GC96eGdKwnpumAiiF4wHSdhhnvQHuWYehAKPG5G9Ujuz3	8648	12259	12259	1618145820000
17118	3NK79Stn6HUXwhT4MZgVn6N6gBFZybhaGk5x8NGuTbiNZ438PBzP	17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	1405	865	288	6301	12463	jxKPT9wj9iPrnEzkHcgV5WxprQXK1zuuwa2wtqrBv5uuyTxSPZU	8673	12262	12262	1618146360000
17130	3NLD3fuunMkWD7qgL1RpS3JyiHtKT2XDR68oKEdZSwT22YFL2GUN	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1500	1171	288	6301	12463	jwGTVzSe2HosuH1QopuNhyH672sc9PxYn2Bv2Ax9bBm6KsSFWpT	8681	12270	12270	1618147800000
17135	3NLAMGmHLR1wzz45DzvcasHxPJncdsxfaNDjSqmLosQBbMgwU4JT	17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	1529	1070	288	6301	12463	jxXoeQ7YbNVmA1k9FeK6gWFiKGu1YmZdzWLdwax4eeWEykG83Z5	8683	12273	12273	1618148340000
17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	17135	3NLAMGmHLR1wzz45DzvcasHxPJncdsxfaNDjSqmLosQBbMgwU4JT	1419	814	288	6301	12463	jwz3RcpEYBKzkhUN8VB7wkQTaKX1sXCYbmVpmkhHUGSWDT7NtM6	8684	12274	12274	1618148520000
17143	3NKq4Cn9YpncpEMh2yskuRJXcij349zmjYY7FVRDu77BveiQtCWB	17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	1602	1123	288	6301	12463	jwirSkimPgVyztY2kxQDJGHn8ecyRVKhGgZrjTc3wvpLApQmYjA	8689	12281	12281	1618149780000
17145	3NKKwyameAyKRATVLUtZQUxkBZmZMEvrsd5Y7ehfk1TYAyMAaVYb	17144	3NL5x2de632bcojhU5UEKUwBX6g8ceoASkqS7xJRagEra6yBLFMW	1647	1176	288	6301	12463	jwPA3LM26NXxcfTZnHG3T53WzGVVcZ7PmCiNPRifdc5nntYszDp	8690	12282	12282	1618149960000
17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	17147	3NLL2pie2iC3JXQgAMbWbp7NrfC3YQ9P2AGtaBPKeymsc6eB4svk	1577	1201	289	6301	12463	jxBzt9Yu1QXwweoqRGUdQezXj9wMNAzoCgmKW3sYxBcRtNzxFx6	8693	12286	12286	1618150680000
17151	3NKeqyK6cWqJNm7HZPXyQXWP29JihWpnqwNw2kBiVgwrtVE1Qy36	16972	3NKhu4jByJWLe56rXqKP8AtTUXwLiVe93JttBmZzoG79dWgVncCF	1471	151	285	6301	12463	jxPyKt62RvCJ24pKW6GA6Lq6HPJW2ki7exErYLRGzezwLqcwwYL	8601	12287	12287	1618150860000
17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1403	824	289	6301	12463	jxnZaDYKANLantsTuZNvieFKufi1QdnNRXwAC91h3GASW8e2Loz	8696	12291	12291	1618151580000
17158	3NLL1247JdajhEuzeaajtPU4FYMzfoQL5LzARvmnWuZju5K7YvZg	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1593	1100	289	6301	12463	jxcLxydF6XzT1y8wV5ZhtvCqSvPpcK53vamb5pkR1HpzqzjvTTz	8697	12293	12293	1618151940000
17162	3NKJppo2X4WRiae9aYSQQkTvfMhu1LRUeWyPoJVNwiePXAKmztR1	17158	3NLL1247JdajhEuzeaajtPU4FYMzfoQL5LzARvmnWuZju5K7YvZg	1579	1263	289	6301	12463	jwK4h2k8Wp4BuAdKxsXU7ZjcmErrTU4jB7HAiE4BsXss9fDKeVK	8698	12294	12294	1618152120000
17163	3NLMadn3Zr7BcCwJXVQ3PSndujfk3zyetz1GLjTSjNhZwqMzurro	17162	3NKJppo2X4WRiae9aYSQQkTvfMhu1LRUeWyPoJVNwiePXAKmztR1	1419	814	289	6301	12463	jxYeDhk3nXLB7gXWauvgVnqDEpKuqiwgHhAo13cW8j5TEqALZSK	8699	12297	12297	1618152660000
17166	3NKPbNbXDB2w6ugaJ75dab4qa7Q3pD4heHGiBrK6LCbb8kGkRVVg	17116	3NK7u31aFSnjYH5JriPUKaPjynRdQ645Vbn3eL4NV6keC18EHYMw	1571	1335	287	6301	12463	jy1EeZVGVvFkRfBXhbWeCfvDQw1eLPnuA6rBQy5NxZLM4XeDt8k	8644	12301	12301	1618153380000
17171	3NLdcp9Zcto2ZZMe9PMLLKduxpMrZVBWmM9Kno2bshTbQLsEketw	17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	1455	1086	289	6301	12463	jwr6b2dN5hLUe5993PubuJjEdmcJfrKCdXx7eaqTHc4zRzSPxNU	8704	12305	12305	1618154100000
17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	17172	3NKPvUFJuvUoXaxCAnnasdvSDpHMJzHadyzaF9AyczQi3KcEZKQi	1405	905	289	6301	12463	jxkgcBW6fExrUXLYPVbB69jz29TnPnN7UuTLP7oc28LaUrZrGLQ	8705	12306	12306	1618154280000
17177	3NKRHHQQEnMy83RL81tFKYDjM2gYCJKmuBxpMBz5AEmVyKLY8bur	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	171	1374	289	6301	12463	jxaYnxD76xPAVZG7ZVrkUAgnswfkdzbcCWnwjxtb6UVJXLPuE3e	8706	12307	12307	1618154460000
17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1599	1041	289	6301	12463	jxN3V9ri6GmXVF1cUxgnNQRbeBQAfRKkLSuTUnoNwrPSzX6PXc7	8708	12310	12310	1618155000000
17183	3NLQLbizG7ubii77wJsMsQnHmPbkfADwHGPoE9W5Kohe3mZF7TXE	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1599	1041	288	6301	12463	jy19y1GSWp8frsaNA5mXbf3xuiKZM1invf488LXjHCYoxuYnRZF	8685	12310	12310	1618155000000
17187	3NKqwD3UfNqzcdAosMarnFJabZXNdf45XJKJD5Q8D2v8HmZAJwQD	17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	1407	1395	289	6301	12463	jxQ88AbPjCHHBQ1vRpwpvkvwt13R4e6KYUBDHBdqV4Y6sHCeKqG	8709	12311	12311	1618155180000
17194	3NKSDF1SQTFTFn7cJXqMRqA7hRsPV9zwSJWozyAzUQvXFJmEacTH	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1448	1311	290	6301	12463	jy1Aak1pZFvGKRh4C7RpndE2xjba3HmaJQzN65e8eeDfkCQUodn	8714	12317	12317	1618156260000
17198	3NKw1ooggTCf6BjYZJo9kUKcq9LTWvQqS6nhwjRaBdCU84LJ8Lqp	17195	3NKDNeVqAmVGebE1GVbVv1jpSFM1KUXCTWP2Ci6w1WhFoPJSrj9f	1406	1393	290	6301	12463	jx1gCT8Pn1JVxGk1QHiiKWWMkcUwcVD9u1WhjpHZkNpSmD5Hg9o	8715	12318	12318	1618156440000
17202	3NKMbxXG9MDERA3JTFuReDHS8Lgpt8WgnK1Fkk4TE3axJyh37xec	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1506	1373	290	6301	12463	jwx3ZPsvCvj7RiTrPLRStDEuyYWa48g7CMdrBtJYEnczR9S3xuY	8717	12321	12321	1618156980000
17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1622	1110	290	6301	12463	jwbm49SiCGB6Ta8VXae2TFG2Gtd3VfsVQqtzLc5oQw1VsqLRENw	8718	12322	12322	1618157160000
17208	3NKnKi55UunEXWAWTcJpMPzVmssQZw9v6Ro857Hvjw2L62oemghi	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	563	1359	290	6301	12463	jwQHeidtbSUv4Z1tLwdWPgDxfGxr24oqXRHS3MT76A3TwRihBAg	8719	12323	12323	1618157340000
17210	3NK7C4LnorF3JZEYUERBqFautzDJU2cnuLp3Zakaugb4yQT2SGSU	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1649	1257	290	6301	12463	jwHZEs6QMf2z1RC8G9ULGyvfwp1orf6TmgQWn3P8rjaovz53mTQ	8719	12323	12323	1618157340000
17138	3NLwxb9BEKQ2szNy8uWycuQgntMbq3nFrRRTjHyfrxmW5sHZ5knn	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1600	1372	288	6301	12463	jwDgyFNaafrE2XtGByjad25TYiJJyqjahR87pSc9YJUTbNQZ9cy	8685	12275	12275	1618148700000
17140	3NLKN5jkaimpamcnSAZApoQnJMfX9MGBsbMCgcXe5oMC7U9mz33J	17138	3NLwxb9BEKQ2szNy8uWycuQgntMbq3nFrRRTjHyfrxmW5sHZ5knn	1619	1029	288	6301	12463	jxGmYpsN8bBNP9oZHuFtngAUeU8psk2QpeZ7XV2W9dGsfP647TS	8686	12276	12276	1618148880000
17147	3NLL2pie2iC3JXQgAMbWbp7NrfC3YQ9P2AGtaBPKeymsc6eB4svk	17146	3NKMkQj9Nwj5fBeq8tn1yJkTXFLTJWhvKWmhWfrxrrbpL3DLRUoN	1406	1393	289	6301	12463	jxJChiR1jJHnqKdKfyZRtiu9BP37z9U1BS6fKTeWPLfVJBYbxay	8692	12284	12284	1618150320000
17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	17149	3NK8fqTh28gEPheCfFn5W4VSbbEVVENBSmpKFDAsohKg4Z3NgwTJ	1553	776	289	6301	12463	jx7PhbeqyfYAbtBVmTFKAKTVkRZV1pFM3zok1zZrpXE1wdF3yJM	8695	12288	12288	1618151040000
17153	3NKnGwwmcGixF4gnMYUFr9JwC4PTeFovUtY3Br8xF8poV1FwFLZ5	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1564	1338	289	6301	12463	jxSFb2Zzo2Gexef1jPVvUMCTUgWrF1S9VLRfYyDxmN4i3xotYjF	8696	12291	12291	1618151580000
17161	3NK5G89ucYF4rGMEbJYpRXfsEDx2CgJj1TyKGr3FW1B3gnYbQ1bK	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1448	1185	289	6301	12463	jx4gRgi7yEQZAbip3Kc25L1QmSGAEuEUzTPEFKczZnwPjDtXyig	8697	12293	12293	1618151940000
17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	17164	3NLkAye8RFbFNRJ4bQ6FNW3JDtXWXkd4T5eEPpfDZKvtRkx9sN1M	1407	1395	289	6301	12463	jwSogKaZXWoyaUooedqdx2esLBPhRhRGhFC3WHYsyXW8AY1R417	8701	12299	12299	1618153020000
17168	3NLEuzTWaSHuPBZSdoQc5aLocVJXvAoEqJhNd8yQJJJEotdiYmGi	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	1419	814	289	6301	12463	jxGd1D1TaVjNHmj3zDY38Hcpn2R2uWwF9U67MzJGSZoVjcwUgFM	8702	12302	12302	1618153560000
17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	17167	3NLhHZPhXVgusjvM7NJkgUsD4THkUvqe5PsGwMBWN6LDD6QmwHmi	1426	1118	289	6301	12463	jwrH978ji64wMgaWxK9UdGNmZXPobwMqQGjMp6QjE4h26WfUNUd	8703	12304	12304	1618153920000
17176	3NKQdc5gzKi4MyQEYvcvreuPDMV4fQ63M4zFSSTjEyuHRA5bPHQT	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1407	1395	289	6301	12463	jxsEronNJRbXy4qPtNyNAYMgYs8YHHSbHwPyTyGBZfxHei6R3jJ	8706	12307	12307	1618154460000
17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	1549	1116	289	6301	12463	jx63cidp3njevqFps65SF6GhnXKfuGGojHfD5ajB9z7XwXWcniM	8709	12311	12311	1618155180000
17189	3NKVkPvf7YScR99gfMB9pqb8fzCT8ZWE7nJf3WqGTmuHJQSJ6FSc	17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	1440	1131	290	6301	12463	jwVaGFULs5aSYyx28VWWS9i9AsRtU1iQ6K6M9x8sPZPhW56JyJE	8710	12313	12313	1618155540000
17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	17190	3NKaVoVmCQaNo6CJ3E62k9x7h5Jj6pTGoq1BEvZhvVp6YEyPUdhq	1406	1393	290	6301	12463	jxkUbYsqR2uSwG6g3gtzrKRseQ3i7FAxk9uUhhZYKwmKgKGSgi7	8712	12315	12315	1618155900000
17197	3NKUUsyEdHLxTf5Yyyh9zPQALAX8TwVTK9Tu6MXvuM5u7UmPAbrU	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1581	778	290	6301	12463	jxk5zHbFXBfhGetFfKpW2mTca81A7ByURLqHV2RoVE1qMgS8oGm	8714	12317	12317	1618156260000
17201	3NLXcbyvznATnNwRsCbNL5BaxJzTbwMwe8t4gihRCb69hzF3KJZo	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1657	1344	290	6301	12463	jwcHEbjX3CP6tjdcKKL56EReBRNhTVCZn9CnqwU1bekkhzY8E7v	8717	12321	12321	1618156980000
17207	3NKsDKEUQq2k7ePy4EzQMAAaaBGDtxcUGa4TadqBe2aguX8Vw5wx	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1649	1257	290	6301	12463	jxXbwUNAW9TDpJeukYKDKJZ27FBXxvvXpfd4DkVE4vvzaYoLCkU	8719	12323	12323	1618157340000
17211	3NLjpZuzHRHyXQu4QEKfBnQsB9goo2RVQzmMdsRxGYygCPYR8qNV	17209	3NL7N3aXsYYmc4rEFvVx5nXLNf6ZDRN9kZnm2PpgZHyfNe55outH	641	1090	290	6301	12463	jxEWZKTxGunhHgoujhLNfUZC6hmXQMDxkMeLhqQqanPLT7hmJTA	8720	12324	12324	1618157520000
17214	3NKLnXVtY99hvboksCyfydhuJ6q4UucbobmRf8vPKyhPkrSBLGuf	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	1397	838	290	6301	12463	jwiBeMD7L3cQuahZkj9b2aLPMos5KXURLipvTkfsTgLYWgBdYD3	8722	12326	12326	1618157880000
17219	3NLCVMccXRAxvnvPf722YzMniqenCFqCamEPFWwfkTbjQZ8Mpn5G	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	1553	776	290	6301	12463	jxidHDS13sQMikPrpgcyEFiz8H6dwGMmHURFsu5XY2LrLpLarZe	8723	12328	12328	1618158240000
17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	17225	3NKCSG7wYaAD2hGLWZGo5NW64KtvJuQMkd3ARQcHGNVRNEcBLP8C	596	1060	290	6301	12463	jwnLuL3r2pQfhCmU1T2x9m79R4tEznGjCWMAZP8oAcWjzquLH8F	8727	12333	12333	1618159140000
17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	1477	1224	290	6301	12463	jxqj2BFMc7MDGeCyKAiiSwdeE8N85hKEbRFMJJeWXYHMyXEz8us	8729	12336	12336	1618159680000
17241	3NKrMRAyC2dwKvBDNkMZKcQipSqwQ4s6G6Y77E64Z87oCYyan8Vs	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1406	1393	291	6301	12463	jxP9ytq7NnzbdeJPcQgWRyHa3G4VLsTMrXgKvhkxD2EaMc6QXQk	8734	12344	12344	1618161120000
17243	3NLgSfsvs7FKRjSQgBzdciFi1dkeELcexv1VLKV6aYDh2zp2gHNv	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1546	1339	291	6301	12463	jwju8vkExhpei41BjW2kZfg84Q1Fzqsau6nxJCaiDqS8PjWADCJ	8735	12345	12345	1618161300000
17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	17246	3NLBQzrnwNWsMJNZJN3J7TBnT3nFdyU6A8GbKYCSvLcGRzAs22Vy	1609	1207	291	6301	12463	jwzM6G2zkUkVkzjbjzZoL6QPHTXyYxAHvYvP8ge3SdKLpxyH6JJ	8737	12348	12348	1618161840000
17252	3NK3aNKuruz2pi4EUsSgfhL4CZgtPN2wMvzUPPaeMFxTQ4NZW349	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jwQ8qMoDR9ukGYMtsbdjwY2E4CL65KPKqstTgPT1VCGic7te8Ze	8739	12351	12351	1618162380000
17261	3NKCKJxpGLc73t8WxK7ZMVyCczZWU9v35E6Bm9RsiNv8kFmAARXa	17205	3NKWnxBGdoBf7u3ZA4AZnS73yNx9V9BxMWeXburCvMziYdZgH9um	1474	1329	281	6301	12463	jxn559hDonGZruZ2csyzoM32KYzksFbHyeoRANwDmTtmW8KPvtm	8525	12356	12356	1618163280000
17266	3NLRVE8cUMbqzRT6eEk9qMJpuTjMghrQtPUnBXatg76qRysjsfdq	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	171	1008	291	6301	12463	jxfWJWzP8uLuS5gEZtE1EmMpuJ6XLWuSMgGXpLk3iztdiEcz6n1	8745	12358	12358	1618163640000
17268	3NLvWhsP34rYduexTWKxs5DfJ4atmR8ZhkJSCoWpqNw16DTcDCJn	17267	3NKdooKXTLzAowQvwkswra5rwkk9LAaYpBwiYe2QyApVq1rwNJVZ	1633	1390	291	6301	12463	jxxoPwwEVGJSETHiJYgEAGNJXXCqvnAWf955qzcaSc1bV4ya53f	8747	12360	12360	1618164000000
17271	3NKzx9kfQPx1jE2Gv3DyijcmGjp9fVeW7AVx4i5M3QdrWUsU1Uau	16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	1601	1142	285	6301	12463	jwURX5TFDZWVrgGfRaC6Xi8J8TwyguNWdmb1Mzad4yukN5gQFsQ	8608	12361	12361	1618164242262
17273	3NKmSLN5W3GvWNrjqL7UR8J2Ka9ynpZHmV2MgcwBysa6LnvhTqKU	17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	1601	1142	290	6301	12463	jwwnJRS7shjbK73UJY1oTdCTnxHtNeSfYh7E9uTpebEtX5M9zsp	8713	12363	12363	1618164540000
17278	3NLHpebLbXLUVv6fsGVFq21LuSfF2Q3hvQaBtUnHNuN2BrXfXWC7	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1656	1343	291	6301	12463	jwDh21YSQ234tuCT3E1H11tzHSpiv3ZPxH8hAuNLnkm7v1LGiQ1	8752	12365	12365	1618164900000
17285	3NKjTEVYgDbh5q65D4vQbVnBtVc3o1VYZBZvd6WyWo2gBpErMEQJ	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1637	816	292	6301	12463	jwggwuGLH43gvh1MLKm8RYDgQWJ4YeeTKefXiicHsnL7NHUengr	8754	12368	12368	1618165440000
17149	3NK8fqTh28gEPheCfFn5W4VSbbEVVENBSmpKFDAsohKg4Z3NgwTJ	17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	1471	151	289	6301	12463	jxFpXDQf8ArAerh68biopcHeWXMs6bJV3QBY1bax9a4dpoAJAzq	8694	12287	12287	1618150860000
17155	3NKLtjAdwSwG9FxNmwFtPDfofpxfzLcgZVuwq3CjKiVfefrtDiTz	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1406	1393	289	6301	12463	jwuEF5tj7ARyebDxZcNmF9iZxXw7GK8Ga3NuRQQk8MaXYkucqjo	8696	12291	12291	1618151580000
17159	3NKYPBQMjz4GfTiKsy6q4YJgzbroqxN6o1PrpUQCJ5THysLFeLwB	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1642	1001	289	6301	12463	jxpbQTL4pRJcfdof7rTaGX61NpMY5E3dzfQWYgPZ7QwSYwqYQqv	8697	12293	12293	1618151940000
17169	3NKNwivqqNfUHHhBZPYCueSLmGwSrCUhY8N7CipQCKQH1nAhyMqu	16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	1426	1118	284	6301	12463	jweqGEiDrvS7SZfasK5tWWMVZHXAFvYnYwbrbJcF6opGZo4B7kr	8586	12304	12304	1618153920000
17172	3NKPvUFJuvUoXaxCAnnasdvSDpHMJzHadyzaF9AyczQi3KcEZKQi	17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	1397	828	289	6301	12463	jxYhuvsDfUCVDpMuAz8PnBKQLLunp3bF1ZiBt6PdZ7G3BYjpYTC	8704	12305	12305	1618154100000
17174	3NKqwGhdkmxkeoFjESYQbeCWGAjrBd7xkT6exALrW9sJeJaq6cqp	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1656	1097	289	6301	12463	jwCbWU4Q5WD4iUNaZpaMKwC6jiXxmCYomwck4Av3gr4rgk7wBdT	8706	12307	12307	1618154460000
17178	3NLMrzGB6Gj8WKPkkgki9RFm3d5jDWGwwzMQqzh3eJCCSbXFGY5w	17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	1581	778	289	6301	12463	jwyrCR76LBUTLQ7jmnTokGmoBNfNWXuevHWcMf8gWYSce7SmQfq	8707	12308	12308	1618154640000
17181	3NLroH1Hxw3trtXtLBes33YVNkouH1XDx5fsAatnyUitA4DPbtEu	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1649	1257	289	6301	12463	jwELYfU29z66bujr6mNKtBfmRyfs3KuWSiC59PFLPNWLwGmQLXn	8708	12310	12310	1618155000000
17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	1652	1069	290	6301	12463	jx3UFdViaYuVwFe4w6n2rMxp4z3ctq9x72dw83aVaPtMTwoDNJj	8713	12316	12316	1618156080000
17195	3NKDNeVqAmVGebE1GVbVv1jpSFM1KUXCTWP2Ci6w1WhFoPJSrj9f	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1403	823	290	6301	12463	jwHcMZmUn7CaLGbST13BJiRndhvLWbHWLzwhT6NxXBeZdHveTu6	8714	12317	12317	1618156260000
17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	17198	3NKw1ooggTCf6BjYZJo9kUKcq9LTWvQqS6nhwjRaBdCU84LJ8Lqp	1579	1389	290	6301	12463	jwFTKwUVZDk4fzUHeuzvNtfLYxj4gXwa4MTViWRL4X1UUnCi2My	8716	12320	12320	1618156800000
17204	3NKEvFjd14y5AHNBn5M5HdgtPHAjtJyLUzUWKhXGGkCMYXj7pDUd	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1546	1093	290	6301	12463	jwwJRQEcvyr9H7wyZGcGJoNWJKaoUU2ddJxVcaGsQHukQdpWWXt	8718	12322	12322	1618157160000
17216	3NLcyK7Aq1krMaGmoCZM1LfxPLECXsAK4gnWRKwTCMYTVConk1Jc	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	80	1273	290	6301	12463	jwUSs9tbnGckAdT9ZfaomnXag8ymjEA7eHxSsi8ZkfTjZF5N2KR	8722	12326	12326	1618157880000
17217	3NLrou8s5inbzBsffP4RLKCoV1NWGUUaeYbPMRpCQnR9qWzY5fpt	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	1407	1395	290	6301	12463	jxt4bgfb7krRKCojj34j1DtvnmDAJAVMKmQ2sXfUPVjjC8fDaT6	8723	12328	12328	1618158240000
17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	17218	3NKQ9cQghRuc2g5UvnyqXGcJ93uPv2EVLAwb3EPU2HQSERRnprdS	1509	1074	290	6301	12463	jx4XUAEcnwq8StsrZXaEmZsGMr6p3ZvwC1PAWU7FzpXjTibTQXC	8724	12330	12330	1618158600000
17223	3NL8TykCNbGbAFbDcEFkNCzm9sXF78r2ZhRVJyAcvx3cExQyukJ3	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1448	1065	290	6301	12463	jx2LYqoWJVeGesCjpENAuRzdbu4zXpVxhwbCBFMn5Vuzi65qZcG	8725	12331	12331	1618158780000
17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	1402	852	290	6301	12463	jwdBoSqA5nCTJFTUvbyByza8yBYXuC3W5jyksDU3dtmpPc39zEb	8728	12334	12334	1618159320000
17230	3NLwpAENSGMxKdwfHX1sir7X9StZvvJ2sYZT6Evp5apXoHqnAohy	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000
17233	3NK7FHnoCWg9HweLhdBLW7yMGMsgfnXdBncqC4A68wHf85gNakoL	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000
17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	1634	1331	291	6301	12463	jxs5iU8ojzE8GAUMxiNWZYqLreHzTfycuYRjegvV3NTFRkxo38L	8732	12341	12341	1618160580000
17237	3NKeT9BFTa64hZdPNMCdfhjMoR1R9t7VeeXfUtWfHnEXcXEVfumB	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1651	1301	291	6301	12463	jwxo3wnDxCLgHbWrgzbmrhonrRgNAHzKLX6RK8FSS9pYFcM9xi9	8733	12342	12342	1618160760000
17239	3NKSSuhnD1QQzuPGPcjfrSqb6Kkb6bXFXpkrvE27r8SdrXH9iNeV	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1651	1301	291	6301	12463	jwXnp9y2Wv2LNVzwDfPNSLEFw5W1VeoYzCJjDxNDPfKCJ5KPnWj	8733	12342	12342	1618160760000
17245	3NKeiw9gTo4A5urjYGJWNjvRutWWL2eheZpmbr6nSY77Xp7aivDy	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1609	1087	291	6301	12463	jxukxQsUKVxMSiPfcgUafLMwXeVhj2d5P6vu65BNrapEmsVHVDE	8735	12345	12345	1618161300000
17246	3NLBQzrnwNWsMJNZJN3J7TBnT3nFdyU6A8GbKYCSvLcGRzAs22Vy	17243	3NLgSfsvs7FKRjSQgBzdciFi1dkeELcexv1VLKV6aYDh2zp2gHNv	633	1384	291	6301	12463	jxryzSed8qBbj3MXNUohdSMob4z9xXCcp6xs7LBEbCPRZepQdQZ	8736	12346	12346	1618161480000
17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	1671	1365	291	6301	12463	jxJ3rRqN82oVhMMLmmiuX3fjdcJVJmxhNcZNdWK8avPRowE9iPb	8738	12349	12349	1618162020000
17254	3NKUfiEvnMc9ykWP3vDojuVVsES421wfUMSwMESxjViHaffb15hy	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jwvk7eh7BrqnsDNa8DNyHuYpGRSMxiyvbbPJtLpkzQZaokYBQmo	8739	12351	12351	1618162380000
17255	3NLjoToA9QSGUVvds4PVGmAPqB6eC7r9w1nkWrHnrYgU9rhceNJb	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1476	1125	291	6301	12463	jwkC4s4Sw6tSjn68uMR17ALoK4t5EHxxF8Q7wejXq4TiktWqTsn	8740	12352	12352	1618162560000
17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1476	1125	291	6301	12463	jxxwqi3ihEZEdmz9Ka96R5UfvPBaYiaRzduts1nGsFQnUUt21JH	8740	12352	12352	1618162560000
17260	3NKTbr8Shn663iH4rRfFEG8Vp9dPhzZvepHRW5HUmZFVsjZde9Ks	17259	3NKTtQNkwYNjQ9LyDAC6AqTvQzTqTqXw1AmCfVkRRurCt5cybFYN	632	1382	291	6301	12463	jxQmLg2hzC9WG7hKbVxWmFNCboiXETXsyg9vscHavHgszd47enM	8742	12355	12355	1618163100000
17262	3NLSDKgYkZ3Mo3VjXqbRF5i9yNq11eg6s71okDYUa26GUdiHCqex	17260	3NKTbr8Shn663iH4rRfFEG8Vp9dPhzZvepHRW5HUmZFVsjZde9Ks	1474	1329	291	6301	12463	jwNTYkc4ZTXzscQyYYYu8ppS41AtwqFbPngMunLM1FJShtDNvcb	8743	12356	12356	1618163280000
17267	3NKdooKXTLzAowQvwkswra5rwkk9LAaYpBwiYe2QyApVq1rwNJVZ	17265	3NK5dt1XSfXZcwycEit9sxtCG7BCCRr3VQGYWiTQ28S1WTyq7ehq	1507	1034	291	6301	12463	jwGXL9moSKkowhZZ8sEgbLafcUstDFS88qgPW6hQG8GwTY56hsA	8746	12359	12359	1618163820000
17275	3NKeD6SCDZ7Bmw7nKHxMDno8KVjSa4TEMiD5fvkdeocLQwWysTqs	17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	1483	587	291	6301	12463	jwoJNpysLzeDLdJQa5wyHQABUoGzsTJ9vpPtzZf52nnZ6Wdn4ox	8750	12363	12363	1618164540000
17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	1611	1215	289	6301	12463	jx2vYr6q5Hcvx6L8PXxcBrAurn83YjGZCgWGGLVhc1aBDsZ8EwX	8707	12308	12308	1618154640000
17182	3NLocG6XaXXAiKuTNMN1NB8oDXGeNxTWXCYsoXfaoBozA93oRDos	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1578	1296	289	6301	12463	jxz66Dsqq1hBMsgumb2AtcA8HhkXGYdyrbrkCAUEzkXGoSHNtE8	8708	12310	12310	1618155000000
17184	3NLPbbYAodT6jBuTBADFXipX7KMYBwMmmcrwpG1pTJ1EPfw1wa1s	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1599	1041	289	6301	12463	jwJJWEcHMcW99cJQKqqXrQ2Maa1VbsX4cxzkbVpYRBW4Fr17miM	8696	12310	12310	1618155046386
17185	3NLYSrP2idzRqzqxKSxvwvdD9QTerQbEV8VVDQyTXQRbeqMjcR2b	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1599	1041	289	6301	12463	jwdNS3Yy13tQuuK5hsS9Acp8fy37uRwgF4r1P4MAx61GD12LDgm	8706	12310	12310	1618155090237
17188	3NLwnVXzzNXCmUryHfHwMg9K2pNF4qg2W98vPE26dQG3UVbjvYTS	17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	1440	1131	289	6301	12463	jxdVwh3okgy7EARV3WsDGFvvJNzHjbq9jE1SsnH5vRsCFAjEWkS	8710	12313	12313	1618155540000
17190	3NKaVoVmCQaNo6CJ3E62k9x7h5Jj6pTGoq1BEvZhvVp6YEyPUdhq	17188	3NLwnVXzzNXCmUryHfHwMg9K2pNF4qg2W98vPE26dQG3UVbjvYTS	1402	874	290	6301	12463	jxPe8tajMFrn6ds3yptJpq9kndpsU4FCmAfStHP3248LzsENJZf	8711	12314	12314	1618155720000
17193	3NKbZjwfhx3g2vPScVVx4uSwMJkCsXZBnbQCaTLCd1sVPUktNb62	17157	3NLAL2NRDfmAeXutss19e1p6TiUkbGx5FP7rHDXtAwG2Uc3R5cvR	1448	1311	286	6301	12463	jwzbqaYUrz9QASqfXBz825ksSn3JbWGpQgoR9pKSMtN3VrG4ePt	8628	12317	12317	1618156260000
17196	3NKtcEmcLkrpXqumv7bUqddAqWaajZJG13Bmfxuzrny1bBHaVkqN	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1448	1311	290	6301	12463	jwgxvZM4n7msTz4DuCz3xScQrVG4ibqQ2bDxSB9vqA8S6MUV1Se	8714	12317	12317	1618156260000
17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1637	815	290	6301	12463	jwHbcJYWZtPKq3Fb6j9uuT9J88r92SZrDoQwDqt2wxXfLdueUvQ	8717	12321	12321	1618156980000
17205	3NKWnxBGdoBf7u3ZA4AZnS73yNx9V9BxMWeXburCvMziYdZgH9um	16964	3NLT4r9Xrvow13UgTCUFHiKrVEcFkkLAmUTasx9ni2ZgsKevctM2	1474	1329	281	6301	12463	jwiXC97sn9YY7aFCNNwxz5M4db9no8xwZZ7NVWK8nVAAgRm4WKE	8524	12322	12322	1618157160000
17206	3NKY1rCuw4hjSYL55jzQ1CvhFnMWTwJBWAqHfVEwg2XHsAGtJY7F	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1474	1329	290	6301	12463	jxqFDjefypncsvaxUMKWGAWqy2Gk1uv2TsrTgPJPwfNGoc6vZYw	8718	12322	12322	1618157160000
17209	3NL7N3aXsYYmc4rEFvVx5nXLNf6ZDRN9kZnm2PpgZHyfNe55outH	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1460	626	290	6301	12463	jwzEPRcgr2CNogGx1kczxB9mqSvdekPR9Ts9cTVUdLnrU3ZeS1X	8719	12323	12323	1618157340000
17213	3NLe7cCXNTMhvPviCV2DWETdWtHnG2FbCuyuMabq4rTJ9wtdyMD1	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	80	1273	290	6301	12463	jxsv1GwW75vtUq9HjZrMs5GH51WG29bha5ZMJGpydDctEyad6GM	8722	12326	12326	1618157880000
17218	3NKQ9cQghRuc2g5UvnyqXGcJ93uPv2EVLAwb3EPU2HQSERRnprdS	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	311	1181	290	6301	12463	jwKuf47wJi14xKbpCkLEMr6AXdoQx3h794Nz8yEop4zNR8bx1z3	8723	12328	12328	1618158240000
17221	3NKqeBMk83AZwon3tjALPt9E9UANtfayxKbUbwenYUPsNYkjFzZP	17193	3NKbZjwfhx3g2vPScVVx4uSwMJkCsXZBnbQCaTLCd1sVPUktNb62	1448	1065	286	6301	12463	jwn7YY5PtfuteSVjgj7fBQQ82rknALvVm7nhU8Atfoi8nnW2WNd	8629	12331	12331	1618158780000
17224	3NKsqsby8etYaoEaHgWUJATQczH9RQZ8hhtHRU31ZRsVUQ6ZwY7F	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1448	1065	290	6301	12463	jxXU6S4YxcbdB99qznDbCCF74AARJ61uEsYdMmCuGFM4zDFoecP	8725	12331	12331	1618158780000
17225	3NKCSG7wYaAD2hGLWZGo5NW64KtvJuQMkd3ARQcHGNVRNEcBLP8C	17222	3NLcvwPXi4EfpTj3trN91aH6rdDybFYVXvjyGqaiaL6GaGWXEJpn	1458	1323	290	6301	12463	jxWv2hExtLtQoZUz6afEi5ENCeoYpE87f77CoRrt7pbP1UNivqw	8726	12332	12332	1618158960000
17228	3NKc7U5e3V9qvJuoisjRBfdgMYWT8VzR4F3ZySRn5FkV6bVGiCJ7	17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	42	42	290	6301	12463	jxBtLokPBx8rJ1zN6NXF8E5gG4DiD4BbYJVLPCEVveC8okKDU3v	8729	12336	12336	1618159680000
17231	3NKSaG3H2daPdwTpgXbkj1ccxp2GwQLLZ7EemAMyt5tX7sgF72nu	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1407	1395	290	6301	12463	jwobHvEiAoV458qxxKcTnv1Tugv4tCwqezqa15584zdHAZwNYcW	8730	12338	12338	1618160040000
17236	3NLSGo1u8Xzf7kAjRXmmnzEJBL8d8VV6QCukN7Md7yMTfFWha5mT	17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	1483	1030	291	6301	12463	jxWFW9pTk5bujZheMV1b4sTTdVCUJRWrHcC745gC7WANA6oVpHp	8732	12341	12341	1618160580000
17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1483	1030	291	6301	12463	jwHfro1sM2bdPHP6yCo247jiB2mZgZnq3pmAEyrKoZPrim1iUoD	8733	12342	12342	1618160760000
17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1476	1371	291	6301	12463	jwvhMLeh3Y42aq98ntCpgBkoToRdyjbWAD8MkK6FxhrcuWUcPmz	8734	12344	12344	1618161120000
17247	3NL6bemdsc2bKbxJVmZEPGcT1eUPy9v47kyJuRWS71DSh49wsJJf	17168	3NLEuzTWaSHuPBZSdoQc5aLocVJXvAoEqJhNd8yQJJJEotdiYmGi	1481	790	289	6301	12463	jw9pCCBRKbG8UciYYfYW2wmzz9kVmczGfzkC9eT2pqJKP6bbqdA	8703	12346	12346	1618161480000
17256	3NLL6XexhQeEbktvsFMdzaPPyAHvdPL5bbJfy7eojpdKg1VbrhUj	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1642	1001	291	6301	12463	jy2Fe83z8UiHPJVZSt6WDYPeMtJPNayC46iPcfUUDuJ2Vv2yC4i	8740	12352	12352	1618162560000
17258	3NKo6srAME9FRKyGvnZ9Fzh544VobWzdegxnxTKHs9sNhsNYHos9	17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	298	1308	291	6301	12463	jwvd9P3EQAs5m1FXsBpNfAkmk9xBq6RHd3seHFTivFmvyLqn6ie	8741	12353	12353	1618162740000
17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	17262	3NLSDKgYkZ3Mo3VjXqbRF5i9yNq11eg6s71okDYUa26GUdiHCqex	1588	1266	291	6301	12463	jx4g3vXRboHvCD7HDsbvRT4yjieVY81NFa3LyyL5WuUm2vrJw4i	8744	12357	12357	1618163460000
17265	3NK5dt1XSfXZcwycEit9sxtCG7BCCRr3VQGYWiTQ28S1WTyq7ehq	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	1529	1190	291	6301	12463	jx8NBP8rbvkhbQFLQBbb17JYDF5QNUSHUCvww5Etx5aeoAU4mEP	8745	12358	12358	1618163640000
17270	3NLMUVs5nYeFNpVqeKBZyKMguEdLTT2XpWZrVpYteZx5HHa6JEuk	17268	3NLvWhsP34rYduexTWKxs5DfJ4atmR8ZhkJSCoWpqNw16DTcDCJn	1601	1142	291	6301	12463	jxvJN8pc3q9r15qk7Tfg2tED5P1e9vs6ju4wuFpDvTNs8JQWjy6	8748	12361	12361	1618164180000
17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	17270	3NLMUVs5nYeFNpVqeKBZyKMguEdLTT2XpWZrVpYteZx5HHa6JEuk	1406	1393	291	6301	12463	jy2sxpsXYCDKxd3C2QUniTj8BQZ5axCZheGrkZd3pVQEqpoPcrf	8749	12362	12362	1618164360000
17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	17274	3NLu9HvpBHGadHRT5g8WsZNGvpKhEBfmeWyU51HxtSLYbLYD9ifV	1460	585	291	6301	12463	jwnvhEGdgaSHRZGKhVzJF82QCSZm7bGzSjLayKy2v8tpwiVdH8z	8751	12364	12364	1618164720000
17282	3NLcsCNqB2pGPTqTcy4oVCrhFccN6ekPdYqS4CckLBGGhpuSxzDh	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1633	1024	291	6301	12463	jxNFoqooB7YBcH2Djfp3oyvqr4vyCgRWK9a5ZDY3uuarjqGc2z8	8752	12365	12365	1618164900000
17284	3NL4QFLcePJUNtABTzyGyHwMCVgvSfcFU2ijTZzHwQeGDjorwMnQ	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1649	1383	292	6301	12463	jwMEDMdv59EZogzpUZK5tarBQ4oGJ54YexyphBBBfJWNAgKapoa	8754	12368	12368	1618165440000
17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	17211	3NLjpZuzHRHyXQu4QEKfBnQsB9goo2RVQzmMdsRxGYygCPYR8qNV	1631	794	290	6301	12463	jwDwGmUUhCXxU8E9GvtyVcSWrCUKByAcWWWbMFd9rRAJc5oSL11	8721	12325	12325	1618157700000
17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	1637	816	290	6301	12463	jwAorwtNpA4RbSqDRxfspdhbicJxWmmfF2wrYBCePebSs9c39zg	8722	12326	12326	1618157880000
17222	3NLcvwPXi4EfpTj3trN91aH6rdDybFYVXvjyGqaiaL6GaGWXEJpn	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1607	1348	290	6301	12463	jxZXSKjw6yphiBJcA2DHiuoVj48YRFtPaScK1iq6pCeCLYkHPFc	8725	12331	12331	1618158780000
17232	3NKGdmPx8aGAxxH2uU5hu1qruzujdaMcfmtkwgZsWNCPA7gADbKv	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000
17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	17231	3NKSaG3H2daPdwTpgXbkj1ccxp2GwQLLZ7EemAMyt5tX7sgF72nu	1509	1320	291	6301	12463	jxdi3Z8GXYrvH4WmEKDUcZ3CCCFHANCgFtv4yMogr7K8fjEEpoQ	8731	12340	12340	1618160400000
17242	3NLZMnM7vZKmqbVpHRCrY8kkSkCiJp971Rc9Wo4v62baj7KLABjw	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1547	1012	291	6301	12463	jwNmRP58duw5a33P8qqfbZ5G8qsrkh19V2mgZMkp3LAZdczDQq2	8734	12344	12344	1618161120000
17244	3NLmfXuyoNK6xXdr7LTxxfGHTDCbqHFvPp4a8UDWbtS5icqWV92y	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1402	866	291	6301	12463	jxqvsmsXoPHQ632mYD9SXEzZyLkwcdcXdpWV1XS4KbSzA2ryL3L	8735	12345	12345	1618161300000
17248	3NKzsc39CB1ZNTurhUqCkxJrfuw8nEKTtHas2CWRKt2ks5J6iS8D	17025	3NLunpMJknEJk1EwVTL3Hf1YQ3TFxdM6rbgdTex5LbBsMSNYw7HF	633	1384	286	6301	12463	jxGPpAbsacUeDiNs3oND3hYsPaBUY3Z14xNEtWkM31bB2EUmFxc	8624	12346	12346	1618161480000
17250	3NLxs7UUcrQqjshgkvptDMUr8DpXC67XwaLzckak4CG76w445EnD	17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	80	1273	291	6301	12463	jw9te3fSHgfHRJNY4KFy3hsGMP4HW39b1VzMDYohLSNmbUojE5X	8738	12349	12349	1618162020000
17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jxg7rVSbDGHuwgvRkErBMVxnkRiy2et2NxoB8o41SZLYbdfNGCf	8739	12351	12351	1618162380000
17259	3NKTtQNkwYNjQ9LyDAC6AqTvQzTqTqXw1AmCfVkRRurCt5cybFYN	17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	1406	1393	291	6301	12463	jwQGCnBrPsibXD7pkwHWDyE4dCjPAkGWNHPnrwJn3XjMBf4w8S9	8741	12353	12353	1618162740000
17264	3NLtZsybM9r5YfAqBd5bikWeqhQu38wFmss7GLySE2rG1RgEUpUH	17061	3NL21QHJixP3bKLJwMkz86PVKpghxj6XEbbuTbYjrYxNfewGtm6K	1588	1266	286	6301	12463	jxwEfV7q4sC7oJTADJncQmbCRP5H5esKwTWywgkLRsUNqve1hph	8643	12357	12357	1618163460000
17269	3NKcp9PYK11VH6oe34rVyRRCtgY9iBhyBA23X5EmBb5kfZ74T9GB	16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	1601	1142	284	6301	12463	jwbjwssQS9qcskrkp7cqkyo2SePAfwd9NcDHEYG5RQSdKwbjGQj	8591	12361	12361	1618164180000
17274	3NLu9HvpBHGadHRT5g8WsZNGvpKhEBfmeWyU51HxtSLYbLYD9ifV	17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	1601	1142	291	6301	12463	jwbhwoN3iLLYeEn66V8FhZbVEmnynMAE1bMHM8VVQKpGS3P6gQh	8750	12363	12363	1618164540000
17276	3NKjqcUAYM4CyhttwdYrWBoMHG3BDwNmPB2gTbH989UkdmTzp4k6	17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	1601	1142	290	6301	12463	jwbys7RZMqLaeyotkNJYGsQC9BCemDb9WaFArrazQU5cpej5Uxi	8728	12363	12363	1618164608275
17279	3NK8k83YhsfyduqrQNAGAfR7sqbEtnDvwsRceWFmLqnjeLdF6UDH	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1656	1343	291	6301	12463	jwDh21YSQ234tuCT3E1H11tzHSpiv3ZPxH8hAuNLnkm7v1LGiQ1	8752	12365	12365	1618164900000
17286	3NKSikaEgWkwNkA7pvZv8uut8jA5NDR3BEMtNVytrsLFfzPZyuDY	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1647	1302	292	6301	12463	jwQNvGSrjduUaSWfFNpuTvoJMLS5U2W4RuvEsmFLFguDUopJfmQ	8754	12368	12368	1618165440000
17292	3NKvN2NMsEwMnZkKXNYxAWwhPQVwnWhNoCdeFiLfMtkVCxuGtJ4R	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1500	1297	292	6301	12463	jwi6vcr8cDQms3FKVz2PA9LMRXXfBruQvnh5b762HUCjfH6vfvL	8758	12375	12375	1618166700000
17296	3NL8wDt5xy4QajadmwSdMP2AVBjSYrrYNUFQCxmsYZdVAKZ48tZy	17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	1460	1078	292	6301	12463	jwjm9LgGmttuAzqaqyGDL44H4hWHVbPThMJHMbCFUivXq4wsioK	8760	12379	12379	1618167420000
17300	3NLXT2HeyZ18MvquDoSQdb15suRdG7NJwnMNnwt5UN2kfpt1de8b	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	632	1256	292	6301	12463	jw9HVWCvKPJaPkS5kgNsQ3ELCFvPGekcjHRVLKvXGP6vRXNWFFj	8764	12387	12387	1618168860000
17303	3NKFwiHuRVugRAVWKzRSQfdnuWmTbvzdmmNzqfXJgEzzkz3tK6eo	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	1542	1304	292	6301	12463	jwPakYejKBYZRTWoDXUuuSUFU3jwNYH3Xo7UFGzGwJCeRe5r8Dh	8764	12387	12387	1618168860000
17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	1549	996	292	6301	12463	jwShuuz7By39njSVjh7rs12SPQhbsdLFdjQM21BYDTbGy6RVRW3	8765	12388	12388	1618169040000
17310	3NKfvU1XVsyy41hQsCJEpoPLTCusnZLZkWcJ2JExCYdMyvNqerME	17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	1553	776	292	6301	12463	jwg3a7TFaVaA6651tTVRL8g2wDZxxQ21JEAdunAjkPVqjcuzZya	8769	12393	12393	1618169940000
17312	3NKevqX5aUdDrwmmW5Cf6WCisM895PCXvpTRatYRb99YvGoJ83TB	17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	1607	1348	292	6301	12463	jwk6GaCEgJQiEMPuMLNpc2oMu9Xdy9JgNyLhsjZocZEJZYu7NJx	8770	12394	12394	1618170120000
17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	1546	1093	292	6301	12463	jwBG3e9wWBSSngobgmkNHnpx5i4wD2WeubmXrwLgEJCe22ZFME1	8771	12395	12395	1618170300000
17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	17318	3NLD1K3cJE1KzijD2aWfKFtxrq8ixLNHi4prZ57pzcESxf7uqfxF	1403	782	293	6301	12463	jwE4W1577tgRGMD973Rs5eCDcPDribqjeqifcJoPtP6SdoSSsWC	8775	12399	12399	1618171020000
17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	448	448	293	6301	12463	jwdmP2tHyFX9U8TJEHtZM1wjHkVBMYdx3Ybdb1pAFaK8z1ijQdQ	8776	12400	12400	1618171200000
17324	3NKz6joE6ZSd1oLdQoiFrtQVC5DR1oLckV299srpJa8kWt6BU3Ks	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1596	1363	293	6301	12463	jxbxX786TG7qbLUykKQXHL272kbPBBT1GhqHFtohCb9bXuoK1Jf	8777	12402	12402	1618171560000
17331	3NLnm7xpTpoDJz2MJbYyZ3jAoFF8bYawbZnue1Pe96Fmyouh8oFm	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	1600	1006	293	6301	12463	jwwfhiBz8fFVxdDqmRVpY5LjiTgb7o2AsJRgZ8cQU1JSo4f6UeP	8779	12404	12404	1618171920000
17333	3NLbqE1kEFJ55aWuKGimYRYjA3MrKp4VFqffDYQmM9jGE8PLrXnU	17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	1405	869	293	6301	12463	jxZCieNKMooELbwqhZoxzA6RPZaJSTaSiWAMFzaTi9vyN21ykTe	8780	12406	12406	1618172280000
17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	17337	3NLvrMRW36hYyWGisCKHABLGiZe5mqMcowy4kGBqyhV4HHPrAqdn	1403	31	293	6301	12463	jxbBXdMYQtgf5xh5iGzoVRo9M99fCJncLt21sRPKgU42AgLYBzD	8784	12411	12411	1618173180000
17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	1406	1393	293	6301	12463	jxdV2ThFHbcLN6sybFjfXJYhrscUPWqYzEtCseKxkMQktNiWPyS	8787	12414	12414	1618173720000
17280	3NLKNAS891Ar68dkhgnjj23hhbjJ3Pnt18TbtKKEp3JCgDzcrJaS	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1406	1393	291	6301	12463	jxNgNxU4ysrqSsaFC2MZ6jNcms7qqoiagjcuwx9eba4tow3yz32	8752	12365	12365	1618164900000
17281	3NK9ZJZcGjJqTtnzy5ULdBJXgYNY78F9AdnwnWyVLuPJF5hmSXDq	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1407	1395	291	6301	12463	jwXnQunUbs23MvG8Vh6QBfJ4pWMfZfu5ighoFyfojXjRwL7qiLV	8752	12365	12365	1618164900000
17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	17281	3NK9ZJZcGjJqTtnzy5ULdBJXgYNY78F9AdnwnWyVLuPJF5hmSXDq	484	1193	292	6301	12463	jwj5w1o7nt6PDHU9BZzFhatK7vkHLiDKt4ewbnjYfyL8HkzH5wq	8753	12366	12366	1618165080000
17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	17288	3NKs2c4B8HqDh75XcDh8ACDhk3MVGXRNnxsPDLBLmSjxMkDeEWnZ	1403	31	292	6301	12463	jxR2gE4fS2NnxsYAH9Gwra2pyJtK6uaZbz9YVZ9XoFAYfnqpPLP	8757	12374	12374	1618166520000
17301	3NL6oFG3eTzeNVtqMFZH1Cnp3JJStjSaj3YNw47HqDQ6QmK31kxX	17053	3NLjvxtwxiuZvtqheDgLhL7UG94McuKvBn2Cgrrpr1JWd8b8fpXV	1542	1304	282	6301	12463	jwnbCBMJN4VTCBA9erXA12AUDnq9fve74VWw2WbWuitdepjuX4X	8540	12387	12387	1618168860000
17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	1471	1260	292	6301	12463	jxZ1BALMQX42PyWwA6XkodiDRmoopuv9s1Y7ShXFGyEh7HkDyFD	8766	12390	12390	1618169400000
17317	3NKS7wcY82hAMHwCy6pwpHGvqbohjqU4r8XQFFNPiS492fRDuin8	17316	3NKxSNQdCqCER9rnZiFYZfXY4o35kN9yf2cC3rykH7PpJza2majt	1581	778	293	6301	12463	jwMMQER67meG7W6Vr1XiZ8GxM6yCowDmdyYRgrEi5RpNxmtN2Zc	8773	12397	12397	1618170660000
17325	3NKqK2FieQJc31JRFfuKNzHC6fwDUq5ev8X4QvTwLaWVCuA4xMZt	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1634	1205	293	6301	12463	jxU7oNXrPayRLurVNZAvqWij7FMCyZehY9aN8tZzScgKmHL6Dai	8777	12402	12402	1618171560000
17336	3NKsby7qhrxsJXHpsn3GMGCgsaVa1KSXMT5k6Yg2N5a7z622uvNg	17334	3NLn3UHKYZLHTvLrRDGbo3iCHAn4KKyftKNvH6bqvvr6cw1J6esP	1672	919	293	6301	12463	jxeVrrwFKSHVwX61mr7Y5MkK2jggYk3q3vYLcNMLQv5g7TfqDsM	8782	12409	12409	1618172820000
17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	17339	3NKSpf9LRMxHpEhTvk892ds26Cprbm5RzhWs3CvRGD1yZtMQsJxT	1650	1009	293	6301	12463	jwJ4cupfWrXb517d8TZe9XU2AeiVS72FqGgbZ1rv42PYwaHR75e	8786	12413	12413	1618173540000
17348	3NLJ9FxyeykTEmztQzZSguMq42RsdsJJmraVc5hBufP8onwS9Sks	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	1426	1238	293	6301	12463	jxjHo5Knjyz9QfrojEzdPVWAyWrvsan6nLWG5Wwdx3oC6e95kF5	8789	12416	12416	1618174080000
17352	3NKDdHgz5vAo8sdHJif9C2hoNxcL74qc3bpEcHHurR7WszVKSwzS	17351	3NLSdviqqcrVkzeQDEsgseH89WZsCGmVCZrwBoSj5kMDNPDjF91s	1444	1381	293	6301	12463	jwhZv6tEpJDBgeanV5nbXGGJQd8yuxBy9SDYDQnKx72RccaZSCS	8791	12418	12418	1618174440000
17360	3NLqGAqvrDNJ4PuSPdUGPBFMA5iEX4gfqvKoGmijgGfJFUYMiGW2	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1637	816	294	6301	12463	jxUheuBeeK91DL9JLwsFN6DwqrrUGcNXw4gHNUToq7pLePudx5M	8794	12423	12423	1618175340000
17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	17360	3NLqGAqvrDNJ4PuSPdUGPBFMA5iEX4gfqvKoGmijgGfJFUYMiGW2	1631	794	294	6301	12463	jw96NyjiPwKaAWT3SAn5JBEdd3Kqq3PqG4bg4WKcn8zktvStg84	8795	12424	12424	1618175520000
17365	3NLkJ4XZitcVWgsgzffjvVvNnATxaqeKoTZF37kAsuSYouzsMpsi	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1646	1228	294	6301	12463	jxNLqgyg7btbkWTmMwV2iNi7vjjzjDoDqgZhZd4vDP2WHdsy5Pj	8796	12426	12426	1618175880000
17369	3NKzTf6cb1eLdsDhtTq9jcWo4wTGCfWshfMcE6zFUYnhv9f5bTSK	17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	1501	1114	294	6301	12463	jwEwhynBEnxcKLKLdJS4brfamEjMjUvZCzm2F9m4EYHfo1zWYyH	8798	12429	12429	1618176420000
17371	3NKNpRpcFtnvHvVh3qMgvmyFZJTBbi6fwBn5AgCrGXkXTSBa38Ep	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1602	1003	294	6301	12463	jwQDgQ6CE1YWrQaA4HdF7nE2MfTAw88BkRnQZ5Eerh1UrBE91ph	8799	12430	12430	1618176600000
17375	3NKHFnfbQKfNHaYM3ZPz7kksdGhXQZGkM1MTByQrD93SdnvL3k4c	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1602	1003	294	6301	12463	jwZRZWdjuugutvqwsdnqLR5A1DbMw4Lc2B56UtgVvQTccaYg85z	8799	12430	12430	1618176600000
17378	3NL9o56CQvr5e3kLHy3hr8ZRMhKmr7xnuDPrtMUe2LL6eqgjvg2S	17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	1406	1393	294	6301	12463	jxzNUkx2WDv3FJVFHSohxCgDvUvQQAjkhGg6FymandNV1VroJ36	8802	12434	12434	1618177320000
17382	3NLarSAzc7xytV14meEoTHsnMnJ8migYDmFsnysDChSFfx52Xz2y	17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	1407	1395	294	6301	12463	jwt6i6BKzPZeV5xPy9XybLSMsh397ZnkwzWhXQRKdcuM9qCQyQx	8804	12439	12439	1618178220000
17384	3NLAQAP3mXPT14VWFb4BJzahrpjXxHmJpeJEkCqFP8Z7hYWGsgyN	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1422	1337	294	6301	12463	jy1dYBJEn1pK9SpPM35MtKJrZdmmVKmGt8pjCCmae7fTE1ufM6m	8806	12441	12441	1618178580000
17389	3NLVeGQUJ67cmYwjjfBxE8TGzr2yeakhpxjF7S8u539brpGpfjLi	17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	1675	1096	294	6301	12463	jwbyBNPtbZhQVoUkVaeKE5RV6Cu28jkh6jeeSb3BbC5SakgVSJc	8808	12446	12446	1618179480000
17394	3NLWPHka5kE6pvfpyavMhQ1yFB4TUPsEGwex6QqzYEL6PNQUcupd	17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	1419	814	294	6301	12463	jxhEEJP7hFyyxk2oZqnUBuoiuKEwS6kbDuxXnBdaWtaBm6Q5qRQ	8810	12450	12450	1618180200000
17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	17396	3NL8YHUtBXCr6SDB2erwE6LLpTTJYmfXZrba7L8LSpNuDHHvJsBW	1397	828	294	6301	12463	jwaPYJmop8JpNu4cDRnwrM6L1NZCr32YFd5c69yzrRburdor7Ro	8812	12454	12454	1618180920000
17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxJDg2GnkPLHbXT1mA51uoxbMB2HtujLCdDJv7Szymtpmcxs5Ra	8813	12457	12457	1618181460000
17405	3NK8GpJpkR3AJax79uXjyS3ytPDb4hYkcJSZHWc7RK6QMpyZ3aqR	17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	1426	1364	295	6301	12463	jxsLwMmFdCJePwKDLpxrPC3v1Ksa4951F47ibebHhYTzDnqmNTh	8817	12461	12461	1618182180000
17408	3NK7ZvnsgD2fxWLfMu55A7sXHyVxfHN229hCrPwAvR5B116EdC6K	17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	1407	1395	295	6301	12463	jwfhb4LpAqQ9ULzfS4kFuSdekAtpBZQAoKn3NNM4ggZWvBBCria	8818	12463	12463	1618182540000
17410	3NKAgVJNKc5u5ZXMMZTwMahFafDBiuyENTe6dsnmehHdYTSDvyFa	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1444	1135	295	6301	12463	jw8fGyns1Fy7mT8EofGpFRvKDZwUZ5NjMMhD5jCQKBhVoNhPXmQ	8820	12466	12466	1618183080000
17415	3NLSmcyAgXG4XHqvXGFAvPENDgbZWkdykUHH6BSTHhbD7hukoTye	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	1407	1395	295	6301	12463	jxpCByM2Xm5KB4dkjA45mYCwW3hsLfBC2CxZNYQtKExmFQgZFwh	8821	12467	12467	1618183260000
17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	1476	1125	295	6301	12463	jwTtRMjVc2XVVboiL6oxNcbApp8fFJNJkNtLHD5kD476zdo8TEj	8824	12470	12470	1618183800000
17424	3NL8Y663qSz5cT6eVER99Kz9MaCKQD9eAZoq1RxiBp2GsU7pdKnN	17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	1619	1149	295	6301	12463	jxq7FRbbXb4p5qP9Xj1ntS6LvZfL19fDMUduC9VtkVcwwn2oQEd	8826	12473	12473	1618184340000
17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	17428	3NLDa6NVRiAscd2HLekpG4Y5F13yPTiBZN217ags8Ay8yMQAo5sc	1467	1010	295	6301	12463	jxnVpC63qytPf4f5BPnnyr4NL3U9mgX8zmpoRT7Rf5wFDBdHU6A	8829	12477	12477	1618185060000
17287	3NK4dY6dXTaV9ftbVNBQweaDefwB8PRv3HZCS7ppPgUDfnPu7YMH	17284	3NL4QFLcePJUNtABTzyGyHwMCVgvSfcFU2ijTZzHwQeGDjorwMnQ	44	1325	292	6301	12463	jwgSfbY3Sz5B2RDWwaUBa5NP7cc8cgtFkTFjmDVFSmYYa1r2xP6	8755	12371	12371	1618165980000
17290	3NKBuaDp1PN7Tg3tJr34zZujWfLLy2kSUeUXZSEKsAongspQbR9a	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1458	1077	292	6301	12463	jwadF1byB42kqjDyUnRHc9K4w3tyEHpWbvPsB1FJqSfznFm2rhJ	8758	12375	12375	1618166700000
17293	3NK7GUssSYf6iapbu4hLy7CeMvdw3d2sM3dxug5YAgxAj2vn7iqa	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1500	1297	292	6301	12463	jxjekZX69J9BXXtSYvENYFGoN89ELSX3TxQcndkNxi7oVp9Vopr	8758	12375	12375	1618166700000
17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	17290	3NKBuaDp1PN7Tg3tJr34zZujWfLLy2kSUeUXZSEKsAongspQbR9a	1593	1100	292	6301	12463	jxxVAHRMfVLUU4SY92wtLF5mZFx36GLQU1iG2PFTozGMVTuu5Bu	8759	12376	12376	1618166880000
17295	3NLiHFEHRwXzEUYLFxmzNsKHijAmXivk4oYG92Fu4QgUaXUd9WUY	17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	1455	1332	292	6301	12463	jwcMBTwX2AEhcKNkYv75JAgZ1mejR9BbzDzx3vxHrj7oTLewACB	8760	12379	12379	1618167420000
17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	17296	3NL8wDt5xy4QajadmwSdMP2AVBjSYrrYNUFQCxmsYZdVAKZ48tZy	1600	1372	292	6301	12463	jxDgGfC8d4zeemTkaW8TyjQXGPdfNZyKxJLv6w9dQxhT2ND3gFa	8761	12380	12380	1618167600000
17298	3NLo8TejEXz6NJG92ftzvPF2cwjVcc5UxvXPdS5WCbG2RAftzoRo	17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	1406	1393	292	6301	12463	jx1sXSxYQYjFGSVdZ4SahFAy1tnLFvhDLEh8jfC1ZLMMw8JyCH6	8762	12384	12384	1618168320000
17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	1406	1393	292	6301	12463	jwcARMAQrkt67WYxfobzRmbEXYi2zgospPAxpZ9qxQPWzCkLLza	8764	12387	12387	1618168860000
17306	3NK8QvSzmFpadFwJ2uk97Vn3wkxWKc8ESHjrSxYHAseJZvw2pPyX	17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	1601	1022	292	6301	12463	jwAA3MhBQ4L3H2o6RLktRDeqzuAVp2ykJtyF2st1hAN2wkUpgvt	8767	12391	12391	1618169580000
17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	17306	3NK8QvSzmFpadFwJ2uk97Vn3wkxWKc8ESHjrSxYHAseJZvw2pPyX	596	940	292	6301	12463	jwRyEhrWC83Ev5ULsq5KfRawLPWa2sAhKPpmBTgrFErVACCweHC	8768	12392	12392	1618169760000
17313	3NKChLZnBddCmoazxeok8JK1csTsdpU5tf612U1qDN56fY2KKTyF	17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	1546	1093	292	6301	12463	jwBG3e9wWBSSngobgmkNHnpx5i4wD2WeubmXrwLgEJCe22ZFME1	8771	12395	12395	1618170300000
17315	3NK6H3NEE4dHCoxfsqYTBhMvAwmNtZP9MTbrho4piwQTc5gwLd2y	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	1405	867	293	6301	12463	jxDwqPgjBKKzGW7uRSvNFFhLYt6YSuy7fU8e38kBfodBfwbSUsx	8772	12396	12396	1618170480000
17320	3NKorKh6km1HPprfgH3UCVVXbwz3D9eQwHCWzJT84hzisaMcvhV9	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	1403	824	293	6301	12463	jxc3U8enoGt2jdFr1HE2taqF53wJqDpNCPMRqy1VJi6Vm8oNSrV	8776	12400	12400	1618171200000
17326	3NKNafVFnecnp9uuvWDMjUoCuwd74jMaiP3yGZHfBUYbrRnrYkL9	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1577	1327	293	6301	12463	jwpUoS1UNyT8RNB3B8tu1vrF2AHrEo2rxAQa8K6EsTa573Ehpqm	8777	12402	12402	1618171560000
17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	17324	3NKz6joE6ZSd1oLdQoiFrtQVC5DR1oLckV299srpJa8kWt6BU3Ks	606	1169	293	6301	12463	jxnkSmUoNKPcwwRa2iDKdq2buJoct3RPPptswE8X9ppjQzqM6ce	8778	12403	12403	1618171740000
17329	3NK7UZFYcquZnEdPygdbPzRN3JWmbH1j34Lpu5wbJa4ePc5osNxP	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	1419	814	293	6301	12463	jwRTzF6ujNNMoE6BJhwqqy1KeGxHHSJKNLM8uo66EZscpMVfsNb	8779	12404	12404	1618171920000
17334	3NLn3UHKYZLHTvLrRDGbo3iCHAn4KKyftKNvH6bqvvr6cw1J6esP	17332	3NLvFTGtgEXFDg8Emw5vdwaE1CJrbZxqGdxWQns8SGnDERJdF3HC	171	1008	293	6301	12463	jxSrgD18TAR2Sh2DLR8PrigCmwUTYLwTcGJmsianfDCrEZYddDs	8781	12407	12407	1618172460000
17339	3NKSpf9LRMxHpEhTvk892ds26Cprbm5RzhWs3CvRGD1yZtMQsJxT	17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	1675	1342	293	6301	12463	jxXc9td5gzTLtpdGFb9MdhXE4co64fsns6AkwRVhhGkhBBPex51	8785	12412	12412	1618173360000
17344	3NLEt6vnnCBPxi312aNNjDzSbU9EYPf1WRVF3Le7gfNuUtNAWoAW	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	596	1180	293	6301	12463	jx2a6JwsGXHAPgpMBFvgbFv3iLrgxAg6mK1nGoEFgbit8aGCFDJ	8788	12415	12415	1618173900000
17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	1581	778	293	6301	12463	jwspEkErrEUKNS28f22npwgqxZCFzuyjtAJcFjX6QMAAN8B1Wef	8788	12415	12415	1618173900000
17349	3NLSERchRqwfwPm9vqTxMxuK5j395zo6fokdjW8SZAZyojy1LusW	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	1426	1238	293	6301	12463	jxAt9no9z6QDNkvu7AfwpESK1bmrbJJGcGunWYWUC8mB3txm1Ph	8789	12416	12416	1618174080000
17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	17352	3NKDdHgz5vAo8sdHJif9C2hoNxcL74qc3bpEcHHurR7WszVKSwzS	1608	1163	293	6301	12463	jwnfKK5nUSbhkTgB8qwSgrGC3oq4j1aHArnL21nR739R14o2YSi	8792	12419	12419	1618174620000
17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000
17358	3NLHogoy6JkNkzoh9VWvaKSLcz6WJm8FG2EtVZqEj4Nhzk5QXj2H	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1457	1391	294	6301	12463	jwBzYGyrCzWdCk9AhRHzwQKq5YJ34gdLibSudQh5EK5Si1rj1i8	8794	12423	12423	1618175340000
17361	3NLt9bsvqBxQ9YXGqpeRUFp2pTqioVpPYefwxg52VyUY6aRgF6zo	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000
17366	3NLYbzSVz7TrKepvYgQHaRHknkPScCWEEN4vpuKMdhBb1NXmJ45n	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	684	986	294	6301	12463	jxc2uxHrA3hxbeNL6qwKLjXdVfBrWqxmKPdBLJ1EZUjZNuZfyVr	8796	12426	12426	1618175880000
17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	1402	906	294	6301	12463	jxKthnvebT2moX9dnTiz92qNNvBj3jYpwadvyhVPCemEBmMNkEe	8798	12429	12429	1618176420000
17372	3NLSHgRAU9kJASj3YxqKQ9A89q4vFUPYMBDrMPHrVhbjMJV2FRnG	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1549	1362	294	6301	12463	jwqzQs7DJ1vEvGYitgqxEuqZTugy7NnfxiD2ucX33cd8d1SzfXv	8799	12430	12430	1618176600000
17376	3NKAYGSyeqNJKMwsqyaCi4miKtW85ZdTyB1N2Ph1giHFLpx6RgL5	17372	3NLSHgRAU9kJASj3YxqKQ9A89q4vFUPYMBDrMPHrVhbjMJV2FRnG	1403	824	294	6301	12463	jws1xcCWnxwCvArwiMQecgFE46sFadkRtT8p22UCHso4EEtpjZ9	8800	12431	12431	1618176780000
17379	3NKqHfhByxH5gqMwYD3dmvvwgWhtoMioB2kcrsc3Mk9tb7x5dFCQ	17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	1407	1395	294	6301	12463	jxi3D88uMkiXXH6goFFghzngxv7yfrjYrJEvKMPtxDfbkhuaeZ3	8802	12434	12434	1618177320000
17385	3NL4o2iALoHcdgnkZkGY8XYyWaUdQmCDVtmFheGvtsnbueT3rb75	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1422	1337	294	6301	12463	jx8M7ZbG4PrLzJiPgNb8LFd1T5Pyffqu9xHcWLAiSYdfdZdA4MP	8806	12441	12441	1618178580000
17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	1588	1392	294	6301	12463	jxrMHmAAtEp3HdmYYBMhaUWtqAY4NWCMSeqqYZvt7QCkt9ezPib	8808	12446	12446	1618179480000
17288	3NKs2c4B8HqDh75XcDh8ACDhk3MVGXRNnxsPDLBLmSjxMkDeEWnZ	17287	3NK4dY6dXTaV9ftbVNBQweaDefwB8PRv3HZCS7ppPgUDfnPu7YMH	44	348	292	6301	12463	jxEZkvhZ9WNDkqGigncBb5eQ26uXyVqV8REPG1rGdYmEQARxnU4	8756	12373	12373	1618166340000
17291	3NLbLhshTsgSDhmnrk8h7zSXRVAQWy3vTTeVHt9baJB1amBRCZee	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1458	1077	292	6301	12463	jwZXbL3M8CQop9KYFDKozqeys7SvWNspoijAjpWTsz8P6XP2MZR	8758	12375	12375	1618166700000
17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	17298	3NLo8TejEXz6NJG92ftzvPF2cwjVcc5UxvXPdS5WCbG2RAftzoRo	484	1073	292	6301	12463	jy2xRo8S7dLraEbmXRwMnTGcZLYHVgqTryZyneXCSYBGrAow7AY	8763	12385	12385	1618168500000
17307	3NKF1eQ2DFpxcpkvtS75J63PZNLVWib8yQvpyTK9WuuxHL4qv9av	17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	1483	1276	292	6301	12463	jxCcqzzTMEAETZoTNbRa8cYwbJocHjzVFA6zHTowEYN9DqFvQ5Z	8767	12391	12391	1618169580000
17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	1534	156	292	6301	12463	jwbevHRY24SoatRJYCSD33HsobJmaEajw8xkr9irXBTD6kQB4nJ	8769	12393	12393	1618169940000
17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	1607	1348	292	6301	12463	jxJvm2cP623pSJgswmTdKUTUShtYVSEsUEd4BCBscQLwCyuWxch	8770	12394	12394	1618170120000
17316	3NKxSNQdCqCER9rnZiFYZfXY4o35kN9yf2cC3rykH7PpJza2majt	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	44	1325	293	6301	12463	jxXtqD7CmG8F2QvvDtVKDShmDAH7WVgSJ3g2xEmyVPSdjfX9mpm	8772	12396	12396	1618170480000
17318	3NLD1K3cJE1KzijD2aWfKFtxrq8ixLNHi4prZ57pzcESxf7uqfxF	17317	3NKS7wcY82hAMHwCy6pwpHGvqbohjqU4r8XQFFNPiS492fRDuin8	448	1179	293	6301	12463	jy1Yu6YiPuBxp3dn4qsL6GJBxwhNEuUu1NF1pCAFZaDByXFzUjW	8774	12398	12398	1618170840000
17321	3NKpfgqfk6p1eNHQ6GQPM346FeknB38EGzwDMTFZ3CMuaFxK3Wi7	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	1406	1393	293	6301	12463	jxnFj8X7LKQ4GJi84sG4w1NUckaQHa5mppQyFLgCsKK3zuWtFUh	8776	12400	12400	1618171200000
17323	3NLwSBkvciauZ1hDzbPuLXifZFzzkN9WS845kbfvNCrbgKQ1BGYA	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1406	1393	293	6301	12463	jxTsYmNUtsNofBM5miXiuQ2m4N78EJ23Sgcpmcz8RQ8TvoyC6qx	8777	12402	12402	1618171560000
17328	3NK5xpnXiQ6gb4h3fXtArW9vD2sB12wHkrLCQcsSsRLuBnHRRokQ	17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	606	1169	292	6301	12463	jxhQExArD1fR1Krcogz7wrELCKzEQTkGthoyA8qz5rNkmncJh9g	8762	12403	12403	1618171740000
17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	563	993	293	6301	12463	jwjPE7dQGJDELDTVvS5rW5yLJh44yHWTaeiWS6bCWoo2gLcZi7Z	8779	12404	12404	1618171920000
17332	3NLvFTGtgEXFDg8Emw5vdwaE1CJrbZxqGdxWQns8SGnDERJdF3HC	17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	42	1235	293	6301	12463	jxrrvqxYRKnEyR8tyi7hobnLk7b8cgxM1PPeXVyJdGMsxgLY6z8	8780	12406	12406	1618172280000
17335	3NKA8jooGge4bZ2QvqiVtp9Z8egnjVoAzAWSBvPucEwrdEcjjVjq	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1672	919	293	6301	12463	jxCcxnwyRcJvnJe6qY8VLMjibNerpxG8MEFniQR35CBLmWdaKwG	8777	12409	12409	1618172820000
17337	3NLvrMRW36hYyWGisCKHABLGiZe5mqMcowy4kGBqyhV4HHPrAqdn	17336	3NKsby7qhrxsJXHpsn3GMGCgsaVa1KSXMT5k6Yg2N5a7z622uvNg	1407	1395	293	6301	12463	jxdTg1xuM3fGdLvNLE9PHDTy5XtjHNeJVX8yjocrz5aHdhWQnoG	8783	12410	12410	1618173000000
17340	3NKCkRhofLoyuvWeuwUjK2zrcvTu7YNCdfvTHjT1wLSBZ6mMmyVB	17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	1581	778	293	6301	12463	jxXh1CzWoTC4iJ6LtwVgF2MvFh7o3UVhAh7QnZJE1MowGp8At24	8785	12412	12412	1618173360000
17342	3NLfJgMKLnaUvrPJZtx1sZNCMsUnEUgknPTALVxgubmKfEDxqrNt	17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	1593	1100	293	6301	12463	jwjRV1Geh1kkqibWWiA1iSJzm39Nt7xPPy9gc5VL7MmvxofCaDD	8787	12414	12414	1618173720000
17345	3NKn2oknkaA3M1Dk2rdqzseCtrGCgUMYh96MTpXXaAoP39wLgWe3	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	1403	40	293	6301	12463	jwxGyS9XNnN98gGzTDT7fpFx9Zeju8Uu5taKU1X3SPBcU94yNA9	8788	12415	12415	1618173900000
17350	3NKEyEyv1fVSx3KX3ig47XEDKyf9CxcUYZB83Szi7yrh3vFNC5y9	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	633	1384	293	6301	12463	jy315BuvRNgWPNFjK3msWSdfVF3HgU146ix4QCKBxX5pgH5jdek	8789	12416	12416	1618174080000
17351	3NLSdviqqcrVkzeQDEsgseH89WZsCGmVCZrwBoSj5kMDNPDjF91s	17347	3NKFqz2knmTDtnF49p1szgoUthPgj7g3r8TpQJ1qAvxn7NCZK4Mz	1440	1377	293	6301	12463	jwRW9HvQeCZRNJ3bpMouKL8mDMmYVT2SSkXzEjA48thyjq3PYbi	8790	12417	12417	1618174260000
17354	3NLiWJkUzm6spXkRFMjLrDLYgf172r6h6woE7csQE8eft3MqKbRS	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000
17359	3NKzZTyea7ETPRapnucjju8pQDp56Redfprorn2pjKJWfqiUUPcW	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000
17362	3NLVxv3ao78RSNJZiZx5VJE4uQyYQXDPyJjpVHAaWB6d8qp6mf9e	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000
17367	3NLaMWHu38wNhTEVGK2A1Ecw9zsWCLHbqMnGovkuvbbmE1pMqcnW	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1448	1065	294	6301	12463	jxbR1wGeGxzYiqxyuCLo3dbFKyar9ipwV6BcZLc6KHriLqAv2jP	8796	12426	12426	1618175880000
17373	3NLcy11URd1HfNpBF2JvxR27jFKbjij5RMJdShsFEswZxv4RqCGg	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1406	1393	294	6301	12463	jxzFKxUbe7o4pprba2kEExEK77adGi57XqRnnW9F4SwgGEPy27F	8799	12430	12430	1618176600000
17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	17376	3NKAYGSyeqNJKMwsqyaCi4miKtW85ZdTyB1N2Ph1giHFLpx6RgL5	1656	1217	294	6301	12463	jwjCrLN9kNDj8VemsBjh85npBpuhN8N5Jcv5U75AM49T51TJE4T	8801	12432	12432	1618176960000
17381	3NKz8V83wFM6ELha9aGHcpYcFtGFWFR1cBqoZSHy9p81dDvbx73j	17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	1406	1393	294	6301	12463	jxQ14hDYoNKLbzb638DqYq5TEZnq8KhrdTJCqNWoXYWjaCWG6DT	8804	12439	12439	1618178220000
17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	17381	3NKz8V83wFM6ELha9aGHcpYcFtGFWFR1cBqoZSHy9p81dDvbx73j	1467	1130	294	6301	12463	jwePSJvQjqAVXe2CaamVTM7F3BPc9Bqc1yU1PGFGjcAFAw6rLqr	8805	12440	12440	1618178400000
17391	3NLfQp8M6kjKCFNEL82YskKKFmUANLsbSK85eg9TuxuYi3qLHtBT	17264	3NLtZsybM9r5YfAqBd5bikWeqhQu38wFmss7GLySE2rG1RgEUpUH	1588	1392	286	6301	12463	jx3nZ1BSN4tLoKzDPd3vCEaGpMD4Kvh3FseMYz2TPwhAAhyoHxx	8644	12446	12446	1618179480000
17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	470	1309	294	6301	12463	jx2u8W1NxJMkPLJLuqqS6JXoPT63TBeBicmRuoJB4ojqaUM79HE	8809	12448	12448	1618179840000
17396	3NL8YHUtBXCr6SDB2erwE6LLpTTJYmfXZrba7L8LSpNuDHHvJsBW	17395	3NKcwN22kT17XRVXJwWtTunsKF47g9UJvK6r9jnZxJp929pwnKcC	1407	1395	294	6301	12463	jwNwVoYwzJhKisBWNYiVzJL1A6rSXT1uvMyDS7mT2gXTLaWP3VJ	8811	12451	12451	1618180380000
17402	3NLknMnNAWB4F3zudmNSzNUj9uErYrBS76eJaz3w11q5Cx4aUoPN	17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	1406	1393	295	6301	12463	jxu6kA5o7EeJaD3zKwGFaXQaQpbLRKt3KzfRgQW9ZKR7SSzid23	8814	12458	12458	1618181640000
17347	3NKFqz2knmTDtnF49p1szgoUthPgj7g3r8TpQJ1qAvxn7NCZK4Mz	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	633	1384	293	6301	12463	jwL6sKrwHcZWCWiMFVS7Tco1z8NH3JBaaRS6vmAi6VjQt96gPno	8789	12416	12416	1618174080000
17355	3NKTEqdhxy3EiX1AnnG9Xbg6rdhkHrFrqcBy1AHnj6c5aEAa1Tf9	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000
17357	3NKHcYPrc7EY3KGLQdMfgiuPYG8gSq6XkEBWyKo5o7PxjAz96Gof	17161	3NK5G89ucYF4rGMEbJYpRXfsEDx2CgJj1TyKGr3FW1B3gnYbQ1bK	1439	1033	289	6301	12463	jwx6wSw7tDyDT4qgZxKzewHhE4yfCpWzK94UiugPhxTqVULAUBp	8698	12423	12423	1618175340000
17364	3NKxpx4BDNxK4tToY7XyNSyq6HgMRtMUhMERZtbpnYQxEdr1sYZH	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1448	1065	294	6301	12463	jxDoBqac89wxRy1YgEbGtv5y2PtkU1BRaLjcWBRrhYJZtEFHHLG	8796	12426	12426	1618175880000
17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	17367	3NLaMWHu38wNhTEVGK2A1Ecw9zsWCLHbqMnGovkuvbbmE1pMqcnW	1587	1357	294	6301	12463	jwi7pbBsKHt3Xb2vQSprzGWN1PxEaj8iP4KxJmdP1aWDsV36C87	8797	12428	12428	1618176240000
17374	3NLrpQu9vwyhx1t1VBmiRdUVZq9rosgU8hMoAbqjwafN3hBoyebK	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1407	1395	294	6301	12463	jxLWQa92EBakdWDWauKarLARDvGtddUMvYCuTn28x8sAwJE8u7L	8799	12430	12430	1618176600000
17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	17378	3NL9o56CQvr5e3kLHy3hr8ZRMhKmr7xnuDPrtMUe2LL6eqgjvg2S	1483	894	294	6301	12463	jwitYstDtutHBwuF3p7iXqX8wkCvNQGNFLpwdCuKG4TTb4PzPcB	8803	12437	12437	1618177860000
17386	3NLRXFn2jtDB95hHowoT3YTbTyJdpzgbvjRdkToPUsdFMdCXM61k	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1406	1393	294	6301	12463	jx1C9BxA7yGXjDZs32yrDdnp4d92BhR7RAxuvuYzF53xgnAf5PU	8806	12441	12441	1618178580000
17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	17384	3NLAQAP3mXPT14VWFb4BJzahrpjXxHmJpeJEkCqFP8Z7hYWGsgyN	1600	1126	294	6301	12463	jxTXBPdQnNxoYGRbnstgJsAAX1v5kzEJ1qdS8dAo73WLorQbZ7t	8807	12442	12442	1618178760000
17388	3NL8zHMJAZmubi9WTUkc8hLmXqSphwNjSnzispW23Fpv3F2b8UYz	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	1588	1392	293	6301	12463	jwVkZSr6bh6x5ZX6SxcXSoVJHEoAJMm9TAc3jTntCcphVePe7Rm	8772	12446	12446	1618179480000
17400	3NL2bRvtsuTQq9C5EaXPGgzb1mZux4RucT1pAVNMew1fD1WXtPpM	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxJDg2GnkPLHbXT1mA51uoxbMB2HtujLCdDJv7Szymtpmcxs5Ra	8813	12457	12457	1618181460000
17401	3NLQy9CMXu4h8DXXKSJ7ob3XJuM5Qcj91LQJ1yH1TX9yDARuMF8m	17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	1672	1285	295	6301	12463	jwwWWKTWxGPX89C9PFb3cmo3ZrNstiKCnPDGC5U9WYzFH9qQ6RV	8814	12458	12458	1618181640000
17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	1471	1260	295	6301	12463	jx1hZquthKb1QHmzbk9qy8ysZBY1HxUxS6whvjay1ZZkVi4spLo	8819	12465	12465	1618182900000
17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1457	1145	295	6301	12463	jwYjSBaGeHfHX4nyz3SeqymGgv11wRkPjsGe2dL3zeN5EvBmvsc	8820	12466	12466	1618183080000
17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	17417	3NKTKtekbJfG6PZHa6phwXYtw2uJ1mms6Pr5DqfEVLtisXSEiHSd	1616	116	295	6301	12463	jwMAodGUyFhaEcC1a5JQJo5kcVbmKscEFPqFHT7Umhxa6iAv4bX	8823	12469	12469	1618183620000
17423	3NLE28Dp3N7x8HxRFbAnXXfVDQ9pqyvz8EDoorMjkuXGqa4avaiz	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1541	1052	295	6301	12463	jxxAEYBqNHkLrvnNXYWNeFVxaD9YDQx23icLMuovTJbkJ8FzMcU	8825	12472	12472	1618184160000
17428	3NLDa6NVRiAscd2HLekpG4Y5F13yPTiBZN217ags8Ay8yMQAo5sc	17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	1507	914	295	6301	12463	jxXEHbow7trgE7E2zvSio3iXRwcgsuuhXB4hVC3hejkH2bq7n3Q	8828	12476	12476	1618184880000
17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	1610	1068	295	6301	12463	jwDxrC6Z7wGMEXfttVAaXPimRkJzRBWEHLCDRJXt7XmJY4a268F	8830	12478	12478	1618185240000
17433	3NLUBYyeeF5gP49vkyoXvLJ9T19NQwkvKE215qmCcSbXxibHsVnJ	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1549	1116	295	6301	12463	jwMH1DmEqnCM7CV6ckvrFcWbddYWskMrB9qC6WEfENB4NrZLKs2	8831	12479	12479	1618185420000
17447	3NLk1VDoimPP8sGfQoxu7yVzg1KPRFj71pXbrkyePPeub8xD5QbH	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1553	776	296	6301	12463	jwzXk5cChHcEA8Hx5DMnbtWPYQ2M1Kjh3hzdAxAQ9JUeVyntRh6	8835	12485	12485	1618186500000
17448	3NKNVq5VWE9KpFqqWxeZ5pQgEnTbGXGtzhUwnBuTNYpNmMm19jkE	17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	1534	371	296	6301	12463	jx6WNWu9fxocvhEZ3kQNSpeWZ2i4u57Houg9b6rNQA7W62ndvGn	8836	12486	12486	1618186680000
17453	3NKPWsR36WybvQGZr1nJ2iYkLzwbPVCejfoMNiyXv61QKiwj5sDR	17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	1546	1093	296	6301	12463	jxtQ3zrxWAbXpAgutRmm69xnvbMUvzN2VpEYAyaBLBVzaK7yj7X	8839	12490	12490	1618187400000
17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1494	668	296	6301	12463	jxAoevXjGdDiraHu5zP4i4zMNckt6ai6es9BuXNyh4cxVYNZK1e	8841	12493	12493	1618187940000
17461	3NKg81EVCFUhX9SPqujXYubsr1E656njmARn2oJpauhtqUpPHn1e	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1406	1393	296	6301	12463	jwtivSHiTNV5APnQSZsY26E4e4MkMFNZLL5EwvfoMg3xFyvUkNS	8843	12496	12496	1618188480000
17466	3NKRqij9Jo3LmARqhRXHj1UR6SxfXPUN1NsgZHLricwjSqVSp8MG	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	1652	949	291	6301	12463	jwgqdWrK3xdK5QbNMMB73jCwDK9mu4Qd6uGjFwwFD7tr4wAFk4a	8745	12498	12498	1618188840000
17468	3NL9xs4NgKxDtQAXD9oUkMUejQG8QWgw7T38NRcLYPapRxPZqyht	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jwpHG54jjoXttqKb9DjzGhCiQvpgtbSETxAWDWq7UmqWG39Trxm	8845	12500	12500	1618189200000
17470	3NLqjmbZ6q5qUUCaoJ8RRH2WQpyQQitPVnh3mizXcNXegKDbsC62	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1594	960	295	6301	12463	jxhKDR3mP83N4yyf63P36J843K6MxSSgVjstRbvnJCSoAENm2Hm	8831	12501	12501	1618189380000
17475	3NKhmBYvDXRx4eePk499fq13frLFZHWjhCz2F7RAUx1EN7e42LAf	17472	3NKeWYjHqX8FtuFSsgLPoHavStdkfmvSWUHfhwBdTLysFtKvtKuK	1407	1395	297	6301	12463	jxn9UphYDvcHttFWtfsnKaUPjgsRA7bXGQJkSYcuuibbB5xFwe1	8847	12502	12502	1618189560000
17478	3NLLc8DMeAc7nCfgXzDyLkc35oVNMFjoYPyNtRQvneiSDu124b8B	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1397	838	297	6301	12463	jxt7CkXGTguEK6zZMqoc3Bby9gDEu8Gmb6ybZM2xjsK1iiznNYT	8850	12506	12506	1618190280000
17486	3NLqW45pqFgNEQ21ypCfPk7QEw3HF2Tu3TYXwzQDZ1WJGDWC5iXh	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxEDsoTFSSV4kduhkF5jpayX2HQhK4UDw2PFZNCGN5vTkGsLSw9	8852	12508	12508	1618190640000
17488	3NKPK38tgUL4Lg9s1jWqxdBpwRpN9tFfuWu68313CcibzYbyMrXR	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1647	1302	297	6301	12463	jxu2EFTsgSZbQGuihaodN3TY8dbdW4RJANEg4e5H9wSCeaFABkV	8852	12508	12508	1618190640000
17492	3NLnQciDZ2rqVZdyEidz9UWEtmSp7yJMzMYib89Dj8hRk7rBRftP	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1407	1395	297	6301	12463	jwbXiiauzfesudRCYZAfixFBBqxZ4pL9ow7rwyLPkzj5he3pcbU	8854	12510	12510	1618191000000
17392	3NL77pvKDLk4AvbPoeXYoWjWGFksapqgVP7ZRs9hvSwkiWmM9SmK	17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	470	1309	294	6301	12463	jwMeUobc4QbMokdPvJQTiLXx7oTbVyNKydNbdrnjCYXyWVLu2qm	8809	12448	12448	1618179840000
17395	3NKcwN22kT17XRVXJwWtTunsKF47g9UJvK6r9jnZxJp929pwnKcC	17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	1407	1395	294	6301	12463	jxCmYox8Q72MSaJkYWknUbzgM6BAnrdjfDQBcpRhBqpU2PVpVz2	8810	12450	12450	1618180200000
17399	3NK91MsuVqJ1T5xh4FDmkVnsXcoxS3GxkcsYJadVGj3G6CdNRWzG	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxUUcKuaDMVCLqwueoHNUjp2GHSyh2WzNNbwAhgpYmBbDUy1rNB	8813	12457	12457	1618181460000
17403	3NK8UwYd9Xy5StVtMiiK4uX3PjAZWrzUPct7bxUn4gk8bBQcbprp	17402	3NLknMnNAWB4F3zudmNSzNUj9uErYrBS76eJaz3w11q5Cx4aUoPN	1407	1395	295	6301	12463	jwFhEBpex1p6viK1aLwJBNMqtcsoEZTpaPcoSK6XJY7yEPDwFqW	8815	12459	12459	1618181820000
17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	1637	816	295	6301	12463	jwk7TGz53t5iZJLpEeiLL34x1SbdrVhLdaqHUM2nfF8sEtxxtbF	8817	12461	12461	1618182180000
17411	3NLLNNTvucugAg2dv9WhsPeM8JJwbmjVTQoPx35sP4gb5S1woEXV	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1439	1279	295	6301	12463	jxWhC518ZaNmZSH6RKqUfyer5WkMaVgVuAKvRdWHkEr8Zw4iYBN	8820	12466	12466	1618183080000
17416	3NKUdHb7S3524faUrqRgvYaGvwHKvhLuminPvxbD1LJMD1ewKKxA	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	498	498	295	6301	12463	jwZ2pAg2MB8Rh3jJiRBScDauUp1N6EjPLMLhqx3A5LJuLRS85cy	8821	12467	12467	1618183260000
17417	3NKTKtekbJfG6PZHa6phwXYtw2uJ1mms6Pr5DqfEVLtisXSEiHSd	17416	3NKUdHb7S3524faUrqRgvYaGvwHKvhLuminPvxbD1LJMD1ewKKxA	1490	133	295	6301	12463	jw6iKFy1WbEDSsrykqizvywKifPW1Qcg5fKms3moBAoJ3e3jGdp	8822	12468	12468	1618183440000
17420	3NKhtJSKuaiKxNWuc5rC1iB7D9Z6ZW4Kht8LL3jmYhHsjk7reUL2	17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	1559	1353	295	6301	12463	jxz5xqzT5rFEd2RtPyyT4522NC9F3nyFNRiBcHbm8FzQSNoYoDj	8824	12470	12470	1618183800000
17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1541	1052	295	6301	12463	jw9LLsnXxTkajZZHGgVQ8xbSvGMWqG5pzzvPX8N5DLyajZVmqFU	8825	12472	12472	1618184160000
17425	3NKsGYKEKZz8vodqq2oTJajbhWkCxtke71dD3BxdB1gzvdsC6zaS	17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	1508	1387	295	6301	12463	jwyqsLK8NoXYqGo6dXB1yHfXJuBCn4RUs2ipLFBaQvFRR5jAv3o	8826	12473	12473	1618184340000
17427	3NLSNd5nCQCMnEQ74VR4sxPFDL5YMMvwap21e3Q2dtv2nnw7XpFr	17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	1622	1356	295	6301	12463	jy3263Tgm7Ktso3vypbmin3vxFTByRNVMRfFghBbKH1NfFGikhe	8828	12476	12476	1618184880000
17432	3NKFrcKe7JvyTn9CozVz8xSubsgz9aAffy1GVu6c5C3HdxCXu1Zz	17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	1671	1239	292	6301	12463	jxUgRf3ycNe7SJ8NUAvm4PtB9NfMSn7Nttm4bZKbmGkJJtSyx7K	8766	12478	12478	1618185240000
17435	3NKtCfGTB3GReMM1rhGk62vgdDeoEiRruvApYwHjAFm9KzjGYFnw	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1403	824	295	6301	12463	jwcEZvH93sQLKAHwW7rPmmqNna3TesDwteLZjr7tAbwtfJwRNWS	8831	12479	12479	1618185420000
17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	1656	1343	295	6301	12463	jxixiBZ2XMa6ha9Y2NCqkGzU5xGL7143Wtx8jSzqxtCPfbzYffV	8832	12480	12480	1618185600000
17439	3NKs8Q6tBwyKr14MtgcmTcEHJAaZ6RGygJyiXKZ33pEdzTYXqE3x	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000
17442	3NLXJxdrSmRpc7ktCFrJt5bNbu8LRHR5nhd68wy88AgrZYk578YB	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000
17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	17441	3NK9uTKhaVV2XnKZ3PDjMq8cX23gRoidBcC8N9163aTiEu9JbwM5	1637	816	296	6301	12463	jxng3ungcTtYffSvEFnhQxvcoXEpKwv4XkuD38iUVxhPtwHRmT8	8834	12483	12483	1618186140000
17445	3NLwiHgWghNn6ZR5XECqfXXyP9fFVjMthDCxCnLzEWrKrULToHxY	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1637	816	296	6301	12463	jxS5koRa371JtQZiazjau2b8WQEhW9zuf8MLZbDhHjjV8dkCGBQ	8835	12485	12485	1618186500000
17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	17450	3NLoWUrHAyfNvfx9pfh8DRMvo77nsTK6ARDX8SEGRvQYw5v2mCUT	1593	1100	296	6301	12463	jwiDDMBzX3JxULFv4GuQfkALUk8z74eYjPMk5Zxi7bGkGx9VdaW	8838	12489	12489	1618187220000
17458	3NLZ41siZyUeaZhrNBbSEUbzcX4AYzzVYZKR71D88NQ4YbrZN4d7	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1405	873	296	6301	12463	jxxiffXjZgyYJxtNFn7ZpgV8QGeDSQV9fuQyPukcQWuDNq4j7qU	8841	12495	12495	1618188300000
17463	3NLSmpWXzy4vmRc11FcnC1yTDXH1McKPdHE1BqbHmhMNXRrPXifs	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1503	1277	296	6301	12463	jwjzpTaXgiyu91D27uD6VUwGvn3xE9wee5RLSNKVwLK24RsjmcE	8842	12496	12496	1618188480000
17464	3NKBef5dq4zqFi4eRvA7JxQZGxUhtXErEWonRVyZgUGHErJ6m9vJ	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1652	949	296	6301	12463	jxu4kihFdwKBFKj6U8CUNyqR7TKpkLWn34oXNXUXh8q2fhoUz1o	8844	12498	12498	1618188840000
17471	3NLBVE54eZ1guxy2jB4a1KxDG3GSAcQUxZ1nYyet22vgBZ15MBGW	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1594	960	296	6301	12463	jxibe1hmJ54Aw8BDzzPh2eCh7oyK7NUm1WQA9X7c9ckTfa68e2S	8842	12501	12501	1618189441204
17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	17476	3NLdS7sdTkGoqRv5NnvRmQ8S1Xkvekzokd1KLupxGDd9JfmHPPiW	1405	865	297	6301	12463	jwaLWoJwcVomWD5YqELZRynKf3HLYEHhntAfSdHiKV2PkeMqCb1	8849	12505	12505	1618190100000
17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jxLpfdXQc2rcY1pjtXi2qApCG6DzrTKbK96dt2eGyG5pPh7o9BM	8851	12507	12507	1618190460000
17484	3NLMCG2qUB8QwqKeRSrRRtyrePASeFRUjKeCxS9ShxzPR7YoSADr	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxxh4g6u8XGEvBthogPqEjFfTEPhazFcffwdcZ1LfjYcttND6g1	8852	12508	12508	1618190640000
17491	3NLXEXVMfneqhhkxU4ozFzSguUmpcD4w2e7he5j4zfmpA5Eqe6uu	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1647	1056	297	6301	12463	jwCUhirSMYPUDxwBzopwnqVRUxSkdKHbFPM5x1dK4uudgHji5pd	8854	12510	12510	1618191000000
17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	17492	3NLnQciDZ2rqVZdyEidz9UWEtmSp7yJMzMYib89Dj8hRk7rBRftP	58	915	297	6301	12463	jxw8SKWiW7rn3KyEjsNXZmckq5ytnBLzws9U8b2RtmtzTx9NARy	8855	12511	12511	1618191180000
17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	1631	794	297	6301	12463	jxDGUZ25zYNQEV2SFFviaMMDXRxyy1nWvPFNBxrFs9KWvv6HHU9	8856	12512	12512	1618191360000
17498	3NKbh77zQfcoyctoeEA1o5uGNNLYJxrifaCPrs1WTYgPBY8s4EVk	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	1589	920	297	6301	12463	jxHg7ENjCU4BHH2WGEWNhcet2C7NP2CmigdDueCJCaViEyqqbfk	8859	12515	12515	1618191900000
17506	3NKJGjT9xGd3FhahHgDGYo4Wussz3ip9aivTHjJtfyoRzehbgWH9	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1650	1375	298	6301	12463	jxqPrNMtDaFvPZznohZAsDpiWwq4GxXTDPyKCw6DwWkBQc8cbN4	8863	12520	12520	1618192800000
17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	17403	3NK8UwYd9Xy5StVtMiiK4uX3PjAZWrzUPct7bxUn4gk8bBQcbprp	1581	778	295	6301	12463	jx5j84w629dpzVibDqBaXDDrKDLANPYHg7UJioYbmNqS1HDYs9i	8816	12460	12460	1618182000000
17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	1419	814	295	6301	12463	jwnKHPVp4CsUhWvn3AfnhvWY3i58ghEnhVNRAJBPHytMYcewcDW	8818	12463	12463	1618182540000
17413	3NLQwepJC8mHmusacN6VJKQe5qoN6wrjZ26AThEV4M6bbr3WoFa7	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1406	1393	295	6301	12463	jx8DZLTsDasp5ybihv3tq7n43opHGfSD2ix3b3q4C5koYcYnVZg	8820	12466	12466	1618183080000
17414	3NKwYaw4S7ktgo6taQkLuQ6kAkK8CxS6RfCURKe5dxC3XZiWb3k6	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	532	937	295	6301	12463	jxx7oCSMxg3N6QSPdhjiyz8GdzQiDj7xurreZGAqEo2ntYaU1oa	8821	12467	12467	1618183260000
17421	3NL5pv7Y4z4WAstsRkJT4UL69GaDxSw5izLXbXCQf3STuAt42wZk	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1668	1124	295	6301	12463	jxe24qJRcXeGsc32bbwDYKqJB4WYKhj7wtLKbztafD2Fcb2mQf9	8825	12472	12472	1618184160000
17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	17424	3NL8Y663qSz5cT6eVER99Kz9MaCKQD9eAZoq1RxiBp2GsU7pdKnN	1489	1134	295	6301	12463	jxraPPeLBzP3JzFRwFtqrNYAbxfqA1K7zsyWRY1udz6sfMxk3qe	8827	12475	12475	1618184700000
17431	3NLRR86TtRbLkaVSVMXMJ99MxnRWDZwscbUMdGSa71hYKPeyu29M	17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	1671	1239	295	6301	12463	jxGvh8qEUKfuiG21G68HiJxRyrvBKTDcvy4jDGwLpWcPbsHvebz	8830	12478	12478	1618185240000
17437	3NLEo3YM4MuE5EZy94ghJVcQvbLCDEacVjy2n3tuY7pVMoFnW468	17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	1407	1395	295	6301	12463	jwBhCtmTroduFfyi3euVm5Pp5FiYfgcHmQnhc898zoFsDNTrksM	8832	12480	12480	1618185600000
17440	3NLqa3FZgSeYjRcFUeCdLcipodTsNV6W3wiV5fuEbrAgAcYEE82A	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1407	1395	295	6301	12463	jy2S6Lcy1tFLzapRhYPUMQPcQ8JLJjHwBxuh3hqoiAjsgZj1WKu	8833	12482	12482	1618185960000
17443	3NLeUPY21LWY2dPY2dUg3ysE5QWbEi8STS5GXDDoyYKemXhVkDAF	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000
17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1407	1395	296	6301	12463	jwrjuisx1dLBuzqokeUAnV2BeqXExtkTywfpowcgrQWCEQ4t7nr	8835	12485	12485	1618186500000
17450	3NLoWUrHAyfNvfx9pfh8DRMvo77nsTK6ARDX8SEGRvQYw5v2mCUT	17448	3NKNVq5VWE9KpFqqWxeZ5pQgEnTbGXGtzhUwnBuTNYpNmMm19jkE	632	1256	296	6301	12463	jwnan61JmsRAekuUysdc21VmQwewMfXZ5WaRFkBomv1ELTEkVzS	8837	12488	12488	1618187040000
17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	17453	3NKPWsR36WybvQGZr1nJ2iYkLzwbPVCejfoMNiyXv61QKiwj5sDR	1476	1371	296	6301	12463	jy128kqMM8S3nqCaGvEvBPKbMyoJ7jRwMfprjrhGaPxAuQBhyMb	8840	12491	12491	1618187580000
17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1503	1277	296	6301	12463	jxsvfPZgz7abE9yPLGZT5dvidpC9wVm5NcwfHFLWuATYm2N7m5u	8843	12496	12496	1618188480000
17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1652	949	296	6301	12463	jwRyDpkhBXeVE9itiCtLph8ebXh2jS86dmZWcBJWthg6dSPpC9e	8844	12498	12498	1618188840000
17467	3NLLQFLfkvohGFnzLT3GvJoSc4GLreXFwN4LYYhJsDPGqrGeQsiH	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jxtoR4NeHKg99ZQPjjQpAAVrbck7C9zp9qwpFriTVsCRyRa8Uz8	8845	12500	12500	1618189200000
17472	3NKeWYjHqX8FtuFSsgLPoHavStdkfmvSWUHfhwBdTLysFtKvtKuK	17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	1508	1387	297	6301	12463	jxSGrtuab7HR7taJGsSXC48u3Dv8hNzzaN7LDxqMMcJ2e9d6H81	8846	12501	12501	1618189380000
17474	3NKcS3Aj8a2yMSXTPvuVd2jFnCG5kk6BPuoJJHjPv2p7wWbA5kjZ	17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	1594	960	296	6301	12463	jxzARivQ96D9rwNdiyj41eoK6N4bsvmvx5vv3pBvsS4eNGbd9zg	8846	12501	12501	1618189380000
17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1573	1072	297	6301	12463	jwebhYKUEaG9cNYbJLtFLbKeobJG1KaVzThyiQJAdXDT1QvFxgv	8850	12506	12506	1618190280000
17483	3NLQLj9LB2f1BKbZWFX8Ei7Y7DadXV37UcKZFqNC1Cg65gM977cz	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jxaWBRGvXRs9N1V3occHGvYTZYFML3cu5ar3bZCs1aZ6RSLM4Dr	8851	12507	12507	1618190460000
17485	3NKtLPAAgu1EXG6ipR4Ex6ByYjkS1G4EVKbxfP3gfMaa1BniDGbh	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxSPndTNAgEqfW5v6sQSiMZ7mpanoYsYGH6ptBTycFJyquPpNhb	8852	12508	12508	1618190640000
17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	17488	3NKPK38tgUL4Lg9s1jWqxdBpwRpN9tFfuWu68313CcibzYbyMrXR	1402	884	297	6301	12463	jxoeaN3VWkndiJ59nsGXACAtF2UCaPd7UwXDyiXcLEQK5Ptm4tj	8853	12509	12509	1618190820000
17496	3NKfucVMHvdkiHhohLgnhrAjGm5tzvKT7qD4AokH4oFjisGHJsxc	17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	1406	1393	297	6301	12463	jxHoxVnUmLCBkbEhgik86hkirkyibhB1XSmbF14Pqa3RPWcJUZs	8857	12513	12513	1618191540000
17499	3NKecov8RtigQU3ENjg69jLdAnn4rMxjLkGo2LykuUggaYPBDtKC	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	484	1319	297	6301	12463	jxQJd3ed6BcnxUqtsvd1HhV7Li9cubMfoMymSL2y8urr1SSREgP	8859	12515	12515	1618191900000
17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	17502	3NLScziQXyJzdNAKB7bKQVCph15QYyRfxaoQMw9tSkawvEHWDXyq	1406	1393	298	6301	12463	jwE8zGmGmtVZmpCsNxtwVGwqhu54LjTSDwjYYc2pd8AgKQhwuro	8862	12518	12518	1618192440000
17512	3NKthLNkodgeFdhckN3EBMC7Y2jWJKjT14TejfAf5oMXH1ufKQH3	17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	1509	1320	298	6301	12463	jwgFtb7sa3Ju6YAAqGXGEx8cBjZa7RoiVDTn8WycJxAx8FBT8Si	8866	12525	12525	1618193700000
17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	17510	3NKgGBnNxm3r8cJnfx78BkCD5u4Yn9zE3J5rPEZmKvbZNf6mtiE7	632	1382	298	6301	12463	jxAzRgsoy6bWXkmxh9VA3JxQWSdWLLynnZeWbBgwrARhozwETaP	8867	12526	12526	1618193880000
17519	3NKk2PtVRPjpc57zc87eVa5UQWVSKeRHtmzE7PinRX2RisWqU6EH	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1448	1311	298	6301	12463	jx7QSTyrSKpkJLcjcPJ33M2EASG9WC8rZKRUoP2jhidnGeVXGim	8870	12529	12529	1618194420000
17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	448	1305	298	6301	12463	jxrU53NLPubszyGMtS4UpDhCgGpvWm6xnoW1iCi531SLeRuy1hp	8871	12530	12530	1618194600000
17523	3NLaW2ntTGyavfRWTLBhMgdeHKvZ7LQM7VvnpWmw5GmWmSU5QgyF	17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	1460	1324	298	6301	12463	jxZFHQziCJqNv9RaaxqXRCw1pxMkFmCMg9RukmWW9JDYboC5DKq	8872	12531	12531	1618194780000
17526	3NLbiRqbtvhNHYnGGtwuoBiDFjsganfGzwmtZBaUt6sZMcvq2J8q	17525	3NLKSeMoLrQVLX9D8t96eZGZ2uymBgtYkz9t4GRswXy5n1cAYPTZ	1553	776	298	6301	12463	jwiNWYBLG5F7YXJDUo6FBDZMTwUnEDDYzcPmwZtgf4SutQ4Ufsh	8874	12536	12536	1618195680000
17530	3NLZbkGNoLZ3QSRQCjZMnM1H2nj1QrHEgGnnyeXD16wjFV7XSoEB	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1637	816	298	6301	12463	jwMt2LgwKSZnerekR4mP1yhH5GmKQQ1Urvd9A52SmEKVv71Synb	8876	12539	12539	1618196220000
17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1490	1274	295	6301	12463	jwoicb4ibCpd1kvF1hbwUEhjdp7ADcJTVTQ7QzMCArzZsi3JH74	8831	12479	12479	1618185420000
17438	3NLf63UmvxiE4zPWFCBxMAynYjveRcSi8SJrj16Gt2akox2NruLL	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1402	870	295	6301	12463	jwmqQeeM2RfPiBNTdYFUvXwenP97AJao3aJJZqoUn7ubxEAmuo2	8833	12482	12482	1618185960000
17441	3NK9uTKhaVV2XnKZ3PDjMq8cX23gRoidBcC8N9163aTiEu9JbwM5	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1581	778	295	6301	12463	jwmfYfU1FdiAfugybsf6uJmzCEV9Xdw48yddbhxNmXxt8PWtVk5	8833	12482	12482	1618185960000
17449	3NKRwCesRQtMVwEsu5Mk6ftHvnBThqMetGWqAHPiE16pY3Pw5pjE	17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	1637	816	296	6301	12463	jxmNSYw4pXVD7x87CVWNHDiGdiPJF5Ai8vd4QEdQf23KB6PTH3L	8836	12486	12486	1618186680000
17451	3NLe1CW3PXQMtVgU7omUznvq7L7HTeAzwUJEzWb9cTHn9y2CBRoU	17052	3NLpitDQKKuUFatogn9FwkPWaAXVMt62Pp7QgpoG1q5KakJgQUiE	700	832	284	6301	12463	jxSa9BSBCS5tEL8WzJotwQiMxL7KFZFm4WgRkHG4RG2HsipJQpE	8568	12488	12488	1618187040000
17454	3NL9BL9oSD8Zp1pBEfDr5KiE4WwBqWBv9qk5U9cndc3UWqHoJiEA	17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	1445	1164	296	6301	12463	jxMAXXo4eumr4YkM6s7iWW5bp9B4L6fEwFy8msVbdcP4BtbwL8Z	8839	12490	12490	1618187400000
17457	3NKTnkvo8a1WXm9utEmEGq8KsqmJoEKMFnDQ4JkyoPdakB7fgpYu	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1642	1121	296	6301	12463	jxhVpQLR5CRyzjCebvfnWk9xfthiHSPQXL8Q6e7THDKeKAYdFz2	8841	12495	12495	1618188300000
17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1642	1121	296	6301	12463	jxrLaM86Gy3XubUeJ9UuNZMJmRcBTSHRAvjH4DpvVHD7NtWTj1v	8842	12495	12495	1618188300000
17462	3NKBfK3cRZ9N63ubdEwStCd4A3BrKGScz2bfWvmHbNgKhosqp8AT	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1503	1277	296	6301	12463	jxrs6sjMFSB14m9RGzfWSgkibbebYwVoxdjE8o6binSft7oHZou	8842	12496	12496	1618188480000
17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jx17JMFrkfvpijMgcD3dqVaPmJDo7XMbbhfh13fgymbJN73d1yS	8845	12500	12500	1618189200000
17473	3NKF3mwfUkQTCavesSNjGD9ZE4eAKvHN98sALgZHw5xxJgckDSRG	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1594	960	296	6301	12463	jxfeuzUkjnBnmj2tqJG6uvMkiano3SH9LWB9G3fpmVNB4JzD7Xq	8844	12501	12501	1618189490647
17476	3NLdS7sdTkGoqRv5NnvRmQ8S1Xkvekzokd1KLupxGDd9JfmHPPiW	17475	3NKhmBYvDXRx4eePk499fq13frLFZHWjhCz2F7RAUx1EN7e42LAf	1405	875	297	6301	12463	jwEX8ExhbC6bNfxSLhkdNFiy1QkAWYQBFTPkpK1znCnKiRhZuPM	8848	12503	12503	1618189740000
17479	3NKU49VLxnBCXdMJZKYxBJM9LJyhXKGrmvxxV1kbt29iAiZyneLn	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1608	1289	297	6301	12463	jwDdaCGbK4pibHe8QGsj7kRoCewidA6RVtbguvUJrPopdc8pUGt	8850	12506	12506	1618190280000
17481	3NKiXYmHRG8rZjstAUhPB1EdhMo8hAQHM4hzLQzJMfZhY1Wzrdmp	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jw9SQwnHRzVu2Gii9FndbFnuVqX9PoyGSABWjqe5c9Hm9S5kC8Y	8851	12507	12507	1618190460000
17487	3NK3UPHnS1iZGLhhTSV9iHD7jwkphTMnpp6YajDASMCJf7YvKen8	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1406	1393	297	6301	12463	jx9t4nmTdjD2czHgLk2Nhwj7LRD12PWSGpijUCrEkNfrwiM22qj	8852	12508	12508	1618190640000
17490	3NK3VqbkNksAtgC6pHk2ULU2LRcL8ZT4zqGxJqTRT3ciJdh9AshA	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1403	824	297	6301	12463	jxKoFHMAedYwfJvzw3tZ6X7narXQwKQLP7N8mNGnBfktgrS1Nfy	8854	12510	12510	1618191000000
17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	17496	3NKfucVMHvdkiHhohLgnhrAjGm5tzvKT7qD4AokH4oFjisGHJsxc	532	937	297	6301	12463	jxqQXj4TahUeiaTSVQtkzDcK4r8KBjwqezyVdr9zx1AvKSWRV1S	8858	12514	12514	1618191720000
17502	3NLScziQXyJzdNAKB7bKQVCph15QYyRfxaoQMw9tSkawvEHWDXyq	17501	3NKfzYrNfwXdJ6efKGGybZUyrbVg4RgVd4S5TFnX1EM8VNdYJZYh	1507	1154	298	6301	12463	jxFUuuXmABzsFHC7JByFHBbJci2rodU497AwtAGJbLsf4TcyG1V	8861	12517	12517	1618192260000
17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1581	778	298	6301	12463	jwZSpvUH2PNbL5scE4T4RLzxZPfPnHebyLJLcDVDi1acFoYZPKg	8863	12520	12520	1618192800000
17507	3NKGS6YvSvQCthLrFUhPjPANJBf75X4fwSwftAxiJFfcAn3t12qA	17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	1649	1137	298	6301	12463	jwzDfxqW9QoPKE9GdB2D7EJYC4SAE2d3SUsUYaM3K6LViavhE75	8864	12521	12521	1618192980000
17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	1631	794	298	6301	12463	jwfVt6MRPF6c6gwbLr1zrDn4edbA9t2gARfSHjnKMCMrthakFex	8865	12522	12522	1618193160000
17510	3NKgGBnNxm3r8cJnfx78BkCD5u4Yn9zE3J5rPEZmKvbZNf6mtiE7	17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	1503	1277	298	6301	12463	jxCvyG8yWEGeSnDBj3tG7ChX1YnKfZyTT5Xrbz6LNSWpVgpz8RU	8866	12525	12525	1618193700000
17515	3NKcLqsumvwafXUuBbiPapLe6BAGkq5Bsv6gE3sXM5kewp5pw6oY	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	171	1248	298	6301	12463	jwcxaTFuJEKLuFrVyZ5W52vMy5MdQYckutZvv5zC83BWnpAahhJ	8868	12527	12527	1618194060000
17517	3NLLPfDRWVPT8y1hnQ5d9ZvVjnT91ZJ2eAW37wKhSBnBcSNjyC9Z	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1448	1311	298	6301	12463	jwXWjVLvAfR44LYGzpvJMd9pWrN5ckwwBMNHWCdYJ4DB28gjwgV	8870	12529	12529	1618194420000
17522	3NKxja2LviB5iDqWbnT8GV2bVsyV5VumjLfTc21CZwdZtBxMxA5d	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	1631	794	298	6301	12463	jxqTLbwZbL3mtzLu6TakUWghEwQVaxRpcvc3d6mHrRfUDCqaqZR	8871	12530	12530	1618194600000
17528	3NL68HU1jFHsYxqyVQ9Se9eJf7VZUT9scMNiXGAkdmyuEc6H9rc5	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1423	343	298	6301	12463	jwN733qFWuxUS6wnqbwyd5YFw7F8ruFaAgb6MnqN4cLjjXZ6wSP	8876	12539	12539	1618196220000
17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	367	367	298	6301	12463	jxyn4NfCr9zmdXe98VY8LBH1F8jPsb6RExHEqWnE5GUPgCAHcj3	8881	12547	12547	1618197660000
17538	3NKEZBg4D4pta6sbV9giuYYLuttqKuFzwhvrjL1sp4YgDppFirTM	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1571	969	297	6301	12463	jwAdhdaDmbSpe6aszrqjLjwZctgd2Hby45LLirbBLH3n6CcXaG1	8852	12548	12548	1618197840000
17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	1581	778	299	6301	12463	jwH3ujGQuDLKjPZomqFXEGToTjdHoKQE5W7D7h2GtPgoD8DKLXH	8884	12551	12551	1618198380000
17548	3NLjpQFNFLx3GTTwyGy4fE4Vu3cAHaDzqSGC3LiuyCQKtgJaPq48	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1647	1176	299	6301	12463	jx1Ba5Rkcb3z8VJA7MVa4EHfABToqmc6BC2Z6Zrggjr4doGpt3k	8885	12552	12552	1618198560000
17550	3NKJ4sLxtfGcszigZxvhd4oJDXNBzXMUXEnNvW8HehfU3t3bt96w	17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	1406	1393	299	6301	12463	jwQQbJxEG5rBrrxL6NbczAL8AvPzg9tXR6NbAFetrjHCfRaAzt1	8886	12553	12553	1618198740000
17552	3NLcmwNMMYEYhSjGKcJPDencLUGk8yGc3QHUQa3GCJ79xBBETgp4	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	171	1128	299	6301	12463	jwB9H3i9XYHyYzmSvBWpEqLkd4tdoSy9zQ9VNeKi6JQKcPZ9ob4	8887	12554	12554	1618198920000
17494	3NLVTPX2fxu7brjrTWJBY2HjMMxeH9y13MGgzWndCxVLVWPn49jq	17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	1458	1323	297	6301	12463	jxeckHJomWPAdHgcNvxPiYrVJc4HaTaSxn2cHVnjt4ZShLMz3fF	8856	12512	12512	1618191360000
17500	3NKV6v2urBCroojjzdg4EAgx4croekx4wYysHLV69chdenPYLSoS	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	1406	1393	297	6301	12463	jw6kYq7bC78gmAu7RDqRFKmqfKA3uKTY6BcmH2xWwcJVVmPXYJx	8859	12515	12515	1618191900000
17501	3NKfzYrNfwXdJ6efKGGybZUyrbVg4RgVd4S5TFnX1EM8VNdYJZYh	17498	3NKbh77zQfcoyctoeEA1o5uGNNLYJxrifaCPrs1WTYgPBY8s4EVk	1631	794	297	6301	12463	jxxdau3nq4hzqMM1MEQXvcF2B69zFqTwAJb4MCQn3QpBRQ9KAzq	8860	12516	12516	1618192080000
17504	3NL8Jhx2cuHzVvyCCLmjQRvHhFh7FFnoJipMiYwwRcy5mReVmxXQ	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1406	1393	298	6301	12463	jwSJTPv9enH6kQuNWCRjGpRBovbZ2CLgXBC9HpWJejGdj4wurss	8863	12520	12520	1618192800000
17514	3NLYVmU9Pya6MSBJ8zsq3CV9PyC4ZyFb4X4EL88ShAsFUrxTe7CY	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	1656	1097	298	6301	12463	jwqTvJ2EiXX4M6UwYdpGs6qmGvn7Bkco86e6oZWS5hqFXncSeS9	8868	12527	12527	1618194060000
17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	17514	3NLYVmU9Pya6MSBJ8zsq3CV9PyC4ZyFb4X4EL88ShAsFUrxTe7CY	1405	883	298	6301	12463	jwaq7LLi6Zq3NvoZXR1eEFYh6GGAQwpaBSMUyBQr16yFTLYAiHg	8869	12528	12528	1618194240000
17521	3NKbpyi89nEwS6vfEjNz4XgaHxoGMaaVcz6GXVoNB1ZABeHYWdjz	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	1637	815	298	6301	12463	jxZ5z8UA86DgbrH9QuJb5gi43HDv55doX365PqbsPASxn3f4cNE	8871	12530	12530	1618194600000
17524	3NLfieeSz7dWAjEdA4PAReuP5hsRQerkriBt7fDM8gBGTVAU82NX	17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	1406	1393	298	6301	12463	jx7surzicizgcN3FGEftTRmU53UYKBnW2s9aXWnXjAFt2KJE7mh	8872	12531	12531	1618194780000
17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	17526	3NLbiRqbtvhNHYnGGtwuoBiDFjsganfGzwmtZBaUt6sZMcvq2J8q	1407	1395	298	6301	12463	jwWhFq1KA6yaLnEHC1GSo4pT6nNHQNercYV3uarJeY9GEHdmU7m	8875	12537	12537	1618195860000
17532	3NKAaHNy8i9dwbDqkFAPwJLnGXoqoTFJr9vecM3PZzrdtt8LZp9Z	17531	3NK7xY6e8RAXUhCrN4tLAYD3RBLYqLaLz3vjJJWNzvVEUZ1Xrsqb	1579	1263	298	6301	12463	jw8tNBo4j8RBR5D1riHaa7DQE77sKU2t5YhTU6G9rX2ksDU5LCz	8878	12541	12541	1618196580000
17540	3NKJ1G2PcPyVYxNDULPsnhqTYLtEkHHtWGoCCG1EKSZoPN1D44n4	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	563	1113	299	6301	12463	jxvYmdyEsq1fa5xff5BTwMUbvkRfWquutZ4sZeYiD7VRgLzvJNJ	8882	12548	12548	1618197840000
17543	3NKyTTMsKxjP9HZVBJ8kqMnutEHtamAo6ohc7Lkiq7EYC7g7buvG	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1541	932	299	6301	12463	jw98wrpjAVh6CPaugHKwRrwBnApjyY8QeVxbprjF4ZGQq4wFCzs	8883	12550	12550	1618198200000
17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1403	786	299	6301	12463	jxYJCNocLHwTAHfaVVYW4QE9C4uacYuT5uT64mUFt2f9RqfrnVv	8885	12552	12552	1618198560000
17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	1507	1154	299	6301	12463	jxkt6yHkDf4stT2WnwFHt6reuYCbbJwLxQvogTPuwQoEAKQDJQP	8886	12553	12553	1618198740000
17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	44	44	299	6301	12463	jxr1LmaaJp9brVaNFoqRZtBARhZAnuaYruGKTEKqP8wT7wZ1Cs9	8887	12554	12554	1618198920000
17557	3NLKXJVnfPueDp4RPbq4n5JBXFYP9ckHndHEwCB9ETWtJSPwbyxK	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1406	1393	299	6301	12463	jxjPgQiGhoPgL3R1owoHzVGS6jJkSiG2xdUCA5DH5JUs73w5gJf	8888	12555	12555	1618199100000
17560	3NL52HLUdoRaBA7sFodJcsgvtMhXChQkwLaycGLMsNWzjaA2ArW7	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1596	997	299	6301	12463	jxqj8LRhkYsGpqsHQ2jkyyHfLAir2f63iivVbz5fsY3tnEbFZtD	8889	12556	12556	1618199280000
17562	3NKG41wXQzoRxQK3BTaZnuvNVAG3AFbHa3pWGNCxUzZeUzfovKxL	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1627	1259	299	6301	12463	jw6kRTA52PJEoCpTAvBPKyY8eo7y1dH3yS9pG6JuhpARnzLHTHi	8890	12557	12557	1618199460000
17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	1403	786	299	6301	12463	jy38cTMUeHP1Btmi7xJNCqrK2CYDSG8odrou74cJRNhro8DwCW3	8891	12559	12559	1618199820000
17567	3NKnZMCTf2nPbrcmGLBMPNrgfMtrPRTgXPhvJrXriWXzPzKhC9wN	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1594	960	299	6301	12463	jwFBPosd3Ymcpha2FaX8CKHinbCqXX4dJK4yS7gwwBk97vYWzz3	8892	12560	12560	1618200000000
17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	338	338	299	6301	12463	jxtnrTrAE4Ppy8dhygLS25ensKvsnYHxmMgXpMhycNnS5Tuc4XV	8893	12562	12562	1618200360000
17576	3NKr7tq5xDRAUh6eFssjDApBgef1bFhpZMd7MqntpvkDpLqNUHKz	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	42	1361	299	6301	12463	jxPBaqHwcoNvLxJjYAPSeV4ndTNTzhbkgDeC6vAvoVe8NaaMdLk	8894	12563	12563	1618200540000
17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	17579	3NLbUr9KcTY4KqaWACbnwWRZHea6pA43uAnvtYcVUA3FbzyYej3n	1444	1135	299	6301	12463	jxF5Fu9YwAbd1H4j68kcp1uSz9Ey3NbbDeSyBAX3FatAFQZAiFi	8896	12565	12565	1618200900000
17583	3NKgEEZk7KUMZvotchWKhRf9q6LcF5Wucn1EjnJd7m3WJvjBXpGQ	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1609	1207	299	6301	12463	jwyQWaTKnhqvdsQv765C8AZRh8i1XLYy9zn61SewZRHn2qhawNw	8897	12568	12568	1618201440000
17588	3NKcpaVUiRVq5etMv3zH4VwhizTKfcNeCMmsG1G8v6VGaFUkGBnr	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1624	968	299	6301	12463	jxZRFQm5XtoNgKdNUoD33CeVQt4DzNtBxooRNMUdRzB9egUApoJ	8899	12571	12571	1618201980000
17593	3NKB7SNZtGULXjwoz1V7Pbdp9M7JmvA38jHwhJ84upN3wvJps5i7	17591	3NKvwb1YYwTmFKaZrc1cRz82kb2NN8co8mjM7rVSsNJPLdZBnFsZ	1402	852	299	6301	12463	jwFh2RxZJ9izfX64cytic8WZjy3dN45ndNAFb9hZV1B3hhmxJfB	8900	12572	12572	1618202160000
17599	3NLQWviuvZ8KyV51p8NDwXXmWxhVvHP6ZFdX3zUq2TZkBw16Zw8B	17101	3NKgbYxLKhUJz2AgfbkGgim2tYT3yQZAV2YQ8Jq63pL2kJ8JHKB8	152	1330	285	6301	12463	jxfhYJ1P12eaZ4Tnr4XQHsLSDU2C9DxXPx2twFn9Vj2UxEjdQ4G	8619	12575	12575	1618202700000
17604	3NLE68ASYqnF4bQ7J1srbHiYmxMphhcwKJLEtru3SppukKhZXKFL	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	684	1226	300	6301	12463	jwMwn2gJPvMDSr75S37SiQtEAdJVtWjDdQPueK25jZ1eaMEUVvF	8904	12578	12578	1618203240000
17606	3NL6Kf4Bs9ZYXqpJNGdwnFyibaaGThE88gwux1fSVYykHU719etJ	17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	1406	1393	300	6301	12463	jwd3VqAiugDTcnUoms7aywnAcceWhLRUDEV76DnxdXGJ2fkmkgu	8905	12579	12579	1618203420000
17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	17607	3NLAj3Wi6DE36hQEdR4PsrcXKtkiciU6uYcs6sAWsBzU1ts1jTU7	1406	1393	300	6301	12463	jw9a6xj9Vi2RQo5R7TXccUkvETaQUmjmk9zVoiELdRmnt1Z4JpV	8906	12580	12580	1618203600000
17620	3NKX7V3gaYM6Vmw3yfrUhMwT9SKQx75ArqDLbtp553pTeGTcBqC3	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1405	873	300	6301	12463	jxeHq832J3FaquUbc5hxbeZAMFu83YTTJzAZbvBKD9pJ7wGJ2HM	8910	12584	12584	1618204320000
17621	3NKBaSWtQJLS5ba5McTcktYhKZsRnt5GFc5ngCmFfBwe4mYvL3mw	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1643	1053	300	6301	12463	jw9m7sAmD8Ki2Z7zW9pEwhkQeq6LKq5eWMFj5ELPePpz1v2AHx6	8910	12584	12584	1618204320000
17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	1649	1137	298	6301	12463	jxzHBDLVbvUBQyM71oVZqDPvMba4xBj6NK6EPVC4Ej9bKmRerfa	8864	12521	12521	1618192980000
17511	3NLF66VpdcTLn6AgyjtXXWQSnYnaPo9UaREhYKTWkzJQypQnB1Jt	17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	1503	1277	298	6301	12463	jwALmsf5s9HWiwRxpmL8tGAqV8gSTUYpiEhSiqgPcHisQPsTjji	8865	12525	12525	1618193700000
17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1419	814	298	6301	12463	jwMoRNLyWZNu8LkMXqka8BRkGNsarPtyYZwkf6ndSaVY4BWLGqH	8870	12529	12529	1618194420000
17525	3NLKSeMoLrQVLX9D8t96eZGZ2uymBgtYkz9t4GRswXy5n1cAYPTZ	17523	3NLaW2ntTGyavfRWTLBhMgdeHKvZ7LQM7VvnpWmw5GmWmSU5QgyF	1579	1023	298	6301	12463	jxGHLBXsFLMbpikVRs7GQyPbzSqC219tS47vNWTtmJkFGToKUMk	8873	12533	12533	1618195140000
17529	3NLgVMb7oR1JJ8UcErHnXGwWnS1rHAsKT9wcTZXMVcKXtXgwQrMK	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1407	1395	298	6301	12463	jxcZaSKD2tjmKZzYhh2KeXsZwpJbDs7bSmQH1kkyudGnMQxS5oP	8876	12539	12539	1618196220000
17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	17532	3NKAaHNy8i9dwbDqkFAPwJLnGXoqoTFJr9vecM3PZzrdtt8LZp9Z	1559	1227	298	6301	12463	jwskGdt6ZfqrXL6t3Lkk1U5kqafesL1Qp544YQvdWhsbibaRvT5	8879	12542	12542	1618196760000
17534	3NKnT8pmxhE6C3BKSnS3hVFSkA4juz5Wr48vSqwK4bpjjxtMxhHz	17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	1672	1285	298	6301	12463	jxRvxYJ1WsfP9FN3knbyiMtVqjYXUCckzoSUXy99a9AhgUm68m9	8880	12546	12546	1618197480000
17537	3NKGTWYPZMwviZF7HoUHvQCdJYNhS6rJ8MnuTD48mqiA5UcS6VGt	17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	367	367	299	6301	12463	jwKGBR4zHJBGzXrMXq62NgJma6SDwuW58KkShQfiorkrA16Dg5d	8881	12547	12547	1618197660000
17541	3NLPJJpzKLouSoyyXL4j3CPmruFYcHaHtXYXp2GZSBhs8x9tSn9B	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1541	932	298	6301	12463	jxTkGcx1KQCkM7qa7mKYXYVFQvfHDsjTNSLAfhVVdvmFktjEgbT	8883	12550	12550	1618198200000
17544	3NKG17imkvDeepSQoy78Y6qCfcT4J6VbjE5zuujtwdFpifTjEpLz	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1407	1395	299	6301	12463	jwhGfxcrfYVkRy2jz14gwjtghaW61Z3LZR6XY83EiRPtw6yLXD5	8883	12550	12550	1618198200000
17553	3NKsqiaApCQAZUcxcSuaytLiLbJiD5wGjgPN9cJTJVr6Umptpajj	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	1483	1150	299	6301	12463	jwtuC4Md7gZnqK6EkvbCWZ1GURLPgmyDiXpeBSypv3Z939TuTXr	8887	12554	12554	1618198920000
17555	3NLjF1BiCDvYMdT4Ui7y3Vxct8kt8EJdfu7MJ7rBPxJ1JsqYaHtZ	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwwJzZxJRhDWj4h8AWzQJSy9txiBLXCxP8J73NAeARM9D4FBMJq	8888	12555	12555	1618199100000
17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1553	776	299	6301	12463	jwUxtQXz8N3d5keR5aUZPPMSd15JoGo7bm1GGWkz6yVmJk48xKE	8890	12557	12557	1618199460000
17569	3NLd2QDP7sAULWpy9qLyZi5kwyeYg9wfPxkj2tfCvmvnHH4MM8Yy	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	412	412	299	6301	12463	jxSsFhahRNDk5VcJ6qnxHtTWvV5bQsfAr9tWpaBMumWBEzYwwAM	8892	12560	12560	1618200000000
17573	3NLPnLezPHk3NNg6m4vSBAvjpGmYmSmf6MQUBZMgD65E9xxP3GDb	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	338	338	299	6301	12463	jx3Pu3hS4YHatNsndgo87CJ96ReuRjaHCBzLdHYcwjNxGaF58bK	8883	12562	12562	1618200360000
17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	43	1310	299	6301	12463	jxfcvnAS7zPVtWJeDUDb1uq5um3oqupoxnqSmfHTvhDW9E46ivY	8894	12563	12563	1618200540000
17578	3NL6cyY2tcBCzXeN22dh8P8n5M7gWVqmj1afADQT5LYBhqQHtUoR	17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	1581	778	299	6301	12463	jwmvdDB5bbyx647RbJyeScYzHmxoyQgHqN6Xhr7qbemsyapwZby	8884	12563	12563	1618200606519
17579	3NLbUr9KcTY4KqaWACbnwWRZHea6pA43uAnvtYcVUA3FbzyYej3n	17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	1403	792	299	6301	12463	jy1MUakMnsHJjyVCZz9wzpkm4Xvpm9HRFv3CpEBqFpXhveL37uD	8895	12564	12564	1618200720000
17585	3NKM63aQt9GB71CVDdPJAE88bwePwytYFY23o6xtj27FBHk7k92f	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1407	1395	299	6301	12463	jwJpJg45EcKdrPMJs16yfWJ6J51GJ5dG9YCg8qWzq7t5q3bKQsQ	8897	12568	12568	1618201440000
17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	17586	3NLxbRL8fdXdab52mmBaXoaqSMgUW78d7Vaa96ZttRMSv8D6xu9B	1601	1388	299	6301	12463	jxJhwkP2P84mE3fxmfkwdGTuioRDBSBNezXHK7LEpjBxL3e9QMt	8898	12570	12570	1618201800000
17590	3NKutoASJhx1jZPtqZk6GukB2xkbBD4nbRWoGudK89eB48p8GD4K	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1624	968	299	6301	12463	jwV34Yz2tQLRLgR2Tpk7AV4DhwVH2m3RXAR8wCkaZitANL4CxVQ	8899	12571	12571	1618201980000
17594	3NLf2XVKpAJWXrLscgWK2rebv5qKWMNCK7jwYEsde5iJw5YSieEA	17590	3NKutoASJhx1jZPtqZk6GukB2xkbBD4nbRWoGudK89eB48p8GD4K	1403	824	299	6301	12463	jwQQL2bVjpYRYjxLkaDXZPhCJPBhu6zj2HGgngnLVu8LkG7p5sS	8900	12572	12572	1618202160000
17598	3NLYy5eoaSNX9mdxpCNWWcZ5Kb3wMnBjEFa8xoaqsVkVw6g3eiCx	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1439	1279	299	6301	12463	jwDzLRg6KGfNUUm7bqoK2414AvdTq7miihLzU7KDLpoPEkFe2o6	8890	12575	12575	1618202700000
17600	3NLTuoFcbkUixe6NBTkoED6YQBmeFA6qPvnCTGeGtFUbebHbXB7R	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1673	1368	299	6301	12463	jwW6wHaJVHitbzJZDtCRUGxC8WuehHmqEtboqkHdC4TCcc2Z5ho	8897	12575	12575	1618202700000
17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	17597	3NKBVjkKZs1NvsyUtmjGEBx9BmwcZhU7qN1Szbsbk8nDcRRN9Ui3	1581	778	300	6301	12463	jwgrbwcibyLp9AMjajv8Tf88x6jw1pxrWaeYQbXMqEztMVQkUfW	8903	12575	12575	1618202700000
17610	3NLSS7X4UazSE7pHsweMZQCpR9PM6niTfbSYUauFqwpSVP2Po6He	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jxC1PHPbZeNxvD9Jpx3zJE93RdSsgTR2VJVgsT9kP3LczboAT5p	8907	12581	12581	1618203780000
17614	3NL5yFoGbJbQcYfHjWCNuompBz9X2rzUTi3fybXBeHuvNBaaCPEN	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	1407	1395	300	6301	12463	jwBdKpF1tqqrx6tPRoDp5XbCbPZA3dPh2SyR2iRUSUugpJPyW6U	8908	12582	12582	1618203960000
17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	1406	1393	300	6301	12463	jxQNrMtDLMYP4dRbSE8ZY3BroUdobVX4TRM17zoZDpJHDshGtD3	8909	12583	12583	1618204140000
17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1542	938	300	6301	12463	jx24kqBRCZKoVYsrnwVUoheTAspt8hFmZeKsFhcDi4wTr2vFXiF	8910	12584	12584	1618204320000
17628	3NLg7R2BDf9G7AAdTMgB5ZUDPx6kGTUBwFLoef7pry21zSPPnd2C	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1611	1341	300	6301	12463	jwQ9W8hPQADUP5iULvz9AtHm1suRmBkqmntk1KfiBDxscgSVy9j	8913	12588	12588	1618205040000
17630	3NLZVrMqDrpb5R8YgWSKUR9W89gYa5sMSa7SQSsxhTUi2zZPPY2k	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	1670	1156	300	6301	12463	jxkZvSWpSbZxrwQmU7wkqVwZdaBJjf6E4VK2DsS3pfQYNvUqKVp	8914	12589	12589	1618205220000
17634	3NLkoW5b6ydQkqbKLhbaqSPFDHhxeMpT2VqovZfBYNo6ZCeXAPa3	17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	1553	776	300	6301	12463	jwcwRZEPMFf6yDdS6G29DnSCd7DFEjqBD4kpARqnMbV7WFxed5u	8916	12591	12591	1618205580000
17531	3NK7xY6e8RAXUhCrN4tLAYD3RBLYqLaLz3vjJJWNzvVEUZ1Xrsqb	17528	3NL68HU1jFHsYxqyVQ9Se9eJf7VZUT9scMNiXGAkdmyuEc6H9rc5	1423	282	298	6301	12463	jwmvERaTCZRhWQttKqGePjrFvLiRA19BqzjxrWDsAFNnG374srL	8877	12540	12540	1618196400000
17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	1672	1285	298	6301	12463	jxRvxYJ1WsfP9FN3knbyiMtVqjYXUCckzoSUXy99a9AhgUm68m9	8880	12546	12546	1618197480000
17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	563	1113	298	6301	12463	jwWjyGeKuZNMFzM87V3Gz77tf3qZZLkNBS7U1Qy31vqybVAwweC	8882	12548	12548	1618197840000
17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1642	1241	299	6301	12463	jwQhLq4tawgicYRuu8Bc5kHXvy4XcNhS5zAST91J7s7vot1MVGa	8883	12550	12550	1618198200000
17546	3NLRjFDgnzQhqfKQyU9bdzj27cw8xzY2jQDy94F86uyf4xyxvvjL	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1546	1339	299	6301	12463	jx3PEtFBZaiU7pTzoDWScDyz1WNT81zXJPNJfEdtJyECR5D9YiL	8885	12552	12552	1618198560000
17556	3NKdg9Q71wWtE8NEtjH7npuQrZTpJRnmY1evYsrKGvG7ZQ75D1v7	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwxoZ92ytgiH1JFuuog4oCXrFsE4apLSygscky57wxfirMUadED	8888	12555	12555	1618199100000
17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1573	1192	299	6301	12463	jy3Dh6NJaPcvKUcn9Brnjv9DKN3ZJB69scrohwYmvTgsi8SEzED	8888	12555	12555	1618199100000
17559	3NKMKLkD56G64ePBwiaKkfKYCaCvEyGN7YH8VrsxcdH5Ym8WGL8Z	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1403	824	299	6301	12463	jw6st3rQGMh85R1tfqeWFJK9mqFtAF3HjZs3hZzLG3tHjDi4ent	8889	12556	12556	1618199280000
17564	3NLRzPbEDk6yBhsc9mXVnYgZ3A2taWbmJsvtDcRd3h7bMhuLWMAo	17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	1559	1107	299	6301	12463	jxspFC2Wg7GdNHTUEu4xaYti9bEaLD7dNV7ijdYFg1dcsCEApXo	8891	12559	12559	1618199820000
17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1546	1093	299	6301	12463	jwVe9apbJdof4VmmT4noem2V1Rocq2kufQ7nfS6pQmpPCLzo9p3	8892	12560	12560	1618200000000
17570	3NKdX4a2iaVfZ36yVNQmvNNUrCCMNjPU5hyFsKnMwDyxyU9AZabu	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1406	1393	299	6301	12463	jwscjK2Jzm7T3ads9baMQBiZkAUyB8c9CSrMVMb7kbDatDFdDZM	8892	12560	12560	1618200000000
17580	3NLxgtxmS4tG5wSB7sy7nAcDsAosCmuqZ43n6tZxuLpdL55UJebZ	17572	3NLjP6RbCjM3LRTUErdSxq97ZZ2HaAAGEWrFii4hN1uaDJjcRipe	1406	1393	299	6301	12463	jxxAgePLkLaCGUz6E8huD8hPQHVTKiWwWJp7dLEFZppoEmWhTB1	8894	12565	12565	1618200900000
17582	3NK5X4w4Apm5iySfFNqybA4vvtGgM2AXJiW4sY66SS3SfAeo1Qij	17538	3NKEZBg4D4pta6sbV9giuYYLuttqKuFzwhvrjL1sp4YgDppFirTM	1571	1335	297	6301	12463	jy2vmnLHANHfNJi3FD1LwhXvWT6AdYAoD8aVMHjsy9UBg2Mzgat	8853	12566	12566	1618201080000
17592	3NKPnq2FXcrviTkpPCkxF1BtH8PLarUJLGgFQrA2yov72wZtUrQe	17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	1513	1013	292	6301	12463	jwvbE4kpSavbXowHb2TXGwzxnh5htZPT3CHqRY2jVHPngVu5iE4	8765	12572	12572	1618202160000
17596	3NLeABH9jXqDnUj6qpTyVmrLTiZZFP6uSZZkD9vZTr6SMFJpqKZx	17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	596	1306	295	6301	12463	jwfVz73SYjBKFtpAEQy4aDz99QgR7C4wfSjL7d7GjyH4pXdSNyL	8819	12573	12573	1618202340000
17601	3NKrCAA86Yq8TpjNUsaDo9etgXSZnNNroC6rvELt7dG7AeCtZJfQ	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	152	1330	291	6301	12463	jwo7VMKxPQ8N2yw5E6yGF47mabru9br6hRSBgQYPPL3mFdHWTKJ	8745	12575	12575	1618202700000
17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	1406	1393	300	6301	12463	jwwUou1UHJXA38HHRrTNeiCExjfUvLDwiejKM35QcYoRW1K5BpD	8904	12578	12578	1618203240000
17611	3NKqTvitCJUXuCaixuz4ExDiwG3rs6NezJnJQBw9wECecSSutARj	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jw9VmCuTmjxaUuakYMd2qXgEpNgqYgiWcGx3LDvb7aR3KqYo8HB	8907	12581	12581	1618203780000
17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1506	1127	300	6301	12463	jwoHaY6ptUZBj6KsoWv2vNk9ue1K3FEZWkGWFtXSxpXpAHg9bBS	8907	12581	12581	1618203780000
17615	3NL1bEhYbwBByKu2eNSZbc58wpM1jpaxYdopJrVpunEEYKrHueTc	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	1403	824	300	6301	12463	jxyjTTT9CTv2pgn1V4Wd5jHQfyTi9no9VoPGvc75m7nkXob7Es7	8908	12582	12582	1618203960000
17617	3NKvS4nvqEfkJNpPCGB2bxcJrbow9raFsqrhJfeGS1G39YLYbcAn	17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	1581	778	300	6301	12463	jwiehXVJqFzTuaWeNP9DJLnKjQ77ahM5yJffnYReHc5pz1YxfH8	8909	12583	12583	1618204140000
17619	3NLKVA2R48iNgxkzKzNFmjrS588RpyWF9T6cQaQciGmzMwBnr3xv	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	58	1035	300	6301	12463	jwWmWLeh7JQk1jF7bRMGoSmZ69ibe2Z7CoWUQbQieve9RmmR7oE	8910	12584	12584	1618204320000
17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1607	982	300	6301	12463	jwdVjfk23XaZF1vXurKik4Dr5UJwaoo53Gqfjzv9wP9qLT2EhWb	8912	12586	12586	1618204680000
17631	3NLKZbVN7zP4tLr4EfmFCuGiHkGHuYv3tuRBwCHBV4PEzgp5buud	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	369	1312	300	6301	12463	jwWEUKMaD7C8ct2CkNwZHYsZACfHbMkjA7QDXwfCmSQgVb1PNCZ	8914	12589	12589	1618205220000
17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	1631	793	300	6301	12463	jx2JwYdMnYnUSfGA8eXdMzyum4yE6NT7JFUuTdQkDHaamrBdWr2	8916	12591	12591	1618205580000
17644	3NLBw8G5SJvc7A1TCDZuQQs3pZwSxtr5Ua3Ebnt6sF9kYRR53ruc	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1406	1393	300	6301	12463	jx4iR9iuLWPkRn21LF2wBJHk2bcxXLVG7VLAedCtKQ6pidtSKgT	8921	12596	12596	1618206480000
17649	3NLapdSvUm5FkGzok63wEjxp6rADyzsa7bRf9eVSq13YM8FsdBWg	17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	1407	1395	300	6301	12463	jwXUHwXSXwuzgQZmRrGa3gCpMUERinUtMfXX6aTA2azBqxk23sm	8923	12600	12600	1618207200000
17652	3NKQDrcGHRzZziViHfU52qUeNYbHJoADE8fkardBuiZuAW8PfXQ9	17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	369	1312	301	6301	12463	jxijwZL5QY2GzSifr9FmSHY7JPvcdww25yZMg5mm6tk6AgEtcG4	8924	12601	12601	1618207380000
17656	3NKSdg76Wews6Vb2588a6r1riYHZpWAS3qbjtSNs3mMwEncrhZm1	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1483	361	301	6301	12463	jx6TmgkfyFTi76QEPCqfFVMgrCcmxWC33Ar2cbN2G7YTjpyjUmD	8926	12603	12603	1618207740000
17660	3NLaJ3rjTvv2ZbKrPb6697GePXvxcmveZgihpeUYf57GNuHp3QJc	17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	1407	1395	301	6301	12463	jwDwna9gNwhLtjJwyxtmNavaeCrG3hVknSiyXnhTNPb1KVG7gfh	8927	12604	12604	1618207920000
17667	3NKVudxjB45PaDzuwL9UThcEopJ8RFtHvpXphH3ZshxFopcEfwem	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1460	1078	301	6301	12463	jwrMb4RouV3zAbYAjFEVHojfs1jYSRuTQAaT6tmasSb6FLN7b23	8930	12609	12609	1618208820000
17670	3NLtmvdMDWy6gQaGYHjhs6XqH74N1aFb6dpUK17NQjJS8M1LtHb1	17601	3NKrCAA86Yq8TpjNUsaDo9etgXSZnNNroC6rvELt7dG7AeCtZJfQ	152	1330	292	6301	12463	jxVEvCBEKrPexxkFFv4LnFUj3qJzVE5tvw2yRqmWVf6Z6vGAuiF	8746	12611	12611	1618209180000
17554	3NLTMoZgPAjmNq2k1PqLiCn18Zc6AGgQv9iFz7vPtuWcTqWBrD3z	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwesWFtpoJjBrqKFatC3XbpvF865suVEjT8bY5SZtM8FNGMT6Xo	8888	12555	12555	1618199100000
17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1406	1393	299	6301	12463	jxFg4WW9XwKtaxjekMgnznckBjeQRzPDFR1yzjbLA9pk9soHFDp	8889	12556	12556	1618199280000
17568	3NKoPRucWzrDmk8mmpwRvwfJjStH5vUePJuEC9vbiYkHPsSQw7Ua	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1546	1093	299	6301	12463	jxuhPK9xmTd5pZLnpAk9FWEKdQFmSAhkdpVGKs571J7fNF3Cdpu	8885	12560	12560	1618200000000
17572	3NLjP6RbCjM3LRTUErdSxq97ZZ2HaAAGEWrFii4hN1uaDJjcRipe	17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	1406	1393	299	6301	12463	jxN2ZJGpE48N1DazEQzJe9FSUjy2CEw3QKS9GmjZujgkG64e2Xm	8893	12562	12562	1618200360000
17574	3NLE6FKu5kgb6sfpc19fUput4Tu1xCwKYYw1XtYA2jGLZ9RRfkRg	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	1609	1333	299	6301	12463	jwQoxz1nEZLPXpayJSTUef4X7e1kP1dZsqmUY1wrZJSNCgta9Hm	8894	12563	12563	1618200540000
17577	3NKxw6ao4ru9W482np3jc2Y1HjdhQgJyme9x49atm8nbvNhkVUfK	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	1581	778	298	6301	12463	jwwvW2wzDjYnS9DZJ7xSMtdLmA52yVF7WwRoV9Qj2bBppubXiK1	8868	12563	12563	1618200540000
17584	3NLDWbBYJPiomb1ZfgjoSJP27hADFK3wX1A4fFAV7YKXYubJtgrh	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1651	1055	299	6301	12463	jxbKd1X3AEYJDHFvfMUTRccPK7gVD3gJJ92qAUgZTmpcy57deXV	8897	12568	12568	1618201440000
17586	3NLxbRL8fdXdab52mmBaXoaqSMgUW78d7Vaa96ZttRMSv8D6xu9B	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1651	1055	299	6301	12463	jx4VVU7W8KUGhKqNLPATdaLi8pTL2mKDRcZp93sNrBAmXpeCEZy	8897	12568	12568	1618201440000
17589	3NL525LMHR9g2WMyS1Q4BNPBBvwEck7bykKuz8fXy4M2XHZBC5vH	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1407	1395	299	6301	12463	jwLssQ4h9DTANzgTXWC2aUT8nqiRvtX7jtkCRZfJSfNeEVbSykW	8899	12571	12571	1618201980000
17591	3NKvwb1YYwTmFKaZrc1cRz82kb2NN8co8mjM7rVSsNJPLdZBnFsZ	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1650	1249	299	6301	12463	jxquqWedjGQSfgRBuf1EB3Wgk86oyreZjuaD5zJJyzodCy1Ftg1	8899	12571	12571	1618201980000
17595	3NKjyXmwPUVMLJGzrZWKFzQPG7okDgH4foQ3Q3VwXYM8Tem6218g	17594	3NLf2XVKpAJWXrLscgWK2rebv5qKWMNCK7jwYEsde5iJw5YSieEA	596	1306	299	6301	12463	jwrFqph1gqLVSvcAmJ5tSo4S7War3jML1D9XYEynZh9WgWfrhJr	8901	12573	12573	1618202340000
17597	3NKBVjkKZs1NvsyUtmjGEBx9BmwcZhU7qN1Szbsbk8nDcRRN9Ui3	17595	3NKjyXmwPUVMLJGzrZWKFzQPG7okDgH4foQ3Q3VwXYM8Tem6218g	1522	1076	300	6301	12463	jxqrx5Nb58uDaTFxN7yFM4tkKRsQQ4UJuD2d8oNzj1xUPbBGbvh	8902	12574	12574	1618202520000
17605	3NKDRtr6THLxfsuJ193VRqt61Rq2JGYQ5ZvAqDw7Kkqi8FvxkdLr	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	684	1226	300	6301	12463	jwLiZFU7ujr76SSjW6uUzxTjtWdFSMzUYmBY2RuAcuZuojLNy9N	8904	12578	12578	1618203240000
17607	3NLAj3Wi6DE36hQEdR4PsrcXKtkiciU6uYcs6sAWsBzU1ts1jTU7	17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	1507	1280	300	6301	12463	jwDmtpTy5cG9J2WjYqNaMRCj6skM27iPMy6Y29Yhg9ywHDVvn4n	8905	12579	12579	1618203420000
17609	3NLruXAAkuxaWpPDqpAN8y3AwYxxifHV6RzussUuZYeDHtDhhrVM	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jwfdy68gVWFa1GMSxj7FiTtR3tqRbpnxa7oBNE5518HxTB2RQQo	8907	12581	12581	1618203780000
17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	684	986	300	6301	12463	jwq2XvNAVXcEHueyGjPB2ts2s3LDbJ9g8bX2BjaFweR8e1j2KYF	8908	12582	12582	1618203960000
17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	1406	1393	300	6301	12463	jwKEzCKoDoChYbWZXtgE3fptJK5FM4B6xNGoZtjkA7f7ByLZvLB	8911	12585	12585	1618204500000
17625	3NKdXajZ9sDbjWbhNViFDcn5cP5rMB3rSUSHCXScRydzeSHiBWNF	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1541	1298	300	6301	12463	jwWJemFztZgYpn3gnDTF9QZ4obaLkS8G8PsKgT3CCoDPEC39d5n	8912	12586	12586	1618204680000
17627	3NKh3QMHMrAYzoWhDFUpkcS2KaY6vFGkGv4c12d9PZNCD16eCznM	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1403	823	300	6301	12463	jws5F7eGpm44WbJDisok5Kua3QLgAYv369XT6BgGs7nMsfGa7XZ	8913	12588	12588	1618205040000
17629	3NLq8kfGbm9qLkwH7q6Ti7UryT4ChmfVpkkFLztyQrHrCnqjeqjy	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	1589	1160	300	6301	12463	jxVyWCpSSm9BxhxtWsbYtJR8xkQ2KuwXpQNoLsPnzFKJ5csS1ej	8914	12589	12589	1618205220000
17632	3NLsWUu3dtzLnxPYpY368EF8BgkpQPqjTW27qhvhHZtR3zzqdBk8	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	369	1312	289	6301	12463	jy22J3E6r9N5tAPsd8keFbfskyzsWaARpC1RpDD7DCdt2QzLgDE	8702	12589	12589	1618205220000
17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	17631	3NLKZbVN7zP4tLr4EfmFCuGiHkGHuYv3tuRBwCHBV4PEzgp5buud	684	986	300	6301	12463	jxEgmt21UwdsPQCdL95bzxgHFjLpkar4SA4HmbXNM3pB91xv9ry	8915	12590	12590	1618205400000
17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	80	907	300	6301	12463	jxs153p1X8AZnZ1J6qVaohvZCHbzf2UtR1GQqPPq9TBFhJgB9sQ	8917	12592	12592	1618205760000
17639	3NKqr1j1rARqv74btLNdmsB5CppX4NoHf8PYh733cz5AmB8EbTUn	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1613	983	296	6301	12463	jx8rqV3M6XXQL1mNtoX3KRf37B2Ew8ataGtWHjwqiDnuwiC3m2x	8843	12592	12592	1618205760000
17641	3NKtrrNFTLyw3SuRCvxFPBWb9wx4YJDGTtuq7LQxKMFaxDAXQQbZ	17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	606	1295	300	6301	12463	jwrP9z9UWzJUtGYHaPBY4wQhdY4Ei3Xu2TFJgtNScHguf92kMJP	8918	12593	12593	1618205940000
17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	17642	3NKqJimvsjPxDYn3qnmsUJFsXTMcJ8q6ZPhGfLN1UnbdmJvEBBPu	1407	1395	300	6301	12463	jwbRbVqo1mZAtLtfqCNoJToiqKCpbCJubpaRQAFkYBf4PDN7nk7	8920	12595	12595	1618206300000
17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	17647	3NKrEmbcxf1KUCBSUA4uWUNnv1rNoriFW55PgXjW2cVSD6Eudzei	1445	924	300	6301	12463	jxQ95y4SDQBqRD3ZPX4wYzXk1uvcWWvjhx27BUuTmhzJSvZsBJN	8922	12599	12599	1618207020000
17651	3NLbXsG7iECzqMCyuode3V3Nc4h47vvm6sR8gcXRiAW9wmX3oabi	17632	3NLsWUu3dtzLnxPYpY368EF8BgkpQPqjTW27qhvhHZtR3zzqdBk8	369	1312	290	6301	12463	jwuKhv1eVoix4yhE4jWwjgHn65dwjeqceWPgm7CoUxSHDW2EZ8w	8703	12601	12601	1618207380000
17653	3NLAm5mhis4RDgL75VUN6ha3t1eTTXJ33tsgorhhWHMLzQ4wWNHQ	17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	1516	928	300	6301	12463	jwti7Lc99hup2tvgE29fkM5r4H1LsEMSE5DB3E39rdwjij499TB	8911	12602	12602	1618207560000
17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1577	1201	301	6301	12463	jxihwEfAdfvv5Udm2iBES9omJSbYsPGRdXwgkfA2GzFHG5DUJFy	8926	12603	12603	1618207740000
17659	3NKjm3ogVxdYmmohj824d6DZ55xr8sQzCiiBgPtkDiAJVmjhCtC1	17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	1406	1393	301	6301	12463	jx7HsE6foWKTpFunDYuYdAXJKxWNoUDMwvnxBz3dLLPcKHZcE4k	8927	12604	12604	1618207920000
17662	3NLKZFsYQAnKDKhuY9sA31bxhQmLxZz45bhT7fumSzp81Y95Qm7U	17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	684	1352	301	6301	12463	jxsYkAjzmua4YjMw2VvbGrXWNrBPUR1GRTsTAUHBP4BKxPmCNrq	8929	12608	12608	1618208640000
17624	3NKNEJWJv8AvePHjtHYJaogkFsU6WUwpS7ZGCaB6tPBEfWx9Y9W3	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1541	1298	300	6301	12463	jy1DfzijEJvr19uRyskZajNskmCyk98M8nzZpStRmB7DZ151Wc5	8912	12586	12586	1618204680000
17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1654	1214	300	6301	12463	jxqPPiARFZeyxrxzzNWPbumyZWXWXHfKozXcbLZzF6SF3fenKsT	8913	12588	12588	1618205040000
17638	3NLNzTBcertzNUrayGqwMqaQ8YkHLkjWiQq71ZXkKK9uiFWwhJow	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	1631	794	300	6301	12463	jxp5JGqYDZeQXvEmF4FQttz2YTmjoArCB7pmysjHdWX1P4A4EEd	8917	12592	12592	1618205760000
17640	3NL9tSecgRiwYWhiquX1FrGX9rCbk4VwznsWvoG9H6JpN2yJppsZ	17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	1406	1393	300	6301	12463	jwp8PKYoL6xSWcPyLFb9vTgVPtzVq3LgZMyoCou1AacFmW4vZt9	8918	12593	12593	1618205940000
17642	3NKqJimvsjPxDYn3qnmsUJFsXTMcJ8q6ZPhGfLN1UnbdmJvEBBPu	17640	3NL9tSecgRiwYWhiquX1FrGX9rCbk4VwznsWvoG9H6JpN2yJppsZ	1451	1292	300	6301	12463	jy1fGnS31iWSmHSun8NuKUQYVmKG6qAbvyHiS7gsVWa8GNoyfMf	8919	12594	12594	1618206120000
17645	3NKtFVfNSBiof5vkityUaX5NzovaTWiQEmn2keMB4bWoCfxS5HTM	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1426	998	300	6301	12463	jwQHWuT4CTXn514Ux6oMWPjG8vJyBF2DTbEFS3z7kmfoJ5t2XTG	8921	12596	12596	1618206480000
17647	3NKrEmbcxf1KUCBSUA4uWUNnv1rNoriFW55PgXjW2cVSD6Eudzei	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1549	1236	300	6301	12463	jxca7ASxfvajrGfycYK2gG5kdEm4C57typg5L9baWjBpk4PehuX	8921	12596	12596	1618206480000
17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	1631	794	300	6301	12463	jxpm6mGNzj3HdxaeFwfcYe7DSchDDhieC2gJVtj8Xp4qRtCxqeN	8923	12600	12600	1618207200000
17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	17652	3NKQDrcGHRzZziViHfU52qUeNYbHJoADE8fkardBuiZuAW8PfXQ9	1474	1329	301	6301	12463	jwfxsdqCckdPd1wDyai8nmJQpBTKS2q75KSDGzdthzDhCRcH97V	8925	12602	12602	1618207560000
17657	3NLbQd6NhysS88g86RERJrSajS5eRyK6rdZ8cqwwJWFBhNUSWhJB	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1657	1344	301	6301	12463	jwaU1pnPDCa6HX9zDFJtVoCxvRDb9u3EQyP6Ti8N3if7XVYT76g	8926	12603	12603	1618207740000
17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	17660	3NLaJ3rjTvv2ZbKrPb6697GePXvxcmveZgihpeUYf57GNuHp3QJc	1471	1140	301	6301	12463	jxY3sVWJJe4gFBbTmZJsjaEA7McDNedRKgKqrynLyzhKpgwai5Y	8928	12606	12606	1618208280000
17664	3NKtoFEJnymwqiixrPXtfByeDEpMYC9hsHeJdkopbZMXFvFxXJry	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1406	1393	301	6301	12463	jxBaGSUXhCKaoTkTtFJ9GDXAUXFKCMB5c8mFtg6oxRWdEJdFdwW	8930	12609	12609	1618208820000
17668	3NKNyixKBRpscWv8JWQ8Z6VYnGNibnysXgAgGLNGt4QGf3UA8zMn	17665	3NLxZDAhNXB2R473sQK74x154d2ZZA5Q1mkcNCiGb2zqw7cDKiNC	1407	1395	301	6301	12463	jxigEQZfR6b17SGSKgaowwbG1Met6MHQuho9hY39KZU6BuF1tBz	8931	12610	12610	1618209000000
17677	3NLt4LKFD3zSuULXAozE1X4bYEaRdoEjDLRi9pnzD5WfaCbnctJE	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1585	1240	301	6301	12463	jxUN4yJi2zSx62PMHD2Q5E7k6p7JqsNuKiubLeBL6gJTXG3omAU	8935	12618	12618	1618210440000
17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	1593	1346	301	6301	12463	jxERGEkWMhcEjyUD4QSr871QbSGYRm1bo6aNe7Zk4NR7GpHUE1P	8938	12621	12621	1618210980000
17683	3NLJxMv21giuB8SXovvP3rL7MFNyx3EAwBsywGB2YLDZcxv2uDbU	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1542	1304	301	6301	12463	jxNfrBadYjEKvBKyDJrWzBSQTzYBeXXSauvfUYTQ1BRS1iRJW3Y	8939	12622	12622	1618211160000
17686	3NKMMnutkUXc7BJRRPBZt4k4c4RXSPDvbadFsfjtZWVzzg3L31HJ	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	641	1336	298	6301	12463	jxx76e9MzV7pimSUT1MQecNz1AVeVHgGmRAuFGTSmLoD7u7w1rd	8863	12623	12623	1618211340000
17688	3NLKwR2WNymmRwwDmAM51LjEsjSQZ9FgSWjk9SrDeQmux9NR9RtF	17582	3NK5X4w4Apm5iySfFNqybA4vvtGgM2AXJiW4sY66SS3SfAeo1Qij	1571	1335	297	6301	12463	jxFMB2a9Tq65RJpySZRkxZtEyXgsu3RABjViHcCZtB8bSuFSrHi	8854	12625	12625	1618211700000
17690	3NKFEt5tvEVCjyzDw37K5y2KuVeqnxpfu2xhHDpG1VUfrmRNd5qT	17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	1501	1360	301	6301	12463	jxi5FNMS6oeVAk3Q2yyCjKZ29jFRUvYPJttnW7Wht8QmPaSbjxp	8941	12631	12631	1618212780000
17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	1407	1395	301	6301	12463	jxL6GqyHTK2t8ST4a4CfPndQ6UWB58FmZKSRiUrCuyKM2V9cuUE	8942	12632	12632	1618212960000
17700	3NKJmFYVSZuzzCEAF796GxxuzL5mMpR6EnEt1DegoCRkCe6kdLK7	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	302	6301	12463	jweGXqVJjsrE91p1UWuqw2V94rFvcbPZ5hCMXDQ22RXwj9M75K3	8947	12640	12640	1618214400000
17702	3NLCGoUH5fJXnNJyoJ9TSojPohAuuu66EvxvQSSX93KMua1vzcKm	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1500	1051	302	6301	12463	jwPnbHEA7RpQMescXm8sxB7cdbadnQg25KCWCybNF6gPwdzr7X2	8948	12641	12641	1618214580000
17706	3NLMgQx9SY4cijFT4w7gkZoB818zsRvT36q6aWDxmfDf6YsBPphh	17700	3NKJmFYVSZuzzCEAF796GxxuzL5mMpR6EnEt1DegoCRkCe6kdLK7	1648	1158	302	6301	12463	jxDdkmx5vEWhQvV6XGzpE6ciUZrvEVETDhZBvtJ5KVdWof1fExH	8948	12641	12641	1618214580000
17711	3NK44gwccFG5cRxni2rXP7kcDpScy3CCv7eP9EcLnFS5UVm9Xuac	17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	1406	1393	302	6301	12463	jxD5SyjfvF6cPqc23jD5aHxY7tdCXwYXv8C81KogXLreixMkhV6	8952	12646	12646	1618215480000
17719	3NLhqE7Qx1fviZDgDuem21tnqAKmQ3eJRuZje9V6r2fHUqfj1iP6	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1581	778	302	6301	12463	jwAnnKPSUTTQSm6ZwC8rxvSgFwdWDE8bY3kCmu2vCiog5EgmVvj	8955	12652	12652	1618216560000
17721	3NLd1z2sRmqT1AQ3DoaoGhi6gE28NSbnhmitmHZfbxbDrsP9MH9U	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1461	1271	302	6301	12463	jwAjg7qbsdXo27V8SA4XVhSFEva4ghNTqnhMr6tro8zK4u1VSzW	8955	12652	12652	1618216560000
17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	733	640	302	6301	12463	jwTZQHu6kfvuUBeHcu6yWRQCFYFFauxwXucNzoAjJyxfUpqq3PR	8957	12654	12654	1618216920000
17726	3NLJes9crH4hjxf8gcxo9JtQ7Tqw3CaxAKVYE89x7k9m62dvPYjG	17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	1589	1286	302	6301	12463	jxBPDrAsAC8Xp1FXctLYWbK53rXBHQbQhbM6CoVhGhXopLnKd7K	8958	12655	12655	1618217100000
17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	17727	3NLaM7E18y48d7YnX5zpGbsjdn7FEPZkE6iwWv7md2MV6p6Aiv8G	1637	816	302	6301	12463	jwgZDXtt4i53zituCM1s1EQqf32k9GVSTK1CHiNhDdbGhKYJqmy	8960	12658	12658	1618217640000
17731	3NKkpeLPxi7wZig2r5AUAmdrcVNHT4iZg9MY2XGghk9whto3iK42	17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	1448	1311	302	6301	12463	jwKAAdWBWMmJth7MJW1WyY9BTufuSZ8d9RRS6ArxNSgKp2f7Cck	8961	12659	12659	1618217820000
17734	3NKdvScgHe8AzdTtKmdckk1gp4vkqakq8LHCsr1zLLMdmQcr8GsJ	17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	1503	1151	302	6301	12463	jxEvHkSQnVAJpMxtUcZCJiVp7BTYxJQuGc1Yo5Bbc5YqWUiqgQq	8964	12665	12665	1618218900000
17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1553	776	302	6301	12463	jwnWzkvyeHnwSwAF345RSeWshcZ1qwZmwQCFLmXtEv9UEbcooS8	8966	12670	12670	1618219800000
17637	3NLKe2sfjAGrnC5cvVavdsR8PcF192W38VBKzVv1oigQRjCVTJGo	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	1581	778	300	6301	12463	jxu865B7FEiP81quDVnNGdLpkug392Z4i6CnSttWV5FNYMrJfSV	8917	12592	12592	1618205760000
17646	3NLFx41rXEvYk11gzczmaYWrpepJMSkcwV6omMB1jehr7JtuAjBw	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1457	1025	300	6301	12463	jxjFDz7XWyV7xNEE8PGXPLMm4sJ4kW76FgZTiY1vCrE5HDDnXZu	8921	12596	12596	1618206480000
17655	3NKaKW8NjL4nraZM4Q1i5jLboBy82XMDq6Dte9XnnbU3d8uRtQvK	17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	1474	1329	301	6301	12463	jwJpE4wHR5H7ZCrhAkBazMrYxeXzN1X4PVCAddLhQv6ajN9LogM	8924	12602	12602	1618207560000
17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	632	1256	301	6301	12463	jwemvGGcFEY3id6oanB5KPFXDgsSpXyTq2sDjhpCqXPcjNsc3PJ	8929	12608	12608	1618208640000
17666	3NKXWMNkzUsSw5nzNWyUMfzWCoVqu5oqrPvfGj5TUuJovstqczQ9	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1594	1326	301	6301	12463	jwJeLtUzTkHprdYpmdyRwgMku2BXtjxDERPkp37nw7Eg7NUFBiy	8930	12609	12609	1618208820000
17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	1407	1395	301	6301	12463	jxFhUW58sfQJ6L9orMx8wy39NKZzmz8XjK91bRdqXAPGpYyHNoD	8933	12612	12612	1618209360000
17673	3NKXBTCm727rvxaiH62yRLhAuchWCwE5uBCEJoMJ452KXYYpbjXo	17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	1490	1028	301	6301	12463	jx6fg8AbNXTvZs4taybYcofK9qkwt7xWYANeexk9sEcG4Cknd9k	8934	12617	12617	1618210260000
17675	3NLRoVLf6KXpj7Rt36HJBL6P2wrkYKUEtH48k5EZgcNDDhTdAmBV	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1406	1393	301	6301	12463	jxqSyavnjQAjiWVDfEw1Ep8mpbxRxm5PGHkLpQBckccoScHtaLe	8935	12618	12618	1618210440000
17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1623	829	301	6301	12463	jwqWzciv7Q9CnfnF5zTCNqDJiwQZeUKPZeGe6Uu3aHpSZzqg5Vr	8939	12622	12622	1618211160000
17687	3NKPNti4qTxNchaqaFHrNvU6gLbBERtR7MsdjWV3LhfCLhQdKezn	17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	641	1336	301	6301	12463	jwztpUR32xbSgHT6hZ4HdngagkkvRf9wpTUNvCGkPhXjDVf5kGB	8940	12623	12623	1618211340000
17693	3NKmycjxCBGDFycY4vbBza1wytacB2Bk2AfiTQjVbXTsnwz7oKuo	17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	1507	1280	301	6301	12463	jwr7xT6gofrVrrowfPSHz1pRTFcwr6weyMveK52veX52dspPwfW	8943	12634	12634	1618213320000
17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	301	6301	12463	jxyAQzRHZtQbxjQN9JgijQfnpTPZ1orNjiPmxYi5SjupgfmWZXY	8947	12640	12640	1618214400000
17704	3NKBBtn19C2wUCZYv1DWpVixwjr5Wnnhu83JNuSC7L9xvZEBrxCS	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1619	1275	302	6301	12463	jxtSWCLjQ1EhsijuJCJnePn9ZyGuQ3L7iCpUcPYn7mpw8hztHXy	8948	12641	12641	1618214580000
17707	3NLesCiK7Uhj6XHyf1U1EVYHbUMH5tqVw7ev1zW5LgY8Yi3nTWCW	17702	3NLCGoUH5fJXnNJyoJ9TSojPohAuuu66EvxvQSSX93KMua1vzcKm	1406	1393	302	6301	12463	jxBbWBQon84Prc9pmhTX8GjTrJa65EhmN25pcJY5NHKu8832eWm	8949	12642	12642	1618214760000
17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	1527	1293	302	6301	12463	jx7g3jbvuMum5TZehtpPrCp5yADQSqNbkL2zy6vHGPCkHoiSxNi	8951	12644	12644	1618215120000
17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	1671	1365	302	6301	12463	jwq2U5GYi57dyAwE7h9fCJ8vLECXtf7hDuNXxDjVyWVeougxzKh	8952	12646	12646	1618215480000
17715	3NLCo1XjU1M5tcYMVS6fNGNngU3gspy7WgJJUwi1H5kzBKQvymqu	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1527	927	302	6301	12463	jxF24i4VnbNqzWs3AcP46xJTyyuqfkvy3nyY2FM3MTmdrN6H2io	8953	12648	12648	1618215840000
17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	17714	3NLWpQsRyUwsK9VKzZCJNh2BZmZanFQpUzXJD2ZVw8v1Jf7pUKhP	1406	1393	302	6301	12463	jwnVZ39nvUp5kbeUBLNFQ25BMjXrxaxzAdghwXCm4eLhLWcbont	8954	12650	12650	1618216200000
17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	17720	3NKnHpSp5BtmbRDHQ2nEguke95U1DkebAvXZ6aadP1qvcTeHQAbP	1406	1393	302	6301	12463	jxEAgMtbfdUpkpJgRiLLgWgRuJ9DrMEYCxzNF1LCoep3Fbxq8N1	8956	12653	12653	1618216740000
17727	3NLaM7E18y48d7YnX5zpGbsjdn7FEPZkE6iwWv7md2MV6p6Aiv8G	17726	3NLJes9crH4hjxf8gcxo9JtQ7Tqw3CaxAKVYE89x7k9m62dvPYjG	1535	93	302	6301	12463	jwYxVVSmMtwYaN5QPHy3HN53c8zuVBT5hAyC9QQr45m8vUYfZLA	8959	12657	12657	1618217460000
17732	3NKNJZXA9b9Pjftc9vwM5LNcDVoau644tweFh2STt7U4jo1eFcsM	17730	3NLrQvd1E7RUtNMEsXLLaeAGW7FiUVorsY45cmjBDne7Kam9EAKV	1419	814	302	6301	12463	jwRkvn94TtGGVWrtxVDTy9Mdn666zvBeYbUaR1hzW7hWMJiTg2H	8962	12661	12661	1618218180000
17739	3NLQ5uB7pdP8T5guYaJLDaasHrBPx8X6XEg5mMd5nfQDemn4Kg4W	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jw7E5bQd5zn7XYLMaH2pD9mmLzg7HdCQUH2mecaUFLFjZrj7HcM	8966	12670	12670	1618219800000
17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	1593	1346	303	6301	12463	jx7tvokqNJNfHbPWpLA23ck81BhQS2omSDfy4iE1kqryXyFSz5b	8968	12673	12673	1618220340000
17757	3NLNrZCNjHFCzqionAHFaLK634yUnLsXa7Veia5QYW2AvAXfRpYz	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1649	1383	303	6301	12463	jwrvsvmsMTo1uMkbaLQvrc1getairGBY8vd8D9epfW1eGum4CZq	8972	12680	12680	1618221600000
17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	1503	1031	303	6301	12463	jxW7Hn4zv3Rm4VZFzBzJWFBYtyPX9Lcr52WB8BHQRnqEaywanJe	8973	12681	12681	1618221780000
17761	3NLHsMoVHfJsYfLu9UNunJrSswoTpGMYWhrEYS1LUZXSGEyffpLe	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1627	1259	303	6301	12463	jxyHMUo3N3QLCRJt1B5hWLwpHxmvSvnd8ebw5wQVTDGpZxq2nAR	8974	12682	12682	1618221960000
17775	3NLkoUMSLDPbtyN2qUgNhW7GYWEijKhK38eHuopokPmtfKv2bau4	17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	149	1283	303	6301	12463	jxEYNLKst7ULFvH3dvWA7VXg3fE92BEYRaLcf2r6Rnt2waiJbTo	8980	12695	12695	1618224300000
17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	17776	3NKv8Eg1KkV8e1xwv4Ea3s5N9cbuVidTvbkGFTvaMNGdWxbPqnbu	1611	1341	303	6301	12463	jwApbd7bau8NuPFgqPDoQV5REuVFpSxEQMKAmTzdkAjffX6qZc8	8982	12697	12697	1618224660000
17779	3NLFEMmSqBJXC8P4Nk7L4VkHYu98GtKj3zi9gNg3L6AEkW4Kgi8x	17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	576	1109	303	6301	12463	jwJtGuGW8WTSBq8iuguD4CWPfpbD5nEpfZLqPnPNHS5F9JJFc2T	8983	12698	12698	1618224840000
17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	1406	1393	304	6301	12463	jxLK7Nri7cSGLB653q13hFvnemm6ixN8xym5mXaYLQNi5GuAMDL	8986	12701	12701	1618225380000
17784	3NK5SLgDvtiRR9ZaNmnKu56ywy9gBxW8sthqBUq85ijrR65hRR1z	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1549	1362	296	6301	12463	jx6Ai3Q2bk2T8KGa2HQfTFEvSjJ2RedDZVkL8mcsqKDmuobm9bU	8845	12702	12702	1618225560000
17788	3NLZE4xpifLTBFzKwrJxER5zQsjuQEWH8sMD2Vm4N91YSCJUbY9Z	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1553	776	304	6301	12463	jxHZP2zN7er3VXAUGW5hTHyeRFQzBt48y97TRufU5q6gizWd8Cc	8987	12702	12702	1618225560000
17665	3NLxZDAhNXB2R473sQK74x154d2ZZA5Q1mkcNCiGb2zqw7cDKiNC	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1489	1134	301	6301	12463	jwWBiA87AhGjvb7s15rMfkPiv5bMnJsZs2UGigu9g6UHrgziZQX	8930	12609	12609	1618208820000
17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	17668	3NKNyixKBRpscWv8JWQ8Z6VYnGNibnysXgAgGLNGt4QGf3UA8zMn	152	1330	301	6301	12463	jwAw3CisdshTzgNd94u6f8GKU4DDNr87dEuu1w5sJo9eyBcEK4w	8932	12611	12611	1618209180000
17671	3NKkgYY8YZ8e8tYAcAX1DF61mUUBQib3FFXgKN3iHReurQRS5hgJ	17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	1585	1366	301	6301	12463	jxXmqcVZGW1HYo6GHSpSMzgmk4BnfUt3FQU1cNtW4eBh1E79xLi	8933	12612	12612	1618209360000
17678	3NLcWNmpVcjuewT9m8kMw5Nb6ya1QHrAoKziKUZQWGk4TjubRbAY	17629	3NLq8kfGbm9qLkwH7q6Ti7UryT4ChmfVpkkFLztyQrHrCnqjeqjy	1500	1051	300	6301	12463	jxRy63th2FtXjmLja1fTthhhgWRFRESZxm6foFe6CDkgBngMaVm	8915	12618	12618	1618210440000
17679	3NL7e1NBhmpLTb629T3uz5EKc6ejnvUChbjjMGLURmhhfAiTWKaX	17677	3NLt4LKFD3zSuULXAozE1X4bYEaRdoEjDLRi9pnzD5WfaCbnctJE	1471	1020	301	6301	12463	jwtowrQgXuhGB9uYp4FUpejinj9ViLjoW1v3aR4Xp6V4DeLMQpA	8936	12619	12619	1618210620000
17682	3NLji1fbaTkLMzGsJKVyqD5u7wKqc72PyMsqcUg9yYL2ozHprjwR	17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	1560	1291	301	6301	12463	jxiVSaZur45shVzhApMnDg8e7vjGaZXSLMz3KuertvXxEyzR7Vf	8938	12621	12621	1618210980000
17695	3NKhDVb6Fvc9NLVjpDe3spEfEqghZusim69VGikjnNbsqSy7tYBP	17694	3NKQPTuXNXo3BWT7evgQMNYmRFoDFcT25iL5xa78A9ykxe16AzRv	1601	1022	301	6301	12463	jwU39A56V2FfKX2jhK6PuqbHcf5UaDYiUxaTPZTzR4952chMEd1	8944	12635	12635	1618213500000
17698	3NKVCqFzG9uFDJh9D9X112fbtyg25qxCQNehjHxeXLnCb5Vaw6wA	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	302	6301	12463	jxfJW1CM4e4rRz6UBvbLD1HKx4Mu59CDmH3Tf6RaZ1xdPSE3b2Z	8947	12640	12640	1618214400000
17701	3NKvpPPGjqe7MeyurSr4dGKnMnwKgt9e1hWunizNZD2KSCrKk9KU	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1633	1390	302	6301	12463	jxT8iL2527UdDf8pHSVy9YqvKWZWUXzANihuTMsMbvWRsDg15YD	8947	12640	12640	1618214400000
17703	3NKGUvfByN6FGnmTVKAEE5VpXV3V19iaYMx7mqBccyxeLqbXhy7a	17678	3NLcWNmpVcjuewT9m8kMw5Nb6ya1QHrAoKziKUZQWGk4TjubRbAY	1500	1051	300	6301	12463	jxL7aGBg1axBA8WYt4rgDh5hkwGBj43ii2dRUYtzMSv7EbCZ1qS	8916	12641	12641	1618214580000
17709	3NKVWpf8k3RWjwTAM9V9oVwBwM3g8m9Ly7eUz2Eyg4SKzjn53cDp	17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	1527	1293	302	6301	12463	jxtchXYbi5apoDcjdoh3FGQWb7cq7GnxAx1kDp9P8tGhyfajwRm	8951	12644	12644	1618215120000
17712	3NKWtHL64a7cYuqJz7r44Bquo9YiDvtBqE77d9TouVo7w7r7rpdn	17653	3NLAm5mhis4RDgL75VUN6ha3t1eTTXJ33tsgorhhWHMLzQ4wWNHQ	1516	1294	300	6301	12463	jy2fmPhuFKq8BWGyagWTZ3HAAXddfhRgp3YG1X6NPDn3tHugqoJ	8912	12646	12646	1618215480000
17714	3NLWpQsRyUwsK9VKzZCJNh2BZmZanFQpUzXJD2ZVw8v1Jf7pUKhP	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1527	927	302	6301	12463	jwmuyPJPZvEFQZDwuzoHLCpWxtaQLWCznxjiPqZB2ACK5kJcLTY	8953	12648	12648	1618215840000
17724	3NL4ag3ViqTUxAUWCX2gN7D883hNFUxWvtBY1pxHBm8YUiPUHJyc	17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	596	1306	302	6301	12463	jxT5vSGB54HpchKGcabt28d9N71SehkF15eDjihYVpCxzBZnRuz	8957	12654	12654	1618216920000
17729	3NLWSU5P7hrVufxpRxKVQMi2b74jXS5PaPWhD9bDDh3Tfi9VRf2d	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1448	1311	301	6301	12463	jwE8gYSvxYYbDEiinAGzqUcyGcXDAdH1iDmjDLrX9d4jRrm9Jp7	8939	12659	12659	1618217820000
17735	3NLyVAocpWzN5dVBGARKfN41ufVfJhFd2tKe9DUyUZE8zQDVVCMb	17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	484	1193	302	6301	12463	jwmMPwsBCafqAtXFy3b2vz5nN56d8B5TzTyndJgXvG6TGxjip5m	8964	12665	12665	1618218900000
17738	3NLtt129DiUzd1SLu1miXQBpUp8tG4hynRaxFcafXZXqKNX25adZ	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jwMtj7hWUUJXzaD42ugo1GnkEgvP3SBcYRQkCC7PbrcKNsvZyPu	8966	12670	12670	1618219800000
17741	3NKuXM8ae5tm6NUELgxjX3kp2v7X5g8bUzM8jTua4quMx42EXvxj	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000
17743	3NKkmXTRd49KmNsGttaGf4ZawvgwPZsWPPJDcYBVUrYfMYdbvTwB	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000
17746	3NKVbu2ssC3LLAWhKGzAyFkCHHNXpD5iUd92UeRnhrBBSeD8X9yU	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	1406	1393	303	6301	12463	jxzS3DvJfZcHQpwv1Nv6yWsxsAxMrhkysAi8b5Nyjda2yn3Rb8Z	8967	12672	12672	1618220160000
17751	3NLPZdGZrEVqJ9TxB7QSVGMJUeDL8mDtKT2hfkxUhjjfJReykvPg	17600	3NLTuoFcbkUixe6NBTkoED6YQBmeFA6qPvnCTGeGtFUbebHbXB7R	1673	1368	299	6301	12463	jwsGfujodT2VQ5FoxoLg87LRiRHqPNMoMavUdx139mccpoyKmi7	8898	12673	12673	1618220340000
17753	3NLiQHuVvJmk2eswtWUdgijTXfCEqWHngyQ3qhhyjmiZi4Sb9AeT	17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	1451	1292	303	6301	12463	jxCX8oDfLzWvPoyPSqapKdfk1FARcxPZKUAEX66QoCFEm43mGLy	8969	12674	12674	1618220520000
17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	17754	3NLxptnEzRCcYJwzJ4g1Q2SokXs6xeAcXzN2C4vJQ71yEG2RcGF1	1509	1320	303	6301	12463	jwAGUB79MAxgx1EjouGvgriGULnVeiHGizKTK1v7PcMUwom6Hab	8971	12676	12676	1618220880000
17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1406	1393	303	6301	12463	jwAcUw9EeXsMKcVGwVpT1Jcmgt1pQupJtGvYDxAUvCkPHNmsxfq	8972	12680	12680	1618221600000
17764	3NKjbttZFy6WtswGMf1ZyJp2vTatX5QccF2f8BuEbtC637vzY2TP	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1559	1353	303	6301	12463	jwqK8FehwVeUW8imjDDmUrUH1HqjZXMkNtaM296U5MP79oVSNaq	8974	12682	12682	1618221960000
17768	3NKaioaZi1iKA5e8Pe2a8d1PPFQwSsMKSPPpLZKJx81SM1yqgKpf	17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	633	1384	303	6301	12463	jwmC1N3bWRxNo7bK7pp9jkbsKPbb9vLwZhj11cByTyi7CfSDRP8	8976	12686	12686	1618222680000
17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	1631	794	303	6301	12463	jwfq5mnF65KPXJCiB3TVtVy9K7TgZGCnctEF4bzATpcUqA2BNVs	8978	12691	12691	1618223580000
17774	3NKNSGDTAMkbondsrDJRAbZpZvUVewHZUtvmC6oPoF3a95AsVMBX	17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	1553	776	303	6301	12463	jxwatf4NJgu7SajwScyJv2KJTRFanrLXBk9ot89HGzqQasKZH9n	8980	12695	12695	1618224300000
17776	3NKv8Eg1KkV8e1xwv4Ea3s5N9cbuVidTvbkGFTvaMNGdWxbPqnbu	17774	3NKNSGDTAMkbondsrDJRAbZpZvUVewHZUtvmC6oPoF3a95AsVMBX	311	1307	303	6301	12463	jxfkf3sS3FC33jqpFPk3du5VTcGFkQWwBa7fLr2oFbiz7JyscmN	8981	12696	12696	1618224480000
17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	17780	3NKJXJbS1BDGzKSQTrrCjNVjaRTLHLAinnFLFH4zUJ7g2hM8s5oy	1589	1286	304	6301	12463	jxCqWBXrnYxCTikrTmfqhKz7rmdRQoxwwQqV92ncb8tnUNpNqR5	8985	12700	12700	1618225200000
17787	3NKWSSYqwhZtK62pgLCgbohbgGm9EAMwBUim6ePN5N2f54aQFBn8	17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	1549	1362	297	6301	12463	jy2ZWqsWKspp7xFLcCvVXbVknuFrh5LWVFxFXBqc9LmJTyEmrRm	8857	12702	12702	1618225596628
17791	3NKidjcSp7vh92wt257jPtBThBfuygHKksmhysp3rvyvqjvHNES9	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	1549	1362	298	6301	12463	jxR5dDn1GDnJbJdrSyVo7ipDigg6LorTh6bTinZTUfnnCVp738w	8882	12702	12702	1618225663880
17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	358	358	301	6301	12463	jwQRmtp6xHdv9YUivpaZ6gdX6KHvcpoqeQADmUQMAebfckuTBeo	8934	12617	12617	1618210260000
17676	3NKB8tfmq4ExLYCNnbfGHnDtnnnEoXCsfk7eCh5ktVPpRrpuWe1K	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1500	1051	301	6301	12463	jwvuQqYJsSjMwdZ1nNPHh4wtLmMJ2prgg54ckyuNfpFvKqGYZTY	8935	12618	12618	1618210440000
17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	17679	3NL7e1NBhmpLTb629T3uz5EKc6ejnvUChbjjMGLURmhhfAiTWKaX	1407	1395	301	6301	12463	jxstN32Sgm9Qcd6x1c2UfF9Eh6E4Jnxx5pz4AvcwvWuxvRe83wo	8937	12620	12620	1618210800000
17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	1406	1393	301	6301	12463	jwzFJmkgn1VcsRtEWiPcgBCVvzVLuzKxPpC9CEZ3dWLi89tCZ7c	8940	12623	12623	1618211340000
17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	1564	1092	301	6301	12463	jxFqHZ3cwT61s2zGKpJxMsCyaEt8NovfNTwmfFNtKYWViDjE3iw	8941	12631	12631	1618212780000
17691	3NKNZAQZzSvT7vnq8P1C6rxDN2CkVSqAcK4sE5t5nPeg3xQstK55	17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	1610	1314	301	6301	12463	jwas2Sbk1DAXgYn3g55D1afm5Ee2UK3V5gzphNNQWz7TJ7y7LRG	8942	12632	12632	1618212960000
17694	3NKQPTuXNXo3BWT7evgQMNYmRFoDFcT25iL5xa78A9ykxe16AzRv	17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	632	1382	301	6301	12463	jxRKLCEC4tyyjM99PNvnA21uQencuAtikbcWdKNp5xG6kMeEcq4	8943	12634	12634	1618213320000
17696	3NLErYVdWLBSNnsTASWDpzdpD4XAKXJW27fGaNtAE6zYTvKg83jb	17695	3NKhDVb6Fvc9NLVjpDe3spEfEqghZusim69VGikjnNbsqSy7tYBP	1457	1391	301	6301	12463	jwcfgREyYoFJ9mwntokmDGBC7ni4mzWdybfCtB3PEbp5nv2rMNc	8945	12636	12636	1618213680000
17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	17696	3NLErYVdWLBSNnsTASWDpzdpD4XAKXJW27fGaNtAE6zYTvKg83jb	1407	1395	301	6301	12463	jxW7o5W9TCzqQDFafJLtUDfSb6mJAkS6Ati2QXKNRqU3d4FiLPx	8946	12639	12639	1618214220000
17705	3NKtjBntoBMfRztbVh4baJib3WumxdDuRNsVMvY7z73QxvpNwFF4	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1619	1275	302	6301	12463	jxtpuDUyYEeReBX1MDAZCpZAK639YP7hXuefwoUsb1FnbArnQzc	8948	12641	12641	1618214580000
17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	17707	3NLesCiK7Uhj6XHyf1U1EVYHbUMH5tqVw7ev1zW5LgY8Yi3nTWCW	484	1319	302	6301	12463	jxEJDg9335NADT8Rbqd759BtCmysNEcT9JZUmL13TMRxF4S4MQp	8950	12643	12643	1618214940000
17716	3NKMwveqMeTiWmGEog6JPUS2U9SMkgbZe3jUBqdFyAFZLLxhqX3j	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1617	922	302	6301	12463	jwhaE6CsXjNGvo41rEGm49zaKBGLyppH3yjXfmkDd4C37QM13Ju	8953	12648	12648	1618215840000
17718	3NLpUmQZhkkjUTiTeSG4gFjQQLB1xFSBMCGEyNT9jcfGQrbTTvHm	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1672	1285	302	6301	12463	jxfLkiqCMahLJtuXNoTGx1r3dZzFYYjXeK4C4BkJVu6A9mXgF6y	8955	12652	12652	1618216560000
17720	3NKnHpSp5BtmbRDHQ2nEguke95U1DkebAvXZ6aadP1qvcTeHQAbP	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1652	1069	302	6301	12463	jxYHdqd1JvugqJp7FwKfAZYF23KzkSn1uryiFUKLmNz5EAzn2n1	8955	12652	12652	1618216560000
17725	3NKfCizTHz7Txw2WgU6wgcpk4cHDfJMxrEWPL53Jkjgnezk6qk2b	17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	1402	808	302	6301	12463	jwjkxaBqHeer3h5WAy71jkTEyULHUfntzkm4G3nc3UihuU54a5f	8958	12655	12655	1618217100000
17730	3NLrQvd1E7RUtNMEsXLLaeAGW7FiUVorsY45cmjBDne7Kam9EAKV	17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	1448	1311	302	6301	12463	jwytYQngubKYsPeusALaFhSX59qrNcMjrcd4FGyaTi49KAQu4Hv	8961	12659	12659	1618217820000
17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	17732	3NKNJZXA9b9Pjftc9vwM5LNcDVoau644tweFh2STt7U4jo1eFcsM	1637	816	302	6301	12463	jxQh1xCu4GzFK3nf1otjJ5wcBpK4w13xs798XoSRSr8YwvU1eAQ	8963	12663	12663	1618218540000
17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	17734	3NKdvScgHe8AzdTtKmdckk1gp4vkqakq8LHCsr1zLLMdmQcr8GsJ	1631	794	302	6301	12463	jwQsGNXTit1pjVvPgekc9TnZcDQbcaJAPpSu1KY7drCFxcGbXLQ	8965	12668	12668	1618219440000
17740	3NKdQHzFEkjLrqLeu45s8dQ9MGG5v4xfsrDw4JAbhse2Q6wAuZt7	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	532	1303	302	6301	12463	jxU1LR8enPhzn4qMsTWHvcu8ot2vbEtB1CUajis4QqEujaGQsMT	8966	12670	12670	1618219800000
17742	3NKmz4NKtGSFpkSwRP5gqR3qikSqGb4SyjyaZ5skGMz3xZTJHd2s	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000
17744	3NLY67YtSe5DsotJUkoPG3EwyvpgAMU66rofum2rbrTCNPhkeh2K	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	532	1303	302	6301	12463	jw79epwzM5C5tHT5Mw7X9f32PwNvvvmUYwgWjC4an6ge1V5ewYm	8966	12670	12670	1618219800000
17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	532	937	303	6301	12463	jxTS96b8Gu2ECpTaSLrueK38sVKyCz8gZgULwustByhAgcAoE6U	8967	12672	12672	1618220160000
17750	3NKbgWdbH4Ao8u5gQurasqG56iQagbYpKgyD8y9HPujyZLzG14Zw	17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	311	941	303	6301	12463	jxtoA6F7EhnkbjJJRrEzHSPNzoEyuVJfgAUo3fNcWmyVz28XvCX	8968	12673	12673	1618220340000
17754	3NLxptnEzRCcYJwzJ4g1Q2SokXs6xeAcXzN2C4vJQ71yEG2RcGF1	17752	3NLKCQ4UTkCg1z52nwDLB33CnMkGaRNoTG4CNoV2JUzFS5kc4Cdv	1668	1370	303	6301	12463	jxvddFdfQJihsoxFg2zKDEWrjYBvstedtRWVLNigg1bEfPWJJJC	8970	12675	12675	1618220700000
17758	3NKsYZMmkL3rKiitiF1unuob2uojKbubq34hXi6GDouyBkeW3MDK	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1602	1003	303	6301	12463	jwsj534zmbjFQyergXPyMC68g8YShTJdErESoGxpVSfDLMXpDwM	8972	12680	12680	1618221600000
17760	3NLuL4p8YfbR6mmk23y5UCwRkzUfM94xt3SQ41eHrEsUuC2cT3um	17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	1483	397	303	6301	12463	jwbALSfNAm71MMxffGNzEN75Sdwqxioh5WrTsYuNB2J2uiP8zyb	8973	12681	12681	1618221780000
17762	3NLRM7XynzDwBXh1VJs8ksuM1bJwDJ971LMovCMCrZjVsRK7ps2H	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1406	1393	303	6301	12463	jwhrwkHcAx43byjf6DzXcqQY1Div5nKuJz8WN2amjwUNtTs32YN	8974	12682	12682	1618221960000
17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	17765	3NLddKoeLA2ZWBmaEKrz7cEUL68JUbukq6vmafNvqJWyzppoESuy	1455	1332	303	6301	12463	jwkVBL1UKRiSemK5CgwxECb6MxkcxEaTyN8rvRQeZoysc5RbaGk	8975	12684	12684	1618222320000
17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	17767	3NKM8WVFt9tm7tsmh2vNJcBCRmKU14WYC81eeVftveqvZy6HsXJC	1631	794	303	6301	12463	jwngVMtHXTmYzNrdV7hoF8mPb1eiNrLiSVrQ8Axo5zi1MVmEb1b	8977	12687	12687	1618222860000
17770	3NLtQbBASUHSs4pXjCG461UTjeD6mGRD9jcKtp2JbhNpcjRwuKgq	17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	1407	1395	303	6301	12463	jxUTdqKc1tvAHVdzr1CuNjU6J14d2kN1VGsw7YaDf48WUCVXDFZ	8978	12691	12691	1618223580000
17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	1406	1393	303	6301	12463	jxm1hRfDRZyNiDkWBPXediPTjaF1EAzJoe6gQrfnjzb2uhrH13J	8979	12692	12692	1618223760000
17780	3NKJXJbS1BDGzKSQTrrCjNVjaRTLHLAinnFLFH4zUJ7g2hM8s5oy	17779	3NLFEMmSqBJXC8P4Nk7L4VkHYu98GtKj3zi9gNg3L6AEkW4Kgi8x	1608	1043	304	6301	12463	jxc1vR2295oVL3L4nA2iaWNMnf8huh9Ec6jyMZpsAnMDidH8Spm	8984	12699	12699	1618225020000
17745	3NKaYVJW7iwpktXb9E8oeiVf1gu3MbGejToXXMZ6yKxZ9kiPWQNz	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jx4TTyhKcq5Ke93RutC3rQWwPQpZyK41m3Eq64g92rPMr3iixyi	8966	12670	12670	1618219800000
17748	3NLZXttXFYmGfcNKgsRdavEEjL8XZWpEpwQ9LLqGDS1Hwo79zHVn	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	532	937	303	6301	12463	jwjLtSaX1vbpv7Hoa1kgoYxoCZaYki4vhDZos5qmdfUvFwSUz4H	8967	12672	12672	1618220160000
17752	3NLKCQ4UTkCg1z52nwDLB33CnMkGaRNoTG4CNoV2JUzFS5kc4Cdv	17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	1670	1282	303	6301	12463	jxiXDpMmyrDau9WLH5B4PwY6A7cxHLA24rhgZTqcPDmoh1RguFc	8969	12674	12674	1618220520000
17763	3NLXSW7Amqoh4qucb6u6xKR9TNu4a6B1NVviNN67HHxEssFHN3Kz	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	606	1295	303	6301	12463	jxUFy1PpkuKPF3o4drBtnZWR41nvi3sxTeaENssrLWCUporhQnH	8974	12682	12682	1618221960000
17765	3NLddKoeLA2ZWBmaEKrz7cEUL68JUbukq6vmafNvqJWyzppoESuy	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1451	1046	303	6301	12463	jwttKxjkhsFWUmWYcVSZfuRu9PUYRTE3cY1uVMxPrs5W3QyJinf	8974	12682	12682	1618221960000
17767	3NKM8WVFt9tm7tsmh2vNJcBCRmKU14WYC81eeVftveqvZy6HsXJC	17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	1406	1393	303	6301	12463	jxAksvJpmDsmfAR2VRxjax2pQXjnFfwhwe5HizsPEdh4wS8mVuz	8976	12686	12686	1618222680000
17773	3NL4912t6k7EpGjTUyYz4wUeAiZzwmNdB821P41frFCwhcBYCBBQ	17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	1579	1389	303	6301	12463	jwnhhJgtaaaEe8t2k16YUZhXWcyWgo94y3uiZwuajZdsiNdTeHn	8979	12692	12692	1618223760000
17778	3NK9JNBUApguQeLpJE6xKETePhKaU3va1JYzUYA5Kx1gTsM3HDVc	17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	1599	1161	303	6301	12463	jwFHKQJaHq4AyeQ8SKADi4LbaxiU2vWxvM8sRe38SZUCyQWGLMZ	8983	12698	12698	1618224840000
17786	3NLHLARUVR9LFZzNHWzyUtYpELuW3m4qJwKYogefqujo1JxQJvxN	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1439	1279	304	6301	12463	jwdHo7ayWmeL44pr7i9br7Ry8nyZSZBAFWGkBXct7DGzBso1GUU	8987	12702	12702	1618225560000
17790	3NKbNobdczPMEAsoEPntZW1RJRMGd57RhJtwCF49U9U656fUhfmt	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1549	1362	298	6301	12463	jxYLNqgXF2X5vJqQirwJBDzzaJPJ2WruJA7oeYYxvRzLSe8XND7	8870	12702	12702	1618225630387
17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1406	1393	304	6301	12463	jxudug7wCeZv3f2Nno98aTrLTNasj8mHKWPkGwV1q8SRpNYFbnx	8992	12708	12708	1618226640000
17802	3NLLZQH2Y4qJ8iVQdejQg1pC5uZ8thqneGsDGTT7gR4ZzEx3Syya	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1581	777	304	6301	12463	jx68MKiwimSFK61a1q6G7ADhYN6CSMHrD8WaN1S582QPUnEUqcq	8992	12708	12708	1618226640000
17806	3NL1hTbEdTFyhMJ59NuAAh4XtbeuWYob5nMHCgB8ZFg5TqGzMDfT	17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	1648	1158	304	6301	12463	jwK1rPCnvi4YCFpQeFecZXNr8PsyabGUzHVprBJjYxMcw8LjFbr	8993	12709	12709	1618226820000
17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	1672	1285	304	6301	12463	jxY2Qw7LdtvxYUhzygVFMecHjMTw6w6xPEgK1EYFu2i8wd6oBCP	8996	12715	12715	1618227900000
17813	3NKjX2akump6n8PGedBrARjX8C4QBmZSZm2EMRDjUJS83HS7AptK	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1476	1005	304	6301	12463	jw8oioyRQFHi4kek2G1RZNw2DJTWnb5JAR6tQPvjE2jRfEjQu3t	8997	12716	12716	1618228080000
17821	3NKKwhdQypyFfQb7q9fk6Q9voLo9c1futpa8Zygd3JkybCspGNLq	17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	1406	1393	304	6301	12463	jxi8ZReAoy5b78J9VHn3YJd8LAmnJEUhfvdX2uqakpihKJcpf76	9000	12719	12719	1618228620000
17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	17821	3NKKwhdQypyFfQb7q9fk6Q9voLo9c1futpa8Zygd3JkybCspGNLq	1407	1395	304	6301	12463	jwwLSZ5vSaAg5Je5n4kqmEDJDgv9Z5j661EzudLpqwnQSb6Lu1X	9001	12720	12720	1618228800000
17828	3NL6bxJhj1PFtV8ABvh9BPL31UqxSJK6mAHhXMsCcbHkVp8ZrHC8	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1402	868	304	6301	12463	jxUFgDyt26RQAR63Y4w9tGVSQoev7SMpCz8w4CXprRWYdESFEuB	9004	12724	12724	1618229520000
17833	3NKWf4azAupKSk6SXYEeNK5dwbDAag34TmVymweWntFnj8nNjYBK	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	304	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000
17838	3NLbvoAMd8aVqcTQwiDjyavLkUwPoejY51B5R8DEw4ydjtwCQLmW	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	470	1309	305	6301	12463	jwnTH8jxCxZQJqw9viLXKRNdKrAYXFGTc2N46nuVpnKwg6orqUv	9007	12728	12728	1618230240000
17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1581	778	305	6301	12463	jxNDvvgnSqot74mFVTGh9GPWjDqDPmjeszxJ8siTTSwKRqW2sYn	9007	12728	12728	1618230240000
17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1546	973	305	6301	12463	jwyvEqyFL9mnNJgVHsXeaQHYgdQJCdFwE8NkxAX4vYAScPcrTyG	9008	12729	12729	1618230420000
17847	3NLvWUgQUbphBGEwySjAwMbx8WdSbqQ8VUcWx66rCy8Gyg4DL8VD	17837	3NLjkqXzc3nzadwdFJ3xnKaLFHHzWzAZynBffUS85iFQKUff8w4Q	1403	824	305	6301	12463	jxZM47psPnLA6BQB1ERABeGwnpqmT3SMaNpxB81b75Gp4hsU2A7	9008	12729	12729	1618230490001
17852	3NKSdFb2vxJosVtJMFFEo4kaNBro3jcTCRGTMnLhzYzb2XJYS26F	17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	1406	1393	305	6301	12463	jwCGPMmxKaRt5QtwTH4PGQygf57uH6gNiZLQyNXKKvsA91dykf4	9011	12732	12732	1618230960000
17857	3NLXXAi9XhoCFe171Dxo9ofCvCeVTVgUjBUh65wCPpHWS3E4SDmZ	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1523	1195	305	6301	12463	jxsF3E3rYgtGw8Kvi85jxahU7H9EgA6GimifDZxRHdgYPfvF3D9	9012	12733	12733	1618231140000
17862	3NLgPSQ88YY85oy4F7A4aGZdWpwKegJ6G9D6ZDBV39UwuteppHeV	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1406	1393	305	6301	12463	jwrxaSknkD93V3dYSLAA5keR51SwQAQmSzhvzckEFu36UAjW9om	9015	12736	12736	1618231680000
17871	3NLXpp5w2NT8UiV6N615N7rt67tPupi3xgSRorQUwr8wDRPGsn4i	17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	1458	1077	305	6301	12463	jxfAJu7XEtMg1erqoHt9LunJXoeTGrFNt2tYmPt8e9DiPtLeXMx	9019	12743	12743	1618232940000
17876	3NKksPrs362UGdqVptqsqQ4uqJMNjCPnZSnvCQsuTkviJcrS7YYb	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1553	776	305	6301	12463	jxuM41yBvCseD97t6SWuxuumyiTcb3yQK2HAtRBivtskcdqLP8f	9022	12746	12746	1618233480000
17877	3NKjUeLwKLeRgnMmgNCBFT8WDa6RPsbqzENJbkzbhcQZiV6PFGtN	17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	42	1361	305	6301	12463	jwnfbuUN9uHGg9Wwzt6DFPYBcH1qC5XuTYCCiLKATezr8qhPfzN	9023	12747	12747	1618233660000
17883	3NKWkUZjErNe9ZQ7Xa2TJpzsK4tbM5ry2DAPEkZbCUSz25qAMMSm	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1403	780	305	6301	12463	jw9HvnjRZXjTiy7tBWcsYXGW5Zghj9XeuCZbCKs6fmwP6KcS2z5	9025	12751	12751	1618234380000
17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	17882	3NKY5QqTptMoauN2Jc9yYw36bXeuSe1ahL4Vja76zGeheb8dxVbz	576	1109	306	6301	12463	jx76Yh3ikzAcZt63MfjnEJSkmFhPtLUeppGpcKBWgan1eERs3eF	9026	12753	12753	1618234740000
17889	3NL7bpwMB5BBmx7c3qHrbdXCfF5QRtuHoqiHQw1YNvqBuAABVu51	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	1634	1085	306	6301	12463	jwq3cBsDhPMxnWJJ8D3tvVivU7qvUUDsMiP2rZEd8Sstr7dpFUh	9028	12756	12756	1618235280000
17783	3NKVpANZxKYjLie9q9ujVyCLCJiX2ALFSFjPXKD4s8UfDf3X54x9	17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	1407	1395	304	6301	12463	jx6R19YT2sfNPsKKDz4K8wiQd71vUHWKnRxDh8j99ELwavr38ac	8986	12701	12701	1618225380000
17785	3NK4QjEmZV1xGnHhTiJWFh2osBi8kLZ7mSSjuwVibymHB9ECujMx	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1549	1362	304	6301	12463	jwf46Y5fyZy92Tc2meEcA5aS3JiY1Uy54Ue4MnBX5thb1QwsrGd	8987	12702	12702	1618225560000
17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1540	229	304	6301	12463	jxacc44PvqFhsBnpZRWs99F3oqAyBrZ13s2nV9YQt7anZfQ8dBL	8987	12702	12702	1618225560000
17793	3NKteAhPtfWPR8SrsqCWT3s8xjwy2HM7R7iHkuCo9w94s5aLfSXj	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1529	950	304	6301	12463	jx4b41NVnd5HyYJosd6ixoQ4mGsVG6QZ6KuViYJkzQQ6VK5FuKD	8988	12704	12704	1618225920000
17795	3NKKboktSyLqjJWmsySiNGeCtN2iwQ8YAPAVBtJAfvFiNeRBFeMP	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1403	792	304	6301	12463	jxbsndTqZzLZvCRLpuQvkV3PN1qawwiaiug19MSwV3uYDipKLBo	8988	12704	12704	1618225920000
17797	3NLjUAUYtxjVs8mqDankxtFh2Lzj4DRESFjw7h9Ua5miHt9NXLv8	17796	3NK3quGv1mE2zsHvqs2q7oeNytLEXc6a5tejieHsRUVoTFqVLEho	1590	1300	304	6301	12463	jwtRyrP6iEwPaT4s1uLhvkUjDwrgcryKNnXNS4LXYmGTBh7EiBL	8990	12706	12706	1618226280000
17801	3NL5KxPvbE9Yd7AtLqtLE699tDptCvzWUvb5gxrE53a1JuieKgZ6	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	470	1309	304	6301	12463	jxh4QSMuQeQPT7SbhmLv7kWotezZrjgYqrPWaFssoKex3XvVJX6	8992	12708	12708	1618226640000
17805	3NL91q7FG5aUQpY8St5UFEF2Tbyt2QRYdaCj3trABVM1Mzz13yBT	17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	470	1309	304	6301	12463	jwm6ByzNtBxyCXkqLSHPMmi8maGQ3t3KhqoxBKmypQtVbdEtbd9	8993	12709	12709	1618226820000
17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	17802	3NLLZQH2Y4qJ8iVQdejQg1pC5uZ8thqneGsDGTT7gR4ZzEx3Syya	470	1309	304	6301	12463	jwufc5X8vuPnb9HZtKdwaiQrpfsaBhzfPXqhaqeSYRCaR7urGP9	8993	12709	12709	1618226820000
17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	17809	3NKx6a2bXxduQuYJEQsaES36A1QrLiZoKiaD7c9hnK2hYQfyQfge	1623	830	304	6301	12463	jxLwMyaYUKEcQVpGmZLsZe2mNDqPHz2FMb46pYVNfjk6v7zf8j8	8995	12714	12714	1618227720000
17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1419	813	304	6301	12463	jxbuGFLSciD5xxCtrch3nyMwHwottuCXbdokDSZAxjm1aNUZZEF	8997	12716	12716	1618228080000
17818	3NKnajEvcqRjxDh7ztArRKWu3iV2Yk7BKzo8Ns5kXgQiXnQBQcJe	17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	1637	815	304	6301	12463	jx4yUKs6efCmG4a4WidEXdZjFeEyw8fHfCamQWWXst1UdKXAFvu	8998	12717	12717	1618228260000
17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	17818	3NKnajEvcqRjxDh7ztArRKWu3iV2Yk7BKzo8Ns5kXgQiXnQBQcJe	1553	776	304	6301	12463	jwyXaeJG5Aipgk9wLrmhcKr4irmbm1mcD5y2KnmqyZ3Vf5FdxuY	8999	12718	12718	1618228440000
17827	3NLb6bfLWPHhADWfNywUMN8ZkRrtdA1WLjovwiYvRvcBAXizHLwU	17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	1601	1388	304	6301	12463	jxti8RjaJP6p2oAUjD4rNUr1CgqbVQUhtRd3PRLfBhZ6eX3hTCj	9003	12723	12723	1618229340000
17831	3NLmQNXecmXj6JMvp8iZjVm2mJn16gEKCXn8j93C31vQYCsjBLfA	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	171	1374	304	6301	12463	jxjfHLqE3jBsFsThxPKH2HMw6RwTDqpWV1LwMompeEHmRh1MPkW	9004	12724	12724	1618229520000
17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	17831	3NLmQNXecmXj6JMvp8iZjVm2mJn16gEKCXn8j93C31vQYCsjBLfA	1656	1097	304	6301	12463	jxaoECruUxEDm7uFhwireAzvv5n7MzgR7uNhCfVzQvMiMT6osXb	9005	12725	12725	1618229700000
17837	3NLjkqXzc3nzadwdFJ3xnKaLFHHzWzAZynBffUS85iFQKUff8w4Q	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1654	1214	305	6301	12463	jxwNsCDo7GzPQd4qGyPauk9QBZVyPjL6ZXkcudXpYnFLFMRBbgT	9007	12728	12728	1618230240000
17841	3NLdtqNtB4TDhfUaQwGzuzxebFC5xDJtVn3iW4ibCwa1yAJkiUJn	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	470	1309	305	6301	12463	jxbANz4AKgzXt29DqqLRQMGcZYSwcLX5HASj4yizgPgnRx7nQvi	9007	12728	12728	1618230240000
17846	3NKv1bZYhdPvqpY8qC6ytBNVCJ8YGrDSgimVBpv1QVwJqWX61F2K	17834	3NKtE7ifUyjShHjyAuboVTEMvmymRLCrDi5nAhgT8kyRroNk54Ac	1403	824	305	6301	12463	jwLd19xtCCSr54dB6T1aypGZM5GycABMDLVE43ctmqXWXfPHuCp	9007	12729	12729	1618230420000
17850	3NLjV6sm4ucxd8127i3djhQMvhCXTgAaS9z77wt3FBbGy29oDGak	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	1648	1284	305	6301	12463	jxrEpajhwwFoMkHG3RFv4zDaniKHfL9aoU19QsYApWAJLoJnNJC	9009	12730	12730	1618230600000
17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	1670	916	305	6301	12463	jxrDtvbcX3iDBd2FB15Nd3Dy3ywBUmy4t9VSWnQ4sEmuaSKWLPo	9010	12731	12731	1618230780000
17856	3NLtJgY9zFHhVn45w4YcCFLu1URciYqsCTz4iKsQUHrkX8HZAUfU	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1619	1275	305	6301	12463	jwtxq3D5XWy4qFXqJhfA7vEFU5BfydBnuRZv5VVvdtHXTvYmxVw	9012	12733	12733	1618231140000
17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	632	1016	305	6301	12463	jwv7zJohWjngYCgCeheHSSMQuncz2a4imvHfoaGYtaq56SkrSZu	9014	12735	12735	1618231500000
17870	3NKEHPCTdkCiTQm9EGxjBkaFaHUok9QV4vjkpQr3Qs4gupdoECN3	17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	1406	1393	305	6301	12463	jwRVXEqPyMvWYQB8ZENQD1fGsUdvFMrQ6iVMFEN5CKxDFTsAMx1	9019	12743	12743	1618232940000
17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1407	1395	305	6301	12463	jwdCsrUHWAVSaPfMh2WfJ2ycU3VyGZ2974wnrP7WdPVBGhwSdfn	9022	12746	12746	1618233480000
17882	3NKY5QqTptMoauN2Jc9yYw36bXeuSe1ahL4Vja76zGeheb8dxVbz	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1467	1130	305	6301	12463	jxdEWZCRgPzu4QbYyrD7c2sFiETpWG8qUyfbzMD7xSg52hLSqWT	9025	12751	12751	1618234380000
17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	1657	1344	306	6301	12463	jwHKZu5WqHTk6X1WUQYEc5ovbZFsvZ4G7Eiu4PE3imdySyWenyz	9027	12755	12755	1618235100000
17892	3NL5FUUHJtpGrYySQVT2wjZu9Y4PBqh5ypg5Wpobru9iGKSUK4kH	17887	3NKCkBaRaBrQT5Wo6r4MvfnyCdYCxY2NJpQRpwmSi7HzLhTPqqj8	1670	1282	306	6301	12463	jxvMUX5ZmBw2HwQCZ25HyXGh6xExDcJuMggouCtKZxiSHNxjwoA	9028	12756	12756	1618235280000
17893	3NLerus6C2cscoSQFYpwLq9Vzwm61VxiCExDPx5DpgFcVQ1ngPnL	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	1407	1395	306	6301	12463	jxePMHjvtkm1XmG5LnkGETdAkejj7ToDAN3aE2K2znYjJZkWdJ5	9029	12757	12757	1618235460000
17900	3NKhd8zpGwZcRPYGhSZyafz7Ydvs6LEzW6GxK2s21riTjwtDoUaD	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	633	1384	306	6301	12463	jxpTcuHmzVDxET2KafonhphggPUykwcZkKtgeUi66gM94x9FfRc	9031	12764	12764	1618236720000
17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	369	1066	306	6301	12463	jwG9NGw3zQFNxYfQihKhwrRx1P11hP5vKyfLV6bMenSzsLtEwL1	9032	12766	12766	1618237080000
17905	3NLCDKfa6B3uZux3r2wZ8wQv1MHeYejWdFywYLZeLQgQQi9Ar2Uh	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	470	1063	306	6301	12463	jxZmJnhg44K5vSFGK2XswsdstUAsuh4cYUUB9zE8emiqYUnu24v	9031	12766	12766	1618237080000
17792	3NKKJfpmyW3PrR2jNQtg2yC8SWa4f16aLU82ywTRsi6NKMsPQMJZ	17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	1549	1362	299	6301	12463	jwHxum5WVzbr2RfzpewBwvLFqPe5Wqeu5sbYBWoAb7ZzY5Tx8jZ	8895	12702	12702	1618225697454
17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	17797	3NLjUAUYtxjVs8mqDankxtFh2Lzj4DRESFjw7h9Ua5miHt9NXLv8	1637	816	304	6301	12463	jxfh4DhuEfmiS1YWtcuR2hYzqKEsye6jX8wJ4D88fXWEoGLAFGh	8991	12707	12707	1618226460000
17800	3NLYhkiiCKFyyY15mab6kLokGLLUV3kjQouK7WdQwW1v4dixwtYV	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1594	1326	304	6301	12463	jwERjYHZ9Uk1E7v2k1KNPc9FM8yR9f9T2ZJfBbe1kCccH2hEcox	8992	12708	12708	1618226640000
17803	3NLpcFcAXPuPg752wRkTQqmS3etNNYhfQvCERKoAtS4AQP5CenfZ	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1594	1326	304	6301	12463	jxP2S4c7nPvpq3hkrvDt3DN9RGU5g3obJLhS95Wmg6oH4iNHeow	8992	12708	12708	1618226640000
17808	3NLwcyhHYyc3MGwbL7N6etjZsEKGJUbSqNLbw1gYF4HvdbcyrPHw	17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	1555	1347	304	6301	12463	jxztWJTSKWp9ueAXZYMCJadP3v4316aKv7ZKzRJedR8VpP8qrX4	8994	12710	12710	1618227000000
17809	3NKx6a2bXxduQuYJEQsaES36A1QrLiZoKiaD7c9hnK2hYQfyQfge	17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	1407	1395	304	6301	12463	jwWedSm3ApHiRvXWCE2A4XDVHRza9g4dRUSML91aLbfPquxfDFU	8994	12713	12713	1618227540000
17812	3NKDzMWSzLGuHQtnrskPTvpUXGtteVCjerexR17WKEhGaRGQ1f4G	17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	1609	1333	304	6301	12463	jwnGCDXW5GD4EcJB3i3wnAi9sW6tdPiyboFhKp2ps1QsUix8T1R	8996	12715	12715	1618227900000
17814	3NL7uGqcRpZraaFrApKUzMViFu6GWAmQ7zVWs7t23yTSBvWfg68r	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1627	1385	304	6301	12463	jxAH1svKoem1w7RqqeX5MuBQWas2cejzujLL4YFMFibwo4SURvu	8997	12716	12716	1618228080000
17817	3NKXQRbRrCR62Nw26ySELeuwez833sH7zYvmn9js2zKQrqnLADLw	17751	3NLPZdGZrEVqJ9TxB7QSVGMJUeDL8mDtKT2hfkxUhjjfJReykvPg	1673	1242	299	6301	12463	jwsGfujodT2VQ5FoxoLg87LRiRHqPNMoMavUdx139mccpoyKmi7	8899	12716	12716	1618228080000
17819	3NKFULBwx2bbuiodVhtD7WA4iySQhYLgpcj1Zncdz8AgUMVwLSFp	17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	1506	1127	304	6301	12463	jxe7nhgJwx3mUnPGM7XdD4616YVDWWXH6RndCMxBdAj89mWBjrK	8998	12717	12717	1618228260000
17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	1589	1040	304	6301	12463	jx7VTaZENuSFbN7rWckgm7bddCbDkLCiyevgdc8t9w9St1xLMVh	9002	12722	12722	1618229160000
17829	3NKxjCjpsGRsih9fyrp7UmTzMRDTVTDSgvSzywbDzwhNgCBQmRnW	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1403	824	304	6301	12463	jwbQWnCVeaPPqF6skT5oxv8yJLQJfCM5D9H5rALbpWXSLPGKtUB	9004	12724	12724	1618229520000
17834	3NKtE7ifUyjShHjyAuboVTEMvmymRLCrDi5nAhgT8kyRroNk54Ac	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	305	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000
17839	3NLQnaJ3SaeDqPg3s1mW28cKwhQF9XUABFSWYHywqxNASaXKwnNK	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1534	1071	305	6301	12463	jw87QzQJos7c9sQXi9TTi9NkXdV9jKspZ67guoL4bLZyt5bUjKr	9007	12728	12728	1618230240000
17844	3NKpTQDdYD9cnSiiUm8beLCYtB8t7KjnsWF7KK7XN2AKFWYNPsrx	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1518	833	305	6301	12463	jwGWJauvnEQMqfrQLWYFsJcadeK2EwjV4moU1BH3YGPJdY2sBwS	9008	12729	12729	1618230420000
17848	3NLD31gC8eSfhjD96xaTQa33EJbuXdqiNtpArsA2hRfeVjRoZtdM	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	1460	541	305	6301	12463	jwCCT1Pf2bwAvCB5DLnjW5U2Toup76YAh8KdLXXGv5cG63M2wnN	9009	12730	12730	1618230600000
17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	1657	1344	305	6301	12463	jxdhAUVTWaUYEt2SHYuJL5zouZCXRsnXiGHAdVUfr4Yd3sCimaK	9011	12732	12732	1618230960000
17854	3NKxUA9DzXPjv8cwpkRnv3CgPQFBdmegwGAWKzR12W961GQVtP49	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1523	1195	305	6301	12463	jxupwUsedvixpysaMMtEYbQ9gsXEmN4EWfvjghqBsGYnzZRub7E	9012	12733	12733	1618231140000
17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	17856	3NLtJgY9zFHhVn45w4YcCFLu1URciYqsCTz4iKsQUHrkX8HZAUfU	1455	1086	305	6301	12463	jwErXGvBdvxftQ2PisWTjvtSU2ZWPo5fFnifycSfUtm8vHoGUAq	9013	12734	12734	1618231320000
17859	3NKjV866mGENL6GLQdwUpUZ7292RLnxLcgGkMrpouzUP3dQ7oiGD	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	1655	682	305	6301	12463	jxRrQsM9vgMyas5r7rUZc1wWuG77j9WmkANPyJ7EVGjfYV2RcHz	9014	12735	12735	1618231500000
17863	3NKzz3X5PwKyUGB66VDVa6stxj96Bvto3bhyVzuH4uyoo8EzaNko	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1573	1072	305	6301	12463	jwDPKgv11zYCjz3cV1wLDm7kNrPkAiqsDaKQw9gU4hNxoRPXNUi	9015	12736	12736	1618231680000
17866	3NKKjJGUrj2KQpNZXM7Y6NtWH5ygh1GcHVs11EDY9cRBS6FvB45K	17688	3NLKwR2WNymmRwwDmAM51LjEsjSQZ9FgSWjk9SrDeQmux9NR9RtF	1571	1089	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8855	12739	12739	1618232220000
17872	3NLFJPtCj1G9VnZPqrkaLcCSBWfudJkisbzHHY684582QR4YM3ah	17871	3NLXpp5w2NT8UiV6N615N7rt67tPupi3xgSRorQUwr8wDRPGsn4i	641	970	305	6301	12463	jwWmXHpcCYrwepM16njFHuqyq4QBS2NViS9AkDMuaJwwt4KRhyj	9020	12744	12744	1618233120000
17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	17872	3NLFJPtCj1G9VnZPqrkaLcCSBWfudJkisbzHHY684582QR4YM3ah	1403	824	305	6301	12463	jweQEdNR7KvBmLysL1wKUyUipjqrPRGPNpkzKXfk6XVuYVFFaEs	9021	12745	12745	1618233300000
17878	3NLwk4Jc8a4dxqKnxZCAHMSi98LLct4oFUJfrTDc89zgSC72cHSJ	17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	484	1193	305	6301	12463	jwfvWABef8TBiJoQc6wDbMw6vmeWbsUNZzKtxzKp1314CDURC8f	9023	12747	12747	1618233660000
17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	17877	3NKjUeLwKLeRgnMmgNCBFT8WDa6RPsbqzENJbkzbhcQZiV6PFGtN	1600	694	305	6301	12463	jxRii8q89MbzPhaqieZXjxwrEvbxRt1RBuW6RrnV5kUTg71G2wa	9024	12750	12750	1618234200000
17880	3NLK8QPYadN3NneLrL3J1Z6N84LGF1sa9nrm6CBUWpLTPp9CPxpo	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1467	1130	305	6301	12463	jxdEWZCRgPzu4QbYyrD7c2sFiETpWG8qUyfbzMD7xSg52hLSqWT	9025	12751	12751	1618234380000
17885	3NKsZrgkCK6AhUuNKGM3ogtfBx4FSasSgrPxmprEwog2Gq6UH8zb	17880	3NLK8QPYadN3NneLrL3J1Z6N84LGF1sa9nrm6CBUWpLTPp9CPxpo	576	1109	306	6301	12463	jx76Yh3ikzAcZt63MfjnEJSkmFhPtLUeppGpcKBWgan1eERs3eF	9026	12753	12753	1618234740000
17890	3NKzWaGGpYATZ9JzKYmKWCTCmr6hrRmUe2zyMYLpF83Xt7MH1Coi	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	1670	1282	306	6301	12463	jxZAHr8iwaTDXtBWZYXVY81JMkcj2KeVUHGUTVRXJLMN7A9Pciv	9028	12756	12756	1618235280000
17895	3NKA7ERLuRme9tJVCdRhRKEZ4EgS1RdEvFrP1tJ41X8Aw8L8HSsG	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	563	1233	306	6301	12463	jxU6SC9UDuVXLVikTDDLFsRbfy2k4hBtPTsTTjbbV75kX3YZFhP	9029	12757	12757	1618235460000
17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	1668	1124	306	6301	12463	jw9zXVjELk9JwyAb2shKRf16qnSbCtqgGPhKL2H3ZnwocHTMxQ7	9030	12762	12762	1618236360000
17903	3NLx7ExnzBiPJ1dgEhvRTV61rSPAiVP6hX6tordGBYUQvePnYShe	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	470	1063	306	6301	12463	jxQfNq13U9KcjkWjn72JFatCyV3T8quNNA5KBRKfCvKkaC2ze8T	9032	12766	12766	1618237080000
17794	3NLhwsLfpuw1xaCafr2EGdZ9tr3jdMvS5HxrE2FL6H5hbbQEqXrA	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1593	1346	304	6301	12463	jxp6V9W8T12BiszjkXejWmLGFZVYqZPanLL1kj5orStr8wNNuHV	8988	12704	12704	1618225920000
17796	3NK3quGv1mE2zsHvqs2q7oeNytLEXc6a5tejieHsRUVoTFqVLEho	17795	3NKKboktSyLqjJWmsySiNGeCtN2iwQ8YAPAVBtJAfvFiNeRBFeMP	1407	1395	304	6301	12463	jw8LrydaR5Y1dd8wXvjFJeAMPMxPU8qgmRg9DDDsQntnzKoyYQF	8989	12705	12705	1618226100000
17804	3NLChghEx93bqedUxvKtZf4AiMDnRDPB7MwcoZQihyZa5FkSEaUc	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	470	1309	304	6301	12463	jwJXJFv88ECReSSHWxXjWn2s5NNAn4Q8heLZ7W5mPM4evQhJnMC	8992	12708	12708	1618226640000
17815	3NKzjzH5wtEgGZxUiAKsmRLU5dD9t25hHrVZNzFQetJtCxY7UvuA	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1553	776	304	6301	12463	jwR1JQSyvyCZQHSmsPtPkbyQWoNenfuvR5NVaMdSEC98kM2Frpw	8997	12716	12716	1618228080000
17822	3NKDsqYwzZDWSnLJFnEvdnfc7cMQUaVosCNvbroKeUhnafAkj2Ap	17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	1407	1395	304	6301	12463	jwH1mhgHS9F4Ci519zZ1KzjNv9A2uwAb5JD3DGPYjcr7rBctNUo	9000	12719	12719	1618228620000
17825	3NK94RVekpSoWyx1PuSRj8xFVFN8Kny82ZNcUz8zccv95iYDTbKS	17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	1405	881	304	6301	12463	jwoaV5bfGt7bxJsRUMA2e8JjwVKo2VrmZrdXkKPYkaWRF22FWiR	9002	12722	12722	1618229160000
17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	1627	1259	304	6301	12463	jwkSVweZLwvZjpeudnmqyoBG7E8qrhDmuNeNvd9qGz2enpjybub	9003	12723	12723	1618229340000
17830	3NLNkkwaFjTTqHRqYRXvqcovCGCmqmwGjT4ZBmHWnHgCHNrWpZyM	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1460	1324	304	6301	12463	jxJ6YS7PVrewvLYU68LqRCsUF4cMqoJzzC5H41wG4EimMN66af4	9004	12724	12724	1618229520000
17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	305	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000
17836	3NKDwYipFgyRh3UUnYpamx6E1B3uW6nDcGwkMnVg4RYzeNLJjF2L	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1534	1071	305	6301	12463	jwtnneM9dZCFq7eY5pLAAThFEeVGun1bs9G9DBTyGgrmCwqP6hW	9007	12728	12728	1618230240000
17840	3NLSpjwViszrFwBKzZWkcuYskB9uykmnp8unwpk1ASotCzFH6wTV	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	1662	219	299	6301	12463	jxxwCdpxCWVVcUYPwuAZfW4q9HXiz59ZnkSg3szXQWxkDcGzP8h	8894	12728	12728	1618230240000
17845	3NLd8q2Ex9NMt9344enN1wF9v5jeGYYQCPHPknQF6ZiEUDhxrWuc	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1546	973	305	6301	12463	jwtGYmoSz6WojpsbQTSDk6qXKr5uCMepymsQ8sY6wLbNewJKy9v	9008	12729	12729	1618230420000
17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	311	1181	305	6301	12463	jwEYT2wttdisBEB6dqBeCrev4DrFhN5cKEUufobrSFUpyh6DxFc	9009	12730	12730	1618230600000
17855	3NKRGMTjQ2dNyhxrpm3ppsbejcb15ozwuuNvKRg1HoWtq6KZg4wu	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1523	1195	300	6301	12463	jwjRvWaSsFkLtm1a5tsaTyxggR2bdovu1MzGLTT8ocsfPpnduxU	8921	12733	12733	1618231140000
17860	3NKV63JYER8ZrJRtHwxNW2KUWfeibzorFDnPhBkgb6AN8bXa9PPc	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	484	1319	305	6301	12463	jxEA31DVMmAUSpAb9sgdTCiwdZA24WaqNbkr371o6szL3onXP8A	9014	12735	12735	1618231500000
17864	3NKcMhi3QSv9HCQk4XG1ZGB6ztYvWZpJ7xEczvD4Tsn3LsRRxPyD	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1611	1341	305	6301	12463	jwxBtCTpgTfE5efZfuXQ42vVye7Z3UbkYaLu7VBaTqw6EWzf8J4	9015	12736	12736	1618231680000
17865	3NKHHVFqrdkFbvG6uT6iVPyv4FZf8Qp3YVSqixmYCe6E5VA2SXi9	17863	3NKzz3X5PwKyUGB66VDVa6stxj96Bvto3bhyVzuH4uyoo8EzaNko	369	1066	305	6301	12463	jx7rJCt85fTqGkeEpsiQzXJKjn8xJBbFiXf9zxasRPzpi3k11vd	9016	12737	12737	1618231860000
17867	3NLY475isKT25Zb5A8LCtDrbEAYuLm7wJFor1a5hfqNkZWCrw8HC	17865	3NKHHVFqrdkFbvG6uT6iVPyv4FZf8Qp3YVSqixmYCe6E5VA2SXi9	1406	1393	305	6301	12463	jxrW7PqtWkR24rsVguRfB49KEuxgA6cbnkh9YmLtR2vhLseo15X	9017	12739	12739	1618232220000
17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	17867	3NLY475isKT25Zb5A8LCtDrbEAYuLm7wJFor1a5hfqNkZWCrw8HC	1587	991	305	6301	12463	jwEnbXd9bWn2GJHAEGBPHH8F2yEhZaFKgNFznHaVP7Td1whRzEn	9018	12742	12742	1618232760000
17869	3NLGjyBDWhYbix5qAT1vJCGRWaWii8J3A9HEPyWAJxQ4xkRP8wb3	17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	1458	1077	305	6301	12463	jxCsPWm8ES7xVkPX7nLZHVRx2qLuDWkKR6L9v7NpfzKnCY5gcuQ	9010	12743	12743	1618232940000
17874	3NKufvpqScVMyAevHtRhUcxZmFtuE8cE2nxfQGqaMag8bJtan7Rs	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1622	1356	305	6301	12463	jxcbiLWnBGHPspoPXF2Ehz2dnXPQFozHPEGN2puyzWjTrMa3VVL	9022	12746	12746	1618233480000
17881	3NKzm9T1pmRDETjSwXLsh8U1dmGV8kHYEXwycUnx3rsHDZy2bNTu	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1406	1393	305	6301	12463	jxXgzZX9SjJQ72KQ7C2fciiGfTc1YKWuSJFUZVua9zUtHCibFsz	9025	12751	12751	1618234380000
17886	3NLJpoj47Wm3aF8FFtDzxot9Y9dNjS3Hkm6yVx457YCGF1wRjXQD	17866	3NKKjJGUrj2KQpNZXM7Y6NtWH5ygh1GcHVs11EDY9cRBS6FvB45K	1571	1209	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8856	12754	12754	1618234920000
17887	3NKCkBaRaBrQT5Wo6r4MvfnyCdYCxY2NJpQRpwmSi7HzLhTPqqj8	17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	1657	1344	306	6301	12463	jwv7zeDKkEMzYb63ewTfcNjdEKk6FsQjvDe6ZPrs1YNFWaVdU1Y	9027	12755	12755	1618235100000
17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	171	1248	306	6301	12463	jwTaMe174AFNQbyeDBgL5JDNxmZd7uXFRdR7FjCaGLGd3FKsx2A	9028	12756	12756	1618235280000
17896	3NKHhP5nEwPGbmbWcsirKGiJhopFQYPRGtgs39M6KKtPd1ekMepD	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	563	1233	304	6301	12463	jxtUJScjHNq5Yu2J6Yc2eTrhsskKARJspEoUZLCM7zogVfL6Vxn	8988	12757	12757	1618235460000
17898	3NL1UCSn6iVrw8xskCVSDznpbRmdGXhqRDpFffTKg5nXjzaMXJTX	17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	1579	1023	306	6301	12463	jwGfdxp8Bc3ync4LCtbyiiuxE8F9PW95gTJtRsj7KbTN1YSQH9e	9030	12762	12762	1618236360000
17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	1406	1393	306	6301	12463	jxBkYEjrMPDA2YKiHKocu3YzafdodeghTEbf7z1YRPEfoG9WukV	9031	12764	12764	1618236720000
17904	3NK3uzew5R2qkEpdpeJvFCUJc7R5BeqBPeM2eWqsUQ8Nfuc3j4i2	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	1648	1158	306	6301	12463	jwvKmMM4SMY4MFVj3Qeg2AeKWThUwg41NBnDpRJMC4sEvuWyDbs	9032	12766	12766	1618237080000
17909	3NLiVzgCybQFAU4Bb7bYWQWnfxadUrA18EuJHjXSTbkktmTrHciQ	17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	633	1138	306	6301	12463	jxCRaUQkkfg7RJCRRVqTbXeDUwDh1fpbtQeY8cdoMsER3chwLZg	9034	12768	12768	1618237440000
17914	3NLa9GGeL51G76sx48PmmZvxLukfPhrJ2DfxBxDTHwemPqtLuxUp	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1623	830	306	6301	12463	jwXSx1kQtzgiyuVA7z6chRv7Bgot4X89aLNkpdSq3Sr5NwJ1C1D	9035	12770	12770	1618237800000
17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	17913	3NKS63sy6xEc7Ba9iDvpsvosmBTUFGsiz6bJyUdoy1NncG5QDFaE	1483	551	306	6301	12463	jwxbto7r66gct5LmxEd61HRZaDLSYSJ8JtpZcJ5b2yMxCnRcL6m	9036	12771	12771	1618237980000
17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	42	995	306	6301	12463	jwGkjM9A8fR9nzXUtSRp7R6vAGnZcwjV39sceRovrdvacWRydoz	9029	12757	12757	1618235460000
17902	3NL8nte3isdUbkCHRTmXpsLnRR844HDGUZWcwmFTXCKBvc9zFBV2	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	1581	778	306	6301	12463	jwnmdG8XjWJVnw7kBRkhttFDm1EFfqhiDst7UPdQAxqbSxtWZwT	9032	12766	12766	1618237080000
17907	3NK6P8iCCKNYAU6x51WdCx7AAN7TtZT6iHG2ufhNUMxGn2iNxHd5	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1419	814	306	6301	12463	jxcoBRUg4QUeRmgQQ2ZiDJGHd7noDQwgsKeiGT4SRHD1NjqN8Yv	9033	12767	12767	1618237260000
17912	3NKHWpaXcnsPrLVguwo612GAeFJTucr9jme1wKZvbPK7tjHnDZjw	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1649	1383	306	6301	12463	jxB4GGwGcCAzVw6GxmC2xEJRBkmK5JTU5Nudcu4JPVfh32dng3a	9035	12770	12770	1618237800000
17918	3NLhTgv42saJn5qNbUXewwhNcWL6CnsKToSYCMTH811yUA8PLQKB	17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	1503	911	306	6301	12463	jwncueTKPmNkyc1ZZFKtJCVfvi1oofVrscV8RDymr222rBfXXrF	9038	12774	12774	1618238520000
17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	152	1330	306	6301	12463	jwadZ8N4wEFS82CtJe67T81a2jJr9nwZYovq1Wd2zb5G7aprkYN	9042	12778	12778	1618239240000
17928	3NKTuUT1zNqGGxDAAznmYCSPgyumqkat7QfQGmJ8av6BtufPGTtQ	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1406	1393	307	6301	12463	jxqxRZ3KP8ATrWghzSJWCphrL5Wqg9nLEQ4iBudrazLCXmsibDE	9044	12780	12780	1618239600000
17934	3NKJmbixeoFuZ3UsuquGo9UpXQ5T7GRf6wy184vsyz1qtLzHMPy5	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1579	1389	307	6301	12463	jxgm3KzHAZasM2h7mpsgfreZjNA3axjmRECzsLEQXmAXq4t2ohH	9047	12784	12784	1618240320000
17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	632	1382	307	6301	12463	jwYbJJhmqCD9FUmETXB8fd5ApC2jFcLum9CyQCXSyJfQDTrQGmh	9048	12785	12785	1618240500000
17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	17942	3NLmqti5DD2XzLRaRf3kZd5Ls1Hy8PZNL7QoUkvn6L2X9cvj6iZf	633	1258	307	6301	12463	jwjpQCXSZ3QpH67Y9Lg6wb7yA5gJmh7gLs7xTcCWtaw3jvnBUTq	9051	12788	12788	1618241040000
17945	3NLTf5mfnZWGtwXyWFzig7WjFi97B14CHx4jk2jqouXktfxPUD1w	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1671	1365	307	6301	12463	jwwmGsVrNP3NzvKMTxuWWYE4DqzritiohgiCbMjS95VE1bQYqHr	9052	12790	12790	1618241400000
17950	3NKJC9fMsdKv5upGS6wY1cuq3TS38o6h6siDnyHS9EVrEuvq5yjZ	17949	3NLEWBKF56sD7fiMjWF27xgEJydtgRJCKY84w9DyTHF3MyTEMdkg	1657	1218	307	6301	12463	jw8fQpGs2rcLapnN9fnZFwQ16pbbhi4ApXAxmwmcrbKJr9rgsut	9054	12792	12792	1618241760000
17951	3NLsPDMhjC9eX3BiJ7HkSTNyxMfnibsayAdgFcaDkD3NGsBmYxJ4	17950	3NKJC9fMsdKv5upGS6wY1cuq3TS38o6h6siDnyHS9EVrEuvq5yjZ	1599	1041	307	6301	12463	jwqkURMEmk44XVv2acbfxUCxdormjWGrJ4HyXoNJqmo3KgHMTUT	9055	12793	12793	1618241940000
17956	3NKMoSg7Jnc5bxmE7aZt5gkx1BPtRj6yzQpTs8oV2CC28oX518LS	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1522	1196	307	6301	12463	jxmvqnjN67Fc1DjCZMT2766k44CjdppnubaNsTvCxRQXUTeCMRt	9057	12795	12795	1618242300000
17959	3NKVdqP4DnCkydZma7vLSoTkKANYG7fCAodStEufyP5TsKXkeC58	17712	3NKWtHL64a7cYuqJz7r44Bquo9YiDvtBqE77d9TouVo7w7r7rpdn	1516	1294	300	6301	12463	jx1SCxX2fvkQkjXRE3C7sL4FarM4HaM8WyToKEduGRv5utnmDGn	8913	12798	12798	1618242840000
17965	3NLiJ1ume5Zs6fEjddzzPjuWJ3NXmHe59t7s9L8uSKKYz4bUm3RD	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	1405	867	307	6301	12463	jwyH8T8h6vKdVQEVJb3kxV3hy2qiQH1sqBbr652j5t4SpmDjUdV	9062	12804	12804	1618243920000
17970	3NKZjsCqXELyz4wpao1H4QfRSEYikXBx4P9ofJX3X7Wc6nBaNR6m	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1403	786	307	6301	12463	jxyTVqPmJwXnYniUUJGCZmiYmqacg5cpzW2sf9fR2zXGBKFKqrd	9063	12805	12805	1618244100000
17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	1403	791	307	6301	12463	jwiETUZL8EcvkKtHt5tcnScvfarQdPQuKi9VzLSEEHCRp3xT26J	9064	12807	12807	1618244460000
17975	3NKeShjA24xZdWRzdyVnA1gFaoaci2FNZgpbDTBtS6h8aLTxfZgy	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1602	1123	308	6301	12463	jwuzjmSwXHhr96SQr67nyG4LTmDbb1e3VTBhtuV8CU4hcreVQNb	9065	12808	12808	1618244640000
17976	3NKJHsAegQfn6hj42xgrySmPjNgP2j6eMyS5G2zEMJZZ5Rr2Qbgs	17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	369	1312	308	6301	12463	jxSA79tcLXXAqVGbKypQemSgshdQ7yoHftMDNE5z1SMwiuCH7ez	9066	12809	12809	1618244820000
17981	3NKiuxM9Th9rMTE6T96TATzCKSc2uBV4jBsCLi4Roq2MKp54J9cq	17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	1403	31	308	6301	12463	jxTtZ4F3t9UT3PLDxbWthTuhPdxgyaVSyzMHHheTrPowFGPetZ5	9068	12812	12812	1618245360000
17982	3NKrAdMJm3Hbxy9fFyscH3zQDvPLAa4SkLSXnjx3Ds872iWL3Cpy	17981	3NKiuxM9Th9rMTE6T96TATzCKSc2uBV4jBsCLi4Roq2MKp54J9cq	1631	794	308	6301	12463	jwt1CX35gJwXNH5hvEm7sgFAAxfMBQbjqYq59728wRXuskW2po9	9069	12814	12814	1618245720000
17983	3NKFQCcVWtb7nsFpcEW4wqkTk4JRgaf6F7tU8L69tgSfFFkT8TNn	17982	3NKrAdMJm3Hbxy9fFyscH3zQDvPLAa4SkLSXnjx3Ds872iWL3Cpy	1623	839	308	6301	12463	jwT9pyuEMf2uMTKEfD4z6on7UoPvLYEdzAZrhQPJPs62BeEBSoG	9070	12816	12816	1618246080000
17984	3NLnZcpsL82o1Gt6S6LnF98mBcJQXGGG26ypK9jL58kZxMMvQJuV	17983	3NKFQCcVWtb7nsFpcEW4wqkTk4JRgaf6F7tU8L69tgSfFFkT8TNn	1406	1393	308	6301	12463	jwzcGLk8dNgToyrGgkyEfAbD3K2PJQYtRW58tZ4a7dJNqjfHW17	9071	12818	12818	1618246440000
17985	3NLgtDkofj4pVC3LHvmLEcDxJBbXWHoHEfZqotWSCPyu9HQBhpK6	17984	3NLnZcpsL82o1Gt6S6LnF98mBcJQXGGG26ypK9jL58kZxMMvQJuV	1600	410	308	6301	12463	jwTq8L9SRFKEddGVRkRSMjF9i1rRbf4NGe5MeuQLbJpFhzGfrCV	9072	12819	12819	1618246620000
17988	3NLXFgoG8g6GZwNDDLYZcVVUQ1QkPNCt1gsRZcn1ede6t8MnQjUW	17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	1651	1301	308	6301	12463	jxefm3jYKLfWBFZeC5eiBgTVq9h8g2xqskT6L2GgffvZcyWYUq7	9075	12822	12822	1618247160000
17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	1651	1301	308	6301	12463	jxRgEcaR9mMUhWXuXh4vcfPBiSEL6Lk9wJg627nqoeDcp6vRr8s	9075	12822	12822	1618247160000
17999	3NKqwniuNs3A91EsLmqfAiVPFhYBUp1AFvcSsgKNzHjL5XmckCa5	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	1607	1348	308	6301	12463	jxejGUnANd9RGYQekVKprV424q852REvc4Vkrx4SrsjPEYZWbdF	9081	12830	12830	1618248600000
18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	1403	824	308	6301	12463	jxqr2oPKfc2o69HjvSSP2vrj6q4nKYS8hCYYLcpoHYQPpc3dkbp	9081	12830	12830	1618248600000
18006	3NL78NXVXgKztLNqBKV4vmUejToAZ2uMQeAqPRJUcCLFj6miq247	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1657	1344	309	6301	12463	jwuUtnERtsi3Aoz7fTv9CoBPmUkemas1TMzrcidtWb5BEPUU8W4	9083	12832	12832	1618248960000
18009	3NLyYUVqDqcpzFVD5WQ2zxLrVJdF1qiAzMZXa4Hu9xzw9BfLtJck	18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	1553	776	309	6301	12463	jxRRc5fQZFW87qgLgjoPEd9EptzUAYQ1AAiXRAsp6NkUyw7KdZm	9084	12833	12833	1618249140000
18010	3NLBpCxXmYGsPF6AjqBqC7gRUdzJJzeicDiezSNuAzVG3S2wRetP	18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	1637	816	309	6301	12463	jwtzVo8TbFgt3ZJe2G1YXXRWG6FCLyEUrB9wPYTm3RFsq2sW9U4	9084	12834	12834	1618249320000
17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1406	1393	306	6301	12463	jxKWmgPejbfkiTE4RRSzhxqTo6jmLNgdrUQz6F8heTtw72Pvaym	9033	12767	12767	1618237260000
17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	1402	888	306	6301	12463	jxpmWKzMaeTGnhTS1uhofZZYLe9YCktrrb8eHwiJGZ5fwGQkurH	9034	12768	12768	1618237440000
17911	3NLUUqnp52bPxGK3YpNECRURvzLKRbuLzjJ3Ezf9UvTmKHuNgMyi	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1407	1395	306	6301	12463	jxDW2bh1rGELgRYQenmrBD7VdWEnKQEbjpfFAGHwuq26JLHB5iQ	9035	12770	12770	1618237800000
17917	3NKADAkxt67acMwdvhDUxZNjezi4m6xvd3ngGhhqpLs2ignLQ6a8	17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	1406	1393	306	6301	12463	jwJkhw4wQiTRbHc6jRn4tPF9zELLT7EgKw2QPVLhPWWTmXDvpHF	9038	12774	12774	1618238520000
17924	3NK3iNU5v42bwWtqW3QFy76WrJuLYGGQnykq7Jojji8BHRVj2cPE	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1594	1326	306	6301	12463	jweo9kAfDsT23EeC2Aw7u2mxUFK1tKQd4ixhF9MvwCjLy16dSET	9042	12778	12778	1618239240000
17929	3NLyZnzb9H9jJN65gzKkFAQ4jJ5NHRBBLzrvKNm11dBYLjR5BmBf	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxAK5XkRC4GtUt19GdnJ9zvcdtLYVfW4pqxqDfrvHZ7esh5uXMC	9044	12780	12780	1618239600000
17935	3NKYmXapvGKtcxtp8Us8SJ73ZUDKwQoveMPqFL2ugGFdjhcQoeTK	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1405	873	307	6301	12463	jxPhe7n2CpsivXM7WTQbVRPLmk7vovD9QRzzQWiP8JnZXpGdT54	9047	12784	12784	1618240320000
17940	3NK5d6wMdWf1N9t61u4pMQj9NbPR6vKqNpgoFNixVtSxedvDSJ49	17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	43	1310	307	6301	12463	jwM4EQKZqZU8NLL8USNgRAr5r3yjve7RcU9gL1KgcvK3NgHPJ5i	9049	12786	12786	1618240680000
17946	3NKEWRpSdtrVGopoKcV37oU8c9h447fU56vtrxPXwZWqHdrZnbkk	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1547	1378	307	6301	12463	jwarJyHJSWbfLSNpvJJ6j3sq5NJLy3tPh2f3Yq1xxDtkpPN5tHc	9052	12790	12790	1618241400000
17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	17951	3NLsPDMhjC9eX3BiJ7HkSTNyxMfnibsayAdgFcaDkD3NGsBmYxJ4	1647	1176	307	6301	12463	jwbhqN35TK6CR9mDTNZVaSAggCQ7xqKgJjy39kV4UKu9BpSF1A3	9056	12794	12794	1618242120000
17957	3NLxq2o7hVtrHv9bgayXtiGA1aQHoHzhpGEnKw9L342jhBG7vkRA	17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	1654	1340	307	6301	12463	jx8rtiw4XVoXXDJStsKfyrX9g3S4iqjCaTfnE1CvpADvXRUSCfD	9058	12796	12796	1618242480000
17960	3NLgD5A5ZF13BzKAWXtczBZRA2jSvkAMhHdkcQkdF9Ypx3MZYzZG	17957	3NLxq2o7hVtrHv9bgayXtiGA1aQHoHzhpGEnKw9L342jhBG7vkRA	621	621	307	6301	12463	jwcx5C8cjU9p76FpkeFfn3g63DJcZvmCXDU2BjFjC6EZtqbZHxn	9059	12798	12798	1618242840000
17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	171	1248	307	6301	12463	jxLCLYtHjcp9upAaK8DUwmw8xrR6ojRsrTt3eEAnRaMRgCYUQVq	9062	12804	12804	1618243920000
17967	3NLSuxeUaDafV2EhAgisbv5YDXRGomjgna8ifveEG9rRVKT3qUjP	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1503	1031	307	6301	12463	jwMnqhrGVFnTsQiBWZudZs8SJ3n5NTt8Be27EQ6ytzPVqJDR5kQ	9063	12805	12805	1618244100000
17972	3NKyKG3Ctrr1JVStC8cNyzaiQ5NzpUgYpZBi6ihNgj1QKZfQi6Dr	17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	1637	816	308	6301	12463	jxYNPoooWuTV8MzJG6DhgBnvfjKHGMz3CgGzaZuFHkEKNMvh9cB	9064	12807	12807	1618244460000
17977	3NKvHbe7uCFwx6sZvKu8xrTcwSHnSaVDVLvzzvqqKtGuq9KY589T	17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	1637	816	308	6301	12463	jxsyuPcMeLaP9bv2S3CkaDqdeLW5wmq6rAD8RXa2eFF69syQaAo	9066	12809	12809	1618244820000
17986	3NLZekAwjsuYXcYSFkwBMkwSpPBY3mR9wrX4cCwSATpwacbvuDKT	17985	3NLgtDkofj4pVC3LHvmLEcDxJBbXWHoHEfZqotWSCPyu9HQBhpK6	1555	1221	308	6301	12463	jwFuyhAtAruGuCfedHWLcXJbPsjEL5FQjCPoL82ANBA5pvwoivk	9073	12820	12820	1618246800000
17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	17986	3NLZekAwjsuYXcYSFkwBMkwSpPBY3mR9wrX4cCwSATpwacbvuDKT	1589	1286	308	6301	12463	jxNUKBMHRxf4EXdyeZmVhARPJRe2tnGc3gc2UQpctoZRMaA5zgJ	9074	12821	12821	1618246980000
17991	3NL3srEntcYQpAFq1vBFHCLj5D4y6XjaPLQrn5bzN2ykL4V7iy1s	17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	1553	776	308	6301	12463	jxhusdPn6f51bmNqJDL3q5hkFJzpCdLmaYWGtvryVsdHF8q3K2u	9076	12823	12823	1618247340000
17995	3NLyHWUNXo4nUvWu9DrfkNJZLUVPTk86HhxmccT9d3ujZGE6hcLn	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1448	1311	308	6301	12463	jwiNLScsJVPPooRKLjYCGzshMEUHj8iP1LRsFeGKnS9RP2qmPmN	9079	12828	12828	1618248240000
17997	3NKGPmr9mJoJVy43tZXSbj4YR5iqTvhrRPayk8VbDMCFR58Fq2Fb	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1448	1311	308	6301	12463	jwEDx6TpFdrzkMtG5YnTb7Uak2PCvUyaHNJzANHik3sFnRv55jy	9079	12828	12828	1618248240000
18002	3NLZabK9We4kxDBNVxMpUV9kGXvBbhzGLsREkoZyHyhJB6k3FiUE	18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	1560	1291	309	6301	12463	jxWX1yQwSRcF8rejmkT6ZKyFcKxXqWpKPSxsksXjFhBA6mY9GNX	9082	12831	12831	1618248780000
18004	3NLa8HKbArDGg4nggZJcRweagsELHRMCNFXDSb7uTHK21Tzr8Unq	18000	3NLoDCqLxN83iGis5fAv4nqkW8DVeVJikme6upTCTuexDwPFAePv	1560	1291	309	6301	12463	jxk8DYDkBQ7NX8SDALzop1d41qQw8xjaDrme2N8b4JcBLddrumT	9082	12831	12831	1618248780000
18013	3NK9ihnWdC7WRgVdAHdKQTAzVwGA2UKiHAwb2ogRdRNBwyL5RQEz	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1542	1304	309	6301	12463	jxCWt15Qg8kHDf3mHroFphJjTS8EaJR1ZAYhy46ZA57o8JgYNZG	9085	12835	12835	1618249500000
18015	3NKfvfsHcizyLVLFb3NtNF5ZSaCHHRqLk22NxvDDYzf3h2y1vK9v	18012	3NK3C6ktRr8PGypqDMF7XisJSBHhtqQDKggVEyazEoZc4bosaLbu	1590	198	309	6301	12463	jwY6gjq4cRCYfpQtJo4jfEZqnqd6WnHaJ17LBX2tH9Kpad7uNU6	9087	12836	12836	1618249680000
18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1587	1357	309	6301	12463	jwj3kS9Y5JGKBaYKg2NyXaotk7yifQKa24u8SzesxDKaiBduHit	9089	12838	12838	1618250040000
18020	3NKL1xPaRHv8xNF8vg7WxfyFBcDmVhQN3mYmA2J9zPTPijVkEbcr	18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	1406	1393	309	6301	12463	jwBufBajf6VG9hJtZhfQtYtjroWiTfk1AfyodPu7DCrpbWNytH4	9090	12839	12839	1618250220000
18025	3NLX2LKw2irQDA8P2LZiEiBqLiGVXXWZg6uVP8sxgPARRTQrrckp	18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	1407	1395	309	6301	12463	jxNpm9zy8QEZJzsT7US9D5dnhoDyAJCE5HXpAGt3648BVGRrYUU	9094	12844	12844	1618251120000
18028	3NLH5Q3KKBgaMQ7S21HBSxLFB3GMz5a5c37HCp9JYMxocAsXmLha	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1634	1085	309	6301	12463	jwVh4rjd5YpWFQNVoyj1wreuX2mBRnDgLAxUKJ9A5DyrjKpM5ai	9096	12846	12846	1618251480000
18041	3NLUWdDoL1kKYn7Rvb8L8vG59Fc33DHLrnY5RHAuvCBF51hjxv1q	18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	1405	875	309	6301	12463	jxtuAKyjTnUG2uZpWPQSKa2oTQybwogVf1eDx45noN89ztHs1Lb	9101	12852	12852	1618252560000
18043	3NKMHLfxeLLtM1kLaUNipkDEg8B3K2ry9yYkHYGTKPZGGAuboPyQ	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	80	1273	309	6301	12463	jxxcRR1m7hhconBZLQgGBZenLgeUckGG4H3CJn8cN7mEEZZ7CUE	9102	12853	12853	1618252740000
18045	3NLdddWptSCgkJ7h16h1DZWehgGqah8b1RQnzMk1CFGERAjNqXdt	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	1403	785	309	6301	12463	jwJkrSzKUCrziMPVCCf21Lxkc2CG4HZUn6F5xrbPQnVJYDN93m5	9102	12853	12853	1618252740000
17908	3NLNK8ifUXAZD3YS931NdTBhgZCNkLgooKzvwPqqPCvjHtvdnUQE	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1643	1053	306	6301	12463	jwEi9a3pyDaR7Po2R37T3mcJDwqykTSE3hucYiRUMp2NsPBoTB8	9033	12767	12767	1618237260000
17913	3NKS63sy6xEc7Ba9iDvpsvosmBTUFGsiz6bJyUdoy1NncG5QDFaE	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1445	1164	306	6301	12463	jxcieHbxyJF8q5dLJCTsD9CnfT5pQU2kc4Mn5f22Xra7aw7bkAA	9035	12770	12770	1618237800000
17921	3NKzeMSwenSPx5wiQQRfS7P9nGci8ywqUiqCRWu5NNVUgD2bghTu	17920	3NL1nG5x75u7n1HqCiSMkTt6Js5LB4f9wPC42yikc9oe7Q3RZXes	1406	1393	306	6301	12463	jwxvDgqBfZxwSQCLrZqJxLjNeaQHywb3YvM2vA6xwxGyBv8Cqhq	9040	12776	12776	1618238880000
17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	17921	3NKzeMSwenSPx5wiQQRfS7P9nGci8ywqUiqCRWu5NNVUgD2bghTu	1405	849	306	6301	12463	jxuCaMXbaH7ULF1NWX23yKS2JXFMJSHtxWKAxEjo4aZm3SR7Tyx	9041	12777	12777	1618239060000
17927	3NKHSjtrxEyFfnVSUYR2mfXxY1katvbpNAm548GhZQXYrU7oR7Jh	17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	1610	1314	306	6301	12463	jwpTV2scLxo38Wp2hszRP9fUZUwQeKZG81ERQp4PSH2SnSR7nJ6	9043	12779	12779	1618239420000
17931	3NLgeXT7QoXBDgWSTWV4xmY4SbFT8sv7U5mdvDMapqQCpMX6upNi	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxAK5XkRC4GtUt19GdnJ9zvcdtLYVfW4pqxqDfrvHZ7esh5uXMC	9044	12780	12780	1618239600000
17932	3NKDGzKNokSSuxGYZ74hnj8t5n27UiYKZP8wgkKv7VQ2DP2adhkq	17928	3NKTuUT1zNqGGxDAAznmYCSPgyumqkat7QfQGmJ8av6BtufPGTtQ	58	1035	307	6301	12463	jxKxbU4ZPQx22GZZ65zm7ecEji1soMBBtxAMMY5bY1VmsEHUYvA	9045	12782	12782	1618239960000
17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	17932	3NKDGzKNokSSuxGYZ74hnj8t5n27UiYKZP8wgkKv7VQ2DP2adhkq	1407	1395	307	6301	12463	jwux93F6Ydmjc76QT8txnnsmXLAPAsXpq2Y4so8PbiaY9JSmhqe	9046	12783	12783	1618240140000
17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1650	1249	307	6301	12463	jwA9S9G6x7ZZafAamXaBFraML1VhazF2Q5BwyqPbXgkHNoHuKER	9047	12784	12784	1618240320000
17938	3NLyFeBq5Rtoxcc8aYx8Yd7SnbeLjYnHzZQTnNznYLaYUGo6oYDL	17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	632	1382	307	6301	12463	jxc6LtKAYQwpTzBp1vQPPza5PpqotGFFGyLDeeNPBaS2kXpjwDX	9048	12785	12785	1618240500000
17943	3NLBRZqWFeBddSNVas6GyZPe2S1CPPp42JcL7hyZ4LbSmNbTysq9	17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	1650	1375	307	6301	12463	jxWGe71TeA2bENdUujVsr8S2rf3u9fakYZavpFYzAVa8D5seuo2	9050	12787	12787	1618240860000
17948	3NLBHcFDVn9NGCtB6a5bRWS4cRMrdF2pB3RcvoLyk6Terese16Dp	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1559	1353	307	6301	12463	jw8XV6cdoyFnbAVkWysPJFwwnsHfqP3LjKiCkMMPXC86ocvjrms	9052	12790	12790	1618241400000
17949	3NLEWBKF56sD7fiMjWF27xgEJydtgRJCKY84w9DyTHF3MyTEMdkg	17948	3NLBHcFDVn9NGCtB6a5bRWS4cRMrdF2pB3RcvoLyk6Terese16Dp	1646	1108	307	6301	12463	jxhuk5JWCPj5hw8Es8g966CUC5cKXhrfkDSSDGHZNnNdQUzAfx8	9053	12791	12791	1618241580000
17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1453	47	307	6301	12463	jwuEEVkiRaZgKe2xxRsgfzELmuWBQYsxJQWswbRL9L5epDK5vY1	9057	12795	12795	1618242300000
17961	3NK8nh5qX8zQkGi4KDyq5G9y7oCRTGb6uTCwVJ7fEHkYAK6BvHLv	17716	3NKMwveqMeTiWmGEog6JPUS2U9SMkgbZe3jUBqdFyAFZLLxhqX3j	621	621	302	6301	12463	jxhnv6oraXG7nLGFv4awm5JQqNeEjvnpf7beZdwxsw36T7a12rU	8954	12798	12798	1618242840000
17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	17960	3NLgD5A5ZF13BzKAWXtczBZRA2jSvkAMhHdkcQkdF9Ypx3MZYzZG	529	529	307	6301	12463	jwPTtqsEqUapZJqtV6qkbLwexhy158eHaGGT8kwjJGggsUkn8po	9060	12800	12800	1618243200000
17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	1672	1285	307	6301	12463	jw8rkQz3Y4xJcY1tcaFkNLEq8EY7aCFFwkaQBzis2cXQB7ZjgzX	9061	12801	12801	1618243380000
17964	3NL4F73esWZ3mzfe1Mg4wyyxZkSh7AHDTakEiRiT7avPftuqtyuP	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	44	1325	307	6301	12463	jx91wmeSdyFctwKfB93oxVP4rw5pBexnpFUSFMBoFo3PBh7CgNp	9062	12804	12804	1618243920000
17969	3NK6zhqXS67HVFKThRXWhT7vDQnmjKzSJrJLkFPbd58WVwzuCo9D	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1578	1296	307	6301	12463	jw8LEaYatzsk3a9VApQgMu7SzhkKKX7CyLFoCjtrjQdhziN69oQ	9063	12805	12805	1618244100000
17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1578	930	308	6301	12463	jxQ7LYWP4BHYDNortuDu4fU1ZTnxX2zMmTPrYxVpvLvEuT5AVKw	9065	12808	12808	1618244640000
17979	3NKYTouzhAPgJiuH2a9znBJgJCHctEUb36xZbjpzgyJtuyK5nzP4	17976	3NKJHsAegQfn6hj42xgrySmPjNgP2j6eMyS5G2zEMJZZ5Rr2Qbgs	1643	1053	308	6301	12463	jwU5J28cqhnuWWT5QP28ngnzKso1WqCzSbenUkyCabxF4bBNX3B	9067	12810	12810	1618245000000
17980	3NKCZBJ1QcKAo4ir1zTn6cDupKnwbcE6ZSBLTCZndhdP5d958R7K	17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	1553	776	308	6301	12463	jwj5hBk9pqu2cfPH8LDKNS7nFLYgQFzCb8SBPDCavKvjgWf6Exm	9068	12812	12812	1618245360000
17990	3NLipawzee8D6tfSCthdbt47Bi5XbXf16Th4xQDL3YvWhVvV3RE2	17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	1407	1395	308	6301	12463	jwRpYrrTuPHRwBeL1ZmiXXWC6g52PmLHAtZJKghqRXpFeRYCVyj	9076	12823	12823	1618247340000
17992	3NLT4noh7peEuXqKvW113zYv8SYHnAC5MinGQRYC9m3F9xYqiebM	17991	3NL3srEntcYQpAFq1vBFHCLj5D4y6XjaPLQrn5bzN2ykL4V7iy1s	1406	1393	308	6301	12463	jwar3UY5HqfcpZeepePnKZWB3yAsrBgPEZxNRgn8hdgUFwbK3sL	9077	12826	12826	1618247880000
17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	17992	3NLT4noh7peEuXqKvW113zYv8SYHnAC5MinGQRYC9m3F9xYqiebM	1444	1381	308	6301	12463	jxzayh3ppEbsUwETzUeFS3mAWWkMjBnTAeBg6o7Uf61wAW6oALv	9078	12827	12827	1618248060000
17994	3NL6bhs7ReWgGJnLjvKdG4YgFERB2hLwE7gpwZgg6SNjteivA76p	17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	1444	1381	307	6301	12463	jxarvg6qLtJgZkAmgaowsQhJ1EwgQoDpR6N5QQKoHLmCAE9camv	9061	12827	12827	1618248060000
17996	3NKyHCj5NUwERFcJZPUidsqho7upyu38Y25EoephaFckZm7gCNLn	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1623	839	308	6301	12463	jwwoosKeDjgJZjKTJdCQUNFDNfMRWtRbfEV1Wi3vWxyZkwRSju9	9079	12828	12828	1618248240000
18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	1403	824	308	6301	12463	jww4FUzz7wfWkNKmsTph7zV7NVqGitDLFhw3G4JySPAr7Y1smS4	9082	12831	12831	1618248780000
18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1657	1344	309	6301	12463	jwJX35x9zofaoh5FDGKfwokhrhPUMfwLXrNB7gWWDefYjMRZACp	9083	12832	12832	1618248960000
18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	1675	1342	309	6301	12463	jxBQAknLDvBDYTwWqusLNGocpYzxQgHr5ypcTbPXn7YwfewUTRc	9084	12833	12833	1618249140000
18012	3NK3C6ktRr8PGypqDMF7XisJSBHhtqQDKggVEyazEoZc4bosaLbu	18011	3NLPW8NWAJMM7TNn2dAe6dCE2xCsBx9AkoTAENvXMj8yyrJfioXH	1542	1304	309	6301	12463	jx9fiYEsRzYYcmp9b2qGnbpcgCND1dLUt8aqSmB5wVzKr3k4fSS	9086	12835	12835	1618249500000
18021	3NKzRHwVPai1ou466JdyEVnPHLBzmn2dbfDB3ebrSdDbcpCxwCxb	18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	1637	816	309	6301	12463	jwo9QoZUDVpUSk6Kc1yUgrvg8xcoeg9gnbe7NxsVyRTd37eW1VR	9090	12839	12839	1618250220000
17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	1590	934	306	6301	12463	jxyY7fz8cuinGiSaSsv8cZmyTcBHC7HEAnxA76edGQyQQ2kj68K	9037	12773	12773	1618238340000
17919	3NLQXfygomK4sUoZgcsJmj2fuFS58k29kfrQSUXfECujj5NN5h1g	17592	3NKPnq2FXcrviTkpPCkxF1BtH8PLarUJLGgFQrA2yov72wZtUrQe	1513	1133	292	6301	12463	jw8WQMvfxtLjD4kTpVT8gBeENoXM38sWHkcGksCvU86SfruEoSY	8766	12774	12774	1618238520000
17920	3NL1nG5x75u7n1HqCiSMkTt6Js5LB4f9wPC42yikc9oe7Q3RZXes	17918	3NLhTgv42saJn5qNbUXewwhNcWL6CnsKToSYCMTH811yUA8PLQKB	1506	1247	306	6301	12463	jxoxHrZEDDeLUx1KebDEiYN2kaP4e3zfhcJxJRyWJyv7sBYFyVu	9039	12775	12775	1618238700000
17925	3NKW9zS46PZW76PyRniA75GKJqJGZ3NQn7gNXAySFs69tBWMhJzm	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1483	245	306	6301	12463	jxpF6aqTGKpLKbmL6TZDUJTG1M7L4J3Zc834eP5LyKcu5tZ1gQt	9042	12778	12778	1618239240000
17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	1407	1395	306	6301	12463	jwh4ET2rnreb95jqeA3kD4isiHPAhuCK7NCUfydwAwvzv6U7GHV	9043	12779	12779	1618239420000
17930	3NKtVhkYD3GbnhPExkjDQKWJPvEBAcceaExiygmmFu31W5eFHKpL	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxLUCzuLFtPYT1sDxayVoaBVqkwmhAiuHxQYapzayiLLQfpU7vR	9044	12780	12780	1618239600000
17936	3NLw1NRcarUHeHUnd6MgSVx6h8RRHNukruRnQ39L5Ze9nfKhFrnX	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1579	1389	307	6301	12463	jxnShpx3uY9ZuUadfFMgUAZPevH5GKJRfCPKCwy4DpSJYmEQVke	9047	12784	12784	1618240320000
17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	43	1310	307	6301	12463	jwgfYmhdmdL7jsWP66krkkPjAgcbAnWGnoV1VCrqaf9bBS8Q2QL	9049	12786	12786	1618240680000
17942	3NLmqti5DD2XzLRaRf3kZd5Ls1Hy8PZNL7QoUkvn6L2X9cvj6iZf	17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	44	1325	307	6301	12463	jx4urKP85wHTn8imoSj7LBpMcsZHajonn8qEkfmzwHXkDZo7f6q	9050	12787	12787	1618240860000
17947	3NLx8RfbHJFqYqGWtJ7r2jT9jjMp49aQhDjY8CNKM5unLh5PCWBY	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1672	1285	307	6301	12463	jxgkwLfYvqvoCAUvv5Tsp8KnxZHfVzNJr9TSCeFKkKWuJbmvytt	9052	12790	12790	1618241400000
17953	3NKhphhYP2KJic5ySbKiaLNmaiyRPrSimCiEnJaJDbVSbHibw9DU	17808	3NLwcyhHYyc3MGwbL7N6etjZsEKGJUbSqNLbw1gYF4HvdbcyrPHw	1647	1176	304	6301	12463	jxapM9D4BAWrbVu8DZjS8hkiegLiFcgXRzgQcaXEHqCdduE7Wrv	8995	12794	12794	1618242120000
17954	3NKbCKZfmCXZiaXJamZsNog6ZMxMnMdoJDBWwBMeJoq7brfEM1zX	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1668	1370	307	6301	12463	jxmDVgetRnNnAboYZ9FrWZK6Lwf4vPCxoXrnMGCpjd9UPDXUxos	9057	12795	12795	1618242300000
17958	3NKyU9eFVXSUSU8jYDyembGSkJZET72vExvY4wfVfA8ByWRxqFKL	17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	1553	776	307	6301	12463	jxq8XDGbi1QU8yELNGUeLttDfX8TBc4fUX38zpaCrqL2QFVaC1T	9058	12796	12796	1618242480000
17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1406	1393	307	6301	12463	jwdtiRUeT4i7ALA71XmKarMeVvFGpQ7FmYVfZqyxkumdr5sGVFc	9063	12805	12805	1618244100000
17973	3NKqKtx9pacF6wyUqqYNoL6T4ucTAXTuaR8m5VbH278KKFQdBfK5	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1602	1123	308	6301	12463	jwAfRyUEGH4ipg3nS94BEJCYTYLcqzXkig1bGxXCRtgiPaRETW2	9065	12808	12808	1618244640000
17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	17977	3NKvHbe7uCFwx6sZvKu8xrTcwSHnSaVDVLvzzvqqKtGuq9KY589T	1599	1287	308	6301	12463	jwwveCpyV7AQ1KDNnokUumRuUCFzVJF952eziw2fGAjYcUF2A6w	9067	12810	12810	1618245000000
17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	17997	3NKGPmr9mJoJVy43tZXSbj4YR5iqTvhrRPayk8VbDMCFR58Fq2Fb	1407	1395	308	6301	12463	jwoYRgDdMRqL3fFRiQds9faiL5Disoo85wsC4dPWwUVPzEFVTiE	9080	12829	12829	1618248420000
18000	3NLoDCqLxN83iGis5fAv4nqkW8DVeVJikme6upTCTuexDwPFAePv	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	684	1226	308	6301	12463	jxY4xQp821n3wW9uiGupVwcDwTv6JwZ1Tb3wWS5PHuZvWfL6wnx	9081	12830	12830	1618248600000
18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1675	1342	309	6301	12463	jwgoQk5y9GkxYm7Ze7bxPqGJH8p5ZEM6dWNWHc8am5AzKWyKpVU	9083	12833	12833	1618249140000
18011	3NLPW8NWAJMM7TNn2dAe6dCE2xCsBx9AkoTAENvXMj8yyrJfioXH	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1637	816	309	6301	12463	jwW3S3SMwBazeBQsBrAP2Z2q1HUzugYK1HgW7Pe5j84o3NP1AHf	9085	12834	12834	1618249373224
18014	3NLG4AJ8rZ3BAutygh47n5gmk7jVfmeTVgsgnQQc96YUX6Pff68D	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1403	824	309	6301	12463	jwsCxiJvqLsYRE6F5HTPtCV5XJLw5Hu1qWWPjW4fuczUybrET7u	9085	12835	12835	1618249500000
18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	18015	3NKfvfsHcizyLVLFb3NtNF5ZSaCHHRqLk22NxvDDYzf3h2y1vK9v	1607	1102	309	6301	12463	jxkBhZZYYACBRueSjbQqzLg7m1P4pygzncXuPBia1Q4zQCtwNds	9088	12837	12837	1618249860000
18019	3NLauCJjxgpHDAgnfokJsbi9rq28ciDaH9cWk5zCwbMCBLVgjUoU	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1587	1357	309	6301	12463	jwpyLmdf3jpTCee4WQ9sc8YvTFndj22hvGLkXCz8cmg54ah7L7c	9089	12838	12838	1618250040000
18023	3NKJP4pe8MiB7QksEHUzM6WV7WACLBkdA1QsqvHpWX11Jc14b9BQ	18022	3NLU3Dus4CZTotRN5Q9uJRYLiUkyeP9QXStNVERZfy8dM9sCvgsV	1406	1393	309	6301	12463	jxBcsHJ59UeYgJ7BJkYELNy6yzgGRpQcBKy3Ao4UsbFr9KWsPRF	9092	12842	12842	1618250760000
18029	3NLZXxBcwzNXCUftQo42JGvhvvxEqUWBNFt5WbLUrmR143RNxEB9	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1599	1041	309	6301	12463	jxAodB3r7E5mDYnZE5b7ZHwFKjFT2N2xfxFkLk4EGPXx4jYLEsm	9096	12846	12846	1618251480000
18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	18028	3NLH5Q3KKBgaMQ7S21HBSxLFB3GMz5a5c37HCp9JYMxocAsXmLha	1637	816	309	6301	12463	jxxkkZvcBfzw7BjXUgCPnj7tfVR7o7oCoqQ4T4grRJXmTeqKkfh	9097	12847	12847	1618251660000
18033	3NKkcoTvXcFUVeyjg8afNUpPHGSHtSBh3ZFi4mFxavmNBeZhvneX	18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	369	369	309	6301	12463	jw8jKSwXf7XFhWuALd2hpcSoQUBvK3TxcniKutDTSNHeH1BmQmr	9098	12849	12849	1618252020000
18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	1407	1395	309	6301	12463	jwfQBMM5PK81Dzca2BXm5vNPSufQ9tiiuAxb2E3tFsSWvSFjb5U	9100	12851	12851	1618252380000
18039	3NKDYV1VT36ZM9qdntKxQ5qB3UpFZY2XTQs9Kgg5RvygvvPKtcF5	18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	1627	1385	309	6301	12463	jxWombKudt37RVmspScznefcwDFCzMNYfeCVxMCMT4M6YzUYupe	9100	12851	12851	1618252380000
18044	3NKdkNAyvU2mi8LZMrHtiUfGg9PqhSe9yy32WnqWDZFCgLW4xoZs	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	1534	1317	309	6301	12463	jx2DXLvsrEmEZ4CM4Bgr6EG9hX4vYyaTmexTdW7hYFJ49RK2khq	9102	12853	12853	1618252740000
18048	3NKHCrhrDBinAUQDjdXTav6ydnMuwytTVun36vCLudsHUN4gvzuj	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1419	814	309	6301	12463	jxbvpJjujUecSNHkYBBwEfFBKrBMQPaQD85asAkx3taKES6ZUxu	9104	12855	12855	1618253100000
18050	3NLHuJa7qtHnxKWknJtuwkVqrafAGrhRHjhdt1z8jPgkZgdHCmD4	18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	484	1319	309	6301	12463	jwzVzQG12NE6pxfdWqXEsCp15HX1W2RPgfMN3BakeTEbAJUmy5P	9105	12856	12856	1618253280000
18017	3NKKwDWjdNtMZT14AJMH9G5vwFtxSGbb4LU2KhAwPZyBngDhuPeo	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1451	1292	309	6301	12463	jxHkrMHzL3F3foxboy4oC36RGQtQ9ifQ7y3Rn94jnUdkWhSBAcB	9089	12838	12838	1618250040000
18022	3NLU3Dus4CZTotRN5Q9uJRYLiUkyeP9QXStNVERZfy8dM9sCvgsV	18021	3NKzRHwVPai1ou466JdyEVnPHLBzmn2dbfDB3ebrSdDbcpCxwCxb	1600	1246	309	6301	12463	jxbbfnEuFZLk9XvwfXECrfmxDDFf5ucswmnVPQUUvr7495o4HfM	9091	12841	12841	1618250580000
18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	18026	3NKznHZmohvJ7LkHLbNdTg6UwU2V7vA5Ty7KghiHsf9qqs3UHizY	1503	1277	309	6301	12463	jxLXvYtZUPVLZKPiGpsK1yXuHBxAN6PVaWdqkVkMCukd3RsRUhr	9095	12845	12845	1618251300000
18031	3NKRPJh4uXDVQvcAcLYfc5m4QChTWnLYnde3DsSrXnZgbHYRjiVS	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1637	816	309	6301	12463	jw7nuzvpt5oh52sj2gQKKKyy21uMMj5xXD1GmXRrFsPXyQ1dSM4	9096	12846	12846	1618251480000
18034	3NKszcAFgJPx6bEpiw8twoaAiYBVmEdev8UrLyqCqPRPXx8cHJqP	17927	3NKHSjtrxEyFfnVSUYR2mfXxY1katvbpNAm548GhZQXYrU7oR7Jh	563	1359	306	6301	12463	jwcbt6g6DYAg7SXwvMZydjHGo5FnB3s1aYJxKWCYnfwU7BudLy8	9044	12849	12849	1618252020000
18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	563	1359	309	6301	12463	jxFYGUex67kXwgGL4KVk515qVfGBVbPxVpQWYx9N5KsYmBNK6qt	9098	12849	12849	1618252020000
18036	3NLAZM8rSpi2wHScM2CyXUsoFUagmjm4AiWgkpeudgxFXsqyb9kx	18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	1402	882	309	6301	12463	jxaYriGZoCueZ9v9EUARND1rJY9QQa2jiLuYJVqWYkRSAcBboy1	9099	12850	12850	1618252200000
18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	1407	1395	309	6301	12463	jwRCjEooBL5xuyyq9ejYttmfUqsfHgwzSocDivNgeH1pAJQEDSL	9099	12850	12850	1618252200000
18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1407	1395	309	6301	12463	jw7zgzhrxmDGkR9jo7HAzgwRpZSc4wmKYgPfuTUpkdU3jSHNbT8	9104	12855	12855	1618253100000
18049	3NLckD3uMFncXAifJ2ymK8CrshSuz84t3Xj6ZYGqvLGjHqZRVhXP	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1637	816	309	6301	12463	jxYawEBUFcQmMPu4eGheMjWpvagBTYYLB5QmqCp61S8LfftLEYW	9104	12855	12855	1618253100000
18051	3NKracEcBoLgnrvP3dArY3nWANTzjFAMFGYmqdG8hr3hd9E9sPEy	18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	1648	1284	309	6301	12463	jx2hYwiNzG4Xh9BtmEB1zWWswivzFsrm7fVTTopGZxvPbEuYzGz	9105	12856	12856	1618253280000
18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	44	1079	310	6301	12463	jwpnW6y31fsiSvLZDiafqHXyQ4i8raTtS11rkxSxmCVS1dGpPwf	9107	12859	12859	1618253820000
18057	3NKokdCh22kNz6NScou2wrj2oUjFyRr4D6eDM1zbQn9zge3uLrPK	17959	3NKVdqP4DnCkydZma7vLSoTkKANYG7fCAodStEufyP5TsKXkeC58	1516	928	300	6301	12463	jxmFHfHaXnMiaXhJwpufqgTiTkWN6WMTJuZZp4YHcdt3BP3xLTy	8914	12861	12861	1618254180000
18060	3NLAVuV6dUyBLgaSQxiuLdLMf7bGGHHsyxcxAS4ymVkA1NL9Qag1	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1654	1340	310	6301	12463	jxEjBZV5v6tbhAJctXxEggeXT8tLSAJBryWNPUmxn2hrRjzjgxD	9109	12863	12863	1618254540000
18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1405	873	310	6301	12463	jwxS5271ibMPRFifCdgRXV7o2kR67FRVV2erZPWmtEkRZEJEHGL	9109	12863	12863	1618254540000
18064	3NKiveAsnouiwTaXjuRj3SyJt5VQqk4j2QXY73atTVHv4mTTDv3v	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	1477	1350	310	6301	12463	jwf6qhZcEYcvB2GSeZ1BmTkSX889Az1cBePxDnnTGDMMhoXYiBu	9110	12864	12864	1618254720000
18069	3NL5amxM9XXH6TagkUY2vLyff7EaAyfxphz13kTkEvt1y2Ro6jBL	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1672	1285	310	6301	12463	jx8XiqzFznJkZnm8F5FRTq9pxRAkvLJpn9FkGJuBupVYnnvGEne	9113	12867	12867	1618255260000
18071	3NLRpk5FZHHboTpH9fqUkBqhdmTGUGemRsntwZadWGbVt5kZ4Kwi	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1513	1133	310	6301	12463	jw7p34VYD8pdVc3ixKAUNaNDGnusLtseN8DiGtdCvACGDzndMwN	9113	12867	12867	1618255260000
18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	1646	1354	310	6301	12463	jwsJKZHdqrttsq2JUn8MJoP6UqUvtDfJVHb5mNLimKWrZvBj9CU	9117	12875	12875	1618256700000
18079	3NKDv4uYdwoeSBiDwRRXBrS3jLnBikxpfsqUSUV5z47wqx82ztBL	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	633	1138	310	6301	12463	jxXtf7sjbQUbpFfLFwjQXzVsjhGKtdMNQxs68jntLjJuyQD78Bp	9118	12876	12876	1618256880000
18081	3NKKmBEuDzWn5zPJJw6KhAUqsXxvm7sZXmqMTWfERxCubJrfRby2	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1594	1326	310	6301	12463	jxsBmi8UoecHNbSt1cQo6FLLQeJLXrx7hurYJdoEY7DSk7fpBY7	9118	12876	12876	1618256880000
18083	3NK6qFZvbwS7kuUt9guCwDdQ4WZRLNdQFsP4FsyZeJ74k8SbaQdb	17886	3NLJpoj47Wm3aF8FFtDzxot9Y9dNjS3Hkm6yVx457YCGF1wRjXQD	1571	969	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8857	12878	12878	1618257240000
18085	3NLajmpMCtHX1P9UzYAT3ZEj3uMWj1rFww68wDeaLvQ8FDA2Jg8v	18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	1547	683	309	6301	12463	jxiyWSeSHEz3XSSM3ExfdMw7jhUp7ZXbuL9oKCWxAN8w5eyhM1u	9084	12880	12880	1618257600000
18087	3NKkskyPTqwGsSnAM5k5PusHV2HdFzHcpashEdG2Xm5Z5KxarkPC	18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	1647	1176	310	6301	12463	jxqSS38Lxsyti6M3UHaByrkhu8FNB6jAPBN4neY5ksTisTpxzX6	9121	12881	12881	1618257780000
18104	3NKEAMccckxpx8qQE2jStRkNFSZSk3Ga7W4NVkvLxTLeoNRV3Jqg	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000
18106	3NKyiTjMuWKidgUcjsYjsy464TQg2BQpXoBRcH79VfYCCWcuMhbC	18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	1587	1357	311	6301	12463	jxKLTi2V7id3xXGb9pWNVkHYLGRq3jAmP6tUUvACiADxvCQ3k7D	9133	12894	12894	1618260120000
18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	448	1305	311	6301	12463	jxTqxmxDXyH3bj3TydGAHHBQbNFNtjckHgV4Poq68DQTRKXhmxd	9136	12897	12897	1618260660000
18115	3NKRVevNiUKRUwFknECdjpaeBz7VKk56QSe6RbXUBejKCSVko6hA	18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	1474	963	310	6301	12463	jxe133DetaYiFeqx8FYX9qLov8pkZ2JgsW9wEdw3roWWAANAwX3	9122	12897	12897	1618260660000
18118	3NL2csrWeerUKWDT5FjKKfokLY4nxQLYyWHAVieJP6XDyf89Pafm	18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	1402	892	311	6301	12463	jx7Fxm4uppsKmrc1hxYD7AKG751Wirfp3sdw4SxiML4NfRpkfgS	9137	12902	12902	1618261560000
18123	3NKMUPkJkjH4KvJ4ri4goanHUAowTtT3qWG388Uu6v3UeHjr5Lki	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1602	1369	310	6301	12463	jxhzA7WDEVZY5FdfaMFaxc4grUSZ3wYbBR9azHuJdRN6J2Jt9m6	9132	12905	12905	1618262100000
18133	3NLHxzDjHjKEGoUszdSiuUReNZuf7qXtRhMDk66q1Rbh448tkg8D	18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	1553	776	311	6301	12463	jxGmixxwqXAfp6g7KEo4TWjRPJBU4uQha6dLAqfCpHh5wgb76Aa	9144	12914	12914	1618263720000
18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	18139	3NK2zYy1iECqEhFJj6G6LK8cEZbtZeAzT7eTP3KVbLjkvJs6h34Y	1613	1349	311	6301	12463	jwYsfMQi2RH3spkxRDhdnnqWdvyUygGjhaxDoWfnEc8PhfiXXtP	9147	12919	12919	1618264620000
18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	18023	3NKJP4pe8MiB7QksEHUzM6WV7WACLBkdA1QsqvHpWX11Jc14b9BQ	1578	1170	309	6301	12463	jwaYbC1Fk3nSjmPtScxteF56WR1LML65JTzza3V7Crp4kGDAyp8	9093	12843	12843	1618250940000
18026	3NKznHZmohvJ7LkHLbNdTg6UwU2V7vA5Ty7KghiHsf9qqs3UHizY	18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	149	1157	309	6301	12463	jwFjdXTek132W5dCCJio64TRenPeb3uKCRiGf7zhXmEBw5P2MCg	9094	12844	12844	1618251120000
18030	3NKcVvoZZiGvFG637rGksQMpAWxq2SRTaAdzLBcjDNyS9kqoCW4Q	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1419	814	309	6301	12463	jws7dJcQ3YshpweYxNBNAZV7mEE3dtksMxT15eYmVeMce8r5u9G	9096	12846	12846	1618251480000
18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	1588	1026	309	6301	12463	jx2Y2QUoprFRZgjsT5Kui6Vu8aMD6GcKwk7hiqTY9do4LmvQe3n	9101	12852	12852	1618252560000
18042	3NLZ1F3F11iYbm18D8CiFa3pXrxYBud32s3t9M97xrQrXw58uGLj	17819	3NKFULBwx2bbuiodVhtD7WA4iySQhYLgpcj1Zncdz8AgUMVwLSFp	1481	790	304	6301	12463	jxesLtHsA4aem6MhXnXKubGGYCrnaBrV4oJ8FCJQ9pkRWHTKocB	8999	12852	12852	1618252560000
18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	18043	3NKMHLfxeLLtM1kLaUNipkDEg8B3K2ry9yYkHYGTKPZGGAuboPyQ	1406	1393	309	6301	12463	jx66ghfyzzKH2195hKA2DxxL9SZtUeY5sFRdkmkafwbiFB5aC8t	9103	12854	12854	1618252920000
18056	3NLGMUYDBNRCy2tPKegyQXoHbaj3xPNAdW7Y1zhcJ25h7efMj9Ks	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	44	1079	310	6301	12463	jwpnW6y31fsiSvLZDiafqHXyQ4i8raTtS11rkxSxmCVS1dGpPwf	9107	12859	12859	1618253820000
18058	3NLSHLM91h5SSS7QGqEqceRbcNA98sjxWqnswyU4DS77V5j3XLSM	18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	1476	1371	310	6301	12463	jxdt6kod1juGUQMwSe9ys2UDVwpr7gzV6KpHzJPsF1KK7chC3Pq	9108	12861	12861	1618254180000
18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	1461	1271	310	6301	12463	jxZTEZXx4xDvMmw7C1PASUeWZk11Gx1E8t6qcjFpWb1mRb4pFrE	9108	12861	12861	1618254180000
18066	3NKnydX6PyQAby6PjsUAnfTaePZoSumcEGaFt3hiidgjYYbVcQXe	18065	3NKBNBrrgMQr4vE2ceYdrWp9f47SadUCPS3NU3BgaJCetx98xCF1	1405	873	310	6301	12463	jwRfhsb2eLEwSTasG23C215P1NS1FB9Ke5BWPz1i1ejL7WRc9jV	9111	12865	12865	1618254900000
18073	3NKXAoWS4PcnWKnXuh1kJMSVnf6yfZE8YD4CXxSHH1kGi63d3iKg	18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	1670	1282	310	6301	12463	jwCMEcCKs3AUHFGKkbCkBoBpbUaczURRuNvbcqEgWHf4VcJqnha	9114	12869	12869	1618255620000
18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	18075	3NLrsGAhKJmDtCouFsjnU5SpFSyPpoxZvtnzYP87qnSJDuHJksNd	1623	839	310	6301	12463	jwNABvXkx8rFBapnvaY9EyuZ2AaSQ2Aymv8x6PyYN36FhiGu2Dd	9116	12874	12874	1618256520000
18086	3NKtVSvNF4ztdvTSsEM6kzYKV2269XBhGvVpBLHUmaaD9DYqW7oC	18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	1534	1317	310	6301	12463	jx88PXd2TVq9tvj2pExnYEUGJxFfZ5nQft1zz3MXdiXR2uh6MAj	9120	12880	12880	1618257600000
18089	3NKKdKfHUhYhAANYYywD2TmEZArav66ncGW1uhFS2fgZRnckZd46	17953	3NKhphhYP2KJic5ySbKiaLNmaiyRPrSimCiEnJaJDbVSbHibw9DU	1647	1176	305	6301	12463	jxcKTpb5QkjoQgHgr4DZCYkFCbVAhyfkM21VMzoPxm9SPjHvZ7T	8996	12881	12881	1618257780000
18091	3NKMi19PH5TzoeGM2VjtPdot3KYgDJhNYfNkpwh59vzm1gXJM8gv	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1675	1342	310	6301	12463	jxHQQem2Rpbaiqi6NqgzWvmaqmbNrTvWkQYiaHAjW4sDzFPrCwa	9123	12883	12883	1618258140000
18093	3NKeWG1ZcK5uV5W5e3jW7tvFUUEjCuduLhnRuQNAgpPh8rAoDeUR	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1581	778	310	6301	12463	jwLAmqWZr7943isBGKqBmyxB4ZMZZ7ferjpxKHZmfWEbQ9wU8yW	9123	12883	12883	1618258140000
18096	3NKFW8NgHRBaRwzeW2wiMm6f8N9G4zNX4sBewxCLxGhguoPpJiuN	18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	1455	1086	310	6301	12463	jwoZxdQmNpSZNrt7U49Pnc1uBYAfEmG3TzuMDTqggo3C2KHkeEb	9125	12885	12885	1618258500000
18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	18097	3NLbANV9YKUksS7ZS7eG6XAsxgVceTPVL7PQwWaQcLjVDkAaudQd	1637	816	310	6301	12463	jxyQXYRuvBhvydwYhvouowMqHo2wsuryYtXRwrEAGiUveoZFg9i	9127	12887	12887	1618258860000
18101	3NKzqHAk5efShaiRzkJ1HF5orztURkyZHtnQ55aubdaxkG65Rvbo	18100	3NKFgKWVjnzShXtoC5qNmA62RBf1Qsu9ChKW6uSxj42CL1thkH4c	1553	776	310	6301	12463	jwqEY35jwg12SehBcuS7oEPidZv8EAjDYv1k2hrSz2a2YqkGrd6	9130	12891	12891	1618259580000
18108	3NL8oAcRFJuX5EdZ8nm3xW9gfLAVouBz1xSW6RjLHh5gTgxn7our	18107	3NKMu5aduv5Vx2QFbJAHdJJj2Zb5MRwzHt6LUv4TUT4V71hK2DDf	1560	1045	311	6301	12463	jwKuBrSyfnask5Di8S9VHiTg1Cw8idE3TPsPBgyoUBkxJpabzQ6	9134	12895	12895	1618260300000
18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	18108	3NL8oAcRFJuX5EdZ8nm3xW9gfLAVouBz1xSW6RjLHh5gTgxn7our	1553	776	311	6301	12463	jwiX3bLVHQfiuDh2aF9CM5djYpwxnhRMqgD8unfxA9v9PQaxw5q	9135	12896	12896	1618260480000
18113	3NLqWX1JCQuLERVxDqJesMCWBFF2BHRALjXyJYE6qBWPEbBQS2pR	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1407	1395	311	6301	12463	jxi8uEyXkAvphVFgx85RGYYK2a72ahMJeUSYVo1u2CNyTdfZgKv	9136	12897	12897	1618260660000
18120	3NLsMo5GaaYgQXtozTqmbM7wY3RqzAPjfGr4F6Kqr4WDuecGizQD	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	596	1060	311	6301	12463	jwPVnSV1sSCZW1SN8FaVN15Qk3a7uWm8XPHcA1GtPRhzyoHf7jf	9138	12903	12903	1618261740000
18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	1407	1395	311	6301	12463	jy2LAAxkuqdQY3Yrw2LZ5HpdqKNwfKV7C5cT3U2wDkCspMuVpg9	9140	12907	12907	1618262460000
18128	3NKFGqoWoRTLeNybK6KDUiSxuUbT1qwuRdk3RTR4cHcxy5PwTrNU	18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	43	1310	311	6301	12463	jxvXXgkd9R9ebUR5U47G9PjUgg38KssmgL2FvYNj4zZbREaJ3p5	9141	12910	12910	1618263000000
18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	596	940	311	6301	12463	jwJ6nHG3gs5jr9cBPywbGyzNkhC6uGcZSmoHSbnCSss7XmdhZYT	9143	12913	12913	1618263540000
18145	3NLcfnbomDrxb5zv5tB97SMmEFFCE1F3d6JiEZfAGC7KjdqCcKWG	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	1448	1065	311	6301	12463	jxAQ75Ki6w71YcNmGQ1FK57TLKkGQcWXJpYYFvq8H3inosBrhnw	9150	12923	12923	1618265340000
18147	3NLMW8eZxBM4tY6H4bw9sP5SJcqz9n4CaFYvN7PwYf1EDGdEk7qK	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	43	1310	311	6301	12463	jxAvK4dzJqYHPU3JFbgRYfKufihL3QwqsC837kDKNEFTqQ2FKwQ	9150	12923	12923	1618265340000
18150	3NLJGkDRePTZykPPPHVnnZUM49R8SHp3mSfHb8f5kJ3hT6jEAeFt	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000
18152	3NKcTpmtTuwLPJQE7cTnsfH18qnMeZDkUaq95AGGqMo2xNnzoZNF	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000
18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1419	814	311	6301	12463	jwFTP4XrTRLWyYje29WDyRNVAf5eNJP23Z7SnxzxtTw46MsNWEt	9152	12928	12928	1618266240000
18155	3NLEhXuUjRFGg8VyRPanCut85Z6Rs8ScLdXzZhdnxMm9xJLp2aMB	18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	641	1336	312	6301	12463	jwsnoakBh4f4T8zudsQ9QYNRuXcPq7A7mXhYDps3zQce8yLkMYe	9153	12932	12932	1618266960000
18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	18051	3NKracEcBoLgnrvP3dArY3nWANTzjFAMFGYmqdG8hr3hd9E9sPEy	1406	1393	309	6301	12463	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT	9106	12858	12858	1618253640000
18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	18066	3NKnydX6PyQAby6PjsUAnfTaePZoSumcEGaFt3hiidgjYYbVcQXe	599	599	310	6301	12463	jwvFffTekGdMkCVaBVDFCSCuoVot2h47F1rBkXJ4JdUikyBAV8Q	9112	12866	12866	1618255080000
18074	3NLZ3Yw2Uv9mvy9Wenp88j59f9iodx1URLF47BVJTyM5Qy8h1sz1	18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	1651	1301	310	6301	12463	jweDx5YcS9AtGMwvE9cNMDUqxT8pdu1GHoto8b8W5djUZVx29NJ	9114	12869	12869	1618255620000
18080	3NLpuzmDrBGQmq22GpGiay3QJa62waD2MWbihVfy4X5PPGgjMMmW	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1407	1395	310	6301	12463	jwD8q3rgz5ftvXpupQ3qHkBp5gB5HCnBDg3AtHDdLJ4R9PL5z1C	9118	12876	12876	1618256880000
18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	18080	3NLpuzmDrBGQmq22GpGiay3QJa62waD2MWbihVfy4X5PPGgjMMmW	1406	1393	310	6301	12463	jwpLmuMoUPdSzkiJmCqcn1mW8WLbhhy2s2LxkkcLuYXH268kbXs	9119	12877	12877	1618257060000
18092	3NL3X8PzrvbaveuygU3pqf4WdFFVG4Rke16xNR34X1nPSCwtPjzH	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1578	1296	310	6301	12463	jwS45g4wtAUKRMz5YvcXrUnx8R8HH3zJTw2WmAH3rVTtUfHhTTE	9123	12883	12883	1618258140000
18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	18093	3NKeWG1ZcK5uV5W5e3jW7tvFUUEjCuduLhnRuQNAgpPh8rAoDeUR	532	937	310	6301	12463	jxYQjEyhmNYVMcg6Xudw4odC3VFNjJMtwuotJMKsgdGxgZKVijK	9124	12884	12884	1618258320000
18099	3NLLUCaooVpUVgW7GsuNEQbsyA7sD5ZYjq7i8VAcrVrXKo7rYMMd	18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	44	1199	310	6301	12463	jxj6LsWJtVxcpoP15UrqqWKzaaRtoEzZFYpHMyzjPPV5cLiGn3o	9128	12888	12888	1618259040000
18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	18101	3NKzqHAk5efShaiRzkJ1HF5orztURkyZHtnQ55aubdaxkG65Rvbo	1637	816	310	6301	12463	jxP5Rn5ikwVcvYkkSA6kePoqRWRnHfcwWLNk6py6UefgKYcFYRr	9131	12892	12892	1618259760000
18109	3NKmw5auRQ74hPFrYEjrGg3T4jSJicSiK4iUipfg9tfFBymm27HR	18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	1560	1045	310	6301	12463	jxEP88j7aHo3oUK4MrYXNrCrdY2YYJSggFwAexeYGPaysP5cnZG	9128	12895	12895	1618260300000
18112	3NLcT9zKQUsFB7AiUj9p9aseHKBtcppb6qPGPsNguLrrJkoEWrm7	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1406	1393	311	6301	12463	jxCdVjenBGYEPRtersRb9Y3maJST7ij57dcwNUnYn5xg2iiSCdw	9136	12897	12897	1618260660000
18116	3NKPCmQDQUQUC1H1axb7zoW6xUMh12kgFrd7JeN7jAuWyWhP2yNU	18083	3NK6qFZvbwS7kuUt9guCwDdQ4WZRLNdQFsP4FsyZeJ74k8SbaQdb	1571	1335	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8858	12899	12899	1618261020000
18119	3NKQ4h2LCkWLF1jortgFPKNqsxFNakHG6YLPqTkNDGeVhsmwW722	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	311	1061	311	6301	12463	jxthxQ9CS8LHkCe1HLDxUkkntRJmTYJR5GMGjmHs4yKtFkvzWyv	9138	12903	12903	1618261740000
18121	3NLsKBHeyT8A1epttwfoHtQBPoGbU4TUkihMTUNu7K2cnYKzmRzH	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	171	1128	311	6301	12463	jwFmPuG4VoBsJZRFRk6VjsMqhxq2xgH22a1MwcfUxGdEq2BtzhQ	9138	12903	12903	1618261740000
18124	3NLnVUnenPJpF3ggJVGTbJ1hRdJpfuEAQV16VBTZgGjrNFU78ST4	18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	1522	1076	311	6301	12463	jxfdXnfjnNdVrSA29dvvVofqcFUNZkH7gdyPqCTYhn6Qub3ND6h	9140	12907	12907	1618262460000
18126	3NKLbGi6j8gkagt9Bb2PFKrr4b1ZuT4sNmtjSEkYmhnUCuRKG2z6	18063	3NKcJUjLkgpuxX9jfbtiYokgeWUdwBmaR97UUcB1bM3B2tE3bxqL	1555	1101	310	6301	12463	jx4APUZBFeh3h18ZAc7BJpjQ45KyhkqWBStQNQykGaxFTnZRRk1	9111	12907	12907	1618262460000
18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	18127	3NLJdsU64uhKDPnQJZP3wefu4L8BXcyRUVzTRKWphVCyTwS8tGQi	1407	1395	311	6301	12463	jxdSU8CEXdPvnXeknnYzFPua1vTtgTcDG9Ji2UDK8i6xZQw4dPr	9142	12912	12912	1618263360000
18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	1500	931	311	6301	12463	jx7zVN92VJuAiv4cLCUyj3LMUn7YwnzYPAyyv49m5gY6UzdQGDQ	9144	12914	12914	1618263720000
18136	3NKZdxGDkHxvLjQBAVcZcFJiVGEPX8wc262nxqohJRTdVgLKHGFX	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1406	1393	311	6301	12463	jw9CvRCX2m1BVa297JzyhqNkRLxf4TmC7HXxAg8LujNTaC1KnYV	9145	12917	12917	1618264260000
18138	3NKQoNJypjgo2E1jeMBbu1wZ5ckwxiXnRPiv2fFFhs8y8hMfBqi7	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1483	520	311	6301	12463	jwib7uMghPJB1WNXetEiWnyjMmoMxC1yi7yieWKfQJP92Sd3HeQ	9145	12917	12917	1618264260000
18140	3NLckxdmnLPVSzkYhfPHaAtazijHsJwRdQAHCiWPNbodFgH44TPN	18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	1581	778	311	6301	12463	jx5vQyHKkuppQtuEiKnhowJFyjoreuKmHhrAVEBVcYJaooztFUk	9146	12918	12918	1618264440000
18143	3NKkC2gaAsms8shM3tuRrRJN2ZCnXvBtVapEeK9s523RPyMPL2kD	18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	1593	1346	311	6301	12463	jwDXV12sZaucGV8RLXZVFa5c8BjQS5WXKVkm9ferjJSwDXcGGtQ	9148	12921	12921	1618264980000
18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	1593	980	312	6301	12463	jwj4oyRwX7SRKm7dWieKMWGREBAXSkeLwXFbBGJJeYQDK8ufQZh	9154	12934	12934	1618267320000
18161	3NKsvxNkJG7H83XZuySsRUDzKLpSJKyeU4xQQ7uvc2U3gAQ5Z3aP	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	596	1060	312	6301	12463	jxvr6AeNUwHmMh2gjLSbbvps5CNtv3Zaeq59X8Vy5dn6Hu89iJC	9156	12937	12937	1618267860000
18163	3NKNU6F2fJ5fLGGTpJX3LpxguNuaw9KAHPMCSQyTa3gAAi2ErBV3	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	1596	1363	312	6301	12463	jxbrunMuYak829DoqEpYdp9SuDb83NipACXDGvc4d2mo8LErAF2	9156	12937	12937	1618267860000
18169	3NKHGVvjLE4NfaZiEqMTsJeEUHCp16TQTLKfwubSNfYYY7rKatNM	18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	1405	867	312	6301	12463	jx8utckJj26W5RgpLhMB1bWg3XxcWS6RvxvoXk7Ahht1fLEVtRo	9162	12945	12945	1618269300000
18178	3NLToiYdofEJxze4xi3p6ZNFQiTEftEAkVPVKKTuLn1XwUe2KJrz	18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	1564	1092	312	6301	12463	jxkcAhBowvokiL6AfLtvH9WgrCTfYc1n4zFVbXwvCRLD6s5sKQX	9167	12956	12956	1618271280000
18180	3NKgWoax3B1Jx7wy3SP2uu68ymWjQLfUKoJbALhcAGiLSjXGc6Y7	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	1649	1383	312	6301	12463	jxhj9AkhF1kgsTgTCdbTt2JRnrFJw9Dzu9wnbA6HoHsn4gRzM1E	9168	12958	12958	1618271640000
18182	3NKwStQdfu8CJwxyEsUqLxMa1B2fRgpxrMec5433ixm86svbVRko	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	641	1336	312	6301	12463	jwfkJaRpc6o5iKK146L3QTgDkgr4BX16E8dFWoGqe6TjsKb3tYg	9168	12958	12958	1618271640000
18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1403	824	312	6301	12463	jxK6XFavUx85kqPWzNFrqnLfyd2EXjPpfp4fw3FuKLHu9dfxCD5	9170	12960	12960	1618272000000
18189	3NLPLGVSbKFXPs1YvTbt6sXKmLgTfqY3qJw92dgVfBVMKcYrgPRs	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxzeUBRpfnpaeeTiWzphMTQZrr8nCi831pX7ULZ93DjvwVnUxme	9170	12960	12960	1618272000000
18192	3NL7kUtq4UQoLWsFf3aCyUmbc9zwbWapr7xZDcGmF8aEs495ZRLb	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	313	6301	12463	jxYrfpotPtDTJ3JojsjVjraQt1bRbPnLi1esFQJyeTU29DJ8ZZK	9170	12960	12960	1618272000000
18053	3NK49DLmkoqj9i5Dhj8NrQt4bzaJPcjP94t6kPgFjVp7t9gZwkN1	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	1462	471	309	6301	12463	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT	9107	12859	12859	1618253820000
18055	3NKPUT3LpS3WTaEjo8UNDtWR3bNUScn3oHL2yUw3w7TMtKizyBoi	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	1462	471	310	6301	12463	jxpwPCufWMMmjQidRRPxcvUfuAD1mHi5UpTqaQMhn8eggwFhH8e	9107	12859	12859	1618253820000
18061	3NLoa3C6D6tNsaA52ciYQ7zShE5Cab2nh7GY2sFkq7Ume2PoYtQa	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1581	778	310	6301	12463	jx8Sc17YaxES2nqTWgrqd87yyyM6J2ryGFnCVg4NWB7YPjr1kWr	9109	12863	12863	1618254540000
18063	3NKcJUjLkgpuxX9jfbtiYokgeWUdwBmaR97UUcB1bM3B2tE3bxqL	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	470	1309	310	6301	12463	jxdvsuMaezaNfU9cRV88Sr4TUS9AF1MQVWywtUbD96YEnQP55fc	9110	12864	12864	1618254720000
18065	3NKBNBrrgMQr4vE2ceYdrWp9f47SadUCPS3NU3BgaJCetx98xCF1	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	470	1309	310	6301	12463	jwJ15eyUyQ82BNP5gjWzxLNc3JRnJUBMUJ8r81dVCGWHBPQJyjD	9110	12864	12864	1618254720000
18068	3NLLaUTiG6QSuyYJoJpnp7hHYGvf8BR5J6NeYJrNHSYXJZFqFDjA	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1634	1085	310	6301	12463	jw6qkosLiiPmKsFpBvNCN1T5FFSxDcMCYxGTVsfJPz7jhzrs49y	9113	12867	12867	1618255260000
18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1627	1139	310	6301	12463	jxQLf776VQVZLWk1WjBDiXQBuCTJCxQePHhajJGQPhT4X5awh3d	9113	12867	12867	1618255260000
18072	3NK7H5jZnfYKbGagMZMyC8Wgje4ns7YZBWFvLhBNGv8DGWbujtra	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1652	1315	310	6301	12463	jwDuK2mKvRUP6eA1i3txqQcqhvThVq9QDu19gkMY3jXZf8js4j1	9113	12867	12867	1618255260000
18075	3NLrsGAhKJmDtCouFsjnU5SpFSyPpoxZvtnzYP87qnSJDuHJksNd	18074	3NLZ3Yw2Uv9mvy9Wenp88j59f9iodx1URLF47BVJTyM5Qy8h1sz1	686	686	310	6301	12463	jwnWu76xAWWuMqErs6ZAt4cP5zExnWyt5ozA3ksxgs3Vg6paZWM	9115	12872	12872	1618256160000
18078	3NL5KNT7oeeywRfUzm84N4n67BCUmUw7xQLRxJjPaaQKjPqPnMxi	18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	1610	1314	310	6301	12463	jwtp4mCopB8CDXiP4QSfMVqkimr7E24bWzKmLSrJxb76DuSXiZX	9117	12875	12875	1618256700000
18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	1547	683	310	6301	12463	jweMxf42181a5axza2QEj7HLQazwjqrQ1B8BbCRtmsgR3NcMhrm	9120	12880	12880	1618257600000
18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	1403	824	310	6301	12463	jwszQYhspQ7GvneqkRCHgAFUk6QT3gnfDa8VKMiGqhPe5852qf8	9121	12881	12881	1618257780000
18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	1407	1395	310	6301	12463	jxkZTdtpcwmBmKfEJYaZDWpBstGyHHFSW4g16nXthHyESGpnYgr	9122	12882	12882	1618257960000
18095	3NKXmjr15KQvMAuFBqCf7QTddWS7qwiLz3JjqaU9oLBfLKZKR4Tu	18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	1579	1389	310	6301	12463	jwRBjfx6eWQY9Rk5YUvskRWuxaGaUnuAror3LCdjQCa3X2Fe9CQ	9125	12885	12885	1618258500000
18097	3NLbANV9YKUksS7ZS7eG6XAsxgVceTPVL7PQwWaQcLjVDkAaudQd	18095	3NKXmjr15KQvMAuFBqCf7QTddWS7qwiLz3JjqaU9oLBfLKZKR4Tu	1407	1395	310	6301	12463	jx7GNVMS8vQNvsZNA678TBLW69m5u7t1xmKaSDaDxf4U3UfKXva	9126	12886	12886	1618258680000
18100	3NKFgKWVjnzShXtoC5qNmA62RBf1Qsu9ChKW6uSxj42CL1thkH4c	18099	3NLLUCaooVpUVgW7GsuNEQbsyA7sD5ZYjq7i8VAcrVrXKo7rYMMd	1546	1339	310	6301	12463	jwwiwG61SyZcZZM74SbqfQ5yepqM2AQQaK5k6cjrBZncQAKmvqG	9129	12889	12889	1618259220000
18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000
18105	3NKqyU9hMfGi3TC2ScFhd6XNWMyWa79nXVddEE3nB1xocS9d42DS	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000
18107	3NKMu5aduv5Vx2QFbJAHdJJj2Zb5MRwzHt6LUv4TUT4V71hK2DDf	18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	1587	1357	311	6301	12463	jwRK7NNo1Qdtrc36kiAjvSpNyv2NcsbdQKFmjCh2FBB1bs7SuZc	9133	12894	12894	1618260120000
18114	3NLGDPGAnYUcQUN2eHuhE1v21hyyc1zsHaQbb8mSVVp5a6ru5GaS	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1474	963	311	6301	12463	jwbQZPXfma4CAHFeNUPLc1eM5ZK4EgtvFLcABFQTBfTuVVexQo3	9136	12897	12897	1618260660000
18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	1553	776	311	6301	12463	jxUvk3Lzba6Fq6kTMQ5DShURS3yKtFbA2oH1cbA5Z4kZWygcLzg	9137	12902	12902	1618261560000
18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	18121	3NLsKBHeyT8A1epttwfoHtQBPoGbU4TUkihMTUNu7K2cnYKzmRzH	1602	1369	311	6301	12463	jxNvwasCSQbXKkEc8nekqupNWi6cXmMV891bJSECJevngXNHccn	9139	12905	12905	1618262100000
18127	3NLJdsU64uhKDPnQJZP3wefu4L8BXcyRUVzTRKWphVCyTwS8tGQi	18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	1637	816	311	6301	12463	jxvsFZi4W2SDMojhNM5qAy2RiGCgm2E2zZFXL7veS7b1a46k5mY	9141	12910	12910	1618263000000
18130	3NKTLvCJuT5Rsc4hyqBRaEShkp58gbMFgpSWRZRLKuHJzEL3gg6C	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	369	1186	311	6301	12463	jx51AMZP8zuBrFzb2CHcP63zHyydgBfgz4wsD2xdmwXSkpxu3bS	9143	12913	12913	1618263540000
18132	3NKEydBvTipJAkAHtwMf99uHKhSnHeANX3u9hYkcJuAY3aEnHibB	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	1489	1380	311	6301	12463	jwWsb2p1SH3YBoGRjxjFML9f4YURWVZbwrnn57VyBEZGU7rhaxS	9143	12913	12913	1618263540000
18135	3NKqFQr6bHLEHaXaYYsnAeR4NG6tBmKZ8uwJeTZWebm2sruA4XV1	17703	3NKGUvfByN6FGnmTVKAEE5VpXV3V19iaYMx7mqBccyxeLqbXhy7a	1500	931	300	6301	12463	jxU4mam4ywqWpjfjeQDBTQgztQDHzQHwT6WRREc1PZ3wQrit6co	8917	12914	12914	1618263720000
18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1581	778	311	6301	12463	jx9am1t5usY7j8pgDTrRhooCS1u3v9VAuYKk3nKhnPXSpB5ZYmV	9145	12917	12917	1618264260000
18139	3NK2zYy1iECqEhFJj6G6LK8cEZbtZeAzT7eTP3KVbLjkvJs6h34Y	18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	1406	1393	311	6301	12463	jx67Ycwuku1Fzz85H9KoQLVUMm1DjEwkeNpT78YzDmaKoS1CNCF	9146	12918	12918	1618264440000
18142	3NLwX1ztbC7QbB2aM13eriNQHGnXqV4jikLEib5xBCdYn1menqid	18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	1564	1338	311	6301	12463	jwBe3jY5mp3xQkLWj6qN2cp8GYWvqN5HZheZqJgGTJ6Tk7esrqf	9148	12921	12921	1618264980000
18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	18143	3NKkC2gaAsms8shM3tuRrRJN2ZCnXvBtVapEeK9s523RPyMPL2kD	1631	794	311	6301	12463	jxHAKvjpD7haqKDfmimir3LJxaqAnFCjnhLVPoT2rGFNSYwvLVQ	9149	12922	12922	1618265160000
18149	3NKL9Vj1EecR2Fi9brF58xgQi8XzWfshy9pZqbwzP5doVj8rhLXy	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1650	1009	307	6301	12463	jxTVMtMmFwgTQuzXP1MeBc7kw6zM7p6qKUza96eqX9YvXbeUKCG	9057	12925	12925	1618265700000
18157	3NK547NwJxJyRmKcQ4548YwrypXFKbpoG97v95FR3yEaJu9Mod7d	18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	1407	1395	312	6301	12463	jwVZsWZD7p8LAGbbJmXtd3Vitqiquh3WkqCoYS1t8XN7tFS4Ak2	9154	12934	12934	1618267320000
18146	3NLuBYQRFbRsh8SzKZieLoKrLpWcdHNyWTbUMVtyxwLA8oRtdSBf	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	1448	1065	311	6301	12463	jxXoRNBBLdBbykeDoDpmkYy1uFk4Hw3k5UwPVrTNhriikNSAp4o	9150	12923	12923	1618265340000
18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	18147	3NLMW8eZxBM4tY6H4bw9sP5SJcqz9n4CaFYvN7PwYf1EDGdEk7qK	1553	776	311	6301	12463	jxSCm8v4kP9Ert1j5KtWUCvD9V8yprwzetKQcidfUbgmS38S4Gx	9151	12924	12924	1618265520000
18151	3NLn74hVwfhixqeitijHGXMTtRBJyP7ddcqKfuMXAiovXi1aziPa	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000
18153	3NKokvEp5kXMEYvDk3sYx8sf222BrBoAHGogRtzXiprMfKpxmyob	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1419	814	310	6301	12463	jxtUADG2zskBrEyZZWJAnScoXvjJ5Rh9vyACscHnDKQk5jtWwLH	9118	12928	12928	1618266240000
18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	641	1336	312	6301	12463	jwsnoakBh4f4T8zudsQ9QYNRuXcPq7A7mXhYDps3zQce8yLkMYe	9153	12932	12932	1618266960000
18166	3NKnJBa64AmaDAfzKkmrvsPUD6E4dwhz1tW4kPbgReN3ScD2QDZ8	18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	1650	1375	312	6301	12463	jwRmPTHfDhMbsXHuwUdFyvyVvmkK4rVHu1yqfWBjnMudHHB1ZAB	9159	12940	12940	1618268400000
18172	3NLeLa7YjD56orjmYBFeBRHt2nGvgebq3sjzHBYfCafz38Hjdrt8	18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	1642	1241	312	6301	12463	jwF5axn2g4szE3sPgbWWUtLzAi77HjGL6FDrJuaHw6KCFCWuXZs	9163	12947	12947	1618269660000
18175	3NKES5mXbzYxAATzXxopJ3dnZw4W5tWFE78e983EYyfrFGwucV3A	18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	1407	1395	312	6301	12463	jwhecBcJRjkanEPTxmVGXK9VLiXrmFiADhPDTEgVGEY9x4yxU6z	9165	12951	12951	1618270380000
18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	18175	3NKES5mXbzYxAATzXxopJ3dnZw4W5tWFE78e983EYyfrFGwucV3A	1646	988	312	6301	12463	jxZvcRW3fiuhXZQPyjhmmXnFMKHgGFeANTuenQBFBxFy5RKD43r	9166	12955	12955	1618271100000
18185	3NKQ6qZeWUcwQpiF5NnKicCD1gx3E1c8eFr4xDJ9PxxhM5sQT3Qf	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	312	6301	12463	jx6zE6DLierzWtpvzx5hHJm2ueRH5FYhVdovz9fzbGpFYR2mGkR	9170	12960	12960	1618272000000
18188	3NKofR75MrhHEqcWBVxietPXMetgqQjvBRCoU5c1hSCDu6cDEyAK	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	313	6301	12463	jwR1MQaCayEN8uYqy1UL3nVvUHnsZeiqMWXbEf1M8LBJ5nF3ZjU	9170	12960	12960	1618272000000
18190	3NKkbkcyenZ6hjwfgTvmgUvEx9hfhVVxeEFJ3T7gmKYmn2mG3L7s	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	364	364	313	6301	12463	jwocJUtTxqUCzhH34ZDX46bR5YoVWoRqYnKSbYoKqHeSEwwSwqh	9170	12960	12960	1618272000000
18194	3NKq1bjfFZmJtRsezeEVRvw9LQZUkEAeQ6Nf8tMYYQSEE59N19dw	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	313	6301	12463	jxpp4aSZ8VPLrNXWGKCwR5qhyg9ZLqpvKiZpb281eoajftwvapJ	9170	12960	12960	1618272000000
18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	18189	3NLPLGVSbKFXPs1YvTbt6sXKmLgTfqY3qJw92dgVfBVMKcYrgPRs	1601	1388	313	6301	12463	jxgBY1nUGBN9he5n5BxFWdkVyTsJ6Xb9P7LyVUmGtiYcG9KB4gi	9171	12962	12962	1618272360000
18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	606	929	313	6301	12463	jxtuRvt94s1VXoxBbqVPaqQE2YebMdzRmrJGAf1sBxZWiQ1vdud	9173	12964	12964	1618272720000
18207	3NLBibdjfyqGZ1ct7K27AycPkgNjdBTya3ywBfUJpNnFNfqxzRnw	18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	1624	1334	313	6301	12463	jwdkpsmQVqtt532jEFHF8NcNGvJSmDXpn5YbYQjkNgWZypNpxK3	9172	12966	12966	1618273080000
18209	3NK4oqWe2eqnk75ksUBvxJWviuYHdXa3kJQLVqCqfgDN1iFtH1jF	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1624	1334	313	6301	12463	jwiCWrdQN4iytEicHLb5CXmQqp1QDG3p4PFNR6ovk9twByp3L76	9174	12966	12966	1618273080000
18212	3NKjpDdUn15gQu9AzmjuPpnEfxRxVjJmxaUVp2AsrkXGmYe9wB1v	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	563	993	313	6301	12463	jxQTotXGgE2JB8qa3xKguDDq22nmW8hqHvghang6URKNQK1p2iU	9175	12969	12969	1618273620000
18214	3NKRXhvFvCgk81ycCZgaUg4rTDcAzDkni1DyW1XaCTiA3j1gtUe5	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	1448	1311	313	6301	12463	jx8xtfHMnFYk6rMsEEiEZ1FgcDNjyn4Wc2rTMCieWin9833aYZD	9176	12970	12970	1618273800000
18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	1406	1393	313	6301	12463	jwMTeKccXNk3UwYm3zig7KWWxVNWyoF7BMZwTejn8PcJ65Vthvy	9177	12971	12971	1618273980000
18221	3NKmocnZVSr3RxCzBkTX9RoDSyU8Mk1fAAoWWZEdVSd4F6mNDBbP	18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	58	1281	313	6301	12463	jw9rnWriERczExfiZqpZebTKSZ6NgZpi4gbuY327mwYKUS5oNAs	9178	12972	12972	1618274160000
18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	18229	3NK3uTCXAN5sksVpLQSUGncPXSe4sMQFXmfJiTNvJDoTjStcQyLf	1522	1322	313	6301	12463	jwiSMiNS5HukCBy2RERtwaF5AZX4pq635wvkvNJrvBpHdTz4igP	9183	12978	12978	1618275240000
18235	3NKcibB8ns2GZCMHTHAEC8kNnXL24xYVwBjBMTLLcGhJgefbvejQ	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1613	1349	313	6301	12463	jwmia3boTjLgNK8hRnCtG8U9LkhsgXk1JAdQZLvRg2YsstNg87q	9186	12981	12981	1618275780000
18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1403	824	313	6301	12463	jwdmrLaJE3D58tDzL8VfDbu153h3qPGNZiSPiPXKaBcZyjgRjfX	9186	12981	12981	1618275780000
18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1471	1386	313	6301	12463	jxfQFii4YhRgr9qjA585jDdWaphdo5KjCL7xue1bh33dVhCpuTg	9187	12982	12982	1618275960000
18244	3NKmMiVcmTkXDFDMU5XtdXiofNMCafrc8ocaQidyV5yrVJ4LgXYY	18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	1668	1004	313	6301	12463	jwzFnveQtg43xG6CeGSShczzyHYZjEUaaVphY8MtVcCeLWs5FDB	9189	12985	12985	1618276500000
18246	3NKgUuHYnPskir6C5ESKDGcb8PyKAhxtm8Kkzjf7v4vL6Pkmg1LJ	18245	3NLWWFjEXxhFgBnbrXwyUZU55dtRdy9sT8AobMXefb9ms37n4kjw	1406	1393	313	6301	12463	jxFU7Sm51vKQkMuTGCVe8baZnJHtVroMX8ZWjWiJpts7ssg9SW4	9190	12986	12986	1618276680000
18247	3NKbr5NS9jEFxso9Q5r3tw4WHxZpVkQ1T6b7jfrNmhQ3ZrR7kFaU	18246	3NKgUuHYnPskir6C5ESKDGcb8PyKAhxtm8Kkzjf7v4vL6Pkmg1LJ	1501	1234	313	6301	12463	jwFbuFB8NXFHGNp7mC9noYihofURd5XZnU8i1YqmSCkbVFJ9U2A	9191	12989	12989	1618277220000
18250	3NLV8UgYZbHmQNn5QjWCs61dXDqXMmbqPsJ63ziYVRRDxRLCcqkU	18231	3NLSy5h2Q41zkWxTd7tJTJi7nt7kLZ7mdkDm3kSaPouvgxpnG7FX	1599	1287	313	6301	12463	jxnRQHJKqtYnNco5SzpZjR3YKg95ru4QAfN7xmPVh7bu45aBPY8	9185	12991	12991	1618277580000
18256	3NKocuR3ubcDMGAELgexLxXfTC6Ej81xjNj1QxN51Gd2WpqVNxXi	18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	1403	824	314	6301	12463	jwMMuDiVj4bkfgC8ftGsdteZPxZbriz5RoS1KECc1GVMkXCPzoc	9194	12993	12993	1618277940000
18260	3NKyW2Vv6MCXQT1dnPiTsQZNQf4HswcAvkDBethVTgdCx1HiT69B	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	1631	794	314	6301	12463	jxA432KvEggW1BvMbzCufMcLfk3snRuavJgJqR4xXMT1PhV9Vhk	9196	12994	12994	1618278120000
18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	18262	3NKqN75ptR83J5bBg2qceVFawGQvFSDTrqWuBn5fXc4Y5i1gAxBL	1406	1393	314	6301	12463	jxpSxujpXQY16vEZrgcVeKVhnP21bXL7M9y8PydmuZwMBgNtQiM	9199	12998	12998	1618278840000
18159	3NLyXNuC31MduoH4JHaawByUYU4H5KJ5EwKnq8tcDz9BgEe5fGts	18155	3NLEhXuUjRFGg8VyRPanCut85Z6Rs8ScLdXzZhdnxMm9xJLp2aMB	1403	824	312	6301	12463	jxgtkpqv9TK6ne3XCe6njVUpHhURUHdh9zduE95Az64NHZNCSR9	9154	12934	12934	1618267320000
18162	3NKi559yXp11uEbbsVQX1CCsVecSiLSLjKWyj3UWkY9GE1kfbFKZ	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	1406	1393	312	6301	12463	jwFnaMrg63p8uWgxpxN1jo5X7ipBcvCQuAbEtoMAzgzdDZUVQJk	9156	12937	12937	1618267860000
18164	3NLK6sAiF55eFdVaypYEHbLXhLD4hTMuYMDBG5thjNmEqascJELa	18162	3NKi559yXp11uEbbsVQX1CCsVecSiLSLjKWyj3UWkY9GE1kfbFKZ	1599	921	312	6301	12463	jwNdBmE28Xhn8bH2GZ9RerWxHVhjXZFqPyLRFh3o4AoXiQHqU9i	9157	12938	12938	1618268040000
18167	3NL7Ft9Nz5wgKw2n7UY92uKcDqFfeMcfZiqhh7ojc2yDVgF43g5J	18166	3NKnJBa64AmaDAfzKkmrvsPUD6E4dwhz1tW4kPbgReN3ScD2QDZ8	1407	1395	312	6301	12463	jwArN3h8217Hgtc7sTXocpxQ8XP9H6vXjr9FckAsop4BQd3S7go	9160	12941	12941	1618268580000
18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	1508	1141	312	6301	12463	jxsQp8LosVaGdAR98Z3dwMVMCBV2VJrYnPda1kheguxEdwu6Te1	9162	12945	12945	1618269300000
18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	18171	3NLXMPRBpAAqrAc2qRpShHto1oR8KSoNAB1TnJ9j1wzhxGQQaVoJ	1553	776	312	6301	12463	jwM753hjNbtPGRukjc6xEhgi2P8vc4kN81VmHGprYxCthgMWezx	9164	12949	12949	1618270020000
18181	3NKq7YbBdzjaFT1izA6WGS6bLnnF579sYHHqU22dB3HjE3rMGF8R	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	1407	1395	312	6301	12463	jwBZycJBzdZQn3y91B982rVbeFeyZfRbcLRUAPFuMdnwMMKSid6	9168	12958	12958	1618271640000
18183	3NKtLFR8HhcbZwGKsS8KaxsPYSh5ae9PchLrRWMduSKtJ3R6g6E6	18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	641	1336	312	6301	12463	jxgL5kSLWFhPMo6R7hTXv5B1thZvMHD4AibT2oiDYEt2wt3YwU7	9159	12958	12958	1618271640000
18191	3NKmss5T7oDfhdXWEwWANELGrd6DZvcmqA8CuDica6ooQjUvJtM8	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	312	6301	12463	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft	9170	12960	12960	1618272000000
18195	3NKBUw1Pdrn2WHBEygPVED6t8u1NfFK35PskejzwMvbEBmH7Joe6	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	364	364	313	6301	12463	jwocJUtTxqUCzhH34ZDX46bR5YoVWoRqYnKSbYoKqHeSEwwSwqh	9170	12960	12960	1618272000000
18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	1625	161	313	6301	12463	jwo5tuKsUUN43Jkaht9Z8sKuHf4nfzshZLpfqJ14HknNMs3VpJZ	9172	12963	12963	1618272540000
18203	3NLKiAqnnBdgq2ZbSYwPwWmfdfi3WC1AkLyzJ11BoeddTjiU8MWy	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1564	1338	313	6301	12463	jwuLURN5CsZZRXrvFr2cDX9ifsDjM32J4fpmGWG6FmbNnBw18Gr	9173	12964	12964	1618272720000
18223	3NLXdE19xMbnyE3DcZEpYNSpB59xEVgyYnrkPUf7da7xsSrxcPhe	18109	3NKmw5auRQ74hPFrYEjrGg3T4jSJicSiK4iUipfg9tfFBymm27HR	1560	1165	310	6301	12463	jwT4syKDsUveN55VJBgJ5kp1x5K6nYugKVooidiM6gMzXYFByUw	9129	12972	12972	1618274160000
18226	3NLVQXFbHJJ7wLBvUzSbHT4pgtus2GuKTrb1BN1YKYh7ayQg9QtG	18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	1617	1042	313	6301	12463	jx749o992DnDpkQmez6cTNaJaq1xU8jfzxe9t7CTsG4GHr9YT6f	9180	12975	12975	1618274700000
18228	3NLjX3my65GikcnMKGw8FrGVhyejRykT644xhsvvqsir7QLXkWDC	18225	3NKEhVWcyFGqJCQfk7nKZkrJzV5tyWntMaYRWjT1UR8TBRdF8ELa	1578	1296	313	6301	12463	jxKiwBUvaS5w5HMsFSGitFngXqwX48ocNsRni6rcCVNxrExHoqY	9181	12976	12976	1618274880000
18231	3NLSy5h2Q41zkWxTd7tJTJi7nt7kLZ7mdkDm3kSaPouvgxpnG7FX	18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	1588	1266	313	6301	12463	jweBngnaXCa9Scfnw6NsVBZbwmzXRqEHT51xrgdt5qxHu9w4A5Y	9184	12979	12979	1618275420000
18233	3NLarzcCvLJiUSu1NVfrA7qCTtA5QHm3ycQm4F1cjyZGm7d1P4p8	18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	1643	933	312	6301	12463	jwmS5o46iDpex4GfhVpdYLDTv52q5PGBvkcdjyt31vZvEbEhxrn	9155	12979	12979	1618275420000
18236	3NLhAT27pE8YrfiCmfEP766FggRx9Dcg3Xcn9WDfR93XB7zj7b97	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1613	1349	313	6301	12463	jxjh2DHUBJz5kuLQgEWAt6GBR6AqaG22ktJPoW7LpJas4yTKtvH	9186	12981	12981	1618275780000
18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1593	1346	313	6301	12463	jxqgGtnAdxaAvV7pmBSvmEiiNiBmg2gvdCaX8uuqW8QbXNGW4Kv	9188	12984	12984	1618276320000
18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1599	1287	314	6301	12463	jwi1L3KXWjihfVPgmqUkEJUZ4r4EFqo6WNMemMgzexqUHf5PH2D	9193	12991	12991	1618277580000
18254	3NLBSztUgrRf62XYgv4REMECQ8zva4SQ5n9tmDVQD6gMTFTUswdn	18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	1573	1318	314	6301	12463	jxDAjxmsugBMf3aYtgQFdqEJHaBg9ZBpRjAGzrvQyaTnkFT2tkJ	9194	12992	12992	1618277760000
18259	3NLdwfWtownYZgUUavMZ6HfHEwFhWRV4pz76V49BJLqYNWCPgMAe	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	1594	1080	314	6301	12463	jwyoML5uTECfGobscd5DV5qqbNnt23XZVLZZoxHf99Fduz5VKVj	9196	12994	12994	1618278120000
18261	3NKZRM6RbRRVoKUaw1pUXDFwU7bKASN1wmGg9yeMEB7GBayP2oXT	18258	3NL1QN3CsZ7qdWMeoh7WM2KR97E7p6FJhU584qfSBa9z3oaaPUzg	1573	1318	314	6301	12463	jxTDp8qwPMPHh9vFVnTbXngHagb8mizBV8ncKjDeA6AgSmy9abn	9197	12995	12995	1618278300000
18264	3NLTc9ugBwwad42SxfkPF1ZJMvL4w3eDvG1AB8SY3tjKtRZ1u9hq	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1402	852	314	6301	12463	jwLrjJVJoCxxCJNSMoM2GrbmsbAiZUHqSrbUSzEpWxrxwddP1pW	9200	12999	12999	1618279020000
18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	18264	3NLTc9ugBwwad42SxfkPF1ZJMvL4w3eDvG1AB8SY3tjKtRZ1u9hq	1596	1363	314	6301	12463	jxjJTYww698RCC5Xy44xAUNz4Fuhntk99dJJC29z2z6hrGYpz9z	9201	13000	13000	1618279200000
18272	3NKngHEobcyoicxeBBNTD7yX4UyjSYecNAQcgWyHGfV8Gxzdh4Wz	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1403	786	314	6301	12463	jxuWfLU6xtKFsemqVJNWuHm4oavyn9UUcGmoSP8eoEinQpM5oKQ	9206	13007	13007	1618280460000
18274	3NLvYikrtGGB3ELxrFwzHY1awA9RytZnFhKxXS66qLRw1y6pxtrZ	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1483	893	314	6301	12463	jy3BGueXxLjwVSiQi5JcUF5v54v3SZzR6X9iVNLXw2ztnSYsiaW	9206	13007	13007	1618280460000
18278	3NLMM8AnbprFHjPDaovD8Zy5RyNAvGVwxYBfj1s7oYusm49BBidc	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	1622	990	314	6301	12463	jwB7fjLefj33ncMqU4bn43eLvDbiR5jc8yiDGhKvR6SSCNVtTQx	9209	13011	13011	1618281180000
18284	3NKUoG4xZWyd1ivVwBwguB7HbMKThabZXaFCZuzjSmh2jpxM784k	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1654	1094	313	6301	12463	jxa5Rd4YV4mzZqc3gtvkf2rAeWQYoLcKGVNE1mt5LS12SAwNdXy	9187	13016	13016	1618282080000
18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1523	1321	314	6301	12463	jxkKoJj7X3GLPLQ4aFWcdTNcBk6WCkVJaPNwkfKGHDwfwKUPxeY	9217	13021	13021	1618282980000
18294	3NLiF8QaFJL68dYLoKKQ5p4EpqQ1cDRPyWXf2CR1i7P3bSVAE2Qf	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1523	581	315	6301	12463	jwF66TWtRwFK8woL6DtZFdhFCe92LTyb8e57GbauVqdqC5t7RPL	9218	13022	13022	1618283160000
18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1522	1322	315	6301	12463	jxiquwi843LNPpM74kLuVfPApmMnvmmazc2JkLEnFk864caRact	9219	13023	13023	1618283340000
18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	1571	1335	312	6301	12463	jwgzU4Pjo4gkd62j55teaxi96GtUt2cFsQfdi8Y7TYb6syTTpKw	9155	12936	12936	1618267680000
18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	18164	3NLK6sAiF55eFdVaypYEHbLXhLD4hTMuYMDBG5thjNmEqascJELa	1406	1393	312	6301	12463	jwQ2q5uCaaGN91aDe4JQGwbrUtNRkZEzLL82a55NkpuhLjspYWf	9158	12939	12939	1618268220000
18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	18167	3NL7Ft9Nz5wgKw2n7UY92uKcDqFfeMcfZiqhh7ojc2yDVgF43g5J	1553	776	312	6301	12463	jx4kS4PU8TP3pBqG8BbE1QFCtTR5bsJJKep8y2qVAjuAnD4RoQX	9161	12944	12944	1618269120000
18171	3NLXMPRBpAAqrAc2qRpShHto1oR8KSoNAB1TnJ9j1wzhxGQQaVoJ	18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	1406	1393	312	6301	12463	jx8sR5dhXwzb4CSdtPVz98RFJZzunUXZ3d5t2i659LbV4Sxdirz	9163	12947	12947	1618269660000
18174	3NKeRFUoMX4xx8UwGmQHyziZGEt7kLtfqNvcivcLBwHpSwZgRFzd	18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	1599	1161	312	6301	12463	jw8nDXHXbYDE8ZESBfao8ELBBcXN1bPSeEzMMv5zwxEqvkEC8uF	9165	12951	12951	1618270380000
18177	3NLT8Mt7e8LpKsr3dsjUA4EaS1T3ePe92VYgqDbRgBdMPPGpZycb	18057	3NKokdCh22kNz6NScou2wrj2oUjFyRr4D6eDM1zbQn9zge3uLrPK	1516	1168	300	6301	12463	jxe6bEKL3LSjUgjzqUNwRVtwz3jTbmHQvQLiRYWtiENEPHCihCK	8915	12956	12956	1618271280000
18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	1483	1276	312	6301	12463	jxXYEYuBExGvdMTi64ZDWMGiQXXiy6JLD3UmStcqfvuDqAtrfBG	9167	12956	12956	1618271280000
18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	18180	3NKgWoax3B1Jx7wy3SP2uu68ymWjQLfUKoJbALhcAGiLSjXGc6Y7	1407	1395	312	6301	12463	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft	9169	12959	12959	1618271820000
18186	3NKwLDoWTUDn8hyKoFELNieXReeP1g6jdTeTaGt7sfwc1KTgZFcm	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	313	6301	12463	jwR1MQaCayEN8uYqy1UL3nVvUHnsZeiqMWXbEf1M8LBJ5nF3ZjU	9170	12960	12960	1618272000000
18197	3NKpUZQTGKcarogN3apCVh7BMtE2rrXmt8tbb6vUG3RbDCYCQTmJ	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1546	1339	312	6301	12463	jwFdqMestQ32PCLEgADAs4nXTFnuZ92PtvfVnZ4L85uuc2yxuwb	9171	12961	12961	1618272180000
18199	3NKHDcWoCuP6CXqSKv5PZVRxQpKjszGtGqBpsEY62Chxje7KzEJc	18193	3NL4UGxZ2zKgcojxVVVnAw786Hthx3FkowUpQfnU3CsoYZsPiZJC	1553	776	313	6301	12463	jx7YnzptF6Hw4k5u9hamS7nM37HVahbW39r3xtanzn7xuhvvATu	9171	12962	12962	1618272360000
18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1624	1334	313	6301	12463	jwrqqEFnrYBZc6d6f7Hd2GxMLu2cVomagcSV9hFCARAN8uaTwR8	9174	12966	12966	1618273080000
18210	3NKL3g6a3k7P5SVHBFs343N2YM4516EMYhuDr814VHjAjmh2gbSs	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1403	824	313	6301	12463	jxUkHQcEcz6ci5tk3TCJCFk3odvpAzVqRVVJjk6bv9yeWaUcSQh	9174	12966	12966	1618273080000
18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	684	1106	313	6301	12463	jwwV183W2Z5s7u1bcz43xkEdCeKi6GxPe5iGBSJkht1o3nmesdM	9175	12969	12969	1618273620000
18213	3NLpLWkzUJDMVgFwLUcfnM84vuwzJMV3SezXu6mf1Fx1vgNyeczG	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	563	993	313	6301	12463	jwT6kiZYPftDcHMxv532oPECYzdS3nXALzSsgtb1RNmKjknesaC	9175	12969	12969	1618273620000
18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	448	1305	313	6301	12463	jwBgmoD3ebKR3dTs9BtY3vYJtMmF6grpMk1QmgevzqKgDicYPU8	9176	12970	12970	1618273800000
18217	3NKyZUA21McUNV3DmoC6Ejk4n2kfLr5SZ7KjYHrevKCQPqQkEsi1	18196	3NKsHJ5Ke7uwxvzToG1odkisxQweFzFXHqs43iXYFRoNhb3Kv6HT	448	1305	313	6301	12463	jwPPrCf4ysiu4sx54VWBV4sHX4vTME19HgV8a8ULV1CPZYrqyCB	9171	12970	12970	1618273800000
18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	18221	3NKmocnZVSr3RxCzBkTX9RoDSyU8Mk1fAAoWWZEdVSd4F6mNDBbP	1634	1331	313	6301	12463	jxa5yFQsKnxxLXGPfNCVJJwSFcwFfiP9E88PuZiqWVaBtqYZUtT	9179	12974	12974	1618274520000
18229	3NK3uTCXAN5sksVpLQSUGncPXSe4sMQFXmfJiTNvJDoTjStcQyLf	18228	3NLjX3my65GikcnMKGw8FrGVhyejRykT644xhsvvqsir7QLXkWDC	1407	1395	313	6301	12463	jx4MnnEbLapSCFQgRKpszBxduZ2PPGp7RzDuEptVLXFp4TEV6bF	9182	12977	12977	1618275060000
18238	3NKKjRBcTXewPyUZZKASe6kERP9qxCiojpiGyNwXxgEvxSRQiwkS	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1588	1146	313	6301	12463	jwMMeWqTtEcLAVrZGWBNqi7QZVsPQKb1MD3E9hhdLwiiCaNG5sh	9187	12982	12982	1618275960000
18240	3NKnHMXFPYHt8eQEkTKQ2SnDHV8WTFN8vQA2V37cqD32NrqVRRaZ	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1623	830	313	6301	12463	jwrXN9mp3CoVNFburNou979eZWN6RU7mFE5cQN4Ec5LR3QDknQU	9187	12982	12982	1618275960000
18245	3NLWWFjEXxhFgBnbrXwyUZU55dtRdy9sT8AobMXefb9ms37n4kjw	18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	1672	1285	313	6301	12463	jxYznsGTHuBXaaWcyrZ8jX2Mhwhk84sqbnQ6JtvTjchJF9sJgGQ	9189	12985	12985	1618276500000
18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	18247	3NKbr5NS9jEFxso9Q5r3tw4WHxZpVkQ1T6b7jfrNmhQ3ZrR7kFaU	1652	1315	313	6301	12463	jxvVcwhAWJsVUVdH9bqgHPQFnronHGcNpXbxhnQey1W3ZwFeaNt	9192	12990	12990	1618277400000
18251	3NKMf5M2Kioc3CGPMa6Kajj2DDPqFiUow7mf9SoMp2PV7HvcUH9X	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1637	816	314	6301	12463	jwc3yBtSSNwAS9oGqkCrREAHfcoUjUXEFtAPLnkafTEwN8Es2Ab	9193	12991	12991	1618277580000
18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	18254	3NLBSztUgrRf62XYgv4REMECQ8zva4SQ5n9tmDVQD6gMTFTUswdn	1581	778	314	6301	12463	jwbc9fjd8owrh3eXPkwkqMYiwW9VDYmkN76hdcdVuoX8byKbRrc	9195	12993	12993	1618277940000
18257	3NKRx513Fk4udErQtVPcQrU9VUpmSvmxXjDZzUx4wEZgXTNHiv2y	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	576	1355	314	6301	12463	jxa6Bp8bfmAuh4miUj3dG1JdqAN72g1cBMu3eQBnikudmRyH8BM	9196	12994	12994	1618278120000
18267	3NLr9v6Uq6PL3BFbxC23DeBP7QUJodTEFoZXYUpAydttEQfeTJfw	18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	1651	1055	314	6301	12463	jxe9cUuwNyoQ9ToHgY4ZrSMgZjTAh6Szim4mSJiYpigyypKjTRy	9202	13001	13001	1618279380000
18269	3NKhwom8RWmPVmnPnLipUcW9yDCrvnSoPpAmRtT27bnVszthCut4	18268	3NKG5Qpfw7gDbfzDFZ2GJEE81uCAon9oJkGzTc1yh2GxtsrGhRqH	1633	1390	314	6301	12463	jx48vYzfKn7KaBneCidWAZh2UbtLQaDPtiWQrgY4o2dpJEG8uxu	9203	13002	13002	1618279560000
18273	3NKGXdJ2nhHCjsLtetUvxVeqAjKvgyMkmoesYLExRjPgFBd4e6np	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1406	1393	314	6301	12463	jwMPtW9FZyoFMuQ4PoXouo2h9NN28xtVsaxKfcy4g7fZUMp2Dqx	9206	13007	13007	1618280460000
18275	3NKQDBaB1f19eAK5r2xtBb1vBTEBfDS26Ao8Q9C653WU98pCmw9N	18274	3NLvYikrtGGB3ELxrFwzHY1awA9RytZnFhKxXS66qLRw1y6pxtrZ	1577	1327	314	6301	12463	jwXTBggE7e1FqUZPtFT27pfnprzf7c4j4sV6FBiYP36Gk6LNX55	9207	13009	13009	1618280820000
18279	3NLsxPQNV4RwSdMy3ykDbfsii3fCzCwK6eH67qShLUacXAokTQFk	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	1623	830	314	6301	12463	jxd7dxJ3PDdao9vuQxF9nvEwQUQcfSemg8G87X9m4MpLBvvV8s1	9209	13011	13011	1618281180000
18285	3NKsFbCG4xBAKRjkoukXUEJkK9gyuysk4Ua9PX41cUWrXXAwtfdD	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	1407	1395	314	6301	12463	jxyXZKnzXirEbXUKHUqAHqqvSf1icakFFbeVjZseBk2ufFEzstg	9214	13017	13017	1618282260000
18193	3NL4UGxZ2zKgcojxVVVnAw786Hthx3FkowUpQfnU3CsoYZsPiZJC	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxiFAxKEq9LYJwqwn574F4PS7kCcdMQtuAA6STR1RjZgavA9QSg	9170	12960	12960	1618272000000
18196	3NKsHJ5Ke7uwxvzToG1odkisxQweFzFXHqs43iXYFRoNhb3Kv6HT	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxogxeu5bJ3mQo9EDdpFJ7kKqTNUssqmhFkzLrhnX6CaHgHGZxd	9170	12960	12960	1618272000000
18198	3NLhVFX9xe7hqjDGez6SCik4VCVdTG9Jqvoyjus2nq2ghnLDsxwW	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1546	1339	313	6301	12463	jwFdqMestQ32PCLEgADAs4nXTFnuZ92PtvfVnZ4L85uuc2yxuwb	9171	12961	12961	1618272180000
18202	3NLFoZdk8wuNafPEzhRR53GTqz1mg4yBJ1AX5roNVffYBpPHxr4V	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1403	824	312	6301	12463	jwjM2R5ACGBHsWgziSsKN6iS7ALrb72RMDUHRgumbrP78rhsaX7	9171	12963	12963	1618272540000
18204	3NLSQsN9sihtmcfh4QKsyW9yBLTCpsyNyLeFHJkesrcoMW4wWJoW	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1578	1296	313	6301	12463	jwBNtVmSFJ1fZZd5GsjP9FZvRTrKdsPwDcLbneXBccH4XTzy6MA	9173	12964	12964	1618272720000
18206	3NKakLUtwFyZwKEjduU54NpFrCBjdzKBB14iBxytZUAvdLGLwsud	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1407	1395	313	6301	12463	jxyDhh3kY9DKHezzekzXN4beaQoSNXx6iUitradirFAavEFFvhm	9173	12964	12964	1618272720000
18216	3NKtShTi9QKaWiE58uaYuDpSmueYqyRhpqbiJvLQoAgP7DXg1wAH	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	1448	1311	313	6301	12463	jxnmAa3W9RMBkHVeHjX5zvMFqAPxAkbLFF5n9m3P5vtBwqyB1EA	9176	12970	12970	1618273800000
18218	3NKe5GJVYhkqJwTLqKK9TxSjVk3UoLLUmsSf8XbbxRQppZPBYiV6	18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	1589	1286	313	6301	12463	jxcNt4bhxchGYtZu7t3rhXwUYSau9dYUb6mWG3aEohj3JVHgXo6	9177	12971	12971	1618273980000
18220	3NKAz8s2jQ51sNH13PqANgMgefiisW9rwHFWZVYTXD9YXeCYr6EN	18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	1560	1165	313	6301	12463	jwQ4BozidekFFFhWikFaAMSEeVRxYCnXbTes6CxixbfGPuNVsEv	9178	12972	12972	1618274160000
18222	3NKmGxjfmntdkF8VFhZTx4uZFnvmszwPZwBr7psQGCMScsM9nbkH	18042	3NLZ1F3F11iYbm18D8CiFa3pXrxYBud32s3t9M97xrQrXw58uGLj	1481	790	304	6301	12463	jx5FHcjFYdLmcFyVyeiE3VFjYS9Bq6r63jU5JKmsJAJTvjQPshC	9000	12972	12972	1618274160000
18225	3NKEhVWcyFGqJCQfk7nKZkrJzV5tyWntMaYRWjT1UR8TBRdF8ELa	18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	1503	1151	313	6301	12463	jxVt36fBZ7bK3yLU1nZ7Yetxg49K1N6jDTt7qm6LQg1FsR3EJ5S	9180	12975	12975	1618274700000
18227	3NKHVam4LGvusWU4yr2VFhJAxLQRgr236yR3mY1MGpJhSpNf7sgm	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1503	1151	311	6301	12463	jxZsKog8BZvdgqKVBVZhr6nJPqLsaq17uBay9MKFspfpF52bKD6	9152	12975	12975	1618274700000
18232	3NKXcF6d1Kfvj5PTMrnVQMps3JxpMpEfqRv8wC1HAiFuxAiumRXu	18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	1403	824	313	6301	12463	jwEgX98bihzmVZDTpSEPkMZTeMssowM64mR4RtAjUcQPa6sGxhs	9184	12979	12979	1618275420000
18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	18232	3NKXcF6d1Kfvj5PTMrnVQMps3JxpMpEfqRv8wC1HAiFuxAiumRXu	1587	1357	313	6301	12463	jxeNGzeg5nQgvXUkEUyVyeBYzK3emwHJd4nBzXqeGBvjV4GWxd1	9185	12980	12980	1618275600000
18241	3NL1NRmDkNYvhCHFmfGeXXJTuyPdGkXifui8CRAjqVJANGwYQLSX	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1668	1124	313	6301	12463	jwYLArydgTfyoKAFpTaJ46cZcBy9ntPKB6e2JNxsCW5D2bNW223	9188	12984	12984	1618276320000
18243	3NLNtgAkDsJV8uFhP5PmNqaEaMo1KiNZH6avcyaKyeT2aL9pULqg	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1483	84	313	6301	12463	jwnpHRRyULFD2jXaWDg5j6XVXTACMvKTqbKN5HrqboqYZUKcZZt	9188	12984	12984	1618276320000
18249	3NLC61gMVxAfn6wbNMKxqbe5T27EDpQpR9KFzMgKrHFRyLcVquHv	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1405	905	314	6301	12463	jwSyUZdYL8u5Vd7cBHcc1xecXDqsYsyFpP6A1CCeHm3MGAXecnn	9193	12991	12991	1618277580000
18253	3NKwar3fvFnHV4o4c9nbaK1s3RHZEk2A1KrvLPb3fxoE1SvLxqfw	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1631	794	314	6301	12463	jwGP3WX4btgk7b1nSkGPYK6iW1ynA9utypV6iQt8CfhwEX9ksDR	9193	12991	12991	1618277580000
18258	3NL1QN3CsZ7qdWMeoh7WM2KR97E7p6FJhU584qfSBa9z3oaaPUzg	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	576	1355	314	6301	12463	jxrDkzhPvF8AbvRqmyrq9dZviUgJfrhS47mhTka4vy9RD2ffVZS	9196	12994	12994	1618278120000
18262	3NKqN75ptR83J5bBg2qceVFawGQvFSDTrqWuBn5fXc4Y5i1gAxBL	18261	3NKZRM6RbRRVoKUaw1pUXDFwU7bKASN1wmGg9yeMEB7GBayP2oXT	1406	1393	314	6301	12463	jxqBMi1kQatf4zMAs4cWGGzaiACCkf9v4LAAQFftQw7rUt5fTWT	9198	12996	12996	1618278480000
18265	3NLsvQABk7ENkkq8bRJ3AbNwgw86GDo3dBWaQkBJLWWhzeCG3Fs3	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1406	1393	314	6301	12463	jwhnX3MmeS48jtvtDMysPW1mhiUZgcdz1vV1WMbAy19HxNrDZeV	9200	12999	12999	1618279020000
18270	3NKeibXVg2biJSpmKo52CN3sSynHe7G15gQsZUDNRuTiarSVcc5Z	18269	3NKhwom8RWmPVmnPnLipUcW9yDCrvnSoPpAmRtT27bnVszthCut4	1406	1393	314	6301	12463	jxxzAbkuqFHtVZT3aDAESgebTMKUECBEaFaiqa3ZsZegfvrBvxX	9204	13003	13003	1618279740000
18280	3NKMXNEZFq3eECLMquh3rU5Kh12DmBhNrDsqJ37PGmWc3ypyB3jK	18279	3NLsxPQNV4RwSdMy3ykDbfsii3fCzCwK6eH67qShLUacXAokTQFk	1457	1391	314	6301	12463	jxEa52k5ZuRoK9KjYu2sHro3H4mBh7YuDpbELJjyruWn6CzdxH6	9210	13012	13012	1618281360000
18281	3NKUGbuJmEhXRmxS89v3dK1LxYGTphLu9ehzaFR7Tr6EDbvrCM82	18280	3NKMXNEZFq3eECLMquh3rU5Kh12DmBhNrDsqJ37PGmWc3ypyB3jK	1671	1119	314	6301	12463	jwtMxituVhJXaJKenJyzSgAWEJirzdVQRUXVEtCjAdaUP4pTs2m	9211	13013	13013	1618281540000
18282	3NKUMTAnvuQAe1UT3gPd2cUPHrPzDw2EECpQCo6ngDy9jM6JRkkA	18281	3NKUGbuJmEhXRmxS89v3dK1LxYGTphLu9ehzaFR7Tr6EDbvrCM82	1501	1234	314	6301	12463	jxUpqUvY7bxnLvT7GsRLKKHxtfVKLjb5x5y6YoELZErrRaX3Qn5	9212	13015	13015	1618281900000
18286	3NKtGwwuYQAqfHuCQcG1PX1dKMariNgJhUin4cxvLUFFBweASN3f	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	470	1063	314	6301	12463	jwmgJwzd7t7ruLDUv3tzLojSyfPhUBt1vuv9i9AgV8KtTEvs6a2	9214	13017	13017	1618282260000
18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	1513	1379	314	6301	12463	jx6aq7NrZPaYWpjpV5tnyufLQzPi34ihCBxM2NwjscZ3XGTSsTy	9216	13020	13020	1618282800000
18291	3NLqBn7zaJY9JDwANPLfd9Rf4JZQdLG5xigKWPDXQGJdwcvQoJog	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1457	1265	314	6301	12463	jwoMdhoCn1y2b84jzdTmHe3Q9fPaLUu3eJMkbtfQprd4k4ShbcP	9217	13021	13021	1618282980000
18298	3NKAp38ax1anG1vPUmnbcB3scf3VQcFqmSZCBBSM1L3xVsnVDBoK	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1402	874	315	6301	12463	jwKa6TXZBQKRQvz9aMTSje4QihYrWoLnHD85ohmPWYZgoEQ7n1b	9219	13023	13023	1618283340000
18299	3NKu9mcqi2ymtPqSXmMZrEP9rcbsKqUJEGaAfMv6SD9VYj5B2ZSx	18295	3NLDn58ED5xEWMVAno7UqqoQGR4whZKGfnMYYpTTK4WPorjCMKvj	1546	973	315	6301	12463	jw7vmFdTB4qbpff3vkEXXStGDseSxU8QhDXGkA2821XfKttTrE2	9219	13023	13023	1618283340000
18301	3NKMNUXWjQKQ51ncwKzViEgwtZsjowtk5Z5VS7RbG3ZP1mwqHjna	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1403	824	315	6301	12463	jw8DRDon6nSjB6YJwsRaKSkN237zCN1uDVf2UTeZFH3nVnKT2ii	9220	13024	13024	1618283520000
18303	3NKiCrPKQFsV6RLQLy3PcLeENYkxn1vpnf74NcV3FnyERvsnStNy	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1407	1395	315	6301	12463	jxiuvcTshqhhgiUKahWZwvuzt4g6FCczkh7Fuwmocxm523ChzL5	9220	13024	13024	1618283520000
18268	3NKG5Qpfw7gDbfzDFZ2GJEE81uCAon9oJkGzTc1yh2GxtsrGhRqH	18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	1651	1055	314	6301	12463	jxfFF7j8FKiGizs8S28eUtZ3Y4G2gxz3QbmhG6cfZAXuTNrbpK6	9202	13001	13001	1618279380000
18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	18270	3NKeibXVg2biJSpmKo52CN3sSynHe7G15gQsZUDNRuTiarSVcc5Z	1407	1395	314	6301	12463	jxtVk1vptvdPCJyB8oCgDxYpsBMJ5F3L8Yh58syUJEfRrtdvrX3	9205	13005	13005	1618280100000
18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	18275	3NKQDBaB1f19eAK5r2xtBb1vBTEBfDS26Ao8Q9C653WU98pCmw9N	1407	1395	314	6301	12463	jxb9XLdRKSZQWsApGj77aSgTzNsqYbw6AKLHTrC9uuVxko8LWBP	9208	13010	13010	1618281000000
18277	3NLdjNq2FHsH7u9yY5JPsth3Df1WaWmBtMLCCFoQuA7CWvkpU1ho	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	311	941	314	6301	12463	jwdcWvBidbnbiTMER9mjSsKFENzrvVYjsJGPufyWZiz6ZMBCnxQ	9209	13011	13011	1618281180000
18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	18282	3NKUMTAnvuQAe1UT3gPd2cUPHrPzDw2EECpQCo6ngDy9jM6JRkkA	1654	1094	314	6301	12463	jx8JUnHgSKunGe3f6KsPSFUfT8zir68r5Z8PAAgmyECwSZVHSFD	9213	13016	13016	1618282080000
18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	18285	3NKsFbCG4xBAKRjkoukXUEJkK9gyuysk4Ua9PX41cUWrXXAwtfdD	1507	1280	314	6301	12463	jw9RvPmNYd3fVuMYiSxr7r81WexXMLhSeMK5daHPaEwkY2aoar4	9215	13019	13019	1618282620000
18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1553	776	315	6301	12463	jwHrRaxk5j4tvueHHDgFb2tU8hZQvgLmUD45KUv1rbPpsNUMohg	9218	13022	13022	1618283160000
18295	3NLDn58ED5xEWMVAno7UqqoQGR4whZKGfnMYYpTTK4WPorjCMKvj	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1523	581	315	6301	12463	jxEtZqMAUSC1gn96kbFdxmrf1Trpx6j7UmLf7x135HsLf7YXutX	9218	13022	13022	1618283160000
18304	3NLhvEmiq7ZEdz9CitD7Cza8bJdi43DY5RiMtMgKGXvtD5JZ31HC	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	1422	1091	315	6301	12463	jxvsyjEEk9BtaLtumPgzXrFMKdvYVKoCry1hcZi2LSzH7Nj7qMH	9221	13025	13025	1618283700000
18306	3NKVBdQuxEbexKFFYkXb3BAeX1jKQ3pLqcHLkmLswfSnNuJurhhT	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	1675	1096	315	6301	12463	jwd2X5GCyVB1Yf8s6u4xhUBfw1s5Ff6DCCUycnpwNjW21vpwoLo	9221	13025	13025	1618283700000
18312	3NLwbzfjLnuDx3ocT8UqCZni8JRTMSmMdDoYrdyeoxVg1DuUwtnA	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	576	1355	315	6301	12463	jwNVheyostkxR96n63bN619JW39UcUXQrmu2SekGEp3FYHMAgGX	9225	13033	13033	1618285140000
18316	3NKb92j4yx7NSHfkLpHEPoWgFjSAPXRK1p5tL4raqPND1j9ELPp1	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1541	1298	315	6301	12463	jxpA3m2gMwiTWCS9rCQzmskQGEcdnMtGCbQKALn2QM2EGgH2GhJ	9225	13033	13033	1618285140000
18320	3NLgyKcRyCUSQzN3achNYkRTfGdRZBmmQ29S4q8BMV33eteT3Bsm	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1651	1055	315	6301	12463	jxLxpEiJrDrem55iKXXHWc74jZWhE5kPioQ8p694wCMvgnjt7aj	9227	13036	13036	1618285680000
18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	18323	3NLkSZVkcTGUcNXoVENPRxw1rArfZwjkEwUAB8nUBNjFvvsGVUer	1406	1393	315	6301	12463	jxLA7a7Rge8YyyQ3SKe7ZgPsa4Z9vBNwR2qCv319hUsyZRVCBCP	9230	13039	13039	1618286220000
18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	1553	776	315	6301	12463	jxaFVwvhsczJefgXdEFTP8stRVSBxiUEjhNM8363tcroZvxkZg7	9232	13042	13042	1618286760000
18331	3NLQPj2bopMTr7dRWBoqDpXQtmbj1pWUoiL4CPnhuB2YgX6e15wa	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1534	1317	315	6301	12463	jxQj7ghG1ceoRXXBgpg61P99rEKWSN7rQHPvbfC2Kmzy5YSiHLZ	9233	13044	13044	1618287120000
18339	3NLHx7Y3Ytzq1PajDhFyzVuo1sXGkgibaJT6Tbnkrz2N3rCmVm1k	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	1523	1321	315	6301	12463	jwZPdDg4vThU5uPF6hwft5oz5qGM8ghCUzEuRszzAod3fUU23gC	9240	13053	13053	1618288740000
18341	3NLVWRgow9C4vPQHj1uiJjvG5V1b3dU1ow4guQVLSnF8sksXWoFw	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	1523	1321	315	6301	12463	jwp2KPgkjbpGU6ohPNmpgizea3NMWcx8P3M9wxs8efVTSN18cbh	9240	13053	13053	1618288740000
18347	3NLqYSb5sHcZZLB3NZyZYxHDSui1f31CTE7gQUbmHbLcGhnEYKS1	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1596	1363	316	6301	12463	jwchES15e9xLosq5MLtLVSTbb5Fc9mtXKmbj28H3LkjEuRTeRdo	9244	13060	13060	1618290000000
18349	3NLMCaJV12eJ77krUrnBxbSAxjBerKjNTVyHVfr9bx82qXyz5rgk	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1523	1195	316	6301	12463	jwAEyR6JYxBsrXzzh24taKcT99N4pwHorKRSMDC4nJokCYtGWoE	9244	13060	13060	1618290000000
18351	3NLxwVegeUCkatcdDhAY8mPdpwfm3XQR2A7fvUSqNwgR4jXqQ3KE	18350	3NKwiJyofBbFJu3RdJooUSUdPx7PbDGf7SHCEPtLo6nexrf6P2Q5	1407	1395	316	6301	12463	jxDKTe5LpygcQV5iN4aYxZDDCx6B16BDo81L7B72j2aG5vrDi8z	9246	13062	13062	1618290360000
18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	18353	3NLDsQSs6QUVK1Jk9euEp6oyMPoynZLBSC875xRXfbiPQkMQC6Qb	1407	1395	316	6301	12463	jxYoWfRqKtvTxXsTnqNbLyv1QTnuzGKxPqvxSYvvRfjeFGd216k	9249	13066	13066	1618291080000
18357	3NLNJJTkYNmtrYtYqPYpVnJZ4K77JZcwaeUpxk272mAvjWDDWjML	18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	311	1061	316	6301	12463	jx6T1Miz4Ck15UZPs2XyNTvJTPvxQ56qsqHdqEtoYHYpqeSVNea	9251	13069	13069	1618291620000
18368	3NLNp9KyYdZUoZGLA9ZcgR2nM32QdvDRPnE2WShTTW6xFEDSbzDM	18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	1599	1041	316	6301	12463	jwex8ez37akB5kPttVRxaEPozFHzocXufNUe4wKAaCuMERhtiG9	9257	13077	13077	1618293060000
18371	3NLF6hzfF1Q6nougErcUviTSm6zFiMBuDMaGCpNKzTiCfcT4SAuz	18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	1522	1076	316	6301	12463	jxLroLUKj6s1d9Jr3ALJFqo2W9nrDJScdzKt5kaG3PWEnxmE4kb	9258	13078	13078	1618293240000
18376	3NLtNTZ6oVKKzniciRUEjFz65SfwftPAXTzN7fDah53431aaN5ZH	18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	1407	1395	316	6301	12463	jwBGhz4eGcvvrwLVg5ywsEzEKQosniAa5q9hAsFG5m1tcx7LVvn	9261	13081	13081	1618293780000
18387	3NLecRTbyuVFGc6qJWC3eCLQQJYVFqTMGEcXBhrbwjBLKbNxNSCC	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1516	1048	317	6301	12463	jwQyh8p5hLaZs9bpgCPS8v5VWXv8dRXJbk2fSQedQzXWttNBnSy	9268	13091	13091	1618295580000
18394	3NKHR5UP6ERWbV5wmENEcQy761DmPYJaPj7JzxgfBVUykf7qr8sB	18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	1403	824	317	6301	12463	jy2nLzPF24PbefRUGjbctParzxxRSh8ubTu2dnpLMnNFuk82Vxx	9270	13093	13093	1618295940000
18396	3NLtJr4H9aNN3tfQcc4K14HMadeuWDKWKdcmDEkr7aTXuZZFawYi	18395	3NLBVdpbTqztbux2aaD2mPyJ7rhBWk3QK1yPR7DT31r4SDZsQxvb	1483	103	317	6301	12463	jxBaSbupmFPtH75EJ2TegGE5NpE76aJdEc5viZdWCP4zGDVWwiC	9272	13095	13095	1618296300000
18399	3NK3moHwqavT8WfPyAuRkGizURgEwgVhLUdT2B8yZE4kuC5LuaT6	18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	1483	1150	317	6301	12463	jwhVXvbxJ1wVA729Xxetm4FaWLhUPefkQGiicBLr2AjMjeJCPst	9275	13099	13099	1618297020000
18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	1522	1196	317	6301	12463	jxH4sZ7aBV6NdU2fGDV3YnzW6nc9UtED4NxZpoWYKoQDFBFmcxZ	9276	13100	13100	1618297200000
18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1608	1289	317	6301	12463	jxW8w4Q5iv5SvY37xuEtFwoacnGNCQAvWgTgeUNT71pt7pLjU8H	9277	13101	13101	1618297380000
18287	3NLSArtsVmSF3BX1XmLxMQNriQw5U8e1SXKbUoe4ZuErv8s52BJt	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	470	1063	314	6301	12463	jxJUknrXFw9b7Xvr9J2LJiLyqFDThWiJgQ5NyedZdoF4fFDhWMi	9214	13017	13017	1618282260000
18292	3NKrQYPmKCMfguEiTmPdH8yan87xmm19FY8ovSzuMdN95MfRJVHy	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1523	1321	314	6301	12463	jwqZisyiNAXrjbCxbkcTxZG82JTfvaRegk6bWiZZxuDA79myqur	9217	13021	13021	1618282980000
18297	3NL3C4K9FT56UYFWdyyugSwdQVejK1hCGQ84QxRR1ZoRai8S9Pbj	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1406	1393	315	6301	12463	jxWhVHLKFkX5aux8rVTexELCHjuooWdPLSPD1ozpE4TJLVGtQ4W	9219	13023	13023	1618283340000
18305	3NKh21qegN5JGTjNo4U6eTy3MzDvmNAManWGHz6EBSoJumgfwsFb	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	599	599	315	6301	12463	jwUvqvxwTKJb4RaCYHLRG1KvT15QHZE23xihZuw7Z75XJyPpqNV	9221	13025	13025	1618283700000
18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	18306	3NKVBdQuxEbexKFFYkXb3BAeX1jKQ3pLqcHLkmLswfSnNuJurhhT	1622	1230	315	6301	12463	jwFHTyVYoGGX2hepFVhohBBGPxtmU1fMbag5qZn99q2etxcewby	9222	13026	13026	1618283880000
18318	3NK4JZUmLLN3CrHeaT3NqusXksNqDJTBu6gWPNFcAXiSSibHkXQy	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1406	1393	315	6301	12463	jwL5SvJaXCerUZDeq2cTZkgsJCJuPfVXLWks2hYzTWuMgqmSKzF	9227	13036	13036	1618285680000
18322	3NLSm9sBkJZSx3qiE54bkQFDVHYKXTZfX7iBsEVT7uFZCkgoUa3D	18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	1581	778	315	6301	12463	jwZexWA4fRvC61Vqji3KKtGNzqdKQmkYcS3W79mRbrzpRpG1Vih	9228	13037	13037	1618285860000
18328	3NLpkbqRAZ5ks67XYscE7ZvQbQKXyoh7gbYiv4PaLoVNQ165hAVD	18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	1406	1393	315	6301	12463	jwSxpkENVDPnYra3ZfDp1eBSBow5YrJyCZ9xyEFkBpxaq4xNXRE	9232	13042	13042	1618286760000
18332	3NL8Q93d438Ye4nijwahjAvaCQYqxAzcTygkei2StEcW7kJwJdnq	18331	3NLQPj2bopMTr7dRWBoqDpXQtmbj1pWUoiL4CPnhuB2YgX6e15wa	1623	839	315	6301	12463	jxWKHF4DHJkupu9iUVsCbde7zQLNF7HdEE4ZZUEVbD76Yv2Af9e	9234	13045	13045	1618287300000
18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	18334	3NKU4sgrhAYnvyGL21cDPuQV3KUJSHCaxCihK6ZbrsqN4kLTrtQS	1403	812	315	6301	12463	jwgSoCmErgAZMM7LY6axW8icaT9SbTyU9E6itg2DGQtAawdLPC2	9237	13049	13049	1618288020000
18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	18344	3NLTDovKuYqdhtaQdpiKu6AbDjTkJQ3LWVX3zqvZbtaQzv2rovLZ	1406	1393	316	6301	12463	jxC2dJgM1xSiJz3KqQ1misnSKTmjo2iZ31M6NCrH4Fmgn1s7FpM	9243	13057	13057	1618289460000
18350	3NKwiJyofBbFJu3RdJooUSUdPx7PbDGf7SHCEPtLo6nexrf6P2Q5	18348	3NKrPGwtRCcfBvWXYXip3kkFRh7UYoimaGBGRoqnFMByrQjFK3tt	1447	1219	316	6301	12463	jxoa2QJJETUP9ArVfEjRHLYuVZyvxePysRfpxsZzS3t1YhNr5u7	9245	13061	13061	1618290180000
18353	3NLDsQSs6QUVK1Jk9euEp6oyMPoynZLBSC875xRXfbiPQkMQC6Qb	18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	1673	1368	316	6301	12463	jwqpV8fxdWStv9t3pij9iNDX2d5mptfWfA4uk8fGAu9PLXTyqSQ	9248	13065	13065	1618290900000
18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	18357	3NLNJJTkYNmtrYtYqPYpVnJZ4K77JZcwaeUpxk272mAvjWDDWjML	1593	1100	316	6301	12463	jwRPuVUxB4p8fQxNqvp15gmJsp3nh9ks8C5AsvxJ531qzyQVyL2	9252	13070	13070	1618291800000
18365	3NLkfFEv4d3LB4AuGiHcRhsm8dfPMY6tznqXbTH4BkqNPECVZsjm	18363	3NLW6mzQrBUonvRJnMfRZZCgb7oCEFiTmgHuR84QM1xz2fEkpsa4	1406	1393	316	6301	12463	jxDK6ZdKFHXJs17VJSAaNRLYa2PStwbaCfP58vob9UB1hdyvTr5	9255	13074	13074	1618292520000
18367	3NKaNrzQ5rp1wde4kthnkwDDqk15eMYPtxosuZqEENRmUeV5UBNS	18126	3NKLbGi6j8gkagt9Bb2PFKrr4b1ZuT4sNmtjSEkYmhnUCuRKG2z6	1555	1101	310	6301	12463	jw9HpdUTpB9WGyVwuUYoqXCiPmYtHAtRR8bc2esvPfNtLzVKQcV	9112	13076	13076	1618292880000
18372	3NKd92PsnRGnTfATo43ZyGyQeQnB1UnhhYKAqSbmXEKGoE4xGana	18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	298	311	316	6301	12463	jwtb86QNgNWZ62DLsxT3UdqJ1rz3WLUb4MfeMtEVszxwk7GNVFf	9258	13078	13078	1618293240000
18375	3NLLb6qiE73VPDACS2GkSMuSWXrL2VJZ6KjJ75H7xEaZZU5eg5cd	18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	632	1136	316	6301	12463	jy1ct5GnPEKMh6bbc2QuRKqQR3hrmW8Sr9TJKRJLFxeT53mW42U	9261	13081	13081	1618293780000
18377	3NKJisvEV62kfqfnB5zJDhJBjoA1EkZQsiuNfFg9aLPwZ8b4AqfH	18376	3NLtNTZ6oVKKzniciRUEjFz65SfwftPAXTzN7fDah53431aaN5ZH	1553	776	316	6301	12463	jxjr4H4CnYXteuoBd4JhvXwRyq3gKDfRMXf7QQsHgJZZEmJrjBX	9262	13082	13082	1618293960000
18380	3NLuz4udmmM3zfsx956MphU5dt1dd6tKqKBp7TEESTzvF3ZteAY1	18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	1406	1393	316	6301	12463	jwHfizuazGLUn8PgptwtpPtuiGJso5CN6MjcxVrnvSPGsgMMmHP	9264	13085	13085	1618294500000
18385	3NKKaQgotDnmhYX7vFWSeAZ4mvWvZqJiioPtKZL1b7weLKJ8s4oq	18383	3NLfY1fhegkFNHhPBHnig1xUz9U4Nc56bqMfkgZwmVq1Wq7FF8EP	1596	1237	317	6301	12463	jx8Vi4uo4c5jDMnQz6D9jHGsLJUqVpdnBXLAboNmLzRP1jVTbFj	9266	13088	13088	1618295040000
18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1406	1393	317	6301	12463	jwEPokZMmgtTSV7SpEV9HPw64wEamqaVu7uS7DoLZTgmR6coj1y	9268	13091	13091	1618295580000
18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	44	1325	317	6301	12463	jwGCkmsg1zwSfiTGJaieMuJc3VD8q9Rv1CsKRNT9PWiRs2gRd5u	9269	13092	13092	1618295760000
18397	3NKiVYCs2qwacc4RqEyfvUbw1Wi2MEA1fk57YHtcBkzQWrtE1PMq	18396	3NLtJr4H9aNN3tfQcc4K14HMadeuWDKWKdcmDEkr7aTXuZZFawYi	415	415	317	6301	12463	jwLu4K3EgMEFArV99GSzaU8jLh2J31pB6rBsoTjcsxu6T7RifD1	9273	13096	13096	1618296480000
18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	1651	1175	317	6301	12463	jxsv9saWqkE2hieaKFYEqfCyAA5LDgvk8oBrqu8SERuuR8JTMYk	9275	13099	13099	1618297020000
18403	3NLmRMLN235pBiJhbJ77NQoU2rgReo7fwhJFaA8mTTW4x4Sztvbm	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1471	1260	317	6301	12463	jwZCyqF6QraoC9rPpgKZXmPSXDrafQ8whSPxokBCpWb1Y7SzDmw	9277	13101	13101	1618297380000
18405	3NK7AAnC1ArfFiPQBBnNwC8unD86cbF3M3EJcNaWfhLviQt4BGcH	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1405	873	317	6301	12463	jy1uKn4ChbfF5mhSNkguZAqdYGGZPjLgyv8eoGKixQnaQvcrpxD	9278	13103	13103	1618297740000
18407	3NK6t1fARPhz2quTd3M3YWNZWXSfYJ6rnA2MoovA9CRwBCn5Y8c6	18405	3NK7AAnC1ArfFiPQBBnNwC8unD86cbF3M3EJcNaWfhLviQt4BGcH	1573	1072	317	6301	12463	jwBhNHCqX7Rbbdin2obsmRYUR75ymCqdAs2kFiZWNX2NoD8b4Xb	9279	13104	13104	1618297920000
18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	18409	3NLjnHPH2YorrWgaQ6SVvBixdv55n6at6wA1D9gmamhz64WHMNnq	1407	1395	317	6301	12463	jxwnp8GYvKuidxStKfEMThPTRddVoVKkzE8oXvdQfDis73rXJWQ	9282	13107	13107	1618298460000
18415	3NLK58snnqLwEVeXBtc2LzFjyfQ13GmBv1J3LjwfW9iHp8asEZ6u	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	606	1049	317	6301	12463	jy1NxpkW3eRq6aMYQeGGLJNEBtLDYy5N8ezfCLiyMyfjQXdmNfj	9284	13111	13111	1618299180000
18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	18415	3NLK58snnqLwEVeXBtc2LzFjyfQ13GmBv1J3LjwfW9iHp8asEZ6u	1406	1393	317	6301	12463	jwtrjUfnDRsPPPJLPJDFQx2LTiCAYdkx7SkZ7Nvj9W7guHYhnYA	9285	13112	13112	1618299360000
18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	1675	976	317	6301	12463	jwsHnzUaXey5ZKdsqVA3fftXrZmWm2KniVkQqbKqnkfEiFrgovu	9286	13113	13113	1618299540000
18300	3NKhqdMcy8a3JuidNSso5w57WTYP5ZHRqkWwW2sWJHiKxuELByTF	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1546	973	315	6301	12463	jxPCPZJZtK3D87xbzYVBpd4NPiPZErQt9wrAqRELBjEudXFrbPa	9219	13023	13023	1618283340000
18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1426	1238	315	6301	12463	jxC4TiuftV8GvAu7inx3chDrNcvWsqE7gATutkGTgphSAakPkyH	9220	13024	13024	1618283520000
18308	3NL8Y3Drqf5PUMt72umq4M2CXcHD9UbpXry6gJHB5BJaXX28gAfx	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	1403	824	315	6301	12463	jwxC3xyj3NiJ7YnyH5hQ4CLsocBmLrr2q9xeDrN6sV882wkGngv	9223	13031	13031	1618284780000
18310	3NKGPp7d2SwURujAWYgSFfS6AXVwmnf2A3DXV6YtLyB6DPXxJoDV	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	1634	1085	315	6301	12463	jxrvors5HybESoS5PyDMEFZcD8Dyc4UJFqpvyJ2Bzy3eNhBbeme	9223	13031	13031	1618284780000
18313	3NLSAvyq8vvSGugBoJLWMqmzuJ3RYPcQmgiJsGkXfQyuLAW62ASa	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1541	1298	315	6301	12463	jwsvRwcx8MtmoWtN8XrBSfXAaYguT8rj2QfoEGS4oRZc1ov2FHh	9225	13033	13033	1618285140000
18315	3NLsTfHrZxn3CMV4MAvmY8JTsPjmEsNM2uWvjLipPLNx9oWzVENU	18284	3NKUoG4xZWyd1ivVwBwguB7HbMKThabZXaFCZuzjSmh2jpxM784k	1654	1340	314	6301	12463	jxZNEET7iwcNEbDSmXmkc7JrTnbqSWfdEobWom1V18mnsnMr9vT	9188	13033	13033	1618285140000
18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	18314	3NL1xKVEZheGjFbCiTUf3VQJ7yJep14VJvcBUX3w5BZopNjdCPyd	1642	1001	315	6301	12463	jy3M1JcyEzpSWCE6i74sR39Mz2oU7saozjrLKwovKwFiu5Xesw8	9226	13035	13035	1618285500000
18321	3NL3RCnc3cHdSr4vHhEX325VetwACsC2v84ZjSY1iZuUgvVVSKCo	18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	1671	1119	315	6301	12463	jx2bGUCVEJEKmLo78wFQ9SLciv61tgYK6Z8SXUNKdrYyKuW9Mgs	9228	13037	13037	1618285860000
18323	3NLkSZVkcTGUcNXoVENPRxw1rArfZwjkEwUAB8nUBNjFvvsGVUer	18322	3NLSm9sBkJZSx3qiE54bkQFDVHYKXTZfX7iBsEVT7uFZCkgoUa3D	1577	1327	315	6301	12463	jxUJk15DhxFaKbXXT1J3bjnKabf5NNhMaXoDUoHsuStj3sUoRiH	9229	13038	13038	1618286040000
18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1440	1377	315	6301	12463	jxi6NAE8LMtP446av1ZQ7c5nfNaXDMrbm9ip3mD8odZpHwrF5pX	9231	13040	13040	1618286400000
18330	3NLDtJ2kV8xFEgpwK5LnF6yeTo7FKCGk6YH6Mknx5sgKym3VApDL	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1406	1393	315	6301	12463	jxhJejf1MJgVdnRYt4zufx83r2AXug91eEHNHvw1Qqnh5v8DAj7	9233	13044	13044	1618287120000
18333	3NKLiPfDGjgRxkjR8gfN7d3zCmucy9PkC4XJeUVptwhFw67aTUrJ	18332	3NL8Q93d438Ye4nijwahjAvaCQYqxAzcTygkei2StEcW7kJwJdnq	1426	998	315	6301	12463	jxMGttWmwXmmFboJkJhA9f5eCkH4LS7cA5P9PNmkfBAAvM9urz9	9235	13047	13047	1618287660000
18336	3NK52DRJpdYyHGp1zwZnczvPwDGMN5qhz3UQN9qYrzCj1Xe4FtTY	18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	1407	1395	315	6301	12463	jxuRGzF8FPi9rp6yfCNP4iE93UcA4ftZo4A1YK9gWF69qJHiV5W	9238	13051	13051	1618288380000
18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	18336	3NK52DRJpdYyHGp1zwZnczvPwDGMN5qhz3UQN9qYrzCj1Xe4FtTY	1402	850	315	6301	12463	jx7GbEDVpCrYiU3UE69LpwkVNs7CVZJ8zYcNzn9TjD8EUmEnrHx	9239	13052	13052	1618288560000
18343	3NKayRweYAr7HiFZ86RqxJbQY6pu6y39KCviSzkSdy2irJNeqBxw	18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	1483	84	316	6301	12463	jxawxA4WQQ6XgY8FHbQA238uaMtd2EovFf6SvcLN3VHCb19tNn6	9242	13056	13056	1618289280000
18346	3NKoehvQUQj3b8Kg6BfFSVsXUqC4YFy9s9iYbbKzBiLHZ8gntr9d	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1523	1195	316	6301	12463	jxtumarqidxe73dFUxpJCZUppmRSFzQ1re9A7xxcRxH2FeHswtd	9244	13060	13060	1618290000000
18348	3NKrPGwtRCcfBvWXYXip3kkFRh7UYoimaGBGRoqnFMByrQjFK3tt	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1627	1385	316	6301	12463	jwc1j56895qXsoBjq2t3CeuPbYANizKeonzXNriqq6fVaSBr93J	9244	13060	13060	1618290000000
18356	3NKVKJK3RPKN28bTVzavkcXS5bj8vjghjoPj4n2KLmevsbTb8Jho	18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	152	1330	316	6301	12463	jwUPa7CnXf9PgPsdLsXGayWFTK2dTLkmJfGbF63XzYgHAoKUJVc	9250	13067	13067	1618291260000
18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1542	1304	316	6301	12463	jwkEbEJnhD6cRbiSgRQBTvcvfccjdhShR5ZwJLTpG7kRY1BE7MF	9253	13071	13071	1618291980000
18361	3NKRdpaooLTkRsmEd2fpRqHvksXZweYjAQsdU9SJMtXXFedgyN7h	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1448	1311	316	6301	12463	jw9NJ3k1vZDHy75ggeRD6x4yF4px7mNqA7Yf8Di2ExiLbQc87gx	9253	13071	13071	1618291980000
18363	3NLW6mzQrBUonvRJnMfRZZCgb7oCEFiTmgHuR84QM1xz2fEkpsa4	18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	298	1182	316	6301	12463	jwRJTgUjEzYvsaerJ6EUhRApCNbNk3qDxMWdQrdcfFd8uwinTyU	9254	13072	13072	1618292160000
18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	18365	3NLkfFEv4d3LB4AuGiHcRhsm8dfPMY6tznqXbTH4BkqNPECVZsjm	1577	961	316	6301	12463	jwxZtvk2dgrwkF816t4Tz4yTDSLXRpauWxs5wsN9mrmXiEqnWpu	9256	13075	13075	1618292700000
18370	3NKX9cTRKHECTzDKXCTrWczBZELeW4zUrfuDfe3eyfDeNErfHTkn	18250	3NLV8UgYZbHmQNn5QjWCs61dXDqXMmbqPsJ63ziYVRRDxRLCcqkU	1599	1041	313	6301	12463	jwkn381q5vLPUoATVdSnHFP1JXgwyA6i5oNK8W97YM24NSMNhWC	9186	13077	13077	1618293060000
18373	3NLiNNDxnphGoP9iDqfaF2Gs38VSjx6LQLUajSHbg9m8XczA4BSj	18371	3NLF6hzfF1Q6nougErcUviTSm6zFiMBuDMaGCpNKzTiCfcT4SAuz	1406	1393	316	6301	12463	jx3uFsB1pLXWn9fCruWhELRqeypF53qoHnUqRnFLVPBJDPpyZBQ	9259	13079	13079	1618293420000
18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	18377	3NKJisvEV62kfqfnB5zJDhJBjoA1EkZQsiuNfFg9aLPwZ8b4AqfH	1406	1393	316	6301	12463	jwVnJdsfLtjvHAkzKUjW51A4jgkZJA1ahVVMeCK6SRTiRTyw9gw	9263	13083	13083	1618294140000
18381	3NLFJE7yzGM2qQMaLjMmScnEfQwyZuWgRQH6fYb9omjepwLT3o9p	18370	3NKX9cTRKHECTzDKXCTrWczBZELeW4zUrfuDfe3eyfDeNErfHTkn	1599	1161	314	6301	12463	jxWLmXskrUYnQ6FpGzmDyyjfZN6rBoEvi7mHpKb95XSCwZYpgyx	9187	13085	13085	1618294500000
18383	3NLfY1fhegkFNHhPBHnig1xUz9U4Nc56bqMfkgZwmVq1Wq7FF8EP	18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	1508	1387	317	6301	12463	jwi2XSo57mhKmYgvvNQg7tWEvqyWuzmatQwaULdfMrydcaCGQHy	9265	13087	13087	1618294860000
18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	18385	3NKKaQgotDnmhYX7vFWSeAZ4mvWvZqJiioPtKZL1b7weLKJ8s4oq	1406	1393	317	6301	12463	jx2sLbWg6CmQqCgEBqCVraxJmXu89HQTZ4493Jk9n4j7ab62ozA	9267	13090	13090	1618295400000
18389	3NLhqCHNkK8tV9bGPatGD4BCvvhk4TYgPSEBfKkNxTx83EQFUvNr	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1440	1251	317	6301	12463	jx3ATyrQCq1gENCyTBJhFFvAmertbJZRq8dN3Njg7AJtAUrNPK2	9268	13091	13091	1618295580000
18391	3NLoEuYMQXJSunYRgTNH4L1qngMVMyV6o6EBbZEQ2C6dWwZEEDy2	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	1407	1395	317	6301	12463	jxjweq9rG8H19pQdZ3rHzgssLknzRteuLEs7eHd2fdzBQRrbYQY	9269	13092	13092	1618295760000
18393	3NL747zhAWNAEK7wpiRU1bSz8MTKyU1HtscqbuysTZJe1tU6viXo	18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	1542	1058	317	6301	12463	jwnyA69EqHUtAEnoLZDi8E9TFxaqJh27tL5Umw34WewzfQdJx23	9270	13093	13093	1618295940000
18395	3NLBVdpbTqztbux2aaD2mPyJ7rhBWk3QK1yPR7DT31r4SDZsQxvb	18393	3NL747zhAWNAEK7wpiRU1bSz8MTKyU1HtscqbuysTZJe1tU6viXo	1451	1046	317	6301	12463	jxxBPb82roteGPiCmfk6wZ86jpGRbMQQyeBCmrFE1y8WGKYE15Z	9271	13094	13094	1618296120000
18309	3NL5VuuAZWBQexxi29pwXFDejHxJdYYgWRDowtY5L8YHGYDtFc1i	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	149	1283	315	6301	12463	jwxfZuP5A2U5VdLtPCzhznonc9J8QmNALG2CiLi7QvkEhaPhoHr	9223	13031	13031	1618284780000
18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	18310	3NKGPp7d2SwURujAWYgSFfS6AXVwmnf2A3DXV6YtLyB6DPXxJoDV	1602	1243	315	6301	12463	jw6duBcwW149aGj3pqMzahBHRkVgQVE4pCmgQ2fhSKq3ZUiAJPz	9224	13032	13032	1618284960000
18314	3NL1xKVEZheGjFbCiTUf3VQJ7yJep14VJvcBUX3w5BZopNjdCPyd	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1654	1340	315	6301	12463	jwjyRFRhWVkY5W8kxVzx1LncGBpmWduqDzrG7qu46aXNyWbEBGM	9225	13033	13033	1618285140000
18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1651	1055	315	6301	12463	jxfAkzeH9hMdxS1NhqC835EP8WhQCZGEhGZ36NhC6zKLWk723K8	9227	13036	13036	1618285680000
18326	3NLxJdgQGv78Jk9EdK24ru2ykASHboYJGB4d68tULr7PiiypjKd5	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1440	1377	315	6301	12463	jy2kZUXPzHD5eKkpiV66faqtsfu2fniaARsSVHMXAv7TuaQmLFJ	9231	13040	13040	1618286400000
18327	3NKDMkvS9oBdoYv3wCK9NTpL1Nb4tVYDiPm4hb4YQfvzGFXJzqff	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1578	1296	315	6301	12463	jxvZZJQ4iLgMV6jwcCkjEfYeB7av3a2xHyjHUgYapKaW95xvdfM	9231	13040	13040	1618286400000
18334	3NKU4sgrhAYnvyGL21cDPuQV3KUJSHCaxCihK6ZbrsqN4kLTrtQS	18333	3NKLiPfDGjgRxkjR8gfN7d3zCmucy9PkC4XJeUVptwhFw67aTUrJ	1403	824	315	6301	12463	jwfTKnVbgb1UXawfiyiYH7KL54CvMdxHLUH3z18CrLbHwjFa9dS	9236	13048	13048	1618287840000
18337	3NKkaG9krASvv2cZNPA6oFWGpDiuUsbZoVtksGkG4L5JyJtm6Kbq	18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	1581	778	315	6301	12463	jx4hBwH2v5PxYW1b2YG6xoY9frqQiAgPnqkAdtbnXZbYno85yqq	9238	13051	13051	1618288380000
18340	3NKiETA7h3sKKByUPoUX7seejYDhLEsHxe8V1RsnBe87zGEngcCs	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	606	1049	315	6301	12463	jwMDeugWAvEeSZxDGB3wdBxVPhHuNMNMWfa9qP31QEeQzUFTWtr	9240	13053	13053	1618288740000
18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	18339	3NLHx7Y3Ytzq1PajDhFyzVuo1sXGkgibaJT6Tbnkrz2N3rCmVm1k	1600	1126	315	6301	12463	jx4guwgVK1G1xBabDLUXZQvL4bVaJdgkt5P4QXxRMNXwhn3Biud	9241	13055	13055	1618289100000
18344	3NLTDovKuYqdhtaQdpiKu6AbDjTkJQ3LWVX3zqvZbtaQzv2rovLZ	18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	1483	84	316	6301	12463	jx5devpBrPbgn5hYhUcgaKyu6HzEzJbkkEPZrEPSmhGA3NbEbwk	9242	13056	13056	1618289280000
18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	18351	3NLxwVegeUCkatcdDhAY8mPdpwfm3XQR2A7fvUSqNwgR4jXqQ3KE	1476	1245	316	6301	12463	jxtMxKy7vRCuQCvAJcKbPW3b9efFhhXgriYXceuDHCUtMDLWMTR	9247	13064	13064	1618290720000
18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	1425	184	316	6301	12463	jxXjiyE5XFNHpKpJtvZERDmLExwssBfA5XdUBEbcnrwPK8YCB24	9250	13067	13067	1618291260000
18360	3NLaCnX6JJP3rXy7BFYf5YoLor494kz4SqYaEg4FiKahCvxDZEkc	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1587	1357	316	6301	12463	jwD78t4DM5HzBh5P16utrC4j7vPPWtoSGtGjpCWDXZFSAbdgM7y	9253	13071	13071	1618291980000
18362	3NLf5DwkNzyXkzKMSNoCUaRzdEsaDuej34ApSz5e5td7CJpjjgj9	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1448	1311	316	6301	12463	jxaWgYEqzPGt7BcqdryQV7BgFTWqmAR1bQGSv2RnbnzcR5obfQD	9253	13071	13071	1618291980000
18364	3NKzgbui7Ea9hQguzekHQFtK1ifkN1AjJ4LQ97EkS3sx8ug8GMAC	18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	1637	816	316	6301	12463	jxqnH2yQqKpfWSrcpgzxm85u1NGk1tABWUvGeTbMVeC6ziYsBvh	9254	13072	13072	1618292160000
18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	532	1303	316	6301	12463	jxwD4CFdJWtiDtSTDorv1RbSkMfo6kjcNnh5vwWiywEEudGF1cy	9257	13077	13077	1618293060000
18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	18373	3NLiNNDxnphGoP9iDqfaF2Gs38VSjx6LQLUajSHbg9m8XczA4BSj	1406	1393	316	6301	12463	jwN67DpMvqK9QUdM9waQNLWoZm8su1Er27KTue7F6ucKizhzvqk	9260	13080	13080	1618293600000
18379	3NKfMQgNE71K8FMVSzPbjBNpgZXgsk91cJZzKhgf6jCnJxJ4F46N	18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	1633	1264	316	6301	12463	jxjNqWCUHApEJwwEYXbg8Mqz6KaDrLh2VK73CQUkFWEg6qaYnvr	9251	13083	13083	1618294140000
18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	1599	1161	316	6301	12463	jwTTH25N7AsMmoyBThX5wL6EHTcz7gfdCSwmsm9x9tXERJMLeN2	9264	13085	13085	1618294500000
18384	3NL815yzdH8CUBw3aswhRoLZLLRSqaUur4W9V1EsXMK16TgboVm4	18222	3NKmGxjfmntdkF8VFhZTx4uZFnvmszwPZwBr7psQGCMScsM9nbkH	1481	790	304	6301	12463	jx9fseydvrsaMEs5QAbSkzTsgFM8Ee8G3JZqSjwTRYTjdkbJ5aP	9001	13088	13088	1618295040000
18392	3NLXNS4gy5FB9rwkpkjqXQzoqVDn3Vv8251Jx1XqRdo7ACWxgpdh	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	1573	1072	317	6301	12463	jwzs5aB88Kfmu7MbfdgKVQ9YZFuJivbXRt67rbsDmDhMZQDg6xB	9269	13092	13092	1618295760000
18402	3NLQKSBAoiTUsqAcaiGuiuNc4QVryAsvQoiRKRHfvCSsAGua2GCz	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1406	1393	317	6301	12463	jwrohst3fpqUuCz2LW4Wj2Agb7fJN8gCMpUkHDYeeUv4mMwVy6i	9277	13101	13101	1618297380000
18409	3NLjnHPH2YorrWgaQ6SVvBixdv55n6at6wA1D9gmamhz64WHMNnq	18408	3NLidNYydWeihP8ZVBwbLqTnhhXb5pPuqiYoHPEXYNreTJcz6ZTy	1440	1377	317	6301	12463	jwn2cL4AEuydNM3oFKppAiQZeCCeZyMHfQjYMitf6vuwFjJayZi	9281	13106	13106	1618298280000
18412	3NKfUp9fcfqQh7Uzj6q32GVycABFUrdEhon44q1mKc2mwmv4XNvC	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1448	1185	317	6301	12463	jwvZMjtNhX4oSCHFoadJZ3TgdLisLpWrteXuoYGzSvj4EmyYXNR	9283	13108	13108	1618298640000
18419	3NKZhVCBeGPCe61JE1kfHFimD7VPDDPhzq3Rd734PbCP5BPnj98k	18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	576	1355	317	6301	12463	jxZ8XRbZ3dQtvEeeFR8kqRtCGag3E4g7njHeWdyc9P3xztaPKUW	9286	13113	13113	1618299540000
18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	1529	1316	317	6301	12463	jx3NJqaHKkSicQXB4DMKLdkh2QEMcYnhQs3vvQ26CCRfnDPRHVK	9287	13114	13114	1618299720000
18424	3NKT7tHLyt3WXFiVeevuoj76VUcg1TUxjx7DSuDa7yjWVdUHNqth	18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	1477	984	317	6301	12463	jxxse8pfUdGFF3UuqXSbtLgCT4KjDMc5MycLxCvwBQRSisAdQw6	9288	13115	13115	1618299900000
18426	3NKTn8sTjTN2aHAMH4cCVbEUchPCP7AbxsFZ5FHcT1tWs2U6BQfq	18425	3NKpF8HxByQiHnrUjpPpPtjRW12mTqgsq6bkKJa8haruXZ5vfWiT	1406	1393	318	6301	12463	jweoQ18ASFpteTMQQmEwqkwkDdn1ZcTKb8DekwxE7yU6tLu7iB6	9290	13117	13117	1618300260000
18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	18426	3NKTn8sTjTN2aHAMH4cCVbEUchPCP7AbxsFZ5FHcT1tWs2U6BQfq	563	1359	318	6301	12463	jxCdX7JTV1DYTBzvN6gRKxKsXTDv1BNdN6wv6u6gGiJtBbswH9p	9291	13118	13118	1618300440000
18431	3NLpgCt7mroPDaAU4TKZq3kKnyHLxbFngneZN1XFZfqTthfpCB75	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1403	786	318	6301	12463	jwqMEfWS2e1AQzrqXacj83QGyiJC7wW9TGAVdR7SAUDmUioNX8w	9293	13121	13121	1618300980000
18435	3NLenX4YgydNwCaJPhBPyFhV4cQFYTEtS9WP8789C9Df3E13hFrV	18153	3NKokvEp5kXMEYvDk3sYx8sf222BrBoAHGogRtzXiprMfKpxmyob	1419	814	311	6301	12463	jwi8pY5fBxTPHg1Ggq9oPZWTA7JSJWcQDaGT6mRufaizufAfd3z	9119	13121	13121	1618300980000
18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	18397	3NKiVYCs2qwacc4RqEyfvUbw1Wi2MEA1fk57YHtcBkzQWrtE1PMq	1471	1260	317	6301	12463	jxN7KmE2TXyK1S5Pq1yFWAhqDyodWaqqKhCFfCH7bVRWnorhE61	9274	13097	13097	1618296660000
18406	3NL3ub3wb2o66zipoZz6sjcsSgBnTym4ycdagdjkLFZVxFwXJft8	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1406	1393	317	6301	12463	jwGQrjW6yk7CTUNbJRuCUF2rAp4ky46X6xHNW4CCvRndnMijoDe	9278	13103	13103	1618297740000
18408	3NLidNYydWeihP8ZVBwbLqTnhhXb5pPuqiYoHPEXYNreTJcz6ZTy	18407	3NK6t1fARPhz2quTd3M3YWNZWXSfYJ6rnA2MoovA9CRwBCn5Y8c6	1489	1134	317	6301	12463	jwJj29eNyJw4cTNHr7cyuvWkEApVWGkXSKmJyBQa6PwdMdVGhBB	9280	13105	13105	1618298100000
18418	3NKs4wNXrFxpiYnppXSZdkLByq9zErHbvQaDPSouMzzCyJSVgTDT	18391	3NLoEuYMQXJSunYRgTNH4L1qngMVMyV6o6EBbZEQ2C6dWwZEEDy2	1675	976	317	6301	12463	jx582NUPvp67nrKPWQ4SdqmhNZNhQbwh6zh1QY7p5ePVDYzdfTH	9270	13113	13113	1618299540000
18422	3NKZMsXD6yPyiXd544Zmjtw5xP6QdrGQQz2RH2hMagkj119e48iW	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1529	1316	317	6301	12463	jxJAeMcVVBZv87qdJQLN72dQCmhNGfuziA9ioa7dYcKteMDur4g	9278	13114	13114	1618299720000
18427	3NLLG1dvgjzXp2VetZVaG6wkasiu1pTxiGATKA7hLdueFaTxqQ2j	18399	3NK3moHwqavT8WfPyAuRkGizURgEwgVhLUdT2B8yZE4kuC5LuaT6	563	1359	317	6301	12463	jxEHGwzC3X88AeKp9emP61jURQjZR83maurw9tkB1sfmzSQnFLo	9276	13118	13118	1618300440000
18432	3NKoehQGQEdTStyoGnxhYssPZiJgWPsp44XbNRAnLbVia589ru6G	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1549	1236	318	6301	12463	jxR8LE3MGjsLu2J51xErQVD4fyTho937AQxQT51ExNL4jhYEdCX	9293	13121	13121	1618300980000
18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1419	814	318	6301	12463	jxKzzHdZVMfSaPxaExQqyfXVa771Lf3MCQ4SFNUdVStRihbYQK9	9293	13121	13121	1618300980000
18445	3NKDHmD4RJZ7i3L28gNCrGhmTPg159wYzw6hEgarbX2Wg187mSUR	18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	1397	828	318	6301	12463	jxH52utXCAG4PVHYjmhrmVgLYV366dDXVYqr43J9Q89UWsCwtxh	9298	13127	13127	1618302060000
18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1406	1393	318	6301	12463	jxV9CYjPvh3Y92medr4w1jQUuVhcHNuoU9ap3wM4SCpKW2i3wnB	9299	13128	13128	1618302240000
18449	3NL28wUZF5tEYkXuDT7VoRtbmvW2FcwMTeYgiPHJBZsftJ5Ldr7D	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1651	1055	318	6301	12463	jwjUDyCAqeyjmhDosDUR5qUHhHWa4M9vQTV2Y9B2XUfGLcKnRZ1	9299	13128	13128	1618302240000
18456	3NL24BHS8yt7hdSMNHtz3KN5PcHDsto7oJwinxsCzyn4G513Uxrb	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1541	1172	318	6301	12463	jxPk9CHdBu3AR61LUrZ9mh915AnMv8LJxnvooSVW6tvPc8ax9wQ	9302	13131	13131	1618302780000
18458	3NLYGDWjWSkJqhpqjo789xYrzG8rtyHgEBNcbLDmryHhBge96npG	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1407	1395	318	6301	12463	jwUc5skS9kSU11noqv2NnCfrWB2AT3B6p6F9yXBLikiKyogwqQ9	9302	13131	13131	1618302780000
18461	3NKvakwiXgoV2ExuhEhJcpUP5GTT3CQPvpaCKLjqrK5tRXmoVuxf	18223	3NLXdE19xMbnyE3DcZEpYNSpB59xEVgyYnrkPUf7da7xsSrxcPhe	1560	1045	310	6301	12463	jwT4syKDsUveN55VJBgJ5kp1x5K6nYugKVooidiM6gMzXYFByUw	9130	13131	13131	1618302780000
18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	632	1136	318	6301	12463	jxf5nmTa5T93mFLbdiPuysdrMpseNWCaPBgWVrdEdR862mY8p4Q	9304	13133	13133	1618303140000
18466	3NKsVsuryixvNfq32KyCVWVAukkQgLPgGEUDcoFi6ER5N2YxathH	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1637	816	318	6301	12463	jwvEEo4mrAAx8wnPCxNrDxQN2CnWNnBTH3b4k8RZ2rMyWKTHYjR	9304	13133	13133	1618303140000
18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1631	794	318	6301	12463	jxSSmu6MnSdczZHmjHSQ2Qwd89CGeD4P9z81YBbSMqCyo1YMbLt	9307	13139	13139	1618304220000
18476	3NLEPKntrqP4eA89W4uUarSkWVDamQsM8mPG6kgpnegWF5Xca7Ja	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1627	1259	318	6301	12463	jxPA4f5mqEs7TY6D8o2NBy7ieyLynP4Qo6LMM7gKpv8puu1qZ68	9308	13141	13141	1618304580000
18480	3NKdeTHKu44w3deqqzoz57MEQwPsm92kYUkvQX14LhSq93MwwTbH	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	532	937	318	6301	12463	jwJgQTyeekhd7maFdDhnYnTgonc5PyejJwrXV2B63pB2dWBi3BV	9308	13141	13141	1618304580000
18483	3NL6wbBSNrVjiFi8jYyzX7Ewc9JAsWaeX1NzQE1RNjSysPLbH5wE	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1527	1293	318	6301	12463	jweeeJdbV85u5x11C2S6mk8SVyHp1PW9s5NdDzU3kp1WCk1oA3p	9308	13141	13141	1618304580000
18488	3NKbrDc2cExcJGHSwCh5BsxvD9XufvFEXytT6HMQ9MYbZanixVN3	18485	3NKEYKzvqoaNTLFN2if98t3orHbtVCjZCc3N676dakiBSEV8JF3x	1650	1129	319	6301	12463	jwG4c8SNn6SinhFzSiDAx71AdtBDomNEdu5MesvsQXHSeQjVQzM	9311	13148	13148	1618305840000
18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	1656	1217	319	6301	12463	jx1gxJvYi8SJqoc6szcu3yqc4vcviQfvhDHH3iT7SvX1FMohvzB	9314	13151	13151	1618306380000
18500	3NLYCpRs8GxEG6uijAsdvPmeM2vKZCi45fDBGDVa7MKvPCGQThPC	18227	3NKHVam4LGvusWU4yr2VFhJAxLQRgr236yR3mY1MGpJhSpNf7sgm	1503	1277	312	6301	12463	jwQrTLSif76u9NsLap6U5Jrjmx6weYKdJXsCCn7raZHwWmsW7Xk	9153	13156	13156	1618307280000
18502	3NK69y3UqMSri6Nh9hJHgjHqLqhpcY9Fe8sio9nabt1MM8D4XEfL	18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	1406	1393	319	6301	12463	jxKjQV189ekY17cyLAhHxWPrw38adGp2UrJ3Aidubp4xRN12BxM	9319	13157	13157	1618307460000
18505	3NK3yzwCxHRxzyakGXCb6Vsnif2M6Y82RAA586YzMzarnk7Jr34e	18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	42	995	319	6301	12463	jwdnT9EueTsZwDqPbVEy39yixek7gNPdNznLA3cPvKpF85KuxPu	9321	13159	13159	1618307820000
18507	3NLbtdksRA6bX8jqXS1E5kFBW68vtcHTyi9DBcchqUYdu9U3giEA	17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	1592	592	306	6301	12463	jx8MAfXPHr5hsRVvuEtpXqtoCEkerthCKzojHp9fgsHEASWpKJX	9037	13161	13161	1618308180000
18509	3NLs67KcWvrRj3bWRFAMbUqDvCUVbnJBN6soH7fcjQy4kxuJ2Pa7	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	369	946	319	6301	12463	jwG3gsCTHZNoR98GgrwL7jdQ2ARH5HVKFVwCwkTnj6g2HZLG2P3	9323	13162	13162	1618308360000
18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	18515	3NLUQQpCuixLgGFKscG1bU5ZzwBDkPrVuFZXJ6FHPNPiquYNnX33	1618	527	319	6301	12463	jxQaKY4w8bZjNx2j7XXhP7u4mWEcY1ii54WNj9NSJBnqyyGJ3CB	9326	13166	13166	1618309080000
18519	3NKbyJ2dzNK8DQGCNbNLnpxSoQssfCJberWFTQEprKtGNwTf2Heg	18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	1675	1096	319	6301	12463	jwrqVKptPtk9fudLXJGyjYYartjHieT7fNKBBU1zBLoZYm8edtF	9327	13167	13167	1618309260000
18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	18522	3NLu3Rf2sN6nM2gVz3VxiMTBhyHT9oV6ZRvJ9eaYbgx3HFRgmoQe	1637	816	320	6301	12463	jwuBPomqZ9SnC8VL78EiRWTkHanmznxc5nJKJZCQMqscmxrNZy2	9330	13170	13170	1618309800000
18528	3NLydiqWHaTMzcvn7dDxjxdiL9kHGAWLjUAwSUTPoWVATQtMiTvM	18527	3NKeUEjo9pxR9Jbee8THi3SkNFW79LPd7YAh98MHqy73R9FyP189	1637	816	320	6301	12463	jxHZR1gNR7onm51BQZkfezd64q3CR8XoyAh8LbBDJZEjKEAGjux	9333	13173	13173	1618310340000
18531	3NK3jkTxuaRpFJfwairSs3mwmPA3Xy8RB45bJ7tNFWPJznhiAUPj	18530	3NL6qKXe2rbUAtSiAU5N2vjjuUHWypHvXF6w3yQSSLYPE4mKPwgJ	1405	851	320	6301	12463	jw6qwTGRKRrCKcX8n1yUHmCCkFoeTLdpHKFThqcs3vUnGg71r79	9336	13177	13177	1618311060000
18411	3NLGbYmiXQVLXvvKn6tXe7hCUnanPvrT1RydgBQqbBaqPiKCRE8B	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1406	1393	317	6301	12463	jxoAXWbLc8QNA1pN6YbTpG2cfSZZpP1GuEGcQa446W317JUL8iS	9283	13108	13108	1618298640000
18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1448	1185	317	6301	12463	jwLPFeyr9uB7X8Dn8ZAt9L9WnDSA1R3fe2uLUUZ32EQsUZTf7oD	9283	13108	13108	1618298640000
18414	3NKWDBxQiHcgfftn2gNK21Abr1BHLXoCisM6QXDPPAJdnYcqWUjx	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	1403	824	317	6301	12463	jxfBCFcJSqtGh535EAFCCihu1WHHq1CgTKH6qwd2YgECARoJcni	9284	13111	13111	1618299180000
18416	3NLvqjsCQQpCk51DPM6omDzVBbje41riyztaZ6zxjV27gLy2EJMF	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	606	1049	317	6301	12463	jwPTr8fiWYT8kZgPiskaY5S9zb4sNvmpYK9uT7KnxhYkztqeFHM	9284	13111	13111	1618299180000
18423	3NLN2vud2vmSbj5CB3yk961mmcZx9N4BVj1VirmUmruTe4punZ3A	18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	1477	984	317	6301	12463	jxxse8pfUdGFF3UuqXSbtLgCT4KjDMc5MycLxCvwBQRSisAdQw6	9288	13115	13115	1618299900000
18425	3NKpF8HxByQiHnrUjpPpPtjRW12mTqgsq6bkKJa8haruXZ5vfWiT	18423	3NLN2vud2vmSbj5CB3yk961mmcZx9N4BVj1VirmUmruTe4punZ3A	1403	824	318	6301	12463	jwuS7iqQ8cf6m4rTKBthFa8VxQJ116xhM1gT23EGrgZaXY7K3uM	9289	13116	13116	1618300080000
18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	1407	1395	318	6301	12463	jxyvxCn7n9F3uezYdnqsDfDWnpQsFrsSNjxs9AN8z3b7oqkdMih	9292	13119	13119	1618300620000
18433	3NLH2eWprHTutKsjbjs5oyvvJfujDsLtuRKs5Gfe559QcsZhoUzd	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1407	1395	318	6301	12463	jxTp7skUcogXp85FU8sVTW4cZqA8JEKQcLpvxS1CSnJHPnFQLmN	9293	13121	13121	1618300980000
18436	3NKDbB9jqBuNa87tYH3sEhw2u7GiJ5SnHRBhG1aUBmGTPsHMcE9P	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1489	1134	318	6301	12463	jxcRrsjnGSxQnUJV48NebyL73uLQPb9uxYAiCYt8SHPEg9LB4CE	9294	13122	13122	1618301160000
18438	3NK8p3AqUguKjvRWuRYHHbSTJPnmVk34w4RXQtrs5nKNhoKMfyXc	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1476	1125	318	6301	12463	jwSKZRaW7whUhqfpkoGMA96Z3unyHtW8Cfy4Tm2cGc1csQ9E9k6	9294	13122	13122	1618301160000
18440	3NLmYjR4q9jC8sGrSft12R2zFoSSZuTnLBpg2HxvzjkQew6PdUiY	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1476	1125	318	6301	12463	jxLvvFAAL8P35rE86r4n6N3ezkHGu93U4rdkmzcfYPznZnzYmPk	9294	13122	13122	1618301160000
18443	3NLFgKgP4n3fA8gJxeytGnVXs76QJbMLfXcxJobwXYVDp1p1bfXE	18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	1548	387	318	6301	12463	jxUcw94WYZsBV2wn1GHhquk9sstQVS21QGzF7ZpXNpvvkZf5T6H	9296	13125	13125	1618301700000
18450	3NKxbzfR6deEYBtT4bjuSGhkduGrW3HPxnFdgaN5y4Cm68tdVVyB	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	684	1106	318	6301	12463	jwKcbkwAZRADfvQABDgL6Lb31KtxHJrhBfGBmojDkrw9TJUmY2B	9300	13129	13129	1618302420000
18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	1405	849	318	6301	12463	jwG8Lh2pXK9w3LQPqMQVpvZRE3Q9c57Ur17rUyeYAy9M4XatJVW	9301	13130	13130	1618302600000
18457	3NLTSBHGrk87GXHKR2BnQ3preRBLc5f77kfeBdSRfkfvU4yhs5jW	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1560	1045	318	6301	12463	jwmBJVNTnKmhjXECD8mr2n2PmyWLqK4yAmNb22NZi9xK5LE4g9H	9302	13131	13131	1618302780000
18465	3NKgPaLKTCKTN3ghA3BQdQV5xTn3vm9uuPDrbratTCbA5qNnBXa1	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1447	1099	318	6301	12463	jxNDMTdX3Pt1GyBdGWPX8m8uMAQ4c2nvQ7bVUL6gaHheJ8XppJ2	9304	13133	13133	1618303140000
18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	18467	3NLjeSik5aD5JT35dd1XqenE5DWYpT5JoseGEWhFSPgZEXrbTKfg	1649	1017	318	6301	12463	jxhr1kRXaw6fDFonVXkoTXw1Z13n6KByYhGVK6V5tQxu6XEwASC	9306	13138	13138	1618304040000
18474	3NKJKBZZdQFE7iTD3kjRezqdwsDWP7bkEb46bXPbJVNVJW1Q1v9d	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1649	1383	318	6301	12463	jwQ8nT6U6e2PQNsF1EAKtyS7sh1Q3qCdPQ5j9uhaZK6nHe5kNmm	9308	13141	13141	1618304580000
18477	3NKaxTN1ZytHHccVxvdBZVHpxWYce2xEUw1CkU5gKpsCLpA8hc29	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1649	1383	318	6301	12463	jxKck7X9s49yMiecGLcq9ULeNFe8ZU2Hw5FFncvAepxFJkxMxCp	9308	13141	13141	1618304580000
18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	18483	3NL6wbBSNrVjiFi8jYyzX7Ewc9JAsWaeX1NzQE1RNjSysPLbH5wE	1633	1144	318	6301	12463	jxuWuTBbP5qExCGmppQ21cVnsRNMyhVzHCmGM1zRBxo5ePyV8cE	9309	13146	13146	1618305480000
18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	18488	3NKbrDc2cExcJGHSwCh5BsxvD9XufvFEXytT6HMQ9MYbZanixVN3	1405	873	319	6301	12463	jxWRnwjodvW1TxjRiyijKQF3K2sCANPsyaJW4kwBjZiJ9NW1VG6	9312	13149	13149	1618306020000
18491	3NKq7YHngAZwhnxSUYD8cBTxsvzF6sZXcDWjRXmADFwCNgx9FHve	18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	263	263	319	6301	12463	jwk5B3kXXweDcUviNeC4dfS1S1G2eKPWr6XvTwaSr7vvBNQUqut	9313	13150	13150	1618306200000
18496	3NK414Uji3w1RkssNXgB9KThLHQWQs7JCUB1T5XPdng8pgcjf7P7	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1637	816	319	6301	12463	jxSASRWKZAaJK6NmR3p2E5veWwjQ2buVzPBvujAboGvQJHuQpvF	9315	13152	13152	1618306560000
18498	3NKu1CUV1vA5h6KXenxtQN5WYdtext4c1gjaUPbAXRnRUbu3oUE5	18497	3NKQjwmz9bLtq3W5xG5NEjJQEPW5qgquCKbhXXckZR96AthWV6xg	1571	1089	319	6301	12463	jwFvh8xxRp1N8bptdufkRoTVJUgGYAjPPZJ9d8eEtivwopu4vtm	9317	13154	13154	1618306920000
18510	3NKpn387mvBd17nJg1fFes5A3mEUMutK8nq6tkfCzNyCt17eo1jH	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	369	946	319	6301	12463	jwhd531UnR6HQuEJbqWWoAHvcsm7TmY3MDDQoAFouMu7n1T6vJm	9323	13162	13162	1618308360000
18512	3NL8sh9QRtkjX9Gth3VWtN7PGMKuq9vsooZywU2sxWMgVZwih1f2	18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	1670	1156	319	6301	12463	jxx4PvWirpYHXbAaz2Vjwb4qBZHSbEnDf2PdunixcKTxQeg77mu	9324	13163	13163	1618308540000
18514	3NLHG1qKjojdVvR4oppqDw4PkazPDMrpNfrYbHfnRuJC8CkcL44U	18418	3NKs4wNXrFxpiYnppXSZdkLByq9zErHbvQaDPSouMzzCyJSVgTDT	1675	1342	317	6301	12463	jw9SKbcDecGWQexy2VceLtCNutLNE3YafuNy7rsUyGxAT46yz3D	9271	13164	13164	1618308720000
18517	3NKN7jMR45hwWyc2iFny67XLe1x99CMzaeFkf5q9yMSan3fPa9Lw	18514	3NLHG1qKjojdVvR4oppqDw4PkazPDMrpNfrYbHfnRuJC8CkcL44U	1675	1096	317	6301	12463	jxHP4bd8W2BHLpsqDCDhGUmsqaYhS38aDhS4AkQuCSJZH8EnhYh	9272	13167	13167	1618309260000
18521	3NKrFrpdcbXiXpSztLgB7rXD1fN7k38YQkW9X5FkuepWNuEQqX8j	18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	1406	1393	319	6301	12463	jxnB197HzYT3XT4RNCNxfvPmDXcJUn9BrTcxVTrh6bwHGNRKYF4	9328	13168	13168	1618309440000
18524	3NKKQmX3CTBSgUsyScBwizW6wtNDk59HdgQoTqD42yjNcsRo8Cij	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1406	1393	320	6301	12463	jwsGYMchhyNQJif6JUi4MT37nqBTrRUz5zskCnCuf5RSxq1zi4T	9331	13171	13171	1618309980000
18526	3NKbVRPC3qPEdCqjDHkrmoXvRiYMoEtVZnR8ACSCBgRAdwAcTxhv	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1608	1043	320	6301	12463	jxAWB13UcNS3kUZUKy9sj2SCLzdpo2HhnT1Z2pnwvwu6MRjSgYx	9331	13171	13171	1618309980000
18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	18531	3NK3jkTxuaRpFJfwairSs3mwmPA3Xy8RB45bJ7tNFWPJznhiAUPj	1600	1246	320	6301	12463	jxBQf1iiHKHxSmyKXxtU9JnuWDoU16ru3SFwsFrSgQ5EEwyTLWg	9337	13179	13179	1618311420000
18429	3NKE7tuybG9iVsQPmQwUpyyXR5aaC6ZMZyzC9f9fQPCrfHbXVmXT	18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	1460	1324	318	6301	12463	jxWS1i7UqANob1fbs3j8oA2j9xoLaY4C1uAkQraeTPNVcYby9Wm	9292	13119	13119	1618300620000
18439	3NLbapZrWThtt3br8cUoVhMhiLghv5DMs9f7kqedNTtJV5qbY8rE	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1489	1134	318	6301	12463	jwJ1HNTn4HaHdrCX7hW9wtcfsXD7CrzQ7NWmkbvr1s5y1u9HnJ9	9294	13122	13122	1618301160000
18442	3NKLNE5AJs5pNie1Zn9wc6w8ELJM2JypBPZmJfXqV9NqBxDkwWs1	18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	1460	576	318	6301	12463	jwnXd9P8xmFGaafPc8wLbDGQB7pQiLzs7g4SZzrmPXhSPpcMP7W	9296	13125	13125	1618301700000
18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	18443	3NLFgKgP4n3fA8gJxeytGnVXs76QJbMLfXcxJobwXYVDp1p1bfXE	1407	1395	318	6301	12463	jxeoft7VaDRHSqWv4qsLpHCwzTrHxJVuqWVUiVURKLsm1SzLibQ	9297	13126	13126	1618301880000
18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	1627	1139	318	6301	12463	jxUSpCj3mckCc8LMmQkNSreNLKwu53FoFLyFFUXPZ1d3qYMQmzr	9300	13129	13129	1618302420000
18453	3NKBMUWfUopZuGVdi1odTBXQhuSMwXZyEU4wgvemNsftFJcoz9zK	18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	684	1106	316	6301	12463	jwyBhhxEcZ8iU6JRYeNjo8qLnmH665Xc6ZLXJeJpLhVRy7bx1QX	9265	13129	13129	1618302420000
18460	3NKDksLa3uEp19uokvmrPBSya9pbUtePYvwRbHwRLLyEwZ6JHNVd	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1541	1172	318	6301	12463	jxU6GMPcUX6GNMV1j54WZn4H3NiFAYvwbeAHfnmoURXG8sQJF1N	9302	13131	13131	1618302780000
18463	3NLaeDeRGpb8ZwSLgjnmky5LLuy9u3pjTAE2Xf3GgjCxEhk7S9oH	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1458	1323	318	6301	12463	jxCperN1xaHmXLHXYfN6nCX556KHc8XSmNRVebtiAoLFUwgi8jR	9304	13133	13133	1618303140000
18468	3NLdakT9c6BHwNYHQMN94D2qhmr5uCpXrKBfZ9Z2N7FTh3ztmBsM	18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	1627	1259	318	6301	12463	jxK8YMbQTvG6j3Xa7mkYvoBXh46sjH7hYmiex12v871P5iJ3dk4	9305	13135	13135	1618303500000
18471	3NLt9wzWdFm5YQVM3zUVt2w3DFyV8vnCHkieRjsv7RRvTXwuD3p9	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1474	1329	318	6301	12463	jwriSfYSRwTjEeRN1ymRxbTrq3hBqnhF8iSiXPMnxSZPbtcmMVf	9307	13139	13139	1618304220000
18475	3NLSR3phdbQAB5y9rkcuy3uimvDPxi1ZpTuKktWytXmV8pqYJz33	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1527	1293	318	6301	12463	jxvQGE3zpgntz5M2dwR8L3qYcbBoGUsrf9WKA5STfoFRYkpHGKK	9308	13141	13141	1618304580000
18478	3NKh9f2KKbgAgk5rDpkZ7L3rrWroikFLdotfSFN2BfM9ZGBBBUPb	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1649	1383	318	6301	12463	jxKck7X9s49yMiecGLcq9ULeNFe8ZU2Hw5FFncvAepxFJkxMxCp	9308	13141	13141	1618304580000
18482	3NLHMNFLXnmBD8N1ZmCbrdNkY6Dta3GYgpet87zubgdoctxKYkr6	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	532	937	318	6301	12463	jwJgQTyeekhd7maFdDhnYnTgonc5PyejJwrXV2B63pB2dWBi3BV	9308	13141	13141	1618304580000
18486	3NKipp9ubyZEpF4HQmLbhrA5NNjCu4uh3htFkMzf6DDDoteeFx1H	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	152	964	319	6301	12463	jxiXruZEPNK6tikhb9ocFQ6P7AmuUSnWQnzU1kSX2MjysQMtcys	9310	13147	13147	1618305660000
18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	1581	778	319	6301	12463	jx9uMQRbXbodhv7UrjCMPAgZ1jnfXFoUzPTzULKdBipReZcpTqL	9313	13150	13150	1618306200000
18495	3NLVsikeu9gFnTMztuwLp9QcKYvYKMVi5VnTcgqjN71tHmmc13QD	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1406	1393	319	6301	12463	jwV94BCv6k4jp7quC8Tjk7CDtkVUGJkXeL1GnrjgKghFygVm3nE	9315	13152	13152	1618306560000
18497	3NKQjwmz9bLtq3W5xG5NEjJQEPW5qgquCKbhXXckZR96AthWV6xg	18494	3NKZRzGsfd6f5QJkxwVNYACkeSSJFHwXgDrU33vPNemv3eo46FE9	1445	1044	319	6301	12463	jxZsaowYGw9xUYVGoe8gXyJpRU4q1WRkHLm7HNwebgL2e1ShUN7	9316	13153	13153	1618306740000
18504	3NK5U7nd78QxG6SHiTa8Sq4nDjnvH24s1V4STPok4M9metYmkMLF	18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	1648	1038	319	6301	12463	jx8binnrYDUn7XppzcTDMYAfNtA2SyprchnBsb3vrLN1Jgy25vT	9321	13159	13159	1618307820000
18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	1467	1376	319	6301	12463	jwbooXjtiLY1wWCzKjUPughTHUFvUvfntAqV6CsYJLEfVNnTyzi	9323	13162	13162	1618308360000
18513	3NLRHPY543mh78msno4EECx4NQ1VS8GcjH5YzL2RqHisesx9WUTZ	18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	1407	1395	319	6301	12463	jx1ojJXW4KJCHhAWwDjbK8NGhmW79wdrNVu17Tv8JmK9abK2pBe	9324	13163	13163	1618308540000
18515	3NLUQQpCuixLgGFKscG1bU5ZzwBDkPrVuFZXJ6FHPNPiquYNnX33	18512	3NL8sh9QRtkjX9Gth3VWtN7PGMKuq9vsooZywU2sxWMgVZwih1f2	1675	1342	319	6301	12463	jwdaFgorUS3CvwLd1fTgu5t47jS1jBA5ahZ9h3fJsMg1ZYoEr75	9325	13164	13164	1618308720000
18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	1406	1393	319	6301	12463	jxTK69nRovhKFsBaFGjU81wPFugrVbaBtijTY1J2fcPcsPGCyDn	9327	13167	13167	1618309260000
18520	3NLsvDbw2j4yUBu7AwWDdx8TiZJHw3rLzN4BCuR3kG5j7nr95AXk	18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	1458	351	319	6301	12463	jwMAwmboN3vSdkh2HHZGQ2b395NgLWhdwVbFpp8mXEgUitBiA5w	9328	13168	13168	1618309440000
18527	3NKeUEjo9pxR9Jbee8THi3SkNFW79LPd7YAh98MHqy73R9FyP189	18526	3NKbVRPC3qPEdCqjDHkrmoXvRiYMoEtVZnR8ACSCBgRAdwAcTxhv	80	1273	320	6301	12463	jwKE2FuLcGSvbyV2ew5r5YMqDPyXnbCpPkNVXPTAgUfKz3DrJqK	9332	13172	13172	1618310160000
18530	3NL6qKXe2rbUAtSiAU5N2vjjuUHWypHvXF6w3yQSSLYPE4mKPwgJ	18529	3NLVKVEJXrRAnWSBrN6Ppk22nxgvWnoHtH7jodC9EBBXcccji9fC	1406	1393	320	6301	12463	jxHZtfYKRPwk3uoViQdpzxTV591HoMnTLYQXcTwAoc7dc7wozBE	9335	13175	13175	1618310700000
18533	3NKZHpWmuX9LiXCKw1TvZakEuqHXSWtmmHwAo8KqbxZCEypGVRSu	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1460	558	320	6301	12463	jx5q2BDJHGR3bdnM8qUvesiGYCvLQ1WEa2RDcdqWDA2mRBEgTdy	9338	13180	13180	1618311600000
18535	3NKR35Lt5V96HkJCzVDSP31ohBi1rjspTmaHknsMMKSkXETpLDHC	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1489	1380	320	6301	12463	jwVxb5hfm5tp1VAJTJuyHyxvdac6FGEfuQ7BNjvH6eRFggq9P4H	9338	13180	13180	1618311600000
18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	18537	3NLbiLzepgHtAXaeqGBRfFiBasNKqDxVDancJnrRzzFbES5XPzt8	1406	1393	320	6301	12463	jxR7iL43mtJrFzY7DCXfHD5GDks455k34MFkwVXg1r7b6gZuzyP	9340	13183	13183	1618312140000
18547	3NLBeMiktYPZXpKK355nSCDKmK7Hwvb9ERirkvMgWzet35LNZGTV	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1536	1313	320	6301	12463	jxDwBnGCC8mtqWuny4Q5ViZLZRdZSPNHaZp9doLoghKdB3wWjYP	9345	13188	13188	1618313040000
18549	3NKTUV7sS7Q8eEmoHeNhofrw1rnUtRDNiefQZo1JJLiGSLsEsYbg	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1440	1131	320	6301	12463	jwiiAUy25KtZrjkTYc9norjh9fj3Tf88JGfR2RKDU1NDDNguAPL	9345	13188	13188	1618313040000
18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	18552	3NLY3sGFbsRhKDqt6SDXsRZZnk3YneDXFN1jGh4WiF3sCByHhKss	1600	1126	320	6301	12463	jxqxdu4S1XX2XbNyGHw5wpE63ggVwNfxePDEZiPCpHByKKSMf8d	9349	13196	13196	1618314480000
18560	3NLPbXoWpya7wZTEbzGup6Z6erBRcW9Aqa51q6ZXF3HgA2Dg76PS	18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	1406	1393	321	6301	12463	jxysagARTWTm6vkYHcc2aYr72S5swaBPPeVQmz2TLnZznH1aHJ4	9353	13200	13200	1618315200000
18437	3NK7ALvK5Ue9bNkwBJRFM2ZM2gvRLXxZCsCA6C51ZVuQEPvDzf3q	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1407	1395	318	6301	12463	jxYqPo9rHRAzUbdAtTkPqPEYW1ZGjfW2JZhQTr4bijyjsnY2YBj	9294	13122	13122	1618301160000
18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	18436	3NKDbB9jqBuNa87tYH3sEhw2u7GiJ5SnHRBhG1aUBmGTPsHMcE9P	1403	824	318	6301	12463	jxX15DDWKeyf9uFTzWNjcBLzJHcy9QZcoZokBxYHggPEsg3j665	9295	13124	13124	1618301520000
18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	1600	1126	318	6301	12463	jwkmiiQNpyToZYHGSGKPr65w7QfNQxJYDDo1M8vLzqejyWeZ7KA	9298	13127	13127	1618302060000
18448	3NKDyeXNqVwoRuMtCRFQX7R9j71kKakvhh9ThiyRWm1uw5qtC3jY	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1651	1055	318	6301	12463	jwxeza5KdK9uEegW2kzMMC9XQUViNj6QJGuzevRGSWotbHYowPK	9299	13128	13128	1618302240000
18451	3NKbCM2GWgN2XMSH6v8vGj1Xpo4YqbMMc73pYEkAJSn54fUyUuwq	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	1407	1395	318	6301	12463	jx9p3JQZpA3Ddo2qtoY4HQYwA3yR4RPjfSgW58ySN7219WA3CVs	9300	13129	13129	1618302420000
18455	3NLNLKnr4vVmMEPjZErFWVKrnhePq5M6t8m3a1p5PQxYUhPTo4Tf	18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	1406	1393	318	6301	12463	jwL1VoGEca6TQkXjVVVwEuUG451L9iV42wnXraENhgNBitvQMu7	9301	13130	13130	1618302600000
18459	3NLcph9j2g8jAJNZiEbtNkQ3BXw7ocF6ao7bZfGhhmkFGDxvmhLN	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1513	1253	318	6301	12463	jwUzgn9URnvWZchVyWrzNqD91znDQ4yffahc8yfVtRNtk7vdZvY	9302	13131	13131	1618302780000
18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	18457	3NLTSBHGrk87GXHKR2BnQ3preRBLc5f77kfeBdSRfkfvU4yhs5jW	1588	1392	318	6301	12463	jxgvNbMXAZoRRNuRwt5AnuodtWUxGfyQYs3ypbEzvmXYtgGvqh5	9303	13132	13132	1618302960000
18467	3NLjeSik5aD5JT35dd1XqenE5DWYpT5JoseGEWhFSPgZEXrbTKfg	18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	1403	824	318	6301	12463	jxU1zMV3JQJtz8m948Wtf7vFWn5cCVAPBJSSMsz4t9mnJ5ZbUWW	9305	13135	13135	1618303500000
18470	3NKJaSypMeyd4nkCdmrB9jcTYH3XHWqmU3M2unsSVHfDDEMyeX9S	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1474	1329	318	6301	12463	jxcg3aa3BNwF7cR5CeZW8rsvf6UzTxCKVRfT2cv6A66uuAm1hdi	9307	13139	13139	1618304220000
18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1508	1261	318	6301	12463	jxRVQHK8HxQLTQB1FCLABXeBMj6SpJsupAwM7oqmxnogxBZJVkR	9307	13139	13139	1618304220000
18479	3NKd59qtu9nSNRJnZXE8zvzhQ7h4Z5hL88gQWZEYEnPGo3gmw3hb	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1527	1293	318	6301	12463	jxStPwWxgf1rgvRnEGdjbf8LxxrbkkyDkTshYshyUev61KhsfvP	9308	13141	13141	1618304580000
18481	3NKVCBmVXVs2mSvMQJKaMBfKuWCKSLqxHddz1QpodEfSi2p229uN	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	532	937	318	6301	12463	jwd89BBuhAnuhDikrhdmkrVadEcWaSUeeetwBuJKjj5m9kyRsdD	9308	13141	13141	1618304580000
18485	3NKEYKzvqoaNTLFN2if98t3orHbtVCjZCc3N676dakiBSEV8JF3x	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	1516	1294	319	6301	12463	jwqMiNhY2MKzgoJM8VMHdfo1fNgVMs1dH5rktNvhDihkFHxyy7A	9310	13147	13147	1618305660000
18487	3NKoKvtiQmcCd4HphyxY9dhKtZxuzzGmAvmoLMg51hvVHThv63si	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	1541	1298	319	6301	12463	jx9RhZ8R3m53PzAaimErvhLRDKRoi2tJmXWBV5AvxSJnfADmt6v	9310	13147	13147	1618305660000
18492	3NKdKQ9SC2PWLopKJhVttpsuCq5xrTGmQPVmB5u7DCy2CvZD2me4	18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	1458	1077	319	6301	12463	jwz4ad6DuFvYb4yJbLPJZ31w3NGkNBC5HQNBWZa6T9zk4rd9Zzv	9314	13151	13151	1618306380000
18494	3NKZRzGsfd6f5QJkxwVNYACkeSSJFHwXgDrU33vPNemv3eo46FE9	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1402	882	319	6301	12463	jxLMszFkraZZHndBRJvLMeVPiba6W6qN4CugdeuyKN1T5hpwjAL	9315	13152	13152	1618306560000
18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	18498	3NKu1CUV1vA5h6KXenxtQN5WYdtext4c1gjaUPbAXRnRUbu3oUE5	1503	1277	319	6301	12463	jxihhPc7qxNMhE6wQabxHrAMwkPDtGJa8KufJUMJ4HKfPwUF6EY	9318	13156	13156	1618307280000
18501	3NLECaQLUqKkAuW7YHou3bn1SHm8FX1Prfc2RbDcfVfqazXDGMn9	18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	1622	1356	319	6301	12463	jwDhxEcmaqeCH27bpLHedwhaGPqSebe9uVMSX9hkwYoxSCPecct	9319	13157	13157	1618307460000
18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	18501	3NLECaQLUqKkAuW7YHou3bn1SHm8FX1Prfc2RbDcfVfqazXDGMn9	1585	1366	319	6301	12463	jxgPX2GkXaAxvGNqAudhAkEFAL4HGwbxi9joWGkM9veBo3Xpc8k	9320	13158	13158	1618307640000
18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	18504	3NK5U7nd78QxG6SHiTa8Sq4nDjnvH24s1V4STPok4M9metYmkMLF	1592	592	319	6301	12463	jxKtWxmiZ2QYKYyYYkgZUxmrxo4Sg4VBhHyqRsj1jhXzc3Pmcf1	9322	13161	13161	1618308180000
18508	3NKmLpRsSvSYt1iZBWDqMNWsHUNcfUFG95ygdCUvMeRKgATJsbL2	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1592	592	306	6301	12463	jxgRWJs8Y3hqDFtMgFFCHqSK3ttowHDC16LwBMtzQHSMBFoAMCJ	9042	13161	13161	1618308235389
18522	3NLu3Rf2sN6nM2gVz3VxiMTBhyHT9oV6ZRvJ9eaYbgx3HFRgmoQe	18521	3NKrFrpdcbXiXpSztLgB7rXD1fN7k38YQkW9X5FkuepWNuEQqX8j	1507	914	320	6301	12463	jwtcWdqSjBhMh35X51B3EHA22n14jme9NedVAv183WgnqV5i5v1	9329	13169	13169	1618309620000
18525	3NLKSACArJjZHySMCeEa7oHBfu5WdgjtyFj5ka4bgtb8fBT1U37S	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1673	1122	320	6301	12463	jxbCHxXwDya8fgyzEBSSNZLqDr7tkpwLiDhCoqfvbNX2epPnn7X	9331	13171	13171	1618309980000
18529	3NLVKVEJXrRAnWSBrN6Ppk22nxgvWnoHtH7jodC9EBBXcccji9fC	18528	3NLydiqWHaTMzcvn7dDxjxdiL9kHGAWLjUAwSUTPoWVATQtMiTvM	1581	778	320	6301	12463	jxMS2BViMNjPLBBNjQMgBvzk9zRAB7unvjvEnUGcr4HT9pWS3NH	9334	13174	13174	1618310520000
18537	3NLbiLzepgHtAXaeqGBRfFiBasNKqDxVDancJnrRzzFbES5XPzt8	18533	3NKZHpWmuX9LiXCKw1TvZakEuqHXSWtmmHwAo8KqbxZCEypGVRSu	1407	1395	320	6301	12463	jxoiCdtEUvom7JLcHvrPatZLqQnzXosPhxgUsQKUUXyRyRajqQL	9339	13182	13182	1618311960000
18540	3NLMnkRTDET49y39GSgpC72dJiiFizV3EBKTmuYHPGdmJtkNtQQ2	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1670	1282	320	6301	12463	jwNkZPjrGfjN5xnF1hKQoAMkB6cKHNzj6uZzt6aVfGX6a4ykZFf	9341	13184	13184	1618312320000
18542	3NKVmrYnP2nrpzXvZR6eXfB3oLoz9peQ1ZEogcNwFWdgCo1hwYof	18539	3NKoU6LdRTrnWkgDcfMBoH4DhESYivFbTsECWyUD1mffYW7AX6E7	1637	816	320	6301	12463	jx7oh7fQQszMt5oB6QStYyvzAqyGKTBZ9iVditMHaovo3yAd5K5	9342	13185	13185	1618312500000
18545	3NKFoBuS2TDd9CsFkraDx9dtmZDZvzduUi8AnkcBkQPSeSLb1WFW	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1507	1154	320	6301	12463	jwdQ5mNPfqRUdLg7GJAj3srbAfTooHZ3PchRwyTR4UAXHwxbqwf	9344	13187	13187	1618312860000
18552	3NLY3sGFbsRhKDqt6SDXsRZZnk3YneDXFN1jGh4WiF3sCByHhKss	18551	3NKY7NbCR8sRtxY4rPmmu1trXLe2z3CNWfkT1ZEJvBfJsNzHgwwo	1623	830	320	6301	12463	jwqBXcCxZ1FJW1jJmZrGhedmEjsXidkptrmYZJvGvpLyHEqRScX	9348	13193	13193	1618313940000
18555	3NL4J24GrT3RdCtZ7ephCtwZjuMdYj9QNcVe8PYKNpxfnBaHLiTe	18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	1407	1395	321	6301	12463	jwMJN1ruYQcyLFsKLxYoy88WfRHLVqeCxtuPdceB12u2sNcQkX4	9350	13197	13197	1618314660000
18558	3NLkGwxWuLvjd8RG2y7ihWWhgxBHQdPQWR3HpPZ2JYdTy79PzBL7	18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	1407	1395	321	6301	12463	jxYDazpcyDSxp9AFq3P8tXJcDgoWEHVuouNYkd6Y66P3mU8h7PN	9352	13199	13199	1618315020000
18534	3NKp6U4L3AVyZfDEQuKgKn91668XAPxutnjRL6erq2kJCAyKxUMW	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1440	1377	320	6301	12463	jwCpSWrL5aRj4inBbsBMB82XN7saEbKjkCbTkxr2erG4s8nfzWC	9338	13180	13180	1618311600000
18539	3NKoU6LdRTrnWkgDcfMBoH4DhESYivFbTsECWyUD1mffYW7AX6E7	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1406	1393	320	6301	12463	jxtQ7cFULJpkm4Rbwg8qXeNNWXQxPmeJ2LMYtpgmytuxGGLEMDw	9341	13184	13184	1618312320000
18544	3NKBXZirHDgpK78YGkL43tnL9edMzQfF1sm5CkZEovAYJwb6e9UD	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1406	1393	320	6301	12463	jx3vmty1sfSTPHfKoyEphqGcKJLSwhdKFQtc61Gx3NbPD54KZFb	9344	13187	13187	1618312860000
18548	3NKwLvZMgv3upWc13q61WNo3WcDYpNYKzK6muLvf75H7P8VaF1v4	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1406	1393	320	6301	12463	jwzZEf6QVnGL3Guvj4jWsGZ32W6NGaQjTPpadZN26koWBMJUmQN	9345	13188	13188	1618313040000
18551	3NKY7NbCR8sRtxY4rPmmu1trXLe2z3CNWfkT1ZEJvBfJsNzHgwwo	18550	3NKfiJvPDhUmeZerwR6xE3ur7ouzYQU3ZbD6n6TFwJM9hgHo6kAv	1403	824	320	6301	12463	jw9s849trobPMTdNBsPk9ujDQxbJtY1feh5aA7mLNQTEGCUpkm8	9347	13192	13192	1618313760000
18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	1610	1314	321	6301	12463	jxEYTqfWGinBa3Eu634KuHJ1sft5D2zbnbD7cah4X2vkF54m3pQ	9352	13199	13199	1618315020000
18559	3NKrdBM1hcH8dV9cxauMqdk1gTXYDHg3beLBeSqFGt7CnVuxTD8T	18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	1547	1252	321	6301	12463	jwxKw5EKuFgAv1UTLii9hVsndVMchsBBuGMmZzNjn9zgESrcr4q	9353	13200	13200	1618315200000
18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	684	1106	321	6301	12463	jwnyNJiKUWm7pSn37tNqD5bki66RLgzrhg1wgZ9nAKr95FB9hsC	9355	13204	13204	1618315920000
18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	18567	3NKYGn2KZJxNQ9MMcviMop1AcXSw5Gt3EKxBBYfNcRQk3S4CcWuh	1637	815	321	6301	12463	jxWB9dxs4mgvjCQ3igiu4JPX98LbXc4chiuTLeG25yiFi5PmzJx	9358	13207	13207	1618316460000
18571	3NKz7iTkLyHbwKG3AGjSWiQxZZkyUpff2wjBD6Fg143qnYXSFdFq	18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	1670	1036	321	6301	12463	jwignEn8Gkc7kjV2paPTZzj47WUXPJ6PzcJ1gbkrdFGFDogRg2z	9359	13208	13208	1618316640000
18575	3NKrrYHcf7qN9X7qTNpATtjyRDZCuGQYzuAiwkoFKY6T6vhwZxic	18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	1670	1036	316	6301	12463	jxGGdNagPE9tABMg1zK2YF26vogHvaHKpAHvRucqUfc7jsDgsub	9248	13208	13208	1618316751609
18585	3NLhZ2uZFT33MuFAtZUnUGoMHMMWnWGGpw8unTEMj6HgomFVUB7v	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1625	161	321	6301	12463	jwU783ZGvqcKvyg6Eepyg4USmJLzwwDT1rJZBF8ECSwb9AHGsMS	9366	13219	13219	1618318620000
18586	3NKhbpAzD3SdS1GEm9pzrUy3T6T23baARsQTKBB6WrexVG8mFEoZ	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1581	778	321	6301	12463	jwu1yBEYxnpJzEe6q3ZoG92WzoasB1WuaHqbhDtwHtFQKUizyUQ	9366	13219	13219	1618318620000
18589	3NLDi6yqnxbUGpK87f8GG1ZxV9SCyZANkTmQsynr1Xfv6ToHE7Zq	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1461	1271	321	6301	12463	jxegEtkc152nPieboz3qToq7ErTRdGSstJ7zYQa5YuWjoMUmyKN	9369	13223	13223	1618319340000
18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1617	1042	321	6301	12463	jwK82SWWu7FAq9VFbct6d9uQGL3U1W3mHGtg9432E2axi8sJMvw	9369	13223	13223	1618319340000
18595	3NLwn6YcvjbnouQTQTjSvzMHLhBaYgrrPk8jtsrYXcjjXDCSetyw	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1596	1117	321	6301	12463	jx8HseiJhSXdPYF7YEzBxQXvmoAnKivMTLRBrwkWBGE2ZJcjSxN	9370	13225	13225	1618319700000
18599	3NKiN55v7PABffmq6RniJb1tJ2KPq6hETfJD3AEHUmWBgHWnBwPL	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	470	1309	321	6301	12463	jwragg9MAoa2x1uZhmpBWLgiphadRMB8dKmMf16A65QQLLyWTh7	9370	13225	13225	1618319700000
18536	3NKosuVXs2mY6zm28DubDqdyJpYHArfFW4tAZziAMF1JP187rUbd	18445	3NKDHmD4RJZ7i3L28gNCrGhmTPg159wYzw6hEgarbX2Wg187mSUR	1634	1331	318	6301	12463	jxsE3vEothGENJvhcBbPM18U7HvAujEb1PUui1MqZZTQFGhtZCQ	9299	13181	13181	1618311780000
18541	3NKZk5p4L4H9gLfYzGF7WYecMrRqSfSHFefGBLZdZoUYvV6m2XXx	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1407	1395	320	6301	12463	jx58rJLakP5k5VfbdEtbt3nMRkHuN2vEGDSoojm3XrEvrb3eY9o	9341	13184	13184	1618312320000
18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	18542	3NKVmrYnP2nrpzXvZR6eXfB3oLoz9peQ1ZEogcNwFWdgCo1hwYof	1500	1297	320	6301	12463	jxh25ppFbUknKc8RHrqCjKfgWvkvkYuY7zxXmSWnvndGohjKmsB	9343	13186	13186	1618312680000
18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1577	1081	320	6301	12463	jxGNH71JYgFHX3YWZtYxyLeRuo16cVakut1ffwLE3rHHfEV6NjK	9344	13187	13187	1618312860000
18550	3NKfiJvPDhUmeZerwR6xE3ur7ouzYQU3ZbD6n6TFwJM9hgHo6kAv	18548	3NKwLvZMgv3upWc13q61WNo3WcDYpNYKzK6muLvf75H7P8VaF1v4	369	946	320	6301	12463	jwUb5meNFG9s4pButra9tN19BrLGza9KZYhE8khfsPA4x3VBFXt	9346	13189	13189	1618313220000
18554	3NL17nFWU6oNLvB4RL4svc7sxneCUHbhuvhcayZvM8My6SQhw9iU	18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	1403	824	321	6301	12463	jxvTWAALE5vqPPNtdZTZU787osP1XxnHJWrUUWt3cScJd9PgGsv	9350	13197	13197	1618314660000
18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	18554	3NL17nFWU6oNLvB4RL4svc7sxneCUHbhuvhcayZvM8My6SQhw9iU	1406	1393	321	6301	12463	jxZPNqSVZ1A8gnS8b79zmxxzqUKM6LVMHFTKGri5RcwSkeBKX17	9351	13198	13198	1618314840000
18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	18560	3NLPbXoWpya7wZTEbzGup6Z6erBRcW9Aqa51q6ZXF3HgA2Dg76PS	1406	1393	321	6301	12463	jwLc49rHWtCvq936G2NBnU96xr7yNCxd1cfECabHs348Wx8bMhi	9354	13202	13202	1618315560000
18564	3NKjs1xvof98tfJa8PpVeaXUP5r7u37g8QeQUkintZJ7ZpPY8WXi	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	684	1352	321	6301	12463	jxBqigPKgKcTvceSWRmxMEEbVwyYi2N2TaAtFWxLdx249hdrv1q	9356	13205	13205	1618316100000
18573	3NLsSbs9ov418UZpEU8h1D1vE4hKoPtjy6oyAMqy731U4EkoJmfw	18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	1670	1036	314	6301	12463	jwPiJu3Qrv2xwgix11XLZEAiUu2itCieZZpiv6ZjrmntY13AnCy	9216	13208	13208	1618316677732
18580	3NKKt4o1nu5jJtdigsnKq9258ieaHCrQ4APnSpfR1uH79uedTbpB	18579	3NK9YXWDjn6J2Es5NPXGXnQKmZQzzx8htUr9QEQjSBfmTKLnzzB3	1647	1056	321	6301	12463	jwGF8aqvvHxN2Wz6XibQ1n9YD1mZRk3dkH825tM8rrApt3Vu8Hy	9363	13213	13213	1618317540000
18584	3NKhasUkmX3RkMGLT1yK8MT6TULK34eHG4QTaeD1mQxc6Gc4WZRF	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1402	852	321	6301	12463	jwBAS5H9XACepcNPPvadSbj1NsDomfFcreWifhV78SZNBUE8ypA	9366	13219	13219	1618318620000
18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	18587	3NLtpVJhQpv3XKJKq3QVwJ4QZL9SjzuHSyeExPZiKYhi7nsZc5xH	1406	1393	321	6301	12463	jwUYnp5gBoB1HpZ7bheQZGpR3FFpRtPYzp8fPNY8Qat2es6xiYo	9368	13222	13222	1618319160000
18594	3NK3BYTGmyhz5s36jBcXzEFbxhu6DbnNnrsVJZTnhyoj5sR9cGee	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1471	1140	321	6301	12463	jxu8zi9iTr9x7a1d4LH1hnkCaunV29JG5N4N4V2Bxggk8K8Jz29	9370	13225	13225	1618319700000
18596	3NLbGfWijB4yXuuXcxUZ6tyXzDHnRudEr7xK37qWEp1rqmoAs7C2	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	448	1059	321	6301	12463	jxfT6ZzmSi23WGGTJGow4VFKGqXjJsmGvfikGvkuuoab5Wrdnq2	9370	13225	13225	1618319700000
18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1407	1395	321	6301	12463	jwYfLXePn6UJaEqxrRgEAbJNNFEhq5a6kchfZZPhsVxfJot93s3	9370	13225	13225	1618319700000
18563	3NKNP2vEYD1BKW5QvaAk65BD9RAc1iNpYwAbqEV7vhqHu6YTiQkT	18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	684	1106	321	6301	12463	jwpd89qmNNprZeawDJUDw692egb1Dk3sgsPqgaYbAWQ4btNDh5c	9355	13204	13204	1618315920000
18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	684	1352	321	6301	12463	jx1irgJtsS7mujgkJH7gQzJUUQh137n5T74wP95iBKacrPJ2V3z	9356	13205	13205	1618316100000
18567	3NKYGn2KZJxNQ9MMcviMop1AcXSw5Gt3EKxBBYfNcRQk3S4CcWuh	18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	1587	1111	321	6301	12463	jx3wCkYn3obiyc3NhRk92M4fuqhWAbbsPqktXHdegFLXUnwNk7a	9357	13206	13206	1618316280000
18576	3NL4z9G6czXoEvnB5Te6FeRbmCWLz3JvWb6zWY5JG7gmcFbsBWAg	18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	1406	1393	321	6301	12463	jxyd6ELrwepaTWBGUtmBX1v2hx7DUP4NKw5DVXHqHqPBzeBnxjZ	9360	13209	13209	1618316820000
18578	3NKwYPG1npidYHEQjYwvKW4rSVgS3frGpaBy6ygBiGUTU5UBkJkU	18576	3NL4z9G6czXoEvnB5Te6FeRbmCWLz3JvWb6zWY5JG7gmcFbsBWAg	1407	1395	321	6301	12463	jxqoFXhf94ijVZoKbrEfyH3bL7QHrA8ym7YqUHm9dkdUATYbq2A	9361	13210	13210	1618317000000
18581	3NK3nbpDPqQf8wjgdFWBxsyqiyK5tycphoyrDdoBAAGhwQJgoJ4d	18580	3NKKt4o1nu5jJtdigsnKq9258ieaHCrQ4APnSpfR1uH79uedTbpB	1609	1333	321	6301	12463	jxz9rAg5u5RpySmA4i2gwMo3vbx4LhAEU5oH8ydZ4AR1WcACr7S	9364	13214	13214	1618317720000
18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	18581	3NK3nbpDPqQf8wjgdFWBxsyqiyK5tycphoyrDdoBAAGhwQJgoJ4d	1405	851	321	6301	12463	jwegMzUNq13npWuFgE9hd98jZc9vZ3vB9Kxg6NLCCN2x4qiXEyQ	9365	13217	13217	1618318260000
18592	3NLwT7ZeNJeMtgCDMGxUZNnJreLaMcB1owpvz5aJ6GgX86VGHSVm	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1622	1356	321	6301	12463	jwxHeZFfPGzcL6tNmvEKQPvNzs2s4w8UR6KfMT7oiKkpWoW69Fq	9370	13225	13225	1618319700000
18597	3NKkzozh9CPdmgP9HdSjPVUdFKnEAvaZ85tise5ksBRopz9kSQqG	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	448	1059	321	6301	12463	jxfT6ZzmSi23WGGTJGow4VFKGqXjJsmGvfikGvkuuoab5Wrdnq2	9370	13225	13225	1618319700000
18566	3NLGR3pNU9vZXLRXpsG4a5yuvGfsLVrVUW6WEHDR3Rbe6Ti5We9B	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	1405	887	321	6301	12463	jwraEknktAKNx8KsvfkefHQr9mRMGJCDTVw237ajPTvkpDbfNQW	9356	13205	13205	1618316100000
18568	3NKQArzfjxcWzCdjWdF8yKXxVy2Lpen8wHv1X9WdAJrNR7yjW8ve	18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	1627	1139	321	6301	12463	jxadC57QJ8JKLctsnKtw3FHdnLmT1XNr7uVqY89rkbtiiux787e	9357	13206	13206	1618316280000
18570	3NKGLzrbUBVrJtuy4S7RejxBXdQMobUDRUJQHsaZBYg9U87LRa33	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1670	1036	314	6301	12463	jxHenFGRrWpjZCz3H67dypTrYcRZimmEp42qQf7PxdeoPDLepRF	9200	13208	13208	1618316640000
18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	1406	1393	321	6301	12463	jwLfr6d7SYZBXG85ZPGWT4YN6wpkgri91HhCtRGGGwLwXUYuPvD	9359	13208	13208	1618316640000
18574	3NKBe7mxANRjsV6s4yEJBJV7BdK6iXEQiJKDf2L2ZSqGw9kcNGcE	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1670	1036	315	6301	12463	jwJTnh1yUPUY1LkxTLwV9GtTy7LrsqpWXvKwTJfDEk4jLP79KdS	9233	13208	13208	1618316715041
18577	3NKGL7GCXNmYq78TUUvsoSfE8u2QudDibFsFFo1QdmhUKvDrNhFk	18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	1445	1290	321	6301	12463	jxfcENDUBGSH3Pqm4oJuSSVs3dXyJCnD3PKjNLShqkAaKFkMCVd	9360	13209	13209	1618316820000
18579	3NK9YXWDjn6J2Es5NPXGXnQKmZQzzx8htUr9QEQjSBfmTKLnzzB3	18578	3NKwYPG1npidYHEQjYwvKW4rSVgS3frGpaBy6ygBiGUTU5UBkJkU	1402	874	321	6301	12463	jxxSJ2tHsgrwtPcf9NrVM6rmDunW18dmtfQafFgqDJkBRdAvegU	9362	13212	13212	1618317360000
18583	3NKai4t9cgj5qaszBkqXHy7adXw9Bydz1zS7va1JkR1rfHDLgMoG	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	369	1312	321	6301	12463	jxf5BRp1zXZNRxe1TxoPUqq7VFZKg7aSfi5244htXSSsFzmZK8s	9366	13219	13219	1618318620000
18587	3NLtpVJhQpv3XKJKq3QVwJ4QZL9SjzuHSyeExPZiKYhi7nsZc5xH	18583	3NKai4t9cgj5qaszBkqXHy7adXw9Bydz1zS7va1JkR1rfHDLgMoG	1407	1395	321	6301	12463	jxhY1mVzW59CskJseSpDZKMEfAy6EMDdmFSSe4g4K1LuRS9trSh	9367	13220	13220	1618318800000
18590	3NLdLZqCX6pxY3zpe2RBVfEsAwrhZ3GJjgHQSwW4ETfX4DWbVGen	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1608	1289	321	6301	12463	jwBaAeEStjdF5m1HPFAeisgjx1cUyuoKirHfMDYBxzmtgxkq5w7	9369	13223	13223	1618319340000
18593	3NL1zBDkujSHiqYaVh6k5nhQTHiDvdRR9Dnzo8ReH2auv6wZwzEF	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	470	1309	321	6301	12463	jxFfR5BKw5TxCYrFGcejVerUVCLQCxKKWhoUNUhCMj5jfhty9f4	9370	13225	13225	1618319700000
18600	3NLaK7bBpxeQKD3dfirygR6wmwY33hsVqNg6DMhnftG7i4frvRnw	18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	1637	816	322	6301	12463	jwZSTBR7jNj51Grxb1Su6ZwNBkARqpTteZBoKPWGbyM8Pqu1NrZ	9371	13226	13226	1618319880000
18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	1406	1393	322	6301	12463	jxWAU8JWnh2bingxYVRxTUChMKf9PoR4ckcR3nq1ccLgXTtxh83	9371	13226	13226	1618319880000
18602	3NKKU9ygEAL458egN3K8wed3Sm61L7Utz4biLYzQvzMwcpSu8WrW	18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	311	1181	322	6301	12463	jw9CYfurwWFjj9rZRcPHo5xS6CGpA57E4aabnoGbCLScqMfKCBT	9372	13227	13227	1618320060000
18603	3NK42bjnZyyMnEtydBqSN4VgiAcHPo9sM8oS3ZvhdN4QBydxrvFg	18602	3NKKU9ygEAL458egN3K8wed3Sm61L7Utz4biLYzQvzMwcpSu8WrW	1672	919	322	6301	12463	jwdQeusafyUbyM1u9nrKiLKo1e7YJxbeVvLYBC3prJKP5GgiydG	9373	13228	13228	1618320240000
18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	18603	3NK42bjnZyyMnEtydBqSN4VgiAcHPo9sM8oS3ZvhdN4QBydxrvFg	1407	1395	322	6301	12463	jwVaxfzdFXBJ5HeVYFzxUrWsPo1cZ4GhB4XrZZFdCf3RKxvggsa	9374	13229	13229	1618320420000
18605	3NKsdTquRZ459xmM9uX1R4R7cYcw9kCspUCzRN77U5H2Ph8UNKFX	18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	1406	1393	322	6301	12463	jwUa4dFheGZiH6wUSQesm1m683wPptHNdoyZNbeSLGcTGEU6AWx	9375	13230	13230	1618320600000
18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	1407	1395	322	6301	12463	jxUwu6Eu1czYG8eKqK3bJMzLUCEiViwj9AM4fg2bZz6AxeEhBaD	9375	13230	13230	1618320600000
18607	3NL3C6QjvoP9Ndsa3emcrXU58g8eBpVryeVgNzvPwPw6p5LQGaR4	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1403	812	322	6301	12463	jwLsgg5gPQ8yNHkGQHW7SkwA1YSw21ArGmetGqGM1nVpNvtGtdn	9376	13231	13231	1618320780000
18608	3NLXJf6xpPTZ7Z2R9ayPDw5ZVdPKVHtzyZzaFW4i9hk4rMZDYRMU	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1507	1280	322	6301	12463	jw7mU29CNey8iowwQBXNN7EFVrnuEySGtuCfXCfnGPL6ZJjWGtS	9376	13231	13231	1618320780000
18609	3NLLiLbfRwrXSrzixLnkqVhVN4ShRrZycVeXgz3dQZgoX4yaGDHD	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1553	776	322	6301	12463	jxk5BSy2MWVHNHzJpNaAfmWBBckeC57wCee6Zn2qSpDovARsdvU	9376	13231	13231	1618320780000
18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1577	961	322	6301	12463	jwp92XRPXd8YymTosorFqRVsszAn9TYi1wez7KMTihevEyCoLmQ	9376	13231	13231	1618320780000
18611	3NLNQJ8DcnWimmTMcR2UE9pYJt6Qo1H7zhv5DphrxJ9BJB2gLiEx	18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	1673	1002	322	6301	12463	jxhgmfGFzsJcSL5Fq6c4Zhg3kSch9AfQt6oyLTCLGfjqNNPhMsK	9377	13232	13232	1618320960000
18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	1581	778	322	6301	12463	jwnf21U1D2kVDU5xdyp4QPET9KP3qPNgG9gY8gDoXFNHXYQmN2D	9377	13232	13232	1618320960000
18613	3NKTDV3nLQyDRdsP6PDfbBWxLLHhCnbuasoNK12VfFfDYiAunT7X	18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	1509	1074	322	6301	12463	jwPBzYbkqMachp81nocpaKGwjcEKDLeCz3tdpyqsoMZKZEdXPBH	9378	13239	13239	1618322220000
18614	3NLfBq9Z7GXsibfw7Yt9Mv2okjfqXVTSofQfRD2L8qS8QWXMnwTP	18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	1593	980	322	6301	12463	jwo3iq3GcUdwq85Un44oeJA1DRy6p5YsrV796E6wUkaxqnCuuQG	9378	13239	13239	1618322220000
18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	18614	3NLfBq9Z7GXsibfw7Yt9Mv2okjfqXVTSofQfRD2L8qS8QWXMnwTP	1581	778	322	6301	12463	jxrdQHmNBw5Sa6Z7xsGBrFN1ePp71H3CJjfcHPETpjeW5Kcm7WV	9379	13240	13240	1618322400000
18616	3NKauF1dVemTzoXcuCFQXxMb46p2b8F2aYTzGDHetCbmdoWrEeV7	18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	1419	814	322	6301	12463	jwxZmp1GWdTBH7q92AWvSRZoWGEVcurXktCzKePsG1WLnXQ5rXx	9380	13241	13241	1618322580000
18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	1407	1395	322	6301	12463	jwTWMUsan6jr3X1bgL21ocELy1bUWXZq4F6KyxM4fLxXfiJcvft	9380	13241	13241	1618322580000
18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	700	840	322	6301	12463	jxEXT1jZuR9cuJZhACECPcK89vje5hGgvNnxgiDpQr9HtnYUW6A	9381	13242	13242	1618322760000
18619	3NKeURXwUs5RBUqbtmMQtRzCogW7fRt54XrsB6trbYwCZKnR6k5x	18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	1646	1354	322	6301	12463	jxdJXiwbWkGodczmqASnWNmDJYJieSq7bCvFPENCdxwb4vdDrVq	9381	13242	13242	1618322760000
18620	3NLPb9CnTyR4v9Q55ZtbVgNjEnsXEsEPdXU6VYLNFDryt8v2QMTV	18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	1516	1294	322	6301	12463	jwdBQTUZWcphSnMcikxVM3B6p6wPZQQPqzHyCD3MWUZtZZdYkEz	9382	13243	13243	1618322940000
18621	3NLc45dyUhJtPnBWfz2naSdGQ2Jwv5ht8WcKZJVHoHFaaW7BE5VU	18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	1624	1334	322	6301	12463	jwGtAi7C4az9ox3ohWeyP4tQiBRfRWimmJToiMUpJaHWHxjXJYF	9382	13243	13243	1618322940000
18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	18625	3NLY2cBTan9VqUV5m8KxfhHK1DNRdy9L7ySi5SPtFsDw7QhzmTpq	1407	1395	322	6301	12463	jwNu2ZhoJ3dbZupehyc2smnmGFKvdBjYDy4M5jm1RmCMuW8Kvrh	9386	13248	13248	1618323840000
18629	3NLMSD91kyREJ13moEAtqCicnduPi138pEw63CPMPEctQow3MUrb	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1623	830	322	6301	12463	jxDn3KFGUXAG5Ks1n5yr5rTCnE5KGTouiLtRur2UbtmTnZusYcJ	9387	13250	13250	1618324200000
18634	3NLs15hRjEATLi9Vb7A6KvPnoJ2V1Sm7SoUSEcf1fCZ83joWyiTX	18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	1546	1213	322	6301	12463	jw85jESCVXcS3c7aiLaAGESiznK3uSJyJLHNiL6V5zACrpXWZwg	9390	13256	13256	1618325280000
18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	18636	3NLQgcNqgjD3EhZz7qWSdoATkWpk9U16qxeRRBznHH6EiDhzejK4	1549	1116	322	6301	12463	jxJyTU6m7aVh6AHyeJuwmgH3yiAUTLqihtHFEhde1SovNvTb9gF	9392	13260	13260	1618326000000
18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	1596	1237	323	6301	12463	jwFT1wXGQVtqfMy31jbK3kPYayRQGsqRWCn71VhhesJiVA5zLDY	9394	13263	13263	1618326540000
18642	3NLJLPHMctwL6WAhaZmKR6bRHEXk3obCXAM8JBZhTfF4mJtwnJUZ	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	484	1193	323	6301	12463	jxCGvpvb1YuLQAez6zd7Wj6YQYyqWSswhQG5iVnCCLErZ4aHp4c	9395	13264	13264	1618326720000
18649	3NKu87sC5N5kyyVr9DJKjuQgthqfXzwc5iGGJGkXrSH2i8L8PjMz	18647	3NKHM5yGVR89gZKGWFJTP83Qkxo8ytvAwbYgNDuwKFmrc2iH7BNK	563	1233	323	6301	12463	jxqxYrvo4MnuTMu5671GuaBpVQjDExMVQnChfJC9kttQeGuCSAj	9397	13267	13267	1618327260000
18651	3NLC1TE3iKM4xocgNxpUgkLB8bSkzk23CZsFpNPqre7nko6EUyTS	18650	3NLfzSxvjFGcKcrZ6SprdqEEvmvSSgNd35wh6qzVDooX5g7wpgmt	1406	1393	323	6301	12463	jxWNCE89qAG8vMc6BkGaZhk9pRjYhjTrjfpNLErJ4rA7AkYoU3m	9398	13268	13268	1618327440000
18657	3NKatP6JgrkHx9J3mQCB1bM1gcZZduXmMkxM4taHncsieiMPXC3V	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1507	1034	323	6301	12463	jxoZXiw4htErrHs9zXii5LrTA85MJNMTLKaciGPfY23bMVEWrn6	9401	13273	13273	1618328340000
18661	3NK8uSt2mrjHyaL49Fk3x5vqEj5kUyxaDB1rf3gxpD5M3bU3jKkr	18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	1445	1044	323	6301	12463	jy1M1qqrhaFYdaKHUKjafVgGgp2BzFvM9n24wXwY6NUwW3wqLkk	9403	13275	13275	1618328700000
18663	3NLVkj7WB2SmmfDuLyTu7eZuVBjxdCnXtixVstD4YGcvMVt8BiuX	18613	3NKTDV3nLQyDRdsP6PDfbBWxLLHhCnbuasoNK12VfFfDYiAunT7X	1631	794	322	6301	12463	jxC9AhRomiVF9Gvjj9r2t5keLzHZNLAfLvdJE5SJM364PWeDdZ2	9379	13276	13276	1618328880000
18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	1460	572	323	6301	12463	jwPGXNfg98sm3E9j6P1MSBjktoXp7iezf6dhpXYrEYQrbmCZTTi	9407	13279	13279	1618329420000
18674	3NKTRvaBdzz67FC6tGzaYh5PTH8hKZDANYnUXNwboP9rSqGHY89a	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1547	1378	323	6301	12463	jwXic8F2nFREVMwaUpW1nhpyCnfDaGRwYgVoqpU2p35DjqoJx5N	9408	13280	13280	1618329600000
18680	3NKzRV2R79LUUcYtod3n1Wf6FtsGRUnZnR5eXimYTAA8fVpGtgT3	18679	3NKpZ3Yky2jzgAffKEjXLJm2VtCPDU9ZycwqaTVpuScNZd2NPUeC	606	929	323	6301	12463	jwGkWA9hP36ZtDgBz58UYzKv5wcsMcQ15EyDh8atQsjir2jtAD9	9411	13287	13287	1618330860000
18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	149	1283	323	6301	12463	jwgttPrjBEbPjcqamNGsTWjD6jZcSeNcmK1QosK7hHh7TyK6Khc	9413	13290	13290	1618331400000
18692	3NKNzNcxx6vvsxi7BcqvC8CiGAJEnqHC4t7eQ7GzNx5TE5BcgcBK	18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	1610	1314	324	6301	12463	jxafLkq5cHqQmC2WWjaFt8DXQrwo82GXyN7CRdQXdmwbH7TrcgH	9416	13293	13293	1618331940000
18696	3NKhynAtsrAvorB8BCMX12C6QrowXbRV7U6w87pYGvgR32J1PRgL	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1651	1055	324	6301	12463	jxu4iXeXxETmqpGPoai5sip9cJo5Kq4QLqpAe5EXp9LpE5MoTs4	9418	13296	13296	1618332480000
18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	1594	1326	324	6301	12463	jxBhRNfnEDgar8MQA655giN2S1LNq66TRKkixBm5dLQB1mM9h7g	9425	13308	13308	1618334640000
18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	18719	3NLwXBDvYCSkeB9QEVtpEfgpfG6RwB7m7Wmz3XUKoHEBaWkr2bTf	1406	1393	324	6301	12463	jxSEsUE6rJqyfyGgqfrn4p1jsjRk7seh2yp7Bu2k9n7EiWKetnx	9432	13319	13319	1618336620000
18722	3NLDqxM8RStEDcKAYtniWxC8Y2cfD6s5SwEufTBjXN8B4RLjPi5H	18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	1631	794	324	6301	12463	jwXUmf1JD2vnBYhrPLkUCZCFEyuuDHvg4axXEGHLSaDak1oGKUb	9433	13320	13320	1618336800000
18725	3NLr7nTa6gDiiQ9dsBtr4H56ubfNSZQdqqGBcqA4Gkcb4kMSt975	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	1406	1393	324	6301	12463	jwWFvZxV5jMCVBzEKJVQYChqGQbPPcqJekjtyM3NFAgbQjbkWGP	9435	13323	13323	1618337340000
18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	1588	1266	324	6301	12463	jwabssKWPCMSc4U74x8Wdowrzt9ZvB59bwqpZQ1Q8Uv14zEaDSe	9436	13324	13324	1618337520000
18732	3NLwL6cWZ2ykeWrMocqDTSBeREZawqRSEoQgSbDBvYBSdkCLdEwJ	18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	1406	1393	325	6301	12463	jxBQN8xB9u7m9PpZFsQdWoJM1fSxzpG2RZkvgeSzo9arXzEycgb	9439	13327	13327	1618338060000
18737	3NL1fUan6y48GHEasCkAug9jk6TCVvZqP46Vj9d2TcW8NgZGUAW9	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	1407	1395	325	6301	12463	jxX4qAyVWJtiVPPQSV9DUeH47SPXaVMTdc6rH98PZfUXxRkZoVN	9441	13332	13332	1618338960000
18742	3NKCNwgeTP7rZU5rqyEQ2akwUhrzwHabBg8E3PmzjB2tUur18jsY	18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	1601	1142	325	6301	12463	jxaRwF8bWBnzm7bUvreNKZByocBB8hkaUvtUor1tBgFyuxbiz3m	9444	13336	13336	1618339680000
18748	3NL222n1K5s68n46TCiC9GHcgEgff8WwsMoskKkHZtH71sFBZFHg	18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	1649	1017	324	6301	12463	jxYVx27FYL31Ghm3MKQNxryJj6wcZbHqqQEfW5XbK2Nbtnk4DuK	9437	13341	13341	1618340580000
18750	3NLTwWQZPuQN84STfdZWjPFSiMnkcS8bdc7kYTfSomN75BTd6eAL	18749	3NKWNjWdt7W4SEQ2uMygocSZddkYDFsfRnw2Yx1oC2dKJm4d3HGS	369	1186	325	6301	12463	jx2yAt1pC97q255TGADx6Tr4m6YT1dUcohCRUjhd7WfDTuLyxaU	9450	13344	13344	1618341120000
18753	3NL8uKsRATMXa74vPgLJaky9rPXGYShNNuiukmrS91pcwhmrU6eZ	18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	1471	1260	325	6301	12463	jxgVa7h7Wm7PbA32SiKXDPWrei41Vbxts7tPurkr7DpWUYB9nmY	9453	13347	13347	1618341660000
18755	3NLUMLtTGdQowi2pPLXNvnrBDc2HioZKAH4i4E7MGiYNNpT821xo	18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	1594	1326	325	6301	12463	jxt64XDY7vUSRS7B1fUaGHupaJQuyEdhSCkJwSYefeynRHkdGRQ	9454	13348	13348	1618341840000
18760	3NLH652q7JeT9C6T3ebVJoVeXe6YfpxpgSTxahPZ3zxHo7SJ5BcK	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	369	1066	325	6301	12463	jwA1AEHby2KZ7dNjmyVtbNFsKEDnRegBSuQvSMmcnCzSUPkM29U	9457	13351	13351	1618342380000
18762	3NKREpB6hMSSKvGN3KXC3nTLKKEDW8BHFou6mW8NtvCvA3Eodjqg	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1406	1393	325	6301	12463	jwBEJT5ScN7koCHD8CrMt4zSsjGEXthmbYchniFLM2K6kN938Cz	9457	13351	13351	1618342380000
18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	18620	3NLPb9CnTyR4v9Q55ZtbVgNjEnsXEsEPdXU6VYLNFDryt8v2QMTV	1403	782	322	6301	12463	jwFDedYX5nnLC2uzhRcuaDJz6VV9SzesMMhiPNm3AyLFZBrCZzT	9383	13244	13244	1618323120000
18625	3NLY2cBTan9VqUV5m8KxfhHK1DNRdy9L7ySi5SPtFsDw7QhzmTpq	18624	3NKThLA9FeFeVQCTSx6NLG1BFUGBE9NGneQ5huz32sXm1qxWdoWk	1483	910	322	6301	12463	jwPjoQiwzArTobyRDJ5Aa74baQ3EntevGEUkrezJ46sTuAyeQW6	9385	13247	13247	1618323660000
18630	3NLG8sRhebaHo6cCUMUKPnQTJmiybDYJhWT3rZxXUnfNKqUYEF9i	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1403	812	322	6301	12463	jwJjvM2cY4jxMwDLix2JuUspXhJ3ht6ro1kaFH3BAeR2xxwohMA	9388	13252	13252	1618324560000
18632	3NKnDfYmcuXzcuKXsA2be7PcrycXA1RoPjzBP7taF6AmJkJS9qFU	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1581	778	322	6301	12463	jwgWRtpA2xF5VkB6ixpMYdGNxzuuBgX3gFob9LjuaURxzAKwCoy	9388	13252	13252	1618324560000
18635	3NLJM3526cWLFoLjc5jx4BC4BuezoECeR44fQ1F7ocNDLojXWwss	18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	1407	1395	322	6301	12463	jwreos6EKp8Qz4xGBrhup15DBvChGwa77eYhPTw1L1YCtfr3gEA	9390	13256	13256	1618325280000
18641	3NKvYXh94LCKSRZtUBmwiawnFxaLkc9pHYq8nNLh5P1Ar9yhB9Ay	18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	1650	1249	323	6301	12463	jxLshPHg8BTeVgxnNZiiKy9jqVWfJUQgApJnoGRztGioyLnkyGZ	9394	13263	13263	1618326540000
18644	3NKqLyAXPrmK65DzQdCrpaNHfFZ9ycDScV43Dnt1pg4Rm6f78ZAj	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1501	1360	323	6301	12463	jxvaQbmuBu1eZHN8S69MoMWGwiWKMwf23UCQqLzkkQE42uGBPsQ	9395	13264	13264	1618326720000
18646	3NL2qUvRJtghqjt37WnNBy7zrVBUcJ4PFsjGyiRSqsoANahNX7AK	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1474	1329	323	6301	12463	jxRUupvDQtfKQJPYTkAgd7QtEofbKiopXMYR3ohAwq1KrPY5FQs	9395	13264	13264	1618326720000
18650	3NLfzSxvjFGcKcrZ6SprdqEEvmvSSgNd35wh6qzVDooX5g7wpgmt	18648	3NKNXvTgf22TeaWocALw5moEJa3yka8YZnxgW3bwJGS6UZiEUJUh	563	1233	323	6301	12463	jxP3KrLpoQGGiwu2D2Caowv52H6kzhJ5AMSGXEwT1vLeXitUNxw	9397	13267	13267	1618327260000
18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	42	42	323	6301	12463	jxHa1QjpJtBvdPQwXfTb3AdVXs38TiuyyNAMTAR4eBDuD8V963V	9400	13271	13271	1618327980000
18656	3NLf7kKv8FVtX2nKYLqsB6tkVWVY1zoALL1aaiQLiPjW8n5w2Gwq	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1594	960	323	6301	12463	jxkN1RQjv3AF82hi8SzshhZQnuDgPWWfN84EmwQifF3o4pteggf	9401	13273	13273	1618328340000
18659	3NLSaQe5bFyxF6KKCNEwKsU932UsTBLeN13XReUqBKYmFcwhKyiR	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1581	778	323	6301	12463	jwfTCL7CJRe4TFq4jy46sYVZUWzc6cwmVWkDuEvALbJcfbdqArE	9401	13273	13273	1618328340000
18662	3NLgf4ZZwr7Qf8875snWQ66GLtvukFuNMqWbceZtiZxnSGEYhwnB	18661	3NK8uSt2mrjHyaL49Fk3x5vqEj5kUyxaDB1rf3gxpD5M3bU3jKkr	1406	1393	323	6301	12463	jxFR2EpRbbrYJGBeDRb12oQYARH9rk7icsDwA6aEfJ8p2exvS7k	9404	13276	13276	1618328880000
18667	3NKpJfbxiRhGurtSMorwHfPJViGfG8idDA7KfYpHJDW8LRMacCpN	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	576	1355	323	6301	12463	jxUNQoEVxm5QhsCreLvtT1DnVh2cYNvzcnZrNzfN69zgUNCP2DK	9406	13278	13278	1618329240000
18673	3NL78VBhT7TUVYY9agFQ46CQBKNjnJAVa1vtjoZ4TRhpV7A8AZvn	18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	1506	1373	317	6301	12463	jxqVBhL2Fpj2JVa4D9RNcpTN8JMByzMJpg3shxnWy4naFKJdEJK	9276	13279	13279	1618329420000
18675	3NK3oAFSJ7BcQMUhFPHw4V3mLtL4uZ2UtnLcSXtRVbfnJi6UWJJt	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1637	816	323	6301	12463	jxPKsNnCvYTRfojFu2Rpk1Kd3De3q8vdkLWZdL9w3xCywSXkJRM	9408	13280	13280	1618329600000
18677	3NKxLDXkgLB6ykRc4x6NBqDxrdLwUZaUFgGr5XMM71gQc3rAxtur	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1547	1378	323	6301	12463	jwFwoav1hUzhScDLsUJWAGFDAbK8ABpku1AjaAZf8VsffkprUpY	9408	13280	13280	1618329600000
18681	3NL3xCF6VsWKAnXZnco5TxVi5H83YH4b5by6M7jMbJ5daBsQQ8jN	18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	606	929	322	6301	12463	jwJvV1kYaB5nv4MVRk12LGC1gkPrmYKc64NHJposXo7fGyb3cSK	9372	13287	13287	1618330860000
18684	3NK51uodosEXMKBkSUVy7YHFe2JZnnRz2eXNwBCLNunrd7dmgFnk	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	1560	1291	323	6301	12463	jxKvnqdEYdDAASo2rfLFB1us3tYGKHEiyHbxuhGvpET4YwiTN1D	9413	13290	13290	1618331400000
18686	3NLTKW2MDeNHMCzXXLhBVtYPYNed12nibDAJJUq5pLDpVyoR3CoJ	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	80	1027	323	6301	12463	jwSCMuXdMLgSc48Kc3QHqGxPq4VrQwK8GPCAsU2GL3hGQJBLWzv	9414	13291	13291	1618331580000
18689	3NKoGY4vxS1hitQhM6ouPL1uPMzkhEfoGdLk1CjnbrV7PsZbKsxX	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	80	1027	323	6301	12463	jwvnoZaUqUCbePiS9smgjAHuXHNPaWaqfk3b54ejmbd3NhpKmjR	9414	13291	13291	1618331580000
18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	18689	3NKoGY4vxS1hitQhM6ouPL1uPMzkhEfoGdLk1CjnbrV7PsZbKsxX	1460	496	323	6301	12463	jxhugE72JwMnaoFs9NQurfDZHycUF7HdtsRxcupA3DKeHAyEPBe	9415	13292	13292	1618331760000
18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	1656	1343	324	6301	12463	jx1z2rWCZ3uWCD3boHJbueTtskmK572umm2gprWcAX3zbfoRRcf	9417	13295	13295	1618332300000
18695	3NKyxTG9NjkkhakgqJ2imobM6fKyRFuehfP4MjpitxpW3WZVNbRt	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1563	66	324	6301	12463	jxDxYYXcaLMyteF3jszGG8HQJivT8jdZ9uppAoJZ4Ac66bEN4ss	9418	13296	13296	1618332480000
18697	3NL4k3VKQJHqg5BcGDdBrP9e63jGrhseCm5hCfECcDxWJD62hLzD	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1651	1055	324	6301	12463	jxtXtBEw2KWFtHyMsEeBPXnSfkATBD9CZnQYsKroMXadi7MqMS1	9418	13296	13296	1618332480000
18699	3NLRpjwc3HYceoa14eJpHPLPSSkBhJ6B318c3523DjJ8kvFW6YJe	18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	1476	1125	323	6301	12463	jy2LmenXotgXiBCpdKyGfjAFTy5YR1BMu7evo6ytNgjXazBNfZf	9410	13296	13296	1618332480000
18702	3NK3v655QRabdtZj31FMUrNPhaT1oetqan5kYE5jzS9bhZZoh4Yz	18701	3NKQwQARXZXPH2U3Nd7kCMHkmJtDbNkN8w5spPsDPubnEJwkp8uQ	1481	790	324	6301	12463	jwnGXTSvGZzrhAMwEDBaxBCbHtweZM4PAfr3SoH1qaCJgvnnxwT	9420	13300	13300	1618333200000
18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	18707	3NLoy2m8XiFsMKUfBC9pdpTM1sKBgUya7XateXh6N9nt1numrf4a	1637	816	324	6301	12463	jwkkrB7F2D3kKBK9oHdH4BaTv52ps6ALmbWRVy2QUmTKAa3WeSw	9424	13307	13307	1618334460000
18711	3NLs7aehCJ6N1yePgaudw6CWVqRyskR6PQnTZn7dhhbmh1rgv9CK	18536	3NKosuVXs2mY6zm28DubDqdyJpYHArfFW4tAZziAMF1JP187rUbd	1634	1205	318	6301	12463	jxsNq9UQav6erpv9TXt45wtxshMtqR9hD5KEFyNCgxLC79jnAZ7	9300	13312	13312	1618335360000
18716	3NLUTTJpqkJtroLWzSTB2T4ipVAjoFwPirVFVA7ZCHGhnC5yS1GF	18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	1403	823	324	6301	12463	jw6eXmEH5ygFjKaswCaH57LUXDuh27d1C8w9fGQwLnVHtg6J9Ev	9429	13315	13315	1618335900000
18718	3NKYhnDca6EHV8wP79PZYodiux4sbtPJGE9HdT5RPNYZeusJ1VKC	18716	3NLUTTJpqkJtroLWzSTB2T4ipVAjoFwPirVFVA7ZCHGhnC5yS1GF	1407	1395	324	6301	12463	jxsPze7hSqzXFqhr1qsXPNVgPvJ3krKGrD44rPtHHWtBme3XL8L	9430	13316	13316	1618336080000
18721	3NKPRjEic1R7uVTAHZQ1MvoeuCZnLdNv4r4HPrEAqaHa5N4wicFw	18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	1513	1379	324	6301	12463	jxWswNAYVuGirSYHWf2qMGZF15cwKCiVZ4JUXpR8wN1yDFyr1i6	9433	13320	13320	1618336800000
18623	3NLrtZAQZ1DgMHRQFNPygoTu9EFKpbq4v15GAh9nGToTKQ94xrwx	18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	1463	464	322	6301	12463	jwDUwBnL2mThHzfaBoifSes8BgwN1L2grYSFBeYBEbxJrCHJFoF	9384	13245	13245	1618323300000
18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1581	778	322	6301	12463	jxv6M5DS1P6WS6Pog7KSAXiES1sAbbMuvux1BrL6toKV6LvCH2N	9387	13250	13250	1618324200000
18631	3NKMSvs41b17zHZRjgffVSqbUKaNHY1ycT8uTnYyygK5F5wUigdz	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1490	1148	322	6301	12463	jwvcjqyryTAJdXfLa85qTUUCxeT1a6uVq3nK6yDmFJxbYkAHFYS	9388	13252	13252	1618324560000
18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	18630	3NLG8sRhebaHo6cCUMUKPnQTJmiybDYJhWT3rZxXUnfNKqUYEF9i	576	989	322	6301	12463	jwMTbfhkbD7WuA26KVEKUmsQ7E4RvYQFaGUTjBf8sDdfbBU6TTw	9389	13254	13254	1618324920000
18636	3NLQgcNqgjD3EhZz7qWSdoATkWpk9U16qxeRRBznHH6EiDhzejK4	18635	3NLJM3526cWLFoLjc5jx4BC4BuezoECeR44fQ1F7ocNDLojXWwss	1403	823	322	6301	12463	jxo7cAM77xk14tHnsrLUeXoC52Jzv5kVuFX1zTdjVphCtiiZ6jo	9391	13257	13257	1618325460000
18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	1407	1395	323	6301	12463	jx7muko8iPaKghZLY62C5KnfXBLFMx5YTehr8WHkD367D9psf6X	9393	13261	13261	1618326180000
18648	3NKNXvTgf22TeaWocALw5moEJa3yka8YZnxgW3bwJGS6UZiEUJUh	18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	1590	1054	323	6301	12463	jxtVCxHAFEnzGTwTe4Sn7ct5zk6GC2qgAwSEuRzt5LEvbH7rqQs	9396	13266	13266	1618327080000
18654	3NLuj8K2fBwMfWhhuvPhKSU4UjTMeDcXC6oi6VSMBMnZQeAetibr	18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	1579	1023	323	6301	12463	jwGkivpaFACuf34iFgCzPJbVkU42rKyzRrps2d477srtRvX2LYA	9400	13271	13271	1618327980000
18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	18657	3NKatP6JgrkHx9J3mQCB1bM1gcZZduXmMkxM4taHncsieiMPXC3V	1650	1129	323	6301	12463	jwfoyDDRyjxhkxYte8ZPTnvzUN1SmonHG8BvdUiUT5XphUH5dze	9402	13274	13274	1618328520000
18665	3NL8VzYoiXrRh5Umm6ytuNSZAuDJywnG5zdFbBQtTgwKxUTx2ysQ	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1547	1012	323	6301	12463	jxc94ufCXm8RaJF93Kmy6kj2PsSSz1cb32oN14P4xommrq6iVqw	9406	13278	13278	1618329240000
18669	3NKkePwAYSAdAe3gsTmRz1xoQAaNcZ163q1w8WtLzDg2q5Dc9u95	18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	1547	1012	323	6301	12463	jxGV5miHSHDoN4bQCCB6sF6aHjVMbvby3u2Y76snfjBThT4MC9S	9403	13278	13278	1618329264374
18672	3NLQ5M8JeeAF7tDG71uLDNgFa23AutpbS13LmB4iTqWjPVpxRJ6A	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	448	939	323	6301	12463	jwx9XY9gAM4nSSJNL4ntqY8S8MrXsQUCXcDrQ5mPxYUDgTVNNdN	9407	13279	13279	1618329420000
18676	3NLmwhHovUSF9m4GZoMnQFg3QzHhdtR57nHcwvAkvL4YMfCmBbsQ	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1407	1395	323	6301	12463	jx3N8VJ1JHBW5u4CckaReMKjFdoeoeR6sN6bwFkrduEGyZLtnfA	9408	13280	13280	1618329600000
18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	18675	3NK3oAFSJ7BcQMUhFPHw4V3mLtL4uZ2UtnLcSXtRVbfnJi6UWJJt	448	1179	323	6301	12463	jwREKDLVSf6HeZHrh4sUyRW9XTHr857E3MEj9c3bTgwXtMByqNQ	9409	13281	13281	1618329780000
18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	18680	3NKzRV2R79LUUcYtod3n1Wf6FtsGRUnZnR5eXimYTAA8fVpGtgT3	1407	1395	323	6301	12463	jw7xX9gsFX9UZnNPXpHUhCoYjsJJ5V6AXS676xidF681ojvenE3	9412	13289	13289	1618331220000
18687	3NKeiaR2vgoecdn2hHxKDHhtieZYef9bn33jtmPLpJyY5zpQdvWP	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	43	1310	323	6301	12463	jwrVKy51EK1fD4kgY2xuLMvcp9e2jfoFkHyHoEY64Gck7VeDGD7	9414	13291	13291	1618331580000
18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	1610	1314	323	6301	12463	jwNdVatdRfJTBxz71iUJEFYDsVbu6aqzjvYEVhmAMhq1A2ZViDF	9416	13293	13293	1618331940000
18694	3NL2dMZyFfuMPw2rSN2g9cAwg2PtCmMUza13ui4fQGb4idMK4m46	18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	1656	1343	324	6301	12463	jx1z2rWCZ3uWCD3boHJbueTtskmK572umm2gprWcAX3zbfoRRcf	9417	13295	13295	1618332300000
18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1476	1125	324	6301	12463	jw9xDusH3K4qzCmstA58vLjauw46eb4zLBpQaUe7BqjiZ9DPDFV	9418	13296	13296	1618332480000
18700	3NK58CfE7ZUVH8nXQvpGuPiwycs66sMTMBkZdPYKXBzTyko4LWqi	18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	1444	1381	324	6301	12463	jx8MhcZ9koTnCvMqEkASGJtHqDS7D7J3nT39QVctmr4foG5i2cR	9419	13298	13298	1618332840000
18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	18702	3NK3v655QRabdtZj31FMUrNPhaT1oetqan5kYE5jzS9bhZZoh4Yz	1596	1363	324	6301	12463	jwhvaSuRF8ZkrxwZcLEwdJ96BtAcm81h248aKb3nUNim7DeaNS2	9421	13301	13301	1618333380000
18705	3NLXJ6bmqnA5N5euQRQ5oVdAEpSYfWCGWGSuP1euZKx56dkSUrD1	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1490	1274	324	6301	12463	jwi9i6r4Rg2mQs69GQ6LHnzQN8Kj2pGccgGyd81jrKiXDPjjNAq	9422	13302	13302	1618333560000
18712	3NLXyY6B7p5LuMszkDTikftw3ME4uemVuzFziLNhvgrLQEEvnGgP	18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	1610	1314	324	6301	12463	jwEgUHZnc93ktYBJ6abdpiEUCt78rHPnbAwZReZaaA5KC76G3JB	9426	13312	13312	1618335360000
18714	3NLgYTjJcXJksuG44RJfwCLinsGRCVL7jQYffghpqw21Acet7nCj	18712	3NLXyY6B7p5LuMszkDTikftw3ME4uemVuzFziLNhvgrLQEEvnGgP	1590	934	324	6301	12463	jxmnHP8ed5iYyXyMeN3dG3uW3hgxo12zKxn9jGABQ94jiaKyUGA	9427	13313	13313	1618335540000
18717	3NLmW7gTbqpP3yAEqD9GJpwEHMKsD4eYLUnwZc3eN86CmrTy4G8U	18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	1534	1317	324	6301	12463	jwgXv6JESYcvkZf8qGmiib3KiqDzEcuKkYTo8udqh8HRpgg1mWm	9429	13315	13315	1618335900000
18719	3NLwXBDvYCSkeB9QEVtpEfgpfG6RwB7m7Wmz3XUKoHEBaWkr2bTf	18718	3NKYhnDca6EHV8wP79PZYodiux4sbtPJGE9HdT5RPNYZeusJ1VKC	1522	1196	324	6301	12463	jwB8fqFFG3WLZ3VvjuVg213RKNHVUcJe5Rbx5hQLrPwJxxjT2QJ	9431	13318	13318	1618336440000
18729	3NKi8H9ZHPMfHS6YRGnhpAxZUEWGukqcUETeQTMZjj9YSyJG9U6H	18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	1406	1393	324	6301	12463	jwc7aUXaVs36cdjM79ENERvpAojPNrZ5ENGADLGuy8X13yvvVdE	9437	13325	13325	1618337700000
18735	3NLrKpMqBSdsuKjuexRZA9v4BJ5paBCjvRTveKntAa1GxT13stK1	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	298	1182	325	6301	12463	jwXnwcishGt58YWaWVyTMq3T3NncQ5aeS9YGtZ55eddV6mTTbKg	9441	13332	13332	1618338960000
18740	3NLmAnu2WYWH9T6FGGCVUpHUNpncnEG7cZaP6entjnu4nmcm243X	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	606	929	325	6301	12463	jwtD6Forv5CWaUbp5LWBYgr8SEsQdNrNFz5SHzby6nQazuuU7Rw	9442	13333	13333	1618339140000
18744	3NKYX8SLYNq28d1ApfTksSDh2Bv1GCv87UifWVw9Kngti2vKKMNm	18742	3NKCNwgeTP7rZU5rqyEQ2akwUhrzwHabBg8E3PmzjB2tUur18jsY	1564	1338	325	6301	12463	jxE6ikgP1fvNVBnsMS4KDrcdE7a9bR9QSEgT8Dt22qG8sTDxY1G	9445	13337	13337	1618339860000
18747	3NLLwA3Yt9oKq5MHpSkZHypFWht76PsQbYmrUTKvVxq1QRMXmLJb	18746	3NLpZJVHyGpMH4LEZ3ytnJC8fCqwaYgWowesWHDkh6R1yfSz8DQ8	1649	1017	325	6301	12463	jxUoxDwyvrNyyk6tSjneKvSMY6kfghg2L5ZNFBcmYXTHx8nCQs1	9448	13341	13341	1618340580000
18749	3NKWNjWdt7W4SEQ2uMygocSZddkYDFsfRnw2Yx1oC2dKJm4d3HGS	18747	3NLLwA3Yt9oKq5MHpSkZHypFWht76PsQbYmrUTKvVxq1QRMXmLJb	1407	1395	325	6301	12463	jwdnYDERXipsMUv2L7LyKoShJ1LKkte5oRfgzV7zTkxi6RHodAk	9449	13342	13342	1618340760000
18624	3NKThLA9FeFeVQCTSx6NLG1BFUGBE9NGneQ5huz32sXm1qxWdoWk	18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	1476	1371	322	6301	12463	jwuh4qaqefDZwsdQ5r1EMBc6xv2CiaWBygM3Gn9kPfPJgLXCR6G	9384	13245	13245	1618323300000
18627	3NKDExz1HRME7UxvNktr46xjLe699TRHXW29CtWnnenDgqMAyVUZ	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1406	1393	322	6301	12463	jw8BVaEgGGRvUrTwsWncdNZFyRfF7wjSfxTGxkxUa7tvUB7dkNL	9387	13250	13250	1618324200000
18638	3NLKjr6wze5Uu52q9K2WGiS8YDEexbeH34yeYu9PDU6B2F56ZVvo	18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	1571	1335	323	6301	12463	jwoFDuebYEQzf21aHyPjmFXkFZqWHQd2jkWEeL1hdXj5bJoHZuY	9393	13261	13261	1618326180000
18643	3NKTCNeC4neXpLxWT5CmUJzcvDP7s4VzH35dY8rZYAnMGQnUyuuZ	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1509	1194	323	6301	12463	jxpxb8AhhU8e124Ug8BX7KpgNWiN5cRine9LAJWisf4mth2kY3D	9395	13264	13264	1618326720000
18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1474	1329	323	6301	12463	jxUBGDmvkWMjWtetXK2EVPD4ZpXCh3m965yUAqkzh4DkTAisTuZ	9395	13264	13264	1618326720000
18647	3NKHM5yGVR89gZKGWFJTP83Qkxo8ytvAwbYgNDuwKFmrc2iH7BNK	18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	1476	1371	323	6301	12463	jwkNwZiqq65149rtMpckiJGKRegiNBMueyvN9W14yKyWvfRctzy	9396	13266	13266	1618327080000
18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	18651	3NLC1TE3iKM4xocgNxpUgkLB8bSkzk23CZsFpNPqre7nko6EUyTS	1406	1393	323	6301	12463	jxrFbBYVfys3XUFt4PeWsxSP6R2Bhc6hCBnYqaoZKo6jZ1iCrQX	9399	13269	13269	1618327620000
18655	3NLnQyQtRdZ8oaFstG9AfGzfASj9aLYAS3KM97qwVWvGDu1QkFPA	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1668	1370	323	6301	12463	jxYDEMxaAwxGjaKRwZPEz57xyz5FVscrqLpqhXsmmcYkY6a2Vjq	9401	13273	13273	1618328340000
18658	3NKwstKCGeh2uQQApZSDmvKDvybZUBy4ePtCRsnCKaVWYn8zZig4	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1573	1192	323	6301	12463	jwST8BFFEjeHWxMLmbCi3ivS3UrHCg7nKVbtcR9DjRJvN91wztK	9401	13273	13273	1618328340000
18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	18662	3NLgf4ZZwr7Qf8875snWQ66GLtvukFuNMqWbceZtiZxnSGEYhwnB	1397	838	323	6301	12463	jwUxtQBsz5y3tN3Px6s596nVTpk7nMZNbdRFGeMQUSiwA7ffZvz	9405	13277	13277	1618329060000
18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1403	782	323	6301	12463	jxANWjJ6QbNUd7bot33TbMjEQBuF85iVcukiYNTzKP3BYJtehvu	9406	13278	13278	1618329240000
18668	3NLQzRwu8YeiZHRLxt9ysRT6RpMoQRYkcaxYC453iZW38Aa1Batc	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1581	778	323	6301	12463	jxawSe9o4FzQScVJcy5Trc8tA4fqGx2S6T88tERRkbSLLu8gJeR	9406	13278	13278	1618329240000
18671	3NKSf7yuwn7kRj3rnf4oZrDeqjYs7j4UQyQAX3fqUkXm6bmKgbjp	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	1506	1373	323	6301	12463	jwqMeXJvwYjFA2DcBDfSpwJzJiCdvzR7JL9fS9DFnBYsKFyxciB	9407	13279	13279	1618329420000
18679	3NKpZ3Yky2jzgAffKEjXLJm2VtCPDU9ZycwqaTVpuScNZd2NPUeC	18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	1403	824	323	6301	12463	jwtQ8geU94RHNWbh3sm2LBahLRwjcKBwitp8xvUvVKTBKWzyXZT	9410	13282	13282	1618329960000
18683	3NLt3FvzMcoHgXvE59pzoWgcN1gtgUEWMdjLZVRiZxziS6FJT3HK	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	1560	1291	323	6301	12463	jxzBTmBhqtXc4mgh77rMM6zjuofZ4GLTACMhqvppqCbv2NmV55H	9413	13290	13290	1618331400000
18688	3NLAVif7V963x921KP11dzFWdRGPJ4AwdV7vLF9YKx4Da3vuety9	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	43	1310	323	6301	12463	jxXBxtn5K44rgG1PJpfVLADaagrp93b5y7k5hoD39GqjBgKF5su	9414	13291	13291	1618331580000
18701	3NKQwQARXZXPH2U3Nd7kCMHkmJtDbNkN8w5spPsDPubnEJwkp8uQ	18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	1403	824	324	6301	12463	jwzTE2XcVopKPR6LtL6GQ173ZSvyCkiswg2UKYdsHSfeWZW1qbc	9419	13298	13298	1618332840000
18704	3NLVN68wQpSysCk9SYS9UabZyCPy6yoh9gpmyF9YdsR5F7V3V3as	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1500	1297	324	6301	12463	jxoT6EcPkFweAaD3fE1kgNb9Vc9tWXpEDnRAqUMvVJ5L8D2vnoQ	9422	13302	13302	1618333560000
18706	3NKggiEDbJYN1WGhLHXzdvhETiRamD6wauYCnMZxs7Rgmp8ywoaB	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1407	1395	324	6301	12463	jxzwA7zpRG9qNAFifz8mwdKsYzCWkNVVFmffFvA2giHF9eVaXh5	9422	13302	13302	1618333560000
18707	3NLoy2m8XiFsMKUfBC9pdpTM1sKBgUya7XateXh6N9nt1numrf4a	18706	3NKggiEDbJYN1WGhLHXzdvhETiRamD6wauYCnMZxs7Rgmp8ywoaB	1587	991	324	6301	12463	jxxCH38beni27VT3eiWEjeSPBpFk2BWR9mxFHug3PFZh1wVzUS2	9423	13305	13305	1618334100000
18710	3NK8YRu4TfTFUUdcoktJxKWfxwbRmHqPnJDq6j7KHJCnMQZPBuek	18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	448	939	324	6301	12463	jxVAS6gnyET2KYW1LojHemTVZZYaWLz6V5dZiBTvTWwco4Dr2p6	9425	13308	13308	1618334640000
18713	3NLbpfcfXMyWrj7ZMGh3LU6srH4hEBJDUx9G4HKucxzFSrXgbQ5H	18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	1460	496	324	6301	12463	jx7DkBXtRzSaL23gzi8c8Wdir9cPiaEu4Hnxufnj4hQp6Em6VtH	9426	13312	13312	1618335360000
18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	18714	3NLgYTjJcXJksuG44RJfwCLinsGRCVL7jQYffghpqw21Acet7nCj	1623	829	324	6301	12463	jxM7rMQXyuZnBNFEbkWB7o1tEjEB3aNme9F8xzYw6XgCZyj2ZBt	9428	13314	13314	1618335720000
18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	18722	3NLDqxM8RStEDcKAYtniWxC8Y2cfD6s5SwEufTBjXN8B4RLjPi5H	1559	1107	324	6301	12463	jx4DyGS5A8gFQxovMxp1QFpBywSQiwCGgDnTQQdZxMuw2aFa6YE	9434	13322	13322	1618337160000
18728	3NLefpUg4W79bgCJ7tuQZSfDiKaLf5xZWtz54FKauDoA2fAkr6s2	18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	1460	612	324	6301	12463	jwqhWT2cCyuyTzpkMykGfwcdPomq9JoWkGirsLzDYErs5XUs668	9436	13324	13324	1618337520000
18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	18729	3NKi8H9ZHPMfHS6YRGnhpAxZUEWGukqcUETeQTMZjj9YSyJG9U6H	1457	1391	324	6301	12463	jwUPqD4PeuoNbyXDBAtE86YzsqeBMUs9zpufQbbEZDwGK4z7N3u	9438	13326	13326	1618337880000
18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	18732	3NLwL6cWZ2ykeWrMocqDTSBeREZawqRSEoQgSbDBvYBSdkCLdEwJ	1593	1346	325	6301	12463	jxYF8aeejfEQ4H6UQRkzmh4nrCq9fDaLMKBA12nkRuR4dEXr3yH	9440	13329	13329	1618338420000
18738	3NLmdyMeiAq13GC7Yd3nKWo9o9zjop4F1wLfeBrBzNBvFR4k7HXr	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	1509	954	325	6301	12463	jwE8GcbEcsuQRHhEYsuauqvBsWEq9hn7usc9VVLbvRnic2mXEu5	9442	13333	13333	1618339140000
18743	3NL4nFjeY8WKS8yootdhRCJGduGg3taQMJKFXzxDfLCHDeuEwJqd	18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	171	1374	325	6301	12463	jw9UqXTVCr6LGFfaY5CEWHTtuUcsABQJQ5cSSMVJ95SJG5QoMc4	9444	13336	13336	1618339680000
18745	3NKKjfTepE7m2AR8veekCnQ7vu3qHx4VWyeiWZhdQURX2FdsCQnh	18744	3NKYX8SLYNq28d1ApfTksSDh2Bv1GCv87UifWVw9Kngti2vKKMNm	1509	1194	325	6301	12463	jwFMhF6HWjaBq8wusMFsfRpYeSgY3QP5qKCbiArpyz4KoKCNwGs	9446	13338	13338	1618340040000
18751	3NKZeHGuswJdMdAuPBNJTT3ydVwcPjzP9MvGibh9Kvi2bs8zP3WS	18750	3NLTwWQZPuQN84STfdZWjPFSiMnkcS8bdc7kYTfSomN75BTd6eAL	1589	1286	325	6301	12463	jwUvKtVfiHynNW1h5RQ7e2KcVjVFUAdj5RBZvByjejLuQSBu4cW	9451	13345	13345	1618341300000
18758	3NKthpQMa8DXjv6bEqGcXnKFcLc1EDkPpA4BYgp874jfxJTyiSfv	18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	1407	1395	325	6301	12463	jwxKxtJ6zrnfw8tn7LMakZnQMVbKwFHdYiCiTc4KBbgdzb1eoUb	9455	13349	13349	1618342020000
18724	3NLwTqak28Y1uYivpqC8Q7fRgKwMfZVSodE38uMZoBdGrd1K3yuG	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	1671	1119	324	6301	12463	jxvr6wamunSS54bFZtHtxHeP3wFnXgVuLEoEu2ZNemtced8UKKe	9435	13323	13323	1618337340000
18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	448	939	324	6301	12463	jxTXaKhjUM39eJj6FApw3LXsq62M9uERnfmZ12mpbr7ie2gwjem	9435	13323	13323	1618337340000
18731	3NL3NbdTWu9ALzAWnb1f58KB9VPoKaowg25g1qEyp5midNaA2voV	18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	1588	1392	325	6301	12463	jwW2xjbYLYnhu1g4hVs8LY1fLVAemSNazvTSFoFwbn69xwtu4NX	9439	13327	13327	1618338060000
18734	3NLLGn6xeCGcMHcGbALnv34vpGY48LN6PxUcyfFyCPVWQ4Tkv6PJ	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	298	1182	325	6301	12463	jy3HUiprc6JtxdB1wkemBEMQk8krbVwmyn35qBN5EFhJRr959UQ	9441	13332	13332	1618338960000
18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	1601	1142	325	6301	12463	jxsertgnSvLro4BbiqfX8PAyzqDGgjR2Lz7oSXGwrQa4efaCsx5	9441	13332	13332	1618338960000
18739	3NLsfiD8pQw8qF8u2K283tUnvTUwXApoNKdYqtGxo6Rd4oc3PXFB	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	606	929	325	6301	12463	jwDvCcjCCBMSyd24txVdD9WAL4z4RDvEr38g9k7Kz15cbRRy8gY	9442	13333	13333	1618339140000
18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	18738	3NLmdyMeiAq13GC7Yd3nKWo9o9zjop4F1wLfeBrBzNBvFR4k7HXr	1648	1038	325	6301	12463	jxLtDqCyRyo1nTEvcwo8UP2cCY58tTxqKAasJdfDL6XU7psT8dT	9443	13335	13335	1618339500000
18746	3NLpZJVHyGpMH4LEZ3ytnJC8fCqwaYgWowesWHDkh6R1yfSz8DQ8	18745	3NKKjfTepE7m2AR8veekCnQ7vu3qHx4VWyeiWZhdQURX2FdsCQnh	1516	1294	325	6301	12463	jwS9oNiVFzohjDfuhaVQe85w4uyzGp8dhwV8FWd3JjpeENUnGcu	9447	13339	13339	1618340220000
18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	1457	1391	325	6301	12463	jwPo6kodkRCGsnfbnVqZy8UzZPwWu6KtAJU74Yp51Sq7PQS5CTN	9453	13347	13347	1618341660000
18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	1581	778	325	6301	12463	jwxMv1phgVBj6cWTCPWbbVvKqoJFxa6EuH4DCxuG6PUXwT7RKG2	9454	13348	13348	1618341840000
18761	3NKR1h1V7d7hJmQmmaqARZY273jC8mTDCcwNuKhXaW3ehPz8i47m	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	596	1180	325	6301	12463	jwbFY9Xqug3gkwPBkET37aVjMTzVmzgEB544QFmTDJCXVtBSQYE	9457	13351	13351	1618342380000
18764	3NLoLmCoeBXJ6WdB5bkLFCGARWCagceDNwATibe22PZUh3q2tW6u	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1407	1395	325	6301	12463	jxsgYs8DacXdHdvr1YrwNVG9wBETkKUVyvNvCp7MZZxJmP5zvwu	9457	13351	13351	1618342380000
18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1631	794	325	6301	12463	jwa86hwCNugfGj1umfa5RUmzZU5CQ3Fiza9JLEL9ZLq1DBJFPyZ	9457	13351	13351	1618342380000
18774	3NLARSkfTYQheJob8n68zxfgFW3yX4z92MhwMBPvMMxaXjoAicLE	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1440	1251	325	6301	12463	jxCVNohvYfwZo3YKUMfcHMNttu9BPgxTby3DmeW2CVCtkQhmrEW	9461	13355	13355	1618343100000
18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	684	1352	326	6301	12463	jxifz8ALf3irf9EEMqJnZJuL8D8WW9GqBURjU5Khft1FTkLuwEd	9463	13360	13360	1618344000000
18789	3NLtyCx9vjHCXiUvy4CcX7wdBT6h7jCffzY61LY2jniykwafRGXV	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1652	1315	326	6301	12463	jxwo3WLmHgz5xwFsuRax28iRdALUD1bCj9BYcFVE1ys3L3fPBYj	9468	13368	13368	1618345440000
18794	3NLvFTND8Yai9Af39s3APo3Bq7aSthT6Us1fMcFqtNf6yVyS5hK4	18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	1623	830	326	6301	12463	jwp2dW1SPpEg2WYY3nQv1FbmMqHB4B2Lv1k3t3m5zqWqb6hrgcG	9470	13371	13371	1618345980000
18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	18794	3NLvFTND8Yai9Af39s3APo3Bq7aSthT6Us1fMcFqtNf6yVyS5hK4	1553	776	326	6301	12463	jx2Tetsq5KgtmW9tqZFTAQe4igBeY9CBbJhNyHNDB787yfEKdqo	9471	13376	13376	1618346880000
18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	18804	3NL6Mtq6pvDMbY5qGKDMGzkcVBxq2DbHGEh4V4fY6SiWc1NAfqnF	1406	1393	326	6301	12463	jxfEkq6i9xRfF2ChFj1QSR4tvBzMqUdaUEC4HcN66frbCje91zH	9477	13383	13383	1618348140000
18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1407	1395	326	6301	12463	jwDX8F4BBi9S84XJfL4FXCEnPzPHMWswcJdTNyg6HpgjvUKBJnE	9478	13384	13384	1618348320000
18812	3NKsmk88Los7CdCBa8PFkSUvGaWhJpVQiPAqrvm8kiPQHP96ErKL	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	632	1136	326	6301	12463	jwccdw4g5AUu1LFmcLDm7D4XGRwFn5QM5868avSymqyNLGWrR9h	9480	13388	13388	1618349040000
18819	3NKyvtpUkHcDYDqkUSrUhUvTui1nJAfUnMcgjeoQV8uc44N2pJEh	18748	3NL222n1K5s68n46TCiC9GHcgEgff8WwsMoskKkHZtH71sFBZFHg	1649	1137	324	6301	12463	jxYVx27FYL31Ghm3MKQNxryJj6wcZbHqqQEfW5XbK2Nbtnk4DuK	9438	13392	13392	1618349760000
18821	3NL7dqA7iG9nmgz2as8GasZZZCH7hMAUndKf7j84Uq1u8YGbvyBk	18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	1602	1369	326	6301	12463	jxRbSsZSWi1peUqPPLbfZNtzj3xTqrP7tcowPxjbbdUPk3AZKBP	9484	13392	13392	1618349760000
18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	18824	3NKddkor5atZAH2DK6QRmUya4wexK7pjkaWve17nfFqjDdGvYq5b	1406	1393	327	6301	12463	jw8DXWuaxzgGj2ETwFbxFX6NgTsuTy7FXi9xeYwUYH7J6bxphCU	9487	13395	13395	1618350300000
18828	3NLr6BKPTQ1Bm8WShZ9rAdeAo5BUb74d3h7awfv18fu3LLPYkqHw	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1619	1149	327	6301	12463	jwKGj9uRnxsmfa7PRtwbFm9JUaqK8bfHeyfTfEi8Ui2nHPFpBWL	9488	13396	13396	1618350480000
18833	3NL2QrtP3LaxCvhMHHWmeoweo4tBLn4tN9i8q4XiTYLQu1LTgMBY	18832	3NLUUdUK3pM6oKqFHCURoBtpVTR3974RBWi376Psfr1sjCDdiD8b	1581	778	327	6301	12463	jwBFfFnbQKrnqhipbCnryPqmoAJnCae6kqxwWgQyp5uSKhtHcHZ	9491	13400	13400	1618351200000
18836	3NK5YQcadgamBKBkmz8GCNkQhcgCpEQEkyPYbgmGRMeH63PujGXw	18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	1657	1344	327	6301	12463	jwjDYdMbcVumg5t8zwwS86uNUGPCw3HkfdWW99VNZQVLa4kbMRW	9494	13403	13403	1618351740000
18841	3NL1LqfED8j8z59TppRdudnPZSjYD6gMpqEJRuEqVrdpzT6EKBN5	18840	3NKNkviQpmPMZeDwTRsCRuX8G1cZQ26k1uiDA2cHuoPgH9RU5Lna	1553	776	327	6301	12463	jxW5L8Nxjhv7FvpiJbWbELkAwsdb3oiEKKK2awLEFJxdHJ8Hd6v	9497	13407	13407	1618352460000
18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	18843	3NKTEo1cAzXu2iXBrtG3iiJsvCGD9AhgZX3Pvt4jiBX5YroxKdGZ	1581	778	327	6301	12463	jwDXqaJ72RhMriyeHdTcFfn2J1HVing4Y6B6vDUPxBEb6gzb7Rk	9500	13412	13412	1618353360000
18847	3NKfHxdPcd6m958zfNG2Av1Q31eXXd9PXV7UErgUUCGdU3oooGLc	18845	3NKjLjvCpBNTNg6SVZmHhkg6r37HYb88FNULZBtpBUazvkJz2dji	1585	1120	327	6301	12463	jxPHxfq7GyyocTWxZWpnDCyDoRb6pzC4YHDp32vKP76H8FFgET5	9502	13415	13415	1618353900000
18854	3NK7Rk8ReJgFcdmtVbmVUzsMW9ehaTUgBZTLiweLPfDDh9xcNbzu	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1600	1126	327	6301	12463	jwJPkQUzqyKNSQXHYuC77Av8hZYKEXEAZPBsnbmCbsswkQBaujC	9505	13418	13418	1618354440000
18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	1637	816	327	6301	12463	jwgWZruZfL1GBtzje1tE8AKqCw9XhjDJHuB5tanzhnAJjxihX45	9509	13423	13423	1618355340000
18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	18751	3NKZeHGuswJdMdAuPBNJTT3ydVwcPjzP9MvGibh9Kvi2bs8zP3WS	1447	1345	325	6301	12463	jwyfDRAKVjocQ6Dfk38BY1jQimv5au1kEWbqmDzgHr1moYTp46m	9452	13346	13346	1618341480000
18757	3NKg7hPjfWEmcFkw2cCEdSLvEWwMWcnvrsbdzw1tnALkDdoQGePC	18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	633	1138	325	6301	12463	jx5C3gXEqFQNrbbnoYfgUmu1SuC8eziZEpKjUynr9fpGgfa9WoZ	9455	13349	13349	1618342020000
18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	18758	3NKthpQMa8DXjv6bEqGcXnKFcLc1EDkPpA4BYgp874jfxJTyiSfv	1541	932	325	6301	12463	jwcWwcx2Vqz7VHEtS6TgG3CEhagxegfu7watP3tyQduVu45Q5hC	9456	13350	13350	1618342200000
18768	3NLDG6CdRY2CiigsbXCWAWb7y3gShTuceKBP2g5Dk7eneqrycFQR	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1588	1392	325	6301	12463	jxbP2akdSk5F8MovKCfRN3RsGpNCTCoFTd3rV2agExSSWKLKaqs	9459	13353	13353	1618342740000
18770	3NLd3cGBnfpJkGeG3qFcQCouQpF8xmwZ1bPm5SUhh5acV7fSvUDb	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1471	1386	325	6301	12463	jwSm8YUHifz9dT16uq2YozqzkqFrqAKgp8kHrDtBXy2LHsUXuSm	9459	13353	13353	1618342740000
18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	18770	3NLd3cGBnfpJkGeG3qFcQCouQpF8xmwZ1bPm5SUhh5acV7fSvUDb	1403	824	325	6301	12463	jxGPLtY6JEkNsshKLmpWH3Jwtu3TbNyG7HTQt2Y87aBBtcPoHLK	9460	13354	13354	1618342920000
18775	3NLNsTgjvEW8t676DKrotmZc5diYBcHjbDi2aWzMGGekcypdUBaL	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1402	810	325	6301	12463	jwmmznJ7C88VGNLLr8QopbRJfvKmH85ApeMkNkN86QpxdExVMnF	9461	13355	13355	1618343100000
18778	3NLiJs6AZL5yoGfDuJSpyFd22wDBVf5fkEBYAm2dHGwDB89ZcQnP	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	1455	966	326	6301	12463	jxG7Qu3RM5TTRphcRu1wCxoRGQBPnkT2FcDP7vSTxxRJfE32djB	9463	13360	13360	1618344000000
18780	3NLc1KMon8L1Sgq9shWYNKprmG2m7DYC3N426Ee5gQ824Mr4aCKU	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	484	1193	326	6301	12463	jwAyWDGg1WDJisx4Kr68jKUufmiwHLx4EUJbBuUcoHVdfuS7m3N	9464	13361	13361	1618344180000
18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	1553	776	326	6301	12463	jxSN99CNFxVMruGLYrXvmN2owqYMogSCDw4KCWNmZdzooDBnFDf	9464	13361	13361	1618344180000
18785	3NL2rxsgWjkdEsY6j1oe2cg3Q9tDTnUteFU47yFQEzNtDLDUGtNq	18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	1419	814	326	6301	12463	jxxd9GjFVKnA564P4jDZBgcV6WruAEuairb6dWyAAKysREHSeTC	9466	13365	13365	1618344900000
18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	18785	3NL2rxsgWjkdEsY6j1oe2cg3Q9tDTnUteFU47yFQEzNtDLDUGtNq	1637	816	326	6301	12463	jwYDFCoDK5CDrxC8ufBmzXtXK82m4R2sh7r8NQPw9N4BF9sSezY	9467	13366	13366	1618345080000
18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	1457	1145	326	6301	12463	jx4X1Tr5cRzHnLhJHcH69BxWDWqPWfjUW8Ro6Wq8FJhYdhJNpin	9469	13369	13369	1618345620000
18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1501	1360	326	6301	12463	jwrgx9zrEMrWVhg91DRLcKqWspjH3KECdoWtaBQTmmTQiKY41tc	9472	13377	13377	1618347060000
18798	3NKZK74nz4xhHM6VdW63sBP5waNnGpEwm2GStXPdCHqiWyPphiW3	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1407	1395	326	6301	12463	jxDKQ5Q7hroPNJ2GK33z4zE1m7rPtwZagZRkjMaRVqxfCUAuNLb	9472	13377	13377	1618347060000
18800	3NLiVjpqkJNhceFQjXGBJJBE5uFW2ng1CtgPWEcPccm4bEG6BZxZ	18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	1579	1389	326	6301	12463	jxwj9m3UjoT9oQunqEtZwm8jwUvYuAwJq1D8m5pgLeJirc9ZSpm	9473	13378	13378	1618347240000
18803	3NKx5zS4DTaAHdfDRdZ5MeaXEGEWSAdSJFwmZf3TmHvWBTbtQUgU	18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	1581	778	326	6301	12463	jx3StVybUiioAY1ZkeDqBXfC75ecAkDx3rBxjG5Qac6ZvdCYmTw	9475	13381	13381	1618347780000
18808	3NLkhJRGUoANZX7xup3sdHC2Qt8YA5KKGSWs6QS85jmULbnniSXC	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1631	794	326	6301	12463	jwfddS6RjPAsHqy1wsWBPvzKJexhDkwNGoBfNNJKjJ21w6CpV5E	9478	13384	13384	1618348320000
18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1651	1175	326	6301	12463	jxgvEV8ybocvmDP4SYHAzY2GuQgbazRN8RpCgA8vtKiE6mybP68	9479	13385	13385	1618348500000
18813	3NKMA79Auy9nEfPPFjaVBk9mnp2MNXjJpbQG4tCurkjGgU7Ap6Xc	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	1656	1217	326	6301	12463	jwL8kasFjbCikchpS2G1TFarKoiR1GmibzhCgPvEN2GjR5139UP	9480	13388	13388	1618349040000
18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	18814	3NKHbngE1uHX6kTMQCsLFTsUq16fHMK2fQKwtu9chUDuQWykEv7d	1601	1388	326	6301	12463	jwZjK4AasE7GRFtkfNdepe5PhhdcfVpw7yNXrUMsPREq48ge2Gp	9481	13389	13389	1618349220000
18817	3NKWonhXDJYg8Htr7KgMtSgMhdy4ef83dh69UVERTpzJT3iLGgYb	18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	1602	1369	326	6301	12463	jwEu22A81gjtbZkpupTkSkDy6tHMaQXjqJ7cdNaGCj6D7ajsc9K	9482	13390	13390	1618349400000
18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	18821	3NL7dqA7iG9nmgz2as8GasZZZCH7hMAUndKf7j84Uq1u8YGbvyBk	632	1016	326	6301	12463	jx7vzixwWMa6SbWNkSgj8ZRcB44EQL31JkLrQAbn4aG5vHAfnQ9	9485	13393	13393	1618349940000
18824	3NKddkor5atZAH2DK6QRmUya4wexK7pjkaWve17nfFqjDdGvYq5b	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1457	1025	326	6301	12463	jxYeLmv54jG2oEihS8CBqhv9MTjnEC89MSTyepcoD5UPc8MaYJF	9486	13394	13394	1618350120000
18829	3NLmEwmqc11G6VsQcJNGyy5vhhV4ZMuEi997FyK8ZCkgcqVzC78y	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1637	816	327	6301	12463	jw6k7W4RVrjLWvsmQmzVZPXFM8W7KuQVWh4NFpJi6CJsnyHimzz	9488	13396	13396	1618350480000
18831	3NK6eimpbmf85rhfTu944dhHrCzYcf5f7zryTCStxWWi5DoqKyum	18830	3NLS64YvMM29UM9gGVzVfpfADg43UjfzjU3TjZ8ZGQvKSGRA2YGP	1419	814	327	6301	12463	jxZM9W9EM2ge7Yvgsm5AzDBujkfBHD7KdxuhFuuHUyRMS9L6Fvu	9489	13398	13398	1618350840000
18834	3NKm6J9FcD6LFuvkRdQZ6MBfH7tYwEa9G2U7MEe8rLDg53yzZjAN	18833	3NL2QrtP3LaxCvhMHHWmeoweo4tBLn4tN9i8q4XiTYLQu1LTgMBY	1406	1393	327	6301	12463	jx5nGriMniZ1Wxbffx1mS8QTL1CiEYwpBv1sBY4NjdUE1kUD75v	9492	13401	13401	1618351380000
18839	3NKsShn7z7VsRydzxBEVSt9LBZKKWTwg2Wt7UgKj2s4p7aT7571F	18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	1648	1158	327	6301	12463	jwDpND2Lm3X9jkxtkei1xcTetMUxxHmeboxuHbmiYvSRyufEn1f	9496	13406	13406	1618352280000
18842	3NKGZJiYS39KibUJTUUoRG3hJLnX7AMsv6cQkihUPvny7qu2tWUA	18841	3NL1LqfED8j8z59TppRdudnPZSjYD6gMpqEJRuEqVrdpzT6EKBN5	1460	1324	327	6301	12463	jxvyYPtfxgqMp1FGYCxYiP8ay27dfwYLk5nNqhrnGBRwJfJHeHL	9498	13409	13409	1618352820000
18845	3NKjLjvCpBNTNg6SVZmHhkg6r37HYb88FNULZBtpBUazvkJz2dji	18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	1631	794	327	6301	12463	jxAviz8DRzsYPe6cioP26Efom2QwzhUfXAPawr7m5dytcFXFMk4	9501	13414	13414	1618353720000
18850	3NKMSecF3Be7VefLyqBGoaxHFzVA8RbBCQBWntJbhFcr877hc8em	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1509	1074	327	6301	12463	jxtrDCpTcXGVtAmsN7VG9xZEn5Fb3gvDN1MDYeXK4is4eq5vHyL	9505	13418	13418	1618354440000
18853	3NKFWBt5fe9YfqNjKqahnLD5UDq9a4nP71yngKeYD2gAqkVNPT8m	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1406	1393	327	6301	12463	jwUPTY59jHGzwXKFs8v76jxw7m37kTY9UQNGvrrkJGWLvswcRX2	9505	13418	13418	1618354440000
18763	3NK97a4PR9ZpjNGdHnYTnv9Agm2iPGXGisP4RFtbsbBsbdjDGtUt	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1461	1271	325	6301	12463	jwqSjE4AruVMzoRbB1tgUQtYgEUxHHD7CFwD2YuNq9tYuuNdFrA	9457	13351	13351	1618342380000
18767	3NKsbSV5y2Q82wVrrXJwkj4U1diNaaSxoS1y7H2Sd9SAKsGEmzbQ	18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	1406	1393	325	6301	12463	jxtndMDRHmwU81V3FJsinvUUwwAD6TEJu3WdjPsqskan1Stqh8V	9458	13352	13352	1618342560000
18771	3NLDH89SBXtLRCoVBZ4stxJfrfEL8xAzHT5XvEcCwDWUkYDEHmHU	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1541	1172	325	6301	12463	jwECNpgnzo59KdoTbWDTVx8cBEpT1BorpqD7jvSdZDLQG4FVP9x	9459	13353	13353	1618342740000
18784	3NKg6oTVNVLgN46J2ouaWvU4HdvQAnr4vp3D1FcE1BXxuYsEVqri	18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	1608	1043	326	6301	12463	jxN1r4zBRF34knoXD4xsn6j635Q3SAHGre4ySDrPDCLea3U8MPf	9465	13363	13363	1618344540000
18786	3NLnejR18iXPbrAHqKvxh2SCgW9NEoAUdKaJcfn9xaAzb1ofYE82	18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	1581	778	326	6301	12463	jxmhLPtsrEg82yWqfwgf2sP5wsDinT6h3og7ek1nex7jNueBxCa	9466	13365	13365	1618344900000
18791	3NL4JQuRVJdbDoNYFHy3n1iSHvoSCUyqdq5skAmRpjkJuoAmTFo8	18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	1524	119	326	6301	12463	jxSQ31EK3ozAEysB4KjxoMJET6UwEqJktuAb5a3y8W1YzabXyTa	9469	13369	13369	1618345620000
18799	3NLjCQ8yApBaU1XqUhWsfHj3eotw8yad6L9fWXa4TzTZnMzkMopJ	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1474	1329	326	6301	12463	jwBdr59qsnKu9eacWqAWbgHnp872EyA2ZskNQ7U67MKmKUkQCAf	9472	13377	13377	1618347060000
18802	3NLdQsyTBoXXnDy6GsWG1KmDgFcJgjFDuSHJJ1tpwbfh6AiXBdoG	18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	1405	867	326	6301	12463	jwVXvimgCyVbG6jGstWngQzH27CaNREHaSeua5nutbVq9HwJs6e	9475	13381	13381	1618347780000
18804	3NL6Mtq6pvDMbY5qGKDMGzkcVBxq2DbHGEh4V4fY6SiWc1NAfqnF	18802	3NLdQsyTBoXXnDy6GsWG1KmDgFcJgjFDuSHJJ1tpwbfh6AiXBdoG	44	1325	326	6301	12463	jxN6fHrcaMjuvuh7FzeifzRR4mq1dFM7mqo4MPkcHdr2u8N1PQD	9476	13382	13382	1618347960000
18809	3NLhMZR479VigLWsNZdRRE9x64JJrZ2LoDWQwvfYYoTW1khFzh6K	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1406	1393	326	6301	12463	jxvmT7d9KSVh2gox2J6y3aaimzp9gLS1hGqJoqhaSQvb8sXvxsb	9479	13385	13385	1618348500000
18811	3NKPwT4SBtAuShBuK17oxtxuGkPHRiyUvFRVmUc76wjzqxmUqBdZ	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1651	1175	326	6301	12463	jwEBoVJXhz7219f8TGFeKJHZpTRRjmLEo9Atm1eNXFCbmPEmgWS	9479	13385	13385	1618348500000
18814	3NKHbngE1uHX6kTMQCsLFTsUq16fHMK2fQKwtu9chUDuQWykEv7d	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	1637	816	326	6301	12463	jwgtnyBqBKT83EA23mnUTMqEyf4nZNFg8542Qa8c7aqgEuxeJyQ	9480	13388	13388	1618349040000
18816	3NLMFaZfqnnQxMdv5RoQA7Jv761YwQ53n8kiuk2826Yk1ud6KRuZ	18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	1617	1042	326	6301	12463	jx6hFUUr7LpCRYmBqmFXEcBuSezDwAuzmvFNYNUyEu5rFaRuC7W	9482	13390	13390	1618349400000
18823	3NKdsSFLkhsrWbmH6dW9beZLuYuxGLQ61zrQoTJfaWurVen5r4Ai	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1406	1393	326	6301	12463	jwhe9WEXqGYau78cCEWVKXYfcW8RHLLFFZtfW5Y3jcy7GinGa3N	9486	13394	13394	1618350120000
18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	18834	3NKm6J9FcD6LFuvkRdQZ6MBfH7tYwEa9G2U7MEe8rLDg53yzZjAN	1490	908	327	6301	12463	jxcWhaeAqduKXjofUxbor3QXMJxoWnbZqPXo1ebAdhA2NoN7jfd	9493	13402	13402	1618351560000
18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	18837	3NKud2womi54SEtzJdghy9yhwmikYKYrbELrBF9AX59StdGtmyaV	1508	1021	327	6301	12463	jxCJWodWGqNthyDzTZbA5Ld9HsB44YRX5fW7kqt9CLNeUFd7GkJ	9495	13405	13405	1618352100000
18840	3NKNkviQpmPMZeDwTRsCRuX8G1cZQ26k1uiDA2cHuoPgH9RU5Lna	18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	700	840	327	6301	12463	jxig6fDQzEJ3ztgLspTMSx3kYsytHcnHw1P9rU4Ek1dwepusPWe	9496	13406	13406	1618352280000
18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	18848	3NL3xRokHbtnwzmgHHXzhNE8tJ6SFAyVTaMAQQGRkcYPSoPoV7CA	532	1303	327	6301	12463	jxhUjLPiVHFkr4bpPvPqNQUspeLR7Vvp5A4EkvP2LKBag53ptTt	9504	13417	13417	1618354260000
18852	3NLPooAXWXS5rA2S8s2QKDr24rnSuEdypFX44ecjRCQvEJoEcf5D	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	80	1273	327	6301	12463	jx28BgXBysJnQtqX2Dg8wyUWcVVHiV4J2TvM4eG5cwCkYBXRz7o	9505	13418	13418	1618354440000
18856	3NKggaQSm6q6Mt8WueHMFmK4eEAU9xCQXNDqCAZ7xrixkeYrwiCv	18855	3NK3faLafCoAxmdSa3dq3pNCVAs9zuBgueVPuakkt6NFERxm4o55	1460	558	327	6301	12463	jwQShTp3S8ziAiDbeojbvsrN1icVz49JAyZqmm22e7KZZpvFSTe	9507	13421	13421	1618354980000
18864	3NKLFVQpCHTVJSVzgjqL3kSWZAt45EJsawSCPJ2betYfrmFXw7BQ	18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	1547	1132	327	6301	12463	jwCNDis93Djog6zHbHdnbMBLTY2GPVuWNRPEfj9b9ZPcmuRHAjh	9512	13429	13429	1618356420000
18866	3NLtaC5s9NtvhynrJfuZ7v5grSpEMK9Resk4qg4ymtRtpKvLaHZR	18864	3NKLFVQpCHTVJSVzgjqL3kSWZAt45EJsawSCPJ2betYfrmFXw7BQ	1407	1395	327	6301	12463	jxmrtLB9uNXu79mMDrJxcpiznw5TkkAJidKaGrvmvSoBNprYJ2J	9513	13430	13430	1618356600000
18869	3NLLuhjFgrZsCEs57LkCUkBJRwZiY76N2QMrBA7UJcH1RHvfrRKJ	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1553	776	327	6301	12463	jwjYFsrDdT6EnRpQ6miGQKhXfJxjr8LA9q8wYjYo1PNcaWdaaMK	9516	13434	13434	1618357320000
18871	3NLXybmaiFCCTyQZNjuwewW6PpZC1foWrdjra4yx6TUz3ZbUXtq5	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1407	1395	327	6301	12463	jxMUU3hRk11SY2agjuXfsnEFronE7qCfe8vMDuE9HZaLrWGTb4E	9516	13434	13434	1618357320000
18876	3NLuu2VfXqt8BVtvuqmPpoHU7VPGeyASqro1VAsoQMus2FpNLLAS	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1560	1045	326	6301	12463	jwNktZdzNCnmsEmRwLu9bUNMpCW1P9jAjA5PGQEa5PqoJTRZgga	9478	13436	13436	1618357680000
18878	3NLjjoQKcvsfnpTVtXkMLtTFGmLFGUcnjhfZpgho5i7DPDK699ef	18877	3NKaxXdxSkXGEsqBZpMrLukGCnZK5fdFwCrZxHmcnHhPUhQomNH9	311	1307	327	6301	12463	jwVP7Cyt8p4MNZMK5VYswSiauvpq5DDwGv9HCzmXR6W8tSWKbMo	9519	13438	13438	1618358040000
18881	3NKHk5k5wtyEKfuHyFN2KzWi77EJFYDRNRao1nAyX4SyxVY11fsc	18880	3NLQLU9WQRDzve36sGSweb78hn9ZqYRtEExpLtbsUpmj22vqb5bb	152	1084	328	6301	12463	jwnTwNofb12SwEbgx7oPuRjQUxoDtWTe7KMZqHqdjTcL8px2HXe	9522	13441	13441	1618358580000
18884	3NLNdEsCpm6pgo4kqzhJwUV9wCaYtnPw5QAVMDJNj1pReqpchRnc	18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	1564	1212	328	6301	12463	jxyWW5HrrMxtvwJwgj6K5zxt22YnQHCw6G1oVrREGEHJpBqJSVs	9524	13443	13443	1618358940000
18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	18885	3NKu6PWSAkZG7o6bHYy348aBDPYEqsm1deeJPEeXvYuTLCvv7FoR	1646	988	328	6301	12463	jxWMwt3QFg7NFRDCbUGj9z4Hj2CGsUh48Vfa1wewL9FiU7DgDY9	9526	13445	13445	1618359300000
18889	3NK3YCkwDQbHe4Cw7qhY9teHXPUUfkeYLmrs9ievuQnCgxa4QMWA	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	1607	1102	328	6301	12463	jwKfWE6Km4as31BUQjHzuMQKyF53LdUd9xZGQycKXwaBioWGzdN	9529	13450	13450	1618360200000
18892	3NLiSx381vNnNT3gczgqB12MN4E881PTZirhPFmotuXZ6K5CU2LX	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jx2LkjBwqy4mt7esYX3VzL1N7vwtKBrS3SBfQEZg6rSZZfjcX7C	9530	13451	13451	1618360380000
18895	3NLpzjNA17WyyteoESUgievmF7wvJVp2YYbnEiThgL8JwRvhd69s	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jwKG41FCi6V8hnkWLBKTAjHw98uunmmxr44GPHYoX6g7s1G4KRS	9530	13451	13451	1618360380000
18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	1403	824	325	6301	12463	jx5ae8ovfPkPajh3KaNcGkurixoQom9zB34K4htSMTJpXyMRKbo	9458	13352	13352	1618342560000
18769	3NL2Vdunj6XzHxBBDJcXUyENyNvwumDhsF6jsm4KoJ7VND4roJpG	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1656	977	325	6301	12463	jwPPpJMe3xM5v1h2YJnX2pc8tjy8KJ4R1SDmAF9Nk4Ca6t1BjXE	9459	13353	13353	1618342740000
18773	3NKmLQpzyRGEhqn6VRnyV59Jkwb9j3XmVQpEEhzFNFtdRfNqQt3H	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1675	976	325	6301	12463	jwUXHRLDun3PhnuaFTbXd8TS3Riz1nYy1S5bb4FvfKKJhZv1g7k	9461	13355	13355	1618343100000
18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	18774	3NLARSkfTYQheJob8n68zxfgFW3yX4z92MhwMBPvMMxaXjoAicLE	1647	846	325	6301	12463	jxxYEKrNK9xTBesNUECJ8uEu8JHTkVFY33vjKFvxZTZZsG7G3a4	9462	13359	13359	1618343820000
18779	3NKt4jF6TUdsvvxpvzdjvSDCo9FsVt9cTF2hMP72WChY3aGm3WRw	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	1403	824	326	6301	12463	jxmx7daGJy3djx3enUaPuc1Js3ybx8fQaECNTAYRvfZDief35oV	9463	13360	13360	1618344000000
18781	3NK94iA4mdbxAHUvcxV6xdZKdS9H2ccKUDekTRALp6WNWDxzQpwK	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	69	69	326	6301	12463	jwJ97VfpZNgPkeGST6FfF4AGejw3LfLywB2daNQymR2puGGUF2U	9464	13361	13361	1618344180000
18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	1457	1025	326	6301	12463	jxS8FnC95ZjowUUPe9o3F41z581jEmwxZNR1g9Bmeh8HjdcTCMX	9465	13363	13363	1618344540000
18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1405	873	326	6301	12463	jwvbYAwZAm7a9VuNiQaA5QDL9QP71hx4ei5e8m3anu7VHEUDehm	9468	13368	13368	1618345440000
18790	3NKgimR5V5ZraDoJFnG8uR2CtasCbXvRUBaqsQNsbNAU7bXTkmc7	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1652	1315	326	6301	12463	jwYyYGvVUqVDCDvrvmyhnY1fk2wWCLK6eZBioAhdozHDeApfxkB	9468	13368	13368	1618345440000
18793	3NLRTZfQ1QCSwhZxXts5W4q95Y3g9KWoMT4cn63kjDZgDN1SkCCs	18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	1637	816	326	6301	12463	jxJZCXqzWLk9fVVnJNeCoik4zn7mrfEMniTN2k7ij41jbLB1kyh	9470	13371	13371	1618345980000
18797	3NKbeg4L8r5zcpCreDp3VRa5eoz3TNHxDFAgcroUath3QtuUajuE	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1474	1329	326	6301	12463	jxipbtVBQAz6bKMvp3DYoHbXKecReZRZcWsjv68dzTgXZT4nBZd	9472	13377	13377	1618347060000
18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	18800	3NLiVjpqkJNhceFQjXGBJJBE5uFW2ng1CtgPWEcPccm4bEG6BZxZ	532	937	326	6301	12463	jy2NyRknKrmXNJsjC2eAD4EKCp1pmfL4x4jEaEt1ozTxnhUBGsC	9474	13379	13379	1618347420000
18806	3NLFf2o9F2S2Der6rmhKvzxjbC1cNDznYPeTMSTA56kkf2iZ4V6H	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1406	1393	326	6301	12463	jwZeJHPAHs7ssjf6Rdsn8GaQ4enPPDqnV6xv2Pc1CFvxoHUXEhR	9478	13384	13384	1618348320000
18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	18817	3NKWonhXDJYg8Htr7KgMtSgMhdy4ef83dh69UVERTpzJT3iLGgYb	1601	1022	326	6301	12463	jxQinPsEVz8jozUqSwiynpdsjkZEr7dHVGTo5oGeUJJ5WbGv44B	9483	13391	13391	1618349580000
18820	3NLDcvJ79VQPXu8ikkWjcDjfEpdS8VXX8KZycJYGX3EF2Lua5qyW	18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	1649	1137	326	6301	12463	jx1W7t8EwqFkyMSFdqFog3tVc9ewa7xLBwXPPBbcMG1ao6forCx	9484	13392	13392	1618349760000
18825	3NKHDYct5kAWfkM15eJie4XXdXrLKrqm5v9h2wEJ1cjwFUycygkU	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1407	1395	326	6301	12463	jxamLZ1nEWxaLRWd8hXJNk6FBZWcpyEUZRznz4uJWQHK9sYHVMZ	9486	13394	13394	1618350120000
18827	3NK7VHsvhvPRcTzhn8A35xScbVQoEBJoee6M7tMtDrnomcoWabp7	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1477	1104	327	6301	12463	jwmmKhMXrDh2tupaVKGibhYqT8rdHcDrbBgUfXZFecg9jZNNq1S	9488	13396	13396	1618350480000
18830	3NLS64YvMM29UM9gGVzVfpfADg43UjfzjU3TjZ8ZGQvKSGRA2YGP	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1646	1108	327	6301	12463	jwYRgyHHTJp1c5Yp9Be3WFoSFsDDWgyrnf5HBGRV3TGjwpYHWBG	9488	13396	13396	1618350480000
18832	3NLUUdUK3pM6oKqFHCURoBtpVTR3974RBWi376Psfr1sjCDdiD8b	18831	3NK6eimpbmf85rhfTu944dhHrCzYcf5f7zryTCStxWWi5DoqKyum	1406	1393	327	6301	12463	jwRD6JLQW7hXW8xTsX6VBcXtLTM1BdWdy8WXbPoia1kktQYeAH7	9490	13399	13399	1618351020000
18837	3NKud2womi54SEtzJdghy9yhwmikYKYrbELrBF9AX59StdGtmyaV	18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	1643	1053	327	6301	12463	jw9JCCh5WFhojZ1rAXoePHbEwVM3JwH8zJ94aru4rRRTdRkPqE3	9494	13403	13403	1618351740000
18843	3NKTEo1cAzXu2iXBrtG3iiJsvCGD9AhgZX3Pvt4jiBX5YroxKdGZ	18842	3NKGZJiYS39KibUJTUUoRG3hJLnX7AMsv6cQkihUPvny7qu2tWUA	1407	1395	327	6301	12463	jwr1ptLkXyQUmD4fkbBZt4tDgYKajit8ZwZgv7ws6JjVr6kHXbh	9499	13411	13411	1618353180000
18846	3NLeZevhmPm1gazbdPPu3upwtrTVHjnYDRzTNt39ArCi4sn5no8S	18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	1590	1174	327	6301	12463	jwGsn6Sozx8davtW8mZzLB5B46MBanysEi712i51yYqAfCtSNGo	9501	13414	13414	1618353720000
18848	3NL3xRokHbtnwzmgHHXzhNE8tJ6SFAyVTaMAQQGRkcYPSoPoV7CA	18847	3NKfHxdPcd6m958zfNG2Av1Q31eXXd9PXV7UErgUUCGdU3oooGLc	1631	793	327	6301	12463	jwxkUnTPP1mfqEBJwsoteHBFcuPT1Kzn9ckjLoutMrp2PxnEDkx	9503	13416	13416	1618354080000
18851	3NKo74eVA4y8YPBWe9AABi74ggYwnysrsMu1odzraexSDzZQ34fe	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1403	823	327	6301	12463	jwTed5vArNsU43smTVNk4kft6vsRdVJzCmGhRgiPAhvuuASzK4w	9505	13418	13418	1618354440000
18855	3NK3faLafCoAxmdSa3dq3pNCVAs9zuBgueVPuakkt6NFERxm4o55	18853	3NKFWBt5fe9YfqNjKqahnLD5UDq9a4nP71yngKeYD2gAqkVNPT8m	1602	1123	327	6301	12463	jwoDa43PBs1NRK8MQEcBY9UDLtqmB3Waq3jxLPLxA6EB783vjsk	9506	13420	13420	1618354800000
18858	3NLmjfUDsRFNV5EPnMsEHG9eb6L9ZSy4JvyHxKma5DbCw8PP8246	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	311	1307	327	6301	12463	jxoxcLDVHtMHS5hP4n33zripyiZGf9qeEcJUTQ8A8cGadG2a4RR	9509	13423	13423	1618355340000
18861	3NLDz8QEjks7g8rKVnNew5gKBu7ofVUBEyPyrJVcdXxLCdz4y5ba	18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	44	1325	327	6301	12463	jwBTedJU5DwiH6DFTjgfQCKYwHu6THPR56ytWUqcYZw92ZyhLQV	9510	13425	13425	1618355700000
18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	1654	1094	327	6301	12463	jx4NEkM9ZTNt4d8u45U2fhnVj6whYEVgtLTCD88NbC9D646Y7Bs	9511	13427	13427	1618356060000
18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	18867	3NLtWJnPrdmK6VuLKLHcNrEdocmYainH5VygkCLA2nPoyK7TETZv	1503	1031	327	6301	12463	jwe6nhmCDkyGJyCE144T9mgwD48i56W4bn8XEtePervzVdETttp	9515	13432	13432	1618356960000
18873	3NLZZLMpbGLyYCRpUfvjE2N4g6DsWh3xiVJr4Af4nuVcA9En8DTx	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1672	919	327	6301	12463	jwZsLTMfbvPJQYemXp11sZoYTrXq88kqkNEyoNtbxqmkSpcFgfV	9518	13436	13436	1618357680000
18880	3NLQLU9WQRDzve36sGSweb78hn9ZqYRtEExpLtbsUpmj22vqb5bb	18879	3NLF3WSjFeMTJJX2VgvDrmiUDvWduYHthfcm3rDZo6JheA7wq5u2	1422	1091	327	6301	12463	jwcnYvAxpJybHDMJr4UtJ3xH5kYwjKpWjkBrx2rgp1MqJnb4N8s	9521	13440	13440	1618358400000
18883	3NKb6aQwV5fGgR2dETYn38rwZbMNXYBTyJgksYiCQWAWzVF19HxB	18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	1646	988	328	6301	12463	jwaXcqg8iuwSzAwgJC5qQHMFTAs1Yy2yYBJ4Bn2vjSjaZCFez3P	9524	13443	13443	1618358940000
18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	18856	3NKggaQSm6q6Mt8WueHMFmK4eEAU9xCQXNDqCAZ7xrixkeYrwiCv	1467	1376	327	6301	12463	jwjrWGdRSjJhvNPKvdvYCQdAp844TB78nSehWoDjsF7RracE9E3	9508	13422	13422	1618355160000
18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	1547	1378	327	6301	12463	jwAZGXxttCEhX6sfbQxe97ds8bcEngUT22x46SuNSG2toywbzq3	9510	13425	13425	1618355700000
18865	3NLUxyUuoJ4uc17JJ5hkmGD645rFfJjhCGeKpRb6TDYJHUr6mRvj	18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	1637	816	327	6301	12463	jwNR9TPAHd9UQymA6qP2d95WfxbKeURCV69R6hoKHJyG3Zdbkyx	9512	13429	13429	1618356420000
18875	3NLh6qRnhW1VJJq8QayVXjDAA971HR9Uqjp95P7VER5faicU3d8H	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1445	1290	327	6301	12463	jx2s4B4vEu4i1kqsjGU1HKCFRfSigupHxCBtoWBvThg22RsRkG3	9518	13436	13436	1618357680000
18877	3NKaxXdxSkXGEsqBZpMrLukGCnZK5fdFwCrZxHmcnHhPUhQomNH9	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1407	1395	327	6301	12463	jwuQ8AS9HHQkBmYfQ63nGAjG4auFPbbEoCtZBX7MSNBbobv4jX1	9518	13436	13436	1618357680000
18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	18881	3NKHk5k5wtyEKfuHyFN2KzWi77EJFYDRNRao1nAyX4SyxVY11fsc	415	415	328	6301	12463	jwwx9jC6TUQHRxGfutSGbmv8k5zDtVWqq8JJjy2NHjQpsux8uaU	9523	13442	13442	1618358760000
18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	311	1307	328	6301	12463	jx1yCGvUU546QTs6q7GCNoZRGgzsTGzEnrBhPE5X7QD4pSuSWYE	9529	13450	13450	1618360200000
18893	3NKumUJ7yXtP4xuJXoXuPxBN2Fvhpi4mSGw5JQWq9oB9F1qvxA6u	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	470	1063	328	6301	12463	jxhWtcr2hiubFiGVb5Urra1Ev4WnKc2piygi2wmYEzWJUT5k1qD	9530	13451	13451	1618360380000
18899	3NLwrdSxY872RkBFVy2HVeL7fBmhhCm4X1JKtVcJ6rGq6seVeLAK	18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	1422	1337	328	6301	12463	jxGwVQfP8nvzk8B3Ku3Xrmq6tnekcMVdKmgSuips4fArmTMh7eE	9533	13454	13454	1618360920000
18902	3NLbwQN4WC5wfHTQB3oZnwCCu5p9YRyeWLVECHZgSv6yjTJPsScQ	18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	1603	444	317	6301	12463	jxGYiEdm9Kztw7TA7KMJmNxcejt168RVUxA8HZZWknqyDQqfyAq	9287	13457	13457	1618361460000
18904	3NL4H68uYjDG1Duqfhc3asTtjDb3xyZcaEKKaSBB6xSfb6YpbWAp	18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	470	1063	328	6301	12463	jxEbQ6VA71MjViB7CmFKbmWMx3fDGQCYJueXUY38NhsbBBDxqfs	9534	13457	13457	1618361460000
18906	3NKxfTG3Njoc2Ta9Re38oXFNoupNM3a2NxFa2Qr6CzZpZsQc3zyX	18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	1627	1139	328	6301	12463	jx1Vcc2bSZEymk88xMpCNNuGgfgV71bjGnRSUADJNZmYhZVRnHb	9536	13458	13458	1618361640000
18907	3NKpcvFjUwfJRBa3HTzLcykD76HkMJV4AEdgAAgCQg4w6KLkYMKy	18906	3NKxfTG3Njoc2Ta9Re38oXFNoupNM3a2NxFa2Qr6CzZpZsQc3zyX	1546	1339	328	6301	12463	jxta7xkTs1wVScYBTriB8fX6nFitY95DbuUosDbyJSE5fzKf2kt	9537	13462	13462	1618362360000
18909	3NK9G4DzNArUYZy6X23uc7MvmxUoqrWuhsD1LCgF9n4wgPhMHefv	18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	1581	778	328	6301	12463	jxNaxf3vkiRLjFCcJtJBJf2cpF5W3bLAzFBqgrHAMiGCzckHNr3	9527	13462	13462	1618362425435
18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	1671	1119	328	6301	12463	jxSFwv7dKC63Q2BQTnygKsMj2rQhUy44mr2rrYCc4zK6opQnB8V	9540	13466	13466	1618363080000
18922	3NLQrHmqxEDuzj8xewBfMpBvMZoienZCE6jJTiYVxMaGsb5sDEe3	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	1406	1393	328	6301	12463	jwMUhYhPBu17YCigDPsfdUFptaSDpCSCnmdpTnmfkV8fUBP5Emh	9545	13472	13472	1618364160000
18924	3NLqN6HSQUDmowxCU3DMZLSseeZq9XFApNeFWDVBBVhMemh915mK	18921	3NKLTF6bk2VV3HiF7LC5ehbKUsj8JRgFn9jws3k86CS4JsjcBmbs	1476	1371	328	6301	12463	jwsP3N6cEeEt7TttEwvgsZVezZeV1swgzDffQuVjg5xhwT9ZZ8n	9546	13473	13473	1618364340000
18927	3NKexyw8bqNn9DC7fYW8AFjyD9BoSoTbPFsfuu3NBgG7sZp4UeEt	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1455	1086	328	6301	12463	jy2EKTNuiZ6yAXPny4vp8wGVLKHtLauUjwdviNVezqRugTeHr1D	9548	13475	13475	1618364700000
18931	3NLjmddLq9VUZ3QEogtbhtejYVMKDmqA9dG1KtxazsLzzudaZ6B5	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	596	940	328	6301	12463	jxqJ37AQHSGxZyYmwswfPoHsgL6716WSFJHuYQEkqjsKXpKLsSQ	9550	13477	13477	1618365060000
18933	3NL3ViziXE51RoGwrPE3p6phH29kPHsDWAs7M8oohAM8fAesW8vj	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	1474	1083	328	6301	12463	jxDKmY9SUeiwmzgqg4SxZ7474RncnHGARsqZwgrMCfyT4FunVjw	9550	13477	13477	1618365060000
18938	3NL4Rat7aB1hZyCFtNHvbDupKdXsGmfhmrPusJhyUWqDg9nybsjZ	18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	484	1319	328	6301	12463	jxfkdMVgpGtGonYab6HxXeVriDQug97xAHxtUEpKzF6jKSSCDMH	9554	13481	13481	1618365780000
18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	18938	3NL4Rat7aB1hZyCFtNHvbDupKdXsGmfhmrPusJhyUWqDg9nybsjZ	1407	1395	328	6301	12463	jwXNoUq6Hi8tJ1YZ2bwirwWmcYYFaDakVvjQUuQ5W47zreajGRM	9555	13482	13482	1618365960000
18941	3NL3pXA4aVuET7kMywb6Vj64tErvtvDwbwKzc3RqesRQxtdirzcE	18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	1593	1220	328	6301	12463	jy2v265S6ubDKQd2xhtHkYULL6hTdAJ5vPhDwtdBVrgCC4Xfuxu	9556	13485	13485	1618366500000
18943	3NK5TcsMoCi43gEtY2zWB1Ynd7MebppCWTvocPmDJv52JoqsT3CL	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1547	1378	329	6301	12463	jxPWV3ASFTTDhMxQePAijxx9qydpXV5SAj3MgaDrG7YTys3D8qK	9557	13486	13486	1618366680000
18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1553	776	329	6301	12463	jxUwDBgCMMKUKQi9gJKWt8EEwqcxTs7DzbseQmfi4CaJv3hg6Qc	9557	13486	13486	1618366680000
18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	606	1049	329	6301	12463	jwB6xxHPYjgZnqgXmpXRC1V6gjxMBwUzUTmk9TiQ8b1vuseoAGB	9558	13488	13488	1618367040000
18952	3NLTFYgr3UKjxXFy35xwdyrdnhjV8GZw2RYCTdzxS4vzRczLXtmS	18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	1489	1134	329	6301	12463	jxhyMVbcnJr8HjRGJz7CSjdnPjvF2HqTuC6BTe3HQs5w8zuX44f	9560	13490	13490	1618367400000
18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1608	1163	329	6301	12463	jx6UQ16Vhr4qprACuYfCzGE5AbnT6DkZtbz3hUXXQBMWg2HuvHi	9563	13493	13493	1618367940000
18959	3NKY95BgZsjYY5VR5UXmsxGrST83EsEdn792X33hTJCFi7ZW5Sxr	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1608	1163	329	6301	12463	jwPAJ47yqQReX9RdDH6jjCS2JBALE9waimrkvKUE9TYsgtpyL42	9563	13493	13493	1618367940000
18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1448	1311	329	6301	12463	jxQaGUGrF2ZYnXy3Lk5Xb6RRac6Dqfh9D17paRgpg1nSAx2iBiU	9564	13494	13494	1618368120000
18966	3NK5bkt3FAU7m1Lh7LjUEvuGvKJZcXxHavB2v7jwHd4BP6vdsfgX	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1426	1118	329	6301	12463	jwUaLfV5KVoDdLr44GgkGpJLL1RFuQvkJYz9gpc2sFcXkYVFLfw	9567	13497	13497	1618368660000
18968	3NKHnV41pKGGz36ovPDmPqvS6PEosFJsGJm9V2X8rJ5G7ZfMftRx	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1643	1299	329	6301	12463	jxbaJEqq8rVwNwfLsAVZiuc793pFPsGLGCFZgfewGFdXSs4jyCE	9567	13497	13497	1618368660000
18862	3NL7V2ERcqVLShzK3onHbFYFXYxhPFNR1qbcn5TJobgH86Cas9KG	18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	1619	909	327	6301	12463	jxA5B1hPxxW4FgwowfNREVk3U7PNJgEf2s327Ds8tuHpTom5WUV	9511	13427	13427	1618356060000
18867	3NLtWJnPrdmK6VuLKLHcNrEdocmYainH5VygkCLA2nPoyK7TETZv	18866	3NLtaC5s9NtvhynrJfuZ7v5grSpEMK9Resk4qg4ymtRtpKvLaHZR	1403	823	327	6301	12463	jx9BCjPxQC4SVuQtYquakqR4WR3b6BajwpjQLnDQAajy4Unq2dB	9514	13431	13431	1618356780000
18870	3NLf88wffJUG11Trow5UmyswRY8spNP4ExTf3gYwnwFEK2Vww1ph	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1534	222	327	6301	12463	jwuNjURdeyno9EJhtt2YGW9PdYrahvTBLwQb1MT1fBKb3hCM7AN	9516	13434	13434	1618357320000
18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	18871	3NLXybmaiFCCTyQZNjuwewW6PpZC1foWrdjra4yx6TUz3ZbUXtq5	684	1352	327	6301	12463	jx5WR3GHqqBSymqbgzUP7oD5FqELLJpKBUrDPeQ1GCp7o1SMnQz	9517	13435	13435	1618357500000
18874	3NKcA3NHCcWK4hsgVN7KFVH3pkCRwsTbUbbevA3SvQHUNCCTsRK8	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1560	1045	327	6301	12463	jx34XQVdUSsNC1Cu4KukgCnSqdLeW5Jiyu6xxDoJsk56JQRNbvR	9518	13436	13436	1618357680000
18879	3NLF3WSjFeMTJJX2VgvDrmiUDvWduYHthfcm3rDZo6JheA7wq5u2	18878	3NLjjoQKcvsfnpTVtXkMLtTFGmLFGUcnjhfZpgho5i7DPDK699ef	1581	778	327	6301	12463	jx729t2awJaNLEcF5FbMaZcTARkBa98LDsYH9b8b3oR5Qxf9mpe	9520	13439	13439	1618358220000
18887	3NLeST2McgJpCokYb9darAWAHTV64DDr5C1jtXpTDpYxHTBrmJuH	18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	1444	1135	328	6301	12463	jwGyXQXYgorZi3YKWZQ35T4FJJKF1abufXKyEbUb8iwg5jxKDn8	9527	13447	13447	1618359660000
18896	3NLMeuMLBidnZ7U99X6tGCoJbfDENuzWp5ZvuU2DrmUZAq433t6N	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	470	1063	328	6301	12463	jwpmQQybMGsY95jhVP8n8X3ZFgrMNRjTdUFUn9UVCNLQQhwcBeR	9529	13451	13451	1618360380000
18901	3NLTRJr1o19LAL621Rh9hA2GgvM9o4Dgd3fdLZLRGTj5cf1ijhe1	18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	1534	1317	328	6301	12463	jxrnnsauv5X1dNJRrGAw9HwmtGXtKr29qrezvcmjR4ef4zAhSej	9534	13455	13455	1618361100000
18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	18910	3NLSuaZPU4hVeaGwycmqX9jcpgb8Bdrw495Aj8oe8kmst7Tiax7J	1547	1012	328	6301	12463	jwG6yPMFiYmnStfxajobBuLqN4KSTpintiWGmw71QTWtUWY7YSU	9539	13464	13464	1618362720000
18914	3NKxS8xoek6FMM8f5jJ8cou6mTu32YhXNoMDmPdrzVc6poaL8f6K	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1406	1393	328	6301	12463	jwzf7uxwDkzVgC6phARSP4WKmN3mSr38TRvV2AV1r1va6ELb4q6	9541	13467	13467	1618363260000
18916	3NL1dcwGG9oDs3d4AxpHu7k8t9H6XwhazAs7ogtyA4oK4qT1JgoB	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1407	1395	328	6301	12463	jxPb5FDzfKTZgNNADKYRRsfGmKULopMRrrGsfZgy4r6vDYBphH7	9541	13467	13467	1618363260000
18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	18918	3NLtaTo25NAk1t55mtdBob6jJGfdAaWMZjqJUB8QR89ZUu3wSmkp	1560	1045	328	6301	12463	jwHZcBwjsgrfW71DVNEPEkaVvseSUSPaafD9TyMEBsBWcBbW14x	9544	13471	13471	1618363980000
18921	3NKLTF6bk2VV3HiF7LC5ehbKUsj8JRgFn9jws3k86CS4JsjcBmbs	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	235	235	328	6301	12463	jwKNgRM4Y4Dd3rb91hxzyPrhGXVCFJKKrrznqSknbkPerQa8G3B	9545	13472	13472	1618364160000
18923	3NK4TSwDRHwwrfNSq9F7QJh8cfTpKNLEqzom9ghjUMmbZK7W9CwZ	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	1624	1334	328	6301	12463	jwCn6yvBaG65HB53tiBYjd4D2J3hQG2d5CwhzVrJ3U1wMs1s8zs	9545	13472	13472	1618364160000
18926	3NLNyop2bYCpuDA8q4jeNBeWRcjQKa3XtMQcCJYZsQpkqHByTNBD	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	289	289	328	6301	12463	jxwENqtdb77Aa7LRjWE899d23MRYS4WFUvdmvveTfLTMPt5Hd8Q	9548	13475	13475	1618364700000
18928	3NLaV2nbo8rwYHxQXtkEVHt3kgZ8KQTHQucH2ZBCJQmY7xKErVZE	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1471	1140	328	6301	12463	jxYj42fEND42BTYkNomSXvsmgF11afVf7qwmPZQ1dnMokV3CvSG	9548	13475	13475	1618364700000
18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	18927	3NKexyw8bqNn9DC7fYW8AFjyD9BoSoTbPFsfuu3NBgG7sZp4UeEt	1402	854	328	6301	12463	jxL9iich2BNPzbQbNSTASZJGYXEZsSRdHz7tv9UGdginQL5DTSC	9549	13476	13476	1618364880000
18935	3NKtwknfN82roECRcDfPMuunNBPA2LCr1gFgxLF13zgvvduuJEoR	18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	1513	1133	328	6301	12463	jwp33a7FrBnHjdDdbCDH2HPH7ThUuiHMhgpu2Xax4ZVH2AYFqh7	9552	13479	13479	1618365420000
18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	18936	3NKKPcVYbFrBcRQP2inXKsnRQDWigW6SMUkXkS6Bngh59Ke4gn1Q	563	1113	328	6301	12463	jx6RZEn6uuPaiZKXw5EKzu4sGaQHdkU5HBUmQB99orMerjbq564	9553	13480	13480	1618365600000
18947	3NLkfcEJQ49jF6RNWXEPpg5KnQFhqhKrJDiDFCKc4P2Zy3XfN34H	18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	1406	1393	329	6301	12463	jwb9cNE4qu1PBMhe6BrSo5jcuTAK8XNbEV6qj9qfJUkNzzqgbYN	9558	13488	13488	1618367040000
18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1602	1243	329	6301	12463	jwqf8tdx9AdMv9oewaetoCVDeMf9pNEFtQtSaRigAEqScS8af1R	9559	13489	13489	1618367220000
18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	18952	3NLTFYgr3UKjxXFy35xwdyrdnhjV8GZw2RYCTdzxS4vzRczLXtmS	80	1147	329	6301	12463	jx8L6cNkzjzMgZRExbzbsEst5BhKXMBJqyHNW1HqyTtjBahTkFv	9561	13491	13491	1618367580000
18963	3NKGcm245wG9EbjjvZKbVkVeXm71y9t8bLDYPBRjSyLukMoBRe48	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	1403	824	329	6301	12463	jx9ruT4aR4JBzQdbcmKzmtYLBVhka44GsxoXNqrRnQvyRAWMgNa	9565	13495	13495	1618368300000
18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	1419	814	329	6301	12463	jxhPU6a6R9x19GFVBzHPKCA9QDgGBkUNQyPPv4FohByBJjdbynq	9566	13496	13496	1618368480000
18970	3NLPivAsSETkpi3yCNdzkvGxYYaqHqMdqp2gEcQaZN91aEcXRaKM	18968	3NKHnV41pKGGz36ovPDmPqvS6PEosFJsGJm9V2X8rJ5G7ZfMftRx	1419	814	329	6301	12463	jwoegvVCAPdRch4o5HtZCnEogeRN237CSnfqddLQGkjuv3VD9fF	9568	13499	13499	1618369020000
18973	3NKndjdvptzrh7zbi69b4XbxPCRcSn163jJQExUQ3uH9oDWsWzti	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jwd17BPY3a9nfxVV13AdENpWQ369i19cCaqt9Lj78Cvzt2RCHzT	9570	13501	13501	1618369380000
18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	1444	207	329	6301	12463	jxpVCqeCa3oP5fUNi8ksWr5AsyRYNMMBtmXt8h2ZHqNfmYRrpxR	9573	13507	13507	1618370460000
18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	684	1352	329	6301	12463	jxDCQVAnncHGdoa4LXywsSNjY3SnmA6duUk36ja9JXeocSoS6Gj	9574	13508	13508	1618370640000
18987	3NLAAmYN9hEb2z1SUc3bFMi3iSeW8qW8AqLTfkMyTjNMXaeT5PmB	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	407	407	329	6301	12463	jwaVNJ7e7f8J8NYEN3ys473diUHMXADqJszpTnMxBEQNPwvYxPH	9575	13509	13509	1618370820000
18991	3NLcnoF7rPK3NKkroYxwa3LkYTJpf4gBzZKuJp9A84aPcQuDr1B5	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jworhCtHbXWQWe3BXwEMhNwyoeEP6gmr7tjCooGtv1bZVe4T3oT	9577	13511	13511	1618371180000
18995	3NKVqMyDpMxqXyPH2tLLZUH6aL97bUug9xhb5NNecg4AeFeHUTV3	18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	1444	1135	329	6301	12463	jws37yxYh3g9fmsaMDEHcHRua5n5XGJNLPDFrKNEkQWyNt9adzC	9578	13512	13512	1618371360000
18885	3NKu6PWSAkZG7o6bHYy348aBDPYEqsm1deeJPEeXvYuTLCvv7FoR	18884	3NLNdEsCpm6pgo4kqzhJwUV9wCaYtnPw5QAVMDJNj1pReqpchRnc	1403	786	328	6301	12463	jwdhVMB7BZFmhfHGWa55Z5HdTWcLbj3bha4vM6jmLyb7fKac3su	9525	13444	13444	1618359120000
18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	18887	3NLeST2McgJpCokYb9darAWAHTV64DDr5C1jtXpTDpYxHTBrmJuH	1647	1302	328	6301	12463	jwN9J1DVS5Vj3MmqtbBacf51ceEfyVF3QcWzv3dpCdKY5Ptquiz	9528	13448	13448	1618359840000
18891	3NKZi1YZE4AHXj9YU3J7k5zsggvwLXCErdXFPrUtfFc6n9ModfGM	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jwswtXSfYhzm1ZwA6kbxausWc4RuqbxQ8U16MXEpHgAHbG9hRhc	9530	13451	13451	1618360380000
18894	3NL71KgCjF7UjaMNzkcVJiwvYKSqtigNY8XtduGPSiUTGdYZW7VC	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1402	890	328	6301	12463	jxzqbp2E2iLZrXSgypwhNikj3iEw6Ryv9sv6gz4rLgVtfGKP2av	9530	13451	13451	1618360380000
18897	3NLcHAupEFCP4j5VMEvG61y3ikuPpdoMAJkr8usbJLNiyimdC4YW	18891	3NKZi1YZE4AHXj9YU3J7k5zsggvwLXCErdXFPrUtfFc6n9ModfGM	596	1180	328	6301	12463	jx94hzG6rkffCLYprn6QG6ZDmB5rGqJghmjhjrpaBZrq1TamacT	9531	13452	13452	1618360560000
18910	3NLSuaZPU4hVeaGwycmqX9jcpgb8Bdrw495Aj8oe8kmst7Tiax7J	18907	3NKpcvFjUwfJRBa3HTzLcykD76HkMJV4AEdgAAgCQg4w6KLkYMKy	1534	1071	328	6301	12463	jwxyJYNpmjcet1bG3FjCct8L1bN34dA6oPC4yAJXgn3QDmy7Zup	9538	13463	13463	1618362540000
18915	3NKCBT87G4cMDot4vxttSgRKDwbFYHVAxC2sr9fpiQYtQoCRxz5J	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1654	1214	328	6301	12463	jxnF3VHRCtuEYoDwyPnVsJUsMiaPZs51RsunkHvTK6ot4FMFDYH	9541	13467	13467	1618363260000
18917	3NKwcPF9YG3r1bcEXxvTa1U6Q7c17BDsz7xf4Hkts1Ad97QQ6fS3	18915	3NKCBT87G4cMDot4vxttSgRKDwbFYHVAxC2sr9fpiQYtQoCRxz5J	1407	1395	328	6301	12463	jws6DRCRk3SJ2UsespZ2QzEiJaDnoAgQkLUrxWSWcBfzZMricGC	9542	13468	13468	1618363440000
18920	3NLxnCmPhX6uNphnxGKJh73dYpkZFjAVmW5Hg5MDwnL3wyVEWqhV	18876	3NLuu2VfXqt8BVtvuqmPpoHU7VPGeyASqro1VAsoQMus2FpNLLAS	1560	1045	327	6301	12463	jxxYZkUFpyierPD6HuqMe9mrx1XADBSAnbBnKrq5amWJ3BAUvsm	9479	13471	13471	1618363980000
18929	3NLrLjY9P4pXnHvQhLxB84uoTkLUpBAwtcgS5dqzaUrwuXBTUx4v	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1406	1393	328	6301	12463	jxsGqkXfCaxA9bJvkCXgu7n6XUR1TLLMHAV2aiLk6swDZjwdbcE	9548	13475	13475	1618364700000
18932	3NKCkArFFwWs3e4DdeMXZ9cvdDCASd2ZuDFkoyJukEASRLBS1ZXN	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	1474	1083	328	6301	12463	jwsP4q5MCSxvRgfChz96r3JB4MqNpia32Dyd8fdMD5ttSaDydzM	9550	13477	13477	1618365060000
18936	3NKKPcVYbFrBcRQP2inXKsnRQDWigW6SMUkXkS6Bngh59Ke4gn1Q	18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	1631	794	328	6301	12463	jwfgsK2LphzqGXBPgKwzj7oxX3tpUpETRdYTMTrYCph2wDvDYXd	9552	13479	13479	1618365420000
18946	3NLo8oGWtCNEE2nGFafhPCYTV8pbH61PRhwKsKitdf7BEJ589G1i	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1599	1287	329	6301	12463	jwFBQ9FpnBSv5edsSYCJQXxtG4kHSiL8JA7dFdH4hB1YNo8xsQT	9557	13486	13486	1618366680000
18953	3NLxb1wyEe9EozegL5ZgEEyhE7QbMr3vuUdjU6YHH34eUdREA2ho	18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	1549	1116	329	6301	12463	jwTLZ2KT2gkuJ3hW4afVXtbsd6vcRBMVW98e9TVUDu6ZCdgMt7Q	9560	13490	13490	1618367400000
18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	1406	1393	329	6301	12463	jxBBwdUDJshyrPktGGBbcRNWZYWC6fzNnPX7UMTn8pCLvEk6HL7	9562	13492	13492	1618367760000
18962	3NKTnV1419pwuLm8geUsRACmbgADSk1NLg4DkGZYMmgxntjjDA3f	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1448	1311	329	6301	12463	jwyF3MSqS8Sd6YgCHib2JFRmg7Qzg2LbpQdz8suxqjcRyyjUtoX	9564	13494	13494	1618368120000
18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	1553	776	329	6301	12463	jxyuVAbiVGxPnjo8E5gbHP4vjXmfuYuCaTNb13Tmamfv7TrR2iU	9565	13495	13495	1618368300000
18967	3NL1gZzWKvFKjXD8r1yJ7oUgxM1ViQJbUzFJ1o54Jg7QKaeSZpbQ	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1406	1393	329	6301	12463	jxymJcmraLU2xBp5txioani8C2TpEHxcL7WZb7oxt7P1DFEeG5s	9567	13497	13497	1618368660000
18969	3NL8EXD9zgUdGFPtvjudxCSWJGn6rX64jowqqPU2xi1ikpjfN7HH	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1633	1024	329	6301	12463	jwSPcHqaEbvCj8kom9oz6ZrFKVAdMLwD8foBmnSE5CfvDLpFKpL	9567	13497	13497	1618368660000
18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	18970	3NLPivAsSETkpi3yCNdzkvGxYYaqHqMdqp2gEcQaZN91aEcXRaKM	1529	1316	329	6301	12463	jwSsLbzjWsHa6WSqvtLWprJUPrc4VmA2GD1jKzYDKDeWyYVj8BA	9569	13500	13500	1618369200000
18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1648	1158	329	6301	12463	jxLYB3GJ7mhQjzxFJoA8dUM2HcmiPcKcP1fuqeQffHwRubTN8vm	9572	13506	13506	1618370280000
18993	3NLWJmBgHsJvVNfjKq7kumoVGwQsBUg8ChxNR48YwpKneGrbjgr7	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jwYsdDV41CgffHNFuvxaM612q6ps9t4Xh49WQPLpVN55t9Dgz9v	9577	13511	13511	1618371180000
18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1611	1341	329	6301	12463	jxCdMnX9NmDSQxD8iuqneaJxjZCMHNv6mzyrboPR6KYTLeohdPZ	9577	13511	13511	1618371180000
19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	1651	1301	329	6301	12463	jwus7FRiCpEzoaWTEvQcoWMu4ymha3VUbQ7KwnHrM92o8qFdoQZ	9581	13515	13515	1618371900000
19003	3NLCu6zU6BecgxC3yETZZYPuKQvGibebdy22DXyWkH83VCoArW5n	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jwTS53FhKxRsXFvpSiNToAkA717eNziNDwWDrqQh9Aj7nQJ7EEm	9582	13516	13516	1618372080000
19006	3NL7vxrdH9hpqe6LkXYufnizgsoBUgCD2N3FuMU8Bkv4k8Pcp2Fn	19004	3NLNHdp4nb9Cg3FeJ7R1924zzf6Bqxrp2bnUPqzhVDmmNPX5RkSj	1587	1357	329	6301	12463	jxbGgUPRTiTg1KUGAnX9FYnqQcA9FV9MuYbJywbayTU59jFCYPT	9583	13517	13517	1618372260000
19008	3NKZxEwGdjMArkC6iawXrwkHiRLhmy3ou1nVAqoVAAKHxB9qXjcq	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1610	467	329	6301	12463	jxus4k4Xad2ndALkCpSCGZqn2AXHE7rydQTNJ7FWYGiim5nUND7	9585	13519	13519	1618372620000
19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	448	939	329	6301	12463	jwWtdAMHNJTY9Vttik9hP2E2ZqPMiGZxqyNj2nKxtJcjXDDTBf3	9586	13520	13520	1618372800000
19015	3NKVXtR5ibuXmmrCah1hRfT8iS7c9oH7mQyTC7TfFfrazmhgBTFM	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1503	1151	329	6301	12463	jwJkxzQPdyjRATdwTKyqdXPP4sveEWTYmDaVjbZgeXG9RkHRppm	9587	13521	13521	1618372980000
19019	3NKg8KmFqoL5JhTiZ82r5ybqNbkPGeUi9Pwi2qdiKuJpys8b6A9v	18819	3NKyvtpUkHcDYDqkUSrUhUvTui1nJAfUnMcgjeoQV8uc44N2pJEh	1649	1383	324	6301	12463	jwz6m94tyoEW9Rv6qfRpLRJ9tBzJ5o9bEPvrhFDEnwELSeQiaUC	9439	13524	13524	1618373520000
19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	1593	1100	329	6301	12463	jxaP5LGhtWELMjEKMUWPFnBSwnPQwPzQdFaQPKxUMQuXR9P7chj	9589	13524	13524	1618373520000
19024	3NLs2vEMN426P6cYQ7j7dkpYbzESppcgUudBYnJqw1TRPQQ2kbZb	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000
18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	18897	3NLcHAupEFCP4j5VMEvG61y3ikuPpdoMAJkr8usbJLNiyimdC4YW	1637	816	328	6301	12463	jxW7hzxebwzXTV3C3Su82DYR3bpJVV6qUFBcDzh3itNnXK2pooQ	9532	13453	13453	1618360740000
18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	1601	1142	328	6301	12463	jxA8rEpMGRrU7tMAi7XRcK9ZVJCHphSwu5qFz67JmhwHdPeVGUU	9533	13454	13454	1618360920000
18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	18901	3NLTRJr1o19LAL621Rh9hA2GgvM9o4Dgd3fdLZLRGTj5cf1ijhe1	470	1063	328	6301	12463	jxeGDTr9osUqHcushnKuknfXhoLviubvpNgtSz62CDf4M6wkTdw	9535	13457	13457	1618361460000
18905	3NK5jjyZpj8Xqsib9MpoXvhYSpjk1nVTt1VyHYqXbtDu65xxA6kz	18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	1547	1378	328	6301	12463	jxhtEqMkMVsCLKMLHeezqQajy1D5j711enakHnJfDX8frQZLVrs	9536	13458	13458	1618361640000
18908	3NKRukMvCgmMCt7EX21K4Z8n8wSxoXYLjWW1TCTy3bmuG7Cd2t4j	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	1581	778	327	6301	12463	jwPzAAcrc4C3AX2RMB4z5C5CyppBhfXc2BxUE6MYjMtjJHMrLA7	9509	13462	13462	1618362360000
18913	3NL245HJsCZ5jYhyc7rSeTunF9xVsYEEDV7DYfAa5s6Ga5fZBde7	18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	1406	1393	328	6301	12463	jwDAQEUtusBX9cr7tt5gHVEW4Ww5MNVDdRYBJCjgEpX6Zbn2e4B	9540	13466	13466	1618363080000
18918	3NLtaTo25NAk1t55mtdBob6jJGfdAaWMZjqJUB8QR89ZUu3wSmkp	18917	3NKwcPF9YG3r1bcEXxvTa1U6Q7c17BDsz7xf4Hkts1Ad97QQ6fS3	1451	1292	328	6301	12463	jxHcz81aixdjUv979yGqW3J5dBHhUokh6EqTZy12Fw1sVhtk6a9	9543	13470	13470	1618363800000
18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	18924	3NLqN6HSQUDmowxCU3DMZLSseeZq9XFApNeFWDVBBVhMemh915mK	1501	1360	328	6301	12463	jxWGhCE9EZ1PPcuHYwZETUVFG5fWX5nR6njUsZt21QTX61RLNEQ	9547	13474	13474	1618364520000
18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	18932	3NKCkArFFwWs3e4DdeMXZ9cvdDCASd2ZuDFkoyJukEASRLBS1ZXN	1541	1052	328	6301	12463	jxLTcnhHVh1rc2YocfU8JWsk3sDYm2WhVVJMzPyWqEWUGpZhwu5	9551	13478	13478	1618365240000
18939	3NLDGKnGuvuYxnDgg1aig84vhdE6YrAbaRG4tfn5o9ACBnqWYzRw	18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	1407	1395	328	6301	12463	jxvXf8YwX7cwu4VMsGrmBpdqrCLAqUPDXEwbFKTGJBvuTDRXNrA	9554	13481	13481	1618365780000
18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	1407	1395	328	6301	12463	jxVRJCy4MCvwUSUxcc6JHUUXCTyay2NMSc5EubaLLLEUEyrXeMQ	9556	13485	13485	1618366500000
18944	3NLfAN69iW8vg2Z63QiNUFyQniDEmDy18LaZ8PJ5pVJkVE55YcgF	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1599	1287	329	6301	12463	jxNPE6V3E6uudeCUy8hHVndSG4K7qE3k4s2pktPhATb8oXDmrXa	9557	13486	13486	1618366680000
18949	3NKP9JaKZpTJRLftFZDPctdzrad2yc6ePHef63u5MBd7Rb7nHnJV	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1406	1393	329	6301	12463	jxk9FHDMDNBempeDnfSxRuLNmBxTDQPokVcn9xHxZqowZZS5iAU	9559	13489	13489	1618367220000
18951	3NLJizXxfw4vA8MxeGmVG7GWC8QHnFeNbKMCBE2sDZ471xgNYUG3	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1602	1243	329	6301	12463	jwk8dFpoCNY3vG6U7kHqmVQqKDnEz6nc2JSGiE5B4841yJRUHwd	9559	13489	13489	1618367220000
18956	3NLwaGn4crxA6Pt1WXy2iJC6ELnDGZoQgMB7n6T2Gk1HdQ4mtmqT	18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	1637	816	329	6301	12463	jxjo9umDeq8S2HNrXX7oHnnHSaQsEXHofacBRXaVUAtaNXogZXY	9562	13492	13492	1618367760000
18958	3NKCPny86GxHUqcb41zhBfhkRcB4g2Yx2rjvTSEPhbvxRbHBUnVj	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1581	778	329	6301	12463	jx4qUh42hcEBskvNZQA9yX7BVWtiodTw8GtDjKHn3ZPxSRJJr1B	9563	13493	13493	1618367940000
18960	3NL5XjNNiH15R6xQgu9oUmcgpy1UEMQswrdA1xJ2Qk9egnFGDyi4	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1405	867	329	6301	12463	jwnjeTDqpehaj3RnJZHV89FN8Gs6SayqQNKuADomPCzz7FssQ3E	9564	13494	13494	1618368120000
18972	3NKBprv6CPjrEPR1em4XcHKo7eSvontoyXiZmkd6YNKYmvvpNjQm	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jxSFmcMbrdbhwHRXzsLiPApwHRDrhwpcp7ax5TjSjAEGnoiRJ8H	9570	13501	13501	1618369380000
18976	3NKCotUvL91NKCf1yR3A2HyYy6fX4mVwsYANk9bS65Duy3armMDM	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1481	790	329	6301	12463	jwANMvNX22rYFLDYn8qXPChCAjARnB8XpvmhAvAJzcwsYRAckwi	9570	13501	13501	1618369380000
18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	18975	3NLjSNZs17HecHpCAARg7qcgQEFbL7vzFaqRGjM1jAR9Dx4fvfLr	1601	1022	329	6301	12463	jwLJopNBnEWyFQYzKUtusbCMb12NaCba8vWxkuS9toT2JRifvYh	9571	13505	13505	1618370100000
18981	3NLH3AhPucMi3pg3G7tpYiJih21JVGeBtmUGeVNGbgnkjSCJuYFV	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1559	1353	329	6301	12463	jwoAFNtwTrjTBw1S9VZB4CNZVV1vQrXwrHUPzBzGkxX7sLrxFwt	9572	13506	13506	1618370280000
18986	3NKVmQYzKRWLdjmWSMV8eqURGG6uwzap3Y8qztzqvfyvvQJmZ5D4	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	1668	1370	329	6301	12463	jwWsHvqRMuYRrfFWiXtkVsafT9XimmR2D3LPjnFiYGNR8GCP5J7	9575	13509	13509	1618370820000
18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	1590	1054	329	6301	12463	jxV66t3Q7AHW3oZsybY6cLJpdgxMy7swx8JzAWSZ9XZ9qcJXAY7	9575	13509	13509	1618370820000
18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	1553	776	329	6301	12463	jxG4AbTpoXWtZAds81a34m61kpMsrd8xMh5S3cTgvEcuzh9m2NL	9576	13510	13510	1618371000000
18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	18995	3NKVqMyDpMxqXyPH2tLLZUH6aL97bUug9xhb5NNecg4AeFeHUTV3	1419	814	329	6301	12463	jwfsrrfHZAVcRtqP5Um3tL47h9BtHpyHQkEDkryAG4he4NJS6ik	9579	13513	13513	1618371540000
18999	3NKfdMiozVtTyH5axaoHiCP3thScEV56EHr8ECC4oiCa6FuEJEA6	18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	1627	1259	329	6301	12463	jxpN6sWcASSYNTCwsPYrMaWUAUahiwJFupDw1U8b3eUgbAhBtfb	9580	13514	13514	1618371720000
19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1503	1277	329	6301	12463	jwRjZZcUTLnrFzr7R2jDBvKEPump6LEwJLFTgGCRaZwg5yrQhFx	9585	13519	13519	1618372620000
19013	3NKbxWu4hYsxcvTBing3g8c6bMvwCzxLkon1K28cVwkSK1ieAjAf	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	1631	794	329	6301	12463	jx7DiPN7wmyDY47XbV1EYKKdiDSydj4YkNTsH9ToUzQ53cDjD1j	9586	13520	13520	1618372800000
19016	3NKij9MDMsB4wnV8ZxeJbD44cpfHk7y5PYJ4KC3AurCVaiQxm3uC	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1547	1378	329	6301	12463	jwtk2nf9wH9nY9wFa5aGWi55MKWgfTR6Xbe4ytHpSWWKB1TsMJs	9587	13521	13521	1618372980000
19017	3NLfrWXG4Hm5etUCNKupmEskrp6gXTrp7rUJpWWmJ6D1tscvULZs	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1650	1375	329	6301	12463	jxyeQHdhYbhZYXrHCY8Nouts7Jf1SxXFWyxhdQzyCBrfUwAj4NS	9587	13521	13521	1618372980000
19022	3NLQ8WsgP3joyyHuocRhqm6wpML6RMikM5P2eseXxgrE4jaczCEd	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000
19035	3NKszSPBVFDASNMv9SsxFhD9PpB45LHmCJ897Tk8AEogX2N39JTw	19034	3NLEma2D1Lxn8zeCLRNQUbdZvpdvgDQUVcvqgubDVaMHb2Haon1o	1534	1317	330	6301	12463	jxUTa6E64xVphszvpZkG7JYaAzKmPsuoVuDqNhiUBxqav4SAkML	9599	13538	13538	1618376040000
18974	3NLXARGoCxTJWBKYUbfZSnRH1KrHLgEJjArgXvzVHi8RWa7FFqgV	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jxqFqDD3F1hTPf5vjBi1vcr8EKm4hEc13dC4Y74tP3nLfK8W7iA	9570	13501	13501	1618369380000
18975	3NLjSNZs17HecHpCAARg7qcgQEFbL7vzFaqRGjM1jAR9Dx4fvfLr	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1627	1385	329	6301	12463	jwiDeBngr5QhgLMLgQAGSgy6RzEj79bTJh3MAWCAjPfrBqcsiVi	9570	13501	13501	1618369380000
18978	3NLtNDQbc4aEbJpcrrZY1xqPEJCoB2Yi3sESmAy6E4Td829C12jd	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1588	1392	329	6301	12463	jy26AHCfTGPSN32gqM1m1HnDooupy9QyD44UKz71QmaHZMkM31h	9572	13506	13506	1618370280000
18980	3NKb8ahWP3UWexPAvRKx13v89kW3eChMqhX75RCMudnb4RtCQAxn	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1559	1353	329	6301	12463	jwF7KEN5svQq7rsLsKBq5qvxrEbromtAPcfVXdZaGzvVVkcHC7D	9572	13506	13506	1618370280000
18983	3NLNWGpbwgJesYzw2nJ5R8tz2S18ECN3t3JzeNxHsu2CLZJs2dZk	18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	1406	1393	329	6301	12463	jxC7BJEXaibXZ3vdQCBXZet27ixfgczjUu2C4twKgZ1RDc698jM	9573	13507	13507	1618370460000
18985	3NLZSubVr1ze7zSMAGKXaQ9p9xK1JX1WaAhcLEwNqK3X7TxrbK8W	18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	1637	816	329	6301	12463	jwWMPAt3SQTZ55vTGHgSQF3n55wagSbQ1EAPPKX4YCix9amRLZV	9574	13508	13508	1618370640000
18989	3NKH98b2tNttqi1pWxwehyHuwDturjMtGpaDnEBqjQKgDHGVQYMp	18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	1402	852	329	6301	12463	jxRiNWAhbdd7QTDvRjUD9ZxLPDHthRUKP3XcPkbSMqCc8WQedMu	9576	13510	13510	1618371000000
18992	3NLek1pki11dLxh3HQPardsUrRfba5UKLcuNQda6GACzHYZpFuBz	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jw874gcHyewsaUQvEJNv2JEDpX36hRQchPn27wiFFHZBhXJ5dhy	9577	13511	13511	1618371180000
18996	3NK9GywFgAVBWBDSVb4VA3VgpkLcX5brW5ZWQzVe5aErJp2ixQQJ	18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	1403	824	329	6301	12463	jwwQymZRsx2twCEoTPehuQXyuVXwmYGicDsToBdXy4iAouGvTmc	9578	13512	13512	1618371360000
18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	1599	1161	329	6301	12463	jwnL6B2Ee5rWwDgjLrQXMhqWLgXQ2W6bKCYWZbPJkVheoEuyTnd	9580	13514	13514	1618371720000
19005	3NLURHkmSMc7sLFJL7pE23ix16cNzuHPqZgZcyY2vD7xZwjwYvDx	18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	1587	1357	329	6301	12463	jwPSCt8Visv6xcWdxcMs81LbwM831iQXHtmAqswj4jxC7iTdrTd	9566	13517	13517	1618372260000
19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	19006	3NL7vxrdH9hpqe6LkXYufnizgsoBUgCD2N3FuMU8Bkv4k8Pcp2Fn	1588	1392	329	6301	12463	jwzXpLtxvu61p4c3KFkrMtTv71cJs46ALfnAnPB4ddMskKTAuuw	9584	13518	13518	1618372440000
19010	3NLhLHtkaMR93g6AbmQm5rZQub13sae6xuC6uxqFZt6LXcadFm9y	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1405	891	329	6301	12463	jxRi5HfYZ1uwQbBTivfadei4cvjgu1t9t4tVkzRmfHn1nMfkw8k	9585	13519	13519	1618372620000
19014	3NLab5fxCtHMSzUcZw9iJCVugZKG7qAjS9vy3sWULemv5ZyHu7yF	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1483	893	329	6301	12463	jwjhqLeLn36NFN2TzArfbxwJXsNKq7B1DdLDYNfUWNNyT1rCTnF	9587	13521	13521	1618372980000
19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	19017	3NLfrWXG4Hm5etUCNKupmEskrp6gXTrp7rUJpWWmJ6D1tscvULZs	1623	830	329	6301	12463	jwzgUwSdUEG6Ncr1sikXujiRSu6PqVvpwsYSbAcm723xRvjNhGn	9588	13522	13522	1618373160000
19025	3NLrXFoojixQ7x3rUeppbJNzpNebJL7VQwfGtGaVCGnRPQKJXLVR	19022	3NLQ8WsgP3joyyHuocRhqm6wpML6RMikM5P2eseXxgrE4jaczCEd	1402	852	330	6301	12463	jwPiMCGx9TTWx4tLykFsdndFWPBEYJzMDMdySBPBiNpg1Xm4Gch	9591	13526	13526	1618373880000
19026	3NLqoso28pDL2rCCdWAeFcbHMbzqxm62HXvZBduzru6H3SohjaQP	19025	3NLrXFoojixQ7x3rUeppbJNzpNebJL7VQwfGtGaVCGnRPQKJXLVR	1405	849	330	6301	12463	jwWUZkW8TeAAycE2ev5sRzWnBSkFcDd3VTJGgKcxX9UVsGho6Bt	9592	13530	13530	1618374600000
19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	19028	3NLS6d9Q7diuNtP4NEUHdXYtmdFa6upA6nNJx8aesdgcTYpC5Veb	1607	1102	330	6301	12463	jxrDt3tWDV5JYNZLTEZV9uwDeLij3w1UaCUQtVoMotAXqeYjgjk	9595	13534	13534	1618375320000
19032	3NL7YzF6VS1YZf67qeSKtTVFrwjyiFhQqP8zA6nmuUiaA2YRv7z7	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1585	1366	330	6301	12463	jx1m7MVesWPaC5oc43zZ93rrfRwG8Yip5SKvcNWdyXyX5vKZbmi	9597	13536	13536	1618375680000
19034	3NLEma2D1Lxn8zeCLRNQUbdZvpdvgDQUVcvqgubDVaMHb2Haon1o	19031	3NL2NUhwbxRk5ucjyw57vHzFZ78Yp4g8zwjZ1si7jFQ5GKp8LsA8	43	1064	330	6301	12463	jwWcBXxDZBD5FuhHiqo5rZAhZJ2ddvHDg4x3bgtEzYYxtyyJvBz	9598	13537	13537	1618375860000
19039	3NK5xpze2Np2FbvubBxvzahwaxz5x2YzSLk2RQhF4XAzcG9DHxCj	19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	1406	1393	330	6301	12463	jwE9YbArEwLmBv56LY3hA3GyH7X4gMYjjsuJQbrtZHWgkbPAZyq	9602	13541	13541	1618376580000
19042	3NLWwRGYpXfdktDYVeMiYKsM5sMFRZmxzampNcPsY7Hx8YMbsdoM	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1553	776	330	6301	12463	jx65DfcxLRy4wEWcYMGMmbYGNxg1ApHDnAEaHiveTGGu8AYrbRy	9604	13546	13546	1618377480000
19045	3NL3YEE4u1tRekLHakYhhRZyRqpH7FEcB2CGUYW8NktoUzYM13RQ	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jxKVW89ovwgVFmWobw1otDwCrBzrSza72jGwh6PYjwRXwkvko7T	9606	13550	13550	1618378200000
19059	3NLUnYg9MeNN3Nt6B6DgZ9EshjfQBNLh6XfhjkdMPbG23MwSWRDp	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1578	1050	330	6301	12463	jx8s6nXsaxi9KLTPJMqkNMbC6kjKxn98Fu7vRVhjtjn9NAUctoe	9612	13564	13564	1618380720000
19063	3NL59XsvU5YUf1dk3kyN8UkURjmobDjuDtt1RnhaKXM8aDoCHLiY	19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	1403	31	330	6301	12463	jxuuC58MHHmVKCjcMEzBT9ehgbbiLJCu7oibCbJGVMM2BqFuYnH	9613	13565	13565	1618380900000
19068	3NLrmFQeBM86Bgtta4fnb1Vk5oLbaTTcV4843PdQj8jcSCAaCxHq	19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	1406	1393	330	6301	12463	jwxF7MpwGf8dAbKio8QFt9Muk97CFuSTBPvLP9HyHnMXdthNia7	9617	13569	13569	1618381620000
19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	19069	3NKjW41aJ9D59kxGCuy9bJyW9rjy5Z7HtFfycK31ZyegCrFKYbsJ	1406	1393	330	6301	12463	jxDy8tALuKYZdZz3YaDS6dPiEGoDxfxt3es23bNcyVb2RvSwcQd	9618	13570	13570	1618381800000
19073	3NKQWbQri9jPnVUQjRW3zxSHzY1ohr5YpFiEM3aSQ8vX8oAiyKjS	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1643	1173	331	6301	12463	jxvWTk5eei35izBHqrbKin2h9jbdzp1L6HA9zTtn6pRxEfXLsLc	9619	13571	13571	1618381980000
19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	1553	776	331	6301	12463	jx5xBnje2QsfDQKcEz3mcHVRcRtfcRDvCaKrSfqgfoZi4iZfXFt	9622	13574	13574	1618382520000
19082	3NKWYqEkQUAfkp8v35zVujkocvwn1KgVeszNksijakxDWT1xFvjc	19081	3NLnbdMcDqxAtuP825Cizmk8jUmagqWCNyPr2QTDcYrTgqNQ8uFi	1403	782	331	6301	12463	jxKUfusWVJUp3pg5nhMyVVcksFGawj2HTBtYz9dzWuM2XZ35PVG	9625	13577	13577	1618383060000
19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	80	1273	331	6301	12463	jx1v9uJCzNRpkbcvGtcgmpUzaPAo3zfniL1oSVCarCPRQKfHVFj	9627	13582	13582	1618383960000
19088	3NKoZ1DszYqbsp7WKiWEJvAzALJ8w5Q71oK1XoiNwCsXBzebCD1T	19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	1402	858	331	6301	12463	jxp9nAVZrkCZcSM8QE8yNv3kFG9kDBAZJQdrd63KZfFjTEZjs8A	9628	13583	13583	1618384140000
19000	3NKcMShfWaG3qHrhVL71sw9K78r9eR5YQfMv9osVzqBkjBHLwCjx	18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	1651	1301	329	6301	12463	jxVwrATBtTFPqtmHEjhB3PcHkmWpUMnLxp4YZq9iYminETpkwKf	9581	13515	13515	1618371900000
19002	3NL6yBHa1gHapK4iSc7T1BTXD19Gicg8imNERfa88fvK2Lb69wsU	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jwp19pf9rRe1WkGnUromJBd23WCgWNqCkZR4GBc1ahW4xBxa3c3	9582	13516	13516	1618372080000
19004	3NLNHdp4nb9Cg3FeJ7R1924zzf6Bqxrp2bnUPqzhVDmmNPX5RkSj	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jxAFLuUCKJnfp7mhVPNjuVUz5VkVap2VrF5GEFrG2Dg5AbV8D1V	9582	13516	13516	1618372080000
19011	3NKRxaXmyLvNQEGS8NY8r8rRP3ydJfEDtFSkysrohk55nZvWsmHp	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	1547	1132	329	6301	12463	jwGY1RvnTG63JR81sCRAkPtXAKMM7D326GQyjnCmFVsksv1syVA	9586	13520	13520	1618372800000
19020	3NLcgHnhq4rquKbYSHeWBywws6DDAYBf8hda6hyVxbEPL4n2w5AA	19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	1649	1383	329	6301	12463	jxsdo3zY4bzamt9EjXnzCPKSsHSdwQyCY27EXJB91aStWybFqL3	9589	13524	13524	1618373520000
19023	3NLcCeSot7hFFRygRHxinfuq5ow262WkvTjsA1bFDVcTViLKemUV	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000
19028	3NLS6d9Q7diuNtP4NEUHdXYtmdFa6upA6nNJx8aesdgcTYpC5Veb	19027	3NLZfPXhv9UgBqLsbZgypy9S69F7SgAs36fAZ1DEmv3h3HNHME5W	1455	1086	330	6301	12463	jxwi9hTthUh6dudkreGZvsHGgzdodVszikHJDbvcCzybzqDvyoR	9594	13532	13532	1618374960000
19031	3NL2NUhwbxRk5ucjyw57vHzFZ78Yp4g8zwjZ1si7jFQ5GKp8LsA8	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1403	824	330	6301	12463	jxmpTWnhTLUxLftghLQKVquRusEJezuwexAtcM1j2UJJLkSibMz	9597	13536	13536	1618375680000
19036	3NLaHWkXXEbHsnJeQEsvkhvAD9QhTjP8VqB1bDqSyKopdCBZaK9J	19035	3NKszSPBVFDASNMv9SsxFhD9PpB45LHmCJ897Tk8AEogX2N39JTw	1516	1048	330	6301	12463	jw9X8EaVuspNxfaXzJ1EUUszn7uhtrsBeMqnzLPZBcBJRAhBouq	9600	13539	13539	1618376220000
19047	3NLvQGKSpw7tao4d9AVoJtnatnUsxERWzkVbCetfd1PdUrtHkMjg	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jwnfahhzNupKL9F2bYSN7JT248z4GYS88Thuq5neZ1ebuZadwVg	9606	13550	13550	1618378200000
19050	3NKCj268v6KGvsPp7XmCxAgWDYQ9mZye54i8H4cc75nP5Ungy3yu	19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	1513	1253	330	6301	12463	jxbkPM54jftvqJXZ1aW1tsN5CV1dzio39Hc4aw7Vkv3iSSqcBmo	9608	13555	13555	1618379100000
19053	3NLAWBtV8sw5ybrgjKfeBQ9YpWwKsmyAMMzgw4D9PauQdTJ4RAP9	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1581	778	330	6301	12463	jxyUS9uUH9o9ptqAxxDjUQ8RVArpHf425VbV1ipqPCzGmi3SUV7	9610	13558	13558	1618379640000
19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	19053	3NLAWBtV8sw5ybrgjKfeBQ9YpWwKsmyAMMzgw4D9PauQdTJ4RAP9	1422	1091	330	6301	12463	jx62vvaEcZYY66WemxJno4kDkJCF8xXCPzy6ojDLYRKToUBteFy	9611	13563	13563	1618380540000
19056	3NKGm4zLRvscUnU6ykyNrCEQ4RAr29Djhmfz6QaakndZMjLqGnjc	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jxoYhKURXwHqBBDp1f22eu8nfJZYt7TYLYBbWqF9ELwfJJ586zb	9612	13564	13564	1618380720000
19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1407	1395	330	6301	12463	jxvHvANuMYEe1ssZWpWcvs9cypCmCxEzPo6MWFe3S2oh7kckH4H	9612	13564	13564	1618380720000
19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	19064	3NKvWf1WxY2LvdEfzZYj64HAYAu2rc1coh2qNYKpP9CjrgQ3N1Zc	1647	845	330	6301	12463	jwQkvNwinnd76kMKzecPahfzKRXcft7r2gB8Z7zHSDb5P5TnSST	9615	13567	13567	1618381260000
19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	43	1184	330	6301	12463	jx5YBmJRYezUALE1gcTFNYkDMCgSfv5t7hdh38kZEvzJXGvR4ux	9616	13568	13568	1618381440000
19072	3NKUrGzepi3EMLzFTVdopuoHgQJ36DzZq8W7WFvuPcKuXPJQs9eC	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jwKxLq88oTtCcbirkf3LW2C3vsssGmq5CjUodCpsq5vU7TjSPTd	9619	13571	13571	1618381980000
19074	3NKmpxCEvykKjgAqFEXz7Jv93AVTCXA3rxrHxLkJhsSESnKovgdW	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jx9GvTHpFixc2jii6wea9UFDSY7yXComX5WDXvZx4hse49r7VWM	9619	13571	13571	1618381980000
19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	1403	824	331	6301	12463	jwevxVY39XC9VgFYMcRAG56QixhbvyTG6bBxEwgeZFR2bQHjiCH	9623	13575	13575	1618382700000
19081	3NLnbdMcDqxAtuP825Cizmk8jUmagqWCNyPr2QTDcYrTgqNQ8uFi	19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	1406	1393	331	6301	12463	jxrufsafESmE6pmp1RSArdhMQdYK7Qk2rJVw5msMuxu2NahuQxv	9624	13576	13576	1618382880000
19087	3NKoiFWxyBmca8R1roU9xA547jXBkjMHSHVE3J2aQsC7f21hQD6k	19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	1406	1393	331	6301	12463	jxUJS1kCMxvtDooie87eNCQCfajdkPBLmMFo8tuB9jAyuXshvRD	9628	13583	13583	1618384140000
19090	3NKgTk84c4bjvihauBC9HchbjRs8KQC3tQHeMKAgLgosxYBKQr38	19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	1497	654	331	6301	12463	jwdgMRpNpZQhBBGYFLj173iKxcV3d2Y3grYJ4GRDRe81TpgfD3Q	9623	13588	13588	1618385040000
19095	3NKKGfJpP8sCoZrDAKjmQASKSajxcP6csfttpELX5qKA9so8NqFM	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	563	1359	331	6301	12463	jweGr2HS9XGGrRpDE46kA4pLmjoB7Hk5WB6TZ5pCoMU2Hbh32rd	9632	13590	13590	1618385400000
19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	19098	3NK5s2iRHt9XiZe7h271u4WxPeRRMjNsnygvrEUgqdEa98zBxpi7	1406	1393	331	6301	12463	jwPBXpz9s7BnzC6L5fHPLv4hbr2ZspcvwKE5H5LGffSQVbjx3Z2	9633	13591	13591	1618385580000
19107	3NKW3Q5ErJJ4ac4HA8tmv5PrFUhz7XWQZr4Br7W43cVq1gAfYwnq	19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	1407	1395	331	6301	12463	jxNzVJdaiQNJSHEAqaU7tzXvCheRA13kVZCbksJoiYTuiHHWDRN	9638	13599	13599	1618387020000
19109	3NLL9D431egCTcNKCL8tSqKbXLWbt2WraiQ41XzDEFo3auJfeJSp	19108	3NL51H2ZPJUvuSFBaR56cEMqSt1ytiPpoHx7e6aQgEFNsVUPxSAn	1407	1395	331	6301	12463	jwEddnDSCNXXk7jMbJzN42VhUAuSHLZSQqJ9ZHiJAUyFBpfE1Bp	9639	13600	13600	1618387200000
19112	3NLAArgDQULWLQMDby3q1Tvwd5sT6q791H5QdEsxb6wCgMx8T8mS	19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	44	348	331	6301	12463	jw8LBdSskQpZWywMY3XtJbZ1kXScmzZkQW35wHgQJRGSpsJAAYP	9642	13603	13603	1618387740000
19114	3NLBknrus48wgn3qNimqGDPdBqTsnWstuKb8go7hdz3yKeHb2bc5	19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	1637	816	331	6301	12463	jwneCT4fB34456iPozxxSgLWaCmsxa3Eki5xD9as6RnD8wrSptv	9643	13604	13604	1618387920000
19117	3NLyTaq3uuretjUU2NpAJdQq3Ba8AnBBCwxzEUxs6mSNaii6ZZgn	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1546	1339	332	6301	12463	jwV7MM3bhW6CsMzhtqtXVi9yLPqKDavCUBRLLSbErdSvGg8oBTJ	9645	13607	13607	1618388460000
19119	3NKCkFP95Gvk6PATsn6fEsR3K1xm1prpveK9Bk8gtkiNdGvrvpZX	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	349	349	332	6301	12463	jw7FfsqNR5gBxUWiy69xv3Nr9dxjTFQGS2xVTxgYQP5tE6DJvpe	9645	13607	13607	1618388460000
19126	3NLkk3DBVwBA2KZq1rANbPDdtF2vwefXT3cB1Nv4vpX8uDwvYyX4	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1477	1350	332	6301	12463	jxRwm6KdatX2owB2Pom3oqHcFV1mAzNuakDphk43AAUk6LCrfbY	9648	13611	13611	1618389180000
19027	3NLZfPXhv9UgBqLsbZgypy9S69F7SgAs36fAZ1DEmv3h3HNHME5W	19026	3NLqoso28pDL2rCCdWAeFcbHMbzqxm62HXvZBduzru6H3SohjaQP	1406	1393	330	6301	12463	jxAiU3US3DTVWFicLnxKBp7j9DzzG3tvHLseujUgNbUC84v82rt	9593	13531	13531	1618374780000
19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	1406	1393	330	6301	12463	jxbTRMzFVZZKXaDQKrJJmvZFJfbvHCronWSaGWi99ZFG8DAzKPH	9596	13535	13535	1618375500000
19033	3NKwmom37gaA96BduZguYcdGTSAgBtShUdFMArF5NSoJNcaDsz7w	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1637	816	330	6301	12463	jwbxdNVJc62FqqRxMPLwFsCSHsfRV9gVZ5oaL2H8VHEyW7Lqqq3	9597	13536	13536	1618375680000
19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	19036	3NLaHWkXXEbHsnJeQEsvkhvAD9QhTjP8VqB1bDqSyKopdCBZaK9J	1553	776	330	6301	12463	jxe8fxanhuVQagj6cd8xTvSQfPBxUD5GNi3CgAGfWmk68tui9WN	9601	13540	13540	1618376400000
19043	3NLVSABFQtVoGiyfNG7EG8xAcXsE7cBQZWVhD3qPqZUi2Hys4LUg	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1623	829	330	6301	12463	jxYqV1wF5TH3GkvtP6gAuAPQFuuvDkTiZyavGRzp2PrCij1mS5d	9604	13546	13546	1618377480000
19046	3NLEapPmdMwmFNVUJtG2q2QZ4erpLoaBf4GrDmLbvpRuKgjkyTKb	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jxag41YbMeJHLikQAi8AFq4zRr9ibesqk4ASBQt9NwDZLQJtFcK	9606	13550	13550	1618378200000
19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	19047	3NLvQGKSpw7tao4d9AVoJtnatnUsxERWzkVbCetfd1PdUrtHkMjg	1407	1395	330	6301	12463	jwoa9WxibFDYt8vC2kNg9c9EXMibSPCTJG51JfXFoSQynUFUYfw	9607	13551	13551	1618378380000
19049	3NLr4TWRk1MQwpptcoH3xEVVUehfYoKvG4bMHqCdC2yQqPFShNjc	19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	1589	1286	330	6301	12463	jwWYDdrgNnmg6JqbgRUb8zvkNzGZ5GR9JoavcoUXLN6JQ6qcPEy	9608	13555	13555	1618379100000
19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	19049	3NLr4TWRk1MQwpptcoH3xEVVUehfYoKvG4bMHqCdC2yQqPFShNjc	1406	1393	330	6301	12463	jxoyz97BdLpsox3XSoqJTyx5K1QBChqRTCW76Pv1vyjheuLw2xC	9609	13556	13556	1618379280000
19055	3NL5uPETbfop6tsS1NKkTD92VxLrxRYjC6hw3vxjgT3SUdJhsMM9	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jxNtYBXJDhB3Mv1yFW3tQ7sp7JTHGMGPZ3TWTd5iZGTmqYu5sMk	9612	13564	13564	1618380720000
19057	3NKBjaZ4CeS9UESeuHYWYPNHVS193oQJB9xnuhWs886hzaPnic6T	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jwirNSLQvewt8a6DgtpayyhwBdSCajmdeQh2xRusKvDkL9g7A3b	9612	13564	13564	1618380720000
19060	3NLweScyeipRcjT9om6T8yVk7EEx4pHaARF1LLu7kkVWQQ9m4ojQ	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1623	839	330	6301	12463	jwRBSPhcj1nh99qRrysvhQKM7WGcaV3gbHDRuzUkFG7uZSLxHkJ	9612	13564	13564	1618380720000
19066	3NLxtq2WxAJYVg9cZLuFZNKUtZEJ2ziSTNb7b9QK5advR9BMEoAd	19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	1407	1395	330	6301	12463	jxAPUcspUv59qShZVnfeQKZivs1eW4vYAMkmTWHr6tDNSSJ6dqh	9616	13568	13568	1618381440000
19071	3NKnzbPCq1d4ZduBaTzqc6e7sZei2jfKewSLxhvcwztpKYifK6Lw	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jwApELFqLShiSyEnJoq4HLqUs1Z1i3SiH1RyYXpasrM7LpSb12h	9619	13571	13571	1618381980000
19075	3NLZsAkjSxkn2y2jNCWJgkLhCEnGNckSwYs5gbvdRDMnSmrwMWtM	19073	3NKQWbQri9jPnVUQjRW3zxSHzY1ohr5YpFiEM3aSQ8vX8oAiyKjS	1631	794	331	6301	12463	jy29YaSUNBLXZvxMXXjwL2vLjCTdhTYjBqpEGa3SSt2GZTqxfBW	9620	13572	13572	1618382160000
19078	3NL79EGNzEoipdWrR1qFR5ySYJMZzzkECG8h1wuUo925CJs7NqrE	19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	1601	1142	331	6301	12463	jwY3JiJHLWw8PMUJugkNE1c7zcAaDEoHxb4J8LCGiLEW7Bkn8W1	9622	13574	13574	1618382520000
19080	3NKyx6azRfnbKc9LZjGJMHCFMcvYKQfe7i7HyZF6SYhuTAmSMx9J	19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	1610	1068	331	6301	12463	jwmHkVMgcFmEGHfjGCJf2HHjZ2tu619zpHrHGkAwdpb4Wu64LRA	9624	13576	13576	1618382880000
19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	19082	3NKWYqEkQUAfkp8v35zVujkocvwn1KgVeszNksijakxDWT1xFvjc	662	662	331	6301	12463	jwHhYS3qZSGZrzFG9N854QxK6tAQA3TmSJxuJjfFhbDAKEFPmHh	9626	13579	13579	1618383420000
19086	3NK7aFe25j71QkoLomNKRtcnY4WFqaTJt4z616KC3WxfTBUSCiSF	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1585	1240	331	6301	12463	jxkGfw8srVvC2GrMnGpfTWrmSkWmMyvHs1ZX4JHE2auQFfuKR1G	9627	13582	13582	1618383960000
19096	3NKn4d1S7BaAe548hnyUtG14G5bUoryYrGJohVvsoHkyXVWBnHCW	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	563	1359	329	6301	12463	jwBTTT4i8iUfQ2VstfSFytLYU9t582usArCLT4g8NmAKxq3B5so	9565	13590	13590	1618385400000
19103	3NL2hYgP7BJEB5i277q4E9qr1YpJW63vDtaDN4mSSJPz5H27iDGo	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	340	443	331	6301	12463	jwPDvN9MRpdHffUeDjQHSvdcbpXmgqXd8QBhQ3brsPp3FPjKkZ4	9634	13593	13593	1618385940000
19105	3NLvEQaPAkZRtABsiZikNcFEahu7YGAKzRsHqCXbi2oZ2KCfbQZK	19104	3NKJVBNtfsa1eiidCB4icrAMmAUnZtyJ3BnfJV9BfkTiBNYtgqKC	1426	1238	331	6301	12463	jwx47RLw7Yci17vV1G3FpbRAhnwKHEPVEy51tKCYJ6Gt1ArCJmN	9636	13595	13595	1618386300000
19108	3NL51H2ZPJUvuSFBaR56cEMqSt1ytiPpoHx7e6aQgEFNsVUPxSAn	19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	1645	460	331	6301	12463	jx4Tzz68ToYMDoZNpJYxDkqqXuRgLTLfxDFzDj6pKwU1UBE2aQk	9638	13599	13599	1618387020000
19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	19114	3NLBknrus48wgn3qNimqGDPdBqTsnWstuKb8go7hdz3yKeHb2bc5	1403	824	332	6301	12463	jwc59Lm1KiAdvDEjExxzYkYMQQke6VdyfNtBw4jn4z8L6ZwDYw4	9644	13606	13606	1618388280000
19121	3NLAebd1kg4K6RTbb8nZaCvmNhpVR7AVoqKkcT3tmAUWdGogLTfS	18929	3NLrLjY9P4pXnHvQhLxB84uoTkLUpBAwtcgS5dqzaUrwuXBTUx4v	311	1307	328	6301	12463	jxsjHBoQoKSPZpcTxd8fhTwKQSNAf599BMDag4oHuBCe516dFmG	9549	13609	13609	1618388820000
19130	3NKhboPFnRFi6hseihfdDJf3wVd4deUtJSJqS9K476nKSvXbQJue	19023	3NLcCeSot7hFFRygRHxinfuq5ow262WkvTjsA1bFDVcTViLKemUV	1571	1089	330	6301	12463	jweEwoZi4CCF55YC8LVFm4xQBVqqmwqkAFkGUET78pE4VQSfCbM	9591	13613	13613	1618389540000
19137	3NKtcLx2NJ5p64WNgJwZnZiq77GLwwLTebxAvDWer4zAvcfXtCCp	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	298	1308	332	6301	12463	jwpGaDrzYM43vW2bQkfv5TAaBFNerYYKo81XtvLEWNqz83sJYN8	9654	13621	13621	1618390980000
19138	3NLRcwfrNmid9xfVNg3xY7Mgs8rbWRC9ztR3QgbkqmCZatQaaGCA	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	298	1308	332	6301	12463	jxEkFgX2o7N5e5gqh4qvwgWHx891eyL7cH2YFj1VojnfzGrWaXv	9654	13621	13621	1618390980000
19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	1403	823	332	6301	12463	jxH4wYWodCnqDGfNnEXznkuMDstBdiTGDVxrQ6KhJnNWVPWVJHM	9654	13621	13621	1618390980000
19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	700	840	332	6301	12463	jwrWUqgw969aZbiK62XakJKfjAFKNUCv6qdDT1ergQ9EeJhkrGa	9655	13622	13622	1618391160000
19141	3NLFpEiwduoK8ZsDJBxLtrQ5gd1qu3BZtXF2RYsENYrq24vnphTL	19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	364	364	332	6301	12463	jwXKekdMDPjV4Gkedyo4EqLTywMuuQZejtfpbGpSkjbGa6MgnuT	9655	13622	13622	1618391160000
19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	298	1182	332	6301	12463	jxq9ranZ2ac5Zj9iwzVQyXifBUkUYdU2sqFC818ZZLsuYtBvYpW	9656	13624	13624	1618391520000
19038	3NLAv83xf1ucxGWnErTQEhSaJRQGSP4WMkE1ETbapmdozGvkw6Ru	19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	457	457	330	6301	12463	jxXnnZgw3uyudsh67rjA4R2fdYYhK3kxf6Upwpk8GMFqjwCKNBJ	9602	13541	13541	1618376580000
19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	19039	3NK5xpze2Np2FbvubBxvzahwaxz5x2YzSLk2RQhF4XAzcG9DHxCj	1451	1166	330	6301	12463	jy143UnuQyHo8KZVCHh3pSLhp4qDsAZFEnH85JMrQr7NANa6gjR	9603	13542	13542	1618376760000
19041	3NL6tJUJF5ULaqkjWTkqusgH1DtnrUSRUnRPSFZkcKWL2AD57ek5	19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	1407	1395	330	6301	12463	jxFEE3jeyoZp4GnkzxSTTmGpqiowqUuK5opHmEJcn3gLBv4KeZZ	9596	13546	13546	1618377480000
19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	19042	3NLWwRGYpXfdktDYVeMiYKsM5sMFRZmxzampNcPsY7Hx8YMbsdoM	1481	790	330	6301	12463	jxVzgQ445CJ8gXZB5saKzgGErwQAqcbL9CEW9xGXFoV8dqPZ6y6	9605	13549	13549	1618378020000
19052	3NKZyNNDzCBtNgpTSAfGq5vUkVpCUMJKGEefR41ofCYypYJ7fu4y	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1406	1393	330	6301	12463	jxD5sk1FsKUiE7FDQu78YxszpykxTBgTRpw8Kfpv2134rBWcHD2	9610	13558	13558	1618379640000
19061	3NK8U1D8JHwYHP6XdLhLpKYMzezGaRGt7Nkz1UQ5m8qgn56xh1Bp	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1631	794	330	6301	12463	jwP9kmYU1Nk3fBZCk2M34DCohkPoFpniPgDrtCXA2hZ8o2tWa55	9612	13564	13564	1618380720000
19062	3NLwqAcfFVbhyXZt87VUj8SKPykLywqe853NvMvrt66YkmPpTfwh	19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	1609	1333	330	6301	12463	jwHqFWZpNjYf1Yh5xNzAC4ixURsb8iJ7KsDwP6kc9ay4zDJavrt	9613	13565	13565	1618380900000
19064	3NKvWf1WxY2LvdEfzZYj64HAYAu2rc1coh2qNYKpP9CjrgQ3N1Zc	19063	3NL59XsvU5YUf1dk3kyN8UkURjmobDjuDtt1RnhaKXM8aDoCHLiY	1549	1236	330	6301	12463	jxBJF4Vd6pS5KezFey7seksoRU8sBbx9JcZuXYETGBEzGCUUYB7	9614	13566	13566	1618381080000
19069	3NKjW41aJ9D59kxGCuy9bJyW9rjy5Z7HtFfycK31ZyegCrFKYbsJ	19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	1611	1341	330	6301	12463	jx2tQk4CK8gXAe1Dom97Tk9sohAXRDqgKvg4twHqeUgwH4h5Nfh	9617	13569	13569	1618381620000
19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	19075	3NLZsAkjSxkn2y2jNCWJgkLhCEnGNckSwYs5gbvdRDMnSmrwMWtM	1460	958	331	6301	12463	jxoTznR69YxiHqmjk4fAEiPFooZWgMFChYCtLowYPS6QLAVRWc6	9621	13573	13573	1618382340000
19084	3NKoCHPxrW852toBsrag4QDEoPXaRtkGsyR9YzyLA3e7KpF4VFUx	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1407	1395	331	6301	12463	jwKRtEgN6GHiX1R8CtKVQTMkxMLNat69ehWmbHhZzpsi71zowa6	9627	13582	13582	1618383960000
19089	3NLZAAZ5WQ21hj173NCv2spZa3BXerjLt8Ny8Fvq7g4Dv7ab5hBT	19088	3NKoZ1DszYqbsp7WKiWEJvAzALJ8w5Q71oK1XoiNwCsXBzebCD1T	1406	1393	331	6301	12463	jy1UrQM1n4PDEzipGWhYu7HrEgJF1bGc16r2GnfCdniNZzNiDPJ	9629	13586	13586	1618384680000
19092	3NK9J48QGYeqB3WdoaZte1hhcV7gQSbzeNjwpsEhTGJfV9AKwbiJ	19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	684	1352	331	6301	12463	jwtyx9A9uYysKNaD9ZePB8WNeGzaWFXHXNifMB7s2SLgsuW3D7C	9631	13589	13589	1618385220000
19094	3NLovoFMFxhGFDkGdPBfuBwwAhXBW5TExM2EZw3r3iK9i8BCmb72	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1671	1239	331	6301	12463	jwAx4pvKsTjRvnxVmQKTjQPDTK2maiJyaUkf3oxX5FuCX7eUv81	9632	13590	13590	1618385400000
19098	3NK5s2iRHt9XiZe7h271u4WxPeRRMjNsnygvrEUgqdEa98zBxpi7	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1406	1393	331	6301	12463	jxErkA1ASJpevapoTUtrAd5QZBbruqg8Xu7BJvoMaMbE2MRHvYi	9632	13590	13590	1618385400000
19101	3NKzKL2AsV5E92UU1shHtSMTaYmEKKQVp3SUjcMs8eKVJSB2EsFZ	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1402	870	331	6301	12463	jx6oUyQkSp4tY9RKfYpcEdVhJHPGU3rSXBGuhC7UrwFrZcCoib6	9634	13593	13593	1618385940000
19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	19105	3NLvEQaPAkZRtABsiZikNcFEahu7YGAKzRsHqCXbi2oZ2KCfbQZK	1590	1174	331	6301	12463	jwP4gmTC5hmbMx7mJ9KWdRVJqU57rKX2W1eEyA98yi2PdKpAnBt	9637	13597	13597	1618386660000
19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	19110	3NK7FxeAnpQUZMQKaAV2s4AT3NWEhwWvssq5AtjEoEzfCHpPp5nz	1581	778	331	6301	12463	jxFBL9FjEhK7CzGftgqPMk7mmFEr4o1AFjQkPkckEKHTxqaJu3t	9641	13602	13602	1618387560000
19115	3NKKurD97kPiiPPUEHnUuY8ULcbkrp6CUiERESJUU8DPkskG2JhD	19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	1578	930	331	6301	12463	jwoABWqiqNnpbjeieV3G4BduWe1HUhk5rtahUQ7KKhM5UawP8Dt	9643	13604	13604	1618387920000
19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	1407	1395	332	6301	12463	jxr7B73U2n5HwcN7hdgxP7GXqVe6Znf3UUhFNyRzbg5y62HFvdo	9646	13609	13609	1618388820000
19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	1507	1280	332	6301	12463	jwLUXYnir8Tb8QC4krvxsAouAUEfbAcQggKTmtDxRYgL2CfArGF	9647	13610	13610	1618389000000
19131	3NKTKhqtEa6iofhRGHqcadZ77pP8ionrixwuwVCRPdGuuRnB624B	19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	1560	264	332	6301	12463	jwgHoqh5VRdruaGB3jG5dfhjyKsnRgUPshSvkKoKFDBSHg2jo6K	9649	13613	13613	1618389540000
19134	3NLf7d5TL1EjQ5UDvX8zoPSc4poq9SgMJWQRYeUXdzX2yEe1i2Fq	19133	3NKGgLDuFGBiZVMXAeuJ6GPf7LRrJydp3m9qbmCQovfaPsymKj8d	1406	1393	332	6301	12463	jwjKU7MWHLhW5puZUU5X45wp6MsYBRtnvmLfrmpawvv3iVTo15L	9651	13618	13618	1618390440000
19148	3NK911pKBnBnPoYBSdNQpGJaJkoMoG2BA7UMfXPTgQPCxd4Mi97v	19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	1462	471	332	6301	12463	jxRmQgACfUHYuCjT9TVAMDc3t2fLw4qE8ZD7WpaCBR4cHNYSwxg	9660	13628	13628	1618392240000
19152	3NKaQ3gYXVSPWGZwyRyKUaxN8pvg2xRkURuGfiXWybX88vsFKdQV	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1507	1280	332	6301	12463	jwvsRqVuTWngErj6ZvVuZaYnNsozPwknnUuGoJ4zNLvX4iqvgq5	9662	13634	13634	1618393320000
19155	3NKPDTshBTXyS7N1HA4u12ATmb1XhmYDTZWiWWTyut4w4jvuHtRb	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1419	814	332	6301	12463	jx9GxfgXgkDfTUGW5FYri3ck8aNVLC2hnkCkujrPfdFSPhyoGD7	9662	13634	13634	1618393320000
19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	19152	3NKaQ3gYXVSPWGZwyRyKUaxN8pvg2xRkURuGfiXWybX88vsFKdQV	1406	1393	333	6301	12463	jwWYXSeBFDXTZYxyVEsJdjrVoXKJ4m9hkb7kvSzcH4KXiMMyFb2	9663	13635	13635	1618393500000
19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1405	873	333	6301	12463	jwMmY7x6ib52RmHSphG9MuG1Uw7PMqkxYNDBeB5V5rF5XqRXAmr	9667	13640	13640	1618394400000
19165	3NKEsxJoo9tbk4ZsbHapCB7aNWdtiWWwNf169tAKTze3EaEuS6Fz	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1631	794	333	6301	12463	jxKmJBxZ1HWpoPp9nM6FRvxPaBr5nwutPunhPP25AExJRXB4WYe	9667	13640	13640	1618394400000
19168	3NL9u19ggHVQAHEJAdDQhcGkgi89DfTc4BTQTcGPs2a9MtiiHNVv	19167	3NLBHJX4d93GigTMGMXCba7jtc48ucE9pEaeVAqunaPj4uCMsSBT	1406	1393	333	6301	12463	jxXNJx9sEh8AAGNQoT663dtAztbuRe2Wd7yHrz5GiuqbBq1xmeC	9669	13644	13644	1618395120000
19171	3NLR6aTTuayGmgaaraufJoaEnoTKVqnGQdmRTpacBxU4PYa5d4qz	19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	1397	828	333	6301	12463	jwZaEq65hiJuA2uLXk1xRp717hpuDYmg1UveQ525VTKs8pXQdkk	9671	13646	13646	1618395480000
19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	1647	1302	333	6301	12463	jxRxf6PzYHumBZFZGvbeAsFGGJmDQ7bEDzchFDzSeoDWHBL4F1H	9674	13651	13651	1618396380000
19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	19089	3NLZAAZ5WQ21hj173NCv2spZa3BXerjLt8Ny8Fvq7g4Dv7ab5hBT	1497	654	331	6301	12463	jwDVeLbvPc8HMaKdx2xGuTCXrxtEepnRghKmZPzGNEPZdDW1mUf	9630	13588	13588	1618385040000
19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	1619	909	331	6301	12463	jwLmkxbEC12mHX93ufRR6tGDTKQ8JckSh6YVNy2poN1TZHA1oTL	9631	13589	13589	1618385220000
19097	3NLk1jnhx1f6bUYxgRcS3seRLAFHonL6r21ihijv3MHXEw9ZLk26	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1578	1050	331	6301	12463	jxpHxPhCg6Ziuaru9kTeVVow64gyMb8zRfMuQ3pwvNKdfdd6nni	9632	13590	13590	1618385400000
19100	3NLg7RQaZFa3hhaC4irotPtkGSBJ89hS4WRQ3vb36VZWaEzyeMXK	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1407	1395	331	6301	12463	jw9aufgybBtwP4tfJqSFoJpXqX7XMyiUMp3mQ7mGyM51X56Hxj3	9634	13593	13593	1618385940000
19102	3NKDn7ym7CHCD96EERqUk14w9oQNDmvDp6ymZ7nEgaEPjQiqBbun	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1406	1393	331	6301	12463	jwfK2crzA89jd3SNafz8iucZdJbsnpp4LFX3jaNGdnvCLsAdHBz	9634	13593	13593	1618385940000
19104	3NKJVBNtfsa1eiidCB4icrAMmAUnZtyJ3BnfJV9BfkTiBNYtgqKC	19102	3NKDn7ym7CHCD96EERqUk14w9oQNDmvDp6ymZ7nEgaEPjQiqBbun	1457	1391	331	6301	12463	jxsFxe3ZftuMFuSFqqk3JedWKFvgqPtgyV8zwquAGSPCaCBCLQA	9635	13594	13594	1618386120000
19110	3NK7FxeAnpQUZMQKaAV2s4AT3NWEhwWvssq5AtjEoEzfCHpPp5nz	19109	3NLL9D431egCTcNKCL8tSqKbXLWbt2WraiQ41XzDEFo3auJfeJSp	171	1374	331	6301	12463	jxqKwje21RPgHfZeVq9VJFqk9WBQPKQKjA7PTRLgC24YjgSodaC	9640	13601	13601	1618387380000
19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	1673	1002	331	6301	12463	jwnwFdbP28dRwFpjxGNdYyRq3pKpY5EGCKcaJ1iTcf2D1SEurZR	9642	13603	13603	1618387740000
19118	3NL76h69KB49h6Aie4JnKYVqhzwujr5gmoVDy5XHHUFDaUKuNF6j	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1670	916	332	6301	12463	jwDG3tkMFtzJJfCtAfn2EQSFSjoMactf9MMqtL6Sb96m57X92RQ	9645	13607	13607	1618388460000
19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1541	1298	332	6301	12463	jwoMa4MG1ZGiYHpSgfHK4b1qzNuvvuLiqPwm1Rn7r7t9M6hTHv1	9645	13607	13607	1618388460000
19123	3NKLANg6JDSHS7M7wMned5hs6F5x8bHwN8d7uYZfh1xbdHBXM4dP	19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	311	1307	332	6301	12463	jwoR3GBEauqntoG3dgrrioTbmnZ2GYscYCRRYTnUuvgL1FWkaTK	9646	13609	13609	1618388820000
19125	3NLiC4s15FeQHYCPPUb3T1qTGqpzmZvLCoSS2aAg8ZKZEn88tsc2	19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	1403	823	332	6301	12463	jxCcbVSYLhmk7E3Xt7uQiVV1ofEK2izVKgmKAVh2iUuE7rihd92	9647	13610	13610	1618389000000
19127	3NKCDrvgnPKCKRnXVMLg5zpfSKghtJixqtUeckpzx5rvgzDBE5Gn	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1474	1329	332	6301	12463	jwxtBY8jjVXFpzaiyaxosYv4et74osmM1KQzx5UsGR8C29mV59P	9648	13611	13611	1618389180000
19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1474	1329	332	6301	12463	jxo1pgTrLgKAbMGvSDAK4RdMzrzqTPsAr43AnCxWxLMfU7vKsNN	9648	13611	13611	1618389180000
19132	3NLXjpsWasd75LcjnjohGVZPvJ1F5Msq5mYBKfPehrnz7cByuAwg	19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	1402	874	332	6301	12463	jwMdJ3sJaQLS3eiZijy19WKpwQZuSBAdSge4KA37xiBRn24cd6k	9649	13613	13613	1618389540000
19135	3NKcWoeXK9JfgZroYFP5FSEM7EPTiq4MgNm5L5gm7Q6k7zWkkt6C	19134	3NLf7d5TL1EjQ5UDvX8zoPSc4poq9SgMJWQRYeUXdzX2yEe1i2Fq	43	1064	332	6301	12463	jxKBkafymJB3iFVbKn6MQfhzzeooTSup8rLxkFoUBCQP7foX9Vd	9652	13619	13619	1618390620000
19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	19135	3NKcWoeXK9JfgZroYFP5FSEM7EPTiq4MgNm5L5gm7Q6k7zWkkt6C	1631	794	332	6301	12463	jx1R8cPFMKXBEz58RUHZigXjKnCKqY6Ex7Ccm2tp8ahF9LzXCer	9653	13620	13620	1618390800000
19144	3NK4a5vWTUDmFMKgVtJBTSzFAzPLBYGKjkHH1MHBgJ8g6BEFiHUd	19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	632	1382	332	6301	12463	jwzVe6zM24X5MhzfTRXwTw4B9xZ6QECR52udh6EMskhwFMnraqK	9657	13625	13625	1618391700000
19146	3NLgedAYKTxQP5BoeZ82L1hanZ4VdtR5h7RuYzgnzKabn4FaqmqZ	19145	3NKadmh7VsCGahzWCSzsa7MoHjTKz5mXfFksWr3RrKaA6TbUy9on	1610	1314	332	6301	12463	jxof42AdTjbGcEMUCYfmxBn4bhZwhHf7hevgzazjymsy2GcBWcZ	9658	13626	13626	1618391880000
19149	3NK8rHuDRP4JDzYryDVXTDUrQxGgmGdmWHEMq5iTdr41Z6sCzSDG	19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	1610	1314	332	6301	12463	jxuNt6eupRztnMrQ733v4mf6fLH8bxjzUhA8CsfvtYu4H7ajxzT	9660	13628	13628	1618392240000
19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	19149	3NK8rHuDRP4JDzYryDVXTDUrQxGgmGdmWHEMq5iTdr41Z6sCzSDG	1508	1261	332	6301	12463	jxuvTLJ8uTNVUbRYHwttbLgTQBTuuZ4dPGZuyrZUmwUWZNC2rZh	9661	13633	13633	1618393140000
19153	3NLELvQXRJJMEMR9nnk24SMGEaB8xpz4fENtGxmfRcHGBQgCadP7	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1444	1255	332	6301	12463	jxNVFvxPP8RmHVeEL4YX4L7bJ13YrgCHfUHrnQSyGS9anDGBcqf	9662	13634	13634	1618393320000
19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	19157	3NKR2bnayEeRxSBGTT1sB1fKo8R9XerumrxJbpzDBhxovraeKr9p	1623	830	333	6301	12463	jxWtCx1F9zSBZjz1cFYJR3TDf5Syr7yE3mZSNrr342ACo7ckgjY	9665	13637	13637	1618393860000
19166	3NLWSfzjKZ61RYKpDKVszGfFLrjkceeJDUsgRvpVjVHJipssyvRD	19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	1529	1070	333	6301	12463	jwvcAfEPT2BpjxRfGM5BvdU52XbDB9gFmkwQysVUmRi484MRDJW	9668	13642	13642	1618394760000
19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	19168	3NL9u19ggHVQAHEJAdDQhcGkgi89DfTc4BTQTcGPs2a9MtiiHNVv	1675	976	333	6301	12463	jxxeSYGASXJaSNNxuHC1yPdtfos7hRW9YnTFp8XWtT6vxRCZrKb	9670	13645	13645	1618395300000
19177	3NKi8edBU9P9z1x8ejFs4g7o3VXjWjRCXHE4WX8zxaAks6kdYuwx	19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	42	1361	333	6301	12463	jxpexgw92TKvyv6xNgXyrdfEgKjTeo8mVFG7vQrwzvSi1KEcKYU	9676	13653	13653	1618396740000
19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	1637	816	333	6301	12463	jxdomKKfH9FpnVduWNnjUAH5X53ujQ5eQ8xG8D1YV4Ycy82oEQG	9677	13654	13654	1618396920000
19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	1407	1395	333	6301	12463	jy2mpqhHcUHWRPhic2Rf2vitWy8eGma7mwW7xCpet4xjYcJnTFd	9680	13658	13658	1618397640000
19189	3NKg5bYgP2hiFCBVj4D38ZU8zeqAjG5BLSUccUhTxrZBC7cR5Hub	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1406	1393	334	6301	12463	jxRfUhMKMGSTT2ih7ZALJKfzPQGckfC8cXJWMZkUh4ZJwCYsT2v	9681	13659	13659	1618397820000
19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	1474	1083	334	6301	12463	jwDWHr5YWvtLLNStfFfcdxVnzqC8d4gkAQGqP9FaVgJXoFhqwEM	9683	13662	13662	1618398360000
19194	3NLaa95kEFZoZgwXPfgZYmRnXMxa5heqPTLFtgFrPPh8TurvhdKj	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1440	1011	334	6301	12463	jwvZ3HR6AKUoiaU8cYXxwuzuhZGVgZondKStaiXJ3UQedLYEjfT	9684	13663	13663	1618398540000
19199	3NLFrFZwryRcRKwoCtdDofMmku6ZbpsS2CfhQNz11GehPKC3eTdb	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	1406	1393	334	6301	12463	jwF1yMpoMAtZysU66xQiuMzTunV3NBDgv5CG67byWvf2QuuQfKD	9686	13666	13666	1618399080000
19128	3NLWmzrShXY1SJnjrhfmJXJtkxRQeEC1dwfPhxS22ak6Gv2BqgpZ	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1590	1054	332	6301	12463	jwrpgBLKVuwFsXzXJ47jDdoBwJ4Lvb3gXip8KYS9HjJFo2mRu96	9648	13611	13611	1618389180000
19133	3NKGgLDuFGBiZVMXAeuJ6GPf7LRrJydp3m9qbmCQovfaPsymKj8d	19131	3NKTKhqtEa6iofhRGHqcadZ77pP8ionrixwuwVCRPdGuuRnB624B	1549	1116	332	6301	12463	jxVS2idCMBZVTdtNo7uZ4y91iQUe4FhFoVuq8SBmJuvcgL9BC4R	9650	13615	13615	1618389900000
19151	3NKooPivUXcKRXZij9MnkfFGqsXy5fmggRWGyJwGRzv3rLYgAct5	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1444	1255	332	6301	12463	jxNVFvxPP8RmHVeEL4YX4L7bJ13YrgCHfUHrnQSyGS9anDGBcqf	9662	13634	13634	1618393320000
19158	3NKVHQ5V8GpVz1sFro4Yu2CfoDaQDA6axDRC3pCHxx6TWudDeLCP	19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	302	302	333	6301	12463	jxpyyiMUvXhSx5fxcDGxJg6PzFg5jtXoPnKw6XdvtnB3muNgp1Z	9664	13636	13636	1618393680000
19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	1668	1370	333	6301	12463	jxnna2UeZHweEbbe5PoKG5YRUrCnzv1Lf3uL3f7JCfxwEAciPxA	9666	13639	13639	1618394220000
19163	3NLyAmtrQSVsYQBhT9Vx8GKfKFVHeDWQ2PRW91rKHwCHxAKaxQ6C	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1564	1092	333	6301	12463	jx7PFQBRdBqTZHyzMUHtgjb7bwJMwxt5NP1e12Sbu6fyV9HH8Py	9667	13640	13640	1618394400000
19167	3NLBHJX4d93GigTMGMXCba7jtc48ucE9pEaeVAqunaPj4uCMsSBT	19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	1403	824	333	6301	12463	jwNbdxXt9gRZMx5GBFM7hfrA1c9QPnX9F5PmgdXvbKSveBfURTQ	9668	13642	13642	1618394760000
19170	3NLL1f5a33Tpugkao3yH8hDHurV5RWciwTrtyo3Q1ZM9Wsujc8w5	19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	1447	1345	333	6301	12463	jxfHST2oXAhNqLpEUXCGmuE5sSQc6LbjmG2NUtAyHB711JTUvKU	9671	13646	13646	1618395480000
19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	19172	3NK776JeJoXyWjGc9W5sCYSNuJhfvdiq22sw1jcDzK62jW2P4Ygz	1627	1385	333	6301	12463	jxNgTgh5AygJk7Uv8tFbkEdUrkdw3ReKAhQiLPmBmPUvsX5jn3U	9673	13650	13650	1618396200000
19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	1673	1368	333	6301	12463	jx532ioMPs2xXSB2cE3mPXRvE8uJiD825zx8ZTYgmYBCSEbeH59	9675	13652	13652	1618396560000
19183	3NLqkHHr4zidEWrB5qSCqbz5ApU1oKUoxd94As36DXyFtZxj2fvD	19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	1560	1291	333	6301	12463	jxCYmfUjVxv5LqWM9naroBL461wGGPd9aRqUxEZzFJYQCEXNjEm	9678	13655	13655	1618397100000
19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	1407	1395	334	6301	12463	jxWu7MgfMPoWg2UM6kRHhUbzY8mvHdY9cr5kMP1pxqyPFj1sP5R	9686	13666	13666	1618399080000
19208	3NKug4XfWo1XrYzhhjDgEeQ3sbXXGm2JAQAB4hooUvoUYdbTgLy8	19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	1407	1395	334	6301	12463	jx91WzFDfY2aPduws53jJKLGTwAnGBvXG2EYChtxwht8eSExFy5	9691	13677	13677	1618401060000
19210	3NKfLw5Gx2wYq5grz6iBpCADJaG4TkRkHVtgAFrvWfa4nFReNKS9	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	448	1305	334	6301	12463	jwptAoDKyFhP9harf853DvLTNh7B3wi4xgouWVKimpdPvuezgrf	9692	13678	13678	1618401240000
19214	3NKKKVXgNAiTRzL6YRQqZBcDuzUvNfvKEPr5JsXK7ziNuZmsAvz5	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1489	1014	334	6301	12463	jx1kPqMsBjzw6gsyoUL8UUDXDFNqGvcEpwGKHpTZLKowwwuj52E	9694	13685	13685	1618402500000
19217	3NKMpD2A4PXkVvnYKF8VcJWX6ZGsLuFsBBoiPAqdafGH1UB5rLQ6	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	1407	1395	334	6301	12463	jxMvJEkRBChc2MW7KYgTiTHqxVkxzCwoNY4anFBjBpDABfpjFKs	9695	13688	13688	1618403040000
19218	3NL5MPB45BEBm64QfEAcmS4Bc6gMquXKutKNiLPW9bzbNho25zkP	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	1536	1067	334	6301	12463	jxvZ4DExmgfNFeMgZJHDLGrBGV5neqHt5jgkiBjTLn3SPSU9WJs	9695	13688	13688	1618403040000
19222	3NLdSWLsWTuxisyu5uwARZzGs57U7JcMKzsK6N4j5zAxPTV6tMGF	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	335	6301	12463	jwNxPfVzX8wiAmJMp5x5F6vdx5V9KvH9xXw8zZ7vPJpFZG54ap8	9696	13690	13690	1618403400000
19225	3NKEGzWgkQvsqJxkPM4bfTwzft32aw3V2obFe4poJRkH4BzBKJTR	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jxBvqfu6rXeFSBwWCjb4f5Qv2Dj3m3iByWa3trRN7QXDAQSm1Jm	9697	13691	13691	1618403580000
19228	3NL1rUwpU9UGYYfmEKRbH3mn945R2TdwW9z5bKS8iEdNbiZRXAJ5	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	58	1035	335	6301	12463	jwDoA3uYdNrZm3uSdvsw9eT2JDMxV5LNfk3KCd4HsDU8LFg6Mai	9697	13691	13691	1618403580000
19230	3NKVjcWz9bfDyXa2wL7eRPAo1AZz2QFtkpTeGm9554H54RHQrHLF	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jwJk4YDLMoGvDUJNSMo2kUHoxp8mxawHdNn6Vmom1BVbPHPuqva	9697	13691	13691	1618403580000
19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1403	824	335	6301	12463	jwa1B3G2PXZ5MrnF7y2V8kac23Fojidm22HaxVLhVbCLw8GB6c6	9697	13691	13691	1618403580000
19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1422	1091	335	6301	12463	jwcjAJSpMKFeicVNnrz2tXmL7xX9BnkYuDivAkCN2susPv1TjK2	9699	13693	13693	1618403940000
19239	3NLe2zyiQcYvNwbfTAtosDPGiQMkRcciX3Dug27HVz9QaZsmLdT7	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1403	824	335	6301	12463	jwRtMpHLoYQVoJ4e2wsJka17WFgZtgGo4AyDbk2DVxCMNxc2iEM	9700	13694	13694	1618404120000
19244	3NLSJboDpJFqUgAF4VwCqeeqfPLD7ViiCkPi35kYcc39CvhGkBEZ	19243	3NKUAH4acNQuj21sZst2nvXFDirVB6dLBECz9XFE7o9zFR6rAj5z	1406	1393	335	6301	12463	jwfzF78JwrwpzDiDPVKJnhc2oLcUcuYwHdpPRU1s1c4oSp5Xvxs	9702	13697	13697	1618404660000
19247	3NKwEGn6GfKf6kyjz1u4qoyuJhzRJouX2y4gHCPR2nVLy2EKHvDv	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	1458	1197	335	6301	12463	jwDb3Dkjo3GVFB37KUWPpZXmi7dw4BSb2zYKHtkpnzu2F3Jmns7	9704	13699	13699	1618405020000
19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	19247	3NKwEGn6GfKf6kyjz1u4qoyuJhzRJouX2y4gHCPR2nVLy2EKHvDv	1477	1104	335	6301	12463	jwBi2CAdiFqFsrPD61koqrjoyHBUg3PzzcBSkNkzLMsai2GvkWo	9705	13701	13701	1618405380000
19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	1673	1368	335	6301	12463	jxMGH9D2QR3L4WgJ21SyVs1ZDHUrzwTYC1xRPXAZPjGGiguX9Gc	9708	13705	13705	1618406100000
19261	3NKCfcNsckHK7sGxshMAcuAPXC8cxBP5kWHdUcNRCLGfC39Xk4hF	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1406	1393	335	6301	12463	jx4WmkoUpiaJEqSrouCzFSpmJeJgAPDDpN5EwkDAzh8nxoBoEcP	9709	13708	13708	1618406640000
19263	3NKbnk9Pu9RkmyEKqFq1XPopZLRapn7mD7k8tULT9SdQoxAQHPbo	19262	3NKZEmx2FtTBTz2oh3Y7ywgGKUNW5256tLZuaCHjAvhA3u5535CA	1458	957	335	6301	12463	jwCDuVUawgc6vbs5cRAcqQavVuGCR1SeCRJTRFCsBNuGB7HYAC9	9711	13710	13710	1618407000000
19266	3NKpKugHZfVLyxgNSX7c75t7taFftZDbfPdK9HAA2cg5zwoqAm5Q	19257	3NLpS5JEZ2vBBst8P1SjvUy4TV6d4cRNRG5vP7Uhwg47hjuFBTFy	1577	1327	335	6301	12463	jx6m12RTpYhCKw7DJDD6i6QEuRnjBTpUDxsiMk1J1k4dxvSbD7q	9710	13713	13713	1618407540000
19269	3NKV9iP6b8ab6fsSA3YH98GCfPgEYJg1AHfT8rQJ2GYXRQFdNaVy	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000
19143	3NKMqXgNkKQP5s5PZBpjBgG3qUe8KZ9gYocqywg3Pfonz3ZVfgst	19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	298	1182	332	6301	12463	jwS7cE1Na1NVE35YLbjNKpNAMjPAxJBVJLA5Uo7BUfdznouQCjs	9656	13624	13624	1618391520000
19145	3NKadmh7VsCGahzWCSzsa7MoHjTKz5mXfFksWr3RrKaA6TbUy9on	19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	1403	824	332	6301	12463	jxLPn5pVD5CxSPQQFQLcdRv8DGfvrxKrVmej9tidbexhPEsuH98	9657	13625	13625	1618391700000
19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	19146	3NLgedAYKTxQP5BoeZ82L1hanZ4VdtR5h7RuYzgnzKabn4FaqmqZ	1407	1395	332	6301	12463	jxhUSi5wujX3BwhMZ3PHmv1BHnxDge8bUJqL3Qrz5H5pCGFwseY	9659	13627	13627	1618392060000
19154	3NK7QFAUtXCVZwKZcjhzJBfUc5M2y99J2uyU3wzxsXChwhr17TBx	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1419	814	332	6301	12463	jx9GxfgXgkDfTUGW5FYri3ck8aNVLC2hnkCkujrPfdFSPhyoGD7	9662	13634	13634	1618393320000
19157	3NKR2bnayEeRxSBGTT1sB1fKo8R9XerumrxJbpzDBhxovraeKr9p	19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	1581	777	333	6301	12463	jxHonBwkHhUTmB5crtjHzCMVdZpd96ZSSmDfpsCDH39qTYvo9fF	9664	13636	13636	1618393680000
19160	3NL8HiWyk58T377nY2DLjmze9WYS6sf8W1c1Qoxc4RG8cRHpAr3A	19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	1668	1370	333	6301	12463	jwJ9hyN2JXAZM1cyq1oP9aozqP1gigcjAX66qdgD5JzSK6Jv74s	9666	13639	13639	1618394220000
19162	3NKWjumEmXun4ESnTyBscZcdDLpPpDmsBrMy5C3TtajwCc3HEP1G	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1407	1395	333	6301	12463	jx28LuSAZk8RQUAjY8Wqz4imLjLSVwaYGWUyGsEDzH2pDiFwTYw	9667	13640	13640	1618394400000
19172	3NK776JeJoXyWjGc9W5sCYSNuJhfvdiq22sw1jcDzK62jW2P4Ygz	19171	3NLR6aTTuayGmgaaraufJoaEnoTKVqnGQdmRTpacBxU4PYa5d4qz	1642	1121	333	6301	12463	jwub2pKjg1oyWR7qb8imd9YukKvwJtxrTGMsKxPTwhiFfwo6tL9	9672	13647	13647	1618395660000
19175	3NK8hMkcw6pbQcoAqEyXQVC7t6zZADB35LQicGBYreP8ZaaCzWsN	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	448	1305	333	6301	12463	jxFVmikH6AS6JWR5gdvrpsD6wApiykX6uBUEDfPQyviwMtG3dK2	9675	13652	13652	1618396560000
19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	1673	1122	333	6301	12463	jxhrrfCB9Gwvz9hGUeZm3NLqy8dQtcTP5iweGx53mX6f8HFH3Dq	9676	13653	13653	1618396740000
19180	3NL4K1ik7zjxF73rdmD8Z2y5hycTVt61M6465rLaZGSeJivsb7w6	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1646	1228	330	6301	12463	jwDe1wDvuHGkH9utpxo4hvMwXWuaqCGdgJie8AwVAASuc9njv1m	9610	13654	13654	1618396920000
19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	1509	1320	333	6301	12463	jwmz6c45GeFtSsNL7PFTUeT9HSyk7uEMZdJ2jmufbDsXT7LMRCb	9678	13655	13655	1618397100000
19184	3NKyfqZrNASVQZnbxcVkXLX6Ya9UryisoZDTwopEnUdwhyLazbhg	19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	1607	1348	333	6301	12463	jxMjSTNEMMkLocDWHrqGFTfgey9nQpDY7JQQ8fd21NPCZKg1KKh	9679	13656	13656	1618397280000
19187	3NLAKWiKgJGJNYGwLWeZvJR8tuqiWCUoCVHf9D7b6ZVbTfk7qiE3	19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	1403	824	333	6301	12463	jxdGr6o1NE4yH2V97Bf11HtekkkNphpt1kaits3PvcLPkbDjJ1h	9680	13658	13658	1618397640000
19192	3NK4epemYzLc2TFK72KPjCi7soWPFZ1DgTxBwz9TnUrSmSxKhnGo	19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	1474	1083	334	6301	12463	jxnfge9SvT1kJTwgWcJYNbjTxjHY4Jg6qRgZickgH993ira253B	9683	13662	13662	1618398360000
19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	19195	3NK69qA47SDJWLYSTZB2kyZ9kyuqZWP4WTYGUvh8pMYzZimYpY79	1407	1395	334	6301	12463	jwur6rbgeLBSrZE6Y6PLzd9JggaPpb4cb2Yz2ryvJZS1cVxZ4dd	9685	13664	13664	1618398720000
19200	3NKP7ErPWjB1j2CeJdypoZackT9B2X4HJR1eT5T5fsyUYN2tJP9E	18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	369	1066	326	6301	12463	jxwwbHhy59TTCokcP1V3QG4DBkUssUj1Fw4fHSUxuvNCimd1673	9473	13666	13666	1618399080000
19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	1607	271	334	6301	12463	jxwbodGPLm5ydPmEfc3BTTBGuxbLwFEiTkRcgpWwJumBp9bjXuc	9687	13668	13668	1618399440000
19204	3NLLKnuBTeNW9FVqgHxiKu9n4Mpmnrkz3BXVQ89VuRcrsVtYgDNK	19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	1455	1206	334	6301	12463	jxseDRTv3aKWjKww8z9RJ3tqBzQ1LHX4yzkwCzQECuWnPTbPeTp	9688	13670	13670	1618399800000
19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	19204	3NLLKnuBTeNW9FVqgHxiKu9n4Mpmnrkz3BXVQ89VuRcrsVtYgDNK	1587	991	334	6301	12463	jx5zAUvBwoFoghrTuQ1qYJCitGdTTvtJgvRcRPcp4Szw3vvT21S	9689	13675	13675	1618400700000
19221	3NKN6ZTKvU2x1G7difo5Aj8MP5qZEX5X1aByHrpm9KJNd4Fkeyo8	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	334	6301	12463	jwDik6kxX6xETvJZJFuPLDg51BvGRH2q7GbbNX8TmbsPzdFsoVm	9696	13690	13690	1618403400000
19224	3NLHcwFWcJanq4es2nf6NG2Qcp3eYWUMqGgrYAYNxYicwk3HBVob	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	44	1325	333	6301	12463	jxSGFmp2rEeEH1jXZ7Q7ujJSSsfox8YhqtE1PfAjRWYK2S6JVgr	9675	13691	13691	1618403580000
19227	3NKQrtJTkg4UN4Vk3dcw7M5noMFGVyYkLeNjFWqGwV2p5ovaB7px	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1546	1093	335	6301	12463	jwo6agMcLXkZMP53pz8AUtJBcF5ZJYKqoq1LqJXbKQeP5B5kNhg	9697	13691	13691	1618403580000
19229	3NLg6RL9MmYWyxbpJH3mWrXYfvLqaz27fLXDt9L5jk79yhPLZbER	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	44	1325	335	6301	12463	jwVymigzAN6LN2kfQNhawXRXSeN1T4ZbQMwVxqQT2zVTNeFrbK8	9697	13691	13691	1618403580000
19242	3NLTnKsVUt1pidBEKjaBRrb5BR9VqGjLwyYkFVjK8q4B9z9DATeN	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1406	1393	335	6301	12463	jwXnZF3EGDD53P3Kx95VpTb7qwwUQVz6PbMttHeNx72i9fZGNFJ	9700	13694	13694	1618404120000
19243	3NKUAH4acNQuj21sZst2nvXFDirVB6dLBECz9XFE7o9zFR6rAj5z	19242	3NLTnKsVUt1pidBEKjaBRrb5BR9VqGjLwyYkFVjK8q4B9z9DATeN	1406	1393	335	6301	12463	jwiUt2LErtXo7arvjpCkmCDPSp9FxAyxByUxRf4zm1wFJ5rwe3w	9701	13695	13695	1618404300000
19246	3NLvjs5YTDY2EoGYJMZTEj5pKpbBpAAm84rvE7JhCyExgBMBFedh	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	632	1136	335	6301	12463	jwRFfmsAFwtXm8NUgLt1mCNSKAjFsUwndWX51HzEAgymYR5KXMN	9704	13699	13699	1618405020000
19251	3NKN6avnh3KPYB4SaHuTxYoneCixzdTKKo5pH3Mt4V8Nkc8qWFud	19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	1406	1393	335	6301	12463	jxn4mebtzAk2UVoXwnavKLQKBtLdWt5zGZosAgf3QriSWcoPEKP	9706	13702	13702	1618405560000
19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	1631	794	335	6301	12463	jx4MgNPmPkakKGTi1h284CXdmEmQDaAhixERSjCY46PLNuih9uX	9707	13703	13703	1618405740000
19256	3NLm3oNU4VMu6xrmi5958tb3dmeBimKTT2saKMjDGTQ1nMGKTLvS	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1461	1271	330	6301	12463	jxMENyhNtpRFAwB9FT34x5TLp4tBJzYatnruHUoGVWcY2CGiF7h	9604	13707	13707	1618406460000
19259	3NKRBwYY6Sdqdh3HGLShZuuq7srnv1EGMsstd5fKfxecgW96XfTy	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1419	814	335	6301	12463	jwDNBFmqoq4oGCXpZT3c4iWW61j8fWCFse4zdze22ud4vSeKGdP	9709	13708	13708	1618406640000
19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	19264	3NLVjJ5g6QwKZ1WRMiB2UX3ft2eMsuyyYhyPeLHz4jfJBJdFfEAU	1637	816	335	6301	12463	jwgiUyJbpbEzmn5smUxsQLNF7spkAZsDBFcSJX62sTyFPhFNPBx	9713	13712	13712	1618407360000
19181	3NKWXXzoJbcEXWXZHVerLr47SbRzrWAmsL3i38jfTGGBAuXWGusm	19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	1646	1228	333	6301	12463	jwuprsWJb5mYT6qkm5J2sUvHxVXiDHYyF9iRxYzcjAHvxVTTATH	9677	13654	13654	1618396920000
19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	1607	1348	333	6301	12463	jwDgmeL3BHnqjSzc1BVEzsWzBJq3CRKg1bdMN2FVwFsZJVqi72m	9679	13656	13656	1618397280000
19188	3NLoXCTqxZqEz8Bo2TFfQHRveakKAQ8Zsdw2psWWTxR8kUhe1k8T	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1402	810	334	6301	12463	jwyRgozekFc7khvQU3J8sHEeatiXaZ7mSFABCir48LRgqrJNxKq	9681	13659	13659	1618397820000
19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	19189	3NKg5bYgP2hiFCBVj4D38ZU8zeqAjG5BLSUccUhTxrZBC7cR5Hub	1406	1393	334	6301	12463	jwK5i8dnZHyuwgN1WeqjT16i5J7AnCnLG1rbTduQoawdvJPv6AC	9682	13660	13660	1618398000000
19193	3NKxz2T8aSJ65bcWUJSLwB3q4btSFzviFeKEhCH8xe95PPNMDXLY	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1407	1395	334	6301	12463	jwXfpZkTKGZTE65tAnNVnha3PqSzWwE4yza4cxtMnDioHHw9dhj	9684	13663	13663	1618398540000
19195	3NK69qA47SDJWLYSTZB2kyZ9kyuqZWP4WTYGUvh8pMYzZimYpY79	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1406	1393	334	6301	12463	jxfKsusJ6VkUMsUzw3esUtGaUL6B66BrWqeq9WKT1HCnza4527L	9684	13663	13663	1618398540000
19198	3NLUr5PxQgtG2xPzVyvDx8TVFbFgML9Yt9VZEYdQPq9MaW3NAs2h	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	369	1066	334	6301	12463	jwttELr44R4BWCRSsZaU29ySASzhMxeupufZhx1bCCxqfY4LKw5	9686	13666	13666	1618399080000
19202	3NLxViVrGyUybJubqgkaxb48ZPy4yt216CRonwYHRgP3CGjYgWyX	19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	1607	271	334	6301	12463	jxU8aC8pjp3rmLMPjcfQwRE6e8T7HwdBcf6o8b6Y1qXU1Q74tzm	9687	13668	13668	1618399440000
19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	1489	1134	334	6301	12463	jx6P7KcHRzgbqTYSN6tNTKZdsipPhQfbp92XvkWC3zDg6TCGneM	9690	13676	13676	1618400880000
19211	3NKRkpVQaxLvwYYka7R71b3S7X2wmdH1ZwXQXpnP1fd7jcJfXbJR	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	532	1303	334	6301	12463	jwfRSQKM84RFs2MFnHY5BzDu46t15A1xN2ijkUhbwP5Duqf2u2z	9692	13678	13678	1618401240000
19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	19210	3NKfLw5Gx2wYq5grz6iBpCADJaG4TkRkHVtgAFrvWfa4nFReNKS9	1406	1393	334	6301	12463	jxutYcdZnGB32CYhqLuoLqejP3cRQaP1vdKuRMZ6oKvMiBNkgVV	9693	13679	13679	1618401420000
19215	3NLQdh9GEap5Xeo9mkDd8QsGjuRG3F9cWRk9ShPKXGinPZ1y9MeA	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1489	1014	334	6301	12463	jwcSG4p3uc2c2gRSmEEgApqmFYYwXq99CvyFUk493BxfBNX4jov	9694	13685	13685	1618402500000
19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	334	6301	12463	jwNxPfVzX8wiAmJMp5x5F6vdx5V9KvH9xXw8zZ7vPJpFZG54ap8	9696	13690	13690	1618403400000
19226	3NL2V5MVzrPYxUDrW3kqhZCSuMy2c3K1iqDzfzsyuz4ewVZeDNBY	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jwjbafZebjy8YMa5RJf6qnLAX3dFF4PZL9s7TegRGX8tQG3eK6n	9697	13691	13691	1618403580000
19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	599	599	335	6301	12463	jwNYbRGB5abQwas8nvSfPqLnY8hjDSkdWXvpbz4ENU64sbBJrCw	9698	13692	13692	1618403760000
19236	3NKiW8Q8okgkpDa4cBoirc6t6XHBHBbharZKe4z9vUT1bJWrqy9D	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1589	1286	335	6301	12463	jxPhCj17XcV3KQTQqnDmgv3YkDREuuBSNGr6Eg4xE7fzhzK3BCo	9699	13693	13693	1618403940000
19240	3NKMATBpdWnLvAUvgyvn51HRF8fnqDtC6unUAukJwT8fjb9vZdGs	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1516	1168	335	6301	12463	jwftcKKbRsQsVbU3KLjbQpHkCb1o2WrehbHXqoLZokbywGLFzAL	9700	13694	13694	1618404120000
19248	3NLqgcfNVwXp7eVn7E97cuTJ3h8en3JEpKHFdTHjCPqPKe44jVif	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	1487	53	335	6301	12463	jxDaBkT4tUuvmDajPsYWE1Qb1xuWkwCUUucYhFqF7hmQm57mgee	9704	13699	13699	1618405020000
19252	3NKTTifzTroUjZH8oNo8nxxWJNLNUKpWbso1JYdMGuVEECyS2KRN	19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	1670	1282	335	6301	12463	jwqfYPYLok5rn3drWc551AyV6HHwP8QAFyHemZQGyCvs7Mn92ZH	9707	13703	13703	1618405740000
19255	3NK9Bx6DJPu1CdrtDZKyASaqqUPHbRE9T6mNsSB34nufftVwbGQd	19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	1643	1299	335	6301	12463	jwRT3eACqSvwUj4ne1sLght1dmstxC7Z3cBacVScqQ7FGGaVLLy	9708	13705	13705	1618406100000
19257	3NLpS5JEZ2vBBst8P1SjvUy4TV6d4cRNRG5vP7Uhwg47hjuFBTFy	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	596	1306	335	6301	12463	jwvESgvULfskdfZUxPCzw8TJQEyfKhTDs3WEwAfD4H7vXr3DQgA	9709	13708	13708	1618406640000
19260	3NK4Ta6VzwS7qJ72bs2qp5cAASr4GvKi6LDetzT6wSaAbJWxRmwQ	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1581	778	335	6301	12463	jx9D6s5k8a3Ho6ykeFzhJVaL6kUndWWkjvL25PLB3o4QqYQJyqn	9709	13708	13708	1618406640000
19264	3NLVjJ5g6QwKZ1WRMiB2UX3ft2eMsuyyYhyPeLHz4jfJBJdFfEAU	19263	3NKbnk9Pu9RkmyEKqFq1XPopZLRapn7mD7k8tULT9SdQoxAQHPbo	1529	1316	335	6301	12463	jwb6dRh4p6itmPRSfX4yP2YfP8Fa4hraRDvJVcx9qJFiu3nvLeG	9712	13711	13711	1618407180000
19267	3NK6o82YTKSfWqtHyH2YVN6MipwfgmECbDsMzNyZ2wRrBiBdbP68	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000
19270	3NLiEfjF8DXYtmBufuU2yrTQfrQYEftads4LwjnHXpk2iBq2Byw2	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1553	775	335	6301	12463	jxzXRD6EPPEnU9yYodAKu3HKdtbX8yBh7cnha97dLs2EgC5yPJi	9714	13713	13713	1618407540000
19273	3NKriJvqoV7gjmpJneED6o1MLCGAv8RCVdLwwTyNDe7hFwLH22M1	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jxnWhy2RfsT6LvKW3r7JC69viKbsgZwhbHB7VhEhd2MaXjqqKTf	9717	13716	13716	1618408080000
19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	1489	1134	336	6301	12463	jxpJpTdaspKrEKsVUyproyqnxzb61WCrJZxTsegNCpJmj23AC2Q	9719	13719	13719	1618408620000
19280	3NK4gLAD3jYyGG7aAfY5dBPgPpEcsV479ezTNNDFjW5kKGBugh6p	19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	484	953	336	6301	12463	jwENCdJqRjZb9A7LNXodVWctHCjpeTt18F6dEUgRmp2AEG1aCpA	9720	13720	13720	1618408800000
19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	1403	824	336	6301	12463	jxdHePKFtbtAQpszW7THC3BP2fP5qV3ciEPSJddUZbfhPTjqTzZ	9722	13723	13723	1618409340000
19285	3NLDtWD3xekvuQ4AEAXzFSjaVU72Kx6KUH55rgj4LgmKFNfNRtT4	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1599	1287	336	6301	12463	jwTzovVu8aRzc1cjgqZxAWvsmhLtpBY1ueDF1Z39GUQAinARGJ2	9723	13724	13724	1618409520000
19291	3NKLYCPSeARm3VdgeZZjH5bVe9NnZXb6npyhK2Ptsuw5fiU1dxSk	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1555	1347	336	6301	12463	jxDEzbyexbu1nbcDNfJ7FBNHZVe9b3NcRTg2YM6X5jMLjPRyMDy	9726	13729	13729	1618410420000
19298	3NLFkB5dHo5bR2bVqzw25p6u9UT95u3H9UnX4TNNJtAEuzmLafdv	19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	484	484	336	6301	12463	jxb6xbjXFc359y5qbg6eNa4NpQbTdbvXAwefFYyQPoREiTSRwCQ	9729	13733	13733	1618411140000
19203	3NKZ62KmRUuoKDTH6MJUdk3mEytyEQ5vShh6aV229zbGvZHQ1Qwm	19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	1407	1395	334	6301	12463	jx7pHWoSVdBuFwrmNkJMM6nwWCrHBgva3TNqs5ADeizRuc4Q4oW	9688	13670	13670	1618399800000
19207	3NLSuwWXrfRVjKtFdUELfRd5GpJhjK8B8g1TWDYfnb8a9tGMeYRe	19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	1489	1134	334	6301	12463	jwgYZ1JCrYgmfV8gSjom76APjkUmsfyVjRBxSrts72iCXJNEWJ9	9690	13676	13676	1618400880000
19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	1585	1240	334	6301	12463	jxjLwZwWg8kh8qRFPc2h14N9CvfKruRyFLuyEHmV6oPLWtx1yeT	9691	13677	13677	1618401060000
19212	3NKgYxwCbyDyCbq8nfzNZQn7xJZnCeWis2tau1h3BSbMqW5jeoYa	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	448	1305	334	6301	12463	jwtCSBqHrYEZ45QEsytximj3HQuvLGMFboSHquuTg1t8Nb7mGGw	9692	13678	13678	1618401240000
19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1403	812	334	6301	12463	jxWkYMkUVCmNfTkc2AsD7K39uRLmJacgcSuAafhSz8maRVjyGHC	9694	13685	13685	1618402500000
19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	532	1303	334	6301	12463	jx5rLp197XHkUHRP6kw6YHgJrKBe8ZX5FtXDgs8WvKTNbN5XR8n	9695	13688	13688	1618403040000
19220	3NLcmmTC16Q396BCkGj7zYn1w5PqeJYZ3ibLcKaQEhks4hGcNPhC	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	532	1303	334	6301	12463	jx5rLp197XHkUHRP6kw6YHgJrKBe8ZX5FtXDgs8WvKTNbN5XR8n	9695	13688	13688	1618403040000
19232	3NLevQr6CTrmSpekQtcfw5oPSa8Gwmq7v3BR6CCn9opG2qhqZfXP	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1546	1093	334	6301	12463	jxgjAN8Hb8iSQqfcaUBd8SgYeVahLqX6PFLn1sjJGXSNkKDF6xv	9697	13691	13691	1618403580000
19234	3NLpr9HYLoYecSssrQDmbmXUBcEWe1ZBZkhQCSfmHJt9neNMnBiq	19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	1407	1395	335	6301	12463	jwyKxQLZvucvLRMzUH4qfrpWi4i8xMeUMyuVCHqWCZhpyNWN58G	9698	13692	13692	1618403760000
19237	3NK5yyj2fE6qQu9bNxQm1JSyJsnya7oaBJKvr2StcQGwVExEeRA6	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1439	1279	335	6301	12463	jxH6GoUGBe1C4x7UcynJj7qboDG7P4JCkUce92KmGGy2PDg8cQu	9699	13693	13693	1618403940000
19238	3NLYGCMvuSNRHuQageJG8yRA2znp6iHgUqwjvKhjBsErRE9CTVu9	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1541	1172	335	6301	12463	jxnAN9QoYiej9go5uzJUGXyw9u5Th8WfmT6F6yHGzUDuhcPsghd	9699	13693	13693	1618403940000
19241	3NLJGy4ZEDodKLB3WbFp3GfPdXUa3fqExFSgnaErhRLGRrcfM9oe	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1637	816	335	6301	12463	jwV3CRxB9zQx4DPY2rYc1rZ1HiJTSVTwTpKSgMFPSiVuU5UYhpd	9700	13694	13694	1618404120000
19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	19244	3NLSJboDpJFqUgAF4VwCqeeqfPLD7ViiCkPi35kYcc39CvhGkBEZ	1588	1146	335	6301	12463	jxa5tXeqiCqbNWRcghEkjDP6gCfmGQUt9j9dJ1A12AptWoU7Vkx	9703	13698	13698	1618404840000
19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	1536	1313	335	6301	12463	jxnrtCch5qxf4Uev9QyBuY4SABsSy1yjQPbwiuo5a5YtgPvPyh8	9706	13702	13702	1618405560000
19258	3NLrGZVguYk1qsZZQ8kevR5Kopcw8xoQtiN9z2QaGAMwAuESfDqX	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1439	1033	335	6301	12463	jwDTaeE9tzSzrsYV4v1zgkixfRDtfexVgV2w9LyHu7yG4eWq5xG	9709	13708	13708	1618406640000
19262	3NKZEmx2FtTBTz2oh3Y7ywgGKUNW5256tLZuaCHjAvhA3u5535CA	19261	3NKCfcNsckHK7sGxshMAcuAPXC8cxBP5kWHdUcNRCLGfC39Xk4hF	1405	867	335	6301	12463	jx2WUXcpLQurPHswtFJ95kDKAHte2eRLfThhfheyGGJhPggFB2W	9710	13709	13709	1618406820000
19268	3NLn4efUGjJg278XgkvCbg9h2SVaSutGDyZVZJayiFTShwnSnNFY	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000
19271	3NLZrjb7bur7ZnwL27NkDJ1HeTu1U3PSteMxto9ZWZCNSgVnDHPa	19267	3NK6o82YTKSfWqtHyH2YVN6MipwfgmECbDsMzNyZ2wRrBiBdbP68	1403	782	336	6301	12463	jwFD1x5YztPbR9CFGK56XZAbAPquphfsjRQ2j4dbrbLkFNwocWp	9715	13714	13714	1618407720000
19274	3NKHrZsU3GT6uvTGmTucbDYPUqTmZEPiSkqMdN88gRhpBUKXjNn5	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jwb2JTT6m4v3mG7J4V8A8PCf8FtzWJjAHbv7mpVsWQ2FMshMMxs	9717	13716	13716	1618408080000
19279	3NLHDjU3bBByVJEdHTWmXPDGCpGEdQna5N8RRXqJsJxwkwdznqLu	19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	633	1384	336	6301	12463	jx1c6VMsUCQWL8TgsoobGUrGuYnGGb5zPLmYGU5gsE7rSnAbXNg	9719	13719	13719	1618408620000
19281	3NKexMZxfWKeynS34bU6CkuQuam8MJx6DoYBG54QV5GKhk7tQTHw	19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	1406	1393	336	6301	12463	jy3CzNXjKowcAoJg73BwM21tTKGnYcVCggE4r74Wg2tWDVj1i1g	9720	13720	13720	1618408800000
19284	3NKMYnUjBk4nCTEm6vHtg4kKDh5BSKSF5cFhuoP3jpu3D7uMYK8j	19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	1623	839	336	6301	12463	jwEd2AqY5TxoHtj7FHniE7xTZr8GgoC386vZ5oVYeSv3pUcE9Gz	9722	13723	13723	1618409340000
19288	3NKdqWLg6n5WguqK3xjk6RYcMm3JUZzCjSFPTVP4ibKj7FvW9vHg	19286	3NLwvt95Wp4NY5F5F2r5oqTZwEuJUqHikSExVkQV8vU5RwEgV6rr	1406	1393	336	6301	12463	jwN5Gicki4MuEnhqEsqJGpnDU3qhLU1MqvMgL5gAEPoWs2MRXwy	9724	13725	13725	1618409700000
19293	3NL1S7efXZj8sHpjwKibjbP9VJR4jeQdWqRaM8BtXdfpY5DN1NmA	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1467	1130	336	6301	12463	jxmoqbydQ6rHBHbbX7mR6najKtgCqBaQRGPtgh6ak7fWWBHN9z2	9727	13730	13730	1618410600000
19304	3NLoN7pUyTrnrwgzW9yidVdDpfaeznaSqVFTd9Bu2eG5UkpEi6wN	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1477	1350	337	6301	12463	jwjRfaeYVAKphpEyQMTAv3fJgQGE93sbBoBjyytM4oG1bEZy3r1	9734	13740	13740	1618412400000
19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	19310	3NKgcMAJSQFBv8JqK9cgvLZ7zdAtF5vf1nWrdUNw1ppeLdr5KAas	606	1295	337	6301	12463	jxuQm7A5xj5bsvzScjS7Ye7udiC1AmbbqPWjnwBH6dTi43Eh2ag	9738	13745	13745	1618413300000
19314	3NLRNbCVSrmxRx7AfgYHr2zAmgHrHovNwTCw87jeLsaagHniRnpn	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jxVQfVY4LF5gP4xTKDeT1s6VgGmJJhBWrmL5phJxVqxeQLJCDL2	9739	13746	13746	1618413480000
19315	3NKcKydDeP8Lir7JMW9i3tR2pvcPim5mB3Rbq2pWJCdkRoHkeUSi	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1555	1347	337	6301	12463	jw6n5PLWMXgSwTWaVS3q5eGhmvb3qqyFhuiFzbCtw86jbVZF7ha	9739	13746	13746	1618413480000
19326	3NK3gun3Ufc1EoAmHw82J15ByP1htTJgTU4Sm26HWUBqgqLRh92p	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1407	1395	337	6301	12463	jx4hvYcygAtsmu6hFPwcQm8HgnLzN7T1bBeftzcndP2o3taQchw	9746	13758	13758	1618415640000
19331	3NLsAr4YGd4BNyC71FjvyfE1G6zTDkWHdmYM7TBGoeuSXwZVAGHA	19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	1573	952	337	6301	12463	jxteEBrJF5f1VbT3rbJwLpwm6VLzv9MEHj28sUg8DWwNBpFcfc4	9747	13760	13760	1618416000000
19334	3NKtEW8m5Uyx1YYqfXX6WL1GJU4j7M5qsT7XrExE8kiC9nA9k4Ln	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	1406	1393	338	6301	12463	jx1NpQw4xdSgAxizzwHeG19bDR6T1cE3VtERiSsarEp3vzhnWwu	9748	13761	13761	1618416180000
19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	44	1325	338	6301	12463	jwRMsGSryapPi3H8dq67nmuGro66XTkWtsBUciYmLVJWFDuCNzn	9750	13765	13765	1618416900000
19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	19271	3NLZrjb7bur7ZnwL27NkDJ1HeTu1U3PSteMxto9ZWZCNSgVnDHPa	1564	1338	336	6301	12463	jxcziG6p37iHya6JhHRGoJWn2Ychy6gEjpfbpHeiP45e7W68kFe	9716	13715	13715	1618407900000
19275	3NKh3PBwX8mtWLQzTLhjKfJeMr2eLhXXN6k7AwHBW1yk1A1Nb2Bo	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1406	1393	336	6301	12463	jwFmfhb8gQQmGWc1n8uZ65ye6VuUdHjVXumd2Gh3NPyuV3LrH4K	9717	13716	13716	1618408080000
19286	3NLwvt95Wp4NY5F5F2r5oqTZwEuJUqHikSExVkQV8vU5RwEgV6rr	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1403	824	336	6301	12463	jxoA4ECatEULnodsGmhHCzGKCGnvGeRmsbTAY7oFXGdEXuceDrE	9723	13724	13724	1618409520000
19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	19288	3NKdqWLg6n5WguqK3xjk6RYcMm3JUZzCjSFPTVP4ibKj7FvW9vHg	1637	816	336	6301	12463	jxh1BSKWJTkciXRTwTD8xjr1E3YPwrrvCrHKpiJMHRpVfGfqQih	9725	13727	13727	1618410060000
19294	3NLkzV5kpYKFen2nZfFViMg7vcCG8Xs8mMM2nk8aK2Qs2Dzw9ZQA	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1588	1392	336	6301	12463	jxBPeLzZCuXLe7cvtMBHfokDgT5sXPvppn8gPRi41VdjZjuoTDx	9727	13730	13730	1618410600000
19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	19293	3NL1S7efXZj8sHpjwKibjbP9VJR4jeQdWqRaM8BtXdfpY5DN1NmA	1670	1282	336	6301	12463	jx6YprxKLssHWqRLnNX96Uff1wVGyZv4CC1vz7FCpaLwWcVKr1c	9728	13732	13732	1618410960000
19301	3NK7NANAGnqofVdTudQZozM6c1gCmCAoCbqmmEzWUrPBDRXwumjd	19300	3NKbdoebH4EL3kZACkGUdFEXxz4VV7Z2R5Urymz2ufKLRDTcCwKU	1407	1395	336	6301	12463	jwUVWuWN1My4w5d4VuTk8wZLnRo3wEmPa1jP1iA3Hv2EmDLXHeX	9732	13736	13736	1618411680000
19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1477	1350	337	6301	12463	jwjRfaeYVAKphpEyQMTAv3fJgQGE93sbBoBjyytM4oG1bEZy3r1	9734	13740	13740	1618412400000
19309	3NKFfWRgEnZiFqFSKu4RMG7BAvCnezF1rLkcgp6WgBBuJ8mxUdsV	19307	3NLqz6tMRookmHkwqzee6ANpUWh3Qk3UoZE9nmSwcmVCLU8fpbCT	1406	1393	337	6301	12463	jxiNoM2B11Qq9AKbqSMfKvWtRhGRF6cuS2BKfrduvQsVTCeHECh	9736	13743	13743	1618412940000
19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	19312	3NL7TFCWXg8jMLt1VUdvSrHkxs1KTNWnEiGvtb1LULqSqzCrL9vL	1406	1393	337	6301	12463	jxrSjo1poUHmq1D1WBFHtATPvk9HLyxG9S42VQtvWpm5MDgaBFu	9740	13748	13748	1618413840000
19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	1637	816	337	6301	12463	jxjeWTSAyWijMP2wmwsFKe5Qqmjsr5em32vxPYtDYdBVcqdE9Ru	9745	13755	13755	1618415100000
19327	3NLkAfYz7JXui7voQV9SbSsuTH1XESRosLv9oTCv1PN2AMb7MuGG	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	684	1106	337	6301	12463	jxSHZ8sxhDsTsh2YvWpXTBpRzCdt76R5poepSkUAmy9GipsaVcQ	9746	13758	13758	1618415640000
19329	3NLZmXRw1dvqYQND7PMVfaqAr2DpjYwEcCR37Exd8nNnY87wBxNH	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1631	794	337	6301	12463	jxbwPdJeQaqfq28MKEKLzdXhqFg5KU7qTxrHMPJCsfSDGmEy4to	9746	13758	13758	1618415640000
19339	3NKQDPahP4bcEHrChTvKSyKvvozRNMDUqs8QFfRhBRZZ8wWZi57s	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1588	1266	338	6301	12463	jwzpPC46jHEqER49ZGawkP8Fg3EiE3qMi896bx9QoWRzH5JMX8C	9752	13768	13768	1618417440000
19346	3NLtyBBSfgkh1wZxZJk7EifZ6e1ru6fP1ehK3vUMveqgT7E5ET6K	19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	632	1016	338	6301	12463	jwLWAXDaif3xp9d23oADdnT16YpW9rX5mJrVFeEWNoJvReMwXEK	9755	13771	13771	1618417980000
19353	3NKRL52XDxc95QcUsyK4HtgYrZf4jZProUd3Q4Ax3uaQ4CdCWZv4	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1577	1081	338	6301	12463	jxU774tBbixpLThUUXoHWsrRJfeLLewWXukoPPYbJ7b7WeTA9Hu	9757	13773	13773	1618418340000
19356	3NLRCGvGtTFdiCvGwnSwKvXAWXtXNYWKf7wUkgNohMSdhE1D76ff	19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	1444	1255	336	6301	12463	jxFRfEtL4g3334d7edZBArf3kPAE6rhatSL1k6MUBA1tuHgMdA3	9731	13779	13779	1618419420000
19362	3NLuGbNycTzW1GFLF97ipR2nd99hr11cEAmY3zUhtaDYHViDSSuH	19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	1578	1050	338	6301	12463	jxFPv6GDdJZHA1jagRRS2WTheqeM36QzgbhvTyL3bYhkjHTkALx	9761	13781	13781	1618419780000
19365	3NKvQ5jcpanzsPbSAS2tmz1QS52HwA12DMc21FYLL4XvPV7uLzkX	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1672	1285	339	6301	12463	jxGbKWLxDpXdjG8CWx5ZYUvswvCb1asHiVWP5gHFQvu5fa7AhRy	9763	13784	13784	1618420320000
19367	3NKYAAFGQEAE8eHYvRaCdHwWod2uzcTaxjfQApjMKhkWrqvmA8gm	19366	3NKtxjhKMu5jbjpvKDb3EMPPtRWXd28AkmUGsdAaEzZ4vR3QqLou	596	1060	339	6301	12463	jwNiGtVoAfdBu6tdqKsfJwvgrkskwJ8ggvbaSPDpdzsMv5TCqS9	9764	13786	13786	1618420680000
19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	1405	849	339	6301	12463	jy3D6P1vbdnfZuimd8EKvvqMKJnYb19WfBpCQqbwo1rSDCc6vfA	9767	13789	13789	1618421220000
19374	3NKAs3qYvZsWQppL4pN9HrhNqEBLa8W7xhKSsT2QPKi7PqdPBoe9	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	58	1281	339	6301	12463	jwLcPMYE9jfzq69DVdnvxJ88NXaXuLRW7gQEoscZq8wsCbaYGmF	9768	13790	13790	1618421400000
19377	3NKRDmS1QbAYJNXwg6hXRzFwEbLKk4CHj94SJ3K2mgJfLWkHQu3E	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	641	970	339	6301	12463	jxGJfcQQQDtMHUp5jVDj7cBy7Q3zEPur8Bm4K9RW4AXQdqRwcuB	9768	13790	13790	1618421400000
19380	3NLhfM6WGZr6ZCPifMVSghdddeGVmcAUoLAFU884f8p3hXKCkxsr	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	641	970	339	6301	12463	jwyvbqsJDDqojd91osgoQdAeh3Wa8hgVpTAUE7pS2zx1hdaQTHF	9768	13790	13790	1618421400000
19384	3NLFEyZpAzS17ehF8RSYx7VhfZ2G3mFZAc5NZ3d5esaRDSJGmSAR	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1403	824	339	6301	12463	jxxW8R9y3vnGY5o6pHhXW8Euapm628uSAw6be983i9Qsc3ohTCB	9770	13792	13792	1618421760000
19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	19384	3NLFEyZpAzS17ehF8RSYx7VhfZ2G3mFZAc5NZ3d5esaRDSJGmSAR	1650	1129	339	6301	12463	jwPb4377hqnQXqcNgAx68rVS3Uc8SuVZC2Cwoaff6YdK8wJhGYJ	9771	13793	13793	1618421940000
19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	1601	1388	339	6301	12463	jxFt6htH2oPBRXLNDqobAm3SaUQ8vXWabt3iRTJj22xBXGQo53K	9772	13797	13797	1618422660000
19390	3NLutSBoBQRcL6n8ibhrKa3nMigx9oPXc1nJhdKmTasRvJxx8fFH	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1579	1023	339	6301	12463	jwtTkbUzgKEQFLB2nCY3yaUFRiaeQXsPMGTbYanm7Y4HNMYkCsF	9773	13798	13798	1618422840000
19396	3NLr9LHHedEaAsy9S4yy68uvAjkaziBc3He8CJJayqG3ydYG5vC3	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	733	640	339	6301	12463	jxG78K6XhYjftwKuXWFb7hWFX42YKiN3GSm9bcEcgp1VkNBSDjh	9776	13801	13801	1618423380000
19399	3NKntsFpWm6aejGuKBFquvMdYmbtkN2kunRDCMgBYHJKV7jbgzYt	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	43	1064	339	6301	12463	jwdgsxtRrXibTCG9boEYkKhhc8HVixAtZrQ6ncKveiM5piBuwrE	9776	13801	13801	1618423380000
19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	19396	3NLr9LHHedEaAsy9S4yy68uvAjkaziBc3He8CJJayqG3ydYG5vC3	641	1336	339	6301	12463	jwbbUfRDxKMoJFGmj5zSf3zVYkvCuxXb2y6MywZqtrpiqLhPH7W	9777	13802	13802	1618423560000
19402	3NLttuDsdHP6w4rYVhsnT9EZyqPi3uVT3ZtzXsEKS8aboyv89H9L	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	532	1057	339	6301	12463	jwr1MNTdXY94GPj5oxp9DPjgTAJADaihrMH2sw8ZjoZSqRAVRRa	9778	13803	13803	1618423740000
19276	3NKJACHGkZk2jTVdttL6gGkSRFJhBxe8FLSUQQP38yy1Na7RXZa4	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jwYoDB7W5XtGNrBrpEdrsdwn2bQuBFJV573sq276DAecuiDxH2p	9717	13716	13716	1618408080000
19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	19273	3NKriJvqoV7gjmpJneED6o1MLCGAv8RCVdLwwTyNDe7hFwLH22M1	1571	1209	336	6301	12463	jx8oq5jMppgpHnDSwEN72b6K62ub3xLF2m9nkXmweg64RqwDkp9	9718	13717	13717	1618408260000
19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	19281	3NKexMZxfWKeynS34bU6CkuQuam8MJx6DoYBG54QV5GKhk7tQTHw	1673	1242	336	6301	12463	jxtCzLV5HuWffnoRiRe4v4kpL7g8fzY1LF3oNzN6h1Egrd5eada	9721	13721	13721	1618408980000
19287	3NKvwoPxndkYstASN2cGqrxa9vNAB5GT3Xcnf8KGdmYBgaxZuN6X	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1406	1393	336	6301	12463	jxYzUn8fGEfphHUktYicqT9ycF5JuQbrJ5crYDHK4C5H5Vyunhg	9723	13724	13724	1618409520000
19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1407	1395	336	6301	12463	jxfYWjmCKN1QUWQCVs2csAjWaWkYjTAow9cDAEbaPuSpNbgdwUa	9726	13729	13729	1618410420000
19292	3NLD3cuVYpoKYwLHw4McJJi7hYZqsp5Bsc2pxg1t1xjnX3FZuPyH	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1643	1173	336	6301	12463	jx2b8cZ9WV8RMWeDexmeTmDfsCF2HHfLzdwstG3M1bY3B8rYJET	9726	13729	13729	1618410420000
19295	3NL6wACyt6VBafggnHeyxAp1jQRqh5Ce4ye2Didq5BNwHJfCkhH5	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1444	1135	336	6301	12463	jwfPixQh3gFDHgU3tSqx3oJp8c1xVYMYgxnV6jYEevFbXgQmyfF	9727	13730	13730	1618410600000
19297	3NLhvSbhrYC2VDe94TM429wBh1sr6bYDMw8uhrd1Eng57S4SQtA8	19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	684	1352	336	6301	12463	jwFtvCM9yKwi1Wsd7TiqwZPG5dhywNHxdoFVBjhKY23eLjZB4kJ	9729	13733	13733	1618411140000
19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	19298	3NLFkB5dHo5bR2bVqzw25p6u9UT95u3H9UnX4TNNJtAEuzmLafdv	1571	1089	336	6301	12463	jwpD3Qru4w7DhF8TUYf8fQuheu3k4epyeKPpEJCVSQYyhHe7WH8	9730	13734	13734	1618411320000
19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	19301	3NK7NANAGnqofVdTudQZozM6c1gCmCAoCbqmmEzWUrPBDRXwumjd	1591	281	336	6301	12463	jxX3n7Yxb8EoJcnkhxnwGE4QjhWxo951dqe9fL2krh688PCtES7	9733	13737	13737	1618411860000
19307	3NLqz6tMRookmHkwqzee6ANpUWh3Qk3UoZE9nmSwcmVCLU8fpbCT	19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	1477	1350	337	6301	12463	jwe7dgT1qAkx8ugx6bDchbikR5LiphXHcrG3SCLDVxz2WTeC8rP	9735	13742	13742	1618412760000
19312	3NL7TFCWXg8jMLt1VUdvSrHkxs1KTNWnEiGvtb1LULqSqzCrL9vL	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jxCvMRD6JJEJCTxbfomNw6srbLtg516d5RCK3FeBR3YhYt1kVbY	9739	13746	13746	1618413480000
19317	3NK7atu2cmJcfYJ4fnnDSAg92YLdFPPUPBzLFSyWfAtnUp4q6fzo	19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	1542	1304	337	6301	12463	jxLhK1XL5QNde1q1GfpE3PYiDuDmsiQQwLyPb37RiyVtGQzGRZm	9741	13749	13749	1618414020000
19319	3NL8XabgX48W3jQ8fToK1JULbqLiCy3Tgq1ZRKwMG2VxZLCXsmyr	19317	3NK7atu2cmJcfYJ4fnnDSAg92YLdFPPUPBzLFSyWfAtnUp4q6fzo	1422	1337	337	6301	12463	jxG6Lf6KXkk8Bv13oHZJJ1uuEw29vmEzVq5a53AipEcPTQ4KkRj	9742	13750	13750	1618414200000
19321	3NK8d6ujQjLZ4yvoQL6cAWqDDGB4jHyWLcY1zFMpo9zcND8wgWhz	19137	3NKtcLx2NJ5p64WNgJwZnZiq77GLwwLTebxAvDWer4zAvcfXtCCp	641	1336	332	6301	12463	jxMFqf2qxxpBaJU1GfZdpzXLvWeaMCiDc2szYC4dL3K7wVDUL35	9655	13751	13751	1618414380000
19322	3NLBNGnwqsaCzycCb7UJcTBopVZqZ45opqPKfafw4Da9TZxhytwH	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1613	1223	334	6301	12463	jwcdW4jtDUMuAzsKQ5kZTXrkdTq4u3HPTTVmse4hsbP4khwk2jX	9684	13754	13754	1618414920000
19325	3NLZ7Y6gkg8ubWGpLK8KFLrBDh9zyd5RvSrNyYiXk8Bk6pkuVodr	19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	1406	1393	337	6301	12463	jwBQRTrW7RH5vujCcFaLgi8ZTmWuoJDBBxXySeDcGSVLRT9W6XT	9745	13755	13755	1618415100000
19332	3NKUFcxwiMrDXGDhQPAWbyMPUqxcZiSVdm8LA8TGY4SdudRhHw6D	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	1422	1091	338	6301	12463	jxCA1KYfLLgoubjF3K78ABZdFHoGoRPHAbw1yAEv4xCCLcrqbz6	9748	13761	13761	1618416180000
19337	3NKjApZkaK4rtTJMeEFRwLjxoBmGnUiVW5VX7TVRZqnsGXxF3xpr	19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	44	1325	338	6301	12463	jw7UkRwVNM9937gRAqJq4K87Ut3RXdezSrgyDFBa74d6YDkFYJd	9750	13765	13765	1618416900000
19340	3NLVuAfDbNuofJQrgXmbSd742bZRXn2R7sADS6AZMcGKyYnqWKgs	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1451	1166	338	6301	12463	jwun2wz8Pe64CwXQWvBNC9w3aRhApKEjs53D1EcTdXMvhPHqbEH	9752	13768	13768	1618417440000
19342	3NKEkNvWPF9qideoCEWtPCMDJF778yBBgCEUW8ewZdKGh8NxzFT7	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1637	816	338	6301	12463	jxmSHfFxaFk7tJZNG4NoBdKDJpAwyN2xRoHouaooLeWkU5vyoYM	9752	13768	13768	1618417440000
19344	3NKUsWYupqtHc5BV3ymCgCdrb7gSeFwnPim7bpSAJxkQhs7GTrnF	19341	3NKkqFHpQWfua88LSDD25hDvSp9sft8WvaTL3VWDHLoDsShp9xxS	1402	34	338	6301	12463	jxWp7MM3GnGXFfD3qUTEuhJon9UNKJkXkxe6fWBTaFueivB4bS7	9753	13769	13769	1618417620000
19347	3NL86a8F675it9Sy9NR4ifktu8TncQRY3ZQEvSSPpB6zN1DCidKJ	19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	44	1325	338	6301	12463	jwDaddFCNvXi5r7pQ6vfZUTErdGRZ8QroSHbZkjbwCkTZ4bKYE7	9755	13771	13771	1618417980000
19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	19346	3NLtyBBSfgkh1wZxZJk7EifZ6e1ru6fP1ehK3vUMveqgT7E5ET6K	1405	867	338	6301	12463	jwyhSUZrGmMeb6ihB9Zc4ZwNZd25FUN4YMdmfpMuq17rMQ9Ry8Y	9756	13772	13772	1618418160000
19357	3NKPhxDwsmmtfuijCDxiNsZxQn3aspxTUfbHF58Z5aaSD47iXMvt	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	58	149	338	6301	12463	jwmLCQs1YrEw53D6QGz3tdyoENBgR3vyQN2EVSkjPSwQkbDsJp5	9759	13779	13779	1618419420000
19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	19355	3NKQVDZcP6hci2sL111qSTGhpuMutmktDu14ho7ozLYbGtiLq5cv	1673	1002	338	6301	12463	jxGRxiJTgVUAzknP6cJEFzzz3vx8uTP3FRYf7UEVhcLgH2ZAz29	9760	13780	13780	1618419600000
19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	19362	3NLuGbNycTzW1GFLF97ipR2nd99hr11cEAmY3zUhtaDYHViDSSuH	1460	1324	338	6301	12463	jxosoWszzBnHZtMjDf3EwpaNuBrH1ZRpJq8iM2st5FmoGo7KthU	9762	13783	13783	1618420140000
19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	532	937	339	6301	12463	jxtgHz3FHPTroxnBMXDnEfSgov3sqF3As2yQc4TTkvuHjRYjrLf	9766	13788	13788	1618421040000
19373	3NLgmsFmbFoJa94hLjjM5gQEifQ4eHkvwDUPPjVpAQpJ6suzkMHe	19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	1406	1393	339	6301	12463	jxh7U6w3hPuNjqfxBtJCTTVP9EwX4PspgundpenWXUb3Yn9rAoy	9767	13789	13789	1618421220000
19375	3NKN4G2UcwiU2knCgVtczkCmJjbTxQCM17hCf2q7KrSCUPx2a1qa	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1489	1380	339	6301	12463	jwS7yYiMqg4TRZ78Ge2KqVsTnyBXR8uCFRMZBxJUEuh3hnTDPwv	9768	13790	13790	1618421400000
19378	3NK52ypJvMEhJmn3E8h3qDUN7vB7TKcENW6UgCqEC84QmhGEB1TP	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1611	1215	339	6301	12463	jwEWpYV69RiubmuyxhoKK33oRxiQ9yQsbUqxv2hok85DMaaPQDL	9768	13790	13790	1618421400000
19382	3NKxsnoPEoTMStYX8DkJRmGS6qGi9z5XHSaVQmL6CB9wrnS74ko5	19377	3NKRDmS1QbAYJNXwg6hXRzFwEbLKk4CHj94SJ3K2mgJfLWkHQu3E	1646	1108	339	6301	12463	jwD7fc8pxmjGfjeqDWDKjQd1N351Ktze39ttUN7y3Zv4hNBQ4n6	9769	13791	13791	1618421580000
19300	3NKbdoebH4EL3kZACkGUdFEXxz4VV7Z2R5Urymz2ufKLRDTcCwKU	19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	1542	938	336	6301	12463	jxSCFc7NKcPWTFHop4gVxTZca2BXx1RxbRjBwSZVzJAx6KNmkwQ	9731	13735	13735	1618411500000
19303	3NLx4VxFjDMvK3f33mXoVHWoL6ygjXcD2QaRx5hCkW88cbFcQYb2	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1634	1205	337	6301	12463	jxHHPBsbTEm15gU1661vD7LCgmateYjMuNahnpcriEKRwsmg5f4	9734	13740	13740	1618412400000
19306	3NKZMcNqMkWb7S35QS71o8FBmJbcFJovbk4ViDzSCVXmEzMVtpoy	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1553	776	337	6301	12463	jwdaUPEzvT4cbwXNmuNKidFTAU5rVMuiobfFn5nt6jHTeFcRP9P	9734	13740	13740	1618412400000
19308	3NKKZdXc3GZo2Nxc8tzqTvSTUqXAzmJM6X7MSmpgZcsQnbckZ4TN	19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	1553	776	337	6301	12463	jx9TnZ4RByTDaVxPLDGmDbYDx8TJGk2CSQ1Em8qHAiSzWhARVGy	9735	13742	13742	1618412760000
19310	3NKgcMAJSQFBv8JqK9cgvLZ7zdAtF5vf1nWrdUNw1ppeLdr5KAas	19309	3NKFfWRgEnZiFqFSKu4RMG7BAvCnezF1rLkcgp6WgBBuJ8mxUdsV	1637	816	337	6301	12463	jxmpk96M7dBMHPwmQqEoVxhV5GniATwRQBrMBcaxirQ6Bgpy1ex	9737	13744	13744	1618413120000
19313	3NK6vjjfZijhbduguTSnnBeEPxEto8Yu9p1ZegSAfWWZr1DWE4Tn	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jwDgbEDpibk1qzjALx31289vR3mLudyQ3V6CEGQfWxKPVFy5KcZ	9739	13746	13746	1618413480000
19318	3NLuUayaAGGaVsjWCxjBcK72oYzgRUeSzbvZ2gA66t8xUiq6r5PP	19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	1455	1332	337	6301	12463	jwi8ZotZ1YJyYvTGEUHEYbsps64Ju4wrt6Ue4LjZdhGMRw5zj35	9741	13749	13749	1618414020000
19320	3NKw3poNVAj8WwdvTaSMUHSVaidfqHgdJD4gWCiqNu4SujdKnv9z	19319	3NL8XabgX48W3jQ8fToK1JULbqLiCy3Tgq1ZRKwMG2VxZLCXsmyr	641	1336	337	6301	12463	jwTzuGNvMQXJrqhwTFbjuENUFbkFmYC3tCmy14V1MQrzuzuJt27	9743	13751	13751	1618414380000
19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	19320	3NKw3poNVAj8WwdvTaSMUHSVaidfqHgdJD4gWCiqNu4SujdKnv9z	1613	1223	337	6301	12463	jwCuQXGKmzkk7LVfrpcfcPMMkE94eZuF2gKqUJRFzZCeFdhfce7	9744	13754	13754	1618414920000
19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1406	1393	337	6301	12463	jwuerkXWTP2Qv4Q9yb85YpwfB53irNPvWRcGoi8BSEXwTpHKo88	9746	13758	13758	1618415640000
19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	1498	417	337	6301	12463	jwxcYnHSP1Dbf73FgFqzkdExRuiTmPHrYm4ocByaGSophJYpjSX	9747	13760	13760	1618416000000
19333	3NLYszUnDQKgJiT7AhRqio28wGWjqBTdq63jawStakDzkyw9Ginf	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	42	1115	338	6301	12463	jxbeWx4QrZUQ3hYqyjDDPjhGTXLHkWtQ23bzRReu9ogkZ93p6TA	9748	13761	13761	1618416180000
19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	19332	3NKUFcxwiMrDXGDhQPAWbyMPUqxcZiSVdm8LA8TGY4SdudRhHw6D	1631	794	338	6301	12463	jxhm55rYUGhiibVqD1jUnrsf9hqocDkGTq1JkCkHtzU8HFdhNsz	9749	13764	13764	1618416720000
19341	3NKkqFHpQWfua88LSDD25hDvSp9sft8WvaTL3VWDHLoDsShp9xxS	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	484	953	338	6301	12463	jwtGLcQQ66cRL5nat9W6JoR8WrNFS4BWFWytRCAnLLX9uBQ8CSw	9752	13768	13768	1618417440000
19343	3NKGs8z822P7AzL6EPqxgoDyys7jcESfHPmXDW5zYpUyXMnKNHDV	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1406	1393	338	6301	12463	jxtXkHNDYQMFDRmXc2UnN3xXGrRnjvmikcMjUsCAACyuu9af6DN	9752	13768	13768	1618417440000
19348	3NLwFgXvCKFZ4cFmt5kRdkAqSHAceQrW4cPpPybr14xbdNhK8ihB	19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	641	970	338	6301	12463	jwFPu5EhWo5b9JwjbbupcxBUY9hLVtzg4X6LVaWyWx3zcpk67R1	9751	13771	13771	1618417980000
19349	3NKc4Z54nPipK9AXKvYM9mrGSV2Q7rd45drMu7rkrrswLvvo2RP9	19321	3NK8d6ujQjLZ4yvoQL6cAWqDDGB4jHyWLcY1zFMpo9zcND8wgWhz	641	970	332	6301	12463	jx8oagFKqja3r7zQCtBZjFa244cXxkkiwn3fdiG9o1Gq4n53b4H	9656	13771	13771	1618417980000
19351	3NLsJu4TJgd5najxjWGh78gBc4Twe9WH3ABiJ7sgctCgiR8Rvmrq	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1406	1393	338	6301	12463	jwpehynqubaW2xM6iDGiJN7moiWatsP1EKF6KCysfsgRhWfEiL2	9757	13773	13773	1618418340000
19358	3NLkTW7XCtdUSznRn3mx8psQnP7KF6pZ9iWrnndk2fWhdBWgFU5z	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	448	1305	338	6301	12463	jwwd1jPDFYcc6LwvhesTBT4Tfg5hrwU8Xpi7Tf9cYeNLeALgZ5R	9759	13779	13779	1618419420000
19361	3NKyWHMU7e8mETW7YeuyKwF2VsrUZaqn8y7BJXapJDciMBFaa16q	19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	1407	1395	338	6301	12463	jwNyX6sb2jAhMdyKuBkNfexXzkG21nUSVhxzQfe5X4ucoY4YtG6	9761	13781	13781	1618419780000
19366	3NKtxjhKMu5jbjpvKDb3EMPPtRWXd28AkmUGsdAaEzZ4vR3QqLou	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1406	1393	339	6301	12463	jxCvzdLGaGS1WEiKKaxbxgPQCviQHfuLBKMmpNmoro97RSs8uRa	9763	13784	13784	1618420320000
19368	3NKdr5xqbkDV9ZWWbEu29RMakYY3fDTZ8wQ9mN4BK6Soj48Y9Z47	19365	3NKvQ5jcpanzsPbSAS2tmz1QS52HwA12DMc21FYLL4XvPV7uLzkX	596	1060	339	6301	12463	jw7YA9w4nhKNtkbHJVZ5X7UtdNooFd3kLnGU4KrPKik3rQq5z78	9764	13786	13786	1618420680000
19371	3NLgV5rbMbrKn8657Tbngukerca39sjipaDYDQjcgRCTeLDfbVR6	19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	1402	882	339	6301	12463	jwCGKuuJB4aZVFGKVY4VS5pXMjBgVLCyKMJpjcMJGz9UmA9aKff	9766	13788	13788	1618421040000
19376	3NLHMRw4FAX1GBbr1Y3YcEz7PmfKBSkhX4QKbRTkDQfmSSDrzBuY	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1522	1322	339	6301	12463	jwqE7gBHmpvMZUJ7y6jAGW9D8fjdrTFQoRVaJAd7SRQHnXPw3DV	9768	13790	13790	1618421400000
19388	3NKasnebhcRs9ryPPHCw9pKxWBX86kGDvamKQjNoESZek65uw9qU	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1455	1332	339	6301	12463	jwAAeo3KVdJy6gThC7XydVBnefojzK7k4Ptz4RqzJke4sFep91J	9773	13798	13798	1618422840000
19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1637	816	339	6301	12463	jwsYspv1utWuYXDtFiuZhzFZNdHJztUQn6ZsxjsoLw89i5giB8L	9773	13798	13798	1618422840000
19393	3NLoVSygy2BwwEy3YZjr4ix6BK18EWhfVQBYiSo8Ypk2NYdZeLE7	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	532	1057	339	6301	12463	jwuWDfiW3i2ugFeJpoCxHx9U5X2Bpkh27LBghRH4HVHM4rYAqnf	9774	13799	13799	1618423020000
19398	3NKx9vXRPWsaL17iCxYRj67exQ98k5Ww41d5paMVd8hzRrmbqZXp	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	1637	816	339	6301	12463	jxMVkeWn8KgBseu9vfeR7guuMujAyofztTtSDqHPuAbZsmTdxqJ	9776	13801	13801	1618423380000
19401	3NKN974iFpuQiwRQuX7LbnRDaP2DR8kv5QjQs8ma26wUtkGxfkq9	19379	3NLwa4ugD7TKDGAu3afQxyHmiL9qyNHSrKkn3GFBz7WKZfDKJnpu	641	1336	332	6301	12463	jxquJFN2ah9qpZAkhMrsPn8SQnnGQ7iFE5o8vVrpG1e9EEVGcPK	9658	13802	13802	1618423560000
19404	3NK7Z1rts51SKAYzqVPh1tGAG1vpTUtVj3t7mbmBYAA9zeaV2d1j	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	1403	824	339	6301	12463	jxhVPsj8oG5YJ5gm5bdMzW9st5w2N4Sx3vUgtwQVzKPu9rwmfru	9778	13803	13803	1618423740000
19405	3NLakZRua639s2kp3qevB9t6QY2tWzcsH92ZffzXYmGK4dqJSCuj	19403	3NLDFBRqENnzi8X6y1p3QkFaDTuzxr96nXsPkYJz4szJs9WindXj	1407	1395	339	6301	12463	jxN17eu8Y1hkaAi53ehS36qDG1yBRjqkxJuUoSfsYSx3fvpRxCy	9779	13804	13804	1618423920000
19422	3NL8nuH8uiMMLidZNyF3B65M2nEoKKnLQmSwPVP8nnJY6DXvbV7e	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	311	1061	340	6301	12463	jx75Du3EthS5uyJwXDL6YrN1euoDjv2BzrLZih5CJqHBzJNa8JQ	9788	13815	13815	1618425900000
19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	1599	1287	338	6301	12463	jwB1VxKyhQyxGJ5cQ9LGiK1imsdBJX2Sw7ieMY5gmfdQMTUN5zU	9751	13766	13766	1618417080000
19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	19344	3NKUsWYupqtHc5BV3ymCgCdrb7gSeFwnPim7bpSAJxkQhs7GTrnF	1406	1393	338	6301	12463	jxxwQJ9k1KsaFbnh9Padxg9FuDWe9vjXcq5EXmrNJ1zT3cEvRKV	9754	13770	13770	1618417800000
19352	3NKq3Tz4TwGmTzmLUPtgJU6SyMj9tB68dp2vYLLVBnC2k4u9qUfq	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1577	1081	338	6301	12463	jx4MP2YUmoweqLkCrUGzdaUTdmxBpPntW5zcnyL18iCuJnsJRfb	9757	13773	13773	1618418340000
19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	19353	3NKRL52XDxc95QcUsyK4HtgYrZf4jZProUd3Q4Ax3uaQ4CdCWZv4	1403	782	338	6301	12463	jxrTW8Ui4DDdCpERgAduF5AScQ2w8rs66FMJTxXCiL9vDMBAYuN	9758	13776	13776	1618418880000
19355	3NKQVDZcP6hci2sL111qSTGhpuMutmktDu14ho7ozLYbGtiLq5cv	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	1444	1255	338	6301	12463	jwAYmMY2SKAGjfvMu7rQAuWX9bojKVdiQ4zCToWRQy47iSeEJDN	9759	13779	13779	1618419420000
19359	3NKmGsnthhPFvKvygEVydTSX74ykcGx7uAetneNfk6zrozW8WuxL	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	606	1169	338	6301	12463	jwX8c32HWziPuM145phWkuFHJ6MvFYWbaNRkdFKnhZ411hVXhxL	9759	13779	13779	1618419420000
19364	3NKbvMLUEYXEVjzcUfWCoASdK2S2RLRcTDDMnQrZ6TUGoR4kM47Y	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1672	1285	338	6301	12463	jxh1tDPaxq8VfR7VNScComAhoZXRy5NRd6r9XazYhJuVkRyURXu	9763	13784	13784	1618420320000
19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	19367	3NKYAAFGQEAE8eHYvRaCdHwWod2uzcTaxjfQApjMKhkWrqvmA8gm	1504	113	339	6301	12463	jxVNzTEpmhr98TkFFLPjSpn4nNm42QyJ1WbxtwmjsJiNZr84mBU	9765	13787	13787	1618420860000
19379	3NLwa4ugD7TKDGAu3afQxyHmiL9qyNHSrKkn3GFBz7WKZfDKJnpu	19349	3NKc4Z54nPipK9AXKvYM9mrGSV2Q7rd45drMu7rkrrswLvvo2RP9	641	970	332	6301	12463	jwS5fikKYfespTzVkXtckQCUWgFwW4dXGDfJ6e4HaU27c9w7Wm8	9657	13790	13790	1618421400000
19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	19378	3NK52ypJvMEhJmn3E8h3qDUN7vB7TKcENW6UgCqEC84QmhGEB1TP	1646	1108	339	6301	12463	jwo11aNcVwuXV2Zw72XJKK5mmGEaQcz9LXsV3ysTZXAh4WaAYe3	9769	13791	13791	1618421580000
19383	3NLd7a5CtwAqny2YTHDddNn4CWyaYtDeDNLSiEeWWpgnzpo39J2W	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1503	1151	339	6301	12463	jwQWS9GcGxg5Twc3KhfbsfegREMnvC5AtcKxReCjm4zcFtrUkNX	9770	13792	13792	1618421760000
19389	3NKNQkG3ETB45N1NXmKEWxnY7ivd6LuEbgypByV3cBw9HdwpmhpD	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1403	786	339	6301	12463	jxnaiBzDvzE4GKLpaVf1dPxr5uDBTjMwAhTeeTNsKgs47zEiEw4	9773	13798	13798	1618422840000
19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	19392	3NKqkT8FR25ozJkAgMY7vTUbb3rMB4Pi5YQR9brsRoHPqxZSDanL	1402	874	339	6301	12463	jwxWm1LnNFpEkbwiTrqa2zDho7nuWLy3arMa51UTrL4YpzSZsBH	9775	13800	13800	1618423200000
19406	3NK9du8wpTWz9utfrXtEyPDNKNVnb9ZbBGzdMj4ibs9MANyQWJKK	19402	3NLttuDsdHP6w4rYVhsnT9EZyqPi3uVT3ZtzXsEKS8aboyv89H9L	1553	776	339	6301	12463	jw6t6hFvr3FxnAZAyV9aM62q9CaX7M8hvmqcJjXThYZxBPdcf16	9779	13804	13804	1618423920000
19408	3NL5p88e1bUwgkjHebpyw24AeKVtETkopdstCLYyVWYp8CLpEgDu	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1534	1191	331	6301	12463	jxwcDux3HJNuxLpFECRdCcm2a41KWpF6qMfYMGp82umH8cyyQLE	9627	13806	13806	1618424280000
19410	3NLF3HZzaSmcKaipQtq4Z7ZdE9dH6pMzQCyyNEQBoxbiWnTuEYXr	19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	1534	1191	339	6301	12463	jwjhtAsVXg6Jy7zcdU5v5JiPnLTUpwPJCY1EueLg381AxUgE27q	9781	13806	13806	1618424280000
19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	19412	3NLnjNNgdwxBXjfuVZXDGSvKz2saLzxbXHr6SsGGUR53mht5Wfjj	1407	1395	340	6301	12463	jxZW3VgUBL9zj4HBevcqooqDtdUjySVv11AdovnKZLzN4Va2efu	9784	13810	13810	1618425000000
19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	19416	3NLCiWNAnRJ7hCTycQvGmZwznjCHVAXjiPBBJNYxYFE8C6iaav81	1406	1393	340	6301	12463	jxspAiBGEAgMDTRXSKGeL2KWGsSgkXvBqrGugyaAp9SycWzSjpK	9787	13813	13813	1618425540000
19423	3NLai8jajeNhaWSHJiXxiNxcvEPSa1ujPBmXbNisnnMGFruhsJHT	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	1637	816	340	6301	12463	jwwkn9ByZmh8ZYw6eWNkB3RequSMQqordoEUvDsY8JGC7hkyXsm	9788	13815	13815	1618425900000
19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	19421	3NL24NZaCYxQSDx2BUfsBhePoW7hVwPae5Geavk9Xsw2MqH2b8Su	58	1281	340	6301	12463	jxfmGZZunS3s2Teeprbh5ax1pJAS8ZasU8BMSgQ7r1vJ66d5pkt	9789	13817	13817	1618426260000
19429	3NL5bwSZUFGzWk6B7LSLAS1HHPWubgauWiA7qoez2DMF2SYjoFdy	19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	1407	1395	340	6301	12463	jxjWFBtJ1oSNWaBbEsjmoRo2GkFqboVV5JK86TATpB8yrD398P3	9792	13820	13820	1618426800000
19432	3NLUu69konEJBhdjrhwuk119sJzjKEYeZFbFEKJq3efumujHFEz2	19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	1406	1393	340	6301	12463	jwAvpNxQt58HavKJYhVywo5gZqGzhjb5czQRJk5HmurXxz58RXm	9794	13823	13823	1618427340000
19435	3NKSVFHvYf49NkdcRXbp4V2cirrTdaxqQzukm8twQc6dgEJXsvrd	19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	1555	1347	340	6301	12463	jwH8rtCe1T9YFFmdaCNbfkAoD5nfYp5jchQdaXVCLGXQwK7wH1g	9795	13825	13825	1618427700000
19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	1407	1395	340	6301	12463	jwcv2zAcFDVVsZm6zrvw5fyYoQf1fkEpLC51V5APMYovYJqcioT	9796	13826	13826	1618427880000
19440	3NKbGsxogPCDp8ZjhTwWQttUpfJ2EW54Rhdjcq8gpavcawxBCiUA	19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	1419	814	340	6301	12463	jwLnSy4ER5EPKwQ8e49icVPezPifj5UdLssJZ9dQ7mHkL8SKLnr	9797	13831	13831	1618428780000
19442	3NLb9puV755qXJqWvBfzzduQb97WjFZKRiZKnKRbJTFWk5irN1Db	19441	3NKK9YVPDnQRdm7tkZU66mKrvACGZjBS8RhjUWZJpJTtY7CnCbtd	1407	1395	340	6301	12463	jx721VvFvNrKLA7SDMjGucvAbw6GTxM6y4Jvo7nFCabWg12N7C9	9799	13833	13833	1618429140000
19445	3NKZHSZBCuQZf8sdSGojfbHdXSbvsVjqojqMi8fvAXkXLNWn6jYf	19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	563	1359	340	6301	12463	jwwUfoasuXTf8Xv4VXARGbp8jjcUGcP3Hiria5VKgCCUptN5nVy	9801	13835	13835	1618429500000
19447	3NLqBbxMLawF7gi6dayGUTUAVwqWLWgChxJZufBFxv3E97PH8YYx	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1672	1285	341	6301	12463	jxqLk8YZZXDWUMXgjEDpeLw37T8J2FYcSpVSTDyvhU12gfuARPa	9802	13836	13836	1618429680000
19449	3NLb8jSkpDsBfEGQzPRABbBKTyW7y1eHckyUHZ8akX8ZqbLP7cHh	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1406	1393	341	6301	12463	jxm49eVL33yPfQTCB8zxMn87qGfoRPSBzUa56vjamsg2vHngsNC	9802	13836	13836	1618429680000
19459	3NLbSRYu9yWVvtxxWpps7UZrsuYsiWKCwkirxR6MVVZRsgWYxxiM	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1402	852	341	6301	12463	jxGjXmWYZZbrzeiYyeBE77C3npFkRiFzj6ycnzRASGJuRg79q6U	9809	13846	13846	1618431480000
19466	3NLGuZnh18g6pBfH8Sgpj5gWxjXdPxPtqsLfuRM8UrudyfUz4ipX	19464	3NKmeWqjhbUhyrq1QCMNpAzLTibZkocGzHYAo9ZB6Mn3W6tqgCag	1439	1153	341	6301	12463	jwzTrQMYMPztN8WY4RimwK8UPQ2yWz9zSGERkGBjDzbdfEXTVwk	9812	13849	13849	1618432020000
19469	3NKbeEwdQaLSw952KdM1t2Zg5J93DDUvYe6AtKuJ1B8B36TPUzJb	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1522	1322	341	6301	12463	jxbNC874ixhDip9pEn8h5Bg8PG2Eu3Dq6EAnwWSExrteZFmCLE3	9815	13854	13854	1618432920000
19385	3NLi3z4HdXwpnykL9u88vx9mHg1PG8SBYBdCnr3JnNaTwSPYX29u	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1476	1245	339	6301	12463	jxL68zw5SygZGwT2yi3qprhGxHEN1xUTSNJm4WP7UXq8FGhFHJf	9770	13792	13792	1618421760000
19392	3NKqkT8FR25ozJkAgMY7vTUbb3rMB4Pi5YQR9brsRoHPqxZSDanL	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	1589	1040	339	6301	12463	jwQouzWDMcdgMvLvgmaZyTkVB281gxbDQ5SCTtRbm9vEf7ghHgi	9774	13799	13799	1618423020000
19394	3NLUzRdzFDN87pjBLJjjEFaZLHDShJR1HjzjWcGRCmLwCoLG5KVS	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	532	1057	339	6301	12463	jxKjrP8mxdfGQ2qwFZK6xJbXFdE9f6FZKdNtJcBuu1ZG7A2CrGA	9774	13799	13799	1618423020000
19397	3NKXMLWNhWh7Bu8vGUd1Q8LGra3QhAmZQvCxzWK2KhRf4Cnnoj1o	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	632	1136	339	6301	12463	jxntHJfmT1cmrb3VJdCMkG1dchgSGiUQWz7JhWk1sif57c2pnDa	9776	13801	13801	1618423380000
19403	3NLDFBRqENnzi8X6y1p3QkFaDTuzxr96nXsPkYJz4szJs9WindXj	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	532	1057	339	6301	12463	jx2nBzu1rZ1dhuhE7zUUcTn2xFKLwaSaXzRNoedGzfdyMQFCCnz	9778	13803	13803	1618423740000
19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	19405	3NLakZRua639s2kp3qevB9t6QY2tWzcsH92ZffzXYmGK4dqJSCuj	1457	1145	339	6301	12463	jwbmPpqwD33Zf1XNbzNPFD9C9kBvxyqXorrX9vn5Ycb4H5bADu7	9780	13805	13805	1618424100000
19409	3NLxGth7KbHLpFnDxFYNsTymRsHGnC4Fit1drU1pugSKAhXFDK89	19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	1406	1393	339	6301	12463	jwcEsRd7Np2oMpkxWSY5Z9GR6pTLrMzWaLddDab9B5GQ71FkBRr	9781	13806	13806	1618424280000
19412	3NLnjNNgdwxBXjfuVZXDGSvKz2saLzxbXHr6SsGGUR53mht5Wfjj	19411	3NLRqUUFejTTfZAEYA6fAVeFP7cMv4L9QECExus9Sbqzj983fjXC	1500	1051	339	6301	12463	jxFYyFfH13Uzg4CnYDMFVGNSonEG8hnYX276PUVvahzH5SPmnxz	9783	13809	13809	1618424820000
19415	3NLTGL8apQ81vPatW69ZQywPRFhrk5PBobpVgPi2jKEbpDECA4J3	19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	576	989	340	6301	12463	jwjUtKGyN4dTugo8jtLWq9yVLj8Dxpe1Un9wHvxsTdk15oTSssG	9785	13811	13811	1618425180000
19417	3NLGVAj7Ksez1uhXm47AEDB8bZY9fejiJxi288aTJXbZaPJZsUhY	19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	1460	617	340	6301	12463	jy19a7wPnrQwNpz8Ty37UXFHCbx47bnhvUuNF7MrzUGm3y4TgdS	9786	13812	13812	1618425360000
19421	3NL24NZaCYxQSDx2BUfsBhePoW7hVwPae5Geavk9Xsw2MqH2b8Su	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	1656	1343	340	6301	12463	jxHA8NgSo6n4syQhtEjdodApTxjoyUmg47gvsroLBAxF5PqHevG	9788	13815	13815	1618425900000
19425	3NLTKDruGP8Tsud1h1TEnZDy7DMp1Rz2bhNW6wUox3Yh8yVBDL6S	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1402	1267	340	6301	12463	jwTSvHKRvkUY8FeC3iTAdouyhZ5GStuWBUHiejnmyyzKWsVMo7N	9790	13818	13818	1618426440000
19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	19429	3NL5bwSZUFGzWk6B7LSLAS1HHPWubgauWiA7qoez2DMF2SYjoFdy	1406	1393	340	6301	12463	jxXCfpArwzdgGTDJnXqopKJBph5bJgB6X21wkXQX4myqeUW3xpf	9793	13822	13822	1618427160000
19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	1522	1196	340	6301	12463	jwzcywLd61peNg7A28AFxPH8uwKFtnBAnrGEMWKaavWwdTYTXm9	9795	13825	13825	1618427700000
19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	19442	3NLb9puV755qXJqWvBfzzduQb97WjFZKRiZKnKRbJTFWk5irN1Db	1406	1393	340	6301	12463	jwh4rPfrcn3jLzGG3fhRnjP3unaZkEWVW5mowGg5VzZrP1o7BWY	9800	13834	13834	1618429320000
19448	3NLxXsQn3cFW8K4CFk1umrWvREMAP2r8WVeFFMLgqxqxqsT3t5xu	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1490	1274	341	6301	12463	jxVcGdkJ2bjJUmbiupjZtQV9ho8heuzis8iNj1CRH2TMww2dttZ	9802	13836	13836	1618429680000
19450	3NL75DTN6SMS3c3eiYAs1bE8pqC9BwYtc4RSMb298b3BqudWBKz6	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1422	1337	341	6301	12463	jxfpZT6UvFHtkZcEEnb6FvBmXS6C3qWH9d3DXWRqiJyywpNECKF	9803	13837	13837	1618429860000
19452	3NLVdVg6hTszQvK3vJf2524K1ZQsqSoU979pY9ZwvyNvKNN7oXNn	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1406	1393	341	6301	12463	jwocuStFdwDgedo92j1psQXq8QGqXs9abmjYwtAyZ8VNbY3GYEA	9803	13837	13837	1618429860000
19455	3NLqU5g8H5XYULmc5w7LLjf6eEqbqX8nC7WmwBuZc8x9Coo5FNLQ	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1617	1162	341	6301	12463	jxvc9zjZNre2zGCMPsGbhPq7wf5rcASNmDvzrvFFZQMDaoMUKZy	9806	13841	13841	1618430580000
19457	3NLsvvthi9K1RTDmCsp57WMiwVeQjwp8SHCmBKj9URpW1dbNWobH	19456	3NK9npDsxs7aRPGPrrvVW7KYvvEGRgt1iJhjsqzooFqszgMUSBET	1610	1068	341	6301	12463	jwBw5cP9qZTzqJWqADM5KxRqkSzo8U9hWhDu5ZTJCmFcFBnfLYP	9807	13842	13842	1618430760000
19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	19457	3NLsvvthi9K1RTDmCsp57WMiwVeQjwp8SHCmBKj9URpW1dbNWobH	1631	794	341	6301	12463	jxbuE9GaiUsivX8Vc9QoU1PmjcCbhTHy2G8QGpSP5eUP6Q5Fahw	9808	13845	13845	1618431300000
19460	3NL6R6wvcpwNkPfojURsaF7DjU6AFMGCejhg265REkGkoaqgZPPY	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1403	824	341	6301	12463	jwexFutQ9WrX8w3RSPbojG34iJcibZ3y5s31f255qymtcHz8N2a	9809	13846	13846	1618431480000
19463	3NLs91D8fjFjhjtj2oHgvAT4jhYrVac9Vi4Sv9YtzC5mRPDomN3g	19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	1406	1393	341	6301	12463	jwiDKqKkoGy3nxfHGcR1nwT3pXbiQmWgff3BdmRLLAyWHDexunr	9810	13847	13847	1618431660000
19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	19467	3NLBGbdM5KBbc1uEnbzVPqUVZBLspACJAGrHUKeqrtydDGgAV5C9	1403	824	341	6301	12463	jwBwnKkqEQDoJyw1c86rscmaYNhnAP2zmsR6hbwrT4dbQCARVsD	9814	13853	13853	1618432740000
19475	3NKaTxtBKT3cBhbQVaguQXUzkAwJY1qKW7QVF5mwpLkAwThQwQ1f	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1444	1135	341	6301	12463	jxBa13EX2zi8xvTsddhWwcefGwEJLZpczG5DRJ2MMJhUvcqXSPv	9819	13858	13858	1618433640000
19480	3NLn1ijVaXUWPSeJYkLjBJjR3S6SXK2aMGp4Y4QV8GHj6w7iRaQo	19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	1403	824	342	6301	12463	jwkdcMEZ6aVvKNfTSSJi5MB1nhZZwKQ2Dn7XfAU6krL7WddVpE6	9821	13861	13861	1618434180000
19483	3NKLgtGppipzxp1sBbyLttFX8GAKeiEUACycCvjVA3mrF47SLo1u	19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	1549	1362	342	6301	12463	jxZSf5abL3pZ6oD5Yv8dHjzVCGiuTUa4JYeswxiGJ25JEBJ3U4n	9821	13861	13861	1618434180000
19484	3NKrgpgcdES8pF5YbTxsaNxWCPHu3eCPiF5VpxvYsV5WkMNzSFzQ	19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	1406	1393	342	6301	12463	jwxkKYetqFJcKQZREUo4yxcjaGJQ6mV5wMHjAxBheAqzNnr3fd6	9822	13862	13862	1618434360000
19487	3NLxLP1p7W9DGGqQvsfPervNx6jUiLqANJ9Nmd5D8EMxXvHQiezF	19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	1403	824	342	6301	12463	jwQZBVxMtTU6RJ4p6gDx7Vms5HdkSknAWZK4jr2SJk1xwyTfsAR	9823	13863	13863	1618434540000
19489	3NLdMZGpfAhUu8D1tnczp6CaB13mN4P57kWj6tyJJTsKyMhM5pF4	19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	484	953	342	6301	12463	jwB2hn825ZsXwdXKnpGwE2hdJ1qbKbS8h5fnp7D5SSN2BBtWR6d	9824	13864	13864	1618434720000
19491	3NLQK4eNVtEtzJWwFx71qjtBhDy5WEd4MfoyCsi1rjKi1ig6G11y	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1460	595	342	6301	12463	jxWWHJuK5oqWcDgCJ4zgkf5msdAmB4S1darqgGG2GrazhV1zc9T	9825	13865	13865	1618434900000
19496	3NKTpwoVzHJzc78uzSgLdVCnwrWgHXWxqRX9XCPijDvbWPhLUgCm	19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	1547	1252	342	6301	12463	jxmzDcLKJHKWpW5HGGc5zEwupdaoWoQF3ccxZyuv6umcqdb1pZU	9828	13870	13870	1618435800000
19411	3NLRqUUFejTTfZAEYA6fAVeFP7cMv4L9QECExus9Sbqzj983fjXC	19409	3NLxGth7KbHLpFnDxFYNsTymRsHGnC4Fit1drU1pugSKAhXFDK89	1406	1393	339	6301	12463	jwb1Mn9gR4UFUvVEfciyTxrvdD7cHi5Ea1afk2GXdme2ESep2yQ	9782	13808	13808	1618424640000
19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	1403	824	340	6301	12463	jx4CF9ZBH53qArXMQzxZUGikmXQE1aKLtsfjAQTrm8pg9RkRXqM	9785	13811	13811	1618425180000
19416	3NLCiWNAnRJ7hCTycQvGmZwznjCHVAXjiPBBJNYxYFE8C6iaav81	19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	1407	1395	340	6301	12463	jwxR6X322pwxMbBd4MS1yntw6aTUS5DH3oCGwxrYBKKJTRkZwMc	9786	13812	13812	1618425360000
19419	3NLYFoUuEEsjTqrUFgfhjbSRPyzwtzhY87vVc4JpbFfddN1Vwnvo	19121	3NLAebd1kg4K6RTbb8nZaCvmNhpVR7AVoqKkcT3tmAUWdGogLTfS	311	1061	328	6301	12463	jxpGTxuSoGLh1UKVdwXktshZ96jHM3xE9tK3fW8vgeLu8mBEnRA	9550	13815	13815	1618425900000
19420	3NLBsU7bsEsEQAmFfh7yR1Cx2VZqmAmmPrY97Nb8Tk9NsmVYaK7u	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	311	1061	340	6301	12463	jxi4nwydp3QMkNQq9ry7gtorZzHoEpqUGkCwA46E7RHK48mVewF	9788	13815	13815	1618425900000
19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	19426	3NLxv6k5y2xwMyQ5pfjtRBEbXJ8Xmhw77WpFrtXGKbmvKNBmec7C	1671	1365	340	6301	12463	jxLq6GVVuB7tsY6UFLowyJZCnbVWv1aqvavgBcfGUmEJE9QE3S7	9791	13819	13819	1618426620000
19437	3NKVQmeatzeLCLK6C9BHskqjE7LQwLLBWSrc7euHig3dzEENejDj	19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	1406	1393	340	6301	12463	jwF9TyungprF8NNw9SQpXtn3BjHZev1zmwqgiwLqMnY4gG7DQUK	9796	13826	13826	1618427880000
19438	3NLJH5vwPNhZUwdEJFmx7xMgAvhq3M8kDrtaPqCR1K4f6KuuzMNL	19256	3NLm3oNU4VMu6xrmi5958tb3dmeBimKTT2saKMjDGTQ1nMGKTLvS	1461	1271	330	6301	12463	jwzn6CYrBg9r5ACdFFLGqAgJkow7dCJ6VxFuVHDzR4nBsbsJ1tB	9605	13831	13831	1618428780000
19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	19453	3NLexGnr5EN6M3wkrNfoZYhJcm7dW4gXcsp957Pg6B584Sgpujgd	1627	1259	341	6301	12463	jxvrWK3npMur8gth9Wtyw8ciENd1PAdrrnZRhrjW9MMBrun3e6Y	9805	13840	13840	1618430400000
19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	1407	1395	341	6301	12463	jwyYEQfCw3tzLWa3eaE3zg6AzC2cnhoMDipfEMb1NDdiVKGR3Sy	9810	13847	13847	1618431660000
19464	3NKmeWqjhbUhyrq1QCMNpAzLTibZkocGzHYAo9ZB6Mn3W6tqgCag	19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	1564	1338	341	6301	12463	jxWQUNnBsifjkvh7GxviWbJbuQWmdDbX7Rhz7Amwokw3DoV7DwK	9811	13848	13848	1618431840000
19467	3NLBGbdM5KBbc1uEnbzVPqUVZBLspACJAGrHUKeqrtydDGgAV5C9	19466	3NLGuZnh18g6pBfH8Sgpj5gWxjXdPxPtqsLfuRM8UrudyfUz4ipX	1617	1162	341	6301	12463	jxDiZ7fY2M6jB47XHGtSuSsuLY9w7E8BL2sLqZwMm2QxrchWNxG	9813	13852	13852	1618432560000
19470	3NLUrbieswXmAoHsqoYBK2soczUMMEbRyE9jKz2TgLBQ4FHntdQN	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1522	1322	341	6301	12463	jwupxRP4aNCpxms3mBSkfRhrXAgaZr9U81J9t449vo4oVmzRxWe	9815	13854	13854	1618432920000
19472	3NLin9VgN4Xo4tRsfccnGhsH3H5hjbNNerZCkn7XebNMTuRWjVcQ	19471	3NKZu22pVT48X3iBVhESeoqtcmqRG2ZcMgcFUgfwmJedsJGAUpPC	1564	1338	341	6301	12463	jwH6ne52dLq2QCoQ2wCvywNN18gJn98cKXTta2Bputgrejhv7Gv	9816	13855	13855	1618433100000
19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	1581	778	341	6301	12463	jxyXrgzu5e2xSFdk22P69bEVCbFsbsDBZwsVbRay7EZkrEYY11T	9820	13860	13860	1618434000000
19482	3NKcRonfeLRf2LEcd5Mudt7JBrQ4bP5UiugojKEN7hoZQsqXhrs5	19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	1549	1362	342	6301	12463	jxfXWBTzBhU9pc6wo31tsN34RtbBDfkKqSutU9JdCYnAzBNRghj	9821	13861	13861	1618434180000
19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	1406	1393	342	6301	12463	jxk8TasZh26SPUakqnNAx77NCF4jxFUw5rHVxXkqTsV7Misgbdz	9823	13863	13863	1618434540000
19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	1668	1004	342	6301	12463	jwkq4hRRDaJbtEdLtjPd8tu83oJXadCW5XRgTGqC7j8r3DKktsq	9824	13864	13864	1618434720000
19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	19496	3NKTpwoVzHJzc78uzSgLdVCnwrWgHXWxqRX9XCPijDvbWPhLUgCm	1578	1170	342	6301	12463	jw6ziyxwFZyuayJCQMBwuBLt7fyWRfKmy7fv1oU1WWdCiPEf5FG	9829	13871	13871	1618435980000
19501	3NLtCXZRQroZxLJ61xRGyHr1YPvMSDRc2n8kyBvw8Zwi4icD9ZVf	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jxknJa4FkcaV3odqKYRANywvMMFH3NTSfhUfzRN3hR8a6DzVzEA	9830	13872	13872	1618436160000
19505	3NKS4ytv7zisE49ab3WJASWMUimSXEd37HXcALZfcVmbA6BxNDJE	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1402	874	342	6301	12463	jxgFzcWQJs2hG4Ba7bwB7FEAkJpEc8w7pP9p6YZi8nwa2yhiqX4	9831	13874	13874	1618436520000
19510	3NLj7jMR3uJSneW9rj8t66KRCu4tUEyztsCAYZUprV9yMY3wUupm	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1594	1326	342	6301	12463	jwJkffM9ZpPT9cU5xgvwFn8Rmf8gAX8LC5wunZKSHeibZPe8QTi	9832	13875	13875	1618436700000
19513	3NKHS1xLxwqrgvtgTM9MxN7GokiiARXEn5r6xwZ3kJdbGLwyqkoR	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1631	794	342	6301	12463	jwoM7LZN2fquQvthx7FBdQfqmmHuMr6TCCyk8REF3k1u1TyRTxE	9832	13875	13875	1618436700000
19518	3NKyfpVgV2yD3CKpWi54k8yHbjUmZbQ6cfTPMLUHgd6kgevvAdjW	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1445	1164	341	6301	12463	jx1eW56C33DoWmSHGDa1ovP43dXdmMAkbWYGV42RwE8o4vcLdEY	9806	13879	13879	1618437420000
19521	3NKtMRkrcQtxsCXhm1Z7z3sQdBVpTVsCvsAqQPhyxH8SPGQtzuyc	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1547	1378	342	6301	12463	jxgaR51XBgkQay1t8K2V7h5bPWzTdnDcakY94vabnNf9w76CA4w	9835	13879	13879	1618437420000
19522	3NKCHd1zRwBtZqhgbkaP5idsne5tC6Hv8UnX1UrcKvLoty3wUkot	19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	1402	850	342	6301	12463	jwr3dQmkgVVXhuLdGp5HAsNXGHTzQaRbjbhsYFv5gmysekFPuz1	9836	13880	13880	1618437600000
19531	3NLK43HTzCYsUoCKMQmww93hwAabu1V3Pikqt4YXntBQhadn29fN	19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	1642	1367	342	6301	12463	jxS3PVTsQZFLffWZkMFdRrFJEiMzfaw9HR1vubUyoHc4P25nB5k	9839	13883	13883	1618438140000
19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	369	1066	342	6301	12463	jweMNidFAQFFmYDQWKsUypXbE63EHkEt1Xdgno3zqL953tL9pbC	9841	13886	13886	1618438680000
19536	3NKWFhkQzUJmNKXFPqLA1DsuWBtkJwKRHhFVh7p3fzM4Bd3bmUuS	19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	1546	1213	343	6301	12463	jxvgoL6GMvQFYREnyjvDNHdmDfpAKH9XxV9sVmbvkvW8WmW1zPu	9842	13887	13887	1618438860000
19541	3NL8hnyJBkPK3bTLL2i1soDF9pavN2aor1QX1CKZ8VaKHMUoVEGj	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1406	1393	343	6301	12463	jwR7Hu25b6Qg5qUmNrTxBR6S7PUJcxVD8RE3BAmxbhjud9c5WUU	9843	13888	13888	1618439040000
19543	3NKiY8iQPBjbmfZhZA5c2Z8kaq3gzWHfTZHMA6zFX83WKe84CZ8X	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1672	1285	343	6301	12463	jx6Zeyv7UsDTNiNpigh9y8hJ2XgwEAksB7Cw1GFmPBTZxxJVNgo	9845	13892	13892	1618439760000
19546	3NKp2ExVjX6MYzSHCUHMHDPK5vFNXxGRG37MyhH7HxWwbFK1Mgkm	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	171	1374	343	6301	12463	jxXwPnU7moZbbsnURRssV7HguC5PmgcmoDcAGMq35H4GvLmFQNC	9845	13892	13892	1618439760000
19426	3NLxv6k5y2xwMyQ5pfjtRBEbXJ8Xmhw77WpFrtXGKbmvKNBmec7C	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1581	778	340	6301	12463	jxgDHdSBgmrPaD4kyAS7k55GUadyK3wVJneLV8DtxM9yc6ASGRL	9790	13818	13818	1618426440000
19428	3NLpbZeLnYcDmMC7QsEjcGrWAsRnr1pfhcDSNurqe23m4zQ4TrL3	19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	1619	1275	340	6301	12463	jxpRoUE9bKCg7NoccYJBJapqWqRT8XShvYimWsycurmjqiiD45G	9792	13820	13820	1618426800000
19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	1599	1287	340	6301	12463	jxGRB3n5iLSKjBm9Xhz8yuxJeL82HcnpRgErJX4R4D4VrMmpcif	9794	13823	13823	1618427340000
19434	3NK47K2cSTbNYRfNfuXbJyzcKPod7bSLBKtkkQBJtxqF6QsLSHB3	19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	1555	1347	333	6301	12463	jwYqKskPnk4DCMnRBkKiy2JyHqaufXT8hTZceHrxk8j2grjo9qo	9674	13825	13825	1618427700000
19439	3NKYDhoXqrut7pUDRhDx4pGcXnnBHRyhwQJbfyooXkwCPLtQ9oAJ	19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	1476	1005	340	6301	12463	jxwa5EVWvKxmHwaXJRA9Sd3dSK5DDwQGrJ9gmyssJK6CQk9cqez	9797	13831	13831	1618428780000
19441	3NKK9YVPDnQRdm7tkZU66mKrvACGZjBS8RhjUWZJpJTtY7CnCbtd	19440	3NKbGsxogPCDp8ZjhTwWQttUpfJ2EW54Rhdjcq8gpavcawxBCiUA	1509	954	340	6301	12463	jwLYisyGUCB6oByRBfsHfqH3KUrAvGJvdiYoWVcoMUgzvMvnh5a	9798	13832	13832	1618428960000
19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	1672	1285	340	6301	12463	jxa8rNEpLNMfqh7fv5a9LrJYxpHrb9a8CwHbWdqPfVw68cWYhhP	9801	13835	13835	1618429500000
19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1490	1274	340	6301	12463	jwpCPnnj4XX64KLjpDzg8p55Z3MLtR3apWvU4kyXoLk4iLTMBKq	9802	13836	13836	1618429680000
19451	3NKRgehzVevmU6jsGrCBZUAUB4KXrAyXK2wPr2n1xEPW5EDhMono	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1422	1337	341	6301	12463	jwQQ7z6Hpiz93jJDAjkG2YvYboLCUE1SsfKZ78nSCC1WRzbpEdW	9803	13837	13837	1618429860000
19453	3NLexGnr5EN6M3wkrNfoZYhJcm7dW4gXcsp957Pg6B584Sgpujgd	19451	3NKRgehzVevmU6jsGrCBZUAUB4KXrAyXK2wPr2n1xEPW5EDhMono	1406	1393	341	6301	12463	jwPhiLPqr8h8njUay1P1UQKodKBwKbHq7qjgiKzhQ5kJoyHkHkm	9804	13839	13839	1618430220000
19456	3NK9npDsxs7aRPGPrrvVW7KYvvEGRgt1iJhjsqzooFqszgMUSBET	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1406	1393	341	6301	12463	jxZk7h5cn8BVdsv2mwa3GnVyCBQbQUzwoeADeYiaN5p1EVG7VGg	9806	13841	13841	1618430580000
19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1651	1301	341	6301	12463	jxsxpbaFP3u1cmcLQjPLnWXtrnqRnLDspRwLKia8ZsKJZN9i1zb	9809	13846	13846	1618431480000
19465	3NKe5QAV9P4CaQ3kpFDZyDTUKpJhYyyx8zB9KBuacZJA5d8gbCeg	19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	1631	794	341	6301	12463	jwR93K1ddJKoEVrJ7dvZhvFkWA8R3dxv9CrmHLqcy31oBxQ1dDG	9811	13848	13848	1618431840000
19471	3NKZu22pVT48X3iBVhESeoqtcmqRG2ZcMgcFUgfwmJedsJGAUpPC	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1402	906	341	6301	12463	jxWnh8RnW2PQU9uyp6zu323ebbJJrs1BK6YffquhaHKXgtHjjZW	9815	13854	13854	1618432920000
19473	3NKT95FX2PC4WamH1Du9yraqaC7mEzHL7nKcatwq2AkZb3QC1GQF	19472	3NLin9VgN4Xo4tRsfccnGhsH3H5hjbNNerZCkn7XebNMTuRWjVcQ	1547	1012	341	6301	12463	jx6zqpRS2gctMmX6MG35uwao2CR7xH3eYa6W8so1mQtXxDcjZv3	9817	13856	13856	1618433280000
19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1444	1135	341	6301	12463	jx5Utk1ZcYXHodB1Nevew5DX5L622JxKV6x5nmcDJ9rm5yUFTYj	9819	13858	13858	1618433640000
19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	1419	814	341	6301	12463	jwPFyrpnL78PJpgEEaXzwfvhwbpoCh3i88WEJV45KxQnYPR2awN	9820	13860	13860	1618434000000
19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	1647	936	342	6301	12463	jxBC1kAbwX4U38QCvkiayyHviu7MwWbNvrq6rEkwC5EraPLtrXV	9821	13861	13861	1618434180000
19492	3NL6qNivAHceQx2VGdm6fY8veBSx8B3AgnR4XfFj3CUDYiPKJrYD	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1481	790	342	6301	12463	jx9UEC9Szb9itspw7XcPPSzWuCsBUpU8K89pbt3Sia4fUn1NYiD	9825	13865	13865	1618434900000
19497	3NKUwNn9ZdPkYbfHsg8aW7WRUU2NT9toDg9b9bT9aZ7atRNZhULU	19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	152	1204	342	6301	12463	jwCfFwjGLFBgb1CDbsRENe5Ke5jKPDo7qcYeAVbyUYf6iRBWzdo	9828	13870	13870	1618435800000
19499	3NLufnompj13qsuRRtuYYekv8zCiGuuwb2C5755vvzsS8NjuJEqo	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jwkMbK8eos5i436pAiVGF36PkUPUf4oumAMhzEo6f2UCvVeRPCN	9830	13872	13872	1618436160000
19503	3NKJSf9qjSizcp4Ai1N2zHMX4C9poeqHEPGWUC8JVn2Dm4fQuni1	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1600	50	342	6301	12463	jxYa9oi5Tkou2r21VsPpfb19t6aUfzm8JUhEPjKN5sx27mToQhM	9830	13872	13872	1618436160000
19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1637	816	342	6301	12463	jxXDXxjVefuS1ZYWYadjRXFqK11fjzFnsXGzxJ8dRgj6qn2Gvnb	9831	13874	13874	1618436520000
19508	3NKWXwgVL91KwDRb3hh6yS4Nw4bFJaGhh7bnT19FWEgF6VcXwXHC	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1422	1211	342	6301	12463	jxsRMFVJ1HQmxBvZxQzKFXFdjkwGd3coJC1M2goyZdhmk5pkCis	9832	13875	13875	1618436700000
19514	3NL7yMVTNjJfzwXyNdNtLTanSP4kxwXL2PmggUzMNzjTyg8szNYU	19513	3NKHS1xLxwqrgvtgTM9MxN7GokiiARXEn5r6xwZ3kJdbGLwyqkoR	1402	850	342	6301	12463	jy1TzfwdyVi1wNVY1BV1RKp1gmB8MSzuS4fo3qCB5YjqkvUVFYU	9833	13876	13876	1618436880000
19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	1581	778	342	6301	12463	jx5WBiWL4fLmzN1qgUZgiTNkiPnfgHMST37L18FSDUuZk5QsqE1	9834	13878	13878	1618437240000
19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1445	1164	342	6301	12463	jw96hPz82PMBroCVCtPACz1RkkFNjKRMyzittrhNNgVfawzHP5m	9835	13879	13879	1618437420000
19526	3NKS8ka1tk1A5RXFZcWNZQ8PY1xk1hqhHA2ikHwUPLZHc6ukCcBg	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1541	1298	342	6301	12463	jwU4Wgr4szRi9eJpUJhnmWko1RhqrQeeRBsEX8854qhXusYQRXZ	9837	13881	13881	1618437780000
19528	3NK9dFZ57Mgan3S7viR5nBCmyDsSmBBQCpTW3brCWxAgz5jYGEFb	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jwjikqLuUgpXXxE6UN6b1NtXZv3jxPUNkBPXhJ2PsAihJRkpMfu	9838	13882	13882	1618437960000
19535	3NKVKVqEuby3bK9hvatxJVozBXQTUsujrrvKRF2v2a8hrzWpaZwu	19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	1546	1213	342	6301	12463	jw9LnHzyreQSp5UaeSFiuk1wUxr7aqNPRVmjvvAuM5o7VngVZRC	9839	13887	13887	1618438860000
19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	1406	1393	343	6301	12463	jx23PQJzj2Cb316dtY2bLYV5qHL5KYgG2wabHkBxmsQg6FyQ2tp	9842	13887	13887	1618438860000
19539	3NKF2h6tGT3VZbwipa5362aAN5yAqSPDj25AeaQh5ARzvSh6vZzN	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1672	1285	343	6301	12463	jxF6a6ua6zPEnKN5avfgK8j7GdtxcRJfshc4ZoFGkpeqBqrPkQZ	9843	13888	13888	1618439040000
19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	19473	3NKT95FX2PC4WamH1Du9yraqaC7mEzHL7nKcatwq2AkZb3QC1GQF	1489	1134	341	6301	12463	jxgAMgtM5WnCEv9f9Q29axj8Jt56Sxe6Lq56WyE3dBD3FhkmVnR	9818	13857	13857	1618433460000
19477	3NLBavwMnYR42pgsDPmLZJDr5Cm7zd9LmE3kCBnAG4sQV5AYySDS	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1406	1393	341	6301	12463	jxUxNTZHfV6LidEF1b4SniGuxypmikKijssXiM1NBbtKd6f19xd	9819	13858	13858	1618433640000
19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	337	337	342	6301	12463	jwQH1ypmtsCz2KgH6j9H3vwM4zgQqmwAznUTs8hLrxcSH2AhfVy	9822	13862	13862	1618434360000
19490	3NKXNEcTCrB6bN9buvvwHTEGUiXEaB2agy7fgEJzsLtSCPErrQ5G	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1460	595	342	6301	12463	jwRZBLwfeqnEyd66RYfBZhmrSmmhwJeDWFUvRExnWUiBxEUpWkv	9825	13865	13865	1618434900000
19493	3NLCzJ52QhFaZmrZq7DBGJEuBVZhDr6MKGdoBdUNXX4hRSUejiEC	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1457	1391	342	6301	12463	jwue7Bn2aCWf3TYyPNHknykXw3o8HzjpnfLhDbJyokQjo5XGTuR	9825	13865	13865	1618434900000
19494	3NKjYsu8ofGEf7ydJhRnKyws2MWLzs5JAFj4ovPzAc5kYaqVd99q	19492	3NL6qNivAHceQx2VGdm6fY8veBSx8B3AgnR4XfFj3CUDYiPKJrYD	1579	291	342	6301	12463	jxaKSdainjEs7W5HiG7ZrEw135a4qZ4NGuyS45U9xWzsTwcZWkH	9826	13866	13866	1618435080000
19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	19494	3NKjYsu8ofGEf7ydJhRnKyws2MWLzs5JAFj4ovPzAc5kYaqVd99q	1637	815	342	6301	12463	jxpHcX4513qnbpzUtE9Lbqxezk2XMncivsEbHznCRTkANeMkjBK	9827	13869	13869	1618435620000
19500	3NL9nQBZrAGgzmugq3z2Z9moHiNsuYjrk7C2ALPtpUFxm4tXAYWt	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jwtciUbGtdU5ovVNWjzgdb8nn119pQ7WEEF9sHF4s7os33e9y5y	9830	13872	13872	1618436160000
19504	3NLQHHtkP81JV72PyvNzjgKMApSfhg5exbEDiWb2XcB9YmMfaZvz	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1509	1194	342	6301	12463	jxHT2QVwKgAo12xh3u8wnFViBJVBFcCyHejvngcdqfyqxFXK8Q1	9831	13874	13874	1618436520000
19509	3NL9YzLFgijyXnQy1STNgLj8m9GTqZmv6GajjCNjhf29ryRgHDgH	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1610	1068	342	6301	12463	jwNtAj9JByK9dS7eE35nzyCXbWtyuMUcKK5jo2fQg7cj689Ak79	9832	13875	13875	1618436700000
19512	3NKizJvMEtVJu9HuokrRGoGdhcBU16z9fGb63mZwyYz8hmkteZVV	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	641	1090	342	6301	12463	jxtNAwscz32o9SgVHjvuPBPv4AonQsrckP7agASwBsR6FTJi4wE	9832	13875	13875	1618436700000
19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	19509	3NL9YzLFgijyXnQy1STNgLj8m9GTqZmv6GajjCNjhf29ryRgHDgH	1403	812	342	6301	12463	jwASfBmR9Amy5YGBnni8xAwhRvebi9BmrazYefvs3sLmt4YaR7M	9833	13877	13877	1618437060000
19520	3NKGgAMggKs3Jv7c84WN7NADCr2yhyvHUcMtFHi5heC7u5UoSGso	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1406	1393	342	6301	12463	jxY7Cb22XiJDbuKj6KWJGPuPT6Uy9UoFPHdG1WViL5rkq4W22Do	9835	13879	13879	1618437420000
19524	3NL6gstE1swLr68iaQ9XSHwJL1TTheXmrZqVQcA5AaCEi26FUUjk	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1622	1356	342	6301	12463	jwLHTSKdjjkdQqZ3gqFaHCHwj6jJW6SwfsLT6Vk8C5MWgKAarNM	9837	13881	13881	1618437780000
19529	3NLLch361hGkyoWkCz3Bhd6kGwkbVQAufi4v2hjKRpLPRVrVyyLq	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jxRNHcjbibjrNoucJpcVJ14jHZL7NEwgyxRffgf9Ydm7xeRrzkE	9838	13882	13882	1618437960000
19533	3NKKTtP5db9M1Q9zqQX2YmAaw8hr9yFf2nrHB62YavUnccGSrwbT	19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	1634	1085	342	6301	12463	jxNhY2cu11gy7gQHwyG84i8sTTjTKy9WLtmgrNqNdQKrPTrjZk3	9841	13886	13886	1618438680000
19538	3NLrd3HrdaWTLXRiF3oKKL4LRZGkkye6Qtc9UrqrgPLByBijymC4	19514	3NL7yMVTNjJfzwXyNdNtLTanSP4kxwXL2PmggUzMNzjTyg8szNYU	1546	1213	342	6301	12463	jx2TRb6PXdn69RWyn9rHD3A1jpHmaLMbWVKDuzWEksLaxSCBZsN	9834	13887	13887	1618438860000
19540	3NKDFzngMfqKrzjhnhzRxNMUxR5dGwQwpMNvPy5pRahe1gGVWc9R	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1672	1285	343	6301	12463	jwkUhZc5q5KKu6xBzzmmXY4qFEUcZF7v5MhKXHZdqRHYRSqrtam	9843	13888	13888	1618439040000
19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	19539	3NKF2h6tGT3VZbwipa5362aAN5yAqSPDj25AeaQh5ARzvSh6vZzN	1406	1393	343	6301	12463	jw9oBFVpXxKPjUs6xQP7CU6637LBWPGkaH1gGjEaZQtX2VShUH4	9844	13889	13889	1618439220000
19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1403	824	343	6301	12463	jwTTtaVhujtPsVoXhqfPkvNCEXHwRU44dNiEBwGUJm9z8kWnz6K	9845	13892	13892	1618439760000
19547	3NLsTzrWibkpG1mqdM7s5Q6Ny2MuHm9D31MCr8XgJSocA6A8uJmf	19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	58	915	343	6301	12463	jwG4dSUjVBWQ3imiReVawmxU6TnBgRsdizqnf7johnUyxSMpsGr	9846	13893	13893	1618439940000
19550	3NLw94pmBWRFkzwG9a4HZbZTxXVUsRUW1AuPqwxroWHhNmg5JDiS	19548	3NKAE4VXDysEnkCt2RB7exYfwTGLCtvuUGjUGTMuza8PVCWyLRX8	1447	979	343	6301	12463	jwqyvrY6CkcT1SoE6NAL9BdTs4Epe5E4ATf47ecSzx1cSRTaHU6	9847	13895	13895	1618440300000
19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	19563	3NKTTRL2nvsVMKLmmbK9e1FGKMt8QoDsHgpD6WXiBvVFXyUEbgvb	1406	1393	343	6301	12463	jwUTczFNLTYa2CSgqX5cNvxYQXWtQi8EGHd3jCZq1cJt3goooT5	9855	13904	13904	1618441920000
19571	3NKkRL53zhno7776QPViEysu2j1hS79ZKS1xa7FuQ8J7qNYdGi7f	19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	1642	1121	343	6301	12463	jxQZJBbYnxSKcksZCidohD9bKUwvtnioHJSLcD7PtNRUWfY6ko2	9858	13907	13907	1618442460000
19573	3NKMZnmEKnyjxVXuzPVy46n6XQZy6eGa4bsYvzKt6fLLSULuTRkJ	19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	1457	1391	343	6301	12463	jxMEAcaegt7UuvTEvGNDtYAHKtCKuwASkCbGtS4Mccstz1xUrL1	9858	13907	13907	1618442460000
19575	3NLdoM9B55t1fTKvBh6cT1yarhuwcM2rvydsy7W23qdWmpyuM4Ki	19574	3NKQqpbvtgo1jVzwirtjXFw5wfeztrXsAJLuE7ZCba6SvEvEKgGY	1652	1315	343	6301	12463	jxt2KzWofG7sZcqa17zGUd3EX5jCh35mF9fzUBav1pK9E6QbGzN	9859	13908	13908	1618442640000
19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	19577	3NLKP69KXcqH4GxDmnpaGVxJ5cFexWfij2qaWtCWTeaYUBHzMFqp	1439	1153	343	6301	12463	jxESq4UjAWNYchbZEbEJrfefhE5Ygk7Pso8jt18tAQSUoVPE7ZD	9862	13912	13912	1618443360000
19583	3NKHoTBhXkkpAg71Y4DAm2wwfoPkQsgE5B1m89szTPrRacZcUaoF	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1627	1139	344	6301	12463	jwTJeGQytAvkPZ7k69cqCA6mMZCs4RiMsmPvxKPhq2G96bauxvm	9865	13915	13915	1618443900000
19588	3NLSKgfjDDCehabSPpeLVqRtvL82DY1exSHPwkPjqZUxooJgbzmY	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	1406	1393	344	6301	12463	jxNHaAvtrivWpkq7PVeK8xEqx2fyN7fB7ab9qTTHWW5QSo7Fxkf	9866	13916	13916	1618444080000
19592	3NKgjzDvzGt6MM5Dcc3sjn6EPd1WBg12dU4f7kivFG8TbmbXXD7d	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	641	1090	344	6301	12463	jwWPhtdEKrPaC4rDQKA6pjZQUkSUDNLj2j2DSQJdo5VAHeMU8Ec	9867	13917	13917	1618444260000
19594	3NK8c9Ni13V2dgmduWrmSgfpzxZC5BMaw7yidFREn53tDzsjFA9j	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	1623	830	344	6301	12463	jwxg1LSr58Qq3LkQbVazoJmFKbcSQ6Gg5QGJHCsYfFzQSnT1cA7	9867	13917	13917	1618444260000
19596	3NLeeHSbbC26K4qVcGDBTeAen2L2JmwsXDH7jq1QhVrnfucjgNrk	19595	3NKZcderv3iVE9odGxEz1ui3eahNXJ3F8eyx1B5V4SbXM8rDsFh9	1600	1006	344	6301	12463	jxbrF3gfgcD9k6sNC9AQMuQEeicVUGoQvq4Zw8cFpYaaGZ3firr	9869	13919	13919	1618444620000
19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1407	1395	342	6301	12463	jxYhyfSqEv6pzauomvbJ6WVfasytHeshbzCv8zbzXQESGtTFWmu	9830	13872	13872	1618436160000
19506	3NKDnAY2pxAmYoihNLg34pPXg9wYe94iLeXTGphEED3RqsBvcNwz	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1549	1236	342	6301	12463	jwFvqeUUReBa771UH4rFw38h1vMtGmpZb7PTYXdCFqzWJx9RLLB	9831	13874	13874	1618436520000
19511	3NKdYGQZ7ietNdTSgV6hN9ZpiTBMRUv7Bt2WRfWRKPSawPRjpkL3	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	448	939	342	6301	12463	jwGXLwERjBj3ESbdXs6KbjibegMPJ6MKDMMXvtmYG953oztZoR7	9832	13875	13875	1618436700000
19516	3NLEF4g2P66wm4fnKLLfusFttohCSNyBghPUJDSV11d7KDb32WgH	19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	1406	1393	342	6301	12463	jxBCdwZiUGKDN17d11nCm5rraPJePVsMjMF5s538xwwjzjd3njg	9834	13878	13878	1618437240000
19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	1406	1393	342	6301	12463	jxZepysqKYcWKaJgnVHtn8rUuvsJ99pHPf9Nacd1ykmiXULz3S6	9836	13880	13880	1618437600000
19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1622	1356	342	6301	12463	jwA2ioDH1J2BXaavWPDPTKEdUWNuwfovacAPJjcVieJS37cKvCf	9837	13881	13881	1618437780000
19527	3NK8b7HGQ8obpr4PSWpTc5oftfpeKrKHWwq8XDVcHv4UeEvAK9rk	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jwL8k3SaTtNJ4Wj7STvVs1gv5uBGAXcsrLZcswQew4AuD2JEStV	9838	13882	13882	1618437960000
19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1403	785	342	6301	12463	jwEbW98NPJuJGZXztT75wrRVfubwxrFbzn87DpfpFDfn9s9CfWG	9838	13882	13882	1618437960000
19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	19531	3NLK43HTzCYsUoCKMQmww93hwAabu1V3Pikqt4YXntBQhadn29fN	1647	1302	342	6301	12463	jx7fQ2qpgALT1FNHYLNUHwxwpD2Ywt6944zN6VET6qgnX8cbANa	9840	13885	13885	1618438500000
19544	3NKu98Y6NNiBGH1LAp9Ke3FSLDr27jhA8TE4J1Rgf3rern8i9ztb	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1672	1285	343	6301	12463	jwpJmMKpQE8t8FgLm3z8boRA5FQSLVqNWK5XCiLQdvYNTzaRZnT	9845	13892	13892	1618439760000
19548	3NKAE4VXDysEnkCt2RB7exYfwTGLCtvuUGjUGTMuza8PVCWyLRX8	19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	1553	776	343	6301	12463	jwTcd4KggaSZeYyYc26gWsuBhkYWYEARE6PE5q5LQuKbppS8ERD	9846	13893	13893	1618439940000
19551	3NLaz5h2vUx9ZWU4WToDMTuhWck1oKNm5ctuURHMP4hF2LXajo3d	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1483	438	333	6301	12463	jxMMUndLr5wdcPNoKCnUz8Ytd9hhhXtzXiHxDtsPhPHtny5CWYw	9681	13897	13897	1618440660000
19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1546	1093	343	6301	12463	jwjJQxQNtqKZS1MoUc9QjxXXBwVHvoCHGEoWYggagmTTBgjB2R1	9849	13898	13898	1618440840000
19557	3NLoZHPdTimCeaN1T7tkijvWV4mpAKh81vJ1B5oRrpYGhJdAHEzT	19538	3NLrd3HrdaWTLXRiF3oKKL4LRZGkkye6Qtc9UrqrgPLByBijymC4	1546	1093	342	6301	12463	jw8MhQqUafL1vTNXWMWW7gdpq6nZBkZWfq9vPCFoNqyACibqy1U	9835	13898	13898	1618440840000
19562	3NKfUUYW5ws2dqXktT1khfh3hNrN5ExdpeHrAfzxkH7BVJPUWxVN	19561	3NL1qwrRD1jhgPYt1a1SfsZBZrpjbB5TjxX9Y4jFxV8wBLhzBALF	1631	794	343	6301	12463	jxPDEbP5rqixDCWe2FWruiS8tLMTpAQqPFrp7T8P7GJFn9ZVCUg	9853	13902	13902	1618441560000
19565	3NLQrVNXke66VqRpcWV8a1SbFBvo3JgbMfoUjvqywc7QoQscX2j2	19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	1637	816	343	6301	12463	jwmCLr6K1YVdC2j3ywjNzVnwSGupziReE9AoeoJyQMHMGxAgiAy	9856	13905	13905	1618442100000
19567	3NKuHN4ps1KDZqkJtdLcgENgM92vEGATK13pPUCWjQiwLD5aXBoR	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1627	1259	343	6301	12463	jxPvzBa7QVSRDUSFnHpuFDyub7P7VBXe1zt6unPY3BjjBEvEhKn	9857	13906	13906	1618442280000
19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1451	1046	343	6301	12463	jwkNKXMbayLhVvn5uuHdBFkpk3CjU8Hc4VgkfENDy6nraApFTF7	9857	13906	13906	1618442280000
19572	3NLULaYo5t1PYw5fdntDAroD55PKQjv5Q5S54UzCtbbU12msaPKC	19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	1481	790	343	6301	12463	jxqc97zYgb3Gn3XHcmdrGXKfVK5w1kdzYdETfPVouY5c4NHdeX4	9858	13907	13907	1618442460000
19574	3NKQqpbvtgo1jVzwirtjXFw5wfeztrXsAJLuE7ZCba6SvEvEKgGY	19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	1642	1121	343	6301	12463	jxwahJtxEyP7Ca4EQ5KXGVSiUDkaHiqnsUDga8piE4tSA9LALVt	9858	13907	13907	1618442460000
19576	3NKGYxYuDexH26uFwuth1QinF7xATn1eWcxgaKHRdvM8h8Zeh6jh	19575	3NLdoM9B55t1fTKvBh6cT1yarhuwcM2rvydsy7W23qdWmpyuM4Ki	1608	1043	343	6301	12463	jxdFkT3f4ykrWBuvt83Rp79pSrf1gYKnwvh1WjgAEqdCygEUaZX	9860	13909	13909	1618442820000
19579	3NLKSzBSKKofr6jY3HT4fLtoK59Jx8LS3eeSMg1NL5VYUqNZYG1c	19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	1649	1383	343	6301	12463	jxQLRX5v687tLxx8NFmhh14N38tX5z3SDwURgTxz2cSwHko1C9V	9863	13913	13913	1618443540000
19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	369	946	344	6301	12463	jwbKjxFtMgDdKorAQf9TPavpYvkWJCETQefdssLzJcvX7HZ211m	9864	13914	13914	1618443720000
19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1589	1040	344	6301	12463	jx8e4bU1JiU485iocxvoXUXHSoSMw8hykdik8YSdSmjPL5qkCGH	9865	13915	13915	1618443900000
19589	3NL2hLumxPjaayaopL9s5sm9mV85RTRFvZh8e1QNv2EM4sjbCaZE	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	532	1057	342	6301	12463	jwxwp79ZqVU39w16MADfpUCuwZxKDgmWXSaoypmtTB4BzXNQjZD	9837	13916	13916	1618444080000
19590	3NKL3T97tuuuSgyteCkyrwaSDFmRbLraqrmwW5bAewuvT8yfDFYn	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	171	1374	344	6301	12463	jxzyzqkjvXhtPfMop6DGoENSepAYMMke9N5zkg2JoGEdUMuaN7p	9866	13916	13916	1618444080000
19593	3NLt6JFFQ51yz8RE1LHxk6VcUupWouTveMZRuhGcd9iG4My1D5cs	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	641	1090	343	6301	12463	jxCFsSaaiQtXatKun847F6amsc6mdjvLAM8CDLPAAdfR1CPE9jR	9845	13917	13917	1618444260000
19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	19596	3NLeeHSbbC26K4qVcGDBTeAen2L2JmwsXDH7jq1QhVrnfucjgNrk	1508	1387	344	6301	12463	jwBa8SXZ2cazcwFyisYBGa6DFb6SNhnNHX55LxS6XdsCud5sXAP	9870	13922	13922	1618445160000
19600	3NLGGCdhsfLUXAsfaqKs1DQGugqXjk6eJ1eRPo5PFVf4iPgz7YUs	19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	1403	824	344	6301	12463	jx6wJh6UDP5kUH2Zhpm6GYh73PKt1gf5Rg2uTF5xmsqduTYsRbG	9872	13925	13925	1618445700000
19602	3NLJ4VwjgUKPD4ZKz5JxCjSkhjJgjuprL8JmHZRmadTyLef8Yc1A	19601	3NKuwy4oShQusjVAoqfsEUbJutWamEJ7DMwMLy6UCPqCY5UnbAw9	152	1330	344	6301	12463	jx3sL9eZMsSAdch4DxSiujrJiXFisYSobYuPqXhtGC61kaHJzD3	9873	13926	13926	1618445880000
19605	3NKnoPNxYZxVxYJLVBv8NirsPyoxLMe1PnSag1HXNnRaS6Q5Q693	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1407	1395	344	6301	12463	jxs1MmmRYexyWiTomwcHHqjQ6gwCeHRE6fvzQ3yceNNULdUazJ3	9875	13928	13928	1618446240000
19607	3NLe3JhDw4596Kmsy5BsXkvsmzWkMEeD4JDciZ9sPxmpyeY1L2bx	19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	1556	578	339	6301	12463	jxNAz42WPn1Z3pkVoaqd9BYi2wZhP6V3cz7cvUk77SKwmXpptby	9772	13930	13930	1618446600000
19549	3NKeCNPRqrAA1F2ueoiLhzJwQxp74mJZSmHgxN6dvFgdFJZwkaEg	19547	3NLsTzrWibkpG1mqdM7s5Q6Ny2MuHm9D31MCr8XgJSocA6A8uJmf	1447	979	343	6301	12463	jx9AB5frovGe97BXypPSnfuBjHnqrBBKVsCwSP1QGxH63P6zUQH	9847	13895	13895	1618440300000
19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	19550	3NLw94pmBWRFkzwG9a4HZbZTxXVUsRUW1AuPqwxroWHhNmg5JDiS	1483	438	343	6301	12463	jxFeqi6P4NhnKt3SoxgrBr6tAeRQZLy2xP81ytiuUFyTn4yJDgA	9848	13897	13897	1618440660000
19555	3NLwdWqdXg1tCx2onJi4sqmEKkUwVvrsQx8EWcnPT5cCKSTRMdT9	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1407	1395	343	6301	12463	jx8gMmy3XJ4KPzLUqhkS5ftnTcukmwojcmDNH4Ne5nGAcWv6RPE	9849	13898	13898	1618440840000
19559	3NKQRJDPxPWDAdnsvpbqnm1zGmDK2Lo9bHazwXdVgGsgXPQw6Rww	19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	448	1305	343	6301	12463	jweKeyLPg9KZHt4r1ttqsySFjNUVH3GCLBqZWw4nsfc7vpMwrta	9850	13899	13899	1618441020000
19561	3NL1qwrRD1jhgPYt1a1SfsZBZrpjbB5TjxX9Y4jFxV8wBLhzBALF	19560	3NKvdj48z5bZcCwN8ytcj8m9pat3qaj4i3BMVprQBbEEmgGPeBzr	1608	1043	343	6301	12463	jwXeFXNtuT7Xy6SNzeGb7JyPNRC7rxYgbthhrSX7WS53Ptn8hzS	9852	13901	13901	1618441380000
19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1451	1046	343	6301	12463	jxcR1ocV59BPT1zaXFpyCAmVN8bT4fHs5e9AbGqCcH3YUNubS4u	9857	13906	13906	1618442280000
19587	3NKSQMoYB3scxmQDr2Mi4L21Cesg1KEYv5hLJQJxw1AubRmU6ws4	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	532	1057	344	6301	12463	jxq5zXqfSPBZzxWhrLV9hiSd6tP5e3oDWpi7479fCpCMvP73aMu	9866	13916	13916	1618444080000
19591	3NKXAoYERJpLhp7WZJHopUhUJp9AaYA56VHBiu5rqrSuNayNUjpM	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	1403	824	344	6301	12463	jwACoFTStRsf6p4dk5StroUTvj6ZscAJvFcqHcwicKgpVyidijy	9867	13917	13917	1618444260000
19595	3NKZcderv3iVE9odGxEz1ui3eahNXJ3F8eyx1B5V4SbXM8rDsFh9	19591	3NKXAoYERJpLhp7WZJHopUhUJp9AaYA56VHBiu5rqrSuNayNUjpM	1460	958	344	6301	12463	jxCpb4q9FKLv9iv1zaUBEqxU1c7BUXxHZc4JyKqBVirxA167kUx	9868	13918	13918	1618444440000
19599	3NKnr4cX5uJ2Dz43ks56hQ8tTJE3eS1RpX56ep7xN8zsLd6VPm9H	19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	80	1147	344	6301	12463	jwSU2xMVCTNZv4KBQj3gLPYCT9HyHqbYcy8FYmP5oviMoUg9biv	9871	13923	13923	1618445340000
19608	3NLFvtFNu9ZKXRWzqmMDbTSPvDydqa2yXgg8tYHLTSaCs3Dmf3KY	19605	3NKnoPNxYZxVxYJLVBv8NirsPyoxLMe1PnSag1HXNnRaS6Q5Q693	1556	578	344	6301	12463	jxLienVS4X9HLepRaDMcytjMFSw79Hatoj5g1LfjcNas77Q5gP5	9876	13930	13930	1618446600000
19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	1406	1393	344	6301	12463	jxk7XgT3wg1AvUFMYaDUihSvP6zRLSroLQjVztnKud6oxQp354F	9878	13933	13933	1618447140000
19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1555	1347	344	6301	12463	jxLudGw6dNrVzN5Zfas3LajdBdDae1n4YQw51fJyXtWmi8aXMh3	9880	13938	13938	1618448040000
19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1403	786	344	6301	12463	jwcdX3QSJMQvvJd4r34BiqFAQEYMapqbe9LcwZx9T6QTb259hkb	9881	13941	13941	1618448580000
19622	3NLLYDmyMk3SXEqajeRgTLbqQF16bFf9EdzR1thfrGm5wyLZSG67	19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	1555	1101	345	6301	12463	jwLD9SCrG3X3JVyh9KTaVmWoLrQYjhf5gspqFnbCW5fsfQ521tx	9882	13943	13943	1618448940000
19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	19623	3NKjfvsoH95iVo5GpDZTTJFTgKcjzVzVPN9RhRWJMhYGifDi3BFJ	1483	894	345	6301	12463	jxaLW9mP9ZVee6kXAX15ehVrX78QS4M7jQqAnLAC6gx8oDECVv5	9884	13946	13946	1618449480000
19625	3NKm4KzRgAgLZ1JPqEb2m7kEbFwX7ihEYsZGRHEdFj88B8DpkvwK	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	1613	1103	345	6301	12463	jwp2qaQsXqoFsBe62T79WkKKaHiw24Ua14BNDQGhV2VTLHHahf9	9885	13950	13950	1618450200000
19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	19629	3NLsyCgNsA9NA9QdS7M5P7QSUVG3bVv7hdYuj8RXq2GWHU4sDR2r	1402	882	345	6301	12463	jxDYxUtgok6YHeh1RthDXvEp7GUbiiKfCR1GybpK1SSRx7FD5Yd	9888	13954	13954	1618450920000
19639	3NLocnbVmm1Jua8TiUckXTnymc7Js6U9KgUDUDBfAgCyB4YjKmw3	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1672	1039	345	6301	12463	jwH4cznc2DiZCcUR5iTUxZ5rgkkDjgqgo3agbX2vV63jpv4xKzU	9892	13960	13960	1618452000000
19642	3NLUirVZZ5SUuBmQgzWVERCricHAiaXYqBDyDJ2SCSUWJhdaEa2Q	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1474	1329	345	6301	12463	jwBs5oRYdizGhHse8GvdDPdKgFWucxQpWA5UquEpeJemcRqf29v	9892	13960	13960	1618452000000
19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	1553	776	345	6301	12463	jx2dbjM9SUK7Yr1tyf8nBpWzjwY6ZbBwpzo3vrNqAYgrvStaoRU	9893	13962	13962	1618452360000
19647	3NKjACTp32Udm9ivqYxENh4f3DxLus2kuP6G2Gcca2gsyCTHbVu8	19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	1534	628	344	6301	12463	jw8E4d4kgggC34mc4x9fEiWo97HEUq1zHgFjVoZTs79QcyEJ5Cd	9878	13964	13964	1618452720000
19652	3NLn2LK5ZQebpgAEX8uJ8JH9mE3uYYwj3xfxs6RfJJWU42qvJp1T	19651	3NLph2ctSWjyNo7Nii4TNyLG7tR3DBtUjK9P4ENNz7nPkSDw42Yr	1675	1342	346	6301	12463	jxhbXbiWxN6WmoECuHcTsXNK6FrxRLjuggTDDKKPL9U6HUbijcZ	9898	13970	13970	1618453800000
19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	19656	3NLBQmF8bRn5j74tp7QYGG24XQY4traAxd5Le9ohUP1u3TzoPfjn	1631	794	346	6301	12463	jx3XoSjEyCZe8pS1q1bNbbmgMwxeB1urZEN1wVcU2sSwaibYYTy	9901	13974	13974	1618454520000
19662	3NKVAjSmzzRe5eXhYf2tQqyy4MngUD2bPjtBJwV3YifwqxmFXxJP	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	1536	947	346	6301	12463	jwARxcM29wtuV4dBrXQkbU8rjLzfMYNcsDzCK8KyNsRdeUxRoRf	9905	13978	13978	1618455240000
19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1648	1284	346	6301	12463	jwM81DXWxhbntCoWBsCA4nFyq9dqNjHvJx6KHuy8n2xztReJFkP	9907	13980	13980	1618455600000
19669	3NLn36w2qkfjQDCV62xtXNY9kuS7YLxJUHKNrUos9FPvd9e6STcA	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	1403	812	346	6301	12463	jxpPkbbKemNnSoVeFvfDZZKVsuF1GgbdnMTcw6nxX8qbCw3a7Sz	9908	13981	13981	1618455780000
19674	3NK5fqXcweBigSBFAz2v5hkxSWZ1RaUPcxbEc8z8A2wqskgkz7i1	19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	606	929	346	6301	12463	jwRKBuyE87ckr2UfECz5Q34wACJnnSdmyRaWz6MUdNhAma9eNSD	9909	13983	13983	1618456140000
19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	19676	3NLtdiazTEcFmZm6nASwnu6ox9pGMghp678G2yDWBHderu7zJvsd	1513	1253	346	6301	12463	jwxZEnE8qaHEBRneUsff91yys7eg4pL3rBfJ2HQdTMbguoPCahf	9911	13986	13986	1618456680000
19683	3NLWV9CDCXZ2xQcD82nuJ4ZKbB97cMwvV4iJu3bGzDsqCtL5frvG	19679	3NKRb1HMgiJnT9QYiECmaETFWxPVcyD9CbNpNmABjsfAXXTGtQRm	1553	776	347	6301	12463	jxucP5oRRZ9sbMbnPwyM36skFf1ugzrZaeuHceakQZgZ2GqKfYg	9913	13988	13988	1618457040000
19685	3NLgjKfUXS9CTGWqVPiVBRSsSxfPrCD9kMQ7GqkqNWo9rhK9rgGj	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	80	1273	347	6301	12463	jxq2xcBFTMcF7ZBFXbZEQSgSseC1G9Um1bpQDccZtY6wgKS7Ys6	9914	13989	13989	1618457220000
19692	3NLarqWvZeWUXz5myJdPTz4XiMASMiL9cmdPhwAFBXx6QUoZJEUz	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1534	60	347	6301	12463	jwkp46K6B6f3rqmGZ629yxKNj2rTTmn3wET7V2JcYbNwdrszdQt	9915	13990	13990	1618457400000
19554	3NKAmLfEZH9cAZCZ8LQL5byHwniE1b2as3DvhPXz7v61V6k9pe8x	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1546	1093	343	6301	12463	jwaweTscRwFMK1eMuZs7nMnJrkpJvD1anoaX1MQ1bAq5FnQEduw	9849	13898	13898	1618440840000
19556	3NKTtQYzQBpyDeqgSNh8vpgN4Nr4waqnM3tWqr9vZ34wM7vjy9fC	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1506	1127	343	6301	12463	jwFPh6Vevq1YUw1SxEJydZS4AsibiStFXQHQTzAipZozzkKEixc	9849	13898	13898	1618440840000
19558	3NKrxmxj9f1GAMknFPydY4NuJYY45RtsF5FRJLsMX7yvh7FEKBzu	19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	448	1305	343	6301	12463	jxdYfCLu8oA6ER4FyHWiEKty521G1J7LJD415BdzDk2bPmNdUAN	9850	13899	13899	1618441020000
19560	3NKvdj48z5bZcCwN8ytcj8m9pat3qaj4i3BMVprQBbEEmgGPeBzr	19558	3NKrxmxj9f1GAMknFPydY4NuJYY45RtsF5FRJLsMX7yvh7FEKBzu	1405	873	343	6301	12463	jwScuNRnTGcGH6zegz2hPkocaReoBEUZyh2fg1SF9Z95B8dzKBk	9851	13900	13900	1618441200000
19563	3NKTTRL2nvsVMKLmmbK9e1FGKMt8QoDsHgpD6WXiBvVFXyUEbgvb	19562	3NKfUUYW5ws2dqXktT1khfh3hNrN5ExdpeHrAfzxkH7BVJPUWxVN	1648	1038	343	6301	12463	jx3uUEFXvrD38kXVvFZvUozAWkVaFvfyfYQLuUNmEVRcHHNbS4w	9854	13903	13903	1618441740000
19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	1610	1314	343	6301	12463	jxAZgHD4b1WvFVu3xMEtL4F1fbXKA4HsTbDGTyFDeG6EDrMr3tP	9856	13905	13905	1618442100000
19568	3NLBRSSNRuRrD2AMGoLRrwKRUTfLrshRtaJQUv56MMMu47fyJWNW	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1451	1046	340	6301	12463	jxLm7wHkQVr5aQBAHHjubjZFH8cBh4Qi4zYNeMk2QvJM28vLaFh	9790	13906	13906	1618442280000
19577	3NLKP69KXcqH4GxDmnpaGVxJ5cFexWfij2qaWtCWTeaYUBHzMFqp	19576	3NKGYxYuDexH26uFwuth1QinF7xATn1eWcxgaKHRdvM8h8Zeh6jh	1637	815	343	6301	12463	jx3xoaEeeLQti3CV56Lq621Zk3jDphEckzSSzVHHDbXWjh6gYg8	9861	13911	13911	1618443180000
19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	1649	1383	344	6301	12463	jwoB7Bg9g76zVxqbzpEG2cw9nJ1RnUDvovNEsU3YPon1zurCd3M	9863	13913	13913	1618443540000
19582	3NKcJYZk3gyo7kH9wG3T51zr1bp2xhiKQqRbQM2bVRxnWamuSvtN	19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	1668	1370	344	6301	12463	jxQhAegPaYnpciZX373wGXTXYpf3Qg1wGAhX3cqZD5DHtppfN5x	9864	13914	13914	1618443720000
19585	3NL4ZnstvP3aLAugYSNizBReAFp1xp9UJeL5Dx81GrkmDRpynXUq	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1483	304	344	6301	12463	jw8D9mNaADFYTGcGfsW3Bs5FpQEfzpNzJwkhJeEs1hm1SEYPcL8	9865	13915	13915	1618443900000
19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	1490	1148	344	6301	12463	jxYWEFREnWR8vPMFqiDXAUpmLDVKWwz2E9qApmHZ6Re3JFLthmQ	9866	13916	13916	1618444080000
19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	1467	1376	344	6301	12463	jy33FHUeFhvs6mQsEF213sE4BKLkePdzx5ANc1J9gpxNMdU6TFv	9871	13923	13923	1618445340000
19601	3NKuwy4oShQusjVAoqfsEUbJutWamEJ7DMwMLy6UCPqCY5UnbAw9	19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	1426	1364	344	6301	12463	jy3CQ7YBWKBLCUEovcj3GGztorXw4TsfTfDSHbJcpuBJwgswXdL	9872	13925	13925	1618445700000
19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	19602	3NLJ4VwjgUKPD4ZKz5JxCjSkhjJgjuprL8JmHZRmadTyLef8Yc1A	1637	816	344	6301	12463	jwwycc6AWJCkrkFTreFwfpU5ecuQP15b5MfFod7eea5tun8eECW	9874	13927	13927	1618446060000
19606	3NKDkkVa82oxSdjqNqQcxSBkNZkd4AD6PaXct75o9FkCygvLmCgC	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1406	1393	344	6301	12463	jwj2Bp2Y2BQ1EQdJEXbTgqF9xnZamRosNBKUXovovB2ay8uBJS9	9875	13928	13928	1618446240000
19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	19608	3NLFvtFNu9ZKXRWzqmMDbTSPvDydqa2yXgg8tYHLTSaCs3Dmf3KY	1642	1121	344	6301	12463	jwiFGTH2qACyJEMMfUaxJ3dJKAfkhM68cbreZnhqwUxTiwiQLw2	9877	13931	13931	1618446780000
19621	3NKkhGeqqsjXneSjNMJYZrdH74W6ZT5xL7YbNxSpYCm7vixpnEF2	19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	1555	1101	345	6301	12463	jwLD9SCrG3X3JVyh9KTaVmWoLrQYjhf5gspqFnbCW5fsfQ521tx	9882	13943	13943	1618448940000
19623	3NKjfvsoH95iVo5GpDZTTJFTgKcjzVzVPN9RhRWJMhYGifDi3BFJ	19621	3NKkhGeqqsjXneSjNMJYZrdH74W6ZT5xL7YbNxSpYCm7vixpnEF2	1402	856	345	6301	12463	jwteLcg9JwcM4WeeirCnyNTTpf8nYZAEZK38JCKNrmVa943NjZ7	9883	13944	13944	1618449120000
19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	19634	3NKDu9k1k5NCisjSpq8SLKKePhSgrJU2RWqShxuFNaJfQc6eyyoA	1560	1045	345	6301	12463	jwShSsHk3t1yjWJnBUDL9SBGCTi5w7NNii99hTiUvM4w5vLKQuE	9891	13959	13959	1618451820000
19638	3NKzcSaKoEVsH4kMZLf5oobSPdVPxtemtqB68wVCnmxUKgFfwFWT	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1474	1329	345	6301	12463	jwYZZMWNvYRLcUV6tp6eQi6XDHDgFAJzyXER6ALCQX2v2W4WiZa	9892	13960	13960	1618452000000
19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1599	1041	345	6301	12463	jxwsMugKLikaPGFkEgZ1DLhFnFhP43oWwgR4VVX4aRNFAys2a42	9892	13960	13960	1618452000000
19646	3NKtRZNH2DBqofHnUbX6EYApt4bemavTyYUfy5hkdgST2xLyiRXT	19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	1631	794	345	6301	12463	jwzRjbk6f54317cQKvCrBWMVRYmUJHNAEqzAdjGAJCqKaPU8fts	9894	13964	13964	1618452720000
19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	19648	3NKUMtUg7rfcKtzg9afA5Aap3dxb82JmPYhFtp5wrfMqx645TqC5	1627	1385	345	6301	12463	jxCsGxvZyiJpqYQBWGA3wMF96vxddT6Y36GxH2va1tCjeWxPzmf	9896	13967	13967	1618453260000
19651	3NLph2ctSWjyNo7Nii4TNyLG7tR3DBtUjK9P4ENNz7nPkSDw42Yr	19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	1559	987	345	6301	12463	jxQGNbw8p7YtkJAs8iW9jXK1A1MMp68QQJGPw6fHhrpfjxZqkBo	9897	13968	13968	1618453440000
19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	19653	3NKrENj3RGaacuHQbA52CbYSfG7jawNntDVDz1o6qcyW1Kz4HeL5	1622	1356	346	6301	12463	jy2ho4vKnRXiCJEUZGpm1HtwU2z8NEiME4d6ocTtQAStAnTLkz4	9899	13971	13971	1618453980000
19659	3NKJ4XUzSK9QyxhN4GDQucXir8mF62jnZQQatSoFqiGB2oDMHAp5	19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	1581	778	346	6301	12463	jwkAzTgWEhBB3tWp3nSVwT3Z7bsKXPTNzCqeVBkYb7Fx4RnJGpH	9902	13975	13975	1618454700000
19664	3NKissRVxVtQhCw4yoLLMCGLvdKCQqbtJy2vZJ6iJENeS93dw71Z	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	563	1233	346	6301	12463	jxHwgjtDE8NwExntPYx9L6A8JyZBjNepDrWp7qke7G1SC8scmQB	9905	13978	13978	1618455240000
19666	3NK4U7cACZVxK3eJPxAsVy39y5LTyxCtS5nVn5dhhKwi86LPTHpu	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1471	1140	346	6301	12463	jwz94h29geAkqRXusFrYXVREpc9YuX43Q7hdyadfwdx48vkkDg7	9907	13980	13980	1618455600000
19671	3NKMuFD9Uk6gAbNkuDn4ob9XdkHq6i5DApqCE7hLYzSZ8AtMgqVx	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	1553	776	346	6301	12463	jw9V5WQ13hjts9BgZMB7DoefKG2rHjJaxuHPtcBREa5FWgmmGpK	9908	13981	13981	1618455780000
19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	1407	1395	346	6301	12463	jxrSYErStK8HW6ScTxhxvX19Enc5qREK3F9vzC1TMEEthbX3kwu	9909	13983	13983	1618456140000
19676	3NLtdiazTEcFmZm6nASwnu6ox9pGMghp678G2yDWBHderu7zJvsd	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1406	1393	346	6301	12463	jx9aDwSCUYCMSYKzCEYqJcjhXRJ8RMT54FPKzyB1iJZ87a59nKS	9910	13985	13985	1618456500000
19604	3NK5bKwu6TRuoJsW7dByrkjjPXXYk2k6PVa7PNVgpAvufiEQP1VZ	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1619	454	344	6301	12463	jxBircFR2GBGCfhizYzcFfRxopVm4WqSp8VncrpVC3aLJ8bu9Fc	9875	13928	13928	1618446240000
19609	3NLUk1g7uFWMJRYfRt4649AUYiZqU9se4JxLzWeG19dHudPEXhne	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1556	578	339	6301	12463	jxC675BzoaAfybid3LyTYt4jZf7x1qcoHKj3iSHnuprA8Xn5qvc	9770	13930	13930	1618446600000
19612	3NK4MNqLDbWj4jScr3oK3Vo4nPV8PuCo3eW4GnJVfJApV3j2dMKK	19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	58	1281	344	6301	12463	jxjLqLJMGxNgi2hiBDDduBbYMPMDEwq3zmcMtziRQG8cyfRXyDk	9879	13935	13935	1618447500000
19615	3NKtMCx48YCgRJ9sgLrj6bb1RBmazqki1UhKk8DLrLGmxztLZiVM	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1489	1380	344	6301	12463	jwXE2CdqMiH29r9UBzQBPfEGLdh4odNituQXk6WEHVLN4hf9BMB	9880	13938	13938	1618448040000
19618	3NLp7pSeBsrsaV7VfESYs5pT5Gtvhvs66JGLpBX6xkYPZBTfRivi	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1546	1093	344	6301	12463	jxoJPwrDi7krCHHYGCMFJTacByoPQSfp4WYwE3zZ9VWhA6AssTU	9881	13941	13941	1618448580000
19626	3NK6CDD4EEkRSmoaDQu5AwX3kg1ewUaR12SX6dniMNs4QgVMZmqx	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	149	917	345	6301	12463	jwMJmhSS3QQbRxvt2tR5K4cdokMU5oE9xzwjrPvxgBtrWnmJe4y	9885	13950	13950	1618450200000
19628	3NL2L6vaCoASFe16WMFD6R3Fjsh4ZFd9RRrGaKYh1xUPHYFNQr5r	19625	3NKm4KzRgAgLZ1JPqEb2m7kEbFwX7ihEYsZGRHEdFj88B8DpkvwK	1406	1393	345	6301	12463	jwEuje8XTTr24TFkK9ESoRPh2aR9Zt4bYmpiXZtRa2Ln4sBVgSr	9886	13952	13952	1618450560000
19631	3NKCtENQPhJw3z39BsonRmke9cqxXBvbfGprkiCLkcScNqWTWi6J	19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	1527	1293	345	6301	12463	jxwR23C5SgLaLgZMSWPRSwKsycDvvquebZMfdNdDrYAgubZC3iS	9889	13956	13956	1618451280000
19633	3NL9ZRHabkjJZTJxnbpqmCFUFf18moZo5Zyf6sDLKi5aKhrQrgXd	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1527	1293	344	6301	12463	jx25PZUDKYV3HLYfiH84fEUG8PFHniP4EfwzugbZSwxxpQhFM5p	9880	13956	13956	1618451280000
19636	3NKJTzKDBrg7qfA1vAeY37V7UnpcWxEgxJniPoAoAe9dkUHt9Qmb	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1578	556	345	6301	12463	jwvjkwSio4TabQ6sFtALuaPS8RtqZDUWCNyh1zYJ99eAqNAVgyL	9892	13960	13960	1618452000000
19645	3NLDfvYMXrHWgyYRypTsPjw8Ep7x3PFv84rBBtxj7bsDdEmrgvyW	19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	1534	628	345	6301	12463	jwREWegY5KCFm2aUv9DyDAbUWaNUXohRMnkggk4dc8Vi36SeCFj	9894	13964	13964	1618452720000
19650	3NKhpG6UFH1XHHtWwzzU5Gx4Q97VUjzfPEuEkj7UWB4i13PL3xVH	19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	1559	987	345	6301	12463	jxQGNbw8p7YtkJAs8iW9jXK1A1MMp68QQJGPw6fHhrpfjxZqkBo	9897	13968	13968	1618453440000
19655	3NKTyep7QAbsVehAGZs8C5vwrkgQesueom5QKtuUn8JfhMC3fjcz	19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	1608	1289	346	6301	12463	jwL3wNaZLJNFRqk84f8aEKXugREEca8GfYfvBor4bemBWxJLv2i	9900	13972	13972	1618454160000
19658	3NLkYjVeK67ujRvoKtSiAsXRWhdrxGHt8TTX5uZpwmT9PRzXLF9c	19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	1455	1206	346	6301	12463	jwZeq7UXhSRwUQYKGYPELDJGdYwNxGvVMXSed4RDSJgryitcKLR	9902	13975	13975	1618454700000
19660	3NLdMSUavG2Bkm1rpkY42dASAYfSkoFKHhhvYNZTW2UcvrvTJ3yn	19658	3NLkYjVeK67ujRvoKtSiAsXRWhdrxGHt8TTX5uZpwmT9PRzXLF9c	1501	1234	346	6301	12463	jxucZW4genPePsiGTGmbQtbMMgAJhHZvMCafEgxDj9B48q3JmT9	9903	13976	13976	1618454880000
19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	19664	3NKissRVxVtQhCw4yoLLMCGLvdKCQqbtJy2vZJ6iJENeS93dw71Z	1406	1393	346	6301	12463	jx5ZvhsMV3oFn3FwFuimHnku8f3p1k9XSev4dQ79VkcJgu1sNjX	9906	13979	13979	1618455420000
19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	555	555	346	6301	12463	jxtjfpX5GtqGkY2fVazHumsoxckZiJJ2hf91K4ZCovWmKfXVorC	9908	13981	13981	1618455780000
19677	3NLDEc2oxmVGVB4uJcT8fDctN3GHpvr2BD3sDpyyGnxbgT7yma8m	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1652	1315	346	6301	12463	jwRiHjAdAKKG6JXC7UX1eKkWHLEpxnrVLAMh54MJfGtYRNQQmnY	9910	13985	13985	1618456500000
19679	3NKRb1HMgiJnT9QYiECmaETFWxPVcyD9CbNpNmABjsfAXXTGtQRm	19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	1601	1142	346	6301	12463	jwE6nBFYNf7nuEUaxh9RicueSPVKnovvFsgN28Fi8VeytjhZghD	9912	13987	13987	1618456860000
19681	3NLTjTteeXYr99iH94GJ4owQiKv671batV9CimKoZNGYyDvmZWQd	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwMnkDVE7mwY1hofuih3rRQ7tbsuBDaVuq3cqfkWPY5kznj8Bfn	9913	13988	13988	1618457040000
19686	3NKShbJHxfPWsNMnw3jMqK4pDa5ThM4jJ5Gbh7n4EGbnhWuUuKRj	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	58	915	347	6301	12463	jxRAgTmHPxSPkhRjAdYhnGqasN9fHMCWw18cqTLzdYHNE7dn2sa	9914	13989	13989	1618457220000
19690	3NK7NChdMqVveA7mVqJ7yc7Az6N9c6FRppng2DsjMMtYp2nDQeFu	19683	3NLWV9CDCXZ2xQcD82nuJ4ZKbB97cMwvV4iJu3bGzDsqCtL5frvG	80	1273	347	6301	12463	jxBXQcswQgv7L1jGDskytbon1n1DThoQZF8veqrPZi5hvi6pNL4	9914	13989	13989	1618457220000
19693	3NKvJV7d6Y4vCWym1sKj2xc3SB7Gm8Fg2gdbA1bdKN5KTGjTP1gV	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1564	1338	347	6301	12463	jxVHpuviMXfUDJGMKUdN8nKjoUB6jd9cmpA37SKaG14u1CLgw5d	9915	13990	13990	1618457400000
19694	3NLsErhJXyegJySzhns996Y7vXZK6xradT9cBBPrfZtUkp5hMzyx	19647	3NKjACTp32Udm9ivqYxENh4f3DxLus2kuP6G2Gcca2gsyCTHbVu8	1534	60	345	6301	12463	jxRVXRte2gPnw3grcbpB5HzBhSeAjgrKPaP2ZhJRVQKVtyEr6PZ	9879	13990	13990	1618457400000
19697	3NLjXJgxkfCsMBD1jd5H98SroX2A1CieHF7UmmxMTyzWus2hWtfN	19696	3NKihFPMVpzeMj9MbpcCnykPvUxdGg2nGBpBRYSGQw9e4dVKTLiv	1617	1162	347	6301	12463	jx1CfPTAAmu51tQPqSdVWeSo4Rs4LLpXxYmGoLqGcWMsxP6Xuaa	9917	13993	13993	1618457940000
19700	3NLCUDF9gfrtyVTHvXBGTNUT9m1WT8oipFdKaSPfkq1ZfzHQBqoB	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1634	1331	347	6301	12463	jwmgoGWgPgQEu1cDTYn1fvrecsrWaS647mTjBQu7ApujcvJyXcC	9920	13997	13997	1618458660000
19703	3NKM8Z6mShYvkQUVNvN21ik9wghev6ixb1rbwgiJuXZLCCFwwqwb	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1448	1065	347	6301	12463	jxvhk6XQDySq3kj7FXK2w98qMyco9QgopQZbfmkJToR6Yt6XrJY	9920	13997	13997	1618458660000
19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	19704	3NLb9XHLAGGy1NvwTsHbDAeS4BYgptha5UeJodEo3pTtmyc4pDms	1407	1395	347	6301	12463	jwjttPXRozGtxR6dngJ9pvs9gNBfsk35aazG2SVxsuiieAF6Zis	9922	14001	14001	1618459380000
19708	3NLcfbbaKoT1gLCM2yWeq1n7V9cF1PtVw8cuQqjU6w63L4jbBvio	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1439	913	347	6301	12463	jxhXrkZ1cuKfSY6DNnZkQ8HMxWk5tfSo9MPKgvgohufZqnRx9Jc	9923	14002	14002	1618459560000
19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	1508	1387	348	6301	12463	jwJBTif4WdJdkcwotqCEd8ehAqfS838StXXqd8VGSHEodQAGxUk	9924	14003	14003	1618459740000
19715	3NKca4veHPud36h8ghHt284mSXzc9WHBgwPZmZeZcnd9D3ATqNex	19487	3NLxLP1p7W9DGGqQvsfPervNx6jUiLqANJ9Nmd5D8EMxXvHQiezF	684	1106	342	6301	12463	jxJ3NSrGDRwq6ZZ4qcoKMRERVPcw1xFaqtodWbDF1eb2W28m8JH	9824	14004	14004	1618459920000
19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	1490	1028	348	6301	12463	jwyZQGV6EACTSp2H3Xw3ZwpqjvDxQ3pEqLURj2uGvAEv4n8RYLb	9929	14011	14011	1618461180000
19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	1406	1393	344	6301	12463	jxktAQq5oWDCHrfgZj2EAdUcbvHhYQXzQTrNSXyBdiv2c4hBrFa	9879	13935	13935	1618447500000
19616	3NLBWfkmRPuJ5pBSfEf7LZ6ZFKwUpMmfagkee6MWVK1pzcnFPoNB	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1647	1302	344	6301	12463	jwGqBZgod4VBFLVLpW3fZ3SwcaDSEm47DhubszqHRzTEv1X65LV	9880	13938	13938	1618448040000
19619	3NLqQNHrqBmXhkfEgGaPu4DkG67JbvZtXg88dRaU7dD2o87ZvG2H	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1546	1093	344	6301	12463	jwuriRGuuP15V8EwHmatu7qmtn4Dg852xtSojS92Sk6XqxACXHc	9881	13941	13941	1618448580000
19620	3NL5jQjDEuDF65FjrWSMUAZE3BRVPdow9NyN7E1NjhxDXCg9GFw1	19557	3NLoZHPdTimCeaN1T7tkijvWV4mpAKh81vJ1B5oRrpYGhJdAHEzT	1546	1093	343	6301	12463	jxMQjXrojJYjn9asmcxBmjKijNWW4M5b2uLAx7BFZzF3sbuBwwH	9836	13941	13941	1618448580000
19627	3NL4LyKdTf8cYvT6k1DGeAeAsebUq7DquY55DQBFqqyVwAeCubbB	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	1406	1393	345	6301	12463	jxpPmFy1cVCKGpGqnTH3bKBpU3SSX46r6hefXXQuyJGewEcGUNj	9885	13950	13950	1618450200000
19629	3NLsyCgNsA9NA9QdS7M5P7QSUVG3bVv7hdYuj8RXq2GWHU4sDR2r	19628	3NL2L6vaCoASFe16WMFD6R3Fjsh4ZFd9RRrGaKYh1xUPHYFNQr5r	1513	1379	345	6301	12463	jwTS1f1c1T6aHGxRhnKCnsWwDcYj6Mjv7EXPxEVCAbd1qnGqt6a	9887	13953	13953	1618450740000
19632	3NK5MNapMfYG2ZkqsJHruh1fvB5H1ZEGvZuSkcuwr88vvitCDcEb	19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	1527	1293	345	6301	12463	jxZ1VDU6r39GJuA4k3ZXVrz7UsVDJtwBtWtucuFirZAZmKcfNub	9889	13956	13956	1618451280000
19634	3NKDu9k1k5NCisjSpq8SLKKePhSgrJU2RWqShxuFNaJfQc6eyyoA	19632	3NK5MNapMfYG2ZkqsJHruh1fvB5H1ZEGvZuSkcuwr88vvitCDcEb	1406	1393	345	6301	12463	jwtusQcrCPXzJP9ACQkoKdy1btcbyQvxNQNpTz2Vh59RM3EG4n5	9890	13957	13957	1618451460000
19637	3NLYbKh2cteGzJJxn8WgCuf7s7Ph22cHSzMkbK2m3APtMVyfzyQS	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	58	915	345	6301	12463	jwcJkDKW6oCaJwk5dt6vp3tP8YPqRL3xAkHbuSUrNfiihRyfre3	9892	13960	13960	1618452000000
19640	3NKfHkHRf6Q5hxCwcp8gt6pQvNdGSPuo4LbToDM36xQpiXwqdn5q	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1458	1323	345	6301	12463	jwVM44CTQPVpsVTXNLcSCn5aZVnWH2xkNM7rAaN1jwVRXLFhznw	9892	13960	13960	1618452000000
19643	3NLxikzyHN3yLi73DMLsBagYfD3NqZSL72ibMV9XLCZGXWao3ERE	19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	1422	971	345	6301	12463	jwitAR53cvdNoEd5KvJeRWxiM5q9hecawvtdudr3nPJxgSpteMb	9893	13962	13962	1618452360000
19648	3NKUMtUg7rfcKtzg9afA5Aap3dxb82JmPYhFtp5wrfMqx645TqC5	19646	3NKtRZNH2DBqofHnUbX6EYApt4bemavTyYUfy5hkdgST2xLyiRXT	1467	1010	345	6301	12463	jwjWhdXXQZ83XTjn8Ww5KASL9D9TH71ChfVn586c3PgoHxf8PSK	9895	13966	13966	1618453080000
19653	3NKrENj3RGaacuHQbA52CbYSfG7jawNntDVDz1o6qcyW1Kz4HeL5	19650	3NKhpG6UFH1XHHtWwzzU5Gx4Q97VUjzfPEuEkj7UWB4i13PL3xVH	1675	1342	346	6301	12463	jxhbXbiWxN6WmoECuHcTsXNK6FrxRLjuggTDDKKPL9U6HUbijcZ	9898	13970	13970	1618453800000
19656	3NLBQmF8bRn5j74tp7QYGG24XQY4traAxd5Le9ohUP1u3TzoPfjn	19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	1407	1395	346	6301	12463	jxB6YJgwJguNoaQeKyxDESgv779eJiFHack25SYKrBcx6xWNrtF	9900	13972	13972	1618454160000
19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	19660	3NLdMSUavG2Bkm1rpkY42dASAYfSkoFKHhhvYNZTW2UcvrvTJ3yn	1631	794	346	6301	12463	jxdAJjpuUc22ZfQgQsSbKMmbDdyvAYsz1fymVPjsaruYJaKXkBN	9904	13977	13977	1618455060000
19663	3NLLzJdznnkucPHgm1CQqti1RkMSyRh6ks796xwXXVAvft4Tkrnq	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	1536	947	346	6301	12463	jxYFLwQfQEgMrgEhZXrKuPp36BScPjBmz6rnAwu2DG7QG1CrrmY	9905	13978	13978	1618455240000
19668	3NKn6U1G6WQroVJXcU9YqDN4q5SPtP7AqyfH2rkXpbnFAH9SMrV9	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1489	1254	346	6301	12463	jwfQ4ZCtqAthusowWB1a61haRBiGFquaK6SDvW41YJsdW6RSEwW	9907	13980	13980	1618455600000
19672	3NKQUM6PgbV6FcC4ADtBjXjvTygCQ3oF9ggitnwWj2efPLNphLFs	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	555	555	346	6301	12463	jxas2SghrYMbBrpMfvq1t89qqLWnessfK9KmcpbEyc34s1MaiY5	9908	13981	13981	1618455780000
19675	3NLAEye8rvRikQ8PoSXPN9iYXLyvScL87xaFN2iFMYEWb9VAwqaG	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1560	1165	346	6301	12463	jwEaNUtkYTqF5zYYfdek6TedbZXy7wwWLk6462EB9KKsxJGq1g1	9910	13985	13985	1618456500000
19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	1601	1142	347	6301	12463	jx1XdvxsNzLiWkVMfx3Srsmg8i2MnWhrqkMkTUfb8EYTHHLn8aa	9912	13987	13987	1618456860000
19687	3NKJSUwDxAXCvxUNK6u3oew8yaTVwPh7j45vq7TQh141pdeCBQB9	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	58	915	347	6301	12463	jwRUJfW2i5ye7E3B6bT52ETVBpLVZMGzBcyz2MLBRghxw81Zsco	9914	13989	13989	1618457220000
19688	3NL3fnqkhmU6aRVDCc1f9C32sQaWM26LdgWungTn4X5ERme1tr2a	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	80	1273	347	6301	12463	jwrLC144xk3h1dLWNyuXAVVfTLp3umbwjvRRf8BbEZkTk9dLzA4	9914	13989	13989	1618457220000
19695	3NKdFyof5nze6m4rW3TNSddJX9MyopELF8p97wkZ8X9Eez4HBGSr	19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	1419	813	347	6301	12463	jxi21oPUFU9XUbWQyZV8tMwm6HNVW5L4cgqZgz9U6L6o41DAupv	9916	13991	13991	1618457580000
19698	3NKbXGgVnupMoAxjBG1zL5NsRqx8dqgrBvjQR8wa54qrcUo612cf	19697	3NLjXJgxkfCsMBD1jd5H98SroX2A1CieHF7UmmxMTyzWus2hWtfN	1407	1395	347	6301	12463	jxP7zw3iBmY7ZN7WUYZJVtFb5EBLxnENsEv1iMbTmQY2L2SZE9r	9918	13995	13995	1618458300000
19701	3NKLJRVrMsFSde1ME1etVJ6Pvny3zjjoHeBvkiEMF4xwguW2saNR	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1448	1065	347	6301	12463	jwQfZNZK3wvDuRJMvPFgXbKXK2KhN26rdzYK7LqtvjwLsRYWKwC	9920	13997	13997	1618458660000
19710	3NLsrrMu4WhzhWmj4rejxnf8SCFa1Xf876jXrjyUJsVd46ryPaJy	19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	149	1283	347	6301	12463	jwSknJUZH74PfZ6b9LSMHn56PiurzGejLN57kVo8YxrwywcUfUY	9924	14003	14003	1618459740000
19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	19716	3NKjvAB7Z8Mue6iJxNc6wLpS6SGeoFBzKzPRjfjWkb1scvuUcSvC	1642	1367	348	6301	12463	jxb8KfMzdziW5cJYh9GB9NeRz3YRKwGa9vbD6ShTBnSWacLEYY2	9927	14008	14008	1618460640000
19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	641	1336	348	6301	12463	jwXT7vsBbt2iAAWDQmNixE61B7tZep3i3M2hF2mDpaWsJgvt48F	9930	14012	14012	1618461360000
19725	3NKGDVY4LdMkLMKaMSwcYDePiCUfs6rvnd1DXZJMsUpK8GU19j4E	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	80	1273	348	6301	12463	jxaQw7t8EZCyJ4xgNi3VVzhGNo2r7HdnTD3CMANCrMeQwH2bzSe	9930	14012	14012	1618461360000
19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1637	816	348	6301	12463	jxXVA3FroyLe6MRwKKYgPa8zK8ym6CeNpHoBgotPXXVj64LN8D9	9931	14014	14014	1618461720000
19729	3NLgAJPRJq4CBwAHs8sHTeZcCfMYevVm82jRYFhKqD9A1BRK4qUZ	19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	1637	816	348	6301	12463	jwsFUNUwdQ9SJG61sozzEFre4xyTNxvNACWsChkLYU9VPysMBmi	9932	14015	14015	1618461900000
19731	3NLCmoYD5m43Na3GLqXewsSrwbgBEb5LwTmrKEM3UJtfcAAYzLRF	19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	1516	1294	348	6301	12463	jwFrj9jCCP4D6s2rybphnCeio2kGsrPmj1xbRSeXnnoLtRTsxxh	9933	14016	14016	1618462080000
19682	3NLWiHywZnkusGBzz5jPz5KiV9NkpU2xkxJYSW3VDx4AbM7Wbu3r	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwR2hWvRdVfv6ZLzuUYVfzcvPBxeYssZqi9LuRXACWjf4uNMeGo	9913	13988	13988	1618457040000
19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwANKmQs6yW2QGsEMxcF829HS2crVCEcT5eYHGmzWEU3PLS9swQ	9913	13988	13988	1618457040000
19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	1601	1022	347	6301	12463	jxV67F23tNu6m5bC2d4YWFv6CSBQsPGVV9eyVdEa1f2BCxmSwP7	9914	13989	13989	1618457220000
19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	298	1308	347	6301	12463	jwLk5xznYxupgCujnNmFe77mrh17o3m86ZDpj38vcV2gMwDoVv7	9915	13990	13990	1618457400000
19696	3NKihFPMVpzeMj9MbpcCnykPvUxdGg2nGBpBRYSGQw9e4dVKTLiv	19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	1406	1393	347	6301	12463	jxovLkwzPcG34yjeppgK1tirCQie1br1t2CTKbqY6p85DrwJ6k9	9916	13991	13991	1618457580000
19706	3NKyQFPeJissGPLkCZa6DqevHUyEbjRFoiescCMC9k6Pc7xefTgi	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1458	351	347	6301	12463	jweFoWfa4bMtZCJ394ZPfBpY4PdQmpUrZPWF9xXP85G7dQaia9f	9923	14002	14002	1618459560000
19713	3NKAgSVZjE9rCmFV82RDUmAsDodTU2kzzofDZmZLR4fw3YqQD9Aw	19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	684	1106	348	6301	12463	jwwaMHRRU5PUiJxxaA8aMaqp8Rhxyz6cQGAPowRNvUwQviZQ2Zz	9925	14004	14004	1618459920000
19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	1406	1393	348	6301	12463	jx4STayKSawzZKR1LG2tgDk5XBjKShWhUL5b9ZYAj5z3qnhXSv6	9928	14009	14009	1618460820000
19723	3NKXb76fUHDaoCm55G9XaR5QYm3isKfD5BUHSgN5qWuthX8famre	19593	3NLt6JFFQ51yz8RE1LHxk6VcUupWouTveMZRuhGcd9iG4My1D5cs	641	1336	343	6301	12463	jxqnd8PVp5Xz4hatKaBGZb8qdbyZjgXuWUSBwQXp7898a2Dv8Aw	9846	14012	14012	1618461360000
19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	1461	1271	348	6301	12463	jxAopLtZnoKSQHnfCGP11DjVRR7S4LQJ4dWdLKWRoU996tD7xFu	9932	14015	14015	1618461900000
19735	3NLGjVm7mcsLZNtV29gWiEnkuB2ejJ6qX5Gsa87Kowh7pLG2kcwG	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	633	1384	348	6301	12463	jwEFGrWG7W2U25NRT6QJmh43N9sQoQbK9tpZLnZyXYV5XK3RMq3	9935	14019	14019	1618462620000
19741	3NKKutGYWRMpYu4xzGbC7ZypbKK5TYrBbVhXEEtvuptdAZEJGyrz	19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	1608	1289	348	6301	12463	jw7MMuVNdMPUv77HmAN7RBg9DwiXCHhpD4NVWDLdQaCdTEXpjx3	9937	14021	14021	1618462980000
19743	3NL26TgVVmvvPvt3LfKRHi14K4e7PJ9aeVYbTyd9NuJzuZVweNJR	19742	3NLxDdjvSFcshxqaEe67ojL3yK8QaQk9Wjh6LdWeN9bxUMC8XdPz	1553	776	348	6301	12463	jwvRgfzUCJcbS14Rrpd9pnxzkVi5Kx5Eyc8MQMq7ofQ3Xe7EBPv	9938	14022	14022	1618463160000
19747	3NLDki4d7fek7u45kJkRg532CJpB4tZzgb9QmHRKoHfRB4eza2oW	19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	1407	1395	348	6301	12463	jwvwh3TfRbhY9GXrNhz1VSp64SMgB9TAoL4Un9ThFbSjjW1hpKP	9942	14030	14030	1618464600000
19752	3NKbcg3Fv5q21pjBQrcJSagZVtN8qNpYtKnRvuDGc3aCMHaLsAHx	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	633	1138	348	6301	12463	jxhpsBhrE4dk7rQJdUn5SUyf9F7cm2A5gd5eS4NCAJvgFeqj8vT	9944	14032	14032	1618464960000
19754	3NKknxNMPZTQ9H9JxMkmUn6y1cJPT4k3He55uQvAmEYhNmXpNf2d	19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	1536	1067	349	6301	12463	jxEcq8zaVDsEd4MpnnF2PBiSDda4yLbZZw8iQyHV8Jnq5AGZr3b	9945	14033	14033	1618465140000
19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	19754	3NKknxNMPZTQ9H9JxMkmUn6y1cJPT4k3He55uQvAmEYhNmXpNf2d	1407	1395	349	6301	12463	jwB2PuMXaGHGjnAeqjYFbrGwkxWvWZVQwgqQJhrhK8Kph7gipFb	9946	14034	14034	1618465320000
19759	3NLX7JqL8MLxf7Xj4DityG9CodHHRER351FiwSbn6VQeHiAgZm1Y	19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	1506	1127	349	6301	12463	jwSzfZo3ppN8Khv9ZdkejK8NsMoepAUsWJ7voMHaDpRHmZsRn8a	9947	14035	14035	1618465500000
19761	3NK6cUASDJ1jMfxiunHP8rjooxcCrhJaQgFhPuZAie41tJf5M3uu	19760	3NLUbGZJg3HXzAuCunUbYRacAYs7QqQVMwKy4gD4BwYd18EUxx9M	1406	1393	349	6301	12463	jxmZetdH6bp81y3FodeyUKQ9ox9MxahR1WY5299TNyTsDqKLAMJ	9949	14038	14038	1618466040000
19770	3NKkEyNeDUcsqyF1aRGNHammgCox16ucWj5TCX2LNscKxC1hhd58	19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	1611	1341	349	6301	12463	jwW6giEsGKe6sKQRTzfJWtwbFoRC5BjbEgcburcBmmyqx4B9RuN	9953	14042	14042	1618466760000
19779	3NL8i6yw6GoC92zQzEUVFqYMCasjWMZR2pQv7neypzWJtr6YhT4i	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1419	814	349	6301	12463	jxKxbm7uvMAXgqY7y8UZthijq1d3aRty96BNrHviEYHjeCnqPQk	9960	14052	14052	1618468560000
19782	3NLRnqD5q3xYjt5e8c4Z9XppZEFidfmcjhrowEqpRdwwT1fTbLcJ	19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	1476	1371	349	6301	12463	jxwxU13RDTHQUpKSKbJxuoRaw4rqfMUSMSzxjnbyABkWPqUYPNu	9957	14055	14055	1618469100000
19787	3NKJGLmEsUUjSGPYFN5rvN99SgusopQREDTkBbKtYaLu8Va4aszq	19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	1458	1323	350	6301	12463	jxNEvdGb4M5xhoyVBr5zJfCjAXPXkrjrVurckdpje2eBHF8p4kK	9964	14060	14060	1618470000000
19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	19788	3NKnKLyTSMaBaQxd6jVPELcqpUm54WabuSUXwLZeMFxFZ8ZmqNrt	1402	868	350	6301	12463	jwKnpM3DvrKrmGK6uNfKb43JmvwEMYj4QKfS1wvFWp6EWvktqwr	9966	14062	14062	1618470360000
19795	3NLKtyj8zVvmU61Bq1thau58CdtCEeCtYXximHg1FRPDxsa3btjE	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1571	969	350	6301	12463	jwASxyTUGFt5sUwypYmNLZj79ywwEupvox3VKgiFkzZbKiZcA4T	9969	14065	14065	1618470900000
19799	3NLZuD7kztMHLKTc5eovVj1woLYBAPU3AhgAfL1H8aMt53aFgibj	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jxmN7s8Y6X9jN4cpRjYKcKLV9WxtWv69T9nV2CM8LQwr7EG8GVD	9971	14067	14067	1618471260000
19801	3NLgzuo66S6jVwMjRN43p9i5tcc8BSGhwQKkukiwE5RrFsnyz7ug	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jwZvcetG39nr3PRiQyDpEpDjJgcQtdPqc9EvJuS6TPtGiDRtSaK	9971	14067	14067	1618471260000
19808	3NLsjV8MLrRoqr1KCn22PqFoDQkWeLYZ5HXxbqoNq9cnCEwZLkrS	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	633	633	350	6301	12463	jwQiSCb8okcg5S1JEGLkRboMiE2ci42VZKauLh5sizkL2H7ceCq	9976	14077	14077	1618473060000
19814	3NKc3tZZWv1dRy8kZFD4SDG13DxmaRJ6j57nK5DnaPaUnyWPG5PU	19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	1422	1337	350	6301	12463	jxJnC2j7rXRrCmmhNLtQ6AYZKcCdxdvUzm9Kg94pxZ5dkpL6UEv	9979	14080	14080	1618473600000
19815	3NLotYLzRSZZhEDE6F8FT4RZSsig4YKUN7vTUt8ZKUsTuGyKpVrb	19814	3NKc3tZZWv1dRy8kZFD4SDG13DxmaRJ6j57nK5DnaPaUnyWPG5PU	1578	930	350	6301	12463	jy32iP1Mb9hC7pKrse134qUyJeBpW3V6gnruuJsQRvxdxrAYTab	9980	14083	14083	1618474140000
19819	3NLVfqnck1VByQwsAABppxubtgZyXvE1xGtJnGReRSP8nF3X9tJ8	19818	3NKZPdYbHNHfeTQAiZHkqEaz4rqPWWqn778F96g3BtJbhqqXo8ca	1631	794	350	6301	12463	jxiyg2AXATtpSr5tTHhaebqAXawV623z6bpve3unxnBHWCZkHy4	9983	14087	14087	1618474860000
19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	19823	3NLN4rbDdvFvfbxqS3WZXvPbZU2zBRDh85Zqv1iZCs4fJFYyRRn6	1579	1389	351	6301	12463	jxgjzjvpzonVYVNT5zCnanGLw6ZR3dsGCNHe2kyuYHKjTiMVqG1	9987	14092	14092	1618475760000
19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	19698	3NKbXGgVnupMoAxjBG1zL5NsRqx8dqgrBvjQR8wa54qrcUo612cf	1426	1118	347	6301	12463	jxcsX18zwDbGxKMKjzLR7AxnMNYtWbJmBJHW35mzH921JhkMxeC	9919	13996	13996	1618458480000
19702	3NLAJhfE1ZJGsXVVLgkffZNxAt45nvq2zZKyCFQmhm9FaSYtZ6WS	19627	3NL4LyKdTf8cYvT6k1DGeAeAsebUq7DquY55DQBFqqyVwAeCubbB	1448	1065	345	6301	12463	jxPXLccH4ZfyEVckETqqwWC5HXGv1v9bsfR5g9JyRnEJGdK5JSz	9886	13997	13997	1618458660000
19704	3NLb9XHLAGGy1NvwTsHbDAeS4BYgptha5UeJodEo3pTtmyc4pDms	19703	3NKM8Z6mShYvkQUVNvN21ik9wghev6ixb1rbwgiJuXZLCCFwwqwb	1422	1337	347	6301	12463	jxaNcRmmsUV9duura7sAN9jyqZrjtkPX42dPt8txcwg73qf2S3M	9921	13999	13999	1618459020000
19707	3NKSqhqcxVs8BxiFzUkhTSvR9988LsrAt7Sj3yomdoszUsbhRFcb	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1439	913	347	6301	12463	jxhXrkZ1cuKfSY6DNnZkQ8HMxWk5tfSo9MPKgvgohufZqnRx9Jc	9923	14002	14002	1618459560000
19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1458	351	347	6301	12463	jweFoWfa4bMtZCJ394ZPfBpY4PdQmpUrZPWF9xXP85G7dQaia9f	9923	14002	14002	1618459560000
19711	3NKFj6bchyKs2YeSwKQGcjrnrEKm7dAdNrynCV4GUcCsQgUJoYwT	19706	3NKyQFPeJissGPLkCZa6DqevHUyEbjRFoiescCMC9k6Pc7xefTgi	149	1283	348	6301	12463	jwVwMatWDfVRTc7RB3G1FHSwb4ki3VY3SD2UT9upGs1ppJzTB9Q	9924	14003	14003	1618459740000
19714	3NKvBDGhZ6MScF9CWySe1AbeQwWsfKtGQpkp5PDmhY5ftWhxzYdv	19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	684	1106	348	6301	12463	jwKM5a4Kwe62urDWwPsxgwi3g3cMZoQF2r4LXdzt2ye8kYCH2mz	9925	14004	14004	1618459920000
19716	3NKjvAB7Z8Mue6iJxNc6wLpS6SGeoFBzKzPRjfjWkb1scvuUcSvC	19714	3NKvBDGhZ6MScF9CWySe1AbeQwWsfKtGQpkp5PDmhY5ftWhxzYdv	1646	1354	348	6301	12463	jxY2NcMjFe4QLXdSjSorkjfmkVrWgwWAhK9CUtMJtVWr9WjXQ9B	9926	14007	14007	1618460460000
19719	3NKTa2mu46b45ie7YkwnRdeKJNB78NHoEkr1A7BKX5iMM5C5CLXU	19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	1490	1028	348	6301	12463	jwtsNuEfw4mN9gagWhiujJ4LNS5FRivNZUUMT6sbSRBySVw2npx	9929	14011	14011	1618461180000
19721	3NLSdqn4ffaXaqMh5HBP6ktbZCi4kJeWw3fC1pJ6z7Y9yFhASq66	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	80	1273	348	6301	12463	jwypB11AqaaamKuorKeJMm5ukF2FyhVdjWkkjphAR7KxKsQCMF9	9930	14012	14012	1618461360000
19728	3NKHF3mybHdFkbGMAKWSSKv8BJZQ4UBii4wV6b7EjE1oi5F5qc8p	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1631	794	348	6301	12463	jx3MUoyns2cWRnjg8jTSXSUMpcjFVnCkerhRjkJVsybAiEnnRQd	9931	14014	14014	1618461720000
19732	3NLj5fRFBxDYkEoWH87q27YH97HUzQJsmFMbBJgXjWhc5eSPpFnw	19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	1501	1114	348	6301	12463	jwQNeZ5K1Qc4Vajn1tXYTM59TWqxaZwFds6NSPP9gZ2PfLNTecB	9933	14016	14016	1618462080000
19736	3NKkDfyZstaKpnunLLQwCUHBfULHoxS9Cx4mgdxnJ21xZn4UTra2	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	633	1384	348	6301	12463	jxRu2EqucG4141a2vND2ed3qTpop5u2v5eqi92PDaGtVNVPieoy	9935	14019	14019	1618462620000
19737	3NLdDwSnsK8sVV6iDW1kathNyrG1uYDoPLCfqXRk4aNNdpyQBQvZ	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	1534	1071	348	6301	12463	jwKS1CZxFEs4qxcfCpvVSAt3eSLbnzvNFAuM8bN6h4c9GkktrGh	9935	14019	14019	1618462620000
19739	3NLFuaissEoEWRC2b4QXE93fLW8RVVaSL5X3VKipmf6r2rNpG5FB	19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	1483	1030	348	6301	12463	jwjmDTy6iyBZEiMrAqnV2spkyQHqPETtw1oMuN3MpdugGFKXghn	9936	14020	14020	1618462800000
19742	3NLxDdjvSFcshxqaEe67ojL3yK8QaQk9Wjh6LdWeN9bxUMC8XdPz	19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	1599	1161	348	6301	12463	jwWTBRPYGQvaFscPp5cK2puEQ5eChqcFcN159rsZNEfJaSFs2B7	9937	14021	14021	1618462980000
19744	3NLcsQV7kZdSBSuft8C8CSUUsNPfy1RGySuPbLxiNwVaKtTZmYqF	19743	3NL26TgVVmvvPvt3LfKRHi14K4e7PJ9aeVYbTyd9NuJzuZVweNJR	596	596	348	6301	12463	jxhUYqwcLKLySVmXirjt8hSQ1eCZNaT1UgeGyFRBN9NmCnJLY51	9939	14024	14024	1618463520000
19745	3NKQzu8JdN1XXSUwwkpS516WzQPdt8nxnzvbzMSqhLqHfgAgqHXk	19744	3NLcsQV7kZdSBSuft8C8CSUUsNPfy1RGySuPbLxiNwVaKtTZmYqF	1406	1393	348	6301	12463	jxH3gBgtSFrE8xRs6F3H2mPcbcCTWePkQBrVoM574ZgSt51s9fd	9940	14028	14028	1618464240000
19748	3NK53bgfMSjAy2ykvYkux1h9h6NV3tcVGAckrXCoMJ5aNhw2gxyY	19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	1406	1393	348	6301	12463	jxoAr7yEYsXvAfqEkVhx8Q4McR1vndKKZLmGhBZNcRGqm1UsDzd	9942	14030	14030	1618464600000
19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	19747	3NLDki4d7fek7u45kJkRg532CJpB4tZzgb9QmHRKoHfRB4eza2oW	632	1382	348	6301	12463	jwGQcHUxe6Xfw6YcghCv6PAxwh2rC95A12XiJsyZWLCAWG9NAZd	9943	14031	14031	1618464780000
19753	3NKihEKygs1cHdqJXQQxmV8pCXHhUjCcBuWW9EHq8nfQrtmB47zc	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	1637	816	349	6301	12463	jwHJpBVsrQsjvmjTbDJ9t956ojUXCFLoT6WLYYjxVWtQBryZ12j	9944	14032	14032	1618464960000
19755	3NLNuqY7FWy84V1XCLGoNTjfpGXGdLAxRPeSeMUR5P2yt6UMfKNn	19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	1536	1067	349	6301	12463	jwmDMvfjX8YLLt84osb7btn1hhnQqD69T8DrimvLoaHf9tcbSai	9945	14033	14033	1618465140000
19757	3NKbvGDx9aVFEa9PZ1BV3tqygPtrb53hpimcQt9MK6BxUv8Kumbo	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1588	1266	347	6301	12463	jx3txhYMkiVbkntfWunSZzvUi14yN9wZ5R8dfQocgkfsKenDsdR	9915	14035	14035	1618465500000
19762	3NL2V36JDv31sMMvVSy8PFJajhJPadqmFcRLuYSyyC6t2UAYRXTq	19761	3NK6cUASDJ1jMfxiunHP8rjooxcCrhJaQgFhPuZAie41tJf5M3uu	1624	1088	349	6301	12463	jxRK6pmCUghTsYUQ6gmb16Ucg4NX19Sy8894ULFLc4n6BLzEc2j	9950	14039	14039	1618466220000
19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	19762	3NL2V36JDv31sMMvVSy8PFJajhJPadqmFcRLuYSyyC6t2UAYRXTq	1560	925	349	6301	12463	jxHGLtAkA4dH1VXPssqd7FnUHbttbycLApCHh9NMnqxSJZGBhHV	9951	14040	14040	1618466400000
19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	19770	3NKkEyNeDUcsqyF1aRGNHammgCox16ucWj5TCX2LNscKxC1hhd58	1490	908	349	6301	12463	jwJbEAqHhDK1wwuSK71mZUmkSXSUHUGW5dLt52tbHsEcVhN3Adj	9954	14043	14043	1618466940000
19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	1421	508	349	6301	12463	jxiFt9eHuaHuzWsQcnkPtrLq254Tv61VB6A8c2Jg4mfkxu4F5P6	9957	14048	14048	1618467840000
19784	3NKc8ndK6CnBhXkUVqKPvAxJnVjgh2n6pQvQw3YAEKGEGt5tdc1f	19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	1513	1379	349	6301	12463	jxuyxGDAmEzKRe2GodaZWoqgqf1LURyPJC4fGvUsjJYbX4do1wf	9962	14056	14056	1618469280000
19790	3NKfWzhYQVU4dy4UZxkqz9tN1JAs3CD29gL5dUbvgetbG5VivzoQ	19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	1406	1393	350	6301	12463	jw8kYVezoqHD9S6axYDsejsPRYa47RuVMabnxmc4vBaMhhZLguf	9967	14063	14063	1618470540000
19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	19791	3NKCCFV287ccQTiBadoLynmAMJ9dCoEFXbgGkttYMts5FaEgQkN7	369	1312	350	6301	12463	jxM64PFhonK1fk1RRHMQ54wgoqV23bUxvh7sV2J8BKiQNqrHbBW	9968	14064	14064	1618470720000
19809	3NKLpRLZ3HLE6ihxrXyvzTU2Nb2EqB39wTys8Cs7iobyhdrSS9RU	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	1623	839	350	6301	12463	jxwQNupnwXR7FGbwikWMZGfmvX2vARCzHQq1PBCs4sd4A8ehoXL	9976	14077	14077	1618473060000
19817	3NLW8CRzdV4VgF75Wkwifdom5DtExZaMG5R7cveJopTd3pbtY5pY	19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	1637	816	350	6301	12463	jxeVE9gHgggdxhAquhtTyhrSyK4h4ERXQxwnPstVxKV3MNF7XMr	9982	14086	14086	1618474680000
19724	3NKXo7SyTpxPAvTsG8Qcnrx1iYb6u6wmT2XsWM8F7fRC3k847fvA	19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	641	1336	348	6301	12463	jxdnVXaC74GA6BAR7T4vA897X8GHL9UW51hJV5ErmZkJdthPJgL	9928	14012	14012	1618461360000
19726	3NL2gcQa9ySqtDFmJRpU4hVt23EQ3z38mqwRiikukJy7s4QFSmd6	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1483	6	348	6301	12463	jwWGCfNVLLg4aX1Vza4zWKmoDGN2jJ3wuJgDAhD1rbgUSDBmGCb	9931	14014	14014	1618461720000
19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	19731	3NLCmoYD5m43Na3GLqXewsSrwbgBEb5LwTmrKEM3UJtfcAAYzLRF	1600	50	348	6301	12463	jwpKd6pNmyxxFvKsquTLriyT5BG15mcrT3hEzThCG3dw8BorekR	9934	14018	14018	1618462440000
19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	1406	1393	348	6301	12463	jwsnhnA6XjcefydSXzxKJKfwY85V53n1CB8wWhBmvq37MbJBA16	9936	14020	14020	1618462800000
19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	19745	3NKQzu8JdN1XXSUwwkpS516WzQPdt8nxnzvbzMSqhLqHfgAgqHXk	1405	873	348	6301	12463	jwk9wVJYDbyR7LPsiZhL1YANV3nDNwfXUXZVTbbPPAVHdSu83fV	9941	14029	14029	1618464420000
19765	3NKHBXudXT8fXihJBZvuiN1rn5j2U5uH3tdh4xCZwSc9dpn3hfUc	19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	44	1325	349	6301	12463	jwsZ2ue5SCJafJUgwUswDYyp3stMPruAuVR6ipk8HcUiCDehzrB	9952	14041	14041	1618466580000
19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	641	1090	349	6301	12463	jwvzc87Hm4Lhoe71EB46rtCBZQD9MqmwiXfS6E5umM6gzjW6Hxv	9952	14041	14041	1618466580000
19769	3NKjfhyTtU2nfUhXoudtrJEtbsd7zRWtYdNMTkhwrQ8zi4EU6AJH	19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	1407	1395	349	6301	12463	jxVwGpWr77D5d1WRbBruHhzFag6NiMdgoabJmrvKqCA8ztgzz7f	9953	14042	14042	1618466760000
19772	3NK7sKv2VTScnkeGCzjsUeuiicAYvAr5ZK5vJmAw1W9enKt6E95J	19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	1599	1287	349	6301	12463	jx7y5GJx7yHoMf4tTgTwBECN1jxQgWDUhfQKt4MRahS8bbpzkfu	9955	14045	14045	1618467300000
19775	3NKBkWhpEgzacU2M8JGECbrMq6ZoEAowWFthvdbTGkDdSCdn1m2W	19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	1483	377	349	6301	12463	jxPLJPog5b53wecaujKJcD3YyzK1pxBYoFCv1Zc1y61S3vVQogn	9958	14049	14049	1618468020000
19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	19775	3NKBkWhpEgzacU2M8JGECbrMq6ZoEAowWFthvdbTGkDdSCdn1m2W	1406	1393	349	6301	12463	jwNCDQotBHzxiDgPJMY7j5JanAv1XHJBVvM3PeoDNExXhiNDzNm	9959	14050	14050	1618468200000
19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1407	1395	349	6301	12463	jxV7ZCojGAKFEvXUpYh4FKyav1zgaRbGGcAgJNWdvbGsHxwW1rd	9960	14052	14052	1618468560000
19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	19784	3NKc8ndK6CnBhXkUVqKPvAxJnVjgh2n6pQvQw3YAEKGEGt5tdc1f	1581	778	349	6301	12463	jwPYr1Z8Ph1B6k3Mg4SnLNgn5tvAGJNuC6wDZaXPW76W93ES1vm	9963	14058	14058	1618469640000
19788	3NKnKLyTSMaBaQxd6jVPELcqpUm54WabuSUXwLZeMFxFZ8ZmqNrt	19786	3NLRjDFkVKsywN946nRfXmEUXDZ1NznFRsEaqLrRDVjYiBDiXLws	1406	1393	350	6301	12463	jwNkZR1sdMJKLrynTVedHb4mZ648FLNSAHdNjKaBayRFsXGFhMp	9965	14061	14061	1618470180000
19793	3NLhrd71PvVYpb2HjQZjwJofxswtZnLuPgseicnbX2VQf6n6WDHk	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1605	166	350	6301	12463	jxBKvZhapwjgb4E9g88mEfdzEpukYZYG2iezr9fst98SQBAGANL	9969	14065	14065	1618470900000
19796	3NKbpcaeiRQuRtuhwJtbA8SbKbemBne8dmKUXKESEH5ukGb8LB7V	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1605	166	350	6301	12463	jwf1LrrEsSM2LCBtPqsdUfb2dMBuwkXXgFGyZKGDnZJ8CbeaZUQ	9969	14065	14065	1618470900000
19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	19796	3NKbpcaeiRQuRtuhwJtbA8SbKbemBne8dmKUXKESEH5ukGb8LB7V	1402	852	350	6301	12463	jwLXr719XuuwSedL8as6bXjev2xyQJ8JSdRzVCEeAammP3nu1re	9970	14066	14066	1618471080000
19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	19800	3NKjrgosMJnYpEBeqDDmZJiojEBwKVQhf6cZVycy2Dhwf6yMGVac	1407	1395	350	6301	12463	jxafWJm8ikygzspqdfVGioP5LRPGCHkE5wB48Xyd6iSVzzeYWTq	9972	14069	14069	1618471620000
19803	3NKx1JEKPHso7QGLcSLAhXaSb1XjgCCM5MF3ZehnvQtHAtnXdSio	19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	1467	1130	350	6301	12463	jwAqXZd4q9PM2rbqw1hnVAsF31yVQZDwxgw1PuqLAvtegnr3yTW	9973	14073	14073	1618472340000
19805	3NLBmmRa8VH1aG2R4v4qgpwTBsWsCGGN2ZmdrGPhoVxhvAcoeQwo	19803	3NKx1JEKPHso7QGLcSLAhXaSb1XjgCCM5MF3ZehnvQtHAtnXdSio	1407	1395	350	6301	12463	jx32PfQCLKzEz2WNoxHLJB3FcUTo2JsEs5Z3hqb4tw4hAMgjwtQ	9974	14074	14074	1618472520000
19810	3NL3guE3wPy49ouuWyGxpENvUBw2o4oBLnue5HDNAYfEeycHLLko	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	243	243	350	6301	12463	jwSXfCByqsoyJu6Hcr6sHjudcitLYx9ctBLQCuJXoKrsukXMy6P	9976	14077	14077	1618473060000
19818	3NKZPdYbHNHfeTQAiZHkqEaz4rqPWWqn778F96g3BtJbhqqXo8ca	19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	1407	1395	350	6301	12463	jx2mi7VaKgfWAkDh3m6wZWYQ2rTjJA2Nk2eeCBmtam9TgowNnRf	9982	14086	14086	1618474680000
19823	3NLN4rbDdvFvfbxqS3WZXvPbZU2zBRDh85Zqv1iZCs4fJFYyRRn6	19822	3NKrxKGr3JpYT2CzAFUeUb89ae6MFMsVWFX1QLYqYNJp1ffHR4ej	1403	824	351	6301	12463	jxWAzfCF3ckv33SSbPcQkVUU3mZse8n49cSr4ABQhJM1NPo2jGf	9986	14091	14091	1618475580000
19828	3NKSj9ZRtZq9XCKkbf1a5s5YHWUMJkpLtp6irQKMPMKi24dU9yLi	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1423	561	351	6301	12463	jwT74c4UuYr5KqXMDdHkd8GVTTGCcCMB6gtKnas4v4vp7DSviD1	9989	14094	14094	1618476120000
19831	3NLigkzhcpMpL8ebr3SfAQQ6TfzgJd7MPPCtM1KNwyKk6qLYVaD5	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1577	1201	351	6301	12463	jxAxkPoZ2HJtHhk3bwVvuKmnCtL2XLBTQeBVCj8XUKkCNEydGJG	9989	14094	14094	1618476120000
19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	19828	3NKSj9ZRtZq9XCKkbf1a5s5YHWUMJkpLtp6irQKMPMKi24dU9yLi	1637	816	351	6301	12463	jwaEAB5cnfFarYyuJjmiMF7TyEYuR8ezQrayFYSM884NyPR7x8W	9990	14095	14095	1618476300000
19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	1457	1025	351	6301	12463	jxxanFeoFzQbetbhY3xEQWmbkN6R3g579RSUQLyCQje3WE8vUfM	9991	14096	14096	1618476480000
19837	3NKiHSvFR4k5iNXLMjrdQm23gUcmTwivf4dC4Va7Rn3zjmjQXdgt	19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	1656	1097	351	6301	12463	jxHQ2P7suYie3TEbmFXW2zkBjkoPA8YaFgtVb8YMtjqsAL4JcsX	9994	14099	14099	1618477020000
19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	19837	3NKiHSvFR4k5iNXLMjrdQm23gUcmTwivf4dC4Va7Rn3zjmjQXdgt	1447	1345	351	6301	12463	jxT3RhuSL65G8RznjSMSmNrkNNVoJRYugvB2xfETkM29ffEKE7T	9995	14100	14100	1618477200000
19845	3NLsNLbpJGYkGYWVMPUfRoxkdi7PDrtpJRJBAhh94qtpLJ5FwRNK	19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	1619	1149	351	6301	12463	jwd5wQeDHF2KgUe6hwzqsYEFqAS7UYbVLtF8t4pMS7HWaCE6mRG	9997	14102	14102	1618477560000
19846	3NKrd5saMRPLRLXBZoN7wfxbwNhJVB5t2ksK4dVXatCKhYC1CK7o	19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	532	1303	351	6301	12463	jw99hmX8kUpDAXWzEQBGg93TVsdnm6Gey5RXUSYh5ZBBHkBSws9	9998	14104	14104	1618477920000
19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	19846	3NKrd5saMRPLRLXBZoN7wfxbwNhJVB5t2ksK4dVXatCKhYC1CK7o	1406	1393	351	6301	12463	jwKyrYy6qFkC9E3NNBEahaSCwGVQoBvFLmM5jKkycqYibUepbEU	9999	14105	14105	1618478100000
19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	1534	1071	348	6301	12463	jwot6K7epzLjU1mv4ESXnCSMoVwxRF73qhWEZ5Jv6KzQHwu1GmF	9935	14019	14019	1618462620000
19738	3NKBiSkKA5mRyYFBfPUVkUsTWq2spZRQLFNc7PeRGxQQnwCJzGAr	19694	3NLsErhJXyegJySzhns996Y7vXZK6xradT9cBBPrfZtUkp5hMzyx	1534	1071	346	6301	12463	jxY3ZnStymdGFeKeajna1qnADKq7nMUeERY2k3eXEbB62h7HunF	9880	14019	14019	1618462620000
19749	3NL3BYScVgwu6mig7HAVXvF3XSPNkAHAgUmS7gQrwPSwz6yxPizV	19710	3NLsrrMu4WhzhWmj4rejxnf8SCFa1Xf876jXrjyUJsVd46ryPaJy	632	1382	348	6301	12463	jwgWpUnZWVfPzhcHgGjYPoPbc5AtyB7ArmvsAL9jSBjPzpnrD8C	9925	14031	14031	1618464780000
19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	633	1138	349	6301	12463	jwqqvLzEB29z8pJ47FXYMFBZXhcUM7U49qMiR9RtWqfeVNeXh5z	9944	14032	14032	1618464960000
19758	3NKs41WVupHK5YUjpdrGQyvyfjeRkd3HxuxXywVE6uSz2c26qrkx	19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	1588	1266	349	6301	12463	jxhKCBxW88Xau9oJCv39A313Vzpfr5D1mFHhijnXy4aB7HYoPeh	9947	14035	14035	1618465500000
19760	3NLUbGZJg3HXzAuCunUbYRacAYs7QqQVMwKy4gD4BwYd18EUxx9M	19758	3NKs41WVupHK5YUjpdrGQyvyfjeRkd3HxuxXywVE6uSz2c26qrkx	1637	816	349	6301	12463	jx3MhcZZdVTcH7XCTrxZNjQZ2EnJbUuu8qEtYBHRryz5srNdGzD	9948	14036	14036	1618465680000
19763	3NKiAijJ8MfLDDFAUiNEpMZXMmr6iWrAPD7fWkCYd7aS8i2pVyj3	19732	3NLj5fRFBxDYkEoWH87q27YH97HUzQJsmFMbBJgXjWhc5eSPpFnw	1560	925	348	6301	12463	jweRSzeggs2cYQ2EL89VTsSCPNpCtrsKYVhVB5ownGp9Tq2aHTm	9934	14040	14040	1618466400000
19766	3NLbWa3efG7zb2XJdtMuzJaJWvjVMYhUW4axfLCkh3zEVrPkjwym	19723	3NKXb76fUHDaoCm55G9XaR5QYm3isKfD5BUHSgN5qWuthX8famre	641	1090	343	6301	12463	jwZqiA1DDEYGhDxa8DqQfiWLPzsxX2aDWCQRU65sxpEfXzMmD67	9847	14041	14041	1618466580000
19768	3NLJPPEMgyGbvSjtrrhdiwWPoNvm2weoJHMJ1pmxhNuZiuRbkoFf	19724	3NKXo7SyTpxPAvTsG8Qcnrx1iYb6u6wmT2XsWM8F7fRC3k847fvA	641	1090	348	6301	12463	jwCJUKZZwwJeLDtvKYxEZ6Q8G5Yx7FhgP6AEbWvuxmBC1TXgm6J	9929	14041	14041	1618466580000
19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	19772	3NK7sKv2VTScnkeGCzjsUeuiicAYvAr5ZK5vJmAw1W9enKt6E95J	1405	851	349	6301	12463	jxkJbskZpZnhVxLVebH9NnsVaqCN4kaKkhh6nVd6J6pmVhrh1fT	9956	14047	14047	1618467660000
19776	3NLmAX92racMwR56iuNBnX16Xw8UyViK94vfsLRksgAZke6weAVp	19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	1522	1196	349	6301	12463	jwxyDSoKRzhUV98Qy2JyMJkKCawUCKzbAz3juWL7WAfNuSdyKvN	9958	14049	14049	1618468020000
19778	3NKJRBsFWrFnzYjWpK8YV6zd6oBCw71RR4ZBNbanysG7w5Aw9yow	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1490	1028	349	6301	12463	jwcCagCBEJK2vGEnkxRyva9qh1BWvLiQrsLXNRD8bZteJZJvxa8	9960	14052	14052	1618468560000
19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	1476	1371	349	6301	12463	jxsGLWvhJzgJQU3dWZXRhdqgKjQHrr9RyTgzzuEzEot3GmwDiJt	9961	14055	14055	1618469100000
19783	3NKM1bwHzk5b3gL6NpVBAStmavRvmNFECPEuj1c3gZtXEZjWbPcZ	19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	149	1037	349	6301	12463	jxhfwYFJNbMqvJ1h8uUoVHmmLp3HinPR3qs896owhSYJCL6WR9c	9962	14056	14056	1618469280000
19786	3NLRjDFkVKsywN946nRfXmEUXDZ1NznFRsEaqLrRDVjYiBDiXLws	19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	1622	1356	350	6301	12463	jwDUcJoe6K5nfCHyDTVraXg51YMn1HJiSWDRe1eRLKMTkyWpFgp	9964	14060	14060	1618470000000
19791	3NKCCFV287ccQTiBadoLynmAMJ9dCoEFXbgGkttYMts5FaEgQkN7	19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	1513	1379	350	6301	12463	jxZGd5wQPaYo44Tqzw7U8QdrbVUNMVHEpbo5eZTpiC7yYfocAca	9967	14063	14063	1618470540000
19794	3NLPKMpVLRYdbFwBULGM5XoxcCeh7EFL71EK69kSZYke33Hv4srS	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1403	824	350	6301	12463	jwPhmanxvRCaGsG9qdcRu1eaUZGuiCQJH8rVQKHee43jgvJuXSu	9969	14065	14065	1618470900000
19798	3NL9zE2s2yEvLzD1UW1sLi6hc8gKLuxU7yDw6BC4coR9FmZnvmu2	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1593	980	350	6301	12463	jxPMNZ5RV39G3gKFhk58F1DCo5weai8S3Lr6mavaRLf2JC792YA	9971	14067	14067	1618471260000
19800	3NKjrgosMJnYpEBeqDDmZJiojEBwKVQhf6cZVycy2Dhwf6yMGVac	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jxK2oWP3CA5VRRNkQ3JmbrLcYY1KnMVvXdZX9uCwwdBkn1h5vMu	9971	14067	14067	1618471260000
19804	3NKs1fh4wW9KxJkBac4FM1m145i9QeNkXvQWWZ8F59ik7uQXwm9y	19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	1483	1150	350	6301	12463	jwTFhW2tnkjXd2tUWc5vAoWxpmmf88r4yZrQUJDQV589qmvXau2	9973	14073	14073	1618472340000
19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	19805	3NLBmmRa8VH1aG2R4v4qgpwTBsWsCGGN2ZmdrGPhoVxhvAcoeQwo	1515	287	350	6301	12463	jwawntwnZz8ZQ4J6HRLuQ99gZtTHbKfpdJPSi4zePnfxtYQw5eB	9975	14076	14076	1618472880000
19807	3NKGQedEkygoK3BEBZsDfwGBUPxK7PfNJ6Tys8TTkjnLaqTpx7QM	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	1405	851	350	6301	12463	jwBf1J5V5HD6qA4peTbw1UW5cXujjZrJwdza6zUPmYoX9wSxnv5	9976	14077	14077	1618473060000
19811	3NLMK15oge6Ky1bMnunNZ6CWztd6bYEQUTyDva6WskbDHdzREKXo	19808	3NLsjV8MLrRoqr1KCn22PqFoDQkWeLYZ5HXxbqoNq9cnCEwZLkrS	1407	1395	350	6301	12463	jx41pawa2asRnQXmMFfQttNuBJRWGW21dBiGDDDdx49gH3tXXX5	9977	14078	14078	1618473240000
19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	19811	3NLMK15oge6Ky1bMnunNZ6CWztd6bYEQUTyDva6WskbDHdzREKXo	1477	1350	350	6301	12463	jwW2f1hCob1gCUG22XmmCGPcEJJTJQucg6HbF6H78Ws59rfGYp3	9978	14079	14079	1618473420000
19813	3NKtBcQT2vbwz6oqxTjzyCEGnKbhKofwytxYQYShZCcJdSx2xUab	19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	1529	1316	350	6301	12463	jx1vs9s3qD4SRr4mE51r1ucxs7vt3p7DcCvCpTm41u3rJYntz8n	9979	14080	14080	1618473600000
19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	19815	3NLotYLzRSZZhEDE6F8FT4RZSsig4YKUN7vTUt8ZKUsTuGyKpVrb	606	929	350	6301	12463	jxeBD7YWphYUPSwWHdPAzKuVkb4Pt7WhArG6NNpSnSbbkQLBQXw	9981	14085	14085	1618474500000
19821	3NKZg2ttisyVftpu12SB65c5ZddgfYAW9PJ3KWDFYJw7wUSuarBs	19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	1555	1347	349	6301	12463	jxy4wwAQHQ6JYbGZEVfMLbSXS984thXNNroPm7nsT7hjbrSLa3W	9955	14090	14090	1618475400000
19826	3NLMm2S9zPUUEFyyySmhuQ3t4TarA1LrDK1LYPeagCzmvXSYj2uk	19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	1631	794	351	6301	12463	jxvaQpZ14j7YGgUEJCmZHKpCZkfDR2atCD4LjwYXYFfwLbcN1aE	9988	14093	14093	1618475940000
19829	3NKGz3HFZx1HccbFznsfY7bunyG6aPzywFC9ftj3X4TuPwspUuCX	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1476	1125	351	6301	12463	jxzKMKkhxiizL3gHwLjRJPp75rnaSJcPk6VbPeCEL5reqwZRZKw	9989	14094	14094	1618476120000
19835	3NLtVqfra25CqZGXeHF1HH5XthLYeqqLYvnt3Q2GLmviMyy5nBwo	19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	1402	882	351	6301	12463	jx1h6U15J69XwzzpH6NmthG7uhN22GsimrDNR1fFFiPVG4XTcPv	9992	14097	14097	1618476660000
19838	3NKnpRrkaoLtsJL7xdsMVMxFPdsMK3HwtdvYzsTg13wJ9vzyLiwQ	19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	58	1155	351	6301	12463	jxsqokZPQMTjXCmspcG4e8kTv3QZNw2Z3cKWnQsUiH1BqX4MPBL	9994	14099	14099	1618477020000
19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	1402	1267	351	6301	12463	jxhpPGgdtWbe6W4otVDJGxQsyYL7fB1dvNrmWBauKdvgNhBuWws	9996	14101	14101	1618477380000
19820	3NKR3LoD3TLQ4Gotmhg59xUYcuq9hwVMuEujT99QywJhkDTYWwDy	19819	3NLVfqnck1VByQwsAABppxubtgZyXvE1xGtJnGReRSP8nF3X9tJ8	1403	824	350	6301	12463	jwqUHVsZfVd5Zrne9VqvT9KM37TR9XPj6Qe5dcnGtzHi7XPnWC3	9984	14089	14089	1618475220000
19822	3NKrxKGr3JpYT2CzAFUeUb89ae6MFMsVWFX1QLYqYNJp1ffHR4ej	19820	3NKR3LoD3TLQ4Gotmhg59xUYcuq9hwVMuEujT99QywJhkDTYWwDy	1555	1347	351	6301	12463	jy2QVgpV4ybF5v4Znhw38VWbEy5SdX66KJTQrk9Wwk9DkEP1vHd	9985	14090	14090	1618475400000
19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	1397	699	351	6301	12463	jwYz1XQFt4vYLjLAMVdkgkaP8xkWRdKEw14X9BqpQF9s3ABa4K9	9988	14093	14093	1618475940000
19827	3NKLktBQKZTEf9VR8fxZGz4UaccXJgSs3jgZ8zgUn3PmPG1A71p4	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1542	1304	351	6301	12463	jwXdpDBjhPbpkNhsHAquAWmYTLUtEyJdBgDQAUenXGK1VH3F9qs	9989	14094	14094	1618476120000
19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	19835	3NLtVqfra25CqZGXeHF1HH5XthLYeqqLYvnt3Q2GLmviMyy5nBwo	1534	1317	351	6301	12463	jxrD9od5Qnkfa8mV7P3PN7GkAS8bxcstDJP7JVzwEQyzpSftvEN	9993	14098	14098	1618476840000
19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	1559	1353	351	6301	12463	jxMmc3mofNoY8oB5L9q4eksZUUaGzzUJGvUgquFoCTAjfBqpczA	9996	14101	14101	1618477380000
19844	3NLpcWsFesKbesARzHWFbbzQLDNGQP1Jto7MPPYwTrisRW935Agi	19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	596	1180	351	6301	12463	jxEsGCgAz8ZRd1ushP1EEHpNpndmb6v6fnxEGs6t8CNbfvy1cf2	9997	14102	14102	1618477560000
19850	3NLB1hQ6wdSHQbDB1L1xYMUv6oARhWz25uCMg4oeyW1jjDrs5Zjx	19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	152	1084	351	6301	12463	jxziCkAob1uRrz2Mz83yaYLKvQkfd9WtHNG2oF4vaBQzu3NRTen	10000	14106	14106	1618478280000
19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1657	1344	351	6301	12463	jx62Tm4VKq85g83ZDJmFKdWVBKkWfLDA5c1KrWY3JSu2aL3FU6r	10001	14107	14107	1618478460000
19856	3NKEQqcktCMj51TUzRA3JQt84w2LJKPUEvT4djeJofZbYLXG9CHL	19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	1403	782	351	6301	12463	jwUVgaD8ztNiLHrMNiEnM6aFN6YJf5NBJZ1J5P8zgTpdRf9ieFZ	10002	14108	14108	1618478640000
19862	3NLXfiMRdv9fRq5QwwVxqtzH25QcaxYTvHr2KipznVok2BuPafY3	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1440	1131	351	6301	12463	jwbi6F79L5mCpQmyV5wDhNypNUP63jJzeiCQRnuVdGcWC6k8jdF	10005	14111	14111	1618479180000
19867	3NLDVvizXzmzVybEniAbjVsC9ftwzGWDbQrBSnSUeH9iDzp44miL	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1652	1315	352	6301	12463	jxpXuYWXZo4HS66rxryjAjHap1UKQPynQckXYYzZtSk5WJxgXus	10008	14118	14118	1618480440000
19869	3NLQRwTKdGUKBovq74YELEBz2erfJXHrMFM1MDcXw76b7Y76bgof	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	484	953	352	6301	12463	jwGzr5PpQWYZ3DAcQPsVU7yQjFxeLHpQCHpsnjSyFvsFZR4aTi2	10009	14119	14119	1618480620000
19873	3NKVBWNv5bRWRxBFASkAkB6ET2AUxPmQaiW5ywJDUGVjErxYXYdb	19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	337	337	352	6301	12463	jy1ho4jGGBBjaF4MfGsn6rknUPq227UiJr9NaZhq8gsNwyBeT72	10010	14120	14120	1618480800000
19878	3NKLUn3dWUohbCpanooFi9pgDMZFmkDSortPnAXQXAw4KR7xVE1G	19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	1508	1021	352	6301	12463	jwy8vePCfyhQtx5h68Ee6UscZCsm1pFPdQ34VP1QGvfy5usn8T1	10013	14123	14123	1618481340000
19881	3NL2hZmJ4EsWpBLf3nait5gbRy9gDAKQGsA6zK2P36Er729k7pK8	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1560	1045	352	6301	12463	jxHp8DmCLW6oxWyWRwXsvQDsoJPpHf4EhzX642CVH3zQYShVzPU	10015	14126	14126	1618481880000
19882	3NLJunV5pzoUPdkzNg3kGnaUQeM5mV37ciXZaTBTS7zCeYmBCx7G	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1419	814	352	6301	12463	jxoKz88UYAHFhVKh1ywB6NZSxKsjmpJF98BbPYaJFFCkjRvRA9G	10015	14126	14126	1618481880000
19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	19881	3NL2hZmJ4EsWpBLf3nait5gbRy9gDAKQGsA6zK2P36Er729k7pK8	1649	1383	352	6301	12463	jxxep9yokwQFivgGzsUCCAyZfqhHFVLAGcPj2tujYNfwrLSCTPT	10016	14128	14128	1618482240000
19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	19888	3NKJitpuLy6EV6aakzYP2yjNbWynJFa17MobSEZHj7iQa91wbX2j	298	942	352	6301	12463	jwQUu5RMXdb4pA3A9wSfc35ZKi9YgvSmXjfhfLrCvWM42RGA1jn	10019	14132	14132	1618482960000
19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1406	1393	352	6301	12463	jwJ5mScuNZiUVPBimXpEWi88dciNcrCMtH17gFq8FTcWMi6sUAP	10021	14135	14135	1618483500000
19896	3NLEQnbofs6zSy6SJKZHHdHtMJuPHVfcvP5TZchQo2VqNJWT6nFd	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1407	1395	352	6301	12463	jwPBCeDEpPMYGhySXRRNGLEtsSKLDAN2mUHQF5oeE677ymkzSXz	10021	14135	14135	1618483500000
19899	3NL2WAaRcptcBJooqjRMHBo95nTb3CdeVECdVuBKktXZvMbDGRZc	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	369	946	352	6301	12463	jxbUnJKQYTyB9BP9UrqeLiwj1opsxD6oqEnryn77azPxUtTJrdD	10022	14136	14136	1618483680000
19903	3NKKKpk8PKKe4wi18wV2F3fphioF8Y6FE8kPLSFCZkxgVfdR7KWa	19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	1675	1342	353	6301	12463	jx48QGWw5s6atYDRnsRiSTHfW5kx4zPaqRCtojgPKGDXiDjc5rs	10024	14139	14139	1618484220000
19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	1672	1285	353	6301	12463	jwGrahiGCiSc72eFRSpnkSbvUMUX4vGsGhQRTQkrgPyWkLaNNrT	10025	14142	14142	1618484760000
19908	3NKeqQrCCrHWyKsuNsxu5LypKpFx86WyhSfnKUpAMgrnuxEyAPrV	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1406	1393	353	6301	12463	jxr5ttfBNH668hcu52nKDMGyrzAYGs6nHoU6TQ2BVVyN5xMH9qt	10026	14143	14143	1618484940000
19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	19916	3NLodbrfTp3Jh7nTfWaf25cDgcYdnMy8rRVMKPZHLwWUZ3HdK795	1403	824	353	6301	12463	jxofYt7KsJcescswSBeYgtFEmB9wfGcoBXiCep4xzwx3w8y3otf	10031	14148	14148	1618485840000
19920	3NKQfYWgRyUG29kNVju4vMuQemJMPEXm73HfLMquqsgfM5icsBKa	19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	641	1336	353	6301	12463	jxzUUX46XZvrvhJ5rtB884Bz3sDGacM6EquXmmibHiBRDjQpEzT	10033	14151	14151	1618486380000
19932	3NKjrXnBkDXhbF1RG5CHdNd6QeyV6kg3qNKg3uDM6uWed7xe46Zs	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1402	868	353	6301	12463	jwUHkhsNQkBbM1hypLBBRjih4RfSM27ksj3wYeyzJgb4oSgMA2Z	10038	14156	14156	1618487280000
19934	3NLjZQDkyoop8bbDef4X8fUknSxF4G6LgXiRRQmbtZj2XY2t7NGv	19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	1637	816	353	6301	12463	jwDw2MJr5EnHo3JRpKRvKNWuhfSyzxcHjpRaj25N9MpAgF86NnU	10039	14157	14157	1618487460000
19936	3NKG2jH6oDrTWzfCvTpLdCyavdx891xinkdt6D5dP6X85jxXUkQZ	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1407	1395	353	6301	12463	jwbixh9wt8cByYXRXc8Gre6FHdw2FrSri41CVc211qJhK8SMwKW	10040	14158	14158	1618487640000
19938	3NKdnV2ms2T3nUo3BH1h6do2CCuUnJvRkYC6Jy9qAT5xRLe54j1L	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1668	1124	353	6301	12463	jw8wSADRmeQd9g2TCqKpZa9Grg3h47mw8xbTndqQmZydYcJXSNT	10041	14159	14159	1618487820000
19942	3NLtWGdZRcUgsj7nTnfy7L5iABEWi6XGdGcy8q74oTEUf6BEPvqQ	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	632	1016	353	6301	12463	jw8kK2htLnh2N3Cjts8RsK4NurE2vWRrpiX85V1AEfwWXRzeSPV	10041	14159	14159	1618487820000
19830	3NLuViLZZ36gLUDDFJ2hXqcZs2J7H1YpLk2SSfeQDWiXnwJ2wmtM	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1601	1388	351	6301	12463	jwJCwwpdhFR9biKJQmrJdKUARp2kzcnNtRvmMF7cp5rvRJf5s8y	9989	14094	14094	1618476120000
19833	3NL5GsFzhCKJcSNLSZ2wrUJdXZnCDT6yWLVTj7NptBvmbrnA1xdX	19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	1663	650	351	6301	12463	jwbxSbQMKbW3H9bJEK2KMTjUJMKPXcvsDS72WYxtwJ4iLGkQKME	9991	14096	14096	1618476480000
19843	3NLNWxa9GWpcAn1NF6ULPVifBm77PTWkmBsPvaQA9EZQNftJYrd6	19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	1619	1149	351	6301	12463	jwYsGGiC5GQcspaJuMejDbFnQUkeSh7ncMhobzYzqizpP4erzMr	9997	14102	14102	1618477560000
19847	3NKkPLyVnfSFwPmKpmZSRi7MoGvSk4dNnrESLjShRLrQSrLKKYfn	19589	3NL2hLumxPjaayaopL9s5sm9mV85RTRFvZh8e1QNv2EM4sjbCaZE	532	1303	342	6301	12463	jy1pHYRiLs11xG1uwQcNzgEjz2k1J2fVNptcVfg2kHgE6Yq4rWb	9838	14104	14104	1618477920000
19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	596	1060	351	6301	12463	jxUz36yLYqGevFdLLmw58NLVddgirH5zBf8HYhTRX81JYrLSCsq	10000	14106	14106	1618478280000
19852	3NLxvxZCWg2J9NCsV9RAajjAZBf1wacxaPhfiyMYzBE8rvbDswsZ	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1670	1282	351	6301	12463	jxhYpesatEe5ZobngZgHHzgXVBqWYQ9VJsMoKPPDdJ7XRfP8Y7c	10001	14107	14107	1618478460000
19858	3NLtKx82ZEfLZDw4awGYTa2G1Na8aWndUjzoDxcRpoHXZCjiGGQ5	19856	3NKEQqcktCMj51TUzRA3JQt84w2LJKPUEvT4djeJofZbYLXG9CHL	1407	1395	351	6301	12463	jwCh3mRSYFfCFnG4eCWzcb5YF76nTATPBFcvM4BrQZyaF5wwKBp	10003	14109	14109	1618478820000
19861	3NLFara2XeR5sEdtW9bgEDLHTDY5Eeos8zmYWNNGhr55WBuGKTdz	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1403	824	351	6301	12463	jw8mUAp6QgdCHHRfWcjeXn97L3qpnpijUN2VBZ5tZK2zcsTjPMD	10005	14111	14111	1618479180000
19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	19864	3NKky7KkYZCEVboy5djh5gEF6PD3eSGBUAsSdy2ZkWCP2p1snxJo	1406	1393	352	6301	12463	jxqf7oxYpiKxt7ni9qRYfp4t88UaTYR6SK7EP5DECC7cJcrHNEs	10007	14113	14113	1618479540000
19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1471	1020	352	6301	12463	jxWFd8npBPdyjsUmk8MD2i9wiofHnQaQnEjv4Q9VGs5gCcNTuY8	10008	14118	14118	1618480440000
19876	3NLugyMZ1rBiQyHfcvGq76yfrrHTirMwKdvB4txfQ5zfHWRBMKPU	19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	641	1210	352	6301	12463	jwxopm4RZfuybUJMALVsMvg8HdYLxzDS31JcpqZaHGiXgLQE7HJ	10011	14121	14121	1618480980000
19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	19876	3NLugyMZ1rBiQyHfcvGq76yfrrHTirMwKdvB4txfQ5zfHWRBMKPU	1403	824	352	6301	12463	jx2EAibijE3gkJNv4wTEwXPwiswWYz3cBheseiCDGxSH7GXKoJi	10012	14122	14122	1618481160000
19880	3NLAWUiBBPbJJpHCnrYxoW6rthtbAxYhoJZYL5TP6BTw7fBk31Lg	19763	3NKiAijJ8MfLDDFAUiNEpMZXMmr6iWrAPD7fWkCYd7aS8i2pVyj3	1560	1045	348	6301	12463	jxzpMtfEAss8WvdgKkq7hdFxvuhyjHPXVsJHgma4Qbi5H5foWQ7	9935	14126	14126	1618481880000
19883	3NLmhn35AeRCdCcz8PTzFZQbwNvqEUZ66vZpSiP78N4KU3Fcxpwg	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1419	814	352	6301	12463	jxT5HHUb9F7ovUoJrw8FmrFsDmCuDbsYGYrenpZaom3vuyNBtN5	10015	14126	14126	1618481880000
19887	3NLhm9xMDGFwf3xoEn9Q4FXQwyEfvNteaGxRNQDGZ6ZeV7ujfWTv	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	484	1319	352	6301	12463	jxtqPkvRCitGm97jhuH1BYq1Bf7ToRuWnCypFnjC1eNJHJ3bAmH	10017	14129	14129	1618482420000
19888	3NKJitpuLy6EV6aakzYP2yjNbWynJFa17MobSEZHj7iQa91wbX2j	19887	3NLhm9xMDGFwf3xoEn9Q4FXQwyEfvNteaGxRNQDGZ6ZeV7ujfWTv	1593	1346	352	6301	12463	jxiecDU7c6RqxDJsBHDLHRYDZUp7QUJCT4Riukdk2vt9yQaHn6h	10018	14130	14130	1618482600000
19895	3NKG5ERdG24r1kzGdhUo6DVcaHW2sxmTCA2FA8VgupWQaP7rLQZT	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1637	816	352	6301	12463	jwYnwELzaaoEskcan5uLgJT9td7EPqdkNsK3LKYoTjvy48AhUcv	10021	14135	14135	1618483500000
19898	3NLvAGyoFBRKRsLKSzUtqny7ptnvk6yyurfAGsMVKz8ugtLv3TEK	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	1458	1323	352	6301	12463	jxxdu7qosgUxqXzMqnPe2GpPuU5tmS3GoXmCJsbE2R5uhHB4tAY	10022	14136	14136	1618483680000
19905	3NLYtEokqn2LGV8o1gwfvSYujroGY9UtYY7HpiBbnYn1iriBB8ty	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	1406	1393	353	6301	12463	jwMya3G6MctZF68uaWNdLkthg3VzBQ2bsq2bVLQMn4y37jFRRZS	10025	14142	14142	1618484760000
19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	1471	1386	353	6301	12463	jwN4rJU53y6hEM7bxHZfEPmoXiU6pbDCTmub2rJY5gVzgFygCny	10027	14144	14144	1618485120000
19914	3NKp2phvEvgfCzQo8fjN4E9krZkpuwo3gtrFYtA5JMS3zZXLfHiW	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	1553	776	353	6301	12463	jwKicX5XyW5ra8whz26AE9NA4CVaL36BzSsad3kdVC3iQjMPL81	10028	14145	14145	1618485300000
19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	1650	1375	353	6301	12463	jwtxdLQ6vdRurPUdYsp4Wu1ys99UFww4HzgM3vkCSAoYYACFrbd	10033	14151	14151	1618486380000
19924	3NKJB2YScYr3JpXccREAdMCFXBP1j7u9ETmawWYtx6DjvsaMJ5ep	19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	1509	1074	353	6301	12463	jxUZ9E5idx3AdNXJS11YUd5D6U49su4Ht83KfURVLtXYpuvfxoW	10034	14152	14152	1618486560000
19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	1422	1337	353	6301	12463	jxgmM3vA6m4dF543REBXT8dVbrUfMNjBCyWHvAidZYsBsQymFNH	10037	14155	14155	1618487100000
19931	3NLZonpRNy5uPLm3gHFbR3tpvKFfh6g9DdM9uk3KqZ3daBKSySM4	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1668	1370	353	6301	12463	jwt9auUxedQZrRYWY1Jc7LP1V1e8k8Z6ZSQakm56ZeZfnPoRPs5	10038	14156	14156	1618487280000
19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	1602	1123	353	6301	12463	jxRCowpWRT5KuszSXqPShTeb6wJYtZRxiMpYoHe98BGZey5kfdM	10039	14157	14157	1618487460000
19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1439	1033	353	6301	12463	jwAzN1kdE9GsLVcC5xJyaqxbbqPtkgTKDbVLBtBhoiqzNcnLsGw	10040	14158	14158	1618487640000
19941	3NK9u8khnguAQnr1KEGMJCHgDUukK8BRLBwg1FsRUHy5dSurrN8N	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1407	1395	353	6301	12463	jxydwAdCJVESP2XCCurMvUoimB1ec45zhJvx1GBwABkonixNstF	10041	14159	14159	1618487820000
19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	684	1226	353	6301	12463	jwKbqv3x7zVBDhgRLycL19CcbJh7QzTCdC99Ya4UxHLFgoLZZtM	10042	14161	14161	1618488180000
19951	3NLHWYAGtsYmvZN7ip8cihJ2SbN8bFUJAjpcECvgLMaCpfVugRLL	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1652	1315	354	6301	12463	jx4k63xGMPjiXmpzzikQyxhPvDF8UcxwTQ3b4xT2q5pvwFoho2L	10046	14168	14168	1618489440000
19957	3NKtYoLkkQo3D3WyfhWiNwNFvKZkPmTu84HHenP14qXKPFwt8NJk	19956	3NKvLBsW72gWCeKbdqn3t3NVEba6s9ZdXyHEPEMPJ4q1if7s1hz9	1547	1378	354	6301	12463	jwCjgU53CzyRRztMvv43FXp1qawT2RtgWZGgec9MDwjm4q4AQGU	10050	14177	14177	1618491060000
19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	19957	3NKtYoLkkQo3D3WyfhWiNwNFvKZkPmTu84HHenP14qXKPFwt8NJk	1439	1153	354	6301	12463	jw8zTazedYLRPGN4U8KVfecabEmPm4ZE7AGUARBVQSSidWgk72C	10051	14178	14178	1618491240000
19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	596	1180	351	6301	12463	jwzxg9RSDW4bhhan82kNK9RyGyqaNmeVMqvJZB8br9YnRePJhWH	9997	14102	14102	1618477560000
19851	3NLpxsyVVG1BovcXZgoeBPDe8ZGd6oZfNTgX9sv6nxsViC6WHVqC	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1406	1393	351	6301	12463	jxcZXUjEYzY1uw6GVY7qiY3u523jCL33ps6s9wd4JVfbcGdXHDn	10001	14107	14107	1618478460000
19855	3NLdHqqPvPmRbF8jUE4J85viacFA6yRa8jPGXmHZVYJb1Wsh7iRj	19847	3NKkPLyVnfSFwPmKpmZSRi7MoGvSk4dNnrESLjShRLrQSrLKKYfn	532	1057	342	6301	12463	jwPmJKyCxg2262HFhC9fczETeX8Sd6zzMdR7urcV2ei7s3TEwbw	9839	14107	14107	1618478460000
19857	3NKJMxjvM2Esmo9qWyfLNFMQSHMkJtjvjUwcZUNQ5QBBtmeump8w	19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	1650	1249	351	6301	12463	jy2KVAzoGiN5hvRrC2QKNrivPoysWP2ddkH9RnrbhvjmSPWWrtD	10002	14108	14108	1618478640000
19860	3NLk5zCrJb7tbCuR3gN61N8LLAQ7LLT3NXAf6MmyMKiCzeosh1ZA	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	350	350	351	6301	12463	jwiv4vhA1YgydyfedMf4jS1KJU4eLsfLXm9KEM9p5bvXXHKS7Wz	10005	14111	14111	1618479180000
19864	3NKky7KkYZCEVboy5djh5gEF6PD3eSGBUAsSdy2ZkWCP2p1snxJo	19863	3NLPtUJNFi5ygksdJdpbKV5xpxyBe59CConpd35U2LYZW2DMT1En	1406	1393	351	6301	12463	jwjmAic2Ld2m3xkhGJvFdKxTrze3121UUupVmH2oGoDjg48dy9d	10006	14112	14112	1618479360000
19871	3NK77CeWSAH61kLkDBq3JtLF5yLoLg2gTYvrLrmnb9uAbws6vMNR	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	1553	776	352	6301	12463	jxQgHK89evsnzkmeaTWonXBLuKjENTuZH4U23XbKgbtk4mGiYiC	10009	14119	14119	1618480620000
19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	1403	824	352	6301	12463	jw78cBE96KuJa1NAXZjXRUT6EqiSt5EwAYPmxxKmvTLq1WEHbGK	10010	14120	14120	1618480800000
19875	3NLWbWj5US2atTS38JkecFofgRN3BUGhwsWGtMMvD2qbAeKJtb6m	19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	641	1210	351	6301	12463	jxZvpjfDCRLwMosss2ZeAFh74MdvH43ECgQmvuB7QfW9F9Fn29L	9992	14121	14121	1618480980000
19886	3NLDE7781p6kZqxtCWpxuPsijnKnmPMmreNNnFTBHK217YffGptG	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	1622	1110	352	6301	12463	jxLPZPnYwKQa8TrzjSsfCuC4eainUWBHbmEyot2LAzieJ2VCrPV	10017	14129	14129	1618482420000
19891	3NK4buffRbQcVhrNWTHZ57ugNqKnTT75w5cQLM76NdfEbw4y4yEB	19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	1534	1071	352	6301	12463	jxKkSRnRX2WwBnTrzudtUSgYiNtK65cckbNnJBH1rPJmnSnxqja	10020	14134	14134	1618483320000
19894	3NLYo2aMaRPvpm69yjk3BSYPMm7cKU2JoqXNy6kqCC4FDdKjxeTg	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1555	1221	352	6301	12463	jxLBScpFvHdXoAMhYK2Hzmeu438PJN8BPktPY8L9ycjEemnU9QR	10021	14135	14135	1618483500000
19897	3NLXrUgZWToCiDjpvg1MdKPzZ2B5ueMWLWwkAc8qC16WGajdaz4c	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	369	946	352	6301	12463	jxbUnJKQYTyB9BP9UrqeLiwj1opsxD6oqEnryn77azPxUtTJrdD	10022	14136	14136	1618483680000
19900	3NK4T4RZ1vND3pdtBw2sBaxCT3hiSoiHtqwBTfqM6jtiU6MvXeWG	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	1481	790	352	6301	12463	jwrRgY5kPJb2vuGjwHyNcPDCRBTqf5n7SbKhE1VbJsp4KZjBpq7	10022	14136	14136	1618483680000
19902	3NKtGwQkMNaaHpDbWMRev6KJmcYBTCu2r2XNAidqEoMTuBeHY4EG	19899	3NL2WAaRcptcBJooqjRMHBo95nTb3CdeVECdVuBKktXZvMbDGRZc	1590	1300	353	6301	12463	jy11ozQmbJWYAf31aYHUK7NHBbakmcTbKws71DLoSX58ZFFAkLC	10023	14138	14138	1618484040000
19910	3NKsVj132gCHQyM98Xy4DoamjoEGkg664RWn6o1wR9UQpLB25GgT	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1637	816	353	6301	12463	jwgbT9wB2MDiMBMLrjCrpTPfch45A2w4QgDLnA5GCXHqKjf7dYm	10026	14143	14143	1618484940000
19911	3NLGZ7X6gPP2vH7rHSSZhRfQZLeD4mj6uUyABZocsPswmGmwnX57	19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	1503	1277	353	6301	12463	jxoaqtpMduTgMsSu4xQFaMRfxsnBUDVvxqoSj2j6qN4zTrhXLTt	10027	14144	14144	1618485120000
19916	3NLodbrfTp3Jh7nTfWaf25cDgcYdnMy8rRVMKPZHLwWUZ3HdK795	19915	3NLskcayzTcCMrH35ZA6X8phX2gJbfUkcqCmwmSF56buAMUjY1XC	1457	1145	353	6301	12463	jwfZYma6Zrz96rEXU8Z3xYnRZUFYb7LV73nQnHWUSFfSSXwyxhH	10030	14147	14147	1618485660000
19919	3NLPYtBaEkDuaA5HEmMMcA7VPtx2GUiVennh9X5v8RgqDRGBR7hz	19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	1590	934	353	6301	12463	jwUtpEgMhZyBWjcfVNDakzpdxmS5ZF7CczP32nc93LJK8UQfFVi	10032	14150	14150	1618486200000
19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	1403	824	353	6301	12463	jxDz7YhWBekuZZ9SyweKb3B66whSTjQXuZNKaPhGLAmnWNnGKoM	10034	14152	14152	1618486560000
19926	3NL9cAeP5iLaKDdrvKgrKD3w6PWk9UbkJyVK2DCThE4ubPjUJqNH	19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	1637	816	353	6301	12463	jwzwEtcSE3FYUfp1JFHs1YPHdbbTWAYhyoxBLyet142rQTfGyui	10035	14153	14153	1618486740000
19928	3NLxnPqCXzANMgXg3Z6UzF8qYdydG6DNPPGx2sm1cAvkTve98pDw	19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	1422	1337	353	6301	12463	jwEWCq6pPmpPb3crxXp6P23UFJWC4rw9nYdre1bAkbVax6Ncjys	10037	14155	14155	1618487100000
19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1467	1250	353	6301	12463	jwas7MQjSfBkxoN1myoNcXyLUeX4cQFeJkmCQEHbJmjLw1yF1qS	10038	14156	14156	1618487280000
19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1589	1286	353	6301	12463	jxBbzY4kE5g68oxQRk3Hq7WJRuqZLwVHtssC4GSabEatYWf4jZN	10041	14159	14159	1618487820000
19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	19946	3NLMHG2cqipC18E6EFuwKyKz6nQhjHDiRcSnMZJunNHF7cpJ1UbD	1637	816	354	6301	12463	jxMkraPRPsjxFCggpGZdHcCueB3oqZsR9uKUF7AtHL4r6FyrfMY	10044	14164	14164	1618488720000
19948	3NKYZVKwtbEwqqmsU2pExNkjrvPpXHtBW3gJYPWgETZtBMDF9GFi	19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	1589	1040	354	6301	12463	jxf2aAq1DTzHs55MP8DoztEP21JRbj3FJiHvUzjd8ehYuWZ2bBw	10045	14167	14167	1618489260000
19950	3NKNyWhwJo19gGFxLnMGKnuZy18Dx8xZSX4CfhZUV5hRSm6HFUjf	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1445	1044	354	6301	12463	jwmHp4RdFnatZWXbMQ6qjaxYLTZ48LQKPgqyvoAQUqyzwcYwxKJ	10046	14168	14168	1618489440000
19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	19950	3NKNyWhwJo19gGFxLnMGKnuZy18Dx8xZSX4CfhZUV5hRSm6HFUjf	44	1079	354	6301	12463	jxsh6UE2r7w5Hn2TpMka2oGMAe2eBkLFhf6Jh52XJLWmUXpb7vr	10047	14171	14171	1618489980000
19954	3NK7hpBe2L3rMKrstmoBpHPeXvpfVXMZdNg1m6hqggENWQDH7zwk	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	606	1295	354	6301	12463	jwvw4yT7ixBQJfVuMBUeJtozLbuAjHJWdKWc5jHZTJSYnn5Hn7V	10048	14175	14175	1618490700000
19956	3NKvLBsW72gWCeKbdqn3t3NVEba6s9ZdXyHEPEMPJ4q1if7s1hz9	19955	3NLr6jCYpnaFPjJgsJuc4nQhz4uUdfn1Y64ByWoR39PvELew1fQP	1406	1393	354	6301	12463	jwPuUFoG11wjNL3iEdT3oZRDpypHkj8eqhDgMTPkdnVZk9FtmHR	10049	14176	14176	1618490880000
19966	3NKDixwrbxLZMTT5hTVKGGnJBtfrP6kStTtzv81EhkTMsZ9Lryvu	19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	1560	1291	354	6301	12463	jxSiV6V5eYtSS3FzCSdpnPLA1w2aqEpunksjBY83ELoBL9RHRkP	10054	14181	14181	1618491780000
19971	3NKu7HryJHJ66U7LhwxcMdY3zCTMGUVySDEfvtHnyD32eCP6qoXY	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jwsKpNTCrnRHdN5V8Sj18ieRYxpzWCxmZ8FidF9LsL2fKUMftNk	10058	14188	14188	1618493040000
19854	3NKwggyVzLZfPrUKfMqy5mbRZa5nroQ3ChwPCofwysPKDHr3YcpV	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	532	1057	351	6301	12463	jwBwPi3ykc8UoU2PW1GeKPzcQa3JDpqbPwGuUWW28LvfzRdgkq7	10001	14107	14107	1618478460000
19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	19858	3NLtKx82ZEfLZDw4awGYTa2G1Na8aWndUjzoDxcRpoHXZCjiGGQ5	1407	1395	351	6301	12463	jwavJZFafLEyxyyAwTxVtSM8uBPsX6nRwwTZ3KGgZRRMKC5oofP	10004	14110	14110	1618479000000
19863	3NLPtUJNFi5ygksdJdpbKV5xpxyBe59CConpd35U2LYZW2DMT1En	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1440	1131	351	6301	12463	jxWkuaksMniTwr98JWbNLVqShUgNvBbFBdeCXqbEFyJ4wDLdgSb	10005	14111	14111	1618479180000
19868	3NLUKNMTiDnXZhTYc4aHfC2SDA3vrM7VmPqBxEwjoYrEdhTdrU1i	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1652	1315	352	6301	12463	jxmXj2d2RnPEBukz4y2ZSFFgbVXsNqY19W7mpKqkHzAMK67CEa8	10008	14118	14118	1618480440000
19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	1611	1215	352	6301	12463	jx3TxDSQxFaqPTz33Z16ocJwHmCtHBNYdfzN5pg4VoKJRXqRaYK	10009	14119	14119	1618480620000
19874	3NLsdEhcNbcEV71MgfiGfmTCtyhS4DoBPeuk49ZusnDFZZ2zwocd	19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	1646	1228	352	6301	12463	jwkJZ3TKSsTmSEDt7fc6XPuwx49MjatK84bpGSBSPfAYuJHnSKg	10011	14121	14121	1618480980000
19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	19878	3NKLUn3dWUohbCpanooFi9pgDMZFmkDSortPnAXQXAw4KR7xVE1G	1581	778	352	6301	12463	jx6kQyxjadXH6t7oFCCP5QxdFsjVajVSGk8fNeM3vSx8ySL5k25	10014	14125	14125	1618481700000
19885	3NKLeCskU4AYGQqcKKn3UsQFswgAfboDSbrCybidkFQiBRukNSih	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	1622	1110	352	6301	12463	jwgSMNCSn4xXsPAzYE1ECJmY5o6ZQTx5GQSpRdzczC34RDxDZiB	10017	14129	14129	1618482420000
19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	1403	824	352	6301	12463	jwP9aWvbPefYyndAvAxGUKLwFKpZPVVS2PjG6BmGMcHSBbqfzKJ	10020	14134	14134	1618483320000
19893	3NLUsPBiAL1v1CRJmkHT2R37vtPWTuw5p21nCnQrA1bQvMyp51u8	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1403	824	352	6301	12463	jxFpXMsCCDi98MHwcwjmVMWnJMZWDK1NF9e5sq9oqZ4C91Uhvjg	10021	14135	14135	1618483500000
19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	19900	3NK4T4RZ1vND3pdtBw2sBaxCT3hiSoiHtqwBTfqM6jtiU6MvXeWG	1637	816	353	6301	12463	jxxiAeRMqbX4WCGDv9j25AicPz7k7Fow7aJc4kY6zTZjoUVtanz	10023	14138	14138	1618484040000
19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	1397	699	353	6301	12463	jx1jQy2nWb6xmhzywBEhNsPi4ZVkKv9FSexgKvajeMC6qJMgY7M	10024	14139	14139	1618484220000
19907	3NKqrUA3oTa2RC6eFJYFDYvcbHtKDBwBjcKwq7tAUaAG5s9cFyaq	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	58	915	353	6301	12463	jwYi9AurJEFxYnVE8mdME7gxs2LJTKvw9pjT1HtB4BFgMYJjPDe	10025	14142	14142	1618484760000
19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1536	1187	353	6301	12463	jwZYyof73jwTAsJYjaxYqiKMKuzyguCHEzH9PoWx9LhFpTVJipW	10026	14143	14143	1618484940000
19913	3NKM6eYYwGZK7XDLhzvs7PkV7v3mhGs2AvLBFLLM1axX8RUSRVMt	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	606	929	353	6301	12463	jwCod3eCFNsR1SX9xBwKKNUgRNUHA8PYGdBXd2YHnJTBvoNLDTv	10028	14145	14145	1618485300000
19915	3NLskcayzTcCMrH35ZA6X8phX2gJbfUkcqCmwmSF56buAMUjY1XC	19913	3NKM6eYYwGZK7XDLhzvs7PkV7v3mhGs2AvLBFLLM1axX8RUSRVMt	1622	1356	353	6301	12463	jxnc65PXxazkaU4wWiHNbU6X98o17ob7APFmKWjEeYvx6aV7XUJ	10029	14146	14146	1618485480000
19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	1670	1156	353	6301	12463	jwJfm7cARkvGcyW7wJEsu8CebSqJjQGrbueqYfAWvemZaWqqQbH	10032	14150	14150	1618486200000
19921	3NKnRumoD28URCCZ9iCy5MxMMi91w8UrLNhavGgYH5bBFkqeHahE	19875	3NLWbWj5US2atTS38JkecFofgRN3BUGhwsWGtMMvD2qbAeKJtb6m	641	1336	351	6301	12463	jwovLhPTVDEprU8MFz8qD5a3bWRgvjWNhPJhcPwM6kHR7hRamdG	9993	14151	14151	1618486380000
19925	3NLavqsRjkbw45T1eYtGjaAUHSGzSyzrRyuqZaMTjdvCKYJxA21r	19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	1406	1393	353	6301	12463	jwoUGD52pm9tCS53bkPwFdzSEcWqryU2Fi6kxtePNfBwANE1m2P	10035	14153	14153	1618486740000
19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	19926	3NL9cAeP5iLaKDdrvKgrKD3w6PWk9UbkJyVK2DCThE4ubPjUJqNH	1407	1395	353	6301	12463	jxsEbARnYQBXRxbzzKZ7dqS7MLz1y7mtUZpGb6fucdf3Uj8QoNm	10036	14154	14154	1618486920000
19937	3NLkckjrNi96v4WJp4qoqTYbrhMoAoxpMfqWJYUxDmmh5xr4hJdY	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1611	1341	353	6301	12463	jxDFwFAJdALgeNaPGUh6eGr4RGxFMGGWkKvbbVZPifUWcLwkqtU	10040	14158	14158	1618487640000
19939	3NLTyfK1B2EjU7NAnTxYvpbNYNLerfVUGcJU6RpcKr7gAvYofetw	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1403	824	353	6301	12463	jy316qRBrax1pzLn65ZQBTse7heXCkfmwaoPhd2uYemL9e1uHzS	10041	14159	14159	1618487820000
19943	3NLDL3nYSMzyCA6RPdMCMCmeXuEg95CvCuK4suFBThb2J6J9jsFd	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1581	778	353	6301	12463	jwQ9aZFFVDQ8gR3mdGTj6Lj9VF3jsRGHHhPdyChzDc4HdZBFf9e	10041	14159	14159	1618487820000
19946	3NLMHG2cqipC18E6EFuwKyKz6nQhjHDiRcSnMZJunNHF7cpJ1UbD	19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	1407	1395	354	6301	12463	jwm4Eh8yyVTcWpK32o4ia9Y3QndtKt7g459MxF33PTZQeJt8KeL	10043	14162	14162	1618488360000
19958	3NKjTXrMLKz5bakyLvcGNxHWMfUj9HY2VxoZ6iWLXoPykdKeiwm9	19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	1547	1378	349	6301	12463	jxGbVq59dBtinPG9rpWumF2xCbU8L3FvzfGru7L2zXNQ9XgKTkR	9961	14177	14177	1618491060000
19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1648	1284	354	6301	12463	jwa5FJffRv4nAjFx2AH8ev8uY91HKpuxszNgD6yCj5xvYaFFUtn	10052	14179	14179	1618491420000
19963	3NKwVwraYpDwBTd1kdJmMp4C8PELT2Bv65fzt2XW49UNnLMmDmnT	19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	1407	1395	354	6301	12463	jwMVCYoRPGtwPEHv7AeiWSwEqTzDjyMLptjzfd3UawiWzBYet8y	10053	14180	14180	1618491600000
19965	3NKbRBon7vNuWZRLrN5tYtxNgQvSUxPJsesrfhVZJzx46ZDCmn1d	19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	1522	1196	354	6301	12463	jwaNfBUuWQ7PrJjy15P5LTpQ6xiPQjZFy1YaiSWCfsAVmY9X7mr	10054	14181	14181	1618491780000
19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	19967	3NKMxbzGSrMaWmtEBJ7UPMG9raSMxFxHNNAEm9iJRWbuCHxjtdLg	1637	816	354	6301	12463	jxMuNVgGtus8EB1QX5HYjwNYuhEaAQ7TkhcYSZR7SWKdHhpENtH	10056	14185	14185	1618492500000
19974	3NLh63DtQ32NGAf6CBsVJo6xDy98HdSYebMtTSFrmuEHRRYTayje	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jxVV2waqJMLguAkFw19y1q7QNBifDpFUo1fB2VatuBzAu4Ab1Gp	10058	14188	14188	1618493040000
19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	19972	3NLhGf3s9Aom2EvwAKhpQkn816W9dPipeesp3Qi3GSe4kayGn9P2	1559	987	354	6301	12463	jwtJMA7CFLxa7c1NriHWquPjXeFEqdriCg16DtCZZ85fYZmXCFM	10059	14190	14190	1618493400000
19980	3NL8UFJJAG8C5WYyAQ7qhr2hy5k2iitRPo5m94VRzJHBrRn37Rwm	19979	3NKSfyjGankB6TXzuGsBehF4MgUSezyUyZr9ukjFBGY8hHiTwTqa	1594	1326	355	6301	12463	jxo46Roxvp2YxeijhgKmqXVvKGKzwmXMXYj7SUf64rWWwNKC7QW	10061	14193	14193	1618493940000
19944	3NLiS9jKjfrJtBXuSFEuufzfdb8TonfrqrT4v7P1cpeidM5xrUBG	19749	3NL3BYScVgwu6mig7HAVXvF3XSPNkAHAgUmS7gQrwPSwz6yxPizV	632	1016	348	6301	12463	jxz4QsquQscxEXTs342SSVKsVWeWr4LNq2PZZcqxK8tZEJvjFm4	9926	14159	14159	1618487820000
19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	1553	776	354	6301	12463	jwbmJ5PxXBfeGZCBiG5HtP3ydK5aM95wjrdw6SuJLkQDVecBigA	10045	14167	14167	1618489260000
19952	3NL5bZgRhFC2i9sw7MSYaVcUHoGLeiWqViSCyyB3bfXpJrnxHpu1	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1652	1315	354	6301	12463	jx3hR3qYxnX9EzWYXAqCQXxJhtZN3p8mMjSCMaGKLdYga6XDPPL	10046	14168	14168	1618489440000
19955	3NLr6jCYpnaFPjJgsJuc4nQhz4uUdfn1Y64ByWoR39PvELew1fQP	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	606	1295	354	6301	12463	jx4PxMwk9qitS9EJ1esSjL6MfSMjbYgqL2MV4VPa4ZEGRMmrh6P	10048	14175	14175	1618490700000
19960	3NLrCpFUuXcVv89CrWQb97ewPJjkM13gBSpLgucA5xJs5HMqEm53	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1547	1252	354	6301	12463	jwQ6AUpKkqF3iUnzZcv4jeA4LjKGKFtU5LRetdbrvZp2VdJVgan	10052	14179	14179	1618491420000
19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	1622	1110	354	6301	12463	jwjTQAxshnY3GN1GtQEH5Gge4m1RKkkRVufT8zLg8Qukpvu3eNx	10053	14180	14180	1618491600000
19967	3NKMxbzGSrMaWmtEBJ7UPMG9raSMxFxHNNAEm9iJRWbuCHxjtdLg	19965	3NKbRBon7vNuWZRLrN5tYtxNgQvSUxPJsesrfhVZJzx46ZDCmn1d	1406	1393	354	6301	12463	jxgrwNWATdgrwZ5gPAvr9LPtWqaozuNYSjuApR6FWdYgnW8mWFZ	10055	14183	14183	1618492140000
19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	1406	1393	354	6301	12463	jwgYUn2WYeVHkCdq7RKSqbFCFnWQAugRW8CnaB2A2jHv8PJRhVM	10057	14186	14186	1618492680000
19973	3NKUQuojdL4xkexHHQbcCo3qBtBgyi2kzzGswpREuyc4xhzNeqcf	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1471	1386	354	6301	12463	jwTWJbbDQ7C6nc7vPcuykxyDgBA9CrLtPqQjXvygBjX3fTsAPSP	10058	14188	14188	1618493040000
19976	3NK66LvMy13LfiUmZ9Gu2t9JpdzB4LRw1EczdXFc7DMYqvJw5TP5	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1553	776	354	6301	12463	jwSX3sPknzEc3ykkuhRXu5CnJSSZLcavZSE9h9RuJ3unYpw1MzM	10058	14188	14188	1618493040000
19982	3NLW8g5KssGx2YGhnMungTFsiLTsJxWeHwQbNvG4mgK5RfxiqCoF	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1407	1395	355	6301	12463	jwqB2FEKdn4Cr3GZsiXhcL1Wfb1otdtRZqswMVkFckiWQSJmvcD	10063	14195	14195	1618494300000
19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1631	794	355	6301	12463	jxzJdx9REz21VU6BxBmkSPFiuasBKk88w4vCSMTNHoxtrRk6zAy	10063	14195	14195	1618494300000
19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	1419	814	355	6301	12463	jxMoGR818ZTNsYCL8LMqJjtuSNTXKZVUM6K7Vf5o5BbVsYyhyFx	10064	14196	14196	1618494480000
19992	3NLPyGRGtxhDzn6z8mJ2M5bUSFmDEr2CMfFnf2rFmcScXutTWy7b	19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	298	1308	355	6301	12463	jxKPKwGpPEtDrRXsQBUJZc4e6eLjG14qfb1isgi7W5VoL9WASpA	10067	14201	14201	1618495380000
19994	3NKACV3fxhZw5G3LaLgjj3vtiu9Dmn7Bn24Mi9veHYLbpesBEe4z	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1440	1011	355	6301	12463	jwDhpFckwE3sZhhUer4t7FHSdEcEJsicpjbYPAegH31B6N4ivi7	10068	14202	14202	1618495560000
20003	3NKyvRJoWYfeNtx4ky28ojcuqD8Ytv9EkN9LGxXAkq9oAhWVbyap	19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	1460	533	355	6301	12463	jwjp4SEN2z5a1PkrJ7K7QTem5vy8qYJHHyVCF427bwHznmh6Mww	10071	14205	14205	1618496100000
20005	3NKbudTvk5PvpUgmPCUjGBPKFdTeXMKYny9p4RhBLucGdYy7h8Ky	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	576	1109	355	6301	12463	jwHvgiMRVnECbyAJEhrUTPDwbTaXRoPRyQjUFKbts6rWegPSi8x	10072	14206	14206	1618496280000
20008	3NLni6mL6Hkz4smP6UFXEW9xVZgBbyCfmB8bqa6a9i4vfwHNEj3f	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1624	1208	355	6301	12463	jxHqheeXY3dJ5gaaqd5arvhun58iqwEiYkLCf4sPTPJtABMMREn	10072	14206	14206	1618496280000
20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	20009	3NKAAvqPNFFMNMFBHNX8s7gjLrfpo2qGjEuxmf5jW7v15uKT2kxW	1589	1040	355	6301	12463	jwLn5ffztu5VnmcFH6PLfkP4TcK1SYDm5T587xufiy6SFk2Nzz7	10074	14209	14209	1618496820000
20013	3NLfDFUD4ehVrDBRw9m998dvz3EAsSPMCdCrW2pJQ3gSbFUkZmiU	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1587	991	355	6301	12463	jxkUENd5k6GjyXzqW9nYGt8AUdLCCSBzq3ZesBH2rTQYbq13pJA	10075	14210	14210	1618497000000
20016	3NLPhqoPCYAkKFZVZimcgTLdi7wuNKGLaNE4xM8CTx2UWGwMQT4Z	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1508	1387	355	6301	12463	jwapMNwimkYS2qZyMyJV4NGGru4PsDM43PfVToxxgc89Y7gzdHq	10075	14210	14210	1618497000000
20021	3NL1S5bn5FDUa8AJBL6HNBwiEX6SAbEAk8xaSs7bNZowBG9YJTqi	20020	3NKhMWiRJvVtCyq2eKEH7TuSwbedfW4dKuNKtCMKhfksbcPhCoJY	1578	1050	356	6301	12463	jwa4gHBCTpST9JkSjTWgo1Di5ZhBYRRpCiAmmGzXy8TgH79kDKc	10078	14213	14213	1618497540000
20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	20023	3NKo8RzX2S9rKUGWsjPenuqUyEoMMo6PBF3AsCpwLj6o39PbptTs	1650	1375	356	6301	12463	jwf8oFAsbDj1r2hyCepLYVtMawJ4agKzQNcdiDRzwGRPFjRn4M7	10081	14217	14217	1618498260000
20027	3NL5fTs19UtvpFo35p3h8WiFBP1qzMnPqSmcMbZTH5XuFWWN7UWq	20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	1619	1275	356	6301	12463	jxQvUR299uC4hr6qziQeASQDdPjFDh3xTueC1mmQjiugGWqWufD	10082	14219	14219	1618498620000
20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	20032	3NK3rGEnGB9vwD7CGxWZnW3XRoQufJ4b7z7JTrQa6refdKmaG2ES	1407	1395	356	6301	12463	jxYCb8JxKWMDym2nt8e3voi9jKQjrSCHsDBCpXPkbZXhbYYQ1V5	10085	14222	14222	1618499160000
20041	3NKbWzU1AqHUGMKo6uRGDXQMrsKNVCECPn6ttLtyUj9UGyH848Zs	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1448	1185	356	6301	12463	jxAZ1e3vcMP81Ub4UAWd3DNVdgWQ9f61Tt5GWa9SeomHkbRKne6	10088	14225	14225	1618499700000
20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	20040	3NKdJ231P3F63HKovuFZvwZ8NBqawLptyo6z7SYMwwpaSwn5woAt	369	1312	356	6301	12463	jwfdRhG32HxyKJvRveiePCJiPPLqu5mqF2q8kD1x7PJSicP3FDG	10089	14226	14226	1618499880000
20047	3NKii6LgmBxr8ifjQV4RD8rTVPNADUTDR593UWCEKotzrrTejpJd	19964	3NLShbNfNXB8ehdaYJJbhikKYWN7oVeCE9usSzd2t787rLYNJKF2	1560	1045	348	6301	12463	jwFL4bp7KDkPYT5EKd8aUYASh2bzQYFoE3uFV1pJJzYbLc778AZ	9937	14230	14230	1618500600000
20050	3NKBrx4svy3bTiBFFLbxZwnLHCL2QhKVMWP6bmdMGkjNEF8cZHhi	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	563	1359	356	6301	12463	jwhQ3vmGx9wruKmZEezdPSDiXPtSB2Hoe8WZD3Ai2zp4F45n8Wk	10092	14230	14230	1618500600000
20054	3NL9hyy2TySUNMAYo5qr1hrgcPrRzYuFHrXaczSKcbBnRRjDJrpR	20053	3NL63TQ37ZcxSurzzvLDNrdexoo7xZz2p1LfiN8yPg4p2pmUgUyH	1406	1393	357	6301	12463	jwDCK1ob8YWyyCfKRDqboAdi9fQ9tyNf5FLpXHFAL6jdwD6tMRZ	10096	14234	14234	1618501320000
20059	3NKmkKygKWHvoTY4Fx7at1qxWZusmBVR3MAaDJY9NU29ALTEiFRN	20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	1564	1212	357	6301	12463	jxB6fX7gMEUtdE9poV3559KzTHXppve3CXjH1uEBFwtzWQ1m2n9	10098	14236	14236	1618501680000
20063	3NKQDGX7BkJVbkS8KMzorrh2BtsNt3EnTTtDo3eEWsWKyM1CCcHD	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1489	1134	357	6301	12463	jxD1HCV3SrDVqZNaaBrW5ikKAEtt9GxMBCaiQvQhatGdwoQd1NK	10101	14244	14244	1618503120000
19964	3NLShbNfNXB8ehdaYJJbhikKYWN7oVeCE9usSzd2t787rLYNJKF2	19880	3NLAWUiBBPbJJpHCnrYxoW6rthtbAxYhoJZYL5TP6BTw7fBk31Lg	1560	1291	348	6301	12463	jwbKHWwYdqcYBrRyVHo3tU6ocUF1hdkr7SrhhYuMxeHi4cjH9JE	9936	14181	14181	1618491780000
19969	3NKYJjUm4vtNsqEVuBzVk72jRioJJEo8NEB9C3dbHdLUEVc3HHVX	19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	1467	1376	354	6301	12463	jxTV5vZ9tsHcaYHCWpjsniXcKPeJBAJ4uYmbC3EtQDvLU4Zo4sH	10057	14186	14186	1618492680000
19972	3NLhGf3s9Aom2EvwAKhpQkn816W9dPipeesp3Qi3GSe4kayGn9P2	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jxpX1iaoyU5P92GFf2HQw7HYs5Djr5vugYutYW8rcpwuZsDSPZC	10058	14188	14188	1618493040000
19975	3NKJrjeJrC6AGn4rQXfWyNyNAoHRFNFJM3RtXHphqfeiN2qLvrMU	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1407	1395	354	6301	12463	jx26PsEQk5Fukg4r4fnh1kZaiRTup449iuXD7fCYjyCJEjXPa6X	10058	14188	14188	1618493040000
19979	3NKSfyjGankB6TXzuGsBehF4MgUSezyUyZr9ukjFBGY8hHiTwTqa	19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	80	1273	355	6301	12463	jxhQ833ftCbwUucvzmmXxwJuwQNFXHMbtkksnuYnRPP218ssNGR	10060	14191	14191	1618493580000
19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	19980	3NL8UFJJAG8C5WYyAQ7qhr2hy5k2iitRPo5m94VRzJHBrRn37Rwm	1513	1133	355	6301	12463	jxg6R8UtDsnmZ8uYdJmirzALX2Fc8Sk2paTHjprB29AGmkr1sb7	10062	14194	14194	1618494120000
19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	19988	3NKy3635az89f795NHLrhS1ZHVkewCZ5AJbVqfPsVm5BCuaH89Ce	1460	674	355	6301	12463	jxuxehgxhgNvNTYV2WyQCEH7GKq5WrSwkNJYHwbYGR4fv4AEWtV	10066	14198	14198	1618494840000
19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	298	1308	355	6301	12463	jwf9ZSPovQ3HmDcBsGz1ddG9qJu8sLtWqfUsNe3qqDqKH9bXCB8	10067	14201	14201	1618495380000
19993	3NKwBbc8mws66znqnkhhEPZaw7PgCUQXS6ycMiCr2TEp1JVzXnnC	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1406	1393	355	6301	12463	jwSTnMDcgLTR7PUJM4KKrrKHGxMU3VtuddgfARdvZcLDpwjoR4S	10068	14202	14202	1618495560000
19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1477	1224	355	6301	12463	jwskpGTdWcV9CryzAsWbKSNreRpzDy7V42cT93A4L4W22fTJJGU	10068	14202	14202	1618495560000
19998	3NLe8ZQDH2idLT6U3CYiEF9YUTkGA5UTLvQbAW5TuUNgGvCQ16vp	19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	1513	1013	355	6301	12463	jxsNRfgjxafrw7dYtYP5ym9PgehGkf9rVsT61g2omVWnoRUk3jT	10069	14203	14203	1618495740000
20000	3NLaq5fngarFo3FV9EdYY4UHEdqZ1EeWpzp3jes1uVqtwLi1cfZB	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	1675	1342	354	6301	12463	jxUmKQRUSFYK9Go4m2gK1sgMKopjqLFgGFp3eLy1PdPw4G5T62J	10048	14204	14204	1618495920000
20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	1405	867	355	6301	12463	jw7ByJCgqyJRNoM7g4jZ66w58huyz4a7jKmtQeBomAurD9xQSwx	10071	14205	14205	1618496100000
20004	3NKjBJ8fCaJvJsjmpHae94VwYeZoTrzVFQMF4YLkomFRcVDqTH6s	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1406	1393	355	6301	12463	jxwFAWAcvReFa28rdGkVXaWDpYp2Wn31v5uPiSFhB6sswVwKJbc	10072	14206	14206	1618496280000
20007	3NKZ1PtXNoyW3JaBzf1mj7WhmU2T55wfS9ryzNnLjzp97MP6pf2X	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1624	1208	355	6301	12463	jwWz6n4NS9rkqFsTsdq8xwNUcUFX9CCCZXzkFqGL9QyUJVqNwBu	10072	14206	14206	1618496280000
20009	3NKAAvqPNFFMNMFBHNX8s7gjLrfpo2qGjEuxmf5jW7v15uKT2kxW	20007	3NKZ1PtXNoyW3JaBzf1mj7WhmU2T55wfS9ryzNnLjzp97MP6pf2X	563	1359	355	6301	12463	jx2BR6PDJ9gg1aVbwdxhMMsxnHPrxcBAcL2qZ2JwqBVwW1CLQXg	10073	14208	14208	1618496640000
20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	298	1182	355	6301	12463	jxMDTxnfAf89d21bsmaV9sAxorBfCwXvCtYCS2ZpguQkCZXLG5H	10075	14210	14210	1618497000000
20023	3NKo8RzX2S9rKUGWsjPenuqUyEoMMo6PBF3AsCpwLj6o39PbptTs	20022	3NKxh2W9wPsSw4tBoEgAog7sdTaG5M9kmm3DJzWmbuiLeJBJ6ALg	1503	1031	356	6301	12463	jxsSZVuSqJ2bK9fkzx9o5JdDKBVzUSb5j83mnxSGXREnQPyJqQy	10080	14216	14216	1618498080000
20029	3NL5Vc5Uq3fJnJ5JmanmUgm362PY6kTFmaj36a8E4uhQ16Y41d6d	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	1619	1275	353	6301	12463	jxWku9R5w1E9e8CHMXgw1VfYFy6VY6f4ZiWyyErYVCWem8iXpMr	10028	14219	14219	1618498697181
20036	3NL8QPERTg7jfh2FbK9158nrSt2SgQmKAjSWm7X2anua6RPcUh1S	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1440	1377	356	6301	12463	jwCRV8eTWoaCDPZLo6stxC9ToRP5XZoaEkiuerf7AF6oZkwbSKr	10086	14223	14223	1618499340000
20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	1588	1392	356	6301	12463	jwZ3ioNyDZgei6GwFC9Atqsq9yKCybbqgDg6i8pgEmspJZbi5mu	10087	14224	14224	1618499520000
20040	3NKdJ231P3F63HKovuFZvwZ8NBqawLptyo6z7SYMwwpaSwn5woAt	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1637	816	356	6301	12463	jxU4mDUujHryG3AL5RHsMCXyxvaBZBy9pBi3T1H46UgcoMz71EZ	10088	14225	14225	1618499700000
20045	3NKMicJci6EprN4PYrWj8tvh7LmACYomwF5CuPaCTQPdFHMVr32B	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	563	993	356	6301	12463	jwWfKQCHgPuytaFzkST89HPR2T2aSGHmndj6PMGDtdXiWVcMNXA	10090	14227	14227	1618500060000
20049	3NLCVPQqv4KvFR22ftMM8t8qDdiyzMHtNXCbDNLixBoFrZ5UAErn	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	1483	894	356	6301	12463	jxCREw6741vtwfzvkG8aGy7i7QVEjeRAkMZz2viGQsqYHRUugBP	10092	14230	14230	1618500600000
20051	3NKEKJLiqeVPBBaGoWNupZSUh5DtdmBugjvmvR6XFkxjwNxRfiru	20048	3NLhsETMWMMnFStcktfjRHhWuyEwa39CE1ewavos4KWgXLYtvM8M	1402	892	356	6301	12463	jxHx3ERF4gQUYXpiYn28E2fnFU7yPrmrYhcH7hSbPJHzT9WRLHW	10093	14231	14231	1618500780000
20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	20054	3NL9hyy2TySUNMAYo5qr1hrgcPrRzYuFHrXaczSKcbBnRRjDJrpR	1477	1104	357	6301	12463	jwdAW2fQq5idbMc4j83kEr19oVhYukWo6DhLdTFEvwGbPBuaHAE	10097	14235	14235	1618501500000
20058	3NLENiz38Dkfctb4cmGcEpWZKhC2sdHBYndMHYt8L1KUktTfL97d	20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	58	1281	357	6301	12463	jxyciBhAGVtrTHGkppab26XThdwzDrCF2kQbeHH7twQm1aJ8BwN	10098	14236	14236	1618501680000
20062	3NKnw2ScoqLxev5qcP36Ep6Hg2maZ5HBVqyTncQMkL218J8EqdF3	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1402	852	357	6301	12463	jwsAxRAkRzxPq8bMLEd4YxTvBjBeetjRXm3TTPFpQ5Ggx7yi5yL	10101	14244	14244	1618503120000
20066	3NLtgvowSw7PPpmZnSUuy8rKC6mtDru11rC8j9EmKJdYChxRicnD	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jx8jY13XFfM3B46iWQehEEUM6PtnoZmyfDQvEA7BFoyje7eJ7ap	10101	14244	14244	1618503120000
20068	3NKc1KxmDg2i4S4Cw1PQ9MA2HC1UFiRMfYhLcMv4WH2ZTUAasaig	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jx3pQBJAcSVNT2SNdtXepupezta6uwnu4hbc4ZpzNpzkBvnnFE8	10101	14244	14244	1618503120000
20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	684	1352	357	6301	12463	jwy83tCkSvhWQnCFNL9H1iMBbdCysV4FNr1dr97X32ZiBWs1QUd	10102	14245	14245	1618503300000
20071	3NLhQuAvUjsPu54ityqscXCohLfn8vb59hpYBAb4fxBdvPbAb6Jt	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1403	792	357	6301	12463	jwgNrvGbDfSN5ndouZYfZj4KZpfSQyootzbgXGdtLRLgfN9tcQr	10103	14246	14246	1618503480000
19978	3NK8U2pb2aL4EGdbWLZmcenPRxAVocr8GBSqsPidQ3RYoA5R6Pqj	19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	80	1273	355	6301	12463	jxaqTddciAkrXVQFH33ELZjDQWdxQqGjRtaCcSAPkcT3YcS6ceJ	10060	14191	14191	1618493580000
19985	3NLUkza3hLhT4aBsaVz35UtARrRkfG6egmmYFWZ4zvyK7xGBMYAu	19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	1406	1393	355	6301	12463	jwcJcUmW5BnJcoyJURDwFNJZper2RC4p7bjMUD4qboUpxSDbeqP	10064	14196	14196	1618494480000
19988	3NKy3635az89f795NHLrhS1ZHVkewCZ5AJbVqfPsVm5BCuaH89Ce	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1596	1363	355	6301	12463	jx2g1BusUtCMqb8TCspjJqhE37wk2rxAvauXDqiDs9H3J12HcSM	10065	14197	14197	1618494660000
19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	1406	1393	355	6301	12463	jxhKT6pJPoJcCrA2prHxViL8d42Pd5VYUrt9YrKu51mhr4mdWbW	10069	14203	14203	1618495740000
19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	1675	1342	355	6301	12463	jxuY1yCw553tXr5brFCB56EfwaLhuRtx15TayqgXxsF9uYoDxpa	10070	14204	14204	1618495920000
20006	3NLingxuaxenGmDZsFEqvHmf2JPSSpAhQJCsxwUDGycXyKtGQxch	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	641	970	355	6301	12463	jwyN6qv3AEJeNikKgdTzrVwEfWMZ6at7jEgkoQdVdBVFy4bEkFS	10072	14206	14206	1618496280000
20011	3NK57Bgcek4nDQNUmDfhn8ECjYWJnZYMsnGyPnzNg9cxmKPQoy6P	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1619	1149	355	6301	12463	jwePowWMKpHr2rdWpEtgR6zp9pTtbLVdG1iXY44m8qFdSd9AW75	10075	14210	14210	1618497000000
20015	3NKPpHze615M2CJHXTnPXv8uSzzFBDsuBSSYG5Rc7DY9g2kwgNz8	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1637	816	355	6301	12463	jwMFq7Xkp7uNNWZpGuQB9VeamDgCuHogLoWZvEunbGES1bmV7c6	10075	14210	14210	1618497000000
20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	1407	1395	355	6301	12463	jxXx318QRMJ1LLnuCwYA6kgntw7CeSqcUwtm1LLoMCv2q4EAnJv	10076	14211	14211	1618497180000
20020	3NKhMWiRJvVtCyq2eKEH7TuSwbedfW4dKuNKtCMKhfksbcPhCoJY	20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	1624	1208	356	6301	12463	jw9yfk1skC3tJjAAuUEhfFCXNnnsn2dBDknHDx3xHL8oGVAsYRp	10077	14212	14212	1618497360000
20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	1549	1362	356	6301	12463	jwXQSGAjJSaN8Zu2KaArENABsguFgbDDUd6xE25Mz3zARJFj3sU	10082	14219	14219	1618498620000
20030	3NLLR6ibUU8ydRk9RZD41Rz1byxF8nramyhvAgx9VDNWvSC8g8pE	19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	1619	1275	353	6301	12463	jx86Yc8zqp3orfEHZ9tX6oZGJVCZoNVozf8UnSFmA7MpqpnTaBc	10042	14219	14219	1618498734624
20032	3NK3rGEnGB9vwD7CGxWZnW3XRoQufJ4b7z7JTrQa6refdKmaG2ES	20031	3NKer5juTTJbduGpyJyNqQDrZKshgdgz3LVVBsEroJWnXT44KnnN	1672	1159	356	6301	12463	jxoo5xiXQhorBeUqzbYEJerQ522ct6tbJrPoV9UCXYKwp1q8HS6	10084	14221	14221	1618498980000
20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1637	816	356	6301	12463	jwEhwmKpBVZPCw8nAoDdu9E8i4Tb4XWcpzcTrAY89QBPW8uxref	10086	14223	14223	1618499340000
20039	3NKM1GirA9GeuJJ7fAocpmwxpUSNxrrXJZ1Eiv1DsxZntVs3ws3U	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1448	1185	356	6301	12463	jwuPJjc6LM6B7avbE6PUwCv375Et2oRKPkbU3RnevXbwQ4LXNZR	10088	14225	14225	1618499700000
20044	3NKQ88tp3QP5D1Z4Z1aetJb37kENWFRmPJgeZ6cR2W56nJHqGpcY	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	1407	1395	356	6301	12463	jwWmg659ZfukRXGd8SxfRhov5NivrPjZZUJMs6J1gXA649FjzdD	10090	14227	14227	1618500060000
20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	20044	3NKQ88tp3QP5D1Z4Z1aetJb37kENWFRmPJgeZ6cR2W56nJHqGpcY	484	1319	356	6301	12463	jxx6zaz79FtLw7z5vM835nYk5d9xoZkR1FaC9h5gNUEw3d6Laqw	10091	14229	14229	1618500420000
20048	3NLhsETMWMMnFStcktfjRHhWuyEwa39CE1ewavos4KWgXLYtvM8M	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	1560	1045	356	6301	12463	jxE9miV6Myi7Z6GRgREs58PFX8MvedyFfzS5DukW8EUjVoGMram	10092	14230	14230	1618500600000
20053	3NL63TQ37ZcxSurzzvLDNrdexoo7xZz2p1LfiN8yPg4p2pmUgUyH	20052	3NKnrkAKs5FLDWK6XvqjRLAdRXEbyG54WZShAEv7N5Zo3kBrHD9Y	1622	1356	357	6301	12463	jwbu9QGyj7eJ2URXSHaN5rHB1PjKF8dRCwEKYZAEPdLwZ2H5692	10095	14233	14233	1618501140000
20065	3NLFmQta77AhGa5sFcV3aGBuKGzWDmZ59jqMYjUpRkMfHtcbPNw1	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jwCtqvriBHYuZv9xPahJf4y7nMsicWBTKt4Z8U31hk6GQR5Jken	10101	14244	14244	1618503120000
20067	3NLFehztMFHj27ZuPjz8sno6BEPZbVm12MiyMqZSUBVyaiuNyzVy	20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	1553	776	356	6301	12463	jwCKKLXFYXeKiPCapS8FEheKXVVDqamm1tbzVPnCghKf3SVq65x	10083	14244	14244	1618503120000
20074	3NKZCzNWM8cMqxLR5Nb2TQYNHfHHKTUmcRWpg59JyjWH5HWxAfND	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1581	778	357	6301	12463	jx8nFAHuGW8K7dcGNzzjVQWnGqB1dnriDrT9P1xn6NiPyWJ4km6	10103	14246	14246	1618503480000
20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	20071	3NLhQuAvUjsPu54ityqscXCohLfn8vb59hpYBAb4fxBdvPbAb6Jt	1406	1393	357	6301	12463	jwCLN4iLy93rdTeaPiiQJV3HHUqPfUJf99j7CUJ7hpBcTg67h4c	10104	14247	14247	1618503660000
20080	3NLbezfWgk8mCxUu51jPb7WvHt95639V3F2gUmEmoWsgpEGJPjx9	20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	1406	1393	357	6301	12463	jwLeyNfrxnH3i139D6yYCMULt9jgWNecGHr7rFHTE1UQYNuMQcc	10108	14251	14251	1618504380000
20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	20081	3NKbfyUzaGrnFEUW8XdtYSEzLGvzkwQch5CpWSVKiuNA4SoG6Jn5	1406	1393	357	6301	12463	jxyL6fGb8eLadTSWM3fQNYRbY2qPTyVbUuwWHPFjwJGqnVNSYpQ	10109	14252	14252	1618504560000
20087	3NKPbUtSic1jXWWR3oQgv6ybf9Xnz8oVVPd3ysoq5q41Jen3steF	20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	149	1283	358	6301	12463	jxNsQTicPY6cB4rvKknxev4HajUquoTxt4fJTg1qMBk6ot3hPaL	10111	14256	14256	1618505280000
20090	3NLJkosvNaizpMbEb4owVkE8EqexLo24qq1Lxhzxw7kz2eJ9tnoo	20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	1648	1284	358	6301	12463	jxGpRVCnVpvspz6bXRdBPsh4koh4r7PTFUJ7TGg5MhhApUmaBVo	10113	14258	14258	1618505640000
20092	3NLfoN18HiBJjWHK7GhhPoJBW9vVHmZay3oXKV7FLxbojjaWhB5E	20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	1631	793	358	6301	12463	jxfXNy7eDr3d5Xwm8hvXjHhZEgw57B4CMiZpu43QjJn3ahmN4zG	10114	14259	14259	1618505820000
20098	3NKZagW1jQd8bdw8mfsSQ7jXNQ4Ct23XhvVVq5UHQjkqG5PgrKau	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1631	794	358	6301	12463	jw9DJQnMQwsw9Dmy7zhSJgeNjENB5Js1VPkmaUbkGS2NDpXGaer	10116	14263	14263	1618506540000
20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	44	959	359	6301	12463	jxQVkVX8PgLo6CU1tKVioQdbe4g1i6UFt9GbJ7mbYJ5iFdSpxty	10118	14268	14268	1618507440000
20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1406	1393	359	6301	12463	jxbptNiDW5gWyPxYZVnV9hDp43XzTnHTnDCrywJyCJmw2we4YY4	10119	14269	14269	1618507620000
20108	3NKaQb34WArxsWXF14ZfWENggkT9dZCGN25ut5WNb22d1tpbaRc5	20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	1407	1395	359	6301	12463	jwmUKyerQHvaDVMwVDJBcH1gurZbVccnHuUkhpk3odnz52MY8fp	10120	14270	14270	1618507800000
19983	3NKYJoL1X4pZZ6F3m7BxqK8kJQHdeRL1e4vnp2hEnWLNcHkq4izM	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1623	830	355	6301	12463	jx9bSeq4gRgL44jPbz3zELRjVDB5HhXRo3746Q55NWZ1FexCatb	10063	14195	14195	1618494300000
19987	3NLQ8y9JF9WYqGhP7pyzNbtX1QwbRLJKw2H1c2c8AADAhUvEeYMb	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1509	1074	355	6301	12463	jx3miNgEctaNQFa47SM1HYuDvza6XzPMktP8Ec1uFJzr9LbR9aq	10065	14197	14197	1618494660000
19989	3NK8ub8n8xxG6zsij9kZWAegJsNsnFn8x2vvNT8u2MB7kW5JudJd	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1631	794	355	6301	12463	jwKYsgXE1r41u5qYxHrZeGe67upnoUtm9TS3QPqyKBhsybFj1Mq	10065	14197	14197	1618494660000
19995	3NL1MvGZ2Atdkvd1cqhdUwtRc4ZxDZNQtASJzMrcpUvkE64mHYuo	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1419	814	355	6301	12463	jwp5jPfTaBmNoDQYcSMPrySK41HQ1JRxJSfLF9A63bh8YwtLRhW	10068	14202	14202	1618495560000
20001	3NKwRyMLFZfM7iVSvH8WVK1vAvok8f2cL5jvFw3x7nFFTTakXa3V	19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	1631	794	355	6301	12463	jxr4BiBN9XmyUhGg1yz2nACaJPMmxmd3ziN5RiAxLQB8ydLkhaU	10070	14204	14204	1618495920000
20014	3NLscKa1AQ45ob7vEL1mKbtbfjFjnyuFa9YYaGPqKgH4bsZRZV6V	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1407	1395	355	6301	12463	jwbUxyUQNhDxMxyPhwmRMHpmjJNCtkybC1Tvhz66BYrnj6ZzyUE	10075	14210	14210	1618497000000
20017	3NKcsXn3NrU2uNBu7eU5ATK9SEDbECF1fmGvujX42R8kvY3E2EuY	20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	311	941	355	6301	12463	jwbmo7TUBRtoQnAfYf4AyGK3m8tRS4jE2RNzeA5eUYBNayNCncu	10076	14211	14211	1618497180000
20019	3NK3vgfN4dA5f8EGq93XkHFSxymboub3FnBT9zfJXw53umn9SVAc	20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	1406	1393	356	6301	12463	jxx3EGAxvC3B2C6wkZGeXyXhZ9kAh6WhiyPj2D1uNK3Azhad5za	10077	14212	14212	1618497360000
20022	3NKxh2W9wPsSw4tBoEgAog7sdTaG5M9kmm3DJzWmbuiLeJBJ6ALg	20021	3NL1S5bn5FDUa8AJBL6HNBwiEX6SAbEAk8xaSs7bNZowBG9YJTqi	1457	401	356	6301	12463	jxnwf94vDBQfB6MiLho1rk3nszt9D91CwBqyHxiSZt3f1o2KX8Q	10079	14215	14215	1618497900000
20025	3NKFhMmNeGZR8daKD8zWASLzUUzhVtyMp3DfjFteUxyKKAvukYwk	19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	1619	1275	351	6301	12463	jxEN6B2jYVuiVtSr7MsK6QjJYybKpuHMCZ7SoaWnqQLQxACXsRC	9998	14219	14219	1618498620000
20028	3NLMhRoNSYJYTiDkscvU67ytWiS1kGSUx7vPjywsk6XJxePG5m5g	19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	1619	1275	352	6301	12463	jxtZGTiFGJiw8qhh3TSiHXk5zvdAJ8EPZkwKna7S3aroDp1Heix	10013	14219	14219	1618498657907
20031	3NKer5juTTJbduGpyJyNqQDrZKshgdgz3LVVBsEroJWnXT44KnnN	20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	684	1106	356	6301	12463	jxK98BPsbF7a7YZp41jnkTiFtZdN2CbRYdQRdFuJiQcv5txvv2Z	10083	14220	14220	1618498800000
20034	3NLAaQo3hrLQAu9hbv7iwXiffQxY22taMhXjP39mysMnbPwKzBxW	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1405	883	356	6301	12463	jwVi7djqW73WYkELkGgqbTbqShaQZyxMVMpNL1bmxiuQvM6k1uR	10086	14223	14223	1618499340000
20038	3NLoDKLrwc8ouBVTEjAa1Z6WVspKZKWyeAHqherD4juHV7akkKDY	20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	171	1374	356	6301	12463	jwBAUVXmZ1bjfkgouXkQ8xmetUDqJPMdPaB5Vg6LZ7vdAfwXhyS	10087	14224	14224	1618499520000
20043	3NKzsci66yLVjGXmBSYE4kSg1YDUzn3S2sTCxQaU2cvowFoWSQ8U	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	1403	786	356	6301	12463	jwEJcufcoHAH6rVh3MSCQWetuKUFWGJHUnamv1fEVaTSsws6AGV	10090	14227	14227	1618500060000
20052	3NKnrkAKs5FLDWK6XvqjRLAdRXEbyG54WZShAEv7N5Zo3kBrHD9Y	20051	3NKEKJLiqeVPBBaGoWNupZSUh5DtdmBugjvmvR6XFkxjwNxRfiru	1610	1068	356	6301	12463	jwpvBLjsYLtLQ4AB7SR7jBJ27YA7pEMQz8HyChQXYuyqN38wkN1	10094	14232	14232	1618500960000
20055	3NKUWRLAHWMZXy2LxhwFChqJuhCeSQmC3EnpQzMGBMTPHSLdhiee	19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	1477	1104	353	6301	12463	jxS4xBYoANr76JJAynP9mnVyqzjPBy1AS2xN6ogaNWC8sxsG3ag	10043	14235	14235	1618501500000
20057	3NKMDAB2jAc7739kZfkgFkhkmtXDGtVnmae36aFqiVpDbWukELXN	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1477	1104	354	6301	12463	jx1hVvaNrTVfMATegkCibxus2HbTpcRCcZovCxvaNjgJNbXsi8X	10052	14235	14235	1618501555126
20060	3NLT154PUhFZAJLdXpYTbHvRjBqeiKvcndqzFeZufrmn35xJbLAJ	20058	3NLENiz38Dkfctb4cmGcEpWZKhC2sdHBYndMHYt8L1KUktTfL97d	1405	867	357	6301	12463	jxG1BPay9U9H3r36EcZFA2TT4n8i5tNkvKWg32EcNqTKFV6zpJy	10099	14240	14240	1618502400000
20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	20060	3NLT154PUhFZAJLdXpYTbHvRjBqeiKvcndqzFeZufrmn35xJbLAJ	1631	794	357	6301	12463	jwta6rfg254fXjxuGoZuFVkS172kL86GT8gdBpLepSeRFGYdhwV	10100	14243	14243	1618502940000
20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1407	1395	357	6301	12463	jwDZWXp6prcLz4MLEwurY3HdGU4hpvAadu6N4juYxnyvebLU5Sz	10101	14244	14244	1618503120000
20073	3NKfdK1zSETExmcHRnbffE7QuPN8eAqYFHq98RHjJ5EQqFKJrKFh	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1407	1395	357	6301	12463	jwWgANBRjfSGDoGhGQrazZvyy69z5rSo38wr8q8aU3SxvERLALp	10103	14246	14246	1618503480000
20077	3NLKjR9CWe2dT8ooxWqdDVTRpTuZzfPoVKxQmnCentmYkL8e9BZd	20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	1637	816	357	6301	12463	jwCc96GVvC5KU13naf9UHvjssfaNkoDdeskjniNMKSCrna39HBy	10105	14248	14248	1618503840000
20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	20078	3NKKPArAazei278pk6HCgFsoejk9XWuuzGg7dUZ8p5dWpFu7E9Sj	1637	816	357	6301	12463	jwDmN3K9fY9nJPppz2QkX42cvJKyoCRS1TVHKa1EbWEeYnyRg5w	10107	14250	14250	1618504200000
20085	3NKgecg16aEPkVPrE1UuLEaV33BSjpkpZfzvBeUc42BcoxkcJ4br	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1489	1014	358	6301	12463	jxAKPrqAc7jEX3pxTGcyZfsXbYnu9bB5w4FqR31iBmPF94BQ7E8	10110	14253	14253	1618504740000
20086	3NKiEAUEYv73yqdXPwSWrM2dPyiqBYZhVBWXQWFakbcQ7jgLeryp	20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	1631	794	358	6301	12463	jxVC5BBy4TQUzJs7pYmkHLf8J5x2a1sAUuRHYvF3WdtyLp7HTuu	10111	14254	14254	1618504920000
20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	1571	969	358	6301	12463	jwvKWJDhHQYeWA6hwtfYFf6vSSfLQfZNJzxWAKFbzAvZaaeGoYh	10113	14258	14258	1618505640000
20095	3NKNnZAJMbAs1py4N3NNKpFk8WejxHt8EFmrnfJcecMbgYskpQZn	20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	1476	1371	358	6301	12463	jwWqjsnrrTxrNDTjtQjqcazvZMFSLFE8AvaFFfe3rgYoSYC4wpZ	10115	14261	14261	1618506180000
20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1648	1038	358	6301	12463	jwZ3z2kPceUhHe4mqpsXzWAtNVhSXZAUkaEZYM1uqAEo6L9Sg4c	10116	14263	14263	1618506540000
20103	3NLxYrBLdk2Ni3hDcNjxEKYNi7CEf8u995gFE5QzSsEf4Nc7VWzv	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	44	1199	359	6301	12463	jwY8WAdZNh8e4NhGXGoes3ajz9soXKMCmcSqaXJBhnf5Ys2qA71	10119	14269	14269	1618507620000
20107	3NLmQ1dS8LPDg8z9j7FpkWZrbeReEKgwFHBTSpvGp9kbZ4gREFD3	20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	369	1312	359	6301	12463	jwDMuEvEsVuiqCYYrJ6UoZPG5s1tf4WEAaqcupWs2UrsdKZVSME	10120	14270	14270	1618507800000
20112	3NLPtzF72qP6zCXcAEbuk1zDvPV8SRKNGDuLGBuJEmv9RfZBbETN	20111	3NKwKbTg8SjWDRBHTiTXewC8nCi9aiuPmXBLsWKnVVWnbhjb8N5P	1419	814	359	6301	12463	jy1hYfXtiMZpTjwNK7HmL7jHyP8VZ8jQZRgGnCzdkKw7yqNE25f	10124	14274	14274	1618508520000
20070	3NLeEeoH7i6wfgbHQExKSRocNzc42DtQtVBZr8zsJkc7NFJsCGUu	20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	1607	1102	357	6301	12463	jwtMz7Wi1q8v7JTjxk7h9hLwVJrnFK6S7ctwR1gBB92XCTZ76Gm	10102	14245	14245	1618503300000
20072	3NKU1YbgDjwTs79mWTcKU2VPy924SpenQzomBbDVP4CbwFvgrwmt	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1406	1393	357	6301	12463	jwKxkyt3C5H1o2oDHTmnRRSaSe38i22CEfnywgnVXbMUcWDpYXu	10103	14246	14246	1618503480000
20076	3NLsZViYzyHsXKdQpkRVctyXMcGXDdYFFyETRWK5SkqFEYvBBscM	20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	1426	1118	357	6301	12463	jwRyaAkC5DJXtReyUJNvRETTzqQK7i9a7o78qXoU8547tTec5Gb	10105	14248	14248	1618503840000
20084	3NLirowv39WeR73UL22sBYmPpzWaerSHkyEJbnbuq6Gh2FKfozuM	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1503	911	358	6301	12463	jxDxCJz8yZdMbDPdnBgmSuKKiY6UU63N7PUrffS4RV1vwNkPuC7	10110	14253	14253	1618504740000
20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	1407	1395	358	6301	12463	jxT2HbbnUQ8UESVtdvZoa6KRgE6fFoEuQQRLVxDuYFC5RboxB6h	10114	14259	14259	1618505820000
20094	3NLD6pngMrH6FDm5WmoqhsZyXc6WhiFd5K1ERz8jT6o1V45TarPn	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1547	1252	357	6301	12463	jwhxBYghdCp8WJPTLDz478pT35umwxv9dDV4XwUbcnTwTYpgtQa	10110	14261	14261	1618506180000
20096	3NKCu8KPP4MnsfwvT6cdLWpFNbBognJy1a8i7GBUycjzDKguHwb7	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1643	1299	358	6301	12463	jwHmWFRFXN88BaXCHbUsUBi3DxfVXxhaDaFZNxxxvFHLB1fm3EQ	10116	14262	14262	1618506360000
20100	3NKmCigB35CqV8pH2c3YeEhzrrYqJS8y6QC7UPQNtgqFWfuWSeug	20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	1439	1153	359	6301	12463	jxkrUzRo5AEW1n23iJbBLyw2aj3NkACU7eiJ6NycYSBFTFhYEg7	10117	14266	14266	1618507080000
20106	3NLF3XzjxVJsAaP5q4hKUdiiA3uvTdP4SbGFodvRkzqQme5euHhE	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1440	1131	359	6301	12463	jwDWPZEDedKuXyY6ALP6wvrf8voz5ZEhncvr7UFGonxqFzyi8mS	10119	14269	14269	1618507620000
20109	3NLZ6BvV3eecioxyEoyyPJPPBZnJU7vZbfKrBw4so12L4EcjGQbo	20108	3NKaQb34WArxsWXF14ZfWENggkT9dZCGN25ut5WNb22d1tpbaRc5	1631	794	359	6301	12463	jwyyve3KFYUyymLV7c1kyjmvtZDUapYUAAdYVsCnHyzH3wVjGxf	10121	14271	14271	1618507980000
20114	3NKrt8eTeCT8k5qYeEfeERWe79t1sJgyj9qutkjpiSMxfu13tExT	20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	1407	1395	359	6301	12463	jwEeo2SsfTDFQxghictyQqBT1UQmUQto8abYZMU5fuZzt9MyCNi	10126	14276	14276	1618508880000
20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	1631	794	359	12463	12465	jxcDwceuA4SeK4uEzAWLvcHfrnjRzFR6XhBq5v2RsoJpLAwa17Z	10129	14280	14280	1618509600001
20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	20122	3NLbQNzKqGrraXirGoWg81gGZm14tkZyVxqCXwKXCMP4ohKrMP9e	1529	1190	359	12463	12468	jwaGHxKaX5gxmSPbi8ThwPWwF6DEXgPWoehDVreQLFu4uovB6FM	10131	14284	14284	1618510320000
20127	3NKt7HVu4S4d9Q1hpB9oEf5mhCD6uQGDKeCddLwvUYGF17BonFyS	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1624	1334	360	12463	12470	jy1iJFsubP3C9D8KgNrQL1ivbeipwACC2Y9iPdGexyZcryLuKAu	10132	14285	14285	1618510500000
20129	3NLubK2BwLtwvo1wBh2dpLV71J9MH2nrEAGAeqqX5LacLD46mNui	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	1652	1315	360	12463	12472	jwjtAYiTg4iZ4GfL4PTBQj5cb5KtuQDUrZ9xgtprSnhdeUdu2kv	10133	14286	14286	1618510680000
20138	3NKG8p6bMQAmEKc8FF8tAGtqQeEdZbnbTNa6D6gt7W2teCH8Nh4n	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1610	1314	360	12463	12479	jxZKQHskHJFLE75MFGbyTp7De23Y9tEUmDspdttSG87QsqyuLmg	10137	14292	14292	1618511760000
20149	3NLLiqgyQaZ47VrQbywvVfpwmp91MMURFiTuXAYGRme7yynTZ5Aj	20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	1608	1163	360	12463	12490	jwC8XSSjvkVXe9incYHRQLvn7mEaKgNqRfABTe82KpghkfXZYkp	10141	14296	14296	1618512480000
20157	3NKzsFPUJGVbMjeGLpQ1dbHMpw2sM9MV9gdAvLtsmXezmtzJAADH	20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	1619	1275	360	12463	12498	jxaMw9Ysa7wZhWen4fc7q3UY4A92vnDoucTC95cP7tBmUwGnxYC	10147	14304	14304	1618513920000
20161	3NLaE67ffLQMg3muGGMMLmht44jvbR7ojmYTYmQiRFzxByek4YFf	20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	1407	1395	361	12463	12502	jw7WMSCFZCyZx2VBNPHdFTBsiUYnyC1QXpb6YPV8A9uUDhW2y9Q	10149	14309	14309	1618514820000
20168	3NKAtcaaHjMRTootcN3ZVoQTmvhaQoHjnwQp7Dd851YW6ibWMgFz	20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	596	1180	361	12463	12509	jwSgmXDUKKZyyQ77ZkhCvyrP12Ki1sruru8PdsP9wWrSY2XFm34	10153	14318	14318	1618516440000
20173	3NLm5wdkX8KcYh7Q5ZBA5uB5yKD78TnGjTFB1wAkk2wBFHU47Wv7	20172	3NLkTk1A316tV19UiqMBubYSz47KZNAiFJxLtHnXHecM2wJWXKWf	1407	1395	361	12463	12514	jwsaXm7DjWhjHEfMqc5HQinTxBjL9iWvMjrxNR39pWTcN9MJAxF	10157	14322	14322	1618517160000
20181	3NLfedSiPtaaeUG6Aamj5HRsqbVQRsy4xxqmdLDVEBt6dE2oKLus	19652	3NLn2LK5ZQebpgAEX8uJ8JH9mE3uYYwj3xfxs6RfJJWU42qvJp1T	448	1305	346	12463	12522	jxh1xwM2iPVnKnWUkReB2gx32GQ4zL3ECkaekJYmUsKpVrAwpby	9899	14330	14330	1618518600000
20183	3NLE6nNLznKq6NGFm7b5zyYTGxjUghFbdntKoREravzK8XHaMwaH	20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	1407	1395	362	12463	12524	jwcFRtKsGXAjQTkTWwrTTzhDbXVvVZmERFRwcRyXBcHEJYzr5jQ	10163	14333	14333	1618519140000
20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	20184	3NLEp9R6zzve9tVXAx6yoDcpaPFUjzU51PWHmAaVsS18PynPB4hp	684	1352	362	12463	12527	jxMLwMXmHhS2naepMMfPiaXLceh3nuSR9uSLFRYUScYKMq4AtEh	10165	14337	14337	1618519860000
20191	3NKL3KmWSEWnm7dDGdZvZvJdbBT5qPBJYb2wJoE3w4yLTTmV1d8M	20190	3NLWmHaquCBfoLMVYcRekSepTvqJF4h8YaKDmtRuEo4iBDro21kG	1654	974	362	12463	12532	jxTVvghG4N84Z57NBciSZCCyASBW6322RgdC7J34VtETCR8eXoR	10168	14342	14342	1618520760000
20194	3NLVu8xR4wt9hoW7wyWZxp8dD6G5GrLUGU2FMqvyMWzkbkRnfCK7	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	1672	1039	362	12463	12535	jwfR3LkGXi5Nx9pSneVkJNuNYcaDgE3vJMSPWQRmayFYow7bx1u	10171	14346	14346	1618521480000
20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	20197	3NKL5G3Cm33iQYdhwxKnSqditWULA6QrrkqJVyqYMKQdZKQ82nx8	633	1258	362	12463	12540	jwg98WJo6XHwQzKjRRfc8aZnx3XG7Lc4T9rkQcsxmfxfiU5pZ2t	10173	14349	14349	1618522020000
20208	3NKE8p8YBy1A3reqkoq2L2esuN4NGqNSXEcWp2gnfQsVf2qsJqfJ	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1403	824	362	12463	12549	jw9uDU7KkMhcSSz67L4iAfTk8L5PVbrTP4AiPa4k3v1NX2TrAdm	10178	14354	14354	1618522920000
20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1585	1366	363	12463	12558	jxUUMGB43Z5Cwaxf1XhwYBXgB9dohX6hmtnGmbYeZJktTvVrofE	10181	14359	14359	1618523820000
20221	3NLkSDG1Mog6pFMnT98hhYsYHtMQsoPGN3iP2bSu1hn1RhVUvH8t	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1560	1165	363	12463	12562	jwPZsPu3mSA5Faa6ws459hzSooDiXvpi9RAwDNqwT4da1vKQ2t9	10182	14362	14362	1618524360000
20231	3NKgNHLELo6MWnMCvDADNxW1RtzCQ8semVMsf1B5m5yfeBVByHNa	20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	1501	1360	363	12463	12572	jwmK3zyrDWFWrncCZRGqADQU7BBz8384bF3dNYrQpE6hetSsUWP	10186	14367	14367	1618525260000
20233	3NLjwHo3PPxJzuaEKEnZZv3xe4fvE8Akg8AhPBUDXLEv58njA5VJ	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1457	1391	363	12463	12574	jxHFioU9w8qDfxXFffh7CKyoV6pevuGgMrpBB85NqnW87nicXb3	10188	14369	14369	1618525620000
20078	3NKKPArAazei278pk6HCgFsoejk9XWuuzGg7dUZ8p5dWpFu7E9Sj	20077	3NLKjR9CWe2dT8ooxWqdDVTRpTuZzfPoVKxQmnCentmYkL8e9BZd	1516	1294	357	6301	12463	jxoFoWJ9UocxwusYxhn37GfruR8dFwKE3P1dkeSXrtRHUiHvryb	10106	14249	14249	1618504020000
20081	3NKbfyUzaGrnFEUW8XdtYSEzLGvzkwQch5CpWSVKiuNA4SoG6Jn5	20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	1403	824	357	6301	12463	jw9gNU5ba42b4WM2TrWe9RsGUsQdbaeGtXZ28iQAZttWS2sbq2p	10108	14251	14251	1618504380000
20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1503	911	358	6301	12463	jwPy8aiVbZ3DRVV1EwkdWU3tvY6afjt6ydJHivhmjtQq1RkjgJz	10110	14253	14253	1618504740000
20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	20087	3NKPbUtSic1jXWWR3oQgv6ybf9Xnz8oVVPd3ysoq5q41Jen3steF	1573	1318	358	6301	12463	jy2SAqWicQbxdvUj2KVR5xdjdLiaRMmv9ThycasXjAMNXWyZE7f	10112	14257	14257	1618505460000
20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	1547	1252	358	6301	12463	jwwSJDsCbCCBkiaJSkB4UvmTFrEamsv2EKy6218DvJj3MPQ4Jib	10115	14261	14261	1618506180000
20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	1602	1369	359	6301	12463	jxKNdUuQxNa7P6RgfaVqDAs2yKiEJhJXgkWhzsdp8QD6Z8N5JZd	10117	14266	14266	1618507080000
20102	3NKTKJvUK9zKf2Vb9L4ABaDLdZfqjjaPNB8xTGbMaJtgwwkP26zf	20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	1406	1393	359	6301	12463	jxsAA8aDNWYWrBZKwHjNP9hU7rg8rEpWdPBdvXbKbzTyEibvvnU	10118	14268	14268	1618507440000
20105	3NLmTft1m6vwtCxt2Bj3dEsxKP6fxTKKFuVXAhfE4AqRfYazeZsA	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1407	1395	359	6301	12463	jwgBnSZR5pX4ydyHi6xEExCyCAiCxvZb6JcMUarnZg6Jjxu6xoK	10119	14269	14269	1618507620000
20111	3NKwKbTg8SjWDRBHTiTXewC8nCi9aiuPmXBLsWKnVVWnbhjb8N5P	20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	1652	1315	359	6301	12463	jxvHvJUkLYrmeHc7ZgbuGaM7WYy3r7Fnso3TkThdNT3dKwaoHwN	10123	14273	14273	1618508340000
20117	3NKP5iMfu5SbVsb6ubkxPnyyYUs5ToLp4aBbFHcaJnpvuXFAGM4i	20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	532	532	359	6301	12463	jx4ycf6VdbcQB2UgZAaFnEYEUAnxq5qV17gRiYA3csjhtz3NuWy	10126	14276	14276	1618508880000
20118	3NL7Z1Vwnnv6zNJpzmxZMx79m4pFB5rRAY3kBjyaeqqVy7RrYsdK	20117	3NKP5iMfu5SbVsb6ubkxPnyyYUs5ToLp4aBbFHcaJnpvuXFAGM4i	1406	1393	359	6301	12463	jxHYG9Yo7GHp5Ub4WT3FxmgJwTzZhEQCSZkXeHdukwYMnPcpJVg	10127	14277	14277	1618509060000
20123	3NLuqaGzPzahv7k3vNQnMJC1qFUsVwnJFrJgVaekutCjkrdq8Wjs	20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	1643	1299	359	12463	12467	jwtNakHfhDyMGcDC5ZNWMcSjFoyh4wRNzSTxo6ixwz9buGeyL37	10130	14282	14282	1618509960000
20128	3NLvG1HN74wuFFw8fWrw3T9JrAxeBLLCmXEWCMdBGf4G7gmgsEDX	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	633	1138	360	12463	12471	jxE4zqALNkH5xWkQ4URaDQzVRYBuRD2zxzfqucZxHieHUjWTEx8	10133	14286	14286	1618510680000
20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	1652	1315	359	12463	12472	jwjtAYiTg4iZ4GfL4PTBQj5cb5KtuQDUrZ9xgtprSnhdeUdu2kv	10133	14286	14286	1618510680000
20136	3NLUQbS8Dwt9YgPBdqWcgDi7iChU1M6MbCw2XYQHtrscZJxkoNRF	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1637	816	360	12463	12477	jxNFw2yXoXG7UTPuoTEhKbar36Tqet7JaXfnkn59QBGeAUNwdGB	10135	14290	14290	1618511400000
20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	20138	3NKG8p6bMQAmEKc8FF8tAGtqQeEdZbnbTNa6D6gt7W2teCH8Nh4n	1406	1393	360	12463	12483	jxyHUntxPjMjoZKa7BkoU1qvLb2x8Yw3iNzbxyzNBiCeXqNaLHg	10138	14293	14293	1618511940000
20145	3NKG9QGpFpbz5ZuMPHGewEYE9xavRLcDsdn8zvXi8DdaJoTvRb2w	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1407	1395	360	12463	12486	jx7NFUHaWJAgc3G66kRMVkrzy974XqSdaziLkrHFm5A2RaaA8tR	10139	14294	14294	1618512120000
20146	3NL9f8a7bGrSaAnPmV7UxhviB9y6drGSLYDzybcio3Wsqv5S6W9W	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1590	1300	360	12463	12487	jxNRCkJ7km3MBBwn4swZuKY9hSKNza55w4Mahogfbpqy7Ch7adL	10139	14294	14294	1618512120000
20151	3NKJsHccU92kHfWh3q3HRQzSkiUbAzWRaKC28gQXLUqtqyTZKgDc	20150	3NKJ9H956tN4HXCUbfKKes67yXen5jFn7ZDUSuSSCfSJz2aWfzkh	1419	814	360	12463	12492	jxhHcdDQDJVFoHYA4dbwTF6V7Ro5DbQjxeFetoFh1RCncix9ioM	10142	14297	14297	1618512660000
20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	20153	3NK8bxPy76Mk2Wh3Rh1fDMKMTK8zy8kVm9U4hs1enyBHPYdNLZg9	1499	515	360	12463	12495	jxDmqthpB6jpEERV9wd9dTzECzXeUZwSwBQLLSp7a1J8otN7D9L	10145	14301	14301	1618513380000
20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	1589	1286	361	12463	12501	jy2ESDiWRgwGzMeeL6qLXavwJqw7sdHqx9TWnhXYdjsyMraoBCr	10149	14309	14309	1618514820000
20162	3NKn4rWLnbDoJxucfopPNsw5ykBZVgmMGLG1kk6364VfLF6pdiBB	20067	3NLFehztMFHj27ZuPjz8sno6BEPZbVm12MiyMqZSUBVyaiuNyzVy	1553	776	357	12463	12503	jxMT6mfnnVNKWj2JaEguD1mUspe5sqrqtoEwPN8vH4cRAaX13oA	10084	14309	14309	1618514820000
20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	20164	3NL2kUHgwfKxorboTYNsNQqfJgFdw25f4bsevtLbByXJ8CWTJYJw	1675	1096	361	12463	12506	jx6Kk1Gv642NdvniwkMUJLniQno3CvnuBEe1xictAamNf8Q6mc7	10151	14315	14315	1618515900000
20170	3NK5WSNbd9PBH1qSXkdPZwUBUUD5B311XFE6njJ6QQNRW4jmXBb8	20168	3NKAtcaaHjMRTootcN3ZVoQTmvhaQoHjnwQp7Dd851YW6ibWMgFz	1407	1395	361	12463	12511	jwC9ErLVMj9GzFA2UPS5ZNo9737RfhaC9Bti3wJNzfjpNULx98q	10154	14319	14319	1618516620000
20176	3NL9rjpLTdXbMuezXnzAP1b4g21QynNHpzbN56PQPxc1q67SoBHW	20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	1631	794	361	12463	12517	jwDFhebdjTGfVWQR56d8hr6CWm5qUq48vCJjsEbepyUMJC6djuQ	10159	14325	14325	1618517700000
20179	3NLXu4DmYi9VXh7nigMzG2ad7iZZm4NRboy7rdeHRuwdPzD1RVnW	20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	1439	1153	361	12463	12520	jxBPYnTWLmpg9BEjZDrHdLcJ3ThkfMbsxsFNpX4w961iMHoLFit	10161	14329	14329	1618518420000
20182	3NLJdwzqVPGMKSo1kMyTqVrJUdvYbyBayN5PaPZ3wkME2mA2gEbn	20162	3NKn4rWLnbDoJxucfopPNsw5ykBZVgmMGLG1kk6364VfLF6pdiBB	1553	776	357	12463	12523	jws4wgm2oUCYMkVKqbQifPKFx16i8qvWSwXppCovRgTzngkxYSu	10085	14332	14332	1618518960000
20185	3NLR1uBqzEeiyZq9isfCBphAMeA5zAugWCdvsrHD7Jt7SjREkLmd	19944	3NLiS9jKjfrJtBXuSFEuufzfdb8TonfrqrT4v7P1cpeidM5xrUBG	632	1136	349	12463	12526	jx3gXGjNqJ6FDgBfVDwar2z7EXndT45i6mXYxnddbrgbt7S8KJb	9927	14335	14335	1618519500000
20188	3NKCZ54B6ATecXHCoJ1hVV44eQ8mufdkj3vErRAWKNqmZ5fcu7KE	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1467	1376	362	12463	12529	jwnBNiyRCajgfkiATqVzH4yx7hkjF6hDDePkfWgVUz7HNFAn9Yg	10166	14338	14338	1618520040000
20190	3NLWmHaquCBfoLMVYcRekSepTvqJF4h8YaKDmtRuEo4iBDro21kG	20189	3NKY56JgkHWSRYRHCmMZTsCx3LZhNPK9PXKwzpFCnecVL8sGQ57L	1406	1393	362	12463	12531	jxk1QXA4du5DgM4d7HduSSA7f1dKocPU4MjbmAaSH867zoxRtV8	10167	14339	14339	1618520220000
20201	3NLQC2VwQKbAHEypEhySsghnD9wiB8DfS68xVnqqEb1E3ERDGbdz	20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	1402	900	362	12463	12542	jwW9uRxrBVYSHk1dWTCVwNkJTVhR3aNoeKrzsyVtozwnDcCdZvb	10174	14350	14350	1618522200000
20203	3NLvSa1bf5MxgmqjPMJYV3u7pA76W9eXaYtXXqMmuPHXPGG4SNtV	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1483	560	362	12463	12544	jxLovp2UE7DUoX2mrpR3JB1ajQvWNf5vhUJpHgZMo3iTfbooWh4	10176	14352	14352	1618522560000
20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	20109	3NLZ6BvV3eecioxyEoyyPJPPBZnJU7vZbfKrBw4so12L4EcjGQbo	43	1310	359	6301	12463	jwFwiehAEskC44gzCKfodQXq8TnnYEV9PSySHbdTnkbZqcn1E7W	10122	14272	14272	1618508160000
20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	20112	3NLPtzF72qP6zCXcAEbuk1zDvPV8SRKNGDuLGBuJEmv9RfZBbETN	1536	1313	359	6301	12463	jx3Hwsx2VnTey69WqpH7t8fSLtSSmB986K1xUwBQJ13RS7UG8fp	10125	14275	14275	1618508700000
20116	3NKgYpgX9TmCAWyCTnRKtBtj59gaNm2JRsC981RJ6eGxfd8HrpBS	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	532	532	350	6301	12463	jwWbADVExzSxeP5wNqaXPcepS9ucp1hMSw46mSJXMf9Tuo33SWa	9969	14276	14276	1618508880000
20120	3NKvW5TmDwppVrudkPCiZioEkq33LkYYHzTzVNFVgx3ZJDd7w7hM	20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	1506	1373	359	12463	12464	jxyAAQhgsFerXiNACNKfaSzq8jPPEnQWfxJ1kPoyNYyjmAsfngU	10129	14280	14280	1618509600000
20126	3NL1pqyYAB2XLZEcJmULJHhRZWD3cPmvCc1KxCGwcF8kK6jmzpTt	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1624	1334	360	12463	12470	jy1iJFsubP3C9D8KgNrQL1ivbeipwACC2Y9iPdGexyZcryLuKAu	10132	14285	14285	1618510500000
20130	3NKCjZm8fBorPQYDHSULUmUPYF6LUjfhA9LfMPtDnXghax3koBGQ	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	633	1138	360	12463	12471	jwQ9EVBotzcLKpDW8PSqosPPRwZn1XASngJ8et6pZfquxfA3b1f	10133	14286	14286	1618510680000
20133	3NKjNQqRJ5kK2Mc7wKZC1tV2cNycMZc1AntnDEhacNKqjtFTqQxg	20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	1637	816	360	12463	12474	jxQAqLQ5yKRjkdXUm7q16G2hH2M9R3TpKGfrAjPJPbBFJuo56uu	10134	14287	14287	1618510860000
20135	3NKxmtvGtQK5t6Nbne2C3jwDqmjmUZ1YRdQUHFEXc353PhSR4QyV	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1406	1393	360	12463	12476	jx5QurucGfY5BoknzxAKXyjbUB9rikvy9bnmw5iD71p3XPZrZJt	10135	14290	14290	1618511400000
20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	20136	3NLUQbS8Dwt9YgPBdqWcgDi7iChU1M6MbCw2XYQHtrscZJxkoNRF	1406	1393	360	12463	12478	jx6HDJoSPrK4nEqijEf5EUjrSAmPDfT6yDvXVigX6UgFM3W73PV	10136	14291	14291	1618511580000
20140	3NKB3eiocBqERcbE4R1djNTkoonhWXC7S4jEBmTaz91gMVbGhFL8	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1403	824	360	12463	12481	jwkYcYpngDigrsn7U8wyyURdiezDBbwcSZLBRCd2gaNrpi9SayG	10137	14292	14292	1618511760000
20141	3NKtviiDaz1Sa7Sg8sY9xKjgjyx9RaUaAX5caSYpWiY4X3j7SF6g	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1623	830	360	12463	12482	jxBwd8uq6EYMjignmuJEdukd8UweTqX3KxXe578MZa9pRTcV2c6	10137	14292	14292	1618511760000
20144	3NK7JbV5HH59BtBJGKueGFXqg5TMZv2Ph8es192hKm8d69TNGVkT	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1440	1377	360	12463	12485	jwYwmivpPphoCSPfNqSrXJaYicE39ZaYVVWLUFcpDami97KakdH	10139	14294	14294	1618512120000
20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	20143	3NLkGRdwNNzWzbZfMhAcvZizfzY41PbfaRwnKj4a1mrtXJLDeqRm	1617	1042	360	12463	12489	jwURmK87jG9vPEwCkRkeSgQZTgg2kseUbCT18CJTf7hkeDaUn2T	10140	14295	14295	1618512300000
20153	3NK8bxPy76Mk2Wh3Rh1fDMKMTK8zy8kVm9U4hs1enyBHPYdNLZg9	20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	684	1106	360	12463	12494	jwbmhaLDjYVgWrvJKLxgsLRkkT2PRXAym3Xdk1jvTCcLBvTTgHH	10144	14300	14300	1618513200000
20156	3NL8jX8mNosSTBJC5c5US5FCcK6kvS9o5cmGcdCuHmpzeaZhxzU4	20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	1405	867	360	12463	12497	jxmBwdH2LyYBADkveiXpiazbUvkfBhSJk9vXXBPiRi2hb8zKPNU	10146	14302	14302	1618513560000
20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	20158	3NLHpmpsFCNxjAyhXPKQPmDmj1aAVes4kMaEiidfwCWfLM89bZbR	1549	1116	360	12463	12500	jxsduu9cgiV8FVdmXEFh6vK4X761jVxUPdFrBE7FJYb1BNkXDwZ	10148	14308	14308	1618514640000
20164	3NL2kUHgwfKxorboTYNsNQqfJgFdw25f4bsevtLbByXJ8CWTJYJw	20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	1602	1369	361	12463	12505	jwTbC8XTpHwJBh7vCc9NPe6JbVvcPMpCZWG1HX42Hk5WyGHeavd	10150	14311	14311	1618515180000
20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	1547	1378	361	12463	12508	jwTAFd8TwLoewXUjjCV6sxECLtrMAC39e5W2EbbubHt1ctSyFm6	10152	14316	14316	1618516080000
20172	3NLkTk1A316tV19UiqMBubYSz47KZNAiFJxLtHnXHecM2wJWXKWf	20171	3NKBvbDoevnBtHr87cdXHUbpoRHpwqgJFSn6tKqLCFqioss87yKo	1447	1345	361	12463	12513	jxtndVmTm4B2gZ9wcHP6uX9NbRhNTVeAv7tB64cMxDWcjsApjwZ	10156	14321	14321	1618516980000
20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	1407	1395	361	12463	12516	jxr1an5cGyBy9ZSinihX4xAZZhSm9eEt4s4mR4oSPt4iKdBmQ4b	10159	14325	14325	1618517700000
20178	3NLGPcUKNzqZ6Qhim8niFTmfLsuyckchzzT43x6KMKcqZYw8XUib	20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	1594	1326	361	12463	12519	jwEwTpAuBhQ2Zptf3TCA6VYWAoehppdZ9Puq4VrESHSLqtk3gn3	10161	14329	14329	1618518420000
20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	20179	3NLXu4DmYi9VXh7nigMzG2ad7iZZm4NRboy7rdeHRuwdPzD1RVnW	448	1305	362	12463	12521	jxUWFsFL2ZUNG9uiSrrJ8dUHFsHE4Pp7xgfeHEVRsMbdBZwK7F6	10162	14330	14330	1618518600000
20184	3NLEp9R6zzve9tVXAx6yoDcpaPFUjzU51PWHmAaVsS18PynPB4hp	20183	3NLE6nNLznKq6NGFm7b5zyYTGxjUghFbdntKoREravzK8XHaMwaH	1581	778	362	12463	12525	jwNGYma6GmypWmPQAUBePfUgqiQPoFTTCjzF8PNveLcAKG9jqVu	10164	14334	14334	1618519320000
20187	3NLpb63UfKECAsySnopz2YRTaWXGKQ7eRhQhXVS6TgKpj1s2XVyE	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1406	1393	362	12463	12528	jwqt41G1EQpEdnDcn4C7LAABKsctj4FGh6KkKF2pYQEGmgzC6jq	10166	14338	14338	1618520040000
20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	20192	3NK6kHx8w7bMjs7XMvCvxfLXKtuHWGBxRcXmsXGY2d88Vzq4SPfk	1553	775	362	12463	12534	jy3CF4hQKgM5MxmXcVAnNZuAvUuVSnxXvqoD8kTuHwu365MpSgW	10170	14345	14345	1618521300000
20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	606	1169	362	12463	12537	jwPphNNNEh55kwBv3nSbG19GXNvPzexcp1mujXaPTDVDTitiMVE	10171	14346	14346	1618521480000
20198	3NK7FcYKfnC2E7eJzTt1hSs4yBKPHUT9mJukv99f64yZqZaSDEoQ	20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	1578	1296	362	12463	12539	jwS7mmEcPKxjCkViFLcGAynnEzXBVgwbNi7kZy1Z13hDe2yLw1B	10172	14347	14347	1618521660000
20200	3NLVrkWor7LGH63Yt3dF51CvzvXnmkQjQHHWTYNpuEoBrpuo6GJy	20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	1529	1070	362	12463	12541	jwk8YGHMrpLLANnaMJGkuuNyrXBE3h4PSEKg16axmYnuhwAEe9m	10174	14350	14350	1618522200000
20205	3NLdzPgunFRrod954Q31wwjLXyhpQsvp6ScSyNE87nSEmgHVDT6b	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1601	1022	362	12463	12546	jwytKPqg5X2rbNQpa777MKTWueGFaUVn5GnDoRskv8JVVZtH4zS	10176	14352	14352	1618522560000
20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	20204	3NL3dRvp1EpA4u4wzLDUcggiZvNaN7EBKQesci4YtphZuMNnifxx	1407	1395	362	12463	12548	jxsFBqDPPg7BmJxADUAREiHeoFwX1zfN4J7MZ7EwZ61vMRqiA5L	10177	14353	14353	1618522740000
20210	3NKEq3y8Bu2LgJ39FShpsSLPwi9Bd8Ngiof9NfVRzaNNzGN31HUc	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1508	1021	362	12463	12551	jw9p5zyz8GfC2ymWWsjiUW5feJB1tNLmaTEXKeuez93wMgN7gGu	10178	14354	14354	1618522920000
20215	3NKnc3M1K74qu1Zgp3vuaBZLxgzFhMzemNd1a3dMsKX2Cer5A9Cb	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1483	163	363	12463	12556	jwHB1r2AVPvmazdCiCFXXrwsZiHzoxeXBYbgZZNnBRTRh1QiidV	10181	14359	14359	1618523820000
20115	3NKi4qBhqW5ZPMa9LxzBDbBDdPrzDd7sgBqKCbjriX1F8JfPLPLb	19855	3NLdHqqPvPmRbF8jUE4J85viacFA6yRa8jPGXmHZVYJb1Wsh7iRj	532	532	342	6301	12463	jxpn59dP9fXweqMwq7Y5ayyDmhqvyxcdsKg5wgx3ckqRzXCDrNo	9840	14276	14276	1618508880000
20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	20118	3NL7Z1Vwnnv6zNJpzmxZMx79m4pFB5rRAY3kBjyaeqqVy7RrYsdK	1406	1393	359	6301	12463	jx9ErQnMb2Y6UxfEFzmjNV4TMFWNJnd7jPJdfQ4FKBV9RtFGo6n	10128	14278	14278	1618509240000
20122	3NLbQNzKqGrraXirGoWg81gGZm14tkZyVxqCXwKXCMP4ohKrMP9e	20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	1406	1393	359	12463	12466	jxNPSbQGMnooUjyAuPeufPRzZZ9zReboukdTeJGYNzk5B3RNH9G	10130	14282	14282	1618509960000
20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1659	548	359	12463	12469	jxm5Jd4jW9vBrEftkci1GGVH8KWyP9nMafu51GwZgzu4hUqT3By	10132	14285	14285	1618510500000
20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	1422	1337	360	12463	12473	jxDZsBA4M5oKfZBoY1zhL9wb9NYS6VXYJ5bJC3ghUEA2cxyJf7g	10134	14287	14287	1618510860000
20134	3NLn5WQYvAxNy61Xu4HmK1mHBWnfdUaM9XsCYg5urdKfTniRvY5o	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1671	1365	360	12463	12475	jxuF5FbuQMb8MNbKraKMJbZTL3ENFg9xbR7Q6k3tXsLhsQtcLXc	10135	14290	14290	1618511400000
20139	3NKXen5SFCN4HJ6LUrSZqK8Yrbk4NdiN9T5GHZd8eiZWHxeChrMw	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1406	1393	360	12463	12480	jxe2iVvEmRsLKmGamTJwEKB9QvgxxaXNFLgeYVFu96tFE8b87kX	10137	14292	14292	1618511760000
20143	3NLkGRdwNNzWzbZfMhAcvZizfzY41PbfaRwnKj4a1mrtXJLDeqRm	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1406	1393	360	12463	12484	jwWUFzXXYVH7KstGsnroyyfxEpuZFpxisrARtCbd5QsAa6HByKe	10139	14294	14294	1618512120000
20147	3NKHeTbu9H6SrRR1MhfcAuA344oEDJcAh45qY9yKGs5Ug6bmR11j	20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	1590	1300	359	12463	12488	jwFfG1SaMJgQ57C3mKzvUUdmECJzFpPCopbwtrZ13Ryk7xSW3KT	10123	14294	14294	1618512120000
20150	3NKJ9H956tN4HXCUbfKKes67yXen5jFn7ZDUSuSSCfSJz2aWfzkh	20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	1646	1108	360	12463	12491	jxj2pQtgFExPdFuyskDUakWKAtCBZAWpCJbW8bBrxDwiP3YBKVt	10141	14296	14296	1618512480000
20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	20151	3NKJsHccU92kHfWh3q3HRQzSkiUbAzWRaKC28gQXLUqtqyTZKgDc	1406	1393	360	12463	12493	jx958qgCyypy7rxc3pwQS6iy3gkPe5eC67fejCzMoJX2UGkNkqx	10143	14298	14298	1618512840000
20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	1654	974	360	12463	12496	jxUPZuMimQifJECD3FZf6MkDSsht8hzB2GTxEgeEpYRpUZZSA7S	10146	14302	14302	1618513560000
20158	3NLHpmpsFCNxjAyhXPKQPmDmj1aAVes4kMaEiidfwCWfLM89bZbR	20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	1483	731	360	12463	12499	jxukT587L4E62aEdNnqK2zVczCpUNVFTSLCs2dDRZyyBU2iTbjd	10147	14304	14304	1618513920000
20163	3NLCc6DvMUCLcurwFZsHG9hFN9v5rjWGut8ogWUbQXU1zJdhVVmP	20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	1483	1276	361	12463	12504	jwkjdYf4UTEHqGvDc4K4qegST87eYfAHoCgFNL6NX4xUqSSb7xZ	10150	14311	14311	1618515180000
20166	3NKFG9BC5pyLWVk1Fx7nFSYbwu8TK2N1chjTyhF1hNZ4pgw6bzqX	20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	1403	782	361	12463	12507	jw9t395RCTNk95bgAmX28L9fB8FRvyt96iSUafsHsuWQqSqWb55	10152	14316	14316	1618516080000
20169	3NKCm4tDNTHHu7oZoFDXEiZjgYz6cw2Qj9MPTwLcWFVfFfzdJGCX	20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	1406	1393	361	12463	12510	jxUnD8AfJpNZUyX7sKi3yjaNrRCTE3vZpzXr5FoJEsGCA5cr9yH	10153	14318	14318	1618516440000
20171	3NKBvbDoevnBtHr87cdXHUbpoRHpwqgJFSn6tKqLCFqioss87yKo	20170	3NK5WSNbd9PBH1qSXkdPZwUBUUD5B311XFE6njJ6QQNRW4jmXBb8	1467	1010	361	12463	12512	jwek28Gf6XCXouqq8qRtyGoSK6SwDiAQjVAfutHsFQSbqCheTzn	10155	14320	14320	1618516800000
20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	20173	3NLm5wdkX8KcYh7Q5ZBA5uB5yKD78TnGjTFB1wAkk2wBFHU47Wv7	298	1308	361	12463	12515	jwW3kaSHqD5Dn2LHdqq8nJVV43x32nEUTCmJMmpoFEzNpHZzdcR	10158	14323	14323	1618517340000
20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	1439	1153	361	12463	12518	jwHkecHT59JQxnR4MYH42SKQ7heZYUaj3RGZZJZdNTthKFgrPBu	10160	14328	14328	1618518240000
20189	3NKY56JgkHWSRYRHCmMZTsCx3LZhNPK9PXKwzpFCnecVL8sGQ57L	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1419	814	362	12463	12530	jwB5jpwS7799wgXzU15sVciYSAotMDkatf6VgQMB4tdMzwJbnTC	10166	14338	14338	1618520040000
20192	3NK6kHx8w7bMjs7XMvCvxfLXKtuHWGBxRcXmsXGY2d88Vzq4SPfk	20191	3NKL3KmWSEWnm7dDGdZvZvJdbBT5qPBJYb2wJoE3w4yLTTmV1d8M	1509	1320	362	12463	12533	jwi1fYdX1a2dQTZGcSeTdrJyFNQHJE3qX36ydJK3BrmcpE9d526	10169	14343	14343	1618520940000
20195	3NKzDFvjx1bZLCvURXzVUhwcQqYqiGPdghN4ZC1PcT3Tb9nhWe9d	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	1549	1116	362	12463	12536	jxCyq6qJaBTnJ56HxPMkYGSgGZxQjYyjqWadkYiodU2ejLYzvuM	10171	14346	14346	1618521480000
20197	3NKL5G3Cm33iQYdhwxKnSqditWULA6QrrkqJVyqYMKQdZKQ82nx8	20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	1405	1	362	12463	12538	jxa7STNgz85QtyKqrZ9MeLHs1KX39wcWoeXxuMxFWBiRiEWpvM6	10172	14347	14347	1618521660000
20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	20201	3NLQC2VwQKbAHEypEhySsghnD9wiB8DfS68xVnqqEb1E3ERDGbdz	1407	1395	362	12463	12543	jxzvjj5wVPTsQhBKE2XRTXFUysKd3wACk5CB6vx9DAeRKAV9aYV	10175	14351	14351	1618522380000
20204	3NL3dRvp1EpA4u4wzLDUcggiZvNaN7EBKQesci4YtphZuMNnifxx	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1439	482	362	12463	12545	jwxaJn7EfBGDf9RoSwFKiQCj7MiEzc49EYAVCh6PjVPB56NipA5	10176	14352	14352	1618522560000
20209	3NLPmMQCY95Kw7CYBBvPnzuCarr7UuBxRKBii9ksq8GiXu3gs9q1	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1471	1260	362	12463	12550	jwvcJFf4bG2odct4jHTS1hxfSZedjwcC281imtsoknHb4ydpEsP	10178	14354	14354	1618522920000
20212	3NKb3rkwPYvxXkRM9baXeJGM46W14dpr4SHdPNeE52L1cyUHbzYF	20206	3NLRezAc8ZhWzZrupUquzvyj13fHt1aTddNdvpx1xjWnuZ1oEGz3	1439	1153	362	12463	12553	jwBePJ99d4XnNbdgb6h8bo8S1GC9acBcawpm58YtfFP43g3sUzu	10164	14354	14354	1618522920000
20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	20213	3NKYMb6i3sH5KKW3g7xfcYQnCvdmhEVovL1No222ehHK67F4AUYB	1406	1393	363	12463	12555	jwNBEC8Bdcc6sMs83PMKxuv7g7SutbjFuYV4fHvSkUdG1f3sF9f	10180	14357	14357	1618523460000
20219	3NLftWSpfsZ8vEG9Fk6M2VwdDi6CZNAbD8z9yFr8AiEfFAVAHsBc	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1577	1327	363	12463	12560	jwNwMNdgdLjtAA9vvLbPJ5CcG54fQCU6jyUuvA2pohbNFt9ZP8W	10181	14359	14359	1618523820000
20222	3NKXEbSXDSxQosgX8rFY2MH7Tdw8vs8uJTQCWEm54EzGewWQ6veA	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1407	1395	363	12463	12563	jw7eQBMkY4NJFqgQ53rUkhX9qpw2FZKzabvkiQrqAbkF7y5chCf	10182	14362	14362	1618524360000
20226	3NLa42EW4QDB5EsNH9hmLGV7tYHi4UmP75cx8s54gNgSXgF8QmdA	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1634	1205	363	12463	12567	jxWC7nrQtMWuzsT3yY9NAuAa6D5N9WqGToRg7MsA1o5RQaKwz9s	10183	14363	14363	1618524540000
20234	3NLLF7zovNx8Zk8oGXkPcRd8Tyxg18M85aoKN317VxCWF7d6mLtf	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1501	1114	363	12463	12575	jwpY4wAPwKBxndVtc5U929czfNCSVMf5RF29aHFT9YtVmoc8KSr	10188	14369	14369	1618525620000
20206	3NLRezAc8ZhWzZrupUquzvyj13fHt1aTddNdvpx1xjWnuZ1oEGz3	20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	1439	482	362	12463	12547	jxQY9pH1N6y7JNXBLKZnqzXiL5nsnA6C7QcJ5sWxXzHXzsLBMsa	10163	14352	14352	1618522560000
20211	3NKi2JRprYA9yGsG83awT5r3gCLjU7Y5Wbhdzm3ZfrutTkh2ZxNb	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1439	1153	362	12463	12552	jwYV2kzWkunayjySMt6tzmgoYTJkSNccdsJEbsZRzBzJ7vvmrTL	10178	14354	14354	1618522920000
20213	3NKYMb6i3sH5KKW3g7xfcYQnCvdmhEVovL1No222ehHK67F4AUYB	20211	3NKi2JRprYA9yGsG83awT5r3gCLjU7Y5Wbhdzm3ZfrutTkh2ZxNb	1407	1395	362	12463	12554	jxWyzJYF5HrYorzQ2PW8xFtYUZDejBSt5iJKhacDRRp2PMSuaWQ	10179	14356	14356	1618523280000
20216	3NKb4qnmCngNSigNrJpMPxoRwyBH8ebkf7Qy1SZ1jGCk3259VL66	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1406	1393	363	12463	12557	jx3RQiW1o5ieoBWDrKi6QrxrQU3jTt5CeFhjm5gw7g4cwAZYTM1	10181	14359	14359	1618523820000
20220	3NLr3QvGY9N653YVP8CYxd5qXt8gvimjufBbEL4fixRSUnU4A5Re	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1507	1154	363	12463	12561	jxQct574wFYsdLMMAEA2v5YaBZTySFLPDBys5dszwrfyyC9iSZc	10182	14362	14362	1618524360000
20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1406	1393	363	12463	12566	jxzgwxH9bNzEcwHKqAhkfc6cDGq3rLdcP11WsYW2uH3VLmhaQLM	10183	14363	14363	1618524540000
20228	3NLM61Ky6J8ZdgFPbGmrEtx5S4tmt5Dr5CSzBpQ7f6WpUbDamyi9	20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	1406	1393	363	12463	12569	jxnW7ZPfqFoNfwAjqUWXnjoPz31KwRyz7LT2dJiuRAdzpS18mHG	10184	14365	14365	1618524900000
20230	3NK4cpFnqtVZJFymDHWRKtjg9jRzRDuqzbx2eg9d8Y8Qe2xxGVE9	20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	1579	1389	363	12463	12571	jx5YbHqb56isxB3wpFp5vPzrt8hAZfuPKy5KxgbpkMmAFDNETzS	10186	14367	14367	1618525260000
20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	20230	3NK4cpFnqtVZJFymDHWRKtjg9jRzRDuqzbx2eg9d8Y8Qe2xxGVE9	1489	1134	363	12463	12573	jxKYQTFqEUs6C29n2Q6VTron5X77kKkgCtU7Fq85qbDvfM7hr6Z	10187	14368	14368	1618525440000
20243	3NKHFsmkRP2Lbpfi5q4v4xwkNRRteUryKDqLmgxAbYA6tZhT72St	20242	3NK4gM2239yJBZgZveBdoyCzhKL5zdRgGDCoqvm6MVicC1597Gx3	1406	1393	363	12463	12584	jwYeURKGx62LGeddDNMQs7RkeQpX67P24FxKrdeJYEVSfNEkDss	10193	14374	14374	1618526520000
20248	3NKfd89ohE4w4iLyN9R4eUYPRdRETWCkJj5zEaoh6g4kdVsfG68J	20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	484	1193	363	12463	12589	jwEYz33cM1mW4HEz4YJWoXMidXD9np2x6qcQtntShTDTKfH4QHh	10197	14383	14383	1618528140000
20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	20249	3NLQPTR7EyVLCCW8gKNdtiz1cXXUqYZC4bKvm4ktXqgrks7nTCmC	1483	603	364	12463	12591	jxsV1MeXvzpvE1p86u4PvvUBxWPgnpsXYH97W5zYepFfSxbSLeQ	10199	14385	14385	1618528500000
20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	152	1084	364	12463	12595	jx4CDe43mLzLJCo2eJzJGHFJwH2WFPh5nHprh3JKfgxrmenYrvE	10201	14391	14391	1618529580000
20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	20258	3NL3BXDSygNdr7PkccL4e2YpBWvDvQNZcdthaFKf5BbxxX3DVZvz	1406	1393	364	12463	12599	jxeU6J1KEEMyyiWpNSQjAYsjQQsyBMCrMieNp2KGSConxA5Nqmp	10204	14395	14395	1618530300000
20262	3NKRkm63XQCcvDkS9ZBTBYpfCrsr8yhENkw5N4eBaBWtbt9kXmME	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1403	824	364	12463	12602	jwfaXVXhXz67tJDLuk9kjf9SRgaKBTGEujmXnaCuGJr5d5ruby8	10205	14396	14396	1618530480000
20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	1578	556	364	12463	12605	jxU8DGsX2cQvhmLcxtDpZ5yHy93ZPzCi86hDVr13D3oo4SMUQNT	10207	14399	14399	1618531020000
20268	3NLBYM5pyjwBLyzaZbFXJecBRcmVbRu8qntKgMN72BndaZRc2iAS	20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	633	1138	364	12463	12607	jwHHan6hpZTCYLtRz7peCd9syhNa179Mesnx1T7UgWCqDU2rHHf	10208	14400	14400	1618531200000
20271	3NLV7BS5f13L3siPZFehcaSoGCxDHxJ4hd73s7YAC9Noz5ssJBEB	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1534	1071	364	12463	12610	jxDLzSVzvNnJfNsvRU2HH7ex7RRBSMr3V9wXSWaFPJkbzravzNY	10209	14402	14402	1618531560000
20273	3NLg4WAXPSFfzmrTYmZtVtcmD2GiLbsBM52fVW28drEvwakNZyrU	20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	1406	1393	364	12463	12611	jwKDfvd81CiAN9t91Znr2A1e9nLQMmvQYrHnscWuk4A22vz1ZEi	10210	14404	14404	1618531920000
20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	1587	272	364	12463	12614	jwty4rMTpzwY8apgm4JJ7uVEwYwso1JtWa4cyozoGC5d2GtegCp	10212	14408	14408	1618532640000
20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1633	1390	364	12463	12619	jxFxWUuTEf9gQALfz4bBLsaZo3UTf3UXnv83G6YR9dLppq3Qb4r	10213	14409	14409	1618532820000
20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	58	1281	364	12463	12620	jwx5tRsLMDCB6B7NLMMXt5rnDvUceFhkS43qAkav1sRNSwjNARJ	10214	14410	14410	1618533000000
20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1406	1393	364	12463	12623	jwpo9V7cjBvCRPCLthEw9xH4pFWjaqXm7Pp6LzDjRPPEFgVLJ8y	10215	14412	14412	1618533360000
20287	3NLjXbTkifY4uPGwa9goodQfpCmxUaFFz9SMydv9BAJVPySn483F	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1426	1118	365	12463	12625	jxEMNJn5LFrBrHFaB5n8H7vNwuJ4Ncs3pBmNFUNqrDNT1bhuEub	10216	14414	14414	1618533720000
20296	3NKKrBYRqgr1syKuh8gPd6chQTXhy7SM18974AhE7UKDGeFJe5Cu	20295	3NKEgzahxvFEFw77FM5vYJ24Z9KQQPJ14opi6wRUBiLZyu8AUDQF	1407	1395	365	12463	12631	jxs5aM1LpoqKoWAVWvT2bUSYfpfTe5TT4tXy3p9cRPU81ZTkztq	10218	14418	14418	1618534440000
20302	3NKgnzheFCxWAXsspdewVzAYFRRALo6vJA8DYKV5FvLa5eiEX9PM	20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	1564	1092	365	12463	12637	jwsxd4KKYKQANtKzv9gzHH94eQuiCPpnc1yx8S7ebsKZ7G52BqC	10223	14425	14425	1618535700000
20304	3NLKnKyXowA7kBCh4H6MxQm1iv673fbLaeoDKBM6DAefqPxJqixN	20302	3NKgnzheFCxWAXsspdewVzAYFRRALo6vJA8DYKV5FvLa5eiEX9PM	43	1310	365	12463	12639	jxvP6GdALsAbuZ6pPtcJjsWvJG34ny8EU8tLfZZLtBhjAxYFr6v	10224	14426	14426	1618535880000
20307	3NLhovLn5bZohNwPuEGfE5C19TppAW5UcjBxCEveTwQ2oUKEdxFc	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1559	1107	365	12463	12642	jxgEXMEX8ipuTipA8p7s2wHAiqMjhvMWnMR7q5iBcQZ47zPUnhf	10227	14430	14430	1618536600000
20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	20309	3NKPmjcEEnD1yuY7EdJ14CmFWydczPnp9GUNjZPQrzvpvnVsB6SQ	1553	776	365	12463	12645	jwVYuFgFBwECUexLSkqugz12h3RPaHDicfr5yb8f6xooqHhRVBx	10229	14433	14433	1618537140000
20313	3NLDNae6D4x3vFQtGcZJvEyeyHoGYRoHTGtsmFRFS9CmFT4wKkAr	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1591	281	365	12463	12648	jweUubJZsa2pNepBsiYE5UTgWcSFhxE6m5GFhiSfm1f8kZ1vn5H	10230	14434	14434	1618537320000
20323	3NLneU6witPtDomacb4WHNTfuMAVhHKKCNRgxmhtJn3DsXt8qMqv	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1406	1393	366	12463	12656	jxAbgLmNnnkrSYKg9GVTHehVq2qjD3F5wmumduUioHMhSDU2uPL	10236	14443	14443	1618538940000
20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	1407	1395	366	12463	12660	jwbRaVypxDeVvERLinAAsrXxH5iichR4YQENxaoJpTk3LyL39Gq	10237	14445	14445	1618539300000
20218	3NKwS9f8busqwUfzDeyqLKPgmi8GmrJrwVz9uhmXpgtCH9xvJKjw	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1407	1395	363	12463	12559	jwMdSVdoRTTAeTb5Bq6bDCTQ8Hr4qmK9yEkuEBkYPVCXZ2V39NC	10181	14359	14359	1618523820000
20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1589	1286	363	12463	12564	jxybvmNC9aPth55tuvp8rVCwDkoKTKNWSrxBFxutiPa46p8k3Uw	10182	14362	14362	1618524360000
20224	3NKUvWDehe8KBdxjnNGVjM9NUzyttbcLRe25eaWL7ZNi3XHyN6vc	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1503	1031	363	12463	12565	jx6L1Vr8Sap2Huejm77HWJaySGiMW4cczyEuUc3TmVDTo2mLkYE	10183	14363	14363	1618524540000
20227	3NLVpZ9btxB6Z9Aa2rCUCJWp2bU8Pzw8RL28dNXJXfgGxfoq21qH	20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	1656	1097	363	12463	12568	jx6RRKNYKhaJDtZjeS8pvTzqYDm4Vcbp7DYPQc2JZVf25EwnUkr	10184	14365	14365	1618524900000
20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	20228	3NLM61Ky6J8ZdgFPbGmrEtx5S4tmt5Dr5CSzBpQ7f6WpUbDamyi9	1668	1370	363	12463	12570	jwRJnxLpkMVJjb71aGhycNvZSHmR1E4GwbP5TFhUgydo5vpe5c9	10185	14366	14366	1618525080000
20235	3NLg4pag5zpcwJshJJxjJJX4MTV83tQiYShRBNX1ZBz8woNi4sVq	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1439	1033	363	12463	12576	jxYp8x5TFZprdF1Hn6sfwjCYxUfxvGyJkFP4Y1P2pHN3d4GyxCT	10188	14369	14369	1618525620000
20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	20237	3NLL29mpY872dcvG7thsoou7qCq9x8djcBpEaKneS6uvANahK2wJ	1559	1353	363	12463	12579	jwUbFwvRRTHivdhT7Js5ozExDWD7TPSZ88H86bsNg818qFvCCx6	10190	14371	14371	1618525980000
20241	3NLh9jz1Gnsag4CecuZAJ3esEqdETb5tTdbr5xEJvSNbC2YU36ya	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1407	1395	363	12463	12582	jxRqsp4UWAVWjCoxe3FbaVp5B4ew3Kf7R2Kc5rBSHhKbY1PfgdU	10191	14372	14372	1618526160000
20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	20245	3NKys76karPnNSGTmnVD83CbECS7NFTsggzCWyqbH2wUP42qmNYB	1610	948	363	12463	12587	jwhfkmzhfKJLP4tPViCU6Eb9vL45tzLHh6U3yufU7swdizH4GYX	10196	14380	14380	1618527600000
20247	3NLQRsaSK8zSv7U38JQZjyvbfYLLThnGRmGR8Wn4GEqHubrBvvCf	20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	1406	1393	363	12463	12588	jwx4otcJSuy2zjCHDHbwy2iyf1my4C8E7S8euH4L8n5kWrdH8ZF	10197	14383	14383	1618528140000
20249	3NLQPTR7EyVLCCW8gKNdtiz1cXXUqYZC4bKvm4ktXqgrks7nTCmC	20247	3NLQRsaSK8zSv7U38JQZjyvbfYLLThnGRmGR8Wn4GEqHubrBvvCf	596	1306	364	12463	12590	jwkGT1ewGs1RE3E2EZLCsJJMaSH6UXupkh16esCKizrX5jG7FFn	10198	14384	14384	1618528320000
20253	3NKU2B6fuoEyELhC44d7n2hkKG8r12pAZFyiP7y4Agwa1rVgp7wd	20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	1407	1395	364	12463	12594	jxUurdfEehwVLBcDRaSqQFrSPrVwrLgHgMknudoHz3mKDqHppU9	10201	14391	14391	1618529580000
20255	3NLCZGRoCK58J33Witbsu79QtzXAzRZ3NQFUVWcmKRzatvyMRm6o	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1634	1205	364	12463	12596	jwH5ewUSJYWXCjBwVWNWTvyKn9AvwaKYwcHqZepnAh4jT57bkZZ	10202	14392	14392	1618529760000
20257	3NKVUy9z2x2qurSsEmkGXTczCVQtjZDuXi5T4V5t7Ru8sY7xd4Ur	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1581	778	364	12463	12597	jwc5Z89pa8N47st7MVVvGDYFtZU8SLs5JLcJc85UTaZ23Hb39df	10202	14392	14392	1618529760000
20258	3NL3BXDSygNdr7PkccL4e2YpBWvDvQNZcdthaFKf5BbxxX3DVZvz	20255	3NLCZGRoCK58J33Witbsu79QtzXAzRZ3NQFUVWcmKRzatvyMRm6o	633	1018	364	12463	12598	jxLqbjg6NCvykWdw2dHCGsDCb6oYXuFYz5EaQkVT7Jbuy87ow4r	10203	14394	14394	1618530120000
20261	3NKNeJTmv8n5EZXuuFTdazEPMsktY6ffEoTUc2BBNTpp8sfK3SQi	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1507	1280	364	12463	12601	jwkCrCYyz3BBiyYfBDT4H5iYaPUs3DV28yPCRCYg3sFb3yXDkbL	10205	14396	14396	1618530480000
20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1402	858	364	12463	12609	jwMPhzEWvXddgmy8ZMyHZctnT3BNfEuuipCRtkMLyvtEzH5Ac5Z	10209	14402	14402	1618531560000
20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	20274	3NLk5iQgRbPzUhM1VkcbKJE4BqRMhmUzXWu65pnx3Gfm3z8Q19Zr	576	1355	364	12463	12613	jxdU4aTwbqt5ZAGBmdPeAbK2boZqsYbL8qf415a6QXDkhhRyans	10211	14406	14406	1618532280000
20280	3NKiH3LFr5LqpMMEBApVBuYt7zeYNYc5fyjzHn1LVePWYfxrfYww	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1406	1393	364	12463	12618	jwHSY7Ps7JpKVbvxzChAnh6tnXW8rigtbN2q28CFZhXn7eMM9C1	10213	14409	14409	1618532820000
20284	3NLgXfAuVPWk1pzr71Td3esoqRexqwh8DjJtgUJvk1dMM8xsj2in	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1405	873	364	12463	12622	jxTXxh9uT1LnRa9RAmwaWagRiG4uV5RHuSstXyYL1RbrVELiiGi	10215	14412	14412	1618533360000
20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1426	1118	365	12463	12625	jxQpje8yL5UAHUPdekhcDnJBSX6n7tZe9rLRUcGz4FFX8wWecfW	10216	14414	14414	1618533720000
20293	3NKwMKhWdTwT2A9Ha27M5e2khRCgKBqC2udkiXTr35AxXqwbSf4R	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1631	793	365	12463	12628	jxGXVFpZynjMiqtxmPanCNGKizHNi8c6MHFAavRNuBT4VN4tcnv	10216	14414	14414	1618533720000
20299	3NKhMbX3EzXfAuxxqhFznn9SWMZWL74oxRBRwKFKywFoRDHjTPSt	20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	1483	301	365	12463	12634	jxqwyu26Rwg8WxaQ26V2z1VnDSBX9JFqzAGWq8o5RLV2e2WTarE	10220	14421	14421	1618534980000
20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	20300	3NKd5Hhpm6mUUXCJxqrNc7fYQTbfoDHHTsAghEoWHPHDcUXiNK5J	1407	1395	365	12463	12636	jxPbgKdjQTXZxsGLRaG7Q14QRCcTRyHiqRz6qWZQBpnmsGGcprm	10222	14424	14424	1618535520000
20309	3NKPmjcEEnD1yuY7EdJ14CmFWydczPnp9GUNjZPQrzvpvnVsB6SQ	20308	3NKRcWAEM4H5uQrKWwtayuBVGFbP6QnhD36LkW7yPnq2AFz1dLi3	1596	1117	365	12463	12644	jxwx1T4MNBTwuG5jdZuzopHU2xKLcmyPRhBkbvNzHvBr5PtL4P3	10228	14431	14431	1618536780000
20312	3NLK8MtUR2miQD5ULa2tatr4G37dAphse5Nh1mGrfPMxhkbps9Xf	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1585	1120	365	12463	12647	jxznEECEwPqd7Bg5tXJMWFbpPf2DsK85NwUz9mSNdxbcJcifVY9	10230	14434	14434	1618537320000
20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	470	1309	365	12463	12649	jxuViAGKSY2ua6XyU6xnbncXEwZXebzwNsfCTiAx3omfcVCTkuc	10231	14435	14435	1618537500000
20317	3NLmAaBCHHgTTTZRySaaUTQeT5wRmPCLbioZGQh4iwMuFw7CiXi2	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1477	1350	365	12463	12651	jwzCJctp2Qr3Xa56a4BRp4Uebpa5J7339vAdrU7EoNR3xRaSj12	10232	14436	14436	1618537680000
20319	3NLEKt6pEMitPcWKkKENhHpegtS8K4fmXxA3hLtFq77Gzobs515v	20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	1477	1350	365	12463	12652	jwda8vG25cWukHNo8y6hm6DsukWfRBRMwBEMiybLryNR9rkrGCp	10233	14439	14439	1618538220000
20322	3NLvTo3qA5S2TQCPcpYADMMGNJq2vaMJFWg9TWcwpsNWdpybBCVN	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1407	1395	366	12463	12655	jxoSAvtqXf8F5YH47Ycq3srsY7QXfEJgWxp3Q7uZ5SVB1u3nv3Q	10236	14443	14443	1618538940000
20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1403	800	366	12463	12659	jxxCGFpayE4XPveMrqZphEKSze8C4G83LNLjNkvpJyp6uEWLCDE	10236	14443	14443	1618538940000
20333	3NKZXBwVXNEg3AeK8mz1RYJUdNnt226vNc2W9GSC1cGjkikh9ahx	20332	3NLx934rP9SVejtaUH8R8Y3ynrb455yHyE2DUfymTDA4dAJrPmJv	1440	1377	366	12463	12666	jxRYAqDCWrUP93jdeKT7wMDozVg7m6YpxZWTABJBqiK4u4VSBoE	10240	14448	14448	1618539840000
20236	3NKtbdN92Qd2WfuUw6UTv3wqzSH8sUeEspXYqnjQudb1buwigACK	20212	3NKb3rkwPYvxXkRM9baXeJGM46W14dpr4SHdPNeE52L1cyUHbzYF	1439	1033	362	12463	12577	jxjowtTtY4gh1W2SRosn33dkDHwSdxNMZmbfXTJoFZEe6gsyXMp	10165	14369	14369	1618525620000
20239	3NKqdCvWMptLLLKuFsKRHXVzaUtZhZawsLB3YqsLWArXtZneyhGt	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1553	776	363	12463	12580	jy2w83UPtpS6Srkr3KCtYJ3ouKk7h9g8EGYD7Vt3hxWMunjtGcw	10191	14372	14372	1618526160000
20244	3NLGYAQeD5xVGuokVTrNV8E7c3v9bSnKAnVpn331gwKt5FtV9cCV	20243	3NKHFsmkRP2Lbpfi5q4v4xwkNRRteUryKDqLmgxAbYA6tZhT72St	1529	1316	363	12463	12585	jwz83UCGKqaXfpr2XPPWkTcQ4MjGiNWux27cbrz4ypiS2fRBiBS	10194	14376	14376	1618526880000
20251	3NLGKx7hHByRch6DNVvdc3Xn5e8n5sX7NjpaZBCRtCyBa1LAtGZR	20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	1642	1367	364	12463	12592	jx41kBFwPcRkT72GYZ5CqXpTh8wsj2gRvztNih6zicmRwYGxcDo	10200	14387	14387	1618528860000
20256	3NL8qvB6VjmFbdgmikWeZDkei9am82j4uEjNDkF2ZCaU1AEbUZCK	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1634	1205	364	12463	12596	jxacfe1GzPA3LtLq4PRJjbnV3DQB9AFReJVz22SMLnnP9GHsvZh	10202	14392	14392	1618529760000
20263	3NKfHcsYwc4n1zw7vN8YpT37bvuctbB8D6az2MkzTajJGZKjG4cL	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1547	1132	364	12463	12600	jxzQPvmPWBQ7JomYz1Dbyo1LjqJXxfosf2G49yMqZchXaXh71wM	10205	14396	14396	1618530480000
20264	3NLNn17wuxhSMvCgNc4Ybz2AoRnvymxtNMze49vx38kNMybNSc3f	20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	684	1106	364	12463	12603	jx1LCJbZsCVgro4hM9T7cP87KNmkkLA52LaTRwRdURxV3G3duVk	10206	14398	14398	1618530840000
20267	3NKgshkVT92Rqgg56j12M4oD6dSqSGTxpR9GhQDa4C9R9ivByYbT	20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	1407	1395	364	12463	12606	jwALrBrWUSRjuTnqvC4npgiW8BumUiwyz4xBaKrASD1BnUZDaM3	10207	14399	14399	1618531020000
20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	1559	1353	364	12463	12608	jwDxrtfahNa2hskS9vrmLshVdFJi7jSw8kt2U6kHsFRs35NFXD8	10208	14400	14400	1618531200000
20272	3NKnuTn3WpSQT5eF9t3yciZWqoVYfE17SZ1daq62RaeL2u6GVD7X	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1534	1071	364	12463	12610	jwxs8uZUVuWwRVVzVJB3k5ZmE8qVpKrF5B63wFvRubgT28CZVqj	10209	14402	14402	1618531560000
20274	3NLk5iQgRbPzUhM1VkcbKJE4BqRMhmUzXWu65pnx3Gfm3z8Q19Zr	20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	1471	1386	364	12463	12612	jwifBbRXfq7FmCQyYQU4t4E7zy8yLfwCGfSNTJFNSKDujak23Hr	10210	14404	14404	1618531920000
20277	3NL8vXHXnxbPdBaXBKFYjdTef2yvoMGnC3yFDMHYNoLDVxAWWxaR	20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	1407	1395	364	12463	12615	jxGKj8LxP9HTmD99iZtT1RXkU3SiFEQW6dz89ZcMBRvZuRyE977	10212	14408	14408	1618532640000
20278	3NLSHv2xNnaKgrRmd6yuT9TE3M81qVN1w2NGs8wytHjdBNTSF4MK	19765	3NKHBXudXT8fXihJBZvuiN1rn5j2U5uH3tdh4xCZwSc9dpn3hfUc	42	1361	349	12463	12616	jwJhEToo9bQV3hxUP1Eg8q7zWjrtk4VCD9xFMfpzgfvx3mhRLgt	9953	14408	14408	1618532640000
20283	3NKsSd92FaWXwsGcUjoccg53Tfouh6K7sWGtm41BCUgeR6CJ9kmA	20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	1580	423	364	12463	12621	jx623ZZ2oqoZ6aKvgbNK4XfzakThmajnxhq88Bxe1tvWT7j5cVg	10214	14410	14410	1618533000000
20286	3NKzpUFD95hyLSVnCfssRQNkvaPVYDn2D5HPtDPRrqRWnuJGLk2c	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1581	778	364	12463	12624	jwnEEakojHFEGWwgJPZ4WeY98v6iBdJr3uDakBNyesM3Vk26ycJ	10215	14412	14412	1618533360000
20288	3NL8mWhisquJu9gQrJ21m1n2dkcxKj6x932AMa9a1iHm9k8UJx7A	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	365	12463	12626	jwizLhQ3ezUWzGsS56kaWAZwtYsu1T7tSRCV5jva9kzYAgAe5KC	10216	14414	14414	1618533720000
20291	3NL7Fx2ZsfCdvsdcy5Fn7xqVScroU2MduRphzXW8P5C7zD74sXJA	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	364	12463	12626	jx8517oqRR8TCYFpNZb8HULxfY6tax35B8adpJXMXWoQH1jHm5P	10216	14414	14414	1618533720000
20294	3NLVVthGPUb5if8RS6yt1dyMQLxbUorEWCHz7RsUQymFouSzHqtC	20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	1529	1070	365	12463	12629	jwtyVtA1UL1AQkUjCrVZYw1q7tHZ2FAjF8xyu6Rwrruznzjd4oJ	10217	14415	14415	1618533900000
20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	20296	3NKKrBYRqgr1syKuh8gPd6chQTXhy7SM18974AhE7UKDGeFJe5Cu	1407	1395	365	12463	12632	jwfYjtnCSoXU3mDFrtZMgE7cjJTSFk8B1jaV2TqiwSoWfmMgwmb	10219	14420	14420	1618534800000
20300	3NKd5Hhpm6mUUXCJxqrNc7fYQTbfoDHHTsAghEoWHPHDcUXiNK5J	20299	3NKhMbX3EzXfAuxxqhFznn9SWMZWL74oxRBRwKFKywFoRDHjTPSt	1581	778	365	12463	12635	jwxWFPcFqK3UwwZY1zoUGXp9zDXem2tbDLBwAQmMz5J4FVUzsmW	10221	14423	14423	1618535340000
20303	3NLrji6ifUL6atXt6uZoL8zq5qNGtjBmJbKfRCG3sHoWRZdNakey	20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	1581	778	365	12463	12638	jwRX7mTSkp5xa9QDk7NToBPKrMFiKc6QA9Q8532jwoeWXmhVDoV	10223	14425	14425	1618535700000
20305	3NK6xgQJ75gsteHGsWJpfPHXGedbwYGuWr1hpNJFaYCkxhprUZ9D	20304	3NLKnKyXowA7kBCh4H6MxQm1iv673fbLaeoDKBM6DAefqPxJqixN	1573	1192	365	12463	12640	jwQu982VMKRF61X5cCHswGePHBS3bSUUotjbjm9NPi7zaDFxv84	10225	14427	14427	1618536060000
20308	3NKRcWAEM4H5uQrKWwtayuBVGFbP6QnhD36LkW7yPnq2AFz1dLi3	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1581	778	365	12463	12643	jxxXnEW9GLoywM1pJsikJbZt2gqEuf1rdD675gGbF5rQDo39jG9	10227	14430	14430	1618536600000
20315	3NKGaSiiVMxzeQDVWcBVSpusWU7NSyhNumgtnfFNhPSJy6dppKts	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1406	1393	365	12463	12650	jy1erjnatBk8mnq4HY3xGvNRyVVQmwTZpn3mDxjnq2Uv46q27zL	10232	14436	14436	1618537680000
20318	3NLD9sjMSLxVtFMCYxAkUiYwdn9h3YWxxNtD548gN3p8WpkUnsJS	20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	1477	1350	365	12463	12652	jxtb3ZPw9K7mqaAc4YnLDeiFULRkXLznLdRbJAS3hn3CX2GEpPf	10233	14439	14439	1618538220000
20320	3NKzG6WYg5XepamDQy2YrC9TX7sX5XBZH93C16xNjMzrURFvCQAn	20318	3NLD9sjMSLxVtFMCYxAkUiYwdn9h3YWxxNtD548gN3p8WpkUnsJS	1610	1068	365	12463	12653	jxVvaSUPaXumKinxsaZD8sKs38Q1GvqkpXuJHByBZn367oEH6ja	10234	14440	14440	1618538400000
20324	3NLrfgGHo7mKanYuqhapVpARZ9biAW1AeoPTvpxf3QJrtqgYjL4q	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	149	1283	366	12463	12657	jwYSiGQBZZNtikx5jNvXwnKqU9NCq1XNQRSnvRa8B3HaDG8rGfi	10236	14443	14443	1618538940000
20328	3NLreJxyoNK5yCooUkH6cev4tvF6EX7tqXpeEUj8DxB5de8aE452	20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	1458	1323	366	12463	12661	jwrmD8cxyV6ABPsz4ePU5d5KU2xBM5q8v49wQMzJeT4pmgxgAL8	10237	14445	14445	1618539300000
20332	3NLx934rP9SVejtaUH8R8Y3ynrb455yHyE2DUfymTDA4dAJrPmJv	20331	3NLSrCuDvAnRZLKUMUgCR24KA2gTzijuBSThjxGLFZHgzDo7drKu	1547	1012	366	12463	12665	jw6fs4j6fdYts3xDyZ1xMK6x8jamT8gwkvhGmkEdpGy2DcvY7eR	10239	14447	14447	1618539660000
20335	3NLof2FqxCzu4UwPPFPn3QZ6GTsxXKX5Tfhjy2kqvoz9JCyJmp2z	20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	1407	1395	366	12463	12668	jwV77EGKnwqTpx8eAVayLivpKygovz6HCfT5WG5mwsnUQibdA43	10242	14452	14452	1618540560000
20342	3NK8QgunPnQajUfefe3HmmDhktUwfWT2u8iCp7jeVR9tGjbF2tQj	20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	1402	868	366	12463	12675	jwkWGs7mKUvM36Y23UXzGQM46QNe7kVrkUYWNpKoLcG3UGm3wfa	10245	14456	14456	1618541280000
20345	3NKZBU6FR55EZcCqHWZRF3PMvvhft7Vnj3sFABvDCWXfhbC1666o	20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	1516	1294	366	12463	12678	jxL8toQ2edUS82wz1L3nhFdgsQgTWP7fVXxfr8GiyGQY7rseVwi	10247	14459	14459	1618541820000
20237	3NLL29mpY872dcvG7thsoou7qCq9x8djcBpEaKneS6uvANahK2wJ	20234	3NLLF7zovNx8Zk8oGXkPcRd8Tyxg18M85aoKN317VxCWF7d6mLtf	1613	1103	363	12463	12578	jxeMoL4jhPjuC3XGPDrNdkFnfiX3Av56P7BkfUGprZCu31mFQzh	10189	14370	14370	1618525800000
20240	3NKgfYMnkRo85ygG94xpBbP1aB83nUaBeKazGhWq7Y5RBNNoG49f	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1406	1393	363	12463	12581	jx5AwS673Kocn2qNMPxKvGw6q3d2D2icSNZTKPejFQBaUi2jz4a	10191	14372	14372	1618526160000
20242	3NK4gM2239yJBZgZveBdoyCzhKL5zdRgGDCoqvm6MVicC1597Gx3	20239	3NKqdCvWMptLLLKuFsKRHXVzaUtZhZawsLB3YqsLWArXtZneyhGt	1407	1395	363	12463	12583	jxepSqPrr2TKHhcc6FWx1UZTxSNTHMoPLbWpSzqTgzXShxPoXmm	10192	14373	14373	1618526340000
20245	3NKys76karPnNSGTmnVD83CbECS7NFTsggzCWyqbH2wUP42qmNYB	20244	3NLGYAQeD5xVGuokVTrNV8E7c3v9bSnKAnVpn331gwKt5FtV9cCV	210	210	363	12463	12586	jxUtyhLkrMXnSQ46Z4hyYAw8zpziciu6BgNDxJVXKX7Cw3rkquN	10195	14378	14378	1618527240000
20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	1553	776	364	12463	12593	jwTsm2uDeQYcWDWrWjC9TM2A4ULMTAg4P1GorPE5f65sV2AJVBY	10200	14387	14387	1618528860000
20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1547	1132	364	12463	12600	jws1ghcKf4FpFHZXFXKvqaa9AyHej5nZLjzCcXVFSWEpMwtiJPZ	10205	14396	14396	1618530480000
20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	369	1312	364	12463	12604	jxykCDYfvCtyRtk9Di7guP7tQaZKSzFnvbHzEkrE6uLoR2SWrMC	10206	14398	14398	1618530840000
20279	3NLAF9cMnV2CYj9e3Pgb8CJrtcM6HPtqNkXzRf5Pk8qXcCofr8e1	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1405	1	364	12463	12617	jxCPtWP1dZF4TWn6tcAazfkcjfcHcDYuyDL3yKEZ7sgaNtn9kmZ	10213	14409	14409	1618532820000
20289	3NKA1GMqxCzEqgxeDuiin4hSpHnrk8JbNiLg7v5me34YZZxxXNrD	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	365	12463	12626	jxyLmyLVFdRz8UgQXvzasWzUAWLUun25eyCQkGBchSfrRUWFFCZ	10216	14414	14414	1618533720000
20292	3NLcSrucU9xwsB1GiNW6bzqAEuYPgg8giucxfXfTZgaY2qKWwcBn	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1601	1142	365	12463	12627	jxWyDRfm7HvfjArJwf2Dk7uqp9ANJS4hxHRvpK2Lys1CGX3MVHZ	10216	14414	14414	1618533720000
20295	3NKEgzahxvFEFw77FM5vYJ24Z9KQQPJ14opi6wRUBiLZyu8AUDQF	20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	1406	1393	365	12463	12630	jxd3fnkCKeZUuqiLAmN5GbNwHmJexhKe4xTvx17PthidzoSfaau	10217	14415	14415	1618533900000
20298	3NKP4xoMyGq1iY6arSu1VTvnmUpsNSwZJ9Z7y2BGtnn9iQX3BM2U	20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	1406	1393	365	12463	12633	jwDkN3Vy4ftSQW1ExEBumH84RauQ58DCw3x2DihXJyj31k7MeWp	10220	14421	14421	1618534980000
20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	20305	3NK6xgQJ75gsteHGsWJpfPHXGedbwYGuWr1hpNJFaYCkxhprUZ9D	1403	782	365	12463	12641	jwwxGRJkHbi5eKdxHPEzMPRnDAz1TMVtqZt9d7wjvRu5cLMk7T2	10226	14429	14429	1618536420000
20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1406	1393	365	12463	12646	jwT9ECCPGuNgYHpnMXgcjSXuYkRdqezUxMi5Vnvr6kw6mUMkMbe	10230	14434	14434	1618537320000
20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1477	1350	365	12463	12651	jwVzwW9QB2rkNsGba7W11Hw5zTPCyFqVhXWqNY6YX5EFCMyTkqw	10232	14436	14436	1618537680000
20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	20320	3NKzG6WYg5XepamDQy2YrC9TX7sX5XBZH93C16xNjMzrURFvCQAn	1634	1331	366	12463	12654	jxYxPSs2VYJ4Ms7aYhV4cPjQ8Eqj9MpgpjpHLpqZdKeLnpExh23	10235	14442	14442	1618538760000
20325	3NL9NVNsGc4K4bF5tu1Qe37rkGLfZ9kViL94KaK1n7NiuWHesqPs	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1553	776	366	12463	12658	jwWAqzu9BYvYqY4H3ytW4KG3BftNPDjakM9S8P9Js17nsd2hk8K	10236	14443	14443	1618538940000
20330	3NKYcMHK9tcufqn2FNn9ocxb7FSpF9NYmpzovNu6pHWf5Dupe2ut	20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	1407	1395	366	12463	12663	jwGiX6bnc3w3uMpuxJCcdxqtDn2BtQaaQds6M4EjWMAJdRoXkCD	10238	14446	14446	1618539480000
20336	3NLw9dcrpajRL5PbnGRXGRHipNV8qtneTBysHiKbGQ9YVJs48nvW	20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	1542	1304	366	12463	12669	jwZSL5FVFiWEXKN7wWGyTD1bpTcexzP2W3LPXCh7DkH6t1SA5od	10242	14452	14452	1618540560000
20338	3NLwSsLQqu4VvU7aKhDeuJAKr87T5bQMSCzRTm4T4nEwFfdyr5fc	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	311	1061	366	12463	12671	jx7o6uW9DojybQP7weDmMXwn9MFQJX6KgxW8FX7THAzTob8zCPG	10244	14454	14454	1618540920000
20341	3NKppokMjsxFtNJmSBWWCFzAdWgguivkEWpvEx6emMYLvae1qhz2	20324	3NLrfgGHo7mKanYuqhapVpARZ9biAW1AeoPTvpxf3QJrtqgYjL4q	149	1283	366	12463	12674	jwnzgXndk9SUMmEi2gPaqMMwdp6txLMgBwJ4CUDGKjAkavFG1zd	10237	14454	14454	1618540920000
20343	3NKc29aXpigPUKcyszjCYnwqmA7qRUwntfq3SM2jkGdgLpaxJC3K	20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	1637	816	366	12463	12676	jxHCabbWjTyVxtzTKEJCr7EiZ5WhnYuBnicmp7Joxc4G4yhzBpm	10245	14456	14456	1618541280000
20346	3NLjkTo1m9iow4KBt4FjzCxkbQVWKP3w27Qk74UWR5qksMNQrqaM	20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	1407	1395	366	12463	12679	jx4szPvhjYRFGxzJ3uAhgn6inhw7YMtDREV2NgZu9SsE97VhnRo	10247	14459	14459	1618541820000
20355	3NKjH3XYSs4vznaeCDpXVUcExFrTdbJteNEMS4ohV42Le3KmZJ8N	20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	1407	1395	366	12463	12688	jwnymQAo1p7LPaLmqFpVEqpyLRBFPKjj6HvPDcmdaSet5LJNsdM	10252	14466	14466	1618543080000
20358	3NLPFfXHbBREntMatcdjywCWpAAbhj2njYtEaNpWyamo86Bye9Ho	20357	3NLQv97tBSmjQhwwAFq27dJK5VXsSHpZaQMG1gfDsg7ChwPNPpSA	55	517	367	12463	12691	jxSnRGyP1c5Vvnxpy3AeyWHWPhWNWMpGufB8kvFVZhPkqxHBiYg	10254	14469	14469	1618543620000
20360	3NKuFAwYrC98pDaN6y6dqrtWncRS8xLpdifWszLqHk2gnkMhJxV6	20358	3NLPFfXHbBREntMatcdjywCWpAAbhj2njYtEaNpWyamo86Bye9Ho	1419	814	367	12463	12693	jwssPZP61MPH3KzhJ8jmRCti5tSjm2v5ZfCGbURyHXBzWQEFpV4	10255	14470	14470	1618543800000
20363	3NLMLYLBFGMzACbAi82M94MZqsZHCE3HkPHBmTePSsdyy3UgpcoC	20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	1481	790	367	12463	12696	jxEZdUWry8spGY84QA5UAV2MdVpgxdCmgZZGQtR3cfj2yqYdhyr	10257	14472	14472	1618544160000
20365	3NLJ2ZUc5idnKuSSJx4Yub9kAwEr55ajSQQvBN3MKzqMMcBWLeg3	20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	1407	1395	367	12463	12698	jxwaFHgHHvaPzWo6mSx3EMkhJagrYHn7KW3YKto5x7rBXxcwq8p	10259	14474	14474	1618544520000
20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	20367	3NLos38uPPaDu4VqpAqypHR8HZ9F3qU4AWvwsRBiLboxsrEcPGxC	1405	873	367	12463	12701	jx6zmjrEAGHkwafRbSR2MAqjCLF1GagphsgXYWAynYVLcTux43t	10261	14477	14477	1618545060000
20371	3NLuZkSfomdhk1aASgmd98jxqs6vGVVUhyXWiMCwP6CYczt5HUkn	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	576	1355	367	12463	12704	jx2LEFDT5kBE2S6Db9xQnB9gi1Dqc9CzgBPaJ3zpjPnJEmUXE5d	10262	14478	14478	1618545240000
20387	3NKibvANNkj8BppR97ADieJi2mpzoZKgsqGU25gLyazSxSMCuWnz	20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	1500	1171	367	12463	12719	jxYzf5gMTeQ9jMYW54Wv6MbBWwrC5YasKRPUfKKeumGAdgSpDtV	10271	14488	14488	1618547040000
20396	3NK7qz9aWc8yUHd19EMb1AZo6eWNRuR2PyLN7C5wN7mKTHfmTRTr	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jy2bStT2TSQJMcEUauq89rxJppGji6qs6Vdo6sTgWCTt6RKNTAw	10276	14496	14496	1618548480000
20329	3NLKXrG3qhaLJgkXmdjWByViFVHy5YErwEvHfRNB1kEC3gNWesUn	20227	3NLVpZ9btxB6Z9Aa2rCUCJWp2bU8Pzw8RL28dNXJXfgGxfoq21qH	1643	1053	363	12463	12662	jwiTgQuCp5nA8HxbUkaS3iZ9WdBQR7XtFEGg23Z8iLbf6mM9Rck	10185	14445	14445	1618539300000
20331	3NLSrCuDvAnRZLKUMUgCR24KA2gTzijuBSThjxGLFZHgzDo7drKu	20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	1637	816	366	12463	12664	jx9i1k5CQjD9bpLuLSVkTVHpHZCJN7fL63cqXTfzU2fU2XJbC5H	10238	14446	14446	1618539480000
20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	20333	3NKZXBwVXNEg3AeK8mz1RYJUdNnt226vNc2W9GSC1cGjkikh9ahx	1624	1334	366	12463	12667	jxXzpze5jzViQXVvWLuFv8qed7xjvCrWRzTKUmkDcmg2DHWyC6n	10241	14450	14450	1618540200000
20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	20335	3NLof2FqxCzu4UwPPFPn3QZ6GTsxXKX5Tfhjy2kqvoz9JCyJmp2z	1670	1282	366	12463	12670	jwJ8VeDDPte6kRdS5d2ppRBwZpNNT2r1xybb31AzUpvZnLJhRgi	10243	14453	14453	1618540740000
20340	3NKKv3ehABjnGSCwDveQYbDmPGavrXZmSWHGYycP1Cxk8MD9rhit	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	1403	824	366	12463	12673	jwJCf6iGxUMDVpD3TCbLW7wn6Q6G9dmgd99kQ7LLjy7JSmuiaFd	10244	14454	14454	1618540920000
20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	20343	3NKc29aXpigPUKcyszjCYnwqmA7qRUwntfq3SM2jkGdgLpaxJC3K	1406	1393	366	12463	12677	jw6hh18yJ2hnM8iUMiGNvyjLmUn29MuNo2N57LDpATkLAspERVZ	10246	14458	14458	1618541640000
20347	3NLa4qdgVwyHiN3shD1w8Ro2zpSthfG7pRZh9RLinh2TqtT3i4ML	20346	3NLjkTo1m9iow4KBt4FjzCxkbQVWKP3w27Qk74UWR5qksMNQrqaM	1457	1391	366	12463	12680	jwzrHXrtmdw8jCAsEUXpnveBvsPe1KV639ZMp6Kq1XtmrKq3tQL	10248	14462	14462	1618542360000
20350	3NLMNAPXn9ZjnAyjVAq3eRKhe2dWyyvLDjQRzNVaecYzkYg7hZkx	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1406	1393	366	12463	12683	jxmxbgwgHXLE6v8vAMkdc72R88HmkGBQme8Wogw6PFUJZhAwohE	10250	14464	14464	1618542720000
20353	3NLknGQDKorKhb4aNSK1pDhMibgv6wWJwGgBmhsCA2bAyKioCnit	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1631	793	366	12463	12686	jww1HxQKj7er8i6UgHw8jAPV72UUsSqL94whVm1VGhcrgDkU8NN	10250	14464	14464	1618542720000
20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	20350	3NLMNAPXn9ZjnAyjVAq3eRKhe2dWyyvLDjQRzNVaecYzkYg7hZkx	1547	1132	366	12463	12687	jwywY9nrdHmheDB7csoJcaZdwkCY7GE2ictvdQLAbQjcB7oKquR	10251	14465	14465	1618542900000
20359	3NL2BUvdRNjHpWXbPhnPfrHmCsa5TtWvnZoR4F7ewZzhRjdWQiVS	20338	3NLwSsLQqu4VvU7aKhDeuJAKr87T5bQMSCzRTm4T4nEwFfdyr5fc	1419	814	366	12463	12692	jxWiRXzyDv4XyRrXhLJoW6yvGiQxReetyNzmEdS6sEitfYRTyQg	10245	14470	14470	1618543800000
20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	20362	3NLYeDw7NtdSRTkKReaFYHtgxaP2JxgZsAFkQVP9HLvMfMrvxUai	1637	816	367	12463	12697	jwH1KChMFrr5gQFaM5q2ywzr2Yx7RTmYfciQ8423jkJ9SaU6RwW	10258	14473	14473	1618544340000
20369	3NLtDtBxxEVDoPkCCERjpkBacZvUSioyeeJwkNXQMRiGrYkcDHnA	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	1516	1294	367	12463	12702	jxhV6npGXXLwmwj8JTmKgGwdo33FY3nHqNKPrp8UMGUjMKxFZub	10262	14478	14478	1618545240000
20374	3NKfEnHtYz3xKNLeZMYcq2ywrPnfAeyPMG2xR1KDgafkEeccwDq9	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1406	1393	367	12463	12707	jxZmLqqcZYqZEPCB32W6Z8NzNuF9WLHRhsGCyZsNHeTyKv7MFXL	10265	14481	14481	1618545780000
20376	3NLMDXxV5yuf4htHer99amZxfNyfKtxBfwgKG3AcSVzCzw2o6u8w	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1647	846	367	12463	12709	jxCZKfvUHGksAVx7M4giQD3u5BDwAKW3fU1wfbSstC2oiVeYexK	10265	14481	14481	1618545780000
20381	3NKgDivVDTxmLciLQjcCmr7pnJdJ1WT1agnjLYazwi7kvZHNqgZV	20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	1406	1393	367	12463	12713	jxNcCecwfsbhNFeaJ25jimZSFVcq7zYtR3JMSdMCASp9LFs5WkW	10268	14485	14485	1618546500000
20383	3NLJXgSFwndL2RNWkM14ywNPf8eBg8BVWxpUVYVKVPyWZwQ9EBxc	20382	3NKUUcebqwTystWuTRX7kHTU2TbdiTzKbNrYNqxsA9UN8ZYHqnCN	1553	776	367	12463	12715	jws2oyimqovDR7T4HwMxqMUYZvXEFV4rZE7vaXToXr9Es4NvQW5	10269	14486	14486	1618546680000
20388	3NLK8CmAPwqDQhRRqSt2P3LUxUfbkVnTjs4L7WpiLjjW3VidbwUS	20386	3NLVQKDTkvDQb6YQ3uD9S5EN7qXuB3yEyYghnPQbvf8s6iBDjVnr	1577	1201	367	12463	12720	jx9vXVzVge3Wtv9HPRvDFpobDvk9EkgxLAuqmFwC4hW9xtwbizs	10272	14490	14490	1618547400000
20392	3NLGZ2xFssHsFqdnyoxt34L4TCkSN6GSZBFpRNPGSxm19C2hBSH5	20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	1617	1288	368	12463	12724	jxuh3Dga84FZ9qm7rPR5ZZxMydpGqFPA9QbokjXQ2u5oRpeoRUY	10275	14495	14495	1618548300000
20394	3NL93etus22qGAacpApWze8dqag4fg7wGaHshkp2RWbtdg65EiFW	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	58	1281	368	12463	12726	jwBMJgSkQyGhfQEX952y6jCLcCtvXHV4x86cYQ7fKESnrtuh1iN	10276	14496	14496	1618548480000
20397	3NLQucX1BcgxnDiA1qLYG7YHjASKRseHet5pfCQt1M2cwQ9K4Qvz	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	58	1281	368	12463	12726	jxXFkDnj8vy84M76fsFi3opSK1mwvtnGWqwPDDv3TkxsZUUT3ci	10276	14496	14496	1618548480000
20405	3NLhzzcdNSthqi1dTmRz9PnL8J46AmJHLVprXtRi8mQN5p1qhskC	20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	1596	1363	368	12463	12734	jxDdzqNFhrhj3HL3Fom2X7svheLM3WdrXcknDqvqhxNvJFSsf7Q	10280	14503	14503	1618549740000
20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	20406	3NKs8bsAxKwmjKJkRN5wceaSbo4F3yFp9WHLaJrxeBN8aHoWkV6V	1483	1030	368	12463	12736	jxa4vAhzXR5hCVxw6za4hgJkpq9ao7bfCF4gFQaRnSNEGxZ22gr	10282	14506	14506	1618550280000
20411	3NKWGwABG97aQnWEpPZk5VKNimKLPPMoCHeC26DW4aw4hzVG8T8u	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1553	776	368	12463	12739	jwrkseU1g38yB9dLCB6KpNQVi2ZUEXaVd6VwmAgvuBem6AN9yyp	10283	14507	14507	1618550460000
20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	1405	867	368	12463	12742	jwSA9w36Jqno3NiNH2haaWWeShAkBUPwC3XvgAucGvuy342q1f3	10285	14510	14510	1618551000000
20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1617	922	368	12463	12745	jxzgD9fRo78XixzfxEjRjDoLGxLRSFtuSLiLv2sZ96prfs6SSaZ	10286	14511	14511	1618551180000
20419	3NLDXkkrtpNbCcVQwDdCxM77igLXQ8i6K6ogP7qSVTVHYvgm1d9E	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1407	1395	368	12463	12747	jwGh9LvuhAYG3GT2eq9s7XdhDJQPEvBY48Yifav4dLeVi7oKdus	10287	14513	14513	1618551540000
20430	3NKK37DcZCbjxVcYhmqAfnpFDjX8JFH8yLBGVNmwFSZZa3ZaDR2d	20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	532	1303	369	12463	12756	jwFESdMXmU7knXrJZ3YwbsF8iEos8BPqz4yyuzvRZZvoBU43rKK	10291	14518	14518	1618552440000
20433	3NL9x4No92thVksodBTgEN146J8imzACEG9skXKxaSXK5qDbpaX7	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1483	603	369	12463	12759	jxNpdJokgb9CKPGHp9JKQn2CzWcvWzMbjQ8XoJc3Ei1UHXmPmpQ	10292	14519	14519	1618552620000
20439	3NLcfFNyUsEFqFv5sCfUBLFVaGJiryTQBtYYnG1dLEejSyJjoFnT	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	1406	1393	369	12463	12763	jxffvhZ5FJFYwfVqmM2MtNAfXhDeq31ehhmgAaRLSjbsVCozAr6	10294	14521	14521	1618552980000
20444	3NLwNSJozhN2Ndb7Mstbh45hSmHegYUqz5ZasQfR9iKt72tVgBVg	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1405	851	369	12463	12768	jwv7XKzkbW9gdTqYva5N1hsM5LbFLF5STN6YoTvwUSQFfZwfqmc	10296	14523	14523	1618553340000
20449	3NLAhuSPk8nV7fr3CAeCMeww3AwC68ohUVC4E5iqzG5vCKHssveH	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1477	1104	369	12463	12773	jxiMjwgY3BLdQNSVC6fPjWbVJw87tF2p1fhn8GkXHfCQi2BjSdf	10298	14525	14525	1618553700000
20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	149	1283	366	12463	12672	jwxwdSMjvPdkHrDY3zeajKLosy1gzvpiTZFAXQMNwdCa7sAd9aA	10244	14454	14454	1618540920000
20349	3NL9hm5fLrR1cAdSBpAh6mrYCrBZixarofwYRpCcHJ72AGjJymX4	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1407	1395	366	12463	12682	jx3fBZVzujpymzdK1dioAKgiQwT3oCzPTDzB4UBWYYzsncrXZWG	10250	14464	14464	1618542720000
20352	3NLuae38guemSbwQoqtQymtGasf83FVa7USvGsjZPLFpNhwxyB2g	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1637	816	366	12463	12685	jwtcj6aJds98tHcX9Hn7bL1Lvcy9qg1aPzCN9PsggjiULsPBZFe	10250	14464	14464	1618542720000
20356	3NK6MjrxeDerYgFoQ4hqZUssKkdni1tWjdzk5ZJ26VreZ6MKuu15	20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	1571	969	366	12463	12689	jxiukAoKynKFf74LhkjxmA9p8AYsrt5PHtB99HH6qV8fK2zmRUb	10252	14466	14466	1618543080000
20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	20360	3NKuFAwYrC98pDaN6y6dqrtWncRS8xLpdifWszLqHk2gnkMhJxV6	1648	1284	367	12463	12694	jwuTmrpeQLgWf5RsF6yABzX7bLoGFBYqc31dQigp4QDKSnhZPr4	10256	14471	14471	1618543980000
20366	3NKAjYJgJFWfzzNbAYLwozVfT4eRd8T57JMrUyHVk5iJoTm3e7fQ	20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	1444	1135	367	12463	12699	jxabdS4ki2SctRSH2Dwvg4bmbzxGqUxTX6MpsUFDVCHeasCpHK9	10259	14474	14474	1618544520000
20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	20372	3NKzyw9K66cARJFTr4xcCPAbRAtoUYrYkZXYcNKGnNA8FNQQUWKZ	1407	1395	367	12463	12706	jwaeKx3qwtc9XQ1bpAwSWMRJBzYDqj3MLnQceCCqMQHsfaJQWz1	10264	14480	14480	1618545600000
20378	3NKvxGzSnpAuikuBRqqAeaHWraPvZQzvWz2wwV5czKa811U85t4w	20359	3NL2BUvdRNjHpWXbPhnPfrHmCsa5TtWvnZoR4F7ewZzhRjdWQiVS	1419	814	367	12463	12710	jw8kScC3tFxg5TqqyR3XCyK2daPZrsy2RzGRFxvJkXnMyWWZSfm	10246	14483	14483	1618546140000
20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	20379	3NK5hFLFTMM5CRJb4bNRSynLe79ENipqWeMiTo1HgCQA1ALGwBp4	1529	1070	367	12463	12712	jwBeJVK5z4S4dD4J9csNpja1W4eMpghpNZxakGFgNiwQHuoeyhg	10267	14484	14484	1618546320000
20385	3NKnkwCfYHvcyTGRdKjwYVVfAyDDU3bQRWuoMX5zLJ2kpjqeN1zy	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1509	1194	365	12463	12717	jwowcptrnEb5iy4be3WrHDjFsVyPH5ceVX4bukBb8nQWWALTm8Q	10227	14488	14488	1618547040000
20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	20389	3NKRpDaPaahKGrQb9ZFgRjMeuw2K77pv5wB8agRUz98K3n7Y5nef	1654	1214	368	12463	12722	jwF7XiKoSHP8B67BfMJU4XZYDMFD21WK7YzAtcZkVHy49oohaJi	10274	14492	14492	1618547760000
20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	596	1306	368	12463	12723	jy1Yi7nDucHV2RCUidRvuooxg7kdowLTnf4egNnrSo8H4ppFPgA	10275	14495	14495	1618548300000
20393	3NLTiMHZEisMzgVUjevWQjXyy2EJWnnCYanQPPrSUKw6BAykKduQ	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jwrpn5km5rLKoTYyVoLDZx8kx7f7DJEpn4LmrTutasVCHxZkLAb	10276	14496	14496	1618548480000
20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	20396	3NK7qz9aWc8yUHd19EMb1AZo6eWNRuR2PyLN7C5wN7mKTHfmTRTr	1600	1126	368	12463	12727	jwmJLrP2dNxRDSHMHSBwrUHUL4RUxFZWdyq34B54droVusxSims	10277	14497	14497	1618548660000
20401	3NKbqjiyvkHZw993qrFPukB6En9kgRyZPn6BjMxXRcCNNAFeEiiJ	20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	1617	1162	368	12463	12730	jwhBhtXqHL6Mthjtd3ynNMMi8jAJroBj9mAC8CpAmrm3QcNfkYu	10278	14498	14498	1618548840000
20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	20400	3NKpGSZroUfXf23KUgw5mhb6fr7KgAaswxcHgYTJ3JsUsAg4Su9r	1422	1337	368	12463	12732	jxq33ay6s55MAqYfNK3cDBPNBysRBFuWksqFerkhtihNf7q3PRg	10279	14499	14499	1618549020000
20404	3NKXa2mUaZHVsLrbnBa4RuhxsxWmt5aCW3A3Q3oJhCTeAtp3LUxp	20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	1578	1296	368	12463	12733	jwmreBBtaxKGT55MLhyhhWCjQst44yxLFYrtFQce6hSaDDsgQH5	10280	14503	14503	1618549740000
20406	3NKs8bsAxKwmjKJkRN5wceaSbo4F3yFp9WHLaJrxeBN8aHoWkV6V	20405	3NLhzzcdNSthqi1dTmRz9PnL8J46AmJHLVprXtRi8mQN5p1qhskC	1402	874	368	12463	12735	jx3gEXGdEeN8DvVCEyqpKL3x3qsvzo8jP3t6vuaRo4geCHArQeH	10281	14504	14504	1618549920000
20410	3NL7m1TzRcEPX7Q4nDe5hMPktFQjE2bBUJZoytrKCHA1esdJV2fp	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1671	1119	368	12463	12738	jwh7e1d6zgCQt4wSeFzNJE1TxizT7UgWY7yrAnZYBRUPfoCPuhZ	10283	14507	14507	1618550460000
20416	3NLuqWGSocJzi9N6oQj5UMojJ86wm7SdEJrEpLxtDJCfCWD48hwT	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1406	1393	368	12463	12744	jwuibR2NKwNuGggy8N8XPGU9E5DDBWUHKDbsZkt9mvg7w45ExfM	10286	14511	14511	1618551180000
20421	3NLWmoE4SLaGW2LoT92sKj7svtn7cNLxEcsMBg8b1tWvaVa67hg3	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1474	1329	368	12463	12748	jxcyagmLTX2u33yVAM7m4AYPyvSsBdfd4wmm6PsezHugqAzWgpX	10287	14513	14513	1618551540000
20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	20422	3NKQzLmmKMfbzkgRzP4yuHEYXwsD7mpKeqZUS3C9DCLQrzcGuZnj	1579	1389	368	12463	12750	jxuh6npDfKqYmciomMkrWZJUJ6fiTRAYZ8r5yHhCBCBpBp58MNX	10289	14515	14515	1618551900000
20426	3NL9YeSg5vN2tQvZWUq9r7GsVEe1DpGCgsrRLPMa5yXKZzVXkVy1	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1402	874	368	12463	12752	jw8gGaqrSXUMzmATmUJ1S48heQAgcJAzTi7njmoLPnSwskiEHcG	10290	14516	14516	1618552080000
20432	3NK8jko7XfeBfx7sgLcajfgzGSqPhxi7542r8i4SXfafd8Pp3GbG	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1649	1383	369	12463	12758	jwnaTe8BRwf9bdptJUE9dXjW4R269XwBrKTQsLZiHkqjcGmaTks	10292	14519	14519	1618552620000
20437	3NL3BocXutVAzp3NHqFamb2PMdruuZj9WuRa1kX5D4TBRCdMgw5G	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1540	321	369	12463	12760	jxy3hrF4XV5K2U7WoG5UwwS5DgBicpYV7bEKC8SNf8W13SkWMv1	10293	14520	14520	1618552800000
20443	3NLTsMKrHBwu3628YBKqLnpreKtEQAKxkjbaVYXcCMSfaagDGWcj	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1421	508	369	12463	12767	jwo7gyz7fuMshKk41GLLJP8yMMbKejAGuBJhAoAjps8QmVLnX1d	10296	14523	14523	1618553340000
20448	3NKnUzVtt7NcJi6rxmZn1s8xbpJ48AQhJCSpwfZsK59TBQTuMxbr	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1402	870	369	12463	12772	jxJDj52Qp4pABZPUFmaXcmcPmfSULDN35PZMmMauJpRJ5D8NPJP	10298	14525	14525	1618553700000
20452	3NKBx8iLwwHebahFqu8oDJJRHV9znsVqBbNSAnByFwJ9a4E4w2P1	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1529	1070	369	12463	12776	jwLGmRJJdpDwQa8VDX1qytzppMgb57hjxzAw3n91M5yiXSGa673	10300	14527	14527	1618554060000
20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	20453	3NLtP7tkcA1qiccXky1XkxLRLMDvs4Uedr8TQsfF7xgP8yALHjBM	633	1138	369	12463	12780	jwyLrPStbDo4snmxj3zrWA5PFXan2NRQW5tte7hG8TbaJMjkc8T	10301	14528	14528	1618554240000
20459	3NKwMoGucFxG7D45SX4rs2Uqw1Vhdv8EEGH57rpZcbC7xHegMpvp	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1613	1103	369	12463	12783	jxy7Rgwmpio1cNAdBZz6svfdzHNrJCDrsFwBzvLY2MAgnyeKD6m	10302	14529	14529	1618554420000
20465	3NKoTX4EhaX1kTwM7SDb3hXA7x1Euaq7HWrtbLJzRLJzhrztjBLH	20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	1634	1331	369	12463	12787	jxZgGzs6NBzQo4TiEjktDvxBMmdAf72drxTTHWLWU42YofWUjLZ	10305	14532	14532	1618554960000
20470	3NLmL9d4KWaQrDj16VQbwfJ7j8SEXFPkJf8S5ivrAEmduqdFzTYN	20468	3NKpYdh7ZVQfBN1recpWx4CaDphTutVJM7rqbRnq5FLe6shmWrvr	1501	1360	369	12463	12792	jwUjLKLRetmTTbSsXcKD3wamwF3kiYuBBzXmyEtmzXo54peU9Gi	10308	14535	14535	1618555500000
20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	20347	3NLa4qdgVwyHiN3shD1w8Ro2zpSthfG7pRZh9RLinh2TqtT3i4ML	80	1273	366	12463	12681	jwYHKweofDnabGPKZN3otVTgw5JSDd4oDyTiCvfPTEToeisEZ1r	10249	14463	14463	1618542540000
20351	3NKyrtzgBxfZrRNgQXPeh6xQmjkzxECd4MAEozR1WGpvAnjHJsni	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1403	785	366	12463	12684	jwSfYGYUL1mWzAw7mYqdhr1C6wYRRGK4n7sr3cBtpMaHkhm62FJ	10250	14464	14464	1618542720000
20357	3NLQv97tBSmjQhwwAFq27dJK5VXsSHpZaQMG1gfDsg7ChwPNPpSA	20355	3NKjH3XYSs4vznaeCDpXVUcExFrTdbJteNEMS4ohV42Le3KmZJ8N	1402	868	367	12463	12690	jwboDwLHesB4KZGWSsJZBtQ7Tk8XwT1Q2z7ErucbxzD3DFQaDHJ	10253	14467	14467	1618543260000
20362	3NLYeDw7NtdSRTkKReaFYHtgxaP2JxgZsAFkQVP9HLvMfMrvxUai	20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	1560	1291	367	12463	12695	jxz1pz8LKg2P1KvypH9Zps1TuAbf2hpZngBQaFPkQbABKvap64m	10257	14472	14472	1618544160000
20367	3NLos38uPPaDu4VqpAqypHR8HZ9F3qU4AWvwsRBiLboxsrEcPGxC	20365	3NLJ2ZUc5idnKuSSJx4Yub9kAwEr55ajSQQvBN3MKzqMMcBWLeg3	1460	958	367	12463	12700	jxMirFCU9G3TfPJeJiQZNqseqW9RJypKUF95XXhF8DqCESh1gV7	10260	14475	14475	1618544700000
20370	3NKUnk3AAHwGyHeW5WCEUcFVuScWAFZx55a72GSXGrfR4F2NBtqP	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	1406	1393	367	12463	12703	jxbyYt56YtvjMfVjEZGuQ52WNbDmvR3qeNsezp8YToUoj61noHS	10262	14478	14478	1618545240000
20372	3NKzyw9K66cARJFTr4xcCPAbRAtoUYrYkZXYcNKGnNA8FNQQUWKZ	20370	3NKUnk3AAHwGyHeW5WCEUcFVuScWAFZx55a72GSXGrfR4F2NBtqP	1403	811	367	12463	12705	jwzMdMcuH87V1opivYirxCRpxdHyFh1UpJPmUw4CXgUqnwsHyzz	10263	14479	14479	1618545420000
20375	3NKia33XGuGhGZaL23MU4ptfkWmY2eXKVqquj35iiWGGcVqbhrpy	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1474	1329	367	12463	12708	jws7HKT7FVGsXHRTn9Vipgp7yQSZxCE12XvJVov99jnD3trxQuu	10265	14481	14481	1618545780000
20377	3NLJ48A1YgG92fDXykZpp28t8WHz1AQRZnzLTNXAiGm5KE8xDVHG	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1474	1329	367	12463	12708	jx1CTeZgwZgqfT8QQfDXNfkf9bpjnFDwraBPFEgvo28GPXP2fsL	10265	14481	14481	1618545780000
20379	3NK5hFLFTMM5CRJb4bNRSynLe79ENipqWeMiTo1HgCQA1ALGwBp4	20376	3NLMDXxV5yuf4htHer99amZxfNyfKtxBfwgKG3AcSVzCzw2o6u8w	1419	814	367	12463	12711	jwZ9sFyABPc8GmVwUrQTpi4e9go3A1Q3wxC4AJY542CDYJY7mSj	10266	14483	14483	1618546140000
20382	3NKUUcebqwTystWuTRX7kHTU2TbdiTzKbNrYNqxsA9UN8ZYHqnCN	20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	1553	775	367	12463	12714	jwceoxpzggYMWM1WZ9juDudjHtr317JVDyTHMudqnsQHgF7G5gU	10268	14485	14485	1618546500000
20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	20383	3NLJXgSFwndL2RNWkM14ywNPf8eBg8BVWxpUVYVKVPyWZwQ9EBxc	1402	809	367	12463	12716	jw9j13Wnbn6Xxbn2v7bGdQVpdjEupP8Qo41BDozfbM1Fx59MhQz	10270	14487	14487	1618546860000
20386	3NLVQKDTkvDQb6YQ3uD9S5EN7qXuB3yEyYghnPQbvf8s6iBDjVnr	20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	1509	1194	367	12463	12718	jx9XHChCdtCKyV13bftu5LKrEHJLVzEutgQLNbPpdFQ8HC1P2cD	10271	14488	14488	1618547040000
20389	3NKRpDaPaahKGrQb9ZFgRjMeuw2K77pv5wB8agRUz98K3n7Y5nef	20388	3NLK8CmAPwqDQhRRqSt2P3LUxUfbkVnTjs4L7WpiLjjW3VidbwUS	44	1079	368	12463	12721	jww2naWSEYXnGhRbSJesdtPd8Fr6KhdNHvP66zKnmDu4wdbF1ev	10273	14491	14491	1618547580000
20395	3NK8efytF2GtiC3Axiom6aqCVwoz3fgCxxK3e93nAMh9W7m94yMG	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jwSX1zc8HtNwbEPY6jga3m3apiiTxBYi57yPENSL7kq26YaWPZS	10276	14496	14496	1618548480000
20399	3NKkNKJqeXVYxewmWSzW65ALzJgAEimU4R9DJCohPbZaiB6mCTYT	20329	3NLKXrG3qhaLJgkXmdjWByViFVHy5YErwEvHfRNB1kEC3gNWesUn	1643	1299	364	12463	12728	jxR3uMcyMautKQv8yE9Zk6gZLCBUUkKXVPy6KDQZZmWcJF2PNvE	10186	14497	14497	1618548660000
20402	3NL9ohbTzjUkvy5XXoAMdFNxBAEjELGJt8QfYLTeGHmURnCCBBiN	20374	3NKfEnHtYz3xKNLeZMYcq2ywrPnfAeyPMG2xR1KDgafkEeccwDq9	1422	1337	367	12463	12731	jxAnVUWFUUfyCzaJFbXTPBJ2rC8onv6R2iWyqWDT5Cqvt8xfjkC	10266	14499	14499	1618549020000
20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1609	1087	368	12463	12737	jxi5rr9M6o5rgJMx6QK9YGYAiBJemgXEaXNhg2goz2uDeWAdPL7	10283	14507	14507	1618550460000
20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	1650	1375	368	12463	12740	jwW384ae17unWdu5Uu5h2jKxWRfioHsez5Xz3jw7iHKSQ7EGwoK	10284	14508	14508	1618550640000
20415	3NKtENuT5U2yzDHn3fUNZsm3nVGToqp8TGvFZsxGTGUeyAcBT9Sq	20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	1476	1125	368	12463	12743	jwzhHLCrw6qud5zvtfrWLk3W1ZpdZ272gjkhEXpCuips4vyujiJ	10285	14510	14510	1618551000000
20418	3NKuSJ3Q56qPJutWSca9UhciK82PsxcE1VQ8gjKDBEyRZi9N8ih5	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1581	777	368	12463	12746	jwu3gPn2spnvJD7Ev8pHxBX7YK95L8nxibnebUurihPbAvMqEcv	10286	14511	14511	1618551180000
20424	3NL857UDGqJnd5AURfSQmN9TUx95d4RRVUNdLG1w9W6xpzEHpJjf	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1503	1277	368	12463	12751	jwWvLUsZN72FRqzz83ayz5DdUij6ESw5ioc9fMqjHaNgJxam4kK	10290	14516	14516	1618552080000
20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1624	1088	368	12463	12754	jwt7dpe8uR3YZL9LmAXuz3nMegu3eeVPjU3AKcB8vkfU8oPBpTB	10290	14516	14516	1618552080000
20435	3NLsN3u4SLBjZz3PMj9bHaZh3aavpEzHuXSYBzMcvoYZGw8p7Y4D	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1540	321	369	12463	12760	jxJnajVFMTAjzXBixKTPuEuqYmyxvFCQBMvQqj8Xvw9BJi9ceKp	10293	14520	14520	1618552800000
20440	3NLALYoyASkBqMdBHTCJevRVgq9RkThBFsBFYfJZRi9HV3U4LJeW	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	1578	1170	369	12463	12764	jxqcnQEGm7BGYm1ccyKgNCxGELgZKPZTmG9RRooURLLm7qUV1ne	10294	14521	14521	1618552980000
20445	3NL3J1bdWT4z9p2ZtJmKxyKP1EQtXMpDT9nQq7UDcvZRfjDdCnYB	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1534	164	369	12463	12769	jwLgfAZ4UqBdFoPQdMEQsnMpPd4ZUz915EmuDr3uSRVtp3NmWdu	10296	14523	14523	1618553340000
20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	20444	3NLwNSJozhN2Ndb7Mstbh45hSmHegYUqz5ZasQfR9iKt72tVgBVg	1406	1393	369	12463	12770	jw7mMyZ84GQyLKRCU5eVpd9eNrqMCBmQEhrMPFhauXVb5jkb7NH	10297	14524	14524	1618553520000
20450	3NL5jBHvguWWF1jv4hgnjGUwACzftJBZPx7F9YfnnQaPPqqTVwgx	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1560	135	369	12463	12774	jxP3tuJ1SCoMiTgFMivHANDYvj5JcbzkmySXxkFc474sWRnkt2k	10298	14525	14525	1618553700000
20454	3NLarnVYurPfsuGjGtPYyAL1txBYRENP4wYgX6k1sTYXvCg8TrXh	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1507	1280	369	12463	12778	jww4bUPpyfZbP41KbwZwvsPfuQb9kV35fYgmN3Eb4Wj2Cmw8C48	10300	14527	14527	1618554060000
20458	3NKHm2DY7wwjFWcj3agymsGquWsMVm3f8beDLaPMyFWjchfLqff2	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1403	824	369	12463	12782	jx55SuWyYh6KatANLt7kDx9Jpp2Bxn8ykwpBvNXUzy9LubLKDrD	10302	14529	14529	1618554420000
20462	3NLYbSAfUgti1uKr5qhK83A4CWL4HqUEdKyvvMLUiE9Yh1FS11oM	20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	1406	1393	369	12463	12785	jxqbcsHvgzvAe3RZd7ZgbTuwpBaEtQrNjQsS7vdoCaCPgASTLVx	10304	14531	14531	1618554780000
20464	3NLrrX5cSmxMkDWv56udRS1rarn7gnA9SfArfBAhwnbg5HAdaKBF	20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	1634	1331	369	12463	12787	jwLpA25AmGh3d2AT4PWsyhzjVDG7uBmKPhsc3MQspcQHRRWVRFn	10305	14532	14532	1618554960000
20400	3NKpGSZroUfXf23KUgw5mhb6fr7KgAaswxcHgYTJ3JsUsAg4Su9r	20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	1406	1393	368	12463	12729	jwYPbfbyrcSLWGyqTG64NiE6zaVT7yzULoUWp6cUDF9WwWEVrBF	10278	14498	14498	1618548840000
20409	3NLvxkbyZZnHzoP3LPCBXDD4836bdYa1CRKjYADECphhcgVqmyZA	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1609	1087	368	12463	12737	jwhYz1b6TFTRivCpFhkyGEdczyHdotonSSNfsEKZPbsMnCwmfhf	10283	14507	14507	1618550460000
20413	3NLFNLRe7nMVDbn11fH5PK5ifGaAfrJ9yrk3HMA2gdz1jMadBA6h	20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	1396	436	368	12463	12741	jwQARNUwYqgVjmtsoszmtDkK61b98pA6NTzzpVDz1ydEG95rf91	10284	14510	14510	1618551000000
20420	3NLNsNDcMrkQma2iqdwbC2xxo5EtyT4bVvAXS6KXjqHbqtSFcTeP	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1474	1329	368	12463	12748	jxcobKnTVL654fPd7y8frMazeJHrkYAzVvgAMFbgSSdhb5P2obm	10287	14513	14513	1618551540000
20422	3NKQzLmmKMfbzkgRzP4yuHEYXwsD7mpKeqZUS3C9DCLQrzcGuZnj	20420	3NLNsNDcMrkQma2iqdwbC2xxo5EtyT4bVvAXS6KXjqHbqtSFcTeP	1406	1393	368	12463	12749	jxzRk9vhDaxhAX5nkMFJvkqAYB4wwBqtwjsifipg9gHAzQ2jcAQ	10288	14514	14514	1618551720000
20425	3NL1p5RxAXKKX85ARBNgKrctrU3obebLN5fXxbeFBWpLmQLzgabH	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1503	1277	368	12463	12751	jwWvLUsZN72FRqzz83ayz5DdUij6ESw5ioc9fMqjHaNgJxam4kK	10290	14516	14516	1618552080000
20427	3NLcN3FbUjFAKv7sG8PVSMUHJ4pcjAKZ3bXBadHstrGAaJzajqmW	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1652	1189	368	12463	12753	jxbapmRsRF7UxhG6UCnnFEYMvwP7JX2EU8FKcF4AFc9VePVsNQv	10290	14516	14516	1618552080000
20429	3NLJT9mure82tJryRoMc9k4hn7fHScErDcZZhViWs7stwF4pdkGW	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	532	1303	368	12463	12755	jxG8FGsqnCo6n7foTS2okXn1AZyJu4ZNkwGn24MsXrQxWMcmpic	10286	14518	14518	1618552440000
20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	1500	931	369	12463	12757	jwymzoJkcD7rqZeE1EDuPT9cMM61T1oKERYPX5cgNCZYMrzUnbS	10291	14518	14518	1618552440000
20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1483	603	369	12463	12759	jxFL1fZKs3PArFXcH1FRabm1v8oWPPfF7RBzXeviUUZHDgeRP5Q	10292	14519	14519	1618552620000
20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1637	816	369	12463	12761	jwEidcLCe9tY5MhaKL8wq6PgxK9azqE7b2pBsqYDuf4MChshJxk	10293	14520	14520	1618552800000
20438	3NKS1gNwd2MNr5EgbasxzFwicMagkzqix4Dujfz1wpLcQ2YtrmfC	20433	3NL9x4No92thVksodBTgEN146J8imzACEG9skXKxaSXK5qDbpaX7	1631	794	369	12463	12762	jxqUcUvduxT6cPmakX2CoVGePkD91ygcbetJZ3j1VSKZkgBKSmw	10293	14520	14520	1618552800000
20441	3NLPrHRh6AtWB8HkdpM2GfyTN7Na8L4xgQ2mPXaxzdyxPPJa8EwP	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	632	1136	369	12463	12765	jx5FB7bnhSLc19oxGDDbupL3Jo4BZ2EpqAdZSFtzKY3uaBJAip9	10294	14521	14521	1618552980000
20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	20439	3NLcfFNyUsEFqFv5sCfUBLFVaGJiryTQBtYYnG1dLEejSyJjoFnT	1672	1285	369	12463	12766	jxFm4tFT36AD6BouK2BnyBAt61fgSNCZdYejzkDYgSWM1PxT6AE	10295	14522	14522	1618553160000
20447	3NLrp1XZ4Qw5rS9VyeyP7dgoJqgAkNzyUvBLojQ888ANV4AKyXDs	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1642	1367	369	12463	12771	jxj634iTG4LmTgfwaA33BJksHMWA2sRJPSFT8WaLJNHhfjVgMuv	10298	14525	14525	1618553700000
20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	20448	3NKnUzVtt7NcJi6rxmZn1s8xbpJ48AQhJCSpwfZsK59TBQTuMxbr	1407	1395	369	12463	12775	jwUX5CJTxWP3TdZKQ3stbfdqskMzGyHXd9WErPhYrUWNtmQfDNL	10299	14526	14526	1618553880000
20455	3NLfefJY6hWd2AWMhL4PcGD6Tsj423JuwKnEZK7rMXtNLyG9Wp7J	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	684	1352	369	12463	12779	jx2k2dajA6FYd45SJzo2upmrL7jH1oHpeNkyuhhxNYnJqA2FFU6	10300	14527	14527	1618554060000
20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	1536	1067	369	12463	12786	jweKDZzdEThQEaSd4U3vCcTCtpc4nKfqLhJGzLMvkoMECC4dWUE	10304	14531	14531	1618554780000
20472	3NLtQgCWbpKRcsxnpYJPHMVAA1yHUFFkjqHrh7DYwAPfYYj1TQJP	20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	1407	1395	369	12463	12794	jxAeQnMxLVwYRNeWsRNGaPACkEZPmKX7RnHJ6QqJiKb4Geddehy	10310	14537	14537	1618555860000
20474	3NLMYXAuZumm9oiK8UG4RSbmcnWnnRxAZKYGkgYd73sF6cNiH89e	20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	1500	1297	369	12463	12796	jxQbFtyZ9pMe4mQRoRUgi9n6EjWi2qeXX1BtXMuJQ7GTr58xNkG	10311	14538	14538	1618556040000
20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	633	1384	370	12463	12800	jx2C48rZ1wBEgYxevjhTRYMApejwN4gPrEA414mSKzznkwsBZTS	10313	14545	14545	1618557300000
20483	3NKdZA7Jzx4QsCW12KebAEjZ5cbuMSoFR4k8JYBebvHH4yR71eSm	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1668	1124	370	12463	12804	jwNUzEf5NwzUyog8pSNPM8N2KFxGjVtxDBTVqvb9jkD5NjGb7hE	10315	14547	14547	1618557660000
20486	3NL6PxNDcsxMkUnLzjaC2xkBnd66BLEnnmkkei9H3r4dLU78dBGa	20476	3NKBhS1b9AQDvrZbZe3f6ScQABrY66gsEPyZ3QbahctqNQH4Nuio	1451	1292	370	12463	12807	jwdCpVBGTCi1DqAfgHetCz2pHX6LhkRJW8RHyCxP6MhWEhUchwa	10313	14547	14547	1618557660000
20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1647	1302	370	12463	12809	jy1pCxadLDbgP6R53J2GKJt4sJuCVwHj6sDZ9nkVAuTPKpYbcd5	10316	14549	14549	1618558020000
20491	3NKdc5onUxBimQ7qxnk76se65uHu5PCn3KZ6nspDfjs7mWLJrXA7	20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	1637	816	370	12463	12811	jwZRd1znAugokDz3NRSos8fqZWAhuwFjyEHN93xHLkmV5JgyEro	10317	14550	14550	1618558200000
20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	20493	3NKQ3egNzjyxL8jnWSWBAH3oPZ8g4yZLNtNuJbHutSVfrKqBDfL2	1647	936	370	12463	12814	jwuMm3523sRXXnyj95cHUu9K7zytKJbhNkVydUU5Ay8xHaWcY8r	10320	14555	14555	1618559100000
20497	3NLqVNqmMMtxU2gJKkH8iQouUWfUiqQcLpxq8pyE1utrLLNzV536	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1500	1297	370	12463	12817	jy32ZQd79kL3sM6QKCFaiRmgURdfwjqYGdS23W2HEDVV5t4yU4E	10321	14556	14556	1618559280000
20498	3NLaRMwVJ1pSqnobTznD1DNxxoa4SNCooWPWSB2b9Kj2T1d6s9Ja	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1500	1297	370	12463	12817	jwX4d8E5UL4uT3jzzaQdDQcKRiP7HDXYv5pRm36Bcffzh5hVh24	10321	14556	14556	1618559280000
20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	149	1157	370	12463	12820	jxRThkqRzoHCNx3zGZRKskoWbJp7UR7RiEjYnNXxCphbA6eGTuJ	10324	14559	14559	1618559820000
20508	3NKVnKHskUxH4czJhD54DiHtUwSaejGR9fu5FeZsnArYDqUriFqn	20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	1675	1096	365	12463	12825	jxx6Q8vRjCwSMkpan4CySHuRKWps8waFt9K9BpEeZ3Ty4QTmosu	10231	14560	14560	1618560000000
20453	3NLtP7tkcA1qiccXky1XkxLRLMDvs4Uedr8TQsfF7xgP8yALHjBM	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1406	1393	369	12463	12777	jwkHdcQxNo2QtkNCLjwwGXSzQKdiLJEsJeJZYaoT9Ch1UTVLYGQ	10300	14527	14527	1618554060000
20457	3NLAJX6fmCJk9i3FxvaoHSLhgK1QRKmicmupeziM18MKYmNVj9AR	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1483	366	369	12463	12781	jxtuYpgDXti4PzGpPgos2sTNz1Zb8LMWbYcugh1gsVs512UDu7c	10302	14529	14529	1618554420000
20460	3NK9fVycEAC2KaKZMEf5NWMTWH8Y1M6Uw9C86Pxi2X9hko7yjTd8	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1613	1103	369	12463	12783	jwz8UaQwAKbyVEt9stqkw9oYjCUgjWLufNvG8bcbRTbwrFMAKUb	10302	14529	14529	1618554420000
20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	20458	3NKHm2DY7wwjFWcj3agymsGquWsMVm3f8beDLaPMyFWjchfLqff2	1521	305	369	12463	12784	jxQuDHkWB7zTPAReMw1zb5uu1bCaU4hY1NCtac4EtK5MKtMiVWw	10303	14530	14530	1618554600000
20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	20464	3NLrrX5cSmxMkDWv56udRS1rarn7gnA9SfArfBAhwnbg5HAdaKBF	1637	816	369	12463	12788	jwyXroYYtoQHWFQozkfwYCPbHTNBukwRtH6rAt5LJTa11iFKJfK	10306	14533	14533	1618555140000
20468	3NKpYdh7ZVQfBN1recpWx4CaDphTutVJM7rqbRnq5FLe6shmWrvr	20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	1407	1395	369	12463	12790	jwkhMT4k2FXDF6eQqLzsKrGU5guDwFByenSUrKaoMxznB98QSi6	10307	14534	14534	1618555320000
20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	1500	1297	369	12463	12796	jwcg7ZC6zc26QmB31uN2JvZ8rcwfCKxDeQdaufSuXo1pY3cDNBs	10311	14538	14538	1618556040000
20476	3NKBhS1b9AQDvrZbZe3f6ScQABrY66gsEPyZ3QbahctqNQH4Nuio	20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	1457	1265	370	12463	12797	jxbXMgboTRv1F7Unq8u5Zx8ZJcL57b9JHxNWozSUW7DAYZ4uENY	10312	14539	14539	1618556220000
20482	3NKVkq5ikCYN9vCW33C92fzbYXkQ4w1YuPvGpcyuiDvNTg8c4cTG	20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	1534	1071	370	12463	12803	jxmveuWyoJXseCPPdjcotj31fugUvdyeVKB5288PfgtjwkGM8Sf	10314	14546	14546	1618557480000
20487	3NLRS4StprFvd1dfC2Qj6kWjtvJaiubKuWLcHSnqgapPKBpZkxMY	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1476	1245	370	12463	12808	jwwz8eKxehrfmrWHY4vujoCtMjNLvpzH4PW3XaUj79qR3bUjrMN	10316	14549	14549	1618558020000
20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1656	1217	370	12463	12815	jwjpY13somfPkdsMEFQdc5xvEJDMqGF7gqdRDZGyoUYFMpZttna	10321	14556	14556	1618559280000
20500	3NLiBPf8ZxHaF4baBh294UxZH6RRqTq5DUfBAvW512atP2Vj7r6E	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwtXKfRFW3wFPQCudoBAxbpdqwDiFk7bMn3RZaKJVM955xZ6cAu	10322	14557	14557	1618559460000
20505	3NKtxz5M3G8oEF5cBPnaU7m8ZwMNXd7ESs8A6EmJMbehQM8KKsVu	20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	1534	951	370	12463	12822	jwp3bGauEwrgeYHm99zXk7wceHiGW8WvENVHF7h5vMPa29J5wpf	10324	14559	14559	1618559820000
20467	3NL3Y93GcAJBbvRG3yaoTDmXJY4HKTsrKcW9FaJqYdAEnpRgaZ9q	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	152	1204	368	12463	12789	jwKSDm4JFPKFaYURen3LdSfFvwuCv1zqa2Te7yzAm7KdWuose57	10276	14533	14533	1618555140000
20469	3NL3GTJVuoGoU8NZc7mzXqgrZfCCrN9tmi9zXKdUdtaTTLk91Zjd	20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	1553	776	369	12463	12791	jxX5rsos46E2CSZmoniDwTrxQYXVKjcq3wRXU1PWZoK9G42KcLn	10307	14534	14534	1618555320000
20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	20470	3NLmL9d4KWaQrDj16VQbwfJ7j8SEXFPkJf8S5ivrAEmduqdFzTYN	1571	1089	369	12463	12793	jx7jvUjayBSJkE91os93Y3iy5Tjho4z4tVi3N69iH97ovZCUQY8	10309	14536	14536	1618555680000
20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	1419	814	370	12463	12798	jxkBMVkqb9PnGUgSg8JDWjPqdc4h5yWi6dZMkWwQAHpuYs3Vsy2	10312	14539	14539	1618556220000
20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1673	1368	370	12463	12806	jwkGnePCpNriVPj3XdHUd2LgyL1UjW3scWurrSimnNgNWAUR48g	10315	14547	14547	1618557660000
20490	3NLGcR7SuDL1S8beiTpZCGyDbLRWvAoLuqSTWWfMKnmWJQVowJ4u	20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	1646	1228	370	12463	12810	jwxJgbtxThYfPNgQNGinHHFzuSXT8Gdtvf6ZJzLhM748Zs7TKgk	10317	14550	14550	1618558200000
20493	3NKQ3egNzjyxL8jnWSWBAH3oPZ8g4yZLNtNuJbHutSVfrKqBDfL2	20492	3NLutFnyarPh8PRu3jX6W5dC2wMczGF29t9HKuLxEAaSkM794buQ	1610	1068	370	12463	12813	jxWwZ3iGzRvZepj3cPz6gRQivSPnHN6QEvKMe63GdNXgAQPRHM7	10319	14554	14554	1618558920000
20496	3NKTvpNDYeiF4ik3EtpgH5V1ZaBQTA3dtqPaY9UKvs7HRNouqz1u	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1646	1354	370	12463	12816	jwEqbtiWU7FxUiifvWTNoLcwJGbS8AENKt1ytVRAshUaPDLkMEv	10321	14556	14556	1618559280000
20501	3NKY4TeAxNxT4tgqAP1MvEdYyVnEBeV2vqimMdJ5JMKDRub6PwB2	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwHeobLNvg8FHYR12vFWAk3JBLtvBcHRbFeUYb8sCQHaWp7qRdW	10322	14557	14557	1618559460000
20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	58	915	370	12463	12819	jwXtf7QKset3i6xKfzH5ka69iTp99n5sFP63coewdnXKu1W8DHn	10323	14558	14558	1618559640000
20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	1675	1096	370	12463	12824	jwKDsTP4cN9PGpBrsRwJhcFXQcXL7649zkiDG2Y8b5U1SUXQ4yu	10325	14560	14560	1618560000000
20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	1445	924	369	12463	12795	jwtQpVNne1gXE5z1Wp5iouUWWXW9qtSGdGgqSar2i1s2WPK2hiA	10310	14537	14537	1618555860000
20478	3NL3a1KXQKngoGzRjVSrk8n7iC6jhWZMDUpj8sbBXhfEGVG1vx4Z	20378	3NKvxGzSnpAuikuBRqqAeaHWraPvZQzvWz2wwV5czKa811U85t4w	1419	814	367	12463	12799	jy2ojta64JWQjCjJQn6pwjjpjDMa9B4wfebHJNhMYikaBRStPYo	10247	14539	14539	1618556220000
20480	3NLAWbGbCeDk8mLX1AFZfgoMmMJzhaaTvGLFNUN7bDvZvatzBLoc	20474	3NLMYXAuZumm9oiK8UG4RSbmcnWnnRxAZKYGkgYd73sF6cNiH89e	633	1384	369	12463	12801	jxVVys8Q5SvEFo8r5ddyw9Qvb6uw4pT8MGwzFZDcygPMTGZKHy5	10312	14545	14545	1618557300000
20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	1593	1346	370	12463	12802	jwJJyak3MWxVdx1NNjJsYyYPiuKgMycotoEnwTyLQqUbP2Jto9b	10314	14546	14546	1618557480000
20484	3NLt8V2AsVXVzkd7wcVdS6MfFDr4UYhQBDe1KYaWkKWKZdrV7hzC	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1451	1292	370	12463	12805	jwvNwT2HGk6tXWW8AJ7uDg7J5unC5r1JWKNnvxNLs4417NxfDfg	10315	14547	14547	1618557660000
20489	3NKp7M5TGA4pMeNiqCLHFiQadue2TsGXfrjWwcSomaFCTPVxwKf5	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1476	1245	370	12463	12808	jwVpmjRSAxeEnFeEFmodsFuVWiuHdPjvewFNL5aieM9qxkZ2Cj1	10316	14549	14549	1618558020000
20492	3NLutFnyarPh8PRu3jX6W5dC2wMczGF29t9HKuLxEAaSkM794buQ	20491	3NKdc5onUxBimQ7qxnk76se65uHu5PCn3KZ6nspDfjs7mWLJrXA7	1477	1104	370	12463	12812	jxf8QjVAiT9hKqD371PVJHQC4hHCy5U27s1QrQQw47j7nyeAfZX	10318	14553	14553	1618558740000
20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwcPMpQgDqejvvhtD5KtZkjpeZk4LMnm9yHyvbWUtyys4AXbXiU	10322	14557	14557	1618559460000
20504	3NKKvvWW9qjkr7uMmohCTNXQpYLYsRrG8Sx8buzHQQ9VzYGJvpnf	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	149	1157	370	12463	12821	jxkgLRt7LWLTThXvLpNdzxGfRdQ2ELsfpjdFXakoqZ2gS3KzkXM	10321	14559	14559	1618559820000
20506	3NL9dR12bskir3acHseZ22c2a6ozabBGPF5xXXqfPteLbxgo87fd	20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	149	1157	370	12463	12823	jxF4tyseTES6xy5XdZ682yyY6Rg51rJbFBtNX6YVA3QuY4nq1vY	10323	14559	14559	1618559874546
20509	3NLumdBioaVGRjc44TkZLGgD75Xr3eATaTbScm3gwZiGFwNxRcNg	20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	1675	1096	370	12463	12824	jwyEv4ZR9XxajSX3FybqqLXFhdkrREw3DA8jAzCUGu855NB2mVx	10325	14560	14560	1618560000000
20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	596	1180	370	12463	12826	jxnapMx2HcG8RMkMk3pwSZdEvRDv55VGW8mQWkwQ7QW4otQRfzn	10326	14561	14561	1618560180000
20511	3NL5RfBNjW374k8z6SqNiGYEJYbEJQiCD9LW97YsSDDKWqefuTPu	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	596	1180	370	12463	12826	jxhUNtCBX4MM9To7imLHzJeeGdB53V1MjsJ3fHdTiJ3hRc6AKvn	10326	14561	14561	1618560180000
20512	3NLTHiBhBNB5cAFECHeDcdBqFHteGivdZg6Z1bjrFtktLebia8uJ	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	1483	894	370	12463	12827	jx7MofbZPmUbzECjE67GkqPJYouiyxFyFQnCzZmq6wMUpF3etJd	10327	14562	14562	1618560360000
20513	3NLXUajqWe1FkceA2ufY1VWhUKfkm1kNbenR2nujtGAai2AU7zaK	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	1483	894	370	12463	12827	jwkW5JoRaWSDVE61wEpW1QWnKBoVF2fUodcbMDTtFXYLeEsFxu2	10327	14562	14562	1618560360000
20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	171	1128	370	12463	12828	jxyQk1cYdDjkTxe9kjEcjSqU6pafbfX9nzA8w1BPmxZ2to2Yitz	10327	14562	14562	1618560360000
20515	3NLV757VpSwmjNEz1sR1yxztPXfpLobsGdKg1KqPqbtjzko5tv6K	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1527	1293	370	12463	12829	jwmB3N5ea9WQtdycF7cp2EPUxJy99nnKyBudz6vGXDQRRAeiAwG	10328	14567	14567	1618561260000
20516	3NLSg9bcfdv5HyL7m6qLkt5fapjnS1FhrC3yYktbu9xVNBAktPf8	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1406	1393	370	12463	12830	jxXMrfDGRJ3dDkt6C2MwHVS7vPydfLYsGz8ap9YgJ425KP6ABdP	10328	14567	14567	1618561260000
20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1527	1293	370	12463	12829	jxB2dtN7A2yYFGv19guePhjjV4i9n3LLQvNcdvZi6gdhpeoKBwA	10328	14567	14567	1618561260000
20518	3NLj2Qad9YMe1i935agcceasqPDmAW1WDQoo62SJua4seYY9yogX	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	576	989	370	12463	12831	jxggFog6TBvVKJD1heTijqdH4sNaVDr5ccq8RKkeofLY4zJxhzs	10329	14569	14569	1618561620000
20519	3NLKxJbpqUJQpor3MH79PpqajvP7XgZViiDHttCQ8JyGXPQo6d1f	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	470	1309	371	12463	12832	jwVjwsHrAdkMxpiFArunDrpyW6MmC39UuKRqED5QNNDSJa7gGTn	10329	14569	14569	1618561620000
20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	1594	204	371	12463	12833	jxx8wY6a1xPswTWfKsc1fDsFE4h3xPVtzhwy88f937ZfMB9pKrx	10329	14569	14569	1618561620000
20521	3NLpmgwTZ3oQu4McGonx2rqQ4QvuMQkDoetnB3ruop96sVPv6r7h	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	576	989	371	12463	12831	jxwwipdoaFdxGdBMmYoknzE78jcDvXdwWCqJxDDA119TxWVCGMd	10329	14569	14569	1618561620000
20522	3NKPcyMKVPCbG5n4RQf5cW6TCyJG9ueej6QM72zWJZKDgo8Lbet5	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	1673	1368	371	12463	12834	jwZ6YJjBwJsCL9PL7VPDYaV3mVCwivKR8vuLZqBWn4Lf7geFy3Z	10330	14570	14570	1618561800000
20523	3NKAfACh3h8UE3yr6tnAqipMQSH12xwJhg3nDWhcLVgEf5yCxWPH	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	1439	1279	371	12463	12835	jwt3PK94rHUxknX5ACyQXtz8rZ4DFr5iMXfC4jPfygStND83ve3	10330	14570	14570	1618561800000
20524	3NKfWH58bsLk42VZVd8FcuSZEXNmpGcJ9mrF33SkxQ5yCCdA2dt7	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	470	1183	371	12463	12836	jwPg8z6zDd3LYtE47wx9dEQRw3z5vjnhyzjC6jmraW9GTxMyK8T	10330	14570	14570	1618561800000
20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	20522	3NKPcyMKVPCbG5n4RQf5cW6TCyJG9ueej6QM72zWJZKDgo8Lbet5	632	1136	371	12463	12837	jxg2NL4uy1xRRncd15gWFCf3HLQakWkvGyYvpzF15j8yqK3fpMJ	10331	14571	14571	1618561980000
20526	3NLjxZuSafV5jkCnZXa7AbuV917j3Qs6L2uw91YQwFn4YnywhVLk	20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	1581	778	371	12463	12838	jxtE6PFuj3bexzEnhsUCTXrLo5EnyTohUgvm2Bm4ekgbXNDeJbf	10332	14572	14572	1618562160000
20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	20526	3NLjxZuSafV5jkCnZXa7AbuV917j3Qs6L2uw91YQwFn4YnywhVLk	1634	1085	371	12463	12839	jwsnKJj3aLqrbfFkaZepysroFtCmyodvbjbk2WoMRbHEkpWZmkL	10333	14573	14573	1618562340000
20528	3NLiCivuDoqCdoqyzasyChAqfQwaHB5k112ueBGRku2Wc4WTNTb6	20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	1642	1121	371	12463	12840	jwHfAtbG5rXDkGGfcaJsa573NgTgRoLdAVFpo5o2RHeVBRCAhmg	10334	14574	14574	1618562520000
20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	1406	1393	371	12463	12841	jxizXzVcADFavsnRZJnMnr4fyHfwaNvkMM5A5qpLoGpeeuowqJb	10334	14574	14574	1618562520000
20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	1407	1395	371	12463	12842	jxXeHBGcHpg28drPBWgymZGnyyiWTm8BUFiM9uL3AmaSbLmwdYQ	10335	14575	14575	1618562700000
20531	3NKkua9LZUMGq74L1NXhB4JJRpA2w2nR2Fuin4t69JiFXE38ep21	20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	1403	786	371	12463	12843	jwKbXgY2PcnsL18id5FqNF8Y8bLeKwwW26fXG1VX3U3ufhBDk6j	10335	14575	14575	1618562700000
20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1553	776	371	12463	12847	jx6kSQvJCAPojhzuGg5oB8BL1VCWbzVkys1yVTu993eUkNHat1J	10336	14576	14576	1618562880000
20536	3NKBoHpawZ13QUTmSMaY24RmpDRdAXQ94NawR4gboU2aL4iZ1wCG	20399	3NKkNKJqeXVYxewmWSzW65ALzJgAEimU4R9DJCohPbZaiB6mCTYT	1643	933	364	12463	12848	jwq5WxKZ9XeNERXoyTPa7jWHLYNeenTr6wyEhkD29KyTMWqqN7k	10187	14577	14577	1618563060000
20542	3NLxKWGDcPgw5GbpvNsyXgsdWYuiJLnnamULPFqZ8jcuuhGfjrSD	20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	1577	1081	371	12463	12854	jxVnPzaTgmuEExx4dqWErz7kveiY6YjqMZgnxoFN2MzEnb6tinh	10341	14582	14582	1618563960000
20543	3NLMfAn95Kiq3avd7gHUxk7wWzXff5HMzPoaiwX2ZCVZMZBK1GYF	20542	3NLxKWGDcPgw5GbpvNsyXgsdWYuiJLnnamULPFqZ8jcuuhGfjrSD	1503	911	371	12463	12855	jxXTNzoNUzBqxbuTwVefDhHCoKqKuJHpb2UdWhbZP3AFBDzqPRL	10342	14584	14584	1618564320000
20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	20543	3NLMfAn95Kiq3avd7gHUxk7wWzXff5HMzPoaiwX2ZCVZMZBK1GYF	1507	1280	371	12463	12856	jxU9L7ScgDvtZG6LTgB6rQjNBUXq6xRkeAhSfLdNZdE9K5uqrru	10343	14585	14585	1618564500000
20549	3NKKugy8E4yeQuAgCKcqf8jL7zGJ7Figb2u1T7VARB7LNDAvLc9Z	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1476	1371	371	12463	12860	jwzjnVjw4iBrt2XpBrj6rRXaRhNrnVP4JVfF3H2t5E9Ew3KmPbD	10345	14587	14587	1618564860000
20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1546	973	372	12463	12865	jx9FK21K141P55DaYGsS2uhkEhXXKFeJpDTKX5ZVReL68ho8FGz	10347	14589	14589	1618565220000
20559	3NL5mb6atvf9YocoB7RXBQ1RK9BKUwgkAvPSDhCSG519Wh3W5pug	20385	3NKnkwCfYHvcyTGRdKjwYVVfAyDDU3bQRWuoMX5zLJ2kpjqeN1zy	1509	1320	365	12463	12869	jxVKsrTCkf63PFQjR3BFjCLmWxWWpomsDP7vPjGQHWXpts2NdVF	10228	14592	14592	1618565760000
20565	3NLd1JqacV1hWaxxKD5JUS3PJG2UXH5BVPRZVFYNqbF8nWTV3QUb	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1407	1395	372	12463	12874	jy25s2VvaHFyNs3uM3mUoPqGkEHoCVPgx1fFVLjN8KdMkPMZaYa	10351	14595	14595	1618566300000
20569	3NLMcQsUt3xTyKGUXnq2QL4qA1t4koQEwiKjFSXT9WjbbwbCke4b	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1451	1292	372	12463	12878	jwZjJjZmoaQxYQZm3TqA7UHCNTG3izLhuW4M4Cc1cjngvYLELyU	10351	14595	14595	1618566300000
20573	3NLRaxrwvPF6mrDsvJZcUNqSG9wrFCUHfhRMNL4apGds3DLyQ7sN	20486	3NL6PxNDcsxMkUnLzjaC2xkBnd66BLEnnmkkei9H3r4dLU78dBGa	1451	1292	370	12463	12881	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10314	14595	14595	1618566300000
20577	3NLY6a3Cnv2LfaTh14HcenvJkbP8hDiTaTTP7thTPr4Q1KmsU8QA	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1672	1039	372	12463	12885	jwrhrWbQZzs5zat2cjo6mnS1TnTESDNzPnQ5aWcKKxuF8Ti4Zaz	10354	14598	14598	1618566840000
20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1419	814	372	12463	12889	jwN4ExPU1cn91ks554cqTbQJQxoqHJAKk6E9M979d81DPDfZr6h	10354	14598	14598	1618566840000
20582	3NL3jABJoA98yJiy76Qrdhzm8WnCVPnJg2PFAHtBHct9XcHh7ZCD	20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	470	943	372	12463	12890	jwrdxuy16bg4wpBq3XJsZU9cBRy6GjzJpSvw3XsvgwQFo8ANxXA	10355	14600	14600	1618567200000
20587	3NLCY3qZqdTtgzEYkaG9c9FqdiKJ1h57eTFtkc8U5shyjn1zSod2	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1610	1068	372	12463	12894	jwhPQvrCE1v9qTpiUAWqdsMwTqLb9e2QRVM3iYA8sUFwFCGCQfg	10357	14602	14602	1618567560000
20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	1647	1302	372	12463	12898	jwC2AdVJk36DRjDyL6zf14yx64mTrNewtLKZBPLKvD5uuAQpqGV	10358	14603	14603	1618567740000
20597	3NK6GX2zGvjiQRVwtVK5V7HzW8nP72hHYq1gWJWnpvHgM5a1bd6X	20593	3NKftttyQK53HpV4ghS9eTY4QoMtfdXb7JgaPisUgAzSJyNYFASF	1593	1346	372	12463	12902	jwzc3nvp9yiFzmjK2MpdA1BB1jeKU3PbGhskEhcF3gQd8pHznBR	10360	14605	14605	1618568100000
20603	3NKXVeUwFy4QTrDHXUdx3oYpnpwPRGNpizxv7qgDEofsi4SS6LUY	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1571	1089	373	12463	12908	jxzEHvdEAgab1VH3k93PSDUmPC4AJjuFzpR4nU1RsfHBKjq3d7W	10364	14609	14609	1618568820000
20607	3NKz54H88M8nFBYHc6XqWaK1mMLixaxBEd3W8vZ5qUTr2VBbCaiD	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1613	1103	373	12463	12910	jwvHTX7Xyjh3h7t7VpsEn3ADCL8wTm5fNpCHpn8anXzqSWQ2PWW	10364	14609	14609	1618568820000
20608	3NKH4xeatHH4vTcE3wDdwi48eAbujbakFrkthHTSBSMt9Msuy5nZ	20429	3NLJT9mure82tJryRoMc9k4hn7fHScErDcZZhViWs7stwF4pdkGW	532	1177	368	12463	12911	jwMyQh8QnDmrgUL2CTpRpy6CBJqTTU5zis4As4WPBZq5s3teu1C	10287	14611	14611	1618569180000
20614	3NLZ2mg2Wt856A1N6JW8dkygaUaF3FJUR2acPjNH6vcZinV3uddL	20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	1407	1395	373	12463	12917	jwnXXS49qpyzMeZk2gabFoiFHh6cxvxpxNEqBovb59wM76Xrpa1	10368	14616	14616	1618570080000
20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	20619	3NLi2M3Cd3aUmz7sW7exZ75syptmL6nwqZVMvm3s28CytvrJsd8F	1657	978	373	12463	12924	jxwTm9SUSdwH9HUap99jmBUiy5qBNdjgZNuD9gpXrAvjb2ZyKqY	10373	14622	14622	1618571160000
20622	3NKFazbru4heqGSPVJyh9dQDJmY6i2DNRHhBh8p8Tb3RcQGXVwoc	20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	1627	1139	373	12463	12925	jwekHpRF17v8foFJRmuXCrkJvRrdyiYdAPZZxENvttNTear6sqZ	10374	14624	14624	1618571520000
20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	1642	1121	374	12463	12936	jxnobhzSBhcpSQecRaAVcysSpvVjn5weesz1z4D5Mxnnkia8Jvq	10381	14637	14637	1618573860000
20638	3NL7to3g2N8iL8xZFt5gDTsyqa9d1azWmpjCawQwNmqsS4UUrdsA	20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	1555	981	374	12463	12941	jxkDxNK1RGCTAGH1ZBHx8P4LZAe16Ybh8BDUEF2961qbFjhd1GX	10384	14640	14640	1618574400000
20639	3NLXJV7gRCFAAS7wTRwiwLXcnwiRAJTpbcduhkv17gWaoT28XFaG	20637	3NKoDNWnHjMnYDnYmCaE8ng2MdYZDoC1ccd9CKgwtokQ2RY77xVM	1407	1395	374	12463	12942	jxd4uCSkZ1fx394VkGtyNbQbFML93p7dDTHTLBwxbNv5oZ4aD63	10385	14641	14641	1618574580000
20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1577	1327	374	12463	12948	jx3KgfNRHPu9E8D5FwbRoMZmrCBVvjiJrCcoUJ8XmFXhMbmvgDp	10389	14646	14646	1618575480000
20650	3NK8UqcGo8CX2dGAVhUdbV7PDDFHozDbCUAaDY46z6ZAJ1rxydZ7	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	1477	1350	370	12463	12953	jwmDqC91W6YP6nWc5HLEUhTwacyksVDgz4a5UAZwPTjXNzj8ddS	10326	14647	14647	1618575704672
20655	3NLjfBBvgahVfdAxewR1kSemX9qJV7WjEq1xNwBHNuoq5V3uvm7b	20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	1529	1316	374	12463	12958	jwHRJBAMDrQVANs7dHFqAtquh3PXU4eVeVx3YyCabxCvQvHpLqV	10392	14649	14649	1618576020000
20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1673	1368	374	12463	12962	jwLa4GNUJnQhEBtj9x4bPoL44bgn5wBJYSkAyipyaQErotqK3y4	10393	14650	14650	1618576200000
20660	3NLvCoVw96zdTx3eayuyyrJuWcZVbHqhqN89aXra4quDwS4WRJuK	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1448	1311	374	12463	12963	jw7sTr1rnbpTWpKeRLWfhukGCi62H3TUVUWwXN5C9ExRjjwZQmU	10394	14651	14651	1618576380000
20532	3NLKzDUJ2hvUAHDB7moYGp7LsJnh1ehaJ9mbe5Xdf9oxS89TH95k	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1516	1168	371	12463	12844	jwDhtyaSV4HrgRMeRWv2w7fZ9Wx2JSN4RSgzrnvyKd5ZNCmf81X	10336	14576	14576	1618562880000
20537	3NL3FDwUruPLs2ARLNznLKmFabjmY2gYmULvC3kwKQMMof1Q8mZF	20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	1483	361	371	12463	12849	jx8dRLi94E77TfeFMPxh8MaPvQqkRR6zr9h6hq5No7EzUVJpfEx	10337	14578	14578	1618563240000
20545	3NLVBLFtR3ZW2rEtj8JVL8Ay6CZtTsL1LMH1kJHmVfkFCKuLbdfZ	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1407	1395	371	12463	12857	jwmwAGN61y5npRAKYe1uCqamnqVg6iFzoAEmJ416AoZEuoCECBB	10344	14586	14586	1618564680000
20550	3NLQscYt3Enrr18mRBKNEsFLPGxeq8YsRaTjAozVtjQMT2mdTT4Z	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1508	1387	371	12463	12861	jwkAy3CXRgEKGm9gKRXqytrisg3P3tTUbmEZ9Vq7QquE5R4rdaU	10345	14587	14587	1618564860000
20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	1407	1395	372	12463	12866	jwQ5yoQcVUXte5oXPTqf89wH9uftox3rLwtB2RzmkbHTPJYdspz	10348	14590	14590	1618565400000
20560	3NK5uaFHDrT9SivUxT6mXGfUGpx4GSju6MuH5KWBXoPzdrMJb6gm	20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	1406	1393	372	12463	12870	jxarXp1q12t9tgQ7XPryJrn2eTUxygZFgF5N9VfCxRdubtj2RQ8	10349	14592	14592	1618565760000
20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1407	1395	372	12463	12871	jxhgThkcGnS3yD85zgRoDz8r47oSmmqXhvKdCew9ftfr1eanYa9	10350	14593	14593	1618565940000
20566	3NLE7uk5YpjmqMands42teWGkX6vQutHT75XBVVsxPuWes3Hy1qh	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1422	1337	372	12463	12875	jwuQwwzHbsjyCJ1wnd17DMUHEyfSbDUDesNv9efV7gbawzghbYV	10351	14595	14595	1618566300000
20570	3NK6GvM49RHTk248SvRXpoGYqGry9uxstijnwhUzRL1amDxrtDts	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1623	839	372	12463	12879	jxeoTayMJQGzmZuFLAg3q9arKYN9ettaCp6EKm5bCGvPTE6VDNo	10351	14595	14595	1618566300000
20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	20565	3NLd1JqacV1hWaxxKD5JUS3PJG2UXH5BVPRZVFYNqbF8nWTV3QUb	1553	776	372	12463	12882	jwkDhEymhf2tCxKD7nCekfd1HEXDFCPMpcJUdqVqD6D7K3bKqsv	10352	14596	14596	1618566480000
20575	3NLwwShaUgfxWfZHp7kcxFerPrQJjrA3xBPoqLjPsEVe4Pbsb3D9	20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	1455	1206	372	12463	12883	jwJ69sbW7Y25kRZRJsNcVuUnhLWNr2CtQxNyC2Rz7vrCtquo2uV	10353	14597	14597	1618566660000
20579	3NLhE6QAc9isGUKaA1iKDwP6ZdM1oS77yWbAUnkUVcM22k6qfCHM	20478	3NL3a1KXQKngoGzRjVSrk8n7iC6jhWZMDUpj8sbBXhfEGVG1vx4Z	1419	814	368	12463	12887	jxHHuH4phHFLjqZTj6izXvcUa5cAdAPSxHc9Bzma19PtkAWSG2V	10248	14598	14598	1618566840000
20585	3NK5w2gFpv9Az45awetAw3hxNZCfQhvZGXdoSE7zi4VWSUQ5AWhZ	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	606	1049	372	12463	12892	jx4NWKn17AzrtwsK8fDcM2xyBjvr9pu8tDauxjE6YHCg15RiYe7	10356	14601	14601	1618567380000
20589	3NKie4NcBf1Xh6TfnevJmVo8vgcXVPfbqxDJyZav3A3QBTPwCxMf	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	369	1312	372	12463	12896	jwax1Pn8Mm8pruqNVPT9wq3CbLVAgUGfUioscDUqP5i7espVsSC	10357	14602	14602	1618567560000
20594	3NLS3kRVGokRjXMt924FMSgX23xiP2Yp9rXDEPVUY93qvVgRv8A9	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	1458	1077	372	12463	12899	jxG4G6MrDpUi72MxJBUxE2tiUGKwKGKKshSHM2dy5xQK3zUoaTt	10359	14604	14604	1618567920000
20600	3NKnEjYvV8QBqqk2LQaRmjQoL2WvGunToUynTN1Z4FdwA46mv1RP	20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	1553	776	372	12463	12905	jxA8RoKhELRfG9h3k3NFRm4cbUMjhc6uET1v8qJ6YxAmP8BaxQJ	10363	14608	14608	1618568640000
20605	3NKzxuqXfBtBAZBu1UUVuNRkCHUzhM2PNnuHY5E6tcCQnCuYNhV4	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1613	1103	373	12463	12910	jy1AfdN5D73N1cLfVxnN536DpiD9CDw6AKnC639amfRyD1ZLnre	10364	14609	14609	1618568820000
20611	3NLdKGc1eebgr4cLY9trVNqN1UrMp2z8sbvSYnF2DXNSXW885Xpd	20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	1673	1242	373	12463	12914	jwwWbwPzS5MwGoqruHDGyBSy1ZXKbWccVwTMAZYksENvgW8rJgV	10366	14614	14614	1618569720000
20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	1656	1097	373	12463	12915	jx12zPzJZMmef5rWqtkw7QWLaCCSyL9xKtbDWvWjQWgnyHUt6Ue	10367	14615	14615	1618569900000
20618	3NKQk3NmYQraL89V1o9SNEh3BHV2FcFyCveZURPduh55o63KMbnE	20617	3NKvczktHkBriGxPtA5Dp8oAmAH8zuPYgDmKTmvnZotMetjVuWdW	1555	1221	373	12463	12921	jwV5KgMGWj2HhejEGuL5TusnjiLChsQKhmHFEpsNRDQbkZGm2Pt	10371	14620	14620	1618570800000
20619	3NLi2M3Cd3aUmz7sW7exZ75syptmL6nwqZVMvm3s28CytvrJsd8F	20618	3NKQk3NmYQraL89V1o9SNEh3BHV2FcFyCveZURPduh55o63KMbnE	1578	1170	373	12463	12922	jxqp4Xn4M3PMr3qeNL5LqC6DZhz3xNy2XfoyWXmBTd4F2KgHcER	10372	14621	14621	1618570980000
20624	3NLwLyBeFhYv8EMfxgyAHBTcWgnoadkGwvCuqC5y1rPdppMLJY7h	20579	3NLhE6QAc9isGUKaA1iKDwP6ZdM1oS77yWbAUnkUVcM22k6qfCHM	1419	814	368	12463	12927	jxHHuH4phHFLjqZTj6izXvcUa5cAdAPSxHc9Bzma19PtkAWSG2V	10249	14624	14624	1618571520000
20635	3NKEEL1B4ahymQzw8iyV5g7BE9qnF1Umw3o3hi1UxJcu4JjDypwA	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1599	1041	374	12463	12938	jwMqo356tWVm8fNCswVqUDYc52PJr7L4hzaQPHZMpQvPR1t6Yqw	10382	14638	14638	1618574040000
20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	20634	3NLxTGgNHbXB8E3x1zKoZ3fmVVP2e2gu1PwbygtLDbQoyHhFJwdC	1406	1393	374	12463	12939	jx3hEkkXXACD4tsa5EX3CR4HoD8TAYcqXBQCfEzwD7QNGkV8sr4	10383	14639	14639	1618574220000
20643	3NLcBXoGi7zWDY8MGc744Pjjk9n3bkigkkKGxryRQ1DaBDjpUnaD	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1407	1395	374	12463	12946	jwHWN4XWuYFEKBS6FSBD4SokKu6B6WBmH6tz89km9fBzq2TcaxG	10389	14646	14646	1618575480000
20648	3NKQCCBbp6WTzuHnRZYwEeqTrQjujvQZwuxUAU9j94B6Cp6zJLkn	20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	1477	1350	374	12463	12951	jxU2SwbcczgKtBr6MfQmZRpP2FbsjzFHPpJ7Yo8EwKFKdZMTtXX	10390	14647	14647	1618575660000
20652	3NLQdk7puDwoBqAbuLyivEXuGZKR1UGx1p4bJ5JqGKxASkSH2pNz	20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	1477	1350	371	12463	12955	jwua6BFhYt3r7VopHZpjATuQVkcYAYEpaW9muekaiKcRyoGXtHE	10339	14647	14647	1618575751523
20657	3NKKscphC6xx6hbRUrQevhRPZuiB4HnvcrVCHshwnBLc4x7258ss	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	43	1310	374	12463	12960	jxHCgPzxmAFKEAy5pkvRehsU9J9d27SFmC1yHa3tJ6q1uvzze4G	10393	14650	14650	1618576200000
20662	3NKfRB5KRkvubYmw1Y7LUEj778vSJFKDvy2HMoxrxKZ4HQ5LGo2d	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1403	782	374	12463	12964	jxbTQkG2PiQNoURCFa1137oFiNvYPdf5hcPcUiPcPBJYmRMWhf1	10394	14651	14651	1618576380000
20669	3NLdH4R6wiqKRaXzie6MMvALXfnSH7gD1RV66Zxgcw4Vq5sAPdTj	20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	1637	816	374	12463	12970	jx3XztGmj9zipygNpUKy5dffgV6xfW18VVc7jpgTofxeEKfRWDw	10397	14657	14657	1618577460000
20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1447	1345	375	12463	12976	jwLn9XvPtKPgHmtGMBX9DPmaTwzqyqP2gipd7dyTZP9SJwJgX2H	10400	14662	14662	1618578360000
20680	3NKrZGbbc9GLcvfQPXXQett6bn8X2jR4MNVaH1HeR3Q1iTrDQ3PU	20663	3NKQE8ofq65soCPo6RXqjMCyQhgndoe9VyecgNu3zLz7KK8rJP4c	1456	244	374	12463	12981	jwoUNzCLBjvwYtd1w8qFAsMbbmycq4w7XigdYWw4DG7wQ275n9S	10396	14663	14663	1618578540000
20533	3NLbKNww5SP33PzfL3fD1KtqiuFKn5N7a4H4rDYp9Nom8F4Y8Tqm	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1657	1344	371	12463	12845	jwS9sUT1cqg45KVBBPW1uwtJTKRhmq4fM6rM3TMMsBfJNHX1yw4	10336	14576	14576	1618562880000
20538	3NKysgMHogBRsM2v4HXmwLpvfjNaoWkW1hDVG3mDExhff47ispap	20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	684	1352	371	12463	12850	jwieAFoLbRkHwz6XQEnHKufMjWrWZx8u46oGRk9T8NrVW9o7xm4	10337	14578	14578	1618563240000
20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	20538	3NKysgMHogBRsM2v4HXmwLpvfjNaoWkW1hDVG3mDExhff47ispap	1407	1395	371	12463	12851	jw7fL2vuaoz4YyAgRWit6Da13ttnLpYVesdhJNmEh2mDZvn9SDq	10338	14579	14579	1618563420000
20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1651	1175	371	12463	12858	jwHqWwYSLCJDVJCWTpE72q7RkayKrtqRGSGue1QdCdWDW4yF8V7	10344	14586	14586	1618564680000
20547	3NKDwmwRGAtQ1obJwjP7DuD4KB9mhBXKULNVUu4UwmCsssAh4JFs	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1651	1175	371	12463	12858	jxsfYyVyBWhQZSerVRKXUjh2rsY2y193w9EbbSsTfpo61hyML53	10344	14586	14586	1618564680000
20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	20550	3NLQscYt3Enrr18mRBKNEsFLPGxeq8YsRaTjAozVtjQMT2mdTT4Z	1444	1255	372	12463	12862	jwRyZA2Yqk9pTRHXBBd2bXfj83SjiVXJVadPST36THU96AM1T1C	10346	14588	14588	1618565040000
20552	3NKk7igYEhmVUowgFsyqef2HAcRG58wEacLz4z4AESKgbon2hc9Y	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1503	1277	372	12463	12863	jx5MzUZKpucdiLGxcTLH5PLcLvSGiC9CZZKqLsQG9UsCqvWLi4Z	10347	14589	14589	1618565220000
20556	3NKVtKpfZq4NyeYf4D9tiGx9msZCAzEzCLcWV56kEXE3WByGmGHJ	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	684	1106	372	12463	12867	jwCfTN8QBCqqaHaA3mbJiGrC5RWfQctRT55SFQXoGs7zz7229bF	10348	14590	14590	1618565400000
20562	3NLqqPSsevMNYS2vZxRJU1E7SeXPsEA7tNo6WwYboY3Zz2Jta3s4	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1474	1083	372	12463	12872	jwhVy5PKFjj7JPnbfF5m5zZRmvT6PK7xQZ7uqnGPq8A5ViSh4tb	10350	14593	14593	1618565940000
20567	3NLtrfLmNXVnNwsuFqwf9GxhPy4QZ6SfPsiffLEL5S71EFAs3mLk	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	606	1169	372	12463	12876	jxRwUCArMRWYK5nqVxKwwGuRJwqpCP6cfQdaFKHeXmogyQpN2S7	10351	14595	14595	1618566300000
20571	3NLnZ2oG1ZHngAtZTaL33zwHbCdBQUaa5SLVqSxbge1ybg6FCtQE	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	448	1059	372	12463	12880	jwe6bbg7fXb1wDk9zYR15fNkgPUZJyhy68PL7Y4Pt4aSDTiYtow	10351	14595	14595	1618566300000
20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	369	1066	372	12463	12884	jwu1NXYRpybxHRfxqFwHW3QofH8RVnLNobrsANDdgQ56qD1sbBP	10353	14597	14597	1618566660000
20580	3NKeJC8Pxhvd7g4pwVe4RiYZWu4rN8GKutz4yWJXwY1VrvRXigf6	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1542	938	372	12463	12888	jwmKZNLksRP9UFYPontvgMSqN9QjQ5iAEGBQqh86euw5NWUquDP	10354	14598	14598	1618566840000
20586	3NKKXFucznqpi4Mtp89etrmCDYyUVLxDmM8zp17ZWum5oX3V9W1G	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	1445	1044	372	12463	12893	jxPpXhpJBYyBQug3hEzAcMCPsuQk6FsNK7fCULhBN584NTj2AbA	10356	14601	14601	1618567380000
20590	3NLrLPZwPbtk6m4fbNHVrQ8omXAHo92SP8XiCKqA4pUsQCvgUjKS	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1610	1068	372	12463	12894	jwTnACNRdFfgwgsJM1RfymKgE3vr4ZwMCevevnq6bVvB9yQ8Jdx	10357	14602	14602	1618567560000
20591	3NLoVkEqsSYMCR3asM9KYVqpp2V53WXmVw5ejS9UdPPjXXtMCVgP	20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	1407	1395	372	12463	12897	jxshTRUZkG8bCWxgLQcW7YN6JcWmhSryAvm3ftnBXtUwHwgsWVV	10358	14603	14603	1618567740000
20595	3NKt2eb6XLzkEKPskCqZRFP93Q3F5xM18VeM4Ma3qfpNk3MV95Yi	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	389	389	372	12463	12900	jx5FY8WUweXFMv7caUPhTw1eTZsYNafRGCLhThNMmFFvpmXZkix	10359	14604	14604	1618567920000
20596	3NKXE6MebLtXF7jKy8rfP22GSHcU1B7WyuhTbCkyBiu5ioDS1jWu	20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	1593	1346	371	12463	12901	jwo9SEJv6vqYh9h6GQ2zpkd4nJq3xj1WXK6vUf44f5ws8rDy5zV	10332	14605	14605	1618568100000
20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	1458	1323	372	12463	12906	jwKjec1PmwQYygoq4yB8gpSGbUUJMRHZn6DVULdLzNHMStMbxSv	10363	14608	14608	1618568640000
20602	3NKSEgwATNwCMmuH1BskNtztiRkQtZSFhu7Sf8NHeKbTicfjV8Zd	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1610	1068	373	12463	12907	jwzQ8HGJApbLgcgCH48Z95MEhrhEMvzw8bE5b9xWsxN7GFr61a7	10364	14609	14609	1618568820000
20606	3NLxRKxZg2DyK1sp89H7pnGyyvqM6ydhxZ7vVNrZuEyRFfh1WNx6	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1610	1068	373	12463	12907	jwzQ8HGJApbLgcgCH48Z95MEhrhEMvzw8bE5b9xWsxN7GFr61a7	10364	14609	14609	1618568820000
20613	3NL8oGJcfV6VTgk28Bd6b5QT5xS2t2Vi99YFGrcJrupYs7i8ecsq	20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	1403	824	373	12463	12916	jwEmKFU1xpGghxyJi4En9Qifc2kLvrGrYSprfVpK3RNkXYLkPw1	10367	14615	14615	1618569900000
20620	3NLsnVp424D2K6iZbmTypJzN3K7SCf8kDCGLGaLMyU7ctqvJbywo	20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	1578	1170	371	12463	12923	jwo2T2V938tWWr9LtWwyVXsezy4iintm4KgXyRFSkyizZGvqCGR	10341	14621	14621	1618570980000
20625	3NKKDpfext8kZBxdneD5K5BkquNRUyz6Xrp8buDxsQwHYKKtveCh	20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	1419	814	373	12463	12928	jxsfAhNoP7CX8UvCUiitc3U71jT8N8mJ4JoJ1zgtV2Azza2pbGW	10374	14624	14624	1618571520000
20626	3NKZN5hmo8eHGXwvzF3j7SoG7dvy695Xmx8GnDAUkrDbhjEWqdDF	20625	3NKKDpfext8kZBxdneD5K5BkquNRUyz6Xrp8buDxsQwHYKKtveCh	470	1063	373	12463	12929	jwXC3diDkagQ38UwiDyHKEw4CiJkNvJkP7UsDNN1jmLeKKFBJoU	10375	14626	14626	1618571880000
20627	3NKHNmxvpnxptDsfgsdrEjci8H2TFsCcLP7vhoLHWwCbmDnEuyCe	20626	3NKZN5hmo8eHGXwvzF3j7SoG7dvy695Xmx8GnDAUkrDbhjEWqdDF	1529	1316	373	12463	12930	jx2kqyQjEL82zyNdec566KaXynYC9z6STLaNp3ZY88hnftkHYca	10376	14627	14627	1618572060000
20628	3NLPZy7iqnzym7jjB65KaMckZUd3M8ephfbSo8B4EUJb5jVfKm2W	20627	3NKHNmxvpnxptDsfgsdrEjci8H2TFsCcLP7vhoLHWwCbmDnEuyCe	1647	1302	373	12463	12931	jwHw2BcUZ6X1sF2pXBPc22AZJv9Z9TD4cAqLRTVrSkf8TqxZusi	10377	14630	14630	1618572600000
20629	3NKAb5Jdc8Jjf2MfPK5qtkq3USARTsk7skHCZTzi6KDKuGnVhRcS	20628	3NLPZy7iqnzym7jjB65KaMckZUd3M8ephfbSo8B4EUJb5jVfKm2W	210	210	373	12463	12932	jxFgrQywvDvnY7ipkQnvtAqeELAEChbFAnU62ifWwB9b2FTG6t6	10378	14632	14632	1618572960000
20630	3NKWh74tvwifThd5tpL88BEtqur9eUz7QzMWgbWLUUfQcn6F9qDQ	20629	3NKAb5Jdc8Jjf2MfPK5qtkq3USARTsk7skHCZTzi6KDKuGnVhRcS	1407	1395	373	12463	12933	jw88sYN7UttWYwT7HqHnEJSzAGPMCLrvYHfothhsfSTeLJbgqcH	10379	14634	14634	1618573320000
20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	20630	3NKWh74tvwifThd5tpL88BEtqur9eUz7QzMWgbWLUUfQcn6F9qDQ	1581	778	374	12463	12934	jxmyiNuDusTabLxu1BkrUHsU2pcfxsHgFkYVQNCXgpY62zSfKPq	10380	14636	14636	1618573680000
20632	3NKxAxoetchsLgQvB8YGjBhYcjmGyi2twSAPy93w4qNEuvYKZUTC	20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	1671	1365	374	12463	12935	jwgEBGPaSWwxaXdTaRvv52iHuoq3Y9UfoJnQzeg46J9EhSWhuLV	10381	14637	14637	1618573860000
20637	3NKoDNWnHjMnYDnYmCaE8ng2MdYZDoC1ccd9CKgwtokQ2RY77xVM	20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	1406	1393	374	12463	12940	jwbZxBrDh2sC8jELvtGx1H7Vp12wgyipHcKNZDBQfH1sXeuK7eb	10384	14640	14640	1618574400000
20534	3NKn9XvMhH6e14m4YU1H47EPmbKmcCMMQvDpqfpT2uKY7CBnRmGC	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	369	1186	371	12463	12846	jwcmEy9axpRYBxNSSMXFbHEnjr8WRBK8oCtCq11a59xAJWmbd7h	10336	14576	14576	1618562880000
20540	3NLnQkgpZ2hZAH7jA5Fvi2o1vJwqjkU1wRgqAnfmZQCfa2NaCejN	20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	1642	1367	371	12463	12852	jx7EPZd21Y86662AX1YETZihNr479wqoiJ9umSv21Vp6N4wqZjD	10339	14580	14580	1618563600000
20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	20540	3NLnQkgpZ2hZAH7jA5Fvi2o1vJwqjkU1wRgqAnfmZQCfa2NaCejN	1607	1102	371	12463	12853	jxzMXCB3ZL5SoXmGHS3bG2t2DFYaaHokAYzML9KkV4b3XoKGBeQ	10340	14581	14581	1618563780000
20548	3NLeJgntgx9i6HKmnMTfk3DpN29tBTBGu31jkUDoChfwrhzJTuXU	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1460	1198	371	12463	12859	jxfoQT76RvM1bQAYrK8JZ6eczGKfQSfFgaJo4DibNVGe3nej1UY	10345	14587	14587	1618564860000
20553	3NKFjvSwveV7UDGpX6Au4boGnzrwh2NaenWtkxhmcgCpoD3XexiX	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1627	1385	372	12463	12864	jwso3AxqBgbVuPMFs1y3VQzSzJgcME1vEuTer3VsZbeHBPWGjMp	10347	14589	14589	1618565220000
20557	3NKDgH6rEkJrPykUDpqfCwatxhjmem9HBezNf4LqsxyJPwDxhUug	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	684	1106	372	12463	12867	jxHay38gin6r6b9nbqnkcoiqcJvdpyUNPq7UkT3oZHxtzANghEo	10348	14590	14590	1618565400000
20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	1509	1320	372	12463	12868	jxPx22F8bT8LHDVk4azQnG9SWoWZG7jLWVbp78TZybEYTFVKXZG	10349	14592	14592	1618565760000
20563	3NKQtR9RUa8SC7gXLhERuGEL7uGZaSLz8c5Biz9bhWh27NL8bVqh	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1474	1083	372	12463	12872	jx6x52QqeSxLRZ39a4o8ZhofzBimtSAKXmGaRGW1NW4VVVZmoz5	10350	14593	14593	1618565940000
20564	3NLgNH4Vos1HTyjdBHY8aSrmB8NpWsTo4SCTKv7T5ZxzkUxFPArr	20402	3NL9ohbTzjUkvy5XXoAMdFNxBAEjELGJt8QfYLTeGHmURnCCBBiN	1422	1337	367	12463	12873	jy1humBQbbTu26RsE4vaimuggjcUcoB45E3bryvr4MSubTwssnE	10267	14595	14595	1618566300000
20568	3NLbUvdrB33dRg64hVqqcfRBh9uf4RgRcdsMTPnuRtB35JDEWpFw	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1571	969	372	12463	12877	jxhKuqKN7YYSQrvcqbvaqvvKnpVkWp59ZtR26zhA4W9QvGWJeTH	10351	14595	14595	1618566300000
20572	3NLXbnLhoYFPDSemwrDmyjNw6DA4sGHNKaCxKrDcDMZw8QCeYjoK	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	448	1059	372	12463	12880	jwZ9EYSSAj2mmdTUK1ZneCWDEUFAgfEf7mb9N86w9juKSrQUGfZ	10351	14595	14595	1618566300000
20578	3NKU2Aj98fYDK41jVSPT91hNtT7YBoyFPodSRXZXc2x4vdrzER9W	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1490	1148	372	12463	12886	jwUyfKVdQQs88HfFKuCM7YT8CyYLLht4ik4bS7yronYi3jr4QHn	10354	14598	14598	1618566840000
20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	470	943	372	12463	12890	jx9MyphtzhFnWgK7HJSGfS7krQLkGC5ssYRaA1d5fMS8u1Aoxz1	10355	14600	14600	1618567200000
20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	1405	869	372	12463	12891	jwV4eEVXyrbd6gY145AHzMgeKadRr7VopKEkoqxyMnts2YMbtaA	10356	14601	14601	1618567380000
20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1406	1393	372	12463	12895	jx2msaxfCo2F74dGtJzFZz39W6F96narG2RGGRJ3vGzCWmAFGPx	10357	14602	14602	1618567560000
20593	3NKftttyQK53HpV4ghS9eTY4QoMtfdXb7JgaPisUgAzSJyNYFASF	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	1458	1077	372	12463	12899	jwz8Qvd39R4MDozSDjSvV4ozHj2MfC2BnsyzvV16sV5qvjDY9FW	10359	14604	14604	1618567920000
20598	3NLrEmHNZnLVANNK4iF1CkNDNqNEyFhYxy5AMDCeqViZDDwuUoAu	20597	3NK6GX2zGvjiQRVwtVK5V7HzW8nP72hHYq1gWJWnpvHgM5a1bd6X	152	1330	372	12463	12903	jwHRNnXAnM6bhThavS5MYb8RHrbLzop2GMWAMZEU1pcwaDXgk3A	10361	14606	14606	1618568280000
20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	20598	3NLrEmHNZnLVANNK4iF1CkNDNqNEyFhYxy5AMDCeqViZDDwuUoAu	1407	1395	372	12463	12904	jwjqtKPyn5eb9T7WeBumbXiERcozSQjGnbs7hJ7TGCpsZXP84CP	10362	14607	14607	1618568460000
20604	3NL7GYCk8tZMEb23DYr97S3zG1GnvDXHuh8B2BhiT2mgtWFRLkuW	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1637	816	373	12463	12909	jxzEWsjcYR2gXndaXGUw2vp8DxmHhk8DkCho6AJrbiWvA6acmwQ	10364	14609	14609	1618568820000
20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	20604	3NL7GYCk8tZMEb23DYr97S3zG1GnvDXHuh8B2BhiT2mgtWFRLkuW	532	1177	373	12463	12912	jxfZnqz5jVTCy8hLwEXvBU1W1VckvPyCQ9mtZD5ip6kD7E6kE5k	10365	14611	14611	1618569180000
20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	1406	1393	373	12463	12913	jxmxmUeebkAdnwhR5xr6tb3VoYPVNycp1KLXdosavrZJfnJxod4	10366	14614	14614	1618569720000
20615	3NKk7JQZ5vBnqxKzJPmobKNUBdXdPNDdEfvpTzr2WRbHgs5wHCGb	20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	1403	824	373	12463	12918	jwwWUiUExT1CS9zzanLGPkzZTZfxZfNcY4N2PfX492wwRYtcExC	10368	14616	14616	1618570080000
20616	3NKctH9HkuiKWybe69bHtHm5w25SFUDERQn1X83j4UP9UVRftcHo	20614	3NLZ2mg2Wt856A1N6JW8dkygaUaF3FJUR2acPjNH6vcZinV3uddL	1426	1118	373	12463	12919	jwiAzvwWMUxUpUkGR9SJaYzfifisMBfEvTBPdz6ZVzRPPf55rcZ	10369	14617	14617	1618570260000
20617	3NKvczktHkBriGxPtA5Dp8oAmAH8zuPYgDmKTmvnZotMetjVuWdW	20616	3NKctH9HkuiKWybe69bHtHm5w25SFUDERQn1X83j4UP9UVRftcHo	1648	1284	373	12463	12920	jxY721wGmEtJEfQaMYcFCYyQNUBWVe964m5uny683ZB1z8aPdUA	10370	14619	14619	1618570620000
20623	3NLuTUZhAJBGkDu2UVWGB9PdzzwwFSrtmgAJnvydGaJVnveBfjtL	20591	3NLoVkEqsSYMCR3asM9KYVqpp2V53WXmVw5ejS9UdPPjXXtMCVgP	1627	1139	372	12463	12926	jxZXJFMYPxcPEpJi4ibjrHemmWzqNe2F7j1ArbhSDk6t83zo1nB	10359	14624	14624	1618571520000
20634	3NLxTGgNHbXB8E3x1zKoZ3fmVVP2e2gu1PwbygtLDbQoyHhFJwdC	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1407	1395	374	12463	12937	jxCq1bCGQ4i9UHehCf45rvdSEQD9Xuozs4PuR2v6NmsbxPAqREA	10382	14638	14638	1618574040000
20640	3NK9BDxrhfBJgHBAuoCGxq41Zvp2d5incqUnj6RBHM3cPffGYVp8	20639	3NLXJV7gRCFAAS7wTRwiwLXcnwiRAJTpbcduhkv17gWaoT28XFaG	1516	928	374	12463	12943	jxowLB3NF3T8SbbuCersY8RujxNPRcqQNKkaDgRXq88CyRPhtNJ	10386	14642	14642	1618574760000
20641	3NLRHvSL28d433xygwDFPNf4rpP2FL5TcypBXhf8HbG418hwzoiZ	20640	3NK9BDxrhfBJgHBAuoCGxq41Zvp2d5incqUnj6RBHM3cPffGYVp8	1637	816	374	12463	12944	jwuQy9hZ2KzYTo3V95q1rMQCErMHEPBMV3bfPivhjy2mF84gzAS	10387	14644	14644	1618575120000
20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	20641	3NLRHvSL28d433xygwDFPNf4rpP2FL5TcypBXhf8HbG418hwzoiZ	80	1273	374	12463	12945	jx7PqcRX5qGn7pESxaKFhJseydH8GtV3J3EJ7P3LywgRdrZW3Mj	10388	14645	14645	1618575300000
20646	3NKNZ4GpwsWfiDDzhra21DiyuWh7pmNitKej2Wbpd6a4Uu2UBy84	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1508	1387	372	12463	12949	jwvbbnxnjUvh5kmMLmWmntVvLjNSyyGmR8eodokPKpHrBBN1e4c	10357	14646	14646	1618575480000
20647	3NKnXuWZcsRNwrGWoQLCxNvowGhnNhmwHaD5sEFJJq44d64Nv16C	20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	1477	1350	370	12463	12950	jwsAiZdxxC6YKyG7bWrRZAjdxmQbpVi1TSqx8vutFAcYNi1e63R	10313	14647	14647	1618575660000
20651	3NKBZBc6cx92qY8ndVWGJgRGPq2XEQn6ynCRM6TvpmMUTcesYhBR	20487	3NLRS4StprFvd1dfC2Qj6kWjtvJaiubKuWLcHSnqgapPKBpZkxMY	1624	1088	370	12463	12954	jwzRC8NMi12S1DDSTHCDgXcXa8c19tpUJ1wj7byyUaaEJeHtmu7	10317	14647	14647	1618575660000
20644	3NLdCZXeEkUnajB81vBoJW1P5KmgQxNCxnCLBov68kuHoe6otsjn	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1508	1387	374	12463	12947	jxV5sEWb2hk7hAVEgTUZgW2rW8YiuTxUsnShpoyBJ3tA8EGZAF8	10389	14646	14646	1618575480000
20649	3NKTDfAeStGHpe4wf7GEeSGvJNnj4uUcaUUP1YxdboSsNvqquuBJ	20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	1624	1088	374	12463	12952	jxXwLCkxPmn74NVB19FnNWiWD8TtTw2H3BgLAme1WpVaiGEEe1u	10390	14647	14647	1618575660000
20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	20648	3NKQCCBbp6WTzuHnRZYwEeqTrQjujvQZwuxUAU9j94B6Cp6zJLkn	1601	1388	374	12463	12956	jxJ4K7ETV6mjgcxot6JGPzQi5FxWuHvPCCKcA8iCUC2Q6PdGbon	10391	14648	14648	1618575840000
20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	1406	1393	374	12463	12957	jxpDLpU8egtFViyV6SNzHBjPVVrKsPJsPtZEkWeYGTR2FJnw18G	10392	14649	14649	1618576020000
20658	3NKu5WYiHxBKCwgi9d3EspWh5LAiigajZojrUzQrKLpnoCMwWPRh	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1406	1393	374	12463	12961	jwCoCzr3vSW7spc51HLMg65rXXPyWDyfXUL2iPwobYQee7iCHUs	10393	14650	14650	1618576200000
20663	3NKQE8ofq65soCPo6RXqjMCyQhgndoe9VyecgNu3zLz7KK8rJP4c	20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	1571	1335	374	12463	12965	jwdghnX3mZALsr9WS8NK2bXNTmcom52NCwVcZzQ7hjVMZs112bz	10395	14652	14652	1618576560000
20665	3NLTkfBA1RQbH3VxdntvnhrBDkFM3hBPEwr8WKhgJfjsd3dxSYdC	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1527	927	374	12463	12967	jx4DurVVQW75YDaAFFkwbFNWd7wBFgymZKX5Mrjhyio13KBdaFu	10396	14656	14656	1618577280000
20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	1547	1252	374	12463	12971	jwym7a5EgFFZgRHyiGPsWTxuKpJK8cFvHz7a6DoTRHdvJ81bXAN	10398	14658	14658	1618577640000
20676	3NLWzuVfbmsV8PwAkuKTqFgXNcKnxJqJukUSYsDFg1mhJjVXoCDe	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1406	1393	375	12463	12977	jxKXsnvYPkMJAfnuq9F3fD4AvDBuEKNBrAjKp46qX3Sops2K8vB	10400	14662	14662	1618578360000
20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	1627	1385	375	12463	12982	jwsoDNT67kNDAx1uLnjhfouTZyeTT2FvtMZuGsPfs5YTbJpLk72	10402	14664	14664	1618578720000
20686	3NKCZZ8DHKaeM6uZnMjxxyZL75uiLVqiCh6HtsxbNkFXMnei2axz	20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	1673	1122	375	12463	12987	jxga8MbMy4hSFgELjmPwwcvKv1u37XxE17QWPmtvvP5EroRW3tF	10404	14666	14666	1618579080000
20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	596	1060	375	12463	12992	jxfnVDGtiFSgDkgoWMbpEj2HvFbU4enGr9nN85xayRkoswMvpHH	10407	14669	14669	1618579620000
20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	1407	1395	375	12463	12993	jxHztxj83Xq9avh2Y5X8C9GPqJEN73G7yTtbChJBvU5nvCPmNGE	10408	14671	14671	1618579980000
20697	3NLAo8TXwZKvwz8u7ZmkoEAWDXXvZss6uVved18KvpPijhz36Sn2	20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	1654	1214	375	12463	12997	jxraXTdwxwnGJfrkTyJbRk5AiFodNsV8X93dKvAfg7wrfBSpqtd	10409	14672	14672	1618580160000
20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	20696	3NLLtQyqELA5KLwFLprF72caJ5kJGmd6X19LSkUFtqSvij8Jw8fN	686	686	375	12463	12998	jx347yGRg6xkBaiPnsdgC9e78ARiNAYt551CADR5eZAL4d4aGTu	10410	14673	14673	1618580340000
20699	3NKYt4upL1Pdp94MaBuzAStd6fNHuWzrHMfdnavzeSRTYrmxTr9x	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1648	1284	375	12463	12999	jxTrvM7d4ESPe3op3JF85zDkvoqdaN3h7NiuHfqGQgMG26uBvKL	10411	14675	14675	1618580700000
20703	3NK7Jisw7BG6hqvKJtgZ8HSEAQ5FadWFmmgahooctcpM5F3dHXih	20701	3NKa1EjM68eZepjShwA5889SraCKpWtFYNUaQcfN3YDoo5NN4rB4	1529	1070	375	12463	13002	jxNfucYCw2EwP3ynbP1DvxnYpUUQ7Qmi3Ra3w6iG9dS3QrJWAtj	10412	14676	14676	1618580880000
20709	3NLpmYuhCdiXoXBF8McibS6eAiK1sAtwb1Gz3HcL7nNJ6hkDXHvi	20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	1480	659	361	12463	13008	jxqhzCGCd8PXddbQ7jqbRHjZjU9RCcwfFuV9eTGko7Y69PvSBYQ	10160	14679	14679	1618581479098
20714	3NKgpq1UDA4ACVH8fC5jrnuC8SvUL8y6xuQYyXyKrEbVmod7DYvn	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1585	1120	375	12463	13013	jwQ9vzGrnGsV6TbNXj47hJKaJghSEmA1RD6SZuGKNwnDN493WoX	10416	14681	14681	1618581780000
20718	3NKtYc5LBJm74A15DEFANSoZ2XDnL5a5KRNoPHmDzeQvdWQRXXjy	20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	1542	1058	375	12463	13017	jwMr2rAsL26DyqaLiDeMCePnZpxWujTqcpqoZz8byjXxuQCGKEt	10417	14682	14682	1618581960000
20723	3NLrDDDwovKKyKq3cwViRk2F6UZTvkfmdYr6ERUhnzP2EyREwn1v	20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	1631	794	375	12463	13022	jxZoQaNLVqhtn5e8FoMGbFgHtRFSMKDdUopyoAyYg7jzDrWbKCF	10419	14684	14684	1618582320000
20724	3NKRbbZDhoVb32csCpUsQiAqpZ8pwC1G2XgZeDxN9g1HpWCe4pUY	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1407	1395	376	12463	13023	jxWSdjgUccFhynzrowdKmP25UbnoHtM2riZ4okKt8FqsoBQKXdU	10420	14686	14686	1618582680000
20729	3NKCfiSAwiYEUAEXZjya5otve6VPrg9B6FEQFKPtsMWBdJ2ounKE	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1631	794	376	12463	13026	jxS13XmHWdpKtQVrBhmjZpviXNGUGQncD2pVxgdbkwNSLBrddE1	10420	14686	14686	1618582680000
20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	20729	3NKCfiSAwiYEUAEXZjya5otve6VPrg9B6FEQFKPtsMWBdJ2ounKE	1406	1393	376	12463	13027	jxg4HKMDUvCpX84u1gHwwQeM8oAn7tYaxfTH3Km3EAvUtnKZh1f	10421	14689	14689	1618583220000
20735	3NL2jbFYwCrnBL5pL4p6NVJJCg8S5zq1mai8GpWRpXnFNnyDXGFY	20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	1542	1058	376	12463	13032	jwgrWn2fFuSeASJppdmf8Kn4MAWsNnaynPU3HotFz6zbaEvzZFn	10422	14692	14692	1618583760000
20736	3NLU4Unybb3gXnUn8LpAZWM2CnHApHcZZGh99m4GAeQyvnTCnLKV	20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	1602	1369	376	12463	13033	jwkmyQWU4iHmFnQhzFgJzBoDNhybDYLPcz9uTWDD1s14GU6KYoX	10424	14693	14693	1618583940000
20742	3NKgMwwLhUdnymiP4yUJHRkrwmRWkersWyczoXZHzGmxGo7Kg7Rs	20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	1564	972	376	12463	13039	jwXFdyE7TsXqusVwsUKarQAinMM39Gw5H9qVCoQEDuMpHB2t1aM	10427	14697	14697	1618584660000
20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	563	1359	376	12463	13044	jxHcKLZ54iEpVW2knnypouHRea8SFE3bqP2BE9L1PhcbiZ1pdA5	10430	14700	14700	1618585200000
20748	3NLTr2pBgLeoU5QoqAsB44e7VfSgYP3UTHqAcsYN2mxdXnAPVnDd	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1406	1393	376	12463	13045	jwQnzmGc8mFs3u4Xg9K6TcZ5FW1PNLjyM3uuyqyfMw9NFdHhvjr	10431	14701	14701	1618585380000
20753	3NLw7g6e8pGzUSFgvQ9JQay8d1Hx6Rjdb9j2pi49e3etXvEeGzqT	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1527	1293	376	12463	13049	jw7tm41odSwB1u3fhBrzxNFZwsnM9YfTJdLiZGGoo3ezxBap86R	10433	14704	14704	1618585920000
20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	470	1309	376	12463	13054	jxTcGmRTSq43YCpJjL4JQ5tu91E8VpgV6d9DUZuF3TUsNZW2T6P	10435	14706	14706	1618586280000
20763	3NKaBQrPvNGEcdyyL9si6tLxw5FVqJhqjYiZy8aveqKYdUfVtDi7	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1633	1144	375	12463	13059	jxSBUoCtecQanVfd5FrxQdRca1WRLvjWAZ5sbhdLSrhsujt752k	10416	14707	14707	1618586460000
20656	3NLJRkAGRBE3UudXLPniG5f6dN8nytif288w5WcB66sZHrkR8fRg	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1407	1395	374	12463	12959	jwcoyLom6E1krBMew89WqesnRkCo7A2vPogjzocxDgXu3oHMxTw	10393	14650	14650	1618576200000
20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1448	1311	374	12463	12963	jwKa8HuqKJAS9nP4P8kp2GhQnddGzxxN3DibWNGNsvXK7azuWXr	10394	14651	14651	1618576380000
20667	3NLttpZxxTv9spjeFUbyLnZ43sUbHbvX9w7RdC4X6L2zKPoQj9uW	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1527	927	374	12463	12967	jw8qMryhJ2kbZGMpWDoSFXSGLBb6PVYq98jCefiLpoi4KVfPi6J	10396	14656	14656	1618577280000
20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	1506	1007	374	12463	12969	jy29gGYBy6AKnKNwF1W8ZyyHvpcSh8XzdoeQgvQVHRSz3RHoDVw	10397	14657	14657	1618577460000
20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	1406	1393	375	12463	12974	jwZUDAG5we4zJ4BaFWcRcDMkPxdKtkndyKGbZ2pFfRk5C4dK5TK	10399	14659	14659	1618577820000
20674	3NLY6Qy3CMXAvZvnhZGDEAFd6vYMznwn7yroQDgW9mz28jmer4jW	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1670	916	375	12463	12975	jxfzpRgHjSW7AdKdZr6u45S8f1KtAuXCRG2DfqxUe5gkGypFK2Q	10400	14662	14662	1618578360000
20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	1456	244	375	12463	12980	jw9tY1y6Xx2BzqAgoX3nH1YgXFtK2cztBa1CxPA1f6cqv38EaVo	10401	14663	14663	1618578540000
20683	3NL18LeQsjNM9yh7PpZUZsv8gVrfH7FLnMr1SP4NWiffVUgDyW7x	20623	3NLuTUZhAJBGkDu2UVWGB9PdzzwwFSrtmgAJnvydGaJVnveBfjtL	1627	1385	373	12463	12984	jw8BJPmqyKqBJnLModEyQEYyyAz8EY9TnHd5LeRdSJtifnQZBVw	10360	14664	14664	1618578720000
20684	3NKJKYgifJLK9Esapz7d6GLdnpcvpxnoAVUcsy21eGyTVeNkvpMu	20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	1460	626	375	12463	12985	jwUpchzMpXBZL7qZ1NjyzCrspCB9TBaNCu6jrA7fzcjoqRxeJW1	10403	14665	14665	1618578900000
20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	20688	3NL7QaF1hBbHirgWapj9XPNRcHreRyJ3kG72P8PMaRohyKHgkoQh	1407	1395	375	12463	12990	jwnoJP27KWWiVkVw5CZCKGxsmBx5rsUCaejfWh2sUAromToZWsP	10406	14668	14668	1618579440000
20690	3NLs1ZFvgQ6AFErZNza18yvvZi44M4y7pZ9cyVNWiSNpAUmbP5sE	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	1594	1326	375	12463	12991	jxK4iCJKsiintU39wGnFEYQpLUHCyjtaSNdwdwSVxmnEzZhu3iK	10407	14669	14669	1618579620000
20695	3NLpwDXu4BZBFh7CZ2EuZVcvbNAmpynn9xfpSvYcv3Fn7JMwjwqv	20505	3NKtxz5M3G8oEF5cBPnaU7m8ZwMNXd7ESs8A6EmJMbehQM8KKsVu	1654	1214	370	12463	12995	jxtSqsVc8WcCgMbKm85VSuGvbF68R2MAXpLJkpKkzJvGTbKztwy	10325	14672	14672	1618580160000
20701	3NKa1EjM68eZepjShwA5889SraCKpWtFYNUaQcfN3YDoo5NN4rB4	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	641	1090	375	12463	13001	jxdamokx6pDKXBtfhKKsaEzCkaN2JFymoh7WsCsoq4kMzoxikKh	10411	14675	14675	1618580700000
20707	3NKHhXKQLNuBUWFHXMf7dRnMWhvNMRmJMMXTXhAnazbs23EiNHVi	20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	1407	1395	375	12463	13006	jxUhF3qXjHbF9pEvCQc3AjbKAPC22sF9xYw9ryMhNvJVyArX7BG	10414	14679	14679	1618581420000
20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1564	1092	375	12463	13010	jxJHmeLc5SLKdGyxcKysGZTUTZxJJ5mKt9nHcm8motwwJMeiwfh	10415	14680	14680	1618581600000
20716	3NLAa55bBCkeW7H1LTwS619Z5PKbyovXPhg7gLBDRspNQXD6VPzM	20536	3NKBoHpawZ13QUTmSMaY24RmpDRdAXQ94NawR4gboU2aL4iZ1wCG	1643	1299	365	12463	13015	jwqwjLcW37Ng5d8XFs91s5fd7cDSKwNaFrF8V7aKrvgucVFZT79	10188	14681	14681	1618581780000
20721	3NLxtdH3j71TYwYMkGjpewS8jfQVgFg5dCkZ4Qk9dspkVSidMUtR	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1458	1458	374	12463	13020	jwwHLH4PkZfJMKj2gAT3Cw2n1jXgxoYQrrDii9oB9fwuS3AqNUB	10382	14683	14683	1618582140000
20726	3NLHhu8UKCYfD2mBAasKadG5k5qx1kjDRDXZcRD1ppH19xDBa27G	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwSRRJt9XpS1ggiPTrDWVQhAFCBuu8kzvJkiqdkVMcRtpD7FN3o	10420	14686	14686	1618582680000
20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	1542	1058	376	12463	13030	jwox1BuivomALcHK88McRRu9XrAPKDLvHXUrSL3pymGeTJQPApt	10423	14692	14692	1618583760000
20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	20736	3NLU4Unybb3gXnUn8LpAZWM2CnHApHcZZGh99m4GAeQyvnTCnLKV	1534	1317	376	12463	13035	jy2GqcePFd8SeDf2fAEY7LKiNWBXhJjrdBhBYeH3SMVWQUYUqWF	10425	14694	14694	1618584120000
20739	3NKxTgfh2sMwS1pF2rh2MGdJobJ7w2EY9GdcHT89NxMEYueNZkit	20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	1407	1395	376	12463	13036	jxe49CxeUWCbGiSkEBL2qidLtzZjV3Pa9termnsuK1qYFZqBHx5	10426	14696	14696	1618584480000
20744	3NK4w2k5q8rVeHAe59NUNJr4kmUBEq6e1zJRQSn7yGNkJvPS4AWt	20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	1581	778	376	12463	13041	jwBPnoXZzk1Ep1JVLWPrsD89E3HFNNKDLYqnRaQys843cVEw6w7	10428	14698	14698	1618584840000
20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	20744	3NK4w2k5q8rVeHAe59NUNJr4kmUBEq6e1zJRQSn7yGNkJvPS4AWt	298	942	376	12463	13042	jxyovL67rprTEcSgWY9epXS9mHDh3zbMpAYASZhja1RsNYYdqnc	10429	14699	14699	1618585020000
20750	3NLNKh7yQdY3R4mA6CVCMKbCgjPzAq1GNV6T9fLWvoPuF9D4w6c5	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1637	816	376	12463	13047	jwua3PP7V6mN4SkBb3Y8muxj86zCBkw7LzrfznZh4MnecAz6LDM	10431	14701	14701	1618585380000
20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	20750	3NLNKh7yQdY3R4mA6CVCMKbCgjPzAq1GNV6T9fLWvoPuF9D4w6c5	1503	1277	376	12463	13048	jwuxRHVsqUv17Qo9rSM8PTt3rF93PLrL4dRbCCCTCG6L1qbhhfD	10432	14703	14703	1618585740000
20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	1650	1375	376	12463	13052	jwSFruo2ddzqVDWJbFTWboHze9JzsHGmdG53sfYXvoqkv6Lv43r	10434	14705	14705	1618586100000
20761	3NLZ23cMyYpEs9236mxhnyQj3dxsr9k8677W8UQrbxjNVDWuzmmP	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1627	1139	377	12463	13057	jwVft2gGXhcwdMBqzaGi3rBXdfK7b3ku6v9DeSuUgVhEiwptqu1	10436	14707	14707	1618586460000
20765	3NLwYY6sz5J7HT2uSdLvCXZoNoKrtqggZ1FhTxJtd76yfiisoqKd	20764	3NKktJQzk8VwEX2L4xPPaP3vPCt5HApjtdiseYcJRWQaeshezWdA	1407	1395	377	12463	13061	jwEbJ3L9pDxDW5E7RngGNE7CquUkZdzct3r1h1LLWK5rq4RYuY4	10437	14708	14708	1618586640000
20770	3NLTRbhuSrwCjtWeMy4Ha5rubkjNtCNejzJApPqevZNbisn8AoKw	20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	1439	913	377	12463	13065	jxMc9pFJyYtceUbsMJk1NQsNb5hkhp4sMcvB6gH6qimiLq3SEAY	10438	14709	14709	1618586820000
20771	3NLbZTKEx3y5kuHLLzxCwNhpJnG3XuVdmrEKk5qbPhktCTx1zFaA	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1406	1393	377	12463	13066	jxRdCxZDrb1zg7cw5A6khrshKWwYAbxKzYnC7Mm78SsmhJpFhNP	10439	14711	14711	1618587180000
20775	3NKi86ANcvu7f7r4eyHnesZCt11UyiW5DADZLUNRqpB9UibRyvGB	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	576	1109	377	12463	13068	jxo3dxxL9iMCTN5pA2ApHC9vsB4ioRjUxovBDQV1DWEtxAgC4H3	10439	14711	14711	1618587180000
20783	3NKNmibTrjWzSTAp8i1x8TgJJdCUCifu7Su68BAP718S3sD85CK8	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	311	1181	377	12463	13075	jxkGkWYNpEs32JK4CX6cdfwHBEp7mHnuhGyVsv5mToQTMpRdbHS	10445	14720	14720	1618588800000
20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	1403	824	374	12463	12966	jxXAXvJyMDy3kVb9HWgjoo4J5GZTdr1fZkWDxj1xJRqCJ8Ftw5M	10395	14652	14652	1618576560000
20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1426	1364	374	12463	12968	jxQmSezZSi49QWeAyx4dcDyRsbzM75bX7TLSpaVx72E5FTed47W	10396	14656	14656	1618577280000
20671	3NKrGjLKtqTjuQvoEGadoKShuk5S8Yjb2GQP8zviZu4CtYJfqyRH	20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	1623	830	374	12463	12972	jxHKMDaVGsuCqxQ6M5MheRJ65c6rnSebwBj3LybkdhT8jRLu1uw	10398	14658	14658	1618577640000
20672	3NKjYw26DueE4UYFvrDc2jdMQqvpNj5wZgJBmhUFEjig1xG5MQ89	20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	1423	343	375	12463	12973	jxupNE3fMrfWtB5cBeon7tESh5nodutpmbMCGjXfZvXJuB6hTtF	10399	14659	14659	1618577820000
20677	3NKKHopwcVxeNJBmX5hdKqg55B3UWxKqWUw5EuLSiaK2JkaaRZrn	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	80	1273	375	12463	12978	jxmbkSUUAifqkWqroQrTpR5r7AL6fUWYM3KoBn51fFuHk9jRbiG	10400	14662	14662	1618578360000
20678	3NKsQXDzM3PwCpxCTWArgvTkg7kubftZ5i4RY3L6cXbQrjtnt9GQ	20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	298	1308	375	12463	12979	jwRn2tKo4T1GdEJQF24KLru1qvi223t7hcwvbmqraKB4eHqznpE	10401	14663	14663	1618578540000
20682	3NL7jmT1u6fHMgrYNPofCk6q7z27QRX9ytfUKx9E8gAr1tz8BFuk	20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	1673	1368	375	12463	12983	jwqe7v6o6XSqEMvRBzZE7oZHT6Rc1QA9e5tz4kNjbivPz9Q9E3w	10402	14664	14664	1618578720000
20687	3NKtV6a8cEUDoNpxdmu7LRcqSp2NThTMhZgp2m9BbQAdV9mt6xU1	20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	162	162	375	12463	12988	jwnkCBXmyHxtKpMGstEAhkpVRctXQNHi53JF31AYwAQZaJjLdxo	10404	14666	14666	1618579080000
20688	3NL7QaF1hBbHirgWapj9XPNRcHreRyJ3kG72P8PMaRohyKHgkoQh	20686	3NKCZZ8DHKaeM6uZnMjxxyZL75uiLVqiCh6HtsxbNkFXMnei2axz	1637	816	375	12463	12989	jwv7jg9Guh66AY6RfQsJHkmpDqfJawvoe7hWtrhSTqUeao8RuPK	10405	14667	14667	1618579260000
20694	3NLirdCZndesAkitKKwK4629FYe5HZVJLn7zf4V41Tp8AgGikmyw	20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	1553	776	375	12463	12994	jxzz2bA6USMVBfJNUDghukU7DB4U9geF9Uhi1wj1HAD2Pf5jsjG	10408	14671	14671	1618579980000
20700	3NKsXw77LfPtr1CxoL8MFiyLyAQbAiNsAbe3nf5jjFEmLZD6zk9N	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1474	1329	375	12463	13000	jwQCDr98z6rzDTwnvwgEpxiYmpiuc6bPT65N95TTqyZXdDuXU1e	10411	14675	14675	1618580700000
20704	3NKP1Wgcm7gpcbW9TJ2i2ai9eeMcCByyBN7dFqakUgmJg2GEzzCw	20700	3NKsXw77LfPtr1CxoL8MFiyLyAQbAiNsAbe3nf5jjFEmLZD6zk9N	171	1374	375	12463	13003	jxzLb7igxejgMXGEhsztUst8zVvxNqc6Ajh1yQN2uXjCYiWyZzW	10412	14676	14676	1618580880000
20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	20704	3NKP1Wgcm7gpcbW9TJ2i2ai9eeMcCByyBN7dFqakUgmJg2GEzzCw	1501	1234	375	12463	13004	jxxFDKedvPGFSZ1DejqeJDn7wwcLGKVUCErGGMJjoF7N9EZByZK	10413	14678	14678	1618581240000
20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	1480	659	375	12463	13005	jxmSakP58DmsCv9CBX823DpyXGqRsnY44aFEftEyiAsfkr4khjE	10414	14679	14679	1618581420000
20710	3NLoZyk4h6Fj1xi5jiZ5syGaqkJavxZncpNrv3XsF64m9ET7ycxo	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1406	1393	375	12463	13009	jx8n6cR2hKyQkV92CKxG5dXSxxv4YpqvZZJQZmJso32Atwuas2F	10415	14680	14680	1618581600000
20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1476	1005	375	12463	13014	jwSsHBTBo2yagVQwvkDJ5hJYx8Wekh1Qaa8yjsMpY8Qu71xJnCZ	10416	14681	14681	1618581780000
20719	3NLWL5R2nHW4YsoPKfvMcinbDjNXcZx4ryrth55xGoVsjwSJ43cG	20713	3NKThhFU35bZcxXQuqpwkBekttkSz9CBHFNdKxoKVpXvJFMNkHA7	1542	1058	375	12463	13018	jwBjec1RYnn21fvAJymh7YnjTAMNKJyHC6pw1SPMcGFVX1CbGcu	10417	14682	14682	1618581960000
20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	20718	3NKtYc5LBJm74A15DEFANSoZ2XDnL5a5KRNoPHmDzeQvdWQRXXjy	1458	1458	375	12463	13019	jxgmNTzMQSP9LxjXtuWFsfhKbQmMXwohWAWQ3otuiTKiY9wjs8S	10418	14683	14683	1618582140000
20725	3NKGA8YdgAPUYypphBRUrNcz4G4UrbiK2pYs3x2Sb8He3ZGvtatt	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwSRRJt9XpS1ggiPTrDWVQhAFCBuu8kzvJkiqdkVMcRtpD7FN3o	10420	14686	14686	1618582680000
20731	3NKKckZrFD7AnGZbNhpfA8g5jewekDAKFXS7KkrDpV5PZ9qe9Ayc	20725	3NKGA8YdgAPUYypphBRUrNcz4G4UrbiK2pYs3x2Sb8He3ZGvtatt	1647	936	376	12463	13028	jwWKSSJWfuAPtWhrCjckDFQLogBBCY1Cmkk2xMzr7DovJz5mdQK	10421	14689	14689	1618583220000
20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	1457	1391	376	12463	13029	jwdTnoiGWJv4fgCqq81t9tBzbNYsZU9A61XohW7zQ7Z44AneAN4	10422	14691	14691	1618583580000
20737	3NKugbLmn6wafNuQB4bCpbdCsEgNVbTAqCKLXV9uvE6Kb61gK3E9	20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	1646	1108	376	12463	13034	jxc8sshedFxQKVshi39DDBtdYNWqEMriiT7dPoMd2tUq6jvNsmK	10424	14693	14693	1618583940000
20743	3NKDjiaZYhd9yWtKJpF3WsZeP5YCfvwCFfoBSGEb8whra4FuDhTd	20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	1407	1395	376	12463	13040	jwGJVHyaMMTD9jC3GXCV9r6QTjaD7LTLQyK2SLeizBrWCMNAfFY	10428	14698	14698	1618584840000
20746	3NKqsWH3ggyDdfmSVRYvzJgr5N2GMct9u3dmwQ1BfqFnNvGb13it	20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	1610	1188	376	12463	13043	jxqHFDESz9WcjuQRBrBy1zmsktwdUWWYgcfDRDMbJKEVbdK2jxd	10430	14700	14700	1618585200000
20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1527	1293	376	12463	13049	jxhwauZMHjddQqbSLmoDZ1SKqKyRBvp3J5ELxyvn148vctG6XMC	10433	14704	14704	1618585920000
20757	3NKSs5csrU7z51wsPYoE1fbjTWm1rTJ5sgwHxc3NqqJDS1v25zcD	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	1423	334	376	12463	13053	jxghTYqpSk89KnLQMMduHn6wG41o1UZxaLh17UEbmy7KgjbDgtn	10435	14706	14706	1618586280000
20762	3NK52JKPChwWqpGu1ecSL3qJNAETShdJQtTvJdKeXPz48LG3g6iq	20683	3NL18LeQsjNM9yh7PpZUZsv8gVrfH7FLnMr1SP4NWiffVUgDyW7x	1627	1139	374	12463	13058	jwEwgRQoBXefJyUgo34xYDFHMuMb927QKZjYBEPMLV8qfieJSYc	10361	14707	14707	1618586460000
20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	20761	3NLZ23cMyYpEs9236mxhnyQj3dxsr9k8677W8UQrbxjNVDWuzmmP	1587	1231	377	12463	13062	jxYCuHddEqjESiBZTQL3To5gVjkytNNigLWSyBubwNQEvfBL4NP	10437	14708	14708	1618586640000
20772	3NKwTreLhiswbY3n8diUbThKURC44SFfkPY4thH38txaS2zcN5ia	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1474	1329	377	12463	13067	jxi6YXFsVbKEKSNoaErDnBEeYuBFATnpqN4W8fSxphu5sr3fpRM	10439	14711	14711	1618587180000
20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	20773	3NLbMNvSfJEtNSLsi2M9tSnoM84eSmZcztVQKrC3eQW4FGhqwY8w	1402	874	377	12463	13069	jxGXghE3oKz38cRjMr9K6s1bbw8TokHE88uZsrXspTzHmcaEMKV	10440	14712	14712	1618587360000
20777	3NKyhCsxZF8b767Ay4A8x1HYV1t37ESbUryZ3H1QtkxB6AsgcLHw	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	210	210	377	12463	13070	jxoQ5FBP8a5LuR3bMqPkmQmzS6wAiWv3Bk3SpSMrtGxXhxRahwd	10441	14714	14714	1618587720000
20784	3NLYZ1tR1yZzryU42wb5mz8eT4CAG9sbbuL4trWtt5r9rVZzHzcF	20765	3NLwYY6sz5J7HT2uSdLvCXZoNoKrtqggZ1FhTxJtd76yfiisoqKd	1508	1387	377	12463	13076	jxbw4sVYqgJdJnx9XwvZrbTK6tzpTWoRShgVSojVXdzh6jQBj5C	10438	14720	14720	1618588803302
20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	80	80	375	12463	12986	jxjcaoG9c7wXtPCBLpBjnQ8ySGRTXeUa1PVcaxGvCCaq9Arhpai	10403	14665	14665	1618578900000
20691	3NLU7CQbqRr1ydjxgz2gt6aK7ibhPfnrGAYnNcRPpE23eZvyo1Rf	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	1594	1326	375	12463	12991	jxtpQQAAmspr5MczecbvBDxvz6qMZpWbWB4jDFs4n2iKk4BUQMX	10407	14669	14669	1618579620000
20696	3NLLtQyqELA5KLwFLprF72caJ5kJGmd6X19LSkUFtqSvij8Jw8fN	20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	1483	1276	375	12463	12996	jwbU3rXhQy5VA4MRbGPVYuACmqZP1rjNc6rDoMdFuZw1wGwxEE2	10409	14672	14672	1618580160000
20702	3NLqZiXqMMJ9PmYYyHqtgUBUZr4yitcokeLrssqjS18Ds3MDxhXY	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1474	1329	375	12463	13000	jxEqZP8kR74r56KUnHFVDVJxkf1amXavwMd7aVvK7dmVa1xec3U	10411	14675	14675	1618580700000
20708	3NLvAvegF4B5SZqkHmg651KCMw7gDhhssTnsuWBNaZVWeSoycajb	20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	1480	659	360	12463	13007	jxbha4Nc1o8uP6mge8Qdtne44dVW7JS4wEKDA2j2h4XeVPfpo1a	10144	14679	14679	1618581420000
20712	3NKWfSX2tJLm2MstMWsBE3GQc39hJSyTqMj3EF7mRzoZkDNUouwj	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1613	1349	375	12463	13011	jwg21oE8pqBAAYw1m6ufQNJkG9QWBAzEkusxxTcnRFfkka5292x	10415	14680	14680	1618581600000
20713	3NKThhFU35bZcxXQuqpwkBekttkSz9CBHFNdKxoKVpXvJFMNkHA7	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1527	1167	375	12463	13012	jxTRd1AkKDeQurrzHBcUqoj38FsJW3X1pwR1ei751CDJiF5LPHR	10416	14681	14681	1618581780000
20717	3NKxWFmpDdB7yRSeuoeSiEJ1VHrgqpdYfPegp54stit8EuU9MRHY	20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	1507	1034	375	12463	13016	jwomeqrAXocWxDFxLZac2aptRB3syMq53ERwe8BfT15fYXV9iiL	10417	14682	14682	1618581960000
20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	1460	1078	375	12463	13021	jxDBMgFWLQTjroix6tfQkxxUvgbHjjQq5cnb7TmK8w2bgQ3Uaot	10419	14684	14684	1618582320000
20727	3NKev43kop34Qihqpea2f7gV843ShdivsALmYiuHzf4mdD3DUUYY	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwzrC43o12NQogTDLLqWDo8DHYaoTWXjhq1HXBGc1gov17Yyt5P	10420	14686	14686	1618582680000
20728	3NKm6o2ckQDAHVsaMZSVHZWaBAHgp4R7CpqrRjz1FS4d6pcmJNqR	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1581	778	376	12463	13025	jwzHKnUwRgPrGSPzkB3cU9ENb2HSFCxnE8DQAos7W1Ty2aUQxGt	10420	14686	14686	1618582680000
20734	3NLtv22Td5ZWw4n6yD6XZvupt57ZcdTxMXzvUkXqMdiL6B6qr4is	20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	1403	823	376	12463	13031	jwb57Fvg6XQAZV9CPJmhaXbGG3GoLmFsDhhWUCLRXKTDUPJdZxm	10423	14692	14692	1618583760000
20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	1613	1349	376	12463	13037	jwq78HznSQfqjaP3kU9YTF3EguCcKBdo5KS5phWCFhgTYtNrfWg	10426	14696	14696	1618584480000
20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	1501	1114	376	12463	13038	jxM7vzSxfYAi2TcijxBVLvEDa1mJ3KVJ2Gp24uLHbUifpX3Y2yi	10427	14697	14697	1618584660000
20749	3NKVfyQuRDLgjvaYBxVGzcSATspdRTbTAa2B7tA7eamwH2Kr397d	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1506	1373	376	12463	13046	jxps5Lsr7oWzeYbjVaJQ87MeBwnvUiYn3LRcQJuYq218oEwhupv	10431	14701	14701	1618585380000
20754	3NLMnhYznQTSQ6q962hVUE9YLG7hkHaDpvZQADBe5T7vs3umUEGW	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1536	947	376	12463	13050	jwMj5jAAsR1te9nhfuoivTBkGMsPCA7TvAZ8Nv393AH19NDEWPB	10433	14704	14704	1618585920000
20755	3NLJBVZHDC6AFSWCBysn1bgKDWKKwPh8ykkpSkopRfoBUgkbuJ9H	20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	1406	1393	376	12463	13051	jwCQcvR6FuDCw9uczpuNrw1oAYjvqDfrfzHyUbukZauPDZvMw38	10434	14705	14705	1618586100000
20759	3NLEHJw43VVcmnNSx5AWmTrF5HR637UK6VvucL2Rc1NqNLecKwEa	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	1577	961	376	12463	13055	jwJfSFmWn2wavTtYZmyAEwiXiktVdz4Jc5FuTBWssGDCmviU2HS	10435	14706	14706	1618586280000
20760	3NKCrhNv7D1HpbfT6FQYboXWCgDKba16ERNiTb562MwMW74VVS9j	20731	3NKKckZrFD7AnGZbNhpfA8g5jewekDAKFXS7KkrDpV5PZ9qe9Ayc	1638	630	376	12463	13056	jwQpUUhXtLLGLnRcdzSrn3tyfq2HTkcPRX4mgTu6n7RxHTkAJ4G	10422	14707	14707	1618586465199
20764	3NKktJQzk8VwEX2L4xPPaP3vPCt5HApjtdiseYcJRWQaeshezWdA	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1638	630	377	12463	13060	jweDDRuHJkVpbh86BbHtgSk5VcyDABEKxsP4oZoLLgSDNao2kPr	10436	14707	14707	1618586460000
20768	3NKbPDKSsNLDj5VEQgGThVcqsCRRm3a2EQdmLQC9Yg7XqCLaxbCb	20767	3NKfqz8Cm2dGqJchuwieQZPqVyJg8BXRue28Au44t3uSnxsh14W3	1587	1231	377	12463	13064	jxwad3x6jT8c9frDPKgA7UBpS3uhLHGrWA5izjGb925sKQau8ro	10437	14708	14708	1618586640000
20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	1439	913	377	12463	13065	jwzui8PHjAq7oZzvnytKsGmMVLp6L9ABPpBT4ivBECASPA14eyk	10438	14709	14709	1618586820000
20774	3NKmvktR2QQ1NKE4mQGfoEtmZW7iE8aUqMyay99nbFaCrhHpM4bL	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1474	1329	377	12463	13067	jw97BxxLTq9gfdtuwtuX7cRVDbWmYafdsdXarRwP3kqWdWiTKzW	10439	14711	14711	1618587180000
20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1549	1116	377	12463	13074	jw9yQEJnuKPv3VmAx2qK8H6LHkHKc9UfwCJJX7FefvVu9gUhhJM	10445	14720	14720	1618588800000
20786	3NKSUcXVhp4ozNEycE9zZJSxptyPysefZTWGSgRxvmzoKonkVYai	20646	3NKNZ4GpwsWfiDDzhra21DiyuWh7pmNitKej2Wbpd6a4Uu2UBy84	1508	1387	373	12463	13078	jwDyCsXkDT1aBnCMyNT5YetXDKSnyRdA26kRdCBNoiXBso5JSQq	10358	14720	14720	1618588800000
20787	3NKoLdzXSgxkUdXAX5SrpgjHgHTThrbgh9qBB8yBUBSikQtVEaqh	20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	1600	1006	377	12463	13079	jwuRyXez6jiQjVC1qQugytrCQXEnszigSnA8qMZpkGHBegMTFps	10446	14721	14721	1618588980000
20792	3NLBdYtEw75NGdaEzpnbEsEHjct7SvYxbvsVQRSwsaRtzSNsDUKw	20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	1507	1280	377	12463	13084	jwqJjDPXdPvc8UCMsGyno1mPopx6TRFRyKfVTxpWmh18wHmqirP	10449	14724	14724	1618589520000
20793	3NK4wsUmfo4TeLDBRmWFeyKLwp7Nz29XgFuLujpkJZKx6TpAfKgd	20792	3NLBdYtEw75NGdaEzpnbEsEHjct7SvYxbvsVQRSwsaRtzSNsDUKw	1637	816	377	12463	13085	jxecf3vHPH1whtuokvpY2ECXcRotBJhmCu82RXt1TPMf84rHVr4	10450	14725	14725	1618589700000
20799	3NKHBJKNURUez4LyXRusEdkKjZiW5G2mNxmY38tDLTapawsjrsy4	20573	3NLRaxrwvPF6mrDsvJZcUNqSG9wrFCUHfhRMNL4apGds3DLyQ7sN	1451	926	370	12463	13090	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10315	14729	14729	1618590420000
20807	3NKwhFGX8Fi52N29ySEd81tqFdUHBHafPTtXT47BqoQMccJgLLyE	20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	596	1306	378	12463	13097	jwPQZZ7tmKxPhDf2wxaBjriaFf3QUr94yV6W6QsPKSoBcrVUREN	10460	14737	14737	1618591860000
20812	3NLXaSkJkmid3BedGa6MeEoEBzgLe3NRKAsCpoR983uYsiKNH4M3	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1651	1301	378	12463	13101	jwp51mxRxrJf7J3f3C2erbQ4BDR1k7mdL6SuFtC9esyW2k62QmD	10462	14739	14739	1618592220000
20817	3NL6zRxvNPhbQj2RHQo2ZknUHSVX3M5Pkhm2Ufxii1R1hHx6zoaD	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1574	396	378	12463	13106	jw98mLYxbsCUrt5QdvuLSam7pFF3gWQg815GkD4L3gDvwy5k8Dt	10464	14741	14741	1618592580000
20767	3NKfqz8Cm2dGqJchuwieQZPqVyJg8BXRue28Au44t3uSnxsh14W3	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1633	1144	377	12463	13063	jwqF9u551BDDPrwJvkBJhZ7fU9Y8UKrEQYYCcUtGpb2vu39ahGX	10436	14707	14707	1618586460000
20773	3NLbMNvSfJEtNSLsi2M9tSnoM84eSmZcztVQKrC3eQW4FGhqwY8w	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	576	1109	377	12463	13068	jwuARzsSUDJrdpJjKWxumWQ9v5sbfoRJiWue6LsTerQ7S3e4gfh	10439	14711	14711	1618587180000
20778	3NK7L4Gb8A7iHT7hfX9n5MkHxeQKQxNoZqYosNqHWamH8kaQ16Qi	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	210	210	377	12463	13070	jwGiZNqMtovo1boqJnMkLMn7bJEHM8UQwP7jDDBaQ8rpNX7qZR1	10441	14714	14714	1618587720000
20779	3NL7Vcoaz1ffzT4trwC1gTwnXxpebB6V3eNNQrXojV8GUK1BJBZY	20777	3NKyhCsxZF8b767Ay4A8x1HYV1t37ESbUryZ3H1QtkxB6AsgcLHw	1631	794	377	12463	13071	jwj4MNcU4QMMSdduEGrBmEYEnNy8vHM9X2ijh2tJfub4dUq4Fe5	10442	14715	14715	1618587900000
20780	3NK5uYbrTreqWtE3ruhmECPki4t6xNuj1vBqJo3z6B7qgyCDewne	20779	3NL7Vcoaz1ffzT4trwC1gTwnXxpebB6V3eNNQrXojV8GUK1BJBZY	1403	824	377	12463	13072	jwr3a3CQLHMGG96rpkocd4WQAs17e9wtD8cKBGYdD7DWrcd5BDM	10443	14718	14718	1618588440000
20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	20780	3NK5uYbrTreqWtE3ruhmECPki4t6xNuj1vBqJo3z6B7qgyCDewne	1646	1354	377	12463	13073	jwp1YyMAuqS5BqiRZaH9i2WAPybcqE9Cmt3EjQNoN5Cm5xAY5HF	10444	14719	14719	1618588620000
20785	3NLxjWzqAqubmMuTQZRzCcwQwpd3FKWKtZsysja1VzUPVai9WYpi	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1637	816	377	12463	13077	jwDk2YE8B8Qfz1ssMtThAYwEtPURpBHyq2q8qCzkm134xsenfb2	10445	14720	14720	1618588800000
20791	3NKAZH16FAAMQpPJHHDLUKMzDERLP9XVqYD3quu36Wz31qJJ16d4	20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	1422	1337	377	12463	13083	jwCGYj8mzVZ2PtKpz7UJXXk6hs7qrrQavvxWHvBCdRNFFoSCUrE	10449	14724	14724	1618589520000
20797	3NLedLf4m4FE3dEA3vpPdSrzsDFeGJ1fiF79PJ1VMPp9N4hxDbMv	20795	3NL6VrLbrEK94MfxVKQSmaXXKE8d9Zg2dPHkM9Srd3D61DB9Hxr2	1402	796	377	12463	13088	jwwxxNWUUa5qFNNwtCaYyiN8ZoEm6h62UuKifTZXDv1CNhcvNhj	10453	14728	14728	1618590240000
20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	20797	3NLedLf4m4FE3dEA3vpPdSrzsDFeGJ1fiF79PJ1VMPp9N4hxDbMv	1451	926	378	12463	13089	jwjt4uMK1E5ZdqY1XKLYrcwZtHC6wLf8N8g1ZRdw6vjePDNHDZE	10454	14729	14729	1618590420000
20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	20804	3NKLR9KVUi3uJPVVmMx1twxJNqkkbtq3imezxByMvtbYThE9kLdt	1406	1393	378	12463	13096	jwoNUPMNpCDqbbSTubqakxxa3TdQN3gA6o6aGYgHd4K549missC	10459	14736	14736	1618591680000
20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	596	1306	378	12463	13097	jwKn6V1HLhpx8E39pZ6uuVA7U7yweNL4ZeujD4Bie6kzgqyVxda	10460	14737	14737	1618591862392
20811	3NLne7hb9sMz46dPKtJEFb8dZF3bU4dLm4iQenFSLwa6eTS7oA2F	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1651	1301	378	12463	13101	jwcrwwYf2HdmeZQyrTsTRJ9kgDbx5T4f7vikJbJmFAr2yvEAMZA	10462	14739	14739	1618592224450
20816	3NKv6NTi7i4WzMd5UWtv8Sg66ipghV53XxKDnhpjPTkqjg3LEsoE	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1406	1393	378	12463	13105	jwkDtX14eH1KoAUhxXmKfRDbqY2r8R3KcSmF82p1DHvqjKcENJY	10464	14741	14741	1618592580000
20824	3NKV4RzgakspGVYVQzAxyDiuwKtTRkyrn4XQrMaWm3U8amAnjd2z	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1490	1028	378	12463	13112	jwkrbfUeE5VLfu8k2yjSn3BNxUugheGKmAVTMbM1uTd4qnPHs4Q	10467	14744	14744	1618593120000
20831	3NLZPcqyP1Dkv4xaac8sYhnCemLfM6fUQsAdtueEGrnKowKVQUVw	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1439	1279	378	12463	13118	jxZmdZpR6Brvx7N3yrEdvWsRqwf8E6eNdeGqxk6XdjcQXA52XFf	10470	14747	14747	1618593660000
20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	1405	873	378	12463	13122	jweQUCenY3cjPJU8g5RaqnbRAWku173krYX4fKv5iTYRsM2jpNt	10472	14749	14749	1618594020000
20841	3NKYsRnKvqnS3eBSfYcLs3YHL8ri1VFy8UTnyYWagnb7KC4kRtCi	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	1617	1288	378	12463	13128	jwvqckZUwzC8JwycP5VNC6VwthdeJ1Pg3SVFi5nMdXhXfSVjK6h	10474	14751	14751	1618594380000
20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	1649	571	378	12463	13130	jxAT4CDSUf1xRsdMsCThC17E68DUM6VEkrsHrZL5GYEaC2q5g9N	10475	14752	14752	1618594560000
20848	3NKpF43nXvC6urWSBPmR8dcMjdSQof2nDh3CHxTPWVGAinkpKUu8	20836	3NK4BZX8ytPGfY4yNSSTNA5tu5rEN9xLQwY5kN4FsFKYu76S1qjq	1633	1024	376	12463	13134	jwHsP3HS8rT9x2rYYHabD7hFhvuBpLkAVYquPAP8LLz5bGMKRcC	10418	14756	14756	1618595280000
20851	3NLdbRe347dZS77tG1iaXqbd3s1cJubQBWNid2mKBsDzXkPNpo8E	20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	1617	1162	378	12463	13137	jwkShzYkfYrtkzRiZHHdLVBPQhqmFeAeRrqfuUWTxutps1TFDgp	10479	14757	14757	1618595460000
20857	3NKFN3hwN92VYoBAKPZEeDw4M9qVpNZCeR2vTLDfvk1SBF5i41rG	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1609	1333	379	12463	13142	jwcNY7k8ogEvJy8SBMVe7EF6tNLNY48vzxUn2BokcNLC1Fm4fQF	10482	14764	14764	1618596720000
20863	3NLiuKn5nZ7MHVXYwwjKb1W7rZZLsMtPUZoRvdougPi8TemQtHP2	20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	1587	1357	379	12463	13148	jwgEyikDL39oiFNMd97EFt4RSR7HBG1kJaxqq3ZovumyALjsWGY	10487	14773	14773	1618598340000
20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	1403	824	379	12463	13150	jxx4JSYJrHEfop49ANZpgGZvV18gRjDT8JJCSFvQN6FyfLpxovT	10489	14776	14776	1618598880000
20870	3NLewBQj8W5YfFuu4ucbEiNFaMnfEr36bX8RzbPKguukbQ2wH1kS	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	1501	1234	379	12463	13155	jx4zhKC1qMTLJoMdNFQF8tD4dgqV9JEsogzX1HoRZRjrFqauiPS	10490	14777	14777	1618599060000
20872	3NLRGUa8AhFj3CvXYTWEz14ouPsLDeq6ujeBPgPRFMK53gu4jTnn	20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	1426	1364	379	12463	13157	jxRKBwjLxVJ69WML2hH6FgLx8hD63gFgvM119GrmbQ4PtJDnGX9	10492	14780	14780	1618599600000
20875	3NLnH1gmaxG5w1W1stpvjiPnht9jjcRRpGMffzpbEPLSoq3DvPck	20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	1671	1119	379	12463	13160	jxKqTE9rgpxkuYJdQFVnTf9Ejzj8XHQ86SH9edVToEbD8Pe1p9t	10494	14783	14783	1618600140000
20880	3NKYvucHQbnwCDMfzTe9ggDfApNmw5FLezNi8RJLNHQwA2APavok	20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	484	1319	378	12463	13165	jwqhXF5UFJX1qWGg5pnzSqsUvtZkSC8eKA4bPRD63Dkn9MfpNLu	10475	14785	14785	1618600500000
20882	3NLWqQgDq9ChcDcNxtHFcHD94FyYiXjDtynnvx1i8MofeVwVG4CF	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1467	1250	379	12463	13167	jxzGp4HcQ8B62RBDdoudBAgF5CN7qtU5wQxwu2PHWJ59msakEA2	10498	14787	14787	1618600860000
20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	1447	1219	379	12463	13171	jwSWAeV2fNehAqVPB4xDCQ71scxGbUEMvzUy2ojhQMHzmTYncKB	10499	14788	14788	1618601040000
20889	3NKDEKEVihfB7z94dodVrJBwgQQuzk3TkVU9MU37HS7rRENw8qpf	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1451	926	379	12463	13174	jxT3tKvQ5VZfQDyUADkX4JTMKb1RZ9c28z3eHsGnBQrh27p2Mka	10500	14789	14789	1618601220000
20891	3NKrXqVYrPvt5GUts7DMcZWPSki6tYp93K23y47Jp3mRBEAZcypb	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1403	824	379	12463	13176	jwDxxNBymyY1r4KYn6ru7Nyycq6RXdxcd5nvjW3qsRsMUkN6U1s	10500	14789	14789	1618601220000
20788	3NKnLTxKpbBNarhzhiw42qX4w7SNY5Zkb3iR6AW1u7Hu1tQuRWFn	20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	1613	1103	377	12463	13080	jxtVh9KbinLET4W4uef5znawoFecUMgQ8aEj5WKBbYzzPLDxJRQ	10446	14721	14721	1618588980000
20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	20793	3NK4wsUmfo4TeLDBRmWFeyKLwp7Nz29XgFuLujpkJZKx6TpAfKgd	1406	1393	377	12463	13086	jwgQMc77Ti8FsN9zLQuaGsWre3bQ6emhFfPZgPV9xHYPLayZKPe	10451	14726	14726	1618589880000
20795	3NL6VrLbrEK94MfxVKQSmaXXKE8d9Zg2dPHkM9Srd3D61DB9Hxr2	20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	1607	1102	377	12463	13087	jxXHspHb84zcGZKYhDo89rG9e7A9kZCyCzztAFUzhtDZLWjVrzZ	10452	14727	14727	1618590063495
20800	3NKfGgXkSEwdJgPcjUetBZ3LbkC5T2cc6mo7jCPoRLVQ3GLrJao4	20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	1406	1393	378	12463	13091	jxzqKyHLMHNGe4yvmx2G3XjqNYQXbcAqDXcWvmBW1sCiaJeynhq	10455	14730	14730	1618590600000
20801	3NKxkbz9dAiCPSknR6Z8Jt7uQYfGa8VYfrk16xhpaZRaeB5NyKaG	20800	3NKfGgXkSEwdJgPcjUetBZ3LbkC5T2cc6mo7jCPoRLVQ3GLrJao4	1599	1041	378	12463	13092	jxEK7xjRsdv19wWVpPY825pWT1p9FaNqcLTwyFLaSQo8QPgvTBx	10456	14731	14731	1618590780000
20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	20801	3NKxkbz9dAiCPSknR6Z8Jt7uQYfGa8VYfrk16xhpaZRaeB5NyKaG	1634	1331	378	12463	13093	jwaMBwTDSvS7M1qYg8ay92AenYEzpc69YqToKedX6NJXXnu8AVA	10457	14734	14734	1618591320000
20803	3NLgvbyEyy6MoqUWy5vvLnZ5Dx76LVBkevBbj9WGuf7y2iFzhkhp	20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	1426	1118	378	12463	13094	jwHPYbB5ujut2cppuz9t9jAA4ifqUvUv3FgWjeYEDGGBHXEacZE	10458	14735	14735	1618591500000
20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	364	364	378	12463	13098	jwuvit4z6uKdD9DcbxpyJruciDY7FKrw7k1QsGv1gybTLjNYbbk	10461	14738	14738	1618592040000
20809	3NKPyHV8bwiM32pyMatSt5iuV4hgS1uEBVXhV8NWzxpkQVmVWiy3	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	404	404	378	12463	13099	jwYkjNmvTCj4eAbH8PNcbDMUZCLsXTnAvgc2fw5wFvgD9Mik6Q6	10462	14739	14739	1618592220000
20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	20809	3NKPyHV8bwiM32pyMatSt5iuV4hgS1uEBVXhV8NWzxpkQVmVWiy3	311	1181	378	12463	13102	jwbfV2AaQ3iaSq4Ze66SisD7ohvFhmqgF2GP7BmmBRoVj5EsgAs	10463	14740	14740	1618592400000
20814	3NLZH8sZDweybvo3izRdx2UJyH51G29VHbmkFEfTB9HW2sHvdzwV	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1542	1304	378	12463	13103	jxW5U5vwCqMMtHmiCzS85Q7yoXHegmwH1KP6h4J8XDhyXSCcVgX	10464	14741	14741	1618592580000
20823	3NLTtU6vdMiQohFESxVDgSeYahFSqcSiVhyy2n6JsDGazxnVm9Fp	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1490	1028	378	12463	13112	jxVSjdnGL2yejbph1gJxxEj74vZn5ZHSXSvfx4sft1dX1c9ABbf	10467	14744	14744	1618593120000
20827	3NL9jZ8XqtAxD4mEPfSb6juyL3wEBSuKXi1mwfcQUsnQtMH6fUT9	20824	3NKV4RzgakspGVYVQzAxyDiuwKtTRkyrn4XQrMaWm3U8amAnjd2z	1617	1162	378	12463	13114	jxSKdfmq2AotrnKsz2j6LCNWMtEn2Gma3fANEcwZBt2Hpize6YE	10468	14745	14745	1618593300000
20830	3NLKTkrFqEwzr7taqtiNWQCPhkWaMkBDCeqTxaccocAENW1AU37r	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1529	950	378	12463	13117	jwz76ZSwPgY7bPctCih23MCaaAckzkbWmMQYGVghq8rEpTfZ9xG	10470	14747	14747	1618593660000
20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	1457	1391	378	12463	13121	jxW6HKMuoWUFb4tzNxdc5NAQNfCGTCCvHJYeCEhM5wg991S9e2u	10471	14748	14748	1618593840000
20836	3NK4BZX8ytPGfY4yNSSTNA5tu5rEN9xLQwY5kN4FsFKYu76S1qjq	20763	3NKaBQrPvNGEcdyyL9si6tLxw5FVqJhqjYiZy8aveqKYdUfVtDi7	1633	1144	376	12463	13123	jwvYghUem3YbUtPi9woVqF127MWVdvmTj16UpDAG95pY2eg1ere	10417	14749	14749	1618594020000
20840	3NKaSHTgBebKg5dou2aXcP5ebQpvRowMpqB4qR6GBjvsftaUwyh7	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	369	946	378	12463	13127	jwP8oy3zAmRYHB2YQxMWursrUPVjAviLPUyVXsxLAVkT1gPAdfo	10474	14751	14751	1618594380000
20845	3NKbkWHQSpLXRwyLsMz7Mxo3MEtHhij25tXGWut2oWpzRwHPhLU3	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1402	874	378	12463	13132	jwwneH3hgqWj11W1FLFboe6YqcKMtfYyHZFU83cSti4jPN4tQy9	10476	14753	14753	1618594740000
20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	20847	3NKRxgRtQhED3BYd384G4Jf1K1ENh8NMdXdWEyvAWs4EtUYN1hfs	1633	1024	378	12463	13135	jwuKbeo773Xmq8jy3Z7XDJGqAAmvbKwZjDaFkytUKwVTFCsekgh	10478	14756	14756	1618595280000
20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	20850	3NKEP232gDsxQCCv1QVLmfFFhyfqHXtGZuLj4zSW2XkRxTgziGsU	1546	1339	379	12463	13138	jwUMNp5Kian565fBfbQWa8hBmSYJgE8MUvEv69TBCFpdSMMo7ii	10480	14759	14759	1618595820000
20853	3NLtwNG4kdAfNLy4NSU5AedjdP1FThQSviQrUjEcTEq2bc9FS6a3	20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	1426	1364	379	12463	13139	jwXAz3UBUt5KQ2s35393sTekDmrFdAD2ahKGtszCrSELh56JZ7K	10481	14763	14763	1618596540000
20855	3NKXQQ9EEiyFTTmq942fqVT8vR2z6TH1TK7if7o4b21YkemGQRy2	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1527	1047	379	12463	13141	jwiydPorJEJ3PRrLHvsf2uR4nw4ke2maQWQVPKHwfmhBQrJUyQr	10482	14764	14764	1618596720000
20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	20860	3NLNJmAmUEiDxLbLeGbtrLViuw8zkFNXKBdLMaLvdHDE4qfbt3rB	563	1113	379	12463	13146	jxABdB7WWnYoSPtFp49YGQU8ZbacBjbYwdaW1PmiN6P9meFquZK	10486	14771	14771	1618597980000
20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	20862	3NLKDypYqc8hXCzZPMm8mpJGABUimvrqWWgoxtGqDsV4nxQg6JRA	1581	778	379	12463	13149	jwiTkM7q3ynUw6sQLwqCak29u5DKZASNzM52s38DUdRjUdsiBVk	10488	14775	14775	1618598700000
20869	3NL61ngUG8tTanMwcF5g4EoT7bEBVni6nyeSdSHrjCZ1rSvoe28B	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	1460	647	379	12463	13154	jwo69gSWG9G2ajKh6njEHztZAsfqgZ3G1kWhqKvMAMcX7ygzgdN	10490	14777	14777	1618599060000
20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	20870	3NLewBQj8W5YfFuu4ucbEiNFaMnfEr36bX8RzbPKguukbQ2wH1kS	1560	1291	379	12463	13156	jwY1BSRPG4pC2dJdYMJevujo9oBgmUej9jhLQV9KszpyHQDohFR	10491	14779	14779	1618599420000
20878	3NL5EsaHabbyw93HPqtz7DfG9PNVcYdoHcrY8tWv7wcbw9qYUbyG	20876	3NK8xh49FVz47j2fzut3U1amiRDWf5zbSGWMQoBknhVKNxpv6HGP	1444	1135	379	12463	13163	jwbqGnCyYx7XfW3JUa1LjSvbGdR8MVudze2pXb33q2PQeB3eu9P	10495	14784	14784	1618600320000
20899	3NKpCtg9C7CQWz7sGVb3hb3jFYwszHdVceJ2XbSPEH7qm59cCAer	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1509	1320	380	12463	13184	jxmPFumVSFJH66xiCENCfwmszEFEppdvmwhFLLbX4GW6D46RGFd	10506	14795	14795	1618602303025
20903	3NLhKz3Lc4xZRUdvr1ABRStFR4i6DZHxawedbFpzcPctnpQcSQxA	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1509	1320	380	12463	13184	jxmPFumVSFJH66xiCENCfwmszEFEppdvmwhFLLbX4GW6D46RGFd	10506	14795	14795	1618602300000
20906	3NKTCV2vmh2FtoReengpgnh83h6gxJGEjNGZSqgcbTRXJgn1TPkT	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1668	1004	380	12463	13189	jwiUW1bcjZrXLn8tsmeM7xJ4ZLVDQTKmSBQ2yr1BAtfUPbPbf2H	10508	14798	14798	1618602840000
20908	3NLhNuj2RoeTNhC9igQNkYBywCuTedSg8HgLB8kgBEj5JwLnEAS3	20906	3NKTCV2vmh2FtoReengpgnh83h6gxJGEjNGZSqgcbTRXJgn1TPkT	1407	1395	380	12463	13191	jwSjhxasJMUMzD88vZa4jRpWrnPUnrHmuTjM73K41ji83R64Fug	10509	14799	14799	1618603020000
20912	3NL3JQg2xkLKSYJgQXYv2pTTpcxsEUuMyTssEzqEAuGiGP1cBBpJ	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1514	39	378	12463	13195	jwD3uVbkjFLCHhuBEjoUUsXoda3QZcMm6dtDiYG9pnqwNeANbYW	10467	14806	14806	1618604280000
20789	3NLkkh2L3555TGsTYmgBbHs5v8yDEMhGygAnH3ovLTCfQ7bg5H5D	20788	3NKnLTxKpbBNarhzhiw42qX4w7SNY5Zkb3iR6AW1u7Hu1tQuRWFn	1546	1213	377	12463	13081	jxP12PM146bGh1kURpRdPjG9ZvkoHeXqDLEx9xm8D8jVqnd5pUQ	10447	14722	14722	1618589160000
20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	20789	3NLkkh2L3555TGsTYmgBbHs5v8yDEMhGygAnH3ovLTCfQ7bg5H5D	1406	1393	377	12463	13082	jxJB8uPyPBLuRuCbZEbF8DGfGdn5GSCH9qb842AY62xFfb5Yv5k	10448	14723	14723	1618589340000
20796	3NKpzu6kW9rPvumc1wtxXcsDXtJRwoAmF8M9MoCsC73mkKND17su	20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	1607	1102	377	12463	13087	jxRqg79EzZC5PRPdzFveGCBsyLQdVLbaUAiytQU7jdSurVijPuA	10452	14727	14727	1618590060000
20804	3NKLR9KVUi3uJPVVmMx1twxJNqkkbtq3imezxByMvtbYThE9kLdt	20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	1405	865	378	12463	13095	jx2tsCxqkzTtAb88pyMWNc2E5XgNYN7h1RU58Kg2NU45MnMp2Kr	10458	14735	14735	1618591500000
20810	3NKEsnJyYFHV8sbZksNXWbLkpAeq5p8xMSUK2oUQZSRUVgYMcikw	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1406	1393	378	12463	13100	jxAoQafMENjVHyFTLNHqgZrf1JnPJF842HSKdtmg9YRMJmQKRWY	10462	14739	14739	1618592220000
20815	3NLTq8GaUroi94iJtGyX9SF9UY9KEZx4ZBwSx2E1xRwNcTx93GAg	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1600	1372	378	12463	13104	jxhFmVDHB3SdL9NXpkwNXetqcCLTSqcQdJvYbujotCUbLMQmY6K	10464	14741	14741	1618592580000
20818	3NKrnQVxR56Ao22wEiW5pB4UdZy73E6fNXn381LpSKPuXoHQYA35	20735	3NL2jbFYwCrnBL5pL4p6NVJJCg8S5zq1mai8GpWRpXnFNnyDXGFY	1542	1304	376	12463	13107	jxFpCqhT8i4Xmd3vgFr3KiopztoxZ3mTEqETMWfj6g4FwG8XK1r	10423	14741	14741	1618592580000
20819	3NKTbbpLiixJiPvcD1QekqcJgaqHZG9HpPbffNvw53cesbv9QJUR	20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	1646	1108	378	12463	13108	jwrihj1FdLxKiYMTq9gCK1D3oDa5My79i3hqvwf6WVWXP6c5wyq	10455	14742	14742	1618592766996
20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	20814	3NLZH8sZDweybvo3izRdx2UJyH51G29VHbmkFEfTB9HW2sHvdzwV	1646	1108	378	12463	13109	jx4dq7aZHE5WKr1wk2dxVE14THhtNdvDaceAtWxeydEC7a7wNEg	10465	14742	14742	1618592760000
20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	1407	1395	378	12463	13110	jxavedHpFQSbBPSs7QzfqE97DoSnc7cmTDRHQrZzMp6GbhggDEo	10466	14743	14743	1618592940000
20825	3NKCeDK57Zbmu2jVS48vZZWTV9jVQPawUZWD15743XjWxAnqdjNf	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1476	1245	378	12463	13113	jw9ENV2zddSBEbjYvfDWCxnKLJ7wqrG6MpwMopZ2Feor5a7wCKx	10467	14744	14744	1618593120000
20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	1589	1286	378	12463	13125	jwQWatP9X93w2HguvoicwvgUCgWxUtvcEAqUZxsASMtThDMHKwN	10473	14750	14750	1618594200000
20846	3NKiCncspzU647S85zuC8FSXnzWqPAHM8NVqUgvWAzs69wDPDEzb	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1460	1078	378	12463	13131	jwGqd6VCxcbzRw637gHBz9S3naMSABDv3PJZar95uk2jH7Zug8u	10476	14753	14753	1618594740000
20847	3NKRxgRtQhED3BYd384G4Jf1K1ENh8NMdXdWEyvAWs4EtUYN1hfs	20844	3NL1AfwD9g26UfpPc7sfMvXmiqmNYvh1pAccw2a2RCSUpUfDMcWX	1403	824	378	12463	13133	jxdiUZF9quNKVdiQZVTcYf3qXQvczsBg21zHi6tNVZvDaxretva	10477	14754	14754	1618594920000
20850	3NKEP232gDsxQCCv1QVLmfFFhyfqHXtGZuLj4zSW2XkRxTgziGsU	20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	1406	1393	378	12463	13136	jxCoNwqRumRv19xB7P1D8AwhZ6UFovhcXpfhNgNafuqj98UEEkW	10479	14757	14757	1618595460000
20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	1407	1395	379	12463	13140	jxPK3h4ZQQjHNQwuSs6y5HhE5hBETt1G1qfFKm4syEKzQ1PKAGW	10481	14763	14763	1618596540000
20856	3NKFLgvw1aS2yx5eT3B1ADqKR9Xr6wq47VE5vNAsN2fMgHUJ1gEE	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1527	1047	379	12463	13141	jx9MLGpVBubjKT6Hwz94roHj4DH8ihXiSvNFKNJoTevhMp1s6fA	10482	14764	14764	1618596720000
20858	3NKoLBcNXmrBqvR3YTyt6zcwFfps2k2RywtN2MRxrsZ5QZXcadNZ	20856	3NKFLgvw1aS2yx5eT3B1ADqKR9Xr6wq47VE5vNAsN2fMgHUJ1gEE	1594	1080	379	12463	13143	jxoiZLwHXvR3kX4GQn3TVeAn5CApZgBjkmwoEwUUB9xgoziu2hi	10483	14765	14765	1618596900000
20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	20858	3NKoLBcNXmrBqvR3YTyt6zcwFfps2k2RywtN2MRxrsZ5QZXcadNZ	1406	1393	379	12463	13144	jxmUkEBhij8Fffcn7Em6WHzwBWjvAwTibJMzVvWX6pHzpKuwRGE	10484	14769	14769	1618597620000
20862	3NLKDypYqc8hXCzZPMm8mpJGABUimvrqWWgoxtGqDsV4nxQg6JRA	20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	1407	1395	379	12463	13147	jwXp6RfpWWmYyXKCebingXRo86MiWAbeLUkYffvxCoxyAb1Jka8	10487	14773	14773	1618598340000
20867	3NL4ucRdAXi6ra9Ko8ECoHiZKZNWTbPLoK7mZXDMmtPH6KuR5NgB	20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	1647	1176	378	12463	13152	jw8V6VFWggQgm3CfKujiz5jRtBSg3q253rDCRQcTmZnVBbof6Wb	10461	14776	14776	1618598880000
20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	20873	3NLVyySuPvYRXfjYxaEyCYYbdpwwVtTG9NEK3RTQsaHyrbotYyfo	563	1359	379	12463	13159	jx4hsbRWUSaJwqTPvZ5Zpe99VkKNhY9tG6x1Y9xoniZDrYJJk4w	10493	14781	14781	1618599780000
20877	3NLfPA49omPkpWeixVdpnG1M8Sgev1PkTV16XUEXGdDyLjgpX1fT	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1671	1119	378	12463	13162	jx8CEZ2iCEePjka5aUjpUWKspbqgSwyPUvrAD1GruzrS9KAsrZU	10470	14783	14783	1618600140000
20879	3NLgJ1zrBwrghmxPgd52y3Hs8Fq2Q64WZYjgisGGxrLGXVv7UXQA	20878	3NL5EsaHabbyw93HPqtz7DfG9PNVcYdoHcrY8tWv7wcbw9qYUbyG	1631	794	379	12463	13164	jwX52qAToS3FHSmqbwrAHBMoHJFSkQmduBU2w4qhUx2w6GSnpvL	10496	14785	14785	1618600500000
20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	20879	3NLgJ1zrBwrghmxPgd52y3Hs8Fq2Q64WZYjgisGGxrLGXVv7UXQA	1489	1014	379	12463	13166	jwqpuXDvrZwZ6xRuF5dk9EnmS9zTsWGW6AtV7Ghv31ycENk5X4f	10497	14786	14786	1618600680000
20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1627	1259	379	12463	13169	jwkD4nXfVtuqtSWK9ZWckCv1iyoSQW2DEZQpjGrYFa9BXamdxZi	10498	14787	14787	1618600860000
20888	3NLkUK2T3AHPwdUmVfzNbRrB3QJoncKWU36UmiuLeR6mf9yadj27	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1589	1040	379	12463	13173	jxzkng2ngpWkNpzktM4ZdJUaiEBXf98JiayNvPkGDRM5yAZg3Ux	10500	14789	14789	1618601220000
20890	3NL4rBS1nydUm1rzAPT5td4Br1JdzCwieyzuka4uxfmANCKU6wsW	20799	3NKHBJKNURUez4LyXRusEdkKjZiW5G2mNxmY38tDLTapawsjrsy4	1451	926	370	12463	13175	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10316	14789	14789	1618601220000
20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	20888	3NLkUK2T3AHPwdUmVfzNbRrB3QJoncKWU36UmiuLeR6mf9yadj27	1564	1092	380	12463	13177	jxxDAFTsHNg5wbedYAZpoYn5P7hGTP1KmvSE72rBKZg8aREadKg	10501	14790	14790	1618601400000
20897	3NLJ2DQE3g4GPxDFxLHSJNTFbxpd8SpbjJ1egBaceWL7fCHcgkpE	20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	1668	1004	380	12463	13182	jwu6Egj61gdpbGsSTBM5BuMTgXXEAUNgss2WyojSWED4TYVex5R	10505	14794	14794	1618602120000
20900	3NKqcVxCgybd9sfuoJGkZ5TiMVGn8Co7wZ6qX2RhFUbMFuHCGkF7	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1634	965	380	12463	13185	jxkbhhzrH7XLE6jyxfiNUvxSRugVebf53u6dz2meAB5ebc4A2vM	10506	14795	14795	1618602300000
20909	3NKaD7QysyNYsvm8hJ95iYEXpAaDM48EdQGM3ZNUqwM6xEa1J12e	20908	3NLhNuj2RoeTNhC9igQNkYBywCuTedSg8HgLB8kgBEj5JwLnEAS3	1553	776	380	12463	13192	jxaRgnbNxvURXQRPLQd8aScUWJ1YgVUR4E6BtfU36Hji7UQVMTS	10510	14802	14802	1618603560000
20822	3NLc9cPgV5kRd9o4J5oPu4NvNYMpa4Vay4AtY499Us4Z4YyLgcRX	20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	1402	890	378	12463	13111	jxjiZ7pP9mjqadypjayidXoTYYuYqMk8k2MdiiZdwH9a4TZ7FU7	10466	14743	14743	1618592940000
20826	3NKygFUYiCNbhQjefTPUDwXzuVpoSVyLzfxsjUspDpVbaKGQAbxW	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1476	1245	378	12463	13113	jwa9b3m9SxqryZBuWJ9JevnrbvnnJoWXEKNmiVDkdiJ3gmQT4ke	10467	14744	14744	1618593120000
20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	20827	3NL9jZ8XqtAxD4mEPfSb6juyL3wEBSuKXi1mwfcQUsnQtMH6fUT9	1553	776	378	12463	13115	jxXwCfk5BhPEV5zFtvLc5jGVm5qWCLtrEmtJLinXCHJfmDzD9AL	10469	14746	14746	1618593480000
20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1407	1395	378	12463	13116	jwkC3nRYTcdEXh1SEDo4bWFBP6q8g88owUhmQQ4U9qRoTDUpbC6	10470	14747	14747	1618593660000
20832	3NLrKd6Qz6zpWZkZcNrdKWiYRziFeq7xpqnFePQGSTXo2ZYXj7bh	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1403	782	378	12463	13119	jwa4joRkJVxH4rx6w3KoDz48W9Ui7PkqGNsV4LP26wAYmSHq7dm	10470	14747	14747	1618593660000
20833	3NLucwYoyVStjEGotnmTv97XoBjeCkFSCXciWtpQ6PfYVxwKXgXu	20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	1637	816	378	12463	13120	jwsZ5ChiUJMHSmCx9t1oicBAz4agrgUSUaPevq9J7vTRhkzhmDN	10471	14748	14748	1618593840000
20837	3NLgGHY3cG3DarGqLgjCg7hqzbbEdPJ79WeKaT2KKPuuCaf42Art	20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	1633	1144	378	12463	13124	jx6PBstXNRpAvLx8FpTadN1YQ9Kwh2cQdEAVtVFywJJmTMYVSxW	10472	14749	14749	1618594020000
20839	3NLActvtpvk7D47NWzhP6UPE7NK4Bx8RgiBq8qYgMJ3ncp6mvKiD	20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	1403	782	378	12463	13126	jwMJnV1sWERinGNqAzu3vUk7raJtTZ5tNALrxUoXHaLqyRmfkUG	10473	14750	14750	1618594200000
20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	1631	793	378	12463	13129	jw7AG2fUXcnnnU2P4VSrTJUKv31MZL9WFqdPxLdnWwwB8MJpcgL	10474	14751	14751	1618594380000
20844	3NL1AfwD9g26UfpPc7sfMvXmiqmNYvh1pAccw2a2RCSUpUfDMcWX	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1460	1078	378	12463	13131	jxyri31sL8wFaYXZAGSj9mK83gmUcuVHGWbQjGQienXr82ka63S	10476	14753	14753	1618594742899
20860	3NLNJmAmUEiDxLbLeGbtrLViuw8zkFNXKBdLMaLvdHDE4qfbt3rB	20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	1607	577	379	12463	13145	jxyye77WVo564Ghr5p1UnJngrRamftB1DCGo84tBhMnqcocdEji	10485	14770	14770	1618597800000
20866	3NLv99YoBNEYXWmH3eqKWCXnDfKyWjWnQSZo1MPf3yuPfaZ8KgDz	20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	684	1352	379	12463	13151	jxKknQ3jBqR8qfp1e9EA4wwZHxCrKSKHFcqra2FAmDPj9pfGPoW	10489	14776	14776	1618598880000
20868	3NK6d5wAx3S7PvWGGnGTnn2sBSrJcx6XrfSTyafDvUczyRKQuuNo	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	596	1060	379	12463	13153	jxHM7NkL3JgC7JcX6rBEVoX5gUU21vKv9nRn22Vpeh1QCWtT4rL	10490	14777	14777	1618599060000
20873	3NLVyySuPvYRXfjYxaEyCYYbdpwwVtTG9NEK3RTQsaHyrbotYyfo	20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	633	1138	379	12463	13158	jxEZywCmV6ACmM4frJm5fbrqydcn3HM8uHkHQdKFGzRYM49iEpz	10492	14780	14780	1618599600000
20876	3NK8xh49FVz47j2fzut3U1amiRDWf5zbSGWMQoBknhVKNxpv6HGP	20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	1637	815	379	12463	13161	jwoaZHfY5VTuhVcn47vGRLxjH2qoqCpFRwfm9bxHHARd5qduHBq	10494	14783	14783	1618600140000
20883	3NKdrUKyBVbAPnYzXEFrFMTsGUqJMXrM38mpYRAaRoC5xZcXXPYG	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1407	1395	379	12463	13168	jxJ2V2kcacK1HuPFYfT8uNubFvqX3HMuc4oqA773fjQDe6L3hQ2	10498	14787	14787	1618600860000
20885	3NLA3nVadnmp8kCqc2nJrdzQGbSKP2zmVfiLqzgyirGMPdvH6wG1	20762	3NK52JKPChwWqpGu1ecSL3qJNAETShdJQtTvJdKeXPz48LG3g6iq	1627	1259	374	12463	13170	jwEwgRQoBXefJyUgo34xYDFHMuMb927QKZjYBEPMLV8qfieJSYc	10362	14787	14787	1618600860000
20887	3NLMC8QYzhxS7GZ3mtF66SwBimhh5kbKPLaSz2EWnkg8gXVLoUNT	20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	1623	839	379	12463	13172	jxxMjphytd6YKAoMmD925ZAveiBk7qZTNw6ZDoRA6PjT7TFKRif	10499	14788	14788	1618601040000
20894	3NLTJhvGSHb43ATQMYazEPTxwhnrFFFbU3TBwDPLBU4ES4iDJ7U3	20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	1406	1393	380	12463	13179	jwn5JsvChY1GLudyW9ydF9woEyQ2QsQmfNyXLWiZFc98DymfNmv	10502	14791	14791	1618601580000
20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	1407	1395	380	12463	13181	jxh3hW83xPpUjnKiBkr4b7QSxUexCH5tT17ySNH8YpWBAhQ9RRA	10504	14793	14793	1618601940000
20902	3NK64i5pTQnn675YWgN7Ksqjc7wTRPTgUQq5dRDZtQt3vvsnnKCz	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1448	1311	380	12463	13186	jxXeTuj1txQzjWRarMLm5VQbp4UAMMGeFfW5xkJxEvtw3HKx29H	10506	14795	14795	1618602303964
20905	3NKttxxFABiGWbnrK9hzxAvA15eW1t5syPxErW26FhyYJkREJjxE	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1460	674	380	12463	13188	jwtCoN5G78jncg7hYmY2sDaFFZDYc8EdoAKUkv4qdah2QXUTgZU	10508	14798	14798	1618602840000
20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	20910	3NLMpRZ6mDpHk5CHbSs8YRo7hy83AtqT8AgAGYY9fpFi8DDpnDvX	1514	39	380	12463	13194	jw9CmmYohmXgv6oM4jdUfHx1hsdL1jPjxkv82XLLN8reMgHd2ys	10512	14806	14806	1618604280000
20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1403	782	380	12463	13197	jxVQsgdL5c773Z5PdDVgRY1QtbrWcPJ88DWGB3kLJhs7KYHs9Dk	10513	14807	14807	1618604460000
20916	3NLRA6D7spxhC6V9mGtZHgfSBrwHqSXsxqjeAq141vhJwL9jtzhn	20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	1407	1395	380	12463	13199	jxFGR8KFe1jZHb2nbY91Ydh9A7EmPgMHcofmbgCcjCVNdoJ2bAQ	10514	14809	14809	1618604820000
20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	1500	1297	380	12463	13201	jxCoDYrr6EFV7LbHmG8wZsztu8bgY6oJSF8BpTdHL8qiwsVDtU7	10515	14810	14810	1618605002700
20923	3NLtiTCqGSa2SiHhKJCYRyHfg2jqV4k1Jv1eJ61rpPdVXeqdftjF	20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	1637	816	380	12463	13206	jwhsFhqnjDYe5Hn2YSkos7fM7Pu3sFYkYFSdqKai3HzLALMSUud	10518	14813	14813	1618605540000
20928	3NLrnRfU1KxBoEeRUmLgC8SheWHtti4vRmVoXCgKKw5kyWLBg72D	20926	3NLrncRcPthVuHe6EAwmcsUcNpzdggZmGBwqFm4n4gjdFSuSeEZB	1406	1393	380	12463	13210	jxoUi9LCZ35MaQx9bB4Hz7Dm4sQKdV3CRVmDZe4zsUuTwrgA1VT	10522	14817	14817	1618606260000
20937	3NLmJTBEypjEV9DsKTipM4MkWuoDhBYjAfdn6W7qiVjuJ21hmLHQ	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	1503	447	381	12463	13215	jw8hMJxc9Wfddf7wyGz7ubkwW3geDCdmBGUxYt2Nafeqn6962Kr	10526	14824	14824	1618607520000
20938	3NKcBXr3iELFSunYCJ5bejDzpCNnASc3jvkHscw5xikeWAnQCz29	20934	3NKZ1oYeLoSZjwDJAtjY43TLoxmDC3JQNuijpyz9rnC3vPfvUPwj	1406	1393	381	12463	13217	jwzi9Jf917eUHAvEQ27stR8t47r4FiaB155ZiY5jqUCRFto1YhD	10527	14825	14825	1618607700000
20941	3NKck6zs7pzaKYvFhA7GY9zuhRniJsP6h3F7Ns15ABBEW5bFuLUJ	20940	3NL9F9cresPqLgmvLgh735M1WpHKpmVDPw399pYnJA6ayLc6oq5J	1403	782	381	12463	13220	jwax8oFFayaZc6Ly46xV6HirUyBivcFETaQvqbiRxFQsm9RSe15	10530	14829	14829	1618608420000
20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	20943	3NK7GL5wgNWVDhN1xmJjPQVvyeGGfqATq5J4XyZbJGYm5jTbHD6p	1637	816	381	12463	13223	jxfvVRN4WQ6CBwzUc2UPTDiT4td4erEAtGgzZLSWNUmTgsvdm17	10533	14833	14833	1618609140000
20893	3NKeqfRPQ8zUJ1tBE6h7okC4rGvkEpNkb5dES2RZ2pWCe3k9gZvc	20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	1489	1014	380	12463	13178	jxu3h5LXxMDnsA4QPqWApvXazwUHKG6dV2rf8Q6ErmLMCmKGnXJ	10502	14791	14791	1618601580000
20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	20894	3NLTJhvGSHb43ATQMYazEPTxwhnrFFFbU3TBwDPLBU4ES4iDJ7U3	1406	1393	380	12463	13180	jwx7YLtD8EYya7Xmgp55auHB6rT1Myk3PrfqMBLJNMKNbosrkSP	10503	14792	14792	1618601760000
20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	1406	1393	380	12463	13183	jxvMe1vtbMwLyegH1sC7sMHCMtfKEDmvUoeZFHzACapzniwRrMb	10505	14794	14794	1618602120000
20901	3NKZoiKrPbMcSFqi5pGgYiHMhCjDqFQaZaGXMgwa1C5XvSWiHC9q	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1448	1311	380	12463	13186	jwdJUPbPzC9EhRuxRVMRhtjMmHV8hMErT51wa78nSo35E6X423W	10506	14795	14795	1618602300000
20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	20900	3NKqcVxCgybd9sfuoJGkZ5TiMVGn8Co7wZ6qX2RhFUbMFuHCGkF7	1460	656	380	12463	13187	jxbTnQBVqXZhuC4r76Qc4EgqwEbjzUraeu59VXeDzicFeE3DTnq	10507	14796	14796	1618602480000
20907	3NKwxW9fTNeuqiYcmprS6zwBVHbZ28NfVZojRTfD8v1yvpzGyte3	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1403	824	380	12463	13190	jxaCJTVBSRQd65c3Div5DYtUZ8MRnQKfBduM7Adr3mqwbye2dyF	10508	14798	14798	1618602840000
20913	3NKDD9ZvvbGjWaEVEWmXNiT2ULmVDXQVJioUSnxRntqqH2f45ZZg	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1467	1010	380	12463	13196	jy2xPfiRrdk83Bx13Bxw1WPnf3aV6FYnGxzHuXtidD1yAHbCgvK	10513	14807	14807	1618604460000
20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	1613	1349	380	12463	13203	jwP2HrPmis8fnQ7hd79Bo5yEB761s1DfYxtmbqErsLvebSBYozn	10516	14811	14811	1618605180000
20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	20924	3NKLWpadLXbhUtKx2fatYj1gZreeRZt7CVB4sQ5sxtFXLaJP1y2m	1402	874	380	12463	13208	jwgLLZjkba6daiz3GPeen2qJTeioHJdWs1c4Ls2AsT68JnvS8uq	10520	14815	14815	1618605900000
20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	1642	1241	380	12463	13212	jwykn6hChoLzGsg62zJWXjNfKf2qQpJ9ZUz8XY4UM776jDGNZY2	10524	14821	14821	1618606980000
20933	3NL5vkoAuQnJuXysmT8B36CWMSqZxGgykL2AWZkkg3GQr9nW3hZL	20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	1474	1083	381	12463	13213	jxzvYAjN7si1XQySoMtxFrKeJJBbFvwouE72j42bdopiQE66uGv	10525	14822	14822	1618607160000
20936	3NLfQQjHyADsGG3B9K1r4uSuMk623q4ppUNbYvm1n9N5WGN1HxUv	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	632	1382	381	12463	13216	jxNM29w3ADYv7Hu8EP4f7LJcLRkFZ6H5Hb7crhGC3qSc1LKmUuF	10526	14824	14824	1618607520000
20940	3NL9F9cresPqLgmvLgh735M1WpHKpmVDPw399pYnJA6ayLc6oq5J	20939	3NLGd2MEoaXme5C8ouEkPVH7i2pvx9pGx4QxJ1HSvTwrXStn1GKq	1407	1395	381	12463	13219	jwy39iyn3tnAuJ2ToenV5M6khUk9hDmKKSe5FYhUTVTfcxv91dy	10529	14828	14828	1618608240000
20943	3NK7GL5wgNWVDhN1xmJjPQVvyeGGfqATq5J4XyZbJGYm5jTbHD6p	20942	3NKE8wZeJerG3aqmHtrSiZkiLxHE4U4YY1bsQasSifMQJU5J8mUA	1588	1392	381	12463	13222	jwLGMxbCTjVq3LHsWtMjPs6xN1CuWByghNszaBfzns38xycpj7T	10532	14831	14831	1618608780000
20947	3NKbhMKAmFnL5gDtF87nUZxuQwAQzVAG3qWMW56bPLi3UmTKzEhU	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1406	1393	381	12463	13226	jxbEAdmZd3uNhWBWGa2zjW7awmrofCa5FCKCS69JCti94GuQH9N	10534	14836	14836	1618609680000
20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	20949	3NKWMWpnMD6DZUbK1D3q6mnoLAt2a9tntjtZyEkccA7r9U9LdVtJ	1581	778	381	12463	13230	jxkgkovRHuDn77ivZRwgyJfDvFhq3EPhCsAamBs5Ce4d7cgN2nt	10537	14839	14839	1618610220000
20959	3NKeaDbrJPYsVet5GyaDZBNLxML2JT1cMuEFQuJVVBPX5h4pdfPQ	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1489	1014	381	12463	13238	jxYqXwKXuu8f7qaNnBrfbMrRKLiWzGJToqGxHo4BGcGhes65LZw	10542	14846	14846	1618611480000
20963	3NLERiLhBsWAAi1UZiWtYkBATk71XhVC7m3FkLgtSSrkaXoGrWTh	20962	3NLaEWybBvakqmU4cFPdM5kEjnRBVDTLoRnTmnUan9dBUcicpiva	1571	1089	381	12463	13242	jxBU215NqNwLb6jaHC9vkZrF7MhTcPn7cumCzRrrDvsNsSMzCug	10544	14849	14849	1618612020000
20969	3NLrvGLViS5XyKrEiGkL83S9C28Nn11ggreWFQWeD5deeaGSnMEd	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jwi9FPK1q969o4bLVexYK86gnzEKTHdk1evi5RsULtpKtxAWAJ7	10546	14852	14852	1618612560000
20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	20971	3NKriKGBEEVuai6FUftstZFWic3friC2mejx3B7KdbD6FYE97fBM	1646	1354	382	12463	13249	jxeC63APHbUSzGBjLnpQkpFsexpQcJp8yayBmpWbnyPbR7LUhXf	10548	14854	14854	1618612920000
20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	700	840	382	12463	13250	jxmzBn6yVc7RqW5w44SzcxNW34Np99J1b8N3kdPyrgctKPEmwaU	10549	14855	14855	1618613100000
20977	3NLXyyi6EufNT6JrYP9sJKFziWdB17hzT95f6B3rZtWCCTcx16BE	20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	1587	1111	382	12463	13253	jwWMn8J7D5NDv9YVDeJczrnZ5zD3vkEHJZV1GftRzZd7BTwmBLz	10551	14857	14857	1618613460000
20978	3NLcPFRpfG8ce5pgdFDSg1CLCYYta5dYR7if59etchXugrCSxz2Q	20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	1553	776	382	12463	13254	jxsxKijYZE7jftcpscawobkExraPYMwRLh8L7zFcF8e1RRs1P7A	10551	14857	14857	1618613460000
20980	3NKaMWgeYQohvbMwaQ2r19Q3Q33yre5BnUfc2rYLPRgpYvMei9ec	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1426	1364	382	12463	13256	jxSSUZofQDMC4wzyFxamiGkSvr3eWasAN4DGKHugxPx81bskeD9	10553	14859	14859	1618613820000
20983	3NKLFuKWCgDtiu7J2DgjdHAnWyByWZoFWe3dK8PeeaZMSwekrnmV	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	1407	1395	382	12463	13259	jwAXv68P2hmFUjVZP1u8QVPz8Z6ejjqxkcNiHwAT3j7ypApeoYs	10554	14860	14860	1618614000000
20991	3NL7Ne1QKFjruq2bK9NrSvFQjFyDUQuAsFK8iBxYvLgB2B9XC3Qw	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1578	1050	382	12463	13267	jxEN8HFjXuGPjXs7gkqXMVPHteB3zpgfATqNT3nXcACLD4HErN7	10557	14863	14863	1618614542530
20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	20989	3NLVBy4RP3HnwTnsq9uP8oTJ6fjZvfSVnAp2Y5ofc4HLGers72vw	1580	422	382	12463	13268	jwh2odaVV6segoKjT4LLf675LFMHyuCwyhyhKfE7kD6PFVFptXc	10558	14864	14864	1618614720000
21007	3NKgZz9trq9jJ3Kv6Vx6K8PgCGS5CxbxkZ9mZAjuQYNRBTGKGyW4	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1489	1014	382	12463	13279	jxjo6a3ewLeFf8WqvG6qYY4ba6RLAsHjoGPSjT7FW47L39GS9tx	10563	14875	14875	1618616700000
21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1403	792	382	12463	13290	jxu8A17chD6e6v3qSszS28a5Zw2jd9AtevSJuTdLiE2yDCUqP9c	10568	14882	14882	1618617960000
21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618502488
21026	3NKhnvqbiEcnmGmgGhk8VfV4LgfxV2vpKMCAio5j493Gk8aRjipQ	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618500000
21030	3NLGHPWssSiSa8D4PZYg8xBoiw7e3gHL6jnjAFcSfELYLCN5ekdA	21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	1403	824	383	12463	13297	jxMnCTUfHm2uJTz5guj4TXc1sRTFTpjx3hasvBMK5x3jJ5fBi9b	10570	14886	14886	1618618680000
20910	3NLMpRZ6mDpHk5CHbSs8YRo7hy83AtqT8AgAGYY9fpFi8DDpnDvX	20909	3NKaD7QysyNYsvm8hJ95iYEXpAaDM48EdQGM3ZNUqwM6xEa1J12e	1406	1393	380	12463	13193	jy1R1cWgKMFgiqB9MagH2pG7zrdz4ARLUeRZnZBRzEdJkyLQKuy	10511	14805	14805	1618604100000
20922	3NLrnbJyAGhJ7L5UUrByu9eEKzpryjPQq1txUgUtiUkLWEzTj4Mj	20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	1571	1335	380	12463	13205	jwz8C4VrymLLr6GfNmxrARZSQBgj26XkNBdoYwXqYrGgRmr4VUW	10517	14812	14812	1618605360000
20924	3NKLWpadLXbhUtKx2fatYj1gZreeRZt7CVB4sQ5sxtFXLaJP1y2m	20923	3NLtiTCqGSa2SiHhKJCYRyHfg2jqV4k1Jv1eJ61rpPdVXeqdftjF	311	941	380	12463	13207	jwzJ36LmpK6XL4CZiynQb5CUQzYQWpDRZ8C4Hto251sLGvKnBzV	10519	14814	14814	1618605720000
20927	3NKrTJfPub12SMSxzauMyGS9aVzBQJv13GtATdewvMARgw8Rzw5S	20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	1448	1311	380	12463	13209	jxzLpGiXAP23epXvZmLpb36S9eavDkpJ5MhpVG3tCUMPxWgkvqf	10521	14816	14816	1618606080000
20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	20928	3NLrnRfU1KxBoEeRUmLgC8SheWHtti4vRmVoXCgKKw5kyWLBg72D	43	944	380	12463	13211	jwFYDqsjwZukL7gCWnTtWeHMCuEFRgn9EasnUCje6YynW2foRqW	10523	14818	14818	1618606440000
20930	3NL5Gshi3JRb6QZ6jf2RhWFB9d4jpYFGFxW9YNaGtUjG2neeKeWJ	20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	1642	1241	380	12463	13212	jwykn6hChoLzGsg62zJWXjNfKf2qQpJ9ZUz8XY4UM776jDGNZY2	10524	14821	14821	1618606980000
20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	1474	1083	381	12463	13213	jxC97bYF1fbzFbsmj9ftim5UQdgVh8PXbyGua7xqhC3KPut9zeA	10525	14822	14822	1618607160000
20935	3NKeNRAzA15NF2RCv2fdtAe9ZEZxcYL5zDSg6hQEhyJXKpAncmse	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	1503	447	381	12463	13215	jw8hMJxc9Wfddf7wyGz7ubkwW3geDCdmBGUxYt2Nafeqn6962Kr	10526	14824	14824	1618607522036
20942	3NKE8wZeJerG3aqmHtrSiZkiLxHE4U4YY1bsQasSifMQJU5J8mUA	20941	3NKck6zs7pzaKYvFhA7GY9zuhRniJsP6h3F7Ns15ABBEW5bFuLUJ	632	1382	381	12463	13221	jxcVbEBxRYoDYvTRpBQZC1nH88Sje4rc4xFZaQQXeGLP9yDVy9T	10531	14830	14830	1618608600000
20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1594	1326	381	12463	13225	jxHqSbdE8i6nNdLzcWCYLXwCYzQMXPHpeuEjgfks4DSscB2f1aY	10534	14836	14836	1618609680000
20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	1460	1324	381	12463	13227	jy1v38GQmg4Pd6gfrsqjiFSQmHTFHQ6oCRSULRrMZitDqFBUewL	10535	14837	14837	1618609860000
20953	3NKgoV5REeEPYY67K1jwzu6i8BTp4WRWpry4xJNXToJD9UQrxJsf	20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	1516	1168	381	12463	13232	jxhraFNWnpSvHXgkkEpG7sVut6LVc6wuNkN9ogV3N6epJh3w41P	10538	14840	14840	1618610400000
20955	3NLL3EhimWjLZGUdm5pDX6kD7JycXCpZNFSxgnDU7mH4y1Nx2bkM	20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	1546	1339	381	12463	13234	jxE1GjNsTpHyQ3yw6XoeYrLA9pxYMjcDKvnw1kFUpqNHBMjmzqk	10540	14842	14842	1618610760000
20958	3NLU4QtfkGr2MEZKyqpssWEM8nhJqWr994VWpHFEkRHWq3Rkn4xr	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	298	1062	381	12463	13237	jxCuR8K5rGGQBxVo59nL27UqaXhx9FKHpYsWP6it8UXuV9wdVU5	10542	14846	14846	1618611480000
20961	3NL8Vn1WUv9atpEZZN67JNVDPi8jMcSVh25ywKv5y2xjiyBcm2rM	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1650	1375	381	12463	13240	jwnqjHkhvAp2LDeY1YSyhQ6XnhDXxZku4ijaeMJWipjcA3Uqa7r	10542	14846	14846	1618611480000
20967	3NKkwjzGYMN2poTEsHyo23jNHHnzaMHyoJ9ZjvCxjQ4sPyPtq6EM	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	1444	1135	382	12463	13246	jxgBvXPPoKYDDgpWshfS5yATGYiZnEX9ttKsssUGf1UYkHsH5Uu	10546	14852	14852	1618612560000
20972	3NKyRSdPCJrTYbsLgVPxbmZyAGunBXfsihQkRFMNpcf4ASMFfL8v	20818	3NKrnQVxR56Ao22wEiW5pB4UdZy73E6fNXn381LpSKPuXoHQYA35	1542	1178	376	12463	13248	jwnDXUY5kGYo9DRhLkWJZvjo8o3ukUXZW6dYLj6yXMtr5TjLJ9j	10424	14853	14853	1618612740000
20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1402	876	382	12463	13257	jwNo6nVvVSZaakdATgHiBD2h1yqB4HuBAWrYV1v3draMviDjH4a	10553	14859	14859	1618613820000
20982	3NKAwM6fvM4dF2y1QvUGp2sQ4tjE99Zw9FdYrRZMFXVoFj6t2rNg	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1407	1395	382	12463	13258	jxJQJ2X4SCj2jEFuuAe85718DfUJiQDLZQQoi9eqT4KdPgvUisE	10553	14859	14859	1618613820000
20987	3NLdZmpSQsJqvz2tAzSFMDN2ULLS8MiBb5CC72jDVUwECCphRaPW	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1619	1275	382	12463	13263	jx63uqurL2YsBUtPkUqqLbz4ih3KJ2B6FAW6hEmXAwoWGqwfERx	10556	14862	14862	1618614360000
20989	3NLVBy4RP3HnwTnsq9uP8oTJ6fjZvfSVnAp2Y5ofc4HLGers72vw	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1407	1395	382	12463	13265	jwq2rUidzu88jDkovViXVTiz4SwnLAUGRASJY7kafhTerUHR9in	10557	14863	14863	1618614540000
20994	3NLonEYBPYsEsxCs34wkRh9KcWs9nRHDm4kxmCRxjaYq24t283wV	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1609	1087	382	12463	13270	jx71Wa4CxCd3PKoiFN3Tonox8p7a8g2dyiwuu3V324JNcr3WHSZ	10559	14866	14866	1618615082740
20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1651	1301	382	12463	13272	jwrxf9zdR1HfKwDZCU8XBATBhdw8aqheXZYJFHVz3rdYiwyEjNN	10560	14870	14870	1618615800000
21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	684	1352	382	12463	13274	jwmX6S79ybQDz3Dsuf5aCZBd9KmBCcvfgmgZQDGUQ3DNVmBW6g4	10561	14872	14872	1618616160000
21004	3NL2UDs7VTM1RLa3KzxmAQWcgZ3hXXbGYwnGqnsBwPRbcYRV2r6k	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1407	1395	382	12463	13277	jxqjPFCG8zsgrjJzDsn8wszQy7PS9TeGmBQ2tkD5wHBnaRTFnWP	10562	14873	14873	1618616340000
21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1474	1203	382	12463	13278	jwnVKtsFNNQH4ex5MbDXDq6TYNdT7EN9CAXyuUJs4cTKQ3PJxzP	10562	14873	14873	1618616340000
21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	21008	3NLZ6uC82XbGYXDyaTa8bxV6qQVT36bT2bpWjsun5JP7hd6dTKTS	1458	1323	382	12463	13281	jwE15PvqpwQXsjjAkAQb52bQCVCh2JpdVrbaNC1v6WDa7adeSBw	10564	14876	14876	1618616883496
21012	3NKx9FhNZNoSLu5Lj9hJ6BCxYtp1qXdhKi5qPoto1wjwkPScHapS	21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	1656	1097	382	12463	13283	jwQqXWsJHwb9XZTsqz1jCptRZdTtqydbMS357S4Xig956wSPNXs	10565	14877	14877	1618617060000
21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	1529	1070	382	12463	13286	jxAwsLR2qCmG3odNAweJwLxWDbyD8txxRWHEu5PCKDygdrbiYcj	10567	14881	14881	1618617780000
21017	3NLtQPu4fVFgzZFwaXHD7WwRdnSaVWtHLNxQFQRNAbjXaJsmGKEv	20695	3NLpwDXu4BZBFh7CZ2EuZVcvbNAmpynn9xfpSvYcv3Fn7JMwjwqv	1654	1340	370	12463	13288	jxtSqsVc8WcCgMbKm85VSuGvbF68R2MAXpLJkpKkzJvGTbKztwy	10326	14882	14882	1618617960000
21018	3NKTGriW6vRAR2DaYmQBVkaBtZrXuqGENytWnSbJFqvikidXCuyu	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1654	1340	382	12463	13289	jxKkH5dUaw8EHiNEvqfsAteoNaQuRo6gQNY44gKAy48ZMHF5V9t	10568	14882	14882	1618617963331
21021	3NKeMvFLaXBhC73byugxJV37pQJpDsxJQHZjGeBqexZ59WueNkCA	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000
20915	3NK8WZHrLcDwmtYMMqYpyV3ayZiB3xgZuNfroYYnuon26XF2nsni	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	311	1307	380	12463	13198	jw8jpxbvjDHUcQ5HWVJdvfrA8GQWxaWx4ywWVyiKux3bz5DEAeU	10513	14807	14807	1618604460000
20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	1553	776	380	12463	13200	jwzziDZXWWpF778QDysPMZJVu5cyCFriTnwxFJ9ipYb1iz8FBgq	10514	14809	14809	1618604820000
20919	3NKehjTLBDgYLVDdF8Gb5yHyTStNT3CJHfa9dT5WQtUPBLW2mXyq	20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	1407	1395	380	12463	13202	jwqL1PofxNa7PdJqc2W8KiRq8h6dzvBUUf2Ty2yANaZqYZN8FMK	10515	14810	14810	1618605000000
20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	1553	776	380	12463	13204	jxb7smCmh7Gc6VS3QXazcCA4KdKyFAivJ8MiQSUjRxijuFMDJCu	10517	14812	14812	1618605360000
20926	3NLrncRcPthVuHe6EAwmcsUcNpzdggZmGBwqFm4n4gjdFSuSeEZB	20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	1448	1311	380	12463	13209	jwk48ifu6K7Qh79dwMHuyofydUaDv4eLaahm2N6sHLuF67XZN7S	10521	14816	14816	1618606080000
20934	3NKZ1oYeLoSZjwDJAtjY43TLoxmDC3JQNuijpyz9rnC3vPfvUPwj	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	80	1027	381	12463	13214	jwEeibLivu9e6m6LT2zA85pdiKKsD9Dv6A2U9knvD9QKjaBkDHF	10526	14824	14824	1618607520000
20939	3NLGd2MEoaXme5C8ouEkPVH7i2pvx9pGx4QxJ1HSvTwrXStn1GKq	20938	3NKcBXr3iELFSunYCJ5bejDzpCNnASc3jvkHscw5xikeWAnQCz29	1587	1357	381	12463	13218	jxpyYR8dX6QJkKy223jfMJtNVBmxwtHNkijh3ZEcPE545yJ4G1V	10528	14827	14827	1618608060000
20945	3NLjs7iEXPSKzQKVVKVJ5g8uaNP6oZCtLMChPyos8EpcW15rtjcB	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1407	1395	381	12463	13224	jwjHxwr44eqVeNkEvd8GqyXYrEVxRkGqzJPMxvSK82TRHUuCkF6	10534	14836	14836	1618609680000
20950	3NKmkP4vJKc5QzhELJsmSFL8Qp43w4ebsgsf6tkQER8vzVN8u3RS	20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	1407	1395	381	12463	13229	jxWr1JnPyL7KXrS1V39XUHZ4KamJKfC83zfzYq78bCM5C4aJget	10536	14838	14838	1618610040000
20952	3NLsiNn2ZCrqnP7vBKeyVDWQYiJoGfLY1SpjLtBN44DkinSzhS85	20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	1648	1284	381	12463	13231	jxe2P1M1NUGGrXVMhkagM8e7EAUHbQHQvxJQUBSt1EriNQ6T4ud	10538	14840	14840	1618610400000
20960	3NKq2gFWBrTyRrVZkWDupy4fZHbrLrBYvaFeR76sfiEZsP24dc4Q	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1624	1334	381	12463	13239	jwQb75ewMYYrnLhwsTpv7HJqrPCGgUbLupc5hZCM97aGVamnqgC	10542	14846	14846	1618611480000
20962	3NLaEWybBvakqmU4cFPdM5kEjnRBVDTLoRnTmnUan9dBUcicpiva	20960	3NKq2gFWBrTyRrVZkWDupy4fZHbrLrBYvaFeR76sfiEZsP24dc4Q	1637	816	381	12463	13241	jwSaargTVLzjuEeA9PxCBsrupdBKKHq9fWfbB7RcKcDB92SzEhm	10543	14848	14848	1618611840000
20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	20963	3NLERiLhBsWAAi1UZiWtYkBATk71XhVC7m3FkLgtSSrkaXoGrWTh	1624	1334	381	12463	13244	jxfg1qyM1wozQjrwDXhwaS9kQoK4JmN6gGh4WR2H2mRnwxDvJ7T	10545	14851	14851	1618612380000
20968	3NKZEQTCgy7Ve8ZHdYx6J8ZG1oyNpokw4twjf1LXq6Fyof7YEMPa	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	1444	1135	382	12463	13246	jxgBvXPPoKYDDgpWshfS5yATGYiZnEX9ttKsssUGf1UYkHsH5Uu	10546	14852	14852	1618612560000
20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	20977	3NLXyyi6EufNT6JrYP9sJKFziWdB17hzT95f6B3rZtWCCTcx16BE	1406	1393	382	12463	13255	jxawMNv7Bp2MNEMHoydDPXLzUHArVKGGSQfPsX9Sz8m3Q5wCMtX	10552	14858	14858	1618613640000
20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	20984	3NLjJC4wf8m5ojSmyqeueKNzkyLAferbM2Eg39iXG9pjyAiJpyqR	1476	1371	382	12463	13261	jwQogScrGp952JZV4B9qKVx9XqUvS5MgeifnVxMdkB1c51G9Mre	10555	14861	14861	1618614180000
20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1403	824	382	12463	13264	jxqhdN6sBZVEBDPLH5G3R3JKctNt4W5LNFetfcerrfzW4BvxrT8	10556	14862	14862	1618614360000
20990	3NLxrJ2kWPwXi4rqwfPp9eRnngdzAcV7VPGUPTZKWeWo7rPzvM2Y	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1423	214	382	12463	13266	jwg1g5UAeLi1eZGozr3kJgJFHBfmcA73aamJjbESTy5Szdvp3hJ	10557	14863	14863	1618614540000
20995	3NK8eF1gxbnG4ahioNDNzm3xCDn4kt1h9sPwJuXeVXFmqXwUriwJ	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1609	1087	382	12463	13270	jx71Wa4CxCd3PKoiFN3Tonox8p7a8g2dyiwuu3V324JNcr3WHSZ	10559	14866	14866	1618615080000
20997	3NLL93DcPmqhDvH1ouuajCW8LBw6PEhc5eXA3t1dGiXnzsdgnMPU	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1547	1378	382	12463	13271	jxD3fZh4dLD83jaRDENDoiq7pxUi2ATuRuBoEehfu7zUt3Bgav3	10560	14870	14870	1618615800000
21000	3NKW8kMCoQQpX71noNXJboWWgE4jXyXGZeNdRMz69iLeB9FQzEB8	20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	1547	1378	380	12463	13273	jxLXpQCKXQKqtG7Rm9SmsunC63FkZCP8VTJ5kJnb1vb2yRXZn2W	10518	14870	14870	1618615800000
21002	3NKkhgxpD9Ua8BbPAjsHy7YP4WWnxiV78f3P2MoM5cBebjKPRpbs	20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	1509	1074	382	12463	13275	jxbgCJ1neYa81dM5xpSLwCaVPnu2a32FBwCooPXrHkwgmFwywR5	10561	14872	14872	1618616160000
21005	3NLeoPgwNHUn8orBLpNF6DeDoAqWXsStaNZrtLVbG69HuPRHMxpb	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1474	1203	382	12463	13278	jwJ5uTZ63QbjbY6FEyenQTLKbev4YTf52db2z8GhNNNz4Cd6bWF	10562	14873	14873	1618616340000
21009	3NKdBjdcbN7i9GCsncen769vu4NKqp7f9VuX6NQ8tUtzPd5xUikA	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1489	1014	382	12463	13279	jwEBHNFJz3PN5uVySAi3mhEfi33WYwSNSPYp1nrVdPGG1LVixaa	10563	14875	14875	1618616700000
21013	3NKdiHdnXVsr7skHzScWp7bNvzrG2sM72AarzaakdyVPaLji22po	21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	364	364	382	12463	13284	jwRhnCGGcKmV6XtiQHcMJ7ZCZ2FHfhcTLL55ZwY2zuiiZEjWCcg	10565	14877	14877	1618617060000
21016	3NKqvj8NAmQ9asN2DyxNosd15YNuWxzhKhTq3RJ6aXL8eLdpYvuu	21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	1553	776	382	12463	13287	jwF9h1J7LSiV7jRhxJ19BYeGCqsFv3WrkLZxfHPMqpCJonULF3R	10567	14881	14881	1618617780000
21022	3NL3ZkddBg2zBZxCb9k8g4pgn5g9ukvrdZGCeTDY8EJCGE74Hxx4	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000
21028	3NKRErhHvCoTVXYNBxZz1n6GkHbNgzjL8XmCq92nYioen6bWJi6C	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1631	794	383	12463	13295	jx8BjvF567S2X3wAyUUUr8QFFVXzxkba4tCjVA1aJ8Ef6EGT38Y	10569	14885	14885	1618618500000
21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	1451	1292	383	12463	13298	jwTQERGHuz87AC44xH1PJNzyXx8HAFhSNypuBfshrmsHDRocaPY	10571	14887	14887	1618618860000
21034	3NK6R8BNEoFSH9QntbLTKPmAimTfrdNakYdE4tbCu6QVWhTfwNqx	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	563	1359	383	12463	13300	jwkSdEbtRGM72SbTbgpRFQi62f8jmnjsK48Ufmv5rsnHsJZc3zt	10572	14888	14888	1618619040000
21037	3NLSi4Fix3GFppnpGrqRzZkTZrcXUjwdGwQpLGVqsPqz4u2nrofe	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	563	1359	382	12463	13303	jwXkWpzgi3sQak2NahAYsF13i6qE8nHp6EhmQfCBJrnJ9nnNN52	10554	14888	14888	1618619112658
21041	3NL2gNWasjWoFfzTwtoY6pDDjV8sy8qPVnugGkXK4YYVdgwZ9mKQ	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1594	1080	383	12463	13307	jwjYkGJLJNe4XCURM3PKsSpojEXZazPvYpx2SXoMLkiuJxPB57h	10574	14890	14890	1618619400000
20949	3NKWMWpnMD6DZUbK1D3q6mnoLAt2a9tntjtZyEkccA7r9U9LdVtJ	20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	1490	1274	381	12463	13228	jwYeuqRjj6Sdz7gMTdXuwUJrsJJLrksppCGob6sri3SR5Jpmjv4	10536	14838	14838	1618610040000
20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	20953	3NKgoV5REeEPYY67K1jwzu6i8BTp4WRWpry4xJNXToJD9UQrxJsf	1405	891	381	12463	13233	jx4znx4hecZALeKgKyVaFzQLQ3KbfNBVKm9GzoWKHBY8VJZnXWR	10539	14841	14841	1618610580000
20956	3NLipWAi5zvn4gCfqfra2pC6s8HHiN6YrtpYo5RYTmxVP6Czt5GP	20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	1403	824	381	12463	13235	jxmmg1oRj5ZYiyFQ9VPHM91SN5KvNMGxPCj7eXKMMq7whTtVTDu	10540	14842	14842	1618610760000
20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	20956	3NLipWAi5zvn4gCfqfra2pC6s8HHiN6YrtpYo5RYTmxVP6Czt5GP	1657	1098	381	12463	13236	jxwjAAJxQxKKybiuAzjkmzNSN9JunbeyG2pEvSa8WeYy6CWBuii	10541	14845	14845	1618611300000
20964	3NLdU4d2d4RXBKxsEZot8vEYC6AXCkUDFHnyKos8djHuko2dU819	20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	1457	1265	380	12463	13243	jxfCXPKS3af8efCjxULFNmpBtAdujZxBfmw6B4e5c5LWnMQEekr	10504	14851	14851	1618612383175
20966	3NLSoX18rDprkNpUvyHVXYUXgq7ooNBSkFUvP8JmZzVu1ciuduAK	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jw6yJ61RmEHrWw3kmztBz1Cz9jQ8msBXrMxhm98Vcr6UsECiNAh	10546	14852	14852	1618612562383
20970	3NKWt3rQiKYVSjQ8hpggPgPMUPTnTRfyTPtbU18znUhEbLZYhL7s	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jxi5vwGY1enbtzY5652TY2H2bRRQW169ckqDn5YsZQ8cpb4Sojs	10546	14852	14852	1618612560000
20971	3NKriKGBEEVuai6FUftstZFWic3friC2mejx3B7KdbD6FYE97fBM	20967	3NKkwjzGYMN2poTEsHyo23jNHHnzaMHyoJ9ZjvCxjQ4sPyPtq6EM	1542	1178	382	12463	13247	jwHm7v9cdfM3V6PXdJfq8DKh9aGSpf128jHLpcvfZdKdoXadA6Y	10547	14853	14853	1618612740000
20975	3NKk2D9ozbkqEB1MRN5NRZGKEyw6jrRim7cVhsghet2Kz2E2aM3h	20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	1403	31	382	12463	13251	jx5W6qgN17zp9XrFYRYepiZDCvKVKe3DSZpDuJFSuZspu4Mb7Pv	10550	14856	14856	1618613280000
20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	1419	814	382	12463	13252	jxq6TxGwdgTW1vw5dvp5cc64cRasdiv7ad5k8jntyXsYzpjZx2f	10550	14856	14856	1618613280000
20984	3NLjJC4wf8m5ojSmyqeueKNzkyLAferbM2Eg39iXG9pjyAiJpyqR	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	1402	870	382	12463	13260	jwJcA9vXm6TEtDxSPpuAwyf9hRVVcTEbsfn6mGZ1n4VjtiWbEzh	10554	14860	14860	1618614000000
20986	3NL58ZMyosZquW7Jz7mXHtRXy3jQ883HhbEi1iC7vP1iHXPZxKCP	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1447	1099	382	12463	13262	jy2LPnStM5wNKjudZaiuBhNDTbeQMvZjezwQdApw6NZaKcHtNvM	10556	14862	14862	1618614360000
20993	3NKNgmuMshtAyszjdRM393h3Zwgn7L6fk65MmJckYeqTo3HxTyvV	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1445	1164	382	12463	13269	jxKrJCfCU3MpiArtsZYNaKCtnBGc5VGeLFFywyVfSRGXwByT6YU	10559	14866	14866	1618615080000
20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1445	1164	382	12463	13269	jxbz9MCKvsAr98zfWVWjsnFdmyrrhf9vxj5gmbebXZieKZVucr2	10559	14866	14866	1618615080000
20998	3NLdyH1gPDcTDejGwSgM2xqeWffJ7vSyAArcaxU7SLWtzgnMeywX	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1651	1301	382	12463	13272	jxJNixesYPAEvbUmTduFk12nxMwN1w8w7jkDzpcDhRh7HouJB6d	10560	14870	14870	1618615800000
21003	3NL2qLLyE3JscgPt7FHkNuqAgrimM8hknULLkjY8zALUw3a2PyEP	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1402	862	382	12463	13276	jxLqrcec7TaPXi7NqdV5qk4XX9g1ZJmfj5JSvWFa3Crhc1yezTT	10562	14873	14873	1618616340000
21008	3NLZ6uC82XbGYXDyaTa8bxV6qQVT36bT2bpWjsun5JP7hd6dTKTS	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1555	1347	382	12463	13280	jwChsXArVvvHaXPjuABRF3LCxDRgF2ovsbeLUDHLg9bJHcDk914	10563	14875	14875	1618616700000
21011	3NK74WQFAHxrLNysToXk1mcVAL7vMwsiwVT6o18xUJ4ZVbpvJtH9	20721	3NLxtdH3j71TYwYMkGjpewS8jfQVgFg5dCkZ4Qk9dspkVSidMUtR	1458	1323	375	12463	13282	jwpBYo11geqY8kf5WuRxcK4MhKDk6mAAmvNuBndNcujDD1HoqBg	10383	14876	14876	1618616880000
21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	21012	3NKx9FhNZNoSLu5Lj9hJ6BCxYtp1qXdhKi5qPoto1wjwkPScHapS	1571	1089	382	12463	13285	jxmH4cMqc8SQ4Ny51ffL3SyCF2rBzNejmok6tYyFeimm8eNyibX	10566	14879	14879	1618617420000
21020	3NK5k1fckGftcKNd1P4V6TXiG5ZHUFB7tLqthZDLTVqyuNMDoccY	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1581	778	382	12463	13291	jx8BdJQaM7QSzZcFvDKMhvzG7LyU8H6zG1bRvkPGorfaXAkmDAC	10568	14882	14882	1618617960000
21024	3NLVoBCerxR7ac7gYgETNpAtzoacEMQo4bcz8ZKwCVxnhmeVcUVQ	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000
21031	3NKHdQtRLYyDgXkwKJmqpnsVWWwwMbbRzgiVhGmRiBi9EQWvreMX	21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	1451	1292	383	12463	13298	jwTQERGHuz87AC44xH1PJNzyXx8HAFhSNypuBfshrmsHDRocaPY	10571	14887	14887	1618618862546
21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	171	1128	383	12463	13301	jxkkiBZaTmvvPJGbgRCehpj3ZSVzRsLLH9ojcbFz2H9KW31m24z	10572	14888	14888	1618619044531
21038	3NKwwfDcMkGcuLvvmaPrPaneUhD4uGkSwjcDdfepGnhAr2xsYbNh	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	1631	794	383	12463	13304	jxcRKVZqN5fE2HFJwED2yUGWoN3XZbtz95cDdA3AAu5ixD5Ace8	10572	14888	14888	1618619040000
21045	3NLiknDSwKapUebgAT8aFjb2hY72jQdFUGCjXC2eJfr8wvf5xkf6	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	700	832	383	12463	13311	jx8QFKKWmdFDbqVt3uSsudPZ3RzdctDkdqXSagtfUZRJKiF7iTf	10576	14893	14893	1618619940000
21049	3NLW9qXtgKeQQzAYaZActfYg2wyYEh6mWaeaojAzfJy2UxeUWbPr	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1581	777	383	12463	13315	jx3W83gTcJ3gvduY4M9wmwSgGNDgGxXNtVcnRJLnPoH7gKhH8JF	10577	14894	14894	1618620120000
21052	3NLkhYg1UNjP6ssmGGpA3sPAhdjRYuv7X65HDNTmqXKxs8w8MSUy	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	1402	868	383	12463	13318	jx5emGtUmQ75FyvDJbjo3ZzNjQJLWA6QnxCMYu9yA1sDmrzV6Qx	10578	14895	14895	1618620300000
21058	3NK7cTKNxG6SA422N6Knc7heEz2vEEJk2GzeeoGWJtRAdgU2gkZL	21057	3NKwCkx1TVP6iemfwFsQArNipGnyMGx962m6djP2J1Wz3BdGguqP	1637	816	383	12463	13323	jwg4MSMRks4tzgQoJjLxCYRwKZkh1qGfcuE3gQJHchGRFSZzhby	10581	14899	14899	1618621020000
21061	3NLWHvz4bbbiuoraBWCu8cBFu2PLi9bsoN56YBUNvPjARrDSs6Yt	20903	3NLhKz3Lc4xZRUdvr1ABRStFR4i6DZHxawedbFpzcPctnpQcSQxA	1593	1220	380	12463	13326	jwtyXWmntd93bzuxJ2qX1we5z7q6o5LYDwMXHH6s6f1Jwdf46mc	10507	14903	14903	1618621745176
21066	3NKVrFDvGmY9oGJeYwv99TZwJ4aorbFxbKwttD5187f3CTJPG1C5	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jwLDpn3ZAc4z8mxQwitdL2LbGFXBvk42vA4cKR6J65ywCaEBU93	10585	14904	14904	1618621923280
21071	3NLQW6GEL5TftXiBW62VGTSj5cPAPx7SYXLHutRbiKfLe7FiYzHq	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1609	967	383	12463	13334	jxmeP1CSZuWBnEmkRU87PoQibhbcQUdbtLoJN7QyGSU1zoZT2E4	10587	14908	14908	1618622640000
21074	3NLipNnyJ6dy8rMR21y4UNozdV1Qg4ZFYFrjKLGP3QjDwDApjHny	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1407	1395	383	12463	13337	jxoVvXUFiWFLAKB2PDp2Ej8oLJNLaRV5MKwcJjZJY5ZjVvt8TER	10588	14909	14909	1618622820000
21025	3NLRDF69UsAPbWoW3rg36n88U6XLbYthYjM4DVr3oizDBswg9ydC	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1407	1395	383	12463	13294	jxTYzQk8RVdNtVyLxvjjKTqYEAsJAjgog1M5PcLh5Ty1Ai6HQsS	10569	14885	14885	1618618500000
21027	3NKtbyicT1yaxagZiR5APtTk1RHEENKbcWzG2eGpu2ApsUdD7rmj	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618500000
21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	676	676	383	12463	13296	jxTrbuSTDJpgiz3YJibyFkErspmm2H9cn8Lsmnqc9Jf2bXnJmMQ	10570	14886	14886	1618618680000
21036	3NLMGrjxDJ3Dsib4cjt2ALQsg4MzM1c9AJKVCJPJ9aBbYZX8tWYY	20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	563	1359	381	12463	13302	jxiiWEexiy8Sp74es6d4YbwamQr8AfppDBSViWTH6cJqtBRb1Tz	10535	14888	14888	1618619047530
21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1460	522	383	12463	13306	jxDAB3v16Qdg4jcWA7hLR1posantyi6xPSZo7oPdiZpXk6rbgzM	10574	14890	14890	1618619400000
21042	3NL62tkNKbuWDk1BxSQAw2iBeigcWA4T53crUyhjVvr9HySo2PUw	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1403	782	383	12463	13308	jxsU7wW129gEoXzeRXYN9v5NSH9xW2Dv7eBhVrkDS8MhHDFVG4B	10574	14890	14890	1618619400000
21047	3NKZBrWtfnUtMg8W4KMBUnoncN5rFSDeVyipq6R5V4DJyWV7KS2W	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1407	1395	383	12463	13313	jxwTqSW2sx4UBVUsrVw7TxnjfazH88E94fWZT3AUFi79Pcx1oVj	10577	14894	14894	1618620120000
21053	3NL17ikgZSPHkoRJ2oAikc7LTaKmuzaJeh3eSBQEL3vbSFxYiXL1	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	448	1305	383	12463	13316	jxXJ4t1rMA6sqWfbSZJQhTLXFJYC8JR1eEWAAbzhnoUCYDPnR2k	10578	14895	14895	1618620303380
21054	3NKp11PXSyuKK8T8FMjJjSJkDz8bmPUPb8Q6G9x84UKhW55zPvt1	21052	3NLkhYg1UNjP6ssmGGpA3sPAhdjRYuv7X65HDNTmqXKxs8w8MSUy	1460	1324	383	12463	13319	jxodnGcHk68EWH1kifWk3cH7jPMFu4M8gMGaUZgsHM4rYfw7gzk	10579	14897	14897	1618620660000
21056	3NLErh6Sw5mam6xXZ6tRAcpYCiN4Q2TZRTzstcdfoFLRNArnbB4K	21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	1648	1284	383	12463	13321	jwMHedymFQq7AtQqaniUW3iR4YD75VujSiunY8cbwcwRsa7TYjP	10580	14898	14898	1618620840000
21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	21058	3NK7cTKNxG6SA422N6Knc7heEz2vEEJk2GzeeoGWJtRAdgU2gkZL	1637	816	383	12463	13324	jxi8MSwwAmyCTp9659YFWMUUTSB6e8LDLHUY2TXvzGiR2vzdCpC	10582	14901	14901	1618621380000
21063	3NLsfYZp3o7xZwGtuFFBwR1cQG8LfFGH1sc6NnWi2Zpm3N9c95fJ	21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	1593	1220	383	12463	13328	jxvvPojM7p5txWh5otv5xQijhAtf2NY36x2wrQSoRaBY4Z4ZGLB	10583	14903	14903	1618621740000
21067	3NKwHzGdVP8cQA2b8ZHV7dicmGARPphaJ4fvETptoGDM6zEzpdwa	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1588	1392	383	12463	13332	jxESAWs6wwJRuYYeXwiWHnnLHXujiq1AYc2uipSkv4u6DVXtpv9	10585	14904	14904	1618621920000
21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	1646	1108	383	12463	13341	jwKejCozLv2D1JdNqvZceBDSxryuwERW6EXmpeZbhGcKsA4xwLx	10590	14911	14911	1618623180000
21081	3NLTtC3oWNm5E473C6VLTRxoWPCVvU1DJBzBZRnGiN88ypZwfBVn	21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	1553	776	383	12463	13343	jwDCAsfpzWA9hYXtp5qhH6LKSmtRWcHSynzCxWEwNffzmtKTtWh	10591	14912	14912	1618623360000
21084	3NKqnVm5WYtuVdwdVDJxaFtnsHn5LbBFGLFosiqmRbpupd2Du8wn	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1651	1301	383	12463	13346	jxAttThm44M9jD8Z9pCpb3MRDThT3Q1FYGBN2atupS3LUy8mTBw	10593	14915	14915	1618623900000
21093	3NLb7QMw2e38GiqdqMhnPhXv9J5n17yPzgU2GBKjvQH5akk7uveb	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jxH6QuUebK8y2J9G2a1iomaMiH8UN9qhf7pcR9oHTaCjjGxeY8u	10596	14920	14920	1618624800000
21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1549	1362	384	12463	13355	jxG7WDVfjKLxi4y1NJ9RPLtoxPRCCqv7wREG2YzGXD9SF4mfWiY	10597	14921	14921	1618624980000
21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	1637	816	384	12463	13357	jxtRHRcuKHqaAfKWL7Eu2jV2f2yRJ8Zt4DvEY3UansEa5XrU74r	10598	14922	14922	1618625160000
21106	3NLvADqRqcpGHdbEmwPN9yLXDHbiQN5P3oCBku3xkcEaTxbccPNU	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1403	824	384	12463	13361	jwjMSJynZCwmVFutSWLtgRVJ4DEsf2WUUYV77EFXQDbpGT6SxWz	10599	14925	14925	1618625700000
21108	3NKJR2T89gNcq2m2HoKp7nNoZZQmqMKtXiT2t18Zr11hbqngkYu3	21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	1406	1393	384	12463	13363	jx9nvKFDhjuKetgaQVzoperw1oqGU1BmCrEon8E1EXY7RArZdbN	10601	14926	14926	1618625880000
21111	3NLvKqCGUehh64B3e1KdH7WHtFcovziWtEiTSmtfdazJyNujuRUW	21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	1406	1393	384	12463	13366	jxRtwTTW1XypF86GcCvG9hT4GasgzUbVi47f57NbUFywGaVFieG	10602	14927	14927	1618626060000
21115	3NKxGcWTUWwUiV33cDetAX3DZbprLgEuVMJJZHn5xtQ555ADWZs7	21113	3NKc8woWPssBLWBLVm3fQ5QqXkgxtZtsv7twszksLh6senf6ceo1	1406	1393	384	12463	13370	jxMZmrQzJCKsnfSNmjDsUWZyCKSyiNnj4nDiJgWHiPqjYQbqogh	10604	14929	14929	1618626420000
21117	3NLscUmSzAbitXAiS9GfFT12rGzbcWNhw7JJWN62sfR75hkQL8rZ	21116	3NK9YafPiXreJ9zU6yCdk3pGzDEPB67wEKqnQhW5QjRmDkbc4KjB	1403	824	384	12463	13372	jxAGj7wckM51qhHo4cQkJ6rYSvYEEEffM6Gi1GXhy1LDzkBau88	10605	14930	14930	1618626600000
21120	3NLWxJ3MmLxx7wL89xgmQsZBcdT8USvfsaBH3iEazVqVqEDTbhqf	21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	1587	1111	384	12463	13375	jwduQG3ceRXfa1g9Y3u1W9wHbshdk45632dNXLmdVj1NKPkABRR	10608	14934	14934	1618627320000
21123	3NLZgPLcVh3pfVonaJmhWawYdCyd4KaD8933T2LwsqqiXepwacBh	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	1483	114	384	12463	13378	jxcNo2H2tX3BFA6juPck6Tm17keDSPGMyrCS77AzGAdP9brk7xx	10610	14938	14938	1618628040000
21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	1631	794	384	12463	13380	jxkXcTmeJ46yznDZVtsF57V5iFZmxZYYNz7Gv6WLJMshFZ3tBQ7	10610	14938	14938	1618628040000
21130	3NLLjYE3fCq6oYEtQymsaSQFUPexQXrwitJJXLYkfDRfjye2Haar	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1588	1392	384	12463	13385	jxqGyRgrWeVozUSguxiMY1VK1nR1KnJGSPFhBJXyjyVm77rZPrf	10613	14941	14941	1618628580000
21135	3NLAY9Di6aj9FJcq8gWB3MREim52k9PxTPhPqXx64umk6DyutYQp	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1407	1395	384	12463	13390	jxrkd7gBCXCYDuPychZ2HMkJ3GxzmW5b6nszhp69nuFR5FJndhH	10614	14943	14943	1618628940000
21137	3NLV4F7AdRXmiXuw73gw6izmTJrdq1WCX5abk5Cnqa6aK8SGQ5eh	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	448	939	384	12463	13389	jxJCWCYdDaN4hfaobCsC9dxoLxvKZwi2wJNoxsi9ZrE52Hdvizq	10614	14943	14943	1618628940000
21139	3NKg8LJ5EY2jq4d168wnLgxDA1jjAt6u6dZgJcxn1gF2Ab14PY9S	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1631	794	384	12463	13393	jwHSxJR76S1oG22a1GEosQ7FmRnaMQmmApDKfjkM97fNyEpdnM1	10614	14943	14943	1618628940000
21141	3NKq3e1fgwdZF9o35LY4zDP2JEuZtt38Taj368ys6ixTYMGjJ2td	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1489	1254	384	12463	13395	jxo3jwVJS1CozzjtjBaQK84BKbJuebnWVhvGafhJkozAKjrsCrV	10616	14945	14945	1618629300000
21033	3NKyp555sZJYC6aqxZC5E5Cc9vvLjGdpC27PAvo9sVmh5X7Nr2c4	21026	3NKhnvqbiEcnmGmgGhk8VfV4LgfxV2vpKMCAio5j493Gk8aRjipQ	1451	1292	383	12463	13299	jwCuKM5GZSzPuNdBWjia3XnQWTFcuLNvpkxYczi1LvPe86KS66F	10570	14887	14887	1618618860000
21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	1406	1393	383	12463	13305	jwtKaqnJ2FreX39qTTNcCG6csZwviJmnUspLCnRNqqsuiEiJJfy	10573	14889	14889	1618619220000
21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	1406	1393	383	12463	13310	jw8QBF2wLsCgySd8PYTdormLjFZJS1P5qs8XpqrjyAEkrvCB59V	10576	14893	14893	1618619940000
21051	3NKiTADXHUATGCAhjuvkVBnMjAoMTiiXhJj13xnezuXYZuJA58cb	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	1637	816	383	12463	13317	jwzzDnubtwm5Lg5bco6EDFQHBoztajKWrdw7T6XeYa5qR3YJ3Sx	10578	14895	14895	1618620300000
21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	1403	824	383	12463	13325	jwXYo5gLQi3eUbP4auVk4DDdzrazcBbTPUhbMSU9CauGDfdkBqT	10583	14902	14902	1618621560000
21062	3NL5wruVcad8tdWNWgRLPptC9aaXDD3brxvVgznLbJsSZPZZAjkC	21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	1407	1395	383	12463	13327	jwH3U5t2qpns6YXndxfenuUQ1tGhjtzwRdCxCyZxK2mfuiatRdR	10584	14903	14903	1618621740000
21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	1581	778	383	12463	13329	jxGKh528yHE9aaKLKKxmaW7B9xJmf9MkjxurjgPVWgrVPzSTozX	10584	14903	14903	1618621740000
21069	3NKvDjxFDNMW4FfupKeED3N5KqSbuvakZEgcfoVqQVySbb38Rq91	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jxNBQEipWgh2uKVBdziV9r2soYkhVDXStUawHLFYJ2xMEMhfKwU	10585	14904	14904	1618621920000
21073	3NK9ThfUUg7DLQZq1xFerRLAsACjUkbFv5K98x39o4dWUfSEimq7	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1648	1038	383	12463	13336	jwV4zN8CzMULym9g4cXJFe1cNC4UYhErxMNz6QXLXzeYEPNPQAP	10588	14909	14909	1618622820000
21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	21073	3NK9ThfUUg7DLQZq1xFerRLAsACjUkbFv5K98x39o4dWUfSEimq7	1402	868	383	12463	13339	jxG61jTkGcKe8r1zuFW9xPW1fuUvwmNSqGnixQehZvKsfdndvCi	10589	14910	14910	1618623000000
21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	21081	3NLTtC3oWNm5E473C6VLTRxoWPCVvU1DJBzBZRnGiN88ypZwfBVn	1516	1294	383	12463	13344	jwM44EcMbSsEzYEZqHP6YCpyaYnFEZwhchqayzBQFiDPQ2Yu92i	10592	14913	14913	1618623543398
21087	3NLiXynUfxCHmGMpRpjHzA5jYRg3Rm16T8xhk5H1kEBJuRZ2StEL	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624083039
21089	3NL9KeRSDU51F91GU7hbNZ26ee9hSBnUvJ1LxuwP9rp9QoSYavq7	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624084430
21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	21089	3NL9KeRSDU51F91GU7hbNZ26ee9hSBnUvJ1LxuwP9rp9QoSYavq7	662	662	384	12463	13350	jxaFMFxjRbJqNkCmcskJx89vgN3pPQ7UW7XVXToeNCJmYw2Q7DY	10595	14918	14918	1618624440000
21095	3NKmpMnusLFyuw8phcicheumZtbkC8nmxiiPuMLPK7LBVm9NpmXk	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1451	1046	384	12463	13353	jxztECFTwZff7NSDDTpkMPb9RWioQaSLu6xfxhxnGQuc4WMirzH	10596	14920	14920	1618624800000
21098	3NLCtgLniVYcdAhcBWwrcPF5tNm3hjsE37JdbyMRMQqcAJrr8RDm	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1549	1362	384	12463	13355	jxG7WDVfjKLxi4y1NJ9RPLtoxPRCCqv7wREG2YzGXD9SF4mfWiY	10597	14921	14921	1618624983127
21102	3NLrsE1CjXPBNRnMEkAshbpsRVkYNxBuscgisRszUUpYte5yHW5L	21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	1631	794	384	12463	13358	jwUekfm6D7pfovkBXUTBp2WxDtUWETYBS19dwnCgZcftjoX149Q	10598	14922	14922	1618625160000
21105	3NLp2JPkDBCZJsPKH4bt8HR1jPDFxx2pLzEDUoV1sqKRLoqpkdj4	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1448	1185	384	12463	13360	jww25rR8pQFQxE2eQzXA7skvJumwGfVj5PZxZuKMyf5szg2NWg8	10600	14924	14924	1618625520000
21107	3NKDAfUR6q6eQ7wFQacY2HLqoP349pQ5VpPojpw2o8jUtiRbpQT4	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1403	824	384	12463	13362	jwA9JLAb5ohJh7ZBeHAxPC6wLFkAMr845KJ3Az3UDrS7M3jbdRa	10600	14925	14925	1618625746358
21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1446	518	384	12463	13369	jxK2sJqfNH57eTRSsw66c7w7DvEhuZgs3dVQ9tdWM396bnQnQRD	10603	14928	14928	1618626243606
21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	21118	3NKnAE684LWZR7bTcQDkjfh2skTFCJKywxABpux1XWEzUFSjkv3T	1477	1104	384	12463	13374	jwY2yGJuC8pzbxKVFEuqEtWhtMSuywgqXmren1AYY96DyAsvsY7	10607	14933	14933	1618627140000
21121	3NKsozhjWSeeD6CdAHFhSkWp1BZgUsAgwiD8duvaAWzgqvgw5vtN	21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	1403	824	384	12463	13376	jwnAQjtrSyexfirDWzheFYoDUaJpYJ34C9Ays5Pd9W8P1V8QnAz	10608	14934	14934	1618627320000
21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	21121	3NKsozhjWSeeD6CdAHFhSkWp1BZgUsAgwiD8duvaAWzgqvgw5vtN	1501	1360	384	12463	13377	jx3uxEXurV8AhmUecpG8tM7NT9vUBkRJdVWLJzAUVUtwiALxLpc	10609	14937	14937	1618627860000
21127	3NLnrDhovCyzC3Ah9NUoH4XLbryqexsPHhLQoyv4cP2SenrD3dTB	21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	1406	1393	384	12463	13382	jwAMaLRBHeFckM9dcfkKZBHEbjTKkgfwGLNtANiMcmzDws9KGVd	10611	14939	14939	1618628220000
21129	3NLPFEVKUhsraqXhxm5wkAtVrd5cwv8iNBLv9A7rRHZzxjTBW2Hy	21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	1631	794	384	12463	13384	jwksA69LXTxc2KHirqsbYrMnHMevpK4qBvNuy9kEmgbbeZUVsME	10612	14940	14940	1618628400000
21132	3NLkrp8Koi1QumiePoG8aA3AdWWYdF6fK5yz5k7sEgENBD3yRQyg	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1407	1395	384	12463	13387	jxtJKEcFruqfhFXn5W4M7MPQdCgarRAgwX9La9dEYgph9BMhcfz	10613	14941	14941	1618628580000
21136	3NKzakvyA4KFSKTUtsFUhovmcrF7ZCo5CeUQwzBHafdtX6GB19ka	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1611	1215	384	12463	13391	jwcMHJ8kaoxnKNPFTRc968ZMiUzrrmGUzrCGKQH6HR1GeMbUBxW	10614	14943	14943	1618628945082
21138	3NKngzYvbFMsa9TNaBDxebHoDumrbcUjMH8tfqRhWDiN3mknTZ5q	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1590	1300	384	12463	13392	jxrLESu25Hw96V79v79ymrk6vQC6MzfTJwKpDBNikdw4UxGiqpY	10614	14943	14943	1618628940000
21143	3NLNR3nt3NQ4hZjJASm95bh4dmB4rma9dp9XMTaPmLiqgZjeSe2p	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1407	1395	384	12463	13397	jwRa3M1xMSybunqfJDQMf2p1M8btBMcvGapP7XubCegHMjop6he	10616	14945	14945	1618629300000
21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	1553	776	385	12463	13405	jwj1aT5CSpZr5VzK2bGkusfQ11WvmVTL3ogKn7PZ2dTZoJyS2ep	10622	14957	14957	1618631460000
21158	3NKuBZKND6TLceuLYTN4DM9bAHfdkSnM1Q1NvkUgdef6WBaR4da5	21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	1501	994	385	12463	13411	jwk2NnJT41m3jjBouyau8MPkQpbUETZvHdPN1ha6DYX5rnt3iim	10626	14961	14961	1618632180000
21162	3NKsedDCcNRA2j8bqx6dCLFpFhNjN95FMh3nmjNy4n4m3h1k8vAp	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1407	1395	385	12463	13414	jxbzzkpBpTryFL9UCiEuXgF7Yg7E2UgDCA2p8SFVdrjsn2qj5TB	10628	14965	14965	1618632900000
21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	1444	1381	383	12463	13309	jw7sTVUsQSw8c83a91R5sQ21TnJEDCXhgwUGKQGQnDy5fCExqRq	10575	14892	14892	1618619760000
21046	3NLVxxVjNH78DWta4PfdeJd7YoJXjNKYJV3VkTujj95JEZ7Mdjvj	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	1631	794	383	12463	13312	jxSv7QAQj7ubRtghLh6RiR9jPotsWZQ3PPRHm3wtBYN6K4sPkLU	10576	14893	14893	1618619940000
21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1405	1	383	12463	13314	jxKyf2F8Y8A6hL9a8ZM6uqRE3HT2A1C1uZNUM2mmwYMWDcQW6n7	10577	14894	14894	1618620120000
21050	3NKyWTbsBnfHCy3tM9Q7kf5kg6GfYiRRxGoT3V1MZ35ZZWRCroiQ	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	448	1305	383	12463	13316	jxXJ4t1rMA6sqWfbSZJQhTLXFJYC8JR1eEWAAbzhnoUCYDPnR2k	10578	14895	14895	1618620303246
21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	21051	3NKiTADXHUATGCAhjuvkVBnMjAoMTiiXhJj13xnezuXYZuJA58cb	1403	824	383	12463	13320	jwF82XP4jH6buNfsKuPjnbJVjQzL3CP5W2Xp2VYp18Rq73o2X98	10579	14897	14897	1618620660000
21057	3NKwCkx1TVP6iemfwFsQArNipGnyMGx962m6djP2J1Wz3BdGguqP	21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	1407	1395	383	12463	13322	jwXzyC5Kj9TrVndPWJsRNXJp72LYN6jaxjebkkm4z9gzBnxReDm	10580	14898	14898	1618620840000
21065	3NKtKkKuKLL4Vp2NkEXrKmwQ6oYs3PE18Ju92J51Wiv9p4LMN9aU	20880	3NKYvucHQbnwCDMfzTe9ggDfApNmw5FLezNi8RJLNHQwA2APavok	484	1193	379	12463	13330	jwU855a9iMgZcDYzzRAEUjdiWULqpjuZSAWTNQkeZux71uGjvkS	10476	14903	14903	1618621740000
21068	3NLhFjL1j4c4eHUoh9WHPUnabzTnewDHQdzCX5PECEumfWzBnYMB	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jxtYodPVrphHuPbzy6XbnXh9x28icZBPjH7ETti4eMFLRkcs1vu	10585	14904	14904	1618621920000
21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	21067	3NKwHzGdVP8cQA2b8ZHV7dicmGARPphaJ4fvETptoGDM6zEzpdwa	1637	816	383	12463	13333	jxKnus4P6DjYkseFv4ozovsT9VdRCBzvg4deURoCDjBZVT8SSXg	10586	14907	14907	1618622460000
21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1406	1393	383	12463	13335	jxvsxfug7cdZbHcSj8sx6Gyj1aufLZcPUe8ycKHZXB42VsTwEAi	10587	14908	14908	1618622640000
21075	3NKbdKQibRPC3hKffW4ZAKfCFFZUUCMhjS1hWSca9vqSW7KjAp4n	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1651	1301	383	12463	13338	jxXbjCTrpY1J3hAsbC7wYaKu3wytL5Xa6S84ZR4gdyphXBYVQyR	10588	14909	14909	1618622820000
21085	3NKnMsSRFf3PJF93VGu2gW7toHLGCJYWGRxDbQ3LAmtn6Ect6r3u	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1651	1301	383	12463	13346	jxidbdD5Mg1P4hNMoLEqb4fBQKYTKWiQioGQraw4hUT24qxenic	10593	14915	14915	1618623900000
21086	3NK9smpzMuwxEnCEofW6eTTarD6UDwLXCutYuqhXPJnRVZPhWnhK	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	1546	1093	384	12463	13347	jxXa1kadU1h2zSPKj6FKsj6KFJbwMD8bG9V9CkCfYxgf1PeXZi9	10594	14916	14916	1618624080000
21088	3NKjnh1a9vzkpiguBmujoYKNjby81vMre5afWJ6VRKxm9vr9HFmt	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	1613	1349	384	12463	13349	jwYRFphWZEGqetc934SVfHSQJgZXLRt2UBa8oWSSAzhSAR65f25	10594	14916	14916	1618624080000
21094	3NKoxswBBBKGztctHP9AFywZnB4XVDdQbXdcqweUAMtDSdppPhJW	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jxq1SsHuhjsdgjc9vHgy3kBrTNCeF6Unc1G4dSaAfeHYwWQjz1t	10596	14920	14920	1618624800000
21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1448	1185	384	12463	13360	jwPf7Lc4FMJRo4Fzf77iRHVhCV5fgcAseEAAFKyjCkXw882vqGR	10600	14924	14924	1618625520000
21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	1631	794	384	12463	13364	jx2v6uvpGB2eoM678V2oViLxWTvSmJdsKazx4RgBKtzpr7koxSc	10601	14926	14926	1618625880000
21113	3NKc8woWPssBLWBLVm3fQ5QqXkgxtZtsv7twszksLh6senf6ceo1	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1642	1241	384	12463	13368	jx1B54PgrxRUbNy4vETu2x1NPGkRkVNBSz35vhV47QUV7wbxfWU	10603	14928	14928	1618626240000
21116	3NK9YafPiXreJ9zU6yCdk3pGzDEPB67wEKqnQhW5QjRmDkbc4KjB	21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	1403	824	384	12463	13371	jwi4H19pyuX2rH2iHMZ4fEJgdedb3Ni35iJzHRiKvv88tZM9x7v	10604	14929	14929	1618626420000
21118	3NKnAE684LWZR7bTcQDkjfh2skTFCJKywxABpux1XWEzUFSjkv3T	21117	3NLscUmSzAbitXAiS9GfFT12rGzbcWNhw7JJWN62sfR75hkQL8rZ	1422	1211	384	12463	13373	jwpLePeQz7J86SXohSmxzfogrCcRZ5LA3D312zsdGWFYZa2Lzdb	10606	14931	14931	1618626780000
21124	3NLP3ZMANekSTMmtZcG1vW87wuqpqg2EU5HssbsTp2nAm2u67B4Y	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	247	247	384	12463	13379	jxvcUQTvVnjeGsUz6Cyrz8ELVbFPTLncMaZL98XQhjGuP852mzJ	10610	14938	14938	1618628045683
21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	1407	1395	384	12463	13381	jwcR82jbn4osD3FVB2tCH1XvqaRq4yRdZrn6V9rispxWnMVRVBS	10611	14939	14939	1618628220000
21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	1405	851	384	12463	13383	jwVekEcuP2f4cUc6Mg1XnPLAijUJV5v6RXWT34pdcDXAG44dYRw	10612	14940	14940	1618628400000
21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1602	1123	384	12463	13386	jxsW1sBL7r46EtQ8L6jBs3ijBT1MLyxbvnSGxbquEZTVJitMMMM	10613	14941	14941	1618628580000
21142	3NKu1THqnGqY2VnmmfUqn9ENfmY3qbBzWwAghDRcC31oAJWksDsd	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1637	816	384	12463	13396	jwUgV4cxyLvkwg7BS2ivvHkHuWaJb7RP2ifWSfxmDGfLLPDBqqK	10616	14945	14945	1618629300000
21144	3NK7nxionTD3yuF5oX85Z4Ygtiw1WsHK1RncZxCt11r7TpTfbBBh	21141	3NKq3e1fgwdZF9o35LY4zDP2JEuZtt38Taj368ys6ixTYMGjJ2td	1441	65	384	12463	13398	jwmZ2QMtau6yUcBrAG3jbbM1arQQNygw8zyLXyYDuu3vjYE9H1n	10617	14947	14947	1618629660000
21148	3NKyDnMRCzUB1bwNBarP52E3rydUcsFgmc454DYM1tebR6Dz1aUk	21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	1406	1393	385	12463	13402	jwHMrvWvLFAbfPjiL912d5hVWkMyVRk91d1bD1ejAnCRgs6XhFQ	10620	14953	14953	1618630740000
21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	1588	1392	385	12463	13407	jxiBwUMX7J1YL37CRosCNUU4J41GmWVTmMuzxtAg1qwaFeveK5m	10623	14958	14958	1618631640000
21161	3NLvDNVQcLciZRv2Zf2gLS7NREW9Hrj5TnBm3HXrLDAPPd1Z1HdQ	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1542	1304	385	12463	13413	jxVjG14TnBpHg9CaKxaLMVKVAixYj6sussDD2FPWTM6m9TKvgpu	10628	14965	14965	1618632900000
21168	3NLsYKoQESEVaSnUvPDYGURXWxv7wsZZRgsv6cXSxq1we8gSZeRa	21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	1471	1386	385	12463	13420	jxJ9GfTDju2cs3AKFiksDYkjKPFEucELx5RJDoq7SLpiGbqg1p6	10632	14969	14969	1618633620000
21169	3NKDNvYx6PzZ6WVVoH7Wtn1a7uqoxke7RvNeYMY5foVgJxSDH8qk	20877	3NLfPA49omPkpWeixVdpnG1M8Sgev1PkTV16XUEXGdDyLjgpX1fT	1671	1365	379	12463	13421	jxxqiddDcd8yPfE3yRV6ewam2DNB2PPRzu1AhYpmJLvzWZLw8J5	10471	14969	14969	1618633620000
21172	3NLkmF9w63Fv8ErzK7c7qr1aFgXyCwAEGJ5gxEuLV4LM9xmih42Q	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	470	1309	385	12463	13424	jwDoUcXQ955AvwWMpX38i5RZa5Fnh3nfVTuTProuhpCqRd6mGih	10633	14970	14970	1618633800000
21076	3NKb4Rn7CBWkcMJDX5qBAcQDnSzymJrDkps8GByARjBrUuod9Xxa	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1651	1301	383	12463	13338	jxv1xVEXRBVzSQYwqLfircLrofR16iFwfheVQ5jkzQC8Qn7c9kP	10588	14909	14909	1618622820000
21078	3NLogQSznQ5CGqDDvnhAfJ29RiWq6erT6EmcXghQ2JPAotTHVR13	21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	1555	1347	383	12463	13340	jxhfpWNPPgV1WyrJaoyqD71aoyu6TX5QUwRdUxw4M6yn6UaeNV4	10590	14911	14911	1618623180000
21080	3NLTptuiA1ymdfYRLBgB5WmGmRq2xm9pFBegtrWJMG6HScBhW54f	21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	1407	1395	383	12463	13342	jxKjdatCeLP7kyet18gnyXZNM6824TxDZ5if4xZLAkXPDzbvZiH	10591	14912	14912	1618623360000
21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1406	1393	383	12463	13345	jwMPezjMouwQUKsrRUdbjVezVLFsZHUH7PcUkPt5kdSBNqLEq6J	10593	14915	14915	1618623900000
21090	3NKSx4pCoCiCon7aHbpCzEMJnhbwxSrF5BUjezt1m4QgQNpgUKbP	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624080000
21092	3NKJtatL9XPYHkNEPqg8o2U5CuQb1VexPsHbXCXasGcpSeFoy1US	21053	3NL17ikgZSPHkoRJ2oAikc7LTaKmuzaJeh3eSBQEL3vbSFxYiXL1	1451	1046	383	12463	13351	jx7JWg4PwXkVjtvQAejrL9tWR3gvajYw3A7SbSYxknvcXJYPUc5	10579	14920	14920	1618624802997
21096	3NLFq6bJ4HxqXoES7CEPTnkqaY1ZUywWCdR9ZtWTW8KxyQAHB5qm	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jwdLqLcwBk9eH38SGjJj2SLTzt1YQpjBmdMZ4n6YRL62A6wbwYK	10596	14920	14920	1618624800000
21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	171	1248	384	12463	13354	jxehWmjpBc9vx6SrRQKLC7EFrR5ozP9WHSJS4WU644jNXUAfm1H	10596	14920	14920	1618624800000
21099	3NKivmwf1ghrUEREFvoyi65nmzdS5KSEkJnECfcF1MLZqXDLGefG	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1656	1097	384	12463	13356	jxpyqcuTDoZ5eQ77oTWydTQZWgg3piNCddySXTFu6Q9t2MiJwrs	10597	14921	14921	1618624980000
21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1406	1393	384	12463	13359	jxn82Mje2mZggykLY8ByehrzaRpdoYpAcTVorirjiKCnqx8JDDu	10599	14923	14923	1618625340000
21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	1455	1332	384	12463	13365	jwdcJC89oWtVqmgWhYUsMy3uV2YvGGwLpE3Sh1cW9WDuajnoJFv	10602	14927	14927	1618626063097
21112	3NKczj7gfVW1fFCpxqfiHPBJmSD3u93C3hqqDxboLtysVB1GbZXY	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1579	1389	384	12463	13367	jxad62hKa1EfXnxTJzPfr282QvXha8o5cZN18Ehidnb6dJ7SZ7Y	10603	14928	14928	1618626240000
21133	3NKcrKnUQrLtfpC3BH5ewZL31BXiDoY2LaBZQRMfgGxGwjSJEcCr	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1594	1326	384	12463	13388	jx2mf8v2XQdYwRcHxY8ZNbNrSdoaazp63MUZs7HQHLxukBUNDip	10613	14941	14941	1618628580000
21134	3NKcddiJ6WJbE3A4ytM3EukSvkrub2zL6xAa1o4ZqvrB8pu2kWzC	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	448	939	384	12463	13389	jy12TV6duhzBvPpE9MYe82GDJgzvWkudBCnk5mHfwRrpae27xyx	10614	14943	14943	1618628940000
21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	21136	3NKzakvyA4KFSKTUtsFUhovmcrF7ZCo5CeUQwzBHafdtX6GB19ka	1631	794	384	12463	13394	jwSMKuqiVFjH2epFYk3JEkbpe7MQYWYUvBXNUBtouVZRTSyekT3	10615	14944	14944	1618629120000
21145	3NKJtG2y3Xf3fbE6wghsHtXPDBkRozaXnfCDuZWZUgnUsHgXAtX2	21144	3NK7nxionTD3yuF5oX85Z4Ygtiw1WsHK1RncZxCt11r7TpTfbBBh	1490	123	384	12463	13399	jwuuNQdfD5TPBnFm1krr6VXTKYHNZ7hSE6qHWGAKp9561rY1Hno	10618	14948	14948	1618629840000
21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	21145	3NKJtG2y3Xf3fbE6wghsHtXPDBkRozaXnfCDuZWZUgnUsHgXAtX2	1407	1395	384	12463	13400	jwh4YGYami4h1fp4VrfuvQtwZrsBm2uv8P25MbhoKBd7b7oPAU9	10619	14952	14952	1618630560000
21149	3NKw71uSV5qfMM2ErdeSrqrD5YrRFrmnnmGcz4TW9bA3RjCs71v6	21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	1406	1393	385	12463	13403	jxNn9FuE12VAoA5GE1SwJUG6L23jrtFxRhEmoaLcacQKoHpQcEV	10621	14955	14955	1618631100000
21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	1406	1393	385	12463	13408	jwVbwVsEE7KbbH9AjM4n5dPXvqSWpXfYNK6Rs3FnwbN7ziN5KWo	10624	14959	14959	1618631820000
21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	1508	1141	385	12463	13410	jxL3suVzvfuNoJUebsTuUTfsoi7Hj4FKBLv5BK6BawUqqB9HjTy	10625	14960	14960	1618632000000
21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	21158	3NKuBZKND6TLceuLYTN4DM9bAHfdkSnM1Q1NvkUgdef6WBaR4da5	1549	1362	385	12463	13412	jxkmqJPfeAcmMbxq5LtSf2Yiw8ytYekimQCD6DVhF6FJ163Ca9r	10627	14964	14964	1618632720000
21164	3NKpdotoSFVcvSftYKGprmiB9dQCPiY2RXFt4gs7bUZfZvqhF6f7	21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	1503	1277	385	12463	13416	jw8ZqjQ46cbexqNy5ZB3Km2BxbcnBiJqy8Ljkh25Vbd2ELQPB3N	10630	14967	14967	1618633260000
21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	21164	3NKpdotoSFVcvSftYKGprmiB9dQCPiY2RXFt4gs7bUZfZvqhF6f7	1559	987	385	12463	13418	jwLWLo1NXzZYWmzBnmx6HAmdenwTkXvoqvJW36yGjDcDLFMAKeC	10631	14968	14968	1618633440000
21170	3NK5qB2XRvGeWzNoMKgSMpCZgG81LwW18YvbDi6dRGt6KPmuLSpb	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	80	1147	385	12463	13422	jxYQoAn5Q3X84hncmj7NZrnQqFJV2hSBViHjKLDKWJn99wgzCkS	10633	14970	14970	1618633800000
21179	3NLAbRKh6DxvD33NvWnxUjZb1MhWEg55FzqgMvvaKVy9Mg6ev3z3	21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	1445	1044	385	12463	13430	jwsRvsdq7a9UGRX2ahHFwhdAKuaLR57JQfCZZXKuhBNukDPgSXo	10635	14974	14974	1618634520000
21182	3NKQ6Nu7ygqCAaQkSfniLL594Fvuup9WXaLgvt976ou7ZUYF5G95	21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	1406	1393	385	12463	13433	jwXkCGaKLDWQE3wSJZS5TU2LZKhXBnLvpeYtTdcBYhjivJDYjqt	10637	14977	14977	1618635060000
21185	3NK9GvPdckEKRDsXbasbwebK3aAoSrRgcJoRap1wYpjexjnYFr4d	21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	1407	1395	385	12463	13436	jxaeX9VNyZ5M3Y7jhJZtpcKEAJorZgA58c9YX4DMep8SGqNRA7Q	10638	14980	14980	1618635600000
21190	3NKLEZeiwg9c1Davnx4a15vT7e8LtwWuCvxDQjUnopPefdyLuFpo	21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	1406	1393	385	12463	13440	jwSCX7KMa6G8CLsJJhBLQ6TVjiutB2QGowNVBBXjZf4NZM3qLfR	10640	14985	14985	1618636500000
21192	3NKcccgSm78pY1j5AvWe2vtgGyiKXjF9kx4tL6GbqgaDtyhKyvB4	21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	1529	1190	385	12463	13442	jwKAV79peF7xrS1B2hgb2AriaPiCG1W9s6GgxDcXf1kstF6nDc2	10641	14986	14986	1618636680000
21197	3NL9VSaLDvcFE7MvWGHoMLK2Z5dKkAuWhmLhsRJJJgLPRWYBfn2G	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jwmdm7bcVqvJpixGPu8W98RneTHfHZCB2QiZtVC854PxVEHYuay	10643	14988	14988	1618637040000
21203	3NL5Zuyg6mgNsLFATeTvURHYAq2XcfDk2f2J3QrYmJCJeHWSbh26	21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	1601	1388	386	12463	13451	jwc7FrbmX9j1gsQRoyScG2SMwfznyghSwfcR8SN4Kw7UiXJ9jhx	10646	14995	14995	1618638300000
21209	3NKe8vcts2VbJmk5wyzerUpjVk9FzYoCoLyzqnCVB7Q5dHbfJ6TZ	21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	1609	1333	386	12463	13457	jwXTCiUybmCQstkHSyguSFeHHf6kJaevgVFn9VxRUyjbQ6rRFJ6	10649	14998	14998	1618638840000
21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	1403	824	384	12463	13401	jwUDsja8qQH88awgeEiZTmTDNKyAYbojU1wdmoyRVEcDyjuLQPH	10620	14953	14953	1618630740000
21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	1564	1212	385	12463	13404	jw845UfDqGRauRkDkxx8AdLkqVCzcSc1eX8JRNZyYn7ysD4Vm6G	10621	14955	14955	1618631100000
21152	3NLJqJ5tKnHNLnwjbpUhZaE9grtdtnBMXiq7eCzmU8BJ8b5DYFAe	21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	1403	823	385	12463	13406	jwT2q6d7Lyou5HaEr37DST7Q7BoMp9mRr6HgWZYA7qobUu9LZ1r	10623	14958	14958	1618631640000
21155	3NLLrABT92qyYJJq62gFAbb99Ry5HM3miLF6gz9ymxwgRjcGgFcr	21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	1476	1245	385	12463	13409	jwPfVmyvqtT9XTUnPzUAiRCLwtxJ2yWBP3MhaUwWeqdNYm5aT53	10624	14959	14959	1618631820000
21157	3NKoYGZ8BDuUiTWKggkUqMAPzXF6AasAhjAduC9oqe8MtbQmPrys	21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	1508	1141	385	12463	13410	jxL3suVzvfuNoJUebsTuUTfsoi7Hj4FKBLv5BK6BawUqqB9HjTy	10625	14960	14960	1618632003408
21160	3NKZ6D4HpjSRFZkK2ng2qt9HYA16UnSg6mGb5NbswR9PJfJBWfgg	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1542	1304	385	12463	13413	jxVjG14TnBpHg9CaKxaLMVKVAixYj6sussDD2FPWTM6m9TKvgpu	10628	14965	14965	1618632901883
21165	3NLs6nHiX8xEP82sxsMAW15HxYdv9iKm71pDqHivePHtMiHWeJQ5	21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	1406	1393	385	12463	13417	jwDs6fBcDjfD84cu5VVQQGvw9qJg9TiMYdWs2ThrFYJtH956MDi	10630	14967	14967	1618633260000
21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	1671	1365	385	12463	13419	jxwpJvGDPx9H94FZjt1Cf6bAmTeQV3jaULF2H4mFURWunie4X8j	10632	14969	14969	1618633620000
21171	3NLDjMbT1B23NJi4pV88VYWeC4oj8wNX62VHDaaPqDYRvssqPvJe	21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	80	1147	383	12463	13423	jwo7MJpzT3vWymS5Z1wdqNHMZ69Fsfr1KLhLknKzWvXCie3utGd	10575	14970	14970	1618633803323
21173	3NKKKQuQHku1hvfFC7CpbuWfm3FCLyJB5p1fM6hTV4AzMB5cVa76	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1406	1393	385	12463	13425	jxJyu2JHTG67KQJZiKNTyJq7N3HUFJzRoqQ6KVW5RVBT92nkfCU	10633	14970	14970	1618633800000
21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1649	1383	385	12463	13429	jw8SdtnTmaoh7Xbhq45vEwzssXaoCSe1N3UJkJokReSuuJr6SJp	10634	14973	14973	1618634340000
21180	3NLMsadi9sZZW4nyWyKMPkDfD7KmdAyKSUn1mbxKeQk5iaSnoMaj	21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	1407	1395	385	12463	13431	jwi5F2AARWf6e8UpFzvgRxCjP5UADnqJo8sd6P9evuUscHeYVcm	10635	14974	14974	1618634520000
21188	3NKFjg9tESEvZLRwhTTnMZorGYSpEhwyxHSMt4EgXGzCbQkvZLtV	21065	3NKtKkKuKLL4Vp2NkEXrKmwQ6oYs3PE18Ju92J51Wiv9p4LMN9aU	484	1319	380	12463	13438	jwZcozkAyTzhDzxYPT4cfsk8ukZYALzvgoJQbWLceQ3ogeVUXjt	10477	14983	14983	1618636140000
21193	3NKuMbJmPnTDmR93FwxJtTK2pB9VthWAuxqSBcu8JkFnhQH8dw8G	21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	1518	787	385	12463	13443	jx7p2mAsUzRL1yR8eu8jCz9JT166KK6bGU2Gd6UGb1zoe97MhfH	10641	14986	14986	1618636680000
21195	3NKHovuWx1p3SZkEFrAx6DRmEtTDXTp4eXTPLRb7ovoTanESCt7b	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jx9TyYqdkw5Ge55d2CvA382SVS5uxxgswxPM3HFBzTh9tYDf1oV	10643	14988	14988	1618637040000
21200	3NLPX6bzatmGzyzmncnJS1q19S5eJeYKx6p3ttB776ZsPrubnKgJ	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1649	1257	384	12463	13448	jx9wd6FwSFT9wuJCRVMEqRu2juG7DPXdDJaVbTEKcKJSpdFEfVM	10596	14992	14992	1618637812070
21205	3NKmuvwaKsK9mvkRLVoL45ZduHbYnDMeMNKDWXwXf5fBAUv1CrLH	20867	3NL4ucRdAXi6ra9Ko8ECoHiZKZNWTbPLoK7mZXDMmtPH6KuR5NgB	1647	1302	379	12463	13453	jxRTXoLG9jeJvX8ssgEGJqwESj6Ts32GFvQYaaFnvqoxpKQ7tc3	10462	14996	14996	1618638480000
21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	21204	3NKL1ZisDUzCYataGYP1AHmv5rKtLkD3KBdZQryzWjkPhqBP5APX	1656	1097	386	12463	13455	jxNgaTWN4CN8krPmbPnbXJBFMjJzhmpRbKXmSvoUZapMSM9xjGX	10648	14997	14997	1618638660000
21212	3NKEaxYyNgxFqR4soAtwH7yidc62BQfZrdifU6JGVQx3hpPb8bt2	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1637	816	386	12463	13460	jwNFmj7ym2jSNjfsUasiDUQk6My6fVmeR5rX66m6Y7Q3ETbtkBh	10651	15000	15000	1618639200000
21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	1596	1363	386	12463	13462	jx5Fr8Ln91qrUyBkPqwdDLHdBujgkXn28DYYXMgk8HaZoaLGChx	10652	15001	15001	1618639380000
21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	1406	1393	386	12463	13464	jw7WtXXJUyFhCPS3fF5JzxK1TinE4fkTJs4pZt9hEvMRbn9a5ke	10653	15002	15002	1618639560000
21219	3NKRkzBismWZf1TgyzKtCy57q9mx4qsDkydTkZkugcGm1mCaLana	21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	1555	1347	386	12463	13467	jx8e5DiuZ6yDJNMrCJZueRqxpDvvtePUXm9uKhbvNigoekSjZyP	10654	15004	15004	1618639920000
21227	3NKo4PPg3tJ97igYoXjDL5qNY8VpAT34SZmZp3wrtMeZoqhVVgVw	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1673	144	386	12463	13474	jxKQ3kM4w3CSpT1TzXmEp6LqwfzL8Q7oZypfHi1RcvLW6hUXJXx	10660	15014	15014	1618641720000
21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	1503	1151	386	12463	13479	jxLinPMp3phzcTCNBJFb58VGz2XBcm9Yv3B5hQnxnrKF4LLZHDq	10663	15018	15018	1618642440000
21237	3NKLKW4quLaSegib2RPA3Ad77ZmLyrRu4hdchcmPgJdCrt8ErpVw	21171	3NLDjMbT1B23NJi4pV88VYWeC4oj8wNX62VHDaaPqDYRvssqPvJe	80	1027	383	12463	13484	jx4n34qFyR6mc3VgM36bJRRRZviAAxU7VfFCdVXKrnbct4UDfNQ	10576	15021	15021	1618642980000
21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	1624	1208	386	12463	13486	jwWD5QDnPJPncjbVwafqtXqu4sPwQaPw5RojsnRU2JWdCRzrry7	10666	15021	15021	1618642980000
21242	3NLc7AhKVH3xFbhoVgmNe9RhseWmCuUa7HseouCT44579oPahGvN	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1444	1135	386	12463	13488	jxoFMkF17CXYp3ZYDpet79Xzjar91y6sv8ub9sUTfeTQi6ZdCJJ	10667	15022	15022	1618643160000
21244	3NLJagbqCGY2EzgcKCo1yS7rD2j5D1eoAWEnijiQysB1mYQLMXUL	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000
21249	3NKD5iBpcMWzpUZ6VoXXEtJH1eL2FDonrdc2pSYsLQWLqJrojDxE	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1542	1178	387	12463	13493	jwEfTGgwNUEpka8Vy6StPUJwrZZvUh8PFJHo6kSzy9pN65wH8zU	10671	15027	15027	1618644060000
21252	3NKypvkmGmC5uYhnagNtU2JFazkDcAtBJghXkgVjiN7Ytkm8zBug	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1406	1393	387	12463	13496	jxfMbx1toQrP2QCkaUg7awMcHYb3dBUWg88z7tUJX3TQiU3ByHG	10671	15027	15027	1618644060000
21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	44	1199	387	12463	13497	jw9ChuH5Duus3WL8pqH4T7bCQc4YvE6DL8zhprXssNND8Fzn8DW	10672	15028	15028	1618644240000
21258	3NKM9UNdwShiL1ghuzcwtpGvojmdoCiKctFR18V7cAVDZ6kkq4QM	21257	3NLveZRn4CoZ32WWN9zUrLiEN3MFafF4kYCqBeAygQFU2EY1cfg3	1406	1393	387	12463	13501	jxdT6zEdDA8xYaUKU3q4Z7jyLpcqDRPytqVuX6Xg9kHMoA9uUdC	10675	15031	15031	1618644780000
21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	21161	3NLvDNVQcLciZRv2Zf2gLS7NREW9Hrj5TnBm3HXrLDAPPd1Z1HdQ	1406	1393	385	12463	13415	jwVH17QN59NwdVqefathqi9TA5pC1W97NybLMzwifbvspoMzbbv	10629	14966	14966	1618633080000
21175	3NLGp3xuAVQK1DRnskUqs9Qhyi7nEKEjpj3qVDyBr4Ehw9ZNGuBd	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1559	1353	385	12463	13427	jwTsTsU13BLZ9cYyED2JMdvjaMaHrmmToTUyFQXAZjEYo29SfwZ	10633	14970	14970	1618633800000
21177	3NL6XUrsrphg8w6oY1SjguXb2YLKFVkGzNwgP5fVEix8DmY84Yje	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1649	1383	385	12463	13429	jw8SdtnTmaoh7Xbhq45vEwzssXaoCSe1N3UJkJokReSuuJr6SJp	10634	14973	14973	1618634342485
21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	21179	3NLAbRKh6DxvD33NvWnxUjZb1MhWEg55FzqgMvvaKVy9Mg6ev3z3	1407	1395	385	12463	13432	jxMt1a7xQMGa4ZfL1GHjK2m3R1ykZx44yhbJvw8SZ8GbRM5feJf	10636	14976	14976	1618634880000
21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	1406	1393	385	12463	13435	jxz1eYBHWPXUWihVbmXV8w281NddD6DuPN8TbZJWeHcvfBQ5azX	10638	14980	14980	1618635600000
21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	1675	1216	385	12463	13437	jxk2QEfGGhL4BS8JBqNPNC7jtYt3wYKkEyojJ62EHUoYvjM1Zhe	10639	14981	14981	1618635780000
21189	3NKuMw5YVxWsXZWCEgmACpEhfWMCEAHenCMmyQ2fuDTLZmEp9sT6	20986	3NL58ZMyosZquW7Jz7mXHtRXy3jQ883HhbEi1iC7vP1iHXPZxKCP	1505	276	382	12463	13439	jwzrCBcNtaL4BoLa76FFWhNDurNB4avMCZr9SzPX8eNbez6yus2	10557	14984	14984	1618636320000
21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	21192	3NKcccgSm78pY1j5AvWe2vtgGyiKXjF9kx4tL6GbqgaDtyhKyvB4	1406	1393	385	12463	13444	jwgjDrfFZhrwitAcPxVvA62Wr5t1g7C8SNSU1eABTbHM1hgzayz	10642	14987	14987	1618636860000
21196	3NLdqXUHSfvt4Xu5yA2M2ebp11fR7e9HoxbhZcsKPm3NxKnwDCLC	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jxQ4skGHBfNj3pBKni65w4ANJtqFVZCWr5KYw5Ai4HJPVm1pHMU	10643	14988	14988	1618637040000
21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	21198	3NL1SzkUJL4P6hVjkwMwiNkpYg6Xfv8pgGUcYXmVHvnTwiFfZ3F4	1649	1257	386	12463	13447	jxzvksymJHXuisqyfqZdtX9vjKAQknXHgHqrRcNQ5T924X9Ebjn	10645	14992	14992	1618637760000
21201	3NKGECkGgWDah13Yuythqk85UQuEnx7xDqwRarFizDxrKy9Lkhph	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1649	1257	383	12463	13449	jy2CXSUe2qzUecpYQy9AREzzrrUzMcwtx4zVm7P8A59sBM23bLJ	10587	14992	14992	1618637767235
21202	3NLfcC3f5b8pZfwNA7Sez2bW1RhK4HjV3Nk9BrgtgA2JJLonu6Ad	21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	1406	1393	386	12463	13450	jwYvtCDV4vjedLKxTCdMDKmCB4eCY42ttgTFrmHFZRuPiLwAHc4	10646	14995	14995	1618638300000
21204	3NKL1ZisDUzCYataGYP1AHmv5rKtLkD3KBdZQryzWjkPhqBP5APX	21203	3NL5Zuyg6mgNsLFATeTvURHYAq2XcfDk2f2J3QrYmJCJeHWSbh26	1447	1345	386	12463	13452	jxL28NyjcvQqCtLwvW7qxp55LjTEvMEjhHCYe4ZcdgB2dLm1vAC	10647	14996	14996	1618638480000
21206	3NKEqm6qpH1Vbi7j6r8MgteFrKx9WTehiKqm9zJZGn1aX9UcSKWn	21160	3NKZ6D4HpjSRFZkK2ng2qt9HYA16UnSg6mGb5NbswR9PJfJBWfgg	1656	1097	385	12463	13454	jwMTxGkvoibivoLzX97xqazRceMHXjWnfHBcqfZHZKsthU5yBPp	10629	14997	14997	1618638662645
21208	3NLsq6fBoXxuo6ZbyYGMEpYjBFERwQhKq6ur2uZSSPaZyvhh9Yta	21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	1672	1285	386	12463	13456	jxBqTXE7GEiXGZcDLWdgK8of2duzZWGX2WatMEQUWx7fqg2PTCq	10649	14998	14998	1618638840000
21223	3NL7dG3AUJ4XozEwjcJ4ZpwvZ35n61Q1gzUt59veB569DByc1M5Q	21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	1608	923	386	12463	13471	jwZK4h1EuUZguormhnuJCMHeStJb9Duou5PRXeA1qs1Ks6Vz2yv	10657	15009	15009	1618640822638
21225	3NLFLh7MNSzV5q5XWfS51FnLrh367dADuq3Pj4nhTqxSiJ3w8ZP3	21223	3NL7dG3AUJ4XozEwjcJ4ZpwvZ35n61Q1gzUt59veB569DByc1M5Q	1406	1393	386	12463	13472	jx57xHsCpz1juYyur2trFotdQvXdjT5Awj8E6zmXCD6gxNUVRMJ	10658	15010	15010	1618641000000
21229	3NLmPxDQ1qXNacCKiYzMrAxhFKKA89tJowyKvwvxGwUkkKRrLVUz	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1407	1395	386	12463	13476	jwypWb3ZwXyqs2vZA99xDKCygyNNvvaGMQRXVnYgfin8BTet42m	10660	15014	15014	1618641720000
21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	21230	3NLXyD1LXhF7t1AS77iNZ4UZYh9Dc8gC24jJNBhmMCP1hYSMLXBW	1406	1393	386	12463	13478	jwsYTRNauGqDsTAshY8iJdot4i8VR3yDSiEp1WzVqGxXy4TXNei	10662	15017	15017	1618642260000
21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1403	823	386	12463	13487	jx4Yv6TRZQcn2P9Pm61rghNy1DrEM6vfbmJ47psjSdBd4EcivjF	10667	15022	15022	1618643160000
21243	3NL8kzEEWB17qrUcTZscKNUAGxcSo72DrLLxBkmpyZFNks62xz49	21033	3NKyp555sZJYC6aqxZC5E5Cc9vvLjGdpC27PAvo9sVmh5X7Nr2c4	563	1359	383	12463	13489	jxXejbd7632stMyq6aaKFDR8XfpZpY5RR4y7LLCTdhrJgDX7nEE	10571	15023	15023	1618643340000
21245	3NL26BFLvQPjFZds2Ld8rNVK3opGhmHAUM2Abj3i3u4DcAYewvDh	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000
21247	3NLtT3iNyiyR2tzHLJgGax2kYhn2qKqsUvJ1WjcVx5Aw6fatq7xr	21246	3NLYMLE1LoFHDCGKNkXqWr4XqAeGNrCf72iSfCxssHX7jz5LBcfA	1406	1393	387	12463	13491	jwrnTemXUaMcwc7Z5kSBGpjAdPaTYoL3z7NStJS4npbdwbQNLkn	10669	15024	15024	1618643520000
21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	532	1303	387	12463	13495	jwqfveCti726AH79zKadw6PNfbqdDaQbN6UP3zJ92b74oTn3Fzm	10671	15027	15027	1618644060000
21259	3NLrzeEyEZAdtBpEzuToEKU45yGbzZRaJyBtXkw2iEZrAgdLGYag	21258	3NKM9UNdwShiL1ghuzcwtpGvojmdoCiKctFR18V7cAVDZ6kkq4QM	1406	1393	387	12463	13502	jwRBDnpqfnaiVVVvAiVSb5GBe6ajwteAkHdRHegJmQ1bGekLAkG	10676	15032	15032	1618644960000
21268	3NLNsT7M7jdjqybgMsiacDVMrsthaFFVscThzuqJtxSHp1yY7oKb	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1631	794	387	12463	13510	jwroi865HFP3jwUYSofWr3G3Re4rs1udFi5bzBp1zqErgV1s1ei	10679	15039	15039	1618646220000
21269	3NL8TNBN4TrJWsdvVLALEFeye3d3wYdSHjqnpTA7tDkK9SJef5C3	21268	3NLNsT7M7jdjqybgMsiacDVMrsthaFFVscThzuqJtxSHp1yY7oKb	1444	1381	387	12463	13511	jy2JgnRodAhXsFdsh5ZqAgRUjz13ktvvRyZaQj7PpiEK34JmAsX	10680	15040	15040	1618646400000
21272	3NKDmgyHzAXzbNRmLY8owns98WaszzQ1bC8EQ9JEijtf73ijBczo	21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	563	1359	387	12463	13514	jxnoiYaec1qkTmx6VJC7Cw37hqbeUtDFHyBZJro614u8UF1Bgup	10682	15044	15044	1618647120000
21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	80	1273	387	12463	13516	jxd4UsejiBTdBZfYzoswH9Pz3sv1vZsZ7nrmvMy3fGFdHvpwcoH	10684	15048	15048	1618647840000
21281	3NLjoDvm4WcUr6AKuiKpB8UxjpaKf66zDvfE5pSJv68KrEpQrPmt	21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	1451	1292	384	12463	13522	jwW8ukufUpwmygv6kmXhFNQQ5cqimx6atrCEjaDoeKVSJnXAPyc	10604	15048	15048	1618647923175
21284	3NLfmSxA1J39qmcDRuSKwQ52QTnEGVbo7W1bFrMq1ALJRMmwD3Md	21282	3NKURJkNo8ob67mZibZXKQBFE6rj3xeeVKarPEXgssrbENCH94Ur	1529	1070	388	12463	13525	jxXbdeFVJUsyR7ox86qfRLDSTNezqLaznEUBYwutvncGQQe8CMg	10686	15051	15051	1618648380000
21294	3NLn6RBfm1ojvvz8wAxetus9DAtHCKH8TP2X67jpeYF5FgzbbGx2	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1405	861	388	12463	13535	jxafXEZdbnehyScme5MZCTZn3US68ZnRvDH5Cum187gFf29idoc	10693	15060	15060	1618650000000
21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1637	816	385	12463	13426	jx7PbwSEeP4qU1ue1ZZA6P5bzt41CSosFHR4zpUQLumF5xFpL3u	10633	14970	14970	1618633800000
21176	3NLKd6hq19W3Y1zxjojDkMbbJ8Rueh6YgXess2M6FhhMgBXrf64j	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1403	824	385	12463	13428	jxP98s19Ljhm4EWEngTuKqk7petaeoLG7jqSr5ku2NJauqM8MAb	10634	14973	14973	1618634340000
21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	1581	778	385	12463	13434	jy2LvJi3HoLnzRTNPtTPmKmT7Fk2gPc7YqFZgx5gQoQcmb7TGPe	10637	14977	14977	1618635060000
21186	3NKn5ZnSnvuBY8hfXTVQ1tYHPgf1ykJQ4ZsHcezsctb9uywkDTE2	21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	1675	1216	385	12463	13437	jxk2QEfGGhL4BS8JBqNPNC7jtYt3wYKkEyojJ62EHUoYvjM1Zhe	10639	14981	14981	1618635783588
21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	1581	778	385	12463	13441	jxehfP2oMegqvRTxxDBQSeNqoBNV8mxwkXixxgSWDRBWsY9GeXc	10640	14985	14985	1618636500000
21198	3NL1SzkUJL4P6hVjkwMwiNkpYg6Xfv8pgGUcYXmVHvnTwiFfZ3F4	21196	3NLdqXUHSfvt4Xu5yA2M2ebp11fR7e9HoxbhZcsKPm3NxKnwDCLC	1421	384	386	12463	13446	jxBrSkVBs53HDi1oz2JmxsHHyTgSMMdVEiGBZjaLBxQbL8a8tyC	10644	14989	14989	1618637220000
21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	21208	3NLsq6fBoXxuo6ZbyYGMEpYjBFERwQhKq6ur2uZSSPaZyvhh9Yta	1402	852	386	12463	13458	jx4B5A5qLuiftmQbNSUWPp2ZTk9HS77x92qw3MGFhUioGa9MKSq	10650	14999	14999	1618639020000
21213	3NLh92euzhhT99W335w9TVkdtQaMxhr5169mPivGDoRW3x2jyh1z	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1407	1395	386	12463	13461	jy2aTa8Vgm65zADMLkHVA5ahzCxT326rEAWWvCoJ4WBSTQ4rFRC	10651	15000	15000	1618639200000
21215	3NLGFjnfFj33vVMaqSAkUSQ7cPDAty912zqrFSorEhQxbJFNx2do	21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	1476	1371	386	12463	13463	jwTMwBJVpBvkiLhikFyNgLmXNwduhYaJysN8sEf9ta5XeENtvCM	10652	15001	15001	1618639380000
21217	3NLtdv41jHUwEv3S7Yw8sTnzGZVhXmzGx4UwhAvHvfaS8syZqEhQ	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1555	1347	386	12463	13465	jwhKW5JqtWX7vfX7E7DyvH4B7tCynPY8GXMAM2QyPxxJBavBkoT	10651	15004	15004	1618639920000
21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	21221	3NKJcfXKbCVcucb3K3qaKAYUdHH5h1eJk2h17bKmG6XExevCsuhG	1637	816	386	12463	13470	jwhmzM27nj8aaghD6NRoQYEjXyVfYMk4EJEDYhMNXGAtxzNjaVf	10656	15008	15008	1618640640000
21228	3NLSRPrMjqoL7QEziaz2CNwAJHTf2C88JmCud84DVZRZmXjC3z1o	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1648	1158	386	12463	13475	jw8xNE5FjBKMECiCs63iSMp3Frm1QQPHSZSTABXGLY6uq6Niap4	10660	15014	15014	1618641720000
21230	3NLXyD1LXhF7t1AS77iNZ4UZYh9Dc8gC24jJNBhmMCP1hYSMLXBW	21228	3NLSRPrMjqoL7QEziaz2CNwAJHTf2C88JmCud84DVZRZmXjC3z1o	1406	1393	386	12463	13477	jxtKBuJZ39QyoDCmqE1fUxXtmibUqydKHZ8VGeGFHVASxpLJq9F	10661	15015	15015	1618641900000
21233	3NKgRAEeEgNsLAF6PCoiY9jcPLYpKop52uqwKkwR45uCmfxHGnUN	21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	1406	1393	386	12463	13480	jxr4S3AqyLs9Xi6tEWmpA8oo1P46Genow6C7wYWfwuMkWpqQXZT	10663	15018	15018	1618642440000
21235	3NL1fJypFKik7y2e15G4wd26bEHEuzdUs1tYNQfsjByLhvhZQqXD	21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	1553	776	386	12463	13482	jxDSR199zSQvuFBsEGWvtkCVTvEQU6tp4d8w1kTkzTFV2g6kK3P	10664	15019	15019	1618642620000
21238	3NK8hBLzCocWnAmevo4yTrvNNwo2z3DT9KCUioyQk4LbFXofWk9n	21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	80	1027	386	12463	13485	jxFP1DdbMm7y5XE5xwycs9MsWw8Kd9bbH6cSPaEvAoAkaEN2VRy	10666	15021	15021	1618642980000
21250	3NKQxFVWsw3QpBBog4HhcKU2tdtegDTT1FdEh4Xez2jG9S3wTtNo	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1672	1159	387	12463	13494	jxTNwtvd2Fy6ry6aABgmT99xdB9aAJrJmxDjAJK8aQ9TKYBvPwd	10671	15027	15027	1618644060000
21254	3NK63pB6bUU8ztXk95L76VzYHXmwi15J5bZBCqNwLSaRQq8EMKgn	21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	1406	1393	387	12463	13498	jwS6hCLJwgkmzNY4VjjZniHoCsisjbW5u6RsP23wmpqKdUZanBN	10672	15028	15028	1618644240000
21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	1668	1004	387	12463	13499	jwBSshx2WZjVAse5wdVpas8C1UBpXGxs4sa4fQ9FoHBgzGq8nGz	10673	15029	15029	1618644425122
21263	3NL98NgwUtYDEb7BEkhEMJG77M6xXtLujmK15ZXEhCncx6Xm2WFp	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1670	1156	387	12463	13504	jxfGLDRvKqLbuLPgERY95WDBXKr4AuuqmLVHVTq5ZkVVQnGRaEo	10678	15037	15037	1618645860000
21265	3NLWsfv3HGGKXD1tsi2k3Nsa4FjBNcJ5GY7DW794hxznys3s7Z4i	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1426	1364	387	12463	13507	jw6z7HxdYaE6R85vpY4dN7mXkQxhEyF1g8fTXCWgWL1ZEbfUU76	10679	15039	15039	1618646220000
21267	3NL8aLaThcASht54XjXZMKEGGNGiRRwJjRNXYHPSsYNBAiwQa2xD	21263	3NL98NgwUtYDEb7BEkhEMJG77M6xXtLujmK15ZXEhCncx6Xm2WFp	1476	1371	387	12463	13509	jx6NPmh139nDcabvd3dJtbsgXmS5ge2Nk5xJVhgeVsfvEJX9QFj	10679	15039	15039	1618646220000
21278	3NLnhvoUehAK2DNtBDTp9fMLkVSHP9UcsDz1NtUz7PiBD1tjMH6U	21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	1451	1292	387	12463	13519	jwyaQwHgZF3SHrBCdSh7PfZLEKNe4GScn1DevaYNLVhPwRVVSHJ	10684	15048	15048	1618647840000
21286	3NLbcPLbNfHEE24QzqNFbMuFj1E4Acw3aA4j9y18vqo5URZ3efEL	21285	3NKyZ3CidXrgK5wXTYbWyZDnXnahskVGJzwp9JYM64YFeowsCAr3	1508	1387	388	12463	13527	jxxTzAn3xnmfp4M4VY9nfjWDQemACryyj7f3VBxU2NM5a9vygVQ	10688	15053	15053	1618648740000
21289	3NL5yvj32mFNcPxpycSGCz2NiQYMRFMYtTkvDTtVX7sNhjwQJLVB	21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	1407	1395	388	12463	13530	jxzGyqfVZWoPwvkktosPUMHtUBNL5vQypEFZKYxapmnxeZLmkAA	10690	15055	15055	1618649100000
21291	3NLyboyUmsb8UPvk48KeazPoj9dDizS9XNm3bgc5T91iogNnnHBM	21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	1650	1009	388	12463	13532	jxF1AYG8tHTeNQd2bsp8MvbcbMfDjSUQiQCFKvmWrcPo6j2UX8k	10691	15057	15057	1618649460000
21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1593	1100	388	12463	13538	jwu8HFaRtwBJk3kJfJDS2ZkZTnQvLqQcufvmJi5Fp6VFbahn2qD	10694	15061	15061	1618650180000
21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	1547	1378	388	12463	13540	jwbcRaAMFYFVXRnzw2ULTWLs6Bec4gYbfgektHLRzZToJEVDtLK	10695	15062	15062	1618650360000
21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1581	777	388	12463	13545	jwzcpTfXr6vCM9EwCtuMfk5YYZavGpEs3rgjremqzMA6YbqmrxY	10696	15063	15063	1618650540000
21307	3NLgCS8EiEyTXdppaAujUT2VkkDTCEPPXVqGnJckQM7aKnUrVDys	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1506	1247	388	12463	13547	jxcyVJmyFtayhWZ1jDTT5gKU3xem8FAfNqK6w9wjTsMCfQyeydh	10697	15064	15064	1618650720000
21311	3NKwt6KNwXig9sPyRi8vsJLY2iBxCsYg4dcTY2f2ruy7po5AG8DT	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1633	1024	388	12463	13548	jx1twTMAC3LXWPwyJxMTmEtMqA9ayHnyFxuPT4yXHJmLGHiZsVe	10697	15064	15064	1618650730082
21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	1508	1141	388	12463	13554	jwzTuo98oo6dWimZc4nBXQtiow4NYrJ45xfSYGYNJvS3THAVPey	10700	15067	15067	1618651260000
21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1634	1331	386	12463	13459	jwLiAQqh4oE2MH5mUycdUdhWQfpaJ8Fwo5oaQ8TzgCyZxjCKZmS	10651	15000	15000	1618639200000
21218	3NKKQYqUgUjrsKwE4YF3gv1SwgUbvVHZ3oXZvpKEUpWV8PnyCm5i	21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	1552	513	386	12463	13466	jwhR2eLqSoFBLn2vdNjDXeoVaPrZcN5kdS7tjX92ibqamNP3bEG	10654	15004	15004	1618639920000
21220	3NKo5eEb7xsSzcqeFkpeE8fX8bNZz6NSPJozkAh2zA4LPo57MWya	21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	1555	1347	386	12463	13468	jxzFoucizSGx3bU3EB5BNvTmVMv7JdcumXyZHA8NywKfNpXzmFi	10653	15004	15004	1618639992425
21221	3NKJcfXKbCVcucb3K3qaKAYUdHH5h1eJk2h17bKmG6XExevCsuhG	21218	3NKKQYqUgUjrsKwE4YF3gv1SwgUbvVHZ3oXZvpKEUpWV8PnyCm5i	1406	1393	386	12463	13469	jxoE1ZcWBqAkHPXJHutoiwdB7Fmy27YDAtECSYNwSDiPno3XsBt	10655	15007	15007	1618640460000
21224	3NKs79kDS5H6KcpCUSpjshB3QDpvp3bsRy4dPa7Q3YQzEY49ruqv	21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	1608	923	386	12463	13471	jwZK4h1EuUZguormhnuJCMHeStJb9Duou5PRXeA1qs1Ks6Vz2yv	10657	15009	15009	1618640820000
21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	21225	3NLFLh7MNSzV5q5XWfS51FnLrh367dADuq3Pj4nhTqxSiJ3w8ZP3	1611	1341	386	12463	13473	jwYPsuX3oktr1pzhyESSozEtsmVyyGuGSQwLe8yX97sLWMzFpHx	10659	15012	15012	1618641360000
21234	3NL2RRmAS2xCFndzeh1eMk61njgE9E99w3ccV9nTz6KSaujnqLXs	21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	1522	1076	386	12463	13481	jxsximczQxVvKTTK9Ya2KW1fX5TKAuokciUFaETmRg5rsBtcRHx	10664	15019	15019	1618642620000
21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	21235	3NL1fJypFKik7y2e15G4wd26bEHEuzdUs1tYNQfsjByLhvhZQqXD	1405	1	386	12463	13483	jwbktnPzbwuQcb4HXBpVDvTpwiEtXbGnv2WBvBipUXLC9UW84XM	10665	15020	15020	1618642800000
21241	3NLgLQ9AHyi7rJgWwe23AipSFn8V2MkwtSexk3RM36zXxyWaB7Y7	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1444	1135	386	12463	13488	jxoFMkF17CXYp3ZYDpet79Xzjar91y6sv8ub9sUTfeTQi6ZdCJJ	10667	15022	15022	1618643160000
21246	3NLYMLE1LoFHDCGKNkXqWr4XqAeGNrCf72iSfCxssHX7jz5LBcfA	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000
21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	21247	3NLtT3iNyiyR2tzHLJgGax2kYhn2qKqsUvJ1WjcVx5Aw6fatq7xr	1547	1132	387	12463	13492	jxf8t27BJMNMtxSVEmnpQjMw9E1VocT2HuafqEXpRWvTQXCwdxi	10670	15025	15025	1618643700000
21255	3NLDqGqi2jnfMDkEiiUtgEHfHzabVcN56SLVJ776KrHpasWso2wZ	21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	1668	1004	387	12463	13499	jwBSshx2WZjVAse5wdVpas8C1UBpXGxs4sa4fQ9FoHBgzGq8nGz	10673	15029	15029	1618644420000
21257	3NLveZRn4CoZ32WWN9zUrLiEN3MFafF4kYCqBeAygQFU2EY1cfg3	21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	1483	910	387	12463	13500	jxFfkCdzmnHufLWMA7dkvTA5zz5TWMhtfkYq8YwKQPSV9n4fYzK	10674	15030	15030	1618644600000
21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	21259	3NLrzeEyEZAdtBpEzuToEKU45yGbzZRaJyBtXkw2iEZrAgdLGYag	1581	777	387	12463	13503	jwMXrAswe7VcHfYQpdfMJQm9vaTE5Qo2Yxkwn2AjGAM4Rs6ZPzR	10677	15033	15033	1618645140000
21261	3NKubqHiNdn4Yrgn2CX8kdqF95TiSceW4j9t9JHeWuNx5nkgpXBg	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1670	1156	387	12463	13504	jxfGLDRvKqLbuLPgERY95WDBXKr4AuuqmLVHVTq5ZkVVQnGRaEo	10678	15037	15037	1618645862597
21273	3NKBDWzbDnyP3ZeDCwH3h6eKCW9SVVh9x55Fk4a7HQntZ8FCwThH	21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	563	1359	387	12463	13514	jxHB7o7s5ySc6UWFfVYwANWnmjgQt26NkMxtVFjKw8p8jz1UUxo	10682	15044	15044	1618647120000
21276	3NKAhYt2CyLZw8pXiNdR5Fxd9Veu1ppVc1GiWuFGuGpSsVoYDehi	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1451	1292	384	12463	13517	jwXSoMfds3bBZsFa9o7mTgzTT6xPFGooVjLfqNngq6Ro32hYR1w	10599	15048	15048	1618647840000
21279	3NL6QuWkv14Hx6notNfpkP9MKRkbWbpYX4GfQ7i4AbgBn58aqR5N	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1451	1292	384	12463	13520	jwtcZC5nrenpN7HjxE2AWPF2n4anHuMBK4FwrzWXKx6VpozRNuA	10603	15048	15048	1618647880075
21282	3NKURJkNo8ob67mZibZXKQBFE6rj3xeeVKarPEXgssrbENCH94Ur	21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	1403	824	387	12463	13523	jxx9A9f4TZsQsF2dDKkCG9btYkGjwfrVrpeuK8mi6KtV65pC4hn	10685	15050	15050	1618648200000
21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	21286	3NLbcPLbNfHEE24QzqNFbMuFj1E4Acw3aA4j9y18vqo5URZ3efEL	1426	1118	388	12463	13528	jwxzzmmVXYg5kKUFVk9U4kWDQ92egeD4nbR8kD3F4M6guXT4eUN	10689	15054	15054	1618648920000
21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	1489	1380	388	12463	13531	jwKwKxQghv6B6VMEn6Dg6gmH7q385is23ai3yQNsiPaMD54ejdY	10691	15057	15057	1618649460000
21292	3NKKoY4T8G483cBkkmakqjJEWNRgJro2iSmXoxhiq3MoPvTQAXps	21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	1467	1376	388	12463	13533	jwiFHQKohyvC3pe47bF4DDNHhen5SiGMnoFNh5ve2kdRPMx1ejC	10692	15058	15058	1618649640000
21295	3NKobGstP7jLY8FgzvaZqYeHhmMTpHb9qUhpTAtCKDJ3C6umqNNQ	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1490	1274	388	12463	13536	jxidmAvCNP9uVNr1NRHMGpN6Uabe3dH4bcJ76spv7SujgYiaagA	10693	15060	15060	1618650000000
21297	3NKZn9gu9SDzbZKMP1wJpm7gLASzU5EGYFEwGKKUEqqHYa8wuA5T	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1593	1100	388	12463	13538	jwu8HFaRtwBJk3kJfJDS2ZkZTnQvLqQcufvmJi5Fp6VFbahn2qD	10694	15061	15061	1618650183009
21304	3NKP5cckRVDkwUSF3zTXFXQufkoQByTqYa46aEFyt9YgDHmF7Pn1	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1474	1329	388	12463	13544	jxkq545JrN1yhiU75dUhSVyQXMQuNZX8E9Vkd3DPPaHDzswDKAT	10696	15063	15063	1618650540000
21309	3NLFjx6Qz32obiFQPZB6nyP3LSqJLbnYBFfM6MYPSZ4wJwaaDjsj	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1633	1024	388	12463	13548	jx1twTMAC3LXWPwyJxMTmEtMqA9ayHnyFxuPT4yXHJmLGHiZsVe	10697	15064	15064	1618650720000
21312	3NKhNsHojTMoSEBYYpXTUtmzJa6xCt1v4eKrBr5ThGZBUpiVktLN	21303	3NKSMhi4wJUE3Cfb2PCkbPWNtzkYwVVDNzbLBDdA5hSKErNva2nC	1489	1254	388	12463	13550	jxfrnEiZM22SFEvWt38esutVcLppKf1Ku9c61CeZvGnQK6EqjoQ	10697	15064	15064	1618650720000
21320	3NLBgMQ5dHpvmNKxQZF3cdszRsEQxTGkVaGcGCfUagJRZSYdF9Br	21319	3NLFyAMyYS6pyYkMhrggZYhwxtN4EUCeA6p6Jxh7yaZYV5Vb6GMg	1553	776	388	12463	13556	jwuvGKhewQVKz7CNYBDKFNR741VCZ49MubUWbShe8vCkcUwiB9Z	10702	15072	15072	1618652160000
21323	3NLnMschd7UNMWN2Bgr3NzA3muj1qWK5LWWe971918bzCC8rx2Lu	21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	1541	1172	388	12463	13559	jxnS325SKFXq4hBxK7tmCGGDhfBzpKDbazsR6xBL6A6vqmwhTjy	10704	15074	15074	1618652520000
21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	1599	1287	388	12463	13561	jxFuCncr1XnT8rzuCrAq1oUmw7GzwyqtigEhjicEkYEicqUoqW5	10706	15076	15076	1618652880000
21328	3NLbkSueqqkoH9dhjLBZj1BqmrbGWiGvLFhzmgbPsCRmDDh6fm69	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jwB9mDrX5g5TZTdi6myGWopkSafqMryBB3xj1X1cSBNDVy3pQRp	10707	15077	15077	1618653060000
21332	3NKjr9PgssGxaZsC7Mj6CCzD8WmDevSKtkzrSh3QdKQhaGENYudt	21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	1522	956	389	12463	13565	jwvU3GVFDgemUdkKRAgMNrTccaQNpcy1iCUpJiTJCfa3ytbE9XU	10708	15078	15078	1618653240000
21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1522	1076	387	12463	13505	jxRQf6VxkKfSdpfJGnaFxYP6EgSFvK2Lwv1bRiFun8RpfQUELcF	10678	15037	15037	1618645860000
21264	3NKuxZAhCPQyBMd9Yq9SECQCurKA4YiLxHWFs5Ub9m6KXicpEPh6	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1622	1110	387	12463	13506	jxeEGwJ8w3HLgVgoMWJCQS2FrtGGyQNAWNL9kV9F7J1NwpTAKA9	10679	15039	15039	1618646220000
21266	3NLphLvv7fa1WyAx2Et2K6amKYcSmQAD7cGsog17mEYaA8n5BWfG	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1476	1371	387	12463	13508	jwnyXyhwjbUMMgcsXTUypXAcbXppjfccpdS5kkuweF96QMUa2ed	10679	15039	15039	1618646220000
21270	3NLJvpa1kdVLuE698LCDrXHRep1dRxu2PMQPVRnUw3rWZ6dvdQYx	21266	3NLphLvv7fa1WyAx2Et2K6amKYcSmQAD7cGsog17mEYaA8n5BWfG	1444	1381	387	12463	13512	jwmeBTEkhU8smjs48pe2n8pQZJkvhLBTALWmFDnARJTDTY7uRQR	10680	15040	15040	1618646400000
21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	21269	3NL8TNBN4TrJWsdvVLALEFeye3d3wYdSHjqnpTA7tDkK9SJef5C3	1406	1393	387	12463	13513	jxHhdr4ii4pWtFzZvTbqEEJBKyNg326gR67Ygm6bo9k41niPos8	10681	15043	15043	1618646940000
21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	21273	3NKBDWzbDnyP3ZeDCwH3h6eKCW9SVVh9x55Fk4a7HQntZ8FCwThH	1477	1350	387	12463	13515	jwe8AC4Z4EdqEf8xTsh1Qs8k5pJQzfShfwL7JVtoZig8ipeWFZd	10683	15047	15047	1618647660000
21277	3NKEJavF4kmmfcbangvbi7MivoU8afBwLVcFHJNde37NPXMU8pd4	21237	3NKLKW4quLaSegib2RPA3Ad77ZmLyrRu4hdchcmPgJdCrt8ErpVw	80	1273	383	12463	13518	jwHLssMhh52nbBwESPcpKe278fMneJ215nwngSDahtHo3AnKF7U	10577	15048	15048	1618647840000
21280	3NKHz6AmRQg2gyeuL5YxxNeiVWns9DAh97nJ9FougNznaUZkEWE6	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1451	1292	387	12463	13521	jwe9QSfH3YW5wE4zJ4NyDAsN8W4f69yQnPp8kyACFcYxvHEZAxD	10678	15048	15048	1618647840000
21283	3NKMtNNkMWhK6m9sywvbvjZoMDBQwCp4tVxwjnascvdsTKu2dgMS	21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	1406	1393	387	12463	13524	jxq2MVduvRAZD8WPtXRYsz2rn1keKrD6GY8hTLSGYH4kmrW7awH	10685	15050	15050	1618648200000
21285	3NKyZ3CidXrgK5wXTYbWyZDnXnahskVGJzwp9JYM64YFeowsCAr3	21284	3NLfmSxA1J39qmcDRuSKwQ52QTnEGVbo7W1bFrMq1ALJRMmwD3Md	1581	778	388	12463	13526	jxFswQCmXHKLgVNJ5L3H3HXgNnv192vbKCH1BCg4jh1pvmfbFFQ	10687	15052	15052	1618648560000
21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	44	1325	388	12463	13529	jwfubMLCb3V1aS2EW3ZVcLPdfae9UqAtXqam3qwoKCpN2cYnjJL	10690	15055	15055	1618649100000
21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	1637	816	388	12463	13534	jwQn8NZAehB4YnfoRdJtgqsUnovaMT913cNXxtZmKPvt66m9ECc	10692	15058	15058	1618649640000
21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1407	1395	388	12463	13537	jwenqwKws3HCgiWLkuNBDmwZB5RUWcNWX8i994WTBjEN9x5ejY4	10693	15060	15060	1618650000000
21298	3NLX34i7oRQEw8MAhdZX4FDpqFoGz5uqV2abwJjBMhjKPT5qhLFK	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1406	1393	388	12463	13539	jxrfMJ9KHFvRNvLsN151nGEYCaWZcZALJ95GjuJV4bX2EEit6Qr	10694	15061	15061	1618650180000
21302	3NKuTpJEBAYNapkAfvS7WKB72A612qi5qwwngf2YVMbL3WVFqSVf	21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	1474	1329	383	12463	13542	jxvSPriMdmXd4mX1cgsJ6rTVdKDwPxt25QRRkPZ8LCsATbpoeAN	10573	15063	15063	1618650540000
21306	3NLVM2UhJVgBx8aKvVbhvdGswmD542R1X3gvgxESsCxEGCN1FMKF	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1489	1254	388	12463	13546	jwAVcykVrDhYDyKmg6gFtizAaq7rjx5bQ5bm8UUycmpq7znXTbG	10697	15064	15064	1618650720000
21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	21307	3NLgCS8EiEyTXdppaAujUT2VkkDTCEPPXVqGnJckQM7aKnUrVDys	1421	370	388	12463	13551	jwJd66duP5nx78Zmtx9HLEhN2ryBPuacQ1sksvCgASb8Q9UrtDz	10698	15065	15065	1618650900000
21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	1407	1395	388	12463	13553	jxS4eGAocerfJa9qNB2Kj56wRxsb4Du9NYL8z4aP2Xvgr21xr52	10699	15066	15066	1618651080000
21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	21320	3NLBgMQ5dHpvmNKxQZF3cdszRsEQxTGkVaGcGCfUagJRZSYdF9Br	470	1063	388	12463	13557	jwcm3z5sUwqzLPbyYWWinMwQ3ndkHb1pZDAjjJ8qAX3KihZQdLp	10703	15073	15073	1618652340000
21326	3NLpnqqCuCG1WwT4RHAQBhnHH8YF242cDs1fVPPCZkNjsjfBZmY2	21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	1599	1287	388	12463	13561	jxFuCncr1XnT8rzuCrAq1oUmw7GzwyqtigEhjicEkYEicqUoqW5	10706	15076	15076	1618652882590
21335	3NKnREh1tgkN4gLwzUfqBXcfsK5ad37SePW6bu3EmQ3fBcup2NWe	21333	3NLGvjmFpfftkLscKP7RfCYpEYd7LvX8fisFP6n1wPQ6cg1KUaAN	1594	1200	389	12463	13566	jwhJtZvbVhps1Q9UgWGt7MZLXgZzDeRcEPWhzC93NFCoqGt2jAk	10709	15079	15079	1618653420000
21337	3NKvq4D44xc7J9UnuLGuzjQEuBdskyWifJ8ntL9F5UweF2HzmoVu	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1407	1395	389	12463	13568	jwby6V8rfiw7bAsnFJrvGGAtfuhwm22M3RHn6mo8D2rj74gLNHS	10710	15080	15080	1618653600000
21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	1542	1304	389	12463	13571	jxk8q9qZ6emkeq1nHEwPAw1LxcSZ8Bjkx4DhTYBkZC6RT7Ni8HP	10712	15082	15082	1618653960000
21344	3NLUSdrXPNYiePqH5dx2XHkg4oiBx3b2LkCDPN2GqMTrjhE5iu7F	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1405	851	389	12463	13574	jx62m1L2UW9v7SCzNu3iboqMmhquAQfRmvuBgUMDScuaN7bbZCx	10713	15084	15084	1618654320000
21351	3NKky3qkPy3wWUtxYRSRdtNkG6nVr9WkvWHMoHpvsJ8jiUC3o52k	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1460	1078	389	12463	13581	jwHpvghzigsYmPyA4c3Dym1nqFXsULy5UavPuwzx8oLGhhZjeNC	10716	15090	15090	1618655400000
21356	3NKJDjq17f5Rjqq29JJpXn91SkCWLA73xTqAzV1trJQWy1wiwYse	21354	3NLizNQRgFELyS1frGB1TmQawaiWDCLsmxnzPV1PEpYbCBE4YeSC	1471	1386	389	12463	13584	jwdFkJEHPT6caS8dQPBBkqa7AzPWRaWY4fRhmWLDaVF5KKdZYHY	10719	15093	15093	1618655940000
21363	3NLe9gxWRoSq6aasLHWDQaap3pgPSs3zbtHeDqhTRkYfYjpAkPDg	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1542	1058	389	12463	13590	jwsZX8y4iqy4C5ipfTieY7mut5boYjvHkJeHkdmCGb3NQt6HFNe	10722	15104	15104	1618657920000
21365	3NKt9oeXUguaUanmdLen2GvhQhW6mNAZvzbAPcSW1q6mbPK5LsM2	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1611	1341	389	12463	13592	jwLpR146N2GWNNj7CBjoMwuD6BCPFpk9zWXh5bodTQkNbKCoq43	10722	15104	15104	1618657920000
21367	3NLEwkwbDvYR6AFPGf9vbwWH572czkCXaHc2Ukn2LcMVmy6jRSid	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658100000
21374	3NKahMqVjiLyT2QP8J4WTraqBdH4QVXKgh7GgBWPZTfJ1HtjpUUr	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1547	1252	390	12463	13597	jxDq6UHHUbFwe5NJMRS8Qdwhv6xGJW8HPHJ1osNnmVpK2dvMF1B	10725	15108	15108	1618658644883
21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1419	814	390	12463	13598	jxGYsbgLRa7vnqEuszzFz1BMkpD4RJ2Br8Jg5BwZRDd4aYWtzuR	10725	15108	15108	1618658646305
21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	21380	3NLagsxYto19Pbe58gc61D73Y2ezYd9uGzdBpePVWdFbhQTPRjDg	1559	1353	390	12463	13603	jx4k1rN1awAMCZ6gMmR2EqgtJsAP956VoSo6NYrbtux3MCQQhKF	10727	15111	15111	1618659180000
21301	3NLPSyZqkPdjVf3xMvitrAiRM2PADe58a5KSMVV3fgbQuqnAxU1h	21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	1444	1135	388	12463	13541	jxrzD6HQdKQjeGtc1VhF3k2MGRrgTwNZnx8WEFHpzUJnWf6t2eY	10695	15062	15062	1618650360000
21303	3NKSMhi4wJUE3Cfb2PCkbPWNtzkYwVVDNzbLBDdA5hSKErNva2nC	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1627	1385	388	12463	13543	jxxxW1jRVu5ynGJJztjxrCFPrxHhAcvi1gjrbXCvtQRiXNMNzta	10696	15063	15063	1618650540000
21308	3NLHzSkLQhhuAgGfFHG6orASxhmkhRCWRwJc5X9BUAHzByj7wkWr	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1489	1254	388	12463	13546	jwyDyUhPRYUqAgvLTbjTLZ5W5sfdTrxUW2ULLbedftWw6WSzxH9	10697	15064	15064	1618650720000
21310	3NKWjwFVZXj8GB1zRGeNGVCj4dAVHmPQyCkeFwH7FRHfzc8Kpj2s	20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	1506	1247	380	12463	13549	jxg6MDmAQPUa8T5cvxZznxTHnDz5yq56W87QbfTCdiUsrJwHXzx	10516	15064	15064	1618650720000
21314	3NLDr1DSUrNzh3CGFEBf6S4WYv8d7iWYWQPKg8YTV99Kzz5HF3m9	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	1571	1335	388	12463	13552	jxi6QtSPRhpjBMr8mWzb3oWosEf5KXooNCaLAGJpyzLWAWd3z3d	10699	15066	15066	1618651080000
21318	3NKQfAkPPqCAgBpuwgpjRGQ7XxW1629GLY6HFr8bWTe9h4P6mFrv	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651984574
21322	3NK3iGd7vqoGFzN1NjPcdta64hDkucr9Li9D3WnPvZAc8y9cDBDj	21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	1637	816	388	12463	13558	jy2ejPtY8m3MHNjtNEoZRTmVgetxeePsAUTBh1wV4AotT6H2M4Z	10704	15074	15074	1618652520000
21327	3NLNeFZ57mXT3dehjFT19NHa6oeQhaybTnR3TDhKmm1xRNeGm6gH	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	1637	816	389	12463	13562	jx4QLx7qp72gn8rLFGrmuhQryUmxRD3zT65kiKrqCMcFHsAXTVD	10707	15077	15077	1618653060000
21330	3NLUnLbR8eL99i3giqV9yoJk9Tm5RiU2Q8jNVVkgzxaRDhixbYX1	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jwQCvoKe4JPgA8P8sh3JSZq65aCdKvG6MbgYqBMJfe4FbcQnS59	10707	15077	15077	1618653060000
21331	3NKTW727UewpP1va4NJhZzit52MWkv7Vao1y5tAezXQcTVLHTPHf	21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	1503	1031	389	12463	13564	jxxCj486x4httUajY3BVopVsBboUCQLDdFnWrmjHqM23iqKRsrn	10708	15078	15078	1618653240000
21333	3NLGvjmFpfftkLscKP7RfCYpEYd7LvX8fisFP6n1wPQ6cg1KUaAN	21328	3NLbkSueqqkoH9dhjLBZj1BqmrbGWiGvLFhzmgbPsCRmDDh6fm69	1522	956	389	12463	13565	jxooYLux71RDuzn3DSNkE43WMsTnMmpDwM9xmNQXg1vmCYLnLVz	10708	15078	15078	1618653240000
21339	3NLPaTFzxs8Z6G8CL8FAAGEbsxkprXQMrNgJV8TVb7qB3zt3dJ8G	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	526	526	389	12463	13569	jwEQkddJrxYK4xi48Fsxee1bZijZydGxfgECEQmHYm6MHQLm3W6	10710	15080	15080	1618653600000
21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	21337	3NKvq4D44xc7J9UnuLGuzjQEuBdskyWifJ8ntL9F5UweF2HzmoVu	1553	776	389	12463	13570	jwV9FRTcF8DAEn2LjHUJEBozqZmE4LZgsKy2qKRa91Sv95mT2LS	10711	15081	15081	1618653780000
21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	1508	1141	389	12463	13580	jwHUEn828Sxi6FETsAZSrt3JQAx3yLwqUt6h27SY2XnvYJvGCZP	10715	15088	15088	1618655040000
21355	3NKkddaNEMs1V9S84dDQ7mJSqv54LxzZNzzg3TNwfQHXEN3F4BzJ	21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	1607	1222	389	12463	13583	jwoQKf2UskkaQyxsLUY8YEMefRtT23EEzseP35YXrsAMt8rF7Mw	10718	15092	15092	1618655760000
21359	3NKHYHGZ114LczHBxFuygKsyL8PDgnJFcEafYXxUu4ayxqnrBCzd	21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	1637	816	389	12463	13587	jwqUBB4wrW3VqFMHT8bPx2WN7MmRYt2UqFLf1eUTTM3du6b1zdJ	10721	15102	15102	1618657560000
21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1542	1058	389	12463	13590	jwsZX8y4iqy4C5ipfTieY7mut5boYjvHkJeHkdmCGb3NQt6HFNe	10722	15104	15104	1618657920000
21364	3NKPUDUXbtfuSuf3m4bsHWcK58XRLg8xX9piy1PnVhkPj889zHjW	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1637	816	389	12463	13591	jxhyB12bkjheTTEiZn1R5dAfznwfNm6SnWAkpEjjYqSHQtiJaxf	10722	15104	15104	1618657920000
21366	3NLbYSA86kZijBeh8hrcxbn8VQP2RPaB8nGsuYL2purmkBeA4Ucq	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1406	1393	389	12463	13593	jwTM6ch5fu1WviajVtHAcyvo2BWkwUdGBXhFL2vxD82V864wAoT	10722	15104	15104	1618657920000
21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	21367	3NLEwkwbDvYR6AFPGf9vbwWH572czkCXaHc2Ukn2LcMVmy6jRSid	1447	1345	390	12463	13595	jwno43cwaYqnr6zdcVGzuuAA8CLHGSU1wREw1ZfnNhsWLCtSnyd	10724	15107	15107	1618658460000
21373	3NKMv48bK2kAazoyPb2NWMF9FV6h6CRdGJzrDdqwdMCXdGXpawpL	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1547	1252	390	12463	13597	jxDq6UHHUbFwe5NJMRS8Qdwhv6xGJW8HPHJ1osNnmVpK2dvMF1B	10725	15108	15108	1618658640000
21376	3NKLJqvaBLRZBnQ4TcybxdBACGMsnVXi7cWVS9boJKpJkTNLPQYi	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1594	1326	390	12463	13599	jxgkn1W32U2diGsNgrhR5DcE4vWCAKCtGrm6m59wyxYFAzQSEZT	10725	15108	15108	1618658640000
21379	3NL2eU7DxEzeR5a9gUSyfg4yvRvSsGXUgjcWFzYDtjzN4Jf3YqWd	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1467	1376	377	12463	13601	jwW8CXsWx5DqSbLGn6XTQhkbCnJLBLSUFT12v3exDgq1jrrdqtG	10445	15108	15108	1618658768267
21383	3NLwfYLgxsK49Wctr1PPYbGAWigM8obyKV1SCWARXkdpjF4sn8Y9	21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	1402	876	390	12463	13605	jwNM2wfZKcJq6N1cdWtbXgbosG6tE7Fb1uWFJgLRjBQxidwp4PT	10728	15113	15113	1618659540000
21385	3NLVeSvNgYKQsJJ9ZBjSD8cw8sTvrqYhfYkphWtQN49sy6FX93Ps	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659723369
21387	3NKy5PcnnX1wTeBabbF4JoZmN39BxPv4mQaorDYemMXZu7Jfx6Zo	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659720000
21389	3NLUnw7sVe9mUJMfaJuyqPn48daSZSKFiGbgQnwbQRVSTNVrcZ96	21385	3NLVeSvNgYKQsJJ9ZBjSD8cw8sTvrqYhfYkphWtQN49sy6FX93Ps	633	1018	390	12463	13608	jwXBvnbGn7V6oGJqWhKA9KfVHf6jXKz8CZjVKrzyTSuhz4Ay9XY	10730	15115	15115	1618659900000
21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1406	1393	390	12463	13613	jwsyaXyZUAe8EuGrqJUXKXhnE7eDZMqRbQUUkHud1W9rZ3ueAJc	10733	15118	15118	1618660440000
21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	1447	1345	390	12463	13615	jwh9aFyv1dV7YNNPe2dYjNKudZayXvbg3X9FYKa47VMXE4m27wh	10734	15119	15119	1618660620000
21398	3NLdJQxgyRsN7xMkgcV8C7Htkb1p8a9b5bxX6oxhnvFLri2kEpDp	21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	1541	1172	390	12463	13617	jwMQBpB5QzjcazoScFUwPmX4QzLhG6G5tpRyihrDviuNNnW9Rw2	10734	15119	15119	1618660620000
21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	470	1183	390	12463	13621	jwFPvcboqYwQ5MxnMtCCx6ayy4vs5Aa96WLr3NQrhWq7rHpnZG4	10735	15122	15122	1618661160000
21403	3NL53dV3Jae19h3e7iwN1RhTDG6gTm2KmKFzMVuyhinkCPYGv1FJ	21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	1402	852	390	12463	13622	jwq6JtDHN8qayUPL3PR8z5WxX2FPo16LQkd2ChbkeavMMbEPupF	10736	15124	15124	1618661520000
21317	3NK3zSMt57khQHKjRTwSydCzZDYPNwZBc5Ak8yznZhgp3GsHWRGb	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651980000
21319	3NLFyAMyYS6pyYkMhrggZYhwxtN4EUCeA6p6Jxh7yaZYV5Vb6GMg	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651987488
21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	21323	3NLnMschd7UNMWN2Bgr3NzA3muj1qWK5LWWe971918bzCC8rx2Lu	1579	1389	388	12463	13560	jwVWVUbWXXvyd2Kp5k5kyynZ6QtVudc1YwYWo9Hbc5cocQQjtFt	10705	15075	15075	1618652700000
21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jxmUHgHVzfBkDPZsbQDsUmwCQwVi4KzMvW6K4zUNviN9BCBZ8KK	10707	15077	15077	1618653060000
21338	3NKrdECjt5MZjctj7viC8aAZvEAyNzo8kQmoWpiUXC5Y2Y43sCAd	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1672	1285	389	12463	13567	jxCBY95kFFeMrf6fwDQRG6qTkr6cPy2dsP9tUL2kcyTiLhgqT2C	10710	15080	15080	1618653600000
21342	3NKRsZgs7d1BMrgsntkchkDr1XqHpeTGXXecW7dqVbFVCyE3spNh	21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	1549	1362	389	12463	13572	jwRmee4TX9brdRBu1VmdQcG5C1e8DBxHodzL29cojrcYZ72N5Ue	10712	15082	15082	1618653960000
21345	3NL2esgbbgCFsMGVs3hxJBbi146cG2gHQgYf8J9rNQ77YqiXxPRx	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1483	1276	389	12463	13575	jwtq1QDg2YGRXQRCyNCaWBTVAJThid7wgzJDEFteFgLgPmWSrLz	10713	15084	15084	1618654320000
21347	3NKiE59mCF5UdXMSRyBJseZaGjLaoUA5UvKhv9nHNRpu4BmWFxPr	20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	1483	1276	382	12463	13577	jwpFXgZ7mS1uhcPYFyum3hx1yDg7QTaZshpBV4kZgzuCk4cecis	10549	15084	15084	1618654320000
21349	3NLF48jqbqqP52So1tcqdioXow518G5RdBdaaWEM1RukjAmG4wyz	21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	532	1057	389	12463	13579	jxUjG5Nf5xvhtDhfwNCfEMWhyYvSQ4YdREL5saaP67QEXgx5xRD	10715	15088	15088	1618655040000
21352	3NKKLAB4znymkjAiPKTGtjqmq3iFNAx6gC6g5S9zbSgyhenGLNkc	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1460	1078	389	12463	13581	jwHpvghzigsYmPyA4c3Dym1nqFXsULy5UavPuwzx8oLGhhZjeNC	10716	15090	15090	1618655403404
21354	3NLizNQRgFELyS1frGB1TmQawaiWDCLsmxnzPV1PEpYbCBE4YeSC	21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	1607	1222	389	12463	13583	jwoQKf2UskkaQyxsLUY8YEMefRtT23EEzseP35YXrsAMt8rF7Mw	10718	15092	15092	1618655762869
21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	21356	3NKJDjq17f5Rjqq29JJpXn91SkCWLA73xTqAzV1trJQWy1wiwYse	1553	776	389	12463	13585	jwyqYDRfvNBZ4L9Fp4iPCSTgtW1pVtaNLSm2UWrKvaNEqa42N75	10720	15096	15096	1618656480000
21358	3NLcAHukUWaz7ttjgiXLL8ptKF5WxsYtudZuDVPGBaSmv3HKq5rw	21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	1581	778	388	12463	13586	jwXcofobYfMLfR8wkH9Eg9C1cJHL2cMFbLzfrkCmmsbJgnNAcFX	10700	15100	15100	1618657205462
21361	3NL5eBa2bNf2tfyyr2XL6CwtmxsdUrYXbfSsz7D8jsYCYSioxmwu	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1403	824	389	12463	13589	jwKNMAqBqMpd28FVY6XoAG431yezYcwuT8MPhHqgAV6aa4PfM3H	10722	15104	15104	1618657920000
21368	3NLaauqwED9nTXYh1gwgC8zYQW69MRZ9V1cZEbgP4g7ATwZSQ74r	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658107725
21370	3NLJDGbFJhNLF5yfwpMSQ8QCYXimbQhxXi7Ue88X4kLHihBKmuai	21369	3NKFPv8X6k2jV6UwnjEtokcYJ1B4HDxQm8YWoREDMt7gXfEBx1pJ	1447	1345	390	12463	13595	jwno43cwaYqnr6zdcVGzuuAA8CLHGSU1wREw1ZfnNhsWLCtSnyd	10724	15107	15107	1618658462967
21372	3NLSrfx7roBCwe4dNq7wFrTut7QXM54P3LPicVUxeB9ZrvvC8y1S	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1467	1376	390	12463	13596	jw99vqAPLRAX9ZjejfhwdxJraKELJ4Fr1Q64vbb4ywdWyLfY1HZ	10725	15108	15108	1618658640000
21375	3NKivdCaWhFmqwheFosmi7XZDTHcQe1VWNszeVstjRjb8K3NZBzj	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1419	814	390	12463	13598	jxGYsbgLRa7vnqEuszzFz1BMkpD4RJ2Br8Jg5BwZRDd4aYWtzuR	10725	15108	15108	1618658640000
21378	3NKuxYuEQgvGCJqvhJgGEwgDMLDbJ4q8PeG9H6cQcHPv7aLQvG4B	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	1467	1376	377	12463	13600	jwYMJjyEkJ4iDZkWFwJtUQAKkeMqTsJ1ek5NVKJWfiYS61L9LLA	10441	15108	15108	1618658738569
21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	1579	1263	390	12463	13604	jxm9j2uQpiu7kJAJp9DB6ywGRRLFojtKDG43s7Ez68fvKzJmemi	10728	15113	15113	1618659540000
21384	3NKmQcWpZyaZBzuVpfeSvKzMG5jGw3Mv6qGehr67jMXTH71v1HUA	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1426	1118	390	12463	13606	jw6cedpe4j3XkHrwqbviAYhJutxXa548PFTw1mk5BSowuFwwBkU	10729	15114	15114	1618659720000
21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	21390	3NLGCBbF4Kj8zuNqnD92SXKpXHbQZypBSTViu4sUEE2mbDeosR5n	1536	1187	390	12463	13610	jxTdmcZpJUK8P6Sh4mxyB1sRYfU1z5ZhSWWwmx4kMxECfwGh6kU	10732	15117	15117	1618660260000
21393	3NKK8kJYefGk4MYUJbK4MHLwftX3zvA9d9KLmrg5hTG4WC2NiST1	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1599	1161	390	12463	13612	jxU4Z2JZwDdv76b8xxMuhM6TcdWHWURFb9N4E3ZXdJAvFj19yGN	10733	15118	15118	1618660440000
21401	3NLbxk1QQ3VdyMdAnYeVLoPUS98Ajv1CnHkG24C5ePCPejx8FhE9	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	532	1303	390	12463	13620	jx7awFncy87xScc42KWmhMHyfVULb95Y5UDZ1mPEYybTPRsfhs5	10735	15122	15122	1618661160000
21405	3NKWHeiHg3KkBH5wJFhe9XKorfuKyDuHofX6gAfu4cfZNpezhFZk	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	1588	1266	390	12463	13624	jwU1GqrfAdjrwT79xBARqaNLyKqt9L8XBSvXzAB6am41NsSfid1	10737	15125	15125	1618661700000
21410	3NLLM1PihMTu1j1E1zx5w3vURQu1LAwkdfFC4m7vUVpJH596pk2v	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1406	1393	390	12463	13628	jwM1QrjMYYGRAJBJiW8zyYSpAu9fJLoLUr8kasvap6PzC9B8wsY	10738	15126	15126	1618661880000
21411	3NKhZTCRuP4MnJziyJwdvXsWaabDvTTCo3qjv6xiwKZKMVv2fFbB	21205	3NKmuvwaKsK9mvkRLVoL45ZduHbYnDMeMNKDWXwXf5fBAUv1CrLH	1647	845	380	12463	13629	jwxT6N3o2tucX1LkUcamdJpM7x9w6snwqTHU4Q8spvihHXmawrX	10463	15126	15126	1618661880000
21417	3NL14vn9DxbKkz3riPJZ17Bfz33iSpPpfRt6LfC8twjh5jmyFtNn	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1657	1344	390	12463	13633	jwAk2NzW9mHb5ZWo8UJrp1EfeQpaeAvPbhokfJk13YehY2b2du9	10740	15130	15130	1618662602670
21421	3NK946JfNde7Wj4gjJbX9CbEnoUnZEoFVdpqcdrM67rBHWqEzDXZ	21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	1445	924	391	12463	13636	jwFDBMyYVAjpmgcsjfceGE5JdFhUGaFU7UEJswWpofQP9XK2Pje	10743	15133	15133	1618663140000
21423	3NKT7jmyU1WLsQrgCEkw26EaY9SkCSqhhbPsM9Zihb7SA29fLEez	21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	1483	560	391	12463	13638	jwjkogogp4w3NbdYnW56HuFFgtDoPgYn8YjCFzRjSyAgxJU9mGX	10744	15134	15134	1618663320000
21426	3NKiJ39BGRZKo2MUengGHLjqmjdy3MR4ZD16e76Eit8FTpty2Kyy	21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	1406	1393	391	12463	13641	jxMS8CZsNAgnxmh6bKEucTG6hQCcUZYiCUNwa9nY7jEmC1pNa5R	10745	15135	15135	1618663500000
21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	1406	1393	391	12463	13644	jxczzmiNvpAyt7oGSLTLTqhrqEtHvjR7CkH3WJS48Rvfpfjw7H2	10747	15140	15140	1618664400000
21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	21332	3NKjr9PgssGxaZsC7Mj6CCzD8WmDevSKtkzrSh3QdKQhaGENYudt	1594	1200	389	12463	13566	jy2wNBmV9YMjRnBQavmjMSAPsjSgJoSSLANKZ9VBquh9meCVDs5	10709	15079	15079	1618653420000
21336	3NKisMZYLrQecdp2axTx8g37sd1Nr74bJrNvJSXtBhgwbYbtFqAj	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1672	1285	389	12463	13567	jxCBY95kFFeMrf6fwDQRG6qTkr6cPy2dsP9tUL2kcyTiLhgqT2C	10710	15080	15080	1618653603018
21343	3NKMHjqC9VbV1H5NfHFWGGrGbMwAzc2EXrSxK1RfRAHd5vgQ82uU	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1600	1126	389	12463	13573	jx4mzFD4LQ3iaRtNb6wwF88BqkCXoqSYMdombFFU3F2dc6Nenjx	10713	15084	15084	1618654320000
21346	3NLXtf7wazsfUYS8C5L8fjFz6h3UcGNDp2x1nBXqPg9Ge1rs7drj	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	532	1303	389	12463	13576	jwjUJz5m1tgn893JaH1hLmA7W41RjEmtRCEQtogPw9XocL2YJ5q	10713	15084	15084	1618654320000
21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	21346	3NLXtf7wazsfUYS8C5L8fjFz6h3UcGNDp2x1nBXqPg9Ge1rs7drj	289	289	389	12463	13578	jw6pEyQuY3xVR65QV9bzogoQ6Z1geWHeS1Xt1x93rciFkkiFfpp	10714	15087	15087	1618654860000
21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	21352	3NKKLAB4znymkjAiPKTGtjqmq3iFNAx6gC6g5S9zbSgyhenGLNkc	1501	1360	389	12463	13582	jwbPbWHrxVLqC5Y8XuPNPesx9DSjPLEjbQNCrdD8SiNindFeZwr	10717	15091	15091	1618655580000
21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	1402	892	389	12463	13588	jwXbgNp355VMfv6hx9xppfo4PbEVZV3ojMWNDjNh1DwpBcYXVYg	10721	15102	15102	1618657560000
21369	3NKFPv8X6k2jV6UwnjEtokcYJ1B4HDxQm8YWoREDMt7gXfEBx1pJ	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658110369
21380	3NLagsxYto19Pbe58gc61D73Y2ezYd9uGzdBpePVWdFbhQTPRjDg	21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	1637	816	390	12463	13602	jwySk7hHb3McAMkNRGNSi589wezZoD3qnJBiAaVEReWnwioEP8x	10726	15109	15109	1618658820000
21386	3NKPFSgfavpF5NEaMD9h1bQfYU9EavS5du89bA3dvELQJm3UQxj6	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659723739
21392	3NKBarD2Yya69WVFyxucLaYJMUqUPUwEnSTqkSUSuu8vd5z8ZmMw	21331	3NKTW727UewpP1va4NJhZzit52MWkv7Vao1y5tAezXQcTVLHTPHf	1536	1187	389	12463	13611	jwEwN89EfmX3r16S99KumQPQbDqV6u3FTr8HMJ9Wjj76vQoX4Yk	10709	15117	15117	1618660260000
21395	3NKTJYdyo7779RKz776yoX5DLEq2evgFZq9xyS4BRpdDJJiFDbpg	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1577	1201	390	12463	13614	jxRSD8QsqRYt1PmywNdqrTf9DJysRvW9Rjnyf23E9ocTD6T1La9	10733	15118	15118	1618660440000
21397	3NKBDJXJ884fLe3vxzLQMrNqSgrt9nsNtvS2tPBMvgMmvFLQtC8G	21358	3NLcAHukUWaz7ttjgiXLL8ptKF5WxsYtudZuDVPGBaSmv3HKq5rw	1581	778	388	12463	13616	jwQgtnWjFjNQ1QPjxudYHPpehgnnyKNQ11ojcaJZsfSTHKRjMRw	10701	15119	15119	1618660620000
21399	3NLFq1spiAXtzNUjMWR3cByFzXXDHxpy8e2SJvq9cNExPoTH5aPt	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	1445	1290	390	12463	13618	jy2MY4JcYQXfJpRTKtMAX9wFcY2govyKamZK1D8R1H5iiv2DkFA	10735	15122	15122	1618661160000
21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1407	1395	390	12463	13626	jxZV68s5Ytg6a6Sr2MzJCz9KVsodkAwRBxAFh3TzprteoeGzDxG	10738	15126	15126	1618661880000
21413	3NKoPfeEz2gKDvVthzNymJe3YANfxKmF6fnSK5fqSfuVDMNyZrS1	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1673	1368	390	12463	13631	jwYtcnH1f4LPbsGbT1GsnF2LbkS2F244cBarSzkaozzJTBaLin5	10739	15127	15127	1618662060000
21415	3NKnaEMfSMcc8aDJYbgunqZ8GfmvLn7D5fFnqiwyP4AQ2yLXY2Um	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1549	1362	390	12463	13632	jwgDqaKw1W88d4M7c3fJtr8rjqRdsxV9Hk8tkRhJTqvfYMPcGRx	10740	15130	15130	1618662600000
21418	3NKd35QPj8X3e1V31T652VYTLpF3fZnHxYr5vtoA3GQ9xbt3FeJN	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1549	1362	390	12463	13632	jwgDqaKw1W88d4M7c3fJtr8rjqRdsxV9Hk8tkRhJTqvfYMPcGRx	10740	15130	15130	1618662600000
21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	149	1283	391	12463	13639	jwStq9Vf8YQWxB8Y1ainhhDa9p6cW9tCax28eyvA3Ae3bqTBynD	10744	15134	15134	1618663320000
21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	21426	3NKiJ39BGRZKo2MUengGHLjqmjdy3MR4ZD16e76Eit8FTpty2Kyy	1483	1276	391	12463	13642	jwK6hgNRK9KwKiQTPgCi1vikuE1g3ZT7aT6cpH5US7xsiPMNZhd	10746	15137	15137	1618663860000
21430	3NLLpsTRm75uWikaicjFEj8vwdNAx8jMzTBigf33UFH8vJwW7h7c	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1656	1343	391	12463	13645	jxRwg7sz7gnKBNRzGwM2hsNp266pLfp4U6uwxRAWhKtNXDaRfQi	10748	15141	15141	1618664580000
21435	3NKKX9CZq8q8fvaCM7AY7vjfRHKHfCmSmTZ7qVFL8xadtidjkmGs	21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	1541	1052	391	12463	13650	jxkrP4BrRNKZkkPN83At3X9E1tteYKeC7bkhecQPdmZFjRgy7Ue	10750	15144	15144	1618665120000
21437	3NKUyTxrFJd41yRrBMRVsmbTmFKnDta6hfZonRgFGDnTWgezVVMs	21416	3NLJhcNXUHGstH1i1WuS8RAF5pBDSTVuS9hiFmQFt8EbZZm8nGoF	684	986	390	12463	13652	jwBKWtiL1GwVn7yWoY8Ee4iYucZwcsFT3m4FHssWVZxmCoMzm3q	10741	15146	15146	1618665480000
21440	3NLkcftT6HVhzsJCqrjVTsbWmhxzzy73ZvpQPJyNuY9pgTszLMFi	21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	1451	1292	391	12463	13655	jwEaXbtqyVJotRsNJcqYa8QoefQ698ccmGgxcoSUTwqbgFpEe51	10754	15149	15149	1618666020000
21446	3NK3vZrmvMhSxdTw4BEAoyrAoB59VUL9ffTYyoM9yjWBiUcHyzTN	21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	1407	1395	391	12463	13661	jwAmmg937fxDGVQWXp6t9aXpbLKZPwZ97CnKjgKAexLamvVRp12	10757	15153	15153	1618666740000
21453	3NKpntES45ktnNinx2u9zPXxsZTExmMWBKDTcCCwDgfU73d2xJV6	21397	3NKBDJXJ884fLe3vxzLQMrNqSgrt9nsNtvS2tPBMvgMmvFLQtC8G	1581	778	388	12463	13668	jwa2YRbh8WbypLyrgwfWDqsAEftUYhzuyJhyF28AovGSff4SVLC	10702	15160	15160	1618668000000
21454	3NLtpgYUGbCVknARsYwFkvcUDDgVjF1w7pu2yHFSofrF4uepDo6T	21452	3NK82eKFXXtTsWfb5oUsCrDbBpozMHaWLJ7Bu7QMSNHwAus3Cce3	1508	1387	392	12463	13669	jxoxiKK6Fm6wDZ3k4DA5sRwG9EgtVi9gpAT6cJoMhG36awgEQNZ	10763	15160	15160	1618668000000
21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	21457	3NKKDhCjY8rQE1TdX8FFBWCQieBimNthNMMwP3s7ZTWsigvuN1Ay	1406	1393	392	12463	13673	jxSvhx7khNADGFBH1DiAsiEgW9nXpo3Z1DTtdy1GuzyqYAYjsJX	10766	15165	15165	1618668900000
21460	3NLa2rkdU88f9f3oFtd5hT8GdDgMPtCz3anBWB9VEnW4DmK1Vfnu	21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	1631	794	392	12463	13675	jxEVsKHQhYfktMTPafVynhufqd4cRM1a58DJvNxS71C2REQjpT8	10767	15166	15166	1618669080000
21463	3NKtTY8Hkpz7JEtScCz1EB3ACpaVF2nMPoz4uPrXWhPFe8Vufsrk	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1652	1315	392	12463	13678	jwALPz3JPHZKzFcCZ8tG1fA8djgdJV9e7ZNewsEXJfp7gyKsR6J	10768	15167	15167	1618669260000
21465	3NLx7fNGy3YrsMdMxcKXmESdi8cL3q9MDDvB2cFa2t6V75H3Pd5u	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	606	1049	392	12463	13679	jwemUrMGGrb1ZtLjrFy2Dn6KXEpFLddyQjQDWQ6AVPb19JFEFs7	10769	15170	15170	1618669800000
21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	21471	3NLT8V7424sT5z4LTfCfLVqzX5PTSdTYtCffsYsWA7VQGs4om9XB	1439	1279	392	12463	13690	jxG5R5c13cVAmPCMeaXfWTYrcWpQcqtELW2EJwK8fZ3AcVBmDQs	10771	15174	15174	1618670520000
21388	3NKezPFcRzxxktadKUx4LNPSXHR9uRPvHKNeFN77EXDa4tmtQj6b	21387	3NKy5PcnnX1wTeBabbF4JoZmN39BxPv4mQaorDYemMXZu7Jfx6Zo	633	1018	390	12463	13608	jwXBvnbGn7V6oGJqWhKA9KfVHf6jXKz8CZjVKrzyTSuhz4Ay9XY	10730	15115	15115	1618659900000
21390	3NLGCBbF4Kj8zuNqnD92SXKpXHbQZypBSTViu4sUEE2mbDeosR5n	21389	3NLUnw7sVe9mUJMfaJuyqPn48daSZSKFiGbgQnwbQRVSTNVrcZ96	1648	1038	390	12463	13609	jwSzEUWo32DD16gechZUNP7zGrVDuE2fNjPH6fZPF7r2YrqrGGR	10731	15116	15116	1618660080000
21400	3NLJSJyjK52vL4GRThWPxE25UE2A6c2n4ffvMdR6a4Eyq2eqzybM	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	1471	1020	390	12463	13619	jwi7a3gM4RsFNK6RBUbWEDodDB33tbUsuVD7pS2C26swG98wGbg	10735	15122	15122	1618661160000
21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	1631	794	390	12463	13623	jxq6NUt5rBK2GQfMXL8zhxbwfn16KhcJEztWJ8GjyKQhrG8DwUA	10736	15124	15124	1618661520000
21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	596	1060	390	12463	13625	jwSMXTF2d4R345R1L6SmJeYTSaVNBNEoz5T6FoMDC3isWSUG8mm	10737	15125	15125	1618661712765
21409	3NLeAHyoFpaCseeQVhC8TfJRESjSyVWAXBneKdtiiSt1ezZhbLSC	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1408	72	390	12463	13627	jx4HGrz9UDyfEjjBV3P9bBqJy5u3fAU8JUopmdzd2JDnhSQQeo3	10738	15126	15126	1618661880000
21414	3NK4JQzzYsEV4Lig6hEth3rMsCCjQh8eot7rPQJGE189AjFNJiE9	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1458	957	390	12463	13630	jxM8wMg2QCQ2hCEBDLmNdUiLK7S56j5xyPo963Zq3WuzDQtrXqT	10739	15127	15127	1618662060000
21416	3NLJhcNXUHGstH1i1WuS8RAF5pBDSTVuS9hiFmQFt8EbZZm8nGoF	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1657	1344	390	12463	13633	jxY8scYgiub2uGx6wxXDGT3vW3HdsPtLYPhETxL9wMGHjnbc2Nd	10740	15130	15130	1618662600000
21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	21419	3NLbrGs7rG6PY3PDicsJt9WoN964ogZShpMkhf1Vp6VQu9F8bfxe	1631	794	391	12463	13635	jwQAttb1ZefkTFms7T39odQxNq93ZhP9z3mdAt3v95xCYhZhirE	10742	15132	15132	1618662960000
21425	3NLx8nuJogDeLfor1yRiE5QVekbXf5v1xNENjCa7pcRAFbSktMp5	21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	1407	1395	391	12463	13640	jwQYLtUrWuwmfvjWbKzkQtjqamRDQhoMhEvhDm4dkkMciRbkFev	10745	15135	15135	1618663500000
21428	3NK7ZpGzhxWuRr79kxKKN9RQq2xxvRDDHDNtvSaQN9wKJKFc8ehR	21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	1675	1342	391	12463	13643	jxWErMfGZkQf5BcSFVRZf85RD5KUtDyogwx6CkaPUvuHHVW3A45	10747	15140	15140	1618664400000
21431	3NKjUqKFg85EztZABuoSvXTcj3HWRDTXxE5igsABWwKhPW8ChAmc	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1637	816	391	12463	13646	jxfvz8AKBaa3dR1p5xvRdn2grNLFTzhchcq2iZcZmKwbwZJqEq9	10748	15141	15141	1618664580000
21438	3NLwuYU6JtegiyYef9gasDL3Zph2rAF5E6jfMHPJ36FRwaiLTA7x	21436	3NKKjEcMe4d4SaXM4VbzfuBj3u86e73KGwnP6d3p1kyx9BvzM7XZ	641	1336	391	12463	13653	jx5jSDXddFSWdF1wzCedWrHpiQxfrxN5dvaK5dT7HddNX4cPNNb	10752	15147	15147	1618665660000
21441	3NLiXDgMVJ2eEgsNRa4dMsjApKMRZ4dnTobCj9ER3tQi7BJrk3d6	21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	1407	1395	391	12463	13656	jxJcTxE6Zn6w4MZTUWvaFrp8hAWZ417wA9TwTDk8au9U6QLrnAM	10754	15149	15149	1618666020000
21443	3NLmBRJiu6AoDLVQxDncjhZA9hJ6CLryx7uiG5FXLADKidhzMhiY	21440	3NLkcftT6HVhzsJCqrjVTsbWmhxzzy73ZvpQPJyNuY9pgTszLMFi	1553	776	391	12463	13658	jxtBsKefCBYzaJSA94rAVtazFFm8ZbYdVxEUYxoDEVwLFq97DgV	10755	15151	15151	1618666380000
21449	3NKkQuXTKiC3knW8SW3ngW14qFwX6B4hgi5X7AKzHoVDiEYySUxt	21448	3NLs2t9hWVAqQQQUS8fNRQK53WHiiDA5VZu3ohq95AgbgqCQB1gL	684	1226	392	12463	13664	jwoPk17sYS6YKne6TPduFvtGGsMaykVvBg3jxUDqiJTVGst5Yxs	10760	15157	15157	1618667460000
21451	3NKjRuhASgRYV6BHWqyhzmpchRDJtNu3a22FE8628CBu7cVVJ37X	21449	3NKkQuXTKiC3knW8SW3ngW14qFwX6B4hgi5X7AKzHoVDiEYySUxt	563	993	392	12463	13666	jwRbbtnv7bEh7jgfneCFdMz5HXXcN8Xxa3XcbaCHy7UvdktmUii	10761	15158	15158	1618667640000
21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	21454	3NLtpgYUGbCVknARsYwFkvcUDDgVjF1w7pu2yHFSofrF4uepDo6T	80	907	392	12463	13670	jxuXmBxKXWeUB8eJz7md6JhpuyhhobQMFtdy25MhBqeP9fNpDCX	10764	15161	15161	1618668180000
21461	3NLrUwdscBHEs4yb5VQ9W4xe8APBHzXjjvCdTbRt4UEtJJQ1MiGo	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1585	1366	392	12463	13676	jwGti296JThns66UBgDR5YJZKMLK1KSNe7HQMfHidqteMgjA3kj	10768	15167	15167	1618669260000
21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	596	1306	392	12463	13680	jxWFTmF2zKrT3SDU7BbKGNEwo1sUWTegdkmFJXTibjyvev4zFDn	10769	15170	15170	1618669800000
21468	3NLYyBca5hyR7s6rd2zVbjveuNvdMV5REniodsSRxnXkM4ujb4L7	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	1402	874	392	12463	13682	jwokxyBY4Vw8zXMw9SCiZQzazgkw5MFCEriaNcFPCSU6BiMGyru	10769	15170	15170	1618669800000
21470	3NKETtgEmAWXHUYCzwse3DMt37SSAPAjVUp8DDpJPMEr47UDkuDe	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	632	1016	392	12463	13684	jy3Cfogs75aAgFNMPrLEBnz3ck9sh5xcrSXN77VEqc1oAhFcATj	10770	15171	15171	1618669980000
21472	3NLDPisCkUW4HSLyJ7enQzm9z72NbURBKCnGgmDDKKTZrnkbDvEN	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	641	1336	392	12463	13686	jxvZ5RekW1T3rUvziPdK1jry19jx1FtdkgubkZSWwEb9dGKPVJj	10770	15171	15171	1618669980000
21474	3NK5MEn2M9zEH4K7Q2awTY5jsjjCqgR7a7ibmRWde1oFsJZ3Pwy9	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1407	1395	379	12463	13688	jxRz8DEt1da2gahTPQhZae8NKPWs7W8PQMCnZ4YQHbFi7mvpS6y	10498	15172	15172	1618670230931
21477	3NLgVK3uDjsghmgEuFjscmzoKFJBgEJB1PUaZoPDrHDGmmG5npJd	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jxAGppf63G7eFbL38M3ZPaCzJm7PXHQ193XTwcSonkTAdr7jsgs	10772	15175	15175	1618670700000
21480	3NKoUC1JxpVmUcuhHKV7tNzV99Qay8nSuvq6Xn15Q19Ac9uruu7Y	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jwphPGmbhtCQDiS8rGSJgrfNhueAB3Buz4CVJAxhvunNEqGT446	10772	15175	15175	1618670700000
21481	3NKWDpusoPxHBvZufuHUh7udXbpHaLvfGmrCEgMd5ZVnZYs2sFhL	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1599	1161	392	12463	13693	jxVGTsMRMmP3W39rM8U59YXeqjEJYYfnf9bQQ3cLpC1vUcnwKMq	10772	15175	15175	1618670700000
21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	21485	3NKHYWZQPbm8uFcFxyrmt5hgMPu9hFopo755yJhaJR1fnS84WsvC	1406	1393	392	12463	13698	jwe8Bgr3P2sebHYdQScqavQ4oib7VLMQYHaP5KxCvDanjjXaDq9	10775	15179	15179	1618671420000
21488	3NKbBdwyZH7VhXPckXNKeEK6k6GrSUNpe1xx9tECQiET4HdG8No3	21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	563	1113	392	12463	13700	jwhdkZ9hz4CWYvoJHf4PV8UzYXjBDyv6k1gaXDbucwbxeP65aB7	10776	15180	15180	1618671600000
21491	3NKvTUPnbYj7sLns8rFPDgMcnLQUYAkgQzxqPBPAA73dgw9DermJ	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	1407	1395	393	12463	13703	jw8nkbFVk857zMicbioqMmFPt1RPaMNSH5BX5Uri5ajCtNzHCks	10779	15183	15183	1618672140000
21493	3NLrzpeKqNaKFjUUcCxDejSehqtu5jzBXQy7Zh9rPi5YTwEmiZBP	21453	3NKpntES45ktnNinx2u9zPXxsZTExmMWBKDTcCCwDgfU73d2xJV6	1581	778	388	12463	13705	jwx98R1BYHihomiUmnDdqxAqsqfYWpwqdTozKW76VyjZuRHFhXh	10703	15183	15183	1618672140000
21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	21491	3NKvTUPnbYj7sLns8rFPDgMcnLQUYAkgQzxqPBPAA73dgw9DermJ	1403	824	393	12463	13707	jxUwvWCjzqghhu6WzWH75ZRXo2AWmzw72RzRMZGCcYad51UBnbx	10780	15184	15184	1618672320000
21406	3NKAfeccgAmCCVhKDaiHLs2MdZXUsqP5yYq7sgwsYg8ineacmhm5	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	596	1060	390	12463	13625	jwSMXTF2d4R345R1L6SmJeYTSaVNBNEoz5T6FoMDC3isWSUG8mm	10737	15125	15125	1618661700000
21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1458	957	390	12463	13630	jxM8wMg2QCQ2hCEBDLmNdUiLK7S56j5xyPo963Zq3WuzDQtrXqT	10739	15127	15127	1618662063490
21419	3NLbrGs7rG6PY3PDicsJt9WoN964ogZShpMkhf1Vp6VQu9F8bfxe	21415	3NKnaEMfSMcc8aDJYbgunqZ8GfmvLn7D5fFnqiwyP4AQ2yLXY2Um	1407	1395	391	12463	13634	jxgzafRQEBRUpaDYBsJiKoSEjR2wSdBpDLrQtb9J9SexvHJS6LF	10741	15131	15131	1618662780000
21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	1501	1360	391	12463	13637	jxJYVmGDTh1QoVCsdNpwPN4XYvQPC233kS1sFUBmL1PQM8HiZRE	10743	15133	15133	1618663140000
21434	3NKQ9DSkEZgAbu65cR6dc5CXK4WzEpXx8GLCixcbBumtYtAxs9g6	21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	1623	830	391	12463	13649	jxZbidq8ieVFX363PhQg9gDkweMFZ9SpYNxCfwYYkDGZxEWAn1t	10750	15144	15144	1618665120000
21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	21438	3NLwuYU6JtegiyYef9gasDL3Zph2rAF5E6jfMHPJ36FRwaiLTA7x	1651	1055	391	12463	13654	jwiWN6kqtUNqXqq5xYB6U6ve26e2zrvVCJf2RfpWShoDek82jHS	10753	15148	15148	1618665840000
21442	3NKpG1ubUBKtKkCZ1BUizAYT69QbaQZ8FWPEhaWw47prDFRj2M9m	21188	3NKFjg9tESEvZLRwhTTnMZorGYSpEhwyxHSMt4EgXGzCbQkvZLtV	484	1319	380	12463	13657	jwZcozkAyTzhDzxYPT4cfsk8ukZYALzvgoJQbWLceQ3ogeVUXjt	10478	15149	15149	1618666020000
21445	3NKLx6XQp4W5yKhfSzP9gXPjb73rgDXc2AVpRkq9WY3ianAi84XW	21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	1445	1290	391	12463	13660	jwJc3LpeRdLHftBTaWxLEq1qDWqQPgsQnKUqP8hT5122oAq75sD	10757	15153	15153	1618666740000
21448	3NLs2t9hWVAqQQQUS8fNRQK53WHiiDA5VZu3ohq95AgbgqCQB1gL	21447	3NKKEJaoxPopUgMpPn1XxyNxETzzeKrdKccQK1qZfJLZsSJtxmVc	1407	1395	392	12463	13663	jwZEqdZ8fbTnPZ2GD1o8yTxoqNTVgQWG81v5EeCv97aeCYrfpVY	10759	15156	15156	1618667280000
21457	3NKKDhCjY8rQE1TdX8FFBWCQieBimNthNMMwP3s7ZTWsigvuN1Ay	21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	1460	486	392	12463	13672	jwdD6hMn9eGRJmQ8M7defhqamS3pyqAf7xe7KaAeLc7peWDjJDx	10765	15163	15163	1618668540000
21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1652	1315	392	12463	13678	jwALPz3JPHZKzFcCZ8tG1fA8djgdJV9e7ZNewsEXJfp7gyKsR6J	10768	15167	15167	1618669264670
21467	3NK4K3o8rkp5xHevT9mWkYLxjhGCTWQcBcLz5UWUeuu9fDrE1HVR	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	1599	1161	392	12463	13681	jwZTDuxA6qRDtYoYp5dpvUDj6Hu51h1LMjvP2yTAomz1M4gG7xu	10769	15170	15170	1618669800000
21469	3NLVg7Z2NQfp2sWPjemLYxVN4f7qiBi4EtPyzLw86s9je4Y3CaD5	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	1571	1209	392	12463	13683	jxqZZv3w7myPTLi7kRe8kQrbdHAZhLxAp82ZreroSYXUE4PSa6V	10770	15171	15171	1618669980000
21473	3NL5PH2NGUU9nQPA2hoSW6R7Toz1AJQBpK1o74KSSbnLfQEhnXqz	20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	1407	1395	379	12463	13687	jxLLz7ZU7XVBGNes9yNyoBANFrr5oqiTnyH24U35FGANEW1DoEF	10485	15172	15172	1618670194126
21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	21481	3NKWDpusoPxHBvZufuHUh7udXbpHaLvfGmrCEgMd5ZVnZYs2sFhL	1423	104	392	12463	13696	jxzAkQvVSNXc5LXYoFq1H625panJApaPJRifegRe6qNyGgTU21p	10773	15176	15176	1618670880000
21487	3NKhuSvHuTmqEHoTC6CijDhWcXaeUrQgS5A4Z262hFX8u8ZRjNMi	21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	1571	1209	392	12463	13699	jwgq8c7YYRXHaNoD8W8WnoMADJLSVtcJukzmCRWMjSZun9837vk	10776	15180	15180	1618671600000
21494	3NLP3dY2gthzYNNMhfEjaQKvLEUBkuACeK7zwWdNSuB8F6MQ5cnW	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	1631	794	393	12463	13706	jxMSBrZTC3rGTq8mJhgKvxs9bMrRshnXDoEyXM7k6M1eBm3XDFK	10779	15183	15183	1618672140000
21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	21498	3NKYbH3ijE2i1ttn6BePXkcBoimeaYNBdFakvxg4FsjZ7cAJxEhc	1544	347	393	12463	13711	jx32jVwimG87uJRtKCWB7JHgaCH3PFvKzzeS5d4MnhJQDFueAHn	10783	15188	15188	1618673040000
21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	21503	3NLxJvGe5yJCsEMcjN4JkhPmdaUYoBUX9T1Y3E6sGEBNgvgLpEUB	1571	1209	393	12463	13716	jxM7dxpofeSDHScbpAJZX4eyVYaPq9rUGAiW6npHi9LZF9o1Kbh	10786	15192	15192	1618673760000
21505	3NK3tMBqab4yXJMipRMpH3xZysDdzZCWhch1kW7PSnLReD1egLkh	21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	1542	1178	393	12463	13717	jw9FzwZj7LtBn3M7aDTCQnuDj63zarbcnoKu7jc9C8pxYxav5t3	10787	15195	15195	1618674300000
21507	3NKScntDR91Gd2jG1Coux5gWq172m8LBWijfV1sHYAUbk3xSoHyv	21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	1541	1052	393	12463	13719	jwxjyDPxPt66XGW6GjVg4hvrReTs8XJcQ3iwLfw3S7LTDcw6NN3	10788	15196	15196	1618674480000
21510	3NK3ytrMNhyrckNRKMhrjeiLP9EPkq2TikB4RrPrSeYXNB4KNHV4	21509	3NKY8DsDCwAouR7kBQ1nBUuSVKR58oUucG82Hmo8Me276wHG8Gi8	1445	924	393	12463	13721	jwaAgBDhrZUajUvBbtVGiGLuSNkZtfGwP6wKZpcbCo7SDNrcbLW	10790	15199	15199	1618675020000
21513	3NKaDsfvD1g3B7eGdxiWDPW9BHpTg6jE5tPXRt6hxUCu6C5vLadN	21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	1403	824	393	12463	13724	jxfnhgA94TN1USLbcsXFgJUCt9fL4MverZg4sM1MedB8s1CyrNK	10792	15202	15202	1618675560000
21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	21514	3NLQwEnmBsLSt5z8DtKfpotQj4cCZL9E6WAb48GtzFadAHVgkkWv	1440	1011	393	12463	13727	jwFJLk1cbZibdJE2peRHsuDW1dddHtcwo3LZ4Qa9QA48xjByHoE	10794	15204	15204	1618675920000
21518	3NLYPuVhwyTQhkgz2jbLComDNbvjxiNCMd3kMrggeACsEYJ3hE5J	21310	3NKWjwFVZXj8GB1zRGeNGVCj4dAVHmPQyCkeFwH7FRHfzc8Kpj2s	1506	1247	381	12463	13729	jwYuyutx5qDNdvyniLXS4fGR4DxnVe2HDaPHR3NgZS49csH6kxr	10517	15205	15205	1618676100000
21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	21519	3NKErxSzErFy3Mumv4LRswf6beEtKrteQK7Fhy5Y81eJnhnBiftL	1585	1366	393	12463	13731	jx9Eq6nDGGZd1MYEigpzqgz9T8BvxN6XQzib9DXTAZDjSCDQe4a	10796	15206	15206	1618676280000
21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	1579	1263	393	12463	13737	jxcdfBM92nhtnaoP6sNcHp2h4KPSqXeZLUEKgPddd7SMpHUd7XS	10799	15210	15210	1618677000000
21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	394	12463	13739	jx7RNxJpBQgGNd4haRJcuvkAZ8FBQibDqg8gyWdesWsiHK6Hidv	10801	15212	15212	1618677360000
21536	3NLW1HFsc2Bag9vPQ1Yaox1mqCMZrwxwPgF6jRV1VsMH4sMRQy4L	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	58	1035	394	12463	13740	jxuAzHXUmnqW1z3duzNHUYqq4NEkNCvJg6PnHv4tLNY4LST6Jmo	10801	15212	15212	1618677360000
21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1555	1347	394	12463	13744	jwtyYqKrCC7UWoyNFDLs5gzW2sFQauMLAdoyu838Vp5QspkAE5i	10802	15213	15213	1618677540000
21545	3NKTWxAzxProYafzjpvKvTQkXPQxNRJbo1sAMytbKWyEvEMdxUTA	21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	1607	1348	394	12463	13749	jw96o9Rpo84FK63SucyioqY3ELiWo4agiRquHz7poNnzVcYTbya	10804	15217	15217	1618678260000
21547	3NL5W3U8eEru2eQkyDYpAQ8n6VH64QZU6t5oykbCJtKQ58LPvYXn	21392	3NKBarD2Yya69WVFyxucLaYJMUqUPUwEnSTqkSUSuu8vd5z8ZmMw	1536	1187	389	12463	13751	jwkQkvijYfnvU6R8H7ZnbBfsHs9iRwH7jZV2nMtQSHHKh5wM4pG	10710	15217	15217	1618678260000
21432	3NKwTUUPTpfYneDvWK5qHUSv6qUe13YqvCvBTNNPdLwYcJKdrQA7	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1516	928	391	12463	13647	jwN5aAFtG8QxvDAF4aB7448H4ZEhG2JfaSHbccE3q4LDVU4b2Hc	10748	15141	15141	1618664580000
21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	21431	3NKjUqKFg85EztZABuoSvXTcj3HWRDTXxE5igsABWwKhPW8ChAmc	1587	1357	391	12463	13648	jwik4mgduVeacr2rcFxnZQw36K8Cty1M2V6GdECzGzZFKnfkyb3	10749	15142	15142	1618664760000
21436	3NKKjEcMe4d4SaXM4VbzfuBj3u86e73KGwnP6d3p1kyx9BvzM7XZ	21434	3NKQ9DSkEZgAbu65cR6dc5CXK4WzEpXx8GLCixcbBumtYtAxs9g6	684	986	391	12463	13651	jxpNsDb8mRuqgVBiN6VbcgLzcVinBYvemdxxEVUb4CkSnJ3jV2V	10751	15146	15146	1618665480000
21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	21443	3NLmBRJiu6AoDLVQxDncjhZA9hJ6CLryx7uiG5FXLADKidhzMhiY	152	1330	391	12463	13659	jwbQfGejLH3dxYBQtAUQKCHK78APRwWyHvhYn3m5P12sZZQmrdk	10756	15152	15152	1618666560000
21447	3NKKEJaoxPopUgMpPn1XxyNxETzzeKrdKccQK1qZfJLZsSJtxmVc	21445	3NKLx6XQp4W5yKhfSzP9gXPjb73rgDXc2AVpRkq9WY3ianAi84XW	1596	1237	391	12463	13662	jwAbei6rzeK4SEfDfbTKwLavAsLy3KneVJaY3qCn4ddQcHktu8X	10758	15155	15155	1618667100000
21450	3NLtDZeUDp7DQbB1ASK6CijmCJyjNA7V7m91YBCMsM5XXWW15mo7	21437	3NKUyTxrFJd41yRrBMRVsmbTmFKnDta6hfZonRgFGDnTWgezVVMs	684	1226	390	12463	13665	jwLdZx4xQD9NJyNUv8eSy4Js1czPBHruJ7bLKKMwc1z31dgTT5X	10742	15157	15157	1618667460000
21452	3NK82eKFXXtTsWfb5oUsCrDbBpozMHaWLJ7Bu7QMSNHwAus3Cce3	21451	3NKjRuhASgRYV6BHWqyhzmpchRDJtNu3a22FE8628CBu7cVVJ37X	1490	1028	392	12463	13667	jws5Y2gBqsDZqberumBSyXCS5rwNr8MC9ncWuShNQeoSwoZjPpg	10762	15159	15159	1618667820000
21456	3NLA9Y4jjPDHTaqmPyt1DC9ebUQj3nvDEeMr84H5TfmR66pEWbip	21277	3NKEJavF4kmmfcbangvbi7MivoU8afBwLVcFHJNde37NPXMU8pd4	80	907	383	12463	13671	jxkQ3FsNevVLoV7BNY8w89R9vHXdyyfXwQ3PMcppcMB4zc36FLr	10578	15161	15161	1618668180000
21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	1619	909	392	12463	13674	jwYxHd22icxjQnDYUdnsM7DLomwfXHjV4spSGitZCFyRuGkYhpU	10767	15166	15166	1618669080000
21462	3NKzvY8j17ccPrE9J18G64EZJK6FGtupCzbsdz4cxveDzkzEtSvt	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	532	1303	392	12463	13677	jwfR6913R4ykKafgwUfVW44Zvcc6XqqwpeFWtAY5cyAEB7X6hbF	10768	15167	15167	1618669260000
21471	3NLT8V7424sT5z4LTfCfLVqzX5PTSdTYtCffsYsWA7VQGs4om9XB	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	1460	565	392	12463	13685	jwemPxPovoFysxiRSMtsWDep7hptv7iS7seH2LiGjBNta8an68c	10770	15171	15171	1618669980000
21475	3NKhMQhPgGYNo1ingBomBHSvBh5YyLjjYrLaocdTnWVzjnLmUVnL	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1407	1395	380	12463	13689	jwsyCJPJQ5iTv1atAPnQeoSKsTL5B1mVLprooXPtc7oeY9AkzN3	10513	15172	15172	1618670265253
21478	3NKZTFyr4cVCPZUaFuf4N9zJurih4h8en1fQbtj59Cf6y2yfdkwr	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1405	851	392	12463	13692	jwcMEBsHgSwevvMiTR8DMDpJGtWxUFb8Muxg89gJhV8bku7cEU8	10772	15175	15175	1618670700000
21482	3NKBugBYBG72vnAhHKrGce4xsTgxrZF2yQdgJ9QYcEHRB3qNaqnZ	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1601	1388	392	12463	13694	jwe7JH5UJR6EAVdPV2SoibE7oSAZyYC9oPJxj9AVQ7zNgGBy5Ug	10772	15175	15175	1618670700000
21489	3NL8AzM9yabHMs16M6i3NXJQ4yAMNCZtamf8wMsg3WsbdUYWQRBo	21488	3NKbBdwyZH7VhXPckXNKeEK6k6GrSUNpe1xx9tECQiET4HdG8No3	1637	816	392	12463	13701	jwQidyoJ6EmUG3w8GDYnvzpdBcCdGYpoAG4723X2T63aEztZHbv	10777	15181	15181	1618671780000
21492	3NKjwbN3TAgQPXT1Z2pVTRAuYVrvmj6SnAQqM848hsC9ayW4B3uS	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	596	1060	393	12463	13704	jxUfG324YfHyQRGk7wPZ1dcWwdRXmVGSQ7mcpUG3jwGdafmQ8xY	10779	15183	15183	1618672140000
21496	3NKG8j3g3pyfmvha6g8Q8LMQ5YT6dZz8HnhScfhKAXgcWABHdJzT	21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	1578	1050	393	12463	13708	jx7JznMPxKUBKSATrfsMKcY3gooBTVyK95mJidg66jrHChf7W1x	10781	15186	15186	1618672680000
21509	3NKY8DsDCwAouR7kBQ1nBUuSVKR58oUucG82Hmo8Me276wHG8Gi8	21507	3NKScntDR91Gd2jG1Coux5gWq172m8LBWijfV1sHYAUbk3xSoHyv	1406	1393	393	12463	13720	jwoQkVMTdS76fVq6d3aZjxY2xwhzAp9pEsZRmraToeCM7e5yd4Q	10789	15197	15197	1618674660000
21512	3NKG4jWbFaneuSqBWv7K8MQtgCGATRP1gv6VAQaPKELEXruqiAou	21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	1407	1395	393	12463	13723	jwwqENseRppKDhuHSmQmyvnQ2spZW2YAySMdqkbU4xUixXutJsD	10792	15202	15202	1618675560000
21523	3NLMuHDfc2wNczCMmAVkxm74SVtUoHyYcJBaymoDA3GVNc8N2HEt	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	576	1355	393	12463	13734	jwRHjJ9TXZWhW5Xk5wkTbUGczLNwTsg28C2AxKhxZZv1EdFGCvb	10797	15207	15207	1618676460000
21529	3NL9Nv5Q6rvahU35JU7dGrxHNiWGABgATYrz5fz117tFaFoB6URx	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10800	15211	15211	1618677184520
21531	3NKJJ4Jst37MYqp5EMRpwQqdZLQcwXSQ7rwBnDrvKH8DJxJNwx2m	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	393	12463	13739	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10801	15212	15212	1618677360000
21533	3NKGTCjWEkhLphZkDD96uYnvQcMt4ocENJ8qdR2AbcuHqbr3VWF7	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	394	12463	13739	jwZfhW8eRsdbXyy8eQPmLoEfokhrzvfF9J8kP6RSePAv2qCSAC1	10801	15212	15212	1618677360000
21538	3NKKPumPSiMKsMPLdsfRdrhskeqgZT8wid3manVbYxSQbHWL8ab5	21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	547	547	392	12463	13743	jxzGrMB4CP7nGLVkaZ2TLwEsZcxnvSzLG3f54qPdyGXt9iexqQ2	10774	15213	15213	1618677540000
21542	3NLotkPRHypWEDf2LJtV5h1EwbuiaF4bqtHTVQ7NKjVfWP2EMzCm	21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	1483	420	394	12463	13746	jxZcxqEHJuVK2WGLMAkNgpEGjHkT8heEXGurTSKKf8S3Q84ZnLz	10803	15216	15216	1618678080000
21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	21539	3NKJBxek71YdJzvWPQuS3wKN3yBkg5AWCeRDvnvNEyxh5Pjhp5WR	1553	776	394	12463	13748	jw9ekFxkqqHkcNKWTSzUgY6pXZrQDzZ3u4BLBJtQviPwxmtNCWS	10803	15216	15216	1618678080000
21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	21549	3NL4Qzg1iYbsxL51D54HBRS91S9rSecmb99c2JzkSZNzyH1pQqgs	1406	1393	394	12463	13753	jxZ6UC6wfV39qM2QmzwQCmyzTrGfckBoTHohHBbajVSnVWZz3LS	10806	15220	15220	1618678800000
21556	3NKsmdysKNnBQBqvUgBj4DLRJCJc14WjZHrh6TQhveh56JU15bNz	21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	1460	474	394	12463	13759	jwjh7G32b1dJnMu9TSbd12S5LH31HM3GbZz69ztmLs1MKk6UKi3	10809	15223	15223	1618679340000
21558	3NLs3ySRNFMX1k4UPhXYArHTeh1s5kFfn2MULqrQBio36E2kVCwK	21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	1402	866	394	12463	13761	jxanQbh8VQAmEqczU24CukMpAsPBC6EF1UBDPtwXuZM8fL5zeeo	10810	15224	15224	1618679520000
21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jx9bm2zM7W6RynoCCnwN8nEZCXz1kNxnyHM2Sbr8z5MHCwTDzMr	10812	15226	15226	1618679880000
21567	3NKrq1DvGrNMEsKMxPZYXCCxQFBiinNb9Kqw5yoarjSrYuoq8Mks	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1594	1326	394	12463	13768	jx8sYAj5AtEePZeEJfqmKXrbCCcD9VqZXLrUTPiRbvJrqXv7vgN	10814	15228	15228	1618680240000
21569	3NKrgYAWwYwj9SS8arad3DFvJXhYTNPDWmE35tuiYE7e7ccdiyfV	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1406	1393	394	12463	13770	jxocbGrJxyYUfGdwbU8hcR631ZZ7n2FtoHwhuYNyYcZdMHXtbfr	10814	15228	15228	1618680240000
21479	3NLjAeWHA9GgxN8yLQqkkgDHJXj3odopL1ThQixjh3igA2LSA9nd	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jwCKRKQZmSmYpXXo9n6GzCUWd8ZKHSieZGHV5C9tmgD9Uo4nAFE	10772	15175	15175	1618670700000
21483	3NL2QjmVWpcQBpkaJhR95Wv1yGqhDENT5jbYHKBMDBdN7yVUkbEu	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1406	1393	392	12463	13695	jx9bWzeFVmxtLMpFgh5ivuBgRYTh32CEqmchnv81cotdEK5e5gS	10772	15175	15175	1618670700000
21485	3NKHYWZQPbm8uFcFxyrmt5hgMPu9hFopo755yJhaJR1fnS84WsvC	21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	1406	1393	392	12463	13697	jwthTqx5ZVtXzgzgbD3NuiVAni39Bf14iPU1BpxYkhkXWu2zEVZ	10774	15178	15178	1618671240000
21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	21489	3NL8AzM9yabHMs16M6i3NXJQ4yAMNCZtamf8wMsg3WsbdUYWQRBo	1403	824	393	12463	13702	jwUgxQotJX7WPB97SXnYjCfrWgmF2XDVPr2U8kopqo5vvrGjYH9	10778	15182	15182	1618671960000
21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	1406	1393	393	12463	13709	jxghJGv1Q4VcHkjZGho41TpRE9bEfF3KrMG8uGo4ktpRXhbib9v	10781	15186	15186	1618672680000
21500	3NK6P6Khpvo2zixi2DnburTwcjMu7WQPU5UKaaSN8nCsFmbTSXEJ	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	44	1199	393	12463	13712	jwpm1R3QityFsKdbx43zr5uZ5DFZigvMR1XqJpMm4hfZzuchf87	10784	15189	15189	1618673220000
21502	3NLdQB61A6x2SsD9WkdBC49XjX8LynckEoy7QunnmPHtfG81bZa4	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	1406	1393	393	12463	13714	jwD4zT9hbshiMg6cr8YtzApZbEp8TaWEUA3YL2LmotQ1gkLMsL5	10784	15189	15189	1618673220000
21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	1608	1289	393	12463	13718	jwiA2qeBYMEP8o33q1d5wiZDvma9fYrZd3p8UviSXT21TvUaEBJ	10787	15195	15195	1618674300000
21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	21510	3NK3ytrMNhyrckNRKMhrjeiLP9EPkq2TikB4RrPrSeYXNB4KNHV4	1673	1002	393	12463	13722	jxVaLd87brboSf14jDUdiSy6qTcnrfMMCPUH9QWBcFuC96PA5KQ	10791	15201	15201	1618675380000
21517	3NLUoMzL4nK5z1axRhqr1XQzJQhFmubG5er7zEV3eKV29eTsR5fa	21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	1407	1395	393	12463	13728	jwJVoiFs9wjPtudVwyt1mqf163dgbSsJki4B7sQvfp1XEm6E8Fv	10795	15205	15205	1618676100000
21521	3NKjfNyShwG6TN17qdcQCyv1dacjDDU1Ez1KaH8kR4BvmMTXm9tz	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	1407	1395	393	12463	13732	jwRx176wTyVemimLA35g1MWMKRtrfqXgwJ1Lb1d2GiTFkM2CYrq	10797	15207	15207	1618676460000
21524	3NKtuUk3bwzJekrVDdBuFJxnkoUCvjjCUboQGGZh7PjqrMnTEktk	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	576	1355	393	12463	13734	jwcxEShU4aXuzokHcKznwPi2J1zwPB1UdMeskbnoCE5ndkR7fJY	10797	15207	15207	1618676460000
21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	21522	3NL3E5bSw8awMsozeLhy16URhtm9zSc95igTQR5EmqToQjWM3gJN	1483	397	393	12463	13735	jw6mzF3XbVrnpQAepAg38vGhNn8qraqEowGdA5nQ6mNTLvz5NJn	10798	15208	15208	1618676640000
21528	3NL5Xrn2NtQewoC7uzmVuQoyp6iLxNsYHCtGDCKEmgqYyKxSUYF2	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jxmpz8AvjyvHLA15qZtA7WKAZiosUPKX2aU7nxRfXwKfeYTkFfQ	10800	15211	15211	1618677180000
21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10800	15211	15211	1618677180000
21532	3NK9ghN1R253QYkduN8fy1iof6t48JrEuUMMRADsZXL5pRNZCxQR	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	58	1035	394	12463	13740	jwJKBovumxqWMrrPruPbbupKw7WwBRmHueFa5jEnh3EAoxPo5Ce	10801	15212	15212	1618677360000
21541	3NKq7AAwh5ppXCxws3boaYTwmvAnrXCorUmNY4ZYA5VPmiNdS4ge	21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	1613	1223	385	12463	13745	jwPvmAiNC9UVsw2C3Cnxg26jx8bJ9DZSxvJ4n9jsVtViNKJy9JM	10622	15215	15215	1618677900000
21543	3NKze5D3sciiDMLCcvqo6U1F79VrhcArccjHo52yf9nyzwyo1uFx	21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	1402	868	394	12463	13747	jx83Ga2YPn9dVUPdTTD2D2saRhk8GdUz6cwvyFiXojMLs2zjrzy	10803	15216	15216	1618678080000
21552	3NKfVf5k5VoctKtUJPbK4CuN2v8gLuu9K5bTy7ZWM3EmhTUnc6H2	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1451	1166	394	12463	13755	jwgUocYcrvZYssbmXtUZgscx4RuL3Z9RoN3sAE4cn6dYHBWgKuZ	10807	15221	15221	1618678980000
21559	3NKgsJgeBHJv1iJUo4kChL8Uge9MtikVQ8cvVhDfAyJDfmwLs41q	21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	326	326	394	12463	13762	jx5awamRbBARU9hxUqQ7NhHyTdqRf3To1QUTqNiUZVAtjagQmRW	10810	15224	15224	1618679520000
21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1407	1395	394	12463	13765	jxBBvoFqxYGTegjBpcbuUW3oDTVD47xTcF3w53HNSWPPbjsfw7S	10813	15227	15227	1618680060000
21566	3NLuNHjZMbkT4h3rP2Q2HDewhGYRqQBP1age4nFfyMrtkdiF6Sqx	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1547	1252	394	12463	13767	jwDCFMY24myJt9ij5ZiJyr3qe9qj9gLrwAspa8SQf1YRpEFveSd	10813	15227	15227	1618680060000
21568	3NLveE6vqGVtpfhQTz6zydzyoNar9d4GtC84o4Kc3KonNfh2z7qC	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1516	1168	394	12463	13769	jwapfvgCU7B3Ta2qyoAE5ZGK43ikfB6e97zpAyVkwZXLPqF5ZYR	10814	15228	15228	1618680240000
21570	3NLZERG361UuRpVtzQ2BvbyrB2PTTsttag3FDFYe5sA61ALBnTaw	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1594	1326	394	12463	13768	jxy2QGJvPxVLBeFZWejBU5GMbnh8AgERAQ7L8fP2z1NQo9pnjC1	10814	15228	15228	1618680240000
21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1451	1292	394	12463	13775	jwbF2xFFEP7v4wq9zEjEqDAPqPdYVjziz6e1B47qJddAysmCEwm	10817	15231	15231	1618680780000
21582	3NLYC3JqfGBqQkKvoiLRRsNBiJJckPVGHXt9nK73oJYWubByU5yP	21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	1458	1323	394	12463	13780	jx7f9FzQYmduKcUpRRXBYvJeDjfLEnspYCJFezy5kYYxZdyDj7e	10820	15235	15235	1618681500000
21584	3NKHAr6Kb5Bzivv7Ax9NfaBzvoRGqfgynUVhKyKXviPn118CAtQV	21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	1542	1304	394	12463	13782	jxLS6MNgry6uH9HfVC2yKhbeSoVfXpzzpaQUdXMaAm3CepVeDjD	10821	15236	15236	1618681680000
21591	3NKnVEszeFtBgMDYuAKwV6KPkzBXzwt5o6aR6uXfzkj1DBxK8MSy	21302	3NKuTpJEBAYNapkAfvS7WKB72A612qi5qwwngf2YVMbL3WVFqSVf	1474	1203	384	12463	13789	jw7PEJBhoBWCYLhXK7ox54EwTW8VhTNZ4k5SQJHvYsTKxvqhA1E	10574	15240	15240	1618682400000
21593	3NLSdLLHHXDoSpcot4dx3HvRfq5N5XtTz9eyARD6UPweK4ioPqbo	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	1443	424	395	12463	13791	jxY8fcmJFdAZvSpVFEHnnE1ZUWr24bt1aFaarYuD9kLaw1nFwUN	10825	15242	15242	1618682762326
21605	3NKGwDnMDXcvCzg4yfdtCfSSKjHjR94K8HNnWTUzNjv1LBCdwN5n	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1654	974	395	12463	13800	jxF7UvDS4pouzPrn7rvNTkZKPzbbRzKBXbmtBenqSWh3dTokroL	10828	15245	15245	1618683300000
21606	3NLEq7dyGgvBbQjLqnwenXc3dDuYY8gREZxhKkDoCdti86aMENQs	21547	3NL5W3U8eEru2eQkyDYpAQ8n6VH64QZU6t5oykbCJtKQ58LPvYXn	1536	1313	389	12463	13802	jxxdazJU15r3B7daGpP8DwZqrArpBsW4xz5KfSN9ZL2cpgmUgb9	10711	15245	15245	1618683300000
21608	3NKzvBPP1hJunnPwSXFx2vsJADoijDJjSYcT8kDUjEMcckKiQCTy	21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	1406	1393	395	12463	13804	jwRJk6pauynDCLCTk1kJ8vMueqXKsnrsZg9RR5thnGGpzYD3jMV	10829	15246	15246	1618683480000
21498	3NKYbH3ijE2i1ttn6BePXkcBoimeaYNBdFakvxg4FsjZ7cAJxEhc	21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	1675	1342	393	12463	13710	jxucyJZvSYCdmoithjBfhViPJbE2FnpqUF6ZnkbFS37ARj8oH54	10782	15187	15187	1618672860000
21501	3NLTH2ZU65xq6Mb55d3a1LQtFyTdhweTb4RkrgdG9RKaLLbuwf9h	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	1403	824	393	12463	13713	jxzUhBcAGAcuQ4J5dNCQhGMxxL2kdqcsSGjo6KBtxz8M7zX6uah	10784	15189	15189	1618673220000
21503	3NLxJvGe5yJCsEMcjN4JkhPmdaUYoBUX9T1Y3E6sGEBNgvgLpEUB	21500	3NK6P6Khpvo2zixi2DnburTwcjMu7WQPU5UKaaSN8nCsFmbTSXEJ	1589	1040	393	12463	13715	jwx8z5p9vFtFwUYFrdrRsZMLmah77XPWVfE9BmmRZ7EEzNdfNEL	10785	15191	15191	1618673580000
21508	3NL5BAfkL27xWZJmP5RwYfTNYfotVrF4byHhtxwgzMcdMhLwkYHA	21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	1541	1052	393	12463	13719	jwmchVNL8oo2WBBTSjUW428am21RN7ijPmFUZ9Qr1QEqViNKgpn	10788	15196	15196	1618674480000
21514	3NLQwEnmBsLSt5z8DtKfpotQj4cCZL9E6WAb48GtzFadAHVgkkWv	21513	3NKaDsfvD1g3B7eGdxiWDPW9BHpTg6jE5tPXRt6hxUCu6C5vLadN	149	1283	393	12463	13725	jx8sdktivREAuNJexUXQL5igMWf1piWRuFz1TMAYcQUrJitxrR8	10793	15203	15203	1618675740000
21515	3NKwnxrzMhHJPBYBatRGD6zrJETM3PqN9QGU4UNKEg5tQh9gCVDr	20937	3NLmJTBEypjEV9DsKTipM4MkWuoDhBYjAfdn6W7qiVjuJ21hmLHQ	1440	1011	381	12463	13726	jxyYpQCD3FFVGCw8GdkqfamK9LxcYzj4ebvknTCA4TyfBYjztbN	10527	15204	15204	1618675928455
21519	3NKErxSzErFy3Mumv4LRswf6beEtKrteQK7Fhy5Y81eJnhnBiftL	21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	1506	1247	393	12463	13730	jxZvfHJwBoLbBRzqZtzT8TQ5tfcwEsFwNumyCtWp1nfaFKaxiPC	10795	15205	15205	1618676100000
21522	3NL3E5bSw8awMsozeLhy16URhtm9zSc95igTQR5EmqToQjWM3gJN	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	300	300	393	12463	13733	jxXbNKT4BjXawsbqcrGBXJs8hE7cP5gQ3wyVoxjBP2vDS7heo3m	10797	15207	15207	1618676460000
21526	3NKu2sV1u5tGyDGauV28Gre7hdiwiLgJUjR1qeivooPYFdTAXU5k	21493	3NLrzpeKqNaKFjUUcCxDejSehqtu5jzBXQy7Zh9rPi5YTwEmiZBP	1581	778	388	12463	13736	jxZacbnk9RAb8L1CXvw9i3fqo5EE6GAnwCencHdVdm7ULcvyG2i	10704	15210	15210	1618677000000
21535	3NLMrVbAtUtm2MATTmVNwBesci1rRBBR7oagvQrNrMknLzEYamAm	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1406	1393	394	12463	13741	jxHpbHLiLzyPs7WVemijxKxhaLrGnrk7am8vkpBHTjuKJ165NvW	10801	15212	15212	1618677360000
21537	3NK38SoCVYn45fSCkRoiFmLRHWBNRLSmmfHEu73ju4PJvcgsjUn6	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1637	815	394	12463	13742	jxmfyzjMJNfEC79fN48PLps9Wo8ktoGApfhhnTdsysWPgmt6jNC	10802	15213	15213	1618677540000
21539	3NKJBxek71YdJzvWPQuS3wKN3yBkg5AWCeRDvnvNEyxh5Pjhp5WR	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1555	1347	394	12463	13744	jxhgXCDxX9hVZevuQdqrrKRRnaTyHhtjCYt68BnqEw7Fsbis91H	10802	15213	15213	1618677540000
21546	3NKey3AH9wBvmNRauziS2nFsxetQhvXNYUTU1mhf1HBvS4A8T2P8	21543	3NKze5D3sciiDMLCcvqo6U1F79VrhcArccjHo52yf9nyzwyo1uFx	1536	1187	394	12463	13750	jwpeAo8zBQPGeP4yaT6H3MzVQxLZLBaQixgYxPK9UMA1c2HXCo6	10804	15217	15217	1618678260000
21548	3NKxzWbJ1E3RoXk65FVDXiD6BqRVPor2U499878zHGtW8pJQvQK6	21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	1607	1348	394	12463	13749	jxN4gevd7DYXG7kNXdjqgNLSfEY3DwUmgoG2FkvMEmsKShyfKca	10804	15217	15217	1618678260000
21549	3NL4Qzg1iYbsxL51D54HBRS91S9rSecmb99c2JzkSZNzyH1pQqgs	21545	3NKTWxAzxProYafzjpvKvTQkXPQxNRJbo1sAMytbKWyEvEMdxUTA	1608	1043	394	12463	13752	jxCjn22t5PWCi1XZkwAmrtEtg92LjANzdam4AvuVEJa3NrqfxGg	10805	15218	15218	1618678440000
21553	3NLFWe1q5fmGaGPX9UEgFbsKfRVnjhzWr8GyPSHpqut8kp8bYDd9	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1602	1123	394	12463	13756	jwEZ4rmgvNssv15NQFiZ465QuxabNk8ychZmGcRSqW5eBnNSXMX	10807	15221	15221	1618678980000
21554	3NLv6F2U8M6Wnv1cE39SAeUaoU1Ahg3Ps46ySo9RZGqBgYh35hx7	21370	3NLJDGbFJhNLF5yfwpMSQ8QCYXimbQhxXi7Ue88X4kLHihBKmuai	1602	1123	390	12463	13757	jxm9cugq1qFec2emrreCPg9d5GQ5Fqbjq3gsUQtYEWWXSMxb4XD	10725	15221	15221	1618678980000
21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	21551	3NKTYkAZuCB1v6vd4FNstAyAzudSirXwf65JEsXetNqoUPU85eiz	175	175	394	12463	13758	jx6zbezAdHbkFjqfGYDQdipKMGjAdVeV8KQCMZ65FnYEP51H9KU	10808	15222	15222	1618679160000
21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	21558	3NLs3ySRNFMX1k4UPhXYArHTeh1s5kFfn2MULqrQBio36E2kVCwK	1623	830	394	12463	13763	jxUvEYPieHKj2phpuh3wsAxHT8FNP8fqh2zPoFsuND98pMLEzvo	10811	15225	15225	1618679700000
21562	3NKWf3rDnu7gPcgKL3ixVnvvKVhmWHk2Sjr24bsjtjXVNpc4QmrS	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jwbnrvGauuxkKb2SaF7qpJEsts3Lk66Z44zv2bn1LRb3bxYKoRt	10812	15226	15226	1618679880000
21565	3NKTK7WT8jyiGpJ4YsDoCtv8j2KpCCRTJPkwWWzqKhSqrKFjTUkx	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1534	1317	394	12463	13766	jwYDvBib1wWGP6fHk2DRiSqWSn6bRFuka7HzS5kCz35aqq3kMgP	10813	15227	15227	1618680060000
21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	21572	3NLLRokLz1haE7EvpCWs679cDD7x8iKW1Cd4rXYVXzYb9YdV7KJD	1509	954	394	12463	13773	jxFUL29k4fP8vCQdt9PZ6UvRtYTnrmN8LMxCjUsVeYtcw2cHvTb	10816	15230	15230	1618680600000
21576	3NLLi2PpwjQKQB6JN33PTBE6DKoGSoKpkH47nTBo3EJmQpLV8Bkq	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1546	1213	394	12463	13776	jx9woZgPxUnfKK2woW7mDawmkmcw5HVkpwAt2Uub1DfoiEoKUFZ	10817	15231	15231	1618680780000
21585	3NLvD7qj7vWXttj3iBEeA8ZNohFsjgUjyM8p85adrv9wkfRgLJMo	21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	1500	1171	394	12463	13783	jxjrC2Ud1nnrDSMSiZrzNiRTCSPeonUc4j7BsGuQ5X5BiQnHo4N	10821	15236	15236	1618681680000
21587	3NKvP4W2mnmQXhcWJxvaKCRwbAcAQMgjHZvQ61bQ4BE6N5jd5xdH	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1607	1222	394	12463	13785	jwpdFaAzgQqx7aDajr3zJAKoEjvU4Nh4DeRShwtJ3TXoVJNgEcQ	10823	15238	15238	1618682040000
21589	3NLRyFn8bZPhTM1U3yHAjN8XD2G1Rhgz4ogvjEzadFXDUjQZ1R7y	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1631	794	394	12463	13787	jwiGus9wE6s4t8xMqByXWTPP29zwUyYDrU6NY8dHXpep7TM4FNj	10823	15238	15238	1618682040000
21594	3NLihXjD6fdtDte3J2GFMzzorh8i29NoRjaASVs1X91h9cvSegNH	21526	3NKu2sV1u5tGyDGauV28Gre7hdiwiLgJUjR1qeivooPYFdTAXU5k	1581	778	388	12463	13792	jxk4MnhSUeS2nRVcMmTcWF7fuSN7Ss9r4PC5DqPfZM5ivBu8F3s	10705	15242	15242	1618682760000
21596	3NKiy9m6snEj44oWXfZLFRX5mtcWtYAS3XFfgfg31wgvYAPxF18x	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	1443	424	395	12463	13791	jxY8fcmJFdAZvSpVFEHnnE1ZUWr24bt1aFaarYuD9kLaw1nFwUN	10825	15242	15242	1618682764073
21598	3NLZ57TXGF3ZQE1NbR7LYku73vRwGnvgsen8B1BowFgU6DgeX7RJ	21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	1489	1254	395	12463	13795	jwC2tmqYjFCPRDCVatTDFF8NKD45ZibXRy8uZofkXENMLHsuqCm	10826	15243	15243	1618682940000
21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1627	1019	395	12463	13797	jwcfvvKs89rpX357AnJeH7VNBzMqernmoXG28ra4g7GojYDJeKS	10827	15244	15244	1618683120000
21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1536	1313	395	12463	13803	jxDCAmX6fjZsUA6enQM6U8Rhcth7AsXemRnzG4MHr2c3cn7nHVG	10828	15245	15245	1618683300000
21611	3NLJQrM7NbYWKkJxyhn7MMZ35aNpLXFfJrdboTcqfy2ffMJNVo8v	21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	1407	1395	395	12463	13807	jxKvsWvtTvax1wXxBNBJ5o2sXyGFfeSRdN868igjS3t5cDwdB9c	10831	15248	15248	1618683840000
21551	3NKTYkAZuCB1v6vd4FNstAyAzudSirXwf65JEsXetNqoUPU85eiz	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1407	1395	394	12463	13754	jx1XKAxHrpwiFxCFDBi6BjyvZCps6w8wqghNmT34P8HJsxa3Nbf	10807	15221	15221	1618678980000
21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	1422	1337	394	12463	13760	jxow21tkJLFzKN97FBHX5B1LPEgrsMUQ6GgoLhoCb5Vs1szXd62	10809	15223	15223	1618679340000
21561	3NKr8tytcpLeWrmy75eAXfJ6Dxupi9rENXmU5tUafxt4ZBmnWead	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jwpr3RSzK8xVbGhDsg6QJyEkioDyVBcyzuBR95VRuAsGkT3siec	10812	15226	15226	1618679880000
21572	3NLLRokLz1haE7EvpCWs679cDD7x8iKW1Cd4rXYVXzYb9YdV7KJD	21567	3NKrq1DvGrNMEsKMxPZYXCCxQFBiinNb9Kqw5yoarjSrYuoq8Mks	1624	1334	394	12463	13772	jwWbrrkSixyW92A1BFeEcddW3NrmV3x7aCtpgW2WEyrzQfXUVjW	10815	15229	15229	1618680420000
21574	3NKPUsqBSqYUCgSKTPyfX3fxiTqxPJ459BDX5JF3fUfxXioiBYTP	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1402	858	394	12463	13774	jwpjdyuUhvV5nUvHKst6Z1GwUHbvX79UHrwfVzKDJmPg9JDryzG	10814	15230	15230	1618680600000
21579	3NK5JjYedwsca37haa1FB5rjRKjNKDASfXTAKUbzQ51Z8tgceVvv	21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	1602	1369	394	12463	13777	jwWZJwdtsSqtPrP1CnLDEMAKqZsMaVYZ1oWbk45MDQLGTZ7Jymy	10818	15232	15232	1618680960000
21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	21578	3NLhRnjr88Qrx1MndAWRL9tdoUE5xZKRGdMuoeuxQFCzwPNv3nGV	1397	827	394	12463	13779	jxuzbNbmm8aqzGsaWa2LjDUoKyeMVTBWW24ZKPzzEAsQsYWh3Jd	10819	15233	15233	1618681140000
21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	21584	3NKHAr6Kb5Bzivv7Ax9NfaBzvoRGqfgynUVhKyKXviPn118CAtQV	1419	814	394	12463	13784	jxh5P3zaYgfTZ5SFmf58yx1Hi6sFrWZojpkphTBCogLqbmyr8AA	10822	15237	15237	1618681860000
21592	3NKNJxWhLuAqcoVKTrpzHa6JGiRw4U2JH3GfJdDaszo4g4eUgbgJ	21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	1474	1203	394	12463	13790	jxmC6hM1E3xYVdcauWUn9HKjmzo3iuxf6dAFVdyq6ZHfSuvc1of	10824	15240	15240	1618682400000
21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	1407	1395	395	12463	13794	jxsQCFzEFCsFJsPjmZ6hBRRucaRzycgGmqYsSWqzz5M7CvpcawX	10826	15243	15243	1618682940000
21599	3NKhAfxj2Mu5B43HSfe6r4fx7ABHhTqLAqYWdJrgKANbuHZNzt4p	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1407	1395	395	12463	13796	jwJvywAAN6ZXjRGnNCEM2fUEGDzaPvgaBugtxrWkR5MbsCRjZ2t	10827	15244	15244	1618683120000
21602	3NLLVP325NQhGyjbTofHwompf2Ewk3cHcnp7wnGgkwuNj8Q2yvHy	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1419	813	395	12463	13799	jwz66w58a3EU5eRRUdm5oBngR79cpPRWACyzMAqwHVeehyuCGQT	10827	15244	15244	1618683120000
21604	3NLGQ73mUhQ4p4LaGHf4iDtX7mcYvR2BDGQGvhF32pTbp4eZ4LnW	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1451	1292	395	12463	13801	jxnKEPfjz3ua5xeVC6uL33E8Jkc1DrERm326ZzRxuFtcTucrsUk	10828	15245	15245	1618683300000
21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	21608	3NKzvBPP1hJunnPwSXFx2vsJADoijDJjSYcT8kDUjEMcckKiQCTy	1590	1300	395	12463	13806	jxm6eh7Bsm85CL1QgyxXQNpohbbDEBLarML63UfWQtva857Jz9E	10830	15247	15247	1618683660000
21617	3NLASMrMmUG5e178dFvLqUYS8D2p4WBNwD84KT2mFcfEKuQZiw4a	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1652	1189	395	12463	13813	jwj3bEDeii9uWRuCT9kZHQ1W95z5sUQGdRkbdpf6ui1nLa9PHg8	10833	15250	15250	1618684200000
21619	3NLgquCDJMexQ2CGF5oJXAQpYEUrfxULEgF6BdjPfSYpnGRPLwPb	21594	3NLihXjD6fdtDte3J2GFMzzorh8i29NoRjaASVs1X91h9cvSegNH	1581	778	388	12463	13815	jxWPf8RdLTJrTLxEide4gLLc7yst5mkq1X9T22YRtbVdBJnSGUi	10706	15251	15251	1618684380000
21621	3NLoU25v2xj2eaw83wGp18JY2ikMLCRRVZah7okxTVbjcYitNHJK	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1406	1393	395	12463	13817	jxueCr1SUHLNXV9KgrRtJo8qgkCofaJWsGrNkAbe6pKytKjjmv2	10834	15252	15252	1618684560000
21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	21629	3NLMkVorVJYmin1gohCB3zhY5jP8B5WXZ699zuza1fSdAo5XUkq2	1490	1028	395	12463	13825	jxon38m5GSSjGu88aMoZAs8nXQskEhJkoSPUDyP8zxqtb9uhcPa	10837	15256	15256	1618685280000
21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1585	1120	395	12463	13828	jwwWJcFUY4hKFMrPhEyQ8J8DxhMuf8pF1BFbB8YpgnbC52U2Qnu	10838	15257	15257	1618685460000
21647	3NKQfZosvnF6UG2rDiLUUdQghBNUQaeeEEK56PgnjQGDGzJsMR7N	21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	1444	1381	395	12463	13837	jwgRbKKvmPmurYAcScp4rVdiEMjmVhiXQugqJVoUVBbxvBSjgea	10845	15266	15266	1618687080000
21650	3NLodqGQULTxs3FkXHZd6MFxA4TVNdqRXNKFFe84Pt4vmqKKNGtW	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1403	824	396	12463	13840	jxswEHFByeiAnJgB6EqC8WUsgpp1fGATv5Y75b9ZpsupVjrqpju	10846	15267	15267	1618687260000
21652	3NKxYsiAeNcTwfHporD6giUTPuGdxkLzG6YvoFFGVaqhaY9SHDmn	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1609	1333	396	12463	13841	jwhgbdiXTwE4hXoAX7mmRVBUNAPk6KMBrt12RGnSumXGn5CqAsZ	10846	15267	15267	1618687260000
21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	1627	1139	396	12463	13843	jxyJkBrqTBVhfLVei6UtG4WpnEdoePiJtRLmtphZ5xfL3DoxLA5	10847	15270	15270	1618687800000
21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	21658	3NKsnk2fyeASGkEvRAdkHz1TE4LWkDNqmHGoySEdS84wxuDwv847	1542	1304	396	12463	13848	jxNu6bJThH6ir6VFDsB2HVEqFjgFfxdugyxpgQM9ZJC4JSXh7aU	10851	15274	15274	1618688520000
21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	1560	1045	396	12463	13851	jxfktaQTm1ih1BAVK6UaUazx23zoGGkTbb3P2CyAvif7Mifzekz	10854	15277	15277	1618689060000
21666	3NLibCgumSEokgUeoRiq4jAVR6cUkhftTMEr5jtnVtDqQYGZ5zC8	21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	1560	1045	385	12463	13852	jwKwbn44ndNFJKZwRYgGPHPTi4e4Wm81cpbmWVz92jAM6gwHvgf	10626	15277	15277	1618689060000
21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	21671	3NKgsBsPzed72iSMU29VP8FwNrqxFVZxqUJjQ6SWWuPndbEFSrWv	1444	1015	396	12463	13858	jwpwCPiZBEvqspckqAbZz5Tugr6pjcppm3Voi86cfTTogHWwMA7	10857	15281	15281	1618689780000
21681	3NLM3KR3nrefinRAtighYumFhL7MZTctwR9cRk2ChZG9Bcb7g8Gf	21580	3NKcD6wWitKVff3fA6n5TcqBj9Nw8NMhpWtzNWJJxw5aDuF7Fc9v	1402	850	394	12463	13866	jwGUCquEfCXEorP6rrCA4sAN3TDnEXLZPoCYaGswNhM8YG2vqWu	10816	15286	15286	1618690680000
21685	3NKXYYvB5yH7BD9aDrwW3kHmDdnpDZGEK6mDEztXkgY9MghmMguw	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jwrYLZZrC3t5NjSVbBJiL2pUv5FQAKrKYTq47wJzu1pqim6PSFg	10863	15287	15287	1618690860000
21688	3NKbJcUrrCbKKHFUYmWxnDzWSMUyWCgwYLgPsqWBSKBuLmk8yGGG	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jxtGPQoWDcDEzfppiUwtVT9x1MnRB5R7uQUenUZvGwr56tvxnf5	10863	15287	15287	1618690926795
21690	3NKqEEdzdUxvL96vZsBAwYRSUezVRxianrHjai7TkYcwqVqvxcvY	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1593	1100	396	12463	13871	jxEGVq9rMT6xbfGqCyH6UsVH2mRwrnAxRi2NkFKxPTo51Kz6eox	10865	15291	15291	1618691580000
21692	3NK4XBsB16ywoBLYHVovPwzYfnjyhVZDigo8JuMbw12zDc5Lc6cx	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1593	1100	396	12463	13871	jxkgcoo3DWUcZwPk2wd7PdyBM1JFqecThXVbhhuRrL4mDRsJkpC	10865	15291	15291	1618691580000
21571	3NKbcoQ9rkyn93gV8gLzBE5zQqJbgDxtHhUpzEveZ6dYsdKpcY36	21565	3NKTK7WT8jyiGpJ4YsDoCtv8j2KpCCRTJPkwWWzqKhSqrKFjTUkx	1613	1349	394	12463	13771	jwN1tPNKsQBUB1Mh9dqU2faH8xPYXtxKkPjzV4nw1p4NES9Ym7v	10814	15228	15228	1618680240000
21577	3NLK2BdZksskyk3CiZjGuDU6uHJK2vjtZGt56BX5W3sXg1fKYZXn	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1546	1213	394	12463	13776	jx9woZgPxUnfKK2woW7mDawmkmcw5HVkpwAt2Uub1DfoiEoKUFZ	10817	15231	15231	1618680782694
21578	3NLhRnjr88Qrx1MndAWRL9tdoUE5xZKRGdMuoeuxQFCzwPNv3nGV	21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	1602	1369	394	12463	13777	jwkk3vRBdxeKG2y2cKvMZ9yxZEtQFhuo9LW3ezMQq1vxpPucGf8	10818	15232	15232	1618680960000
21580	3NKcD6wWitKVff3fA6n5TcqBj9Nw8NMhpWtzNWJJxw5aDuF7Fc9v	21574	3NKPUsqBSqYUCgSKTPyfX3fxiTqxPJ459BDX5JF3fUfxXioiBYTP	1402	888	394	12463	13778	jxhChNdPAeBDCJcRamoNNJVdxjsYrF7icf73mYJo4WBNeeSGquq	10815	15232	15232	1618680960000
21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	1609	1087	394	12463	13781	jwJHQgEvJca41CCk7Ei4Md9acGyLSm7wMdWsNjbz2ywVY3GDDPw	10820	15235	15235	1618681500000
21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1501	1360	394	12463	13786	jxpGrKEJpHePUb7nCHFUebfSioWzdEzutQz78mVqCfWQSsGknXw	10823	15238	15238	1618682040000
21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	1407	1395	394	12463	13788	jwQocWzkfgpVyUjmLCaiBZFz2reL728GdGNhxTS2bUJTxM36Goo	10824	15240	15240	1618682400000
21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	632	1382	395	12463	13793	jwBQbRfDzz6g3HAPDmJapAyggCCEQxwAJyzoapaAK9QtMcG3VVw	10825	15242	15242	1618682760000
21601	3NLFE6JM3UftVE58FJ5X7eGf4KtmLsotMSxNXjpunxCgZNW2q8qD	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1675	1342	395	12463	13798	jwHoEiZvyTP7rqGVbB13UaZn9zn6eHUQgL1suymPapcviP46F7u	10827	15244	15244	1618683120000
21603	3NK98zUtLteW3U3T8d6f2SK3zsT1oncAaMNNrttZFXngaevn5ZHV	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1654	974	395	12463	13800	jxKYi7GznCjVNifsiYVkdyxhVXeTdBoVdz8Zd4xwB9bba2NuKTx	10828	15245	15245	1618683300000
21609	3NLZ7kej95pjFLdsCCJWRh9DRdASeL2oezPYQJE4T9mMGzqpHids	21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	1507	345	395	12463	13805	jxDcopqwUKUK7uXqC19HADY6kHh6jkXaSfSfynYs1g7tA74gpNg	10829	15246	15246	1618683480000
21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	1457	1391	395	12463	13808	jwg5x92wck1p28a3HSHHpiCGTsVjSHEN5oBDpo9RfkLKSaYiut6	10831	15248	15248	1618683840000
21618	3NKgWSebDqmiKojcsCaRSpJd1oB1jhybctuQ8degBg3juimRo9CS	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1564	1338	389	12463	13814	jxnCcrHXTMTyvcQGwGsfvgoyFjjHojzhknetoKfo3TiKmVchbSV	10716	15250	15250	1618684200000
21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	606	1295	395	12463	13820	jwf7vMPeJqqorK9ZVAjb6UGjGgKrfUzSMvjmEVN5XBCfBefbjJF	10834	15252	15252	1618684560000
21626	3NK59NetmjqQZctL1xRiY1nHwAQ1iXtJfB5YHUi91EBp5jWGGXhU	21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	1670	1036	393	12463	13821	jxneHCh6MdoFEPnLYMsVouF2cHURwJtF4LjpF14mfhRC3KRxJYE	10782	15252	15252	1618684560000
21627	3NLMrHoDBn9BWbwWt6EtUokzbyjMDSofg2BoVyWCLky5MT85oDAg	21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	1406	1393	395	12463	13822	jweCKzbpcQqTjovAG59Y6PWvmDr3nBwpEjKYCCDzkhsYNRmqH7e	10835	15253	15253	1618684740000
21634	3NKTTz1Ud8R7MVAWe99kwuVZ9z2V2z74XtB22Nz7z5at9CMdmXSM	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1536	1313	395	12463	13827	jxu5oBQRiHKWZrRopte9MehrGEpSTgZrg6d33uPWYc3CtvAND4H	10838	15257	15257	1618685460000
21639	3NLUvCgwbzyqb6yC2wf2KMvTChFdiK7DTKHTHsw4nQFY7ZUXbMKW	21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	1672	919	395	12463	13831	jxSjSQaG1XoiRyJgDLVJvFTTWf3BT7cK4sMeVabDzToMjD2nUtW	10840	15259	15259	1618685820000
21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	470	1309	395	12463	13833	jwRyVyViNH5BnYryVVUn2mANu9zye3xZjckeL77RLMZbpvU3Wv9	10842	15261	15261	1618686180000
21644	3NKCXT75gHTk4HKfj7BgH1vBCjJ5EpHh7P3YQJgjg4RohB8bn4ao	21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	1460	958	395	12463	13835	jxoz9V9VVveCrZPc6B735cxM3wPoqNZHJnfRfLnHxLk1fTLFgt7	10843	15263	15263	1618686540000
21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	1444	1381	395	12463	13837	jwgRbKKvmPmurYAcScp4rVdiEMjmVhiXQugqJVoUVBbxvBSjgea	10845	15266	15266	1618687080000
21649	3NLo2QziDomupNfX95pVnZ4aG2ZPxHiciBavEGAAWDXLm76at9rE	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1542	1058	396	12463	13839	jwmTqmYq6VhTnTXB1tdfBRvH73QE1Bn1NJdfjn7Umb3NhrGLy5R	10846	15267	15267	1618687260000
21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1542	1058	396	12463	13839	jw93QpAL29dx1ek9JKRmbKAd72HCLxD1MS2oimr2joXQCMeV9us	10846	15267	15267	1618687260000
21655	3NKiTKkUCXytH8MXv4Wken7kT3H3HBZvjPyzfA8EHYwkcnCfZNgL	21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	1637	816	396	12463	13844	jxxQ8ddJzjkMrhfJiS4maDwnRX2wwxSAGvjyLKGPyejsAAEq51r	10847	15270	15270	1618687800000
21658	3NKsnk2fyeASGkEvRAdkHz1TE4LWkDNqmHGoySEdS84wxuDwv847	21657	3NKCV1xdzHUmQjphAKLgced8ekMZwfDh93uvZZkWMoEQuFbLQXgX	80	1027	396	12463	13847	jxZSuw2D6s1vU6GEWA792VVkNxHAhMS3zUMM1CyzHWiYacKPRob	10850	15273	15273	1618688340000
21661	3NL1Lrh8s2PjCN25jNUr3mybAr3cvN9PBFfazEVp4uDWNcLJ3DxH	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jy2vbQTWYDjZgDx259XNX89pFXigmwEYY7gTkHSDjfmwnThHuA7	10852	15275	15275	1618688702484
21667	3NLe4aE4FDwurSNyMkf7rHe19WipbCoJn8vgbdzntALWV6Ttv4Cu	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1602	1369	396	12463	13853	jwNvKMNDVSdds647UDoQ6QYWpyputZPKUvXQumkJCXU41pEwGZw	10855	15278	15278	1618689240000
21670	3NKQZMyse3H56o8ZszpPM7LtTE4wcPLAgZ2DHVRn1rN1rGuVFjYs	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1675	1342	396	12463	13855	jxnGJjgBV99jbJcMqAaxfwLtx7Fb3vYpQ9L2THFZTdPW2oSe5j1	10855	15278	15278	1618689240000
21672	3NL7DBMCbANx2XJvj4fb2ZgM16hPYCz3qMjvpw3J1Y4DFkNke4dF	21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	1542	1304	396	12463	13857	jx9u3Ta43iNj2Ze8VoBUUczZzLsqbeqvxfsh9E3mB8u8djR3eek	10848	15280	15280	1618689600000
21674	3NLc1daYvUicAxGHW8F4navEscm8khmc4JEwDWwCE4tc9VgoKnVj	21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	1546	973	396	12463	13859	jwXwE4bsikLui6HzTdtY8shfJxzWsxUECiQTFBEHQB6mcciFmSW	10858	15282	15282	1618689960000
21679	3NLNeYV3nFQ7WfmdcJESafoUJgyqQNctkKof4eZSjnvovCrAtB7q	21678	3NKA3S9w96RVuZr2Png5ccAgqx2cK99iu12ZnkoJDEvBGCS8NRAA	43	1184	396	12463	13864	jxNJ63e3DUXqku82B8b1Tb7NvhAxMVzjsu4SBJdex11sQb1SSCQ	10861	15285	15285	1618690500000
21684	3NLZapfwVQmp6w4muiLbuALho9Jbjba2sxwLJi6QLW53j2NBmG6f	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1579	1263	396	12463	13869	jwyUNEn6jvhrvqaXJHZ6A3hCzUcHRx8SvHciHJF643t5Ybvt13c	10863	15287	15287	1618690860000
21613	3NLLSbSHAyiJaA2DExr1W9HRDtnjmxSipD66ZTdSG8VvEKT2VZb8	21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	1627	1385	395	12463	13809	jxjqBKZVoqR7Jp2pcfk6NnTKabaUiwamkWgKqKaRK6WHEww1xGX	10832	15249	15249	1618684020000
21615	3NKjHRZ7NuByaPuWpDSTp5TwxxYVztmrMcRnqfhcdsnPNyRShJHv	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1656	1343	395	12463	13811	jxCN1V1Ez62GWnATFAeFS7hQywsoqndSM4bHRhbVB8fVPBRttPi	10833	15250	15250	1618684200000
21622	3NLP1aZf6n92ocTZ3d8zhjUYxS1f6mMxs89vGzKk6GAri9Tq1wxC	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1407	1395	395	12463	13818	jxEn23hGhYeZfpwFKKaGwZfKtuFAtHvr4Eptm6xcJJ7gaU5EH5y	10834	15252	15252	1618684560000
21625	3NKi6sC9Vu3LawrnyZpJvjdJ6ZdHrWGP42YQMsFq1XB4s6W1vZpo	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1670	1036	395	12463	13819	jwNYbXPChiWNBrV84D4xEDM7MtkcK8PJc8XGri8MzqiaCaH9adX	10834	15252	15252	1618684560000
21628	3NKMmcHGBSee5bpaUZEEo7qx9uiQ34Mfeue4b5dX5aqeapLLitYb	21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	1673	1368	395	12463	13823	jx5mDzZQAYf6p5ZVTaYaCYFZF5zHb7e3UiFLpoYSH66E4UXr5BP	10835	15253	15253	1618684740000
21631	3NL6Adg2YfC62j3K7Afb5rGMa4HT7ANr9AVS1mRjPxL2xJZ6LY3T	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1406	1393	395	12463	13826	jwUZhygG1AYBVmUssJ3PmQ4RAoaecV5ivVSEjYKPxNj96vzw5d4	10838	15257	15257	1618685460000
21635	3NLEW1viF8QH8xV8GjhLHt5DApX1RMenv762SQCrpNCosXqS3cyf	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1593	1346	395	12463	13829	jxk3n82mnCKBEUy3xyPe3kWnNEmz3fRH6N3iHPeMJsg8huWbL11	10839	15258	15258	1618685640000
21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1631	794	395	12463	13830	jwkNLBxUy6HYcYR3RWE87sEU9Y5vdxHLapWSEfTpPBReizu81Tk	10839	15258	15258	1618685640000
21643	3NLeRr31V7vwhbd8DPcqzDw4G8w53fejjn9H2fLKzVcwSvSR3S2u	21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	1460	958	395	12463	13835	jw9NhYwAWVbsCReoZHFnXYuxXArgWT3Wh9FKnmDJshN2toDR6vb	10843	15263	15263	1618686540000
21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	21643	3NLeRr31V7vwhbd8DPcqzDw4G8w53fejjn9H2fLKzVcwSvSR3S2u	1648	1284	395	12463	13836	jwYxLsXhXuasZi4MmsowLpjyMcnjApvHCUZ7Tu6mU1zSQQAqwxM	10844	15264	15264	1618686720000
21648	3NKUcCuBMmuEpXSK9AnTpf5Hudo8HjAgoDxtb8Ssfs1P2hjw64CC	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1407	1395	396	12463	13838	jxtJ6SywpnruCLS73CLeu6J1BcojuMarNxVVQifh4ZEFxLXSNZa	10846	15267	15267	1618687260000
21657	3NKCV1xdzHUmQjphAKLgced8ekMZwfDh93uvZZkWMoEQuFbLQXgX	21656	3NKeZKJKjMDcXzcea6z3tUQXJ4wzqUBvQa9QZbdGKeeHPdcxRoeX	1516	1294	396	12463	13846	jwRdT2MAPrvA5R5x6fdcyD3b6XmSmJRGUPFRAxnokrqrw4xM5ju	10849	15272	15272	1618688160000
21660	3NLPmJot5jzrpjzDqKsXFM8DrduF1XK9XpVXt1Sztz6msPbjJ4Pu	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jwcxWKe4RHnKWenRQ6fCBqPYjWgAvqsVj6WiYE9f5GDLMMjJmct	10852	15275	15275	1618688700000
21662	3NK9JAVqQnyjQsYYpDMwb1p5JrbjVQZkgxA9pedEQJ2SV99Lan7m	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jy2vbQTWYDjZgDx259XNX89pFXigmwEYY7gTkHSDjfmwnThHuA7	10852	15275	15275	1618688700000
21665	3NKWnWxfYZDfETLEvBPkmUqwxVGFMKogtjc5fr85w99saNStg652	21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	1560	1045	396	12463	13851	jxfpUYtiw8VVY3fPrMi4XkcNUzwYgdfuiiZbcEm3ZoMYjEQmVzg	10854	15277	15277	1618689060000
21669	3NKrgzsDTW1TUK1CaU1cTkjpUQ7LMT2BhygXX6fPxcF9rWd6JQz7	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1607	1102	396	12463	13854	jxSzj5hv6DKQEX2osbxuPZLKhvakkLhDAzTLxV2yUQt4Hc8r9QX	10855	15278	15278	1618689240000
21671	3NKgsBsPzed72iSMU29VP8FwNrqxFVZxqUJjQ6SWWuPndbEFSrWv	21669	3NKrgzsDTW1TUK1CaU1cTkjpUQ7LMT2BhygXX6fPxcF9rWd6JQz7	1542	1304	396	12463	13856	jx8RhpSFEBf2KZDYb5zhMhhTGZsvaTQvMzdR1ZjEQfBuQERoqyk	10856	15280	15280	1618689600000
21676	3NLKhmSE1Uzx2DZfTvkPkLMpSCSDjfpLgqksnTD5MNQPy6jqUUTY	21619	3NLgquCDJMexQ2CGF5oJXAQpYEUrfxULEgF6BdjPfSYpnGRPLwPb	1581	778	388	12463	13861	jxW4f7LmHDnveWbQm26UENS5NhQvPjS1G7VWmgssbG9pJExsYAS	10707	15282	15282	1618689960000
21678	3NKA3S9w96RVuZr2Png5ccAgqx2cK99iu12ZnkoJDEvBGCS8NRAA	21677	3NKuSr9JiNtaqDf1kfuhLYoAgP6o8R3dFnLAYY9Gfv7mho7QnEDR	1553	775	396	12463	13863	jwUxgqbEqPSGrcnzVyY1dKEGrsW3XSwPVzuMjyy8b5XwWWp46rr	10860	15284	15284	1618690320000
21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	21679	3NLNeYV3nFQ7WfmdcJESafoUJgyqQNctkKof4eZSjnvovCrAtB7q	1553	776	396	12463	13867	jxoYspc9ppcSBbLF7b5KGj1dBnPWhso8Uf83hnXwdagZmBp1mYA	10862	15286	15286	1618690680000
21683	3NLFX3PQJf64SgCYaVpM2C7BfZYMbpbjuwiZQmyeVEjezLhMTjbf	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jwSqmFWM41YZKNMQTFikoec6htGPxiYYf81z5HGLHrfGPQ4t1Dh	10863	15287	15287	1618690860000
21686	3NKu7Rewu6akGuCCTYjdcxKTRfcn6FuKEcPRNgy3BAEtSu7HUHfp	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jw8VNRnqNfUCAv4dFMBGJ5RAbNnccPcfjAH9ZGrC68eERM6WBaY	10863	15287	15287	1618690860000
21694	3NKEXUuNNsfUVQaGKzPUksqWqn4Zx1KgKakEZvEpKUKqym1H5sCT	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jwb5ts9QSiYueix9pVVeZkKGpX9F9MD5ir3caGk7nGUxWXuTdcd	10867	15294	15294	1618692120000
21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	1440	1377	397	12463	13882	jx84EXqp4kB6CYARinajJM6iJq33QhuFu8YSaJdf3RWaBZ1hDJh	10872	15302	15302	1618693560000
21707	3NK9cLhXpZi25V7dwE97vq4UbjxaZ7B5xupTxaeoXWdQa1B1hoyQ	21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	1483	421	397	12463	13883	jwXX89UY68jL3vZ7hKQKU1y7Z3dYYyJCuRoyxHUgY2aq35i4XtN	10873	15304	15304	1618693920000
21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1536	1313	397	12463	13886	jx1YtpMV3f6HNvNMfD51XgJJbwzxWHrbvuLHVB4ntr2HZ96mnKN	10875	15307	15307	1618694460000
21714	3NK5ErbfzZswUqRGAeDDrvCvi4hrz3CZkGWkZPNRSYNuCMMkc5zB	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1637	816	397	12463	13889	jxLwL3gYBkqTmnXKQU7o6CxewwdXMcratgvUvLfjDaGuacyVReY	10877	15310	15310	1618695000000
21717	3NLkf2UyzCFB5FQgWkLtAcLQNwj6qnFkL6rwA1T41RuDggAMGjRg	21716	3NLHJ1q1maQjnUsTHdgmMLii4AiPUGqtTWVe1iUMhw544FWchdhi	1637	816	397	12463	13891	jxZe1sZhpoz7sjeVuJ7uTP8noJb3gntsnGa7semJSCJe6DHsBD9	10878	15314	15314	1618695720000
21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	44	1199	397	12463	13894	jxKHCYwGm5goi4dAHmCynk7tMN2wfV7qV8FMkAtmEwMaKCidzqz	10881	15317	15317	1618696260000
21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1406	1393	397	12463	13896	jwEPTMCTEDP4MpcL5UvzwBkiYkRxTBVs6C5GPdnSrpkMZDzeyvs	10882	15318	15318	1618696440000
21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1406	1393	397	12463	13903	jxdmAjbZy29UGV3gGy6f8vLyAe5dn2dDiR6NeeCeFqirWu6Cznx	10885	15321	15321	1618696980000
21733	3NKGykXWDY8vdcyeCTJaohn58vXunLuaGaQLxqGchPNKEPNuAf1y	21681	3NLM3KR3nrefinRAtighYumFhL7MZTctwR9cRk2ChZG9Bcb7g8Gf	1402	888	395	12463	13907	jwxR17jfvG7gtq7K6HQ9PUzpBe8ZLSsd9HEzmsQW8v41dRPMtst	10817	15321	15321	1618696980000
21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	1403	824	395	12463	13810	jwPixYENY9MaSqkTgPm8rzLrHs2MBk39HUygMxLiARaYYaW82PC	10832	15249	15249	1618684020000
21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1637	816	395	12463	13812	jwjiMCbJGcm4Yzv5rDjbCZDtXEjVx9qDeo1MSLSmf3zKmBie7KH	10833	15250	15250	1618684200000
21620	3NLUR83Fb1jRJPiBaEH7RwUFrnyj9ZkohghMFqSp9CWSM6B1AojK	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1631	794	382	12463	13816	jxUrzxGCkgP4kepmMVVovyGUbqMFcNFNZc53ss89YNAGU74BMqb	10563	15251	15251	1618684380000
21623	3NKdLyS9vh1vjxavjPyK5LQMcQ6vG5jsPDmKg8qVWntk2jriFwet	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1670	1036	395	12463	13819	jwwf1dqSueJUGRi8v7BCuMQb11Tpp2fmdbUww742PBJccGYqmUE	10834	15252	15252	1618684560000
21629	3NLMkVorVJYmin1gohCB3zhY5jP8B5WXZ699zuza1fSdAo5XUkq2	21627	3NLMrHoDBn9BWbwWt6EtUokzbyjMDSofg2BoVyWCLky5MT85oDAg	1419	814	395	12463	13824	jwzpDV6GFHp8RquBzdt3sQpoVxcsSgsUa37HLZJ1UVCSsKsuYBP	10836	15255	15255	1618685100000
21632	3NLPccr2op26KEyK9brEgza2ogpZ9aMMUGDFxNv7YkhmfR6Abp6w	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1536	1313	395	12463	13827	jxkeCBLaLcn3rrD2LMUhBQyY1arKMXUFyP3k2xNsPrqyGbmgS4e	10838	15257	15257	1618685460000
21636	3NL3fhzCnq9gbYcT8D82V5r4Am9gEj8M8SATWk6nkFdwtBc9LzKr	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1593	1346	395	12463	13829	jxwkBrAubgTNyN2Y1DQ3XymzQGJy1FEYbnkdjJYNYwmHZwYyb5H	10839	15258	15258	1618685640000
21638	3NKfxTwQgYA4EYrfQ55Ls3DCKiddZSYvNhvChom4osGQAJ7XCEyR	21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	1672	919	395	12463	13831	jwrDSotGLxcDU66ChHP2YY9866RRvnA3Ftun1WJt1D7jBguP3ZN	10840	15259	15259	1618685820000
21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	21638	3NKfxTwQgYA4EYrfQ55Ls3DCKiddZSYvNhvChom4osGQAJ7XCEyR	1426	1364	395	12463	13832	jxcTheHY4vySb7wGeDVaAJjRUNbZEd7MRPCoBNbFVZUnuP5yPtD	10841	15260	15260	1618686000000
21642	3NKxvWrTb9Qu9CXUZ2pq5NuagcR5KksL6zBySgjUUyfBy2qFnBjM	21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	1648	1158	395	12463	13834	jx4eLWABJJRxQsDz7nA5jXhqeCm293AqqqrSqy5q3pdk7u1nJtF	10842	15261	15261	1618686180000
21653	3NKgeBUY9SLarVf9vZUwzrdJGwoEvxPV5FbPAP4hvPJyn1DpdsjH	21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	1481	790	387	12463	13842	jwuTviAYD2Pq8xfLv6AMUKV4a4DxUgiYhpEaF2EZ22pytiPmDJV	10674	15267	15267	1618687260000
21656	3NKeZKJKjMDcXzcea6z3tUQXJ4wzqUBvQa9QZbdGKeeHPdcxRoeX	21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	1407	1395	396	12463	13845	jxzDwhxrkBdFqd3UsWVjLsfbaa7QzLgrNtFTHMw26FLsGKMvHZw	10848	15271	15271	1618687980000
21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	21662	3NK9JAVqQnyjQsYYpDMwb1p5JrbjVQZkgxA9pedEQJ2SV99Lan7m	1407	1395	396	12463	13850	jxCd8JivAmJuxrcrxhiggBHdv9mM3Xiv8nzqXfxhU61Rs8w8e31	10853	15276	15276	1618688880000
21668	3NK49XpwD9LNgcDzAJrqBqefwVDcJDoSzheSVgTfuUNYCYXM63xP	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1602	1369	396	12463	13853	jxThVMDxeswbfMYtSsz6uWXEsabu11ad1iJ6UFU7Fe73iQoirhs	10855	15278	15278	1618689240000
21675	3NLYAibq6BwFC1gyKCRbGyX2TdEZxnFcuQtKQEoZtJRbjbzC9bGB	21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	470	943	396	12463	13860	jwdHrbJeEs9uriCWh4FpoaneNsCvAVMAUh3gp5qHCuk29diNcZc	10858	15282	15282	1618689960000
21677	3NKuSr9JiNtaqDf1kfuhLYoAgP6o8R3dFnLAYY9Gfv7mho7QnEDR	21675	3NLYAibq6BwFC1gyKCRbGyX2TdEZxnFcuQtKQEoZtJRbjbzC9bGB	1589	1040	396	12463	13862	jwY1AtaeUecSwgvBRDhP7A8r5eBVisgGjGJTN4jXpHi6CdeuwpF	10859	15283	15283	1618690140000
21680	3NKG71Uk3HyaFSwy8irBj4xWmQoXsxtHqWoD7FFwYPcWoMwS5o3j	21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	43	1184	392	12463	13865	jwcPDLsp2SEgM73VW9THteJueNS7Zwfo1fZtcCjvfE4WmtvCVqC	10765	15285	15285	1618690500000
21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	21685	3NKXYYvB5yH7BD9aDrwW3kHmDdnpDZGEK6mDEztXkgY9MghmMguw	1675	1342	396	12463	13870	jwb8uY58ppgHzffqKM58Mhf3UkAn8yspXRXmLEktPXgzP5FZhpX	10864	15288	15288	1618691040000
21691	3NKnTRJregArrLbhNtAmecjF4NnaYTe6b4M2NkyLohPeFuMR6Hh6	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1634	1331	396	12463	13872	jxoF52KnnMLGTAFvMcKoqaJN1LMYN9CrHKVH1HDJaZJQYesSSJA	10865	15291	15291	1618691580000
21700	3NLFsGZumYQhDiYQZ8LdXGkvRPtCiaoZMFkP8nR7M1MvTUuGkygG	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1596	1117	397	12463	13878	jwAQh8fFnJsy2DVkFMyZxEgJosB4SYwz3gAEatGJi2oyNMZJ9uS	10869	15296	15296	1618692480000
21702	3NLW38FdQ89HYDCxmv9uFiXixfytajdGASyRZRWEjEdjUPPb6Hvf	21699	3NLEzdUqo53HWbJNFDokHsp5FSC8Fw3L3WTT9esokurUa8cxp3aF	1406	1393	397	12463	13880	jxP9q4agFHEX95soCrFZi9SqRpzYnuiQQjR1CeJotoEbNqffUDy	10870	15297	15297	1618692660000
21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	21702	3NLW38FdQ89HYDCxmv9uFiXixfytajdGASyRZRWEjEdjUPPb6Hvf	1403	824	397	12463	13881	jwEGy2BYTMdMxSdcFqvS3ZcCMm8MiDS5drt1Gx4RvDELrmB9ZdV	10871	15301	15301	1618693380000
21705	3NKkvH1mpZxYJxwL5VkBEg6r6x84UsyZcnFyfkcMnkP3z6EzoTQZ	21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	1440	1377	397	12463	13882	jwPrwDpiMfKGLuVUGrTh5yynMx5DPtawygc4TSJeqrruEe6CcYS	10872	15302	15302	1618693560000
21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	21707	3NK9cLhXpZi25V7dwE97vq4UbjxaZ7B5xupTxaeoXWdQa1B1hoyQ	369	1312	397	12463	13884	jwdr8y8EhE26us63Cw2Fa8okCJS7okc9T9vbQskc1uUM5gQK5Lr	10874	15305	15305	1618694100000
21726	3NK7GT6L3TUhg2Bz4Wu1yhDLB3pTXUMcs3ftTiqG3ehcTvfFoC95	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1619	1275	397	12463	13900	jwruWWBNv7vfG6nqTtNqbPEnNsUYgCmtmSroqkfg1TqwaU3AgjR	10883	15319	15319	1618696620000
21732	3NL2pLA5E2WRPhW63ckTWzMjLWyXHPisehs4PMZYby3Y2drQAkM6	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1506	1373	397	12463	13906	jxrFRnJLNWsdzpDrmX5ZyYXbE4dFzdJEjJkY3QvQr5jKSeC6hJk	10885	15321	15321	1618696980000
21736	3NLvW91YzqfgyiUAhVfrVJADDDmbNkUNPatbg1egG6vu95xmE2vE	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1599	1287	398	12463	13908	jxaGHm1hcRmDqEq41a8VPQSbgjpoB4g2JNiXs5uD4F2Fjak2atg	10886	15324	15324	1618697520000
21739	3NKuTGDE9MFVnkypEn3f4sW2MtbQR3evVtaLnYws8G7FmZBZPPAQ	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1637	816	398	12463	13912	jx8Snm883be35ai5tpUnHkeWYoF4ixLLqhdYR7xgMBXDzR4UArv	10887	15326	15326	1618697880000
21741	3NLSUCNX5innfYhrUd84gSKvkUA5QHNza3vbeabayfVQ6p79YHEc	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1651	1301	398	12463	13913	jxfcNLpSG7ucpPcocRwquagG8kgunc6k311qAy6zh9eoULkVxUa	10887	15326	15326	1618697880000
21750	3NKEQcN6FV9v83Rvnr7ddYgspAw5JMbSdBZ3Vyp5uGrzriGckNj1	21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	1474	1203	398	12463	13922	jy15QF7kUQW69GFzhW12ynxf8jPEXB5484UgrE6eKKoPdJApqvq	10891	15330	15330	1618698600000
21754	3NLAe3eSvtb3rfDEtXUS3Xp6QcRBgYWg4tkPHKpL6cwznfx4WN9r	21680	3NKG71Uk3HyaFSwy8irBj4xWmQoXsxtHqWoD7FFwYPcWoMwS5o3j	43	1310	392	12463	13926	jxbMX2VGw29VWxxgps9yjYeCYkp3PrzycPoVxCxgoRJL75gadES	10766	15331	15331	1618698780000
21756	3NLKiSLKgo4dpM4JHWjaFH9dHnEnL9inz8FY7jpyTQsDTojFYzyp	21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	1419	814	398	12463	13928	jwZPngHi9Fa1qHCTLhRcfMfuvWJvfjUQXnGmvWYkLwLaxdnKSSd	10893	15332	15332	1618698960000
21687	3NLFrUmqK2VLJz6KM5m7DepQPERc9zxp2G6ogFtgArnGmZ9K7WGU	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jw8VNRnqNfUCAv4dFMBGJ5RAbNnccPcfjAH9ZGrC68eERM6WBaY	10863	15287	15287	1618690912246
21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jxLtHFd3TQvraTA3VBs37Uv8m3ZWXskUJ8iTqigXk2HqMbr42Go	10867	15294	15294	1618692120000
21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	1405	887	397	12463	13875	jxkRYKphEQwS7sbUqxfzYbYopoG1qz6vixEgmZ4PN8WRsEJZheA	10868	15295	15295	1618692300000
21699	3NLEzdUqo53HWbJNFDokHsp5FSC8Fw3L3WTT9esokurUa8cxp3aF	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1585	1120	397	12463	13877	jwca1FAk1oGi7urNeie7GGJXpzig33ANX8FDncgu73aYhfrqhSE	10869	15296	15296	1618692480000
21701	3NLoqE2tFnG1MWH83iRennJTjgaJitwgUr9Zy2ixnhiHRzBM5hqA	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1590	1054	397	12463	13879	jw938zRGqccGun2d6PQZguUx1qHefDTA3MLVJJ5KPaenxU12B9n	10869	15296	15296	1618692480000
21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	1608	1289	397	12463	13887	jxs3vPAcvuFSgChkTdoKe8LZMS2RKt6q3q82deRZp7rDvkvs5aC	10876	15308	15308	1618694640000
21715	3NKzUUUD8eD2ZVmoGpanw2LX3rjC238rYYMR77QwubX7AUHCgJur	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1541	1298	397	12463	13890	jxTAfU2p3fpuJiKUVYnzDC2jirAvuM8xErSe6zE25s8JD8XPGps	10877	15310	15310	1618695000000
21718	3NKwNR2oKskvXvVPh8AknaNkR5SXXCV2LMS6NAGmbrxs8PUTq1qU	21717	3NLkf2UyzCFB5FQgWkLtAcLQNwj6qnFkL6rwA1T41RuDggAMGjRg	360	360	397	12463	13892	jwQ3cbjcV7HQHAoBntVbgmaSjnSwtRSB888J21cENNppD12XbFq	10879	15315	15315	1618695900000
21721	3NKmfNzTFaVF4diACYJymuzaJQu3NL36tSEPsuDVV4mLB6d8G6JK	21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	1637	816	397	12463	13895	jx1n1ua5AmEdXuV3wn8NtwcXMPLhryZ57Y1mhQX3eGD8poGgD7d	10881	15317	15317	1618696260000
21723	3NLChwqedKRApjXe19XtDRYbuTDtzDJZidLDm5BtCLTsmD3f4yTd	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1536	1313	397	12463	13897	jy3FghspqufXkeFtZNJh1YwzRzkk4Kpu4AU1f7iM6gcQpverRKQ	10882	15318	15318	1618696440000
21725	3NL6qpDFqU9pGHdkGtJRpTnxuq6E36yJMUMUoJqNXH5oLPXGtSxY	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1407	1395	397	12463	13899	jx1CFiNDERWsBCVTBfeAwS5TCGru1ZTLyG7xMRqZoQS8iXcQFQ6	10883	15319	15319	1618696620000
21730	3NKbpcK3iGGbGFka2Ekgb6HF41hmtB4THQa53dnTsSENDf1EdgMb	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1657	1098	397	12463	13904	jwSihhziA65shWFnbHghzLiaMGgLXftS1oFZcFhidwFdgKM4aAY	10885	15321	15321	1618696980000
21735	3NLbyYB8AzL7o8VSrTGRUkhuAFVAgwskHhKmssXEUaWucg8iveKh	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1594	1326	398	12463	13909	jwpjatgWSXBQMs1BLAjzG6TBS7ypUvWdhRdkUzwqooJcHmdPFKM	10886	15324	15324	1618697520000
21737	3NL2TXNKd1PKM4oE6xoh9tobSkqrQg1RC3f7Mdrewk5pjYdXpL5v	21618	3NKgWSebDqmiKojcsCaRSpJd1oB1jhybctuQ8degBg3juimRo9CS	1564	1338	390	12463	13910	jwx5LRrq3qx8Nbgqcb238SMrdM4PwwNXXYsz4PazSrmpfZX1y5M	10717	15325	15325	1618697700000
21744	3NLUEFhkNgTi13cdgWtoumMKx3xLshKbhtLLjdDBZ7rvzazbZFm1	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1648	1038	398	12463	13916	jwsKNrhUKswm9EFDrfTmFfZvBHDCQYiajrL3j5vE6hWo13zJwPY	10888	15327	15327	1618698060000
21748	3NLwCwzUmSKZGgMwFcgXeEpaGZupan1iX957KbXCqZAD7WQ6wDdW	21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	1637	816	398	12463	13920	jweLB1xEZhJDwv6YnLDbusA4kv7VgG6VuzwxHzMMhke7JKsvEbV	10890	15329	15329	1618698420000
21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	1607	1348	398	12463	13930	jxsVdR4tbTEDyBHkfhzrV8Ch9TCpgesvqt9eTdNdnnAKKsdFCfd	10895	15334	15334	1618699320000
21761	3NLoVmPsKLJiqWGBqHHQ524MNEMvcXcjtzkALpMkYVkVsrjTdQGQ	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1407	1395	398	12463	13933	jwXajPBmqVhRm9KeCWNp8zvEfY91auziTuoWqcX5jrAk4Fd9g2f	10896	15335	15335	1618699500000
21764	3NKYx4m76BE8SF6BwoKcTfdbGze58ncF1WM9g1TTqmaPtXUfUB5r	21676	3NLKhmSE1Uzx2DZfTvkPkLMpSCSDjfpLgqksnTD5MNQPy6jqUUTY	1581	778	388	12463	13936	jwWJggFpyXrUDMkbFLmFdP5pwWeF2qw2bpJkNDuNmy1vVseJigT	10708	15336	15336	1618699680000
21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	1428	472	398	12463	13937	jxyPJhLY6E4CAzsUiMTcSA63frgxXwvZJ8P8dv3ajRMKGZZwqbH	10898	15337	15337	1618699860000
21772	3NLmA41vPzJsr9sihwWjUaoE5janGY6cGux7CbQE7tc2yebix8Ch	21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	1594	1080	398	12463	13944	jwBNGFdA51ESMg2R29Ute1Z2j9X15gg4mEpN5GNhFQZr1eUwTpn	10901	15341	15341	1618700580000
21774	3NLSJne9oaqCHBS8MybQBFEkCgVkNCqTnVzDCVh2uyKFmcTyXS33	21772	3NLmA41vPzJsr9sihwWjUaoE5janGY6cGux7CbQE7tc2yebix8Ch	1406	1393	398	12463	13946	jxreVzuFsUTeXhDZuhtNmQvz9q1GUMqTwBqDFwYEXAPy9DtoaQF	10902	15342	15342	1618700760000
21775	3NKqHYk8871HHorHArq9cPoVpKCBGLBrXmmCGHEVqnoQunPVAUVT	21774	3NLSJne9oaqCHBS8MybQBFEkCgVkNCqTnVzDCVh2uyKFmcTyXS33	1637	816	398	12463	13947	jwmAWPeExsE8rqQtusMQkGE1KvbiVuuBQ5jF5J2bTGjMHqXWZ3U	10903	15345	15345	1618701300000
21781	3NLASZ2vtAJNV5FCMR884TzZ7mBJhGJZjoozsGkzh1TnqCLKbJJx	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	1671	1365	398	12463	13953	jxLMzhtvhVdmSaYTf7Wu4HW2VVXt2aZqXRFbsr5Ltm9aQMjjcMZ	10906	15349	15349	1618702020000
21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	1613	1349	399	12463	13958	jwKaqEwHgHyuAQdaEAv4gRssFwv6sHvTe3YGV9FRh4tv2ZLsaSH	10908	15351	15351	1618702380000
21792	3NKiG9ftRZZrRPmVhAGqQKE7YrTxkMdfpsM1E9dcrw9kyU13bszG	21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	1617	922	398	12463	13962	jxTFTSUfUKDYoKb67EhSsY3fZxK2j8ZL3RECtuSeo2cL2pAidmT	10895	15355	15355	1618703100000
21797	3NKeYsaHRHZDHpmHdV5F2XToKWLRNreRhne3UprjcJFGo5UMyRwZ	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	684	1352	399	12463	13967	jx8KUrYZSPVAiCavakSgXksmg7rQyoi9V1zndc9wJPid99cRDT2	10912	15359	15359	1618703820000
21800	3NKEeosCX84ZsK6bBJTGhb2pkXgbdXJmt427VS513vKkYYeDnmum	21764	3NKYx4m76BE8SF6BwoKcTfdbGze58ncF1WM9g1TTqmaPtXUfUB5r	1581	778	388	12463	13970	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10709	15359	15359	1618703820000
21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	21798	3NL2bc8hk1jRxSAwqF91yKPWUjcKrW6GFrAX19v19cV9P2nkt3hw	1610	1068	399	12463	13971	jwXt8PfYtsuYdZPhcqJeAw4YRsJbXKHpRkqk29kV6XVXrhKZjYi	10913	15360	15360	1618704000000
21806	3NKY7Wqk6ZNZs523FYVLfLRU6kopxkRzdS6gNUjGZrQZw2Mp6eTt	21674	3NLc1daYvUicAxGHW8F4navEscm8khmc4JEwDWwCE4tc9VgoKnVj	1560	1291	396	12463	13976	jxoLAgvHmR5LPskrSVsHYqQfKdCWB1jv8u33muq673AGWSvAS8S	10859	15362	15362	1618704360000
21808	3NLFPKDaLxZwjGn5BN59M4iCD9qNoqACTDE8yZWV1FbXood5nvdp	21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	1633	1024	399	12463	13978	jwtYpC3YhnESrqV4n4RNKNviHpPJcRykXt3urRmmVeZs9NY4JPt	10915	15364	15364	1618704720000
21810	3NLmvDKibWbLrPVXwKtfMgDHxvVEvs6bkwZbTMtAw5GDhbKbHamk	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	633	1384	399	12463	13980	jxfSmpDWjHefaxu7xmRfqm4yYsXvtDwDnxf3cP9dddXPBqmLxCM	10917	15366	15366	1618705080000
21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	21692	3NK4XBsB16ywoBLYHVovPwzYfnjyhVZDigo8JuMbw12zDc5Lc6cx	1534	1317	397	12463	13873	jwqH4LxDzSaFWpTqz27YxT3V6e8zi6B3nzqbkng65oY7Jz2f34i	10866	15292	15292	1618691760000
21696	3NLT9KMHJErgb2dG89NdzX3zoKqSo44eN4D5rDUfryrxELdFrV4o	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jxRoRrBQWzALNhR24oqqDLBLWwgUvajcpDkmswu53CJBaZNYNYN	10867	15294	15294	1618692120000
21698	3NKDmQ5Hu3VeGidRep4a3Bkvzh1ddwBuWjGAtA1PoXR4ADp35Bjg	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1571	1335	397	12463	13876	jxdzNT7jwhQannqtwmkXs9MXb3zxSvmCh9XSmkeZEfwXozKMAw7	10869	15296	15296	1618692480000
21706	3NLhcGJHYHy7ygryaHxmKwNysQZiFz8dP8MdZ7LmuPr3yAjkBxnf	21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	1483	421	397	12463	13883	jxykaJ7bHjrX2X2RtNmaQ4VWSfv95qpLyax15zWwCWdNDY9uFbs	10873	15304	15304	1618693920000
21709	3NK9SMecrzh9ZGHYwgGYuU5N9tCGKSZxgB67fQyNEJmNRnSqgVuJ	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1406	1393	397	12463	13885	jxhsZq7MNpgwp1T55mwEbDVpU5zCo17nMXu64Wv1kD5YMktw7zo	10875	15307	15307	1618694460000
21711	3NLvn1jGkMffJuJHPMfVyrfANcKEKipsFE6cFV6DwDk4JyNVjgXo	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1536	1313	397	12463	13886	jxKDB9z3LFdt2FhjjaHfJZm3bovj9zMLd8TSU6687Fgxm3RiUcF	10875	15307	15307	1618694460000
21713	3NLXod6vTEyoYSjNYHNiFdKwV6uN7zQ9AuJJ2MpkE3TR8vU2Fw4H	21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	1631	794	397	12463	13888	jxFYXKg9qdW46rAZcApJGBYWrmCQndxBNX7BxUZ4iMgQ8c7WJ8K	10876	15308	15308	1618694640000
21716	3NLHJ1q1maQjnUsTHdgmMLii4AiPUGqtTWVe1iUMhw544FWchdhi	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1541	1298	397	12463	13890	jxKimSQMF4QEKVuA3zToy6DsNcFffQu4F7nLfooD6fNWyoeFBDH	10877	15310	15310	1618695000000
21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	21718	3NKwNR2oKskvXvVPh8AknaNkR5SXXCV2LMS6NAGmbrxs8PUTq1qU	1403	824	397	12463	13893	jwPAQoHTiwpWpozKWrv9PBrtYxoPbX9MD5RuBpZvRDb7L9236Pt	10880	15316	15316	1618696080000
21724	3NKmb3RGjjm9aHn3DbNwnVTDg9dAQ8GJ1NwGqEsyiWf1y13JC8zs	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1673	1122	397	12463	13898	jxf9LpTb66grAadxa2e2aDtWjh67fEbmctoukwrS9wLoPTHfCK4	10882	15318	15318	1618696440000
21727	3NKAS3Mw3rK2PnSHCqSLtB3P4BARW9sGMwgJcdH6jGzMPckr6WRT	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1656	1097	397	12463	13901	jwjFrpBFHy25LbNcyUzvatWRDa2JLH1BdQ9ayYFhPzBb8G5fqtx	10883	15319	15319	1618696620000
21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	21726	3NK7GT6L3TUhg2Bz4Wu1yhDLB3pTXUMcs3ftTiqG3ehcTvfFoC95	1542	1304	397	12463	13902	jxbaEGMJTv16ML9ArtLmeUKv6GthFKUzF3Jhf31cf8c7uWPj4AJ	10884	15320	15320	1618696800000
21731	3NKWJR4iXDSx9LKAMXoHDTVwfDmZ8xvSQ1PcnpBtS9vmgQ4LjMBh	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1601	1142	397	12463	13905	jxQGGiMkL2Ujgy4VmexmK47Q3yB1hfRRy8vGBzwCrrFCx6bmdoN	10885	15321	15321	1618696980000
21742	3NLQMmYZbtEd46aWHfj6bMiZAvFF61Mn6EBW66j2vcaRGHYPrDFK	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1587	1231	398	12463	13914	jxNwiVTyrbUB4mmBwQyVd8XCywP4X8d98Mg86aewx9wpdEJqDQ9	10888	15327	15327	1618698060000
21745	3NKwCQ47Wn1bwBix5BcU3tPNNFQpVPnAH24H9vTjHtYNUjqkB7ky	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1579	1263	398	12463	13917	jxRjjnsBpUpRe29P6csdQ9yxkATuE5bT4EJNPkNgURLqtNM2ZVw	10888	15327	15327	1618698060000
21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	21745	3NKwCQ47Wn1bwBix5BcU3tPNNFQpVPnAH24H9vTjHtYNUjqkB7ky	1673	1242	398	12463	13918	jwhRrWZjkfAZetzQck7ivN8mHZYKvw1mzTDzjFwQchVnDQv8dpp	10889	15328	15328	1618698240000
21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	1607	1348	398	12463	13923	jwcYPYDnYeY9cwBpF5zAvMDFCVx2nhyU4yWJA7k8VpmB6dKot77	10892	15331	15331	1618698780000
21753	3NKKtiuZHBPBjHAiaAENqwyXHEWt2j3AuEohZQedemh1ejqGM4F5	21698	3NKDmQ5Hu3VeGidRep4a3Bkvzh1ddwBuWjGAtA1PoXR4ADp35Bjg	1607	1348	397	12463	13925	jwGdGzUcsxAE7kjA9tBKpLrwqYCSA7zgoKYWrEbXyDiHpXXiF5K	10870	15331	15331	1618698780000
21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	21755	3NK5cEY9RfuANFHkMqMaZZzKPqTKXGsTj2K6qE7j45yM1jcRR4gY	1458	1458	398	12463	13929	jxwdD6v1kT4vwNJKbrCmQFepCimoHHxpKYBo1kxUEbS838yEVjt	10894	15333	15333	1618699140000
21759	3NKVDH4HoJcGGuCuNFAaDjd5nzcZnt7DbWHoG3JvrcMoCjxMqW89	21753	3NKKtiuZHBPBjHAiaAENqwyXHEWt2j3AuEohZQedemh1ejqGM4F5	1607	1348	398	12463	13931	jxMHP5mPFPtpP1nYeCeRr9emRezyyVcGSVz5H8ahJViqTh1p7La	10871	15334	15334	1618699320000
21766	3NLBPraf8uZJfRn5jBmZuV45FzP9q9zvA4efPGbaxcYbXZDmfnwe	21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	1501	1360	398	12463	13938	jwBceEwFW4MGPHZRM45hkU9C9YPrSSj6UZgVxoGXRc3nhJ54NZK	10898	15337	15337	1618699860000
21769	3NLWabJVYxN4zhBf7LmvtoD47PGWje8WNRXhPiEMNgmnUwKiTP2J	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1623	839	398	12463	13941	jxdVQcVzeV2GbJkdU61ySbfPgW7SJRpvtDZG13V9tvhucaSg6AM	10899	15339	15339	1618700220000
21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	1549	1236	398	12463	13943	jx8KQi4anpuke3M9cAMSohHf9ZPY67FaEDPsqzzCFTaCzcafmNe	10900	15340	15340	1618700400000
21776	3NLTBLFLvSYRR7V6JHJyifbsAojpM4XyRPngiQJfFhZP4kom53jo	21733	3NKGykXWDY8vdcyeCTJaohn58vXunLuaGaQLxqGchPNKEPNuAf1y	1402	868	396	12463	13948	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10818	15346	15346	1618701480000
21778	3NKn9v7DhYecREDN1DUyhrP2YcvQsUVQPmugHCj9uCKaPsN5FyRJ	21776	3NLTBLFLvSYRR7V6JHJyifbsAojpM4XyRPngiQJfFhZP4kom53jo	1402	868	396	12463	13950	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10819	15347	15347	1618701660000
21780	3NK8zT4AHTv9eRDRxWdzhw9q3xBbLv1qWUW51hp6TSH1Tkosa3Wg	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	684	1352	398	12463	13952	jxNnZUc5KqPzqgUbBrDj5DLraQrXXuzP95LCSeSXsUnWnC6AJ1U	10906	15349	15349	1618702020000
21783	3NLoCYSjFQUEGRsfhpYq3jhPkziU3XhbHKJzjkiALLwE8pR9NAs9	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	448	1179	398	12463	13955	jxTyd6of67Ybd9FwKsxk6ZR7oqAyKLDcukz6KCDfc3wkAQxVeS2	10906	15349	15349	1618702020000
21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	21784	3NLxRcVx9xZu1ZTaQz5cmbJPtWW2jHGvSVRhwB9wKsEe4KSDu8Kq	1422	1337	398	12463	13957	jxWxTnC6PmAs5NiwzcfBHvaswFsmmaJ3ccyoXqz8xymWZ8JkBR7	10907	15350	15350	1618702200000
21789	3NK7CkFttBfxcQHTf633RWXUHBZHmLB9cSnbU8isCRb5w2FQED77	21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	1406	1393	399	12463	13959	jwWHBNxyPrYtFcrMK5YMFieLxFeH8QXE6kvvH1wpZPtzZt8ZJDg	10909	15354	15354	1618702920000
21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	21793	3NKHfF6Z48b3jeZRENMLy5FRV2qXGyNiySiSMJcivaD9W4LEBshz	1407	1395	399	12463	13964	jws96TsdHXgv461XgsDoJDMukAGZmjNqyKzvaa4sLgMd9TiRAxZ	10911	15357	15357	1618703460000
21796	3NLnz4rwXmvY2YFdkuywjx5Xa87BGbK57fEg7AU3CfjL4UMHWsqF	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	152	1330	397	12463	13966	jwcgvppirHKFzbE3LdWAhpf94iFzP8BHCpkUXhdS2NYsQJuLJvj	10882	15358	15358	1618703640000
21804	3NLvad21wh3Qp9qhAxjCwBEg9aYekLgPpnbt47UuuefHFvLMf2XT	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1406	1393	399	12463	13974	jxTTeVKS7BtuoToaeskzfqCkwyxg2jCg7hxNYUhJpJYk1f3yety	10914	15362	15362	1618704360000
21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1599	1287	398	12463	13908	jxaGHm1hcRmDqEq41a8VPQSbgjpoB4g2JNiXs5uD4F2Fjak2atg	10886	15324	15324	1618697520000
21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1406	1393	398	12463	13911	jx6Cx7t49fQbVWK5SqPMY39vCAGKxWVVzpeHKA2dwZRJckiHfh1	10887	15326	15326	1618697880000
21740	3NLqN1axMZPPsBCxa3A1p97GmnS1Uw2WrhneMWShcXsqZ4apYcsn	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1651	1301	398	12463	13913	jwP3bJoZJvYhEcVgZUuduAHjFBg4demt3XHGdqeMK2cwrs3x4Fk	10887	15326	15326	1618697880000
21743	3NKyaRAeAeAr1MDe8kJR6fyuNdKhiAgGEWmB1x4rXnrVKdsgHJDz	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1508	1141	398	12463	13915	jxGGQh9wmET91ruywWgchFRzEhKMsiPKASSzZQKRjaHVfxKWFid	10888	15327	15327	1618698060000
21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	1403	782	398	12463	13919	jxY5EWF3p42FuE8b3EwJfrJap1g6fC9jRwhLPiarSXVPV7qXgno	10890	15329	15329	1618698420000
21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	1534	1191	398	12463	13921	jwUz8DG8Xm621i3LBBXDgnvqpAFnbmFBT5NuTW2Cn9Fq66kExz8	10891	15330	15330	1618698600000
21752	3NLr7aRX46mkajYizsotGpuxNEGW3BcKxLeJCTnjUZTYEA4cz8BX	21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	43	1310	398	12463	13924	jxGFG68Ek7FT1znfyL1dMephGLodwZ6CZMs8i7qiZuLHFy4ZLUs	10892	15331	15331	1618698780000
21755	3NK5cEY9RfuANFHkMqMaZZzKPqTKXGsTj2K6qE7j45yM1jcRR4gY	21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	1407	1395	398	12463	13927	jwutn5iWcBwkvuyT4ScxZCwkmnzPfpzPAZ5wMDZFLN28RcTz2z5	10893	15332	15332	1618698960000
21760	3NLVpJvSj7RA9t1ymeYkLoq5GvaqvR4ZxUtqkNvwbAuBwDwbcbXe	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1403	786	398	12463	13932	jwuFmdh5EzUMa3WuTTB7PNecGd2K8eZWMMa4QHy8oCWdu6VmpKP	10896	15335	15335	1618699500000
21762	3NLUtYomjKunZNdH893JzkYjv4u9kXqMRravArCX4f1ALRuwbQmw	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1631	794	398	12463	13934	jwuWXKfwEdXYF57iTcLC9PZRasvaX54Fdn6XzrfUx1wek4miUEF	10896	15335	15335	1618699500000
21767	3NKv3TXrfhRpMNwFetGMAa1kfauK5PPtRnDv7fRe7gmwaoTmrVoa	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1546	973	398	12463	13939	jxuUnNTfpv8UaoRwyv3Qksab9VWGKyG4kxsqFyxyzEiDRRsD5KQ	10899	15339	15339	1618700220000
21777	3NLt5ShMLh6HE4JmDBem3DShXEwisFG2tE4gP5DR7ukwqD7vRwN4	21775	3NKqHYk8871HHorHArq9cPoVpKCBGLBrXmmCGHEVqnoQunPVAUVT	532	1303	398	12463	13949	jxiUpeSkKh7h3gZhu8KEcZGLtUy7xHJ6dL2DGDPJtHBLMKHJJah	10904	15347	15347	1618701660000
21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	21777	3NLt5ShMLh6HE4JmDBem3DShXEwisFG2tE4gP5DR7ukwqD7vRwN4	1590	1054	398	12463	13951	jxE1xxE3mZVsRWP1NTtUcGYZHw2MamAQW7jeGXGoFGWpA3cU62Y	10905	15348	15348	1618701840000
21791	3NKdi2Bf4C18Bq54uVzZFVGfV2zTuJtujv39HUtGkHjgE4WCDZvR	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1406	1393	399	12463	13961	jxZ5ggHWEAi674d1aZvEiCS1Te2p19qrbR5pmjzkMYv2MwkF9xx	10910	15355	15355	1618703100000
21793	3NKHfF6Z48b3jeZRENMLy5FRV2qXGyNiySiSMJcivaD9W4LEBshz	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1623	839	399	12463	13963	jy2TSiUzpDtcM35Y9ijd1dKKwFh7HoMBdgyH63DWfXysjEbhoUW	10910	15355	15355	1618703100000
21799	3NKtJQzZFe83Nbini3eor4h6J6WSVinSDRpSs5tqbNMayL6g132Q	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	311	1307	399	12463	13969	jwYdVBFNTYvJbaA2NyYKxCEzeCD8cJX58npVykv3PYQvVaGwZ4q	10912	15359	15359	1618703820000
21803	3NLZzcvDJtvnQhjY97uMffY9wKvk18bB6J6JhJmGBwV1jUfGtat4	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1403	824	399	12463	13973	jx2EshKQD9hogVZmCFeDmszTTbfMSdirjd1KYJcNZshi1coJTWi	10914	15362	15362	1618704360000
21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	21807	3NKPcBZJVyPs9kfq9PV2G39sSGuVremZpNtaVJg5DBLzXApksch5	632	1382	399	12463	13979	jwgNKV5AcpAbTGAwptioA6BCMy5KP9z9cLRAMd6MBcvbrHvH41B	10916	15365	15365	1618704900000
21811	3NKQwA8dvbFVuFGNYrG5ynuzkUfYehJF9fco5YFRdxzUg2mYsBte	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	497	657	399	12463	13981	jwABkrCZqNZv8wxGEhTxMQJ5AVq1Gim4AZsd8YN8j7dTckSe7f6	10917	15366	15366	1618705083816
21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	1593	1100	399	12463	13983	jxPh8eUN67ERjFCsyoq7HedsCpy2XNrpK72AedV1yAwbUQHE3FA	10918	15368	15368	1618705440000
21816	3NLtJ16ZdWaTpwihGbytwjp5fYpXW4kAvU9BtjgmjTjm72fxRcL3	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1406	1393	399	12463	13985	jwa7L9rEXdpiEZP8h32nqpqCamYaVVyDLGDUHFqAYPjsZewmknu	10919	15370	15370	1618705800000
21819	3NKn6Xao6vMkQk6exNzgec9eRoNLRdBDRKYTiCEaWcCcs1n1NNGu	21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	1405	851	399	12463	13988	jwUcyykTSxBefYdJEwPpfHkVb5EdLWCZJQC11qLipoKbTDJAXbr	10921	15374	15374	1618706520000
21822	3NL3vRyez7RZoSGuT8BMmh1E6erK4ETvG76GZsPLTQC7e1FmdK14	21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	369	946	399	12463	13991	jwEVz9aRYAyV3V7RUBXod6nEiKXFMBjhFnAaJxDHgmrLPXXGCmT	10922	15378	15378	1618707240000
21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1529	1070	400	12463	13994	jwvcgg1WH91v7mtpmo7cGHMryWkJoZYASHPDuVtSedCTaWro5zC	10924	15382	15382	1618707960000
21830	3NKeqVGiNrBHuZoSpi9DbdmAyb8kUAohGRc6TbWa6nCbE9X4J4cd	21821	3NKmgPjM8sg3sdUqKQEKmgndEd7ciQZrrq2uVsbfcrF8wfZSTRVE	1581	778	388	12463	13998	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10711	15385	15385	1618708500000
21833	3NLnMSP52roRt6rDYcaYsU8Ndbe954xm2uF9bp3i6CjL8rbWujoM	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	1407	1395	400	12463	14001	jwBsfBBeHmrSus3vNsdbn5cM2Dtuj2ZfF1wFHFnQY7pnV3EHrNS	10927	15388	15388	1618709040000
21835	3NKK7GMttSVrmfN1CLWPqPde2STSEEuRWWWCfVB77cV5jX1C2LYv	21833	3NLnMSP52roRt6rDYcaYsU8Ndbe954xm2uF9bp3i6CjL8rbWujoM	1483	390	400	12463	14003	jxVfCGDsVy3qtr5KJzUQJLpD1Derfw6QZ9qXgPxQ9rzyz1Y2ywg	10928	15390	15390	1618709400000
21841	3NKgrWy4v7xoYDW2jfgNc5Rg6PHxGLnqDyq7WFqeuRX399gmhfwS	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1448	449	400	12463	14009	jx9K8z8hQFpXZqUUi6ECE8h28woBTcBucJAdapT3nk213a3rrTF	10931	15393	15393	1618709940000
21845	3NL94fWjHC7vQAeDcfZ2qUyX2HeZpjQFyZr7DvBPKiNb1MRme2vW	21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	1555	1101	400	12463	14012	jwcvwPxtB4yKBUKnm8B93dzDQuSUZAHaZMdpFk2teHhUiwJsons	10933	15396	15396	1618710480000
21847	3NLH13CbfPsn4DnLhGGNZPEPzyWFHLvUJ5VZNYiLhZrN3uQFsGLU	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1403	824	400	12463	14014	jwXhTriZzen77CH4TdUbwS4QRfLb78m6MiVmNXh5X1LxDBu5XsP	10934	15399	15399	1618711020000
21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1631	794	400	12463	14016	jwWz7GvFRKDq6vtXRgBwrN8C7KiVfjCNqb3v4Dj1z1UUEixZnjs	10934	15399	15399	1618711020000
21861	3NL5M8kDbWN1NQ4LK6hwovcvujt6KyqXyc5KikX1goGfBXbTeYqi	21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	633	1384	400	12463	14027	jxV3w39FcuwbQ1bJZUsjccWC5n1Dt7VqY8Pgvwexag2nUhkodGj	10940	15407	15407	1618712460000
21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	21760	3NLVpJvSj7RA9t1ymeYkLoq5GvaqvR4ZxUtqkNvwbAuBwDwbcbXe	1637	816	398	12463	13935	jx9UyaMoHUh26zUiPumvM5dperijEbbwHG81cEWNLib7iLEz9Rx	10897	15336	15336	1618699680000
21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1634	313	398	12463	13940	jwufCkQG3owQyL1BG7EPknsTgwXVMfqo9dEnPyBWNWiKXXx2TGn	10899	15339	15339	1618700220000
21770	3NKRe7BTmM5kgXUemj8Zn2KCfYFeTdzgsqGnjJtqgdhHpbi7QTXP	21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	1559	1107	398	12463	13942	jxQbZyq18pN22yGsK9mrUwDxRLoQ5HxW7HhCtjE3Gdd2BE8P2kk	10900	15340	15340	1618700400000
21773	3NKbwwg7fYpNXxiAPqDjRZpHZJrtNmgDQ2cjgcpinfMPkZiZQfsi	21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	1419	814	398	12463	13945	jwbxdFniCHSpVsNvZsXomHoRVxGKgP83LCexiJ6JbFcwZtHC2YA	10901	15341	15341	1618700580000
21782	3NLvewNBQvrzQN3eBLv189cdf9D8L9Sk6Pzvp3MNVfBrVNHSsb11	21778	3NKn9v7DhYecREDN1DUyhrP2YcvQsUVQPmugHCj9uCKaPsN5FyRJ	1402	808	396	12463	13954	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10820	15349	15349	1618702020000
21784	3NLxRcVx9xZu1ZTaQz5cmbJPtWW2jHGvSVRhwB9wKsEe4KSDu8Kq	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	171	1374	398	12463	13956	jxk8ezsXjudZ9t1it7FSDLRy5526989pSRDbxaLZKTA43eG34sg	10906	15349	15349	1618702020000
21785	3NKCkZ9xR81pzGFYma2U5tU84jsFjGumWXTtxm57poQwFnBPP9P5	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	448	1179	398	12463	13955	jxTyd6of67Ybd9FwKsxk6ZR7oqAyKLDcukz6KCDfc3wkAQxVeS2	10906	15349	15349	1618702025436
21788	3NLj4A3QRi4VtcX1Sw6nVrkuH4M2BXVjh6bPUXV2PQUVVtbhkRuv	21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	1613	1349	399	12463	13958	jxwdAT6NyoE9ctm6N1rJCu8ZGnKMUtCjQnSZDW8m8TVj7RZU277	10908	15351	15351	1618702380000
21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	641	970	399	12463	13960	jwBpdLea4g3ELCMVVGE43v11FY7AMMTbPnmbfsZUvKtDJh89KFm	10909	15354	15354	1618702920000
21795	3NKjG5tURZnzmj8pV5jx4T1UggRk7pzSoxGBQ8CKiHXm5nMkVui7	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	152	1330	395	12463	13965	jxn6M2UTfcb19eqytpftFdS5zpBp4fawZ2Zvb9qfaxbjW74aknj	10839	15358	15358	1618703640000
21798	3NL2bc8hk1jRxSAwqF91yKPWUjcKrW6GFrAX19v19cV9P2nkt3hw	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	1407	1395	399	12463	13968	jxfM7cV1xXo6o2iV4DBUjCAUZfceZtEvvQRaDGhjJa8ZDJpzfwW	10912	15359	15359	1618703820000
21802	3NLrX8w7RFXmqexd7y1Ejt4RNV3rS3fECn8DWBJXE14ZgLCg2S4c	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1407	1395	399	12463	13972	jx6KZFXHXBsnBYbgcJJDf1TQQe6J38uN17gLBREvbXsc3ja2U38	10914	15362	15362	1618704360000
21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1560	1291	399	12463	13975	jwtjPzBmGHM1yQjKm7PMaVmXuhWCkZ91NRmcwgZ8GuHk2g3uwEG	10914	15362	15362	1618704360000
21813	3NK7QATzMsLE4AvkGX11BHktrfppynfQjTZ9Dmwxi2wcsHjiZWob	21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	1407	1395	399	12463	13982	jwCK14F6zkX8sfN4JQVj33XcGVoyqSueo9miAfhUinKdvnyob3u	10918	15368	15368	1618705440000
21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	21816	3NLtJ16ZdWaTpwihGbytwjp5fYpXW4kAvU9BtjgmjTjm72fxRcL3	1609	1333	399	12463	13987	jy2VkUrVCEkKtiaw397zqb25JJBEYmr4EFmsjfWCJoCJjt4Tewb	10920	15372	15372	1618706160000
21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	21822	3NL3vRyez7RZoSGuT8BMmh1E6erK4ETvG76GZsPLTQC7e1FmdK14	1503	1277	399	12463	13993	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q	10923	15380	15380	1618707600000
21832	3NLDy43oe5zwoHJVpUR9X5cGvDA3emh8zwoPnbaH455RcuERwxUW	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	596	940	400	12463	14000	jy1g11eMEr118zocTWBbNYJUVCMm39siViHH1baM5a5rkdCdH6n	10927	15388	15388	1618709040000
21834	3NKxJi4ecbDtFjU53JiSqx2v7hKHvuBtfQGc6D2YgrsdsiDWxdTa	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	1553	776	400	12463	14002	jxZbdzactMKywjRWnFGLHq8sAPshd6E6UNQGopSj8xKntHSBUv1	10927	15388	15388	1618709040000
21837	3NKhwTWSS5TFARFmntMK27r7HuUbFWP5jVi3LozyBAiHjWMEtfNt	21835	3NKK7GMttSVrmfN1CLWPqPde2STSEEuRWWWCfVB77cV5jX1C2LYv	1476	1245	400	12463	14005	jwBGdKy98w8wubfPNLG2Zo4DRnE7qEDhADJrAb852VXQMqhDYsK	10929	15391	15391	1618709580000
21840	3NLEGaehaEEEcUeYCZgyCXwpKZHfPTM7oL2cyJscZg9hNbKsUX2W	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1637	815	400	12463	14008	jw8GkaNrU7enpGvHUrDkz9mS2FgefGJYbXmY8Hnk8gB68YJJasq	10931	15393	15393	1618709940000
21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	1419	814	400	12463	14011	jwxBjhg327gsytSm12MtjyYMMQU5U2MjuG3ttn5AGBvfZZ4W2Yw	10933	15396	15396	1618710480000
21846	3NKMC8mVPY3e2RdxRWKGsYX9govqmW43NijPZq7LRBDNEpLPg1iA	21653	3NKgeBUY9SLarVf9vZUwzrdJGwoEvxPV5FbPAP4hvPJyn1DpdsjH	1481	790	388	12463	14013	jwVbBvJiG4smNqxYMNLH5HyP9eb4Vwb44FHkCFiiEpDTTmx7ggE	10675	15396	15396	1618710480000
21851	3NKmVdycXPm99Q5rXd8uinr2LJLnRYcio47yXuxvBXGTt9UW1JpP	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1501	148	400	12463	14018	jwBCUKq2C9WVQna8FXZomFb78CmFmxBFzE3AoNTgkzGpvCibbuE	10935	15400	15400	1618711200000
21854	3NLDEWmfYVE8bL4c89UnukWpZrqZUTdLmcKYPPigTRp8Hp9FaJow	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1668	1004	400	12463	14021	jwQUH1oCm4nwTkm9qVoLpPvwYgRjr1Vxc5capL6idZMkHnpKJ7z	10937	15404	15404	1618711920000
21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	21859	3NLvUsEcyBYmiRZsJNhoF99RDGt8urmBGBcLkxMn1z37koNeHEaP	1650	1009	400	12463	14026	jxF7sTxEXWdudzoLcSsizTjEN9VPaBXB2Trzv8AK45jRamckdHA	10939	15406	15406	1618712280000
21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	21862	3NKMMu4tMqKRFSFWAGF4pXatfUHCF1SGoRdJ6YpKPViPXEjnx5Up	1483	373	400	12463	14029	jw77oBSMJUJwMkR4qYb17Tv2G7TdpsycZrEFP4qAuqmakUvtabc	10942	15409	15409	1618712820000
21865	3NKsWTGLP8jnXrnaksmcyLyvPEzxcw4nZodbegveAZtEWwV7uuvy	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1477	1350	400	12463	14031	jwLwLjuRNPEude3pVNGrmAEs6bfDuDuKQ4xP4RNpYvaZXuJSHTh	10943	15410	15410	1618713000000
21868	3NLkUa9ir2c5gsRqAA3QvBXDXkwBks7fSQ7cSb1S3N9mxi3ytiTe	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx6Brd5c6wDKVuG7Emrak1na16V3Xb8WzBsK4154URYUXq9aEop	10943	15410	15410	1618713000000
21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	1471	1386	400	12463	14036	jxVYBtxaUyJ89jLPJ5u3iVSeCHAmBDBcgBUJXAa8UBnxoKiyfDL	10945	15412	15412	1618713360000
21875	3NKBg13KTBjdFTbKj697E8hqj91XKUNbYiURKXdTrXRWpgqQiBiM	21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	1577	1327	400	12463	14037	jxzxoaAEWfmyxyasgYbRzR2DEbgSUoBEhbLXGCHRVcxpDEbXyj6	10940	15412	15412	1618713360000
21883	3NLUufKLCV2oLUAd9PNUvKhhEEZG3jt4jCib6gWdsc3Jw77WQuMd	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1407	1395	401	12463	14044	jwznM3jKfrqDLQsSwu22NnZJEeBj6wJjVYaBMtFVZ7UyMeZo3Ma	10950	15419	15419	1618714620000
21885	3NKA58GVcavJR6DkThwuJ1qNUfje9vcKcGTmKDybivusYHnAzrxx	21884	3NKQdYQvuJVqfK98QuDnDNhtifAuf8B148GZBGk9c9bRutzE8fan	1608	1289	401	12463	14046	jwp6zZgS9EMSsvgqd4K8iaPzVWxNCA5BZrf2Y5LYDxybF6ECGHi	10951	15420	15420	1618714800000
21807	3NKPcBZJVyPs9kfq9PV2G39sSGuVremZpNtaVJg5DBLzXApksch5	21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	1623	830	399	12463	13977	jwH4RJdEgBoVLECwSKYmDpwG1dz2CF55i4CBStyREsKnxsh23Ke	10915	15364	15364	1618704720000
21817	3NLZZGudAJAv8dnhPwPSq2VXx87BLgcezK5bTwYhWSkrvGM4k9eh	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1589	1040	399	12463	13986	jxd8GMzh8HK177a2eByPDJgeCBJUtYuUB6UMU8XB3jsAjQst1Sh	10919	15370	15370	1618705800000
21823	3NL4uXEJzZdSByuFEWqwpazjCa4erswTVC2UUhQGgk14WEVHwx6B	21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	1407	1395	399	12463	13992	jwzCwehWLKm31hUNb9u9MQM1kwQM7NSbsVMSnqEe4tMCKvE8SUZ	10922	15378	15378	1618707240000
21826	3NKArhZ6uiAXEkYWRk9tNmt6RmUMCq9RBmEuB4h2Tw2GPhndGZ19	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1541	1298	400	12463	13995	jxeqRv4r6sQvBteJ4rYqXf3hpp1ugp7b9iRpwwZqxdQqJ1noFcD	10924	15382	15382	1618707960000
21828	3NL8x85YyazBiwhE83zBrYNg9FqgReNsZfe8qzL5tP2tvywkpihG	21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	1637	815	400	12463	13996	jximf6KqTyQEBqGrpvGgbQvPHRX4yFLzs3wcCK9pSYgsx22axf5	10925	15384	15384	1618708320000
21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	21829	3NLjS754Kb3M5hjiz1tCoSpjna5muQcY5Tf5xY6Rq6DRM9MijcZc	1474	1203	400	12463	13999	jwDp9Mfahxz9eURcY3AKckRFUoi7jNkqjavcaLm66ajnjnx2oJ7	10926	15387	15387	1618708860000
21836	3NLLYp7he2TiTYUeTRdnKqj6fdbkhiy6EZK4P87BdmwFMMYbo5in	21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	1476	1245	397	12463	14004	jwKw5tjaBYPEXpqvHvhxn3fCCjcQWGGgX8mSLMSUX2jqjSVGz2G	10868	15391	15391	1618709580000
21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	21837	3NKhwTWSS5TFARFmntMK27r7HuUbFWP5jVi3LozyBAiHjWMEtfNt	1594	1200	400	12463	14006	jwdrxrq5NYzgrM22uK74hgS3RC7Yg9csJGfwjsY9HWx4rLuSnvP	10930	15392	15392	1618709760000
21842	3NLR28ooFTceju3PtQVYgZTE5SKNTwKLbo6oBZip8HADxbDHzEis	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1448	449	400	12463	14009	jwX6NTxXECyGJJKyg7rLN7N2BkKtxqgD8cfbS9zo4rSJaJ2soAe	10931	15393	15393	1618709943959
21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	21851	3NKmVdycXPm99Q5rXd8uinr2LJLnRYcio47yXuxvBXGTt9UW1JpP	1578	930	400	12463	14019	jwyiBvrpFHxAhZQf5gLU9KFjigJ7mPEotQwukhFBsrYkmcameCt	10936	15401	15401	1618711380000
21855	3NKUVL5Zx12jANU3CVHhnUM7bcM2C5BSC64jEb7sCLUUS2R6pqov	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1541	1298	400	12463	14022	jwuiSmoLvbPgVCtHbUPc3zybC2RzHHVjNB1nkazo5ypZCjFHbnD	10937	15404	15404	1618711920000
21857	3NLud3PunJtvkUpi298Gq4erGNYEif2czce2vRHSSsx1higfitdR	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	1406	1393	400	12463	14023	jxS7J7urkC3yHa4rBB5TKSSFpzuXDjtC3rziDnyXTVLiXQ5iVPi	10938	15405	15405	1618712100000
21859	3NLvUsEcyBYmiRZsJNhoF99RDGt8urmBGBcLkxMn1z37koNeHEaP	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	1611	1341	400	12463	14025	jwoRFXFtLz1VWL3J9gwRA8u1YQVigzAx1NYKYDC7pSqf8ssVJdU	10938	15405	15405	1618712100000
21864	3NKMzKaRtL4Pdt5Nsa761NK1mAQLonWkjGNJaD31sxxH8tQMRct5	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx8nKWS9riEbter7YrriahMQLcumDXHkEAziR4z9W8n7yvuwV89	10943	15410	15410	1618713000000
21867	3NKaJbairQbngo4j7CBLr1TaG7rvbFcHWHDnSkCjeL7Tr4KwmAiJ	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx6Brd5c6wDKVuG7Emrak1na16V3Xb8WzBsK4154URYUXq9aEop	10943	15410	15410	1618713000000
21871	3NKQZe38RcnYze4BbV2QJ6DDJ5dNPpY5yXEZLYTVSX2BtYiGhQ8Y	21870	3NKFyaLZCaVsLEGfziTw8FBN69vF5Tmanx8UuRpbH1sAD1B5Lbug	1634	313	394	12463	14034	jwgnwXxrrMYgn3L5JLPq9TQrkn9iMqSc42wj8vQwsdQBmuSjb69	10800	15339	15339	1618700220000
21879	3NL1GJszHpjDGf1FGNFUDmKQf5zyz3D29AGq66XEyJ5qkuKVs9Dy	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1541	1298	401	12463	14041	jwvVN1kn7qv1LczjU28d1ByjzS4bqz1NqEWHhZryLbg4MbfC9BM	10948	15416	15416	1618714080000
21890	3NKvibaZJLmxFLXcbVtwBHR7dapDF6emor69C6WzBAbU5fPdEc8e	21881	3NL3pcQnt8Wu87t15eDffTfqbftKxpy7amNny1P9UkbTjSzQWGtj	1581	777	388	12463	14051	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10713	15423	15423	1618715340000
21891	3NLs8EB7bWeMKiPJ9Q84BkNeSc7P7YpUdTrGds421yWNLg2J4aKX	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1671	1365	401	12463	14052	jx17dX7RmyUt73pyjyrTRiqVhurskMKEKSByeTBUE5zbUwkWCiZ	10955	15424	15424	1618715520000
21894	3NK9Jon1cnJAYNwdrG6GFUBFY6HDtnuBUMfnNqMovs3dL5qB8BCD	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1637	816	401	12463	14054	jxM4jvc29u4SkdP3YkX1NvfQQ72WSMUj6bWTonxm6dxfzS4Vx6Y	10955	15424	15424	1618715520000
21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	1457	1391	401	12463	14058	jwFrgskUPV4v5Kei5k1nYR7woSo2M6hQFuDPYQpTGHcvppfcRjW	10958	15428	15428	1618716240000
21912	3NK9eZEM62HH5rMFXQZf2AWFNQ3FWs13GUQXEU9nHtdbKs9BjYVB	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	596	1306	401	12463	14070	jwDbBXFjLpVQYPL3z2pAF6rVv7nAgafbJNZ4i1KH7mRCst9Zh7X	10955	15435	15435	1618717500000
21920	3NKTZrGjrWmZks5XV4th7jhBKS6gNAakxdTNrmijmBwsN1yyivrQ	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	1403	824	402	12463	14077	jxqbBkvHGenQoTbDrPpFhENQe23qb4vZuGcxLXbLZ9WJZgWBxQN	10969	15442	15442	1618718760000
21922	3NKvs2Hy5NGFpjKK9d15mY6sM3bvANMeuLzcyEAjiLtkeczxG2pK	21815	3NLuHQo2rzAZRBZbJAtZuB9BZ7JaZRRffKX2hYJWPtJnBmFPRqdP	1402	852	396	12463	14078	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10822	15443	15443	1618718940000
21926	3NLTLzCEZarcfBcbRb9yjyjjg1wkiK8YDp22hRGNXGZf31EHcbMr	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1447	1099	402	12463	14082	jxfbau4F7QpNvxkm2uLPx64TAn1X86VwnSP2PoxpqBax1j62TKu	10972	15451	15451	1618720380000
21930	3NLV1nVJ2CKLPRUmmEnj1B5xSYpcT5UgrDJVnSWnSctSqGiHPViK	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1651	1055	402	12463	14084	jwVuuEWvwWRSgoYxZVDQXBgcbFinXyMcFFskCgq49f35phxp1Ap	10972	15451	15451	1618720380000
21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1637	816	402	12463	14087	jxG29TYaYbswRzUAfv1GJCS9MBrHJdtuHi4TwHGbt7UscDDi7Hj	10974	15454	15454	1618720920000
21935	3NLfjteRX3qTL6CtXYMj2KjyJ7y5D5FRGBkCopQngwsjHPcpAj7R	21922	3NKvs2Hy5NGFpjKK9d15mY6sM3bvANMeuLzcyEAjiLtkeczxG2pK	1402	882	396	12463	14089	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10823	15455	15455	1618721100000
21938	3NKZwxG2dmbHdbMMjrvtEcDR1R7V3iaVbw14XWoCSwExDsLL5iQM	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1448	1311	402	12463	14090	jxq6NPcrFfA6U3uzuH6LBZSR6p3t4hD37UdeE2LpsnGDMtznzpf	10975	15455	15455	1618721100000
21939	3NKL5Fc1fY2bXz126NgmD8gdUwjoPUJnscQT4PaetYnFHCTe21dq	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1651	1175	402	12463	14092	jxn3t894Z6wejzc6fvGR3bLwR9uYRjUpgzsp2YDccs1o7TuDmxG	10975	15455	15455	1618721100000
21941	3NL1rpB1pTo1rcQCdLjoFah9HwFB7xATRTnjDiB2NbatB7wp6Ew4	21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	1407	1395	402	12463	14093	jwZXeXsStD5iW3THjAD4WYWnUm9Huc7BcexhYsm8t7XzxsXKVVx	10976	15456	15456	1618721280000
21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	21943	3NLdgNmKJveEUecip41RG1Wxh3NsGLRcoc9jYkBhFRCaoiNtipg9	1631	794	402	12463	14096	jwxf3ouezzWHsFuy9JFxwDzwXoTGi532Z6Umzqgrojb1mCMG2cg	10978	15459	15459	1618721820000
21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	497	657	399	12463	13981	jwABkrCZqNZv8wxGEhTxMQJ5AVq1Gim4AZsd8YN8j7dTckSe7f6	10917	15366	15366	1618705080000
21815	3NLuHQo2rzAZRBZbJAtZuB9BZ7JaZRRffKX2hYJWPtJnBmFPRqdP	21782	3NLvewNBQvrzQN3eBLv189cdf9D8L9Sk6Pzvp3MNVfBrVNHSsb11	1402	868	396	12463	13984	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10821	15369	15369	1618705620000
21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	1652	1189	399	12463	13989	jwneQM1yYmRjgu56vAmW8vEzmZdns188E3r5qES26jQp4LXujym	10921	15374	15374	1618706520000
21821	3NKmgPjM8sg3sdUqKQEKmgndEd7ciQZrrq2uVsbfcrF8wfZSTRVE	21800	3NKEeosCX84ZsK6bBJTGhb2pkXgbdXJmt427VS513vKkYYeDnmum	1581	778	388	12463	13990	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10710	15377	15377	1618707060000
21827	3NLMTy1ZayKQchizLTdvZy7XjJdULvT47MtNu8CGFUayBFgzyHdy	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1541	1298	400	12463	13995	jwij566i4T5F2mifAxToiC4S3eXx95X2NjQdo6fQPwKARCiGYmZ	10924	15382	15382	1618707960000
21829	3NLjS754Kb3M5hjiz1tCoSpjna5muQcY5Tf5xY6Rq6DRM9MijcZc	21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	1509	1320	400	12463	13997	jy2ZndWhHYppPCKtXqF88XxdmsSCWfGo2teWqhXrZQQ1prjJ3fU	10925	15384	15384	1618708320000
21839	3NLZzxoN4DDfEzb28Rw2r65fRfLk8aHB7H16ioBu6P8NA1zYwAYn	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1407	1395	400	12463	14007	jwdgG6WDfSApzSVemS6Gyiatc2oTWAUhx7s1PoRypyQXEcT9dfz	10931	15393	15393	1618709940000
21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	21840	3NLEGaehaEEEcUeYCZgyCXwpKZHfPTM7oL2cyJscZg9hNbKsUX2W	1508	1141	400	12463	14010	jxiFjxUgmfu6sCktsYHZpmY8Az3i1jg7QpHntUDWgBKuWSZHFt7	10932	15394	15394	1618710120000
21848	3NKdCyTqw214AeKypi2f4QcRXAxh2E3b68BPvtGzpFSD73akbHXK	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1447	1345	400	12463	14015	jwokSYnygt9RVy626zXaNQzEAMpg4BmJKmVoD6EcQNPCNRxg8n3	10934	15399	15399	1618711020000
21850	3NLUHjbX4Bs4R7XfCwXcp5hjtWAHwsT12WokCYKJ1RHVKGQXaNvG	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1578	930	400	12463	14017	jxdsN5dEjxsiYtRYTtEE8wuiE6Had1Knm9M12VjG2NDsiyqQ4u5	10935	15400	15400	1618711200000
21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1406	1393	400	12463	14020	jwsBRnBCBwQxtFzaTve5CCmqM5Dt2JrGz8r3MDdU6xxPsVi9vQ4	10937	15404	15404	1618711920000
21856	3NKX8Ncgqb9pR3m7sBvWaXFSshGsMo6ZRvDbJg3ro15LLJqyy64R	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1541	1298	400	12463	14022	jxwtCQpVKabfcFTuPKHLhKiUtcNAFxuXWnY8ojpgFgn3rqcAXCS	10937	15404	15404	1618711920000
21858	3NLdivPKsD8BsKePszYJPN62A7Lpze9cFWH8WbAmr1kkU6CZ7gLB	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	171	1374	400	12463	14024	jwniZYMz5W2RarJ72F3ZZFfWsX9opJgoHiJvP82pQgQoUX44huZ	10938	15405	15405	1618712100000
21862	3NKMMu4tMqKRFSFWAGF4pXatfUHCF1SGoRdJ6YpKPViPXEjnx5Up	21861	3NL5M8kDbWN1NQ4LK6hwovcvujt6KyqXyc5KikX1goGfBXbTeYqi	1675	1096	400	12463	14028	jxAbcbgttAg4Gt2W1B5H3vkhn7rtoDfQ9HmBGpW6itrGcfS1WS4	10941	15408	15408	1618712640000
21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	21866	3NKcX8yb8au3MmvC3QjczmcwHyhYSe32YgBtpxYmmrWKPkSin1gs	1634	965	400	12463	14032	jwXYewRpjfh1oQJxCvwEFyNAaessWzvxVo2636KuDvAYoHCPGS9	10944	15411	15411	1618713180000
21872	3NL6v43YrYUNiNkRwZB7Qwc3rzyndcEWWQJeCHTUxhbksMdSpLjg	21871	3NKQZe38RcnYze4BbV2QJ6DDJ5dNPpY5yXEZLYTVSX2BtYiGhQ8Y	1634	965	394	12463	14035	jxj7ZePMbs57PgYWV7e729ByNERaQzvtAdLjKX18pY29wt1vr9n	10801	15411	15411	1618713180000
21877	3NLoyCrR2JPa28Zxh8DCE8Xn2sapaqNyApUPEZzrGiCSJyhAy7Dd	21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	1666	85	401	12463	14039	jwwo3NTeia8f8PGbBZABuEGdZXpEdnTFRNpyKyEbCT9stSWXVDt	10946	15413	15413	1618713540000
21880	3NKQmPkj7DZuAoRZK7Kgw1LntupMJ81aKgwYvhpU8Jo54QTqfaJu	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1541	1298	401	12463	14041	jw9TPZPAYLaEGYMezBhkSXgURtDwGWbcnki3nyjVbayBKQdg4N8	10948	15416	15416	1618714080000
21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	21879	3NL1GJszHpjDGf1FGNFUDmKQf5zyz3D29AGq66XEyJ5qkuKVs9Dy	1549	1362	401	12463	14043	jwGhwquudKAqjepEWRPie6tZLwp59Aa6Koz6922X259SytSd6W4	10949	15418	15418	1618714440000
21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	21886	3NKi57a9Ms6MEa2qfC4pKXJEGbTP75Cm466JSNeVy7UGFT3BRWEm	1573	1318	401	12463	14048	jxqXHJMBeyGALSSz7QG8vAGqr5zVpyJKGXKHwgMNx1p3z9z72uR	10953	15422	15422	1618715160000
21892	3NLcmBAETzdcfLgPhpMiu58CCAPjUihFkv4ajVaiLRb2kVaDbrZq	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1671	1365	401	12463	14052	jw7R27Ek6s8ZA8974Gky5bNxm8cQULrMjc7nRU7ZyQUrQDaT3Eh	10955	15424	15424	1618715520000
21896	3NK4cYrLR5GLwthRk1v7c7QnYfHzcnwipP3Txtse3UoAxQZo5eZd	21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	1406	1393	401	12463	14056	jwxJ9N2KLknRZc8A8f3eBBGN6i43yRmmiVPLDnsizVVgSRhv7yT	10957	15426	15426	1618715880000
21901	3NKcfRgyzufpgc7zYPj81otrD4WK8yWsySi58evbX3MPn3KdQjwp	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1419	814	401	12463	14061	jxS4Hm4NFy1Eu26HXtPndAZpBL4ap1LNRAWX4JWEurbTBDw45qv	10959	15429	15429	1618716420000
21903	3NKkSEuAH382FGerPYMBQ22nMmUWupFKykwgrdoqdNyJnzASS3js	21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	1649	1383	401	12463	14063	jxNcA8PLvEEpCfrbuLLWTjvFLnfsqEK3BZQqcQSThEvtFwVVMRL	10960	15430	15430	1618716603445
21905	3NLLUpLdaHd4r92KNswm2MuV5QLznQzcAKsCq1oqwKJMXqQhSouo	21792	3NKiG9ftRZZrRPmVhAGqQKE7YrTxkMdfpsM1E9dcrw9kyU13bszG	1617	1288	398	12463	14064	jwgKPu49TTh3wcnsPUce3SzTiN5jeRu5Vyi5igHkDuc4Ymbb998	10896	15430	15430	1618716600000
21908	3NLgyS7AavDti7WxoHCcnGhWeDrjwn2nU5pv6Vtrm8tB9ng9iwwi	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	1541	1052	401	12463	14067	jxGXcUXPN8vktY9zyRaDGDnNaPLxHyi5oPkLirEf7QBeSKNMFZN	10962	15433	15433	1618717140000
21910	3NLGm4hmYudCjRnL7FjeA9kWsZr6ZS4XWQcrM2ZU5tf5zEcVzbL3	21907	3NKhJRC3SGmYnYnPn8o8XbeR9BLTHv3mRPrkwieELJMG7Y6FJWJ7	1631	794	401	12463	14068	jw99uMSGWP3Vgiys6P8u7cD6yKLKBHYjsMZNZRUo1mpTPRM5UHK	10963	15434	15434	1618717320000
21915	3NLXSTSacvBrKyqqHFiVYzeYYPvPMjKnDSHG3RSB18gkSvjs9bPi	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1458	1077	401	12463	14073	jwNiiJXNVB4iqHv5nVE6EhNehwksyWece5ghV3N2uZQQ51E2XoY	10967	15438	15438	1618718040000
21917	3NKMXdmc8dE2SuLSu3a4Xg7p6tcGBWceEm2HqVThTLcyMR6zNejQ	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1553	776	401	12463	14074	jwUaeSEDHuPkJAME6KwzMhD4k1n1GmwGKSEW1RaFX4EsBs3eME6	10967	15438	15438	1618718040000
21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	21923	3NK7WXWx5YSHUB2dUQk3SLTmAuUH1t4mTR1eeGtcTeP9TouHFaem	576	1229	402	12463	14080	jxW1VF6cBqQvjnSFr616ibpysmUY5kJKMfuiK7Qyg7KWXf2LdNx	10971	15450	15450	1618720200000
21927	3NK9U5BGvVxJzTgew1M6SZ6d99B39awBoudktzPvqS9ov8oP4UZd	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1445	1290	402	12463	14083	jxcfdo11WmFziXtaFH9nY6rj7xfpo2TzRUrqoEucLz4HzuCJ2YZ	10972	15451	15451	1618720380000
21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	21927	3NK9U5BGvVxJzTgew1M6SZ6d99B39awBoudktzPvqS9ov8oP4UZd	1501	1360	402	12463	14085	jxpVUCLWYSZaHbgBoUoNHWAG7nQHvkz9APcr5AGfWVThi1FMty9	10973	15453	15453	1618720740000
21866	3NKcX8yb8au3MmvC3QjczmcwHyhYSe32YgBtpxYmmrWKPkSin1gs	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1477	1350	400	12463	14031	jx2PvWKv2wXqgSxTcyB1HkoDPWguUVZcNGBFE5Siga3p9S3Fp1A	10943	15410	15410	1618713000000
21870	3NKFyaLZCaVsLEGfziTw8FBN69vF5Tmanx8UuRpbH1sAD1B5Lbug	21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	1634	1331	393	12463	14033	jwTw2ZYRHey53iER61f6QreYQJc2EFYDcJsT3Uhx2HK8sDrsHV5	10799	15291	15291	1618691580000
21874	3NLH4d7jrU7Te8zUdPVs8J12vxCJQA24SJZc88KwAZa1cVDA1it5	21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	1471	1386	401	12463	14036	jxVYBtxaUyJ89jLPJ5u3iVSeCHAmBDBcgBUJXAa8UBnxoKiyfDL	10945	15412	15412	1618713360000
21876	3NKLWfmA4jQ8WUoepNNrdy3fqc7arerRg15XZqFHhc1XmUJ4fipv	21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	1406	1393	401	12463	14038	jy1bNRSZApooDLn96CrCvNi7Cu5EAmjVqV4d2X6sp9kqJs8K8vZ	10946	15413	15413	1618713540000
21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	21876	3NKLWfmA4jQ8WUoepNNrdy3fqc7arerRg15XZqFHhc1XmUJ4fipv	1407	1395	401	12463	14040	jxDTGhcu16HdpjEEfAF1gigv8fAMiqPpmLZuCx35hxjev1hy7wq	10947	15414	15414	1618713720000
21881	3NL3pcQnt8Wu87t15eDffTfqbftKxpy7amNny1P9UkbTjSzQWGtj	21830	3NKeqVGiNrBHuZoSpi9DbdmAyb8kUAohGRc6TbWa6nCbE9X4J4cd	1581	778	388	12463	14042	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10712	15417	15417	1618714260000
21884	3NKQdYQvuJVqfK98QuDnDNhtifAuf8B148GZBGk9c9bRutzE8fan	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1637	816	401	12463	14045	jwFicnRkLy1x7TXfkMyHMGZmNtrbUt5oE5ig4PJqw6PR9rrzGct	10950	15419	15419	1618714620000
21886	3NKi57a9Ms6MEa2qfC4pKXJEGbTP75Cm466JSNeVy7UGFT3BRWEm	21885	3NKA58GVcavJR6DkThwuJ1qNUfje9vcKcGTmKDybivusYHnAzrxx	563	1233	401	12463	14047	jwHbz4rAipcbtNumcTbdr9mBA6cH3utDjcoaDe9yrCM4J61pNcT	10952	15421	15421	1618714980000
21889	3NKWkeEqVbmTsErZriVfk4bo7Ku8LH2DoTnAQkUdCjmMwL2Q7xwD	21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	1571	1335	401	12463	14050	jxw2q6K89sEZFiqexSCHz6XM19LkQfyuGQQaSH1FhNFV3Vf1LzF	10954	15423	15423	1618715340000
21893	3NL2T31shpcWYt2nn1DKTXiFp8eS6qKrshryK4Zz2GsYNxkH2Dzn	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1406	1393	401	12463	14053	jwHMhG9p9vwjBjTtKTJbLKQY3sdbWL8Upna7Vodhmuj9Y3STnJ7	10955	15424	15424	1618715520000
21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	21891	3NLs8EB7bWeMKiPJ9Q84BkNeSc7P7YpUdTrGds421yWNLg2J4aKX	1423	343	401	12463	14055	jwsRqHRCh9W1BCbTp1eKP8yzRrZPfzXV1JU45uivw5QWBUrb9ch	10956	15425	15425	1618715700000
21900	3NLdHN9LAD8xB9qVyzkvBDNPWSqD5x6wWA5QWsTFTcKLXxSdpMJM	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1403	824	401	12463	14060	jw8L7GwyBm2erHavfPjhBPWoeP2HLXWybV5pg44JhT6zhTYjx9W	10959	15429	15429	1618716420000
21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1585	1120	401	12463	14062	jwo8RaQ56TUB79U1KzY1vQUJECVmX6yGG3gRckk3thUyqL78Pam	10959	15429	15429	1618716420000
21907	3NKhJRC3SGmYnYnPn8o8XbeR9BLTHv3mRPrkwieELJMG7Y6FJWJ7	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	633	1018	401	12463	14066	jwLde4ikiGRmeamw5n43wmihRvmPH4KjQ7y82TCB4h35M5Ezw16	10962	15433	15433	1618717140000
21909	3NLTwjsVrqE91biGA95qmpr4rLpSXuojESexVU2NzhGBEoSeb4eG	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	1541	1052	401	12463	14067	jxcUd6bjDyzducsokhUGiejjoJgbZBZ1Vc7Fs8Ximeo9TCTBbzP	10962	15433	15433	1618717140000
21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	21913	3NLLNdGLXUMh1ZAH6r4nN5zWiLetUCaCykiBkrhCJzDHBnLbfXsz	1553	776	401	12463	14072	jxK6SKPeFCJ21g6BFHcuEK3eWzXYCQsxBrD4UrFnTyBb7Ex5119	10966	15437	15437	1618717860000
21916	3NKykqAQKT4yvwzpnzSFBgE5uHsy3mdyjY62w84ZZoQezk5DxWwk	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1458	1077	401	12463	14073	jwNiiJXNVB4iqHv5nVE6EhNehwksyWece5ghV3N2uZQQ51E2XoY	10967	15438	15438	1618718040000
21919	3NLTtuYWzLjrRuMkjjzY2QXN1LJ5sbuZqBRyEVv2yNh6CeqogFA9	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	311	1181	402	12463	14076	jxESW1zroonSYLW6avDsmUDLWpDJSA9i4qzDDAceMjqeVS8ksGw	10969	15442	15442	1618718760000
21923	3NK7WXWx5YSHUB2dUQk3SLTmAuUH1t4mTR1eeGtcTeP9TouHFaem	21920	3NKTZrGjrWmZks5XV4th7jhBKS6gNAakxdTNrmijmBwsN1yyivrQ	1579	1143	402	12463	14079	jxQRuLdEQRFR16zQRhjLnajbP1JEGzPvvw11AvzkWBXvU4bAV9K	10970	15449	15449	1618720020000
21929	3NKyLkzb2DTA6GtBcZNpC5UQRox6jLWRqnqq63P2MCvrrwvqYK4u	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1445	1290	402	12463	14083	jwyGTuqNfPcUitkh8ZpQcTQYyH5498ckfGVqtKddF8fKfWU5wGT	10972	15451	15451	1618720380000
21932	3NLfb9Jh2vqUJ7MTixG9AjJMumhE7zQTcjf3iUBaE22TAitAYZ61	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1406	1393	402	12463	14086	jwdY5jGJMZ6Qk3tRdW3iD8qdbcS79UY7Y2W6BH6J3URZ9B2rq91	10974	15454	15454	1618720920000
21937	3NLQcfAo1Nu2iVMkRVjsyY9uX1HFnUc1fk3QzchGnsHofGwgGdPD	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1421	136	402	12463	14091	jx25qcS8cW4EDvfzptPhf4jbbfqVjcykrDwbsqzj9BFz26Yvebg	10975	15455	15455	1618721100000
21943	3NLdgNmKJveEUecip41RG1Wxh3NsGLRcoc9jYkBhFRCaoiNtipg9	21941	3NL1rpB1pTo1rcQCdLjoFah9HwFB7xATRTnjDiB2NbatB7wp6Ew4	1637	816	402	12463	14095	jxaxCirCEyrEpprycFJoZM59wLVTMy3m6RvUe1PR2AEcigJTtne	10977	15458	15458	1618721640000
21946	3NLJ3PhMeoJ3x76F2Jp6kgDC8Kg6CMA5vL2Zg1hgXMCN58EbVjMC	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1500	931	402	12463	14098	jxsznNff4K8NH2m7875bNYaxgYejCLXDYAfDytdx1VatGUK9K1t	10979	15460	15460	1618722000000
21948	3NLGrH71xG5UMfnbfBm6cFZPuVCVEQtMdbSbBbeGURren6HaHYzb	21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	1579	291	402	12463	14100	jwFY3gwg9NBygGi7DX6VVvfb1TiEb9iWjZcQVReaXTGgzwnkBgc	10980	15461	15461	1618722180000
21952	3NLLxdqFYe6m24RLyJHvUcKJuzsttDuhHYzppy9CB4QA43LUy2gw	21950	3NLHNvQ2T251nbwWEWz4rpr2oRKDs4o1Bb4TBP52N6qScZuzHhyP	1403	824	402	12463	14103	jwpdrZYycCACAr2R7unuhXbGXim4CvUkk2dUkUPu2Tbo11zYCVi	10982	15466	15466	1618723080000
21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1403	812	403	12463	14110	jwvNWZPr4JRqY21df5YX5zP29VAG8qX66UZQ6QanEP6DdMsgYwA	10986	15472	15472	1618724160000
21963	3NKWxdDuxBrRkjj3nmGoYSCaQEG1Rngd44DsHjLKcVNB87j7xrvr	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1610	1314	403	12463	14113	jxKejHsc7W7zAuJidRLk8JxDKZBF9txBJaetiiRvKiinw2FkuBf	10987	15473	15473	1618724340000
21967	3NKMndxDe9ySV6zrcEKzVQBU45a9pDfYpPsGhhsiUn5Zce8hCfuY	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	532	1303	399	12463	14117	jxQRb4XSxYvwsJnPPFja3PqeUdnHRYo3NjtoryjQhEHN91XyMFr	10912	15473	15473	1618724340000
21977	3NLY891i5HZkrUZYjBJx6noi1XEiUd2Qb1QnaZRxwk4Mjzhn29ZX	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1405	851	403	12463	14125	jxq755HCk9VQtgrMj1dUtnxHxtU4Rj4P6RGrQA6jkSjtodYzdzn	10989	15476	15476	1618724880000
21982	3NKWBVi6EW5TdKQM1GEbv9JZPf3sTV18dSBCqpScTLQ8i63sFmpq	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1541	1172	403	12463	14128	jwchTprZDfaDwGqiqHy4YXgjwLPigvM7XXdNi1jWBGTs9kJZraD	10989	15476	15476	1618724880000
21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	21983	3NLqj2j5mJtEYxZXuASCn98kx6TFDvghMed8oQ9ja3WCmtsN4DMR	1613	1103	403	12463	14131	jx6kMW3W6Nc7pi6fvcEVV3wCupLBE4dmzwo4Ytf5bV4MzVNuSq3	10991	15479	15479	1618725420000
21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	1407	1395	401	12463	14049	jwwV21sQnqzY8QqQUF3vAge7mQAWq4NyUPiyPhymwgT3Y1zTG63	10954	15423	15423	1618715340000
21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	1637	816	401	12463	14057	jwjaHYzydTVBbVr4v5KQVFkQ4FrJTeDi8GVnyGAGPP1CsirmBQe	10957	15426	15426	1618715880000
21899	3NLF7k5i6zPbTqRd2fJiGh2MeEuBxX2M8TwrnVRrcNKooZCa9QM9	21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	1648	1284	401	12463	14059	jwwYFkz9T3t5t7prwU1N5zviZYXJt7tSGMigwGrnUdbymY2MeZx	10958	15428	15428	1618716240000
21904	3NLsWWMeKGTF62EqCjGRRHQc9NmvzdTwStYgkLKQDD7q29s4gArn	21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	1649	1383	401	12463	14063	jxNcA8PLvEEpCfrbuLLWTjvFLnfsqEK3BZQqcQSThEvtFwVVMRL	10960	15430	15430	1618716600000
21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	21903	3NKkSEuAH382FGerPYMBQ22nMmUWupFKykwgrdoqdNyJnzASS3js	1483	217	401	12463	14065	jwephPu5bNF3Auvv5qrjSNm55uEz2qncFaY1ErHTadUcvk3n42g	10961	15431	15431	1618716780000
21911	3NKLsPGE6mMj29u4zYygNZQvsP7hTaUVqupZRAdAEUcVxXVbLP4A	21910	3NLGm4hmYudCjRnL7FjeA9kWsZr6ZS4XWQcrM2ZU5tf5zEcVzbL3	596	1306	401	12463	14069	jwnXDhcNCmDQJAWRr48KX4S4myQQVy1H4oG3r36pQbvDPJba9mJ	10964	15435	15435	1618717500000
21913	3NLLNdGLXUMh1ZAH6r4nN5zWiLetUCaCykiBkrhCJzDHBnLbfXsz	21911	3NKLsPGE6mMj29u4zYygNZQvsP7hTaUVqupZRAdAEUcVxXVbLP4A	1460	664	401	12463	14071	jy2UAoFr4VndAByw2AkiejCsLxobVrmEDjNqhbZz2Y552t8mrnE	10965	15436	15436	1618717680000
21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	21915	3NLXSTSacvBrKyqqHFiVYzeYYPvPMjKnDSHG3RSB18gkSvjs9bPi	1587	1357	402	12463	14075	jwibH2N5AT1Y8ZKnRFKH88hxigQmZ3b77gPjm8tfFz7n6TJ7djm	10968	15440	15440	1618718400000
21921	3NLXsG6chCvohguQynzndpdgZYj8KfLqijHJsyskobmFQ99vLKzd	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	311	1181	402	12463	14076	jxu41GLYMYzpYUBg4QCfAHRx5XTj7hcPJajDv36HP4KzfLZ78Jo	10969	15442	15442	1618718760000
21925	3NLd6Hfm3JKQ7ApQVBTURnjnDFCarbCmCgaqkHFxGaXAsKU4PCVz	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1406	1393	402	12463	14081	jxNyMHqqZMmt4Exwqf4JiKb1u1ggwyMKrnYEMoVi7X8T35TiCA4	10972	15451	15451	1618720380000
21928	3NKyuZ2mvmyYkCnZKNmQLrieAT7azgv8kFrVm15YFzRUuGe76XkN	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1651	1055	402	12463	14084	jx6HEMGgQQiyYeJxzddDCYAehj3jZUB6XdaJiH7ncyczTKwXzSv	10972	15451	15451	1618720380000
21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1407	1395	402	12463	14097	jwDGFnVnx1gHDZif63FD9zZdAeT3PPuAGsmYRhWd44wsAMQ3W5P	10979	15460	15460	1618722000000
21950	3NLHNvQ2T251nbwWEWz4rpr2oRKDs4o1Bb4TBP52N6qScZuzHhyP	21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	1406	1393	402	12463	14101	jxd1eAiGh4oQvbSoqwRqgt1cMCoCaTUXheZ4FpdfXxydWSkMDCi	10981	15464	15464	1618722720000
21953	3NLWBrMXzt9SQx4hjSxZeJ8gKVbmgZ1sLPaWnqtsLporqRj5Qgoj	21952	3NLLxdqFYe6m24RLyJHvUcKJuzsttDuhHYzppy9CB4QA43LUy2gw	1406	1393	402	12463	14104	jwsXKr1MqTNsA1rhJCPeFtdYoX87GUbMA3teKqufrnSj6uYjUvY	10983	15468	15468	1618723440000
21956	3NKrqF7kpwSqyX2i7MZdTpV8o1ssvUcWrfLnnoy7Sh3sZ1vfWDUN	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1483	1276	403	12463	14107	jxZGJCyTan1fL8weDC3NcPxCbKYVoSnhUffN8tSL6q2irRaMWuv	10985	15471	15471	1618723980000
21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1631	794	403	12463	14108	jxoZ5TkWNvgxNwp2EJKf1vcHpKdMUt449Bpa2o9LdLhSSYKr6Ge	10985	15471	15471	1618723980000
21964	3NLJME9rMVyAKkSS2WiqvYqMnae99ycrpAgsrtPUKdQ252ACbkNg	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1403	782	403	12463	14114	jxkmmx4KxFEPyfUEhBExDm37o7mJMKab35LQA2LBJbmQEDUkenr	10987	15473	15473	1618724340000
21965	3NKMk2c1cTetZhj3hzaMnSUc7uiMmUcPLPj5XWjhk8c6jLpB3EPq	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1445	1290	403	12463	14115	jwDA8SwhRky54JBMMnZSvqqpFQC31c8zxg24brsmnsSmkWqKysX	10987	15473	15473	1618724340000
21968	3NK7f6Q7vA1idFB1DC9QsiuHuboUGASoCJkTUqUsKEiWUMM9S7bM	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1445	1290	403	12463	14118	jxSosoHDTfNM79fAUmy6daBzoA3wCTCUEjDmhRj8fYTaqRzRXWb	10986	15473	15473	1618724340000
21969	3NLRtqzPhMedcqYh7TKx8fejeRHKGiupryCmLMo956t7Enh6yUYp	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	484	484	388	12463	14119	jxgRNTSjdyRb5qHaddR9MyzoZTjKMCtB5Pw1us8buRP5jAaoM7c	10699	15474	15474	1618724556675
21971	3NKPgc5J7TyjbWS2SaPiGL2LuT5NNGht5kk4EeBx9v49sKCDsm8p	21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	484	484	390	12463	14121	jwNMvWvGtnYvKQZSxwhgURZVu15trLMmC2vKDf7L2uKb5o3epaX	10726	15474	15474	1618724629754
21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	21964	3NLJME9rMVyAKkSS2WiqvYqMnae99ycrpAgsrtPUKdQ252ACbkNg	298	1308	403	12463	14123	jwqTLSMWtWJ358SGNVts8RBycS41ZipGjLgwPLHwwkS81j3U4Vj	10988	15475	15475	1618724700000
21976	3NLv2Lap4SDKdHpUrubhqdj3oC4xkdssestsTcqNyzMzKfcQ4MJ2	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	298	1308	403	12463	14124	jx2MJMtmh5sBkBTUGuFuMhFk89dnBVVQwcuuzgqaP49tFng3PiL	10988	15475	15475	1618724700000
21978	3NL874JVkBKNDDuP13BnGfM8iSShwYeX2feWUAa9YpSdzq8jwzuy	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1522	1076	403	12463	14126	jxqSfHRCYDji7JHL4D7rHqaRLx2QkrmpyMRAD5UnSieiPNZrinV	10989	15476	15476	1618724880000
21987	3NLGoo7PKWyf3dEDve5smZFrFZQJ54TV323kkMqfR7cakfM9TSdq	21986	3NKvYWwAJuLt6mSmRhsKiG4kMFjCzSzCFK5xRNmjPkGhGeTCxuja	1594	1326	403	12463	14134	jxAH9XEzwBc2yM8GaBwnfUrQC2D3SsvX2QK72WaHhYGKzQJwdSJ	10993	15481	15481	1618725780000
21990	3NLMLSFFn9co6EAJoTX6bC3XMoJDVHJzASdEHePf8qc59RG4eKCm	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1654	1340	403	12463	14137	jxKVseZhk6T1CfRRAzbpCivMERbXBA8eahpcpDXDfPMMEM83aF7	10996	15485	15485	1618726500000
21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	1406	1393	403	12463	14144	jy2CoUZznDihVkTgiTu9xauN7nm7nt9pQFF1x2zWVYpQfTNQ8TE	11000	15490	15490	1618727400000
21999	3NKZ1ab5n6vUZEpyEwRErhJYk6hAoSrTAJV3Z1NXMNShj97wCaVV	21905	3NLLUpLdaHd4r92KNswm2MuV5QLznQzcAKsCq1oqwKJMXqQhSouo	1617	1288	399	12463	14146	jwoQxr77PM3TWtzUiPNdcuHCiXLxqmKNSje2SiEUXEiVwgZpQhr	10897	15490	15490	1618727400000
22004	3NLsRrQ7TCmbaEMbgiWZvnndNH2tJTnDQs7TxS1PE6tbzooYUNVk	22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	1553	776	403	12463	14151	jxsiRD1WLvhhofhFi1hRcWWZWefQNcX1zvJJiv5QAfwWnNFdAyp	11003	15493	15493	1618727940000
22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1405	881	403	12463	14156	jxYqAozcawW6PNkbYYnouY1JDxNe6TJSxXyphunpt3fxzzSM8Zp	11006	15497	15497	1618728660000
22011	3NLNwud62oK1pqUpxAbiFRdE6wpKoP6332NGCn61omgbaNR57FPu	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1419	814	403	12463	14157	jxhKNh7sNF13QJair7aGef1TXPn1UHgaLXCrfhXvbZKkgxXuyMw	11006	15497	15497	1618728660000
22018	3NK4VemKYt9Sp1qxvo256PTtKhfPAz2SgdFZHYXBjoBzCaipuYaX	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1448	1311	404	12463	14162	jx5f71V9tkYnyoU6gz1t1EuyV9Vf2e5wyYsccNtQs7ivTQ4gZNK	11009	15500	15500	1618729200000
21934	3NL84ZLLzfN7Kbs1rjQWrQEsiwXNRfRz1qxP6UZFwjQQ4WUvTGvh	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1601	1142	402	12463	14088	jwheNUsjTN4ebheF9BHstbXAaU89et99bY2zqiHvaBAp2fQbVao	10974	15454	15454	1618720920000
21936	3NKxkxzWQBqPmffKXCoebUZi7fBqRc9bENdSYkHZ5Qxz99Z9ro6y	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1448	1311	402	12463	14090	jwcEv2QqDfobVAFi8vZHxP26PYZ9UjxF3w6PCiBm69yr2fgyTCd	10975	15455	15455	1618721100000
21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1651	1175	402	12463	14092	jxQmk3Pue3BncU6HoRg186iGPthFBP7MzV5qgofzJHyUyq6rBPh	10975	15455	15455	1618721100000
21942	3NLpjFw4ws2vC5aJJtuDVDXNP3WVMX5rjY3wNnf7evXMMrHW7nh1	21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	1406	1393	402	12463	14094	jxM3NEGmWYASe7ooGC9gJhHSP4FEPbnws2outwUvFwTRNtQsbRW	10976	15456	15456	1618721280000
21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	1579	291	402	12463	14100	jwyMTHW2b31ikJxbWpfmQmCKaCNxKD2avBGiy4gCebxc26jK7rP	10980	15461	15461	1618722180000
21955	3NKXEnbFa1KhSDSActkBSnETPsRLqENKLnLxFowGy4EZfjaQizqe	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1406	1393	403	12463	14106	jw7nYT5g7V9PncJNfmcXBmCWogRpaX97BDkjoPaBqb3z6eQAKhH	10985	15471	15471	1618723980000
21962	3NKG8XP7jQndVcnw7jMXrGk8xVjZBpzU6iQJP8pE7rT71yJEHeTa	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1405	867	403	12463	14112	jwnJVCVE4t5CVngrco8oWz2bJsoWgqjAPkgx8XefFwX9VyzzfLE	10987	15473	15473	1618724340000
21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	532	1303	403	12463	14116	jxwV9JwkBacG9cxHcjckywAXathoExgLfcyh3v7tevP6EC7Bs2L	10987	15473	15473	1618724340000
21970	3NKXCnx1nh8fqCp9ZdraN5uny3gN49Ya4VuNJwf9nXT3oiCejDeU	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	484	484	389	12463	14120	jwuAArTiMxAyWKAzJhoWn1cpv6ewdrDxJnzRVsHJVc3PuEAaidu	10713	15474	15474	1618724593767
21973	3NKAACUPCYXRu7nTTBAgaNoZD8AfN3otvisJJcj1E5AivtZVFLU7	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jxmBcdp9kcqFzb5QW5YM6XVoQCcZjNfvXJoVdSj2p5E8ZuQSCai	10988	15475	15475	1618724700000
21975	3NLXFJi53icAhggVAsBnihWzDjHywq7DrQbpEWeK9Hf9vZCX98z7	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jxV14SBmUJYe7kbsExgSZ3e3vto8Zj7hvd3o2p3VzQrGfc9cabm	10988	15475	15475	1618724700000
21981	3NKzdxKeGn3Kg2bi6pHF59C5aKP2HrtwvMzFYuo4xT6CydoVubd9	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1522	1076	394	12463	14129	jxgzbhQLmJSwtbTgrxLASARLcAmzLDzKLr7EG91HbYXNCt18pfJ	10813	15476	15476	1618724880000
21983	3NLqj2j5mJtEYxZXuASCn98kx6TFDvghMed8oQ9ja3WCmtsN4DMR	21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	1619	1275	403	12463	14130	jxJQtZYAXPmMpR9UyEXV9JtJtRa4EqeMPCrGe9x1oZs6Nyz4fUR	10990	15478	15478	1618725240000
21988	3NLyJiS1ZHbFQNhkcQZ82QkN6cqdMvb6xb5ukwUaTGFVPvgdV8qY	21987	3NLGoo7PKWyf3dEDve5smZFrFZQJ54TV323kkMqfR7cakfM9TSdq	1403	824	403	12463	14135	jxHJLsgeWxXfWAh3VnXUBd5kkv8SFLQbkVPNSBAy1LiwAwEiLm9	10994	15482	15482	1618725960000
21992	3NLdpbZaGAdkqWg8r9BFkCWTqHbzBzVC6kLAsLK9RzMbTqSkXPjh	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1406	1393	403	12463	14139	jx9MqhhqxQ3uXy3mk8wMWKkjgrCSvZZ4PEDtopx692DeLazktee	10996	15485	15485	1618726500000
21993	3NLG8341JfdDZDbC2GVSsEDoh9BebGCEpnzVzfVmcY2n32m1Lc1N	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1553	776	403	12463	14140	jwJFdFoaYkocLqSgdkQgPrgTVrAPjfHhpYpH6njo7fvigjcRE9V	10996	15485	15485	1618726500000
21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	21995	3NK8DS8HXa4dzT1VRCAku1QFP3dEc51RBWvC3VjEZ83A2nvaciwx	1573	1318	403	12463	14143	jwMHo48LQLAkWfs2HEZ2n6FYZ9bDRFvQ3B3Hd9eKTZNoE1GKXk5	10999	15489	15489	1618727220000
22001	3NLKUYk4fb1WL1vgp6WivLrzMH35YBzmFUHM7ZBKoYGwzFZBie8Z	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1406	1393	403	12463	14148	jwpHnzvPNSj1p9LJY7Sm2CRGZcgfrhgy3GjFyZSs1ckXjPdsZ9B	11001	15491	15491	1618727580000
22012	3NKdcMyTwmi1YxnLZr3TmyEosYK2wya1cx5G93ME9A6SyivnH2Ke	22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	1407	1395	404	12463	14158	jxmThEwU3AN92Hh8vh7aFNs8Ubn2W3vB5TrkpJXkj8huVRnZ1Yc	11007	15498	15498	1618728840000
22015	3NK8ugQCKjWimZuVVnURAyPfQMTei7qC1xYRRT3BB2cpXDky3HsD	22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	1445	1290	404	12463	14160	jx6t5FEi7HXbg9BdMQiGCHzXUZkyhPb6zEijzGpgKhnoeWravKy	11008	15499	15499	1618729020000
22017	3NLM1VUj4MYVEos1v9vD3TSVfKicFBUTfAuXrzvpciWQd1Vq4Roz	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1448	1311	404	12463	14162	jx1P43NSnoPLoNLpPbVkcJUa1q1WFF4fTU5mswuCYnwNgem5d33	11009	15500	15500	1618729200000
22020	3NLRx6xrTB5H81Cw8CQpvAwdA2L1oNFtKSUBj5ogR5QwJJrz4YYf	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1541	1298	404	12463	14164	jx6jjoPapB9Tt6sKB6TfDWAiK5RKGyCFFaU91bhKjW6y5ykySMG	11009	15500	15500	1618729200000
22025	3NKPiupwUE4mNTx1J3Bdafvf6FnXb1YruPgNyMBWvRrBDXFLhuu5	22022	3NKXhVMrHsw4AhLZoxAfb2YstUZgPKJTz9qgdrtTMvsmFBzZByrA	1440	1011	404	12463	14168	jxwNREg6Yf3gV2uvM76hvqgLUVLn6kHpEtjHdkV6XEPHp4VkQhz	11011	15502	15502	1618729560000
22028	3NLFmmmuLuWvGNa7njj1Sb8opwDvxEK7BfnjuQkef4oFbGEaGT2z	22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	1672	1285	404	12463	14171	jxLXSj3qFDd1Sr1rk6rDnGojvdKoA9LKkcUyRzBn4QXLKHnL3Ro	11013	15504	15504	1618729920000
22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	1654	1340	404	12463	14174	jwySwHhxj1NM2oArmqh3fzMsh6S5N2PPTZfhr6s7XMW2DcxEQnY	11015	15508	15508	1618730640000
22033	3NL8a4HJ7tqYgnDR8YNRyzgmzEVhLpiAm166WFkijnU4kh2zBw9x	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1601	1262	404	12463	14176	jwmPfMoK2bBBNkjHwWRcqPqobwJ5CcLF5L48KvgUGCpfdJ5whBn	11016	15509	15509	1618730820000
22035	3NKJ33awbyiKUfPsv3r5bncjGtWdL8UgetsyCoKKoHatCCiTmhoz	22034	3NLUCL8XChdzHygcnbmEAJiJFQp2hFJzfpRrrujn3aDkCNL9wCJy	1670	1282	404	12463	14178	jwcVj8SA9pUaPfFeVkKYFFxYFKxqqRddULWVbuvenaPS9NnNCuY	11017	15510	15510	1618731000000
22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	22039	3NLsnS45rKMQP5xp2uczDYrFWaHSuqyD7hx1oy7xVjXfxQnBJndY	1578	1170	404	12463	14183	jxb8YrUkcsxAXRzaEZN7vQBg5GNECRwtfsYmoexWPYHBzAEJ8AJ	11021	15516	15516	1618732080000
22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1672	1285	404	12463	14189	jxAT515hv6R3sDfQgC7nay7NTnNAVvmvjSBjG69mVvBmHLsSYxP	11025	15523	15523	1618733340000
22051	3NK4ZuAFGZy7AvyL4hu21cwbp7TPF8rQcjiwkGzsbV81j11vHBBB	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	404	12463	14192	jxyXQ5AMAoPT6rhLodAD98Pc1oCXTJggYg86HBWtix8gEpdapj3	11026	15524	15524	1618733520000
22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	405	12463	14192	jwCAc14do5YaQNeCCEZCKEfAYq22mWYkBZaRA4WSL449rGvPQsB	11026	15524	15524	1618733520000
22055	3NLavmfFrhFbFz6mCBvM6VF13gXUdDScMQx1F1PEGdGemriEayaP	22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	1646	1228	405	12463	14196	jx3JequkXA5ngYqHBHCzQJsvXBQCrpy9j9cL4pFNtQbghxJogKq	11028	15526	15526	1618733880000
21947	3NKQ6F7TozR7ewXSvU33AxSSyBEAiDPQe6EBEDyPpB7hNemTNMnS	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1637	816	402	12463	14099	jxJXA13ysugKQGgk9634rkMvMyWbAVPM73jxnhZ3ATJt6NN6jvw	10979	15460	15460	1618722000000
21951	3NKFTUasC2ahtDwXb8xPdLoqn3PTiNYnGYP6qxPBF8iVr3U33Efd	21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	1516	1048	402	12463	14102	jxw8KrDTD5agouSdGqvK2u9FdvEKttA9shX9LqSXGkomxkw7CX4	10981	15464	15464	1618722720000
21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	21953	3NLWBrMXzt9SQx4hjSxZeJ8gKVbmgZ1sLPaWnqtsLporqRj5Qgoj	1588	1392	402	12463	14105	jwbHYwGJnjjW6fws5LUxsc3TbNmXH2156cRzAEgpTaaonQKb4DW	10984	15469	15469	1618723620000
21957	3NKotPcyZVMWLtLuKZVFgp9J6Mz3et1KuyNtjNwsAiPTjqTFNfrw	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1483	1276	403	12463	14107	jxZGJCyTan1fL8weDC3NcPxCbKYVoSnhUffN8tSL6q2irRaMWuv	10985	15471	15471	1618723980000
21959	3NKypBK4o3qThpfS3DF5prpYwbM7VB6xCdyqj5xHRD1oSPkvJHmC	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1590	934	403	12463	14109	jxfuRNyB4kUa2fTrWPm4xWUR9BWkbDV5tVtSRLYAAnDpR2hJd1t	10985	15471	15471	1618723980000
21961	3NKm1mfE9VHCuvBk8dPptfhhiBo5CizGU8CzR8SgQHK4qYiVTAE6	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1631	794	403	12463	14111	jwn2QfcVvdMNQoN4aFM7rAWw6f2bWCuodKxmU6wQDBCroVxR8xe	10986	15472	15472	1618724160000
21972	3NKVXtPscxSFmoK9tYDFKzcwNtBvsuqJdKEv91HGoEjdEeXMumw8	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jwAmhdkCsJMnU3c7te4iNiCKsspg1tBD1LzQokcTho36cazw1zE	10988	15475	15475	1618724700000
21979	3NKSHXY5cHZRovDJmjfXBP21vaqhRQNUaVVtmyCYybnKCRuTzLGm	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1675	1216	403	12463	14127	jwVjCACz9tEMcUYu6b96yCXRCoSCz8qe6amm3zxGgmjCY7MY41F	10989	15476	15476	1618724880000
21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1541	1172	403	12463	14128	jy2fPKzmJhquVsgxMo7x6JMEuH1WHJi22UpETywPo8UwGn2NY2W	10989	15476	15476	1618724880000
21985	3NL9sSbWwXF2ouE5GVQDoi6hZTk4B3zzsFK1fqBMTv3aGuJjAYsE	21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	1422	971	403	12463	14132	jwUTRTZi57uQyCuDmNxnTRLErAcHCQbc7ZVqMUk91Ja7aXZbuts	10992	15480	15480	1618725600000
21991	3NLGCS5Lffhij821qooMfQneaTGHMLLKtUPWsPbe4noFAS74SJp7	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1407	1395	403	12463	14138	jxk7C6LbTgqzU6N3p74LcExziZxUNxpx9MjTHrHBiby1sq1AaaQ	10996	15485	15485	1618726500000
21995	3NK8DS8HXa4dzT1VRCAku1QFP3dEc51RBWvC3VjEZ83A2nvaciwx	21994	3NKTrVuzao3deswkSQPLwe2APbVExoSKvaNawnKizTwhXdExBbpu	298	1182	403	12463	14142	jxV8k8hcMfzvZyPwHVWcS9JvCwE2p9L7ca7SDSfbqu3JpawFrBy	10998	15488	15488	1618727040000
21998	3NLJLttopLjCh9csDjozxQUp36NNiD9nqhHbMyEG7LmQCiPoTMy6	21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	1673	1368	403	12463	14145	jx2KfYpko7WfbfJFeZurtc2wNYcE6zfi5w7v29yAmS7ZtnvzT1s	11000	15490	15490	1618727400000
22000	3NLLnPLXAAciyiAjKN223UjJcjzqUSQTNm8fXxpbvwcxr9h1TUf4	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1457	1265	403	12463	14147	jxeE1vcmRnUK993SHCxoPAmDpZfnj442h89jBLkdgZHajndZBWW	11001	15491	15491	1618727580000
22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	22004	3NLsRrQ7TCmbaEMbgiWZvnndNH2tJTnDQs7TxS1PE6tbzooYUNVk	1529	1070	403	12463	14152	jwbb5majSSQnQuLsPmku7C454BNwMRTQYQhxsBiMHiqMxUULWWX	11004	15495	15495	1618728300000
22007	3NKK56YnnbZaAJprMg6XURR5kCncXr1ida4CgQu3Sfp5SSdhjBsT	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1444	1381	403	12463	14154	jwWX31NAp2oBKVnSKAGWezWRdjM2tZRoe5XX5g83K1Mi6sDy3ps	11005	15496	15496	1618728480000
22010	3NLnWDQbbSzqdbqjrFEbfHq2BNSd7yxMGtfqDFZapw3FoQEJ4DqJ	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1419	814	403	12463	14157	jxAbUxEtUF8ch5guZBZCz5LF6pw4WRjsp9Vcy3W22bVUYhBGWiG	11006	15497	15497	1618728660000
22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	1445	1290	404	12463	14160	jwYDW9Zqwo8TsQUbDy9UPzuo6wFb9gVZasKuQou9DK9fqUuWuY2	11008	15499	15499	1618729020000
22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1406	1393	404	12463	14161	jxbBbjmDFx5rLby7ucCTkiDTLKBpfq6mtULMfyNidyqjvNB88Dv	11009	15500	15500	1618729200000
22019	3NKgGrWEtYaqMeai44nLPSeCes3ooNAZqyjHERj6fSQBMyvPdz8p	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1559	1353	404	12463	14163	jwRJRA2tgomydQ8dkpK5FLa7t4j5JPjTKhdpqNJ67u2Pt1Wsqgu	11009	15500	15500	1618729200000
22023	3NK5S5ufdAQnKsvAuboAHyvHogZXEM8SSg8fku8YLzgLaXT1GCcm	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	1458	1323	404	12463	14166	jweEuBZ1BbsvTvncW5egv8cctXwpQ2cpAiN7g6mqAC9n4TL5bEe	11010	15501	15501	1618729380000
22027	3NLiPGZz7W1ubmMTa6zibegJwYrerNmKBLVSfn7tzUPmisR5TRQN	22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	1407	1395	404	12463	14170	jxziggXCjxb4oSgeyDuXhrcUDcYqoHRzzwiHf3SZfoVnFzBoSYo	11013	15504	15504	1618729920000
22030	3NLGPeD6HgjViB1ScZb5h3N4uipQEXv6JnDuwvq35B6VGNayoR2D	22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	1406	1393	404	12463	14173	jwaPFGdV8QHETAPoWTjbiVfjwz84jWzDVqY2NRdGM3TDd7ESzuA	11015	15508	15508	1618730640000
22036	3NLjYiiSY1vPyTWmxvzUiHW7kcwjozCUEkZ1vTWP21kLVnBaiNGn	21626	3NK59NetmjqQZctL1xRiY1nHwAQ1iXtJfB5YHUi91EBp5jWGGXhU	1670	1282	394	12463	14179	jwM3FeG7NJa4DtCHskoFMFEnhEUux72aAofqMSxWzwiMR9zMXCv	10783	15510	15510	1618731000000
22037	3NLZfjux31VgG5W21CGkzeEuehGBfgBJBpTQccyqzqMH8wzLCSax	22035	3NKJ33awbyiKUfPsv3r5bncjGtWdL8UgetsyCoKKoHatCCiTmhoz	1534	428	404	12463	14180	jxTA9AVAjUQzxxysNKVgipVXozqMmz1JT9kB5JaFy1hKLzEEKT7	11018	15513	15513	1618731540000
22048	3NK5zmWPtoVbxKpKCCeJW4nxmhE8yweD1ucPF2PDoR5Am867a6pY	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1601	1262	404	12463	14191	jwe49gW82EoMR3WTi4bC3fK9Jgr9pVc2e8y66kPZ4zt4d9xUpjk	11025	15523	15523	1618733340000
22050	3NLfcQDxWT9rQBLg32FEXxJD6TUAbtLh4pNwkh8u4HZ1pR1etqkA	21935	3NLfjteRX3qTL6CtXYMj2KjyJ7y5D5FRGBkCopQngwsjHPcpAj7R	1402	868	396	12463	14193	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10824	15524	15524	1618733520000
22054	3NL1TjSAozerckbpoasFqU3TNb9htLXALAjkSQZvwNDTBP5RZzfm	22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	532	937	405	12463	14195	jxwJZBv8nvH9UbtzJuQyBXqtvD9Hi59baCWrDtAdbNAfykYzSs1	11028	15526	15526	1618733880000
22059	3NKTzokvUGaq8JqkwjmDZqp6t3AWL4axN28boTPnev1iiWxWYuk7	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1594	1200	405	12463	14200	jwFQxi2cmG2u3UfysAPQ1Z9HFkwKMU6H5TvViMpn9YnN83wk81d	11030	15528	15528	1618734240000
22064	3NLrqNvLSSJKkidZVjgcfwaKY1MrDSNTjGTpsZgBjqRZ9ZKLVa72	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1637	816	405	12463	14205	jwci1ykwv2rXbNcPdE5vr8FN4adXMfdjVXcHSRh7YYo3zUfCC3R	11032	15532	15532	1618734960000
22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	1587	1111	405	12463	14207	jxnD8uddwtJfqyNUBjfGnpJXXYzpeorC3sUPfCLsCRKNBB43vAu	11034	15534	15534	1618735320000
22069	3NLMXvxm8dNtREax7ULGKEpmvhdyEMe4Zp4oGMTqAiZA5XUh7Bdu	22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	1534	574	405	12463	14209	jwnwVLbndak4Pdd4ismh4LjhFw3obkguUkDG5t35a3WzSFMhgCg	11035	15536	15536	1618735680000
21986	3NKvYWwAJuLt6mSmRhsKiG4kMFjCzSzCFK5xRNmjPkGhGeTCxuja	21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	1623	830	403	12463	14133	jwN4NjxiRh6zijGCkm7G3Sc2vwSM45MyTrBfW7smez35UMNG7VH	10992	15480	15480	1618725600000
21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	21988	3NLyJiS1ZHbFQNhkcQZ82QkN6cqdMvb6xb5ukwUaTGFVPvgdV8qY	369	1066	403	12463	14136	jx2i7U8z3UfjTUjYYUw9TzcwTXTm5DxTswchQ8CQCHFXmLqMeKN	10995	15484	15484	1618726320000
21994	3NKTrVuzao3deswkSQPLwe2APbVExoSKvaNawnKizTwhXdExBbpu	21990	3NLMLSFFn9co6EAJoTX6bC3XMoJDVHJzASdEHePf8qc59RG4eKCm	1406	1393	403	12463	14141	jwbdRVqR3umdNM3wv6Hm37CJvCyaEz79NeqzrB4rMMQd58fZqHp	10997	15487	15487	1618726860000
22002	3NK7RHs9KFaMEwqE6Ra2r2DkXnYL9eW4nG46wnRyFKibrtD7HMsa	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1559	1227	403	12463	14149	jxrJ4vNpEE24Ae6s7gqHe97XiXpAd2TW4m1WvWnyajf8ySftdEp	11001	15491	15491	1618727580000
22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	22000	3NLLnPLXAAciyiAjKN223UjJcjzqUSQTNm8fXxpbvwcxr9h1TUf4	1623	839	403	12463	14150	jxX7HUNKWMbGbsDGbtewS5UrWdcJg1G2Sr6ZrZZnDHASLeJDoWv	11002	15492	15492	1618727760000
22006	3NKTMoUupYfFr9GUPgeT6tq4Qi8nn1bSNxvfZFN1PRDYgMz28LFE	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1403	824	403	12463	14153	jx6VN1RDcmepj3qeb9NyiGdbTRuQyVKUmhFPuZ3gRWfox5hhCxe	11005	15496	15496	1618728480000
22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1555	981	403	12463	14155	jwvqAcKL8xYQBX9JeRnHfR1N61wg9pt8TkB5RkmCNyuLWJhcXuj	11005	15496	15496	1618728480000
22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	1406	1393	404	12463	14159	jx8GSzQVtCN9ruFAfA53QAQSFouYrRD2bZu6sKXMbgrK5VxwFNz	11007	15498	15498	1618728840000
22021	3NKgXi9qfqSyK2xcj7QNNyPtQtzCTAxU4VaiN4DNEtHPTz8mkqsN	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1541	1298	404	12463	14164	jwB9ahGrhCxYDinP8Vevk9DRXRrBYa8Vj53bmu8rV2uezZdyWma	11009	15500	15500	1618729200000
22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	22024	3NLuiTew7c24JS1Grc9Ygh7gssraUyyD7ttGcvhcwbx43kJ4Ekgu	1610	948	404	12463	14169	jxKZJQTVHhYFLjdYhVPeP5m6g9mLvkLFfdD9aQT41bGbHAqtd7A	11012	15503	15503	1618729740000
22038	3NLwJqdgVizc1FCeXsogLqRawbqaf2WK7JUN15bMctX1mE9uM8py	22037	3NLZfjux31VgG5W21CGkzeEuehGBfgBJBpTQccyqzqMH8wzLCSax	1638	630	404	12463	14181	jxEwCYpYAm183D6M5CmF4xmLiwGHwpQW3omyNuNw2YrRfbx6bfn	11019	15514	15514	1618731720000
22041	3NLtRy12dorjVPmBb1HuRQaYJuiyxnKU82EjKMSpy1BLnD5mU6Yo	22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	1611	1341	404	12463	14184	jwibxeip4DbhdE44pfE9yJWAMxbMbSbXtQJ4XSZsXQWBFnzZGZ8	11022	15517	15517	1618732260000
22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	22041	3NLtRy12dorjVPmBb1HuRQaYJuiyxnKU82EjKMSpy1BLnD5mU6Yo	1406	1393	404	12463	14186	jxdCZRedcsXsn6yw7DvDUZrhuh4FafHMNkG3tdAgMdso5Dwc9vK	11023	15518	15518	1618732440000
22044	3NLhRmfGyK54ZFR2xY29BacJmfZCpgynMjj7BPcCMbBoHd61RNtj	22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	700	840	404	12463	14187	jwxcHx3dU7FqMaFrceHodrbz6GhJRkypPr3rY3riLpRpog1z7Sb	11024	15522	15522	1618733160000
22047	3NLp5374KttN1vuRzFiFpwwfnrRQ4r7ZhnSxAnm3whwPHyw4BRbd	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1403	786	404	12463	14190	jwvymqRxAetJe7ycFJt1Aj9XyULPRzPmDYroWhukDNtXiwmwZMF	11025	15523	15523	1618733340000
22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	1623	830	405	12463	14194	jxFeFaXmtCnNKw1jT65uYn7ZUYohjNymepRUk1W4YmFtH3fDiGt	11027	15525	15525	1618733700000
22063	3NL5j4kivr8kz1y1r2YJCNPqUPuQNAnKxpRCmkeonAjgTUsDSa2H	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1403	823	405	12463	14204	jwvjnKVHxqqSUSVRnd7SNWDvufTnc1P4PAcogqkiqziLitPBVja	11032	15532	15532	1618734960000
22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	22063	3NL5j4kivr8kz1y1r2YJCNPqUPuQNAnKxpRCmkeonAjgTUsDSa2H	1405	867	405	12463	14206	jxmT698UH8iJesiaJ3g63SVCePw6HQDeXMXE2ToPJCJYQeZ7mt3	11033	15533	15533	1618735140000
22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	22068	3NKtRNZcUuN4zqJ3nAAZJWnqXpgUnVTxj3FyEu8cLXjRBCeRhET6	43	1184	405	12463	14210	jwvsL5xMNuF6eHzopbri6PFocrnQR64CuZLbZUr5PPN9fTMDNQB	11036	15537	15537	1618735860000
22072	3NLqHczR4pzZX5uKEDC4SsFt7nsvJzvnUYWZdxR868FkQewBEJUp	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1406	1393	405	12463	14212	jwmm7qjkT2mP4vT5vMzVQYzTQo4AtykzA4yY7LPszQJsdL9Dzqg	11037	15538	15538	1618736040000
22075	3NKTzQRNbEDcxKVYuGDQTL6hSzNDFNrv5mQLnNH3JQvoJ56Lmwwn	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jw8yZ7CYYQ5aTsnTdzihUUS8xCg3ZRxmC6u1EdSvBuCquzQW4hK	11037	15538	15538	1618736040000
22079	3NKBH6Ah9QAewDvoFb7ikwa5VrtCpgZ6jgbFvEnixCvaFbXBTd3B	22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	1646	1354	405	12463	14216	jxsv5HDmpgSxRpfsAFXWSUMXPNPpYUibGJBfwiDWt9sKycUP8qS	11039	15541	15541	1618736580000
22084	3NKvi1MKb6NBBunXvWrLNwwySQ183FMpcMED3J7LABGLDjUvcT9j	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1613	1349	405	12463	14220	jwUeGr57DEw5TZWdWCJ8Zf5aEuAfsJh87P9ZYxuS38pdH2XWdVQ	11042	15545	15545	1618737300000
22086	3NLB1xogpehJie1MpjBngYtRsZo3t5QA89Ubw2BfQA98xSpu7Dm5	22082	3NLj69q9bnxe8Mr56kg8ehWfqNqkmfT48hQKSfx3v17KXd9DWb6V	1553	776	405	12463	14222	jxRr8j9HGui9RqyG3ZmM7mnPxtR82rCdZ6ne2Lknue2frC9Ph9c	11028	15545	15545	1618737300000
22088	3NLYzd6rZnkmoEbxuPMhS51jnVgfNtvfmZDMmLSsHD1uzU9pvhVq	22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	1406	1393	405	12463	14224	jwkSJF1BdgsxfTDqMdPNzWEtR6AoTejs9itz43evTNBX7nVeX2w	11043	15546	15546	1618737480000
22096	3NKniRuUb2hdwXcxT7vU8JkUwTr3XYtp3UmYaffnUGJofepqgku8	22095	3NLQJMPJYbbrxD8Tu7vJE6zKybaJTZCiXdLGus21ddKVeW34RvWY	1542	1058	406	12463	14232	jwD4bKPZERjddzZJ6rPwbCDm7eaw7htm9SWYJuDhAj3zAmt3zrn	11048	15554	15554	1618738920000
22101	3NKYTJbV93hutDMn5pLzCc28HwcdZi6PNvvddaZZM7ixeqDU3e69	22099	3NLdHHLYugudL5GrtP7fr6djecvYSNmtB9D7UsZeYG37mVcSuKXG	1546	973	406	12463	14237	jxS67ga1PJFnMWgiJdAnwF1VjDRrWAv1pt2mHzvEUXbAX7ZQU3C	11051	15558	15558	1618739640000
22105	3NKvS1udRHrXXDgYoaDai24VBQ5rTLCgY1BU7SV5nhn7qXF9DJ91	22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	1403	824	406	12463	14241	jwL1NP7NV1FMRDBhm8FngFN5srgYBYxRSN3HunqqnAqb6Y6rp1U	11055	15565	15565	1618740900000
22112	3NKrf5ddtKjruWFW9sQWna9gg9acdWfN1AR3pqx3SFozkFFN4LDf	22086	3NLB1xogpehJie1MpjBngYtRsZo3t5QA89Ubw2BfQA98xSpu7Dm5	1553	776	405	12463	14248	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11029	15569	15569	1618741620000
22114	3NKJ8V2H67zySHYoRDreW53GNNGLor7aBzEBM4iYBPDNHhLEmwsJ	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	1542	1304	406	12463	14249	jwB34riFoCvdaKi4DFcnR1VoCWEesqFqFS74HMRpjPkKXXQdweq	11059	15570	15570	1618741800000
22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	22116	3NL4UHWapG4Byi9QYskeXLHhQQdUn1XAybDXbR1vqDeaf3tdm53Q	1474	1329	406	12463	14252	jw7jf8ojv5v8WDhRCKyN84jLHgWCKhLVtNzgRbx9CwBVHx5YTj9	11061	15574	15574	1618742520000
22120	3NLjdxf3CcYeCP5aB2X2wLgPMbF6vzk5EKxNhaSPhmzgXRa6knw6	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000
22022	3NKXhVMrHsw4AhLZoxAfb2YstUZgPKJTz9qgdrtTMvsmFBzZByrA	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	1407	1395	404	12463	14165	jxgTKxc5ySa7j7zW8kSRdeCYWU8GUnUkbsKmDYPGDmioEZgYNCQ	11010	15501	15501	1618729380000
22024	3NLuiTew7c24JS1Grc9Ygh7gssraUyyD7ttGcvhcwbx43kJ4Ekgu	22023	3NK5S5ufdAQnKsvAuboAHyvHogZXEM8SSg8fku8YLzgLaXT1GCcm	1440	1011	404	12463	14167	jwq1GeziftPPDmTUS92xawTgbCSXZryzF3DuiMPj3sg9pgWKM4A	11011	15502	15502	1618729560000
22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	22027	3NLiPGZz7W1ubmMTa6zibegJwYrerNmKBLVSfn7tzUPmisR5TRQN	484	1193	404	12463	14172	jwkasyyFHrXcKT8DWHjng3VuMhMPLyF8FnNMPg3SzVsd6oX68AW	11014	15505	15505	1618730100000
22032	3NLgrtyngw6yJa5NFwr2UhNtbTcikpciSjTjRoGTxfDFYw4f4h15	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1406	1393	404	12463	14175	jwPAiGSXjV8ZhpSmwhLs5Z6FtwHAyw9bL3H4BFNZHVR3K2YJhuC	11016	15509	15509	1618730820000
22034	3NLUCL8XChdzHygcnbmEAJiJFQp2hFJzfpRrrujn3aDkCNL9wCJy	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1631	794	404	12463	14177	jxLzUHLLx5NZGZi3wCSY6efiwtjrNWWvSX5xecsAzcLGCmV1pni	11016	15509	15509	1618730820000
22039	3NLsnS45rKMQP5xp2uczDYrFWaHSuqyD7hx1oy7xVjXfxQnBJndY	22038	3NLwJqdgVizc1FCeXsogLqRawbqaf2WK7JUN15bMctX1mE9uM8py	1406	1393	404	12463	14182	jxbaPLxtZknUCwCMUdVXxydPamwcs1CCb7HGPvcWZA6QahXV6LT	11020	15515	15515	1618731900000
22042	3NKmSboToWQU76FKzJXfC1XuA4myCEq3g5zHWkAV9XYV64D2wiFS	22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	1553	775	404	12463	14185	jxtCDKTRHHjhE1zXur6fCHzaGUPZcVb2yMrLfZatHF9HtQ14Moe	11022	15517	15517	1618732260000
22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	1581	778	404	12463	14188	jxnSTueZkGLpi37DDrfc26A7jpJU1NCRk8i4Mg7Cftm964tYuLC	11024	15522	15522	1618733160000
22049	3NLHafsP9ay8AsH2ftvxfvGRQa1jeqBjdttiHXP3dGDjvCvoUsbn	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	405	12463	14192	jwCAc14do5YaQNeCCEZCKEfAYq22mWYkBZaRA4WSL449rGvPQsB	11026	15524	15524	1618733520000
22056	3NLvwYmHC7gBZ6JKDv9tng1DP49HsAqYK5LnQrnHfvqKYjncK2V9	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	532	937	404	12463	14197	jwCPXkoTDdn5s5gRPsXVmo5NkgriGHNSTi2sz2Wr52iMzUMSR6g	11010	15526	15526	1618733880000
22058	3NKt7NXFYHVb4xRKpyxPAesBFyVcfqBiURiVkBf7obEmQey4nLpj	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1407	1395	405	12463	14199	jwV5Ccz8HznU3RWMDh1L3JSFVihKt3zhUd5QFpku5WNsdPGNNhJ	11030	15528	15528	1618734240000
22060	3NLjGuXb9WVc9MuMLXZtN7Byb4hLgzJW9H3rYXqLoyC4F6MKEsZL	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1550	434	405	12463	14201	jwRLX95vJD9ByHNMU3z1728SCvVr7JSrSW7AkumL18FSy9qkiX9	11030	15528	15528	1618734240000
22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	22059	3NKTzokvUGaq8JqkwjmDZqp6t3AWL4axN28boTPnev1iiWxWYuk7	1656	1343	405	12463	14202	jwnMcVaFMBfYMBM2VWGKJLWP2gjq1GjnRcqyL4AjNT2QNWXHzmv	11031	15531	15531	1618734780000
22068	3NKtRNZcUuN4zqJ3nAAZJWnqXpgUnVTxj3FyEu8cLXjRBCeRhET6	22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	1405	867	405	12463	14208	jwpHa4tLqtrjBtmdLhn6sDXMSJrAcF6nH9T1zyFB7S9H5HA88ik	11035	15536	15536	1618735680000
22076	3NKMNmDmuZx7EHNxWvAy2UAH7UtAyLDXekVMnkciCLMcWETQZnR4	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1673	1002	405	12463	14214	jweAaXU8nEy4sLtbfJwYoXXB22BXRAu8sJKxTfSsxCC7nh1PNaL	11037	15538	15538	1618736040000
22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	22076	3NKMNmDmuZx7EHNxWvAy2UAH7UtAyLDXekVMnkciCLMcWETQZnR4	1637	816	405	12463	14215	jx5a37e3cZ7PQ29WvA3eHXzUjnQ552pSDrbHMB9k1iF6FD4xEus	11038	15540	15540	1618736400000
22082	3NLj69q9bnxe8Mr56kg8ehWfqNqkmfT48hQKSfx3v17KXd9DWb6V	22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	1553	776	405	12463	14219	jxfNeMNvfjepzGQkeryBaSW1ShQV9pfYc4o4gDqLtNVfFD2ckiE	11027	15544	15544	1618737120000
22091	3NLrUsPYDrKDtqQs3V5pdSMwSymbwuao79gB9FjcurJzgrLhmpam	22088	3NLYzd6rZnkmoEbxuPMhS51jnVgfNtvfmZDMmLSsHD1uzU9pvhVq	1555	1101	405	12463	14227	jxBvocTYJ3aaVWhPs2zRF8sbhQyUWxvrGuXLQiixC5PJfHaDhyM	11044	15547	15547	1618737660000
22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	22091	3NLrUsPYDrKDtqQs3V5pdSMwSymbwuao79gB9FjcurJzgrLhmpam	1579	1389	405	12463	14228	jwqG48GCiapdXxDuttDnvo6SHAEMF5qmV71GTJ2vZYV3CsKrzUd	11045	15551	15551	1618738380000
22094	3NLC3NL2wn8ZE7oT3hgYDL7yT2ypWANsWNhHndGAAKandP7XxZZh	22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	1637	816	406	12463	14230	jx5cJWn27YrUdQFdQpSY1Pu1g2JR1efpi2YrkWjVcrTg8AauZRd	11046	15552	15552	1618738560000
22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	22096	3NKniRuUb2hdwXcxT7vU8JkUwTr3XYtp3UmYaffnUGJofepqgku8	1458	1323	406	12463	14233	jwEP637chjTe5Scfo9uSHkswj9YjvRyjBQ3D6NY64jVvKpVdUVs	11049	15555	15555	1618739100000
22100	3NKLZBysr1RAcDvrkEKYFHCrqGeJQTVR1BuMYbFMJcJ1w4Tm1GFZ	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	676	676	406	12463	14236	jwPSZeadaMLnyhQo5sovL3xJTt1ywtqPdhGmoqeLPbQ8kK8exkB	11050	15557	15557	1618739460000
22102	3NKmHQp6fGQD1vRCSMBWi8PfuDgd5h4SdYNseS5ky4KNaHdEFYHM	22101	3NKYTJbV93hutDMn5pLzCc28HwcdZi6PNvvddaZZM7ixeqDU3e69	1637	816	406	12463	14238	jxCX2cAEup8NDKvGz2PPp73d1Xr6S187k2EfDrL1FjaAaL5HEVb	11052	15559	15559	1618739820000
22108	3NKVN1jSK1KErZbb2uhd12nopmmBi6uBjABnwrSQVCoBo9L9DnTE	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1407	1395	406	12463	14244	jwA6363gEsYRSiR1YaKLSxtSAjUyaKh7ZWH8EgAABevZxrpJRV7	11057	15568	15568	1618741440000
22110	3NLM8QpEt9sw762omGZFFox5SeM5RDag7hLWnwqt8HrB39AQ8yz3	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1549	1362	406	12463	14246	jxvhEKmGEUGuozy5Ru5RtJUYszmhpz4rBvGpY1HohV5s2NYnRPN	11057	15568	15568	1618741440000
22118	3NKtpku1dkamJfwVg3Cn2Aumx4GSo4P48x87v7TpnVXaMffhs1hC	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000
22123	3NKcr3jEvQ1GHdRYBo8mMsjKbUvsjqiPJ8WwNYae32MF5vqK2deo	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1407	1395	407	12463	14256	jxok2to5GwYcbuN3m2KHcEALDLe1MTgtg6t789qCNn9o55sVUso	11065	15579	15579	1618743420000
22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1559	1353	407	12463	14264	jwdVaAwQaRvoU1fNFmwwj9y5Nqr1joeiLsBtrdus1AKjp1Q8mWq	11070	15586	15586	1618744680000
22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	22138	3NLqke11Q51emhSH9Fi1sAu7LARckvQTaofpzYWYZZfz6eEdxeEn	1610	467	407	12463	14270	jwWqoDeoyQ9bXdqAF8PbkXbp3Ci2QvyaHT32uBKPrv6BsQs2RGN	11074	15593	15593	1618745940000
22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1636	140	407	12463	14273	jxSWT3jtDy6eZZvPrRp3wJyYi7K1Drn8e3d8cEXvB2L4hiHaDYA	11075	15594	15594	1618746120000
22145	3NLK329hcgGvaetDjMXgq6BMUMUQcA9Th89E9Cmw8gryuujZ43Zr	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1426	998	407	12463	14276	jxgwguTcwRmPPBwYUd4m6jy7fjBGb3GRoKbEreBMK5y6BfGGBLY	11076	15596	15596	1618746480000
22146	3NLeYuRpoeYuZeXLdwUEDcENxcqKoUymewSLM9Az3rAsPwkw9uKT	22144	3NLazNGdkDiKpGVC8HV35ArDFP3mrk4ScK3KNiY6hxarj3hnFtqi	1406	1393	407	12463	14277	jxMdy65W2c6ZCLhU3PE9yxRvxGahzwLkXatsCdzzyv2iTF2qRRz	11077	15597	15597	1618746660000
22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	22055	3NLavmfFrhFbFz6mCBvM6VF13gXUdDScMQx1F1PEGdGemriEayaP	1631	794	405	12463	14198	jxbpP5n4uXKimam2qfCzZNEPojDXyqyRcU6wgNp8Z7YinDw1Lwa	11029	15527	15527	1618734060000
22062	3NKsgsoVeDcArXPW2ZeTV8QBLBdivSttp5TUz2g69c1wWZ1oS6em	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1407	1395	405	12463	14203	jxfqUHc19gUu6cwfo6zejEUuR4DLmxWL1AXpYtGfDKZrsExVC7g	11032	15532	15532	1618734960000
22067	3NKSvsc2sJAibPWRf85yoRRD9E29ovucKCcHUAuQigDytjYc8jRz	22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	1587	1111	405	12463	14207	jw825u8mMQ6hd3dzAr1WQ5pAYaLjoYYz1jxejcb7WACbT6CV9NX	11034	15534	15534	1618735320000
22074	3NLBba7CXbPXnyYe4q933rnMK1nmTy84gnDAKnkgAQnwiWwhkx4r	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jxT8hNpaoBw1BEzoJgNEm9AZQ9F6rqHf5ga8awzk6g44XQy16XR	11037	15538	15538	1618736040000
22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	22080	3NKyZsfniwPakq8Qh7i9xzoHWMFubyX9W5pZYf1xC7W4b6kAeBe7	1403	31	405	12463	14218	jxu1pdCGZMJYB6YhGjJ51Pq2hutuvLFbNZrtcZvQ5ifoDWK6KrV	11041	15543	15543	1618736940000
22090	3NLL34nBY2vU7ZVUK6GUhcF7CKjRLQ78v742Eoj3RqTggFsGtw7a	22089	3NKqYvfjZBc34r9CiPLEY1kqBQXo5xkVYzxzTGYmyurPxuXhUqLo	1555	1101	405	12463	14226	jwru4ctpg4jVMnM4nz6GzPhe93WL5VzcFt2nRvwRE8Lwo1fyVis	11044	15547	15547	1618737660000
22093	3NLSobSK2E88aU7bqQgLEfPjs7Cjh4NEUGuEvwknhJmcoeiuQigt	22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	1607	982	406	12463	14229	jxpuVpkUaRqKadvE5PbSeqr1VLc6ufvVFaRa6qkykYwqNVMTmtf	11046	15552	15552	1618738560000
22099	3NLdHHLYugudL5GrtP7fr6djecvYSNmtB9D7UsZeYG37mVcSuKXG	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	700	840	406	12463	14235	jxRwG9FMX7kXNTRfiJRxmeawWo2XJ2USA8UxJ2MDcocApz3smCu	11050	15557	15557	1618739460000
22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	22103	3NLst8tdqE3PzZo9VcNo4dpks7yAgnPTv7HDeQ7rcZx1YfMa9w2G	1593	1100	406	12463	14240	jxDud6yEvu9UyNZxSetExvMPLi8zn8YBV9n7yCk6NdoDBEzuaVY	11054	15564	15564	1618740720000
22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	22106	3NL3XsihsNvjzM9Ss1z9CqdUzzJ5tqFf8S7grDGYddHA9BF5pApG	1501	1114	406	12463	14243	jxmgk7ynABDvANd8UfNP8HEn64FjxNTDf6rtuPAxE2FQVNrPeYj	11056	15567	15567	1618741260000
22116	3NL4UHWapG4Byi9QYskeXLHhQQdUn1XAybDXbR1vqDeaf3tdm53Q	22113	3NLnspbBXp1yHvMscQdW4dB9Gxh3TAmpxsBFKsHLSNxPhVVcXuSV	1407	1395	406	12463	14251	jxP5ftxrhuazgmu3xRrJryra6trtxhfAzzxh25hNMD9DoVzCMEU	11060	15571	15571	1618741980000
22119	3NLX6ecQHJVN8GGDyvXYk8t2nZHstUFQ7CwvRZg1Wcp4q5kA1N1u	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000
22125	3NLNeXcNtd37ZjSpTbsYjNoWMSmKAexkAusV8EJTcdio9a4R4uzC	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1457	1145	407	12463	14258	jwZskNQHLX4yn2jmFe3t7KyVkVREwv4V3mMpJCk4367hMHrVE3X	11065	15579	15579	1618743420000
22126	3NL7H3VBfDam2DtcXyMLibfEx1ohyqqBpfSh4d4e7kSU49sE6bPD	22124	3NKmjf72fzaK4v8udBoLPaXfcW7UZvkZ1xYFEETUMCkN9wM36Z2d	1432	109	407	12463	14259	jxyxn5KLkvpBKAH4PPM5Wv85EBreqsXRWNp2hjhQ7qj71D5RE2s	11066	15580	15580	1618743600000
22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	22128	3NLAw17fUmxtPtd5NakrQBWXsmj37QTqzB9HKgE2agv6WFv5t8Nu	1631	794	407	12463	14262	jwqWGiV3vUJcc2pUvat8GjT33DNqRjiZtyASDkrMpKzYAZbnyn8	11069	15584	15584	1618744320000
22132	3NKviuJ2qoSbQh6g7qC9KHEyAZ7wQE6s8zi27BAeXJJ7gEQqbGZ7	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1634	1205	407	12463	14265	jxvMDRpCigKjZmXfGciUzSCm8xUDkW69f4Mk5715BN3kjvnSLp4	11070	15586	15586	1618744680000
22135	3NLFxPaTDGFNSEr7zrs8toLbctfw4PGKkt8JpdDbzfb3rAxsPr61	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jwj3zNBaozC3ocMzDHcRmDZJJn52dKFytv6Cek5XH4WhmCvSS8h	11071	15587	15587	1618744860000
22137	3NKeTFjFJkDpT6obmT1Ff1SKRpRTErqTxwYJ9rr9mzZav6yPgcvy	22134	3NLXot8YVQC967AtxomkmQs45r75whQM3XF5AToxYSBnE4CQrnPW	641	1336	407	12463	14268	jwY5aAzp6xJnZrbJ4XJAV8VR2CWCEDBQ9nVYPWYhxDUwxjFgxBR	11072	15590	15590	1618745400000
22141	3NLhj21sk8UPW2LAa8SCxw7JDUjFnS8tvAEBuuVa2SnbM4Zps9Dn	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1426	998	407	12463	14272	jwyHxFu5oqKQMukeKFEn14Luatw8QDtSF18KxgoewvEah94zbym	11075	15596	15596	1618746480000
22147	3NLLwWNhLVkvcTJ6yhtnoyoSpAzB1nSoavFpjgGPSMPBgvG1AeJP	22146	3NLeYuRpoeYuZeXLdwUEDcENxcqKoUymewSLM9Az3rAsPwkw9uKT	1501	1360	407	12463	14278	jxkt24v8jH56GpH4ACamTkskbxkzYXjJUwjaF1VEj2yNobobs6p	11078	15598	15598	1618746840000
22150	3NKL9RxDdsjKN37rkrp2KWxDCwhy92GNWn6396Y1nCEQouKPCLH2	22149	3NL5Tii8LD277dw1pyNsshyrMkfCGemvdSrHXzoNBnQuUbp3ai5B	1460	1324	407	12463	14281	jwMCZLdoEVEveQrJPPjiMjWJmNqaW92cYBzE2YRg4gQK7XPnfx3	11081	15602	15602	1618747560000
22154	3NLdNysP1Bt3u1mKLC13vLGn7yZgb3N1LYhcRKi7xTeQvTEFhjFX	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1615	459	408	12463	14285	jy1qk37u4gzFSaFrmrSxkQLpUbVnbgpGGVx161BSSMdpgSALxM2	11083	15605	15605	1618748100000
22156	3NLGV5wtFgoituCLJME3KnSrBZbEfmgzVueyTqwoi6LzyESgHFrc	22112	3NKrf5ddtKjruWFW9sQWna9gg9acdWfN1AR3pqx3SFozkFFN4LDf	1553	776	405	12463	14286	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11030	15605	15605	1618748100000
22160	3NLj2oFpZQXRd4H32WUGamk41XBPgfdS5Xk1EKmEoFuxU43uGVAa	22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	1637	816	408	12463	14289	jwh4gLyNuoeQ7TsMYju71pTcWjHVxQr5zQNKd3GytUSADoAvMCq	11085	15607	15607	1618748460000
22162	3NLWC3QXoDGLMf1m8K5Jv54fNT3YL6VUGAFA2u9Seq6Qh2gX3vnc	22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	1637	816	408	12463	14291	jwqjrwkZEkEK5zSHMBhDHrkgz8HtcSwrqgaKhBYLp4EWRyku4bH	11086	15608	15608	1618748640000
22166	3NKhd5yfmAtqQDWB68yU75L9e7Rtio7j6EzM644Fn28eNdQZLQhd	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1405	855	408	12463	14295	jwGgqY9hvq44e5XZXMVU6m65vcaegM55wtizpbyAjydc8esYKzJ	11088	15610	15610	1618749000000
22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	22170	3NKWrJvsQnGem66ZupQPsnjcNk1ZKU5Kif9L5XGLNpySTsSB8Qo2	563	1359	408	12463	14300	jwhxTyXkMW9yAPLyePpyPXP36mnehSXaVnN66vha24QBcZrL4vc	11091	15613	15613	1618749540000
22174	3NLQ8F4zzEpBvWWupF5EyxpY3x9su1bBJrLvcUxYm5XzsNyBuh4c	22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	484	1193	408	12463	14303	jwHoJMMdHydcQ37WAqhnaELCKNgdzAxNB8Jqexjm25AWThkHF4c	11094	15617	15617	1618750260000
22176	3NL9qBu2n9ADyrFXr9qRL9Rro7jDpBVrrszFEo6kaocPnx2f1f6E	22174	3NLQ8F4zzEpBvWWupF5EyxpY3x9su1bBJrLvcUxYm5XzsNyBuh4c	1455	1332	408	12463	14305	jwDKDZzLxeby5fpJounYqePLtqDLmX9HufV4xECiXBi7KRzQgoE	11095	15618	15618	1618750440000
22182	3NKEDgL7BZNw1F38LMRUkeDuQLpzdQRPjDCkVDhhDipME54f2tKU	22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	1403	824	408	12463	14311	jx5Ek5J7yKhSzWZ6ma3i2cT3CC73bHKg7GToBpYaawfXfwiySaB	11100	15626	15626	1618751880000
22187	3NKLYn93sp5K7bnJLaDXtruJHjikem4pou9na9SMuEta4kSELSsF	22186	3NLhE2J5UNbVut6JJphzSweUqi4mMrkUDKSQpHceyUniczB2yvim	1406	1393	409	12463	14316	jwUrJsosdJwXRGuwEeNvenudTLZMxvJU6neNPUJ8vArhfCmonEL	11103	15630	15630	1618752600000
22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	22189	3NLdcZLtt51bJhYYx6XsWqRE5fwWqHKXAXZjBYgFKbGeywaNNmzS	1594	1200	409	12463	14319	jxG9DRaBW3gnMBFdKPmnbYccYFwNwryHvC4BuNvbQcYWRapi42n	11106	15633	15633	1618753140000
22071	3NLYcwBLaPbb19Qz3H5y6z1zH4ePv3GxkTj4VXwneiLpW98uyRzX	21754	3NLAe3eSvtb3rfDEtXUS3Xp6QcRBgYWg4tkPHKpL6cwznfx4WN9r	43	1184	392	12463	14211	jwe8ee21WBLZBgAeDcWupshHmRhY1G9dScY2MFLLHtm4hxnEsae	10767	15537	15537	1618735860000
22073	3NKx1uCBE94e1rwRV4DUkPr6sF8hcH6NhyseGyBMMnxnFbjmpMGA	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jx3bNWjjCpYxi4qxWTwkGm7e3q7yd1nXfnfSvHmNpaDdjntocTJ	11037	15538	15538	1618736040000
22078	3NL1H6BvhCw1W8BCB16kJgSeHajvVNXDy9sSHujxD2AmbeNeggWJ	22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	1646	1354	405	12463	14216	jxxrkzfQRVYsg1SkG5wvwQ7tJqWMTMdQ8ZBfhvuY5Q1q6EMxZgh	11039	15541	15541	1618736580000
22080	3NKyZsfniwPakq8Qh7i9xzoHWMFubyX9W5pZYf1xC7W4b6kAeBe7	22079	3NKBH6Ah9QAewDvoFb7ikwa5VrtCpgZ6jgbFvEnixCvaFbXBTd3B	1407	1395	405	12463	14217	jwKMChZNJRkuRkWew2fmSBnPUgHLc7YXgda93uqyFpCouZpP7zP	11040	15542	15542	1618736760000
22083	3NKZEm6x5Qcs1yHXmZYLiXfJ42nTcS6ujUdZkP1syfdcCBMjzavP	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1613	1349	405	12463	14220	jwgu88ymd574vL9wCXBUQAT2jgriX433v8R4xtPQbbLZG3nLQH7	11042	15545	15545	1618737300000
22085	3NL9FAQLK6eZ1wEjP7yrnk1qVAiNA4VNvmTcxiX6AKuAZfbSyANn	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1518	833	405	12463	14221	jwDj7fSSD2d19APQvFJjuZyuW3GdCzoUQ7cZhXv3yh96SC6aqRo	11042	15545	15545	1618737300000
22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1474	1329	405	12463	14223	jxT8jpAEBumbBJ4iSxEmeRbeRZxQTSXiXANdynV6iebp1ZVKCoA	11042	15545	15545	1618737300000
22089	3NKqYvfjZBc34r9CiPLEY1kqBQXo5xkVYzxzTGYmyurPxuXhUqLo	22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	1631	794	405	12463	14225	jwmoUDL97vTmoWDA7xQK8pAEyGoRTKXnZP2aF55Bh8J5TRR4scf	11043	15546	15546	1618737480000
22095	3NLQJMPJYbbrxD8Tu7vJE6zKybaJTZCiXdLGus21ddKVeW34RvWY	22093	3NLSobSK2E88aU7bqQgLEfPjs7Cjh4NEUGuEvwknhJmcoeiuQigt	1406	1393	406	12463	14231	jx9tNMKTwudgoPgSwMaDz4sP7TKzGnabbC4p1yeJaDD2F5kS6q4	11047	15553	15553	1618738740000
22098	3NKb2aGwWSGKRq8SpG3nFdWvUJJ1V8ovQP4DboDD25XG1v4Mpb1k	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	1610	1314	406	12463	14234	jwv8tpxmUAgswFG4rSZ2wVkfmK5GKkjb1MFteMk9aPgBqMNmd3d	11050	15557	15557	1618739460000
22103	3NLst8tdqE3PzZo9VcNo4dpks7yAgnPTv7HDeQ7rcZx1YfMa9w2G	22102	3NKmHQp6fGQD1vRCSMBWi8PfuDgd5h4SdYNseS5ky4KNaHdEFYHM	1509	954	406	12463	14239	jwMgVCoKQg46zgyjiCN9Q65KgTnoZSxahPdvEMG5fZMHiXKTyxD	11053	15562	15562	1618740360000
22106	3NL3XsihsNvjzM9Ss1z9CqdUzzJ5tqFf8S7grDGYddHA9BF5pApG	22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	1509	1320	406	12463	14242	jwC6aEFRwFbxMEo8LLpkJ9xD3sD6AcDmHv98FuMRn2hiMUEsfnK	11055	15565	15565	1618740900000
22109	3NLMozLAP3cqoqnwxxDRptRSse29k7H3GCnACTzTTJAnaX7DJarf	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1501	1360	406	12463	14245	jwwWfN5M47QdfzXRK5MyNLjrswrvDZvZd6f9bJbPtnxH73ANBuj	11057	15568	15568	1618741440000
22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	22110	3NLM8QpEt9sw762omGZFFox5SeM5RDag7hLWnwqt8HrB39AQ8yz3	1405	867	406	12463	14247	jwWLAJiXYxaVfTaiBNiTvzNQZtyhEoBpnhJMDCSbJhZdAvuvCSP	11058	15569	15569	1618741620000
22113	3NLnspbBXp1yHvMscQdW4dB9Gxh3TAmpxsBFKsHLSNxPhVVcXuSV	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	1542	1304	406	12463	14249	jy38gD7R81YLWgwJkLP5wCUe74EqKQyCz6VmUr5v1ABPgp7DwEA	11059	15570	15570	1618741800000
22115	3NLdpX6BrCgEUgs7M9xvdKbcxXjoSUPfYSKkcqt2AFspVjM9RGXB	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	563	1359	406	12463	14250	jxc7SPM52Sztc51yQYYfs5ddpacM4s7xknvJoV7t2CusVxXPq3R	11059	15570	15570	1618741800000
22121	3NLVzg7FL7uavC9vaqohRkJm4bFcytfemsEZRJAdqZWorpeqXxtJ	22120	3NLjdxf3CcYeCP5aB2X2wLgPMbF6vzk5EKxNhaSPhmzgXRa6knw6	1637	816	407	12463	14254	jx413Gh2EFVnZyCsdcgkGvJHE2gYTEDtQZsYu6ctMvU8UuwZ57N	11063	15577	15577	1618743060000
22124	3NKmjf72fzaK4v8udBoLPaXfcW7UZvkZ1xYFEETUMCkN9wM36Z2d	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1406	1393	407	12463	14257	jxQN2bqpoYEv64Yy94VvVhezhZJtftvPJgdCqsEPBkJXDxX3zWV	11065	15579	15579	1618743420000
22128	3NLAw17fUmxtPtd5NakrQBWXsmj37QTqzB9HKgE2agv6WFv5t8Nu	22127	3NKaeVhfxM7L3xurDmYvHzfas7uHE5WQi2TB9ZnFMk6is7Qr85u2	1587	1357	407	12463	14261	jxRpj3ut3pBFpDtdbLVD8iCsBUDQch5ra7aC14Vj7DhJqm9899G	11068	15582	15582	1618743960000
22133	3NKu2rsZqYK4A921xGAASZjScaoJQSic2zjEhkntH3ZmjyMDjNYn	21872	3NL6v43YrYUNiNkRwZB7Qwc3rzyndcEWWQJeCHTUxhbksMdSpLjg	1634	1205	394	12463	14266	jxyaGoUNjq9jaeDKzT6hfWNnpFzPUUXpMUBW2ezQYKNXkNwyVmv	10802	15586	15586	1618744680000
22134	3NLXot8YVQC967AtxomkmQs45r75whQM3XF5AToxYSBnE4CQrnPW	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jwpG9XXVeqWdm8XsHay2GhjyhypKRS8FrEeLpeXTL1RUgSRatwH	11071	15587	15587	1618744860000
22140	3NLGPyZquCDd5xt8yeLb4GVqbFXDeQTkg8ALYgPAZxUMezrzas1L	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1503	1277	407	12463	14271	jwyQ1wEBaRMN2Xmuy1TE7pTwt4x6WPY3McGN1b4M9D7b7H5DUsb	11075	15596	15596	1618746480000
22143	3NLScdaehFGypNruQgtqbBmRHnVTf8ZdhjCoMWoXn4LhfgKzHqTn	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1407	1395	407	12463	14274	jxXkRTDg55sXwt6zH5doeeSN3ib8LQXwiEvF6Mcw9w6hupnPFGr	11076	15596	15596	1618746480000
22153	3NKuTAkMViyyQkAF2oupr3vzt8vD6mT4cMLYxi1UmejbS6tjJa22	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1555	1221	407	12463	14284	jxpvJJUrr1RxuzTV2cZZFrMLKBK8HbstJgCrL3qvp7TR4QvWHPV	11083	15605	15605	1618748100000
22157	3NLhVMcJPhQ5MxeEmLMD8aQRFHX75Q15vRTZc5tpEZBMoP3ZBQcJ	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1555	1221	408	12463	14284	jxSyEkM4r6jZDK2epB2G9oodbU91LsxaqcJ9y3gK5L3jkGCH5XS	11083	15605	15605	1618748100000
22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	1407	1395	408	12463	14288	jwnR44rNjTwJN6z3fDaDomvDEGppRKSQDtshn9tXfneBRsbkiEN	11085	15607	15607	1618748460000
22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	1405	851	408	12463	14290	jx3QoCCiDPErzWypv3Rhk4HyNXFck7sT64tfBDRsKDDTWx9zdu2	11086	15608	15608	1618748640000
22164	3NL89wQn2aTw5p6sma2KBKMVQwqzqCiL55G5pqwCscZtsL6TFJB6	22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	1649	1137	408	12463	14293	jxUrQdgJua4836GhkAvhi4ihC3CTGYJ7uV28dLxD4uqLkceEKgc	11087	15609	15609	1618748820000
22170	3NKWrJvsQnGem66ZupQPsnjcNk1ZKU5Kif9L5XGLNpySTsSB8Qo2	22169	3NKPuNAVzvd8KutT9Cc4mg4ofEgbZ1LxZJwq3jTqUE92NwGK6TBY	1589	920	408	12463	14299	jwLH4Cx3HSHZtbixgj9WhUAgBapVYhyUALysoQGjdLGhedTM26g	11090	15612	15612	1618749360000
22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	22172	3NL3c5BDaUFwxYSZpHS59fvEVxneRpyLE9CyuqaNmwZRbycHYqiU	1407	1395	408	12463	14302	jxufRrFsxNT27AAapZjLzZUAebPRVmoSyLdN4eeE4Gb9BVvr8P5	11093	15615	15615	1618749900000
22179	3NKVBqMdHeQKFDcc5p12MEj8pUB22Pu2HXVa5ybhCratzpgcP9NX	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1637	816	408	12463	14308	jxvG9Rg7XY3gekxGZ698LrVuvrA6TfvrvpwmsVXDvsgK9ZGkUWZ	11097	15622	15622	1618751160000
22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	22180	3NKNAwMkTjtxWvRViDHzqdf6WrwioosBb4UpJm79jCCZjPAYuTX3	1522	1076	408	12463	14310	jwa3ZJZ4AKAyzbovitmSiKTnavbvERTGF52aceXke5q2pHPEw9u	11099	15624	15624	1618751520000
22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	22121	3NLVzg7FL7uavC9vaqohRkJm4bFcytfemsEZRJAdqZWorpeqXxtJ	1407	1395	407	12463	14255	jx7s4vMgi5zDEFjhGgBMPfycVnFtGc3FmZ4dBPraW5T5oEg2gNn	11064	15578	15578	1618743240000
22127	3NKaeVhfxM7L3xurDmYvHzfas7uHE5WQi2TB9ZnFMk6is7Qr85u2	22126	3NL7H3VBfDam2DtcXyMLibfEx1ohyqqBpfSh4d4e7kSU49sE6bPD	1631	794	407	12463	14260	jxfLEDzQYnUAq3hBAYVgtBvUq3xd6DqE5oB1tpRC7prmkMweL1L	11067	15581	15581	1618743780000
22130	3NKtzVCUofwQQQTNfSfDCpvzcwP6gqH4ZV5aky7fhdZBPxiaBqxd	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1547	1132	407	12463	14263	jxBxkivxZXQVQRJBypS7zs5igKaYUtae3MDkvJjfejQ8dWthEQT	11070	15586	15586	1618744680000
22136	3NLHWKCeage6K3KGvbNLGctDFfXNfouriUbiaGvXfX3tTs3RPtvM	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jxWxDBmVaiUmcsN9xCH1EXuuq4UMmvgy7rwLrQPVZ24rmvBihEM	11071	15587	15587	1618744860000
22138	3NLqke11Q51emhSH9Fi1sAu7LARckvQTaofpzYWYZZfz6eEdxeEn	22137	3NKeTFjFJkDpT6obmT1Ff1SKRpRTErqTxwYJ9rr9mzZav6yPgcvy	1474	1203	407	12463	14269	jwHEywJ2CBdrFjJiDpEspnSmUVB69RGLgMXn45SLvhnm7GLBNww	11073	15592	15592	1618745760000
22144	3NLazNGdkDiKpGVC8HV35ArDFP3mrk4ScK3KNiY6hxarj3hnFtqi	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1503	1277	407	12463	14275	jxuAXZedGc8s4hFugnkzEgahQwdATXdAYzymJr2ap7ozvjHvXvZ	11076	15596	15596	1618746480000
22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	22147	3NLLwWNhLVkvcTJ6yhtnoyoSpAzB1nSoavFpjgGPSMPBgvG1AeJP	1474	963	407	12463	14279	jxtEPorgERpKA4FvXRMHZHP6zyytHsrbyya3YHPqXFBpDvbZxpZ	11079	15600	15600	1618747200000
22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	22150	3NKL9RxDdsjKN37rkrp2KWxDCwhy92GNWn6396Y1nCEQouKPCLH2	1406	1393	407	12463	14282	jwmGsBYGLJARNhZzb66jNiPCkby8WtjKb3ifn41oDzA4obS4bTa	11082	15604	15604	1618747920000
22167	3NLCPqbSq9XgHNwjQ2GspwuHs6Z9vTojHazvDYGmqaZWzwugL3Fd	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1406	1393	408	12463	14296	jwcdNdjnK5f3SXLt6cLX4PNcj2uAyLWb6pgu2oBy7NQ6TNb9xYk	11088	15610	15610	1618749000000
22169	3NKPuNAVzvd8KutT9Cc4mg4ofEgbZ1LxZJwq3jTqUE92NwGK6TBY	22166	3NKhd5yfmAtqQDWB68yU75L9e7Rtio7j6EzM644Fn28eNdQZLQhd	1611	1341	408	12463	14298	jxDAQsJsixDsPYEvkhNAA2ysJkSVeM3y84SgHypAERy9xoMJrUV	11089	15611	15611	1618749180000
22175	3NKLCX3ji34d1nDrsb9dfdvAWyEyQYjKEJofGi8BMg24sT3pHCRr	22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	44	959	408	12463	14304	jxjCYiabyZnBFRQnur47MnmYvAmefGSYyBtCzjMurPUppb3VV3V	11094	15617	15617	1618750260000
22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	22176	3NL9qBu2n9ADyrFXr9qRL9Rro7jDpBVrrszFEo6kaocPnx2f1f6E	1407	1395	408	12463	14306	jxkAfvP5S5ZBW1xnoog35N1RpB6w6Pj4ZiGKqHdxQzq7qWMnqYq	11096	15620	15620	1618750800000
22180	3NKNAwMkTjtxWvRViDHzqdf6WrwioosBb4UpJm79jCCZjPAYuTX3	22179	3NKVBqMdHeQKFDcc5p12MEj8pUB22Pu2HXVa5ybhCratzpgcP9NX	1637	816	408	12463	14309	jxbZgFbwRzEvDh3ExpTtAhHivmf3YWNL1X1nqD1YqSdSMFwCszn	11098	15623	15623	1618751340000
22183	3NK75c8vX3tPUkbXiEnoC3EcjXQgoyrUBhd7VhLkTce1ohaZ1eH1	22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	1581	778	408	12463	14312	jwZtxLsf9ZLZeU2RLYmKQTqaYTSi5PTu45rGVTjLEwB8UGTqWFB	11100	15626	15626	1618751880000
22185	3NLhFKsRM5SWrNQtVEABw5dMbJzrC4i2WMUQQfkwSj57XqWhJfvJ	22182	3NKEDgL7BZNw1F38LMRUkeDuQLpzdQRPjDCkVDhhDipME54f2tKU	1611	1341	408	12463	14314	jwG2TcAW4WZYu11AxdMK2x9FfXhf2FQ1LkzP73V3JajAFamX8qc	11101	15628	15628	1618752240000
22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	22187	3NKLYn93sp5K7bnJLaDXtruJHjikem4pou9na9SMuEta4kSELSsF	1581	778	409	12463	14317	jwzKR923rkEzXLqFZtcqM6BaPG7YDkBHaJDBTTQiAxRR6wU8hMk	11104	15631	15631	1618752780000
22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	22191	3NL8tQt6C9Yoe32W57miKGZYME6quXpnJSsjbqxELRqWAKniMppM	1608	1289	409	12463	14322	jwZzSp6DrjcbMMmwKidgPs1tq2nmP6eDN2cfm4QqRGq7tcqenku	11108	15636	15636	1618753680000
22196	3NKkVKkCAph6UcvVpbjStYbYCzN3DAQvecX8oSVYeXqhAkNbMQpe	22194	3NLNfnWLKq5Q3zCQyz3vuj1rVX4ERDCz6k2BfEDttgYWaAS3u4t2	369	1312	409	12463	14325	jwoJTeLaREP5r99FqwdFGwpo474bkvdZwzQS2RmNGezZt8nhcfj	11110	15639	15639	1618754220000
22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	22196	3NKkVKkCAph6UcvVpbjStYbYCzN3DAQvecX8oSVYeXqhAkNbMQpe	1631	794	409	12463	14327	jwn9C49rEeQmnuzfUFGpdsHVjaHoavuVWzBcqFQeQwdSYWg4tRX	11111	15640	15640	1618754400000
22201	3NKJZyevCSrWEegJmLFZNWFJa4nXt7tSnNi4XKGtYtYfv3oQ7kWQ	22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	1607	982	409	12463	14330	jwPmSqZuRW6Ro6adWVhrDGSbgomgwamZNCYYNLw5FVc9v91GUNR	11112	15642	15642	1618754760000
22203	3NL7KyG1nD1cTGGpF8yKLiRiSA8a25s99N2whr1ZXfThzYZyTyTL	22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	1426	1118	409	12463	14332	jxx4GnYs3eqsZabQgP8gozn47tCaoq936coALRhdHMTBSHQrd3B	11114	15644	15644	1618755120000
22208	3NKmytjCofzjiuvyYK1q8RGYxXHbhqZTEYeeVrrgNxWFqL6NP5U9	22199	3NKYNZdhxtLJ8DMgLRDKgkDP8DvcSf1ViZfrWEqEJP6fdQes1Ac5	1516	928	405	12463	14337	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11007	15647	15647	1618755660000
22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	22209	3NKioVenpyQofejTEu1MRTUPN9EYy2VUW21GXPo85beUyLsgn7mp	1624	1334	409	12463	14340	jwxVyDFog8mgxvUzhhLRGGzYSkFVMCNgpThVTXcVnoLeNMDWKSW	11119	15652	15652	1618756560000
22212	3NLSBpaV8jaBiYcZ7WND6UVa5GonVdDsjwCsJ1vhM6Sq5PoJSmwq	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1578	930	410	12463	14341	jxoDGSrRy1ws2GyLpBWZLSaRk97C7yZKNt81EQMGQ7zerWrcEZ3	11120	15655	15655	1618757100000
22218	3NKwxc4nniykhwkpPQHCEp5BaUd8Dq521CjCh3dZvFkNt3bW8bfJ	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1403	824	399	12463	14346	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q	10924	15659	15659	1618757854724
22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	22221	3NLa1BsjxMwxXpmaNmy8jMuFDuE3ghRbGsPVWCzdXpZmaxSgTq9A	1611	1341	410	12463	14350	jw9PFG72Wj3HB8gMRsk6sgoHbTLhuVqHLsQLaEp3QT8xXbDQcNt	11124	15662	15662	1618758360000
22229	3NLSrLYJALX94Q4mi5cBX8vmFVFg2jCJYVpnhvHc1oCj5mCXv7wN	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1587	1357	410	12463	14355	jxntNMT6Czg9oZbCGaQCgm8QH5geD5W21WRcxmotRR6VLtUR11v	11126	15664	15664	1618758720000
22232	3NKmXJR5b7ALPkUbJbt7QMxuY2pXX3Z9GZyyZu7WjdFaXCzngKBq	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1619	1029	410	12463	14357	jxgDepEzPG5aGoW7yu4utSYt6esyZ1EBqpc3MGRPvfJC92xfb1j	11126	15664	15664	1618758720000
22233	3NLWt3BbgVNQAZEiV9CVcyBRA2Za4HnJFq7q4FdGaY96rm4bMvav	22232	3NKmXJR5b7ALPkUbJbt7QMxuY2pXX3Z9GZyyZu7WjdFaXCzngKBq	1634	1085	410	12463	14358	jx9JqQT28eitfrRUWk2Mbc5mRZGpBkee8FGkK1FH2n3oHo35rY6	11127	15666	15666	1618759080000
22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	22237	3NKNPyMhhnm2hPv6JXDeUByJM5T3rFcRUFETjCB5hvp8gWgCBjkD	1579	1389	410	12463	14363	jxy5pZe9xcG4iZSBDxkV1yVZtDbcUT3qLWBtRjBWA2BHJ3rM3d9	11130	15670	15670	1618759800000
22245	3NK9aygjK7biqZEsqES9RzrY7mVUdgxGU1Z5zYqPtHD4d1rtMS2F	21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	1501	1360	403	12463	14370	jxsTutZGgtPkeXqSP2ieU9r65Sufh4MNs1PXtJHPLxdshzhYxKD	10990	15673	15673	1618760386622
22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	1406	1393	410	12463	14372	jwhFPjBSTJ8kw3faoer77zuVbUqm5JwCHeTvreQZDoPBkTjDTgC	11134	15674	15674	1618760520000
22149	3NL5Tii8LD277dw1pyNsshyrMkfCGemvdSrHXzoNBnQuUbp3ai5B	22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	1406	1393	407	12463	14280	jwXCZ52y63vt4ZWD4vEyowpGeoT7yBS53sgUG3FgaCQSu4EvHjN	11080	15601	15601	1618747380000
22152	3NKe1crY4gSP8VmL156Jmqv765kviFPSvSqimFASNLwpT26urwPr	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1654	1214	408	12463	14283	jwDcte4JgaVKoAUudvycFEPSKwxqeHqAaUJhHwa7ahNg5u6LcpK	11083	15605	15605	1618748100000
22155	3NK79Atnns1qrbhVsXTfJAXLQGUrp7FT2B6YLVqTAvBrsAUsx5W9	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1654	1214	408	12463	14283	jwDcte4JgaVKoAUudvycFEPSKwxqeHqAaUJhHwa7ahNg5u6LcpK	11083	15605	15605	1618748100000
22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	22153	3NKuTAkMViyyQkAF2oupr3vzt8vD6mT4cMLYxi1UmejbS6tjJa22	1406	1393	408	12463	14287	jxggSkPtkkk5LbBqJRzQ4uv78Ssh82d26RitBd8b4Bik5deo27u	11084	15606	15606	1618748280000
22163	3NKvwEQJ6GaJdeynqA8QPs7HafzjLGSLZ9V2SyGFnfG8e7jTaxh7	22154	3NLdNysP1Bt3u1mKLC13vLGn7yZgb3N1LYhcRKi7xTeQvTEFhjFX	1609	1087	408	12463	14292	jwohVqT84iN38RV7SaYyHgAYBEfJCd5xKpp7TXfXgTw9CKXMGG8	11084	15609	15609	1618748820000
22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	1609	1087	408	12463	14294	jxbg1jBihkVivEhBZddzmrmefbZ7qrAJnqhN2TmC4rHruBbEMQE	11087	15609	15609	1618748820000
22168	3NLQVFyHToXZYxVdootZ96Dri9NyhSyYk8tznCsnPCvQHJsJADpz	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1457	1025	408	12463	14297	jxeUHVRQXvwxLREc1jBQNJVyoSsNggwGnBS6JT1Yrb6War1ZNzm	11088	15610	15610	1618749000000
22172	3NL3c5BDaUFwxYSZpHS59fvEVxneRpyLE9CyuqaNmwZRbycHYqiU	22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	1471	1020	408	12463	14301	jwQiB7ksxiT6xhnHh3oVRE9NRDkx4Nek7qjwE1Kdsgy7wYRZU8p	11092	15614	15614	1618749720000
22178	3NL7kDwFHYKTfQLsKbtAtbg9gSStdsoe1oLPFmK7oFiZ1TYWGbaf	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1555	981	408	12463	14307	jwxfhqRU8gGcNBtVG76gbwxb6XeMppp9Ze8Vz8o9WEaVhUdRxoT	11097	15622	15622	1618751160000
22186	3NLhE2J5UNbVut6JJphzSweUqi4mMrkUDKSQpHceyUniczB2yvim	22185	3NLhFKsRM5SWrNQtVEABw5dMbJzrC4i2WMUQQfkwSj57XqWhJfvJ	1578	1050	409	12463	14315	jx4GehgPJqMJfHj6VycU7wRn2NbHxTSVk2tr15GLcRTCJPQauoC	11102	15629	15629	1618752420000
22191	3NL8tQt6C9Yoe32W57miKGZYME6quXpnJSsjbqxELRqWAKniMppM	22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	1403	812	409	12463	14320	jxAURe2sh7W5jZeYVLB8XW6mLakAugbH7zi8pv2uwbPvZkLBLrW	11107	15634	15634	1618753320000
22194	3NLNfnWLKq5Q3zCQyz3vuj1rVX4ERDCz6k2BfEDttgYWaAS3u4t2	22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	1406	1393	409	12463	14323	jwxozPbWvXbN8hA5TnPigtf2yyKgEFjDweDJYJkEeQ9W2un6bw2	11109	15637	15637	1618753860000
22199	3NKYNZdhxtLJ8DMgLRDKgkDP8DvcSf1ViZfrWEqEJP6fdQes1Ac5	22184	3NL2UCFpjuxjWkgqZK8sw5mFLYjmtapQpFEczfRjWWqUbS53kDJ7	1516	1294	404	12463	14328	jwGnsYi9fJF21JPCqBtqQLeHgF9McxY483mH15r8M4L6wcTkrEp	11006	15641	15641	1618754580000
22204	3NKeVyWxKMW8xZyXQ8scxS5Tn1fSeCsrnMbT5mBhGatVo3KUH9nz	22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	1631	794	409	12463	14333	jxdWQ2LsM3Hi2QfpRxxqw2p7vcwpk9RHDdydhtSHLLfnDied3fv	11114	15644	15644	1618755120000
22206	3NKyrJULJmYeExyHzG86LnHrt8fDY1kEr5kESMYiruzzfy5Cz9Aw	22205	3NKVBAu1upsM6z42XBrZvVJKJQCrxtmvbE9ruwwZF1B9sQX3gW6d	1607	1348	409	12463	14335	jwY4AynvQxNGg2ruJHTCjYZfHx2ZKi4b1Gq777u3kNewoMmCURx	11116	15646	15646	1618755480000
22209	3NKioVenpyQofejTEu1MRTUPN9EYy2VUW21GXPo85beUyLsgn7mp	22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	1407	1395	409	12463	14338	jwan1nyYc59eT2SwoAHDpajP1yDwojrLYQnqXjHbpUKnKGzPAPv	11118	15650	15650	1618756200000
22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1588	1266	410	12463	14342	jwfS4HVQRH4Av6jS7ofNCPDbTjbY3dTgNdhX9xHvHNuyX6wan1d	11120	15655	15655	1618757100000
22215	3NKW8M7ZNimVzMVNeZL7A1mFBTe4FgtALxjaeo2GebeN1ePb5irN	22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	1617	1288	410	12463	14343	jwJS149QBbVgnyfbHnXoXpWgpXVQ34TMrNJicxvyR3n5pA6ygrg	11121	15656	15656	1618757280000
22216	3NK5sibNamMXwV9iTswGgovicEXm7j38Zfd2L9Si9mcfmGWjZ7A5	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1403	824	399	12463	14344	jxohfvhTNw4eSawfVXjskmeAmz734Xtszfx9qu7J6JDHHbc2SsB	10910	15659	15659	1618757820000
22220	3NKCbHEjTSMT2eMxYLoBzLoU1LVgyJXquDgN4Uy7To4eVVyuECoZ	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1403	824	401	12463	14348	jxYf99NKePj8fZ56yLvEThMVF5PVPVBkRLPkoJ1aaDkSree3GSy	10950	15659	15659	1618757923991
22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	43	1184	410	12463	14351	jxYzV1TvmmMVCBKqergR7VVjRxarvkrGmdDreTHmPN8gyDL3qNV	11125	15663	15663	1618758540000
22226	3NLiCqMejuJErzksQkqBvky9r7yGkYsFGRx8qUvm2jn7hbFsCcAa	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1577	1201	410	12463	14353	jxvTuKmfq42ogEWFntV7VhnJ34Mw69e9G91fXj6YV2eBukq5dzY	11125	15663	15663	1618758540000
22230	3NL9v3WqbpkD3apevAkwYcdxsSXR8ep6ueRBwAfPZ7aVE1HK6t2b	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1587	1357	410	12463	14355	jwxQxrPQASabY62S2tpR8ibpAW4eG3PEHnc2jR4qzTMHzqd2sXd	11126	15664	15664	1618758720000
22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	22233	3NLWt3BbgVNQAZEiV9CVcyBRA2Za4HnJFq7q4FdGaY96rm4bMvav	1501	1114	410	12463	14359	jxRC1jBjbyHVspNYYUndZGuy2VrRstuAWvUkxyj6XKsTQFDqW3U	11128	15668	15668	1618759440000
22239	3NKxyDEbGihtuqpUxw9cSFrgPwEGu7xNSiezAhfDmdcUPkQ4HXRS	22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	470	1183	410	12463	14364	jwfg4UwV7kmdDJsEWRvrt2WtzFaQxEMdtVbiRhizLHiWzj213jY	11131	15671	15671	1618759980000
22241	3NKpBSkEriU9LiXvdzo6SDy3nRwT1NojiosZSQBTsc25PmguCXga	22240	3NLVSR8eNirKdhCxnyVNseaaUAipTj5WN6SSQcxRy7seByfa1db1	1501	1114	410	12463	14366	jwsLdFFMXEDuLzmrP8KDXes8u6ebuPA6RpNgLYbFwAYeGdFXeXx	11132	15672	15672	1618760160000
22243	3NLpbwAnecsxPy71ay6TMvRcLeFrNoGjizzdT8UvYU3ovxo83NiV	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1501	1114	401	12463	14368	jxG8WrnKKNyd78gGdZ2zSF3V3aZS5BYLfVLs3t8v3LKFjvkhkYc	10948	15672	15672	1618760215681
22248	3NK5B7uQHxwxoDzhunTkG5aVRt4NMi33HhaNSXqBUiTYM6xVYP3J	22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	1445	1290	410	12463	14373	jwqsyZi5WBeixR1ihPdZkicjUQR8DeAm21JYKvpdTE3J3GZ8Ntf	11134	15674	15674	1618760520000
22250	3NKU3AiKbCKyukScXhuXEKdzszeP8LhxMMA3FNAZD2UukaWrLo1c	22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	1507	1034	410	12463	14375	jw8JSGbmkS7DK8yXiAF1cXJh6myWasnGENDY98px8iSc5X5vthv	11135	15676	15676	1618760880000
22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	1403	824	411	12463	14380	jxaRGwBtywuguuwrLMmjgtMwDZaKR5Mcr9rVicNCBMAyCDZCm7y	11138	15680	15680	1618761600000
22262	3NLNL7WsznjqwtBMWeucsuYtoe48tuoEKZ4icqE4Ut5yjQzzzHv7	22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	1670	1036	411	12463	14384	jwRadTYzUJscCaURa914gHiGdwjXAc4JLdXi26jmnNRhVk4JRkK	11141	15683	15683	1618762140000
22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	22262	3NLNL7WsznjqwtBMWeucsuYtoe48tuoEKZ4icqE4Ut5yjQzzzHv7	1637	816	411	12463	14386	jxibcdBD7jT87DzWrS7oxc46cLS5LGf62UyRK39wT7MgV3NkR8X	11142	15684	15684	1618762320000
22184	3NL2UCFpjuxjWkgqZK8sw5mFLYjmtapQpFEczfRjWWqUbS53kDJ7	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1516	1048	403	12463	14313	jxLk2vbHFPntqgTGFRYDt6vnyxFbpNqsAU6ZtRb1Kxk2G7uVPRq	11005	15628	15628	1618752240000
22189	3NLdcZLtt51bJhYYx6XsWqRE5fwWqHKXAXZjBYgFKbGeywaNNmzS	22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	1445	1290	409	12463	14318	jwT5Tt3DEWy3VR89kPyoBuVV2gasHuAatM5ZBNo4JQ3km29gL2k	11105	15632	15632	1618752960000
22192	3NKB5noQnzVKRZ3EbGy1pX8fwpmuMQmsNTEaw6DJnu6g19RAUhzy	22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	1613	1349	409	12463	14321	jwR8TaKeaSbu6VGUrdR6XMo4pUqY6dtmQAV6EK7aLwEtAE9uotS	11107	15634	15634	1618753320000
22195	3NKuPyzCPagFeFeVEe7WV2zjMNSbt8RyY1rW9WystpcBnhLyZbx6	22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	1637	816	409	12463	14324	jwUXE2rSYcMLdMwePYHSB7QGg6ZpZuq6uLSwDvK66rvakYVZ7Cv	11109	15637	15637	1618753860000
22197	3NLj3wFLC4WAMm824EJmgURZ6AkC3jrsqR2fyDYZEXQS77GhCy7f	22156	3NLGV5wtFgoituCLJME3KnSrBZbEfmgzVueyTqwoi6LzyESgHFrc	1553	776	405	12463	14326	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11031	15640	15640	1618754400000
22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	22200	3NLuPPFQzakSVAXD6sjXuqtGp6aUsaxXF2gydvLPAJuzexPG8wF1	1407	1395	409	12463	14331	jwsFDgTeVi9dQPivLnXGn6HY5ZGZLEvT4ncUqtvji5yCPdGqst2	11113	15643	15643	1618754940000
22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	22206	3NKyrJULJmYeExyHzG86LnHrt8fDY1kEr5kESMYiruzzfy5Cz9Aw	1403	824	409	12463	14336	jxKDW385cmo6cM9ePHXagu8r3TSf6xGD6UtowYnxVsravsE3oFT	11117	15647	15647	1618755660000
22210	3NL8DM2Y4d4kVgvV1Q28BQSt2RHegsS7VqJuW7p11TMRtCBKXGzX	22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	1672	1285	409	12463	14339	jw78za7t5dEAtgLfsmkdVdfMZKYZ4PaDArfHrFxcqCzY85RrT5Y	11118	15650	15650	1618756200000
22221	3NLa1BsjxMwxXpmaNmy8jMuFDuE3ghRbGsPVWCzdXpZmaxSgTq9A	22217	3NKUbFacwH2osxH3U1YQxLa7L6BRKkC6kXXrQZ3MsgrYtiSYj4UP	1471	1260	410	12463	14349	jxfYRPs9yeUZJQbSTG8MeWas6deZyXPCD79jbbiswBQg2HXGWV3	11123	15661	15661	1618758180000
22224	3NLcmcoYMdGb1xcyP5nAPWNvXoJsUkabtQV5PxZFRYWB8nezQ9qp	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1407	1395	410	12463	14352	jw7aHWZxjZVtraAkeFh3KGLo7Fe8KARptgKANxcmnWNTaFqe1L1	11125	15663	15663	1618758540000
22227	3NLm9ZgofiD2YzSgR1CE79KRDtQG8N69HvTiaHtwxcPhDkZYv8N9	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1577	1201	410	12463	14353	jwt5EQpvGpjgg9DgJjKEVS1a8baB5AMUjdSAtiEa8zhz85tY4MX	11125	15663	15663	1618758540000
22235	3NKzyHRbaEFbGFRfYNuqxDVRX1y3aR1JDjRHxaXq449hKHt8uRu9	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1617	922	410	12463	14360	jwEDefKNV4iJJxeWBib2gyWxZUYcwscTr6x4hgg2gLptymRGehx	11129	15669	15669	1618759620000
22237	3NKNPyMhhnm2hPv6JXDeUByJM5T3rFcRUFETjCB5hvp8gWgCBjkD	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1624	1208	410	12463	14362	jwDrnQQakA55NtWdder1MEEybboYSeJdee5Bvdiarm2hQySaQsS	11129	15669	15669	1618759620000
22240	3NLVSR8eNirKdhCxnyVNseaaUAipTj5WN6SSQcxRy7seByfa1db1	22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	1560	400	410	12463	14365	jwyyWsrhmZ8gc2qd31U3xDo4nxjGUYjSAyD7rhMMbZy3TTJo3FP	11131	15671	15671	1618759980000
22242	3NKm7btXhNdpycyDyuZh3ZL8sCvwcMKzxdJkqcigfM4huVHLWA6x	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1501	1114	400	12463	14367	jxseHGMkEhAMu8KTW2HPqozYRXHbs5iyDc9Mhk5C1t6GWxL4Tok	10935	15672	15672	1618760160000
22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	22241	3NKpBSkEriU9LiXvdzo6SDy3nRwT1NojiosZSQBTsc25PmguCXga	1501	1360	410	12463	14369	jx5UaxKBWvwzsS1mAMtoSJxfgjMtHS19XLyHxB5Nx4gupegdpGj	11133	15673	15673	1618760340000
22246	3NLe1kJj6cpZ5dZsfgJezxUUn4Ei3fa8eW9LFbvtNsHfAGAfKbaD	22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	1501	1360	403	12463	14371	jy2q5Zj1rmbQEiCjPTMKC9ns3XPn1WtVfXM6r9fxkg95kDoE7ES	11003	15673	15673	1618760442713
22249	3NLGkhJ3SgVUbXieh68gobTU4aT8qBVu9Ge3cAY157Q8M7tqMNra	22208	3NKmytjCofzjiuvyYK1q8RGYxXHbhqZTEYeeVrrgNxWFqL6NP5U9	1516	1168	405	12463	14374	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11008	15674	15674	1618760520000
22253	3NLMPeH8urxUSmKsAfaUg9AP5qvvSkBP6Cb8Xb7d4swpwVHK45uX	22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	1601	1388	410	12463	14378	jwVLZzk3RJymeREjjETBsDmfHepQ4LhSFVKLw4VyAYXhmN9fCZt	11136	15678	15678	1618761240000
22256	3NL9rpCsH2KmoRt7hy9cfJDCUYbXeS4LYSGWqqkrHjGgqDYBfNv9	22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	1637	816	411	12463	14381	jxEuQCbrF89jvYnwPGWTwxr7sKRZa52i51K4vh3BrSPMM5bH5rx	11138	15680	15680	1618761600000
22258	3NKrhL82hy5hYzVN3sML86ppvbZiok4Rooo3RU4S458Y2nemcg2e	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jxX17ded5MhTxdBekcdaygx7uKrrw8JtmqmdMZzf27RgQPuYZht	11139	15681	15681	1618761780000
22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	484	953	411	12463	14383	jwGBAQz4ciXbxXbE956Nms37JBUReBDdKF955B9aoYtYphGBXsv	11140	15682	15682	1618761960000
22263	3NLEqs9Sm31HqHhdXXd7gUym8JvnWJpa9CHbzCxEgrJHR9mkj17C	22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	1522	1322	411	12463	14385	jwH5MTubbWzgqG1Karb2V32SrK9wZ1vFM48n4ui1cbPEmzNYUF6	11141	15683	15683	1618762140000
22266	3NKDcE3vzS3bqyLHkrDLPJtFk9AjZHrbnNE7mqZQekKoqsrtreYt	22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	700	832	411	12463	14388	jxYHYKxXLppxnrxpUi4byKRUi2UtcrssdnLnr2qEf273xVH9r5t	11143	15687	15687	1618762860000
22268	3NKq8rS2ibGVydzuPVrMUpnuyEmJdSoWgS73qKNvp529H3SpZKaN	22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	1407	1395	411	12463	14390	jwDtZq4HKQ54LJYqbvQRj8xKZsJSz19zppCGETVggTpzmyS63rD	11145	15689	15689	1618763220000
22274	3NLVZXr4fufrFfxJrUdevZ3kXopvpioVhBQu5tRkCJuUMQE2N5FH	22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	1406	1393	411	12463	14396	jxY5c8SPU5fMxPRarGqKEoMZaMANNM7uSAXwk9n117bhMWxAFRP	11149	15695	15695	1618764300000
22276	3NLBXkm7QA1yQgbV1egwkJKzvA3ZWVgRZKyM7vGSV45kCm1hmyYB	22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	1507	914	411	12463	14398	jwKZMUC52qTBknBnLxFWMSRZXEptwRdk8ZrCnAqnJw2hFXayutJ	11151	15698	15698	1618764840000
22281	3NKRT2cTL7QAe8LExev2CKoTunUELwFhfefrTdR6P7Bb6mQZE6wa	22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	563	1359	411	12463	14403	jx3kmHtZf8gMs77dpU54PsoJsA3G5mgGTQS1epLpugxBoz1gdTk	11153	15700	15700	1618765200000
22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	22282	3NK3Vpidzv4Fk2xdzdmgHNuPdWNRN9JC94eXvPSNM1pEWaLnFuVJ	1670	1036	411	12463	14407	jxHTRDiJo3XnMWK8VJXuHj95LeiFqjxKtb1FnedZEswVAuAbkjQ	11155	15702	15702	1618765560000
22291	3NK9UEsxVcP6G1WhEY4uwofpeSxxF2fHQc2hJJ6hPnyQNdwupEi1	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	369	1312	411	12463	14411	jwEDdEauCR2aUiN2KSQ2u5qdAkGoqJ1GhVpNZtqg9mAGzbGnEKB	11157	15705	15705	1618766100000
22292	3NLDrjAHNg2q6MEpPDGdSTKZecQYnSggqKpKgfhexzXh677M2pfK	22289	3NKNjfU1rpALzgm7UEnSvnwAW7ZYFEpnZUQde3YuEE3tzuFAUzQX	1457	1391	412	12463	14413	jxxgPHrLFCNR9XTu8v2aVtEneWFvfxenfVBXDewsfJZCWGsoPUm	11158	15706	15706	1618766280000
22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	1397	828	412	12463	14418	jxWVbWxMf1cfUNnrrH3Cddw7CMtbmV36bu9ZyM2vJNCZznNLMk4	11161	15710	15710	1618767000000
22200	3NLuPPFQzakSVAXD6sjXuqtGp6aUsaxXF2gydvLPAJuzexPG8wF1	22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	1405	873	409	12463	14329	jwBgKzuRcRUXdnmQzQoRi1H9JA5tQLXjzekSd7mEfGxUfRvuGUd	11112	15642	15642	1618754760000
22205	3NKVBAu1upsM6z42XBrZvVJKJQCrxtmvbE9ruwwZF1B9sQX3gW6d	22203	3NL7KyG1nD1cTGGpF8yKLiRiSA8a25s99N2whr1ZXfThzYZyTyTL	298	1182	409	12463	14334	jwrQYzPs8q9WFRDdzs5XyTppu7STL2LNcXQsicEooT8TApis32g	11115	15645	15645	1618755300000
22214	3NLLEcFaLyymAj54keQK3erapXuCk8aFcCMMByCy2JhE3d4F5hhY	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1578	930	410	12463	14341	jxoDGSrRy1ws2GyLpBWZLSaRk97C7yZKNt81EQMGQ7zerWrcEZ3	11120	15655	15655	1618757100000
22217	3NKUbFacwH2osxH3U1YQxLa7L6BRKkC6kXXrQZ3MsgrYtiSYj4UP	22215	3NKW8M7ZNimVzMVNeZL7A1mFBTe4FgtALxjaeo2GebeN1ePb5irN	1599	1161	410	12463	14345	jwS9eJ7WqBWXMXzXJWovdXPXzTP5hEXn82MHYvDbcgoPdMuiLQv	11122	15659	15659	1618757820000
22219	3NKuKDSoZFX8AQ35xEe1ue29Np4xyEhWqTP2oZqcWXPs5xuHcUDr	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1403	824	400	12463	14347	jwfFBu4KXBKVBag9Fb5pdsj8JeoAnyd6tfyZwA39pMg77AyA6HQ	10937	15659	15659	1618757887200
22225	3NLfeBL1d5dobPWe1PSmTXc5Qm9Bjc8fQsiaZMP7NayEcFK4jrTQ	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	43	1184	410	12463	14351	jwK4TWHqDZNE8VRpCJC1AJgtcU3wyX5KPoFCzpRFodyPQnE8NDh	11125	15663	15663	1618758540000
22228	3NK9CkYofZbrRoJiWLuzMtgtGKNEYxzPXgA75W8XvVQhf3jAvhaP	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1407	1395	410	12463	14354	jxXHaTPiD4u5bokAMSqqNXR6JZYnrQQuowTQDVmTMSF2n6ixFMJ	11126	15664	15664	1618758720000
22231	3NKvV1EycPkYD8cNkjPULZT18Weq4isQoWjMT2AkSHPBQKrbR9g8	22201	3NKJZyevCSrWEegJmLFZNWFJa4nXt7tSnNi4XKGtYtYfv3oQ7kWQ	1619	1029	409	12463	14356	jy1AQgEYr2jaDhQW2C9cZvczvLWwA2YAVsi9JUbvRQELgBMVsXP	11113	15664	15664	1618758720000
22236	3NK6JMctD7tr67GFiQJX8ugfkFyo4RofJKLCXENz3NYXVBhoSjVe	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1422	971	410	12463	14361	jx4Dm4SXVtvyPxRa6Ld1oCqghnnoq21BzgvQVSm2TDGjmCH8CXW	11129	15669	15669	1618759620000
22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	1631	794	410	12463	14376	jwVGnpLLu7sJSocKCu4ntAihVyWqLE9J7s65ZB7dSHfY9TzWLig	11135	15676	15676	1618760880000
22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	22253	3NLMPeH8urxUSmKsAfaUg9AP5qvvSkBP6Cb8Xb7d4swpwVHK45uX	80	1273	411	12463	14379	jxh2nH3fULcPRQyAzWRbH3Sbf9nAL4E4mcTwnrwcueQF1mc9SZo	11137	15679	15679	1618761420000
22261	3NKDdwbxTtzRHtsJCGuEz32Eo8XzeCFXscMMNUgr39vSZT1DiJLR	22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	484	953	411	12463	14383	jwUxqrhq6FBoorPfx52AgTfn5RHFBwwvdfYD29goFekbxRDahQo	11140	15682	15682	1618761960000
22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	1406	1393	411	12463	14391	jxmGXWnU1eYbRfn3wCQa6XRMaSJ2wRjwNK59rD9f1Ysss7je2Fu	11145	15689	15689	1618763220000
22271	3NKy8yoC7TgKD7uy9BTZfFBnfpTHa9H3vwH7qZh2ru1YuNtjyjhy	22270	3NL6ZAQEmNeJnVbNyGhomRdH1yZ49qz7h7ZsBhFHpWhUZKvzAqzW	1406	1393	411	12463	14393	jxDSjmoTJeAWsMzy3hkXNu6h1NXsScRMRBESgwLGc4xC6no8Lmp	11147	15692	15692	1618763760000
22277	3NLRyGuvH5fgPnD7rZofJ8suczt6tra5SFxj3xuwEwMs6th5n2aT	22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	1461	1271	411	12463	14399	jwSwgiP9hjgeiH5xJ5mfHsVFkHQnWbsRwwWnW5Nw6jpY1x1vPy4	11151	15698	15698	1618764840000
22279	3NLTaQxWMaHywW3A9UgGShnmjX4AE8C5pBsNozrAwLFRTFZ2H6wj	22197	3NLj3wFLC4WAMm824EJmgURZ6AkC3jrsqR2fyDYZEXQS77GhCy7f	1553	776	405	12463	14401	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11032	15699	15699	1618765020000
22286	3NK8oJJqX8mibayMT5LfqA9WMoGX7PbQDnaf2RwFC6mfCzxPEsTe	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1405	865	411	12463	14408	jwts6xyxQ5kiAEDzQ9sP1QKjFQsMdXmNpKQgQzGygS7cbJSfAQx	11156	15703	15703	1618765740000
22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	22292	3NLDrjAHNg2q6MEpPDGdSTKZecQYnSggqKpKgfhexzXh677M2pfK	1406	1393	412	12463	14414	jxAYir8Ubjos4idu46jn1qiJPEtUMSoZ85i1cgsxQwX99zoRMwK	11159	15707	15707	1618766460000
22296	3NL32rVqn5weF8rYSsM31HRUhMihMPT37oPjX7SWUrcd3tFTYGFv	22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	1509	1320	408	12463	14417	jwBWGD8sRzpNbqRDfbb2xXh7qgMkFAy3i2uQMQ1QEspvWzH7GD7	11092	15709	15709	1618766820000
22298	3NL8ajehK9W36EpxHSoWxvzhbB6YSQdTFKFsjEEaiZQrvhiftXfs	22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	1406	1393	412	12463	14419	jwNVToMK3GeonT4kMRCNKdJxSYFyGEfCtWYZBhViRjfXDs82HGB	11161	15710	15710	1618767000000
22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	1581	778	412	12463	14422	jx6NspMULFJAd3DECUB3rjk6gVVXThoD5r8jat6UkKgMZBtFR5b	11163	15715	15715	1618767900000
22303	3NLXdRjZX8bjNBtkXkwRW5LgqAhpB1du4tSUnrRdWAfb4SqCYiU2	22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	1513	1379	412	12463	14424	jwzKLULysagtGeNYouewSHv9xqJLvHPj6QnxavUsN3jS9BiwvsG	11164	15716	15716	1618768080000
22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	22303	3NLXdRjZX8bjNBtkXkwRW5LgqAhpB1du4tSUnrRdWAfb4SqCYiU2	1467	1130	412	12463	14425	jxBr3FKmMPfC3vkqvVUZTtnAh4NbNdiFMMggyQDV8v29fxbD8TL	11165	15719	15719	1618768620000
22308	3NKAudcJ2j2sJwYnS1Sjqdk9x5y9fPZCsoXHRt8g5zZezTtqNE2s	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1631	794	412	12463	14429	jwq6N9A2VTDWn2BAVv6fLWmiFaa61N2Aqaw6hwdht4k63rDBhd8	11166	15720	15720	1618768800000
22313	3NKx8FcPo9efJ76vyXS2hdqkmvXKkwvu4TLcgKwSSHWTbXhYDoA6	22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	1490	1148	412	12463	14434	jx6LwbUT1wfdo3LmjDWnTxnaRVceV8EcrR6wdiG4pwunZdw2iQT	11170	15724	15724	1618769520000
22315	3NKgUhpPju6FqZ9BeaGAfmLyFCDHz9QtJE5iDeke2R9mSxUjnCDB	22279	3NLTaQxWMaHywW3A9UgGShnmjX4AE8C5pBsNozrAwLFRTFZ2H6wj	1553	775	405	12463	14436	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11033	15724	15724	1618769520000
22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	22316	3NKHhpfjG34gDtjZDfx6Ed6EeZ2YqG2Vg3tkVJKhzx4sgerkscwC	1646	1228	412	12463	14439	jxhceMBUgD21yL1Ct29dZYVtSkajXVakMPbZStxMf2REqhYy5Ya	11172	15728	15728	1618770240000
22319	3NKsvjXBWaMVPQfKYMKJ2o3diXH39eV37qgwisoGy47LATZhHjPY	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1420	403	412	12463	14440	jxagik14qcoDWNPdrckeFhyNKNtVJLEhiUPNoqKbJoBFMq6hxVX	11173	15731	15731	1618770780000
22324	3NLfafGG7vcD4oo8UoRyQ74n4fqPVthKqgbde4dbwnobuPoxpGmS	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	484	1319	413	12463	14444	jwzoZoxYhd1JUnMBNsjRaFovFt9FeD8w2N8CCdonM1jGJz5Ruoz	11174	15733	15733	1618771140000
22326	3NL3VEHQc8rLZBSpfSov37xfqcCStH4EUcSJRPZok5B4to4e1DvM	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1477	1224	413	12463	14443	jwka3hxbYFhxZaN1tREVSCot3qY8LqDxdYERwgH1PXhfq9uUoTt	11174	15733	15733	1618771140000
22330	3NLvh9pMsDdGy5k7qE5kdBkMUGrZRhAra9ZJ1ctCqPtQHw2A1K3X	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1649	1257	413	12463	14447	jwYVUrETJe42MXLSVSkSHF1ZcYK9pK7injPXEVS7cz6mdJJ1k6D	11175	15734	15734	1618771320000
22338	3NKTdtkoV6AqrDihx6ZvM6uPHRUrYDG1RJwdWB6cEeCT9c5Zps1T	22337	3NKuZb5pGAvcJP45dPKPrK3NcsCU9VHVAZCw6bA6QRuKkUjatH8r	1405	851	413	12463	14454	jxVdtbwbYhGCTHS3CofQT3XNchPtxd24YV3BCxzyYwfLge2555X	11181	15743	15743	1618772940000
22252	3NLVfpDZdcyG1TcKA2X8DMYgPNEaXLmsZN1hmjmm5VHz5i7HARkD	22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	1522	956	410	12463	14377	jxwygatZKyPx37qhr16YimxTHtkjTS6whZQP4WUwazEsta1cYPA	11136	15678	15678	1618761240000
22257	3NLYKi47qVxtCRyVDy2WRevcVSwXrBATVn4XR8bCM3y4RmKpoMhA	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jxAHPk67d6hSVBrYtbBHRFhWL1wkmZrenUryZgT9DNd2HHUgw47	11139	15681	15681	1618761780000
22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jwVJW1q93AnVoKmnavfWspmDckr1tR4SC736c2Fe6KCUUrfVErm	11139	15681	15681	1618761780000
22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	22271	3NKy8yoC7TgKD7uy9BTZfFBnfpTHa9H3vwH7qZh2ru1YuNtjyjhy	1627	1259	411	12463	14394	jwzPt5XNUTNMJCrh8osCo9rYn8gExiU2bWik1NPz4GaYLhZynq9	11148	15694	15694	1618764120000
22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	22273	3NK4sk5MDDGwCfpe6kLS27cHm4Gk9E514YMiuRBD7JE3z9JmMBVm	1471	1386	411	12463	14397	jxJ61V7vgkGAKpeAT6QQ43XAMDwvMMCPbaWuXpyGxjK3g3jaFYT	11150	15697	15697	1618764660000
22282	3NK3Vpidzv4Fk2xdzdmgHNuPdWNRN9JC94eXvPSNM1pEWaLnFuVJ	22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	1406	1393	411	12463	14404	jxB59LcWKBESBvAucJpWB3EGKhvhqwKfaycGWYA5yoEyDSR1TD7	11154	15701	15701	1618765380000
22284	3NLbLfTCQxH8D4HnvkX4Kk7TWNBhAGgS3kv9UX1YWYiQhymWP5vg	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1506	1373	399	12463	14406	jweRM9jzqquVgn1MkQ5xJMeApUQFijFWzaea8hqMk1gjeq6qvAX	10919	15701	15701	1618765380000
22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1406	1393	411	12463	14409	jwZ4o14f32rSjxtPUYujhUweNuVedH3XVdAm4Rc3PwfdWibizZF	11156	15703	15703	1618765740000
22289	3NKNjfU1rpALzgm7UEnSvnwAW7ZYFEpnZUQde3YuEE3tzuFAUzQX	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	369	1312	411	12463	14411	jwLKjzkw1iCL7NRz4Lrmd2bsgyqvSqSexHcHFy3yMNT6L6iY9X8	11157	15705	15705	1618766100000
22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	1509	1320	412	12463	14415	jxQiVjDxwvgvJsMLFFuKiiHpLyE3SKHCyt4PnACx7gUkvX6A99S	11160	15709	15709	1618766820000
22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	1571	969	412	12463	14420	jxj3CftLCnrBRLHCQEKScYkyjSHDQuodwUPkBv3S29AitcX61ma	11162	15714	15714	1618767720000
22311	3NLMUhAcMvdE1ny1xuRSm39XVTna2TrTrgLb9tnFg2XMmxbb12eV	22310	3NLjkje3EYgc3ZDk3641HA9MLKBH1mvQ5hSMZHHFNtxmhjLjFW1o	1406	1393	412	12463	14432	jxZVM8iuCk7qYE7mna9UsFv9BpkvgX9CKwqsdx9jZLZHenviuoF	11168	15722	15722	1618769160000
22316	3NKHhpfjG34gDtjZDfx6Ed6EeZ2YqG2Vg3tkVJKhzx4sgerkscwC	22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	1642	1367	412	12463	14437	jxnw7wYBVieZPDHbFrtfFJtUDGU4SJYHZ6kBBjeCSAHNTAChqny	11171	15726	15726	1618769880000
22322	3NKZkqGPjpXw7EF88d67QzrevY6kP5W5VFcosgZPMB4FX2Fz2kev	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1610	1068	413	12463	14442	jwabDdyTKH42mUsSBeiCQfXrQLTV63QsPoxSFGakXscjncW7Vdn	11174	15733	15733	1618771140000
22328	3NLT1J5LsKazhmc7uUnxFKHxdaEVnZN9uReSaMxnMWnnUEL1f8S3	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1648	1284	412	12463	14446	jxM1ScJTFbMwgiQRYC6XJT9Gq2WUvwj85rkjV1gLVnLDvyHJUp7	11175	15734	15734	1618771320000
22333	3NLAsPvVWTuRJM5rrveKWgj1WDr1aQC8Ep1ztVETwFyJpYRXpnKs	22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	1611	1341	413	12463	14450	jx6S5WSkKawZmD4kd2nuboJF8yAVFR9dnNGj2m3wqP94S6Put9v	11177	15737	15737	1618771860000
22336	3NKVk1S89LDH46cWMRFLLQdPLNmu6JJRpv8crVWyFHosQD4M99NA	22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	1651	1175	413	12463	14453	jxm4ZbCk1L8KR86ShQkJZiPPLMdXRFHG627ksaZSYTQo4umCmyw	11180	15742	15742	1618772760000
22347	3NLjvX32i24cTgsBYZXtAuQvUReXkHpycbidVWLwMxo1AqMzN8ZT	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	606	1049	413	12463	14462	jxNtNKhox2Vz5HSLUAEzqjjJUmNAqSVNtLEAMp5KFnTsnEhUWEa	11186	15751	15751	1618774380000
22351	3NLSAhErBFEw3kh8YLyCaXvRMEAKZRopQrHXEubYZpyr366vVWYC	22349	3NK4YsHD7f27evqZ79mQYAkVYNZQMn7ysWti3HKtS8chzyTTCxpV	1594	1326	413	12463	14466	jxtRxHPNZDhDRZdtRJkPS9AepXaKHbBXw9NgqcAYAopH8nCTD2L	11188	15753	15753	1618774740000
22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	22351	3NLSAhErBFEw3kh8YLyCaXvRMEAKZRopQrHXEubYZpyr366vVWYC	1406	1393	413	12463	14468	jwzFdws39pwjiojzVLiBfgEDGY2xfdB3wK2rzkgAfavd6i5PWQP	11189	15754	15754	1618774920000
22360	3NL7c8RvjK8EgHDoMrYfsXf9g6SyPsApG68xqbmqH3jxsZyad235	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	1405	873	413	12463	14475	jx8cBiZzVUX4ZQYPabLPfmYraWaVR9b6n3rimQPZ3YrRZ6aF3Md	11192	15757	15757	1618775460000
22368	3NL2HopYXULN3F7patqM5xCbFTf4xTEnXeMBpPHEamttbuznoJUH	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1476	1245	414	12463	14483	jxbP3wZA84UKvVKYgQTGUPaqWPTvVpRYFkzcJsVG7ordrjbkHtm	11196	15764	15764	1618776720000
22372	3NLQgskBBr7k5JNG6bfvBFxbje3WWWwPkCL717feAz48S1NHe6YE	22371	3NKM4bacwZ7q2GHj3NAN2V3bv3bPD5JMabE7ykEN6LVQXqWgLyTF	1407	1395	414	12463	14487	jwd5cu86JEyub61Mw4vyff1TPmFuNCkfwUobsrTLfTfkL2HhdUC	11198	15766	15766	1618777080000
22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	22377	3NLKfi3P4zEMWAFCqPfTvXWcnE8qPCADfstK5u7rCYaYt9rHoty5	1631	794	414	12463	14493	jxsd8vxgB8anUgG3cdYux2h8nqMHDbkSaTnVxgSJTEYYiXKaDdB	11203	15774	15774	1618778520000
22383	3NKZ4J83LssQihtBg5P61PbNzeT5nmZkHCsBaD8DA7xg9zxkskoD	22381	3NLHgBdvA5eNkqmJhLoYyCXPT4zqqe1bRXGU85eyWDFBkqFYvhpK	633	1384	414	12463	14498	jwpcLphEhXA7TBEAtM9JFXHH7yMNdWJT2yWLLBXS9v3ZdMEWKXv	11206	15777	15777	1618779060000
22390	3NKW9CUrTfHNDgTAnT17pE32KGPo4yF6b6YpNZbhuxx4P69V7Jzk	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1407	1395	414	12463	14505	jwSF3wKYgRSsz8q2Vbyn2ja51aEtSC9Ky27k4cUZRYPQSV5wpVW	11209	15780	15780	1618779600000
22392	3NLU5zaAxV2vFtpwPC7uxwtAD78CxM3n9qG9vjd16uAaCdvy42vf	22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	632	1382	414	12463	14507	jxrdm8dDcnb8DfRjondb8TL9v4xXtmmhGRuHeM93Qyg26k8Jmfh	11210	15781	15781	1618779780000
22394	3NLUcbWiDYv7c6oBoXy8NFuJcFJFf4q1mVCL6RPxokzJVnRuzEi3	22392	3NLU5zaAxV2vFtpwPC7uxwtAD78CxM3n9qG9vjd16uAaCdvy42vf	1594	1326	414	12463	14509	jwymBjT3uuPxA6hFyXJLezN74mwhqSZ3H5SC9zn2ZvJ4S4smibe	11211	15782	15782	1618779960000
22397	3NLFAQuPHb8v7AJhVZwowLWpGDQJdWCgAdWJY6LQUwkwx7i1HKbg	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1448	1065	415	12463	14512	jx9o2qvf8sKkPfcpbZaXzxs7yEz67pNTaPBywJBZkE3Pr2qBYvT	11214	15786	15786	1618780680000
22400	3NLnnytvrPiuoPhdb57gsfxjvBM9JT4pFhCjtEUq4PMhz96C1z5r	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1448	1065	415	12463	14512	jx7Gpe6Dxz7TdYfQsHiW6zd67tohuVx7LDpw3wtd9X9w9NsCaHZ	11214	15786	15786	1618780680000
22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1573	1192	415	12463	14515	jx6CEXaHw1cxyuUbbTJqHVFK62YXh1xG2bAHiZ8e7QYSG4oxP17	11214	15786	15786	1618780680000
22409	3NLfVcPjbf6fSBRgNJz19QU4zeUNxX65CXqNi5uMx39a1V3cw6cZ	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	369	1066	415	12463	14522	jwQDjHfHdYmegX4Vci9XyFkXgc7zUByuJFmpyiPR7jhEcwnbhCi	11217	15790	15790	1618781400000
22265	3NLbbT3faH2kyLfGi9Nw7ELBLWj3syBbqSWMBdaBDE3Fvu7LwURt	22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	1579	1389	411	12463	14387	jwUutWWHqUNboeNiWGCoHXN8bkPiUk7huiUdJnMmBxDWtzHbAXr	11143	15687	15687	1618762860000
22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	22265	3NLbbT3faH2kyLfGi9Nw7ELBLWj3syBbqSWMBdaBDE3Fvu7LwURt	298	1062	411	12463	14389	jxV1digJYMp1yYy9CMhfEWaSTkqWZx5BDVrDDWSj1wjTnNULdJB	11144	15688	15688	1618763040000
22270	3NL6ZAQEmNeJnVbNyGhomRdH1yZ49qz7h7ZsBhFHpWhUZKvzAqzW	22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	633	1138	411	12463	14392	jx2pgmbGs4gmc4JmQhZavWYkhDehM66cDCJJCFoRjsZe9vXiZcL	11146	15691	15691	1618763580000
22273	3NK4sk5MDDGwCfpe6kLS27cHm4Gk9E514YMiuRBD7JE3z9JmMBVm	22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	1407	1395	411	12463	14395	jx56oP6P5DRcR4LUQc6njFda96oai9q9ApDaW1UkrjmUb5QVU9o	11149	15695	15695	1618764300000
22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	22276	3NLBXkm7QA1yQgbV1egwkJKzvA3ZWVgRZKyM7vGSV45kCm1hmyYB	1406	1393	411	12463	14400	jx58Kt2iSbST4bRUBHZCdqqZ731CQvpqjsu8uYnMMpvNoxSDCSz	11152	15699	15699	1618765020000
22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	1406	1393	411	12463	14402	jx84GGRSqaDuWxmDQdh7mJmwanzM8Ap24hYnntAhBQDMcXNuBSj	11153	15700	15700	1618765200000
22283	3NKeTG5e6VZJgqkQZM9Z1Hi6QdfD29Hr3D5tQxJUyBNTxPjssBY2	22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	1506	1373	411	12463	14405	jxLvkZqu6c3yiaWaPyZ6KFTdXsRZwNyGkmFBETNMgzVpgZjVvF2	11154	15701	15701	1618765380000
22288	3NKSuVxpR374ZRumNtYPzDymkwcSPEnrZZ5K3rnxBxfgEKJuNZfh	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1594	1326	411	12463	14410	jxbfUxUpGynJr48xWxVJX5tVGnx5FocgBBwtnESVtaqvrGhxaF6	11156	15703	15703	1618765740000
22290	3NKcExRePeUaWZiQxvSVdKDMUVb2MTm9pJYuSVMNgVrDsnTQCobV	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	1406	1393	411	12463	14412	jxPagAsxfdDrs5w8RmPGqqy6MjMLhvCuG2evjmYfhRgqMrWKSu6	11157	15705	15705	1618766100000
22295	3NLm9t1sk8NqVbz7CCTLraA1H5hBrK7Q5JFS1Mk7bG4ba4Kha1pP	22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	171	1374	412	12463	14416	jwgn6sFUNs4ijxsFqu4ZdNBvDafY3AdPP6p5SgtHiGJDppcSdRy	11160	15709	15709	1618766820000
22300	3NKHPKi1D9f1u595qM7AxK5zXURNGanj8y7EmSemncoQF2bt5Zh4	22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	1406	1393	412	12463	14421	jwhzi8ZeGZTcyxRdM4ZjiVh69FjHjKF3qZAHqBy9SV47U1j3PLM	11163	15715	15715	1618767900000
22302	3NLcj4ofBsUpJt4YHfgWdo5SUhpoLR2QYszPYYtxUShYuau3HiBZ	22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	1483	453	412	12463	14423	jy2fdzTcKiZWEnw6yYK4Uc2ASVEYsATJJfN3XFzBoReRfGwgBuo	11164	15716	15716	1618768080000
22305	3NKEJwtNgd5nEJ61iiwte1wqsjpeVEPJczrj6G9D1pf1gV1fenhA	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1467	1010	412	12463	14426	jxNFrQf2NwLHGYEG2DFqGGjBx2bpGYLQBK6dKFRmyJDCDRV9ifQ	11166	15720	15720	1618768800000
22307	3NLrWTNFdig1G8mKPGf7gEewhwUeBe6wqaFBgT3KVS9cXHFGdYLH	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1578	1050	412	12463	14428	jxWKuPcW6mwNQqcm6fLbtFQYvb3XQ2LJqYWzTEBoB1yQwfekzJ8	11166	15720	15720	1618768800000
22309	3NKr84ueCwbPCPfjL7QiU6na6UbQzNwxo89h8MJhQebhBPKHUd14	22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	1607	1222	411	12463	14430	jwPbSXbGZrWUCEgkHEXJP78vQv3PKqePUNKZWJNzVP8MTkjhrpA	11146	15720	15720	1618768800000
22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	22311	3NLMUhAcMvdE1ny1xuRSm39XVTna2TrTrgLb9tnFg2XMmxbb12eV	1403	824	412	12463	14433	jxSnfjtzyonn7Soh4Sng6uQQXB2oBjLyHkYQxbC8pyiATxMVU7D	11169	15723	15723	1618769340000
22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	1634	1085	412	12463	14435	jwH8hZ1KwAVnbjvVAvuC87RrmrAwYGc9LRDVisrkkFuYHYjjY19	11170	15724	15724	1618769520000
22317	3NKtBkr7cTCWNi6AjKKGaj9sXWhu6KiUGRNVTY9EKsYA9MkgXf4H	22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	1623	839	412	12463	14438	jx8i7q8mhpui1NtFu1xJkV427VKbGL98r3HkAUiPq8t5Pih5dr8	11171	15726	15726	1618769880000
22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1403	824	412	12463	14441	jx5NCoPauEP3TMLPphogBFHbx85dRc2uhPma6Eq6ZADNnjk8wjc	11173	15731	15731	1618770780000
22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1477	1224	412	12463	14443	jx7HrJXZhDdSzgy6HaxXJ5HLr9DvK3j8YRSYsWhP4JCcnR5kcB6	11174	15733	15733	1618771140000
22329	3NLAAoqWW2Dkd2ZnBVH6RUPjABXoqc4psYDhXZzwpSsedsfH47Ru	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1649	1257	412	12463	14447	jxsymKjJMP6BKChFBjqd6c1hmBdMQUg4n5Kn5ygEUtFe14uawQ6	11175	15734	15734	1618771320000
22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	22329	3NLAAoqWW2Dkd2ZnBVH6RUPjABXoqc4psYDhXZzwpSsedsfH47Ru	1647	845	412	12463	14448	jxJVoZbzqN2Mw4YQKGYFJce1bWsg1G9g8CkkUXTAiK8YAvoiQ8C	11176	15736	15736	1618771680000
22334	3NKY9uciGyTjiHSWNaWFz7q1Vs1LWqvnW84iuvDfpzR8bEumnbqS	22332	3NKh9PUA3u1kbJZ9TjgQb627eCb6563Ku9BgwvP9maUVY89Wfnew	1617	267	413	12463	14451	jwDsc2Eje6jwUuLVapNkqQgCXDobCAkSSPQuCaQDQgvFPR5Xg5m	11178	15739	15739	1618772220000
22337	3NKuZb5pGAvcJP45dPKPrK3NcsCU9VHVAZCw6bA6QRuKkUjatH8r	22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	1651	1175	413	12463	14453	jxbecxtVpeWkFk1KNja2893nQhVGNkMn4s8s9YJNWa7SKdSM5Hc	11180	15742	15742	1618772760000
22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	22338	3NKTdtkoV6AqrDihx6ZvM6uPHRUrYDG1RJwdWB6cEeCT9c5Zps1T	1406	1393	413	12463	14455	jxS642kvgpubF627e61ufyrR2Q52sGZRftyBeQGgMvrLSobfgaR	11182	15744	15744	1618773120000
22340	3NKKGWmwz5HRmQo3ZsuYQ7wP2e3uaopFPCygLYDRjTC7M42Dubxk	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	1627	1139	413	12463	14456	jxbv7obC1CpijHxn7DcPWbHLuWWHxzZdrjdZxptELWEVM9SpTq7	11183	15747	15747	1618773660000
22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	448	1305	413	12463	14457	jwPFbn8oBDbRU6nAXm3zYRn9QQNfzHvmb3fDgjAcT3CK8Bs5Qxb	11183	15747	15747	1618773660000
22349	3NK4YsHD7f27evqZ79mQYAkVYNZQMn7ysWti3HKtS8chzyTTCxpV	22348	3NKGh3L9PC3dExigr9jmeEKLF8dCn6GJ8xRjgnQkWdhyugp7P7by	1624	1334	413	12463	14464	jwfv5SFH7sHAn26QMq87EYDMKnVrKPb3Hg4L3T4z4BaY3LmscX7	11187	15752	15752	1618774560000
22352	3NK6K998PNu4xXzVHU1jzxDcXi9K1pSGXEf7pcgqR1guyZ5qPyM3	22315	3NKgUhpPju6FqZ9BeaGAfmLyFCDHz9QtJE5iDeke2R9mSxUjnCDB	1553	776	405	12463	14467	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11034	15753	15753	1618774740000
22354	3NK6GYjJzBK1SULhfqCfVFhrG1UcNCgXivazkpUPwjFrYi8Hb24k	22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	633	1384	412	12463	14469	jwKctvyx3Uk2WbfN5W7J1ZDiKVAE1sYMp8ELtv2LWbhaB69GU7p	11162	15755	15755	1618775100000
22356	3NK3NYX4Uh3A9qqt6byNZ4SzNSMJM2Pr8DDvU41KGpCZnmymCUj3	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1529	1316	413	12463	14471	jxnjJgZ6B6M2y8xTNh68FEft6TaQVb72xsTk9LXUpWCKn2AjbHn	11190	15755	15755	1618775100000
22361	3NKxATZVMuCsKdDFxp9yr34kJLgTM9BNRaFrFYRFLdK2Mr16gde4	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	484	1193	413	12463	14476	jxJmHwRNH26v8M8pg4j5dfmhUmxpGknnSSscQ44qcTZzSbyaSmf	11192	15757	15757	1618775460000
22306	3NLuwdGgDZMy2WcmYYLgThAAT32tAwuC7y1D2r9Q3Xn7sgzWLeYj	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1607	1222	412	12463	14427	jwFgbc72uvHHaZzjLotx1rbZ7LbAY2cwse4UXiUrfB1zRZTs4MT	11166	15720	15720	1618768800000
22310	3NLjkje3EYgc3ZDk3641HA9MLKBH1mvQ5hSMZHHFNtxmhjLjFW1o	22306	3NLuwdGgDZMy2WcmYYLgThAAT32tAwuC7y1D2r9Q3Xn7sgzWLeYj	1406	1393	412	12463	14431	jxrVw4t8o4qycoZZLrms91zPiF8Ru9NAjmgCyFKEzpqVG25FCUz	11167	15721	15721	1618768980000
22321	3NKWjnGMGmCbFrAQoLUSsZgMX3mvTwrKC82Vt6LqE7BkN2fU5fk2	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1420	403	412	12463	14440	jxagik14qcoDWNPdrckeFhyNKNtVJLEhiUPNoqKbJoBFMq6hxVX	11173	15731	15731	1618770780000
22325	3NLnyzHTAdDh3723UBmY1Rvt3Xywc8jeBoPnWbnwdJEecQs2t949	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	484	1319	412	12463	14444	jxDkYZHBu7JjJURrNkJNp9S1XvqHmBq89RGAHNxeAb66b5pM8TV	11174	15733	15733	1618771140000
22327	3NKEkeBNnS7MSFz7YsreAsQHSnc31hpqL5LTpLNq2Vo2DTdudWnh	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1401	4	413	12463	14445	jxsW6dD2qMB4dqwH5xN5Cg7dH6Mvp4K8t9eWTkfDxTdvv9o2Bym	11174	15733	15733	1618771140000
22332	3NKh9PUA3u1kbJZ9TjgQb627eCb6563Ku9BgwvP9maUVY89Wfnew	22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	1457	1391	413	12463	14449	jxH54YsriHLDWPEzXzBknnk9hmDdaAXJa966crMf4iVskCddEaF	11177	15737	15737	1618771860000
22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	22334	3NKY9uciGyTjiHSWNaWFz7q1Vs1LWqvnW84iuvDfpzR8bEumnbqS	1536	1313	413	12463	14452	jxRMyYs976xhURNtmJfmnovpos8gMo699tRjNQ9rLgJ8f9ShdbD	11179	15741	15741	1618772580000
22343	3NLApGk52p3yjkW2b9eRtabDyzQLQQynzUvJAA8hC5XzyxWrBJxd	22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	1421	375	413	12463	14458	jxW6UAdVGUkfSudAHmJG1Sz4V2XwMeMzcxCSQw7W28Vbf1WqnzB	11184	15749	15749	1618774020000
22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	22343	3NLApGk52p3yjkW2b9eRtabDyzQLQQynzUvJAA8hC5XzyxWrBJxd	1637	816	413	12463	14460	jxiREwL7EiGKx6kdhWXZ1HrJCW1ZcR4rbNYPQA6py5X8ArgJyrY	11185	15750	15750	1618774200000
22357	3NLXZtMgDUeJ7HrMkA43oCShbBGuJJvfymHDvvxu9offusT5Xhjr	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	633	1384	413	12463	14472	jwvWJ87WvPsBC5nfqYMnwWz2gN1BsDwJAZtL2rxkEMvpr38Mviw	11190	15755	15755	1618775100000
22364	3NKhJ1pQ6rV6DsKcPnCLMN2PHgYEiJGqjQwkLTVy9XXUji6Scsij	22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	1407	1395	414	12463	14479	jwq5mAbD8txUpVDUyagFqvEQZbnenzLxZfnteCHk2gNZpWCQ3Pq	11194	15761	15761	1618776180000
22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	22364	3NKhJ1pQ6rV6DsKcPnCLMN2PHgYEiJGqjQwkLTVy9XXUji6Scsij	1403	824	414	12463	14481	jxMwG9iD4potpJUwgKFBSKt7GBi1Svf2Q3tTjN7MXWjNsMjcCsU	11195	15762	15762	1618776360000
22371	3NKM4bacwZ7q2GHj3NAN2V3bv3bPD5JMabE7ykEN6LVQXqWgLyTF	22367	3NL5g8gVA9ZNHdD3CwuqkL35N5L36etq2mRTQH8khcc7HQaC6SRT	1460	107	414	12463	14486	jwDUVspFnomnxMzq6UintG7bQtP55aDM6atXy7JBSEBfH2LEfnM	11197	15765	15765	1618776900000
22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	22373	3NKRZb8NviMHjBSqYTE5hVw4uaheiCkTQEZYoGVbZvpDF71adfUp	1522	1322	414	12463	14489	jwoiXCDwy774F3NtA19K8Mqz9CBQs3kNrE8YKd89X5gJftBijyD	11200	15769	15769	1618777620000
22377	3NLKfi3P4zEMWAFCqPfTvXWcnE8qPCADfstK5u7rCYaYt9rHoty5	22375	3NLCDH63xbvyruT9e5NubM7VSLXunHwixJ8McSMS5emaLHVpFJKX	1425	184	414	12463	14492	jxeBhS914cbEyjqJKFpKLP3H8UYh6JNUnGiaxvGDDJRCjPp6wGg	11202	15773	15773	1618778340000
22380	3NKBLWRtV25Yg1BD4kkhDJE8zffZUVxc5L6QYtxH9X7gfYvnpekU	22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	1460	1324	414	12463	14495	jxytRkygwLu97sYfX51k1PCoYsJA2eekW77iFhbGzLUCxMSnYNH	11204	15775	15775	1618778700000
22382	3NLtKvd1ZuPUEKNF5Dz71nxaVVFKN44czw2THyVMw8jEw4bLNTD3	22354	3NK6GYjJzBK1SULhfqCfVFhrG1UcNCgXivazkpUPwjFrYi8Hb24k	633	1384	412	12463	14497	jxYyn31LUxwCLhTCqFMcAeBWjoQW3UdcZvjZQwJmYksNJGPehxu	11163	15777	15777	1618779060000
22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	22383	3NKZ4J83LssQihtBg5P61PbNzeT5nmZkHCsBaD8DA7xg9zxkskoD	1649	1257	414	12463	14499	jwazZ7isgiz35n3SWsH41HMg2SzuwTcxkhATMjsqC92YAf4Ftpx	11207	15778	15778	1618779240000
22387	3NLD2zLnF1xjJeBSMjqvgWtkVPYEe8YdvwPt8HxQARSpoxCS48iL	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1623	830	414	12463	14502	jwMWBtHGEu2kMTZg2FnXFisatZ9iJ6aJr4neSJG3WXjPqGFDZYe	11208	15779	15779	1618779420000
22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1560	1045	414	12463	14506	jwEjJ7c2xJP4GEDfNvzAiiSBBZxziZXe3cGcyNg3S4jLyZc3tiX	11209	15780	15780	1618779600000
22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	1637	816	415	12463	14517	jwVFnWaWkdWUqskhHziHK31MT3JgEiYvC9verdCGVzQcWxsN1DT	11215	15788	15788	1618781040000
22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	1405	851	415	12463	14519	jxZcNNG5vkUoDZKwKGCWZQeEEAMB4hedXHsmHQoN1bTFZyPyYEe	11216	15789	15789	1618781220000
22407	3NLy4NRym53qoJixy5sQ5oLNc8WqK2oxP9W6RHrzmeUwSriUZP8p	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	606	1169	415	12463	14521	jwVK85YZ6QRFn92pY1iyCfCwVc9SGZXcNTMjnT9i26reWV1EZ4v	11217	15790	15790	1618781400000
22419	3NLh5tW8UshFAY1E2N5s7DTzhdvMy2XMk3W6JMDnGLyxmxNXcwos	22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	1406	1393	415	12463	14531	jwFtn46WbqKw9ASBLZwaN2hmSdbGZWSX6onscBY2UCVF9KaPGqo	11222	15797	15797	1618782660000
22422	3NLSTVqiTLvGxWd9anb9CdFYsNsGR3Bd3Pc1BfAYVSoRUBCVXWZa	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1503	1151	415	12463	14533	jwKAehaKVB7hC3cnk4vT4hbdxpoi2YV5bVLbD6ZQj1o6DvbJQya	11223	15799	15799	1618783020000
22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	22424	3NKdZMq5b8G5UwqXFoutFxZPsjk4uTRYFsYjEAmKdmeiMY9qwpAC	633	1384	415	12463	14537	jwvsgWVEVtre3JV7hx6aRv9V3L8upK21HXVFyYrp6LPRJTq8y8s	11224	15801	15801	1618783380000
22434	3NLACG2eg5D7H1LWAomeoM2s2rykS3BR9yEgmdPm43SSHjXArVzA	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1624	1334	415	12463	14545	jwB2GsRCNBZuvvyYDJqofZaZW7T6xjg71uEhhqGSfc1cE4Jw7F4	11228	15805	15805	1618784100000
22435	3NLxZkcBEmeLSU96YHUFEDxyTEbd8A7CESsJ877hEhuSG8B4Y8ie	22350	3NKiELNcXctH6BTUN2HsnMzcqc77xfQs5NdvpGPmyaDSJVAreezk	1624	1334	412	12463	14546	jwn6zKJaA4SDsaanra46UhZ9aP7Hh2SQ3onKQqA7aUkcfE5Pccm	11176	15805	15805	1618784100000
22437	3NK6FSByGZYSvbh5zb9bkmPRoiBhPCMnjKYEMUAWAnSh8zJnM5Hb	22309	3NKr84ueCwbPCPfjL7QiU6na6UbQzNwxo89h8MJhQebhBPKHUd14	1607	982	412	12463	14548	jwxCMDSbSk2ALiNWLa9D9yHQDQtaMBb9bxZqBQv4CRkb3T2tJDv	11147	15806	15806	1618784280000
22440	3NKy9kMb3Zd1L71bwCNYBJsP78qqCA4CdNeit6XgC5qoKCDZ1SqY	22385	3NLRbd61CMu32ngBq4QXPQD7soViawAGohwySQDtJDysCYaLYne9	1601	1142	414	12463	14551	jx8dCuSrQJjyd4ipAzDQLeoaJFyTyA15D4dZNy2FagVbHG2dSoe	11209	15808	15808	1618784640000
22442	3NLg31YFB8c7NzYy3RQbjNQypA3kps8UWREKr32GvRHYD6q6M89G	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	149	1037	415	12463	14552	jwZeVB324xuR2sKYYuG9rrvZAxKvd1gEWqj9qnaAdWuAQ7zd8ce	11231	15809	15809	1618784820000
22444	3NLvHJ24bGxuLZ3JYHYUTr36vBv8eqAe6oACfdnG7KNwDLV7RHEM	22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	470	1183	415	12463	14554	jwY9CzFijkGwAjz22T325RyBhbGtKxRsX91iLgKYyaRUsFQce2k	11232	15810	15810	1618785000000
22341	3NLTjapkcLs9QbaxKoJjVxpU6wVvxm23HGgMV9cjkj1bXEaokmGj	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	448	1305	413	12463	14457	jxrH7BTk7UfD3z4tobzRGccz96wvqdF4wjCyYgVZBL2z4K6UfBT	11183	15747	15747	1618773660000
22344	3NKGkRj5AsAYKmq3W4TvXMGXjL5Eq1H6SiJfdsGFY2U67JAYTRhj	22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	1588	1392	413	12463	14459	jwz5oqum8dAhZ3Bw4EvrpgLMBcXWSCtTTo4NixdwkgUnxJecxXE	11184	15749	15749	1618774020000
22346	3NKCpNW5w8n9bHCPCKywosz3F1pL2FDXrPhVzJ3wP3kwgxLW1xqf	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	80	907	413	12463	14461	jxRTnbKvjgEphWPfHCzRpYygbatXYCyBvbkvoyc3mdLBzyuZyDm	11186	15751	15751	1618774380000
22348	3NKGh3L9PC3dExigr9jmeEKLF8dCn6GJ8xRjgnQkWdhyugp7P7by	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	1507	1034	413	12463	14463	jxU1iAPDdczkCcCAuZGhiKAcvo2X8RRxD9aFCK3AaR6fz2EDJgp	11186	15751	15751	1618774380000
22350	3NKiELNcXctH6BTUN2HsnMzcqc77xfQs5NdvpGPmyaDSJVAreezk	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1624	1334	412	12463	14465	jxHcQqLq8aQ6AWyco1DeYxok3aqwQeS9WgKJAQacFEiMW21waKe	11175	15752	15752	1618774560000
22355	3NLV8Vv32rScpPLdDvjfwewgppCF4srjy4bvM4B5CADVAcmymf1u	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1406	1393	413	12463	14470	jwYoSSgGuToHGkCvh2BM94fHe8mJFgUUuR47ut5gc5PVcGEc2CB	11190	15755	15755	1618775100000
22358	3NKWCtHdMWTSBjNqtwRtM8EC3LcuFSX96cdrQLAFwqp23Vcfi7xC	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1455	1206	413	12463	14473	jwnENgyToyYZBenb5ZevGuJwoonGDPL5QmMyb9nrNjZbgVLjC17	11190	15755	15755	1618775100000
22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	22357	3NLXZtMgDUeJ7HrMkA43oCShbBGuJJvfymHDvvxu9offusT5Xhjr	1501	1114	413	12463	14474	jxJs1ha1JBbgeXwc2RQ7WRtFZkHfA3xQCUeYZdbFHmVraPiPD7V	11191	15756	15756	1618775280000
22362	3NKPyG2zbG14XR5687oqCSAjrSJ3FFh5zpJ4fnmeUzQN8Ryky8xX	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	1593	1346	413	12463	14477	jxfHJ9AgkEWvxV3MvGsXWcQxjEJmaykkAzn8hNiZ8UskRJZK7Dd	11192	15757	15757	1618775460000
22365	3NKe1ZG33gHjeZfvLpzRiyoAaCkpvG8S9vNGczenaxZokNAa1yXB	22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	1559	1353	414	12463	14480	jwWhnGJ6rFBij3FgzKtEiygMLVQdggzoPdToYFh8tTGaiWoifxG	11194	15761	15761	1618776180000
22367	3NL5g8gVA9ZNHdD3CwuqkL35N5L36etq2mRTQH8khcc7HQaC6SRT	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1403	824	414	12463	14482	jxeVznro6dyMbFQZS5Zh2Q4qz45da5JsC4637VUBmpHh26uLRmu	11196	15764	15764	1618776720000
22370	3NKqbhs7GLG13UcRhk1cXN2h6Cckd2yy9r6yiATCooa5pFjaiiRf	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1581	778	414	12463	14485	jxySNvUp6ZArKCarbWYRLRHSNeS8ZTuKrAYVKmQhGsA8SuFFQwQ	11196	15764	15764	1618776720000
22375	3NLCDH63xbvyruT9e5NubM7VSLXunHwixJ8McSMS5emaLHVpFJKX	22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	1457	1025	414	12463	14490	jxagmzqC9aZvFMJ26aTQZdf5Hg1gNeukMZvvwWMy8iV8wTZad8s	11201	15771	15771	1618777980000
22385	3NLRbd61CMu32ngBq4QXPQD7soViawAGohwySQDtJDysCYaLYne9	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1477	984	414	12463	14500	jx9Wn29RvK5RnNnubDHgVxFNCGqi1FCkVLi8KQtEDmccPWhDEJ7	11208	15779	15779	1618779420000
22389	3NL8MqxsSbhK2K4dYj68Y6vKnLsNhAHYj13dT3mCa2kWXq6oYdQR	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1588	1266	414	12463	14504	jxZ3qsnT3mnDMDWHZC9Ha2EyKkADtw7wmiQmt3xYBZv5wy54Cmf	11209	15780	15780	1618779600000
22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	22395	3NK9JYo5eVLYnorswqf7qxtLQWkTG7TR9Y772TfB5rnK3ufLJi7n	1633	1264	415	12463	14511	jwM39h8zW3pEF9xDvR8fxmKH87UJzAwzmWMXQ7g7Vb1c1dKB2xU	11213	15784	15784	1618780320000
22399	3NKVpfbzN7sh97EQJ5fgeAxuQ74FizLXFL7pYJYwP83saHCJjvNq	22249	3NLGkhJ3SgVUbXieh68gobTU4aT8qBVu9Ge3cAY157Q8M7tqMNra	1516	1294	405	12463	14514	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11009	15786	15786	1618780680000
22406	3NK4pkcNmEqbSsekBMWmnVy8zmrff5Vt6aMQi1dC1i893Cb3mvsc	22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	1407	1395	415	12463	14520	jw8DxyZqpCqU6hGv7DqWRQ9MCDGfT4KL72kBhDF5raDQAZpo9WH	11216	15789	15789	1618781220000
22408	3NL2P17N6Pc7JJWHThq9Mr3qyKRoNQbGJ1ZGw5YXxHGZgqi6tPKv	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	606	1169	415	12463	14521	jxqsuoYjGd2jpKTVTBanCGo8a1nWcvFzWEtEQfwbL8AnihyaCgJ	11217	15790	15790	1618781400000
22415	3NKscSMBzJRnUQpgADvQYVzFskvdt22Le1tTMf9yVjh4mvz8xshv	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1547	1132	415	12463	14528	jxJkNx1QQqRH3RzG1F2SPCg9mYRfDgK8eDNrzGQ6HtzMAPwTuDD	11221	15796	15796	1618782480000
22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1590	934	415	12463	14529	jxDVBdTJwQLhXUoXx6CcdxVhM9vcPeo2bMQTVHK23KFs6fEYAZo	11221	15796	15796	1618782480000
22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	1617	922	415	12463	14532	jxRcxrndfa8oqrhMYvtt5ZJNsj3PB7SyFUzZ3FVu8arnrYup7tV	11222	15797	15797	1618782660000
22423	3NKxdKN6ueZPTQDotzHBF2oLSbGJkPpM7fSBEZpAhzeNQ5xyL7Dv	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	369	1066	415	12463	14534	jxtzygjmoqKkbm6pVxuy1YoqbodHgHsbWY3oqcovTWMNBDnHAxD	11223	15799	15799	1618783020000
22424	3NKdZMq5b8G5UwqXFoutFxZPsjk4uTRYFsYjEAmKdmeiMY9qwpAC	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1559	1353	415	12463	14535	jxG8wVpX8DivsKchjqmUfRqghVYJR1PMKmW6RD6kSVnpuH3e89k	11223	15799	15799	1618783020000
22429	3NLV7PuHuGNFamWbQUgVq1GekevoqQgGRc8dTvDA7WW6DeomzRqZ	22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	1573	1072	415	12463	14540	jxLziEZF4Xj8s1yfQUgzJWGLfVhtyosF66YMp6SaaFw9Bciw4WX	11225	15802	15802	1618783560000
22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	22430	3NKfaLndFdc8cajJ3gGkMBqBR7v7yFQLSqBazu8eqQYzTdsEhMvu	1654	974	415	12463	14542	jxymFzrSZ5STv76H8ijeoXXF8rLYAMwBXaGDG1ktZFJGx98VxhL	11227	15804	15804	1618783920000
22438	3NLhjtUbyjuYeWKJo8i6Wo9yMFFqgkYfynNhwE4vUKYrVipsVgGa	22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	1506	1127	415	12463	14549	jwBgkxnYb4b2ZuSJRkp2KEJPux6xBD3bqRsQZpWvzHWMQ2miMeT	11230	15808	15808	1618784640000
22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	1652	1189	415	12463	14553	jxBZC9wkqk8cJhvxrecqVPNjULkS3kqDC1dM9LouBsB3TwKfeyp	11231	15809	15809	1618784820000
22450	3NLtob9pVQWm8zFL7r4HNfj383cAtkJQCU4VgjSF3FWrRAjS1wTs	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1637	816	416	12463	14559	jxmMZ6EVjC7VY2HG4PovXaFscrr8L6zsYiRKvyoZvbn9WXSgT7R	11234	15812	15812	1618785360000
22452	3NLqpBar2wyxeoWrYD26RowJWy8uaTPbDuqGdARbd5HT8qEU1G1q	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	1407	1395	416	12463	14561	jx4H3dpYxFZLSLdKUKPUagvBhSQtoPmzxeAPQhMrev1C2QAfFsD	11236	15815	15815	1618785900000
22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	1441	65	416	12463	14565	jxFgRPMXeYFopjtk9GaZGenigy6EQFTRdvyuXtbKmPWPfBEteJY	11238	15817	15817	1618786260000
22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	1506	1373	416	12463	14569	jwsX3djnh9UnZjVCzFFsMTpKT4WK8e8W4TbmfSHw1AHBCANQajo	11241	15820	15820	1618786800000
22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	22362	3NKPyG2zbG14XR5687oqCSAjrSJ3FFh5zpJ4fnmeUzQN8Ryky8xX	1419	814	414	12463	14478	jwpmeSLycRQJ49FSuiaAiC9uQ9JiZBsn4D8GZXFtTxUjAq2ZZMU	11193	15760	15760	1618776000000
22369	3NL5dnw9rCuASfWVpqboauNBcSFw7JijVnRqdcdhuz81pE28LUy3	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	44	708	414	12463	14484	jwhHBAMY1uLUQNuiwqAw3yuUUWHkNw1HagbKQqRo6ABCGkzf2Jt	11196	15764	15764	1618776720000
22373	3NKRZb8NviMHjBSqYTE5hVw4uaheiCkTQEZYoGVbZvpDF71adfUp	22372	3NLQgskBBr7k5JNG6bfvBFxbje3WWWwPkCL717feAz48S1NHe6YE	1407	1395	414	12463	14488	jwtJYbiHzu6Ggri8GEBSZFZBu3Sek7QxPBmFx67caT8hTcD4QJ8	11199	15768	15768	1618777440000
22376	3NLwAuwUdZG76hxCd66uLAEd6kUxCZViVWzEMZNKUCjDPoGoEgsZ	22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	1646	1108	414	12463	14491	jwV2uyUQFf1Q2BJAm4PyBvggShY2AESj7yWxcegoRKBim5LZ5N5	11201	15771	15771	1618777980000
22379	3NLn9gCXH932NegHwstmeZxJZCgTfrtfbeCUd3BqCVy5EqAdZ79y	22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	1407	1395	414	12463	14494	jy1uhfiJ63n6memBWxU3wKq9Dz1E578L5XnJzHaAEXn3Rs1ttku	11204	15775	15775	1618778700000
22381	3NLHgBdvA5eNkqmJhLoYyCXPT4zqqe1bRXGU85eyWDFBkqFYvhpK	22379	3NLn9gCXH932NegHwstmeZxJZCgTfrtfbeCUd3BqCVy5EqAdZ79y	1536	1313	414	12463	14496	jxPWG4VgVMJ99hVkJKHd1ZW5ephXyWXq1q48X21jbhNyH4YxWtu	11205	15776	15776	1618778880000
22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1608	1043	414	12463	14501	jwiMqgy8rqUDTpftAARg5Tx9Eh8bKaYzJwuTHNsi6fgCHNbdVQd	11208	15779	15779	1618779420000
22388	3NLW7LVMAAhWSab13U3s2Q9vyaNgCHH4e6f3cpeMxJP81ptn8mJz	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1608	1043	413	12463	14503	jxafMUY2VRqM4WoHenP1Yc5EATVUa6Q81FEt2KndNHPDxHWayKq	11190	15779	15779	1618779420000
22393	3NKQJsMw8gYzF41p58rt4DEk3zXbfH8uScasVpEVfjrpMMQg2GJR	22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	1581	778	414	12463	14508	jwUfP83AiaWR6kJLM8Pip9jZWiVSUg5gSrtXaJ9XjscizKru2Ju	11210	15781	15781	1618779780000
22395	3NK9JYo5eVLYnorswqf7qxtLQWkTG7TR9Y772TfB5rnK3ufLJi7n	22394	3NLUcbWiDYv7c6oBoXy8NFuJcFJFf4q1mVCL6RPxokzJVnRuzEi3	1458	1197	414	12463	14510	jwAeHi89Pm7yKJTy4PwiTWzGEmJcHfyKW26vXgFxU6JL45iC8UC	11212	15783	15783	1618780140000
22398	3NLBvZdJr3rm6knhUwy8LKznBYB1h6Dg3BR86ZDHTCSJqmmNx8Mt	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	80	1147	415	12463	14513	jwdKfxHjvN2LKpLRoa7HBU7nKThXs3gZm6QfmWocVPZQkrarJ53	11214	15786	15786	1618780680000
22402	3NLcvRs7kaEGTG71FBRuWMBcZq37D1HcddCgjLiZ4LeBsKzKWWcj	22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	1608	1289	415	12463	14516	jwx8iXNAC5RBdp3NCGzo8jVEt21WzD7z58Bz76oZfthfJFzowN4	11215	15788	15788	1618781040000
22404	3NLyNpJRGMGDX5TCHdcjQJRuscip7hM7yopSJ9w59WSpsmpJV75z	22388	3NLW7LVMAAhWSab13U3s2Q9vyaNgCHH4e6f3cpeMxJP81ptn8mJz	1608	1289	414	12463	14518	jxNSaFPmxPTTrWaDpgFYUKuiaAjUJgFpCqvZhYQqzLU9CVEPzZA	11191	15788	15788	1618781040000
22412	3NLKBbw8c2LngKFAsifC9t5A7MZijkQgVvmhgpYp8setAshGHvAf	22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	1406	1393	415	12463	14525	jxAWK4sJbuQ2RuXmPW4qpNzt9DSiwQN2FsKVFwaAWsZzAENEP1S	11218	15793	15793	1618781940000
22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	22413	3NLuq9HhHZV8w5KuRX3x8ZKKXDHqfmbu2N7UdojhzUCTtj7ayWyA	1534	1317	415	12463	14527	jxeQCyga5b56acAzdRYdcaLSiW2WXTKzj7a6MkLdAkTb6JWoHYm	11220	15795	15795	1618782300000
22421	3NLq1jWN6utTMzqq7CAk3aFBn6iTDBUQByKnjQ9Ra1GEAW9JidML	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1503	1151	415	12463	14533	jy31R37dUmkN6Qp2FBNRGMFUHsib5Eh5ttBzhPH8y9ZPuH83Syf	11223	15799	15799	1618783020000
22428	3NKAyYcovZM8Yq3nFT27y7CMHf8tV5pmSAKk647bqGyDVJ4iB43E	22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	1406	1393	415	12463	14539	jwnx4BQUscCmgMsXUUTYCseTax7XJYL6AB5dyw4ZtkaL6qJzCDP	11225	15802	15802	1618783560000
22430	3NKfaLndFdc8cajJ3gGkMBqBR7v7yFQLSqBazu8eqQYzTdsEhMvu	22428	3NKAyYcovZM8Yq3nFT27y7CMHf8tV5pmSAKk647bqGyDVJ4iB43E	1654	1340	415	12463	14541	jwDbvgP1aRLiKLS1Dnu2NnJQQ1E3hYPEk9RqeGxMqPY4XgWJVmi	11226	15803	15803	1618783740000
22433	3NKWyphEV9P6Zs2WAoLhDJ8xannPqUQecbwmaG61cYnFPedFs5YP	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1675	1342	415	12463	14544	jwgcFzMQxfGNjHDRkfeqXyunUWvWMeGFJEYgVTisMdEq9aoyDUd	11228	15805	15805	1618784100000
22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	1654	1094	416	12463	14555	jwhm1CQjhfTPGf2nzJw94YZ2tj59GoNCbmfQKgzuVhZUm8KnR8Z	11233	15811	15811	1618785180000
22448	3NKK238jfhHtEr4JQw3d1GMTUdHAEka7at79dwzUo5MjzXcF21vh	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1407	1395	416	12463	14557	jxyKg2pqibb4XBL1HnLUPVMqDuesb7rWzPtR1z9h7cP6EGpJUqX	11234	15812	15812	1618785360000
22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jxs9LQnUDRwj7FayBsGie2NKqNKUeMiFFDfiTptLYWcpGD4FWDE	11237	15816	15816	1618786080000
22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	22461	3NLToKjKZspubwehCYkxXdFzCZW1gBMrpHX2RHfXwQSA4tXWQUWe	1650	1375	416	12463	14568	jxbCVuUtaaBaBdPsieeuH2zx3Cib4wVdCmm2EteAzok8CQM3uaW	11240	15819	15819	1618786620000
22467	3NL7Yn9C2CJp1VEiJFYNRz2hiSxnctAC9FuBmgPUHhehwKUsQ7Mi	22296	3NL32rVqn5weF8rYSsM31HRUhMihMPT37oPjX7SWUrcd3tFTYGFv	1509	1074	409	12463	14573	jxfPuQh6yc7zXaJEVAtNwgNePkCrjjWzD72pHYoCNGYJ8T56tyV	11093	15821	15821	1618786980000
22471	3NK9qei8qV1aFPw9AaDrwyZhHJMVAohi6S5a3MQWQ6MXwDNfNNeB	22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	1471	1386	416	12463	14577	jwNGd7gyGBY81cRxhm71YFU3Lz7XMdKcnxPsr3r75NN5UbvENVa	11244	15824	15824	1618787520000
22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	22471	3NK9qei8qV1aFPw9AaDrwyZhHJMVAohi6S5a3MQWQ6MXwDNfNNeB	1406	1393	416	12463	14580	jwYW4XQwr5zsn7fPM4kLDsnDtwmsQEKKf9iTDAcfaLUsBFNWfU9	11245	15828	15828	1618788240000
22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1585	1120	416	12463	14584	jxHj2FGfVJW4LgaUKXP9Ms3Tz1qNMJNSoidMBBfT9vQLALMQFX9	11247	15830	15830	1618788600000
22481	3NK6kysJvQEbPp6Mz8zXKWsrdCznx2G4ZfhEz3Ta9hWBa9PB1tb4	22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	1406	1393	416	12463	14586	jwybBaivCp8assPd8WKpEr6XNLZhWvvwjfA4fK4xk8zWSv7Abnp	11248	15831	15831	1618788780000
22486	3NLEuWt6utDdxVEuSYPoUiSaqAYBEyddFBaaK52tK5wnQEqhEowp	22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	1541	610	417	12463	14591	jxPpLn2EZGwCLz76rhAj9FBA9VWygsx9t46CRwskuh3BsEf2fJq	11251	15836	15836	1618789680000
22489	3NKNzn4YDCmp8uoCFTt8d6gcSETcjVDUQUnEGwMbw6ggne5Z5EqG	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1670	1156	417	12463	14593	jwNnF7rFdCQ4NvU37t6Y8cYZ8n2S3fJARZyZwxxnwC3wW5LAJY6	11253	15839	15839	1618790220000
22492	3NKHPhtK5sVn1UXoc3m4wtFWkPZ7gz8tnBjPAwahyEDLPYzj5PFU	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1407	1395	417	12463	14596	jwhHQzKqHgimMTQmAJqoQn2b5D5WXR7e4sxdRxU2bATcoZYneyK	11253	15839	15839	1618790220000
22495	3NKX9gwga7aubRE3hAhe4J1kzEL82PbpK63Lp5zCZcJkxeCY5bP2	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1439	482	417	12463	14598	jwKESLaXJE9EgAUQh4kVSFRRsehkrLSYXvLWm9QZz4FxN8r5cjS	11254	15840	15840	1618790400000
22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	1406	1393	415	12463	14523	jxyAE7wHBHSE4FJFGr58JWjDSYaVUHmDoJRGMLkkLvcevt1iucf	11217	15790	15790	1618781400000
22411	3NLEtwFY6B4VJMjxoK39sQhzERXvakri6QrkKgfparmFWxGQgxJx	22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	1542	938	415	12463	14524	jxcfYRPUpa3Xu89W8NKQn1zu5y1RDVKDmVDN8Nr54uP8KPPdbxD	11218	15793	15793	1618781940000
22413	3NLuq9HhHZV8w5KuRX3x8ZKKXDHqfmbu2N7UdojhzUCTtj7ayWyA	22412	3NLKBbw8c2LngKFAsifC9t5A7MZijkQgVvmhgpYp8setAshGHvAf	1476	1371	415	12463	14526	jwfemQACbPRGA5vmDER52Tc3PQDg5HCAUAwhYZVAJAfSk69aS6C	11219	15794	15794	1618782120000
22416	3NKoKdXuagGjKYPcN9qZSNboocPnfDKwdEMs81co7REXYqdEiYQ2	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1547	1132	415	12463	14528	jx9EnD2i1yeuD9aGdPWRBzrF1r2Etp6HLWsH8ywR4zymwsM45Vd	11221	15796	15796	1618782480000
22418	3NKgHS7jGZtJzQ94jCz11ixCJkRhkPEMU7doyo1kT1yRfzCsX85Y	22407	3NLy4NRym53qoJixy5sQ5oLNc8WqK2oxP9W6RHrzmeUwSriUZP8p	1590	934	415	12463	14530	jwLnU6cagj5Zp5e3pYr7SdFyvfHYGv9DFXbvSKRLTmSxSpeAEsy	11218	15796	15796	1618782480000
22425	3NKyywxxN6KqSiXdQVsPium6EN4R8Btc43AuBh5m1XptZN8CuuGq	22382	3NLtKvd1ZuPUEKNF5Dz71nxaVVFKN44czw2THyVMw8jEw4bLNTD3	633	1384	412	12463	14536	jx6jdWcZryF2EpxsgVw1muyu55Fo8TeN5wJiAf7mH7moE2H4JvQ	11164	15801	15801	1618783380000
22427	3NLmtyXZU2Ahv52gJBgoMTMxkVERh82Br4hYRNSSooMoFf4YkvYd	22399	3NKVpfbzN7sh97EQJ5fgeAxuQ74FizLXFL7pYJYwP83saHCJjvNq	1516	1294	405	12463	14538	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11010	15802	15802	1618783560000
22432	3NLWyTpR3HGKrjL1htCXVjnHSt9ZET55aC23scxQEpqNR8n3asnu	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1589	920	415	12463	14543	jwq68CKshrhQ17wSKG9PMMNsS5XDgFS5gqaVR94qvfmf5BdqD6H	11228	15805	15805	1618784100000
22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	22432	3NLWyTpR3HGKrjL1htCXVjnHSt9ZET55aC23scxQEpqNR8n3asnu	1607	982	415	12463	14547	jwr1xjaVJAV9aQWj8uAYEzTLzFRnpXzU11ebpFNv7vaXVBVUNou	11229	15806	15806	1618784280000
22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	1601	1142	415	12463	14550	jwU3F3drFASs7d68Xtiuo27waNad9tE93xcknfctNuz9UGS91ox	11230	15808	15808	1618784640000
22441	3NKk9wWHhKMVNGUrr5Eq2A3uLabuthPLrhsRVqKZj12cr6i5K8HB	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	149	1037	415	12463	14552	jwXkZ62Qhd6S6cGTzB99yvdnn5EBHuGJunzA8gtJPjJHTvw5eLf	11231	15809	15809	1618784820000
22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	470	1183	415	12463	14554	jwY9CzFijkGwAjz22T325RyBhbGtKxRsX91iLgKYyaRUsFQce2k	11232	15810	15810	1618785000000
22453	3NLRL8RHgXPT8USbBgewTzL6aGkppZrNeEWKHwQDZeUfSBB8D2dm	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	448	1305	416	12463	14562	jxmF4NMzX3sb37ZMnKoL3uZTjYcwfUXG4E5ZnLDhB22kuqWaT48	11236	15815	15815	1618785900000
22457	3NKr2A7KmJmMzKwQydapxPWLDHWhqM6PtKkD5SWc9n5dqHrVpc3j	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jxsJntsfB2Yune3vbQM1Hsmpj4NHmyBrdtm98carMsbzkuCiETq	11237	15816	15816	1618786080000
22461	3NLToKjKZspubwehCYkxXdFzCZW1gBMrpHX2RHfXwQSA4tXWQUWe	22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	1581	778	416	12463	14567	jwq5zXNyN6j9znMpdBfDgrJB5QYYNMSVKkGgX6RsxSoyXxkdzhp	11239	15818	15818	1618786440000
22464	3NLrmTbMwZGtc1zwadRuUfE1fzKBxvbcUWS75d95VgLuHeJ5Tvog	22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	171	1008	416	12463	14570	jxzt2RDfWHeqtzWfFYqDMChsAX9ksye3ypCxRsQsejT6W6Hwr1K	11241	15820	15820	1618786800000
22468	3NLi9jHWPp8T6jgaWvFDMWBWLLMiTvzvZcNrHu94gs98iUj3vhJE	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	1422	971	416	12463	14574	jwcsman2GY188AqoBds3D6gLmPFwbPToKwuNfgQhVoHCXaZGKi2	11243	15822	15822	1618787160000
22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	1406	1393	417	12463	14590	jxPFHySAuzq9fqF7KN2iHLCnydfD6AjKP8RBPn2fWyNPvg4eJHY	11250	15834	15834	1618789320000
22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	22486	3NLEuWt6utDdxVEuSYPoUiSaqAYBEyddFBaaK52tK5wnQEqhEowp	1477	1350	417	12463	14592	jxdJMYt6eaPk3qJzCuB62USTcTEqXjgzSoCgGN4Qr1TyLikvCAk	11252	15837	15837	1618789860000
22491	3NLSiiaGon24aYAfPgBoRsw83e2VV6ZRM1paMyu5yJvAxkAqQm7C	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1406	1393	417	12463	14595	jwbSgMWYmZZMoF4ueGSA5fLxeDjSzyefMxTDLUADCzVBWXPGe9B	11253	15839	15839	1618790220000
22497	3NKZaURfvwXtfCrHWzaR3xzvftHzS4MSaQmoWCdU587UyVuUAoc8	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1460	958	417	12463	14599	jwPyZsXMikVNbkWdAkc7h4vRxxgGy8QL3Xyo2WQwpHYq1JoFagm	11254	15840	15840	1618790400000
22500	3NKQY3wYTrAGvSufsEhJeCb3ikLHYh2dghpJLJJz3Djg4Krna89p	22483	3NKuvJc7NtGX11dkf9Wpd6et8StuZ3epQdbgzK9qXu4vU7esmsjE	1553	776	405	12463	14601	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11036	15843	15843	1618790940000
22502	3NLrzke2MhFBuaYm4Sb2Trn5QipW3DKQmpvUT5PY47fC4yR5pU8L	22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	1541	1172	417	12463	14602	jxVCsChRePtVs818HLF1N63uTRBT7rSoWTdBCn4HQ2HLZnDWYX5	11256	15844	15844	1618791120000
22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	641	1090	417	12463	14604	jwCgXxSTK49kD2H9RFRkjCGNh21hQYDfigpzhD3uMZkJrAmuST4	11257	15846	15846	1618791480000
22509	3NLDTBvLLi2aPgpNGdYJzhWkHPAxAMenefmLVmAekoDTDsYv8a7C	22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	1555	981	418	12463	14607	jwQq7zbz9QwrNUUp2GdE3XuhqFyizuPWCJ83ZSpzZPaKv9gJLRg	11259	15848	15848	1618791840000
22521	3NLTkzgdKtQ6kfRjvq5xcjG9e2VjCYcfx2nxyUs5VXiGK6KxRu8x	22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	1406	1393	418	12463	14619	jwH5xjQ4AvYYEJ64YSv9GdK7pS3eP5FmdXb9LiAL2cVRN4J4jhQ	11266	15855	15855	1618793100000
22523	3NKn9UfRc65cbL4ie3EwJNLz9uCzv8nZgSf9xxMtrBshBquHd5s4	22521	3NLTkzgdKtQ6kfRjvq5xcjG9e2VjCYcfx2nxyUs5VXiGK6KxRu8x	1581	778	418	12463	14621	jxK3sGnt38CpuhwX1FVw1rSDoEuiAvczDy8DnfBfpNZ7v2XoFKv	11267	15856	15856	1618793280000
22526	3NKnJVnBEhbUYG1NjgCkZBR9jWLf7rYtwfoGXEzDJX5XjCc1HUtr	22513	3NLhL7hFVeyB4kN65nfBi3qDWeUctnDJqNcoGZSo5iE3FWS5exvA	1553	776	405	12463	14624	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11039	15859	15859	1618793820000
22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	1483	877	418	12463	14625	jwKjm2geWyGvraHwnnqRo7jpzS5ac9jfnGScGWRrb8w7w3XRC7G	11270	15860	15860	1618794000000
22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	22533	3NKVjjijf4mHcAc1s7miiPVgKkXXn5dw5iYYebnWZTAvVYL9vzWY	1656	977	419	12463	14630	jx4DBhPLQr2v7BGBdt8EmRcbMKvoqAdeeapcZ8xo1sihpBxTWjk	11274	15868	15868	1618795440000
22537	3NKWnUZGwJYqZV2RkdCvx3ZyoPxjrvp44xopiHqhUS5pm2wVfFiu	22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	1581	778	419	12463	14633	jwSpggJ4cbPeuiHChjJBH46SFPrbc6yd2JjppZq9jiKKxtNDZ4o	11276	15872	15872	1618796160000
22547	3NLD6sK6EHEuM7z6pYKbWMhmSAxdeFmcQzAaa9CxhB1zmhtNBifn	22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	1670	1156	419	12463	14642	jxYyZsqCPatYo5Q88fYHE22CWvWQQfFWdNL64PU5kk6KpLURqyU	11280	15879	15879	1618797420000
22447	3NLv43T5ws6twguVsYVrNkRWBEoSXPv7RXUrvp5xtHcgEpb6YfWZ	22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	1637	816	416	12463	14556	jwjejnmS1nk5XErNUfjWHPnpwzXp3B4Q8WydrvxrxJvbNXENERQ	11233	15811	15811	1618785180000
22449	3NKyeMf9DM9cCBWGojUDjubswXnZdEBnGWwKme6e9k3Vzj7WmzCB	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1602	1123	416	12463	14558	jxLRJMBVaf4cxhkU1N3vbz6WnK69ygi4zapi6oqjUsCbwfVRMJi	11234	15812	15812	1618785360000
22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	22448	3NKK238jfhHtEr4JQw3d1GMTUdHAEka7at79dwzUo5MjzXcF21vh	1407	1395	416	12463	14560	jwvWhjtkWccsBYsmRLLeiEZNoLe4gDs995JbZGCweD2VXPDB7Fu	11235	15814	15814	1618785720000
22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	448	1305	416	12463	14562	jwqC2c8qrSYP8YhJFE5WMQGEvMrs7DTn4uUdJTLxTGJLYRxjTde	11236	15815	15815	1618785900000
22456	3NKHSHps4LFuLVVWYc3u3rkciT2g6bdaw58idVXYVKX7xxA7oJQZ	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jwe5Ke2DPRsiWGm4Yfx1xHsAfXo1odRWFhPE7AY1rb8MNJ5RyLA	11237	15816	15816	1618786080000
22458	3NLcEiYteN8p5MyoMvK7xBAxpTuR81RbikQrC1ZoJ2nx23noreyx	22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	1407	1395	416	12463	14564	jwbVCu2xyhMby74ZS1Qv2BhETjDVbMZyJhAC3dEh8YFqYaLk8Br	11238	15817	15817	1618786260000
22460	3NLTPj5uCNAY5wxC2btdNradgBYNGgkWi43JRa3vTFYbTRo2LJ99	22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	1403	824	416	12463	14566	jwBpnQVaGtHZfu5UwyyasavgYix3LbYkfybrP9v4TrgQaSW1DpA	11239	15818	15818	1618786440000
22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	1406	1393	416	12463	14571	jwmN5zfzn9uPtfbrbuvRDPx8vtUK8opaZ7QV5SEqmETyEugjpbN	11242	15821	15821	1618786980000
22469	3NL9szxxFME6bBgxYQhiAYJiAceVG8edyfoHkEZPSdrXN9sckBPp	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	1610	948	416	12463	14575	jxE4j4ms8gGqTW7hWPCvY2qfu79Ve9WuqEDnpdT2gBAbVv6Ez6Q	11243	15822	15822	1618787160000
22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	1406	1393	416	12463	14581	jxQt5qgPvqjqBe8AcT6UN4deHZCNKugWx5MxopAwv6m2yXDhZ6g	11246	15829	15829	1618788420000
22477	3NKUYbwV5dBajXwJfPTKXM6uiJLYyAYF85ndCp5fmfDkYtoFwnk2	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1547	1378	416	12463	14583	jxSCzkhmjJNrfSHRsNz4WHSAWLZJKZoaR3ck2nY8ybfV9HaJRuB	11247	15830	15830	1618788600000
22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	22480	3NLoX4G4sUsTE9WEphtaFo3Q7A14FBshNw7EvRRn84vrYQgct2Tw	1513	1133	416	12463	14587	jwVysD2QQLs5WdQBM5W9J1AjqTXwA3CqK6M6TcCs1NhPmD51WNT	11249	15833	15833	1618789140000
22484	3NLr9mWdUB546CiG7tbcBkGA8La8HtUNsy31Fupa7YcvNVapNH2z	22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	1403	824	416	12463	14589	jxDuANJNjknLcF6gssueWca52rLywJBuc9BdC76r4wg4VjAygZP	11250	15834	15834	1618789320000
22487	3NLR73oWZnKNAucGSpjo3J2fVaA9D8QRnkDQZRWZFMKJCe3qahYN	22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	1541	610	417	12463	14591	jwDpTZwAnWqWRfmMwfFZ4qNQZwPyV96aVdMd7nL8LeQ1yLbRHzb	11251	15836	15836	1618789680000
22493	3NKAwCSuByctVR9KdiKna1ETZ5toC4H3eUQQvqB8e9jY5w4iqgLs	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	44	1079	417	12463	14597	jxHFWg1ewargjKwwCSPeSdLVoCQLKdKprxPVUf6vZe9ZUJqcpA2	11253	15839	15839	1618790220000
22496	3NLU557yapTEhvgixdWrZGnMPRVmDX5eBqVEnymkhTbNEUxNvPzu	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1460	958	417	12463	14599	jxHSJuEZbGDKnmLPCynakUyWNQhpY3zk7Tihu4omT5ZgSjQ2VPu	11254	15840	15840	1618790400000
22503	3NKuavwNyHvSC7yNXHfVRzAZmhZpY1wX4zdWoscNiReQEPfPbrpW	22500	3NKQY3wYTrAGvSufsEhJeCb3ikLHYh2dghpJLJJz3Djg4Krna89p	1553	775	405	12463	14603	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11037	15846	15846	1618791480000
22510	3NLa1AnV43fx9ReNtXthFrT1HABDrXQgKYb7JvcEVwnYmtxqNQzq	22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	1589	1040	418	12463	14608	jxSDQov7Gs7uAJRpvAD1FKV2S5ei7HefNM8pEy4doBJ8632K5T3	11260	15849	15849	1618792020000
22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	22510	3NLa1AnV43fx9ReNtXthFrT1HABDrXQgKYb7JvcEVwnYmtxqNQzq	1642	1121	418	12463	14610	jy2wGYZ9QUFiG8LBwjbiDsLxcfpn3tLrLL93ichZUMRUkRdH5Sx	11261	15850	15850	1618792200000
22515	3NL13R8SwaQ9S1gVFZfFyXYqbb6d28yq4cvdnSoovV53k6fu5zLM	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1406	1393	418	12463	14613	jwXsw5bqyX9XNYm2jbto5ALCA223kMosEieJqghCgnDHR2ThxyW	11262	15851	15851	1618792380000
22517	3NLNxq5GQXu1uaCVqYi1EzGoQVxaoCz4VzWrPtMDrvyMw2ruxrWu	22515	3NL13R8SwaQ9S1gVFZfFyXYqbb6d28yq4cvdnSoovV53k6fu5zLM	1657	1344	418	12463	14615	jxHgLhnFHs6MTWidxr9SBLWpMpiQ5X5YGmDdg5oVSDWvvdzbCJn	11263	15852	15852	1618792560000
22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	1406	1393	418	12463	14618	jxUJ19bFeCeFhfjGCjg4izQYeUh8w2RddWi3ApVLLCscCKxswyf	11265	15854	15854	1618792920000
22527	3NKocC1pg3VHdBwwo844NcLRqGPk2PStqyJwmPDwmuEjMmQnsWa4	22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	1483	877	418	12463	14625	jwEQG81cZmXk252ct8XAq3HPxj2DDjhv1EPPny16FJrLU8Poxab	11270	15860	15860	1618794000000
22530	3NK7UYakdwHdtWBxwuNavNCmjmnwWfwzzyqyupBXqzPQ8fa5jfmA	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1651	1301	418	12463	14627	jwydjhuz1jCNfr8KH7Q3qvuwQUdRdS7XsBvq8VaDnF1qWXib4qW	11271	15862	15862	1618794360000
22532	3NKRadiJ8c5A5q5qYhByLNF2RTQTrb2PM26PThcsZwZ9o5hnTdRT	22529	3NK4ZB5Ppz8eSNWEWmEP23MM16rjwN19wGZP78fskyB4yDoGrrsr	1406	1393	418	12463	14628	jxoaDLVgqZzDjGFmmrw4b23C87QFoKp7DKChNdkkhTJkUFPbBg9	11272	15864	15864	1618794720000
22543	3NKCBAVDz6ptYHbxhVF2pZM27aHUxCR6mwEJDZQpozSddqSZhDVK	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	43	1064	419	12463	14638	jxsE1tyf4QpTrEdgw1MgJUqKQfP3oVVXoKR689f6og7c5XsHDK8	11278	15874	15874	1618796520000
22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	22544	3NLiCGfJg4URkm3TJHFx5kpfGgWY8o2pJe4tQPsdPeRmD1QnDU6A	1507	1280	419	12463	14640	jxgzdiBWsHmk4VdDZPuTSThgQR4k2bN6mpfT6dS4SmZB2MrW582	11279	15875	15875	1618796700000
22548	3NL4mX42ZhTEWbUMntac88uezXnMtbH2rg6Ja8BefAGCPMhDKHe1	22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	1406	1393	419	12463	14643	jxwFLzH7362ZueoSDkt115cEz2q4cgPdgRhi3gnLbEDngKZ4yQW	11280	15879	15879	1618797420000
22551	3NLMn8SgaK5pyxYBMgBkZUX7SA2qwjRtXNvfCQmmFKbLSy6wviCV	22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	1656	1343	419	12463	14646	jxHxZB7b62o72CwK61awR5HeBbBEN6DXdgosSmoWSbSeCGSoaif	11283	15883	15883	1618798140000
22560	3NLEc9feZCBXJVRLvynMfLUB3qEMxfnh1UhM8Xkz6KGSjgexHqFW	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1631	793	419	12463	14655	jw8QosBQ18UbviLydheT7owy9PwgN2soHFZHvAJAW4CCpD1QtAd	11286	15886	15886	1618798680000
22565	3NKJpouKoxkdrSBjK2HEY7HLdcxaKuyF4MaBtdPgmeDsa3NKiL5w	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	311	1061	420	12463	14659	jwx3vGKe1AU2M8JogYnqtWEytDQo1TM3LJGGo2mBzPVVLm55xWU	11289	15890	15890	1618799400000
22568	3NK5W1oxS6BYvQMh1ZjngdfFjrSzA71mjthZjdX7p1dT7aWejqex	22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	1647	846	420	12463	14662	jxxmmnwiDFA2yY5pBjRkgn4T4jFDWwwLRQZpRABikpUrGVwNQgt	11290	15893	15893	1618799940000
22466	3NLmfuyeNmqSkDnYQL4jTULpMtXiJzSua6WSGuRFRm6b1t4Zkvmj	22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	1509	1074	416	12463	14572	jwutSjRVm8hqHvXCX5hRvwnNYmQE3p6Pd1B82DU361UStErsvN4	11242	15821	15821	1618786980000
22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	171	1008	416	12463	14576	jx7arnnoXPRnwWNDzf2BJVUM6UjPTsLdL71JJ55Ryyi6LpaWNq9	11243	15822	15822	1618787160000
22472	3NKXX63KgjUn95mm3DSydRqNh5FfiwaNaNjHvE1xxeMbU1nCX3qm	22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	1637	816	416	12463	14578	jxBidokciBQZUHpp9L9E4gancwtBZbMW8BcumzxrKnkCw8fyAwp	11244	15824	15824	1618787520000
22473	3NKqfFp3DCJQURnMdPePTTAEubKmzSUKLa5cSHZiuFUar9Ams6ta	22427	3NLmtyXZU2Ahv52gJBgoMTMxkVERh82Br4hYRNSSooMoFf4YkvYd	1516	479	405	12463	14579	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11011	15827	15827	1618788060000
22476	3NKaeApJoTokVCsuPWGB8zRYgqTmDdFNg9RC4fTgZhwv6Ny6WiWN	22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	1594	1080	416	12463	14582	jwPLNgt5TrYSifiKnthLre2pBS9f3H9ngsyLsQUtyikqNov3Axz	11246	15829	15829	1618788420000
22478	3NLtCURbaLVhddho17oPiMf9zPv4LQaDcieWg5kkXBErDuWaDxY5	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1547	1378	416	12463	14583	jxs1DHUDcL5DEVCSkoV7RYpdk6yKHcjHs1ejPqWANrZPWzmugTP	11247	15830	15830	1618788600000
22480	3NLoX4G4sUsTE9WEphtaFo3Q7A14FBshNw7EvRRn84vrYQgct2Tw	22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	369	1312	416	12463	14585	jy2MWm8XHuTcJkss133YqQAP5vopTVKRHXCsZhtpWcU2fhGowiz	11248	15831	15831	1618788780000
22483	3NKuvJc7NtGX11dkf9Wpd6et8StuZ3epQdbgzK9qXu4vU7esmsjE	22352	3NK6K998PNu4xXzVHU1jzxDcXi9K1pSGXEf7pcgqR1guyZ5qPyM3	1553	776	405	12463	14588	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11035	15833	15833	1618789140000
22490	3NLBt5BkoocAGhdqf4HFZ1UMRK327p2G6GhRFg5cukAvvsVsYMCQ	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1460	1198	417	12463	14594	jwFkzGBQ23JEN7zBssscZsW7ffDhhdXvHQgh6MtHXwq8JXJ33yB	11253	15839	15839	1618790220000
22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1460	1198	417	12463	14594	jxsEtzGqcpuiAF5sxCuXz3CtRW97tV9GQTvsFo8xuZ2KgJ1EApp	11253	15839	15839	1618790220000
22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	22496	3NLU557yapTEhvgixdWrZGnMPRVmDX5eBqVEnymkhTbNEUxNvPzu	1407	1395	417	12463	14600	jwras22ztPmUF443KoqLpnyTDyLyuK1UxDPpT41m96xsoqMETsw	11255	15843	15843	1618790940000
22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	1541	1172	417	12463	14602	jxpPxX3u48b1ZzG1UMbPCYW3ZdZdsNTAcS9aCY7eK3RzGGDLzQD	11256	15844	15844	1618791120000
22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	1403	824	417	12463	14605	jwZRsfppszEh5fsHwbidsreTH3QEdD4nW3uahkhgheQeiDufU2L	11258	15847	15847	1618791660000
22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	1555	981	418	12463	14607	jwQq7zbz9QwrNUUp2GdE3XuhqFyizuPWCJ83ZSpzZPaKv9gJLRg	11259	15848	15848	1618791840000
22511	3NKAgCECtideStMRWkMuoBJFNSVsRaR3Xk29QaUtrj71qb9GWUhW	22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	1649	1383	418	12463	14609	jx1oAPSu2K6cV34iV8CPCr53UMAtiNV2VX9Rwo3cVB8tqYKmfMR	11260	15849	15849	1618792020000
22513	3NLhL7hFVeyB4kN65nfBi3qDWeUctnDJqNcoGZSo5iE3FWS5exvA	22503	3NKuavwNyHvSC7yNXHfVRzAZmhZpY1wX4zdWoscNiReQEPfPbrpW	1553	776	405	12463	14611	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11038	15850	15850	1618792200000
22516	3NKq2Zcj2AJR6WSkToe44KKPaVCeYZZQUZD9tBqYPKnnXxA5qD5U	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1585	1120	418	12463	14614	jxDfUd5Wq6a3v76Gtp6p1dkzCivRzeP75hnWD4r8BwKRiZM3Z7G	11262	15851	15851	1618792380000
22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	22517	3NLNxq5GQXu1uaCVqYi1EzGoQVxaoCz4VzWrPtMDrvyMw2ruxrWu	1508	1141	418	12463	14616	jwQWXXbhBuaER9Vz2s9uWfN817LiGKwVsgt5AcxnNrgrcUujReT	11264	15853	15853	1618792740000
22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	22524	3NLqhw5zPTUgZhxsTtsUGMMhcRP3rPLNzDVhmxRKP5Psjtj2i46a	1609	1087	418	12463	14623	jwap8BRQPX5AJ6xHhPH2JPM4imPhCiWs15oSoscTk71SnSrrUfM	11269	15858	15858	1618793640000
22533	3NKVjjijf4mHcAc1s7miiPVgKkXXn5dw5iYYebnWZTAvVYL9vzWY	22532	3NKRadiJ8c5A5q5qYhByLNF2RTQTrb2PM26PThcsZwZ9o5hnTdRT	1405	1	419	12463	14629	jx1mKrVPDjgfLDv9tejLKsbRRTS8qJ3opw56V4jecZaSMHcEkdh	11273	15866	15866	1618795080000
22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	1419	814	419	12463	14632	jxnNJgeUeewBTD5UEPTNQ2kbDEaZ5WfyNe9ZERJVum8LoQQ3Jgr	11275	15869	15869	1618795620000
22539	3NK9Z6DuFzYUro2gLH4nNggUuHU4HpknXTt5tKbTtY4c2V3WuM34	22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	1406	1393	419	12463	14635	jwcvaELVuWmZeXdrsFtp6TYzqaxeVMmUYRE6G79UdHGWnPRiVbX	11277	15873	15873	1618796340000
22541	3NKmGN9emPPZNuAJUnng6xcZwd7bpdBE6TsFcbZPmLiLcW5sQSLL	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1602	1003	419	12463	14637	jwqdF4mnZWCrCUPudvqRaZSjn5R6ip9hghxdr144MKYAZsqczXm	11278	15874	15874	1618796520000
22546	3NKy3y3SVR2StjxQxTsHe3rYcQDChobAt79L8YeFRRkoxoc9yCwD	22526	3NKnJVnBEhbUYG1NjgCkZBR9jWLf7rYtwfoGXEzDJX5XjCc1HUtr	1553	776	405	12463	14641	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11040	15875	15875	1618796700000
22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	1633	1024	419	12463	14651	jwd2zb6dQkzbFNqYd43qcqAkKsVYZ9SCwq9KpFEYAGPwBJ9n7ka	11285	15885	15885	1618798500000
22558	3NLNj3dcTisKdCDGn1x91YddfKZTLgJ445y4oKDV2Z5pDXVLZyp8	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1637	816	419	12463	14653	jxY4rQBbW25g7xZucNuXsVT59GFXwPH8x2M9YSsVrsCK41sFkqc	11286	15886	15886	1618798680000
22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	1467	1376	419	12463	14657	jxZhGqQhpNWy7szc11BwCVEWU2i1ejMas6jTE3L8YSY8cGdn74V	11288	15889	15889	1618799220000
22566	3NKG4VvSrem2Re2r5kAi7jWo55PGzg6KgNpFopxH4FC6t2rqKyqx	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	1460	1324	420	12463	14660	jx9ZzcrCtv6qffx6CgXkjs6RkSzrRQyNrrE8bdYdLUG2iKutVbg	11289	15890	15890	1618799400000
22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	22573	3NKhDC3Jzb1Us5dvqnFPF8taE5JpuFpTDTsdb3GY2ceEhaF7ZrPd	1650	1009	420	12463	14669	jy2VNfCE1FhEy8ZvvuXnQo7GHMUpFfSpHxUrNtP6YTJTSJrM3rc	11294	15897	15897	1618800660000
22580	3NKDxE4prk3bCPbhKH38nsBC81Zg5vst4WtPGj3tDRs52X4G3iJU	22579	3NL2cUGxzzvJjUy7z2gZnNA7jCnbB7feECQ6QZRpBTyjRbYQPu7h	1601	1022	420	12463	14674	jwFNshAr6ZCm6BPBFRNrJ3bjyvE7QuvmjMepAquhwgvJQKfyoZ9	11297	15902	15902	1618801560000
22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1483	499	420	12463	14679	jxaYUcTpii66GtLvwWF8b19LkDjifNUAUX6WZPDbVuKBFdxTPAt	11299	15904	15904	1618801920000
22590	3NKgScheu67KYBMWiSGqK53jjVYC35kQpSAvN8QD1LCTiaZCEG3n	22553	3NLKkoNbnWyw8LN3EP7jbcVbRxsecpme9QprMBgNmgCMprbQS3AB	1553	776	405	12463	14684	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11042	15910	15910	1618803000000
22498	3NLYdV196Z27c4M3WAm4ibbChmZieT3mpzsRZreDjPfQyHMBekbo	22490	3NLBt5BkoocAGhdqf4HFZ1UMRK327p2G6GhRFg5cukAvvsVsYMCQ	1439	482	417	12463	14598	jwDHbYBWiKApBrjdiF1nkfMLf7L9evQqMNMTKEqgiQSfqHMJUc2	11254	15840	15840	1618790400000
22505	3NL99PrWTZKXfx7iBkJEZ4SeXsQpf4tnjDGoURmEQuz2aYsXSBCV	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	641	1090	417	12463	14604	jwDuMpkRWeERnRcJzxAusTHZsPhJwn83v1vosLZpKLYbj4mUejb	11257	15846	15846	1618791480000
22507	3NLNgSRPRhSasUu8DfRcnAk3PBggXGLGvjtFUCLJtavh8H3Nwnas	22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	576	1109	417	12463	14606	jw6cbgtLbcem6PgdRrDqho1u1n3YTa97TpZubnh4XKuXev8yN7p	11258	15847	15847	1618791660000
22514	3NLyWr4117FsFnLDFHDimKHxSSf7Tab2nnR8Y8Sud4e7viw9XH9s	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1407	1395	418	12463	14612	jwC9GK7Wrs1gxsp1ZAChQiCaMmzU1AtB6KuFgeBY7MYQdLnoMBG	11262	15851	15851	1618792380000
22519	3NKsoqTkZmt4wGMnoVcozA7PPD4PKUvNqdkFoJxtddgnRx6VU8vT	22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	1407	1395	418	12463	14617	jxQvLFtZbyEF4RD1x1ihTKxo6C7paGraYyJqwgMP9XLRwcKL22w	11265	15854	15854	1618792920000
22522	3NK5hRkznWhzyZVhwLzoo9BTqsjXBJYQX86qxFaTGB1XvoTQHNVb	22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	1637	816	418	12463	14620	jwxvAF33TdJAudHEF5DH4m9872FUcjd6215nYEJS34BFDECJ3fs	11266	15855	15855	1618793100000
22524	3NLqhw5zPTUgZhxsTtsUGMMhcRP3rPLNzDVhmxRKP5Psjtj2i46a	22523	3NKn9UfRc65cbL4ie3EwJNLz9uCzv8nZgSf9xxMtrBshBquHd5s4	1648	1284	418	12463	14622	jxotSVYgjvWZQNk4aSMrny8gMApWvXhZMSCmQmXS2MCrmBj9YpC	11268	15857	15857	1618793460000
22529	3NK4ZB5Ppz8eSNWEWmEP23MM16rjwN19wGZP78fskyB4yDoGrrsr	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1406	1393	418	12463	14626	jx1cYBM38DMeJkAsv4pA3Hc8VobSCVNZxxwqBRPjRVz3DGRPtBc	11271	15862	15862	1618794360000
22531	3NLnLDsKXf4h5KRSzsQ8ZyKorQGYbf7mhXcsmeruBQexJfqgTuc1	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1651	1301	418	12463	14627	jxmdG3eifzxZuNmc8rDpiANRmD8exFtZG8LdcKeLLHXR17Zfqcc	11271	15862	15862	1618794360000
22535	3NLCgC3KLZDPECzFKSEvuqcKcxh2aSuGwfdA6uQJJr7eCGRXTgqu	22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	1407	1395	419	12463	14631	jwqCW67p1btTJcapaqJQZvtT9x6SHHcxXK4L3ok7HPcMxBCkeKv	11275	15869	15869	1618795620000
22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	1652	1189	419	12463	14634	jx2EpWKEz9198XiUbKQbDrCgU1NE5xhdjKZzcRCvaQU5PBL7U32	11276	15872	15872	1618796160000
22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	1529	1190	419	12463	14636	jy2LsccgHvHrrEruZervHER71Q21nHGhQ9A7mPcA9gmDTMhbrKq	11277	15873	15873	1618796340000
22542	3NLxyntFVdh2pZXvAzJmMc75cBM48bzP9kcgbkYEYx87DkfJCkLN	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1602	1003	419	12463	14637	jxXDRuC7jbktdb3yJAeAzsgzKgXXJS4iMLhdNJtkBkuaTiaTQFp	11278	15874	15874	1618796520000
22544	3NLiCGfJg4URkm3TJHFx5kpfGgWY8o2pJe4tQPsdPeRmD1QnDU6A	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1577	1327	419	12463	14639	jxEbyWTPsxPAQFc2YQLywparqH5caxi5C8JKZFTpTUdpn9qtFK5	11278	15874	15874	1618796520000
22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	22549	3NKcZP2osxUEzwg8cJJMyTYqdjpZn2huvjARxJrsA3kBwUDbRQyA	1507	1280	419	12463	14645	jx8atFSLMV17CwEt9R5NiF15M69RcJgqyjuMhQiLjQCcPRvjs2n	11282	15881	15881	1618797780000
22553	3NLKkoNbnWyw8LN3EP7jbcVbRxsecpme9QprMBgNmgCMprbQS3AB	22546	3NKy3y3SVR2StjxQxTsHe3rYcQDChobAt79L8YeFRRkoxoc9yCwD	1553	776	405	12463	14648	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11041	15883	15883	1618798140000
22555	3NLkmtaBzV2D7wM8PGcvT1ST4PvJQJhRCQVrwBCgxdXLKHMraKNw	22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	1607	982	419	12463	14650	jxRxoiVDBwNQCoZqf8tgFgkF95RRJRwDtiBBebr5kpDZnXr8Q7R	11285	15885	15885	1618798500000
22557	3NLE8VUiuxh6gBcjfzfSppbMcrNPU2UoCzFFm8fs1HNPCw7tdfh1	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1579	1143	419	12463	14652	jwt1PPcZqDPrmn8sMzBd9vY3LUnKKbxvqDz3maXbbjp7pwHZgt9	11286	15886	15886	1618798680000
22562	3NKmC6iDBRhjeVZFrfZQuJUvQf4C7efBqXm2aucvZCvhezMPv4nn	22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	1467	1376	419	12463	14657	jxZhGqQhpNWy7szc11BwCVEWU2i1ejMas6jTE3L8YSY8cGdn74V	11288	15889	15889	1618799220000
22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	1447	1099	420	12463	14658	jxoCHYTXxYYDpoLLpDYDeBXvqPajDEAovjEPjb9MBq9F2KJBVQs	11289	15890	15890	1618799400000
22567	3NL3LkCzvvvTwYWvNkBoCsKRL8q7Y7e3wtpYyzyaHiz2bxwFcXQ7	22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	1405	865	420	12463	14661	jxCEUpiBnAGsiU45fGdbWgvkRSrBZNY8PuTtFraVz1TuSUfAv1k	11290	15893	15893	1618799940000
22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	22568	3NK5W1oxS6BYvQMh1ZjngdfFjrSzA71mjthZjdX7p1dT7aWejqex	1607	372	420	12463	14663	jwwPAomThifzoja3XCUsNoTFZeQ3UjrgBhVNGmx8YUTn16UKJoi	11291	15894	15894	1618800120000
22572	3NLCaWVQuDZ2gKBAN4ekuZ6BpZxXBapMVupm9x6Q3jUFc3D1Hupr	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1669	378	420	12463	14666	jwtVUqcCAgvXyikUHmsNkouCjpCjrVumuMH7cvn4vyNc8oSSHM4	11292	15895	15895	1618800300000
22574	3NKLEAvHPSNxdrtnvYTFc3N3D9VyQ2G8kFmMaCDCnrXdpHjhJ9Bk	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1555	1347	420	12463	14668	jw9RZzJ1JjA15xsqVfKXvZJ23mM2jWzmUCp9itkARPxuCT1J6ND	11293	15896	15896	1618800480000
22579	3NL2cUGxzzvJjUy7z2gZnNA7jCnbB7feECQ6QZRpBTyjRbYQPu7h	22578	3NLDryha4KwH2rk42zfsif18MzUFmRF4WJxLjhQPnY3ojjMaNrLa	1419	139	420	12463	14673	jxk9NjatkQpDgfheS6E4XwPSKdS7ErWARN4hmYWGzTVFj9z9GxY	11296	15901	15901	1618801380000
22581	3NK9ahL18GhdDrtJVsKQyvUksRbaAvQU4YC7zGipXt3K4UiuL9oq	22440	3NKy9kMb3Zd1L71bwCNYBJsP78qqCA4CdNeit6XgC5qoKCDZ1SqY	1601	1022	415	12463	14675	jwwvw1udD4komqxgoRptcaDunAauKvmHaABGeLFn7oehq9UPRzo	11210	15902	15902	1618801560000
22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	1536	1067	420	12463	14680	jwJ2KB32eLBNbTos7xhnpT1DyRX1dgzH927us1N2exT3ypGg5HD	11300	15905	15905	1618802100000
22588	3NKAquGUk4YHxapa4fHkHpf8zQHVD39G4zB6MF2DGU3969nBXoFw	22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	1590	1300	420	12463	14682	jxu4QvgBXPaLLgZvzRwzEyyerAWefCVrq8ut9EExsF9WpNQuj5R	11301	15906	15906	1618802280000
22589	3NLvgCv9aru7dmrq5S54AYkLVXno8HFhFjTFs9UqvQZ4mDf1gbL5	22588	3NKAquGUk4YHxapa4fHkHpf8zQHVD39G4zB6MF2DGU3969nBXoFw	1403	824	420	12463	14683	jxMoK8LUSijgexVvi24rnneiLwPfQfMt9y2ofW4njHYN6Etdtpk	11302	15909	15909	1618802820000
22592	3NKQHfuidAgwggJmMRKwFK9S41rQQCMsKu53PLpyK538qmpWvFYj	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1451	926	418	12463	14686	jxWYGJxwyUPS7ZJt8fNxgnfqnYfc4ErNuAuhVwDdKz8hBCruCNi	11271	15913	15913	1618803540000
22595	3NKmpfvaYHXYXfe7vJ4JaQaGFypRLHjQj6o3GHpfw9yPPSXANCCv	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	470	1183	421	12463	14687	jxYhSiY33RsFbZ5EEU2xDqNA2sCmMyGGU9soSuBe9D189hKQKez	11304	15913	15913	1618803540000
22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	1426	1118	421	12463	14689	jxTUmFm3p3mr9LiGnpMBtU1CjSckUy2pYdf2g6mXrWHmL3r7Gda	11305	15914	15914	1618803720000
22549	3NKcZP2osxUEzwg8cJJMyTYqdjpZn2huvjARxJrsA3kBwUDbRQyA	22547	3NLD6sK6EHEuM7z6pYKbWMhmSAxdeFmcQzAaa9CxhB1zmhtNBifn	1596	1237	419	12463	14644	jxBYPkxkc6qM9Jf8ms8gtnNdwmRVQRRYcpjPVYDT7MVg42n1cPV	11281	15880	15880	1618797600000
22552	3NK5dUqLvjKZf1EjtUABwBowLusNFi6ed93pJpQu9vtNigRFbKg2	22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	1444	1381	419	12463	14647	jxW2qj2ouLT6Po8s9byjvak42X9V7QAb4dsSSAQFdd8GNviPR3k	11283	15883	15883	1618798140000
22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	22552	3NK5dUqLvjKZf1EjtUABwBowLusNFi6ed93pJpQu9vtNigRFbKg2	1578	930	419	12463	14649	jwk4pnLCQAeKEguFgpsc9pvjH7Zjw28MMF8BgBnTTc59ZyTibVv	11284	15884	15884	1618798320000
22559	3NLP6DkyfnZwt9K7m5rLxTZTJjFBi9gmnNTzxhVfWK4RhXwCqL9L	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1406	1393	419	12463	14654	jxuGHsikmD65uGXdRGtw5TZJ38tEvQEhMtAwo7p1Qovd1WqFLjH	11286	15886	15886	1618798680000
22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	22559	3NLP6DkyfnZwt9K7m5rLxTZTJjFBi9gmnNTzxhVfWK4RhXwCqL9L	1407	1395	419	12463	14656	jwWoW4NaVSknQG4KNZQ7JhghUfdEq46Hrn2o2UrpfkujjPECf1e	11287	15888	15888	1618799040000
22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1536	1313	420	12463	14665	jwQdZ5262qZtRjQRdMnGoEw1AZ6Ypp9HNvBA7tJFDPNCPPn6dXK	11292	15895	15895	1618800300000
22573	3NKhDC3Jzb1Us5dvqnFPF8taE5JpuFpTDTsdb3GY2ceEhaF7ZrPd	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1407	1395	420	12463	14667	jwPcTKx1mH7fh7v9S3fd6BdBx9B9kpSGp9GuEGe1TZYcBwnHAbZ	11293	15896	15896	1618800480000
22576	3NLAGrjkbBUYsFb2V7NaxLikbZUGULj1YMN1TagWUhUnESRFPVa7	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1596	1363	420	12463	14670	jwH1WuiB39eWqhgD9mWW9yhxyzaHj5bt65CV3dUaxp6QnYoYSkm	11293	15899	15899	1618801020000
22578	3NLDryha4KwH2rk42zfsif18MzUFmRF4WJxLjhQPnY3ojjMaNrLa	22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	1590	1174	420	12463	14672	jws3fjA9B2evGFddTUc2YvSZWVqhkXmkQejAdpPVBY3E4q33BiX	11295	15900	15900	1618801200000
22583	3NKUYcGK8YbkJYCoBdxP7ULrnH8nJWRKk9Z3r198m8p1H2c3K54D	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1543	695	420	12463	14677	jwAhbYzgKHesaZCTVugTURRCnYCtRRq6wWv2rYAi4we8DbFJnK1	11299	15904	15904	1618801920000
22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	22589	3NLvgCv9aru7dmrq5S54AYkLVXno8HFhFjTFs9UqvQZ4mDf1gbL5	1648	1158	420	12463	14685	jwQ9fBUGpujhku4rD8pUKGSz18zhfUcxwY6zSGeANFFQzJ55mpP	11303	15912	15912	1618803360000
22594	3NKj8nqS7AWqEfqFTxEC8dLHGuu7ZNFA5vem5gSMu2V5WYPPKzU1	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	1451	926	421	12463	14688	jxSmhsvX14JnAwAz8p5to2eztFGgdtRrcLbuv5mAN2Ahu8wTRY1	11304	15913	15913	1618803540000
22599	3NLU7wmfLCT6UdAYgc1iivB1tEkneVHeGUVMUnuU8gWfDSJ2FnHH	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1639	250	421	12463	14692	jwZY6AJpyeGMKSXFU4G32P6dzTf5CeaSkn3Au6amtetbb5JBY28	11306	15918	15918	1618804440000
22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	22598	3NLNFRT4toGbDE938TUsyu88xrpVrKsQtXF2NfQvvTxK3VvwvDvj	1403	824	421	12463	14693	jxonD5cSfrcNtK7WoNT3KQrfxBNGJUwpisCH5jq6gzsrnncNAqB	11307	15920	15920	1618804800000
22570	3NLqag9cDkQwxbtUD2EyZK5irkFKhZ6d15iWRLLWL2fLiJSCo1nS	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1467	1376	420	12463	14664	jwXHU8dWgzCxnVXYYctjVo9zifHY38ajjTS9MZyargjk8Jtubg2	11292	15895	15895	1618800300000
22577	3NKwxTJzWN7MF8nUh1E7y9pa931mWsvRbpkJ9nmvDUULCSC1sHWP	22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	1444	1381	420	12463	14671	jwaNSQAxap1XEqRgruhMGHu7kSkVSpZEKzxDnruh46XnzmvBxWR	11295	15900	15900	1618801200000
22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	22580	3NKDxE4prk3bCPbhKH38nsBC81Zg5vst4WtPGj3tDRs52X4G3iJU	1407	1395	420	12463	14676	jwXYtqRgD9SAx2tQ6PCC2277u86zuf95QqJ7XfqJqjYgoAYbAef	11298	15903	15903	1618801740000
22584	3NLjT6SEn7dXtV53pCoqwHkfncU2sLoyERMNQqMtkCZUoszmoySz	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1619	1275	420	12463	14678	jw6h2aM7rDUiBrXpSLS54jf7epj2Dzh1BthrtYwbnKvjJ4pRWx1	11299	15904	15904	1618801920000
22587	3NLMfcZnp4N6jPTdXQaeq736UmpkSJzodQGawUprpmrG8NmQ2XSd	22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	1611	975	420	12463	14681	jwYD1TTiWJ2rSn823wDFP7NBeQvH2m6tXea1kwJ2PxQ5ccVDMq3	11300	15905	15905	1618802100000
22597	3NLDo5qSWoSHN6huMmogLr5hNARE3LbMoXWhwQzEj5minXovptFA	22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	1589	1160	421	12463	14690	jxGNFPDdZxZu2Gz8NRWAGaKJTZ1nG1wVhMdM3HemSSHHw2WgBDi	11305	15914	15914	1618803720000
22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1599	1041	421	12463	14697	jwZsLnhm9q7K78yF4LuPKgkRnpExAmM2oXf9sBu6dcb38aZVAXM	11309	15922	15922	1618805160000
22608	3NLAB4JBUoZWvgXfFmakyj8pHJkaQ44aZHAkFxd86oBW2CEVor51	22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	1646	988	421	12463	14699	jxsYvr4ugc6WmJnG4EwjEcvuZubytdoA9MyijfnrcwRAaVvVV4s	11310	15925	15925	1618805700000
22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	1403	824	421	12463	14701	jws44X29mwPqu6tCr66j6Bs4WTtPVHQS1YrPYhJby788qV2wDPf	11311	15926	15926	1618805880000
22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	470	1183	421	12463	14687	jxs4jtXKydKTVTyLPc6oriiU3hvUxQm6acSq7H9KpNkCSJNSZLy	11304	15913	15913	1618803540000
22598	3NLNFRT4toGbDE938TUsyu88xrpVrKsQtXF2NfQvvTxK3VvwvDvj	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1406	1393	421	12463	14691	jwGarC2KoyXLACPAPspJswEK43hh4dpvz98zftn1ooC8M7Wu5nc	11306	15918	15918	1618804440000
22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	1406	1393	421	12463	14695	jwz88Jidu1TTKFsEGRwYS2Hg9VQXexXTAmUrdtFAcX5xKn8SCbv	11308	15921	15921	1618804980000
22606	3NLQtvD44b5KbzU9PKpSnBqoGDsS92uoDmN6RdyjbKFdn7fNWFZz	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	43	1184	421	12463	14698	jw7saNcvM8oe5hLZxk9ngKaoaZ5zxW6ETjezeAPRLd7PgxMGTnN	11309	15922	15922	1618805160000
22600	3NLqiPj5ZEXAcQruJ7rwY6VdJykQu9vPREwbNgSu7EYcpJt6sd8Y	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1639	250	421	12463	14692	jwf6ENVqfmEghVcm7wtPJhr8GhdvJkq9VkbkMef8Qk2XVxcjQUe	11306	15918	15918	1618804440000
22602	3NLRT2vLNygo8MyYN1tC78GV7xadtsk7B31GwGWeiRX7XkYF4dNN	22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	1613	1223	421	12463	14694	jxiv514E2F2emhsbGStuzTBLJoWqhVq6cE5eAFqCpGJJnvB2R7w	11308	15921	15921	1618804980000
22604	3NKTGd8qARQNkG6NSRA7z4xh7RDeCbig8bPGUZauPPeC9pnDC6ji	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1405	881	421	12463	14696	jxNN8sY7V98v1jDJqXSMCpCQ7PajmYenbNJLtPuTckFjA9dVRa5	11309	15922	15922	1618805160000
22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	1646	988	421	12463	14699	jxrco7DaFsLm97qrXYzGeZ3czHgr8pnw3iCKMRvxwnG1YEsPJaS	11310	15925	15925	1618805700000
22609	3NKtKE7HNrBaHvoJRSjJmX3sPag6L2Jt26DwPoxYDgoeo4LJVGnA	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	1503	1151	421	12463	14700	jy1MccvLzZoGDxzkxJA9yuKLkSfkaFeG3Zf3epjCZwMer8aHkQP	11311	15926	15926	1618805880000
22611	3NL1K3pPePoc9P3HQTeBc75ftjGgYSCziZgDHxn3mZaejp1WaaZZ	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	44	1325	421	12463	14702	jwmxPPsWbbw8VPktpo2DcbCQkDwtHaWKWhXhAuhrvR5FD3Y47Zh	11311	15926	15926	1618805880000
22612	3NKaWUiGFrwvk9snxs2f9qa4J1urRCkG8Ayy9bDLqe3TLwQ9G4yk	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	44	1325	421	12463	14702	jwL1oNVUbXhmrNZnfz5jwjqfhuqvg6UzAfDufxty9iw2HX8rVXn	11311	15926	15926	1618805880000
22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	1407	1395	421	12463	14703	jwS1RCkZJQ687tAa1r4raDme6PBerLBFr5p4xTcLENFNM3pAQbD	11312	15927	15927	1618806060000
22614	3NKWd3D13oBUTXueSYRpUcpaMaAAYVidLqycrhXnFzSTmyy93JiC	22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	1581	778	421	12463	14704	jwk6SRQGMad6WCjJUrscg43RAWs4s3p9LeUH5peGfwEevs4XctY	11312	15927	15927	1618806060000
22615	3NLmpJeDCdV813uFboknz4gLNTeib9X7a2M8mNjR2fQPxaDhLGWo	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1483	593	421	12463	14705	jxe9akgdbCWRMruq4cksaFrd3SzwhicxScXkH8q5ePDEkYVkceF	11313	15928	15928	1618806240000
22616	3NKUc8RoGcMhM81Z1TRyQeCeBCD5HauTYv14Nn5PVufmbFd18gAL	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwvsrnJK9cQ34ZEmbFSB7YvFqqQaXgRfxWBqTRMhBhms9h8M9Zi	11313	15928	15928	1618806240000
22617	3NKWoxUaWxYJUx2cjb6VrscNXizJaevGPLnHPoinRqJ9wrd67S7P	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwXNNhQf6cWpfchJP45YxzEe1CTyt56BtHFYoaxSpnh86HGdEXz	11313	15928	15928	1618806240000
22618	3NLUXzHndqEJZS6kCppu78agTKP9g1TLVkQHeQ3CKJ7u6Ef71edS	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwCNP8vsjiUnPjfMAZ3rjvLiHgbn7hZmCER6tP9X7vWCRLPgfXr	11313	15928	15928	1618806240000
22619	3NL7PRWGVDAQoBAxvpUKe3HL6brYzcunVbqWuYXDcomatjjsE9kb	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1581	778	421	12463	14707	jwB6G2Ef6bCsopCWae1tL9s5WfiMCsQKkCFCRBGhS2SHfijnjKC	11313	15928	15928	1618806240000
22620	3NLUJc43hzCDNdd2ofGyv42G5y7Jbz9uECQbwnQ9SUbsccBEgoGy	22619	3NL7PRWGVDAQoBAxvpUKe3HL6brYzcunVbqWuYXDcomatjjsE9kb	1656	1343	421	12463	14708	jwW3cJvxLiJ3uhE1ocLpcfFLAMDfnT9nc7TtU3PKZ44CkC99kEL	11314	15929	15929	1618806420000
22621	3NKiFZMpxY7czS4QgPKyoRgidAi22U4hWCwTX7A99ZkHwiZ2cxGD	22616	3NKUc8RoGcMhM81Z1TRyQeCeBCD5HauTYv14Nn5PVufmbFd18gAL	1656	1343	421	12463	14709	jxWbpvhUAtP3XLyEYWDheBdgCAQx1Ds8V3dMPWRjGz8v9gghfkJ	11314	15929	15929	1618806420000
22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	22621	3NKiFZMpxY7czS4QgPKyoRgidAi22U4hWCwTX7A99ZkHwiZ2cxGD	1503	1151	421	12463	14710	jxsV7a4VqZvGyypniok9uie2ajNpf726KRUERCjYrM1EVgw6EaG	11315	15930	15930	1618806600000
22623	3NKHDKgmW4WQNJBPqy6pjM2TfXhPHhRyyjNF3QvfqYeFqWBAh5Qv	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	1483	402	421	12463	14711	jwrP8C8A2x4VWRrFJVsysQPM47NcNV3t5PVCcNXaCgK6NHTHMr1	11316	15931	15931	1618806780000
22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	80	1273	421	12463	14712	jwNVUeLrVTKmNXPYs8V7c9QiUSP6byGgzj7MH6g7gC9BHFo2qxy	11316	15931	15931	1618806780000
22625	3NKySjDkiAvZNxRKpBxAAf8GfRU4sGDQYV6zy4nkkg31fo4wo5Wm	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	641	1210	421	12463	14713	jwyCBuVFWLt8pqBA9C5csoais9vGg7ghHeeYvH3SewaSQmn56ve	11316	15931	15931	1618806780000
22626	3NLE5U8nLgQbrFYaFBGLsKq7YKwKxBXPUafHDcp9NPdYuwpDeB88	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	641	1210	421	12463	14713	jxbu5hpLsh2vTxnMJBtBhjZ4xCkyTPJZqLRsrJCvjTBfgMD32zK	11316	15931	15931	1618806780000
22627	3NKF1smFbmnDH29jLZ33R5naGswcJnsadZncuqGMuiKx9vF6Uwfz	22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	1668	1124	421	12463	14714	jx52Yj6taBc6tGoaZyPhydWL5Qk2Mbwvhy6rtHi2sYQaxDQbATj	11317	15933	15933	1618807140000
22628	3NKn74dcCBtFVPvLNP8Z64ftFH3KsiJZmtrtfjZbrF28HGBahsiY	22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	1637	816	421	12463	14715	jwqUDUvc8mwhVkTNYNvUhVcWFxAVATyYK28NzS5pWQnXjuqyNes	11317	15933	15933	1618807140000
22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	22627	3NKF1smFbmnDH29jLZ33R5naGswcJnsadZncuqGMuiKx9vF6Uwfz	1457	1391	421	12463	14716	jwGat6NDPmNTQ5wGgV9JhcHvSEKcXAAjReMhMDwKL8VMJ1iDTFz	11318	15934	15934	1618807320000
22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1503	911	421	12463	14717	jwGuDjpMY2oq73x59RjPks5LbE2wC5NY34hqFquQESAJoQQps37	11319	15935	15935	1618807500000
22631	3NLUfxyZec49Dxo7YwxMYAe81rbwH8MYBPAuVR9ZnU5hNxtKde8n	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1671	1119	421	12463	14718	jx9qYRbM2KjtcidsCbhBB4QE8ggSMMRMKNQu28CSWkV6DoBetco	11319	15935	15935	1618807500000
22632	3NKgYPg4pRHm5VUjyZRxo1vMj8d5mK2W5Co9zmv8p3ufAwnM3Yoe	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1541	1172	421	12463	14719	jxu1pymMG92abwBnvYd1qjDzVpPY22SEBE6nBcgnhLGV9CUMmyV	11319	15935	15935	1618807500000
22633	3NLVkrpgFyYJGnVSTJiWdE4hLJJQQ8PLCvqgo39BnYpnYx4YVp8C	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1541	1172	421	12463	14719	jwZaY4hZkVs2hcw1FzCaZC6gtGuCQPtjLbcf3FzuYBzTnX5vU9Q	11319	15935	15935	1618807500000
22634	3NKDkapEHuhP8e1UL8VKJNGkyHiC93m55LAYhsymP9yuZuseFLCg	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1619	909	421	12463	14720	jxVmbypjA498S1CwLMs7Dx7Sbhcii5ym9rn8rr3SMrJMQPdoS5P	11320	15937	15937	1618807860000
22635	3NLWxB23bkBc7W46achYcA6bQqrdycPmarhxhtX5mN5qJUm3qZdu	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1675	1342	421	12463	14721	jwcvb7fkvhVuYuJKPfsWUFvauPN7fGikdTpk7XsyhK8cuV3uAos	11320	15937	15937	1618807860000
22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1631	794	421	12463	14722	jx8SurRHzGZZ1JHiPg5Ek8bJZ9dVv9YGvjoXTDzLEtMGQvi7aSh	11320	15937	15937	1618807860000
22637	3NL8PNHHpkepKWeWWp5pwFM3mEYgEFrDpPvixQHBPi1YR1gq1DYC	22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	44	1079	421	12463	14723	jwJcL44DoyLkcvCVWos9SCKKViyAeSkL3GhsYGc9hqwt7rktEQZ	11321	15938	15938	1618808040000
22638	3NKNVB1MQnRXpSXzCdtBnWiAW9DBNLhunU6YHPQUdMdRQdcEJNwK	22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	1588	1026	421	12463	14724	jw8mYcZuPScufg4mQAzzAxMAp7id7WnEwUEmTo1624fKgo8W1X1	11321	15938	15938	1618808040000
22641	3NL7FjKZcaz8JwkqhbH9mQrsmgVYLUQYekUyCWcWBxzAek8Zg2z1	22639	3NLe9QvHK9YYAcGZCQHw4gUfJJS2cXSeYpkxgvGCDmyuxhFmzT7P	1573	1318	421	12463	14727	jxZEb3qxRNP1sCCjsF9i2ojNMq9QnCwMgEBBm45n2QARCJFQ46Y	11322	15939	15939	1618808220000
22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	1588	1392	422	12463	14729	jwd1hzJo2mnWLUXkLMqArnKGUGgmQrfWgca5teFzWEgE2Jq21pn	11323	15940	15940	1618808400000
22645	3NLhKiYryocYfqpPtcBYH2kxWZ6xs8ajkZZzT9yHTifAhmJDZ3KG	22641	3NL7FjKZcaz8JwkqhbH9mQrsmgVYLUQYekUyCWcWBxzAek8Zg2z1	1588	1392	422	12463	14731	jwGGmXHFtsXxg4h3H3Mj2jwwMc1TLykMPLM6vdgdQdemHJGSBcR	11323	15940	15940	1618808400000
22656	3NLEMwmeNarJWUYHX8YWu1Qxesk4fnc9EW7QeMqYXZB6dHM8jaUb	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	311	1061	422	12463	14741	jweg77W3RXGLN86TWQmYkJj4kJHgfzYxNa7M2FJAvWcSvdh8BBt	11328	15946	15946	1618809480000
22659	3NL4NzDURP1FVh7eW2veEmcWJHrSs2sS1dvpZbjCsgWDWf9NAJxD	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	448	1305	422	12463	14742	jw9TYMnWhGmRq1oMh1JQDVK4RYLhyT7GRFZoeYdXUHVFzEzUU8D	11328	15946	15946	1618809480000
22666	3NKAcxnQMfVeRVAspSUb94h19kkHTnSvet3VxKEvCqsf31hmz6L8	22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	1637	816	410	12463	14750	jxerRiZ9eDsKxggYpY9NoNdFk7VemP6UJMCfJWGRQzHxgYLEPhD	11121	15954	15954	1618811017854
22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	1600	1126	422	12463	14755	jxFHARPhn2dB4WPVP5bR8xafutgLu6sQ4XnLALWrbofNV9HGecS	11334	15958	15958	1618811640000
22676	3NKVGt4X4hX1ay2wSqQK793KXCHXno2FzZZxAPQmiYkg8rHnAiWv	22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	1407	1395	422	12463	14760	jx9wPuEiPqZVz2f3FwiRUPbTUvsxahyo75q313dpZmVkfFpbj8s	11338	15962	15962	1618812360000
22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	1503	1031	422	12463	14765	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN	11341	15966	15966	1618813080000
22688	3NLQnv9gfMW3pccejAPrwUG5nctxathQD7nAZ9XgKZCni4Hu2DuC	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1577	1327	423	12463	14771	jxhNDDyUhXRes7Y183rBYvBiuoHuNCRAxad7WXvHte9w9VodZiv	11343	15968	15968	1618813440000
22691	3NKobTUBvKDyZJTwqFFzqnejVbYMKMUafCAJVVc6ahuB9UPQXTAd	22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	1507	1034	423	12463	14774	jxAnzhSYQ9S81vzBCJYK4q7mq8uLsPkw3HHbKkPyuK7exWygDUN	11345	15971	15971	1618813980000
22693	3NLs4iAc7UNLUbRVGNfY7NKpDrGrDngE3xG4yaMV6KZy14yLGPg5	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1458	1323	423	12463	14776	jxQwD7jUc9xjaUbzVA2eCM2MqPDtrtz86Q5oByNHaivA2hZCWDW	11347	15973	15973	1618814340000
22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	22694	3NKL3wdNmDhd2c4rCFHnodkx7PrPR7nMBriQhWJcgk3bFo71W5kM	1406	1393	423	12463	14779	jw7BEotrqWW6qJR7f55Ykif9GC15Bw6VdpHwZBpd817fWK2jQSu	11348	15977	15977	1618815060000
22699	3NLZu8TCFFo1xDmEdYM45Yd1y9e1BzFQug5giqk6YZMC65nkwmcY	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1670	916	423	12463	14782	jwVrN65951ysBntPpnAM5z8FFpwKA5gyiThQqB6MmrzBNgfTYd5	11349	15978	15978	1618815240000
22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	1477	1224	423	12463	14786	jxqwaA3auhmHqV1VsPZiJ82ytNFUApgWTpFQQV6hxM18u8EnKNp	11350	15979	15979	1618815420000
22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	1577	1081	423	12463	14793	jwANEM57r5XD4hqUcNz6VuCjYQxKrPSPQnd4oHDRE5tMBKaaLDP	11353	15985	15985	1618816500000
22718	3NKvSzeDYwSTL7Svu7W53qzYAN1WVE5BgjQ7koe5EVvijeo3BdHi	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1406	1393	423	12463	14800	jwkzvxJ58yU8vU4vaDFfEqad7jGy5zguH2VcQT6h5JUhdJ61icN	11358	15993	15993	1618817940000
22722	3NK7zji9kxitk7chi7xVe8aQ8qc5x8ZMEixJmM6vrFQQ73aTT1SX	22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	1651	1055	423	12463	14803	jxBSPCWaqpr4eeZ8rzT53RaVBgaFhtxgUq6fUMpWBVbmehmDG28	11359	15994	15994	1618818120000
22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000
22728	3NKHKioA4TEwjXNoGhnS5ASavQCPa4AQbKWyktCrgC7tyB4seZ3M	22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	1602	1123	424	12463	14807	jxviM2Nktgt7yv8LW5tS9ZX1SbbeBJn6XBuCiPon5C1dNYUkhPP	11363	15999	15999	1618819020000
22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	22732	3NLRyX7ymBmpWjCVfuqrdz73tH7puxNH5GtuXMLY52CKQLTn4ESi	1637	816	424	12463	14812	jxEw59rSgRU1AHipeoTDQF35Tzy6QQAaUn3cXGC6Yh4ndL3cmg6	11367	16004	16004	1618819920000
22734	3NKHaUapqFQaeDqGGfycXJYmRfBkmmmFsthtAoVG6375x5fkfsnz	22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	1581	778	407	12463	14813	jxg2cH8VS87FkScfaggu2bZxhb44jjDR9Xp2PsbS58GTAgCQxte	11080	16007	16007	1618820460000
22736	3NK7WWftPPsYvPZRhuWZsu9dn593grwGGCr99X8wNDYE179JjUNg	22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	1589	1040	424	12463	14815	jxFq9qXm3TzxV4nQnQEj95ioyjbTWDqhZbazNoYYMJ9M4bHbyz7	11368	16008	16008	1618820640000
22739	3NL3XV9dCCvT7SWn1DVnsqoL7bogr2dQ2NsYFYTc78j3QNTuCYC9	22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	1407	1395	424	12463	14818	jwWczS61JTCFeWyDxDuzc5eVyfHqGuStCnQzbg8rQnXpZ585k18	11370	16011	16011	1618821180000
22741	3NKB1D5aw5jKVo3oMcAVMRySqF815MEH9ga8LuVRLSEBCk6JWKKh	22740	3NLsuNo7XvCipabU4vnpoMbv9aLoFZaeFG5dnFuJaNbVAMNxfQhU	1476	1125	424	12463	14820	jy3FwsF82SMFgUXVenb6ZL3PEP75zu7sZXF4Vr6oBtdWXhH6eUC	11371	16012	16012	1618821360000
22747	3NLHm1WFcB32s6bLt5f9aC6DYMsx5yWZCWczCu45Hsb1XscXwyL4	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	149	1283	424	12463	14826	jx4xcztYCg1a4YhaZDoJsswse887enpMwrXCuHoeqJ9sXtPraHQ	11376	16019	16019	1618822620000
22750	3NKWv8kXQrWyogZogh8MPzDXyapUELy66ri5iY1szF2B6kBaRoLG	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1440	1011	424	12463	14829	jwa2JjGT4ptRAHh2cQUjNRiRiEAUYBWMC5r6UfCcMnhiwGf8a4D	11376	16019	16019	1618822620000
22756	3NL3STGZAERN1DqfSDqrkLrukzRo5vcHDMyCE8vv9cFLwofw3Phg	22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	633	1384	424	12463	14833	jxRU5TVzCGPzHPizQAZQJEdySrW4bdKrBxdHa9zmHbc54uw82JS	11377	16022	16022	1618823160000
22758	3NKCzEu6GQeUwP3WPwzEW4p2v5sUTQUtmARyfEABuPvLurqx4jW7	22757	3NLib4kFNpi2nY6gHyedc9ALX53sQS8BWexBS6zQ1cvC6kjrN3QQ	1637	816	424	12463	14835	jweByEY7cjyQxoRDrS7rC9bVZzernMk378HJay1J3phTMpuAYCD	11379	16024	16024	1618823520000
22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	1581	778	424	12463	14838	jwVooKvrFfbyUdnPw6uptxSVb7k3idbeT3GNUo3F5GorX8DpLiw	11381	16027	16027	1618824060000
22763	3NKjUnfuKagg1vNqEGhsr7rb542iRyuQu5SrXf8aXcgg4GEuD7oy	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1440	1131	425	12463	14840	jxyNA49ysNxWDRnsUMqZpV7FY5FBnsxNvYsMZkV9YoeDbJDKPh2	11382	16028	16028	1618824240000
22639	3NLe9QvHK9YYAcGZCQHw4gUfJJS2cXSeYpkxgvGCDmyuxhFmzT7P	22635	3NLWxB23bkBc7W46achYcA6bQqrdycPmarhxhtX5mN5qJUm3qZdu	1588	1026	421	12463	14725	jxAH7h2dBE8k1BQ4smVa4GZxkfagMhZ7xysbXcvgXFBe2zstp4b	11321	15938	15938	1618808040000
22644	3NLZuNex8QdkYoxSUGXDAbuggHwseixrBGwFKPSiU87vd7d1UpFQ	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	532	1057	422	12463	14730	jxtJAiVDVQRHN2oSLVZ3SkfoL2WBCCmURm159mdoFpaL2HxjMZg	11323	15940	15940	1618808400000
22648	3NKsn668qxNi8sjr3AN9NBdYdjSn22QGNrPukFSh44o1zQhKs7mH	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1631	794	422	12463	14734	jwmuc6Hcihp538RbJc3MBxkV9THYjZ51TcSZwAC8eMzAQ3xiK2E	11324	15942	15942	1618808760000
22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1407	1395	422	12463	14736	jwdSbxz98RuLbuvzzVTzjwhGuqibmPmrzmWf7yqQ3NkUD6rbszC	11326	15944	15944	1618809120000
22652	3NLXXtuFptGA2sh9Qjk68zPBZUpRB78ctDwRSGVehLZpWiWdE2mk	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1474	1083	422	12463	14737	jwVzsRCGhP8NWKXHm4g1tonjJ8rqYeENJniJrcKPMkCGHaV1YLS	11326	15944	15944	1618809120000
22657	3NK3U9p3p83LXoprAwuGbBKDw7eKU3pm1BL1ZVrSwNvy29QYDjPt	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	448	1305	422	12463	14742	jxGhtwmf4sAGL7yFH6z8Yt6kDLki18qHxkE6zz6HQwgcqd2NLMP	11328	15946	15946	1618809480000
22662	3NKPwU2Jh2KfWUUngmaBNas5HdiCCu7jZ2pP8vFoqjzPqG3HSCmJ	22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	1611	1095	422	12463	14746	jxrbtdyrKeUAbPfjUVD6TRUF7p6ozh3kN2e8xrBxyvcRMbrZbha	11330	15951	15951	1618810380000
22667	3NLxnQkd3bQiHngKvn9JpeSmvE1JtZ3p1uPfiXQtFamjLudSYuDa	22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	80	80	422	12463	14751	jwcpWxwcPVEnHCTKoD6qvM8RVQ2Lhnwh9sBJWD4uwvKXN2WyJkP	11332	15955	15955	1618811100000
22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	1403	782	422	12463	14753	jy2zjbB6JqeAgoWJpcCtW54VdCrkn3QChYvz5eikqnjApgxLAx5	11333	15956	15956	1618811280000
22672	3NLi552Uh4UTGBt59BWa4335vsuaM34rZGFdzTrggTt6Q6qb7DcQ	22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	1407	1395	422	12463	14756	jxqGiZUCCks1Rg73mzdpp6qAC9urXNPWj7gpr7dzFjTGtQy7jw6	11335	15959	15959	1618811820000
22674	3NKGZC7e5JC62m3Fk39vabnCS3Lw2YsfEk36CpEoKuJDpMTnz5AB	22672	3NLi552Uh4UTGBt59BWa4335vsuaM34rZGFdzTrggTt6Q6qb7DcQ	1646	988	422	12463	14758	jx7bKcK7gGeiqsZ6quRuDRKbYCk8dCaQwRXzEbuX1rfwFY7yePB	11336	15960	15960	1618812000000
22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	149	917	422	12463	14761	jwNZEAZDSx7oeRrrhnar26R4F9zgfsdYERaXkQb4o4RcRvsPjoa	11338	15962	15962	1618812360000
22679	3NLbg7wnTMYwGgfSmDiFgevKy2sz9Cn73mfbeKUzqSASERrVxDNe	22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	1648	1284	422	12463	14763	jxAh5rJTBmmu3M5R7dcV2x1KM2p8zieMvFuwzbhEMj1Qh3iBfji	11339	15963	15963	1618812540000
22682	3NKN1RDVGJSzddFQBzaTfUMqsMUSJd7eHtwygAvEuoQsNZt5u5ef	22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	1587	1357	422	12463	14766	jx4bi665pqk8FkRyvgA7ccM6pEvfgmxZNsL6rLXFVeLYDcqT4B3	11341	15966	15966	1618813080000
22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1617	1288	423	12463	14768	jw98shV9xbLwudbWZjuUNkebtQZ4aRZiMNLVbckMcwiLBZQcjFa	11342	15967	15967	1618813260000
22686	3NKFiErzZXrk7QCEhfznLrX3eaLBYR8VLCFcoQAhyzge6J4xASbg	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1403	824	423	12463	14769	jx4JD5MGSjbWUjtujQXKwZLArCt5KhujRkGDsbADYrkYLSH6J7a	11343	15968	15968	1618813440000
22706	3NLDQ9KeXzRdAJVy7HifeGSpZNox5YnqGQqEjSjG24x2cuUhzgo8	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1637	816	423	12463	14789	jxUFuH3Z66oxDDsjrQXxyWiKdjVNmtpGMoJHnQFUr9zketaaxQz	11352	15983	15983	1618816140000
22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1536	1313	423	12463	14791	jwVyj4LuyEH62vYDDmNcs6CEc7pAimsi5hCje994evC48NZVb1h	11352	15983	15983	1618816140000
22711	3NL3513y44XpQZhYLUgWxwEpmAmatmS4UBky1Y5RV513h51Hmikg	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1448	1311	423	12463	14794	jxYUCb75bHEJ4qGkft26fpSfJjXgsWnoNXYe9V6TvGCsVLNEsQM	11354	15988	15988	1618817040000
22713	3NK6sdTtigVRdvqDwUtocwwW39pn9kehStbzFvRMM2PXStyhMSuE	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1448	1311	423	12463	14794	jxiUZxTEUoWqAjgR27F8iyFfX3p6SVKaPenYjv8W6CkpjnUUHwY	11354	15988	15988	1618817040000
22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	1648	1284	423	12463	14798	jxc49PSbhScVQvpHyvG4oXLbcrAsmS3k6XJFAztDXMqTq8FFKAf	11357	15992	15992	1618817760000
22723	3NLg5kqLN9VBt2ueW2amvequCgasqaDyGuAW98cDywQhp8G4jJty	22722	3NK7zji9kxitk7chi7xVe8aQ8qc5x8ZMEixJmM6vrFQQ73aTT1SX	1405	883	423	12463	14804	jwrnUr9739g8CSuGw7yHT5ZjEmuWkU6K8i2muPzmoPPaEzQ8jQC	11360	15995	15995	1618818300000
22726	3NLCCH9Rc81srpEfy9pFWpCJvDr9qeSauFxu3VSnEHAh3rwvhnzW	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000
22731	3NLJKbK9nrrDPhfuvWjhsL4kRKMmqWWZfZwwRgAgvrQpuxnGauSG	22730	3NKBtVuWpzNmksRnc6Fr4u4EAsjXFSXqFAxiVQcmRP9ABFUiuMs4	1551	437	424	12463	14810	jxGd84htj8AUcznusRi9xXf4UVDG7dsdi6ySFaSUhN6YA4v9drd	11365	16002	16002	1618819560000
22737	3NLn4qCaMwSQLqdLp3ExwtbzFQdExz6puJEGre8cV3d5XLddCXr6	22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	1513	1013	424	12463	14816	jwv4Bhpp18EUKm1JoGKUo5zwxW933p1RVkjZNQtta9CqNa3Z5ZN	11368	16008	16008	1618820640000
22740	3NLsuNo7XvCipabU4vnpoMbv9aLoFZaeFG5dnFuJaNbVAMNxfQhU	22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	1406	1393	424	12463	14819	jxHy9fZiXf7M8NXidiLLREEMPLsGxFRQYveweCZ7XKHvzYiKRuf	11370	16011	16011	1618821180000
22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	22741	3NKB1D5aw5jKVo3oMcAVMRySqF815MEH9ga8LuVRLSEBCk6JWKKh	1637	816	424	12463	14821	jy1EjmvPF7knnwJdav1FGa3dBp17sY1BfedzjBQ3qHeYkFqqPY4	11372	16014	16014	1618821720000
22745	3NLnqfmjNUsMoqM5yph7JJtCLUYEbfCYtq2zDoGeCLMuwvRwtYf8	22743	3NKdoHSN9PkUpurM3RxeeeNdzwhd65GzYu1uij4JVrc99nR7tHCE	1578	930	424	12463	14824	jwz3E5Au8hrm52ha6eP4jTaoJJXzH7dVN24p5J9tehBA6XZKepE	11374	16017	16017	1618822260000
22751	3NKjibZHoqdvyPyxPUVk68gA61eZwTU78K44JhN4rAb8RqjN762B	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1500	1171	424	12463	14830	jwdo7wEyXGwZppQkESmeVcWQbbfihUEN2ir646vNQJY7zTZdwZQ	11376	16019	16019	1618822620000
22754	3NKsDKmjDntiyR54vbi9xqhsK9JSYLDkenkrwTB4X21M8YHX2bkJ	22425	3NKyywxxN6KqSiXdQVsPium6EN4R8Btc43AuBh5m1XptZN8CuuGq	633	1384	412	12463	14831	jxPDL8gha7K2DNvfYpndwtsExLQX6NFiejLA4Z4HXMuwZbchD68	11165	16022	16022	1618823160000
22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	22758	3NKCzEu6GQeUwP3WPwzEW4p2v5sUTQUtmARyfEABuPvLurqx4jW7	1407	1395	424	12463	14836	jxHgKh34oppqyFaVDKg1pkWJf4ZYCLkfk799SsyTQwdX7htmX2s	11380	16025	16025	1618823700000
22764	3NKiCBr7xkc43q23idYMfb1aaRFCyKh8hbpxNVzcd17LvBMbtxAz	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	563	1233	425	12463	14841	jxPxziZyN4s7Hum1gTxj6UW5A1yj6qdtvskvrxUR1TQ3MZ1eCgx	11382	16028	16028	1618824240000
22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	22638	3NKNVB1MQnRXpSXzCdtBnWiAW9DBNLhunU6YHPQUdMdRQdcEJNwK	1637	816	421	12463	14726	jwTP2Zyo3RynxiomVQoMoWEVq8CQGc6QVCeRtHkkaJQpSXDAePW	11322	15939	15939	1618808220000
22647	3NKo2h9HUwQEUzsgwmAyfKgo9keTYEv99JZkf4YvrLvMjdHY57U8	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1637	816	422	12463	14733	jx2NCZ9XN5PevnTE8jtJSs1nHg9gRAZbhikTmdq8fMnK5GQGqVp	11324	15942	15942	1618808760000
22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	22647	3NKo2h9HUwQEUzsgwmAyfKgo9keTYEv99JZkf4YvrLvMjdHY57U8	1585	1000	422	12463	14735	jwuHQFYqg2HW9coBWUN2wgYhWAnxxR9bJJcAXERZ6MvoRkVDUVc	11325	15943	15943	1618808940000
22654	3NLD28QvMaM8fzWpnkWNchNCPJ2ni7rafdzt1Z8yvUo9ZDUJmdeK	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1406	1393	422	12463	14739	jwU9fm416FHXEyFVncJ31cV5roHK9qs8hh4ffntKpgdAFJz2tew	11327	15945	15945	1618809300000
22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	22656	3NLEMwmeNarJWUYHX8YWu1Qxesk4fnc9EW7QeMqYXZB6dHM8jaUb	55	55	422	12463	14744	jxDZPQE6KZpGHPyAbUfrqwMxWiw89eWZL5AxjYuJdyg3C3Z6yoS	11329	15948	15948	1618809840000
22661	3NKpB1KXbp7L139AiTzMP45jQJsyfR7xkjK9zN3mQoEpZKCBqLSX	22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	1649	1137	422	12463	14745	jwvATik6LCucxkuW55DC7DQfpCAt4tkJYFyetbYg2hBGtb78XHd	11330	15951	15951	1618810380000
22664	3NLucMvdfhdA3D9QJQPAA9p7GMmGGTLRwdbRJsjyGB11edJVTbJs	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1637	816	408	12463	14748	jwgUwhN8j38fVawBe4mBUWrbrzbtuE4tZ6epdhaEh2VyFpK3eFs	11088	15954	15954	1618810920000
22678	3NK8uqVkgJD3GNPE67Qx4rAdwtqpvaxT9y7dxX6HcEHFaDH2aVEb	22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	1403	824	422	12463	14762	jxmpEvP2adxwr73ngmLq4rf4ySqbR16pwTbD7HPifKxzsTXpTMr	11339	15963	15963	1618812540000
22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	22679	3NLbg7wnTMYwGgfSmDiFgevKy2sz9Cn73mfbeKUzqSASERrVxDNe	1483	201	422	12463	14764	jwCzmfQiDjUd6uNg7cSdGXVcchxyuoH4PCUSVv5NaQgrg44KkUy	11340	15964	15964	1618812720000
22683	3NKcjD99fx9ccAWpVnHfj11BHLtHBEqgprTEvN1KSx3yw5NueZPA	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1580	423	422	12463	14767	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN	11342	15967	15967	1618813260000
22687	3NL7x2RKMWDtZYKN8hrovUm88oGjMkK7keFjS6iDm7U9NCHMvqYC	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1648	1158	423	12463	14770	jxP5HwFqkBL68bxDkq4Yb5KwE7bTUchRT36E35o2ZtNiQAHJzH9	11343	15968	15968	1618813440000
22690	3NL5AE8AQojw5otk8vC3UM1kJ8YEpaZ61igBtZUYN1hTCLLiupuC	22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	1467	1010	423	12463	14773	jxyR7Q2ybpQPcT2DhvZhSKajMYrTQFvAvQiSyTjD8bCvLYNArGV	11345	15971	15971	1618813980000
22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	22690	3NL5AE8AQojw5otk8vC3UM1kJ8YEpaZ61igBtZUYN1hTCLLiupuC	632	1382	423	12463	14775	jxdzP635ZaDXKw1b6guuhdP74codrJ72x7ooeCGbiUQ7LeyP6qr	11346	15972	15972	1618814160000
22695	3NK6JRadXmX9F7cxSo8h1cE4YGvYhrxzQgchQkwHgn2S1Fh9tp4R	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1581	778	423	12463	14778	jxyd4ZkcwpACS8EDN6QrKAqSqxGLW4sE1vCQ5NseboueBwVuFLc	11347	15973	15973	1618814340000
22698	3NLKUWHhqqZXPvrKcn252E2NXgxtw1j9c8gjxuQc1Y9fNhLtM8zw	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1406	1393	423	12463	14781	jxQwGeKTRdT6uHJ2qBucNSjTsNEL7dZv8pdd8gQXg2v5yTKsQot	11349	15978	15978	1618815240000
22701	3NKHVPH61yVXhQkZxDGh3DAEsQgNpTqdxukQhSD51Mn8ago2JJ4h	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1581	777	423	12463	14784	jw8XxjZeJKWNgDpicHo4iDpgDd92FCdb3eTpXz6mUcE56Qoa9k5	11349	15978	15978	1618815240000
22702	3NL6E5GSJ72ZjftaWfFox1rvBaDqnkp8z9rBX2coYXhMCZQShxy6	22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	1599	1287	423	12463	14785	jwKh9WxNeyWuMGa1RqtYhTsVMobv29K2FmBpMK3kM33ZRguwdDB	11350	15979	15979	1618815420000
22705	3NKZt5XupwVghpZoWvPkGY1ZNrL3QhdEXRVvzhEMjqLfrSARdnNM	22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	1406	1393	423	12463	14788	jwKNUQjsfdxkucWKfE87s7SNp1QqMXcnDFfR1jWD9Lt9mZakSkC	11351	15982	15982	1618815960000
22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	22714	3NKfj2rvEy1uMxzVFFCFn9shXkmRdrY7XX6iTzES8rtCgsUGwQr8	1471	1386	423	12463	14797	jwnW6K1iPniTyDLgP1XyyNyWzS8LzxGggTsbU1BdVT8SBnsspjB	11356	15991	15991	1618817580000
22720	3NLtx1uUYs93RYiRjdBizzKdw8L3iCqwxB7egGxKy8hBKT97g1un	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1489	1014	423	12463	14802	jxDPF1mUpqydp58SVh2KJKD4rTz5imJYSRmaDxLGoTp4bQFHZxT	11358	15993	15993	1618817940000
22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	22723	3NLg5kqLN9VBt2ueW2amvequCgasqaDyGuAW98cDywQhp8G4jJty	1650	1375	423	12463	14805	jwMXjDWPzgYsz3EFEfYr5RC576xEASYGpaTPMhfS8yuwvm2NM1J	11361	15996	15996	1618818480000
22727	3NKy47aSPwwVkET7WEJppViR2Kay3rdJWsSTQiRoAqKHhhocfP6Y	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000
22730	3NKBtVuWpzNmksRnc6Fr4u4EAsjXFSXqFAxiVQcmRP9ABFUiuMs4	22729	3NKGxrmBMcRMTtbnUagSmXVU9Np8GmxGs8a3ptL1VhEwT3vdHAka	1623	839	424	12463	14809	jx5seqJw6Ho764SPziSYSkDV5X6cYGan3NMqKGdfGnm5cD63JpZ	11364	16001	16001	1618819380000
22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	22736	3NK7WWftPPsYvPZRhuWZsu9dn593grwGGCr99X8wNDYE179JjUNg	1405	867	424	12463	14817	jwstqPZtFkCP7peMWST5AJrpebez8sodBCtMXp3NYMGo4sUx62a	11369	16010	16010	1618821000000
22744	3NLEycfRiLRZ49Yrsq7pEiQHsEiA7gbkMNFWh89DnkVuRE75cndk	22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	1588	1266	424	12463	14823	jwdUeqovAUbYuuH31m9v2aEwkSiVfZwwcFfijXaCC1kXdof6HrD	11373	16016	16016	1618822080000
22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	22745	3NLnqfmjNUsMoqM5yph7JJtCLUYEbfCYtq2zDoGeCLMuwvRwtYf8	1631	794	424	12463	14825	jxtLViWjcLrmWAoeZTjzEnKTDWp8hHXac9McErVcUTX2qsaDFFn	11375	16018	16018	1618822440000
22749	3NKSeieFEN6aeqbdUurEtAWA4uZ1MMvviMymXq8usvTVreo2XZkC	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1579	1143	424	12463	14828	jwGqmhTnKeaQXTYkb5ZqXgrPsouaGSxDtHR6ofd2ZLsoXB9B4pq	11376	16019	16019	1618822620000
22753	3NLo6oPGLPGtDKADZt1dRdoH4jYgKkGH4SPcF1aUaDRJMZk7V9Y1	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1579	1143	424	12463	14828	jxwXpTPHsV88V6VWPfNtF48z3finZfoUHtGf8FFnxc2kXFsZR5f	11376	16019	16019	1618822620000
22755	3NLGfoFb35GAiBAGGkz7REYhtoBx43yV11PN8z5bb67W2WWtWoSb	22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	1406	1393	424	12463	14832	jx8NF6sMbJdPEa6ekXssvs7Ldgj8SaZ1AtN97jXQviqyu91dzQn	11377	16022	16022	1618823160000
22765	3NKr2Pt3JSjXRjnfkXS9rYPmpqmUcKFdSmLURxcLmkKBQCewiK85	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	563	1233	425	12463	14841	jxPxziZyN4s7Hum1gTxj6UW5A1yj6qdtvskvrxUR1TQ3MZ1eCgx	11382	16028	16028	1618824240000
22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	22766	3NKZ3uLdG3dnPViJWLKVWdBAtPp7AkjnZcQxxaY6rayuscd8gFaj	1451	1292	425	12463	14843	jwmxwXoVUXtKCpL6yzyj88rBxNTtRBFvsqbsLJADafKww9q2Av9	11384	16030	16030	1618824600000
22776	3NL8Hvr21mPvFNSX5XCuVhQF1fk5PFbXE96bv26jFZSfoC2LxGrZ	22773	3NKM9ZcaMReiaya1gbkAP8aX5vzXpy4vggMAboipjLoZVGfA4hFz	1440	1251	425	12463	14851	jx2B67tJwU9NgzGZ5ifEdJP2Wq82uAxNiVccQcZVT1VyNZwkmWM	11389	16041	16041	1618826580000
22642	3NLCK9pDnw1T7Ce42Sq8Syosg7qXrvbwapd6FEYCm4RhopTw4YE6	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	1422	1337	422	12463	14728	jwV5WuHN6Mwh1u3fzdbJ6v8wnYquiBmZ92wYAHwvYaYk878jJyC	11323	15940	15940	1618808400000
22646	3NKo5jUjD5YfBwoXaotYHrGAj8GX61fpcG2721DU8SsqUEW7x5x2	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1559	1227	422	12463	14732	jwc5kdwD3TvW3EcdeY6iSPJPZaBDZjw8Bw5QXMacfdqCeMnY1pS	11324	15942	15942	1618808760000
22651	3NKDFZobnxDbatpVvDvjokvogF8crbEzTPiStZAU4kuxycW8NboV	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1474	1083	422	12463	14737	jxFrFXAKn26yUo9NjmNWwYuvYQ8jfdWu6gg2DgCESK4kCJqaCq6	11326	15944	15944	1618809120000
22653	3NK6smG4gkDhrDRVyPSd5o1dCeceJsQXN8qXntme3xJMzfb7cM36	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1471	1140	422	12463	14738	jxAnpZYqUZF48WmQuB4LLdpDaYw54Hz35HzyPEQaPGrYakikQJh	11327	15945	15945	1618809300000
22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1445	1044	422	12463	14740	jx1fPENbZRfr3vmbq8SxySiLZVnADBAg6XVeqWf4KYm9FACwp7r	11327	15945	15945	1618809300000
22658	3NK6jSAhWnbpYug8YkkjMG9ApBfhgQpo13PAyvFPqNxk8Mqw9ALv	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	1637	815	422	12463	14743	jwPqstWdzPdWBTcRADJatKYm14YzLNiLM8A5852faSkQhUd4LzZ	11328	15946	15946	1618809480000
22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	22662	3NKPwU2Jh2KfWUUngmaBNas5HdiCCu7jZ2pP8vFoqjzPqG3HSCmJ	1422	1337	422	12463	14747	jwFRD1QgYrSNc38nFTaT893JCPDB5Po5n32Pvo6fRBbJDg5WN79	11331	15954	15954	1618810920000
22665	3NLFXnRo4haKpTDoL9kiAnBHWioxtZLJpHYxvGtWbvxzCHvzjN76	22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	1637	816	409	12463	14749	jwbNdfUJJMfqcWFzqX3pWHADoYfULqqLPfuu4MQ6cjSg4uaG8E4	11105	15954	15954	1618810969360
22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	1403	823	422	12463	14752	jwgDaBf5qvR2d6eUfZ4F1uS6rcMvBZ6xdZfXaAm4zkv6qDUn3Gw	11332	15955	15955	1618811100000
22670	3NLSyyM8zasprQGggcPrgVU3LhnRxusop8j3TsgvLbbaL3cJScXc	22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	1506	1127	422	12463	14754	jwhQb8V2kbc1ErH8TrxNBdZgW7BdbWfSs1hgxXeKFLNcm6j4oyf	11333	15956	15956	1618811280000
22673	3NKcTNgxt5S5y9a1hj1mP57hS649GMFMGbivEriBEUsJvseaXTGL	22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	1601	1142	422	12463	14757	jwLPD1LZR9dKj6jRouH2JX78ZYafX7nQCPqCpsqwymcJGWPZW2Z	11335	15959	15959	1618811820000
22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	22674	3NKGZC7e5JC62m3Fk39vabnCS3Lw2YsfEk36CpEoKuJDpMTnz5AB	1458	957	422	12463	14759	jwe3zkhva24y2hzDSiwZ7sJ7XYkXvvNRq3vFHjcbPX6N7n24Jk5	11337	15961	15961	1618812180000
22685	3NKSYWtnreLRvh6ivoXyea3rLZAR3KREZRECBonvZRpim2xQpfQG	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1580	423	423	12463	14767	jwmJwFmskFhDeH1F1oHVHbRLrnFkCH6wt7pBcjHGwHqDLbsEEe5	11342	15967	15967	1618813260000
22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	22687	3NL7x2RKMWDtZYKN8hrovUm88oGjMkK7keFjS6iDm7U9NCHMvqYC	1405	891	423	12463	14772	jwWRcdKBpYu6owkqbchyiZds76Ce7b6VVRw8gTTZZ49NcRGTqr8	11344	15969	15969	1618813620000
22694	3NKL3wdNmDhd2c4rCFHnodkx7PrPR7nMBriQhWJcgk3bFo71W5kM	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1407	1395	423	12463	14777	jxCjHaayuf45rzLtA1TnqNUWiCdibRtDJ8Gv2aQtoKTaMni5b14	11347	15973	15973	1618814340000
22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1602	1369	423	12463	14780	jxt4hAYDz6HMDyQpPxJdUFTDpNSPyBVaQ6GpzUjJvdSs41UiPh2	11349	15978	15978	1618815240000
22700	3NKhoasTzLLPtATzGnnhRmwDZK1Vs9rprBgfYG6DN6A3kTCBw6qC	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	405	405	423	12463	14783	jwRWdJk1Kvk5QgnjHqaNPdL1RXHg4JeJLbwDqGN7L5hyA9h81iJ	11349	15978	15978	1618815240000
22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	1521	305	423	12463	14787	jy1JhoKptLDHKWCZVq7o6R6aKxC2EK6fbzbQTywsX3hCwqkxmmQ	11351	15982	15982	1618815960000
22707	3NKbCjTs7brkXWiBkDQHTG4ozwAt4DMaGpqZK8otuF4HANnCmBPB	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1407	1395	423	12463	14790	jxrKHUAUME2kuCuLv6LEUA8r7c3n8c5b5vKbBDf2Xg3pepYKMAM	11352	15983	15983	1618816140000
22709	3NKHjxUanjZF8k5sHfJi4odXooCWDzEYpCZNUrjDfSK1j3Jpkz2M	22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	1406	1393	423	12463	14792	jwyH53ub4tnUoafHDMh7tukREWT2jPBBLh4KvnWDJHfQCCffhtM	11353	15985	15985	1618816500000
22712	3NK7L3rRc1oVhEiVFHk1hkJAmqs4CTpkhChT4nhn6gMFCGSuLQxB	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1633	1024	423	12463	14795	jwkmYUekKdNqdKZzKbuP3Wzkv8zCLVg7uepQ8myn18peJLR96nt	11354	15988	15988	1618817040000
22714	3NKfj2rvEy1uMxzVFFCFn9shXkmRdrY7XX6iTzES8rtCgsUGwQr8	22713	3NK6sdTtigVRdvqDwUtocwwW39pn9kehStbzFvRMM2PXStyhMSuE	1447	1345	423	12463	14796	jx1nLUU5UneY4xEFQVakg7WpMSu13nFtmqcVdJ9wyX7oSQq9nF9	11355	15990	15990	1618817400000
22717	3NLwRq2kcroLgcMC6Jns1cjxCDyqhFXwNgLezFMJfagJu89VQUAR	22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	1627	1385	423	12463	14799	jxJB3xMWaJuNixEbvhjmZWXiJwY7REWM9cvHtkS3i7qQs4ZiYUh	11357	15992	15992	1618817760000
22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1506	1247	423	12463	14801	jxLgEckZBjDyUzvdR3JL8x66Mc125K7DX8UMcYdcC9VqnmHWEoR	11358	15993	15993	1618817940000
22721	3NLa1nyBcWvEUfyd4AhW7RSVmG5d2tQKgGAiowjAxcuYzHXpfizH	22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	1651	1055	423	12463	14803	jxHfr3vB5Nv3py4G4czcKUV1UhYtCe5FTCAZgs38sjLVfWxndTm	11359	15994	15994	1618818120000
22729	3NKGxrmBMcRMTtbnUagSmXVU9Np8GmxGs8a3ptL1VhEwT3vdHAka	22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	1406	1393	424	12463	14808	jwEgGtQrGEqnVfWhWaZyX6EziAVKevJ8YYjK4da8qTDvaSmMx78	11363	15999	15999	1618819020000
22732	3NLRyX7ymBmpWjCVfuqrdz73tH7puxNH5GtuXMLY52CKQLTn4ESi	22731	3NLJKbK9nrrDPhfuvWjhsL4kRKMmqWWZfZwwRgAgvrQpuxnGauSG	1461	1271	424	12463	14811	jy2MBty4PEcV25vdaf2f8SthjnUeDLzYGbxvqnx725NTbyQzkLo	11366	16003	16003	1618819740000
22735	3NKdxbAHHx4LQPWA7CSRebTwRo2gucJ6p8E1BpDpDq8RRs1vEasY	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1581	778	408	12463	14814	jxaAqsJoLRisLQSG3VtXaV9iVfT76e69VXsbzPQLqqQC7Q9KNav	11097	16007	16007	1618820540213
22743	3NKdoHSN9PkUpurM3RxeeeNdzwhd65GzYu1uij4JVrc99nR7tHCE	22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	1581	778	424	12463	14822	jxNDUne4DHgrAod6FijVoo25CdAJUKT4ioDotW5ZabKBF8hLyM4	11373	16016	16016	1618822080000
22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1617	1288	424	12463	14827	jwwSp44Lep5a4fkdJjtGQdnibc8TjsT6ruFjbcE6Qj9gCfdxzJA	11376	16019	16019	1618822620000
22752	3NLt8E2HRh2edkcvTYjAAdwVgfspQvb7nftSLY5eMXRQjMixDgMV	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1500	1171	424	12463	14830	jwPsybDaMXNN6DD6nkR9j114o38Xeo4MeemBX3YWjqZ5tqbNijh	11376	16019	16019	1618822620000
22757	3NLib4kFNpi2nY6gHyedc9ALX53sQS8BWexBS6zQ1cvC6kjrN3QQ	22755	3NLGfoFb35GAiBAGGkz7REYhtoBx43yV11PN8z5bb67W2WWtWoSb	1407	1395	424	12463	14834	jx81KbTHcDEwfuv4GZnHd26nFipaQzybRksCie5uQDD2QEZMCxS	11378	16023	16023	1618823340000
22760	3NKFj53MUToe1V7kQSTWcoDK7mzT3HArDWuHvi1uD5C1zBvkXjUG	22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	1637	815	424	12463	14837	jwk9MdVuSEy143BkKHKsu5tZWxeaZ8TbFemuAqFRBrZKEqk567E	11381	16027	16027	1618824060000
22762	3NLRAG1d4Xg7prxUwkdcoH9M3wCB3BsEahPT8VXQWcWjkqrBVovd	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1549	996	424	12463	14839	jwgADjyGGDVSUa9ysZipxqsGx6jmiaPcfAsJycp1mGR2QUDXuBe	11382	16028	16028	1618824240000
22786	3NKjUkA88cZkXAiPsTYthyezde4UWAEQ2keKxgLWRMowaZxUERre	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	80	1027	425	12463	14860	jwn7vXLtHpAzi8hQDr1DPYPjs91FQLRsZ81z7hXNNZfGSfAvwjw	11396	16049	16049	1618828020000
22797	3NL4RmzUVp1NwAvz91fvGTTC768qGamdJN6bfn8LHJSfm2ntW8mu	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	700	840	426	12463	14869	jxgW6bmBYueHfC3KsDhMkrBs1SpAT2WCDaddZCQrwHtnUbuXfmb	11401	16058	16058	1618829640000
22803	3NKnH5yAXkoByQZ7hT1bJcTrBuVvcysQ8Bff89o2oyY9kEw7n5NF	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	1501	1360	426	12463	14875	jwv3yNnNqy9k5BmZ21q5WoU2qNg7JsD3LkVkd61fxucunLZwNtE	11403	16060	16060	1618830000000
22805	3NLLvjfxQoopGqBxzyTF7Qw7AKy9NcNW8o4vz15hyQLcwPgNnTnR	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1609	1333	426	12463	14877	jwyCRVjw68oTMPiJDjX17J7dYem6n9EfjQGuuamwiMYFFFrJWxV	11404	16061	16061	1618830180000
22807	3NLN8QMQHrK9ERkezzBvmQYEgitHgNkR5fCYqarKLFnhqgTdSsBq	22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	1447	979	426	12463	14878	jx23RW8iuvtYvTHdNyeMViisgrPG4iFCQZmu7N8cQMoc8kJAqAr	11405	16062	16062	1618830360000
22810	3NKruJdkY7jgW272fxr9Lsc8bjYbdKrWxbVubExfFGCyWGhMhUNE	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	1671	1365	426	12463	14881	jw9NKcRUXqKsi9HsqzqgHbhabgeXQiQ7oEtVysk1QrkhcGUwAEE	11408	16065	16065	1618830900000
22815	3NKTWnXJuJu2kqiZEyRJ7iTS6EQrfUVG2vFjCKHXZnUWKTNfcm5w	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1541	1172	426	12463	14886	jxVbcPKYqzzxNtSAZmo6bxf1V5kXigwGwc5U9UNqqnpGSM4XSjy	11409	16066	16066	1618831080000
22819	3NKYTJegQrHb5MDEVo4KPDVT4ruQSpLTmEAyKjhHa9ix4iisFcYB	22818	3NLGb91UfgoPUeojV8xCugcgQsEjHFWLzSEo9ydzNnW3p6N7zz5o	1407	1395	426	12463	14889	jxAon9nUe3841GJw9zFTrynXEPhdX67h7Fa118fCrV391Bs6Z6D	11411	16070	16070	1618831800000
22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	22821	3NKA6dyh8rUKjUNrYz1iTRxisXssm6wGp1fLTB9o2U6TZ9wQXQhF	1642	1121	426	12463	14892	jx95DCpVdrugtj79pwfJLMT1PksAjsP8L1hiZrNyWaGqPFzCSHr	11414	16073	16073	1618832340000
22824	3NLxZwPh5PN4vhH8vzxMA779ccUiyfbeeK4vw1EBy9s4UvUQauPn	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1507	1280	426	12463	14894	jxgXpvhuSicSxCdCfuYumqzgZhurrbKPVqRv1L6N3xFQhfAYkXk	11402	16073	16073	1618832410041
22827	3NKU9xa57St5eBjYCxbXmBUKcufTUZATmrssAtAiiSp5Js9mkVbw	22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	1637	816	426	12463	14896	jwYejEyhPtS7nB8XotwHvPsi68eQouY5225yrhrHQuaRRhB1oEo	11416	16077	16077	1618833060000
22829	3NLPx8ED3JwekBkWnoRzGru44K9ajkR9G9dswHo8hvbHFpvWmnew	22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	684	1226	426	12463	14898	jw928HyEpZy7F5wakAdhYP2FGRsgkkzf22aAw5vEBtn9xaVhT2x	11417	16078	16078	1618833240000
22832	3NKLWuMquXKGAGGJPaB4gkb1iHt55QDREqKS8Uo3pmyMPSTKjahv	22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	1624	1088	426	12463	14901	jwp7Wxrrp6m8AiLuX5upyK2eo95ENFk7GZG2eLwWVzsoT4MuAAv	11418	16079	16079	1618833420000
22834	3NLKzf4yUf76Qwy9S3jrms14mmAKWDCVqkzxDzHCiPh9x8DzP5fp	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	427	12463	14902	jxQuV3pVCcB3VJsfcZvMSDaQmtWF1pQuqPAtKmJZKZ87t8uzvK8	11419	16080	16080	1618833600000
22836	3NLycYwGCuvoLuhz2s6dymRHkEWLPezwkQN8rNhtuGH5JV3Vb7Y6	22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	1403	824	427	12463	14903	jxP3UxqtuUr5R9rA1dgtg3F2m4fExJ2RG7yPVKsjG6AzwdKuH73	11420	16081	16081	1618833780000
22841	3NKRgMNZMTRsZDf53Z76EeiNCygbziFD3KmCsKgcKLx12t76b1W4	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	1509	1320	425	12463	14908	jwMqzNVBJiZmNEanhxRmbvtd8jwhZK9QsS1YrZfEnGruHKWLqXq	11393	16084	16084	1618834363395
22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	22846	3NL5ywLUH3ehTpaHnpWNjBcXpP2ozs7iAx77deMS6Q1DC9JQ7SE6	1578	1050	427	12463	14914	jwp9euE1BRbJGNAbFANVJFgK2SjJS5DMnJ1zrVKWCPfPPUZR19R	11425	16087	16087	1618834860000
22849	3NLbbriAxpwJK3m6UgXr4urZMjpPLcMvyHTjnUJsq9kM6WYY1mGs	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1406	1393	427	12463	14916	jwdouxb4mQkTzTV5yzo7TC5rCbGopskQYNpBtgYuaKgJPgRVW3H	11426	16088	16088	1618835040000
22852	3NLxrAyxwZvmpmMvGJ2WCjCuxk56fzxaxwF9Lgw11543fcFesSSD	22836	3NLycYwGCuvoLuhz2s6dymRHkEWLPezwkQN8rNhtuGH5JV3Vb7Y6	1509	1320	427	12463	14919	jwPvzvuSL5N27sgci59JnsxRnQPH38AKYjv6eoQRYKrjsSyU2WC	11421	16084	16084	1618834492799
22858	3NLPJ77UMVrrVuwgHhTDYuo2zeH47VxpBpXi1bdtqzxTTYYE8MAa	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jwtfrdNxsx3WF5t1WNwC7gLMvajLF8z9jLxmq6cimZ43BHGwGP7	11428	16090	16090	1618835400000
22863	3NKiP9itavKnums9QjEeD3v1TgNdddCQ2fBP6DBGs5XShXCVf23h	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1623	830	427	12463	14926	jxhBpNu9C2GCUn2tRqsHkZme398YmA9nxWs6VpKUrhZCJQ97Yvb	11429	16091	16091	1618835580000
22864	3NKAspjBHBtrYf8howKcs2ib3mdV2TmgpU6ocDHUHpToE3smYKhF	22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	1506	1007	427	12463	14927	jwKtR1W6ppxU5uUWi2uGpNXyAdZ3qcyCwjjEAUoAXVc3KVPn2sF	11430	16092	16092	1618835760000
22869	3NKvFpULEQ7HnvGX5YyzAje9eTCofcSbBXErM16QAf46Xx5s16uy	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	470	1309	427	12463	14932	jwAUt4PhrtbmGvBrUX6WYQ9DyMUwM3ZfEJwXzdGoP86EybHpGB8	11431	16093	16093	1618835940000
22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	22872	3NKDiiV4jRj5MMcMsfpSqx6uCCGXg9KWBdHewaD2DPe6yh2GezVu	484	1319	427	12463	14935	jwkrZ4vKuoGpmFQWNC4V73HQs3sPUaedqzy914oWskgpSJHBWkm	11434	16096	16096	1618836480000
22876	3NLQPwbkivCfwci2gqcAXNeaLUt8Af6aFAaohiYVYhSvYorx4AZ1	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1405	867	427	12463	14938	jxJ42qUKqadbubYVnzRmDf3YKMSPHjmopx6F2VvkPzf1brvLbFp	11436	16099	16099	1618837020000
22878	3NLmpmqRmiuWQeG1o6b7F3mA7CoBkv7giK2CUGrdbBA4MTiG5Ts7	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1596	1363	427	12463	14940	jwbhVVBmMGrxp7FHuUS1biJYHADoWfAVooDjZUAQ9uXwDfCuCv2	11436	16099	16099	1618837020000
22880	3NKs3854fLzGB6ts2CxQNBX93hmS7sYRrgy6pW1YuBR1tpNoG3JK	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1631	794	427	12463	14942	jwQUiWQzGRnbd18Ggym3ktJtQdfK7LJKz2hSg1UpSKR2eURbeLN	11436	16099	16099	1618837020000
22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	22882	3NKtJQMQj9WSu2pb46cPy5jXycXDMoxmznAcLcgz9HBbpdDYAFWQ	1492	346	427	12463	14945	jx2YWEXm8LqTRRp6RGWuqiq5nMU3MPBa5VWDp1F5cmPy3AMKHaP	11439	16102	16102	1618837560000
22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	1637	816	428	12463	14948	jwnJJWRbJ9SeZZaNbUiX3GKzrq6AsybQLb4aPzDrrtEo8ACQWKN	11441	16105	16105	1618838100000
22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	1474	963	428	12463	14956	jwweQWw5AS2XfWLAXr7moyUoTJZQHtmRFmMtwWR6SxtJA89k3DJ	11444	16108	16108	1618838640000
22766	3NKZ3uLdG3dnPViJWLKVWdBAtPp7AkjnZcQxxaY6rayuscd8gFaj	22763	3NKjUnfuKagg1vNqEGhsr7rb542iRyuQu5SrXf8aXcgg4GEuD7oy	1406	1393	425	12463	14842	jwpXu1KbsbAMDPpHm4csdTM4gSNCWXpWGCAUTHiGS2pUi9LSdhZ	11383	16029	16029	1618824420000
22769	3NLr5j8TMLfnR9dcqd63x7XoyA7Sctkw7yM2Gu39f8LuuH9U8M81	22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	1651	1175	425	12463	14844	jx7KA7ZfYNpYdR4RTSz2mVh8vgm5DjfDqXNDGSVvGPrmLC3ERBA	11385	16031	16031	1618824780000
22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	22770	3NL3fsmbaEMH2GAPyNbUmM85ndZLBzuq5nKKVYBLHWBA6Qxat4ZJ	1405	849	425	12463	14846	jxJZZQ5uwiyimUsPYtZsqYVQGGmK8wEu8c3S6pJ1xy6u1DfDinN	11387	16034	16034	1618825320000
22773	3NKM9ZcaMReiaya1gbkAP8aX5vzXpy4vggMAboipjLoZVGfA4hFz	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1406	1393	425	12463	14848	jxizWxk4rvjHuN7woU5dyzuMcKetj2FvRAah1iF4dABm15SQVXT	11388	16040	16040	1618826400000
22775	3NL4GbcDg1TMiv1wjfg93EsEytghjj334ochcS2uWzLneAJ8C4qJ	22774	3NKyJC2qnSHY8RQJevSX7Pf1cY3P6o59bHAGyTL7JtwczbFKotCe	1440	1251	425	12463	14850	jww3sP6WfeJmNFpBizNN5Q1sDZZZ6ZEsyiUeVnNzG5yNcNiMr21	11389	16041	16041	1618826580000
22778	3NLN7PotE9yVdmb5TeVJVKUPLn5uPjVgBMbySDqPmJAqs23SbZSr	22777	3NLik5voCQzVY2y6L7i6Nov3RywAznMLM5FZBQpzuVjwKYbo38TU	1406	1393	425	12463	14853	jwD17Cy7eCo3RrcbtuPQVnwyqohqc3NdyFAQT6wKhoFz2ExJNac	11391	16043	16043	1618826940000
22781	3NKiTptBxJu24W9uCG4oCEBhfK5cP3P3tfGoxHZ5w7s3upNJkoj2	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	1406	1393	425	12463	14856	jwtGBgtLt6MU4M16hehSiELtFmFfponLpJUDpWMigrLyCfKwA7v	11393	16045	16045	1618827300000
22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	22784	3NLnWNuhvGTmFL3FGQRTzmMpBRHPGCoREymNMqz7VLxBW2n2Bhbs	1461	1271	425	12463	14859	jw8gQC5fgZPjw99JRnzA4bpQdXBLDU1GV7yiUDM2s8xtbnW11AA	11395	16048	16048	1618827840000
22788	3NLTGx1Ld8hagpYEZxeRQCJuEtMByrAMJW5v4PpUZtdt6Z6QCXVA	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	1675	1216	425	12463	14861	jxGRx7M2XrJcS5kHJrCEjms3SJ31AQ6o7kMmSkVfEMruP1eWBcK	11396	16049	16049	1618828020000
22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	22790	3NKfkrYjmrrNH7ouBxnQSS5q5p8sVse364NyiJcxSxBVoLnhC7rm	1406	1393	425	12463	14864	jw7svmjmqjMfLN8qimMF8jqEE7zyhbELZoCTJZQ5UALnq5Vtq7v	11399	16055	16055	1618829100000
22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1422	1337	426	12463	14867	jwGyfYhVGbWi5rmFNMWLMVBoYq4E2VBfMqtBwaJYEzFUGLvQQGq	11401	16058	16058	1618829640000
22796	3NLvkEcCEQHFj4hrdF5k3vH9BSUdLQbSeidqupdLHL32zwfsaeAo	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1422	1337	426	12463	14867	jwygpsCED6KJyfvyj2HL6rBbocNXSzwkZ1Pygq6Rjvwh7VRwM5w	11401	16058	16058	1618829640000
22798	3NKdHyBPbm34ibBh1SwuprfWaVMzSZwoJc6Cq79SbgJNVXtPXT89	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1506	1373	426	12463	14870	jxz2Ci1fcotzsZwL4HXsiSbeq2LKxL21Wh52gThnhnQV3K28xSu	11401	16058	16058	1618829640000
22801	3NL1ZxmSARu2DjqddoPrQJqtfF4aHo3CSGa2P73DC4L3dEs2pX3h	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1560	1291	426	12463	14873	jww2TX3U9iXWUinky8FL9XpvuawACWuRYs2vjEPMdL8f5dwwvYd	11402	16059	16059	1618829820000
22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	1407	1395	426	12463	14874	jx14f2gbCK6LpafMeWmjUyzkkyAqK5ULSMCZL4teXShRQrnYUSu	11403	16060	16060	1618830000000
22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	22808	3NKjejCv4MZVWJL8cVaX6UxQmdBx8pGvy8ETurh7qEgVbq6UrHgP	416	416	426	12463	14880	jwEmeUPHhLdgKZBMVyakVQNbu1yzBRfN71Qq6MWa1D7WhBo9PV1	11407	16064	16064	1618830720000
22812	3NLG6tkcp8kNTod1y1i8nrAkwZsvsN7Hi3nJ6ZV4eaKrmyRC3pyb	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	1631	794	426	12463	14883	jxaopB4NWsFQxqhRLuhgkUCafYMBmeLMEk1nVhfrj6VZjD9umpR	11408	16065	16065	1618830900000
22814	3NKBpWx15YTnCXZiCsDuA3K49knwXax23Nd2XFDEJBGn9jbJfVJf	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1637	816	426	12463	14885	jwT4KVk4om6jQxPKGkRhpmHyUMg3BpMnUC9kwDKoftSLvV8fiSa	11409	16066	16066	1618831080000
22821	3NKA6dyh8rUKjUNrYz1iTRxisXssm6wGp1fLTB9o2U6TZ9wQXQhF	22820	3NK478rt7ioWi9Q5wYYVFfMUz3VQXvyQhdfL9ev2hCvaao5fSKy6	1647	846	426	12463	14891	jw7nLdET6bMsQmJS3cLNxBcBzifu5xrvvbEmoB9QVRwmfH3atrU	11413	16072	16072	1618832160000
22826	3NKtv21TbNTg99sa3s4zGxiZZRLgp94HVf2LeYnu1P7G6L3LADqJ	22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	1474	1329	426	12463	14895	jxgSExgwrCb5t27mCMWtpmqQSpxnzYJ6en6UCCb1izxhHDmkGRy	11415	16076	16076	1618832880000
22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	1637	816	426	12463	14900	jwZB5zfnXjV71L6PesjEBQhqcawU1FdMej6zjWP7aGnyBxvNWSB	11418	16079	16079	1618833420000
22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	426	12463	14902	jwqykwaB3YvDropASTVuis8HYbUgxFa5LBrL5kUPs6VCY3czCje	11419	16080	16080	1618833600000
22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	22837	3NLbFbXnmFQiERkcQ3uuWVHRzJrJb44JEgrQHwpbmJshMtGJyQUv	1637	816	427	12463	14905	jwcZf4qEx28pPV4zEsna9WshaMGgMvgKs9EQSfWdypugrFMfu3A	11421	16083	16083	1618834140000
22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	22839	3NLJG4U2Phzw7AHzxwSJAEPafrWcqtiU9baHu38gTsETZFcXHaiD	1637	816	427	12463	14911	jwBL8i2YTwsbCUzrfnWjcCwmN84RMxEf7ggjpdenJCcf3zhKzSk	11423	16085	16085	1618834500000
22846	3NL5ywLUH3ehTpaHnpWNjBcXpP2ozs7iAx77deMS6Q1DC9JQ7SE6	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1406	1393	427	12463	14913	jxnpT7dtcohtqRLFbCokAZkJoqWSNB8gAnHaJQnvcHBHJj7mmBx	11424	16086	16086	1618834680000
22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jwjuu21uBm44qqjieWMUFyUHHyiWJZvsJXzGVyaBN7tVfY9KiSZ	11428	16090	16090	1618835400000
22862	3NLrgqwGFrpUDoAWv55Vmju1Pc8g8es8Dg6dVJsGg8CKxn53AFY2	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1448	1311	427	12463	14925	jwErmJWCUJNLY8Emy9RCez9V1Gngjt2ycCgaahhhrJDbwt4M84u	11429	16091	16091	1618835580000
22866	3NKu3RzQFk1y5cKdUKdvc556oUErNW44wuNMYFKbnWPZL5qjhZkh	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	1542	1304	427	12463	14929	jxfGNoRZ5NdBPskvSMfqgoghhP4V2HorxyZmtrWmAstcUxgtMVE	11431	16093	16093	1618835940000
22868	3NKRmRnWkM2xnjR4QvGejxUvpejfG7yvM1L5ffpbHv333P5sQy21	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	700	840	427	12463	14931	jxXWn9xXaX8Wmnn3GtXehKp9GmgyJPnLsjrQ1X9YRYsmhQT33hr	11431	16093	16093	1618835940000
22888	3NK7SSvvovCgmb8hCwAf7K1Av7H4CSfAuu1Gt6yokcFvEyLcfceb	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	1534	1071	428	12463	14950	jwrBXaHtkpSsHSaA1Uy2GLtAJmvdouyQY22NgdKwApBcyvUYfLg	11442	16106	16106	1618838280000
22890	3NKRVrJ2EFWL48rZfhF5B2SR8k4cE3oStohbyhSZotc2usNVF7DP	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	298	1308	427	12463	14952	jxVwJxSpu8Frq9CLePzNuZqwSNFzHSYkrW7Zvh8pvkZ69ao7nUu	11431	16106	16106	1618838280000
22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1541	1298	428	12463	14954	jwEL78Lo6zygRf4uKdDqz4aDQHRBGCsbBDxRoRg1pynbyRu9BUv	11443	16107	16107	1618838460000
22768	3NKYVgp6qKPJqVx9eGM5h6gu5hsViJDJro9BkvHC2BuEkfjJ6StR	22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	1651	1175	425	12463	14844	jwcjhzoerSSsLqbbV6AGhiRrKzrr7NgcfdAMxw1H1zM5tKb9mH9	11385	16031	16031	1618824780000
22770	3NL3fsmbaEMH2GAPyNbUmM85ndZLBzuq5nKKVYBLHWBA6Qxat4ZJ	22769	3NLr5j8TMLfnR9dcqd63x7XoyA7Sctkw7yM2Gu39f8LuuH9U8M81	1406	1393	425	12463	14845	jy286es85fF4Mo5Jvdf9mG3wuazr4f2rDRbXQ1fKVSgEi9oM5Gq	11386	16032	16032	1618824960000
22772	3NK5StqYGqbzbsQ3PLe8T1TZFmJUxZzmqdT48SHyPZqVL1N5ZP8s	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1403	824	425	12463	14847	jwK2FMXGVyxqq5CT3hKXMoZGWpm7ybgLX5XbyatYocZLDapBoF4	11388	16040	16040	1618826400000
22774	3NKyJC2qnSHY8RQJevSX7Pf1cY3P6o59bHAGyTL7JtwczbFKotCe	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1581	778	425	12463	14849	jwsYNm2ACwcwiYidvCSmSdnjj4LpmD8UDFubY5JbzQGSWAPPDGg	11388	16040	16040	1618826400000
22777	3NLik5voCQzVY2y6L7i6Nov3RywAznMLM5FZBQpzuVjwKYbo38TU	22775	3NL4GbcDg1TMiv1wjfg93EsEytghjj334ochcS2uWzLneAJ8C4qJ	1589	1286	425	12463	14852	jwJXTphknapXY6oNskMRe7hzeJMWK4DJoAT6YnR4mQ9A4C2pjkt	11390	16042	16042	1618826760000
22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	606	929	425	12463	14855	jxpMi15t2c5DJ1Bhm52BTqZ3VzUXz78LZBdM15dj3q7p2ZYjRtK	11393	16045	16045	1618827300000
22783	3NKKZa7Ma2vGaEp5fxghTdfFMoMy6M8CKVxiun2GfZ7gDNNPQqRJ	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1529	1316	425	12463	14857	jwvqEdhjroKS1eRsp79QGUGwnReEc2W8CAUPfw2vf3pchkJJfJc	11394	16047	16047	1618827660000
22790	3NKfkrYjmrrNH7ouBxnQSS5q5p8sVse364NyiJcxSxBVoLnhC7rm	22789	3NLgM7Khzi7BvN3HRsAb37EnMfeFbYYr4xM9NAmTy9BURbpErEzL	1631	794	425	12463	14863	jwhxjQaKQaFXrVNqC1yM33y3JEwA1HUCyafviPLndXWRyY2gTUf	11398	16053	16053	1618828740000
22793	3NL9C5Degoa96xAxG6eBhqTqyH6519eNEuMmyfKuTNAFeYNVA8ZF	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1403	824	426	12463	14866	jx3HestFRqjc3rhST93pNVxSdYvE2CVTRYxeDQ3rAM4CCaNv6AY	11401	16058	16058	1618829640000
22795	3NKqW8ThSLV5KMrSAQMePpYuzGWf54deH5bKnPUw7T524c7dGX3W	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1483	878	426	12463	14868	jxK64mEHCtbZ6ZuCSYgSbAMwwPaoxc8pkpfB4hbCm2ehtomwHVh	11401	16058	16058	1618829640000
22800	3NK6Nocu46bK1fFkyK2CMaBJFd5o68AADeB9fqS2twbJ6uW5dfcd	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	413	413	426	12463	14872	jwSXs9XZ1ou7Cy9obe6TcXQLmDdaoQbepNAtaEytwH7SH3n7khU	11402	16059	16059	1618829820000
22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1609	1333	426	12463	14877	jwhnDVsF5rXuvNq3T1isxDCjZ4EBhUQ7RsFUUaGdKGb12qNHtqK	11404	16061	16061	1618830180000
22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	576	1355	426	12463	14882	jx9hx89X6TUtMpEwHSptKRMKavFKwTzSvXBkodz8ZLKQTaxgmo4	11408	16065	16065	1618830900000
22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1648	1038	426	12463	14884	jx27UfgVe8oscw4ZZEqBuWrtT7WrsJr6DceYxE35NchzcRSw4Eg	11409	16066	16066	1618831080000
22816	3NKbwncHHbz6fSBrJJnKnzkPaQUvmUqa5JTxn3JFSSumXfD4BD1T	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1541	1172	426	12463	14886	jxgJ47WLBxE8hAMQaF71ZttjEHbe9KTgJwMaeH5R85BNXxfr46g	11409	16066	16066	1618831080000
22818	3NLGb91UfgoPUeojV8xCugcgQsEjHFWLzSEo9ydzNnW3p6N7zz5o	22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	1406	1393	426	12463	14888	jw9A5mxunuNx74gSqybFySL8Ak4dNr2VDRcJATGwjBFbyz6hDAM	11410	16068	16068	1618831440000
22823	3NLU4ZLFpTXekL6KRQG6Au9fH9qUFjR8vphdxktWnuMAJxosbsqb	22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	1507	1280	426	12463	14893	jxSRB9PXMc7Fru5CSDSxK4ifZAveDv3bq7iUrguwAsS7995CoVw	11400	16073	16073	1618832340000
22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	1657	1218	426	12463	14897	jxoPEqYpFGKfs384ufTWz2CHcZ9XdKEoj7W1FaUMqX3zaLgfaYv	11416	16077	16077	1618833060000
22837	3NLbFbXnmFQiERkcQ3uuWVHRzJrJb44JEgrQHwpbmJshMtGJyQUv	22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	171	1008	427	12463	14904	jwEhCmKhisyDzpbbPiu4eRAFAYBM9vBjMVm7epMcXbp3u8haA89	11420	16081	16081	1618833780000
22840	3NKfFoB5Y4a58rYyZspmXkmB4rips4CfnQuTWsj4tBWqwhuhopAa	22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	58	1281	427	12463	14907	jxD84qajaMpMKK8wDjcQhPUioGaoZ5GTphAPxBnR85MsiHLBNPz	11422	16084	16084	1618834320000
22843	3NKtHMCP7hS2AJk8xnq6GAA9BLxK596byJ79ZXnzTDX1tgH4j4Fh	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1509	1320	424	12463	14910	jxoSQEc9cw3Uh5yzMRZchbURzpxeGD1sDWWYjsua3MrP9PkVboq	11382	16084	16084	1618834320000
22848	3NKTApTRnpZ5m2xJpDGp8GBsUEUDjdK4tLzNaKpUMm1GrRazeXct	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1637	816	427	12463	14915	jxTD1LMFKN8d1EYQmpbLjfuyE3aPZgD1e7jNJgfdwtjZDXUS9kA	11426	16088	16088	1618835040000
22851	3NLckmaftVVJ3vKKoWdcM6kg4H2qMt3mx2oun4ECBX28PkrgNYWH	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1500	1297	427	12463	14918	jxS2PUcQ8tEg81fdGVVbsZessqZ2tt5iq3YUkxxCUdYmUh3tHw4	11426	16088	16088	1618835040000
22855	3NLHmN4ZbPA6nSdvHh4d1yCPx2TinLhshDUt9yzNBRCngbdT9cEi	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	298	1308	427	12463	14922	jxTh8FmLMYWdgf4jDNRZFLoUoD9hsHkRwZnqjiHNQy3TaM2gCk2	11427	16089	16089	1618835220000
22860	3NLKwXZD71vM8Hzn56tFhBsVsfBjPcxd9s3Dig9mYBTHDtTjUeBL	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jxE2F96VBb2rHgFK77wMRyLsJf3k6ufk6jcT4rPVwj2TKqEgYeF	11428	16090	16090	1618835400000
22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1448	1311	427	12463	14925	jwbLKWw2kcXhtiypve5swR4yWaHKZU9GFyG4qrzGF5a4aUX5qvp	11429	16091	16091	1618835580000
22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	1445	1290	427	12463	14928	jwcXjUsLR6YNneXCx2rpHTXuhdU3KboDZ7BihEZMNT8F8jKLb3v	11430	16092	16092	1618835760000
22872	3NKDiiV4jRj5MMcMsfpSqx6uCCGXg9KWBdHewaD2DPe6yh2GezVu	22871	3NKuZQZjSxqicf1SntcYCeGSQxzaZRQzLreHL7ztE3NVcBvn96MZ	606	1169	427	12463	14934	jwBk3WDYnrjwCZKzuuSAPX6HFqBjGwdjUb7e5vuzxGA4819yuAy	11433	16095	16095	1618836300000
22875	3NLYC5qRzAqCNR19X14ASAH1CdPcFG4ZTxZvokqSG18JB2KR1m81	22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	1650	1249	427	12463	14937	jxyop8fvBXoKvFhqSMJo8Dk1Yh39EKxnR5o41FryFE8mZ1Dz2nq	11435	16098	16098	1618836840000
22877	3NKHJqUfnNH5TycJTbN9A3VJuQjwebzHFwFa6ou6kiuwQEBvYTER	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1406	1393	427	12463	14939	jwm83wXAhj8omxCGxP6qrizccM6JehHnFfTUFeNU6k2kcorWVxN	11436	16099	16099	1618837020000
22882	3NKtJQMQj9WSu2pb46cPy5jXycXDMoxmznAcLcgz9HBbpdDYAFWQ	22881	3NKHBouqw71aDZyr2GJfEUVmQ8DB7DWjP8EP41GaYkqU5cmYNYAp	1407	1395	427	12463	14944	jxj5J1URZswt5KvHGMdJ1ciqxSCAub9zyFT7gZGj57YVQcWMD4g	11438	16101	16101	1618837380000
22885	3NLx3XTLmHAbdG7m1xW1wwYnmAFiGtjWEqFJ7VMvLMtMMGvzAfkV	22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	1600	1372	427	12463	14947	jwnxNhTZpqCyycR4HDvuisjP5ayRpa9wJ6euJ5xuBzJXnLozA2V	11440	16104	16104	1618837920000
22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	22778	3NLN7PotE9yVdmb5TeVJVKUPLn5uPjVgBMbySDqPmJAqs23SbZSr	1581	777	425	12463	14854	jw9P5cnBRgsL94TUox2dV5rxf19ML4qDzExSWfDrHkzSSSHPzPL	11392	16044	16044	1618827120000
22782	3NLEz6VEqzjQEvU1yAkMoWmCo3Mqoa3N6ERTU8DAtjAA69BU52i8	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1529	1316	425	12463	14857	jwoek8oWjuaRnqfS9TawfrAKVSaXUB46ibQ5k6RePkpeKKXxgqz	11394	16047	16047	1618827660000
22784	3NLnWNuhvGTmFL3FGQRTzmMpBRHPGCoREymNMqz7VLxBW2n2Bhbs	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1672	919	425	12463	14858	jwSLXuSn1HhCS8ngjN7BCVRqpobhxNJ9WZgBjXiJNrQ3ec5PVWV	11394	16047	16047	1618827660000
22787	3NLenMu6FJFWkLbn6RfZ2skzxNe2thiffLERJ33Zam4vMozNzZNc	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	1675	1216	425	12463	14861	jxe3nLCDMXxwhqjifxhD4facgzbdBsZ19ZCEZS9Y6txSegocpV9	11396	16049	16049	1618828020000
22789	3NLgM7Khzi7BvN3HRsAb37EnMfeFbYYr4xM9NAmTy9BURbpErEzL	22786	3NKjUkA88cZkXAiPsTYthyezde4UWAEQ2keKxgLWRMowaZxUERre	1407	1395	425	12463	14862	jxnPt5imb1s5CVby2SwjTxaDnXMK2CHEg93Re5M1GDv2yxQtkGM	11397	16051	16051	1618828380000
22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	1403	31	426	12463	14865	jxCS4X7rF6aW6s8FRN2FGNjcp1tXCU2sisFgVhpAuDMVgH9aTmz	11400	16056	16056	1618829280000
22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1407	1395	426	12463	14871	jwZmzwHuQdP2JpVy7huyZrbQbm8Xp1EnXaEJCncz93rdo3aBKuu	11402	16059	16059	1618829820000
22804	3NKXkUddXTLvd3uFcTm7mUa9sZziZX2YxE3fmMtfPMR1N96JxMRc	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	58	1035	426	12463	14876	jwd47DEsfhUk8h1Pz6UDAKAn3paAVVZvNi6QScPSymdBXjttVsR	11403	16060	16060	1618830000000
22808	3NKjejCv4MZVWJL8cVaX6UxQmdBx8pGvy8ETurh7qEgVbq6UrHgP	22807	3NLN8QMQHrK9ERkezzBvmQYEgitHgNkR5fCYqarKLFnhqgTdSsBq	1406	1393	426	12463	14879	jwT5Q5KBYgTRDdmieFepQqJWH6d5sTkWyDFBZZq2aWozWtMoij9	11406	16063	16063	1618830540000
22817	3NKV4zCG9m2L8ucZb4dtBGVYdqKQr4aseG3vU8i3P2zAAVYagt9W	22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	1407	1395	426	12463	14887	jwNPuTFEGuGYugGBsn1XiRvnXX32Qr5WR7SoScMcHZdFWYSZP45	11410	16068	16068	1618831440000
22820	3NK478rt7ioWi9Q5wYYVFfMUz3VQXvyQhdfL9ev2hCvaao5fSKy6	22819	3NKYTJegQrHb5MDEVo4KPDVT4ruQSpLTmEAyKjhHa9ix4iisFcYB	1588	1146	426	12463	14890	jwPUe5RpEp7zneLhhSAiSxrw7VYvM5BGbdBDpuQxgw9ZzPN1fMy	11412	16071	16071	1618831980000
22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	1474	1329	426	12463	14895	jx42JsRQPkKFyM4wDR8wMboZu1TjADVAFeVN3HVwdNr6bqKxNwQ	11415	16076	16076	1618832880000
22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	1571	1089	426	12463	14899	jwLXym7U4yMZchCZmnkveDxoHWtBeDGxSRCgW1fSJMtQ8TuRdJ9	11417	16078	16078	1618833240000
22835	3NLVBsrJLKKozAETNXnv1mzmmyQ998YjKXYLv3uQFZ6HgajMKxLV	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	426	12463	14902	jwcztmkRhKzqdYyJqaLfcxDesZ4swiTs2YJ5Tvzed93Uc3Urvp2	11419	16080	16080	1618833600000
22839	3NLJG4U2Phzw7AHzxwSJAEPafrWcqtiU9baHu38gTsETZFcXHaiD	22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	1509	1320	427	12463	14906	jwL2ANcGLL32yTkW53W7nVDLDQVUfrpuzYifx4sRgqioAqfiqU5	11422	16084	16084	1618834320000
22842	3NLUFv8EdEcFWBYLh5kJXRyYWvRzGEp1XVZCY9heeLFsSoXBabcz	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1509	1320	426	12463	14909	jwFeY3RXH2u73tywaKSavfMGFAbTWStkQ4Q2t9cgXUqnGPiVkzR	11404	16084	16084	1618834408300
22845	3NKiasL8LTQ1itLnGVRM4BBGYRcfUvSbmz3KBbrV7Zpy6ugfkvWY	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1403	824	427	12463	14912	jxAecfrjg6QmmRcQJ3Su2bi5NP4ViyCguMARuxhzT7rJnCPAmnT	11424	16086	16086	1618834680000
22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1509	1320	427	12463	14917	jxsn96aLaLpGZoB6RUsg5JdKjECYZxPjL3d3ZKGDEZp9Ndh7fwv	11426	16088	16088	1618835040000
22853	3NLKkok3XMK1QUNNnNdFhVakQZxZYCeUKAHKrrJjpqX1Fg2nAoFP	22852	3NLxrAyxwZvmpmMvGJ2WCjCuxk56fzxaxwF9Lgw11543fcFesSSD	1509	1320	427	12463	14920	jwJgbVipb6RbzMZxwKgvQzqrx7R9xZn2hsGKgWihEdsioKxw7ny	11422	16088	16088	1618835040000
22854	3NKbpdjthuMthuQPF3K1DhgXTRD9fWkiryfHiEngRzDamHWmKpFn	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	1407	1395	427	12463	14921	jxan9A5Zk8d6thXQkKhwxn2yg2aN5pyAQNKKzvnUiir4LV8RyjZ	11427	16089	16089	1618835220000
22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	298	1308	427	12463	14922	jwxHxM7Kp8RmoEXLC7DnzGnYmSbyGgQZv23jrKHpNqrKYNBit7Q	11427	16089	16089	1618835220000
22859	3NLNzBKwDuM6gynqLTgHtcnBrHsuZKDJ732ChjvhmBJK3LmqNPRo	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1406	1393	427	12463	14924	jx2i5XRCts2VQ16XLHtGju1fXYCW3WZjwhtNon8eE7aPH3NWWYh	11428	16090	16090	1618835400000
22867	3NKfd6juqhdZpMT8isydbJaHYwaYWx2TnTarmNVcPnncxvQjdbar	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	1613	1349	427	12463	14930	jxiqRnEqHq549JrD2XK477DfcrjksyCKYo2PPBJkzc72PZiJDY3	11431	16093	16093	1618835940000
22870	3NLiLTxR6FDZEKKBaNSnHoWgBUF4da1QxsN3hYvCfoexJZEV2DdQ	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	470	1309	427	12463	14932	jx2737oqjy4ihBpp3u5hjGVKTAS3yhBd14NCep8Y6cBX2pdThuB	11431	16093	16093	1618835940000
22871	3NKuZQZjSxqicf1SntcYCeGSQxzaZRQzLreHL7ztE3NVcBvn96MZ	22868	3NKRmRnWkM2xnjR4QvGejxUvpejfG7yvM1L5ffpbHv333P5sQy21	1406	1393	427	12463	14933	jx9f7w72khQR4TzA6whh5irVV466eE6YrZ8tDrAuL34fgrM7p65	11432	16094	16094	1618836120000
22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	1594	960	427	12463	14936	jwPTCdTXXbu54t515pGecLj4jemAX1vVoK1X5eMbVBkQZ1QBnNJ	11435	16098	16098	1618836840000
22879	3NKkPKKoMWLHENtbW9wzG2re2eZW9vejXLopfq2RrdFFgpSEnCiM	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1419	814	427	12463	14941	jws4sx5YoYMNir3qC8k3BvZg9qUNaC6rCKpST7rSnUJ9qkT5KjA	11436	16099	16099	1618837020000
22881	3NKHBouqw71aDZyr2GJfEUVmQ8DB7DWjP8EP41GaYkqU5cmYNYAp	22879	3NKkPKKoMWLHENtbW9wzG2re2eZW9vejXLopfq2RrdFFgpSEnCiM	1397	838	427	12463	14943	jxEaHkkxG5zd5vTKykDXc2W4QLPjgYQQMKA1TDA2iX35b5QXHMo	11437	16100	16100	1618837200000
22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	1455	1206	427	12463	14946	jxbPPEFWmF6iLm22xvwFuSYGsvkrsBwYhsSdnZEexbtdkk8mVut	11440	16104	16104	1618837920000
22891	3NLV16Z2JrsP1naLQo9W566kvN8hsVTYh1CLZue41ostTpkYR1uN	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1578	930	428	12463	14953	jxpUUSJY3ZziEXGH7ikPRKKJdSu5hQjcyQxCGRhSmrjxRU5uPbw	11443	16107	16107	1618838460000
22893	3NKUfFjNHRU17khbEuxswjH4x92M8xbKiJH8YFcvu4dFAz5EDb7F	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1541	1298	428	12463	14954	jxq3wBb3UbRZrfvgRtyzwzxYkYX6v6y1Sa9w4pU4E6Uei7QQb7r	11443	16107	16107	1618838460000
22896	3NKsMGDydcDu2huvs76bG9PfJP4JJZJ5335eki5fv7c5nyWmsTAP	22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	42	1115	428	12463	14957	jwmR8AYKzSTTGDTcJFqcAgANXoJGBZfCVZYXUjokiDGwSQG9Hck	11445	16109	16109	1618838820000
22887	3NKdQcwQR9UrUz8LPVU4veVsETDBkHyTWd61YVeptUx7zqMwJZNy	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	1406	1393	428	12463	14949	jxpheMvE2KwM7QJ3iVD1DPENJL5bGpJtGzTKEtmh2SdDgVKtBE1	11442	16106	16106	1618838280000
22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	298	1308	428	12463	14951	jxFA3AkveWyN1VBBpAPXDoJivUQacG4raBseRh2S7eKwUkriMFu	11442	16106	16106	1618838280000
22894	3NLHejteSrhn3YQDtUzH2ronRXsTLgC3pikzecR1U16oCTWKCuSA	22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	1637	816	428	12463	14955	jweZKkQwaWLgMagNurWxw6Hc6JMasZxEqfzYHPZxkJtCydL1fiV	11444	16108	16108	1618838640000
22903	3NLCYw8tPL1oxKM3qVRpPYPUBEQoF118RnNXrhv6RLGq77sXbUMk	22890	3NKRVrJ2EFWL48rZfhF5B2SR8k4cE3oStohbyhSZotc2usNVF7DP	1579	1143	427	12463	14962	jxyrnfqemtAwKf2rwg74mAjm2NyWcYFdQAb7NEXVCG69xbc3j5p	11432	16112	16112	1618839360000
22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1637	816	428	12463	14965	jxnVyA4RTA3Eykh9GTQ5yfrikbKWaAGMSnBbANnE2WkXM6qumDv	11449	16113	16113	1618839540000
22916	3NL1xfCKTUp3u6R7cLW7msjx2PYCLVPm778EuRh6Mi1CpSmkN3gy	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1474	1329	428	12463	14973	jwkLYQfHKcVw59gf6GGsTp9xvrjM2GkKQnpKtutuMsgGvY8N9zz	11455	16123	16123	1618841340000
22923	3NLBJPcVTai7ooabNtmXGyEYbH2ao4gDRzYfRAybVTC76Mntuqv2	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	43	1064	428	12463	14980	jx7pYnjtKYdAkf9eXiDRZJxwXRXbornwU7P2Xg8hBLQL14ji9TP	11458	16126	16126	1618841880000
22925	3NKZVa9NJZM83MDs9sPNELwQPVDU2HniWRvruAYhmRD8vKSHHZhM	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1593	1346	428	12463	14982	jwNrGNRj2cfUYZUpfGFybLZ7oWfxjVvcWBJA842nMgkHDccKS62	11458	16126	16126	1618841880000
22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	22926	3NKzdFpYp5o2iMk2z9Qz1hc437J3STK6T1EbBbask87wdsPQxHDz	1406	1393	428	12463	14984	jx8J1EuwCAhknywJyfP8sKLKsdAHyAcSfcayhqCcZqPp7kEu3xC	11459	16127	16127	1618842060000
22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	429	12463	14987	jwvhfkTMfhZdyxfdMoy2KyiFm4XZJYWZeYvtGXkAzcWv9EWUmmZ	11460	16128	16128	1618842240000
22931	3NLjEEMHUwQXHiUtGCvnkBeAmphTnZhVAhQgYFDxPM7uk2FG6MFV	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	428	12463	14987	jwQAb6HW3qLkRFY74G3uLHWtib7biXbZfNnXtwwjLVRxVsnvoAM	11460	16128	16128	1618842240000
22937	3NLwtaWBmWpGFhtFrhTNeBeby5ckRn3tq7Dr7qhuRoWJdyMTeYpY	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1406	1393	429	12463	14991	jxPzLcRetcJUsii73jW3ePkULZgkPm5mYJr9uHTfuBvBsUVcMDs	11461	16129	16129	1618842420000
22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	22938	3NKb63mnGByZ8w6zEcNjYgXnRbiHgFAhQKiM7e78rPFjcPZ8hZU9	1675	1342	429	12463	14994	jxHJCJpv4gkP3Lgs8aMtCPGZLpK58BqvYo4j2t5UH76CZh6U3VK	11463	16131	16131	1618842780000
22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	1560	1045	429	12463	14998	jx1mFhrQhWHpv9YifDJaTBuTzj4q7Z6vAqbcbJuqigjZ7Wgc4Dg	11465	16136	16136	1618843680000
22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1508	1387	429	12463	15001	jxYEiKJThZ5gW6fUPwakatcVNkbKx53EykH3b6pHJNWYKymjoJq	11466	16137	16137	1618843860000
22954	3NLx6E47LrZsYW6YwiGhhU3LEMaWfXJ9j4gxvtZf5GDP9PcwePxA	22951	3NLYAUKYSoMyY1oLrjB1BGFiLriEU1piZj3YBP1hgqMULNqe7361	1593	1346	429	12463	15007	jwCMYcHJVd3E1vGzDGPr9U5JYzBsryARuqkXHmonDkKNya3468H	11468	16140	16140	1618844400000
22958	3NK7p4fiSTqeXXd9WedRKHGdStc3KiCUjH4zWXHG2igiNde4ckid	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	606	929	429	12463	15011	jwBTvKZgbAgFmAfdJ42VK87BWXy8iAiDannWmBwDD29sSpDwLo4	11471	16147	16147	1618845660000
22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	1426	1118	429	12463	15013	jw9BjtKoMZzrTcyva38JRVDt4Uqv7aDdHVuZxMrnoFPddvCqAab	11471	16147	16147	1618845660000
22962	3NKwB3kyTjo1DnrV9fGTsLXcYPiSsnbrk4WJ1wigbQz22APDatmS	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1406	1393	429	12463	15015	jwUqSsDzy6iQfgGnqGWYafPDgNvabPdzTepXuFwTnWiQNaCjZ8t	11472	16148	16148	1618845840000
22964	3NKJZDLmebduDaKN1KzXMJxj9p5skRSxPkEFDFq7C7RDgeuskD8r	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1560	925	429	12463	15017	jx4jZqPutPPrNh8UKF67ya3sKaBKg1MRAy5j5XEPvktbLw48dy4	11472	16148	16148	1618845840000
22967	3NLF8FsDLLwy4z4ynq7UnkUJDFFNjWBi4ExPBgkzbtCm7CJm7r5B	22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	632	1382	429	12463	15018	jwHtKjVb8Py4keHg22WYGndPxTuwXYsfFX3VXwo35KgZBCjMJMn	11473	16149	16149	1618846020000
22969	3NL3az8GoR9fNQ3ByNFN4ek1DAttAuUyj84QnaFbWbq5FjpxbhUp	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	606	1295	429	12463	15020	jxUweX8RMyuFZwy7b9rqKR5rKReHoXbqiCecFGfqsS6VfoibcMH	11475	16152	16152	1618846560000
22971	3NKZQtLExfTVChCfKDDKGXtz4e1aixL4TMHfdnLUPZucaY82kaoq	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1541	1298	429	12463	15022	jwGcoBVQ7JeVs15SWyNzyoBfzjn9r4ZYn79ZV7DRn3nkAoMBviC	11475	16152	16152	1618846560000
22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1566	318	430	12463	15026	jxhV7auArSJ1fnV9YBhdEeMpmnKe5igeQW6nrx8FptNmpMKTvoV	11478	16155	16155	1618847100000
22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1553	776	430	12463	15029	jwWYNAnnwrbFLCG9GL68LrtZWMg7gfyNiPGGewFHm7zmhucbLbe	11479	16158	16158	1618847640000
22984	3NLNPg8L5Bv8j9GJm4a29GqKfA3KeWh2aeVcWcPbb8RDLzmVhhGZ	22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	1607	1102	430	12463	15032	jwA6F1JHuNKouzNCZincyp5ksGnUGVz57ws9WHQpjPRUUbgiP1C	11481	16162	16162	1618848360000
22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	1607	1102	430	12463	15032	jwUytJkBsG3N4ZcpE1zARgizpMeBpLMGBkWq5wes3T5yfguLUqW	11481	16162	16162	1618848360000
22989	3NL1PXQkqvXtmkeq7FXUoFE63tDCgjNuvdx92U3FkzodxbGtA6pa	22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	1467	1376	430	12463	15035	jx6u9enZJSnfGh47NaqXgaphSSRmiotezs7fJARqJHXmdK6nrMi	11483	16165	16165	1618848900000
22992	3NL6ZWG4rNcwzypvTLt4Xj7u4AoTK6d69F35byMrqCeCwnMMeN4C	22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	1581	778	430	12463	15038	jxoS8UaHCjFdTsqoALFToHYKhPFggKinDmQS9oJRxa2H1cCe7VN	11484	16167	16167	1618849260000
22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	22993	3NLQLKZKFUEWxpNYAceG5u78t4Pt2j464aUP7YdJRW5EEE7o3qrk	1406	1393	430	12463	15040	jwwjSkRgYyNew5aeyf6wigN8cqZDEHna6MdRUUwo2cGqZzL7bhp	11486	16169	16169	1618849620000
23001	3NKgpfdUbAWay6bsyXAuxxX2CyTsaocrtGgQ3A6VxNBM5as6W3nF	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1406	1393	430	12463	15047	jwngutEbCGCZNiWZu14p9MgUMVM63Qm13nw4pceyq615zmAJeM6	11490	16177	16177	1618851060000
23010	3NK9puE2SDfwgdEUtYrPAkZEavrQWTDdPE4MDemUFfwrkJm32kwq	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	1490	1028	430	12463	15054	jws6WEvF1rxY6TS9MvFKRKnkYPvWtfaPo21gXBUb7Lmj7T1X6GJ	11494	16182	16182	1618851960000
22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	1642	1121	428	12463	14958	jxWUgf9agsC5XG2Db9S8Ve5JA9VWdfZX28F4uhvyqTfcaReAvCx	11445	16109	16109	1618838820000
22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	1571	1089	428	12463	14960	jwiMQj5vf3Hmajzg1XM7YqmWJ9KwjyKnYNgjEKnrb85WqnazPR8	11446	16110	16110	1618839000000
22902	3NL1RjTrwykrVFjYRocvV7vu7UgAKiunmh5QKRUniTjgM7dm81D1	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jxLRQ6dvomR8yjEoacquscKD3LX3tad7SJfczuyBBDzHo8mY22F	11447	16111	16111	1618839180000
22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	1637	815	428	12463	14967	jxZrhuqZfLU3ufsMDoJA9E78MTbe3tUU7a2hMVpWNxoP2sGe3WY	11451	16117	16117	1618840260000
22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1403	786	428	12463	14969	jxATqK5cf2z6o5FPtwekkW7RAGD5FHg7EJC3Wj2qf46qav2Mvck	11452	16118	16118	1618840440000
22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	22913	3NLbPEsBbTMZxkcypkBaredQexnS8q6794pXcWnnf8kzrbsdYg4F	1637	816	428	12463	14972	jxNnXXLrzzxCBpQYZyKis6475xHHYDvHGwcungXGfuFCHJC2Fpn	11454	16122	16122	1618841160000
22919	3NKdhYs7VpTAWAzhqCxxZUxifzkert8iNzSiPAcWqC8uXzkT9pUC	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1593	1346	428	12463	14976	jwH4f8voatSCBzSPBCwsfZXPh6KYoYHkNa23coS4AUJoWV19YVY	11452	16125	16125	1618841700000
22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	1593	1346	428	12463	14978	jxRwHyF2tJrJaJtVWdwoNsPpZVtjkTZrHRFTAKoCqxDxU4pGX2i	11457	16125	16125	1618841700000
22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1503	1277	429	12463	14988	jwuHD6fDUPedTgRKtbauHfqTyxXCiwL6t32M6Xis1AxWzMuqkh5	11461	16129	16129	1618842420000
22938	3NKb63mnGByZ8w6zEcNjYgXnRbiHgFAhQKiM7e78rPFjcPZ8hZU9	22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	1405	873	429	12463	14992	jwXBQobqmsuUoQYibjijv6BYjnSU6hneXzMKP67BC6fQAXCaedw	11462	16130	16130	1618842600000
22941	3NLcp7sRGGmcVBhKd2gwjVpUEizV8wfzurU19WwoXJHcabcUXxn4	22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	1675	1342	428	12463	14995	jwVwZhsa3PW3zh8wAskZ32PHJaGdgggNrzF3ph3kcCdorJ1G452	11441	16131	16131	1618842780000
22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1607	1348	429	12463	14996	jx6jdQPHr9cu1Z3MvhM7oV9zafQbcK7dyqSYQkkP9Pa6wr2DrMz	11464	16133	16133	1618843140000
22946	3NK7hAxmwethpvXH8EQz2FDrAxTCQ1xScotLWcniWGTyq6sFzh1S	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1656	1343	429	12463	14999	jwaoobPf2nhTUdmQJ6hqJYTNpACe6ARfzDnVkmZALjxdF1Qb7iU	11466	16137	16137	1618843860000
22949	3NKABgHskPVSs2xfVghkpEqtD8qhNniZMYit4G7as6rPfUhX5WSc	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1513	1379	429	12463	15002	jxsxo1HpD2hqEhG854V3p3ohuf32HYUYYamEqNP9xbEj4GcqYTM	11466	16137	16137	1618843860000
22955	3NKvGgmrh1ihPEKkoNuweXnUiq4C4fR9PonsJC15h3cXDD4uzW3K	22954	3NLx6E47LrZsYW6YwiGhhU3LEMaWfXJ9j4gxvtZf5GDP9PcwePxA	1675	1096	429	12463	15008	jxkYufc2JndXRa4CbCTWLNLZ7sjyQ334pehnHi1JdckApqQLaTH	11469	16141	16141	1618844580000
22959	3NL5dvkEunkNgVRj2GdGt5XC4Hpr1ehmeYHFB38AC64rLFA2DrLK	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	1553	776	429	12463	15012	jxXUKzUhjKjRGHh1eNArS3JAsoR7go5Js2rcbfD3br4eiLkaeHR	11471	16147	16147	1618845660000
22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1607	1348	429	12463	15016	jx4vPDC6D5iQPCjMB8r7BfGZjLDai2Qbt2NSePWt2gVQra3Hi9E	11472	16148	16148	1618845840000
22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	1406	1393	429	12463	15019	jwkN8obD79Ze3o8QgVNF4ihyWkV6D96C9XwF56nvhzh7u3VGMiL	11474	16151	16151	1618846380000
22974	3NLUhb6YvvfBq7pzAZ92QLRQFEdZAvXGp7ChvThoUUiEN761BBom	22971	3NKZQtLExfTVChCfKDDKGXtz4e1aixL4TMHfdnLUPZucaY82kaoq	1559	1107	429	12463	15023	jx65hFUzfJU5oPumtGZzHFFJpmCYwVsfVQLgoP1T5LPMRJAWubB	11476	16153	16153	1618846740000
22976	3NL9WwLU498Vk8xTXzz5ugpSimaJHkzF8tPxffntUY27VYagSF3z	22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	1476	1371	430	12463	15024	jwDm9NjweR6hNxqyfnYvC1My3yCXtNwUxMqrWnaFPLvgJDmgPd8	11477	16154	16154	1618846920000
22979	3NLUtT5HB3kxEPPr6TCcSEXtQkssF4t4bMnapB7xURFzzWTmn6wV	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1646	1228	430	12463	15027	jxqxjTj8ypiRAsYXaR8jCRNed8Q5c3grzMnKjC61pR8hM2eq4Qj	11478	16155	16155	1618847100000
22982	3NLWo9Vij7YaXcw5Z4Ueo1bniRntfg9uea5ba8ksDcd7qVXyAoi8	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1406	1393	430	12463	15030	jxU7T2VAx66rvp2an2jsAYzdHC2FDRS6yAhowYYbJu3NQVwwg8y	11479	16158	16158	1618847640000
22985	3NKS2tj5jxt5ftSw7kEXVdyw1pepkVu8DX9J91txVZLPBzVSX4oz	22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	1607	1102	430	12463	15033	jxD6hZDMwEuRAMUCFCFmN1FqAC59ZM8H5PEY9qhd9bVFpj5E8HB	11480	16162	16162	1618848360000
22987	3NKAeHnL5zKEdPXQjvef64aerFHKTT4my1yvZtGjFPr43RpbeUcJ	22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	1439	1033	430	12463	15034	jxmF6fLZGvR9hU4AGvQRNaLjkzeZUqeDBdoayxSD3eTVQTi64v4	11482	16164	16164	1618848720000
22995	3NKmDLEnJGr3fJsdVkqVKzvHnNJsjKe3AgtFFBmbUgXHGRmxga1A	22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	1642	1367	430	12463	15041	jxThb2K3YMd1yBNsxoFvyJad1y5R9Q64V4ECT2WvWMBZNB3VTic	11487	16171	16171	1618849980000
22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	22995	3NKmDLEnJGr3fJsdVkqVKzvHnNJsjKe3AgtFFBmbUgXHGRmxga1A	684	684	430	12463	15042	jxArLWRmFGp9cDVYzweh34GPMuWaLkAp2YYTgwRkivY6BQgzMQo	11488	16175	16175	1618850700000
22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	1405	1	430	12463	15044	jwmyQA9YfmJ9nD8TaQgZybmyJztscHDJCWcrLSS1vgJbt5WAuXb	11489	16176	16176	1618850880000
23002	3NLaqJJ1pYZBcyZTar4567QJ1VxFydbGLzHQ6evevob4XRGfhZa5	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	171	1248	430	12463	15048	jwiN5iuXr2gqUtfZpXDUpLd4RRZQ96W6319PT2ug3WnLdm8jKqq	11490	16177	16177	1618851060000
23005	3NLi54FBZzA7DWQtkRG1fupbdLdGsAPTv2sV4M3tDmTurrEpA4E9	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1440	1131	430	12463	15051	jxX1pJftAtboCTU8q2UfFwqBHJyKbUqB2XWGQEb87yoBNGgX8DC	11493	16180	16180	1618851600000
23007	3NKYRnYQmSatrRX34DqLnfeMgg8VibAEdY31cUS955oP86LZpC4H	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1444	1381	430	12463	15052	jwtaovKHvZQdG5rtpZyffYomXVDBXf5yeXxMzVSiFANKUvk4MHA	11493	16180	16180	1618851600000
23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1444	1381	430	12463	15052	jxrksmw8gRALQgRwgjA9urnZqhMxDGuo7tYZcM7iQmPeQU13rzB	11493	16180	16180	1618851600000
23011	3NLyJ1DtEBmaAr4VYPVtUySFz4AtQN8xYQuZBwYxghX1VbJS8hfC	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	96	96	430	12463	15055	jx19ZcGr3Tk2hbBsdhMp9rjKiwMyeqxxp5Nb97wJKQjpRGbrp4o	11494	16182	16182	1618851960000
22898	3NLAhFTZmcLNECsGjEp8BMHPi9PQ33bLmWqR4VBthSyAAzoAvWyn	22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	1403	824	428	12463	14959	jwzEZuNKpZdP1wXvEuD9M3ugHspNGc3DGQhFSYmxGPX4TazpywS	11446	16110	16110	1618839000000
22901	3NL4eAGarsW1tW3iE2vZQmV81DhEi1mfuk3QoFurK9vbiXLu9rQN	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jwMXXqUPtau4QT8oB4XLfbVabY76fa1PMyj2orHkr9BryZo7iw9	11447	16111	16111	1618839180000
22905	3NLxtJExKmDCJ3tQ9SdRnxNwpssitp8UkHab5hryhWMbgQcbMZKf	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1407	1395	428	12463	14964	jxRg74LhfZQheTnW3tYL6hUbJrAXATU9x6FZ59bYvY7Kop3q1qu	11449	16113	16113	1618839540000
22908	3NL8A46C43meFErR1sVfi5ve6zTYHJrcddA87EkPVpvsMsm1psmD	22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	1419	814	428	12463	14966	jxRrVHJsCUPU4C16EQHHcyBmjGhodSmXgbsZQo35BkWtvcUhTe1	11450	16116	16116	1618840080000
22913	3NLbPEsBbTMZxkcypkBaredQexnS8q6794pXcWnnf8kzrbsdYg4F	22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	1407	1395	428	12463	14971	jx18LpYYwxQbmPqfNKoaqMY2FijXsHFBo2Akm6uxpfKmmDib6X4	11453	16121	16121	1618840980000
22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	22917	3NLyMocCmnq9yPkTxPQg9bJgPUyNt8PijRqNGgxZY6s2ndhitNse	1648	918	428	12463	14975	jxkAFJtmdxLGtD1RjWzxkpnDq6QijyfP9i1ogmta3CN1oq6ksqV	11456	16124	16124	1618841520000
22920	3NKZ8Esc5961aRZwwQD5tdhTCDuX72WFQNAJpDfzLGo4aAq5BqMH	22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	1637	816	428	12463	14977	jwLX7m8EujY7u7G91fFv4kckFTx5AeLMiueaF1fWuPshesyYkGE	11457	16125	16125	1618841700000
22922	3NKJWvBSYvwtZoPEdkv89H16LuG4866n3qG5dmo6ATAVd6cw54Ft	22919	3NKdhYs7VpTAWAzhqCxxZUxifzkert8iNzSiPAcWqC8uXzkT9pUC	1593	1346	428	12463	14979	jwFZyu6QxzLAYU5kqeHPKnft5qxjo6YnWR77vURxxSH2tiMf4Sg	11453	16126	16126	1618841880000
22924	3NLBWekPB8HeP7FHuYXCV1E4KnjSwYd275ob4LpkU2ye6aARjAEC	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1649	1137	428	12463	14981	jwW5Cx3qa6zgCjKkTL1JsJibLqDC8NwJ1xFcQxA73tprJejEYVV	11458	16126	16126	1618841880000
22926	3NKzdFpYp5o2iMk2z9Qz1hc437J3STK6T1EbBbask87wdsPQxHDz	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1571	969	428	12463	14983	jxChumZqnfSDVFEkpQqjpKBF3sf8S722jPnCwWERuA7yiz6Erz4	11458	16126	16126	1618841880000
22929	3NLxfdAu1cCdtfxFVMmMAdNocA4eAcrbJvsBxiXihvtiTmMbfiwo	22898	3NLAhFTZmcLNECsGjEp8BMHPi9PQ33bLmWqR4VBthSyAAzoAvWyn	1569	485	428	12463	14986	jx9T9DLqn6AFCUu5Qs6fEZ1HNzemE8DaM1NNF4G8sc1mSzQEWY6	11447	16128	16128	1618842240000
22933	3NLaerbVtjvRJ1TgbxpQ8kkCsw3dbQaortDgrev5Secdo9geXB7y	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	429	12463	14987	jwEAzTD5v1jaD7w6WdFcNnGdG23rL6rYiXmZcZCZfHfCpYxNryp	11460	16128	16128	1618842240000
22936	3NLHtZ8H6JCY8C5Jmoc2D9xoGuXEwspMzZ6cvTF7ijBhm9aBJpws	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1407	1395	429	12463	14990	jwMbcZg26BjMKtj6J8RtcVCzvDc16CgN2XWf1z6D7Ci4tvQB75Z	11461	16129	16129	1618842420000
22939	3NL5k4AGG3LgAAUUUoVukKPvyfcfWrfeBWr1z3BVJ4fSPseSNUMV	22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	641	1090	429	12463	14993	jx8LCyZh1yqBtFJ78h2946VXKtQZy5ABFtorBfvvZ5BdeF85sMA	11462	16130	16130	1618842600000
22942	3NKyVzfQCb3g16iTzUH8dHHUYPmTJdA9wNJoXMkWVZhV6qmsKFPB	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1607	1348	429	12463	14996	jy1eGHGMYq88VPihnhwSc1qd3pEXnYnZK7tBT7MPSNXohQbkjaK	11464	16133	16133	1618843140000
22952	3NLEgAaHh6T4TL1f3CdDxuv3B5k5cR2ivW9VhhzqrGUaJsH8Vqff	22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	1553	776	429	12463	15005	jwmXD3Gka9rmYQ2MHXDZMSwEnU3wRtftziZMXM24jjpVzBbCXmA	11467	16139	16139	1618844220000
22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	22955	3NKvGgmrh1ihPEKkoNuweXnUiq4C4fR9PonsJC15h3cXDD4uzW3K	1407	1395	429	12463	15010	jwmvwcGfTsG99gaeqoAkShYar1NyhpSumhZ8jaoo2JDwpgt4MMP	11470	16146	16146	1618845480000
22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	632	1382	429	12463	15018	jwiFWaPufk5M9XUogW5KYA55AqPhtcTeKaxWwmNmKwWuctn2uem	11473	16149	16149	1618846020000
22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	22972	3NKAjNkBVYynDUUF8AMK26Q9TKgVRLxDGfCvuampUuB4VfVYuNQd	1559	1107	429	12463	15023	jwUvhyKqc5Bf76sGibVJCNG3AMXZ16337WALKe5pwiHTByygAgb	11476	16153	16153	1618846740000
22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	1476	1371	430	12463	15024	jxAETA8NAu7vtN7XJMQXMxhWdF1REw5EpEkhUJQwZTbVtSPnokR	11477	16154	16154	1618846920000
22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	1439	1033	430	12463	15034	jw6uLqyUAYupMtiqz7JE9eeAYS1y6X75aH75znLHSKXFq2863RN	11482	16164	16164	1618848720000
22991	3NLsfywwWY3gLxiBzCtPgwxVPStm6EhfevPAE9mirUxRT9Y6Pgwz	22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	1500	1051	430	12463	15037	jwwUwhSRroxcVT6xNF9eD1uPUQTv7TPsK4hkyfcPi7J7Qaq62HU	11484	16167	16167	1618849260000
22993	3NLQLKZKFUEWxpNYAceG5u78t4Pt2j464aUP7YdJRW5EEE7o3qrk	22992	3NL6ZWG4rNcwzypvTLt4Xj7u4AoTK6d69F35byMrqCeCwnMMeN4C	1553	776	430	12463	15039	jxDhSvyJphRuxoTTAnNzY22qLte8TwdJaVyCMaB6Jfi6GMEAxky	11485	16168	16168	1618849440000
22997	3NL2fHe1PzUU2crRG4h2ZVV6CSEX8vGV8PFpggs7h8NKFBNHUCAN	22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	1403	824	430	12463	15043	jwBisduuzJYpTjeCEWjJ7jeWgBaLSBRgbAchD54qR7qbwDc4ayg	11489	16176	16176	1618850880000
23000	3NLyGDGfz784dnWP7xVfhEfo1rCx8Q9uKEm8XdwLMbnskoETwrpU	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1405	875	430	12463	15046	jwYrb2JhXQaz9THfhDH6qJShTSf6sSnaQAqE8dkwhfvbXFrWrWA	11490	16177	16177	1618851060000
23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	23003	3NL7yWAkmLQ6bpXUwy27hKWsWwkmtBpDyNqzgWxNwvCT1kwdSEge	1634	1331	430	12463	15050	jwijshnUm4Q6uGCDtFsN2iVLQRjwYhSfvxSEENEYue5U6Ufqmqp	11492	16179	16179	1618851420000
23006	3NLLdESF8CPGugpdEWKiWGNqZgThyNejSU1rqMPXrrQvS9AbfERK	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1440	1131	430	12463	15051	jxNsKJsKZpUNeD8Yhfgf5ieSBimYjTrgbM6gb76v3ksgC2arxAH	11493	16180	16180	1618851600000
23009	3NLt3WbGrGWcBqLyHCvFkLPsBvqFgPXNtsYbo5CNLy5M5hk5S8QW	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	1403	824	430	12463	15053	jwv1frRL8HVotPzKQb4rm7sd9iLTbnWhvw43GThTMACLviCuyqY	11494	16182	16182	1618851960000
23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	23007	3NKYRnYQmSatrRX34DqLnfeMgg8VibAEdY31cUS955oP86LZpC4H	1490	1028	430	12463	15054	jxHQARWqmKezEJbuS5UuaqFbkBsqxbQEAsVLVAkqmMf7cQbwWty	11494	16182	16182	1618851960000
23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	23013	3NKw3KEKgUhdgiDcUGZSghX1ZkfTQKzHjESEEfQ9VnK2a7JxicBC	1406	1393	430	12463	15058	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD	11496	16185	16185	1618852500000
23023	3NLJri4Sku5XdDKQ6RPzVQZvCESP9w1Pu5x6YgLKjkPp6pr4xHoQ	22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	1407	1395	430	12463	15063	jxiUzmTHXSrP6F2GdRKVzNe6jCir6JNM3v5pAyhjPDeiXUepoRG	11487	16188	16188	1618853076095
23026	3NLnezWiXT5jcRpvY3kYNZDPv3dqBCVPuF162xMco8pKAv147ZL4	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1593	1346	431	12463	15066	jx7Qe4pgaFT9vDHmrFvbxMpJ7CDtRrngiJ3PoNa4z94JgoQCFaC	11498	16188	16188	1618853040000
22900	3NKcMxYT6gjjyN3Uz4HuZ3sUGfKae3YFTRt9RzrvWLnf7ojGnjh9	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jwz93G3Fd6jAjo57PGVKJ4gVBi1ZfquTGQMyJ64WP4Do7kxmnGy	11447	16111	16111	1618839180000
22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	22901	3NL4eAGarsW1tW3iE2vZQmV81DhEi1mfuk3QoFurK9vbiXLu9rQN	1579	1143	428	12463	14963	jxMK1pxUyvKxLxpTtnaKigTn8LF85eH6otso58MTZFdjwK4m4XF	11448	16112	16112	1618839360000
22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	1419	814	428	12463	14966	jxHQbJK1YffkFQvqB8TzcWcuBJMimFnL48DDKXjKhxERq53kBiY	11450	16116	16116	1618840080000
22910	3NKyBxwFAGy4tP8TGAk337NvHM6pLj1jKzPWwU2iLx3N5s9KQjsc	22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	1458	1323	428	12463	14968	jxwHzKMmVhKquQcJHyJL4gzFT9PYddu8o1oy4ogghiXWQjoL83C	11451	16117	16117	1618840260000
22912	3NLFyBE6z5cqgMXPTpCKTcJKtZLEfip3wKx9YUKnZqXRpBVG8WZd	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1406	1393	428	12463	14970	jwfcDfJbZJW9TYJmvV9ir2RtVMw3gPANLXQcK9fYxBq8wMNwR8H	11452	16118	16118	1618840440000
22915	3NK86ZUdHgpgXgSfrWPqFb4qDdyn2wwpVZsWosCjno8r9dQipJCB	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1474	1329	428	12463	14973	jw8G9YLLh3jhoWD3VAXXpCM7n3PwRN4k3QK37B3mwvKF4daVTMZ	11455	16123	16123	1618841340000
22917	3NLyMocCmnq9yPkTxPQg9bJgPUyNt8PijRqNGgxZY6s2ndhitNse	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1461	1271	428	12463	14974	jxcT7Jxa4mR5WnbKdbzS5mhf84oRzgHTpid3pHM6z5hkyGqqCX7	11455	16123	16123	1618841340000
22928	3NK8DdFE6TU97RQ3ecyLvHMfA3L2ee7utJQV1A83YwvHXrxuw3Xe	22796	3NLvkEcCEQHFj4hrdF5k3vH9BSUdLQbSeidqupdLHL32zwfsaeAo	1569	485	426	12463	14985	jx5Db9a5sSLQroeXi7rfynoCcrcaZeyF3ucR92v7Ps28MZvwF8w	11402	16128	16128	1618842240000
22932	3NKnE7QnDAV6ggNwhEqacBRpBKdnUDRmVQdT33NFMKaux8MepDvT	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	428	12463	14987	jwAox4cfkXwC6P2u1GWrBL4JCLHn4Mpa6GWGeUEdHXPGVMMwD5Z	11460	16128	16128	1618842240000
22935	3NLLmhz6EqhbNGyR3j3z6GBPA3wQKSfhvnbQwkZNAu8TQt3P19KZ	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1668	1004	429	12463	14989	jxqc2YAUbzG335WCA7atctEPRbEW1aeNv2zjqcVYaXGQJtSdJYm	11461	16129	16129	1618842420000
22944	3NLtQ7RkSVd7zGbwB4BAotkPmm1BWef4E4S7ruBhbGMYPSrB2UPg	22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	1406	1393	429	12463	14997	jxiM1iy5aUqy8yCSaDYvzKUMzDhNdSQJCsnFHw3E3Khto3f5pPB	11465	16136	16136	1618843680000
22947	3NK88VbJSDb9PrvrtWVotLUAQC3mUw7AKotm68rUvv8zhAkCLGGG	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1406	1393	429	12463	15000	jwcc2vHgo5LzfUxigRP7WSDc3XUnro3FQQ1vZEVgQu4PfACr11S	11466	16137	16137	1618843860000
22950	3NLxMoxcBS95BULSywNMrhrk9tsLmKPumbxDzeC9cftvZVfQaj96	22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	1508	1387	422	12463	15003	jwNUXXVQ1kukJuhckVczknXUBC4pyoZBmhbRPj6D6fgpwi1duhS	11334	16137	16137	1618843860000
22951	3NLYAUKYSoMyY1oLrjB1BGFiLriEU1piZj3YBP1hgqMULNqe7361	22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	1406	1393	429	12463	15004	jwxPQbfapt64brxRQt9rQpN32ZZE4RwUZRLQZ4jaR2tQiqE74B7	11467	16139	16139	1618844220000
22953	3NL66TPvbhbeqw9MvumQQiJEogo81kebQaJ6wMKm45ytbKBAAaTM	22922	3NKJWvBSYvwtZoPEdkv89H16LuG4866n3qG5dmo6ATAVd6cw54Ft	1593	1346	428	12463	15006	jwmqdNBVXUaW59cZvo1XZD5TzmjgW8je7kz6v2Lz6LmBQQ6wymh	11454	16140	16140	1618844400000
22956	3NKHVmapJLmwpjjPjAmiEb6DiJGsxhs5raFim3o796rbiecPxWT2	22941	3NLcp7sRGGmcVBhKd2gwjVpUEizV8wfzurU19WwoXJHcabcUXxn4	1675	1096	428	12463	15009	jxUR8tEex2hrk35FqS3mr9igkasMQKKjiChNKXH698vp88PeRQc	11442	16141	16141	1618844580000
22961	3NLExU48oyQ47PPJXeRuEJUk6zG3YR5dABHNZbJM7CBSKcbyrggG	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1599	1287	429	12463	15014	jxwUeu1iR7hnCq8tS95QVRfQuim9EK8NtTpGP7EnkDE1utDM4ar	11472	16148	16148	1618845840000
22965	3NLBfsT59zB298CCda8GJ6tnvzrxT7Z5jwmGvqjj6L6wZrHmKQtw	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1607	1348	429	12463	15016	jxUL7zHPGTAhiF7XPE4Sf7BxBd63weFMmJuyKzoBZxcg2Yv5MaX	11472	16148	16148	1618845840000
22970	3NLKLXKemKURoxyTwTC2V1HeoGgqUsZju9BcoZerZgndQf9nxAAW	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1447	1099	429	12463	15021	jxEV8Qx4RiS3vussoMjRhU6y4RuZhxaQCWSJAmbmcmDHckURrFn	11475	16152	16152	1618846560000
22972	3NKAjNkBVYynDUUF8AMK26Q9TKgVRLxDGfCvuampUuB4VfVYuNQd	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1541	1298	429	12463	15022	jxWDSpzhjkDrmJPGuKXp63nEjrRPTXD3epn4kPGJK4eBciZKnYR	11475	16152	16152	1618846560000
22977	3NL1krQMb56bZfTuY5ZRH4Na6RkVKtGzeVTLS4DnahRa9J5qwAfx	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1553	776	430	12463	15025	jw7W3PzZMLmPvACpptGUZyTcUEvq8QcL8qDdBwFRrr2Bfp6Nftx	11478	16155	16155	1618847100000
22980	3NKWzbrU5y4vmNe6Frnn1bZ6aKPAQxjrpT5wJ38Z6cpwi2VVa82N	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1646	1228	426	12463	15028	jwAVp9PKj1Eb4GqayNA9n1VkKzuP1Nwp2QZZqUH8tzZZ7fomBqM	11402	16155	16155	1618847100000
22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	1650	1129	430	12463	15031	jwaWm8sG5kBMKUdW7oogot7AMdkxz7fF5asQ6NqGbjkWjKAs2C1	11480	16161	16161	1618848180000
22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	1673	1122	430	12463	15036	jxAYV71ag4Jkva8vM9hMAujrMghLDj72wLPpdxGjekJNYoJG2Fb	11483	16165	16165	1618848900000
22999	3NKmLEv9K14SYHTvg2x1J3HW5gh25KLsTjuYeb3WH9cGNjJxfbh4	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1503	1277	430	12463	15045	jwafzs8UtwrxRF6h33wtDaBZaaRN49U5ZVCXd81AKPM6YFu5GAN	11490	16177	16177	1618851060000
23003	3NL7yWAkmLQ6bpXUwy27hKWsWwkmtBpDyNqzgWxNwvCT1kwdSEge	22999	3NKmLEv9K14SYHTvg2x1J3HW5gh25KLsTjuYeb3WH9cGNjJxfbh4	1407	1395	430	12463	15049	jxkJUdRocB6Qdp5cHVT2GYiFo6WikmVvAop5mz4YdbKxkp1SRby	11491	16178	16178	1618851240000
23014	3NKF99APmCXERASYdAZPU2FGvKqmik3ZkWGgfRazXA71nAxFX38t	23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	1559	1353	430	12463	15057	jx3x8sfcwypy4eKqwcwkZa9LbkZt7wzRxc2vMVmVmr9KfdDxQyp	11495	16183	16183	1618852140000
23020	3NLKSBk3iDPq95NoFVsH6Go1pckxZtDQJ2YvSLqH9Gjz4gu6nuMS	22953	3NL66TPvbhbeqw9MvumQQiJEogo81kebQaJ6wMKm45ytbKBAAaTM	1593	1346	428	12463	15060	jxJYYXtzG1b3zc77pdAbhBGpT1SW9WM7bZPGirj1N1y4tZ9nYrP	11455	16188	16188	1618853040000
23032	3NLxdudQdApL7cuuT7oMUAsf48YR82f8DB8Q9LfpeziHUDtiWuce	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1581	778	431	12463	15071	jweTNfbS2XaMUpc4hYmkRjYKXjSapUwwcC2D6s5jurncpUwWVAu	11499	16189	16189	1618853220000
23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	23029	3NKLFNS3GVBA4gvJzp3p6sfPC1j9b98csYRT4KcgMjhgJyoxWU7k	1671	1119	431	12463	15072	jwqaZXjRkT5QsoovhCx7UgrMRiA57rJBwV21fzWmme7Cp4ywQv4	11500	16191	16191	1618853580000
23041	3NKf75fSrickbPguBX2bup4LVrkooRPEkB2HCJ96RwuHMHpu9Xwb	23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	255	255	431	12463	15080	jw8aocpvrYXHDcRMvTa8MDbNu6cbiLcSbcRd5FAG1HDvAAxzxVN	11504	16200	16200	1618855200000
23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	23045	3NLNZnMLqBDrYPSNqkFP1nbgUBHuR4qtqGjoXDPNxavp4M4foB2u	1631	794	431	12463	15085	jxboSSz3VcNg25ypgbyh6v2Dm7R3L4nydXhZUyi7jcgStpyjFK7	11507	16203	16203	1618855740000
23013	3NKw3KEKgUhdgiDcUGZSghX1ZkfTQKzHjESEEfQ9VnK2a7JxicBC	23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	1403	824	430	12463	15056	jxXTfKef4swLcwkZ9exxcfxncRvZH9Ekra1sitteTDHroYdwViX	11495	16183	16183	1618852140000
23018	3NLKozXWWpvEu9EYmrCfzYBqrQryu3PXgiv68mvMWeqgeZX967c1	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	431	12463	15059	jxEKt3FZVnrg8Eee9wiy6v1hr41sHJxkndDYhVCu5GdCMWXvxuc	11497	16187	16187	1618852860000
23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1406	1393	431	12463	15062	jw89itJoVMdJMUtfDHbuvkx8NNsk5zkfKXjwWvHfanFdp9bQr19	11498	16188	16188	1618853040000
23025	3NLNsMug5ZWzDwexCXj8qRcUr8FozwPjHP7D4LuEioc1PFhetVaL	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1651	1055	431	12463	15065	jy1EA4897jzpe8KzyHoR4LgqtBUzUPaVdX5KtFH4rsUSuebLxGe	11498	16188	16188	1618853040000
23027	3NKh7dvi4B5VjTavMWBoXgPWcYt9MoqWyTK2SJC1bLfTzdiaNa6v	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1651	1055	431	12463	15065	jx4UFdsVzFosVDTqki3qduWei1twXqh83TUTveYeviLEdHo8LM5	11498	16188	16188	1618853040000
23031	3NKKkjXiHGR4WYtYzxzgNCqYBBm7LvDveBL8XQ51YP1YWYbdiwV2	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1553	776	431	12463	15070	jxiAPNsSAMc9aVnxFXcLBQMT21CVvucR7wzmpZ7ZskvfYFfnt7b	11499	16189	16189	1618853220000
23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	1654	1214	431	12463	15075	jxnzysJteMSS3S6Ca3VovLYcMcw1ReDLKYXr8YvXzSE7zh1j6gQ	11502	16197	16197	1618854660000
23039	3NLTwkfVLa4vUXqegfttCf6eRQgHRknnHByShPFrmAwXn8Q6rT6r	23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	1406	1393	431	12463	15078	jxJZaycGUVntxNu1QLBqjx71hJBqnkewjiu9DXaFrDwye1pk5tf	11503	16199	16199	1618855020000
23045	3NLNZnMLqBDrYPSNqkFP1nbgUBHuR4qtqGjoXDPNxavp4M4foB2u	23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	1406	1393	431	12463	15084	jwup61B1s6cAuYaL6jAWy1ijWVwFxRaU4gYG7jRV7BeKR1qjv1V	11506	16202	16202	1618855560000
23048	3NKXwcaFaSYTaQ7RYWRFuF5CX12ZadLi6Hj1UsHLWhJUq2bxXVhK	23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	1642	1121	431	12463	15087	jwcUXJYTmLxJX2fbvnnEZRxrALh19a9UvBsWNg3vRDj2wnCVC5S	11508	16205	16205	1618856100000
23050	3NKLEP1i8i4rqBUYeKHFwy7r13Uht8MXLzdbNLh4xTo4QbyBFZoT	23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	1407	1395	431	12463	15089	jxqNnR66wk5Fhc8HcwJwxrrfvFrGnAqxSdh77yuX3uaErM4c96g	11509	16206	16206	1618856280000
23053	3NLCDvWUeXfSyBqpTQXSGbCDbWEP8Gtf6HnQR7syJPgQ8ybDcbge	23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	1507	1280	431	12463	15092	jwGziFF4djJyMCg6Se1YbWpXpzbBDsKY8NbaTY6VnoYurgAZkQ7	11511	16209	16209	1618856820000
23055	3NLJnxkiC2PScsqB35z6C2YpfDqWBwgh2a4YYwHUSnCwDFdjrrnb	23053	3NLCDvWUeXfSyBqpTQXSGbCDbWEP8Gtf6HnQR7syJPgQ8ybDcbge	1637	816	431	12463	15094	jwMv97n2KFSfwtdK1kjxakdXkysLzvNv1mDPZk14ZaWKQ354mys	11512	16210	16210	1618857000000
23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1476	1371	432	12463	15101	jwXAHn5GUdMh1vw11vFPQ1ctwBcMh4ozpvtBG2jiQ3kA36HENAB	11515	16214	16214	1618857720000
23065	3NLigHUD6Wd1Xdkny7SCECsKnuqZR7KLfoCBBmR3ygtAzt9bYqL6	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	1489	1134	432	12463	15104	jxdpuA9PjZaxLYb2pc1wgiwVCRj2pzAsUQtxMf2qS77F8YxWEvD	11516	16215	16215	1618857900000
23067	3NKYXCnrjTy22jjAx6WQ7skfCcGg2FJHuNHyp2Q2KEAxXqB8tRRL	23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	684	1352	432	12463	15106	jxeg9yCbTfKUbNQUWHotFRewtbk488jcdwH4T6iXmuoLxphUjqF	11517	16217	16217	1618858260000
23069	3NL9pnf3CLRQuWwKu1G6krMcgJLMgziZMDRoqr6Exsjox7Vb9hWC	23057	3NLSkaoCEGxUN3N3KWPCi6aSR3QWRhnyP6EiG9do3GGSnBybdzuL	1522	1322	427	12463	15108	jxoA6kLyPyqAg8r8kDLrVLLuCWhKVu6JvEJfemLNh1sZHbC3cZj	11426	16218	16218	1618858440000
23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	23075	3NLkzsGVsonVqsJm4X3zj4Jr11HHJnnTioP5aGWeC5V8qRvbeszq	1634	1085	432	12463	15115	jxTcL1j5fVwRrs7vJ7e1PLPrbY7uW8uU2GNuh7vwxmeP2rroWEy	11521	16221	16221	1618858980000
23079	3NLjffg37LDVa5rnNsaAj6SFySYqcMwGyGFzcEYWse4New7Xnzm5	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jxiAtLKjmeJNpMuZuzV81NZkzx6pfXdnLeStXamHtAb2FQR1Kqb	11522	16222	16222	1618859160000
23083	3NLb1yGqJBhHvBQLU11WYExCjBgAC1p6VHXoCwkfnCj69Kog6Q5r	23082	3NLqq8e46CGA2Ubtw2jqjdio2ZAge6jNdp5fUNp4Nh9jEFmLBQQQ	1637	816	432	12463	15120	jwjLvH4PLzZ1qZq2SyGbyrdceuEH7x8oyxisjArcTXEegqjJYXN	11526	16226	16226	1618859880000
23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	23083	3NLb1yGqJBhHvBQLU11WYExCjBgAC1p6VHXoCwkfnCj69Kog6Q5r	1403	824	432	12463	15121	jxw2yMhx45NdWykwpMYzWTDYpfkoHjzpeXrt3zFJG294Ra8pJ2g	11527	16229	16229	1618860420000
23089	3NKHgN4VoSAoZik5YxckkgZ6unrYpkiAKwL5DwzPB3MbUmZYcHrZ	23060	3NKjP5H4vgXWobfW9TD5uY1DzHqb9n8eFQt75V2gZJ5Wo9Zj5EXm	1623	830	432	12463	15124	jwWifpT4JMTM7Pc9ZoQCvTXtQukTrPTuCNKF52MgBnuFfpUM4q1	11515	16234	16234	1618861320000
23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	23091	3NK9YA7RhA7kPyQJ69bbmW6T8ctCc88dRt2X7GRGf5xt5Y3cZ2ah	1654	1214	432	12463	15127	jwgF4RyxBtrF71B9twZu2DEUZ6ihyYELGseDLvQ9msctcTrmbG5	11531	16237	16237	1618861860000
23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	149	917	432	12463	15130	jwxFhwwyttkhYJ2nu4QybrwssyU4L9Dq8DQ1n88QThKbcsqpHpr	11532	16239	16239	1618862220000
23097	3NLoSDx58QWDS1MX2L7DikfZ72GM3brE6n78dbxgZfuUPFE5ed1n	23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	1474	1083	433	12463	15131	jxA6RbfkwJRQxbGgQJibBy7tJ2fh3vuL4QLgsEsWLnT8g1kBkwp	11533	16240	16240	1618862400000
23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	23101	3NK7thHh9puDnRBojoE3thd78yUuJvTTNz8pfdbM5jjw7EAFBsDi	1601	1388	433	12463	15136	jwMd1vdA1AWMoQj1RdYDUHg7wDJo66aXgRtUjEthxVuf458zbAV	11537	16245	16245	1618863300000
23105	3NK5WiRdrL7MpWGFX1zVTXCFxFvuECUNRkQZhddfAqJ9PLFw3tkt	23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	1474	963	433	12463	15138	jxWkjKNkWbQNwJF1BFyzVziyZotHk1UUoyqLCnM9FMroT9uUkEH	11539	16247	16247	1618863660000
23107	3NLLnKAxaz7KBJAFL1rUUNrjCDjmbDzkVQ5BWPzCEb4SHs4s8CrS	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	44	1325	433	12463	15140	jxYpchZMKivFcKDoB719HBM4ovFrDzHccZC9495gs97AYg2NpQf	11541	16249	16249	1618864020000
23111	3NKifkMtzUtFyjr9DC53beiSG4o5BJEJH6rvYisg3saebw3rGrDu	23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	700	840	433	12463	15144	jxMDy6i95621qvnzrQmu9cbyZ2gmygMNejuFZSkXTE6j92rPTic	11542	16250	16250	1618864200000
23114	3NL8qpz7CSEbtEvrxHj9zgDYbT8v1PJN2xs7wDPpdNUAKjVtJkqY	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1611	1341	430	12463	15147	jxsLXuSyTDiRwhF97DzivhwTBeMAFQZxyYgb7tyjRTmBiHJ7LtB	11479	16254	16254	1618864920000
23117	3NLDQXcXKMu5N9HPXWcS9aaqh59KmS5TA2hXpNcge4oK8Yg5qiKF	23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	1577	1327	432	12463	15150	jxZRctuaQxcbLYmTtNTg3DKYGWaim24G3JQowhGE6uZuyXzfy8J	11525	16258	16258	1618865640000
23119	3NLDnUzCXwAddvqqGXnSm8jcGP2iPQzscfrrRPr82p4SFPPZwZqc	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1633	1024	433	12463	15152	jwhsq9q98XPgt3UVJzyxTt1hRd8WfHLBCjn4be7zmj9Kfd2Zm5z	11547	16258	16258	1618865640000
23015	3NLEnpci3akbgawbrVnBkyPDda18MgNMNKPJVjRXENNTn7SLPYmj	23010	3NK9puE2SDfwgdEUtYrPAkZEavrQWTDdPE4MDemUFfwrkJm32kwq	1559	1353	430	12463	15057	jwCbKcj2viqtCSjLjPqvk1caG8dMh8owfkUyKnBYZXv9CJpcPjM	11495	16183	16183	1618852140000
23017	3NLcHhKxFetFPjriohrPentYor12LTbbirEi3zygKyYf1pEshHwH	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	430	12463	15059	jwb61LyiBZ7pNhGL6eHkpN9LJucsYyMDUaSd29sc7T82QeJryE7	11497	16187	16187	1618852860000
23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	431	12463	15059	jxEKt3FZVnrg8Eee9wiy6v1hr41sHJxkndDYhVCu5GdCMWXvxuc	11497	16187	16187	1618852860000
23021	3NK6yjef4nbWBXFHMjyBQTUoua69kNNcMzq5Q2RGWtYUjtVbaRu2	22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	1407	1395	429	12463	15061	jx9EHuqcMK99K1tvfRSbSUXgepeMcp3nKzQ96P8sMBh9yc3ev8W	11474	16188	16188	1618853040000
23024	3NLo1ZZPPeS3fNXZdeHKgYeLQyNbvCT1sjRXWqJz8T6XG2j1zbfZ	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1581	778	431	12463	15064	jwaC5ZKx4ZJ4bzh7YxDiJvaaPRnb9dh5syCHb7WNF5wG6ZpkVc4	11498	16188	16188	1618853040000
23028	3NLQjcs8u4DXyExTBD3WKJV4m1jYfjA6zBygGuxXzph8NZ2jAedY	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1407	1395	430	12463	15067	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD	11497	16188	16188	1618853109385
23030	3NK8fE8H2CTcg5jyhQTxZifVtgMv9Mkzbz8Zuvr1cxR5tSTzkHru	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1627	1139	431	12463	15069	jxXeB55a9hhQoJFq35NRyx7z6ZwgTc15HXFtTR1QjFntoSsD5J2	11499	16189	16189	1618853220000
23035	3NLtArZzqgciWALTDdTQjhzUAKdgaKfnhirC3y3FSPpdcDA9XZcZ	23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	1634	1085	431	12463	15074	jxAAQmPaEU5uZ5f7CHoAvmhPhSgZozC58A1uprmaUugE5byRpEW	11501	16194	16194	1618854120000
23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	1649	1383	431	12463	15077	jxMDsKQR9ypKQfwxvZ6qszyWdJT9ZJg6jHgZyLgiG6HgXxLLBkw	11503	16199	16199	1618855020000
23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	1407	1395	431	12463	15079	jwvmEKLsCyiDTBnAXCWvd5HP2uVVZqvpWZr1vnokE33FhekJkHC	11504	16200	16200	1618855200000
23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	1613	1223	431	12463	15082	jwBycJXe1PCS9iUx6bEsr9KoAVnAZLMcMmX6UFMCmbA5acSS8qo	11505	16201	16201	1618855380000
23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	23051	3NL976V5GpV1UDt2oXNVuyecwFe5Fn8WEULMLyo9aNx6REs4iGEc	1454	130	431	12463	15091	jx2ZZ28TEPFTRRWAk49Vg5MY44REuWm9Z2y3okQhzs2xVVgkQuL	11510	16207	16207	1618856460000
23057	3NLSkaoCEGxUN3N3KWPCi6aSR3QWRhnyP6EiG9do3GGSnBybdzuL	23047	3NLTDzfKHQSdZQLSBukxtdM9wD3NCfhzmk9bppgh3fXuAa3tgk42	1522	1322	427	12463	15096	jwcp7236AYtqogvoQhCJUwnmznNzxr9WnxMu9ofwPzNKMQfdBiN	11425	16212	16212	1618857360000
23060	3NKjP5H4vgXWobfW9TD5uY1DzHqb9n8eFQt75V2gZJ5Wo9Zj5EXm	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1405	849	431	12463	15099	jxVfX8gmPxQHoBgyqzu9fGoc4YPvP7sCxKbCyjJKUR5qSAhh1C3	11514	16212	16212	1618857360000
23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	298	1182	432	12463	15103	jw8Tr3VXkW52kc7QipxQqEFBomsZbqVNyTNhdBe3yH3HYvAW88k	11516	16215	16215	1618857900000
23071	3NKbdn7BsdM2UiDGCxEMTABJLGwj7FL28sAAQQDTjrf9sUb6Fhae	23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	1522	1322	432	12463	15110	jwnvNtBXhizodmHbNNd63RNSiSxcAPBzNgHbiTY1ctGCnzAvETh	11518	16218	16218	1618858440000
23075	3NLkzsGVsonVqsJm4X3zj4Jr11HHJnnTioP5aGWeC5V8qRvbeszq	23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	1637	816	432	12463	15114	jwMzpsYaHbSXRaL8Vy8ipMC6mUcGyQtgwq8htpgiaUeTXrLcUDG	11520	16220	16220	1618858800000
23078	3NLwRTTGE3114DQtNpgj5283DXaU8W7KGHVNPypV8SHX275nGJT8	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jwnVhziHEJL1a58pFf7RB4kqtbmeU51XXMBffYeoJ41GnqfXVpK	11522	16222	16222	1618859160000
23080	3NKKxdaVG8mBvPtQxLvGQzrkviiCDHFSKnUNQMgoyymjU3cs6qAs	23077	3NKSZkNEMtYqEcTZdr5sDVk7AdZQfuzS1txN5k1JRvscApuvwykv	1451	1292	432	12463	15117	jxbCm8Y72wGvYuRdzLCMLW93Dzq7mgN39pBJBPZHhq2cHGHgYNJ	11523	16223	16223	1618859340000
23086	3NLs1qkvFabiGfXgCPTNvbPb4uvKPEtw6nVnXpCseTDeMnnYrexc	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	563	1113	432	12463	15122	jxcmdr1oPeqzN1CJsdDBL4ToQYDd2UZGQ8DzxxiKnCUPUWUt1zW	11528	16230	16230	1618860600000
23088	3NKFDdpA3PecGpwJvSiiP6bBpLq4NKf8rMx9YdZbAkKzCSRQ5HPv	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	1651	1055	432	12463	15123	jxQxwhE51ck7Y1CNp2uihVRVkTvqvQMzWSfG33TxyhXed1yAh9p	11528	16230	16230	1618860600000
23091	3NK9YA7RhA7kPyQJ69bbmW6T8ctCc88dRt2X7GRGf5xt5Y3cZ2ah	23090	3NKeaBtVTZnanj7YA4iET2LqX1oz98Huj7CNTbvL61doPdPD28eC	1610	1068	432	12463	15126	jwAyYmDSTbfQhbsnj4AhUH7rsc9aGvNKTk3G9rNPG4U8i7T4xxp	11530	16236	16236	1618861680000
23094	3NKxhuNEgqz3csG9tcgXXyqSespzxs4Hbcf8DGQs1JzQ4SYfrduc	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	1405	875	432	12463	15129	jwn5Ka9J99LyoykeppqB2hNrkdcCduzrWyuBw98K3TAiCSMYcZs	11532	16239	16239	1618862220000
23096	3NLZVWn2qER5g2Gwe6q2kNYqEnWgsiR5uhxzTnAytxAiEBoe1RCc	23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	1474	1083	433	12463	15131	jxUxsHqEdgoS8g9aqJVQWJ2AyE1MrPSUZGkPvtiDR8DBKGnNGyG	11533	16240	16240	1618862400000
23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	23098	3NLf42BGmfATmVmtq8SwFBBoSLodqHGkYjgUKZfTopxtDtVazt4B	367	367	433	12463	15133	jxiUMdWQgZwrisUFjqnLdL6fguYyoBhpMirag4i4N7e5E6fHfZM	11535	16243	16243	1618862940000
23101	3NK7thHh9puDnRBojoE3thd78yUuJvTTNz8pfdbM5jjw7EAFBsDi	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	641	1210	433	12463	15135	jwejnaBFS76ZKgfdXZYNuXLCm6RY2cjkidgMi7m1s2HCKFPKpzX	11536	16244	16244	1618863120000
23104	3NL6R4GTnYqCcuKfxhHW8DxJPz5ewxyVjffEdZof5Qdm7XTp9pSr	23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	1474	963	433	12463	15138	jwzuW5ijj14YXDn243VLipLKkuSGztziKN21rQk5Gj66sSvxSUa	11539	16247	16247	1618863660000
23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	23104	3NL6R4GTnYqCcuKfxhHW8DxJPz5ewxyVjffEdZof5Qdm7XTp9pSr	1403	31	433	12463	15139	jwh8px7hLWFEK7mhqbo84bDacPnC4YQThhqP8F4C2CDVgTFA13f	11540	16248	16248	1618863840000
23109	3NK8FtUfomftuVP2HngnUpDRzTfojZrzYTWt8x4BuWbzdU2QbpfR	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	1637	816	433	12463	15142	jwvA8mRNmF6UJPPUaqyfFKD1FUzvX4eNe5FDRJmwH1dmMnufm9T	11541	16249	16249	1618864020000
23113	3NKNcRWi2iZnFaLvvJQwQ8SVY7PXBuiiEACRuc19sC5L2r5DAL3A	23112	3NLoHYLmQP6xpFpVsL9Q1XBFFghq3uXfNsLJy327mxGL64zRTuFg	606	1049	433	12463	15146	jw7Rr98EtYrgGgWxFW6MCYrep4Tm2XnuXFnkgpE5LgJjWkEHHbN	11544	16252	16252	1618864560000
23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	23115	3NLm7Ay58sU9Kyjpoj2xX9NwuGMEcYFv7EDi1gkaMhbp96VGTqoz	1407	1395	433	12463	15149	jwXrrYKsGvK7H5iuejCbwnXRpQjf63tBV7Uw1Gt97U4dWG96d3L	11546	16256	16256	1618865280000
23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	23120	3NLnH6tW2GQgqaQrE9bC93S3YHkkV3PaJXhBucWWu9cBoNeAoruS	1555	981	433	12463	15154	jwEetcWh2ZqHJ6cE4pRQxHHYFPhhoKXsGvypSLtZ1sWzWE7zQR5	11548	16259	16259	1618865820000
23029	3NKLFNS3GVBA4gvJzp3p6sfPC1j9b98csYRT4KcgMjhgJyoxWU7k	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1407	1395	431	12463	15068	jxLPpvhcD7hCSynxzRg1Mb4C7XdrGvQdZSTs1qu4nSXw6K8Gnk5	11499	16189	16189	1618853220000
23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	1617	1288	431	12463	15073	jwXX34GtuAeh5VvrxF9VBX7TNkLiQnBSovuL7ibPSH1HQiXjRZi	11501	16194	16194	1618854120000
23037	3NLEFWMNwSFF4Zs2VNpKaE7RuuBfbsCRnEck8KVYBibVZh4Q1Phw	23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	329	329	431	12463	15076	jxNiAvKqHvU92sAzcdYzDvw2U99pHmSoxwA9rLj1egkKmp2LrjS	11502	16197	16197	1618854660000
23042	3NLNXLcwQHRvX9cq2nFozxxARWo9652hATHTn9rSW8Wt6Pejjpwk	23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	1439	1279	431	12463	15081	jx1uQCAmrpstj7jPasoXdtVhDEbFVSruKGECtr8br1pqQvTTNaY	11505	16201	16201	1618855380000
23044	3NLngcrmCCHNjYnDFR35yAEX59BxRCz6AN1B8NccpEicxjLhJrZV	23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	1627	1139	431	12463	15083	jwyVAt3VMBA7iBBgnUECs8K4p2vkFCSYnPAmq7PMxZTkfkpHtR7	11506	16202	16202	1618855560000
23047	3NLTDzfKHQSdZQLSBukxtdM9wD3NCfhzmk9bppgh3fXuAa3tgk42	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1522	1322	427	12463	15086	jxshaHTmU7qwGv6FwRHSt9nCaRJct5QhiXqE35mPAVoESSh7F55	11424	16205	16205	1618856100000
23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	1522	1322	431	12463	15088	jwybmLL2yqRNA2UdPgQDYYDBGYEQnYTYUdBddNqzRDL3hkgZB5d	11508	16205	16205	1618856100000
23051	3NL976V5GpV1UDt2oXNVuyecwFe5Fn8WEULMLyo9aNx6REs4iGEc	23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	448	1305	431	12463	15090	jwjRoSoWaJkQAzzWLNiy3Lg7376gA78YQ6h7AgencsVafLKHnfJ	11509	16206	16206	1618856280000
23059	3NK6SXHZA2bsnzXLBLZ4kaR1e7gjMh6PK2FKqyV4ZMiHo6jnwvXj	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1522	1322	431	12463	15098	jwbMhyvq3qX9YMHRAYL8EnwCXmgq8EFTufD91aX9VT4fDeFZ8zT	11514	16212	16212	1618857360000
23061	3NLWt7QievmsLdeR4qVDVreHfJzCnSSP49SPP61spzXfmv1U99Vh	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1406	1393	432	12463	15100	jwbvd4SSy7JPBYXDfSKqD8ZFREQbZ8wzHiNRvVjUxfhCDiiKNRf	11515	16214	16214	1618857720000
23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	171	1374	432	12463	15107	jwGpEYJQaB58XYWjPhdF9aaLeWndCqSfP2RGcmy85H73FH8JqHh	11517	16217	16217	1618858260000
23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	1627	1019	432	12463	15109	jwwPezDBMsWgQ2vhLwop7USyKRWo5oSQxPyMWaUG6igsKvgx2Jk	11518	16218	16218	1618858440000
23073	3NLC3uTopUVM3dS6Hn1E3thkEDJJZqYv9gdkdiogqr6cdL4Nvrdn	23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	1419	814	432	12463	15112	jwTJ3TA1J4cXbcxNMnQAN9N2aACFqVXjQowjKwYKfrqNKghx3Lh	11519	16219	16219	1618858620000
23077	3NKSZkNEMtYqEcTZdr5sDVk7AdZQfuzS1txN5k1JRvscApuvwykv	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jxvwHZxua8u7LmZeM65pgEAUwRuKvW2JDaPrd5hpeAftUPRa3RJ	11522	16222	16222	1618859160000
23082	3NLqq8e46CGA2Ubtw2jqjdio2ZAge6jNdp5fUNp4Nh9jEFmLBQQQ	23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	1407	1395	432	12463	15119	jwbfPQwVC8VFiaGvDz2sou4offkSf16KYBbVVJRchpTK3ASmogs	11525	16225	16225	1618859700000
23085	3NL1eHSGeWfPL3hQXYX6cEn5YWu8QhQKrHRMyYWxSToi7Xc3gkw5	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	563	1113	432	12463	15122	jxMRJXeKT1g8uBD6RAY3bZh71aMJ2wL5jNaDaGBhmKqGaNAE7KW	11528	16230	16230	1618860600000
23087	3NK5brhqsWUfR7wKTMkgPfJxea5mCHvQjnDgktjUJP9inv1n16NH	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	1651	1055	432	12463	15123	jxgz2V2K2WWZjurq1jJbTbtDF6tgdbnSaRsw7VuqhrkFj5nf3cs	11528	16230	16230	1618860600000
23098	3NLf42BGmfATmVmtq8SwFBBoSLodqHGkYjgUKZfTopxtDtVazt4B	23096	3NLZVWn2qER5g2Gwe6q2kNYqEnWgsiR5uhxzTnAytxAiEBoe1RCc	1637	816	433	12463	15132	jx2mdpfFAENwGLAbGqjSKSd4EqbdXEc9LiJU8NqCzAbt8nwP7hg	11534	16242	16242	1618862760000
23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	1406	1393	433	12463	15137	jwLoRKJMna1nfbc9X15PB3sLu83LnWvheEgzrdsP8JsjfU3wYXr	11538	16246	16246	1618863480000
23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	1672	919	433	12463	15141	jwV8YAjzgKkmLcr5WqKCbQ6WMguYSykG6UPVd4GoQRwQ4zMdgFu	11541	16249	16249	1618864020000
23110	3NKT7paja4NFwAAh3DU7RAocegxkpQvMDZWDjBTQz5xtED2B3ATD	23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	1553	776	433	12463	15143	jxP1ehQBZEGx3gxyhCvaG2QqHCDqkmo9HTCpxABZRXwoeReG8Ys	11542	16250	16250	1618864200000
23118	3NKBSzpkVaTfT3UuxGwhU91T8Xjne9h74N3osANrtJ8UADbC2Dhm	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	1581	778	417	12463	15151	jxsaaFq6P8sdDqtaBW4UhQryBpfdTdup8tqjyh7mViR3szAPL3e	11257	16258	16258	1618865640000
23120	3NLnH6tW2GQgqaQrE9bC93S3YHkkV3PaJXhBucWWu9cBoNeAoruS	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1577	1327	433	12463	15153	jwcUjj2ih14a7AQty4w1teWzJsdmHpjJxGsWMnXCcYiTggNHmoV	11547	16258	16258	1618865640000
23123	3NK3FCy6veNJYy9Mnj36gBZsBE61zMDLBqQqKb9yyCS5MM3Av69A	23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	1650	1129	433	12463	15156	jwoHjuGnfkponxWFMGdp1fHHdLbEFAZ4eRX83vwbE21v5wkvfoE	11549	16260	16260	1618866000000
23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	484	1319	433	12463	15158	jwb14afwT7TsJcWHDaYu3ueTz1fQ2gcvUzZ8a3H5zU7zyiJJ7Hx	11551	16263	16263	1618866540000
23129	3NKQcGMAMg3Jc4detmD5qEejgcYQWyEb8JPkhAvNWusvtc3kdgsc	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1483	570	433	12463	15161	jwK2GKKFMxPnvXF23FdXqHnCtmijNqScWDSiacx6nVcrSfFh5G4	11552	16264	16264	1618866720000
23133	3NLvK3AXkKcrC77ZxEfsdXth2NQqNfSCdxmsN55uNvaQuWxxyovW	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxeHkWGnyFqz8cHbCegLbBtLRtBVuqbJzWpLASbQoGfusjTx879	11553	16266	16266	1618867080000
23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	1490	1274	434	12463	15168	jxLcTKUT674ZzR9TzV9r5vizr6q3zp5VKQsLwyunSMgW8AuscJh	11554	16268	16268	1618867440000
23139	3NK5gSDscV6Qkh6HTgNimWN9tpBehE85rb1ChovbgjMm7H317AYx	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	684	1352	434	12463	15169	jxK5XCQeeDvyiwwFAKbgiQb4usKP8zdAT72Aot1ZgZy7UQgtDFW	11555	16270	16270	1618867800000
23144	3NLgYGkHkbR4wayj6vTsSSSsVUKsr22KpbeDETe8jECpyc9kLcNR	23143	3NKUPMieVFLzgXo3CqCQWLCC4YdXuYoCvt8ALj35gEXHXyk8ztWp	1407	1395	434	12463	15173	jwmdYWuKAhVDM5cjAR1t7t5m6A498v2Rci63Np4RtMm1PTyN9Pa	11557	16272	16272	1618868160000
23145	3NLkeTw3PUnJ5AWCvJCAexQg9ZwSyDk1ZjM7wCJy4RnZTYXFzyvM	23144	3NLgYGkHkbR4wayj6vTsSSSsVUKsr22KpbeDETe8jECpyc9kLcNR	1407	1395	434	12463	15174	jxqDHWMM18Ff91Vx4aTQLJu2qYkjsZvBEoXSExDboQtunzC9bgc	11558	16273	16273	1618868340000
23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	23146	3NKCkQzpvpRjstVqW68Zr5uzHqT7Xfg7xajKTkSZTnFcvy3c5HNH	1407	1395	434	12463	15176	jxxoA1vzpotjMvQDrSNJJ5W5NNGGQceyTScekq6ywCSzCSG2wd7	11560	16277	16277	1618869060000
23054	3NKRPApmNgNdNEeUsMYZr4Dit4L2Z1W7yiiQaz41WoPW8LpZbhs6	23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	1577	961	431	12463	15093	jwzUNd6A6zv1hA3gu1R6aeJs1WAFNHupbXhWCMFVcR6jvVQxLHN	11511	16209	16209	1618856820000
23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	23055	3NLJnxkiC2PScsqB35z6C2YpfDqWBwgh2a4YYwHUSnCwDFdjrrnb	1649	1383	431	12463	15095	jw74UACcq5A8fHX15BadunTg3nG1ryyC2b8kXM3cQnxRaSNC1XQ	11513	16211	16211	1618857180000
23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1406	1393	431	12463	15097	jwKdmuHYEMvvpTwsuVR5gG92HFmgC4RC4KDfuPXzXSvNr3rCFiT	11514	16212	16212	1618857360000
23063	3NLETEujrUuciXAGBiNN9316Y22iaC8QqYSD2bTWFPZ8YPpj3oe4	23020	3NLKSBk3iDPq95NoFVsH6Go1pckxZtDQJ2YvSLqH9Gjz4gu6nuMS	1593	1346	428	12463	15102	jxJYYXtzG1b3zc77pdAbhBGpT1SW9WM7bZPGirj1N1y4tZ9nYrP	11456	16215	16215	1618857900000
23066	3NL2UvQcqjK5q8Xm7hozxEMYmfEafLAMCjjPRiCVmMsjECei1gk9	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	1593	1346	432	12463	15105	jxEjxBdrFR3qDtA6PLKAuAc19cFrPbnms1q79YuBpELSzuLNKqA	11516	16215	16215	1618857900000
23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	1458	957	432	12463	15111	jxZAqbb1shLz7aAzPFpnqAPaCxwjBUYAF78NZWZTeZNE2gQJrNu	11519	16219	16219	1618858620000
23074	3NLrQ4jFp8PCB9C3nQ1HFbBsT2sTe4RHN1cAN3sWrRSqgAaqv4mx	23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	1406	1393	432	12463	15113	jwqLxfzmTGNvPY67guxguKAqsTRAJtd9m97MZxDDfyVeb9vBKPF	11520	16220	16220	1618858800000
23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	23080	3NKKxdaVG8mBvPtQxLvGQzrkviiCDHFSKnUNQMgoyymjU3cs6qAs	58	1281	432	12463	15118	jxoksMmQeX4KsEvyj1EKMZhjCe7sVti3Y2c7msH1fXHRKcHMpZ9	11524	16224	16224	1618859520000
23090	3NKeaBtVTZnanj7YA4iET2LqX1oz98Huj7CNTbvL61doPdPD28eC	23087	3NK5brhqsWUfR7wKTMkgPfJxea5mCHvQjnDgktjUJP9inv1n16NH	1637	816	432	12463	15125	jweNb4hhzPKe2GzaMDwwgBszYYhPxk1HHqbmFYDwQ5gHrZYdLaF	11529	16235	16235	1618861500000
23093	3NKeXwj9ct72PS64oKw1hjxauLtVAdDFPH6HE15uZ5bUxXYoVboM	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	1407	1395	432	12463	15128	jwaM3YsgShTUrfBwpCNZuqj8FdK4czUH6wA2aczkoKX9HHCaGsP	11532	16239	16239	1618862220000
23100	3NLczyaqbcUWdaeK7XYmvQ2ZRotZteGNyYrgHArwX3A7eUPzLnxj	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	1581	778	433	12463	15134	jxdmcrnZLZk1HbFnZ2a815qu2hbgoMSACxBZCHMkxhvoyEou3sV	11536	16244	16244	1618863120000
23112	3NLoHYLmQP6xpFpVsL9Q1XBFFghq3uXfNsLJy327mxGL64zRTuFg	23111	3NKifkMtzUtFyjr9DC53beiSG4o5BJEJH6rvYisg3saebw3rGrDu	1406	1393	433	12463	15145	jxBib8m6Yox587oZhRvHz4p27coyz7yr3GM3QSD8duneZsoznbm	11543	16251	16251	1618864380000
23115	3NLm7Ay58sU9Kyjpoj2xX9NwuGMEcYFv7EDi1gkaMhbp96VGTqoz	23113	3NKNcRWi2iZnFaLvvJQwQ8SVY7PXBuiiEACRuc19sC5L2r5DAL3A	1624	1208	433	12463	15148	jy2xnWLF1rXzyumZyNQTavUKy2SVfCq6r538Rp4W9PK11qYhDB3	11545	16255	16255	1618865100000
23122	3NKJhLi5faRRKoJSz1Rz1f4Vb59Uhbfohaz9fM3t8VxPiRfaiSvX	23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	1633	1390	433	12463	15155	jx4Mzrp86pyCB5zPZTy6X6pPy4eWZ15LKVwEqeEimnpyUYjBTcW	11549	16260	16260	1618866000000
23128	3NLQck9qJwEVvyn2c2TpGnpipsJJLBVoQt6P5LtesiHkxgPzaM9E	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1579	1389	433	12463	15160	jx5JV1CsZCnuEQCnoiRW9Y6qVSJyyvmSPaqae59vZeNQb3xNdnE	11552	16264	16264	1618866720000
23131	3NLFf2AZieSkHJE2HbHzo5NfaaDsYH2NfQsHPinJJoDo1bN4VnfY	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1652	1189	433	12463	15163	jxBk7cmhSyQJQsHWCNPcgivyqBtxi7WKh3Km8aG2QX7EhGYMGpV	11552	16264	16264	1618866720000
23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxpUnKZDGo6MaJyTQEhhpZCcJDqRLsCd6YY9rai2VAre5rCoaZN	11553	16266	16266	1618867080000
23136	3NLLW4rnhqupr8VEXp4XRTph5aUkjYSiM4cA8u56J6QDiGR13GZs	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	1444	1381	433	12463	15166	jwaBWzoi8A8nFGESQJ3fe1JbALPyhJbbMkhUJ7uo97yAeah1JsX	11536	16266	16266	1618867080000
23137	3NLcSBEPfWCN37fsVvnQ1sTPKps5Euks33c8dxHoAtv4ATzBHXj9	23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	1637	816	434	12463	15167	jwG8JfHtGLQ66qec2sNCfEv1kQw6DTdJCwQKWjcT31SJ36dD7Hs	11554	16268	16268	1618867440000
23142	3NKomskqHonzfnX48gYzJKFmEBpVoUmHsEcMJCR1x2U5xEHCMsUt	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1651	1055	434	12463	15171	jxrofKMhUKKj3bT8WSVtm21fUAiJz2ibZyt1udq3jRwfDXTiTbn	11555	16270	16270	1618867800000
23143	3NKUPMieVFLzgXo3CqCQWLCC4YdXuYoCvt8ALj35gEXHXyk8ztWp	23139	3NK5gSDscV6Qkh6HTgNimWN9tpBehE85rb1ChovbgjMm7H317AYx	1476	1125	434	12463	15172	jwtvcj3vLfXV1LqzCp9ypedD5Wsfx7gN1pXfS1YdkYaz3Xwbr32	11556	16271	16271	1618867980000
23150	3NLGNqreEkiDEoViyseKD2ksYC7rSGU3D9MENVnkwZeWZj6VRwfN	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	1419	814	434	12463	15179	jw7jR5oPt1dj2JRLtCsziDMFXnat6SPT9iygMUYfK5sbi5TStsz	11561	16278	16278	1618869240000
23155	3NLZo2T3jizCGBGirqYpkHHD2HdNWkbf7NTnUZqp5sQ64bpzTBJ6	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1633	1144	434	12463	15184	jwHDMTL8i5f4w83yjemQA1kNsv31uxgP6BQDgxyhaUVujGQwVZ8	11563	16280	16280	1618869600000
23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	1440	1377	434	12463	15188	jxsLyC5ZBfbQ752uvae9rzvzhYZodJxGbh1FhcWp9oZrCBQ6Q6Q	11565	16283	16283	1618870140000
23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	684	986	434	12463	15189	jxFBfbCR4q9wye1F3emqMdJdzyvXdYNeNrmFjx81BD34EeQhm4u	11566	16285	16285	1618870500000
23167	3NLW1R1DYh4xPZZAoWa6vRaz3o131AVz6ePQsJ9uNvc3jBeikSuA	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	1520	48	434	12463	15193	jxr41PZV1upxJyzwnZxGetm2SuGsN3YgVkoiVrztvg2kGxbXJAA	11568	16288	16288	1618871040000
23172	3NL4qGKX9ZwjuZgfp6gNL3UGrEHhi3V1PYADAnY87sXZJ6rGYFcn	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1406	1393	434	12463	15198	jx6hpd3zw7CsVm7D9W8egJWmU3jsKyWB8utt3i8XaEjCR6Hm1S7	11569	16289	16289	1618871220000
23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	23177	3NLbADm8GnP4viS5kVfqc6yBqJbbGMquGy2pYLw7TC7AA8UH76KY	298	1062	434	12463	15203	jwkdiAe1Y88LH8vx935X34zSpxD8S5J3JzNytx4S8ZDo4F4fCnw	11573	16294	16294	1618872120000
23179	3NKmLio2WkwcHBhVb4JFBEwLLMXD3ePjccirFHX6nSYJe9VLdbaL	23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	1518	787	433	12463	15204	jxr3Xpx5SDDq5ipnwAcGNZvwZVinzu1NcbHiRwPm6mSnBA6Xgod	11538	16296	16296	1618872480000
23181	3NLP5i7o7SxFpjnNCJ8JERQJ3syyZ3D2P5pEK8DXZYoLuMTot1GB	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1460	1324	434	12463	15205	jxNwKXtBpTXkLRKsFt5uDUhdAzbK7Cp34bZ1zrZwSaze7ftJ7C3	11574	16299	16299	1618873020000
23185	3NKG5cjy7rqp1xaGY6QhBaxvytLmx8QFK8vWbXBQp6rWxvm387Hx	23180	3NL7DVSnRP4qbhNF6j7UrX2AT6H8WuxhVXNnaS3eq7iZYMeXLygr	1405	867	435	12463	15209	jwqqxAweSScMrEovvku4bvC1JGP1owo4LGwp4zTEkDDWCycqtCs	11575	16300	16300	1618873200000
23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	23185	3NKG5cjy7rqp1xaGY6QhBaxvytLmx8QFK8vWbXBQp6rWxvm387Hx	1608	1289	435	12463	15210	jx1Q3TPFpcKMVEgpgjsqpNLvsfQJie1V7apa91HJ1ih9chB9aMu	11576	16302	16302	1618873560000
23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	23122	3NKJhLi5faRRKoJSz1Rz1f4Vb59Uhbfohaz9fM3t8VxPiRfaiSvX	1631	794	433	12463	15157	jxnZYt12LpdbfZ1KX8YPUrEnBL6BjnzT4aRk1aoC2QmqxYcEE4d	11550	16262	16262	1618866360000
23134	3NL6LPgoiWGMd9KjQgVL8UZq7dYZLdKYhE4ZZucHVfYE2pjH457N	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxeHkWGnyFqz8cHbCegLbBtLRtBVuqbJzWpLASbQoGfusjTx879	11553	16266	16266	1618867080000
23140	3NLxERtJ74zM4TtakXKAYRwRgCSLJn9sJJxhmDorqZVE5XjG1X6u	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1406	1393	434	12463	15170	jxUN3MmVxQnLzZU32rNF3KghQFEDPhsVaoKiPqrWxcYQoKwxVvH	11555	16270	16270	1618867800000
23146	3NKCkQzpvpRjstVqW68Zr5uzHqT7Xfg7xajKTkSZTnFcvy3c5HNH	23145	3NLkeTw3PUnJ5AWCvJCAexQg9ZwSyDk1ZjM7wCJy4RnZTYXFzyvM	1405	873	434	12463	15175	jwo5uEA1yFin5VuxV8zT1i6FsGHFyoVVN4avyTCzVQ3KgDwimDh	11559	16274	16274	1618868520000
23148	3NKXuwBQUVGmdCoM2bHoA7ywmXjMsHZ15PEqa2sDaPKUKGAkdbQP	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	633	1018	434	12463	15177	jxqjTPD9pzYRiy5ZTKVFRkE6eH7uUvkiEwv31H1NF2aTbGpnCNp	11561	16278	16278	1618869240000
23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	641	1090	434	12463	15182	jxTGzPHxanBnnotorbPfZuvr1CH3XQKGyPhjveGnrpdH9mEiDft	11562	16279	16279	1618869420000
23157	3NKkHVJu8oqqBdaoWjfYFN7wMftL5e7kMAFsH8YuJTi1yDyJA8xL	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1633	1144	434	12463	15184	jxNCou88fyMcYkzNtGMZgjAqADXfTpJskmorUVhGuqTTvjf5wfW	11563	16280	16280	1618869600000
23158	3NKn9KqxsaJT2us223smZHNs1YKLyUQpofRo5dWeg7CcTGnp5DCw	23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	1649	1257	434	12463	15186	jxutQ88YN3A66ci6dMHyWRKNZMLDUPTTJF3cqysxBvm3RvKoqc1	11564	16282	16282	1618869960000
23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	1506	1127	434	12463	15191	jxL6BQGG6ePV6MvM24b5a6GHjY8bcM7zWgDsAbddXGxF4P16bpg	11567	16287	16287	1618870860000
23170	3NK8xD7cPgHJL2aXVUGKkDNF3MAvgePuyvEua5WiX33Adz6pyTj4	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1403	824	434	12463	15196	jxDYrnJSA2yMR8aN7CeeiMbeM2Fg6o4DhJhA3Y7MpstY7f5HEhE	11569	16289	16289	1618871220000
23174	3NLyU7i1P5eceuNB6eWr6roN8YhgSD8thCLpREuZk9m9bLummb75	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1588	1392	427	12463	15200	jxAuTm4fw5KpGUAbYPKKT9KKRH3u8QF2M2a8zRj7WXUjJyBDwXF	11429	16290	16290	1618871400000
23175	3NLvbq6xjib2RS8Yudq8dWZuY3s4j2ZrCxRW2WuVLBZaFuXrTnrn	23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	1460	475	434	12463	15201	jxfA69pJ6SCht4MfVunf14EuqXNkha8xngLF1fFXu6vnEwRd1tm	11571	16292	16292	1618871760000
23183	3NLN2mnYgGr3c7yVFVYdjmLsuH6Y7ySNZxtoLWxFFS3gUASbwkDk	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	80	1027	434	12463	15207	jxoG859ixHLnDZhXeeiCh4H5khEuKR3qikFEUDSfY3HgCqimsQx	11574	16299	16299	1618873020000
23189	3NLy2hfZqF6sqoGcEhqEAk3BkgsPZEjfADqJxbmviBdFDUPh5Gaa	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	684	1352	435	12463	15213	jx6jXUcRMPZJmTsoDRbEW4eFVqJLP81EHZAVUnSenb66xoszPii	11578	16304	16304	1618873920000
23194	3NKNvy988pPihhFMqzqtJ2D2mvDq8f3DUaiDESsQfQfWPp2Tdzgq	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1406	1393	435	12463	15218	jxBGa9x2R83KdmWmCPv1r226pmNo2TVKMt48W534Ft96MnvDnPS	11579	16305	16305	1618874100000
23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	23195	3NLWEVS5S2nCQ5yyhA8CvcRNomj95A2YS7PwPH2MBtRfvbqkg4QA	532	1303	435	12463	15220	jxPXAvnyMsTfnp3q8Fz4MAnRgHWeLEFEkk17SydhmUWH35HWcMz	11580	16306	16306	1618874280000
23199	3NKAKAVmWgV9iuk1rnoQvA82ryttB7iDf8bfknii969e7GvTXLuD	23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	1560	1291	435	12463	15221	jxpQTuP8dCVd7NTB6jupu2U7HbgFma1ibAfigU6txgaKZXGxASL	11581	16307	16307	1618874460000
23205	3NLDY8idqe89fiP7Tmq2zpbt4VJVC9i37TpiY7NrHMCk1XeDhJrZ	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	470	943	435	12463	15227	jx8p8nYLJmt4UYpvTDi6FvsmHmMVZXvDYCV7SZ8uQEmKAsrv5KJ	11584	16311	16311	1618875180000
23209	3NL28e4P7VwRuWE6WdxhRw4dz7GMwpFeW3oxJS7bGcbosDbXibJJ	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1457	1391	435	12463	15231	jwUncP686FoYA2N2NMaxptxJ8gVbKUDaa1UkE2TXTdBJLvvQFq4	11585	16312	16312	1618875360000
23214	3NKNnZZVhS6WBT9zpPuAazXwGn3uQpacsJ39PhoGE3Rn4kvobN9t	23089	3NKHgN4VoSAoZik5YxckkgZ6unrYpkiAKwL5DwzPB3MbUmZYcHrZ	1623	839	432	12463	15235	jwoW32XN8i6m9NgoiNdQfkMU2en37nmq2FVMQYNrhAmH9Tteb8w	11516	16313	16313	1618875540000
23219	3NKpvZ43nGmkGJyycdwAS6ZsdCNW4KtnvVTDdeBHsi8nY7qMC1o1	23117	3NLDQXcXKMu5N9HPXWcS9aaqh59KmS5TA2hXpNcge4oK8Yg5qiKF	1577	1327	432	12463	15240	jxLcq2wj7N95pKQNd1U5r7Wyowun9zNpnSehUHEYZZjzgPMztCX	11526	16316	16316	1618876080000
23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	1405	887	435	12463	15246	jwiJT9kGcHNqBSTXfhrGWDdXA74QBdbyoV8iHCnLqmBghiakabH	11591	16319	16319	1618876620000
23229	3NKRyJpdyMvxwAuSFsDZvJXErew2QLtnKJXq98NjQcnnjuEB1fii	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1547	1378	421	12463	15250	jxBh3zhz6hhjdBGywy9hyUFRqjr6fgqDe1gKqrV6XPRB4pjE9Ae	11309	16319	16319	1618876663888
23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	23233	3NKDuHMVicctQh4fPRxZL8ZnJZdpwuEsR5BxHi1Vaw6EMFNdcXV8	1406	1393	435	12463	15255	jwcAeTwzpDWuLbX7BxdCxDdPt4pMaBNWLTZC6Reie9WboNzMdK8	11594	16322	16322	1618877160000
23235	3NLRg8jERJEeggnXRRkR7Zkduhq27dBviNbU9o8b9DA5Wr7YoSur	23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	1403	782	435	12463	15256	jwf16kFZD3Vf762kvVkrpoTM5bgUfdR9N39RimzLNT6bnrRj5wb	11595	16323	16323	1618877340000
23240	3NLFWvbAR3CpZayt3Gvqxr2iLfGKPQzWqVy9YeXpGQgyS4cYLZxN	23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	1440	1011	435	12463	15260	jxGEHRcYXjnWgLZSa9gDQWQK7jRPxVekWkQSnKocnwTXQuXMHWN	11597	16325	16325	1618877700000
23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1489	1254	435	12463	15266	jxbgqpGYpZLxqKDjUtp3AuT5APjVjSjRySjjXUpQ8pj6G4PwSTm	11600	16329	16329	1618878420000
23250	3NLj3phz3qfczqxBG1SoRLg6Kmfcu8cuxMazHNxKgswEMJgdRCgz	23114	3NL8qpz7CSEbtEvrxHj9zgDYbT8v1PJN2xs7wDPpdNUAKjVtJkqY	1611	1341	430	12463	15270	jxxYh6kJSypJd9NntD3sRGzzRzNwqxCZuUYMHUEFvWa2ZXyNjDz	11480	16330	16330	1618878600000
23255	3NL2prAjDzvkAvtuvetDQmA5mYkudxf1PmSUnNfy1HHfymMYNjrm	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1647	1176	436	12463	15274	jxKdAQnAc9FTHjdokMnKuHWVAxZnD1RhnxgST8Ckvzod2WUEpvR	11602	16331	16331	1618878780000
23260	3NKrge1Xjov1M4mHCyLZ2hvJAomvkXNFfibE5pMWDNWmU5Vwm6SL	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1631	794	436	12463	15279	jwEcP4DBACJ6sGNN7q5qLsMoJgLyCqKrzi9dAobBkDu6wc6UG3t	11605	16334	16334	1618879320000
23261	3NKs7RQJsFjXGZ4ifaMJy3rpcB8c86wmzfWUWqJjTWquEv4nvJrj	23258	3NLX3Lb62eBvoSU54JvEtXmijbdAJbVuPNj9y3rAeHdiXa9i53xp	42	1361	436	12463	15280	jwbREyMGpNyD5yfp52zQxZQ8ZhifR6pbkPiqXyCYbBBbhS9wfAS	11606	16335	16335	1618879500000
23266	3NKnkLDLQFtUnSCDa4XSH6VPjoJncy3hUoZyutZnuK9ZHfpWW4Md	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jxZy6EwTCpy3bafDo9oS4BZLmyAQ5bkp5Bbfb4Z5LuZnHQGv6G9	11609	16338	16338	1618880040000
23125	3NKRX6HrvnqcVXWJ6pR8Sh84TeaBbmYUstLDMV8mmm1VjrZRydNz	23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	484	1319	433	12463	15158	jxEJsLwwMLckLwbb2Ht6KPV3m6boRYDgioxUAAE4mf2xTLpXeC9	11551	16263	16263	1618866540000
23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1602	1003	433	12463	15159	jxv1TCVWKZMh6vapE75aKw7ZwfNkBxfNNCGJgnWRMZGQfoSXS5R	11552	16264	16264	1618866720000
23130	3NLhhEyBPRJvpkWiM27dHAdAP58VdyJzCUQsm2Fm5rfhe9utFxfK	22903	3NLCYw8tPL1oxKM3qVRpPYPUBEQoF118RnNXrhv6RLGq77sXbUMk	1579	1389	428	12463	15162	jx8QLhh8JqyM2KxV8y4FbDF1aGBHZmzumf8MH7RRmizBNoDrf3z	11433	16264	16264	1618866720000
23135	3NLiiLZQmyeMRAE93cssBHogW8mW88GaE6JJ3Xs5gYvfbBTuDzoz	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1444	1381	433	12463	15165	jy2eCqqcxCCTyBaGyVenAoKKuGeaeQc9kU7ef79eCfERGpS5hZY	11553	16266	16266	1618867080000
23141	3NLYCFMYMpqX45PizhC4iiXfELn9NTVWPUMzPwo7esQFgG4GvJhh	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1651	1055	434	12463	15171	jwDGq2EqPTDK6iy9sZt1qaThzxTZyLtZPWaNxQv8MJkx6vQFS5J	11555	16270	16270	1618867800000
23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	1672	1039	434	12463	15178	jwTpx6NaiNCRsfAkygMAmhF32Z1eeuBnjibC5sjZ8xfSMUXWjXR	11561	16278	16278	1618869240000
23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1444	1255	434	12463	15183	jwScG8LinV4PtExQUYNtFKSX1wNC3H7JapQZbSViDhsNUjm5DtY	11563	16280	16280	1618869600000
23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	1406	1393	434	12463	15187	jwGM6DhXuZpuAPKkgk3vvnqtqEvbthQACkjGDfktWn6Nc7M7mJr	11564	16282	16282	1618869960000
23160	3NKznaiyrVB3Hs43HyLgUEuhtYKit7H38orbWUuxJ4quamzWForr	23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	1440	1377	434	12463	15188	jxcH1g56dXDt3ruiZYFo2FmJDTbYBsvk6tepQFxqJo3257ZW3qz	11565	16283	16283	1618870140000
23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	1447	1219	434	12463	15192	jwxVsaU6xfj54GPcJrBPEDEeTZh2XBmE1E33xq2t1yakWUqL6ba	11568	16288	16288	1618871040000
23171	3NL1CbjULtdMKq4QB8NBWxXUXV1Ec3J6s4LC5Gzzy4249o7DBCDu	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1642	1367	434	12463	15197	jwrYa2do6ZTnkvZP5BH8wS7z7r8xSVCdiRh7Uxa9Yx4cssKpsNj	11569	16289	16289	1618871220000
23176	3NKPFvyCiTpa4dijDf1yJY2iG5fmxJhjuMJJGk5Jc58bkbjzUYcd	23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	1460	475	434	12463	15201	jwkrZTMXe8pgasxPkFEKN6GBMWrVRohZZ91F7qemjSeRH479sjP	11571	16292	16292	1618871760000
23177	3NLbADm8GnP4viS5kVfqc6yBqJbbGMquGy2pYLw7TC7AA8UH76KY	23175	3NLvbq6xjib2RS8Yudq8dWZuY3s4j2ZrCxRW2WuVLBZaFuXrTnrn	1407	1395	434	12463	15202	jwryj26RhbTxpoKZdJU3JCpZxo4x56Y8qrRm6sU9BCtd8MCYYr3	11572	16293	16293	1618871940000
23180	3NL7DVSnRP4qbhNF6j7UrX2AT6H8WuxhVXNnaS3eq7iZYMeXLygr	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1460	1324	434	12463	15205	jwT4dLV4JNZ8R7jje6KEKpwb5ySntP2Uu8wzfMtCyEiNiM8kz7C	11574	16299	16299	1618873020000
23184	3NLEZiDKFenwna9o3kEaAQnBEQxcBtTQQJgaoXXnepTimydTMQ46	22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	80	1027	426	12463	15208	jxfQMzW9XEYCBuDxPyp8F6Yyz4PkANtPf7YufzkDce127cCgq1L	11405	16299	16299	1618873020000
23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	1501	1114	435	12463	15212	jxDp1vTLSXwQD2Ric9LuBpqhuUvRjrKZ6zhRcc7iynQqbViLXtM	11577	16303	16303	1618873740000
23193	3NKkHE23c7WYFEMBZj2hmKSXi5xPrHtqgJxT2otzGiSgNpQb4ETU	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1407	1395	435	12463	15217	jxoP7vq6FowRA2YkCjCPV9dHSZawZU1wAjXHJe4L7zhgqoD93Cb	11579	16305	16305	1618874100000
23197	3NLP2G4mGMnALzgrbupSC1QDXRGEbqfC1qXZBz3BfNA28AZhCZ4v	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1483	49	435	12463	15219	jxmxaWJPmBBRzcE8Ddr71f3pqJxpNreQZSus1tQ75AyzdE3aWuK	11579	16305	16305	1618874100000
23204	3NKrcWoPEoCVJpoybYDbUMaVu9F4rERpVR27RAjhsiqnKQi4tzs5	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1571	969	435	12463	15226	jwBCWZYXbvvgyrZzp6t1i8KqnXNJYrMFdLx8noBV7KD8xaCb7nD	11584	16311	16311	1618875180000
23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1483	84	435	12463	15230	jwuD6Eikqc7nfkD6mYvbMrhswGaCpxbZdhz9YbfnEAmQiLjCDHY	11585	16312	16312	1618875360000
23213	3NLMTvBTQyPYgpncUVGwJ36wnNhZDWW7xmyu9393VXiqA9KWomEd	23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	1406	1393	435	12463	15234	jwaWDccj2TW3e1stVDRVC7yxRLs3772q1D4DYBbdtZTBrmDwkRX	11586	16313	16313	1618875540000
23218	3NKPPtMc3z7ALSRiufP4ynxNfToRaJXVq3BnJCjzsd3umATBekFb	23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	1624	1334	435	12463	15239	jwRf24ELv8Bp8GQjbGEKuDQHYwBK2E3McqEbmVLSDwRwNLkpSsn	11588	16315	16315	1618875900000
23223	3NLSyhbqHsbUi8PHXeLgYL2pNNHU8dbca8jW1oKuw3QnTUBuNL1j	23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	1461	1271	430	12463	15244	jxwBoGgZ4WcrDkyDm3JkhsLM9VWWPKKHKGufyCPzDdRYarc4sWS	11485	16318	16318	1618876440000
23224	3NKikVmzN5D1PYBDWpv1dYnNpgQADD1HAb2WmXVeDZT23brKaGv9	22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	1547	1378	420	12463	15245	jxFjdeebj1PhPFAZZYa9qtzGv4PUanGGDe53arJ5esJeeEmwMZr	11301	16319	16319	1618876620000
23228	3NL7GT8c5CHrVuWfhkeng7aur8ptRAS3soSrEcDpYU3Yex9mfYFX	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1547	1378	432	12463	15249	jw9wXMUshiwhpAiafd3qCKmbLphqhxS1CXsPexnk2sutj7PwDEX	11515	16319	16319	1618876620000
23233	3NKDuHMVicctQh4fPRxZL8ZnJZdpwuEsR5BxHi1Vaw6EMFNdcXV8	23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	547	547	435	12463	15254	jxsfEnGU9dtCnwYC33ywMjTfiagzTRAw5oLSXpgp1aKW7w1gY46	11593	16321	16321	1618876980000
23238	3NK7ZS565qda4fcdz9SfML58Be9WYjH2Uk6YAg8xeJSGAjJvmRpN	23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	1406	1393	435	12463	15259	jwzyvDFFFWG5YdRfTgWxGzRePmLvHU3EXrdHKaArHV2RpTMD7b7	11596	16324	16324	1618877520000
23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	1440	1011	435	12463	15260	jxYyDFFmVVuZmu1gBf3vqWfT18hKT3CjQCLcKASoXmDWsuwWx27	11597	16325	16325	1618877700000
23244	3NLfN2EHZXxhBbmk1zJphYcKjpMdeRrVVTfzGAb9jJG2Ev3L7WXr	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1581	778	433	12463	15264	jxj2Ah9xahZ3FResYBWcjT86smbJsbPFZQ8tJL8R5j7AcwBK1VY	11547	16327	16327	1618878060000
23245	3NLJfWjvvynLWpMtdhi77yFuJUuHM1sGb28PqiooP1UNufXLm9Qe	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1509	1194	435	12463	15265	jxnMJ2odQs6VSbk2yjVogKtZzswzaPXvMaG2CoHcaQ2nqRWbSr8	11600	16329	16329	1618878420000
23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1447	1345	436	12463	15269	jxi6QjRfXhPE7uBrucJnt2pr7tE2RaN66NoabinZ7miqz2nekx4	11601	16330	16330	1618878600000
23254	3NLAs4VBCyG7wGKGaPxWB2qNcjRmdQzu57esST9yiascBfpd9Sbu	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1637	1637	436	12463	15273	jwQ3x1JwLr2z9DhWZPYh1ywKksYRshZQkL6iXzU41EuHQKTfhVg	11602	16331	16331	1618878780000
23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	22989	3NL1PXQkqvXtmkeq7FXUoFE63tDCgjNuvdx92U3FkzodxbGtA6pa	633	1018	430	12463	15180	jx7XQGjeaRBuyXNogvVRhTHdptxmVCcR6EnRVex49Ef2aWBBiM2	11484	16278	16278	1618869240000
23152	3NLQ276Z9tPtGxiKQQFNLjvcBAVVWSS3wVk8RZihw2f31zugCjuK	23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	1403	782	434	12463	15181	jwtFX7S7S4DrwXXz2NAE7rJsEuAKg8SFkPAPXWSZVVhUu814zwT	11562	16279	16279	1618869420000
23156	3NLw2UA1unfvrHAkieZTGUa66tisQvLd9nrZbRoKKX6JWnvRn58T	23136	3NLLW4rnhqupr8VEXp4XRTph5aUkjYSiM4cA8u56J6QDiGR13GZs	1444	1255	433	12463	15185	jwkXR3gvhK9FpuXXW9qPknnL2vGYDWxMztiZHpW421KT2637KHp	11537	16280	16280	1618869600000
23163	3NKhzGB73dZzYjVMc8FdZkxBhYHA7ieY5axLtBnEXGVxMk3o4guD	23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	1513	1133	434	12463	15190	jxhk3WkuYsCHLvbXAq3fJRgFMgzmq2tMHrpsCi7E39HC3efYefo	11566	16285	16285	1618870500000
23164	3NKjMZ7A9EDqepQMk6ZNzjbvbJcG94oHKNzDUAno5FYbrxC31giB	23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	1506	1127	434	12463	15191	jxjuaKjNxKCctEQ7sfwMdHWDCtQpELQ736zFVXN6dq3cw66eTRH	11567	16287	16287	1618870860000
23168	3NKeqdT67gTpArop9bNCVNpV8TAn3bvZVqbdGx9vPKcfa3NqnyTs	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	42	1115	434	12463	15194	jxH6xmFajAZ38FCbYce3z8nBWErwmxFTcBtMRkQYLeN1babJkQ2	11568	16288	16288	1618871040000
23169	3NKi6aR5g9KswbdeCqmVm5UUZSxFvyqaAALdPYzcLkNN9fS4ZFWZ	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1407	1395	434	12463	15195	jwvEcaBHYYWjXeHhEPjtebWvPMBgKcvj7QWgamEAoBXWjrWCxXA	11569	16289	16289	1618871220000
23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	23171	3NL1CbjULtdMKq4QB8NBWxXUXV1Ec3J6s4LC5Gzzy4249o7DBCDu	1588	1392	434	12463	15199	jxCKG3ohQuWbpqafxayGHHraErhof5uiCQA7wXqLXBHyQR72RKL	11570	16290	16290	1618871400000
23182	3NLb4889d6tbRcweyA8ZxL4yssHxXsNSXRvxm3RpVgDDUB6VsVNc	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1406	1393	434	12463	15206	jwup8YdW5YZiDrGWcKV5B82X7c2boeuyjY8mbp4Bm38w1x8jLdT	11574	16299	16299	1618873020000
23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	1406	1393	435	12463	15214	jwky6pEUQBevHHikAGfk1VxdWwc4uV7HcMd9ZZjp3fYfyvikjVj	11578	16304	16304	1618873920000
23195	3NLWEVS5S2nCQ5yyhA8CvcRNomj95A2YS7PwPH2MBtRfvbqkg4QA	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1529	1316	435	12463	15216	jxhZZeY69tBnYqePtZfqyBCrUD856UXzsEvTrFem7Hftu6HF5xN	11579	16305	16305	1618874100000
23200	3NKZRMm3ip3HGi7Q2qtuiqYJvM6yHqEAotvxZbXpTRZby9rwQzCf	23199	3NKAKAVmWgV9iuk1rnoQvA82ryttB7iDf8bfknii969e7GvTXLuD	1560	925	435	12463	15222	jwGoxuCN2bLErTUJzfXF2ZcTEUXTc6ZWvvnBGk8ZJBJ44m2d358	11582	16308	16308	1618874640000
23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	23200	3NKZRMm3ip3HGi7Q2qtuiqYJvM6yHqEAotvxZbXpTRZby9rwQzCf	1589	1286	435	12463	15223	jxzQSDhHeAcMbb7spU6p1MVjz6CpQ7XFJ9RfaHnS8QUiHhbjzYC	11583	16309	16309	1618874820000
23202	3NKdhVB6o85tfZpLyLznemMBtSf9dLMVLv1ayiRQjG1FMtyFZ8BE	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1406	1393	435	12463	15224	jwzTDBZcVSZ4myEy3hLHg1onyBTKnABEprZLhjnMoHfgvVayvym	11584	16311	16311	1618875180000
23206	3NL77ciTL7PhZQJXti9Gmr8VuLmcsVR2wybj6bsqKh7Mz2xQLhEw	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1671	1365	435	12463	15228	jwmupjHUTMLVB66gbMBUYB6xALvyTgWtqcGQqMgyvn64ixtAPgq	11585	16312	16312	1618875360000
23210	3NLK1Vy9T8ApTDgGh1zdFRFwaitUcC1bnYtWKf16dS4EfKfckVCq	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1673	1368	435	12463	15232	jwGcgfwbGynb1XS3qCYbFmNQTYnUPTkB5auiVZHHmh9gXz8htKP	11585	16312	16312	1618875360000
23215	3NL5bxn7abcSSCDuLDtce9bWQREYoSGKPeeMzWVXuSbLX4gqQ1Q7	23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	1403	824	435	12463	15236	jxfzT4z2DYZNVo1GVsvDmLfLwjTf5sKEXepuqF7PUQ3bU9WzwjN	11587	16314	16314	1618875720000
23220	3NLfsTPMTJbcxgE1d9NpH7BNqEQZv7aVKuGU6ZuWgKcnJDDsGJpm	23218	3NKPPtMc3z7ALSRiufP4ynxNfToRaJXVq3BnJCjzsd3umATBekFb	1577	1327	435	12463	15241	jwTdM9YNY8CoPFWWC4kgZ6UYyk9VnUXMPyumi6qWqcavW2oSqXn	11589	16316	16316	1618876080000
23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	23220	3NLfsTPMTJbcxgE1d9NpH7BNqEQZv7aVKuGU6ZuWgKcnJDDsGJpm	576	1355	435	12463	15242	jxWqMorzW1zfSGHtv9x51UD9RgzA7XUbtKXhykmcDqpZFr2A7Hr	11590	16317	16317	1618876260000
23226	3NKL4DuSGAiLXZcpyoeQpnqG2wV4hhA4jA6Uo4ZAWUkaUHpJAQhT	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	1547	1378	435	12463	15247	jwLXsV6i3T2LMNEoBncMJH3b79u1WNj2pnRC6QsbK7n4qY5dvaL	11591	16319	16319	1618876620000
23230	3NKWzXRUcvquvZcrvpUx8kLNyQiP6JbT1b6RxS6zKw2aprLtQi7y	23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	1608	1043	435	12463	15251	jy2RU5MzGS5KgCdD83g7uMJxHT5EVdMB5WJb5ZmevtJwPzLpNHj	11592	16320	16320	1618876800000
23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	1406	1393	435	12463	15257	jy24KPtDejLDBbXPNc8YWf8QZMuLKHZy6sVHB79VJqy3YcmbWCF	11595	16323	16323	1618877340000
23241	3NK6KpiBuabknieCuCrgQQvpyXwpnYjQrxUMXpUk7yxdAUhx5KMc	23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	1406	1393	435	12463	15261	jxKUyZNRbYFsoc1xHogNUdiNQa91QvLVMqbFgb8B5mYNv1JBdAr	11598	16326	16326	1618877880000
23247	3NLHqs6QtnaE414RDrsfRtRipFa2rVyUeBFd1RkJewt1J4TYttfH	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1637	816	435	12463	15267	jxNdFwatXoY5vXbjuQau6h7KTzrPVQa6N9ETxCiSzDMHMSY4MuY	11600	16329	16329	1618878420000
23251	3NKshjZJQ1D6nBTXGPmgdqCMb7f3UBhWztqz9a5y7KrzgDWV3kPK	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1656	1343	436	12463	15268	jxKqM4jjCgfpzsuVo73mDVGmhSCVPTxhy3BUhLYWzUfdUzEmY2o	11601	16330	16330	1618878600000
23256	3NKT47YnbGtocSbbuNqY5bhSrEdppCEbDazCpmdP8ZRhFAJe84UV	23253	3NLLtjqtacZX4TgYr84TPNP7CTP57xvurNqhAhGMN41xdhZmKHYe	1637	816	436	12463	15275	jwsKKJ3VpgKtKJyB2nzRaCMRneF8DrFQBZX54KMDGey3tiDVSA4	11603	16332	16332	1618878960000
23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	23256	3NKT47YnbGtocSbbuNqY5bhSrEdppCEbDazCpmdP8ZRhFAJe84UV	152	1330	436	12463	15276	jwweeht9YJHZyMdYNdg6DAuSo8oE5JzaRqdnroTF8bHgMYNRqcx	11604	16333	16333	1618879140000
23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	23261	3NKs7RQJsFjXGZ4ifaMJy3rpcB8c86wmzfWUWqJjTWquEv4nvJrj	1564	1338	436	12463	15281	jxnou1MKDjDEQMr3U64rmtyUDstrpgfzi6k9RgfJcQqrdwiQZBc	11607	16336	16336	1618879680000
23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	1406	1393	436	12463	15282	jwupGoWyCKHoCDjiVVRX7GVLgtBdbedadPeyD1WyL4g1kMBPyzQ	11608	16337	16337	1618879860000
23267	3NLxCYbXvRqijxhMmpearYPyKW2Z7EnUvZa6HqYwnvagfF3MjH5d	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jwWPWjUQMgjwM8ztthbBAnB6zP6eW1kHJzJ1BhUryoMkBsw9wCj	11609	16338	16338	1618880040000
23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	1506	1373	436	12463	15289	jwsWzF1YTY85yqJTw3hb1Vuy2k6DPgVkrfzrkDvfLXAeJSFjYh8	11611	16342	16342	1618880760000
23274	3NLvZR2zwH5rsXkKWHs2dvywb5crnCK72QPyGihUDWi1LK8krAoW	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	1671	1365	436	12463	15290	jxQEvz2K7aSJ6VKyevSYkqHnUh6amJHSb79JRfCfz9zzALubo8u	11612	16343	16343	1618880940000
23187	3NKvVN4VdxsSZpAQroqXtW1izKhTfDMJM3z4DHjVF2W5drn1a7Gz	23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	1656	1343	435	12463	15211	jxMkgsHaxzsCJYizd41EG98Jw596qbXMVEvyX4qs57KbjY8PoJw	11577	16303	16303	1618873740000
23191	3NLSPMgKP8ttDBRALv6xqpRM7tg2J2vc7MmMZNnMVa9Cvzbf9ddt	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	1555	1347	435	12463	15215	jwmQ1zGaXZU5hBKxfZ7PRDJLcv2zWUjbwxMS16tZGCyChwx6P7b	11578	16304	16304	1618873920000
23192	3NLdotzH2Chda1U9t2G1UZjUV3t7QLs1dL7YHW2GDqy6KrdJ1gx2	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1529	1316	435	12463	15216	jwmHv2Xx6S6z2C7NNA5sCzaPJfSdkFtUHSADy6aG9GFqvadFiPP	11579	16305	16305	1618874100000
23196	3NLHvPjC5g9mmD9h3bo3KKkoq25nbrUWZxDJGfGypJQmQaskgovC	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1483	49	435	12463	15219	jxisYh4xh6FEMYGh5uqziutFPxv1fGtrJwNmEApM6SLxvcDfyvF	11579	16305	16305	1618874100000
23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1553	776	435	12463	15225	jxxvwAgkxHafcK9BiC4GPqhExTSNXNjmw4eJVV8yTCHDpUZfayR	11584	16311	16311	1618875180000
23207	3NKrBhFjGdTiWKjkuW9LsLHz3Nc4idDNCyiQ9ixegGavbtG66stZ	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	563	1113	435	12463	15229	jwUqGJnUyRH4XzfA1xWexi3vZkzd9hj3UUKMZApviv869gg6Akw	11585	16312	16312	1618875360000
23211	3NL1BcVA9sSwqBQGBKbA8kzqKnoxX3pBGbi3ZM2k6dXtdwaZ2mMi	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	563	1113	435	12463	15229	jwEgAecX655BU1oyaqD6twGAep8sxSvaKDZAoZ1zBxQ3axv6uLD	11585	16312	16312	1618875360000
23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	1407	1395	435	12463	15233	jxf5CD4Z3dSZ9VHQKSVZu3AqY8vArNNydR7ozjkqoETjC5Cvv78	11586	16313	16313	1618875540000
23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	1553	776	435	12463	15237	jwBtRQuEBa2LYfAnVTu4rD6r2yYmzpbpEkoc5HJkpPzPvA4gt4X	11587	16314	16314	1618875720000
23217	3NK7g1jicKqaFw1EdJAveTwTGrqqqbeq25cKidMAAXZeg7Jn7aBg	23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	1406	1393	435	12463	15238	jxCL2aVdyjnZuAs4fjmWhVT3ux51ZzSKkrmg5rwxLfJ2nT5S86z	11588	16315	16315	1618875900000
23222	3NLAoS6LLZUUahhAWTu1ZWT37ZbdXphyXhJXacNqBUyU3BEiKoUD	23164	3NKjMZ7A9EDqepQMk6ZNzjbvbJcG94oHKNzDUAno5FYbrxC31giB	576	1355	434	12463	15243	jwPWsKq6r9C1rR6HRdBZhBrfHgagfBuKZdXizcykK5GpnjmmyYB	11568	16317	16317	1618876260000
23227	3NLNzF9co3NfP9Eu2G8VT2xCGo2k3AZc1Sp4w1Dx1cw1ZKHSPXtt	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	58	1281	435	12463	15248	jwwHmgPDaUk2Q7bAFdjACTs2U2hYUnF97X3Q3Q3A3Vacj3wtWK1	11591	16319	16319	1618876620000
23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	1403	824	435	12463	15252	jxy5DEmEJGteb3hxZxUY59keih4tj9St5EezdR9Mqps2Roz1QCx	11592	16320	16320	1618876800000
23232	3NLb11w2ZHG7M7XN3FB6QpU8rFGYnuCcnivz5TeQ2tC54Ry5u747	23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	1622	1356	435	12463	15253	jx4aKAQ1AZbt34cFjz6DyRXgTkof5NJcNHrzcGK4qqyQe6zjD3R	11593	16321	16321	1618876980000
23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	149	1283	435	12463	15258	jxNycpocAFHCVJcQkzYRhDY3skWLPPvn7cappZbdWLqNsYbGUTC	11596	16324	16324	1618877520000
23242	3NL45GJmtp6c3JFBArxdCczToFWvKRoesFSkmGerR6AfFEfpk3nw	23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	1657	978	435	12463	15262	jxxt2Z5sbwyjDf91rt4Ft4QbXRanEU6g23P7iTJPdrH19c7bkmD	11598	16326	16326	1618877880000
23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	23242	3NL45GJmtp6c3JFBArxdCczToFWvKRoesFSkmGerR6AfFEfpk3nw	1405	855	435	12463	15263	jxu9wQ5dQAssHRoGj3rY2gpyxpmae6yQ2GuKPCEBBNVcWbMVni6	11599	16327	16327	1618878060000
23248	3NKTvNyxDFBVRMWXhAtot4r18Lj9pdE2g2QEG1RDzo22dwUvLgWw	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1656	1343	436	12463	15268	jwsyUgvY89c7bP7EHiLF9pd7LrnZFdRA24Ne72pGTQ9XJdF95sb	11601	16330	16330	1618878600000
23252	3NKqQTjC2KSoHkyk1zNZrmHEUZhjwmy3VUWiPPo6ab7SpxP8eQV2	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1455	1206	436	12463	15271	jxp82Y6N4H5fbskPrRiSLjNGpKLRNZbRuoD1JJTwCBmxEUUTkCc	11601	16330	16330	1618878600000
23253	3NLLtjqtacZX4TgYr84TPNP7CTP57xvurNqhAhGMN41xdhZmKHYe	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1406	1393	436	12463	15272	jxCEuEGqNQg1QoAjLum7bWab12ZaJyNFLdmsTSsUVhmnAHbA65z	11602	16331	16331	1618878780000
23258	3NLX3Lb62eBvoSU54JvEtXmijbdAJbVuPNj9y3rAeHdiXa9i53xp	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1509	1194	436	12463	15277	jwafUucCeNmj6T1MWSjr4K4iAkhcN4Pxe6YR8pFeqAQMMgnUZ7z	11605	16334	16334	1618879320000
23264	3NKVC2wjMS5hhPVGsRt8uRaCkgAAhkxLx8u26g4aZKn9uvQL3ZyP	23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	1631	793	436	12463	15283	jwHEa7Knv54pp5RxnhGMx38pY69CSbCpY9Y7rnT1RfYLDEbHtqs	11608	16337	16337	1618879860000
23268	3NKp553FRhWY3gepGyxbLhnuGaVEy2nrSGaoqA7HsTQgRi4NYNCZ	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1406	1393	436	12463	15285	jxhvmGdUjqfSRpxh5eLHadAp5LbTFMfRJBAqQ6pRvqes7AyogtN	11609	16338	16338	1618880040000
23269	3NLeRsuS9NT34NgwgjHKXDL55uWzpgnRbmGmh9Ffi473xeW266av	23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	596	1306	436	12463	15286	jwNieM6MZx8EMWwFYFXNMRewRz7Ln6y8wh7XSizSRfwKpdScF9S	11610	16339	16339	1618880220000
23275	3NLaf7zM9TCTv2Gk1ShVzQiJaEYBPieDKaqJGWZPjDJz1LC29a1M	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	1403	824	436	12463	15291	jxoUTSvJpUSEWKsXvdAGZHs5CbwVdAPdK4r4ZbMwxr59EzfHQ4V	11612	16343	16343	1618880940000
23281	3NLfK1PADkqqJMBiCzk2TavPwyMC2Z6stKxku2L4KC3mDvFRNYNU	23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	1407	1395	436	12463	15296	jwhGGjKYfKaJDFV24ugt7tRPN2YYXWRe6AdJNe4qttRtVdjVcyk	11616	16348	16348	1618881840000
23288	3NL5J8gJupAHrE8r9T5VnDQCVUTejDd9ZikAi83Zw7qTVvUSLuyo	23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	633	1384	436	12463	15302	jxPcAbduaPfMhEAheL7VHfabhSzasr8BmTHaG3HQ91T5ZEyXYGy	11620	16354	16354	1618882920000
23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1406	1393	436	12463	15309	jxKgPzV7Hz5LCh6VHyAtoXobMX8JmgRaUgd8Q8t9cx3h2am2yf4	11623	16359	16359	1618883820000
23302	3NLM7p8tbzLQ82HQDCnD94GJu93M2DJctTXYuaEXQSMZxaDDRSxR	23184	3NLEZiDKFenwna9o3kEaAQnBEQxcBtTQQJgaoXXnepTimydTMQ46	80	1027	427	12463	15316	jwiQkQXGTsEFETAR4TfS31Eyvc7Ru64TpPFmfNTY8cbtuptHFqW	11406	16365	16365	1618884900000
23306	3NLm1ANuGQRuazdTnLEEQYUECYdFijUo364uXdGkxZ6GTKQHYHD9	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1445	1290	437	12463	15318	jwbCkYRfxcvcut6qbxaM8CCMhXm194AaZ2jymMvZ4efEJa3R6hq	11629	16366	16366	1618885080000
23307	3NL9Gqzt2mJQ2J5WM2LNp9SazsKx8rQtbeUZ1hh3L9PzQo3KCxum	23304	3NKwobmnyaEjQvY719wF8PtZ9a3a7Fyukmdm1ZyZDk68FeZ1go8N	1553	776	437	12463	15319	jwAseBo138AsJZnf3ZSKZZimGKHJkwmr1UZbpptHm8SenZTGxe4	11630	16367	16367	1618885260000
23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	23307	3NL9Gqzt2mJQ2J5WM2LNp9SazsKx8rQtbeUZ1hh3L9PzQo3KCxum	1593	1346	437	12463	15320	jwD1RQ3iebG8nSy2hWLFVYWeVkkbhKJAmv6J8g3X3U6paj9iMPB	11631	16369	16369	1618885620000
23259	3NKYdreKUSN5D5EoWq6xKwcyuT7vDTwfcWuSVuMbtPVM9TVf5pE5	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1673	1368	436	12463	15278	jxmjuSJgvFbBnvFGPNTqAUMEkKyXemJwp8gSZvARGUSG47CyyJA	11605	16334	16334	1618879320000
23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jwNU8FrMAiz1xrrJskZcrMkgj1yZ95PZ8HntPa4BotZxReBKNbn	11609	16338	16338	1618880040000
23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	1460	376	436	12463	15287	jwW7cmVmLammK6jza7ovNKj3uX4KWM8pCHovdVhUQta6rTPkWKa	11610	16339	16339	1618880220000
23276	3NLL1cjwdMxc5BnAgyZnqaaQ4YPnYtJjVzYAb1KZDPom2sWCPGEU	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	532	1057	436	12463	15292	jwaDBjfiqcyLL7vCiK2QaCq53zufNFgM2XoGfQ7ASPMbf5rD6gZ	11612	16343	16343	1618880940000
23277	3NKKFkzf1sNGuNuCcUzDwLBQMkJvjCy42wzJV3kdi6LSkqdYtP88	23276	3NLL1cjwdMxc5BnAgyZnqaaQ4YPnYtJjVzYAb1KZDPom2sWCPGEU	1633	1390	436	12463	15293	jwYdX9b4QLRrv4erpFcXnM3eskMcPVU6K38S1NpN9KnNfhYFjM7	11613	16345	16345	1618881300000
23282	3NLaPaDwkgWTHQxfsvsFXV4HVuVtGnXVaN2nA3Rv4QGFbXvCFWmX	23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	686	686	436	12463	15297	jwwrxrtu7BAEfMDzfB76aVbnKZ7ybxxP4M2prh5WsrCBAb6ubK5	11616	16348	16348	1618881840000
23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	23282	3NLaPaDwkgWTHQxfsvsFXV4HVuVtGnXVaN2nA3Rv4QGFbXvCFWmX	1476	1125	436	12463	15298	jxX9RfpZnJpV2qbdixsbftg7JLVRfGntuDMihd5wPfi3hH8FiQV	11617	16349	16349	1618882020000
23289	3NLu7GhZbwJymniTD3Fu4retBfGjg9iTZU8LTen1mTkvGfrouKWC	23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	1477	1350	436	12463	15303	jxJtDE5rQAqjZq49yfoMTYpwuNGweLfiqcKNuZwyWtwURSAq6HL	11620	16354	16354	1618882920000
23296	3NLbsztEk6CDsToPeJHuV68k1CthpDdgThxZVVuHDcCUre7ze2Nf	23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	684	1352	436	12463	15310	jxUwHRLo14WomdNLFLrZkdANptSiNd6BBD61gCqL1PjtZ3aw5qP	11624	16360	16360	1618884000000
23303	3NKMaSEsxAJGW9sH6ReUR2JdfatvfXFDdYDrQWtmvAXyv6zXBuXV	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1460	483	437	12463	15317	jw79LsoUMNi9YQpqx4Jm9PwqM2AX8qjD6ze8pnSvogEWdwaUSCF	11629	16366	16366	1618885080000
23309	3NKk9bdJJVxMWYXt5DdnPMkMnaYHZvSRqUNpxosiPHPsEJEKTFj5	23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	1407	1395	437	12463	15321	jx7tihQYxcLJCE8ziXEgxgZ1BH5m3g61UkKha2K5aNjZkaRgr43	11632	16370	16370	1618885800000
23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1397	828	437	12463	15328	jxcuwYbVYUXT5HuMst25ycsWKFjjgvFLRsTuM3grStrauGAgzUs	11635	16375	16375	1618886700000
23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	1439	1279	437	12463	15334	jwbxUpScBigJe75C2A2Rdh6BiEsxukhtrUFXBydcmoDYPBwFMyA	11639	16380	16380	1618887600000
23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	1460	1078	437	12463	15335	jwR8cvG1LnLWAkvGEcGumJbdGf8datY6EFZM1TxtvrLrLk5JJUX	11640	16381	16381	1618887780000
23328	3NLhZntpxZbSr7ws7qprDu4oiAKMyk6XiACrHsdNjtphzoudEUFB	23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	1651	935	437	12463	15340	jxMun7hV4fiBwp7SNWQDSW7GJ18WVYd1kY8Fc6XGvK96C4QG5m3	11636	16383	16383	1618888140000
23332	3NKhm6JGzYzvLkh1TCCFCuv9W3ypaWJHp7xtqVMcq63Sb8k5dv3R	23074	3NLrQ4jFp8PCB9C3nQ1HFbBsT2sTe4RHN1cAN3sWrRSqgAaqv4mx	1458	1197	432	12463	15344	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11521	16384	16384	1618888320000
23333	3NLLZZCPQ4b3LBDrmXQjML1MK2xHbksgSnoZhhe6UxGJK7NZrU3V	23063	3NLETEujrUuciXAGBiNN9316Y22iaC8QqYSD2bTWFPZ8YPpj3oe4	1481	790	428	12463	15345	jxG7v4tX6L3QKqKvDiQdBpWWpNb1uSvR27LmnNFQP26MoZw5HqN	11457	16385	16385	1618888500000
23338	3NKfK6XgJAf1zXs6aVJNiVL9Xjzos9XCNQQoZ5YnxwyNiMFGgxUg	22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	1483	1150	428	12463	15350	jxUmBrsz4PQtx4iUSM1LKK5NkqPtcmpreuL5CT59DAdAFZ4QuTh	11453	16387	16387	1618888860000
23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	44	44	437	12463	15357	jwnvXoiahD7TCPuR7BiNJzn4CqbFNopjfmkRQcDVnToJ9xDnQb8	11649	16393	16393	1618889940000
23351	3NKqTsp4FDcfyg9rqcSkJK6zFF78sr2rLXKuxgcFP6mSboAd3XbW	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1637	816	437	12463	15363	jxJHFY4FzW4vU4ZYwx3cgA5ocTsSbqgm1aaVgaVLgpZLzY4vLL4	11652	16397	16397	1618890660000
23355	3NL7yN5oHUgMS5f3v6mWsMfetfCVKGKTrfuYd7LFb6fPr8kYm68y	23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	1594	1326	437	12463	15367	jx9Sz1RePNeYMA5RzD3ScHQkHwGYPma4gykL9PAiv4cbLResZvJ	11653	16398	16398	1618890840000
23356	3NKRUuctLdujQbiAyePCvcRSHdyNEq7UjCmoRbmtfWZktVDkiZVL	23355	3NL7yN5oHUgMS5f3v6mWsMfetfCVKGKTrfuYd7LFb6fPr8kYm68y	1617	1288	437	12463	15368	jwPd1exaJwThkskhj8osJKUjHfNU9AvdBiKnS5FYnmWRjfMUiTj	11654	16400	16400	1618891200000
23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	23356	3NKRUuctLdujQbiAyePCvcRSHdyNEq7UjCmoRbmtfWZktVDkiZVL	1599	1287	437	12463	15369	jxgafMUyLfKpYBxrGhj3yuNY1HRzJoPAvM8itJfbcuETsbPhvN7	11655	16401	16401	1618891380000
23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	23361	3NLGXrGAUhtcUKpadhv7YfFTGzj1E9ejSg44Hi5qtXmPat7jAzz7	1564	972	438	12463	15374	jxxXDNnpjhpja6vtMncRr9HgfpmhsSFwt7f5Sso7DYgD85VN9pR	11658	16404	16404	1618891920000
23363	3NKwPdJK4TBy2sDnvYYEkABig6EEsCX7eY4NgVVcTyLmtezRaqEh	23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	1500	1171	438	12463	15375	jxpx6QjSmZVP2oZCb6KwWNfqXcmGpyFQYbGW2K6k328TCRZfPLm	11659	16405	16405	1618892100000
23370	3NLFMq6iXWxFja4b6eqCL64MaD32eHopCf1e4S1dfSTAhVKUepYA	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1509	954	438	12463	15382	jxTsKByLAoyrfUM7MBayrWsHHgTX6fFf1EWhW3zsfPAb6prZqWU	11663	16412	16412	1618893360000
23375	3NLi2Aig3wVyL6khJs6AMj7fpvHXN4wNtWQpnhULr2mMK5gaXb7k	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxtCoFc7PHYLM8wVwZ2tcAjsQNhDKcM5UsNy9fSjmiVhDs2fCQb	11664	16413	16413	1618893540000
23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	1617	1162	438	12463	15388	jxNHSUtsEXH8tnRz2rapZmHCAGX7FP6MdAY3i6yhWWo8GCezabd	11666	16416	16416	1618894080000
23381	3NKMf7uW3LxAEPxEcQifkNhK5V9KFZH5e7w2YLcPtQgfwhgy6zNY	23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	1407	1395	438	12463	15389	jxRL7PcfzFwQZkJZ4UTxFzBGgM1P6R5E1Yr2f9bEUKm4oECRz4S	11667	16417	16417	1618894260000
23386	3NKBANQK4C4nMxsx477wdK1kZYtgYj4BT6FFX12cgMbfPBJBBdUe	23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	311	1307	438	12463	15394	jwiHKtYa8h7DWCVvNoh9PtYCToGkuo9zyYRHcGSt8TxmHK6BUsf	11669	16420	16420	1618894800000
23387	3NLmMbam85dtqmWgQVeEazxAhSFL9vcPi9wToVpiWVTHRDykXkCx	23169	3NKi6aR5g9KswbdeCqmVm5UUZSxFvyqaAALdPYzcLkNN9fS4ZFWZ	171	1248	434	12463	15395	jwEwqcvt4WWhdqUVqqpnpEzXMaAUhrM4ovQUoEiq7GSEapED3Lx	11570	16421	16421	1618894980000
23388	3NKTEEyNws1Nk1nzmp921c2gnRVkMkcL9iMk5KMgvyNFjQz3arbE	23327	3NLixR6wXTXdmLK6ww5agBpKS1QfJYmFRyZsZmdY5CBncbYoHcQB	1581	778	433	12463	15396	jwFux6pTLN44LeL2MLNEajBKGs3VP8M7rAewSAVbNb4YXviS4VF	11550	16423	16423	1618895340000
23271	3NKWX29Ugh32muXYh3QFResHqREJWtcrvgjBCFPAxNQbrPMKefpW	23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	596	1306	435	12463	15288	jwMSRhd12DynVT1RNFgJPEyUnQ3NsgnJn4GNNmtbAGd4nEBFq4d	11581	16339	16339	1618880220000
23272	3NKbqsz6JygoJALJE3PYhuLKCnpXJRkjBCueNdEzDAZietUWMsKP	23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	1506	1373	436	12463	15289	jw8JX7cvMZaqcdoKhDQ2DVFEm7FBv8YRcjQDJd7EXYLs6DTbYyC	11611	16342	16342	1618880760000
23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	23277	3NKKFkzf1sNGuNuCcUzDwLBQMkJvjCy42wzJV3kdi6LSkqdYtP88	1406	1393	436	12463	15294	jwBb9FnLBYYvP4FkDiCkF87gyFb26HSREHG7igXAuCc8tLTBT1u	11614	16346	16346	1618881480000
23279	3NKDQqx5g3P5sHgrP4wRkBtvtsLDhdAx4Xv43cW1Cwx4d82zA4TW	23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	1541	1052	436	12463	15295	jwJ6bbt5vKiAHhSMdW9xBBjGTdbi4ef6nQpWLzPqdanBY8Y1wbw	11615	16347	16347	1618881660000
23284	3NKUtebvTNi5kwZXBDf2gCRMPqLHuDzWc7XbCudbcGrZMvX5SysG	23214	3NKNnZZVhS6WBT9zpPuAazXwGn3uQpacsJ39PhoGE3Rn4kvobN9t	1623	839	433	12463	15299	jwMzm69TmMGcY5Cr1SscU9MGgCi2ubyXS8tvzcPg9fryhdDXbHA	11517	16349	16349	1618882020000
23285	3NLf8QYgWzCdPqFMriCbXKxfCr8bL1Q1VyHxi4AGSNHMXXhFaMoe	23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	1529	1316	436	12463	15300	jwwppZgxWeVAd9Lkd9bWfXmnkoBYzRzUf8SoHhaEAtGvs6dxCsY	11618	16352	16352	1618882560000
23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	633	1384	431	12463	15304	jwuq4neuDQshVPqrCdDTbf9hm2LqkZMwdb61zPtE4u88G1ovf3z	11485	16354	16354	1618882920000
23291	3NKckMHjRt9qsyqwSfDkDVoxXecfqWdc7UzuDET5APpwjsFzjQV4	23289	3NLu7GhZbwJymniTD3Fu4retBfGjg9iTZU8LTen1mTkvGfrouKWC	1610	1068	436	12463	15305	jxxK3QZ3j1aDjaVj7wMvMH95wbUE2V1UCS7hP3n1bYivohn8sry	11621	16356	16356	1618883280000
23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	23291	3NKckMHjRt9qsyqwSfDkDVoxXecfqWdc7UzuDET5APpwjsFzjQV4	1553	776	436	12463	15306	jwdJ8MmhFGFsXXwHAaURYZu34jPD99YXk69AKtzNm3vY54EChQG	11622	16357	16357	1618883460000
23293	3NKphptFT1f8PGoreZLwU83Lpx4kB1XMgihJMjn4oAkFE53JNecq	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1439	1033	436	12463	15307	jwqGv4JFP3xCPqXSMcEmsnMxykT7HfijZPCh1vL5GmGmfHJCxNp	11623	16359	16359	1618883820000
23297	3NK67xsFFoHHczoZV3WSZt9vCiziChRFEEFELg2PZQk3MznMATQU	23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	1671	1365	436	12463	15311	jxhRGgneSZ2rHAnxmbps5E2763XZgstskJjEePNharYWeEmQe8k	11624	16360	16360	1618884000000
23298	3NLhCvp5A3Xa1AaufKiYg2zhYq6X6p3ZP8DVWRQqhpBjFD8zXV8g	23297	3NK67xsFFoHHczoZV3WSZt9vCiziChRFEEFELg2PZQk3MznMATQU	1637	816	436	12463	15312	jxr1yNkDCB2CoUq5jWwZomG3bPDedzVpBN1jiKyBPGiBtTVxLVK	11625	16362	16362	1618884360000
23299	3NLCReMd3ZdwckJwr4BwecMJtcNyxLtzGAz8LudJSfUvaawyVdzd	23298	3NLhCvp5A3Xa1AaufKiYg2zhYq6X6p3ZP8DVWRQqhpBjFD8zXV8g	1407	1395	436	12463	15313	jwhKVaf5s1UFc9BgL2QHnhwkxvB2UKwtVJVdUGi44vyEgPeGtKj	11626	16363	16363	1618884540000
23304	3NKwobmnyaEjQvY719wF8PtZ9a3a7Fyukmdm1ZyZDk68FeZ1go8N	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1445	1290	437	12463	15318	jwbCkYRfxcvcut6qbxaM8CCMhXm194AaZ2jymMvZ4efEJa3R6hq	11629	16366	16366	1618885080000
23310	3NLRMByJH17h5HSbSBhAp2oeh4vXt78uPeMcQi18F9RCB9tARZB6	23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	1406	1393	437	12463	15322	jxH7fAJuDoce2kCD5LCq2eiz4XmZM8SVjdT3sgM6KAcr3JovvhF	11632	16370	16370	1618885800000
23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	23310	3NLRMByJH17h5HSbSBhAp2oeh4vXt78uPeMcQi18F9RCB9tARZB6	576	1355	437	12463	15323	jxgKZK9qvoBJ7TbDXmy3HeqgpKeGE84h3krvnJLGQZB92vczoQR	11633	16371	16371	1618885980000
23317	3NLP9gzfRkT24HsWCDBbABFzv962g434KUWv6ehi7ueCdGKPVFDT	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1637	816	437	12463	15329	jwAoWfwtGL659oMz6akzYziFm8CHFxi2psesEVR2dtQDEVNPnD9	11635	16375	16375	1618886700000
23318	3NKGUayTsvAEQWR5P1GGx4w5Nsy8LNYnKDkRLRHPg3XiKLaX6J4R	23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	1534	1191	437	12463	15330	jwpbao3zfHEa2o4AX7sV6DqL2891uaxg3pvjHht8EfdLt768i2A	11636	16377	16377	1618887060000
23324	3NKksuE17wBkCzWBJ2vEVVxwf7exya31Po3qvN9AafQd37KoYXmY	23244	3NLfN2EHZXxhBbmk1zJphYcKjpMdeRrVVTfzGAb9jJG2Ev3L7WXr	1581	778	433	12463	15336	jxz9yxZ4yvw1Au9Y5CmAPmoYAUGjk3NXXfm3uUaVCKTuenpghQq	11548	16381	16381	1618887780000
23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	1651	935	437	12463	15341	jwzUgWMTapweyKG62QZWjusz6xe3Mwm9DRnunwYPa7FXmKBopL2	11641	16383	16383	1618888140000
23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	23331	3NLPE9SUz66h5cxmamMA9TgW24nuN9DBkwLCkkErxZ7DNvoZnesU	1652	1069	437	12463	15346	jwzasJyoHd7ZPdmUzyXh6jB8bkWaJEfRY52sK61VtGD4HYTwoNn	11643	16385	16385	1618888500000
23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	23337	3NLGVZBu7gv3eHghBsivowe8NQs9MApq25kybPUxJGu9xF8EhhrK	1460	483	437	12463	15351	jxFVbyZwjZF6geXGJKwwLDueChmCswCK3y1X5LZ4UtAFQkYrmpP	11646	16388	16388	1618889040000
23340	3NKTU9jV6uSM1skvdy6xHzFazLXzZbmviGhYD6BuT1iCrD9QWthw	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	1553	776	437	12463	15352	jxt94mixWkR7W8YwZaE1utkJxJkKbBpv1cx8yRdg2pARwWpyeTh	11647	16390	16390	1618889400000
23346	3NLmTYkNh7im7wndiUCPsxxU25hcAKvQ37z3BfHFCzvVp1UPLFr8	23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	532	1303	437	12463	15358	jxuMq7LjE453267tD3FCAY7XhG5H3wwSySHofS5SzTRxNxwdCz2	11650	16394	16394	1618890120000
23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1406	1393	437	12463	15364	jxYduY2EJFmGJQGZmuaR1DaA2JKbs17YcX63XW65XrtmoPbs8gZ	11652	16397	16397	1618890660000
23358	3NKHdYeciFcoe2pxKVu1usWRATHXoep5KwdTCXV6Qj9uPYfTDLUb	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1405	867	437	12463	15370	jxJPkpc8XcsmnzeoPa4yzb7K43Np6H9j49iEKGVpGb7BJibTuBt	11656	16402	16402	1618891560000
23364	3NLD9uwL8YHUE6BEe4BTahgA5AkF2HKgm7VVQaCDudTrCYXtgg8b	23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	1600	410	438	12463	15376	jx6GVsDJ5FjPzmotLdAsZwJZuqK1xKFjN4d9ksBZDQfhUmnUabw	11659	16405	16405	1618892100000
23365	3NLTBsyrK2fWkU2Y4Kydea4UT4wXAjmLTFgBpkh2Kroifn8ttnSb	23363	3NKwPdJK4TBy2sDnvYYEkABig6EEsCX7eY4NgVVcTyLmtezRaqEh	1406	1393	438	12463	15377	jw9X6y3BQW8RTgvD9yeAKEmBYLf9Tps2g6FSArFjnxHVYkhN1RK	11660	16407	16407	1618892460000
23371	3NKBmKHBivKYXkY6SAH3GaM8Whm4fkwLgh6tbU2rfmGVoFcNip7C	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1509	954	438	12463	15382	jwyKXjYuGBAJiZQBdbVZBCAMxvtX8VE5ZGDvwsZ8nrsBYcwXSr3	11663	16412	16412	1618893360000
23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxKxpaUX8hiAr6HpaQi4LojBBYQb9p8xvM7swzuje9W6Q2cr9Zu	11664	16413	16413	1618893540000
23377	3NLnSf4Fwjev3UbMQta7m6fyWq1TtSdn4eWUp81dA4i2MGBTGu3a	23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	470	1063	438	12463	15386	jxoGhZK95nVGDY3zcHZ3j25qVrTdZndwmVDT333WggE3c8RDiUw	11665	16415	16415	1618893900000
23382	3NKjxfMEpqP9Rw3c4aPViLVPU8KTw8ybwcrjXskW5nRcrsGqUyPJ	23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	1406	1393	438	12463	15390	jwRQ2Ecv4Ub64GeKhCFmx5asLMwNrCoGZy9uKvgz2bsBfejyoCV	11667	16417	16417	1618894260000
23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	1541	1052	436	12463	15295	jxSubmxKywfPfbgZBtjxdWbxMBSgfZn8GPwsyroipXHP15gBuVe	11615	16347	16347	1618881660000
23286	3NLsnV828WN13GTm8kQFACo9YE6huPqN4UYpgqEPeyH24efmZnQZ	23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	1529	1316	436	12463	15300	jy2DwvY54akYpGdj5kW8C5Ask8b5ymTCvpB6ixBnvxHk5rHStv7	11618	16352	16352	1618882560000
23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	23285	3NLf8QYgWzCdPqFMriCbXKxfCr8bL1Q1VyHxi4AGSNHMXXhFaMoe	1509	1320	436	12463	15301	jwbxe3LPbJBeyyvcR68UAzYUAJFKrhe3rLZCGDyDKXya3jn5wL3	11619	16353	16353	1618882740000
23294	3NKxMeTxe7sE513H7QGiJcECS9g9vmeKfBsRx1DiUy76uziz9shc	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1672	1285	436	12463	15308	jxLqHnAFERbTqJ5NNwouyGTUTiMvbsNy4S3XSY8APfy62v9dDMt	11623	16359	16359	1618883820000
23300	3NKWdthsH5MsjcpUz5RbkBDiBbjX2MRJmzcxrEA7RNhxjpH4riuy	23299	3NLCReMd3ZdwckJwr4BwecMJtcNyxLtzGAz8LudJSfUvaawyVdzd	44	1325	436	12463	15314	jw7Cd3Fa5kSDT79vsCcM1MmzNc7GZb6JG3Jd1Kp5uCXnTSEsAMA	11627	16364	16364	1618884720000
23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	23300	3NKWdthsH5MsjcpUz5RbkBDiBbjX2MRJmzcxrEA7RNhxjpH4riuy	80	1027	436	12463	15315	jwKHK4X1rjsRSQgkptwFSyzW2jwar1HcNrQkn6jXCz36d9BH3xZ	11628	16365	16365	1618884900000
23305	3NLPHeUS5aQQae4A2WzQtzwarzc6SnqMeTcDHTpzbddbMctwHRE5	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1460	483	437	12463	15317	jw79LsoUMNi9YQpqx4Jm9PwqM2AX8qjD6ze8pnSvogEWdwaUSCF	11629	16366	16366	1618885080000
23312	3NLtGAzZza3mcw8ggcvzs55xQczCjd8CysW6VG6qmNfA8Gkj3Cpe	23222	3NLAoS6LLZUUahhAWTu1ZWT37ZbdXphyXhJXacNqBUyU3BEiKoUD	576	1355	435	12463	15324	jwJc2WhyudQwD2bqtKpuiu3rSFnHbMNTXHz7AJi6LgPXQ8qvXHP	11569	16371	16371	1618885980000
23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	684	1352	437	12463	15325	jwpZGnWu7PF1iFtEkxHane6oBFZeE9KLL6owFfrW63SeL5AruLT	11634	16373	16373	1618886340000
23319	3NLh8LebVgzycGpjb6hntmdpnRfeHQP4Hfcabsq3JcvZSQQw99Xm	23318	3NKGUayTsvAEQWR5P1GGx4w5Nsy8LNYnKDkRLRHPg3XiKLaX6J4R	1403	824	437	12463	15331	jxXRU7mgPJmthKjySMGcLmPFcnofaa7j7wYnf5rp4jaLpQbJTZo	11637	16378	16378	1618887240000
23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	23319	3NLh8LebVgzycGpjb6hntmdpnRfeHQP4Hfcabsq3JcvZSQQw99Xm	298	1062	437	12463	15332	jxVLizaUVV47A23wwqJQ6NyU5hpE7aav2dHcUBYDxnbGAkPFUQn	11638	16379	16379	1618887420000
23325	3NKhWXB6HWvmgbYLnFRYt5MQLhNvChkubHWEKRNpLXX6t7epTWPP	23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	1631	794	437	12463	15337	jxkcRfx5sR3ypzeTdu27fYpxVvqSk8trTNoDjK7WWBxB87vRZvs	11640	16381	16381	1618887780000
23326	3NLo6nXK4Wyi2pfobgBirMz1aeegzuqvMXaBPXTVpouC13HNF5pG	23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	1403	823	437	12463	15338	jxrZQp8j2wNfg3cHzo69eT1p2s7YS7UR3obHEymbrvXEtJKNcgw	11641	16383	16383	1618888140000
23330	3NKgptAuTRHieaTHgrfym2Lpi29qmanoNtgjNNSrFaJnng13RTXy	23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	1458	1197	437	12463	15342	jx7wCeiSdc8NHQCn7wYxFFmZS5NGTiDGdhbDz3MshzdqxdktKAg	11642	16384	16384	1618888320000
23335	3NKW3i3jHh1mXrordxZwpXqbgowz9CcitPNoptVqAv1wz3HwCSyf	23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	1447	1345	437	12463	15347	jwdgYjP86gcyxLwF81v14zZzEG9moydsoBf1AC527wvsiTS5Qh5	11644	16386	16386	1618888680000
23341	3NLtmxYhcQQ4RipvkiCRuvfg2uFA3S5nQ5q3NboDFXKxYFMCf4WH	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	42	1361	437	12463	15353	jxr9KBVRQJU2ZPedYTR1QcubdjypXCho39FbBTUWPdtK8SZyCfE	11647	16390	16390	1618889400000
23347	3NLvoPkbVdssdHsJYsbGaWekN4XrQsKFyopcEhE1do19SyfxJQDw	23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	1457	1391	437	12463	15359	jwL19KPovcHwSGWihf26EB3nDMe2sgUT6qzoqnEB8NqH2UhizQf	11650	16394	16394	1618890120000
23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	23347	3NLvoPkbVdssdHsJYsbGaWekN4XrQsKFyopcEhE1do19SyfxJQDw	1471	1140	437	12463	15360	jy252XRh2ZpyB9mj86i4ZF84XJmAaBzvUFHzs7zb7EuwJUJUGMD	11651	16395	16395	1618890300000
23349	3NKu5SDCM76bEV9WvRSxPvsSHkRwUzBGxKhc8Rv51K5jdqCCrb9p	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1588	1392	437	12463	15361	jwdJffzWJ5zw7evpTUy8y8CyMp9gDdq5FSAfvEwEaVGuEbAEwRS	11652	16397	16397	1618890660000
23353	3NL8puLK4LituyHzdXjMmmKRKH1TcqAKY9oyu3JEWX6UMZg85Zc9	23302	3NLM7p8tbzLQ82HQDCnD94GJu93M2DJctTXYuaEXQSMZxaDDRSxR	80	907	428	12463	15365	jxHLfovYKApmVuhkcGxk8tAPpHLqP82nEpyWgPbbC4G17MrETdX	11407	16397	16397	1618890660000
23359	3NKALnG2E9pLQUzMjnbYkTLdLr3ew1gKVarjYKZNCYegmtaWmP8T	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1407	1395	437	12463	15371	jxh5Y1c4qwSA5Q4JLKLp4zpovTSUZxfDCdfoRQR2Ke4yg8FNR8W	11656	16402	16402	1618891560000
23366	3NLGTCZVbANzdrcHsyeqT4h7vLJMpGNdNEuHXH1kvxDAfhb2VGuE	23314	3NK6sUhW5MaDtbLqYfRvC3M9uXG5WoNYkJTetG5kGCRaABrdQmaC	1461	1271	431	12463	15378	jxWfSXfPUKxSTFwihcEF8WaM74setMUGtsJy4zqzHbsBgec7TBw	11487	16408	16408	1618892640000
23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	23365	3NLTBsyrK2fWkU2Y4Kydea4UT4wXAjmLTFgBpkh2Kroifn8ttnSb	1623	839	438	12463	15379	jxNCRmg8dXdGs6D43YhXbCfpFaFfgxtiK9HWFbZyuS7pnDToBCq	11661	16409	16409	1618892820000
23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	1547	1252	438	12463	15380	jwdVnLmaxsJkzsstnEdsAphhggAWMFgkYX4JDVv8xDbsc5L2DLq	11662	16411	16411	1618893180000
23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1406	1393	438	12463	15383	jwPqtdAtwgjeFXVAVuTfEtEUEWkZi4nxD3ZsFf4QMFNGHEEK6Mw	11663	16412	16412	1618893360000
23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	470	1063	438	12463	15386	jxCmiWQSGj5tx1TgnbiRRjKQWU4dbSYdAgfjUP5s18c1yLzecbS	11665	16415	16415	1618893900000
23383	3NK8i6wDe128n1vSdA2xxrtYmW86v2mm2QwHx6NP4YFpEefVT4fi	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	75	75	438	12463	15391	jxzDYyqodAWv66RJqZAnXDHC7Z2751Cs9U4iK9Ft72s8WVm6LYf	11663	16417	16417	1618894260000
23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	23381	3NKMf7uW3LxAEPxEcQifkNhK5V9KFZH5e7w2YLcPtQgfwhgy6zNY	1599	477	438	12463	15392	jwVd9LVTDnCfXBZs9SEHcxWhtNE13Ek8WsWDQRH4ihRiAoQG861	11668	16419	16419	1618894620000
23395	3NKpWSD9oqcrv1LWSDGRsQW6xYoh3PbS5b6j6WZ6ntSb1MS4kTzo	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1483	893	438	12463	15403	jwcPJdayw2WYiJuDnDS3RxrahrvbjCPPANusDCuwrKpnGwtZAiF	11671	16427	16427	1618896060000
23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	1403	824	438	12463	15405	jwbZuuoHjuCAHUsBv1fsbGJxpnjaHPCbbNheg4GgcrzhzkVusBb	11672	16428	16428	1618896240000
23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	23402	3NLwmyRjXuHR5vxruGJJZ3BdNntzcAmXXCAZanK5THGVEZG8Gdqp	1637	816	438	12463	15410	jxffyjxMmU4TmL4NAwsBDYJZdetoh78pgfz25DnaQi8GxKr1CNa	11676	16432	16432	1618896960000
23404	3NLd5LxYW7jKmWrMziJAimk35FRCchEopbf7RfWXGDa8Ck83tb5u	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1477	1350	438	12463	15411	jxPbYfoLt5V8NXTYvhrJCuK4pvqNejUpCAydG89hNtJbWju2Ys7	11677	16436	16436	1618897680000
23314	3NK6sUhW5MaDtbLqYfRvC3M9uXG5WoNYkJTetG5kGCRaABrdQmaC	23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	1461	1271	431	12463	15326	jwuP1XpXiE6Gec66HYy3uKBiQzaKh9UsMFfaZdFWTLh3nBLhjcV	11486	16374	16374	1618886520000
23315	3NKzoFR3MvX9e1J3k1gwfzxcNSxFo4vxcYxWRBbR9EgfpPSE1pop	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1610	1314	437	12463	15327	jxkoEAiSVT7cBdzvqfeNJ9FrZNXZBSU8hrHyp7shZJ1TZgH32Zs	11635	16375	16375	1618886700000
23321	3NLNqDnGaNEPKhdMWdSEG6pHQZNHq5fAB9z6a2UsZhy2tCyrxDh2	23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	44	1079	437	12463	15333	jxBi25ReTCEUcjWdrrK4YFL7PBiCoJt3SgNoB3RjCMNtsgaaZNL	11639	16380	16380	1618887600000
23327	3NLixR6wXTXdmLK6ww5agBpKS1QfJYmFRyZsZmdY5CBncbYoHcQB	23324	3NKksuE17wBkCzWBJ2vEVVxwf7exya31Po3qvN9AafQd37KoYXmY	1581	778	433	12463	15339	jxyEBUsJKMjKTzuRj3mn2Bj2PTdMfWhBzQdoxMsgQyBmJP2JFcJ	11549	16383	16383	1618888140000
23331	3NLPE9SUz66h5cxmamMA9TgW24nuN9DBkwLCkkErxZ7DNvoZnesU	23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	1406	1393	437	12463	15343	jxfVj7dMi9S765qVjmnhjXLu1qzHFVKqzgnbJXyausKdMsVAWNg	11642	16384	16384	1618888320000
23336	3NKyKHZALLSXWXjcRyTpqRs7ScNeX42Rrk7fMRgTKHdsH6tapFiV	23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	58	1155	437	12463	15348	jxWzA7D21y45jca7tEhK5GXy1LkjCsinrH9oN319XEq7mvS4fV5	11644	16386	16386	1618888680000
23337	3NLGVZBu7gv3eHghBsivowe8NQs9MApq25kybPUxJGu9xF8EhhrK	23335	3NKW3i3jHh1mXrordxZwpXqbgowz9CcitPNoptVqAv1wz3HwCSyf	1483	1150	437	12463	15349	jxAHGFHvuTjhKLpEBHNSwBrDhLDw9iLEFP8rPmcVZfm8XUDG1gQ	11645	16387	16387	1618888860000
23342	3NKNSDiQUPNb62Gih9opa7UcKfxGGdfLe6DeJHtHLphibV6AYSPK	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	1637	816	437	12463	15354	jwkcV35TViVycqJLuLvtkPGMiGdkUq3oJMLEmoevSnNQaQPN7KD	11647	16390	16390	1618889400000
23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	23341	3NLtmxYhcQQ4RipvkiCRuvfg2uFA3S5nQ5q3NboDFXKxYFMCf4WH	1591	281	437	12463	15355	jwDTgpjxTP2m1ucCVy9kNEqxeH9J2An3FNe6HgXxmQ4kubejcRM	11648	16392	16392	1618889760000
23344	3NL4t6y8PQBvpGVCcPKE2VpNKMZEtJvFfe2bjdi9UwT22uLswBcf	23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	1422	1337	437	12463	15356	jy16yP973DJAizJ5WiNFTa7kb1LQAtzP4Ko1SfxSYyXGiCMKqDT	11649	16393	16393	1618889940000
23350	3NLCnTVEGUr1pYMjX5c1VEQS3U8GbpFoJ1MA7ddEwW9J66k4HwBb	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	80	907	437	12463	15362	jwsBJfx7bS1Mh6joYjHofBFW34LCvPWJCawddHD7PBHT8jzc3VW	11652	16397	16397	1618890660000
23354	3NKSNz2wwrgeaCaBnpg1XUsVM4TKkCnhoVNiUcq1Nsn5iE4vrRhf	23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	1593	1346	437	12463	15366	jwTnw7rMZ4pgpa284bEu5NmRuqFuZ2NwTfDHuzmyzfLBmDhbcyp	11653	16398	16398	1618890840000
23360	3NKzPDMao83A8uzrLSCpmagnWEGJdqhXESy4zgbSAZiLudoKcWWZ	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1617	1042	437	12463	15372	jxrpYn8KgmFQpYHh2eA18eWh5cAe57BkR5s5ArqZQLGcrmLadju	11656	16402	16402	1618891560000
23361	3NLGXrGAUhtcUKpadhv7YfFTGzj1E9ejSg44Hi5qtXmPat7jAzz7	23358	3NKHdYeciFcoe2pxKVu1usWRATHXoep5KwdTCXV6Qj9uPYfTDLUb	1403	824	438	12463	15373	jxDekGReGNmpZ6342s5RYcMfuyh2PCzjtWdu4D77koe33Lutryf	11657	16403	16403	1618891740000
23369	3NKvHv3oyC83L6n85u58Bnk3dEC8UHemUu1ZbWRtaYDWHCZn25ma	23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	1406	1393	438	12463	15381	jxQvyH8BajgfBgBtxGEqrUtmnWJgnLodZVPUvzkyRPkjzjZMrkn	11662	16411	16411	1618893180000
23373	3NKxMyLNaZBVeUHMbGfua5skFyVq1dhAKm7Xe3WTMeN8SwvCemaV	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1634	1205	438	12463	15384	jwUUd8PeiBWzEYDxwkBzppwtc6qi3yoLSggiNPmmR51o25cbvaG	11663	16412	16412	1618893360000
23374	3NKFYpFxVGL1fpEx7rfqxZZt8j5zxwCZxNnABpz6mdUfAc9BkFLj	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxgfujZPXK32MPCusRZ1K2GpMCQg84PrYDZR3PtK7L1ZwPGys65	11664	16413	16413	1618893540000
23379	3NLNu4MSQ5v25t5TPw2VKY3v5RrQMB93eaTwNrpxnwiHqzo89jt6	23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	1403	800	438	12463	15387	jxcBvYwWJQWAxshGQfMm2A7E7GWoBRKNyu94ZhqswmWS2f1htCp	11666	16416	16416	1618894080000
23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	1594	1080	438	12463	15393	jxZqy1q7D5hdPY3XeYsLgrbrAMyqgsvb96XUugezLxEdyup3oS9	11669	16420	16420	1618894800000
23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	633	1384	438	12463	15400	jwG1Vg8AsvAFaAPqXeRU4HsqTR3zqtp48dAmvg2z53ipcVe8g8W	11671	16427	16427	1618896060000
23397	3NKBUddCjDjysbX8VgHUSHxSzZPeLtaf5jwZujxyNM8FYUa45s3S	23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	633	1384	432	12463	15404	jxwT1aFw18jtvYYfJrkFZQTh42NuvipFqz2zLuRGFmW5k7xXfNS	11486	16427	16427	1618896060000
23400	3NKw9wDx2WiFqVT8rXySoNdFft6GVM4ZWNDPuQ6Nqk96JdhMH6wS	23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	1405	849	438	12463	15407	jxvf2TMqZq76v9XUehFHNV8MhQh4WwwDGCmckrNjd16E3RdcDpZ	11673	16429	16429	1618896420000
23401	3NLstXoXMtsaqGQYXGfHKfovKPmhLNd6CZu658SNyb7FL7TJqTXD	23400	3NKw9wDx2WiFqVT8rXySoNdFft6GVM4ZWNDPuQ6Nqk96JdhMH6wS	1600	1372	438	12463	15408	jwtoy9k4ssDsHs8QoK3YXya34Eytua4ADgx4ZwjVFYGmXdDvpjh	11674	16430	16430	1618896600000
23405	3NKTm7pA1ZSWcrphzTnknXaYaszZ5Xx9tKdGc4doR3ZLSiQZue8M	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	152	1330	438	12463	15412	jxWhNc4KQabfShGgKs7jVvFGThnWSSo5ja3hSKHLWHKRxKpCntR	11677	16436	16436	1618897680000
23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	23404	3NLd5LxYW7jKmWrMziJAimk35FRCchEopbf7RfWXGDa8Ck83tb5u	1407	1395	438	12463	15414	jwHf48wb4uTGCgczYgZErwVzKAz1hSKbmfkLvriQXRxvdd9ZcG4	11678	16438	16438	1618898040000
23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1587	1111	439	12463	15420	jxfhmqsojffBHfN5JrRFvioyRhkL5JUwas1Tbdh6VyhabHoXT7Y	11682	16443	16443	1618898940000
23418	3NKGWGnHDjjksvZUjLR5v89dNnP5pFEWhwX3ZLEAB9wSv8BCfAZz	23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	1529	1070	439	12463	15423	jwZ57aFvawGQ9e2jzgFDsSN17Xf4uepfh2xE4FyK7HVpVzc998M	11683	16444	16444	1618899120000
23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	23419	3NLyQGWqA5ZLAZhe1oVLyteLA62U5sbkHK7S5QP46hXt9fLQsJDH	1483	562	439	12463	15425	jxELMwjyFFPYPRAq6wycvuhY9y9ZQRUDciCQHjWXUFKeC4R3kS4	11685	16446	16446	1618899480000
23423	3NL73PAhNrFc57J7uEohFE3a8JmVpX7tc9XcbkV9z6rYNqnimmip	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxywM97VzaYejsyid2fuWcdZJePyek6MJDr6q2ecciLN2TpTA79	11687	16450	16450	1618900200000
23431	3NKRuKbyCAWzmujFrd9drHMSSUAfK8RcHsX9ER54fQBMhZt5WZxD	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1506	1127	439	12463	15433	jwNJahLx7bF6xpV1CRcAkG2Jspc5mE7A5juxfVfjqjwHX3fVYux	11689	16452	16452	1618900560000
23432	3NLt3qz61fDixuXmRDrm1jLdgrQpwdXjtY4sDi6sRsAarTsyHnvM	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1608	1289	439	12463	15434	jwK8sxvSsatMpXZMxp8XipAVxNvumGg2KAZu6tMVunyXGL9ymfc	11690	16453	16453	1618900740000
23435	3NKGAKHjWXdvxmJ3H6oc3h3whRHrfuFAx16bA1FnZx8MwChSwRTa	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1541	1298	439	12463	15437	jxD82hHYvWF1XKBPGcGyD6YEEWSYcwH2Pdj2pb9abfpLqLFYemt	11690	16453	16453	1618900740000
23389	3NKGf9Bi7kJrrkUR5fNAaySjA7LNnuCTU9iCjWfTsCapY9zgoLSv	23388	3NKTEEyNws1Nk1nzmp921c2gnRVkMkcL9iMk5KMgvyNFjQz3arbE	1581	778	433	12463	15397	jxYKykwh54TPKQwTSkBacn54EYCicBwVwHWaHDv3HxZPfoa6EuD	11551	16424	16424	1618895520000
23393	3NKXsNydThGNcAmJGoPsaheTZ6jWRnVxytjkK2KRuEV9HGD9kvJj	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1503	1151	438	12463	15401	jwR4cn2NHvFpKYqfgXCq4vSt1rmaXf9TQNc5FYTXV4gDWQWyzDn	11671	16427	16427	1618896060000
23399	3NK9reipQLxRaXtiQnR3LgZJDQsvxgNUBoKY1YThFcVVE8geUAwQ	23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	1406	1393	438	12463	15406	jxPRP9SPQvwryVi1RWJzdMg15bQtAynPnYA29Zi64eRTrb8X84j	11672	16428	16428	1618896240000
23410	3NKEULYugW9NFZzmGHmJDycAnZ3hh6iQhKMURphLfR2gPdeukVNg	23156	3NLw2UA1unfvrHAkieZTGUa66tisQvLd9nrZbRoKKX6JWnvRn58T	1444	1015	434	12463	15417	jwcCRfzKXYizTPT92KpiqGjJbU5U9RqLtbKvmkwZaGmd9N7QmLf	11538	16439	16439	1618898220000
23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	152	1330	438	12463	15419	jwckiK82y7P5vSx8oHNPNQokXPPWVF3zM9vb9NxqKLvd4pPneLi	11681	16441	16441	1618898580000
23416	3NKUagUSNesemRChmmiwL7vr51sVG3w4tVGz77Nm3DH4ppGnF98V	23393	3NKXsNydThGNcAmJGoPsaheTZ6jWRnVxytjkK2KRuEV9HGD9kvJj	1457	1265	438	12463	15422	jxkks1ijbyvPoM1W7LDfezrkrshnyzWUTo8f6gPmdPhjrkM6ATJ	11672	16443	16443	1618898940000
23419	3NLyQGWqA5ZLAZhe1oVLyteLA62U5sbkHK7S5QP46hXt9fLQsJDH	23418	3NKGWGnHDjjksvZUjLR5v89dNnP5pFEWhwX3ZLEAB9wSv8BCfAZz	1553	776	439	12463	15424	jwDv5m1DgaGK2KandtiPjmLhRNjeYnm9hf2YYro2b9knGeNmGGa	11684	16445	16445	1618899300000
23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	1631	794	439	12463	15427	jwgaaFEkPCpiyEcvam4goaedMEjK84WMwMWcqMhHRr16hWPJPLt	11686	16449	16449	1618900020000
23425	3NLEDaH1sVcpL9GohPVSSxoMCWfckFhQo3UZDQzikK15k8DJ2rnN	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxm3LgBh5n88ZNF3oXfMmoxT3YrTjpy5Y6Q6e4AEZVReXdUNacy	11687	16450	16450	1618900200000
23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	596	1306	439	12463	15432	jxWMroofisfgvJ8r9xUtUkLaf59Vq1YtN95YVPe3vS4tjukDnAH	11689	16452	16452	1618900560000
23434	3NL7DQezmX5YbppZYDfeXTvaUW4FqTh2MbSxZpGLpH13xPsh6n4u	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1406	1393	439	12463	15436	jwk3WeZjGAefkZg2r8rwTLFnrkpYiTumaTLiSosgFZmyKTxiffW	11690	16453	16453	1618900740000
23436	3NLUXVcRJWi8XGpqi6uHC3XHBXVyJASwLtNcRYr1yXWnPnZ8KNYb	23428	3NKXHLHZb3cpFkfNEyjXsdfHcKetfAS5D82GwKDuaS4Pm2Rwa38T	1541	1298	439	12463	15438	jwym5BtJtcdukiESf5uowZUM2J4F5PMVL5jP12VAJbyNCwXWmnX	11690	16453	16453	1618900740000
23437	3NK7MZ9yToaZa4scshyd2jE8hoBYiRq1XEKbj9jfSX1NFBLNYK39	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1405	851	439	12463	15439	jxLq6RxoqrbXi8nw4U1BcaCbd9cSJiYSwJY1hCtSXTYkqeS3Mgh	11691	16454	16454	1618900920000
23441	3NLoQ4ugpfPRjWmbFmBZpvwXLtaXtQiu4XZxiuEy3LLRoGT2nJyN	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1406	1393	439	12463	15443	jxpTVJFYyPig1UY3mNT6ycaREuxKyCbuZa2boF7mcuB6M47GYJe	11691	16454	16454	1618900920000
23444	3NLUrQcvmVg88FJVP9ykwZWXURyBWA5YpgSsVwRyf3JrgZgrECyQ	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	404	404	439	12463	15445	jxhavBddsXP47wE1GwEeTYcCGENSYhfoSQ6tTPsHNzjgG6dTFUd	11691	16454	16454	1618900922976
23445	3NKQFXHohKkkkYzoewCCmzc7RSytefUe6jQ9tuvUkNDfrD4BoQj8	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1602	1123	430	12463	15446	jxvz8BXtddxW3NkFGF4izUmiftjp9FMRnckjv16QVgRwCMXbviq	11478	16454	16454	1618901003744
23448	3NLKxKUy3E4PR2jDGjekLR9DMewPEtoHfaBiBLNNzPHd81zFMb65	23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	1406	1393	439	12463	15449	jxoPAN4SbYi5R3pCDCCLLeEqySXcVZqtbRhBwf8pRoxd2LwdRTy	11692	16455	16455	1618901100000
23452	3NL7FdGoLmFGLhVDEazszUwUFFLkpnfhb65QCmujcgwrKTbLaM1v	23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	1460	1198	439	12463	15453	jwNqoXZ8s7GmipwHAkxRLqfTSanQKBBVunWUXD9ckT55hEebNbi	11695	16458	16458	1618901640000
23457	3NKjteTEt4DrPVbkyTtFg2EkgrR3VFk8Ka6EwLLWE8Ebyo94onqH	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1458	957	439	12463	15458	jxpQkxtx2DMLbkin95D2w3gc4Udw47nWH4gwERBHPYAFHrPR5RL	11697	16460	16460	1618902000000
23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	1571	1089	439	12463	15465	jxt38JQ8fAkDh427gEKYt5ACNGJ4tAwz58NZbkzjpRNYc97cZSJ	11700	16466	16466	1618903080000
23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	1406	1393	439	12463	15468	jxCRgjFAqnjn4CVCh9f6yRYVMMHj5SEVcPCjxPDGE4PQHwvymRL	11701	16467	16467	1618903260000
23470	3NKq6AuovBWm1CauHxiAGkznqHZxxAVV8tybN4Mds8pHGXiMMmns	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1407	1395	439	12463	15470	jwMkdyZFeBVFBFbLqka6wToYw6ntTdWk933zsZgNWHJRgP66crj	11703	16469	16469	1618903620000
23475	3NKbkoHY4KThE6peCBsLk6XrmKKXcSD955Hc2dbXHjCmJ6GEmE9i	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jxVHaK1HSimGvTpG41K23mHLaKmttfcJnQbrJ3T8EAXJt2s6RxF	11705	16471	16471	1618903980000
23484	3NLuLshKwZ45hBkPBoHSgbF5GB1HLUf45s8q7teuS3KGSXFM9H8y	23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	1406	1393	440	12463	15482	jxFBjNsGSd2vNa9vXPWbDCQFMNYv1yPwTP8xC6kfaDRuciftUho	11710	16478	16478	1618905240000
23491	3NLsZFCKTD9FVQgEZzN3oR8yPUDetwm86HMvrYgG2ZuZ5zvzzKu3	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1611	1095	440	12463	15489	jxtEgCoLDvSyvpaiW38qo3EWCkN3J2BeqonYPae77n8sC6okasd	11712	16480	16480	1618905600000
23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	1534	164	440	12463	15491	jwE7emyLWqncDgWbJ83E9AWtYPR9RskRsy3W5QteGMqamLiUVvJ	11713	16482	16482	1618905960000
23496	3NLkEkscrsxwK4sdyEiwsJ3JbFxdGSpnqYdZW3TifvncAtMbWidj	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1654	1340	440	12463	15494	jxrpBvy8sTUo6w6uxteTYTmjmMC68fgHiS7LjhvH6j2tDPfEBCM	11714	16483	16483	1618906140000
23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	23498	3NLb2G1NN1jyJWtajJPRe7Ara7kxehQTCqUcMR6AqLaUc22nTrXM	1611	975	440	12463	15499	jx3Tz83BJegXWt27u8cZne2VQz5SsZLEUCFCEN4Ljso1s6HHrmn	11715	16484	16484	1618906320000
23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1403	824	440	12463	15502	jxgy2Hx9QTiN7Yt6sMMVto3tLtmrCjn5nUNdMTxz4a9gQbYqLKw	11717	16487	16487	1618906860000
23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	1474	1329	440	12463	15506	jwjsRxRbFHJvGf2bumByU59AFadkw6mpaJGAugcChyap6PpMcL4	11718	16488	16488	1618907040000
23511	3NLLXMq8X4QkHD9jUWMZBkZLb8DFKxHDK8mUP7ne9t73FbETsAX3	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1651	1301	440	12463	15508	jxMyTgMULqhvVW864uqkWYcN7qYK6DmBw38pkUpTVtms4ucyJyx	11719	16489	16489	1618907220000
23517	3NLdGpvmGH89tBsEZhZ55yE5ym6Jq685LXoQVQVBhCJSLnZJELba	23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	1447	1345	440	12463	15512	jwY1g24KGFvF8og5yhH4wznQBu8wzgSnC2LBmkjEkMgD2j6sVWi	11722	16492	16492	1618907760000
23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	1407	1395	438	12463	15398	jxNWzb6XeLpvu8gNhwxf3iM5s6UhJmox7Etzf4GjoKvsyVraBkF	11670	16425	16425	1618895700000
23391	3NKn6xRvM9aPbk2f9stQHny3RQ7V28YK6UXV969UpwotvrGBFDJH	23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	1403	824	438	12463	15399	jwLJ9J2tkFEXDoMEx1nTHFAqEXbLGVmCSrsrY6VdvHcL3GHaMwi	11670	16425	16425	1618895700000
23394	3NK9axSMmWiBGK2auTvXSJCSUVragUeJvmHfj4odQLs8aNE9BDko	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	563	1359	438	12463	15402	jxVzSEGDU4Qcmdptae8tdNcUDw4epmqQKvLSNWxR3spYQwFqEtB	11671	16427	16427	1618896060000
23396	3NLG4qWaAgeMXyqSqnhpRKC6isb2yQe7gjbigSr4r5zbTbwNRU1e	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1483	893	438	12463	15403	jxZmtHMrYwyDK8CjEy2znUUR4KnDU2toEZ7XKi5z2C1mJF73aDE	11671	16427	16427	1618896060000
23402	3NLwmyRjXuHR5vxruGJJZ3BdNntzcAmXXCAZanK5THGVEZG8Gdqp	23401	3NLstXoXMtsaqGQYXGfHKfovKPmhLNd6CZu658SNyb7FL7TJqTXD	1647	1302	438	12463	15409	jxXHTUQv36NN2fK7dRbJGxBZ6qWNveNAp3M1s4X6KCtrmfDksa3	11675	16431	16431	1618896780000
23406	3NK8yMRf5iSkkbnvnoSSpV6hx6oRDy1J53WZQxHz9gDSTDsfCm7j	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1559	1227	438	12463	15413	jxFsk7c4kCDYZikkvsEdirVvpbdFNZJiZ5mkXKisUeLhgEReqmm	11677	16436	16436	1618897680000
23408	3NKyedfBXT8DMFk1e5tpFUdHj3xsfBM99rFVJBgfPVkkPNE48XaF	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1471	1140	438	12463	15415	jwgdCE3u8kPnwChUqdVgLNgeHQasaxC3AYCejNV8yQLXDyvN3vH	11679	16439	16439	1618898220000
23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	1490	1274	438	12463	15418	jwK3Xd33LHMgKrfwZgpZ5wzvgaokbun9aXTN2sn4uzSrxt8B3kV	11680	16440	16440	1618898400000
23415	3NKMGCTZvphib13HW2J2vYvrVMEaSZsHWwRfc5WUGp4dh8jVuoT3	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1553	776	439	12463	15421	jxnBG7qm8qU43Lk21G3uRg1szGr5HzugoPRhzVBheL6bSjRoPwK	11682	16443	16443	1618898940000
23421	3NLB2SZVtBsLwAHsSqWY3tb7NKhFYEfSP4yHqTNV57sJRxL1WY89	23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	1483	562	438	12463	15426	jwwvpJzqRNMjDr7tiimjiSDuDz1Qc6Vt34j89EMkU6d6TDdvuGE	11673	16446	16446	1618899480000
23424	3NK6ECghT89r2CaG9Hjrntfkdt94TPEespqjXFZYduANituACt2c	23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	1445	1290	439	12463	15429	jxF7S4xfSePU7LGfTTQLrsz8aYFFLCPYttfHWA9jL4v9N5V3xsJ	11686	16450	16450	1618900200000
23426	3NKPTrmyHknVvXejNZhrYLjotq9LbLD6ctpUkuJ1uHbZUm6k7NrN	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxm3LgBh5n88ZNF3oXfMmoxT3YrTjpy5Y6Q6e4AEZVReXdUNacy	11687	16450	16450	1618900252147
23428	3NKXHLHZb3cpFkfNEyjXsdfHcKetfAS5D82GwKDuaS4Pm2Rwa38T	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1405	867	439	12463	15431	jwQL9CTabsoYsHYDwkzyMv5u5uBaas1cxUoW9LSRNHq7k9dNaHC	11689	16452	16452	1618900560000
23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1490	1274	439	12463	15435	jxBXUKSQQ4r2rTwB87tJyGatmTiZMBey96f3hCjfdLL2Ux7dBxM	11690	16453	16453	1618900740000
23440	3NKFpYiXGoxkFmiznaDX2EMP8SFM4rTMJGNUKow21mNrp2ePm6L1	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1602	1123	439	12463	15442	jxEEFDimyo3dPYAbxPVMeAi53p8KxxwEGU1NTayEnszaDV4rV2Z	11691	16454	16454	1618900920000
23447	3NKwgm212Y45QiovhjVakF8YCGL19EHqmD52knqLz79taYKjurtP	23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	1407	1395	439	12463	15448	jxhUwbNURMwRApqR5TM1btsBRThxHaqbTrJ2sPQK7fvR5NDztpx	11692	16455	16455	1618901100000
23449	3NK85FGcLKcB3qjsapz6fxhEGJzn2TA1qcFvrPih4WioRJgAbrSt	23447	3NKwgm212Y45QiovhjVakF8YCGL19EHqmD52knqLz79taYKjurtP	1483	578	439	12463	15450	jwYK5JnsCZS7P4LGXAp2gCpE9ginzEdM4NEakp3WQvkPCVQyjM3	11693	16456	16456	1618901280000
23456	3NKn6UnLQxwKBPfKApxSJP6r1ZqK9tRrB6PiRaebFk4Qf8bLwjFh	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	80	907	439	12463	15457	jxUdnAvKYQM2rKvNofCZNReoiXPxGCbshF55YpWk2hkpnJQZZQV	11697	16460	16460	1618902000000
23467	3NLRiKUFxZ6rui5D8sQzPdLxuL5c3KvvzNTgSGbdug2dnshLNqrt	23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	1407	1395	439	12463	15467	jxiREiYs14wJ19CnyGsBHF5L26Nzran8ByTRxo1gjBnnfAfGoZ8	11701	16467	16467	1618903260000
23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	1406	1393	439	12463	15469	jwX9jdfogRbn4zkK9LCYxsv1jyZq67iYfJahJBPaUVPVEQrCCBD	11702	16468	16468	1618903440000
23474	3NKcPpUvyMivSsAytuK7bXkeDxxPwrsMttpL4QSduS7dVyEJEuL2	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jw9Bf4w9yWkbFfonZbW8kP4zR9nEau1rKQC3WdvN2dqB3q3u2N1	11705	16471	16471	1618903980000
23479	3NKYGYGeyxnW3X9zBfEiPRVbvT529FQbuLhBW6iGbF4N6WEVfWN7	23389	3NKGf9Bi7kJrrkUR5fNAaySjA7LNnuCTU9iCjWfTsCapY9zgoLSv	1581	778	433	12463	15477	jxxyD3qZ1onA6DQ4DRXzLCVfBvvpbLg9om34PNxdLEeYL6obY18	11552	16473	16473	1618904340000
23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	23480	3NLvy3bW6pPJWUrm7MQ5JGxUY7uCDRT63v3uVW23ccr25ApvTkyS	1555	1347	440	12463	15479	jxcnd76HUzU5xPbmQguFZGofkKgPzmtpQc1uACjMQvX6kTj8D7v	11708	16475	16475	1618904700000
23485	3NLWU5rsJDcwBxWZzgugUVJkByK8AhRJQo3ZdtShCcUdmEdn69Qt	23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	1601	1262	440	12463	15483	jwSeA6j7B6CA6V4DazEtrBBp7MpPautHCgzCuhip9Q2Aa13YnVK	11710	16478	16478	1618905240000
23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	23484	3NLuLshKwZ45hBkPBoHSgbF5GB1HLUf45s8q7teuS3KGSXFM9H8y	1460	426	440	12463	15485	jwdGeMvKXrf8pnMs2Qxf4ZHCNo1w8EswCQr1udJ2Gnc8tHe13Ne	11711	16479	16479	1618905420000
23489	3NLJoNbZKTjeDu3si9swqwEskJCR5nPbydyGP4qpgptgjYyvHjs6	23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	1460	426	438	12463	15487	jx4MHekWqU1tN5MeVcAnFDGhmsTA3akAru79oW4ffFKBKr3634P	11681	16479	16479	1618905502854
23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1555	1101	440	12463	15490	jwYJmqyNXy9sbzicZCSbgRGQEg3Q2HYepsaffhNBZ8Kjh34QMkt	11712	16480	16480	1618905600000
23494	3NL69i3B54xFQoNFWXyZ7RyFk9DC5FYaxRzNBWHmFG7Dj5DaH6ni	23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	1623	830	440	12463	15492	jx1kA5eFdz5WS5iMC7HXqPsQYKxhoMP3VWwiNNaWE9KMQdji7qW	11713	16482	16482	1618905960000
23497	3NKrm6gknPnfRuiqYahcYQHAGRf4HV7R7LcnRdYPRv9LfyTLygRx	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1406	1393	440	12463	15495	jweo8aT7gdiSfYG3sUY7ZDaKzz31NhMzTqrDzs1REw1nYR45kTz	11714	16483	16483	1618906140000
23502	3NLx6vZZj776M4TeesGhF2bT3RYCnxh7ykqjee8rm6f3ZA1XAWE3	23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	1445	1290	440	12463	15500	jwrb34KTdNbGxazBEUCUJDxFeaCaHVUvpDS92hsis5ctkNWj6vz	11716	16486	16486	1618906680000
23505	3NL6DVC33FtYZYtsibPUAeFyLnHTgupc5yeshYhRRYQoJe8FMGFr	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1406	1393	440	12463	15503	jxbi5YqnJAqPvfTdaugh9ZbuBiUm6Z2v3Wy4YyGAXYsHWoQvD5w	11717	16487	16487	1618906860000
23509	3NLsJMd48it5iUQKryTF9iPrG6AC87U7bFymRu6V7e6rjetuAVYz	23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	1474	1329	440	12463	15506	jxb4roLNQN4hghyeAcEZxwEGHqERSaDYZgjMt6SnKjXR9NLUbeE	11718	16488	16488	1618907040000
23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1444	1015	438	12463	15416	jy2AGCALwv8Vhxr6zQ1qnFN3ud97drkx4uxF6izPjQ4rYtN6uHj	11679	16439	16439	1618898220000
23413	3NKvfoykb6FUfoBcrPjVJF1kfZ1i6WonbDvLxq89S5KpN4sS4uvQ	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1587	1111	438	12463	15420	jxdLCHmYuRmfrFTjfrzzWv1fDo4M9BFn96K7fXHBJ4AMVWe8JM4	11682	16443	16443	1618898940000
23417	3NLfFFt41WdQi2uuaYT3Q2iFkmBMtSL6tNWKXBLm11NZAmoPqGVF	23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	1529	1070	439	12463	15423	jxeKfmEkSd4yEm52Q2eMsB9DvmN3FYu3N5B5juHhgHXaB9didKM	11683	16444	16444	1618899120000
23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	23426	3NKPTrmyHknVvXejNZhrYLjotq9LbLD6ctpUkuJ1uHbZUm6k7NrN	1624	1334	439	12463	15430	jwuNRa6HdiQDFJ6ktLrEngop9kPc8NKyHabo3kG2qihnv1pD5wc	11688	16451	16451	1618900380000
23430	3NKPgf185ofEftn1RNTbpyQBHSAgSiUdyGndF2B9tE9YMSorri8F	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1506	1127	439	12463	15433	jwXtsiskLckmZKjHW8NGt2VkEUM3whrcr4L529XqAkiApbmriD5	11689	16452	16452	1618900560000
23438	3NKaRYpdCRBYmEVZVK6Zyb1s2xPGbHuFSrunckPbiXgBwaXbtaF3	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1602	1123	428	12463	15440	jwfjKWom9K47FQL8XMQTrb91CMzoDSJprdSB9MyHGwc8qj6Sq4E	11449	16454	16454	1618900920000
23442	3NL9GEWABKgB3iaetwCD1C7uB7NucUx5tzjKEnb2RUTytRLP8Z9u	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1529	1316	439	12463	15441	jwqXcJHPuFcaGezYdcm1haZsuydTpuQWKYxivjhNoGa1eLBFHrV	11691	16454	16454	1618900920000
23450	3NK8c4GbLH5y5vMBWmiYMp5ohu822NGThkLKJtJ4LUxzBq8ioMgY	23421	3NLB2SZVtBsLwAHsSqWY3tb7NKhFYEfSP4yHqTNV57sJRxL1WY89	1483	578	438	12463	15451	jwvuh124HBfLbZ5iyXNGwBjxKBt5xRWAA2zqSjtMpUkFhTmGwkV	11674	16456	16456	1618901280000
23453	3NLjEVYUAUwdu3ZBySTuCsDRTQvq7SBECqjzmiDqYxGLUPBGaADQ	23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	149	1037	439	12463	15454	jxqqeFSCDo2cp9D2crN6jjKVkK6izqLhjcHtoj4Zk1ARogjpdRE	11695	16458	16458	1618901640000
23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	23453	3NLjEVYUAUwdu3ZBySTuCsDRTQvq7SBECqjzmiDqYxGLUPBGaADQ	1536	1313	439	12463	15456	jwZfDf9h4zPDBa9bWHeioGmVB1PcyGSKHjpGw169txJ9YAsYSUy	11696	16459	16459	1618901820000
23458	3NK5PosmbMUTbE9pYmCgCpW32B8p9hwKK2CBRHNnJkRnoKT4sAwY	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1440	1011	439	12463	15459	jxN11Xt9QByJ8KeHL9qFBrdwhncCivAPYNee4cet1vGuTVgw3Ln	11697	16460	16460	1618902000000
23461	3NLJN9n3rYtmruvyU6D5cHAYhdpREX7BxQoSPcZvgQ6Ms5G5wa1k	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1444	1015	439	12463	15461	jwehYpHZ35G5pDjSbGwQrocd7cKZd41KyLQsWLHaFZABvkwTdd7	11697	16460	16460	1618902000000
23462	3NKGvz8AAAbquty8zEyci75Q3rDQPkqCFiBFEMGYKK6mNLkAGBnd	23410	3NKEULYugW9NFZzmGHmJDycAnZ3hh6iQhKMURphLfR2gPdeukVNg	1444	1015	435	12463	15462	jwAsbWeMMoauksnjWAXZcxP6wyWBtAs4qmwggKgMNPQAg75geiR	11539	16460	16460	1618902000000
23463	3NL9rgXVY6hk6EcrtZgPAFFzNGH4jsnv9Ge2sMW45q1JbqXFjFFW	23456	3NKn6UnLQxwKBPfKApxSJP6r1ZqK9tRrB6PiRaebFk4Qf8bLwjFh	1631	794	439	12463	15463	jwZTbuGDCBfdKqbty7zmnYormvx5wS6mktry4MmuJv2ML9vZruD	11698	16463	16463	1618902540000
23466	3NLfD1qPPvSgzC8NGW4dzPPBTHusrgQefu4EEyJofcmEGpLYZzWC	23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	1608	1289	439	12463	15466	jwEccdzsz51zS1MSGcQQYu6T7sjyc8iBrpgs92VuvT6cQPRGBfn	11700	16466	16466	1618903080000
23471	3NLo4WMtfY8bxXUJpA2sGZ8qps6Xb1QFS5jyQvMM9tL8ViHN37X1	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1553	776	439	12463	15471	jwigmAs9VjqupNdxTuZS3qfgn6FTk94zGHN7rwtJezwsfuUYvga	11703	16469	16469	1618903620000
23476	3NKNtfoWHLUt7242ywMXsYHvqjqqrSb55HCnJp32reGM5fPuUWMV	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jxenX82UTNNAZ11FzxXGr8C9kkWq3acqdAQciA86wrF1PpLXXqk	11705	16471	16471	1618903980000
23482	3NK8JNwjngzso7rSBMv1sk7dHDbmTJRdJfWiwrJrYrd8QQZ7sCme	23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	684	1352	440	12463	15480	jweuLHcREuUHuWk8StUcdKeRYrTYv4aUaUmG7PFnb9zMxJPqZup	11709	16476	16476	1618904880000
23486	3NKNYUydqA7ntKZeAAenThkeRt7Mu7To6ec4ptGi7NRVQYrGDeKm	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1460	426	438	12463	15484	jxyu73C9ghNVyQ8DKvQmetXJXtTMQPGzu8q5VxvJQ3WUts2SrY9	11677	16479	16479	1618905420000
23490	3NLGg49gRAK4GYvfpDSP5Kyht1nBuTmaY12KSeSdhdqXfLBJx1ai	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1403	824	440	12463	15488	jwMYGwnyxPiZng69YspLcjpHvhv1tiYyzAsbNtDBVdfAJTssc1K	11712	16480	16480	1618905600000
23495	3NKB2g1jEK1bEvjWa6credF8gGZYrW8AC4swM3RtLFbWkao7JQeP	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1672	1285	440	12463	15493	jxBUEmxhoAK1UdujCKyt1QXyoWrc5QEXmxSKmsNR9oTaLLh3K7Q	11714	16483	16483	1618906140000
23498	3NLb2G1NN1jyJWtajJPRe7Ara7kxehQTCqUcMR6AqLaUc22nTrXM	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1458	1197	440	12463	15496	jxD738xJshknJ9Wz9iQZqDS84DcxvwUxB8AwUazwN4me4BNHd6K	11714	16483	16483	1618906140000
23500	3NKoedTeGXzDFeobhEKxvKd9rAditqRAKn24MTJxjZimLLedpL2L	23460	3NKjhQx4YWCWS7V66x884FxCU1dxveUyqpQtMH5E6VTqCacjd8Qz	1458	1197	432	12463	15498	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11523	16483	16483	1618906140000
23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	1634	1205	440	12463	15501	jwA68rc9b2nQxAk6Q7EZmZhomXn4Mv9GtGBQYVptY6nTkrErnGj	11716	16486	16486	1618906680000
23507	3NLjt8MUhf5gKnpHM5Fo9PrYTAyShx5Q45oqR6DUEomSmhUr8FAi	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1560	925	440	12463	15505	jwrUxCk4Wu3veJXE5exjqiSvupSnGm7p1woqcEAt1HQ99omFpii	11717	16487	16487	1618906860000
23510	3NKhmkJxvMinT7pKtQyojxDaDWNouAnPbUenv5BQyJgT7cSZsgbR	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1407	1395	440	12463	15507	jwWuoNMVDfY5eDJymdUQ3GKwbMBf6frHrs9bHwzRQ2GjuEF5uGr	11719	16489	16489	1618907220000
23515	3NLr9E7SHCPnxdqjAXtn6hmPMHNdQ91Y879N7f9G7NkJjJbd21Hs	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1448	945	440	12463	15511	jwTkvxeFByuvxkU7ApGmACFu6Sz59dTvggr5z3GbpDiMt3hfC7Z	11721	16491	16491	1618907580000
23519	3NLjFCLhbRVm6QjPtXguZNgPwGtuxg6osehNS5yhuhharZBrB7MZ	23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	1445	924	440	12463	15513	jxUU9nKe9CmvAes8wDnctUa87tCCTXCmKGVvdPE7yo4WdsaedCF	11723	16493	16493	1618907940000
23522	3NL15ng7XkNqJGYKX43tJ9zmAEN3wEayonDwbi8ZcLTLMxrGwLBw	23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	1407	1395	440	12463	15516	jwik5MJRsSskKxTFQcKt38Pic566TpoVGtqigWM3q6CG1F6tpEg	11724	16496	16496	1618908480000
23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	1403	824	440	12463	15520	jwVvtvnhrsfWWSi23bGpoVWeQAZeHDHyVnVW6DrJVuQS3tgSNrc	11727	16499	16499	1618909020000
23529	3NKycxTTqTuNEtXrXczPjXVoMe2iWMCok93nM3ju9A9XuUWWQoBV	23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	1577	1081	441	12463	15522	jw8Qf21LyTCCk3S9LJbAPeohAvumaqjXuz4zHdb5bfyXhu7Csr7	11728	16501	16501	1618909380000
23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	1402	882	441	12463	15524	jxCdL8EZPiYtV3Xg4GkTK3usKzAr7aBMiyVQaxF9qNEtGs3WCq5	11730	16503	16503	1618909740000
23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1529	1316	439	12463	15441	jxkPRQgjzpdQmRzz3nMTHHTGhgb1BSu9pbD8U6UEQQtdR6eDsom	11691	16454	16454	1618900920000
23443	3NK5GhMyFnNKh5MQtGk6gecdqxURE2wREboPugprgyC46GK7z8fh	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1602	1123	429	12463	15444	jwtNYVjwe9uE42H9Pe8BwNMB8yZbfy8QiM7dR8zg5fkdXnDMRC1	11464	16454	16454	1618900962235
23446	3NLZp3aZ4A6sWqFvpN2Y4WNggEXwScRsahyzzHdDSLujqVHBYNxr	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1602	1123	430	12463	15447	jwMN6G2uLKozxw4zSLBrttM5bPSWaR7ecRZYpT6BD9xBRLnrymg	11493	16454	16454	1618901047827
23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	23449	3NK85FGcLKcB3qjsapz6fxhEGJzn2TA1qcFvrPih4WioRJgAbrSt	1507	1280	439	12463	15452	jxo7bUjxvWPhCJd5k1dg97Hpi2oL9ogbgf1kJn8VUi5JCU4w6Yw	11694	16457	16457	1618901460000
23454	3NKSsaewnKNxxQvhsNifb6njyd3hge8Dd4dwtzS4pfMGwyMcG17U	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1460	1198	438	12463	15455	jxNSFuUXcWN9m61ePdhYDeh2bMFomXkeu6vnALcpCBksEXVVxWU	11663	16458	16458	1618901640000
23459	3NLQJagNo1ouVjCoAVJ6pHpqsTpNTNeN9XRxBpMVGCd8toXwZmwz	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1440	1011	439	12463	15459	jxUF5Z7nNfWA5MiigybqM9WCdrAzWvxTaTGWtBa9PWJYLZt7hHK	11697	16460	16460	1618902000000
23460	3NKjhQx4YWCWS7V66x884FxCU1dxveUyqpQtMH5E6VTqCacjd8Qz	23332	3NKhm6JGzYzvLkh1TCCFCuv9W3ypaWJHp7xtqVMcq63Sb8k5dv3R	1458	957	432	12463	15460	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11522	16460	16460	1618902000000
23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	23463	3NL9rgXVY6hk6EcrtZgPAFFzNGH4jsnv9Ge2sMW45q1JbqXFjFFW	1407	1395	439	12463	15464	jx2tWK9dAjdyfPRioBiHMRLH1CEmsEqbukXP8Vp5Ls6J2Syq5wg	11699	16465	16465	1618902900000
23472	3NL7Mvd3LqTfu2kn131MnZZnJpernq6PepuZbDnifgXynK8Qw2d4	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1647	1302	439	12463	15472	jwgB4xCuXkMxfhcQkKFqBQrvsBHxayQzpf76w8rVGgi9tpStNHX	11703	16469	16469	1618903620000
23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	23470	3NKq6AuovBWm1CauHxiAGkznqHZxxAVV8tybN4Mds8pHGXiMMmns	1536	1313	439	12463	15473	jxsvMSaVN3wz2ynkrtDmCq5GatM2JrdG5mMaawXv1QuifCzzdVU	11704	16470	16470	1618903800000
23477	3NL5NTYuhwVVHmuWZbBFmPcF6qsugRcfA4i9N8Lz6xeqP2n9BHYZ	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1670	1282	439	12463	15475	jwF3CjDfzWXPzW8mDBiAA3QkYCdLBJPpXxUKEH83t2pUwgj2ubC	11705	16471	16471	1618903980000
23478	3NL4JXFqvfZGZBk2ttPw47pAFqHtiTjVuSTztqqjCHH4wcjwmPVn	23474	3NKcPpUvyMivSsAytuK7bXkeDxxPwrsMttpL4QSduS7dVyEJEuL2	1672	1285	439	12463	15476	jwyviW33UJzbNSJ8BdyT2auUr76o9ssT9ZHynSkXZyz9Emhgdqf	11706	16473	16473	1618904340000
23480	3NLvy3bW6pPJWUrm7MQ5JGxUY7uCDRT63v3uVW23ccr25ApvTkyS	23478	3NL4JXFqvfZGZBk2ttPw47pAFqHtiTjVuSTztqqjCHH4wcjwmPVn	369	1066	440	12463	15478	jwVsFUMgMCVWaf2jh7pQYKVHRrZjC33LirJTnohstbzUyomLW9v	11707	16474	16474	1618904520000
23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	1580	423	440	12463	15481	jxJ7H7DaW4ffZTch8137uBBRUeA6XCvqR1WRbRrEXftH9oTMv7k	11709	16476	16476	1618904880000
23488	3NL31wg8gWDaDpZwzbU1mTUzAZBKtdReJAuUcchwACb3qw7aym1Q	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1460	426	438	12463	15486	jwS5Mg85VqHpzT8Gyp6h4PyxwU4Mdj2SvN3avvEgpnnjQRRp994	11679	16479	16479	1618905462340
23499	3NL5ujHbLymajhxbhfR7xVg8mw5HgHU8sn9LAUJUrDGV2PQWrfQp	23387	3NLmMbam85dtqmWgQVeEazxAhSFL9vcPi9wToVpiWVTHRDykXkCx	171	1374	434	12463	15497	jwYoN9xLh1tGy6yny4Tf8gXqCT8CS3FybnLpmAducymLgBFTJ3v	11571	16483	16483	1618906140000
23506	3NKzstpqBdza89HaGRvTPjxXeGbENXghWzib9QmcEZkZnRS6waAp	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1623	830	440	12463	15504	jwGL5j5nuPQSKphpK9apbZp86FBrGdryWpPoRHPapx1ggZ6mS8B	11717	16487	16487	1618906860000
23512	3NKVYkWaatWkTMYivP2GWFTDbV7JA7fpoGrPGS5zcgexLCTHyZDV	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1651	1301	440	12463	15508	jwru48f1LFda6VwVM9KUvivP3pYzf7tihySARFgncfdhyDBDR1L	11719	16489	16489	1618907220000
23514	3NLHMAUz6B8UJxUtNSWjYLUJiaqbBVwLh9ziUShQ5s1zKsMZPsLt	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1501	1234	440	12463	15510	jxVLuXvB3VC1Aj3uQCGpty2CKxboeCofppE5WgQrtF2uiTkU2w3	11721	16491	16491	1618907580000
23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1448	945	440	12463	15511	jxXVR4wkKZhRSd4ohezUtMFcewpwZjYsMm3PGYwbryVoYH57yqF	11721	16491	16491	1618907580000
23521	3NKR6J2hv3kWVfd6xFpdx7ixSPzhNoZzR7tuBUH6PaAys4izkw2u	23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	1607	1348	440	12463	15515	jwMfaNSZju7ZkT3L6UnKn2NkbKHuwE9VVVdajXfTgTAwTywcQwc	11724	16496	16496	1618908480000
23523	3NKqLXWhqH1zEusimLYHZ2BMBT3DPT3LdV1ySzk3gTfjjCvAEb7H	23349	3NKu5SDCM76bEV9WvRSxPvsSHkRwUzBGxKhc8Rv51K5jdqCCrb9p	1607	1348	437	12463	15517	jx3tiD49XTdcunovXbkyeZP5ADTksDWiUcdqVXbdkjiKKbtkymV	11653	16496	16496	1618908480000
23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	23524	3NLYmqY3ryGQzSVnu1VJX7aDJ6HQ2EBqN1tiW6Ri5RdMyVkJ3GSZ	684	1106	440	12463	15519	jx7DoXfEJNhFrxiJETaVFMmVMNht6Z96eC6ydEvvm78uz3NAXuC	11726	16498	16498	1618908840000
23528	3NKEWyVpkN9SEgSWaZvCKAy4YiHosc6Ji5NvR16Ff9fzLYvAHwnk	23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	1577	1081	441	12463	15522	jxc4fTeibP9ofU9BhHv4jkRxBMHGk2tFiQR3dBSYsjAQhT9fqc8	11728	16501	16501	1618909380000
23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	23528	3NKEWyVpkN9SEgSWaZvCKAy4YiHosc6Ji5NvR16Ff9fzLYvAHwnk	1675	1216	441	12463	15523	jwCHhVv5aX3menCLjtWzJNk8EKtjKDMZriYLjxRTZtLVKmz7Afz	11729	16502	16502	1618909560000
23535	3NKnkT6Rqa5KynzGGxPgZ2oQH9T7JBrHT3VjbzFz76r1zLtsQk7i	23479	3NKYGYGeyxnW3X9zBfEiPRVbvT529FQbuLhBW6iGbF4N6WEVfWN7	1581	778	433	12463	15528	jwY2JqTTC8wwC7RspFdLDgCWijzwmzJ2sWrXxGcxzTYQuJssZ39	11553	16505	16505	1618910100000
23541	3NL9ihE9okVKpxuzoA6soSLh6XUVJU9d7Y4djjfASgFfZ8p1ZZ7E	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	1406	1393	441	12463	15534	jwMAgBUqGZw44AdSRKhToCBnSD4jowxMetCTpX6K7ZMjzMZ6uZN	11734	16510	16510	1618911000000
23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	23544	3NLSxhiqc9RFDuguAysDb6A4ZiWUmT9XUoDhzJXww7qbrDoqdaXE	1560	1045	441	12463	15538	jxQcETaE53kUcoUPptyPTrP1PfKZHesTWQ74AHbo3mVUniKJcq8	11737	16513	16513	1618911540000
23548	3NKYrapcBkao1SgzcQwKpPbJUZbC1SVb4bg1f4Z1TK8ZL3ynXfBN	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1670	1282	441	12463	15541	jwFcmmvJQT7DSumYrcv9maLUg5WM1SBcbbehvtAd7DjHXFCBxmm	11738	16514	16514	1618911720000
23550	3NKEU6i6eZhLya9iDZyMjRbv7ctLPyNho6ZDyEB471FXPJ3S8JqQ	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1506	1247	441	12463	15543	jxsbY4TBgubCXX7gt2jnSzPgjJyfWrq947tQCdfzkPXMQ7nSWu1	11738	16516	16516	1618912080000
23555	3NKVusg37yvdvZzstKyjYYBq8NaL2uVeUMbvZY5wyv8LMoELLfAv	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1624	1208	441	12463	15548	jwFpzwjCdWMMmphZohHYvJ9vT1NfypafPRSTsUosmVewM1LXczF	11740	16518	16518	1618912440000
23557	3NKkX3b23eWfa2ezciDv3SiZ5BJB6Nfnm6FydMSVottyoqdZz78Y	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1668	1370	441	12463	15550	jwJ6TF9apCFzu5P7FNxShQnsfVudBdwPVpWiVw83rZW1ZrP8YvT	11741	16520	16520	1618912800000
23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	23511	3NLLXMq8X4QkHD9jUWMZBkZLb8DFKxHDK8mUP7ne9t73FbETsAX3	1578	1296	440	12463	15509	jwUeHrhYfPQXSPCkccxpWThL8UTC1a9wuW9dWdP2xXKzjbvNQM2	11720	16490	16490	1618907400000
23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	1447	1345	440	12463	15512	jx44trBLZGTXfGRYwE7NHoMrRrTgdEtKU1TCdSDF3KtMvZWymmm	11722	16492	16492	1618907760000
23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	1403	782	441	12463	15531	jy2AHkqgUJyM6Z45Ny5QGZL6YBtvV6JGgYnXcG5j8h5XDDCrhx8	11733	16509	16509	1618910820000
23540	3NKWZWAQcPkkrEXQz6kzJB2zBby2FhDgzb8vjJaYqbzYM1DAya9f	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	80	907	441	12463	15533	jxZtNg5uXUUGAnsuVsZWxvH9C9PjKgFjGBnQA2qUBWyM9Tx93SK	11734	16510	16510	1618911000000
23542	3NKpKY7tyc2Yaz4NcNZhEy8ZcBxJYpkdES7WKUq2MH15bjZH1quz	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	632	1016	441	12463	15535	jxAFasWCxTyturDdoioLPYZDvAJGnoq9TVhcJbpHbzrkAzREG28	11734	16510	16510	1618911000000
23546	3NKwjcP6Xda3hhPStVG7Q7PJo2jgR3H7g3iBhZ7idfKMreEszXS1	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1439	1279	441	12463	15539	jxX41qpGfJidbLLExxghsNPra5WM8C27ZqKuC1pHfXRXpFQqMtk	11738	16514	16514	1618911720000
23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1406	1393	441	12463	15545	jxcLEds716xTfcoM2HAKmuF1rpd5SNMJQaJ6A8wNvdmuv7hJUyi	11739	16516	16516	1618912080000
23553	3NKFFZRky52A9AsceCFSzsxmZ6UygfeUar6YHMdqC2a45uNjUGwk	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1587	1111	441	12463	15546	jwXWyj6WQEbGYuVFs5M7AaZyXWDLjjLFQZzkHi72j2fzwNVYeVC	11740	16518	16518	1618912440000
23559	3NKwoCoTjzbhoyWtWNqi3xFQwoW3o1Ms9Fy2nzb5pJT8m15khNjW	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	448	1059	441	12463	15552	jwZDxa1KHRbM6D6iNoNCdFtm8QTNca7tkj1TNkvjnJn6Tkvxp1M	11741	16520	16520	1618912800000
23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	23558	3NK46YQchyGuFJmiZL4XfM34a4Bc4y8C4RoBwdsbxfkosr3WKgfZ	1637	816	441	12463	15553	jxo4UHW5Qf9N3o6eYass8SQaA74aZP26zLw8dhTsq5EhV6VqLVU	11742	16522	16522	1618913160000
23567	3NKRktaSiWeNzYbt4qa9NUFDpM1pTq4g6e9g7cJLwnuyjSGFHM4z	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	369	946	442	12463	15559	jwggyFJdZA1zzJVGJvJG5qEK5cFrVaX2tiJw1NAhWNymaEh1itg	11745	16526	16526	1618913880000
23572	3NKCoWHhUb46diBnVhMyRLQLDDj39ao9LVivo2R39NvUEXWJFMvi	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1474	1083	442	12463	15564	jxJF7nhDAMNJbCK4nJswYxmn5cwzcJwvYngiHZwtbSe65kjhTPd	11747	16528	16528	1618914240000
23574	3NLRahazwDRFcKLods169WHB7h9ESayXohhrJpLq8U4uYtCs6NrF	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	369	1312	442	12463	15565	jxAEcRg1pVkmwbeXmeQPTiPUzNDUE3v4oaLsaW6mbuATaPiQiML	11748	16529	16529	1618914420000
23577	3NLvYm2SLFRhjzpZqCY9nVVcDx7n4qVa6criNw8ARy6jqUdG2YAv	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	1634	1085	442	12463	15568	jxhNrHL7gX4TSYwLMC5ar5eGLxUXMH56WuAXVSXCyv1sY4TyQ4D	11748	16529	16529	1618914420000
23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	23576	3NK4Dfp2csaG2yCdDoi6T7i8EdNQerV72TtHBWqNyDFP6t81JVYU	532	1303	442	12463	15569	jw6k3ojWDGejPpHdgz1u69BotTmortXebyZ6rt1zrrG2J9xxALd	11749	16530	16530	1618914600000
23584	3NLPYjGWbRSfjJqMRwr1ZHKZku7V3Fz8tXqUKSBev9Agj2vXsd7T	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jwtRhFnFGgvsqpAaDpcseq7AaqtH8t6fqUdVDhAfovPJiaFH3RL	11752	16533	16533	1618915140000
23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	1553	776	442	12463	15579	jwY2LPcZutqbg3esdpiBRJ2nVT2VEzNpJ62trFzS18HBo7V86Fd	11755	16536	16536	1618915680000
23593	3NLocqZ4eX4xW7S2AxhcJjsGQScESiJRtrWxsXwK8EVEAmmFPtH1	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1407	1395	442	12463	15582	jx5uuNZosuDUghb3J7J8ozUFYGRnPF3T8hrPjk8Q4AmW6YUQAHm	11756	16538	16538	1618916040000
23597	3NLtJ8MYhKYBpfiNm6BgN9kj4YeGHwiKSpFuBvXXusWDPAizEixM	23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	1407	1395	442	12463	15586	jwVfxo1zAr5Gg8Y7CFLhP47mDH3zcGCzyLw5Y4RfxFGeerZa9v3	11758	16541	16541	1618916580000
23604	3NLE4NR6nv78sNBBuD4ECHRmRAdBC6e3ara2VAtr479eqRCGF332	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1546	1339	442	12463	15593	jxkou6Di5kHSwwHE5wSCfyFXGANYdaCPhuYjhH9ryVB7CTiAGTp	11761	16545	16545	1618917300000
23608	3NKLBFEb9ywWV2NdrnRgTChARmnNih4YQtXE3i4sCzZ8G3MR27af	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1637	816	442	12463	15597	jwiaKv8NsWM3QdYt6pWoLHZ1T3nDGyc6S8YQPfFrLHjgBTZLxBi	11761	16545	16545	1618917300000
23616	3NKYmgXa22akwDQwS7rPJXfHBHRpbUWDKX5PnwKSRYcGGVStKYL5	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1670	1282	443	12463	15604	jx7CrUPaa5EA2hFG8b4PApootqFEi3tvS3jpRUoLTyKLzRcfbVQ	11765	16551	16551	1618918380000
23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	684	1106	443	12463	15607	jxLf9ztrajtKGjTrufBD5DV9eawaoScD1ezJ8CMumkBrpxGfuJr	11767	16553	16553	1618918740000
23623	3NL48GJMMd4zq4bNJqthagc1kSoTvHxDudNDuj2d5fpf53rVcrpz	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1490	908	443	12463	15610	jwdtSiCFhtnXWhu1pzoGqHk8Tjnm1xBYsPs8WngMcQV35K2LKXV	11768	16556	16556	1618919280000
23625	3NK5gj3USLD9dwF2x6fPnFk4j8TNPHjp5CudYZNzmaNUE72UFHAx	23622	3NLJ4p4Kv8MscH8ooxGNx9fqSD3UmQtaje9QfAJa1ET2HgmALXk4	1406	1393	443	12463	15611	jxncWHv84XWZew7M4JKPGTT3kcuMvQh99tLGiXfasqAf7kUzm66	11769	16558	16558	1618919640000
23628	3NKSqjwNXJwaZ5bUGoT2GZPMQgfFptGNT8wkZWP1zUfXei9YzoRQ	23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	684	1352	443	12463	15614	jwve9ZJyecR3ksw6w6thePe4LRWfoUYGZYGbjpS1JuyPCmKXiqM	11771	16561	16561	1618920180000
23638	3NKGJv3a4jHceeU96uPM1miWjr8BiCADruJBR52i6avA7r4U2tV7	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1549	1116	443	12463	15623	jwFT1bGa7AdeEW67L1HZpdhER6zTg1ykERmA5LHc8AqSPDR7sjH	11776	16570	16570	1618921800000
23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	1587	991	443	12463	15628	jxuXWbR4ymT1n9B1cJRP74gMS1d9Essiti6Gie3F6eW3tNx2noH	11778	16573	16573	1618922340000
23645	3NLeemn2RDBD2r4pnpCbiZVF4zkBbdghLH7b2bLM9hAzjpfVWTEi	23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	1536	1313	443	12463	15630	jx9diU29gRUSPcyqzfsbgRfVNrXVSv9RkW2qhVXa6YckfsK7t7u	11779	16574	16574	1618922520000
23650	3NKWSrZzg9havLx5uQLAXjmZ2PpTYrTLg4jd9bSV1LDTi5AZ3k5Z	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxVakY4JkPdZYGJVuDWwNYunXnyRcWZ6EhwTGbTVDAAUDDKPKf6	11782	16577	16577	1618923060000
23655	3NKDmEbVcVtPmqbcmWDrsXbKEL8F87wJG6D4qUUReCFN3e7xgTb3	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1506	1127	444	12463	15637	jxkPqvsFaP57vkmPPvrhRsyhtgPzkE4SASJr7zArzWEFGvvevL5	11783	16578	16578	1618923240000
23662	3NLWCMYTJCT6L42v25U8tLWUUWMNBKCCT4PhUctLZTbxWJKLbn5B	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1407	1395	444	12463	15644	jwVZN9f7wBGj1PL5gwi8qf3xb9GmuCDfxBZKQUC8iJ3TZeRyKkK	11785	16582	16582	1618923960000
23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	1406	1393	440	12463	15514	jwmetMVtYQGZYkvD4nWvkTNcALEqwPqkD7d68ZsTzUn1Tzq7Avx	11723	16493	16493	1618907940000
23524	3NLYmqY3ryGQzSVnu1VJX7aDJ6HQ2EBqN1tiW6Ri5RdMyVkJ3GSZ	23521	3NKR6J2hv3kWVfd6xFpdx7ixSPzhNoZzR7tuBUH6PaAys4izkw2u	1406	1393	440	12463	15518	jwjF9LyVWNViWaPM2UNNkVxNCBrg4oJHCbUxPvaEVwixwSwAkH6	11725	16497	16497	1618908660000
23527	3NK7NkG4U7LEinUhTqyfPkGubPrK1LDUR4oFB1cKKbyj9qGQmHbv	23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	1598	514	440	12463	15521	jwmSySRKBUePsbJEqxJbwukFmiDA2iaFJKSDmuShikpqcnu1eZU	11727	16499	16499	1618909020000
23532	3NL8ComdX1bq214TWh839WC4Qmad79wd1iyXyBe3Lr7avaX9Qo6P	23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	1406	1393	441	12463	15525	jxZMRjFrSqZVjBrJBg2sT2mK171N73T4MMVfUUtPT57yf58zjiZ	11730	16503	16503	1618909740000
23534	3NKEVmxNFkgmwsmUuTiYonduympzfvLt7kZ3BoM3ASDjtKgHEHqj	23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	149	1283	441	12463	15527	jwVNK3XmuKdYy7jB3QQkkbyjNt8VoGW5SkeaGh4PdsZdTfQns4F	11731	16504	16504	1618909920000
23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	23533	3NL8DkbQosVVASoLA5AN6UvHQ8J5JHqaJrvyFdRRYybNAqk2AK94	1627	1019	441	12463	15529	jwZCVzvYjk3Tq1tAEisiALxJywkzpa3MNLyXf4Rvg7k2PzviWWp	11732	16506	16506	1618910280000
23537	3NKkPK1YCnpA7yMocuF1wNyWhMCh3prvjZG1PKghBaD3BYWmLn8a	23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	1602	1243	441	12463	15530	jwGzJG7nFX6roTXWSPBkesk2H8tC8fVLhj58u8N7EK8P1pbFnsg	11733	16509	16509	1618910820000
23539	3NLcuoqmzge7YeuwVzrYKFsxySVQEsNVQN7wnTAP55hCn5gy1gwr	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	1619	1275	441	12463	15532	jwskbfHmrMxDwbYJKKPbRg2XcsS8p4pkM8BPotsecGWDg3HSvPk	11734	16510	16510	1618911000000
23544	3NLSxhiqc9RFDuguAysDb6A4ZiWUmT9XUoDhzJXww7qbrDoqdaXE	23543	3NLMYXJNU34r5wUCF5fHCKvD4aSaLThaG5t5xf2KQnuX11F8HRpW	1406	1393	441	12463	15537	jxs7YSPbds4t8t66nPpYECfjnGHqDJDRCsvBFi9NAGwwjhQ1PnZ	11736	16512	16512	1618911360000
23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	43	1310	441	12463	15540	jxEVwsfvB5qjsZP69DUbKcQPxuTeLSPUvgBwURW8aqH1CXVUT8j	11738	16514	16514	1618911720000
23549	3NLWpJSq5MWvVSBNLnMF87mKpu72CJPxLYBs4QspLnhCxa18x8hp	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1542	1058	441	12463	15542	jwbruZLg3vg3APxmRaQ4hThgjM2PPgeCteTtbQxy4mHwrbCLPnX	11739	16516	16516	1618912080000
23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1407	1395	441	12463	15547	jx9XDKJX7BEuHvDJKausW7iCNbF9aP7YSbyRWK5sYNjJvXoKtrm	11740	16518	16518	1618912440000
23556	3NKXUjn5VMNGff7M1pduKXKZV7cQBESKoA8qEZAYAyPHZ4FpbYn4	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1646	1108	441	12463	15549	jwCBB5UHPLPbTZdMfvK6tV98xgfnwgtMgioJ9qct6NFKpGi4grr	11741	16520	16520	1618912800000
23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	23568	3NKECUbCBV7TNo96qgM2GxG5wdCrScc1HUtH1FCsZBRAMyPKBKLX	563	1359	442	12463	15561	jx6QBTBHA7cmvzyZaV8FxV7Xdw7ocDZjPesCHPgkRWer2QHWfzq	11746	16527	16527	1618914060000
23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1579	1389	442	12463	15563	jxJwNV3c6kAHbcR2m59exa3seq3xC9TpKNeGVG1c9UU3AXEFph5	11747	16528	16528	1618914240000
23576	3NK4Dfp2csaG2yCdDoi6T7i8EdNQerV72TtHBWqNyDFP6t81JVYU	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	1623	839	442	12463	15567	jwwg6vzgQJ7Ve9VxfWkbfwPsLAEtmdqgW1USmgUjWVVskwu8auC	11748	16529	16529	1618914420000
23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1534	1317	442	12463	15574	jwnha44BEuWr6gQsTN8Dzic6sS5EDfKsPCEMKjKQgEnFR9Hk6Uv	11752	16533	16533	1618915140000
23587	3NKS9iFz1zFJYTrTwvNYCJxMAqLmK1WRZpg8S5ZEPfm7rdEK4tqS	23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	1403	792	442	12463	15576	jx5gFJduiWw9KUEQrb9G5Q6fqp7scr9ByRSiomZUCwCJszFLHHW	11753	16534	16534	1618915320000
23589	3NKhPhf7ujFjuSGyx696TRgsdhTFECrhmJCeZAtJ4Dd52DmJwztj	23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	1407	1395	442	12463	15578	jwLhsfK5SffCJcCX25gRWQiXgvV1DDNVqX7sUma3havnmTewMjb	11755	16536	16536	1618915680000
23592	3NLod5DZXp4ZbkDKoKfW68LZR3MNC5Y5h2u5CodVaM6KEjcCUiAn	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	596	1306	442	12463	15581	jwqRWN34ZC71tsDn7j1dJrmqB1FhFvuw5jwYEEQf1oHpo64t7nx	11756	16538	16538	1618916040000
23595	3NLgExJaFzN19xnt2MuqwW656bQ8sAHDJP81sh8EqhA8vRQdiec2	23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	596	1306	442	12463	15584	jwzW9ZxdPo1gguoHXx2AYkSTQhdSvPQZvAhGCUemWuhzkskfk3u	11754	16538	16538	1618916040000
23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	23592	3NLod5DZXp4ZbkDKoKfW68LZR3MNC5Y5h2u5CodVaM6KEjcCUiAn	1631	794	442	12463	15585	jwtMyipFoMcPj11SXpGCon2Y8pEEEzFBMWd6ckUaUV2iX6vCYNn	11757	16540	16540	1618916400000
23607	3NKzF5vDdmRLDSAqTpp6kwwjUn85ooefJt841kVfKtRJc1ZboNSA	23535	3NKnkT6Rqa5KynzGGxPgZ2oQH9T7JBrHT3VjbzFz76r1zLtsQk7i	1581	777	433	12463	15596	jx3QxfehBVCtYovfBcd55CK3X7SqQqx99yPnjPWGs5NWgXwYf9Q	11554	16545	16545	1618917300000
23610	3NLriJT3TGcPLaAxGbg2nTTsgbFMYBDMxc9UximjmG6qoHmpBCS3	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1546	1339	442	12463	15593	jw7nRA6xTK7PKascUBCZUpVtHH6vbLSZfqmvzyPYSHzziQS6KQW	11761	16545	16545	1618917300000
23613	3NLrZGAWnki791ojvCan8KiJVnknvZALEM2JsRwtVeUrgmxu5Kjn	23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	1406	1393	442	12463	15601	jwZyaT7X5dqXwHfqDrfXrSAvm46w7RVER2nsEJZkCcp4Z5gmxn6	11763	16549	16549	1618918020000
23615	3NLKhPi2K3UFP3tmUtZQM79nXeDVSQzyKVwBZ7bCwWftW5uQaCgr	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1627	1259	443	12463	15603	jwsd3X4pSQZ7MNw9FX8b6tG8Ur1WKiCAfcv5XYkWe1XxNYthCkg	11765	16551	16551	1618918380000
23622	3NLJ4p4Kv8MscH8ooxGNx9fqSD3UmQtaje9QfAJa1ET2HgmALXk4	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1546	1339	443	12463	15609	jwxzqbpcjEUYXgAYJbXMc6LTyLJyf55Shatyd6res5DgihLMpFL	11768	16556	16556	1618919280000
23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	23625	3NK5gj3USLD9dwF2x6fPnFk4j8TNPHjp5CudYZNzmaNUE72UFHAx	1406	1393	443	12463	15613	jwv54kbY487F5wxQvrJPqeuKJCpcu2GQ4Hb8mTEpJsdys9RPcir	11770	16560	16560	1618920000000
23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	23628	3NKSqjwNXJwaZ5bUGoT2GZPMQgfFptGNT8wkZWP1zUfXei9YzoRQ	1602	1369	443	12463	15616	jxJznGvCvFMFgbXtNwRwGv5FyRvfCh6Y4sVhT1Y3EtEUgJMTXfK	11772	16563	16563	1618920540000
23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1403	785	443	12463	15618	jwkUg9m6WMwt6Z2oUHx1qx4xpE4ZAcnzKBXtYqnxXyFvp7uQtEx	11773	16564	16564	1618920720000
23635	3NKWju6hjouUkQQ3caJMy2qymCcNNv8DFrYFcL7VCQ4BiMg6jAic	23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	1553	776	443	12463	15620	jy1vi9xXZQyMNRQq7neQqRh3L1zFyHau1r4cXJLe6vohrLmZDCC	11774	16565	16565	1618920900000
23637	3NL5N63yCqvVDswFbukz9aaEXfg8Pz27cp8VV9ezERoa3RTCRsM8	23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	1552	513	443	12463	15622	jwpjZjiPgMavyFyBEoE2Bc9DAta92v19cKnH68BqRBFirVubdDL	11775	16567	16567	1618921262872
23533	3NL8DkbQosVVASoLA5AN6UvHQ8J5JHqaJrvyFdRRYybNAqk2AK94	23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	1656	1217	441	12463	15526	jwAcErDtvkfeP289KMpsgggPHYch4FdHHYjMcVvCwRVxG5KnQ2Y	11731	16504	16504	1618909920000
23543	3NLMYXJNU34r5wUCF5fHCKvD4aSaLThaG5t5xf2KQnuX11F8HRpW	23541	3NL9ihE9okVKpxuzoA6soSLh6XUVJU9d7Y4djjfASgFfZ8p1ZZ7E	1407	1395	441	12463	15536	jy14ETMoT89t8TQiKgfvKahaQaEr9o1xWMZRJJtazQeTrHycwpj	11735	16511	16511	1618911180000
23551	3NL9PXS4HSzQcN59ZUs8voiVTofdXxJ7A1HwhCekNLwXMfKAZo3E	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1506	1247	441	12463	15544	jxFeokxN5uSifw1BwHcfzwADhtwRKuPpWEMmXRsDuKeY1eL7qJu	11739	16516	16516	1618912080000
23558	3NK46YQchyGuFJmiZL4XfM34a4Bc4y8C4RoBwdsbxfkosr3WKgfZ	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1406	1393	441	12463	15551	jxGVKgCXah3qj6SLpVqsPqY2eBaN9F7VKztyBQyEFLGX9obXpPu	11741	16520	16520	1618912800000
23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	1579	1023	441	12463	15554	jwHQ777brZ2QQQomRj4NFNVRBS5LktTkrxhKCwty9M71uMdua5Q	11743	16523	16523	1618913340000
23563	3NLMP9Rvrbi4nXZjuatA292eQMsFKTi7nRLbDmvc4NqgV1Cgev9g	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1402	868	441	12463	15556	jxQNEEVLnUmffQQREtKfGsDHt623XZxMgALw3e6DAChkrzbGeuY	11744	16524	16524	1618913520000
23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1647	846	441	12463	15558	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF	11744	16524	16524	1618913520000
23568	3NKECUbCBV7TNo96qgM2GxG5wdCrScc1HUtH1FCsZBRAMyPKBKLX	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	1476	1371	442	12463	15560	jxA8YvtM3LbCCombQ1QC7UeNQWMKyxCS8CWAotJ1LTcq1w8HAcj	11745	16526	16526	1618913880000
23570	3NLt9YgHoRvWzsz6dddTD2M7nZEkhAb3WUyQgMSztKvKgiMsxHWs	23567	3NKRktaSiWeNzYbt4qa9NUFDpM1pTq4g6e9g7cJLwnuyjSGFHM4z	563	1359	442	12463	15562	jxYayFXuaGf7fDTkF1FRnQSTqfdZJQEsUEYL39ghM1d8SQDzt86	11746	16527	16527	1618914060000
23573	3NLKmsPc4kDL5Ac6gAMntugmB5EZZXnBxwzxeivvHB1NEHUGiBgK	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1474	1083	442	12463	15564	jwM68NAbPci95HZx6yDCcmJJS3sQmogc6sGtsDW2mSukR7an5Pk	11747	16528	16528	1618914240000
23575	3NKyHyeuuEcYjfQYQZoQb4BGoTMAo8xYedbRhxZkRyZWULrAWmtA	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	80	1027	442	12463	15566	jxK6yBFsw44VAndmfceaGaLY9MkmUdHfgQ5rn15ppSfWh4iCKj1	11748	16529	16529	1618914420000
23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	1500	1051	442	12463	15570	jxHTrqPqsNhcmbkSzoNMFPFrqhaWiwf8ZxnjbETbViWXk5hxLB4	11750	16531	16531	1618914780000
23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	1541	1298	442	12463	15572	jxzyQqaPG2XLK2eVHN8rXyg3uRb5yMwuC2aW8GYkAcah8rGmU3A	11751	16532	16532	1618914960000
23585	3NL6xBUV1v1irdRYeJRhjyj17sJduYdTe3LqSw8YJfBxex3i4PJL	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jxgQBnDniawU5o4uA1DzcmxLahTWBkDtcVCwAoWsLikYTiRsCrt	11752	16533	16533	1618915140000
23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	1610	948	442	12463	15577	jwSZ5q4558cAvohvyhckvYqLK9WhgXL2qM7UxfZn3zGocqFtwEw	11754	16535	16535	1618915500000
23594	3NLL93KvhEfFUNP4UPo3vyguhAGxbCaAHBSRkdF3XZzyEouswgMU	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1406	1393	442	12463	15583	jwPs88T4qaWh9uF1HjM3KnNVnbbzMAxsh2BuoB6uL4EKUEVjh7i	11756	16538	16538	1618916040000
23598	3NLJCbMBdJMH1ooiM65jC4koatrHMTNJFmo8o3Rps8NeWHrT9gTW	23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	1559	1353	442	12463	15587	jxxVKyDs1wnoFVMEgMrpXERtBVBmEmZb3gHXywVCwfzE8EjkWv3	11751	16541	16541	1618916580000
23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	1587	1231	442	12463	15589	jxRLpGAVB2L4BFGquRak9CusdSgbM4ooGrgyeEVzswHGNpn7wbn	11759	16543	16543	1618916940000
23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	1553	776	442	12463	15591	jwCMxVVkp5Wk1TMdtsQB4vVHLDfFzSpfA6wWRso4sznGk2oGcG5	11760	16544	16544	1618917120000
23605	3NKhtdxFu15GgsnBVpXRtUC1jtfMT1pTcbkFBvJg8LpMTL9MGrAs	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1489	1014	442	12463	15594	jxvvK5nnxqW3SkDTXbyGEvsu6ZCMEW8S5FeBP9ZKYeJC4akVnZb	11761	16545	16545	1618917300000
23617	3NKj34dEjFUiUYFkZy9oQ4U4qHYDLdG7drN6oZVmFVH7E85FQBCH	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1670	1282	443	12463	15604	jx7CrUPaa5EA2hFG8b4PApootqFEi3tvS3jpRUoLTyKLzRcfbVQ	11765	16551	16551	1618918380000
23618	3NKMyVZWLi2MxvJGuHVqzCrW7WCmmZCEHeg3pV8Fjve9yJ6G5yH5	23615	3NLKhPi2K3UFP3tmUtZQM79nXeDVSQzyKVwBZ7bCwWftW5uQaCgr	1474	1083	443	12463	15605	jwdqkicd91XHbai5ojMb6xWzgR9SiwKwZVnpy7hNfHNo1dePxaG	11766	16552	16552	1618918560000
23621	3NLAipJdgFQrkcUJ2aVBBeqEiXYV2UARwMVRdGUvXXyCCh8cgDG3	23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	1637	816	443	12463	15608	jwQHzRbx6CbcibD9sC9HLk4k41asyFrm8vaRx9XFY9PVrkbpyyf	11767	16553	16553	1618918740000
23624	3NLCfMdvkDmuccQkrQypEJkCiyQuRPTSmHczo5PCe9k1uW65LR6K	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1546	1339	443	12463	15609	jxu88S3bg7KoSVensJYaUWfqc45ug5VWp8iF9558sHjzQ89DyXH	11768	16556	16556	1618919280000
23626	3NKiCqdJAh2AKWdzrkkZutSXUj8tk6ncJLUu1EzXH3avt3KADd8q	23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	1673	1242	439	12463	15612	jx9iZej7N3orJf5VkqKv5NSCxqsXsGLvA1igQpjj1hCACuabf3R	11702	16558	16558	1618919640000
23629	3NLKCebE3fv2amgxjN59BDBrZMWqcciPNddT5WX4Am8uCNawpgW2	23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	1406	1393	443	12463	15615	jxtmMx8Y1H5gmBhXMbp8wRgJqUruduKQB4RZAdHAt6kJBQHCbSx	11771	16561	16561	1618920180000
23631	3NLkdeSrBk38KjTt7cjtuNaQcmuxzFRFYn9hMDsSdyvfuFKgAg5A	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1480	659	443	12463	15617	jxmhTJ17eUZLJGJPVf9H9g2HfTpwuMqPSZKX2pQMqZrVjT6xHfJ	11773	16564	16564	1618920720000
23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	1656	580	443	12463	15621	jxtBAhrvNXL7AJH2eB5MaWrpEBF9wKuLtVMg8jCetf2d5174J9n	11775	16567	16567	1618921260000
23639	3NKQNxLd4NHCru7M3o5wuitYBw49beSCCWvMv6sfmQL6MLHtWtWc	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1406	1393	443	12463	15624	jwRQCj52FVxZzzsyAUthuo4qEZUMtvBYYqts6Ksv6Vka9HeyPt4	11776	16570	16570	1618921800000
23641	3NLY12S2jEULUeNGk4H5yxo4A67PFoCn1fNCzUY1gyUvMfgr36ef	23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	1600	1126	443	12463	15626	jxAn5ihp33K22aj2XRmWkVKQXKwtm73p9UKM8myknAm3ZH9wPFZ	11777	16571	16571	1618921980000
23644	3NKvXG9eTn2G75dxE3uoYw3itGrSeo5zDCXSEofZN2g1dDRdZqyt	23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	1406	1393	443	12463	15629	jxDr5rUP872ZajcAoXa2nh9wrdLWbYjd2vxEgJgaf4fbgb6tTe2	11778	16573	16573	1618922340000
23646	3NLiAskyFSYEJiX5REsH8kbeRwfvMkyiy1iiAxSpoMK5SLDtRXVF	23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	1406	1393	443	12463	15631	jwz3xXuvF6P7UJuB9249rMHjvehp11hDsc1NddFPiYWRW29ix7s	11779	16574	16574	1618922520000
23562	3NLmUsKYG7cUyds8g4iYecpC8VgEXsBoXsmTYbSdqGW5GRrSTEWy	23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	1436	87	441	12463	15555	jxJbBapokHMK5jPBh46BJxQfMSYNNN45gKsfHfH2ZtYmvAB7N13	11743	16523	16523	1618913340000
23564	3NLANyTFedSLu9TEtdU4G4FpfvohXfr5T8SMYZyiaDAg3Dw8LawZ	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1403	824	441	12463	15557	jxuuHGQkQDHyGpa9bfna1aMPbHNEk3mV1ddEbHjJcZkSuyASCJK	11744	16524	16524	1618913520000
23566	3NKme5yhxyTK2UGaehAKHBjkXX5zf3deTNivtxySvqXzQa5VpxEa	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	369	946	441	12463	15559	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF	11745	16526	16526	1618913880000
23580	3NKB76YfMaW2NQK9GupGrq1W6EWqn2ZzedvhwFypE5ptJ1Lh5cc8	23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	1579	1389	442	12463	15571	jxNzbcvye7oEW8sEB7fdNHc5bWZHhLLo6fUxjCjv6iJ23n6u1K4	11750	16531	16531	1618914780000
23582	3NLkXGjSUKv32FNVyo7mhgeMcrtxiBowrS978YfvEbnNh33HfQi2	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jx7StTiYFobq2qyRBYcmwtYZgHC5km6hryGK2N42qW4MQrcwfPz	11752	16533	16533	1618915140000
23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	1609	1333	442	12463	15575	jxmLLjQcNRQx9a6gEQMziTDwz3fcY38SF8BHP4TBqmn7MNNbCuV	11753	16534	16534	1618915320000
23591	3NL9N7dNJHxKSh3JuEXUN25M1jucZMmppnuXEqE6LHUDqq7G8Ldh	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1445	1290	442	12463	15580	jw8FYgxqLJo37MyfgvmKNSnjbUbZSoJfw753rijrouY6g4ayJzX	11756	16538	16538	1618916040000
23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	1559	1353	442	12463	15588	jwiqbmPudLVSRerPQ8u74UPb6tKf3p1UyeJ9g9LxFFBSU6ppENQ	11758	16541	16541	1618916580000
23601	3NKZfsGZFbhFZCKfpVwTmPjHRbZ3B2KvQtRMZqD4NRawctGkzme3	23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	149	1037	442	12463	15590	jxPYMbqEdwToGWUubb7egQjcyVMjDpzzYKE3f3CeTbDudcG235H	11759	16543	16543	1618916940000
23603	3NLca9zofva22M2chRihsYWo1muYo3ETaphYtMQtjhoZQdpgLeZW	23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	1406	1393	442	12463	15592	jx1bGyRiRUR5xqhRLareKnPBhoyLpEqk12KpsLz29GrRPicLAXA	11760	16544	16544	1618917120000
23606	3NLKydaRv1V4fcuLEKArd358i3tXDHSooiAxYXLk6WWgb5hUgr1T	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1627	1139	442	12463	15595	jwDnbX2J2DFRe4JgdcPvdmc8AXn4WdZ383SDsinK2Wb2zinDzSm	11761	16545	16545	1618917300000
23609	3NKfyDsiXvh6uT5CiMg55ce1e4ZCiLP5KUnyHnFet5yQwopDtSRf	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1406	1393	442	12463	15598	jxz1CzQWB7MtvNDFh2siao8Dtyz6gVXSojYCQbo5vFpzF2sAuSM	11761	16545	16545	1618917300000
23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	23606	3NLKydaRv1V4fcuLEKArd358i3tXDHSooiAxYXLk6WWgb5hUgr1T	1448	1065	442	12463	15599	jxkXMpuMVTKeXrPdasNb5o3Y5xmNfwpCoBfefpKbjkbHXVjwL6E	11762	16546	16546	1618917480000
23612	3NKduyvbmeB6K8pn3pyKuKrKE5QuWeM4yTebkJCrEvMDpb15ZTyY	23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	684	1352	442	12463	15600	jwgXreyVUnWkWYvS2b281nGGy1dTDxMiNKmNbRt3uJcUurWh5B5	11763	16549	16549	1618918020000
23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	23612	3NKduyvbmeB6K8pn3pyKuKrKE5QuWeM4yTebkJCrEvMDpb15ZTyY	596	1306	442	12463	15602	jwimWTPJfhrbKUAJ4DegXehCJKBDuAW3UJi3VXFNDdEXjBZdx4r	11764	16550	16550	1618918200000
23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	23617	3NKj34dEjFUiUYFkZy9oQ4U4qHYDLdG7drN6oZVmFVH7E85FQBCH	1474	1083	443	12463	15606	jxDonaFomMimxJ63RSNdDJpXgDzyd52LMVsQyb9XJz7KQuyXKvn	11766	16552	16552	1618918560000
23632	3NLmgiU71xfK3KSjfMPN4xZNBWynkvXsbyhbLvvXWfhyFfjvP2oE	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1480	659	443	12463	15617	jx8h1NGztZGxSh6rhqC9PaVELXmp9aYHUukrph83Fx9eVeuE12s	11773	16564	16564	1618920720000
23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	1407	1395	443	12463	15619	jxvYnBebj1MKjPYuUFwRvdUzP4TZsaHjKBZhJKHwv9oTemH3qzh	11774	16565	16565	1618920900000
23649	3NKUKRQhwVqefvzNDobRg2HSCBe7HFMbqhff5PR6XoPeD1SS7A6q	23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	1406	1393	443	12463	15634	jwt6MKiU7QAqSNE4dNaQZL3k9JsMpatwKuhT8rtsqxg9kG1icg5	11781	16576	16576	1618922880000
23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	23650	3NKWSrZzg9havLx5uQLAXjmZ2PpTYrTLg4jd9bSV1LDTi5AZ3k5Z	1403	31	444	12463	15636	jxwnCF3Xqd41tXNqkLuoZiRENzYjy6PnBq7UeT5gfrcCtH4zsC9	11783	16578	16578	1618923240000
23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	1654	1094	444	12463	15640	jy1tJvCMMGwW8MsKNFZF53bxCn3cdSKb7EkXSZmCW3yzns7BwRU	11784	16581	16581	1618923780000
23660	3NLUoUsvjqm7yEDiryyGCHMnSK9Gs68pc7SmNyS5ePmJiQ9E1esw	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1670	1282	444	12463	15642	jxiWaLVPJHxrpTdEz7yYgoKTJ8gS3pyvqEMQiLW7LjCatHHtJck	11785	16582	16582	1618923960000
23666	3NK7myoNBpB9D9vb8SoV3TDcn413zrjmFxNXtpGtE1EsFpPP9AnF	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	1611	1095	444	12463	15647	jwp7PEJjJoyfDrQNtgckzzgqK27D65P4MNAPKbAj3jBYL5HoZSg	11786	16583	16583	1618924140000
23667	3NK4y2NYYnKcScbg9YMguim4bBwR6VNJVj4Q8mr6jpRA3uMdxLC9	23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	1560	1045	444	12463	15648	jxVXexXbjT39H5VuHxKPsikgamVWff13y5azDdybkxvqZmzsFwN	11787	16584	16584	1618924320000
23670	3NKQSeyhfF4cWr2MtCutEVGMXkUeCsNdyDpM3aNJ9KMpSx2TiSe1	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1656	580	444	12463	15650	jwXvFw9RidTjbmTTDmevnNVHAhBS49MnoKFKtsSPeDZbCLfGfoG	11789	16587	16587	1618924860000
23677	3NKEWhvk59kJ88GJJnDLxJFPcLhLvFrNgowHJZVLdcxf67VBpEuK	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1560	1165	444	12463	15655	jwmUGgj5LGMEKTDQ5o914rTXbsXbABAuvrPDAYw2YfRX9cWrcJQ	11790	16588	16588	1618925040000
23681	3NLwnN8bf3YiD6Bb5Pfykz3bGVQ2DMsfvZWHduj6qw6p5XTYbxbC	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1571	1335	444	12463	15658	jwJFr45iZa7zKcRN3mcqc9E5vwLN1mkiUsbdtecDerUoYnDgTZp	11792	16591	16591	1618925580000
23685	3NLtbp98TXrgCdJ6iJbB29xxN6pdMd1M2MTKHXrGLEyB2fkuYGAL	23684	3NLVRMJdsiGYtGE4kfqarcfE1HRdEXb7EiAScuTdV1YphUJM2QA3	1553	776	444	12463	15662	jx1C9ygoiXC9RXoNP63K4ZiHEakxK7AXCDAcbWaQoi2XQswPSx4	11794	16594	16594	1618926120000
23688	3NLhSZ6iDQ22WTxfhnwRmK8msXqkgmsY8RMadytXiZxNQzS1dUGq	23687	3NKdRGPBYRUDUFNu1keR5PpJNk1aitmPDxCUWLacH4unTyKHNE4M	1419	814	444	12463	15665	jwfdQhmSNv6bRMNV1CMnPwvMBuwGuWXdtizxZvTC6Lf5cqq5NNR	11797	16598	16598	1618926840000
23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1589	1040	444	12463	15668	jxWgU1MSufTS8B7GbhXfqKj6H3WMNhffiPUKsRbGBgLGMYjzsGd	11800	16601	16601	1618927380000
23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1397	828	444	12463	15671	jwXxaQhb7NJrx4y4vNDULyepShD38nQiat5HQjosFWC3deHvpET	11801	16603	16603	1618927740000
23698	3NLD33U4YcfVnUr57iDhfbR2jE2ngLYszyzDUPDX9JgkiQXJnjVE	23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	1483	660	445	12463	15673	jxjnrPrEBLss6XMek5kfYtt9txBk1AiurFQTtwNYYEWBb11Sxo6	11802	16606	16606	1618928280000
23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1633	1144	443	12463	15625	jxsrWffuP4aTDL4RP4vdmKJSKKMRHfCpTovgzg8zEMcMiCg286W	11776	16570	16570	1618921800000
23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	1508	1387	443	12463	15627	jxYutVKefGg9UqbZQ2UwswY1A1RM7WQqzdwAcuWyFykpKhqdDF5	11777	16571	16571	1618921980000
23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	23645	3NLeemn2RDBD2r4pnpCbiZVF4zkBbdghLH7b2bLM9hAzjpfVWTEi	1585	1120	443	12463	15632	jwrmASmnwtL4u2YwU8Tm3kyBFREA3qNcWJN1FHodWEuyCL3D8xZ	11780	16575	16575	1618922700000
23652	3NKq9XRG6NirJKRcWEJ7vfys7g1QrSGUtUaMkz4xsUiMg3CZXBA2	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxn67ScJuwa82TdignVENMK8eJ4EJHFGxFEz1qGHWMPjN9z128m	11782	16577	16577	1618923060000
23654	3NKbFTniSaSR36U1vUKJ1JqtJHFu6RzmavXfxrc1aUcb2aGWzRoe	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1506	1127	444	12463	15637	jwW6yJZ5WCzfyrK9wvtx3aZDeViGphmZWXFaC1kRgHjTPoYcD7E	11783	16578	16578	1618923240000
23659	3NLHmPG8YgKMVWeyUsaQiRtrAUVgs3v1T6JAQjZzBC1i3x5PmZDw	23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	1403	824	444	12463	15641	jwHZJHAhEmoXMHWXdGU1A2K3MPReAnwhpzyrs9uJq5mkByCdWuC	11784	16581	16581	1618923780000
23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	448	939	444	12463	15643	jwxur377A6djJ1iPeVCSwnf6BVduiveSkvYfU9bDkNt3tY2AvFk	11785	16582	16582	1618923960000
23668	3NLaxs1VA9miS4s4vBdNvPbRjK88k7ZJ81AHFmLvD3yWBthjdxG1	23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	1560	1045	444	12463	15648	jxekMrbo6T6YsdsgAjKYJsCFCp4hiivBQipKMGR2Da4aH4UURYr	11787	16584	16584	1618924320000
23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	470	1063	444	12463	15651	jwWfLVTvXZKLQ28pvQuLkoeeshX4C1svAogePv77MAtW3phC23K	11789	16587	16587	1618924860000
23674	3NKgjVC5dqTXpfXWtdP8SEYWcniTAKc5XatYmPBUGQYQ2fmTazdz	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1651	1175	444	12463	15653	jxLQDtn7anQp7fpdqJtQGmTm9RBQu5aF8G7iwrMWGtMWimtiHWy	11789	16587	16587	1618924860000
23679	3NKnTS7zvAahdVbZBXMCCvsNNFtauc41xd6rTuBzFWxGvKiiQnRY	23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	1448	1311	444	12463	15656	jxvjEib7jeuR22KsMMvmb3f6UAGE6Z5B96uShU9FinbKDbxT7QX	11791	16589	16589	1618925220000
23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1458	1323	444	12463	15659	jw7reXqB7PiQ43YUGkrWsNuo9gmTuCmhzmCgQ9TKabCshNDFAMo	11792	16591	16591	1618925580000
23686	3NLTcPD8g7dDjGj2em7w7ij93iwB6rLbn3c1A2fWvQ941HP8Dih9	23685	3NLtbp98TXrgCdJ6iJbB29xxN6pdMd1M2MTKHXrGLEyB2fkuYGAL	1589	1286	444	12463	15663	jxHdF3axDEEJVBHfDVm6iDBEYM9JwP822ExpAcJMv867pCf8jpZ	11795	16595	16595	1618926300000
23689	3NLpMPze1JzpXFVdCQgvAvXZ4spu1A3546XzGh5HvvSjvrQ5bekV	23688	3NLhSZ6iDQ22WTxfhnwRmK8msXqkgmsY8RMadytXiZxNQzS1dUGq	369	946	444	12463	15666	jxFujooZ6ZA8QPMxxB1KmnZHXrcaiHEHjj6f44XHnQ4vLb3CYGU	11798	16599	16599	1618927020000
23692	3NKbefyBoUAhp77Rc95h5LEfySYHuG5USEygL3HYj8mKv5xcvaML	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1407	1395	444	12463	15669	jxuHdyMRP1UGSv4kj7W8kSB61zamabA9aQ4d44qemoDjHfq4bJs	11800	16601	16601	1618927380000
23695	3NK8y6sEXHovT4kZPc9KiYNzK1jqTbHBnpowQd4vZbPBizR9TjNb	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1471	1140	444	12463	15672	jwkTiJHq2NRj4H1BswdGugqiDgHqNcZVQsSNBQZrjugxeTGCUKF	11801	16603	16603	1618927740000
23699	3NLtRUh1w1oSigL9Y3QRmEwSkNm9L2MspTfcdMUJ2hyZkf3J5KWv	23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	1483	660	444	12463	15673	jx3scnB6hMYtqSyMikxbqj6fVVBFeGyc9XSa5ryazGKrLGoTB5s	11802	16606	16606	1618928280000
23701	3NK6cWL7Y8du635TvGBxXQBwchgu3EfSaQNQEuFoZnSvCxyqFxhn	23699	3NLtRUh1w1oSigL9Y3QRmEwSkNm9L2MspTfcdMUJ2hyZkf3J5KWv	1602	1003	445	12463	15675	jwMbGX9qK3Qmk7VDCE4gYxxTFhC6u1QU2ecFqiXMv3HFEi11z4u	11803	16608	16608	1618928640000
23704	3NLtax9uEDAagjy5WfdwEgjUtXMh7vSyaWRwnYZXRxXU7PDuHpcj	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1445	1164	445	12463	15677	jxVtho7KPQ3xKx1ZybrUmKKav16PV62pkVe1v3NsRBPL69iaW7M	11805	16610	16610	1618929000000
23706	3NL2qrSHy2yobMkyYz5cc96rizuWSvhs9Aht2UDF2jM4rRZ3XQXo	23705	3NKJsidJ8PP2zckYyMzTj7e3FTkmiHkg8fEfySBHKHSLQHbyKjT5	1623	830	445	12463	15679	jwE9U27j4o1Ahic5DdvoEBFFa4EgttMSuu8YviWbxRnMt1sfyVW	11806	16611	16611	1618929180000
23709	3NKgRYapxvN3T8QugypSkGK1oMLhN5hsD97u8MF6S9mG6ivuGd4N	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1460	539	445	12463	15682	jwHMPxSGGWfKoiz1FUHXxaHYNxgQqGcVZ3x9GC2x9GaenmDM4E9	11808	16613	16613	1618929540000
23711	3NLnbFXEjKkJQpuaZ1m6cddse8x3ytWooxDcBcfTojWAeAUHbRmu	23708	3NL8sYrCbiCcsdef1EfCnoEZAQykJwyRyc9TXZ2Fp64EWWwXQ83t	1571	1335	445	12463	15683	jwUqxTvUGdqqZpbxXQUgkjfv37cVoD6cFd5TxLuwUeSqbQ64wpL	11809	16615	16615	1618929900000
23714	3NKonT34vR7TqUySJx1uTvAYZUQ76GvpAjEPRCstMRF5z2MqvF7w	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1599	1287	445	12463	15686	jwmJFKgcSZAroxDi7UDFhCZRXvtF3CavbiZFVdvqZfKVBEoFSxS	11811	16617	16617	1618930260000
23721	3NK9j7RgRBo6GYLCmxtqDBuEoQYg4fxr2o9xg6f8mDZMxZSAr6cM	23700	3NK72ZSixw3sU4KrTuA9FwSKhpgM4Nvxbp8uiGnAvnmVUJ6q18jT	1581	777	433	12463	15691	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11558	16620	16620	1618930800000
23723	3NKV8VNPq8dtKWTSPDQPrgGCkXAnUdrjMAZvro1ZDEHNwQo5MLVQ	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	1406	1393	445	12463	15693	jxMSH2HWGTrK9KLAJz7UZqTj3M7UUxh5VA775iZXMsKbms7C4PL	11814	16622	16622	1618931160000
23725	3NKPrXWUmZxPN3DSky5LGf58P5a8gUt8xGgdvuYk35BaPiVP3upA	23724	3NLq2P2SwbHAM9yc35ixQNjywmaQKhjEuuEA5eLVDKHzLHJBeSff	1483	499	445	12463	15695	jwTWKQ96wAhiTR2qiyf1H1FVQjvT1dmbpvarugjQgfNatpwm3ne	11815	16624	16624	1618931520000
23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	23731	3NLqtK3S8mV8vMd7khfiEufW6H8tDiwCr458Qp1aA1Vvm4ki4hCW	1588	1146	446	12463	15702	jwoF3a6ysFKjyUADnDHBHr2ypqg1L4zisLVJCWoEfBDASTrChqP	11822	16636	16636	1618933680000
23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1406	1393	446	12463	15705	jwSXpAEfi4mXwHYJJyVeSmBj5P3xYPfDySRTLYJwt3pmQKRrKNE	11823	16638	16638	1618934040000
23738	3NLcfVGcBWkYmw1JkopExiiGtZwUBcYVz4Kygqu4ZnMUz2rPWenk	23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	369	1312	446	12463	15708	jwWoG7boNEQyqXjaDQGgav1hnVEygJk4aUKYP9YiHJdfDaMwdqx	11824	16639	16639	1618934220000
23744	3NKgfQT9sUM1UMMJFDefuq1M3xBJm4THD9j4U5NeHuaAdqaFyuXM	23743	3NLqHJCAYZjkdbFi4afTL7vos6vudqDXhWc7xunqL6bscbUgZ4wA	576	989	446	12463	15713	jxTmj64s2o4YbpD454ftSGk5CSte2MT8qK3cwYNxs97jCp3EDKn	11826	16641	16641	1618934580000
23752	3NKoU42A9X3beq96gKRuFp8GqyxMWuCzDpfCf52g522GJBgU4qVY	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	311	1061	446	12463	15721	jwjQwsK3VXRsP31s7bvwTSCBxvE6SXLZk6Z7GTh2cVdQSZLhd8b	11829	16651	16651	1618936380000
23755	3NLtiptvJWLWx23xU5P7tZbpDvW1caHMhHq4wKJoutT1QYc98iW4	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1553	776	446	12463	15724	jw7KAN3Qwxw1uoRzVupcpzNQhSW3kUPQdrjaoMG8StK94BQqgER	11830	16652	16652	1618936560000
23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	1403	812	443	12463	15633	jxmjvwxMKgdTCvnpkrhsHrgLT6fZNwrUmhxgCeH8YT1Whjm7LMa	11781	16576	16576	1618922880000
23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxVakY4JkPdZYGJVuDWwNYunXnyRcWZ6EhwTGbTVDAAUDDKPKf6	11782	16577	16577	1618923060000
23656	3NLqv3vK5aPp3yMriVUNTdMq5tTTDPZqbtvj6EUsBFHeHTAzTivR	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1652	1315	444	12463	15638	jxRBnv66gehHWQJUMn1qmovM8wX8sa2W4y4Gb1bJ8XYYvGrMntm	11783	16578	16578	1618923240000
23657	3NKp4XNfGDrTrr3cQD3QmJS9FLt87zyAUyPGnae94ZAmZqkPWWGS	23607	3NKzF5vDdmRLDSAqTpp6kwwjUn85ooefJt841kVfKtRJc1ZboNSA	1581	778	433	12463	15639	jxwEc4Kp3mmxZhcYibbcVYqRN7PUDB2FG777fMb5zAi7ufU7GwS	11555	16579	16579	1618923420000
23663	3NL9DpspGX24w5NqNM3NJQr2pDXpqZrAhUXfxw92EsgeQNA9Tfp8	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	448	939	444	12463	15643	jwyP4M8pTPmHcNDkm5Bg5qEanA1LASerjrukVF6Wu2YcjbNYhT2	11785	16582	16582	1618923960000
23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	1481	790	444	12463	15646	jw7k5mWa96SeZuChQX6xPa1ZroV1pLdgzsuUQ6xBcw9eJN23BvK	11786	16583	16583	1618924140000
23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	23667	3NK4y2NYYnKcScbg9YMguim4bBwR6VNJVj4Q8mr6jpRA3uMdxLC9	255	255	444	12463	15649	jwqx6FBhATd9WwiNovfwBwA9aPXDBdvU8SokT5RcwaStspnthKV	11788	16585	16585	1618924500000
23673	3NKFAGktpGfWJtMQs7r7BaxyxCenDgED7XUUkfbpmX9dSf2CoUFm	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1651	1175	444	12463	15653	jxvGDy1UEEduo7N8qYVvimhuHtLdyowaKLYY2QqwT6KwTWzer8L	11789	16587	16587	1618924860000
23676	3NLrzj3WCfgC9ZtyjAMD2qnvZcSpfQhv5s7vgQKzHSoahUApxZkj	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1560	1165	444	12463	15655	jxptaMP8q8nP2LdX4PYyW14w4mgRcTvgjWeofy7RoVibicXbe1F	11790	16588	16588	1618925040000
23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	1448	1311	444	12463	15656	jwaatwk68hkz4hNdvgiEj3ZTSX4sef1cMX4FV7tAKwycnf95bCx	11791	16589	16589	1618925220000
23680	3NLQC3Sc6ERikXCBvrgW5Exhn5AJfmgXZd4oymD1BULWEG8SfYZd	23657	3NKp4XNfGDrTrr3cQD3QmJS9FLt87zyAUyPGnae94ZAmZqkPWWGS	1581	778	433	12463	15657	jxJfDaq69PcV6RvLZ3fo1hYbEojv51HcfvUgVGen8TdizDyWTnC	11556	16590	16590	1618925400000
23683	3NK9kFh4EeqXw91GuqdSav9NYWSGxwioaB9MPsY6WcVeDwANcj5h	23500	3NKoedTeGXzDFeobhEKxvKd9rAditqRAKn24MTJxjZimLLedpL2L	1458	1323	432	12463	15660	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11524	16591	16591	1618925580000
23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	23689	3NLpMPze1JzpXFVdCQgvAvXZ4spu1A3546XzGh5HvvSjvrQ5bekV	1405	879	444	12463	15667	jwK3qqHNqzvQisFvTrmQvaAR2XzDRQ3cSy2HpX4VPZKbREQyyw8	11799	16600	16600	1618927200000
23693	3NKXx1PAYTvEQp1puK46Cub5cgwrT3e5iZQeMo8HxYLCAQsZqF9s	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1549	1362	444	12463	15670	jx8tc8qF4cNvDEN7BqeMFSXXbqquek86REVbJxGkhPpFLd2sEUg	11801	16603	16603	1618927740000
23697	3NLvt1GYjLyokBhv9b1qSpHY9HdeCefvr5etMxJpdpqA1fjwfUJu	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1471	1140	444	12463	15672	jwkTiJHq2NRj4H1BswdGugqiDgHqNcZVQsSNBQZrjugxeTGCUKF	11801	16603	16603	1618927740000
23700	3NK72ZSixw3sU4KrTuA9FwSKhpgM4Nvxbp8uiGnAvnmVUJ6q18jT	23680	3NLQC3Sc6ERikXCBvrgW5Exhn5AJfmgXZd4oymD1BULWEG8SfYZd	1581	777	433	12463	15674	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11557	16607	16607	1618928460000
23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	23706	3NL2qrSHy2yobMkyYz5cc96rizuWSvhs9Aht2UDF2jM4rRZ3XQXo	1657	1344	445	12463	15680	jxKNLxQW9Z1aLm7QX9YqgnbtypgW1Yj85TnWBwQCtBdNiBwR6ao	11807	16612	16612	1618929360000
23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	23711	3NLnbFXEjKkJQpuaZ1m6cddse8x3ytWooxDcBcfTojWAeAUHbRmu	1407	1395	445	12463	15684	jwrBHYsmm5bR6BNjLPF9mG3xHVQsABJH4LQADxoqPDsPExDgRLW	11810	16616	16616	1618930080000
23716	3NK7NVEv6o5Z2omHT1FgJcrM13GogiEgsi2nGyJph98csffs1iYT	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1599	1287	445	12463	15686	jwWJQ4UT4vVWWS7bc7XTenChbPAsZr2hAKotnLcfLBnd8bm5raT	11811	16617	16617	1618930260000
23717	3NK5CqqNX1Wd6LmmSZHXncmwzFqT6DeR6EUeCiaTHpMvq8hAMJ1c	23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	1471	1260	445	12463	15687	jxBRw854MQZFqPgFkdsz4EABCx2pRhBW9k8jePn1PCRiLbdEE2y	11812	16619	16619	1618930620000
23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	1439	913	445	12463	15689	jwmuJZ7pxS4cHSXbSH3jWRaQd5wboZkCroyTtezcBSmRkMDKcdK	11813	16620	16620	1618930800000
23727	3NLnsCMJBM6Mdz4aqTHmfhaoQYZg76PkNMx3uRsabQGvavT8iEUz	23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	448	939	445	12463	15697	jwGCCUn7bqV8MzVNBMGr7UTsFiDKLxJRyfvXBWjCpfoBQNUGa35	11817	16627	16627	1618932060000
23731	3NLqtK3S8mV8vMd7khfiEufW6H8tDiwCr458Qp1aA1Vvm4ki4hCW	23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	1489	1134	446	12463	15701	jxTCgSi5oV6uiqQGPwYSrxv9ucHPcMz62vr2hf6gKQLNt33JrMg	11821	16635	16635	1618933500000
23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1631	794	446	12463	15706	jxg22D8uHUr3aeqPQDx9RAZS7gH5wx28ZqMXof8fbKD9keJLsLN	11823	16637	16637	1618933860000
23740	3NKEDqGfTFeAwcYnSwQja1kbrishvJwqTH1mjET1TF7FdfBSz8ZT	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1448	1311	446	12463	15710	jxzNuPJsZPSf9KFzQkQCvPXXerUHNevZ7Twu5j6nLySAjbjUMhJ	11824	16639	16639	1618934220000
23743	3NLqHJCAYZjkdbFi4afTL7vos6vudqDXhWc7xunqL6bscbUgZ4wA	23737	3NKQiouoFsfe5nuQ3ziump8WVb2fuUjUQDpxxsjGJU4Su76kni8e	606	1295	446	12463	15712	jx2L4PSefMGtnwCdoLLvBNdqZ5RaQpAYQmQUJ8pGU9Hh8PEBuah	11825	16640	16640	1618934400000
23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	23746	3NLwwTLy6pEZL8yx4RQopsdcifsqkp2cSCqiURFaxfKudttiqKcT	311	941	446	12463	15716	jwrfdg5aQUo6RiLV5ikXbjsYcpmaZb7N1wy9vVDS3eLapo8fHbj	11828	16650	16650	1618936200000
23750	3NKYgh8DET3adVutoxH2YZR6gRCAAXYpE6GS6ewj5NZfUYgXNuNV	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1406	1393	446	12463	15719	jxwrSbbEXjzgY9XJtcbUrzMF92vbzButK6mSbYJ9n2qrS4EE1in	11829	16651	16651	1618936380000
23762	3NLbVtxr3VhXq7WVXXmekERndMRq4nJQvtydzMneJ8ugkbtMPsUS	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1593	1346	444	12463	15731	jxYFCW8LJv2kNC87VPUeG5cFBTfZgdnCz8yHKQouFXNBCcU8cQ6	11785	16655	16655	1618937100000
23764	3NK7chHzmEZLjdVr6NFihz6Pu7rinwjkj48rNeiMF9GqNxEf9wR9	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1501	994	446	12463	15732	jxNyHRs59FocHEdRUutLEZ71YtqwA3oZwenX41h845rsdCp5fXS	11833	16657	16657	1618937460000
23768	3NL3xHsWghLGPfkr4L8xrBhn4mvnJSAUsdQ7DG274xgA63ZMqmjT	23745	3NLbHFrVDxzZtT5SDuEUgYjNgNuerygbcQXve3GwMsEmSmwSCDh5	1581	778	433	12463	15736	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11560	16660	16660	1618938000000
23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	23771	3NLMnovL7DnFeJb3eZAPpXBgkwQ6VKEgCNM8FYPqVxaiFaqW3D1z	1476	1371	447	12463	15740	jx4PQ2pDRnhad5Ej3dSKhj9FyeCFdHWnL1KeetwV1pXmwhKAtfR	11838	16663	16663	1618938540000
23664	3NKChzgMNgDoKVxphwU7mbi73wCUufQuRZhUFzNuKZAXW4AyVtGF	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	470	1309	444	12463	15645	jwVeopWafhFbdrwYCVdbMdtJikeszbqyWg4DS6T7tYTRu2AcJnL	11786	16583	16583	1618924140000
23672	3NLMPUZ9Trd3zF8U4fQRmDGdfYvgdSfzWQoVmVYPgdeiC5GbH4YA	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1407	1395	444	12463	15652	jxdtiZzdnV9BWG754DSW7KaUpndm2MNj5jKpwyyR936Dptw84QU	11789	16587	16587	1618924860000
23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1654	974	444	12463	15654	jx6kcZhXb8ABCTosdi9CNLz38igWh62JqRw1ij3GpEycQjjeN1J	11790	16588	16588	1618925040000
23684	3NLVRMJdsiGYtGE4kfqarcfE1HRdEXb7EiAScuTdV1YphUJM2QA3	23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	1536	1067	444	12463	15661	jxHxccfV7ZEELADbHCkTjcn1ekiRnCWwgJWjqxxDrPER9Ua88NJ	11793	16593	16593	1618925940000
23687	3NKdRGPBYRUDUFNu1keR5PpJNk1aitmPDxCUWLacH4unTyKHNE4M	23686	3NLTcPD8g7dDjGj2em7w7ij93iwB6rLbn3c1A2fWvQ941HP8Dih9	1406	1393	444	12463	15664	jwsfEZy7DgvMvsremY4r6ZnG261U5UcLPoCBMoHU5RSDrfZtzpr	11796	16597	16597	1618926660000
23696	3NLNaxUmksV7o4ouLu3QgvMpS2HAEiHx7HzcC9gQ1jEfoyhp1DzZ	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1549	1362	444	12463	15670	jx8tc8qF4cNvDEN7BqeMFSXXbqquek86REVbJxGkhPpFLd2sEUg	11801	16603	16603	1618927740000
23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	23701	3NK6cWL7Y8du635TvGBxXQBwchgu3EfSaQNQEuFoZnSvCxyqFxhn	1407	1395	445	12463	15676	jx2AGN9dafuDNtc5DoXZpPQZxs1CbexQEFqwCkRb7cPCjqyFWAR	11804	16609	16609	1618928820000
23705	3NKJsidJ8PP2zckYyMzTj7e3FTkmiHkg8fEfySBHKHSLQHbyKjT5	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	484	1193	445	12463	15678	jxkpEakPogQ9ujdemrQUJWmH2dz2Y9e8gpdA6ZNxSAKqRUo5ADp	11805	16610	16610	1618929000000
23710	3NKKQNDEnbA67ZkannyEChUEx9rvCnUnRxob5ZMNPY7ANYBAoe33	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1460	539	445	12463	15682	jy1x7WUFUzxgmyx3LyqVeRbWH4ixQwv5UN2epuGkEnR37XTB1gu	11808	16613	16613	1618929540000
23715	3NKNLFjGEj2cSXABRMMWAzT273rDPqexAQhHVXopsHv7YL6S6tZx	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1607	1348	445	12463	15685	jxqjd3x2VuwBECjeJ3RayKh4rRes8XKDzBNf63ahTQvJba7W9Zr	11811	16617	16617	1618930260000
23724	3NLq2P2SwbHAM9yc35ixQNjywmaQKhjEuuEA5eLVDKHzLHJBeSff	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	1670	1282	445	12463	15694	jwDWUiNZMNKtwoYjW9ybh3KNbd7WCZTMEACt8qFZpwkoEGzthVY	11814	16622	16622	1618931160000
23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	23725	3NKPrXWUmZxPN3DSky5LGf58P5a8gUt8xGgdvuYk35BaPiVP3upA	1571	1209	445	12463	15696	jxku4PX7eAkd682sD4xXMWMkKao8K9GkJykq29pf6rXco3r6FYj	11816	16626	16626	1618931880000
23729	3NL1SfaWY81aLXp8rG13tE8qXpVGem2MCyAdSNykisjLsWwEt5ay	23728	3NKcbcpt6g2bJ5ejc9CJdwXu5EHqTfu1usUSXkbRv2owfHd9KNnG	1406	1393	446	12463	15699	jw9JPV1gzSSMAFAWGaDbQD4KQusoGmYvncPkCMLiFey8xbJ9PDf	11819	16630	16630	1618932600000
23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	23729	3NL1SfaWY81aLXp8rG13tE8qXpVGem2MCyAdSNykisjLsWwEt5ay	684	1352	446	12463	15700	jxk7PpUWpSt5Gj1mACf64kVgCNLRREEANTLAwkoxhq6grkQrwHJ	11820	16633	16633	1618933140000
23733	3NKhBgeabypoGeehUkAQtXbZLMWPa1pbFmqd7tsRKnsnxUDQHrxW	23582	3NLkXGjSUKv32FNVyo7mhgeMcrtxiBowrS978YfvEbnNh33HfQi2	1455	1206	442	12463	15703	jwUAoRyWw3W14RupGvafeTr8PrVtSrximmQiR2qmdHB2L2pDJnD	11753	16637	16637	1618933860000
23739	3NKbe9kKcX2P8EfqH9B1UAYZiDRFp6vTXtDbDRcFK7UpDijJ2Rf3	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	369	1312	446	12463	15709	jxbAKwRK7wv6bHzJMLr9oehFtZPFSj5qR9TrV7PgKMWnwDKiJuH	11824	16639	16639	1618934220000
23742	3NLjTYjvQs4ZLdLNJDHTagUzneW6uB1JiriMho2VWVjtfFuo5wbw	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1448	1311	446	12463	15710	jwNhQBA4MyiAhy4eFh3MTfUpQp9K2Ng7CfwzuXQbVY1g54HSRV7	11824	16639	16639	1618934220000
23746	3NLwwTLy6pEZL8yx4RQopsdcifsqkp2cSCqiURFaxfKudttiqKcT	23744	3NKgfQT9sUM1UMMJFDefuq1M3xBJm4THD9j4U5NeHuaAdqaFyuXM	1458	1077	446	12463	15715	jxEvRHNwdH3Qg4Efxp4Uati5hGstf1PEsnMVASuWRkAmjHZhKF2	11827	16648	16648	1618935840000
23749	3NKvJq828d3DgeMdjrmre92QdchBrtyVQagERcev4jHv13uSKin6	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1497	654	446	12463	15718	jwNhSNmb3fNSSPbYsJ8gT1AwuKh9LpEhF99oeMWJ1GUcBVex6mQ	11829	16651	16651	1618936380000
23753	3NKNLARe1funaity7xAgRhSnDjxqgUJof5Zz3iaDMuHFgpzMQpkk	23748	3NKJMtiSAPZGS7fW4VLi5dqeMKSpxvB7Gtdqy84gGornuDkukpZ8	311	1061	446	12463	15722	jxnrUbS2tbsHSf3vt47Ef9vmEbSWQZQwzNL8Arh7dHZHPTyjZ3u	11822	16651	16651	1618936380000
23756	3NLi6VSx5iMfP4hK8PfvQDKC3BcFWje6gan16PeJhYk6DZD7bcua	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1578	1296	446	12463	15725	jwGsca6PBxfwXBw6mq7qTHJQg4FAmXzv44ggX3zh218dwSZQHEn	11830	16652	16652	1618936560000
23757	3NKYGuUNY4xyacf9DXRGDs9mkkHjZCGZzxRvNoRQyqDaAxhVaBj2	23631	3NLkdeSrBk38KjTt7cjtuNaQcmuxzFRFYn9hMDsSdyvfuFKgAg5A	1578	1296	443	12463	15726	jwRfzq9d5Aq9ShQXpXu7Wr7ePKUEh4BwQG9eCj8PA4Zf4zMwDpw	11774	16652	16652	1618936560000
23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	23756	3NLi6VSx5iMfP4hK8PfvQDKC3BcFWje6gan16PeJhYk6DZD7bcua	1671	1365	446	12463	15727	jwNqvuUdjk3cwjEtkjW4ajsziBU4pXZaHeWw66s3ErE9UjVmcJH	11831	16653	16653	1618936740000
23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	1553	776	446	12463	15730	jxRrqUsK8Ngkxg2tyg2FB2J9AArqwJ5FkQq6SAmpm4kPyA8Q3SP	11832	16655	16655	1618937100000
23763	3NLWNgMsx2QW531TB9tHbEfryen2ZUBke2VZbsZnfdKK3mYtmnaB	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1501	994	446	12463	15732	jy2FLJ34dPzcGHXq2LZKskSyLskJbUXqX5hPksbuR6jyfNPn6nM	11833	16657	16657	1618937460000
23775	3NK71jnSjzbL1BWEuRVKkyrWUTA1jAESCNgadaCFSfTU9iVtvvAW	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	1587	991	447	12463	15742	jwyUp7sxjFWeASruAFq7sqqE2jd9Stt5rgPqthwWBnduscnkj2X	11839	16664	16664	1618938720000
23777	3NKx6jZQ5qowhBpnqVqdiErzMhAAhd8WVcgw8fEvHXgFZUZBGgH6	23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	1444	1015	447	12463	15744	jwpEys346rFcWcyJLsWYAhKgNA9RXoUipUiUuGq5dieMRKyQ1dm	11840	16665	16665	1618938900000
23782	3NK894KrtSXoV74k9h3GdpCXJNYsMQinT5VrrkSktRNLWSs7Zqpm	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1451	1166	447	12463	15748	jwKGeSSYJXXFqXn8dmt2eHFwmhPpScy1Hq2o8Ppcm1PH2i7xgTq	11842	16668	16668	1618939440000
23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1675	1342	447	12463	15750	jxyBzNcjDKMxpt3G2Kr6u8SwqWg8sDhyKQJt3rXw4XMgVCqJsPS	11843	16669	16669	1618939620000
23788	3NKYbYq1CsnQQy5EktBXPBmdJ4VFJvAxtLrNMBubjYP4FZgo3Cgf	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1577	1081	447	12463	15753	jwpKgGvfhtDwsUQuskHvcLAEdhKSs9VBQWz6XpW7B69uEGhXzNY	11843	16669	16669	1618939620000
23794	3NLkrcxnQrhL1V8BtDTbz2JFYZTwj7bhaZQ8V3hggg8CmgbE6HPT	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jxj2394bDY9kVMBHorjh2apjhw4CEz1DSgKau8uXEjmp8jj2pwi	11845	16671	16671	1618939980000
23797	3NLLRKp6FtMh6n8C6MdFxmspLdFU1ZRWXWd1GsTNnKSTHfxqi4qD	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1426	1364	447	12463	15759	jx49CMGPnyaZPgLuJEBT2hE5VBmLLdABfkHVvpgot3ZWdphEj1H	11846	16672	16672	1618940160000
23703	3NKgMXEjU7qUJaCRuGy2jYoZEZH71E8uZcSR9FvH6bKwFyxCdvRQ	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1445	1164	445	12463	15677	jweDBdZmdHMeX4tTMPKggd4mczPKHP2yecnK6XwrGw3QG56mqsz	11805	16610	16610	1618929000000
23708	3NL8sYrCbiCcsdef1EfCnoEZAQykJwyRyc9TXZ2Fp64EWWwXQ83t	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1402	906	445	12463	15681	jxr5vPEmsfcU5kWAKEjRrEdAmMi9m3t4jZp5auvVySPqtUynZjU	11808	16613	16613	1618929540000
23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1607	1348	445	12463	15685	jxyhCZESY7eoSfVLQVeJigHt8Ugghs78WVZAWEckwy5i6VoWKJA	11811	16617	16617	1618930260000
23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	1406	1393	445	12463	15688	jxGABKn4sbTfq2dwT4k3i8kvU4W9vPBUMYVxjZxSJRBSYeB8qN9	11812	16619	16619	1618930620000
23720	3NLr7VnB9eF6ivsLfV5MMAyUeRRyV74vYuMvo1h2uagcDz7hSYMo	23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	1579	1023	445	12463	15690	jxfZQfjMY2dceUfhYNWmYGSVVd9kPdjLAeK4E1MjiBkFSGEoSQ9	11813	16620	16620	1618930800000
23722	3NKd9zQXQAbHtDSF8qVhLTttL9uJkqDXpNbLcAWD5T7LPqYYowbp	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	43	1310	445	12463	15692	jxrgeAa2CvsEDu1cbpXWnkcVQ5k9nT9cutFhZ76qL7ALGhos6xE	11814	16622	16622	1618931160000
23728	3NKcbcpt6g2bJ5ejc9CJdwXu5EHqTfu1usUSXkbRv2owfHd9KNnG	23727	3NLnsCMJBM6Mdz4aqTHmfhaoQYZg76PkNMx3uRsabQGvavT8iEUz	1675	1342	445	12463	15698	jwki1i3DyQNtypA3MJNf5wLR6Y2hu5h6MRQwkhadWpv5RZbnT42	11818	16629	16629	1618932420000
23734	3NKEpg1Fq3622Z2Qx1eA5LroYr76B9s8dPiecuKS2bzYJYtaGy7m	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1627	1259	446	12463	15704	jxKkt8JGsR6x7GpFAYA95Vmpz3JSBsmEjUkNakdpmN22Dtie7yQ	11823	16638	16638	1618934040000
23737	3NKQiouoFsfe5nuQ3ziump8WVb2fuUjUQDpxxsjGJU4Su76kni8e	23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	1448	1311	446	12463	15707	jwFC9wdgmubUsXZHJGDL6eFSisa8A5MYDjwByZmWqUFr4K8zZvG	11824	16639	16639	1618934220000
23741	3NKwfsGBMp6BUGDpxNa54xBTsSTYy649Ax4vgq9RxrJMYrtreCkp	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1406	1393	446	12463	15711	jwzLmV7pRx4YMdtZJ95ZngcmKbRBmx5Y9inVWSovKmVbxFGLb7n	11824	16639	16639	1618934220000
23745	3NLbHFrVDxzZtT5SDuEUgYjNgNuerygbcQXve3GwMsEmSmwSCDh5	23721	3NK9j7RgRBo6GYLCmxtqDBuEoQYg4fxr2o9xg6f8mDZMxZSAr6cM	1581	778	433	12463	15714	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11559	16648	16648	1618935840000
23748	3NKJMtiSAPZGS7fW4VLi5dqeMKSpxvB7Gtdqy84gGornuDkukpZ8	23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	311	941	446	12463	15717	jwiqmj8FBpjzq6WTfMNzd8i2PQvHLfPhGwDRyT6NeFVJ5QQjhKC	11821	16650	16650	1618936200000
23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1656	977	446	12463	15720	jxiCxtzvLqo9sq5Fp8wRvuPShFUthE663qXfXH6qSwcvLnwPV6X	11829	16651	16651	1618936380000
23754	3NLpaFT24eZHj21Uink7wvaqjxgkPtAKmyqcMngC8dv8hTSR2EBr	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1668	1124	446	12463	15723	jwV6fnak8mG1VFC7GqWNC1Te1iJWN9FwxXsyRwLNxai9zfGM3RB	11830	16652	16652	1618936560000
23759	3NLMPTecUvnkn45vsTNDkdDejmoTYvTxRDS1GPgYVSYq9TTTB5ta	23733	3NKhBgeabypoGeehUkAQtXbZLMWPa1pbFmqd7tsRKnsnxUDQHrxW	1455	966	443	12463	15728	jxUcBryjYUjQ51ijfM3MKJBfVNAiyxjeEi2NKkyaJZxfDJxA3D5	11754	16653	16653	1618936740000
23766	3NL1eyN2hhbuDzT8NXs6HwiSfPdicUrzQT4nKwohdhptufvYCAAE	23764	3NK7chHzmEZLjdVr6NFihz6Pu7rinwjkj48rNeiMF9GqNxEf9wR9	1589	1286	446	12463	15734	jwsQxdV5RajPF7V6jztwPejvhevQR4YiHLx8xs6oR1X5kQdDAfi	11834	16658	16658	1618937640000
23769	3NKyeGkJnP186w2tMZUtcdYAJhcZrRub2Giu5HQbe18SdE1pRSx1	23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	1403	824	447	12463	15737	jwPZcdhHZC1zDKHFjjUYjY2h4YqUBhuHkFxfArBN8qX7btcKBDC	11836	16660	16660	1618938000000
23771	3NLMnovL7DnFeJb3eZAPpXBgkwQ6VKEgCNM8FYPqVxaiFaqW3D1z	23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	1483	1150	447	12463	15739	jwKkrjeH1KgxnESGaj7eoAocNZiNNettn2xZYB1wfGUSN68xtUM	11837	16661	16661	1618938180000
23779	3NKLcgrRSKncDGrBEKvcG79Ap5XuZqaPu5qJdKqm5zh9CP5UKFoS	23499	3NL5ujHbLymajhxbhfR7xVg8mw5HgHU8sn9LAUJUrDGV2PQWrfQp	171	1128	434	12463	15746	jxSFXkxcNGmrTQKFURxo3sdtN1RF5vnDKAcMVaSPertcj13vVka	11572	16665	16665	1618938900000
23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	23778	3NKyC5R5spSjo4cZL4xxXtUDu3zZhtZ8kaTGiY1wi4xVrWB2zmb7	1407	1395	447	12463	15747	jxtkHTjcQpGqFpp7F58BhNuhnUKSFQ6u1Fy2TY84m5wGhaSCwme	11841	16666	16666	1618939080000
23786	3NKqUCHcLLiWDGYosHV73b8gfaXWGoRUSueVKtqbTL1o8d6sSJ9c	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1483	78	447	12463	15752	jwzTfpKgttn5jePfPas8T33AxRtXJgKDRWuFWoPcvHkfdcyKY4a	11843	16669	16669	1618939620000
23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	1402	810	447	12463	15754	jwRmjkdrwsGJxVySfbqtXG2kqiTSqnRFbkZQ4duUtqhtpTEK9rD	11844	16670	16670	1618939800000
23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1654	1214	447	12463	15757	jx6F3kremXH7hBixZrG5pPvXjrDNTtTzidWqjZxQ4YJvGVuyepW	11845	16671	16671	1618939980000
23799	3NLPwds6ByMWUjujqvfLSQt3Qt79cNy5aeZbVfBp1jiGmwcsGLME	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	684	1352	447	12463	15761	jx4DKqXwfMUZWTdJddrxd8P3fW1NR41jzmSRG3CSHeayLgivnFY	11846	16672	16672	1618940160000
23808	3NK5WByHHCVz1V6mRCCq8eiQYWquSahtwpJEgQXSDquVBQQp8a7q	23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	58	1035	447	12463	15770	jwMJbAwSHqHTN88Z1AkiyNrFznEo1vpCLBnmmDmwTD2zX57SvWf	11851	16679	16679	1618941420000
23810	3NKnmegY4qa9Lhk81oMUJFyHxNzebQcLJ4A21AhRGhvMcfRXzqMZ	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1633	1390	447	12463	15772	jxX7Sxq2F5RoyRHKurocsj8H1nNLcX9vBiAizcbBd1bVWr9uZ7T	11852	16680	16680	1618941600000
23812	3NKG5QM8XgJAaLEVSh7W43Likf51L9G42trqjbzjco96XE7rtMiW	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1406	1393	447	12463	15774	jwiujnoCz9skr5uL2nTjZufCFuyTYkknn12oX5RKKDGYb1u7JN8	11853	16681	16681	1618941780000
23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	1476	1371	447	12463	15779	jxRDH6THWDe7MPahWooTUtHqjKevWfQkGYBDzfdrbRiSLU7eSkc	11856	16685	16685	1618942500000
23822	3NKQDk3bD88MeneWMQwSF5Jecp5sZWTNW9fLwnYkArMFdj8yXMFq	23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	1447	1219	448	12463	15781	jxHSfZMecF66rtYMqpxkAmgmC2HfRAPZw7BHE2m9xWSdyHmLxHD	11858	16688	16688	1618943040000
23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	23826	3NKYcfFit1Um9AwKRXC9QzCYAyYU2HVW7Lv1LnrfA6GzedTR5YW7	42	1361	448	12463	15785	jweKEfCGbZzfrJbxpwrW9C22vBjfvsZK5bip14BfecYdS5hUrdN	11861	16692	16692	1618943760000
23830	3NK5veqxqVQfTwGSoJXb67v74uMvpGo2PtwhEJCHeupjHst4sp8L	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1610	1314	448	12463	15788	jxpjm72fmGDtrkBx1iMbsxNWFT5qvchmJCUZCM3na75ifV2K23g	11862	16694	16694	1618944120000
23834	3NLFLV8x1GESm3VRCaMzfWxxFbbZK4c48nHm8VLM5bpbx3SErthq	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1451	1046	448	12463	15792	jxCCF1gdx9YwrBYrwDiTQbfHxshEwSVpKnhTKfT2wTqK7C6xQ4S	11863	16696	16696	1618944480000
23760	3NK6n6XMGMoKAQetyzbwUvaPUp43tm3XYyAoCxuU8LJFyrb1pX6S	23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	1593	1346	446	12463	15729	jxTa8j6JErMx5CWn3z5BzZQ3KerDFAJP2RvgHZbif9oMgYG1TUA	11832	16655	16655	1618937100000
23765	3NKcA9hrLYfGeC4CCFS4Cs7o1y3TvtDifmPdbzBhMfZs1Abm3anm	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1590	1300	446	12463	15733	jxHGbLUpftbutKPBH4dzLLGajsS8oXQW8eZBJYf6Z37SPzL3phE	11833	16657	16657	1618937460000
23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	23766	3NL1eyN2hhbuDzT8NXs6HwiSfPdicUrzQT4nKwohdhptufvYCAAE	1403	824	446	12463	15735	jwhfefAVJaXC3TuQ9rPwAwB2MbADnpAbB7ANid8QWaUpDGoWpBV	11835	16659	16659	1618937820000
23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	1508	1387	446	12463	15738	jwLeT4DuPS7o9ny5zkGumyGD8gbuez6kMaNxanDTS3FmMvFbdYM	11836	16660	16660	1618938000000
23772	3NKQ2Qv94aaSeM7ERHhEE3RTd5k6NuFLDnLh9RrAwETbfWwufqf3	23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	1483	1150	447	12463	15739	jxuneSbzWcv2G1rmYk7uvQDwCj92NbrkJgeZDAwKUNonyZsRjhp	11837	16661	16661	1618938180000
23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	80	1027	447	12463	15741	jwx8FTyFxCcnFSMHX673ZLsYVuKcQopZBavhFpk8UgzagcJVfhs	11839	16664	16664	1618938720000
23776	3NLCYqY4A7KLiZkBv6ZZxX2BVbNo6RSZ3QSA5KZJ2xzRADeR3iRw	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	1631	793	447	12463	15743	jxW436Arzbo6DP7hvDii4UvMKerzQm8HwF1D7BRMj2iwPkVN3SD	11839	16664	16664	1618938720000
23781	3NK9wXqTj7p4GFKWTeYeptUTEyWDHg6mf3LrZgFQpkAqGWktT86M	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1451	1166	447	12463	15748	jwMEQfqCxxKMqDnPPm6xDaBeexEQ2ujkwVEG7MRnsYSfTrxz5Xt	11842	16668	16668	1618939440000
23787	3NKdo7UU6cpspMXGtn3X9d23BRSPMj3e2NY8boXncnu4JdrRoavL	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1675	1342	447	12463	15750	jwMhQRK7htZP8RExah6QwPhBB7XoSGcnkCab3UEUMP7aSByCJsy	11843	16669	16669	1618939620000
23790	3NL3a3JjSSTCc6Y9ZMNcN4d78RUZrd8dtQat4bD4n2JpW9MuNyJc	23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	1609	1333	447	12463	15755	jxX1CunLBeksLa45KD54sivGw5MJAtHdgrmKtpWJWUEgmYXZ2p2	11844	16670	16670	1618939800000
23793	3NKpRVdyWeAdR1Hi6TtBf8TMKLF2gyTVNCqRaoAGmU4G2VLYySHC	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jwoEehgB6Vas5EKqzxxoKwM53g6Gd7f6L8gRt38ej1KEQx7ZYCT	11845	16671	16671	1618939980000
23796	3NK52M9JVNwCTiso8RocfVbxbrU282NuNbWuHP7qz6Mu4SGKV8Ud	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1602	1369	447	12463	15758	jwaHAk8kWPLA3sNRBvcvpSa217Vrk8b3Gu6xzhuwckLwVDmAkhB	11846	16672	16672	1618940160000
23803	3NKkTTzARFVmxQoTQQrSBBTvQwSk7yqidvFrYeWHyvGmrb6RCDtw	23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	1589	1040	447	12463	15765	jxTw5R2kPj7h3SZpKVi44MkUvTTNNHhC6uRwe6ZtBxFN4PeexPP	11848	16675	16675	1618940700000
23805	3NL2a3dZSgPCyy5yrL4o4iDLDDoKKnRufewNAqqt54tMBfhEvDsw	23803	3NKkTTzARFVmxQoTQQrSBBTvQwSk7yqidvFrYeWHyvGmrb6RCDtw	1460	1198	447	12463	15767	jxG7wt1NAbimxeSaa9aUcSQwhLXSFARJTbQYEhkdK4LMJkZufGS	11849	16676	16676	1618940880000
23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1637	816	447	12463	15773	jwgVXiPcDs3rgKLyBqZDUeDtz5cb3u7sGsNhvJgajcat9QQC2on	11852	16680	16680	1618941600000
23813	3NLw2g4NCL1YFVMSE31GzKpoMhVLvwmoS8fD24q1ik6PunvM6af2	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1573	1318	447	12463	15775	jxZUb4US88Xk12E39H41SDcMiQBYKW7tKp4zHwM2WWrY8sDR1qo	11853	16681	16681	1618941780000
23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	1541	1298	448	12463	15780	jxWoQeDJ8VkB3n7tKvZ8bNpFfhPXRaLr4WSVtw8ayXYsyYZLvmD	11857	16687	16687	1618942860000
23823	3NLvoNKF7BxAjLKPF5RKRnHfpcTQJd829N9UP3cUmcQAreC7Z8ZL	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	1447	1219	448	12463	15782	jwvWP8kdXZBz3neyXbjDrtgqJDbSwF7TkwiRFbZorkR6diR2iM9	11859	16690	16690	1618943400000
23828	3NLqC9gfLToVVK9jiK6mL2dmy1QiCGJxFAyMbJUPmpJmbn9dKLmW	23798	3NL73LMEo29BGVJnWYAxAshqjbXYnzjNZtfCbtU92HXKYN83Jw8K	1471	1140	447	12463	15786	jxJDhvRomtFsGX3f6CGkWgkLW7F4r5dGCbiamcnpdbgHVU2hoSp	11847	16694	16694	1618944120000
23831	3NLegAfCHKWaF9vbJSwcKyPd4iM3FcJdFACEMs3iSf8eXrnBBp3C	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1407	1395	448	12463	15789	jxzSDegdFvCxgvpRjgbXxCUcbLzuTYjVkBn1S6g9NXQTmbB9jQW	11862	16694	16694	1618944120000
23835	3NKmxSYYCimzSoT8CqvTzMKoiJnmUsenurPzU4xkixmfdtJmNtkh	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1451	1046	448	12463	15792	jwkMXK1HYz7yQZNYSUMWsmYvGPtH6gPoQmunj9EgqA1oTG2gWum	11863	16696	16696	1618944480000
23842	3NLdYhtsDkGk2Dw8VcWnHUhkUayTbZWViVAvW3Qn9876vgVXh6HZ	23841	3NLMsk61J6rKe4erdMuMdvDAm8JjTubuoKBQ8hpZbio3dJRgVBvE	1553	776	448	12463	15798	jwENuSAtLLUX5QumQWfMG3QQRGX3jJEgwYUHMEsJj2HepdTx7jV	11867	16701	16701	1618945380000
23845	3NLWhAqqNmfZth9ubBqFiMGPyY1feb9yCUdeMR9Hz6BRiUoWSvAt	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1675	1342	448	12463	15801	jxdKukrtvxXJhxTHMUCk9gFTWrDxGDeHLaJYXPMgGh3EXCgwUxq	11869	16704	16704	1618945920000
23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	23849	3NLBk1mZWgieD1yNSVKbhyUCL6TrMCSV4VuVgzkpZou4qyVkVZRS	1403	824	448	12463	15806	jwk6PTCohsPi28X2BsqJfrSHngVcYrc8r4G81QmNySav2ru6MYo	11872	16709	16709	1618946820000
23853	3NLswdMWmC8ovv32aeNYKHoEoyAo85NDT8PNzFBMtf42k4MSgqyh	23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	1513	1253	437	12463	15809	jwP7JZHzL5qT7iadcrN17F5NbXAYJ6zChnD2CeFbgqybh6Lshws	11634	16710	16710	1618947000000
23855	3NLbTjFTHW716AQCenrUk3HkD9f8AMJf6TZTrVT85sjAJrgwm3Dk	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	1599	1041	448	12463	15811	jwy4pe7P2zQGyaeRRT715kSRZWJgsEWTXMRYus7z3Ygt8rwQ4Aq	11875	16712	16712	1618947360000
23861	3NLFct35mqfAbMBi3YBeCqgwpWwNDCmrzvsGokWFbZV16fKYGpBK	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	446	446	449	12463	15814	jwLxJ6idvofNVFUqDUfcJmhPn33cBHixo7kC1A5EXHV9ZFgDRrV	11876	16713	16713	1618947540000
23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	23862	3NLdjBh9LbUd1TS1qyBjrwrqVbNrEaGJw82LPCGb7tEEbXLgAHAq	1407	1395	449	12463	15819	jwNYFHZ36nnTdKFWqQybncgR7bYtT1eZETPbEq2c7bgYsr1fbib	11878	16716	16716	1618948080000
23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1673	1242	449	12463	15822	jwsgn7XYQGG5pjZY9uwTSR8fGLmzoDPhvR4G8gLZUJimB25ZbBd	11881	16720	16720	1618948800000
23874	3NKW9GwiCtHAcAcCxjcboZfkQhFVwoqS6MbeMqXmUepcS19DENFn	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1406	1393	444	12463	15827	jwXrVqwgyCCngdVwbSQJEJAkD2wyR5bMGUUdEUAtht74tgamGVU	11800	16724	16724	1618949520000
23879	3NK3aVCgzHf5KE3oNsHJSxwYoAJLbEeurx3jZp7uvgkiGQFUX7LT	23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	1631	793	449	12463	15832	jxRjFnjDUPqzCW5mfoN8QzgZaJ5gXy8A3k53ic4BxdEdXzceAWA	11884	16727	16727	1618950060000
23883	3NLfoqxBE4NF2TeBPXUq2JuzPk7oPXEGuJZn8dBJnv8YYuFoU5tD	23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	1560	1291	449	12463	15836	jxmaeTYS6V5jQSTmNwGPR8bTJ4Vmdo1vT9oMQgo41g3KNcMt7gc	11888	16735	16735	1618951500000
23778	3NKyC5R5spSjo4cZL4xxXtUDu3zZhtZ8kaTGiY1wi4xVrWB2zmb7	23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	1406	1393	447	12463	15745	jwW96FuEuNvximUgTL8X4ibE1zvjpKKjcF8hFcJcRQp2U7Dw8yo	11840	16665	16665	1618938900000
23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1637	816	447	12463	15749	jwqPEBZeaBjefeRL1PWPUMszZ6dvwswvKGq3ymnqjKbkM5G4dPA	11842	16668	16668	1618939440000
23785	3NLosNiAFtY7QUkVbDsHy2r46wa15MofLp6hmdX25dHTwE3eJmd1	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1405	887	447	12463	15751	jwk9AnqdzRnxCzGDPkrdQ4K3wKTGesmVE1EKLokm8FiwFUAGqHb	11843	16669	16669	1618939620000
23791	3NKmX9YebGWWkkPrSvVK8Z18knvjJR2KMvsctNVkiDPF18u8oNWM	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jxhxCxgr6TDkdhwqcE9VynDc5XKgaoBdHuSkEqpkBwafpFFvP9n	11845	16671	16671	1618939980000
23795	3NLtyw5KHiMGQJitwFAPQ6soJZozM9jiFc7VkwRZ4j9BZuEUKKJw	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1654	1214	447	12463	15757	jw76rxswoi3p89wssmW6b3wGXmEFb2qhdXqNLCKCw3PsW5pfzLg	11845	16671	16671	1618939980000
23798	3NL73LMEo29BGVJnWYAxAshqjbXYnzjNZtfCbtU92HXKYN83Jw8K	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	484	1073	447	12463	15760	jxRz8pRSG2iT8VVWvf34Ezf3bHqYp9yZ3Sfu1jzqmXoqEsin6dZ	11846	16672	16672	1618940160000
23802	3NLTw6ji53MRLghhDgfV4SsyUx5sokeVMzPaV8z3qHWgKjnCVxye	23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	42	1361	447	12463	15764	jxdBQsVpLJjxMbeHPaQbwUu37S9SAZoKmaVuga5dZNqWxGk7xug	11847	16674	16674	1618940520000
23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	1602	1369	447	12463	15769	jxFGwRgLbrq3z8yTeaaAe21SN7PoXcxbxG2oxAQJsqsnE2EKpCn	11851	16679	16679	1618941420000
23809	3NKmJk7qY6djAhQdpUkhfaFN2cRT9LnXpKcmGrYhVzfgDgtUfmGo	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1405	867	447	12463	15771	jwUpSqrDruqXc5h1qGeDCUij2fa5t9WxaeWwVc14F4H6gsj6sDn	11852	16680	16680	1618941600000
23814	3NLZkj9p3kbdmtg3qtktmt5V1DhRSQLP6DGGF47uRxK8YmkmRW3T	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1458	957	447	12463	15776	jx8NTEFFDxighNfgynmr4VUjtTYYqWnkozbyJES2sKnZmmPHaPu	11853	16681	16681	1618941780000
23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	23815	3NKgzpNmCmzXkgGoXp7azqL3JvjABcLHkt44pdqyx474DbWHELAT	1577	1081	447	12463	15778	jxQ6ksPpnC8TWvKb4BG81oMUgz7KhVH7nz8RT6tk5abpA9ELfiy	11855	16683	16683	1618942140000
23819	3NLSnCDpD3zd634PDHKXx7EEfQBwPGJCRCmaniqnkKbq25BuGY8Y	23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	1541	1298	447	12463	15780	jxRtugzWBfK4xgTdcgJKoG78mC1CfhiZoWV5vytN51aaasfTTXw	11857	16687	16687	1618942860000
23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	1447	1219	448	12463	15781	jxiRFYs8CtCLXtMmfsNGHbcgN9QLgTrk14JNxK1D6XKb2c5AFyT	11858	16688	16688	1618943040000
23825	3NKQc5u2yZVFBbA7PjFxT34g8wqXvgZgYFpe14cGLRphp2jgWsEi	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	1447	1219	448	12463	15782	jwnWnpwQMxMfpt8z5MpK9a1XRKUH7ct1MZajsJAC94Wvr8CZZYr	11859	16690	16690	1618943400000
23829	3NKfVV4PZNJkmj5iaZhuLtCfUhnCc5uK56LEeGMxJgYXtJDY7S26	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1471	1140	448	12463	15787	jxUjEcdKzwWNUcMc7pBo8hRRcBpLxfXjjY9iQ89STLs1PXeH9Wz	11862	16694	16694	1618944120000
23833	3NLhWHii4BSjaGdnECtootZRQGtLWxjTqb4RmUEXW56jdTkjEGR3	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1637	816	448	12463	15791	jwrpof1qZFTdgjhnY2P79JAGvF4fPF6B6DHp1xgvgc7vm5WdzYi	11862	16694	16694	1618944120000
23838	3NLZFfcu45iLghNJEHu5sFk6MCmqdCjWqXWGtGj7gEWaqJpx6rpq	23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	1536	1187	448	12463	15794	jwRn1frnUopkn2dhKebG59cbqtGsDRH7jvaUHjCRGr4ww4hkxpk	11864	16697	16697	1618944660000
23840	3NK8mGzAfbFLRVCfTW1kxRD5vwcX3EikXywYxUVeScDBSfsG9mRR	23838	3NLZFfcu45iLghNJEHu5sFk6MCmqdCjWqXWGtGj7gEWaqJpx6rpq	1631	794	448	12463	15796	jx9zzVehZ4MnyukgHDhBoFB48MNZppw1mAWXdx3pZUdthfCqPJC	11865	16698	16698	1618944840000
23846	3NLYU4rtwj3QqB35xNu8myJAk4PoNZ3QmQM7rofyB2cXbfqG4q9P	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1585	1366	448	12463	15802	jwF9B9u9mZJbNKfmnuriUYJkqo78qq8NfD1bbTvXnMWyfd1qup4	11869	16704	16704	1618945920000
23851	3NKQHSa5H1giudNeLM2wxQbXYz8w1WpYYP8rgB9b5TvABHBt8dhF	23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	1407	1395	448	12463	15807	jxQRNcFhikFwXdyAkpYmTuKmbdvd7LPZjh8wiBD2dsLN2zJEpFP	11873	16710	16710	1618947000000
23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	470	1063	448	12463	15812	jx6nccfzCQLL2ZVtXiWsNXxiiuqaSPVSUhuYQxETdSpw8kiJ18y	11875	16712	16712	1618947360000
23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	446	446	448	12463	15814	jxGCYexxh4w3L5LCxoWURnKo1XXcLGTd89kDzbevqnDbyfEuuF9	11876	16713	16713	1618947540000
23862	3NLdjBh9LbUd1TS1qyBjrwrqVbNrEaGJw82LPCGb7tEEbXLgAHAq	23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	1503	1031	449	12463	15817	jx6Ams1sNbFNcMAQ64RVaPLsgca2KLuXh1yqpMfEkX7SQyMvEng	11877	16714	16714	1618947720000
23865	3NL2AGywJwU4aGDasTtTWni7BcY7GYp9uZTJxxkVdRTJPbCiFakF	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwRqDpD53L8UWWL1GnPQY8eBW6e9eJhTEwmpnHRq6yPELjJqtFt	11879	16717	16717	1618948260000
23870	3NL2j1eheevViyBhq4xgj6MUJ8cnvEKTn4SV8wW5RCeTXoUd8qbd	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1402	868	449	12463	15823	jwthc1nL6bg4Wve5yHVCvCV1qWWfde7r9s5B3oQg8D9XvYBKygZ	11881	16720	16720	1618948800000
23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	1547	1252	449	12463	15825	jxUSsdMu1XnpDAosf7EogFKUzXxjnP98nFQUQ6BNMG94naHV3Xn	11882	16722	16722	1618949160000
23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	1631	794	449	12463	15828	jwhfPuMgY7bHQuoRSjVhgFYxjzemTKTNqePDKvCxMCaA9xVcqSa	11883	16725	16725	1618949700000
23877	3NLDKJxTruxY9CeA56urH9av5xdDPXN7odw2JLxzWMyMyacmvJw3	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	632	1256	445	12463	15830	jxxxe9JrmT7tQJBJpP2yA2d6rH1u6YtuUHc98MZnswetiDEJLg5	11814	16726	16726	1618949880000
23880	3NLcSd5KxnD1N1MZj717hkrvdhCMNarjqCJXBHkcZrTiMd7qGRvU	23878	3NLvd8BgpgHh4UF4hGEC8khx7qCeFYFqvKtq6ZdsGmfcHtBHZBRW	1637	816	449	12463	15833	jwDVwjyUQdzK1zUWHciwiWYGeb4DPgn6XjPwbWwvgtDFnbLaMzT	11885	16729	16729	1618950420000
23884	3NLGMez9zc96AN1NKwh5Uuob9jkKMsAwfaYk5sYezhN1hYNf2MnK	23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	1553	776	449	12463	15837	jxMq6rhU4qTEw6BDsd96z3SEFqQkLHd24fbEC6QDVioSpZpGkpS	11888	16735	16735	1618951500000
23886	3NKgkNqWXHxFSVF2JgnZVmbnrMvzpNaseJ5kKsH5zF8tNaJuzGLp	23885	3NLBsj14nuWsG75Spmk3Crzcvt3PX9aMMyFp5vQGkVRmjHsnWo1g	641	1336	449	12463	15839	jxaFS9AiNG5dEmYUKja3XW8ydQkrsyFSuxMGQdma3WGYBGBUfsS	11890	16738	16738	1618952040000
23892	3NKPDXdBgb9z4q2nZ4VhLijREA7oekgoBHUexsBRU7CLCZeTUpfx	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1536	1313	450	12463	15843	jww71mBD1RtRarrUNg2xsbLsbgMnHHrHipi1hTgH5PRtQkjFsWw	11893	16742	16742	1618952760000
23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1564	1092	447	12463	15762	jxL1WFm3dFkbMoHfGYXq6NNiXVF9dxzr3g1nm1oPARi3j34MVRD	11846	16672	16672	1618940160000
23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	1406	1393	447	12463	15763	jx9MYtD784RKWdqCc5qyRkA2fscem4gC4L7967VNXa2pPPYEKa4	11847	16674	16674	1618940520000
23804	3NLNDzxu9MD78qdVvbrWLCGGZiGk7e5ANnXVQzpYXe2KNNvCEWw7	23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	1646	1354	447	12463	15766	jx9csCvb5TSdX1qFnaGM3tc3CaYhWJQkRSv6edYWZTBBHeZZYPh	11848	16675	16675	1618940700000
23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	23805	3NL2a3dZSgPCyy5yrL4o4iDLDDoKKnRufewNAqqt54tMBfhEvDsw	1642	1001	447	12463	15768	jwt6SjP3wWQqCdkfSAsRExLtrmxuyMUTGnAdWCdodJD13CZT2Tr	11850	16678	16678	1618941240000
23815	3NKgzpNmCmzXkgGoXp7azqL3JvjABcLHkt44pdqyx474DbWHELAT	23813	3NLw2g4NCL1YFVMSE31GzKpoMhVLvwmoS8fD24q1ik6PunvM6af2	1403	824	447	12463	15777	jxpP3tCaVxmd4RZtUDnbAV6RFFk1EBMsCDtDSQkGp7dtFZG65Fr	11854	16682	16682	1618941960000
23818	3NKgBB4QHXDiuYPnmNmJi5kFDAqLWSnY21pMMVzARcJNrxRqygtC	23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	1476	1371	447	12463	15779	jxRDH6THWDe7MPahWooTUtHqjKevWfQkGYBDzfdrbRiSLU7eSkc	11856	16685	16685	1618942500000
23824	3NK3wW56rk8FLjCLzXkUJhJYMhhhXKitc5Nes4PnK9nVmMtDkeuS	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	311	941	448	12463	15783	jxZsD4SvwGVHfje7NMz6w7P5DrHvKQCFcc9e77ECpA1jDdLEGG2	11859	16690	16690	1618943400000
23826	3NKYcfFit1Um9AwKRXC9QzCYAyYU2HVW7Lv1LnrfA6GzedTR5YW7	23824	3NK3wW56rk8FLjCLzXkUJhJYMhhhXKitc5Nes4PnK9nVmMtDkeuS	1403	824	448	12463	15784	jxsUbvb4aFYJgzDL9P9YGxbeh6fMHzgAwKoVo1mXBwMeTyRTDSY	11860	16691	16691	1618943580000
23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1560	1291	448	12463	15790	jx4ZPGtQZaKnggx4SqSd5nQWWtp1pcNAGA7eCmtFgS21ip3HrLJ	11862	16694	16694	1618944120000
23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1500	1297	448	12463	15793	jwxzMAxaVeCKmFSXyJwygPVGKFGfmBuTUB1echdUiwQhdjf32RK	11863	16696	16696	1618944480000
23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	23842	3NLdYhtsDkGk2Dw8VcWnHUhkUayTbZWViVAvW3Qn9876vgVXh6HZ	1642	1367	448	12463	15799	jxsJrnJ41Ne8FyAfr2cEDoK6ugWNUvdUGkZkUKVwto4C4PXULRH	11868	16703	16703	1618945740000
23848	3NLPcaVBNfAfr54FtLZwxVrxyAQUdj5FskKukNTAs9GXRKEeyV37	23846	3NLYU4rtwj3QqB35xNu8myJAk4PoNZ3QmQM7rofyB2cXbfqG4q9P	563	1233	448	12463	15804	jw7fsEXwLqKaB8ywMgFkeCXnmCHV1ZtXtxKTT14UKfrpfwLgbyL	11870	16707	16707	1618946460000
23860	3NLMeiAoRnfMpuWDVudwcX4ZAya52C7FphbMSVRX4SKioc12CpD1	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	1553	776	449	12463	15816	jwRQYysFARWJAm89FGhqg6smpUuZH2MTp7dbiXuSdnwjY2sPY6m	11876	16713	16713	1618947540000
23867	3NLMx6Lr1uXPAq2zjsZUBgHNAG96eiwsTSna4E9Ea61ESecQ1kGn	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwVGfmRMpDBV3b4XLeLFNsDK48BSitApXnyoSyatZZg5eM73ouh	11879	16717	16717	1618948260000
23876	3NKZJHZJZftwtKJcdpCrh9VbN6tN4miVUeoQ7xeDjda6TEKSmrkp	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	632	1256	449	12463	15829	jxuXCkBc8Eu7rpxSor61J1JjyPeEkad5XEKmzkxrzYFgdSGZ6fW	11882	16726	16726	1618949880000
23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	23881	3NLF296ySkawQdHmGLpgt1io5e8apajQhQy7YEa6eb5JeU2sWthz	362	362	449	12463	15835	jw9exUFfZADY4tQWur1a9HmCmGzTyoEjSKywjt9XjU4p3G9Vr5j	11887	16734	16734	1618951320000
23885	3NLBsj14nuWsG75Spmk3Crzcvt3PX9aMMyFp5vQGkVRmjHsnWo1g	23884	3NLGMez9zc96AN1NKwh5Uuob9jkKMsAwfaYk5sYezhN1hYNf2MnK	1633	1024	449	12463	15838	jwXQuHTPb5GajKfQPkgo8s7Njzfd8zzRLhL8rDrqXFHLhTyKwJc	11889	16737	16737	1618951860000
23888	3NKtHd7SidCddA2PHyVpVwjz3ZMDcebRhgi1mBbikpEaQyMVaMXr	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	633	1138	449	12463	15841	jxP88xEY9EWD8PxUK4fSvTT1K7HvGv9RQkvsdSQY4dz5a2ztKYK	11892	16741	16741	1618952580000
23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1577	1327	450	12463	15844	jx98mkTKL5RgrmUcq6FddmyBRURPUVr5phG39gVUYb6N6A3bboH	11893	16742	16742	1618952760000
23896	3NKnrYWTtA99Laj4Rieu4aHCAB8pdzzGRKRg6YDHgivSuwyNrqcu	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1490	1148	450	12463	15847	jxN9NNt3oqZV5uc3eYmcFMa93ZtT3QGCTW6H3eHaoWrkddDaN8t	11894	16743	16743	1618952940000
23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	23896	3NKnrYWTtA99Laj4Rieu4aHCAB8pdzzGRKRg6YDHgivSuwyNrqcu	1507	914	450	12463	15848	jw7YrjgkB9SyYsTGpehFKyxqCewJMZyA6A3axRa7JecVF1yABnU	11895	16744	16744	1618953120000
23902	3NLwdEuRNjDMpnPkiSXM8r7vzMbVnbvJM9NZtF8rQc2J23WVgUE7	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1648	1038	450	12463	15852	jx9wjk6UHLFUiqwa72n2Cz7BGBBoG8AFbtcW4yymx6mpVsYpthb	11896	16745	16745	1618953300000
23905	3NLsddWyCaLDiBtrYawBVivptYWGNw8WfLF88sZZvEvgnJHChMm8	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1489	1380	450	12463	15855	jwyZ1zNErACxm4skV33KUKrkS5kSSTSGNqvNKb8zPUdvQ1FPVtL	11897	16746	16746	1618953480000
23910	3NKdCqyodH42r8EEVin1zcKS8quwcwJ4ihMKxu9w1GXnjACvPvE7	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	1534	1191	450	12463	15857	jxC53kGas74Jvd7XHyEXTY4rxS7UuUWXVtc8ec6xqBWERLp8uqp	11898	16747	16747	1618953660000
23918	3NK2yYxKqBxDyVQksjCLzWziuHvAeNxDjoj4YdkDaLTCS8sUFELV	23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	369	1066	450	12463	15864	jwqfWen53fQ89R8zJf4ZGZcb9NoVhqAD8my4AaQff9kFqhuTuU2	11902	16757	16757	1618955460000
23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	23919	3NLFqhPGjXRx6sF1fRBErjz5sD7V3E4x8vAjysJW98AG6FpEnceg	1675	1096	450	12463	15866	jxjj2jCSvz47rWQTKDckNf35cSfA3Ad4CQoMuM1H2d5mUBW2Whg	11904	16759	16759	1618955820000
23923	3NKBoowXUcCQZfG4KyA7Hdu8Da21zbBQFxRWdnZTcvZg5SjaxSyY	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1439	1033	450	12463	15869	jwZQ9uEFck1Zqbgf3ZeLQXFwvFKkmhAUcQWeggGU9XgJcDvYs73	11905	16760	16760	1618956000000
23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	43	944	450	12463	15871	jxp18xUuQxuFcxASdDqdxsU3aNBLdAqmASUCyPiJX1xePByebqT	11906	16761	16761	1618956180000
23927	3NKKMjG2jS3VaxDJCi5dmgc7pEkMDafamA8qq8mgeNAxkAHeeZcj	23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	532	1303	450	12463	15873	jwmkssZG9Njfto4vZ5pR4wq8ooaLfkDGJqcxXsmum9H9i25hTWZ	11907	16762	16762	1618956360000
23931	3NKYxGH3BLuKTQRx1XQfqWtF6RVr22xr36McAAQmHJomLmbvrkb3	23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	1668	1004	450	12463	15877	jxxTL6WMuxFqKXABiJxYY1wUThKBqcsZBtJF86ZHwTw4yR6CRz4	11910	16767	16767	1618957260000
23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	23931	3NKYxGH3BLuKTQRx1XQfqWtF6RVr22xr36McAAQmHJomLmbvrkb3	1477	1104	450	12463	15879	jxoZu33rVMJ3qxuW9FvsNamnqcm1dhXqUH7UnR4yKUNp27xSC9E	11911	16768	16768	1618957440000
23939	3NKE4J4i6oUgLutcJpqMibncM3RSjcCrgtCZEA5LfbfFJkXU3Uqd	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1471	1386	451	12463	15882	jxPEVvjxmFHcgYiM7yAUTNzety2KqyRAVxUmfSs8f9qhJgWacy2	11913	16770	16770	1618957800000
23837	3NKuURKXsJHPqG5REg9BtSBnsfmY1xQggMzzPW6iEjNR5TXZ6Tdz	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1500	1297	448	12463	15793	jwf6x9MKnzqpwpwjFrBVcGfW4FgybF1tpcb2tQsy4UzPRJ8WTKz	11863	16696	16696	1618944480000
23839	3NK9oVuyL1FJiooz3VLz1xmK19khBvDc2NYUFJqoTS4EVMqSBVbi	23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	43	944	448	12463	15795	jxUsVc4432MYYkCUZTmBSeFGo8inQA5i1Wt5jc3WgunPRkf28hJ	11864	16697	16697	1618944660000
23841	3NLMsk61J6rKe4erdMuMdvDAm8JjTubuoKBQ8hpZbio3dJRgVBvE	23840	3NK8mGzAfbFLRVCfTW1kxRD5vwcX3EikXywYxUVeScDBSfsG9mRR	1642	1241	448	12463	15797	jxyd6giKp4h7YvoAsZ2VoRbf87bBBTJfqUCgjxNwRmWGrXHSXda	11866	16700	16700	1618945200000
23844	3NLmx3S5cL5K8QVgB4SK5q8regR9ms9gUT9dKQBYuDf6YovHi7QM	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1406	1393	448	12463	15800	jwevZ9W7Qyd9S8urddFgLi5CKLJRVWicPffZsbc7dfDgXZui3bE	11869	16704	16704	1618945920000
23847	3NLwZbkTYZsZN2tGhFzN2dgXM8wZL2XJirvDP8HupLYvKZ1qn3yo	23416	3NKUagUSNesemRChmmiwL7vr51sVG3w4tVGz77Nm3DH4ppGnF98V	1457	1145	438	12463	15803	jxiVrARCC8J9o3pyP87pysnZ2E4QBmpSXJZwC7hhj7ke32Bejho	11673	16704	16704	1618945920000
23849	3NLBk1mZWgieD1yNSVKbhyUCL6TrMCSV4VuVgzkpZou4qyVkVZRS	23848	3NLPcaVBNfAfr54FtLZwxVrxyAQUdj5FskKukNTAs9GXRKEeyV37	1536	1067	448	12463	15805	jwXGqzkxSAL58dedBwDYAPpRUtJN6WeXfm8htG5bHhDo2WyZT7b	11871	16708	16708	1618946640000
23852	3NLrYuL9TYZSkn35aQH9xPJFCbisaxiUEfGLpe6A2srHcvJxGUsc	23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	1553	776	448	12463	15808	jxHVZ7sw5Jmo5VC1pjoepe9cAye45tFT5Q1Lv1rSeisEkov19yw	11873	16710	16710	1618947000000
23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	23851	3NKQHSa5H1giudNeLM2wxQbXYz8w1WpYYP8rgB9b5TvABHBt8dhF	1402	796	448	12463	15810	jxUh1tGJL6PEJK9eGprqda8F9whN8e282xvxPBGUzsgbw7MVSxg	11874	16711	16711	1618947180000
23857	3NKn52a9VPX736RkSd4rBd3PWmTGYJwWgycZGyYg1pzB2hg4n4ZE	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	1577	1327	448	12463	15813	jxCoYZwmU7KWiKZC86pSKYCux7VVywDMuY2osr77MmNkD4p8fNe	11875	16712	16712	1618947360000
23859	3NLUc2PS4TEPzqNLUSynEY2rDYhRVdKifXJKjA9RJnGEHYuFqhGN	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	1403	812	448	12463	15815	jxW7pVZeAT1eKmov8J7HyjcovPGkrGgpvnRyRCwH5gnzvysw5Bi	11876	16713	16713	1618947540000
23863	3NKYU94KNns2FR92RsCXWdSB6xkm8jqm4QawAq1evpVCXAYeAJL7	23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	1403	823	448	12463	15818	jxaNGrETydNQnxPNSmNthBewVbFDTwTZFN24VRec8LZUYnfWphL	11877	16714	16714	1618947720000
23866	3NLGjXkEccDLP5qYHTMMPfMmA9BHT2xZE1wRPEectqjvqiD9M9nz	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwZ1fLAyHY7o8wfz6Wee4WM9wxbrgM9fZRG1Py3zgLdAF35ppWd	11879	16717	16717	1618948260000
23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	23865	3NL2AGywJwU4aGDasTtTWni7BcY7GYp9uZTJxxkVdRTJPbCiFakF	1654	1340	449	12463	15821	jwcyWKCGhrJT5SZGCyvEPyra7TJv5dgm5V3Lv178HXvya6dRyGS	11880	16719	16719	1618948620000
23871	3NKPksFGjY3gSra28hEhz9fqeSysJxMf895dJnHkdUBT5wfzWYn2	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1458	957	449	12463	15824	jwctKBucMF1q5gghjDEbtV8WUpX1SA9mXyMQh6sEKWJZ9TjCjY4	11881	16720	16720	1618948800000
23873	3NKeKBwEVeb5dcMJohBCdCrSP1McX9mHk64wq311v2c8VYhPjiq5	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	1648	918	449	12463	15826	jwcLjm3q8Q7pZMAjrJFXYSHBLHi6EPpGX2PTKA9jQcAeUmXHPR3	11882	16722	16722	1618949160000
23878	3NLvd8BgpgHh4UF4hGEC8khx7qCeFYFqvKtq6ZdsGmfcHtBHZBRW	23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	1406	1393	449	12463	15831	jwL2hLZPMMyyhVZy4jYrvMH3428rwaQt5houXZoZGVkE1wY1iaz	11884	16727	16727	1618950060000
23881	3NLF296ySkawQdHmGLpgt1io5e8apajQhQy7YEa6eb5JeU2sWthz	23880	3NLcSd5KxnD1N1MZj717hkrvdhCMNarjqCJXBHkcZrTiMd7qGRvU	1447	979	449	12463	15834	jxfAa8e9vqBt2CYKmpTGGq2NBLfnAj3itpx12vjzjpqp9FeGuWk	11886	16732	16732	1618950960000
23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	23886	3NKgkNqWXHxFSVF2JgnZVmbnrMvzpNaseJ5kKsH5zF8tNaJuzGLp	1407	1395	449	12463	15840	jwd7osuW5rYyT3WXhfgTJLrgX2x1DJCVRv4KVa9Y9BueaevtzYG	11891	16740	16740	1618952400000
23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	1601	1022	449	12463	15842	jwtoXSqABLNQu2U91mxpxpt3f3he3vdEBarc737bcYKwD9NGnsN	11892	16741	16741	1618952580000
23901	3NLWsi1cyh2pWyWJXP6AKagie2yc12Hn8o8rHXcYcdKqTERgA4ud	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1670	1036	450	12463	15851	jwRvXsUDnPS7Zgc3HoV2GkvwraKdL9JYXzEDH11knexro1gjtf7	11896	16745	16745	1618953300000
23904	3NKKEfZvYsv7eCG6uuaJWrcpHaoDUTysYQ9EcTrmg1Cr5fEJTrLA	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1402	796	450	12463	15854	jxo3XnDVhJytwbvaDUFac5a1FBxaaj9QVTMkXtMNG3LrV5KSSaj	11897	16746	16746	1618953480000
23906	3NKxTV9x4aiDgvag9SLidKCVUXC9PakarsTEWaKd2cN8C1VFFisn	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1489	1380	450	12463	15855	jxYkPwUAgV431nBvWBVvWYbtCvhC7a5FEUkLuW8eyY7fdNh13qG	11897	16746	16746	1618953480000
23909	3NLC5om7sQvkyPJAtLyyiGMyBhGxWetAwXPDvSRiM8Z16JtUDz97	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	58	1281	450	12463	15858	jxwz2Tp92SWPijEJs5n7hqp5fJj1H4RqggdGA6jnEVFa5nEHLZ6	11898	16747	16747	1618953660000
23911	3NLvXbsxsXmiuNvEhRXDEHtC9dtmG4rmgjTwu6DzQcseJbY17g15	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	58	1281	450	12463	15858	jwSU3jhD5ccoLfJs2FNyHJxPntP4FvaAEUn52N9Wq623FTfsAjy	11898	16747	16747	1618953660000
23917	3NLrbQ1oinBmhbGZLkwU5b3RzjD7AS3U7B5KAgLSxFhGCP6e9qUu	23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	1599	1287	450	12463	15863	jxZhJ88g4V6EsYqEk6MdukyuZ3u5JGC6ZFSa2Uq17QVjg8wHJ4a	11902	16757	16757	1618955460000
23919	3NLFqhPGjXRx6sF1fRBErjz5sD7V3E4x8vAjysJW98AG6FpEnceg	23918	3NK2yYxKqBxDyVQksjCLzWziuHvAeNxDjoj4YdkDaLTCS8sUFELV	1646	1228	450	12463	15865	jxBFfGkEQyNhbPkt5Z7keRqxDrEhvtDofsbjFebNR2nCVcaKsuc	11903	16758	16758	1618955640000
23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1546	1093	450	12463	15868	jxxRycBwNigLKaaSsTe8J9YV4MXXqhAywz1CDXntjTfjb3wih1T	11905	16760	16760	1618956000000
23924	3NKVdDg8aFzqSGRrAEJHkrumskHSuMQi8aZHVPyPE8J6LQDvgwwq	23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	1407	1395	450	12463	15870	jwPA2shBJBN5m466YxHUvGZP1eACBbgnMj9RNoRWpYKnAruj6q6	11906	16761	16761	1618956180000
23926	3NLaRmWKggThociur2s9iXTjqKKrA8B4VmjRBNX8CrQZKM8sHqMp	23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	576	1355	450	12463	15872	jx8xEQprAhMFW5QXwCmdirXn6eket7oJwRZBy9qsS3RAdfVppAh	11907	16762	16762	1618956360000
23929	3NL2mUv6fuzdVTDjihQLbXS5RoihMwhBqbmtdJtTgSVHP553S9Bt	23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	1406	1393	450	12463	15875	jwwvPL1eJwDQ9tLqk7bX9w6Um5Rbg9Dwqq2GzFiAfAYEiTx7WBD	11909	16766	16766	1618957080000
23932	3NKTfLGNyUUnVmNtdmjGWCDXWQqsVTh6dA4PVrKu2wF4QY73V8tE	23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	1483	663	450	12463	15878	jwJJszZ173jrwTUhg1FGVPravuTYGWmrscP4ZS8jjRxa2pTEMFc	11910	16767	16767	1618957260000
23934	3NKyip5qTLGQoidXANxpB6yx9WFq1NVggQRytACU9X1bgnnqixys	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1581	778	451	12463	15880	jxJQLoc9pPFm9uJRxXudtnkANBDDihsLKAZ7Uo77H8HzBxiAwSk	11912	16769	16769	1618957620000
23889	3NKFP4jftzZUSU8SrJS1Ti1zHksXwEZ7S8zzFLXLr1kGroqGWw3E	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	633	1138	449	12463	15841	jxP88xEY9EWD8PxUK4fSvTT1K7HvGv9RQkvsdSQY4dz5a2ztKYK	11892	16741	16741	1618952580000
23891	3NLQ7G9dJCmhtb1YyeNGHcsuaGeHPmSNAYwQbMhURCYyQfk8enTJ	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1536	1313	450	12463	15843	jww71mBD1RtRarrUNg2xsbLsbgMnHHrHipi1hTgH5PRtQkjFsWw	11893	16742	16742	1618952760000
23894	3NKrwwHV1mA4nNTXdbEDgYQnF3iQhifMKP4TTpobyD6BJyKn3mu6	23889	3NKFP4jftzZUSU8SrJS1Ti1zHksXwEZ7S8zzFLXLr1kGroqGWw3E	1559	1227	450	12463	15845	jxn8w3A9i9RoxTANpwBYmMZ1yLWm5Rico6aZWJ7xVuCRyMuffSx	11893	16742	16742	1618952760000
23897	3NLFNPaQBACCoEsZ4sZEtyNTaARfCV5tkdgNmhAkiKeHqL4Qt85w	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1490	1148	450	12463	15847	jx95QxNnF5gxy27JNaqg6XmEKKedCAWWX7jVM678NhkPc6BVxqN	11894	16743	16743	1618952940000
23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1673	1368	450	12463	15849	jwfCZz9RRrj7zsfdcKWSz8jDZSG4Ywbhds3r4quu2ozuvdBKDgZ	11896	16745	16745	1618953300000
23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	23901	3NLWsi1cyh2pWyWJXP6AKagie2yc12Hn8o8rHXcYcdKqTERgA4ud	1585	1366	450	12463	15856	jwipkwEce7wU15Cd2KjxFGzfjkUEyWdhG9rpTDezxfiKgJft8yS	11897	16746	16746	1618953480000
23912	3NLQWBQLXBTiUEBpFvroW1arZeLpKxeHx66a2vGnn3XVzBd7qnB2	23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	1448	1311	450	12463	15859	jxCdxZvWLMd49T8nFQeXnvDczbKXptCifV8yogdyhqrMdu57DVA	11899	16749	16749	1618954020000
23914	3NLXVCkemW3GFh8zNLYVt7dx7S7HMyQ5ZthJRo2Fu1NFrqohuaRz	23912	3NLQWBQLXBTiUEBpFvroW1arZeLpKxeHx66a2vGnn3XVzBd7qnB2	1588	1392	450	12463	15860	jwBCzFRidpwRsqVDm5iNZ3QDBsds4t6SzhDkeN4HXNrbH43Nfjg	11900	16750	16750	1618954200000
23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	23914	3NLXVCkemW3GFh8zNLYVt7dx7S7HMyQ5ZthJRo2Fu1NFrqohuaRz	684	986	450	12463	15861	jx5XtNe4nG2u7pcjLxY2teRdCUJw545k89Jjf8W1ZTHUPBuR2KT	11901	16754	16754	1618954920000
23936	3NLg34SdZnb3oU2mT5dfLDWj6ZybxpbsXKYyy25xLKVYjWpTZV9x	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1590	1300	451	12463	15881	jwM9q4AZoUaoNq5U5NLkoS5eb8iXjXRf9diivTHgWdFvSKJKF4E	11912	16769	16769	1618957620000
23938	3NKcMg3ZnaS1yjdeDxQzQSTt7YeNFhqLXtCda2kaHMibA2Ts7oWF	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1646	1228	451	12463	15883	jxTngHQB5RSt7GST3gsTLgpe1vvdBx8nhgtdF4FLXYhjWvMn7oX	11913	16770	16770	1618957800000
23950	3NKt75PbumixsWgzArJc1ToHiK2Q4BEzLd3H3vWXHMQyYbNN3uFX	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1617	922	451	12463	15894	jwvWgsnDFXYzgn5nSaoV29RfuNDxt6XiWxAcydUveBgnGWe5Rp6	11916	16775	16775	1618958700000
23951	3NKM44oibe8HyPFGpBYT5Yd5FCakUK6H5gPRGFfBvMNtXH1EBqRA	23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	1624	1334	451	12463	15895	jwvnC6i61pgaTpJGZiaXzMqqXdvA44HaNZys16K8fDxHYscnLdZ	11917	16776	16776	1618958880000
23958	3NKuUtdUC65ZYNZNbLgv2d8ZSnLmqyv3DgVTSc74q6BdjkY2L1JY	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1560	925	451	12463	15901	jxFLu9WkAmb4mUHH8n49BfSRfNb4YdrPDLXtd6o6QWk2NjgWnzj	11920	16779	16779	1618959420000
23960	3NKj3Fx67HwPLyUnapCfp7mbo644zMvJdcMK97RNhR2cHPX6Lxjr	23958	3NKuUtdUC65ZYNZNbLgv2d8ZSnLmqyv3DgVTSc74q6BdjkY2L1JY	1623	830	451	12463	15902	jxv64SQttLM5DRPn3DovmV18MozNZUsB8Vkk7qKRnQZvmY4FBJq	11921	16780	16780	1618959600000
23966	3NKGTZ2ZEypjweBQvCspSjvzWLHuW94zbK6WpVT3EQ3BFFEoQwEx	23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	1590	1174	451	12463	15907	jwXxsRzimHBNMw4Po4GWRyZqYMiUwTy36xpTcmghwngSacLa4ak	11925	16786	16786	1618960680000
23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	1406	1393	451	12463	15909	jwQRTK1y65C7BgDc1ZumJZ2ZffbKBxPozSFhQthyZVXrTFACFck	11927	16788	16788	1618961040000
23971	3NK3Winx3FWQML9r3wJ8b6C72atRtR7MyKMQBd1FMkNZmFHGwUqS	23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	1407	1395	451	12463	15912	jwJi5kEHKpmQQk54jxWgWVWKUWKk3f4CaftkVBP3xot3s913AEZ	11928	16789	16789	1618961220000
23973	3NKwbc36K4eMNCmmoz5x811tBSXWyVE6yLqNgpohL7i4gbQdr3nC	23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	1403	823	451	12463	15914	jxuGXuz2qwvApR9AyybJHks7btrcwW7VYbV1nv1V6DxM3StUFxA	11929	16790	16790	1618961400000
23975	3NLSwqmk5H1dUYwQcemPGGGr64P3z6jcejv5eztNXBnUo7VAZJHY	23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	1422	971	452	12463	15916	jxVzy7dxJxRVTAWvmVqXixTGx8cEpkLgVHB1Yo6FNHE2i8FcmTu	11931	16792	16792	1618961760000
23980	3NLYthha78PRaVdgarqQDwDikBLRgS5biW3cfvvJq4BLqP32Dqoz	23947	3NKXJtG3JbW7VbVZfuT2iBd9rnwNM3b1aCHHm4xDvEm6in1P8QFb	1500	1051	451	12463	15920	jxwRRaYg9PkfKKGrti9NwLTVf391WBYPoGNUa2xwR22MU2EA6jq	11916	16796	16796	1618962480000
23982	3NL55Fm5iQUcsGyjPAoBW9km1NW2JnMZgjNBWY1HSUecLEkivvEP	23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	1500	1051	452	12463	15921	jwvbi4byfxJjxr1R4y4JG72QraiaHxFE7PPgwQbTHLn1FfeW6z7	11935	16796	16796	1618962480000
23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	23985	3NLpYtVmVY8DEWfnKEoGvga5cuvBzDfdGHoVZbwnq9MwULTt57bf	1426	1364	452	12463	15926	jwtnMMpch3DMN5HNPNsnv6yqUdiWkT3zw3KeyxFgHxr1gQpmWUB	11938	16799	16799	1618963020000
23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	1622	1356	452	12463	15935	jwiG4Pk6gC5BFJPcAZzSuvMm2evKDJDczSSQ4RyUJS6zRfHDLJB	11942	16803	16803	1618963740000
23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	1589	1286	452	12463	15938	jxmucMNtVxLpUGmBR9TvuhXbNiouAn8jJ4oCBxrSYtAoNxgFvot	11943	16806	16806	1618964280000
24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1623	830	452	12463	15946	jwwU6iLqzbM4AD4VbeBuxD4pBi1FF9AQA6SXb6ZFfnAUWapDpKi	11947	16810	16810	1618965000000
24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	1406	1393	452	12463	15948	jxqh1CEhczhHzyXUENvP3cg7KpQmku4qEpeGbL55rGEXc7zsv9Q	11948	16812	16812	1618965360000
24013	3NKUh7whZtFCq1PsXcGRnSpksGFQNNVFKrAoBX2xeyUMew1f2o9T	24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	1637	816	452	12463	15951	jx3F1sUZQaxzJGWPqyCKm8WUZkf8u4PGFQLDwM22fk7GKY4rF6N	11949	16813	16813	1618965540000
24015	3NLYDjGM6CHSgHmH8kHWk96ja63YjZHpivgvbe1sJ2i7oAgG5Xcr	23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	1534	67	438	12463	15953	jwApZJGH4aL16esxeUS9B6amRseUsAWuzALNZJAJkx3JN2y61PK	11680	16814	16814	1618965720000
24017	3NKPmsnEvYEDLoEMTKnKLhZonq28ye1RqZLbab5UsNoULHtakCEG	24014	3NKdJ9dHd6J9qJNZoUPW21hAbzvWpygGXgW2UrtZwkT47S8uQq7R	1571	1335	452	12463	15955	jw89qgnfEUae97CTQsiBQj8u4romP7rbjcLFE85CXenjFNR4hTT	11951	16815	16815	1618965900000
24030	3NKYC9k6DRPfUzFMFLvjoNeEdi1C8rstn6wsdW9KRbs2r6aFN4ou	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	1637	816	453	12463	15965	jxX87PbvU4rR7F8NZ1C4qMJyFxvFzP2THLdQPDptDq7W1r3FBy5	11958	16823	16823	1618967340000
24031	3NKoRjt9ErnPA9A9Az5NiNMaRc79XMCHVnukyBCPGG5W3pADv4TX	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1642	1367	453	12463	15966	jxRe5CwVM1JUDv3X3k3m2Q5ap8SDAHt445fRExV6MekHVtUyVVo	11959	16824	16824	1618967520000
23895	3NLA13UQMJUwRMrFFWszA8tbVCzb8A2ckd2ACeWKVMBAzRw1XYDL	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1559	1227	450	12463	15846	jxe6uvYEfQK4rSBxpWKTtaxWVpVEaGtrFF4CtV1nnBKXNdprq2v	11893	16742	16742	1618952760000
23900	3NL9s3u69x5erA8Vzy5uTk2k3E36iDeZrWEUmTLuy81n5G65E3Ty	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1607	1348	450	12463	15850	jwx3rzzYtcr4ydp4k3F53r1rDCwJaCcJ4viTy8f7XFsUXAw5ssD	11896	16745	16745	1618953300000
23903	3NKwDbBLpNNfiBXNusVqgN9eYX5aADZ9hZYGGnVWtwqgw67J3VbJ	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1419	814	450	12463	15853	jxZuTfmnt95AvqL6g7Xsi2zNrsi8Z4ja42EubXDjUeLRCvRuzv8	11896	16745	16745	1618953300000
23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	1534	1191	450	12463	15857	jwASxx2rNreeHdaRqWqHg6eUN3aC2heCBPJrazHTV2iE3fkBSfb	11898	16747	16747	1618953660000
23913	3NLRQ6R3B2sR4TCSSBFbusRgnLYu9gEZvnLrxXB6xnddZMwG9VYc	23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	1448	1311	450	12463	15859	jx59mPCnXgMhd8H7gMqr5yRc9eXza8RDD7jUzCvAENXPBvg71uR	11899	16749	16749	1618954020000
23916	3NKy8yYtkyVKP5oTVzCiMKjmpLzduVZ1SASnQtrbDPhbYGyh86mM	23759	3NLMPTecUvnkn45vsTNDkdDejmoTYvTxRDS1GPgYVSYq9TTTB5ta	1455	1332	444	12463	15862	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11755	16755	16755	1618955100000
23921	3NKTSytieUZ1kCGajoD7qg16xAqMvShWZyvpJqTfDoSb9JXwRAsm	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	684	1352	450	12463	15867	jxG74u7BsT2Q2mFNQktXoYKJG1bxGvsrq4TLP1uguWXtbvVM33s	11905	16760	16760	1618956000000
23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	23927	3NKKMjG2jS3VaxDJCi5dmgc7pEkMDafamA8qq8mgeNAxkAHeeZcj	1600	1372	450	12463	15874	jwEx12JYAuvbKxjxVCDrngLh8dVDGW5nVdkCRLmTCuBd3k6HE78	11908	16763	16763	1618956540000
23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	1671	999	450	12463	15876	jw8sTiV1xgTVH6HcJ2Pod5cz4dWpZpBtb71QrW2x9ZBkFFGcgPu	11909	16766	16766	1618957080000
23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1590	1300	451	12463	15881	jwKjy7vttodT6dJqwSBdL6kWsN3L44hatpSU75wnwioUCLA9Se4	11912	16769	16769	1618957620000
23937	3NLkju7PQ1wPz2SMAEQV84tRP1iaVqkLLhm9cEp1Zp6yKCQ52fqf	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1471	1386	451	12463	15882	jwRzrLvTXJqSQ6HXU9UUxQLLaWZSQ3ovfzVdVPJqx8nYwxkC91P	11913	16770	16770	1618957800000
23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	1560	1045	451	12463	15886	jxTGZgY3kVMj5DEVhzcFQAVADgpPb2PdyE8ssNYquyzcinWf5rK	11914	16772	16772	1618958160000
23945	3NL3frwNJAgZTrrLhjBzTBLHZWEw51gQ8CYeww63d8ffRYVEmbv8	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1405	851	451	12463	15889	jxzoLFuaKGEonDa5P2p1JYToEBrBNGPU47nYBpaaBCozEcv1Enj	11915	16773	16773	1618958340000
23949	3NKnyVNAFczjwq18keyY2swBkkLzZUu9ALe6GiMKhUHJrTbiainV	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1607	1348	451	12463	15893	jxRVESF8bwNwUZYdqsNVK7tNPwg6V7HNR1XEFvpCAggJsSCBzEk	11916	16775	16775	1618958700000
23953	3NKN5QnWLFcKCzB2qmMxB8JWeE9FdCag1xfS7JvPd7YkoV1PSBWj	23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	1447	1345	451	12463	15896	jxRKP4zARSHXgVVE6wpFuhYio8qVvWg1FKCVQTZwWvNprh8BMte	11918	16777	16777	1618959060000
23955	3NLZVi7YQZ6D89YHMwVkRoWY83iVRzEz9wWdRQ4uyC9PExeTmyM7	23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	1602	1369	451	12463	15898	jxby9pwEg2cxSDjmaRyBzU2ntoD5AtyQuQSk8gWy27a8oyoGLwh	11919	16778	16778	1618959240000
23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	23962	3NK7JSkpmhfDf2vcx1VSMxM1wPpecLVPwQBX25t3poKVn3btf911	1593	1346	451	12463	15905	jwB3JB8bnhcVLhcgQCrB5Sd1uVFYTR8QcXeEHmRmmWyNBzvTXcG	11924	16785	16785	1618960500000
23965	3NKjywnhdVv5KrDvpZ88jtd92BhUE3Wc5YEaT9EPm8uRpa2huUjG	23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	1590	1174	451	12463	15907	jwVLVWef4tyJWiZmTsy953PdnACAoombEYvTk8zh3BFdDt1w9To	11925	16786	16786	1618960680000
23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	1516	1168	451	12463	15911	jx3aEKHdkaszZqHZb3jBvZdSUAD7hpUPheNx15znSdvP8fa2Psv	11928	16789	16789	1618961220000
23972	3NKMmmuteUvNgQTMRgY5EiFUe9svSsvUtwRHX7iu9K5vFYTWfmk5	23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	1407	1395	451	12463	15913	jwg3uXmNefKgNwMsxd4APc1LAQZW4gjvDwKS5V4LVSctLotpmUt	11929	16790	16790	1618961400000
23977	3NKzbvdZ8CR8EEBcKggqpb5gyaj3WeuaaZiRwqzdPDHPwvjkrVJz	23975	3NLSwqmk5H1dUYwQcemPGGGr64P3z6jcejv5eztNXBnUo7VAZJHY	1672	1285	452	12463	15917	jwju4YgqTyK7KhPT53UsKfWdG3vsE34MhsJUz8qGgoTFb84uY6V	11932	16793	16793	1618961940000
23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	641	1336	452	12463	15923	jw74Ej3ghWvgRLg2TaUs7R5Ac9CRNwhKmB9EbxoB3SMHcP3SAFn	11936	16797	16797	1618962660000
23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	1642	1121	452	12463	15928	jxZNPdVfBaojkwLXNYXj9cv8LZZEabT3mGato7CfLohB7P2bZfo	11939	16800	16800	1618963200000
23992	3NKrAgqRViHQ9nzQireSdAnqkJgedRYSbPv9jnkNpGnD7sXtbMVt	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1403	824	452	12463	15931	jxG3SwZ7bDWYyDCm6e4x71aL65azoN9EKtEizc37zbAUbkPxF9j	11940	16801	16801	1618963380000
23998	3NLoSsHbEUYPcPuB95XnnioBYXzycnA2wGZfmzmVfAVFNNLG6oT4	23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	1670	1156	452	12463	15937	jxPuCwXrfuakxrcYMo9xv49qK9WUrTj6udytNtv6iqysvP5QKL6	11943	16806	16806	1618964280000
24001	3NLMTEwY3MJeyuXmCpnGBYftVk9WUDUNKkXptkqFGvGmUpaHgj7i	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1607	1222	452	12463	15940	jwKxK5C4BLYNgpWBKJKsQByq9HXE4d3QnUMXB7D4fgm6GiwGpfp	11944	16807	16807	1618964460000
24003	3NKz1ydVFyMoNe1ftQ8V18uDBrGCQ7wbEJygpYCkzGZYQGvN79Cu	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	576	989	452	12463	15941	jwimdkEtc6VdcgkX5eUnQAu7vu5VsuaQ38Pre8BbBeobk9y2Xky	11944	16807	16807	1618964460000
24005	3NKGWiC4nBxJSyzr8e2y1G4KHsJbQp6ciidZuNp8tNhta7YGZ9BG	24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	1483	108	452	12463	15943	jwFfC3FfxRj8M1tq7TYh5HMkio9ewdNyFuLYKuCDkDw4EY28Hog	11945	16808	16808	1618964640000
24007	3NKjmZpmHrCTBJc9Y4mDNsWcbaN5WTvZzc2PuEhkrWfeWYjiD9tJ	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1406	1393	452	12463	15945	jwDNQGeFB68wLfbBmwnHCZY6bQCJzsiJ2d6oGHvxHoGfeQCKVCm	11947	16810	16810	1618965000000
24012	3NK4yMuDbT5X3NmM9WtNznXYM1jgVZiSKv8FTuAaTP3daXJrpm4s	24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	1573	1318	452	12463	15950	jweU8hongnfoFAC3eAzToiqVJy72p7bzJZM8CaRLe6Ma8Hb4dij	11949	16813	16813	1618965540000
24014	3NKdJ9dHd6J9qJNZoUPW21hAbzvWpygGXgW2UrtZwkT47S8uQq7R	24013	3NKUh7whZtFCq1PsXcGRnSpksGFQNNVFKrAoBX2xeyUMew1f2o9T	1534	67	452	12463	15952	jxw9NSJrjYqkAfkqV1dmehmNh69LXVnfV7bHJQiheWsfDW2dkgm	11950	16814	16814	1618965720000
24016	3NKm2xaZ6XEgqmBKTg6tXnEJg2eXW7cvVeTqKkp187jHujoBnpcE	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1534	67	439	12463	15954	jwhfqkFok1vyvuE7tpgAT8Yp7gBxmzog91G3HowJ9mxXaKAgfBa	11687	16814	16814	1618965794366
23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1407	1395	451	12463	15884	jxUqucWk2DpyKRtJcZ5oFtoXHR3ssB3FSxyt54T89zjfu6FNaP9	11913	16770	16770	1618957800000
23941	3NKZC5FxSgNyAvxc9wZeGPAGnqLAnySKXkVjFBxcCRCGydVJ3DWr	23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	576	1355	451	12463	15885	jxUWoWdN14UKJ7wkXZcs6Jx5PLJrX3JYFmJNdxFVrysgzJbe3Vb	11914	16772	16772	1618958160000
23944	3NKJyyADWGYjGy3ea9qZRXEn3LEv5Z2akPp1k1ejNkTycyUevzk7	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	621	621	451	12463	15888	jxmToHxcNByk9B4DFteDT3PFbpFjtAgtEyMcNizTuBEsqnZyzrT	11915	16773	16773	1618958340000
23947	3NKXJtG3JbW7VbVZfuT2iBd9rnwNM3b1aCHHm4xDvEm6in1P8QFb	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1647	936	451	12463	15891	jwmYkd94iATNfEGfvxa5KPixBJ73ATMbxRVjj1H9AuyZ6hwdmbU	11915	16773	16773	1618958340000
23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1588	1392	451	12463	15892	jxWXEa2JEuTYoGc2YAmcrQeBrFWJQj3mY4dKgzFc2mRpK8rQF6N	11916	16775	16775	1618958700000
23957	3NLFCysNVfmwDFhG5kauy5zmLnPFrArwRZp5v8VAeW9rfsy64YZ6	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1402	852	451	12463	15900	jxawEE8sYmaxSoJbM6pmBTTBbYsFXrv9WfuTWiFjfWff39aHPjW	11920	16779	16779	1618959420000
23962	3NK7JSkpmhfDf2vcx1VSMxM1wPpecLVPwQBX25t3poKVn3btf911	23961	3NKZqUFhjtfjgDNJcGn5PM4XWdXq5mfu3tudUzSB8EQ4FfsWnr8L	369	1312	451	12463	15904	jxUaQJavXjFt5mcgwf59QS3cyFCVNBxFsbUDifQAYJTuHyobbdJ	11923	16784	16784	1618960320000
23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	23966	3NKGTZ2ZEypjweBQvCspSjvzWLHuW94zbK6WpVT3EQ3BFFEoQwEx	1407	1395	451	12463	15908	jxws5qb4N7CRg5fc75KghvktD3ZqpsFCWpEV39xuGed2KFGacWP	11926	16787	16787	1618960860000
23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	23973	3NKwbc36K4eMNCmmoz5x811tBSXWyVE6yLqNgpohL7i4gbQdr3nC	42	1115	451	12463	15915	jy3AsDst1bGVEZuNgRJFan2ufsbJmZfgNShDkeBdEeV5iTJc2Xe	11930	16791	16791	1618961580000
23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	23978	3NLcznzQqEgtBycripkWQ3t2FumzPkdGxFavtDLgSUdNgpdqW2VW	1611	1215	452	12463	15919	jxEejhUUpuJM7untM2BxWxTji11fVcTo1jYs8SeeSb84i4oKw4d	11934	16795	16795	1618962300000
23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	1500	1051	452	12463	15921	jwis9MxEa4emkpLJceJjA4223qVfdcjQetxEYNDvMiCL1SGHUEy	11935	16796	16796	1618962480000
23986	3NLpVVwf7JgEgfKGJYuXRG9stVEVwzDzEtyp7F2f8qVFBfEYKkdt	23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	1403	824	452	12463	15925	jw7Q6dGsjU2oGbPXSYqZuXe7j3Tqe5u1aLbF3LKpNTcmZ4Nm6Jv	11937	16798	16798	1618962840000
23988	3NLfXBbt3HTARxR27q13eQdKuo9L2aVg2jgKBVdF24HRQxoQLumv	23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	1522	1076	452	12463	15927	jwj5bUibwtWEeL5Qzy4G82v2A9ZFNcLf8noZWLWDBgfMR5g95eE	11939	16800	16800	1618963200000
23991	3NKZUzA9TsT5UHAbSSZY1DNuK1QopM6YJzLz5iNEbMVKGHmGuMY1	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1654	1340	452	12463	15930	jwBivFsHG2qnBWKxVwLcVdicQUCARW55xueCTtEGyQEMmhZxVKb	11940	16801	16801	1618963380000
23995	3NLTbim5XFPFfJ3cZMrPpsWCq7sE968cPpcwZ1u58h7B12ZWFDzD	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1402	882	452	12463	15934	jwRbHG2JodLiJ5LfwxTHgFVq1wJ3VpprHE62Vh99cqLtdeDu4aq	11940	16803	16803	1618963740000
24000	3NLiVA8aFjwQFcRmNScB6QVFpRsL2DJnmTj5JdLc892PVWZ1ks7E	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1406	1393	452	12463	15939	jwndSNK9WpTit7HvRH3D9EPkB3Hh5RGm13Vd51QnVQM46EVZ9uA	11944	16807	16807	1618964460000
24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1607	1222	452	12463	15940	jxpKidegAcm5QbuuEzfpfX8aiz5mEC6KQy8mh6s86GsBhG2fYSh	11944	16807	16807	1618964460000
24004	3NLL8wJob24GH3jDMPxPQNioSy88fbd15cvP4DAqzwN2msdFztHy	24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	1406	1393	452	12463	15942	jwezTPxvQq1G19qzw9EQgkn22i4D6L14rVJYyvDVpJh95umFRFb	11945	16808	16808	1618964640000
24009	3NLWVLM3Q314pAa2evzEgtWscpTgowzPs2rbpC2cLm1g3x8Vi87o	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1633	1264	452	12463	15947	jxNSGw7XrV47XqDTW3cJUVVcTvKpF6ED1JEupgbzZoSVHXVar8B	11947	16810	16810	1618965000000
24011	3NKrVWpR9XM86nrMpNUgMyxqH8L1XksuBADn5FiQ1ntkCdSgsNo4	24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	1631	794	452	12463	15949	jwEW6eBEDctM7HWKE6qB5dw12NKrPAMHDFpRS5mpUU3pCvU3kz2	11948	16812	16812	1618965360000
24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	24017	3NKPmsnEvYEDLoEMTKnKLhZonq28ye1RqZLbab5UsNoULHtakCEG	1671	1119	452	12463	15956	jwnva31rtAHHtXZckLFnqeDVor44RfwZCU2ECpB29kPLvEZvUGi	11952	16816	16816	1618966080000
24021	3NKWuMXas4gF2Xen8VkgoucPdZes2XtYovKwxZiw1b38Q5kJqRAd	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1508	1141	452	12463	15958	jxmJU6r9nak5isbB8a7wR4nyCMtaw4WZxgGNdutfuDYqyDnCyHZ	11953	16817	16817	1618966260000
24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	684	1106	452	12463	15960	jxRKBUL6Kmxyt72YQfNJNQMYm4oZ27Pzbge5wJprw9UwMgmKRnj	11955	16819	16819	1618966620000
24025	3NLERdybXDg7qsEfoyaTqhuMHbb4F3BwM2urhRKymKCvYJkttLst	24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	1579	1023	452	12463	15961	jxsXMyUqXVRu1HLN5ugK9viCBQ4ARtekc9BzkNtjn87b94KjHuz	11956	16820	16820	1618966800000
24028	3NKXw39kLQ9V8jdCX3ZMu8yC2Z28NDiKvn1KrKUYmQFMkFXKfYZW	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	1587	1231	453	12463	15963	jxBNecmfkwGpNmwMouDtGYKeFBRgWHhw8igB5sqUY8bwQKXUzjk	11958	16823	16823	1618967340000
24033	3NLH3opjV6RMgdXxSVND3q8n22zbhKq89i2G3djk4CqRCC8qJoP8	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1675	1216	453	12463	15968	jxCqLmEv1BHN1wfAtd8NfctoMedWhMU7mj9tBhdZTgCQyWKw1p2	11959	16824	16824	1618967520000
24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	1407	1395	453	12463	15970	jx1H76bPcbNLAFsHqGmAzHg9GuJ9J4kWGB4C5jhRT4gSHbkYjn2	11961	16827	16827	1618968060000
24037	3NKV7aC2wi8HhELjMGEE3ZdukSkPSw7QGYFNvA7w34XScVgWocKB	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1587	1357	453	12463	15972	jwRemuseVcAiyAGUEaZrVmTgwLfv1R6avc4nzhdw3pYf39tn6Mi	11962	16828	16828	1618968240000
24042	3NL2ubwWMLMarjQ2RMfdp8xa6rKoC4sGxPwZQAwvJhWeQc1k6yHR	24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	1407	1395	453	12463	15977	jwn448DFs9wakmzmUu5osPnhbocsVuGpfPGXdr4FktgHJ1u9dyx	11963	16829	16829	1618968420000
24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	43	1064	453	12463	15979	jwBzXrbCTMxDrgiztd4WSeQdFjyeJgqob8ewiaT1XF9DQq697yA	11965	16831	16831	1618968780000
24046	3NLpFsBzonUd63LDfcrf1Vu18BqnHY4HbaDLCtzRZrHW4sDfApRt	24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	1588	1392	453	12463	15981	jwfWZoYgc7uUs74Matfu5AS3genYkVeosSjEJE5TPK7HrND4UBV	11966	16832	16832	1618968960000
24053	3NLVEvbAPraWfDZv8EDvgQwuMjTYPEJPhdEx3FibtvC74BXmdhtv	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1448	1065	453	12463	15985	jxgvcKB4VWXV6yimfikc1pwgYzWjXTUaSnKk7ziYN55pdSD3y2B	11969	16838	16838	1618970040000
23943	3NLxY13cu34Z5PvMx39ZLKWAyfSS4sjQi89km6PCihHk4aQLsgNa	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1571	1335	451	12463	15887	jwFtQxB8PQ82w59iZ6DbXSPWavxqavUNBgQpvH5WF7Q6iVTWjCp	11915	16773	16773	1618958340000
23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1602	1123	451	12463	15890	jy3AcihFxhmuXVopxAxGmSDG9EMYR2moUzKi49aVTQWW5Apw5ai	11915	16773	16773	1618958340000
23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	1624	1334	451	12463	15895	jx4k4wabX87JtGzdEESCZQ2pQzgSmUHbu4QL1aQ1Tjush6fhzbB	11917	16776	16776	1618958880000
23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	326	326	451	12463	15897	jxt8rZ5hVPXmvjewPff9YHpqGdwXSDGof1m1zzYdpqMZ3SNdfnf	11918	16777	16777	1618959060000
23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	1559	1353	451	12463	15899	jwkBvsi1rtqctvimj2B3cLiFDxPenZKAygvRnBDTXtTKwSYquKr	11919	16778	16778	1618959240000
23959	3NKs1pb3JS6ZwuhEkGw2pwLsvroTkFKwFbSRLxrGrVYQLyBZo14y	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1560	925	451	12463	15901	jwvvLqsN9wKVudN4dkp6XmapW1ggKN4C3bGy8UJt3LZbnBv4vjo	11920	16779	16779	1618959420000
23961	3NKZqUFhjtfjgDNJcGn5PM4XWdXq5mfu3tudUzSB8EQ4FfsWnr8L	23960	3NKj3Fx67HwPLyUnapCfp7mbo644zMvJdcMK97RNhR2cHPX6Lxjr	1670	1156	451	12463	15903	jxgfELknSiaHvG6gocJ1frBEwQKc3ud49FUpdAWpdavAE5ePQ1e	11922	16782	16782	1618959960000
23964	3NLNnVSpgJKM3SYx8gx4mNf2HZGwrraNUpSETaY946kJa1KtVckT	23762	3NLbVtxr3VhXq7WVXXmekERndMRq4nJQvtydzMneJ8ugkbtMPsUS	1593	1346	445	12463	15906	jwYWJC1zN58Ejq5tzgzByBdSaHeBgeRyHmb7RhqiEHhbzRTcoRL	11786	16785	16785	1618960500000
23969	3NK87DqmKJNUu8mU67pvAbApWSX3vH3imj2YJvYMyhNWz245Jqkj	23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	1623	830	451	12463	15910	jxpTVqhDFAJhtQJ27E93C9dvGBYPSQd6UJXpoMZMXR7TrQNbLrL	11927	16788	16788	1618961040000
23976	3NKpH46X6vWSHdq4zAv4gbapMoM4UxW3NLZb9aGGaEHzxVupjQVs	23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	1422	971	452	12463	15916	jwjLmEBCPid83vuRn783pCPxSnkFp8ujeqX2CgmH331McDCHADR	11931	16792	16792	1618961760000
23978	3NLcznzQqEgtBycripkWQ3t2FumzPkdGxFavtDLgSUdNgpdqW2VW	23977	3NKzbvdZ8CR8EEBcKggqpb5gyaj3WeuaaZiRwqzdPDHPwvjkrVJz	1467	1130	452	12463	15918	jy2hdpnt975PCaeUuR8VL95kjq8NkDV7jRK45deEC1E5j3R6Y6o	11933	16794	16794	1618962120000
23983	3NLJsgWvVBc5C4r1ionQDnMuri75tG6BshD1DYY3wp2mGAwdKatF	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	1422	1211	452	12463	15922	jxJckLLWSDLMDc8xygyxR4JhdYCrEmCKuh9BjZ1RGHwzFrkXdji	11936	16797	16797	1618962660000
23985	3NLpYtVmVY8DEWfnKEoGvga5cuvBzDfdGHoVZbwnq9MwULTt57bf	23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	1608	1289	452	12463	15924	jwZraBc9KMR1RZqMyZyJEjDnm7Vb18NkdfxqvqmbmgRrPEyL5Cy	11937	16798	16798	1618962840000
23990	3NLede134BiH6iYocuZ5Fnga74tna78NyMiL4g2mFtPD87ZRi9W3	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1657	978	452	12463	15929	jwtFe5HuPCWb87XXEP4pxdG2qLTyB8xRxv3FyZ7PQgXUHVbvUdd	11940	16801	16801	1618963380000
23993	3NLWMNJXL23rqUa1bx2MxtBP5vrsZ8NCjYxEtBj97uJXEzr3giCp	23891	3NLQ7G9dJCmhtb1YyeNGHcsuaGeHPmSNAYwQbMhURCYyQfk8enTJ	1657	978	450	12463	15932	jwzWoTT54JfJ1RJzBuJrte5wdfrvi5TVGt7YNB3KfAfSHTAumaD	11894	16801	16801	1618963380000
23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	23991	3NKZUzA9TsT5UHAbSSZY1DNuK1QopM6YJzLz5iNEbMVKGHmGuMY1	1406	1393	452	12463	15933	jwW6CC91NYTMFr3Cbj3LYy8h1AYXMuMusJPKtxcKqYaQ8oAhVQP	11941	16802	16802	1618963560000
23997	3NKYmCNtisUvcxgtSfY6hmE9VynqTqtMBtyCMAMhGEKXsygt2zTv	23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	1624	968	452	12463	15936	jxvRrPSyEiwioiPHQwPXyUA4gEZUTWj4zwVn5Nic9NeMSazXc3e	11942	16803	16803	1618963740000
24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	24005	3NKGWiC4nBxJSyzr8e2y1G4KHsJbQp6ciidZuNp8tNhta7YGZ9BG	1419	814	452	12463	15944	jxfMxaFvCgUaeThjfCwQgQmKLX3UGhfz7BpMVsdFdMg1WfKFEu2	11946	16809	16809	1618964820000
24020	3NLxY7LdZceErVFdi9cwJLMaehhwjzJ2yBZppBqK7pJJDSt6Zwhn	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1529	1316	452	12463	15957	jxSxxg4gNPYmRa7Wh9LxDxXdhu6yTGZEnVw8eyc2BCZQjYHbv8Z	11953	16817	16817	1618966260000
24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	24021	3NKWuMXas4gF2Xen8VkgoucPdZes2XtYovKwxZiw1b38Q5kJqRAd	1406	1393	452	12463	15959	jww4VmkWasQkAsaoe4LBdqGf6HmvGqJfpwy8XwsvZqqvquVi1eS	11954	16818	16818	1618966440000
24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	24025	3NLERdybXDg7qsEfoyaTqhuMHbb4F3BwM2urhRKymKCvYJkttLst	1406	1393	453	12463	15962	jwwkVK7GuYYsra2FooXwJBzDxiccLzxu8UbGpFpLFW7YmdYxLsm	11957	16822	16822	1618967160000
24032	3NLJrB9bw8Y5yed2b11BjUgCjCdPZ2gu8EG4PFP6xoLQuRqQg8Lp	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1501	1360	453	12463	15967	jwcHvZJmhuNJhVi1yjrExDfdvWAfcGteWMaNvBza7zd536b3i2m	11959	16824	16824	1618967520000
24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	24033	3NLH3opjV6RMgdXxSVND3q8n22zbhKq89i2G3djk4CqRCC8qJoP8	1647	1302	453	12463	15969	jxGD5N6EkB7KtyHuLBZpS6HvcmcqFp9khznAhZCUEbkXucPbpsR	11960	16826	16826	1618967880000
24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1522	1076	453	12463	15974	jxSFoyoJT7uQpgVsrtMKoH9XdY1Bs92bx9fK7WLVQAuuXFG9bfd	11962	16828	16828	1618968240000
24041	3NLU9FUiknF9KWuqxcbxRNSN9Zj88E9myizUiZURz7TxrgHUfbKS	24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	1402	902	453	12463	15976	jxLggCW5CxFxwRRtFm3baaaptWz27qhbsb1bef9rx7y1vPnRRGP	11963	16829	16829	1618968420000
24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	24041	3NLU9FUiknF9KWuqxcbxRNSN9Zj88E9myizUiZURz7TxrgHUfbKS	1406	1393	453	12463	15978	jwekkZSxRuRbHiMdpp7SuB59VqQaGvBRDj8K36Tk5Vz9sSsDqzE	11964	16830	16830	1618968600000
24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	1529	1190	453	12463	15983	jwdeLyDczex2nf5MjudHzwLP3DzpfBCGpsj7gMi3oqvdqKfRz5X	11968	16836	16836	1618969680000
24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1483	1276	453	12463	15986	jy2FoaNTLgy49z7AvPw5dKhKnL2P1JkWUfTZmyKydpXvxNrpmW8	11969	16838	16838	1618970040000
24058	3NLMuFDhLyznjWMiLotzt1j18EbCvQ4NyKyfGNX5fgbQUYZ9iADq	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	1406	1393	453	12463	15990	jw8EmHFJRK9tSPH5pynGnnJrJ43FQkVcdzxk7TBnp6j9neXBPWN	11973	16842	16842	1618970760000
24069	3NKgt1YuqCvZUszUBVV4hjEyQw399Efvazu8nZa5gEWLiqEcKueZ	24068	3NKsFjBmjVJ6Sc8WN4hu4W7CvFGbHLJC4fZbo2JvKntt9P3UsgaU	1596	1363	454	12463	16000	jxPn5PYXBf8MJdi432AYo7uxd3PLiPiyDFwCX9wBTNDaHAuZmuz	11979	16853	16853	1618972740000
24072	3NKRYvFx2y1GYvJjfpGsgZgmVZeCeeR5DFW37fENyTtjqe5Agdzq	24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	1405	867	454	12463	16003	jxLNMotpJ1pnPGFkMtzdMzxzhLieFDEBqAuZmqMW8v2e89yAvhf	11981	16856	16856	1618973280000
24074	3NLP1xPe6YokwrkieLgo2yuPvFQ4Ae7BVe3tFbNQmzYZrMrBayhJ	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1406	1393	454	12463	16005	jxtKyk61Sd34T99F3uAAeUyY6QcDboA8zjRFmCBzPZAf1hTC5vh	11983	16858	16858	1618973640000
24019	3NLnKekKxHNRTZPSuf9y5ngKHdwWyWMZRgtUUwyEmJJcaX6xy5h1	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1529	1316	452	12463	15957	jy1qGU8VJsbxGwKvY1kvsGDxnvtUejG4oYc743T2AEjpmbpT6Ro	11953	16817	16817	1618966260000
24024	3NKTY3oZ22h2UbhcdeFjxizPT1X7RMBU3AKgXYPK2Z1aVUqqwGny	24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	684	1106	453	12463	15960	jxfEjT9V9sdyErDBprbvv2FXchpHNaULDsJUDhjbyz9CBaQBQJL	11955	16819	16819	1618966620000
24026	3NKW32bP8HUNXxxhLhPUXUwYCuSAPHVDBfPYPB3JTCq9BiumConF	24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	1579	1023	453	12463	15961	jxvmQRXemvc796BpM3vVF13hbJ3vVs85fXRVArtRv6cT8JP2Ubr	11956	16820	16820	1618966800000
24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	298	1308	453	12463	15964	jxH1bsuScCisKwjapzH3gKxgcT1fcjii2cZmfdoqPtHWY1qwnke	11958	16823	16823	1618967340000
24036	3NKguHHErERc21iLfjvJMmL11sRKPsTSPKAY2poYtAHtdFh57J8Q	24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	1560	1045	453	12463	15971	jxii7zhcHr9wsCHeeAPgQauTHPfwZsucVYhsxiTeBP6siPuR1fd	11961	16827	16827	1618968060000
24038	3NLXuDFs2tC2FimpzjLcfR2m4p7pMdwhNSNdHedTFoHUfZ3N2MP8	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1406	1393	453	12463	15973	jxTvAjzkpAJukbFgKsQuUn2LUNSrQyRdah4VXRY7RiwrSbwvoEW	11962	16828	16828	1618968240000
24040	3NKuaoBZJrPGPoRZaXHyXjSE244cVPFPbY1MuKizNHsiCk2opgAb	23916	3NKy8yYtkyVKP5oTVzCiMKjmpLzduVZ1SASnQtrbDPhbYGyh86mM	1455	1086	444	12463	15975	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11756	16828	16828	1618968240000
24045	3NK8Rh5NDtT2scxC1iKGYnS389sYTNZ3KwJNePQPdt2yQWxzmEgn	24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	1403	824	453	12463	15980	jx7JZ6xGMw9GmMLA7C3eP1n1ajQL7MQdVXhRLR4Jtvwmm9EYNmc	11965	16831	16831	1618968780000
24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	24046	3NLpFsBzonUd63LDfcrf1Vu18BqnHY4HbaDLCtzRZrHW4sDfApRt	1445	924	453	12463	15982	jwtFVc9zg9jeDcUrSuZZWLtueWqtdo8wpKy2pT2LabGUxu6H7XE	11967	16834	16834	1618969320000
24050	3NKhkZs8D8aCnXkEyURsPLnWqFFsQura2xiybthLtFAbx8poVzo4	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1406	1393	453	12463	15984	jxmHVk2srXixzsXWYXpyL8WdNA7GkRCkZ9Nib4UJyuqyTMu8pSY	11969	16838	16838	1618970040000
24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	24056	3NLmPwfg5wmM51geY5kPTuomPNFdTzbsWkhqXgWbJ3RwM5Uijrxx	1623	830	453	12463	15989	jxhEcgLtCkgmnthdLSsD36fpyDgfjTZrgj7kxpxF87H7xxkFLwX	11972	16841	16841	1618970580000
24062	3NLM5Ndz5chcjkdk11zKRVDagZpXg79YQSFqiWJcaC1FGxaWbT8U	24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	1657	1218	453	12463	15994	jwW8FSHaayZNccSBEhDCexUfSHG3rgmidcFopJ7rmHvDzAdAupd	11975	16844	16844	1618971120000
24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	1516	928	453	12463	15996	jxHp1nTyXsmK3UYkMHePP86ok7o6mRoQi82Rh7GDnbdXJsBovkL	11976	16845	16845	1618971300000
24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	1422	1337	454	12463	15998	jxsSBiQUiwPWFebmcGCUrEXyMU7FvGu53iYPwNLkeiMjx6LsUfp	11977	16847	16847	1618971660000
24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	24072	3NKRYvFx2y1GYvJjfpGsgZgmVZeCeeR5DFW37fENyTtjqe5Agdzq	1652	949	454	12463	16004	jww8iTQUNXGBeJbboQJAnsvLPur7pomgXaUFCaZHNWWM82NowEH	11982	16857	16857	1618973460000
24079	3NL7vAHkBJc5Q76xb3AcBxdsgubQVt8h6BDSzyXK8GoLnPUFNLeh	24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	1483	408	454	12463	16010	jxvd3EsBQLPYKpwrh4m4xbEDGHPBiJCzbunp88pPSGV2nJjLu1W	11986	16863	16863	1618974540000
24081	3NK3deUPG26RSvZN6LQWoJ5ar8KF2g9SKSyNz8rwimmvAN9SmqjN	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	1546	1093	454	12463	16012	jwgSBR1kHYHEp9EC7sMmxfu1YWeSgdX9vhTuZuwgdTHbwMpNtzC	11987	16864	16864	1618974720000
24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	24080	3NKK9BasjMrUQf2jJHEegBsRGaUcVvLqy9gyokLFYEdXvT3FyW4j	1406	1393	454	12463	16014	jxXVgyuu1xXU7fhArJZTw5KXdBsSu9C8943J2XWbNg1SbLcBrA6	11988	16866	16866	1618975080000
24087	3NKibsLXBJTsQmjcqZgbpS1DfNYDHpEZ2Cc9Ekyzh4sU8SaE4qoY	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwdMHmipJGKApdGe4WydfMugBc3HgGQTRnTnJELCSqqJcWbv68G	11990	16871	16871	1618975980000
24091	3NKQkYwQhFSvhU8UMr8MWWZ5HDRfqU1PXjQ81y5m4gHmSquXfJnn	24090	3NKtYnoxXrx7iKbadSJVq76sm5v7VYYB9NB3HFRP5wKSAMmREqHf	1637	816	454	12463	16020	jxsvSi7nvn79sFJFJiNxUxF5QLKy69ezphZ3KHosRCSpdSSXxqt	11992	16873	16873	1618976340000
24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1471	1386	454	12463	16023	jxjLGygJh3aavKPSKJRV9YBnt61MiEVFgWxZFDUxyhuzXczzXao	11995	16877	16877	1618977060000
24099	3NLXNZ4pYU53nGffApD9qGsJjjTy44pg3DijzpLT6mCbG4ieGd4s	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	1560	202	454	12463	16028	jwYUt4Ca9WKsybPe3t9NDgaU88i2JbAAwPQhbya3AndTkonPsHe	11996	16878	16878	1618977240000
24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1651	1301	454	12463	16031	jweVdZHoinvGptRGs17ewRiAH1JRJSLJ4SitGjQ7z5iWNLaLgPw	11998	16880	16880	1618977600000
24106	3NLiP5QnxmjRpwH3XV158PoJtdUSU7gH8JtY6tWnQif8ErpmPmCz	24104	3NLeeXTM3zoErgLTruuoPtQXbAsKvXpCrnNgGPbSKADuhoKQUapb	1631	794	454	12463	16033	jwYCpCuAK6hHscJgDPk8gf2nZgP9gCEZphJaFgtEa23jxordpuq	12000	16883	16883	1618978140000
24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	24106	3NLiP5QnxmjRpwH3XV158PoJtdUSU7gH8JtY6tWnQif8ErpmPmCz	1647	845	454	12463	16035	jy28QFTcry3YEZVcvgr9WYNKaqQ4wCvszqAvtqRg5DGwjzp5MwM	12001	16884	16884	1618978320000
24110	3NKzKkZ5HEYFgFUuUhzdQcNUiJkVc7iq4dFs6rpBp7Pqok5hB7em	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1647	845	450	12463	16037	jwK9efMzSBmF23q5EyQYuR3GC4QZ1a4YRb9Ldhv9cTpC19joEuV	11905	16884	16884	1618978413727
24115	3NLFyhRznPiowQ9W6yoAkHznh2V84ukRauSmgdxyByyzecR1rS1K	24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	1589	1286	455	12463	16040	jxWYt38BGMjYbxff8sVQwdSRkFu6dFpAdv4NyzYYo7SMdHMCkv2	12004	16887	16887	1618978860000
24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	1607	1102	455	12463	16043	jxVbBAQnDAV1VrgfY48pFBUxqr3A6eSVG6Mh9vTTo7Uswq6LqPj	12005	16891	16891	1618979580000
24120	3NLemyNXBgGc4UpskM4hwzxsrUNJBx3KELSPCqEk6VURJSafxesG	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jwzKUyVKzzWo7kXTuPhkFzTLk24yVH38gdNw3oLHUxSoriVVpPD	12006	16892	16892	1618979760000
24125	3NKLwmq883bsp9EvyxP2FcyY5Gb892o1kfTVieEYyfChakkh5ELc	24123	3NLFhyvND753XruxuhodiuzmzJosnQyNC1NWSJggXCxHQ7JVYgRK	633	1138	455	12463	16048	jxNyq8P52AypwrC54X8FP9DD7vxnpngFhgcRwgpCvcVY2xs2sN5	12008	16895	16895	1618980300000
24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	24131	3NL3pbePUkPutxbZtVdnb4Xwn7hWmF6CeYjzptDGwYgC5qYQhwN9	1546	1093	455	12463	16055	jw9XyT4hyVdTBNRk6V3RaUS5gEKfJTL41ZWFZgXSga23PQw4xGX	12013	16904	16904	1618981920000
24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1593	980	455	12463	16063	jwCmCe1Hd4BNUjDMzaWXXW3tQ5xcQy8ixGR7aXZZnVZm8DZAh68	12018	16913	16913	1618983540000
24048	3NLuwtQBM1dPsRsWZgUfjgCxsmmDKiuioaoArjGg8o7Vsc6AuRhE	24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	1529	1190	453	12463	15983	jxTbNCnZHHzduibL1jnkx5MMSQBCxBCJefNptkqcmazZmCyzqNf	11968	16836	16836	1618969680000
24051	3NK4CHu8xo57PXR3jwHcRYJuEHMpkxa5rrWcSX7QEmXzGkLRDUPX	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1448	1065	453	12463	15985	jwJ31Mc5EPn2ecfE11f2ta7oUW1gMhXxN4RS3EVSQH1yZkViQQW	11969	16838	16838	1618970040000
24054	3NKWi8yzauyAPx7H3PV8mSbFfA3Xy9a2CP54DzQwkMj53gGLfMju	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1483	1276	453	12463	15986	jxmNsdFT4mMWPostFWRmT5UWWYc5Tvtio42QYpdr6fmhp4sw9Z3	11969	16838	16838	1618970040000
24055	3NK88zXqZHUuL7wyziwChLp5Fin2cqDE38kxCrY7gVuUSyDiZCF6	24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	1407	1395	453	12463	15987	jxAwBBeqGYWAGaiVtJfavTvXugCrygTxSPYXTMcx7S73A5ebKHp	11970	16839	16839	1618970220000
24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	24059	3NKGBcV6LhKFQ4H98JbrM8TUGFdMQmfaXyEsxrg6EBWTZLpHuKhS	1426	1118	453	12463	15992	jxNbez3HVcsfwyG8MWNTiD5xBo1Ec4sButjDovfNF4nTUP1dsWX	11974	16843	16843	1618970940000
24065	3NKL3aqn6PmRtwpSSKnubTGase8f9pVk1DP7dt9wdQpfxQEtLj7B	24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	1637	816	453	12463	15997	jx5fonvuPgZBgLcAPG2TRUA7pzrAduu7j16UkxhTfCnGQL3otmm	11976	16845	16845	1618971300000
24068	3NKsFjBmjVJ6Sc8WN4hu4W7CvFGbHLJC4fZbo2JvKntt9P3UsgaU	24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	1492	346	454	12463	15999	jwNEA6MehsAkMGv13kqP3iD5A2tJNpNNpf4FuK9o89KDzz1nt7A	11978	16852	16852	1618972560000
24071	3NKPy8frSidTcFPMSEUy13gAKuseLcvjyKSkaFVj14MUbbfmyXX5	24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	1501	1360	454	12463	16002	jw9esged54NbRHqfCavvc4ETyRakND9wCrXzzo6DZxeBPaSoc3o	11981	16856	16856	1618973280000
24076	3NLrsLmCXr9VmKbLwiVkKMBmZ1pZWP5SuDFN3HdqTQ6UVkqWpq3P	24075	3NKQf8TjH4vgVjVFoWV7m8B2MYZnEjdE66atstxhxLRtAFMNeACA	1671	1365	454	12463	16007	jxDG16VN7v19RSmfHLJ7vcuUPeNQaQZt23aEtDKoA1QxdpdRxZW	11984	16859	16859	1618973820000
24082	3NKuSm93YPnArwm9FWcQCirkxd7v8TQNiZWfrPxCG5guZmiRKcsd	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	171	1128	454	12463	16013	jxPJq8ttan8G54kg9Gt3MWfwk3LwhHvCacoffLraki6o3nDa5p5	11987	16864	16864	1618974720000
24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	1652	1069	454	12463	16015	jxFB3LkdTszYddbNcH22GcUEE4GLiEefWRKSfEZZB81gGcgZgB6	11989	16867	16867	1618975260000
24088	3NLb1mViXZ1vvk7HyHfMqcUbdseLbnxCwXjNio17PkMVN9ihFeew	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwFbFoTN2pXdwjZrqUgAmBpnPXsExCdnbYpZLsfkiBPxdXx5a8Q	11990	16871	16871	1618975980000
24095	3NKDM1XDmESy8B77PSDZrvgWKJVCtkrfAfvfrnLmooYVuZmCtS7y	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1407	1395	454	12463	16024	jxAkdbEiQzsgLdmHgoZC7Yc6KwccBYDhzcxRYJmK79hmDqyFmxw	11995	16877	16877	1618977060000
24101	3NKukqALASwvVPoEXtyU58EFvLY9ar9K2xy6qj6gLCraqU7WovdQ	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1546	1213	454	12463	16030	jxhk3MeRchfTwF62sEc29Nba67o2NGnNiZujf554CPaTGEYTGc7	11998	16880	16880	1618977600000
24109	3NLE5p69uJCejD5UJjUN2mGY9sqV6BVpDU374ziJuTmwnPwaAi1R	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1647	845	450	12463	16036	jxbnNZMR7jZeYksVvaRRjFdWrmHEQMDDGpDSKTjKk29dQC9EyEp	11894	16884	16884	1618978367193
24111	3NKmsHcYcsaH7NRpzGX1YqvmsHJnT9i7BzavAzxzMihDPwbYUPEU	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000
24116	3NKmMVV5PiYejRbkeVNbGS6832rYWdsybYHZWv9HVSQvyC43UVE2	24040	3NKuaoBZJrPGPoRZaXHyXjSE244cVPFPbY1MuKizNHsiCk2opgAb	1455	1086	444	12463	16041	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11757	16887	16887	1618978860000
24119	3NKNHoQvKnv3wm64yjXg8DHcz8eAjH8JWVLk9VfynvSguXURg5te	24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	1403	824	455	12463	16044	jx945kgmm9a82destrVpS1qobSQdTr5tyAfbxAQcU33Fhkf42zd	12005	16891	16891	1618979580000
24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jxA834dP47UJrUNhnoiGgFZF5XtcHuw7WWwjDTCcLVLzDZTRFAm	12006	16892	16892	1618979760000
24123	3NLFhyvND753XruxuhodiuzmzJosnQyNC1NWSJggXCxHQ7JVYgRK	24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	1675	1096	455	12463	16046	jxEWepYmRQdUcY16EYi65yqJ1KqhFBioNpvva3eTkxBKWzgbvpJ	12007	16894	16894	1618980120000
24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	24125	3NKLwmq883bsp9EvyxP2FcyY5Gb892o1kfTVieEYyfChakkh5ELc	1403	786	455	12463	16049	jwCMQuw65GnHU3yCh7mWvbrirXno8UoyzRVtHvvce4mKuKCpS6x	12009	16897	16897	1618980660000
24128	3NLTjBo8kisqbVoNj8XvcbcJRBxAG2B4JMLQoASRwvw6BoafpTef	24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	1585	1366	455	12463	16051	jxLn152WsLMFeqP35jnWw6nVucTzpkcfbqui7mviZBAbKTQx1s3	12010	16898	16898	1618980840000
24131	3NL3pbePUkPutxbZtVdnb4Xwn7hWmF6CeYjzptDGwYgC5qYQhwN9	24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	1506	1127	455	12463	16054	jwXUdWisUwJHGfmpeKjZMvmQYSvXDwzETsDC7kXWaz28xvjR68Y	12012	16902	16902	1618981560000
24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	1406	1393	455	12463	16056	jwNsSpHWYNKaC8PPRGGyPV2HoKsBxZHFszqnRWTcBRE39GDDWDf	12014	16905	16905	1618982100000
24143	3NLEucEQhYBM2jrafirfGnKNj1kxT5ZwuPnSw6bBds8wktPYeRHv	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1458	1197	455	12463	16062	jwEVdeTphdEMwT6dQMvRkdk4tFBmcFQiAzUfZnriUCZFMcT3DEp	12018	16913	16913	1618983540000
24149	3NKSuimUqfErpAKt3TuaC55cn3M63pNGFQLKPvFjgDmPhFXVULEB	24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	1657	1344	454	12463	16069	jx9DfTSDUTSbydECjZFz4sS4PhKgxxi9CpLfXjBr4pUe9A2LFjJ	11978	16914	16914	1618983767389
24157	3NK3SFU9JvTXw6xJudFeQAb2wmJorksdHGgRRs4JrMUbcHSQiMbv	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1402	890	455	12463	16077	jwETUUoHGgVmQbTfcUsffrHunnwkQc8pEvKurCDmdeVvkjaGkBw	12024	16921	16921	1618984980000
24161	3NKip7N8Zp5Du48FXSMoQefFLJVG5aBG3cMG5xtZj9sC1HuCRvww	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1611	1341	455	12463	16081	jwiKv6hUDUcBa7zcXKDCvTHMiTBLcJ6yM4KToJeJ1BsL5uJu1g9	12025	16922	16922	1618985160000
24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	1613	1613	456	12463	16083	jwMRP71mMG7dDKFz7kcuo5RmgXTaMb8XZPDApHuE2PQEDR34c4W	12027	16925	16925	1618985700000
24166	3NKt77wKrs7D6Lh9jnoPUhf6Fbxo6vVua5rrd1ZKCjRrCRCXrLbX	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1403	824	456	12463	16085	jwFPzys9ppn8vtFjVdxq4nayuSct15oCHP9LVLgjyDLys4NK5Mk	12028	16926	16926	1618985880000
24171	3NL7rKXeAjkfEADJLUvb1rhd39MfMjHoTFGdnBirvS6quEgvZrRV	24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	1647	1056	456	12463	16090	jwDDuq7CmFog6HHiZL1oxDNDcaWsQCYTKQhnMGUkreJ9jCksGh8	12031	16931	16931	1618986780000
24174	3NLTaGkqYGGdTYLUHWweuMeHG6McGBvMcKWrGrt7tJ1FjX55DRVL	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1516	1294	456	12463	16093	jxk6RB5mw6ujR42coDnGi1aJeYVLyoMVXb1SaixNNwBNjtqg5i1	12033	16935	16935	1618987500000
24056	3NLmPwfg5wmM51geY5kPTuomPNFdTzbsWkhqXgWbJ3RwM5Uijrxx	24055	3NK88zXqZHUuL7wyziwChLp5Fin2cqDE38kxCrY7gVuUSyDiZCF6	1434	642	453	12463	15988	jwfZ8Ab8QR2jYs1p2QApoVzNFjm5wdbiPksDauJDTEE2xFhLB61	11971	16840	16840	1618970400000
24059	3NKGBcV6LhKFQ4H98JbrM8TUGFdMQmfaXyEsxrg6EBWTZLpHuKhS	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	684	1352	453	12463	15991	jwYdddSbxeKMyxLpPRiqhSaAUGuvLsPC65n4ejbdmK2yuvKSpEN	11973	16842	16842	1618970760000
24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	1406	1393	453	12463	15993	jwtkt82LexA6yfrcwgFt1QKGehzFhycp4KtpdNWRVjQXuy2RW4K	11975	16844	16844	1618971120000
24063	3NKqsfSUr2fo5S9kMXwZkPYTw5AdHKMwFrZRbcghUZ2AVc96Znqb	23993	3NLWMNJXL23rqUa1bx2MxtBP5vrsZ8NCjYxEtBj97uJXEzr3giCp	1657	1218	451	12463	15995	jw8rrqXKJPN3yhVWJ4wXCe5ze4ZJAjsPnFCmijcJwPi32Jv3yWG	11895	16844	16844	1618971120000
24066	3NL533zpYGwisLSMazSSAJUnsz6hqNpztRoGUaEpWroSUEQMzcoQ	24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	1422	1337	454	12463	15998	jxsSBiQUiwPWFebmcGCUrEXyMU7FvGu53iYPwNLkeiMjx6LsUfp	11977	16847	16847	1618971660000
24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	24069	3NKgt1YuqCvZUszUBVV4hjEyQw399Efvazu8nZa5gEWLiqEcKueZ	1652	1315	454	12463	16001	jxijEiYoqNRKCDE5WDDyBbNPHvE1uytZEzXJb8fAj3UtBMeXm6j	11980	16855	16855	1618973100000
24075	3NKQf8TjH4vgVjVFoWV7m8B2MYZnEjdE66atstxhxLRtAFMNeACA	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1460	426	454	12463	16006	jxoNKb3CJt4LxmgcA932ggC8Jx2Z9tbvCd5YogtA3yghfST38Ak	11983	16858	16858	1618973640000
24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	24076	3NLrsLmCXr9VmKbLwiVkKMBmZ1pZWP5SuDFN3HdqTQ6UVkqWpq3P	1648	1038	454	12463	16008	jwKhfsu6Fwi4fZRtoAmty88XBo5c3hbvSajjwmJoE77aRWYZWMB	11985	16860	16860	1618974000000
24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	1564	1092	454	12463	16009	jwBwLBGYsjuVwrQH3NXt7ygzuqTgLmhvhmVjXgJgfZMbra2DhLY	11986	16863	16863	1618974540000
24080	3NKK9BasjMrUQf2jJHEegBsRGaUcVvLqy9gyokLFYEdXvT3FyW4j	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	311	1307	454	12463	16011	jwWASbYM9ofJqCFrKH7gv6BDeBK1jLRnPGW4gFXQ7FKqTzvqPWq	11987	16864	16864	1618974720000
24086	3NLwsJsLF5L8AsL7xfRgcEA3dnAXdGPW3f2q8scJwEA7hAjNzPPR	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwZDk6AyzyMbq9ggKrpbWncEDD6UyCM7H1mwqSBReeUPgoyCvei	11990	16871	16871	1618975980000
24090	3NKtYnoxXrx7iKbadSJVq76sm5v7VYYB9NB3HFRP5wKSAMmREqHf	24086	3NLwsJsLF5L8AsL7xfRgcEA3dnAXdGPW3f2q8scJwEA7hAjNzPPR	1564	1338	454	12463	16019	jwm5BTqVgSYASqrdTT4DuxyKxC4vNpT66bJuoKdc3jpC5NrZ4LQ	11991	16872	16872	1618976160000
24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	24092	3NLkBDv8EuDxRdhnaHTGKENj79ZR4rh27vJSgrqUeH8UNEA67qxc	1654	1340	454	12463	16022	jw9iqzrczmyHwz2VpxqyeAWQzPzgmYP9a61dsDFSNGtEYb91hUM	11994	16876	16876	1618976880000
24098	3NLXySyFVtsALm9S5uRyMTVMMsVoPTCioRpRYEQMBFjpuMwb1yEn	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	576	1229	454	12463	16027	jwHX2jc6XETFmM2HenW14XcgbPJfLNMTb6RJL4iWSprP8vdKpsz	11996	16878	16878	1618977240000
24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	24098	3NLXySyFVtsALm9S5uRyMTVMMsVoPTCioRpRYEQMBFjpuMwb1yEn	1533	455	454	12463	16029	jxVRTiPEQXp8QemwfTKaofD339MmU6GhiQjxqK1UX4L2R7sLtZj	11997	16879	16879	1618977420000
24105	3NLsDjPHkwFuYY3wY6BymrrxCQp9RH2pWqsw4wBMLNZEzA2u7isb	24102	3NK3MPx6D4L47MYDb3qpcpQ6Mr9pzm9o5RFbJad2AvHSsWkAkHeZ	1578	1296	454	12463	16032	jxK4y4vtg8WQbvkXnGJWMMGY1EsG3VJTLdVR5fkZyzGy3F8cqoE	11999	16881	16881	1618977780000
24113	3NLjiE5pUyqrJe4XigmuCv4T8dH15JQQAePu7JX2SXbxbBqy6mdo	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000
24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	24111	3NKmsHcYcsaH7NRpzGX1YqvmsHJnT9i7BzavAzxzMihDPwbYUPEU	1489	1380	455	12463	16039	jxeDnt5D7jWEN1jHDPzhekkkGDsKPBjaRjpUN4QbkE9JKdzdHBd	12003	16886	16886	1618978680000
24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	1422	1337	455	12463	16050	jxqRQU7GDQGWENzskPhe25jncYuSM5DnhnEoKbTB1yLY9a9MvHt	12010	16898	16898	1618980840000
24130	3NKgovKZqN1fGjRdXJNxpVas54SQEAc3Q5jyFeWSAmdEDPAvJhsy	24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	1403	824	455	12463	16053	jwchKMV2S7p7scP3XMEFRJqdvAdoeEGU9djRE5QX6MaiCEsWsCF	12011	16899	16899	1618981020000
24136	3NKxkTwyou9Xmt9TCXb4FhZZhtWeW8CbGPPdHqcC58pqJqnt9TKM	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	298	1308	455	12463	16058	jy1XmnatcvnxKC6Ri4fJWKE2SSrQ9VXvSnmvwmtui7LxLEaUD3M	12014	16905	16905	1618982100000
24138	3NKNBwd3GP8Ntf8y9UYDrjVrDYpRvdhJ6JvtLzDmns9DfoKz3324	24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	1483	1150	455	12463	16059	jwqdC5Ewd4YyPtCsHWkqc5gcym7ZqXXJLTcUNUZnz2AYCHibjbM	12015	16907	16907	1618982460000
24141	3NLM53q6Di2TP3u9GAnJknXyovNJZ2ArSS3UxwZtnEXikawbZUX5	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1458	1197	455	12463	16062	jw9LeL4PLVHF9vzmoB7mE6ijft2Ng8fCDTyB1sdf6RJpGPxRf6x	12018	16913	16913	1618983540000
24144	3NLGWYPqK94zsvtKjRTZj6taKdZ6HyL2BbMr4coUfe18CTkAW6Qc	23964	3NLNnVSpgJKM3SYx8gx4mNf2HZGwrraNUpSETaY946kJa1KtVckT	1593	980	446	12463	16064	jwHoEybQ4u3on5pDsqGUYCfiFZmohjML118umPBVyKQax5XU4uf	11787	16913	16913	1618983540000
24145	3NKFEUQdePki6hywBp1vUX6BSP9dTHcPXBoZc2eBSYjR5qXGbrb3	24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	1405	881	455	12463	16065	jxSp6XNH7EfSgCRN3FkqE7YBfq9yQgF2ZF3z7DNQ12igBherKX6	12019	16914	16914	1618983720000
24150	3NLYqh3ioipDgpeh5J9WyjgbZyT444YDbjgLNpkUX7XuSJVTPoGk	24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	1490	1274	455	12463	16070	jwdUzNfWbJV7HariCqYr5AUSPoVX8XuFjcPTp2zPAT6TwYNEBkC	12020	16915	16915	1618983900000
24153	3NKKGzjZBptwpWPDTWYN8MraAE5Ypo8FfJhG3e867cqckqiDXgwm	24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	1623	830	455	12463	16073	jxaMMQhRyvU9k4N9Cs37QfSR88g1zWLzuBzLB4KLtyqPTrVTBdG	12021	16917	16917	1618984260000
24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	24154	3NKqUW1uaQAEbVaJZ7UqXvYaFLsM4gBC3q5okMWJDik4ucRyoKZr	1581	778	455	12463	16075	jxzfxbUmLBVa8ZqQJeF6SNyaPp9gZifpJBHHSSzNHbjTmBnFK9Y	12023	16920	16920	1618984800000
24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	24161	3NKip7N8Zp5Du48FXSMoQefFLJVG5aBG3cMG5xtZj9sC1HuCRvww	1402	882	455	12463	16082	jwhYys1jQSC6Rt8QAMDXYzZiG6jY18VNa9ms3GkTN6qc7jsghML	12026	16924	16924	1618985520000
24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	1483	1276	456	12463	16086	jxycpaRp5ndNrjucKZC6URUPPMzRpAzo3hJYuEnz7afmfnfTGaX	12029	16928	16928	1618986240000
24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	298	1062	456	12463	16089	jxThKv88rrqeEjTRHaPGNNtU91upHVZwD8n5kpdY4Y6W56YvHhQ	12030	16929	16929	1618986420000
24177	3NLVcxx4khpK5qF16E9D7XVSdCucND3ZfvsGkWzFmJSSNYHTkxXd	24176	3NKFcE3CThHQgM5rpY8ryNcfd8Xssj8VAf2krimN7U5uXrpzsJ52	171	1128	456	12463	16096	jxK7Ym97EW9AvuovXoe9tws5bVYk3gV3bCzkpn5jDvxUG3KhsSu	12034	16936	16936	1618987680000
24085	3NLuDHEtBjhBMd8SxV2V23L5D4xozLiANBMc7KrVBgagotfoegGS	24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	1573	1318	454	12463	16016	jxAFPU7HQvev7EV9ZAGEmwkhs86eZYB5fEXSEc5K1yTDGx3xbrU	11989	16867	16867	1618975260000
24089	3NLCD53xWwEoTjnZLQ5X4qJSomSqyzuq1ZuAKHWF4EDwwrueTy8b	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	596	1306	454	12463	16018	jwPAByi13n7YhMXVsxnNUkkMhSPt5v5rt4ohSgdfsxXSuHGQtgx	11990	16871	16871	1618975980000
24092	3NLkBDv8EuDxRdhnaHTGKENj79ZR4rh27vJSgrqUeH8UNEA67qxc	24091	3NKQkYwQhFSvhU8UMr8MWWZ5HDRfqU1PXjQ81y5m4gHmSquXfJnn	1406	1393	454	12463	16021	jxtdB7ZLFee5BWLMLD76rYZMRTYSG6XVqFSrkzadmsrDcaQSD9T	11993	16874	16874	1618976520000
24096	3NKN9gDXC6FHK6VEhhfGQvpTMdXMk74iHN1Po2RkvftiENBUDH4F	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1581	778	454	12463	16025	jwA1nd6d1sTj5n3DFPKrGxrWKGGHWz585fP5B58DHsrfD9NLSny	11995	16877	16877	1618977060000
24097	3NLiHw9yV7a5KFLNj7HhSQXsguidKiJc6gMA2Ma484kxW5edzZs3	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	1613	1349	454	12463	16026	jxzTfPL3hGkkaEymQUndMKAfFhN4Tzi6afkJWA6iGnhcjDbWXWy	11996	16878	16878	1618977240000
24102	3NK3MPx6D4L47MYDb3qpcpQ6Mr9pzm9o5RFbJad2AvHSsWkAkHeZ	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1651	1301	454	12463	16031	jxSiFXjn81Sq39n3sbQSJiQq4NmG8emTiUppg8WYUoBSs3msWq3	11998	16880	16880	1618977600000
24104	3NLeeXTM3zoErgLTruuoPtQXbAsKvXpCrnNgGPbSKADuhoKQUapb	24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	1578	1296	454	12463	16032	jx9xrVTUDDXZM36RnyvZqGyb3zPxvNqwSdWSjZJbPXJQLHhw65u	11999	16881	16881	1618977780000
24107	3NLQE463wBG3jCX4a3inVvWjqjbrkQmNFC3fCsQWoJ4BrMv8DKQz	23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	1647	845	449	12463	16034	jwdatvRfoqZdBnA1GENweWUpFXQ7s8mXJ4gmipdVhJkfvS5xcyF	11883	16884	16884	1618978320000
24112	3NL8wqtKrjUDFqBj3n76gTCJZdPbQGphTnJ9qQJAmSzMh8MSopaK	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000
24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	1403	824	455	12463	16042	jxTeN4Th794nDnqhBHk66bpTMdRrTAVEiUQoMjSdWh1X8eMy8Pd	12004	16887	16887	1618978860000
24122	3NLEFNMvoVpqTWBKNxVw22cWD9NzNKNtY3XPCGFNbXgqLZqRxUza	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jxqgS3YVDRbMuzLvaER7rTUmsYe98Ct6wgV6xc713iT4P7d5998	12006	16892	16892	1618979760000
24124	3NLUipsMTYVno1LLk5vDjz5sJqQj3RGy54nvhB4MrXrT14F6tqK3	24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	1460	523	455	12463	16047	jxTFV4jhiKpET1NKu2Zrsp5tdcT2efxMavnfRvKtWsmFfbXqK8h	12007	16894	16894	1618980120000
24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	1656	1097	455	12463	16052	jwas8xmya5awLFjGsNggSC6vgVqeyxDQhe1vqZ7EqAnAn2BuxVd	12011	16899	16899	1618981020000
24132	3NL1x2QyccbcH8hEvL5rPjxpqiyC6a973E88GJx8gxq5GyyMM421	24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	1506	1127	455	12463	16054	jxgz71Ft8oAxS9D9ScAKuuUWCer7ZD9VNqF27hpym8CTi6Y3ryR	12012	16902	16902	1618981560000
24135	3NKzYmPoQxuFjDfhcVi5UZ9pGt8U43fem4eE3p1rVjho7QiVrtVd	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	42	1115	455	12463	16057	jwAE2rxuAYnWwAXn6vnM2uijbdo6Rs1mkb7z97spDx65K7AvNhw	12014	16905	16905	1618982100000
24137	3NKkWwnt64q89JTayfefE9UQCGyhbmBPFESCZsFms8UraaDZWuuQ	24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	1483	1150	455	12463	16059	jw79pRowYJoLaGbKqxzTjpVP7GNsAVQT9urbcjhTbQCsnWpjCEY	12015	16907	16907	1618982460000
24139	3NKrkKSnMtE4ZRi9hZzJ51oEpE6Ag3bJK8fmrSXHMaeepouGjH3F	24138	3NKNBwd3GP8Ntf8y9UYDrjVrDYpRvdhJ6JvtLzDmns9DfoKz3324	1405	851	455	12463	16060	jxuNb6hB7jNpXk2QVFap9ic3xPfjVSnVVdbzyxRo7v5PkgLXaBf	12016	16908	16908	1618982640000
24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	24139	3NKrkKSnMtE4ZRi9hZzJ51oEpE6Ag3bJK8fmrSXHMaeepouGjH3F	1602	1369	455	12463	16061	jwTcuCrDcWCcZo4L2ufttMaBhvpUTQi7wpMenVdiow6GrfjK8Dd	12017	16911	16911	1618983180000
24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	1553	776	455	12463	16067	jwmzMDeyYykPyizfYXaqoLfVC8gpL18Ucyp1z1QMGjGQd5tHgpC	12019	16914	16914	1618983720000
24152	3NK9nrc15jXMJG61Zf1xXSnNkPWq9euhY3bwoCPn5D5No5EDPR8E	24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	1619	1149	455	12463	16072	jwJyLU5MnKS1cKH7Rg1hKhF2FD4SAUrVNVpSeJHpGFP814c5a4s	12021	16917	16917	1618984260000
24154	3NKqUW1uaQAEbVaJZ7UqXvYaFLsM4gBC3q5okMWJDik4ucRyoKZr	24152	3NK9nrc15jXMJG61Zf1xXSnNkPWq9euhY3bwoCPn5D5No5EDPR8E	632	1256	455	12463	16074	jwZnhmhcgxnWNNo35Vva6taQ5gBP7txRKSCQdiRm9ksKnLhZU7L	12022	16918	16918	1618984440000
24158	3NKaqtxrgkjTobw7spLVvhM5jrDzV7J27LDea46y5aNWoC5uuyHp	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1581	778	455	12463	16078	jwhXr1RvVgQjZ1zw1zTLx6m3uwdfKt9AiyQZ6GpmzVr2SfMCvsp	12024	16921	16921	1618984980000
24159	3NKxhrytV6vfGexdfeaWyZVCLgVgaPTLv2AT1qTmg92joEis8Nhj	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1406	1393	455	12463	16079	jwTUGUDAnKnBUxnTvqzcCkziY3RtYGzoNT27MHs3U4DnE5VZjKb	12025	16922	16922	1618985160000
24169	3NL4A7vfHS8Nz6MUDA2WfEt8LyGtoK1GqnvxxanGuhUAuHMSUVRR	24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	1547	1378	456	12463	16088	jwJXBTdfZ98FY8hfJA5mZDCrwmnSFejToBjSTX66Arm7p8fYnXo	12030	16929	16929	1618986420000
24172	3NLT6PANSrVwwg3qPDrozEnRZtUppaFSxEGhqE3CAAP4ANoqHQ7v	24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	1594	960	456	12463	16091	jwQxQUNoodTxRpqwaggb9tRDWoZE7c9oW1ZHBCWaCDtoLQ1rQA4	12031	16931	16931	1618986780000
24175	3NLJ43NHuHSgA9bPnxtZUCJBJ8G8UWV3GY1onosmZvgrk82YqZ27	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1601	1142	456	12463	16094	jwe4gBa6BEh7PsnhMRJ5gaxU9kJBT1jVzYJp8xf6EMdx252Lw4L	12033	16935	16935	1618987500000
24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	1637	816	456	12463	16099	jwUAmH35iFv3NpD5H6FehHtuhzYob5ZUCTzZrbPVuuBKEz23DWP	12036	16940	16940	1618988400000
24182	3NLLZxj256cWeH43a9iUNBJzAKzzj1J88qCRCXjDuzWMVEipD8Ad	24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	44	1325	456	12463	16100	jxF3FNngmEc3i1NydcinDHQDZjEjmT5CrPGSRG47bjqh6om2JYc	12037	16941	16941	1618988580000
24184	3NK4EysMtN1FufbfQu16HWpCAqC7d9g8SYwqT76UnzcbtgsRdU3t	24183	3NLec4sQrzarD8MJBcEB1wsEus9ykyuXvv5K2kVzxdRA4BtJZcQE	1407	1395	456	12463	16102	jwkECy39X3DQAd2gLazKVFKbPJCkMythECyfj4Dyg4dNi6AJpok	12038	16942	16942	1618988760000
24187	3NKZN3bR3REsBjtroYsyo7LNcKd3ZrcbwqKwfiXUkjryS321u95P	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	80	1273	452	12463	16105	jxMpyyGg7bPnnuoShmq7BUXGw3J2csfQpJsLv12jabzBodvZZ5E	11936	16945	16945	1618989300000
24192	3NKhS9s5q5pN7gTmS77DHSCXuMfdGVEd2gCQC6peCD7CJNGVbxxH	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1560	1291	456	12463	16109	jy1F33dNQosxM6h1A9wp9BJb817k39aYSxNbowWKozBEkrQ3DMX	12041	16945	16945	1618989300000
24195	3NKG6DiUbpPbfMwwcML15r2D2ebV8eHkWDJb6s4TiN5UXujCcHF8	24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	1419	814	456	12463	16112	jwPaNKmMfMuFiNjVYSzD5tFMhQ6yPaizENC2ZnPLZVRpnCP9v95	12042	16946	16946	1618989480000
24146	3NLC1tjCkBu3mJ7zvx4kyMbbkEurDHEMSj5hBAHoNbAuUp5jj3Eh	24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	1657	1344	453	12463	16066	jxZoZQ4yTCr5RsbxcpErs8Nti4boXS3vJP9DuHdtXd15TugoER7	11966	16914	16914	1618983720000
24148	3NKz7LtpWk5bsrRpXyFswgNDuNum1GfLyZKEdybxTvX6A37GK8Lm	24063	3NKqsfSUr2fo5S9kMXwZkPYTw5AdHKMwFrZRbcghUZ2AVc96Znqb	1657	1344	451	12463	16068	jxucsDa3MT2Jdxrdi8qEFpD9eyJPEFWSU1q3e6VCRpAR8FPLoGW	11896	16914	16914	1618983720000
24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	1402	852	455	12463	16071	jwxYtKo4cpR3thZqcwJTzBrZcTqrTx4a4J8tu1TesZVcLHuDNss	12020	16915	16915	1618983900000
24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1672	1159	455	12463	16076	jwH2vxcnMvdC19aboVjk2SoxY1YRRs876k4RnizSXuQzjGpLjYU	12024	16921	16921	1618984980000
24160	3NKFxQYZq1Z7eo564dcAXApEViALmrCax56Z6jkVknRpNrbERuRi	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1637	816	455	12463	16080	jy27WCLwi4SFFGeE5LwaiaAUZL2NPu4APwDEPFkPDJ9z4LhXwaw	12025	16922	16922	1618985160000
24163	3NLiS6WSpV61Hko4fdd5yVGofmNyonqBZtUNDkAkLgPNhHn4rKJg	24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	1613	1613	456	12463	16083	jwMRP71mMG7dDKFz7kcuo5RmgXTaMb8XZPDApHuE2PQEDR34c4W	12027	16925	16925	1618985700000
24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1458	957	456	12463	16084	jxNT5BAjGFLh7jXxCKBdmBcWmZx2W3tU9NASHEE7M29hoNbRfdg	12028	16926	16926	1618985880000
24168	3NLfSoqNAEyWZhGqfCQwrAjNMpUAJn7jaRvXLx2oDmiye8cyENh7	24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	1407	1395	456	12463	16087	jx4NUvUyEuJfrqA3NZLxSw4WogoZNpjgMoVcV8mHC5DqBSdPXxr	12029	16928	16928	1618986240000
24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	24172	3NLT6PANSrVwwg3qPDrozEnRZtUppaFSxEGhqE3CAAP4ANoqHQ7v	646	646	456	12463	16092	jxaodssJRyWR987T1XLoo79qfUD8VrsQArC4L4a1PKYJGk9jmEm	12032	16934	16934	1618987320000
24189	3NKuSJrrfMimLafPrjrt6cPrL5q6RVg8Cz8pykbQZqRtoXB4cHpo	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	684	684	456	12463	16107	jwevTSDvXCE3T9K9FV6G8oNQgFWCrRc91CCk2Ui5wiJgXSn4gWy	12041	16945	16945	1618989300000
24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	80	1273	456	12463	16106	jxotDFDNBPFZ4k8sPdcF4VbQUznw2cyYhXihGWdRzRd63CZTdtg	12041	16945	16945	1618989300000
24194	3NKHp7v3emunZbWuF6WGRNaiiG3rcXo31bwuWb9kPBD8L35NtFPE	24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	44	1199	456	12463	16111	jxdJ7FtYGbi8cdsBq9dTkZon2EhBaFqoLGtFebPaN2Jmw8pUyXz	12042	16946	16946	1618989480000
24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	24196	3NLAnGwBA7PkUUfzzjkJH7U4pAVSZeDbc48FHefxJ8Vn948qE5hg	1406	1393	456	12463	16114	jwckyL6ndHd5Le1oEsR8aKyj48CcxXi95QfyhYBFdJzTvG7uEad	12044	16949	16949	1618990020000
24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	1624	1334	456	12463	16117	jwk6xfsFwaVKUZK5ygo5YgfbF2XUq3eEQpohTkE1GkiAALAQ7KK	12046	16951	16951	1618990380000
24204	3NKXXZQRS7tdehVeFgKduk58XMtmzFVMWaAEFo3VdUeXY9xfmgch	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1439	1279	456	12463	16121	jwx9F65f9VhgGjYNfCoXo4FpQoccHPQJLhVMdwUWoDrq4gZ53XF	12048	16954	16954	1618990920000
24209	3NLN2vKad6YS854uxAjMQPXC9cm25fEoRfnot42DmEya6K5NpzeP	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1593	1220	457	12463	16125	jxZKjYbvjomeeTtDQ7wMN7RW5QnUQWDPb6TKvo7Lg6iPaLrECHB	12050	16957	16957	1618991460000
24214	3NLhQbNdkrB95pS4D6KhR8ScwqLN72n8nzrFiPTdkHm2tNhWseeR	24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	1402	852	457	12463	16130	jwGcdFTwefikoZJR1XEW82zZD8e4rCYq4BkDLr51UJmm9C1JnWo	12051	16958	16958	1618991640000
24223	3NLZqV7wupkhg25PVUhggjz63NcSALvmFew4iQLZ3uE6bHqoPTYt	24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	1648	1158	457	12463	16138	jwfojVNwJGNW7v6pENCz1JKw3jDRA9DzJbLcoWsWRZqNpUEW3HM	12056	16963	16963	1618992540000
24225	3NK84oJ15fLrEWhRiPda3a7FNnbqjE1CEuyqMWy4oitvrVSaAfSN	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1657	1344	457	12463	16140	jwga3Vt9MmTGh5wnKzkeMLtVY7QTgkbLxCYWE31sgr7z2aEpJR9	12057	16964	16964	1618992720000
24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1609	1087	457	12463	16143	jxk5ae4xWHN1irmHjT4vVTsNiW7wCi6tDuKfxcHWPVSWDpZ6PFP	12057	16964	16964	1618992720000
24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	1581	777	457	12463	16147	jwBuhfkm6bZkdS5P6YfzBSNsXwuGvqgGPUm5yRkbNES5zpYw8cL	12058	16965	16965	1618992900000
24234	3NKHCpSVZe59p3hjATjueUckL2H7qmZYK2cRE69aQcn7F2WpdxUS	24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	1407	1395	457	12463	16149	jwf83rhFjn8MzPF77dZ8XEEE5coJ8WtRP7TMvNgRBm9xmo1Azvr	12059	16966	16966	1618993080000
24236	3NLEHw6RtekKqG6Yhi871FhWQRfdz3iQSqEte5QCSzZJWdupmQMH	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1403	786	457	12463	16151	jxTie5nb9jW7bL7X4ye63PJcewjfBpCjxL3sW1zA7vpysjSmgwK	12060	16967	16967	1618993260000
24241	3NLD1HybqC9W1zs8stKM8ASnRoYhfS57EZESiGKmcgM7XnpTgDB6	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1406	1393	457	12463	16156	jwcWfunygMTFNAWSvKkdPuXZp2WXVx8wUq5JizEeGvPs7ZCFPcP	12063	16970	16970	1618993800000
24245	3NKo9S1vPZYwYrJ51nuZoYNQ8pJ2M44xrcWrVqddcAqVyS9S3VCc	24201	3NLnLcyfR42rFd8pT8TeT5PEYnFYuj6yB3uE1NP7bUv6xgW1YACQ	1500	1297	451	12463	16159	jxfEstvoabBWSyFa26F8CPegrJGDaRUs3S8E2WkWnGyNdWAhky2	11918	16972	16972	1618994160000
24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	1627	1139	457	12463	16162	jxtMEtYzNTn98xuAEumCw1UEZ48PjegCzMuojzMyS6oyX2qC9ZN	12066	16976	16976	1618994880000
24251	3NKbLHbkt9gVDsSMhM9R28whghWptQke3k5a2prJ5XTBj7o4joye	24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	1483	108	457	12463	16165	jwqstk99pP17BmSfJFFaxG6kHUwVyCB4tp8DQTa3SqCLoHUHFzZ	12067	16978	16978	1618995240000
24266	3NKdAkKe2LWVQZ1vzZDynMUBcZFczSENKzPJnY1mPsN7hqRwekRB	24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	1634	1331	458	12463	16178	jwipsnFE2DaFEeVriYe6mQktZXuzVqQi128UzZm6ikVAnGD1uqK	12073	16989	16989	1618997220000
24268	3NKMs5fJVp3LVJSkV3vKKnUQZLZcM5kQD9CZDzgL6Qwzx4VfBjuB	24264	3NKQWf3mqmFSnXHasHiGUjHkkf3QxwKztF1eqekRdjU93Q6AZWuo	1516	1048	456	12463	16180	jxe65TFahfLRHA3ruFRQwNu65TLM9JSs3ARfhCg8NXNwg53hhss	12046	16991	16991	1618997580000
24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	1483	206	458	12463	16184	jxgWghawox4cr1ZX5RXpDc5nd7h4MnC19g3qLSVah5UaqR33rKp	12076	16992	16992	1618997760000
24277	3NKThGX9u6s2ojXvFSyCF3kzjwFfxW8hdbHyNSXdHkatb2usSGLB	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1508	1261	458	12463	16189	jx4Npq6aiYTvpKzQpVan3h29W2Q7q1ZAD2NQKPWeCkxCGTXK19o	12078	16994	16994	1618998120000
24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1637	816	458	12463	16192	jxzakEndhm6K6M6TwUnoQwLetnvHRwFf6TtKjMrLJ8kY6qWeyi5	12078	16994	16994	1618998120000
24176	3NKFcE3CThHQgM5rpY8ryNcfd8Xssj8VAf2krimN7U5uXrpzsJ52	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1581	778	456	12463	16095	jxNaKUgbJLsaxAGqduFjEaQZ3VDWqahSCcKgSHr1kcWGoZURzH8	12033	16935	16935	1618987500000
24179	3NKoSBQNJBEATb6SFmW5EMxU72nopcjLX1cGMSxB33FjMJXGHFzF	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	563	1113	456	12463	16098	jw8FUYFxaCL2BUQjCeJEUd6N6GvjW2JyPJnKpDmkV7vGZ37G7QF	12036	16940	16940	1618988400000
24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	24185	3NKPffUtfkjkSt3H5GyngtJnnQvH7ZXw5okNQuMeh6NwuNW2xHkf	1579	1389	456	12463	16104	jwoxSmXWSF7fTP4HiSGyE9xoAJAozo56uUZYxMzx7zZoppcTbnp	12040	16944	16944	1618989120000
24191	3NKZhgUnCDjxpUkA556i46AWkDz4iGqcfi515547PsDo42hhtAzr	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1407	1395	456	12463	16108	jxQm5nej4B9M8ng5cdCZa4nnnqkrpqV8hxKCer3vBQdWLBEtmWu	12041	16945	16945	1618989300000
24202	3NKi6Beb4ooqb8ejExRym9wp3TykF9grV4fHbJ2o1wXNmZn2oQd7	24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	1500	1297	456	12463	16119	jxnYuqtBTgBNJ65euCjwoQphWcSAkxWPdjiyotft4TTMaAVkwSx	12047	16952	16952	1618990560000
24205	3NLrUacir5M1SUX5Bk1APKEDhJxBhdw8Akexg7GYZxGTgpjmkkae	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1402	852	456	12463	16122	jwF8nZFt3TcAby9JKHJuvW74EoSkLcRVvNn6X59PiSkdpyQ6vaA	12048	16954	16954	1618990920000
24210	3NLEoHFo3FgQWnmEY2HwG8w9VMqzkZodhNYBbP3oKjmuaZjU1Sdc	24144	3NLGWYPqK94zsvtKjRTZj6taKdZ6HyL2BbMr4coUfe18CTkAW6Qc	1593	1220	446	12463	16126	jwHoEybQ4u3on5pDsqGUYCfiFZmohjML118umPBVyKQax5XU4uf	11788	16957	16957	1618991460000
24212	3NKRJa3R7V63KtjExgMKbzebKSQWmdk6N35MkK2nRHDh5tViN6RL	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1631	794	457	12463	16128	jxjZmJyjY4T53AoFh49sFFNUt1qP1j2Xkt3eSq4EoTvu2767XAq	12050	16957	16957	1618991460000
24219	3NL2tLLur6JzMRpphfLynDzCULs7rH8M1vbPKgKYSJZYpmNVGq8U	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1490	1274	457	12463	16135	jxqdRRHTjHrkojEEbvV14yrXtcZn2CvTXUJUUtrkt7uv3JeFGtQ	12054	16961	16961	1618992180000
24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	1406	1393	457	12463	16139	jwMFf2ZLRv8ksYVaT91NgExFUvDdbR22PnxKks5zJP8YCV4a7CM	12056	16963	16963	1618992540000
24226	3NKEKMyQMdicXf6bz4bbSSyh91h3oaq7dtN3rLxR1Q5EEjw4HJNo	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1406	1393	457	12463	16141	jwdDyocAxheNXRSpgYkjQHyyuNV48bjXXtRut2Z9pLE8ZJbQV12	12057	16964	16964	1618992720000
24229	3NLwZhKAXZzQ4Dx69Ypi17DfNTNYUjVHTB2w6wXciXKaKrLgkvcg	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	633	1384	457	12463	16144	jwmugbGGknnUt6Aamqz4czCvAQnLZjTZyo3a7N1UjSL5CDHHRpC	12057	16964	16964	1618992720000
24239	3NLTZb3xcZbN75qWdLVr9SUzMEypz6FNQ172vHZ48PBNkFFNq5XC	24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	1448	945	454	12463	16154	jwG5NF9uLnxW1pTfp5ipR5C4EvZsD346isvS97rXWASX4tmBMkD	11999	16970	16970	1618993800000
24242	3NLxJD4npbUD61tD3vC6nshcA3e8CF5Gsn2f9hVP6hvChDPC3cGg	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1448	945	457	12463	16155	jw7wzc877TetbFfqRyxhq4TGu3k6xieFTJ4mMrFH9JkQX11cjTd	12063	16970	16970	1618993800000
24249	3NLgs38RFg8zbYcGeiGQpNG78hkxBhpV71Rn8Z5uTJwwRDKbnXri	24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	1581	778	457	12463	16163	jwKMBZKp1j75tbj7cgU2K9Hv2HFwLw7sfowDpwFsjhjLWaLnDnc	12066	16976	16976	1618994880000
24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1406	1393	457	12463	16170	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV	12069	16980	16980	1618995600000
24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1553	776	458	12463	16174	jwjjPbL49xfy6aYLbsvGEwFTfDEXeue9CRhPi3oPAH7KqzktUax	12072	16985	16985	1618996500000
24264	3NKQWf3mqmFSnXHasHiGUjHkkf3QxwKztF1eqekRdjU93Q6AZWuo	24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	1516	1294	456	12463	16176	jxxAJXhFbK2CPzsdjA7yyT5gxKGXtisziVQMZhHJT4wLo5vW2h4	12045	16989	16989	1618997220000
24271	3NKkWvnnZPwbLMaU3axYAEzQkMXHqdFtAXtZkyUtA1bmuhMU9aMc	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1611	1095	458	12463	16183	jx8Wyy6sgt8yUSmcTMg3K2f2PXLaVfonHg5whn6jYpEBkHda3re	12075	16991	16991	1618997580000
24273	3NLUzyyGu4CCcz3CVL2tKvkXMuRswCw6XRouvKkbamdHYhb3LMpx	24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	448	1305	458	12463	16185	jwXKD1QJswQzVjhphCj8Guj2f7rd5zj2tzuTwRDQxWtDR37UyeL	12076	16992	16992	1618997760000
24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	1631	794	458	12463	16187	jxAtuBzw17GFcmuBmYe6viVAbc3WLxXeBrpMBV8LUaRMDqsBKyR	12077	16993	16993	1618997940000
24278	3NLWw5uDWjppL3kCrDv3VuHBW9NM9vtFy3RzhAE7CGtNCLFpdBN7	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1419	814	458	12463	16190	jxpDLehdDU5Da8HMMXCj5nWoykDZddRmEDBo7nSUK593LY822qN	12078	16994	16994	1618998120000
24283	3NLYScMQMW6ZGFjwh2jMjnFRxeNq4kVdSzi2qobFxGmXkGgvYk58	23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	1405	849	444	12463	16195	jxs5C3uyrWztw6voeGG2qv9rsxCqVNmEptYW9rHzx81pXWQL1UK	11793	16995	16995	1618998333356
24286	3NKZgqUWXZM4kqvUwso3BTJSqSiNX7mPm1yDuCRPDC7h1U3QnbnE	23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	1405	849	445	12463	16198	jwjGua4QcJpFTywpRRWgtgBL53mTypkrWCqw5x2qDxqgHvX5pQu	11817	16995	16995	1618998403257
24287	3NL4ovbFYkoU6oBBg7DWFkX4wLud2A7DkCYFDNtjWunJByGB4hSt	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1490	1028	458	12463	16199	jxzbVUaaPpkB6xoaH66sSJo75dY1neKfx6sHHgPGLAZ1ns95DBx	12080	16996	16996	1618998480000
24289	3NKRQTRKuHXseWYJzyA8Bg3oUJPMaUDeafHZE1Md5ikwp1yiETa5	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1467	1130	458	12463	16201	jx4m7dJMCjVuntG87NGno2jvMaEmRE6UEBywQtAWwRWLomQYA5Q	12081	16997	16997	1618998660000
24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1403	824	458	12463	16203	jxbVee1dHNvisFK1xz6X4u4Lynd75EgWtbR5PncBi9KJ1YfHjST	12081	16997	16997	1618998660000
24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	298	1308	458	12463	16206	jwqXzGLDmauxwWQFFBAXuVhrmxK1qfXT6puXrgk8cHwwJey7o5t	12083	17001	17001	1618999380000
24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1657	1098	458	12463	16212	jx5AikytNiZKJ5PnuM2BdrcZ4n2rCDf4MghhK4fFhmH9a4dF922	12086	17005	17005	1619000100000
24306	3NLxbKTMiPXASXmg3HoNGzq1pPtQXRToa5A2WNxBghstEpzovF85	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jwvRt5tgpE3oBzaBxiUJB84YWdtoZD8epPX3BbCX6kjR6kyhsdo	12087	17007	17007	1619000460000
24311	3NLRYu6bFEahfJPd8s8YsRNRAMBXNr3EtaF8q2Tf2BurQFGKez4z	24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	1623	830	459	12463	16220	jx2eeuHmVdE3e9EM9y77U1ELuW17p7XLiW2jpo6n4KSdeMbs1L4	12089	17009	17009	1619000820000
24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1573	1318	459	12463	16222	jxcc4DXaSReiEQzQVrCLLyJvPRDj9HwCBBEieNLJFGV19QqBbK3	12090	17012	17012	1619001360000
24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	24177	3NLVcxx4khpK5qF16E9D7XVSdCucND3ZfvsGkWzFmJSSNYHTkxXd	1406	1393	456	12463	16097	jwh9ETjco2XQ13Q7coNGwdG8GCvdom7zWM8Urn6Yx2TXyLyhJM9	12035	16939	16939	1618988220000
24181	3NL3Tztogcfo3yCRJBp3UvFPi2wNc5RhypJ7woRLh5LzAvybfP4Q	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	563	1113	456	12463	16098	jwomvPfJqkYE4wd7BrKek2vz5dw2jhnnVkoyYkbneBBVuDPCUjt	12036	16940	16940	1618988400000
24183	3NLec4sQrzarD8MJBcEB1wsEus9ykyuXvv5K2kVzxdRA4BtJZcQE	24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	1447	1099	456	12463	16101	jwFLH8yZf7wgsyfWt34d4fssZ8Ez4WTsDWwX3BwGBcyaeEDht4i	12037	16941	16941	1618988580000
24185	3NKPffUtfkjkSt3H5GyngtJnnQvH7ZXw5okNQuMeh6NwuNW2xHkf	24184	3NK4EysMtN1FufbfQu16HWpCAqC7d9g8SYwqT76UnzcbtgsRdU3t	1587	1231	456	12463	16103	jxRUv7odNVcFc8jURbJa8Wk9hKeFU6sf6DALjncd5Y6jWNGK4yD	12039	16943	16943	1618988940000
24188	3NKaq4JgdVoyxGqDVrZQUKWParoEUpG8HAkMo1HhBT5pedfHnxu3	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	80	1273	456	12463	16106	jwTEJvb2jeaunHgUGun6XgrB9Uf2oG1vWdP86URAwnvjjHYzDXW	12041	16945	16945	1618989300000
24193	3NKZPWhkCm7UkxNrehgAFSpaHATfw4L7waFhEe9w9SawY2YwFsmZ	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1403	782	456	12463	16110	jxVDNiyQA1ieoKWWjGkSM2LcpeZ1Gz8akzSwT618m1dNRPNHtb2	12041	16945	16945	1618989300000
24196	3NLAnGwBA7PkUUfzzjkJH7U4pAVSZeDbc48FHefxJ8Vn948qE5hg	24195	3NKG6DiUbpPbfMwwcML15r2D2ebV8eHkWDJb6s4TiN5UXujCcHF8	1670	1282	456	12463	16113	jwd27Vh5FmraHgbtL4GKzQtAQpKczekKUvkoug9G1Es6fRXDygW	12043	16947	16947	1618989660000
24199	3NKofke8vVPCXodxPUra2kPorD8eZVRmJ9aw6iN9Qb7HyJuvjEAY	24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	1402	892	456	12463	16116	jxLxNsZB6bKmC71fqQ8Kjs3bKs8WZm3e4v5Qvoii2u5dg2T4qE3	12046	16951	16951	1618990380000
24201	3NLnLcyfR42rFd8pT8TeT5PEYnFYuj6yB3uE1NP7bUv6xgW1YACQ	23980	3NLYthha78PRaVdgarqQDwDikBLRgS5biW3cfvvJq4BLqP32Dqoz	1500	1297	451	12463	16118	jx1f4wnbzNhaMuHgWJn9pZJUUpYaXhhUDpMBTw68Q1XaRx4TKUH	11917	16952	16952	1618990560000
24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	24207	3NLQSyUbSkhrq4Nxa4LwWjBWKcw4NvfBiAisMJs6ijor77Ca65ix	576	989	457	12463	16124	jwBexrJTeTv9HRdrbatKEMYT2u2NTKYzsHAnXjSv9wwrLv69TVP	12049	16955	16955	1618991100000
24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1407	1395	457	12463	16127	jwXBFAFKyirQq2t7kSL1fc4eCjnwtphraCkqeaANRVR7Aw4qRU3	12050	16957	16957	1618991460000
24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	1471	1386	457	12463	16129	jwokaU7PTLpF6uBN1aH1FY44htzqhSdGt6DPqc8Df8YZ3hMe6D2	12051	16958	16958	1618991640000
24216	3NKLutWnWNs71UzQyzGrRLRRHosypRSi4kXVmw37iUD3y6uLryT8	24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	1403	824	457	12463	16132	jwWkbsjSEz6BUrMXh1vz9MrjkhkX6SagnRmHUh3m8G9XVYgc7bK	12052	16959	16959	1618991820000
24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	1560	1291	457	12463	16134	jxJFFDMngKY8YtTnQd1cdXAo4Zhc8FDMAWMwxCocu4x59ptVrby	12053	16960	16960	1618992000000
24221	3NLsR9e2jVmWxmtTgb1KRYuxGoayVVjHHbKZgTZUUQMhLRfcnNqt	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1490	1274	457	12463	16135	jxrgsgyX71ZoCWaeHGHRzLMtF5LK8mZHA1diJSffPbNmF9qBRkG	12054	16961	16961	1618992180000
24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	24220	3NLKRf74F36STdzRHmEeUz9hFkkSbP1nxKXGKz2aNTV3UZZdaufF	1637	816	457	12463	16137	jwbMex19tdHfypbakhhCYRPQpWPXiCcf7BrYoxbzC131KeS31i8	12055	16962	16962	1618992360000
24227	3NKuB8DyofUd49H4FdfXa3Ns3yNK5WZaWJ51t5SjTuZK9KxygzwJ	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	484	1319	457	12463	16142	jxYVXG8Uht6iNKwmnGcmWBaFcNoBaSVXE6eUjb9nJ7YBXyCLJcs	12057	16964	16964	1618992720000
24231	3NKChKcCNDNRV9w19KQkGUDahWQe1PJEkfzq3gbZSVwo56TMxr9o	24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	1406	1393	457	12463	16146	jxRtoaBm4wvf2wkczoLY8pux4PUwm8hAg3ypPNNt6HL7gZ3LGeF	12058	16965	16965	1618992900000
24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	1617	1042	457	12463	16148	jwyZMTSkzh3agZVrudjowURb3ZD3j2Rf54nH8mmssWxvkNJZcVL	12059	16966	16966	1618993080000
24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	24237	3NKqeNvVy1mKczabz9m7CmX4bL9yQryrh7rtMNm8N5rwej39w6Bb	1601	1388	457	12463	16153	jxc9UtoKsQsdggRtPmShtZTYoQQ9THRimgHwQggqGCPuuLTXwCU	12062	16969	16969	1618993620000
24240	3NKdR8eEye69WEqDbwuv14cXtY4KWB5S6XZzk6SfjibRYahuWs27	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1448	945	457	12463	16155	jwvDp6irZR8E1R195PyXYHmZEgje7o648ZdrY63CbLCzxHANuUb	12063	16970	16970	1618993800000
24243	3NKTASL93SVTjfYFJJK9eS8gbLX7Eeq1Ss4hPEVwzLBrwBHNwt61	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1419	814	457	12463	16157	jwFhqPduUBKeUeUYRiB6oJK7YwX3hNQ697UtTN8vpTwucRbTh52	12063	16970	16970	1618993800000
24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	1461	1271	457	12463	16161	jx3sqQ6p54dQuBDJ4xKS7yUkoo5TmirGLYUE7sVpCmugLd7zXXr	12065	16972	16972	1618994160000
24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	1447	1099	457	12463	16164	jxsUymKrNbD9Vwp6v5RkgpCa59LWUrHiV4c31ckR8qmy3LqayrW	12067	16978	16978	1618995240000
24253	3NLsSCm9tLyJY7ApTJJu7spsAVmNNwqrWnhGCFgnueoE3YAFCnWV	24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	1406	1393	457	12463	16167	jxNcCpZExMVd8Qoxg3wCSW8sAb8rCuLS3295u5D64LKkFrbLpuu	12068	16979	16979	1618995420000
24255	3NKkdZazifcePiUQYJyQ3TfnxEwyRgxQTxwdgoUAnqeMupzVCann	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1642	1121	457	12463	16169	jwYZR5FxbVv9QgE6CyY4rUyacuETrdqgWFZWpTQNsb6V23bzkGe	12069	16980	16980	1618995600000
24258	3NKoU1mWJTZBghYhgpDJVEvQgbXfz2LrE1vnbYXNgGuqSec88xyc	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1623	830	458	12463	16172	jxHaErCKZtmqHRkZqEUoP1NArP5eX3cCFjmjLbVuwxMpSBsw4pS	12070	16983	16983	1618996140000
24260	3NKrYycH7P2p3JJD9PABwLXshzPeSDgcqNDzy4SBbtpc5a2f2EAZ	24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	1448	1311	458	12463	16173	jwWNJYM6rN8qzaU6ZEkbiSaoj1NkF8yx7gxUoE6zXxE7CvTevnM	12071	16984	16984	1618996320000
24263	3NLxsKATgLZUoxjN7FhQmkRpLUCX2iRu61pWpYSA3uRRN1HGVZyG	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1440	1377	458	12463	16175	jxiYzr795AgPN158QE4aYtBUcGr2gnKT7Z4153YwN5H4i6rAgWG	12072	16985	16985	1618996500000
24265	3NKBRHJZep96hCoFMWFEgJdLtHocCN9ajDabQVHFDCA4uGzrC2TE	24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	1522	1076	458	12463	16177	jx2Si39ebkYiRQSghZ86XTPvmPusDs2AR6j6dYz9Gec2jwsNg1c	12073	16989	16989	1618997220000
24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	24265	3NKBRHJZep96hCoFMWFEgJdLtHocCN9ajDabQVHFDCA4uGzrC2TE	1407	1395	458	12463	16179	jxNychWmsCKb9AJ3vBUhfjDyHaPxWNJPo1NzjiucsUbdj8zVZ8S	12074	16990	16990	1618997400000
24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1476	1371	458	12463	16182	jwGB3bDNhg5Fgk2apK5RhGDfjPPpsvYKsMx16RVinq28CNMCL6J	12075	16991	16991	1618997580000
24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	1564	1212	456	12463	16115	jxu4HxNgpqwBetXeabiqs2NS7SQAPKjiy1UsVj1wayNQJ9E4whq	12045	16950	16950	1618990200000
24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	1617	1162	456	12463	16120	jxBryEmT9PpNpaqWbkCWbq3sWHPz6gmfo8MCm92ncNP6pSyJubk	12047	16952	16952	1618990560000
24206	3NLfuW9Z4hwqv6fyYA1FkyV6MosFU2AeKNjf9bqfFi1aPqaTan1A	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1439	1279	456	12463	16121	jxtWcP7G7Cu4owfuUAYC8idGVxRoRNzv7XEX1tYtjdmx4cP9XQp	12048	16954	16954	1618990920000
24207	3NLQSyUbSkhrq4Nxa4LwWjBWKcw4NvfBiAisMJs6ijor77Ca65ix	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1581	778	456	12463	16123	jxfveNLicMsNADVcFCiwiF8e1gBDESAsSPfj88N6RWG8j8YEyhn	12048	16954	16954	1618990920000
24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	1588	1392	457	12463	16131	jxfkbQDhbbrxSex75MLE14Vm9twvHxpRfJ18FDtpgDuMGZ1kuYU	12052	16959	16959	1618991820000
24217	3NKzKHZNw8Vrxcv5iFkUAeYktPZ14WTc33FVJJFNVgFqRWeR3UcZ	24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	1481	790	457	12463	16133	jxB5yuuUfBtjWjiP8qNr9jb4LM41y1YSQoJPbz2S1r9VTAsTNE8	12053	16960	16960	1618992000000
24220	3NLKRf74F36STdzRHmEeUz9hFkkSbP1nxKXGKz2aNTV3UZZdaufF	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1407	1395	457	12463	16136	jx5BBETVhH2r6YkHjCQw4VBgWyv531V4PkQfM6EVTWYX6oKFuHm	12054	16961	16961	1618992180000
24230	3NKyJ45XDAwH9XnLnpFLjVXz8MzHj3W4uipk56KZUKvmUnBRxuG6	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1407	1395	457	12463	16145	jw6uTyVTbySWd3GvcrAv1wfr67saQFbcAABysybQEb1KdGsVyae	12057	16964	16964	1618992720000
24235	3NLawNPwSeY4AKVUn86hbFJXWgaijbeBDiugPnp1xTQnL1YRfy1b	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1402	862	457	12463	16150	jxGyx6UWajcFTKWH16DXMzg4rM8qBbA13mwdU1yYgWGZf1cui2u	12060	16967	16967	1618993260000
24237	3NKqeNvVy1mKczabz9m7CmX4bL9yQryrh7rtMNm8N5rwej39w6Bb	24236	3NLEHw6RtekKqG6Yhi871FhWQRfdz3iQSqEte5QCSzZJWdupmQMH	1607	1102	457	12463	16152	jwBEp2asxN2hQ97SRVF71G8aNxNjFufAXJuFcZGJLw94bvxfkYT	12061	16968	16968	1618993440000
24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	24242	3NLxJD4npbUD61tD3vC6nshcA3e8CF5Gsn2f9hVP6hvChDPC3cGg	1407	1395	457	12463	16158	jxSTZDjCkWKeatCiYWCRvsFQkbdUxUDPpR5ww5XF9bVEXCkfbeF	12064	16971	16971	1618993980000
24246	3NLbLQesMpSWJRNqbhSfgQVqCAGtF9J6NuXiwZPBuATDvWJLAvQn	24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	1500	1297	457	12463	16160	jwnBA6uGmUgY6R1r4E9j6wgq53EhsYkDcmvUARhuDiNft41KW8a	12065	16972	16972	1618994160000
24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	311	1181	457	12463	16166	jxADmyAwcA42yxmMyGKVJyYvSz83mRs2pNdqy7eeGxEwFpWu5kr	12068	16979	16979	1618995420000
24254	3NKhhDXGYfzeaSNh71dTv3iRmBB9mb2EpVTpBFAk25Rn4RArTzQ7	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1456	244	457	12463	16168	jwMQTRvSDGziDjkxxNjrZ7mCEUcxWC7d5MhXEj3877nAgTh8gu6	12069	16980	16980	1618995600000
24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1437	155	458	12463	16171	jwr9bitEoZRU5kBKuSZzYPezR5WJ8xH4raRGKGPj6AWiNr96ks7	12070	16983	16983	1618996140000
24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	1448	1311	458	12463	16173	jxi1QxtFFdzrBBHAZeMBQHkKe7QH7PXRFUFL4YKVfBeevETiwUz	12071	16984	16984	1618996320000
24262	3NL4HTcD8gXxT51kjbpvmxeRi3BNCP4rqHzCr7NCrUaU5PH8Ds3Z	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1440	1377	458	12463	16175	jwtqKJ3bVbMg939DKDQk461sT4udhNLvvNDE2F8zpAeZWQbFPWg	12072	16985	16985	1618996500000
24269	3NKZL6Tbqh4yMqDZCK1zJvBAruykskqS8skHuP9QUoww3M28BZg4	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1599	1161	458	12463	16181	jxmtgEUAwwkmSEN9Syicgotw9fSUqCng5qyK19jJ3YuahYn9fif	12075	16991	16991	1618997580000
24284	3NLFkcn8hG5wsjFM7MS4qcYVkc9GbnBBCDEjEDbRni4SPng3isXA	24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	1542	1304	458	12463	16196	jwzzWcqf8i3TcYs7b5fYHEeVJdYWv6xhSGJzCA5UxRbCC8Yj1Jg	12079	16995	16995	1618998300000
24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1406	1393	458	12463	16200	jxTSQEHoVfbqUtDoxaLVhM93KnvLjcSJWBEfRHrCB437oaFqVfh	12080	16996	16996	1618998480000
24290	3NKa5mxTYLR6BNeZmDh9eDwudVKqNdnhvjhobiU4JNWDygyD7Aqy	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1426	1364	458	12463	16202	jwRthuhfneRF6uBUjiVZoiB5vevBrb8vgjwhTiMN3zDXDc5EbSp	12081	16997	16997	1618998660000
24295	3NLdM9cm82jo5H6Smc4x4ztZ8FH2Vaw2ue5ifSjfxPWdx777KmHG	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	298	1308	458	12463	16206	jwHopecgvVndtwwcD7F3zYPWpAwLvLBjWtf2rR6KdrLheFJyd9m	12083	17001	17001	1618999380000
24297	3NLfBAnBmD5WhTk6V4Sy5c92vNQKvxyMqq69NCS2wUFc2gk9mqiz	24216	3NKLutWnWNs71UzQyzGrRLRRHosypRSi4kXVmw37iUD3y6uLryT8	1594	1200	457	12463	16208	jwMZ3QdwH9SfMLPdGHCSDeWgidXnUmNCES5Yzs1AgnMB23v3U4K	12053	17003	17003	1618999740000
24302	3NKuQUTpyEHUabJ2GX9EfaDczRTznaH3feEQBMuPwkbQJeQS9gWR	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1670	1282	458	12463	16213	jxfBVhM3nPGFPRyMRGRzH26Z3XmTZEzch9tkJ6UsZXhrFfiCLJd	12086	17005	17005	1619000100000
24314	3NKFprmLkfXFohJMEYFbffW6HLkA1HGRpP1hdnkMvpX2v6ax7Mj9	24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	1503	1277	459	12463	16223	jwxQau9hznnB2553SoBMk2p9a7CJwjNJ5qZSczfxq3n7bwstyCo	12091	17014	17014	1619001720000
24317	3NLYVs8qGPLTkmvbdknrt5C5bYYppUfxX2Txqw9GjaEooZr7Qgta	24316	3NKJSbEycg12JJhbj91YPLx7DT6Y2saFnHVQt8wy2HAcZ5v4LMU3	1631	793	459	12463	16226	jxjb9wzNcue8my3eDwxyAsTQai2Xjaqu3zHqtRt8tGCT3vcRyGA	12093	17017	17017	1619002260000
24323	3NK9ogQV4bGZdZAH9kBYFevqGzuxJvLxZce8C9iqwukfEcR6oakY	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1672	1159	459	12463	16231	jxc7EBM6D2qGoMweQcCyyBt1GpyU2J7UjFFqscRFz38y9Q8xvJL	12097	17026	17026	1619003880000
24329	3NLod6Zv9TbRq4RSmT45uFTatpEjv7pGWTkDGXijpf5veu1MWH7B	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1637	816	459	12463	16236	jwAGPB8HbzP5NLswdMTBjoLmKKABHeW32Nbn4eJ8n8nGs2hC92x	12099	17030	17030	1619004600000
24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	24326	3NLP3Ek59EKmUMU93nRVFcHGqhM1cptTYgxYf3MaikeUs8Y8muTs	1483	1030	459	12463	16237	jw8jKinufkKQ7EjnNSkbhA7ETJdxhzXQbhM35zAsNvMnf8xZkJe	12100	17031	17031	1619004780000
24334	3NKbvznXXnRLXBQQ4p9t1ZZFUriTwb5ZD6g1CCkwwgyZD5xKbrnA	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1402	874	459	12463	16239	jwfkUorBiDq1D7PMxJFfprJQrXB724P6NCtBMq18XYKozT2pwem	12101	17034	17034	1619005320000
24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	1406	1393	459	12463	16242	jwd5k1wQaN9k5vtifEnQja1SWzcJzPZg74fKd2XLTUhqj6KUZVH	12102	17035	17035	1619005500000
24339	3NLtUcLTD1bMQ6nUSNuioT4hGW8CYR1UCW9wdXT5j3QDaLkcubzg	24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	1406	1393	459	12463	16244	jwQ9YEr4FduyDqsq7rCyGG9VdJuxDUDEraoZTB6L2BQgzYV4uv3	12103	17036	17036	1619005680000
24274	3NKNWFiFcy175UPudKLtG5GJrKG5Eo5f5BhfHcBjrqMutuzUrpd9	24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	1507	1154	458	12463	16186	jwwW9tZ7A4QofFwK59B5VnRXgz9LGBfVs4LXFL2PuN7BSyYGFu6	12077	16993	16993	1618997940000
24276	3NKxCJvTaWV5hNBC2SusRYm8jdPaJJUceweTdihDaYXbQ5AZKj2V	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1406	1393	458	12463	16188	jx1PXhWZvkQivkeDjm3Qs4dVzX3hxY4FcDqzv6JPh29id6gwK7B	12078	16994	16994	1618998120000
24279	3NLUERTEWzfL3trroQPeXjuCqtuRcn3M3LmUGuRmtqALZmpRFdym	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1403	824	458	12463	16191	jxWNgbLaFbcG3EJt4ZuZdufHJRvybpcj77UdjiVHZAoGRAc2euY	12078	16994	16994	1618998120000
24281	3NKANUaJsnbR4UZCtscTrEQ6SuDVR4vpxEhoQrD8D4qmvGCYgLvU	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1405	849	444	12463	16193	jwxGcknURL1RNay7epMTY2RJxEvUSF6nXMvzBSe6p2jjfm3VPyd	11792	16995	16995	1618998300000
24285	3NLn2FtCaCvnJ7FfUXuHKugLcy58Eti6PdKfPhfpZDMVf8AxS3Kn	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1405	849	445	12463	16197	jwfASrdSLB34Wq6cB9jNtXYkwSFQ9kiVJTBZ5GPQBbbjkmN6m4U	11805	16995	16995	1618998369469
24292	3NKvzzjTik3NPaet8KbkqDYXHZ4BRPjoAF6jdZU3tT5bfCZvLerb	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1406	1393	458	12463	16204	jw8uALZSAVm4xhK27ukizCSpB7muY7HkbpvyfRzB7U2fwCMH2rK	12082	16998	16998	1618998840000
24296	3NKj7caFj5tvoRPNv9kwCbMcnMqhJLeqTY2wQ3NNDHuaEchAK8gH	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	1648	918	458	12463	16207	jwKNyPAwx6MdhGPcWTawwXNP2wvAhWgGZcDP7qmoP7kg3ungSKU	12083	17001	17001	1618999380000
24298	3NLowPCP6iepueVKSuc9BTqdZqrqJmws7VBZTXLigH6ACfCePjVZ	24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	1402	892	458	12463	16209	jww1ee3a8aJgHsFzfw8oet8C794sgFfWmpUqwJJUKKzNxKFYRNR	12084	17003	17003	1618999740000
24303	3NKRH5LL1Vdmzk7udzF2PzB1naF1oMgBXm9E1CtQ5VZTPWjFvsBp	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1501	994	458	12463	16214	jxzi7FecLEW8p8EV9rAyUDCCXMKhi4v1YStFC44LpuitxxbQRpU	12086	17005	17005	1619000100000
24307	3NKPLSxsvbjL64MH9LrtpjB7mM9CjRBAC7uGKDnNdHk5GZW5g2gN	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1637	816	458	12463	16217	jxXkndmfkUdBBvERccVdMUhJ6BDqKaSBNux7E5QxeVTqCgXGngy	12087	17007	17007	1619000460000
24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	24307	3NKPLSxsvbjL64MH9LrtpjB7mM9CjRBAC7uGKDnNdHk5GZW5g2gN	1406	1393	459	12463	16218	jwfmXLzmGnjeNusr1571fKpdj8jUa3yCX3R8FrKFAgCST64RFDv	12088	17008	17008	1619000640000
24312	3NL5ho2u5FyeJv5rC9Ewa6N3k9cV7MGhNP7hkiK4YbvHqQXwhFNa	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1406	1393	459	12463	16221	jxJKyLvhE23uKPXxGamaeQ746mqn8ZGRTgQXDkopBQPy8iLtF3N	12090	17012	17012	1619001360000
24315	3NKwepMPi29rT6R767vJmLgETUhA2Cyx85TBgJDU3wmNFavzQaaB	24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	1458	1077	459	12463	16224	jwzWBBxN6TzmpmNPcrXU18nY1DtPMcm8rpjJf2j6Vhk3tpj5NkU	12091	17014	17014	1619001720000
24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	24317	3NLYVs8qGPLTkmvbdknrt5C5bYYppUfxX2Txqw9GjaEooZr7Qgta	1422	1211	459	12463	16227	jx6bzZFG443ffmKGkrA4CPehoPHM7ny5M2AvfxcPbWrHiupFAhF	12094	17019	17019	1619002620000
24319	3NKVvzte2NhGGn3dmUt3amP1o93uPqN9PjV8WeCi3Evw9HU7d4B2	24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	1541	1298	459	12463	16228	jxFU8ZAgd3NQJfvejH9PejGqSpu62B3ni7Ya1gy3J5cqhEtd68N	12095	17023	17023	1619003340000
24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	24320	3NL1BxK886pvX6M97H7JZbK2WDFCNS9mUXXE5fXmN6creVNWZNjv	1403	812	459	12463	16229	jwQdBJSRq1iNTADERULZUm1koVSjHxwqVpVmaqLdRWngGB2du7w	12096	17024	17024	1619003520000
24327	3NLuHJgeDh7YY8Tpm3zyDuXdBJaX9EmPXYufsa6opWqZEXJyyBFU	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1440	1377	459	12463	16235	jxzAHfU4s1V9y1WZAuHEurfNxCCU9yVeT38SZE4ED4wq4R8r53k	12099	17030	17030	1619004600000
24332	3NLh1cqX7XrCdmdkwFLVRs6MriPvhLmzPeqCv81LNFNHz7ip3VQ5	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jx2G3pgwrwdvWNfsDVaGFRV234hURGXeozasDaQkzr6n2TJW5gq	12101	17034	17034	1619005320000
24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1501	994	459	12463	16240	jwgHwfe3T12v94aG3X8Cn7m7j6tQ1nKAguEP99rZCfgdcwk4JxZ	12101	17034	17034	1619005320000
24336	3NKfhVxEdjTbqaC1mzs7sFTTiAscXufPF65ABf2i2ZZ5dU4J9CxS	24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	1671	1119	459	12463	16241	jxRFnHpeNuQqVSYpbPeqLCqSetdtW6S48QPpMzxKVPF659yDihP	12102	17035	17035	1619005500000
24338	3NLNEE2EYaiUKxkT5JtyoreKEcZzf6xYPoyYeZAxm6Vv9WCjdkSH	24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	1608	582	459	12463	16243	jxUrNMVkqdNfuHN6Er4LkrQ9GRfjwJCHxgdQdQvZG4wPryCaD3q	12103	17036	17036	1619005680000
24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	24342	3NLkP9Bnsywvw8oWLpeD3VHgkmiQbdEWZWQJ14hVHuyLj1K13mdC	1406	1393	460	12463	16248	jxjvmZ8ki4mpSnvDLZGs4AghS9Fje2vVmWRYYXqAL81Ug3Q1Erc	12106	17039	17039	1619006220000
24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	1407	1395	460	12463	16258	jxiZh5fVEgksVwbV1o8mQXnMTiVFQN8zRdPsbPgWSWu1y9yH8dv	12112	17047	17047	1619007660000
24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1651	1175	460	12463	16262	jxvMBqoet4VxGF3ijNCwYuzFvUTWT3L32v6SJAnGUoNhdHcErrh	12114	17049	17049	1619008020000
24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1637	816	460	12463	16264	jxic6cqRH2kL9XM45CTXrtxMdSc7MwTVXmfpFGaNKxpAhCnhWJm	12115	17050	17050	1619008200000
24367	3NKViy6ifMAcL7SU2avjipWWWopBJGUPLdkMXbspWYk5H5VHUG2n	24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	1673	1242	460	12463	16269	jxiMUqiVUgEBjakdm3HV3Cmvu6CWtiPbewLCtCP1AUdEEdMDUdd	12119	17056	17056	1619009280000
24373	3NK3WKxVoKY5ocywvFhNxkB1KE34xQNuTQzTAcSNrMmxVFZZqha4	24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	1602	1369	460	12463	16275	jwsSK4NP1cVsNsTUFGa8QZRogjmv9xi3UpDGbe4wTqpx4f2seu6	12112	17060	17060	1619010041887
24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1652	1189	460	12463	16279	jxj9znqQ8VAQBktFToM29CitC7qx2RNtxUaGpr8jah9zaAyh7uL	12123	17062	17062	1619010360000
24380	3NLdhY1aUzrJgU25wpaZDxJfzrizQrnSz1fwDsfEyj5Y5CWQznHu	24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	1637	816	460	12463	16282	jxShuChidcdgcnjbCrmQgnxD5Wruts83FvQqPuMQsuYtSRy7Zd7	12124	17063	17063	1619010540000
24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	24381	3NLwE8Gu16k6qJ4oSjqfeca2r5MR8QcahCaKZwjq6ti9XBqCRYoq	1608	1163	460	12463	16284	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s	12126	17066	17066	1619011080000
24383	3NKz5engbaXWvkh6Bb7hE6MWuBSjHziBCEcyrQnTyxJx9igbXM2z	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1419	814	460	12463	16285	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s	12127	17069	17069	1619011620000
24385	3NKwHzmwsueREgLv6bszPNNJVv1vi35CneCGcDDRfZLP9GKsLN6n	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1508	1021	461	12463	16287	jxE1XB72aYrVKxZYRPCc3seuoxaGbzagW4rjfho2cfuNC1eTzRK	12127	17069	17069	1619011620000
24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	1670	1282	458	12463	16194	jwJiSyAPgE2hDAmogSjisLG8enNdyoPYwpudZLLmCWKb4EQPPct	12079	16995	16995	1618998300000
24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1624	1334	458	12463	16205	jxQSKzSTDzTxAqnR14zrS9ex8LYQJFGrgVM1jrsjNPAyHro6bvF	12082	16998	16998	1618998840000
24299	3NKqXKzVSxjfvpaVRzLJ1M63hfoU7D1ziuNbzUDYafJCBnJqwnsx	24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	1594	1200	458	12463	16210	jxDx2gWbuZ5ddCfBw3NJNNSZoDRDDGZWmXzM3CtG5D9paiYf5ww	12084	17003	17003	1618999740000
24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	24299	3NKqXKzVSxjfvpaVRzLJ1M63hfoU7D1ziuNbzUDYafJCBnJqwnsx	64	521	458	12463	16211	jwV58guhC4G1EQrXcfH3pEWE1cCwwt39FNf8kKAevE822E6extB	12085	17004	17004	1618999920000
24304	3NKSk5WUzuEzDGwUMhLt6qqb5eQDJsKWxHygwd9mhBBuWRctuP3u	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1560	1291	458	12463	16215	jxffngtQFsuprzKd7BYEx9vihsfCbVNSEE8GGBLunJZhCam1S7Y	12086	17005	17005	1619000100000
24305	3NKULhKKPYa4KBKErWhhQLV1BtLsen3W3nxMhknKLSjjori2RCdb	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jxTuLMmQaHgtMiPYU4qmWT88r2FwE5sgAbpv38gwfxP6dKzFDXA	12087	17007	17007	1619000460000
24308	3NLcf5QtG5kHhrYTTz5WUPohwJjuupSPyMJ2MvuDfUTgbi8KKcba	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jxTuLMmQaHgtMiPYU4qmWT88r2FwE5sgAbpv38gwfxP6dKzFDXA	12087	17007	17007	1619000460000
24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	1602	1003	459	12463	16219	jxjapAJWUuN63ksatLEPNvdAnyqr6JSRKSD6eYcrKwsBNCcRt8o	12089	17009	17009	1619000820000
24320	3NL1BxK886pvX6M97H7JZbK2WDFCNS9mUXXE5fXmN6creVNWZNjv	24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	1541	1298	459	12463	16228	jxhx1m7ixGiPaWf4ZDxsEBjxdjTMbHienRL8JGBQ9QRhsLUkpDK	12095	17023	17023	1619003340000
24322	3NLe9rGmzTG8ZE5CqiFRL2tfgPrvAUuKJnHsya9A31LEv1cpbpqc	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1522	1322	459	12463	16230	jwB7hsmBPcU1Uh3dV78746oVG64k5goZhWfLgfmDLRZUg9tGVdR	12097	17026	17026	1619003880000
24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	24322	3NLe9rGmzTG8ZE5CqiFRL2tfgPrvAUuKJnHsya9A31LEv1cpbpqc	42	1361	459	12463	16233	jwCuuYB9o4rugDHEdcMdPUqYJgE9bpQqCL2ycQ92hoj5h3ZPW7V	12098	17029	17029	1619004420000
24328	3NKgE3FLY496v5dGuRm73rFQ9Tzd6xL7hbMjV4BapnbfytpZemyZ	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1440	1377	459	12463	16235	jxdwaFt86aDC2eSbfrteFUp2Gv8qxxTQFifZVKXh6uqbeFmKixX	12099	17030	17030	1619004600000
24333	3NKt6h8tWgNrYPzzCNtfmwButfJJcrJsRzQ6MiFyT4BPA3aptZkT	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jxC7M2ui2LT5MPUqc7U7yK1DtLDCFf5xL4KeqKfn7t9Xh4Y8HqF	12101	17034	17034	1619005320000
24341	3NLNarX1g39y39tyUXLFknGMHNPnM1VTjmUiH3zvYHjHEa5ndBEq	24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	633	1018	460	12463	16246	jxPeTm8EYqgzgeF8Wosou6Aq653gbiuDzTzKk2A8Y6QqEVvw6sj	12105	17038	17038	1619006040000
24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	24345	3NKoQji1u5gY5Y6tv7cJHi93Zm8jdQh37NjUNiddyq9X4qSgUniS	1668	1004	460	12463	16251	jxM9EVHvgDWqSCTQYpE7xEgCNB4dcjeVnR85cifuXXKVGuZs4WU	12108	17042	17042	1619006760000
24349	3NKKGcNuAznukXAqRTxoonZXkmr1S7adDDPPW4rrv4uU7wpgnDrc	24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	1489	1014	460	12463	16254	jxwiQST4PAj6HfbEnENXkhmEEQ1AwdMFwSBVA4s2M1LV3FT2HMM	12110	17045	17045	1619007300000
24351	3NKonqEHReJFessXYDyXaR1TuxYybqdwSuvwDF5KDzNswboJqgV7	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jwwWeBg8yGuyyx6E9giDyAZVk6FH3s3n1eTofoqUfyEyNbmaNwz	12111	17046	17046	1619007480000
24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jxWs4CEvA2N6RzzWn2Wk2cu4YSDBmnRceRS1A4S2hixfpHCUX6Q	12111	17046	17046	1619007480000
24358	3NKvz6iTsJeeMQ9u2e8wTMneVrbxmzSv3K2jNgAzSR9HYVHWCyyz	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1627	1139	460	12463	16261	jxMcxz5sYQGpmq4fL9k5bJcZy8NxgBhnh3Bqgi6GyFKqrvEMHzZ	12114	17049	17049	1619008020000
24365	3NKedrjVSS2d7PFhh1VbGyR6h1DuhMvcy8YqVtsQwRDHD5PfznpK	24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	1581	778	460	12463	16267	jwFYhtySXcNvnQGnGQ5N5zEx66oEgfLbConkWRN7UQf2TzshQNh	12117	17053	17053	1619008740000
24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	1406	1393	460	12463	16270	jxUsYK6sLA3wmNp6PzhVSNkArL2FB6rotge18nx5QS58hbVQNbv	12119	17056	17056	1619009280000
24375	3NLizJF9aMaiU88fj8MhHCRUE6Z2fTHnRUAeKJ699WPMdgs3t7MC	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1406	1393	460	12463	16277	jxzEb5VKw5WErKzx7UGDHKjRvpjWezMY3amCksXXqEqKxuECUzW	12123	17062	17062	1619010360000
24378	3NK82LixrAXsTaD63Z2L6ECEhvJQfvCdPj8BxTbrYN3hDhxwMN5K	24361	3NL96AFsnRzsuoCBerEBSsG6RfhjuYccdEJ5wYBRqcUKZUxGjPK4	1476	1371	460	12463	16280	jwpos72niAuSy2h8nCRamZTRfmTZtzsH43EE33BZVc4mD9uc3Xv	12116	17062	17062	1619010360000
24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1460	273	461	12463	16286	jxiMUTLPK5o4tLbLfEp6xcPUpLs4CA77UZQX93xwJfKT2bmuyPX	12127	17069	17069	1619011620000
24388	3NLVoeYErL9WMvsGKQwuqA4CYkwiBKfnRemWL8vX38rvpp3takXb	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1439	913	461	12463	16289	jx8h2uasRunuLzQ6VFqzxtG55MSaRLBh2nLLDoPbEoBHuooPTTQ	12128	17070	17070	1619011800000
24394	3NKUPQigwb2AXahcmyahsHMoj1uZr8V4mRu7sYeHuep3eyZWa7Yu	24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	1490	908	461	12463	16295	jxMkNFSMHkkHNh9WMqywt87uyY2krd742vLJ3mDXpJd9oPzwv7L	12130	17072	17072	1619012160000
24401	3NKd9qfHhgKZVLMsc3TgcgKehr7nHHp32cq9hzQnDjSesPVbfMTq	24400	3NLkbSoCo3Ha3RxGYPYKjJtGC7cbekqmpPuMaahPd1z66jHXzi2D	641	1090	461	12463	16302	jw9BBC6NUt3g5UtupoSDookbMxF62P9uvhwE3y74EjZCgh9ExHp	12133	17076	17076	1619012880000
24404	3NKJA8AobEMpm8YtCVSWjHAyH1inXFGy2qaFNs37qmBLgD2NHs99	24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	1581	778	461	12463	16305	jw76RtB41X76dMWVa6DZoXULxwDDnqiBsrXxtbG6kmq5S7mCMGa	12135	17078	17078	1619013240000
24411	3NLyS9UhXs9HhxMr1zsVW1fAizM1WMHcE8k4VVgy174JYBQLLxV7	24409	3NKBS49x1pxPyUxMoC7WAMDHqjTTvac43wg9LwR9yhSECrix2GF6	1406	1393	461	12463	16312	jxqvgsvm1USF7cVp7DbUVBmx5sEgpoK5XHTSUa6hWXK7TEgmdqj	12140	17083	17083	1619014140000
24419	3NKAxw4sYdfAvVP7mdicjkM8fxhcXq9JfT4TwcLt7WECHwtZYNNE	24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	1581	778	461	12463	16320	jwRQfKWeYgCRgkJb8nCSjWYyANctvqwgznbdEXERNoueurW6T6H	12145	17090	17090	1619015400000
24421	3NK8WqYpjEcnYPbX1ZVbGn9RPbdeKPjKv5y7U35MZyvWCuy7kcWw	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1559	1107	458	12463	16322	jwejf8igjWfQYpZyKqUxe8z6eymQbgibMUkKs85RUkRuDQM897x	12075	17091	17091	1619015580000
24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	1650	1375	461	12463	16325	jxfxTmcQraCKP5Ytd8nTGRrKoS4KXb9mTkaWqPtAjLvb694qxMJ	12147	17096	17096	1619016480000
24316	3NKJSbEycg12JJhbj91YPLx7DT6Y2saFnHVQt8wy2HAcZ5v4LMU3	24315	3NKwepMPi29rT6R767vJmLgETUhA2Cyx85TBgJDU3wmNFavzQaaB	1536	1067	459	12463	16225	jxmTF7gH3ZbLksxMcXqDEdCfixp1sj6GibHNFoBbAq71VWT1N2k	12092	17015	17015	1619001900000
24324	3NLWow4MfqNLPVrDZ8k9h3HNYXr9TPa2zSWMym4JUzxFsvJW4PQB	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1594	1326	459	12463	16232	jwpvDWKir1ApZ683ZfLrvK41yvQLrYmAxC8JzkpFnsvJNktY3BM	12097	17026	17026	1619003880000
24326	3NLP3Ek59EKmUMU93nRVFcHGqhM1cptTYgxYf3MaikeUs8Y8muTs	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1503	1277	459	12463	16234	jxt4qaiSuXQBurzwsQUT9w3WDis4Kyhr6EJDe2e7yAiSCzUPRfA	12099	17030	17030	1619004600000
24331	3NLrQjb61HuHGUo56CwaQB2fgR6rfpogn2wsQJEjKcZ1GpuvJXgG	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jwRfcBqHU82S3kKfkBE4FtGver5DmfPkMBS2UsEb1C8vk4pQUZ8	12101	17034	17034	1619005320000
24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	24339	3NLtUcLTD1bMQ6nUSNuioT4hGW8CYR1UCW9wdXT5j3QDaLkcubzg	1637	816	460	12463	16245	jwT6WnL1rMEJj3R7eZ7PLJssRJCr46hmk4zdw8qc7TXnsTLovZq	12104	17037	17037	1619005860000
24345	3NKoQji1u5gY5Y6tv7cJHi93Zm8jdQh37NjUNiddyq9X4qSgUniS	24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	149	1283	460	12463	16250	jwLpVZ6ZCi58JHn49PprXhry3tYAETUfqLaAGcsz1Wpt76ufG2x	12107	17040	17040	1619006400000
24348	3NLYGfbtkrXG5mpt1wTmScFVt7UXPqr1osKuUPVug3xca3BwNWBx	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	596	940	460	12463	16253	jwbe9UXNpDjgqL9fTL9yCkL74QiZNcBEWsv2pBQkfyTSLgeDhLp	12109	17043	17043	1619006940000
24357	3NLQGPtTZGNieMaChT4Ta3r3jQZ84gDKAvobLGZSk6VzeuPsuzze	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	684	1352	460	12463	16260	jy28b5hcxrnaKaNwChYiAhsxh7EWSAjonEbakBBspadWtDpbAGa	12113	17048	17048	1619007840000
24359	3NKp8KEyauSRRS2qWvWSM4pitFz6TS9xVVreBAoEACzePDwEkye2	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1651	1175	460	12463	16262	jxJV7nuTKS4EigTA4YKiBKJGpF2ptxJB9X2W8tVTNiNCRRW7bNd	12114	17049	17049	1619008020000
24361	3NL96AFsnRzsuoCBerEBSsG6RfhjuYccdEJ5wYBRqcUKZUxGjPK4	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1581	778	460	12463	16263	jwS36dzxhxNZQKFAMyZrXA5mPvdfErPotgHohMtS4QdKVwBUs58	12115	17050	17050	1619008200000
24364	3NKQZBmkCqdtvrQvoWqWwQipvViErMYfBhijRoZLvRPDZyeJBcUd	24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	1407	1395	460	12463	16266	jxwFxs1nUjNaUxiMASbTGVR1fAv6GjTkf9DVjSx8gBBjYBh1q4Z	12116	17051	17051	1619008380000
24370	3NLMRJy76A6xW8povCt6Z7Je118bheZFdvDzY9znTVhMa79tCrED	24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	1623	1623	460	12463	16272	jxfLzvhHTBsDV7kGBq63xmdz2HGtnjrdtB5Y3rMWjW3qaqefs2K	12120	17059	17059	1619009820000
24372	3NKNyZqXxoMaDrS4VWzBvNeZbauUjBHwAEAsyt63Pfsce8AwxAnM	24369	3NK5Dzm7vZ7MkQTA32J1GGDEBrnjdxsohg34v152n7VLF2p7F7Rx	1602	1369	460	12463	16274	jwebUt9TJcwNHNvoQqVVFEYqtCVZejbs7ztbY1HAP6mJHQbVAxW	12121	17060	17060	1619010000000
24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	24372	3NKNyZqXxoMaDrS4VWzBvNeZbauUjBHwAEAsyt63Pfsce8AwxAnM	1652	1315	460	12463	16276	jw7cDJszZ6p2ryufRGSnbJ1KDFts9B5tYdfZLy12YmBSHAbf3M1	12122	17061	17061	1619010180000
24379	3NLcSZsMEPPm5Vxkwb6PFJN5ZcZ9mU2ZzW8hfgLQs3ibpkYn9zgj	24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	1483	82	460	12463	16281	jwvpQK4nNWhYrjhnCxgEtwUmTK7RmWTQXdbL1n21oTi9WSkYvYw	12124	17063	17063	1619010540000
24381	3NLwE8Gu16k6qJ4oSjqfeca2r5MR8QcahCaKZwjq6ti9XBqCRYoq	24379	3NLcSZsMEPPm5Vxkwb6PFJN5ZcZ9mU2ZzW8hfgLQs3ibpkYn9zgj	1656	1097	460	12463	16283	jwRH2RBSvNQ3ybzPBgfqeBvRbK2bG3gZdhrL8sqnFLLLPb7SZxW	12125	17064	17064	1619010720000
24390	3NLb7PKeswTR13tHKX8Ysr5HnrErv2G1ScJUiWscMjTuKFsVR2fX	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1637	816	461	12463	16291	jwE9CemaREt8ABeJT18nHPMMpMwKW11QntVmniV5o478QfskJ1D	12128	17070	17070	1619011800000
24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	1608	1289	461	12463	16292	jy2hiV2sBDDoa9D35gDPqzoBczZ3Zqz1GwTccv7Z1pe6Euz9nfm	12129	17071	17071	1619011980000
24393	3NKiDCboghXiFxezKT6StbvFTiLFvhdaJXtnAfZZHmjtCjXkE2Gg	24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	1403	824	461	12463	16294	jwmYV3uVhe44Qf4ib4EKn9GNmHvDmPrmdAg8LH4gs4jNJ1a83xy	12129	17071	17071	1619012068195
24396	3NKCZt5gDCsZaXXFSrpdrLi5dqh5Dc9Y88RtAqpAfs2mjK5LnFik	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	1573	952	460	12463	16297	jxT1jj3SqoqmakJtoMFruyibaFie1yPS4shqMpT3ft8ejmwB38F	12113	17072	17072	1619012160000
24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	1536	1313	461	12463	16299	jwg9J7Epsiqd4cpVSJySF77ZxrvWYLfMEZ1RziVF1JEtUJweQ7W	12131	17073	17073	1619012340000
24405	3NKNAAYwqxZYo8MSLcp6ZoEf2NWypDxhyGWRaS2zq7zm2fzhDT89	24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	1444	1255	461	12463	16306	jwzcRF4RXdgmTzghD7ztRQiR7E4eL9VGpQdMfmcAKxXqiZ7UPrR	12136	17079	17079	1619013420000
24407	3NLG2S85W6oW1UpeMLVvZ4x3XR6TeYK51kUNEQPw71J2wNABnaw3	24405	3NKNAAYwqxZYo8MSLcp6ZoEf2NWypDxhyGWRaS2zq7zm2fzhDT89	1406	1393	461	12463	16308	jwspYKxSxQ7xdGvQ5c9gpGMZhJTUz1QP6NHsYHZMEV2yQEkrWMK	12137	17080	17080	1619013600000
24410	3NKDhsVDv9ti1Yn6CHT9dUhAiWnRj9gGDbtTnEbycRWoAunVm8G3	24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	1407	1395	461	12463	16311	jw9Heyvz6DwaxiHMHxnzWssAZvqgcDpM7PCSSxYsJmunxkk5qSf	12139	17082	17082	1619013960000
24412	3NKBVEGR87huQ2rqAVJZ9TbRxxMf3qQ7H4GmwRbyMgQEHHdMm6iR	24411	3NLyS9UhXs9HhxMr1zsVW1fAizM1WMHcE8k4VVgy174JYBQLLxV7	1542	1304	461	12463	16313	jxiRkQ62KJLZ8jq4wwwBLvZXtsAWSroviQgnC5sjTMwx13CKjfP	12141	17084	17084	1619014320000
24415	3NKTC8n7rtLP3G6BVRoQ53XT8fhXVDhEujBga4Tj4v9sjUs3jz3V	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	1547	1252	461	12463	16316	jwoDqRGMxFnCmEEc7RGxKgqYu43tRdVof4nffdMy5BtsFL1oaVv	12143	17086	17086	1619014680000
24420	3NKR21VxAw6JC8uvtfzTSNjkUCrPvuCMCv7EPVyxPzYkfkerZ8Hd	24396	3NKCZt5gDCsZaXXFSrpdrLi5dqh5Dc9Y88RtAqpAfs2mjK5LnFik	1559	1107	460	12463	16321	jwNMKcmeswpXr7oarjrPDiiLADLXmEVWtR3SA264oC6phAK1MjX	12114	17091	17091	1619015580000
24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	1501	1234	461	12463	16324	jxkLBKmk2Bf7CzySJHkakfpXdwZDG8wjih7waVHn75wtExcZL3f	12146	17093	17093	1619015940000
24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	1582	619	461	12463	16327	jxqcPUidfxzitCfhuod7o3EKB92mvp8PYLFKiK4xeRtrxLWvopp	12148	17097	17097	1619016660000
24431	3NLjnWtDS8j8R1WYSo1xQHBsGct2vYLTvg6x1UqsDYy4DcU3jL94	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1613	1103	461	12463	16332	jwcJGiUJ1LEyLuNqd8ohktFkmBRsV6AWEums39gLzV43Lm19axu	12149	17098	17098	1619016840000
24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	448	1305	461	12463	16336	jx637VFgVtMAMPnGyoVEzTsNzGdT3nsLhHXyJM1WHjyF7Gn6NoN	12151	17101	17101	1619017380000
24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	1407	1395	462	12463	16340	jxxg3Ud3qK19HNGLRkXgVY5V1Cwuo6EFoMDw8s4yzDYnmrcmwmy	12154	17104	17104	1619017920000
24342	3NLkP9Bnsywvw8oWLpeD3VHgkmiQbdEWZWQJ14hVHuyLj1K13mdC	24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	1407	1395	460	12463	16247	jx7DVaRhVAcuqshrYLqbrrMQZ4MgthPpZUjXk3pbKZLyejTcZDr	12105	17038	17038	1619006040000
24344	3NL15i4TxuPHDjREPSfP9ccDKestx8MKJx5iZiPUigtmWp7vUwty	24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	1406	1393	460	12463	16249	jxf9avrZ33jd1K2BnULnkDLH8PXw9LUb1txr5dT6TajcSwnF172	12107	17040	17040	1619006400000
24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	1646	1354	460	12463	16252	jxBzxV1GfBgiHBEc6kPUEwiRMJYARHJBJi5VHYjBgxiqM92vzhe	12109	17043	17043	1619006940000
24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	1536	1313	460	12463	16255	jwPktDZuigjLt7LREyP23kjeakMCZPEV7pVdSz7QZBXQ21pKTAG	12110	17045	17045	1619007300000
24352	3NLYkEaQkuotSdHVKbYsJ7Wd3bVNsEXcuzMVLCwEAH4Ksa5QCGkW	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jxY1nsHpyfZSJggzkZCiRkDoCxAuKVP5LkF3hZeSb7Zp4NK9jTD	12111	17046	17046	1619007480000
24354	3NKzAxsYzzPfyKKhidLhb6qYCpdLbzh4FvbzhPyZAmnbVjcGq3ZF	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1634	1331	460	12463	16257	jwH32Fzt4yE8BRTyjWeJcPiqTEmhECZJjV3WNKDHNdPz3o9gCx9	12111	17046	17046	1619007480000
24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	1483	327	460	12463	16259	jwp3ebs7cJNbUiJbTMPNiWLjGe86f1wnkBRSnQmdYnAyGY68wK4	12113	17048	17048	1619007840000
24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	1553	776	460	12463	16265	jwhkmg34eWXtc55EpG1yAiXuDc3v7ZtXB1zdavRVEPjcw5mr66D	12116	17051	17051	1619008380000
24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	24365	3NKedrjVSS2d7PFhh1VbGyR6h1DuhMvcy8YqVtsQwRDHD5PfznpK	311	1307	460	12463	16268	jwvSiLNLJvFC4F5Mvj5Lu1kusPRk2Rr68E9HcJ6yN94N5aJKftb	12118	17055	17055	1619009100000
24369	3NK5Dzm7vZ7MkQTA32J1GGDEBrnjdxsohg34v152n7VLF2p7F7Rx	24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	1607	1348	460	12463	16271	jwUezu7NWMVhVgu8Hzo5LK6a8rm81UouTeHawSyUw772GWEoH2x	12120	17059	17059	1619009820000
24371	3NLHLMkkHJuHmKCJZLrbBRnMh1QfE1c6hmNjY147fbEEQ7i7SMVW	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1602	1369	459	12463	16273	jxicdEaPEYUVVm3XuP6LwfS5aHt6HqVdAq4JzU82b6KQvtapU1S	12097	17060	17060	1619010000000
24376	3NLrnYwjvkcBP2J1RKomcew42PaiLCjPHXKJvMwwRKSsFPfFoMKJ	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1476	1371	460	12463	16278	jwNUL8FsoPFHPou8uiGir9e7L3UZWejVBTEg7D7evQ7S8vAUcjv	12123	17062	17062	1619010360000
24386	3NKcjHyN7ffgM6jJJrM6V3vApy3GZeH5H8mJR1gDgFbohZgabC1n	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1419	814	461	12463	16285	jwBnYojMFtJTSf47x7WmSnY5skHZUQUtVGzoxT9PQWAPBm3bhs6	12127	17069	17069	1619011620000
24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1407	1395	461	12463	16290	jwFKGqpQqVfDg5Riq9uRzDPHmskCDM27sVvFP4SpZGf5VvjcRQz	12128	17070	17070	1619011800000
24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	1564	1212	461	12463	16296	jwiqhYDeKkeRLpBJjSHKhu1i6nGUiMaWxj2WThdMH7RBEdU8Xxj	12130	17072	17072	1619012160000
24397	3NLsYGgWsurzMmvgacS2ipz3yXEnhfvP8Bd9jmXdGGsfWE5GZg5d	24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	1422	1091	461	12463	16298	jwGtfe8PPADc2xviA58UHSs3sqQvTZokE5taRBdTRoiwfYQ5YQR	12131	17073	17073	1619012340000
24399	3NKbRmdZsnUPpEv2hKJ5zUQyEztEDNje2aWTXjL4YQ6a2LKaoWBa	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	1652	1315	461	12463	16300	jw9Xz7s1d8vjLV4BEqFrMhPz9M5dN5g6W16g2QjgyH633Urx9dY	12132	17074	17074	1619012520000
24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	24401	3NKd9qfHhgKZVLMsc3TgcgKehr7nHHp32cq9hzQnDjSesPVbfMTq	1407	1395	461	12463	16303	jxXg8Q2pW42hmWtgZM5NusQyPEihQuKki4UEuS9PQncXjCRVb6X	12134	17077	17077	1619013060000
24409	3NKBS49x1pxPyUxMoC7WAMDHqjTTvac43wg9LwR9yhSECrix2GF6	24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	1553	776	461	12463	16310	jwfwu9kU1VTzARaRU73hjq8HcSnaz7CR62NgEbXJVKm3yoiC2An	12139	17082	17082	1619013960000
24414	3NKnS5Bqnnrx6jKGmDsrP8BGmPM8Bn4KFw9WjU1fDvqMgEN8MVTM	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	298	1062	461	12463	16315	jwfgp19N6kyb5CpoLo1PAkPkCRGkcRbNPLEkRYYdLp9fS2FwdqQ	12143	17086	17086	1619014680000
24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	24414	3NKnS5Bqnnrx6jKGmDsrP8BGmPM8Bn4KFw9WjU1fDvqMgEN8MVTM	1671	1119	461	12463	16318	jwFWjQ2BmNWMujyGrcS1VNMHPy6qyXbGTME3EpbH44kkFHV7LBC	12144	17089	17089	1619015220000
24422	3NKGmpEm4r8seb7coPii7aHh37npEHYYXvccgVVqMtyFfTHvCx7m	24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	1406	1393	461	12463	16323	jwGoBZ8wGofMa6bwfvTK7ggRhH9n9nFmHMa1PNSvc6J9vQz9fqp	12146	17093	17093	1619015940000
24425	3NLHeLukyEcTxfjA42ayhgm9PB7HmQpMz1cRUVcPRE98rnZJAnNW	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	470	1309	461	12463	16326	jwXVFuwezpE8TZip8R4rd8K8a8oR8THQveKCamTRy8qxv3beJ29	12148	17097	17097	1619016660000
24430	3NKW5c2BBxR5y3ChxudAbqqJUR89ShcZgyCbarmASnBrAZyyvHU7	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1547	1378	461	12463	16331	jwnJR2HfaTAiGhqzXxNxKZowQuJYen5Qj8385EoydQuEE2su6vL	12149	17098	17098	1619016840000
24434	3NKpPtUTFQpAGrENdT43CHgnPecRBHDPwMSNvvuDfgwXYmmPg2R7	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	1553	776	461	12463	16335	jx5XSdFwPAcLM9seL9VEdbr8okWnCKAEFwN46pTsxz3K1YmRcQd	12151	17101	17101	1619017380000
24436	3NLJ32TS9Fu8ZS5pB1qyfqGyL63S1kMu7o6A5jQgyM6aepcDxzsu	24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	1483	1030	462	12463	16337	jwjbhpmpeQkeugiZbPk5Y4tibdQTxPKJBjT2xXZuby7VKcGP2qB	12152	17102	17102	1619017560000
24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	1406	1393	462	12463	16342	jxQzYE8euDSAvfPrQAZRWGXPf9Yo1T1Jb3sTxHxahGRigp4b6Bu	12156	17106	17106	1619018280000
24443	3NKzvhcaW7ZVyHdqGybykpEJhB9hiEF1UpTbmpuA5WHJjNF1N2zP	24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	1403	31	462	12463	16344	jxM6aABB6fZvKMVutzBTEGdUJV3S9YtiZRUY94neeW1Bx66JjeS	12155	17106	17106	1619018357700
24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1536	1067	462	12463	16349	jxfPdY1Qu9Lust4GeFpjCTVPqUzF49ADttDyD11oJX1maXFbJUh	12159	17110	17110	1619019000000
24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	24453	3NLDLYmPRX33gwqhsBU7CUvk6BNKDcLSBLHWDqxmRgoutGNgVeD8	1593	1346	462	12463	16354	jwwToiVbpDuZZ1yUTh4NXqo8U9kqP7Z5B2qXWTb1XhjUMPRWpew	12161	17113	17113	1619019540000
24463	3NLU5hgfdoB7Jap9E8AXJMU58kSJKhvWwbSXgqh8RnanGKETSrML	24460	3NLWNoGaS7rng1PHHFyKktnVo238MAjXgVSCxExkcvDzbNtVT6Px	1426	1118	462	12463	16363	jwrnj6MrY3hpyW2u4YsW1acNtiWUMYCAq7892q9cLwMgBFn53yD	12165	17118	17118	1619020440000
24464	3NKfrhv9Wka7x9xJvwABd6W96SrrAysH4FX5F2CqjTWRxNEFutyE	24463	3NLU5hgfdoB7Jap9E8AXJMU58kSJKhvWwbSXgqh8RnanGKETSrML	1534	371	462	12463	16364	jx3dY7dZnoe5f7wuhzU29BwTfXD7GXW3FLYFNJoxnt1g4555MHi	12166	17121	17121	1619020980000
24387	3NLxP1UmTkKmM7o48g32hqWhdgJA1LegASqPzgC8ieyrP8T5oN1X	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1549	996	461	12463	16288	jwyYNXJSUBxvTZ7c8jxCDocJPYRq2tDLLVUdi5o4j64jFyEQFQZ	12128	17070	17070	1619011800000
24392	3NLdhhcDYCRzExVBDSn5dWeZC3LunK7EZrDeqZ7h64vcd8MrwdVk	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1403	824	461	12463	16293	jxT6UNnfukiaZ5NBhhMfV6pvaSXshowNaJ6w984N5ds7Lzu7fn9	12128	17071	17071	1619011980000
24400	3NLkbSoCo3Ha3RxGYPYKjJtGC7cbekqmpPuMaahPd1z66jHXzi2D	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	171	171	461	12463	16301	jwXHHqPFo5uE5YSV4Bue6H87L5KxsfBc7naycjQ57gh6u77AeJG	12132	17074	17074	1619012520000
24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	1589	1040	461	12463	16304	jwv8HUn5qsLYdxXGYwgMpJNGjLAf7XjSyRNYVeVuM8e6LPyuZ4x	12135	17078	17078	1619013240000
24406	3NLaE35t79kVAu6CZbpeSDW97PSCEWvjsn1gFanwwHkaZfXiMGgF	24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	1596	997	461	12463	16307	jwMTTM8BTRvTQVxzd1P9VK9Md72VUTMsqtJj7BPcVAPpiByvjgY	12136	17079	17079	1619013420000
24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	24407	3NLG2S85W6oW1UpeMLVvZ4x3XR6TeYK51kUNEQPw71J2wNABnaw3	1402	874	461	12463	16309	jwirrcBGKg3zsgkxyrEpVxhZC9nBPJYh56VahEWB2GRRW9medKj	12138	17081	17081	1619013780000
24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	24412	3NKBVEGR87huQ2rqAVJZ9TbRxxMf3qQ7H4GmwRbyMgQEHHdMm6iR	1589	1040	461	12463	16314	jwtwcJwATuBUPWjL91HzbrNYgQkzSePbJ6Htk495xSkiKySsz9R	12142	17085	17085	1619014500000
24416	3NLdwqmXxgzizpzafRUJWcbf3Cbg9g2hLbYMkVntdTejTeSGRxem	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	1481	790	461	12463	16317	jwEb6cZMdeR74HEGo6MjCMNPt7Hgbiqmm7KGgMUJvBRMDs5yAsu	12143	17086	17086	1619014680000
24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	1600	1246	461	12463	16319	jwJgsGX7hPqkAPzPZ9cb1qYUJ7KzPyqFeYuWKrso2mQyRn2dBJx	12145	17090	17090	1619015400000
24427	3NKBqQemFhL4efkbiogFtBJPi2QgfQTNX9PQEWGJuWdZnaZXH3Jt	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	1403	824	461	12463	16328	jxqS4sHLyHCGkcirCxjoCLBaww3zPWLkinEKFKSFFw5UU8Q2oNL	12148	17097	17097	1619016660000
24428	3NKS6z4pyJUFE26T7Xaz5SbPsFF3MeSor4Jx8sAVYhzdWsjCaHnR	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1549	1116	461	12463	16329	jxk1dFjbjs2edKEcNXU1BpYG6rSvUygqMAamBf7xQNBkVMP54dU	12149	17098	17098	1619016840000
24432	3NKtmDP9589vThU64KHkT8FiQ4hFNRoh2CniRZ8c8paw3sQchyX3	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	641	1336	461	12463	16333	jw7AutPYThpGGwXnfg6mgT6HxxkmZ2WWprcbduTMJsg9Me89XCC	12149	17098	17098	1619016840000
24437	3NKFBLTxZ9GRhKU7hTghj87DiSLSa2eeUH2xVKVH3PwLVpaVgDpQ	24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	576	1229	462	12463	16338	jw8iwe2LiHdogYe4f84AqFgeSzME3i5XrZqkCHZtvFLP1xzMrK4	12152	17102	17102	1619017560000
24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	1407	1395	462	12463	16341	jxXNkhcd8YLscdqF2iP9EsLDywGbYq1MqFJfJUckE5eRdHqgEvZ	12155	17105	17105	1619018100000
24445	3NKreGycR67L1Fua9xkV275ap29u2Y8v4RtwtCujvJYa95VtNFtk	24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	1407	1395	462	12463	16346	jx9U3hUkvDsCoDBTTNNf5tK2uUmuwYyRRaG542GnX8gYSyAFbb8	12157	17107	17107	1619018460000
24450	3NKTDiJW9i21igwgRFehPLLKZjpPQkj916mfKo5EvgvobXQVhSGr	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1529	1190	462	12463	16350	jww7fBGFmfozEG2RPzn3JMHvsd5kwQjnLkGSYTqthyXefe3qW2w	12159	17110	17110	1619019000000
24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1546	1339	462	12463	16355	jwjLy9FWTMvmpvSsu9vhAXWEUKcjYjgVdXSyjN5hiUkEENJKYJi	12162	17114	17114	1619019720000
24458	3NKVJiAjbDoMJvA9crNyjzYmUePSj6P34fk5RgCgnT6wVDGUbcws	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1405	851	462	12463	16358	jww8dpKQwZ4Ph2MWK1rxKAisGqRey9Dg6kPJ8b9natDKsvtkyu2	12163	17116	17116	1619020080000
24460	3NLWNoGaS7rng1PHHFyKktnVo238MAjXgVSCxExkcvDzbNtVT6Px	24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	1405	881	462	12463	16360	jxdTsyfb6UQh3Y87fxUvCdgAtJxq1SFtkZSwCc24sR9R2yxaLMv	12164	17117	17117	1619020260000
24462	3NLi5SdkKYQaVbEQq2mTBAkeeV6mWgjAeExcaMqZJyouvXw7zgbE	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	1426	1118	461	12463	16362	jx8M1FAiePmWhfScnNhkvMiBKTYjpzfLHDX6bun3Q7hkXE8kVjB	12151	17118	17118	1619020440000
24470	3NLeW3u3ed1e2GJdqdqpoQ9KR84pyohh8qnZcyGvK35HSwZrFiDW	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1483	295	462	12463	16369	jwnUKUdR3sCcLMoqUWrmR1pcxEA3WXrXDdU8yuBrcuXFBGWkzSP	12169	17125	17125	1619021700000
24473	3NKUu3HMhTRGyk92Kds8XqvLVQw3rGy9ParEHYzyoeTVbYpNr3Be	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1403	782	462	12463	16372	jxgA7pEdCv3GSBfCwJ94Hgvn9TCQodRiEC9WmmnjModsqRK8rHH	12170	17127	17127	1619022060000
24479	3NK8FiFj95bJtNvheYBv6MBVsmseqzciYHzT7DkdDxcAYEf7K5Yp	24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	1407	1395	462	12463	16378	jw8Woo8x6bftDHqWarAr8tZYRcyfGNc12RerYRnJdn25KxCwK8o	12172	17129	17129	1619022420000
24482	3NLyBPv4MR1QNRhQYk7bc4VsvKmverfhVgRmtmnaLRW1vRvd2cFW	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1445	1164	454	12463	16381	jxspqLF75YLkaabFCTvaCaY1DMXhz7zSVsgVCNwcj8QbDfkzUxR	11983	17131	17131	1619022837079
24484	3NKGWec7woCuRtBT6m3jt3Low5kPUWSSdV1RGbrCvDBya5VigptD	24481	3NLmQGU6TFKYmXcQwgYgA1Z4d9ArfXka6eVcwFNYe87Wwr5BMmb8	1656	1097	462	12463	16383	jx5ruESPsjfkCCZV2zvsywuPogLvtHndvRmquzX8E2U3sspyMbP	12174	17132	17132	1619022960000
24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	532	1303	463	12463	16394	jxkY3EwFYXmMtXGvK8pz6EL7zqair1K2adnMGVhVP3TsCZ7gyX5	12182	17143	17143	1619024940000
24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	1581	778	463	12463	16396	jxwCpC2iP1vqHzdd9qJxKH4NoaJHUPYGtJdNPyFvCEVwF6oaZ4L	12183	17145	17145	1619025300000
24500	3NKquk95rTJP1QufXnTQUB9KfVCMAceDsGTZfrJS2sqTHsZFmE6Q	24499	3NLcMyhFCynzBPp8eh8cQyRLujTpvMcMRNTEKAYDM6KwEswFTaFr	1422	1211	463	12463	16398	jwu2fnwgmBd4zyRX43VDsVBvX3usMkTUmgVTkkDf6jsYsSbsbLw	12185	17147	17147	1619025660000
24505	3NKaBxyutF9gFE4TvidGSaJcZnWUCgVWxqrTVYZBH7J1A5E6pkWn	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	58	1281	462	12463	16403	jwy5RZhemZ2NRq4HZiMBjjL41gV6vt34tbzfvxDqM4EMGyn7kpZ	12159	17150	17150	1619026200000
24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	24506	3NKnAwqMQz24ykEEJ1XREuhV6n7g2v75QUwVphhCf19iyCWsxR9x	1617	1042	463	12463	16405	jxCDKwNMapoGSev1yEdKRKsaDosCjd1EJggv1THCdLzYsQgWFJD	12189	17152	17152	1619026560000
24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	1406	1393	463	12463	16410	jwbSRRRxe8AmPX9FE8HUcSZoyLE5TiAHvxs1xumNEZLUXvUAtca	12191	17155	17155	1619027100000
24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	1631	794	463	12463	16413	jxwExoD9W7LHcgYd8mV14ZXdf7rSae378gGcLPHzAMLcrWz3nLQ	12192	17158	17158	1619027640000
24429	3NLgSwJjyhcEceXfLWUPYdCsRQrKJWESEDd6W1y5hEisg6oiGtQh	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1402	810	461	12463	16330	jwF12hmNrH4TMJkXoVomVuHGKW5LUXGBT6eNgdSTzAjsjft7rTm	12149	17098	17098	1619016840000
24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	24429	3NLgSwJjyhcEceXfLWUPYdCsRQrKJWESEDd6W1y5hEisg6oiGtQh	1611	1095	461	12463	16334	jxnnT9exQ8yX26k8X32m5UCRoqQweo13Jnc3nxh1aWHVm8f1AYX	12150	17099	17099	1619017020000
24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	24436	3NLJ32TS9Fu8ZS5pB1qyfqGyL63S1kMu7o6A5jQgyM6aepcDxzsu	1611	1341	462	12463	16339	jxUUrD26HUgVdnCbnDAuWsHsCpijCgK97FdcUm7rnnRdxboiWEa	12153	17103	17103	1619017740000
24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	24444	3NLa7518CqyqG5s8B5LrzMAnj1mzWSxabA1vcsgufJxgCoJFDTHw	563	1113	462	12463	16348	jwwvF3iMKEx131xNFR6xWcZBd51vYYMRMYccjDX2JEKkNbszgzN	12158	17108	17108	1619018640000
24451	3NLS4q7q6HBSATVcQhdJsh7PAKFPCb3LQEMT77GfZPXn3vQqkfbe	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1581	778	462	12463	16351	jxavuvRxw4L7ccCCEFiGYfptw7V8gHXLS8Grs21KN9mJWyb858W	12159	17110	17110	1619019000000
24453	3NLDLYmPRX33gwqhsBU7CUvk6BNKDcLSBLHWDqxmRgoutGNgVeD8	24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	632	1136	462	12463	16353	jx2qHyekB23WdpVVpch3qxuBFZ6f1mQPfBgx9VyeqmpXoh4ufC8	12160	17111	17111	1619019180000
24456	3NLofD2dgE9rYcPbZRJKeAUeWiSsd5xNpSruGcAbHmNJUY3ScGi9	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1647	1176	462	12463	16356	jxQHWwc5SFMwvmE6x9QB7qr1HQYvtt3K6Vn9LNXTPSbfeQaeTaR	12162	17114	17114	1619019720000
24459	3NKKTiGeLEfwDMwE4MyfsA1ZYX8H7WiNet57bNHH55BoeP6jvntA	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1407	1395	462	12463	16359	jwGX8JRwTuyrdBLsNQy8cv8mk4Z9Te3Ay1qcKAcbZMfCzeTSorc	12163	17116	17116	1619020080000
24461	3NKK3hb29zwzV3hi7PVCp6Q4Y3skK3Gmn15hAeDZ1tekKP1etsLn	24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	448	939	462	12463	16361	jwtsBax5fudj7zSQNi7xsAd1fhiDPx4MVfxqF6bYLrJDy82zHVg	12164	17117	17117	1619020260000
24466	3NKnfHMg59k9ogQV6LXEMbrQhRDDjpBUaaAJzuc83QEM2YifUymm	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1507	1034	462	12463	16366	jxGs86SAkGzC7mFvY1MsS1MS7BQ96ns6AMPRy3kMPRYq1no5HDh	12168	17124	17124	1619021520000
24469	3NKA4WzaR5BkzPou7bvYP5JozCX3JGiHtX5QjhyG1QSo5NzDRsbY	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1476	1005	462	12463	16368	jxMW8nurqd8pa1XbXWbqw1osbUzTDzYmHnUDqF7B67TfDGZ3F1q	12168	17124	17124	1619021520000
24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1406	1393	462	12463	16370	jwxZCaHXzdmDuaze6QAKdNEqp6nf1jLLVhyJLF8rXW5yJKXo8Po	12169	17125	17125	1619021700000
24474	3NKnfNEks9eh8NWGeMCvP6pfDkRCgNnsrWEiq9XbNtjbjNYNuTVw	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1546	1213	462	12463	16373	jxVpxjcYVTXMj6GP8RFDoP6F6Y4bAZ9rs5reC1pnq3meU29M3Ri	12169	17127	17127	1619022060000
24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	24472	3NL42MidpVStUNoFTExmP6xFMcb3r6vsE5LVjprrJUcQGfTiXAma	1483	894	462	12463	16376	jw9aYpoytCKLrJhddR75gs6sVPphxa6U2fb6ihjZtzPkKJVKTKy	12171	17128	17128	1619022240000
24480	3NLTVwVcNg3ESh9TVi9kUfRNS8LTW4zvpfLkupYBtZTp76K4mS8S	24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	1445	1164	453	12463	16379	jwpqrAtY6tRRDsypsovYNscyJApSossNDVE1qq3u7YJCa8jgniE	11970	17131	17131	1619022780000
24485	3NKWzZthr8nSsPseTqKc46j93o7558gaprNTDrxpxtX3E2ggf7i8	24484	3NKGWec7woCuRtBT6m3jt3Low5kPUWSSdV1RGbrCvDBya5VigptD	1419	814	462	12463	16384	jwsf18bnhhWtibs2qgvAR9dV3RqsKe8QYRooUueSKanR6VaMWNv	12175	17133	17133	1619023140000
24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	24487	3NKHXLFi4h5VJcUEhoPmWuTz5K348NY5PKu9feuNRs5sLNhmKcWo	152	1084	463	12463	16387	jxZn9nQzHz1kygEyjJvnmTWfxPoU8HkLZMWRYbfBssqX1nHoTCj	12178	17138	17138	1619024040000
24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	1403	824	463	12463	16390	jxxWy3mxztt9hrLioJvh6Y9B9qkAgdNGu5zpCTvrXr3kV9fuGcp	12180	17141	17141	1619024580000
24493	3NKGCiv78ThKWPuGvcTtK7PwNEvycNP36z2WHw738HbVPmJUCLr6	24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	298	1182	463	12463	16392	jxwnS2Lgf1Tbt3G4Kpnp36WKeoEtZ75amJ7k6j3G7oURoKKX57h	12181	17142	17142	1619024760000
24496	3NKafY5gEqb4cUeKFXbPT4bRvqG9i9zwr7LZR1fWWVTVE1oRmRmC	24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	532	1303	463	12463	16394	jxe1p1E9WD94Ad3s8aEhmV173BgW6AgpxJxWji9VkJyUMepKByo	12182	17143	17143	1619024940000
24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	24501	3NKhPgGAkDUdA7o94C76gvXoynhYYNbqZyiwQH6QhzHVifZMb9oT	1403	824	463	12463	16401	jxSp3zsxEtvoAwo93WKqe5Fj9BtnXucfUiJk4w8vjv18LZxVkFQ	12187	17149	17149	1619026020000
24508	3NKw3BZtKD6sXtiZ3ZTDZLvTxVgZtDSLVBBuqEk1uHYajcCjEB44	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1542	1178	463	12463	16406	jy2TeFfqG4ShakEmy66uLGK4WmGESPsk3mwadG7pE7BdSyFs3Zr	12190	17153	17153	1619026740000
24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1623	839	463	12463	16409	jwHs5RkvjyKgNPsbg1YZ7s6kCooFGXPtFX3y6xfajCLaMgo5auX	12190	17153	17153	1619026740000
24513	3NLcn5Lvv1P7Qgj8bq4QXMELN2mGbtP35fjgXpkfF7Bh5RwqvdCf	24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	1407	1395	463	12463	16411	jxUUyGecvAeLWXDtUxUw1ASBzJaThgtRzazRfw2LwFZj8uWrtgf	12191	17155	17155	1619027100000
24518	3NLBHtx5BkzaU5MPXbuNPnVQY4qZAgDEiUCZJVpVGj7eDfR762KC	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1405	1	463	12463	16416	jxYc35KgwWpdBg4Q9aqK7yZN1gx9WjfvQXcTB2GaBo2X3uufgHs	12193	17159	17159	1619027820000
24525	3NKkEddLi8pinGdR7s93h6mLUNn3WKTQFSx6UrhfF7uWnweaLGUg	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1675	1342	458	12463	16423	jxrDAwMepXEcBKVRf15A1vXjAcf9Mdx5a1mHGYTZVoy8gB1yWnz	12082	17159	17159	1619027820000
24528	3NLrrRbNGXaVZbkeoscw7KAjJjzWyPB3MXp856VrTbw7w7TQyN2w	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1407	1395	463	12463	16426	jxsj4iEbgeiSr5MgVW4eDsNZ4Wna2VvuK7Weku3AhmNirVMX1M4	12193	17159	17159	1619027820000
24529	3NKePdyvU5chZwFQmH8rr9pbZMNmYd1HbQTTTQ1h8cDbUNkUH587	24524	3NKeaZ6bj82BDwNyb6t63kwzRVACMEpFT4CXRvSNBu1oaUd7ZoCa	1406	1393	463	12463	16427	jwwnBFQUfTgUgEf7F2mSTn7aHTm7tJyJLfeFMMmr1X4HSMA1Dzx	12194	17161	17161	1619028180000
24531	3NKHGX3aN8YuSMmbj6FWsgFL7R2Z1GVHE3wHESsRVzP5VXQdyWc7	24529	3NKePdyvU5chZwFQmH8rr9pbZMNmYd1HbQTTTQ1h8cDbUNkUH587	1426	1238	463	12463	16429	jwDv7k4zEoTuEBEf3tQn1U5uDR4sQBq3G3nsmmA4CwoVAfsFa1b	12195	17162	17162	1619028360000
24535	3NKL6u14fadM4gH1yCwZ4ycvJK27JmwRFmXHuxUoktxDrSV7QuKb	24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	1477	1224	463	12463	16433	jw6wXhhbkCGWWBGqFsoBvNwjYgR1T4rymXNJ7hx8sX1EYhDiSAx	12193	17167	17167	1619029260000
24537	3NL1FU7hi1NhTxh1hRhQgWwxfts7uDTdNmmvyEeFkL5HbKuvJTac	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1403	782	463	12463	16435	jwofEK56wqZwDPw33S2H3PXAmQ9tE2WsVqGrdiqPP3kYhGiZCFi	12200	17170	17170	1619029800000
24544	3NKGCSTMUvjZnG7zfejrTZb2goxbk4354XEtpnAqmyLikhAASfo7	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1571	1089	457	12463	16441	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV	12070	17174	17174	1619030554802
24442	3NK5jJFBhAQ8MGgWwhuPVRLn6WGYZ7H9K3mN3jHvquvP39C1967q	24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	1403	31	462	12463	16343	jw9zyzg19RgWRviip3j3yv2tcjF48DmpFyMB9SA7oZ4VWqK6XkL	12154	17106	17106	1619018280000
24444	3NLa7518CqyqG5s8B5LrzMAnj1mzWSxabA1vcsgufJxgCoJFDTHw	24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	1589	1286	462	12463	16345	jwajNRLpkEYFjtwcYSrXSYFqA9VVPhDQH87z2NaHjMApdow9dkv	12157	17107	17107	1619018460000
24446	3NKJhM3Q8TeivAiZTKechF6zpvacnHuJUoAv15NcXNDXsVBMuyfq	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	563	1113	460	12463	16347	jxP46rjEMgboboxeUmcTbyhgUUBWarnxbJy2cnPTk8ky1kZRwBk	12109	17108	17108	1619018640000
24449	3NLKJFRhor29WS1MEgX31ccRrrkspBrjF5khvx5BC6LtNAJg5141	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1529	1190	462	12463	16350	jxZ2mSMUaDUNMv5avBr8F1qspK8QvwGMcAWMAxvjaSV4za5M64i	12159	17110	17110	1619019000000
24452	3NLRudYC7sTwZjVzZVkfRFd8A3sc5dDkT5YPX1Lc6fEfg2vXyKUG	24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	1447	143	462	12463	16352	jx29sAvjhLXTv16WjfCCgtujdyrZU4oonPWGyB22mon5hq8w7UP	12160	17111	17111	1619019180000
24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1451	1292	462	12463	16357	jwgjy9ciTvFMZRza4gW3ca5mnWV5APBvvwz37xZFme3MxpoGoew	12163	17116	17116	1619020080000
24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	24464	3NKfrhv9Wka7x9xJvwABd6W96SrrAysH4FX5F2CqjTWRxNEFutyE	1588	1392	462	12463	16365	jwgQh1Go5mKMftZiMu9M4nfCDNvRaK98Yn8QjD3rwQiATujtL6F	12167	17123	17123	1619021340000
24468	3NL6S7FtR24KGVzv6udjjkE9c69QMvqnK7Na9fZa4rBvKSm24AoZ	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1476	1005	462	12463	16368	jxNtDACyF9DQBoudzbtVoJ4pJFRB5hgZkkDWATo6ysmgoi6YUxb	12168	17124	17124	1619021520000
24472	3NL42MidpVStUNoFTExmP6xFMcb3r6vsE5LVjprrJUcQGfTiXAma	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1546	1213	462	12463	16371	jx7ygaRTpYvdUXRJZDBiY1f12L6Gq6n9QmrMKRpiMiSUBeJxT8b	12170	17127	17127	1619022060000
24476	3NKG9Di7KY4PhGmuPgG6xCjinLVaL2Et2GQsX1SQn4drhrJJtx5z	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1637	816	462	12463	16375	jx8P46Trkdr8k47Gu2tKnSkgz8Ks95xTH2whunK79x2WJRPzdZ8	12170	17127	17127	1619022060000
24481	3NLmQGU6TFKYmXcQwgYgA1Z4d9ArfXka6eVcwFNYe87Wwr5BMmb8	24479	3NK8FiFj95bJtNvheYBv6MBVsmseqzciYHzT7DkdDxcAYEf7K5Yp	1445	1164	462	12463	16380	jw8gCC664V5HCshBHrua7VYXrnk3LrowBqu5Vp5KxtMQxhzN58u	12173	17131	17131	1619022780000
24483	3NKRBpJFNwzWPYBPUuQBaz5oyQxuMRVp6SC2PP34jTCmVbwoRprA	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1445	1164	454	12463	16382	jxZfjyyVq9yWMuPCfHqBBJhcFAYGa3gCgeep3Smqh2nn53AD49r	11995	17131	17131	1619022893980
24487	3NKHXLFi4h5VJcUEhoPmWuTz5K348NY5PKu9feuNRs5sLNhmKcWo	24486	3NLf1psCSmKYeoaSi8EokEsA8QDcUdwXBiBy42WRAVSz9ngkaiW5	1637	816	463	12463	16386	jxyWNfTFAiqRUTdBeEHZ3mhGGwCdJMQCfyQVsXVmwYxy94Mpq4h	12177	17137	17137	1619023860000
24490	3NKRC6BuejvsXrEZZRnqDThwXcaqWv32TMXNVgxAxfTs3byvTb12	24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	42	1361	463	12463	16389	jwPwQZurC8ghXdmtp2HL4FyBuosAfKvPCG1a9BNgbVreLTVN9b1	12179	17140	17140	1619024400000
24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	176	176	463	12463	16393	jxumxTQHxtb93hTbJjVgT3xF8SBESqpiUjE6dS7BckjTxoWCcYq	12181	17142	17142	1619024760000
24497	3NLVF1g8b6jsajvJseRkScph55ygFZ8B4zcYBT1w1AN5aVr45uDR	24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	1553	776	463	12463	16395	jx6SKZsiNqNhjrff6FfJVNMMRTKdaWnpReDLkJE5dQArEPZJMnE	12183	17145	17145	1619025300000
24499	3NLcMyhFCynzBPp8eh8cQyRLujTpvMcMRNTEKAYDM6KwEswFTaFr	24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	1610	948	463	12463	16397	jxcx2AcZsGmp4kYmCmfMccFsztz1NaPfv3SkUPCzvNGSupGeoev	12184	17146	17146	1619025480000
24502	3NKmTPgiCXBxVVcS1LivruUqTZjoRmjJYNNdsqYyH36Lv2b1mfTt	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1654	1340	456	12463	16400	jxCX2CdAUijhF99jtPhDfW4y3gf7b7teiLZKgaY8a1VWK4FLinj	12028	17148	17148	1619025840000
24504	3NKSTCaw7Mg1xvuwWrTW6VzzYRxcn2zqBEcbdfhAgK9oU5EaQWn8	24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	1406	1393	463	12463	16402	jwy8DXh8bDNkChcqomTBRPuijAuuwKxwgGpgnJdSwEc7igZqDGq	12188	17150	17150	1619026200000
24510	3NKgwHbKdFvswPopS3pRvmKv1nG4zpkJKXtevdgH5dN1hMjKVKVb	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1602	1123	463	12463	16408	jwvxzQf9LBkkqEV5yF9fSaGt9yHyvHeagaSYjdW96nu6GeQ95Ze	12190	17153	17153	1619026740000
24514	3NLwoEoFRLtyqvW5YgUqQhf1HbzJpLPY9952qeUnnBJJQrmA49QB	24319	3NKVvzte2NhGGn3dmUt3amP1o93uPqN9PjV8WeCi3Evw9HU7d4B2	526	648	459	12463	16412	jxR1juJ8ovdBtEJKzkqP2k93ajVinQKS34Bbs9Fxpj2CNd6RC6a	12096	17158	17158	1619027640000
24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	526	648	463	12463	16414	jwf8t4mKU7BvPP8WAhyHxybp4M3GVWzzpPQSNzVhDmDyTeo38bj	12192	17158	17158	1619027640000
24517	3NKKuLxyXnHR5uLheYRxNdoiXEEBdyDPkQvraHirdQjeXLLbcp8n	24245	3NKo9S1vPZYwYrJ51nuZoYNQ8pJ2M44xrcWrVqddcAqVyS9S3VCc	1500	931	451	12463	16415	jx883Zbe7ngr7B6QtB8nE7pYxtXiASnMQSCbX9W5usqGyhshKPQ	11919	17159	17159	1619027820000
24520	3NKHnZWVou754BJmYbKkasFnaxnPCyZkfmHKf2TemyspRsyBP8tA	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1458	1197	463	12463	16418	jx2mhJ4Xcs1xoVyM6dZxq29wN8EBVyNyyfpY4g7tCx3QsJP5ALh	12193	17159	17159	1619027820000
24523	3NK9Tzt89aoKbov2Xf6sv9aNCvkyeiYf3m1MJeJGZErE8V9BHPmn	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1500	931	463	12463	16421	jw9kWL7PcgLDqTfmB3bGoQwLLoxwxM7Ri2Q5AMM6gNRFsQeFkRX	12193	17159	17159	1619027820000
24527	3NKpZSWWDCZoDJMXj4rqSgd7x27TKFr6LRgsF14xDjKNVsMDpqGc	24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	1458	1197	462	12463	16425	jy2JS9YF39WJf9rpM8eP1LGPzxK5n7RrcyE5fW2cttjohT7goG5	12156	17159	17159	1619027820000
24530	3NKiTCKD7GS4DsAhFxJQpXJAc63XtSnXaN2EV4b8aF1QWmRevSDp	24462	3NLi5SdkKYQaVbEQq2mTBAkeeV6mWgjAeExcaMqZJyouvXw7zgbE	1426	1238	461	12463	16428	jxrxAd2L4pTPvu8GjkcCeV7fHYtTg2rHVC6G1Dz1obyCtKCCwH6	12152	17162	17162	1619028360000
24533	3NKmB44Wftf9aY78JUjUVgnJRXJco1XJS7TtNfAF3h4FmpeXnqgM	24532	3NKVmMFhcdWyshuVXZzHqBaHr1fVhcgZvfNm44yW15GjayKQsx3R	1444	1381	463	12463	16431	jxrBasxhVXZC5ozRTtzFSpMvWFveppTUk4ShwPr7XsBqYXwh3RP	12197	17165	17165	1619028900000
24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	1646	1354	463	12463	16434	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2	12199	17169	17169	1619029620000
24541	3NKv1GQpbzkdtA1LcWszLs6qAPMhrj5Pcp6R14dvfhMLm4QfSvYe	24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	1406	1393	464	12463	16438	jx2boYR4dQG3QXuzixLUdmyC1DpkpJ479gjnHtg89aohHaLWjop	12202	17173	17173	1619030340000
24543	3NL9pcPk9dh77J6fivKRrUNEqzJMT9CuGQZu1KsXjsArnU4gpbpF	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1571	1089	457	12463	16440	jwxzEvxxe3BqdR6RGS8QryVKiEcsMUPyQPTebbfw2cu29FChjCQ	12060	17174	17174	1619030520000
24545	3NKzb6ypGkGYvG1YuANGUd8ifD9ieLuPd51uv6jgrcNB7sbZGWfq	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1571	1089	458	12463	16442	jwhXVtRadvFpMGp6M6AqWayhjuTXDedauntt2fbmqRoP3hYGfti	12080	17174	17174	1619030590250
24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1648	1284	462	12463	16367	jwxEVK8V1AqU8LJTQS4w1tnnPqEP6inywRNv1WiGU8dDm97uZgc	12168	17124	17124	1619021520000
24475	3NL4J6nBFeKfPNNcjbMRQ4DnXLFGMDPtDeraz4f5BeU7EcbBJXVs	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	700	832	462	12463	16374	jxZkys7eYqxQRMnN4un1vcBVSsk5QR5ZSxhsvzVioanZXmtDK4n	12170	17127	17127	1619022060000
24478	3NKpNkNKTS9MXw4DAVcz2saKstDcJ6RwJp1gnENQVR7NfyWb6wFD	24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	1623	839	462	12463	16377	jxUPNbAB1v3qdnoDapr8jysBjKM8YMYeMw6jmwHtd17W36ennhG	12172	17129	17129	1619022420000
24486	3NLf1psCSmKYeoaSi8EokEsA8QDcUdwXBiBy42WRAVSz9ngkaiW5	24485	3NKWzZthr8nSsPseTqKc46j93o7558gaprNTDrxpxtX3E2ggf7i8	152	1084	463	12463	16385	jwXnR9Au1eVYTCiY8cJPtHyaACS8zoBXcyhwhNGtwPjiovg2Aw4	12176	17135	17135	1619023500000
24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	1668	1124	463	12463	16388	jxav8JEKYCq1QZhUKx4vBTn1toLTtQemydCWJSUUvRwtDE1t367	12179	17140	17140	1619024400000
24492	3NLaWJXSAkBCeKiBPeeL5hJgQj3dYGyJspnZDhkvch8JjrHkjAwA	24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	1483	361	463	12463	16391	jwD8K4C3mSsuPH3oWoaFYUfH1SWhPFFbPu8PpfQ5UJdQyzRTkZc	12180	17141	17141	1619024580000
24501	3NKhPgGAkDUdA7o94C76gvXoynhYYNbqZyiwQH6QhzHVifZMb9oT	24500	3NKquk95rTJP1QufXnTQUB9KfVCMAceDsGTZfrJS2sqTHsZFmE6Q	1654	1340	463	12463	16399	jwuh9MXB6Zfhxbsz8bKcUHCd2sbLDpb5P7bzSEauPEZNLMefNJe	12186	17148	17148	1619025840000
24506	3NKnAwqMQz24ykEEJ1XREuhV6n7g2v75QUwVphhCf19iyCWsxR9x	24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	58	1281	463	12463	16404	jwbMdDZToQ1LQSfYsjeNBSF8mxQeUUnaPgW69irCKiA1sQtp7dL	12188	17150	17150	1619026200000
24509	3NLCDtCk7eoZC6qsHe7Z5iDFdii8fWZBfybc8x33ce7KhRuXeGiA	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1668	1668	463	12463	16407	jxepE5TiJvQJL8MwECgLN8pzWTfrWxsymt31zmFbLnzzrGpUntP	12190	17153	17153	1619026740000
24519	3NK3MZx7PAZVKbVfThaGvgB4jq3dQitD7nTdCDBju6WWPSdm1k87	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1657	1098	463	12463	16417	jxSuUzicJRuMX1YK3UjrmwqQwUoL6pnBiqJxM797AX8xHYyaRQu	12193	17159	17159	1619027820000
24522	3NKsCTmdBtCEyKdJVjwFDJ2dCic1ZqjScdGqERoZV4AVrRCVGXfH	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1615	459	463	12463	16420	jwhsaz9s1MubYdYxDdp6zzVxg9CWM1kgUZGQozJsHCHk6YtTJe3	12193	17159	17159	1619027820000
24526	3NLJxhPG5WDfZnfbY4uJvharMEcud6NibqivYrLqm7NqpN6RgXgc	24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	1675	1342	463	12463	16424	jwfrBKArfJc8dVtfAQQaDbzXzhEP66mfRK3DFG9fH4mQYACp4kj	12193	17159	17159	1619027820000
24532	3NKVmMFhcdWyshuVXZzHqBaHr1fVhcgZvfNm44yW15GjayKQsx3R	24531	3NKHGX3aN8YuSMmbj6FWsgFL7R2Z1GVHE3wHESsRVzP5VXQdyWc7	448	1179	463	12463	16430	jwK9H95FrQEMv2Cg3iQ5k5A63yTrbB87sDKqeZiwbgz2ddgdfog	12196	17163	17163	1619028540000
24538	3NLhadjTDHKV5LqogmJvQkQWai2b4JoaBSuWPNFpa3TwXxEZNuiE	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1541	1298	464	12463	16436	jxxet6yYWJPE86gH1sH97jvdaF9SHD9EbxM2ri5UvuBff3vEDAt	12200	17170	17170	1619029800000
24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	24537	3NL1FU7hi1NhTxh1hRhQgWwxfts7uDTdNmmvyEeFkL5HbKuvJTac	684	1226	464	12463	16437	jxGjTdQirH8rDb2KRN89FUciowajfWBiKNv6kMHSe5gAC3W3Wgz	12201	17171	17171	1619029980000
24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	24541	3NKv1GQpbzkdtA1LcWszLs6qAPMhrj5Pcp6R14dvfhMLm4QfSvYe	1483	1030	464	12463	16444	jwSRcSxEh7RtYRMJEph5Hr3EGHUxtFYxBzZcTWFSVrWa4EpvVeU	12203	17175	17175	1619030700000
24550	3NLTqvQ4NyFgUaZ6QCU1gTgXKz6digb9BsUfmZyqUHHCA3Bm9fa7	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1633	1390	464	12463	16447	jwafnVBbJqxjuVUiQadC8PL2D9UgVD5MU3spJ57jk3hWjyaPiXM	12204	17176	17176	1619030880000
24554	3NLQY1rrZXVFotpu1VsRi8xt4XgXRCEhrMygtGkHa793UL61iyCL	24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	1581	777	464	12463	16451	jx2phZRSb1MpSDnKKsfQV3AMeHqAtKRmNobTtMqy3gdVhubrTaC	12205	17177	17177	1619031060000
24558	3NK4p4SZgMSErbVF7nVDj36Gex5SptaeKr4TVRwFqjxY1L5c58ZV	24555	3NLYNYWChzWZcC2kmYvxmVMPkawWeHg4JHimyWcx36ffcJiV84U6	1617	1288	464	12463	16455	jwzpC1Jv3Mw3R6gH96qx8d4EKqU8GDvFeh1nXqV6sBXhgUJVeLu	12207	17180	17180	1619031600000
24561	3NLCYEvL8UbmNT55h64B33XhSMpSALAE7pNQaTT7b5r7fwXPCy4R	24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	1594	1326	464	12463	16457	jwfVcQN6zJonAeaxY2RBWHipAVX99tXM3MBWDHdJHcVbffZaYty	12209	17182	17182	1619031960000
24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	24562	3NKHW3rNF1TRnSxESmxpfubLtmamV85iaSjrDiD8Kc2MyM17EGn2	1581	778	464	12463	16459	jwohsRda5RAruuf2G5BG1rGdg6ZfCCwwwQSMBDBguDTXZ5EZqXn	12211	17184	17184	1619032320000
24566	3NLk2NqZgwk7arL4VFCaygE8yALsgkyHxDWGzrNisuUPHSHCg7Gb	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1578	1170	464	12463	16462	jwQ55P4HPNyJEyD7acvEdwnpLwWMU2xcqp2oeRDCbY9nArAYvYQ	12213	17187	17187	1619032860000
24570	3NLrDkCrFF2vEKWN3WLBhUyxUttdqFBui8R2rRgQ9swfABotqZUx	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1407	1395	464	12463	16466	jy2YAnmj5cuNSsGjP4AxWz3QDR9Co6S6q6nLiZAgapPrVaVibke	12213	17187	17187	1619032860000
24578	3NKepamcLV44GXUi7qTXHqpEsTCF7ikizB5Tre55oByyNAs7xDnq	24576	3NL36Ho5mKGoM69GM3y4nGjNacacqC9uiqHuiEZKzTT3CcUZLoFm	1402	868	464	12463	16473	jwxNXQ8PWHKeFHdGUYzekT3aY5zFd5H7xuvde2VRAxy4jxM9PkJ	12218	17195	17195	1619034300000
24582	3NKAejuZFyrjhQtkUtWWwbTt3MGyxhB2AfwF4gXzbSDdwzz5KyzG	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1549	1362	464	12463	16477	jx3xZ6RDHqhARusfFBc3WBZwd8kJMobWwUs47qJdKotNUBqWMVb	12222	17204	17204	1619035920000
24593	3NKagtPbbnWZVBDpU2n3N4NAM9Pb3YTeSJvD1rT4momnTUBkZugT	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1426	1364	465	12463	16484	jwMZ8Vg1umXJB2orQ8R9PsT1wSwMaAuuQJ4nSUbzCRH4cLvU4uM	12225	17211	17211	1619037180000
24595	3NK355cxb2MKRf3tvnRwQJvsNksrmqSiz5YirkprYakwdELHP15j	24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	1403	782	465	12463	16486	jxMsr4AFmHnC5LPkP4QV7tCQDuzky85hUKkoJYBm1ZSr2ws1iSi	12226	17212	17212	1619037360000
24597	3NLgtgo2qGCz11vUFbgL7prC7bgzHmLY5HctX933ukwrk36R7Fc9	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	1609	1087	465	12463	16488	jwgUA7RtBEuN4fMos4XE4SN1V4xJWuLddBPNS4phz9B6sGchJqV	12227	17213	17213	1619037540000
24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	1406	1393	465	12463	16492	jwEvpemEdV76KDSpjnsR1KtRtHhm6RuUTLMBuAdLBATarCoLoh6	12229	17215	17215	1619037900000
24604	3NKbkSQoPhaNRKTUxj1ER96ob1JVeK3R9EutBBZw9EXPpCfbLa74	24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	1483	1030	465	12463	16494	jw8adeCWBwXG94GcjAE8oBLe5Zs2sYZCc3TqoAXmauek7hJsWX1	12230	17216	17216	1619038080000
24607	3NK7a13buuLBjRMmf8htXvmaU4qRhYGvf4qa48fLWjNgLwLtYpm4	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	152	1084	465	12463	16497	jwAD8iECvmfaaofsNkSC38yJZsEPienRPLwfqKLKTxmEZSLX22p	12232	17219	17219	1619038620000
24613	3NK8XqzeyT5QWgNYcaQAxURA65SxGAs5uyN7ftNePwVhLEAWKAJo	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1560	1045	465	12463	16503	jwDQnMoQfqJGSHtUSQyGMGqsyiDBFDLeUcoHagHSJuzA9kBw5iq	12233	17220	17220	1619038800000
24521	3NLC2zq2ESKte1gSKw1zREA25jBGaeSbvwASaGvarapkxhPug5XF	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1402	852	463	12463	16419	jxERQ4AChgDkxZCtRgX9XjiMuLP57F5bbeRwSf4uyZaQ5EVhthy	12193	17159	17159	1619027820000
24524	3NKeaZ6bj82BDwNyb6t63kwzRVACMEpFT4CXRvSNBu1oaUd7ZoCa	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1675	1342	463	12463	16422	jweSLCkLBV51h5Hc9dq9JEMiqs2gFji5tuhLHWrKHpvby8iXKjk	12193	17159	17159	1619027820000
24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	24533	3NKmB44Wftf9aY78JUjUVgnJRXJco1XJS7TtNfAF3h4FmpeXnqgM	1477	1224	463	12463	16432	jwh6H59uhbjxRxQ7oi9vuPGYncoiyAAXHMDRyJ1BD2yfCX7ute7	12198	17167	17167	1619029260000
24539	3NLwECk8iVtvaAKuSf5nKpy9sfjuLVvLFXRH4RhmDxcEETcTXWd9	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1541	1298	464	12463	16436	jxSEPYGa7X8uBe25g4GjDkv53qyMupLKtZmwb48SG8ps2AcVzAh	12200	17170	17170	1619029800000
24542	3NKQTnSF2DU5eZK4g11tjx11R4zp2gZJYAUkGTGkV3Tc7hxSeA8H	24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	1460	376	464	12463	16439	jwJMhvoQxoUPb3JGMdWmnw1PGv9uaG1EAJkuLNEACbFbJwZ9s4C	12202	17173	17173	1619030340000
24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1406	1393	464	12463	16445	jxJgHuQbUCBrWdgmqb8GhmJDgu7nqWNrxCehf8Wvwiw5PvU8mXn	12204	17176	17176	1619030880000
24552	3NLJcXm19s2JQuYA84GrP38vSe6yho16YCrXR8NSQKUWDMHGPC8k	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1633	1390	463	12463	16449	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2	12200	17176	17176	1619030880000
24555	3NLYNYWChzWZcC2kmYvxmVMPkawWeHg4JHimyWcx36ffcJiV84U6	24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	1547	1378	464	12463	16452	jwxWjPTZ28Cd9GQUsQt6ZVQUqVavxKvqEGCFYkK6NkGnqFHhws1	12206	17179	17179	1619031420000
24557	3NLL5XTjiYWkciCuGZm5zhyYsjJccco9N39DHKcPnHExxjaBqgxG	24502	3NKmTPgiCXBxVVcS1LivruUqTZjoRmjJYNNdsqYyH36Lv2b1mfTt	1654	1214	457	12463	16454	jxRBbcA5P26ZLkXwjUpTPqCj7rg8CKX8xYVhuSCupbQmxgVa8tY	12029	17179	17179	1619031420000
24562	3NKHW3rNF1TRnSxESmxpfubLtmamV85iaSjrDiD8Kc2MyM17EGn2	24561	3NLCYEvL8UbmNT55h64B33XhSMpSALAE7pNQaTT7b5r7fwXPCy4R	1406	1393	464	12463	16458	jxRK8LSLfREbHYxYR917e5XL5qvAVgMmL64t8oP5XaYQ1LzqzCj	12210	17183	17183	1619032140000
24568	3NL9pth51i4aJzyuYX7wXZ7PU85QJgsFaaNePRHr3VzURus7jRFE	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1406	1393	464	12463	16464	jxr4t9bC3ZMFdGWVNKsH1DtSEQ5Ewyo2y48GoqZmVwbDL24yQ3s	12213	17187	17187	1619032860000
24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	24567	3NKZhmCSiQErbjcsVz4qPMvNgBGNYv8o2cFST67iKSkCPnWGGMRs	1534	431	464	12463	16467	jwYMrhpemf2cWAJDe7uuZw61snagFTTita7JaPViNxS6iYvRs1x	12214	17188	17188	1619033040000
24572	3NL38UGQUjQudo4jBEtjgYA83B779bNUXS6CgreJj3rycwQaSboi	24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	1541	610	464	12463	16468	jxmu6SNVnKy3zDBh2VeVW9UJAbP5tBnRejnLtbzkcGYuvNa4i1z	12215	17192	17192	1619033760000
24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	1402	810	464	12463	16470	jwHmqmYu3nEqatt4KybbBvxzCCW4Th1qqPRXPZZ6TidJuLC8K95	12216	17193	17193	1619033940000
24577	3NLX9P8v5jRhy611aHp5QbhSMK6MkQtmNJ41VqZrxmcPz5XbCTQY	24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	1531	294	464	12463	16472	jwPaH63A2hB6xDGpnBCCjgmd7EimnFbGxXEmzcutsAMH6pPuR4L	12217	17194	17194	1619034120000
24579	3NKG5RNXeYwuGwRaM1rLidUom9FVj51HRJkrAoMz8YnSKAiBBKB6	24578	3NKepamcLV44GXUi7qTXHqpEsTCF7ikizB5Tre55oByyNAs7xDnq	1406	1393	464	12463	16474	jwUd4sUoKoyShhvhQW5N6JSDegEk5qJYahLHyRznjTjURSb71SZ	12219	17196	17196	1619034480000
24580	3NLcuk4e9Qfc2fbSpw84kJT418uLzwt9rSA1HtpoAyYfMELz4q7D	24579	3NKG5RNXeYwuGwRaM1rLidUom9FVj51HRJkrAoMz8YnSKAiBBKB6	1460	627	464	12463	16475	jw9UxErm1rSnPmVjeLfGx5ZZi3vXQe3w1hKzzsEvTS58BkScs1d	12220	17199	17199	1619035020000
24584	3NLb5Bpd8Q1PRpkqC5uU2G8e93irwb2oeinpZo3vUcq8dDnBvEqo	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1613	1349	464	12463	16479	jwTq7T5vsDH147yG6hpdoe5gUFbUxZPeYz3ejnTWegyDJwANk9s	12222	17204	17204	1619035920000
24586	3NLTVoLL46Cwu8pwp39qJDRSTudtorrnumsFRVfWDnLATwS4PQY3	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1549	1362	464	12463	16477	jxs8REcfiKMzBfr9PsMS4fFYjeBDAgVbH5xgnnk6S2MAbuUv55m	12222	17204	17204	1619035920000
24589	3NKwFYeSJV7ZY1cpZ9V1ssHaBL1Z4FTceGQStCdoi2W5CCTQ4DJe	24586	3NLTVoLL46Cwu8pwp39qJDRSTudtorrnumsFRVfWDnLATwS4PQY3	1668	1124	465	12463	16480	jwf49WQQdQKmwk6NuVkFA736Uy6ooVWUL4jRATxujx1icYqCXf3	12223	17205	17205	1619036100000
24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1589	1160	465	12463	16485	jxdQEDD4Ph8V8cMj2uYWgMAqnM87EonmkW6xmztHjYA1c9HSMKU	12225	17211	17211	1619037180000
24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	44	1325	465	12463	16487	jxXtX2xWAuGPsZn73XUw7ZMfvkN8vYvZqvv5gbRokuSUMP7bnYo	12226	17212	17212	1619037360000
24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	606	1295	465	12463	16489	jxyfH9wRoK9ZoAfhTy7KJhjMQgRnPzj7NfR1qL9VKnbmGJ4zz7e	12227	17213	17213	1619037540000
24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	1406	1393	465	12463	16491	jxQaZcCcYKbahXuKawJmPVMu6qEjyBhXxaae6nFGrgY44gGujJg	12228	17214	17214	1619037720000
24609	3NKk6AzzWAntyyAN1f5hm7nnZi6zKwvC98V3dz71DD4ZDoJ22Rim	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1406	1393	465	12463	16499	jwfF2ksRrX9U46FCrumnHGr9hn3vfvrWCM5WCbc7Ud6mNN4bdez	12232	17219	17219	1619038620000
24623	3NKvhZDzkt8LhR21P961WHXGWTBrUgxn62hMmrpEAMwiEeVM2FZa	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jxrkxnNmdq6KHtvk7cQ57Q5btR2GckwcPEVSgyv5T2FAmSPfa6w	12236	17227	17227	1619040060000
24630	3NK78TDdqWp6UtE412B4TxTrsc9zp9K9ZcrFCB984w8aQXiFei2d	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1406	1393	465	12463	16517	jxDUkwZ9ZfFmNcvGBsy2WfauMX8n817c4rndBDCxs4HEKGRgQaU	12239	17232	17232	1619040960000
24635	3NKHxjicyUaupZJRWJr6n5qi8AbVombkQoMy88ahqb1M5KEhKHFF	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000
24641	3NLcENnR1LQJiooexENTr7X3xbTSHnWp5fa7eCBQ84SGkzd5EhG2	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1489	1380	466	12463	16524	jwzBbhRpGA6dDyiJMkABXBBqNf5Ly93RkuMPoMALJUYnQZfRhBw	12242	17236	17236	1619041680000
24646	3NK5oqC8Zihpxrfq7EFoC88M4khXQdZmciRB9TfXuHfGKFqUdpVZ	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1549	996	466	12463	16528	jxq9hWShLhCTnLaYwAcMAJD6r67hMFKU8vB93BW2VPRZkBagX7D	12243	17237	17237	1619041860000
24648	3NL6e6MkWMKb4uUuSX6NpzYY3ompkx44U6pfziCggJ37kHBxuTaw	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1448	945	466	12463	16529	jxCGs6WDpyzQFEkU5H2wdMcv9kFSjVp5P6TeBhMc2T7Jfgs3767	12244	17238	17238	1619042040000
24653	3NLmUGP2eyvaR2vQCc1ffLYb7iWWxbprwAgBXJiVs5mEdyJZ5PQ9	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1506	1247	466	12463	16533	jw7gNNXeRNhuoeowTw26uuDaoWHL3DY3oLZM6KRYc9YgmXB4LCg	12245	17239	17239	1619042220000
24546	3NLx16gR7vtnsnpKisqn4se2q3NcC5fJSfk32J1sm1v5h3uQpDwE	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1571	1089	459	12463	16443	jxnsbc5anYR6D5R5xA4E3aCr43QCqEoQMCuabPzPHsx4d2ZqUhQ	12090	17174	17174	1619030627108
24549	3NKvnv8kSWnqwQufvzYiVx3wjh4a7RuMLRhaxwGgdrNpynArXJzv	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1553	776	464	12463	16446	jxfGsGM1kxvRD2JSBtQDrJadR8J2d5eHrTHVWQWpDu2k45KKor3	12204	17176	17176	1619030880000
24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	1600	1126	464	12463	16450	jwrumf3vbyV2RxQDGVMJf6kSVEK7jWPbL7FTqAdJ5YTZ6asFYno	12205	17177	17177	1619031060000
24556	3NKDuseYsANq58iUvj6nVbSDtw6zyp7UjJWN9FSP1KJw6W8oYEoN	24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	1654	1214	464	12463	16453	jxHycjsJCwctCdbYdeq1MzmGobeBUtQi4EVVdHctkWJU3tknRD7	12206	17179	17179	1619031420000
24560	3NKxN8oZkySQU4H56eqySztBoybpjeN1SopM1PCuNE73aiPUhDPw	24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	1594	1326	464	12463	16457	jx3vcbUBcX9t22vKn9T2eSLsoPXbxGAvGvmHFS2BnsHiHuKwJbh	12209	17182	17182	1619031960000
24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	1402	852	464	12463	16461	jxv8LvfjGorkpc5pCZ12p66Rv4n1UdAv4jKRhKSrZViJgskiLu2	12212	17185	17185	1619032500000
24569	3NLQtdM6ntWFzpg557VYG1xyQ1ReLpcmmd4udoZhaFtRW4M4FBgY	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1460	1078	464	12463	16465	jwDH1DApV7zpP6FNmFyTDgosD933iv2dQwCcLyazh17V7P5PkH5	12213	17187	17187	1619032860000
24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	1541	610	464	12463	16468	jxo5JMMfGGqhEbkUWKxgrHq9LQSyDyz5MijKwfPdVkUxYMBbngU	12215	17192	17192	1619033760000
24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	24580	3NLcuk4e9Qfc2fbSpw84kJT418uLzwt9rSA1HtpoAyYfMELz4q7D	1406	1393	464	12463	16476	jxj8Nvkp34ZhFd67XYFvscJAtMAbrwgub49L2dmR7U8dsSTBdDe	12221	17201	17201	1619035380000
24585	3NK8Z4ouosXfRWCgMLxFhHz8uHLNpMP2TD3VWAjEySw3H5x59g3T	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1440	1377	464	12463	16478	jwLVJ4o6Ug2uhtYVk5ntK9JkMQougxfQxCWeRX39BqVVEbuNU7u	12222	17204	17204	1619035920000
24587	3NLLoxdmovzTzAhioku7ZMTcPnpLrJM4AQKRtdYKr1z7iaygCjFR	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1613	1349	464	12463	16479	jwTq7T5vsDH147yG6hpdoe5gUFbUxZPeYz3ejnTWegyDJwANk9s	12222	17204	17204	1619035920000
24592	3NKyQQ7ZrBmvXvx3XYoQeLdnW8AJSPrja7T6o5uCXeyrtNXH6GUS	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1609	1333	465	12463	16483	jwfZNujVq4ehMfyr26A2AbtwomyALS46jLZyCnJUAeCL2afBqk2	12225	17211	17211	1619037180000
24599	3NLAzUssXUXmFMdexMr48mD3g6tegpL5Y6tDQfunJquc9ZNhbCfD	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	1609	1087	465	12463	16488	jwnzq3SdpsLRPWMCoDNDdaBiPmw64TTPSbqnCfu1BXB8jNsLBsi	12227	17213	17213	1619037540000
24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	24605	3NK6hVt3d4rTRXgVrphhUhStv1VK6x3HHWvnrGD2uBvjyKMfuT15	1402	852	465	12463	16496	jxZFuCxjY2z1mHnXxKoV4cNoQJ5BkCNaZhp7mYsfAafmykfgjzb	12231	17218	17218	1619038440000
24611	3NKtkuJGgesBuK44SVMhjD1RtCXyotZB91GJ7GMYwm9HZwkgZnGY	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1445	924	465	12463	16501	jxLk6RT2aaQALVyH47W6ZKMsUBnaAYRSiE475TKuA1XRtiXY8Tv	12232	17219	17219	1619038620000
24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1637	816	465	12463	16505	jwYtCwmx6mruwkbLZDFGfRPtm3UNGWVy3ZTnsBKcL4ciKd3wUNA	12233	17220	17220	1619038800000
24621	3NLTUcAMRDHLowb4HN2AF6HaZqNetxbhL18JCRkfm82oY9emgsmi	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jwu7G1kFLHnCmZAWD9yg8BMr7yotuf9m84Moz5ukW7jdHptBpfZ	12236	17227	17227	1619040060000
24626	3NKoLVRdj9f7pEH7s4o9fCfAZRuP6yxeYNvR3ohqt9pfTde46Qnc	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1581	778	465	12463	16513	jxSKGWihyyjNZDf4ep3d2GVWP3mQccpENSfRdaVChige8Mkc7xg	12236	17227	17227	1619040060000
24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	24627	3NL9p2VvGsoNazcrAz3Kp3qPciaQwZHZEF8LCmEHCPKmqNEHUdMe	1585	1240	465	12463	16515	jwXtuUVGT91DDHFMgiaPqjRa1sntpTYYqdEzRLpmgaCGR5QgLr5	12238	17231	17231	1619040780000
24631	3NLYBpHzaYV2HEhEYBccARNpUs3JQbFyq8qx6S6Tzd6vYGBw5RJx	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1651	1055	465	12463	16518	jxVhS1bZwYewD1eS41oyqLiNhTkeH6b6w8FDSYYhJ5pCaWAhuMn	12239	17232	17232	1619040960000
24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	24632	3NL51qEQZZdc3cpDAnGWws1f2buNeEuNz5MWhr4nM3nAYEiDpLPw	1445	1290	465	12463	16519	jwmk7osKbdBkYzKxyRrf1472PSWv8JdkNzNt12ze8gY8uCNmWvg	12240	17234	17234	1619041320000
24636	3NKrZT75CphPTjzewC35LR5TZtbBKyELfoBZnUMqippNhv2sH9PD	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000
24639	3NKJEL7FVYTcMVrRjGqeQsvz54LkuHzuMWJLwyGt1EvyefNqUNE5	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1549	996	466	12463	16522	jxNxaALNZoxiTdpLs9JSHKWsqFwahzG6299aD2jmQzqtxqY5TEH	12242	17236	17236	1619041680000
24642	3NKUQr27xYxqmWfgmmhU5iqYUGqc8aWuVsmuz97gKYJ38xkVfB5m	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1489	1380	466	12463	16524	jwQkiVh7d6YMr3NEaf2CC26Hnc7x6qe5b9fnXC9CGQkSDAag6tX	12242	17236	17236	1619041680000
24643	3NKkxPENcGcpPksZ3cy2ZyeaET2UMhZmGK71B8BWSQRpZV4Tjooz	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1489	1380	460	12463	16525	jwkeVndJVP1W4KAKkK9a8eprUkfaAwFkEY761tQwWQFxqfqiTyd	12115	17236	17236	1619041680000
24654	3NK4u2ynZjLWMzFoe5Jx5zzyYxAEYyYM1TWuWzY9YBYhrBxScVZS	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1637	816	466	12463	16534	jwMaDHS5CteherdDwhuTQDQ1TeUsM8iYW9gHnpUno8UonLRgcuc	12245	17239	17239	1619042220000
24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	24652	3NLDTCTVWL9URLz2Bdvj9npFykNN21YV7LamWdX6TK1ihGGCVfTv	1585	1000	466	12463	16535	jwUGaZkgyubMZqVXA54KNDjX6UB19Dw4Uc5vJShHaYjXkiaWc8b	12246	17241	17241	1619042580000
24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	1508	1387	466	12463	16537	jwvUxSBKXFUTT6tSrUcDdYLQNESqiT2JYcidXqdZUZFkdKZNfeG	12247	17242	17242	1619042760000
24665	3NKVyeCKxoMwhG2Wj8aC3wBzbzzYuFDKMjBZ5KSCs8fNt2ZQZkCP	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1600	1372	466	12463	16544	jxRWGkaA9FNhBiSKQ9fSTc42EEj4WuhHy68bz8k9UuwM1BrdsW8	12251	17246	17246	1619043480000
24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	24681	3NLYBbPaLCsD4n6qdPZFYKjZ81MaTT4gYuydLGiQBwPTA3pUMPjQ	1407	1395	467	12463	16562	jx5QV7CP6ACiq9GQBwdJpU7c4PV98n4mTDHbHKS33zCe6vUdDyy	12261	17260	17260	1619046000000
24684	3NLJzpTKPN1L8BM7EStbtaav1nYitLTuaQLQkAwRkYwVV9NyzMen	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	606	929	467	12463	16563	jx7osrD5ipjz1JwW7MrD86wZuU9pijqzkTzz7BhTXSSSwBNTtTT	12262	17263	17263	1619046540000
24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	24689	3NLub4TsCqhMGPkJfbFWPBmQRhkqUCk5kCRc7hP5GEyu7YUFYwZD	1406	1393	467	12463	16570	jxuYoZMaphRuzcLSRjWtcnUDkuqr6qNWeVvti9tjwzQB5nzR2QC	12264	17265	17265	1619046900000
24551	3NL67oXzX7qfeqYvJXYikLdGUtJB6nqnoJ9DP1pxWT2xnySnDnuq	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1631	794	464	12463	16448	jxbaepSkQ6U5pjZtXQ9FnEFj6bT8koyt97Gu7P94PC4GVvqHzkb	12204	17176	17176	1619030880000
24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	24558	3NK4p4SZgMSErbVF7nVDj36Gex5SptaeKr4TVRwFqjxY1L5c58ZV	1407	1395	464	12463	16456	jxCdajxrgdukZqMpaiJR7fvz4eaUmZ1d1MHz4rdnxKJWnvwPcsC	12208	17181	17181	1619031780000
24564	3NK58iAebpTuQu2iF4f5dwTrXkPkHPpVpG8ybXVy9Pmi95eAWEjm	24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	1588	1146	464	12463	16460	jx957sgLfcwUj9NTUs38BsScgstiDsJYyrGtNBtGiiaoxxRx3mX	12212	17185	17185	1619032500000
24567	3NKZhmCSiQErbjcsVz4qPMvNgBGNYv8o2cFST67iKSkCPnWGGMRs	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1405	867	464	12463	16463	jwjUiewjQt3EiW5Hgf1V6D9EzJufnKFC46cr5rk2pNT2XHFX6Ae	12213	17187	17187	1619032860000
24574	3NLbsWCgjwcMDhtCu8pUcQyLDEfA39THJDc9kYahmH3qzNMLdpYG	24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	1403	824	464	12463	16469	jwV8E43449GPfmTsVJwbeS5TTiMW2y5Vj59kENH2VspRNze1KPg	12216	17193	17193	1619033940000
24576	3NL36Ho5mKGoM69GM3y4nGjNacacqC9uiqHuiEZKzTT3CcUZLoFm	24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	1447	1345	464	12463	16471	jx2XLSYUHrkUDdhDmryePDav4JELQotEDVNtomD41f1r16zcaTw	12217	17194	17194	1619034120000
24583	3NKVYeEZ4PNeGiCF6huRXznFq8i3sVGRqthB8NSi5A4DmnnCmWSK	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1440	1377	464	12463	16478	jxTvo82LrmBtWiaG9NXPF6pughRNoVABryrB1mJLCn77R3HjktX	12222	17204	17204	1619035920000
24588	3NKmUgiVaKLDCSAoJeJq7YG6Hd3oL9pasYwwEmNRxjky1bavAmD7	24582	3NKAejuZFyrjhQtkUtWWwbTt3MGyxhB2AfwF4gXzbSDdwzz5KyzG	1668	1124	465	12463	16480	jxcRSissf9CHaqSBVmnWj13Yc2qo7TzsEwxghu7DYTexZTJaoA4	12223	17205	17205	1619036100000
24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	24588	3NKmUgiVaKLDCSAoJeJq7YG6Hd3oL9pasYwwEmNRxjky1bavAmD7	1402	862	465	12463	16481	jwmsTYwiQhfRd28AtTd4ZPYVT7dDx3RAikTV18pwGWtGovqfEQa	12224	17208	17208	1619036640000
24591	3NLwey7uhKSQBBrfH4kLihktrSUrMaakbeeV6qxkXc5d9raXPC8h	24530	3NKiTCKD7GS4DsAhFxJQpXJAc63XtSnXaN2EV4b8aF1QWmRevSDp	1426	1364	461	12463	16482	jwbHmq4mZpLSXyWE9Ep6sa7UhWR7XUqzPfsGnE55FAqrZ6PRn7t	12153	17211	17211	1619037180000
24600	3NLNjRHCoZtmSs5TYrgAtfcNWhnxNiKP6mE3meFmpi7GX1bP7ebN	24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	1648	1038	465	12463	16490	jxWPWNxAF28uoP1e7foG7B3QXuhqKpAh9v9r4cGMhJYf8gzpXoQ	12228	17214	17214	1619037720000
24603	3NKjCikms9rDREvb1FvJEHyTnDCTmWr4wRhWxqYnkKYcvdCqzPq8	24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	1624	1334	465	12463	16493	jwceRwLZXLKfvdbj5HN9yVXLuLjJUiihWCaQHRNf4XiYcFwtMrC	12229	17215	17215	1619037900000
24605	3NK6hVt3d4rTRXgVrphhUhStv1VK6x3HHWvnrGD2uBvjyKMfuT15	24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	1476	1245	465	12463	16495	jx5dzZ1qtkEqtj6g8KmUozKKLYGnummKhFWpaEAMxAF3c5URQA3	12230	17216	17216	1619038080000
24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1585	1366	465	12463	16498	jwUG2bkN9WB2pPmGAD2nrEyfR252H6W9Jz4pJRrcBrKAZ7Rs117	12232	17219	17219	1619038620000
24610	3NLWd8TmxMYEagnQzTJFH13Xw5ERRWXYZcjKZnXk3hG7csAUfhVh	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	606	1049	465	12463	16500	jwbhiiM7bsyVP4vMcQ7UbgFtRHHVFo5VoAtyuugZRDhtof462R5	12232	17219	17219	1619038620000
24612	3NKCe77bjaiZMcHjUJCLtNELE7nbUc94U5YRgJUWnq2mb5wNt8y9	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1501	1360	465	12463	16502	jweqRiuwFWQ2d8QBpcWG2kzPUhCxVtsa2mWD4bUWfUsyF6TsHW1	12232	17219	17219	1619038620000
24614	3NKPWzZkzgCwKxUbZh1HLMw9RG2Qgzyp1ixEQdXmkyjTNqdnN8je	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1587	1357	465	12463	16504	jxNWk4hG9NAqaSSjFFCtSrJr1vUkMK5SwzEEsJuFScLxJwKQ2BW	12233	17220	17220	1619038800000
24616	3NL25PAnGt5eVnH9JnuHBKy4GH21bG2e9uLsnKAfCWN8XM5BVdUH	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1560	1045	465	12463	16503	jxCm62cBCZDGAZX3zuAgQ6DwriD8GxkpopoQtyMoLUX4KtzsNpb	12233	17220	17220	1619038800000
24618	3NLDWydD4EA2qKfRKbp1v9JVma5SA44JtMPrTXiMdKPEHfM6AHHd	24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	1402	844	465	12463	16507	jxBd2QKtTHhXtb6nB3TsxbrYyijBRdXeXgnKLkHtZmYpZYvGsZX	12234	17225	17225	1619039700000
24620	3NKNwYTEvoZ95jqqt7atapwHM4EyK1Vfvnw6wuXHQQK77TocrfDi	24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	1646	1108	465	12463	16509	jwNmJYTfPYiarL5r1U3PTW4c9mLWtAZUmhXPKMvfe9BVynhvv2f	12235	17226	17226	1619039880000
24625	3NKsTFHjjpJ4kYZLXDkhoxtVWwTjdgfcBRXJoHpe4yfZCNTavb1J	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	563	1113	465	12463	16512	jxh4FX5SBPLmh7VyBLgg6riStQGkddJtQj8mueT9ebK3CsrndAQ	12236	17227	17227	1619040060000
24627	3NL9p2VvGsoNazcrAz3Kp3qPciaQwZHZEF8LCmEHCPKmqNEHUdMe	24626	3NKoLVRdj9f7pEH7s4o9fCfAZRuP6yxeYNvR3ohqt9pfTde46Qnc	1555	1221	465	12463	16514	jxEkoLCCBDKEzHeDRAKYWnENeBPN7iwigCQVFNWZzo1H5caH6tQ	12237	17228	17228	1619040240000
24629	3NLGgjUcchdi4XWu9rBTe9AmkoJeAEctks5UQbS9iVR4EbDvp4jH	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1403	824	465	12463	16516	jwLAwKypmbZPZAUNnMsKKoTQ5WqVyACGkBnwTLMp62eWpdrqq9p	12239	17232	17232	1619040960000
24632	3NL51qEQZZdc3cpDAnGWws1f2buNeEuNz5MWhr4nM3nAYEiDpLPw	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1651	1055	465	12463	16518	jxovquAo5CHzcGE1aizQuqfpstfyi1Cxb1siY9BUdeoJ3MWdTTS	12239	17232	17232	1619040960000
24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1649	1137	465	12463	16520	jxgs3ZWtkQgn7qystmWhPmsrEM55fz7DaTAJKG2H3esDxyNCroT	12241	17235	17235	1619041500000
24638	3NLLBY8dr47Wuxmeb1wqMdDJ2jCNRYLUHZhscTidTZwgRDKr69TD	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1649	1137	465	12463	16520	jwhUw3rj1DVJAhnwQoTajj4iRh93XReZ7AWobk22bAKZgQAFn96	12241	17235	17235	1619041500000
24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1406	1393	466	12463	16527	jwvJDsDQ5y96VrMA9fCRc2L4UCJDTZqumwkM7HnmL5HRVvDVXjz	12243	17237	17237	1619041860000
24647	3NLobknQny5TdBYHKnTK3DYHGdDqTtr7S5jSjWYxdoyDBhQueR7u	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1448	945	466	12463	16529	jxLK1XHxRdtSKEP544VN7csh7WehwByrnLRtBMzfPjgWBQneUfc	12244	17238	17238	1619042040000
24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1627	1385	466	12463	16531	jxdWM679kmXYys9ngMaGQqabiEBtck3ww3rFfJonT9ZAqzD13rA	12244	17238	17238	1619042040000
24652	3NLDTCTVWL9URLz2Bdvj9npFykNN21YV7LamWdX6TK1ihGGCVfTv	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1506	1247	466	12463	16533	jwbnViBjHfkmoQssYTVEaRcgKsaxvjDtJQ2Zdsek2NdbUQCC9rT	12245	17239	17239	1619042220000
24656	3NLssdUekiUhoJqMZcHmCCTccjxmZGJrTzJ4ypK9o9Tp72jk5Z3d	24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	484	953	466	12463	16536	jxU4e6fnvNqA1udCLXQTFwcLy9xP1NpojDctWNy9Fx2i5t29kLh	12247	17242	17242	1619042760000
24659	3NKruhu5BnsvQ9MXCBke4Touex37bxLkhELDrjbLbdAjDFDzjxqt	24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	1406	1393	466	12463	16539	jxgntpDB5LHzRQQwet4HvUL6soLpraDPxmpMN8zeChQgZzpmTg4	12248	17243	17243	1619042940000
24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	576	1355	465	12463	16506	jwcdBAPmJhfMd5kRtc5Gv8iH6jjnRtcgXUWSoL2CXqMF1xi9tPt	12234	17225	17225	1619039700000
24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	1599	1287	465	12463	16508	jwB8zLZcyySnmgFd285dtNB7xQhH59fCiiv8mgukQWUety2puNR	12235	17226	17226	1619039880000
24622	3NLrq596jawTQRk6rphqc3dqMHTWLN9iok5FFFrUccaNqeyb1BZY	24446	3NKJhM3Q8TeivAiZTKechF6zpvacnHuJUoAv15NcXNDXsVBMuyfq	563	1113	460	12463	16511	jwxH6YbeGhTdGUfDDTjReZYX2aZgFtYTWAs2wwuqz8AhjBhCk3S	12110	17227	17227	1619040060000
24624	3NLA2mgYMX2kFkV2yzXXEQJKvpUkyfFtczB8nvwG6XH4W2b5gLZS	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jxTnarbc4ik4VikTjn1uZJs5wKySaA9mNgcsj1rDVzhsKXmGfD9	12236	17227	17227	1619040060000
24637	3NKGWFbQKKGZMao9e7Vg5m4Kk4bz6VnyCcLkmpVyvQj71R7ymeHv	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000
24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1403	824	466	12463	16523	jxM3ZS1E5CxfsnqVTmWniVSeoDTto3CVsmw93wtQRgRgLYiKtHu	12242	17236	17236	1619041680000
24644	3NLDExJndjNfDFkB5hvucHE8PT3vBK8fRsZNZpoaY3rvgbJ9pXkp	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1403	812	466	12463	16526	jwQzAopXntCFSrwvHVvb7v3m2M3LTAPo1Dr1eU5aHGpvHXQpoPA	12243	17237	17237	1619041860000
24649	3NKixajDVqqFYWCvipC7W7RLNjMrqeTsQjaZ3fDeFun2i9ytP7nv	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1406	1393	466	12463	16530	jxFYhrYPwCR9CvDosPDqQzRBGmS6FwBZsECcxywEPuHUUpwmv3K	12244	17238	17238	1619042040000
24651	3NLRBHARoDbtk6zFnx79a6aXNBSPRQ45Mu4NDCcYS3nQCjid1psV	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1607	1348	466	12463	16532	jxRWsPEHhab6AYJZkhZAx8jgC5u2cAAunAFp8BJa3LWksbPeFkx	12245	17239	17239	1619042220000
24658	3NK9KSTR6WFho3nCHKHZ6xbZJsPnw4UPt4VzCx8v4X4wWa9vTSdj	24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	1599	1287	466	12463	16538	jx7nSCsdsFAhkY5cemes16AQ4F4nquwBU2be2hVyC8Rbea9ahrE	12248	17243	17243	1619042940000
24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	24658	3NK9KSTR6WFho3nCHKHZ6xbZJsPnw4UPt4VzCx8v4X4wWa9vTSdj	1507	1280	466	12463	16540	jwuGxQNfL3DeHpUqfCkjqfHHYJgdcAAoZ7g6KPuFfZwus212KQq	12249	17244	17244	1619043120000
24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1493	614	466	12463	16543	jxUwhmTqBzMpxtD7aAHzgCgYtGNNXbXrDPcVAdm3A1fpYyeECYv	12250	17245	17245	1619043300000
24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1622	1356	466	12463	16545	jx3EkqwzYk2sXp4PqFy2o3z8ZBB2HvCBFAV1wAhEux8gDJCTZqR	12251	17246	17246	1619043480000
24668	3NKec2C88b3KaYcNsnztgMTj4tEch7hmegzWZN3pZSN47fxU38Ce	24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	171	1374	466	12463	16547	jwPnp6QPTwf7t3WDAiA5U9hKbHW3Wzv3VHTQLrZAuzrBSUCamRw	12252	17247	17247	1619043660000
24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1642	1367	466	12463	16549	jwsd9g8ajzUBDm6GH5ZeXoxTPQRXLZEeKLSrHTTDLgAVevWLLDh	12253	17248	17248	1619043840000
24673	3NLcqX4YEamMadFPNBo1jSBwvDWKqrbnKuoAW3AnR6Y4sixeZyQj	24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	1668	1124	466	12463	16552	jwo7ASuPdHCKyeVMvBm5b4UUHEhUpBoZVf8hQACxZ7zd9eDdRpw	12254	17251	17251	1619044380000
24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	24673	3NLcqX4YEamMadFPNBo1jSBwvDWKqrbnKuoAW3AnR6Y4sixeZyQj	484	1073	466	12463	16554	jwKxFSs3AEE2P6HuhVAA7o1aFeNPuiFy86raTn8fyrC2y5QFBLC	12255	17252	17252	1619044560000
24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	24679	3NK5k3oNkxeUhV8PR59oWmAYsM5D3mq6NAkA6YqAbzUmzk2obNCU	1407	1395	466	12463	16559	jxx4EF3Ug9vpCnbKNAoa5Dzrod4cXSCh1kT2LPrgtCf7Pf6Mehv	12259	17256	17256	1619045280000
24681	3NLYBbPaLCsD4n6qdPZFYKjZ81MaTT4gYuydLGiQBwPTA3pUMPjQ	24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	1407	1395	466	12463	16560	jwY6wzc1mXqq5Zj5kqGf84u1V22E9yst5VR9XA8bb7AswamUPSs	12260	17259	17259	1619045820000
24685	3NK9ika2EN2gX9WS8MQzf9CCnotR4rGSJDDy5gg4qgZ3FY87VXXy	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	1490	1028	467	12463	16564	jxphSxdSjUxgyeymrsJsKd3948dnsDitnwN3zUVc9zhanD3M6tm	12262	17263	17263	1619046540000
24689	3NLub4TsCqhMGPkJfbFWPBmQRhkqUCk5kCRc7hP5GEyu7YUFYwZD	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1439	1153	467	12463	16568	jwkLCxuczByaKdThYLQ3gEwpdszLR1f1tJ8kyeLFRA4wdeDFKfM	12263	17264	17264	1619046720000
24692	3NLW7szmuijUpUHJqZWLGrSCwwroY3yWCsRjSvJjvgQjojFtYCD4	24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	1406	1393	467	12463	16571	jwvbYFoQn8W7HByGrBWcnh2bVQtSH1SAwXVEPssU6cn9GxTG1ZX	12265	17267	17267	1619047260000
24694	3NKiF8NUjghsZk6DcgsxudJ81Ue8jzkLbGfFhaHF7avtrnqJE3XT	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1403	824	467	12463	16573	jxSg8wt8xMLThuVH4qZnzNNyFeUU1cvza5qSwBtKLDnfuPVa5z9	12266	17268	17268	1619047440000
24697	3NLuSNkHKKVnpVZSjUAbLLsmcm62UBNh6GTMdnrenrBRcKJG4mM3	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1627	1385	467	12463	16576	jwEhqTJxXxHbEUZhTtVN3sM48Zo58mLupXPiK5uzETF7PVTZ4pc	12266	17268	17268	1619047440000
24704	3NLFnb7CLBVkVpztpDojphxL9RPEYCorXhhZZWGguaebKr4iQ9YL	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1529	1316	467	12463	16582	jxsrs5XHvGvXF3DyWeCfWqVkbEHkKakxvyj1Gw25LT1HtEoMCya	12269	17273	17273	1619048340000
24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1444	1381	467	12463	16585	jxoq23FDapbPWPAYMmVUzxVcdAp6KdRfmarUxdtk6RpwN7fcaDc	12272	17276	17276	1619048880000
24713	3NLF7L6W1KqjJ8Y5z1iYBVDRgg7HTuhurkXTizyuzEx3iHvnfG76	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	411	411	468	12463	16587	jwLvhUovmSt1B5wQYRkBpuhWcKz6cgXgfnK46mgX8sqh9Q7iDMW	12273	17277	17277	1619049060000
24716	3NL5hN2WQgtSMxSaYvTtDVijaH2XSb5WPDboVEqxcbsiEwX1c3SV	24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	632	1382	468	12463	16591	jxKnKHyxVM2btWxbk3Xxtm27HUu6WbjuUgnAMix1KnSzWh2mLfa	12275	17279	17279	1619049420000
24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	24717	3NLRoQDMdWdN7pXGtZ9suTGYFjaR3xvDn4JrB7NPtK3KW66oYe8c	1581	778	468	12463	16593	jweb8CkGaVmVrzv9Vx7swnrXZC3KxSxbxffQcf5PjmZN5uBhk1e	12276	17281	17281	1619049780000
24721	3NLafE9s364Tbi7AG6umJFPUd3geimSK2PFji3LgA6PcMLvLcGNx	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1536	1187	468	12463	16596	jwUyYyatVwSweBqxZxE7MWQQoNCe4xGx9WueMFfC7BQGUKVrC6W	12277	17282	17282	1619049960000
24723	3NLRh9Xmgz6t1sc4b86ywZvNaK8kworyhvoDtg1cdSrNsHThtBQT	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1483	322	468	12463	16598	jwaZ5Q5EbQZUyYawZctFwXr5L9SjRLYTyLZfXBSWKjgYszMEPGm	12278	17286	17286	1619050680000
24728	3NKLPCSHu7WZz2XCVk467zJ2duG14gbdmLHiCeLGBrKnjPDZ7CTt	24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	1483	910	468	12463	16603	jwYTJa4cdzJMcEtgSv2Fp63WcGc3GAVzh3HDF1C5Kq2RE2Q3GAN	12281	17290	17290	1619051400000
24661	3NKBgZCxiG7nmpru9Rpv7HBqA6owzLXFiAZ1F6V9NsPcGDdy8CYU	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1406	1393	466	12463	16541	jwGVH8ZEbFWagdSgSJ4vGJkLMowuMeDhZHG13Ya9v5ac4FKS5kb	12250	17245	17245	1619043300000
24664	3NLPmcZTEDjhoBb2SrqdkwAv9vPzSPoF1KRDP6T56APuHndfcvD3	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1474	1203	466	12463	16542	jx7W14jm2Q8JSdavS7NAoaqdAQnBYfQFw2qD35TG51SVRZCBxLP	12250	17245	17245	1619043300000
24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	1407	1395	466	12463	16548	jwjGxhHSeHhKXcQEp7rgmQGWtxmosWAKB3vBzVtNfdERo5ovvrH	12252	17247	17247	1619043660000
24671	3NKNU7uUyEnzV2cPYeT8Aso1LUtxEoGT7QtjzqFxSwGsyf7b4f6W	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1406	1393	466	12463	16550	jxo9duGcgKkofEcqT6JjtatC8Mwj66CykghNMKv3uoFn2SP67KX	12253	17248	17248	1619043840000
24674	3NKfG5NwZDy6xsZVnqHjLY7G995Er4ppfFM8iFA1NU3xWWTnmUCU	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	1668	1124	453	12463	16553	jwgbjnijC5vURt3svdp2bP2SRCYvFih77nfw74ncoVdWkDxR9Ke	11973	17251	17251	1619044468545
24676	3NKgKarjrGxmusY98kNTPxU9Cj41TDDjfMXmNzTjuo7AB6Q1qTS3	24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	1656	977	466	12463	16555	jxw4TuNYTUqxegVGvubLGogEFfrCpLLEnYAHETveLMe8cJydvgh	12256	17253	17253	1619044740000
24678	3NKy7mzGc8wfq2VNQwKjYQxQN1jGBAKpF9g8SEMjaX9eQUSmVEDt	24677	3NLJaabuGRM91EuAgni6h3ngecvtx6mQdZbgP4soishtPZQhsH7v	152	1204	466	12463	16557	jxd9np5bfavbaMq1dvEBhWhK3yMu1SVtesASuy5CaCkog68DrmZ	12257	17254	17254	1619044920000
24682	3NLh9mPk8jtmZ3kYKtMsytcQcEGKfUsFkZRtokSmkJZEZYtXxcfq	24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	1631	794	466	12463	16561	jwuwhQ9ymTatjVnqSybXJDby79LfLAFYwTCWr2oAfcx1q523Vic	12260	17259	17259	1619045820000
24687	3NLgdL76foGpvX7cE4MVGqeU9ML3Qeo6LvMyd8xRLJiqZaReYKpF	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1602	1243	467	12463	16566	jwGLQZxY7wSs93fp93vi871AXBT8rqsLpKS1SV2zq8mtCWjTFtP	12263	17264	17264	1619046720000
24690	3NKugigAKWj4CPeWxrPqDQrC6h6dZyytNkaRzL3M11sS9awByKwT	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1652	1315	467	12463	16569	jy1mgiVskzEcSFH3sYRtoyPNDgkmeTnY7oQp1wUwdEkVw3wN5yS	12263	17264	17264	1619046720000
24698	3NL9SmGgUMY3CHKa1h7ku2oeGfninJANqWHGrJLeN3pjPdQBWRTC	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1529	1316	467	12463	16577	jwxeWww73VLnkzhjrobu2UURppW2hDuafx7JQuEVUL2toYxmQ6p	12266	17268	17268	1619047440000
24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	24700	3NLvi8C3djharFyVgK6SXGPbLCP7d2yGphn87hSCRDKY38qWmMnJ	1406	1393	467	12463	16579	jxSznf4bx7behvoykmvoUPrYgDWnmjYmwKX5sJNiZoks56QDin4	12268	17270	17270	1619047800000
24702	3NKdtDuMRGrF5xjrVwq9eXseKu2vdHcjTSv3waVRtDV1vrwDGREB	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1457	1391	467	12463	16580	jxHwoYyipzHcHs45HysYzs2sWjq58GJUo8brNpHTYhFn6oxavA7	12269	17273	17273	1619048340000
24705	3NKq3mYu4GKYy1HebmGEXZ7k72GFo6GRK5QWG9jC8pZRh15e1r8W	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1529	1316	467	12463	16582	jxThxUEPo7rcdoxe5UP3RpJLoczstU2Pb9yGeKBJNZ9B2fMKFAZ	12269	17273	17273	1619048340000
24706	3NLeSAtkbCuuFegBnctwvsWxJ813zyZxNjiUe7mVu4pQNBGsZSc7	24703	3NLVgA8FvL5bBZ88Tqhe2gb47WiZ49x4ouw718qSaE62Go3szVde	1419	814	467	12463	16583	jxi3SPga3cb9WuqCcwv56VdgCqBZnGJHvWC9D3bX6T8E7UhJgjg	12270	17274	17274	1619048520000
24709	3NKRYFZbH5HkYNZW6aeuCGJVtjiMKanTxX59UupdgZjN4bZYayKU	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1444	1381	467	12463	16585	jy1DSWsMmsGgHzo6DjzGmN1aCbpj2VJCeWzt951gwyYVV5NCmqd	12272	17276	17276	1619048880000
24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	411	411	468	12463	16587	jwLvhUovmSt1B5wQYRkBpuhWcKz6cgXgfnK46mgX8sqh9Q7iDMW	12273	17277	17277	1619049060000
24714	3NLSfF8G95dn6hMvYok8uwNnQBvNTf3weNkBxp22xzTEbTjd5PNf	24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	1476	1371	468	12463	16589	jxWkLRJ8r5c3aimNmzLgVG44uGGo2Jk9HMYNEXvRZMoxKNZQy4o	12274	17278	17278	1619049240000
24724	3NK7LJtabirtH87dWTKHbQ1bKHaJPgTLpjKTEZhNAFtZYmT7wqXH	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1594	1326	468	12463	16599	jwBPPmmU1V2QQhje9jsphGVkJq8HGbUhtrfuNqpFj1EqmU4Be4x	12278	17286	17286	1619050680000
24726	3NLtadeJvBeWczmkH9U51vpxYydpKeU9VG9gwM9A9jRCU3USRycB	24723	3NLRh9Xmgz6t1sc4b86ywZvNaK8kworyhvoDtg1cdSrNsHThtBQT	1406	1393	468	12463	16601	jwyuncrBB6keYefsvkCcicLBYzLB9Y2pBNXjnTp5JHsFBUb3qro	12279	17288	17288	1619051040000
24731	3NKcceWGWQGEAafSCmEsoXGSp5uohtBQsEArvAE153oqkuRqumwr	24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	1461	1271	463	12463	16606	jxmJa8Vpop6Ep8Qj9HFg6Sy7fmyAAZg7MFQtAtxLHpcF4Q5GVeE	12184	17291	17291	1619051632435
24741	3NL776sJLLcSJTmw5ETgAVaeCqAV9xecW6vTUyo7mMqxnDrZHDFi	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1419	814	469	12463	16615	jxewNkAEVi6q2WvXLqNmrLjcW2VWuctK7fN1CazDNU8DtBX4F1m	12286	17296	17296	1619052480000
24743	3NLaP3r3bQYSKyDvgtyvqoJYsGEneKkPQkj3jXCv9dRAa83UeAY9	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	1460	681	469	12463	16617	jwn1n3uL1PfPbLpkR9cC4HJcaDq8mXhamjVTvi9cmE7hXPBV523	12287	17297	17297	1619052660000
24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	24746	3NKjL2UX4LbPQj46o88T86ki1aJXWBpZPcqyhnMEo2uMHE6u8BaA	1407	1395	469	12463	16622	jwt9TRzpnrYCiTGFykyHW7gAXuDUiDUq4fTPv3MG4LhZD3JS4Qa	12289	17300	17300	1619053200000
24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	24750	3NL39Bfe4upDPcBHhSWu1YRFYR2FkkBa5TRetzeWz6jMM4rN6Uec	1403	824	469	12463	16625	jwcPAaneHjxixJhAdbxNyMdFzPtLNr61QBe9YNmcmDYST8XuktX	12291	17304	17304	1619053920000
24757	3NKktvY2K7Nik78xmPC75bwS25vTPJWJ6fxh4QkLoMKJR8ppSfyd	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	606	1295	469	12463	16629	jxKBqbRG23LecLiLKqnUjv72Ym6otaEu2ZvVBntt2xamtTsDoKi	12293	17306	17306	1619054280000
24760	3NLmiVPPxWJAdfpsdSZCuMUjGx7cseHHN91vqtvcSRuZoAaJr2st	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1553	776	469	12463	16633	jxrgTwZsmBs8TwyeSHan9REg5JQB93DqLVpnKZwZ8TsypsHEapk	12294	17308	17308	1619054640000
24766	3NLdd6gah15oUVXjgB9uHmE4FBHBAhJHxgkE4XmDgqpypc4oFv6K	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1588	1146	470	12463	16639	jwSSzLS2mJiA9FEBr11ZQGYcdHzbfqzxKfoa6qWAqLEnWW8Emz5	12297	17313	17313	1619055540000
24771	3NLjvUmZ9sfWN9BCpqZK2rSvFAgWhfJgPtjgpzbXQBD4eJfTGbyZ	24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	1673	1122	470	12463	16643	jw78zfgu4Q6K4uarEbHKWe2JJUK7aoX7fYiKs8X8zq58saeVENm	12299	17315	17315	1619055900000
24773	3NLPEC1LFup8AurdvMvvdu6xudfeFDNmY1YvrmhFAiMWoEGefoi8	24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	1631	794	470	12463	16645	jxfcT8Xji1NeWcrTwBEDiKQdmnAZUEJUWpdfkQ1ah7aDFX54fEb	12300	17316	17316	1619056080000
24776	3NL38rc2MyH7CZ8gEs5h642zrGDcsYSHdbenFqF2S1cy3VWph2Ni	24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	1406	1393	470	12463	16648	jwC84HrutktYTFDKFCzWXT9tvDp98CBhWmTZeKUpjMrG1d8tbvA	12302	17318	17318	1619056440000
24779	3NLoHjbGGm99jK4B3KsqDiMNFRvMzn285sNCxQaY7DUp7a9c4xwG	24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	1406	1393	470	12463	16651	jwSEZqUsqbfdGhjJSWpncAtqijV9MNPfSgWJSRNWZpBxfv6MPpq	12303	17320	17320	1619056800000
24662	3NLGcF3SjPMnMybtum331TBb8g94shebUAQZvGRueHdzsFPpH1c6	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1474	1203	466	12463	16542	jwd5PUnyFUPJJNStjoM9gjNRVYCgJVW8CrQkRRi89U2EUDiFjTH	12250	17245	17245	1619043300000
24667	3NKgfcZEr8zuijrNqHh3wr8KEQBr72o98c6CCmSJpDEPFs9qtvUU	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1553	776	466	12463	16546	jwBd26tokJ81BfdK4ArrHUUrrupvyjqGZEgDL31LchWGA1ToiaS	12251	17246	17246	1619043480000
24672	3NKLa7N3SH1wyUUoGUUZFxMgXH8hdMfPeLHihNH3L9GirzLQQspJ	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1581	778	466	12463	16551	jwvSUPBBL9kuK2814sCKYoS9iSjY5qY3FVuNRNw5AXfLNX56dJh	12253	17248	17248	1619043840000
24677	3NLJaabuGRM91EuAgni6h3ngecvtx6mQdZbgP4soishtPZQhsH7v	24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	1471	1386	466	12463	16556	jxaJhpWtZLVvfJvFwerLevfxmtzxbBHG81VPiHZTUUxbFvooJk6	12256	17253	17253	1619044740000
24679	3NK5k3oNkxeUhV8PR59oWmAYsM5D3mq6NAkA6YqAbzUmzk2obNCU	24678	3NKy7mzGc8wfq2VNQwKjYQxQN1jGBAKpF9g8SEMjaX9eQUSmVEDt	1407	1395	466	12463	16558	jwmhiJWjipoFSqJVRwRNA6hqGWnhMQbHRbvrvybmc8hH5oNzDBc	12258	17255	17255	1619045100000
24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	1637	816	467	12463	16565	jwNH6h5w3wGxjcVwPQhzVAvHxyMbn92aPZJ1GGogbV3Bd3K2Suq	12262	17263	17263	1619046540000
24688	3NLZeaXtwaVK6syZWxKka8pNHVCy9wkyVGLGxoXrSsXevrxy63of	24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	1652	1315	466	12463	16567	jxYyMCs5hoP1L9U5BLJ9tN14dBEqquqBE3jcfVewFEtr3iwBfyK	12254	17264	17264	1619046720000
24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	1407	1395	467	12463	16572	jwr6XNMNfgg9LSVdEGuNR48w7JY8PdzKMozxHqkQepwFq2owkER	12265	17267	17267	1619047260000
24695	3NKffdmie4dYkGcQHPHb8iNmxi1MhQ7JYWnFmaxMSRP15fPFbnth	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1648	1158	467	12463	16574	jxXNtrHg7bEbUCJprUWQGym3tBELg8ki5HSU1ou5wXneRXK8o3C	12266	17268	17268	1619047440000
24699	3NKbzhurwGFi88ke8oh57vyscyNUSzdB5AmS9v4xCruL6xZdZEZi	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1529	1316	467	12463	16577	jx4fiZuKpoMuQCWUR4bTJn5sMS2xKwkZ5KWbf9juSRuaFqUqkXJ	12266	17268	17268	1619047440000
24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	24706	3NLeSAtkbCuuFegBnctwvsWxJ813zyZxNjiUe7mVu4pQNBGsZSc7	1542	1304	467	12463	16584	jwpw519pkC5bHm2dC9RyyAdyDzv5c9ftRd9WBuYdaBMHbTHPRHt	12271	17275	17275	1619048700000
24712	3NKD2aXPntqLh21NDX2kkWjoUJ64uKMrKmetxpS7DXhbYz2sSVok	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	1439	488	468	12463	16588	jxn8yGoFXoqKTjo6gKJGzecibD7gV3DKQ74XQw1HnKnR2HJivhw	12273	17277	17277	1619049060000
24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	1407	1395	468	12463	16590	jwfz38AAsCRooSrq5vLdi266UNUHmjDYm4xBG5MeF8afE5DpA3L	12274	17278	17278	1619049240000
24717	3NLRoQDMdWdN7pXGtZ9suTGYFjaR3xvDn4JrB7NPtK3KW66oYe8c	24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	1637	816	468	12463	16592	jw7ukpF1gt6jEUmcPMAbmgVWP2R6PLE4Ka8jCgyNBXxnUjqrf8y	12275	17279	17279	1619049420000
24719	3NK5vV116ti3fnmQhRqNX9us9yNgxYXDKGGMzA9jNXsq5JSuV69F	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1403	824	468	12463	16594	jx4FiSZMMHEDyZsokA49zsozaRdCEpJjrsVYamZiEfhCuGuP6Zt	12277	17282	17282	1619049960000
24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1553	776	468	12463	16597	jxZ51xwg3ZBmmMKAUPLz1yckPiCU6Zpoof1L5CirEtfcUQqZ8wn	12277	17285	17285	1619050500000
24725	3NKRnbBagjgyiDmyGLfmiGXEwE7VT4TQtP4JEseuH4pFnyUWjvMP	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1445	1044	468	12463	16600	jxKyTw51roJCiCzMcbHfaw32A3jttpYTp4jn7vhUQsKT1J7ghUt	12278	17286	17286	1619050680000
24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	24726	3NLtadeJvBeWczmkH9U51vpxYydpKeU9VG9gwM9A9jRCU3USRycB	1406	1393	468	12463	16602	jwMKne2DfnpHnt5v6yYujneCRCY5x4Eo8bv6NWmCsh4FcTGtpPB	12280	17289	17289	1619051220000
24729	3NKZv7nRZActzS1ZTXvX5dPvRR59MhZ4vn68taJ35p5AZxf1y2Ac	24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	1522	1076	468	12463	16604	jweMMiZ3j8c8XbZcJ4938SuvrqWyYNfrrBSKxgPN7Rjr1TvyUQ6	12281	17290	17290	1619051400000
24734	3NLFgGC9oHWHsGtFVh2uSfGVCB7BVY6D5ZKuUV41K1dfGsWVofvN	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1672	1039	468	12463	16609	jxA5rwiWyAaX7k7t1TesgwVi4TLQZthyuq5GoTAjd3f5S5KEA6u	12283	17292	17292	1619051760000
24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1672	1039	468	12463	16609	jwHoWo4HUnPavw5arcGmwz7HwMs5ZziSLWF8cEvzRZ8d5Vs4VJP	12283	17292	17292	1619051760000
24746	3NKjL2UX4LbPQj46o88T86ki1aJXWBpZPcqyhnMEo2uMHE6u8BaA	24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	1588	1392	469	12463	16620	jxLPNHHXmqY4KkxQ8r2R6ghat4sz1pCv1GPn8FVtkvAFSNs8cUM	12288	17298	17298	1619052840000
24749	3NLr2sH2TksMNdXoKJXBxNdTYn5esWFiuJ8WhHqCEce1fUDezcuM	24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	1671	1239	469	12463	16623	jx4Lx4o82qLCFQrTjQWtdwMJctiHbT3fBP9tBGphoP472gbhtww	12290	17301	17301	1619053380000
24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	1544	347	469	12463	16626	jxzxmrxnJH4YgYwbihDLQo2yRt8d6FDoKi7UamFjJkKTNTVZgCX	12292	17305	17305	1619054100000
24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	1455	1332	469	12463	16628	jwmt8HBx12R6cHRSwETaV2nQWydQbke3GYFjJfLPwFwErGt9bGn	12293	17306	17306	1619054280000
24758	3NKWToQ9TxAQJ9wvY3UufPK65YY5ANZRoUZK5YQpCPSC4W9aYqnn	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	1631	794	469	12463	16631	jxELqS3cFCBkZ215fp5Mz4X2qHmohLedapyEqHkxhQc8CQHWzUC	12293	17306	17306	1619054280000
24761	3NKiLCDcJfn6kwx4t2fEnE3641mTYFH6sF4t73bJyutZzXZfzhja	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1673	1368	469	12463	16634	jy1gFQQBZZHN1ydyRQWdPVvukgywnwiw7HewF4JZY1djHCejCr4	12294	17308	17308	1619054640000
24764	3NLTVx69FBL9xYXa9SRv2xGn2pju5BarJkec1hTNsgTDMTM7vCLE	24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	1406	1393	469	12463	16637	jxTNWkmz8HjNAwVxtRzekAXqMJaispYTkommcq6wGh8CPG8uY7h	12296	17312	17312	1619055360000
24767	3NLW7EAoyYfgbSmwa1TR8PD4MeHiTXrj75LpHc8CkoBG8hPha9sw	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1483	266	470	12463	16640	jxTbGiiUwKcULwoA8kcgVgoD4eSiSPa4wFQUCzduQj86MQ5FLqT	12297	17313	17313	1619055540000
24774	3NKFosBnPQ1QyzbgKCha933K6GeaDtLEML3P3MWTSkDYCWmHnPVE	24772	3NKspXip2grP4QTNf2p6fze4htMgPCPA4ie6LWMY28p8i471vuKH	1633	1390	470	12463	16646	jw7R9js8qNp7yRFfbrH73ygLu6YZcnoZydrPzAzhBhrhyJYXTJX	12301	17317	17317	1619056260000
24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	1426	1238	470	12463	16662	jx8aHJ3Arziyr4D4PBrYsY9zwBpAUm1N6A6DQuxF2Y1LubZ5x5c	12309	17331	17331	1619058780000
24792	3NKN4Vb44Czzq4w4Z4DV19p7gMPebQaaCLWM2NjcBw16ZnRLpBvA	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1623	830	470	12463	16664	jwaz1ZVTY3GedEEAzPY4wh91XheX8ySGeXCbfZaGsmi31GseyAm	12310	17334	17334	1619059320000
24696	3NLisQ14rvtPJqea9YtXCRTc7XV2EJQTLusB7BZmQygFdjswxXnC	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1407	1395	467	12463	16575	jwnm17bSFvVCExZn2CKzC5K2TNWetZjRivaG4AsDFL8UtBf9ayZ	12266	17268	17268	1619047440000
24700	3NLvi8C3djharFyVgK6SXGPbLCP7d2yGphn87hSCRDKY38qWmMnJ	24697	3NLuSNkHKKVnpVZSjUAbLLsmcm62UBNh6GTMdnrenrBRcKJG4mM3	1581	778	467	12463	16578	jwaX9QEbeDVwGGBRJva6e85f774hyhJRUzr8i3o8kcYnF4W5E6u	12267	17269	17269	1619047620000
24703	3NLVgA8FvL5bBZ88Tqhe2gb47WiZ49x4ouw718qSaE62Go3szVde	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1406	1393	467	12463	16581	jwGyCsTRP3er9xDGGCyYGcCeFCFf6SV2oXd56yiiNmKrz8vqJbD	12269	17273	17273	1619048340000
24710	3NKUhSgpepP2v7zi4RF9WWkZ8rEoELBxo7QCS76CDEct8EAoPY6h	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1407	1395	467	12463	16586	jx72Rzvd6Y4rPBM7qoySCGSZfjE5pAVzUTkdn7MKbEFA5THuKD3	12272	17276	17276	1619048880000
24720	3NLe27HaoQKS9nEqkxJnh8esZfM2bUGpiLohaj17hvJx6nbVbrRW	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1405	887	468	12463	16595	jx1gscrV5YCR7WA4bD2oq3jEpdEDd9KcwBCWLqSALKEPbftokUz	12277	17282	17282	1619049960000
24730	3NLGBVZJC6k52uA68cxcL4kivjJ4mWQYtkAXTA7B9UCNoVH2uTLZ	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1461	1271	462	12463	16605	jwY3S2dZ5qDkEXqmmG4oh81PasPryeAi9kegEsSi6eX42couGEP	12168	17291	17291	1619051580000
24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	24729	3NKZv7nRZActzS1ZTXvX5dPvRR59MhZ4vn68taJ35p5AZxf1y2Ac	1581	778	468	12463	16607	jxjZfJZVfgEFVM4wEU7pjqyD6uS38EAEE5dYWBNi8rzXHQTRkSZ	12282	17291	17291	1619051580000
24735	3NKKBzbBrMTKS51UU8rR7SaKaNvXFJyZLgkLJgg1dUuymmgAWLcd	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1407	1395	468	12463	16610	jx7La4EESdVhvREGbxqVg4yBjxke6kPnvyucgzas6zWadEdUjes	12283	17292	17292	1619051760000
24737	3NLE1qjxLdppupscmvGodrEGUtRBXvRwXrjV8jPXCMnv8WpwZfUR	24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	152	1330	469	12463	16611	jxpXGR4FLPfFRe5gPZc1QMBHEgzh6qS8wZsUJFiS2KJPLZEZxXS	12284	17293	17293	1619051940000
24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	24738	3NKKwScjLjHKquaHiA4cxhvsExgBzbdpH8QEb9B3pP7qvrSDxgLa	1406	1393	469	12463	16613	jxU2Ka76wyU6JGEuwVfPuJq4tE4WEqVhiHQKdq94EzN6WhXakXw	12285	17294	17294	1619052120000
24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	1471	1386	469	12463	16618	jxgnqFsqxuhcvmSvsaNuNu5ZeisQwGdi1qy8EdDGojQQUqZLHuh	12287	17297	17297	1619052660000
24747	3NL2GHaiDzh4vpvJg5cUnT5cwP5zowrFfjFUJbKNpgUfQjD79PRm	24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	1564	1338	469	12463	16621	jwHJmzdraYc9yRYkQrUNgbmwqsNDvcmbrEJ1vsEk8kE7B6YRBMs	12288	17298	17298	1619052840000
24753	3NKKooC8KpfrjD4TiufRrAarn6AT33vAc3FgqYuzXmtXyQZBB2gH	24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	1542	1058	469	12463	16627	jxTDxrNeHUD7eaHg8KXwvzzE3MPUnfgsFJPrtgamTay67uDnLra	12292	17305	17305	1619054100000
24755	3NKCHPoGj1Cpr9t6J1E9VRWqezb2zZbbkqEHABc5BHz89AiCNyxB	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	606	1295	469	12463	16629	jwhfKL2J4CJuuLsHNu5zuvdr2gRndmb5FCwhYfLUNEbVDa7S9iH	12293	17306	17306	1619054280000
24759	3NLZX2Q5Ne5LUSuD9hQ9hrCCVZUfv7Xbd3eo3jL1pXfPBFzLZ819	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1547	1378	469	12463	16632	jxVn32FFtN9AWyT8rBhp89BHDuVyHBGJPqrM6RNTQq2bRzowpuk	12294	17308	17308	1619054640000
24762	3NK7hfLG7bKdcjb5yWN2fpybMdJGy9foaJbTueSro5wtP8D6tv8C	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1407	1395	469	12463	16635	jxDbRWpEJWcEsTYWfJDmaYUcB7C5RLsMck6ANr8FoxN8Myr2JgM	12294	17308	17308	1619054640000
24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	1627	1139	469	12463	16638	jx8yX4TbqvNSJcYkWcFfC8po3ATk4DCuwtUT4GWAmC6goKWANUA	12296	17312	17312	1619055360000
24768	3NKMK9FV134NiSnyfvZa1HoHj9VZbN99kpA8ZhDmcjckWgXwQMKJ	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1483	266	469	12463	16640	jxdxo4WUVPRe4GXyJ4NJYPMBSicCSjYXQhnrvBHgoCEcVeddzdi	12297	17313	17313	1619055540000
24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	24766	3NLdd6gah15oUVXjgB9uHmE4FBHBAhJHxgkE4XmDgqpypc4oFv6K	1467	1130	470	12463	16641	jwXLnPXoZBjA2L5gGnZ9srKDpxEj71T713hkESQcyvMpDfzvxSF	12298	17314	17314	1619055720000
24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	24773	3NLPEC1LFup8AurdvMvvdu6xudfeFDNmY1YvrmhFAiMWoEGefoi8	1555	1101	470	12463	16647	jxamy3gkTnF4SJgu3wz4f1YjAMK7YsnU1svcvFBp5UQTgEgJMqe	12301	17317	17317	1619056260000
24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	1501	1234	470	12463	16649	jxnkVvK4GXf7Ra9Tm3mVSKkpR7jcm95xuLPzasgBb9yPGkZ5ktx	12302	17318	17318	1619056440000
24780	3NKSdYYU4gMNgWceAYgZ845TiT4KFFxfbn55rEswgZYUJtjtMqwV	24779	3NLoHjbGGm99jK4B3KsqDiMNFRvMzn285sNCxQaY7DUp7a9c4xwG	1458	1323	470	12463	16652	jxXdgrvUW33XEFNJ9B1tbtyrtUSbwkG6JAHuHXHWQnMCvxmNUFG	12304	17321	17321	1619056980000
24785	3NKJUVqibK8oBV7HHXmUz16zEbzFwk5BLoaFqJZaJLyFBTuVTjCR	24784	3NKnwYtgP2BHRk8XwviE2j8kMQ2cGBNS6Ykr4t47FHmzKbwhJvDQ	632	1136	470	12463	16657	jxevzgU1yUomijdg3DnuHwqsPnsoxSbGYQV2P4Mcj47iJ9TmFCg	12307	17328	17328	1619058240000
24788	3NLr16yAf4pyo6d9DAxwqwthy5pJ4d2j1h1DfFHTxpcHJpQU7BQM	24591	3NLwey7uhKSQBBrfH4kLihktrSUrMaakbeeV6qxkXc5d9raXPC8h	1426	1238	461	12463	16660	jwzbmvtvSzh6PvfGj65DqH61qaQB1Rip93xjFimBB4fVhGXF1jc	12154	17331	17331	1619058780000
24793	3NKuXrsyqvCWvXiK1fFZ78g6R1fFtpzfgCnASZxBCJH6RNNfxurT	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1455	1332	470	12463	16665	jxiRvLv1TE1d5N2yDqhEqXJYDuwPpcWFxFMQCogAEC9WXLGqC8C	12310	17334	17334	1619059320000
24795	3NK6jN1ASb7vi2ReFJxQP854UMHnPC9n5yiyLKrgT4h2H6qJonPz	24794	3NLMq2G3PvTMU8C4eDeGRVTEB4vkA45quKzeUFFLbmt5fUGxzyQj	1617	922	470	12463	16667	jwcJyXpktTqK6ZYbBCp7goPmSemY4bi4yrWjMTjYJXECCN2GUty	12311	17336	17336	1619059680000
24800	3NKUtK2UJxuPMmprYL6uDvYPjzQqGg3JiWpL25FCRTU8og8FKiWx	24799	3NLQcuwYwn71ja3NZweBoKuBn36wescQHvoQ1j8JKk24XzaUPTQM	1589	1160	471	12463	16672	jxd7XqzL6A9P88oe2KmqG4hxxbdNw2sbvZcEsG6iEdjmCgMgWer	12315	17340	17340	1619060400000
24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	1668	1370	471	12463	16675	jx7DvAzEsritux9XSzY7Y8AyPXZ5sUtPiFVhJRRUf9Pv5nBeRJW	12318	17343	17343	1619060940000
24805	3NKUXF9i5r41Zi9KZtB5GfQVrb7U3AJmJV2SPrcvgxS5czacpJYN	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1593	1220	471	12463	16677	jxZcskCH8dM7TWemnZo4GtuENte6KfcN5tEEFXtKdkc1GQNBZdZ	12319	17344	17344	1619061120000
24807	3NKLapUjZC8hsdKmawM3avFCmmG6j9NGnwp9pUjSqW1cQoZwFv5F	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1407	1395	471	12463	16679	jxNKsUHkqfyAS4t9YtbMDbkHk8HhoerAJfitejVqcSs1T1vj8sa	12319	17344	17344	1619061120000
24810	3NLGHoZU7DGb2XiJ1NWZkvwhvgXX2pFJfkfs4vyrdYsERJ8rfrPy	24682	3NLh9mPk8jtmZ3kYKtMsytcQcEGKfUsFkZRtokSmkJZEZYtXxcfq	1649	1257	466	12463	16682	jxURQ4J6u6THbzNuNUBcS7HCqz8xpbbNGKbF7m4gBoSGJn3rMKr	12261	17345	17345	1619061300000
24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	24818	3NK7TAtLtT2kQWHwEhBdG94bUbRcsi6YYbvUzRaKztwubSKNcXKe	149	1157	471	12463	16691	jxfZn4sxSppYWU2wm8adUR1Rgns3BZfnLNLX9Jwr79nuPhSidAo	12324	17349	17349	1619062020000
24733	3NLh646jwY37NNdFfo8Jh7C5RSqZARw6rdFLN84TFJUJKjykfw5V	24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	1461	1271	463	12463	16608	jxU8oPxcQbQJXTJdmRmGQx1jWf97NpgVrmJXS8EQbhBckqY8J7E	12199	17291	17291	1619051684511
24738	3NKKwScjLjHKquaHiA4cxhvsExgBzbdpH8QEb9B3pP7qvrSDxgLa	24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	1613	661	469	12463	16612	jxmk9gHaC7MWcpidd3FNm7dku8nmWHNdXaCmCjLv6PFyif3zous	12284	17293	17293	1619051940000
24740	3NKRQFFQTeMjyBFD653zihmq2hcBgPJiUooFaiyACPD3hXYAuU3i	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1601	1388	469	12463	16614	jwQsXsU4MTpkJL5N8ayqPkButKXyAVo34pGxWNkY4PkPAH6FzKp	12286	17296	17296	1619052480000
24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1555	1347	469	12463	16616	jwqx8Vzjsx33J3yuNGHEuXcLV25p794kUs2AGWFUtGxsnbCqUfg	12286	17296	17296	1619052480000
24745	3NLdxEoBcrJcdMY37Noccuu4TZT9VsnAefgsKPBHYrDXqPEXV4Y3	24740	3NKRQFFQTeMjyBFD653zihmq2hcBgPJiUooFaiyACPD3hXYAuU3i	1460	681	469	12463	16619	jxFSdR82SumV45jUFYmrZtLTTwHe9xefrHJpMhdS7Fw8BKSH1GY	12287	17297	17297	1619052660000
24750	3NL39Bfe4upDPcBHhSWu1YRFYR2FkkBa5TRetzeWz6jMM4rN6Uec	24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	1647	1176	469	12463	16624	jx2zJdqvWX34ttvBxK6UpeKNsBqvxLPv3BZujBBHf9o5a4btkja	12290	17301	17301	1619053380000
24756	3NKPWHRKGYCpALo77qTxhJv2ueSLbqRjKRDkKt8nymhF3gXJzV9F	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	311	941	469	12463	16630	jxNFkSX2UEWBq3z1bfiy9ntnAQ5GYjD64xYNEW7m44wQmw1LXMn	12293	17306	17306	1619054280000
24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	24762	3NK7hfLG7bKdcjb5yWN2fpybMdJGy9foaJbTueSro5wtP8D6tv8C	1599	1287	469	12463	16636	jwhXNmQ61qkXj5P4Ry5L87cxpncgABzQFtw1vrsUF1Hdvd6rC3J	12295	17310	17310	1619055000000
24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	44	1325	470	12463	16642	jxU44auUXa7n6o6CBULUGQMGJnqSmiUvk3NmouhdLMQ8XXaD8bU	12299	17315	17315	1619055900000
24772	3NKspXip2grP4QTNf2p6fze4htMgPCPA4ie6LWMY28p8i471vuKH	24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	1481	790	470	12463	16644	jxq29oiMyNMcCSinAqqXs7M1cQdyeLKxF1dBRdzFjECQ85YD8jp	12300	17316	17316	1619056080000
24778	3NLQR4ebhrfHZcwZHDgUReCjkQWBWVa3yaJ6DcyubBAnFDGhV1vJ	24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	684	1352	470	12463	16650	jwzHNaUuaayCREGVhAehrW1DutFqmLC9R3ASqvbCwEjBdCGkRiV	12303	17320	17320	1619056800000
24781	3NKQKo4JmpriBM2CQxbsjC4YzKcsyp94BYFTRxepJJx1tD5ywpbs	24527	3NKpZSWWDCZoDJMXj4rqSgd7x27TKFr6LRgsF14xDjKNVsMDpqGc	1458	1323	462	12463	16653	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12157	17321	17321	1619056980000
24782	3NLkfn2uWopoTarLrCDWZDUzd4vRrh4SR6JFeEtAhLY8yzNq96cq	24780	3NKSdYYU4gMNgWceAYgZ845TiT4KFFxfbn55rEswgZYUJtjtMqwV	1458	1323	470	12463	16654	jx9xwFfc4gqKMsLDjbNt1kqADKQ651VN3ewitborJ4z1fhsuqFR	12305	17322	17322	1619057160000
24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	24785	3NKJUVqibK8oBV7HHXmUz16zEbzFwk5BLoaFqJZaJLyFBTuVTjCR	1458	1323	470	12463	16658	jxxDT4rGEYrzDhDrXcW5pQnNj4NZfz7LM3uYSgBgG9wq3cd2GFx	12308	17330	17330	1619058600000
24791	3NLF1KA5RTCv4WeFNUFn7njXBHbZ8m2hrgZ1WDUYjv7g2XQJw6cm	24787	3NK5khUJxjT5erbdfRAL8wMrEXzJY8j6fqoqT57zRFTarvTHwcJ4	1458	1323	462	12463	16663	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12160	17334	17334	1619059320000
24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	24795	3NK6jN1ASb7vi2ReFJxQP854UMHnPC9n5yiyLKrgT4h2H6qJonPz	1637	816	470	12463	16668	jx32uq6xpk78Gjd8N8gH8sWydEEuqNxAVxnJiNXA9bYnviC6mG6	12312	17337	17337	1619059860000
24798	3NKCHTvjp4ZaGsGyZrsk1FjTp8Vu1P1T8vMhdjS9YVQyFBDidGRt	24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	1553	776	470	12463	16670	jw9NwPXZ98e3GAanxSWyGQ6FF1jk5HGejW6a87uAe1Um9PNCnDP	12313	17338	17338	1619060040000
24801	3NLJ4z3qgsuZ8Ba12Gxdd3Ex4gVrauTTv5d2BT1d68L9nWwiqBAE	24800	3NKUtK2UJxuPMmprYL6uDvYPjzQqGg3JiWpL25FCRTU8og8FKiWx	1403	824	471	12463	16673	jxQJ2N1gFFzimjr4K2jzWNVD797aRhd6qKEWpqfRXJQyCsq8puS	12316	17341	17341	1619060580000
24804	3NKRtReuVLjbw65EA62QnTuM2Nk5XdkhgGpk9d7GsjwAeFVbCCgr	24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	1585	1120	471	12463	16676	jxBJ8ENAyEihi3zk5XdYRNxtnCcb2n74cXeVJCGoM6hJj7fZhaE	12318	17343	17343	1619060940000
24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1654	1340	471	12463	16678	jxvPzXR7uBtmLrdUZHDZDyjc9hoMjz8JweUxvv25nE2e9tuJU5a	12319	17344	17344	1619061120000
24808	3NLsoXNayajTK92A5aZsTwXeG5f5Vhm7Uchayj7bFL6vF4ACEn2j	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1649	1257	471	12463	16680	jx1bq2se9ZUmrgjTMpcZ68uHgNnzY5JJgNCVrvCyh93kK8yuiMn	12320	17345	17345	1619061300000
24811	3NL5gkUpPtkukhvLhWP39rFbYtRPeLA2M7gyvgkFK8GBxLwApFH2	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1573	1072	471	12463	16683	jwdiNuHZWxxJ2DvrbR3PJXsJibH9Q21Q199xR4HhFuhqCkeg5VX	12320	17345	17345	1619061300000
24813	3NLEQULBeLfZSo2g714aemEayeUzitPAiBCbTwZXk1Mss5drr7qy	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	1675	1342	471	12463	16685	jx2TdpRtQVb13CL9xowqcVPd42AgEVVygLoBNhWhjGoRneMcoPY	12321	17346	17346	1619061480000
24817	3NKWkvVfkQmA8CYg21JEUTaphQACj2ajyy7tHacSHDjMmaTgXkzF	24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	1405	873	471	12463	16689	jx24ueZoHEeKVXVChE1XwkomGC8LMKVvmap2LpgHpeB6DB3ivx3	12323	17348	17348	1619061840000
24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	1402	852	471	12463	16692	jxwCiPgbSYA5TZ2WJAZDFwh3JGsh1pbqbz9RpYu3yCAbHbbuuZ9	12325	17352	17352	1619062560000
24825	3NKbwRCydPjdKd7MQjFPbDADXMG7jZx3eXvhazJWZyX5aeQTGfiP	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1467	1130	471	12463	16697	jwytXEsZtzyicoadJQAmHM1jaNzY7FKgpWizc63AkAvANcmH6Ux	12327	17355	17355	1619063100000
24830	3NKc4ygPnZBK5Db7FhJqrJGKCXPsMJFk8NN54ZacEVT6JBkeqnV7	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwDN1r7nWia6XMvP6Hd53renneRQrBBK38RE24EiRtT2XNH6ryf	12328	17356	17356	1619063280000
24834	3NLLfPHv3PW8jbnfhSPbPW2DiuRdP5eKRjguJB1g5eWCeAV1Bq2s	24832	3NLPCmVTStjYB1WzSuhnaXVAwYkwxQm5ZDECat4YQLH7gvQNSzJZ	1585	1120	471	12463	16704	jxJKCJEKRAoZddje1LsXJQW8nCiLeCMD1bCsA3p6ViQaZHb3CYj	12330	17359	17359	1619063820000
24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	1406	1393	471	12463	16707	jwGvQUM7MuFzue81UGRwuV1vrLScGyjVL9vo631ceGuBUwqA8gN	12332	17363	17363	1619064540000
24840	3NLeLJk9WwuPvFszFgWLGzSLFPjMqUMPWKvENeKztqvS6icY3up6	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1407	1395	472	12463	16710	jwioq3JZ56eTR9FThuAkdJmQfhs5vR8jK45831JTBvRt2jFjPNU	12333	17365	17365	1619064900000
24842	3NLupmLCT55wfSQHu1yTYyCjMb7QMmgNnxnSUBvu2bGtCvYkb3WH	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1675	1342	472	12463	16712	jwZJdrPSczXYb1fhrNWSMLwsFCjAFF63Q1Umqef2S24kHLwhEmC	12334	17366	17366	1619065080000
24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	1646	1108	472	12463	16714	jwgRj5ooxF5FQCxZwFpn9tMQMcYjEpUz3dNj9u7ahpoD2U1my9g	12335	17367	17367	1619065260000
24783	3NK7Q2KVE1YWdMqe5kbnSAL7uaNTZX3f3JfhqmPQw58XjnU4WxJY	24781	3NKQKo4JmpriBM2CQxbsjC4YzKcsyp94BYFTRxepJJx1tD5ywpbs	1458	1323	462	12463	16655	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12158	17322	17322	1619057160000
24784	3NKnwYtgP2BHRk8XwviE2j8kMQ2cGBNS6Ykr4t47FHmzKbwhJvDQ	24782	3NLkfn2uWopoTarLrCDWZDUzd4vRrh4SR6JFeEtAhLY8yzNq96cq	1578	1296	470	12463	16656	jxvZGPCXT4gJMryiot1nQRXxnfJNMjfsc6NUCAXcmsoBfYtDhby	12306	17327	17327	1619058060000
24787	3NK5khUJxjT5erbdfRAL8wMrEXzJY8j6fqoqT57zRFTarvTHwcJ4	24783	3NK7Q2KVE1YWdMqe5kbnSAL7uaNTZX3f3JfhqmPQw58XjnU4WxJY	1458	1323	462	12463	16659	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12159	17330	17330	1619058600000
24789	3NLV6bX797d2FxT637Hmuzy5zQnmdXfd1Z141Zs36tGBuQjN9iZ9	24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	1593	1220	470	12463	16661	jxXUHV1aXhKjHJ78hGZ9avFJ27GNSt5rBT3DdjV5PK9cMP9eh7g	12309	17331	17331	1619058780000
24799	3NLQcuwYwn71ja3NZweBoKuBn36wescQHvoQ1j8JKk24XzaUPTQM	24798	3NKCHTvjp4ZaGsGyZrsk1FjTp8Vu1P1T8vMhdjS9YVQyFBDidGRt	1637	816	470	12463	16671	jxb4Mog93ngrUum7yLLKH5ptmWTqtAAXwDqLb9ABzWf5AsWTZKR	12314	17339	17339	1619060220000
24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1507	1280	471	12463	16681	jwLyWHQirVMkyg471cj9sWupqWicMSBN33dUnfLTfx8eReHr4dj	12320	17345	17345	1619061300000
24814	3NKWLBK1bkFcrsjvSvbVVJpUB3pDBuXD8ppyhaho1BoojFXNfopb	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	641	1336	471	12463	16686	jxA1aZYg85xfWnjZzCVjFW3z9ckumMwntrhAYHYQu4F1ZiwWHSY	12321	17346	17346	1619061480000
24818	3NK7TAtLtT2kQWHwEhBdG94bUbRcsi6YYbvUzRaKztwubSKNcXKe	24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	1406	1393	471	12463	16690	jxjX2WEqkY1krMVwNMUscEfZnyqHFcmMkmEHM9QyNhDU2kfWSYS	12323	17348	17348	1619061840000
24821	3NLcRuadesUf4nGv9QeX1wWkCuAnop6a65DXy6f7WdpPgo1cinf6	24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	1406	1393	471	12463	16693	jxrVee7PVBZFNRRP6PJsZ3vSRu1WaBNLo9VZyEmerGjD2yqDuLy	12325	17352	17352	1619062560000
24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1419	814	471	12463	16695	jwdBvrXNbBcA2psq6QTGCVAFD5HYUaq9NAjMCUex3jKDuC8xy9B	12326	17353	17353	1619062740000
24826	3NKExGtEDokfoPXxpTd6ffQHt3UCP1KdiD6cmmNwzKkMTMF2R16p	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1553	776	471	12463	16698	jxbzzTCtWm8wG8T29bFwmh7AjsZvQpGocqZa9CKXijBdrn3Gp9C	12327	17355	17355	1619063100000
24831	3NKFLaWvLRLJToCa3FEvGa7T862eFUwreWFUngQLvjE9oUv9BstN	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwqQ8ZfLHpi8s2aLefceqAwviQ8svdSMqE7MVZzX9rURPcP8Ndm	12328	17356	17356	1619063280000
24832	3NLPCmVTStjYB1WzSuhnaXVAwYkwxQm5ZDECat4YQLH7gvQNSzJZ	24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	1402	874	471	12463	16702	jwvk6vWhz3wvQikEgXhDYAY3UBUwLvx9evTh53GxjCPCpiWUcu3	12329	17357	17357	1619063460000
24838	3NKD973XAt7HEgGkrX7mXPcqc4BSwqEyHywsBBbfBxKRZg8ZD8aL	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1670	1282	472	12463	16708	jwQRBzGZu6uN7G6VcbywvV98wCYFBAU2zJVH3VCAHSDTCRFxpZY	12333	17365	17365	1619064900000
24847	3NK6tBt5xj1i5sv6bo35BHpTtjj4K2uX6vdSCqSNUTbVNypxqEHF	24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	1608	1163	472	12463	16715	jxfGkdAXe4qyLGEqqcBNNdeZ3jhbKigWNyYkyD7YAbZcc2XVVE8	12336	17368	17368	1619065440000
24850	3NKCMsmV9VHfwoPQjmSAst8qs6AKs9vtBt6m28NCXrzY2mCfwYL1	24849	3NL3W1P9hKAf8iVta1PoR11eeoqRi4GEYQkqTAWXAGSHhXPnqfDG	1406	1393	472	12463	16718	jxPf4octsZhox1mQ3qj9m2kPfgDLBwKbv41Q9nKRRejWxB9JZcv	12338	17373	17373	1619066340000
24853	3NKAY1ACrJyxLBmA5TFAr7pCP66CTi8eGFpmVxGkgNPDiY8wBK2L	24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	1553	775	472	12463	16721	jwCBmdkFfYweFcHtJ5YyiMmwmdb9ej6hGHgo78D2Cfk6CLEzQx7	12341	17377	17377	1619067060000
24856	3NKzpNoANre3kzAfHSCo9L9FhC7tkWvZCznq4kWdVJfgDLgknbpg	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	1447	1099	472	12463	16724	jxmrUFRtf2q3rKbcS9dycSr88HpDaYVnKJMrdJz7MbjSmt7dX4n	12342	17379	17379	1619067420000
24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	24871	3NKeLxz4fiQKHvoikD4UVUbCCZdqPwLookdJKfixCVJ82EtwJDhD	1536	947	473	12463	16738	jwtZTJ48oDxrmBoWiizPmA81EuaByrj7UvYuxC3UyzDeqHJeJSp	12349	17391	17391	1619069580000
24878	3NKd1Smvs6iBMQmpxfQAjUFtLuLwguCA8qhsNSYdMPc9Fkd3sE2o	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1506	1373	473	12463	16742	jxWEm3Lt6BQgZ1Y6RnTwAXjU5yjTuaRkeYNMhQpzgkvsVhtNWn6	12351	17393	17393	1619069940000
24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	1646	1228	473	12463	16748	jwGgTrLyQnABuPbBukbifnakWGLYcDtrnKYWvacNu2p1iMbUi4Y	12354	17396	17396	1619070480000
24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1587	1111	473	12463	16754	jxSzwA35TWvNy5YuApHwFx1Dh51r829dE42f1vCriAvtxRiojxy	12357	17399	17399	1619071020000
24890	3NLxrfbsPtKXNSqX2LayQENPgu61TrBjFYMswvGcLuZRUiYuTDEL	24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	1623	829	473	12463	16755	jxUg21MLcaREo1xxmhPVDqzWfp4guVA1zcmi5rA9SUacvAy6M7v	12358	17400	17400	1619071200000
24893	3NLXa7FzRP6zf63Vn52GsoB8bxXvyKvEpQUDqWwuiyBJTkGZB9JK	24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	1673	1122	473	12463	16758	jxUwrKYuENm87vUodePcf4EZMYnFzACsQN6q9sRLvvVPJWXHgby	12359	17402	17402	1619071560000
24909	3NKvemPDNSCXgmjnZVPoLbyB9EyU2vgRUuV2bKttC5AziEuZ7bT1	24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	1549	1362	473	12463	16772	jxxzc8zf6frdm89Vv5xVhY9vtj279yFPgC3FrFcB3zUfi7r9VV4	12368	17413	17413	1619073540000
24794	3NLMq2G3PvTMU8C4eDeGRVTEB4vkA45quKzeUFFLbmt5fUGxzyQj	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1458	1323	470	12463	16666	jwDMhrccZPvNVsC1x9W6fEoPcL65HGs55gQeQDj4z9rfs6AU4zL	12310	17334	17334	1619059320000
24797	3NL3cTmJH5cTNPFDQSvF9sjRnPjoLXLJ7dPo34gLghwbm4SbgPSQ	24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	1594	1080	470	12463	16669	jwpSG8hvhcJbZhxuf9zNK24W61qSJxTL1Tjs4WAshgWdTTYdXvy	12313	17338	17338	1619060040000
24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	24801	3NLJ4z3qgsuZ8Ba12Gxdd3Ex4gVrauTTv5d2BT1d68L9nWwiqBAE	576	1355	471	12463	16674	jx2Sx4eJ8mSqYznUzEJCvWGeKgsgrSRzEAAqjFtiztiL3dM8vWX	12317	17342	17342	1619060760000
24812	3NKQ4RxNPk5jBUNcHN8TGntA4FBVscPvUEWzXQ8Jyn3fHDCPz8iK	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	576	1355	471	12463	16684	jx3hGCYrWf4rdGbSnBpBQpQ4LxXHfcRauW1yk8U56xo2pvHALM3	12321	17346	17346	1619061480000
24815	3NKYBCpNEz5xysjNMnNQ2mznd29DeJLZkDqQtTkKUMGkixgbi6kU	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	641	1336	469	12463	16687	jxDKifgy3J15sUjQYvxgbLxKCZwJaJFhx1PoVsaTvqTP5PrzRem	12287	17346	17346	1619061480000
24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	24813	3NLEQULBeLfZSo2g714aemEayeUzitPAiBCbTwZXk1Mss5drr7qy	1637	816	471	12463	16688	jxQKvp3VX9xF8Q7jqHGZcmDi2xqkSPmvVGXTnWBLt1vTAQ9Ua99	12322	17347	17347	1619061660000
24824	3NKKBZvFmZ3LwrWJzQy2iHiobPs5ewFkusDLZ2Twnv5p78B4tUD6	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1634	1085	471	12463	16696	jxjWxcnKWDRBRfNoTEmWgUKwcDezytoz52TWDup5U8x2EfydirG	12326	17353	17353	1619062740000
24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	606	1295	471	12463	16700	jy1oxNb7XMP9xm7xbUT1NUrz78gjHWtwTCgB6jhNe8QRvouhXNY	12328	17356	17356	1619063280000
24833	3NKF34ZtMEBYZxG7L6UEhskycc1m6Jpc3f6rQdocE2SCJnzLpnHV	24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	1406	1393	471	12463	16703	jwVA4dthmDTTx8RV8KLJupGpGrf5KjqWVtNHyVJ83eSY35Mgx2F	12329	17357	17357	1619063460000
24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	24834	3NLLfPHv3PW8jbnfhSPbPW2DiuRdP5eKRjguJB1g5eWCeAV1Bq2s	1407	1395	471	12463	16705	jwu3L6FmvFzohe21VWsfcPs9rRsE2ZRMNpTYAXtLEhpQ9fjUW5d	12331	17360	17360	1619064000000
24836	3NKQoeUhZFvCGeHnkijM9jbey2vvJKowZDwdYThpuP2vSCGfgiQo	24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	1546	1339	471	12463	16706	jxSRMTRi3XwWgQCa9pcDN87pCuw2ivK5Jow8CnmBi4oxdBLyqkR	12332	17363	17363	1619064540000
24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1406	1393	472	12463	16709	jxAQLbofAYbcsCndNGydJpn9VMmQFuXLVeSA5uaMX9whB3fRxYu	12333	17365	17365	1619064900000
24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1637	816	472	12463	16713	jwdKuFB6fnrqenMcKWoeMRuenu59qZ8YAeHa5isfLDZR6DKqvfs	12334	17366	17366	1619065080000
24848	3NLpC5pQdPvCBc9iK9S92WVxf5KLMmc6UL7hsJeSJZUCm6wCLNgZ	24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	1406	1393	472	12463	16716	jxMSSJEiwhv3abjSNTWg4rgviF6EqqDCKMqe1GfB8vCzsb7CNDC	12336	17368	17368	1619065440000
24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	24850	3NKCMsmV9VHfwoPQjmSAst8qs6AKs9vtBt6m28NCXrzY2mCfwYL1	1406	1393	472	12463	16719	jwZtgYLMPzofud4iCcwwsqis9jw7r9r9YQjdwMQxva7Rg7nokiC	12339	17375	17375	1619066700000
24857	3NKbQzd26S5Sm1ABzn1F7mqCCfGLPN5Q4vbCkvnqyPdsG1jsUF5o	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	149	1037	472	12463	16725	jxh2NyKbm9KvFXydzfgbpoGm5MxniHg1irvM7Q9AwKYzySsoEsB	12342	17379	17379	1619067420000
24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	24855	3NKvxgsQN54RD3KdkQmMRewFc3kq8m1Br71mDckjKZyQdkkxyqXj	1407	1395	472	12463	16726	jxXRJnEU4rP32gUthSxVUgBsBKevFwXPWcSpvFMojZ1J5WRXwUR	12343	17380	17380	1619067600000
24861	3NL6bjabuyvv6jouPGB4EKQdB1T8phj2J5UB3bk6BXe1jvKoSXCu	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	1402	868	472	12463	16729	jxgr9oT4q6JFHh9GQxcJ4rniEPLxi5vGRoR4wbn2gAAGt6Ki3pP	12344	17382	17382	1619067960000
24864	3NK3k5HK3FzNBv6dVEzgDW3rSM5jMpYvHEZUKW9PC3CTeMPJR6qJ	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1542	1058	472	12463	16732	jxvQHitJJ8DKp1wwh84MnWaCdZMk9XMaDgfxDqTYaanXQPwe5vE	12347	17386	17386	1619068680000
24866	3NKABdZki28WBNTg7C17CSVogEVNjJtD2zsYEKxX6K2zYcMro32b	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jxBdrgdg91JjeEzqY7HUfXWN3RAZ2pp3fjYkcj8zPjpvsWAB1Bf	12347	17386	17386	1619068680000
24869	3NLKcxNSMZZGnpA5oSMYDbW41fHradd23W3FTFaEtZxy2fktfrY4	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1553	776	472	12463	16736	jxV7yeDqcRGNjLUPL29GV9sANC7ZGByfXMdKHKvLvdz4Hsnkf9p	12347	17386	17386	1619068680000
24875	3NLUDvAJasxKWZBYv5e5tU8mEyfbGCzutzCZ87wWhb8xhtiSpPDd	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1406	1393	473	12463	16741	jwF4q3WJURTZWnDFKfv7eZD2Tg8A7qYFpXUC4CAafcnx3n6ZXb5	12351	17393	17393	1619069940000
24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	24875	3NLUDvAJasxKWZBYv5e5tU8mEyfbGCzutzCZ87wWhb8xhtiSpPDd	1587	1357	473	12463	16744	jwseTDeGJb2om8CYXfL4zWebUikQMvihzArNf4pTpaps5RxazqT	12352	17394	17394	1619070120000
24884	3NLNathS47TWdzMAzz4aEdicvAquBaAMuKmEaiq6BR6d6cRW2TVZ	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	606	1295	473	12463	16749	jxELPDFMCW6MSjbtvNb15bFaFvDUJ1gBm1tJsJsxvmZR5SApZ1c	12355	17397	17397	1619070660000
24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	24885	3NKyXijPcLeDaVvrWijhCqeL7twkU9C2dJDSN5BCvTa4EJHKf47G	1406	1393	473	12463	16751	jxijecDe7rR48nYCkhEbTkcwhqATbvmiCPb38XqR66vsy4GTSKL	12356	17398	17398	1619070840000
24896	3NLvjsJjvmyVmEUYeH7wMCbnd3LA23wkfiCvJb4iWB3EQLZdP5Sx	24894	3NLHHrYMp5V1x4HTJcJCVZpqSHVnKSe3PoABQjxyA6tbSTn4UEuk	1542	1058	473	12463	16761	jx9ndUe1Zo7g9BbD77k7YVxrpQ7UiMekF3Du5erVRszeKtt1bUR	12361	17404	17404	1619071920000
24899	3NLeFnSNmJmYQ6dwF66MDS9J5bnEPiXGYmMvuHdZQXeKt66YKEwo	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	1422	1337	473	12463	16764	jxnYw2EQUgpnbKxZ9o5tpYfzmfGA6dDdLgWyvLKHEexu6j4cGFp	12364	17408	17408	1619072640000
24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	1553	776	473	12463	16766	jw8Fx1G9PqL2UF9jTY4crwssxgL2DQJy21hKBHeopnBDSe9xdCf	12364	17408	17408	1619072640000
24904	3NLP8uKo9X934kwsZif2LQBucQ7jSmSbxGMY4B9k69bwCoyfoTfy	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1578	1050	473	12463	16769	jwwk8Q1iTboexpnQSf5SQdP1TzYUPT4GS1LFEwAvMeNwHZ36rMN	12366	17411	17411	1619073180000
24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jw9agC4yXhinywbYcGCuSym8gMJgeRPTRRjfACvvLaUvXvvkN6H	12367	17412	17412	1619073360000
24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	24907	3NLE84QZvw9RpqLHHJBEXHY5BXaQKpBdqsrtzGsD1eWSec5RYrgr	1549	1362	473	12463	16772	jwgzTWi9i6rAkFEP53SHsvxsg6828kwTdhCYjH9w6oXYWYvZFZY	12368	17413	17413	1619073540000
24913	3NLQZGDcGNZ3nR9h4ZBNBWTwBvG9nU6EtzZS8NCwTjiGQA9hsfb5	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1440	1377	473	12463	16775	jxXGw2qA1Yh7WhZcimxjfAfscLYDnqxPyM3amU9Z9fYLPfzo7uh	12369	17414	17414	1619073720000
24822	3NLPoSv63MUQw613DmcZxwGBKvSxJwiNNsb733NgqFKRpopiGdG8	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1451	926	471	12463	16694	jxiQRtpHtpMwuDdYCo2EkEwyj1oz2r4ChFgUsogdVTouhHpNgij	12326	17353	17353	1619062740000
24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1406	1393	471	12463	16699	jwdugWpnVBPZ4mPg1kg8SBJLkAy6MqXuP6PyZCjtkDCTVL6Njbd	12327	17355	17355	1619063100000
24829	3NLo3zinfwPkr1UCd6YEXuTdJwq6PuHZfMaikaPrxtKuLVKDCeVb	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwjxHXgszd9nZnkn7p6LSYvUPZwJLLXzb1CnT1DymGf4aGzS9XL	12328	17356	17356	1619063280000
24841	3NKDvqn88AE9uoQzgECDipuc3BUEmBSHxj8G7NC4iCvLRTPRq577	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1609	1333	472	12463	16711	jwVXATWKJhKeqTD2mHuv2Mxpnaa7FQTWtWMXfFATaJUGvwTEeKg	12334	17366	17366	1619065080000
24844	3NLmYt1QYDnaWg7ddWCRCfnpvsvueSxvzUv3zHZvamfnQdrcr7Pe	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1609	1333	472	12463	16711	jx6bRinrAD6cjv6teqmcTjVoUrTjMWZ3wczJyGgYzhgPptojQ21	12334	17366	17366	1619065080000
24846	3NLZHbLaWmWUqfhvLsmwueb6qMBhQ294i1Qoy5Qzb3b6AKMdmUtZ	24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	1646	1108	472	12463	16714	jwVyjg82crPca1eDEFKtqagv26oCyKtZXBCXuqKLGEoB4Ft3mjK	12335	17367	17367	1619065260000
24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	1613	1103	472	12463	16722	jxV4uprcbuX2vPHmX2PB9oidYoma6oaXjokWcZ8DMDHvRnpMfhm	12341	17377	17377	1619067060000
24859	3NKxR2y61iBsSjU6Y1iKGmTRYEETS21rfHU3eWCDtpyEB11VJiJG	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	1457	1391	472	12463	16727	jxGBV7HpVYRUgM1UjeUtYPtcapd6kCneUJfFRFyS2XWZiAnxb9L	12344	17382	17382	1619067960000
24862	3NKTytJwCqRgYxsANKUdzdJbetXEhahM5ATHHqxm461xG3QD3bSK	24861	3NL6bjabuyvv6jouPGB4EKQdB1T8phj2J5UB3bk6BXe1jvKoSXCu	1573	1192	472	12463	16730	jwqGD2EJF6EAPsdmbSQ5zHPC5cJzKow8ZRkgKTbkfY21DGpZyp2	12345	17384	17384	1619068320000
24865	3NLc25vMGxUv2TcjDNjoTuGGrjmU4FwhDqdUoDaQt3vvr8qsdRjM	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1589	1286	472	12463	16733	jwiZoCNgGZ6JrQA2Mwf8tAYkFDNR9jmjzyWhjnyEmKDWGaZShvE	12347	17386	17386	1619068680000
24870	3NKxTkV2HMHTqEV8wKEQ69mvYZnYRM1apz4AdMQwmXDme73qcK2Q	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jw8kA6MsdVV5uZe4mSaBZ82PbMGYUtBdQwAaMaPgxXs3xZz2Daf	12347	17386	17386	1619068680000
24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	1564	1338	473	12463	16739	jxj1u8NMRHY7ZmNp5m52UrFJ8WoVFE31FBfmyxztroBAa71xKsz	12350	17392	17392	1619069760000
24876	3NLg4dfhRSqiAL9trStQi11AET6K8wmL7k9fS1Upa1VfUu2e2ZxK	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1506	1373	473	12463	16742	jwLxztBGqSii3mBZ7MjLznYMXKMmtQzVCSZTFh2Ew7qAGcgSai2	12351	17393	17393	1619069940000
24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	43	1310	473	12463	16745	jwCFwm88eZYFEdbg6QKuz4johciCbodLzMwAvep9zBxcGRXraNu	12353	17395	17395	1619070300000
24882	3NLEzUrgqydmP2Sa5SEg9CMtL6MZjVHMHTzwpPy9WJnRdSFjvYay	24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	1406	1393	473	12463	16747	jxtGLKUigK5ZedJ1MX1VmF9hivsgGm9HJFWPG1Wa5nvwX2rYHKB	12354	17396	17396	1619070480000
24887	3NKTiK1UHXga8XTJZ2MGt4QmqD2SUoqBbiPU59uP7mckjEVy1dTS	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1406	1393	473	12463	16752	jxQXjxUyBokSqhaVzfJYLt6R4RZWi4DyVqLW4qJ1vnQrqfhhpQP	12357	17399	17399	1619071020000
24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	1407	1395	473	12463	16756	jxvsWnxWTnvC6i4ndCr6wcwGJCSiwdpRyWsxdp3S4faxVT6M9Nh	12358	17400	17400	1619071200000
24894	3NLHHrYMp5V1x4HTJcJCVZpqSHVnKSe3PoABQjxyA6tbSTn4UEuk	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	1637	816	473	12463	16759	jwm2vzgtVMmrbGhmiGuo3cUgvtCRtriFg57tZpC88MTFBLrPabp	12360	17403	17403	1619071740000
24897	3NLXGM2q36LMqZqWzNqdEtQ8DMwTTYJN8j3yRZShdeCrhmTj5zWA	24896	3NLvjsJjvmyVmEUYeH7wMCbnd3LA23wkfiCvJb4iWB3EQLZdP5Sx	1402	866	473	12463	16762	jxY9VfQzVQBAj7tvzFgGvQa7hFPKdShypcUo635uUdefyT2M7fQ	12362	17405	17405	1619072100000
24900	3NKuLn9wvycvcpmXmmpSsX9JrM8jCF4CqjfmYoZTh7pHtgbSssCS	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	44	1199	473	12463	16765	jxogHJCBVKkJoHeVKFZMWSJDE25jBzRnJL6pwB69JBrA9XD5osF	12364	17408	17408	1619072640000
24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	1610	1188	473	12463	16767	jxypF64jm5BpXDmpdESPTruKWsFHsxQGJCLos2vk7jh6WP2URDb	12365	17410	17410	1619073000000
24907	3NLE84QZvw9RpqLHHJBEXHY5BXaQKpBdqsrtzGsD1eWSec5RYrgr	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jxRyyXPLUPmcGtrRJrcvDhRxbzw2kMtA2EALkeaCQTpKXHNG5WG	12367	17412	17412	1619073360000
24912	3NLjGyPUCGcz3PJbC7qPcKQ13QrjVbWxApUfKf3rVfEef2B5Nnn4	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1571	1209	473	12463	16774	jwBQffcuAZTHbvG1nowdmzUfJUKCUhj2NTyL52D7RnMa9Rt2deE	12369	17414	17414	1619073720000
24915	3NLkSqUEHc5tntSFk1r9jPcME3dB8BMDG54BVRFnSoXNFZdkCiwb	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1440	1377	473	12463	16775	jxpicJYvdFUHxRkMrg4P4FhuArFrCvqJKRnHzDtLtgxYz8hc4px	12369	17414	17414	1619073720000
24918	3NKtc9PUWRMo3Gi6gf8B9VjDoJxUH7ovtv7SizALR5SjTXS6VxQR	24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	1656	1097	473	12463	16778	jxHTUbbtzTi74ueYuHjsN4YgJYMhjH7swBwp694jsNx9ohigo5Q	12370	17415	17415	1619073900000
24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	24919	3NKkanDP7qgR2jSvU8Zj7puKqMghN5SUShbUd3LQHyNPAoJkHsgw	1585	1120	474	12463	16780	jxmx9idyPx5KBWqvAA5SNQGMHu3NgXaiDubVE4S15xtDiWhg4ey	12372	17417	17417	1619074260000
24922	3NKoANfynqHYX4sL4gHRa7QDdSCceo7em7v6Fn48CcuYm3pr6h8x	24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	1560	1165	474	12463	16782	jwWR335gMDMLXMJA87yFGrtaYf9FEzwoaKwDnnDkRUSqoBZAZ7W	12374	17419	17419	1619074620000
24849	3NL3W1P9hKAf8iVta1PoR11eeoqRi4GEYQkqTAWXAGSHhXPnqfDG	24847	3NK6tBt5xj1i5sv6bo35BHpTtjj4K2uX6vdSCqSNUTbVNypxqEHF	1403	824	472	12463	16717	jx22txjhjHRJYJyDB5ESeqdaspSDLTT2gix5PYzEBjaJnWu1tRm	12337	17371	17371	1619065980000
24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	1671	999	472	12463	16720	jw9VWYcar2dJS9nwwn7sXDsKucG46cXfqnDY4R6iJoobiuy8VwG	12340	17376	17376	1619066880000
24855	3NKvxgsQN54RD3KdkQmMRewFc3kq8m1Br71mDckjKZyQdkkxyqXj	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	1542	1304	472	12463	16723	jwTwDPqe3pcw76DsnskKZCqptYGmDtftJ2BxQTwfC9tSQqgKUzH	12342	17379	17379	1619067420000
24860	3NLvNwDYE6Q795abqsuSGPuezRh4bn8UPxp7qidQ9GaDCcpM54yJ	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	42	1235	472	12463	16728	jxPiozfVTnz8FTfJXxMGy3E5tvXYKBB9jqhJBm7dwt5f2xBD3TV	12344	17382	17382	1619067960000
24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	24862	3NKTytJwCqRgYxsANKUdzdJbetXEhahM5ATHHqxm461xG3QD3bSK	1634	1331	472	12463	16731	jxEVmeqdewQ8dt8nhyGV6kuidp3wU19vhDft4kDYk9hVKMaMdgq	12346	17385	17385	1619068500000
24867	3NL5imcsDc1stfCrkgDeixHPLXVwgT6Xyr5T63uEU145vYME7XGJ	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jxfY9WwYvzw9YptEnEAevQYspkDPUi1BnqN5KoPH7PjtA9SJARR	12347	17386	17386	1619068680000
24868	3NLTTcXgViUYaQpmBjNuLhtZTgruKzLouxxARaeA7VgkRmXCoywc	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1648	1158	472	12463	16735	jwXDG2Qv3pHpSCPMsA4rWehAA2KFd6GcKHbmL87GbF46X9Bp4Wb	12347	17386	17386	1619068680000
24871	3NKeLxz4fiQKHvoikD4UVUbCCZdqPwLookdJKfixCVJ82EtwJDhD	24868	3NLTTcXgViUYaQpmBjNuLhtZTgruKzLouxxARaeA7VgkRmXCoywc	1594	1200	472	12463	16737	jxjKKAotb4WqV95rjWbgU1KvHbNqqmmr96K8DX4NfALvkwnazUR	12348	17390	17390	1619069400000
24874	3NKeNcqChh1gNwTW6pnCmLoAgDeBfKTDGnfWyC5Q3MBEyDJwsXC1	24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	1577	1327	473	12463	16740	jxcWNqLBUmvGawepBaSFNQBn5ZXoee5Gj9Cydvd8N1Tvv2bWwfy	12350	17392	17392	1619069760000
24877	3NLKueUKHLcHpkRhvZdcxmVV3HNszZkvdtz4z5D6ZYdj1Ab2nkRf	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1627	1385	473	12463	16743	jwGEiszwMZ5PGFRpnCaV369coKehc9oqorj2naaqmG4Rykm5kQF	12351	17393	17393	1619069940000
24881	3NKTLcpYLAgpertbt4XXv1hJrxpRwwvGnKnDAnrW3nbmnTWNPuP4	24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	1402	868	473	12463	16746	jxBVyKHYjQFhFRBtpfatd2VYq5x3ujwr2anQgvJVUfMmc19Z4my	12353	17395	17395	1619070300000
24885	3NKyXijPcLeDaVvrWijhCqeL7twkU9C2dJDSN5BCvTa4EJHKf47G	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	149	1283	473	12463	16750	jwm9zoKu3nzrLdcTBGQgiSRWKeMnULYA3nSnRp7rynA97KXQDUt	12355	17397	17397	1619070660000
24888	3NLuiXjNEChj3sXG6CxYQQi49e3A6o3umwusw8s4hfkofmNdxbtH	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1461	1271	473	12463	16753	jwH6QZFSfzYCy8VBNHRcNnHz9wDKt8LVv9HgQ482izMbjTn7ykN	12357	17399	17399	1619071020000
24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	1406	1393	473	12463	16757	jxuzsEjaeKNAfgwGT7w7t7M2WG5775nfgGibXYCmCEWkbGcWvBi	12359	17402	17402	1619071560000
24895	3NLVZgP45n9t6Eg4fGydwqXrTGiaDDrDnJfroEnkobegmwK3Ev2F	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	1650	1009	473	12463	16760	jxJbT3A1LrmNTtEk4YpVQVSgD83o5GQoRdPRC73DnzGFpL4Hd2R	12360	17403	17403	1619071740000
24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	24897	3NLXGM2q36LMqZqWzNqdEtQ8DMwTTYJN8j3yRZShdeCrhmTj5zWA	1406	1393	473	12463	16763	jxbkThatEEwQbMW8SUd2NjZVJbKsQnxihCJpGXqYCnX5htMJEWj	12363	17407	17407	1619072460000
24903	3NKjQS98yF1ahL7XV5zFpiT9TSDNv5vW7CcVAhuDPers3mnkc1gx	24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	1490	1274	473	12463	16768	jx5PiDuLBMgDc55kep8Qmp9uk5EKWJtY69CQrWcvcL9ZhePnLQM	12365	17410	17410	1619073000000
24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1506	1247	473	12463	16770	jwebnfuLkdew8kY2Eqr43qtgafirsHUZzBwu3h43zbDvrQHC3CA	12366	17411	17411	1619073180000
24908	3NLGN7ag5ZFnqAtegxnfSbBMhrFk1bnXkRMm2mSpaZAiU5wVuSHc	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jwaBd8J5UYwsqZtsmuRzV4D33sHe3Ak1i3zNLPEjxaKH5J3zhSu	12367	17412	17412	1619073360000
24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	1588	1146	473	12463	16773	jwa16ZH7PV74ySDXBxrBZbrXkTXZCXw1YBvFqutbjwGnTc7MXq8	12368	17413	17413	1619073540000
24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	532	1303	473	12463	16776	jwNTF9JAyKqhWReXeDx1Ppo8cUxjAMDUHDinXZN9MnH28t6KfNq	12369	17414	17414	1619073720000
24917	3NLtYwXooMGCcMbSXmThzuu1y9NoptJPFLN3E2z7ySzoWaNnTbAz	24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	1656	1097	473	12463	16778	jxHTUbbtzTi74ueYuHjsN4YgJYMhjH7swBwp694jsNx9ohigo5Q	12370	17415	17415	1619073900000
24919	3NKkanDP7qgR2jSvU8Zj7puKqMghN5SUShbUd3LQHyNPAoJkHsgw	24918	3NKtc9PUWRMo3Gi6gf8B9VjDoJxUH7ovtv7SizALR5SjTXS6VxQR	1637	816	474	12463	16779	jwKewLTfxF4NPH68GrF8P6SEy4PzHoWruYuBe1Ae6qK5wiYMPU4	12371	17416	17416	1619074080000
24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	1596	1117	474	12463	16781	jwHoGRrmEEEMQxefJE1AxNbQfUv4sduLmiA8EVrpVsSAxwFxcFN	12373	17418	17418	1619074440000
24916	3NLXASHWLZDFzbM7QDy8BNA4QAd5gzu7t75zekCkxnafgkpNtboj	24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	1440	1377	473	12463	16777	jwU9iX86TxAfwUn4F2HxeaoKceb2xm4wncr1cgymWoYAuuk9BJ9	12369	17414	17414	1619073720000
24923	3NL8QXZ19Dv28iiSjgwsPTTSyS2hH7gmLtXyqZ6iFDFBudKnLQYg	24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	1560	1165	474	12463	16783	jwWqbyp4foAU2S5UcoEQ56YWmE11ZVxWwB7QnDibptuXGi7QEXq	12373	17419	17419	1619074620000
24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	1407	1395	474	12463	16784	jwDPb8DxSrwLCBerUnVLEg18HQX2DSRkdT3qDwwVdK3xkLkCyx3	12374	17419	17419	1619074620000
24925	3NLkX8MGFCqB7KZ61S3gQRy8XvePTuYQV1JkgmvJXPitAo7HWyhr	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1406	1393	474	12463	16785	jwnzhon1uNA1XWP6A1v6qZWwaawxxTfzQ2s47xjP4sRLXioZyHX	12375	17421	17421	1619074980000
24926	3NLBaeLPwE3SPMi6128SsFpjweiQe5725KtqFKViS82i8TuTDzS3	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1642	1367	474	12463	16786	jxTtx2YQsDEX1YVwTLqiKUUHKizP1Nq8KGB2F8MV6AWWmdm3hfL	12375	17421	17421	1619074980000
24927	3NKQvMKRxq679tqxrU3Dg5BHqsgK9Y7uM2VJyWNzFmHrKi461pMK	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1540	229	474	12463	16787	jxHRhYA41SrPLDP321VdyHeKN32Prp9bQqW8wo6PCD27nk4VMid	12375	17421	17421	1619074980000
24928	3NLajhWv3YnoX6ZVzmCnSBtxt99Lt2XyXHn8AMjF9PfqCZjhGAe3	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1508	1387	474	12463	16788	jxKturjeZRXJVCDoJ6YaNHN6gb8zthL1ypQYqnqLWc5WB9f61ua	12375	17421	17421	1619074980000
24929	3NL1kFDhdERQs2Sf7z7yrSTyj3EqNUzJdVYyH6NcKnRNuLP5boKU	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1407	1395	474	12463	16789	jx3fXFoP8XunLLB5tLUxvN9PzNHbisZvT8T6cV54tC6mBMwMNgE	12375	17421	17421	1619074980000
24930	3NLPY9JkVNVqFPmUFa4TT1dUUr3mkq89eCkNEr5WxJrovtx2wm8J	24767	3NLW7EAoyYfgbSmwa1TR8PD4MeHiTXrj75LpHc8CkoBG8hPha9sw	1508	1387	470	12463	16790	jxuthE98MUnzVVYE2Y1FKFB4w54YtpueR1YMnM5QQ8m7sCc3x7U	12298	17421	17421	1619074980000
24931	3NLG4tgA9CqnWf5RWFRJXnJsKxzwQnucExpETSWNpaJexrfM1knz	24922	3NKoANfynqHYX4sL4gHRa7QDdSCceo7em7v6Fn48CcuYm3pr6h8x	1540	229	474	12463	16791	jxz9PqjwC4xAVTqsk2uxfdbt8Y4FFCGZoKxaLpc7NnQJgL89vbS	12375	17421	17421	1619074980000
24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	24925	3NLkX8MGFCqB7KZ61S3gQRy8XvePTuYQV1JkgmvJXPitAo7HWyhr	1503	1277	474	12463	16792	jwETZ9HKaujeSoBNTb7WMPAv8QuvgnimZt8rD8RhqBuEj2fexrH	12376	17422	17422	1619075160000
24933	3NLkA4N2Aqoqh2C3hPK5WrvTnzSApcC2XXWBH1Pjp4Ha7tBx1air	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1549	1116	474	12463	16793	jy1ufPgABC9CUaWzsPaRgD7yJkm2wthHXmjeSvWvcu6bmJwUns9	12377	17423	17423	1619075340000
24934	3NKJ8QfjLnAyTi65a9DA7xy68BNM7A2Ne5oZZ18vY1i2qKsCC44U	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1476	1125	474	12463	16794	jxH9QsPoYezWpNQ2bQaJY4YxwU7p3o5v4VjSVNqenDFUVXXELaW	12377	17423	17423	1619075340000
24935	3NKgcMt8Bf2YeicMMkxQuEX3Gf5MaNEUFx5BwWuv6Tzg8h5RyqNL	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1672	1039	474	12463	16795	jx3eHjhrCm1oudHudgrVzpFdVjXZfTx8qtMSN3yZAZen5vT5h2S	12377	17423	17423	1619075340000
24936	3NLhNN4iPbEjgT8vKcqyoJ4oC7p18mZ71HLnzjF36wtfhbhvJvZy	24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	1549	1116	473	12463	16796	jwymg6e22DJYYNSYBEgnQX9eaM65JojyGrRsJc69pwCBYkS35Wk	12369	17423	17423	1619075340000
24937	3NLEPudn5ShaLShVEATMuhkD8TGSw3dZn2m3ehnTTff7ZLZYVDPY	24935	3NKgcMt8Bf2YeicMMkxQuEX3Gf5MaNEUFx5BwWuv6Tzg8h5RyqNL	1646	1354	474	12463	16797	jxsX9BBK8YD8YnDY4FMgn4aX3ueWK6MnzBnnv8ejmmFHMezEUjQ	12378	17424	17424	1619075520000
24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	24937	3NLEPudn5ShaLShVEATMuhkD8TGSw3dZn2m3ehnTTff7ZLZYVDPY	1460	681	474	12463	16798	jxiyp61Kt2JSZRVksLRbCLs8hcwVtpT6Qh67HPRqSurjB7Nv6Pe	12379	17425	17425	1619075700000
24939	3NLYmtwU3Jr7nHW217YxwNVe16U7qsAQkbdo4Vep5VJkTQJ5whvw	24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	1672	1285	460	12463	16799	jwzhzi2rc7KsxLetFgBnNmZvSWECHNVSLdEBxfXLbdGe5MWCj9i	12117	17427	17427	1619076060000
24940	3NLt9REjwX7NrxexaMRtj6uFJe5FKhiz1jv16q7fqihgqZxDA78a	24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	1534	256	474	12463	16800	jwgbqYpUTRf9S1Cb1nTDSvC8hXuzcaoPRQyWGPZhtaPrdRktieB	12380	17427	17427	1619076060000
24941	3NK3FH9Ltuyk9vjxueTZQRYvwEKyKYSgnR24LxW8zvKTfFVLUkUK	24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	1672	1285	474	12463	16801	jxN4SNXEVsH8LzsFZ5K3JwCDtMV4j4StKUpwpe7199cJEWeQfww	12380	17427	17427	1619076060000
24942	3NL5MXg4bcKRXcu7xSsjUCr1Q1dbQuFdLaA7PPS3zEZoNiGcHhch	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	1672	1285	461	12463	16802	jwwbYQScv6EDj6MHfMwQodt5tMd1scc1MLyymm7VjgNbPFGkfP6	12132	17427	17427	1619076096788
24943	3NL9FLcCFWSGWFChU98dr2bVtQ9Yy6kK6aM6fNR3U7ntSic1ijMz	24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	1672	1285	461	12463	16803	jwgvCu237xwZrBnCrFs9toPqrwoYgnJPARDtEDhDPP6VE4Rowi7	12147	17427	17427	1619076131050
24944	3NLmJPB41SkVgj3ELbdQd6Sn8qGNxLBTJdyKU17ZHf9AKpbXNWeR	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1672	1285	462	12463	16804	jx9VSGVHkgp31R7mZDQvbup18V7NRiHfLzA1Wj6fWLFqPM3x3Sa	12162	17427	17427	1619076168040
24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	24940	3NLt9REjwX7NrxexaMRtj6uFJe5FKhiz1jv16q7fqihgqZxDA78a	1405	905	474	12463	16805	jxjCsjkYwSx36NuGugqhzcjW2zhUzb9iuJD2xCeF9u7Ytny8n3j	12381	17428	17428	1619076240000
24946	3NKgJSBwzvSZzFdrDyBaEkMrUe4vEWgJ3uZ5qHd4eKmyk4ZHJHLt	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	152	1330	470	12463	16806	jxeZJX1bK87gM5BMUM4mCxKxbUeso8cYy7s7c9jhHbQVxJrJojq	12310	17429	17429	1619076420000
24947	3NKtrD5pLKQcHvuyZAU9BdVeEB15WCYSyNPR9soKVET2dSzhwVL6	24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	152	1330	474	12463	16807	jx5zTHDE4qp5gsDCFhWPef27HH2UoWY5biiLL1Meb2objBFFZp6	12382	17429	17429	1619076420000
24948	3NLxeVHBGNnCuEwA7bPpHLigrhGhemw5xWL2CYiSPDDSUESCuSQ9	24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	1407	1395	474	12463	16808	jwia682N2YzkB7RPr5sAx1U2Ur2dBKyXwUsDHeEYSdtP2KCKCeU	12382	17429	17429	1619076420000
24949	3NLRquojm4gNM3mehmexh34aQkBFv4qQzDHxTm9VHYiY86qLU1Pi	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	152	1330	471	12463	16809	jwe5w7JhqYegEiFwCPS6kayVjQRuEZRCr3jyDMowGFSbgMX3wjh	12326	17429	17429	1619076457331
24950	3NK7U7hUyUR99CM3ebN89CzSWwoaPemm4taj6riDYFyE5MYnH5LX	24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	152	1330	472	12463	16810	jxiPjJo1nFVfaKFZHujsQvywSX2RpahDfuD946LnrVzekNJ8wph	12340	17429	17429	1619076490992
24951	3NLx1TrG3YpCU1GEW22iBiR34qYMgcGePPxxTDk7MtvPb83CG48t	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	152	1330	473	12463	16811	jxiAxUwC5jUbDAeKzjixDCfxJjP8SafnsYgK2SrWX3s4aZhhDeu	12355	17429	17429	1619076526698
24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	24947	3NKtrD5pLKQcHvuyZAU9BdVeEB15WCYSyNPR9soKVET2dSzhwVL6	1549	1362	474	12463	16812	jxUJqpHabsmfjUouaPerpQH5hd1fnbLhDphhwcunT1pRhVDcAGc	12383	17430	17430	1619076600000
24953	3NLbcEeCxBzJFEX4FjpZq1Ui1buVRQb6SYjtV4L9nzFe6p2QM36G	24936	3NLhNN4iPbEjgT8vKcqyoJ4oC7p18mZ71HLnzjF36wtfhbhvJvZy	1549	1362	474	12463	16813	jwFaHVpEQDDwxJf8r7oDrJN9g68hmfoLLCB8qAAV4VrRA7JzW2R	12370	17430	17430	1619076600000
24954	3NLNxjVmn9kKjHTRPNJc3f3fFiT8ng67mUFYvR7kTzU7gUcQJdjy	24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	1507	1154	474	12463	16814	jxKZwgfDik5y38qkpKhNZ6XhnVVXYXiB3TN3y9nHz6bgLHmjx7e	12384	17431	17431	1619076780000
24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	44	1199	474	12463	16816	jxujHvxvruLJvBGAteT9TxNnZnTJ2PKY4qNmjoF6Wd19Cs1DbaV	12385	17432	17432	1619076960000
24959	3NLC2zbRNGegSxe2qcMaeN1EBQyybPeNdQvjwY8CzemcE7DFaTUo	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1613	983	474	12463	16819	jxVHtmXa3fE3YK6iSoRxWEg1HHJ1TAu7W56fy8jwEQVPuHhGcH7	12386	17433	17433	1619077140000
24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	24965	3NKvM3FrBJNG25ysVD9c5vaNTPDaxhrp3FoLKcQVdQd7X7e9aJgp	1590	1174	474	12463	16825	jwo3LDCL4Zg2sEAtXi62nmrS2iyhhk27ocBtqb31MBLv1Y4vrc4	12390	17440	17440	1619078400000
24972	3NLMDENXLhyNedWwSRfsvqT57w75aisC3C8oQERv3Fm79HhkaGnT	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1623	830	475	12463	16831	jwXupQm1c47TkqT4g7VP2pLr37ADXJmtPfWRN4jnSxZSDGULSKe	12393	17443	17443	1619078940000
24974	3NLddWHgaWENCWqivZmDZUsPgMKjcy3c4vf26jW7jGSLMp9VZE4z	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	1588	1266	475	12463	16833	jxk2jfQDC6E1TyXjqPqdiPi9NEr68jZnvVWn9aBfh2oS9fNCUqY	12394	17445	17445	1619079300000
24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	24976	3NLGzNLWDZXb5yLDq7UYCFYKRoYp4PaUaV1eSXLP27Js1DFs1anc	1406	1393	475	12463	16837	jxysNFHy9DJm1ScpDVnMFa6FWBQ6gnMTYYNirWgn56hLGNUo19y	12396	17447	17447	1619079660000
24983	3NKP4i2ajpQf9tfN4wvzEpZV6VeywNqCtwXnrTctgkpYgpyKejYt	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jwCyHbERUeUT9SAkHKx2g1ttzhUieUTAvtdYrTg7AhfBdnBX72N	12398	17449	17449	1619080020000
24988	3NKxprJ9Re27oBCuARhE4anh1LvY2sX9kPfRSXHQTfUcEKZcW5Un	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	563	993	473	12463	16843	jwfSBJsGuLsmwNqwBNwK3njQ6B94AEjrkz1wvetuRVueG2yQvAm	12360	17452	17452	1619080560000
24989	3NL9WjpfejS3dYioi86VnmPFi4Gvagkq7fvAc9zbHcjRXvqLA4tT	24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	1440	1251	475	12463	16844	jxtVgseFmE4dm3guX8nAqjN3xbpXdirbvEkpL89FTQ86TfSnCkW	12400	17455	17455	1619081100000
24991	3NLQi5QwaTGGu4BN61RX2nmrgs7c5i2nrhmJs5GKJdkP3jpLjNvQ	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1546	1093	475	12463	16845	jxHJmQdBMM6QqLwCmuQGhbccUJjMRBzW52775dnukHHFVzDWAz8	12401	17456	17456	1619081280000
24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1607	1348	475	12463	16846	jwjeHBSnCUTsphz8vzCoZX4BYLq3XpHWZTSUqoYDN8XsFQjdGnQ	12401	17456	17456	1619081280000
24998	3NK6YkVbAs7PvqeejP9NptBfhSWRqKPEdfVMfw6YcqBLfhNyXzK3	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1547	683	475	12463	16850	jxMEN6jtawRhdPsoWavmB9HyXr8PqEtPbKM11LFykMG8jAq8mn8	12402	17458	17458	1619081640000
25003	3NKCNAwqRwgmcCN715gqAjJTNJLHTsgkDULvQJVnbxN4UyzM5VUA	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	484	953	475	12463	16854	jwCgLm8Wv6exU78QR8zTnhaYXTAmFCtp8oPKKxzKY9FRdEqkjW7	12404	17462	17462	1619082360000
25005	3NLuw7anpYWCiduMrBXX3jARsqb4mjgcRvTcqp5bsrUyM2hTmwjo	25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	1594	1326	475	12463	16856	jw7CVwfmrfWo9wQhqgE9Dixi5Uvs1TXL1y9gXAiM5wqMMuZND5s	12405	17464	17464	1619082720000
25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	25009	3NLL5hXMzXLEkpdDnL8UFBCZGtVJPWvCwcbnPyvYz7aXifK4JnhX	1613	1349	475	12463	16861	jwBX7652Vx7QRzWbNszAZ6f1mKhKvqsJHLCh6bZK45Ft4WX5GNy	12408	17467	17467	1619083260000
25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	42	1235	476	12463	16865	jwAmNCoYzVWxp2jYa74CW9324oUnTPFMhB6jEJpfGVyaS293xEA	12411	17470	17470	1619083800000
25021	3NLtxh9S4XpBp2WrSJ3Ay54aQnWuZfDE6SNpjpL8Wu8iTCGPbMn9	25015	3NKExRW2n2E8y6HR8UbSB5s3SWMvYGmxErPKav46SaQfyUuKzdKs	1560	1045	476	12463	16870	jwX2DUnCytsi8e993uNykm8vh3cRC1c8a5Ywz6ddPBYkU7ByD4G	12413	17474	17474	1619084520000
25023	3NL299CtUXVgvwzQshFSLJfQUMVQamghKopULjDjSQGgU1ST8BNT	25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	1407	1395	476	12463	16872	jx95VTYEnHfaQW4JsWSzY5FeJqoB9xZ7N8QsKEXayZTZqx4iqdz	12414	17475	17475	1619084700000
25027	3NLPqGdV74KAGW8v1iNktzBtiJm4a3GmVXh3Q5Pcgj93e1F4ScH7	25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	175	175	476	12463	16876	jy1UUBbA2y3eUCPzKrCeLLfQHuXuf5zfucSCJr2TbTrqTvm6ToQ	12416	17477	17477	1619085060000
25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	25031	3NKHabCTcuRMBisnwMVBp127KU7epkGzGzZq4R9ZYyLMbnHjqQ4Q	1407	1395	476	12463	16882	jwGVvDTqeAjk8bNngxwi9dzSQse7LmV2XRLsGe2G2Cf36NzSBqT	12420	17482	17482	1619085960000
25034	3NKyaf4htGyDVojrntCR9tuYRm9Mtn12bJcn5jeZfKHpjdFWy2YM	25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	1402	874	476	12463	16883	jwQ4i813EeU6ow4wSwmqcDGGJakw8WmCULH6BNAmxLLXUFGRRYW	12421	17483	17483	1619086140000
25038	3NKZhXVtKtU7tSjGzAnk9WT6n7R7mZKgj9uVo3GHCR7P6Vsbcbgo	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1522	1322	473	12463	16887	jxp6z5FENTQYa31LrMtaDi6c8cc4hSC8wRQfzws77g1upbRPkeA	12366	17484	17484	1619086320000
25042	3NLVFGfE2hY7BR3DuZq2ZqagiBHjqDDGnK1HCkUpWSVxGxbxNYNx	25037	3NLaSDanjV96SkESUm8eeJKC4GY2wYdfLRgws2Lwyt9ZFqFK2wN2	152	1330	476	12463	16890	jwvSs1kkCp2jpV9QpY2p4Vaz1FnuxkKgqxeqE7GUX81wJRsmLib	12423	17486	17486	1619086680000
25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	1637	816	476	12463	16893	jxzik1Ugz6L8af4HvmQ2Aab77BBsakriDF6eTUPASBNxY2grC7G	12426	17490	17490	1619087400000
25053	3NLtcFHhjSrmjfMeRc6JccHbsYS5mLW78rqywK4WzpwsEVq6sxh2	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	1474	1329	476	12463	16900	jw9EKiBze7QwHtTeY7xdct6DTAWZ29PqNEJFWcEJiMY99cd8FxE	12431	17495	17495	1619088300000
25055	3NLfbKk9D1JLFqEoJTjtxvj3ejz6sMUAojRXPrrXFdmKerLHXixD	25054	3NLjGnf6qaDhkKms4U5vmC6TcQ235XjDWexRXcN98FjG2KKgbNwp	1407	1395	476	12463	16901	jwTUoe3yqDzjgDYmoH2rNHnt1igA8xqtANEMzqx2DjFxX1vb6Qq	12432	17497	17497	1619088660000
25058	3NLwtqx2F4PZbTW7GQUgq5bAUPgf8WdiYvthSUuyNQc4ytMaDwg5	25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	1506	1373	477	12463	16904	jwMAtFufwQZ3EnJn6omStPGPNPhUMi5YERsrDzuS4kVupFMXp9Z	12435	17502	17502	1619089560000
25065	3NKAXBZ8Jogzg61DZhGmJSKHbW4sHojvNqCWuWk4vFXJgWWnXinF	25064	3NLjpvzepLzS8R1vXds4eTYPK6JSFu9Gk7TXb2apqSuNMN87FY4B	1553	776	477	12463	16910	jwaFE9Z4zuoMHx1wLyuE9qu8RcWD5azbjmB9QMzqiruxnDwDsuH	12439	17506	17506	1619090280000
25068	3NL8cRJMmMdN13qJMcayZ1W4pYSAFZiNEpQXgLwBU1seREmghBEM	25067	3NLSzvAFJfzpaZXj39WPhBHxqbgyptCCgLRY1KWv9pEBrjEQEn8C	1467	1467	477	12463	16913	jwTtFeR7pyVK1oT33c7XMGu4vamkYWcYHVHmfJ1NRLngYJXxdfV	12442	17510	17510	1619091000000
25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1649	1137	477	12463	16922	jxfvBvjyn5wDndHWnetQfPB2X6UmRg8cCwh5fcLVuD3LhsjPT9v	12448	17517	17517	1619092260000
25090	3NKUhVrjL4nhFyw7fJBarqoP9YYnoMmLmxwVGK9DafwC4LBMhgWg	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1670	916	477	12463	16932	jwjApf2JSP21mEuPtj3WzaT2DymAU9dCcsaAw1b1q55tJShhuBh	12455	17529	17529	1619094420000
24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	1445	924	474	12463	16815	jx4TNZLy7aNrQyvVhhqamJKjMhfSAGhPAqZBeexNGghQCJdyoYj	12384	17431	17431	1619076780000
24957	3NKykQVkkiVj5fx1JHMtHdkBEdQt6Ux4S641RdAxFNMvNn3meH8e	24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	1407	1395	474	12463	16817	jxdBHusmTB7JHJiToRB1QzT9bRTBm37fGMGpH1pPefQVcbtsgki	12385	17432	17432	1619076960000
24960	3NLTj2wa3c4Za7jmgzLRfLPpuZs66r7AGVMFnc2LPpfHWkYyGNQ1	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1613	983	474	12463	16819	jx7u8xKvxo4qWg8ie5ahTTiGJzWvfei7GvvV2Lo7Y32LxUNxbDB	12386	17433	17433	1619077140000
24967	3NKjpDFYDJMVXKNYaSKjMHLhbnzqXssQxEr5oDCsehTWEud2aMqk	24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	1406	1393	474	12463	16826	jws5NW6pVSpWyw8FjmHLobmDWr229ehSX62rbohJm5BkgyVYJs4	12391	17441	17441	1619078580000
24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	24967	3NKjpDFYDJMVXKNYaSKjMHLhbnzqXssQxEr5oDCsehTWEud2aMqk	1581	778	475	12463	16828	jwBkGszKXmSK3RYA45c4mGKc1TX6DC4nELoTrpVyMkmrqwHNkMZ	12392	17442	17442	1619078760000
24975	3NLZrVanoPTbZQQsfLNKBcHYPfqYvxvV9zp7WjFN23az2HLE43Hd	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	171	1374	475	12463	16834	jxBMMcuZdmLMAU6kAUh6wVijn5xobAhE33RGWiZq9QWLXVsyxfM	12394	17445	17445	1619079300000
24976	3NLGzNLWDZXb5yLDq7UYCFYKRoYp4PaUaV1eSXLP27Js1DFs1anc	24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	1585	1000	475	12463	16835	jwFEd9KgwbPYh9PioVFz7VAnsskNAGG5skYXSaNQYLCnmjfNrYj	12395	17446	17446	1619079480000
24984	3NLYWBA4263eySAfHa8jhVTcgdPLJqTJKKMieHPpwsKcZHUWaLoX	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jwy36NcWkbBn9qhmeMj7K48sCYadbzVxsmVSiC9qH8NdJf5Gck2	12398	17449	17449	1619080020000
24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	1440	1251	475	12463	16844	jwByc93V5bPTNN1vZsTe27ew8jbQKRoveg92zbSUfy2vtesP4YZ	12400	17455	17455	1619081100000
24995	3NKhUnSxC7uTpRKBywK2DDXGR4qZiqbQV1FijoJPcsBSP3JHHwZb	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	1649	1017	475	12463	16848	jwNGL8ERxWDwE47gifpbnWGNdd6a9hHBkieYWQyK4Nz1EeAhq35	12399	17458	17458	1619081640000
25000	3NLVykyDQZA2q86xuCAyYmRiyjPJYV9KaqJNhbmLmsca4pmf8HfP	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1651	1301	475	12463	16852	jy1yepm9fGAAEk97G6MLP1GdC2xzKN1ufrajZyt3Z57cTbjLRcf	12403	17461	17461	1619082180000
25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	1560	925	475	12463	16857	jwkLDAi5htDE56D93so8Aip1AtPBmauptGMSQW4vEpHdMQaFivG	12405	17464	17464	1619082720000
25011	3NLT29faMWXP1Wv8QbqKuHRojQaEKrVVMCHEing4LwTPXDjx2Ftj	25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	1546	1339	475	12463	16862	jxepSkRqkmBWTg5VReiCE7g1xSTUb7rBhfPh7ukY3K1LAngh9es	12409	17468	17468	1619083440000
25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	25011	3NLT29faMWXP1Wv8QbqKuHRojQaEKrVVMCHEing4LwTPXDjx2Ftj	1623	830	475	12463	16863	jxnuSiWzeGnRBSD1JEVksczJ2vt9kxPdTBKUgXr3ddU5usGVdt3	12410	17469	17469	1619083620000
25016	3NLVXBJbJpiKZ2cCEeGFD5nUzZogYEM4cdAVHcUAtrpwH7yL9LA5	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	369	1186	476	12463	16867	jweNwMAoBsR91NXTftjWrsUE6pMmXPkKuAqKvDgHrD2Qydqa778	12412	17471	17471	1619083980000
25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	1439	1279	476	12463	16869	jxD8nXbSZUctaqndWtQhZ9yCGPhCsZfsF3q3jXyY1yJYWGYeaq5	12413	17474	17474	1619084520000
25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	1601	1388	476	12463	16871	jwttX3UrohiabmpqYJ1fHmAX1oNWbNsbZgBaCKcXCBB6Ung1tbF	12414	17475	17475	1619084700000
25024	3NKQ4W17KbbsaV68VUYdzQvmxRtswGuWaoSfPv8xgPXwbg5f5MXb	25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	1671	1119	476	12463	16873	jx114ZMuGHQFL1H8AfsVHxU4J2oCA2SwGzR9ptiFiV36SE7eVob	12415	17476	17476	1619084880000
25030	3NKwBtR3FYNZEtPEXUpDb1tJq8FTTkCV5foe3EoP2vBHPCLmK9Ko	25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	1587	1357	476	12463	16879	jx3ctaHhNWWf5c1pTUN8YqXdcGgAGjoAzFsZyeW364LQfvQRk3N	12418	17480	17480	1619085600000
25031	3NKHabCTcuRMBisnwMVBp127KU7epkGzGzZq4R9ZYyLMbnHjqQ4Q	25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	1631	794	476	12463	16880	jxrKYZ5wixMkT1DC3KXnm3H4YZdjEHRFeyc9myHF8idzLdXGH2C	12419	17481	17481	1619085780000
25036	3NLVG94QTD983cu7E1aehqfTrvqFw1g6A9dup2FwJ9kLf1YiTNSp	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1522	1322	476	12463	16885	jwEsL8JBguwbWH3Z59y3Fv9JCKPF5jkWuBcKoK2jvQKavsDEnz6	12422	17484	17484	1619086320000
25040	3NLR9Jfqy5nF53NMeyQRzTnfQUCG5eA1BWMnBH884ozqkYYygUpM	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1578	1050	476	12463	16889	jwScaabX3beXMCUSMkKDhe1ux1wRQmUVwEkqHUBQ3Zx4tJtg8zC	12422	17484	17484	1619086320000
25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	25043	3NLBoZJv9vNdTKVoafDs9P7XQaRZb44L5q5xLBSfg6xi8Y9YCgMu	1594	1080	476	12463	16892	jy1mz6BW8gyyLxYS1yaizq4yr7MoFWEGd33HujSjxxkbSmwWZUV	12425	17489	17489	1619087220000
25047	3NKSB2U8F7NmMHgRz8CTG5JVDesvya3Me9d7Pb64SKC6v1dUx4Sy	25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	1637	816	476	12463	16895	jwisgdrtUiofUrGQCZokeYwGkneziFTs6735GF1oVENeW5NRLXQ	12427	17491	17491	1619087580000
25049	3NLedQZYhyNEFiFKidrNYNDBaR6BRkokur5rhf4TreWCdSAchUTY	25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	1590	1174	476	12463	16897	jwZF2tUFB5zzKY4d6HzicfmftJWujE4jQcLhjh9AtsrY9J7NR4J	12429	17493	17493	1619087940000
25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	25049	3NLedQZYhyNEFiFKidrNYNDBaR6BRkokur5rhf4TreWCdSAchUTY	1507	1154	476	12463	16898	jxKvUKrHaWpzfmGAY7t3V8nWtUmfCpLkX3tWnZ645sfJusjcQ4e	12430	17494	17494	1619088120000
25054	3NLjGnf6qaDhkKms4U5vmC6TcQ235XjDWexRXcN98FjG2KKgbNwp	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	1474	1329	476	12463	16900	jwFVmsvSivcoAkDCoyDt89PjehosKvzXYpHYBTABbaw8GPNhwg8	12431	17495	17495	1619088300000
25064	3NLjpvzepLzS8R1vXds4eTYPK6JSFu9Gk7TXb2apqSuNMN87FY4B	25063	3NLaQymgKM5SQKwDbZ5BSCRMGvcaJpzhNMEaxSHZrCQne62ygDun	1501	1360	477	12463	16909	jwcc92DWBZkEMMj7XzwnQdGi48xWsdcHs72AfAYKQoPQJEQAV1d	12438	17505	17505	1619090100000
25072	3NKWvDFUgVAmu64v56z9SsAnBJ1WpGW3fVwk5D9B9vopQEBKdzkt	25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	1406	1393	477	12463	16916	jwSZqrgWjBKcDaxetDdZXySqYb7Aj4PsLieVPVh6hSVjjabEXNt	12445	17514	17514	1619091720000
25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	563	563	477	12463	16919	jxXu7iDVFcMjC58euvY7Fs4tTGABdXah8qYNEkCu76Dc6yit9Vb	12446	17515	17515	1619091900000
25077	3NLnF7SoCtvLCwn8c3UgbFTAZSBzEW5YUvg5o1uTREwtJrZX7YZt	25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	1600	1006	477	12463	16921	jxGL4aY1g5zpGz3NFKufETbwAQBhwaR8mEj9ABKDCAbbrhuU9nf	12447	17516	17516	1619092080000
25080	3NLvdm7sA7qEyf8t3a5ddPQb8LjEojuLf3HxE5jkAQssgfuTKYhs	25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	1536	947	477	12463	16923	jxVjdou9qxzMhRW7WZ3jCyHGefUxPBNpWR1MYyCJRieNKZC4vkW	12449	17519	17519	1619092620000
24958	3NLotkP6tmL7rTc8wmPTpVBdMa75MucUchAjBzjBA5noCzm9bJbr	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1467	1376	474	12463	16818	jwFMqYMTGUiqoXzDkxWwDJeHs18KaLWEaAqVmjDDWvC4JVJ7eNR	12386	17433	17433	1619077140000
24963	3NLaqwi4n2FBiRDkS4mb4QmDL5uA9x8jSm4jh5GEbZjWc1cwr5iX	24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	1407	1395	474	12463	16822	jwuQaH6mG8ZQVQEC2Vxc8W3vZj3rVyTuQRBtFJohY6xBEXgb1VK	12387	17435	17435	1619077500000
24965	3NKvM3FrBJNG25ysVD9c5vaNTPDaxhrp3FoLKcQVdQd7X7e9aJgp	24964	3NLf5pYHeBAwid1uo2RjviiHuz7TZJRc594tSrv1Xt5Z565XoeW5	1403	824	474	12463	16824	jxsP6LwprGhVfb1vx3AN1e7EvZ6KxiGeEHHZjspHenqAJJY3uWZ	12389	17437	17437	1619077860000
24971	3NLRP2kuf2Tp774P8gkFmHrnTRMSjuBpLy6ETXeGR6og5kk5pnix	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1534	1191	475	12463	16830	jx5dqou5SqX1sjazfGKEinESfJcKYC5n3N8KUEptisirbKLcxrS	12393	17443	17443	1619078940000
24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	298	1182	475	12463	16832	jwKRttevvR7W9dxpt5MLQFYvN7GUPYyZhysLUCweQT4G8UuTQE9	12394	17445	17445	1619079300000
24980	3NK7PCnAcbGCHbKHkakZMPo8Zv6ZYLhgYu4gPtygMh3Q9EUzRCqf	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jx4deaDgJkE82R9eCUh4NoZz8d4GFiXaDTerhyrb3WCd2qyzZot	12397	17448	17448	1619079840000
24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1405	873	475	12463	16839	jwK33hJkCKfKmzrQDSHNgpLqstSMGmF61tsqd4WaUxvkLi5zFuk	12398	17449	17449	1619080020000
24987	3NLRAWu3yBbXuMmb83disK6uFC2NoLqB75cNeMKJQ9NMLTwDPHux	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	563	993	475	12463	16842	jxhVaLLrVQRSSiPLaZjErPiYP2qouTiN6vFknAbL9dzwhjwZV5G	12399	17452	17452	1619080560000
24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1547	683	475	12463	16850	jxEjAzctRXP1YVYQ7BzbRwyC2sK7S6FXLgn1Ngwggwyw1ivBxvb	12402	17458	17458	1619081640000
25001	3NLhdwXWKZuirrqYyjZiUDTsAV8WqYYzwrkmmkZkxB1Rv8qZeWrM	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1651	1301	475	12463	16852	jxbb4MLW5Jn1Tji1zgM32hg6QtXokhhH7Kn4j5Y8uSVQWeqdfDZ	12403	17461	17461	1619082180000
25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	1571	1209	475	12463	16853	jwaczTGvGmCDu42fLVTA8mbJ7PZZMiGoJsrvm6CANR8La8Re3SN	12404	17462	17462	1619082360000
25007	3NKf945CKX92yxZguiyKX5FxrF8uA92KEFq52CQM26AWSkp56vtg	25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	1546	1093	475	12463	16858	jxaC3jcQ8n7p53LuaR56FtiU7khGFTLnLFb9WLsMLTLe8kFGuAP	12406	17465	17465	1619082900000
25009	3NLL5hXMzXLEkpdDnL8UFBCZGtVJPWvCwcbnPyvYz7aXifK4JnhX	25008	3NLuNJyKXhWLAV341tVnPHLb5ViwG9F1my5ayzMYXzES2GUbXGyY	1483	1030	475	12463	16860	jwLFiX9CduVjsj8NE92sEoRQQB5KjMT4CbKef4mcTbhcJLN3nq9	12407	17466	17466	1619083080000
25013	3NLVELLQfiTm4QYN9BRXwgFP4QAUwxCbTeNsouSCr7Sgo8DoSzXS	25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	1406	1393	476	12463	16864	jxCCwaWxETjqR11yyuEtkLxsgaYcVLy1Mh6hogin2Bxyhwd6jhX	12411	17470	17470	1619083800000
25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1609	1333	476	12463	16866	jxp6LPcchFveJNAqa1YpTfq1c7JKu6qMZTjzvviM8XTffvQL7E7	12412	17471	17471	1619083980000
25018	3NKcjkg5AoxNP5493hgRqbtLHvin867to6YRtKYeEEzCMZ9k3ov7	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1597	274	476	12463	16868	jx2b9Hor9xUZ4SJpSCD9y5AVmCTvHzMs1nm5puHwysCHrCRkzZh	12412	17474	17474	1619084520000
25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	1406	1393	476	12463	16874	jx8APFmv4MUBZDyZ99qwsjsTp4G9cpihrnouwxY2UqnfoVhrX4S	12415	17476	17476	1619084880000
25026	3NLNqPSqHaSEwjCeGvg8JNNK8ByFRobjebQax4ejW2J5AbYq8HZK	25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	1403	824	476	12463	16875	jxW8NrhGJVX7ru5tEe11zW5e4LdsCCTWHsPwt335aCm6wbsgQQs	12416	17477	17477	1619085060000
25032	3NKJ5NrthAggx5JrQdNPG8125SkCEGoauCFzhHbDbLrakEYHZYhF	25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	1650	1129	476	12463	16881	jx63KZ2DyUTgXVJdQj7pr6Jv321FfWcbFtGPPqAeaYxRVjoX7WV	12419	17481	17481	1619085780000
25037	3NLaSDanjV96SkESUm8eeJKC4GY2wYdfLRgws2Lwyt9ZFqFK2wN2	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1406	1393	476	12463	16886	jxipCTeTTbRTbnUR6QPtcAU6WUdofVtiCiXjJGuyCz9mHBRocYT	12422	17484	17484	1619086320000
25041	3NLGVzfVJVGGj8KFrV3AJwMrrCfrW4kYDM3Pp3kxav2A9ZGqsPao	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1578	1050	476	12463	16889	jwXTG34TcrzEmfUmhup7aLBdoAB8qGGrqzH1cwRpEkvhpaMta9b	12422	17484	17484	1619086320000
25050	3NKnf6GgBpUa4cmgftve1bzVq59aZSFfBmcdAtdLnjxDS2LiY1AR	25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	1590	1174	476	12463	16897	jxrEfR6i33EPmWyrZAzQDF36m6TvFGVV159RXdnyfFsGGoo9DJV	12429	17493	17493	1619087940000
25052	3NLZ6mF8kz4DvWFCvNH8SL1J1AckQacsUphGXs1iXDZoXEHPgDVj	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	43	1310	476	12463	16899	jwx7ZWSvrvBQ16oCbvE7NSWVWHC3iN8W8JbQWN994591e3QYcsh	12431	17495	17495	1619088300000
25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	25056	3NLqRCW5neugttzPBnSEc7wy9PDL2z9fC4up1MhLuenV9B2tUyPk	596	1306	476	12463	16903	jx3uZwR4Ja89fVZaXoJBRQPVj2B2hgnhHbANWm5vpewcZP5qo38	12434	17501	17501	1619089380000
25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	1447	1219	477	12463	16905	jwi7UBNYR4MeoZfmM5iNQhbiG81hiLmSLjDsoYEDdMVYtLxQgNW	12436	17503	17503	1619089740000
25062	3NLYSTiSyegYV1Jt8qteFcbfQHH1dLeq7GDxbpSp9eqfWskdySSc	25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	1596	1117	477	12463	16907	jwPkFFrSZ8cecKjePeLYVQs3D4Qv97V3cSK2xDCdFXmTpXg5bKa	12437	17504	17504	1619089920000
25067	3NLSzvAFJfzpaZXj39WPhBHxqbgyptCCgLRY1KWv9pEBrjEQEn8C	25066	3NL5jg19s45F5QoyaSTZUSvHSZbY9siFs7imu2GRziLprDYhJ3rB	1406	1393	477	12463	16912	jx4oycrGPdceoF8QKV2FsbtXCzexgW16GZhudK6e8bD7ChaVniJ	12441	17508	17508	1619090640000
25070	3NLtvXdRKEvpSzBvbBosEb5iSB61jfSxwyEyN1JxoW4YTV56t2fB	25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	1500	1297	477	12463	16915	jwdKDdDCVhmN6XF9bmzCsmKpGjihh9GU9JpnVQiDShjQowv6JCj	12444	17513	17513	1619091540000
25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	1500	1297	477	12463	16915	jwnBmVykRVE8PiAaqNWuv4NaJgcfWdJFRtChS5NDqp73A5bX4du	12444	17513	17513	1619091540000
25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	1516	1168	477	12463	16917	jwu4svwWN4E3HynquokiJQhzQWALGyh3f2SKfyT1HQfFqZVTo8n	12445	17514	17514	1619091720000
25085	3NL3n9Me4KK7xMoySKAaSXzkQrm4e3fXkxg3Z7kup9JhK32Cu9b2	25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	1501	994	477	12463	16928	jx2yFErYsgfJgSSoSDZ8nz88BJXbiMEzJWAyLCmQ37Bb8G5P3iX	12452	17525	17525	1619093700000
25088	3NL9VgC8nwVL6ZvHXeYbPy1hPzFbEipbV16jVkh696o8GBp1KTXZ	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1596	1117	477	12463	16931	jxzhK5fyoGBJATbgiEHAn4sPkP2weErNStggATQi1sYytZtdkh1	12454	17528	17528	1619094240000
24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1647	845	474	12463	16820	jx5xPAmoLJ2W1SJKMtrZ14Rf3nzTTFq5XxkbuXGWzszqCyZzuPV	12386	17433	17433	1619077140000
24962	3NLQekP9G35FuA2E7pavLasyMtrBh6fccrQxazXfC6FLzovMekKK	24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	1447	979	474	12463	16821	jwQFQZBmUSFu7ZjZZmFzxiswpeGLCkXapXJmGj4SR5A9wRzhdLA	12387	17435	17435	1619077500000
24964	3NLf5pYHeBAwid1uo2RjviiHuz7TZJRc594tSrv1Xt5Z565XoeW5	24962	3NLQekP9G35FuA2E7pavLasyMtrBh6fccrQxazXfC6FLzovMekKK	1564	1338	474	12463	16823	jxMTyVDEeaHttqZupfXmSpSJsXYPJEsv7PEe7WM2pFdXv8dod2Y	12388	17436	17436	1619077680000
24968	3NLhSvnF7Deeuq475zhhoWtYhRrjVmyUymRYaPHy9CVjjBsWkPbZ	24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	311	1307	474	12463	16827	jwybvPLoUTEKeEwfb5NEjNwRS5XP9uzHYdR69YNiDPmaGZQB2KY	12391	17441	17441	1619078580000
24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1608	923	475	12463	16829	jwXSyrTBVs9v6XwECSgnz1VyGB9o7a8qJbNJ7px4eSx8sdxzCmz	12393	17443	17443	1619078940000
24977	3NL63CzNadaYyDCdwdypucSmsCCPSZk86hrRheh24d6qJuizHwuv	24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	171	1008	475	12463	16836	jwwX8Q7AKnAWWFP9WuctwkxtAmyLVxHm8RYiTAfXSUaJSYNG59J	12395	17446	17446	1619079480000
24979	3NLNnWrQrnvsh8kqQAetDbhF6pmGPbPcLFrfTSjEPKxJk5UEKwg6	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jwezTmcaiKPhxybyRZpQkng1FJpjN8SWeY1yXtJC16g71mcys2Q	12397	17448	17448	1619079840000
24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jxBN8G6MwbfJohBrg28KMo3t2jQhNtLoA4oy1Z3zr29ReVzgZjZ	12397	17448	17448	1619079840000
24985	3NKKM8GNCzZqrwxG8KatGCyDnBobRaLFc3wvVVA5Y194nj8CFDxy	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jxCbAhNd3V7JbwD6wcN7JENHdsxMTa9BL2rhH1feWyKsWRoHeKb	12398	17449	17449	1619080020000
24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	1405	875	475	12463	16841	jwC5Zhnvz62Cv8MYSqR4nDsE8iixXMMns8hw1iXGDEQ5tioqC3M	12399	17452	17452	1619080560000
24992	3NL2cwNPtJamUatMmZW56iCf8TJCc6FMMuHYrv7azZG9k6fq7NWJ	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1607	1348	475	12463	16846	jwcr3KFJMx3rsJW9hofXU7zVVD5dzrZhCkV84AK6pDX3mTV9cs1	12401	17456	17456	1619081280000
24994	3NLLCSTvLT8oUEM3GeZNrJNqXJWdzj1aLMNonFuYjJ9S96U6UZi3	24810	3NLGHoZU7DGb2XiJ1NWZkvwhvgXX2pFJfkfs4vyrdYsERJ8rfrPy	1649	1017	466	12463	16847	jwGn9CEypCZ5WxzpfMLGiCUSsbDSpCRcqq1CNNxb3F2FpWP18Ft	12262	17458	17458	1619081640000
24996	3NKWjJybbkaHFBm18XEQrY4s4qsLtsdnrUQZ2C7zVFGLH8ViTEJA	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1649	1017	475	12463	16849	jwoJCR4jFSXsS3BNkuQ262Nvtxw38ExADBGn3ADDgww9KY35jzf	12402	17458	17458	1619081640000
24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1588	1392	475	12463	16851	jweuJ9oT6R9sQvjUg8GNT1CbYY8eWagWrk6wTq1VbsqKTdzDYQV	12403	17461	17461	1619082180000
25004	3NKi2NmHBfwiQdnK42qyULF161cPG5AXTtyx3g7V6D6JwhUsgfzH	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	1657	79	475	12463	16855	jwVppGGnusrzkSDpwEWSavTzqR3auDLJ95QSZkNaEBxMYM2FMYH	12404	17462	17462	1619082360000
25008	3NLuNJyKXhWLAV341tVnPHLb5ViwG9F1my5ayzMYXzES2GUbXGyY	25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	1675	1216	475	12463	16859	jxp6Jxjk11397pp97Qm5W5GsfeeexQfxX9Srn1Y99enEKdrVeqZ	12406	17465	17465	1619082900000
25015	3NKExRW2n2E8y6HR8UbSB5s3SWMvYGmxErPKav46SaQfyUuKzdKs	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1609	1333	476	12463	16866	jwoMq36sehDvRrSaBaMyjtW3YU5xfUsBDQ37sxzQbWgGppdKEpT	12412	17471	17471	1619083980000
25020	3NLi4udPcGnu4hi4GHrRc7gE9EeganxtSZ2RFqodtfWcQi9npeq8	25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	1560	1045	476	12463	16870	jwz4Qj1kcoTjMbVRhxAENrPdTpoSxXoAuNoi4awBEJZg3qHQxYP	12413	17474	17474	1619084520000
25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	25027	3NLPqGdV74KAGW8v1iNktzBtiJm4a3GmVXh3Q5Pcgj93e1F4ScH7	1402	874	476	12463	16877	jwXThwpCTVVbjksfx5HCyoVQf5g66Don4oQoeDEckFAmx2dEJUR	12417	17478	17478	1619085240000
25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	1406	1393	476	12463	16878	jwoRZZpzBrYTMuDyoinBgVNq3ZZEDU65PEFeL8uqTRKgPsxhtQT	12418	17480	17480	1619085600000
25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	1471	1386	476	12463	16884	jwdbQFPEUMZHA9cw9HfeY4AVoAE63RLGUbPRFcSpJFK7DqiYpcs	12421	17483	17483	1619086140000
25039	3NK62VmM3T5jExPSdhkgNQL6yCCA1bBwbmW6PrHXCD8MgZH6MNHN	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1451	1046	476	12463	16888	jwwRDL7s7bsAQ8YMVGz8bz6m7NooVLJUe3JwhRpoCy3PcdXxNdj	12422	17484	17484	1619086320000
25043	3NLBoZJv9vNdTKVoafDs9P7XQaRZb44L5q5xLBSfg6xi8Y9YCgMu	25042	3NLVFGfE2hY7BR3DuZq2ZqagiBHjqDDGnK1HCkUpWSVxGxbxNYNx	1457	1391	476	12463	16891	jxKTPRB5YNFqpnVn7PASmjo9fFQi4CbwEodDqrHN5MeXzmFd4He	12424	17488	17488	1619087040000
25046	3NKx3xdqiU3MfJjpKWLvJoVQjQEjG3PwKRfxYHci1YZSjjFW2JTF	25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	1634	1085	476	12463	16894	jwaWocGvSPnaBtpTtJ69jEJ8BaYSBb5Azu9Z5KJuEyfx56fkX5P	12427	17491	17491	1619087580000
25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	25047	3NKSB2U8F7NmMHgRz8CTG5JVDesvya3Me9d7Pb64SKC6v1dUx4Sy	171	1128	476	12463	16896	jwLXnmiGMeU6zC3UjwpzAUtYezs2rhhwg9GeTmYn8PAiryNZ138	12428	17492	17492	1619087760000
25056	3NLqRCW5neugttzPBnSEc7wy9PDL2z9fC4up1MhLuenV9B2tUyPk	25055	3NLfbKk9D1JLFqEoJTjtxvj3ejz6sMUAojRXPrrXFdmKerLHXixD	1403	786	476	12463	16902	jxXxKPWJVPCZSDe2SbxSbVadfSZi5SgN9XJEJhNtAuKLBCkUjb6	12433	17500	17500	1619089200000
25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	1506	1373	477	12463	16904	jxGDAZN2fWrGH8oZJ7atiDzVbinnDMdD82t4zz89jZyBGm3Jbjo	12435	17502	17502	1619089560000
25061	3NLNg3W2Aa8Y7pCoH9yKPkiCgTU7teYUvN2GAJ1xaLFAQjGevgbG	25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	1637	816	477	12463	16906	jwXAqCHTwPbxhSZPo3n2CEkVtdqNkoBEzJebegS6ofSP9iv2ZSW	12436	17503	17503	1619089740000
25063	3NLaQymgKM5SQKwDbZ5BSCRMGvcaJpzhNMEaxSHZrCQne62ygDun	25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	1581	778	477	12463	16908	jwkE6UCj96Tu4NxDoqSoN7XxRKY3NSDWdm7JeV7BezF8tnXRZyk	12437	17504	17504	1619089920000
25066	3NL5jg19s45F5QoyaSTZUSvHSZbY9siFs7imu2GRziLprDYhJ3rB	25065	3NKAXBZ8Jogzg61DZhGmJSKHbW4sHojvNqCWuWk4vFXJgWWnXinF	1553	776	477	12463	16911	jxF3811vbhTffKkZnVYv2KZm15TxSCPTBScw1HZMCnEDCvbNJwo	12440	17507	17507	1619090460000
25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	25068	3NL8cRJMmMdN13qJMcayZ1W4pYSAFZiNEpQXgLwBU1seREmghBEM	532	1303	477	12463	16914	jwP1exf1Ds5mXLG78GxZFQcqserkG2qfQeMMXKB963naUXaoogq	12443	17511	17511	1619091180000
25074	3NKEjt11rpCopeKbpJPaCb1WmWnGFDVbLpKmwdMbxN2U85j2eu1w	25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	1516	1294	477	12463	16918	jwU7iiuK2xXzxXjPXksfyY7n3SApNe4HvZ4qdF6xktB5WSb7Yse	12446	17515	17515	1619091900000
25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	1536	1067	477	12463	16920	jwri2zeXQEKroFKFbqZ4bmMKrxmRL2U1ri4NXbyuohyJauhUFCr	12447	17516	17516	1619092080000
25079	3NLLAmBg5AED328gv1aZy1VSDYkUetKA8ykDjHEiKRaSziWm7h6A	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1649	1137	477	12463	16922	jxnm5DyVY1At6QKpw5XzjXytVUnJwdEtczzpNN3zZqCxd3Ekzik	12448	17517	17517	1619092260000
25082	3NKd32HyRiGmoJLVefTYV69HsCQsaSmzV5SAeZKaDf1wiwXj5zvU	25081	3NKETd15uP5Ke57PP9GRbtY9HUaUwqTH3ixCSZZNgA47vBH1Ny24	1633	1144	477	12463	16925	jwmv3GNkrynMghAxfDY2BCSMa7HMo8Tme45M7W7PaEpTXfnXuBK	12450	17520	17520	1619092800000
25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	25082	3NKd32HyRiGmoJLVefTYV69HsCQsaSmzV5SAeZKaDf1wiwXj5zvU	1549	1362	477	12463	16926	jxNp8unJjeRrTooVBNHvf7MFMMVBJ6sLtCJE2XFSMkhLiRt1VnE	12451	17521	17521	1619092980000
25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	25084	3NLY7XHNHSaxJGTBavW1FaZNeNuBwyAgPXjBmzvhpdVPFuoR4KwZ	1539	325	477	12463	16929	jwFUCa4hQgYabuL2L6NKSmgGTHBYYTXcMwWzPk9NY8XL2uh63Z4	12453	17526	17526	1619093880000
25091	3NLEuY8xhseZxncdxTV3x2YWE8Fr8AC3eschysyQRXVYrFwm4hUt	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1534	1071	478	12463	16933	jwN5LdjdrV8L1QDtcH7MhyyZsPErp6jCnZmaugMZmDRRTZLspgM	12455	17529	17529	1619094420000
25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	25087	3NKJ6jVB6YoqDJTN4SVZSKrMwW7wUbTmwjcLUpBtFi8H9kMs24cX	1534	1071	478	12463	16933	jwN5LdjdrV8L1QDtcH7MhyyZsPErp6jCnZmaugMZmDRRTZLspgM	12455	17529	17529	1619094420000
25095	3NL2FrWm1M3Ys7RHw7SkSeK6nZtj6GQkhQWdfsSCzSLtFHU19okV	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	1541	1298	478	12463	16935	jxaREmYqD1jq2kQf8XwvftkpsuP7H2bEq8H5xq4grF2H5AWXAU4	12456	17530	17530	1619094600000
25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	25091	3NLEuY8xhseZxncdxTV3x2YWE8Fr8AC3eschysyQRXVYrFwm4hUt	1541	1298	478	12463	16935	jxLdKzLbPCAyqeWDixfEAiRi4DSHhczNt4DA7rGHYLjrY2QJ9kV	12456	17530	17530	1619094600000
25100	3NKFhAtdSb29X1B7DBrfGXmWHNxn62gkaGZ7uHjkm36N4yYqxuAX	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1402	862	478	12463	16938	jx2Bd4J53sKkhHgiEKvwPqmJvvXWmAvskgdCEN38n3Ek6mcah8w	12457	17531	17531	1619094780000
25108	3NLu2d1HryoHM1FdRdxcbJGL7ncbzhdrLBYKYTDG2TgcsDSt2Xee	25106	3NLX59VxVJhRp1vHDKvEmFg9HnLYfYeHuQqVAh1TwsRMtts1nyKY	1407	1395	478	12463	16944	jwd3o5qE1CYDVRBSy6jzUnaX5Pb6qAxoXsSifzxpj53PLvRUwWt	12458	17534	17534	1619095320000
25113	3NLpoM7LbXpFbdrp7veTkCLuUdhb62XMkKnQYbcMfRemFjf8Fm5e	25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	1402	858	478	12463	16949	jwBoPgvQSibQMDtvN7NoFhTGa7ZaaUxc5KHpJq4VHqP3gMP6ZEp	12462	17538	17538	1619096040000
25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1571	1335	478	12463	16952	jx6K1L1837u95tZJ8U4GzH3SAyq3sBD24ckXWmTFNxFpiRY4kAF	12464	17541	17541	1619096580000
25118	3NKZ6r27rcHqfeFHQoFNdqpNLDpBcaWJBPnYB2NDNdboVG7aXiHZ	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1407	1395	478	12463	16954	jxfHBxT5XSrXHYWcrNz2JxmXurTybYdpi8RbnZNXnNvWjbKbxuG	12464	17541	17541	1619096580000
25121	3NLca32nZyoio1tEzKyzCuSatHGG4QxEP4kQRFEvr2oQ8qrfoPnA	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1406	1393	478	12463	16957	jxGKPV12XiNUN7m1Lbk3F7zNz98W7VogYB8xsNcfXDdtUWvpMhB	12465	17542	17542	1619096760000
25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	25127	3NKkZsyBCvWKxSeb2QSH9HbsN9kGAXjRthkejWtR74dMJqQnsR8n	1406	1393	478	12463	16964	jwPoQNt9syE6dLMrQhjac7Xk2Q1QZBYgZcF8ySTS8fFbEHRv9AJ	12469	17546	17546	1619097480000
25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwqhS8cCyfzqKZBMSXMsAeTEFTNjoMyevxyWWFdDX3w4V1CojGP	12471	17549	17549	1619098020000
25135	3NKtKxgZCWoSpUn29bDnUjyV3Ff74mEJnN6VAe2bBEKsJUVrQQji	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwhCk2SEWQ5uRGcMnq889SS1cV28DugCJWQHbKP3mi7XzqK7LYL	12471	17549	17549	1619098020000
25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1507	1280	478	12463	16971	jwXmXzrAZQyh3Ho1DYLkdVQDhXm44D2JdmTMYL26Bptwq4D44iG	12472	17550	17550	1619098200000
25139	3NKBbr6ytGoQ1m24XkTmNe88nwFEaaU5F6AmiAz8PFZ8b4meVs2Z	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1654	1094	478	12463	16973	jxbXVBB7sYzuh1AUH63Z9vnutmA2cHNueU9k646fCWX89g5mzYE	12473	17551	17551	1619098380000
25144	3NLZ9dFKjFuhy1yoDkCkLgnRK85FSbd3nJ9ccao4Rqye1RUKPaFY	25142	3NL2M2D3xmmFNF5dpMoT6GLuHVrPeMUwtK4L8nFTx7N65fMJb4pH	1407	1395	478	12463	16977	jx4Gg9tgjFpei77WRz4mWKDCE4qXTe56PAHue34cmqGSt8Ar8X3	12475	17553	17553	1619098740000
25146	3NKLKfH6jD8nXWC1Vd65F66fRztZ8S5eR69UzKUxrCR9o2cwQrsw	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1588	1392	478	12463	16979	jxSSTxeEqnWknLTgcVyPv2KYbugQs2j715JyRmxVJZpjmrcPyrm	12477	17555	17555	1619099100000
25162	3NKzxgegV8RH8PXMEs2QVHfdDs44N3Y9nmSGcTB6SDEicahUTU49	25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	1407	1395	479	12463	16993	jxhY94UKZBdu4DvUP9zZEN1ifF2nZpZp6yghCdDNvd3eCMbvNS5	12483	17561	17561	1619100180000
25164	3NKGKgzzgT6w83kqqS9r7yX25WMVgWWQRCmbZGam2BSomiu1cexW	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jwLmeCaqP2HjLoJS7CaoSrD1YTwVyUTSCDJWHHb5hqF82Qb74cA	12484	17562	17562	1619100360000
25166	3NLh6v7xgiqHM5xbvqopHPYaNAok6rHeQ3vwB43sggrFqKFzj88h	25160	3NLjvrxKBtMSjraCRgSnKNkYMEsR9FYxWDqX3HSZefpCkbz2N5Hn	1637	816	479	12463	16995	jwDwqTJg755DweQHx71cR6AaQgG1JF7E6zagjetJ1YhTCyTgFts	12470	17562	17562	1619100360000
25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	25172	3NKTE4MViCYeTEeiQFtSi8vV7RWRBLJJ25nay5XT8GwcAgF6WmvN	1406	1393	479	12463	17001	jxY3KJApw51onQVcfLYFGhzESNyA7Di5gXFpJPEWSVSbYFZxMcH	12488	17566	17566	1619101080000
25176	3NL8AG8ExrKzAXLazeE8hgt4DbTVAhS7d1cV6e3v5HEUG7j6bCyc	25175	3NKYZ18zaCU2YHhsbZ98djhXtoE4TL7218iEsRC3sAZrgNz2dGM6	43	1310	479	12463	17004	jwpaDHj928yJGV6r8t1Spr31AwXkk8gGkyosRjDMexUB9hb31b7	12491	17569	17569	1619101620000
25181	3NLiT6EAwDm4YGmnTf3vz7bsnxkVtsmjnZHHbQUGh3vBcftvYUrL	25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	1553	776	475	12463	17009	jwuW6qGwJZXLa8oXymQddUJRoEJVHqc8at1Z6Taz6JzfT9UU23M	12409	17573	17573	1619102394887
25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1406	1393	479	12463	17018	jwRTPaf6DJwB71o3u6tPyT5xV6YUiDN8fxfRJ6HGA5pFfRb8bUY	12497	17577	17577	1619103060000
25194	3NKk8im95ZRM1GwaYuUe5Xf4JWcAefJ46nLEGBtJC8R641ZmNmG3	25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	1500	1709	480	12463	17019	jwqEyaWGmqX7xHbprscAE66CoQwpzzSGZUiQejQdwyvzhkyTz8h	12498	17578	17578	1619103240000
25198	3NKXAiTirb7pNUf7Kmbi8AeRuEAbq2bDaAFtBayXfQ8wyCASnz3H	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	1564	1092	480	12463	17023	jwY7vRBQ57uqRu9xZNT6PmEjhPrx8jePuVeN7njvk2vfWopbW5q	12500	17581	17581	1619103780000
25200	3NK9ku42NcsFFTE7m9zLARvzTvEE2BkESj7gPtebbQUHuVmFLeyN	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	470	1309	478	12463	17025	jxA297HYhq9LpujCnYHsCdMMoXLBC7rrePMwm4gQYb5Qf4eKwEQ	12455	17581	17581	1619103780000
25081	3NKETd15uP5Ke57PP9GRbtY9HUaUwqTH3ixCSZZNgA47vBH1Ny24	25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	1513	1133	477	12463	16924	jxCvswS4DRjzkau8aNJQSR9fYwjXMjdQgPrAGkJwzQw3dMx9B7W	12449	17519	17519	1619092620000
25084	3NLY7XHNHSaxJGTBavW1FaZNeNuBwyAgPXjBmzvhpdVPFuoR4KwZ	25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	58	149	477	12463	16927	jwifNhhGNovumNRVV57DFHiTdZY4MzMrFgPt8WW928sLmvtkCUa	12452	17525	17525	1619093700000
25087	3NKJ6jVB6YoqDJTN4SVZSKrMwW7wUbTmwjcLUpBtFi8H9kMs24cX	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1542	1058	477	12463	16930	jx1SZVVj4bZstWLMFJJb8RDiosyYpQAiPSVS9ZbW5fkKw5Kkogw	12454	17528	17528	1619094240000
25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1542	1058	477	12463	16930	jx1SZVVj4bZstWLMFJJb8RDiosyYpQAiPSVS9ZbW5fkKw5Kkogw	12454	17528	17528	1619094240000
25092	3NLkYrW7mdHUtgumEwa4o8e8R46KMqfQurbfAeMUeG2KG2radNrw	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1670	916	478	12463	16932	jwNANoqkGaB4xb7zVZcaqYN1ufDj6nBf8cVErHtF4W9i193EYqd	12455	17529	17529	1619094420000
25098	3NK3awgFotWnnYhbABwDkQoPawkknWYwJwTCMo6uwbaMZX3rupLF	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1547	1378	478	12463	16936	jxQNdd3jAy7iNGbZKTjexCGapU6rGvgZYRwcpCVtHzcfHkeLjBr	12457	17531	17531	1619094780000
25102	3NLD5trPLvSYLUXgTR6pru8oo3mqWskEL4CwTzhmnMEmJJrg4pAW	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1607	1102	478	12463	16937	jwApvFQgEudAuSYmBMMJJE45sPCzCPWSmsG24H7uD6M8TsuPbpw	12457	17531	17531	1619094780000
25104	3NLaeC6en9dmwXbQuarNtZg8iMAGbKxr2J1nSZy6zFURivTivccg	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1474	1329	477	12463	16941	jwfZFfQpA8pdcoxAG2dQHQGjSExN2Xb89RNVeKvRw2UkUgeBPKh	12448	17531	17531	1619094780000
25106	3NLX59VxVJhRp1vHDKvEmFg9HnLYfYeHuQqVAh1TwsRMtts1nyKY	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1407	1395	478	12463	16942	jxtqwE2fad1wyQowW8TntWA3VDKCACSy8W5F8poRJpeC6DmxsvX	12457	17532	17532	1619094960000
25111	3NKe1qfhNQMa44uA5GoUKySkaguKQputQ9fXmKgswd5Eote7T4cs	25110	3NLNDoUbUmJBBJqB4tYyMEuHMPHT5Y42LafiPbrYFaR2B4g2Esvz	1589	1286	478	12463	16947	jxFR9Qg1hANYGnj61ipH8rHdbTPaNZZZqsBRYzwE5KYfstXYGbk	12460	17536	17536	1619095680000
25117	3NLcmwVL7JUYLXChCofGEmn2pE184EudXVP8jJDaGbNZjFpraaWx	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1406	1393	478	12463	16953	jxpi78StfWcQFkv8e9HZWKGjcemnm57Hd3WXu8xqS5gBBYERi5t	12464	17541	17541	1619096580000
25120	3NKb7TbuW4Mort5mqvegVmDJD581YYdC5DSJUVj2XWj7kiATfEaH	24815	3NKYBCpNEz5xysjNMnNQ2mznd29DeJLZkDqQtTkKUMGkixgbi6kU	641	1090	470	12463	16956	jxQxXBDBjeGEZLY3P5HsqatfwYwhcw3L8BpqmQGUBd2AkUMsiVE	12288	17541	17541	1619096580000
25124	3NKnpG9HHMizu1YhxkuTyQDiXugtU31rUvH4UecFEQgbYDs5QnHH	25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	1553	776	478	12463	16960	jwes3iNS4135sE8frJoxU2TRS15t9egWn6SNmEGP2mrHAVS4dnB	12466	17543	17543	1619096940000
25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	25125	3NLiouYgN95LwbG3D8pmkbigrmkNxCQ6fesY4P9AU3MEntjmTsGY	44	1325	478	12463	16962	jxYBaimDzCn9UmACUdeKP6RXGEXK32ZyyuqdAJdoyjZS2LUNKL8	12467	17544	17544	1619097120000
25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	1599	1041	478	12463	16965	jwUMF7fhmigA8Ki2FQrEvPiSJYUBRXtSohHBfH2xFiUHDXoiRS6	12470	17547	17547	1619097660000
25131	3NKakTHgZDbrrdTWegRpzXzpo9FyaQMrNyiASyQQG7tDfdvtynYt	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1444	1255	478	12463	16967	jxChR1QzQu16pAnaSx1BTMpsWG5aeeRKMrHD864B3eQijzjJRvx	12471	17549	17549	1619098020000
25138	3NLEWMSnwKyKdS8gKir7Ex48g8vzDzFFisJMhJRF4v7HMdMXn54D	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1646	1108	478	12463	16972	jxR575a3HcpWAE8YXs6UsHUf4xeTjNDnp9HXG315Sfmh4ftzHfx	12472	17550	17550	1619098200000
25140	3NKPEAcHxJyYNS53KB68MfepdejFPCt1XQujJEvoV5hnWCAwFjvL	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1529	1070	478	12463	16974	jwcKd2NpiHBxU22UVfLDUtfS8Zgb8yvcWLcFcpRoBnTPsvSWhrb	12473	17551	17551	1619098380000
25142	3NL2M2D3xmmFNF5dpMoT6GLuHVrPeMUwtK4L8nFTx7N65fMJb4pH	25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	1403	824	478	12463	16975	jx15ahxs7V9uLaKtprQCVduuKJR5aUNeE6ZThrBiD4434MVEtSA	12474	17552	17552	1619098560000
25147	3NLo8ZjmdRJ3rn6kdUHqQWLY3aNhxGrecAPGVLjtj7bBnZE6EfbU	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1560	1291	479	12463	16980	jxiyrbFyjx4719LJZvtbByWepjXLqC4D1se33Pa8TKKcyVnX1BE	12477	17555	17555	1619099100000
25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	25147	3NLo8ZjmdRJ3rn6kdUHqQWLY3aNhxGrecAPGVLjtj7bBnZE6EfbU	1553	776	479	12463	16981	jwtzaNKfBwAYCaLe8QtcqyWucvbsdoveN81SEseEync3Q5H9y9j	12478	17556	17556	1619099280000
25151	3NKjLgS8PA6fxCdpZfTqociaqnLniDjpv7KVYcUwdfYBEYNBovsb	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1622	1356	479	12463	16983	jxWFyerXvZDZUqWqwWNjm6axefBGPk3Vnk9vFwrQFaKiGoGJW3X	12479	17557	17557	1619099460000
25156	3NLkb81aHNruDmQoHCAmggGNDSbiK81kmgcUgQoBgazUbc1wCWye	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1457	1145	479	12463	16987	jxkBbcfGHRp12AFSfT4cuPNHZC5TfDW7vX8Xhb2T2qagZywfBwc	12481	17559	17559	1619099820000
25158	3NLmQ29Gv7yVZGCui2gb8HRxicSGppspMZezfqizTm33ZGMBGsso	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1461	1271	479	12463	16989	jwFaviod1CSHJYGUHuP4tLbokyvpiad7tyHUamuDVAZ2jeMwvuN	12481	17559	17559	1619099820000
25160	3NLjvrxKBtMSjraCRgSnKNkYMEsR9FYxWDqX3HSZefpCkbz2N5Hn	25150	3NKU2zLeZoq1NDBQgL9hrpkegnGGPVzsPuFSHLpq7SEpvGuBbf4s	1637	816	478	12463	16991	jwzeXFtHDwhHma3p6CERZE67fvFpakoGro3LioU2VpBwVvLnt9M	12469	17560	17560	1619100000000
25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	1642	1121	479	12463	16996	jxvyLX3wsxjKGjBkyYVWqRhgAEPA96rtaxFPq1YeZ6eNE6ag9Rd	12485	17563	17563	1619100540000
25169	3NKakbbZLUoER48LFWp57qMcZJ3hmTwtzJTJbDt5bAjA8NCpy8FN	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1590	1300	479	12463	16998	jwkqPvh3iCPingBAtu9KKCMWgbEFgJSVrmyxnsXJnNMfytiDKjn	12486	17564	17564	1619100720000
25171	3NLGfftNwdpTZhLBStnEpW96wDyqQn5wmuP1XYQqvKtscLygEac6	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1590	1300	479	12463	16998	jxCWrktHN4myMAewyiVe4zDjctGKob75kQpbMAjp697VWv433kB	12486	17564	17564	1619100720000
25174	3NKRFvZvf6RcQzoCiBeKN7mmG8B5XqM6mXftCkHCoUsyZMRxHJMS	25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	1403	31	479	12463	17002	jwVEjYrhNgkrcXsaAhtNyUTNdZCBSNDSdzjZoCgGAbN6S8cYjbS	12489	17567	17567	1619101260000
25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	25178	3NKpybt78x88gnSAd1xbtPDTkHHW8LjJPqhQzHDLEqQaPaux7S3J	1601	1388	479	12463	17007	jx9YEVigNKmK61hyXTYdpKo1ub4stGHiueoV86Ns1FcKFHUE4Z6	12494	17572	17572	1619102160000
25184	3NL3d4EXUnFgMUNyAnXf87KMXo2i4fsWPfzCWYYwgGSbBQpKVUSu	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1617	1162	479	12463	17012	jxPfvQFuGVjyrjWik2cLQKgMTwZV52sPwjRzipS3Ex44SttcqST	12495	17575	17575	1619102700000
25186	3NLsTpd1Pzo9cmp5u9nNHkKWfJacxUxfXo5eCt8pDqtzFJGd9MFD	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1529	1070	479	12463	17014	jxa1XFERWwksjVVt7JPkX2H4AjGtZJVFBJypiyKKdCPN7iVMd4Q	12495	17575	17575	1619102700000
25094	3NLwG7xGd1xCPJvkV9oia94UeeEiGMznYo2Ju1EPf84pPnUgEE9u	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	369	946	478	12463	16934	jwE2vQLwnzCZ6pdTMXcDhtR1CmQtKQKTD6WKazrPjco3q9ctKKC	12456	17530	17530	1619094600000
25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	1541	1298	478	12463	16935	jwU2Pns8vsCZW5Ss1dykXvJ5WNVnrHPBWYWd6wwHKif49NzjJ1p	12456	17530	17530	1619094600000
25099	3NL73Kqhycwynizvn2Zi6CYq6hEdgMFvrmzCmtuSM1zy2kbhrszL	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1607	1102	478	12463	16937	jwFi7i6N82F5DtGxNTkYEQRsLevPsoiLG9yXyzzcEeuzyKqaMuF	12457	17531	17531	1619094780000
25107	3NLR7y4WcNpbmVM7JNCxeRqmysVnq59BQdaPzhFNCSYhnwdE14vw	25101	3NLjgt1713cY42d6Vh2whHquw78vWZoanLmA6dRdh1q9DkzDiaUz	42	1361	478	12463	16943	jwqmGvWXnDtVRUmvcqKMQ8G7JHc8Kkj3R9BL6zGxHbAVM91hqic	12458	17534	17534	1619095320000
25109	3NKFT9psHsJZwp2kQ6z6RBZ4RWNA9NtWuVXYTGpwF17QVmPNsujr	25104	3NLaeC6en9dmwXbQuarNtZg8iMAGbKxr2J1nSZy6zFURivTivccg	1474	1083	477	12463	16945	jxZUJX5eWVDGKLdrmUgs6H2NSK2Sp7aTnChd952yh5pq4EDaCzp	12449	17534	17534	1619095320000
25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	25111	3NKe1qfhNQMa44uA5GoUKySkaguKQputQ9fXmKgswd5Eote7T4cs	1571	969	478	12463	16948	jy1H8MBBQLFiaxeiLrPHvX4qyeD4KWnPjDr6RNRQEeSLvqyX2KV	12461	17537	17537	1619095860000
25114	3NKbBvXzSmAufLWfJ5w8pxCsvrcB3oNrtBSjrjof3AT7dqAfhUTV	25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	1627	1385	478	12463	16950	jwDczzUt9o9o8noDQhuPwM8oBmGwr45SiYJF8b8cAeTw9LhtLTg	12462	17538	17538	1619096040000
25119	3NKtcyQRGZNFX6mZ9tUdbrM3TicxTo7myi55WkPt4zzNJ2cvU86r	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	641	1090	478	12463	16955	jx7tcrAQfz9mSeiPZgswtVPTcLHm29qXRo4XUzZwKtiSMKs7wzm	12464	17541	17541	1619096580000
25122	3NKyw1g8Xw6rhhp8HsHf9s4xg8TyUhfzeDSLyiTRkLea2a6evpHE	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1483	361	478	12463	16958	jwnBnZMaKLiNyyWUgo8ziQm8NrgdegBD1hRYwfPiiLpt39XFjRo	12465	17542	17542	1619096760000
25127	3NKkZsyBCvWKxSeb2QSH9HbsN9kGAXjRthkejWtR74dMJqQnsR8n	25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	1407	1395	478	12463	16963	jxkcpgWWz1pkYfdsr1HFaPqRguyjFVCjQX3FWs5kLJKhMXuQt8G	12468	17545	17545	1619097300000
25130	3NL3J8UGhiWKazRrDhfKxfrzMiKnSittd6CYrMsqLxaBmfzkHG8P	25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	1553	776	478	12463	16966	jx4wwasUQvm6t6uqJApvjpHaW2Mocw2bAuvrQPZSKdmsr18iHaL	12470	17547	17547	1619097660000
25132	3NL1DyCykCCdfXBzDKVmfcuKt2SWmmMXrTxnu9rWqK3wsif1bAph	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1602	1123	478	12463	16968	jwcHM9CcF4kN5oiDzrJYxx7wfm6hgdem2THqLm9ShHyb3U6zXqM	12471	17549	17549	1619098020000
25134	3NLh23pp8VgeY7FqPqHWGnz3er8avLiz67ZCaeqxq3Mr7NPtXU5h	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwiJR2jssDoE1dhzndQiJZj29Sa4TB1TK43BXJHGX2GcwGFXwsq	12471	17549	17549	1619098020000
25136	3NKBCpuSPw2KRUTQihKpQmdUYzbjJC8Bt8QJpefuE7UtXaGzSJxU	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1672	1285	478	12463	16970	jx5uUTtt5FKZ2KSyYUTaeQNUgJ8VEX5wZ3hnWxPoBPqPYP5AYiN	12472	17550	17550	1619098200000
25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	25144	3NLZ9dFKjFuhy1yoDkCkLgnRK85FSbd3nJ9ccao4Rqye1RUKPaFY	1596	1237	478	12463	16978	jwk73YVU7tbL8uX2VG3Yw28WCZGthxuWdn4xReYBxiFsBsUXmrF	12476	17554	17554	1619098920000
25148	3NLq4MhjUTrcFvGyGDDZXYk3ior6fHoM5DqcKN2vkhfWTqman7pL	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1560	1291	479	12463	16980	jxiyrbFyjx4719LJZvtbByWepjXLqC4D1se33Pa8TKKcyVnX1BE	12477	17555	17555	1619099100000
25152	3NLMYedC1LR3RJkpYkyVJxkKixB42pLE82Y9yQTTZwtUXnnmW7rm	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1439	1033	479	12463	16984	jwbomkDzZXo87aJ2PA8ufiTc9kjvvDpX93z4BYAuRKUDNWvn6SN	12479	17557	17557	1619099460000
25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	25153	3NLXNZG1rkjtxzhCvnM5mVqZ9K22jBSqDJLVJNGmFffNL2X9bFvt	1553	776	479	12463	16985	jwr81w6KiDYgXXyTJ4xBmaKrjjcsf94CHArqHkgKdJtp8i3zec3	12480	17558	17558	1619099640000
25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jxEKECRafvLwhdBMeipPAypU8tNRu21spdTdoq2RZ92Nco5VkXB	12484	17562	17562	1619100360000
25165	3NLtFsC5axz9wgJ4ABktLL8qgi8kXdeaoEEZpQU8VAbuYGQ19SC6	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jxQNrAA31gE8WLC6bxE3CmuF8oR6qje9ZcTzqJVNF4AHxkZQEmS	12484	17562	17562	1619100360000
25168	3NKMVjNbma97frXRx7o9A52WRoTTpAs43QTb66cnovQdeja8Lzjf	25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	1649	1383	479	12463	16997	jwfxZ9mHfjBpdEr3kZ9g3Lq4dCGCKn9QnAZ673ymgNDbnhTSUt2	12485	17563	17563	1619100540000
25172	3NKTE4MViCYeTEeiQFtSi8vV7RWRBLJJ25nay5XT8GwcAgF6WmvN	25171	3NLGfftNwdpTZhLBStnEpW96wDyqQn5wmuP1XYQqvKtscLygEac6	1457	401	479	12463	17000	jwrFXYwf9dzRjPJvCMPzwvFiJdtybYrq4bt6uQn6E3eCsYN41br	12487	17565	17565	1619100900000
25177	3NKV3vLePtvAJPQiH2xsmzVTeNJA7AQ3BzYRUAL4EQypZUJUubi5	25176	3NL8AG8ExrKzAXLazeE8hgt4DbTVAhS7d1cV6e3v5HEUG7j6bCyc	1402	850	479	12463	17005	jw7MrYHk2xFeSGUkBbeqrBZYYJtcw2b6TtgYxr8nCsr6JBRaAyL	12492	17570	17570	1619101800000
25180	3NLhze8LigBymZYSJeFXidGAFLzmUu2bejJd71q3kvLfyDFP7MgH	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1553	776	475	12463	17008	jwstq7Uzd6b9bFmsB9yWitee1pT75mvLKR6PVtKwJGWS3DBK2E7	12393	17573	17573	1619102340000
25182	3NLkP42vdsV4EXAwXUTSE3UX1qNpq99E7gyeYFLSR3M4F8mrt4f5	25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	1553	776	476	12463	17010	jwoaRt9wdVfnn5oXFc6iMsr4qVnFwuL5nNDbNitGsh483MNtw8C	12426	17573	17573	1619102451120
25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1590	1300	479	12463	17013	jx6ywR6AjeyquBsyj9Y9aYDJoeKauEtEv2fJmM9QNF393DyxzFM	12495	17575	17575	1619102700000
25191	3NLTP8X7yWKUZqEQSsZssmVjgjSfKxGzasgkEP2sZEhXwjHReKE2	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1670	1036	479	12463	17017	jxN5zU9oYA2Lda29ha5ttVu4PKu3YKo5wquvHwXHz5z37VrPUHK	12497	17577	17577	1619103060000
25195	3NL3QR3NyjhDzzgeb2gHerGMp2fvChfD7exzAGZAXq2tFj5GLQ9r	25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	1477	1350	480	12463	17020	jwWu4RY3Vaf5AjCfmUCTxMoVpCpDh2X8mZD6S82e2X3ro3qSZmj	12498	17578	17578	1619103240000
25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	470	1309	480	12463	17022	jxdEfogyoBkTVNtM4SWxAvPGtJfuy5yyhwSiQY3ax9cPkKXGiUe	12500	17581	17581	1619103780000
25202	3NKPwnNaraszB1bYmV81NV8xsR9zBPFSDyYAq95HbkexU5macajN	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	1553	776	480	12463	17027	jwRGN7m4iXoiwci7S5Xatkh82QKgec8avZC8dDkjLVCCaMDdC7e	12501	17583	17583	1619104140000
25206	3NKWyLmq4VFMRCYhH8nTww3JgDXYfFFvc5joePER3DwocazxQYkr	25204	3NKbyaRkJSQC4KiXa7gQL8KLdba9cX3Chr9DofAiLXYp1aaAQ5YC	532	1177	480	12463	17031	jwKF8V7aMNKGdtkepQYhXYJ1uM4Yig7gVYFf9GoThVE5xSY8YkT	12503	17586	17586	1619104680000
25213	3NL3LpDTUYwKjhuJvHguicmwYnsTJYxC3AXpugSWGt5uJ3bbbBSc	25211	3NLEWbj1LNwbFZbWwp5cHVLG4houqzYw27kBDyBqLKx9Lu5wYEQB	1500	1297	480	12463	17036	jwxJhYPbmcnkKFirqjEYtA6zMzjQqUyMhze23zzyYM2n65nEBXC	12506	17590	17590	1619105400000
25101	3NLjgt1713cY42d6Vh2whHquw78vWZoanLmA6dRdh1q9DkzDiaUz	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1474	1329	478	12463	16939	jx6UH8dsGqzML1EKTgTmdt96MQCnJhLwBsthdi5CexfRkgVpSwp	12457	17531	17531	1619094780000
25103	3NLCyqPermAz2vQXL6kdcsLyXKBkTEsh4aTwWKq4VA5wyAGygTMS	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1419	813	478	12463	16940	jxzQpbHbFwe5ykzc2XygckxJ7GNd9KqhdAY5SLwV5nfkg2x29eT	12457	17531	17531	1619094780000
25105	3NKtrgWDcweng96F3TjYjYerxvrhq95jozhr8jMDXnFnCaNZiruq	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1419	813	478	12463	16940	jwtbrBNnUnkwRALHsjGZPqwGe3rKXjEcgpf2rkX3XmpT3A15sNp	12457	17531	17531	1619094780000
25110	3NLNDoUbUmJBBJqB4tYyMEuHMPHT5Y42LafiPbrYFaR2B4g2Esvz	25107	3NLR7y4WcNpbmVM7JNCxeRqmysVnq59BQdaPzhFNCSYhnwdE14vw	1406	1393	478	12463	16946	jx7FjwpdctdY1vthCvjz4mRTVjmRmmPaGqqMGra58gzWY6xkqvd	12459	17535	17535	1619095500000
25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	25114	3NKbBvXzSmAufLWfJ5w8pxCsvrcB3oNrtBSjrjof3AT7dqAfhUTV	80	1147	478	12463	16951	jx1ipsbCw92RbcfWNejR7UDWapaqAp6M9L7Xi7zUyDo635qMuVZ	12463	17539	17539	1619096220000
25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1445	1290	478	12463	16959	jxr3muUZzFFMZZycnDfHoUt2qPr4EQwRakSMK9Rvxxyki5LNcg9	12465	17542	17542	1619096760000
25125	3NLiouYgN95LwbG3D8pmkbigrmkNxCQ6fesY4P9AU3MEntjmTsGY	25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	1419	813	478	12463	16961	jxssoWQqs9P67fHJWtnsWptZT8DZ4u38fh6fTnw92XydT8LN4MW	12466	17543	17543	1619096940000
25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1529	1070	478	12463	16974	jwae1d4H2LzjxzQkZVFmMsick7a3vkVeob4hp2wSs6v7cxzQjGB	12473	17551	17551	1619098380000
25143	3NLPDdfeqLoYqiBrNKwBZmTfgjr1gZqUuUMDVajo5Qt9ccsh6D7Q	25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	1560	1291	478	12463	16976	jxXxwmHLuF7uKu1VFu3M5G9LkkbM44rWtwKxj1iXa9D5KPnjc7e	12474	17552	17552	1619098560000
25150	3NKU2zLeZoq1NDBQgL9hrpkegnGGPVzsPuFSHLpq7SEpvGuBbf4s	25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	1637	816	478	12463	16982	jwnPTY11FBetBTxqeyM6eLtsjMDE2NnbTxEwUouQSrwezuvz6M3	12468	17556	17556	1619099280000
25153	3NLXNZG1rkjtxzhCvnM5mVqZ9K22jBSqDJLVJNGmFffNL2X9bFvt	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1622	1356	479	12463	16983	jxnwcrzhbdrvCam6nGHGRTVGy5fqFgFJkNn3k4fwbwVn1ceqxpc	12479	17557	17557	1619099460000
25155	3NL94PeGBnZnoAY9tkpHqhwUTtQuD1CzEMkC333UbDVrLtXEE3BD	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1671	1365	479	12463	16986	jwe9y8VtQWGuFucLsJFUfqExN9M59jnw4K6vgZRyAHgb3YVwFjn	12481	17559	17559	1619099820000
25157	3NLrkwtQwvDuVxVzdrcvjJiRvMZ8PNXTikpmL7FcNT4i4sFhtrfF	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1577	1201	479	12463	16988	jxR96KTbiDiyCghphxuMgMiRDESqRUxYuLDBZuNVTKvYoFShSx9	12481	17559	17559	1619099820000
25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	25155	3NL94PeGBnZnoAY9tkpHqhwUTtQuD1CzEMkC333UbDVrLtXEE3BD	1406	1393	479	12463	16990	jwvcriFTdfe5svtSYZQpHadJKjejgUU1W4qzG68NyB1kFn2S7Le	12482	17560	17560	1619100000000
25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	1622	1356	479	12463	16992	jxPgQGfaNvd66Negsv2Zn34nfPZ6z3o9Y17f4SANNdsAwzguxvL	12483	17561	17561	1619100180000
25170	3NLM6irZWgJMSBcJvfKonGvqCMotwgcSk3NRjmUf1jB6AxMAMScp	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1407	1395	479	12463	16999	jxuw7UX3RFRA3d5muqxUDaTy7jomxFo2zsdpJRoF7z99fg745gQ	12486	17564	17564	1619100720000
25175	3NKYZ18zaCU2YHhsbZ98djhXtoE4TL7218iEsRC3sAZrgNz2dGM6	25174	3NKRFvZvf6RcQzoCiBeKN7mmG8B5XqM6mXftCkHCoUsyZMRxHJMS	369	1312	479	12463	17003	jxhMS1mrBwR8gPp37YUgSuoeRzP6SYHkN34me2BBN22Wgyid6e5	12490	17568	17568	1619101440000
25178	3NKpybt78x88gnSAd1xbtPDTkHHW8LjJPqhQzHDLEqQaPaux7S3J	25177	3NKV3vLePtvAJPQiH2xsmzVTeNJA7AQ3BzYRUAL4EQypZUJUubi5	1648	1284	479	12463	17006	jx2u72TbF1x3av9vZfFCffHDAWS72HDNroENvN8icNUnb9E6x44	12493	17571	17571	1619101980000
25183	3NKaBqXs2RbpdasFFULvSHSo12UNcXiz1hXsi4eSHLNf63nn9Woj	25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	1529	1070	479	12463	17011	jx4f5yjGqpoLkTgm1gA4f2h78Ey7jzBEXCb6b93LdhAmi2Timt6	12489	17575	17575	1619102700000
25187	3NKX3pSFFTJh1eV5DCfocCrd15BrUR61kWajMWGMVACw9vPXeEtK	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1529	1070	479	12463	17014	jwpn2mA3QUHJp22NGhHFkG96LKLkEzrNeQ9Btcn1wtpyTWv1qPv	12495	17575	17575	1619102700000
25189	3NKEjrKmmKzmRe7FXuJGzdYKq46S9FxU7JcJEg2vS7pFfd6jwPzp	25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	1397	828	479	12463	17015	jwBcF436fgqdAL7mtacZ7hZsS74inwDSTHamrfz5FJhh61NxhPV	12496	17576	17576	1619102880000
25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	25195	3NL3QR3NyjhDzzgeb2gHerGMp2fvChfD7exzAGZAXq2tFj5GLQ9r	1581	777	480	12463	17021	jwvhpUxnyLf4F1h9iVHzWvmgdieFpmorPS1LsyRf1WmMojHGHmK	12499	17580	17580	1619103600000
25199	3NLa3aYg6zpqqQZuzhgaS8pJjHftyT4NSAyezgxKMfCARsRekdLp	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	1403	824	480	12463	17024	jxbyoVvrREEyjpYzYbrH2NXUtdKkkXiGw4VUHTkHnaxQo3PG3dJ	12500	17581	17581	1619103780000
25201	3NLGNorjsMsmrMAQYfCcSaR3nCaLLp9rVuKo8CKo5vHPHqwk3iXj	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	311	1181	480	12463	17026	jxPFXuAzFdoUprJaMFKXqxtzT7afW39yLXfZCPPyX577hQy7c7G	12501	17583	17583	1619104140000
25203	3NLoJJmmGUi6e9SHvhQQfn1Myyn1purcKnyLB1qQWBVpPXj5deUi	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	632	1382	480	12463	17028	jxxSFXF9dNgQDckQ4qduJX6KFUiohAXZgRf9KFycpzvkBvbV3sp	12501	17583	17583	1619104140000
25209	3NKuxonv7rQgNNnzRYXtYaY5euqjxfbmJMndErYVVqhGvpRAmk6R	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxevLdwrWTWbndEtShkpdJypXWzuSaJJV5FCiTo84nYqAJJfMry	12505	17589	17589	1619105220000
25211	3NLEWbj1LNwbFZbWwp5cHVLG4houqzYw27kBDyBqLKx9Lu5wYEQB	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxe5myRfLyPP7AmVFnDDWXPMaEV54Tsygj5mq5j1GAMuynwuGND	12505	17589	17589	1619105220000
25215	3NKSFs2y8LCz9HRDgzeGLw1CjQn3qkVhSqiJQecF93pRX17tGWcG	25214	3NKHd2cR3yoM8m3MBpiCa8itxbpLrECWSMytAPsSntemDWsE6s9c	1553	776	480	12463	17038	jxW34RY1ndp1eZ3Wi8KdL1QBiucrwyE9fk4xfGbx1iuou2t1vBo	12508	17592	17592	1619105760000
25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	1600	1372	480	12463	17041	jxn5g2ow1Bcf7pUrpNvjVgekcAiZJEqQR1A1RaYHCauPHAt5Zno	12510	17594	17594	1619106120000
25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	1581	778	480	12463	17043	jwv19G7BdPmjhjtqapuiRw1pTzPy2GDZx1Jda2rczG7phY8e2vG	12511	17595	17595	1619106300000
25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	1476	1371	480	12463	17045	jwBa2ffXWGEpsmsnPJsM7LEDkNEwgmvmyaYgpvJHQhp7HtM4hTG	12512	17596	17596	1619106480000
25233	3NKLYKMJgZXBybHziX9HpzxGUktHKkrYTvUYRpXnUmER2L2ZtdjV	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1406	1393	480	12463	17055	jxUHnkBXAgzyx26MArQ7Gm5mBokGKCzieq42HVDaRYfo39wgtmo	12516	17600	17600	1619107200000
25188	3NKgZNxGr6MwqNgGfqFevMC4hRLrAYsrvvUqcTqrKhCUSFVuD7ch	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1590	1300	479	12463	17013	jw7MnGA6GmEiAKHydkg3zfoik4XEJu8UZsNkTfPXCgBhe6cfpZz	12495	17575	17575	1619102700000
25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	1477	1350	479	12463	17016	jwTQmERhrYdaKQ5cu75Tst8LRCdhKSC1r5aWBXVkuuf2Psjxwdy	12496	17576	17576	1619102880000
25193	3NLUuwNgNa81abW7Ta5tLEL1BwR36TojM7z2LnoHTCw947LCnVVm	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1670	1036	479	12463	17017	jwfN4RN8kNGXMRuQJ5oxcAZRj39kZKE5mtqDqeSsNmfbwYn9Le8	12497	17577	17577	1619103060000
25204	3NKbyaRkJSQC4KiXa7gQL8KLdba9cX3Chr9DofAiLXYp1aaAQ5YC	25203	3NLoJJmmGUi6e9SHvhQQfn1Myyn1purcKnyLB1qQWBVpPXj5deUi	1534	1317	480	12463	17029	jw8VubLAQFDMj6N6HC6xfeSURv1pj3g6B6Yc8R17DPPFG7VtqPJ	12502	17584	17584	1619104320000
25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	25206	3NKWyLmq4VFMRCYhH8nTww3JgDXYfFFvc5joePER3DwocazxQYkr	1593	1100	480	12463	17032	jwyWeBRqXpUzs4Df5W5YRJmetC4HVyHSgyV83f6sWRvWUutzmBW	12504	17588	17588	1619105040000
25219	3NLrPReN7QFq4FGx2aiXhzifUyQYnVSM5RP6xSQCsEz8c4HBFfs2	25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	1403	824	480	12463	17042	jxnLi2t1uLoHnEkEwPDj2WSbmvgRQ97U2UCpesYxcW8kYLnYwA6	12511	17595	17595	1619106300000
25221	3NKPwswT4w9yJ3rbXuybZ9aDgQQGpkESqKhVCSgorwHxM1FWqgVi	25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	298	1308	480	12463	17044	jwNa3k3gBzmEk9BMoMPVoG22a6rxpQpQdonDhkzidQtjhhjX1tJ	12512	17596	17596	1619106480000
25224	3NL4N1C9A1P6TtAi3Tj3ycK2R2DPuz5JjTXsXjbeJ2b6xkC4kELH	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1542	1304	480	12463	17047	jx8zFXS1LizgeaDZwC28chBr2AW5RWbLo4cYGFN6UsebnJG41wF	12513	17597	17597	1619106660000
25228	3NKyxo1M5qgn1S3n3VhKBEubcovphXYKgLgVC7LVrsQKNC26eez7	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1534	1191	480	12463	17051	jwcot2kYMcSkhZTvuNEXano5GEvjdTMCSVJZjW1xeTeHuxTJ5ZC	12514	17598	17598	1619106840000
25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1622	1356	480	12463	17054	jw7LE8NKudDtxFK8iEmuAFWbm84hDzu9CaJHpwBHN3vDuCj5Lb5	12515	17599	17599	1619107020000
25234	3NKLZ8LteLQs9SzrRog14io8qKW6EHXQX32UgYJi5hFPMosDYmwd	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1657	1344	480	12463	17056	jxxQwjeKX7EktxQuEhvuWzAhMCU3v6JbdXVb1BqHqaGD8XvHo4E	12516	17600	17600	1619107200000
25236	3NKQwTsVEspe3pw3SJ2A2PtF3ELrZncE6d8TZVk7XmFwmYgk34Ts	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1634	965	480	12463	17058	jxSHPZbTMrKgwkkxJPu5ErZkY8dPUkKCy7jsdwsDg2UC5ZhcrYJ	12516	17600	17600	1619107200000
25241	3NKgZtFJ9ebSfh778Wr2GzE4tPB95xzKSYTmMzSMYBaCEKizH7zq	25240	3NLgsmMYR6BwBgyYRMpi7XgPHEgT41NUXHpBsjXdkHRgVDWMy83j	1439	1279	481	12463	17062	jxxDPP7i7XnQ7zEPzebNuoyyrnXW46f5FDaaMcjroV7EUWqAFF4	12519	17603	17603	1619107740000
25248	3NKaFkGBsZQn28CDiumVTKBYqPNotRjcErAbAy7DZmYLyyRvFMiV	25244	3NKFZ3U6Qj42ufhwVkL3ttBL3wY1jKYt8atXbHLS7KybDdqmDz4F	1407	1395	481	12463	17069	jxtAYWxStRoAnRHMxvLP8FDQTcrmq5xiGE5ZWwtPBS89MPVxn3k	12522	17607	17607	1619108460000
25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	25250	3NK6D3v5Hmg7fAfX9fqBEqCc8rWP8VU8rpd2REopbRruAxVBZTRy	1407	1395	481	12463	17072	jwVmwkTTiEctA2KBnMKonTcHFGZDohbGCwUvF5JqxVECSEvEnKr	12525	17612	17612	1619109360000
25252	3NKRCCybTW74L13vvSSmdFLibyy1r1cqA5GbDxQYqQbt3qgEzhV3	25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	1471	1260	481	12463	17073	jxwUDU9YpUMGuRFuhs4Drmv7Y3FTyCZDbzcykbf2WBmghR1C8QG	12526	17615	17615	1619109900000
25254	3NLizXjhtD1toRpZL3G339fcVSC3r2FfnnruRDhjuY8Ww4CYZxU2	25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	596	1060	481	12463	17075	jwDVvw9vrXUcApumRaED2mfUqMtjQzLLNymN48KDLGF6G6EJEyf	12527	17616	17616	1619110080000
25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	25254	3NLizXjhtD1toRpZL3G339fcVSC3r2FfnnruRDhjuY8Ww4CYZxU2	1406	1393	481	12463	17077	jwAyCJbYScfVPcuft7Bm533AAVtVsVwHEPtkFbgc2ksFYEGtMZo	12528	17617	17617	1619110260000
25259	3NLQrXEX3qSWZ23hGhBtRzQGC4vacX3dV3FQEQF5nd8GeatAxkkE	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1590	1174	481	12463	17080	jwaifV1cfM2n2hNFkj3bnqRkjy9seGn6cWHpopUdyEDjMFnkEkD	12531	17620	17620	1619110800000
25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	25266	3NLswNzAMJHwFUWv967LGkAc72tP6TWTgrW138zdiKfWPu1WhSYb	1402	888	481	12463	17088	jxcsZ94tvimnQFouNsH1QX1HvqwnuN6sUDbxxCE217x1jDubaCv	12534	17628	17628	1619112240000
25272	3NLs5TLEWd58bxtHY4d7FVC6sg4nmcBCu85iBULwcupvpKBdYghb	25269	3NKDkEDHGu8WvrRDVSNJirGH3yRCsArney7S5SYSkxd1Q9Ze2oMm	1581	778	482	12463	17092	jxciWvYFihw2XXR7MV12rXYr4jNAGB5rwnpPgNcJjPpHgHb4uik	12536	17631	17631	1619112780000
25275	3NLsuiu86kdUrjCg5eFc7JF6w2pug5KYCYPtrJFwbw3sM8AvpowW	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jwzSqZ59trTtPQtKvmXV1vQjtayfEu2hcxFuPKHGppSaHvjwV4L	12539	17635	17635	1619113500000
25277	3NKRFUigGyoYxF1wLnho9CUaEQAbXNtQsHjP9iyb9AFverHwUkMG	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jxWoQyRsKRMSz5BF7Qp7ypy1QRw6qDgHbVS3iPSeQfj5LyTPCkS	12539	17635	17635	1619113500000
25279	3NKJgJoKzRnMrip8V3E6RvMNSuYaHYjQqmdwuBVaJfjEYhHQdH3L	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1581	778	482	12463	17097	jxTM4AWJY17LvGvUc2u4Gg3YDMA6XmfipsEMNxWbzFscTSbD8jG	12539	17635	17635	1619113500000
25284	3NLmCuBR6R1rkCk2cKCH7LUSwGWnoctEL2enzNxCcUT6B74XiGJ9	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jwTdWBQKGtV74amGeGY3neGEuSYxAgRNShHLunf7zFm93RQtDfk	12542	17639	17639	1619114220000
25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	25285	3NLafXCReLEqK8eSQFnJNVbW1euApGhfk4SX4uxRuqtHKPsBMMQ9	1455	966	482	12463	17102	jwqQQGyB8Rmdwu21Seu26MyQq68RSa47zzq1zC1iXkMNKa979hQ	12543	17640	17640	1619114400000
25293	3NLMmhxibyyoZrxtphgUm6Ghbm9ByKSAc9HZpfxZnz6tQbrfQd63	25292	3NLmK9d1cHQotsuemKTa4XgDene8xHqfBy6BW7X1HWCJg5SrmjAW	1402	874	482	12463	17109	jxnrYXFJf2UHgxkBywfcijBXszqG8SGtceU8PiPqEaNojtou4xT	12547	17644	17644	1619115120000
25296	3NL1y4izR1pj6fkMD88oxT5ssYys4p4eqrbGakg2yQRbLoSk6Vnm	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1509	1074	478	12463	17112	jxAKhfKutMrf82PFK2bbbFtTogs7c5s7dTf8pjVjhLDFNDZsxW3	12473	17647	17647	1619115660000
25298	3NLggb9Q3ZycMvqxJZhM4z5JRXS9zwzzyvEFHXmbpFtZhvRaJSS2	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1509	1074	482	12463	17114	jw6mrWj24Yuqti2Kw9HLvcHHsqQFFHJhjTQ1x1Zd1aTMpXRXBSz	12550	17647	17647	1619115660000
25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	25298	3NLggb9Q3ZycMvqxJZhM4z5JRXS9zwzzyvEFHXmbpFtZhvRaJSS2	1447	1099	482	12463	17115	jwZqqt815dE3nHGRBGXoPcGUweDf2i1V7eSBJy9upvBCEmXnaG1	12551	17648	17648	1619115840000
25305	3NLPwfbTXScYTYFc5HrQYmsWmUyDmvLdCXc7egKU1DWiE47s5BWQ	25304	3NLhBhdLyvPp5ycfVchfiGdq6pD4pYrp8sGKWKbZ8YEr4S9X7oWz	1464	591	482	12463	17120	jxpkHrVd84gAs4DnnX1HVLRKJfiTNFbA4nj3JdQ94LgPcgihUMq	12555	17652	17652	1619116560000
25316	3NLW91y1GwK8jTC8QsjpDYxjCL1EX8SBQKEmPXtdL6dSyY2hVpLn	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1610	1188	483	12463	17130	jwW2S1G4W26sK2UjD8V6qj4iRBkf3XT2knd71ETbDZWiMuBasJn	12558	17655	17655	1619117100000
25205	3NKxUa4PeRG5Df57bQGMP9YcFvuf1QP31yHCQmBvYvJ8NMrYd4Ea	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1406	1393	464	12463	17030	jw83R18oB6fWDAuDPSPAH8Cntfpg54RUMZdg8BzGxepwB1apoBU	12213	17585	17585	1619104608030
25208	3NKFv8xPV1K4fbsMNpSczPQQvTqLeV4jU3KqWhN9PFv5y3RuUfw4	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1402	34	480	12463	17033	jxVQd8dL7mVYMBBrF1tvSoYnQ6rWCrT7npK8SRMLCEp4fosQLMb	12505	17589	17589	1619105220000
25210	3NLdxFtsAf7uoBY9D3n7gkuq5dc88zWPmRACa1ZwYL8D6PCLcvAW	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	632	1136	480	12463	17035	jws5CJCqkZBsnT5nYWuTSuAEyr5967bjE79w9fvTow5imbDKhYo	12505	17589	17589	1619105220000
25212	3NKn1zxWR7zmPDi9XQYAWksYTg9PUa5wPixeVZPU6BEkT9vfUUEX	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxUpUNhWewK9f83aAYB8tP2W471V8Mq2eBW2DuBB6EtxRj6gMCh	12505	17589	17589	1619105220000
25214	3NKHd2cR3yoM8m3MBpiCa8itxbpLrECWSMytAPsSntemDWsE6s9c	25213	3NL3LpDTUYwKjhuJvHguicmwYnsTJYxC3AXpugSWGt5uJ3bbbBSc	1406	1393	480	12463	17037	jwmcah5suNHwUnZEV7YPTusBhHBvQvcdrbwKVQ4PccDosdLzwv6	12507	17591	17591	1619105580000
25217	3NKb1mbo6jFm2x1sSTFs23abPPH8u3ziofUDPNrmkgq2FmaVBaBw	25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	1522	956	480	12463	17040	jxFGU961gKgDzpiHfvQgKLSB9iDZX76pZzPgESCgnyt57X9od53	12510	17594	17594	1619106120000
25226	3NK4AQJqYWwxo2bBU9EmvARYbeBGnfiYitghrPAsSsXhAvwhHcUJ	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1608	1289	480	12463	17049	jweyjVUtXLx8wWC8C87n1NSgguW21zG7ArV8SSToZyk4wwvdPWg	12514	17598	17598	1619106840000
25230	3NLdYWvheRrKy6ukesQFefh3mbZMyCWDvjxvEh1j2t9vw6PYe6Tx	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1534	1191	480	12463	17051	jwb7Rw3MDPRAEuAMumX6EsK7Y1N3Ux2pzKTC5zFxctKWyAq4BBb	12514	17598	17598	1619106840000
25239	3NLmc6MSdMhcxSAaNsKNPfLagxPegdK4MXbrP2ymCvjcmjUgJfpL	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1483	327	481	12463	17060	jwtagLU1F8uPU8yA8ks6eF1GcAPa9jk3uVxPLDmTEjJgxeqyiqc	12518	17602	17602	1619107560000
25244	3NKFZ3U6Qj42ufhwVkL3ttBL3wY1jKYt8atXbHLS7KybDdqmDz4F	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	1406	1393	481	12463	17065	jxUjXMqrcUmiT7Lvy76mwDhBJe47LLe83HxkmFDmMth1MKpzEsv	12521	17606	17606	1619108280000
25246	3NL4NTE8mcZHprR9xscpRfayRDvoCd6DHbvePT5J63UqM5BxTo4C	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	689	689	481	12463	17067	jxWbTTUTs9SNvYLmBTWTjsvzR34767cffhd9eSEe3qtmGoNdmbd	12521	17606	17606	1619108280000
25249	3NKVNJota9WvCRHe5ThFKioySHhYhBvCsiAWWiEDbcSFemk1UAKn	25248	3NKaFkGBsZQn28CDiumVTKBYqPNotRjcErAbAy7DZmYLyyRvFMiV	1555	1347	481	12463	17070	jxXSUxWzWLLc2Wg9aVE9qkf54f3qRJaWhoZvv1DfDjN3xNzuPSw	12523	17609	17609	1619108820000
25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	1675	1342	481	12463	17074	jxMidv8YZmJg8F8b2H11t4wPeKmwQDSMEeXr3gygTN3rYQsyN27	12526	17615	17615	1619109900000
25255	3NKchzY6Vm5wAUzre4msqc8vV1zvKdqDvwua3E2bfx13JASk6rhk	25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	1657	978	481	12463	17076	jxGsqxBCMLYqvNcLad82Ug5F8aT6xvvhcKharUoHamFSicWjr2R	12527	17616	17616	1619110080000
25257	3NKk98jhEcyRAn8fcReGE2q4mzhzudyQV1YZ45b7GomZZvcGsUmq	25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	1407	1395	481	12463	17078	jwRHVYBNtd6xWnjDbVBEprUaNynf6m9Dava6rSpAbSuU4eX4sNy	12529	17618	17618	1619110440000
25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	1581	778	481	12463	17085	jxAaqmyZnExxLADkVxpEKjK386p8KwJ35dQaS9uva4TyGV9jRm3	12532	17621	17621	1619110980000
25265	3NLJ833ALKcZMUUs3ECXmQFHZtRb686ssk5SHXvkJGJgGfdmFZYf	25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	1609	1087	481	12463	17086	jxoRkwmjLfN1wsye4Qn4nYgmVG9TWm9eLBUjTLqVoFFggX4uJxp	12533	17626	17626	1619111880000
25268	3NLNYGZRin3UAPVKQVPKfrFtSHF7kcyVPUGHpuf991WQjPAEetCJ	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1523	1195	482	12463	17089	jwHbxtGBsNmd7hXW4r37AsHfVs5MnsctSzhJHPAjPgSGcfiVeP2	12535	17630	17630	1619112600000
25276	3NLiiDSRyoakTPNxRooYVxyeZoX7tucX6xFFGVEJ9NPTd9U5jBSV	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1587	1357	482	12463	17096	jxiVeV8h147Wd1sR8wqFiN1V5QLttdbiNe1P5baLXu1bAzxk4D1	12539	17635	17635	1619113500000
25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jwEFfUWxTgnY9GX8MeyJrfkB9iKyCNoq6Z7PhjjEH5cxcgehGQY	12539	17635	17635	1619113500000
25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	25280	3NKF6pk9BKNn1MzZ3ieVF7dwnrAWgJ5n8BbAXThZJgAEYx5Kq5kF	1553	776	482	12463	17100	jwtfYXNhmyMUfrh1EGMWQFxScDb6oJNfRyDMzwQqTgxGeCm5SrX	12541	17637	17637	1619113860000
25285	3NLafXCReLEqK8eSQFnJNVbW1euApGhfk4SX4uxRuqtHKPsBMMQ9	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jy3AXX8eunpdPzkWPmNtpFwBJwnyHmpo6YegnNtKyvt41zhiDqU	12542	17639	17639	1619114220000
25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	1405	851	482	12463	17103	jxyQTv42dQCYCJbsM4tRqeyCxfE572xLCkLq8tFXbBi7xpvzGiV	12544	17641	17641	1619114580000
25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	1402	1267	482	12463	17105	jxK3iNJDncwZmE14Cv5Cc3u5eD9q4H1CgLB9JBFdoRq3Tob5T36	12545	17642	17642	1619114760000
25291	3NKe7DoLAFxgBcq72SAXbGCrTK2MUCQtsQNn8uq8denpnjzacGua	25243	3NKb233itACUmcLMTUWBGh2kQnrivaT8CAycUCub4rDcXsUFqgkD	1637	816	480	12463	17107	jx8ojSJsjtFcgiEei8yM7N92cobqTqCuTXba1DradoBURSXEHEz	12472	17642	17642	1619114760000
25294	3NKPw8PivuMvVmPhyHQZCqmzduiBY2G4Q2TKo5ojRsgzkfWPAzdD	25293	3NLMmhxibyyoZrxtphgUm6Ghbm9ByKSAc9HZpfxZnz6tQbrfQd63	1405	851	482	12463	17110	jxfFq2CcARq9LnrTR16KuQS1kEFd4LqtDi3CVH3SFjybuffdYwM	12548	17645	17645	1619115300000
25301	3NKCx92XRyRPzr8DjcvF6DDz8g1kcsfBQqveog6787YvryLh7qYE	25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	1642	1001	482	12463	17116	jx5p5q7tJaeaCaQGe47TQyfUZiNMjac9Gz7T4PJWavWNTTvqvfe	12552	17649	17649	1619116020000
25303	3NKZNdqSU64cYtXyjaLGJypNB6oszLCZqLyaSmRiQ8A91abJEnVt	25302	3NKwomK8hmqibSRNj9RMUA7d2Wviyq31mCe5rEu9XT15uxwjf6db	633	1258	482	12463	17118	jxkcA5kRAVEodzLHyKoWCsQCZ5XHYQqQsdjJfFCdekvvhzhjM5a	12553	17650	17650	1619116200000
25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	1523	1075	482	12463	17123	jxyBWuFdpGRdLLFGhhga2AFW2tENQUJdTy5vWGrVpMDD6d3JM5a	12557	17654	17654	1619116920000
25310	3NLViRz84yMKVrcKWY1j5KXLuudV8pGpqPL4zrgirBJ8se31x1xF	25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	1523	1075	482	12463	17123	jxDbeZpXgAyW6EBXV34RcoAdxzLM8MRNposCHEaiA6athuPQgvg	12557	17654	17654	1619116920000
25312	3NLiJWhdUfPiEotwf6UXcF3P3avUgRNBgXUnw4yorvWRuWcj1Hjy	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1407	1395	482	12463	17126	jwkzFwNeurcMQEBfUUPaDsyLXmiCHBUKkK3bEgDeBzagfM8oMqq	12558	17655	17655	1619117100000
25324	3NKW76Wos4AyzzWXAsfWQHMHboDJcYPkozQStJPYdtZn2ECKjJRz	25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	1670	1156	483	12463	17137	jxdkMZVKb1P9X9hAANW4i2CTkow29WCRM8vydwAQLCsSrUYQNew	12561	17662	17662	1619118360000
25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	25215	3NKSFs2y8LCz9HRDgzeGLw1CjQn3qkVhSqiJQecF93pRX17tGWcG	1600	1246	480	12463	17039	jwz4QVD4UxJen4qBoxtafemzgUHbV1SrgdejeSVfmMDe3GFXNPw	12509	17593	17593	1619105940000
25223	3NLKTgjawHdTXSZiJ4dXSQybFFboUb6TgR3QvzCw8zyWCJHih6Xj	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1627	1385	480	12463	17046	jx13BfPg2HmKyswKNzZs5eEw7HUtGpqNdDU8ZgrEp8gpKZT8WLL	12513	17597	17597	1619106660000
25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1611	1341	480	12463	17048	jx4kRhpSKYpRskGgjSeMJDMEgtG1iVPmTFVYAxgAuTocYu6BpJY	12513	17597	17597	1619106660000
25227	3NLX3m6ZarbU1rmgDgYn14aMV53zHDDRgnG3zV4AFXigeWQprqHA	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	596	1306	480	12463	17050	jxQgatasTtyXohphft5RP8rjbCiHZBd4T8b9Ym2q6aeXETBLRd2	12514	17598	17598	1619106840000
25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1623	830	480	12463	17052	jxMiWuZXDMKxAZxNxfoK6yATywe8bfWpgWLSXnKg4BNxeCEceDK	12514	17598	17598	1619106840000
25231	3NKAp2nwWZ5o34Fy3qr71ftz17RQcVUcciH3vVXo11n3SGYXcgjA	25224	3NL4N1C9A1P6TtAi3Tj3ycK2R2DPuz5JjTXsXjbeJ2b6xkC4kELH	596	1306	480	12463	17053	jwKBxNmCh5o2ZYKDzQrKZZ9dWaLrR8ZRzXEsAcNQUDgRTRb1LAE	12514	17598	17598	1619106840000
25238	3NLA5ENM2JtMB4o7VzhKuUvb1vBCdKdPyqQqvSVy6WfBQ6m8YX3g	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1483	327	480	12463	17060	jwFBXZxMGebL5SPQYhWUzFAEJTeBDPKzLPSAEMoxwjMSdDyawsN	12518	17602	17602	1619107560000
25240	3NLgsmMYR6BwBgyYRMpi7XgPHEgT41NUXHpBsjXdkHRgVDWMy83j	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1403	824	481	12463	17061	jxT5fm4epueeGijkYwFxinRey46UcuK7h2z1pmiGqPH6RVJdkGg	12518	17602	17602	1619107560000
25243	3NKb233itACUmcLMTUWBGh2kQnrivaT8CAycUCub4rDcXsUFqgkD	25166	3NLh6v7xgiqHM5xbvqopHPYaNAok6rHeQ3vwB43sggrFqKFzj88h	1637	816	479	12463	17064	jxpVCfudSGDPFcPoe8pcYD1cNBozdRSeYF4iRQTfujUBYvnu65s	12471	17605	17605	1619108100000
25245	3NL9h9jxHgzaPuAdy3qoHakVkTykPh76RSEw38PGRpf4biEwihZf	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	1536	947	481	12463	17066	jw9KDnqbbbk6iYT9nMFut1TcBwjHBqPzz4ACy7TYZ9y1tvJgKYE	12521	17606	17606	1619108280000
25247	3NKZsRenQPkcb86kF4tKGuGcrHoDkbfr2NzJDKjVjNsNoUpWBYre	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	448	1059	481	12463	17068	jwTYa6RxQ9FKsWTTKP7iunVgPznH3njGZnp1hdk5dVWXqn1Af65	12521	17606	17606	1619108280000
25261	3NLMegQVEcN6jm1kk7xPH1tYFmiRuig8MhwVVcxaXN4RdB4SmCFg	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1419	814	481	12463	17082	jwNqU15sBizRaLMNHRqNiiPbh3eCJ3rprwN6T9dPHZA1ppgqagh	12531	17620	17620	1619110800000
25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1555	1347	481	12463	17084	jxixqwPHWME3VxfUpPEnDd6UX4LBndLz5AujFsToJR4y6scuFUp	12531	17620	17620	1619110800000
25266	3NLswNzAMJHwFUWv967LGkAc72tP6TWTgrW138zdiKfWPu1WhSYb	25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	1553	776	481	12463	17087	jwUEtohHGEAN89nE1v8Ye71ce9DqhezGPhJYCXiWvmhyhSREZCA	12533	17626	17626	1619111880000
25270	3NKGSM4ng4MAQvfNc3vijzP886s4jAPrV4MaLXqYrofdaXbu3SfL	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1523	1195	482	12463	17089	jxk9kCPaAAM17VSoViXmNdTfczpYV59LgCay6zafcmxyzynLuse	12535	17630	17630	1619112600000
25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	25273	3NLUZjbtB6WuzwrYJdr3R8CPegcLpDNnoMnx1vui8L3d5omH9Y75	1458	957	482	12463	17094	jwcjNcFfWtoHXieRUivNNCGc9VFZC2mHsZbK3dLZXLeagg6Ckdt	12538	17633	17633	1619113140000
25281	3NKujZrZZpHAqs16jaGp85Bb31fewcTktnq68A9L6Vbyd8NqxQzP	25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	1447	1345	482	12463	17099	jxi3MYBCWAdNkAdu9rti5CnbY2wzsNaMwUQCWP8XH47ZoyAyDmc	12540	17636	17636	1619113680000
25283	3NLrCofxxkb7Lj9MXQbNzDYZNMa4eqJzdCjpUDngRAZaHCLFAoyU	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jxHR4tdgKyJm8sd2tqhacSTQof2gPti3x7soCwBnfHEEwqppJa5	12542	17639	17639	1619114220000
25290	3NKGiATf6iGVqwtzJDkFgAPrrPiKxSmN7fL88qbBpzeeKbpBZZy5	25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	1617	1042	482	12463	17106	jwyBEo2XFep6U8idqTuj7Xn3NPbUr2Y8CFJ5Vqn8sN8dmyDBFYb	12545	17642	17642	1619114760000
25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	25294	3NKPw8PivuMvVmPhyHQZCqmzduiBY2G4Q2TKo5ojRsgzkfWPAzdD	1560	170	482	12463	17111	jxXZN1d3CSR6oZ2ecyzHUpsgHPZcG6swrhLthn3mrQiehbtHcAN	12549	17646	17646	1619115480000
25304	3NLhBhdLyvPp5ycfVchfiGdq6pD4pYrp8sGKWKbZ8YEr4S9X7oWz	25303	3NKZNdqSU64cYtXyjaLGJypNB6oszLCZqLyaSmRiQ8A91abJEnVt	1474	1203	482	12463	17119	jxPJFa3j1CvZzLpYTGJkWhGBqpinAwykhjcmD1Y6SUVn9Fkzr3v	12554	17651	17651	1619116380000
25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	25305	3NLPwfbTXScYTYFc5HrQYmsWmUyDmvLdCXc7egKU1DWiE47s5BWQ	1407	1395	482	12463	17121	jwYje3KHD2Z1en1v5Bs8jxCvsE56QKbWt6Ds5LZF1anSW9sWkVx	12556	17653	17653	1619116740000
25313	3NL8p2QNf7qusNty9pW7qczuJxv6EpZhZMb5Ea9PErdGpydHFLho	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1594	1080	482	12463	17127	jxL4drbCa8q4Hkn5trzZ3ganEoKuTHXEb5FQ4LxYgJUuBmy4eBV	12558	17655	17655	1619117100000
25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1599	1041	483	12463	17129	jxYcmDRf6aCQvzCmZTPYdyzsvh4sanrAHiDp8fPMWyGQkwtJ34W	12558	17655	17655	1619117100000
25317	3NLFQmxMTQpxRfu9aUPQ5ehoraizssYfP4yK9womFiLU575ohGTs	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1513	1379	483	12463	17131	jxzDPiHyswtVpTbTExSNKuoyhF69n5rp3VVNKmj24Dc6Lg6qQPX	12558	17655	17655	1619117100000
25319	3NL9ZqPjEBFNR5yZRJ7Rqtp6QcXJxCGw51J51Lyv1GRu5VtNcWTp	25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	1406	1393	483	12463	17132	jxHoFNmHHbLAeJrYVQgz5FRX6EuCES97UtR75MuujRB4ZFAkBRe	12559	17656	17656	1619117280000
25321	3NLXbqLBarCmyU12oTruB1QRo2VKB7VxVDx26sT8UDUfRAL4LZ9S	25316	3NLW91y1GwK8jTC8QsjpDYxjCL1EX8SBQKEmPXtdL6dSyY2hVpLn	1607	1348	483	12463	17134	jwHhU6o6ELQkp6tLyCKRuCDC24mDKT5p4GLfiJgC2F7qVVWVzE5	12559	17656	17656	1619117280000
25327	3NKKRt3jx7gkaDHPbfYqxj4yZiDNq3iQ899UKeKgQXovAPovGYg8	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1455	1332	483	12463	17140	jwynxqQcaVV9Xehincs9GKUQtC9jh4gYbtQtqy2XkPs5ALttec4	12563	17664	17664	1619118720000
25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1631	794	483	12463	17142	jwDFdt8ZMk8Bj5PbKTKKUjmbJ4pLkMjFFPt1zU5emGnpoLfxfg8	12563	17664	17664	1619118720000
25334	3NLpqLCgRTJGVA2FwPSBjZKyMWSvA4JHyufYxPQ1GjC1d37EnA4Z	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1609	1333	483	12463	17147	jwyPgS95m6k11kZYQ61q8vqn1Q27uo9eno6o5Gi5iiwWu7zUQ41	12565	17667	17667	1619119260000
25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1609	1333	483	12463	17147	jxgtXaeSFqT3Jasj4oezbeGEk6AJKbaZxP8w8JSJQj5t886idbi	12565	17667	17667	1619119260000
25341	3NLvGpCVVDAHRdwYqqSHg8Cwv4K9h5kpnsrZ5jA2zCf4EaHWSoEx	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	448	1305	483	12463	17151	jxH5kJLReG51rp2UPvLvVb5KDTqkUDqgaeCgbHSW9hTELDt9gmb	12566	17668	17668	1619119440000
25235	3NKqa397MXdveReuvFqTtm5eQQxYTXsCzRMFZEJ2xuADvModJ8Bj	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1402	874	480	12463	17057	jxHD95uoLTdgqhBr88nnErNu2NLLf2XQvrRAZWsnGrpPuN1yEZh	12516	17600	17600	1619107200000
25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	25233	3NKLYKMJgZXBybHziX9HpzxGUktHKkrYTvUYRpXnUmER2L2ZtdjV	1406	1393	480	12463	17059	jx2aAJVP1iCS8zofmp1o963pBdysmRsvChipkXQHu2tEaCJSZ3N	12517	17601	17601	1619107380000
25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	25241	3NKgZtFJ9ebSfh778Wr2GzE4tPB95xzKSYTmMzSMYBaCEKizH7zq	1406	1393	481	12463	17063	jxAu2TkQWNYs15U5Bz3R152nUatogufLmqjxND5wf1YVzAfCNws	12520	17604	17604	1619107920000
25250	3NK6D3v5Hmg7fAfX9fqBEqCc8rWP8VU8rpd2REopbRruAxVBZTRy	25249	3NKVNJota9WvCRHe5ThFKioySHhYhBvCsiAWWiEDbcSFemk1UAKn	1406	1393	481	12463	17071	jxZmhw1vZUNSkiiJYsWTMhojneSwbeov9VcvRsLwV6MEmuLzgix	12524	17611	17611	1619109180000
25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	25257	3NKk98jhEcyRAn8fcReGE2q4mzhzudyQV1YZ45b7GomZZvcGsUmq	1670	1282	481	12463	17079	jwVxKPgMo2VTyVuzepeHx3AXq8piWiVNTAFSScawHTwsgqAvSpA	12530	17619	17619	1619110620000
25260	3NLnB9VRCuZ9Bu1wGWoc9e8m4Vtq3o6b29ZfYCez2mng7CFq47t2	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1407	1395	481	12463	17081	jwQqVXndisXGDQBDdjsEdJSUMZgEptup5xPbrnKaSiK9NhHJN4o	12531	17620	17620	1619110800000
25262	3NKaU2o5h7znXpvd2MPoyTNoQPB4X3YQxtqXKd1GQ7UsKFfqS4Cv	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	171	1374	481	12463	17083	jxpGYvdeApFgiVf4vhuQqoaKB692HrWyJDVr7UNAcgfxPpxuwH3	12531	17620	17620	1619110800000
25269	3NKDkEDHGu8WvrRDVSNJirGH3yRCsArney7S5SYSkxd1Q9Ze2oMm	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1657	1344	482	12463	17090	jwdAeJ2rD9dr7DzGMAR9tcraC45JRCUEkmUG7f46PUokoUu8hUF	12535	17630	17630	1619112600000
25271	3NKThz1JbiWnNasq85ugzWzeVEUSrZPvQzPKexBwYxjZv6bsrXQW	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1523	1195	480	12463	17091	jxDW15jZ2ByF8rkaKtUGhv9aQ4oVRUbuFTs86X5suEorefxUVhw	12515	17630	17630	1619112600000
25273	3NLUZjbtB6WuzwrYJdr3R8CPegcLpDNnoMnx1vui8L3d5omH9Y75	25272	3NLs5TLEWd58bxtHY4d7FVC6sg4nmcBCu85iBULwcupvpKBdYghb	1623	839	482	12463	17093	jwB9Q6hpo7S3o38Mygvqr3URqd81K6HDLmMzmrbu6JMXV7wupJ2	12537	17632	17632	1619112960000
25280	3NKF6pk9BKNn1MzZ3ieVF7dwnrAWgJ5n8BbAXThZJgAEYx5Kq5kF	25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	1587	991	482	12463	17098	jwPuYRcecf1HfjRWYuxphoeWVSxe7pUJ5eVnCWz1bqsYFWhf3qZ	12540	17636	17636	1619113680000
25288	3NLRnQrTSX7nL2TQEoavMDZPJkrGHXEtNXqHDnTEAYEbF4RCgMk8	25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	1403	823	482	12463	17104	jxeDLmMqaLZfJiby8G5yKD52HsTYudbcu5RxBdRQw6WiXR2dLyJ	12544	17641	17641	1619114580000
25292	3NLmK9d1cHQotsuemKTa4XgDene8xHqfBy6BW7X1HWCJg5SrmjAW	25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	1471	1020	482	12463	17108	jx1uKpcYRqoBBCyi18G53UuggqeFo5G2zKoratnhuyJ5W7pniCJ	12546	17643	17643	1619114940000
25297	3NL1yUUeDiSnQSVDTbAQCyRukmUCf3rF2cmVFzMPpLu5jiHV3z2R	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1439	1279	482	12463	17113	jwKPDNivqpRYcq9qfsLQTK41KLFRUHvhSjjaU5R6YEJ586Vsj2N	12550	17647	17647	1619115660000
25299	3NKxYaxPxyz5MUyaPwqpr6pqu3Xjz7HrBZReGMR9v25eusdx5cgq	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1439	1279	482	12463	17113	jxzGhNhLarfnHZNEbmMGvqhRduKkLZgrujYKpmREkSx24ziyaDf	12550	17647	17647	1619115660000
25302	3NKwomK8hmqibSRNj9RMUA7d2Wviyq31mCe5rEu9XT15uxwjf6db	25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	44	1079	482	12463	17117	jwzeimVr41XVbbJ8W9cZfwSZ4QpfCgRpawZdZyTyZr99qXAZasB	12552	17649	17649	1619116020000
25307	3NK5Y4YVpinYRZmLq5tPq4WucxqjZpRWM7X8UVPcQKDRag9URgLX	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1523	1075	480	12463	17122	jx2aAJVP1iCS8zofmp1o963pBdysmRsvChipkXQHu2tEaCJSZ3N	12518	17654	17654	1619116920000
25309	3NLrPLqQB3EcZtCAmML1w62ZLBrgAUmQwJQhJgDkAHWASwkywbNi	25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	1523	1075	481	12463	17124	jxCDQR2bW3YHXgMtaDBtD2T43hbk2vFigPJWqskGzkYiTfjz5BL	12532	17654	17654	1619116950710
25311	3NKxTLbGKzeUooT7iyUzLa8SXhXgXZEaPtqp4KWsZ6L6wxoVK24g	25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	1523	1075	482	12463	17125	jxVrEn69L3XkzvsGamn1QNv9rfy6jxyV4mrQY2kdWRsHR4KaHUn	12546	17654	17654	1619116981608
25314	3NLeYN6qVNXXQLHzouXEhcAXzVz44hnHTTTZmpYTKDvuQDhTgfPF	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1608	1043	483	12463	17128	jx9Ec8f1PX9rrJFJBLMAFWEqWA6HPaaHQGnCWKB9TBwYLXJn69e	12558	17655	17655	1619117100000
25325	3NLFzYX8HA78uuyDefgLYoija3Fx8YEq8oZn2TiLGWrj451EDG3o	25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	1406	1393	483	12463	17138	jxYwAA8wyFqBxfYWeLuYMv8ZD5D3vajKGJcJNJEBUbxqiN9qbpg	12561	17662	17662	1619118360000
25330	3NLJApXcJ3UeBKrFi1rS5qCb3CWCP4o2L6wGcCoRQ8qE5hpgTicu	25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	1460	1324	483	12463	17143	jwdjjmPUbVBu2D3osaTGEVD3J6PH4PjKkekChtXnaeesgXhF832	12564	17665	17665	1619118900000
25332	3NLv83SXu3v1vC8mSaEawBkLXZsRPinaHdn7Sh4bg2aNoU6AgUDq	25328	3NLDhHGGtXUH7nj4ciWvKMMHUej7noACa9nye2bSPHTtsTb5AGMi	1460	1324	483	12463	17145	jwfPibPYSGMhZ2aziMoGJxTgeZAj9F3LFsjKGj8mj5nFZb96uuc	12564	17665	17665	1619118900000
25339	3NL9cg27JhsiM5GQ9kJQq4t83ncZFBTZC2CJofUD3yDnnfTykL7c	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	448	1305	483	12463	17151	jwaYLmArzATcWWr7wET1anvtYqsAAxBBgcfL6DJRDS5pi5rCH5m	12566	17668	17668	1619119440000
25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	1407	1395	483	12463	17155	jxvcoVbJATyAqmDnMR2Gkmiyp9P65hRLD5wsL4piPZpZ7Z1NgPT	12568	17671	17671	1619119980000
25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	1643	1173	483	12463	17158	jxYB1M6863viTYvZVABFPziTSTfKa4qCfSgrMVyHjQndJ5Dbiqk	12569	17672	17672	1619120160000
25352	3NKQvwxZoRDzUEBWykNpuksnKkwfSn2XVQHdU8ZWScpSgTW77y9s	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	641	1210	483	12463	17162	jx66TqsFnUCEWbjqCrL6UfW8g8gM5B8Hapn4DWywADEHweBMxT5	12570	17673	17673	1619120340000
25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	25352	3NKQvwxZoRDzUEBWykNpuksnKkwfSn2XVQHdU8ZWScpSgTW77y9s	1406	1393	483	12463	17163	jx4ydt6145Xuhu2m8gDPkoPTdXA6LnxQZMQA2rfz4TDyhtm89WL	12571	17674	17674	1619120520000
25364	3NKH8CinkKwVVCM6qGskkoeu3cUK5BpmMkfefmTKpzTRSgvCR7wq	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1559	1227	484	12463	17171	jxQT3oBaEnN4hcDFyN9dfE6gtVZ3x823mWHPuacxv6RU5tammyP	12576	17682	17682	1619121960000
25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	1601	1262	484	12463	17178	jwW28ucRmsmrYFNUE6zJexsPBi5BZHGTTKvUR8rqitCqPyRCXJM	12579	17685	17685	1619122500000
25373	3NKTxjVL4EQ9rcFmjXsjuMzB3eQH3vdy23xFWJTWP9kF9q3hnJaG	25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	563	1359	484	12463	17180	jxvT42xU8zfmP8SkauYDF4z69nViE8QScncghSqwJEVhvB9pcFQ	12580	17686	17686	1619122680000
25378	3NK9gURinP1LVPGUtMnpksxrySCwts96FUpbXyECMxSqy1x3H8kS	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1522	1322	484	12463	17184	jxR9hP1b1B6kpeFfjTPHfsYosXbQUJ836WMYSZZrCJpW54tgjWk	12582	17688	17688	1619123040000
25318	3NKC6xTh7dxMMMAaQ5GCVhMojN9kyAhA8fpApsgtMaZ89sRWT3MN	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1594	1080	483	12463	17127	jxUfgmzEgVETU4Zo2NbAcrkdvKhWt2Q8g31SBGrdMPPYQpBUU8C	12558	17655	17655	1619117100000
25320	3NKz1SaUN86eF8AKEQRDtVceh37jdnKMxE1PnDbfgzwgizPJHiTG	25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	1607	1348	483	12463	17133	jxjNDcLGUddNZCFk5MdLdSUfh2PU9Y1JK4u4RwACL1D3qPTWXRE	12559	17656	17656	1619117280000
25322	3NKjy4kiFT7d1eWEYrhfPqvzxjyRasATNRGKRuPzrMEipw3AxP1i	25313	3NL8p2QNf7qusNty9pW7qczuJxv6EpZhZMb5Ea9PErdGpydHFLho	1607	1348	483	12463	17135	jx4SyZ4Bw3N1J5cUkgcehFdoWRmgu6JJdfmAGeGX8GWtitxHf9v	12559	17656	17656	1619117280000
25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	25319	3NL9ZqPjEBFNR5yZRJ7Rqtp6QcXJxCGw51J51Lyv1GRu5VtNcWTp	1406	1393	483	12463	17136	jxQdLjzg6B42nKpFsJwCDpeuVJjiP8S8XAjP6BqLvHHqeLJEPAc	12560	17659	17659	1619117820000
25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	25324	3NKW76Wos4AyzzWXAsfWQHMHboDJcYPkozQStJPYdtZn2ECKjJRz	1476	538	483	12463	17139	jxGNxaYradL78d6V3N8qtEYU9vACg1G2fSt3ujft1SujCUoCUVf	12562	17663	17663	1619118540000
25328	3NLDhHGGtXUH7nj4ciWvKMMHUej7noACa9nye2bSPHTtsTb5AGMi	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1578	1296	483	12463	17141	jxcQHDgdHgJYYs5cx1DEANNW8XPZJqNFp79iazdznkdFniQ1LB1	12563	17664	17664	1619118720000
25335	3NKakiG79zFRHiQXJGaYgccdjGDao4RyT1jE9CuC6nC4nS8FF33g	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1406	1393	483	12463	17148	jxvfEQDrXgTfuxWV3KheygD5vxo8ENk5GeeUepX3FfG9wbZryxu	12565	17667	17667	1619119260000
25337	3NL7VP6rpqMYdRJaRp1qj88HrP2ouozmcZTZ3D9R3EFmsXeyoNxk	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1405	849	483	12463	17149	jxiGPGw3dWJcVkvtHqao3J9ZHPS6FLGkSatP3BzEoMk5h7gzU8E	12566	17668	17668	1619119440000
25340	3NLqq7rJzEC5C7h7QW1XioaWGzH4Q2gBWx8bU24ea1Cp9r4tYyzF	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1457	1025	483	12463	17152	jxE1fd3tNhYPJqCuCu8jFcoLbeg3tKrRh6eKL4Byr3vU4xqeoHS	12566	17668	17668	1619119440000
25342	3NLSk5SwVNWq5XJY6oXQ7g8LQiYDLKWB7HyST1CFTkrmHPdQokYX	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1402	850	483	12463	17153	jxpDaSSWQpPBoYU3G5iduEviFQWZiPDM652btf5kTXuB72A3ygS	12566	17668	17668	1619119440000
25343	3NLbbT8wsFef6yzvxWURewLYHcYNQ5Eje396KPpryfR8QJoM9s6q	25334	3NLpqLCgRTJGVA2FwPSBjZKyMWSvA4JHyufYxPQ1GjC1d37EnA4Z	1460	426	483	12463	17150	jxc9DHviVUDzwkjZ1KtJiDoCiGEAceP4MrJ2beUm2KcTkGftvVp	12566	17668	17668	1619119440000
25346	3NLB1Hrzz2fSW31AkECLLG7TDsPFLMQseyD5Xypyec8RfYV18q7D	25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	1402	874	483	12463	17156	jxyvx2e6r6ogHp2Ppg9oXkwbPQwtTy9xNHFvjbLRnMY7J7qCdrA	12568	17671	17671	1619119980000
25351	3NK9cGq1bR8mxbpdwFPhF67vf2UbbSTURd17TcWd1voSodEUkonr	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	641	1210	483	12463	17161	jxSzjAJGdpYTuajuzP39VkMg4qy16wzbq41nVnGvnjQ6eHMpQzp	12565	17673	17673	1619120340000
25355	3NK9EKyNtsbgd1RTi4f8YGVzDuc6hjWtEDASJCXYbp4KYJR1YnDg	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1522	956	483	12463	17164	jy11TVbMoTEvfx6FECZdkcNipuEHqmuDp8G2swd3FMTW5NG7jWB	12572	17675	17675	1619120700000
25359	3NKQg7kGwK2hFJmSWxMY8h3E4o3FAqXj2HEEH6k1r4aVVj6QctCB	25358	3NLqg1cmT6HxaeLWZiZ6xsDZjn4G1CmUH9GY6VCrzLhg8A4JBDz6	1581	778	483	12463	17167	jwZySwXVPnUsJV3GE6r5U78SyH7jghZpEoWZ64hzhvT5rbiQyDK	12573	17676	17676	1619120880000
25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	25359	3NKQg7kGwK2hFJmSWxMY8h3E4o3FAqXj2HEEH6k1r4aVVj6QctCB	1406	1393	483	12463	17168	jwTiP9qfcyRFi2M2DPhmqBp4UoDrfDKCyyccXSPpFHvFPXLNC7X	12574	17679	17679	1619121420000
25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	1419	814	483	12463	17169	jxPicfJGW2P6Lh7GwReZJsmhN8CYX9N3DSW8j8Y1EYRz4toyWcs	12575	17680	17680	1619121600000
25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	25368	3NKNdjeSwpuoXjXkdZAVYviM1t5mQg3Yo2ZBL2pCwTPT8a9UpvrR	298	1062	484	12463	17176	jxEBLDcpketR7UAkG1iQ8yTixNr9EGWGeGnSzXF973UzJeJxVb9	12578	17684	17684	1619122320000
25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	1403	824	484	12463	17181	jxpC8Wt5vpfBQaPVLAhGR3sYa2UnWwT8cyxXBAvSN4EV4uKNtZk	12581	17687	17687	1619122860000
25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1448	945	484	12463	17183	jxwizm1QqCdudaxVH4JBpmFSdRSVStjReWwLUxXs8iwp4PgAAQ4	12582	17688	17688	1619123040000
25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1675	1342	484	12463	17194	jxajc9D2dhcgnWoRzM2ZsSrdrUQnFSRXTwFpEAc3582k7izRcq1	12585	17691	17691	1619123580000
25391	3NKFqynH5kAbAjXeEPN9VpAETCMboUJwn2giS8ajVWCriYowRfPo	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	576	1355	484	12463	17190	jwfq7EktNGdPTJ82W77svdGnvtT7UAB4cKM1YECm8djceJwdVrZ	12585	17691	17691	1619123580000
25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	1407	1395	484	12463	17196	jwE6vuptCPWj4R7M8NPboa9zy69SjEr813BXh6kivQ52WRCiwzG	12586	17693	17693	1619123940000
25400	3NLvKig621KSciPq24kCdbzzZ4jZEP7GReUiUs2jC9bLkg1virv5	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	1403	824	484	12463	17203	jxaoqzEqLkbuCXUGnX5rDuiBWjopMzkmVxQh8yTRSgF5g55DykM	12588	17696	17696	1619124480000
25423	3NK3UGjZaipuPxUi9FNeste1tojCw7mgdoAs7x4JNsEtJYtdWAxQ	25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	1407	1395	485	12463	17222	jxEB8nRTwNDhJ9Cc2otpxkkT4JzyQo7XNRg6fG9L1yUzQz5sbj7	12598	17708	17708	1619126640000
25428	3NLm8iEBiEe8AhtWrDVbMD5Joi7aNFD7EmJMjhjwZxySJohVbjVm	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	298	1308	484	12463	17227	jxF1f2QJnX5huEhuCuDUh6pJNu1sUMSf21UVT946MKPVh8XxqQq	12585	17711	17711	1619127180000
25430	3NKasDyaYYF5RK8HCjt8cCHA1FmuGLcLQNLWdPw7Wp32tSZZSZUB	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1498	353	485	12463	17229	jxMBi2qw1t3f8rCE6zSNXVbFakAL7qXpACaYiEczzcuyE6vvv6m	12600	17711	17711	1619127180000
25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	641	1336	485	12463	17231	jwcSGXS5PFecCWYcETWzhd1h6hxfip3wGLHbQTpeHB23Mt3RUkE	12601	17712	17712	1619127360000
25435	3NLS7CRG2ZNE7RaYhRTuk4gGeE8UobTpvQAsZCtwWUn7m5AU8dTm	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1587	1111	485	12463	17234	jx8mXFwDkC5QH2XFn7d3AjP4HW3oK4FAyHoAdKzVzrVVWSWe8fs	12603	17714	17714	1619127720000
25439	3NK9FPeTdyZPzTN4sWhGFkRhvJMbLkanzZWb4aVRyPd5fd8nQGpc	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jxMSjd7Gzz3MKutSfJS2rjg3fZM6emwR19ymRXcFW6WF2aaJjJ2	12604	17715	17715	1619127900000
25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jwuU3FTjRBnwK8yn5L4JfvaZmxUpPGnKYptV3Sg2uj7TwZ6dsyF	12604	17715	17715	1619127900000
25443	3NKgQLLshGdGAsMmdtfQ1PGsBEhekGP1JJniMLLykqgcS6YjWDGj	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1406	1393	485	12463	17240	jwj14FmZY3Azexv8EQRuaUnLHdffnoPJw4LQuqrCjVMVDqutExv	12605	17716	17716	1619128080000
25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	1553	776	483	12463	17144	jxKCbu45sqBfqpE2FmLPn6BDuu6WgVM33W3r6gVy1STbjfFrZtQ	12564	17665	17665	1619118900000
25333	3NLnEsbXLYDMjZprnnVrSKYggoQ1YdgWdQjoNpson5M3BxCnz24m	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1407	1395	483	12463	17146	jwJ9p4nieJcQZTVhqZVNwA1AHN8JsdDnAaQsNyLVCg3SvJYrzUY	12565	17667	17667	1619119260000
25338	3NL4DT6py2sFGr6cWokerScdyAKP8vgrXwxeV8pxwjL7wez58TRk	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1460	426	483	12463	17150	jxSrMh1NoQACWhCqHE22uNhEGaHB89WfSjihNf1meA8kgH7ThfV	12566	17668	17668	1619119440000
25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	25339	3NL9cg27JhsiM5GQ9kJQq4t83ncZFBTZC2CJofUD3yDnnfTykL7c	298	1308	483	12463	17154	jx8zMDDQTxoA4LqMfCjuRsoM9pEpb34AfNVBZP3GsKi6MGeWsnF	12567	17670	17670	1619119800000
25349	3NKu9nz1UhBMFw9EJ9JSqr9vZbCEGR71Rs4saDV3vzsY5LTPjMoT	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	1642	1367	483	12463	17159	jwoBWvQ3mCrDZ2U5z92bVMjMzANz1o2ThYcknVh5TfFjHNFazG6	12570	17673	17673	1619120340000
25353	3NKWbCuRAebFGNZ8JuyoWB6CfHXuhSbPg2vPrgevht9ruvWvATSF	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	641	1210	483	12463	17162	jwC92umhH3WqCK8J8GzZWZfsenhAFKtUV2bSLh4SZYshcYDx1V1	12570	17673	17673	1619120340000
25356	3NKCFce3N9VpGto1o3yaqYK4YSFDcsrMWpijSjQq21V41TGp1pv7	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1522	956	483	12463	17164	jxRhmP3y9ZiFEeWEK2P1EvLvCYq6jdTsFH6K2xH29nkc7uFShzF	12572	17675	17675	1619120700000
25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1406	1393	484	12463	17170	jwFJRGaC2X2sJ32puowF44oNFtocSWqVMwMbUnAipAFrsqXNNw1	12576	17682	17682	1619121960000
25365	3NKFbR4CQpuPDYfgW4cu8VacGdSgTj65bXh7d9HXm72kRsE76U6q	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1407	1395	484	12463	17172	jwgRfvKcxWEYNsePicgC31vLCp1eFM8rwGMQtFpQm7qdQBfmbvp	12577	17683	17683	1619122140000
25366	3NLXc3mBmc9B7xvVzqtXpZFiuZyC3ZtBKa1UmPBbErQqQsWR3Lp1	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1483	163	484	12463	17173	jwyVVrJjjTpAREPYssJfyh1DbpDBt1sJSevd1h86vif2LCCzgkk	12577	17683	17683	1619122140000
25370	3NKVtUJuTFY9JSLWyydx5NCygXpz4HXPUUbUKV6YKg7eWjEf9Qpo	25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	1553	776	484	12463	17177	jwz9S4sM5w8JqVwLc3KtFruDrjgJ74P3PhLsXKnM3yHJsatB45y	12579	17685	17685	1619122500000
25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	1406	1393	484	12463	17179	jwvvvnjM3guDwisSXJVFsV8LK4efefsAsPCFHhpDVz4yfMxXBJW	12580	17686	17686	1619122680000
25377	3NK6jLvYd6iVqxUqEW4o99Qf8D2P1G83bzRvPNFGMrEJRvgUtVmD	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1522	1322	484	12463	17184	jxuYRZV3FhuPfBDihWPKwroVCJ3g6qwsKCqfLAL1QMsviJhio7e	12582	17688	17688	1619123040000
25379	3NKtuGeC9HmbnWHaBTH9VhSPCf8KcxMG4vfU1pxYqeXeFVGUvegN	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1448	945	484	12463	17183	jwrCGpJ2Ycnvky6gEXndgtt8rj894W6kfQeCQq7eYQVusDSSEJz	12582	17688	17688	1619123040000
25381	3NLEgtrZtMx5Px474KedGA7o3wPLipb9iXrE16PbB4RsN9wUC7Bq	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	1471	1260	484	12463	17186	jwKLLRDX8oubV6gtppHqbv7PxAxDeysQfJAJBaawfb47kPzMid2	12583	17689	17689	1619123220000
25383	3NLq6aYWYEb6QMdWrfcwrXw4BkETKSPWqwRdF17156sVBVSCJ94Q	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	632	1136	484	12463	17188	jxUT5it8sKsKVEKouPw9Qj9BHpPkJoJmpupN4VvwMebancPCStK	12583	17689	17689	1619123220000
25385	3NLhXjSvTUGH6aV7fv1xR7aohz4KT5q8dt4jRxF4MpzRM6tnPAjF	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	576	1355	484	12463	17190	jwWWTCiFTWSFpAenJkoRjXWtfY2pf3kTtdpXWFw4P4kSW7nphha	12585	17691	17691	1619123580000
25386	3NKa6ahGLv4TFeJXQ9yeT7iKAsxatffVTH3ihjtAKJqju12QSDhK	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1529	1190	484	12463	17191	jwKKGoTmCBxb5ubRZ8kGccwK9fYTMwHakM9iaEfcsnqKHULdsg2	12585	17691	17691	1619123580000
25388	3NKqVMtJkKyW6LVmD7ZBHFLDZmNv2bsD5esfmEcEQKy7VRAWxG7o	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1403	824	484	12463	17193	jwMCstybHeJ7a1T3DNk3hnACz6VrwPxcKtEGC3CcCxDi9oFSiNt	12585	17691	17691	1619123580000
25394	3NLUL44v9549SQ7dBdoh9crU3CaPpX924RAFZKvqd4bVx7wRJYHs	25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	1507	1034	484	12463	17197	jwK2EthQ1nXJuPGxPPjwKw4SWRDkWLaRoAfy3wobyqnEZsmQbdN	12586	17693	17693	1619123940000
25396	3NKe3BMLqbATYrH6JpM1DRPRk8EamL994rtK9e63RgPdrYYcqSqX	25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	171	1374	484	12463	17199	jxaVRUfUGKoGxM462UeUuXJAPeTNWy6KbdBQaC5P1d2LuH3UsHv	12587	17694	17694	1619124120000
25398	3NLvEvkc4FfunFo4XvdhNXknLzF38UBjq7ELjosfnMLZSyefehJG	25394	3NLUL44v9549SQ7dBdoh9crU3CaPpX924RAFZKvqd4bVx7wRJYHs	1578	1296	484	12463	17201	jxTiQa9WumgUVqHqeGDuXGZKQ5pNWPuMX1y1o69EzHFZG7CaZEr	12587	17694	17694	1619124120000
25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	606	1049	484	12463	17205	jxR2Lh6b4FhjWLwBi29nmr9ZGD535xZ3a4LhPBcZ8ecdr9TFLfE	12589	17697	17697	1619124660000
25405	3NKCLj1YCdcJ1a61RTfoVv6466FLviVemTpi2re44bnHqn4os9Rc	25311	3NKxTLbGKzeUooT7iyUzLa8SXhXgXZEaPtqp4KWsZ6L6wxoVK24g	532	1177	482	12463	17207	jxbWiiMix6ThF7BCrUFTLmdqed29WD1FuCWxWo6ki4g8QEyMW4e	12547	17697	17697	1619124660000
25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	25407	3NLH9Ja6GPYeupd6d86UjhD25C7LQoTjzyzTBD6LUp8YsVk87Svc	1647	1056	484	12463	17210	jwDX8V3hT2HqFAahMozJQsgaHekwJHGm2nqfqpjmPatas1rHNv7	12592	17702	17702	1619125560000
25411	3NKuxgcpX1scF63Pz6oxvCv3jqMPCnX8eTPjzLuzFTBhX1cqg641	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1673	1368	484	12463	17213	jxkZMSfHMiGg97MLn6tFxvv3XdgT5fL24jJcRB1UXkGc8dfTipj	12593	17703	17703	1619125740000
25415	3NLEzD8a1EMEm9yaGHshzoRhSdRnLvPqk6sqTkKdFagHVfgNZ8vL	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1501	1360	484	12463	17216	jw8ea2sJxEuiSGtpAnP3aszTCLHZy6C5PeU2Py77r5pCx4jRv1p	12594	17704	17704	1619125920000
25417	3NK7Mf7JDzJx3CjjhqDhicwihZ5iPTy8PRTCxQJJUsrW8RTKCCZ6	25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	1439	1033	484	12463	17217	jwuC8EdeGw9ZzACH5BV5EGBfAg1SAcjeqQ7HHdvDcih3zM92aQJ	12595	17705	17705	1619126100000
25419	3NKq9GfbEAjBGkxv2EH75a8XtYa1AdZ2nokQGccP8TCGoCZPeZE1	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	526	526	485	12463	17219	jxVrmdtnZy1z9VYXC9NJHSdX5oWdSAt9g8uCgU6WNWV2JHxPhSH	12596	17706	17706	1619126280000
25421	3NL6dVeSnguEgEZ27AmHbqKrGxvKHqTZJWSEExxmjm5yZpNp8Jqt	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	526	526	485	12463	17219	jxVRCDiDd6UaSPVUaRjAoWAZnsrm9W1kJnGVbsBSj16sHSXygFY	12596	17706	17706	1619126280000
25426	3NKkrPFux3dgnAV9bASYs13sHWKvhFqgSL9dtfiZjS3bunG5sdq6	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	298	1308	485	12463	17225	jwqHV1QGFJsoaoe5qRMcbCoBbHWN3GJLzsoZATZ5g6qtZP4GWj7	12599	17711	17711	1619127180000
25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	1675	1342	485	12463	17232	jy28YrGjvnVJ9uUoVq5Q6NWFREGotkxHmPr6iP19Nx9ot5FxZGU	12602	17713	17713	1619127540000
25347	3NKxLcAkDsuejrJ1ZJSYfaDsJ3wRQWcS5mAENpdaqo1cok1WHQ99	25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	700	832	483	12463	17157	jx6fmdNiU2SsxccDSKiTAEeAxEdf6W2f88c1uTcFfGaHZfHwf4N	12569	17672	17672	1619120160000
25350	3NKwRjLJ2UyH3hZtg5GXGkrL8Aj2qdNT8u8uveru1m6EjGuh8iRR	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	1648	918	483	12463	17160	jxCy4hvnayKCXyXgxWS3jRedExjgdwMEUdeQuWTNsRAqRK5tczr	12570	17673	17673	1619120340000
25357	3NK6wTRKMNYkUSg6HN8YbvGTmmwkCL8j1pdB2jviTDV4UfiE67Fz	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1670	1036	483	12463	17165	jx6MsgWQszBEodbYwwWDmgs5xv9bmRvNbBFW6pa3YQ9f4ZsKczf	12572	17675	17675	1619120700000
25358	3NLqg1cmT6HxaeLWZiZ6xsDZjn4G1CmUH9GY6VCrzLhg8A4JBDz6	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1581	778	483	12463	17166	jwHkWago9uisi946aAAQvo3DaDpEXmKv8yuNT8d4uYxtXseqsFV	12572	17675	17675	1619120700000
25361	3NL6TLQbWX87E8kfWeFbiSSKth8nSFfNEm8CntyCTWFt3u4p3xvL	25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	1419	814	483	12463	17169	jwBNG1mZ1Np3srjXRcri9GmhmQpzBxeAuah6WHZAqwXCtk2HCdG	12575	17680	17680	1619121600000
25367	3NLwtLMGk5jp1tcsT9mCCjsYJPVr9JKpr6JC29FWEqVyeedu8hYi	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1406	1393	484	12463	17174	jwqRTaBw3JaobKp2K1DAqrbdJX1aQmNbBSEiM31YGsnTVyqUAhG	12577	17683	17683	1619122140000
25368	3NKNdjeSwpuoXjXkdZAVYviM1t5mQg3Yo2ZBL2pCwTPT8a9UpvrR	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1599	1161	484	12463	17175	jwVyYk2yoEyhcDQG3x3nUHES8XS79KmfsMSnV8UpneEqgAi4Gg8	12577	17683	17683	1619122140000
25375	3NKNdXBeeAWpBz2B5GubkQcHwJYFjiQz2N4pjJkPhQpkKf9F7JFx	25291	3NKe7DoLAFxgBcq72SAXbGCrTK2MUCQtsQNn8uq8denpnjzacGua	1637	816	480	12463	17182	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12473	17687	17687	1619122860000
25380	3NL64YqErMrK8APAknKstBghKSRYvoFqYHHA96JFf9oWG5vomsGY	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1455	966	484	12463	17185	jwhEVotyRvFftdEKbPG4boT4nAjA8vVvHn2DipjgVJpwPzNqHrz	12582	17688	17688	1619123040000
25387	3NKuCGJVmgK6q2qzs5JhuYwnisZYhMiSfLFQpyqFTdRbyqUrUjXU	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1483	443	484	12463	17192	jxYmfdb8H4MNtz6FUZWomr1CMqkXkFU8nPvgMH9cif2NSzgfEW2	12585	17691	17691	1619123580000
25392	3NLu32onDa7aXLRzfxjGuLxFJVqjUmNfTsvRAVW6td4YQmpfJhRW	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1517	197	484	12463	17195	jxbegJ1Nd75dY5ky3BH7KxrNqLZKRtY7WZu2LDKqjj5nkT4yB9X	12585	17691	17691	1619123580000
25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	470	1309	484	12463	17202	jwyiCX5pSnb9TJMGQBaN1wgBJfSmQhiGL1H24VzYBGmrRzrHJsS	12588	17696	17696	1619124480000
25401	3NKfp5VQDNi6AK1oB4vCCs2xrNBdStGH5rd6hNpsnx8tjGRq4Q2x	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	470	1309	484	12463	17202	jwSzQptWqe4gNiR77JF9ck6ZcQ4jYpy6x235gTdDwrctBUogERn	12588	17696	17696	1619124480000
25406	3NLJSGjzmh6niehqiGhEvpvxAsSQHHtFH2uEPsVwzkqYwjFoEHNM	25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	1406	1393	484	12463	17208	jwy2b1vux6Vm2HZ27fuipHh55V8mDLi3erXsUH1WasYGi2EX5ib	12590	17700	17700	1619125200000
25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1599	1161	484	12463	17211	jwdKMy11trugNED1euTzhphx3MCDH82q5Zd5hxxjKA6VW6ngpYg	12593	17703	17703	1619125740000
25412	3NLajTnDgfQernYc98EwirKcwpjJ8c8WKBaWePHTzHCk9qytrNN8	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1647	1056	484	12463	17214	jxhCappsWpwGy8xyAX8vsisDA17yDZYuhQ46Asm611e8E3q7tzz	12593	17703	17703	1619125740000
25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1422	1337	484	12463	17215	jxXVAWswnHydzXzb1BS9rC8GJ1UuDnWr7UmHrG44bQqPLgx9Xkq	12594	17704	17704	1619125920000
25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	25420	3NKdud34BZ2zm25BNfheaCjywrNrpFZeQ9w1fB1tQyCpkYYmtuRz	621	621	485	12463	17221	jxHdJdcSCTLFUKzzZD3qTUvQKzpmNwFGRYLEcwVRZYvn7o6VCo8	12597	17707	17707	1619126460000
25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	1403	824	485	12463	17223	jwx6gxtNpUzJXexsxaTvb9U33BDwQXWkhQyZupr7Bozm8JRJJHD	12598	17708	17708	1619126640000
25427	3NLCxHZdMEmHF5JYSazxmb6WWGVwy1ZYzresjNpC1Jg3QfbE3zGP	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	298	1308	485	12463	17226	jxVx2Cj4Y5dfk5pv9bajnssaHQ1tD926duy41PAhQLTCprYzuDP	12600	17711	17711	1619127180000
25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1596	1237	485	12463	17228	jwAadrV4RRMSeMDJsUJCrbzSfyL4e6zDSFwXKh3hZqb7M8RmeFM	12600	17711	17711	1619127180000
25431	3NKBwCHhLdbmmWC6HFnx4oT72AUfyGPhwbSh8dcbSiu2MbRMmf3T	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	1481	790	485	12463	17230	jxwYjFstWfyWx3DLHVKxJbXGpZetXD9chcYcgMjJ4pvXhCy5jeL	12599	17711	17711	1619127180000
25438	3NLqtPSiPhT43iv7JCzrYj6RPeo8RG5o52s5uf9t52rrEZpZxqMr	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	80	1273	485	12463	17237	jwdPLLrbCNtmeVcNLzKzUkxK5wQALUCF4uxSVvgpNvcCLBN3mzr	12604	17715	17715	1619127900000
25440	3NLNwSH16KgMxPzdzaaVPnry2UWeS83jK9pAwGGYp6aXyp2q6syX	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1581	778	485	12463	17239	jxACx9xAZxy9kbx4Sw7yAxzWAFLGovSVxh9syzaKJuj8wDWuH5L	12604	17715	17715	1619127900000
25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1489	1380	485	12463	17241	jw6owJTdxHEU6gC6px9TxjKNZeTjSChMmNVZSuYYuBWoy6RR7Sk	12605	17716	17716	1619128080000
25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1607	1348	485	12463	17243	jxNh8chHCmXJckBdE5pASRqj97idkAQTdzcaL6Nedci3Ko5MZLx	12606	17717	17717	1619128260000
25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	1489	1254	485	12463	17246	jwxdGSSUBHnwsRPfKhNML43BaDzKCEWwYp4FypYE5ARUoufuod3	12608	17720	17720	1619128800000
25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	596	1180	485	12463	17249	jwwTQ8JiDamnnv157bwLYGDnoXbez2kAmQp6sipMAUGFwj9SGq3	12609	17721	17721	1619128980000
25458	3NLqMobDDCLrsnWRYVJUApLmnXTYeuQAKJkr5VxGWggULBdSELrP	25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	1419	814	484	12463	17252	jwE2ph8CcWjCtXr828xukMj79cPbnVQP5kTQ9h1U6xfpWpeZbbJ	12581	17722	17722	1619129160000
25462	3NLh9XEdzJeup2LeQH3NCDZU3Hp9sWJNoVRcjRJGTVvM4JJPDZZT	25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	1647	1302	485	12463	17256	jxG36AF7JvConik9WwPZSkMDRBy47UJFzUiMaM3hkReXxzsqEhQ	12611	17723	17723	1619129340000
25467	3NLZ6ti4eRgTKaySrZSpxbQ1AnVpgNnCGtk83gxpE2s1TFyKByKd	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	606	1295	485	12463	17261	jxTifjgLrTWB53eNYpLrfn25FuenPB4FuLtpMT6aDxv9XFRQKqk	12615	17728	17728	1619130240000
25471	3NKd4BUnNtoo9GXaSx3UcdhxadLzBqd1BkhnaU63JaaL3oP1jrCX	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1646	1354	485	12463	17264	jwQCq2JxtJRw63mxV2r8oXVrW6waHk2frsvaVg96rBEGKRSuuVw	12615	17728	17728	1619130240000
25382	3NKvvS6DnYhpWc5xPrQGX5bESnztbTA7N2UYPcpz3JLZUug8MHTg	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	1553	776	484	12463	17187	jwmvSwSSgRq43TVqPvz8ej2Au9L3iT1pcaFo2k5sq1QS9EvEJ4D	12583	17689	17689	1619123220000
25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	25382	3NKvvS6DnYhpWc5xPrQGX5bESnztbTA7N2UYPcpz3JLZUug8MHTg	1403	824	484	12463	17189	jwhFM43r486uAanME15UCzwCPFZDtKyqYDnfVuzCur2cYrhoFoj	12584	17690	17690	1619123400000
25389	3NLbY7vCMAMviuMNajFKeAY6WCcxsAkyDMfJwCENB3PQjrspt1hv	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1529	1190	484	12463	17191	jxHBoGM345HJQqgN8ogtNWf3QEKYyst1MNsWWKSJJ4csqvLtjm8	12585	17691	17691	1619123580000
25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	1578	1296	484	12463	17198	jxgNK6Rh5XMdfwoJQBKRt4pVWZ98KzBrEyxm56vVFM2h3DrL2ew	12587	17694	17694	1619124120000
25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	25375	3NKNdXBeeAWpBz2B5GubkQcHwJYFjiQz2N4pjJkPhQpkKf9F7JFx	1637	816	480	12463	17200	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12474	17694	17694	1619124120000
25402	3NLe4sWdZSqZraBNk2DMGWbX8eXNdzWinY1rpfhuH1XyAAZvY2ZJ	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	1602	1243	484	12463	17204	jxtqvhCavWRdnzx2dpJPHM9erJGChAkmTLra6WatxkyfxbH5t5y	12589	17697	17697	1619124660000
25404	3NL9GLK2wD5soUv5qhdxx1HQk7X9BenhNsaigmtELAxS456sxAPF	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	532	1177	484	12463	17206	jwjRajhxrdLxuZav3s2Esmc6xafj5nAhwp9T1FWxXP9jmeoxbei	12589	17697	17697	1619124660000
25407	3NLH9Ja6GPYeupd6d86UjhD25C7LQoTjzyzTBD6LUp8YsVk87Svc	25406	3NLJSGjzmh6niehqiGhEvpvxAsSQHHtFH2uEPsVwzkqYwjFoEHNM	1406	1393	484	12463	17209	jxvgFyQRL1ynQ3Wq5E5KR67Ekx5bew27tmKhGZnfpNLb8HboMuq	12591	17701	17701	1619125380000
25410	3NLa7D91y5bM3nwWChqGV3xaxbdk6Njg1rLHch7MQDnBSg2mX2h6	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1457	1025	484	12463	17212	jx2DXH7BZdf9cPPHWRk59UKZURREFV1P6d2JfWhbSmmKK1MGJxM	12593	17703	17703	1619125740000
25414	3NKVTAGZ5yGyrQWEw7QyuM5z57EnmMxoZpKi5NrnMu4k5JQhjgne	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1501	1360	484	12463	17216	jxow6vKUaCTRGqdi5GHztUvp9kEDeKRKbtQ72JyPGW2z2oP8pge	12594	17704	17704	1619125920000
25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	1439	1033	484	12463	17217	jxweiLXdWJpZwhiJcdegc7bMXe39wJY2c7Z2eD3mCDvHonsDDsD	12595	17705	17705	1619126100000
25418	3NL8ftW6wbGr9SbReuyZtzeaBjqY6z9WhQxmNQEX6PagNKS1gz8n	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	1549	1236	485	12463	17218	jx62zKhZ6gtHvH4ZPrfiV1uSXzkSCvAujEYsM8TcJpcU8AavNmr	12596	17706	17706	1619126280000
25420	3NKdud34BZ2zm25BNfheaCjywrNrpFZeQ9w1fB1tQyCpkYYmtuRz	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	1581	778	485	12463	17220	jx8JyyCQHTQkpbtc8VT4FHtKgfk68RNFawkd5KxX1o7YmewGurL	12596	17706	17706	1619126280000
25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	1631	794	485	12463	17224	jxfzh2yZjp6w5SXjZAVSxPLWAB6DAydEmXSpHbHMyEor5ands9V	12599	17709	17709	1619126820000
25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1407	1395	485	12463	17233	jxvgJemDfcqx7YGNbDQZo68mtqheDQjJNHkSxMjLtud7jC5kQ8g	12603	17714	17714	1619127720000
25445	3NLxWCxv6QFfberogWd33svrtLzA4PW2jzpuhnT2wfa2XnG2gZUb	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1489	1380	485	12463	17241	jy25792Tk21MF9Z71rAC7Qn69WthMC2YWDD53XbRzJksf6PfHgh	12605	17716	17716	1619128080000
25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	1407	1395	485	12463	17245	jxNNDPauHfi4CWJagjR8Er22uGVaeBveycJejJpkW1mRj4uD226	12607	17719	17719	1619128620000
25452	3NLjuRUqxMKKnY7HTZzAuxDGiu4HQ2Nthx9s1Fevg1cEe9Ld7ozT	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	1406	1393	485	12463	17247	jwcP1mg3N7aisHAPn6NVER6VKGCHYdUsDfvJ713JdzXccggtieD	12609	17721	17721	1619128980000
25456	3NLr4juBwWzesC1AdMSV8DJcy17wc2d521zB6ZnbbMpJNRxUecoX	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	576	1109	485	12463	17250	jxFz4qs6njvkN3onDDq4JbSa3DcbSLcUt525JuL7dBN1fLXuimi	12609	17721	17721	1619128980000
25460	3NKEKt3gbDGJJ66ybU1VvExmAantx5zAHNiHyjy6kjPpiNKkmiRn	25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	1419	814	485	12463	17254	jwwoKPNtTjqci7VGo4edQmCAM4Ei5KnJ4GEfePdnVvphtNm4ndk	12607	17722	17722	1619129239482
25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	25461	3NKJ4zw9ee7pHidZ9pXmuV3pv9zBB8wgHi6dp8TtYW5jzLTncHNh	1492	542	485	12463	17257	jx6gHugrEUEVm8VG3raYUUaCTgHyhWmEzmYEemdnafAKEhQs3XA	12612	17725	17725	1619129700000
25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	1547	1012	485	12463	17259	jwNgd5cnMdGX9gT3eJcGsFCZrHL9RfdqudB5VUJZJLdYyUiUG2M	12613	17726	17726	1619129880000
25468	3NKJrWF5UyErXrzaRfrNJiobqEjydp1xdkniaC49GyXdkCap97Bu	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1403	824	485	12463	17262	jwsijx5CsPtfJ4Aosw1WRfzfKkEJqSZ3N9yTp8LkT1rXS2NAfaV	12615	17728	17728	1619130240000
25470	3NLAUhh3c2eLuXseCHf6xgL5M8dn357hsg9qcnFVtkDgPgXme6Wc	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1646	1354	485	12463	17264	jxztjq2v8CVUic9stsDGzKnQunyZLXsnpKfXXRjP4YA2jYZoJgc	12615	17728	17728	1619130240000
25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	25468	3NKJrWF5UyErXrzaRfrNJiobqEjydp1xdkniaC49GyXdkCap97Bu	298	1062	485	12463	17265	jwgvgL1jSFUYTjw2dRms585pXwXkdWGWpwA3vZbiPJGBvSrMQqT	12616	17729	17729	1619130420000
25474	3NLTdPAE47YzFrjzKxJZBVRbD8QUSUtNB7z52rMqeSs7Ln8LRmVi	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1671	1239	485	12463	17266	jwb7hSzbhJrCVTdAfgoNhCXSKqQXyLB33XtkAsFWu8sE42RD1eL	12617	17730	17730	1619130600000
25476	3NKTyB5QsaBYqtYdY6XQrqf9UsfaaZbxM7s35CsSkE4jDH8DXaZ7	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1581	778	485	12463	17268	jxZneB35uxvdoT6wyKfNDoydnnYWXi2ABVH1ryKcW3w65NNJR5S	12617	17730	17730	1619130600000
25483	3NL1b8FWpEp9GfiGuNauDrqidKZzipnwYUXpGHX1EXZAE8n1t6yh	25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	1509	1074	486	12463	17275	jy3DLt3uUwKuDk43YZTfnJt9yHhmLudLHk1pcjvShFeoUEHeq6N	12620	17733	17733	1619131140000
25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	25487	3NKePtGZ58cXCQXh6af3w42chKGPz416KkoFqgoKB2UfJmAxwuPs	1402	850	486	12463	17281	jxJQYXMmbrdV5pxsDCCjRN56dU1jD7hsFEAFdgKATYp6fqEuhbc	12624	17737	17737	1619131860000
25497	3NKpGP4na1SKfRuUzYUgWnLGFuySPa6maAYzYDdELWTYr2t1nwsb	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jwnQXVKVDojdgZApEPGDt8vG4GrSZdAUeBq8eXtX23byuZWBkPH	12626	17740	17740	1619132400000
25501	3NLRKyo3yhjmEQ5B1Wf6iXsttofV7fKJeRnNEziwHmXuZ7TS28Wu	25500	3NLy1draEM82kGiykezYnry4Uk9NUJh57EVouk3phrQnbuCkqBqC	1622	1356	486	12463	17289	jxzmQHYABaGpJtfdvfq7q1XUrL2wWeTjoY52EPZhjk5ej73WdVz	12628	17742	17742	1619132760000
25506	3NLYgy7VqVTU57vKBUSeZKrQkZQvhYTfJ8M24oKD6GzKCvaiwpsd	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1534	951	486	12463	17293	jxhdSaVNEaYFSxsXh1yJ1zNrhDNmiCD3jLWNSSZvoPnqjXWn7pW	12631	17745	17745	1619133300000
25436	3NLR28ApuUpKqUxwyx4RqXuSFACYKUXgG9NSbncEjLgZfvpcaAtv	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1406	1393	485	12463	17235	jx9AbiwNj8aiNw6hFwRt5RmSEQqVdPNU4NfMZhbHoNSFZ7ooyFC	12603	17714	17714	1619127720000
25437	3NKgeBZh6JsK4sGP15LAuPx1KtLKWh5UfmDhBjjjPAQJ7zsMGWMB	25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	80	1273	481	12463	17236	jxL9xzMRqNGFbWsHxRtcWX6kooTDjVUGieF6ayYTDNLYmfyamNc	12529	17715	17715	1619127900000
25442	3NLg9sQCxYEeGLT69nijDSUit32ztHgaFcaaVD3hndrAuHkxphXc	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jwtcmPebbNzUNFPWQ62ErAwfPHEAmSDDud2PbK9KZXsNZcJvxJ1	12604	17715	17715	1619127900000
25446	3NKV6m6wzFq5hQTQxUgDvCQgtMp9QSiZfUKTfcT7hG4RVx2Lw8qW	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1403	824	485	12463	17242	jxyQJwtTFHBQyMe7DWyxSCSNp2AgpqnJ5QmvgzfSyMQXBdvyUwj	12606	17717	17717	1619128260000
25455	3NLHXC3HgPw2sAbG2iz1xqT4JtZ357LoRXsqWN5zsEiZrRe9Ezv3	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	576	1109	485	12463	17250	jx1gj8xVoUS92XwgisN2TfDgVPMqE6rkto7K3K6K8gqsq7TYrGZ	12609	17721	17721	1619128980000
25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	1406	1393	485	12463	17251	jwsd7FbFC24YANMQ12yKa4kob22zLbc8FLwwUdBcEzi9igdACeS	12610	17722	17722	1619129160000
25459	3NL35kbc4E7ftZ7m5KjYfS2PRGh29VxNFWGHyae7imUzfNrES8ds	25439	3NK9FPeTdyZPzTN4sWhGFkRhvJMbLkanzZWb4aVRyPd5fd8nQGpc	1419	814	485	12463	17253	jxs6HEUAcSBrLcSWLnCWP1jXo9bSdWC6MPek7xu8K9xPCHbHKuM	12605	17722	17722	1619129160000
25464	3NKAhhvUKSSL8XYSWFyZV4Eap414xhcRFzK65AMrMiD7x5scUpvq	25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	1589	920	485	12463	17258	jx3Utq7Bqd211CQG7xL8mvvHuoQDGd5o1E9gSseYoecGwDMLu2s	12613	17726	17726	1619129880000
25469	3NLR5FWAEuSsomCS1VaKwuYQsfqXHjmm9YeBoBDstyLv76r4KZgP	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1447	979	485	12463	17263	jxdw3D9QyFHUkJe1R4TfA4fKeDm9isiAB8enhds5suR1jQeN24b	12615	17728	17728	1619130240000
25473	3NLjNTmXxz3nMWiZJCkSUzjLpRmxjZ7t4RLRbz2WLZ9dQhVFZVEQ	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1671	1239	485	12463	17266	jwb7hSzbhJrCVTdAfgoNhCXSKqQXyLB33XtkAsFWu8sE42RD1eL	12617	17730	17730	1619130600000
25477	3NKfsUm6RtKqEwiZ3B6UC2uaf9iL9RUJt5pt3XdKRRoMesJsJhs9	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1555	1101	485	12463	17269	jwkPZNwKr7roTPkTThBLX5attWyKV9V93BtHw8qRaUuAaVUtWw9	12617	17730	17730	1619130600000
25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	25481	3NKcHajabF5sCRKosfcgSf3xjKRBRhUo5K5aazQ4JzEEcRvpKXmP	1619	1149	486	12463	17276	jwJPaVoR8qZmNrZTtp3Wr94gCvz9axF5KKNgvt3mrfpC4kArj3T	12621	17734	17734	1619131320000
25491	3NKet6gukUEDmYVMp6MGa9BUBJuNbgAtK7mMyHHsrKSck8JR2WSt	25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	1637	816	480	12463	17282	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12475	17738	17738	1619132040000
25499	3NKQ1RnUUt8mr1Din5CVmgpt4TiBct1fRhNobETLFrouD1Kj4Ey8	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jxfMpzLsJsVg5KVwzRzvr1w7Q5cwnbWtCQSXvSccmaXAJri4DGy	12626	17740	17740	1619132400000
25500	3NLy1draEM82kGiykezYnry4Uk9NUJh57EVouk3phrQnbuCkqBqC	25498	3NL7iHqRBviLzHMGgLweGoheez4RKRwv8ZZKTEEpK5HbCVT4Mf9W	298	942	486	12463	17288	jxegmm44CDX9ynJoZqWvrD6hKYjEAH2vdXsxaNCnCfUW97nYDCt	12627	17741	17741	1619132580000
25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1631	794	486	12463	17294	jwB5HuzM2gzKxsHPFe8S93CpnQR1aaBk7woeCoX2aBVszS8qxN5	12631	17745	17745	1619133300000
25521	3NKEu9HswYKreWDmX6BM1DQ7GrFeB95ABx3Uf3sNNUQmcM7pJqbo	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1403	824	486	12463	17306	jxahZFz9NLSNBdAiAWKiYH4v7S7QKnCw6ySjxho2fC4QDfjTRsk	12635	17749	17749	1619134020000
25522	3NLtsuQD8UcQHaTF4T7pi4woJxiVe3nvKqPiEJ25qf9G5m8xeK9R	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1476	1371	486	12463	17304	jwBp5UsamQ5ayYSgoeJiJoVNrtyFU44BAhie9T3yNWicL1pRiaF	12635	17749	17749	1619134020000
25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1406	1393	486	12463	17309	jwSw81MVMoNPJUEaHqrLaqpypqRaYW5cq4iJ3qMfbdbgcdP6hLD	12637	17752	17752	1619134560000
25532	3NLPm8ugddec2bViaXmDxuUGPHev9MUDM1AkVT7RGawFsaPQXEU3	25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	1589	1286	486	12463	17316	jxycR57YfyXLWLWz2dw248gApGMFzZz9faDfF44q5QhJtmFCNrL	12640	17757	17757	1619135460000
25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	25532	3NLPm8ugddec2bViaXmDxuUGPHev9MUDM1AkVT7RGawFsaPQXEU3	1668	1124	487	12463	17318	jxM6jn66eAHYQhADLE2AUmpKCATL75mZSDqaz8U21g38NRfYe7K	12641	17758	17758	1619135640000
25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	25536	3NL8MxprYccx1cFTHDy4ifMazxdMd9RhEo2xAwhCbXB2eikR2c2E	1627	1385	487	12463	17321	jxGnymBiieWitiXKa8jntBAegrg8E59w8QtDVYiqKmXKVt2pWqX	12643	17761	17761	1619136180000
25539	3NLRgkFgE2YPEWaAQWncScycPrbUN5HiLV7i1AVTEwdM726JE3GX	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1581	778	487	12463	17323	jwNri94smrMatu3cbFSsdo8k119yfiybEUQu6DgkciV3gV4YMqc	12644	17762	17762	1619136360000
25542	3NLEfCE4tQygwayF1nkGSFrQQswWbhJsbsSvp7b79x9nprhxswYG	25458	3NLqMobDDCLrsnWRYVJUApLmnXTYeuQAKJkr5VxGWggULBdSELrP	1419	814	484	12463	17326	jxLPnSpX9AteNfXDVTPHEqzoRM4AGuDhkntwEVuneWA9TcPab4z	12582	17765	17765	1619136900000
25544	3NKRbeoMgFEYqV3Dt7RF1zYY5ff5YmG1Y5Bmi7AQeGbVzr69nrPq	25541	3NKhDX4NfMfSBepTVqExiZxUFJmKRvsUkQTk6gqgjKZkjw7QJwT6	1407	1395	487	12463	17328	jxmVwSeC3a6ZHYKX1G9CjsAxDfdMzF4KTL1Rgq7UQuNByqUnzb7	12646	17766	17766	1619137080000
25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	25550	3NKjLbEecRBHrcFHYC7NtzJQmcKUR9XxX6qUex5JeMBvewatHxKy	1501	994	487	12463	17336	jxXV27QaJQeKeDaWTS3ZXAGtLRWiKWrbkV63drnHNka8Jj7ZvFV	12652	17773	17773	1619138340000
25559	3NLN841T4YThWpvcDM2EN5bZEDkG2WJsCTpg4SEuem8Lv51zrtGU	25553	3NKnY1JiWciaiUscXvc7SNg3fP3F4HT9JxZFe5pYJKs8f1t6DurC	1637	816	480	12463	17343	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12479	17778	17778	1619139240000
25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	25568	3NLj29vq85DSRKG39JxymVLoUhhYq9JbrLXvhhTZGZ29ie6KLtot	1655	682	487	12463	17352	jxEEiSExSJgwB2kvMh318i3T6WaFagcomoVLL22GL9nmnZNuJfm	12659	17785	17785	1619140500000
25572	3NL3cTBqe7wRMZz5RhX8Lpwz27Nixkm77iaBvcAkJWMCm43ivU2n	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1460	681	487	12463	17354	jx3nPEkJpDDGhyWBTiEjTc1HxPHNcb3Dr5rBTuaePQEdKhgdmbG	12660	17788	17788	1619141040000
25581	3NLhA5G4V3j4WUmDFjDqcFyZpQS3oqWgkPpsGLTT9rsVdGQnbFHZ	25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	1600	1006	488	12463	17362	jxHFPsmmbdTf2nZDX78WFXEMzHLxQfom2RTW6WdtCymCs1P49rx	12663	17793	17793	1619141940000
25585	3NKFCoQCTdpY5cQfPwrDCiTqrr7W53LaK2CL57jZ1gFa4CbxJcgE	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	1671	1365	486	12463	17366	jwY7BmHiYrU1Q7Ypj9NMEvbw5R8qePb8NrTGgRYrTnGRzoFSCvn	12619	17793	17793	1619142046012
25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	1440	1377	488	12463	17368	jxrTcobyGujsbDbrRLrTN8SL4HkWrxhBjicsqwTtbNMkHkhMBAq	12664	17797	17797	1619142660000
25448	3NLYgKNsFZcNVRTWgop3m7Mir4xF1PGFWt533yHqiUHYqANCV4yi	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1647	936	485	12463	17244	jxd2F6YgEX46i1pvacfVMPKHQ7Y8ffou8S7YdTnxUb7YVq3peLP	12606	17717	17717	1619128260000
25450	3NL9r1tfEhsCnnBpiRGWg5aPnJ8qvaVeCZLXcgxYXB2oUAodQPU6	25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	1489	1254	485	12463	17246	jwchVnQrvbBj14fExAauyP4hGi7bEXVBsYsA9NztEgSjTj2dVF3	12608	17720	17720	1619128800000
25453	3NKHoDCx6pUSTETqjs4Arm3wGV1UTKKCnVS65PDWjW3Xrze5R4EQ	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	1467	1376	485	12463	17248	jw7uXqWmbbF6Uu4JeSZ2mEqVFTJXySSXJcxeJkLv1LhyqCbfzBL	12609	17721	17721	1619128980000
25461	3NKJ4zw9ee7pHidZ9pXmuV3pv9zBB8wgHi6dp8TtYW5jzLTncHNh	25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	1460	1324	485	12463	17255	jwuQUCBZvyzQyWHxrF6Y4ssxMgjNHTFA4GrDmE2aaiWib5RqMX9	12611	17723	17723	1619129340000
25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	1631	794	485	12463	17260	jww3RMdhXnuqEqNVYD38K7VGwMvQPjuy2DhymzGm8ppd7vexqh4	12614	17727	17727	1619130060000
25475	3NLu8xXWULtnR13aUqqsUTKxWeGoLASDKrJPsTdQ3pVFkoVgyAky	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1608	1163	485	12463	17267	jwSf24u5ChUpWSeJNrqimjtZiodxgRykEmwQBs5DMwdUUXBtoLn	12617	17730	17730	1619130600000
25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	700	840	486	12463	17271	jx5CARQS36FHMxfNNE6SAGCxw4gLeqFV4gSpxsi51PmiwyiVHPR	12619	17732	17732	1619130960000
25481	3NKcHajabF5sCRKosfcgSf3xjKRBRhUo5K5aazQ4JzEEcRvpKXmP	25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	1444	1135	486	12463	17273	jxFVGJRt1vUGbP1mKxeyjPNibyB2DQfaPpMpsWakanH3xh5bqnQ	12620	17733	17733	1619131140000
25482	3NK8r6vb12Af2yjb34FYnmDN8dryAoqyZ924ySNZ7MQhXgNFoSs1	25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	1509	1074	480	12463	17274	jxiuKN3ujDip7LwT6tX5poxqCBZAteuCEhxuyBNfb4uJwFLz3bD	12475	17733	17733	1619131140000
25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	1623	839	486	12463	17278	jwtCiqXWrC1pPwWQJqYzWJMxPjr6CLXQg2SWcN1BH6i5AzesrmH	12622	17735	17735	1619131500000
25488	3NLQ5ftiQJcS3KwLWPGADfnwVMDN378h5jEN6Wppx6p8eNj6JYgJ	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1560	925	486	12463	17280	jwArifztMKJFXRNnnxrUDKJ43DY599sTwt1F1wVWbDFxWS8ByUw	12623	17736	17736	1619131680000
25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1448	1311	486	12463	17284	jwveJUyA7fLrA8XvsfRPYzrX3BwZtYNC6QHoxkCw8ADhWP1JCd3	12625	17739	17739	1619132220000
25495	3NLktW9rkU1hmUF7HdDhJDEDt6z6neV6LYLRLxrX346Qg6yqeWgG	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jxmpFqLXfxiTGzWGHLTLMfkG4LGU6QNbhYJ7jtEUkeYhTCNhJqF	12626	17740	17740	1619132400000
25498	3NL7iHqRBviLzHMGgLweGoheez4RKRwv8ZZKTEEpK5HbCVT4Mf9W	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1422	1337	486	12463	17287	jxmpeXqnkGbhvLKJUq9vj7QyZqBmgxBbSw1MdimHhwJQRkjmTr1	12626	17740	17740	1619132400000
25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	25501	3NLRKyo3yhjmEQ5B1Wf6iXsttofV7fKJeRnNEziwHmXuZ7TS28Wu	1445	924	486	12463	17290	jx7YotzBzdysqyp8TAvicecFV2L9oBZMCq9bcRsp1dPmUgUYw4M	12629	17743	17743	1619132940000
25504	3NLQr8hyyGZrQYEmZwRanEi521pezPhZjPpPzZopFKa7d8QiN2oa	25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	1651	1055	486	12463	17291	jwVQdAdmKrLfSZjo7jV9wovvpm8cuLbamNqr3MttRvvCWhRPF7h	12630	17744	17744	1619133120000
25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	1581	778	486	12463	17296	jxU1nB5ZARfmTSrqjGb4jK4Z4diRp5wFgTG3chkw7jjBugjGWYW	12632	17746	17746	1619133480000
25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1406	1393	486	12463	17298	jy2bce3T4TpA7o2pt1t2iXAWKbePr9kqhNecDeUL7J1aLgAAT6t	12633	17747	17747	1619133660000
25514	3NKiJhRb23YPZVHahjFEqYYx9MNCu4Y4usLMv5bohcM9LfTeGmVB	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1501	1360	486	12463	17299	jwyZ7po8ma3LeXu3oiPtQNvbpwtYQHG272jA1bNzt4iqX4yQNo3	12633	17747	17747	1619133660000
25515	3NL4pj13UDtbJA35XdeL27BenG6xuGRrYyZZGVJ7Tx8D9g76qvma	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	606	1049	486	12463	17300	jwKrV1L7ax9zrF47BhhPx21E2qwefxu5gDrAX2bBZ2o75Z5uPHV	12634	17748	17748	1619133840000
25520	3NKu7o5ad2xeYzmrJ73LVGV7HsEYs4Fuu3YABHEm8HF7znGrTEFb	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1654	1340	486	12463	17305	jx8YZJmsCp2o3oC2HDvfiAA8E1Mh6JA8o9SUWddToaEJFhpfYjH	12635	17749	17749	1619134020000
25524	3NL7HNFpsoa591EaHuaa9xmCAKjo8WB5ejiRdGJkmjtURpNgCKG7	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1407	1395	486	12463	17308	jxUZeHzwQDQwFHU5z2LNYWAFmmgSGrgaFCxjbUd5HkY5aKNj1YW	12637	17752	17752	1619134560000
25526	3NKkP5nRZigKb5B43M6mzpLsaRBMaEdgbaUYoBQ4srdavAPTTfAV	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	633	1384	486	12463	17310	jwex5orDdEn4ddDqAcsEZJnUP6VD4ZhSkQijZDhQ332xtNC53f8	12637	17752	17752	1619134560000
25528	3NKJWyxritHZx6BnwB4RRoPM7SZ8RHXY7x3Rg9Pi8zwthgv2KQKE	25491	3NKet6gukUEDmYVMp6MGa9BUBJuNbgAtK7mMyHHsrKSck8JR2WSt	1637	816	480	12463	17312	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12476	17752	17752	1619134560000
25529	3NKb8Ju9Hf5E2K2vypN8qhutqFRnauU3rDEiA8F3XiCP6sTVYTMd	25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	484	1319	486	12463	17313	jwsurLdBW42k5rU7dSyP73J7ruDpzNEqaHLFCMdeneRdjnStN5z	12638	17755	17755	1619135100000
25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	25530	3NLFwixm3sxmYrZV5FtcFP5MQuBP5ntvs6xZm3RAfmFRWBfCWn6a	1646	1228	486	12463	17315	jwXSxgLLLjCRx6qZB7iRxD9B4i94YPrSNyqx1rNqzfeSsBRv4FM	12639	17756	17756	1619135280000
25536	3NL8MxprYccx1cFTHDy4ifMazxdMd9RhEo2xAwhCbXB2eikR2c2E	25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	43	1184	487	12463	17320	jwTpowP6LSFL9dGcdDKmGbQFm9BcqHB8xbSBppoD1Fd9KWWjeD1	12642	17759	17759	1619135820000
25541	3NKhDX4NfMfSBepTVqExiZxUFJmKRvsUkQTk6gqgjKZkjw7QJwT6	25540	3NLK2dzcGKdYHuDvc4pf1JhLdVy25z7ijiQ78Hz2vafEvxC1d34h	1672	1159	487	12463	17325	jxeqK7GvtcRTnagBR6DByeP1nrCSbZBRTFNpHf3h2zHouDgQMSe	12645	17764	17764	1619136720000
25546	3NLCbz4ijvJYLVatkUtNXWkgnEVgTVo4KyVyXHfxoJzo2RzP2ZNi	25545	3NLrrXE7QHmqJfUvo6BLtAGFeq8Y1WStnjjnZ4zmWuNKaaFYT9ru	684	1352	487	12463	17330	jwUDKYX2tbqHKipdUPGS5911djiEAn6XAZKTbauUxUQdASWsK3y	12648	17768	17768	1619137440000
25549	3NKTeZfDzicPajXmH6jwDTYMQjT1jW4MEEK3CF1bnmhguaHUBV8W	25548	3NL4gaT97tgJ5uJRNBE4gc1PGQBgkLNEw4M5kGC1ygWUi6c4GH1m	1622	1356	487	12463	17333	jwzzRaBw2j5UpWTHzNmmmZbgWyWhWW8fcvLanv6WUmmMeWqjCkW	12650	17771	17771	1619137980000
25551	3NKoDtJCZNsknvgjq4QLbuHeDvhGpk7znpY9ELLgxpy1pnUUtu3z	25505	3NL9oXQ6anes8YEVS4tXwqApVPX2DdfxtBwD5Ue3Z5BUG5kKSadv	1555	1347	486	12463	17335	jwarAX1qp7rSt3ntCyLm2sdmebfbf51RoNRb68PgEZzEQBghMTm	12632	17772	17772	1619138160000
25554	3NLiSjjwiFZVbDjduanteSZZALtbtu11NKxERacbLqxbeCDPBrTZ	25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	1546	973	487	12463	17338	jx9ZWEL9PvazjCPf7zHq5eqDvGC7VrbBbHZbcGtY4bGtTGvXVRr	12653	17775	17775	1619138700000
25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	25476	3NKTyB5QsaBYqtYdY6XQrqf9UsfaaZbxM7s35CsSkE4jDH8DXaZ7	1536	1067	486	12463	17270	jwQBZPY99WcoVXWhqfn4tPg5AWh8QirgtSVCfsFtQGYSgktrjs9	12618	17731	17731	1619130780000
25480	3NLnaRzHRji1bMG9vKZfyqeprctw62hqG8m9mN3gDiXs3jwUB6R5	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	1559	1353	486	12463	17272	jwWdFBCP8iJaqVh3iYJ7ojtg1pUgKQd5WLoN2dnaUZMKQ3AsmS1	12619	17732	17732	1619130960000
25485	3NLeRwjVYyVPd31LpNiWJncjyPzBFfR7KCrKvxnbV3PQwesed8jy	25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	1406	1393	486	12463	17277	jxQ1mxQSRakKCLz6qJyf6ksLquJvRDm1NmPfZHBdTrQFt77DQf4	12622	17735	17735	1619131500000
25487	3NKePtGZ58cXCQXh6af3w42chKGPz416KkoFqgoKB2UfJmAxwuPs	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1406	1393	486	12463	17279	jwAr3Py7vC6pgDt9HFvPvPhW5paZcHojVJ6LEukdgiSshD4kq7R	12623	17736	17736	1619131680000
25489	3NL2M35jSGdkz8w9AdNJKpNMmGHLsMDdC5o6MZMRdJAT8xTp2n3j	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1560	925	486	12463	17280	jxa3x6ajEdaxDb1PjPJFQEu6WivSQXMFiJ57ji4i7p5K4kzDYv7	12623	17736	17736	1619131680000
25492	3NKp4nkycw1taq8UXn8uR6YLtBn6atveaxYEWQFokLa9kgYuDjc4	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1460	958	486	12463	17283	jwkDPdLKB1CybfnyxEG8upxAgzGiiJSgHu1MY8ZUpJF8qwsERM7	12625	17739	17739	1619132220000
25494	3NKf6XxqqFLGpFHN5bvdjW6FZrBoHc5zCpuBgxeJRP8GdE2sMy7Q	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1448	1311	486	12463	17284	jwBQf6CDEyfU5eMLiJbDWRBqMk7QGN2Y6zmH137AcMhpUQrdTxf	12625	17739	17739	1619132220000
25496	3NLCLx5YWnxAtb3Toam5NbVsPbHVJz1NxrqmWkQuE8zcfb78anaB	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1500	1297	486	12463	17286	jx5yCY4y4bDTVBLX2CmYhFKJWRgTZjZDFAvDq1gVH7FWQwZD7u9	12626	17740	17740	1619132400000
25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	1651	1055	486	12463	17291	jwFmCHQmwXnCq8PjpqjexXSRAgckTBj75Fef1ez9G6LSGEHRKjK	12630	17744	17744	1619133120000
25505	3NL9oXQ6anes8YEVS4tXwqApVPX2DdfxtBwD5Ue3Z5BUG5kKSadv	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1407	1395	486	12463	17292	jwWWLc1C2drSwn7E97YmuqcrpJoHcLLh4HyBLhKiVbFRHAh8cd7	12631	17745	17745	1619133300000
25512	3NLwqcPv2zePsSiXDYSPVtQmyt6vp6SHWfDfE3MnatdzJagzMYJx	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jxiLZ7uh5SEMFAXcRLtnWiZRhGpaje47sZa8ZPwTpm3h8a71htp	12633	17747	17747	1619133660000
25516	3NKyQqGkz5ETADfrchHyr4SjJp9dN7KxBCRMTs8fa36gUmwqAFix	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	58	915	486	12463	17301	jxtVNNrLVgGg9NTYRNJCbPWEimRuGpdfPVbrMiv6UbSdfdCSKpz	12634	17748	17748	1619133840000
25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	1581	778	486	12463	17303	jwuAjMbXgPpoescZxWmXeuo66oVHPw7c2JonNyjsZq8sGtgffhS	12634	17748	17748	1619133840000
25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	25522	3NLtsuQD8UcQHaTF4T7pi4woJxiVe3nvKqPiEJ25qf9G5m8xeK9R	1668	1370	486	12463	17307	jxjrbmjmbiDUK8rM39Sb1xg7Gv1ezSX5KswRodjHxrFYMKsRkzd	12636	17751	17751	1619134380000
25527	3NKiuNdAPDbud8UKBXKAzz98WvQZqDyK53W35s6Li8noTVaofuMW	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1553	776	486	12463	17311	jxX3HRgZDNdJyZrY5e5ia5eaS96rz2ondteYHUURjNs5P8VganY	12637	17752	17752	1619134560000
25530	3NLFwixm3sxmYrZV5FtcFP5MQuBP5ntvs6xZm3RAfmFRWBfCWn6a	25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	1647	1302	486	12463	17314	jxyuwMwF7ChhySQTN7A8dxTGtAZySnHe18DoH9W7BqUFQEkFMZE	12638	17755	17755	1619135100000
25533	3NLWR5MvUyLQ6NMsLVHMosxteGNmQYNe6vnaq1oqEzKahW2Zuryt	25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	1403	824	486	12463	17317	jwm6DNkEsmDxt7181jKknUkzrrJDSbiYuzWXrQkbQYPvzW2c6n7	12640	17757	17757	1619135460000
25535	3NLWRDkhcMQaUBCJvsQCBvvDkFXtgicVzpEhJXUG2hYBKpQp5rz7	25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	1406	1393	487	12463	17319	jwZxQV7f7QTvCyXve1DYqxFxN14rSGJnpzGXnS1YUJ5jh8WtUzC	12642	17759	17759	1619135820000
25545	3NLrrXE7QHmqJfUvo6BLtAGFeq8Y1WStnjjnZ4zmWuNKaaFYT9ru	25544	3NKRbeoMgFEYqV3Dt7RF1zYY5ff5YmG1Y5Bmi7AQeGbVzr69nrPq	1403	786	487	12463	17329	jx4zbPjz8jPyrADJo3pfy7j19f2in92vaom8BZttS1c3nioQRFo	12647	17767	17767	1619137260000
25547	3NKAs1VvjVxQd8yHZ29LwMJzmXivrJ1G33iKKDybkfdARre4CSx5	25528	3NKJWyxritHZx6BnwB4RRoPM7SZ8RHXY7x3Rg9Pi8zwthgv2KQKE	1637	815	480	12463	17331	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12477	17768	17768	1619137440000
25550	3NKjLbEecRBHrcFHYC7NtzJQmcKUR9XxX6qUex5JeMBvewatHxKy	25549	3NKTeZfDzicPajXmH6jwDTYMQjT1jW4MEEK3CF1bnmhguaHUBV8W	1555	1347	487	12463	17334	jy2EwGbxsZP1p43MSB1icsaPkw7gvv25AvhwrVHYdtPHRjRd2t7	12651	17772	17772	1619138160000
25555	3NKsX9uDTL9zqYe8PDU32tW9Mmau1ZVh4aDRGQwSfCbNtQK8hsJ9	25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	1564	1338	487	12463	17339	jwSVX7ihkyvFtcfsZoh1yAUti7miyCmCjcmUkfMi5236apDqRyr	12653	17775	17775	1619138700000
25557	3NKun6SvVuRXXi68ggySHJsFojT2nunNTAUNDhsYC3XCUwg8iyps	25555	3NKsX9uDTL9zqYe8PDU32tW9Mmau1ZVh4aDRGQwSfCbNtQK8hsJ9	1489	1134	487	12463	17341	jxMiQxPczp265LV6MqzfZrAk5ffWwSm23TQB4vqyitq169w2Dh7	12654	17776	17776	1619138880000
25560	3NKqxW7rup3Wt732aBTKnMeDxBXKzrSKEi4KABX3me7r7QFKv5hD	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1423	282	487	12463	17344	jx4XTZUvbPnamVj5da6qst5vDqufjYB3b9wNm4y6vjA9Bc9cUNd	12656	17779	17779	1619139420000
25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1581	778	487	12463	17346	jwSrUcYo79fy3c74DTfiTwcHnBwJ1DRfKaMEe3J6Xfr5JfpSRu5	12656	17779	17779	1619139420000
25564	3NKy4VzLhKDgMUa1zfdmLRidThASwLN6Frx5WTbi5eWJKxjWFage	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1651	1301	487	12463	17347	jwDr7ASVt6bg7FztXWcWm9dQrhqWEvJkQryAhbBrxBPpC2HPzZE	12656	17779	17779	1619139420000
25567	3NKWA18doBsZ68stQeNhXAns815sbTfG1b4u9xnBLPiNxmDDyhjt	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	1585	1366	487	12463	17350	jwKrFBiH6jwxdNLRmSXkZEZdZBFxakht8bwh1zm2GUyeVk96pRz	12657	17782	17782	1619139960000
25570	3NKsWDkEAD12Tj4pfg1rtNwMP9eB5GbHEFxwjT1HPbsmVnSLBFTb	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1613	1349	487	12463	17353	jwDCZBTEwSk5F4cifEqCLxpg2Du8Ax2nyxqh2iM3ewmV29uWWbR	12660	17788	17788	1619141040000
25574	3NL1wWrK8V4kdm8KtTEe3spg89NTfmZan7WY925n5UzkoLWQwfPy	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1581	778	487	12463	17356	jx5nQ5rmj1vZJZhU23RzG3fW6edk3DmSSAhVgyjDfpFh8jxcniF	12660	17788	17788	1619141040000
25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1406	1393	488	12463	17358	jx4fseZwoQAivcWPoiSJEPYsB9XrW8fMraa5QCAks52fWcyd5ig	12662	17792	17792	1619141760000
25579	3NLwesic2nWCKCmGNRCMzXBED3Dof8gvLFj5xaZoVX1erYL8dJkZ	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1581	777	488	12463	17360	jwk6aVnGvGYAmyJicDwDNShEDnnqBLbHLpSW8ZvtU2uUeRqhMyr	12662	17792	17792	1619141760000
25586	3NKzoCcSV994P1mVBgHVpVaLTPdrDxgHFJJBdZWo2PtAdyCBit6V	25580	3NLm6aecJkQ2VrxY9jeu9fmtYLocnBen6i284RpQBoPXq6F3jsyv	1440	1377	484	12463	17367	jwVhcb3DSuDNWdoBSzHZkWpAvYRzQyBarCcTBbN7CLGfH8rYmP9	12591	17797	17797	1619142660000
25508	3NKAaNb8CTCvBNfdTKPERedEdEFfMQFWXSPBRX622sh5XsbB96RS	25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	1627	1139	486	12463	17295	jwvCJP4icEMbdXCYDAkkbvQGkgE8tffMuHwzXioTBqDtXcXFLmS	12632	17746	17746	1619133480000
25510	3NKbioA8GS5oadF5ufbj8Bg3YUP1391vK7HvrGPLamTHKN62giaq	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jwXhyyo2DnrEZFka6aiQya8jnXQx13WEz1xtkfFdeaFj4okVGfE	12633	17747	17747	1619133660000
25513	3NLFSJhnsTG98NBiCia2zMDpEHFK3TK99nY8sKuFqcvZZxGVvf9D	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jxSt6wza4hBz2iQaovxsYku5Jbvnh8EVTVBXeYbvXsivQmA9XE9	12633	17747	17747	1619133660000
25517	3NKqRCqmnvQxxPhR9kjz9CbHjYy4qgmW1dKd4LB2fHGXLH3K5WBt	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	1656	977	486	12463	17302	jxH5TnWn3PqhGGwBkBJBrA9o1ttFt3BUFK97Xf79Mi8rxvR1mdL	12634	17748	17748	1619133840000
25519	3NLEbt9HURxoQ6cjaEK2VZuVuxok4T76v6fK4tRXCe3o9UUccakx	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1476	1371	486	12463	17304	jxA4eLMKhkZUx1kA6BZHPuSgHymD4S1Xi2E6S7XjJhrPCJeqioj	12635	17749	17749	1619134020000
25538	3NKzHpGgesvyCCDD8WApCUSNpNBv7v1RDQQErnd2SD3K9WDB56wG	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1407	1395	487	12463	17322	jwG9MS47rRzspJEsu7DAqk6c3saLTQCtZUAAfLBoF7AnSikk29M	12644	17762	17762	1619136360000
25540	3NLK2dzcGKdYHuDvc4pf1JhLdVy25z7ijiQ78Hz2vafEvxC1d34h	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1561	74	487	12463	17324	jxzoCVTHrcuM7szzAMAP8AwgD82jEQNM1D8VfzkxNDimi72rUzk	12644	17762	17762	1619136360000
25543	3NKPJiXMNiHgaPPK2yXzKWgY8JdoCCod7wgodQwu82MR5hHdH1Up	25460	3NKEKt3gbDGJJ66ybU1VvExmAantx5zAHNiHyjy6kjPpiNKkmiRn	1419	814	485	12463	17327	jwsd7DaHvqvZrAJ8xA4ptECb4mzCQXEtf2dn77kfZAYsX87y4gv	12608	17765	17765	1619136900000
25548	3NL4gaT97tgJ5uJRNBE4gc1PGQBgkLNEw4M5kGC1ygWUi6c4GH1m	25546	3NLCbz4ijvJYLVatkUtNXWkgnEVgTVo4KyVyXHfxoJzo2RzP2ZNi	470	1309	487	12463	17332	jwBbJrenSpeNXRezxapU2dPjb4BcvJka4KrNkRLeRRNWNAtZTyg	12649	17770	17770	1619137800000
25553	3NKnY1JiWciaiUscXvc7SNg3fP3F4HT9JxZFe5pYJKs8f1t6DurC	25547	3NKAs1VvjVxQd8yHZ29LwMJzmXivrJ1G33iKKDybkfdARre4CSx5	1637	816	480	12463	17337	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12478	17773	17773	1619138340000
25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	25557	3NKun6SvVuRXXi68ggySHJsFojT2nunNTAUNDhsYC3XCUwg8iyps	576	1355	487	12463	17342	jxdaMij3EnGdVCGxHSYcoQqnEybUHb1YjNB8ymEB1kyakipsurh	12655	17778	17778	1619139240000
25561	3NKCV6vKHSb4LV95wweQsobS1TdRFXjpxNua4oH2AyFjSyUHJ34N	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1403	824	487	12463	17345	jy1yu952UT6ADCttUyavXrx75fYcr6yewdS7gqZG6gnY6DreFHG	12656	17779	17779	1619139420000
25565	3NKxfy55n3V1TQ6gdxz198CgShuk5s3rHeh9oNMgvSMSqbBxaURH	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	1602	1003	487	12463	17348	jxTVDrLHquup3YYtkyo43d8KjY8Nj9HifAVdvGx52SePFTZqDFL	12657	17782	17782	1619139960000
25571	3NLDkk3e8QXcnzFqeGB6wMPFWeFukuPSEcgVtgaKuW5oCFpK2CW2	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1613	1349	487	12463	17353	jwm68tuXt3H8DSNGscijC6PxA7xFY1JoaBe4utvVrfMuSGLgvHZ	12660	17788	17788	1619141040000
25582	3NLdnhDczShwvKQoWLDwtkCQVgZBaXmHGC2y6dyv946QekVDC253	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1671	1365	485	12463	17363	jw8N9tmkhNk4aCeU1N8t6K3WN8WMSkHsCX2oL49ueQQb6B6V7HT	12600	17793	17793	1619141974732
25584	3NLqnFFKEBBq5iNfLxueC3BvSbRiMVFY4RR4Zgh8jedz7eExBmbM	25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	1671	1365	485	12463	17365	jxiimXeUpRVnEw53MM2TWkFvwPCKYNkz9ocTqg3broqDYUgBg7P	12610	17793	17793	1619142010706
25587	3NLuhEc3jPPg4nnymoU7jKobE9yTaTZYyjrRfyhEVVWAhzKtZaL4	25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	1440	1377	488	12463	17368	jxDpuSpK4gnHvBUjnvfx2Z6SyALfQSKatHy3Gvig6Lq9XmN1g8E	12664	17797	17797	1619142660000
25589	3NK3wFbbeewwAqUej8gUH7KkkrHRJVJSRxTkoQSrfFJACMRrxUkm	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1407	1395	488	12463	17369	jwyyRUjEAKXWXzhTBcG7rLVdH1KqUpZm215nEKHMnFmQtenkxc3	12665	17798	17798	1619142840000
25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1607	1348	488	12463	17373	jwwZBPndh1TcmLw4spi9ARQPuoTeer7ravs3usdteKHCfffZge4	12668	17801	17801	1619143380000
25596	3NKQVCha5HqtEcfq2fQsgrBS9FpqASNcqVxUXttwNbSunVzzHL7Q	25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	1637	816	488	12463	17375	jxFyfTBK6MXaT8F18ZDdMoAzxzSUxSHShRTs3GyPznneChSKmrN	12669	17802	17802	1619143560000
25598	3NKNCd4GCpx5HYsbBWTTagK3BpK4bEMuT4oFAiTFHFrKV1Yd14Zi	25543	3NKPJiXMNiHgaPPK2yXzKWgY8JdoCCod7wgodQwu82MR5hHdH1Up	1419	814	485	12463	17377	jxxYrYEijmQwWfk3eEirAN5A8KZwwCYKFcfg6pXXDRKyvhjPiiE	12609	17802	17802	1619143560000
25601	3NKhcFaFnhSRsFdudv1eELPNdZWLdntAPiwr2hNNKjpiUhXPHTx6	25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	1656	1343	488	12463	17380	jx3MKur9fA9YzL171xZ2b8zUv8VtRNmZgjmvcr3q9bb3NNJMzTt	12670	17804	17804	1619143920000
25604	3NK7uGZ179Ewg9BRD4zSZgYwJ9n7zM4EzGApME3n66ECg1uApv87	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jxyJuNcXGqocM4DttrSPGetVi1gV7FESbu2nZhoDAVSmSDazLYw	12672	17808	17808	1619144640000
25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	25605	3NKrqAKtHAErgGWJjcEepHb8wrJ9tt63F8HjVcPvDyNWysYppuk9	1405	865	488	12463	17383	jxr4JJxmMBcYfyQFBKxkTU5rYCyshXEcC455p6z9n51aLyKLmst	12673	17809	17809	1619144820000
25609	3NLRP9o111jhs21AGPrkP6jSydzYz8S6xzdrBdzUVtYN2fnpMdap	25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	1440	1377	488	12463	17385	jweHaXDiyzduBMZeapbsXEFyKUFHbntZ2Laox7yW92W2cqTrtuT	12674	17811	17811	1619145180000
25615	3NLGAqJvT5qVHT7AUu9bVVwrBdwRGEx57HFyGLjxU1keLWSK6w1b	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1671	1119	488	12463	17391	jwkQbs3FQmqJrojuJpBZtu3LY3HbW5vn6Cbup2psvEzfA7KKWRB	12677	17814	17814	1619145720000
25620	3NKwpzsdTjEmXNBwJuZNASJBMM6nXUs3HRkuffHDrA4fuHJYLwvM	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1483	217	483	12463	17396	jwugWaNa8vA8EZEtfYEfnHSK3z12aY6WHCQUe4GRqUWJ4bThU19	12576	17818	17818	1619146440000
25625	3NK9pwaU4McmaEXPNSSMzH1UxKmwALHzoSEbSyYMZk2caFS3133a	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1637	816	489	12463	17400	jxh5TY1WMjGmf64pKoFMQUbbZgvwP2ZSQxMZALnsG2Bk2D34KZN	12681	17822	17822	1619147160000
25627	3NKxvbYEYysLyin6UNUVUpQaNCixnvng1dKvryoBsu4gPYo1p6m9	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1643	1299	489	12463	17402	jxPD7rBMTV35kRbNWBVLEhDVxUZaNbUaYZB7XPLQesob9CrLQ42	12681	17822	17822	1619147160000
25631	3NKQcxJjs5gcikm7zaMtcHaDPabEZaZwtDjob1meTY8zvBamETpQ	25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	1587	1111	489	12463	17406	jwnbRAAtKndtmYiZsf3EYCHappsZgpiK56sp6K5CVo2FN6DAk7e	12685	17829	17829	1619148420000
25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	25638	3NKJ9ubfvjEv9Y26C6yivto34ecPYwDCGGteiwAgKr33T7F1X5Bv	1406	1393	489	12463	17414	jxwoLX4BtwpP1hCqvGFmCCxKzjZLRPG7bycN9pYgX6c4qcw6CK6	12689	17837	17837	1619149860000
25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1555	1347	489	12463	17416	jxtBCerQoaoX5cvkBRMQ3VFLnww1YVagkbxWnWq6hAQyzU29Nsw	12690	17838	17838	1619150040000
25556	3NLm9M1dC5kmbwnfhHexRc47YAQdW4GqU4MwcgYdDntP8ZZAPeu2	25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	1546	973	485	12463	17340	jwmb5BUvydEzVtcm5rD9J4Z1qtmZpvpmiDGPNdm1xZQ99amAaYE	12601	17775	17775	1619138700000
25563	3NKWNWfjf2HcoCccz7ywLWa5RKNqLRT6CBxdRqZzf7SrNMRS4H9q	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1651	1301	487	12463	17347	jwcNAbd1QBFqW2UkBwUUUrVDtVXn3JNnjyBNfFXCoRnZ5QWAcYF	12656	17779	17779	1619139420000
25566	3NLQuw1GCRDve4EbnUY1UFvNqjpww7YzhZKWvVNkvXsAhbGgUN98	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	662	662	487	12463	17349	jwMYAzKsKH5knDTJyCBMA3X9sh4jgRE8euVbkUzvA9buVSySrDX	12657	17782	17782	1619139960000
25568	3NLj29vq85DSRKG39JxymVLoUhhYq9JbrLXvhhTZGZ29ie6KLtot	25565	3NKxfy55n3V1TQ6gdxz198CgShuk5s3rHeh9oNMgvSMSqbBxaURH	1671	1365	487	12463	17351	jx28EzyUy5otuPr13MSXUBgJLuRqTCzUfV35yaqjbjihwvNbF7q	12658	17784	17784	1619140320000
25573	3NLoBmHKmexHj9PEnzJTfEm2NhMHikwWzPYHAFRTVm7ZxM7n5mYr	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1445	1290	487	12463	17355	jwhMjGqhhUGS3SaeMYZBgMkcaGi6KDHWx91nKsdUNKH7CuXHHt5	12660	17788	17788	1619141040000
25575	3NKwpAPe9BJJsV4cfCEwJAm4bnRbR5asSPYCtx6hGDLnNMEB7BBj	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1460	681	487	12463	17354	jwM8FKaYAoYcMCYqMC2E9YnkvqNqAMgaHZ1Na2JwMKRwhJCLxBD	12660	17788	17788	1619141040000
25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	25570	3NKsWDkEAD12Tj4pfg1rtNwMP9eB5GbHEFxwjT1HPbsmVnSLBFTb	1581	777	488	12463	17357	jxCsW4GPf2YWA9Pwi9tM8AhMy7EH69QMefda51TaVLdHjJrYV9U	12661	17791	17791	1619141580000
25578	3NLPWV1VhahvmSEin2ytsGXzB8YE6iaMCyFpSQUBpwJXaFXEQWv2	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1534	1071	488	12463	17359	jwvGe9KKqNTJG3t946mQTQmnz5AP3jGKTPcWCxErCSxrqrH2qTq	12662	17792	17792	1619141760000
25580	3NLm6aecJkQ2VrxY9jeu9fmtYLocnBen6i284RpQBoPXq6F3jsyv	25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	1671	1365	484	12463	17361	jwb5n7Vv4Yuue7CjEYG6YRHxcGWtY3FY8wiDyjhi14keX1yhHwx	12590	17793	17793	1619141940000
25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	1671	1365	488	12463	17364	jx78zw2vxkh8FEHqwBAwU3oqXiVpPbBgPZ9cj7UfChERDELi9Ux	12663	17793	17793	1619141940000
25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	25591	3NKUgVViUsDHtEkhy3jBG4TVEYxjMSdGcq4CLnR2Bcx49exNSBoQ	1462	471	488	12463	17372	jwfZSCATuRgtGyC9fJhD3A2ysPQEZyd37eQ7zLu33W1GUATSx4d	12667	17800	17800	1619143200000
25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	1553	776	488	12463	17378	jxsPcUDjco9qbCKx71Z5LX4cXtCvuyQQJjYVzFtAE1QNboZLc2B	12669	17802	17802	1619143560000
25605	3NKrqAKtHAErgGWJjcEepHb8wrJ9tt63F8HjVcPvDyNWysYppuk9	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jwgvB88mf8cvcWAxvs2UemQwBthiaKq1s3WPrucx61K4c1hPeqN	12672	17808	17808	1619144640000
25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	1471	1140	488	12463	17387	jxfXhS2mrCTTGhCwEGKeXNAojsDmivfKzkRHohSfjGmCT7As9LN	12675	17812	17812	1619145360000
25616	3NKPaQdi3DbS67qC8WfSy7KnQSs84Ympu1LHzvN2a4shPEeqofPN	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1406	1393	488	12463	17392	jwfsJPH5zqab2iXmJikChidtBYoGJPeJD46ZkFGvzCjmdZ2N4V8	12677	17814	17814	1619145720000
25618	3NLgHPMgao561bUjDu6UCqVvWpb8BAc3NiHJTwmbKkuy9NgXbSaA	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1403	824	488	12463	17394	jwYLgNvjUB4GmjUuzfDNnVD7CuZLLHLFqmjdMcen3yNXMafz2f8	12677	17814	17814	1619145720000
25623	3NKW5PXAHwAeU9YMJ21CaY8uCfYFNX1vnCv2Sjet5oMuuuSg4buZ	25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	1460	615	489	12463	17398	jwT5wfqm94SgLBjgs4wh2siM1CUiZ6PcWD8Wx5rWq42iPCLzCG4	12680	17820	17820	1619146800000
25628	3NLTdoniCiqDHw5LUheyBia8vpLxPwc1qAB4J3LmPKvMRSWh4u48	25625	3NK9pwaU4McmaEXPNSSMzH1UxKmwALHzoSEbSyYMZk2caFS3133a	1609	1333	489	12463	17403	jxfGwVExrDZrhepbH6oZrKuVfjzqJ26BGEutMz2r85udYeJ1av8	12682	17824	17824	1619147520000
25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	1624	1088	489	12463	17410	jxgUTsDiSZAbdR8My5VqTt32Xa9CZqVSM3fsY8BVzrSFmv2sPto	12687	17835	17835	1619149500000
25637	3NKei4PoYVHLCYFH7Z3AnHkuuWKsPKPK6PkSJZRvn6akfdj5xsyj	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1614	315	489	12463	17412	jxxw2NCc5akn2cGrWv2o51tS67go322MZBFMXL4Cwg1fm9nVLsx	12688	17836	17836	1619149680000
25644	3NKjcgTKC8YUiB8fUykRpeLS2qMk1zgutBMwCxyVPuM3WfP8fKqc	25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	684	1352	489	12463	17419	jwxBcckv6s8XeDVvDkrEdKW9JqEW4H2PrMfkf9xWk9mAZAsz3wX	12691	17840	17840	1619150400000
25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jwSQqA4ziwpmS5Aszuj4zN7ineykDuzxPSJMaNZqZff334gLR1i	12693	17843	17843	1619150940000
25649	3NKCxbjwAaJtWjc6aiKwdbssfDmeCyr2C3sviWn4hhhnuGc4MvBf	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jxrScWC5hddg7gKBGTpHoPPsPBngGsRCMvE4JmK4q5SZu1TfsXr	12693	17843	17843	1619150940000
25651	3NKCRBsuGjvCjeKYMNrw2WKTRshgo3E9U3jEJe7vfs9v1tHLmSZX	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1590	1174	489	12463	17424	jwnfccNf5XpKt7eskVJqHxL8hnvjFW9DYeQQG7Gq8nSQ9Vru7bj	12694	17844	17844	1619151120000
25656	3NLwQ1bfHMGFTH6XboF1GV2oikuu7K1nrd5zK5oiuVYrKiX5a2PV	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jwgCzUnaw4A4b5BSUz66JpTiQb4GPtMfx3tcfHyMDAc4DD72ZDF	12697	17848	17848	1619151840000
25667	3NLMrzymnXV5gxpsVTULjoPJWKbwuGDYDN5TCq4EM5VxPrufKiJc	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1406	1393	490	12463	17434	jwmLGecYuinZYzXvn3s6GYPGeAKR6XfcnUPg6N5gkYN54S6M8PJ	12703	17859	17859	1619153820000
25669	3NLX6jWFFz8jXMqfPa7eGrxFtVzDzBwmWRev26q718sSozhEKpK6	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1631	794	490	12463	17436	jwseU81snWhPDhf5GCuNL6CeA6zwVbaCnDEUBqncRsBDUrCUwrw	12703	17859	17859	1619153820000
25677	3NKNpzokoguE2dHkcDHRmGJu2bEocwKpufxCFyTA4SazbwK7R2nK	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	338	338	490	12463	17441	jxda6WnrPk9S288X59q1kcpxqxdk9dh9Me1MrQkiyFdM7Ww9tt3	12706	17862	17862	1619154360000
25681	3NKT6vUkskzyApvfvL1vHxLpNKXnG6zcxVkvQNoRgZPrhSqNNvF2	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	44	1079	490	12463	17444	jxUmZGXpDsiPvJC5FNqcdjFgfmYdkgyaSfjfZxMHjjaeSCqqbBt	12707	17865	17865	1619154900000
25685	3NKKP2GVvFubGu3AiuFmVZdj41U1k3ejXMDbSxXhW4dUYxvUbyZ3	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1406	1393	490	12463	17447	jwjm1pokjNgexsBcCFWKA8eB43ebtgkEguKwk48fgx3eUSN1imE	12709	17868	17868	1619155440000
25687	3NKUfmBpKK43X3TnYZpbQ65vgfwhxofD6WQixCtACCFjQ18WEv2P	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1501	994	490	12463	17449	jx7b84MHjkUfLxZoxZiiSRUzktpSAe23ZtGgn4t5eoWankwg1mA	12709	17868	17868	1619155440000
25690	3NKkwu9NexKQAQKhWurZjwGgJXT8xk2aFdPb1VVFCYmjxBoVsQHW	25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	1405	1	490	12463	17452	jx3sTGqcd8NJyGSc641SpwYDvVFHCMgc6Ey9W8JNMmoZpxStprq	12711	17870	17870	1619155800000
25590	3NKNYwJdyd3LokgN1uXXA5mAJTBKpHgJnHyvSmNGqUVxgtuRXZN9	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1406	1393	488	12463	17370	jxUxKpeY19bNNFRVkQaqU4rxLWqUrVuePT2co8Lg3zZMuT9ioDr	12665	17798	17798	1619142840000
25593	3NKMFf4DCrgzyUAGU6EZwpUPbsa1t2zQQzsA6NoanquWkhLg24mo	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1607	1348	488	12463	17373	jxwbTNyUGEEFttWZaR1Zm4j2s4Z4coCmFy5htZXUrptM7sN6pFX	12668	17801	17801	1619143380000
25595	3NKwJubrMnnniT4h7uRkDbxYfjhtvB77kH1bKvGaw7NDuj9qWbSs	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1590	1054	488	12463	17374	jwS9hsnrHAcz7B34Vsg6aZawy3WGRNvCEsBWRQMTr5Fn8fuzJ92	12668	17801	17801	1619143380000
25597	3NKregwkXLowMFnzeevLnt73APNC53ti4Hu5zSkrKq9UZ3mXpb6H	25542	3NLEfCE4tQygwayF1nkGSFrQQswWbhJsbsSvp7b79x9nprhxswYG	1419	814	484	12463	17376	jxxBejyHVvvSD2hv82Bk3WzvA1JN5CwppRHgDEjC3MzUVHcZQ1D	12583	17802	17802	1619143560000
25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	25600	3NLPEcFvjqmQFBXBKZM4LNzSF1i2dvHnEBi35qBzpXZGWJ1herek	1642	1001	488	12463	17381	jwLKvQetTmchyB18ojXwW3bAkmpPdAo91Yot7LUaVot2qvqtJBN	12671	17806	17806	1619144280000
25607	3NKsRfvADDdPgDBvUzycsCPjQKQ7LArLosYLgZ49mWhJnsVDtbb8	25586	3NKzoCcSV994P1mVBgHVpVaLTPdrDxgHFJJBdZWo2PtAdyCBit6V	1440	1377	484	12463	17384	jwZEpBGJQVa7HJAq3HTzjRSwcM1dWtr9zw9sXgFE22sEfCmMwug	12592	17811	17811	1619145180000
25614	3NLJjAekPP5koCKQYXmBp9CaySeAtT7zMuraCjdPEbbGKYFqu25t	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	1601	1388	488	12463	17390	jxv5NRUC1eNbuKg9W5pRfG6mUnEXofw31fyeNWMKi3kAMZDzBUk	12676	17813	17813	1619145540000
25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	25619	3NLZhSNyfyF8T1NUw6jSdgQwVRE52weEbCiEF6FcJHAZQqp5v9WH	1483	217	489	12463	17397	jxq5AgZfsXsb5pvocWb467ip5Vv8xxpZQfrj2mUzWub2xy5yyTw	12679	17818	17818	1619146440000
25624	3NLtviEr5zd3NszXWvZCp2TkJRynciYBZXVE4DuNaeUEBtAjmxdT	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1406	1393	489	12463	17399	jwWVM456Mv2fvEG5ViJYggAPAFbSuMJ47M2Xfop9yARGASRqzcj	12681	17822	17822	1619147160000
25626	3NLXPhtbXhEsp8ZRvqUEGkQNiKJ2Fbsw92kQLPRDVueA9gYmph78	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1646	1354	489	12463	17401	jxKBgUP5f51zqtpSfpCMdhEpYyShmFyRh8VoPFTC3WMRiNHgXdR	12681	17822	17822	1619147160000
25629	3NKFaHeANheQJh2Tc4kFJdfRHACDvDpvfS8pnPHve6aGmGvaBdNA	25628	3NLTdoniCiqDHw5LUheyBia8vpLxPwc1qAB4J3LmPKvMRSWh4u48	1587	1231	489	12463	17404	jx5U2ZGouDAXwWanEW2XziBzG6DFK7Qs49rQ96ikaTNinXbs3Wc	12683	17826	17826	1619147880000
25632	3NKT1brzMj6nCT9NF7fEamjbqyVFJEGFKf8sjS9NgdBSf3Pr4VNk	25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	1501	1360	489	12463	17407	jxcx44KUVTL4Nph2wiD5kEhwnwPWhMTHyTXbhEZb7441MNeBBVP	12685	17829	17829	1619148420000
25640	3NKB9AAtjeWYj7PH7N6YZsDr2fY6PX1hS2qLQyivYVv1NjNKuYYf	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1444	1381	489	12463	17415	jxuUzvhq7gZm5jqUMMzLUrBmPsx8AJuY9EgzZSxMw9yx9TKY14o	12690	17838	17838	1619150040000
25642	3NKNX1ZG8orEGK3AbmmoYLFd1EQPz8nQheNHtTQjteoHayLWNjTJ	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1631	794	489	12463	17417	jwJ1be8KgBvz13fqWSRJfudEfDkYaJnaVF9x3jWoyQ7BhrAcEK3	12690	17838	17838	1619150040000
25654	3NLqaxgXNhTJr72n57FGJttZvt3hHknBM7UUVZ4Y2W66it9qwJmy	25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	1460	1324	489	12463	17425	jwTxrb3ijudARM4gPTGBTTCEuLX8ArgpL4TqUfT8Fu9WMLNk51Z	12695	17845	17845	1619151300000
25657	3NLHV4Ux8BVSp5ybJfj32dN12U9BKod26DQspH4fihFKdErG1xD1	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jxnbkC29yfwx33bzBnqqZuF8TmXHMKKWEcdX4GydUWpdY13MsqG	12697	17848	17848	1619151840000
25659	3NLLusDayRLs4cDL6uhv7e7BdmXQUsDXqZQcjLKFz35KBkMWiyEf	25658	3NLfQFvtSbkKfG4vfhoHGsNbpE1Lcf6zB6hBpjysnHvdLTUpQnsr	1623	829	490	12463	17428	jxwhrcpoXppS1a9JXMeiEmdXxc1oYz6RnPrUR61AZAqJmZigfp3	12698	17850	17850	1619152200000
25660	3NKuqnwyED1gRjdMXnuBwZ92dvnULVUMRSLuk5PeSdrBzPcFsmHM	25659	3NLLusDayRLs4cDL6uhv7e7BdmXQUsDXqZQcjLKFz35KBkMWiyEf	700	832	490	12463	17429	jxxovMDxUFMs8iUDXAgi7skss7FmYRURUTwYBmDfsujuvmxjUne	12699	17854	17854	1619152920000
25663	3NKupZNZtguhQFvuJNHNkPzF1RUNyPuJEVdVv53evn76Jr6Q5L1n	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1647	1176	490	12463	17432	jwPsM1SS7p2Bv4qLQPAVNZoJRQj29fw1dGNRnFmhKzGGYZCqbLY	12701	17857	17857	1619153460000
25665	3NKhj2g8LztFX1w6vMb9wivDKAMiMo667jLzQ8dpJaezUmfUXdzm	25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	1536	1187	490	12463	17433	jx4XLXPEQyh2NgEKhgbhV6sxPAXNouNLBXtFzfcaw2EQZaQ3NgL	12702	17858	17858	1619153640000
25672	3NKGXFonpRxWYjaurDDiiKiiZqHuZbgxi55Hv4pP4JWyosStP3b7	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1590	934	490	12463	17439	jxS31YteaGX9GPpfuPfBaiUxbivvu1KACxSooniGCntGfCgKB8F	12705	17861	17861	1619154180000
25674	3NKoLHBsCvcSm73iTT9uUiD2z591fqgkxjBQwJLG4xyTR2g8ycAC	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	1448	1065	490	12463	17440	jx7ftAJGaLe7FPaXPFxsnYrjrLL57TzubLsYvrfQouVpKaURkjd	12706	17862	17862	1619154360000
25678	3NKmyGaUPLoYytUHRWvDTxVKBjDVKFtr5nX7hAUXcMoeYN8bVYkZ	25672	3NKGXFonpRxWYjaurDDiiKiiZqHuZbgxi55Hv4pP4JWyosStP3b7	338	338	490	12463	17441	jwR2Gj3g6UCrt8oCUA53QbVanXhfuGjNvFeEEiVnPJMpECik8y2	12706	17862	17862	1619154360000
25679	3NK8XL8BTy2yN9jRURoU9jwXK6atCKaC2LVW6zP61LDMsNVbMcsi	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1405	1	490	12463	17442	jwawMoQbZjiwEkReBu51nZTaFnndG7C7t1GrCVaN82ASm4MxXdV	12707	17865	17865	1619154900000
25682	3NKZRSMhmbhkNK9waosenpmcqZDBH8ijNfHqUyQtQQskNmK8c9RX	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1579	1389	490	12463	17443	jxhNh8eocGzUmdskAq5qdYAm2NTaXBNjy3iYoZPq8LYM69psrwf	12707	17865	17865	1619154900000
25683	3NKjmNrzpw1SXJ1qCFdj4gxU5DUcZxE1AHWuyWyjNtfmahsZy5fU	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1402	868	490	12463	17445	jwQstVT9GxHo2k38HZQGLR7t8DHvrZiAPBaKhALuSJRuitZnMSm	12707	17865	17865	1619154900000
25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	1483	397	490	12463	17450	jxh3TfKpZjbPMLwZ32ibF6uiSM7mCj1ShCPs693uSQoEwvBRVFR	12710	17869	17869	1619155620000
25696	3NLKq4F6AzX2N3XHnrUwPmDCYsL1qFSS2nxYosrFGP7EbxyEigjc	25559	3NLN841T4YThWpvcDM2EN5bZEDkG2WJsCTpg4SEuem8Lv51zrtGU	1509	1320	480	12463	17458	jxiuKN3ujDip7LwT6tX5poxqCBZAteuCEhxuyBNfb4uJwFLz3bD	12480	17877	17877	1619157060000
25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	1509	1320	490	12463	17459	jx8k4b2GHDndgXBPEk6wPKf2AfJXRzARMjHPhfAgVaMimvZk7m7	12715	17877	17877	1619157060000
25700	3NKaumR3tTA2aMSmBXfV3fsV21q7SgveQLRK8QmV45HmMQekWMRY	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	491	12463	17460	jx5MBXCCqj6eiy4VmEJRTGiQxKb2aAEfaRiHqDCuaXp7D6ffLKV	12716	17878	17878	1619157240000
25703	3NLuah91PXz8E5EFwi7HSXCPRyTnCs7SS57a1X1LYXcKv7vsn8uZ	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1513	1253	488	12463	17462	jw8E3P8SiBXa9UeB74bNd17J2TQsFNUdkrHjwaHwsUUaYH1pov7	12668	17879	17879	1619157420000
25712	3NK6QHv2FcHCjUo3Lu9UuwBtwWvuKW26R3ZEEpJjskMepU2XyhZP	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	1422	1211	491	12463	17468	jxFFDF2ct5qAVVyQCrmpihC6iKV8osr8XK1HhKBJfPPmDcxefFX	12720	17886	17886	1619158680000
25591	3NKUgVViUsDHtEkhy3jBG4TVEYxjMSdGcq4CLnR2Bcx49exNSBoQ	25590	3NKNYwJdyd3LokgN1uXXA5mAJTBKpHgJnHyvSmNGqUVxgtuRXZN9	1637	816	488	12463	17371	jwJNAn2bfzZ5G9CFHrK3gU8dv6s8FG3BFrVUMkwdbtqSYPiTHvT	12666	17799	17799	1619143020000
25600	3NLPEcFvjqmQFBXBKZM4LNzSF1i2dvHnEBi35qBzpXZGWJ1herek	25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	1609	967	488	12463	17379	jwk5qJg3ChRrPHTBPTfo5ZsAfAjy7cJFpUZUizE4qELwunE26TK	12670	17804	17804	1619143920000
25603	3NKsY9qkuVtKswhswfvM9Z2h6gawkKyaVeQ19XLxFNBh5KVg3iX8	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jx2LUkHUxatFjSJV14smnEwwgG1JaH71qz6z3zbsWkSfy67zAY9	12672	17808	17808	1619144640000
25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	1440	1377	488	12463	17385	jwsPR3KbSXnRPYo8Jvi5oaUP6J6KdtCBMidoua9kEugVQVnh6KL	12674	17811	17811	1619145180000
25610	3NLkNzxBqUPgbQZ27sbhY19kvzvdTzCFgyyZWuFQbptHHVTNf1pN	25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	1407	1395	488	12463	17386	jxzpzwYuAzYkyoafAE8iv7qLvXXdMWAu5fwtesT3rRxNbWZyq1u	12675	17812	17812	1619145360000
25612	3NKvAime9Y1VV2MA7rVEJb4M14qHncCQbbbJzRYdLGBxPQ4paP4E	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	1407	1395	488	12463	17388	jx8MGHkLxg97h8EwGkLPK9ih3nSVLybknWtnVFjNHUGZ2bmV5SG	12676	17813	17813	1619145540000
25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	606	1295	488	12463	17389	jxeZpysVxXbEtSuo9wQYCPeREWhDTSasN17YaYmqfVeXUXyTPwP	12676	17813	17813	1619145540000
25617	3NLFYrGTUAoXWnJjhTmgGgYku1u5KpvPmv89AJShfMRuymXVPQfc	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	44	1079	488	12463	17393	jxpqwPNGpd9uDaZiyFYbCEiWtzNaZDwnbRNUs5H5okZyn6y4h3W	12677	17814	17814	1619145720000
25619	3NLZhSNyfyF8T1NUw6jSdgQwVRE52weEbCiEF6FcJHAZQqp5v9WH	25615	3NLGAqJvT5qVHT7AUu9bVVwrBdwRGEx57HFyGLjxU1keLWSK6w1b	1671	1119	488	12463	17395	jwKrz77GAnM5x3uGQzDbBqXMiiAh4hPQgnRik7MAVZuiiWduPpy	12678	17816	17816	1619146080000
25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	1460	615	489	12463	17398	jxo4A9BefFxkaNQXwnFXFQzPbk6enJviJKYBGcBSXc9mQ3Vrhgt	12680	17820	17820	1619146800000
25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	25629	3NKFaHeANheQJh2Tc4kFJdfRHACDvDpvfS8pnPHve6aGmGvaBdNA	1403	824	489	12463	17405	jxAz23Lve3Q1ThKFR1tyHxPN5c91c7ExNXMMpmZC8gMQUs4j2JJ	12684	17827	17827	1619148060000
25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	25632	3NKT1brzMj6nCT9NF7fEamjbqyVFJEGFKf8sjS9NgdBSf3Pr4VNk	1534	1071	489	12463	17408	jx8ifDPzeKDN1gHTwmkN2UCSqZwkHsRFy5JxdPu6ecAThbAXBpo	12686	17831	17831	1619148780000
25634	3NKCLYiHFpQeqRDByqUu8kLRp3X2gnEuQCdTPykKZfRbe93Kqkhg	25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	162	162	489	12463	17409	jwZ395F28fXeDySqJQc6doWPtLuosHrA9dsxRUgV6ZSd74qUGqM	12687	17835	17835	1619149500000
25636	3NLjBp2i2srNZAxnnkJMoVJbUKn6nbyShQGLgnscnQQz5pw4fVnz	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1490	1148	489	12463	17411	jxoTRpvZNmzAqcC2JtnSsFUnC7KqR3F5dcV4QeEKo5B2mxsckcr	12688	17836	17836	1619149680000
25638	3NKJ9ubfvjEv9Y26C6yivto34ecPYwDCGGteiwAgKr33T7F1X5Bv	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1631	794	489	12463	17413	jweGCu5hhv7AdDSByvXiuspuSygviMxZxrx6obakGDeSR593Fkk	12688	17836	17836	1619149680000
25645	3NLB9kKXPxsrrn7L7xwDjUFYYQpx4ki8ZZ5buUuXMx1niWnWXmW1	25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	1474	963	489	12463	17420	jwww4PDuq61s7yyJy9sMgi1tm83WNfHezFRVFKLUnoG9B41wN2Y	12691	17840	17840	1619150400000
25648	3NKWLUF74MHc5HV2JYPmMPiFj3SvkjnXCNunHLzpho3ELghRdaf3	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jxqLu2ZCZ36raD4i8iJjdZVaEUBNZG2tPSLPDmbYEx5CbFhHXZf	12693	17843	17843	1619150940000
25650	3NLsJ4rxiUWJ45DkgJSXuQyZtGAgtitphgYRLFfaUBeY66A3MRny	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1581	778	489	12463	17423	jwKkaqsJnvDvuAocBMhJkbtGejLgxVxEtJ1ArrGR5YveiYMMkEi	12694	17844	17844	1619151120000
25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1590	1174	489	12463	17424	jwqw86CkVjPZj1stT89CPYsR4MrMKHZ4egTHy47arPtfyd1KnBe	12694	17844	17844	1619151120000
25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	25660	3NKuqnwyED1gRjdMXnuBwZ92dvnULVUMRSLuk5PeSdrBzPcFsmHM	1622	1230	490	12463	17430	jwRHmvskPAb5Rpo98XEqMLsmWDbcmSSnR4KeciitQWkUGWRnvQc	12700	17856	17856	1619153280000
25668	3NKJQ1iZ6BwZK3QLJcvyrybCTMxcoB3SWtpAbCe12Kya8b72z9Ev	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1648	1284	490	12463	17435	jxQ3kHe2rHVJC5U5g5Mj2Hyg3bBu4naMfcfE9u7pitcFz2P4qvZ	12703	17859	17859	1619153820000
25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	25669	3NLX6jWFFz8jXMqfPa7eGrxFtVzDzBwmWRev26q718sSozhEKpK6	1553	776	490	12463	17437	jwsQXAqGvoXVwtygw5VkXLL4MznUAKXBZWCA1Fvr8ZRuKhHkY5j	12704	17860	17860	1619154000000
25675	3NLFGyNPQkCH67jVRzfEt5WXGZDGC7Vzk6VuLCzAreKQeHmFYhwJ	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	1448	1065	490	12463	17440	jwMKpWyZhG2kuV9mjQfhnxbBscinJMcw7h7hwu67t1yWRK1WzCw	12706	17862	17862	1619154360000
25680	3NKaU98EghtDXcPutDdqFmoRo2ncEebSui6Lfgh1SiPyCme25QD7	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1579	1389	490	12463	17443	jxAKAxSijUeJLnPsTSR7SKftzv7m5Ycb5dvuCiB7VtXupBo8chN	12707	17865	17865	1619154900000
25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1637	816	490	12463	17448	jxFtWFS5W6Noy383zSnuH9SzA4192qX1kJpubZCupAF5xdkGeo3	12709	17868	17868	1619155440000
25691	3NLVNWvZBMPCfLdR7PFQANJsvWMmfnsA85FDYw3r82F3QimHz947	25689	3NKvRQ4dfjkiQFLSg2pC996dryEFY28tMWK9XHSyuAPsEXoNEP8Y	1672	1039	490	12463	17453	jwxALCW8Tqu5mSyH73aPc7UwEGiDp9grnieK2TeGuLrUW2dudao	12712	17872	17872	1619156160000
25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	25691	3NLVNWvZBMPCfLdR7PFQANJsvWMmfnsA85FDYw3r82F3QimHz947	1610	1314	490	12463	17454	jwD358uhcJfDqhjHTbTteTdLCsZBTjTWT1s6cMeiqqmXwSZCnx3	12713	17875	17875	1619156700000
25694	3NLJgU2e9pb1ayGnMHfNTeKBX5vtiPWi8u31tjh1yyYkt3c78n5P	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	1633	1144	490	12463	17456	jwAvLXeqhxxMaho7x4JYaSSmFabiD8mcfsE9tTywQ357kspPNcB	12714	17876	17876	1619156880000
25705	3NLEfD7GpwzvGD5jPgQuZqzSD7KtcMHVJQ8ppRH4gTjYPg6X5EW3	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jxTimBL2jwH6EJ1rXu59Ji28MpCBpKkr5B5bCaP5eJyCMjKCC76	12718	17880	17880	1619157600000
25710	3NLkWY8JTfiCGTAHEU61M3xuKj4fNLerQ4ubUrfgUN6nmwxRSnnc	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1651	1175	491	12463	17467	jxxaVrWmHhGXWRxcXUSGm7FK2fJ1f15zAs6uBaea5c5mzWzHddd	12719	17883	17883	1619158140000
25717	3NLf3TcZFhyq67E72Ae3fMYrxxwP1znVwPwJqcUJ87oYazBKNVTd	25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	1631	794	491	12463	17473	jwSJntTvYGgE1PLxZpkWPna1jciiuqtW5rNgVQPv7UKCh1AMNgZ	12721	17887	17887	1619158860000
25719	3NKjxmkxrRoCKxHs92r5NgqgjqzFVc8x8cHkQetDwzX5UV8e8cUF	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1634	313	491	12463	17475	jwk911p5T7Gaj1KZ3UJic9aXs5GJSaqtyJDk2nt3U1R9vjYRjjn	12722	17888	17888	1619159040000
25643	3NKY63djrMfGibNcBSss7QRmSisZtUXLFDp5LmnabDy2EFtLgZzg	25551	3NKoDtJCZNsknvgjq4QLbuHeDvhGpk7znpY9ELLgxpy1pnUUtu3z	1555	1347	487	12463	17418	jxi6EBS28RhKEiYZBG2hQaqdXMq79hj3R2TYJeU8kb4TfJtdPWJ	12633	17838	17838	1619150040000
25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	25645	3NLB9kKXPxsrrn7L7xwDjUFYYQpx4ki8ZZ5buUuXMx1niWnWXmW1	1407	1395	489	12463	17421	jxKcoEUq446KQ6mQUojUQpPvAMAGuXwdLRhmYBhQrNryjUd3meB	12692	17842	17842	1619150760000
25653	3NKManhtTVN7TnHDVsnVZNPvUMH6Quc2MWFppYG3PB72YA25hXYh	25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	1460	1324	489	12463	17425	jxhwhW4upaY3MUk1NgtBQe8TK982ZUoecfTVskqfwQ4VuYRXRPy	12695	17845	17845	1619151300000
25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	25654	3NLqaxgXNhTJr72n57FGJttZvt3hHknBM7UUVZ4Y2W66it9qwJmy	1406	1393	489	12463	17426	jwFhHCRbpPz9YcworjS6egr8tRyPsJgtHpYi8KCjkC15UvKmDPD	12696	17846	17846	1619151480000
25658	3NLfQFvtSbkKfG4vfhoHGsNbpE1Lcf6zB6hBpjysnHvdLTUpQnsr	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jw8R7mMR8NFsEQH8T3eY4Djb1aJD5PUaSzNLeSXiQpmqGuEnTq7	12697	17848	17848	1619151840000
25662	3NLTPoTc9zxtmFoexKSVzUFkpfWVM6etwurffnLoPc6XKyXxWZ9x	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1588	1146	490	12463	17431	jwBT6hS6dzZjTpiAbNgbMFj17rXBCn6EAmk2Q8WRjoghd8Me4FS	12701	17857	17857	1619153460000
25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1647	1176	490	12463	17432	jxYN8KxzkzY3YaADNVT31ufTQaZX1uN9MS5y5VfVaVVrQZi1U1y	12701	17857	17857	1619153460000
25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	1536	1187	490	12463	17433	jwnrJMKWaZFVR4cg7gxFmUH4pZ6yYUGsWXywZhKCjKJJSE8nWQR	12702	17858	17858	1619153640000
25671	3NKYX4xrupeHZ3NW6CKMJWPM3Yp1Q8ZnqSWApULMeu7pL39Q7s75	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1627	1019	490	12463	17438	jxYsQ4647dJBsoGVfgHDmDoRqFKmTubkim2mnqitZsSYs1MymBw	12705	17861	17861	1619154180000
25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1590	934	490	12463	17439	jwi6D2UKj4YVgUjMLU9XfUnJc3TMrwX2f1ye8TuUdhCg1CwRr1C	12705	17861	17861	1619154180000
25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	338	338	490	12463	17441	jxFdmZyPzJeWqsw1jbDKcdavyCTQxVk32quLn8hUZEcNjtgXmsQ	12706	17862	17862	1619154360000
25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	25683	3NKjmNrzpw1SXJ1qCFdj4gxU5DUcZxE1AHWuyWyjNtfmahsZy5fU	1405	873	490	12463	17446	jxCC9cLvZkbAS6BgyXofEKnJVDiv7fDGVK8XLWxZmRMoS3WX2bD	12708	17866	17866	1619155080000
25689	3NKvRQ4dfjkiQFLSg2pC996dryEFY28tMWK9XHSyuAPsEXoNEP8Y	25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	1451	1292	490	12463	17451	jws6wmFtqKppe1iQjo9T6hwo4nTgWnb6E6DHHtbhFH8jhYomJ4q	12711	17870	17870	1619155800000
25697	3NKPPrKKSEwSisk51xWgencM4hkkWyn3Dh5J3FttuJReN5n4mtQi	25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	1509	1320	490	12463	17459	jxNH8oisGHJWQuJzuKq7Rf1tm7tbZXxPmTFsViTn52vCMqezMun	12715	17877	17877	1619157060000
25699	3NKLo4VEKHe7QTVentYri4PHkSvnf1eKx91AcmtRekwqiVMu51K6	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	490	12463	17460	jx5MBXCCqj6eiy4VmEJRTGiQxKb2aAEfaRiHqDCuaXp7D6ffLKV	12716	17878	17878	1619157240000
25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	491	12463	17460	jxgpGwEuJG8yFutLriqQffAQEsCRiQvLdkKE7b5afbpuExSWkdy	12716	17878	17878	1619157240000
25706	3NKxUSHRJZmyrx1uqQPxwbg3bwYC3Vt7iD1nFD5iMfLwcCwhqpmo	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jxPnXbV4BV8CC52fwEBnNGUQYdjTTdKw38y8YMkg8Jmz8AqJnNS	12718	17880	17880	1619157600000
25708	3NLg3WDiGcFyVvYXdMddpPNgZ8NDRR4jUxybtSDXiykGhPhzYpjb	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jwndRy6dcmDufjBWoBfJ75x6NvVeWqTkL1c3XjnDNtpk1AaUadH	12718	17880	17880	1619157600000
25713	3NL6FvaRHTdLzGRPzc163KP1tqhUMicnbYEKYRnxYAndgVDM6ZUf	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	576	1355	491	12463	17469	jwJP18isXqp3Wh93oAEgSxtCSqadACjvgC8N7JW8WhHHvaGSd7n	12720	17886	17886	1619158680000
25715	3NKrSEELmcEWUFtMEmbuDZ8rbJyd37PNf751fXacxtxqEcwW9Ypk	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	497	553	491	12463	17471	jwyfj6sPSjrqnr8mDpekovAKNdx5qdYYyUUygtEWYSiTXGLqx2e	12720	17886	17886	1619158680000
25720	3NKmiiay2ohZPSXMmYtY47giYSgD3y8V6uxYVRMnU1iamGJc8uEC	25718	3NL75GBVptvzpp8r4CyvCPSfA8gq7e9xva3GZ8WW71X63Bjbq3Nr	1471	1386	491	12463	17476	jw7vYsx6Zt7Z2MreesUFee57nwC1yP7eurGDgkwDSjSFe4SEjvD	12723	17889	17889	1619159220000
25725	3NLiSGMoHy6HRmwyYCViMECD6jyYGASrNwZ2fR8GD3Hfm2vxK5hp	25724	3NLEKfhpNmJDY991CWa6Jc2LsuhW11YyzEbpVrtJGq4SaDeY1yKa	1581	778	491	12463	17481	jwrJtbyk8CHkdw2m7qBXRMNdABwovQz7j3CVzqYekGQ35mXtPkk	12727	17894	17894	1619160120000
25728	3NK7ZkRR5g9VBQ3PbJ8KQ9okX2JZ2KkcD9oHQnfUeBrKSyGzUQvy	25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	1631	794	491	12463	17484	jwjqrkhu3JFmidp1i4pvp22rKDuZzGn25TLik4dL5jHrsEihb1Z	12729	17897	17897	1619160660000
25731	3NKpgp2V2QBqzX4GU3KG92y8XqynRkLe577CtVT8d1BYGxWCLFrP	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1651	1055	491	12463	17487	jxqdqMH34fLLsU2DLJ7yVv7fXoaCy5tscdvgMRSbxZ28hswX439	12731	17901	17901	1619161380000
25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	25732	3NKRQHvJocn7hju48B8PAvuT6G9aRGGUujrn2dRv5CjY6VA5EfRJ	1474	1329	491	12463	17488	jwxUuBqduRnENPfc9AbcUyhfMuUJQjyer3AqgWAWD1MdF3SXME9	12732	17902	17902	1619161560000
25738	3NKUGBJeVSWHMyWrLc1Q4hJJQ7Ep6A8qmNnWrFNTxMLhfx9XbDTn	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1536	1187	491	12463	17493	jwtKmRDz9HGDrWw74myRWRMLNNskbz5WpxHqT3GmZStE5jX6hCp	12734	17905	17905	1619162100000
25742	3NK4enPyee2J1ya5keksv94ssSHCzjDRw7jBdzBHJsxxgNrKUDfp	25597	3NKregwkXLowMFnzeevLnt73APNC53ti4Hu5zSkrKq9UZ3mXpb6H	1419	814	484	12463	17497	jwEQZpmykdCahf9HAiztVBWVE7Ruu5t6wG8cnGdSZCfDFS5rCnu	12584	17906	17906	1619162280000
25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	1587	1231	492	12463	17505	jxJnL9bxT6MfU8bA9vUYd6Qokg9KYTFDbvKJTLwsbSzFc7ZFP8a	12738	17909	17909	1619162820000
25763	3NKD7mcy3MY8SLxMuGaxeW73cpCEVq2cwByFEXojstCwSPdu8oQQ	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jwTLPivzGQwgcZxwAVm4oX63M8kJCbFSo2trQdwCu1aHPAuKNd4	12742	17913	17913	1619163540000
25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	1405	889	492	12463	17515	jwq4HCUzSa5aVTXa3J6YCksbm8hLb52MexSydt3gcRMFRzfdivs	12743	17914	17914	1619163720000
25773	3NL5C5iLcK9XKBzAkoPvQdFQH2o1QbnVkCLRN5Te2yvmrs5T7t7V	25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	685	685	492	12463	17524	jwogPqi87ni4zLD7jwJXSi3KC7DrgjKppgcUhhhhiVV6jAFwo8Y	12746	17917	17917	1619164260000
25778	3NLV1B8eaDpK6VUUAX16EXJLUmhLJn6gta6eaF41wxNjao3XFH1m	25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	1506	1007	492	12463	17529	jwg3qKkb8ZL8Ufp52UwnSHqfyVDgGcThmSvKm6kGMCKX77avfAX	12749	17921	17921	1619164980000
25693	3NKvFxqYpNKjTNgcaaDfniJ6EGJRgE3ppi4CqAPw4VSX8eQcDn1u	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	1619	909	490	12463	17455	jwyTLKSQfLmSEp3cmtxZ5DHhoS7Tufw4BrHQjfzLzZDhHJSHeAh	12714	17876	17876	1619156880000
25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	563	1740	490	12463	17457	jwQKAhDGgyqrVLpHFHMBpc32Q1jArS3trJVuHLFxj94ypde3v8L	12714	17876	17876	1619156880000
25702	3NKw831dEMFazCvtLdCNDN3Bxwtd1cQa95Hrq3wV8UU2hCU2T5jw	25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	1637	816	491	12463	17461	jxxCu4HJ2vFcFLRmLP4uwkvGfYHuinBEhRqnX5qG5vd27TgnrXZ	12717	17879	17879	1619157420000
25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	1402	842	491	12463	17463	jwEL7EEUHPvZJE1Z5HFmRiuLgns9TzjABtrXJr2zk2oUn4ynUJY	12717	17879	17879	1619157420000
25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1627	1259	491	12463	17465	jwbG7zDGecQf1t4M6cwhL4hn1uZ1B22yqBh8Rior4BxAx2NxQHU	12718	17880	17880	1619157600000
25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1407	1395	491	12463	17466	jxWSrHGRtXC3zUPjFyJSBuy7eyViWcbYFibo1f7GhdKwBqjXhZv	12719	17883	17883	1619158140000
25711	3NKpeKtWzB7jNWpo8kSdbP5JPP3gFRhSMWssa7XqrpXaNstJZRmP	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1651	1175	491	12463	17467	jwWGnM8rPouG2Zcsmp8vTFZZBwnxf84eo7RJJSbtBWKXNkp7r5u	12719	17883	17883	1619158140000
25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	1474	963	491	12463	17472	jxeobutmHYJ4HtvZmq9MHgvPTSwXB5EX6AHam8DCqswfYTemfxu	12721	17887	17887	1619158860000
25718	3NL75GBVptvzpp8r4CyvCPSfA8gq7e9xva3GZ8WW71X63Bjbq3Nr	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1426	1238	491	12463	17474	jxXLN6qhSVHggA5PwCq9ePjcRUXHwztBz6RQwPQaXgJoe9R7CQf	12722	17888	17888	1619159040000
25723	3NKZw6DZ25pRBzukAjdpjMx79raQnccaq2mJnEXEaZzka7FMtByH	25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	1631	794	491	12463	17479	jx82DW8j9q5AAi84CXkvVVUEs8iq7Ej86YqtCJJjA3YphxmfDJr	12725	17892	17892	1619159760000
25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	25725	3NLiSGMoHy6HRmwyYCViMECD6jyYGASrNwZ2fR8GD3Hfm2vxK5hp	641	970	491	12463	17482	jwYfEGQRPQw1mcaq4eKnpMppwWeRQj4u2foawx8CbDPwoq8uYPA	12728	17896	17896	1619160480000
25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	25728	3NK7ZkRR5g9VBQ3PbJ8KQ9okX2JZ2KkcD9oHQnfUeBrKSyGzUQvy	1437	155	491	12463	17485	jxRqN1pNrPV1P6zzc8UK14aNfpd6xezCBnsv3H98KZdRfUBZUnh	12730	17900	17900	1619161200000
25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1671	1119	491	12463	17489	jwdTA7axEFUsm9mqmvn4HgApVYtqetGXTYeDh8S1yBpU41VEou6	12733	17904	17904	1619161920000
25736	3NKvVx3eP8C7nriDtzLnH3sKRiWVq1t8NRnehKxgboLFWDWUva4Z	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1631	794	491	12463	17491	jwZqtDpZ3qQTwvSePxvrC9iv7pE6BhjozVqfsQQcCMUuqZJnAwm	12733	17904	17904	1619161920000
25745	3NKEtiLi2XMJa2DwDcqPQbH6dwtfdwY8Hzk2doG1Z7sQprc54Hoj	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1448	945	491	12463	17499	jwdrzVPcQouZQVsGbKSDuZG6r6pnt1ZbEkYt2HHBEBrUfigFSWS	12735	17906	17906	1619162280000
25747	3NLRi3e82nRHbP9PYbv4ZDRCKeppEF3LeZ3z3AfKaPeMYT8JtsmX	25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	1407	1395	492	12463	17501	jwd6bBf3jBMdPGiQQZWsUkoJ8wCsyah2k9RhwzfFyd8AuthbkKw	12736	17907	17907	1619162460000
25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	25748	3NLQzqEVG9fVrc15STtX27iVXCWbLzbrE9HiBgvfP8szhrTNTdUg	1617	1288	492	12463	17503	jwNJGUDaXTC8cDJxWUPRGFBgeUE48jbcD4G6xfv8wEHbSUiSqkH	12737	17908	17908	1619162640000
25756	3NKRJdkW5Q83hrhyXTpsvp72cAeUYqRw1BCuGbmrfSkSC816BBcp	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	1579	1143	492	12463	17510	jwEHXsrpRyfDiz9eqANUvhpjjZoXvqwKyTpkarHRRg53DgqePMd	12741	17912	17912	1619163360000
25758	3NLbU1GuLSbD2B7oxrgiTFTiPpMAHkKM5pFpPcEXxxtxYHshTwvb	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	1560	1291	492	12463	17512	jwg4vXahFowPEeuz8aJ2w9MdZ4Dw22iEobFM1mqTtd8UQuzBfjy	12741	17912	17912	1619163360000
25760	3NLtwLzndcRmPDeLmih49BfrVdMy6YQnKTyfy2NGbvan2uXDu4CH	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	641	1336	492	12463	17513	jw937CuzJQpEPz9fx3YaCjkkTfkkhuyWTo87o1FPch347S5EJVX	12741	17912	17912	1619163360000
25765	3NL8PLJysbcUupyQA6qVZBkqZieV8qjYGGM67aYfziCL9kZQzfSS	25742	3NK4enPyee2J1ya5keksv94ssSHCzjDRw7jBdzBHJsxxgNrKUDfp	1419	814	484	12463	17516	jxqavydpawpj7XnqadHmM8iUpLR8tUcv7p8D7wN2kYdcPoAmkKA	12585	17915	17915	1619163900000
25767	3NKC78RLptL63FipyttWoMNbcJeZ8rohhZYSYL6WiX6yzkgKeuqd	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	1439	1279	492	12463	17518	jxehTUN2faoSG1cnozTt9Kb13AL4tw3RDs3yjGG7RUkkJqxcwf9	12744	17915	17915	1619163900000
25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	1624	1334	492	12463	17520	jwdZZhLLH5ie3Ldm7A77jPPLigGCp7ZQhDDFreGBYeX7qbPSBbV	12744	17915	17915	1619163900000
25771	3NKmSsKMKYeDvgK6b8PLxqt8kd4Cd3rHsA3EniC18ZF7zbTzQnKq	25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	576	1229	492	12463	17522	jxry3o75LaGnnsU76da1N8YxmcMLTSY6VLg6TGwiVSe1fs8ddEm	12743	17916	17916	1619164080000
25776	3NKyH8rRwRAPf3G3faFMnYNjWvCAjLndJHEepxyXuniF28usexYK	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1617	922	492	12463	17527	jwx7WRrfUkwe1cq4txKtWMeNKeGhAbA7hq5E7zSWTt5wwAW2FiQ	12748	17920	17920	1619164800000
25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	25780	3NLt914tJBX8xRbS2xRHYN1f5wGAEdV82qUnhb9jkpc6g3Xehs3P	1483	180	492	12463	17531	jxk24aqTiqUe3tQNgSsXxHwk6hPBjrYdw22vcCzVdEZqbghY2DL	12751	17924	17924	1619165520000
25784	3NK8nxjkTUWghpWrWr7ibGtt61DWHYSFm4xqtzFHjtwzm2JkPedx	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jwtUSrRzAxvRioF6x2TfVfKsoCRWui5maimaCTG6LkSVt2haA3i	12752	17926	17926	1619165880000
25786	3NKQ12hSAKjuuPdRz6QajXQVXaYspZbH3Bd9a8RB3MzpDi2Fr61a	25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	1467	1010	492	12463	17534	jxQc2NTRJNnn67pVMo6K7s8wXLNgBxuQ8ge8SDPRQ8kaPDwbuPK	12753	17927	17927	1619166060000
25788	3NLfEnF8MutbxKwuvAiKLGx6Vgpqiha1QQSxK5CchV1ornhtfCeM	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jx23iGobgWASj8LSimHAjKBP1q574Uzy3xUnKWhckAMDKC1kCWN	12754	17928	17928	1619166240000
25796	3NKVsz7tsiYMvWHwFkDyWazSB2kmG9S8FfvSstFLjNWGKHNBz4wt	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jxSYD6tnzrsJDtseX5dftMenvFQD6r7922PrDEx5MmuGfw89vkw	12757	17935	17935	1619167500000
25819	3NKwb5g42ZPEBpc68MGp98DhUAY6HuiGX5wiuiNVoie8FVKrg46k	25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	1598	398	493	12463	17563	jwFtHML6thc9HjKaww4AbAPcULGe8X7jUYvV3Lgx1r1egSR59Tx	12766	17947	17947	1619169660000
25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	25826	3NKoLEJ2Hyc57diF1yjU4ksUnZQmadoBZoeGxyh7oR6LdiJtTVeT	1627	1139	493	12463	17571	jwvG3wF4bmWjimcJimdgsySZ5cWnjBtbwuA1jhn1gEDEMyrEWyp	12771	17955	17955	1619171100000
25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	58	1155	491	12463	17470	jxXySJetAQx6M5HVfYDFmn9sj7cG7XWAyoY54RjcDWXAj7LgFQh	12720	17886	17886	1619158680000
25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	25720	3NKmiiay2ohZPSXMmYtY47giYSgD3y8V6uxYVRMnU1iamGJc8uEC	1402	852	491	12463	17477	jwA7bQdeA9ERbBS1v3RdXm6eRiMHxWMNs1G1qznyjSGppB41VVg	12724	17890	17890	1619159400000
25724	3NLEKfhpNmJDY991CWa6Jc2LsuhW11YyzEbpVrtJGq4SaDeY1yKa	25723	3NKZw6DZ25pRBzukAjdpjMx79raQnccaq2mJnEXEaZzka7FMtByH	1407	1395	491	12463	17480	jxA9GUg5SQ5jDnS8M3uDNzCffhZQvmaL5CVSD3E54wEznfgxKte	12726	17893	17893	1619159940000
25727	3NLv6zYtAvNaBPXnhGDHgKtZcfBWvrXvQWUJjNTk78qtemp1Nmyb	25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	1406	1393	491	12463	17483	jwvWoXuuYXokh9Xrqno7g8PmSpeK3iGCVTM1q6iV7q6VTf9HfbR	12729	17897	17897	1619160660000
25730	3NKToajWrT9mrcFMKtCCe7Pa1QFRAdCcYaY69eekF5zi68XdhMhz	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1507	914	491	12463	17486	jwGT3pZW56QFqTSxJQajFFwA8CCDPjz9SRvqVhisyd8K5Py1Pru	12731	17901	17901	1619161380000
25732	3NKRQHvJocn7hju48B8PAvuT6G9aRGGUujrn2dRv5CjY6VA5EfRJ	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1651	1055	491	12463	17487	jwZNDjgZyJVN7H7eqWT9mRBnX2Z9x6pfzLqT3wPoPJUZppwgUf1	12731	17901	17901	1619161380000
25737	3NKiPDypSCTTgPB2f5AHB6jtHCUf63sCy38YFc1xwyHekmTh1SDM	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	80	80	491	12463	17492	jwiqC32aGMjSaVH2Q2WcPUvy8eK3MbuwuMzfyEHN1HN3PL36dkz	12734	17905	17905	1619162100000
25739	3NLtGX9Pfni5v52aEVfH84C4hxQjCjVyaCn1D4f1vVy6xNuc1eeV	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1553	776	491	12463	17494	jw94TzBLTPvqw7bV8RPseBFKWnkDG8LuFnvCU3ZxniX6M59fFbd	12734	17905	17905	1619162100000
25741	3NKbvRPfbQVg99dMxZYjzYGFAb7D9qZoQgFk63DWkrKGFUeBzPyA	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1631	794	491	12463	17496	jy2ndzh53pF6y1d3D5o3Q1LFRGYN7Sz55J5diVkJdgf1wuLjAFo	12734	17905	17905	1619162100000
25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1553	776	491	12463	17498	jx35D2RrUmu4Z9K6Cjs3g8J3GRaUr4ENbHn8CNkpwxS3KjXwcQD	12735	17906	17906	1619162280000
25748	3NLQzqEVG9fVrc15STtX27iVXCWbLzbrE9HiBgvfP8szhrTNTdUg	25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	58	915	492	12463	17502	jwrJXRDDHPa1sDLaKA7qr81gdyT2TMPr6WA7TjCt5T157oZ9b3c	12736	17907	17907	1619162460000
25750	3NLi8fN5wUzDhD13R4t9RNqDHfTVhoueci4HDa6wYMmTY6EcEGSs	25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	1407	1395	492	12463	17504	jwQeELqNCLyZFS9H13VhqqqBk6VJWn1Nykxf6ag79rJeMWLSe75	12738	17909	17909	1619162820000
25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1483	1030	492	12463	17506	jxticykRuoCLws3S3xaUMT56dM9TL8BmXj6nm3v5fppGw774w68	12739	17910	17910	1619163000000
25754	3NKij3vC4sJpvWMBWSRd2Z1RuaL8dSGeU2Yvc943HANxbc4pP9s3	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1634	1085	492	12463	17508	jxYTcqRHoWgdNRrXzDGJd8ewa9iscW68Nacb3toezRH7m5oiqaK	12739	17910	17910	1619163000000
25757	3NKtjfSmt2zxmrpchfnNs5RYh8eQSRz4FdszQj4CwEm4Jg7kTDBt	25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	1560	1291	492	12463	17511	jwFBRqkvNs9qbW8eZY6gYgQzRCt6kfxnMRsVSkGzYSKVGx8Xmh7	12740	17912	17912	1619163360000
25761	3NKtaXirnLgj9jtCmfrRtsig9uyhQ5w6xaeANFwC19VxXHFmxuv5	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jxjYbYBdXB6mBA8iW1qcWNqMRx6NZjJwPEaSQRAXs9nPykxAobq	12742	17913	17913	1619163540000
25772	3NKzJweiSZU9h6zMAJkyzArnEpnX2J7oGRVbi8Lbj3FvFYNyQGWE	25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	1656	977	492	12463	17523	jxgSSu8a6X6TQnLibQN1LD3k9M6GtvLTfK8XVqvWfjwEYtZSH1T	12746	17917	17917	1619164260000
25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	25773	3NL5C5iLcK9XKBzAkoPvQdFQH2o1QbnVkCLRN5Te2yvmrs5T7t7V	1623	830	492	12463	17525	jxAFmjVMv1urcsh8k4BB5rsuZYAyhCioLFd1zshnPxsvYCUid9F	12747	17918	17918	1619164440000
25779	3NLaeyYkQSDHv9zVUWwJyWaiAH4pp1p8V6PXrM8PU3dmn67oWa2L	25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	1506	1007	492	12463	17529	jwG8Lhdu759bLikNLYiccVFM23cmQnDC6xNpZikNJiiv2UKnXMr	12749	17921	17921	1619164980000
25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1608	1289	492	12463	17532	jxPs9pP89T8vUMweWNhFwuE1n8Yfjbi6iLj9V3Xp1SuE5m1uQZn	12752	17926	17926	1619165880000
25785	3NLTMTfqQRuREdL1uQq6NYp4D47TkSwTWcmGewtUBmgFRAvqxYpZ	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jwzcE6Qz4DkwayQasv1kMuZmsDfj2EDYQGerb2ngP19h8qSNR8v	12752	17926	17926	1619165880000
25789	3NKMUXeNoBBwWWo1ghSfWCB2XMMh2WUTwtD6D4yRqPxj4J8p6sd1	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jwEhLRqPmaZxhPnfSNqJAkrScje7ApN81kgpfKVaNx8CDy3PbLk	12754	17928	17928	1619166240000
25791	3NL4hi3vZuAzqTLvq4bSd8PirqYZTWgHumUbs8iqbKtggRYY7e4C	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jxfyqVKXpAtdnLDPxs5FyfKoHkNk7rJHH2JsXqM6raJfPWRSsDE	12754	17928	17928	1619166240000
25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	25788	3NLfEnF8MutbxKwuvAiKLGx6Vgpqiha1QQSxK5CchV1ornhtfCeM	1407	1395	492	12463	17539	jwpXt1chjbgUcpZ7dRbasncKMsXY7uVjBMnUkQrHqffr4urLGEg	12755	17929	17929	1619166420000
25794	3NLMsFNbyZkQQEsJCt4nGHw2JwXD1ZufacVzLoPLBrXwn1TeTZhc	25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	1608	1289	492	12463	17540	jwQ2cUeRH6h9eL5KVxKr5GEjM3e6hD2bTR91xrhEj9SBDyk4813	12756	17934	17934	1619167320000
25797	3NKNZBeMMnUirfURtCkh5r7hwc5Mk7giAF5GEuUNVhJZ3TWchZ9P	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jxcLoNdMbdaWYyH69EkwTsj99MsCeUeZeqhM8wrAvypq4u9m4hk	12757	17935	17935	1619167500000
25799	3NKh9q5xAHcuwcrhAb8tRUUvrML8at9SQkrNAZBmJniqvqQq7T5H	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1406	1393	493	12463	17543	jxrU9B8YVtYZejoCFHMXTrmp9rwkQzwcQhZ2Rd38xhjaHxFafrf	12757	17935	17935	1619167500000
25803	3NLxDRwWHUgqvsebGP8KcZJCetZkrZMKyLDtZ3Mj5VKydceHATby	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	44	1325	493	12463	17547	jxvGTdW8SZdiUUghyTWqHz9Z6i2T4ubjGak4DVc5sXNQMmknRcL	12759	17937	17937	1619167860000
25805	3NKFLHTpNGXzRXuQyXNpVeKUR4RWZsftjstXzN7hmm6PD2KhvjW8	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1611	1341	493	12463	17549	jxeKk5pAQtk3QF9BxKgvmuqgtR2Cjj1LLsmuHrhiR4vXVTRHf6S	12759	17937	17937	1619167860000
25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	1407	1395	493	12463	17554	jwBe8SXXQbHiqoWiCLb8f38ATyDYdxxEW2ivfEmEFhU19Z5nbVn	12762	17941	17941	1619168580000
25812	3NLF8jmzuNztubLj7kKzctp7pn2ap8o1oWFSDxwoD22rjn8Z65g4	25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	1507	1034	493	12463	17556	jwZ6kaCjyvnoxAWjE4BKT45mjDMAYe1KeMBAVXtSRLYTvHMRLdD	12763	17942	17942	1619168760000
25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	25813	3NLf5fzjRVfJ763QhrtWA99VnaYN98CRye5vtzLw1SXSVWDkk4i1	298	1308	493	12463	17558	jxRc3j5pnqByvgM9e4JBdJB6aXQjwxC2prPHzYVRPZ49oUQPJ5y	12764	17943	17943	1619168940000
25722	3NKJxLto2AJaKc9RzyVR8FgMPVtC7LiQLhfE963Ke8LGGyFo6Y9j	25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	1520	48	491	12463	17478	jwhCZXPt6uhEG6W39wAm4WaqdzK9FxxQWzjizdXEhXYL23yN8Re	12725	17892	17892	1619159760000
25735	3NKuthy7jy8nupUSPW5KrbDrm8f3W2ALnSvZ6ruqJo14MY6vc8MM	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1657	1344	491	12463	17490	jxvVDGrzo5tnKWsfpQqweETkNmCk8hHZe4MnRdRQjgUYgSEkBRA	12733	17904	17904	1619161920000
25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	369	1186	491	12463	17495	jxdPdTHTaQiGNWEdN1ZvTUkSg9g464nyQ2zoLKiEAxMX8VeNCY4	12734	17905	17905	1619162100000
25744	3NLwFnZNdk1d38gnAUGmuM92BGLBtJoEcmuWjA2mTbZfxpejiwEo	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1448	945	491	12463	17499	jwLWfS4BkEgrXX91QnAuMnphckc3jozMtcyia4FhUJmavF51YfN	12735	17906	17906	1619162280000
25746	3NL7t6A3Jgj3YF2pvqF4dTZiX7EUUoNrmtd4JUmByfpLLWSRbs1U	25598	3NKNCd4GCpx5HYsbBWTTagK3BpK4bEMuT4oFAiTFHFrKV1Yd14Zi	1419	814	485	12463	17500	jwXggSmYXXVevDDUsBNLKK6t3i1UW7MfJ6knXFy5LbzpPD4v2Mk	12610	17906	17906	1619162280000
25753	3NKwRzWwF7L3BenLLqJvVx8NL9UXPiJf7HfJf7kTCNVqWNQJSCUm	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1422	1091	492	12463	17507	jwnEJgYCzrvG3crdxKwxRkLo8FARgYt9pDSdbvagSVm3qJ2GYb6	12739	17910	17910	1619163000000
25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	1590	1300	492	12463	17509	jxaXfxsPkzTH5BMjCQrSYXTPbTtfLPfb5PpiU7rDqn9Av6mKdAc	12740	17911	17911	1619163180000
25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	641	1336	492	12463	17513	jw937CuzJQpEPz9fx3YaCjkkTfkkhuyWTo87o1FPch347S5EJVX	12741	17912	17912	1619163360000
25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jxruFXLwTBjQshBDki4UzMy9xZ88mq9MMh5CVftz8ftyUQxP4Yn	12742	17913	17913	1619163540000
25766	3NKB7prweAm9qMUVCn9NsZScgYyX1k9ypQUrm718LQDrJXrkAUQs	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	43	1184	492	12463	17517	jwcKAE8SH17mx1CneyRu7BrhczgXRQRMMFkPZ4g62hzkydd8eZG	12744	17915	17915	1619163900000
25768	3NLk24cZ3tp82TtgoQHZMKjQ5uiKe4jrqQpTLpzs443qpFnbfWTe	25746	3NL7t6A3Jgj3YF2pvqF4dTZiX7EUUoNrmtd4JUmByfpLLWSRbs1U	1419	814	485	12463	17519	jxCEJEKRUkXF3gTNUPjPgKQ4WRcwHSFBQuz7pkaUBMihk6iTUoD	12611	17915	17915	1619163900000
25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	576	1229	492	12463	17521	jwxhSZVNdLzpTfcZtL7c5q4MqRxqLVNX8ExcJar716xyiRQJigd	12745	17916	17916	1619164080000
25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1406	1393	492	12463	17526	jxN74kVW341Wyu2Sp1FtA5gPKZSEaHGra39x8BsmuNk2Co5AyKf	12748	17920	17920	1619164800000
25777	3NL3KNpBpxEXtyjV2J3GgBnvUZfskjRUsP15z9yZG5yFw2VqSav1	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1506	1007	486	12463	17528	jxU6RUkdUKNVwS1XVT5uJW3MiK9fkMMxQYrxrTAbyhWGu463uJe	12625	17921	17921	1619164980000
25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	1403	786	492	12463	17535	jwgEczqsVFsGjYnuYuJ1MdkMeLJFrdo7LNQeX3PHQKPeHozMC7k	12753	17927	17927	1619166060000
25792	3NL7cVYHJYp3QSH2v6xReWDQnFmDR7DzPMcvEQWdEKa2EwK3hS8w	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1602	1369	492	12463	17538	jwtoaDkpTAZzxc7wdf5JXkzvqnXP9ZbrL23eCVT3DohaGKxekxh	12754	17928	17928	1619166240000
25800	3NK3AKqdquyshAbUYEc5tZDyawkhYj891r6GTujV3ryuEa11r1xu	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1402	874	493	12463	17544	jwgMjXSTQvAajNM7vnts8P5qZdaZoiW5rkM9L8KwjRee6PhdFCk	12757	17935	17935	1619167500000
25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	25799	3NKh9q5xAHcuwcrhAb8tRUUvrML8at9SQkrNAZBmJniqvqQq7T5H	1648	1284	493	12463	17545	jwiVt3iFBk2izFbZk4eotDDD5sP6tD3iser2oAbRLwPdCFuZ8HF	12758	17936	17936	1619167680000
25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	1668	1370	493	12463	17552	jwWBQszMWUpG5rKmsGSJiVcUBis3M99Wb1yZdFHMJh13ak7oNJB	12761	17940	17940	1619168400000
25811	3NL2mnF4pqbmMW2nH5eyWxMzCzoMspUWkS52KoC2S5m1wz3xXqEz	25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	1622	1356	493	12463	17555	jy2g2ZStTmTEyS56jiFYkFme19C5DGDjnfR9Y6kvpu5V6UAm98D	12762	17941	17941	1619168580000
25816	3NLcHczr4ZscTrMxMUgLeoqb8kvWphTK2Vg85b6fTkpY3S62y7z3	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1555	1101	493	12463	17560	jxdTnFNLWfzNwCB3f1znKxQSUn6CPUygYfqnEzMKJfFZhY1nNtv	12765	17945	17945	1619169300000
25818	3NLZ6e4Hf9vpnbsN6LBz9HaFJ6Lskzp7gpZNNiX4eh8ymQw63wTi	25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	632	1136	493	12463	17562	jx1AoYEb7WrdCKep7cu3Jj1osyoDfmzrgdygyEhqhsPwFj7dEXG	12766	17947	17947	1619169660000
25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	25819	3NKwb5g42ZPEBpc68MGp98DhUAY6HuiGX5wiuiNVoie8FVKrg46k	1631	794	493	12463	17564	jxvMc4jBR3j8owtcpe7o3PJWHrJCvdczw9ZmjCqtAhKdfmxh7yx	12767	17948	17948	1619169840000
25833	3NL4sTHuVCuiTKPgjiNHWzxXiDnEoEYusMxEBSptvfj9fXXcfvCb	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1406	1393	493	12463	17577	jx6Fw3tLp57J8H8Ejii48DJZqGy1kJKT1Bfkm49d91LfxZnC8Es	12774	17959	17959	1619171820000
25835	3NLaZxCQ5o39qxMEtstVrUT7ksSTBvHUKG1R7bxMFVZXLdEEXymp	25703	3NLuah91PXz8E5EFwi7HSXCPRyTnCs7SS57a1X1LYXcKv7vsn8uZ	1513	1379	488	12463	17579	jy3DBnwtNa7w7e26HdfHLapreap7aojB8cs7UNmnNmn7JGfBNEW	12669	17959	17959	1619171820000
25839	3NL73Vapw4i3pA5pFVfsgE8euZDnjBxtLYorqTF7JjkqUAevC4SY	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1403	824	493	12463	17583	jxtaCp42cXcacQc9a59aFH2aXVh2q8H7eXgRk9FP7cLwUM1nh8c	12775	17960	17960	1619172000000
25842	3NL4VnRYSpWsQXMF4ZBnoJJYUTCHysgTKf9AVwtN2s8Nks1crU6A	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1651	1175	493	12463	17585	jwgzEyxy2TyVAHxM51aB6WnKXuSDUDi8pB2rbmUTfXzChw7xe9V	12776	17961	17961	1619172180000
25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	298	1062	494	12463	17586	jwYNGsvVn1SQM37o76fPVXcr9fV8ESpLS2XGdccEwxqwYAgnLoE	12777	17962	17962	1619172360000
25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	1642	1367	494	12463	17594	jxAevzkvHx9mtHWPCeRUBX7Dr86S5P65fTNSnFwTPqcJPPitPid	12782	17971	17971	1619173980000
25854	3NLfijTNeZvaH3S6sPs3gnE7NLQBvf5M28MmHmR8VPYyzzheEyR3	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jxbta2rtydCP3kbixFjqBNz33UMYJqyUaJB52rSGmrjTz7KCD5U	12783	17972	17972	1619174160000
25857	3NLHandjFbj7a4hJKW9EaaKQs31HauAoGVxr4ZqDyo1RrcuUaUYs	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1403	824	494	12463	17597	jxg7xm5qj4YKtuvzRVpmaPNfw6n39orw9SdoB8VwW2U5hK5JpfX	12783	17972	17972	1619174160000
25863	3NLpPezZ8BxcnJ1Yzm6ygQR9UqHwW8L8euNVCAhduQN2N9x9gr7F	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	171	1008	494	12463	17602	jw73jDLHNutrWLywqTdK88zNFvWcBZMyn9JyvTrmNwgHveoLhXa	12785	17975	17975	1619174700000
25780	3NLt914tJBX8xRbS2xRHYN1f5wGAEdV82qUnhb9jkpc6g3Xehs3P	25778	3NLV1B8eaDpK6VUUAX16EXJLUmhLJn6gta6eaF41wxNjao3XFH1m	1406	1393	492	12463	17530	jxqNyQemntNSY4EGSnmbmeQjB5gZttJabejXNhYA7Tfb8icUtPh	12750	17922	17922	1619165160000
25783	3NKTVfBEG3JG7pLuUu4ZtaELp7PxrMAqQLsStXpUti38sCfk3HyH	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jw8BRcVYfDR42spZc39e2KVoYY84sWXLRUNymPUNUUmjnQ1NeJU	12752	17926	17926	1619165880000
25790	3NKtD6uqnqZPHn9V1kA6cT85iuuo2tADcfhg9FQqWKBBg16ycnb3	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1460	273	492	12463	17537	jxXcJ2VcQg7uTPoEBWgiknCkNKRqxK5GNAT11FLYp4Ypjn7KRzg	12754	17928	17928	1619166240000
25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	1601	1022	492	12463	17541	jwkde48Cz7K8gB7UUR3kHgrDJ3NffANU7riX5vWAiKr5hHzHLKf	12756	17934	17934	1619167320000
25798	3NLYg7yJBQ94fDyKAzND1izehn1aeq11HGYmdgKTcrE6PexBvYa8	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jy39aMRdLipX4CVU3Fgx43xVaA9aSAJYFK4daXPFygPRLv2SDSt	12757	17935	17935	1619167500000
25802	3NK7a2wD4EQpvtkS5sT8W31nH8KJf4N2FXxcQZihoQRcPFTdKDEw	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1460	1198	493	12463	17546	jxiHPpe1wanLYtAmpQ451hoJVgzDxaysNZEqaiCGh8z8hYxF5uh	12759	17937	17937	1619167860000
25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1402	876	493	12463	17548	jwfXamJUsj6XYh8WN69c6kUmoeS2Av3KLbyBWngoLNPeWTddYmv	12759	17937	17937	1619167860000
25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	298	1062	493	12463	17550	jx4rFUuLQaezcuMe2DBqUrWHJujCvs7NRKVQPT2NVKDWnoxGqZi	12760	17939	17939	1619168220000
25807	3NLrCAYT3crNBE8xrDPWsNhfH1Jcf7SwuNmw7jRA5MCrP3qsE61u	25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	1405	865	493	12463	17551	jxR1jQXNA4rTbB2qyTY2cg2UjtqpyMGN4Tc9Dug4uid61vcfTd8	12760	17939	17939	1619168220000
25809	3NL9CwWTfoB1WcA4n7oq5RiUhNNLKQVUGjZSKRBHNrPP2sh6Y6U9	25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	1474	1083	493	12463	17553	jxiMwTciGkwkxfm9VXeozZnRywLdsxZjsuqQp7PmmDjyFxqqM93	12761	17940	17940	1619168400000
25813	3NLf5fzjRVfJ763QhrtWA99VnaYN98CRye5vtzLw1SXSVWDkk4i1	25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	1623	839	493	12463	17557	jy2oGMrCQAtdwM6CrfggPJgZm9TqP7bPW6f24jKeyfZNcmQKjiH	12763	17942	17942	1619168760000
25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	1609	1333	493	12463	17565	jxoy9XCKRyZpnoe5zGT46Wj92zdiwxhuHBTHrT7eAVfDtqFtV5Z	12768	17950	17950	1619170200000
25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	1590	1174	493	12463	17568	jxuxDWMTL5UWkGAxdH4xnGre9RDxGxP2KaoY11Lnyo1FqZNvyUA	12769	17953	17953	1619170740000
25826	3NKoLEJ2Hyc57diF1yjU4ksUnZQmadoBZoeGxyh7oR6LdiJtTVeT	25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	1650	1129	493	12463	17570	jxy2eCzgXZGPxPnDm9ZpASzSV8JX7QPNxF2vYQKTUUoSaramaKn	12770	17954	17954	1619170920000
25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	1406	1393	493	12463	17573	jxkoXkmoru5AsADZxZvGp1j6LJ21dAUkmrNXBnSLWiufpQLDBen	12772	17957	17957	1619171460000
25831	3NKcUuoYGizu2Le5ptJkYWTJgY1jjnAYagRvPKvyHgF4pBTj1C5D	25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	1601	1388	493	12463	17575	jxZVNFexp5kZ3dt1nepUjdDm1y5iZnZoQvQS8XjsEMg8qvW1jhp	12773	17958	17958	1619171640000
25838	3NLhoPdNd5ND8W2NSHA3CgiSiTq9EtecdyPkb2WacBqk6NqWPMuC	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1419	814	493	12463	17582	jxvTXw5cnKvVWDZjk533VujeJz8saRdpFgydkYGSm4uZY3wczUu	12775	17960	17960	1619172000000
25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1405	851	493	12463	17584	jwwJCrfWyv1TJRM1j6LdZ5XD8MfZSwvgpats6iiMXs6TVz4XV8p	12776	17961	17961	1619172180000
25847	3NKAXEXAAj6AeNLGvVPvFnY4wSnuZdRfRLK6WoRetQNeTfqLinsh	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1647	1176	494	12463	17589	jxcsQiuKXEhBm6zn3q3fEEYPoJ4MmBdhZJDS99DHBarVwrfADxV	12778	17963	17963	1619172540000
25849	3NLMws488Ymzx6Sassk9k461SJ5DNVNPHuT44Zr2y5X3SftPxURr	25845	3NLfWUq6BSyWzgC1626MVFTvHmFSDPVNHH9cWc8W4BT3LmGkMjgY	606	1049	494	12463	17591	jwpQK4bF3ZMvNXR2iQEYXMXw3aTs9MYgfvZp8ampusALU9n6Sb5	12779	17965	17965	1619172900000
25855	3NLMdwSk3EHfPce4WQtR4J6m1tE5CZzAve1V7rUURtGgkimriFaq	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jwyCJFLrvhJN2jTg2BjpAGLhDNPEzW2umvhKL1ixri2QU1Rhnak	12783	17972	17972	1619174160000
25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	1579	1263	494	12463	17598	jxb1kaXGpbK5qFjuNVUiFFiJt4JN5LBSJvLFtGSm5nNEJ7Qf54S	12784	17973	17973	1619174340000
25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	25864	3NL4tcn9CGMKQ9fn3RM4SCqViMRXk5KLdkhP9YHTJFUAAvmPWtnM	1646	1108	494	12463	17605	jwdi8TD5uPvVNApWGhXn1svbCQNQQWyUJCeCc9LNdZxDJbbRNWa	12787	17978	17978	1619175240000
25871	3NLEut8HgLjsUNK7rgmhBQDXtcmpi1fq2eaiaTmV7uE8A2k6noJe	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1534	81	494	12463	17610	jwwcv4AgutZfs6p4LYGsfh74yT7YsudfmRppfVxTqzeA2s7ULq9	12788	17979	17979	1619175420000
25873	3NKrmu9DTXF3HMUQqqENk6UvJMAK3wBh9L87We9NjgHXuBotuLkX	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jxm7hRjSnyaBXJyX6PwGoazKjWYvNoXuAqbnGH4kXBAYmBUFHHB	12789	17981	17981	1619175780000
25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	1445	1044	494	12463	17616	jwr5Kgn1tnnh4x48Vspsqw3hiSLRB7NVvCDp7YUmNLs36A1hFyt	12791	17985	17985	1619176500000
25882	3NKLwnhunmnNuMz5SsgT5gsYguuz24nNP8TXxwxaYhWTCep1zqGE	25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	1507	1280	494	12463	17618	jwuBcQmvvZRhiq5LEsRSiQ1Dp679YskuGPgyscnT3n9zgiJGsGc	12792	17986	17986	1619176680000
25887	3NKWw3JT82tr8Jy9k9oArY4rNK69qiXi9SYCgSioHuxLbfTgChkZ	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1564	1092	494	12463	17623	jxjJKkjV2YxN5CG5Mbt4StGfTAgtNSuegdZZLk7cSorpHVbgU7g	12795	17990	17990	1619177400000
25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1553	776	494	12463	17625	jwZEQ349EygL9CEbGhaR4XjECq3drc4Mukxa8MjJopZLRfNTmxw	12795	17990	17990	1619177400000
25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	25892	3NKhyxuzDsmX9FGarA9E2zvmKXaQgx1dzubLzV6eH29SVqDeX7ur	1406	1393	494	12463	17630	jxrvEjpSHwRcxYbKyFL6gkziT6MnYtudgXKBT1hHiTfjoBhDnFZ	12798	17993	17993	1619177940000
25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1445	1290	495	12463	17634	jxrNfvJDjmbMTkdCRpwk7FFUwtAcmtBdCkZSA8FWr8bmzq5H41e	12801	18001	18001	1619179380000
25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	1501	1360	495	12463	17638	jwT33y2RN6Q4AXXaZUYCT4wYwLYVSRudCk986tYfyJh6qxVPty6	12802	18002	18002	1619179560000
25815	3NKg9GMggQfX1boN3mXsvCwinPgBRjxjPeffi8zbfRqUXyTB17sG	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1483	1150	493	12463	17559	jx7Xft1SLAM8aXSbsnGnLxYhudwHztgWsefjd1jemqBuKDEZsrZ	12765	17945	17945	1619169300000
25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1623	839	493	12463	17561	jwyfHw9G5NGGZBcsuT83e9e9cAmuHLDrAidyeisBtpAFFeRaNvi	12765	17946	17946	1619169496856
25822	3NL47ki58hzTdAPDPTaQMoU5zYZzcM8CbCEBid6zU8m13pqPqZdM	25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	1560	1291	493	12463	17566	jwAdh8ttpbZgk8xi6cn7joTk4b6mbkBNdn9FWVvzGUmnh812UB8	12768	17950	17950	1619170200000
25823	3NLFn5z6nFcHRgx7y6PB5wU4aCjk94fPmtyCQ8n7eRH32kMdEQzo	25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	1406	1393	493	12463	17567	jwXvwo28TYEhurR2Khg51XHq27jsUyQpASPUAi23JDqKr1kxGKx	12769	17953	17953	1619170740000
25825	3NKicKkKkzdXngKCHx1mz62bn6CSbXGApN6kRkEa64DVTmTqv9vM	25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	1405	867	493	12463	17569	jxULcpqJmsDevN1JP6oVCaAGcACmh8z8L1LuKuzVzRBMPE7DPiM	12770	17954	17954	1619170920000
25828	3NKSSpbpb8KXwYduuCN7jUwvgV6pQVkXW8BkDfqcZazqUDp7s9Ud	25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	1407	1395	493	12463	17572	jxW31v6T7UfKCVC4W8yexu7Q14FUu6zY7uq2bDA2oL52FEU3G9R	12772	17957	17957	1619171460000
25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	1403	782	493	12463	17574	jxTcJrYjJn2a2VGzPZrrevMupaoXaQq9c5hzZ5zF2XuArRtSPvj	12773	17958	17958	1619171640000
25837	3NL9qoXKJS2EsLZwxev18AH1Sj1WeXBceEtT2acostqDkVe1adwB	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	470	1063	493	12463	17581	jwVxudn8FVc6fCV92ofV2ELGYEFz4ctMoWFD2hKX9gfX34bQidu	12775	17960	17960	1619172000000
25841	3NLHvGmj5uaTqt5NuZpXy2VaApZiDUZa2QvgJn8i8HMFWwBH2bKx	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1651	1175	493	12463	17585	jxRoV8aUC2bbArTVANPa2unJmgS4af34KAgM6LbibbvS57Wjcoi	12776	17961	17961	1619172180000
25843	3NKE2C9V9ZBehvbHgY263bQu1Aei8Vjy76miQtdf7Ub63TZT3tzW	25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	298	1062	494	12463	17586	jwYNGsvVn1SQM37o76fPVXcr9fV8ESpLS2XGdccEwxqwYAgnLoE	12777	17962	17962	1619172360000
25846	3NK93fL1o1cR11Vceko8xj6MQXmbo5ZCL57kemmCBx6UU9HXWmWT	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1637	815	494	12463	17588	jwWnqfjwjgkFMJ5Z4QxCh7tWybZH2G6ZJo5HtgWpS4y1Crb2dq4	12778	17963	17963	1619172540000
25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	25850	3NLS8UtkENVTbwLwS733d2oTUdBss9wqFZXoLJgpnCE17dsBF5PW	1407	1395	494	12463	17593	jxf2x1cjyPwWqjsbUSJJWhuH4mGFJAXuiVexhFfteUiwdH4QtZ4	12781	17970	17970	1619173800000
25858	3NLMd1SkZ8GQ1bi17CSK8TZtU7h9zLE19MFX2VN7FgBnmAdGBLYa	25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	1579	1263	494	12463	17598	jxwso9cJHz5WezsceKQQKFdufNEKFMKzoh5sLozidJgTtfDF2P1	12784	17973	17973	1619174340000
25861	3NKZExTzBz2uhfPSagbaNAswBkTYWuZbfZ6xd9jk1AN1Xg2KLTK6	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1588	1146	494	12463	17600	jwwhsqgRxaeT7DY8ieoPCwRJXdx5LWfNpVBzeNXddJkt7kZvj9g	12785	17975	17975	1619174700000
25865	3NLovBAwwBL6tjrcrrS4Ln7ToyFMDBbQFKMTJQa5YCC91GMa6k6g	25766	3NKB7prweAm9qMUVCn9NsZScgYyX1k9ypQUrm718LQDrJXrkAUQs	1646	1108	492	12463	17604	jxGtWA9yKAkBfHXUzkxUUjRKmhDzUW2wNBwf6C9bKps2EPjPfWi	12745	17978	17978	1619175240000
25870	3NLdtKXkbjdY9Wz5XCGc7aDvvAxGpKeBzVZU24s7W661XS6NN6Ux	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1402	850	494	12463	17609	jwjVWACXb9iZbWqSHq9RQjGZzs2DsvaNkRqfeH5BcFoXEQaKsum	12788	17979	17979	1619175420000
25875	3NKhyxQRHLxbAyJd3sWdQHf2T75AGqKvyV3x9zfnHn52PevyzimN	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jwAMNvheoJvmBciGrY1Ebt7Xz1m2iFDw5HqGYGqb8deVn6eCEsK	12789	17981	17981	1619175780000
25881	3NKrYZzyTTQiLQge6ZhHovYAmWBft5GXV5VTz6tFyijCW8fEQhG3	25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	470	1309	494	12463	17617	jwkQQULtTw6dEpnZqj3xPt1CkJKePb6mCSr4k659j9ooFQ5PVum	12791	17985	17985	1619176500000
25888	3NLp2g66v8Po6LzWpo1udwoYNu6poFPQepHyCp2EteYZ1pKTYRuN	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1406	1393	494	12463	17624	jwXscCH1sN1ebHuED2xF365Z9Mqgjd2h4DY7V9A2ZYAHr74XidA	12795	17990	17990	1619177400000
25901	3NKcaG6rJzNRxNDKL7QdP9vmAi6NRTEcimKYCjjRv6EUy5pS28mm	25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	1546	1339	495	12463	17637	jwdx5hAUc9uqtEgURaAr8CmXnZwV5bGFwxaByZhY8MseJH3VNF5	12802	18002	18002	1619179560000
25903	3NLgmpH8VCLUs6j2BuiLmSyE2gkaZChqcEvpg3tEG3TQUXTi6gYg	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1637	816	480	12463	17639	jx8QPktrisrduArMEpCiwjAgeBTC1H3mye8vvBCvkDKuNo4GV4J	12515	18002	18002	1619179610532
25906	3NLBXQqHdbZHoYTFBHv2GMv23AhjvJjpBGsxZPuTP2XLhoNZwMmM	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	576	1355	495	12463	17642	jweBftKmZ9T8F1uym2TNpjhSEwRUX9vfRr9Lr8ffRjTwvUE299V	12804	18006	18006	1619180280000
25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1407	1395	495	12463	17649	jxBZnbHwi1TBSbo78oijQVX668xNctYwgvHQLrUSs198poGaucK	12806	18008	18008	1619180640000
25915	3NKB1ZNGRt87kLCBa57X7XB24D3MwyP5HwvJcBYKxhoPRzJuTMMT	25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	1578	1296	495	12463	17650	jwzPi6AQgxdaRetfND6PgdBb5YSG15CpJPUevRViCNtFvMwgUcW	12807	18010	18010	1619181000000
25924	3NKtkiNL3PhZvKSyaJ8W5uZNhUETLGjnUWpEHGSCFtPsbzUVUFyy	25923	3NLFJFj8bftQS8hnMT4HHyx7QUuRqfStpyeTnJcuANDQxHheVEX6	1623	830	495	12463	17657	jwjKgqQse4jqzmTcvpA2cMYyy3JtGKPT4oppJ4fuNG7m3pmYSdf	12810	18013	18013	1619181540000
25927	3NKa2rgzWjEsjDBp8nK6QKJyiiDJev2mm3Q4EDHnjWycNTch3uLH	25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	1481	790	495	12463	17660	jwmm3UJqsxgHN7zwdbumze6N7KrJNUd7uepnBkzYzKDGnH5TS9d	12812	18017	18017	1619182260000
25935	3NLUWPyFvxHn1Vf62e4tnoJGCX6UD74xPp1XHPx2poS5Ld1Aa9nv	25934	3NLTZDcRDea2ZHzZzs2KDPMUZrH7sEyemFSu2jSTgx9ZvUybt4rT	1542	1178	495	12463	17668	jxuw7bn8xwg1vZgnuQPyA66D2PYM2di9qg9dGgt51c2oEDhZRqJ	12818	18026	18026	1619183880000
25936	3NLuZA7W1hwiFyKHsLmvSwzNuEPvUAYWG3vZVdog5Vo61CMKj2iQ	25935	3NLUWPyFvxHn1Vf62e4tnoJGCX6UD74xPp1XHPx2poS5Ld1Aa9nv	1631	794	495	12463	17669	jwvhd4jvMh6BCNy9YYQL6p1GxooWciTXuaa8steEHRCyjEdX17g	12819	18029	18029	1619184420000
25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	298	1062	495	12463	17673	jwffMHnTG2HAr9n7dygUiaVKesxD3XFJezKVE5vydiQmtqpruWF	12821	18034	18034	1619185320000
25944	3NLffgXbpdPUmpLFXseDFvVtE4NoikbmzMY5NNw58NFwqCn1vFwV	25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	633	1258	485	12463	17675	jxfAgupAp1LYrKpY514NwhLwpU5NQbCEj4sSgfEfVjGw6n5XjC6	12602	18037	18037	1619185860000
25947	3NLjk4nfA1ucfCNtctyB4nkXE4BK4tmjB5kH272sznNe39YT4T1V	25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	633	1258	485	12463	17678	jwehfj4ayrvhhXxUQEtf5hbXuz5w9CyYMSKW8sKgjnot7c9k9F4	12614	18037	18037	1619185899958
25950	3NKFYpunjLXNgfbaB3Afu6ut9QNbituDizzGojHvb1UWVdi7RSAF	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	633	1258	486	12463	17681	jxndfiNzcjL48Vh1W9vrqKuQpENYHT828nQA2R5t728ktVmqSbM	12637	18037	18037	1619185977372
25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1489	1380	493	12463	17576	jxgX7eLYJFuGFsAGWo5ezWhFYuHLWw94ubFPmP2tVKVzVu9bS7E	12774	17959	17959	1619171820000
25834	3NLwWWVJWhBnqTdBFFWbMhTPEp43uZcPLxjswUDAyBfRCrVmYSzh	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1405	851	493	12463	17578	jwzo6WSci944JRCyQ5HLooKNKtCRpCReByrJuXrZgxTTNM8msLm	12774	17959	17959	1619171820000
25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1637	816	493	12463	17580	jwfMaCkAMUVeUmsfziGYDHJPuY58GT2M2xsNNqiR6j5nZ1dAHNU	12775	17960	17960	1619172000000
25845	3NLfWUq6BSyWzgC1626MVFTvHmFSDPVNHH9cWc8W4BT3LmGkMjgY	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1407	1395	494	12463	17587	jwy26RSFrHaShKmUGheax75zoXSLhXNi8C9SJLYx4jhLmeG6qJc	12778	17963	17963	1619172540000
25848	3NLEieVtb7GuaZxNb2eRiN143NLsiXE1DifsWpdRVV2D5vg2WPar	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	632	1382	494	12463	17590	jxGWTAzDsga7mxfoG2abdSkuk3NTFtDkdhHqz7YJzzQgUmvNMsk	12778	17963	17963	1619172540000
25850	3NLS8UtkENVTbwLwS733d2oTUdBss9wqFZXoLJgpnCE17dsBF5PW	25849	3NLMws488Ymzx6Sassk9k461SJ5DNVNPHuT44Zr2y5X3SftPxURr	1402	868	494	12463	17592	jxkE7BbE9uWNtNy33XTi96dqrFtWjnybSrAm2eVoXkwKNJuqseX	12780	17968	17968	1619173440000
25853	3NLamhQsKRJo9oXXXimShxjHdaD4xAderXDknkzoHz8nfcEgnsNu	25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	1403	824	494	12463	17595	jxBafS8kr6FMuTZqjwkXVeY9tRBYaDZJmC8vCDQzLa7Y7YKwqbX	12782	17971	17971	1619173980000
25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jxdSr3DYVTPPjGVjVFNN3DQDSK2wB17o8ahiKPe323ZhgLB8HGe	12783	17972	17972	1619174160000
25860	3NLjkf1YJbrm9LrvceBB17KBXiARwRQo8Uqv5yDzidZi3PKSJmLD	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1407	1395	494	12463	17599	jwaCPX8SSE3rnmRKMtcTa8DifgvR7GCY3WsSEUv2QD8anbiSNx6	12785	17975	17975	1619174700000
25862	3NLqMHAjNVnVUmUKYDwk234ZM312KkZANvcjGw8oR28YZwQBPEfD	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1403	824	494	12463	17601	jwsSTYHoXnUrW33j78SCXqAH8X5bkGqCZSFJUtf7gqwEqQEQSKy	12785	17975	17975	1619174700000
25864	3NL4tcn9CGMKQ9fn3RM4SCqViMRXk5KLdkhP9YHTJFUAAvmPWtnM	25861	3NKZExTzBz2uhfPSagbaNAswBkTYWuZbfZ6xd9jk1AN1Xg2KLTK6	1405	861	494	12463	17603	jwL6XRW2VhbfxUgMtXc5S6JqAUdscpbcUbG6JXDNt7u3z1UsNKh	12786	17976	17976	1619174880000
25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1587	1357	494	12463	17606	jwCrdkKBHTcYMae9Kv87kTZj1Fb2sGmB4Sp9PnFqjS9zGxzQPTM	12788	17979	17979	1619175420000
25869	3NKqURnsu3ho9Ziqf8QfiWofebSMnBDyKY19tpoXKBD1qtVoWuTZ	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1406	1393	494	12463	17608	jxagRugDDBY4sjF79qvpAJTURw4fmd7WeHGtouBw9Us3oVjQeFP	12788	17979	17979	1619175420000
25874	3NK8GT8S1bCmGNDgz74voy3MMwX7RuKQ5faYKw3cr4SJxizjBkN9	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jxjkPnpnTEK4RJwi3taGFYBr7SgqRdZ5d81d9g8cxZmbuh2oqCB	12789	17981	17981	1619175780000
25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1587	1357	494	12463	17613	jxdGd13XuG1Cjctns4A1AawFL1k9To3jLsE7xc1xePCFtspj7ao	12789	17981	17981	1619175780000
25878	3NKM61q4KsppEqb1JHoLJpdU2XkeHQPeChmZwWx8kFcbXG8oJw9s	25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	1406	1393	494	12463	17614	jwzpdwVAhd4kges7Fu2QP4YHwF4x3fbgKAzv95AhW27etWYYDvo	12790	17984	17984	1619176320000
25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	1455	1332	494	12463	17619	jxk157FwBnpsB4SRRhAPyZ8BHiY4tiwrUWzSvvWaWtKXKawEcV6	12792	17986	17986	1619176680000
25885	3NLWzfQhqoz5ykiepEZZLSWHs7Vfx6MPdGnxdDiRBywTUuAZ4QLB	25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	1403	824	494	12463	17621	jxGGUJLc97bEXLwUFAgfoZPs4m1WP4gEVP3UxRECdHzruQZPhdX	12793	17987	17987	1619176860000
25890	3NKVz2JDjUrcDbQJU9Ghw6sopEkYYXFnT1QR2aZ3w49qMtjwEaJG	25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	1406	1393	494	12463	17626	jxauui33NrMKQRN4oX1xtLWG3j8nechYWNFc7Pw5raK18MrrZUh	12796	17991	17991	1619177580000
25892	3NKhyxuzDsmX9FGarA9E2zvmKXaQgx1dzubLzV6eH29SVqDeX7ur	25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	1460	1198	494	12463	17628	jwDdD1BbqPsb9S7EvTFHfWD4RowgWHV3vNxh7xDktbQZbo4XWNc	12797	17992	17992	1619177760000
25896	3NKfGtMrVxWEkiGs5XFhvSJk3bHX3SXoZ1iNQC6SXoBqKsfeWoPM	25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	1402	870	495	12463	17632	jwj7kDsSqr66LyKWCWY8AqUriAQXXLycyB6rYvjU4MjBdhkWUBF	12799	17999	17999	1619179020000
25899	3NKkXt2LHs4NPwatzEywDHbZvUzkRMTd5Rx5hrgVK7horRqdQ3Hk	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1406	1393	495	12463	17635	jxnMNsJ2k6CGDEm9SkaqEucxADWd48wvL4evjSEH34PdHo37Nzv	12801	18001	18001	1619179380000
25905	3NKWcATfYw1AUKJo9HR8bjpXGczseiS8nM8hrS9Do7wyApAQYyLA	25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	1455	966	495	12463	17641	jxm8PUVtqKDzLdXcnAeEBizqVbPrkeNdJ5Wsv47jvpvQZ8w8nYV	12803	18003	18003	1619179740000
25910	3NLikrtJSYHxLJs7D4Z7uMhtpyc3kihCbRmcejao87HTv5a2fXL4	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	470	1309	495	12463	17646	jwRsEovqWNz1qFNaBGoYMkTqHqF2mFX1LDsdFHFANVdDiMzfoSP	12805	18007	18007	1619180460000
25912	3NKrcAwibNb8kEBvgmH9wmZFeYWsrgXk582ToSVReAzQEz8bc9zY	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1542	1304	495	12463	17648	jxK96jCmVb2c1hyabkXCgp2DzMApxXCjfeFDZyksqpN1GyBVEbc	12806	18008	18008	1619180640000
25914	3NL4HRzw4DQd4nUy2KzZdjNwU2f6VQbXTPxvSms5bZp1nqaHbMUh	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1542	1304	495	12463	17648	jxLydKKR8J4SoN4ybM4DPyQnHVYdy7aYKRQav5uNNfTiSTjuaDg	12806	18008	18008	1619180640000
25917	3NKoFQrtiYZXgnBbBVLvToszg73rh7QnNBoS47j5MXWuxEGLDJVU	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1588	1392	495	12463	17652	jxnWbTaqW2BcUd9yKWNSt5u6i7Wrb9BTkqRRny1xiTG3B4jdCu9	12808	18011	18011	1619181180000
25919	3NK49SdDPpc583a8y8tmCicP9RZpt6hePwmsATTT7xizWJqHra8R	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1403	824	495	12463	17654	jxuYv9HxQuYFnytXxf8FL1KJe88AaSc86L2v6ZUjSHPD2oc4zEH	12808	18011	18011	1619181180000
25921	3NKeWvCkbt9vK1eiDn7Z1dst8YgMrqy3ej68U5dnY6bmxRkeQRJi	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jxQTFwZqa95UcwVFFEvNpFmF9CWCyaVqq2jVHTma94CpTbMc1AB	12809	18012	18012	1619181360000
25923	3NLFJFj8bftQS8hnMT4HHyx7QUuRqfStpyeTnJcuANDQxHheVEX6	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1403	824	495	12463	17656	jwJUT23CTGVMBfMQ9PHgyQfmEFDTyJ9NLXUdZ6PUFsW4w9zvAPm	12809	18012	18012	1619181360000
25929	3NLBHdeQfyQ77zMXJubVRPXFuowDs1GNhamm2jPtAXuY1hamjKoX	25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	1656	1343	495	12463	17662	jwwu93pRLADDVLrcYYCef4tPMP5JvpJabU8hKTZJFEKmfWZjwqm	12814	18020	18020	1619182800000
25932	3NLpPCqnVNy5yUbFM6qunwHrKNTugcDnGsdUvge7sKvNTgArrHNa	25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	1503	1031	495	12463	17665	jwtVuVoMtuy3L3Q5pu12dsphy8fEALQBh1YxgffeCm63dbPPeLE	12816	18024	18024	1619183520000
25868	3NLpGo34FzJXjTVCXYMdWTefQDNaGSG9Z2RbLPQPEjefxKkYYEsc	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1637	816	494	12463	17607	jwnHxfbuuFB35sJ4FSh6RhJdHrHetQ6eNbTD9vWJJxsjTj4wARL	12788	17979	17979	1619175420000
25872	3NLJvuaYA6G6j7WGNbTvhK1RgusVEJ7eJVKVTBJDpt8g6PK5SWyT	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1534	81	494	12463	17610	jwhztVt2eSw2tgtBLErWthkoY3B9Nxsh2JxWhMbX8zMvyL7quwr	12788	17979	17979	1619175420000
25876	3NLhLr5FyDkmBhnB6LQ9zS4bChZqC9tST3v676bJNTUTQD3htvpf	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1406	1393	494	12463	17612	jxMYD16Z3mvrcKZ8UYyMAL6G3NLttbZTauqmhomeBNYHV2civYG	12789	17981	17981	1619175780000
25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	1657	978	494	12463	17615	jxhrXpeCd5PT4kbnPhmJEzEhhthStrP5hEgkjtagb5skW7s98aw	12790	17984	17984	1619176320000
25884	3NKS2CSKN3aiAoQoKiubrUgGwd3bcxF1hnSYRbY5fqLZdMEoktC8	25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	1406	1393	494	12463	17620	jx9k5KdKPJiuVdA1Qe5EdtC2XUhTMVSfC9DCzNn37LBDrAz6rAx	12793	17987	17987	1619176860000
25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	25884	3NKS2CSKN3aiAoQoKiubrUgGwd3bcxF1hnSYRbY5fqLZdMEoktC8	1402	906	494	12463	17622	jwrGKFoqpvy4mtfGDmbCcTHmtgrMxg1N98hQf6xz7wMLE44rFLm	12794	17988	17988	1619177040000
25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	1634	1331	494	12463	17627	jxeuwHgq48WSPCcJHoLugiBki6dJ5LkeKYWT5TECZC6Sbcp35XH	12796	17991	17991	1619177580000
25893	3NKpqJDeKes3nSdQTA62AS8JetnzYGrpN7QEeMHf8uqxdB51Z5qF	25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	1596	1237	494	12463	17629	jxnD8G8i4hsZzuuFKmZYjWgfQFQqpEiQrJ4Qyq24wegFUTXFXUF	12797	17992	17992	1619177760000
25895	3NLoK7p5ottZnuwt5uhcYofDcaYPZ5CJ3mZ72AqEjisMSH5VxDVC	25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	1407	1395	495	12463	17631	jwiuh3ei9Rkpba7t1FqYMGYjv8r2ziwVnz5ABvs1mZ12A32QCPA	12799	17999	17999	1619179020000
25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	25896	3NKfGtMrVxWEkiGs5XFhvSJk3bHX3SXoZ1iNQC6SXoBqKsfeWoPM	1471	1260	495	12463	17633	jxw7Pz4BwHogBD5QJWVHuRKotUmqnGD9xRPWyN8miZAP5prWrmC	12800	18000	18000	1619179200000
25900	3NKxez2ikmmvCmThpwwEaVomRxwT7kpr9iqtFLEskaCRoqSuW1nT	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1627	1019	495	12463	17636	jxdHP6q5Nbih9JZR57KqxUrghVJeJBCbFTp8RaN8dF8aBdikawY	12801	18001	18001	1619179380000
25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	1407	1395	495	12463	17640	jwRs8L47nQ8Fbwsr4WQK2En8yvHo4exZ66i3No9qQ786noyJHqT	12803	18003	18003	1619179740000
25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	1406	1393	495	12463	17643	jxzfAHuEXTqCP8V9DrSdukD1CEZo2ZuakyhhKXUCtb9cvbzwu57	12804	18006	18006	1619180280000
25909	3NKwx5vQDgPnt98ugSX6J8Dt7eGcGfM8GiCgYmVC4Qzy9rPiXLcj	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	1406	1393	495	12463	17645	jx7FVRT8XE5HXJGRSFkAYpXyqg2uN2wnrHTS7yRRenyZNBCWTrg	12805	18007	18007	1619180460000
25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	1581	778	495	12463	17647	jwX26QKL3s2b7Nue8o8UDc9ni1do5sTJtcXUs5ZoQsdKkK5p2c1	12805	18007	18007	1619180460000
25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1406	1393	495	12463	17653	jx3cBY29uCFdsbLFXVUtXULbnfvzCbJTNqV9jzbQp8bjvdEwF2T	12808	18011	18011	1619181180000
25920	3NLRahBr6vFHvTQVfmoSEAfLyavjocZEUnkehdBq5ax8FzKgrtqE	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jx7WBcrtXbwfjHfCw4EYxvifXzWRwSw5MpzeSkCQCnnNcLhjyCG	12809	18012	18012	1619181360000
25922	3NLWDtrLmNZvXHhB38wsXHWz4J8BCHqVXSyed1m7BMgQdRJKBfLd	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jxbAYqt2yGvTJe8BiRJiKquqwEL4Uhx1hdvm8YdHZ4M7nZF689s	12809	18012	18012	1619181360000
25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	25924	3NKtkiNL3PhZvKSyaJ8W5uZNhUETLGjnUWpEHGSCFtPsbzUVUFyy	1406	1393	495	12463	17658	jxUupa3eh6hr3uHZWwNY39R7rY26z91o6RJvKxz55z8Dr2YXGXQ	12811	18016	18016	1619182080000
25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	25927	3NKa2rgzWjEsjDBp8nK6QKJyiiDJev2mm3Q4EDHnjWycNTch3uLH	1600	1126	495	12463	17661	jxsrL6wVdmXsKEPNEjRpCvQoDfMW4tTeLE4U3wR1bjTTZ5RiasQ	12813	18019	18019	1619182620000
25930	3NLBBW3XtSG78XHN47DNrBE2kZe965W5ijjyvohDkBYxyLStAMem	25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	1581	778	495	12463	17663	jxnj2SxV3mAUVXspq3SYkyiYViSCjVAnratqX1cvy4WGUzz2fkX	12814	18020	18020	1619182800000
25933	3NLBeU8wKj5JGuDuFR9THK4siG3VWQ6yKcwKVeZxJuTja6QDUdDX	25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	1573	1192	495	12463	17666	jxUraRLhE7kPvAopqMH7oyjWQq7gQZQKpA29ERZQCUVUymj1KBM	12816	18024	18024	1619183520000
25941	3NLtcJWQB79t9wUeSYkeSn2TKBjWhL6ZtBCJdJ21MBFwV7MTvoPT	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	311	1061	495	12463	17671	jx1Jdx7nM1tLhpKtVECs1ZckiEzSuZAS5HNsWK64UGR4fmBKwYx	12821	18034	18034	1619185320000
25945	3NL1CtA8bdx8uozEs8o5CG4jP2ZNcuStwkTbrfEcsEB91MTh4cMt	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	633	1258	496	12463	17676	jxygd4X8QKn67hgnwPMDkddyBuNSuu5FuD3pfS43YrAGwzfvSBX	12822	18037	18037	1619185860000
25951	3NLXcamYETeHHPEvdb4hcZjFvfU8LeZEWfUWneY5nEMdGVoRYiqL	25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	1670	1282	496	12463	17682	jwRrFQovepDJqobCtT8GQWoWt4Tdd1LtKZbS4kaETz2Tc4jChcQ	12824	18039	18039	1619186220000
25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	25952	3NKHsR9JXdL3n4HctQJXhGzw9WdeFTjAMGb7bZfcU9t3JBeeY9Z3	1607	1348	496	12463	17684	jxrMM1mxC7TJdjoLvu64wsbhmUyttG67RaDuPafwmz1PWeMDDPE	12825	18040	18040	1619186400000
25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1553	776	496	12463	17689	jxLrXg8TCHEc5z8VzrWCfhvR7bZzc1FUXfxugKyNf95TsRxexCx	12827	18043	18043	1619186940000
25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	1509	954	496	12463	17691	jxU6EL2924BC3dofheFZLJhMHemU4fQbLpx5m6HyVTZMs9hY3nh	12828	18044	18044	1619187120000
25963	3NKXedbAqRuKTPpmKa7zPBtTiP5B1ntQTGUTjBGKFtxpiGxRbqEi	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1407	1395	496	12463	17694	jx3QSgL61yE8a2BZtb4m4SfzNT3fpmTycR99F1FQQnZnWBvTkNs	12829	18046	18046	1619187480000
25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	1426	1364	496	12463	17698	jwy5AVHSk38TfrnE4cV36HjjkkruSpfDJ7dzy6iEk19GefByVBt	12830	18048	18048	1619187840000
25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	1623	830	496	12463	17705	jwU5JK42a4AmyLDuo6ALRg3isW3683AVc8SxgvhWn4jAWgU75E8	12834	18052	18052	1619188560000
25977	3NKwoUnkNbGqDuxuDQ22BM6hw5S3ESM3rUzjXEq7GTgk3NfxCjxd	25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	1405	867	496	12463	17708	jwMTAscuSaDuozZ9rP17poLwc9kvYj1mvPwrvgEEzrgRkhFsdpg	12835	18053	18053	1619188740000
25908	3NKvCELt9F7WCnJGzjnp3doHseEmcRuVzuNBz57A1qZFir8Qde6v	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	564	564	495	12463	17644	jwRvSKHZWb9E9o2Depd27z1sAEhHaNbRrbZZ6ZwrmxvZRcYZ1w8	12804	18006	18006	1619180280000
25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	1500	1297	495	12463	17651	jxApbmSqUDZC8KUxHrAjaHHeFfHQ84rte9ueAGTqcBTwGN3bsV3	12807	18010	18010	1619181000000
25926	3NLRyPXKpZnsxNpabMawAccNqEdMeivPDwPxATgusrfhkp2QAUiU	25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	1457	1145	495	12463	17659	jxC4VHU8Ah8aJ1hZLzYpDifHFKE5w33orH8b1Pizqo2fVXVa16v	12812	18017	18017	1619182260000
25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	25930	3NLBBW3XtSG78XHN47DNrBE2kZe965W5ijjyvohDkBYxyLStAMem	1403	824	495	12463	17664	jwWYgbLkLuSYUdp6hZBMy2Hm6sKBzyPDfnTmbtjskmJb3JV3Xob	12815	18022	18022	1619183160000
25934	3NLTZDcRDea2ZHzZzs2KDPMUZrH7sEyemFSu2jSTgx9ZvUybt4rT	25932	3NLpPCqnVNy5yUbFM6qunwHrKNTugcDnGsdUvge7sKvNTgArrHNa	1536	1187	495	12463	17667	jwQHHjLbbLEygKrZ2FoAWUT4YbENaVz53BehBhB9Cddy8C5B2BQ	12817	18025	18025	1619183700000
25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	25936	3NLuZA7W1hwiFyKHsLmvSwzNuEPvUAYWG3vZVdog5Vo61CMKj2iQ	1403	824	495	12463	17670	jwhVgEaUwmhguvTNvTgbrf21poa7mtVNrTYceZbAGs3RWZAdhfm	12820	18030	18030	1619184600000
25938	3NLAByun3UNUUpY954JyoJycifGqZgrHpwbg8mqjtHmuSGb6x8tM	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	311	1061	495	12463	17671	jxQcAiK3szWctPY6G6MvYCt4fijtTrL7mPWN6vPWeWyS2hJxjF3	12821	18034	18034	1619185320000
25942	3NKjAM6HyqiGPhwt2XsW7u5QGpkL1ToEJ9Jn4LGAmKgBeR4yQ9Xu	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	1537	227	495	12463	17672	jwEPTGQruBSXLJtNNY1JqihWYdRFMuxC4zpdXi6WJbnvZaVYX9k	12821	18034	18034	1619185320000
25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	25943	3NLwNMXpZvd3XVwgBrszBzu7W8JB7oAzUxR6rb8iMXwpJUcyWhuF	1521	233	496	12463	17679	jxYcmq2kMnFpyuVFEh23mEyxW42ynvzfNabkq3kqiN4dqJXBXNN	12823	18037	18037	1619185860000
25949	3NKyMm7RRLeFABoEvbizjJtHMr2TtDyrSCcuLBXpkqxQK9QqGACW	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	633	1258	486	12463	17680	jxBYjXkRgXQpdYQMrefy1yuTKBkX6Fi5bQBMXGziEu25LHfZ2jG	12626	18037	18037	1619185939015
25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	1573	1318	496	12463	17687	jxF2Wi4drXkL7KTg5UsjLXXgr5hTsibQCCfRDgD7osU4CerFoLf	12826	18041	18041	1619186580000
25964	3NL7tTgws7GL3eeA92fTxVkpSUXkEYm9mPYiYpLVsJHvhT2uxo1M	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	152	1204	496	12463	17695	jxBtCxxWZJqCDk9NgF5D9MeD8rMduxca9v8JkdhXYCqfFZdZnUx	12829	18046	18046	1619187480000
25968	3NLEFgLA8iWjJKDJFu8vzjbei8NPmvua3q1sAr1zger48fmG7XoU	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	1406	1393	496	12463	17699	jy25mN6PtZEyHgfyoaUNfLwGmtbMBUXJbgWkoZdWZTU54eFrZoP	12830	18048	18048	1619187840000
25970	3NK6vLEueaLdgRAHhPjPxtctjvnBP1EhQg9ZJ9uo3hP4NeiNRNjq	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1407	1395	496	12463	17701	jwXZe1Bd5fBfXx1bicyJaJQWP99HZeLqg1kcBSfNWsMQMGK8z5i	12831	18049	18049	1619188020000
25972	3NLLpdnfv2Epjc8j8zPWxNMiPhq5yXHFgtuavcRV9HzjjDooVTwe	25971	3NKUJ6NhY6x9JZL22hkVjFHCYRa6fpccCWvtojRtLKnTihoBqQ7D	1561	3	496	12463	17703	jwW6FDVAe1vYPjP6PGbKnBGjdx1q3Mwa44ftteJjcTs9RrgNgnX	12832	18050	18050	1619188200000
25980	3NKAYiz17juyW9zR6mjQ8uNxJNr5dpVBGiitBK1YgvCLXFW45KiC	25979	3NKbL1PJAC4remdM3W2pWCm7uJwRbmsqLDUECxKjsrALsqT4jfEk	448	1059	496	12463	17711	jxKM9w4HTB72sAo86RWcVGkiyuaKCu7CwHzzuBmbfqxrSDZzYt3	12838	18057	18057	1619189460000
25985	3NKnieiZzZ3dvdy96G7EXixRLwbmj2qJRfMp8T1fXssEL4uXnanZ	25982	3NKii7RXMezkYiww7JDsfFedDwdke78MAvA7MKQtEKZtVWFH3yMC	1500	1051	496	12463	17716	jxcrGDaQgC7bejpJy3UYxn2Sivct7Bz9g1YgUbqfMQGGwJAZ4YY	12841	18062	18062	1619190360000
25990	3NLFevyz4HSawk33oFz6hUhvCZGPAsYb5GsWdfN4BVtY1YLyusvJ	25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	1631	794	496	12463	17721	jx5yGqNZFzhmHqeDkJr7xoyRCab8CcApADma5Ey1SRz3GXWq2nb	12844	18065	18065	1619190900000
25995	3NK9b6trwjxQPt7wJ6NzD2ZxVtHSSoX7sXsvz32itAHCjLx1upyg	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	1564	1338	496	12463	17726	jwbzDcEUa4wVrXFPeLoSKmkofDP9Y9Kuz3BALWySsMygG7r3Lrk	12847	18069	18069	1619191620000
26004	3NLUuyjxRDLsvrSK7BYhcgR7232aCNdijicSdko4YBDo22eZ6CLF	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1651	1301	497	12463	17734	jx76SAn3P7iFqM8AQMHF6xwXyBN7WSqeiMUhgDEGjvzfzKc1FQ8	12851	18073	18073	1619192340000
26012	3NLV5sAsswPLtYmF8RyiSA9pfYuxPddoPnDTc1MP9mS2RvPTtVeS	26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	1602	1369	497	12463	17741	jw79vaprjFb9vtaZ6RG38FNJxiKRjETJwyUQUz3uerB3hcRwuQ1	12857	18081	18081	1619193780000
26014	3NKoGwdwVSRQ25NewfTHZ6ght6CxVwHH7B5RUmwwvrRTaaKUoaxJ	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1423	559	488	12463	17743	jwAhiTZ362W4CSgTYjmRikrEnnkLxPy5MZmqFzxE466GzHLQQWm	12665	18082	18082	1619193960000
26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	26020	3NLLvCoLHEHVtxqLtHxpbEhjX7x5mnhnWnEkvvqA8h6uT2w5aHgS	1657	1218	497	12463	17748	jx8uj2PSVx8RfrytCSnjcjpq4Yb5stn1SXDPztTCJcDmQbxjMGq	12860	18084	18084	1619194320000
26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	1403	812	497	12463	17750	jwqDT1XnyXUkPpdM8QPkGELQ2gV8qVHDP4Z9ZChUohaxHQkZn25	12861	18085	18085	1619194500000
26028	3NLCidKmnpGU3wtDe3BhQGTgkVoWqLSQ12Fn8XL7k63X3CLmKr6u	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1503	911	497	12463	17755	jxNUQhkEJ2JHdJ1v9XixQMfM5CZ95tsv2PKnWe8DjfHAzwWJwha	12864	18088	18088	1619195040000
26030	3NL66GQUpKfHiLvDzubowacJ3KA7XSZ3vKnPJpWjXVvFjcMzgzTP	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1407	1395	497	12463	17757	jx93dU8K56B6WK2qZQe9MxCNu1ZiPprdM5nE6mp86HP2FiUZ4Jh	12864	18088	18088	1619195040000
26033	3NL32Pxg4JoaMFWngRStW1rpha8yczSF2aHF4pWhmqpjAn6sLsgH	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1671	1119	492	12463	17760	jwfDbNLajSjiun16CtofAzUCQD2rhsZpnppNVgTEiskKv7zR3Np	12748	18088	18088	1619195040000
26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	26030	3NL66GQUpKfHiLvDzubowacJ3KA7XSZ3vKnPJpWjXVvFjcMzgzTP	1542	1304	497	12463	17763	jwugHtiXt7NHUUifphF9LmVtWA1n78eTvBhQb79XJqyzaRTFoXT	12865	18089	18089	1619195220000
26039	3NLGwLdzctufeAMKUoMnFbqE4Fgv2EBRFJzXzpLJNvD9aEEpQFGp	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1555	1101	497	12463	17766	jxXRqDR3D7HjDDaLDsLCTQpRRxzWJUvLv15HcciPiWrQ1YX8MQY	12866	18091	18091	1619195580000
26041	3NL6A8AC6zroUozFkR4iJ8bQsf9Z9k1p8rRe9VjbwTXKkP6f2qtQ	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1407	1395	497	12463	17768	jxc994V9FZ6EKCsGqU5zzwweDfmBzgyCk95tRgm66vpVBxqHo8U	12868	18093	18093	1619195940000
26043	3NL9x7H9d1xiayxTeQWkHb8gZkWZoJM4mKnXqGoD1wi4jq52Zrto	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	44	959	497	12463	17770	jxmBehEgMPLtxUGtfMNEBTY23ZmGqDawsDEk5jVfuzgam5DjVWM	12868	18093	18093	1619195940000
26045	3NKFWcAgVP8xsQM2utSkiUiMGfHm9muQp8Smm2ddJPNcoNPw9Mvs	26044	3NLVPbqC97rSNeeUSJuuXpRjhWVYCs2zHbPPDaYWqUBwGgvEK3yf	526	648	497	12463	17772	jxidUnvMWAGy7H6sy98mUbovAcGD9FvoLjwJ32oVjbXiyUTHdbf	12869	18094	18094	1619196120000
25939	3NKnZ9CUbRY2vDC7oKaX4SkurHX1mjYzF2CzQxjxS9BayCfhT2GP	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	1537	227	495	12463	17672	jxmE6j21c3rLCdZD7n45FDAuLia1jDiwRPwAtw77FMm51URgkWn	12821	18034	18034	1619185320000
25943	3NLwNMXpZvd3XVwgBrszBzu7W8JB7oAzUxR6rb8iMXwpJUcyWhuF	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	1631	794	496	12463	17674	jxz65VnQwvUN1JXerNceCfGKDRYBBaVyE3xuoKdyBehMfkzR8ym	12822	18035	18035	1619185500000
25946	3NL6uJyVqUwJ8gVPNpTJaFVMLbRcvJaobvz3Cxemvr4uZ7USZmku	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	1521	233	496	12463	17677	jy2dt2AnVAbzDRLPj7HkiibdfMR9A6uvH5jWANXsNLDmxXxme7r	12822	18037	18037	1619185860000
25952	3NKHsR9JXdL3n4HctQJXhGzw9WdeFTjAMGb7bZfcU9t3JBeeY9Z3	25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	1587	1357	496	12463	17683	jxGvBopDAdtHRKsADHrGP2d86K68T38Kai26YE7L36wXC5V9hDn	12824	18039	18039	1619186220000
25954	3NLVYBrGa7MNoKvrkfLKFDCgg24d4DCn9VmLz767dwekMuAEcxgv	25905	3NKWcATfYw1AUKJo9HR8bjpXGczseiS8nM8hrS9Do7wyApAQYyLA	1637	816	495	12463	17685	jwbvdGSrCnxEuNTK6eqDjoHvePb4ki7saJbL1szDmLFrbDBpwH3	12804	18041	18041	1619186580000
25957	3NLxH766fMwSM55ASLp2TG6iDDfW9hfoPwf6a1W92GPY8W44BUCo	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1407	1395	496	12463	17688	jwANS4aYN4bbknGN5XJxAnHrKGAZUk5hFyAubjE5a7d5soTJHYE	12827	18043	18043	1619186940000
25959	3NLB3shnToiovLeV1RsjEinK9onaBCdnCcfZNSwwboDZGZnBE42J	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1611	1341	496	12463	17690	jwGviLjHrLqNCuyaCae1r2NVKtMsTdQbbY4yJMhU72jukECB7R7	12827	18043	18043	1619186940000
25961	3NK4pA4JmPZgkdP11hzQB7BRehD6c94ncEG3y5KcTKtNQCUFfzdV	25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	171	1248	496	12463	17692	jwhhuomhyyC2eQiYSnAiUVNYSynHqaGk3NkS6vhbUzC7aKGdbjC	12828	18044	18044	1619187120000
25969	3NKgpwDmrzE9vjrWBxy1xSdJ2TXYwvBbEjpUVvPHoh9JAd1oSjLR	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	484	953	496	12463	17700	jxbh28oVBZxaXcXsZGoR8hhZVYrr3uMY18LeEHAQfhfYiStm4Wy	12830	18048	18048	1619187840000
25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	25972	3NLLpdnfv2Epjc8j8zPWxNMiPhq5yXHFgtuavcRV9HzjjDooVTwe	152	1084	496	12463	17704	jxLNe8foeDNridJA2MVRxuXzSKWvU2seBrgLQV2GKDzwymLSfgN	12833	18051	18051	1619188380000
25975	3NLVCd7sSw937uwshEftkyE5nPu8SurhZXsQVPU6tM5Ljsqgahjr	25954	3NLVYBrGa7MNoKvrkfLKFDCgg24d4DCn9VmLz767dwekMuAEcxgv	1637	816	495	12463	17706	jxifuGyQSD3btu1CSMhcXaTHwSo845WKDqYMt4RHLjWQQNZQYXz	12805	18053	18053	1619188740000
25978	3NKr3dTcRt2gMHRDaAvRxtmmYHN4VihkxyPq1VGGGAMoNBpvEK4V	25976	3NK4HnMcBFDGjuFyJ2Lik4Ft83RbV6JSV4XahkWcZZzeMTedxacn	1402	852	496	12463	17709	jwCj91nCfLuAH4cQaEozuvLGYwZEJ6f9cSBq6X5vc1fc9tegN44	12836	18055	18055	1619189100000
25983	3NKZGAjcJdjnxfnsiRvTXEmsvfDDQg2o8cNRrCJ2oExRoWnwpM4z	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	1490	1274	496	12463	17714	jwfKGzGDP5Bq1zZZ4WiKgv7zY11uGUC9JFZS4FKLJxX6r2znEQt	12840	18059	18059	1619189820000
25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	25985	3NKnieiZzZ3dvdy96G7EXixRLwbmj2qJRfMp8T1fXssEL4uXnanZ	1602	1369	496	12463	17717	jxDM3EH6XMyRCaBZNWF3MxHkuLHHS3SyspDAb9pzapJDCTAffJR	12842	18063	18063	1619190540000
25988	3NLcCfmvpr67wsn4Wn4LkmnrE61gMQz6tNU17msqKWVD2HRYBx3N	25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	1585	1240	496	12463	17719	jx2arjpVJ42V9SwxBzNy5ZjsEHmwaXdikzRYCurktVDwf65uF3Q	12843	18064	18064	1619190720000
25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	1403	824	496	12463	17724	jxMhKcU3f9ZRFYeDyb5oypi2LmFEm6gwWVoxoR9daxjwSaFXHUJ	12846	18067	18067	1619191260000
25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	1471	1140	496	12463	17729	jwdDinFVyWVMaQ3ZS1r8rvzEYYezRtrKpW5y4tbvaBp7SqV2mKy	12849	18071	18071	1619191980000
26000	3NKaHTpyzkD9KH3zF1mW673fpGoRP23Hryu38DiCraLQTYvorxxB	25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	1578	1050	497	12463	17730	jwpjZGhpHgBw5Wf5HdLhWXs34ZvkJij98m3PJ8b3SozWDEZNohY	12850	18072	18072	1619192160000
26002	3NLyS5MywmwTbjGkCQe8TDs37aApKNjszpEnknpQjyVGvFTRXmWL	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1578	1296	491	12463	17732	jxHa1WLNJ5MqGDxBSburZhfp2w4GoM1b1zHQzArJHsefUjCXahH	12731	18010	18010	1619181000000
26005	3NLNrZgXB6khdPfcqj8qP2UviQ1z9j8mhuBNZvTyoh5sAQw3YeZB	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1651	1301	497	12463	17734	jx3rrfNbKaQAdKNsASgBt4tfLcd6zn9uwsW9jUzhgZ3JvwMfPmC	12851	18073	18073	1619192340000
26007	3NLEoQdd2GDQguBj1uvE1nwzqGEEpvq3Erq47GiEnXY4AkBrce7L	26006	3NLtgGE2Y5G9xioHkL1UKEPrc93oSD4PvwmztghLHMRGZWGJX3mj	1402	882	497	12463	17736	jxZ2EUVaBwFkUrhtTr1CmxCELTK8dASGyq5Z4eHQiUywEPtntEc	12853	18076	18076	1619192880000
26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	1507	1280	497	12463	17739	jxkLuUcNY1hZUMapBFUXvDTnBbvcdqmieg1hksHa6zF66ermtog	12856	18080	18080	1619193600000
26017	3NKLxDX9qAyFDkHftCG6DCpjm964U7sRENf7aqEN3jAmiVVE7V7q	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jwvz92mcu4DSHzu2AhmVjd7oPqtwGvrnVsjhYYThEHxwEkjhY4G	12859	18083	18083	1619194140000
26019	3NKhN2T85x17JpEjrYhzQSDisJCUVM2RC83Be5oLFT1dYSP7Fx3v	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jwPgUqgESByba78Kvpq878C5H9txHm4F61am1TFkysKVHoCCCRw	12859	18083	18083	1619194140000
26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	26024	3NK42J2Rei9B5XZLVZzymT9bRDobZp7hQr53YWbLEEATDDAmJdAZ	700	832	497	12463	17753	jxEJW8ncFwkvHofgcPZk7aHDZDo4GWYhpqyxYchYmT7qrskiJzY	12863	18087	18087	1619194860000
26029	3NLdbV7NkkDFMSVrB15GqNGNKv5kTTSQJabhutR3PTVq3t6ZRKzq	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1671	1119	497	12463	17756	jxJ3ebh8Djs7DAap9TvRZpDXvxNk4Gee7E7L4xxUtZFKndia7T5	12864	18088	18088	1619195040000
26034	3NKydv6eCfzhFrdRBgc9KEN5YKfK6o2UeokmjFvLCpC1AiPpdssq	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1671	1119	491	12463	17761	jxyXm9L6apjpg2iU5fjG6F3NtHFkPWPXr6qW1hV8ts4bCCRz9aq	12733	18088	18088	1619195110624
26037	3NK7Z7vYkcmLW3d2fatJPRF4QiviMqcHzQKjBs6pKSjbjs6rhnJk	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1460	1324	497	12463	17764	jwtf8u9xBETeLqNAuATp46o4ou6rRhUabK58wecNPVVfr15MRrz	12866	18091	18091	1619195580000
26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	26045	3NKFWcAgVP8xsQM2utSkiUiMGfHm9muQp8Smm2ddJPNcoNPw9Mvs	1634	1331	497	12463	17773	jwmRQkFjbW8m3n5QsABis8bYt1Dgg9zoqQMWEoZRqFScaLBADeP	12870	18096	18096	1619196480000
26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	684	1352	498	12463	17778	jx1Cj9dZ1RRTWcbtmhpTzUoeMczB3Pkowjj5dqnGKgM4sbPdPSK	12874	18103	18103	1619197740000
26059	3NKmKPCXYpLV6evGtuNUHMxdQJCJBPjHUz2B9TaFfFRS8ZSbqHkE	26058	3NLcBpEu91r98yaNFECWU59PWqJtD5Bm4316m2hLCMPVk92XntJb	58	1281	498	12463	17784	jwKtpFP6mrYChMekoFTXwkocC39Q32r1SsinXs1ZExbbpG9bUYs	12878	18107	18107	1619198460000
26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	26059	3NKmKPCXYpLV6evGtuNUHMxdQJCJBPjHUz2B9TaFfFRS8ZSbqHkE	1509	1320	498	12463	17786	jwmoLNr1swXgPsKFn6oxCqH8i7SE5y88jQA1ZFWUuxykk44fMqN	12879	18108	18108	1619198640000
25955	3NK87NdfXKBt9kQzdygexk9ZBjes51G6NwHnM7d6gzQaidRwNoxm	25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	1406	1393	496	12463	17686	jxb6CkCwJR35kbDu85uAbEkNC6HJj2SkHNq5uYHiZRhzKfcbRTv	12826	18041	18041	1619186580000
25962	3NLjT1PbVZy8bfaC9xYX8xVvsVriAfkfBTJTmW2TZpw7snzVEuNt	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1649	1137	496	12463	17693	jwUJwR7MQgtRWMLSTPCt43g42SJF3JAaWXeiEu4sqXYcj6xFcL6	12829	18046	18046	1619187480000
25965	3NL2YrtSb6imTYGz97SHc8r7MxQuNRSjGaVTFjp3DuD5uG8rjzbP	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1581	778	496	12463	17696	jwzSiDDwcaNoesT7yQJAn5jmePoqVqCJK8z6o8cNZk4A5u1qFTW	12829	18046	18046	1619187480000
25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1611	1341	496	12463	17697	jxmEmtZbJxKAoYpRSzwAauPgiaxo8kxVFTUEMV8pqRBAmqn7ohU	12829	18046	18046	1619187480000
25971	3NKUJ6NhY6x9JZL22hkVjFHCYRa6fpccCWvtojRtLKnTihoBqQ7D	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1402	796	496	12463	17702	jxGYvENCwdJj5wZxrAYTsKnkbUMjMbakj7Qv6kh99qeiGbakXzp	12831	18049	18049	1619188020000
25976	3NK4HnMcBFDGjuFyJ2Lik4Ft83RbV6JSV4XahkWcZZzeMTedxacn	25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	1600	1372	496	12463	17707	jwPeA5WpuKpJ6Bt8TiDkd1E9FWcGpiBMcoL5Yx8cxsHAPRVvrbk	12835	18053	18053	1619188740000
25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	25980	3NKAYiz17juyW9zR6mjQ8uNxJNr5dpVBGiitBK1YgvCLXFW45KiC	1406	1393	496	12463	17712	jxgsN2SyHs3Biw7WD4vRj8Pr4NfwRmMQ1qqzkmYzjZ1PbE9yK5T	12839	18058	18058	1619189640000
25989	3NKPt783ueyfFNKbzwdYcgJETqbEU81N3JCJtxZqq3BvQuyji5Lv	25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	1553	776	496	12463	17720	jxCdr73jwrLpwSPqcPzkPXaJMqahuiasMHtAgKvy7XoCRkrCawG	12844	18065	18065	1619190900000
25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	25989	3NKPt783ueyfFNKbzwdYcgJETqbEU81N3JCJtxZqq3BvQuyji5Lv	1672	1159	496	12463	17722	jwheaEgDYLvrUWkATEn1jdscuG7iL5N8NQNr4tbD6vFWJQxnkwJ	12845	18066	18066	1619191080000
25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	1587	1111	496	12463	17725	jxBFV6BMU35nesP1ZjDaAocQXVB3U2Vb1mV5Q6EGYT7hCFTuysy	12847	18069	18069	1619191620000
25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	298	1308	496	12463	17727	jx1JWegiStQviqnfHKpLXT6xhvBjtu22VMVMJMRQAeou1awAcUU	12848	18070	18070	1619191800000
26003	3NLxRMUkY5MbbegUHSntj661RDj1pXR7evMEq9HBuz6gxaZzRH4w	26002	3NLyS5MywmwTbjGkCQe8TDs37aApKNjszpEnknpQjyVGvFTRXmWL	1578	1050	491	12463	17733	jxJC7LPJ8rouTm1gg39BE2okAxhq6u1R5AzE8ayaANKfrWfWCs9	12732	18072	18072	1619192160000
26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	26007	3NLEoQdd2GDQguBj1uvE1nwzqGEEpvq3Erq47GiEnXY4AkBrce7L	1407	1395	497	12463	17737	jwigUNbpoa6ebEAu5VF49mdZi7Lgzy8nkr3tgaSfwam64AoC2zU	12854	18078	18078	1619193240000
26011	3NKeTCok2U5saSVPU2a6WEaNpmxjejPhGG68cYcwnmzfYWe98Q13	26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	311	1307	497	12463	17740	jxnHNjtvDpZvNKqQKDeFdUJoMqGN9RHCbp6sf56UUo13y5Sa3oY	12856	18080	18080	1619193600000
26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	43	1184	497	12463	17742	jwZ85rnHM7dqzXvaVzax8pxUygdgQCWcGNhHQAQv9fyPcsuoqqK	12857	18081	18081	1619193780000
26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	1423	559	497	12463	17744	jxrQiiFudc2AEXiSctQjEfpBSWbzRfzfpEDG6ngmLiEsenzdhqs	12858	18082	18082	1619193960000
26022	3NKnb59zvBwCNDv3Ht4XaEkX4fhUxMSsXdV9y8FkQb1YVVh2Njc1	26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	1585	1120	497	12463	17749	jxcw4S59hZ6jBvusWBaAWjZj4kxhQWF7AUuiiZaczquz3wiaATh	12861	18085	18085	1619194500000
26024	3NK42J2Rei9B5XZLVZzymT9bRDobZp7hQr53YWbLEEATDDAmJdAZ	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	1407	1395	497	12463	17751	jxTiizKwL27dLXDEimVpZEy2boisbGGHSFYJYJWGXFDnY9DRErA	12862	18086	18086	1619194680000
26031	3NLmRuJEooNuuBDiBnCKXGTKFZatn4yLX7o1iPUYZynBUC9o5yVJ	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1600	1246	497	12463	17758	jwuktej5jFxeMuzYWkT6bbYNd6436EZbfqR8gox6vcGrKZZb653	12864	18088	18088	1619195040000
26035	3NKrTugi3V7keLzRMxGkDqsKHiwgrg2CzzEKCuK9PhkRsZLs7UGT	25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	1671	1119	492	12463	17762	jxbrsN9PYbDuiXyRL5BNjZGUD6dCX2WvQQUpUSuN3mRJDBBf8hN	12745	18088	18088	1619195146466
26038	3NLr1nao1J67pqTXWxFGxyRL3PBtScrBNhiwfxvwAHFW68QX7F1N	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1637	816	497	12463	17765	jxpYZq5LcFAsvC5BsiUhjM5piE6AtAdEC1XoiTwzuoCyUpnr3FM	12866	18091	18091	1619195580000
26042	3NKWwSy1CGipRwsbjxURpe7uj9cKLSsJHwnbBQnVkEyHGu1BuPhB	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1522	1196	497	12463	17769	jxNgb2KJDukmSSrioLbQXi9bDQk5wubxdH7VDipcuhsYgdYKjRh	12868	18093	18093	1619195940000
26044	3NLVPbqC97rSNeeUSJuuXpRjhWVYCs2zHbPPDaYWqUBwGgvEK3yf	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1403	824	497	12463	17771	jxwmKKJG6A9Uff4XyW9pZaCqZb7h3dkwHWfnr9f4jm6WFccqUiq	12868	18093	18093	1619195940000
26047	3NKXLwkQVzkjSsgj9wUQXimXY86QXHoBPFcbQU2NoD9mjyvZXpvj	26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	1637	816	497	12463	17774	jxWPaaYFTLqT18McP8Nbv8kZugcDJS4rzaxGERuqJo1Kd21MSxn	12871	18098	18098	1619196840000
26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	26049	3NKtWaZ33P5keD3U6TgdnTfmyaEMbpgy7dD1kiuemRDD3kkwkgto	1555	1347	497	12463	17777	jwMwc8r6N9YPHK3AEJfw9fBoiJYHAfT1WzZzjn1h52WC5kSCQyx	12873	18102	18102	1619197560000
26055	3NKsgERA6DMYMiJ12LqtNpk1gzC1Dv1zaH2BnugK9SYuCXUuPHXr	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1560	1045	498	12463	17781	jwKnFhn2kBV13N6FBLYjf4JqjhNrnDpeUrKagmgJA7TwmdTwELN	12876	18105	18105	1619198100000
26057	3NL42ce8CykPjvGF4zNhpNB7xzfRnEAbhcHuDCuFJpjq5xxe8Qfc	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1560	1045	498	12463	17781	jwsjSE6aCRdke5kh4cf76PFXwNNXZ7ewsXZnh5q2NRnDTeKsTdA	12876	18105	18105	1619198100000
26062	3NLX2mDaC2FmeJfzN8QmBwnxBNfJ7XVfMKRZWtQFY3axeWF5CcC8	26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	1406	1393	498	12463	17787	jxfCtbcit7JH7j535W5m3qhyufonKmfFPRnM4w3qutS4kraUfVe	12880	18110	18110	1619199000000
26066	3NLxyyEZEmfnitTdrLgepbdTPJdYypuMq3Ckcb2xwbiRSbSqectK	26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	1631	794	498	12463	17791	jx8UUmWX4bqrY8Qgy6QcqdY4z8eY7zPz45Rz8WsBwMnUH1h5xUk	12882	18117	18117	1619200260000
26074	3NLrnsRJ4iiSfsdTzGEXegLd7GE2zCbjmKbXGVN4VwBK2V2GGjwf	26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	1403	824	498	12463	17798	jxT2N5nKMuhGb5JEYSdKw8j7m8v7PZjpDJXpguRV5wEwLSfQ5r7	12886	18126	18126	1619201880000
26077	3NKkBsikXT3N5UyYTDTpTNH8h8tbPr3LzuXkLicMVg1gdU2ySgs5	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jxDUJAUb4rXnC1ESs1cieysahr1gFbjW4R2X9JznhhrTCSGmfHx	12887	18127	18127	1619202060000
26081	3NLV1wZfJ9ysXLV3ew2NKeto73dnK1f2q7rmWYHfu8cyVG2DDkgA	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jwSGNwmWBM6HYnQ5bWG4tasUsVjpffoxA6VuTp7624fiPRhvojp	12889	18129	18129	1619202420000
25979	3NKbL1PJAC4remdM3W2pWCm7uJwRbmsqLDUECxKjsrALsqT4jfEk	25978	3NKr3dTcRt2gMHRDaAvRxtmmYHN4VihkxyPq1VGGGAMoNBpvEK4V	1581	777	496	12463	17710	jwMwRx6b7qMFDgRkR6yjRfuTA6prm6yZCeFx4UKvc2x2iocg3aj	12837	18056	18056	1619189280000
25982	3NKii7RXMezkYiww7JDsfFedDwdke78MAvA7MKQtEKZtVWFH3yMC	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	1406	1393	496	12463	17713	jwXy3BTFtUbJJrazVUHL653yDdJxeq92PMpk2NivhGuafykyCuy	12840	18059	18059	1619189820000
25984	3NL6u4SYr2e3DTK6LkGPnqxmxNVCL819SNKWYvRhSoqfrfL4rQv1	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	42	1361	496	12463	17715	jxLPv8z12cFLMi7uA5fW6iFF7vzBYsXYrbhJwgCNiZu6t2vsrBH	12840	18059	18059	1619189820000
25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	1406	1393	496	12463	17718	jwQxQSTfZLrg4tWV8kATozt4TBwRBZVW52kJWvVzRnFCycjDd3C	12843	18064	18064	1619190720000
25992	3NKTnYu2NLwDr4QDYGr2KhwyFxz3X5y1drAjZXEW3yiYLzrvVdap	25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	1607	1102	496	12463	17723	jxAeKYLeJxRwDwVttRBZewVCsRPWMTceiASE4wVEsiwiv5hUpJk	12846	18067	18067	1619191260000
25997	3NLcwRNtg3LkgW8wwRvsQ83cqidoQM66DNVy8ioa5UqaLrpDvTga	25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	1579	1389	496	12463	17728	jxUGu5n1LWMqumoBuM5wSfx5RoNDhHUdkPqsuVzCA53tC6GSUuv	12848	18070	18070	1619191800000
25999	3NKkmhZAFpkxS6R5n2JVS4K1QcPEm5HzGqhTLqufY7AFFvPBQEjc	25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	1471	1140	497	12463	17729	jwZXwWWt1zoEchz6W8uzpt7Ritnh6hS16uqBmYDT1m4zdcuoa65	12849	18071	18071	1619191980000
26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	1594	1080	497	12463	17731	jwyFArkoKbZq7Y8tnybww2VH75RGKYLKNyGeYkECmYNXutPJQvq	12850	18072	18072	1619192160000
26006	3NLtgGE2Y5G9xioHkL1UKEPrc93oSD4PvwmztghLHMRGZWGJX3mj	26004	3NLUuyjxRDLsvrSK7BYhcgR7232aCNdijicSdko4YBDo22eZ6CLF	1407	1395	497	12463	17735	jx7AD92vghebUJP3yEUQ7qbahCQYeVTvCV48sYzphccUZd8ijeD	12852	18075	18075	1619192700000
26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	1501	1114	497	12463	17738	jxtLHresrc55GwbTgu11JuyNVokWPEA7dQzzh9WcPFMpX1NmuRJ	12855	18079	18079	1619193420000
26016	3NKRCJUaEEfFT1UFvvDYZCRYNL5fVDvERK8SfMSYLM8hp9zTa77y	26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	484	1073	497	12463	17745	jxtBdmqY5sg3dBPHbV8Z16arnvD8VXH8SYDMVnQ1kKvVyqxSVs4	12858	18082	18082	1619193960000
26018	3NLhwNGmpbnJGCEDKWsidPRtGyMS3pvpeVo9tsPS5rAtDoZSk7iu	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jxcL4PUHVnqM63ymz225iiAWuEMY3tuKV7HCAoUTBf5BRRup58y	12859	18083	18083	1619194140000
26020	3NLLvCoLHEHVtxqLtHxpbEhjX7x5mnhnWnEkvvqA8h6uT2w5aHgS	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1581	778	497	12463	17747	jww5CZHFW815sM7oxGc5iWTEpn2qwJ99vvG8gc7ib2M21fyPcs6	12859	18083	18083	1619194140000
26025	3NLMp7KrkFSNb9rQHb5zjdwiDEjJYsy4aLGTkgReTomixEKJGLwk	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	1610	948	497	12463	17752	jweGVfyCqFk438DninbneTsTUMEBJ32wDPAhgZs15iEVL78kAtK	12862	18086	18086	1619194680000
26027	3NKvkp6hK6wqkq7a71t3znAbcec4RQnrkXLkw9qWj9ps5fuX5Wcp	25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	1671	1119	490	12463	17754	jxY8EZ6u2cuZhon7g19hSj9erXquH1mVum1KFvxdMDn5eRPsZYc	12710	18088	18088	1619195040000
26032	3NKN7ApfHB35kxsGVE9qSmHBy8iSR15VBfMnYFxdtYNeVaqAWecB	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1671	1119	491	12463	17759	jwu7jq5VrLsmX6FDmwLfZifNhrfQUjvQPpT3y52LBLxKXmPsbZ8	12722	18088	18088	1619195074604
26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	26037	3NK7Z7vYkcmLW3d2fatJPRF4QiviMqcHzQKjBs6pKSjbjs6rhnJk	1407	1395	497	12463	17767	jxuoabKfS5xe7YUnYVbBhykhtHsQs88zfoYB7VLMpGo1VbV67ji	12867	18092	18092	1619195760000
26051	3NLX6D2TQoNZQ3nokg5axdYja9mC8ScyGNRVpkhBrwmPo9ZGPwc6	26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	684	1352	498	12463	17778	jxLBosVuuAatWbAkmKEWAPLE2RJ2q6sncq762QQKFymeSRkHHcM	12874	18103	18103	1619197740000
26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	1439	1033	498	12463	17779	jwyj5UY48pU3gxP7qgjs6SvymmsnJbqyaV6xYefnENCQgAjH35t	12875	18104	18104	1619197920000
26056	3NKrJBSMKNNMvVNwGKP2jqJjpZwXMMBug17au6oL3Ted86psqcBd	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1444	1135	498	12463	17782	jwyBvLdVJRpHFubUN6jm4Xi4b8x3CfnwXYkVVUXor7H72Lws8uv	12876	18105	18105	1619198100000
26060	3NLWo9kiZe6s1zwtsi4KLPFhDFwPCUcPr2zubfNRZwEKuxkzRkJq	26022	3NKnb59zvBwCNDv3Ht4XaEkX4fhUxMSsXdV9y8FkQb1YVVh2Njc1	58	1281	497	12463	17785	jxLJjtvoLHZz6FUECSiAojad8d3cDxAbZukgs2cDfAQ22X1MhdW	12862	18107	18107	1619198460000
26063	3NKteDnyecPfGJwoNUkW6Db3UW5S1Bi8z6icNsRvY951GQrSGpYe	26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	1623	830	498	12463	17788	jwXqTA4PTbHuVHy2g7ravdY8KWjUQ9MoqptscZzwgDfhDrushiL	12880	18110	18110	1619199000000
26067	3NKmoGCVJr5oi8VVZVnkAVz9vrWDbyiP372ZdzMgF9qBdLEJC1v7	26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	1643	1299	498	12463	17792	jwCGRBXHVJq5NZMs2qCqTPsQ7gw5KmC72ZXBmAFNBLJ9PKX9ZSJ	12883	18119	18119	1619200620000
26070	3NLHUvYL12JP3qxkCeszzq3Rcj35QDNkuCLZhY7QPUMbNERagg3D	26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	369	1186	498	12463	17794	jxJdv4X1eGVk19ueWAMsh8AHi3UKRA7PDsKph1GF6QfKg7mKoxg	12884	18123	18123	1619201340000
26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jx1XxyjDJXHSLaN7N5kTXU3MQfevK72YrXykcnWK8m4EXwybRJc	12887	18127	18127	1619202060000
26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	1406	1393	498	12463	17801	jx6pa5WQ9Ls6KqVBYRobt2EjDL8vPUhubiRXz8qAunU2PbkNHV6	12888	18128	18128	1619202240000
26087	3NLKunub5Dnr1dL9DiT7gz3arMqpSEh2qAfhCCG1LcuFLkrPwfX5	26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	171	1374	499	12463	17807	jx7p1ZqHSL2hqKDPF7WJxJ1S9CVaemPyuLhRuNtmrKUz15w8Goh	12892	18135	18135	1619203500000
26094	3NKpwd6ZhxYLbY71zAoyZT7qMrgQj9PNuiXztK1ktLiq6Hb9h3Zp	26093	3NKVtka8UJPg2M9LCs8DwL8icQiDLo7tvVfNyVafpb1JNy4JDkBq	1406	1393	499	12463	17814	jxMrirZVMEwbns3VnKVZEpe3PtXcd3e5kKJyrg1ZWUJgcSfBH9g	12896	18139	18139	1619204220000
26096	3NLuvLQoyCKBSY3EkwzZQWXGd7Td1fo3N9Tmy5Yzz7WSNstJdaBJ	26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	1675	976	497	12463	17816	jxcXqrADVT5naDuAvgbF5CWJnb7NNaL9HQRAY7iidZwHgv67z9r	12855	18140	18140	1619204400000
26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	26104	3NKCuUeUJC1bVZVjob2dYn3ENWbug1UQEdKtNYTv2iSHd9zg6mjr	1406	1393	499	12463	17826	jxwAisucBJxFG6d88NR5veeTUQceHZ3cR1fTQDnRWFQjtuvhi1n	12903	18148	18148	1619205840000
26109	3NKf5QggLb1QvS7qyeqYXpC4egpioMa4QsBtpXQZhfagVEsUSSq3	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1460	627	499	12463	17829	jwVUVWtR3ZUhmcCJBqtGeGtW1zhjUo2MooCRAcDF2LqJP1DKhYe	12904	18149	18149	1619206020000
26111	3NKVfMwvrprHtYP3JBD78EDdqukfme8CKLBaJwpZtDyxhB6tsr6q	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1474	1083	499	12463	17831	jxMVmrWAjeZjxSARnknx6K45whWxhnTAh4TPd1FUUPQqVqccV9R	12904	18149	18149	1619206020000
26048	3NLc6JPRYmi45dmrqtqDcgduqJEcoW4LkL7ff5zaCMH62ZozSTJp	26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	1553	776	497	12463	17775	jx7j7szoiBctt6bMKgyqN52VVe16ayVLVNgLK5su5EK1AMcsTZQ	12871	18098	18098	1619196840000
26049	3NKtWaZ33P5keD3U6TgdnTfmyaEMbpgy7dD1kiuemRDD3kkwkgto	26048	3NLc6JPRYmi45dmrqtqDcgduqJEcoW4LkL7ff5zaCMH62ZozSTJp	1581	778	497	12463	17776	jwTFW3BA4feABg8M8aYNZd89oShZN3k1MGNcevqirZW9F81M3r3	12872	18101	18101	1619197380000
26054	3NKLdsmEwvwRnizBEyLfdtVYZNnmtmPoySYWYzsT9qjQAdG813eZ	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	1577	1327	498	12463	17780	jwvc7WAXHJHdykXhnGYudBVsq1aF29tPVg4nKvc6wQc2qTU7ESP	12875	18104	18104	1619197920000
26058	3NLcBpEu91r98yaNFECWU59PWqJtD5Bm4316m2hLCMPVk92XntJb	26056	3NKrJBSMKNNMvVNwGKP2jqJjpZwXMMBug17au6oL3Ted86psqcBd	1581	778	498	12463	17783	jxpnyuC6udk2ZE95ENs4dXqhGFwzL8QVj8taDEPahbjWBswV5vC	12877	18106	18106	1619198280000
26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	26062	3NLX2mDaC2FmeJfzN8QmBwnxBNfJ7XVfMKRZWtQFY3axeWF5CcC8	1564	1338	498	12463	17789	jx4pTngAnu57BGpqyghEK3wgjRL9WLUbVLcpZpCJbBpCuw1bcYX	12881	18113	18113	1619199540000
26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	1580	423	498	12463	17790	jxyy2eNKs7wUdErqeiL64P24gCoVwezjfrewhFj7mfvbL4Dixnb	12882	18117	18117	1619200260000
26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	1650	1375	498	12463	17793	jxPAqeTyMg3YhUBZm5AF5wQCgtddLqhHZiKTiDBSvrimgfFedTB	12883	18119	18119	1619200620000
26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	1637	816	498	12463	17795	jwNQ9mNvAcsPq2jueM2MSU6erUEs77ocRupGBr1bqQZ9sGEfZzN	12885	18125	18125	1619201700000
26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	1455	1206	498	12463	17797	jxJV5a6f6KEK9VjNR4XGRgHjq6pQGa2sPtGPRbdZmzXcNByNGi9	12886	18126	18126	1619201880000
26076	3NKg2EgMgJxbtEWcJJBPXoe6t2Ne32rvzm4Ld3xHsEh9FPW8vkNW	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jxyDimmyNPJP9dorqGRwgtZbb9kfcKWcVLzYVrSEreEb5U2bUVM	12887	18127	18127	1619202060000
26080	3NLBejGLJ5ChkSFAg1KtfMWAXJbfRDzJ9RNyAKtifGr7x17HwNWD	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1585	1366	498	12463	17802	jy2avqyiGoeAM1YST8c1VESzfJTPmxMWEgDN8RR7p7wWnCTT5aB	12889	18129	18129	1619202420000
26082	3NKsJC7gC5XBjjYfxRmAGVXxrKbzDXH1g9abBfbxcUBbMeuSi7Tp	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jwCVawPT8pNmk6ctDZkt2fGLHdQ4Kax13LksQKRpqGHjVttDFWD	12889	18129	18129	1619202420000
26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	26084	3NKtPMSAMqZ3CXTQDAt4HuoDpPjmpszHupZQjVtwcT5YHSExce8j	369	1186	499	12463	17805	jxCjZbKQp8Tr1Ud4byKeZSK65T9Q4eGYJVU8VyxLERhsDdLFDTc	12891	18134	18134	1619203320000
26090	3NLfyAYVFYdTNXqmfdnseVTJ5J48FF88txaxzRtme2V3D8FRwKv5	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	1637	816	499	12463	17810	jx1PxJhJRdNiAL5KgqMsHuzVaRWuW6KVEHvJvLgBB4wcM1CWuJc	12894	18137	18137	1619203860000
26092	3NLKYwRhXg2no1KxZTp4Zau45Tpian6tnWaQED14rGhBshe7LBMc	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	171	1008	499	12463	17812	jwFupnbv3eDAyRCrB2XhMTTbXwptL9Y1f8muN8eCXPXSWzrFbLT	12894	18137	18137	1619203860000
26097	3NKh7Xbkx9cr2b2WNHgYNRdKGaAsCwiYEcGHpptAr2g9pezFzPas	26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	1607	1348	499	12463	17817	jxE2nXaJS5tjCiboAEqnbERTR45sNu5cPiacxQjYsxAVXmrUQWf	12898	18141	18141	1619204580000
26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	26098	3NLvv6i6Qoc34k2NLYQYDM2FR9QR6GTB3WoFQi8rLrieYv7d6YX4	1403	824	499	12463	17819	jxZczwTa8i1ASVnhaCCr8iiS91QfByPiQ9XBMGuhkgHADnLwKtT	12899	18142	18142	1619204760000
26102	3NKt4uUE8JbJ4aWRHtEZLMLWNuvTw14xXZ5XBXWKzpky2pCNSazz	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1598	514	499	12463	17822	jwzZJ5KWRzE9RYMMQV3q6ZAmGu1RbtP3QTfVvEv5Fz8v7SwpAMx	12901	18145	18145	1619205300000
26104	3NKCuUeUJC1bVZVjob2dYn3ENWbug1UQEdKtNYTv2iSHd9zg6mjr	26102	3NKt4uUE8JbJ4aWRHtEZLMLWNuvTw14xXZ5XBXWKzpky2pCNSazz	1656	1097	499	12463	17824	jwdyf1D9T4WgMeGxQk5LwJnnerkHL2id3mYRUhKcbgRzNPhUFAw	12902	18146	18146	1619205480000
26112	3NKctKG5rXoJNziAHxkHG1jZuGvVDj953Gu2qhvgL8JfcNrEBnp3	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1506	1247	499	12463	17830	jxias25uUFE6MS7jUK3vyM1ioaKWE4uPbSFk6nVk35FcXfcwToB	12904	18149	18149	1619206020000
26113	3NLSeimqt3Ds2aVXueknDEMZ8YYztQ1FukKWriEBHkL4DrxErgbn	26111	3NKVfMwvrprHtYP3JBD78EDdqukfme8CKLBaJwpZtDyxhB6tsr6q	1405	873	499	12463	17832	jxTRCt4yzKDQiLZFbhGXwvZLum7CJzDyKYtnAyQJBeYQLEZaYNS	12905	18150	18150	1619206200000
26116	3NLGsU9T7rcESZxpk2BgXHswL2eNC63qYzv3mij7j5PzgWUzvqpU	26115	3NKjEbMU4A6Vjqz5mVqoBYdUsGRvz5REMBxjH33GniAGqSgV5VEM	1406	1393	499	12463	17835	jw6jpg9nWxHpgQWbeZb6dUdVvVVRHF6WZeHJhtdHVz5wuuuenYe	12908	18153	18153	1619206740000
26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	26121	3NLAv4gPhupq1tdDoFAmuD5rShP2SueKeXRiP4UJYYF3HtxMJJWN	1406	1393	499	12463	17841	jxcyMjg2ah6vx1WkuzvMT1qA6cCgbr8Uwp2bV93sSEdoQyYDM4L	12913	18162	18162	1619208360000
26127	3NKXWDHu9Bx3DdofnuBhpydE1pG4FsE3M8pN9bjUiPHVnV8ihBjP	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1423	199	500	12463	17846	jwGdBYt3wuxDH6u4CirFB5t5xWBGLNYmXhot9SFr2AYLcBrqXFq	12917	18166	18166	1619209080000
26131	3NLGS1u8K3AFdpYYvZHdF8FwYUfW4gV3xfTLA4opthXuFT7Ju4kK	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1403	782	500	12463	17848	jwdanMdF4X5CDedA9PyuwogsF3Y4DsHvwmjVfEEqSFdGu6xV4kY	12917	18166	18166	1619209080000
26134	3NKbkSYkokysrQhx4CJs8yxpavTV1jd5TxTzGwcsunyNwLkkc7WD	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1623	830	500	12463	17851	jw9LnTWwgtBKLpkL6dn67mUVJiqRJQakXpJzMT6kp2ChrQykSa8	12918	18167	18167	1619209260000
26145	3NKTj3ZyVcQY4pws8y2j1vBTL8B7Uia4b5jSL44oHkLpWAeY77GU	26142	3NKudP2CNMbRKnAoNiUxqU2d28enbFzKKLQ9kJPHEsXkDWxaqKGb	1406	1393	500	12463	17862	jxAAVb1QsUrqN2LBcqWUoefVVHJgHjzYbfpa1mznnwvfByo1cnP	12924	18174	18174	1619210520000
26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	596	940	500	12463	17865	jwxTjMJycqvYkxyGrJwicPaENinaZrkJoDmk8VupyuK2iHGjDVB	12927	18178	18178	1619211240000
26153	3NLZNtnaRbf3GQo9ZruS1RQ4Qe5vCmBbKC7JfjyFp2Y5ZdgRmTrW	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1406	1393	500	12463	17870	jwcrEdUC8fkgwAdvdWRDYA8B28XEMz2K6a2xdT8rZmE5pPNML86	12928	18180	18180	1619211600000
26155	3NLTCKtQ9fJgEHsLNEFRwk9xuA54rgPipnZGQ8kVqhLtfzsRKPuf	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1407	1395	500	12463	17872	jwux54PZwMcyqUqLPiXaDHQHj44PXmvBnc8K6rxHom1BFHRwFEu	12929	18181	18181	1619211780000
26158	3NKKgMBbXzdAojeQvEM8CPu7FsLFWA5fZT6xHnNqyziCRqPHawQW	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1623	830	500	12463	17875	jwQfE97Kr5AnohuX2Z7RzA17HfQdHaHbGLQj9MBaDmuUhtsgGy6	12929	18181	18181	1619211780000
26162	3NK9Z7dCx4ZjU8AUGAtRJhhFoVagZwYDuY2xz8PMtAAFwty1eLbH	26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	1406	1393	500	12463	17879	jxZ6NjZgApQQM7Qmz6AawXeybiH4hnZg9sgpY6PELwDe8jweNnR	12932	18185	18185	1619212500000
26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	369	1186	498	12463	17794	jwyEaRDr8zTCwfd69fg96d5AaQM6UCLnrfKchVKQLorFpy4e4dv	12884	18123	18123	1619201340000
26072	3NLsUqivcjdp8PFjZgDnyoiLgy6L6rzbHMq4ttnnNdDA4Jr83Ke5	26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	1403	824	498	12463	17796	jxht2V4mhffwkQhk8FvQKND5nPr2NCBgMjPcQprX339vrWTcn5e	12885	18125	18125	1619201700000
26078	3NL5mnX8wiepgjvz6UBRTEGGkCpHZuKS3Nw98uxrjkwFxFiCDpmY	26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	1509	1320	498	12463	17800	jwcwd3gsfvnATDo573vzqFnijZ7avepKaSfr5sNsCAY6N6Mb5hc	12888	18128	18128	1619202240000
26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	689	689	499	12463	17806	jwoHQhX55qm6sqkvC5SuFBWZpca8TEqm1SVNu51ebRJrEGb7tqj	12892	18135	18135	1619203500000
26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	448	1059	499	12463	17808	jwsFt1NUK6Xnk1rvVGi1XFqqdh1Tgw7djfdtyibmEvomTi5NZkz	12893	18136	18136	1619203680000
26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	26094	3NKpwd6ZhxYLbY71zAoyZT7qMrgQj9PNuiXztK1ktLiq6Hb9h3Zp	1675	976	499	12463	17815	jwpA5LmANkjKurfjueFju5Y6b1Dw8RXn1cvSR3e5WaknrUtBsD8	12897	18140	18140	1619204400000
26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	1643	933	499	12463	17820	jwGHejCKWZCNtVcJiPdLDb8r7AwPFy2L26uFPnHuKHMwjmvYSCb	12900	18143	18143	1619204940000
26103	3NKnjJ6z8FvvfEfah4kvUTdU5RWjx4Fzy6qhtBnpU9Zk6wDzUED3	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1589	1160	499	12463	17823	jweVhx1c7fpMArRyyE9P1n4GLzKTNj3GbRTtQsmhY8VecZ6xAXJ	12901	18145	18145	1619205300000
26107	3NKiFwYheXyEajVbhZvmiXVVTjU91tsJdiwnVsGT5n887iNkSKmi	25777	3NL3KNpBpxEXtyjV2J3GgBnvUZfskjRUsP15z9yZG5yFw2VqSav1	1506	1247	486	12463	17827	jxuYgpk84x2Y3MNshypsNNRuX6gYAKfh7P8aCt2qC26jM4xEeqQ	12626	18149	18149	1619206020000
26110	3NK7QzEXboEZ9wGeNGwErAQBKQ2bdhw4MB3eCnVoeRFbrWhNxE5h	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1506	1247	499	12463	17830	jwzncMtZpCtLfGGeyyQWiww9v4PqyYVuQGdNnbP9YCMeDAvRhKw	12904	18149	18149	1619206020000
26114	3NLDniV9CZHCTQmAtwPeMh25Gtj76hLfEXDwFduAUXhuJ2FewTTP	26113	3NLSeimqt3Ds2aVXueknDEMZ8YYztQ1FukKWriEBHkL4DrxErgbn	700	840	499	12463	17833	jwjKgBfBLyYn9s7n8gkmyD1kyMWpKETXGetcRa8s9wk2U8suVkD	12906	18151	18151	1619206380000
26117	3NKNQLtN1BAZcHyYA1fWaYSeNwLdaDVWDRzL5QkF8ogpFutXtZwC	26116	3NLGsU9T7rcESZxpk2BgXHswL2eNC63qYzv3mij7j5PzgWUzvqpU	1406	1393	499	12463	17836	jwQRo23omp1VHRbDQynjB2G1nLuio6BBM8uTHZsDdJdidJP5ZSS	12909	18155	18155	1619207100000
26120	3NKWo4YqQB55P3eJjie2vdvqLf9CDDCSatagsywgPwD7P8NeDWem	26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	1406	1393	499	12463	17839	jxNHrfYDBe8jWLy4mNFicx1cR3bkL4sKLUswb2NDgBc2SQLxiZ5	12912	18160	18160	1619208000000
26123	3NLvzc8hZsDuqHXaaQVNFb2ek2VLzKBCDaPdoAn7tfdYhQyXvDi7	26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	1500	1051	499	12463	17842	jwPw5SauKH8eoPzsLQQiZzL1BFgHPVnroXSqo9jgStWBH11RXSw	12914	18163	18163	1619208540000
26125	3NKYKcpYHcDxxQKJwpJFXivWYxgXFtgKv7N63AQ8PLrvu6kies3Q	26123	3NLvzc8hZsDuqHXaaQVNFb2ek2VLzKBCDaPdoAn7tfdYhQyXvDi7	1407	1395	499	12463	17844	jwpYgWAtxoE949ezJjquK2dembdoic3BXBca9PF4NRpWaYLrSU1	12915	18164	18164	1619208720000
26132	3NLrHrrEZd7ghtsrN2ScS1ndxrGrjdisR51J6xHXugTH2PFCudSs	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1406	1393	500	12463	17849	jwsgj93Qf34U55gHGWqBNppHoijjjQVrjspBWHUtXEm2d8TDGPm	12918	18167	18167	1619209260000
26136	3NKCZDCE8LUMCQUsSd8D6BUesMiUC2dEdSi2FpWcW8oPWucMfStE	26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	1657	1218	500	12463	17853	jxBGfRmKfxSWq5gFoeaQveEtXQLb46jk8137C6tHNpGSvBYgdn1	12919	18168	18168	1619209440000
26139	3NKD1oKbEKFuqAgsErm6ZDeiWcVgfnBWCkGTdcAsP8kGnogKH9i5	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1419	814	500	12463	17856	jxmVydFnWuShFbPvj243VvFdNvhsUmnWTPR6VRY2dsCr3SQxeq7	12921	18171	18171	1619209980000
26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	26139	3NKD1oKbEKFuqAgsErm6ZDeiWcVgfnBWCkGTdcAsP8kGnogKH9i5	1564	1212	500	12463	17858	jx67jjEbnFiANBndQmyr2D7SK4zx6Nf5vuU9VGSdxATdyy3vE6p	12922	18172	18172	1619210160000
26144	3NLaUgdbB6WUiqageRdmwJfgjESvsnyD5kQbsaAsz1E2Gubmt9y3	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	1657	1344	500	12463	17861	jxaA3eT6fAQRXBCYFzhqDEfGFdMpTw9f9CpHwBe4aNYNEpakkc6	12923	18173	18173	1619210340000
26146	3NL6K3ZRqmmMUnojXmkdqT42b7gMQxcRUGu7PpnhaNJ2kFnT3hPj	26145	3NKTj3ZyVcQY4pws8y2j1vBTL8B7Uia4b5jSL44oHkLpWAeY77GU	1477	1350	500	12463	17863	jxANSg7qbRuX9QXzS1MFHrFD9NaYF9DzdcU7kRQsGqpvbVvDoF8	12925	18175	18175	1619210700000
26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1471	1020	500	12463	17868	jxdwjFsEX2xdLYzRiwBxHpfoaGguBR1WLDfekAxRzrsv5YDk25Z	12928	18180	18180	1619211600000
26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1593	1346	500	12463	17873	jwYcuQaqjcx3hdEQU7ngHdtFWJLXYT16uPskxZcpiDEqYSGWsNV	12929	18181	18181	1619211780000
26160	3NKByhK8gdbzvqn11uABCMoCASFVSi1NfQQqvsno9nitoLxNUVCa	26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	1646	1354	500	12463	17877	jxZtCvFa8EM7uzJP9yLqf7hqsXqyJ2Aqgdwj2Qmqm6VK8W1JWXp	12930	18183	18183	1619212140000
26165	3NKDwogyidLh5A1818jfReU5VB65Feo3UQaamP3h3inmyHKdaktb	26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	1670	1036	500	12463	17882	jwH4E8jV9SF3Sed4PvK3t9vvgBEofb2q5g5N6VVhvB1ybWrB6xJ	12934	18188	18188	1619213040000
26168	3NLBhhFWBSWYdvNjZZSYb6AjBieqcHTuLFyHveg1bhDnSCboPsw1	26167	3NKRo725MRw9yLnBTfmPe2tqfanCXum3ZgStCAY8U3tTJWkiWTzE	1608	1289	500	12463	17885	jxU9QFkgvEhrUVxyjSaD5SRXFRP3u51SFt3z4UNAfQbeAje6qbL	12936	18191	18191	1619213580000
26173	3NLxyy2AGMWpezpZW2phpbKDDytQsJtD6GaEwtr6roMXvqeZwmsz	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1581	778	500	12463	17890	jwvthLc9SVhA8xDd5o4ZdvTQRcTvVVnd6jBZPTSMJcFAdFEyXen	12939	18195	18195	1619214300000
26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	1490	1148	501	12463	17891	jxQVPuTPo2x7nQkkhpXHRK6Ebc7uQeh2VcEsep1afomkjBJQYCn	12940	18196	18196	1619214480000
26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	26179	3NK49WZWgMTURaEtb1s1iLJCmRsVASRdq2VXtm9yktadSobXYqBE	1455	1332	501	12463	17896	jxF7yazJfLL7xXF3sDVmzL1s18aifku91CeUKq9k6Sf8ks6wdgW	12943	18200	18200	1619215200000
26189	3NK4XcWL9k2an3NSNpL8pdVgyTMybgzwH45LwhfJNRZbQej9a7W6	26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	1585	1120	501	12463	17903	jws6hCdXLRQfzxSKqut7aWXBjxcaF1pqnvPs2YJzpBCoWddGw3m	12946	18203	18203	1619215740000
26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	26191	3NLrgGx5kfh5UT4UE25PjQBMnBfZR3gNfrW4tWQh3sXHAHZGxr3E	58	1281	501	12463	17906	jwhUNyCr5sRdKtEAPvvEZR8V5164EZpFnvBPGRzHkYkq15gb5Y1	12948	18207	18207	1619216460000
26197	3NKpwbYTB6SADxF92Vpjkiwhd6AVKgvDCR6vdrVpQcJ32XTFZeQd	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1489	1380	501	12463	17911	jxigGZkqRugLEGxZVKtrovfugzN5DhVYZaujUz2pdHnYhvM8XUF	12950	18210	18210	1619217000000
26083	3NKYQS7fg7MpoSkbDRRcmiyCxVLGd8D4K2W2uhm2QKRT3nCrS6Wy	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jxazsDvcFmYpphRDHCkRCkL8oYr6XaringhuqKX1YVxoKAHUpJ5	12889	18129	18129	1619202420000
26084	3NKtPMSAMqZ3CXTQDAt4HuoDpPjmpszHupZQjVtwcT5YHSExce8j	26082	3NKsJC7gC5XBjjYfxRmAGVXxrKbzDXH1g9abBfbxcUBbMeuSi7Tp	1559	1107	499	12463	17804	jwCc4TfpccJk9cZfn6MmmTzzZE2iQQVfo7LEe66mAoGsy8zyKq5	12890	18133	18133	1619203140000
26089	3NLNrbABJiBrUrd6aFVZyjttWXbx2siyJYYVJGTYvuzt65SznbiF	26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	1501	1114	499	12463	17809	jx1tL1LDdQAkLKr8kEogD7RgpEyPrxavvTVHiCAxuF6PNkzAKsf	12893	18136	18136	1619203680000
26091	3NKhGfZ5Ni6DR5MW2iX7zCFCyEv3yog8BFVbAxMs9bFMreKaDLib	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	1405	849	499	12463	17811	jxueeAJm3u25Z8Njact7vYDacs6F6HGaaJD7GkJzLxfD9bnHJxm	12894	18137	18137	1619203860000
26093	3NKVtka8UJPg2M9LCs8DwL8icQiDLo7tvVfNyVafpb1JNy4JDkBq	26092	3NLKYwRhXg2no1KxZTp4Zau45Tpian6tnWaQED14rGhBshe7LBMc	1406	1393	499	12463	17813	jxsboW6WkKZipzccBH7Q8JPBTeJeQNqG6NGtC8Jw8Af6RtX7xDa	12895	18138	18138	1619204040000
26098	3NLvv6i6Qoc34k2NLYQYDM2FR9QR6GTB3WoFQi8rLrieYv7d6YX4	26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	1406	1393	499	12463	17818	jwGKieWHz11s3DiFf5P3QztMRK83i7inY1g7VB51uVhRpnSWWeE	12898	18141	18141	1619204580000
26101	3NLok8NeGQr2HuCYVE4FfECFq9WuwZ88V3NnWzyXG8gpNf2mSWTw	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1514	39	499	12463	17821	jxNZfQCqx6Bij6pqaySEyy2RNfRLTNWocwrNjUsgcAWtMzEPd5R	12901	18145	18145	1619205300000
26105	3NLhZes8SgNDPfEj7PAm1kb7cw6YtT4m2hviVNmYwogiMPDbym1N	26103	3NKnjJ6z8FvvfEfah4kvUTdU5RWjx4Fzy6qhtBnpU9Zk6wDzUED3	1656	1097	499	12463	17825	jxggVR84v9BUG2bcSiWS9GEgq1P4hNUgSXmYK4sFshM6zNPQHLF	12902	18146	18146	1619205480000
26108	3NLaSwZLrShDgHVaqRqCduDdquEtz89DS22m5uQmiz12KXRaWyZn	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1500	931	499	12463	17828	jxE5C5uABtD2U1qPBzyKLNpqLchUhUdvRUwPy3kxz1PBiHjnHHj	12904	18149	18149	1619206020000
26118	3NLy7wWezCTfnBBeEdS3b1MncVHxSHDnLi2AK8eA8YDCfF5Jsouc	26117	3NKNQLtN1BAZcHyYA1fWaYSeNwLdaDVWDRzL5QkF8ogpFutXtZwC	1402	852	499	12463	17837	jwigcpLhdgewBUYAhgTUbZEZ8zeAmYqU6mEWdwcuynbdUgGL9EV	12910	18157	18157	1619207460000
26124	3NKhRrLDiZsNN5jd9Nm4tFSFsKb3eEYCHC2z87PzvNm6Pi1Ttqkm	26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	1637	816	499	12463	17843	jxbx44iY2gFT2g8bQZsdt8Veo3pEJCy8eRBv3WSYrG3ACWKcEt8	12914	18163	18163	1619208540000
26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	26125	3NKYKcpYHcDxxQKJwpJFXivWYxgXFtgKv7N63AQ8PLrvu6kies3Q	1406	1393	499	12463	17845	jy2JZvQUJzzRxiFatqeQUNrm16QGu2nHVg1Abmb7WtQx1HHdiiZ	12916	18165	18165	1619208900000
26128	3NLkMtcZ2KvS4n3y12zEMiZ2ixWrJ8aQgShoPR3dwxF7j39NPLrA	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1489	1380	500	12463	17847	jxyA8Lurv9QDVsABmPg9yx1sFr9CZGDjftuxqZH6SMz396TyeK9	12917	18166	18166	1619209080000
26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1423	199	500	12463	17846	jxAfjCizfpTLuYjeqAwfFKsaoRJveRV2i3GV1ozHseFVBbEcLNA	12917	18166	18166	1619209080000
26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1405	873	500	12463	17850	jw8GRWPq8JJt3Pbmj763vobBv4hLdqCisXYHief7WMJLR6Ddxg2	12918	18167	18167	1619209260000
26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	26135	3NLy2gawAiDLa2Bx5aL3cuK3rh1cX9s5uL4oHr5b6gpNt11cuFjc	1608	1289	500	12463	17854	jwpzGzRmMm2saPrrW2Y5nnsMjEBAghZHQdALkkgVHRa1TbYbVvw	12920	18170	18170	1619209800000
26142	3NKudP2CNMbRKnAoNiUxqU2d28enbFzKKLQ9kJPHEsXkDWxaqKGb	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	1407	1395	500	12463	17859	jwhDi9yv8LDmfwkbg6Hx3ucay1LHCqjzL2HUH5LHGJGvKoHNwLd	12923	18173	18173	1619210340000
26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	26146	3NL6K3ZRqmmMUnojXmkdqT42b7gMQxcRUGu7PpnhaNJ2kFnT3hPj	1407	1395	500	12463	17864	jx51C6nPND9QZkVh4MyLGik9g2uD6SnvXBmcZkvjwXFAxBP5xqG	12926	18177	18177	1619211060000
26149	3NL1Ak7NaDS473QEieQW5enXmyFfwVkTtBBUcv7qwebyjcVwkLRt	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	596	940	500	12463	17866	jwXsfMKit236iDFVUHpoQJA3GCnHcY4uaV1KPCerSnaqDE4ou9C	12917	18178	18178	1619211240000
26154	3NLKaY5yEnvgkTcSd49b4f97DEGJBLT2758UnFrQLieoKqWFnafb	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1405	857	500	12463	17871	jxnbffm5rEYTByYiLBBnyk7TCae8Rt1KeN1tXNww2PaXAVejoQQ	12928	18180	18180	1619211600000
26163	3NKQu282r7zBLssGB2cJ4XHD9WcJuhGDZXXzmfs3naJ9v5bsJg9e	26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	1581	778	500	12463	17880	jxfmGh1G17GQJZGzotBdVZgg3gjPwByXqy9Pv2ReinZJMHvPCuf	12932	18185	18185	1619212500000
26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1636	140	500	12463	17888	jxHc1YZ3p7uVzqP4TWB3yz24GcpZDodsMATKyochFgWLdAQAkVh	12939	18194	18194	1619214120000
26176	3NKjTXCmSyw8s24QyXEst5zsf9HvoxT8ahej9SyQAZ8SgfvAYRZN	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1549	1236	501	12463	17892	jxWsZnHNrcuavmqDHaLTuzDKjPpUJGyMv6P3RPqLQXnmfRcEaqo	12941	18198	18198	1619214840000
26178	3NKY35cgWZ3y5v8fHx7jwWAxNt63iRc7yFYxRgLCzHBRSenE8HFg	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1631	794	501	12463	17894	jw8Rt6ZH9VmvmfrBanwiKLXpfv9Z8RPeFzH5SY34dfZ7s1MNQDp	12941	18198	18198	1619214840000
26181	3NKktHBoZHKpksDGC5mo2YdLDoH8qampFGvh4RuWnGiGH3cTtLXV	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jxP5cnWMVnQ3ymEUeSxGffdvKRvkFD7J2ZnHJmCjJeK9sEs55pL	12944	18201	18201	1619215380000
26185	3NKaLoMTEZ9764r44LeRe81E2BZSgq7JChDsCpRQVAMKRXXVSBm4	26149	3NL1Ak7NaDS473QEieQW5enXmyFfwVkTtBBUcv7qwebyjcVwkLRt	596	1060	500	12463	17899	jxoFgQkUc848w8DWKdooVuSWX6bC5uGh8nM77db6mGKiSszYDoH	12918	18201	18201	1619215380000
26187	3NKHgkSkKPvDpawRFho56Kf6mbRE2jhCDfW4eCC8CsJvXRyaXnFm	26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	1654	974	501	12463	17901	jx7nmHitmEUeAfU5aoDvs3L8LFHvyHhsvPwF9pDCYSceCGUby9d	12945	18202	18202	1619215560000
26193	3NKZUdBqfgYRumpJJCbkRb3cTbVkitb3HnAFfxpAQz6SVEsnXTd7	26060	3NLWo9kiZe6s1zwtsi4KLPFhDFwPCUcPr2zubfNRZwEKuxkzRkJq	58	1281	498	12463	17907	jwG5doaVEHAF92kSWKrD3J9TdeyjPJ3PmviYWuJLDrc5mvRwJ5V	12863	18207	18207	1619216460000
26194	3NKbijS8wurSymQdNT6pg1JArJ35k2footDGJSSVe2VPmwZQbFg2	26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	1419	814	501	12463	17908	jxhvRvE6nBF2LkcHQzCBwsDcq7DoESg8eshWSYBuHarGd3o5Ps2	12949	18209	18209	1619216820000
26198	3NLSons743q1uBRXz4tnRfEgZzHRPC1oY6924JTBiG3sLkFURHef	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1654	1340	501	12463	17912	jwUfEWfv7uddEiY2sc2QPDXfuWkZYHuKSq7ZvGVrn6DMDsStz93	12950	18210	18210	1619217000000
26199	3NLiMXFXHfPXucTJJdwVqjCUNHvoi17fHCsHGNu3inZbFzinSCn7	26197	3NKpwbYTB6SADxF92Vpjkiwhd6AVKgvDCR6vdrVpQcJ32XTFZeQd	1646	1354	501	12463	17913	jxiRBeQ87kD1KFhEMzdWkHNTrCH5kgCi89ia5QkLpchAx9AzXy9	12951	18211	18211	1619217180000
26207	3NLycKUoPrjNeEy3qBZvwie3frEWeY81ASWr3Cb6tkcT8TNewB2d	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	152	1084	502	12463	17921	jxwCcYbaP2RBd5xD9BwKQHXTziiQVuFrW3oDamay4KZH2DLEf8i	12957	18220	18220	1619218800000
26115	3NKjEbMU4A6Vjqz5mVqoBYdUsGRvz5REMBxjH33GniAGqSgV5VEM	26114	3NLDniV9CZHCTQmAtwPeMh25Gtj76hLfEXDwFduAUXhuJ2FewTTP	1608	1289	499	12463	17834	jxRPPUyau1N7XrkrVn38vNfYaGUPb71zssQUWQafZ3gQcAVrsZR	12907	18152	18152	1619206560000
26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	26118	3NLy7wWezCTfnBBeEdS3b1MncVHxSHDnLi2AK8eA8YDCfF5Jsouc	44	1325	499	12463	17838	jwsFqwzTtpSW1cbARiCoZM8xsMcubgFAzGTqqrFakZYtw29RXuc	12911	18159	18159	1619207820000
26121	3NLAv4gPhupq1tdDoFAmuD5rShP2SueKeXRiP4UJYYF3HtxMJJWN	26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	1403	824	499	12463	17840	jx2JTY57B9hijH8F139xDbMvKYU4n4r9USSFmv2Q5fSAcsiwDVa	12912	18160	18160	1619208000000
26129	3NK5hK7Go2pRbXY6hKAcdUK1L58NVcjL6PaUqEXZNXLtK4ybW3qs	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1489	1380	500	12463	17847	jxq9FPxhn2b5t2yg7WMncGXXia9w67KR3iwng7ZTbWp2vL6a5S5	12917	18166	18166	1619209080000
26135	3NLy2gawAiDLa2Bx5aL3cuK3rh1cX9s5uL4oHr5b6gpNt11cuFjc	26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	1536	1313	500	12463	17852	jxAKFCx34dmBVpDMbCDL8ti7t7W7B1HzXnDq5fbn5YcPKNwq1bL	12919	18168	18168	1619209440000
26138	3NKSHUanVLrHPMXjYooWkrSeRwWyks2V6tJWZL6hRWxReb4RgGiC	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1476	1371	500	12463	17855	jwDDF9sJ7o498gZ9ZRVwxS6qzsTEMaRDDNbVtw4VhRX1gDK4FYJ	12921	18171	18171	1619209980000
26140	3NLghg3eQz9iS9noUfkBVQZBRQz3ZkZs2gSJ27TD3RswCfBHk1HW	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1402	810	500	12463	17857	jxJsz8475dsk2A9Pc7Sh5jM9KRcVgxnbNUz2WCjF6eUGkw11dq1	12921	18171	18171	1619209980000
26143	3NKMKYpGxJWMYiiPtYXmAFN9M8rqxozK9HP6i2xKeYYZSmu6cdCL	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	369	1186	500	12463	17860	jxpoXiASKQQCZpQQXSwNa7wZbb1ykanMGppvvdgX7U29kWDMgai	12923	18173	18173	1619210340000
26150	3NKtPt1Xz7LhPdJWqdDPB25Fo2qk5QEm5Qz6uKG4ye2fQuB8ZHEC	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1671	1119	500	12463	17867	jwPoxXCAXTmQeFMZ4FjGGcAjDrzLVs11JGuhhJHxdLEZ7BBmozE	12928	18180	18180	1619211600000
26152	3NLJKzXvvFMAJv8SPRovCDkb7o3nPX7RY9k8ZZj9xg9gHzKCA5MD	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	448	1059	500	12463	17869	jwhQKeWqAGxervomujwpSjqTg3F4FU9NhmKBHXeHp3Vq2dTk5E8	12928	18180	18180	1619211600000
26157	3NKWn84oihS6TKheq6QDrN2NXhyDQhwxccsmQj7cADQWzZWYzb3F	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1500	1297	500	12463	17874	jxK2DWFcbdrnBtonF5nE48wffHzv8ue3iyhFy4BRY1y16TSJtbc	12929	18181	18181	1619211780000
26159	3NK84rsL4kxxZF82AtgFZoyr5zMrLmM5RZaAJweqQA5HRVFYEWNo	26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	1407	1395	500	12463	17876	jxZjv9WYrXbNyMELNXes8xvTE9Mr6ctK3fF3dA4X2RSGGUP5yUZ	12930	18183	18183	1619212140000
26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	26160	3NKByhK8gdbzvqn11uABCMoCASFVSi1NfQQqvsno9nitoLxNUVCa	43	1184	500	12463	17878	jw9xx83FqML6GSo9M24qk3cYRg2ane6dQVbr5DpP54tqbhsjJCu	12931	18184	18184	1619212320000
26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	26162	3NK9Z7dCx4ZjU8AUGAtRJhhFoVagZwYDuY2xz8PMtAAFwty1eLbH	152	1330	500	12463	17881	jxdRjHR65VEqkQeD6fVxQijt2GF7PJjxk12RmutmnJEzDpsuQ1Q	12933	18187	18187	1619212860000
26166	3NK7YJ8rzSDvd1wKxDA6sYfPbyZzA5BNLpEwGoHz8gPLgQXdtqnN	26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	1609	967	500	12463	17883	jwE72rXmK8vERV4JBix4h9nH8WLpVsAjZQ6ioANnKibwnSpqPHP	12934	18188	18188	1619213040000
26169	3NKHyveujSK6oBtnh8VybKadphaiDtSguWCjFSwzWjYB9KLmXgWc	26168	3NLBhhFWBSWYdvNjZZSYb6AjBieqcHTuLFyHveg1bhDnSCboPsw1	1631	793	500	12463	17886	jxqoDSCTcYQhmfeFsw2BE7snANxpSgH4mJnqEDezgo95Z124AKD	12937	18192	18192	1619213760000
26172	3NKEicG6CDCvjhzZ5v3juRYnCXSH9aLiSEDR91rJMiMm29E9F9Q4	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1642	1241	500	12463	17889	jx1sPUa8wEH1T2ChjM7ukvzqck5M6JNUJEMmwkKS81SB1FonV54	12939	18195	18195	1619214300000
26174	3NLPdqvFNUi7yzsykn7WT76N4E4Z8gPQPrWqYeDZtR6TfF7CEhUP	26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	1490	1148	501	12463	17891	jxKG7TTNCqFRJR499QqA5mtLhV8Udm3rfdZgvZC65Jrkjorg65v	12940	18196	18196	1619214480000
26179	3NK49WZWgMTURaEtb1s1iLJCmRsVASRdq2VXtm9yktadSobXYqBE	26176	3NKjTXCmSyw8s24QyXEst5zsf9HvoxT8ahej9SyQAZ8SgfvAYRZN	1403	824	501	12463	17895	jwcjckotbyJYvf946Kek73EhVqyQgcWff9V3gF5DanaV6nxj3Ga	12942	18199	18199	1619215020000
26182	3NKRnyXfYFgh1NSiL1FEt2qym7FmUcdJBedK7Du36z6dc3B1jMVC	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jweqXgbzf2mPzNWioDRt9apd52QACjMNRxwSdjGd4Uz63e8pLrp	12944	18201	18201	1619215380000
26184	3NLibb1cfnc2BQD3iXnssMr5Sgx8zdSt2iJvBf3BGMTVfiihWbni	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jwNsBsDtE4h7TWaeNdENbGjKjcQDF7pLwqTpQav1te19Ac7TQ7d	12944	18201	18201	1619215380000
26188	3NLieNTaJSzcpFzJutKhZnmtAE2Le56iVXgnN7T2pWsQqQThsgtX	26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	1476	1371	501	12463	17902	jy2Hr3Jk9GgSgXxGcjRpDUxhU2WbC4WeFFqGdvgkHYgsvvkj55x	12946	18203	18203	1619215740000
26190	3NKeHWCFwiVuURuZAmWzfCJwzxx1j33P3fLCgpknmK2n6qDKKSVU	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1617	1288	497	12463	17904	jx8bCmHS8UTQzXSBm2XXeRR5jEcrS7mZt6oZWV22cbR3q4EBTCt	12851	18204	18204	1619215920000
26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	1652	1069	501	12463	17909	jxQKuBzGqzjz2d5sgMzZYVYwpKvJuAZy7jpopGdekPdW6L66HX1	12949	18209	18209	1619216820000
26204	3NLktc5aRRbyNUXemdV7UYP23sHRsnBqcgFgomHmueAN1krBd6kZ	26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	1406	1393	501	12463	17918	jwhrFzCQ48P2bTSTq551TnfPv5zSw7qNAtTTMdjVW97dscyBdRd	12954	18214	18214	1619217720000
26205	3NKLNhWP8bQ74FDo46w3w5cEmVMPxmJQPRmesLCNUzjtwx3t6UXH	26203	3NLLdZruqPFNCKv5LBc3Pz4GiWAAFPXPt13w3eBDaxBW6Jzym21u	1407	1395	501	12463	17919	jwbaq1sC3FSvZdQgK4DZEfddV3qCFWTod72V8WTLzYLnxKgCDzX	12955	18218	18218	1619218440000
26212	3NLeiUaeFmgB9dDttxS1r9ZsF5ik5jc5Bfggmozh1T19228YXCbW	26211	3NKkG9QaKAWFyWwB2pTyxqYsPkbnezAWgNnfj8TNoMW1oKsXY4MB	1406	1393	502	12463	17924	jxtrRXXaVkBbPDcdz8d18ZKZWNThViEV63ZLm4BfQESQsgUh4rC	12959	18222	18222	1619219160000
26215	3NLUysbjE2mhTte5DRLJRbeyia8ACYSQgCVVq9MPFw1ympvq9gaE	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1407	1395	502	12463	17927	jxjhd5EB7imccZJpXjuxFtHs4vbgE8LUQ3UVq1mC6Eu2VaMJFCE	12961	18224	18224	1619219520000
26217	3NKQxz35BGyyK4o6c2jFWJzAwUaf8t1rbReUfDPRVu2QdqX7MzeZ	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1579	291	502	12463	17929	jwYWs7J3DKkgZYeNS9yUezBGG11iiEGo7BQ3X1wD17CQTJSRAwx	12961	18224	18224	1619219520000
26220	3NLUyBs3BQmBy2xorZUidSR8VxGhnVQrkmnjM4dmhBqH6ioFJqbe	26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	1642	1367	502	12463	17932	jx9kFWR8dhmecdML3HqYqLoXxZdRyHucz75Qt9uJ4seGu3wg3iE	12963	18227	18227	1619220060000
26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	1407	1395	502	12463	17934	jxB6ZWRiyAUpMV41adAa66xteBj9H1bRf3WA6bp1Gvkne78B4WG	12964	18228	18228	1619220240000
26225	3NKGdU2FtivFq9nC3MPU6QwEonsH4WrsL5sngvKK7TEA6tbLmewu	26190	3NKeHWCFwiVuURuZAmWzfCJwzxx1j33P3fLCgpknmK2n6qDKKSVU	1617	1288	498	12463	17937	jxeJCcVyfJkFGSSsAsG8JqUKh3ZrxUoKnqV4yosakCp9qWzH7zR	12852	18233	18233	1619221140000
26167	3NKRo725MRw9yLnBTfmPe2tqfanCXum3ZgStCAY8U3tTJWkiWTzE	26165	3NKDwogyidLh5A1818jfReU5VB65Feo3UQaamP3h3inmyHKdaktb	1406	1393	500	12463	17884	jwFPDDxasXc65YsENN5nvSYJeCmMQLDcyQTYfSwCRtCrsUVTCGt	12935	18190	18190	1619213400000
26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	26169	3NKHyveujSK6oBtnh8VybKadphaiDtSguWCjFSwzWjYB9KLmXgWc	1637	816	500	12463	17887	jxcDaVRLFMuwMmgxn5v5W6uCvwDohL7FT1CnTW6rrLh8NWKDm2Z	12938	18193	18193	1619213940000
26177	3NLgDXdRVkB7uZS6Whs6sxE2TizQAkv92EjJroq18P7vLCgYfKRh	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1406	1393	501	12463	17893	jxMq6HSfcktFAAVPHkmo1Q7zXz7TAPHLLAaWhjcnMDtkuxPLmUN	12941	18198	18198	1619214840000
26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	596	1060	501	12463	17898	jxFeAewSDCPJRsftfxL5omqm3opf2BhwTZMXP7g1rBrtJCXFMcx	12944	18201	18201	1619215380000
26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	1542	1058	501	12463	17900	jxUcPGd6a4usgXC4ch7ZdNpZsJsTpPMBCdhkpmPkhf3k6Lrk35L	12945	18202	18202	1619215560000
26191	3NLrgGx5kfh5UT4UE25PjQBMnBfZR3gNfrW4tWQh3sXHAHZGxr3E	26188	3NLieNTaJSzcpFzJutKhZnmtAE2Le56iVXgnN7T2pWsQqQThsgtX	1579	1263	501	12463	17905	jxnhzjKWd8W8oE7iEdwfgJfeAKsuTxuhpMUeWhbxgsQ1hxrxgYE	12947	18206	18206	1619216280000
26196	3NKxWMNhWaYJsVcFDagnGDhxFgidpXTv1mt7HZXdshuZxs5YNmM1	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1467	1376	501	12463	17910	jwFsiM1249M71t69QMQXV3JcyBMLoFiXjcsyfQgzw8dN6fBNS3L	12950	18210	18210	1619217000000
26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	26199	3NLiMXFXHfPXucTJJdwVqjCUNHvoi17fHCsHGNu3inZbFzinSCn7	1406	1393	501	12463	17914	jwZBXVp2mboA77NH1zLXbUt5zXkaUDbgmrmYajzbn5gRMkUD9Nr	12952	18212	18212	1619217360000
26202	3NL6CxfTAnfU6gCuxKYpSUptvGfUfrxs8Zr34yBt3D2UcD9cUaZT	26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	149	1037	501	12463	17916	jwLEVSRZJamBDNUEYW2sVq7W9XnhFU9R6wtRNs6kHQdyJJrrs5V	12953	18213	18213	1619217540000
26203	3NLLdZruqPFNCKv5LBc3Pz4GiWAAFPXPt13w3eBDaxBW6Jzym21u	26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	1407	1395	501	12463	17917	jy2Yv85y6HTErGNuUfCSD3qLgf6zDgDsETBmgkk7PXHrzFg3SDR	12954	18214	18214	1619217720000
26208	3NLSySAKd54jtJ5N5fzP8wXC12LsgEp8vfB1sNCvwbQiyxFCuTdn	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	1610	1068	502	12463	17922	jwYzQqU2Ht8QyCi9uj5wzLsnqPtAzuEViJHXFZhiAfzoiTHWYdB	12957	18220	18220	1619218800000
26230	3NLHuHVvirfyQq4UFatgh2iZnEi6VsYBM9SFDP9NRjNABqrTpPqU	26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	1406	1393	502	12463	17942	jwZhFy3yzr362KrXXEqVzL4ebWQQYitFjhm1zRG5h5KvWbDDdzX	12969	18241	18241	1619222580000
26231	3NL1hEnWhqPW1wGZEfPLk979gMaTkBoCdfHcDnwVgp9b4VttBqmb	26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	1405	851	502	12463	17943	jxtLHga338opYNZ5tkVhqjEsQ1Z3nnyf5NkS5Bw6JJ16Fc1rzTX	12969	18241	18241	1619222580000
26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	1406	1393	502	12463	17945	jwjPpufP1UNfwoNSvbLnDGMUCZyr25gwV5rExTRJb6DTz2hsYgK	12971	18244	18244	1619223120000
26235	3NKyRwWNZbcdWxPnkNz4eBZKBS16oRQc5rYfKWkJW5U7wymsu2P7	25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	633	1384	496	12463	17947	jx8qkrqNaQZZeuiWW2U4VLVjjfcJYavnQEaNEL4ZxvuWaaE5Azy	12834	18245	18245	1619223300000
26239	3NKTVDPYHLTdMqxmCGGXqeLHw6PJ1ga6LN2EpUaMqm9Aq32LEQdD	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	633	1384	496	12463	17951	jwWb5iGdAnvZzpXxkMJkuGLMF92Nr6h5P5wwuXaCAUDQFje6TuB	12847	18245	18245	1619223339165
26246	3NLWneb3Ei4k72s8U7vSFb3aadWzGGFPcafhGvv5ow4kFuyBnA4N	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1460	673	503	12463	17956	jxkjk1aJdMVchWDo54SUvEimkK1NMyPnbQgxxJgup48RUPsj75S	12975	18251	18251	1619224380000
26249	3NKNTmX5PnxBwHgzKLJ1xLjbUFcXAYCxwjYTvSi9q2UimzHerHhf	26248	3NKaPVYmFNX8PJVe9AWEAV2EjW9Z5EnEg6Ydu5HQY14ww98mXi6M	1483	910	503	12463	17960	jxhrJZzZe5vZLWKcHT4FWZKruqeXiyesqCXm1zyxwSEK8scWUHk	12977	18253	18253	1619224740000
26253	3NLXHwgFcuBger3Z8s64AEwXnPajg9cUhZav3UBu8tSfe9V7fWwu	26252	3NKR3LaCSrpcW14xCUhV6MerqNWbAHAhCC6GLZ1byhUDsdAfppkB	64	64	503	12463	17964	jwpgvQp4qzUEx2ywf5wgTvAvzit9pqaPFGKas3kq9B11osg3Xg7	12981	18260	18260	1619226000000
26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1402	854	503	12463	17967	jwkPzNQWzPFbB9AunZEQJcPn4C2sR63U8cfEzeK8VYKinFiWFFN	12983	18262	18262	1619226360000
26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	26265	3NKfk4xo8jgDEmA8WCFJ3o6gEjPhwKLkbA4BDaaKQk8Fzvodw5bP	632	1382	503	12463	17977	jxbbV5DGW9nQ5sz9JWHUeiWDkf92EzBRRVKUxQorf2mra7uMCt9	12989	18271	18271	1619227980000
26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	1559	1353	503	12463	17979	jxkwogr5Fuq6cmegUi98p4UKaAvErM4yqar8NoUqT4xaVGkT5Rj	12990	18272	18272	1619228160000
26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	26272	3NLVRTtyx6XQPf6kM9LNyHiYqxvHn7kUkU55cPL79vXKZjwANR2u	1406	1393	504	12463	17984	jwgc5zcyE9ZTXqCLtGinHczGsPQbHjZpcsRviG1vKab7N554eWf	12994	18276	18276	1619228880000
26278	3NLWezkBBKhFophGbiQ6Wq7sT8r8iYBn2Zk7fNNJBPchChTt5KHi	26277	3NLbUCdj2wjH9en2z8s9eJz7Q1kbHkDg3ksAs13x3GgKDmeTGm4o	1642	1367	504	12463	17989	jwCqSSHUB3q8n9KnDbVAr6RY35Xtr8x4xfDUFTwU9geUBdCDscv	12997	18280	18280	1619229600000
26281	3NLHFfRF3jbVZiGdtGsQdtn76XZa77egmg7SMM8LCsYkf6WchK5X	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1609	1333	504	12463	17992	jxx1k2ikPMQhtbqva5zWXrHZNytyS8ogpvSTN7F5bgLpqguqxJJ	12999	18284	18284	1619230320000
26291	3NKQe3Rw5NovE8ixkLeLQAdNURGwz31eqnC49gQo6QQnyhT8XGJ5	26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	1622	1356	504	12463	18002	jwYLBhW3aeJhWX6QKsxysxcNRXWfUdzyRucJq3vnxm4TuKJiECJ	13005	18292	18292	1619231760000
26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	563	1359	504	12463	18006	jx5hFy4nGrjsUJjf4HvJmoRdf1vhSpJZ1TTogfT8Ex8W6Q2x2zq	13007	18297	18297	1619232660000
26299	3NK5khr1zMBcgnZJtuCwZwYYxpyt5smx71qdaDRmjy5HLVnYw1EW	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	1503	1151	504	12463	18010	jxgTF39Y3XeKTRuyFZukTsXWcZNjtD5iagH2VZVFiV3RrizyS9r	13009	18300	18300	1619233200000
26302	3NLtAmBBFWAnYUgpJ8aipFKYeGbY4xxCYHKiKypvUVnWmd75k5QP	26300	3NLuTohSyedkR8H7BqpUTv9cq1HBAGmVkMiTizMghxXpQKYib9dL	1500	1051	504	12463	18013	jxVPwTnUV7pKQgtf72wgA4U1Bz3PtyuxSS288WhTfnktn5NSiar	13010	18303	18303	1619233740000
26305	3NKThyERguMnBbrbY25kkCtok2AM4SCoGTjvNoztxwGmw3kgR5v2	26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	1607	242	504	12463	18016	jwhniUn3dHdcGPXiWYmyJ992EgEVQrjkBeFVC63oN5Uj1NgaN7R	13013	18307	18307	1619234460000
26307	3NLHSgmMiLfNij8pPD3WtL2yNGr9DiNQgqhHGY2r4TL2CAQ7HrsS	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1407	1395	504	12463	18017	jwQjLpEwYxAKco3XR1o4J5icfRQj3DYEf7D2LJE5pPqaGvNtQM4	13014	18308	18308	1619234640000
26311	3NKrsMgeMVhpr3mX5FuGhMqzuGi4TfjaisWrU6bL6SSHhaNNQx3c	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	504	12463	18021	jx6ZpJ5gcLBjq65d6B8kXyTPr2RsWGSA8sd11TW2Eq8SwnpaxPD	13015	18309	18309	1619234820000
26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	1402	868	501	12463	17915	jx93nqUd4i5jrZ28vsQtCXg4kcTh9UxJhHR6kPAELu6t6UWyfxJ	12953	18213	18213	1619217540000
26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	26205	3NKLNhWP8bQ74FDo46w3w5cEmVMPxmJQPRmesLCNUzjtwx3t6UXH	1549	1362	501	12463	17920	jwwbPts4kPoj4xaZFDFicEo5yoe4JkhKzXfskfDD6KbtbsShdue	12956	18219	18219	1619218620000
26209	3NKYhevTR7EUMZCetstNyyLzGXS4xrXCrz25Voue9uL83ceZWbds	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	152	1084	502	12463	17921	jxwCcYbaP2RBd5xD9BwKQHXTziiQVuFrW3oDamay4KZH2DLEf8i	12957	18220	18220	1619218800000
26211	3NKkG9QaKAWFyWwB2pTyxqYsPkbnezAWgNnfj8TNoMW1oKsXY4MB	26210	3NKHKjfDEuK1ZxV65zbz1bDxxPJXxoPfLfsaZCKaqHkvM3JYoJGc	1407	1395	502	12463	17923	jwjZNZiVgACPSDb13D9swajwTaBdcEMTp4GhzhyBGqUaCscw7Pg	12958	18221	18221	1619218980000
26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	26212	3NLeiUaeFmgB9dDttxS1r9ZsF5ik5jc5Bfggmozh1T19228YXCbW	1560	925	502	12463	17925	jwNN42WW541NuRroWz8PzaxV4VeH4XfM7MQ8ozkpf6CUoa6pHs9	12960	18223	18223	1619219340000
26216	3NLBg5HexSbzVhZGyiv8m6H3fuaFTHoD9wzcF2544hBZWJcLtaUU	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1553	776	502	12463	17928	jxhDpdGk1WC5Q3RBG6hDjZfh6qxTx3B82W1rtfqQxd7zq8hYQm4	12961	18224	18224	1619219520000
26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	26215	3NLUysbjE2mhTte5DRLJRbeyia8ACYSQgCVVq9MPFw1ympvq9gaE	1403	31	502	12463	17930	jws2bVzGKssECBUVKNuv2mdjoKvZvMbM7ykCChvm9Dq2EzfKN6N	12962	18226	18226	1619219880000
26223	3NL3LDiZtVKifPpTiFfs9cdRLqyhpduDcuDQrFJ46fVDKVvNGv13	26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	1483	1150	502	12463	17935	jx9hUEsPDJpMppRwEyCT7fZnepy7JeQ2RqWPakbXWbrmB3BTyec	12965	18230	18230	1619220600000
26226	3NLvknuZkc24DX5dGm8kzgMgqkYdUFgEJzMkU4XDHRFV1jq3TgHv	26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	1599	1287	502	12463	17938	jxgsHfSutBpFK1pq2Vva3Txy6zJ51tdGancVCaoHSYuVxLaSyM3	12966	18237	18237	1619221860000
26228	3NLv5EA4AqQMLgiNm63zHoX1twqzQNE2CGgaYkpK9pqS77ML1Cuv	26226	3NLvknuZkc24DX5dGm8kzgMgqkYdUFgEJzMkU4XDHRFV1jq3TgHv	43	1064	502	12463	17940	jxTCM29fyugbTiEHwTUhqfSErRGyUpAnvjJfRjJNgCKMB9WBaas	12967	18238	18238	1619222040000
26234	3NLGrhtK9rCQ31yPQdzAP7htGbevhFBgmkjijNxBXXwudDJnNvcf	26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	1594	1326	502	12463	17946	jxSpBKC3urkgJezKGmwnRnSsxx1jEbMYDdrdWw3iWm5cfByTVtf	12971	18244	18244	1619223120000
26242	3NK8KZy7xjXe6tJB2Lf87cKpfT4AqNTTRTjvMHdtwx9egmQyM1wW	26236	3NKBxzwmgs7Jm761uhsaakdU5xGSkYN5HkLdd79j484D89yuwkm2	1407	1395	502	12463	17954	jxrEs7SvPEmUpZwkLazq5tE7rDuKU2Ljq7QUACdhDXUpf3ijygE	12973	18246	18246	1619223480000
26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	26242	3NK8KZy7xjXe6tJB2Lf87cKpfT4AqNTTRTjvMHdtwx9egmQyM1wW	43	1310	502	12463	17955	jx2BYvQyw5uXEHDkxh3qM2a7G11RB1harxVRk1SkQSCpfnCfkUg	12974	18250	18250	1619224200000
26250	3NKEBnZrJtZweGmKytgV2agXu5Fhu6Pwh8S19spcnRULLCCFZTU9	26249	3NKNTmX5PnxBwHgzKLJ1xLjbUFcXAYCxwjYTvSi9q2UimzHerHhf	43	1184	503	12463	17961	jxarfSoyfJ1Dy8nJi6XnYCb4dCPt1kpi4QVH4AxdHr1sGWo39rM	12978	18254	18254	1619224920000
26251	3NKSWG86Tx9LQqZDKWoqBt2CjDtg2hFUvuPLfuGDdBbLw1Gms6CR	26250	3NKEBnZrJtZweGmKytgV2agXu5Fhu6Pwh8S19spcnRULLCCFZTU9	1407	1395	503	12463	17962	jwpW168mJCMMgT3RG492kY3gdA4MTqdp52qAiJH6s4E4iAEr9xd	12979	18258	18258	1619225640000
26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	26253	3NLXHwgFcuBger3Z8s64AEwXnPajg9cUhZav3UBu8tSfe9V7fWwu	1553	776	503	12463	17965	jxBJwGc1MLXug2SyhztZvNryGMZhG7NFB43mYsq2eGiqs7F8djr	12982	18261	18261	1619226180000
26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	26260	3NKsNjAwUEbfB4gkMURfWukvzaz3SdtGNTcdCrkUbgM13DW6Qcye	171	1128	503	12463	17972	jxA3LuFJuzdjZVboJ8U6CrdtWio2E2dhEPtKWcUHhQuuG23iiqm	12985	18265	18265	1619226900000
26269	3NLW32pzsK7joDSZryxe58rsA1gieqtTyASUX4D6ycScYjeR1Ecf	26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	1405	857	503	12463	17980	jxJfjCtHdm8uAciYr1YPi5Bo3HuwikDZxx8XJrhJjvUjLFnH14H	12991	18273	18273	1619228340000
26271	3NKGSbJ5hx8ZkBykcYxDHY8ckCP6x2vmwkEPJ3avfJVtA2top4h6	26269	3NLW32pzsK7joDSZryxe58rsA1gieqtTyASUX4D6ycScYjeR1Ecf	1405	873	503	12463	17982	jwELcCxSwie97xVY8ysjqkMzPzCbnoS7jdQXzrfZAi5aRRx4LGx	12992	18274	18274	1619228520000
26274	3NLZkfy4qs5UxZor5TKd8o4nPbdMfdyNrhY3d1nCLAmP5mW61KSd	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1407	1395	504	12463	17985	jx9jj8wvuXd9R9K32LwMGK8K255Pnfz8o1ybffG5c1BSw51evzC	12995	18277	18277	1619229060000
26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	26278	3NLWezkBBKhFophGbiQ6Wq7sT8r8iYBn2Zk7fNNJBPchChTt5KHi	1608	1043	504	12463	17990	jxd2UhKjr3KZBAKhFeVBtmT41Bw6SDBuebxc2zvhhVW44KN6pgQ	12998	18281	18281	1619229780000
26282	3NKP7kbEk2SaVEBYLf8vPFkrgm51eWfDazZKZppJ1RqHY2M7fRAj	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	684	986	504	12463	17993	jwRgDmng8SWgZ5V2KeFNStXgA4t4RZM3DDsjLKgL47EuPZs7Z6K	12999	18284	18284	1619230320000
26284	3NLBdDRKqDrG5A6GS5UYBWhzcGYBjpNfKgvdFps3c4ekXGwD5N2C	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1403	823	504	12463	17995	jx4J33oQjarYx6hZksH3Pwgp4tMx7WuFShyaJTq4JFdQ7iMp7Nm	12999	18284	18284	1619230320000
26286	3NKwvPFMoJHQi7c7JmwoVZp5xNw6eqd3uY2f3rfaeEd2KJnKwxry	26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	1634	1331	504	12463	17997	jx2FfCKgGQgAGicc5zCfKRxQwUDYA8uHLdVqqjs8rRnEB3uxiU7	13000	18285	18285	1619230500000
26289	3NLCNVzCLBL4Uobw6dsXcFThJnfmyCKbSEFAmv9J2q9KyL3JG3KC	26288	3NKbrA7acUp4WXPLzmEePa5UrPtUwKV5Ei8WpRGYv8nZuunfTpX7	43	1184	504	12463	18000	jxqBjgisAm8GEtbka8mZ9Pie4tdhLzTNjbNWsE5u9Nko7metd1P	13003	18290	18290	1619231400000
26292	3NKK4Fm78n7Pi49L4ZHwBRGKDQpntwReDUnFcggpfQLbYWXBYy9E	26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	1522	1076	504	12463	18003	jxhoxVprcfJs9ZuucCyfR2QVCDALuMvDuWnFwLNg7KhGEzBbszc	13005	18292	18292	1619231760000
26296	3NKheX4TUPa7Y9NaJWRFJjscyVFDkHWXQSCNfoQfjmU92MWe53SQ	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	1403	824	504	12463	18007	jwmByqwwYN5D9nGyMknZ4i9Qa9RXdtW3S5eKSSsaqnpnAZoejZZ	13007	18297	18297	1619232660000
26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	1406	1393	504	12463	18008	jxUg8tP5tkRg2qrMNSwmThjqJMfLNDNp5iPwhtwXJ8LzaETwWNL	13008	18298	18298	1619232840000
26300	3NLuTohSyedkR8H7BqpUTv9cq1HBAGmVkMiTizMghxXpQKYib9dL	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	700	840	504	12463	18011	jwMfxQDgf2zumK5h8CySkhQKNd2gxs28t54fyS5nQz2kjDQiey8	13009	18300	18300	1619233200000
26303	3NKrKu2kdJjw8VnVqza1rv4dR9BgQvChEMGWq8szN84bgdSyARfR	26302	3NLtAmBBFWAnYUgpJ8aipFKYeGbY4xxCYHKiKypvUVnWmd75k5QP	44	959	504	12463	18014	jwAXcQivCr15kS6LiqWwQLM7x4EQYoXX45P49DmE1bNoMBxsT5z	13011	18305	18305	1619234100000
26308	3NKq81VnVfdC8z5G724DkU4zmCm4ALa6HSuM6Kf7AugTdHA6R6UJ	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1637	816	504	12463	18018	jxAvLcw7GJAzxfpKYiaKSo3ZKVeDAjxeSF5SsvYCCSAA2D145Ee	13014	18308	18308	1619234640000
26309	3NLs13ZMzYFLkTYFYbHZrfpEBFqTivrs1YXxC4suCtqL7zdc9heZ	26153	3NLZNtnaRbf3GQo9ZruS1RQ4Qe5vCmBbKC7JfjyFp2Y5ZdgRmTrW	1555	1347	500	12463	18019	jxGPb22z7X8G7PHehSwJTmhpCczpjrAegW4Fsd7jZK7AmzPVq19	12929	18308	18308	1619234640000
26210	3NKHKjfDEuK1ZxV65zbz1bDxxPJXxoPfLfsaZCKaqHkvM3JYoJGc	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	1610	1068	502	12463	17922	jwYzQqU2Ht8QyCi9uj5wzLsnqPtAzuEViJHXFZhiAfzoiTHWYdB	12957	18220	18220	1619218800000
26214	3NLZT4zX9XTsAqzxZsjMtzA4THtHpjj8LEg2kkqCUfV6JvsLLMLU	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1483	366	502	12463	17926	jwGJF2KsaNYEhSyTnzffzet3RhSmNMi3v6exmbgdFksDiWeQ6sV	12961	18224	18224	1619219520000
26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	1489	1134	502	12463	17931	jwLFYPxPVrxBUYkMJbXG36i7nosEhtwqspcuvuTiJQHnwyoYgJR	12963	18227	18227	1619220060000
26221	3NKgqUMxbvMCBy8mEGnepz1ymBykVc4LEkZ5MSy3DE4Ky1GxBze9	26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	1406	1393	502	12463	17933	jwoG1rozLzCDPMmTDZax67WQBE8DxmHNgPeojR816p4qFTTUqjn	12964	18228	18228	1619220240000
26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	1406	1393	502	12463	17936	jwKHTUhLp2ChSEVJqtRN5G3AABGcUPEVnmpRxoMn9MtZHVMgqYN	12965	18230	18230	1619220600000
26227	3NKLcYARND64LBL1oXAqGHwgziqKvmw8KFWPLpoQQjRxqzVreWVV	26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	633	1138	502	12463	17939	jwoAE1m97QiA3bwT9PSSMUPRyZV46LhnPyuHPL3Ce8ySNRLPv2N	12966	18237	18237	1619221860000
26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	26228	3NLv5EA4AqQMLgiNm63zHoX1twqzQNE2CGgaYkpK9pqS77ML1Cuv	1406	1393	502	12463	17941	jwKV1SUYMpyfGsHgJuaB3keRF4pFrYF46NcS8L7eZxMqHCgDHVH	12968	18239	18239	1619222220000
26236	3NKBxzwmgs7Jm761uhsaakdU5xGSkYN5HkLdd79j484D89yuwkm2	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	633	1384	502	12463	17948	jxAR3RJBXNGe1Lqp4hMMR1MWa5WtFwX6djmDzfXhDXYDuPzE4SQ	12972	18245	18245	1619223300000
26237	3NLgKHkAjNc3KMyUk97WRym5PWqXBDW5hYux9yAWjMjZCCnM8Et4	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	1406	1393	502	12463	17949	jwmVTihFycWwQdndFeC8TMo7w1NFJw1xFoD9aKazffx9wmMx7qE	12972	18245	18245	1619223300000
26240	3NKgCgiMB9roA89Tas2akGHTzygz8xEuEB9hq4X27WG83ebxwBnt	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	633	1384	497	12463	17952	jxLz4GX2se6ub6tk8rAg6TcVrSsHf51XaumkvQe6Xmd79UZS6hC	12862	18245	18245	1619223379502
26244	3NLxRT533FKG1JNRZiyrjyzgG6ZrpoWud4ou23axXPFx2VqEisvw	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1460	673	503	12463	17956	jwoqLMSZQ69SYmjYDdb5Tyw8SLUJ9oRmzpkTbGiBxKtJr43fqiQ	12975	18251	18251	1619224380000
26247	3NKpxAKFVKbzRjgzLzSF35yXPFFDyZWi3qv2NL1u2a1a7XpaamS8	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1647	1176	503	12463	17958	jwvNi5H3uE7D8QuDmZkx6HmVkTj45qANY5xtHX5MPb6F24WrgPU	12975	18251	18251	1619224380000
26248	3NKaPVYmFNX8PJVe9AWEAV2EjW9Z5EnEg6Ydu5HQY14ww98mXi6M	26244	3NLxRT533FKG1JNRZiyrjyzgG6ZrpoWud4ou23axXPFx2VqEisvw	1542	1058	503	12463	17959	jwJXvFRXf6xZnHCemanUFZaVPMpHpfVZbfYcm4CW2E69oopChS7	12976	18252	18252	1619224560000
26252	3NKR3LaCSrpcW14xCUhV6MerqNWbAHAhCC6GLZ1byhUDsdAfppkB	26251	3NKSWG86Tx9LQqZDKWoqBt2CjDtg2hFUvuPLfuGDdBbLw1Gms6CR	1643	1299	503	12463	17963	jxQHPVyHSxreSKMBHW1kpNJjzPVrawSoW6JAZ3mvKCLeoUeej4i	12980	18259	18259	1619225820000
26257	3NKYCoTG1Dk5SbRZkRWzX5bYBevbCiELFYWbg2ygoN437xbVFHMQ	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1647	1176	503	12463	17968	jx4GyUkyDPP7EbqjmybmC8vQtdMGVA4nsTtCw8n3DuZrSZ3ZfRM	12983	18262	18262	1619226360000
26259	3NLKQNUaooqt3zdytAh8D1eLYBdWrVHdgygxiMN8FALUk3akWjTN	26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	1637	815	503	12463	17970	jxxeJ2rw7Ve1v6A6YHgX3wQ9SvNjY3sqgdhpjs3qYJcXAhGZEBp	12984	18263	18263	1619226540000
26262	3NKgY9w9zHAJwmjm2sr5dFf7PxJCdwFn7KdTqvZo6R9siiFSjb7U	26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	1402	874	503	12463	17973	jx51MAvt5M5csSSHvyQpRDYsXHvs9jbw1CK4z6s24MoLQyfCaWm	12986	18267	18267	1619227260000
26264	3NKdBzK4TRYmpgdExMum3ALw8P25wi4s9uJogScP7UBP5epaCuf8	26262	3NKgY9w9zHAJwmjm2sr5dFf7PxJCdwFn7KdTqvZo6R9siiFSjb7U	1507	914	503	12463	17975	jxhUK21yJ6MGY9CxHdouquFVHqGTQJ1iofasrnEqyfEBHaS6t3p	12987	18268	18268	1619227440000
26267	3NKTYRz5dcL96RShh2L2TBqAJBtrQjVZ2y6P5RdtJr9k88W3awJb	26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	1406	1393	503	12463	17978	jxPLrrjETzWHPSgeb4W6G9K8js4y6vhertqV3poTLgJefB6SfxA	12990	18272	18272	1619228160000
26270	3NLXEMVU8CoEJy9Lj1x9Uo8dMhFwjvw7zKUkoZoomTZGgDpDrSBQ	26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	1516	1294	503	12463	17981	jxwUeUtjwZiyDTzehbG34n9QTPrtignTCj2ih4eyEa8x8jM1HEq	12991	18273	18273	1619228340000
26272	3NLVRTtyx6XQPf6kM9LNyHiYqxvHn7kUkU55cPL79vXKZjwANR2u	26271	3NKGSbJ5hx8ZkBykcYxDHY8ckCP6x2vmwkEPJ3avfJVtA2top4h6	1403	824	503	12463	17983	jwsnQAr1Z5Wxx5gtkXY3wcsjdJnACowQt4iQ4kAyfyeEn7V78pZ	12993	18275	18275	1619228700000
26275	3NKWQzczcPGZ8GCMutisMWBEnubfqxdhPvoeo1Au2PpUZm8BRSru	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1406	1393	504	12463	17986	jxhAVhcPSXfA3w9cygUS7pbavKcVv2f3Y5basJoWvy3zzWVgwmW	12995	18277	18277	1619229060000
26277	3NLbUCdj2wjH9en2z8s9eJz7Q1kbHkDg3ksAs13x3GgKDmeTGm4o	26274	3NLZkfy4qs5UxZor5TKd8o4nPbdMfdyNrhY3d1nCLAmP5mW61KSd	1406	1393	504	12463	17988	jx1jpP5CXK21qYLiCE9M6e3ZwaZpGqzU13JabbvhokxEPLuQXsb	12996	18279	18279	1619229420000
26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	26289	3NLCNVzCLBL4Uobw6dsXcFThJnfmyCKbSEFAmv9J2q9KyL3JG3KC	1407	1395	504	12463	18001	jwHAnWcnf3FABkUbcAGjnauLmTeaUYa9ioNFHtMExcZWna7SRDq	13004	18291	18291	1619231580000
26298	3NKnrKtRB6ihuksQqUWcRi7BzCRyzkq4wxQ7gHKZGcSwwmEiXPMA	26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	1403	824	504	12463	18009	jwMz5VUBJWhBLY6xdj5gtDTa3KTk7mqZNZ2b5krKw1c1UQKtput	13008	18298	18298	1619232840000
26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	1607	242	504	12463	18016	jwXMA9yAUxmAAJqjKfH6ArkdCEF3tdMAXi54xnTgFNLnGXyDbVQ	13013	18307	18307	1619234460000
26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	505	12463	18021	jxZPK5AQCqPvwJ1dKZxMwqKijqCQhXwkQ3pZ36CMKRbhSvfoaoT	13015	18309	18309	1619234820000
26314	3NKvZzbL7eALsswq8QecSK5N5oz577VA6R8PDTEGXiN9JczqG6U3	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	576	1109	505	12463	18022	jwcvMGB7JcVddYxZeL7cuimgwviBpSxFyiRxzM2TCQh4LaF5zva	13016	18310	18310	1619235000000
26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	26323	3NLjidqAeqVAhMn2bZ2uPSinwePDLTtwqUDssURDYHTmdEcNdKMD	1460	612	505	12463	18032	jx22gS3DsEYncQ9zXTndTkQuRSZDUST34Q6Dyg51VVRYeFfccvm	13019	18315	18315	1619235900000
26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	448	1305	505	12463	18034	jxQ17aegXGspZ4JUAwCDz9PJJuv6WLi127DkoDG5DVxKQNh6HzV	13020	18316	18316	1619236080000
26331	3NKymasTtKpptE6dMh2sfibYAzLeXZ12DQeWu7hZJS8Cas3hBiPL	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1670	1036	505	12463	18035	jwPztTvLe5mdd93tzz3Gd4wQW97qttnAMEAgCmrXXaaLjF4qfXr	13021	18318	18318	1619236440000
26338	3NLTvndsZZB1Y98PW5tuUUXinySAxRmyvbu1JecPshYccCfHS9Qi	26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	632	1136	505	12463	18041	jxiBdSkH8f7s2YL5wpm5xqSxZqeNZULw5WDxAa1QxKAjwsfCt9M	13025	18323	18323	1619237340000
26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	26230	3NLHuHVvirfyQq4UFatgh2iZnEi6VsYBM9SFDP9NRjNABqrTpPqU	1647	1302	502	12463	17944	jxsyhSL5rQucW4ejoDk6biJRizjzXZeTHwCE79T4cqAwqsdVkhU	12970	18242	18242	1619222760000
26238	3NLG3ngSiQ4otXs1h3wGs943TKxeEmE9qpnVPdFTwoL12ETVXTyH	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	302	302	502	12463	17950	jwfL4fwiYEunevFBdcvzsuFm4vVCAT3eMqrCtW7WQWB3wxJwAuq	12972	18245	18245	1619223300000
26241	3NKeksPrM8ZJLEdGH5rX874WEPtejXUunghFvthe6CF1zgsP3GYA	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	633	1384	498	12463	17953	jwmAuUtFL6yGUitB1hycgjgE6CrkBRNHQtfwuVMzkv28VQ3agzF	12875	18245	18245	1619223417333
26245	3NL8iKbCJRrAdxbpa6NEWF5dVmxdCcryLfTzqSgs1jrkPMZWXBcP	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1675	1096	503	12463	17957	jxTqriv6dK39zY3quQjoa95SiSw1fFAAuiMMbPHvXqo7ZpxEoCx	12975	18251	18251	1619224380000
26255	3NLnML9KR7CTKQXz4tMn25UteXtVVeTCqAscHGpEVnq1zBayjUkK	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1406	1393	503	12463	17966	jxUcQ6EPJpZreGyGY7JM4NBKa83qthE3rxuiiBHGt9LpQ8kCRk5	12983	18262	18262	1619226360000
26258	3NLQyfPKT16A2KatC4ryhKwRF8q1pm94ZAZeJkk4hTWSTBHLoEam	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1652	1315	503	12463	17969	jwirBGoTrvG72GHM3p4pHN2XfauXPQJtasmQwRwvRqS2gdJUjq1	12983	18262	18262	1619226360000
26260	3NKsNjAwUEbfB4gkMURfWukvzaz3SdtGNTcdCrkUbgM13DW6Qcye	26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	1581	777	503	12463	17971	jxNeEckq5deNF5F9kvgKD86HbMjCPLdRGzN4Gywi8U3ETuJpyrw	12984	18263	18263	1619226540000
26263	3NL77Gh5h63JXtRjX8FRfuMcd26hSuxTYvaT7uhjRXLXHwoNNFDi	26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	1647	936	503	12463	17974	jwsSrYMocEwtXBGdmnGmaSK3j93aYReqHZtVL5Zah9aPCod3RMe	12986	18267	18267	1619227260000
26265	3NKfk4xo8jgDEmA8WCFJ3o6gEjPhwKLkbA4BDaaKQk8Fzvodw5bP	26264	3NKdBzK4TRYmpgdExMum3ALw8P25wi4s9uJogScP7UBP5epaCuf8	1406	1393	503	12463	17976	jww63ij67VZJfV3GJbHU9kkGbuSJZ2GZn21nuBZsbwwymH4PSnx	12988	18270	18270	1619227800000
26276	3NKzpZbiikH8pCBQJvheEEYFRa3zMEQrTDAWJhEZ63LND7Hfn3sd	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1600	1372	504	12463	17987	jw8i1NDcASiXWcnBTHQ9WnfznRR6os2NK5gRgGYWGZbAg9YFmso	12995	18277	18277	1619229060000
26280	3NKKcX8rkc1kmqJhK1DMMa3degJ73i98iqSWkBCYsmxwV6TUt1TV	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1481	790	496	12463	17991	jxTxJqYNbg7iCNTszq83o7EkpiEek3HWPyWcA9seRdrTt3yyR7k	12831	18282	18282	1619229960000
26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1457	1391	504	12463	17994	jwrs8kThNgknPp3HvmdF5g8bCc58GDkbFdP1ZqGtXJxgrqMb3av	12999	18284	18284	1619230320000
26285	3NKAxbsdhuGyKgsue62VzxbSxv4DeMsAtoyUE2qm26HtLTsQiyt9	26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	1542	938	504	12463	17996	jxEU9huwCJX9qza6HhXYZnSu5pzMuKF1ZgN9ees3isL9TVE6QxP	13000	18285	18285	1619230500000
26287	3NKZXqqvxNKWcRuVGKYxegYsZxqTCDecZhUcr8tBwZXREdymCFqa	26286	3NKwvPFMoJHQi7c7JmwoVZp5xNw6eqd3uY2f3rfaeEd2KJnKwxry	1460	595	504	12463	17998	jwKREoHe87yMnptEtEAd7LBmTw8yqrPo36Az6r55KiyFeKXh3D5	13001	18286	18286	1619230680000
26288	3NKbrA7acUp4WXPLzmEePa5UrPtUwKV5Ei8WpRGYv8nZuunfTpX7	26287	3NKZXqqvxNKWcRuVGKYxegYsZxqTCDecZhUcr8tBwZXREdymCFqa	149	1157	504	12463	17999	jwC1dB8HSUann1iT93ckS2pTHGfVLXuqbjHic9wrhjsSSjEv8ni	13002	18289	18289	1619231220000
26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	26292	3NKK4Fm78n7Pi49L4ZHwBRGKDQpntwReDUnFcggpfQLbYWXBYy9E	1406	1393	504	12463	18004	jwNcKPHpq5LpvrzZUnoeASytTde8b1tC8ZC8GbEeBxCNvU3m5FM	13006	18293	18293	1619231940000
26294	3NLXy97stCgN65tDtqNkQ47T5VAuRhMWBm6h72kyNrD74uGV9oRC	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	1406	1393	504	12463	18005	jxWNBasyvyCsXmvY2XJb88C6HG6fqZACUFoN3JeuHfRbmCGJhMh	13007	18297	18297	1619232660000
26301	3NK5cuktPuXGMjQDiu1XhqHJ3KCAhpLx8W1yeHBZZwnzWvJo9ias	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	1590	1300	504	12463	18012	jwgjPqBB7eAEUdjXnfTRk394H48AMUfEcbUdcm1BuMMc1fyR1sk	13009	18300	18300	1619233200000
26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	26303	3NKrKu2kdJjw8VnVqza1rv4dR9BgQvChEMGWq8szN84bgdSyARfR	1477	1350	504	12463	18015	jxav1JwUxkkyZi7V9odCiAmGbYWVb4qLJE2xFAVG7u8Lwg9RD6w	13012	18306	18306	1619234280000
26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1555	1347	504	12463	18020	jweJWuZ17chq9SM5fPxZuiZ7kvGznmqeCBbUwubXgWNF5LQT8ia	13014	18308	18308	1619234640000
26315	3NKbBDdoEsyb5aLjb8TJ391vQevRN59dwQVcVkHBDRKaue6VMmz5	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	1483	163	505	12463	18023	jwuqTGiipCRLRcy77SFDSQ2rMCoDzDg8usygNQEXxwTtcy7MqFZ	13016	18310	18310	1619235000000
26317	3NLt1oTqm9ky3HYpYYXdfdSfYDcZdMR5jw23ztPhB9Hq3DAdXj3G	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1460	637	505	12463	18024	jwzFMi55aDyjFBL3pvQQt5svDqN4L59BoBhTaV8bDNYW5aPEwXC	13017	18312	18312	1619235360000
26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1489	1014	505	12463	18027	jy3GxLzF6uPAH6TwCHG9e9PBKASpP55Ypwdcf9S7ifeZJEThBzX	13017	18312	18312	1619235360000
26324	3NKRARWh9rxnXzTczvF74vJzuaVrCYybwS2MFy9enTkH3yspckAq	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1652	1189	505	12463	18031	jxBhpXoHpapMEE8M8akzpMLrEN2FbiXa1epL6xGqT6mgNjnoh4L	13018	18314	18314	1619235720000
26326	3NLnD69f7vWtcbKGh4nhXMzVja7R4RbqwKitaezyifH46gDDrJxx	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	1407	1395	505	12463	18033	jwmuk2nb66eA4kF3rPjm7BEygQPspjrfBsp9n7un4W4ccu5PNXf	13020	18316	18316	1619236080000
26332	3NKuQxhrEwByFYLqUH8XsToErFFpZASjBcVBpwjUxZZBD2Me5TaR	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1619	1149	505	12463	18036	jwH9xB7xyXgwKPykrZLUKfiwgoenLSpG2upe7zhSSqRXaKDq4jn	13021	18318	18318	1619236440000
26335	3NKmy73eM6U2UYbyYpDxzRNbfh1j7ie1tH4akwje2VUg1jmj4g38	26334	3NKNjyXJxgj7axRLWQaMXgVpx2R348hTjXH89sFWnJnxcFistkrR	1406	1393	505	12463	18039	jxiKgxeU7y8tMmUZNjeU1heug3eyyGnJtUBXeLL53LsZu6TvBK8	13023	18320	18320	1619236800000
26343	3NK7udsrdgH5ggBspVzW1DhowSE3XGFoqW1eCo9YpcA4smvsfAtP	26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	1516	1294	505	12463	18046	jwwFGd45ExfjbTrv1AFqXRgjJEaswTPbddwXuarNj4fQuj3xuyx	13027	18326	18326	1619237880000
26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1590	1300	505	12463	18049	jxKFvrMRy5Bf8dTTDM1gbbzCLPtgiKiS5TULurAtrpSdq9evhkm	13028	18327	18327	1619238060000
26348	3NKjP5yGD8yHEdYjYSyXzzgg4zbc8mxbCTeKG3WGYyw6NErZkzfh	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1590	1300	505	12463	18049	jx6SzLLiC3ML18y49Kjubv4f98YSYJMPUVjaKb1cBvtqBiVmdCr	13028	18327	18327	1619238060000
26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	42	1361	505	12463	18050	jwUY86nhigwqR93UvqsikQ3CDNbVCDcCgSA384Mkkxqc4kjEGsL	13029	18328	18328	1619238240000
26362	3NLhzH9ksbiarSWW5GVzdCKtRCgXBJ596JkHXsvRTNrGotWhR53x	26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	1407	1395	505	12463	18062	jwbtfBZTtqp9tBewUJtXTxj3Pdo7V2GAPrNaTMatnqXMEW49bUP	13037	18340	18340	1619240400000
26312	3NLxMNM3ydyU8YCive86cicQkLpCAvBoWMdVvChpAfhQfiUAGy9S	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	505	12463	18021	jwxZsj6HdnH1GFqRAohKBPD7tWQBWvXtwUqvR4Dk6jm6uyAw4x1	13015	18309	18309	1619234820000
26319	3NLsD3uv3rrAhCHy3xJ9d2y8phrrjC1foCBszb6Tym8VWLrxGNw6	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1406	1393	505	12463	18026	jwzfxbXRz8nS8JZ1hDQz5ZnvFiSwsCH8skFeSU3ozqbDGmJk5jv	13017	18312	18312	1619235360000
26323	3NLjidqAeqVAhMn2bZ2uPSinwePDLTtwqUDssURDYHTmdEcNdKMD	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1637	816	505	12463	18030	jwG1YvxVGEMjpLtu6z3fR15DsvZQR2Mt3vJDSbcryipsvfka1e8	13018	18314	18314	1619235720000
26330	3NLY33eAj48sRBtsmGrVPS86W2B6WjVspodvNN2bMNe2FeTq8xFV	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1619	1149	505	12463	18036	jx3YaHrLEGj6irtR8DhaARWDNi1qrZFNptrQsn2bgwMWXDtNLoK	13021	18318	18318	1619236440000
26333	3NLJ7J2XGM4JSJZJeh3yBnjxfPKHuMiW4VtpJ1WqAL7qvvE5aSor	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1513	1379	505	12463	18037	jwNT51YyTDcwW3BWS4Rzyfqba9ER4begmLiioHLbzzRswnCHfv3	13021	18318	18318	1619236440000
26334	3NKNjyXJxgj7axRLWQaMXgVpx2R348hTjXH89sFWnJnxcFistkrR	26330	3NLY33eAj48sRBtsmGrVPS86W2B6WjVspodvNN2bMNe2FeTq8xFV	1627	1385	505	12463	18038	jxoDxyPYoog5P1csSMrKVAEv1fREBHvCyHuBfxtQrb9pRqmMWTU	13022	18319	18319	1619236620000
26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	632	1136	505	12463	18041	jwsU3qwtid7GctKgTBRib7CBYsVegi9jnuBAobLRVvqjjHhW6fo	13025	18323	18323	1619237340000
26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1649	1383	505	12463	18042	jwvBL6xCXqKHGRiEAgYpD7obo6YeNKfMqMrHHHHoo5VWtec9RGx	13026	18325	18325	1619237700000
26340	3NKq5czGPUeGVk11uWFi48zWpUhu6TMJogdb5GrLoqcSsH6KQMpg	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1581	778	505	12463	18043	jxALmCvrzdaMZrpAshtUEG7ajx1E3QEwthMS6PzgCpYpt4kMf5X	13026	18325	18325	1619237700000
26344	3NL9ma2BzhiQEYxsWnSR27VLd5mPForejo6budyRWLm9RAoHbDCs	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1406	1393	505	12463	18047	jxi6DaobU3vyyjgWBUf4NX25LUSFBURRYJtvyHyCENovLMcFURT	13028	18327	18327	1619238060000
26350	3NL9wGsDb9pUJCgrmJpGMnq9DuaakZCDmHaxKyRPjXqdF1Q5SBpQ	26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	1634	1085	505	12463	18051	jx4sU5t61hMeDES63hcX7jsbU4B4sETV7gmNMEquLygwL4a2qpc	13029	18328	18328	1619238240000
26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	1406	1393	505	12463	18052	jxxR9rpDE3BatWinWvLAMS4k17V5boo5gGnxGXWt2dnCJdAUWbg	13030	18331	18331	1619238780000
26353	3NL1isb5fLgAuyJWSKngwtvFK8LFPDey2AZMzQRDvrGWz32xFc4Q	26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	1506	1127	505	12463	18054	jxX88CUG55UZJBzriYzudwFrjGS1jJf2sPr61iaJYAhF1yFanRK	13031	18332	18332	1619238960000
26356	3NKt7q27LGa9jSApy5K6Yv7ZWvv1FUjPGd2ciybtjxYpEwf1srYg	26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	1405	849	505	12463	18056	jxgNqMbpZ4ABREafXZ7UQhBZLyUgT8eTkxk1VvMXityAmz9fLti	13033	18336	18336	1619239680000
26358	3NK9e6FZuCQeJi3DZVr5HmntowsDRaBANTrREd9qJ1jwTJYQLQot	26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	1534	1071	500	12463	18058	jwsRa3n9bHMkVdyGeDm2en1zyw8zUVfKW9YYJ9482rzxFmefJJe	12927	18336	18336	1619239680000
26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	26360	3NKaNCas8t722ymGPafbeTaxoe5prW3cSZYvsv6LGFJFw76eZjx2	1637	815	505	12463	18061	jxh2fkHoib9fMhhD1SnkfXNVjPABdqsFbiVUnKdAkh473yCm3UR	13036	18339	18339	1619240220000
26366	3NLUteRH1dBDWrhGRvhmEv6GFpKDUbKxrbPYvQUZm4ZvqdhpcCyR	26365	3NLB6vV56iDL4u8xbcHU7X6KpXpeNND49Bwk7YbzdaCzwu4GzfNg	606	929	506	12463	18066	jxGBWNiKPtyZkLKLjNbWYMiM166c7tVrvbu6B9qzU3Nb3NDpiL8	13040	18344	18344	1619241120000
26372	3NLGPK2ZN6EgTRfgxyD9juHNzXxLyEoti2xGbXjdo1EFZAbLkpQU	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1460	426	506	12463	18071	jwxeP7YV9Mm9Yrk42LjMMhicKLN5b28zXucBqU74XC3heQWDKek	13044	18350	18350	1619242200000
26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	26371	3NLvSrYwWN7prvsdBPV5ESVoecspwoydroTRq25SfQam1vHMi2ZP	1474	1083	506	12463	18073	jxBGzsiQokTUjpG2bacoxzmAuNGbTvE3bn5dPV99sQ1wLMRSQsS	13045	18352	18352	1619242560000
26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	532	1057	506	12463	18076	jxJ5HjttUgLsbPcU3nd9nM1Z6kjfRkZz1GqAr4JXqqVfyUCndhg	13047	18355	18355	1619243100000
26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	1406	1393	506	12463	18078	jwZx6QgvSw6eWSVeeSt9gDeNRuZ2pjT8X5ywG4oh7TGn8KzcjWK	13048	18356	18356	1619243280000
26382	3NKYAR69ExToc8bHaJ5gEBWCSXQXfwD5e8e3rx2XZdHRvTYV3oPb	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1406	1393	506	12463	18081	jwBzXCQNTDc7Tu767VtL4XreWE4pndjhM5bPEMx6F8zortxHHVA	13049	18357	18357	1619243460000
26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	1642	1241	506	12463	18086	jxXdWdFhxuKCqspRqeLqXv6MTT38NzMsn881ztHY42tymcoVMxh	13053	18363	18363	1619244540000
26392	3NLk9KqnyEruF13Y7VpwvQHhPfHDAZGRkhq4qRSYbLTwxiNMw28o	26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	1602	1369	499	12463	18089	jwtcuJn7jgFKgUbFuWMu7hGgrkTQYCbcKdY8Wue1zMjxD5HWU1L	12900	18365	18365	1619244900000
26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	26394	3NLs4vqcXqJViGLjbXVnjkbnaPaApSQ7s6BPuqvYaTK3SNWZtUL9	1406	1393	506	12463	18092	jwP22SyAxkmJEhpAgsjxunWn85m3qbqnsdSzUKNJm9EKiNkR6ax	13057	18369	18369	1619245620000
26400	3NK3EBgtFWBSadCHKvZ6oYMoyZdG51zVmdeqfdFQzaT7z17VeN9b	26399	3NL4uV1fLXuCaYKe9Nkz3GjXsMzjJGP5pmP8tjD12diyGotVXNjh	1559	1107	507	12463	18096	jxiPAuB2CJ3rEodgUFLFU29VfeUiLwcAhMk56t59nkMcByiPUBN	13061	18374	18374	1619246520000
26403	3NLigw26LLafuNp1Mz9E7hT2jHC8t7NkiMmjyTwaARRyhgqiX6Bq	26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	1553	776	507	12463	18099	jwAzE7HHLL41hBAezVKrKABKx6MHc8ZyLdh38cA3Qh68XyAb11g	13063	18376	18376	1619246880000
26412	3NLEdqi3cwipvitSZEPg27L3eYntiPxSfYpF1UXjfVtnL6vTS9Jy	26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	1406	1393	507	12463	18108	jxLChydfcbt6YKNXbWxB8xQTvGSXiWBMdzqE4W9oqmWWz95nTee	13067	18381	18381	1619247780000
26421	3NKbi35rnpHPUvXHhStzjfMpfgNMqEeZgt2VJ6NZdPTWC2p7Zc1X	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1646	1354	507	12463	18117	jwkAAQzNc2RahtKJm3hQFC4g42ptcr4FH9bca3B8ah2ZGyP5swc	13072	18391	18391	1619249580000
26429	3NLLzFqEZcNXDbwDxqRg6U6MxAGyCgx8BQpDySyh4SAVaVraTPpA	26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	1571	1335	507	12463	18125	jw9UUmbVaSxoKDg2sfGg66idk7cRbAuuKLPwAne1xLBwx6eQUHm	13075	18394	18394	1619250120000
26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1407	1395	507	12463	18128	jxbb84yctHTiSXgbNh9GSiYQg955yormkV8ir7maRg6BqZNvvmY	13077	18397	18397	1619250660000
26436	3NKY1y9FeCsRm9ajiohDTMeiExgP2gKATpZCBBYG1SvTpjAYPPnj	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	1444	1381	508	12463	18130	jwdkyCViHMzackpG8P6FmENhnb48SG8XqeZNqsKTYLpQFPgsgdH	13078	18399	18399	1619251020000
26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	576	1109	505	12463	18022	jwXX6AAXGAuQAJ8dan1eMahQrQKaLrbqfur3p46R2MmPg8D3arD	13016	18310	18310	1619235000000
26318	3NLmdoqu3bzeSJqU2CCrjC7VvBZ21C6A93xaDes7d8LTrUV4nbYN	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1407	1395	505	12463	18025	jwX6iymLUXYoSAcBBAanbzwmVMPPLdUdv4ndKmpvPMeWdZgPHz8	13017	18312	18312	1619235360000
26321	3NKBzC3fCho4ZphGQFDB9pezog2LhwvKQDRUjjqLf9TDUSBdKGWg	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1509	1074	505	12463	18028	jxov9o6CTqdBbf1rFMC844SeMkDbvfHpjQoL7p7eh7R4stjWEYj	13017	18312	18312	1619235360000
26322	3NLFLM7NHb7TcjveRGHteXXbs4SnAhf2UJQ4vtyyd4uFoqc6agvZ	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1407	1395	505	12463	18029	jx7yF8WCRG7ANrP4iE9qkeBppmmrp43YQWfhwscUkvWFmCswQx7	13018	18314	18314	1619235720000
26327	3NKHUz8tkHvNQVTigLgFuf2K9g82xSxJyHLLwALVtZew84fCJK4m	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	448	1305	505	12463	18034	jwc9NnmhSo6nK6HHzkULqEXrC2zt1oXrU2N83wbbt55aQXu6iYN	13020	18316	18316	1619236080000
26329	3NKnixH3vEmpgZfiaFJVZDBCWJX6qw78KWSYkdLxjJCfmCxtqUDW	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1670	1036	505	12463	18035	jxYRWekQyay91intKh4dD8G4S6uKpapw5mUbBPQLHt7hCsAtyUe	13021	18318	18318	1619236440000
26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	26335	3NKmy73eM6U2UYbyYpDxzRNbfh1j7ie1tH4akwje2VUg1jmj4g38	1403	824	505	12463	18040	jwFajyD4s6Wf8YAh4hNX8PagnZzx792RXU5RKCHqH1G9Jd8PE3o	13024	18322	18322	1619237160000
26341	3NKJSLCyJ4P8DCfmaT5DKaMGwKYfgxKcHubYMVAgCkjR9N2ZfeWH	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1403	824	505	12463	18044	jwB34ZQHckXsNQyYtkpmNtkmXAMm3rvgUh8bs4Uy5qRLyjav3yt	13026	18325	18325	1619237700000
26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	26353	3NL1isb5fLgAuyJWSKngwtvFK8LFPDey2AZMzQRDvrGWz32xFc4Q	1593	1346	505	12463	18055	jwUP7CMPSDyVLr1xRwQSVjG7vqCjpc86oGfDvHrCqywgYM3rGDC	13032	18333	18333	1619239140000
26360	3NKaNCas8t722ymGPafbeTaxoe5prW3cSZYvsv6LGFJFw76eZjx2	26359	3NLJqv81J8ejoeBE61r4qEfgKtLjurJWvu17Xq7Ce9GnA1h81E7m	1406	1393	505	12463	18060	jxeJuKvySgxX1WyS58jutSsVJpyPKtdGjmeFm178rDReKLYU9Go	13035	18338	18338	1619240040000
26363	3NLCrM2m9mhNtGFUSxePj5kYDTZbjDQFx8pDCmiHZz9rEEZjyg1t	26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	80	907	505	12463	18063	jxRYQzfmXU2zybnjUTXk2DTupLnsSYb86wXF66sxcyCVhRQTCCm	13037	18340	18340	1619240400000
26369	3NLWt14nG4ecUPjibebjCzX1LoyB3NvMutZ2o54L8AgoxAUajQj7	26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	1619	1275	506	12463	18068	jx7QHkomJLMq9DLTs198sRsBp1RgfjSZxGhva61GnJAYHwJEHwT	13042	18348	18348	1619241840000
26371	3NLvSrYwWN7prvsdBPV5ESVoecspwoydroTRq25SfQam1vHMi2ZP	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1578	1170	506	12463	18070	jwdKk5MTyyXQu5mADqCUbH2uFBN4Gi1DzgmSKpwCYuiM1c8nKay	13044	18350	18350	1619242200000
26373	3NKEZcedpQs2Ews2sACK71jztHcJoBAY3APPPB8vtZnCfRPhjjNx	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1631	794	506	12463	18072	jwM82VuMehS6B3aGFznodCAhwJ6SWxgbiRQvmCxGjpC154xrMZk	13044	18350	18350	1619242200000
26381	3NKbUWvqFsPo1neobEZSyuduJYAF4tNH2EmVDNcs8yahR1zV4HJg	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1619	1029	506	12463	18080	jxAfmDzuihuPBguAMgJWF3bMLAzhc3eDkJXwBii2bgAD4ioEFmY	13049	18357	18357	1619243460000
26385	3NLeMjj6F9i1wWvv1irE8g9GJLwRx24ANCeBd7CZFV4H56d7mYJZ	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jy1BtqBY6sD1z1PRba23nyRzpdn2kNKypupTLPPiAkiFqxePEUT	13049	18357	18357	1619243460000
26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	26387	3NKYzaL5Hd9DtirMq6wGYsFG1WEcCVTZB4JEn8P2wY84MZZprveA	149	1283	506	12463	18085	jxN4nrYu8zA6FPVUFyWXyoSNStLrGeBUsd3gDdt3Q7LVoSuHF3X	13052	18361	18361	1619244180000
26394	3NLs4vqcXqJViGLjbXVnjkbnaPaApSQ7s6BPuqvYaTK3SNWZtUL9	26393	3NKPJyV5wKTUhFu4gsG755zQUdLjtPA3FDyPTo1WxebSrKSPkNnm	1407	1395	506	12463	18091	jwSJnqWLacMyrNk4LxVbDYruLPM8BUQkkUMdxDHdKAKTsLMMQ8z	13056	18368	18368	1619245440000
26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	1546	1339	506	12463	18093	jxXneZK4hEWwakUY6zG48qgrbmMUxUcedpNGXCgmrgR1zbz3tRo	13058	18371	18371	1619245980000
26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	1406	1393	507	12463	18098	jwo6FhFznpoygpKmRhxcu7k8b4LievxfxSEEuREDcBod2DzzAA1	13063	18376	18376	1619246880000
26405	3NLvJ4wTmsn8PcPjNcTnCi7XVguR7QCrRcejodf7zLpjCpHKS1Pt	26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	1536	1313	507	12463	18101	jw7r4Ei5e5uLB54saW6wsZVR5tkV7GRd7a2oQf5EQRy1yBTWibV	13064	18377	18377	1619247060000
26407	3NLQhsePyDA43UKGYgr38ZQq7bYRa8kUPjZzkSQHY5qHyQCfoa5w	26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	1405	875	507	12463	18103	jxE2y4viFwfJd4JGR5rS1Aj2FDsuigb6FW3gKyxxTRfiy4XmPx6	13065	18379	18379	1619247420000
26409	3NKdoCDz3a5KH1V3kQ97Ei571jTd8eN34bCBsPjhGe7PBV3yg32j	26225	3NKGdU2FtivFq9nC3MPU6QwEonsH4WrsL5sngvKK7TEA6tbLmewu	1617	1288	499	12463	18105	jxA57u3qrtXdjv7fdocwBQXsBsFRusgHn2YX3heXK6rjVePn14F	12853	18379	18379	1619247420000
26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	1637	815	507	12463	18107	jwJH6vVm3PAgBTB5MUnnFcTfTZrnox1gYo2KHjDGYb4VsYKi5s4	13066	18380	18380	1619247600000
26415	3NLVxng6RV6eKWMMRZwPomFF1SvhqghbzjhKSgh5ZDjDyprymzpG	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1610	1068	507	12463	18111	jwhnnyBsscdDEVX82YHa7Rcrbuq887gPLAYs8W2NNk8inZvEHQC	13068	18386	18386	1619248680000
26420	3NKC1K3LquAKN8HrAsJ6fW7YzMjGPWzMqdQt32y5bgg7h1jxyN2J	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1534	1191	507	12463	18116	jwBSKRFMcjuJBZQMqixtFrcJ2sA6VNX7ykTRAGV28qG9HLMu6uN	13072	18391	18391	1619249580000
26424	3NKBQANwVgGXFZsV4jvH9qTf6tEdCw9dzPmKjNx4P9kCvWBnzvTn	26358	3NK9e6FZuCQeJi3DZVr5HmntowsDRaBANTrREd9qJ1jwTJYQLQot	1534	1191	501	12463	18120	jxujLauXSkwtN2jVB1Vd986TNCB1E7aGdYWNyq1LYfhUK4xAeBn	12928	18391	18391	1619249580000
26427	3NLejkG7TRuha19e88UdmmzxQf9UqK5Y5vURdFvHmiCASKCVkRYu	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1406	1393	507	12463	18123	jwd44XF2JA1UC2wk3epCBRXjZdLdavApyu5TbTbpz63mHk1fuvf	13074	18393	18393	1619249940000
26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	26430	3NKtmnH889QMHg66wTXb3pqRWbF93UW4ei4ppTYFMb5hgw5AP5PK	1655	682	507	12463	18127	jxJmXrxLoA1AHwG4PcBxGbgLtFu4Cfge26tEA6Cz1CSHKpfTMLU	13076	18395	18395	1619250300000
26434	3NKCoAT5wHacPztkhaXZUP1f5Wa6fWBGK9pqiGnHpxCnhiVerM5G	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000
26438	3NLVcd4ouxexedZhTQV6pvDZhaU6oKJJzVL5XVausNCWSS8CVQgo	26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	1547	1132	508	12463	18131	jxaBVpvLUrUyQAiKioM5i9aZf5wQ9QKPEv3r6asCbvTEvrrSaXy	13079	18400	18400	1619251200000
26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	1613	1349	508	12463	18134	jwUB2JZ4rTQzv2YqzZ8Zr4PKq38rCZFgbzCD9HpPThbxTQSYb9j	13080	18401	18401	1619251380000
26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	1402	882	505	12463	18045	jxHotzEcP4JMC2VnQDw1hexoePVrWdMmFJvgCatece6otyCzaep	13027	18326	18326	1619237880000
26345	3NKzWqis4fQCTyoHKN2nDKpofWFCKnRMDZK8QzsTsZ7w3pibXjhx	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1624	1208	505	12463	18048	jwS9qpXQfCjoZoWLYET9KzvCzse5FCFL1ekf8UnayhAxA8mPfhH	13028	18327	18327	1619238060000
26347	3NLg5xn4keT1HaRMqWwe9XXbJpRdNBdrXY2BSZ5Y6bKwTnSjRvqF	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1624	1208	505	12463	18048	jx9vACSap4nvx9uXE2xNFJ2nkjjFQyUTBoo7Y68q9F8TtbhTFeG	13028	18327	18327	1619238060000
26352	3NKwELwGhdwNpRrWVoa7sK4vw845amQALZNbcWWBaGsosQ61f2B8	26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	1765	872	505	12463	18053	jwNWYx8TK2pU2UVS7ZD41Gg4Y4HZ8XMJ7dGtRHVLm7rQrtRPqsg	13030	18331	18331	1619238780000
26354	3NLZ1xyPcwTasBFdKttnCHpTvGTCENokVjXthQJTJjDJv1bpFn1M	26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	1506	1127	505	12463	18054	jxwo3eSZLGGRdB9Pk4MtTd8LJf6hmk5VGdxTaiNvxUa7K8UFTxY	13031	18332	18332	1619238960000
26357	3NL64THRBojAmPYPhYbdMx93e35ewjcE9tZ6a9jiJgvPguaiBMhn	26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	1534	1071	505	12463	18057	jwPZG9Mfr8TLwvuCcCzPe4cpzc1kDTHQxTW8V6WKEUiapNBzCV8	13033	18336	18336	1619239680000
26359	3NLJqv81J8ejoeBE61r4qEfgKtLjurJWvu17Xq7Ce9GnA1h81E7m	26356	3NKt7q27LGa9jSApy5K6Yv7ZWvv1FUjPGd2ciybtjxYpEwf1srYg	1406	1393	505	12463	18059	jwzaj3UV4DrurJKJLCxQ56a21B2J9JTp85MMBwynTmuVLfEzEdN	13034	18337	18337	1619239860000
26364	3NK3fHzmmqsGbhbMfR2JCsXZfRPizuDjJvxVkHgcVwirqNhGv1yK	26363	3NLCrM2m9mhNtGFUSxePj5kYDTZbjDQFx8pDCmiHZz9rEEZjyg1t	1508	1387	505	12463	18064	jwdzZgGrhbKt98HF8zVdtKkE9jhfQiL9Y2Wkac8cNKdqfcXzbG8	13038	18341	18341	1619240580000
26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	26366	3NLUteRH1dBDWrhGRvhmEv6GFpKDUbKxrbPYvQUZm4ZvqdhpcCyR	1406	1393	506	12463	18067	jxpRuXcpVZN4QhR9DA5z7CZePZTYVkFn5Mq8q9ZBiDUw9dY8CEB	13041	18346	18346	1619241480000
26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	26368	3NLZUA2ycjW8Jj6LWvCSa8seonhUwwWKnS9LaKs7kEVTRv2iFdtA	1439	1033	506	12463	18069	jx9WLzyJdAbfRmz58BxVfsVj6S1dpBTYzU8rYdTYCBRhK9qSxuH	13043	18349	18349	1619242020000
26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	1467	1010	506	12463	18074	jxtbtxEqcKUxB6gdRaAhieVi5kVzdBdeir1RdQV3L7chbGJyR1u	13046	18354	18354	1619242920000
26380	3NKWzvu71Uawdp42XqHKd3gubGSBpDTbaE4hDVTofvH3hrmP7Sgj	26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	80	1273	506	12463	18079	jwceVvJY5T5w3CkaK45NfADDD7gf8Y6diTQxF8SiJdkPkgZ2qfP	13048	18356	18356	1619243280000
26383	3NL8DCVo38zutccbnrCpQ5cuxAucRUuGdvubqixWYRS6AbQvf2S2	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jx8DZywWWxnEovEjcGHvbFz79pPeLXwTRaHzzUeeap5mfzDUgTA	13049	18357	18357	1619243460000
26386	3NLfY8EmCoZTqKNq7ciandgvMuWJqDqXafbSTNeReLZpxAPGAYvj	26381	3NKbUWvqFsPo1neobEZSyuduJYAF4tNH2EmVDNcs8yahR1zV4HJg	1613	1103	506	12463	18083	jw8h7vGU5dkheVxsMnb5KyCH1z3tcRdyJbixbSWj6dPYhaQuUsB	13050	18358	18358	1619243640000
26390	3NLeTJ17fUc7D2MujHPXxvpGjHz8jXfLzwTbi1Ukc9RE3y4DcjKX	26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	1407	1395	506	12463	18087	jx87tN2PG91T7tGzGBgBLLe9TKW3KGodZUKfxHcYaPPKLhLoThp	13054	18365	18365	1619244900000
26393	3NKPJyV5wKTUhFu4gsG755zQUdLjtPA3FDyPTo1WxebSrKSPkNnm	26390	3NLeTJ17fUc7D2MujHPXxvpGjHz8jXfLzwTbi1Ukc9RE3y4DcjKX	1501	1360	506	12463	18090	jxSC3sMBNaJt5NusbhyLDXRJRQLcBmq7c47nZm3XyHfzjvNDFSR	13055	18367	18367	1619245260000
26396	3NL9ytEm3t6JmZSLudb97ex4BLjnmEiPRRtNdPJGWqh7zKzqZTCz	26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	1546	1339	506	12463	18093	jxXneZK4hEWwakUY6zG48qgrbmMUxUcedpNGXCgmrgR1zbz3tRo	13058	18371	18371	1619245980000
26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	1516	1048	507	12463	18094	jw8ody5jiiDHamu6kQ1FHKAknv5nFjtM5gMuuCgpZvazX7GbfHX	13059	18372	18372	1619246160000
26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	26400	3NK3EBgtFWBSadCHKvZ6oYMoyZdG51zVmdeqfdFQzaT7z17VeN9b	1637	816	507	12463	18097	jwkzTjzwen6ew7LLVT1X6bXaMhhMSPDnu8259c6rvo1f7CUZwdK	13062	18375	18375	1619246700000
26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	1623	839	507	12463	18104	jxBH3HxRjNDkhsw3uuUpnYVHQffRYh2QjoTDKgsPuTehK7KxL6k	13065	18379	18379	1619247420000
26410	3NKWGCLCRUZN1cLZJ2yG31P1Bw8keeKJnFiWJwcqswD6yZ86JhT1	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	1407	1395	507	12463	18106	jwLQsmiGjX9Wba4p238NWQQvHcUQ3gg5Yi3pJvyX1AtHMo5vDQC	13066	18380	18380	1619247600000
26416	3NKgKLAeMdVkC2uv5zXNX2suV9Uq796RvoErWLpWi2pTRuEs91KN	26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	418	418	507	12463	18112	jwpEKnkLzTP9FMw5ECA99uqXP9uA8dEiJ28Q3KobhYQCwNDXHiz	13069	18387	18387	1619248860000
26418	3NLDAd5SdWipdjv6kwSFhWTHsfURpaKgDH2JtfndwB8PGUDgS1NF	26416	3NKgKLAeMdVkC2uv5zXNX2suV9Uq796RvoErWLpWi2pTRuEs91KN	1406	1393	507	12463	18114	jxuNSERrbHNJWcFPYLJ4ob465yp7dsWUn7HPSAn2soyXy7oTUbJ	13070	18388	18388	1619249040000
26422	3NLGfyuaxTPjArPdBGYhPuFqVpXDGwKJYkCAhr6dreTXucs1dQ4D	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1471	1386	507	12463	18118	jwLmqwdYUZnkF2qjrq9uq9sSB65AfdUc4qgvsaBopnTZogC7NG9	13072	18391	18391	1619249580000
26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	26420	3NKC1K3LquAKN8HrAsJ6fW7YzMjGPWzMqdQt32y5bgg7h1jxyN2J	311	1307	507	12463	18121	jwxJ7JrntE6D9kpNJngykrqNaBavav2K4b4xdGZEwuLCuo474EP	13073	18392	18392	1619249760000
26430	3NKtmnH889QMHg66wTXb3pqRWbF93UW4ei4ppTYFMb5hgw5AP5PK	26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	1407	1395	507	12463	18126	jy379dEaaJzYVHoaLkdKhh87yC3z9WhG1NELsCJh7BN3LZekXu7	13075	18394	18394	1619250120000
26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	1406	1393	508	12463	18132	jxtsDCqK5YXuJpbATnymTUZCH39A6Q5JgeNgkS2f4qMe9EardJm	13079	18400	18400	1619251200000
26442	3NL2KeHCHMPXRMB4hZy8aPLbki85kXXhfS9SajNgqXbkX5bsaPdJ	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	1637	816	508	12463	18135	jw7be3xLh3KrzxJYmRjQe7v4boX3sZfatrSrPmw8BsxftqmfHAW	13081	18403	18403	1619251740000
26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	1588	1146	508	12463	18139	jwM21m8xxo44JHyAQsPX2vH3ME6bMYPQDWmshfLYfFDcUVx22ka	13082	18404	18404	1619251920000
26457	3NLuvcAuE96b92A2zSPCLzStdS6VajyXYmm19SUwUL4qAj31Fb7y	26456	3NKaGF5ZKXCtSzcjRNmMD96FyDb9bchAJfRLjp5erwrxo6jpbyBL	1553	776	508	12463	18149	jxDB9gjSmaeL1MjgUKvbAHtWhCNdxy6YcaKToRMc34fsofyvi9p	13086	18408	18408	1619252640000
26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	26458	3NLvTE7vn3EnprmXANQibqa49dBRoMr9DoQdwbGj3dEYgAdNL3P7	1656	1343	508	12463	18152	jx5hFSuRooZAULH5SvFkTfa87tMj2GTEKNwZJhcwicxV6BcY8Lp	13088	18411	18411	1619253180000
26463	3NKQbQheRXeFiBgaVCvpxT1u9eUywEUsoWxXptVWz6yL3wXLzdoy	26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	1623	839	508	12463	18155	jxY5QgjFyenAJsYdS5kUF6hoo58NWaB1CCRdiU5MiUs1C3FQYMa	13089	18413	18413	1619253540000
26365	3NLB6vV56iDL4u8xbcHU7X6KpXpeNND49Bwk7YbzdaCzwu4GzfNg	26364	3NK3fHzmmqsGbhbMfR2JCsXZfRPizuDjJvxVkHgcVwirqNhGv1yK	1407	1395	505	12463	18065	jxWU7mAp5UCrYMjjBErYQeWE8xiJ8ATvX2YmXAjnTFyqoNqeSPN	13039	18343	18343	1619240940000
26368	3NLZUA2ycjW8Jj6LWvCSa8seonhUwwWKnS9LaKs7kEVTRv2iFdtA	26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	1619	1275	506	12463	18068	jx8GLJYdk3Xvr5GDh5rzssykMtxYR6C5Cv3esRwgrdD3piQuhRQ	13042	18348	18348	1619241840000
26376	3NKUxhWiz14amt6qc86crVthwGWv2ki1S8qwvAM4U1qyuFhvP3Dz	26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	1622	1230	506	12463	18075	jxNoRyHigMcKM4SgyTPDf2NbtWssrQajQbsuxskiT8SjgG9BYZP	13046	18354	18354	1619242920000
26378	3NKLxFvskjfFCFmhsNcCJYtL5SuZXCZjS62cbbr9JeV4VfJ7Gpfs	26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	1631	794	506	12463	18077	jx6BRu6Mn64DcbfR5XG9RujGCjnc3iqg1vzZrqkHEUydGJFeNof	13047	18355	18355	1619243100000
26384	3NKvXn2LsWPty8Yv3SXUhaXNEwEgaGqXza1cy6mE3pwH9FqrYfLb	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jxv375xXYjKqZ6b7skjNK6ShENkL79eiPXQqX6jXHqVPoC3nTnG	13049	18357	18357	1619243460000
26387	3NKYzaL5Hd9DtirMq6wGYsFG1WEcCVTZB4JEn8P2wY84MZZprveA	26386	3NLfY8EmCoZTqKNq7ciandgvMuWJqDqXafbSTNeReLZpxAPGAYvj	1642	1241	506	12463	18084	jxioZoKkqW4ttdEJaJwuFZA6jmgESiQ55mpYangc87mjmayfdDu	13051	18359	18359	1619243820000
26391	3NKkdBRNkMAT6AenaxpCUEoZexScQsS9d2XGLrRrcwKHeh2DakgP	26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	1602	1369	506	12463	18088	jwmwmb9eB28ZFPseB38eVqqFpVQ8udUe4S3r4cDhxXtAZu5isTf	13054	18365	18365	1619244900000
26399	3NL4uV1fLXuCaYKe9Nkz3GjXsMzjJGP5pmP8tjD12diyGotVXNjh	26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	311	1307	507	12463	18095	jxLokazfkQwWcH8AYVGTmXaizXVdG6hGwhyYykZtvKwW2QmuiUu	13060	18373	18373	1619246340000
26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	1422	971	507	12463	18100	jwyaLFzJiKyCd4dpVJgybTJETXCNhvr9gTzuQ3V8xaE5f1CXkRe	13064	18377	18377	1619247060000
26406	3NKPHJZAAAZYUxH9jtRDVgWhkcrU36Y9uhzHNgE8fDuJxoWfcYoH	26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	1648	1284	507	12463	18102	jwdkqWsUsrszWnaiVbcbDiowVEs4HAg6AV6FnkJk72FZu8bNT9v	13059	18378	18378	1619247240000
26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	1623	829	507	12463	18109	jwG6xVUnpiMaSC4UtsW4bWzbtbQG7aUm5WbHQtqwrzU5GBrbnHE	13067	18381	18381	1619247780000
26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1476	1371	507	12463	18110	jwxz9W1fNhf4r8aruBHgfdCBRsLrpB8jTnCHPyKfWuHSnUuvP8U	13068	18386	18386	1619248680000
26417	3NLvsU9dnTN2WCKixBRoh68ej53xEDbKJMZ3mHpY2oqWisbceCTj	26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	1643	1299	507	12463	18113	jxhFoufZQpk977A5umiAj4rjbexanDFUr6RYaLvJwZvA57F2Ssb	13069	18387	18387	1619248860000
26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	26418	3NLDAd5SdWipdjv6kwSFhWTHsfURpaKgDH2JtfndwB8PGUDgS1NF	1406	1393	507	12463	18115	jwX1CmxL9pMCDH3KL6NnBCRbnC8CHhqdffvpBP3wpVeDbhtnJJf	13071	18390	18390	1619249400000
26423	3NKzcBrPMaWsQXiuJT9XwMYaptVpS3sMfyZr5fZsDiZA5G7qWtRn	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	606	929	507	12463	18119	jwJ6BNoCHv8PaYxGLf8bwCdo3sS94aUGY9BV27NqdQSmkKWxbhR	13072	18391	18391	1619249580000
26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1501	1360	507	12463	18122	jwax4t7hmuwtgvC5VvNME1bPaLVNcrGWC9jJEae9zxM16Tet61X	13074	18393	18393	1619249940000
26428	3NKvrcZAmYvSMSC7gcb4tP3S4nei2FseKBtKzUY4EzaUZtWZQ2S5	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1631	793	507	12463	18124	jw7vAdjzaoakPU2bUrpPLDxdCVXh4faWaJ351MAeqyoJfFM4A4K	13074	18393	18393	1619249940000
26433	3NKmySfd4PegLWoxGpiMqhTs1VeS9d47VZPm1kQ2pZZBZhxVpQmP	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000
26435	3NKjVfHBBE8kQ5bP4BozyrwtTRci6jekkpnvaex1pDifCfHiF1Ab	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000
26440	3NKATvak41hxUGaUmvvzEUtGumTpHjihENyivqC7ZyQRoyW7fNPn	26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	1407	1395	508	12463	18133	jwMQgZHmw37zfVHKqzmNM76PB4ut5soySrByg3j83D7GaUcUfxN	13080	18401	18401	1619251380000
26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	1553	776	508	12463	18136	jwuYvtPE4QjHeycaQvRxpjpcnPEsdkXyU7pwMK7w3Je9EFPB66c	13081	18403	18403	1619251740000
26447	3NLAYUGoR91s1zvptRrZK82U8Ybpca6d3pCT6tCLcZHaZUYWzcy6	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	1637	815	508	12463	18140	jxFbmhHr9y1rnPctPhkMR9Ku6HsXntvRR5hm7Wf89sffJKRoq8z	13082	18404	18404	1619251920000
26451	3NLqCUnmbhMN1kNtoBZfKFKiRjJPhqpvAQEYeiGT3PheuvWaEeQi	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1646	1354	508	12463	18143	jwp138XmryoMdnDLkAKhRcfDo1ycf8AeqyjuJvA9s2QRyQtnfN9	13083	18405	18405	1619252100000
26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	26451	3NLqCUnmbhMN1kNtoBZfKFKiRjJPhqpvAQEYeiGT3PheuvWaEeQi	1407	1395	508	12463	18145	jwD6LGzAHFBu9udFDYZxEvFFCTigQSuPTtVVNUpaVoPxqdEuW6y	13084	18406	18406	1619252280000
26456	3NKaGF5ZKXCtSzcjRNmMD96FyDb9bchAJfRLjp5erwrxo6jpbyBL	26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	1516	479	508	12463	18148	jwsvb4EGrgtrvZTDCj6ghqYx1buEBBXW32QjXQfUwTSw1xAkXKE	13085	18407	18407	1619252460000
26458	3NLvTE7vn3EnprmXANQibqa49dBRoMr9DoQdwbGj3dEYgAdNL3P7	26457	3NLuvcAuE96b92A2zSPCLzStdS6VajyXYmm19SUwUL4qAj31Fb7y	1657	1218	508	12463	18150	jxDo88bCvPWDQiaF1ZFeX5bE3rs97X5r6yYEqS8wFFxp9PtEitz	13087	18410	18410	1619253000000
26466	3NKMztx6QqNHqaZXz1FsRZM5giq9nz8L83uBbA9TTXUFPUYm7xrk	26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	641	1210	508	12463	18158	jwytrweWBGVqkfMJp8JbKxf3ggWCdeXHJ36jkcQ7TSM9dLGDpdq	13091	18415	18415	1619253900000
26468	3NKVY3Lu5HWTQcTojYSXyQm5AJu4vpeM9VS1XocAMaRxTQThGFbV	26343	3NK7udsrdgH5ggBspVzW1DhowSE3XGFoqW1eCo9YpcA4smvsfAtP	641	1210	505	12463	18160	jx11d4g4tN4A7oZyddRHSSX1KbfCDGQfqm6LTDAtFf7Yr9gpNmv	13028	18415	18415	1619253900000
26476	3NKQr5oKjkD3hKzNAL2MJBK4SVJp1qZa72wqa5xQRGWdpDVhbFpZ	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1447	1345	508	12463	18167	jx1e1MrVvim1AtZjMdNc5Wu8Nw4rqTZFEVLiTGHAj8FDuebSUbj	13095	18421	18421	1619254980000
26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	26474	3NK46mgb3wZHekjtsyDucdYAdiicywpiUjuCk4Vth2VQ7PDfKxYG	1553	776	508	12463	18168	jxNW9etuf1pbdhpgkUViShU3beCFzGaDk24XWcUxYPFRfs7Md4T	13096	18422	18422	1619255160000
26485	3NL5LaKG6We5cMoV43UFqC9EeDBZgQ8JAqdCc7dvCjdgXvExY81o	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1406	1393	509	12463	18175	jxS64yV5UreY2NuDFcn1wBqQoydi29xoGNC9yBBYBmYK8KrqsRc	13099	18425	18425	1619255700000
26486	3NKbehCTHtbBkcu1wrFHEWgeMopP5aN4FTmSNUynUdTzxDtEtXLJ	26485	3NL5LaKG6We5cMoV43UFqC9EeDBZgQ8JAqdCc7dvCjdgXvExY81o	1406	1393	509	12463	18176	jwSZXMNbJZhJjS849NvFrUKjAY4icRY2yxy98UWpvB4XcPtmoac	13100	18426	18426	1619255880000
26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	1444	1381	508	12463	18130	jwCfEorMjtZxHECTZkmDdh9K5okrsaq9ohzNPr3jfP2r61knq9o	13078	18399	18399	1619251020000
26444	3NLYfmehkuZv6JJMQ2vsqueG5pL9WHmPT45tF3GrL8P7ng8xdLVx	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	55	463	508	12463	18137	jxnm8dHwsh4XGmWc4i4KQHfSm5gq195efRSdUygYzFtS2kQVjBW	13081	18403	18403	1619251740000
26448	3NKaiZGbRJLaG5FaVc5KspXRz2TQcEtzbFA551a4SDTJNMicogyR	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	684	1106	508	12463	18141	jwdpgjFAR4HcJ1sas5A9NR7g8bFLWRA9LV7J7Q236omX2wtYjFA	13082	18404	18404	1619251920000
26450	3NLk3R174uLQp9SJe5J6Vu5hvKWP8oJ38DeszWapX4nR13v9MvGP	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1467	1376	508	12463	18142	jwa7VQZhuMphAHfXU76TGSfxkPTb1sJvUAvbPKiv7Bq5frR8j4t	13083	18405	18405	1619252100000
26455	3NLsm8LVSebP3ya3ouvczK2DG7FZ6JSKep69yZ7SKUvswKzSH6cw	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1402	906	507	12463	18147	jxXxmCVkF3HwgKUmHH2S5BuXywdqzkejpptYefcJdtYY65e7nkL	13068	18407	18407	1619252460000
26459	3NKvTunpsUJ9SeNbRuV8KvZ8j2oBjCPGCevUhx9a2pTxmPryGv2J	26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	1468	147	507	12463	18151	jwvuZ9XvE5qKynYet6X361rKSTPjMWcBLxy7TctQDj9VhFuHVmN	13060	18410	18410	1619253000000
26462	3NKjxudFAqYX6vPhWmUyohEjDgutqbP8rVgywLUTnRC9yesmtGYh	26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	684	1352	508	12463	18154	jy2jNrqJaVeQ2WWyXQfdScYXYNe6geXHDQPYRkFxA7z7T8FWJoU	13089	18413	18413	1619253540000
26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	26462	3NKjxudFAqYX6vPhWmUyohEjDgutqbP8rVgywLUTnRC9yesmtGYh	369	1312	508	12463	18156	jxZ22Km3u1nxs5f4CrmzixyW851DkNyxYu8c1Se2TqTvpZUfyEX	13090	18414	18414	1619253720000
26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	1654	1214	508	12463	18161	jxA294oqhdHyhuTjP5wj3Py8pferAvHYB5nh8uJWmCVSBWMv5hN	13092	18417	18417	1619254260000
26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	1448	1185	508	12463	18163	jwqoMX98LaBwg7dEwCpiEiHKVREwKm5Rk5PjYsaMSHvTgHK45hP	13093	18418	18418	1619254440000
26479	3NKCrrDfEkBQNYsmkGEtpV1DUy4FNFhnPGcbQGGKKPy9Yzw434LL	26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	484	1073	509	12463	18170	jxXrKkAibHT3T2f3m2wjphaXsomGHWyoww9YL8e1dsPqUfUAmgS	13097	18423	18423	1619255340000
26481	3NLySyguphKZRaLak1569QZtHmVKWF7zmGDMGz7hHRwpYUYr4sWR	26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	1553	775	509	12463	18172	jwGbSze1B656Crr1fN8EvqWpXAMrQYbFoDtAmvkj19VEAkqoFAy	13098	18424	18424	1619255520000
26493	3NKYiuSjS61UxC6d6bURBPYkbxbT57kXFQV6Y6uqGh1LfWvmrtpS	26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	1460	440	509	12463	18183	jwgakUwLCNNMecwgh8ZWZLnys5mvMuzG4hoy1bpqR3KFG6TephG	13105	18432	18432	1619256960000
26498	3NLGN8h859BFyMgZB6YNVgU5Z5nauxidMQu4aaJ9W8jSKwdkdFjX	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1631	794	509	12463	18188	jxY6adksdEBs2DzyMZSp8aAPBGUj7xFNNLNyedncBi8EMg888iv	13107	18436	18436	1619257680000
26501	3NL3uJdF2t7DKLKi5tFaA8K28UodpMFFQFHcmMCuD6XwonMdVyBg	26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	1490	1028	509	12463	18191	jxhkhw3ue9ts5t9SqvGLjqATHEXav5RMca86U1tYBemR57VNsxR	13110	18441	18441	1619258580000
26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	26501	3NL3uJdF2t7DKLKi5tFaA8K28UodpMFFQFHcmMCuD6XwonMdVyBg	1643	933	509	12463	18193	jxwPwmmdmwmuiJhRdckv8sW4j53bUVFeYMbFNa9mGBYHNCqHUj9	13111	18442	18442	1619258760000
26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	26507	3NLZUZqJyhwjzSnhuxgWPAYrRv6ktZR4FUduspbz9arNSv6zDwDF	1501	1114	509	12463	18198	jwXr1UotnH2ec9AtjM9aAz4HJCLXk3GDxgeFsKYmTppUWUG8bZd	13115	18446	18446	1619259480000
26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	1444	1255	510	12463	18203	jx3s1UorJoCTdXxaP6Paovh3SvpQiCnyo4eUErTBCAJtV2XvGUX	13117	18451	18451	1619260380000
26516	3NLQhAKkQWZj23wpFcsSAoak5FpBFChSGmwhQXbsTz2EjePX7Ag7	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1406	1393	510	12463	18206	jwFrntBHUUcK6WM23BQbksNVdGEEUDw2w4gMxCWxi1we8NX6TbY	13119	18453	18453	1619260740000
26521	3NKABPH9ZDECBDh7prC1s225rNZk4KyeNgrBakD6FtuVAsrVBDTh	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1451	926	510	12463	18211	jxir9p83ctn2jqWN4EzHZjHx7NiyD42uB8Zt7NPhhFkmfoytfNg	13121	18455	18455	1619261100000
26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	26526	3NKxk4k8hmUms7o8sG5hPHnZoUKLRZnAp7xK2qnB3tHu9N4QxMmM	1406	1393	510	12463	18216	jwJLsc27ZjdJJLpCQZffb4aY9w9LYPdVeE2vcqSyDB5m4LRkoP5	13123	18457	18457	1619261460000
26532	3NLnXZCM1dT6AKsVecvLtncYKzjLQCfYcX3tmdBvLgYuQU3LUfbq	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1654	1340	510	12463	18221	jwCsMNKS6EFaU5VESLzr7pkpvaoPz3t6zJacEPrxrHR1pvEvam8	13124	18463	18463	1619262540000
26536	3NKmqBNMXZWZauffZTjGCbQPNuWtSMJGHMNQ6bHzfaWNGjtqXsUK	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1651	1055	510	12463	18224	jwLj2woUD47TrcVEi966CKWVTFpMyUurxo4GvyifBgHkmvAVYk2	13127	18463	18463	1619262540000
26537	3NLvsCBzYHgPNdJfiwbHijXpjoUNYdkj3dyX1UE1kp1oahhdaS6E	26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	42	1361	510	12463	18225	jxYYr1tP2Juk8vHkH9ogmgduh1riCTP5JndZLCza1S3avigayCJ	13128	18465	18465	1619262900000
26539	3NKvio6d9sJGxhXrWXpa64Rwg6gX3HEjESTsGoBf7dqTpHRe8PUX	26538	3NLT3BRbj9jVwoeFB5vSGxCJyRiaHp4RS9fkfQmXekVwHWD54gip	1553	776	510	12463	18227	jy3DZXRaxuwDmQANmhugvZaQsayTBi8hUZti5X16LgYHpxmqejG	13129	18466	18466	1619263080000
26545	3NLY1FXfahBGP4KV1wK6EtTUiWSkrwJWkUbmRiPJBFh7j17TU6ah	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1637	816	510	12463	18233	jxyWyHfDtKVXVMVdmezmaEM1MGFXoVKCnSqT8stRVXWG3ZJHkRd	13132	18471	18471	1619263980000
26548	3NKHL3jiCBkttWm6LdAb2o57TDTHruM87xEkK6FKbkoE1niNjdVg	26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	1588	1266	510	12463	18235	jxJ4FmHJEFtQW9ZDgZMgz2jiyf3tHLn1gSMsUYToiepXqh7UNDT	13134	18475	18475	1619264700000
26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	26549	3NKu6wN3UpXJtS7mkVFdLn9Kr11atYEvU5RH6uokq5Dc5Z96rBex	80	1273	511	12463	18237	jwsNaSb4CSkdVYXCVU74Vy9PgtyuFCHKiZ9KSEHVCU194Um8QVe	13136	18477	18477	1619265060000
26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1407	1395	511	12463	18243	jx1QsqyjAeNBfRLk9NWdPSDDdgH52c14mbhQX3mKZT9iabhNVW4	13140	18483	18483	1619266140000
26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	1407	1395	511	12463	18249	jxLCzjmRbRDCabXCULvswdxcHZ7XGooMecTkG6ddkmfsCac5xtP	13143	18486	18486	1619266680000
26564	3NKszAvbTCxYXmrekj1Uz9MC7WnFU8oE8LKyHGuwh6KJD2FiT1Ew	26455	3NLsm8LVSebP3ya3ouvczK2DG7FZ6JSKep69yZ7SKUvswKzSH6cw	1402	874	508	12463	18251	jwNrG2ADouwbcGHU12RYjYHYefw3rjbxhJZktWVKe7gHf9voeD7	13069	18486	18486	1619266680000
26574	3NKTqCWzeAPGwYJWMjrpdUhphaA5vkeVzZCUetHZ7fKuc8gojVs5	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1590	198	511	12463	18261	jwFk9UeM6sqcfNFfXwgcimfJ5GnZAhZfY7RoqG9Epniae8RB6Rc	13138	18493	18493	1619267940000
26445	3NKpKS7B38hCHKQCcq32nZUxiaZYZmcxQQ6hmod15uGgx5gL1fy5	26428	3NKvrcZAmYvSMSC7gcb4tP3S4nei2FseKBtKzUY4EzaUZtWZQ2S5	684	1106	507	12463	18138	jxCSe7HqSTTha5WaWzNFnS8Dvdtd3SMUdYTpz1VGJXR9rTNPWix	13075	18404	18404	1619251920000
26449	3NL6iMmavYwJrrkmkvnbrkan3xjseTVLYeMzcjTrZdCBqsdGitQB	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	684	1106	508	12463	18141	jxXbZ3EVQPqoqK9DQeagJTBesrYMTLbcwcJDqppwcDNdfC239KF	13082	18404	18404	1619251920000
26452	3NK9mzVP8ycsNJGHE6d2iHQmnZdBJnp1UsDhq1vET5fNa5iX5Tip	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1765	871	508	12463	18144	jx8gzKikusGYZi6Z59zSV7ViNXBWZ2NRiL5ASpCM2zDVitZkgez	13083	18405	18405	1619252100000
26454	3NL4dAwLwZvRpQKofvAnHsh7Q69aPFDnSKHghoj7vWXh8ChJVrQS	26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	1637	816	508	12463	18146	jxeJGznYzLMfZXCTgteZp6kXG5GAtewrLPBNPdFdh9FaRvUPbZP	13085	18407	18407	1619252460000
26461	3NLDswjAY5RdMksty9sKzcgaafooMxNPriZ5RCKAv8jMJMusLSnX	26445	3NKpKS7B38hCHKQCcq32nZUxiaZYZmcxQQ6hmod15uGgx5gL1fy5	684	1352	507	12463	18153	jw7T9eAFBWbwmqscCvMhE9ib4ojCbYbo6Pb23E5HaTTSySDxYBu	13076	18413	18413	1619253540000
26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	1460	1078	508	12463	18164	jwr1zFQYvY9r7PLGomDD41QGfGvuZjti4GVB4tmxz22Gr5sKtoK	13094	18420	18420	1619254800000
26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	1675	976	509	12463	18169	jwbRJGrfWom5gvYG1kLpKeRGETr2KREtRCG2or8MLEYHtB5e1hM	13097	18423	18423	1619255340000
26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	1637	816	509	12463	18171	jwFCpfn2ycYcEPxGpkU3kuCtmmYZczZSPo7m49Vpqq5rT8sBEtk	13098	18424	18424	1619255520000
26482	3NK6cyMu1uEska6TrkamnTJcgaZ4nF4qRNHdYP2xXSDfGESYJ637	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1671	1119	509	12463	18173	jwbSw8SBe5qaL8VzcKMszWVJJ9mf8YrCcGAJX3RGv1uLMycJWgW	13099	18425	18425	1619255700000
26483	3NK95QcdGTqoFFSrnTH9i5wxbQcWbnMa6uJNDTwEiotN84zZvYe1	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1506	1373	509	12463	18174	jwJPe54MJxR2wXbk1W5PwDngwDNKP3cif8x3ym6JEHQZWbYXQrp	13099	18425	18425	1619255700000
26487	3NKw7SE1D8MeBJLMGhh5UCBsFhYEDWrX6zcYykXgajyokZhY3cnr	26486	3NKbehCTHtbBkcu1wrFHEWgeMopP5aN4FTmSNUynUdTzxDtEtXLJ	311	1181	509	12463	18177	jxMKP1YAsuQebzGRUYXB6DRvBMhYet2jV77ViJcGLdrJz9bChUW	13101	18427	18427	1619256060000
26490	3NKnVcMcNCZx1ZjwnWVFW4okdhS1fBdf2JhE2aJf5nTJJ4BaYSLa	26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	1397	828	509	12463	18180	jwPvjL48boGC13EsHmAhV27e7cmDLNujM4emQR158EEvq4aNdwV	13103	18430	18430	1619256600000
26492	3NKF5ce3C9DTF4XR8cMvKsMhiJPHcPXLo21RuVSK6E5ot342J4oe	26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	1406	1393	509	12463	18182	jwb9sJ5MENZBExFpbmRBYYBtKNzQZG183NhTvh67uNQVUyNYCnB	13105	18432	18432	1619256960000
26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	26492	3NKF5ce3C9DTF4XR8cMvKsMhiJPHcPXLo21RuVSK6E5ot342J4oe	1407	1395	509	12463	18185	jwtZxnQcKb6PJ9grn3EJQd4Dc3RBFUgyq7QptT3kaDbwYt8hes2	13106	18435	18435	1619257500000
26497	3NLw9J3FUb8uBE8URyT6Foj9vdoykewce6B3aAhbKJRdc4oFw42v	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1627	1385	509	12463	18187	jwNnKqqvySzZ9oaATGH4yBpbX8z7z4vWZgBS7dCdCuz7Qmi6jXx	13107	18436	18436	1619257680000
26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	26499	3NLJCCcu59nAjYDpjWzFcMhdLUCXDr4aSFtgjErYGEBRmv4Vn6zH	1406	1393	509	12463	18190	jxu7DvzivC1DhMjjVJHRDRxQ7zKuix2injZy9NBL3xxS79iHLMf	13109	18439	18439	1619258220000
26505	3NKW3MqB9Tf4cYZqazRZ8zx2XLpwk1Nkuqk4akttaUXQeSykF1Rb	26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	1474	1203	509	12463	18195	jxJRTvY3kwGGxfVe6SWpsWk9mCNVqqQNhU15pBmbJcURjZLT6as	13112	18443	18443	1619258940000
26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	1581	778	509	12463	18201	jwVMictsnXmjAW8TmfghrbxHKVn1gtsLSduFg7tX4R5dV4Wnv8T	13116	18449	18449	1619260020000
26520	3NKHsgEfiCBP2NBBccHtDDjPQGJFrWo8Pjreny8wwgWrXDRpyaSF	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1458	957	510	12463	18210	jxCHWkoFizxckDKGbuTUZuSsPE1sCf38FfZTeYmeKrZVCYTSphM	13121	18455	18455	1619261100000
26524	3NLqxBrJc1trjHchnDRgiQH7KNrXfiuJGJhek91UtJm7NbNpPuCk	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1637	816	510	12463	18213	jxTiTYgvJJLq8uqzdfhdbMQG5uS49XHCgYeYvJUeqM16rzFZF1p	13121	18455	18455	1619261100000
26526	3NKxk4k8hmUms7o8sG5hPHnZoUKLRZnAp7xK2qnB3tHu9N4QxMmM	26520	3NKHsgEfiCBP2NBBccHtDDjPQGJFrWo8Pjreny8wwgWrXDRpyaSF	1602	1369	510	12463	18215	jxwoeow7sXWC43HqdVDFMjXw4pWxXtWTNoenGyjxfo7baF7AvFE	13122	18456	18456	1619261280000
26529	3NKdAYLWg53GLnybrGcCDt53s2npWuMLkPWijRZXNptT8MEiFum9	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1507	1034	510	12463	18218	jwSbVQov1KEWgad6RbHSkUDWMKopKv3ubMYYEo1WZdu4GceqjHY	13124	18458	18458	1619261640000
26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	26530	3NL3BwdsQGzewx38A7bY2dKBNQ4b71M3TjNwTshvKWxJMHEVnwMA	1585	1120	510	12463	18220	jxt7PHNYZurYCdkm4SxuQnqVrWqKjv4CagWCthQEJiKCyC4UMTt	13126	18460	18460	1619262000000
26535	3NKKbNx5QqS5p4WYnYe4M9x953x3e7cYfBZKB3L4cZX2WP5wjX99	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1651	1055	510	12463	18224	jxWtQsAKXq61fLJVsAk3Gu2hAYj5vGfGYuNWe72wjsS4hjEQ8jN	13127	18463	18463	1619262540000
26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	1581	778	510	12463	18230	jwAu1FPne6tLiMw3Wq9nZX3XGKC9NwRou4au2G1E4cLwxRbMeGT	13131	18470	18470	1619263800000
26547	3NL4Vmt22P4MFGisfgp6hG3vpyQcuYSKpSzefNx67HZGSwqRMswi	26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	1588	1266	510	12463	18235	jxJ4FmHJEFtQW9ZDgZMgz2jiyf3tHLn1gSMsUYToiepXqh7UNDT	13134	18475	18475	1619264700000
26549	3NKu6wN3UpXJtS7mkVFdLn9Kr11atYEvU5RH6uokq5Dc5Z96rBex	26547	3NL4Vmt22P4MFGisfgp6hG3vpyQcuYSKpSzefNx67HZGSwqRMswi	1403	824	511	12463	18236	jxz2ngJgaJiksWTXGsoF8SfeaAgvz2Lp2MWUfwJnBpoP9ciswgT	13135	18476	18476	1619264880000
26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	1471	1386	511	12463	18239	jy1gTFM1VyLBJ3jeC6zJwgKSMHi4DHEAi6MbHG1Ap1y2FGEtFeC	13137	18478	18478	1619265240000
26555	3NKj2ATean9LwBtpL8dMmsGG6HFuW7T6AH7qLyyuDenWFeEtdS2o	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1656	977	511	12463	18242	jwXbreqvAuKRfH6TGDgKdkqrebVVyEVofNNS4jkmxvfuYeCwiJc	13140	18483	18483	1619266140000
26560	3NLPb9YXDZautFyNWRxxWiAfKc6tZDLLdDukrcs3MGWYgr8wtEwN	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1406	1393	511	12463	18247	jxxVQhqQEzRdCy8bCAzrWgjSmQRzZotx4wQDc12P13baR1AbMHH	13141	18484	18484	1619266320000
26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	26565	3NLCzvue3QFykM2SZ3nkkjxAJTF7PXGmV2KNuv1pGBBQDQBVmFsp	1403	31	511	12463	18253	jw9RTxqbuc6Pg8k7kuNZxyuRJggx5xNiMFft5bPFvLCWGg8YGSy	13145	18488	18488	1619267040000
26576	3NLiXmZFpe3J4RYn7iqvoDJoZJBnhX4BrGJPLfjXcqkLqgY8csPJ	26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	1622	1356	511	12463	18263	jxcVKTRSi8Zoqy53KTypJ9zpo4L2xQxxQwp8cmHsXHijZNzKCZq	13150	18496	18496	1619268480000
26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	1406	1393	508	12463	18157	jxEoA4sa7SnqSQ1f4QZaq7bC9BXTokQrxaugGyH1EjqDQ44k5vb	13091	18415	18415	1619253900000
26467	3NKVy6RXjNtRM1npdvJ4uFhZuq7ec3TKGYHBcmZJXXZNPRJCBEwV	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	641	1210	507	12463	18159	jwKajJSGCK4WeXbGfH7YycRZcrRi4xpnnaX9qT88o9Cjkm4rLbo	13066	18415	18415	1619253900000
26470	3NLMLaWxzm5veTvsdi2XeZizL12FHCXibhk33yCSzAYDKjxH67tQ	26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	1407	1395	508	12463	18162	jwPgbSKQvjNq5kwJ2hg3W6RNYTp8fD8z5XGAwEozHGyo8Afp9VC	13092	18417	18417	1619254260000
26472	3NKKY59Je5219KcAWfpfUM1YdycJmeb3ZbRN3nu7u3hZ1ezzC3wj	26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	1448	1185	508	12463	18163	jxzuBk693PMfnu46txcLJqt5upztGSQeLSyKSCC8kLbNcmCwNhp	13093	18418	18418	1619254440000
26474	3NK46mgb3wZHekjtsyDucdYAdiicywpiUjuCk4Vth2VQ7PDfKxYG	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1423	559	508	12463	18165	jxrYupYb69Yr6WjRRCRtX6cQwmfzwkmiPSoVUZ1DttpGFDusKgW	13095	18421	18421	1619254980000
26475	3NL1ynKyStF41XAYFYzQYtXwNygZbcDQhWjr9Z4gzD2pQrcMwjSs	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1407	1395	508	12463	18166	jxPYn1ET5kokViKXXxsjwD3kzMxCdJLh7oBp5KRp4r5mxpnC9cu	13095	18421	18421	1619254980000
26484	3NKGjLmtge1vsgeqFJArHtBPGQBj9HmeAM3eJonWWHe9MnieUJnL	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1506	1373	509	12463	18174	jwwKhirmsMjsLqejqYQ578hwbYoKpb5FNMQbyLw9FoqQ5ZNWMVL	13099	18425	18425	1619255700000
26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	26487	3NKw7SE1D8MeBJLMGhh5UCBsFhYEDWrX6zcYykXgajyokZhY3cnr	1407	1395	509	12463	18178	jxt9tFBrxPD3mXzb9BPiZe1BjvMpLpY6NyoBLFSUQ4ikase34Bq	13102	18428	18428	1619256240000
26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	26490	3NKnVcMcNCZx1ZjwnWVFW4okdhS1fBdf2JhE2aJf5nTJJ4BaYSLa	1407	1395	509	12463	18181	jw6ek2LVgE2iYNqZ2aK1MNrwX7E7dSwvwTaxpiwHSZg1j4PwaXy	13104	18431	18431	1619256780000
26496	3NKTTQRPmsKFr7cdDxXg8Nww1pnrRrf71GugNB9o6gd28VioAriy	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1549	996	509	12463	18186	jwgJHbwmzNHRQAvqusGmAB754khnkEUjQ8fEn8X7g6apyC64S9W	13107	18436	18436	1619257680000
26504	3NK6bc2dH3oAGpxh1hzNnvCLFxEERfRfmagJpMwUytGyhU6jTTQV	26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	1407	1395	509	12463	18194	jwRWnjGtLnxXKV7ZWJrG5g3o4ADPrG1kxvY2QZadfBVx8DYW6LN	13112	18443	18443	1619258940000
26506	3NK45hK5PkVUwQLLyrnnhYMFWV1BVB15r7t5rXtn4UuzUF9JENiJ	26505	3NKW3MqB9Tf4cYZqazRZ8zx2XLpwk1Nkuqk4akttaUXQeSykF1Rb	1508	1141	509	12463	18196	jwE7bBGGb4F9fbUHNaSidtwApDi3VHwE24iPGbkPFxt4x1hWm6e	13113	18444	18444	1619259120000
26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	1467	1010	510	12463	18204	jxipSLZkBdjDianVFTjdPQJiJFKXcZjAMh4Wi1rnpcFggxvJAs2	13118	18452	18452	1619260560000
26517	3NKCZLHviHy4G5LW6a6HsSnpjVJzG3epsrjWvfiLzk6xs6D9TD23	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1581	778	510	12463	18207	jx7euHNT71BBF4nTbXik24u8yzpuAwrtsyNzTrNWVfp7YNZLrSg	13119	18453	18453	1619260740000
26522	3NLcNoBytQN1qabcb9Yfmx49iCwYqYyEddSAE8e7u6DA6oqZx715	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1529	1190	510	12463	18212	jwiERm92vFzH5SqY7w1kyE4ZDJdjP1isKJVT3shGzeGDVnbaS7t	13121	18455	18455	1619261100000
26525	3NLcZ6tyYqvqqPiQuEoSU7AK7M769Y7u6ByDJcYLQacSobGvUYg4	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1643	1173	510	12463	18214	jxfvEMcCoWQR7VTqCrkgYuYXyZsYtk7Xb3vVULdEbm5mBtCwgyN	13121	18455	18455	1619261100000
26530	3NL3BwdsQGzewx38A7bY2dKBNQ4b71M3TjNwTshvKWxJMHEVnwMA	26528	3NKs3tEN5wLP7zTHwcGTv2ugkJu1SV1RksGik8FFPJoLKqtmBMSx	1483	520	510	12463	18219	jwgCUrhSZ77UgnjYpM35Uj6TBhyABAnZmCBbG1jWBMZM2FA1w5L	13125	18459	18459	1619261820000
26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1654	1340	510	12463	18222	jxxcD4BUTKJw5F5c9r5SQG56i1e76qMTZdedP3N5KxCa714XpMo	13127	18463	18463	1619262540000
26538	3NLT3BRbj9jVwoeFB5vSGxCJyRiaHp4RS9fkfQmXekVwHWD54gip	26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	1406	1393	510	12463	18226	jwQfZAVnqBdGKWA8ecG95YBovyg6VEE71LcRnEr4439p4j59cit	13128	18465	18465	1619262900000
26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	26539	3NKvio6d9sJGxhXrWXpa64Rwg6gX3HEjESTsGoBf7dqTpHRe8PUX	1588	1146	510	12463	18228	jxasagDVCPe8n8mkog6o97EAMB1jFQKDdg1qhyYCEYASUHpoQDp	13130	18468	18468	1619263440000
26543	3NKgNw6tBFKWMnZ8hh4bsapnyGWwopvht4NCypVjfEwa1cQ6LPkv	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1501	1114	510	12463	18231	jx8GpBG8wHNRmxeJwYTjaBUpoFeya28vQzjz6jCvp8e9xfgTr5T	13132	18471	18471	1619263980000
26553	3NKZFes7rG3vunMssCp1HAHxtvka5NhMYCNhtsTagXkUHH9yUsxq	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1405	873	511	12463	18240	jxQRVshDzZmXjDtPswTXKPYYEi9fFMcpeUuvATTVBXBteT2F1Pe	13138	18480	18480	1619265600000
26558	3NKSnxZzs7kpvG9qU8PUKtNAHHoDjXE4WNGhjHxEYj1wU7kqMZnB	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1672	1285	511	12463	18245	jxoWSrqNo9LzjYZpj8Rs2YpdotQ4ez6uA5LKEpSCS74z8ekMJoM	13141	18484	18484	1619266320000
26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1589	1040	511	12463	18254	jwaxZLcV8jK3LR863qNoKmzig9i4L9mesT4vtGjALGbyniiU9KR	13146	18489	18489	1619267220000
26568	3NLJopwp6JYw2VzPancCkqLzxVQhe7qFDY5H8uHCqRCCpqLgP8Ty	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1637	816	511	12463	18255	jxTsE3U8Ybx4T1fnPwLJTMt2HZ8Qo2WC77v3UDaCf3jUHHsaWVM	13146	18489	18489	1619267220000
26570	3NL8teiQrx5KoaxPh1N7Wu1WiW3rMkK9Dvz6DsWpVHT8veY2nkAq	26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	1500	1171	511	12463	18257	jxmxnjLYmKo2JiBn8DvXpzgpaTAGfde7QnsSyfdGLhCCAZ2tWCh	13147	18491	18491	1619267580000
26572	3NKS42HLCyCJyMDiNc8KMHcQB4mcrVQu9cjADXD8WH94N8pGLZiZ	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	1406	1393	511	12463	18259	jwJgcGwKYKdXJFtwatRanVpX4ZAEKJGjYm6vWaeNdNgQgEP3L3H	13148	18492	18492	1619267760000
26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	26573	3NK7Xd4DWnULgH93KonMNJ7j932foqVUhnSGB7vADwemfJJAtHeb	1590	198	511	12463	18262	jxcBk9NfCBLFPc4WBAQvNBDZVJQRGKUfoyFusVzxVTsxZooTqqh	13149	18493	18493	1619267940000
26580	3NK5yWc6P1iLuEoepqymQMmpDmULbjy8FsQCcXSQW4LXTZ8oVGkp	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	621	621	507	12463	18267	jwkk1NuAJwaFup8UQ1kwSimeZeYKfXbPiBXb7FzS4EjRWPacZQN	13078	18499	18499	1619269020000
26583	3NLEXgkqWvuooBpQUREh8GoxmuD8yfrLvwgXYXi3ywk98RMn5YoK	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000
26585	3NKKkZArgD5jYvvxehmp9t4bwRXJ1RWxHBEWT4NSbXyv2UymPj74	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jxcCok7W93v8j8PfpWwGtCkg9JQVH5rgWHudLCdvts5t6jBRJAW	13153	18501	18501	1619269380000
26587	3NLTjVibjXn531PLJBGMsJbQMr5HzJ6AeKA9RV92UVk2aixuh7oM	26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	1406	1393	512	12463	18270	jxNC7mnhYZCxqfFsz8EzSpPH65jxDndvMgNSpHjTKBPhanHrs7X	13154	18503	18503	1619269740000
26489	3NKUkWhcmphQXcUnBBJxGcs4tgUyrrJHSdeqeRDSDBpSndLCTL2m	26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	1406	1393	509	12463	18179	jwDy6Kz6rmhf6kXDigBv5a7Xw7VwTqxhS9JqyS3w123Zts6ZRBr	13103	18430	18430	1619256600000
26494	3NLbk6vnEQEaBgk5kSoFngC99uavwBgXbW7Ux8Eptw7PxjKmnms7	26406	3NKPHJZAAAZYUxH9jtRDVgWhkcrU36Y9uhzHNgE8fDuJxoWfcYoH	1648	1158	507	12463	18184	jwRgMJK6qf9zqsXaDMX8YJscAgeFuyjnP9mJXW9UVWdvX6csDXk	13060	18434	18434	1619257320000
26499	3NLJCCcu59nAjYDpjWzFcMhdLUCXDr4aSFtgjErYGEBRmv4Vn6zH	26497	3NLw9J3FUb8uBE8URyT6Foj9vdoykewce6B3aAhbKJRdc4oFw42v	1476	1371	509	12463	18189	jxRJjDij4uVRDfS96XSfcJsuBC6mNHA7UNr85nS5nzkHuJ7Mvkg	13108	18438	18438	1619258040000
26502	3NL5JTDuV3BZm4NydmfdkLYZD2ynUjyX25oR8MP2mFo2EPv1osq6	26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	1634	1085	509	12463	18192	jwryowSUG6urL5koXi7riuKKLzs1qCzQHGc3zLkrLiqJmLmdGEc	13110	18441	18441	1619258580000
26507	3NLZUZqJyhwjzSnhuxgWPAYrRv6ktZR4FUduspbz9arNSv6zDwDF	26506	3NK45hK5PkVUwQLLyrnnhYMFWV1BVB15r7t5rXtn4UuzUF9JENiJ	1483	894	509	12463	18197	jx3xQPhDdqcy6bSwht6ezt7gXbGPWQsWLJQhkACDw1AkziYZmt4	13114	18445	18445	1619259300000
26509	3NKgnT8eZ5uaa6xytyNdNZSuosHoa1bew95V4X5cDZWEUzJJxoqV	26494	3NLbk6vnEQEaBgk5kSoFngC99uavwBgXbW7Ux8Eptw7PxjKmnms7	1648	1038	508	12463	18199	jwbj7cyNzuXfWnGe9Rs7EAp72PMCBBsMygjsiecSe1kKEKbqHMq	13061	18446	18446	1619259480000
26510	3NKPh15AFjhbhVgsAz3M4kZxqqTAxYqrXJc4STJEqHenH3deZjy8	26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	1613	1349	509	12463	18200	jxp2cmhz1sMz94fnjjgSgxwAZVeS7vynTj9Nu5ECmuiufCdiBhV	13116	18449	18449	1619260020000
26512	3NLPciH9fFTPHi5YwnF6cBWYgx6XL4ZPCYxWJ7AvjyNnQi8UZjS1	26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	1631	794	510	12463	18202	jwy49DHFdnqWC66wFPPHk9EX3U9bAVEm86Xk7fJEkcWZJpz1X8Z	13117	18450	18450	1619260200000
26515	3NKQo4b9cgofw9n7heghHucoaUTzSB5N18hh7CEkngtj9Rdw5crg	26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	1553	776	510	12463	18205	jxUFxynpMm1mERCvUZQCDdzwgLSfgZMLer2FzKQHXvVdxuu56eV	13118	18452	18452	1619260560000
26518	3NLTCc89cic43MixgUh5JiioLdjAoYDwCy33AuMz9Dt8NDe1Juv9	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1508	1387	510	12463	18208	jwf6z5TV8dfvnViC9ADR5ryeuGQbfxjzZjav5JXsSivsuZEJ54M	13119	18453	18453	1619260740000
26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	26518	3NLTCc89cic43MixgUh5JiioLdjAoYDwCy33AuMz9Dt8NDe1Juv9	1406	1393	510	12463	18209	jxCtqAkmEn4accf5Q34tBJ1RxbYq9JGEd7W4XjFKdb5jPgGDA8Y	13120	18454	18454	1619260920000
26523	3NKfGWZCWQYEf5BVDANN9UYXdyekiLFhx1soBKwSxszANk4B8fac	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1529	1190	510	12463	18212	jxGPVcmYW9cN4rNYuz3PhZDk6dyW1S9ZW9MxmHV5uHy6K1pYk52	13121	18455	18455	1619261100000
26528	3NKs3tEN5wLP7zTHwcGTv2ugkJu1SV1RksGik8FFPJoLKqtmBMSx	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1565	142	510	12463	18217	jxQBKh8TYLzCuUGsKYXsn4CcerjmwKpjBxzj9Lz6DjcZz6PQZDx	13124	18458	18458	1619261640000
26534	3NKmt3s45fwxKwaTWyRGJKG74tu2wohkFgjsp9dDsnxotKLNVxjp	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1403	782	510	12463	18223	jxvCBjqYauM9ocDtj83nWUsyMvEuYkMyrwrSQrmgySX9HaLCt6g	13127	18463	18463	1619262540000
26541	3NLfyLKrrsKUzMLgPS3266ffs5XCBcoPPDbFXyUGadsqPoRgt9hu	26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	1637	816	510	12463	18229	jxbo4vzQExQHJ3Cu13HjGasE2JpAVH9dmygAZJ5QDyhekQa73xZ	13131	18470	18470	1619263800000
26544	3NLj1c3Bx9LNfnh2RqxQyGLP9dNAmXdnV21qSiePcwQV4wphNVcJ	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1587	1111	510	12463	18232	jxK1dUiPA74BWExKaKiXNA5S4FJBjvRod7giyDUf2J5cj5MNFhw	13132	18471	18471	1619263980000
26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	26544	3NLj1c3Bx9LNfnh2RqxQyGLP9dNAmXdnV21qSiePcwQV4wphNVcJ	1406	1393	510	12463	18234	jx7wKJyFGvb715E2F9jZTTBi3nkbuL8o2zqjKkMqAZmAaZE6Gbp	13133	18474	18474	1619264520000
26551	3NLPSuEwJxrggsBYnjPGwbKygvNcLW1ZqkFBqFv1cPypytjNUmPt	26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	576	1229	511	12463	18238	jxJZxRt3dP2b36D3b4BsobqEfuF5FQC2QJa6rgMKC4V4wdvFRxd	13137	18478	18478	1619265240000
26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	26553	3NKZFes7rG3vunMssCp1HAHxtvka5NhMYCNhtsTagXkUHH9yUsxq	1637	816	511	12463	18241	jwqtmAj7EmXtPaRk1gHeuZ2LR1ngcfLYpFS4TjSEK9JpFWEiV12	13139	18482	18482	1619265960000
26557	3NLTT7pNMnaGPpBwWsqUxQryhKjKEAZirF2XnFh5vrJVjhcZyGEj	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1581	778	511	12463	18244	jwb7otmnbxKCvTa1QoaWySpQJnuWPuXiSJE6Uhy3QanHruRTqDy	13140	18483	18483	1619266140000
26559	3NLvbhQvtYFA7iZ15i3SvKiVk5knqcgfJqTXRwChhgQabYEDbr44	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1587	1357	511	12463	18246	jwDDGJwfjoyFnihMrNgCeuSywop6Em5xfLThbMrTMkwoNvYWMLs	13141	18484	18484	1619266320000
26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	26558	3NKSnxZzs7kpvG9qU8PUKtNAHHoDjXE4WNGhjHxEYj1wU7kqMZnB	1596	1363	511	12463	18248	jwt1RESRAVUkKByQfRTPsCZiGZ86XKLsCdnnxSGBcJXpuDNwpUc	13142	18485	18485	1619266500000
26563	3NL8zv7fNYoeA4oyznAgVJJtdJaM4MtTfXbuzNTKGNQq63iSK6Fj	26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	1652	1315	511	12463	18250	jxz3N6ncRRDGxXo1ZfhQhJ222itTNoBnVWbLAaP1CmssvdPuoPh	13143	18486	18486	1619266680000
26565	3NLCzvue3QFykM2SZ3nkkjxAJTF7PXGmV2KNuv1pGBBQDQBVmFsp	26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	1673	1242	511	12463	18252	jxCs9NHgJvvLSEGsHunfwkqjAMgYsz1MKo8ZmWYunPMdVCDxdSM	13144	18487	18487	1619266860000
26569	3NKr67AcEFn7LJaHERxCPx3P6TDCwdgME3ddhyJiFLgo8GotNV1W	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1613	1349	511	12463	18256	jxtJNeinyeF8PYq5LMLSdTYbAJayeDDVJEtrrDvboNT3StuBs6b	13146	18489	18489	1619267220000
26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	1637	816	511	12463	18258	jxoEvDckfgKaxp2tPQfxfJeHtiQWaSU8aiDBPW9HYmNtLT8rscj	13147	18491	18491	1619267580000
26573	3NK7Xd4DWnULgH93KonMNJ7j932foqVUhnSGB7vADwemfJJAtHeb	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	149	1283	511	12463	18260	jxB76owEDqScTR1qopXypjew5P35vHBpBkygk6Pu7vL1NBmve12	13148	18492	18492	1619267760000
26578	3NLnCzzhWRF6Z4kdKKr9v6jCBd3dyWN9D6d91PKUdNZEjwS5hAkY	26576	3NLiXmZFpe3J4RYn7iqvoDJoZJBnhX4BrGJPLfjXcqkLqgY8csPJ	1509	1074	511	12463	18265	jxfnHafLXjdCJBjStgymNdicZhoRzzv6EYjiSPguVFb7wKwvj9H	13151	18497	18497	1619268660000
26581	3NLshQoXQMwgmSd3gdJ3coYMhNmFAbhPxgUBm816CkFsyqXwcc78	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jxsUBedUSAdndXGz5vrUCT3XyzgqFWqpHcMa12TrKEnVwVaGKvU	13153	18501	18501	1619269380000
26588	3NK6u58DrbZYwYNzggKFuVsgU7Y5jeqjvJxZrm592ATiJ5vaAkAg	26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	1405	849	512	12463	18271	jxE5mpsntyTVJmaMTmnWmNWKhZEifbXtyTof3DnLXV8Vot8Vvh9	13154	18503	18503	1619269740000
26593	3NKKUzMg94MXPXxzoc5vxCXKTpxAWPz6snC9GF3XMaMt3GCLuDpd	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1607	982	512	12463	18276	jwhpfx2gKY61bFBJ2DjgcyATiAS4sdb5bGH24MQMN6XA3XRqUz1	13158	18509	18509	1619270820000
26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	1406	1393	512	12463	18279	jwVWBGxV19N3X2YEQJoZW7RScgyDARCKPnqZMoHd6nzaYwpzmor	13159	18510	18510	1619271000000
26577	3NLNDaxjQtyXAYuDZjNc8BtVunq4bSZTDsYWzTPoCqT9SCdEr2oG	26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	1406	1393	511	12463	18264	jxyD21Tc1mdLEjHaAziMk4G2UTdjs5qyy8g8XCL5ztQFGSjLxeY	13150	18496	18496	1619268480000
26582	3NKqP8PULko4AsqpqUBtc1CnrABH5bBHatH8FMhxrb4EkQQWedN3	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000
26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	26590	3NKxGZkxvDvgMCmRMhhtdLBLLkMuaduhZ3tU2v2rJ6aiN1YfbuWr	1406	1393	512	12463	18274	jwFhRaVRZM59m9yLmenWtZeZrfLXiDwrxibJPy86UMQGcDK821k	13156	18506	18506	1619270280000
26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1607	982	512	12463	18276	jwa8L2sqjoCH3fNxdQNuFeXuyqxezGdVAcgaevwkaAyRhmir8nQ	13158	18509	18509	1619270820000
26598	3NLBi1mFEeUSo5kgF51hDDRzuZx57Ua6t3b6K9X1T6HyMaohJDGb	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jxgd4hYzekWGyX4JPZY5whWYrJzvS9TBDnDRYkfDFXmzudu6RzM	13158	18509	18509	1619270820000
26603	3NKD1URM93TiqHyJugbYPvcCLfGvp7qURLSeodjgktDxifPWLKru	26601	3NLZj7zfjQdi1HSrJnK3D65VQr7okvpKKHJz7ZcQM8rtNgH5SupE	1406	1393	512	12463	18283	jxYGLZ2cp9duyZL4hvNyFougmM3yUTrq34bhkUwrPPav9P1kV39	13161	18513	18513	1619271540000
26606	3NLSp2Jk3ZLsCxEunB6TAX8NUyY8qNrmMgR53d4etRCMdAm18idi	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1634	1085	512	12463	18286	jxQQP66YVg9LaPKZ2rvQmhqcSV9crtBfww3gEMR83HorHUpdZXS	13163	18517	18517	1619272260000
26609	3NLTMH4ZnJUv3QbdeZjYM1sPX3ikGzJRinMYmBQWpL87jnm75Zvh	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1406	1393	512	12463	18289	jwyFw76qVxb92MwWv9DSHDmuBYemyvPqg4coqgoS7gLVX2vpAKS	13165	18519	18519	1619272620000
26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	26612	3NKQjRmQ4E5yyfZfBXjjffWHogVczJiwLJKmRwFk82C98vqC6eFR	1649	1383	512	12463	18293	jxXiqZSepM4AGoChdKdEJkdXkKLRXS6p4cxKm9oPVbSwhtucdhG	13167	18522	18522	1619273160000
26614	3NKGbsCyGiy3F9QAfSmQKn8YhxsZ2gjAPmM8Njxx1S9p19GmnTkM	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1529	1316	512	12463	18294	jxVitdSXAD1gij8PiMrfkv3TLVZdxswiSNdeCnbVdRK8mhXM4t1	13168	18525	18525	1619273700000
26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1619	909	512	12463	18297	jw6upHEnSqQYEHN7DPDEuVArRV5uo1yfVnNNRjUA3eSjjqjSfQb	13168	18525	18525	1619273700000
26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	26625	3NLjhni18oHacg2H5iwhLFKXZ4H14m7jDYFM2HvA6TLF5mq8ZmoR	44	1199	513	12463	18304	jxqj5eoj2TVuZgBCHtzZm7JVmnBXdPhijXt9H5zkQ8mqj6tBVJE	13172	18533	18533	1619275140000
26631	3NLEK9G1bKJgA7ef7Tks8Dy2YQ8izBscZED3qEYv317WPLBcPJUv	26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	1406	1393	513	12463	18309	jwknvsoz5iVcQZstZQhvcVjmp5NJaHYW3Kw3HRL1rTSNiVib3TQ	13175	18537	18537	1619275860000
26633	3NKT57AL3g98bwa4QSdUf7dPpSDp5JCSu1zMKXtWV5KCDQeeBZRp	26632	3NKomHEFrgwyJZdweo1NkCnLZE3Ehsr1zpedZxjZVpiNbgGdkDBV	1405	851	513	12463	18311	jw8XfY3hrA4pDFiT1Xu5ba7ji8c5XAWU95yUssJwocKsrQ64jPJ	13176	18538	18538	1619276040000
26636	3NLoVZfszfmCzeoRKh9J6ywfuR5MxmRL7JUfgdwhA43jyBam6BWp	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1406	1393	513	12463	18314	jx2fPjZizDx7EovxmvCcvaUg6CdYHw7ms3YA6wDfCsgBbvRn9sV	13178	18540	18540	1619276400000
26641	3NLLZMUTdD2QEHa39b4qzB9rdcMcMjZf2zqc47CyHYgemrKkkSqK	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jxGYNdQdzsXNnbTHbC94FKGE6LjipFxVF7FcR1aBbo2hmBu93ee	13179	18543	18543	1619276940000
26648	3NL185HwmG9d6XmwuLjARz8dBS9EBfYV5UFMwChPQvDqgcDsprVQ	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1646	1108	513	12463	18322	jxYGu9oJjv5CkCcujCxVk5a2B3jfiAaZgwTZKSirHjuYjGvFxFW	13182	18547	18547	1619277660000
26652	3NKNG6aXUpvFeM4pFUDCLQ6yAz48jMDpX7bYg5jFMcdCPpE56zLF	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1648	1158	513	12463	18326	jxWgDtxFSQaNHAcgVARFRFskCGBj9FEzp1FMAGPsXnaG7fRgNX5	13184	18549	18549	1619278020000
26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	484	953	513	12463	18332	jx5N1p9kNRjqHKP7AzxXTPcVPZpNzddRSvK2NLscc8jMJMDy9Bb	13187	18552	18552	1619278560000
26662	3NKy4U7Fr88zpDvVMq65ASrKgF96GbQdLcnu7Zd45Zcbg88rPJXe	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1624	1334	513	12463	18335	jx2LMNDqLqtfsK9vMYJpeS77wC22pEeCtZdSagwSEFio13tLBWS	13188	18554	18554	1619278920000
26669	3NKKjzUBz8nThoEjyuHPYB1Ve8yZa7ERwsLBuz5qzqgcSii6FTgR	26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	1527	1293	513	12463	18341	jwc9RD6EbfWmRtNEzjgBrQWof2Ra7fPos45T8bF8T1MmT12EdQV	13190	18557	18557	1619279460000
26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	26676	3NKurcQuVj4yfuMaaSiVq2sVZqtYWeKX4K8Gp78gyMHgsnQupEPC	152	964	514	12463	18348	jxeb7sHWk18JqNE8SkALifA27zuFHPLHDfhDRF6SnvJH8mi8JeZ	13195	18562	18562	1619280360000
26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	26678	3NLgMQWbfVfMtKtpK1sp2LN8n3pTzEeHjEAoebEUXgzPxGk9pNjb	1407	1395	514	12463	18351	jxc6Ug8MUFVgAdc9tciFXBv92fVTe2UfsBu2Ba6VzBZE9SVAApM	13197	18565	18565	1619280900000
26683	3NLpyP3iGK8FtSfNcno81FbjufvZbPk9boAzVP2R1L6FFQvsKewc	26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	1407	1395	514	12463	18354	jxv6EPdjL94kthHvY7abJZfVtPjAKLiFSUDgxTQxwyxzcTCSr78	13198	18568	18568	1619281440000
26685	3NKYebyVqvuYizyukHA1kRZq6X6FmqJGNw9oHS54x3gArERfybK1	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1503	1031	514	12463	18356	jxMSPKGEjeCYCqRn6GXEjCnqJRG65cB4GQPxo8u4tvtmhWydPYR	13199	18570	18570	1619281800000
26687	3NLCqD4V4KQeoGuvoYxeRsdPzRCdnCT1WUXNqy381s7Fb1nMo5V6	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1596	1363	514	12463	18358	jwuhDKo5KN1SEL95WJPUHXGVyBy44HPaA7zn4nUY8bzcJrD4dXz	13199	18570	18570	1619281800000
26690	3NLrhbQ2znzkRJpYCoQL7oa9BmRGu7LUqanfNnZi5DdQBvHNvVdr	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1503	1031	514	12463	18361	jxMoiyi2Ub2P6VyJa5WKHRksqrjV8iSY6LXAUU4KzmqEt6BWFd2	13201	18574	18574	1619282520000
26693	3NKhDrTDVW18s9KToKvgsKkocM9DeydXRKUQ8SqkRixCaHAmhrp2	26689	3NKyBoQMktbcqyrbVHQkYar7Tde9YPwVTTQaiTgcoESPoFeJVGvb	1402	866	509	12463	18364	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13074	18574	18574	1619282520000
26705	3NLkbkzDU5q3WmguKc7HRcFg1jLm4x53rDZKd5Dc9gxJAQkqapbj	26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	1522	1322	515	12463	18376	jwDRdGCisqbnDPPZ27BxhnRJ55QyHYrjruY9FPBnKhvcxfRoXUV	13209	18586	18586	1619284680000
26710	3NKGTxjjM5vFpJGEzeYGNkc51y8t4aWg473Wm3yWqUxbCwoiof1y	26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	1490	1148	515	12463	18380	jxpJZqQaEGKteELkNdnf54Q3TSNTr5o6FZyrJkf8kqJEEetwxd9	13211	18589	18589	1619285220000
26713	3NLcRQ5egLTC7MLHhjS5jKKTGWjaSoVRafsGWPyCr31kzAdZn3vF	26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	1406	1393	515	12463	18383	jwSja3ew3VotnBwCBavLoVeBWxFCmMiJhLoyiyRGzuzpRkJ2Z2p	13213	18593	18593	1619285940000
26715	3NL5n8qMG5Qaxmee2uSxdoJCVoQDRYVFWGHJRAi8vnmEYJSV9kht	26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	1593	1346	515	12463	18385	jxAiK8tCgvNX3bJXFfpoqVGo5KuqZ67LADAVwE25jJhGBY96Xqv	13214	18594	18594	1619286120000
26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	26578	3NLnCzzhWRF6Z4kdKKr9v6jCBd3dyWN9D6d91PKUdNZEjwS5hAkY	621	621	511	12463	18266	jwc5zcMQYMz1aLehwwYvdGr3dmAgVp2BMwBqywDTXuxwsy8MnGR	13152	18499	18499	1619269020000
26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000
26586	3NLnTk9gCT9nf5GLxzhC4u9wy1Wb3Xk9gQU5inNQvryfjJAFm4AM	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jwSizsg5JaG171U6hdFhddsJphgTYNaVJRGk57YEAKw94JFMxHe	13153	18501	18501	1619269380000
26590	3NKxGZkxvDvgMCmRMhhtdLBLLkMuaduhZ3tU2v2rJ6aiN1YfbuWr	26588	3NK6u58DrbZYwYNzggKFuVsgU7Y5jeqjvJxZrm592ATiJ5vaAkAg	1507	1280	512	12463	18273	jx7Xjxg9R8P1uBBhjrgaPQt3YfWoKrNshkTy4Hfc7ubKLQkBxra	13155	18504	18504	1619269920000
26594	3NKCaEqJCRWxFYVRCtxdJaXqNZuYqgfgdxbQ7Eq34QEQipSiafUZ	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jwFfStT1UJ4YjCq7yRn5pf5QLLQZzqQeqUW148aSmrQX33U7Vbb	13158	18509	18509	1619270820000
26597	3NLjtRfpN53bCEnnJCXCpcfbnWVZHWDZNv7x9swtLdtqB9oL4PkX	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1403	812	512	12463	18278	jxNp6wXFtJNbBfxQazX1j7cwQZWxjSFrxZS99EzQUCRCGeCNsPk	13158	18509	18509	1619270820000
26600	3NLhzjVqgKEWLMYiBAsytq6jdpzeYFv2ZhcXN98Rv8JH2o7mvrj7	26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	484	1319	512	12463	18280	jxSFH7BFatq2P6Jx1UxtcfwcXEXifBhV4fJ1tZ9uarrijeTX3Hg	13159	18510	18510	1619271000000
26608	3NKbmhwDhyt1LkZdmJwnPVbGt84X8b68odT6CUL8fcSDvgrrBTSu	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1560	382	512	12463	18288	jw9Y9yX4d5xXjWge3zMzbDw1kCThyBT3tVmh5Xndj5KfGLutNCK	13165	18519	18519	1619272620000
26611	3NKkPzS3oPWwaY6jojhRm7SU4j7tXEBVgXYeNs39nuHbpQpy7mn3	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1553	776	512	12463	18291	jwEhJk4H4Who3zf2Xfwt6KfM4bG3ESAvZdSyTiSEPm342remTxY	13165	18519	18519	1619272620000
26616	3NLazuHbyzYuL6p9Mt7WSr8YaTkNd2aFcASn6WZKgPi8bMyHPijN	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1407	1395	512	12463	18296	jxjjoEnbNoTAXESUZ91ZPknbVj8DjcRD41d5Fhxp1xdPYcJdEXM	13168	18525	18525	1619273700000
26621	3NLPy87Q8bNTFMSMdxUKmvqeCinb8w2614FtJRBHsffSC835Ab98	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1440	1377	512	12463	18299	jxVANGwmdNPACKjTy7Z9NsWGC55q8QCvhSPFQnG85MBg6mdy1qU	13169	18530	18530	1619274600000
26623	3NLZnZNr4URh9utcKuNuc6zF3h8yNTsu66RtANJ5dMpWfAbq7AXA	26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	1642	1367	513	12463	18301	jwwfvDwfykRvrto2eAWP2nxmMkHjuk7y7UVNBkdEMXX7Ap7ymEP	13170	18531	18531	1619274780000
26625	3NLjhni18oHacg2H5iwhLFKXZ4H14m7jDYFM2HvA6TLF5mq8ZmoR	26624	3NLRbW8tLUAYDDSMiGfiBGshSzWStZTSQ4nEtRYtHjVccorP6ZZz	1406	1393	513	12463	18303	jweCzc4d1WX1uVf4EyCrV4tUZvbRHMuB5QvF3cQkbaFRMvbu5h2	13171	18532	18532	1619274960000
26629	3NKBrSb34q8oruc9mv47AtwvNdSEFFww1AiJ4EaryE7FN3msLq7E	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	1637	816	513	12463	18307	jxkTCM7Qg6tvgm3cQwxhnczqBJ5p5K9rcsrquHG4A4KJuywTULP	13173	18535	18535	1619275500000
26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	26627	3NLeiNbNGvodiK8RfpM9pDSrHo82VMgdbzKYYsxvDsmMsMuBWTxR	80	1027	513	12463	18308	jwQdiCkqTDUSUgvCHeRKZGEsFkaWBWdrJ8RPk8neqPQBEGMCWCv	13174	18536	18536	1619275680000
26635	3NKE85DMArQM4gQt6nRoM2kEYhqCLk69AMC9qCR8tsgEU1ZV2uyi	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1448	1311	513	12463	18313	jxi2UUYyH6SsXHKXZn7Qjh4x1k47sDZcLjujjNHCvoMB5AMwZ2S	13178	18540	18540	1619276400000
26638	3NLGrVGigniZQwgdKPfn9UKuHMoXxL1GjAdG63xnHMXiS8ynrkEE	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	58	1281	513	12463	18315	jwVKDrpY6vcSKermC2ssENd9nbwcuZpZPyCr8Ep6K4xN67MGVT9	13178	18540	18540	1619276400000
26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1406	1393	513	12463	18317	jwJE9gfcXHc4Pq3qbBYPecr3dSnCu7XJN51YzquErk8WXXSK9Dj	13179	18543	18543	1619276940000
26645	3NLh3bL6E6DRDfXCjPge9ewqH3xWqkRQAGeesgZpbW9v8dLTPoin	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	1534	371	513	12463	18320	jxw2HKtj74pG54mRz4aVSvYm7phqc6uReQ2Hpn8mpJDHVo4R4E6	13181	18546	18546	1619277480000
26647	3NLRqAPmLckTpFzxzpNakEGsTVguvVZUvtS3WeemZ5xN6GgLnRcQ	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1500	1297	513	12463	18321	jx4e1Q957o6gPiGqkxXieq4rWAi5ZmXLHmd3dq1SbTZv23Ef7XT	13182	18547	18547	1619277660000
26649	3NKfPESFsuoFTuS2fCb1tcmJdT6KB6kGHWyj2FU2PVu58kdjKyVM	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1579	1389	513	12463	18323	jy1qSGqtmWND6h7kEmSxiE4YAXhoVgkxg7LWRF1zC8rdwD3oa67	13182	18547	18547	1619277660000
26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1406	1393	513	12463	18328	jwQTcVTmz5EyBwqx2PA3RP9iMqhVBSYtPkvi9N3VBfKkd4Ahkjd	13184	18549	18549	1619278020000
26656	3NKW4dwY27ZvRRMpJFeRUS7fXUVRwsFEezgjHWXb3uRHntihuKxn	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1634	1331	513	12463	18330	jwPWJncqsmjctTC55ALysMBAf7YozttshDBKvS1drXvNWHEWF4s	13185	18550	18550	1619278200000
26658	3NKSrNwZXDBVBahfV65hqHq2Do3repK6KUT36QrfaMwk8N4P9wBP	26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	484	953	513	12463	18332	jwWU5KRi2HeM8ZupYWEBwcnDNvzkSiETueNDifpKBuGuVEzatCL	13187	18552	18552	1619278560000
26661	3NLdzrJnrmG1Lr2QQEbaLs8opa8KMoJriu2k73SNLanS4QMJg77a	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1637	816	513	12463	18334	jw6fztGnJ1doYp4yy1fx9wwFCPks9jhZjzLz4byhRkhmHT1RF77	13188	18554	18554	1619278920000
26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	1406	1393	513	12463	18336	jwhT8pECoGXxyc1k2y9ZyHtcqc6KrsKZtKax4zEmU3ZKDUt1QGz	13189	18555	18555	1619279100000
26666	3NKepyzXFS3h2BAbCWxnsQ7s2NWGZYLm4YjCnFrjigSLJoD7dn66	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1668	1370	513	12463	18338	jxSLvTwBZiX9x9MaBZZLFRP2KajVSfE7DbnXfcbPStNSTyN2qfi	13190	18557	18557	1619279460000
26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	26671	3NKtpAvSqHbt8zMnw4tMGJeBPce5M8EkM31dx2wvXRNPPAxhyc2x	1602	1123	514	12463	18343	jx8QMwvRz78AudcxkFjycKXfqrr9StRaufjtSgeFxGRaepKDR2M	13192	18559	18559	1619279820000
26675	3NKFL7LyWBuJMKwJmurE4ZUFzvpKvskci84gn65pK3iFuHYr61K1	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1407	1395	514	12463	18346	jxP53cJT5gUveyfCyGQfMcLJ8AvksyJLVJ8TckvcAtt9gpwZrPc	13193	18560	18560	1619280000000
26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	58	915	514	12463	18353	jx2qMTtzvqHhYFQjFYcmvzpX9EKEfSJV4wXCav482pFmStJDFyp	13198	18568	18568	1619281440000
26692	3NKCXWtzz92BMDmjgn9RuWeCz6dy9Ddsy6yXFjgarqEx85xbbHXN	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1637	816	514	12463	18363	jxj8aCQadaiHvkmfweDQtuFLvYQzrUfy8f2kyK5bkzZXiwV7MqA	13201	18574	18574	1619282520000
26694	3NKf3YWqPbCp87NPtmqBL7pGwnTMPxsMEGrLAWtFsfNzkst3nAsr	26692	3NKCXWtzz92BMDmjgn9RuWeCz6dy9Ddsy6yXFjgarqEx85xbbHXN	1405	851	514	12463	18365	jwqjhanpmdje1QKuDw4T9RPLsRYg3nnozMqg4tBDe3T27RTn8Ay	13202	18575	18575	1619282700000
26589	3NKJ34XqJWW59yGeAnkT5BeUhwPGF86FYgeDUSoMeSfjR7uLVneN	26582	3NKqP8PULko4AsqpqUBtc1CnrABH5bBHatH8FMhxrb4EkQQWedN3	1403	824	512	12463	18272	jww1c4MifZ2uZqMEH7NZ664vz59CBfJzSnUrVhP7QiGJCKp77pt	13154	18503	18503	1619269740000
26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	1476	1125	512	12463	18275	jwgvdfUx6yscBrHYYdn7kPrEwV593kAssEQe4xbodGDqazpKxCe	13157	18507	18507	1619270460000
26596	3NLGwfyDw8nCJKQBYDjj57VYf2GHm5Fy4cpUyHP2VmkpA3ZjUK9J	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jwNRUrz1zp1Q7kQ2UrYeQX7rXLu4BHvKRgxxJCGTuJQ7CZwNkTy	13158	18509	18509	1619270820000
26601	3NLZj7zfjQdi1HSrJnK3D65VQr7okvpKKHJz7ZcQM8rtNgH5SupE	26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	1483	1150	512	12463	18281	jxiU1aGHRa2ivi6QaswpG5311S4SLNjvpfSJs1uThQwXAvzx98Y	13160	18512	18512	1619271360000
26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	26603	3NKD1URM93TiqHyJugbYPvcCLfGvp7qURLSeodjgktDxifPWLKru	1656	977	512	12463	18284	jwvG5G2ZBHCGgxjUsnQ3gWXFACm4taDPZEmb9Nq6hqRCsP9nuTf	13162	18516	18516	1619272080000
26610	3NLW6WvQJaMjBoDgVC4iEtebgefZhqFtABk7it5g74TrkMeLYfDV	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1407	1395	512	12463	18290	jwNMi8ow8mSVX2yeRKbGjdEjXJHNRrhPkTGQiqNsr7ikKCtTwu9	13165	18519	18519	1619272620000
26615	3NKKu4yHLBzDrGAoeTQJuxUgo9AxgimA7z8zY97Lb3kmiaVnVWkg	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1406	1393	512	12463	18295	jxroNZ9k44LqWCYLJBf7W2K1cZgvLTofTvaY6SvBDptfFuSDdag	13168	18525	18525	1619273700000
26618	3NKeaPgtiqXYpCtSigLmtGm8js4C4czfTQZzUayYcQYa3fYSqHop	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1529	1316	512	12463	18294	jwVSMcq1HoWUJ87rWEd4eX25Kpck7QpPYxTBTezNVB6i4eiGest	13168	18525	18525	1619273700000
26624	3NLRbW8tLUAYDDSMiGfiBGshSzWStZTSQ4nEtRYtHjVccorP6ZZz	26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	1581	778	513	12463	18302	jwTuryRt91eTQd2JDTNdePyTQqTARQd1tZSfPgP5mBJrmgbJ1Km	13170	18531	18531	1619274780000
26627	3NLeiNbNGvodiK8RfpM9pDSrHo82VMgdbzKYYsxvDsmMsMuBWTxR	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	1602	1123	513	12463	18305	jxk4qKFT5g6y3Wwh4xub91UN3XxX68vW2wJxfkBGQhcQrbCrLPX	13173	18535	18535	1619275500000
26632	3NKomHEFrgwyJZdweo1NkCnLZE3Ehsr1zpedZxjZVpiNbgGdkDBV	26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	1403	824	513	12463	18310	jwFdCz3rvugmNtAJ7V5UDtdWgcNBEpum6jYiaJQPX8QdPnAHfB3	13175	18537	18537	1619275860000
26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	26633	3NKT57AL3g98bwa4QSdUf7dPpSDp5JCSu1zMKXtWV5KCDQeeBZRp	1503	1277	513	12463	18312	jxEx7yCtxmSfPMpuWgpGtjRyhRpUU8v41AsNejEEqzTaW1x736E	13177	18539	18539	1619276220000
26639	3NLhQ9s7TNKtWStn8y5GVKrm3gxx6QNUEWFFUQQ2eU5e87C9NZbo	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jwDVW46cVH2y59FRuwqL7iDtCG6L4H6PuvqnZbD36qHznzZZJT7	13179	18543	18543	1619276940000
26642	3NLvcw3D9sNmvt2vAyr8WoTvMqvJkF6RFZah7eozhffnQrdojuVW	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jxusKQxvqmMz7J5xUpRoph2VTRcvyvagFAdfbwrvWkoXzWgMPL1	13179	18543	18543	1619276940000
26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	1477	1350	513	12463	18318	jwETmm3dd2SBX2fQMYFdAPnxGZCj3V32jDkVB69aiM9ac4oJzd9	13180	18544	18544	1619277120000
26646	3NKtPWNhG8zS1fzkBzoA8XpnMgLuYmQCZVKhViaBUosSTSJRVanb	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	1534	371	513	12463	18320	jxvfzbw7nfKUKsB6QNxwpQNzGdqQ6uLKS5uSYp7R8PRTMEmfTpe	13181	18546	18546	1619277480000
26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	26649	3NKfPESFsuoFTuS2fCb1tcmJdT6KB6kGHWyj2FU2PVu58kdjKyVM	1406	1393	513	12463	18324	jxsk89a9SoR4wZ8i7mDPPpBCFvzPc1fVmxw5EaLe8e4i34vyCrG	13183	18548	18548	1619277840000
26653	3NKa7ho81H9XVACjDXEE1ijyj2Y9T1CrR2LU4MKDf855cUSCpuUA	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1619	909	513	12463	18327	jwf771Vi71PiZghw3nMX5Xe3x6G8MxxruoTxaXCPZM2xvx1bYNs	13184	18549	18549	1619278020000
26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	26655	3NKEQP4ze2CmfaNCjWEaerdyn9F5YfWzqkbtv5aQxRLi48VNR4LQ	1623	830	513	12463	18331	jxk42fzvhCFwuiqxEXJYsN9eMiNW3oJuR4L7WJPtmu2oXhHCvRZ	13186	18551	18551	1619278380000
26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	1650	1375	513	12463	18337	jwAqNqQSMv1Raw7rbyu61ebdWhHCNaFKZgGpVYuVWnqAQPTMz8d	13189	18555	18555	1619279100000
26667	3NLCUR2HZUBtUZhi21gnH18SyePkuijDyfcF4y9fiuG65M6SA9qS	26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	1668	1370	513	12463	18339	jxBx7so8pFkFNVhisbMUZ2iDYDkQK6AG48JfTgySomP82Ya7KZU	13190	18557	18557	1619279460000
26670	3NLVmp3ccwLjiKMS68koihgrynxDkY1srGbDKL2nJ1ZteVGCP7Kv	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1527	1293	513	12463	18340	jy2Vz2kzUE43gQB3g9T5GVwSLT5jRRYdoGA5x3UwjpRjN18RTpg	13190	18557	18557	1619279460000
26671	3NKtpAvSqHbt8zMnw4tMGJeBPce5M8EkM31dx2wvXRNPPAxhyc2x	26669	3NKKjzUBz8nThoEjyuHPYB1Ve8yZa7ERwsLBuz5qzqgcSii6FTgR	1637	816	514	12463	18342	jwcQiE9VK2hQcbnPp8MBaZntpnkYFTEMVKwgeLiBkEiHMGPEeGK	13191	18558	18558	1619279640000
26673	3NKuRTGqbNCeSNExGocteYnXP7vgcLwNzZuXHpWBGx9g9YTpoSGy	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1490	1274	514	12463	18344	jx7aivQaDbqVt1MbYVHKRDTsRxueG7BDHnW2pnDaHhoB2wPL7vL	13193	18560	18560	1619280000000
26678	3NLgMQWbfVfMtKtpK1sp2LN8n3pTzEeHjEAoebEUXgzPxGk9pNjb	26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	1503	1151	514	12463	18349	jxXdyNQHjvkMorasAfBYjK4qZ4sVUCLn4YCvYpjUCHmpqrto2qT	13196	18563	18563	1619280540000
26686	3NLaFnwXgAqAVXRTgYtj5ngKLmhXG9xB6dzDFrKteqH2Ch2dvV7S	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1602	1003	514	12463	18357	jx4Toh5osDn4QTbHXPpodD32kt6vJn9VHARSJzVY9y2SHvcseHo	13199	18570	18570	1619281800000
26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	26687	3NLCqD4V4KQeoGuvoYxeRsdPzRCdnCT1WUXNqy381s7Fb1nMo5V6	1403	824	514	12463	18359	jxXXiUZq5Z8DMm2vC92XBUqwyqaDSgJuzJC3kLUEQHTV67c8x9V	13200	18571	18571	1619281980000
26691	3NLsiBCup3hwQUDp543rjKzCtTzxu2z4RoC1XUTMFg5SQHLm3yGD	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1490	1274	514	12463	18362	jxuH8bzkmREhH2HMbzLBiwqtXSehGBssAuLEJ8HfBWoxAJLnwvw	13201	18574	18574	1619282520000
26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	26694	3NKf3YWqPbCp87NPtmqBL7pGwnTMPxsMEGrLAWtFsfNzkst3nAsr	1637	816	514	12463	18366	jwKgsNmHUKLPznkczVQzydtvEzYfy9SyCw4nrqcFuCuozPJ2Mdz	13203	18576	18576	1619282880000
26700	3NKU2ea6msf5vo3A2zHaL8UKcYtWnruU5sApBugxGrEsxnmmttmQ	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	1406	1393	514	12463	18371	jwDbmzSYhUBkWCoeFzPSAogqiJHELVabDc96ubdUFkYDRwUk1AM	13206	18579	18579	1619283420000
26706	3NKtPgerSmwqETaLWMEfjgko55HhSQhf4QXB4c3prGsinh8L5N76	26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	1522	1322	506	12463	18377	jwqyTpVYuyPFs1XbLggxixdF8HDJgmnKaNm3AfWmEaL3Mncc9mz	13053	18586	18586	1619284680000
26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	26707	3NLyXaTGPDWrYjaemfJjdwnJdhovQXnnKaULyvCS4gTEP42QvyLn	1476	1371	515	12463	18378	jxCuA49qGMt86PnyEqgLXcYQJfBbHqGdZX2B6b93AyyaQU9v2yp	13210	18588	18588	1619285040000
26602	3NKcsczDHKjWNHKUPcDqzXgSfL2c2by3xKAx34CD4TakQDqbZxEE	26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	1581	778	512	12463	18282	jwiikxKaVAYt5tPhAtTSHQo5JW9zVju2sWqrK99UQwCabFDxPwH	13160	18512	18512	1619271360000
26605	3NKFR8PzRN7kJxDDcn7dWhTiEGaQKb5nhmiJLLdpHHzsT5zxTPEF	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1483	1276	512	12463	18285	jwdVHwbEKmkDCex8pkrDML4Voufxa4ddFhnD8GkX1m5VTctnQ89	13163	18517	18517	1619272260000
26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	26606	3NLSp2Jk3ZLsCxEunB6TAX8NUyY8qNrmMgR53d4etRCMdAm18idi	1483	6	512	12463	18287	jxg3j7bn4aHineBoKa5dqPYoFYcKMvcESL45RABeGhxgg3RAGQa	13164	18518	18518	1619272440000
26612	3NKQjRmQ4E5yyfZfBXjjffWHogVczJiwLJKmRwFk82C98vqC6eFR	26611	3NKkPzS3oPWwaY6jojhRm7SU4j7tXEBVgXYeNs39nuHbpQpy7mn3	1460	1324	512	12463	18292	jxWF4LdZgeGdDYmnxxS8CaL7Notg6fgRCJxtzpd6LJhqXwCDVmB	13166	18521	18521	1619272980000
26619	3NL3t58mdnU9347fJNZPtjjm5G92GvruW2kzuKe2BnJzL76yydtf	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1594	1326	512	12463	18298	jweDhoJTfJimGJ2a4c1WA5z3r7M88wH26MQQvumYeyo4Upk9bfs	13168	18525	18525	1619273700000
26620	3NKwxrcin7LsNqHkg4Um7SCHk7UUY4UMu99WS7ASKZ9dyzcKGA1R	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1440	1377	512	12463	18299	jx5j9doSsAWPrzHU8CW3EE31R5oqDBgavB5vCTUUPqb3x6UybXA	13169	18530	18530	1619274600000
26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1406	1393	512	12463	18300	jxn91rVXmQfFm2QmNnbgA8qQgG3aQweSyJtp3kcFXnKjSKCLM5C	13169	18530	18530	1619274600000
26628	3NKv5sh3F7YZKzwhbvnSCxwvvn3GSYgVLRqGqVnsMdho5Ja5AUZu	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	80	907	513	12463	18306	jy1qWtW1Hkszh7BLLigrsE8QjYNrfiTHKaKS6SpJUW1sJUJo931	13173	18535	18535	1619275500000
26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1448	1311	513	12463	18313	jwycTsEC3dVBqGX4fQsC6Ndg7qDTr2wfzo9h9ZTFdx8kPSk3QLB	13178	18540	18540	1619276400000
26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	576	1355	513	12463	18319	jx2Lz2aqveaaRDcaLPrChUMJdBz3Ugdbji321ktWQogFXSRzgWo	13181	18546	18546	1619277480000
26651	3NLqRvvVqns4MZUSM3fV4A31492HuqZPTk3NAzfzBCzhcLg2gP3j	26564	3NKszAvbTCxYXmrekj1Uz9MC7WnFU8oE8LKyHGuwh6KJD2FiT1Ew	1402	852	509	12463	18325	jxG3tCY2qWpqg98x14Xd9LJZ4nL92BcVsZyzky6EQjQJ2YFjY8g	13070	18548	18548	1619277840000
26655	3NKEQP4ze2CmfaNCjWEaerdyn9F5YfWzqkbtv5aQxRLi48VNR4LQ	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1507	914	513	12463	18329	jxgv1tvk6Jy1gXVWfrnTkPiGRVzby7MQ2BexQCCoGnZjoXuy9x2	13185	18550	18550	1619278200000
26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1490	1148	513	12463	18333	jwxH1eSg45EuythNFKMfDoxmDxB4YSFpCxSTYceVQSHosm27RZQ	13188	18554	18554	1619278920000
26665	3NLa2fA3mV5eCU5vbuHaiJnfVVZwECMdKXQ4ixQJGjD4dFUgzXBD	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1668	1370	513	12463	18338	jxrWYtZqyhgU7fg3ToDvoPYhZh9yfZzRx8FkKjTUbXMLXaW3KzT	13190	18557	18557	1619279460000
26668	3NLcsBRmghDvPQ8zcgQFqqjYwKHQWDw7vV6W29xSqRtuQ3MU1n6Z	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1527	1293	513	12463	18340	jxRJ4ianPPUyPWs6Tknykn9fx8UUnncJaeobBfjVfgmGFMpVD1s	13190	18557	18557	1619279460000
26674	3NKPpgKDcR9CseQSWZ1j7bhysYishGXvgUNkRH6DWmh924awRYG2	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1405	883	514	12463	18345	jxHGixA7ioy5qfSsa8ra7EJCSttqFERrNdYRPVLRrweZAykZ3CS	13193	18560	18560	1619280000000
26676	3NKurcQuVj4yfuMaaSiVq2sVZqtYWeKX4K8Gp78gyMHgsnQupEPC	26673	3NKuRTGqbNCeSNExGocteYnXP7vgcLwNzZuXHpWBGx9g9YTpoSGy	80	1147	514	12463	18347	jwuXksf2rgrLXnRDgceyDotqUFsDrqEZWUKMLtv4hgMY4KUMb6X	13194	18561	18561	1619280180000
26679	3NLnjjd9iQZworaCapVdRBNCmUrBtMFH9Y1wDmz7B5tP5TTEQmro	26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	1407	1395	514	12463	18350	jwUZbX28PhSGZaFxxU1kv7UmusX1K2my4cKCPGUS2NUxSPwDYwf	13196	18563	18563	1619280540000
26681	3NLSs6A9cs5G9man52ALr3YVDZxHYyUXtn5YH32M4atrTn9UHsBX	26651	3NLqRvvVqns4MZUSM3fV4A31492HuqZPTk3NAzfzBCzhcLg2gP3j	1402	900	509	12463	18352	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13071	18565	18565	1619280900000
26684	3NKBSCd4VehufdKHGb3xyWhqBtwuXpRvpTL6V77UqQ4QMuEouPMa	26681	3NLSs6A9cs5G9man52ALr3YVDZxHYyUXtn5YH32M4atrTn9UHsBX	1402	808	509	12463	18355	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13072	18569	18569	1619281620000
26689	3NKyBoQMktbcqyrbVHQkYar7Tde9YPwVTTQaiTgcoESPoFeJVGvb	26684	3NKBSCd4VehufdKHGb3xyWhqBtwuXpRvpTL6V77UqQ4QMuEouPMa	1402	852	509	12463	18360	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13073	18573	18573	1619282340000
26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	576	1229	514	12463	18367	jxa4aD4T9Zrwn89FDdTu1So3cVW7p4v72wPkLucwDAJgXyhYUqw	13204	18577	18577	1619283060000
26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	1637	816	514	12463	18369	jwp7HzNvZtJggwCMPvfuqfMEDeSbep3BZWDMMw8ne2txDd32YdN	13205	18578	18578	1619283240000
26701	3NKBNn1kXDeYdaMgkvPU7ndNo97DQWDq5T3nphe3obWiFQSPAYL5	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	1405	867	514	12463	18372	jweJ5JGcDed3RWR3ptEi2TQVFK3i3QKPhfW45YWERdWVS34JA3e	13206	18579	18579	1619283420000
26703	3NKoxwrHwwqPWehTLABJyVpf2QzYZSBr7BdJBaU5dKbnCp5NQkVC	26701	3NKBNn1kXDeYdaMgkvPU7ndNo97DQWDq5T3nphe3obWiFQSPAYL5	1403	824	514	12463	18374	jwt8XXQKSvLc8jFULAXfctaX5TJe68ExJcJW6S9ob51LBMa9BRN	13207	18581	18581	1619283780000
26709	3NKZ8etyeAy1tQUVFGhMx5rPA1zP4SS2i2BMs6ruY6w68PEoEpd2	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1476	1371	512	12463	18379	jxYnkJ3FtExjBVEDZyWsPZfyAJn9sWee1XFDz4Y13ZHTXVMhQWa	13163	18588	18588	1619285040000
26711	3NLTwoHu2T4zR4ddou3STjnYEoLXoVFsPWA1Kbw6k7enKtkYs8ZG	26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	1613	661	515	12463	18381	jwWhbTXTRjgBY7sSsLhuSXWRg17BFagPPJDw8nfFzijAQNF7sHL	13211	18589	18589	1619285220000
26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	1434	642	515	12463	18386	jxvo98SjNgxoNyCKpL85foAvWAp5KaeUm3kjHaoq4GrdwxW3ko1	13214	18594	18594	1619286120000
26723	3NLVYuCeHBnKmNao47SuBPDN5nxynnTCf8cigVMEmqcRFkCv9zGv	26693	3NKhDrTDVW18s9KToKvgsKkocM9DeydXRKUQ8SqkRixCaHAmhrp2	1402	882	509	12463	18392	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13075	18598	18598	1619286840000
26728	3NKwfHWbuZ2JsXxiapi1UBXDdqDE6SJjSoFbqb4y7HqRurSWAUeN	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1407	1395	515	12463	18397	jwnxs35bubtbw4UygD3m2yoMmHw3E3FpcWvipxvaa6K5tieciAE	13221	18604	18604	1619287920000
26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1601	1388	515	12463	18398	jwcetvEbbDW78wVMLafWoGHnj4dKPdJBmX5RKbLwfLN6XDV43Lw	13221	18604	18604	1619287920000
26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	26736	3NLpPQig6E7ZL7am1Y3UvcMxjQLc2yDwExnA8Vpjmn6SveEdojxW	1403	823	515	12463	18406	jx6tVznmFXuMkJsRSzh4G2AK2HkhcT6NVys6D6XaGKvwFh9m8LC	13226	18610	18610	1619289000000
26697	3NKZUgPKHU4NgWuq9FxgpnBPx4XrCAyKTwPEmmkBvZPFSiQDf8k1	26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	606	1295	514	12463	18368	jxmwiZX81BN5TRE1iFGu96pX3n49JDaisbuUE9PzMMCULKLJXqe	13204	18577	18577	1619283060000
26699	3NLDYHohotPFH2BmPHiuJQdM7PUKc4BJSMYi9MaEhNgMr62by5wj	26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	532	1177	514	12463	18370	jwLmMg5bmx3RnPzrpy1RnvzKDxawASsNET95s54Tw2YYUJQ6BbE	13205	18578	18578	1619283240000
26702	3NLTpob5WzRoiBpUHwau52hdTwUMhRY5uxA9j3JwqsBoNxXYAji5	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	42	1361	514	12463	18373	jwM1UbBQxBcKR7sg8nvdgoSAUgKKR7M9JGgZdCjRrNf5Bi4SDuA	13206	18579	18579	1619283420000
26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	26703	3NKoxwrHwwqPWehTLABJyVpf2QzYZSBr7BdJBaU5dKbnCp5NQkVC	1593	1220	514	12463	18375	jwWt774SdEUwFBEt7v4Lw9qbsxwFzj2Q5puEBXp8SBC2Zz7nWpV	13208	18583	18583	1619284140000
26707	3NLyXaTGPDWrYjaemfJjdwnJdhovQXnnKaULyvCS4gTEP42QvyLn	26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	1522	1322	515	12463	18376	jxB99LvGMNjx2hWVA3NxfPY1YmWKVJTXwppqMPaWDd7dRPvzosG	13209	18586	18586	1619284680000
26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	26711	3NLTwoHu2T4zR4ddou3STjnYEoLXoVFsPWA1Kbw6k7enKtkYs8ZG	1619	909	515	12463	18382	jxigQKx8cpWXcNe4Y4YNnnW4nas9Ldvu4ikyNR3uagjcz7SfzQT	13212	18591	18591	1619285580000
26717	3NLjSBKgQtekXyxCYEr1pa3fFbDNMNpuWmtU5pFJJFT4XHmHqbsf	26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	1637	816	515	12463	18387	jwsJ6LnnxtqQCKWoqyJXNfxAZWuub52zuN5ghF5Pg9YLLkC1ati	13215	18595	18595	1619286300000
26719	3NKHFYBGPv33cGFwjMZKWb3cYkBuHWCKxUJJpsBNh3GyrWTQTpeg	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1633	1390	515	12463	18389	jw8nqSjPG8Up14oYZJwmCLTdJXZDcTU5MoMDSj1FJcmdj51B1ox	13216	18596	18596	1619286480000
26721	3NKXptWhDjgD3t6eemYoVpPmGhfdrNDfgFocTCtmY1D3pSLDbAhC	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1633	1390	515	12463	18389	jxntUQWxDsK3kvEGdSKsAZx9SEa4ibERD7gD8o49U13vvWBvjs6	13216	18596	18596	1619286480000
26724	3NLwg2t9hWDg3KWGjiEf2wTc8fE92FitNjxdDiVbGsmrbNkS8SKk	26722	3NLjeFVCjgx6WtPM31TVS5bgWrFDSiLwnC7vFyTpmhQXiB3CSban	1406	1393	515	12463	18393	jx63kmLnuKAjbefWLUYuQ8UeLmwpLrAj1vqyG8J7mRBwRiDKseN	13218	18600	18600	1619287200000
26727	3NKAF1PUBZF9ftLgtpUWdLMGnYbe8LsREhraPiG8vTX7R3jY7KVb	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1607	1102	515	12463	18396	jwcDTDtCrazLweQhnfuKnBpvXBJ8A6tVgUWpCnmYiJZ5gBxbmtS	13221	18604	18604	1619287920000
26732	3NL6EQLYDq8bVSNhdz3xgR546Vw7aDGP5ioeiMKXuNHS17cqCeRG	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1406	1393	515	12463	18401	jxsDEjiDKEiGxTGP1kaVasp1Zvi9uSExpjtsMQzL8U4PAn43bPt	13222	18605	18605	1619288100000
26733	3NL6tKiibdpkkyob1soUJJSyMViLPxwMv9GxxN2EtvWEzfCi9RFd	26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	1406	1393	515	12463	18402	jxgKN9TiWuASsZ2U1JUJDEZM9caxMfkf6BDyoenKfRfjscf6ZXY	13223	18606	18606	1619288280000
26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	515	12463	18407	jxbYUC1uBXvwgeD2hVGMoZaVwxJ9SBdCL7MBgZDTLamURin7iRQ	13227	18611	18611	1619289180000
26744	3NLfo71SW7zfuShL2LxZyJVjRwdec6ZvBTVhFNw6mJ6rzbSiMdHA	26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	1407	1395	516	12463	18410	jxwKZjDfAY8ja6t22QvreuM5HEWhD8zwjTEQc9ZsrVghWkcw6rp	13228	18612	18612	1619289360000
26753	3NL1xX5NZEUDAwEosHLnk5hFF1PjWRYqGRToxKuJxNoJV7YJiAhN	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1405	889	511	12463	18417	jxVtTuR4YXvh2YMwMR96vMHbH3zs6k6biJRNo3Tv9GxMqt5prmo	13138	18617	18617	1619290260000
26757	3NK5SRhbx3uekVY5a428a1ZNW8riE8xT4APuZ1SfCjnTDb9d1SXG	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1405	873	513	12463	18421	jxh7DRmcBuLapMzytdJpk2qo1xWpavr2PMLoFuqKR1qaxXVBwiA	13185	18618	18618	1619290455441
26760	3NLiAYYvRKxjxzbyyJonKxLz8opqYESGCTxWiNE5U2wvaPwjYzUx	26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	1534	1191	516	12463	18424	jxp1BTQg5M9fnaDqNt6wLnf8EtJHdf2bRKMzatu1VqofVZNw2HE	13233	18619	18619	1619290620000
26761	3NKcRxTbKmsS1krd7MrVnjvuMvPjjpXVzL3pVexKryQQnRkT2BSU	26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	1405	841	516	12463	18425	jx9Q5gDddQfXhztT1V5NoNqzH1J4mAuj2c7t6C2LBLQvE9vBKJu	13232	18619	18619	1619290687386
26764	3NKzNNDdbyaRHbQchJ3cgm1v8Q8zzaENQA8P2RvUxktTdQF5Vjtn	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1422	971	516	12463	18428	jxaQthMun7j51K8rqtc28Uw7X1QQjcTRdHNnuwsqYJEZUwRPQQ1	13236	18624	18624	1619291520000
26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	484	953	516	12463	18432	jxqsDkP21nyzCAwa3Waj7zysxXu842N3bF83mFzCBBuCwffdvKf	13238	18628	18628	1619292240000
26773	3NLAUiPUNJHdTjyFmcMmZdQ3xkxL3R2QxZDe3GpwwC7kqeTnCCdk	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	1666	85	516	12463	18436	jwZxENB8p9hnnSA1UAtnhFwxs1ibtnFtkgi1TU4zGCY9t1cDAPP	13240	18636	18636	1619293680000
26775	3NKAFRtnpV8TW4pmfAkztAWYr4MxTZrsHgeRstQ6bGCZ2Hdex5HP	26467	3NKVy6RXjNtRM1npdvJ4uFhZuq7ec3TKGYHBcmZJXXZNPRJCBEwV	641	1336	508	12463	18438	jxFqc34uv4v3MVTDm5gu2oZPHiwQ9CcXEBdNd8RdB3k7DKCbQA3	13067	18636	18636	1619293680000
26777	3NKkdQ5UMVkBUidTcTExMkvXCyF4se5Hp5Ls9FwDKsnxX7ECqFGg	26774	3NKEXpi2DHkaausmDzb9Mw25grnvRzD2Ehy5axydpy5oTeQZtPcR	526	526	516	12463	18440	jwhijh6tmvavjqhJaH3RNrEUrLg7AykAQy6U5iXiN4o4JzdUE5q	13241	18637	18637	1619293860000
26780	3NL4MMVkf1g3h6qAVhapJMJMPB9sW6kWMBEJUfmHpGc7q96UMhMZ	26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	1631	794	516	12463	18443	jx7T4PDN7veB6XY1hGy1VE4ZGTQpA7f3fyCZ3Fpo36bTZGjV7rE	13243	18641	18641	1619294580000
26787	3NLg7hHzWJiBwAXXtbFM4tPDghg64ExX1ogBdaGazY33MygPgfpf	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1506	1127	517	12463	18450	jwgZkmSJLkj6bRhQRdXHqbqpqLaSJXS2kA5yfXdKrRaGJ4eiCmU	13246	18644	18644	1619295120000
26789	3NLyWF3QLZp581Z1BcaiQHE7ebo7uY8FWQDBEa1z4LFu1iDfWfVx	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	1407	1395	517	12463	18451	jw6tDMpB9KtVAe7vNCjNAbusnvKMsdRv9n2QYuPffX69SHWmdGm	13247	18645	18645	1619295300000
26794	3NKY3wsZZm95uwYrCvbyVzYiFQ2gEHS1Ku8GnjjKYnfvYwPbMQvT	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwex46nnxYpZEo3QjMXmjhrAqrLgTDgvw6ctFxWhcsULwKtTFPA	13249	18649	18649	1619296020000
26798	3NLn6zy7zS7nHD5uU47N6MnrdqBMy4TmeA9hC5LoQASaESEZvcb5	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1624	1334	517	12463	18458	jwWv3Lv5hfGKp76DejP8n4og9y15ctgapddXb24NJbzuAjAFL4h	13250	18650	18650	1619296200000
26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	596	1306	517	12463	18461	jxtAhLNDUbmcv7BjbMj5oBxwD66vS1ain3QZ2HnXoHVgZbJXTdR	13252	18652	18652	1619296560000
26803	3NLBTnwxrphSZwBrSo59ujZqZbkn4LX6nBaVtn4EF3CGfACcfosU	26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	1599	1287	517	12463	18463	jwP2FwBrhgK2tPCLceShwhrkMtVqdWyqTMsh1ue1rawXoM8j1Ec	13253	18653	18653	1619296740000
26806	3NKpnMN5KMksu3FE7av6K7mfBbhms5kHBeSmDqf7DuemZ27WCznk	26805	3NLW3h8FE7fZiyhzgLJdPuud2F2j34Rz7HHPFqZb183oFGcWPoET	1546	1339	517	12463	18466	jxWAXwsBvJcQins42JdXqtG65XkMVZxLLY7BkqSQxYQGXhZVtWP	13256	18658	18658	1619297640000
26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	1474	1203	515	12463	18384	jy2cwjWkUFHZNq1SHQ1jyRm15NGQ6AD9nbDGNHrkH7JZrDBQLt7	13213	18593	18593	1619285940000
26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	1474	963	515	12463	18388	jxjVtTrHZhuZ9KRgB7gHwzguDL1V9muM3k7HYjs3xb5Zr46zM9N	13215	18595	18595	1619286300000
26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	26725	3NK92DHiLk3t1eyNeR6L4jYDmSpUwJGYD4NRP7396Lfv5cziucn9	1406	1393	515	12463	18395	jwGLyZGZv5vafhpEtghRHdMPq3rWPMSFD2ei3nSwuDyUzgwrwMU	13220	18602	18602	1619287560000
26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1668	270	515	12463	18399	jxV2a95hq3jzJmm7KKrYyKeXp4GdZ8ES255SZK5HXdgbSJnK57k	13222	18605	18605	1619288100000
26735	3NLwjYj4T9GxyxHMZ3QEedUfcnXCmRz3KuBAMU9T49HCXyGy3Xzu	26734	3NKNcc9MBNExpQbfpXw8Cz7rks2VYq7KRhZHEundETBAM2ZqHdhX	1407	1395	515	12463	18404	jxtEyUbX5ELDi79TsP5wrLURVFG158HWArXj41mjU7LYhq96sqT	13224	18607	18607	1619288460000
26743	3NLCSgUE7vyqcbx7KQc8Qyk1dRHutiUxes3ZTLPaEnqZQYiKKy8h	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1546	973	516	12463	18408	jx6euMseGAz4865Ehi2Uz8kDadrP3pNzLygeTfYx6FQrT4KKfQA	13227	18611	18611	1619289180000
26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	1637	816	516	12463	18411	jxRkh6EzZgMhp2JEZG6Qfg7tFEy6U79MTGuv2abXSjxaYF8Mf2g	13228	18612	18612	1619289360000
26747	3NLFM4waNowaokNBNLARxPrpjdFZoxrzrFWGLsYwLqf1pSKv1SEY	26532	3NLnXZCM1dT6AKsVecvLtncYKzjLQCfYcX3tmdBvLgYuQU3LUfbq	1654	974	510	12463	18413	jxuH5y8NvQnhCv2PSQGTGva6g9p22ymjLq8r2LNLX1WjcehcmTR	13125	18615	18615	1619289900000
26756	3NLAhABCfxUX1FfFrNm2NooGHJvs4Rp2Pfrc6BQsVwXixL65VDVM	26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	1405	889	512	12463	18420	jxg5k9kGYyS7rvzjBkxs3smrnnZxRezaYA8vLYb8F1wHZnMtxrs	13157	18617	18617	1619290336935
26758	3NLZZq7kLhB8tgNh5KNeb8gFu1UzX9p8cCn3uukd6bkf1cDHbJRM	26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	1613	983	516	12463	18422	jx1WVTD1JJA5SidZkrfipi1Y6sDZtzEuKjkXsFbdnQdtoio8uej	13233	18619	18619	1619290620000
26762	3NLyDTwey9mEiF6uq9CCQHi59n7naizcAaUfzzPxvB1118qLH4xy	26760	3NLiAYYvRKxjxzbyyJonKxLz8opqYESGCTxWiNE5U2wvaPwjYzUx	1406	1393	516	12463	18426	jxn72aq9Gvjx3LM6kmSM9z8yDHhAK3h8vqpGCugGyZ5RhUnfumw	13234	18620	18620	1619290800000
26766	3NKeFGhsXAMFCNm3ysWXcS7TpWFY4ybHtqErsAGHEP4jJVAVp4dS	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1649	571	516	12463	18429	jw8hrCJdhxkt8LmMEt4vQwpL2ahiUNBmS8eT28MLJzUMgMQK2bP	13236	18624	18624	1619291520000
26767	3NKtJC1Q1ZEGAh2ovssk8ghueBFSz9wV5J4zZLjFfi6LMEWvHBqA	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1643	1299	516	12463	18430	jxHf1VdXpmNucY8eFNTqfhLKmBcqaQZKd7gdvXKoScBSCV2APLS	13236	18624	18624	1619291520000
26772	3NLw98D1MscZL2tR9d1PTtsdmNMmhLHHVo7nbJGK1TkgLjd5gFP8	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	1602	1123	516	12463	18435	jxJHFtBBTw195TYtCKATM5LEonZzriaXAecDY5SEjaFC8AM9zY6	13240	18636	18636	1619293680000
26776	3NLDgFN8Ctbiokjh5adkNVgFv3Wwzhg5979AVwbYGWNy7LH8rimn	26468	3NKVY3Lu5HWTQcTojYSXyQm5AJu4vpeM9VS1XocAMaRxTQThGFbV	641	1336	506	12463	18439	jwctY4UvTg95GrfkFvZ4YNfW1YtJwKhs7NyPyfqDDhZHKC19TYd	13029	18636	18636	1619293680000
26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	26777	3NKkdQ5UMVkBUidTcTExMkvXCyF4se5Hp5Ls9FwDKsnxX7ECqFGg	1406	1393	516	12463	18441	jxHDHdgsGmZLKrfuGZeFF9gJqRXjMeNyn5PcqwgjmYPxhijgtgU	13242	18638	18638	1619294040000
26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	1407	1395	516	12463	18442	jwLAAxm8YXmRBuLSiNxuoN8vrEx84gyaT7w9KBA8VmH4ZS9zLGP	13243	18641	18641	1619294580000
26781	3NK5KEqUmjGHTF3cFqMSyrk9JceFwhzMUCRsbK8AQUJdnDjncC2B	26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	1419	814	517	12463	18444	jw74aMQiNULi6VLiNmhG4QBhQYBFojYcLPoPWM6SQukt1tx8ik2	13244	18642	18642	1619294760000
26783	3NLcQmmN7M5penBaF39eugJo5yZpVSeQMSAz8jQhqPs4FudaErML	26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	1607	1348	517	12463	18446	jwfTS2AS9ZgNG4B2tm3fESzfSJxoULuyx8nY5PtsDEZ2MUNUw56	13245	18643	18643	1619294940000
26784	3NL21aN8H5uV2wS3WFWNVLjzbpybfAudsSFjhYSApqpwF4oQany7	26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	497	657	508	12463	18447	jwmEGM9tYYWb8TxaUpV2cwaGz5Vvj3wPYoQNXgac1M64et2qkh6	13094	18643	18643	1619294940000
26791	3NKKrhJ6Jeexyr4PBLZC76sK71LsF8kSBY442cRS6GC5CnvqZrTA	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	1406	1393	517	12463	18453	jw7S42qeUo6C5psXky34XXa8m3U33G58PY1P3xG54raNm4AwxtA	13247	18645	18645	1619295300000
26795	3NKoYiqYS8ik21afJ5AYvq1wxkkQAVX1gFzDYxkEFzTgWtx42X8e	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwDfy6mt4cDLkewFwmAW3YivbY48zTKZZZZW5HvPfLCySgHXaXQ	13249	18649	18649	1619296020000
26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1458	1323	517	12463	18456	jxm8PobAV3VBHTFe71dCAD4yLWNJ9MwhqnhaPjYCGTKzxtAnZQm	13249	18649	18649	1619296020000
26797	3NKYzqAT6QYAkSehPgTQcN2PL7HQS99zpvWyGyC78NHcoU8mYF2b	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1673	1242	517	12463	18457	jxBPVK4DJW9cAYmR9N63yA8SmuM4giuCSmA5qYLcULZ2mYmdYy7	13250	18650	18650	1619296200000
26804	3NLRXLNk7187sKyCM8Cu1zmxUano6EXWzK89MFLfyqGgy3KXXUwD	26802	3NLLkVxLveeFwZHGJsG52ZDviJJvutFMHHsuhfwg147iCCx2n3Xy	1460	595	517	12463	18464	jxe2KynDVATw9hPnUrhzSeiVFqpXFkCEGzjNgFJJFdz3JkYoMAs	13254	18654	18654	1619296920000
26810	3NLoLsXYjeSHv2mL8uHXAMxypeNEXmxx52bA5vRhYwDANsmAF3z2	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1406	1393	517	12463	18470	jxmDoBmFFvHR63RqGsr3PAD5o4ymkm9E96P599Qb582XqGDwS1c	13258	18660	18660	1619298000000
26812	3NKRdiDTazwTSxFbyyD5g7YHA3yLx1oo8XNy682cjAp1wP9a5GAT	26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	1522	1196	517	12463	18472	jxidSCrMkYopLDNMFGpgFuTp4sv9AcpL5zjjPCHxnCXpXJcutpb	13259	18662	18662	1619298360000
26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	1406	1393	517	12463	18476	jxGTK6L8Ke1dYsQgApPfYY5SRxGYQRqY9DyyrcYHdZh8YNFnZkf	13261	18667	18667	1619299260000
26818	3NLheLrwtd2P3D6YKTkR5KyU1hZocnRNbJowrDKcnC7qKF8g48LA	26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	1670	1282	518	12463	18477	jxcR2K4q29wySpapvaaau2j718xBAxSZEvc6tmvAnYiH3RAzBnk	13262	18668	18668	1619299440000
26820	3NK6T2kkSekAtPh3K5Aja9uwYeffv79CU4HAHS9ubEWUETNQjVzh	26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	407	407	518	12463	18479	jwqFSxMLi769zmRRh4axw92bUwkgcR6YRrthBbaVDMv1a8ZAEiA	13263	18669	18669	1619299620000
26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	26820	3NK6T2kkSekAtPh3K5Aja9uwYeffv79CU4HAHS9ubEWUETNQjVzh	1405	887	518	12463	18481	jy367E8uQnTg38jeafVttnzekdBhr1RyiR6J2Es1vGDhdAKyDY5	13264	18670	18670	1619299800000
26824	3NL8r6X1ALgJdKavt9fLMw98DViHvq9DMQBH6XBHgPf8jSQQqtUK	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1403	786	518	12463	18483	jxzEKRNnRWqP9KJ7beN5pWWE5B5WYpmKaSKAQRK5Xzqm31Uw9xP	13265	18671	18671	1619299980000
26720	3NLLK8AfEmRPw1kyF1WgTbt9ZseXBJmAmGjgWeGSFANMhuWFrMKZ	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1650	1009	515	12463	18390	jwtiJkZ4Jwys6gzbZCU27YHzWDU15VfxV8QAkjRsKMQSroSipRi	13216	18596	18596	1619286480000
26722	3NLjeFVCjgx6WtPM31TVS5bgWrFDSiLwnC7vFyTpmhQXiB3CSban	26719	3NKHFYBGPv33cGFwjMZKWb3cYkBuHWCKxUJJpsBNh3GyrWTQTpeg	1406	1393	515	12463	18391	jy2gjxfKbVHx1swnAZkjGVjt1x6wAVxxyWfWYcYWwWVxGAKZBLj	13217	18597	18597	1619286660000
26725	3NK92DHiLk3t1eyNeR6L4jYDmSpUwJGYD4NRP7396Lfv5cziucn9	26724	3NLwg2t9hWDg3KWGjiEf2wTc8fE92FitNjxdDiVbGsmrbNkS8SKk	1623	839	515	12463	18394	jxYVhWm2qCJktdKrf19GX2MohM2wz6Av8yhnWbziqYrw1W9UYVL	13219	18601	18601	1619287380000
26731	3NLDa79MQt3CRVvDpCQhNDS4J56GxgWfusSMzTiQGb5MdrVm9iLp	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1445	1290	515	12463	18400	jxYj1thNJvmNSX95WtJLX72Kh3rhFq1pdhBVwRwLMr1q2CHeCVU	13222	18605	18605	1619288100000
26734	3NKNcc9MBNExpQbfpXw8Cz7rks2VYq7KRhZHEundETBAM2ZqHdhX	26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	1403	824	515	12463	18403	jxByS3s7CBiHU5o9Kvo1pyLCGF4sZUzU1GQFacE1xh9ZwDjjcbS	13223	18606	18606	1619288280000
26736	3NLpPQig6E7ZL7am1Y3UvcMxjQLc2yDwExnA8Vpjmn6SveEdojxW	26735	3NLwjYj4T9GxyxHMZ3QEedUfcnXCmRz3KuBAMU9T49HCXyGy3Xzu	1407	1395	515	12463	18405	jwgABBdFhzD2JD75RKaLetCbA2J3ZJsX685GffyHGrKXVKJKfka	13225	18609	18609	1619288820000
26739	3NKp7vNqTrvfv29dgE5oHvEar1GtMLLDE3SPzjiHAQ9QmTfMRCHn	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1546	973	516	12463	18408	jx6euMseGAz4865Ehi2Uz8kDadrP3pNzLygeTfYx6FQrT4KKfQA	13227	18611	18611	1619289180000
26741	3NLsGQ5zXZLwZx6nKDjkvVzD97Fe76aPZcKaX5GCAMAtrXo2cNhK	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	64	64	516	12463	18409	jxT5RFCQSAUBbKzZF3JgYFGxF634RaEy9BJuMDCKuq4VxZMNpNn	13227	18611	18611	1619289180000
26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	1624	1208	516	12463	18415	jwm1nHNV9SYbDVXucrGZ3KDHS8pBkVhTLhbApmyTYsYc9u2eXXu	13230	18615	18615	1619289900000
26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jwLUWRA7fixCunprEojdF7juLxfe8c9pKBVofApUrAuQcpfhRaJ	13231	18616	18616	1619290080000
26754	3NLoCoq4QMw9RUErChNfRzBWk3ELQVs1N9oUwiHDgMofjBJ23TLd	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	1405	889	511	12463	18418	jwBM9nyRbo6a6bjiYUK3QbRKRGBKCwfgx9Db2wYQ9NQj3E1cWra	13148	18617	18617	1619290299169
26765	3NKpbokjXhwbKXDfwcyp7BcekY9mB7G8brNL1SLHfpWYA7v5iwmR	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1422	971	516	12463	18428	jxk3SjQH3bok5ShnBMN8zGWzWmRwLwPKfszha9fKxzFDBk6VTiN	13236	18624	18624	1619291520000
26771	3NLvJLu8t8QRAcJhV4MujHm5qZ4ZD32abCVtDDAY7KyucNWbmYYc	26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	1406	1393	516	12463	18434	jwMYrAY2f1LJLEM7yUJa51YGMP3dL33dS84s86npw7YqHBt1BfB	13239	18634	18634	1619293320000
26774	3NKEXpi2DHkaausmDzb9Mw25grnvRzD2Ehy5axydpy5oTeQZtPcR	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	641	1336	516	12463	18437	jwH3egsjmsyuQ1vTSB1HZPBMg5Hj1VS1gfzhZmiJHn8Ft4Q8Mtj	13240	18636	18636	1619293680000
26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	1406	1393	517	12463	18448	jwnyhp93B8yPFEtrWXynP2VeStUcyDjHmteWRbUni53D7qE55W1	13245	18643	18643	1619294940000
26790	3NLuDRpwAHf18zA9HtPpi91DqRejLjuHvACoxbMksCVakma3Ynro	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	640	640	517	12463	18452	jxCVjSp1d11H5zAUqB8MXcvabSBhEV5q7mKt3xp1NC38iSA3nKq	13247	18645	18645	1619295300000
26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	26790	3NLuDRpwAHf18zA9HtPpi91DqRejLjuHvACoxbMksCVakma3Ynro	1445	1164	517	12463	18454	jxeQrb1TTQnyjukQdp71n3Tnnd4z7NvAjwvohpHt2pWnqx28tKN	13248	18648	18648	1619295840000
26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	26798	3NLn6zy7zS7nHD5uU47N6MnrdqBMy4TmeA9hC5LoQASaESEZvcb5	1650	1129	517	12463	18459	jx1Ezhmha81asVQPdhLzdCKVJXfTVABuoyTyY5uA3W8HJC7SpFX	13251	18651	18651	1619296380000
26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	26806	3NKpnMN5KMksu3FE7av6K7mfBbhms5kHBeSmDqf7DuemZ27WCznk	1406	1393	517	12463	18467	jw7FUuqek7zc6x8EpCEZR6w6k9ceoxgQSF5TCMBoUcqPw27iqXT	13257	18659	18659	1619297820000
26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1407	1395	517	12463	18471	jwTfkDMWUJAxpJ5sF5Ef1cAJwLzgwVH9JKRCs7KUCVUJbLGrLDy	13258	18660	18660	1619298000000
26815	3NLbxdrFzwfbs2qRSeWKn8Kj2FzSCVrGYw7nX6L8UH8RmyeJioNq	26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	1407	1395	517	12463	18475	jxeCLte716LV92JBE1eNiem7V9nShgZmTs9wqKsRDpnD8LEauma	13261	18667	18667	1619299260000
26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	1670	1282	518	12463	18477	jwuD9owLrMsgVuZHMuGeVszEv8UuH1DvwaMCiBuFJfy8WWp3ohW	13262	18668	18668	1619299440000
26819	3NKTgWodxxJijW6WH3M9CSpRrpiVbwLUAE85uKiBdq5yfARizSim	26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	1397	838	518	12463	18478	jxR5f2VV8qhaQMjV4YvcHhodDtu9xui3HsjhUpoW96MAoU2dbH6	13263	18669	18669	1619299620000
26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1654	1340	518	12463	18485	jxvTMzbtJkCW4TbpPQg9Y7e9YenJojrFHUzLY4TEaKgZA6ZS11m	13265	18671	18671	1619299980000
26828	3NLQPfdVfDWNW3McFcctfEyBsfzgqwx4BsXKtf7tCdk8Ngg1h6qE	26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	1406	1393	518	12463	18486	jwJsahqWzJLNb6bb8Nbw4U7BXBfNwcdA1y5ZUv92JDdetL1Hr9B	13266	18672	18672	1619300160000
26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	1406	1393	518	12463	18489	jwNzqYEErTn6SHuSV1TFU7YPhseUk3cHjdqsXJkVFtRKshnjHwL	13268	18674	18674	1619300520000
26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	26835	3NLEkYJ8LUE2sWpjWTSFPWEYidifTRczoqNmqHqVg7ik6zKK16CW	1547	1378	518	12463	18494	jwApzCba7Sh9csWY7C3EfmpZ46FjJxZhWouVS8G3iULMQrXWCRs	13271	18679	18679	1619301420000
26843	3NKRVVhqwyaMt89xrP2nD4JifiwtCznDQxCsfy81ZAtcXaXB8FHS	26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	1406	1393	518	12463	18501	jwFokuS79rqMoSwv4BrUMEpXQjvobEtU9kRc86KcU3us7eiy4XW	13275	18683	18683	1619302140000
26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	26846	3NL2T3kxMhAR2DjDnKybHLYrNRckQLcVcVjUs4JJpaDi8fEnhYUG	1406	1393	518	12463	18505	jwBghwvkpGnv7gmReYHipkWkvnRQXbRXuNbnp3sJ5XRAhWvf4ea	13279	18691	18691	1619303580000
26849	3NLoAUapVGMshGLMpCNUcBmGVnmFkeJ5Hx5VWWRkA1VY8E78nA6k	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	1474	1474	518	12463	18507	jwyRmY5e5YCqSJtZroK4yrjgE4N31x5QcFNL8JkxjHGTDYftZia	13280	18692	18692	1619303760000
26854	3NLu5jjRWLPFrBPQUhpfvQ3z35MywpuyNTS1wuVsvT3BGmdgaCfy	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1406	1393	519	12463	18511	jwqbgufTthRjCLSvb8nZTPmTqsnQExthEuhVsxonTte4RKZTf8k	13283	18696	18696	1619304480000
26856	3NLTCQpTLfi1oVXjTYoP7m3pEurQz4ssyrGU3MuW4qcVXXvT3tdZ	26781	3NK5KEqUmjGHTF3cFqMSyrk9JceFwhzMUCRsbK8AQUJdnDjncC2B	1553	776	517	12463	18512	jwbW6dYiM6Xtdk6vwNrKui9ZMeeu1DVk9o4WttVT7v6cGs9ZtgP	13245	18696	18696	1619304480000
26740	3NLVsULm24shm9SdPLgFHRmMGYTuWepYPJSg6xJC7qCfbLwGKh6g	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	516	12463	18407	jxT5cgRoBXXrHgz5NNi4qiuGVQBvkiPQby4TpuM6yCmwprrsopE	13227	18611	18611	1619289180000
26742	3NLVFrj65JDfEHnun8bYGkbjxYzQ63KoCPdU3MC8F17DXK83297Z	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	516	12463	18407	jwt9SU4ekby1e6yHPGcJPELRQyJ37AZoUXKLxtEFKPsG3kZWG8a	13227	18611	18611	1619289180000
26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	58	1035	516	12463	18412	jxEmsQV7J962SHx95VekB9SeJxd65F6otJtKYZz68GXinaB4LQY	13229	18614	18614	1619289720000
26748	3NLFkap2XQXxAUfWowxuUqa6LwuRfTsQwAAA33gp2xxKxG2xEvuK	26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	1654	974	516	12463	18414	jwVexptiru3MqBDP2LEVxbxZpBYyYua4fdNC77xnUx3j65JnfmJ	13230	18615	18615	1619289900000
26750	3NKa9QDWSq6vPdubkstzSdex6doK9qS2Z7HnmgjKAyt2TAviqpB4	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jwVz4SzosRSD4Yi38p9hWqhMv6uQaMEQmVaAKiqsQFyGc83W8zY	13231	18616	18616	1619290080000
26752	3NL4u14WPcWK4hA55Ko89uk9iBVdm6tWs4C7bcvbKZW6AFUXE2cg	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jx2FEExWGwgLkh14SujqpeE5WehPzeatUu4nXxL22a5EvFupB5F	13231	18616	18616	1619290080000
26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	1419	813	516	12463	18419	jwc5dTQ8eMjfvKz7xf25Bii4x8uvT7MkNAWMoLB1REEnPNYAmi7	13232	18617	18617	1619290260000
26759	3NKN1eUKMR31cQLi1j6H9yr2VaVYcmNQdX8KAYRxYtuC88NMMWKi	26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	1405	841	516	12463	18423	jxbHFyjf3irnFXRmnz8JJwr3U4LcSjCUSSkwmXHTKxfTKBWAR8r	13229	18619	18619	1619290652668
26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	26762	3NLyDTwey9mEiF6uq9CCQHi59n7naizcAaUfzzPxvB1118qLH4xy	1652	1315	516	12463	18427	jw7utVPEjwC3uFdZ1ohpJZ8nnkEAY7ptediFA1JFbxCsy8gm8B7	13235	18621	18621	1619290980000
26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	26766	3NKeFGhsXAMFCNm3ysWXcS7TpWFY4ybHtqErsAGHEP4jJVAVp4dS	1675	1342	516	12463	18431	jxazif93J5ckKrR6psr6Wf9ihy6qcsq8hRF7fYwK5r5MuiiiDQ8	13237	18626	18626	1619291880000
26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	1490	1028	516	12463	18433	jxWwjXnFFzofuFbFT145GBzLGupUAxAp8YcCB1EmD1C9WvrFS28	13239	18634	18634	1619293320000
26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	1601	1388	517	12463	18445	jwzyH226T3fWAmabWQrUPuEJHZqRnZu3ZNo5C2zgXywacGu44e8	13244	18642	18642	1619294760000
26786	3NLVDVm2Mmeam5x7MQg5TTtWknarSrg68ftsi3E29AgYRDqPKt2P	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1672	1039	517	12463	18449	jwQMmDueoKusihkKDS6vAALFHVpm62hCJmJYRRBTT51rhhU1pet	13246	18644	18644	1619295120000
26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1506	1127	517	12463	18450	jwGzbTF2G1T2P6qS9v1wMyvWgzb2dytobgQWrKYnhhZWnekxvFu	13246	18644	18644	1619295120000
26793	3NKwzNBvBEhTnbHdZoVEJLpbaEhFuPc2czP3kzoDB1a2fTJs4hJC	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwcEFtzuSfMxJSbV9oDnB1DMfyBKhG9fWsc649Xa1zbohJzZrRo	13249	18649	18649	1619296020000
26800	3NKd4r9UPQcV4RK4L9HQA5f3QSMX8kXqbmfgGhkYRGG9uPYKUwWL	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	1403	824	517	12463	18460	jxvPtMsbAGpbcrWUx1efgyHWi2FR6gpk9XiS45hnJ78fJEC8PDm	13252	18652	18652	1619296560000
26802	3NLLkVxLveeFwZHGJsG52ZDviJJvutFMHHsuhfwg147iCCx2n3Xy	26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	1546	1213	517	12463	18462	jxWPiJgtwesqSmKxhCsZcCiLJpHmkwvManQsFpC9BAPZHawWqBu	13253	18653	18653	1619296740000
26805	3NLW3h8FE7fZiyhzgLJdPuud2F2j34Rz7HHPFqZb183oFGcWPoET	26804	3NLRXLNk7187sKyCM8Cu1zmxUano6EXWzK89MFLfyqGgy3KXXUwD	1637	816	517	12463	18465	jx8BDLuWLMSVnCJzEoGkudhXBvFwQxS9H83MRQRdMMCMtQz8cmu	13255	18655	18655	1619297100000
26808	3NK6vYYfAsbeRiZsG1W1gwSdzoHesvXuDQP7JyP4ZzQrEkH8Ewvz	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1668	1124	517	12463	18468	jwpR1W7gKEk5SAA3z5sQBtpgJ1RykgprCfHt3vZ9i7PrJypTszx	13258	18660	18660	1619298000000
26813	3NKEMp9uGEh5mRp1g9SCm2NWgSwHXbZ9ysFy5M4ocv2Gi3qryhGp	26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	1637	816	517	12463	18473	jx99zMH7zv8EjSaJ2SsEBMgVU3mYpeRj6opx2xsfMb1bFLMMP6d	13259	18662	18662	1619298360000
26825	3NLtAN6MYd19yNHZCVwm2z7kdY83ooTCKindUbtYX4vcxGkbURh4	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1440	1011	518	12463	18484	jxbG6erkkKfwBEp7dGcQ4pVFoKRMxu1ihk9LYnSFcnxMdCCxdQo	13265	18671	18671	1619299980000
26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	26828	3NLQPfdVfDWNW3McFcctfEyBsfzgqwx4BsXKtf7tCdk8Ngg1h6qE	596	1060	518	12463	18487	jxZZuU16YZmsFhQDFCeGFzg5L7viQWFPArdMv8FxjCS62QJFAm4	13267	18673	18673	1619300340000
26832	3NLZVBYGsXdZPnMDY65U2CAnmrAXVu6Ddq3JoRKYWSXDuRdVZfBf	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	633	1138	518	12463	18490	jxCf15xdVAeyBu4KcU8JghLiK1xqCW8QsLfMno2DBrFgvNsPdjn	13269	18675	18675	1619300700000
26834	3NK4d9CbZ7bB77gD2aeu3B7AYy2d8dXmH7ssNeG1NHHFZRzRtQnP	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	1631	794	518	12463	18492	jwfHvQNkEgPeXnB1CciQv4YsUUxUuLgJyjKYJM8y2Yux1RkHHKn	13269	18675	18675	1619300700000
26837	3NL1Zs616DtZX4KNwSvKA7msoTy8yz9FniqSetBApcppUEfX7Xqd	26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	1467	1250	518	12463	18495	jwKZJuVKJNb1w18zoCPYEWXwBuhBJcdbccc5KVdRrKvE3gD12oy	13272	18680	18680	1619301600000
26839	3NLfjPyzXKkPNHX7Hj8sDigy6tDPrXJfaWCT3v3k7pTyWA7CkBPW	26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	1403	824	518	12463	18497	jwWdjrxUAoXPcqaiQVdvUUBabiFLfDUeBcsEWyh6u7f4Psvp7gs	13273	18681	18681	1619301780000
26844	3NKYLsG5vkxkT2f2QgQCK8Ura5wuzKQLi1xeHkuzbqvWkShcbf8i	26843	3NKRVVhqwyaMt89xrP2nD4JifiwtCznDQxCsfy81ZAtcXaXB8FHS	1406	1393	518	12463	18502	jx5K4wwh7i7GmKon7nnvw7Xm2e761ouLBzZ62K6AZ8CbQ5UtU3B	13276	18684	18684	1619302320000
26845	3NLdzrSwufXdHcAwYhznFtL13vkRWWkjchqFc9RDEtS6aKDkpPLJ	26844	3NKYLsG5vkxkT2f2QgQCK8Ura5wuzKQLi1xeHkuzbqvWkShcbf8i	1623	830	518	12463	18503	jx8h8hpaycx22GJTvXYHA6fpRKPreAZDxDapryfRPB5u87diYTu	13277	18688	18688	1619303040000
26848	3NLWnXvTHkqhsXEeXVPTC6HQ2kpyjqXoCTE3VUPC6b1G3BC5KdJP	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	606	1295	518	12463	18506	jxKXMVGxiptG2AvTh1JiFvugsHaXWq1vkr2VhQVhQQ5uZq9F3GY	13280	18692	18692	1619303760000
26852	3NLyCyWKJ8RX8o5BKSFcSeNryUEzpnQedhDksBLq37XBhAgXnuYx	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jxvG8kvvhTAdCssWFN3vFKueXdMKZpdQV7jaHcsLzf5YtMrzAGd	13283	18696	18696	1619304480000
26855	3NKsRGHCc7sGq9cdYGpNTTWSJupw436SB5A76hjnYJDfAnQdSW3E	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jxywive9MdFAhguJJCVWucoBmJQ9WHcGTWGt1C4S9gLNfvv5pZr	13283	18696	18696	1619304480000
26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	26853	3NLnQyG2s7Paov9KRWPWMXoRKwNq2tNdEByU2udVwJNxxiGh1x1W	1457	1265	519	12463	18513	jwwJvqNYQTPUAA8LXWADpxdXNFb3pyUvQzrHWhotKZSHvJPRrX8	13284	18699	18699	1619305020000
26809	3NKcMwzwrVDwWc7JiWGrek27rsWgH2BTFEPEUrTqAdmc1USwpgZA	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	44	1199	517	12463	18469	jxruJUWvdtT4GoLQmideAxayFjAkzPdxXd69bF4xoTyiTXs18NB	13258	18660	18660	1619298000000
26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	26812	3NKRdiDTazwTSxFbyyD5g7YHA3yLx1oo8XNy682cjAp1wP9a5GAT	1407	1395	517	12463	18474	jwVje88BjF4aPRXeQUGSGuqXtp3y2KB5BbnFYgFiRipteTbMq9R	13260	18666	18666	1619299080000
26821	3NLK1AsAU5xNpS7qtfPrHJPFkWxo8QQE4BNGegtbVRc2e8v4jDgQ	26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	407	407	511	12463	18480	jwZBdzFH7PqK5VykBynjVxwJb87RaSQK889XRAufgErSpp67iu1	13144	18669	18669	1619299620000
26823	3NKq53pXkzawTeyQ1Azf3Azkbgs6PCCmencDcK1s2riYPwGXQcwD	26747	3NLFM4waNowaokNBNLARxPrpjdFZoxrzrFWGLsYwLqf1pSKv1SEY	1654	1340	510	12463	18482	jy2kBYED2j3RkqsLyErabxruNZwJ3PQFjoXCjCaCCEGom4fKFCn	13126	18671	18671	1619299980000
26826	3NKPJByXdTTfAiZRbJugWzUAuH9faZVCi5DKfxLh4Kn3AmqsCpXP	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1440	1011	518	12463	18484	jxn7ooPmkKVK5Btq26LyZdBtD7WpWFGVpzgk1SbMWasypKoLReJ	13265	18671	18671	1619299980000
26830	3NKphSE1FMyhb9XKafUSbeQZpnz7dRYmvjiXJhZVYWpaByZ4d5xn	26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	1637	816	518	12463	18488	jwGbLJT4heGD299XNSqTdjHaypVibSzK9xT4wszYvd8zeEdS58k	13268	18674	18674	1619300520000
26833	3NLmJNWD8EHTuxzg9tsBocCyxd2NGX2qSQbZ8SBLDMHWfs4qL8DF	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	1585	1240	518	12463	18491	jxA7UxcpwXvkVWrMCFTGFD7q5BPpDTsZTBPC1GWyjBQf2BgkhcP	13269	18675	18675	1619300700000
26835	3NLEkYJ8LUE2sWpjWTSFPWEYidifTRczoqNmqHqVg7ik6zKK16CW	26833	3NLmJNWD8EHTuxzg9tsBocCyxd2NGX2qSQbZ8SBLDMHWfs4qL8DF	1619	1029	518	12463	18493	jwCzE5gKa5UFye2UbMgTA1wMRtcerSuvFw2NyecuPoKJ1FjbkZn	13270	18678	18678	1619301240000
26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	1403	824	518	12463	18496	jwccT6mqEZ6VR6xRZKGixYJAnmetVT7C4h36rSUZTyyHN6Ev2Lv	13272	18680	18680	1619301600000
26840	3NKc1rUAj7zL3HdcRMLcwTTKYZKN1mpeJgyf6vTDxLq18qPU11zx	26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	1407	1395	518	12463	18498	jwWfzSMi1nRpNrxVWFpHuvzKrF2w49edrGQp2bd58rdwyn9Yooi	13273	18681	18681	1619301780000
26842	3NK9QmMYEGCZBu1VwdvknWPLGHrfKwhoUXhMExhhfrky4hqh4Jgn	26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	1403	824	518	12463	18500	jwTuiUG2CSqN4VJhoqtjevBUHtgpyqmKNY7T5WzyK7QtqFSKtwW	13275	18683	18683	1619302140000
26846	3NL2T3kxMhAR2DjDnKybHLYrNRckQLcVcVjUs4JJpaDi8fEnhYUG	26845	3NLdzrSwufXdHcAwYhznFtL13vkRWWkjchqFc9RDEtS6aKDkpPLJ	298	357	518	12463	18504	jwE9arzrHmgpKJkd2xYjBvnMd3upt2nngiULSHUF6kw9fj5ssJr	13278	18689	18689	1619303220000
26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	26850	3NLYfvCLF2dXhr6eyJSSDveGSSz4Gyj57k8dYuPQ7spSnttXqW92	1403	782	519	12463	18509	jxNNPKdQTCuto5YqaUHRMhRoFnz2jwDkGBEyonWGDvkincgCrHf	13282	18695	18695	1619304300000
26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1607	1222	519	12463	18515	jwZrpqnukSgW5i3oLMTH7zshHzDBHSCy2ykfJkQDJxrJr4s7JUf	13285	18700	18700	1619305200000
26862	3NLXra3V2ny8116xBGFmn7G8ACwoaFQndmpsK3m2nd34qynTQyQ7	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1407	1395	519	12463	18518	jxEKvNkgta88AAsZCPPkkgeani29A8yijj3PrXn9SrLGrswvfXg	13285	18700	18700	1619305200000
26863	3NLBa7y1SFSCycH7QKhYxFhJzoHon1KqVn3zgwBRKhc1dd7oUaoa	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1588	1026	519	12463	18519	jxZFr7xQxvbvyqiw2mJ6b4bQshcWEnPqRVmC1vPsaZKejoZwPpo	13286	18702	18702	1619305560000
26870	3NKKyAyfuRfRhf3JXjRj82ATi6kZxwPihAbjigC6zt98KZEacReC	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1403	824	519	12463	18526	jwonfj3qpfwn66xMNgdkEFM9gkJe6sSVJCVvDkNX2yCVTPL9FhQ	13290	18706	18706	1619306280000
26879	3NLWyzyYK9i6eHGq5AcvgyrTJwVAcxEYHRmdkSRENu7vhGiqByQR	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1402	868	519	12463	18534	jwZ3zu4uBVb9pfUtec2zAyARgyZLNEyW8pkmdKqcdj9STriSAot	13293	18709	18709	1619306820000
26886	3NKbaEUvKnPDpwcbLbEPerNU9j6jYY12C7hqoHJXt3R5r3zeGSHU	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1600	1372	519	12463	18540	jwVZGuo93g8uy8ogU6XEaeEYFppZ6Pn5tfUQxDGhhvVhkUTnq7a	13296	18714	18714	1619307720000
26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	26889	3NKHpBdNQfvgKRc1yiE31NeCJyApAZRfQPEwr1XWH8qiHCdBMtPF	1406	1393	519	12463	18545	jwLHQbYmGuN5JruNW9yVufvHPNQ7TrZweBtkkzGmBHASFChHyg9	13298	18716	18716	1619308080000
26903	3NKY1HnEeB6FN852c6un4fu2doCiFtJctH493SW9wfJJkKgANNkS	26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	1643	1053	520	12463	18557	jwfvxmFWBu6xKC3LhAmHMxFeQSjAuiXRLEp1sjdLiyaWTLrW4XQ	13304	18729	18729	1619310420000
26908	3NLNKTHQcwVZSPiRNi488MpDGKuRZV3DjVU6Nz4N4uPYiWLGWrps	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1476	1371	520	12463	18562	jx4Gg6ABNvxNRgJy1kvajakBFN6pWne9epLYUrS4wQ55c9ucRQV	13308	18734	18734	1619311320000
26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	26909	3NKY7x439L91krJ9K5nQdNy8jBraPMRUZongyXRHrbt8TTMnGPP8	470	1309	520	12463	18565	jwK1o3iqupecZXYzWPkFLBWNSJUwzWzMDV1fe2QPdecSReHhw6Y	13309	18735	18735	1619311500000
26917	3NKzmwyyh9BeDdGbG9EkKNURPWndKEkpduKZzT3EnVR2ygrwNafF	26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	1474	1329	520	12463	18570	jxKKdWDV5k7FHPB1Nf5KHkRhQwK3VMnKKMRFRw8rjdcXQ6yTYh4	13312	18738	18738	1619312040000
26925	3NKCZxjYDDeJTkh8GjSdsQ5V6usvqm4z5RhWkFWbPNyi6givRNCf	26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	1407	1395	520	12463	18578	jxVPou1DLZYenXemD8EwseNg9wbzrt5BJf2PuFXwCbAXYdtNyep	13317	18745	18745	1619313300000
26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	1581	778	520	12463	18583	jwGRoFEkmEepqPijEx5xUATzvuC7Vx12DyanPofofutGqni1qMS	13320	18750	18750	1619314200000
26933	3NKgmEbx1PwtMsatRERsofEDGPyq5gncrefiiUuTE2VVFhvAcU44	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1448	1311	521	12463	18585	jwC2rszB4f1PLGJrxLZz8AaGagdw4chyFg53hBCTUpVTAowcvbf	13321	18752	18752	1619314560000
26935	3NK5RdFNp6Pywo5P9cXAWi9Sa528sv7gTdhhSyth8rqncc3qx1Qv	26932	3NLeYZbwuWVMYbF6HJxxPabvm1WGXLHzXQ3RN2vU8yEyux3a1qxk	1609	1087	521	12463	18587	jwtX7Uh2NJG1DYF7pY1YBnuNBvj4YMw9b7Cj3HahMNHd2zbvWpt	13322	18753	18753	1619314740000
26940	3NKnj4u8TFXDwC9XLjPfPY1nB168pumkkpbDaEkk56wVnxffxmqx	26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	1406	1393	521	12463	18592	jxwbW71PTWb9B4aJtirYZaV2Wx1wjCrYGmv14d5y43Nf2VxXfvu	13325	18756	18756	1619315280000
26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	1440	1377	521	12463	18600	jxajR84y9JvQWFhRA28vM23JYhD4xTJJ7atMeD36mV6HYHUJHyj	13330	18766	18766	1619317080000
26950	3NLbnui5bBiNYbMXpNjtfTvdtBiKq5ctEKXm9h9bqYHgqfdEidNr	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1403	824	521	12463	18601	jx5DnqYEgt1bt9H4uSknkgTcdxwoGwKMugKPyNDmgMfg6EqHs5b	13331	18767	18767	1619317260000
26956	3NLMSL5cmbYQU8Wsc9gdaWa3FsRRAqi3g1GnjVeDfJF9BpfGyCET	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1648	1284	521	12463	18607	jwxzFThUNjTdUPtVumWVrTo7mWff4wdBqx6esqsRsg3DPbEqXfT	13332	18768	18768	1619317440000
26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	26840	3NKc1rUAj7zL3HdcRMLcwTTKYZKN1mpeJgyf6vTDxLq18qPU11zx	1650	1375	518	12463	18499	jwnQtdEzHokTTPkQei4HZ8Bygx5dBfkK2xACGfeEkviZK2JrF18	13274	18682	18682	1619301960000
26850	3NLYfvCLF2dXhr6eyJSSDveGSSz4Gyj57k8dYuPQ7spSnttXqW92	26848	3NLWnXvTHkqhsXEeXVPTC6HQ2kpyjqXoCTE3VUPC6b1G3BC5KdJP	700	832	518	12463	18508	jxr3K9zPF1obbnbhcFPVgz4XY5WbYLCy8GyYgGgYzAN5Ji4CTvS	13281	18693	18693	1619303940000
26853	3NLnQyG2s7Paov9KRWPWMXoRKwNq2tNdEByU2udVwJNxxiGh1x1W	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jwXWL2gzPYqrCZbB3h36GBjsVz4pj4BR8TatgYTLk9xGKbJTmy9	13283	18696	18696	1619304480000
26860	3NLxXSeegEP9LpmqmFArmk3CMjRhxxE8ciUbqySbwX61sF18SoXT	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1406	1393	519	12463	18516	jxA9JrauAKtxuHDTRzyWNtUYDSHninRAW8afZ5cD2tSVxthVme7	13285	18700	18700	1619305200000
26872	3NL5vAMkAjbq1aPmDfWsnbj6L4B4gR9oc2WVdjL3LMp3RiUS1LyN	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1501	1360	519	12463	18528	jwS3pLCn6tEr9fdm7QPkUkjJpzU56YX1HJK4tFMw1KT1cExQEmX	13290	18706	18706	1619306280000
26873	3NKTUcEHQxKtHeSiUyNyxT6A5VkebNXXFKwsv3XwTuurEsAA8PW7	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1652	1315	519	12463	18529	jxSSJbYPT1RfaVXc4md1FhZaH86Fpj1PJLK3NEPLMfHxoT799DE	13290	18706	18706	1619306280000
26878	3NKmHbtkJWVnzHRbMA71YACafeLxzKsX4YYPg7UnatdznWDpFV5B	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jwhvThA6uUt8o8yhie2SnGUJDura7XWjCFMyk5vz7cF4zfc5pBK	13293	18709	18709	1619306820000
26882	3NLvzRBngiPnsENB84c9N56idEVv3CQ7bDE95v2n9ZTviW9RgkZo	26856	3NLTCQpTLfi1oVXjTYoP7m3pEurQz4ssyrGU3MuW4qcVXXvT3tdZ	1553	775	518	12463	18536	jxuCCiZqtG4BwqmZ82VBqGAv9zvGdwsDrsvJnTMCe2VxbFj3dEC	13246	18710	18710	1619307000000
26885	3NKNC5EjGvPKQEssouVQbQtAhfWDndew8zRjzyGSQbG4gZj4GYDA	26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	1460	958	519	12463	18539	jxFautUrxDMaHrGwWjSvVaikUy97mciaQi6zjEbHKzqV22Fn1G9	13295	18713	18713	1619307540000
26888	3NKjb17DthVRgdf3DZ1U1znvjzMZKrtBws5PaHfuomT89PytXoGy	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1519	1519	519	12463	18542	jwM2yZowunoGTCxnVYNDvY55M6ZZMf9YtgF9ngg1HRsgGjzgpFS	13296	18714	18714	1619307720000
26889	3NKHpBdNQfvgKRc1yiE31NeCJyApAZRfQPEwr1XWH8qiHCdBMtPF	26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	1402	882	519	12463	18543	jwrTvXWyjEDG5ibyfUAuUP5xZ4WDXNQvYGo7U1DchJbbDQRPL4x	13297	18715	18715	1619307900000
26893	3NKH9aHRjPXdBH298upxkd1kQpG4gneN9LKXDXfPfuEpBaN8wsQr	26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	1397	838	519	12463	18547	jwgv58TSo7CPtNWDFD4T5t8jKTCVrcckE1b5JaQ55MizfATBmdH	13299	18717	18717	1619308260000
26899	3NKynasAzS3vcPH9weU7fxzzuMTb9ycFjEVNyo88U5ufpa4intHr	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1500	1297	520	12463	18553	jwmURTAKAmq96wEUSbnZG1a2wdvyodCf7z57uZ7aRFhggmWsPtw	13302	18726	18726	1619309880000
26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	1447	1219	520	12463	18560	jxpgopjxNA4VHfgWr58yyPQSiQPoUXL9Rrnota5g19f3mdLuFsx	13307	18733	18733	1619311140000
26910	3NKTbv3h5jcXpSjfuTiLSEEG8Z7Mgid6HkeFDHzuQgrc4yxKhcgd	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1448	945	520	12463	18563	jx9gJ63QcJ5NLZMMXLfUAz5GaZDH9pQBx7wxP11Q9WHSZ7uUvPZ	13308	18734	18734	1619311320000
26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	1508	1387	520	12463	18567	jwArVJgYGeaNdiGjEVSasoaan8PZXCJELVrUhrLr8kKGPLBQboE	13310	18736	18736	1619311680000
26916	3NKnAWB3YNVPpG1ee443DpxjAEaJymcwDV8YLp4SJsD52ChJEFt8	26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	80	1273	520	12463	18569	jw8HS6DBALpKBwkVMo2deK4ToRAHvN2p3LU81N9QAfqC2dyc5yX	13312	18738	18738	1619312040000
26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	26918	3NKXgSMZY8zUa8YJgLaBPBTxqjQyrfkff1CdAvyxomfimExp6tuU	1406	1393	520	12463	18572	jxxSWxZ9p979uhBd8g9iqp6cUoeSRyPqRsqdNHdENckxsrGsEF9	13314	18742	18742	1619312760000
26921	3NKYxFgWGJqZD94AQn769AtoT6xBeyMuSBBiifHqeADfkCPS9PN8	26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	1587	991	520	12463	18574	jwGUv3aeNZcs1JekX4dgoa5GrxXMJyS8AxiLobfRM2FUpUMCgQJ	13315	18743	18743	1619312940000
26922	3NLN5FJ1JVhSG3dtzqyWhEzNeTNqizTJN4aan3Bn1cWg4vyPCSEA	26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	1406	1393	520	12463	18575	jxxZ75dECVMhfAsaVHBSbcyJY9A9paJXDDkW5yxG2H5CWWAb2bx	13315	18743	18743	1619312940000
26926	3NKXwYZf18paQVb1UgP32XKRctuL6VMPqjxFVprPmivVRBtwfWsq	26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	633	1018	520	12463	18579	jx2BExpP3TVz7TU3VyGboQr51ryG5KerBqmAubneThCVdwXM9A8	13318	18746	18746	1619313480000
26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	26926	3NKXwYZf18paQVb1UgP32XKRctuL6VMPqjxFVprPmivVRBtwfWsq	1407	1395	520	12463	18581	jwB6YSfnrZM8FMGdSwYiNjhE9SoNKAwK569rZ8YADuY4QoE6Z8t	13319	18747	18747	1619313660000
26929	3NLkfQamYvca1ezhr1aCCcskuV1od3v1QjeWS9hQ5Tqh7B7e43M5	26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	1458	1077	520	12463	18582	jxyFoXebk4hfZRRs4udiKDJbu3eGSfHXLBonWUpLhz5Az74Fd4z	13320	18750	18750	1619314200000
26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	26935	3NK5RdFNp6Pywo5P9cXAWi9Sa528sv7gTdhhSyth8rqncc3qx1Qv	1403	824	521	12463	18588	jxHCEy8gQUrJkmnWqHotrM2d3iorFyaKnRphB8G9mvDKxrHgBjp	13323	18754	18754	1619314920000
26941	3NLyWbLy3TcBuNqytePRkrVK6WNfxGCEeSKxP14V69mHYCTmkX86	26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	1675	1216	521	12463	18593	jwAfYJhJFQ2hxzTMR4yZniTU9EQZNQKjFWZteC7F2msBuKQxNbL	13326	18759	18759	1619315820000
26942	3NLTDojuHxUj2NF4mvSW7KofJ42ZNid2ksMBBENY39vjUiyMU8kK	26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	1406	1393	521	12463	18594	jxNPJx1Uj9ByYKPKtagg2cfjx4vdEbhtY7qcXUHYdrijQnKhNRa	13326	18759	18759	1619315820000
26954	3NKBoGQGmuviRZudMbc3SYW3KzcyXS4qZX7TdUvm2K2qD1tCCqqX	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1483	1030	521	12463	18605	jwW7V9R4Mut2vey9R1FV9feuWG8t72vp6H4iXLLPsD3dBdevRok	13332	18768	18768	1619317440000
26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	606	1295	521	12463	18610	jxQgVPSbJxg6g34VFyacTNe4guZs1nQRvXUQ2XJyGEskvYADzpZ	13334	18771	18771	1619317980000
26963	3NLvw3w5qZ1iBsebYV8e1MPGdgEWZoNMGhxW91EJwvo5PoAUt1ng	26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	1627	1385	521	12463	18613	jw99oN8EtkxNxnGbE4aPkpcd6QGVs1yWfku3YfCvYW8bv85qYBi	13335	18773	18773	1619318340000
26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jw7itEsKLtqwRJ5WUaNG12z99LEiesGDuvaXK3NVF9A85nrepMH	13339	18777	18777	1619319060000
26976	3NKKWrJzCTYPhmh79RbiTec9D5Uj39yMQU2NaD8EYMP35Xmnmzfq	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1593	1220	521	12463	18622	jxDDBFUp3c9LHD3rvFLgneh4H4BFhuEYuC66FiTpLAEJFsitTvT	13340	18778	18778	1619319240000
26978	3NKsbhohhoM8zWcVqJh3WUe6LhmbksrsTBfkEiUyQX6wnKzFnfrK	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1624	1334	521	12463	18624	jwW5AU4CZ4GUzpedCVfVGtKCHZqWXkfQLHo3zvqipkMeBuX3FrT	13340	18778	18778	1619319240000
26858	3NKofA4BgGYzDS1DWJeXZWW8nkhXJAvjcMxbLw961ddfJetCMgMC	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1403	824	519	12463	18514	jxUGkRGyzSuJwX5mTr82jyWJPfoZSMNDHHsyRwnfELagZ5rAqU8	13285	18700	18700	1619305200000
26861	3NKHBG6iZ7EALdpAFYvht1QPsLCUwLTe6o54T9KiQJaCYp7AHzSj	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1607	1222	517	12463	18517	jxSKFWCsvqnGv8Qu3AtfaLLDKxFeMMZwLPGjY6pN5nb9Y76Qx4s	13250	18700	18700	1619305200000
26865	3NK7DMe77iULxPjcVg6MGrhdRLrD6X9LYuLFcGezVeAJBC3K7acV	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1634	965	519	12463	18521	jw8pTnQueR9itFjQkGKjcoRSnjFK8VGtWkwZW5DuUzY4XgKUtme	13286	18702	18702	1619305560000
26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	26866	3NKdnkc5HGg8ZNr7r2UyUN8SKAgnG8uaHf3VtMuPN9RsGXiDoUUP	1639	250	519	12463	18523	jxroLb4z9ZNn6ztBhRQ5hjmfpmo8xJYcDg9kL8sw8U84CYzzkCf	13288	18704	18704	1619305920000
26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	26873	3NKTUcEHQxKtHeSiUyNyxT6A5VkebNXXFKwsv3XwTuurEsAA8PW7	1577	1201	519	12463	18530	jxjyrBU4Cqk7yCZ6Ujhto2K8qg1kfqSM6VKZa2LnybfMBN6yLAe	13291	18707	18707	1619306460000
26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	1637	816	519	12463	18532	jwFksn8i5wth1R49NFHazuZMHeRR6e1yFceU7XEXiH2ddmDoCWE	13292	18708	18708	1619306640000
26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	26879	3NLWyzyYK9i6eHGq5AcvgyrTJwVAcxEYHRmdkSRENu7vhGiqByQR	1657	1218	519	12463	18537	jxo4VKxW1bHk19D3VYDzYifEXZR8PsJgEUna3iXiyA9VKkN35bj	13294	18712	18712	1619307360000
26890	3NKnNyS19jfnbkCM5JeAk14W4wL3tePNDbQESsU9AruJD8a56DfA	26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	1407	1395	519	12463	18544	jwyJP9tYahky54CDxugkSr4NFPnzcoh992ftXduBeMrEbPAozV6	13297	18715	18715	1619307900000
26894	3NKAKDVSSshnVjWiC7YZAW83S2wBiHjHX4mXdpRm4MR6kqLb62Rs	26882	3NLvzRBngiPnsENB84c9N56idEVv3CQ7bDE95v2n9ZTviW9RgkZo	1553	776	518	12463	18548	jxKUT1v1cK6httkxQycYyfGDhbYbP6q2Bmr6HXT6isogSaKbu4o	13247	18718	18718	1619308440000
26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	26895	3NKrAYMrPVqUugbzzQMVPwSJpTKKRyX3bzD92u5aMtyVrfC54EV9	1594	960	520	12463	18551	jxjaswsrqenQnoXWw35HMPxkkc3wcmeyvQkGcz5MoTcS6iJvpai	13301	18722	18722	1619309160000
26900	3NL7RoXWCqMTdwM6N2UYzLGiBbHXtQoYsCNZBhiXMLQTHN9wZFPf	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1406	1393	520	12463	18554	jwse5FDT1ShW2rQg1XLsr9TopiQ2UaWZs9fik54SZ9RGWZaVwg6	13302	18726	18726	1619309880000
26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	26900	3NL7RoXWCqMTdwM6N2UYzLGiBbHXtQoYsCNZBhiXMLQTHN9wZFPf	43	1310	520	12463	18555	jwWMZ5acrQy1NH3oUekxt4xYDBfAQtKJFyUfVnksGVtdjDANMJS	13303	18728	18728	1619310240000
26902	3NKFYPv4bjtsijANhkLwKA6UaVf6nEVp5KW1obD497e51u2pxjYB	26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	1608	1289	520	12463	18556	jxk1a49DvuNCa27z8EcAtchPPecgt6mXkRBVbXjoBtVPpYi3WLG	13304	18729	18729	1619310420000
26907	3NKpzo1MRsEDv66xeomgEHUvy6frABKwVGJ1ygPPgM8atGjHJiYC	26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	1649	1137	520	12463	18561	jxCvTVEWCKQcttxSKxAQ8Va6DcZkMT82WeQmd55F36upasy6aeH	13307	18733	18733	1619311140000
26911	3NKWYh5dTn6gRgxQM8EUxJiCtxoZ5UNE7cG4gMfXy5knYVgUNpYB	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1406	1393	520	12463	18564	jxZxQCKkx6cX2mzb3xsVMjipu9f2PoYN94gCCbGdA6XAn2Ebyz5	13308	18734	18734	1619311320000
26920	3NKEAgc6rQVF3xVooe5Gqw9wwppGJC1a1VkCJKsRxJ3NVsfzZTmP	26894	3NKAKDVSSshnVjWiC7YZAW83S2wBiHjHX4mXdpRm4MR6kqLb62Rs	1553	776	519	12463	18573	jwsqzBjXaZVzabdbSi6PH1VLYJ6xb5YSJhGxfUif8nhxfXV8omD	13248	18742	18742	1619312760000
26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	1622	1356	520	12463	18577	jx2f2atPLoJLMLTLhDuQXPjJW9Sf8sDtFkNqQSePKLfne2BX8jH	13317	18745	18745	1619313300000
26927	3NLSeJHnkb1zQ3ztF4u89fNbqYhS2ssa9n2jfZbE2sGfnDa2Nor4	26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	1406	1393	520	12463	18580	jxW77ghTkZrZod9x9i5VU8bwwzFar8hiKtSSUwWoo5xo6Mmjyby	13318	18746	18746	1619313480000
26932	3NLeYZbwuWVMYbF6HJxxPabvm1WGXLHzXQ3RN2vU8yEyux3a1qxk	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1448	1311	521	12463	18585	jxcqUmRv4Y83dNJfkQrryuewdSLUpk9raARJ7B2YwjbKpHpjH32	13321	18752	18752	1619314560000
26934	3NLMYrTyDkp1ZeB8jsZ5qYfY3PwKQGmPFnVTqRcV6s4NGYK9RtwW	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1581	778	521	12463	18586	jwGuMMN7pQJnmCoEUzNqykzza8Z1fqRS3qa3vX5WRi2r4RzyEo6	13321	18752	18752	1619314560000
26937	3NKcFoPMrGhGt4ZEUBMxM5t1WoSrqtLLAfTpPvyDYBG3RmnC1Szd	26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	1619	909	521	12463	18589	jxk4xDfU2BQRrZJ5i1ST1xY96K8W2JSDinj417X2mfVYksDX1ix	13324	18755	18755	1619315100000
26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	298	1308	521	12463	18591	jwKWw9KQPL74xUmFrxKikyG9f1AAuvrTjconENTchduqohDRGfX	13325	18756	18756	1619315280000
26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	26941	3NLyWbLy3TcBuNqytePRkrVK6WNfxGCEeSKxP14V69mHYCTmkX86	1406	1393	521	12463	18595	jxUSW8PSgGyM4H3o1PhUbxzz7jjCuMJ9t7HxEvNbmpSKmYz6sV6	13327	18763	18763	1619316540000
26945	3NKLbEp6Md8BLzYoZdvKkBMQenEcDghr4unrsiqbif5CkW2zYCMF	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	448	1305	521	12463	18597	jwfMCrX93WAc3EfGjmRK29jv6MgzznZxmvyQsufsx4QwPwWQHCJ	13328	18764	18764	1619316720000
26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	26945	3NKLbEp6Md8BLzYoZdvKkBMQenEcDghr4unrsiqbif5CkW2zYCMF	1593	1220	521	12463	18599	jxLAmCorALgH82gA8qoxv94LRZzg7A1FG44QYheRGbrjTskEBVZ	13329	18765	18765	1619316900000
26955	3NKM2Lrw4x53UmXjGSBG7ihyQSuTC1MKhYBSe1jxquE55LBz5Y7X	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1547	1378	521	12463	18606	jx7H5J3FEzTQZk854ECD77TN88isXtcK6Yn8gwoAMFbH25iNHCB	13332	18768	18768	1619317440000
26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	26954	3NKBoGQGmuviRZudMbc3SYW3KzcyXS4qZX7TdUvm2K2qD1tCCqqX	1509	1320	521	12463	18608	jxF4cdN8Qio8HncbEVi2bgHCL6RxD6tTd63aFcBeAFt7AXbFDLw	13333	18769	18769	1619317620000
26961	3NK3mK1Y5aK6yG55QNY7n6XjBhNutkBbtYXKawLUBBd8bQjVszGo	26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	684	684	521	12463	18611	jw94CERf8miPMZ9PoWsjcCeb2VrTEY8XQGkP4fCaF4Hm8kq9Ng9	13334	18771	18771	1619317980000
26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1402	862	521	12463	18616	jxi1SmW7Ra8JDCZr3SU82qMXudJRzS1FJzTtmXsfHGiKAMCo87e	13338	18776	18776	1619318880000
26972	3NKS97mEQBqdKF8grx64uP5CLPNMe7tvEsw8wRM1pDs5gThpH9jw	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jxX5fWNEjRaEn6rubVc36YcrwWMqiGTjRJqxWB3QUrMvA6tM5Ww	13339	18777	18777	1619319060000
26974	3NLjNCrnDCtCobL4qZvfmAFzckBvrdiv2C4rPV6dGy1aFjzvG5J5	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1483	877	521	12463	18621	jwFrBtCA5cpajm7v4q8WAgrSJBKrHyaXKy8ZLxxPuGR1FdgJAdr	13340	18778	18778	1619319240000
26977	3NL9BteEuGKjc7dkt4VQfNppDGTbuKX34KjHEozxqTDPe8GvM2EC	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1501	1360	521	12463	18623	jwD3zUKjoGJbRfiKuqjbSNUD4wMro193nwSSWF4cDkHs7vVCh42	13340	18778	18778	1619319240000
26864	3NKaV19o65deYHXpyaZ9kASkRC1LPUrLh66478Bn6CRbdd7ZF9Qc	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1460	293	519	12463	18520	jxNynz4odwXBvnCkzvJQiR9hfa5Rxo5XAyfoGqsJGRVbesiyA9k	13286	18702	18702	1619305560000
26866	3NKdnkc5HGg8ZNr7r2UyUN8SKAgnG8uaHf3VtMuPN9RsGXiDoUUP	26864	3NKaV19o65deYHXpyaZ9kASkRC1LPUrLh66478Bn6CRbdd7ZF9Qc	1407	1395	519	12463	18522	jxXpu72FYK3rtRJMgXQwoMCqVijKtSFgu1hKUkDFsmo4eNHrddE	13287	18703	18703	1619305740000
26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	1600	1126	519	12463	18524	jxgMv9mKuMoKNSb9jKfZmCuCJjZrHJRfVt17DSmyRHEMmgszMMf	13289	18705	18705	1619306100000
26869	3NKPcpQ2KC2xdd3QmYzRTR141JmKF2r1QGG3Ck1PcEKuw4pDFWgB	26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	1560	1291	519	12463	18525	jwjv8o4WShrL9S9zCnQBucB6JTBWt3i1dVnbQUHcgyZGQpsak36	13289	18705	18705	1619306100000
26871	3NLKo4J4cXGRSZvc4qSv6fVfRPDQnwBSoErVfpoYLJog5x6nLSGs	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1668	1004	519	12463	18527	jwLQbHkGNLhMMqR7g18m2PQnbcLb4ATR8qEzpKSMiWku12ts29x	13290	18706	18706	1619306280000
26875	3NLrEw6VRxL2ZYNCYow8BucsLiaKwmT1cGfRTT2UUjVbXq99DHj2	26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	1559	1227	519	12463	18531	jwNWsYELJRhfd2SMKw9B3ky8sP6M8pdGqTgrr8SaJmRWpcgnJfB	13292	18708	18708	1619306640000
26877	3NKEJhMVKT3gYWznhebaep1bfnzRFpPnR7KAaRHH2ZsgNm4DGyMR	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jxuDtnCmgnPe1fYVx5FSnNxSyuqpVATAKZgAqRX3SHK9rkF7SA2	13293	18709	18709	1619306820000
26880	3NKmEpYKPsKVZhNK7uub6io4C9deEDEYHXdHfBWS7eq7Uv2dGSxa	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jwuxVhNaoFTeAQ9LRXvd1wgUwWCU3NUGWUtzv8CH9feQBg9jqpm	13293	18709	18709	1619306820000
26881	3NLD7HVAnM5Jbuf7AfAGQNiGaFPYpECKTU6EZ6ZUpu1Wze8rY7JC	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1534	256	519	12463	18535	jxEsfQnzhL2VaRuKGD8Xb1qNg7JEcGw1UXmvLP9eaN6fc3Yp3VG	13293	18709	18709	1619306820000
26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	1403	824	519	12463	18538	jxJcCbRYfss5iqpyQ5nDeVMmVnnaVzoN55YGNGu9XPppYepnUMA	13295	18713	18713	1619307540000
26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1406	1393	519	12463	18541	jxZi2WuCspzUo2adDEtXyx2X8gowoGZFwoJdCGhXYdPPB8MF2rk	13296	18714	18714	1619307720000
26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	1542	1304	519	12463	18546	jxAnbsZZyaEn9hfhAmfXpqujQB6sLWvPQ4aCjVU7iKFJRdYCvho	13299	18717	18717	1619308260000
26895	3NKrAYMrPVqUugbzzQMVPwSJpTKKRyX3bzD92u5aMtyVrfC54EV9	26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	1589	920	519	12463	18549	jwzByknJ4um57rZEb39KdPmmhRCgfUMnnpQnepWcDahFzAvDNRi	13300	18720	18720	1619308800000
26896	3NKn6C4aK3stDW2ib8NX1e8wtEJLgLEg7MLGp5vyqV1kCdAXUKmd	26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	1579	1143	519	12463	18550	jxEUbAWfNrBNz3ndVdsKyUWRUsi4b3UUajHGTqEwEJp1usQ3Tfo	13300	18720	18720	1619308800000
26898	3NLJY2xTMoNtjrY291y8Uo22B8c2ddeiCKM7qxjXXP8NpmSgRKaX	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1444	1381	520	12463	18552	jx3641cFZeny4biz92MzURgrmM3XPejiRishYfmitf28N3q8zzD	13302	18726	18726	1619309880000
26904	3NLumVj4KQGygPwnFUiU3d95PEtzPBV1mZkwsQEqrADE2NCkH22g	26902	3NKFYPv4bjtsijANhkLwKA6UaVf6nEVp5KW1obD497e51u2pxjYB	1407	1395	520	12463	18558	jwF48uHuYq7Fys7ssHG8jw6C8xF1XDjqs3LswhQAto3mXp2HjwH	13305	18730	18730	1619310600000
26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	26904	3NLumVj4KQGygPwnFUiU3d95PEtzPBV1mZkwsQEqrADE2NCkH22g	1642	1001	520	12463	18559	jxZWLodCDJp8vYx5CDYxmDDuPTNmsQoLMFbFjWYre9EMqieLVwF	13306	18731	18731	1619310780000
26909	3NKY7x439L91krJ9K5nQdNy8jBraPMRUZongyXRHrbt8TTMnGPP8	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1448	945	520	12463	18563	jxpkqboz9uMCGyLgWyNciUBEd3n4obSVmY8zAAHtq2xWPETHgdE	13308	18734	18734	1619311320000
26913	3NL6M2HmVSfxL7xdPqzVNUHKBXheTVkfu7ggbvwhketHDUQCbsYK	26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	1489	1254	520	12463	18566	jwPiTkEzq3mgDYi3sKrYRbJjwqaHCQmsFgHyTuy1wfP4SKSiyrd	13310	18736	18736	1619311680000
26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	1671	1119	520	12463	18568	jxQhSBaMj4RdKVMqd7Krmu3WpujPYcZ7cbGkYz3EiXbDyD9Xjp2	13311	18737	18737	1619311860000
26918	3NKXgSMZY8zUa8YJgLaBPBTxqjQyrfkff1CdAvyxomfimExp6tuU	26917	3NKzmwyyh9BeDdGbG9EkKNURPWndKEkpduKZzT3EnVR2ygrwNafF	1460	1324	520	12463	18571	jxNiAZQjxT2LwZRtgexN7vpkzEZh21nWBMoGJjP7bhjuobQeE5K	13313	18740	18740	1619312400000
26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	26922	3NLN5FJ1JVhSG3dtzqyWhEzNeTNqizTJN4aan3Bn1cWg4vyPCSEA	1406	1393	520	12463	18576	jx7DRoYSS9prZfC64HHfVvczBmucqveb6ThnneLLXm8HXRzwYYz	13316	18744	18744	1619313120000
26931	3NKCZT4MVp5kxGPReTGJ7JwXiBAm7o8oB2F5mgEf5Co2JpGbjC4e	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1403	824	521	12463	18584	jx3xYPzQbNDSSbbUhycbLM188bSXbeQDZ4TckXzr22GddiwLbAG	13321	18752	18752	1619314560000
26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	80	1147	521	12463	18590	jx5neuVWDW75ET21DWV7pw61a4f8xVXWD9jLWGwtVgTXW1Gv6ic	13324	18755	18755	1619315100000
26944	3NKUHe6BN8Apjsxdnerfx6PbxnwzYJ7jn75BZjRqXQaYYfHKY6wf	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1607	271	521	12463	18596	jw7VULYkmvnaCwoBEaxj2oZwSkasHTwZUQY5hCz3fWSxDsJk9sa	13328	18764	18764	1619316720000
26946	3NLT2tk1HCtw1qQJaqJRgcsgRjh6jWcD1h1Ri8zYPPQRq6e7bx5H	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1614	315	521	12463	18598	jxCTDsHS1L2Py7NM9hiatVJov9NFVcTfdfZA8fQ6PWeUjATwW8j	13328	18764	18764	1619316720000
26949	3NK9Zp8HBmoUjiYNQGCUjrLxHQ1THrzeJ5SYPAdyhDBTLGCVdCap	26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	1440	1377	521	12463	18600	jwV7KDwDsuvKkZqzdCnro2VG5jPPBuYBwJy1BDzmmDheRbeRmmc	13330	18766	18766	1619317080000
26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1501	994	521	12463	18602	jxHCVj6CAzjvs84WP7jWr2EdbeWUHdGbvCFwrmvDNMBzbZjPCkb	13331	18767	18767	1619317260000
26952	3NKy2ivm2ZmEXpXhrPkdMxraUTWB8B3abRV87VETtbQ6jSya3CET	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1637	816	521	12463	18603	jwmpT3NsUag8roD5CUVQa2ihDqTPkzVDBFAsVLquoCfrxbhwBMV	13331	18767	18767	1619317260000
26953	3NKwYprqYHJQ4hFx7hyKwsU17P1ZFdVRje5CCYeBkhgbC2rBvtwB	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1403	824	521	12463	18604	jxaja7NrgTMfWVDRYxfgVPPpgZi7ygLiTzUD7XJqx6abSZEwrWp	13332	18768	18768	1619317440000
26962	3NK6kpNik24wnKcV8xWfyfjFi1b1e3YrLFMaZWt5tn8z9YPNSG4h	26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	1476	1125	521	12463	18612	jws7JsmyFJfMVpEmyQ5Jncv2XqSby4e4pvoMDjVu5JabFXhEFFR	13335	18773	18773	1619318340000
26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	26964	3NKJrHatYQmbKkuEhEGHRbQw2S3Ag29rMWC1veBxtnEGhvYE7dN1	1637	816	521	12463	18615	jxH7bnTsYQp2FAv1DsSVcoz34Uh9Gebr78WVuVRNbqtbxYn9Z4C	13337	18775	18775	1619318700000
26957	3NL4Uj8sRbnFF8qSBPUfiAnPCry7nvuFDnd8sQ58W8RsdNLy9mLS	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1547	1378	521	12463	18606	jwRusqneBYV5DniwRryc2HSPkGmUwBHvDZUi7mYz2mF2436zoRe	13332	18768	18768	1619317440000
26959	3NLkDmRs79zXjU2qSww6yeQXafnjSZYktJu7Ms7m7Fqh5wFofhqG	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1406	1393	521	12463	18609	jxvqn9kqdeoAJatd1sRLQXryfEM8FyRT9rsfSSHGKSsJs1MeSbC	13328	18769	18769	1619317620000
26964	3NKJrHatYQmbKkuEhEGHRbQw2S3Ag29rMWC1veBxtnEGhvYE7dN1	26963	3NLvw3w5qZ1iBsebYV8e1MPGdgEWZoNMGhxW91EJwvo5PoAUt1ng	1607	1102	521	12463	18614	jxWgpHpVpMDZuejQcZ5DfFcCJ7R14u3NuKitVBUri4DTxfFMXEw	13336	18774	18774	1619318520000
26967	3NKYAG9bP7KXZchgVQ9oJktia7XGrSQLAmZcak14BD6AcK3hMf24	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1407	1395	521	12463	18617	jwVc8ATKAcECdaagXtrLfUJ8eYjaVavDqnaG33uQk7eU8rJprNy	13338	18776	18776	1619318880000
26970	3NL31TiFD7gKiBVEj7GCAizKWtE5TTWUPxeHwye1rjsdpMTHUMWq	26787	3NLg7hHzWJiBwAXXtbFM4tPDghg64ExX1ogBdaGazY33MygPgfpf	1506	1007	517	12463	18619	jxWAYA6KRmjWxom9zqysQaSfbGYRFwCheQ1tTnaGaSwZoEgXeB2	13247	18776	18776	1619318880000
26979	3NKzJjrZ8asfUFcPtkFV61ktZGJCae97o9ioay6bupaGrGts4Kkg	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1564	1092	521	12463	18625	jwiQoB6MxEdGuNNYBjNiZAm6p2NFSvGwRvaKvE6eQspdAP8r63o	13340	18778	18778	1619319240000
26982	3NKVEwCTxoab2pT5hKpNGicMSninUFiBk8yd77Q1PjniERkw7XEJ	26981	3NLZQcZEe1ULuhPcjJUTbfd3H2JYccqEg18b26wSzBeutx5pRgzG	1559	456	522	12463	18628	jxHGohLCPDrnSWm59w99b2T9TSjZ27D3jmg6sgNtfarZi6NuY9W	13343	18784	18784	1619320320000
26987	3NKb6RVKLotqbKbpYS9CT5oSVxoXzDo6b7m1ScRGNEATbUCzTfbp	26986	3NLDMxJ4t6X6iv9qAoDGypWsvC3xTjewqUjPzQS3tnJamPN1fo3M	596	596	522	12463	18632	jxXRdnxBk8pPLdE2XTTZwHV9AZL9RMNDUmigPxVEoZ3PMy83he1	13347	18789	18789	1619321220000
26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jx1EJw2bwu5iKApukwpiSrh64LPssSEYa37Xf1wbyJ7UavieCvD	13350	18793	18793	1619321940000
27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	1578	930	522	12463	18643	jy2x6P5Eq3LWBVi7UtAjTU6xRXZg5HBfJdmsE6aqec3XfTzaSbV	13355	18800	18800	1619323200000
27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	1403	824	522	12463	18645	jwBCXo1Z7nPw1tdbMqLVQFxmM85YBVDojcxxHain7n4XF4jzQEF	13356	18801	18801	1619323380000
27005	3NLJjBgcgyW1Y7VUYQe7njbSbnBAM7yHnU9ZsHTEzvajj3prR6Yz	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1406	1393	522	12463	18648	jxzqJTVuWqdc131qx19MkAu6833TtnySEbpF5pAzDanehq6iwRa	13358	18804	18804	1619323920000
27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	1406	1393	522	12463	18651	jwadw73XSfib2DdKxtCEqgjRrpBcdcQptNp2r6gPjNkcArLZEqe	13359	18805	18805	1619324100000
27016	3NLVHrpBPURbrKXRcKwU1msqDVc3gUfQKdCCVp97jCyn5AQ7v2y1	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1542	1304	522	12463	18654	jxgbdJZcUVktQ82U44E7m2b2EaFMZxaMsbDxBV13MXwezPeeisD	13361	18808	18808	1619324640000
27023	3NKoEFWpe2XJib7VByFSMaJw1BAeDN9eALczKVrhAv6yNDkN1iwQ	27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	1549	1362	523	12463	18662	jxmaiXBP2LNNpNBvWgpL9Y94n6UrW1ML3kWKUVAKNoZapq6BwUV	13365	18812	18812	1619325360000
27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	1405	849	523	12463	18669	jxopr6gSJu98hQJpMm2zRjUV38wARSgnaNpQGvGbhBSmJUgFQy1	13368	18815	18815	1619325900000
27041	3NK85ucFQGDUr7D7vmf46wjwTqYbip1jjRKhk5WoYC7z2dcWaVpi	26920	3NKEAgc6rQVF3xVooe5Gqw9wwppGJC1a1VkCJKsRxJ3NVsfzZTmP	1553	776	519	12463	18675	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13249	18817	18817	1619326260000
27042	3NKDt7WDwKxYfWcmjpkN7P36pFiPANULmdwjMBNn6ezLqsGAWUqM	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	364	364	523	12463	18676	jwzZxBckrBz8RjuqoHUhoFNyFuC8bfhqEDmeoSQ5UBuh2TGtv8S	13370	18817	18817	1619326260000
27044	3NKCCiQ792J77zznv9XDHYUmYRXyS1uL3jLGSujYRwMzUgErYaFf	26761	3NKcRxTbKmsS1krd7MrVnjvuMvPjjpXVzL3pVexKryQQnRkT2BSU	576	1109	516	12463	18678	jxGFu1aGDcbagbQyu4MJMsHxqZ7KVHnKr2ngG9DDpnv1Zwtgr3Q	13233	18818	18818	1619326440000
27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	1406	1393	523	12463	18680	jwSkre9SCAsJLg5wQ2tmHncZQqM72Uyp6dSMmBzXiM7oE2J5aHw	13372	18820	18820	1619326800000
27049	3NL1Fs56DkeQZ5uVMGbzBekGPHHcKYxjx6BK5Un6qeVutuSB1z1R	27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	43	1310	523	12463	18683	jwdnXCAnVDuXRVRR6tfZGsxNtkGtxh1kkUdA5u8GoPu7LV5T6if	13373	18822	18822	1619327160000
27051	3NLg7s6fXUtkGA9pUhzNB4UBmKcXgf7XCD7j61Uayj8hqWwu3RZ8	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	1407	1395	523	12463	18685	jxYYYZtpk199RHHFw1GSb2NK4K6NKL7BWP28BtKZttGKFw4vwPp	13374	18823	18823	1619327340000
27053	3NLdzNrbuAcKpBXHxnH1Ei3pAoqFULVtXtAHQ5x5iMAYEbDAmLYT	26925	3NKCZxjYDDeJTkh8GjSdsQ5V6usvqm4z5RhWkFWbPNyi6givRNCf	1670	916	520	12463	18687	jwo4zP2VsntLs2iKqs3YBU6XNNe2JXHSkKmH5YLD8rLCTXqvTKZ	13318	18825	18825	1619327700000
27058	3NLJHuY3aG7e7ZzbAP7LChDmPaKdhw24TeY6tMHU3zJkDWFXtxn1	27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	1671	1119	523	12463	18692	jxKxjaDxnAoTasWfBZ1UXcCotGVcH7bDPVHdHn9U9YgE5FBUBNz	13377	18828	18828	1619328240000
27061	3NLTKSd9Q1tetCqLkkfeAfijcYJceCuYidQDhB2v5QpCxuuxF1wM	27060	3NL7w23RGrtoJF8sMSQvNQZVYE4udRnUjtmhu7hVgdfLdxR9VkQu	632	1136	523	12463	18695	jxEEnvjEVpaJfCM5ATAiPKaLACnZpun8jgKJ6csiatVpJDGo5bM	13379	18831	18831	1619328780000
27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	27062	3NLPi6ywXzm9BSKeE8ycKTqFK6JC63vcZgQ2NfCJPDRXSdL3ndvs	1406	1393	523	12463	18697	jwGe7Pf1vFC9vzfH4R5dGE4K1EEDF9cRNh4Xwzv6TaBeQU2dY4e	13381	18833	18833	1619329140000
27068	3NKu4cShxcp7GEsXGnGbhUTJb53hhLdUZow2ntpEGPeASfkSXn61	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1637	816	523	12463	18701	jxrci6Ls9DBRt2vZJEjZrynHYUxY7axbaMfGcKaPPAUumjG7421	13382	18835	18835	1619329500000
27071	3NKwG4MGnCQ3DMpYvJVzYU9pPbihXCgCnLf44YhFfjVMHyk18f1U	27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	1609	1207	524	12463	18703	jwsBsN4JB89YpmDcu4SY4nWnFMVKBGUTW4bZPu7QqxZzm2FG5kj	13383	18837	18837	1619329860000
27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	606	1295	524	12463	18704	jwQ4sD9aCMG6vw63Cv5zmKmaNBF7Au14LHzaQPxA9oZBzcjnWJY	13384	18838	18838	1619330040000
27078	3NLZXNB3xvQKdpjrsrnSa2tQfuRVNsD2BANj2nkWxzrQePs5RArF	27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	532	1303	524	12463	18709	jxfYngk67a5p3nwDj5AynSUDqh5TJCwjDxSjVhrM76D7bNhAhmE	13387	18842	18842	1619330760000
27080	3NLC5meqe5PdZZ8X2bcAt2NycriLu4PwkCUdMj3zuQHQitCuNa4k	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1623	830	521	12463	18711	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13339	18844	18844	1619331120000
27082	3NKuSGUTWKv1NH7CH1u2ambZKuNTRqnTPdR92us2NuYq6gg3eDhW	27081	3NLEEZhVoVaEYdhzp4TbqRX1RQpARDzVKwXzAjwXyUgoQRqXJoNG	1406	1393	524	12463	18713	jwrjxt8sPgm3nsvLw6pgSsB6Nk6a6XuAkP415iYz97dnX1152ry	13390	18845	18845	1619331300000
26968	3NLSBJBrLsLDWQfcNHTJkayYZv15LyG2Yvch9dgj2392fyhFQCfz	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1506	1007	521	12463	18618	jxngWBiiGfGh831bV2rg5S3eYYbG3HUU3FRiqXg8GQyKYSSMGCw	13338	18776	18776	1619318880000
26969	3NKj9XEcRV2u4skgKwRFqVNctNNMNAyUj8LWZkipqkyvh25Lj2jJ	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1506	1007	521	12463	18618	jwXXm4wqWRWJUkEs7jUEaJn4cjx8gPuQguUKRVRZ6aEQPRXTSaB	13338	18776	18776	1619318880000
26973	3NLXzxvGewus3BziehgBsyub7yyNYd7CLHFDhuoAHA7eT1of5bEs	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jxkiX247SceSqhynNSX9oLp19PmRrrQTTUBkkttA4wqsQveefBS	13339	18777	18777	1619319060000
26975	3NKvyoSZ5T948JgX5q48RVrtnz7L3JCvxRNahh9embwxPprqoWvf	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1483	877	521	12463	18621	jxcrupZd56mH3Rqjf1YJJwCQEChrZ8RaauhrJ33TSbfhe9pinTw	13340	18778	18778	1619319240000
26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	26982	3NKVEwCTxoab2pT5hKpNGicMSninUFiBk8yd77Q1PjniERkw7XEJ	1419	814	522	12463	18629	jxaACCnT67ZBuanR8wig3efbhHH9wqfUQwbEzGRRWqisSNdW7oQ	13344	18786	18786	1619320680000
26988	3NKXREeuaTNeZy75RBRdsrsQV2rfVaYeowWh8oGQCic3JbP2F1b2	26987	3NKb6RVKLotqbKbpYS9CT5oSVxoXzDo6b7m1ScRGNEATbUCzTfbp	1477	1104	522	12463	18633	jwGtmf5zXbK8JXVoiR7GXv3K2rxHEhR2ECcbwQNubyB9V7vaDpQ	13348	18790	18790	1619321400000
26991	3NLL8ctN3xJ19X3Y3si3jUxmVJgTkue3M3hKGwJrvgHxmjsmNgdm	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jwQ7kzzh4wK7kQsnvo424mfsnTKF3ZJHR5MVHA4tkzdvyAnfMEL	13350	18793	18793	1619321940000
26993	3NLLfntSzwsyZyFQ1prjLA84bo3v8v6F3pun8UFQSK8aDdrGLxQC	26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	1406	1393	522	12463	18636	jxPGsRZvefJbMMih9S5okG3EPv6MEyFM8ihPYn4zGdCQxqJ5fuW	13351	18794	18794	1619322120000
26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	26994	3NKy9umi8TSqm2LLKpoiiJdqbPPpptsiTcMqwiCsigGxYP2af3Q5	1406	1393	522	12463	18638	jxEZLv27rzFtL5KAYfC627w5LQir6TBhxE3wD2eFYRK8MWNKtxG	13352	18795	18795	1619322300000
26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	1546	1213	522	12463	18639	jwTLg6BAjBfDGE1sE1wQV5mwH9GWRdvNZpahiySPPeNtpTASZJE	13353	18798	18798	1619322840000
26998	3NLvRwCTuXNNKMMrnUFjCQCQQp8Ki2NfqtjNeZwvc6oWGpxtWxq3	26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	1542	1304	522	12463	18641	jxQaAFArnAgXng3KowsndVcic5itvBM2DMUx8ucq2Fy5RVk19ZP	13354	18799	18799	1619323020000
27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	633	1384	522	12463	18646	jwzLCBZbkmGQhPAbf6WGTxZypVdgqemJsL7TBLnh7KbsGWydeer	13357	18802	18802	1619323560000
27006	3NKgx3zSmfTomQU8aFuUNj7PmE5xvjfgUE5yrZegYKageUbduFyV	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1529	1316	522	12463	18649	jxnR3cdfeVdYscxgm61UVPRxE6y4FD3MvFmMggu4UjWzesGwZfY	13358	18804	18804	1619323920000
27010	3NLNFnJk5dwBJRoXJemuCaEZrkTkfGTpa6RLmrE5j7rF29dD9CiM	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	448	1059	522	12463	18652	jwVnTzZmwXtLiHnnwxfaUGrCdTwNJqVqoWs3mGUb4Ka2uPGzFWu	13359	18805	18805	1619324100000
27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	1407	1395	522	12463	18653	jwCv5kRJMgVSNkgMiTwxbq9XNSndy3awkCskuWNZcxzhYvnzdDW	13360	18807	18807	1619324460000
27015	3NK3qQ1LCT8S73SUzKM5amjgdJJiForRzMhJ2VFqfUt2djuhQHg1	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1624	1334	522	12463	18656	jxkstehfi7iE5VXmwnu9LnYZ2jP4MvZqBvuA5mJnFtACJdT1LVr	13361	18808	18808	1619324640000
27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	27016	3NLVHrpBPURbrKXRcKwU1msqDVc3gUfQKdCCVp97jCyn5AQ7v2y1	1407	1395	523	12463	18657	jxfV75cUDunsSVFpGgauBip9yqjT9tNb1BDw99HXHHrWU7p1UZY	13362	18809	18809	1619324820000
27019	3NL9n13HPRJ58QpyoiKg9WtTjtnaspcbtLxdAw7s72FhJeitSYhq	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1522	1322	523	12463	18659	jwxbf5bp3cvC152NtXWdxa54DL2zuKvushfLhH7WCnEV7bqryaP	13363	18810	18810	1619325000000
27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	44	1199	523	12463	18663	jxhvN2kBRo7K5dHkBkQoTVZTYXQ6aBPxYeXYP1DDU2kzWHGJ9WR	13365	18812	18812	1619325360000
27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	1534	432	523	12463	18664	jwHBSSppSmFQGbgDaxyNQC8PsAAqFyVM3sBBmSnay45dHfn8C7e	13366	18813	18813	1619325540000
27028	3NKPrGhGyL6nA7qhLrv5ktKdY5aBTqC2ouU73vrA2CoStRQoP3H8	27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	1651	1301	523	12463	18666	jx7iruQcPh1cGPAvXttnrZEnBCn4atn55So43YJh6rhtzkyRacW	13367	18814	18814	1619325720000
27030	3NLussrw95mTNKVbhXQ2co5grJ6x4BT4qzdEJFDg3gzhHAcz8qEt	27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	606	929	522	12463	18667	jxXH2tzYNHnF77cjzG9bXixicUAahEbyh78p1Qe5suYY8dXhjYy	13356	18815	18815	1619325900000
27033	3NKqU7WEEwp8zoyKSomABpXEYYj6mS678Lbejf8MFXnVj8qotisU	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	1594	1080	523	12463	18670	jxb1Km5JEzJTLkcZ7oWPe3WxpxYHebHinUnAWZnASky4fsAgxSH	13368	18815	18815	1619325900000
27034	3NLHB7vDFMQpC7pKMvXea7HRjeqJWSESN6TjGd6powFwXJsmbcik	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	606	929	523	12463	18668	jx243Qe3CR9ppRnMA3WeqmwfrfbGXjbE6H5nPRtFJNwnCSXZDJJ	13368	18815	18815	1619325900000
27036	3NLaECB8oPJzwJcRMucf9AkDx3gM68NrtDnR4qZzyBHuPMsEDt1e	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1652	1189	523	12463	18672	jxoo1ZmLbbd1mnJB4HoJ87X2aUMf3ZJkEhrgEtCVAQGmjZkzmAx	13369	18816	18816	1619326080000
27038	3NLvmk5vh3vPjvH4VRhUjnMQYwdzdR7GaMq73GdiUQpSR1pCxtMX	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1440	1377	523	12463	18673	jwwsjEJGS2YRC9YHGhZmgai4WYhMxFjvYA3k1UuCYDKAjsEY5UJ	13370	18817	18817	1619326260000
27039	3NL5EYQEwwrLqKBTGcx7gcRNSpNQhN8ZgXFaXRTy54vzt2HN6DgF	27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	364	364	522	12463	18674	jxpp5VYKur6k6DXpMXQiDgAMN4fhi329EqunDPRZitYtNkCDnsW	13360	18817	18817	1619326260000
27043	3NLH5qE9kvU5Wn9T54CN1k5mYKmsv1Jpvcxqz327MH2QVHbxHd3f	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1637	816	523	12463	18677	jxS9biYS8QCuAKCvJZJCo7EpEWJSxQokRDv5p74rqBqyk1SLCMX	13370	18817	18817	1619326260000
27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	1406	1393	523	12463	18690	jw7Nw365xB2SGsghkVnwJExw5naqzoYRVUueJNDbHLuyVHo3zw9	13376	18827	18827	1619328060000
27059	3NLMAoXDmfGwdDDV8euxW2vh1zboQSnmDB6upYfTHoWSsg9Ro9BN	27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	1573	1318	523	12463	18693	jxH24aoAyEbNLuefP361agXq5VBvtEUDu8RXtpWxmsufubNwqEt	13377	18828	18828	1619328240000
27064	3NK9hJr73oYKfNcFUeGMYRMp4kXeEHkFnNbAfe2PR8e5xfPAXDH2	27041	3NK85ucFQGDUr7D7vmf46wjwTqYbip1jjRKhk5WoYC7z2dcWaVpi	1553	776	519	12463	18698	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13250	18834	18834	1619329320000
27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1402	796	524	12463	18715	jxgvYzxBJSsMADjktohWjkt9RsKAUAcPeN8KiRfcG3gseyNd3Vu	13392	18850	18850	1619332200000
26980	3NLok4M63D2kikpYzMRYRSSufaVRBmbPZSkrdoSuTSUi9ZfAWeZF	26975	3NKvyoSZ5T948JgX5q48RVrtnz7L3JCvxRNahh9embwxPprqoWvf	641	1210	522	12463	18626	jxRJa4gCJr5n4RHA4mP2i1yHxHq6R4E8nSzKA3sXFFJe6NQ4ehC	13341	18779	18779	1619319420000
26986	3NLDMxJ4t6X6iv9qAoDGypWsvC3xTjewqUjPzQS3tnJamPN1fo3M	26984	3NLSGCYPBNmfBFwimMmKE6faJkygcGJ9zYLsGztZBKDAVuX6YQmx	1406	1393	522	12463	18631	jxU6yBRnB2wcN1L8cxbGKuG2uzcedqyB2mqPDKcJeASW5MVQL7f	13346	18788	18788	1619321040000
26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	26988	3NKXREeuaTNeZy75RBRdsrsQV2rfVaYeowWh8oGQCic3JbP2F1b2	1671	1239	522	12463	18634	jwHqQpmdkVfbL84woQKgjboJaDNdwpC7tDWjm3D6yTLof8FKjbh	13349	18792	18792	1619321760000
26992	3NL3iMZMwtMAC78QnofHNEdH5pU5ha3DF7gcH8J7MJmX6bHtDE5a	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jxJwRH7FC6AtwrhPZspuC8yoXJyoAvVnmFUypE5tALM2uUbC2CL	13350	18793	18793	1619321940000
26994	3NKy9umi8TSqm2LLKpoiiJdqbPPpptsiTcMqwiCsigGxYP2af3Q5	26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	1656	1097	522	12463	18637	jwTUQHDFsUZuxCYJzku77psHuieEK52i4LG2YUMo1XeuzzfuV74	13351	18794	18794	1619322120000
26997	3NK4Y1BijdNsZDBF3WvFyPgPtjZYWGfnD8w2gBtwu93VCgjgLGLZ	26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	42	1115	522	12463	18640	jwnwGATuAojbQ65QZkwzrVr3Utb3rynwUeGm8xYzKWN7LpuDR5h	13353	18798	18798	1619322840000
26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	1650	1249	522	12463	18642	jxcnnu1dPHA2yrhHyPGZ5FtAwQ6Ekh2BQ3LXrwD1X982Z4SWSx9	13354	18799	18799	1619323020000
27001	3NLbG7ubXDJXFYnTyye4yZvGEUQZqy2W4SpjPWisnYvCwzpQoCzU	26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	1633	1390	522	12463	18644	jxBmoPcaRvVgFnAADcEq8fYoxxzo4byJx6wdGjja37R4ZL678mY	13355	18800	18800	1619323200000
27004	3NKz8KvxeauKyQn4xVUss1zm3nTVfQcPShMCz5JvEMFz2Yu3j6AD	27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	1483	237	522	12463	18647	jw97itCextAQi7QekxTP76VqaSkVR8gdy7N9eDRahi1kL2krwK5	13357	18802	18802	1619323560000
27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	311	1307	522	12463	18650	jxHW1VwAEJzAD6fSTirK3tY4fEEPuEi3aV4RhGc3ace43gciW83	13358	18804	18804	1619323920000
27013	3NKnXcKFgLq32uFByq2Yoy6L2jcY7nHa6Ci5P5Zbe6te2MxVfHVw	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1542	1304	522	12463	18654	jxgbdJZcUVktQ82U44E7m2b2EaFMZxaMsbDxBV13MXwezPeeisD	13361	18808	18808	1619324640000
27020	3NLwFNMjPHtox1Lcn6vwXas92niPTBoK74SHXTJPwiGnmroQTvaK	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1522	1322	523	12463	18659	jwaTezGUaoc7oaZ6q2eWwiAq4ZiQxBAQVEV29ABpi1EzDowfhsq	13363	18810	18810	1619325000000
27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	27020	3NLwFNMjPHtox1Lcn6vwXas92niPTBoK74SHXTJPwiGnmroQTvaK	1407	1395	523	12463	18661	jxpXsvDq94UZFqrv2PJBQo6LYhoMAAHKoRt7Km8haariRxjMbJS	13364	18811	18811	1619325180000
27040	3NKcB4Yof12UQfn2QHaSzZwk9Yz56Wz4AN3crBXXmKkTR6AR4uK9	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1440	1377	523	12463	18673	jw6fcCcPqj1gHDf2VZjKFRJ4FBvccDWoQ5UjeBr31SGVPv9jV81	13370	18817	18817	1619326260000
27047	3NK7GcY8QdrCnmzGYDBfvK7B9oAVGtaNkhQFdLZr4f3TYLcdixhx	27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	1631	794	523	12463	18681	jwtFJ7sWVVet69MpfjZ2kaThwtYBE7uRokmRb1HvhHmEDPNoiyn	13372	18820	18820	1619326800000
27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	641	1210	523	12463	18686	jwBjxzJPgs9ciMJg5eXTx1cXQ5M8XfL4d4fYvqTg9Hq6BnwfnBq	13374	18823	18823	1619327340000
27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	1670	916	523	12463	18688	jxP1YYWMTufHox7vYdkMbwKoK6Nbak3jrS2wyQhoBG2tdHUTtox	13375	18825	18825	1619327700000
27055	3NLtpxRjn4GRJABztuCRZsmdZhWa8FFeqiaHho6NuPTBeefj1BmR	27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	1555	981	523	12463	18689	jwQiMxYi89fMNsJgdU9rZeSjfNT3ixu7zjBRF4ZngW4GKY2TWF6	13375	18825	18825	1619327700000
27057	3NKhK7gYGMTWxmXtXjtF3YU9KkcUJbGKWAupW34KKzRHXt3oTTqc	27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	43	1310	523	12463	18691	jxhpB1P9gxGLJPBemA9KQva33AD3K8wEN11NkXtW5KemTqyAyLg	13376	18827	18827	1619328060000
27062	3NLPi6ywXzm9BSKeE8ycKTqFK6JC63vcZgQ2NfCJPDRXSdL3ndvs	27061	3NLTKSd9Q1tetCqLkkfeAfijcYJceCuYidQDhB2v5QpCxuuxF1wM	1589	1286	523	12463	18696	jwxnLvQPm4RRQLFTf9egXAG11eXEwRqKiWLxX1siaTQ9CjsbQ7G	13380	18832	18832	1619328960000
27067	3NKbPkDi7mqYiEefHpXGUALfZjjNNWLeUW5CBBcJrbBRVcH8NkeQ	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1506	1373	523	12463	18699	jxBUveunHG2BAWcqRJVEh4bTchNFeFxscJ9bMy7vnrmHSER9oWe	13382	18835	18835	1619329500000
27069	3NL8juk56Z6v1ozAqtvuXZs25Q2tBDUwDefmqLSQws6w1AS3KvPC	26970	3NL31TiFD7gKiBVEj7GCAizKWtE5TTWUPxeHwye1rjsdpMTHUMWq	1506	1373	518	12463	18702	jwcnKKbQsWcgEAjtyn6V6r7mzXgm8giMV9bgcBPSzMdTNxGvVqf	13248	18835	18835	1619329500000
27074	3NKFhcWpqVxHrJ9pc7CiZM2Z4zMdFRMEw44oMR4sBukFFcBRREzw	27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	1407	1395	524	12463	18705	jxC3VQsP3aptLXnz1JvVZF1ksctijFgN8AEmrk2jKHLExD7MHCT	13385	18839	18839	1619330220000
27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	27074	3NKFhcWpqVxHrJ9pc7CiZM2Z4zMdFRMEw44oMR4sBukFFcBRREzw	1672	1159	524	12463	18707	jwt3zAiCBZUpSjahJ4BjRHPFFqbEhR9dzRVFHqepUMLQDrusca4	13386	18841	18841	1619330580000
27079	3NK4A1MJjH9CsAXjbd6kVxMfabL5iPhgpmDuRL5ADdcVjy2yZadw	27078	3NLZXNB3xvQKdpjrsrnSa2tQfuRVNsD2BANj2nkWxzrQePs5RArF	1648	1158	524	12463	18710	jwMCQcCYddXUD9gwfhCaRY9k3ZThuNzCryHXEfYHCrUU5Nw5zTA	13388	18843	18843	1619330940000
27081	3NLEEZhVoVaEYdhzp4TbqRX1RQpARDzVKwXzAjwXyUgoQRqXJoNG	27079	3NK4A1MJjH9CsAXjbd6kVxMfabL5iPhgpmDuRL5ADdcVjy2yZadw	1581	778	524	12463	18712	jxvuNhT3dC8ZSDv4RHaME7hg44pSCbBN8Pz9DCvJJyk2jkUKCaa	13389	18844	18844	1619331120000
27085	3NLDuv9e2crXZ1sa4JTuKWoqqtsnPKTj7enfGNP1jYvR7694Zqvn	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1675	1096	524	12463	18716	jwHiqVTTGWUEyT7ofooiUkGiSPxidmA6VfacmtZzPonnqAhzKSo	13392	18850	18850	1619332200000
27091	3NLf9gcNMcxDUPr8vqrmxA8uynMZ9ziWrxa7BiF6EWVbgPWBxeWu	27089	3NKVCX33k4nNtC6Rbb4abYJTB13sKgDcBsKTaSAEeaP5uA7VZ8rU	1581	778	524	12463	18720	jxMJeH5f3gytMx5VjDRRBsLZpE2ZjH3C5KQaoSXpLn3JRTGnzjs	13394	18852	18852	1619332560000
27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1534	431	524	12463	18723	jx6UCYG6y4ZjMVv9ChRUprdXk8XyzromJwCMVdFRjeALBRamDdT	13397	18856	18856	1619333280000
27098	3NKcesUvdm6ZyFdVrkqSdvpKwbteMyshpY85bcc3Tmdg3ZhMY4Vb	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	1507	1280	517	12463	18727	jwxreepnwThDovfcRTJX4nCi66SRmaPReLQmh1k8AwAUaQwv7sN	13252	18856	18856	1619333324442
27101	3NL44UzXJs4hr8guZ3zkTZPx5XB3mMGXX6a9RVSRJWDkLEXMVGS9	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1406	1393	524	12463	18730	jw8zfnLKwys7Vo9gys7RYQJMzr3k4ydCZnW9jnqX9nU7zfAuLJX	13399	18860	18860	1619334000000
27104	3NKgCmPW4nLdCoqZJgT1AzfANzgZeE1teH8HmKCshFY8z9g9vG4H	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1406	1393	524	12463	18733	jwFFR3i4me5fLbAjtNC1yBxAAXxGaijxX7MM4g4kpDU3yNBgqAW	13401	18863	18863	1619334540000
26981	3NLZQcZEe1ULuhPcjJUTbfd3H2JYccqEg18b26wSzBeutx5pRgzG	26980	3NLok4M63D2kikpYzMRYRSSufaVRBmbPZSkrdoSuTSUi9ZfAWeZF	1675	976	522	12463	18627	jwAKK6SfRasA4zCkAQCwdRt68QFN9rGsjKK2vSWB5gwsE6zUqBX	13342	18781	18781	1619319780000
26984	3NLSGCYPBNmfBFwimMmKE6faJkygcGJ9zYLsGztZBKDAVuX6YQmx	26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	1458	1197	522	12463	18630	jwWKKBmg21JdVN39EpqjQBNZ1wXiFMHbrj96VZao7RRnWSg46QC	13345	18787	18787	1619320860000
26985	3NKA7SXtm6nT6CzhYrbN4i8vtBcSPsFEV296iCMZRjzatcquZrp3	26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	1458	1197	522	12463	18630	jwjLY4VuDpFCcZR8jKztD5eenfF1PziWEu5n8V6wJGJsyW3BTHD	13345	18787	18787	1619320860000
27008	3NKX8FRx374jBpMzi5nuF6Azk8qffFKbMETt6wn8x4SFkAU7GNbV	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1529	1316	522	12463	18649	jwU8W7eYSZKVYPn2gBn262CiwEktZHM1bdpZknmKfy5QEUvckQL	13358	18804	18804	1619323920000
27011	3NLhAagD34Fzkq1usxuroNvTwG5fzgTgtyh49ZgYWZvbk5R8shAF	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	448	1059	522	12463	18652	jxvvcb23x9KcA6Nor2gJa3iAnezHrsgdvP27od8Rz58PeU3igk8	13359	18805	18805	1619324100000
27014	3NK5eQ8QVRtYxeUpC7sm2ZrM9iQ2ujTh84zayVyVRiL1GN3x7xoa	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1467	1010	522	12463	18655	jxGiZkTfyScpdVC1csAahMTpRXQgxZd34NGUv9rk4KzjmKfQWJg	13361	18808	18808	1619324640000
27018	3NKz4Xxi5s5Zi8F66TdNiFg5pn23RqNZNeqcHHxao6HLgkDVsGrC	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1406	1393	523	12463	18658	jwTmVcNSg4W48Hacj5fqaRxgbjc5vYbffJpBeFp6G7aRpqvbxhV	13363	18810	18810	1619325000000
27021	3NKUiBwE8zJePZ2vDYjicevUXsU3TA2R6SFe8pnTsmHdinnScumE	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1407	1395	523	12463	18660	jwNGeY1JcAgJzsWVWJru6VRc2zuUfen5BugA24jZDwHqot8LCXo	13363	18810	18810	1619325000000
27025	3NKc7CbvSESqEt6JdEfSN9a59qSjpec1AXD5TWLUiKbweytBNH6T	27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	1534	432	523	12463	18664	jxij7ZprPfhCrTC1z78S3twXnVjqBkh8CeYfRfC5cBajCHo1fVA	13366	18813	18813	1619325540000
27027	3NKVY72fKVNJzNMRcHp2Fezu9gsWYvaCWqcR6AspdDY38eL3Q6De	26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	1516	1294	520	12463	18665	jxNSHWtgGymTHRKc763tPs3d3Wq2WnVwZQUk1Cn3v5Q4kXXHxmc	13311	18813	18813	1619325540000
27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	1651	1301	523	12463	18666	jwXHDyRqFiHARRhrRUCLXMDfAwKMSApxnoTTHtiQrtE6EYC2xid	13367	18814	18814	1619325720000
27031	3NLjWhonMwvvrmcsPcTgD9chULYNgm8we1ima5sgNhZPJc6QZzvr	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	606	929	523	12463	18668	jxeiGvmKr3n6hS926sk44QUXK9qWPzCrhPM5gvtGpBVQAwfk9Cg	13368	18815	18815	1619325900000
27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1403	824	523	12463	18671	jwf1QEanojZ58LsGYPRJmwThWwrWsFGcMVZChHzS6JR2WGoNW6k	13369	18816	18816	1619326080000
27037	3NLY3jpSeLbG3mLSThdWg8Aifm3b8WzafcPKbGvtfeqWwy36ZuLx	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1652	1189	523	12463	18672	jxqYKMBWBXSB8WPH8XTaGnPKPv3LkW8ivRRzHhDPmDNy8Prmw1D	13369	18816	18816	1619326080000
27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	27043	3NLH5qE9kvU5Wn9T54CN1k5mYKmsv1Jpvcxqz327MH2QVHbxHd3f	576	1109	523	12463	18679	jwVmp9jSjzMJ22HwqYPCWQs5Q7Fnt8Divo3QbXRuhcGvtSSJFKr	13371	18818	18818	1619326440000
27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	44	1325	523	12463	18682	jwtinrFeCFLnDbf1FhQSrCuKvGKtfYknUuQwx5XMTTt4KxLaZvF	13373	18822	18822	1619327160000
27050	3NLTUjgtKnJxv5nxsKjE29UCo6U2vVmqUvUPighmQgFsXNBn3SR3	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	1403	824	523	12463	18684	jwfT82sjCgdP7jn3uQLXmJu3rp3k2x3oKwdHe6CDEbbPyNCuXnU	13374	18823	18823	1619327340000
27060	3NL7w23RGrtoJF8sMSQvNQZVYE4udRnUjtmhu7hVgdfLdxR9VkQu	27059	3NLMAoXDmfGwdDDV8euxW2vh1zboQSnmDB6upYfTHoWSsg9Ro9BN	1646	1228	523	12463	18694	jx6dheokj16tQX94jceGkgLuKCd1N9k6sqeQFJiwFtqSCrwEVzs	13378	18829	18829	1619328420000
27065	3NLjGp7Ph98GwDpzx5R7kZMuVyLxWd4eFXTmRoKgUVEVDw9NNKqp	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1506	1373	523	12463	18699	jxn9DoLUrkWKy44a9pUQgtXa9EQQv6iPS4kqQzwMETXFfKPYvCv	13382	18835	18835	1619329500000
27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1571	1209	523	12463	18700	jxw8Dvx9SrYZAj3pYv9CRhiuzmP9Rvog95iJf5C4qn4XA1QZn5f	13382	18835	18835	1619329500000
27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	1609	1207	523	12463	18703	jwsBsN4JB89YpmDcu4SY4nWnFMVKBGUTW4bZPu7QqxZzm2FG5kj	13383	18837	18837	1619329860000
27072	3NLdq7RJmi1RZ7jZ9jf3EVxUPfgtdqjSHd6ZqnkUoff5vxxWDg5c	27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	606	1295	524	12463	18704	jwqwYCtTdcKwAbGLw4LkEtasYjrV6tTcRnBdboTq26DKn7j7QDq	13384	18838	18838	1619330040000
27075	3NK6wQ2AGVDXbK2s5SnsEwcZFHixMZMNfLNmnH43FgNYvbJY4Fp6	27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	1507	1034	524	12463	18706	jxVjEQegoUGDK7Vdx4nM3H6ERoY4V3jmzXS1RCDXDbzqrX7Ks1c	13385	18839	18839	1619330220000
27077	3NKgwUeiVTH3mAVmDAHDCyfSDD7godnTxJkuqiPS43ox8mct8qaU	27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	1407	1395	524	12463	18708	jxEnZkhg8PXTyBUr2wY1kqgiM8HRmBbmEHfRfk8iRxviBhGXqcy	13387	18842	18842	1619330760000
27086	3NKCXJsRvy5biDHcnRxo95VZeN7NHxvvk7HtuAqnz7sK9AVZqavT	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jxYGQt8Zk1QYAkZttuxUoQyTNdQietEqfvqwtiDgtGkbTV56LBT	13392	18850	18850	1619332200000
27089	3NKVCX33k4nNtC6Rbb4abYJTB13sKgDcBsKTaSAEeaP5uA7VZ8rU	27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	1402	850	524	12463	18718	jxJuedxfLMqxVieQgnRhwY54rUh6A7J1TW6QkEzwQ65x99MiGCQ	13393	18851	18851	1619332380000
27095	3NKn6pViNTPN4Gj4fsbfkSZTQnAXoKPZ7NzfEbkxP7rcmBLZosuJ	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1522	1322	524	12463	18724	jxQ8qAAL4UyGmjnweuenUtTMDbaZm7SfrB6HhzR8kp7UYCTeVq1	13397	18856	18856	1619333280000
27102	3NLgs6iWNNEiiTBaFLLuSHmnQud9MSSkJAfYYN7WEofbpuktfvh6	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1447	1345	524	12463	18731	jwqHWFixQqSwLgwT6ahdn4atiSQJz4eaUAk4XTi17jBqBFsNc1i	13399	18860	18860	1619334000000
27105	3NLaPgivsqu4QCgBoGyjD7fFCbvbHzL1KjyTciR4F6o86m8rUMgG	27064	3NK9hJr73oYKfNcFUeGMYRMp4kXeEHkFnNbAfe2PR8e5xfPAXDH2	1553	776	519	12463	18734	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13251	18863	18863	1619334540000
27107	3NL3oMP5YpQoJHbFE2qC4hBSrrXQdLDGXxMraqzgqXqhbzH5EtFq	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1646	1354	524	12463	18735	jwaV46aEcYAMaVwwwVK9bqzZAoC7sLdqYeKjWyF4o5fphK3dGa3	13401	18863	18863	1619334540000
27111	3NLjZSrgfXfTQ5FBXcSzRv6WYA8C3sEwrQJoyggrUyWk1L52hKHq	27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	1622	1110	525	12463	18739	jxn5L8dWJiAn4Jm3fJqnr6wXPh4QTb3oXZkFD5BMsddMJymDH4n	13404	18866	18866	1619335080000
27113	3NLdPuTkNtox6mi3gsW6cZh8Hhqwunbz1nMoPS2HJmX5F1wzFLqt	27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	1403	786	525	12463	18741	jwet8TYSDtWF9BENPLhgEEDVWbWURMijqiW9QNnNkEBVm1xmTq5	13405	18867	18867	1619335260000
27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	27082	3NKuSGUTWKv1NH7CH1u2ambZKuNTRqnTPdR92us2NuYq6gg3eDhW	1634	1085	524	12463	18714	jx3VDKmS1N8PxEZRSAVTDa6Vt3Uv8xaoX82gD5hrEnqXj25ZQE5	13391	18848	18848	1619331840000
27087	3NK3eVNvaptbE8gQ54dF6FwdE9AR2rTHQdCpwCZYzJdSRJ9rNCqF	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jx6Wmu3ZWXKZpgW5PBQ3yNEGEyagBgwV4mNGnwzuhjKCpHKkFeF	13392	18850	18850	1619332200000
27090	3NKYEg4S9wr3v8uDqn14FuW1pn9wV1YU8WvjQSMywkiihk6nQ6tg	27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	1500	1051	524	12463	18719	jxrNTfES43jsuU4PfqSVL2frMQ81qhH6WK7uxiQUEtG7FBLZqbN	13393	18851	18851	1619332380000
27092	3NLfB93tTkiWE5p1a22BW2g7YgjQT6VbxcMmYHmrcL449nPdVxch	27091	3NLf9gcNMcxDUPr8vqrmxA8uynMZ9ziWrxa7BiF6EWVbgPWBxeWu	1501	1360	524	12463	18721	jwiVhfU9iSrmtBKYZgkNGU39Lrfj8X7fHHcJPgnPrSvF22dFiBa	13395	18853	18853	1619332740000
27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	27092	3NLfB93tTkiWE5p1a22BW2g7YgjQT6VbxcMmYHmrcL449nPdVxch	1581	778	524	12463	18722	jwjXED9nZLBk15n9nksgEgswbN5DrZvmeUdW5bPSdXqNrT2gdVk	13396	18855	18855	1619333100000
27096	3NK8dvYegosbtDXxJgQmuAPGUeK7C1GJ1AKyUJRgYGtggRmAsqkD	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1407	1395	524	12463	18725	jxpeReDrA2fVxRPNzGDh6RT3D3EbhCqmU8TPbAmcqvn1YXTkfUa	13397	18856	18856	1619333280000
27099	3NLSCoDx58SFTfjggSoCXCaUSL5nvWnL1bZtCQikPQNfiQf8ppus	26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	1507	1280	518	12463	18728	jxpEReS6pNG7k4BQJkyN2fgrXUjDjDbsQzRFBh7rwZKfkQWHjsf	13266	18856	18856	1619333370455
27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	27108	3NL7u1MNbNMrYq1Go6BURVt8ATUvunNoKMBr3DMsLN46zh23XxC7	1406	1393	525	12463	18737	jwgiqutUGtwtsdeva8eowEUy9rX2HAp5n5BGXdGAProLmsPFeeA	13403	18865	18865	1619334900000
27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	1637	816	525	12463	18742	jxNKFEcTtfyVbbkpaFXxspWUtznn5Y2CaDX1zuYHRgEKe9yB54k	13405	18867	18867	1619335260000
27116	3NKkJnrkcaU6DMAjuvKpJTayAJHadQBvkMUx2GUMFzPHkXhpnoYj	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1610	1068	525	12463	18743	jx3EQFeeDgbssBdioXQQXHgVpPRFaTfML7jeMqQdBNhjQVp7zS7	13406	18868	18868	1619335440000
27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	27119	3NLSiDvc11H32dDM95UCGcKzVh4214zUEosJTgSurAuvNnCdbjwm	1489	1014	525	12463	18748	jwxH2Swc1bxZq3hECzG7kJetVEbUG1BKcDiCdi7DTidVH5CVERG	13410	18873	18873	1619336340000
27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	27122	3NKzfMJ2dMkaehiYeFX7eoYoDiav2GGizYSEVv7WbWat1HNMsVvC	1403	824	525	12463	18751	jwmUPyBUNjHr8QDVGGBgcrGmqp9Dw5DDPT5uwQywTsrkU9cH6tv	13412	18876	18876	1619336880000
27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1671	1239	525	12463	18759	jxa4C7wwcs8vV3rRmK5wKRszrSn7frBHBNH5SdfoGbZcXXWAadn	13418	18884	18884	1619338320000
27137	3NKVSy72MhTdW1bDx14PzkJRiYFfJaByhcpaUajM3Hi9WmqnnavQ	27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	1637	816	525	12463	18763	jx7VtS1b4Nh1SvSe17JMJNdCp9n96jcFTNyvJYr3VFSWN3dcW5v	13419	18885	18885	1619338500000
27141	3NKXaQsQAsVc9XctcSmmX65aH2PtE6HSN85qprdgvwPA7Chs4c1N	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1440	1377	525	12463	18767	jxe7Vdfb3U4VMGk97JR6o3SdDwYZiKhSbFsG26tL6nfYJP6gCEo	13421	18887	18887	1619338860000
27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1637	816	525	12463	18768	jx1HpFfsyWa4nVM23MJrRwj74LhWYV63tVqDkdTugeqBxhvaMzT	13421	18887	18887	1619338860000
27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	27149	3NKQq8mBsvwzHrAUZmdUVb9SmPGjXHDTT3rQHoUEv3BZFewWThpt	1631	794	526	12463	18776	jxbb2Ee7hkGLF3nShq8WEMBhiFf3nVxmUuSKSJAvkC3FpGVmLDm	13425	18894	18894	1619340120000
27154	3NKBXCtHyfXEKaugnydGLdh4WYEqkLuFyHZiNsiSQFTbkwGiXreZ	27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	1406	1393	526	12463	18779	jxGn7jwVLLSccQ4HGEEMd8HmTUPLHGkdFfQH1G4KHvTRrbwuYeZ	13426	18895	18895	1619340333519
27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	27154	3NKBXCtHyfXEKaugnydGLdh4WYEqkLuFyHZiNsiSQFTbkwGiXreZ	1407	1395	526	12463	18780	jxX8WudQKJ2WSmDPbtLRVcqpa2oX8ajs5WHbZkbex6ReC95MCmX	13427	18896	18896	1619340480000
27158	3NLjuZRor3Rio2zm9nVBJNjK2msWpAZ7hKWbXeogS1wZAZFaoFAw	27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	1403	824	526	12463	18783	jxgowPeqx2LS2VSknF7SdyCCYr8zyPkNvSYJShx2THbngKeu4xo	13428	18898	18898	1619340840000
27163	3NKTLyXGU2cmQ4XmNQMCZTu5WxCW84uBSz32r7GSA9obqZPibALL	27162	3NKCv2NbNwpvzCNpMmAFLpQtuxoWQsPQTBi75YgoPfQP1zUQ5qVM	1406	1393	526	12463	18788	jwoge2ZPCZhRxKXewDNWxG5BGRbRpkDsh2RZSym1UKVmTCyxuoX	13432	18904	18904	1619341920000
27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	27172	3NLheaVwn5yYGL1tpcpB9ghxP1DqXv1fnZkEG59MSoCE1wJcmySw	1549	1362	526	12463	18798	jxG358atmtjWF9E1YbEBs8dFsTUsY9XhkMTAwGefM8a4DUpLXCZ	13438	18911	18911	1619343180000
27179	3NKRGiE97VwxFH2JphaUb7BbQ4HPDYy3fkQX5xNRcZSM6FR1SUmx	27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	1637	816	526	12463	18804	jwS8gMh5metrphcyXJCnv3PwjWMPa3o5x45pJSQv4j9vXBGUFXt	13443	18918	18918	1619344440000
27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	27179	3NKRGiE97VwxFH2JphaUb7BbQ4HPDYy3fkQX5xNRcZSM6FR1SUmx	1501	1360	526	12463	18806	jwPL5pjyDjhXJ1AuHdRBSLPYYbGVt7fuaGA1xkhwcB83VGTT2Fd	13444	18919	18919	1619344620000
27190	3NLKbZJPCPUTtc25e3gCkzz5Mz4hrxHiNGJesN2jrfCMSHXJqP8k	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1610	948	527	12463	18810	jxoRY3kgBJgLWjm3mXMPzG1hAxBjjXnJx3zXcr8mtCm2HykuKiE	13447	18923	18923	1619345340000
27195	3NLrHLbrG9a5gu2Fc336CWJ54f3aaxMic2QGWCpoiEwkhSFKBx3B	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1457	1391	525	12463	18818	jx53y1qS9VRfCaXymJ4g8jKX9rixUSZYDWFdQ815pUTEh5eHiTL	13418	18928	18928	1619346240000
27209	3NKJffbkx4RZf29KhEMUSWGrukqVvadD32ATzCJ2y9tMP6aR4Pq9	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	1529	1190	527	12463	18832	jxCKvT865LpH7uLXn9MdaZtiWfsMLu4fWqT6ck8qvfLZsZT5sXB	13458	18938	18938	1619348040000
27214	3NLJiDpHcDVM67cZQoE3dN1emuHE5PWqrbWodBXS82FZsMbA3q2A	27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	1402	892	527	12463	18836	jw98LaYejHm2baEhYBcPVwnNb2fWK6rN9spyXRd1YinWTFupQB2	13460	18946	18946	1619349480000
27219	3NLqRwA1FTaEEBupcptLoQMGqYcpX79ACGkSZvY2P6EHqXqyY4yf	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1550	434	527	12463	18841	jwfp4RRwWXYy3RZLVRHV2C3MyhNra5FDxTsZSH45K1izujC89So	13461	18949	18949	1619350020000
27223	3NKaEq4pTXyHUxvey7hJjiAiopsRJ9K56Nhg7Dus9k8Ed5U6hmjF	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1406	1393	528	12463	18844	jx49DjZL2s8Soono6KLYgiUbc3bFZHN1XBa4oXcXUeyVX5fEnwJ	13463	18951	18951	1619350380000
27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	27229	3NLNXRrcy89fAVawh4vziRLPLDmRSyQ859JnhC9VdprywsiZ5Hnj	58	1035	528	12463	18849	jxNv6msNw1b6k7RbBcaG185oftnvgCNAijTLdYGtpZWTxQ4Whka	13465	18954	18954	1619350920000
27237	3NLdMhNXx4PKDqReDSbuNYCBN4HMqKaBx6dGit5BAt7cnW2Uo6xa	27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	1611	975	528	12463	18855	jx8fWiQRySUj41s85f4Udnws3McGubtTfMyeWEoM232nR7QN3Up	13467	18956	18956	1619351280000
27088	3NLFwkSY8SKaU5pVkjfLLdriCCW2DEJTNyJU5sVnBnv8zuixK6D3	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jxgvBKhWBRYwemVhvE4DawFGNJEU3gRu8W8ABbeBz3meatNiB94	13392	18850	18850	1619332200000
27097	3NKy31q2ShWpYVutexkfWJqpnp4cmA8tMgXvoug87a4UGPNBoBYq	26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	1507	1280	516	12463	18726	jwZAsJbFNrH9r6XLLEdv2TaBRVGpN4u7gc3MqxQiKzStTd7f3wD	13238	18856	18856	1619333280000
27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	1564	1092	524	12463	18729	jxnVEMRYvhwP5hwye4nGVPyzT5kL6MPcZX6ZqKtdVTDuw8vSeTJ	13398	18858	18858	1619333640000
27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	27101	3NL44UzXJs4hr8guZ3zkTZPx5XB3mMGXX6a9RVSRJWDkLEXMVGS9	1444	1381	524	12463	18732	jxvmMZRA1KvzvnTYGdEBNHkwfET6heaFL8RusWZ6naDPX1oEmr8	13400	18862	18862	1619334360000
27110	3NKm7aQU3qmr7xxZamft7vFRyhUmwNta2et4c2fZBHVzc9XEPruX	27027	3NKVY72fKVNJzNMRcHp2Fezu9gsWYvaCWqcR6AspdDY38eL3Q6De	1516	1294	521	12463	18738	jwpFUtm9irxK3jkXu7UiaLLtmsd54TUf2mf2Bg5g6mTQgZgz5vW	13312	18865	18865	1619334900000
27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	1611	1095	525	12463	18740	jwebVxARByH3kAmv3Yewmw8YundW8JHN9i1ig65CZBcFpVbsP6D	13404	18866	18866	1619335080000
27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	27115	3NLj95CwrWfop3oiUjv6V237C1HmT7D8MYexGvU5hU68kVvTC3oA	1646	1108	525	12463	18744	jxvTVDtW8swLWf68MeGHob5LV9d41meXPxrG8W7cwQ3bbJwzeYm	13407	18869	18869	1619335620000
27119	3NLSiDvc11H32dDM95UCGcKzVh4214zUEosJTgSurAuvNnCdbjwm	27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	1445	1290	525	12463	18746	jxFu7ZeLGim9TNmn7LNC9A3KgJitRrXhQaPrxUrhBDmiW7SrSLm	13409	18871	18871	1619335980000
27120	3NL5r9oUAHi6ahZGnq9DHLS8sdDTpe6Tt7X1Yz4gzHS5heMArwXX	27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	606	1049	525	12463	18747	jwufmAvi11zLs3quTCtruD9BkDhTg9PPZZADMfkj8mPDMgBfK8F	13409	18871	18871	1619335980000
27122	3NKzfMJ2dMkaehiYeFX7eoYoDiav2GGizYSEVv7WbWat1HNMsVvC	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1406	1393	525	12463	18749	jxQ31Qu8VZaL3sSVxwHEaMtTdUcTg8L695gdt24fPp98qCroLAF	13411	18875	18875	1619336700000
27125	3NLmA8woz7f6CwYYQwo4cBFY13fTJE7FnBT22rPQMrc9mrtNAsh8	27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	1447	1099	525	12463	18752	jxGJogL8ydENdDnP4vANq1ErzHFYY68rLHfnURVjpe4cvtAJWrs	13413	18877	18877	1619337060000
27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	27126	3NLihsNjaaSHgnPfXxVJQqogQa3BhKVBA2JS7tiB68UwwABxnTZ2	1642	1001	525	12463	18754	jwH52EuKBnNebsnkUk3oBnUS2Q7c79KVegF9JAF8RFenVWghuNS	13415	18879	18879	1619337420000
27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	1406	1393	525	12463	18757	jwWbaA9AqpnReJUPRWDvzSPQFJTc7vP2dhMLT1DvuowTRpjw7Ba	13417	18883	18883	1619338140000
27133	3NK3mg3UJk5Cpkysu2k7NBevihcgyh7iAU2XTo7hxJe9i71AzR2C	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1577	1201	525	12463	18760	jw8r5x1RmCbp7B49A3BSRCuQUpfTqyDPsPorFYKmyWMeHtSB5FJ	13418	18884	18884	1619338320000
27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	1406	1393	525	12463	18765	jxKWGFuRrrhc1tVJZY25YVVZBbJrZ4B5fKNKcxhMFc4Edp44MSw	13420	18886	18886	1619338680000
27142	3NKaxc7wsAuGfhrytkcisAdqszMYHgjN5TqVXDNsiBkiQHJDgRiG	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1440	1377	525	12463	18767	jwzi5YyDSZh6SzcrSNS6QpjfGn6M3AJtc5bbKruWdxDMVjoZXo3	13421	18887	18887	1619338860000
27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	1421	384	525	12463	18769	jxtdYCgq87CMuNrpe9sjeADeTv23yCqctAPgJQKXN2sSYvkEcRu	13422	18890	18890	1619339400000
27146	3NKoHXNrTiaRamEUGJPykEsyfL83B9i5hEKxm7StDrzDU73cEb13	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	697	697	525	12463	18771	jwT4Khv58FLHsEqCGZe9Yg46AJsa7bRoiPxLqeRom5kjTjw8e5R	13423	18891	18891	1619339580000
27149	3NKQq8mBsvwzHrAUZmdUVb9SmPGjXHDTT3rQHoUEv3BZFewWThpt	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1631	794	525	12463	18774	jwxTU2zexLbfbKbXwBzGqQePi5R4KX8nfQvaGEaQQL6NN5TJZNH	13424	18893	18893	1619339940000
27156	3NKFkpijvLNxXs1iVJ38oM7NFKK7XrQLjMhPjpSgfgCAG3D4pNxk	27105	3NLaPgivsqu4QCgBoGyjD7fFCbvbHzL1KjyTciR4F6o86m8rUMgG	1553	776	519	12463	18781	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13252	18896	18896	1619340480000
27161	3NKCQibxvH1nSrBv4Jwbycq1wqnJXXn4TXHs5VbCCYoP6T1nnXX9	27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	448	939	526	12463	18786	jxHzzy3A88gNK3Bqbdh8xhVzNFMP6GPPTjYqBHRkShChA41tufo	13431	18903	18903	1619341740000
27162	3NKCv2NbNwpvzCNpMmAFLpQtuxoWQsPQTBi75YgoPfQP1zUQ5qVM	27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	1593	1346	526	12463	18787	jxWqLtDrhr94sexncMaqxVkybmNyTgoLYnXXS9cWYXjLvfCBy64	13431	18903	18903	1619341740000
27166	3NLWNJmbT3e9jzeRSZ9fSuH56DSYF8vvWErJiNZ3LQW66KtrLV5f	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1672	1159	526	12463	18791	jwGwG1Vc9uFTrMxge2Frdz5hZyVip9BsBFM3QCMET4m7ZavHmXL	13434	18906	18906	1619342280000
27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1643	1053	526	12463	18793	jwiWGvCq3SkFBsSXoccRkHmL838AkEGAnABZn52N1ThUrn2B6wV	13434	18906	18906	1619342280000
27176	3NL16dTqRXTHXiMa7TVUC5aKGvRmvdWRdVCyZSPJGpMrZp5UmtkB	27175	3NLuMBtpq4MGi1XmGqQKm2Te2rJnZ9JnQedGy1ym38FdESckHefy	1610	948	526	12463	18801	jwZvkmycCqEFNjrfUL1u4GBhJsYVUgnRoDD6gjdJ7FzfYsFtL96	13441	18914	18914	1619343720000
27182	3NL9FKYGJK699rSyoBUXKA4f4fuBZ5G5xaB1QCYxmTxLGGEesPVV	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1483	377	526	12463	18807	jwJmCD4XBexFGCFq4E8trBfhfVP3N6apv8b77G5B48EiFtSfgjJ	13445	18921	18921	1619344980000
27186	3NKikYxZ3EbDAUd96cEj39QL4tbKJTKgFamuEfqgDSxJHUoGAiSb	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1610	948	527	12463	18810	jx4Xmn82EAVtocP3MevTDhxEMkKADU2MCeqbykh6HVswA61fENe	13447	18923	18923	1619345340000
27194	3NKgDVTyCQsq87C25Xg7HccrbXvDnKTH2V8KBQym5TPoQBS42isS	27193	3NL92MsPtphU9wLXbQR7ZKi9T4hddjv1XVqkfWapUdBkqKVsWoJJ	1403	824	527	12463	18817	jxshGyeuLY722N3YKcwFntRnkyHu9sjywowvdm3LFhx9qqdxJPo	13450	18927	18927	1619346060000
27198	3NLaaEhBcXEei6Dy8C8CamnRnhfGS2NCrPbbizXWWjdTMQXFARCg	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1426	1118	527	12463	18821	jxqwpEfZgntuHojoCjB1ze8HSguvSzo4KG6GvaRmWLxWBnFex8U	13453	18931	18931	1619346780000
27200	3NKi314nCC6bD5EH7Re4n3i5B66GCzVJyyn64u4MFGTkcBiriDWC	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1634	1331	527	12463	18823	jx21HPT1wzpTCCdpZkqfCRAo71HeU82cLWYZS5xGL8KZ9A8kHRD	13453	18931	18931	1619346780000
27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	27198	3NLaaEhBcXEei6Dy8C8CamnRnhfGS2NCrPbbizXWWjdTMQXFARCg	1407	1395	527	12463	18825	jy2b4CgyfTpJeUKdKocXoy4RSiFeWS9qYaXfat5pYfpVadPgo97	13454	18932	18932	1619346960000
27205	3NLwuwkeqXHHugR6nCQTC8m2j2swVcubLDQPBRS47rr7w6GUhjvH	27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	1483	122	527	12463	18828	jwCJUQvwQksXEkXdP3L67b9XPNSVLziTvogtvqxgfNFmL3B83Vh	13456	18935	18935	1619347500000
27106	3NL2qye95xzcfrUHN6AMLCw95FMLozqx91CGZ8vyzQAZUjy36gFQ	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1646	1354	524	12463	18735	jwLdDoaG3qd6iy2pfGoSuW6Uk6qYsnTnPajSpZ8M4hdWGvWHy8N	13401	18863	18863	1619334540000
27108	3NL7u1MNbNMrYq1Go6BURVt8ATUvunNoKMBr3DMsLN46zh23XxC7	27104	3NKgCmPW4nLdCoqZJgT1AzfANzgZeE1teH8HmKCshFY8z9g9vG4H	1608	923	525	12463	18736	jxFHiatS74sbhSPJzLmh9Ju7PkUqVnhXjbGjJfp2uThQbfFUb7R	13402	18864	18864	1619334720000
27115	3NLj95CwrWfop3oiUjv6V237C1HmT7D8MYexGvU5hU68kVvTC3oA	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1610	1068	525	12463	18743	jxH1vArJpWFFLSdAMAkQd4oFetA4txsnWcLBwG3o3GNNNqiCzRf	13406	18868	18868	1619335440000
27123	3NKybjp8VyrFEznAn3ZXTBifVHr4ijHR2NNvXWzZ3fHiRSHqJrmr	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1407	1395	525	12463	18750	jwF8EzbX1WR8jpdk4ix6mxgXXGwq68o5rPrXe98Tdcif8AxSbP5	13411	18875	18875	1619336700000
27128	3NLCtKbLXp1dUP4eAmepxEvybzwc8tNf8Rk4U4cnHQXie2YfJmeE	27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	1406	1393	525	12463	18755	jwASF8jyFxsHosmQJ7RKmkvRzkmLEZMJm828zBC2LpWJTWreu2F	13416	18880	18880	1619337600000
27131	3NKRMezq8bcL51xSXwY7CpksdoFpm9kuSyJFSDHoFEPTC2bTqRPW	27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	1522	956	525	12463	18758	jxtyJjvAiKp75e1WehJWc19zbfEspVPY4WRKrS5c6Q7yMf22GG3	13417	18883	18883	1619338140000
27134	3NK5NGBjjCFtipbpRVJncA4uL7Zm4Kdnm4nfDGkWZqgSaCoE1ks4	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1577	1201	525	12463	18760	jxwnJz1at3XWi3CL1Krm5wvWV5sFAekhD5YZUfJd2uxmnPag1tT	13418	18884	18884	1619338320000
27135	3NKAXZktJiBzUBGhwkq7VZZPqbb7MNdA22YQxgvihgG7byXWpGc4	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1581	778	525	12463	18761	jw8nbwMfzcyuG8raaDKhHBwSTMgRVTDXUqEGGqCe9TqYQT2gCRh	13418	18884	18884	1619338320000
27140	3NLKhor2aCL9N1eHasdHqoevL88kUgfYMjKmmiEaC7Gxf8sB7s2A	27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	1670	1156	525	12463	18766	jxDuYZHAGqwyysiNYQDLZ8hP5jAGJW9AYBaiCthDv1535ketmHj	13420	18886	18886	1619338680000
27145	3NLrHxPV4ojUTWS8FDJAPPR2kBRyGjcmr22QQkGuRVPwvEv6vTMQ	27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	1581	778	525	12463	18770	jxSLqaQr82pLr3cBnys49G7nceUqBMTwYQWTWHcEAudtf8ieFot	13422	18890	18890	1619339400000
27147	3NKQPcVhwt66SqR7bSor5G12WZT3Q574moppbtiEsqtTJRabnBSZ	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	1668	1124	525	12463	18772	jwD5WLshRjkK7tt9HypgHRGqzmBdEW1P3exK6rZP3C8d77wKF7E	13423	18891	18891	1619339580000
27150	3NLMwycpugNqKGqrd3utyKevYD2KDn2UWSfqamnTozxxhcUtULJT	26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	171	1248	513	12463	18775	jwxsM1D87SJMhBLWSQqJVmEtPi6tJM3SEQkSazdqsNC5xMvj4Fx	13180	18894	18894	1619340120000
27152	3NLECqvVXJxkL2SoomgWor9PPxzTXWfiURbJxfZ94Y8GicMpgCqu	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1425	184	525	12463	18777	jwK6rXwpTeBwSjs26TuR4d2ezheJTMY6Pp6R42C7JeSZ3BGy3yd	13424	18895	18895	1619340300000
27153	3NLQ35jjNfTJ2WY5a29qLojH86Gfte1tQBLPrMD3nZSh57TRWs38	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1406	1393	525	12463	18778	jwxWDg4LUqQnCe6shsz9sCerkey73EbSq8MLtfYrQrh9w8pTbBj	13424	18895	18895	1619340300000
27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	27157	3NK51nKnW5nczQT87ZbLksxjAkd1XXnff2PtNzHLX5oXu3LvYXyB	1483	1276	526	12463	18784	jxLfm1LfDM7tLxbwZ1NiBM41qdhvMge8CfadTgAYDjRurTKBGPn	13429	18899	18899	1619341020000
27164	3NLDcnoD3VvmhrmV2pKeJ97TF3eTDhzAYgyrCBMN3Zq5dDxc24Cm	27044	3NKCCiQ792J77zznv9XDHYUmYRXyS1uL3jLGSujYRwMzUgErYaFf	576	1229	516	12463	18789	jwSQtH432rnneMgKqth8ZAC1H9yQn1BsReByLAW1oED4bGwieJ9	13234	18905	18905	1619342100000
27167	3NK33BEZo7cUVDvusGSGiymasuUs25rnXFE3nNiECof4X6PB376B	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1577	1327	526	12463	18792	jwanRCuS55BpJUkyFr5chLQNMcczC3fLn3RJSEv3rPELMynRBED	13434	18906	18906	1619342280000
27169	3NKPTj3zGcTia3RUZeWuzqg6bbRtLidUVSKM4mYihXRxy6qgGr4n	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	42	1235	526	12463	18794	jwtbvpn5e9KGPQC3n3XoEJ1U4ghvsB1LN5sj8dZFEg8xAxvwcEp	13435	18908	18908	1619342640000
27171	3NLumYbgeaZvqVjPhcTEqRMwfvicmFqcXxTqerGq3mdAs5otv5DL	27169	3NKPTj3zGcTia3RUZeWuzqg6bbRtLidUVSKM4mYihXRxy6qgGr4n	448	1059	526	12463	18796	jxfSLYYFyNgHDpBYWRgrrQQsg9MHc4j4FNghr8DCpz5moLiRsfp	13436	18909	18909	1619342820000
27174	3NL1HyvTqiaA72CBTokX4ejeV21swrEaDdNwHKTrVdhMLV21pyfn	27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	1406	1393	526	12463	18799	jx6gSeCj6VvV7BFh1utrqrbTFiQyFKXufb7fyYie23ybcbzJMKh	13439	18912	18912	1619343360000
27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	27176	3NL16dTqRXTHXiMa7TVUC5aKGvRmvdWRdVCyZSPJGpMrZp5UmtkB	1403	786	526	12463	18802	jwxVDZ893UaNY821Phk9XfoEdzyhaMSRDe7JtJuwR367XFBCpEM	13442	18916	18916	1619344080000
27183	3NKbLtvcCCaVA9jTs7B8MvYVuz3fdhERXGSdDuXt2kF8n4NekcF7	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1407	1395	526	12463	18808	jwGzHW5qkrXXcGMJjhkkti8pESRgJUKuaZDNYiULBEzNSALyinA	13445	18921	18921	1619344980000
27187	3NLHZQrbbQNNqPdhBm2nV4z3GKCruL1wsU6fUZbd6oZ7Za5tdpun	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1403	824	527	12463	18811	jw9vM6b95T8Sz71Lghqv3p398ESFom9w7K3CVrqt8Vr4EvosmXS	13447	18923	18923	1619345340000
27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1646	1228	527	12463	18812	jwiGeKqPcDtAHvK2UEffhoYJgo9FSLPESJiAE4oiPJ1sKir2XAS	13447	18923	18923	1619345340000
27189	3NKY4HpDGZykuY73iRC618pTj7T5wWG7P1TYw859pBtJn8Adxsb1	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1643	933	527	12463	18813	jxR8tzsMBCZcfsy7V6C2i6ofnJVoe9LyMcVfyfLFoX4dDvkd1LK	13447	18923	18923	1619345340000
27191	3NKttdtDe6PmyD5KogVGj7ZKi2hoY2geoERVWXHpv6F8Jm9s648F	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	1422	1091	527	12463	18814	jxiP5co5d3FCvp79GAEte8NG7QkdCnN4ZGYgQ9F1e4BkUs36PrR	13448	18924	18924	1619345520000
27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	1571	1335	527	12463	18826	jwcdoFWW9kyZ7ku67ACL7zUgkDSkPmrao6g4TP7znWAnwFF1iH5	13455	18934	18934	1619347320000
27206	3NL6FiqASVYj5WfeYdoqSJxQrUNhE9o33iSvxTgbiv9rETzFjaDD	27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	58	1035	527	12463	18829	jxBidfSnG8ZB26Y2ciwDrMA5TDz4Ag4XSk2soo4MgSNCHRRjaSJ	13456	18935	18935	1619347500000
27208	3NLCEfRSedkthbgqNkP6AQxeF8qdTxizAshdiqHV1eiW8TT9vWMe	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	80	1273	518	12463	18831	jwSRraBsDFJKch42c6jDy9j9GuL7Gu4NovTgF12w7LBjn1tm8ym	13280	18938	18938	1619348040000
27211	3NLYBUxgVpyhfqcxmChstwH1Np6Khqn3poPX6L2E7EMVKiDiYsBH	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	1529	1190	527	12463	18832	jwc5hYtmMotBr6bRUCae9fD8VbKPca8PqNcmEf4t5oaoedD9TC5	13458	18938	18938	1619348040000
27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	27211	3NLYBUxgVpyhfqcxmChstwH1Np6Khqn3poPX6L2E7EMVKiDiYsBH	1500	1051	527	12463	18834	jxZcFNCTK4D8h1wXgjeMBsYZWhsrANn2gCGLJy5FybuLdqdPAXx	13459	18939	18939	1619348220000
27218	3NKzYNmT6PDaG8Qtz41Uy4GN8EtPrpfYBbFDRyqjqi45LsCtD5K3	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1407	1395	527	12463	18840	jxP9Gjwz5LKkz4pzaEFCBERMefoKRZoNZmWUkAE6AkvQebqFXDn	13461	18949	18949	1619350020000
27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	1406	1393	525	12463	18745	jxeu1tC7FNjewQsiBsUTkjMcohwLRQ529Upj3Dyo9UCHaFm6uC7	13408	18870	18870	1619335800000
27126	3NLihsNjaaSHgnPfXxVJQqogQa3BhKVBA2JS7tiB68UwwABxnTZ2	27125	3NLmA8woz7f6CwYYQwo4cBFY13fTJE7FnBT22rPQMrc9mrtNAsh8	1508	1387	525	12463	18753	jwvBNXGCfPZcRy6Gz6iAiqbdTZSte4RrM43dTfAK6DdgY6NNitG	13414	18878	18878	1619337240000
27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	684	1226	525	12463	18756	jwHyQMCrNutqRcpxoVvppXCpcoWUDjJH3oz2vVUrncfJAmHTjEH	13416	18880	18880	1619337600000
27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	1407	1395	525	12463	18762	jxzgDYRLcpdsENX2a6zNg9fdoKcQ78ok7fvxufShQSwCmExh8Gc	13419	18885	18885	1619338500000
27138	3NK4cWuP3cRyG9QkQdJZxP6dLZHsv5HV395YXMwWMVobnD3mwYry	27053	3NLdzNrbuAcKpBXHxnH1Ei3pAoqFULVtXtAHQ5x5iMAYEbDAmLYT	1670	1156	520	12463	18764	jwvpzE4TucxZBNZKk3DfWazcgUdcZSY1jDHjiwPfJyt5S4fDMoy	13319	18886	18886	1619338680000
27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	1637	816	525	12463	18773	jwbxFxNesyCTJppUobtYVkt51xESXGuQvWAa74mXvyxaVnH1PPm	13423	18891	18891	1619339580000
27157	3NK51nKnW5nczQT87ZbLksxjAkd1XXnff2PtNzHLX5oXu3LvYXyB	27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	1406	1393	526	12463	18782	jw8Cjt52V36F5RUhdmoqFtqhHT3ETHS8eBfRLK1YsGn9MQ1H1s7	13428	18898	18898	1619340840000
27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	1407	1395	526	12463	18785	jw92577SDSmi7mx9K5ScfTM9qm8Zq3fb4xoLgKDKYX9xmdoAuPx	13430	18902	18902	1619341560000
27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	27163	3NKTLyXGU2cmQ4XmNQMCZTu5WxCW84uBSz32r7GSA9obqZPibALL	576	1229	526	12463	18790	jxwXnZcEqVYtEBjrxuCkia7aQevm2dPdKUBd3F2tZ1wEHR5Pmsc	13433	18905	18905	1619342100000
27170	3NKc8YfBXzUcLUchxKkJUkyk6T8u6Nr2gvQznAXwerRQ65V9M8G5	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	1477	531	526	12463	18795	jwhAUkGsGbhxT2qapCTFQ2TCUNcMhYGeuMrDSmEEe9TCZsr91rc	13435	18908	18908	1619342640000
27172	3NLheaVwn5yYGL1tpcpB9ghxP1DqXv1fnZkEG59MSoCE1wJcmySw	27171	3NLumYbgeaZvqVjPhcTEqRMwfvicmFqcXxTqerGq3mdAs5otv5DL	1675	1216	526	12463	18797	jwDZVt33kyW12rLw5JvrxtXt38PufURqvtYynQPHzNm6BeH3Ump	13437	18910	18910	1619343000000
27175	3NLuMBtpq4MGi1XmGqQKm2Te2rJnZ9JnQedGy1ym38FdESckHefy	27174	3NL1HyvTqiaA72CBTokX4ejeV21swrEaDdNwHKTrVdhMLV21pyfn	1596	1237	526	12463	18800	jwfzaGkbH1S3bXtREkGQj6dZTkmidu2EWPkkNucdM54Ue5gYLWB	13440	18913	18913	1619343540000
27178	3NKwM3ovJAyLnQ2t5eqPr8k3ZHLLtUF2jHLNExCFxtX54RXfXkm8	27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	1407	1395	526	12463	18803	jxp7sE6o6eFJfX8T5jyZBCfXNz3tttdGot8yEmn4wDD2zsVGfqX	13443	18918	18918	1619344440000
27180	3NKo4XzJyXTKUZqY729fHVqoGN4oTTBsyocm5GRdYXq1iCCG3bVx	27150	3NLMwycpugNqKGqrd3utyKevYD2KDn2UWSfqamnTozxxhcUtULJT	171	1374	514	12463	18805	jwFJhxPByBFaL2BDVHrc9KgEcWzRVb4kA3wuG9L5RLHPGU6euf8	13181	18918	18918	1619344440000
27184	3NKjJegcUcRGyXZ5tFERK4BLkAcwQvzZyMfkLsA9vX5gEBDsHUUy	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1483	377	526	12463	18807	jwJmCD4XBexFGCFq4E8trBfhfVP3N6apv8b77G5B48EiFtSfgjJ	13445	18921	18921	1619344980000
27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	27184	3NKjJegcUcRGyXZ5tFERK4BLkAcwQvzZyMfkLsA9vX5gEBDsHUUy	1403	782	527	12463	18809	jwGqcteLTxf3JRg6QkJMcE6yygM2VVWZahzvGkwrqFHcZKPnoya	13446	18922	18922	1619345160000
27192	3NLx6LMJV54hCxdUEapt4HuK78ik3eeLb1Gv9MTwCbiwPiUxfSaY	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	43	1310	527	12463	18815	jxxUxKR5NCon3uQnoytCBtgB4ktojuB4VdLU8MbNx8V2m6Ysopf	13448	18924	18924	1619345520000
27193	3NL92MsPtphU9wLXbQR7ZKi9T4hddjv1XVqkfWapUdBkqKVsWoJJ	27192	3NLx6LMJV54hCxdUEapt4HuK78ik3eeLb1Gv9MTwCbiwPiUxfSaY	1607	1348	527	12463	18816	jxBa8LRnuz9zW1S8dhn4hHibw1hT45EEbtXiXdNmJ26eJUPUPpy	13449	18926	18926	1619345880000
27196	3NLbQscxNz4fGBKtqoTcbpDQSy62rpXCZsFoGdKVzW3KXEZJzSR3	27194	3NKgDVTyCQsq87C25Xg7HccrbXvDnKTH2V8KBQym5TPoQBS42isS	1581	778	527	12463	18819	jwYXh9yy4cFjD7kkQWsgKTTt3LEUz1uiz44m9Jx2Ps9Z176j8pp	13451	18929	18929	1619346420000
27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	27196	3NLbQscxNz4fGBKtqoTcbpDQSy62rpXCZsFoGdKVzW3KXEZJzSR3	1406	1393	527	12463	18820	jx4BWxifuvEcvJeFVKQxEm1X2Gp6dU5qmsqRaJzAJ4vTqpCc6hN	13452	18930	18930	1619346600000
27199	3NLhLBZwjiRd9Q4Q85Gz3NDzPtv1Tajb1WF3JUVv7d2EL6D1f81k	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1633	1024	527	12463	18822	jwNPvhbV23eEAHaNvx5UrQjv982dS5SViBzCQV6xEvQV2TGRFBz	13453	18931	18931	1619346780000
27201	3NLtvkoJWXc9egNz36jBLTTTUvHAfTDc5q3JrCAD5Eg5v1EigUwe	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1633	1024	524	12463	18824	jxaSQXj1iAD6dkT7G5zH3kvqE9fu33ubxQ3QPKLmfGki6P4v5bX	13399	18931	18931	1619346780000
27204	3NKuwLtkkDKYafnsUN7u87tixJ72gcSptB2kbDH2Ha46JaL9odmK	27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	1534	574	527	12463	18827	jxzSdRtrhUW5i8tQMTB7eQv4fUQ1Up3FYrbKsiPBcY9NyBMkEYb	13455	18934	18934	1619347320000
27216	3NLgXywWAorSEW8QxfEVdnHwvYhptp878G7drMWUQecWf2Jp8fWw	27195	3NLrHLbrG9a5gu2Fc336CWJ54f3aaxMic2QGWCpoiEwkhSFKBx3B	1457	1145	526	12463	18838	jxuze2n3E4RViTKvRseLHpHftrp9WSGVuFedHos5553rvxGiEa1	13419	18948	18948	1619349840000
27221	3NKuYNaujeosiCjLN2NRh1RWU13NwN1fcvSsAyr4be8rfhLG1nUV	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1596	1363	527	12463	18843	jwtzDFCG6j5occMSHXahXworiMNiVBsquo6ZVzQ8F1C7hSciCKY	13462	18950	18950	1619350200000
27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1546	973	528	12463	18846	jw8z31vJmWzQ2hKS1kMLW7pS5rkipfRzuPrZwdHGYRMirk3eJ32	13463	18951	18951	1619350380000
27232	3NL7AEYWAx1HuYTyKk9xcLV4EgiErtCQtEmYB4gvDPi4tAPwQ89i	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1610	948	528	12463	18851	jwwFyGka7Zdwt3wqdzA7rPogyg2aFFe4sWzWEaDRxTbHUfu9tD5	13466	18955	18955	1619351100000
27234	3NLDh9mn2Tsirm1RUuqNMAiXtSznhUVYE2oF1NjK6XxFMx7GkWwU	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1634	1331	528	12463	18853	jx1Jk2rn7nEwcptWYv7pGqdmABikxhrx5QPniiSx3hwAHcKVZAw	13466	18955	18955	1619351100000
27236	3NLqmPgBPgNVKystgb54N5BQ4cy21nJGpsXHfuWY4qtGT3v5nRKX	27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	1402	852	528	12463	18854	jxZZTQfU8TPfSEgD2MEMBohkuCTT47umpUsr3ry5B6KADJJWAb2	13467	18956	18956	1619351280000
27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	27240	3NKXLf27fhPCterZxFcWXKP33HCFLzjG4HySbkMCiRZxXtLketUv	42	1361	528	12463	18859	jxVpdgWJ3cpvgcQz1Fy1NUw1mZLN3zxgCXGdaYS3hNiXHfENrcJ	13470	18961	18961	1619352180000
27244	3NL9cfBrh4T5WCjppf6DLUswiCc2tjYJwkeU7G5VGWxJXPjByQFT	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1407	1395	528	12463	18862	jwfar2QpEtnwWhiKVoDsdSjS25vJfHbdHkQVVqChjNnQmBfuR4t	13471	18962	18962	1619352360000
27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	311	1307	528	12463	18866	jxHCkqGKkK3RehHg63srXPuHJ23VhW3t2NY8i4yrk929RG7CRdv	13473	18964	18964	1619352720000
27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	27205	3NLwuwkeqXHHugR6nCQTC8m2j2swVcubLDQPBRS47rr7w6GUhjvH	1403	824	527	12463	18830	jwEEydHVSnthrdABPmM77t2YK3vE5oeUkvY9Li557KtwEpPJoza	13457	18937	18937	1619347860000
27210	3NLAs6uP1K3Yi9YdN2fmeRDdx1g7cSB1Vfkcb4cGfEjyJziuTHQn	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	80	1273	527	12463	18833	jwUpnvU4yFyxrN5FqGngBWawziDYyCv5tYCHppQkANWKVtYHppW	13458	18938	18938	1619348040000
27213	3NLZqx4NT4Cn8wk8Z4qT1FxwEXo6q23kyAm2oXTWWaunNDJoGuFu	27110	3NKm7aQU3qmr7xxZamft7vFRyhUmwNta2et4c2fZBHVzc9XEPruX	1516	1048	522	12463	18835	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13313	18944	18944	1619349120000
27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	1407	1395	527	12463	18837	jwnYYYH9Hz3RVRAJ39T2jmnYgGRNGnGbTEFhby4n9Lsb7SHRSPi	13460	18946	18946	1619349480000
27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1406	1393	527	12463	18839	jwsfQLe4fK5PBBmiPW8C14sYZrhmZ5wgVjohxAhfGQsgZiDWi7n	13461	18949	18949	1619350020000
27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1671	1239	527	12463	18842	jwWGYebNZFYgDfdCkGaT4inToSomuQvHXmXN91Q6e4zNj6qpS2y	13462	18950	18950	1619350200000
27224	3NK3wkx9v9tKwt9Cb6zyJqcw9Bv9vKN8PukiW5UCPg6WTsB7wijE	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1670	1282	528	12463	18845	jwadc1wqE1Pe3Y9wF5ZU6rougEc77i2kqdY8rVqTAKU1WqFYx8u	13463	18951	18951	1619350380000
27228	3NLRG7b6Csw3wQD84wR2DoBKKY7gYWcYcXM8FCD8b3SP1t3xdLFv	27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	1403	824	528	12463	18847	jwAQhNEGDeyaNE2TPJbgnZS3i88bbohW4znZH4R91iS4xDHRhfj	13464	18953	18953	1619350740000
27229	3NLNXRrcy89fAVawh4vziRLPLDmRSyQ859JnhC9VdprywsiZ5Hnj	27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	532	1303	528	12463	18848	jwqiNwPyQRGKvypMBVHGMq5hEu8zuACpUWCZpb6FJk78o2d587M	13464	18953	18953	1619350740000
27233	3NLdhkzd3bX7bL7TQEwLChRpLfwZA92QsnVYgY6h33ZPWwbu8UvV	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1419	814	528	12463	18852	jxgofSQdeiq4vTy2mQxBHCGruFFizHbtdu6LWaBWPZD9Qkmi12P	13466	18955	18955	1619351100000
27235	3NLDmFfRBzoiWvEkkEtHecSCgbwAy6AgfQ4QZNViWLPhQCbiJ6ny	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1419	814	528	12463	18852	jwDthFufatfFLUqjB7qR4Wqves6Efr5sPi9wfSoSxk9gnG7HtbH	13466	18955	18955	1619351100000
27239	3NLh4YmMeYkWTDp2Hx7y5YpkdMoAa2N71gU4ZrrYNhwG77jxihh6	27236	3NLqmPgBPgNVKystgb54N5BQ4cy21nJGpsXHfuWY4qtGT3v5nRKX	1406	1393	528	12463	18857	jxoH3S8PgiKUzjXATCvTBM6vC652rzmdZbZENxw2P8A7aq9cCSJ	13468	18959	18959	1619351820000
27242	3NLCJQypm3MVkX35AVrKhiG2bJqS133n9cw6spMGrTHvFP3oFSaV	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1406	1393	528	12463	18860	jxDP7fmKWrSmUNANNb2GYvr6kf46H5tGcLNd5hwa4JeW53MMWLc	13471	18962	18962	1619352360000
27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	1483	261	528	12463	18874	jxkE3fEdeEdzkeYMpHh2cRW22h9yvLXUYDmSAdKNj4G3KhM3NJz	13476	18967	18967	1619353260000
27264	3NLhP8k9ybrUMt3nrwyVNLGuW5ptFbRbfVMHH2r7JBbZFSkyLBGE	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1529	950	528	12463	18882	jwDSYHCNZag76g2tR3Fg2gMbRQF133H48U6UYGhZqx7Dcg94YW9	13478	18969	18969	1619353620000
27269	3NKqEePjLe4cCGezp8LBSjt7CsSXpJT1pBtnW4wnXMc4xVYUTya5	27267	3NLpJbDpsdS7k3pip9pnXkJaxhBxuNkYVjMg4Ch2yTgw1gdLgbLp	1631	794	526	12463	18886	jwdyxGizeS8pyAyNRHqNZZ9u3ewTvCHeq7kHHHdpDeDgLVbRDou	13431	18930	18930	1619346600000
27272	3NLsLMhrHPEmgNpAVGs1nHty2P1kv1nqh4i1tG1o66eisWLjDFqZ	27156	3NKFkpijvLNxXs1iVJ38oM7NFKK7XrQLjMhPjpSgfgCAG3D4pNxk	1553	776	519	12463	18889	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13253	18971	18971	1619353980000
27281	3NKdrm4wCtSJMzzb24coKaRaFcWZYF3M2SGnLHf1hnCZHi58BtLa	27279	3NLk5FDzFapLo3FRUWnXoKKxU4EXJVE5tgQkaX8Y7rXmTi15yykH	1571	1335	528	12463	18898	jwnSz3BGnjas4KvHmnkwhsbofCJWyLqaGQkz2EskSBm52Fzivaw	13484	18978	18978	1619355240000
27284	3NLVAniznUe7XtkT8exCMbM5rwyiN2pKLxJfL6H9UaqZtfHDKHXz	27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	1461	1271	525	12463	18901	jxNFJQJEqjn96pwbrRuCkU7Z53kn9cPqvGWMzbuC3UkeKBg7keb	13408	18980	18980	1619355600000
27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1587	319	529	12463	18904	jwNFeQBEEXQ6FHFZtgEpUyeF5MSZCLC3afQNL4B4bPdp99y9xWn	13487	18982	18982	1619355960000
27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	27294	3NKoCRKRnBYE3AMNZNMJ3KTqTBn6N7cPEUPxwuiRE5vViM9s7NLB	563	1359	529	12463	18913	jwigzcpwV1SZ75Tu1dkErLJDL1o4uKMRYUnWDjpwFsvUyVvG4Uu	13491	18987	18987	1619356860000
27306	3NK8hjzVTwz6KJxra9zZZAxB7jR2UvJFXeiwMr3JFe3u4CRqbSpo	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	633	633	529	12463	18923	jwCUTFrp8aJSWLTuaxV8pRuuzqkENuPL6AL7zuSAsGWf2J2PSBX	13498	18996	18996	1619358480000
27313	3NKGBxRuFy3Jh6BqrBKsCz4Jv4AmGgBh6Ase1LT67WmJmsiLB5t5	27272	3NLsLMhrHPEmgNpAVGs1nHty2P1kv1nqh4i1tG1o66eisWLjDFqZ	1553	776	519	12463	18930	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13254	18999	18999	1619359020000
27318	3NLmiLv63jsytDCwCmDtE4uvza9Sf1vJFwbTFMFRn2XC8mYC4Acs	27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	1406	1393	529	12463	18935	jwv4g4vbZCfL4RGMR7GYQY9Ekj6mrVUEDefw2WfiAaRBQks4dQ9	13505	19005	19005	1619360100000
27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	1555	1221	529	12463	18938	jwrHRQY8du57knfvBGJv83wLRCmwkbMJnnRFsFCuME61i8boYkX	13507	19008	19008	1619360640000
27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	298	942	530	12463	18940	jwoyr36ZKGhokNvcNjgatPXDHVco9V7h32XUhP7MrvBzZi4jSr9	13508	19009	19009	1619360820000
27324	3NLWg96oDdJzhr2AqD1kZ8acw2jzQeXjQJxsuE8xX5C2BUiuqfXv	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1589	920	530	12463	18941	jwgvVWfssjyhxpGac8Ady2gMJbF1zQxJGXkicithWq4f2wbcys7	13508	19009	19009	1619360820000
27327	3NKmGcPSetX4fsF7x9hPm6CgjEnmHFAsLK9TQMJAUkm5TtoyLXDd	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1652	1069	529	12463	18944	jx1a7BKNBQVErSABgLqe4UFL4LSp7Xj3WLQWXWQ7tShqD8ntdbU	13508	19009	19009	1619360820000
27332	3NLRzueXZsRGANhZjzhnnGr4jq9QMR3rtUJYdGgmTroUkbNsNiN7	27330	3NKtUsgiujMwE2cSQ3v3grW3eXuZ4QQ3bJY7hQYhhtEc6RfkUtao	1571	1089	530	12463	18947	jwtre7iQbSA3xannAbn1cN9Cyg5TXc12DeXNjMk1V6Pd2nTL956	13510	19011	19011	1619361180000
27337	3NKWxch3fDP4vaJZCEb4B77KbJgSnkMgSPXcYTdi9GwgYpkwPf1H	27336	3NKGQNJLeic7ZZfL7198kWHjh8EM5Cm5qsvqnXpbba8KWLdC6XG6	684	1226	530	12463	18952	jxTzfXFiyv4bdBYrYMZsuxhYJVEEhemxM1wyX99DqCgyCghShDE	13514	19017	19017	1619362260000
27341	3NLH2fJo6HLmkhEAy7G72z9Bahw6FJ7WfDujsPXkSCyygY2BrgQU	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	1673	1242	530	12463	18956	jxfrpeeFjJwgket5kbsJcZ66xncDZYAzVaBCKLx3eMqDzt34y4h	13516	19019	19019	1619362620000
27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	27344	3NLd5PCsm6g3WTE7RuK5eov3GaTLogbqtHUEKBBfrzr5ULTcw4We	1406	1393	530	12463	18960	jwXEs3NWmpCFtpajzeGHugbXU8L5sX5yv39kRceizEghiwjqk35	13520	19024	19024	1619363520000
27220	3NK35ZK4FKAFQarjEsbHpdfffghkRmvwhwkkap7wR7h5WuvRgt1F	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1671	1239	527	12463	18842	jwWGYebNZFYgDfdCkGaT4inToSomuQvHXmXN91Q6e4zNj6qpS2y	13462	18950	18950	1619350200000
27225	3NKpVFc82o5cv1Wit1WEzNsimLXTSESkqj8E8m7UTwfzd6iL3N6G	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1546	973	528	12463	18846	jxjDbufEyUQQD8o7r1V21bPnq6e7SVzrfRWp1vr8KnKjdFFzRH2	13463	18951	18951	1619350380000
27226	3NLiwyywxqy9Y9dn6EZGD48duoE36rtHz7K9u2S6y75S8bhhVtWo	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1670	1282	528	12463	18845	jw7cq5ovZ4kfzN1oi85qqo3QUkPxiaK1vRq9V4xXNjsAnXArt37	13463	18951	18951	1619350380000
27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	633	1384	528	12463	18850	jwWMpgnnnama8GHd1YPHFddaU8rbCNVzFUF2eoUvqQhW3d4zfGd	13466	18955	18955	1619351100000
27238	3NLuD3dNN4GedmALRECb85hEvir5VqErxHq7aG9JMyi9o9kdNAND	27080	3NLC5meqe5PdZZ8X2bcAt2NycriLu4PwkCUdMj3zuQHQitCuNa4k	1623	830	521	12463	18856	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13340	18957	18957	1619351460000
27240	3NKXLf27fhPCterZxFcWXKP33HCFLzjG4HySbkMCiRZxXtLketUv	27239	3NLh4YmMeYkWTDp2Hx7y5YpkdMoAa2N71gU4ZrrYNhwG77jxihh6	1646	988	528	12463	18858	jwHsh9xp3AjTnXWF7UpGXGj8eeGxEWpoLbr4XvxS47HB4w6o7mY	13469	18960	18960	1619352000000
27243	3NKfbdbg6NKTX4mfr24t5fFnYS94NxNfemkDXMVpntpDh7xechRG	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1402	868	528	12463	18861	jwPnRmfKvnaWGHrxoM2bCPL1zAgrPWjM95q6KVJhZt85ZvvDeDW	13471	18962	18962	1619352360000
27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	27244	3NL9cfBrh4T5WCjppf6DLUswiCc2tjYJwkeU7G5VGWxJXPjByQFT	1407	1395	528	12463	18863	jxjL5fUqhD5hAWQCh5pr9KTPsH4krHA2RyxYDuiyNMKfCkCDrJY	13472	18963	18963	1619352540000
27247	3NLUGFCHZDJRy53xY5MEP7FouWJSYzFrKr9eJTFEjexcopgt6YZT	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1490	908	528	12463	18865	jxhe95w3zPnNybpre6ijKeiDaQsCybSjPeKnQ8Y1aeDFCxYpa72	13473	18964	18964	1619352720000
27250	3NKg6GpuwLF5rCzjZedUfP5pv18rfEkbv625DiZhwSsgyww6fQ7Q	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1647	1302	528	12463	18868	jwN3Ntj4L2ewPYQ7yqsUb2LYQgqMXo8S8NxxUHmHDXvUmhoiByL	13473	18964	18964	1619352720000
27251	3NLqFYo3sVrzZV2WteczFYBV2fAsJRbLeXf57G1V5SyWx2Kb3Xbo	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1647	1302	525	12463	18869	jwU1WEvECouj9gnpdcKHJzGhksqBRemH8cUEoBxaMCP1kCjp4G8	13411	18964	18964	1619352720000
27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	1407	1395	528	12463	18877	jxyXBhL78oxbWoVtNprYzjiRroTdgkzGnaeHF7htzVGrfzZNP8G	13477	18968	18968	1619353440000
27261	3NKTq2Ro5TPJkPHwkgbvo32kbAptpyCfAxAQWEhKsxTb7nnvpNjA	27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	1656	1097	526	12463	18879	jxe9hzSWK1wKtuwsNmAqyCQwxLaQYHstXG6srwDuvqbBGAseBuz	13426	18968	18968	1619353514115
27267	3NLpJbDpsdS7k3pip9pnXkJaxhBxuNkYVjMg4Ch2yTgw1gdLgbLp	27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	1631	794	526	12463	18884	jwpJyextC2V4Gock8JmK7gDo6xFk1AjpSvCMGpauWHD2BMABgyZ	13430	18902	18902	1619341560000
27271	3NKgJQpZk9gNMTCJm23Y3xSUEvx9hGbgbt8smNeXwxt9Hz55JZF9	27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	1500	1051	528	12463	18888	jwj3jnrJ55bUy5PsCxtvhuXqQwKfBnEB9zeaXL3DnrMMJTAU7ar	13479	18970	18970	1619353800000
27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	1507	1034	528	12463	18892	jxh6U7kWgnX2PsVRY3opFDRQtjeEyFpUxi5bSo3wEv6HACmW5D7	13481	18973	18973	1619354340000
27277	3NLeMWnahZF6B7YEr1g8baSST35ZozmUYCrjFpUiivXT3Z4FYDK2	27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	1476	1245	528	12463	18894	jwrGGhHdxKynrCSooMnaTE9GJ75mbdejftkTPQrbanrf5XSfGqV	13482	18974	18974	1619354520000
27292	3NKz6XfMmtpcTjC7FucnfuuhZ1VSaMLjzd1kFxsvgBXr4SL2ei9b	27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	149	917	529	12463	18909	jx4zjwMR8MkiztrE3GqcdMZWMjSS49PbFrRtoAnp2goDDoz41wK	13489	18984	18984	1619356320000
27295	3NLhrSArqHwk2FUMeVDWQnG2oyDEALr6iSPG2AExbpVKFqfMVi6y	27286	3NLmv1sGnoGU78AXbjoxXgvL9VVgKZY2HyHt9czTvkcTT8gss18S	563	1359	529	12463	18912	jxDNpjpkNxRBbv8pCYbH7TVmuG5FtzrMafDz4kaUWpvyZRkZecZ	13488	18987	18987	1619356860000
27297	3NK6hR8Ccf5MeB2xiJc5FZ68kYsgMJbc1sXkmv3y897yYZU3PnEK	27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	1627	1019	529	12463	18914	jwKFckg8xvW4NrvvBKZjicFDY714f7yqCJyvZVWJb8fQP4CEMJb	13492	18989	18989	1619357220000
27298	3NKJdMFyaBUUEEJK4qDrGCKcLBqwJNzTGqyp1hn2aeEw15GjEjvv	27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	1555	1101	529	12463	18915	jwR9uSowGxwMRKerHwgEZyAN66SWov2AkRT15JjSF16nG8sFn58	13492	18989	18989	1619357220000
27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	1559	1107	529	12463	18922	jx93p3E8aksWPfq6ioD4EaJk1UfCueEC4SSES2YW2VgUAhM6kw7	13497	18995	18995	1619358300000
27308	3NLcTTb8NkjWDk1NkrWBNiptHga8SraLKUYW9a4qSy4FWx9zTJ1F	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1589	920	529	12463	18925	jxYgXdAgU6fyjHChMfwHNFTttE5JrpRGKJs1X6XXfPhac2V8EDH	13498	18996	18996	1619358480000
27309	3NLEYutwb8b2TNZ392boZyRphTh4Fm6KY4Z7NdyD9Mw7DdV6xHS2	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1579	1023	529	12463	18926	jxkpire9cn4ChXy8hqZVAqDEXKwNko4jhch9dUfnRm3FeKgnekg	13498	18996	18996	1619358480000
27314	3NLMXrwz2G8QSQ8XYJsrhfvc6TueDEHRoEK5Ey8oT24zK7T49GDy	27312	3NKaHduu9G7dvmfnaT7mW9noRy9JdvfUcBqDBq1tboUnM5Qdxudn	1668	1124	529	12463	18931	jxaVbvGqPeNrbrgqAyUZybxv47pyMfBPATvoh5HGuL8b4K3poeH	13502	19001	19001	1619359380000
27317	3NLaLzSpkzxeuqKeDmUQ9p3bWE5vrakf6R6s9DeidpAU4oTK47Js	27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	1406	1393	529	12463	18934	jx2pEZ5nmtgq8226zUE8cecp2zqYAwfPpCEjAxLghmwrJ1t3S3d	13504	19003	19003	1619359740000
27325	3NLUu8UqMZUGg1raLwCUFX22rLg7jtPhgwcvudQmEXbzQRsXZMgY	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1513	1379	530	12463	18942	jw7bbhVPV5h2dW7Fzww6ysDU9xSQRohCA8R7AgP4C93Ve1Qsq5M	13508	19009	19009	1619360820000
27329	3NL3LhBaKDnZC9VmpD43EmZqFvBeNNhkGFJaoesPcdjLRqmgkiU3	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1508	1387	530	12463	18943	jxd7xJMadBZYYR6GG1gg3ZxxeSWb5zAMs6U9E2WqCKjytCj3Y6Y	13508	19009	19009	1619360820000
27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	27332	3NLRzueXZsRGANhZjzhnnGr4jq9QMR3rtUJYdGgmTroUkbNsNiN7	1403	824	530	12463	18948	jxYhsX16phgpmUgotZSifMXb5Fz8bQSgwVw531L6FXAPmNWNXDm	13511	19012	19012	1619361360000
27336	3NKGQNJLeic7ZZfL7198kWHjh8EM5Cm5qsvqnXpbba8KWLdC6XG6	27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	1483	308	530	12463	18951	jwSJpYkhuNBGptYeHaAupTLGMhMevpkQ2AZHG6YvWg73NrwGNX9	13513	19016	19016	1619362080000
27346	3NLHv5q3QYAe8qpafr1CKBs9hZKSFYkFHHGVkG2tTRYJVc19iDCv	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1405	867	530	12463	18961	jxi4YaHnr75QskyQtmcivxDk6tcKy9kvNUQjF74SZeKxjpoS164	13521	19025	19025	1619363700000
27347	3NKYfdZG1sWW4ypQqTKn7w4i5dsGpxobH1irNQ7Qt3ifYT2C9qwB	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1402	852	530	12463	18962	jxg7NGv4iTumkBbKLuMv5rzpoFuJGMUgvHEXeufy1o8nSFXD2K3	13521	19025	19025	1619363700000
27246	3NLc8jkbxTJ4Kv8gmp2FACj8d8xH6h4BtL33AaF8e17QksoCcn7d	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1490	908	523	12463	18864	jx8rG1GL4SzFyWmCuC4czpmGUSRUmWv43pD3F8LAyA5VNHmQDGD	13382	18964	18964	1619352720000
27249	3NK7B89DyVMr1ud1BDX29ory42yMHsFWvrASiRmLT1LpvVLG6v9q	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1673	1122	528	12463	18867	jwDcXY4PW9rPBWF8XXNWC9QbwAdtt9Uwkufep8o1Fo5jsEMZwkN	13473	18964	18964	1619352720000
27253	3NKjhdrn1iTCqBrBAY4UpGsxnovToR4q41rtEpJ8xQGQ4E7i85tQ	27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	1403	824	528	12463	18871	jwpicN6mEMZcakWA16zUhFUupHzA1aouMrqdEoyMipAFUH8peRq	13474	18965	18965	1619352900000
27255	3NKX6mW5KqVCWLeaJk4eVfm6FX87sGEe1ZCr3kEbkFx2vsF5KfEL	27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	1403	782	528	12463	18873	jwQmafzfmK4bWsX5MNadrmkeftG5AxaGUZcsHd4Te9qYv7gZCYc	13476	18967	18967	1619353260000
27257	3NKhDj2UKMkkN2Fm3Vo6Wfe2ftpLku7AEfJm8bF5qw8zFW64fQ5J	27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	1656	1097	524	12463	18875	jxWBQawXGHxnfU7iAGnSHtEkiCXcwnz55ZkR5W4ybM6KUBFCbRo	13398	18968	18968	1619353440000
27260	3NKAcwnJyKbxZtEfhqmuKEeVgQFxmXrtXYwk72adgdFsKxuZM59Q	27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	1656	1097	525	12463	18878	jx4U7UgSGxa2cC6awKazHknFqmswSdHcdmYZqDGuNK7pt6fCxCu	13413	18968	18968	1619353480001
27263	3NK3Kk1cTG6zvsLsoWq1aMEVkYhvGV929TPqX3wDxaNHjxLz1DLr	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1405	857	528	12463	18881	jxr5HxpihxBQq4sWfT4cY7b71Y3Fa2MGtqSNBxrg68Cr1Tw7yC9	13478	18969	18969	1619353620000
27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	1406	1393	528	12463	18885	jxryqm1njz5b48zD5Z2cV36SXjT8Qh7KJonvXAr1B63rLtGhbqq	13479	18970	18970	1619353800000
27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	44	959	528	12463	18890	jwpyESdWvtGA9Pb7vAd7LoVW76y8iMQGiaXK3UG77QLuBJbAnyw	13480	18972	18972	1619354160000
27276	3NLcWc5JV9bngaRrvo8xtmNNDJC4fFTcvpN6SLw48kubGHFca851	27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	1407	1395	528	12463	18893	jxDLGtXk6ynXkjJKh3ak6TLHkK1vLRAh14fGZH5agYuPYdprRK4	13481	18973	18973	1619354340000
27278	3NLetHgpnqLHbS6DEFdkcGgZUwZrMy92GGGboxBp5H7tBsxQnweJ	27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	1489	1380	528	12463	18895	jxJw7pLEwEYedLY3moZzbokRYXLCYjzWi94JTSECoztdKgzSGCW	13482	18974	18974	1619354520000
27280	3NKsY4kkZft7m9fMBoNnz3eHor7BhefiTfNNUZatKndL7wfd3n73	27238	3NLuD3dNN4GedmALRECb85hEvir5VqErxHq7aG9JMyi9o9kdNAND	1623	830	521	12463	18897	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13341	18975	18975	1619354700000
27283	3NK9WigKTFYajPRiduFjkth8JQABsMbWVJ4isi4P7vLQ7Xk5enPC	27270	3NLeCABMvFEnsXGBp5vZk92ZaZQUexXhiQQp9mURtjWMKuQpwAQF	1631	794	527	12463	18900	jwjo9aMuybVwnd8yMFpTT1fPkdBARapMdHqqPFpvdEg5UwedMER	13433	18979	18979	1619355420000
27286	3NLmv1sGnoGU78AXbjoxXgvL9VVgKZY2HyHt9czTvkcTT8gss18S	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1406	1393	529	12463	18903	jx1MtUuvS5iw6X1diVPjahS2ua7nKDEtPodTaKjPDBEc69MQ5mP	13487	18982	18982	1619355960000
27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	684	1352	529	12463	18907	jxoF8YC8jGXVo5LZVv8muksibmgB5fGK6wZMQ7b98tKWUqZvcSG	13488	18983	18983	1619356140000
27291	3NKYjXkLHZWLrb6LujMY8vpqToQaSviASSC8g4D3W87nNm7GfjTY	27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	1445	1290	529	12463	18908	jx91ZRjBypYd5FbTvMHMz6T1abfDBM9yvHDRSZLvaj2ZgqptibT	13488	18983	18983	1619356140000
27293	3NLo61N2DyPU4ubNqUA8ftzQrta5YkwpvKxy9RTgox1gAekNyGFj	27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	1403	786	529	12463	18910	jxb6CjG4MGPQWgKizTjGSSKAwpWxs326YRFhC6NCfVco4pCt1mm	13489	18984	18984	1619356320000
27300	3NKZNprRnsKe3e36PaYjgi5AbZaUFxwY2arGTgGnmwj2NGUxRYvr	27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	484	1319	529	12463	18917	jw9u2aEbXPJP1DVqQAdGkVKXPrtiRVipMWdWZiRm3MPs36PQ9K4	13494	18991	18991	1619357580000
27301	3NKJSxC4LuKfAps2gKhesf3BUVSHNybRP1GDXped72kYkgkULDYj	27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	1508	1261	529	12463	18918	jxvZn4bwtHnMtPaTfr7zXiLVtpGFjyXxrruEedJyVe5aLGEbe3F	13494	18991	18991	1619357580000
27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	27302	3NKkiS3dN2fUpT8t9FEojTsaqZoQSTFLTJpnBp2LXQkBd92HKGnL	1673	1368	529	12463	18920	jwbSWxNWQMhCjwEmQTUGN842BJucxob27LTjybMZY3mAqkaA5TQ	13496	18994	18994	1619358120000
27310	3NLXwXcDEL4MnfUzyVrxczxFhjTbBqB8EG5xWpyBgKFQy6Prhp9j	27309	3NLEYutwb8b2TNZ392boZyRphTh4Fm6KY4Z7NdyD9Mw7DdV6xHS2	1403	782	529	12463	18927	jwPezuqav5Z5gq2TacPg1LtdDeLxBenywQp6FxVnr6MVXr2hq7M	13499	18997	18997	1619358660000
27312	3NKaHduu9G7dvmfnaT7mW9noRy9JdvfUcBqDBq1tboUnM5Qdxudn	27311	3NKM4nb6EkeyJmhhmdMcjx3E5TeDTCymzMVUKmsRaVu5dH6sL9UX	1405	905	529	12463	18929	jwVHAbGsCJ2joX94nsv2YRZJmEZypTebkkERHeTjUBSq7i1rGBW	13501	18999	18999	1619359020000
27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	27314	3NLMXrwz2G8QSQ8XYJsrhfvc6TueDEHRoEK5Ey8oT24zK7T49GDy	1406	1393	529	12463	18932	jxi77191sNWoXYmXcTJSNLS6zeGXmKk3QVyFdFqDGuCYt8q87RQ	13503	19002	19002	1619359560000
27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	27319	3NLMg1sVZGUeJxKrcDuau1bi7885cm2w6QhPnKiKBwPhpwqW7pJq	1581	778	529	12463	18937	jxwt8q6aENs6EkZZkZgCmkvf7BS25bWPQt4DmiQCsPnETsKdepR	13506	19006	19006	1619360280000
27326	3NKXYYyQgrv2U4WKaP8Kt1KFNAaj8yTVpyD2qTJkJygteuFTC9cd	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1508	1387	529	12463	18943	jwmjro27sUP1FWkGtCRsL8rAYCeUufbEMrqsyErLUBQWBe3GdLb	13508	19009	19009	1619360820000
27331	3NKaXakmhkUs9Xxxufrhzc4ypPTAVLRJL9FwebpRw7zRTp937W61	27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	1594	1080	530	12463	18946	jwsWWMAkxhwtMu6S95vf1PQx4hxgHKMJwYAZVmzrbTk4fWqHhyo	13509	19010	19010	1619361000000
27334	3NLEyzD1XBER65RF4VGK7KR2rUxWHEFrktEFwKiakbiaBuwfbwnm	27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	1403	786	530	12463	18949	jwQsjDUvUs9pp1Lrpof3tuoh8UYYkR6boHen1UC3892pvaCaZnx	13512	19013	19013	1619361540000
27339	3NKfRP1ZF7LZv9Xc5CCHP1vhmsqrbqjfv22CEWodUFvNkYDH9PgC	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	149	1037	530	12463	18954	jx2gQc5fUfgSSbgbXPsikTwFSiPoPmXNuVAg8V3DVMfvJQsi1ha	13516	19019	19019	1619362620000
27340	3NKfYazGJuV3NojrvrSSXJ72cTbnCfpG8ftGyQchaP4vURo5Xq2Q	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	1675	1216	530	12463	18955	jxR8Bbssc17bJun7siD4RPC9UQt85LcDyPrWM7XkZa4D7qXERCG	13516	19019	19019	1619362620000
27342	3NL6APWLWdTgSbg9mCVxYofGjPhTJ6ArAkg2i75LqXAQn445ndMt	27339	3NKfRP1ZF7LZv9Xc5CCHP1vhmsqrbqjfv22CEWodUFvNkYDH9PgC	1483	1030	530	12463	18957	jx5tGKvnVhyBYrSTzGaJquUZmiLQ6qgdJvNhpDmCytYAKXpaQjP	13517	19021	19021	1619362980000
27344	3NLd5PCsm6g3WTE7RuK5eov3GaTLogbqtHUEKBBfrzr5ULTcw4We	27343	3NKo4stPJNJbiF3gU9adpZfdw363VpbCF4Rge2WsPDuEupix3ph8	1405	851	530	12463	18959	jxmZoiEEd1XGKhUqGkdMjYti8bkeaDQcacmuZKLu1JAvPUgCStN	13519	19023	19023	1619363340000
27349	3NKsJqXs1dRfsneSD6NoTxgcJFNszGm1VW7boEPBJn2okL6nGE5K	27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	1407	1395	530	12463	18964	jxmv5JKMQqmjDo9Ze55Gn2jCjoCD5h9yV7omAXSsS5DcLsgkECP	13522	19026	19026	1619363880000
27252	3NKiAeoWKHRdoebXdfo3xjHG88zbtnhA81zHVdf8Hsis6MsAk26f	27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	684	1226	528	12463	18870	jxmp2iVsYv32Kjx7gr5vmhVT2sJy5Vpzb17eXLp8oqxaEHMpogV	13474	18965	18965	1619352900000
27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	27252	3NKiAeoWKHRdoebXdfo3xjHG88zbtnhA81zHVdf8Hsis6MsAk26f	43	1310	528	12463	18872	jwx5WSsWij3wPzLaPZMDYtqTUzFRUv7X74zAooB1qJnPoZMdgjK	13475	18966	18966	1619353080000
27258	3NKX366nCRBKKQpiBHJF6qVFG7hU7QinJVfoo1usaauQduZUjMWn	27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	1656	1097	528	12463	18876	jx82m6Y3QN325Uw5LotDKLinMjygSohENjuARzNUftpk2KYCrmj	13477	18968	18968	1619353440000
27262	3NKhcaXCaps8WMSvkK8zVJ8y542QQDLVn87t6y1rfPf6r5nUdA7m	27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	1656	1097	526	12463	18880	jwJLLoZUfNZiAEbqNCsUAoyN9unVYjUJXUjB8a1jUpL64MBKmeP	13439	18968	18968	1619353547055
27265	3NL8b5b6wUrRrpWBjCain661Rp4ESZBkTnTrZzjjhMeqUUBW4pSL	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1529	950	528	12463	18882	jxARaWG6gV3CoRvnzEMQXePiJ95qKxmk38BXxKmLpxkWE6pZvcg	13478	18969	18969	1619353620000
27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1407	1395	528	12463	18883	jxYLqWsrSdkjXDhEoBPEde2fXXc1SVqr1kkLyMMtVaUrumr5tGx	13478	18969	18969	1619353620000
27270	3NLeCABMvFEnsXGBp5vZk92ZaZQUexXhiQQp9mURtjWMKuQpwAQF	27269	3NKqEePjLe4cCGezp8LBSjt7CsSXpJT1pBtnW4wnXMc4xVYUTya5	1631	794	526	12463	18887	jxFsTBskskrr8KC3rNFTZVAjW3dAfVqDGg39XunD3c9qnTPS3Ui	13432	18969	18969	1619353620000
27274	3NKDnahzKkUxs3T1C2395x6WF8Cz677YBb3vTNeXrdqBFgwuDygi	27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	1474	1329	528	12463	18891	jwR3wQ7uFvAZYo8ZuDnYQRZrcR5UJMo1iGjDPPLpiEYZKvazrCs	13480	18972	18972	1619354160000
27279	3NLk5FDzFapLo3FRUWnXoKKxU4EXJVE5tgQkaX8Y7rXmTi15yykH	27277	3NLeMWnahZF6B7YEr1g8baSST35ZozmUYCrjFpUiivXT3Z4FYDK2	1445	480	528	12463	18896	jxJqNHLBsC6GrKg6Vf3z8j3nbuUKeZ4yCfkCBR5wm7jM5EgAd1q	13483	18975	18975	1619354700000
27282	3NLXhnsUM1crxc6VDk4p7wENrzeEhg3HrGZQP5vbGDr9hQZBJAfS	27281	3NKdrm4wCtSJMzzb24coKaRaFcWZYF3M2SGnLHf1hnCZHi58BtLa	1594	1080	529	12463	18899	jxptcDkBnRgP92MAXneV1rGLyA3h3ZHa7zV7WygG1DEep74SNM9	13485	18979	18979	1619355420000
27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	27282	3NLXhnsUM1crxc6VDk4p7wENrzeEhg3HrGZQP5vbGDr9hQZBJAfS	1603	444	529	12463	18902	jxxeRdESQFasZ3s1VNnQERj8iyg335o8RKjr6SxzNAUKgHMk1SK	13486	18981	18981	1619355780000
27288	3NK3hheCKfttchkGkomdZJQyWbYZdbs5Gsju7taqE9zY31iJ4SaP	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1555	981	529	12463	18905	jwTPHo9kSYYYsq9AYyRfUL51wzY3gMEUALz5vTTJ3AWoF5oKDJT	13487	18982	18982	1619355960000
27289	3NKxGRhM4kxdy6WEzLf9xU543MRcQJjLxJzaNCoD3W17exHWn1D5	27283	3NK9WigKTFYajPRiduFjkth8JQABsMbWVJ4isi4P7vLQ7Xk5enPC	1631	794	527	12463	18906	jwgqJ2QTaiVG5WKa5qU94RBcd4vuZv15CeBZBVGstEDuKrNLDTn	13434	18982	18982	1619355960000
27294	3NKoCRKRnBYE3AMNZNMJ3KTqTBn6N7cPEUPxwuiRE5vViM9s7NLB	27292	3NKz6XfMmtpcTjC7FucnfuuhZ1VSaMLjzd1kFxsvgBXr4SL2ei9b	1407	1395	529	12463	18911	jxsWhb6oNhmX8d1Jg9TWyEYxb4fZshDKEPS19z2co5XXgDSgQgc	13490	18986	18986	1619356680000
27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	27298	3NKJdMFyaBUUEEJK4qDrGCKcLBqwJNzTGqyp1hn2aeEw15GjEjvv	1403	824	529	12463	18916	jxVXPXoVegtSk4kdGMdryB15WKJQ7pV75vAL9TR3GxzJsKbsiLQ	13493	18990	18990	1619357400000
27302	3NKkiS3dN2fUpT8t9FEojTsaqZoQSTFLTJpnBp2LXQkBd92HKGnL	27301	3NKJSxC4LuKfAps2gKhesf3BUVSHNybRP1GDXped72kYkgkULDYj	1407	1395	529	12463	18919	jxA8gry3Y97xtJxnVqEK4zp2P8j52G1MG7r7kd6CoMfcKWGYwi7	13495	18993	18993	1619357940000
27304	3NKUjg9nJMRG2RqCGp7Mxi7dZsNHszHUSk43nu35xZMXEQ9Mh3pJ	27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	1542	1058	529	12463	18921	jxT63JsTihvbJ9F1niX5puje2sgE9WhGVtQwqQtFMadUgruJkqN	13497	18995	18995	1619358300000
27307	3NLYovErBeJQwPLHe2WmT7qsZYCxyXvEY1VMtHMQmch5VDtdmFPs	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1657	1098	529	12463	18924	jwudYdPPLu1SL2oJZSkanSoFKEV6yU3H5JLjeR5WeiVJrE5djDD	13498	18996	18996	1619358480000
27311	3NKM4nb6EkeyJmhhmdMcjx3E5TeDTCymzMVUKmsRaVu5dH6sL9UX	27310	3NLXwXcDEL4MnfUzyVrxczxFhjTbBqB8EG5xWpyBgKFQy6Prhp9j	1405	873	529	12463	18928	jxNtC56fXdmvdcwTkU9Y2ZtoPEMcCMZqmgNkQAHkMjLLpPp3ptE	13500	18998	18998	1619358840000
27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	1405	873	529	12463	18933	jwVp6NATLkuQ12o36ehwPojTZNKMbrJD3abgFbNS1L7QjUNAtGt	13504	19003	19003	1619359740000
27319	3NLMg1sVZGUeJxKrcDuau1bi7885cm2w6QhPnKiKBwPhpwqW7pJq	27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	1610	1068	529	12463	18936	jwWhxhDtMWG8AVcRs5FRE1KkiyNpxMQz73EQwzSxULSyQ1ibBeA	13505	19005	19005	1619360100000
27322	3NLNZFig2JSxKjqA9rm9XVFEyoYjfnCnDBHrSZyPcPMVTMP1KBkn	27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	1599	1287	529	12463	18939	jxqQUC7emQsEt8hyVGUYNtsaxQXHWqGVBS3mfghUyy4ofXNH6VK	13507	19008	19008	1619360640000
27328	3NKRCuz9k7QWtEpTSc2Jqyf75H4HsPYMLiVDuGYS5MHQDfKH1mHi	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1652	1069	530	12463	18944	jx2ACAv6Yfh35NhNenc2kKeYCtHDuc5TNGFk7Di816wapsfpLFg	13508	19009	19009	1619360820000
27330	3NKtUsgiujMwE2cSQ3v3grW3eXuZ4QQ3bJY7hQYhhtEc6RfkUtao	27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	1547	1378	530	12463	18945	jwgukVrbcgyGDFmet6RvoZ93U6xPBry2h5c8vNvqzXjHZ1ZfueR	13509	19010	19010	1619361000000
27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	1590	1174	530	12463	18950	jy1Ky6Qq9sy57WgWL6adM9i1bBKPH2Ec8TJKvreiBPDXaKPpDop	13512	19013	19013	1619361540000
27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	27337	3NKWxch3fDP4vaJZCEb4B77KbJgSnkMgSPXcYTdi9GwgYpkwPf1H	58	1281	530	12463	18953	jxqYA6ShK1FAT9BdapKm4Uw4znk9MqwB5wSFJhvwxvprT4ogoNU	13515	19018	19018	1619362440000
27343	3NKo4stPJNJbiF3gU9adpZfdw363VpbCF4Rge2WsPDuEupix3ph8	27342	3NL6APWLWdTgSbg9mCVxYofGjPhTJ6ArAkg2i75LqXAQn445ndMt	1407	1395	530	12463	18958	jwW8DL2ukwqPtBqfEHmk4Lueuk3wMjZGmGbLw5spU4JvFsaSLSN	13518	19022	19022	1619363160000
27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1474	1329	530	12463	18963	jwKSxWWnzifWyPZh9HWSdyN1qzRasBgoBycsV6xwqXLowKaPhn4	13521	19025	19025	1619363700000
27350	3NLqdwoFhrK7CkpKi5ceVGP2HL3Dzua7YdAKtjPmk5QHHJ3FFJP5	27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	497	657	530	12463	18965	jwXDQpXfzcRj8KH8AAHTJyRPR7udmG5GC5Be8NuvQiDheneQgfL	13522	19026	19026	1619363880000
27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	1402	850	530	12463	18968	jxZDuunTwcBW92y4f8GW56CZNvQX6mwRLB37kksKX2kK96FJAzF	13524	19031	19031	1619364780000
27354	3NL9YE9ELjCE8qsKyXDm7M42GiJTtfhSLjS5ArVForJaKkJhYHM5	27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	1613	983	530	12463	18969	jxZgap68qcNGdynpaL3TePMBZfof7EPGL93b9yMS1yK5YsFvx5Y	13524	19031	19031	1619364780000
27357	3NKwxn6ewAgBmuMw5M3rPqopnZuJYzTJbuBfKGGreYgr9VqDV8D6	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1619	1275	530	12463	18972	jwih9jdBu8Pua5Kj95QY5Y3BKDpoGRm9XPQwNw3SMtHhtYbpGta	13525	19034	19034	1619365320000
27351	3NKpG4oKepVh23mqzvJHQ6SvCrFeoGzEQzsKy1fLoyLXehTiBY3G	27213	3NLZqx4NT4Cn8wk8Z4qT1FxwEXo6q23kyAm2oXTWWaunNDJoGuFu	1516	1294	522	12463	18966	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13314	19028	19028	1619364240000
27358	3NLchi77wBPM3XSemkZKD8PhqrNa6bXEZs3kFCf8XS5Uzahc46b4	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1648	1284	530	12463	18973	jxEcmiD5Q6drdP45v7jW2eWHmmiWLEXfcCNzKAbUMzYRPT5Wp6x	13525	19034	19034	1619365320000
27360	3NLjzFQudUhTgxrXGvTADG2MmaV4TUo8151G2doEn59ockBH66AS	27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	633	1384	530	12463	18974	jwNrHedkjUz1u2JsMeQnxx3ryhreGsorhApjNb5yaCYCqXZwX8F	13526	19037	19037	1619365860000
27365	3NL66VacYdWNRifHzmX56UaMNFYkS6KLM7YAjYn2TNzFrNHhgs2H	27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	1662	219	531	12463	18974	jxtWvSBhtnmbcTfmeb6ToPEgFibKjAaRHWMGnabbyh7AXPiuB2d	13531	19044	19044	1619367120000
27367	3NKX297iFaZ2TRsXgMrySafTqCpNiktSHLp2fy4YoNUo3XjRvSp6	27289	3NKxGRhM4kxdy6WEzLf9xU543MRcQJjLxJzaNCoD3W17exHWn1D5	1631	794	527	12463	18906	jx83p8sfm4X6xapc7HU6fyw6mQ2XXD7qbEoE9A6ZaaMs6VFkH1r	13435	19044	19044	1619367120000
27370	3NKeUBhasExp5U6jtouibTEcYxTVL9EesKPRFpbGziy2kxenDb9X	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1448	945	531	12463	18974	jxNZ5UE2JTneGAhkbaY2YgDYDYBBJhBjkN6pwggCNr6YoarEy7U	13533	19046	19046	1619367480000
27376	3NLTLkWSKh1tzD81WQjgFFdDZJrEnWWb4coEDWTEUaSFkdYxzvVo	27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	1617	1288	531	12463	18974	jwQAftf9xcUGCxuNdKDHSPma5XTngW8K7ghEybFwUgkuDmedKMV	13537	19055	19055	1619369100000
27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	27376	3NLTLkWSKh1tzD81WQjgFFdDZJrEnWWb4coEDWTEUaSFkdYxzvVo	1419	814	531	12463	18974	jxKFXJvvRY1ruUwDBTDX5hy8JgH6QT6rZah4Lmmq2RQF4wESmGd	13538	19056	19056	1619369280000
27381	3NKop3yChPYBDUHPLVkCbiU8S5t8kuqRJ5iFJ6fwZbG4cwzePUqM	27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	152	1204	531	12463	18974	jxJ2s71gC1tggjLme5eaaPkBsZfhkrx13sqBKx1qZoTp2q8a2ZV	13540	19060	19060	1619370000000
27383	3NKQBwLJMFQKQbceu4XuPNsnJzb6QowYFLBo3Nk9aCh8d1QktgQv	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1529	1316	531	12463	18974	jxumUbVW9N5PFLZUEhWRAKxLeJLJfKFXN3YLDMQxF5fmFtHyH2K	13541	19061	19061	1619370180000
27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1651	1175	531	12463	18974	jwVc43vDGVo26NZ916h45SKrhjzMDACn6Kmy7V4J31LgpGXz6m8	13541	19061	19061	1619370180000
27388	3NLDdJaYB6ZPvoab5khJXFU55TJLsaoCTWifX8QacsYkEJkgPccL	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1406	1393	531	12463	18974	jwL6RqtHqkKqDkzcszgBAfC9pESDLQAcVeTqjMEETHNGj3U1Kt2	13542	19063	19063	1619370540000
27389	3NKLzyLSRUvtD1f1guDL7VDZPnaHg3g5cuzRfpworxdLaCCqhihh	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1675	1342	531	12463	18974	jxgUEjnWxLSsUXEDgrKZwyvKvj9zBRKrniASt7fvQSFBofL6Ltq	13542	19063	19063	1619370540000
27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	27389	3NKLzyLSRUvtD1f1guDL7VDZPnaHg3g5cuzRfpworxdLaCCqhihh	1637	816	531	12463	18974	jwAjxsudr6dJxebp9s7B3NYABAghmS8CRZei2dgKKAqEMjvv1ZT	13543	19065	19065	1619370900000
27393	3NKwazUBToLHpquEyAMw23N5SsSAsJwqEwXt2Sw1dNSwKN3JwneU	27351	3NKpG4oKepVh23mqzvJHQ6SvCrFeoGzEQzsKy1fLoyLXehTiBY3G	1516	575	522	12463	18966	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13315	19068	19068	1619371440000
27401	3NLhqEsGGvctPwxVJfFezZPsGifThDpkhWZKGRzc581cnz5iPb5t	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1407	1395	532	12463	18974	jxKCQgnVXLbzEwc4ieQCVoGQUGpQsrZhBHx1EkbrCMqYaaQe7KS	13550	19076	19076	1619372880000
27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	27404	3NLnjXTY2JZRKtzjBGoDhzxHHUVLBxhgQTRYmeZCEFxxd69FB72Z	1501	994	532	12463	18974	jwmTVPcv9wy18Yzqk4mfmiUS5VaeKNpFdxjwZfpUzhJrG1fgtFn	13552	19078	19078	1619373240000
27413	3NKj7sKDj7zoDiM5K8khxb7Cn7zWfk7d8KNSorq98vV1Ckp3pGwf	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1448	489	532	12463	18974	jxSFhcLizCSn8fXCQQDyrQ9X7N3TMTrpgA1PkjhUPFuq9b8WqDc	13555	19081	19081	1619373780000
27414	3NLDdbUtn5mzcjobztgqsUodd8mTHKKLxCKoAKrW7gQPhqPWJ5rw	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1448	489	532	12463	18974	jwmj4ArpLsnPGTGiZ4LRcWqyET39qwTdUbEYFqrKhBBfuAaptca	13555	19081	19081	1619373780000
27415	3NKomvJ2vcT9LQtLFQYmn9xbY7BFfBbGQpfVkivKvHYitWnwe1Z4	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	633	1138	532	12463	18974	jwx8oErLiDvsJW1aSAmUnRYwkQQCDyJBxknQ6khA24TY9CU8NaS	13556	19082	19082	1619373960000
27419	3NKbPy7BE7vHGGcMmuRRTdAnNGGvkjfNBSiKveaNS6TvtH6QAA7B	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1439	1033	532	12463	18974	jwnh8CBa3RYb93AcAi7nj8jTLDg8UhyanqbZU5V3vxdjZW4achc	13556	19082	19082	1619373960000
27425	3NKGS8apNEU1BV6SVBdNECbrPGJGkq8FKySKtfujBuH3GhFenMC8	27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	1651	1301	532	12463	18974	jweLfhKWUD9Q7bddwPuxKG7vAoh4MVpWAZTNeBWeDZ7PpcS5Kh6	13558	19088	19088	1619375040000
27427	3NK6jUtowtSnM96gvWE5xqRMb6gBWZ4q3ZR9ok63gVM8itHa77vZ	27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	1529	1316	532	12463	18974	jwPLpnKiSwiXtiuYELV3FK9MfaaXgVpnAkKom26iTL1i51sPdrW	13559	19089	19089	1619375220000
27430	3NKV69yVwK9rUHxVtBYVwtsbPsF1bapWx4YghT6GghwmrjPtM56c	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	1599	1287	532	12463	18974	jwEBnC2YnzojmqPqEDTkYbeRcgSuRbubukWggbbyod1G4h5UcKK	13560	19090	19090	1619375400000
27434	3NLdYvfCwhkvnGTnAp6tth3DRVyAcYAJvKBic4z7E7WMzuzcqgUB	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1407	1395	532	12463	18974	jxAMir1fwLyfP1jAw2fq9EPgsSuzPs3eEX9HzYVZaa1qWTMwq2j	13562	19092	19092	1619375760000
27438	3NK6k8AFjTVBxTNLmcQ9MNy7ofYnDRBGSzMC41mCRwvbVGEEHAS6	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1646	1354	525	12463	18742	jx7utqW8CnFqHjBUxVbhkCg7pmE45SqeWuWhkbQtECum1Xnm2Qn	13406	19095	19095	1619376300000
27442	3NL7oJdoqVNkMT9iC18yajYDktXvza6EkTSKxDNZgWX8EPjmt6C6	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1646	1354	532	12463	18974	jxw1Rr8udLqXLhm4vkvkRipfwNu2M9g6VqT54Tocwxucqe4g2Tk	13564	19095	19095	1619376300000
27444	3NKGXcyzBrqMeAX3VtxRuMypeNU265GhRVKLRoYhEYxEUSUkAbPb	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	1646	1354	527	12463	18812	jxYMbvjYF5SqVFpba8UgnqeeXacd6LKe43aqVweG6BhuKt2BTGi	13448	19095	19095	1619376409118
27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1448	1185	533	12463	18974	jxmM5xeM7ytCqqo8PBskE793v4ArirGijvzsd8fxoLZubW1RLUW	13566	19098	19098	1619376840000
27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	1648	1284	533	12463	18974	jwagRormBZcSNJNr5CNLnFDmmc1JTx4TkA7rjrp2zM8XUDdFaBS	13567	19099	19099	1619377020000
27456	3NLxmoQxuhLw88JoXdRoh5n9ZUwGPfFmmrnh9q2NFfknrFSrKFDn	27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	1648	1284	533	12463	18974	jwmBFTiJXob8rz9vkeQ6Zwm4mjgdnjvQ2PmmXTnAG7En6vPgJBN	13570	19102	19102	1619377560000
27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	27458	3NLGjyC88oKxSDtz2rjG1eATQdxShvxMqpi37kxZZEUNaKemdDpr	1581	778	533	12463	18974	jxLSpj4t9szRv3P98H4RfpMzK2nM3UJs54f4gpgwmu7EeBgQdUk	13572	19105	19105	1619378100000
27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	27349	3NKsJqXs1dRfsneSD6NoTxgcJFNszGm1VW7boEPBJn2okL6nGE5K	1654	1214	530	12463	18967	jwRBYc2y9oPhdjAc7EbCcCdVbLEutsGBZSJj9Meae6k4LxLh7n3	13523	19029	19029	1619364420000
27356	3NKzdoCDpeZe8mbBno1espYaFVnoVTCsV4SkNUKZ8xz8qeEys9U4	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1490	1148	530	12463	18971	jwKJ7XXHvo3MYUpYNWNuJq8bzmufqf96bbP2Q37VfAws14YmnK9	13525	19034	19034	1619365320000
27361	3NL9q8pof69XAkNYxjVhzniaTGKyVF8XLvKWS9S2ud2dCRG2zP7G	27359	3NKfghfmtAEZVFVeym7cJT7su8sB457ezKSHkbnSzcRAaU3rbcZK	1634	1085	531	12463	18974	jwzBDADcJQaF895Q54YMNt1zDJRj8C1XftwsRnWPF7JiqSWvzQ5	13527	19040	19040	1619366400000
27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	27365	3NL66VacYdWNRifHzmX56UaMNFYkS6KLM7YAjYn2TNzFrNHhgs2H	1403	824	531	12463	18974	jxyPtnf6iHdTEmLpR1FeynAcyhhtPLtvZbZ7pyC4cjzThNcQFHr	13532	19045	19045	1619367300000
27371	3NL5chXvsLBo74j7gJUZj9X597ULiJ1tVpTwiXxtEZm3n292HGy7	27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	1608	1043	531	12463	18974	jx39LcWeWjGBpuhPJnR6D6jLnz6kYb21nXkWCffAPmfXH34FHcY	13534	19047	19047	1619367660000
27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	27371	3NL5chXvsLBo74j7gJUZj9X597ULiJ1tVpTwiXxtEZm3n292HGy7	1637	816	531	12463	18974	jw7jHbziFNw5euKh7Jdq8JA62z9CAcCRuk78vbvV4naNRhqYzoo	13535	19048	19048	1619367840000
27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	1405	849	531	12463	18974	jx2abpsPuSgEnAAobnqUbb6Dqxqh4fGKC19RoBc81ugRTaG798A	13536	19053	19053	1619368740000
27379	3NKTwHzetAGHMYbwaHEwivcbdhABuh7mTLMmMX7XZAJSYCzUXWjp	27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	1406	1393	531	12463	18974	jxen43iCawnkcEVNbNxx7dVkfLJKE4VUpH5ZD7AENdbWJxUAghA	13539	19057	19057	1619369460000
27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	1581	778	531	12463	18974	jxvTkiijZDSDP9cjppx2etJZsu2e5bqJPfL46W4eYp5t8rGSBqA	13540	19060	19060	1619370000000
27385	3NKTm64ESQ85aDkcZxq2asaqAAviw8FPh2qAjgtNVksz5kHvWZ17	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1651	1175	531	12463	18974	jxboRdvvF9RqkQx4tu3Ndgi32RhDYj9ueu4uGF6EmuPLEJucxJq	13541	19061	19061	1619370180000
27392	3NKmaDmWcTdMA3MNbfS59XUx9yDqbc7ygXEjH5HPwB6KSdUbqVNA	27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	484	1319	531	12463	18974	jx1kHc983BkVn8rvKtTehZLgSq4cZCUrhPU1MGYykVzENYar7z6	13544	19066	19066	1619371080000
27395	3NKNaMbK2TJVRdJxPzFNwNuQciSDNqoLRB8JPgLcMzeVNVvHszRy	27394	3NLijwwxZob88FWbjdz1dPNG3c4XzNQ6BdsgdRj2Vpce6J5ZBQby	1402	796	532	12463	18974	jwahXJJKPkfsj9nFfdKXZFJuCFwi2nsmt6DENAEHu57Uf9kCjtb	13546	19071	19071	1619371980000
27398	3NLJwaQR2HFdmGQ2KNSzFARF4WGgERvuoFsdZFp7yfaJszJ2QWja	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	484	1073	532	12463	18974	jwhWbQudp38TTjb2H7GWqz5rmEnnZn2wASrnuqeJgRvaT2gmddg	13548	19074	19074	1619372520000
27403	3NLJsQzdsASXXKwDxnqn1uaUzDxtDDTBjXsN2B3ehdhahPv3g56W	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1617	1288	532	12463	18974	jwhg75sofWcymFUYFdan7Bm3CU88rjmrcNvYJJXmkdVp58G4Fcc	13550	19076	19076	1619372880000
27405	3NKQcpBkAXsbSNJgUKHMC4g4m5pJdGpQAyQvi7kWxGsg3iwUH3Ey	27403	3NLJsQzdsASXXKwDxnqn1uaUzDxtDDTBjXsN2B3ehdhahPv3g56W	1633	1390	532	12463	18974	jwgEERTR2zRojVdokHN2hm8ocosqg5tm3qD8TmVHnXD7jAmoCX5	13551	19077	19077	1619373060000
27408	3NLUSHssZn7L2W74CNuf4JX1uEwgYrYYFTeqe1iWwePjNpD6C2fe	27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	1448	1311	532	12463	18974	jx7n9NMmGwV3rkVYLDFnBksihsvLjn2xECmUr55ZJb9M1RPKCuc	13553	19079	19079	1619373420000
27410	3NKmvSrLV1AAhUkTxxnzBxCVquHEWBG2sgpuSC8vRQ3op7JrXAaj	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	1419	814	532	12463	18974	jwNazK47QFZGhZD3ep2ob872uRVRy7rLZURXe5QrqaePCCzhA84	13554	19080	19080	1619373600000
27417	3NLYz7bEm2RLCXnRinsBFtB8n3ZWbJZVPmydVaGP8wgbuaGoQQ1N	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1447	979	532	12463	18974	jxisJsErpK1nKTbs2Dk9M7kgbR53mKgu7Ej5cLkw8kdo4Xkoqpp	13556	19082	19082	1619373960000
27421	3NKhioQUNbVjHUU4oDBfMMSgJEh4foGqho1SBB2Uw2ewCdRk9JTm	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1448	1311	532	12463	18974	jxgKQuNHpBgApwhxcUEWKM4g74zJ2EtTUZDnYKj4prXMKwriRpp	13557	19085	19085	1619374500000
27422	3NKCBZmPbUW9N2kQNiUHt8S3zVgp9rw1hzQrpZDLATZyyVCqBKb3	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1448	1311	532	12463	18974	jwXimAd7TW2y89gDiKUi72njq4kfMFk2hYpVDH2BV4FqWo3G7ko	13557	19085	19085	1619374500000
27423	3NLMakFKFyUL6bSXJxWhBrufshCTD45STEEaD7D1tNW9pwxVSVuc	27367	3NKX297iFaZ2TRsXgMrySafTqCpNiktSHLp2fy4YoNUo3XjRvSp6	1631	794	527	12463	18906	jwfuNiPyzQJs46aGtY1X5QiShdZsF9Af3AijMAvoPTZdDYVZj2D	13436	19085	19085	1619374500000
27428	3NKtWSK3okGk5hYMpjgmieQzhcGrS75JDf4FyMCAN1pvhohsCi31	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	58	1035	532	12463	18974	jw7ZW8wD79Ya9ALizmc8TG4MofcqcSvoZKDLXYgVouyWKJ6DHdK	13560	19090	19090	1619375400000
27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	27431	3NLUp1iWgfVcKm2X5KfHzfKJrVMciw2V2N8XsKT36CNTnAwNuzw3	1406	1393	532	12463	18974	jx7t1CwdchH388q8Ku2LWify8YCZ3ag7KzL1sGzYF51XqpU3GRV	13561	19091	19091	1619375580000
27436	3NKkjjkkr82GqffeFmwTZUWV9xPrw9TW6ByFiS9Dy6Qx62FWoAv8	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	576	1109	532	12463	18974	jwvENuqRtP1KKbPXFjrxkcUAHqoKQWUo2N1Yy6tcda4KPhVV3F9	13562	19092	19092	1619375760000
27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	27433	3NK938q2wdqbExDiDhUQWaGqvUm1RULiLFNnPBYRuUNArDEXj6PG	1507	1280	532	12463	18974	jxdgbKFuaBroMkXZJU6SuLdrNc5CbbFx3NhCwGJWgHyKQ6qoHRD	13563	19093	19093	1619375940000
27440	3NKdQFyDB9CyajgRftewHpTpFEuC2Ese6YAfabMPCaisHbxGriWt	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1506	1127	532	12463	18974	jxVsEeTAC2Kp7B1uh9GPaMbYBwzSKLQrX14dJpuYUhEpRnqHVhW	13564	19095	19095	1619376300000
27443	3NKG7UHT4fuDLad4KaqFr6YPSU1RXXCuou5e1AKZaSdnRjpQLKTz	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	1646	1354	526	12463	18793	jwRHATgeAdkk3oYLtTP2wJKp9FwprYcdDHbyhJ2kpw8kJ8GvXf5	13435	19095	19095	1619376373372
27446	3NL4gCsMTukSJX8xssoqoXunB3Vd4fguGBSNbN6W2bnpYtTKtGEB	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1406	1393	533	12463	18974	jxhQMTkvhmnaEFPtorCqnLTnNLbZRS5cKajb4KfxaGiwVeqLzR7	13566	19098	19098	1619376840000
27450	3NKXzcoJx5aeuodsetELWmgdRyntCQ96ukYEscT7CYRP2pqiNgwW	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1448	1185	533	12463	18974	jxJesEtPfb1xCLSrMoXhAPFVMJEN72KF5N576bPs3fdMM8SuzJV	13566	19098	19098	1619376840000
27455	3NKMVZGUUBFMDkYuEaUq7rgs359cjAAgn3uX3yATUujGgBF1tJAf	27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	1403	812	533	12463	18974	jxr9sVDGCmhgv2adUziTMZwC35Jpv3Ve14RskbFomAGYgiazvWY	13569	19101	19101	1619377380000
27457	3NKKwxtZz8YnB9Xw1SK3eprVtusPFuMqKW8Nfug52fS1rDN3m3sn	27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	1474	1329	533	12463	18974	jwsJWpKd3osWB256nh2D1WhVenBAVKT4kbqH2sc1ABAetBJ8r6g	13570	19102	19102	1619377560000
27460	3NKrmoJMnaj8HvdW8q2ozN39kohpLTRHkhSWUK7FT5iYLnSkjjLL	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1406	1393	533	12463	18974	jxMZJcAnT4c9fWPG3aPNaJrU94JVtJg1epmCDW81BsR4MfBprpv	13573	19106	19106	1619378280000
27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1405	873	530	12463	18970	jxWco24dyFJGSsQvo3QpfecQywMyMagT1K2hZVCdK4CFTay1B8Y	13525	19034	19034	1619365320000
27363	3NLaYjagcwMSazohDrR1hZQMoECc8XbKpeKPRKY2HE46pprudsYM	27362	3NKsLXNbh1ZrvTaXueskCCr63y9atDjYEVfbHzqS4x6kvSYiGqWL	1549	996	531	12463	18974	jwRZXuesqi7Kd54batRu5fkGoGCaChCE8xnvMTGPUFKCMVYZHqx	13529	19042	19042	1619366760000
27366	3NLEwQvdk6BceYk4QYHYrdgsThygHGUGLiWcszLQuwJqBSFocPzd	27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	1587	1357	531	12463	18974	jx4FXfErxQjfgPjEfL4ABVDpuGDxwT9nZUnu5XRYAtNDZkXSHQv	13531	19044	19044	1619367120000
27377	3NKubHjy35HgMF5Y3P1Y75zBKHG3EtVqJyw25VBTBbo7DWEerehj	27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	1407	1395	531	12463	18974	jwwRjFbE5GgjmYkJHxuHcSXMPmGb2bb92Fnsd1hc5EWivBvw4Gy	13537	19055	19055	1619369100000
27384	3NK7t9PUsNaXS7TabRKjBzW9uRwt34KFbpSWC7bMKMiecMenNXog	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1529	1316	531	12463	18974	jwiFTsRZ1UNvyDmN2UbGRcdv4BZbztKVapgXfTsSCDsniZTuRUK	13541	19061	19061	1619370180000
27391	3NL2kKKdDx2fTgKo3cr3VSU1bBnZj6YYRyJx3zFkeDEYdHfGBzUa	27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	1649	1257	531	12463	18974	jwnBvGSxV3ztRJx66AeR6UjvJug7EWahSWM1LaFWfZ5L1kKUc5j	13544	19066	19066	1619371080000
27394	3NLijwwxZob88FWbjdz1dPNG3c4XzNQ6BdsgdRj2Vpce6J5ZBQby	27391	3NL2kKKdDx2fTgKo3cr3VSU1bBnZj6YYRyJx3zFkeDEYdHfGBzUa	1589	1040	531	12463	18974	jwmhag88GziRyiudKC9HwLv76XvEWyFQTZe8puzhSVqQS6cuHif	13545	19070	19070	1619371800000
27397	3NKrRyY15NNbmKdLqKWsw7P4B8bqFnHFyHTgA1C1P2h5quAR3TxV	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	623	623	532	12463	18974	jxfVm9w9zVzzFPjpzPRLWSzRKdGS9d12oknHBKyToUQ4Tv2oruE	13548	19074	19074	1619372520000
27402	3NL3bwsNCD1k9VDRMJPEwDcMiezUDmfm8H6dxPXDtqBHFqgQVo8s	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1406	1393	532	12463	18974	jxv3A3mRTsFRa6hMTYSDuLHqM7JfJxNUe4qoeXLP1wKPCRiHw6m	13550	19076	19076	1619372880000
27404	3NLnjXTY2JZRKtzjBGoDhzxHHUVLBxhgQTRYmeZCEFxxd69FB72Z	27402	3NL3bwsNCD1k9VDRMJPEwDcMiezUDmfm8H6dxPXDtqBHFqgQVo8s	1633	1390	532	12463	18974	jx9toPbxqABCMjdpkgLrroCbNwaWWSKWKQg1jQ9GdXFCAQwy33V	13551	19077	19077	1619373060000
27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	1448	1311	532	12463	18974	jxTRuQEDmtYcWMnmk6xd8cX7MyyEaGRz8NAzHMyDJBqPAVHdKxN	13553	19079	19079	1619373420000
27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	1585	1000	532	12463	18974	jw7hDf6aoqkaDx3ve5gBu6Uj4sCSvLK72R4BYx5ioqMfHFP33st	13554	19080	19080	1619373600000
27416	3NL3xamaHCA8by4Thduty5EPpFUuBQpELy4vNizjkuhcb2RrfWQo	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1406	1393	532	12463	18974	jxyHBeYzbSYS23t3W8h11hocDHLDzfjuAAGarEH6fEwpqxCMwmR	13556	19082	19082	1619373960000
27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1406	1393	532	12463	18974	jwTKu2jBVJ7vwC53PW35P25RTKqA4j6gBmcTC9SLtp8UrStz4Hz	13557	19085	19085	1619374500000
27431	3NLUp1iWgfVcKm2X5KfHzfKJrVMciw2V2N8XsKT36CNTnAwNuzw3	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	563	1359	532	12463	18974	jwzkc3qLxK7HexfCKTgo9WjpHzZQEMYjvr5urNkkfh68DcrsL1u	13560	19090	19090	1619375400000
27435	3NL8ycnA7HJnda4HbTYGkpEaBFQx4yBkbpVDxtQNv3en1Q6Ufa4F	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1589	1286	532	12463	18974	jxPzSLoxkvTP9k5UtRnXKT93wVhghnekqdQ2QoXKkApL19m3JmT	13562	19092	19092	1619375760000
27439	3NKwxojS6HwuNKoZoPEQz8eSGF9BaW4TGphnAf5c8qpHLae4rnbE	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1506	1127	532	12463	18974	jwxMhuvivDkK7uV3oS4FZ6PzKHSTa94sZWSAGQ97QYPUW7bGaEh	13564	19095	19095	1619376300000
27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	27440	3NKdQFyDB9CyajgRftewHpTpFEuC2Ese6YAfabMPCaisHbxGriWt	1627	1385	532	12463	18974	jxZ6AzGQUU3mNHLAJKLt5seXueMGFBionijucVZzExGyy4xxR85	13565	19096	19096	1619376480000
27449	3NKw88AYxkPqDuiDaCbfpWDwwHAYgSTxpbAzyDQfKXx73bkdjNkV	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1483	327	533	12463	18974	jwyFufoePa3BmDmiYjYjj78vThf1cjXDHqKCM8h4nyX1k9cJMRj	13566	19098	19098	1619376840000
27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	1406	1393	533	12463	18974	jxRmGqSMBdH29KWXLGuzeUfry5aLdbJdYmZYQjBSngQ3X5SAKbN	13569	19101	19101	1619377380000
27462	3NLvbdXJKchGq3k4QY6weLnZozHeZhU3Xi9K7S3LtjKMYWRFAkVw	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1419	814	533	12463	18974	jxGUWm77v6d6bBcyqQ2MnQZAeJjnwJknyc2WH2ZhtNakb6jxehT	13573	19106	19106	1619378280000
27466	3NKJp4Dt4FmDbCZdtNLVDUjEYt6rPSaMyoLtbp1vs8QDcwsxtve8	27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	341	341	533	12463	18974	jxmvr6DhJuS49oc833D7xGC93FBiN5s8CpaudKisuNpXmeRrv5L	13574	19107	19107	1619378460000
27359	3NKfghfmtAEZVFVeym7cJT7su8sB457ezKSHkbnSzcRAaU3rbcZK	27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	633	1384	530	12463	18974	jwNrHedkjUz1u2JsMeQnxx3ryhreGsorhApjNb5yaCYCqXZwX8F	13526	19037	19037	1619365860000
27362	3NKsLXNbh1ZrvTaXueskCCr63y9atDjYEVfbHzqS4x6kvSYiGqWL	27361	3NL9q8pof69XAkNYxjVhzniaTGKyVF8XLvKWS9S2ud2dCRG2zP7G	563	1233	531	12463	18974	jwEHTTmSEHDiSVpPH1pe2m1JxYgbgAjqGLh8hK3pk19SG8frJaJ	13528	19041	19041	1619366580000
27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	27363	3NLaYjagcwMSazohDrR1hZQMoECc8XbKpeKPRKY2HE46pprudsYM	1610	1068	531	12463	18974	jxcTJrz2pxwN7hayGWVd1Gxr4MxpHWxb1AhReWj7en4H9KxTS1H	13530	19043	19043	1619366940000
27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1448	945	531	12463	18974	jwE6GygVJu12AXxZHYriSvha1BWxhXUcZxXM6Gsd6XpodWmvP8C	13533	19046	19046	1619367480000
27372	3NLCbocvjJp5BodcFBGR6Rt6HGyHQh9Frxk7bzgR7vFLzAUGtZsr	27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	1407	1395	531	12463	18974	jwiG5izELLBkDRAvSdbb63V4CbKGfSdhhVWeqbh4jcJr8j17j2y	13534	19047	19047	1619367660000
27375	3NL9zQ5XuqUyewYxu5f7nwGZpJRrj7irUcz9EXPa1ehRskkSwyUD	27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	1500	1171	531	12463	18974	jy3AMCHT3J8MgtJ49tHpYGtKs2do9s5LGu1iqBgZWftCD2iQ2Ua	13536	19053	19053	1619368740000
27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	369	1312	531	12463	18974	jwKfSYBFRvXFjYt3zFucqb5E6EHWATtaAnQYAJ91jQqZU3LLD47	13539	19057	19057	1619369460000
27387	3NLTqn6AeEQixrQP4dxPDN8C7ASWVGAykCGwcYoGKkGAVzd1fFDe	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1405	867	531	12463	18974	jxhuKPsTAZpXs62Qdps5jjYc6C5KyTHgwr2H1K5RBh1WgQHrkVQ	13542	19063	19063	1619370540000
27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	27395	3NKNaMbK2TJVRdJxPzFNwNuQciSDNqoLRB8JPgLcMzeVNVvHszRy	58	1035	532	12463	18974	jwJPSAR5FBghGHNtyw6qUhgE1KuGRhevHoyNmvq8xxuC2JzaqdF	13547	19073	19073	1619372340000
27399	3NKRr84kX9TXpGfA8JuFKPV27Gw8SzhpZyJK9BKXdgCndfn6ovYT	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	1652	949	532	12463	18974	jwAy11brZxhP8ckerKHVRqXLSpixoUk2N62xqeHdi21HoPHMnmy	13548	19074	19074	1619372520000
27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	27399	3NKRr84kX9TXpGfA8JuFKPV27Gw8SzhpZyJK9BKXdgCndfn6ovYT	1407	1395	532	12463	18974	jwd2Y9wZXnordMDAM5pbywCdBhm5JUfatUnjN8sMzWPgU8TdLEf	13549	19075	19075	1619372700000
27411	3NLgA4iYWtH7mQ1zSSBssVpyviaoGdB3HmSag4nFzQU4LsBtV4Kz	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	42	995	532	12463	18974	jxD9iCXK9PU9BANfSyueKxnVedQWZqnyDFq69m21TPVGMHkwPpX	13554	19080	19080	1619373600000
27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1426	1238	532	12463	18974	jx1Pyxbf5NJT9NEWzXbjUcwn6gyzMa15aiTLR5qrXehn4g4oyYK	13555	19081	19081	1619373780000
27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1407	1395	532	12463	18974	jxJ5oQLtEjkq9kDZR8UL5qJycN3wxTeJjAov3GphWq1HkEuuxUB	13556	19082	19082	1619373960000
27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	1651	1301	532	12463	18974	jwivDbAaUKLdsUfV76xt4F98kDK9PjQ3363xdgPxccUg5eyGhS9	13558	19088	19088	1619375040000
27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	1529	1316	532	12463	18974	jxrzhcoP7MCyoUG8DZPxHNr4MCSzpVfjkzngXJ1SXRQbiUXRLJE	13559	19089	19089	1619375220000
27429	3NLayJggTF8pDKyg4e7qhhp8ayxP2rKAmbRnLPRXvh5y5TMvRUvQ	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	1406	1393	532	12463	18974	jwit8ZPje6PjbQ36hAvog98DbaAZLj3ZdE19iSx7T8C7gPrUXMB	13560	19090	19090	1619375400000
27433	3NK938q2wdqbExDiDhUQWaGqvUm1RULiLFNnPBYRuUNArDEXj6PG	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1406	1393	532	12463	18974	jx7gGqDRK4jDsXn4xr8k6vTjeM2Bn9o5mSpfjvxwMqL9CeauGZR	13562	19092	19092	1619375760000
27441	3NKHLJKywTKsEjEHFjWRL8vXZHBmGRYxypTrNijTVWpLEYSBXxQB	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1646	1354	525	12463	18765	jxHxjyFaJEm2PqqAXpeQAEwZ19ZwSrhrvHKijmRGBzMQuWkG7qX	13421	19095	19095	1619376335533
27447	3NLTyLDXz6QkTkfjVsNomoYeaLbqSckCzizDhhcQqhoBBnkYuH6q	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1637	816	533	12463	18974	jxTnPmRvWz6QswBtu71AKutVZaaWkZZ8R8aFqLWzSLhMbjxChRk	13566	19098	19098	1619376840000
27451	3NKo5KZzpsDnVWp5MhJzSubUrfqyVtouBXu1ubzs9khyU7bhymJq	27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	1403	824	533	12463	18974	jxf3ymYhkSQeuhush7MSWZouY5pGHbBBT7BX2paqRxoQN7R4oAP	13567	19099	19099	1619377020000
27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	606	1169	533	12463	18974	jwdbwEznHeyH2hdcUsTpft8CexyYGQV3ns6kf9Rwthbo55dMhnt	13568	19100	19100	1619377200000
27458	3NLGjyC88oKxSDtz2rjG1eATQdxShvxMqpi37kxZZEUNaKemdDpr	27456	3NLxmoQxuhLw88JoXdRoh5n9ZUwGPfFmmrnh9q2NFfknrFSrKFDn	1594	1200	533	12463	18974	jxRhSdPVzJSSxSU4QX8ctFVQc1CpsLzcuz274Fx5s6XpHPUvUKN	13571	19104	19104	1619377920000
27464	3NLEjFGcCbDvPivNjQ85cCznjbTB5UGYfPMiYCwwCG5PKHigdf7N	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1419	814	533	12463	18974	jx4uwmZQfx6VT3Uefszrh7dacx3Tepe9zZax16fSM2N2x4MeSSP	13573	19106	19106	1619378280000
27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1599	921	533	12463	18974	jxviCc4ornEyxEiJ8tNTXKrh68eyJS4HtPmD99u57hWt7SNLEr3	13573	19106	19106	1619378280000
27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	1426	1364	533	12463	18974	jxKiFeGCxs5ZVrtMvw21e9jjh4GhZGBe9WxeMcDd85K9j1LGqgx	13574	19107	19107	1619378460000
27463	3NLPdMzm6T613MfgzN4T9xCwSWGQ8NoENEksfYrtdjCM9Y5GY8Ks	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1599	921	533	12463	18974	jwpDfvroAGDVFW1DHCp9Pc7Vjs5xcVoNrqagfVQRJXX1Xhz41Qt	13573	19106	19106	1619378280000
27467	3NLF8T7uGSpUzahpiAKXCTs1AxGs8Xv5D3QmZgzzcoiqJwu8zmJf	27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	1406	1393	533	12463	18974	jwihFogo1cbxHUdmAZZQNLmFA9s46y3Ds3jWpjsD3eptaJW4LXU	13575	19110	19110	1619379000000
27468	3NLXVfAnq2KbvrxD2LnNf2BksKR9rKHZpUZCPUD3JyfBjRGcE1Pb	27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	1622	1230	533	12463	18974	jx8pZkb3HbofRaba85snidJ14dcgi1yaQwaxGEL8L6Xr2pB9Ewa	13575	19110	19110	1619379000000
27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	27467	3NLF8T7uGSpUzahpiAKXCTs1AxGs8Xv5D3QmZgzzcoiqJwu8zmJf	1460	681	533	12463	18974	jwA7GRkF3Zw4XKCLWpsH1UrA42XTKTLXX9PVpTDNtKo21yQRx9c	13576	19112	19112	1619379360000
27470	3NLpMXsGgYanQrnB8diHaYUKMCTjx5pz8mQxZr4g2dfSKzJPbSpS	27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	1451	1046	533	12463	18974	jxHZwU4SFr6FSTCFy8g6XDYJK4TMdu2CZszyknypbbVoU79D7Eg	13568	19113	19113	1619379540000
27471	3NKaqYFaKhBKeeWwZLcwotpwGM3hhLd4SRchWq1bwjpdhW16Sc7Z	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1406	1393	533	12463	18974	jw7Aam1zNnmB3J6hnSe8EYJkLehdYeFGAM9C1Zi5tyTCE9xwCEK	13577	19113	19113	1619379540000
27472	3NKhZr1mXmRihVsCTSKRzBkvdQ8TH7Ks87DuZ9jQFPdwLuo9PHmS	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1397	827	533	12463	18974	jxrCX6rBaSXxrj6R2sNTt3Td7mruKu9CQQSyGtg6wsat3XYpkus	13577	19113	19113	1619379540000
27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1451	1046	533	12463	18974	jwFqV7gaHUSqp6Vry6StSLUrBxrvPD8v2srtN7fmCWymkdWB3AU	13577	19113	19113	1619379540000
27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	152	1204	533	12463	18974	jwjm5r7Jx9BzsTMVpVpXwsDZiapz6gxnPPXeH1dRRGmwA7WwtXi	13578	19115	19115	1619379900000
27475	3NKGMhhStMBHDa9WAeVZGJJEJKkb12DTyRhxZw5yRznr434poZaM	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	1648	1158	533	12463	18974	jxvpj6x7BdciCeaZvdMfTURnZSBxKEDgieQcTnGkY2edCkpfbGV	13578	19115	19115	1619379900000
27476	3NKrvH9uquiXJ8quohnhcKrxoj3jQkxBKGrBL2ULQ7tjc7Quvjg1	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	1577	1327	533	12463	18974	jxques3hFpPVwvKj8sqMqxJLeEDzRVcWuWHnrV8PBhJZ69Mgz9z	13578	19115	19115	1619379900000
27477	3NKTrmt1dKa6ynVWKwKcunUFmz8BRtyHegZyebKt9rCYcn8BFKon	27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	1406	1393	534	12463	18974	jxe6Rda8Voxf1iyLRh95MBTHSyd4y5YGbP4v3e6bP7JNSNbZwfs	13579	19116	19116	1619380080000
27478	3NKTCDJqNJoVFHqcR7k4xRji8ah8x4QdfayMjhTTVQ1Q5zYXo6Ca	27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	1444	1015	534	12463	18974	jwTF9vNm7prjtDKyLo1CeapVsrMnmH8AfMvukim1gHEeE24iX1P	13579	19116	19116	1619380080000
27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	27477	3NKTrmt1dKa6ynVWKwKcunUFmz8BRtyHegZyebKt9rCYcn8BFKon	1406	1393	534	12463	18974	jxNjaP53JLUDZBrwN7LTdUTESPeCvk1dBhNcXcsXjDR4DEwMqYk	13580	19117	19117	1619380260000
27480	3NK61WeUu1oYvXDkjLWbUMBK7WNYexJmze7e6LtVALHCn6X5t4c6	27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	1407	1395	534	12463	18974	jwG6z9b7K6F1zPSGSeu6QCirG8mwCc23hn2AnXdwpT33oLbwbvC	13581	19119	19119	1619380620000
27481	3NKsSgr25RHksXMCGTxLqQRubqbBfHJyLmFB5ZW5oVpBPEvavvtW	27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	1610	1068	534	12463	18974	jwJAnNJ8u1F17GQ7x73huiz2NtrUna1KNxcPu6jSqiEfHWHdtBT	13581	19119	19119	1619380620000
27482	3NKGMbxTacz5qTcCFzfQVPv9ZswKfe3JEAU9WsFezsAu2uwZL1Df	27481	3NKsSgr25RHksXMCGTxLqQRubqbBfHJyLmFB5ZW5oVpBPEvavvtW	1406	1393	534	12463	18974	jwW4rh2JtvQLVK7ZnLm9ZXFgoUhNSZGEeCyE6WEGUKNSBhyimT9	13582	19120	19120	1619380800000
27483	3NLBoj64pJ69J1viHGWnkNksaa5Q31knmZH8hbzmfDqeAVCwc91u	27482	3NKGMbxTacz5qTcCFzfQVPv9ZswKfe3JEAU9WsFezsAu2uwZL1Df	1607	1222	534	12463	18974	jwRTArQdsHGRDbjhaZpmqx2UxnDv7ogdz7xG5qnBZbs2wuwwuEX	13583	19121	19121	1619380980000
27484	3NLmfJe5euFhXNPoahYH3iEuUUZmpkQDGZdtGzURzcro2mvwedPZ	27483	3NLBoj64pJ69J1viHGWnkNksaa5Q31knmZH8hbzmfDqeAVCwc91u	152	1330	534	12463	18974	jxeGNWYwafvGMuwUiesMXJXJZSbmiyERVZFsgb6AEzm5WunybRb	13584	19124	19124	1619381520000
27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	27484	3NLmfJe5euFhXNPoahYH3iEuUUZmpkQDGZdtGzURzcro2mvwedPZ	1402	906	534	12463	18974	jwqnrEfQqETrw7NpNr8hif68He8rq1AHjUSUDiPuLNxn7i17puU	13585	19125	19125	1619381700000
27486	3NLhkhhWTDgQfh44edzuDB4Cw3RKDiDUbbJS4omPfuWbkt4dwZ4r	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1489	1380	534	12463	18974	jxNhECfdKuBhPSVD7wT23Pa4jWgqo6fPoYfr9reAJuqbTJxC8xP	13586	19128	19128	1619382240000
27487	3NLutytx4HmvcoUsXWVirdqPeCukbz55dcS2zNwz6bKvuf5xXKiH	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1522	1076	534	12463	18974	jwJrMZm6rmUUh3RcSgNpiomCqQcm2AWyfrnsobgEVCi7yUDra4z	13586	19128	19128	1619382240000
27488	3NLfYk59HekNW9rvZS8WREqeCXBkkfQFuuYzcdA77dL1WgH8Uoam	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1403	786	534	12463	18974	jwrwMv4UcB95LhJiu7WKfdcxn4HEDwQkZGcKRaUwD3aiZZzQsUb	13586	19128	19128	1619382240000
27489	3NLnNqXyivYDnt4A8joZpxaLfVe5oYoghg7bbmTtPpt2FnZtDKY9	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1522	1076	534	12463	18974	jwJrMZm6rmUUh3RcSgNpiomCqQcm2AWyfrnsobgEVCi7yUDra4z	13586	19128	19128	1619382240000
27490	3NLrMc4tNr7NiKyp2oSaJk6reS1jQzpRaeWSfeyG7eaiVQcHaGLB	27486	3NLhkhhWTDgQfh44edzuDB4Cw3RKDiDUbbJS4omPfuWbkt4dwZ4r	1649	1257	535	12463	18974	jwg6BKspCGep1v4nPfzKWMvcRBN3hxMn4PkzB293poGs65VogE6	13587	19130	19130	1619382600000
27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	27490	3NLrMc4tNr7NiKyp2oSaJk6reS1jQzpRaeWSfeyG7eaiVQcHaGLB	1407	1395	535	12463	18974	jxB7SmBe6kLaV4WZcBLbMY3uYEBeYUYdBpnEhayh5EvsxA9MwZM	13588	19131	19131	1619382780000
27492	3NLKF7Ep5Mq4bsJfUG3XXtqVCnjXQ97jkyLLKYDGuV4B7MvNU867	27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	1444	1255	535	12463	18974	jwcSvKTpQXyc13ubnghWfYvTMPHkBahbvsMapkjjvnofBe52qT4	13589	19132	19132	1619382960000
27493	3NKSMH4Hjw4w4KRcFU3eiQqm2bUCUmXGAu9pV3w1G7vPKjQknwdE	27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	1483	680	535	12463	18974	jwTNaUcYuSF8dvQSmZRxkAZYHQNAz6LKSELRoKGvhJgPoNSybpR	13589	19132	19132	1619382960000
27494	3NLtczJPeN7xTZ17EzWCqZmWk62aBAZgnBG8QN5UXHiEnZkZT3xG	27492	3NLKF7Ep5Mq4bsJfUG3XXtqVCnjXQ97jkyLLKYDGuV4B7MvNU867	1406	1393	535	12463	18974	jxgVQaXqnWrWLyFUqZs5gfgvbmTHJ4qwEvT1T2253AziA46p7gn	13590	19134	19134	1619383320000
27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	27494	3NLtczJPeN7xTZ17EzWCqZmWk62aBAZgnBG8QN5UXHiEnZkZT3xG	1589	1160	535	12463	18974	jwLE6F4eJxTrZNBfG8E4rWsH3prQ3yZdPpAKdC6q8bUhEv5oRXc	13591	19135	19135	1619383500000
27496	3NLyXSNzpcPuzxjht2PY72XAibrWgYajdxdg9E2g2V8zX2zb9W3H	27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	152	1330	535	12463	18974	jwLv1Q2QtYfMFEV8SJfoZYFTWrcm9qMdJzNpjPHDdLcWy4TEK5c	13592	19136	19136	1619383680000
27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	1579	1023	535	12463	18974	jxia8PBgR8CoedB9JXBVjZHEnQpYmMt83q155Dep3FyA6ZooAX2	13592	19136	19136	1619383680000
27498	3NKN7np1mCP6zA3sYfE8PgtqPtj9BUZV2bFNv4nUqquMRfE3Jy2W	27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	1406	1393	535	12463	18974	jxidT8tyQEU2fz2Du6SLbBs9Twcx4uB1RQ9tZ2KkgXMYsA9FVnW	13593	19137	19137	1619383860000
27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	1501	1114	535	12463	18974	jxaE1QXXEo1xtzbaxFqTSZ1554s3r9RdfYgXmuhC64HEyPuQj7n	13593	19137	19137	1619383860000
27501	3NKTnD1wp2UfVE4bGskDUQwVtYgXLMNqPPqgwGWKJyRBv7KCjXkQ	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1407	1395	535	12463	18974	jwAmdGspVcu1Vd7cVnr9P2htEqy4fuJ63ZSxuQuw1ao5goWAQPE	13594	19138	19138	1619384040000
27503	3NLNn2maRSoHigBKiizWeSyhoJs8KDDcyfmsfwWdWWFqMVJfyGSg	27500	3NKuDvAk2sWR3W4726xucaj4sJZBiimGxqt3BjgGJsUYwRxzhv1A	1610	467	535	12463	18974	jxmWeyj2ZbbhyxU6KFjP2mujaBFMnSSiqW3dtU3ucxvtQgdvjoA	13595	19140	19140	1619384400000
27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1578	1050	535	12463	18974	jxwFFgs9M6Q9mwH2YSoV8VWqp8nD9hRZrsuoZAmzgSjLjYLKZSf	13601	19153	19153	1619386740000
27513	3NK7rYt2xWA4YJnDMiTXJpvk5aJrsTvdheRVDSo3bqN5atauVT7Z	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	369	1066	535	12463	18974	jxhJNjtYGy7MTK3qqMGeBCQ7Rix2Bc8YMF8qmHfagfMEgrWNwrQ	13602	19154	19154	1619386920000
27517	3NK6LxpXcXgFSZMeyAVCy7sS41yfc4pzr8viuJXvhhgsSQVHH7op	27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	1675	1216	536	12463	18974	jwshYFukmj2ycd4yBsX7XADqZEba1JyZcaLfjt1r9jEdTaevYR3	13603	19155	19155	1619387100000
27520	3NLLJCEEeagN53cjhdbhmLoQQtxw8xCeSziaqh7uebEBea7XtLny	27519	3NLy6bf5t4VAFgHxCjYK5o97iiJ1XQzjFYGH2JS5BoBicPySQp9B	1672	1285	536	12463	18974	jx7cyqkd69FuVfU5no7C3EZuA7RrDb7XGHua8rVyNBZsELnF36f	13605	19159	19159	1619387820000
27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	27522	3NL1DvEgXxvXbQiKmJj3EUUeL9gZCWWfUDPBRGsUNHFh9uDhE9fm	1637	816	536	12463	18974	jwFWtmQMt1VyGPnUhSmPiYEFL1xPACbbjo9jSdhDUgLqB61L5m1	13608	19163	19163	1619388540000
27528	3NKkt9HXasM5oRcZc77P91nymwCLGgiiWr9u121b8S99xwD9EUNZ	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1555	1221	531	12463	18974	jxHV6R9nnLPch5wNbaERy1LCUV6oUkr9HYbtT9EJoNxQ4NL6jnK	13533	19166	19166	1619389080000
27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	1407	1395	536	12463	18974	jxYbeV8jRNEPufW81YvFCQkTXkTtGjbXVUwdyrSAto2WJuhdk2M	13614	19171	19171	1619389980000
27541	3NKdHYxgHUkUa8MbZNja8Ad4XhYhmiWyT8tM11Z46xqqQaR8X5G6	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1422	1211	536	12463	18974	jwwkgMRBmvvtzQ64gW5yiVS6p3xaog65zyzN7TrTqH1WsmDXF1D	13615	19172	19172	1619390160000
27544	3NKHmhpcfUQL8s7VWahoQEgU8asFAMJyFRgZYPZMqm391ffx6qbm	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1489	1254	536	12463	18974	jx8jCm6yi9QpMmDKw12k39AB9QYgcXZdy6VPW9BSQq1qCEYTsnD	13615	19172	19172	1619390160000
27547	3NL4pNRuhESjAXGWevnKzJRDXMNxHeh9bErKddLmRf1X6TWJvBPQ	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1474	1203	536	12463	18974	jwRotBwdn2589qvMtDr4QFfb4yVQYbpLWMZaBA8WnSFxduJ7rF1	13616	19175	19175	1619390700000
27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	27545	3NLZg8MXLhgEfE5mwbemAz9P5QHMHaCrR25JjWY9tWaE7zRTwjhL	1406	1393	536	12463	18974	jxC3FrCd4qP9A7X9EtxkAPZhFumb1K4TLHSW4f7gJE3YpiHBbi1	13617	19177	19177	1619391060000
27560	3NLnA9DnJXDQ2wNRWPcowkAUxGjrTvRvyHXHFjXv5uEZFAg4cj42	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1397	838	537	12463	18974	jxzUq4dLEvoNMBD5J4GRuYXB1feNmGm6Qss3Z6CzMwuEVsp1KcZ	13623	19183	19183	1619392140000
27562	3NLy6yGX9TKd2TGjXtCPv8djgR9dhXugAPfw1xtLSPBsWaQRJuov	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1508	1261	537	12463	18974	jy1Rnq8HzKtArGpAbNa1tftrffKdEhAPTFs3Wi4td8YzdFDiQEQ	13623	19183	19183	1619392140000
27566	3NLdSJ9QSrGy5qT6TaJfakv57GvWcHT5kgNRUUsooToUrWVrzokp	27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	1406	1393	537	12463	18974	jxJ7z6xP8R7AHLkLrGFmwBMMv955hXjqAnYL3taZncgdAW5x1SH	13625	19185	19185	1619392500000
27569	3NK89KrumqXWrwwUL75xXjX1qKbCrJpekcky8Eq1fxbTBA9898Yt	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1608	1043	537	12463	18974	jxYRzmRSkYRHDmF7Y7RCFup1yaCKR63XYrg4X33Xytyn4qXdw35	13627	19188	19188	1619393040000
27571	3NLMzmbs1Tey7JRo2UB6j3G97QptrqNb3cd3nrcdya8eCawsbSYn	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1559	987	537	12463	18974	jwyPxuc1vYbxmqVtedqAWFdqKfEHUF42FMLn73Gv5MzfXPwBVHd	13627	19188	19188	1619393040000
27574	3NLWrYTMxqedeHzFB3fwirGsqbVA6inxM5pvjcntzVzUHmEMhZcq	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1460	1324	537	12463	18974	jwjQD8oiibkzdNmtV4jrqWFbjgrtcuDrqaNKz6ZqgvecYviw7hT	13629	19191	19191	1619393580000
27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1403	824	537	12463	18974	jwnPNNCKZ98W2cfTsiwnKLGP6Z7dpqvgPyo6xo9SvD1ei9iv1Q5	13629	19191	19191	1619393580000
27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	1426	1118	537	12463	18974	jwyRDWLLZWesYogaDMBFCRQKZjkA6tX2npFUFiLxrY2w6KDX8sB	13635	19201	19201	1619395380000
27594	3NLLZGvjLTXmHaruSgpnFoGNcTqc3v4X8JeLH34G6wuB8SNvwmEg	27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	1455	1332	537	12463	18974	jwmofAWrx9hMCYbGUXKyk2aTSD6FT5NRFiKTbejgB6yAwid6MZd	13638	19204	19204	1619395920000
27597	3NKbRb7Q5KsHuA59eKoZ99fid9bL7UDrnFVtPEjP6a7EMYqugL9W	27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	632	1256	537	12463	18974	jxZ8ssxLTnDaxw6iQTU1tCQguXY9j3fmJQyjrmYuCThNtDBvEXG	13640	19207	19207	1619396460000
27599	3NLofscFYwuMFBKy7Qs3CRCL9o63WgZiKApST8kTcGBhzSNdxmfX	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	606	1049	538	12463	18974	jxKh3hqUHsgQeoTZCqDy5Gt4cGCRkee5nu9FnafGp2RjY3xDGPT	13641	19209	19209	1619396820000
27606	3NLn9jexJ52iVw6SbdgyhNbaJUMFsmKuS7raMKfbwD8d1aRgUL68	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1617	922	538	12463	18974	jxhX6AgoV9RPRocFcjKq3bvuyu4nkkWGa7x5AQNi3VGvCrbeo5z	13643	19211	19211	1619397180000
27610	3NLqbD3YHCtnUmSVCFj71yCEgCd2p5YrZkNp2fH9ebtB5R4eArET	27460	3NKrmoJMnaj8HvdW8q2ozN39kohpLTRHkhSWUK7FT5iYLnSkjjLL	1547	1012	533	12463	18974	jwKnhUWEwXSFbWFBJziikeVvvsYeQxjHQT7PUa8xCwfd9HuRhgJ	13574	19216	19216	1619398080000
27614	3NKNBzgjxqmjQdWfV6isBRY48e2hCHYhv9ua4ikUS7m1sw8RhL9M	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	1578	1170	538	12463	18974	jwQMFxW73ZQ1paEp5Up3LyjddEqdmSxPBipqAyDcnREeaPMCGgf	13647	19217	19217	1619398260000
27620	3NKCRU8vZ7tcBgga5aMhksoD615YXKF6khbmZWLi5wjSzBzrD5TQ	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1419	814	538	12463	18974	jwRPscS3K8yZynJt31G6xLAN1hdu6netzPUQfhP1viK2WfMYDV2	13651	19226	19226	1619399880000
27622	3NLmw2YK9thd5QUMSycUBWL6GWWNjwr1Ei36BT4rWchX6sDL14Hc	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1624	968	538	12463	18974	jxZRGMNr8p3wRZucUp2enFsvbdyAMjK9ij6nVKsquA8N2zoGFuj	13651	19226	19226	1619399880000
27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1407	1395	538	12463	18974	jy2Nf1EguwtWv54ETWj9pKXhsPxZ7WG8EtwWPLeTU8kvqBJoidG	13653	19229	19229	1619400420000
27500	3NKuDvAk2sWR3W4726xucaj4sJZBiimGxqt3BjgGJsUYwRxzhv1A	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1406	1393	535	12463	18974	jwQfjfQ9ejrJVviEqAVKKbPWF2sC9CuhXTAfu2zen6WUnckedxZ	13594	19138	19138	1619384040000
27502	3NLE2adpX8SgJbUcWbKwL51DQEfA6kNvPGrjJUj1hbMdNwsXsZ18	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1634	1085	535	12463	18974	jx2ZkNG2k9YKAp2n8nLdnW62R6pyRFowFgicLKTYAcHWkhMnnno	13594	19138	19138	1619384040000
27505	3NLqCJGJJioGaTHz6mkbEaE7yqeAxGnceY5dKXtiNhFH3Nefh27G	27504	3NLV4UNjeL3nGoVw3yZk8aknnHAfrjhGMkepEGJG4NBz1bwyKNeb	1503	1031	535	12463	18974	jwhjdr4Aa2aMuDhefBi9w2GRRereu52AoTyPJHKG2EuEfGLgU9r	13597	19143	19143	1619384940000
27507	3NLbZAitNf4cTtPTiH4fn33kKD6xTL5MQ6sLqvdFtromgTMxkUor	27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	1522	1322	535	12463	18974	jxCiinaxhAirv6DUeDceftYGqERCH7p21u8AX5H6iygFfkrWcg8	13599	19149	19149	1619386020000
27508	3NKz9XLgFLSnLWxZ2FnSoHyZBmXX5zuC7wz31PsXDuEKR4ikKHN5	27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	1403	824	535	12463	18974	jxHbAJW3VjKcaVxyWky3Za953f6xCLPPXkWdtDF6Q8nu4zzQrRw	13599	19149	19149	1619386020000
27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	369	1066	535	12463	18974	jwX5sxHYb7jAxP8XWGg1QiFtBBLbxzCRBeYoGvj2J7cT38Qmxcn	13602	19154	19154	1619386920000
27519	3NLy6bf5t4VAFgHxCjYK5o97iiJ1XQzjFYGH2JS5BoBicPySQp9B	27518	3NKBV8oemtpt67A5SUbuqhU5EDi1d3pU4oNrLB5SwXbDhh7w1LN7	1627	1139	536	12463	18974	jxmt7qi59CD58aAcAKLLUmoPQRWKQ2qJ8zDVM7wQ7nKr1mETwya	13604	19156	19156	1619387280000
27526	3NKqAj5oeDXToD98tkxdKN9E6JseSwD4f8TxVJPtnQQUaZzBusd9	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	1407	1395	536	12463	18974	jxAxSqzop3XZjjEmdbgGF4jftezfTZxSDFrGtEhoQrjw2qtbECe	13609	19164	19164	1619388720000
27527	3NKmqQpMoSSoCpBBWYqXoMcxbPZats5xeG6SfUESp22t9RdcdgVA	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	152	1204	536	12463	18974	jwLxFFxNYVwFvXVZYSBWWhptsNHVRrVEHE8i1f2AiXuTawcfam4	13609	19164	19164	1619388720000
27530	3NKB3xwwmMgsR5UPcKAnroL8NfaK18akgA19ogmPZ86kGoWB5TDN	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1581	778	536	12463	18974	jx6vKn4BnEi58j5cffYY2MGE13jxWRz6XsPxRftiNZmVZntQXAp	13610	19166	19166	1619389080000
27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	632	1382	536	12463	18974	jwBmQ1LrLgcmLh2zM7uATRFNNi5EdpfCvX9oqbfvCkfCDXAzkvJ	13612	19168	19168	1619389440000
27534	3NLfxi81t5BZkxUu1N7YZYR4UziFfE6CxLVWTuWn8PJegLBHoacj	27251	3NLqFYo3sVrzZV2WteczFYBV2fAsJRbLeXf57G1V5SyWx2Kb3Xbo	1647	1056	525	12463	18869	jxN1cypJHiUgPRtpRriYS7ZFd4c2w7KJLXSWMZoxrfD7bjaMLbZ	13412	19168	19168	1619389440000
27537	3NKYEg7uJVgWLS1GtEtDjM5LP71QmJBm4kpstYUYSsrysYFuD6ew	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	211	211	536	12463	18974	jwsawWVuprzcyiDJHXfTjn3mPx16oWAetH8CecjuDHuWzVVC6cc	13613	19170	19170	1619389800000
27538	3NLkbopEPAWC5dNRb7kQ1kkmAuTGfx1fQVRiAvFyiVX3u8PhtJad	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	1403	782	536	12463	18974	jwAsfo4jphP8qhsKj5hVvuVJfYmH6H4ZLWZDbmtAAKTHBo9fcBv	13614	19171	19171	1619389980000
27543	3NLHJRMsUbE4J3N6CzcWaRcHwJZZCh7DfoGcqb5ncm9kLMjGrEdm	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1447	1099	536	12463	18974	jxsC8FqXgvKS7prUoxE7JpcrP8JEwW96Hx4axFZXdBvWZF8SmWi	13615	19172	19172	1619390160000
27546	3NLVyn8owacqz4sPLPTpzDh9GW9FCvrrWJ6wb2VqX2bsh2U3yp6K	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1634	1331	536	12463	18974	jwymEDC1m8Phw53r4re6Ljg4eu2MN1d2FX3HdUfUtjneTa6c9pi	13616	19175	19175	1619390700000
27550	3NKKqCAnfGC9pNV3jU9xi6MiPmLJmpv3pi37CmkPLcGCzRM8atWE	27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	1579	1143	536	12463	18974	jxdxGycMYYaj1TB5Ckc1P13nzEuYb8jxm4vH4vRDTBnhYFF67gY	13618	19178	19178	1619391240000
27553	3NKR4Yvcv5mFRQnPzhrBgALXCwM2gHtQiN1A97FXPq8NXLEtbTK6	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1506	1373	536	12463	18974	jxc4CoLm7md4TkuxFcLEM29BbErfgPsHmg1dni6fp7oaKFL8uBF	13620	19180	19180	1619391600000
27555	3NLKH12z8SBgvjZGU9EZ8WqK53hbqb8mEPxR74981SViAxpPk3Ff	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1440	1131	536	12463	18974	jxNwDKj82ZQChEmbhM7qTHMZ8joQvrF9LViunwpZqeJQvndabAo	13620	19180	19180	1619391600000
27557	3NLiKjrgDH1pmHbHjD84UujQGpXD8nfqcTrfW6HTLPuMQgot6kEE	27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	1507	1280	537	12463	18974	jwqmWc1jvHWY6ae4MmtgG3zhuzxk1uFU993vxwo1hWCBVR2R4aq	13622	19182	19182	1619391960000
27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1406	1393	537	12463	18974	jxfR7iNx3gkmWEhR31jGGq8pdHZB3NSds9T9xoz1p1yYzwAKG3q	13623	19183	19183	1619392140000
27564	3NKFYg8vcsAmQpGqdnufsjZgVVeUURQNwFE9s5z91in9va3MUoRV	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1402	882	537	12463	18974	jwVmCwqMk5NebxoKhx54URJRSePw3z2yG4A1grzyPiBtkTg89KF	13624	19184	19184	1619392320000
27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	27566	3NLdSJ9QSrGy5qT6TaJfakv57GvWcHT5kgNRUUsooToUrWVrzokp	1619	1029	537	12463	18974	jxzxrmFB3XyFtLNLjLstZberB35MauhVdeS9URU2QLHz2Qrv5Xe	13626	19187	19187	1619392860000
27573	3NLvwG3TysFfRpQWPLkCSAmaJTiEVwGjVJNiMb2Wxz8eeg8NMeWx	27280	3NKsY4kkZft7m9fMBoNnz3eHor7BhefiTfNNUZatKndL7wfd3n73	1623	839	521	12463	18897	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13342	19190	19190	1619393400000
27578	3NL7Zh5Q11DgNpVyNVV4JLrYUW2FmgRiMKx2EwtLKHGYV8UoEaVk	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1590	1300	536	12463	18974	jwu9DnJtuB3XhigMAs6zjRnob7CY1ZN3JnQS9EjRxiJu9KQATE9	13620	19192	19192	1619393760000
27580	3NK6UtkweXpzbYT1UgM6jJrPDW7F271FcrvDVwztcsemB8F1HyXm	27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	1581	778	537	12463	18974	jxkZ9ufSCykQZZUmyQbQ1gPwg5Kh9ScMDZLgqnc8JnvW5wzgsLi	13630	19193	19193	1619393940000
27582	3NLuxttxLuLR8qLzueJdVeDVB9p3brbWZVonVr8iUomkH7GQcb4e	27578	3NL7Zh5Q11DgNpVyNVV4JLrYUW2FmgRiMKx2EwtLKHGYV8UoEaVk	1590	934	536	12463	18974	jxcxzf94KSmbwzUJC2ghhTTwCZPcqmttg7CKT3scKe1vpZYnQ6z	13621	19197	19197	1619394660000
27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	27581	3NLQf7YZdKwAQX8DvjEysayssaEkVcgAzMqoA8xu25pjeZ5a3xTR	1590	934	537	12463	18974	jx2MZpGgTdULsQNnm3v2cs7pmcV2ticWKRmKhPxUHN1epDAey7j	13632	19197	19197	1619394660000
27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	1407	1395	537	12463	18974	jwCLMn2DXa2phYNUnzJ6QJWYmap5zgQcmyMxR5hGtFrQ1yqAvo6	13636	19202	19202	1619395560000
27591	3NKCe6qFQbiTBiRBXD4r6SW9XQUTM2CJg1fRNRwzFzm5n9Ze3FxC	27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	1448	1065	537	12463	18974	jxvoQuoi5CFE4gZGdd3M2XSYqH78dtafEeqnMP5cB8RRG2xmYLc	13637	19203	19203	1619395740000
27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	1448	1065	537	12463	18974	jwonNy2DonuSPx7zbhqXTfRDnSBbp826cCRhukiBr81tPH6FjZW	13637	19203	19203	1619395740000
27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	532	1303	537	12463	18974	jxAizwP4zJz69KXTq5VtZB1yM4qxXbyYM6MCyeTVd7bCQ5n6DCD	13639	19205	19205	1619396100000
27504	3NLV4UNjeL3nGoVw3yZk8aknnHAfrjhGMkepEGJG4NBz1bwyKNeb	27503	3NLNn2maRSoHigBKiizWeSyhoJs8KDDcyfmsfwWdWWFqMVJfyGSg	1571	1335	535	12463	18974	jy2c4JnWG16W5h9bzDxGraWbMBry6FtZZaUEUknwaAhnoqGRALe	13596	19141	19141	1619384580000
27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	27507	3NLbZAitNf4cTtPTiH4fn33kKD6xTL5MQ6sLqvdFtromgTMxkUor	1460	429	535	12463	18974	jxrAAmEFhYr8PtmfZVbPrS6TXRmGox4UoZ9YWSc8X2kESp3EgNN	13600	19152	19152	1619386560000
27518	3NKBV8oemtpt67A5SUbuqhU5EDi1d3pU4oNrLB5SwXbDhh7w1LN7	27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	1675	1216	536	12463	18974	jxNcJYQDBJRzf7DhrXoG6NQPSAaPhMKzgg2RhjXC1VpYtoczMn4	13603	19155	19155	1619387100000
27521	3NKib1yyfMYo2tUvrxttBuouUWz87DyWyJA6Q4yMAVFH96ehPejy	27520	3NLLJCEEeagN53cjhdbhmLoQQtxw8xCeSziaqh7uebEBea7XtLny	1406	1393	536	12463	18974	jwBY19WHxQZjR4bPBcj6JnHpSvrfTGxwrtcK9KYvJKKXV1Es6NY	13606	19160	19160	1619388000000
27524	3NLraWLvHaatZj733EqLoiEDjxNEcgM3ngZHgutvA2xgPm3b9XZn	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	1602	1243	536	12463	18974	jy3FH2ye2RD1pjCnx1JYXXVszFopioUFL6ZeanZFmpmDwbjLEH6	13609	19164	19164	1619388720000
27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	27530	3NKB3xwwmMgsR5UPcKAnroL8NfaK18akgA19ogmPZ86kGoWB5TDN	1406	1393	536	12463	18974	jxwc5ThSd1dnWEDtqDb7TY1XNFCuKNuwcNJ5Dvnw8YkA8VeDfVs	13611	19167	19167	1619389260000
27533	3NKgxptbwNDHV8WwWgjCxPEjRdtb6tXYEyjZgUKiigztzMGzVoNR	27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	1647	1056	536	12463	18974	jwsTyDXADHHgBNXKfmKKtoaqBYLvUbC2r2zQXjFnpsUQ7nPFRYZ	13612	19168	19168	1619389440000
27535	3NKXYHzQsNfHMMaq59PuRjKz5w9F73yk258Z8Ndaqy8SMmSm3KAQ	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	1546	1339	536	12463	18974	jxLoUbASoZdcrRWRLpgCY793v7iM6m7hmskfMNczgETqtTWsMGB	13613	19170	19170	1619389800000
27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1407	1395	536	12463	18974	jxZzFyjNZVQaLh5MVHZR4sZCYtbdCz3Wbq7nCNwe7crPbCSQQ3q	13615	19172	19172	1619390160000
27549	3NKUyRpvfwygVrhz733hYfykRf9BYyCgCyuLquX6erEVNYF97Jot	27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	43	1064	536	12463	18974	jx4DEtZsUeUBCBJV7BAVysSPdZe3MeG6qMiG93AvdZtWEHWXb69	13618	19178	19178	1619391240000
27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	27550	3NKKqCAnfGC9pNV3jU9xi6MiPmLJmpv3pi37CmkPLcGCzRM8atWE	1451	1451	536	12463	18974	jxY8KcWL9aJbdPNCmJfhgMz65udXtYTiKCF4wyW17K6r6DX9ccm	13619	19179	19179	1619391420000
27554	3NLPg8fy7uvkHgTTjXy8TzQLxeWvF6o3TGDzes63WwgFRpwUB5sx	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1506	1373	536	12463	18974	jwp5YQPn2T8kQhrmLnmPGt9dN2rduznNbmSXtru4mFXgcVCzXYv	13620	19180	19180	1619391600000
27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	1573	952	537	12463	18974	jxG4MCzu2u74JZnxKqsCzdFgHGEGXPbj9hHJdkxhZV5tEWqThG6	13622	19182	19182	1619391960000
27561	3NLd1biLtoCVaGJoBfRuNkrHzZxfn9LfvBr4hTRUiFMznT4dx3Dh	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1542	1058	537	12463	18974	jwf2RAcfdSQnovZRo8oogBotBfU4UfNJmGwb1pyziitw1LNvG86	13623	19183	19183	1619392140000
27567	3NLEEfFZRJdtdC6Takha6pjqRSTubzgCJqycqnkB3oRxnwnQhWx6	27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	1513	1379	537	12463	18974	jwfuhrjj7Ko3hhFvWzA61zaPzn6zNPcjJzwjTDhx4Yu1qc5PC2T	13625	19185	19185	1619392500000
27570	3NLnumh7j1Mxjgb6yihz6eCqMdD6dmsoy84kMUEXwTD4TQmKuFdu	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1522	1076	537	12463	18974	jx1Y9hgz5eM3AnAFx1F5MVmAKdxbFKgek3MPbQzbA7m7uNLz2yN	13627	19188	19188	1619393040000
27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	27569	3NK89KrumqXWrwwUL75xXjX1qKbCrJpekcky8Eq1fxbTBA9898Yt	1483	361	537	12463	18974	jwxU6myKJqFBDthpjTTavKpUny4r8Y5F7JKT3H4Cadeve7D3tHk	13628	19190	19190	1619393400000
27576	3NKWa6AuiWZwjogSrSgrpBoa4FV18uiMoqp5n8NFSNATeWdXS276	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1560	1045	537	12463	18974	jxqR6cPpQ8SdTCDHW7kY5nEqBLpXGmBVkXAVo8Fw87ga93rtxP6	13629	19191	19191	1619393580000
27579	3NKWppxRC1js7Ec17RmGsTdF8URJ36EwynEaiBV86JymG7MBNkRY	27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	1406	1393	537	12463	18974	jwGKc6y3PNghpoAEnYpSXhic5DnViYRbwVqCm7CnERMKwmSUtAG	13630	19193	19193	1619393940000
27581	3NLQf7YZdKwAQX8DvjEysayssaEkVcgAzMqoA8xu25pjeZ5a3xTR	27579	3NKWppxRC1js7Ec17RmGsTdF8URJ36EwynEaiBV86JymG7MBNkRY	1402	808	537	12463	18974	jwqDEX1yUavkjroXb7FNgyCoUqaG2issh1Ktns2Z6QfNAAZRT7G	13631	19195	19195	1619394300000
27584	3NLPPy82ucmJ3yu9tzKY7zYWHhXqNGCA8PhgjNmj1KTkPrBBs7Ze	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1447	1219	537	12463	18974	jxp6ypo7jcgejvSFkXhHM7mvE2WqRA436t2ZreBXo5DByQcohG8	13633	19198	19198	1619394840000
27585	3NL4nDrZEV5SETrgr1fVe6qbKA2DyWT8EpjsnzmyZXD5n4TNXvXc	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1474	1329	537	12463	18974	jxwLhix5ifgL2iiKsYAaRpMeYBxifTvx2gJkWWVHFi4yQbAdyt6	13633	19198	19198	1619394840000
27590	3NKV4iFAoryYL6KWWDVBKASCauryqpSyAnejWSADkGKaciR8tU3s	27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	1534	1317	537	12463	18974	jxcTF2eLEEt1t4HkvxQh9jToQWwnmB9kEPyVJ1zAaScrp1K7hG2	13636	19202	19202	1619395560000
27600	3NKo3fHScQuQnY5yjja73UoZLTwaVfbsFwRtRdLcoE874MAivehh	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1445	1290	538	12463	18974	jwYDGhs63L6ojvsupyP44SUQ28MgnwNwXtW3GxnDYS4NsHJEb9X	13641	19209	19209	1619396820000
27604	3NLqftvvBndL54BpddAG3P7xE64SEtGh15oSxeagDPUvh4VrLHSp	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1406	1393	538	12463	18974	jxYgpeW8gPQs9q9iYc4N4JgPxbVt3VnCYZKLR1QrjyR2mRULn1r	13643	19211	19211	1619397180000
27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	27608	3NLG2GzDpemxTyc9xEwWiSXq513YqwV7uRpYkMGJ6TL9P2kFMXbj	1547	1012	538	12463	18974	jwdseiffdWZXoUHk3KYQkS7M123PsW6dpRKqjsXHyxjdM2b5GB1	13646	19216	19216	1619398080000
27612	3NK9S6ixcz8fNwSHX9jF3ifo7jp6g3MZLR4obyCp9KcWLBrFuzA1	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	1489	1014	538	12463	18974	jxf6xCKBjw7vsZkLp1soPucjTRqXkpDxesZtjWxYX81qywEEnCU	13647	19217	19217	1619398260000
27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	149	1037	538	12463	18974	jy257LNPv9yrDxUaJy6FZTAH9zVQpNs8jz1apALLia97HpUhyWx	13647	19217	19217	1619398260000
27615	3NL2wXswEcx4X2Er3k8ygY9CUdVpj7qTXkxHuFpAUnycXnyX7PAg	27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	1406	1393	538	12463	18974	jwqXqxuiqtPrEDgvQKhocVbFbF6v7aJtFS82ULAedn1o686E2bZ	13648	19221	19221	1619398980000
27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	27617	3NL4CTzNuysgroYj8zx51XjsGG2AsE1UxXThqvprKQykxKE7Tv5y	1593	1346	538	12463	18974	jx6BW5cTwKNEvboRt99vBpcNSZY4uU62pX2zi4fRdbdZaCPFtC2	13650	19225	19225	1619399700000
27635	3NL7CgUbpxjpkp7JaKUAkvx6DVy8jLV38gDmVHQAh8Vu6mTJ3Hnc	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	1573	1318	538	12463	18974	jxMVxC7FRjhUcnWEoWzvjZp85r3yxySiToeqhXeSZpqz9VYE8Ng	13658	19235	19235	1619401500000
27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1407	1395	538	12463	18974	jxRqwZ42D8Wtn8zMKA6sccF4bfstBXRBpsdHMus4sGZwoR7phf8	13659	19237	19237	1619401860000
27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	27505	3NLqCJGJJioGaTHz6mkbEaE7yqeAxGnceY5dKXtiNhFH3Nefh27G	1406	1393	535	12463	18974	jxWi4zvZv4P6c5NpRJrrtJSagywdfyTjonoYN5m81wHgnPsV6JZ	13598	19144	19144	1619385120000
27510	3NKX6hzL5EZNneRz8UhDWtP9K6HHmNkiBK2tr9VhG4Mh3PLpywHq	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1662	219	535	12463	18974	jw97XeKKwQwtfBnGoJvVkDWixRJ73BdtBCLEHY6V8nVC4TpvMoi	13601	19153	19153	1619386740000
27512	3NLeCUFdYb9vd4uDf215d8WFaABNmwPcMF3vWg7cT9GpCc8BrHkK	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1578	1050	535	12463	18974	jwvm1hQcMHnWbVZHnRAoxrA9owZzk3ZF61nqEhzMBrctrZNcpsJ	13601	19153	19153	1619386740000
27514	3NLNZfUrxa3kGneiZJzG5CXgUSgiPmuzCqTQNEcqxybXKeJuArzY	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	1407	1395	535	12463	18974	jwvLHFqcA434EziVwCxUNX1yRUYu5VkP8FWbaV6VTvr1gFTiR23	13602	19154	19154	1619386920000
27516	3NLfNPA8zanrXCHyVoetWtDH4aqeWqQFykoTLNvLv6Pi5jveUPf1	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	102	102	535	12463	18974	jwtTvbxXwXDQKf6vHKAXMY3meKxXVKrepJofS7Rh96wqUAi6V2Q	13602	19154	19154	1619386920000
27522	3NL1DvEgXxvXbQiKmJj3EUUeL9gZCWWfUDPBRGsUNHFh9uDhE9fm	27521	3NKib1yyfMYo2tUvrxttBuouUWz87DyWyJA6Q4yMAVFH96ehPejy	1611	1341	536	12463	18974	jxD8YouHJw4GbY7RZErSfMD2KN2TFSRwWX3pyVQ45SPzAvKq9r4	13607	19161	19161	1619388180000
27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	152	1204	536	12463	18974	jwpD9KYdHD3bjeG4i1dUWfgVAR7Pbr1LAunfbxcu2FDaZ2AvcAC	13609	19164	19164	1619388720000
27529	3NLSi3fppUdgJY8wsg4abiwv4zn1VWGWTDZsZV8nDwCBKcv6AzVT	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1555	1221	536	12463	18974	jwoKesQCEwRt6J4vbK3N6c5bvcK4Ng4BWvaPGTvKPbwquZg5BXu	13610	19166	19166	1619389080000
27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	1405	875	536	12463	18974	jx3QRzYTAcqsv7666QMBpZi1jT3gaaWEXzTbSmaQHUS7F4kWNmz	13613	19170	19170	1619389800000
27540	3NKBwgPrNskrVvxhpbsufcWN3ayAGtNE5env5JZMg4YKHpFawLHm	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	606	1049	536	12463	18974	jww2isuRp3qvzmB8RXpdK9wJgBoHMpoPSTQ1fCEv3AHkYzdc3F1	13614	19171	19171	1619389980000
27545	3NLZg8MXLhgEfE5mwbemAz9P5QHMHaCrR25JjWY9tWaE7zRTwjhL	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1581	778	536	12463	18974	jwYsQvYhJs4kdx5gyGeZnMcCrXF9g9U4usQPyYTQPBVFP3NrK8f	13616	19175	19175	1619390700000
27552	3NLPBVVZCvuUYTvNT6VUYJnyoZYZASsZMKuf1yKNRnLAYBz4HgrC	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1440	1131	536	12463	18974	jxC4w1c3Cs4Mb2oe9iGdd1neKakKReN8CUWw7brZaTSdhjpLifj	13620	19180	19180	1619391600000
27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	27552	3NLPBVVZCvuUYTvNT6VUYJnyoZYZASsZMKuf1yKNRnLAYBz4HgrC	1407	1395	537	12463	18974	jxLQ29YYQiM6ZHwBntqDc3ohbYSZtAoSVkNdt5mTBWpH5iU5hpw	13621	19181	19181	1619391780000
27563	3NKrMdxM78RFL67gn5NwstKi5wJBsqq2jCS2wiCorutMLaAYQBpF	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1406	1393	537	12463	18974	jwBUCJe7n34YyWsV4ydMESwiHiUvJq6LreZx95A8Ck9zsoWtHor	13624	19184	19184	1619392320000
27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1559	1353	537	12463	18974	jxWZZ5j5ghBPZ6wHSq66RHgbDR3wzQyWceTwZo7AmJHkemY9cnZ	13624	19184	19184	1619392320000
27577	3NKptLPSVL5U7Bx2RXcTGRaafsXg1UBbzdPA3LHktG4fgb8RsJHZ	27423	3NLMakFKFyUL6bSXJxWhBrufshCTD45STEEaD7D1tNW9pwxVSVuc	1631	794	527	12463	18906	jxXstUsgutCFeKt87XGfA3zy91Haa1GeLjyi4EWthgUrk4cHT5w	13437	19191	19191	1619393580000
27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	27584	3NLPPy82ucmJ3yu9tzKY7zYWHhXqNGCA8PhgjNmj1KTkPrBBs7Ze	1581	777	537	12463	18974	jxVoPwXnK5S4EXax4M82Y2SPyKQm1bFa2MafnJ1yzfhpdwoUDha	13634	19199	19199	1619395020000
27588	3NKyUsxJ3gwzhax9AA9FdkfBcJR6jpBqBC5mA9EdFb9aZsZemCKR	27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	1426	1118	537	12463	18974	jxksN9eBn97cAPD13KAvnvoEUFtVdHoPcVkXQ1rty8SNkChadKt	13635	19201	19201	1619395380000
27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	1471	1020	537	12463	18974	jwd5JaBKDQQntZmZxNmN1wZfFU81TQx9g1j8PHYY1sHitniVVdB	13638	19204	19204	1619395920000
27595	3NKcnWZPEHCNdjX2N3asRTyftFxdfjkbLcvTRf95R6e6NmVxDy6R	27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	1447	1345	537	12463	18974	jxxssfZEE1K9kLFpeAiXkziLjKy2zQm6RDQ2mB9YzsYucqcUxnK	13639	19205	19205	1619396100000
27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	632	1256	537	12463	18974	jxZ8ssxLTnDaxw6iQTU1tCQguXY9j3fmJQyjrmYuCThNtDBvEXG	13640	19207	19207	1619396460000
27601	3NK5uK5hhrR89LTmALfqTo4orjBrGh4zSZWPAhtofW8ghbMWenLe	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1445	1290	537	12463	18974	jxjtCVCFoSH2DJ7t7q73tdjJYNhQ4ZtEvAxnDbcJh2vEK1tzevh	13641	19209	19209	1619396820000
27607	3NLkf9PNoPZo4rDsYcefYngjk1SpxyCBQBx3dFujcKCGXMTByckW	27605	3NKDUK3RDpH5m7KQeP1tFXuD4HbfnPutzLhgTUoenPP71szZ8A4V	1402	868	538	12463	18974	jx21VxKdB4cD75TA84Q3PQ5ATnZ7BGs1wbG7CU4zitFhW9CGThi	13644	19212	19212	1619397360000
27611	3NKakZsnHHfxYaN2GUSXkvScbeQBJCn9EseSCUC7JwoiQTEYyZLz	27468	3NLXVfAnq2KbvrxD2LnNf2BksKR9rKHZpUZCPUD3JyfBjRGcE1Pb	1547	1012	533	12463	18974	jxf8R4BBNHbfJ5XKw9SkCDd5Snn8CZY9meEng9Bqy43Y2wJL7my	13576	19216	19216	1619398080000
27616	3NKsJfTDNyAZUmtviwPC1ac1Jm4o8bt1SFycDsePzuqF9oJv4yuc	27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	1649	1257	538	12463	18974	jw9pUbZk5KLqmVvrMm5bSsmHG6HbsiJut4w85vp6rQwfRJhPM7g	13648	19221	19221	1619398980000
27617	3NL4CTzNuysgroYj8zx51XjsGG2AsE1UxXThqvprKQykxKE7Tv5y	27615	3NL2wXswEcx4X2Er3k8ygY9CUdVpj7qTXkxHuFpAUnycXnyX7PAg	684	986	538	12463	18974	jxZDMiw7GSxpFyEBrEqYdTRouzTEd6T3LYYvsaLcfF5GtA2xwn9	13649	19224	19224	1619399520000
27624	3NLaEeGDjFeye9Hzh4af9ASCUbqjA36hMR4Tp69ozBfem68X14BP	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1546	1339	538	12463	18974	jxPUbUU4ZTrJRiDAcnAfRGJxz7wewh3LEma9CBj4s1QAhYHimvN	13653	19229	19229	1619400420000
27629	3NKzwmRpJ6N82wADh7cCRan3GazfqdNkEF7KArHGYgokhwRDikjL	27627	3NLj4bY8xfbUsRa1V9PmzbP4yPHcrvn6ebuTP38NnuBJAtzjCfVb	1407	1395	538	12463	18974	jwsN7Gbr58TuFZMgDHXoKJMYPhFEYrnM9bPMUCZrzLCJuUiYBA1	13655	19232	19232	1619400960000
27636	3NLbJvRY5jz4QH68XdQdj9C3BdXGXvQg8KEobsSx7zV4gXnPAgDx	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jwMhQtiDD75eLKJ1k2hRE3RDYg3QckCZVFEj3pUKH5tf2tX76Mj	13659	19237	19237	1619401860000
27639	3NKS9xyvAgEUFjXdaB3AFzY6aAbv4SgBrdNLTJCDwRH11zAjELVN	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jx7cAgSQgZuBRkFBpajs31rnqrgzzRjMw3xFc48rYSW9FDCt3Nu	13659	19237	19237	1619401860000
27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jw9uZyfXSTNV1sgcDT9UGexXFCmXXGQoGfxJEYVbrGPUyEUt57x	13660	19239	19239	1619402220000
27644	3NK5kGFW4jgAy7gabsJHK9H1aNXZoQ9LHajeuswzpzUVGwXybpQ8	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jxQJ2z3oqeEbpKM4brR4mZmtLh6nsto4KxXck2wmABc2iyDwaAL	13660	19239	19239	1619402220000
27602	3NLLy2XW3iGSEfsgZSdjYRYcyQJc5uWP7Lf9iApB72HonNAHX67q	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1439	1279	538	12463	18974	jwtCCXprfXaYo71bjVKoqjoYDzHgAUv8Vzn7mnFgZ8h23pKqqk9	13641	19209	19209	1619396820000
27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	27599	3NLofscFYwuMFBKy7Qs3CRCL9o63WgZiKApST8kTcGBhzSNdxmfX	563	1113	538	12463	18974	jxgWfvTBf8c288EZ1k32rghLDkY2sUai5xYXtHSvjCWFWi7Mao7	13642	19210	19210	1619397000000
27605	3NKDUK3RDpH5m7KQeP1tFXuD4HbfnPutzLhgTUoenPP71szZ8A4V	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1444	1381	538	12463	18974	jx29FPNQWrkNUqovfAz9ZQd4nzJuHY4jR4MKe6rHb5wJC8yNZun	13643	19211	19211	1619397180000
27608	3NLG2GzDpemxTyc9xEwWiSXq513YqwV7uRpYkMGJ6TL9P2kFMXbj	27607	3NLkf9PNoPZo4rDsYcefYngjk1SpxyCBQBx3dFujcKCGXMTByckW	532	1177	538	12463	18974	jwAcN6AjQJAurbx5kRAMAxi382BEqKL4ceMWtW6vV8Cduoy8B8g	13645	19215	19215	1619397900000
27619	3NKTfzJ6tX7BMWcADAbaoREgG2h9yvDbhHx7yPNEtTiAjqZkgiXf	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1585	1366	538	12463	18974	jw7zUuuwdDBymrW7KS54QRL2VrfeGGo9GuFPAvxSuGWSbddSLHV	13651	19226	19226	1619399880000
27621	3NLZkh3v1s26WmuWE3CZsS4ezbFwoL9X4iLaDjKX2vqzztsrPwUa	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1624	968	538	12463	18974	jx8RgPVQsFCTH9HyngKXowgFXAmy5cwDHkpWdAwX7wETtnjPfnd	13651	19226	19226	1619399880000
27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	27622	3NLmw2YK9thd5QUMSycUBWL6GWWNjwr1Ei36BT4rWchX6sDL14Hc	369	369	538	12463	18974	jwyBsFkAqx61thKyCUpWkFpuhiTQexwoovBW2zAit7ZCdFpZEXE	13652	19227	19227	1619400060000
27626	3NKPhKBmX31e64hYNdKwde63uAge9CrpEe1NZki8LwVcUByLtnbk	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1637	816	538	12463	18974	jxLhi8a8dJt3n8zPL5FuR36bscRo7KxSARb86aqPt1ieFHX7u54	13653	19229	19229	1619400420000
27628	3NLY3Fcpct6L9qQ1PGJWb2BfSS1PwLrPfpFwEZJwkdGGsZ9ZWHro	27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	1581	778	538	12463	18974	jxv4egQLukMHMPL1YC38SeUYTzm4aabgk8zkoXNuPft74w2297X	13654	19230	19230	1619400600000
27631	3NLSdNqvv8iL35WgpFjqjuWTn6vEDvC8axqUVQT1cYRqMyENNz2M	27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	1406	1393	538	12463	18974	jwiQiNRnd5jY34JE2o4vsAN6suXXxZoBfoorTZVW6N6xuyjaUWR	13657	19234	19234	1619401320000
27633	3NLWQ47xNpdxsg9sg1m2zPTarKo45Y6SZBxGCXChTXmMJppCofxN	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	1406	1393	538	12463	18974	jxD69yNwzFr6gGPF3xS3VXWnZ1q3hLpWTkDdMBVpzRs8cEwRQ15	13658	19235	19235	1619401500000
27640	3NLMnR8BhS3ikfgAqnKmKRtP8fCcXKjoRQE4izVC83NFnqdGPvZn	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1407	1395	539	12463	18974	jxkoGi8EitUnr4Yw3wmegEQXxDWzZaC4bz1VWfkVsSZH7gGReH4	13660	19239	19239	1619402220000
27643	3NKZE35DsvaZiJ54qcN7wZPuT7jZdjU6Wrdvwb5muGBkdCHNSp5P	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jw9uZyfXSTNV1sgcDT9UGexXFCmXXGQoGfxJEYVbrGPUyEUt57x	13660	19239	19239	1619402220000
27647	3NLqaWotFS6igG1zyBxSFXaDdjqeYWK9gm3BEZ6PGnffQuQUnQuZ	27645	3NKdE9SVSxWXWNauLZVdVj4Ti76xs1ZhFYWgvoGUtELaL4uPowTr	1503	1277	539	12463	18974	jwHYwensdw6bAFvRn4op4L6pg4iv9mYrCGQs7MTss3wLu3xCASW	13662	19242	19242	1619402760000
27651	3NKxTNn5vy63UahFX4GnP1oZKWH2p7qaxij5SpekuHhDChbhu1sj	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1675	1096	537	12463	18974	jxsYd9MfeeqGdoUNLEY8zoWsDowHLKF4efr6ftLyQJaswWY3fGu	13633	19246	19246	1619403480000
27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	27650	3NLcUA6u2hpPrarm3iZHhsqkiQa9uJBSTjXbC1n74eqJKB3GbR6P	1407	1395	539	12463	18974	jxE8ukBnzjQhEmYD94SiVDqzaRyr8Cqyf2GMWKoRzA4NLq5s7Yq	13665	19247	19247	1619403660000
27658	3NLssscgusjmBih76RRv23wa3emK4UdpKqjH6CFLpztpKELhRRDa	27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	1657	1344	539	12463	18974	jxJ2bD7i7Z5GtNwP3bAXMe2RMVyAZJVcXHjpGRUPdQodxj3w5zB	13668	19250	19250	1619404200000
27672	3NLtSaT43c7VBbYyAvYEBUwysqHNU7K4ccibEKzHDsPXrgTZymVg	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1627	1385	539	12463	18974	jwW2f9CdCVTPNMUAFqYp8gmHGrgpdrU4MXTjg3DFLwtubdfQrbW	13675	19258	19258	1619405640000
27676	3NK7mrDRLwAi4gtUkd34STVZEvideXvnT4vXdAu1nbB3G2Ldd2WX	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	1501	1360	539	12463	18974	jwZxaPj8B3LEPRaxtviDPgvpgyi5idR23dXnRZKzM7K9s4cYxAr	13674	19258	19258	1619405640000
27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	27677	3NKUiAsMdqYLfjT5whnTA1uXgjWEjWh7gPsFAxASxfSH6LUKXrnM	1406	1393	539	12463	18974	jwQAJgvk28vgQkBVJVrD6nYVrUhrd5WPBUUh2VVKkhAnjZK3J4q	13676	19259	19259	1619405820000
27683	3NKT4S6R392WnHzoX1AVkwosvV5Z9Pm95LWRVCwsEKjkPY1wdjnS	27651	3NKxTNn5vy63UahFX4GnP1oZKWH2p7qaxij5SpekuHhDChbhu1sj	1675	1342	538	12463	18974	jwTGARNAa5aB7Cy1yWNSgDH4gKBxi1GrR5hZQeKemvFxK6v7B3F	13634	19262	19262	1619406360000
27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	1541	1298	540	12463	18974	jwbR8aW2reFegjK9vR4UxnDZUfYjNV7X7hJZRHg7BAAC9aHYjyR	13681	19264	19264	1619406720000
27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	1637	816	540	12463	18974	jxiFzLe7AZqSda84wrSnqyTRwnBZmfaheVSJbA4BdD6jzUK8CgT	13682	19266	19266	1619407080000
27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	1483	893	540	12463	18974	jwkQ1mPyntQtxBroykdtaEy6BaAcuXtsg8fx5ecf2GxvmwPkVoH	13685	19269	19269	1619407620000
27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	596	1180	540	12463	18974	jx62ZACJEun7eSYsjjpAxvfneCaf5tkiiNtuhZ38mWGzmnqPrpo	13686	19270	19270	1619407800000
27700	3NLFQMnDN3DFydVTSXHnLV53cpH7ZMSMFMBcxntezKUqE2XvPP8A	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1405	857	540	12463	18974	jwCc9fxtWHo5UHWM79xVB6sgaTqVCgWZPu48PtY48ksKFpRw7cM	13687	19273	19273	1619408340000
27702	3NLGbJEMaCtmouL44CCTMHeeow23CDTEfqqHwfiQb9oK5PyXyyLT	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1611	1095	540	12463	18974	jwPbA581XTwsF4Qc2Fbq6fcYB6N7QS6rVMo9H9AYjaX11HLeq4j	13687	19273	19273	1619408340000
27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1406	1393	540	12463	18974	jxTN75tRUGHuFJfpZXMGnJPPvn6Czrp4NvnEKqjWbTtSKuztAAw	13692	19286	19286	1619410680000
27711	3NL59SVe1hvEQWAeknv5zMe1EtszGuNQbP9sC1bnwBW2d3jzRmBG	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1651	935	540	12463	18974	jw8qELsuD9R9ssQHd9kj2f7aibtJqtvA8YXGEUkMaqsPBftrgUU	13692	19286	19286	1619410680000
27716	3NLfY6oR2kuGT6NUXF85eHYTvG88NyJQPz7kttwNEeriLkG32dok	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1624	1334	540	12463	18974	jxvqX2mriPdWjxoNWpECGhNnpFrqvyFk4n5cJB8tibiDFnHmred	13694	19289	19289	1619411220000
27718	3NKjTRnj5B6YAuyDSZfnHcbq9z4FcFpwhUdLFZ3fqWqatFewGSRV	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1613	1349	540	12463	18974	jxQFFbK7r1wax2weN4ssWhmxyVyuV66cthLgHzyEQRb4P4sDtLZ	13695	19290	19290	1619411400000
27720	3NKaS6TBRbAQbcB2tba5FUwYM2KiAGQgRBp2ixBj2iA6wHRod3Nr	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1613	1349	536	12463	18974	jxQUpKH9sm7gV5JuHuDHGGyMzhxjRoLjuuduiN95Guk4jfAW1eE	13610	19290	19290	1619411400000
27627	3NLj4bY8xfbUsRa1V9PmzbP4yPHcrvn6ebuTP38NnuBJAtzjCfVb	27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	1607	1348	538	12463	18974	jxgM3CihvxMPy4Juia9wRMuw5xq3Qsav7Fh9VphPBPDoajsN6YV	13654	19230	19230	1619400600000
27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	27629	3NKzwmRpJ6N82wADh7cCRan3GazfqdNkEF7KArHGYgokhwRDikjL	532	937	538	12463	18974	jxWGjB2ofB6T8DGyCxjKbHVxM1AmKqBsUTVLxKUyVcdwUD5Nttp	13656	19233	19233	1619401140000
27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	1460	565	538	12463	18974	jwZWTBZ55cBHyUXHvccpzTSEgTQwzpmECrxoq2Pbcco3bVJX7Xt	13657	19234	19234	1619401320000
27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	58	915	538	12463	18974	jx4tn8P92wHt12e6P8wjidzGwLL73QTp3FrH21P2UJtTHvnqR3t	13658	19235	19235	1619401500000
27637	3NLrJzXicNg4YoBQ12fA9QzZ9wt6aFp9GaZDDCVMY8ZVUhwD2EeB	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jxFhTUMgtFJ1ButSt3cc9N12F3TKMyoJqs68W9Gs11wXVNCKRkR	13659	19237	19237	1619401860000
27642	3NLPEPJPfAkTeN5nvrd4HNUHxCbWhTY1ZkirJAaZgKLz98GNmouq	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1403	31	539	12463	18974	jwvrhmTTt2PtVCDjxyLLRPG6efCfQvFgNYU5SEr5eMAV6iWKiWh	13660	19239	19239	1619402220000
27646	3NLMasZFX5jtVG6sw8ckDpg8t6a6feZR6WKHNR63TJsmYA1VVonM	27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	1649	1383	539	12463	18974	jx9GYUXDHkhatZkQZ3PEsFpG9jHtZAJLBNzvQfMP41yd45exw1m	13661	19240	19240	1619402400000
27650	3NLcUA6u2hpPrarm3iZHhsqkiQa9uJBSTjXbC1n74eqJKB3GbR6P	27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	1675	1096	539	12463	18974	jwxhsn1HGvwnSwGE65CQYMZDQU9uuaHmSP7iEE2riWj2rDNpSrL	13664	19246	19246	1619403480000
27652	3NLA1gzY1jkvzb5PFsh9ExBtfqHLW26MBZCUZcJ84aE5GVGf9YCo	27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	1650	1375	539	12463	18974	jwvHm811JznaBC1ymqKWZDANC6XFyVAo79SwCwn4hkj9FnhWpvr	13664	19246	19246	1619403480000
27662	3NK627jgb9ZLBauFoAPZh8uqQMS15ZVqfvniW7ZcGbs9j8oeGLLs	27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	1403	824	539	12463	18974	jwGYxCyBndp9p5TjysTf3gZNB99FZUJ9CNUdjx1xeN8no9eseFU	13671	19254	19254	1619404920000
27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	27662	3NK627jgb9ZLBauFoAPZh8uqQMS15ZVqfvniW7ZcGbs9j8oeGLLs	1671	1365	539	12463	18974	jx2CFo9Tu9QFoQgyxnErxPZK1jr99mXmEByK45yuZVf8WyKRkbv	13672	19255	19255	1619405100000
27669	3NKU4ZyXCXiQrnpxvWGJRVykzdzEpzZXBzL1ogJywrchSFkk4gRP	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	149	1283	539	12463	18974	jxTJ7e5Arhx3EbApinuLZRs4z5F7mW6ygqZ45SMwgMNZbFdDx1S	13674	19257	19257	1619405460000
27671	3NKACnc76jWYYiEUEDRMd2Ji1Sj1LUXoP6pzZKEaiHq97epRiPwr	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1406	1393	539	12463	18974	jwL1h7HbEU3hrNAAD7gEgjydwT9cKQZW3V6TymnnnNQ8zn74x9V	13675	19258	19258	1619405640000
27677	3NKUiAsMdqYLfjT5whnTA1uXgjWEjWh7gPsFAxASxfSH6LUKXrnM	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1501	1360	539	12463	18974	jx7rJj68fL4YuUU9MniDZGYT7oSQncGmLM5B8AvB6UXeVLkaZ5a	13675	19258	19258	1619405640000
27682	3NLTsaqo3bkadXNEyN9MBSNWWWn491VcT1FtdGacJawV7Xrj3sS4	27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	1675	1342	539	12463	18974	jxneqAHZFnCMGwzjqddUtQchsKRQ58TWcUL1rTMf5Nf3Ko4JqC3	13679	19262	19262	1619406360000
27687	3NKbxFjoJnCLVtGmZ33xx4RKHA9xuYLvhbgovopHJ9haWCsVYTxM	27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	1402	884	540	12463	18974	jwchVjuLcH3DfSEhExPdxRigBNDFgYnPxAgbSNuQPuTA3dvbXxn	13682	19266	19266	1619407080000
27689	3NL5ExH59CBubuscrZrWY7cnuSbUKiGQ1KmCP6WXjeh8puysd8dC	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1511	903	540	12463	18974	jxybvxb6Q7vpNmLhaS4cEbNB27x21BEkyjsg8q7P9aKRggW6MGG	13683	19267	19267	1619407260000
27696	3NL7C3oek2XpQM3DQNAQraZD7eDycT9MzmLg77Vt2v8NAvMssX2V	27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	448	1305	540	12463	18974	jxNmwNU1s46AB1YwqyANKJhhE6u5JGG4AFDEZsGY82947MqXrVz	13686	19270	19270	1619407800000
27698	3NL1u9VRjJ3RciCCVdnqzBqVAcrJjStmt5z5rFRrWcx7APAvfhAK	27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	448	1305	530	12463	18950	jxpmfwpgM7yAJtxWNHvEBUNYkGWQBgG1PxQjA3AwzUNJVfFH2wd	13513	19270	19270	1619407800000
27701	3NKruj4E1MmAjAzL3YphNkzsfNPuX3UuLKYTHkJBHzPyzmoxbNJe	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1477	984	540	12463	18974	jwzWGq4j4mf4NBgXae7gXHve7r3CRiijKY2jASvU4NwbpZ1QHTv	13687	19273	19273	1619408340000
27705	3NKaRxfjUfHdoMmcmjXvaKZWj6muWoMFpZHNj6VX24WgzqBYsqrk	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1406	1393	540	12463	18974	jwXNLYGme2jN8ozNGL7hmu6dxwdJfkesyfpKZ4fU5nfEZxG1TRf	13689	19280	19280	1619409600000
27707	3NKqLAYUzpNrnM99cpXGWHaK6VfFe5jDJ3dSxAj3TcaVqwksgVw1	27704	3NL2spwMnvm95hbade2kDa85tkzYk8Fy1JNwMmQAvmKkymDCeGA7	44	1079	540	12463	18974	jxVkEnfLR2WN8R81XHtw63HjuDq5HcvDknnfNo8upC2NVmf8WRN	13690	19282	19282	1619409960000
27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	1407	1395	540	12463	18974	jwsj33zmgcv8kNgCJucae6q8HtZBZ29W1At5yAy7ydXdFXk6xmq	13693	19288	19288	1619411040000
27714	3NLLuGysUXsJ7a5HXokTkkuyB72VsH6rY5Gkm3A3HGbsuW5stAaM	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1405	905	540	12463	18974	jwb3N9hvWESBAZVtWaunpGMyL2kL7g4EAC5XSuX34iRGtXbJm2m	13694	19289	19289	1619411220000
27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1403	31	540	12463	18974	jwEz5s2Ert8LvVhgNqx9d9WaC2SavvbEPdLU3rFoFSQD19QnFZL	13694	19289	19289	1619411220000
27723	3NLuMJD4f5srRF7FV9dwqaGy1bB4nRNBYz25bXQQCNvuDBW7EEUo	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1633	1390	540	12463	18974	jw9yvdRKADLxVSf5uF6tuFX9S8ZR3oReZNVG3kG6pUX4gyZBtK7	13696	19291	19291	1619411580000
27726	3NKB7TMRthAfkBhFJP4wLr51nJS4WSZusttocyguZ3iCmSXJGmez	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	684	1352	539	12463	18974	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx	13681	19294	19294	1619412120000
27732	3NLVFk6UmC7JbXiWt4Fnz3q6Ph9ptu63ewN7MiGspysctxn67Vvi	27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	1407	1395	540	12463	18974	jxfYBNM5GtRKztWUSswgzKothnp1d6giE3apt5uApsAHgLouxzN	13700	19296	19296	1619412480000
27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	27734	3NKceus2pFNtFFvNSnvtjg4N6s5zMZMP5FEsS6RqdkvuGfme7vgb	1637	816	541	12463	18974	jwtQWoGKqxfKy4jGUjQJVRJkg2urriGx1ughXvevUMpU7qxA5H5	13702	19300	19300	1619413200000
27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1590	324	541	12463	18974	jxB4kQUSPRsmK8dMm84PckS3kKBHG5MEYxhSsy5kseRL7k96rJV	13703	19301	19301	1619413380000
27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	27739	3NKUpVPxEjjb25u5hKZYkKVn1YrGAsYZQTQWK3krKFpEgdBX2GNv	1445	924	541	12463	18974	jwtxbjZPaBpsmgoewkhVhWeyUbQFt2iHpBSEh9dgdKadzoyUX2p	13705	19309	19309	1619414820000
27744	3NLp1LXChyMWtWpSPx5UaZ8kJrhSV58JmB6ewGsgqnKNzKamjuiM	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jx1Ru1vcuBkDQYyKK1b1YXvbaKGPeeQ4Go7ovRuEZYAq1oyhwZb	13706	19310	19310	1619415000000
27645	3NKdE9SVSxWXWNauLZVdVj4Ti76xs1ZhFYWgvoGUtELaL4uPowTr	27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	1406	1393	539	12463	18974	jx9QNhYsyRpMcQeMR7BjvP6vfcui4i85DWW91GcT9kn2x7aijbA	13661	19240	19240	1619402400000
27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	27647	3NLqaWotFS6igG1zyBxSFXaDdjqeYWK9gm3BEZ6PGnffQuQUnQuZ	1647	1302	539	12463	18974	jwKdREAifwj6MvLHXFXXUXxQd3QSomqtbPrxbMgPrXCTR3i48Lc	13663	19244	19244	1619403120000
27654	3NKt3LYDMXW1qw6NvDfAcCU5weKwDiWhATjHn7FpenHVp6SEmWYx	27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	1444	1381	539	12463	18974	jwPFU5yyTgw9vABayjRUFRdiFo8GiLKJ4FEt6nE8z9SFy684jsb	13666	19248	19248	1619403840000
27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	1405	889	539	12463	18974	jxaTVyXSrEGgczcD1nigkcUPJU5gzbi1p7r9uz5qBHWGLj1F5BD	13667	19249	19249	1619404020000
27659	3NKhNoDa9xvcgyzwagGrRqaDs9NmLk34MyYrkCwF8LPc24p6bury	27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	1668	1124	539	12463	18974	jwX7n9Qa9xYpirMtx2vWqmJAeN8AKM979q5qwwScSUZHe2pQ1x2	13668	19250	19250	1619404200000
27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	27660	3NKK9dNTktgF84463LawaJY5wehXTtZMbMiUpsrai5BrxBCTpwZB	1578	1296	539	12463	18974	jwpJS5YbrUtWd6cpRyXU5BgaYqUwARmFwMk4xzFMwBpLTBMyv6v	13670	19252	19252	1619404560000
27666	3NKLqbcChVVzW8XsveJsRpitc1EJ89w2AfEmtLYjehka19w5b9mU	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1652	949	539	12463	18974	jwCfgep5zhUjkUYcJGnqBVcc6fLUgRbBCU9Sx2EytzZygR8vTcL	13673	19256	19256	1619405280000
27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	1445	1290	539	12463	18974	jx6g3xwkVfbdWkNax8q2wvTKfTFhREiQrF1LqFv929o61yWz6zo	13674	19257	19257	1619405460000
27673	3NLVDRR4zPcx44eKu8LUUACr4AZT3L2tStn4AgJZF1N6diXf7XBm	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1405	873	539	12463	18974	jwb2FNkXyx3sFaMyUwg46Vh3k7Avt19Ufkj5zXqoJ6GmoxptDas	13675	19258	19258	1619405640000
27675	3NLnsULpPE8NHVxC2TjygRS4uUNGvVCTkimyzFctkshgxQkcJnur	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	44	1325	539	12463	18974	jwkDpj1bVRdcgBmfaHv4tHZx9RbYsy2bhfY6G9ENrs3xnKw5v52	13675	19258	19258	1619405640000
27679	3NLLjJ6j14iqcHoC3RVK14jQmdxcpbCNUiVJjqimeRZvPJBG9h22	27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	1447	1099	539	12463	18974	jxE47xogyvFo3FzfMM4AdY2bxjACbofwJJtYcGxvDsYfUu4xQmL	13677	19260	19260	1619406000000
27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	27680	3NLqfdfg1WTiFokse7WmBGwNvEaniDTKPezqj3sqo4nVhHndpcbx	1490	123	539	12463	18974	jxeXPWNpwj9eosz5K4ZPzJdWuNGTa1qAggnsMr9daJAuApieH1Q	13678	19261	19261	1619406180000
27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	27682	3NLTsaqo3bkadXNEyN9MBSNWWWn491VcT1FtdGacJawV7Xrj3sS4	641	1090	539	12463	18974	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx	13680	19263	19263	1619406540000
27691	3NLk4m1EJCPtwZgP5jcrFFfHNhPvT6eEhJ1tfJvigkWVuwam8xAY	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1511	903	540	12463	18974	jwCMQEtFYVPp2wXKdqvqkQWs7SB6KC7FCGPPrHTj1S5kGC55amF	13683	19267	19267	1619407260000
27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	27692	3NLZwQqQs2pmzVXdhfGdEBuUAHo2hsjM8x5eXThULcuryno9mi3E	1483	600	540	12463	18974	jy1zG3BXmD7iic8evWBmdrCUYY6DpRWKUo9nGZUBcDzKKhQ7K2S	13684	19268	19268	1619407440000
27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	27701	3NKruj4E1MmAjAzL3YphNkzsfNPuX3UuLKYTHkJBHzPyzmoxbNJe	1637	816	540	12463	18974	jxQAGrZk95fx1xSvXCtMGqPxUUtPMBKHA72NcwjgKbWiyCeAutU	13688	19277	19277	1619409060000
27704	3NL2spwMnvm95hbade2kDa85tkzYk8Fy1JNwMmQAvmKkymDCeGA7	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1407	1395	540	12463	18974	jwsupRDNJuViZHiQvQiTm2tP7pdmpojVC2QdQLr91G27DMCUxqY	13689	19280	19280	1619409600000
27706	3NK5NExtiNSjmgt45mNdFp5eEkVoQvmY92dKvyCFiNKyuiADTLDa	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1559	1353	540	12463	18974	jx4sPcyaEqXaYu9PbPvC2zJeSrY4z31nGuBsVi98QcwcPS1RJLE	13689	19280	19280	1619409600000
27713	3NLTqzNPc2bpfGHewSktgrzMRTWeXRhagYyJhHMVGHCzEngMQxkh	27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	1483	878	540	12463	18974	jwTdjCQb6dJEHEAJ9cz8eNv69qUX2rCBwwC34nE3bshxiFRf6dv	13693	19288	19288	1619411040000
27722	3NKkC2oaqQH2STLCV6VbW9Zo3NJX7hHwswAT2J2KM2D7YWXKQ9ic	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1673	23	540	12463	18974	jwd4NzUz58NsPRF2XiHNjPw366LW9WhRojK7qawN3jwXtTfTT6T	13696	19291	19291	1619411580000
27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	27721	3NKBwa8paxJYsSRLNt6fc19KGnUdx53rmRct39jS9Q7tUabt94w5	1406	1393	540	12463	18974	jxYi9q5aKNJdobpcDasya72EmwrrYFbb73VD88t3PHDSNWWLBHA	13697	19292	19292	1619411760000
27731	3NK4mULKF3LzvnW9iw2yAtqvxfutpPX9vg2DeD7BbHDdiL5QD7mR	27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	1637	816	540	12463	18974	jwLppqfRMBaaWuwS7NVD5NRazbLxp7mA62cTiJ2nhdtu6ujkDuC	13699	19295	19295	1619412300000
27733	3NLJ1ET6feDptgcu21EwcwpwizD3FmqFCKHXdgaWrvSuoBrvJNfi	27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	1624	1334	540	12463	18974	jxAKcJ2kDR13G4XJEpYRLLJvjQvX7FTfM1MyaatW3ox9UHRHLkP	13700	19296	19296	1619412480000
27743	3NKHNZzfLYMUq7HrHfginSYmY9k3SFRstC8HEv6p5zoWyKwq7BKp	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jxV69HtcgD2vDP1h2TVJyQPN74rvGrJdhP62yDjgkUc1kdoFopa	13706	19310	19310	1619415000000
27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	632	1382	541	12463	18974	jwxmibkUcZD1U8GJd6iQ89irNSN79jgoHCo57uR3PSQJVKsmEoq	13706	19310	19310	1619415000000
27750	3NK4jRQWMDQroKXr5t2ptAR32b4D5b9cM7rgaje2EFK6XJYpjV9F	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1499	515	541	12463	18974	jx9MG5vpFsE86arTyEu1DdNWDTuJECaHFNyqsxXZmyztkmu78dA	13709	19314	19314	1619415720000
27754	3NKUef5bLcBPxXYDfrUH4pVe15rh6um3bcUb4qNJK8e8ozzH6nCu	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1590	1054	541	12463	18974	jw7o74kwDTefXbaVLL9PAdx4MZ2yW6Nbjo8BMMAZgnqDaRxop89	13710	19315	19315	1619415900000
27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	27753	3NLrym9AMQUykY5FLDahTmuQRMU46LcvzorHcaU9nRXNsfT8Qme9	1587	991	541	12463	18974	jwPcKp9pL8zxHHK3hxruNtNUWWWXeJ5McCWsDXsA4Wt2gebxHV6	13711	19316	19316	1619416080000
27649	3NK8vf7wftvxPwaYyYZ67Fkha6y24zBrhmbPc2W95eceVfPpFwPc	27534	3NLfxi81t5BZkxUu1N7YZYR4UziFfE6CxLVWTuWn8PJegLBHoacj	1647	1302	525	12463	18869	jwTVz3Nobb1JvbRRUNw9Zc5z8BStj9QYeXFtCanpq26NdxTVkJU	13413	19244	19244	1619403120000
27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	1490	908	539	12463	18974	jxjonvw3U5hjYoBWHn8wsEqABHwM1mvGAGn2Y8MbUMtKFVwuu1h	13666	19248	19248	1619403840000
27657	3NL2kTPbVMccxdGGS8pGb4ZYGnTR99Fet8gFKt5XjcTJbiiJb4ag	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	576	989	539	12463	18974	jxv7uaiVfS1bMhhsEufiJtsY1dyd27kVoeyjsWdd8YvDg6AJm11	13667	19249	19249	1619404020000
27660	3NKK9dNTktgF84463LawaJY5wehXTtZMbMiUpsrai5BrxBCTpwZB	27658	3NLssscgusjmBih76RRv23wa3emK4UdpKqjH6CFLpztpKELhRRDa	1513	1253	539	12463	18974	jxysU4nDiqHVXy37sfJDX7WnYVMeKVYPkuYmJgVvg3WrJNwBMa5	13669	19251	19251	1619404380000
27663	3NK4gu3vLDZemgxWF9dmwLBts4JSLWbUF4X3QXyU6J2TeHM11a3K	27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	1483	1030	539	12463	18974	jwqn9QRkgJfvkVUdgcgLwmgDh7BUzKiJn9g5rsShaLfNJdiS6XK	13671	19254	19254	1619404920000
27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1407	1395	539	12463	18974	jwL3Rx4eF7GXgAz7FAp4RgxmAFxAq53zUkeR4dAD7LLcC4kgrpF	13673	19256	19256	1619405280000
27667	3NLjMLPBRNZ5pEht1D2yF1yDEaabnszptiYfNChtcaHQ5xVyzxh8	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1559	987	539	12463	18974	jxUk4VDU9s6kBZfM3jDzeAEhqiDxKJYq5LSzKLQQ32Rb9BuvesS	13673	19256	19256	1619405280000
27670	3NLvQek82r2ry5kjEo1PxYG1evz3QnpzEHEHFEYaGg1wbfGDpnQa	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	44	1325	539	12463	18974	jxEX3XvoixqDfUquZPwGxAo1ZVWx8yq6HaiozdEgMiW61XuKgon	13674	19257	19257	1619405460000
27674	3NKeLnaq9tbrNJ7n9CshKhDCTmMtoWkGup6gMtEorTTR1X6ujGDb	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	532	1177	539	12463	18974	jwidk1pCwAXDqwVgW6WizuvWSA8o3TbbD9rxVnqREWiArLtPKrb	13675	19258	19258	1619405640000
27680	3NLqfdfg1WTiFokse7WmBGwNvEaniDTKPezqj3sqo4nVhHndpcbx	27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	1407	1395	539	12463	18974	jxtRW4T81Yk98GupGxyCbrUXoqsyGiQPZCTzCcynxzKMbwV6Y58	13677	19260	19260	1619406000000
27685	3NKsmZhdifhbVQVu8WfEABNCHGym11EXtqg7ZJkMSiKBixAGbJJ1	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	1541	1298	539	12463	18974	jxX4wCGBq2douMyHs31F8nApvYWakAs2cbRJPti1iMjDMAgnbXV	13681	19264	19264	1619406720000
27690	3NLobKgybSshpofCX5dqgcUWL5QiBy6d1xZckbnwPgiDUAbSV6J8	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1599	477	540	12463	18974	jx8JdwAq2azHPTChuouk1Xmr9LwGD1syNzU9TNQbuv24DwQzcxR	13683	19267	19267	1619407260000
27692	3NLZwQqQs2pmzVXdhfGdEBuUAHo2hsjM8x5eXThULcuryno9mi3E	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1581	778	540	12463	18974	jxMbuZUBUGb4K7rY5t4gVovQJsoUfkPTq13BpXU355nqqZ25xF6	13683	19267	19267	1619407260000
27694	3NKUeSg8Ktr7FFSMWG3SqfMjKUEtyrD5wGuPQqfxgqck5tmkj8T8	27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	1406	1393	540	12463	18974	jwr8qfwMo1VFA87XKb9Bce4CFPGE1vyfRoUwqp67k83YX9WVjYz	13685	19269	19269	1619407620000
27699	3NKjRHqYJicWXRZGezSiQXhx9FdXVnsztT9xB1gPYxShex4CGkT3	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1657	1344	540	12463	18974	jxReaL3YEkXCPDU3FAkbrDBpF5xkvKY9aseuFdetXycEkMHiUiL	13687	19273	19273	1619408340000
27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	27707	3NKqLAYUzpNrnM99cpXGWHaK6VfFe5jDJ3dSxAj3TcaVqwksgVw1	1546	973	540	12463	18974	jwoRQLL5upEUUBcXx4YcmyirXxh77ZwDhN6wc4AdghuKF4zHKji	13691	19285	19285	1619410500000
27710	3NKVRB9ovL8vTDEotrdP7zBKzroAECec9f9Da9WRDygoWrDMEdve	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1651	935	540	12463	18974	jxwH2yiuJugFdF8ZN21mEtd4ZkXz99mTHKJBHMzjW23MGSWu2bj	13692	19286	19286	1619410680000
27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1406	1393	540	12463	18974	jxMHNTB7HusHjFrc8s5pZPwxZLBzWPDmBZt1Bz97nowPYeHyMLY	13695	19290	19290	1619411400000
27719	3NKc93MRCkT2wFVaBWeZxQ7dM2M1fZmpkppuzLTMd4QU9ChD72MY	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1650	1009	540	12463	18974	jwqi7LsZtPxpC4QBfU9YBxQqHEXZyB1tfJdw3TaRKDBAJXVr4h1	13695	19290	19290	1619411400000
27721	3NKBwa8paxJYsSRLNt6fc19KGnUdx53rmRct39jS9Q7tUabt94w5	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1451	926	540	12463	18974	jwR5h2CqLGsGC2ksrbHYBFgiZM5ag3mysaFzky6TEwJEwFjYs2m	13696	19291	19291	1619411580000
27727	3NKJoN1dtuRbUBoVdPjAiRt2aTHDvokarBN1fRXEMMKL7z2oc6cs	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	684	1352	540	12463	18974	jwsKv13YKML4HiKeUrWiwjp5Sm9eDENhc64zj6AsnoqjCqG65Mt	13698	19294	19294	1619412120000
27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1508	1141	540	12463	18974	jxcrWKf9CSWdPeNoTpCeMLpvQmAUDkC1SwmSkQt3qv5m3fv21Lu	13698	19294	19294	1619412120000
27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	58	1281	540	12463	18974	jwejLNpGQESEmZqhW4CrXWxvbLZ9dxCNnHLpr56czv3eiKiQZ9T	13699	19295	19295	1619412300000
27736	3NKKiLQwnS5aGAmVcYR63P82Pard1QMhyq5EGiTNt9yegxy7H9os	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1440	1131	541	12463	18974	jxee3MJ2yfDv4YDm4BA44d7oL3QL8HcbqwWH6J8m7Yf7uUDMhgx	13703	19301	19301	1619413380000
27740	3NKnANaWbGYurteMryGAA5KPaWERNLdbPbRKmNZk4Ui4nFra9EV2	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1593	1100	541	12463	18974	jwuagzKdL1LsyN6STd7eUrgiPrP5yaeCKnXhU11xX2xxcr5Q9kc	13704	19302	19302	1619413560000
27742	3NKjY5cHLbQbwpDD5dLH2jrWRTybXaYmBa73itHYDC6RZaUe5MGV	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jx9PiGX37r864bV3TnXamsjATsqiMrPx3UEo7LMAg73KVNVbbRH	13706	19310	19310	1619415000000
27747	3NLesd3tWwnE16YuBvwXzuF73F8vR45F6AqawKCXXPoDgrXHda6L	27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	1617	1288	541	12463	18974	jxsaBj4Dohby9MNFF8zHXYsEsFndW4VjqqQ5FUB4nrkB8vnEn7F	13707	19312	19312	1619415360000
27749	3NL5377j2m6nxKBJGqKaU6TcLuS12s2ukVk4v4iUYJTajq8QebgL	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1608	1163	541	12463	18974	jxr8nFn4KeauyzmH3tC78oCyRcYcY5g3z3ULrpAQcXcuLhEKZRx	13709	19314	19314	1619415720000
27753	3NLrym9AMQUykY5FLDahTmuQRMU46LcvzorHcaU9nRXNsfT8Qme9	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1407	1395	541	12463	18974	jxQVdU24BZ21zRcadP4qXuQYmQqqwFMugBuvLiBVQdbmt2YxDvJ	13710	19315	19315	1619415900000
27758	3NKRhYA3aMVfVWFcudrFVSKYttodopBKXxkv6VMoxoYRWupKLyff	27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	1407	1395	541	12463	18974	jxmJVxreTouSt3Jg6aQkB8Hr4NLcs7EGEiNH6peDFZEEkiqxvaN	13712	19317	19317	1619416260000
27725	3NLdPaFTwcTTo9U7JAk3Rwk5QWn8q47pEuLFFLNi7qufn2S95ynY	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1503	1277	540	12463	18974	jxMX9C3hfw6GdyFHRfnxtGPZ8pp9YVN4vx1hcMn6Dyors2kSMdk	13698	19294	19294	1619412120000
27729	3NKF4aXDWycrQTxgtkiy6PbJyK79ZnXtcS24SfFYPtiXaorbPufW	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1634	1331	540	12463	18974	jwBUNFaDbYfR3fBKXzmcDqZXUto7VpJCPMVSCPpwmynUmWUYNes	13698	19294	19294	1619412120000
27734	3NKceus2pFNtFFvNSnvtjg4N6s5zMZMP5FEsS6RqdkvuGfme7vgb	27733	3NLJ1ET6feDptgcu21EwcwpwizD3FmqFCKHXdgaWrvSuoBrvJNfi	1406	1393	540	12463	18974	jwYr1adWuoaUe56xUhmF9XMJJhaScVEn6hd1ZkGZEBgf3QyHJ5K	13701	19299	19299	1619413020000
27737	3NKQQQSgXBjfd5a2x7sufekxfUUqpkKVyUKX9tDv5f45vf1K66RG	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1440	1131	541	12463	18974	jwQF6F3Gz4HBZuVtcAKLrjYuzXAvEnrTu6hJxbdyaRSkLDAtHwv	13703	19301	19301	1619413380000
27739	3NKUpVPxEjjb25u5hKZYkKVn1YrGAsYZQTQWK3krKFpEgdBX2GNv	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1467	1130	541	12463	18974	jxxqRUQVahXymtmgx2Qu7sr75T8bqfmseg1Jahapm2bQmfZoH9w	13704	19302	19302	1619413560000
27751	3NKphQeJ7o9AgiKkYNr26jPaqWqve2Y8ucchJoGw9M9C5Ar8uiyp	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	606	1295	541	12463	18974	jx8km3D4FEt5EZPk3abr8epagzmRebzV5iVZi2cNQMgxbj9hgau	13709	19314	19314	1619415720000
27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1581	778	541	12463	18974	jxQHQt4QrT7LauXwxWphafUTM5cHvSUxFSt2AyMpcSkMwXJ8nh3	13709	19314	19314	1619415720000
27746	3NKGM5q6v3ghjoCJn44cueqTYLmDDB5NjiGKvG6uAd6x2Ge5SyKK	27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	1458	1197	541	12463	18974	jxUDg2rCN1vH2yrmXb9iwrTaDHMFmvcpnQWoSgsxhMptK4rcMeD	13707	19312	19312	1619415360000
27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	27747	3NLesd3tWwnE16YuBvwXzuF73F8vR45F6AqawKCXXPoDgrXHda6L	1600	1246	541	12463	18974	jxhzoYPRRBvmu1swxziBTjRqF2Tj4XjZgXPXn5gWd3PCgYAT1GN	13708	19313	19313	1619415540000
27755	3NLSDQiBDh3PAq2XshG1CT8dDvBiW6aHG9g1hiPrBCjvGVtYN6vw	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1590	1054	541	12463	18974	jxc4rw1USarmbR7s9qGLueBmTT4Nwy2CzskzUPvKmFn7HbhNA8D	13710	19315	19315	1619415900000
27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	1447	979	541	12463	18974	jwRYbnSGPKo7rL1u4a52eQxm8pssfHd4dk3n8w2FSaGwCQQaW4Z	13712	19317	19317	1619416260000
27759	3NLdu3W3GL61eL5pJ7BeFo9cgdCVnDnLCiV5iHp7BbJbhZ1NZojw	27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	1617	1288	541	12463	18974	jxRuRVvMHfqXSHRPy7C5AFyybXYaZLai9kkzs1Yma58A2kGsQaC	13713	19322	19322	1619417160000
27760	3NK5n6HaTzPkG3usV5d5K3GBE6U447uwd6g2pijT41WwKs3nHS2K	27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	1579	1023	541	12463	18974	jx1FBDRC2YHmoeN2KLyKJy2KWqubQfwAAh7KWpsp5DaBM3PQdEB	13713	19322	19322	1619417160000
27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	27759	3NLdu3W3GL61eL5pJ7BeFo9cgdCVnDnLCiV5iHp7BbJbhZ1NZojw	1406	1393	541	12463	18974	jxVr6h5P4BNDESTmmvd37r6fNxTf68bsZ5AnXe6yY92h9sabRVz	13714	19323	19323	1619417340000
27762	3NLn3qgg86oWSan3VWztpS58rEVPuMUsMRvnwnYwLzZnJkJYWSL5	27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	1506	1247	541	12463	18974	jxCvsiGvV5ej4g96n6ATJPyHxxiDnrosxDVRKQKWAEEstzDBwLM	13715	19324	19324	1619417520000
27763	3NLL6ZiVSH3ivcTWGjJCtR5emsGTqoJuYbEahcggnFVNKUvasPtk	27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	1506	1247	541	12463	18974	jwjisd77XYabmWPcWKbKrXqurknXqSiKkq3kRrtdV3NBomPepUL	13715	19324	19324	1619417520000
27764	3NKvUvjRMDh9VFLtXvC1AqfD5HKxkYJiwwu197S76Xaytc3gizwt	27762	3NLn3qgg86oWSan3VWztpS58rEVPuMUsMRvnwnYwLzZnJkJYWSL5	1637	816	541	12463	18974	jwt1SGV99FQn79R5dRYwhb1eoJ2D3Shsg4CXXCkgLPKToPXu35M	13716	19325	19325	1619417700000
27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	27764	3NKvUvjRMDh9VFLtXvC1AqfD5HKxkYJiwwu197S76Xaytc3gizwt	1467	1376	541	12463	18974	jxyvoxCh2mP7fFgnHKeendHmyKCGwPiW2zGTnBwionE23EFAHGD	13717	19326	19326	1619417880000
27766	3NL5MhtyWshF4T3fyMDvMRCV85gAqkXjJqZvX5fXCkwefLXGsSUm	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1406	1393	541	12463	18974	jxoj5rThtA5eucVAhcdHEzFhZuPxHZst4hMJoGW6GcMQ7aNuTeV	13718	19327	19327	1619418060000
27767	3NLZAzs9zbcvkkggMXstdW2zEN6LCnnMzXjAZtkVHxpVWP931BJ4	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1546	1213	541	12463	18974	jws4eW6tb8T7gfRqwNTiN1egxthnBt3GPw6DTxtWgSoUo8w8fg5	13718	19327	19327	1619418060000
27768	3NKeUU9rzsAop5Xs3kHFpNKG4zJBHw2bZSoMHgmXvqY4tWxTMJ3G	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1648	1158	541	12463	18974	jxij46UA72Z4FLWkYx4nwvK5DFNS78tW58R6Ntyab1QLu2DUJeV	13718	19327	19327	1619418060000
27769	3NKYRHKbG8UeD1L1zT1RxN4BmvhMUPxg4gdVna3Cs7XBYAFsEcsK	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1594	1326	541	12463	18974	jwSMpGsWB11b5L9Z2HkA1TV2BdV78HJXTuSA1fjxDRccuSqxDCb	13718	19327	19327	1619418060000
27770	3NKQjHaFhZhfyHx7yssNt2zMG1CskFRWB9tf4bBFH9VsnQ39SXTi	27769	3NKYRHKbG8UeD1L1zT1RxN4BmvhMUPxg4gdVna3Cs7XBYAFsEcsK	1649	1137	541	12463	18974	jwaDDHaYmY8FijRqPXF2wnkAd8LoNUCtDC8yfiMfKPspjo1VR9b	13719	19328	19328	1619418240000
27771	3NKURmxWR6g8zyjALfpE8DASMAu4UVbemDicwtNmV9Lhep8CwEof	27770	3NKQjHaFhZhfyHx7yssNt2zMG1CskFRWB9tf4bBFH9VsnQ39SXTi	1547	1132	541	12463	18974	jwRY91XYNkeTJUJSHC1RCqWvvznqiZZb9Jf296rv1NDk8xYXmL1	13720	19329	19329	1619418420000
27772	3NLKZu1x1D93aCbueHGgiEWbxo1a6qebNy8nDzujtD8psLRF1gNs	27771	3NKURmxWR6g8zyjALfpE8DASMAu4UVbemDicwtNmV9Lhep8CwEof	1508	1387	541	12463	18974	jwyQSCTp1zieWx6FySsUv8yL1dBfb3CcTHk3yhrCmcG2oCZRBsB	13721	19331	19331	1619418780000
27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	27772	3NLKZu1x1D93aCbueHGgiEWbxo1a6qebNy8nDzujtD8psLRF1gNs	1646	1108	541	12463	18974	jxF4bjhW7NdSjLFuuAR7mCwy7UbH5SewagzZhhJYLZ5dRMKE3uM	13722	19334	19334	1619419320000
27774	3NKAmPi986VwzXFdVSn6zzd7S23jBhjJ55nVBBUsPNpR3imGRkAb	27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	1439	1279	541	12463	18974	jwMVnHHkJfFeqfE6Bi9yZjXyQB9UR7XoHvbhBFkdpzPKEZhsbF9	13723	19335	19335	1619419500000
27775	3NKSQfRqshqugrzsV6poMHM5no5B42EeLK8Dr156KZ8g8RsQXFi1	27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	1637	816	541	12463	18974	jwT1YPuCuy3biMNrhQgg1595hz81xE5e5juBy5gnguDjrfmZ8Qd	13723	19335	19335	1619419500000
27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	27775	3NKSQfRqshqugrzsV6poMHM5no5B42EeLK8Dr156KZ8g8RsQXFi1	563	993	541	12463	18974	jwdvxGhg2Y35VDM5qSHKFzpx7pQ1p7PupXQ1ynNXe6wo2ZN8yrM	13724	19337	19337	1619419860000
27777	3NL2R4FVtxNZ5hDgqC6sySm5YPPPhgLUiBkmVvXz6rxLR1Ue3QxV	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	58	1035	541	12463	18974	jxoJByhCHZYfSDkqWjT3333qSD7jfPWxnjyvAhoHqoKpeGadBZQ	13725	19338	19338	1619420040000
27778	3NKdeofp4iF7ou5uS3cEBEacihu1UEm1SpUbsVoiE8Xpk8iEMCQ9	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	1407	1395	541	12463	18974	jwzuoHCd2PM9ATfNrM2sbqDev84stFYEqksL1UFKhSw4vqGaKJA	13725	19338	19338	1619420040000
27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	1549	1362	541	12463	18974	jwwpG22WwvjKojmtAsdE3FSDjoqPxd4qEdqZNknPtuADku16ugU	13725	19338	19338	1619420040000
27780	3NLZbZunBdsYEiHPqpvzByaNsR6MZC5w8Dkn9bZuEBcfHmu7fKES	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jxHf5bXYbRDQgRyTG8mqWtFVUxdXEVaAb6xnVngARasUCnokLY3	13726	19340	19340	1619420400000
27781	3NK6QFxABiouz9R45YXJvqgrFMNeweSLnzSFXGDpKFki2ujYkb1Y	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jxobzrbjS7HCg86AaP1iXj4ZdgDzZzrGN5qw1T9UNqQ9mkBPb5E	13726	19340	19340	1619420400000
27782	3NKxbsm2rAE8ejzps3sKBctEZToCN8h3QzsjniGmBNEypyjbmL1i	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jwbJgpf7Ek9r775ce3K2qi5P53JFoqaaHeBSLMkauGw52vS1QJ3	13726	19340	19340	1619420400000
27783	3NL1e3n2ztP9s3dZ1FGwBYpmzpRrw2bDcSAfNx85coexG1q4xXY2	27780	3NLZbZunBdsYEiHPqpvzByaNsR6MZC5w8Dkn9bZuEBcfHmu7fKES	1445	1290	542	12463	18974	jw7RZcALKSAd3wCZQhBAoXDFBh7S8Sk896oV7vBCubaoh1vKFEZ	13727	19343	19343	1619420940000
27784	3NK5F26XYoJKg6mtmRrRCZNptS83y4yRgbYqDkC797zEar34armV	27783	3NL1e3n2ztP9s3dZ1FGwBYpmzpRrw2bDcSAfNx85coexG1q4xXY2	633	1384	542	12463	18974	jwYpdTPNcrHPpBh3UYw2LbnFVmSVpGBf8CJeXRDfiUencEYDvok	13728	19345	19345	1619421300000
27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	27784	3NK5F26XYoJKg6mtmRrRCZNptS83y4yRgbYqDkC797zEar34armV	1406	1393	542	12463	18974	jwtNqwJ9XSdRu4tfrnDza4QYiDdaUSLQaAmtNYMQgHraC1KGPGt	13729	19347	19347	1619421660000
27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	1471	1020	542	12463	18974	jxmAd2ocH9Mm8T9NHCRxMHp92awmZnJ3s4Y5p8Kx5tz2wYFNVLj	13730	19348	19348	1619421840000
27787	3NL6gKdAiAGFfZ6nMkQSjJprRp4qxhT5GKaQME73sjE2CzJZdRBm	27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	1622	1230	542	12463	18974	jxN6e1o2cZP6JQiDv39u1EvseFRpbnsCRaLu3hKG4TnHQ7d7LYu	13731	19350	19350	1619422200000
27790	3NKMj8KernQX8zPPi9Kd2mHKtkS5QXX3Z6cFiNFHoKuc5q1d1zHn	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1536	1313	542	12463	18974	jxNqdQo7zwmWTSHS1S4z9UzrdDRhnCAtrtRskNrdqQBgtSBNCa8	13733	19352	19352	1619422560000
27793	3NK48M2z6WifsdgExFEM5Cd3v5WiTuesoC1YeTB5EPojmbZqj4a8	27790	3NKMj8KernQX8zPPi9Kd2mHKtkS5QXX3Z6cFiNFHoKuc5q1d1zHn	1501	1234	542	12463	18974	jwZ1EBsXbGCes4EaniCEztqufspZRFT1eE3ymh3uMjYih8ispnZ	13734	19353	19353	1619422740000
27797	3NLWiEMiTw4RnnEzhMJNpneD7EYag6QwLawPa5R5j3gWFHMZ4kjU	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1506	1373	542	12463	18974	jxNvPY4cLomHrm5MgBhE1qULivefXMyxmete85XEjn4kxNqPZb3	13736	19356	19356	1619423280000
27802	3NLQ9e4HZvCs3JcuXTHW7QBA3osFNSuTZmxtmeWBDBu5YUMi3s4i	27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	1489	1014	542	12463	18974	jwZDYHb5RRuVuh7iEfucZw2QrpCwq2qw3PtJ9npahi46tswqPNk	13738	19358	19358	1619423640000
27807	3NLVEZCFs799UuwDhbNVmMSUzRNCYqCpPRzcPVcUHAjPpZACecJ2	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jxNafLqvUXkLf8onMMWvDZakBowpS4t5RP24L1defestFthsnXw	13740	19362	19362	1619424360000
27811	3NKU6wdJenzAvXPAfXtczC2qJh8aNNTyr7Rvxf8vD262ECg3FfF5	27810	3NKQm1SaCuwHKVtNFJ7CxXX2wVhNeL6Px7KAwniRsD2AW6xvSAqx	1407	1395	542	12463	18974	jxMhZymXe3u7pfhrPSNMpnYqeTByH4RVsgjyJAFWXXNjsRC5s62	13742	19365	19365	1619424900000
27814	3NKDiaFjydwL7tmd7k148zBNKuqo3ZCW8aaiadov5FpdoBhmZxX6	27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	1599	1287	542	12463	18974	jwDc273dUL4NXYPZ69kSsj5ybQdypPQFaivx1LoDGMaVHJeJHSM	13745	19370	19370	1619425800000
27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	27816	3NL3XdTZq1SVFKnHp1kid5YqCgE9X4Dp9oni8kahTYbqwpMgB3Ug	1587	1231	543	12463	18974	jwuLTByUpLDeTP4vqq6cqmt5KSMR3FQfU3GjVeGFksX2DgX8KGC	13747	19372	19372	1619426160000
27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	27819	3NLsoeDSjBVJ8npYxDF7yCetbZ5engcpnpAf1GpZniyvKuU4Rw3o	1406	1393	543	12463	18974	jwdGFKWxsV1PvSR7bLYAEjiZoGURiQh73AtNL8hyr4cAfLhgxBH	13749	19374	19374	1619426520000
27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	1637	815	543	12463	18974	jwnm7pDUqAm7PnKbHDf8TTGwodfbhjes5dfxrkffUra86B3eAZ1	13751	19376	19376	1619426880000
27826	3NLU5NPpV81V2BmmjAGRUoC4kU8ozs1DUNDQSbDWknhh6PZZegnY	27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	1637	816	543	12463	18974	jwQPZ7zUnWvM3DEKojRj7Fn7y6auSCkkPo2d1JEdvqVAmNA7RqK	13752	19377	19377	1619427060000
27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	344	344	543	12463	18974	jxpjhqTvJS3PJvRLSfhrseCaTCzyrBDem1MKZdce3wYHkWZtKEx	13755	19383	19383	1619428140000
27831	3NKCCco66FQ4UXScWZfrGaMHy9bnTtwZ7DQ9XdMLbrJurXRdfTF8	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	1624	1208	543	12463	18974	jwi55BTntY9Rk1t1kJSsoNbMutYAYN5SJnNN6zEo6gFZT3jyM1y	13755	19383	19383	1619428140000
27832	3NKACDaFGNph7RL4GDEmpkZTJWR7RpSq1ytuX5baYJjhZ47y9ot2	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1598	543	543	12463	18974	jwKbumLWje7eNcNbKeyKND72UUmtfrCHvKH9j3edFKMihy8jBEw	13756	19384	19384	1619428320000
27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	27832	3NKACDaFGNph7RL4GDEmpkZTJWR7RpSq1ytuX5baYJjhZ47y9ot2	1403	824	543	12463	18974	jwVonpS2QTUZ5NCmW2mHG56QX5KupeHyjLp4vTXWEDmSRK8yHjp	13757	19385	19385	1619428500000
27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	27837	3NLAoYnWuRgQmnNatUEFANf7nmRgnV9b6Gob97s6DX8EDEtCvqbX	532	1303	543	12463	18974	jwNpzqCweKTrHgWHPMnDm89RSUko5AXNcC7WZruFPwqqaSp4G6W	13760	19389	19389	1619429220000
27840	3NKn9VPVSpWkLuhYUH7ew6jQzM4n3X2nGNFzJowSCUhW52HAmb6h	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	1646	1108	543	12463	18974	jx4cB45TiVodabTBGJSAVHj5JRYGRKhENPG5rxHyXLeziGrLeym	13761	19390	19390	1619429400000
27844	3NKaswkoyUSfWo9opiKFmGJNz3r5sGMAicHth8zi5zoUwtRVKYRG	27843	3NKJWNc8YrF8H9ZYp4mySkce4Jtr1UkHhhB4Ed8wy3GpLWXWgfMh	1581	778	543	12463	18974	jxTxc5Kbtpo6xiYGgUMHM8SJ5RqeU5dQreEneiUrABU6TXMwewT	13763	19395	19395	1619430300000
27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	1599	1041	543	12463	18974	jy3FN7J8bPT8j2d15qaKZemtFW41FMb5xEUWbApwCaGZVeqMohG	13768	19400	19400	1619431200000
27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	1403	824	544	12463	18974	jxJC9XyrKq6DBYyeaRSPX717pfA8L8DEhmZ1LswThcTMD8mThkw	13769	19402	19402	1619431560000
27859	3NLroXRe9JpCKQpsypg22wN9H2zdouu8wt4rMLZq4QJigUeDSJDE	27858	3NKgoHxUrnPPLnB7GrN74esidpyPNiHrB7GJqMQBEPCvU67Pzp7K	1407	1395	544	12463	18974	jwnKLnbERs3GQhN1eZezZifHWk4q85yVYK83SefyTd2FTb7cqzE	13771	19405	19405	1619432100000
27865	3NKHmgpzyqZSvbyqXzKbDAMDn2jWYfsRCXEAboRSQKxbQbgyFQWA	27864	3NKbGYDuqEk62KBc9PbqUn1gMQdqu5pXZMBgFe5sxzgfVzTHBUpc	1403	782	544	12463	18974	jxjY773BwrzxvhTj8bPEuVDd7abY44JwTWTz5SGzeRuF3s5ixjy	13776	19410	19410	1619433000000
27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1499	515	544	12463	18974	jx5MPYXY4ZAMuMZPG9c6a6kUQ6LaiQjpngrF2H9DQ5ZeQRtDHSx	13779	19414	19414	1619433720000
27871	3NKis9LVvg64XUvc2MA2dBYTEJk5qFU2FLMezdZ5AQPcbVHBntfF	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1560	925	542	12463	18974	jx3Dk2JWMzyMv3wDwHaugezRznvcPhQvwEm6MZFxCR5EnoZzC1C	13740	19414	19414	1619433720000
27873	3NKVw4iqceN8Gyiv3Eak7CXM2ZoLjJtDrRVvCTKC4H3yRdH73hzR	27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	1407	1395	544	12463	18974	jwGXhdEZRdXZBazkH5QiuukQeU7KxJmQRbCGZ2irQsWPi1J2D5F	13780	19415	19415	1619433900000
27874	3NKGCnpAeWVFPLj85KmD2aF1ufHcvhgMwQTVaB9zs7qapwPuVPKU	27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	1476	1245	544	12463	18974	jwpRjT76NA5TpFmiKbXqrL7q6rPVhhZgikA7VhzwnpsaZfRRGvT	13781	19416	19416	1619434080000
27877	3NL45uiauT6Bvoi1qvoq2LpDszKyRTFSALnuuApEjEgCLi8C62C5	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	1536	1313	544	12463	18974	jwaoYjpLtaAFvrDLTCGc43XKpEevZN3AcCDEjYUPudAtxjVoWwR	13783	19418	19418	1619434440000
27880	3NLoczdsF2Qk6541bZCsa2VTA8LWqM9At4W3TBa3Nd3VxfDh7xoM	27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	700	840	544	12463	18974	jxm63UREEz1f81HatyswZVp28Zz2rKTcNVZNa6jStNTHRKAWnjR	13784	19421	19421	1619434980000
27884	3NKtoVoZcXQr7ZG7uewcuwQ52YaQVCEKeYgtvXjxExCs5qKoKhhU	27883	3NLbNhZq1BfZTbY4cojFQgFwMjABhvQNnPzEShWxjCXkn8PX7eVk	1489	1380	544	12463	18974	jwzZvqupZ36raft9Zp6YQ6TWFzo36UqzW3CPgm9FexkaCgJeYms	13786	19425	19425	1619435700000
27887	3NLmF4XPSfcr5VkraT67nZYfBJNbarm6Q8Xcy6jLBx5cuMtoRU2u	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	544	12463	18974	jxEXDxtt9Xx7BoykUehGD1WBctvWm5nvHyJki8vTEXu5j5YqSUq	13789	19430	19430	1619436600000
27890	3NKfT8wFLh21277LNX4s7NzwJhR8jEmPEGyWJnLoamdfFCgTznbY	27889	3NLurDvvFqvgBoZm5dtPHwVgfb3RD5wL8NyuFd5TfQNStd9DVFoW	1406	1393	545	12463	18974	jxVARYGD5QVX56szkbDsv8ozydKqEscKg5eqnVtBb1dVzgYgAvZ	13790	19431	19431	1619436780000
27788	3NKaKU5V241GuGyEFaxofqGvFjbBLKpUC67ANurqJWQZXFo1vfXr	27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	1407	1395	542	12463	18974	jwAEiRGiSSWXN3kJCMQYVwtojn9hRSnywewdmGGPvj9Ns8se5iJ	13731	19350	19350	1619422200000
27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	27793	3NK48M2z6WifsdgExFEM5Cd3v5WiTuesoC1YeTB5EPojmbZqj4a8	1601	1388	542	12463	18974	jwiLeU8KPF9SFKaNsGTXBbj2F1MkUyM9GVrWWGbQSA9xXFjcLUh	13735	19355	19355	1619423100000
27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1506	1373	542	12463	18974	jwhqrXd44w1fHPfMsxEDTUA2p4Q4GhYkxhvhonzzq9J9ypXWacN	13736	19356	19356	1619423280000
27799	3NKAST5EPm3VrVwMvuozFaS4rPSpZiTuMgrq5vyQ4PVHvFaV6ASL	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1589	1286	542	12463	18974	jwACn3vxeCBBzPTC1QfGTq61aS2dcpHD3trBdP8g74Bkt9oCnEc	13737	19357	19357	1619423460000
27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	1534	951	542	12463	18974	jwq6b5Laq4LbiYP8Bu1TtvY29QXCqEbwebswfLQdmAJyiNHU8Yv	13738	19358	19358	1619423640000
27805	3NLGT3op2BSE56j5aHZAgKMJZu3TXXBNrcMsDJ3WeXkV1gDEpFLS	27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	1601	1142	542	12463	18974	jwQwVwAXaKqJX8gdzvwxgwAdsF81DzuzybMU5X7yEk1HycRrLZZ	13739	19360	19360	1619424000000
27806	3NKXxZejBJdGPbVDZQ5bjHyBNHDXPFeMgDrEpUp8TL3w7y5yi1GE	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jxWSCNDEXkx1eGrkJ2Chxz56M95NkDwMbRBVxnzENqVynZNBJYz	13740	19362	19362	1619424360000
27809	3NKuf6hE5WRnz5nbK1yzwpgZSzsdfVSMhcYkALcLcxp8Vd3euNgt	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1476	1125	542	12463	18974	jwyVjWzaJ2tJu5XYUwdXG15RmHKzjtiKaRiwpsZSukyXtugPzrY	13740	19362	19362	1619424360000
27812	3NLA6ftCgWznGwwhXPhbNL8Qfgagnkvvu3zKfon95dnBJffAzqDn	27811	3NKU6wdJenzAvXPAfXtczC2qJh8aNNTyr7Rvxf8vD262ECg3FfF5	1534	1071	542	12463	18974	jwS5cgVvDR6DYdf8sqwQJzks5xYiD6hqBK622VDczaWxtTGeNwV	13743	19367	19367	1619425260000
27818	3NLpQ6qPm5vfk5QyJ5rsv6STbAzdk1EVTK6zKyDc6hwaa7YZT48B	27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	641	641	543	12463	18974	jwt3yevhbVzakJsoegoeL5J9azYP3VqcZAAYqn2ewe5ubMFCeya	13748	19373	19373	1619426340000
27821	3NKL3FjJavsBGN4M9N1TufzeQzzoyLxY8KtLszvzqRqoc6gB4LXv	27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	1555	1347	543	12463	18974	jwyE4mnKnAnhH7DyzM6JdBxskdT5Mhyy98K3LKhNbRyt8R8Cwj4	13750	19375	19375	1619426700000
27824	3NL4Z6VDKRyohRQUqFKGRNZTQu1uwv4TDcC2S8EmT5gNwErsbbrD	27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	1650	1375	543	12463	18974	jxW9LEMRyazJArBAm8oVas9C3bbM2epUoxju4PZ9MpcSTPxHPPw	13751	19376	19376	1619426880000
27827	3NLBMX1M72TKX6CqyNNFVna16amoye6wRYoWuP7QjBCg6Edm7iz1	27826	3NLU5NPpV81V2BmmjAGRUoC4kU8ozs1DUNDQSbDWknhh6PZZegnY	1406	1393	543	12463	18974	jxStvdym5BqWhvymyUTf8J9Ga1JNqiW2KX4cTJQ1Net1GMuHNAc	13753	19378	19378	1619427240000
27834	3NKq3yzp9MYgNsF7kBj5PSUaSe4dXdcWKQrb8ovVHR4Wj7wY4hir	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1541	1172	543	12463	18974	jwqaH3DG8v5tjtN8WockXT8qA1NuBQdgFEA7Aet1SfpBguZrUJo	13756	19384	19384	1619428320000
27836	3NKeSGcgDEBF9pgG8pNJ4dYz3dJK9sbfnuxGeTTCW6nQ6RqeXFSS	27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	1406	1393	543	12463	18974	jwdyMWJrUvwrYPtZULpHnBTohUxmGrXqM6E2VmwZiGERY8YLF4J	13758	19386	19386	1619428680000
27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	1402	874	543	12463	18974	jxn7HRKETcYdDx5VMwoSnU6y5ZPYLcLZ5EXTVw2EiEUkThsps8i	13761	19390	19390	1619429400000
27841	3NKHSP1dwXMZA97XPzd2YhEPdVR7TZr2QmxfqTKDf2uhXgLKefLX	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	44	959	543	12463	18974	jwiBrbbfxFHVQEyS1ootexxTUjdPaTKud8GCvUdKqbj2AgoARSy	13761	19390	19390	1619429400000
27842	3NKxCekCoJ2kkYqpJnUdMsqYqDTBSU8ezQhVp3otxYAhC3AaAG8d	27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	1402	874	543	12463	18974	jxXVArLcufUFr8zADHUBsNeyju4T15m4E7XbrcihMmpwj6aCK4f	13762	19393	19393	1619429940000
27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	27844	3NKaswkoyUSfWo9opiKFmGJNz3r5sGMAicHth8zi5zoUwtRVKYRG	1624	1088	543	12463	18974	jxwvWh9hHcCXMmsAxg7QHm2QiqQwaeU8tAzV5ZnoioZDgm5W2ac	13764	19396	19396	1619430480000
27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1406	1393	543	12463	18974	jwycMFTCTnhEDNCyRTppabE4taBY58tbDSXJXHhJgvKQtz6Yvx6	13765	19397	19397	1619430660000
27848	3NKHQQNSeN8JgEZbE7Las4AwzV9tCAnnqov6oacQtN5SyQm9V4Xp	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1551	437	543	12463	18974	jxjzMR3PL5w3TkgespDq6PTvBNJtiQgVKu58z52828ADaAXJoLt	13765	19397	19397	1619430660000
27850	3NLhjXoxYMabAARuABcTmcJNMV86CJn6Xi4PcWGXvqJbUegxtbmN	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwthUVcwswwRjUscJ4XZjBDBx9q9HZWeHnJdWyGijhGeRASf2ay	13766	19398	19398	1619430840000
27851	3NLHK4WsaQ3Swi3EgYSAMQbdftAU8uoMbLSfU88pVQ8XSGDz3zZp	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwUMMVa4FbaBZCTVg8gLRZpQ6PVJfP2aQAeaMNmZxeKDhK4Z9oT	13766	19398	19398	1619430840000
27854	3NLYegadXuSqRLjtTAeYuXnpfTpRnpwx5fjapeM18NwaRjQU53XQ	27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	1599	1041	543	12463	18974	jy3FN7J8bPT8j2d15qaKZemtFW41FMb5xEUWbApwCaGZVeqMohG	13768	19400	19400	1619431200000
27857	3NL3SGuNdcssGksSwveiBUmihaQRzWfs6zqLEs1hBA1EbNKhCJfg	27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	1406	1393	544	12463	18974	jxXVqaSHoRwmoc3krMzpWCcqG48rNG78ceHWL7cnVeihx8xVY8R	13770	19403	19403	1619431740000
27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	27859	3NLroXRe9JpCKQpsypg22wN9H2zdouu8wt4rMLZq4QJigUeDSJDE	1406	1393	544	12463	18974	jwG7pm5fsd6389K8goM8XPtjRfpAVEgyc3FNf4sWuNqgMbfSp6D	13772	19406	19406	1619432280000
27862	3NLwfjcnpkv3RiyCYCsCcdsoQMYg72kwbZWXpj3frAESMUbi19dy	27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	1407	1395	544	12463	18974	jxacK2NQ2AGWkEFzX6TFSo7R5Nz7HffVt1MEZDQA8pvu693dQPo	13773	19407	19407	1619432460000
27863	3NL35N2dXkYSZSvSiHxFQXu6D6PiKx1BhVTVw58UisRmACXPgHod	27861	3NLZTjKPNSFXaTvthmbbCnPuuYsP1TQCwgohPx9TL2VZgNrmcTwA	1407	1395	544	12463	18974	jxBmAfgBVqSKAM1xKgk4LcTNBtPdPihR1aQNgM7Dq1QnMSAkPGx	13774	19408	19408	1619432640000
27866	3NLGdWAKeCXSCpHWYHsJtaw2g8t2uDmGTGPTrq3pbKDuRWP9JnFv	27865	3NKHmgpzyqZSvbyqXzKbDAMDn2jWYfsRCXEAboRSQKxbQbgyFQWA	1406	1393	544	12463	18974	jwB71AbLT4vzwbN6cVqi3rPcJy5YrM7LC2VsLGdUeYiQBn56SGJ	13777	19412	19412	1619433360000
27869	3NKZYJqjFD6L1dHky52t18iZvA8TPwFsU827KxZnQ1YWdb2Fp9NC	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1647	1056	544	12463	18974	jx5nCeHghAbPPx4PhK9eZvuQMQ9HPGrmA4g1WB3wRhdxyGUqsCS	13779	19414	19414	1619433720000
27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	1622	1230	544	12463	18974	jwK4Lc634psvidNqnCYnTK1QLETnqHVkaunVq9G1oUVteimUtvs	13780	19415	19415	1619433900000
27875	3NL5igrMxismx4itCpmJLtw7jR1kQ61NqUbz6XyDsrdFn945uiSr	27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	149	1283	544	12463	18974	jwAHhUHTjiC8ojiTsqPxyxsJQ5N6yW6XqACBwTu3TyWZDt25Dsq	13781	19416	19416	1619434080000
27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	27788	3NKaKU5V241GuGyEFaxofqGvFjbBLKpUC67ANurqJWQZXFo1vfXr	1406	1393	542	12463	18974	jxdbpiwdkmaaiaaRANQDtUSKfuxiT1pKTDTpBkmtdrcpnpAeZLU	13732	19351	19351	1619422380000
27791	3NL3dxVwdNjtHzU6G86aGaYumq64zUL1Y8GiuTCHz5mdutGyarrQ	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1407	1395	542	12463	18974	jwiZQW5TDGwR3CQuBvK19oTgYUKmciw8gEPBGX8CQTdy798bcL7	13733	19352	19352	1619422560000
27792	3NLgKroAk2i951aXtGxT287o7HVKrZdkoVrE4Ttoc9wx4V1EJZeY	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1581	778	542	12463	18974	jwJgj94Ac3cwAKxNxiovRBUUurpq7WT8BvN7F57n2o8WJc8GNF2	13733	19352	19352	1619422560000
27795	3NLTa9aBEaysjthHQ3WfuwnyFbA2hGsZ6Ep6W2UqNgLbRqpm9HTf	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1474	1083	542	12463	18974	jxz7dhb3yos8FjESJhV2r7LmTpxpCwyC44nGpsTwkfBbe3CXfQY	13736	19356	19356	1619423280000
27798	3NKVsU1VY1F1p8Fx56NQGtQ2koTLiUb75XaW2Agig5nG3a3fnwaD	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1675	976	542	12463	18974	jwH6Gm1YuouxSPc8rVtKxxGr6r3U2tQSJ2SuavHzEmiHGvfnKEt	13737	19357	19357	1619423460000
27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1587	1357	542	12463	18974	jwzovt7aFF5Ud3gnxP3eEBefknhEU8k5diEHRLpXiKWyKUWX9cF	13737	19357	19357	1619423460000
27801	3NKnV9d6c2Yt42EHufcjiU4tnqxK7ZgNoVkSjKoVHSXARG1UTEgz	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1611	1095	542	12463	18974	jwYZaRiV72AXjpUVoVBZgXDvzZyR6QsMpLjha4eZBe3PpQBtzmr	13737	19357	19357	1619423460000
27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	1637	815	542	12463	18974	jwATMWUzkm5b9iH8rsAHci7x7JdB1ZL4Rn2ba6C15DzoFmzDd5q	13739	19360	19360	1619424000000
27808	3NK32f2hzshV3JJNsU8eGAL1MQt4bt2zzyKzhmQ1QzmY9Xh4thAG	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jwVekxxRxLCZTaCA75fMhdHhfWEbDM2qeUMb6vtG8mjw4d7rKiY	13740	19362	19362	1619424360000
27810	3NKQm1SaCuwHKVtNFJ7CxXX2wVhNeL6Px7KAwniRsD2AW6xvSAqx	27808	3NK32f2hzshV3JJNsU8eGAL1MQt4bt2zzyKzhmQ1QzmY9Xh4thAG	1403	782	542	12463	18974	jxC2mUe7rjHkSgcKEDkVBBPoVtqmrWVKGFXJyP5fheGJTopuJb3	13741	19364	19364	1619424720000
27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	27812	3NLA6ftCgWznGwwhXPhbNL8Qfgagnkvvu3zKfon95dnBJffAzqDn	1581	778	542	12463	18974	jxLfCjuLPYCa5YjGvFoqo72oHTVAuKTg9RbMzAatJtvSKyYuX1i	13744	19368	19368	1619425440000
27815	3NK5dAce49am1iBW65SEtJkwidxnbHoxbQSJxnmBeUu8jeziTFHs	27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	1577	1327	542	12463	18974	jwn4LdotUWmELUhugCdg2hmz5Er6f3mttGroK71yzZD5Wj7gqqS	13745	19370	19370	1619425800000
27816	3NL3XdTZq1SVFKnHp1kid5YqCgE9X4Dp9oni8kahTYbqwpMgB3Ug	27814	3NKDiaFjydwL7tmd7k148zBNKuqo3ZCW8aaiadov5FpdoBhmZxX6	1647	1302	542	12463	18974	jwsHFKzGBsFThMi3WUmVB7rQWcHBifRAccZ8pzg34vNaA2FRyWd	13746	19371	19371	1619425980000
27819	3NLsoeDSjBVJ8npYxDF7yCetbZ5engcpnpAf1GpZniyvKuU4Rw3o	27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	1623	830	543	12463	18974	jwRqfgewoUJxN1pkcf6DYzwRaDiHz2Jwjg7mwS45vbrW77NXo6N	13748	19373	19373	1619426340000
27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	1522	1322	543	12463	18974	jwmviUdhevkXF6keWMcvnWWEn8NDNmWFm27cDmoETMevAsVTT7H	13750	19375	19375	1619426700000
27825	3NLGakQH4YzZw8Rq4KGaiaxtkc3cdF8kZazUiDsVkwUorgMtKfg7	27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	1600	1246	543	12463	18974	jxSv5QBtqAtoH9Sv3HqowqYSxAkdLdXPrSHs7GTZJFY889gTDFB	13752	19377	19377	1619427060000
27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	27827	3NLBMX1M72TKX6CqyNNFVna16amoye6wRYoWuP7QjBCg6Edm7iz1	1483	504	543	12463	18974	jxN4Jt88kU3oLUhjdFi6qzYUQrLkVNW6ygQtEGLe3sanT5kW32o	13754	19379	19379	1619427420000
27830	3NKLSriDiX24fFceQrHcF4AXCaR9mMgCpJ5SoLCCgjtaDMoaXNyx	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	1637	816	543	12463	18974	jxpbL7GbG4YDumRBZ6Go2GNfxY84WkB2cKXff1dGxqRS1z8kLou	13755	19383	19383	1619428140000
27833	3NL3cd21iuDoKqQ7K62kkGBNpq9hzFSKuP3JR6ggCVX95xEHNN8U	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1541	1172	543	12463	18974	jxf9agLQs3Q5xCgg6bKd2YeQfZXn3CUtEcwLxsAGc4iAbqMNrK3	13756	19384	19384	1619428320000
27837	3NLAoYnWuRgQmnNatUEFANf7nmRgnV9b6Gob97s6DX8EDEtCvqbX	27836	3NKeSGcgDEBF9pgG8pNJ4dYz3dJK9sbfnuxGeTTCW6nQ6RqeXFSS	1623	830	543	12463	18974	jwV9AuiujcnJzDa2SSyXUa35dn97dkKLqZmfjVhNRP5gwCZQPwA	13759	19387	19387	1619428860000
27843	3NKJWNc8YrF8H9ZYp4mySkce4Jtr1UkHhhB4Ed8wy3GpLWXWgfMh	27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	1406	1393	543	12463	18974	jxR2aoh8nNiuJitUuy7QzkZpbrUoSNTjjFJUcFbV3cRX2vmEEUB	13762	19393	19393	1619429940000
27846	3NKx4xszujQh16tpQNte8bxccuKm39uHWU1CtEk7YnTTrQG3pasM	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1407	1395	543	12463	18974	jwtmLHJ2A8FNM4TrmUvBHxftN5fHPW3RViFJjnZUM5hS7v6fbtf	13765	19397	19397	1619430660000
27849	3NL3ZuUay7FaFyr13LJnyJ9czTHu8dqSPUzx11QzXReBE6St1SPr	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwhGnqihXkojQnCJTTTdzzTgYsAfXZchwCHHqR4w94RLo2AuRne	13766	19398	19398	1619430840000
27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	27851	3NLHK4WsaQ3Swi3EgYSAMQbdftAU8uoMbLSfU88pVQ8XSGDz3zZp	1672	1285	543	12463	18974	jxYHdFQ8BLxbXeVKTfRNKRESzGe1a7JuNC6QLc28yfGUc4uNwwe	13767	19399	19399	1619431020000
27855	3NL7uCjzz5wHqcEkX5B4WH623SZVQWWhVTstjSy1MxMRYPxLDE3L	27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	1460	440	544	12463	18974	jw6dmURZ8un7r7DVmvx87F7XVreuc7TRJ3ewXZiCtYEHsArjaHU	13769	19402	19402	1619431560000
27858	3NKgoHxUrnPPLnB7GrN74esidpyPNiHrB7GJqMQBEPCvU67Pzp7K	27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	1403	786	544	12463	18974	jwTVbimHkzTQZarZGeqhAjdH1Bqa7DFzpaEQQsWX9hT5G3t4WSa	13770	19403	19403	1619431740000
27861	3NLZTjKPNSFXaTvthmbbCnPuuYsP1TQCwgohPx9TL2VZgNrmcTwA	27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	1610	1188	544	12463	18974	jwaVv3zgY6WkSKfPoLUsV1Wg8ZV7fMMCrAqdtVWhVv1WvLR6WzG	13773	19407	19407	1619432460000
27864	3NKbGYDuqEk62KBc9PbqUn1gMQdqu5pXZMBgFe5sxzgfVzTHBUpc	27863	3NL35N2dXkYSZSvSiHxFQXu6D6PiKx1BhVTVw58UisRmACXPgHod	1623	830	544	12463	18974	jwXjmnvfFBk7mN8Thgyti5uzwTrP1BRGqiJhnHU6b4CsbN1wgrR	13775	19409	19409	1619432820000
27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	27866	3NLGdWAKeCXSCpHWYHsJtaw2g8t2uDmGTGPTrq3pbKDuRWP9JnFv	1536	1313	544	12463	18974	jx822MZyiDoY7uigp94bpdhmRUNL9RhyKCh6NxQiaURvDt1XjGb	13778	19413	19413	1619433540000
27870	3NLxDNabviqikNbtecEsX1AooSezv4ctEKgr9dDcqGLJNsaWtR2a	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1560	925	544	12463	18974	jx1JcHWvPk6rVqid8PqpNHHBTUkPkNMmsPqdnRaLCAEa9JMkoGo	13779	19414	19414	1619433720000
27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	27875	3NL5igrMxismx4itCpmJLtw7jR1kQ61NqUbz6XyDsrdFn945uiSr	1611	1341	544	12463	18974	jy2GpPSfY9aRYCnyUrJbkVeaMhAhFDi21DYrF8DBiiVTuFxf4PT	13782	19417	19417	1619434260000
27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	1406	1393	544	12463	18974	jxRvZoZ9uTYd5tK5grQAWY4WbEZfujYph1KuzrAmwWA4iV9fJvk	13783	19418	19418	1619434440000
27879	3NK6AVaet9LjUM9pPmco26GKgu6267a6y8q4rbzwCcpcrvzoJrKL	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	684	1106	544	12463	18974	jxfzAuNFFwM5sxMzaavN4U5pV95ZXVtdqYbLtmA56wTvePup7BB	13783	19418	19418	1619434440000
27881	3NK5wjZ9ENsxoQXyiqL1Ecuf3PqNbJnYwQ64U5cL9xwJGPdnKk4m	27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	1513	1133	544	12463	18974	jwcJQoaNWY8THY4HukPD4TdPzUh4HoHJC7mVXLqSjdYdVXHSs2f	13784	19421	19421	1619434980000
27883	3NLbNhZq1BfZTbY4cojFQgFwMjABhvQNnPzEShWxjCXkn8PX7eVk	27881	3NK5wjZ9ENsxoQXyiqL1Ecuf3PqNbJnYwQ64U5cL9xwJGPdnKk4m	1654	1094	544	12463	18974	jwXJBTVA9YDr2thwm1uTPASfUDzcuiTAH1GW8RSwhWUHoV7rj2p	13785	19422	19422	1619435160000
27885	3NKE4m9MPFZnH6CwNGauPiDPtSZ5dbi2aQg8tYigjryT9jXJ7qWD	27884	3NKtoVoZcXQr7ZG7uewcuwQ52YaQVCEKeYgtvXjxExCs5qKoKhhU	1406	1393	544	12463	18974	jwb4Fpjot2xZkKAgNPaa2weNaKVjADwuN2twrgBHV21Eunu1QHH	13787	19426	19426	1619435880000
27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	27890	3NKfT8wFLh21277LNX4s7NzwJhR8jEmPEGyWJnLoamdfFCgTznbY	1406	1393	545	12463	18974	jwXKk9Q9i5fYFLqwQfG78Rvg6rVJ3vkA9T1fuh7SEqWHesY8iG8	13791	19432	19432	1619436960000
27893	3NKqXfbnBgzNuVzspZDKXEzTjLJH34F5ZgzLsU8YXkHiWgTYuemz	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1602	1003	545	12463	18974	jwihBAs7TtF4C3Q8sDauNPprfSnqTTnufh8xavuSXZQ3RirrLyA	13792	19433	19433	1619437140000
27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	1673	1368	545	12463	18974	jwS1yhD8HFUdyiRoLjuBV6x76WRptPDbLUWg4ELaZ6G6DdMTnQU	13793	19435	19435	1619437500000
27900	3NLnJuykYEU94sQFXL23nAnsJkrwhaeTY5aX6V66yyzX4sZqzNn3	27899	3NLmtJXjA3YsyL7BPQNShxdPurTCkKar7FKZk94DtEBLHjpKBv4J	149	1037	545	12463	18974	jwDHAZCn6mGeShvTaXTXfi8mKa2VngVtCzvUwGEGwv5VfkT5jFi	13795	19437	19437	1619437860000
27903	3NKj9G3kb76cRvDmYvNPhkN5V9AEELDyZGSzgP7FaKWgYQ4f17cd	27902	3NKSSHjYn1LxdfmcJNJDPsqX73Z57jFciK3rMsCUYqepcar3XRsR	1672	1285	545	12463	18974	jwQUMPe6Gm88qz3Hm1aRcNJRWNDH3EjAbMwZZfHX5RKxd69TrtD	13798	19441	19441	1619438580000
27906	3NKyBee6sDUcZEnXYgbY1Y5Ux7fpHtANfQ9nVpNHgKKvzqdvJ8Jj	27905	3NK9WaUBZdtLHeRerszx7oVtQfJHkiWD1LMTJ6hoxnQdrpdsgB5u	1619	1275	545	12463	18974	jxuhLTZBSRAgJH4braJBroXD5MXxjYBcKZDRhsYdwhfVcsB4RYm	13801	19448	19448	1619439840000
27912	3NLyQdiCtvTTKUadBRZy6X7EHCF3kwWEESFhGpBVWosX2gBptGBz	27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	484	1319	545	12463	18974	jxu9mb5xepPkiDCr3sMt2RfFVbpbuLXRKzEVZGZHgYo6vURCFVp	13804	19453	19453	1619440740000
27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	1634	1085	545	12463	18974	jxtStKc2dzYpSTsarkpKkExEYzriQHAxeu7STcwspJhtQ6M387t	13807	19457	19457	1619441460000
27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	1609	1333	546	12463	18974	jxzbca7etCZBEpWRsY8VjQogHuWFoWGivKk2zanYJd62RTAgdCD	13808	19458	19458	1619441640000
27920	3NKoxRSQX3iK8QTzvtZb95wLhs5iTAjSQSBi1eiwTBgErkCup6sb	27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	532	1177	546	12463	18974	jx6WRoj9fdLgT2LbX1K2j6aDYbewFRff5weeQxrVscb2Bv3EJuF	13809	19459	19459	1619441820000
27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	27919	3NLU78DeZcpYToMXhEdQaoUogMwJCszVHsp1N2xc8iKdrJVnwZWT	1581	778	546	12463	18974	jwGVFhYxkEB5E6wsTCdGNph1BKxHZbso3ozVLFnEkqfwWhBFbwP	13810	19460	19460	1619442000000
27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	27922	3NLbPfdNJa3Rr26sYfnPjGMg8B9DnMdVyx6Bh4T4ncU55ueVtH77	1513	1253	546	12463	18974	jxCj11TuMThqCFNAbnveUCc4KDTu8LX724ySye9AYradtsvaf5M	13812	19462	19462	1619442360000
27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	27925	3NKuJ8Cmand1Bf6mgnX2SotjvQhzn5mYENumrWVx3gkr4zTQFPxG	1672	1285	546	12463	18974	jxco9hUQntkLYs2TcRdVzgKnqZXRoBXwSkAfKLEbqsE8KZmBwKN	13814	19464	19464	1619442720000
27930	3NLwqH6B6cBWrJbhopuvYREx1w9AsiMuPbVLg19XR3beMX2utwHe	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1541	1298	546	12463	18974	jwekMNnsRQzoTzuqNKfBNmHkJxeyzsi2bYcwX4ij4YMyPbiUNE6	13815	19465	19465	1619442900000
27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	1578	1170	546	12463	18974	jwACDF5VqaUikKWDPW8r6vUaSgFMqS8aj8qebMHxB3YG2sAXiMd	13817	19469	19469	1619443620000
27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	27934	3NLZrPiSkf2hb46J2aT9FfdWKUSoJQut2isozCNYEP3sq6SG7ekk	1406	1393	546	12463	18974	jxovD2ZZhY9zvFZ3DM7Jjna2m2QJ66nLuNeCNYGx9SmGe1ythVU	13819	19473	19473	1619444340000
27938	3NLS1Ae81psoy3xK2CAssrpnD4ptXe4n9y1tFKUviRHHMkze9nkz	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	44	1325	546	12463	18974	jwBdyg2tSJ4XgkXi7q9hfhy58o96ExUnuNtxz3YPEY4hq1xM2Qb	13820	19474	19474	1619444520000
27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	27941	3NL3diNeXvVnq5pBPZgb1TUksJGPaYSDST4AqipYojJ8jGWbyqqL	1627	1259	546	12463	18974	jxF4EDxi21qoeh31kEK7zSXKoHKeFZSCYe21yC1Y8CgxD1tctoB	13823	19478	19478	1619445240000
27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1407	1395	546	12463	18974	jws7dwew437YcB5z4kmc3p42MMACkcXVmuPVetEA4JF9dF15NAN	13825	19482	19482	1619445960000
27948	3NLCxSE44LEbsPFxuRtKBc49pLesL872XDmcJBPH7NKgppCmFCLy	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1673	1368	546	12463	18974	jw7qQjExzcLTFWTEmU3pWePoDqf9RWxStLQgsjbfxKPwM82bEnZ	13826	19484	19484	1619446320000
27951	3NKs5c7YogBNSCbXRu6uGrauxqN5tUxKSjL5dbK83MYxts34gspp	27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	1555	981	547	12463	18974	jwfPsLyjk2TjKiDSGfMMeaEZUwPBJ2kCJpXFN27KYV5YRqfG2tL	13828	19486	19486	1619446680000
27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	1637	816	547	12463	18974	jwjdCyXCQ3dZ2EjfGjT74SqhdYsmpKF2pm6FERDtekyP6SC9h7Z	13829	19488	19488	1619447040000
27957	3NKdw6PXhERsRmRXkZsVa3rMLQYzkkeGsBn9ky34xCLWKVHbzY4T	27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	1483	1150	547	12463	18974	jwgxuipMoAFegijK8hAxPJZ8FCUbw54SUrDTmijQFju82Mgcsok	13831	19491	19491	1619447580000
27960	3NKkgLPiAMWkVxHwm9svE4SDcftgAuZPhuMB4ziAi9iYf1mJjrnu	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwgu2NCFw7YvrjHAme2CMr7rasCmZJ89mJPurQkSmyFwdu2QUNs	13832	19493	19493	1619447940000
27963	3NLmV6iazh6zfCP3dRkgmmcyZYJgswdEt5S5mwStgyhRL6rr4sug	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1581	778	547	12463	18974	jxUCtBFgTonNvctiLUFPykgTYogm9kKWQ1aEc7eFj99MfSaYs93	13832	19493	19493	1619447940000
27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	27965	3NKJaaVCQvYdffjLvxzNuLJP1ovHkpPGNSwDvmTCt4tDtGTzaxDA	529	529	547	12463	18974	jxieVYDddzYUD1JANBHyjrgJVLYHmJYNz3GJFfefm2K4cFW1DAB	13834	19498	19498	1619448840000
27969	3NKeA3oCDGhvfdRikBceD3MBkZLWShPsDJuHjFyJ4jTKzSKsxKp9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1407	1395	547	12463	18974	jxviK7oBp4xLG6NUvzEni1GWr72QtwUMR7XoB1kZAV95EsGoYzU	13835	19501	19501	1619449380000
27972	3NLZ73t7t7iBouaz5PWjaYuh6GTomCGRp29BfBNh7QuYDRhZoZb9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1439	1279	547	12463	18974	jwVfPrchqDZkA3Yggv1X21fKb5nUSqovycgYK1Ng4ki1VLnjtqU	13835	19501	19501	1619449380000
27882	3NL6zgiStznpxKTxconX5S9YLvzkznaJ5iifh9UpoBv6QT6EbMuJ	27567	3NLEEfFZRJdtdC6Takha6pjqRSTubzgCJqycqnkB3oRxnwnQhWx6	1654	1094	537	12463	18974	jwDoDzGFdA9FTJzSPa7y914q5JZd71dNxTcFHZNNwC2ppNQDLs6	13626	19422	19422	1619435160000
27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	27885	3NKE4m9MPFZnH6CwNGauPiDPtSZ5dbi2aQg8tYigjryT9jXJ7qWD	1407	1395	544	12463	18974	jxfX4145fB4kSNkSaUSSfw6kmpdxYLobFjzEVHr2WagRKixTunY	13788	19429	19429	1619436420000
27888	3NKXyxVqNPL7oP3oGwqQecPhFTL7bRoS8a2g1vjsiwkHDokx2Pdp	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	545	12463	18974	jwe9amUVFS3njVZF85Ayr5LwRURsWnUaA6PMT1Ri3P5oGgV4PnH	13789	19430	19430	1619436600000
27889	3NLurDvvFqvgBoZm5dtPHwVgfb3RD5wL8NyuFd5TfQNStd9DVFoW	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	544	12463	18974	jwACccACe9YDDnbE2FBYTKiVP62LVwbsyNDgqB9HRzhVfDoMkmT	13789	19430	19430	1619436600000
27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1407	1395	545	12463	18974	jwaBbCo8kMf8MGH4nNijes4mqjNcL8drcXvGpH4uLPEFXXV2Kou	13792	19433	19433	1619437140000
27894	3NLVXtWtcDjvwFgjcyAUJ6pbavHi9XNjFgXdaZUJBMqdDz4dLpuw	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1571	969	545	12463	18974	jx2FTq1xeW9LwGJYH3hrPXEbqpkiWmf7MDavajJk6f7qRABzjRW	13792	19433	19433	1619437140000
27895	3NLr1dt5hFivvnkRsKXnUjhCxzjpT5VdVJZUuNUbDP1tBPf3huQP	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	1406	1393	545	12463	18974	jxZsJGxiYTXxrLHu8jkRzkyn8G2WkvH4LRiVPg8Jj34LufLf9Bd	13793	19435	19435	1619437500000
27898	3NLfxPGEr2LjUVugUWyQCLhsZDLoHyvEU3sJ42mEp61w3NBNfvjX	27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	1406	1393	545	12463	18974	jxzSEwv7Mq4jx41SjRPXQ4gcWr4DxJRWxV2isFYSYWbZh42fdEY	13794	19436	19436	1619437680000
27901	3NKb65e9YEcvvFdGSDWHWzt1KmjWfDmovnxrmQCFkFirKgjB7kSb	27900	3NLnJuykYEU94sQFXL23nAnsJkrwhaeTY5aX6V66yyzX4sZqzNn3	1406	1393	545	12463	18974	jwPm9E59yGsTDDbUMhpgQiBAF5GbrThhPjfz3zLmFCpSHbo6MWC	13796	19439	19439	1619438220000
27904	3NKVhGiUce8y9sZjvcrnGToaREa1fYw86hPSuWgcrttWXMmYDUVK	27903	3NKj9G3kb76cRvDmYvNPhkN5V9AEELDyZGSzgP7FaKWgYQ4f17cd	1589	1160	545	12463	18974	jxHyJDWYUUsqKiNwGTxBeuEC6katLZKvmmeyCPUiAcaAVATDvES	13799	19442	19442	1619438760000
27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	27906	3NKyBee6sDUcZEnXYgbY1Y5Ux7fpHtANfQ9nVpNHgKKvzqdvJ8Jj	58	1035	545	12463	18974	jwQXAQJYWJyLDKSmtQF6RDTesZS85muE4ShXYDmasHZLqa5jfAn	13802	19450	19450	1619440200000
27909	3NKDsqAMqa8yfuvM6EaztENtMGKqMAVNHX1FzE1u1R2YggUnYy2Y	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	1407	1395	545	12463	18974	jxP21XDNuLXoG891YhgQii8rV4S4ute6YzdtLFvWd3yFtDbdRd9	13803	19451	19451	1619440380000
27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	498	498	545	12463	18974	jy11AuxDf6TirU6kPg94W8kHBNV13sFpDSTnkNTD9gTpq35Dcco	13803	19451	19451	1619440380000
27913	3NKG7YLaQrabgP6urJp88KEgosgU3R9ZmFGTFymQFsCkeCeKhjig	27911	3NLmCNAsC23ZFaquxFcAKtqqXbVDmrzxAhQzEtSMtRcDCS49pLP2	1581	778	545	12463	18974	jwq7snC1SpnoPGSUB2nSeEKgHn5iNQBDm4ANet2v4yvmTv6Pe8S	13805	19454	19454	1619440920000
27916	3NLDnYCSvAzaTrbwZtcv1uzJ5Aby5DMVmN8z9e4imjLpkgC3Nxwi	27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	1609	1333	545	12463	18974	jxnkw26wfvWyv4feZWDkTDxoRaXF35E2tBNBdzdHvrDrLpLcgSz	13808	19458	19458	1619441640000
27918	3NLXMoJSELmByCcxgUzRQtadXdKrB6cJxHBWp3xJYDAX9TyFzyg2	27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	1637	816	545	12463	18974	jxjAVrJA4FTwjMkD5HKGqQk11a9owgLHMHFCNBaryTKZUmevG8v	13807	19458	19458	1619441640000
27919	3NLU78DeZcpYToMXhEdQaoUogMwJCszVHsp1N2xc8iKdrJVnwZWT	27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	43	1310	546	12463	18974	jwzAJpbj6ffAbBrxidk2fDzRrR4RXSykRwDUqhYj5GBQFo1aGNP	13809	19459	19459	1619441820000
27922	3NLbPfdNJa3Rr26sYfnPjGMg8B9DnMdVyx6Bh4T4ncU55ueVtH77	27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	1483	562	546	12463	18974	jwnCKrj7nJ4356A2R3N5nfzBDSZbqcezX1QJoNC3Js5eRnio45C	13811	19461	19461	1619442180000
27925	3NKuJ8Cmand1Bf6mgnX2SotjvQhzn5mYENumrWVx3gkr4zTQFPxG	27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	1675	1342	546	12463	18974	jxYAipkseSTiLq3tUaSjodfeUXpQXAGFaoxYeD5zJHPW9kBaoCj	13813	19463	19463	1619442540000
27928	3NLU1Yq4a8kUHd2wf1mUoNFgJVp4qo8dejkzmeSkgvJJEUaWoUCh	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1406	1393	546	12463	18974	jx9WCYrJ7sW4LYvUrUnDZeFrnQmzEt1CDpiqTU6eaAfgjpogtuA	13815	19465	19465	1619442900000
27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	27929	3NLwYsVYnzT542AEjMhptn9yUen3MZaqgqYyvMiiBBarmzLw9AtU	1407	1395	546	12463	18974	jwsksxtidRgUWx1z7YmdnNejSFDj6SUfUdjf4wtwgPFqtFqECQe	13816	19468	19468	1619443440000
27934	3NLZrPiSkf2hb46J2aT9FfdWKUSoJQut2isozCNYEP3sq6SG7ekk	27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	1406	1393	546	12463	18974	jxWXq1QRBWEYADUXA47pgQJmgeCfzXcnSJPuD2nMhZwEJn62JXC	13818	19471	19471	1619443980000
27937	3NLF5ubWy3KBsCdmYta8fdEvmZpdbiGGdY2j1rhLwMvkzkM8wFfH	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	1402	874	546	12463	18974	jxuGZwN17NcSP6ZWcJGH331D8T6eXGvP4PbTA1jWdHTQEp3u95Q	13820	19474	19474	1619444520000
27940	3NKF6SbQcS12kbEQc8EXjodce9cG6SVG8mRrAvR62gaaPaMZ3yCg	27937	3NLF5ubWy3KBsCdmYta8fdEvmZpdbiGGdY2j1rhLwMvkzkM8wFfH	1406	1393	546	12463	18974	jxt1Ea72v6rMzqz4EM2aQX4ZaiV9P6gCpfnkWZZLmLumPxXgzdJ	13821	19475	19475	1619444700000
27944	3NLDgPp3vehDAUvETpQQQVZ7j6K4kac3u2kV82Hx75V7Hhgj7xNd	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1406	1393	546	12463	18974	jwGh8zqXdhdRphSnzhtwgVxRdtUeZBxTkFK8ZkKRx8Vo2ui2KeB	13825	19482	19482	1619445960000
27947	3NKyxdKCV9bNuowG2XPJCWJrrLs9r3gwwSf2ZhJQgwKdzW2tdSmD	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1406	1393	546	12463	18974	jy3Fef1RBjZ9iyT1DiC1Vxif5MSh4mgmpMonQjwKaABJg6hb1bv	13826	19484	19484	1619446320000
27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	1407	1395	546	12463	18974	jwnixvANHGUGy2hsvYws8zBDSQT4yyTHA3VAXcDFEQTXryx8zBw	13827	19485	19485	1619446500000
27953	3NLkqkYjdd1pGr1tTSPoPeAbjG47PbUdzE4KWc66QPHWJxsBB6YB	27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	1407	1395	547	12463	18974	jx3ESNTZPd7PPztAiYmXoEVsxAHbj5ubxqqEoGy5M5fYA8B5deP	13829	19488	19488	1619447040000
27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	1407	1395	547	12463	18974	jwETbvBQHSM54kJPyGRUEXCz7jVisuVRDz91cb5vGoELD86pQZ6	13830	19490	19490	1619447400000
27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1600	1006	547	12463	18974	jwZkZ6v5bg6zgUp7cvfRxH7TtGgkqqFG7BKWqkfeVpL5RhsHSSW	13832	19493	19493	1619447940000
27962	3NKvZLcizeJtDsdzoSFEF57Jq8wmF7Q3tLvhw4KhEnus9vjfvgpN	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwV7XNprkY6W6k8ywxWnrg8owadGomKykp6R3AncuNmHyLk1Czo	13832	19493	19493	1619447940000
27965	3NKJaaVCQvYdffjLvxzNuLJP1ovHkpPGNSwDvmTCt4tDtGTzaxDA	27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	1633	1390	547	12463	18974	jxCSurC566tHrGnYNsN2LnJpQhkJ3yQe34od6wTEMmZHg1R3cor	13833	19496	19496	1619448480000
27897	3NL1Lft6wdVcfGrDWAB5XyVrpzcqenYpfGmAunjZfja7WbyMqRgF	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	171	1248	545	12463	18974	jwSVVpu9qrEDak1xzkj2jqwkZcuGr17j6x9Vii1J8vqEKsUQWnF	13793	19435	19435	1619437500000
27899	3NLmtJXjA3YsyL7BPQNShxdPurTCkKar7FKZk94DtEBLHjpKBv4J	27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	80	1027	545	12463	18974	jxZ9k9gH7RoACjLrkU4a6FhwZY24FjgvkmD8jFq4kYLsBgAdHcZ	13794	19436	19436	1619437680000
27902	3NKSSHjYn1LxdfmcJNJDPsqX73Z57jFciK3rMsCUYqepcar3XRsR	27901	3NKb65e9YEcvvFdGSDWHWzt1KmjWfDmovnxrmQCFkFirKgjB7kSb	1668	1004	545	12463	18974	jw7H3JcNKQEzCiPMq1cbiqCY4WnyPdhsUGjzb5iHby4B61EsgrX	13797	19440	19440	1619438400000
27905	3NK9WaUBZdtLHeRerszx7oVtQfJHkiWD1LMTJ6hoxnQdrpdsgB5u	27904	3NKVhGiUce8y9sZjvcrnGToaREa1fYw86hPSuWgcrttWXMmYDUVK	1613	1349	545	12463	18974	jwGL9pPkBzSSbHoTxS2bJ3HrsK7pqZ8CCBGW3APg3NivScvtiia	13800	19447	19447	1619439660000
27908	3NKNTtQeA53bkdovz4sSUL5RzqfrYuNDnSp4BspQJn1oppXX54dh	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	1460	624	545	12463	18974	jxiQoXitKGNjZb6evB6ugrJnvWzkn46xTyQFYhyaTCoh6fKwnSb	13803	19451	19451	1619440380000
27911	3NLmCNAsC23ZFaquxFcAKtqqXbVDmrzxAhQzEtSMtRcDCS49pLP2	27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	1406	1393	545	12463	18974	jx4NhPvfDZZqTdofzpc3yowX385z3GTXRWikE22YjYVaHq1AhZB	13804	19453	19453	1619440740000
27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	27913	3NKG7YLaQrabgP6urJp88KEgosgU3R9ZmFGTFymQFsCkeCeKhjig	42	1361	545	12463	18974	jy2v67KSAmpv1Refj5oPb9QoFRTKhZPwnY1ppb4fQfDLx4rzLFN	13806	19455	19455	1619441100000
27923	3NLAT8rDs1zm89uNPFp4PyEFb9tZBay22M2DzBdq32c5TUsfBsBH	27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	1483	562	546	12463	18974	jxJs8qhaMQ2CKCyuA4JYWkinkLpWT8nr2SHxryGQGjP6mMmpDSm	13811	19461	19461	1619442180000
27926	3NKKm32jnaH3aDj8YbtviNDscBEd54axBG32gogSrsb8t2jGqGBr	27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	1617	267	546	12463	18974	jxK6fcFxuTrApnNLnDQJRS1dXBU3FKdgQyGxziz2BDRkp9w9yAz	13813	19463	19463	1619442540000
27929	3NLwYsVYnzT542AEjMhptn9yUen3MZaqgqYyvMiiBBarmzLw9AtU	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1541	1298	546	12463	18974	jxpLtHfSaoaBgnLdoZGNbuf6Mvas3MeVQJ8W4GRkPXQqGy8vCbU	13815	19465	19465	1619442900000
27932	3NL98s4SvaJQrCw2i7NLYg1ETLTri1V4W4WNunoDahEBvdc8FvDp	27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	1406	1393	546	12463	18974	jxvKULhSeBBAHrWM5c2k8vCXmknakAjDFsBiaT5xp2sjNBwocEF	13817	19469	19469	1619443620000
27935	3NKPAtecwzTtSDQE7Ja6hrK82gGXKkysG3j1hfsNsPcrYwtzro6L	27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	1476	1125	546	12463	18974	jw8WjdQ82woTKu296mBhZBSFNwH5UMm9jMaUUQCGcrnYBEnrypP	13818	19471	19471	1619443980000
27939	3NKBn2B2MTpWaBJX5LbTU7ipWuzQHM856Se3UY45x9HHydxbncHR	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	311	1061	546	12463	18974	jxuRhooWYoYaxrjZfgmQj95oa6TNtyxL9UEbpK2rmz3cFBCtL96	13820	19474	19474	1619444520000
27941	3NL3diNeXvVnq5pBPZgb1TUksJGPaYSDST4AqipYojJ8jGWbyqqL	27940	3NKF6SbQcS12kbEQc8EXjodce9cG6SVG8mRrAvR62gaaPaMZ3yCg	1630	655	546	12463	18974	jwNdKgLnK7yoQ85cLkEQYkiGpLU19sedVyGpxAsKNzViknwENdE	13822	19476	19476	1619444880000
27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	1407	1395	546	12463	18974	jwcp4W8KFGUgDgTP11KxJjBRKhD16g4j8FLARCyA3QR2aUFm9zF	13824	19481	19481	1619445780000
27946	3NKmpdwhdKBQNyv5GKNNvyCbDWFJrPbSoJx5Npit368QyshzbeqK	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1403	824	546	12463	18974	jxJozfsk46d24QR6PRSz97Eg9vo4Z7bqHBfSkAutraXyTgX5Le9	13825	19482	19482	1619445960000
27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1581	778	546	12463	18974	jwtakXaTvSfn7qFadCFuJR8S8HkMvaHpjWYB2JSuvYf3jwPhrJo	13826	19484	19484	1619446320000
27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	1555	981	547	12463	18974	jwfPsLyjk2TjKiDSGfMMeaEZUwPBJ2kCJpXFN27KYV5YRqfG2tL	13828	19486	19486	1619446680000
27955	3NLWZcATPPr18ZNaGqSMKJZ2MvDRw9c59xCbk4mcvhdS8e4PCJwn	27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	1406	1393	547	12463	18974	jxmSfPe1dFLpGXgURn1K8EnzuCrJkQvPPTBNcwJtpqQt54x8S6q	13830	19490	19490	1619447400000
27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	1483	1150	547	12463	18974	jwUgSk8TW79XcZx1hp8xi512GAhiqE7uWZcpQc17YbeYZqQ14cU	13831	19491	19491	1619447580000
27961	3NL5m3NkNRWgWc9Wu7mTh8o8sXz9mHiRutnHnK3sQKZn7YydGeMG	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwwayGjePxMGr85rXDwbEUP4BXsaL6CZvV1KKNtZ4ifGq7naMCz	13832	19493	19493	1619447940000
27964	3NLxcWf8j51yt9soabD1TeBz5LbDzvmgyQJCDQegnp7zb7veEJmB	27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	1633	1390	546	12463	18974	jwa4GyRcK7iir9EwfsJoLCd2yUbtaHS81MpNiAqJe7fD7aWGses	13827	19496	19496	1619448480000
27967	3NL3AvtEeoWFXC45Atkr12HzTJL7STpGJS2sopZ13EkZ48jQtjDS	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1423	332	547	12463	18974	jx1CEPvuXZGNMbvLgmKZBzDd8XbbRR9nbiYE6zu6evuBPZ8rRYY	13835	19501	19501	1619449380000
27970	3NLKeRmoFvTz38CACBDaXzc61qWjGiyMd1aFSTr7m6HVWGUZsoWQ	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1439	1279	547	12463	18974	jxvLiBTyJY932sXVhFKgZ9TzWHcQsPtqoBrBzUtJEdwoTT7gqkS	13835	19501	19501	1619449380000
27973	3NKspcLaosp1MnXS6AXpxTEZwDA8Ap4qmpd6yUn5iagEKKpHEizK	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1529	1070	547	12463	18974	jwhvUWBaRyGFHnMRmUztgA66BGEVbRaLrVzhWnLaNbhJvhWeJpw	13835	19501	19501	1619449380000
27976	3NKwx71DZQbZ6mGmcVdL6ra1sCJ8UyRALfqCVFcrbkTvBmGiYanp	27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	1560	1291	547	12463	18974	jwAm2hiiy9RmXEiDMmojEpLQ2FcC3KZvQEFLvXrL5TeoPjzvbYi	13837	19503	19503	1619449740000
27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	27978	3NLHJ2Su2NhZd52ETYPnm8VWRAG5QziSk33PSBfxVV1nf2ojboky	152	1330	547	12463	18974	jwzGXhxBjiwBeFW7UjMtWJmCh9DGY6ygcL4eTmLwBFzBYnjKZ9V	13839	19507	19507	1619450460000
27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	1406	1393	547	12463	18974	jx6LWjni15JWQGVtBrGBoqcZ9SLsSvTHFBLFgTzvFQrvjmPep2s	13840	19508	19508	1619450640000
27985	3NLPTr5zTkm98XJQnAzxQqrrFnvcE8xKixom2RAS1TNS3uxS4QqN	27983	3NKu2DinaUwqU2vD9hmkwCPFR4DQ8MrfjJXcMsK1Bau3EAzibRe1	1578	1170	547	12463	18974	jwyAGqyp4GVhJXTvCHzcAtc4Toy9frwgmqkQZoQTHrBMURNe8FX	13842	19511	19511	1619451180000
27988	3NKVaChVRmy5VfEqGHF9DPUdcrEebABkYDZuTDE7V42SrMe1ZCmE	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	44	1079	547	12463	18974	jwbNA7PGwhehY6d3dS6aiZFXQewiaWZ8hczcuansMhkT4jCkHHs	13844	19516	19516	1619452080000
27991	3NLe8yaAtinow18Wo3N55vxEqryCgwdmcutS6MS5i52CSqpG7qUa	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1549	1362	547	12463	18974	jx54MDxyPMoweAPm6RVU2yXyuqM4aU59LK2hgRuhE8CjgYWimZm	13845	19517	19517	1619452260000
27994	3NLD88Sm4EMQ1vFzkZ7o7U4FJK1LNJ5scHzuJJzoa56NWcraAzQg	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1549	1362	548	12463	18974	jwpLm4EuWiPb1UBLiFkY8jkHnsVB8mV6uiL2FS7FcgpZeS4nAnB	13845	19517	19517	1619452260000
27968	3NKhwD5pUpodjjCG6bsdPYLGysiK87eczwSUZeZXTDMDmSVGv1U9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1588	1392	547	12463	18974	jxfrffc18RjEhz7XuVh8T7iUsceb3MfMTe8KzmDi3mgKyHBcCEh	13835	19501	19501	1619449380000
27971	3NKYBwWFRpFbkwYACvSM3NU4LXZDmdFcqqbci2unTDjEP13zcuqa	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1529	1070	547	12463	18974	jxWuqE7hjV2pHVyz9DjXAg1YmTzShDASFxUewUffekBJRpivAGD	13835	19501	19501	1619449380000
27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	27971	3NKYBwWFRpFbkwYACvSM3NU4LXZDmdFcqqbci2unTDjEP13zcuqa	1407	1395	547	12463	18974	jxpTwtAFEo5bDYxDjeEZ6fpf4qfC7GqsMdk3Q712fpt59j23mKX	13836	19502	19502	1619449560000
27977	3NL4NTbA85dSfQWfmZitiCoaFxJF1vHwWFzeFQZEgZA1iiKAAk7h	27871	3NKis9LVvg64XUvc2MA2dBYTEJk5qFU2FLMezdZ5AQPcbVHBntfF	1560	1291	543	12463	18974	jwCBf5YVoAMJUuqk4g9rTmyT5dPA36Uxg4293ZBmC9rfqQGka4z	13741	19503	19503	1619449740000
27980	3NLvy7BvQq1Tgaov1ATNy5oirarWDYNE7r2ZNLfGYL8gdvst8hLT	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	58	1155	547	12463	18974	jxCmhkfgqqnndQ2xTJsDLALbhAjVb3yCBYkx22DKSdYsA2sF7jr	13840	19508	19508	1619450640000
27983	3NKu2DinaUwqU2vD9hmkwCPFR4DQ8MrfjJXcMsK1Bau3EAzibRe1	27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	1406	1393	547	12463	18974	jxUQFXS2Q9krDSzpuTw3sFH5k5BGyDRyPz2LRbwTvKcW9UiXCPQ	13841	19510	19510	1619451000000
27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	27985	3NLPTr5zTkm98XJQnAzxQqrrFnvcE8xKixom2RAS1TNS3uxS4QqN	1407	1395	547	12463	18974	jwiVq7QbTCh1qpeADNqQCc9m56jevM6zXkkxuMYkeA426FU2Y1b	13843	19513	19513	1619451540000
27989	3NLX6WvwbNEb5RQc7wKXA7YgVG3mzxMqrR6XxBNK8aSDLAEMKDAr	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jxgiV8wAmuPmDGvErbFoFbquMaCup1JnNKbDvPGngASJXK8fmWb	13844	19516	19516	1619452080000
27992	3NLiaCNYrzc59xYvhWgL2uF8e3h1t7PsyX4wWBYQvZCDHBNZhUt4	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1406	1393	548	12463	18974	jxYAkZKni4dWzcc5pnDJHWmr4xZZEmjzpVf5Yu6nbE4bFdn34oN	13845	19517	19517	1619452260000
27995	3NK6BbActwJfNUP37WbQyAyTmXcRbjGZV3onN7CWgXbNaQTKXA1n	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jwu5swX9h3F37RKWk3MAWDD5bcLiXVSaGqTBg36PvWviUox4fhY	13846	19518	19518	1619452440000
27998	3NLuApFnEJqU4fphEC3Qgg1CqvrJoVMz3KdNtoWqbipMxHjeEtW4	27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	1406	1393	548	12463	18974	jxSAbHyGi3cMTBcxRdgQiwsMYFzjfgjpajcjRjVzs41aVHGebUg	13847	19519	19519	1619452620000
28001	3NKmRTQJJG1JC4d6YWFNvJhrydKefS5as4mkE7je1WCyFZx9yR5Z	27988	3NKVaChVRmy5VfEqGHF9DPUdcrEebABkYDZuTDE7V42SrMe1ZCmE	1559	1353	547	12463	18974	jwe2WUH5L3GkcAQ8vjKfKmmBhd8qnXTAzb9YJb4hXFtsDGg3JSz	13845	19519	19519	1619452692054
28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	28003	3NLHYosimxTMmf4mchBpeFhfWMekv2V8v6QL8XHAXm3fZzfyJrLh	1501	1360	548	12463	18974	jxaLHEYP54NFfcy5bqLRoSwnjrv9v7WZnqrw1eRQS95ok5u9h2h	13850	19522	19522	1619453160000
28007	3NK9cQgcPqiVQxgLpY4eRpsf59jpv4DZo7TckoAWZwpMryqHEM6g	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1467	1250	548	12463	18974	jxkxyJ1ugYCPDhrsMs2rZND4RBhfxpTp7aKfSwdvtfeYSc5D841	13851	19523	19523	1619453340000
28010	3NKxskNX2kKR6asFLNTLMNHDdnd1jTxgMCNmSRzSYTsBPWFaJWJP	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1560	1165	548	12463	18974	jwtK6KGtHGF8rPgWxY1Xe81FKZPGEooM284JGoYmof4Apx7qaKW	13851	19523	19523	1619453340000
28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	28012	3NK5HzLtgSy6HBHjYDcUog6vgA5bpDesk2E4T1MojWRZMjfERQ2f	1608	1289	548	12463	18974	jxxxHpcp5AMzvJLpYDmYE2e9PWvFKH2ZMfVECypCLx4WscQQXMD	13854	19527	19527	1619454060000
28016	3NKuhbS2jHGZtAtM4XK9eF7GqzXtCwvnnxFFAE7ZRd7mjGejhWm3	28015	3NLgBz3Sowx3doLS9EJxHeXYCSN8QrBM9DKysKWiUhPZycR9GHBi	1579	1143	548	12463	18974	jxxBatYqZtKKn9NqGBPLet1sdLUA4ame59NgoH2NhdEwdDscukZ	13856	19529	19529	1619454420000
28019	3NLqYHjAUZWvYGWaHEUDtrwMzEppiTakyPZrgBYF51TjGT63HpAj	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1546	1546	548	12463	18974	jxuXeswGVX9g5NXNGabVCcWR6sfK3eZL7iNZe2NxH2TggLFjEgC	13859	19534	19534	1619455320000
28022	3NKAhT1HRPsYGEwYgFqPzgiNReftW1SrYgfGTB6NwDs5etc8HCsQ	28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	1406	1393	548	12463	18974	jwiyHAdu2pbvSW7SnKa1f3obK4tUSZVP1WoFzfE94N39h3cjsNA	13860	19535	19535	1619455500000
28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	1460	1078	548	12463	18974	jxfXMybnxQiN7i8xsrRVj7FTLKfJxdxaKzeQ2XULP2Zb7PbJUDo	13861	19537	19537	1619455860000
28028	3NKMaZ4NMeEbZuBXBX8oCGnpe1pq4rsi8SkRpTVKL9ReUUygpoz1	28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	632	1382	548	12463	18974	jwCckuQff14LK8AnJBd6ZWy2BW81sRtgKYCTzALhRfztA6MTRPc	13862	19538	19538	1619456040000
28031	3NK9u4SQdRL4kJrDxY6SPQu4z8yDFYCSL9f3R1NTUvMgoApSY1Lp	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1671	1119	541	12463	18974	jxZSEFgbTo2XxGd8GqHCcHCXzrmuTQtHpYLcqgDPURrrUaSfKNn	13704	19538	19538	1619456143584
28034	3NL6vqJWosHLWqH2jhKT6P9sfeE39YDuYNuyHP9ZaNuZvXfMyiRg	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1601	1142	548	12463	18974	jxkJJ2xu1G823y9yQD5j1XRZ33MUMA5FxXdaTpQjkL7geQejEzp	13864	19544	19544	1619457120000
28037	3NLZJg1ZVWLT8bBr9ED5dBL9HDJGqaLRhNSa1TapuiYdd17TSgEs	28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	1647	845	549	12463	18974	jxRG18a1zWc9xk4YdtSVbKeUnueqeBGzjUzRr4JpNtyZRGb2uXe	13866	19546	19546	1619457480000
28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	1483	1276	549	12463	18974	jwz2HxDnhiuD8aG71qn6b2q2sumKjnsQg22orMFMbfEfRX2VNnh	13867	19547	19547	1619457660000
28043	3NKbY74e7edGCGKYJsSRUkpCK81d9oCnqSbUBPP1qWHc7PupZsnE	28041	3NKLEhJZchxZRD5SA6HTo2UoWKBo5dZHYkZFqRbE5eDUwra5xYbY	1407	1395	549	12463	18974	jwKVZ2J8SR2HBc2JrK7WsnWM6DmyH34X3CJzqUfAFf7zTGbjE9Y	13869	19549	19549	1619458020000
28046	3NLB3VPzp1QjneUteLJgqp6GLixFrLmQKjHRvYXs2KviyJc9Nm39	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1509	1194	549	12463	18974	jwPzeo8Hfy7WLdUQMNpKLYpJS1QmZPiAFqDvNMNNKoV1RVsgMtk	13868	19551	19551	1619458429881
28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	1506	1127	549	12463	18974	jy1b4kUYU1p9M1tJDgPGizKxVSNZvArhEa3H7HySjGb4pcr1X3v	13871	19552	19552	1619458560000
28052	3NLLdi46KrLAPxm7iNwdsbcM8XFjMwdzkAAi4x38qCrixhq4LJUt	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1406	1393	549	12463	18974	jxzusoCkMYLD9FV6CQpWGqdNaqWSv7hXPRaYRjUhttaARgePVz8	13872	19553	19553	1619458740000
28055	3NKJvjNvUmJAV2hNWGZUkPigscJxaqj9tMF2bNvcxwrv8cAcUQDr	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1654	974	549	12463	18974	jwn6fUcDURSxvdvTEAwdGhvkxrhQXCUYS1XaEFMupp32C5rHTLf	13872	19553	19553	1619458740000
28058	3NK9UkcXiD3ZCHcPTiY1JsSB7LrQyJNTuyfBr93PiKmfpSJawAst	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxwcnev67nBr1fR5kuhEWWLc5udk7ST12iNKkRe19aHezkAnRkm	13874	19555	19555	1619459100000
28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	28060	3NLWkC1WBruzZtM9hyMfSoLmNMBAkEsUAn9rJDh8ZaaNAy3aWT5V	1402	868	549	12463	18974	jxKamrpCh5PTAjZpm2BrPVT6WnhJBy379EmNFdreKk2hmH2geyJ	13875	19556	19556	1619459280000
27975	3NK4LkViw5H9UFsMV7X14otZ8GBTgZJmjNz3aee4NFuNt6gjBrUT	27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	1601	1388	547	12463	18974	jxvWLMJxJkziMtLFSqn3Hebs9nu5cGUjyJPtR5QwLg6TybsMnBT	13837	19503	19503	1619449740000
27978	3NLHJ2Su2NhZd52ETYPnm8VWRAG5QziSk33PSBfxVV1nf2ojboky	27976	3NKwx71DZQbZ6mGmcVdL6ra1sCJ8UyRALfqCVFcrbkTvBmGiYanp	1675	1216	547	12463	18974	jwueHU8BcboAjQe1i6nrQAbGeXUcCrpazgYBzGSyiguvaEWbyaL	13838	19506	19506	1619450280000
27981	3NKrSj7ByFKpe7Z8Habx1SCoRWS1HvPEXKBppubMp9ZdvnsPUG7X	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	1407	1395	547	12463	18974	jwtSssNcopr7RS1ChAsotTu7Zvjp7fy7ToRWsD8gisRRZdprViy	13840	19508	19508	1619450640000
27984	3NKBtEwRX3FaBdXQqoDJJRa6KY9YMeWnXduzgToiKKzVQXKULmTB	27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	1546	1339	547	12463	18974	jxRL6LT3mNGvYoEwiDDdfteHvEpB3q9x2s5YDN9eazjNJsyugqw	13841	19510	19510	1619451000000
27987	3NLTBKYhVhMSYAcMijGzhiCCyUMqgdJFpUhzHttSMX9AjNSJbPq3	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jwLKpNWWFMnNqho6keLou6rE1xXoBXTsbJr4bdtdykqALmj9zj8	13844	19516	19516	1619452080000
27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jxgiV8wAmuPmDGvErbFoFbquMaCup1JnNKbDvPGngASJXK8fmWb	13844	19516	19516	1619452080000
27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1397	827	548	12463	18974	jw9Csfp7w7g7qmfnyXKQs3iTieHb3Zb3k99TTyow96qJaFUxMAA	13845	19517	19517	1619452260000
27996	3NLfA1kXMhyKZuDiqfnToqC46mqzhbTcjBogrbe7jLhxSJeRbV1h	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jwPSyxAMmpjLjgkRjUJUessDjkoGmgacu1CEJNiTBg26xXnjyJy	13846	19518	19518	1619452440000
27999	3NLwe8nkPi3UtXwR1VEfGCeiWFxFWirr6dAbRZoMLLdte5wZst31	27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	1559	1353	547	12463	18974	jxPcHCbaZujNd4q42MSXRjdqbvY5xe6i3EpzTWDRBLmQzUHGUaq	13833	19519	19519	1619452620000
28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	27998	3NLuApFnEJqU4fphEC3Qgg1CqvrJoVMz3KdNtoWqbipMxHjeEtW4	1581	778	548	12463	18974	jy19afECchDrBXXeSdRpajy8rar1RYx2cLMZ21fVmkijqghTKAZ	13848	19520	19520	1619452800000
28005	3NLdEhwNoV3ogkHAfaDodRDoW2GKZZ39BrE9KMsKhcM3hTDpttpz	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1501	1360	548	12463	18974	jx2JVaG4gucBo4RBjnumTNF1hrrv7mRvLULMrgawSQCBT7kT6KE	13849	19522	19522	1619453160000
28008	3NLVauighhohop9Wm1dB7zSBdJRzNqydqbCge7TzchKLuiaqwc2b	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1407	1395	548	12463	18974	jxYEAMgB8uyqLE7QbMZptrUFfCgBHzTcjTHc86ZePHpfjRTh8Sk	13851	19523	19523	1619453340000
28011	3NKWVG8V9fUkjAhjqsGuadLG61tEuMBP3Jz8WmAiu1RUxRv5QQr9	28010	3NKxskNX2kKR6asFLNTLMNHDdnd1jTxgMCNmSRzSYTsBPWFaJWJP	1455	1206	548	12463	18974	jxVhzgUac1caEXCxxQfv4bXd4USWtbZFKcmK4vvJDXh8QrfQCDq	13852	19524	19524	1619453520000
28014	3NLJmmxK44rQLhxbH4n1GVG8FQ59hNbvxQjHXCYdKNWum65QwCon	28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	1542	938	548	12463	18974	jwfossMYcjkWwG5poBSgEFpVQL6QEaZ53vUrVEAvGVnZr8RN6F1	13855	19528	19528	1619454240000
28017	3NK4X3T1Kx7yBLoJf9fk3mYNwy4DQmGLUNpbygf7DEKqVZmktNB2	28016	3NKuhbS2jHGZtAtM4XK9eF7GqzXtCwvnnxFFAE7ZRd7mjGejhWm3	1588	1392	548	12463	18974	jxtt3ak5JHAFZ3XaoNfjJXowZpemiCQqnr3VTWB3nnQoBKN6975	13857	19530	19530	1619454600000
28020	3NLgHYLW7HBPyWupEp4yWFQDuxSefKcgXRPYG21JyZu5PQCC3War	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1546	1546	548	12463	18974	jwmxmm1Mbcwbr4w5pjUPQvCAzgRJagkLderwVjqUMyCQHDst44i	13859	19534	19534	1619455320000
28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	1587	1357	548	12463	18974	jx6g7bueK1n7FGnkPxJKw6DYoeV7sfbuSGTu1hD5LJEeV4XjkfL	13860	19535	19535	1619455500000
28026	3NL4YPyzvAQRTpgEpvYjtCVsDH9JbWGrtcNa9GsZ8kRmGTFFQxr9	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	1671	1119	539	12463	18974	jw8U4oAFNiv1y5m5P72bRD2oH52VP29Y6trwsN8bE67thjJfc6V	13667	19538	19538	1619456040000
28029	3NLFs8BjAAHAanDnLgybghCv5SAjWQ4vZyKErAtTxQtFu7VXYvZw	27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	1671	1119	539	12463	18974	jx3zUpX2aGmphELhMUDMWq66BsDRzdk3hmSXh6n9wfTqLvUiovo	13679	19538	19538	1619456074285
28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	28028	3NKMaZ4NMeEbZuBXBX8oCGnpe1pq4rsi8SkRpTVKL9ReUUygpoz1	1623	839	548	12463	18974	jx8VDJ1hMqvegH7BAgFkq2NBoQpu7LACksKbk6vYGjn5vmFFZLG	13863	19539	19539	1619456220000
28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	28034	3NL6vqJWosHLWqH2jhKT6P9sfeE39YDuYNuyHP9ZaNuZvXfMyiRg	1637	816	548	12463	18974	jxkvMN4WY7QQiSKXKAjB2FkbN6zbfB7RKTNym2Tda9rHWjF47qu	13865	19545	19545	1619457300000
28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	1624	1334	549	12463	18974	jxcCm1WhtcbVc12Ks49ebQJ9x85ioPBjkCaYSBbyH16HSn1zjBn	13866	19546	19546	1619457480000
28041	3NKLEhJZchxZRD5SA6HTo2UoWKBo5dZHYkZFqRbE5eDUwra5xYbY	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1590	1174	549	12463	18974	jwQrAACd5Z6cPQCRvPRXGazZSYVkddjsnsgPF26kSeYXTzbME9B	13868	19548	19548	1619457840000
28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	28043	3NKbY74e7edGCGKYJsSRUkpCK81d9oCnqSbUBPP1qWHc7PupZsnE	1509	1194	549	12463	18974	jwjfeXBAMEfDv3vovThTfPXSbo3dLwGzPEgPFMVh5JKdyqtoFj7	13870	19551	19551	1619458380000
28047	3NK8HmTuACAVR7z22vgzbsnJBPzvV1mMLUK5hT5jajBBZ8NivEeL	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	606	1169	549	12463	18974	jwcCHVHKwMhnVLRzmevKUbpLhqbtRpFFLYAjTkFVNoTmESK931a	13871	19552	19552	1619458560000
28050	3NKnW7hMAyKaL21Uqct3pm7ppUzkqTHvcpu9LLSvDiLNH6wXZ6Qm	27882	3NL6zgiStznpxKTxconX5S9YLvzkznaJ5iifh9UpoBv6QT6EbMuJ	1654	974	537	12463	18974	jxdMeLG5CtfmGTMYsFNa8R2qdDHbtEgtTReCACGscKsogJ53sWQ	13627	19553	19553	1619458740000
28053	3NKQLb1gdCqPCmgmeyHLVUyGnP1wXaCbXfuQY74Q6aAzx65fCWMc	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jxvTGoHs8bY247GpR31k8YxZf9ZNDuFDnsKRL9nupd8UCTwjbc3	13872	19553	19553	1619458740000
28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	28052	3NLLdi46KrLAPxm7iNwdsbcM8XFjMwdzkAAi4x38qCrixhq4LJUt	1578	1170	549	12463	18974	jwrYiXdeCPwrx1w8PdDNTBoq4qbxxn3jCRmAgLM6yjSpkeHd5LY	13873	19554	19554	1619458920000
28059	3NL6jEydZHNpgHHd3ZyrhKY2jtWQ9H4MsAG3EHRWLCKNCpUgpf4h	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxERfVpPi2M4E99STHBohtCbzwvark3k7oNLjP95LdiGJ5myUAn	13874	19555	19555	1619459100000
28062	3NLGXkF4BoGQ6yJVGeHn1h6z2MPEU4znwqfW5sptrmwCBnNVNYAz	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1588	1146	549	12463	18974	jwoAysgmRG2boYtBrm9wM3WKS7w2vNi1w51s11NTTpwNMiTsUKB	13876	19557	19557	1619459460000
28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	28062	3NLGXkF4BoGQ6yJVGeHn1h6z2MPEU4znwqfW5sptrmwCBnNVNYAz	1407	1395	549	12463	18974	jxnoibsJNZFQVGC6eerdM3T18KnJgsJGv6UHQikv7e3P2D71uYf	13877	19560	19560	1619460000000
28068	3NKPMJzyWgggy2nN4tcEUJPL5HcWCcEMfTesBnuVeWVncjGKMBQZ	28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	1419	814	549	12463	18974	jwmui31VjV7w2Rnoei1JQ7FZjqVTNWDxKydUHjw2JSjvRBkdn38	13879	19563	19563	1619460540000
27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jxyPVEpziUvvCjaXViPADzLhkMsm7HTMou9DGxYWw7UWGESoEJ6	13846	19518	19518	1619452440000
28000	3NKL1jmHWeZPPV6y6txmk9Mz1AyAxeVq1mpCz12NwnubK6c8oMzj	27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	1559	1353	548	12463	18974	jxzkZEUpGG1iDLyGNtkCtreTJAKhzCMht47YkksuPSbKEa3jE8U	13847	19519	19519	1619452620000
28003	3NLHYosimxTMmf4mchBpeFhfWMekv2V8v6QL8XHAXm3fZzfyJrLh	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1634	965	548	12463	18974	jxJPXfZT3tstj9hj1CJ6zhHtytQNgqWuLR1Fg3y1GBHqgvQmK4u	13849	19521	19521	1619452980000
28006	3NLYRqt4buEbrjSpH8nysLCraegTmNrZQErXSjQd2JdjkUkVy1Gf	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1581	778	548	12463	18974	jwzhD9Fv3XPx8MeGjMhfkc39TKmn9XJSwoN2Z35eaAQStkBePqP	13849	19522	19522	1619453160000
28009	3NKcVFuLD3DQD4VmXs6ho8z7jewBSr5n96BSrvT3zQKyDMATAV8M	27977	3NL4NTbA85dSfQWfmZitiCoaFxJF1vHwWFzeFQZEgZA1iiKAAk7h	1560	1165	544	12463	18974	jwQ7hTVkJk2Gkb1d99mxtocjbgFrjRtqAWMpSAAVAAXESPrCeC8	13742	19523	19523	1619453340000
28012	3NK5HzLtgSy6HBHjYDcUog6vgA5bpDesk2E4T1MojWRZMjfERQ2f	28011	3NKWVG8V9fUkjAhjqsGuadLG61tEuMBP3Jz8WmAiu1RUxRv5QQr9	1668	1124	548	12463	18974	jxoFdfUezv94dL27xmqjTjo9hpcQYi17nZG5tQmM7M97LXsKySm	13853	19525	19525	1619453700000
28015	3NLgBz3Sowx3doLS9EJxHeXYCSN8QrBM9DKysKWiUhPZycR9GHBi	28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	1528	692	548	12463	18974	jwUuk8Liv4fXRdtddoNJsmGBFZYxch9izYtBMBedQpwM5XUUF7b	13855	19528	19528	1619454240000
28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	28017	3NK4X3T1Kx7yBLoJf9fk3mYNwy4DQmGLUNpbygf7DEKqVZmktNB2	1585	1000	548	12463	18974	jxreJz72KVuuWUAyir8Hv3qhPGoVwzGHFzxF1crPKfB9SyrqFc9	13858	19533	19533	1619455140000
28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1407	1395	548	12463	18974	jwh66mBADP2nYMNWWimwHBbDYA3YyYK8JaaGRgGMLYs9EpWACVi	13859	19534	19534	1619455320000
28024	3NKRHngiwhtpPdRaYbQLyy9FBS4BB64KsxnXSMeoMVqaxyMHqVZa	28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	1547	1132	548	12463	18974	jxekVPk4mk4QxYdSd9QHC2JAoyCphkCT6iRMygaz3zy6fDmsrax	13861	19537	19537	1619455860000
28027	3NL5SxJtS2RUQM8dd6PCAQERqXj6NbVbvB4qkDLY73iPus94kNUC	28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	1671	1119	548	12463	18974	jx6sTPtLvPwiTH2z1zYXDEXKCDkrGc6p2RwWK6fGHMKHXinKr5R	13862	19538	19538	1619456040000
28030	3NKiCmLWZXstobyesHoNZwbETdyHySUNwhnRxNd3ni7BLX3x6zBT	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1671	1119	540	12463	18974	jwJJ5mskhZPkUX7BZ7CoSe2j1BmxM1NkoSxDcneSMfue3h8A7M4	13692	19538	19538	1619456109505
28033	3NKwkA4oENWEFeF6gPiiR6E8Xq3fMrZvRqhjvbLVAohL2yGZ5AeN	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1402	808	548	12463	18974	jwYVSgrnSKzEHkFCCQTJY3WKUieDyUfWWEDxbVKcy4rxfCTPGHW	13864	19544	19544	1619457120000
28036	3NKqjiASLo76sqtv9edRwMgwFujTh7u9tSqyaWLAEK9eshYkTBE5	27591	3NKCe6qFQbiTBiRBXD4r6SW9XQUTM2CJg1fRNRwzFzm5n9Ze3FxC	1564	1212	537	12463	18974	jxEu5maB6oWtMRVGC7ZQVjcWo3aADP6FMzvhNPd1wVzkYTZfSF4	13638	19545	19545	1619457300000
28039	3NK8Khj4LygU16E3QEaMYRSX8rAYyhZqeq7qGqc8E5FqZ5Kh9VRp	28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	1483	1276	549	12463	18974	jxeMjnoPVQWmv71B8tR6E9BcGwTiMXgFgoMvUfVsJq643ga353b	13867	19547	19547	1619457660000
28042	3NLVAEp6G6cDX4DF435HxZh1A6MmHqMno358W2yJxZnzsNwTUMK2	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1590	1174	549	12463	18974	jwd84CgDXWSXgeom63uku4DW21qSjqapVggTsnDLtQgj3hbcGbc	13868	19548	19548	1619457840000
28045	3NKyK77JyBEm74PNc5UzFvXbbtZy7TQMAa8vueQakAXwZxxKscVh	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1509	1194	548	12463	18974	jxYE5n53Kx2SNCZuqdZ4txo5DKM43M3VpC4Q2xspHbZN9tWGAza	13864	19551	19551	1619458380000
28048	3NLkjoBiHWDivhSgmvtHC5XHTA13FMx6wV6jyqU8XF3bLvijuLTq	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	1506	1127	549	12463	18974	jw9PMzw2HULZtNty35gR5jiL7RLAqVcEx5yBfKWb1Dm4JDj97Hc	13871	19552	19552	1619458560000
28051	3NK9sUzM8iEd8aFmLJoJpGwT4v63ZPCBtwUYdFHUE8yhgxya9DxY	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jwox82UianwvHexQKfFkstX2nVTeYScPaZBatCY44ZCfRQX8HBK	13872	19553	19553	1619458740000
28054	3NLAMCRwf77hVK7xhrApKU16m5T31geqHdG2en4JgQzskjgnWtnH	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jxKii5zEkZpQc3eyQaTPpu5y5Q7aL9StQfYkszKDy3matekJQq8	13872	19553	19553	1619458740000
28057	3NKpX9XuBnNPapWZCRPySb4zkRBmRM5za3Q43uUZ4uBnAMAMAztA	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxg6shZdARbKDEf7V4Rv5QFEcYMdEHrn22ZF46kmdtYgJBmdvnE	13874	19555	19555	1619459100000
28060	3NLWkC1WBruzZtM9hyMfSoLmNMBAkEsUAn9rJDh8ZaaNAy3aWT5V	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1455	1206	549	12463	18974	jxgMTzLuAPyJo74kZiPEGzY8pTxWe7VVZCSVqKUoWhJctAup8Yv	13874	19555	19555	1619459100000
28063	3NKhepzgwU3e4zTmrc61fsE2CUdaJ49eZT7VyJJUKj9S2Hod8gXE	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1407	1395	549	12463	18974	jwkVjNwwG65JZo1wvWb5i96uKtbiBbCg69XdqBqfwg3FUKwQsfg	13876	19557	19557	1619459460000
28066	3NL6sBv7x6KnRGEHFW54A6SEPfzy4us8wNm7vgXw4hFtuDsjgrgg	28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	1406	1393	549	12463	18974	jwfhwjVjbjCd7rxb18gG9HFcBntKhNyjAoBSExKYnThmZxyycWh	13878	19562	19562	1619460360000
28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	80	1027	549	12463	18974	jxjjo6a6d9cDGFpThxb3qrQVsuXhPYhGzKbFkMcKkNj2jyZPLCM	13879	19563	19563	1619460540000
28072	3NL1VoaVZwmWNTFK8uPmJ1peHVyKyyDwV5qd5PsQoktNsbdopWrc	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1675	1096	549	12463	18974	jxSTqUgHjWob7saQkSBhUpbri5vb5WM82NHkETkwCr6FXpXtwaA	13880	19565	19565	1619460900000
28078	3NKhtQikGaeivZnRH5cSPu3hmpouFJthhVLrF2wK4UhHFLWZszMu	28047	3NK8HmTuACAVR7z22vgzbsnJBPzvV1mMLUK5hT5jajBBZ8NivEeL	1553	776	549	12463	18974	jx9FKs2EeyCTPxSAqdTt29Z88DnJzyRbsBA9g62hUdcTXx3PP3F	13872	19573	19573	1619462340000
28081	3NLCZS8nhSXGv1oJefs9Wy8MFkMynVE1vJG2FHQa7teKrxTDGbze	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	1623	830	549	12463	18974	jx5xRWY5p9yX5FW8RAyUan3ydeBDRghHTW7KBZyMyuMxzZTKrQC	13882	19573	19573	1619462340000
28084	3NLu17mwRSg2SknzbrpS7aGLTmKSEE9HooHQ3hgMWz8vSeyhehzZ	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	550	12463	18974	jxhCqRC3MZJ3LYLeBwdDUFzUyr9dDsYynPzvwkTP4M8P18xkHAq	13885	19579	19579	1619463420000
28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	550	12463	18974	jxULndMLz9dxeUi9Pj4XYse73EnbSUgpuLLAiXn4Gds3d7uyRZf	13885	19579	19579	1619463420000
28090	3NKx9fSm8MjpxgXW2BHCDwXTwhcpzhJ56W2XwtL53JTX8i2jqAa8	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1559	1107	550	12463	18974	jxceRdBChcEFxYKDZYMeNjdd4sbhpWgUG6qMpJhcmtwdfw5k8oT	13886	19580	19580	1619463600000
28093	3NLd7MiddMvWSGxr2SEqPUW51bzMs63LFaMULNcutUiXWY8fS47Y	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1407	1395	550	12463	18974	jwept72ywyWcvSjweBTG72WMBKJH2DNNyQaThQQhRG43wyd3TbF	13887	19581	19581	1619463780000
28064	3NKBJhA3P9tgL1t5H6vKpM7wvr16ew2twWoLL3bWoJFM1fAEKdPr	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1624	1334	549	12463	18974	jxF1DYSmiAXTjrfa4Aku2TaHHSGdbAfaozSaGubVv4UFJFbhEdo	13876	19557	19557	1619459460000
28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	1490	123	549	12463	18974	jxvxNhTDXs9J1qbDCDLKtttjdYQBTQpdtuiixxrYCDHXL65sZtN	13878	19562	19562	1619460360000
28070	3NKbJjyBPSVBCKa2tQdHwfTh5rua6dp1hN8hmrc3ioNxuiweu9NP	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1657	1344	549	12463	18974	jxxs7eoTmuBc64X8aNknYEeJH6Hdo7Vzm9xUFfoECHafj9m7Rmh	13880	19565	19565	1619460900000
28073	3NKZ7maZtwXnCULznN1Ljos8iENuddc9bWy6VeQ48ptRKNvSSqC4	28036	3NKqjiASLo76sqtv9edRwMgwFujTh7u9tSqyaWLAEK9eshYkTBE5	1564	1092	538	12463	18974	jwtches28tYeScseFadAahDueS8cyonk1eDV9Pa6HkqTVZYso4o	13639	19567	19567	1619461260000
28076	3NKWwx6ZC3PtXgiHNan8qDekzzsSEa6j7qP6knX5BiPdGGTmZ7Jt	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1622	990	549	12463	18974	jxwJHJDmWyLr4931v3YLzMqLt9Qgew6qVVxSTZ92rJkKjxKhGxt	13881	19570	19570	1619461800000
28079	3NKzetVqFDFFyH7er9LgMSK1h2VNqjNYAGRf2aLbrvnesGSXBsNB	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	632	1136	549	12463	18974	jwaf6txxkexMNLS5kVBCKrfhtMyqPfFJ9RJ2WvdQg9yGozQkToz	13882	19573	19573	1619462340000
28082	3NKoK2hy9FCeCn5r6epyW95ymNSh9EMjxCK8tpZPJsrgCfBUfBjG	28081	3NLCZS8nhSXGv1oJefs9Wy8MFkMynVE1vJG2FHQa7teKrxTDGbze	1518	833	549	12463	18974	jwXHNAgBRbKa85aMU4xqAFqnQuDWta15DD6Tjwu67CNWkcmmJxb	13883	19574	19574	1619462520000
28085	3NLxeLyghmSoAFR46sKQnSLfhzvvf5Gokhd3FquHN9BPFmJ3mzhX	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1668	1244	550	12463	18974	jwzBxedzpfzBieEuwmmZRKpjp75zws9erGzK8b6hhA22338QzRf	13885	19579	19579	1619463420000
28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1448	1311	550	12463	18974	jwdZc2JfKdrWQJQZEgcWYc8uj56HMCYUsxCesgPFcr6VBZSN99h	13886	19580	19580	1619463600000
28091	3NKAdCPdHFi9d1UyxEvQZtLSbhdWZT4YdyJFUHu4qMivA8gHDpQL	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1403	824	550	12463	18974	jxC7JYm2QRo3N5rwphhU4KKHFA9YyivdF5w1AohzYoVPQFfNW9M	13887	19581	19581	1619463780000
28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	1403	824	550	12463	18974	jwNHgn8oysUgkoGxdeCFEDDVBcDpRx1YkDAd1s8mdKUTaK6YFkc	13890	19586	19586	1619464680000
28102	3NK48GAN8HsSQz28W7CdDb8SWqmvXMhjwwNQhjCPSwQ7kZBuoYBu	28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	1637	816	550	12463	18974	jxQK7LCUDSg1ztTDLodAX5uVYsxXyb4h4uZ4Z2KNvhey2xUhbFu	13891	19587	19587	1619464860000
28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	28101	3NKotBdfZ7p2bHqHCswQZ4N8vJc2Uxw8nsz3MLDba3XvW9or65uz	1613	1349	550	12463	18974	jwKQtRs2ocP5bPf2bCUQXuCCjXkERmcwZdbH1o48EcE3KfyaWCs	13892	19588	19588	1619465040000
28108	3NKePPzScxYxKf5EyfirKsRxVE7sCtcbQcqM4ZZwitvwWdQePmrz	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	311	1307	550	12463	18974	jwSabfLVizvSfD48Cf1jpdzBj4HGecbMC7Lcy9d8RxYr6g3RX8a	13894	19591	19591	1619465580000
28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	1601	1388	550	12463	18974	jxgh2DDnaDkRXtABLiuFzTXH2Wkm361zXeYm7nUMLCgQFJNYSpT	13894	19591	19591	1619465580000
28111	3NLRHoPoKGDga1VmuoCifQXjeMvB7KprEUwfe98SWwNR644Z5SKC	28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	1631	794	550	12463	18974	jxRiP3oo6w26fb3Xnvbku5Fax4rmyRSD23GtXeSijXpsDUT3zG1	13895	19593	19593	1619465940000
28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	28110	3NLoWDW66CAzSiiAiQ8FnkTKZC6LTjFo3vXpk9uwLk98bts8PxME	1403	824	550	12463	18974	jxXt7Zob996jKwCLB8cq2nC3mHDSfJWNpFxNDMWyiigGR6HEuhb	13896	19594	19594	1619466120000
28114	3NLqxMg1KyCeVwEk5XDprUAp4k7juCQstmzEPxTe6FQKmQrAxPCy	28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	1406	1393	550	12463	18974	jxCHnCNDbD1654HmbQo8qHAgttCuQ1sBjMgsUNLtcBodVYuw7VG	13897	19596	19596	1619466480000
28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	28113	3NLDJt4mjj23awTCByrV6Qr6HonRrXBj2QWJDskiPSHFuTAAjdhG	152	1084	550	12463	18974	jxbaJftfQNsrvYT5nR4yzaPEchwduvJJMJWCM1faUqxZWe564ux	13898	19598	19598	1619466840000
28117	3NKBRv5B4c2KaxYBEdjRyPK5zjtFtxZUj9a7Y8k9VyxcEsNdm5e7	28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	1607	1348	550	12463	18974	jxzWTd1NxptaUbZk2NH4poaFYbNguA6R8d8zXVD3G9qwajXLsZ4	13899	19599	19599	1619467020000
28118	3NL8ARjuhTzV88KLB3CVrfpjsWiEShto9u6oqPLarUazpZTZNytc	28116	3NKmPpPkxCkTcidJzjssSEAaMw31rBrCutvxanChpCv8QWqphBvK	1406	1393	550	12463	18974	jwynoJqqgMsp7DjK19WT4fD3YQmqKfkmBir9JhMrQQq3kwR3R3m	13900	19600	19600	1619467200000
28121	3NLdxfeQotUnCUQBTqvQebdd8JKTtmpbGt8QKez55zDfaSMte3A2	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000
28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000
28125	3NKjtjDok7C5bYArhhsAJVELddSFBFmopqs316WJmDLWexCrn8Qb	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000
28127	3NL2Zm9Gapm5YyJuAQ8VNxUx6oVJj822QPp4gCaLNVh3hJMFjSdT	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	470	943	551	12463	18974	jwZjWzsJwC3ManiJZMEpiXFFYguoW61cmmDtpLZjdYMPPCx6JGn	13904	19605	19605	1619468100000
28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	28125	3NKjtjDok7C5bYArhhsAJVELddSFBFmopqs316WJmDLWexCrn8Qb	1474	1329	551	12463	18974	jwZtj9SBtWqVxz37PqA3AvwF28By7Mgmwaar4RowVVpfGDUjZJF	13904	19605	19605	1619468100000
28133	3NKuifNMXAs5sevAU9nHvMnnd8QGZuxMM1QVsPo2oX2KtnbPnM4T	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1522	1322	551	12463	18974	jxQpQcPWtmpSujey2Cryf33R7sKNL42o594Prr7G3AagGw2eeqM	13906	19607	19607	1619468460000
28136	3NKBpzVTRwJsA6pBnoEb7hBVZWjV7Sh3H7wQUzGMyYt4mwr2qQaT	28135	3NKhH3W1WHRjWGt974SUBmr1kpFqsm4HAhV6o1YWd7igAEjT2tb5	1637	816	551	12463	18974	jxLHWnmXeGiRuBjMUsAkJ2jbhcZZmKBnqp93HNLTj7sQiKgoWm1	13907	19608	19608	1619468640000
28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	28138	3NKG6DD3mYe4rThdM9MS8sgZiLUFZMng4xHf2HAjvCHMAbEdwWSR	1481	790	551	12463	18974	jxcwFStLmSYSgiDjc8td8Nv3h7HscJmtyvf17B9yaE33soMLWw3	13910	19611	19611	1619469180000
28141	3NLQ71ZhauDdQdGgGgCrLUZvRgSMb5v9evfyZ9aksSctgDWAH2U4	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	1454	130	551	12463	18974	jxAXhoTy3C4ufK6LwG3nbrJqAmdcvmWJ4Dh948s8UvG23pN5N1C	13911	19612	19612	1619469360000
28145	3NLw8RCbVf8PcVLijakwPUdD4GCnJe4CfwQfakxytbgtcd9G97KU	28144	3NLfS4UNLHmdk1qHC4vQ7hmp3Enwx65Jwm1nZVFCaC2BWART5xtt	1420	403	551	12463	18974	jxFFYuVFT6sjSptM8Tkt5nd6Cuy8KZ1CQ3wMiawcSi1QUVr3dQf	13914	19616	19616	1619470080000
28146	3NLToj85vZU5rvafQZingfVkRhCWYswCx5BfLGckd8QsqMJWF4da	28078	3NKhtQikGaeivZnRH5cSPu3hmpouFJthhVLrF2wK4UhHFLWZszMu	1553	776	549	12463	18974	jx6fiN7Q3PnAvCoy6RPghcUXZrbd4UGmnnS2sjzTF6tKZM9Zhm3	13873	19617	19617	1619470260000
28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1657	1344	549	12463	18974	jxzHPcUJU8Rqm5NHQwmvEboUeQBa34n9P8gFb4vhyFL7dCra59A	13880	19565	19565	1619460900000
28074	3NKaaivAbanSfY1fcFg5MzXjuXquueAPkxXkBVvnEEN1kvhJevqn	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1520	48	549	12463	18974	jxsDTJPJPNxTkcpxNKFworkLGwLjZFCpCweK7p6uJ73UrXeE3Wo	13881	19570	19570	1619461800000
28075	3NKeDH1Xk1iY89xEUaHLZjJKiPdB2XLTAq8AMXY6wsJsmoTRyruG	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1622	990	549	12463	18974	jwpWuafAvfBDwAd3TvUSEzEXqSCUjs7iSvbV252SBGNzBJuiSJ5	13881	19570	19570	1619461800000
28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1520	48	549	12463	18974	jxUPw9CXPheHnTz272RqnPEQmnzkvGaz8yubphEC8zGEZKHVaB4	13881	19570	19570	1619461800000
28080	3NKppXEZ8Dju8uscDiSaLuD2qooYzXZmdUmgDZ8gJWi77nqYxMXQ	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	1455	966	549	12463	18974	jwvUQLKRmENvgwsU4wRfmXYYbUtPTM52gR133j5gJZnTy9RDwc2	13882	19573	19573	1619462340000
28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	28082	3NKoK2hy9FCeCn5r6epyW95ymNSh9EMjxCK8tpZPJsrgCfBUfBjG	1490	1148	549	12463	18974	jxcNnRNbR6wLsgdhzGek29XuZ2nTCDfgnasK7XojGPB6V4XpurG	13884	19577	19577	1619463060000
28086	3NKY88uS81aVt3HGnjY1N51G3fp26vViYiHB1uziDYXarWc5QfnC	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	549	12463	18974	jxczizNV4c8khyPYBZ3zMZbVkjozKaBuS4c2ti7d1dcFRftUstm	13885	19579	19579	1619463420000
28089	3NLezSf5dRAa7peQYgmc5DfoXr9hMSf2Gw2zyapkHr9zGLBueibr	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1448	1311	550	12463	18974	jy1Mns1UiDYACzMGoDBN6FFmcsDqncaN3pZv7PyW4K4AMTcdQqC	13886	19580	19580	1619463600000
28092	3NKY4r1agh5TngBs786XLqyVtNjcNNETCN9iR6QyLwWcp2nixDaC	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1637	816	550	12463	18974	jxBmWDVtoA3aRfyZ2oEiMk44sVeuCR8m8dMQ6aKtTgJ6C6xeNtU	13887	19581	19581	1619463780000
28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	1646	1354	550	12463	18974	jxftTTH6vTQ5pwP8fueNs5WegGcb2FB8d4PwK3WAX94EPtWHjTr	13889	19583	19583	1619464140000
28105	3NKejeeVWciqJyNT2p1YAbX9gE5cPcSVwH3LTHGAGUNBYtAgTqP3	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	1590	1174	550	12463	18974	jxRQQU32z7TcX7iEAfhRAVjsyTLYM37zwhq2fmhyZ6wJfBsUT33	13893	19590	19590	1619465400000
28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	28119	3NKRFT2E8ZBehY7mbcvVHwC6pSryM3ztc9ngTUdCH9YjYFZbJc1Q	1461	1271	550	12463	18974	jwuS7K9ToYzmF4mZztTkGgea7hiV7PWQTpktXEdx7639rNYjM14	13902	19603	19603	1619467740000
28122	3NLjLfefDmy9PbFLBaGiEWh7BqHEr8xkHJ8S2j6U5kf1guk6KXod	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000
28124	3NKPpX2fdES3F6vLFsnpqTkgW334ZvECU1EmB9Uv5VZiXjjnLZtp	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000
28126	3NL6168pwEZnU896AXqjuhwhKqAVeWVNP71w9uJquFnQ3Kiwicff	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000
28130	3NLHM7x7mVKtbP9Sau2a8gRmXayo8f9jNvRxpWQWwJyoYFuUfo4D	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	470	943	551	12463	18974	jwBmwzuyz4C1ZXGo4fmnq4q39b89mXHLVuiYNe9V1GwnMHR96rL	13904	19605	19605	1619468100000
28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	1657	1344	551	12463	18974	jw9H6tvJ1oWCRESQz979QLVYeMwMwPPZwnpLTfzSFGZWSR2pD3U	13905	19606	19606	1619468280000
28134	3NKukhdQ9JJTjPPu2RJLK6QjhR5EpxfX4TzGiNfqvCjCm4Gi3L5z	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1590	1300	551	12463	18974	jwNjYQzt76dHKbfQBFX8ixvjS48h4oDwThyZyMat6HLaer64Ehz	13906	19607	19607	1619468460000
28135	3NKhH3W1WHRjWGt974SUBmr1kpFqsm4HAhV6o1YWd7igAEjT2tb5	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1599	1041	551	12463	18974	jxGEvRuyjeeThGZHrx4cqF53xn7E4YdLx1fVRpGCr67tHEBuzNZ	13906	19607	19607	1619468460000
28138	3NKG6DD3mYe4rThdM9MS8sgZiLUFZMng4xHf2HAjvCHMAbEdwWSR	28137	3NKyu6cH7WgpD1f4JUMHcsdYUQ4HPiUu692fT6we9bXswwngE8Lw	1447	1219	551	12463	18974	jx6ZEKziDm7G6nJGDbmKaAXLCQFFMSs2BznyDT9iX55KuXJhUQU	13909	19610	19610	1619469000000
28142	3NLjCoSspbk81VpbAVBp7nJhn7i4A1aunW7qMtZ58v5YyUjtFcP9	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	152	1204	551	12463	18974	jxye3A8HK8Fz1uz2cRX1z6Jyau25aCgKqBQtuyx3adSrMUeHUcB	13911	19612	19612	1619469360000
28144	3NLfS4UNLHmdk1qHC4vQ7hmp3Enwx65Jwm1nZVFCaC2BWART5xtt	28143	3NKTFSVv1VYwESJhi5fZQ8w5uiPLMDucx27tdBsuc1JQs3Wkkkzc	1617	1288	551	12463	18974	jwsNMjZZKRZHf6qfVjX2V2qM4LYtR5TYcpEE6ZSmfq4xtLaVmKW	13913	19615	19615	1619469900000
28149	3NK3sE6WDbHhBdScfyqrr6dtCghKmGJBnzUQotKQNLwjeueenKA4	28148	3NLYZ2LQZmenyVPqEFfnhxRocDkesoyCNBV3qAkR3pHpYdaVaNxu	1652	1315	551	12463	18974	jwgF21eqZF6CJWGc5GnAPZcLi2QWMHK8zjUeJKMa6CQP2T3qbVo	13917	19619	19619	1619470620000
28152	3NKPwujiTy44irFfQqfNUgFNeREC48ibbDmv99hUnpcssUnib8LB	28151	3NKj7qaBLvg6cV4z9vRrJbBLk9DH5Xc8JvZMQBLs7bFU74nrsKHY	1594	1200	551	12463	18974	jxySdWZMdrwGFrmHmjiHxJcpgcVVf19BJbCWe1n4BbBaGKMpLh4	13920	19624	19624	1619471520000
28155	3NLs9GEaEebFFw6tmaS9b29cU15TcpQid7UPzkKAErkvB9AZ9j9U	28153	3NLRFJUUbsa249fvS6xA6Dz5p1dyt4jSQNbc3mo4G9iXTv7KnGrK	1403	782	551	12463	18974	jxBJbn2jmWFT1A6zPy9zYCpJiMRGr1DXvmuJHDoYCvu5repxGNE	13922	19626	19626	1619471880000
28158	3NLwvfCQmyVMtE5BW1XFwTRrUqxWcLK7okCQThw1Qp6hvAmVkYPg	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1675	1342	551	12463	18974	jwtUE5p1GPrqb7dAq1zvcWNcwuHitUkRM1WZXXRPLTyDeWnjc43	13925	19635	19635	1619473500000
28160	3NKpHwyL9fb2E2r38KuchY4L9payHUYRz5D67VbsvEsnuimwWVit	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1594	1080	551	12463	18974	jxdNFy2QUPiMQzJmuSan1dXb32iz5mvP4NcG8CLbVHAfn8vGfTX	13925	19635	19635	1619473500000
28163	3NKw62jn14DfGpKWQuJQYmsdBhYk63sAwTT8yXiHpdSuAQJcWMgU	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	641	970	551	12463	18974	jx8cBd6Nsu6wcojr2D6D8HAbxFU85iHs81C2vfbQ3YZQNTPXQao	13925	19635	19635	1619473500000
28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	28161	3NLNN1yh5Zij4UdscRKv7B98Voq2q9FUjjCGGdGVwUatdQKRMiXE	1407	1395	551	12463	18974	jx11mkTqvGTvV9QFAJUA5JUzDHs4XPbPw17MjAcKD1tvp9KeqJ3	13926	19636	19636	1619473680000
28166	3NLtK7zNZgT8iEe5JAR7ybwL8r9pyMz2J4upGvNBDY5jkUZW73c8	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1509	1320	552	12463	18974	jwNBi4kjvcCDDGhLkjpZgFoGyU1yV1MD51SteNDubxTAz6ydhxN	13927	19637	19637	1619473860000
28168	3NKdYTzycaePUwgnCoWCRg6xgE9y5yFnXHQgp9fQPyqiyqV22Rsb	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	80	1273	551	12463	18974	jxRGJgYZQkEYMzaTUoNBa9DkNhpja2vBrVJoiEHcDLB1KymStLG	13925	19637	19637	1619473860000
28172	3NKomX9tHZe7EeUCXSosyWca9bRFhdhind8XfYgDvkv9kLMpv8SG	28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	1646	988	552	12463	18974	jx7LmN2k66FNPoZveabo6tMTxdZLhDWRKEgpKBqCLreCHRwBNXx	13928	19640	19640	1619474400000
28094	3NLcFQ3MJ86EjgspKTDfKdU54iKYw1j3Y3Wyse7xSqitggsuZavb	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1581	778	550	12463	18974	jxarhHNXsbGvMrQs3Moez51uhpfWiJfsJ3kQfFFwDNotFsvKW4n	13887	19581	19581	1619463780000
28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	28092	3NKY4r1agh5TngBs786XLqyVtNjcNNETCN9iR6QyLwWcp2nixDaC	1406	1393	550	12463	18974	jy1qytuz3tfi3G5VkPexECnudoveHGpjdC6UAEjVNHvJKzVsH8d	13888	19582	19582	1619463960000
28097	3NL4B1pRjMB1RnyFYXMp4RbkiMnzxXPGiMtsvemS32QDfUFUabBf	28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	1476	1371	550	12463	18974	jwiX3EbH1aYzq9CBwJgVwQYHABoy5Yi7G397LDaxtE7YKBXFVUf	13889	19583	19583	1619464140000
28098	3NLdhXzUfy1FoMR1NyoZRPruTYkwku1D8gsvnaRxoRWV1gJmHJL8	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	1407	1395	550	12463	18974	jx9hsg5aYF7LQ4L8pprKHgibc5cY4RopPbE92LDxgPmY1R2ZGt7	13890	19586	19586	1619464680000
28100	3NL2bveucAkkLPiMvzaFWA1WeE6MLLKTqLC5x99RZUNhACuEsLne	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	596	1060	550	12463	18974	jwqe9ucSH4qM7Q9MmgBCww5n4zqRZnxcrzx3wGbRxYz37P9m837	13890	19586	19586	1619464680000
28101	3NKotBdfZ7p2bHqHCswQZ4N8vJc2Uxw8nsz3MLDba3XvW9or65uz	28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	1656	1343	550	12463	18974	jwKnmGq6zwvm9sNKeikhpqMJfJcXG7JTv1hbyrNMTudUtu3imyB	13891	19587	19587	1619464860000
28104	3NKCEXT3RtpqczoQeDm9xpunchYmscxqzV646oNV191PbujD6cDN	27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	633	1384	543	12463	18974	jwL3d1LeUuuB48VsfM5Tne54XdqYMwcPTJC6dxfXTUK7AFLVaEr	13758	19590	19590	1619465400000
28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	633	1384	550	12463	18974	jxYMMXjFtiB3ztTMGNxjjJcogiw66qPcS2Ea4eSC1fhPt5SGYzg	13893	19590	19590	1619465400000
28107	3NLmwahCK9eoCy14oCQz4UvK1WP4H2WY1AA4hiJkdWEqxiXofBcy	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	1490	908	550	12463	18974	jwakTSX61v9QaTgiwuTXDyq3cqbHck8QJyjEVewoJNc4FSktWBz	13894	19591	19591	1619465580000
28110	3NLoWDW66CAzSiiAiQ8FnkTKZC6LTjFo3vXpk9uwLk98bts8PxME	28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	1419	139	550	12463	18974	jxziykoUYgJjM4L11wRwsotDp8sjx9PaCv7oeMynEYYXsKHNGEo	13895	19593	19593	1619465940000
28113	3NLDJt4mjj23awTCByrV6Qr6HonRrXBj2QWJDskiPSHFuTAAjdhG	28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	298	942	550	12463	18974	jx1oPwFX1DFYeQSiWN4TUfvEcfWn7M6orwM9F8hj88QrDeWbqtU	13897	19596	19596	1619466480000
28116	3NKmPpPkxCkTcidJzjssSEAaMw31rBrCutvxanChpCv8QWqphBvK	28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	1483	520	550	12463	18974	jxzVhWqavFZtXQnQcxtmrRqJL2CfjubnKsWVUvy92uZMeag3pem	13899	19599	19599	1619467020000
28119	3NKRFT2E8ZBehY7mbcvVHwC6pSryM3ztc9ngTUdCH9YjYFZbJc1Q	28118	3NL8ARjuhTzV88KLB3CVrfpjsWiEShto9u6oqPLarUazpZTZNytc	1637	816	550	12463	18974	jwWYCK1NNy4TQcbZrA749mgUaTFGFiCakU8uvSLkSy76yJiWp7a	13901	19601	19601	1619467380000
28128	3NKosAeLmePRwbvr1D2vqvk4LN9TF9ZNXVxci7xPVySz4BLUbNWZ	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	1648	1284	551	12463	18974	jx9UVhuBxvQ1d8A6dxxQyMQvXxYBw4z9E68kmC9V2NiaDRbyD9b	13904	19605	19605	1619468100000
28131	3NLEq3T3mG99HLgbvtYswa9nQ6ChxzyKztECeTV5odEp5D2hKZ5y	28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	1657	1344	551	12463	18974	jxPZSdUmRLVUsP1GR9W2TdSh4A3LrGRgoC6Mpocyo2bBpT3s5dq	13905	19606	19606	1619468280000
28137	3NKyu6cH7WgpD1f4JUMHcsdYUQ4HPiUu692fT6we9bXswwngE8Lw	28136	3NKBpzVTRwJsA6pBnoEb7hBVZWjV7Sh3H7wQUzGMyYt4mwr2qQaT	43	1064	551	12463	18974	jx2i1tVcTFSREbWH8dwdq7yzmeSLngSHuKbbacmbFrKPR79ZMkp	13908	19609	19609	1619468820000
28140	3NL6Pgqaq5MuqjfyiBxJF3P2rxumRzLCybkezVsV1UzK6d5D4Em9	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	1460	597	551	12463	18974	jxLnrnQ4cNQWGSw5emvvdGmB8VJ3bQqeymEHcNpemyCFmGJCK1y	13911	19612	19612	1619469360000
28143	3NKTFSVv1VYwESJhi5fZQ8w5uiPLMDucx27tdBsuc1JQs3Wkkkzc	28141	3NLQ71ZhauDdQdGgGgCrLUZvRgSMb5v9evfyZ9aksSctgDWAH2U4	1668	1370	551	12463	18974	jxaiezfJyBevmSi58aF9MkEpVc1x9hvdar8E1yvYpnsu3rZMQPV	13912	19614	19614	1619469720000
28148	3NLYZ2LQZmenyVPqEFfnhxRocDkesoyCNBV3qAkR3pHpYdaVaNxu	28147	3NKDocauqcuoJb97f9pmp7jeeKidvaQGyDJrWywZVDapBmZCKqxM	1507	914	551	12463	18974	jx1DDemNP2kS6x4h4Mc3mpVcvarbbXw1Nc22QTwwpLWwqSzsgAe	13916	19618	19618	1619470440000
28151	3NKj7qaBLvg6cV4z9vRrJbBLk9DH5Xc8JvZMQBLs7bFU74nrsKHY	28150	3NLLrfzCk7eXezRFmqoC4nizwkCQ8j6adkPzdUCZdSfZsi8ioszB	1675	1342	551	12463	18974	jwH5vQYoTYrf7oTSksE1NYUSv1E4emybizithbtQsBznr8yVGeT	13919	19622	19622	1619471160000
28154	3NKTvSAFtFzeG5HWqL5akhiyZHx1iqwQs617fZN7JVAZYLFmq3y3	28146	3NLToj85vZU5rvafQZingfVkRhCWYswCx5BfLGckd8QsqMJWF4da	1553	776	549	12463	18974	jwEgdRVDNaYH2br7NBXSD8vSMzLkpwMiVNzV96iqnQDrG44H5ei	13874	19626	19626	1619471880000
28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	28156	3NK51EPWT3A9XtQ9BeZrckfVFbZqa5XwGXNuTJxTncaWtyUba53z	1403	824	551	12463	18974	jw8DsTrkxke5aiCWviyepuHc4DJbQKZcWx1uPaRN8DUnhNqPVCC	13924	19632	19632	1619472960000
28159	3NKYyQ89fT1uu4mmfQAk4WAiUu4KLe8do6Bfx3XAzdiSk4GGNv3n	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1402	866	551	12463	18974	jwbbpyhfjxEB1B62uKfAVRpGCWPMNV8puiNawqc8dEhxaWiUyvE	13925	19635	19635	1619473500000
28161	3NLNN1yh5Zij4UdscRKv7B98Voq2q9FUjjCGGdGVwUatdQKRMiXE	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1623	830	551	12463	18974	jxEf17oTnQmGGo4AMPP1DdwK8NMK61nymUGHgNEW6sAFvrfJAFJ	13925	19635	19635	1619473500000
28162	3NK4Akk4sZCnjd8vK1dKFZX4jQJhM4o8Ddg2sY3CZM9mKa3ns4Sz	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1631	794	551	12463	18974	jwLpVS21R9t2iBCtjyFNs4r1s6vLb2EEtBAc42uHXbrTLBjtWdD	13925	19635	19635	1619473500000
28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	80	1273	552	12463	18974	jwLSSfVsMXYKub8R5q5HkG5385jAPiwPjhJNLZTzqQD3pYHiEZ6	13927	19637	19637	1619473860000
28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	311	1181	552	12463	18974	jxhPcLJ9DsxrxEdUiJPNnMifdebQea4GvWvuTwZoZ9Mh8aqnxRn	13928	19640	19640	1619474400000
28175	3NKN1Nwof6pYKnMRCzpTnQrtYnfiCuMyBBnnBCaYLd6ExwZj4Uco	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jwZusTPpEpKiFy3Dh8LasAMDWQxSrtqkSnWmQYgLWqG8stioRqB	13929	19641	19641	1619474580000
28178	3NLvCjp9V7kAEHQvSfWFbkxgNVt5ZLSf7ht5cfYo2nZD8DVDtGdH	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jwrSCKmaLGyNL3XiyPtPTH6hMpcg2TFetQQks4DoBFXviA6ELqU	13929	19641	19641	1619474580000
28182	3NLAkLsu8jxMMtLGaXdN4Coi9F3Mrwezgb1CPPkbYuLGiNrKPGPJ	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1656	1343	552	12463	18974	jweHo9w17KjrfxFpTYcp99dNXv1bKnfYqTdRYdbiP4fYpXQhWq2	13932	19646	19646	1619475480000
28189	3NKzBXmvq8424Q74bNVzn3bjKxpxFbhif16aEv7x8mDBbwfAa9SU	28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	1406	1393	552	12463	18974	jxUC4nCDbqFTmKJwM5nB7qY7TUE48AGkSUXu3egHq6rHkts6GkK	13935	19650	19650	1619476200000
28191	3NKgPb7HgwQP5j2f3zvXRz9A8iXiV7UdGYjMRHyVr4ip4DocGvsg	28171	3NK8qhT5W1Y93mnmXA9WXYDBs8rSZGemkAmBiTGebwUW6ZErkKtx	1553	776	549	12463	18974	jxt9sUjeLniCvQx67jRbf7kC6x7yKgtqKRLuteBGEG8MYeDrhvB	13876	19651	19651	1619476380000
28147	3NKDocauqcuoJb97f9pmp7jeeKidvaQGyDJrWywZVDapBmZCKqxM	28145	3NLw8RCbVf8PcVLijakwPUdD4GCnJe4CfwQfakxytbgtcd9G97KU	1631	794	551	12463	18974	jxcf82PXrkTFXaLe3QVgYrL8Pm3mBW2P1zZETamAcSo2FWt5nYt	13915	19617	19617	1619470260000
28150	3NLLrfzCk7eXezRFmqoC4nizwkCQ8j6adkPzdUCZdSfZsi8ioszB	28149	3NK3sE6WDbHhBdScfyqrr6dtCghKmGJBnzUQotKQNLwjeueenKA4	1657	1344	551	12463	18974	jxTEQNye7DjxUojddpfHaXqgrzrtAAnBYWKngaCvnA4q2rPy7HY	13918	19621	19621	1619470980000
28153	3NLRFJUUbsa249fvS6xA6Dz5p1dyt4jSQNbc3mo4G9iXTv7KnGrK	28152	3NKPwujiTy44irFfQqfNUgFNeREC48ibbDmv99hUnpcssUnib8LB	1657	978	551	12463	18974	jwdpSb6DyWZ38uNQszvRBSNdezJgSn7USFe4Zh1yuM87zcz4bBJ	13921	19625	19625	1619471700000
28156	3NK51EPWT3A9XtQ9BeZrckfVFbZqa5XwGXNuTJxTncaWtyUba53z	28155	3NLs9GEaEebFFw6tmaS9b29cU15TcpQid7UPzkKAErkvB9AZ9j9U	1631	794	551	12463	18974	jxvFa5EXaQbtrEYuGM28QeW3Zck5aDnjruHk8ryDARCJPw9JGpx	13923	19630	19630	1619472600000
28165	3NLVvfpjSVbSY4g3hsJVE4gHUckEihVftdCMhPxHgmNJibvr8X8C	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1509	1320	552	12463	18974	jx87rqRmjn7APSCaVJMyBgBxiX3om9dhcmajYFqarCbbmeEmN31	13927	19637	19637	1619473860000
28167	3NLjcFboqvQCnSg7CqYpUpe8d3EfuWm4Fxze2nBbQB2zhg7Twh28	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1406	1393	552	12463	18974	jxnZ2EGjYMdMaGgNLUFUTJHLixsj2pYqQMCYAnLobQvmxA5hAqP	13927	19637	19637	1619473860000
28169	3NL9qNrjbKdnt8KtDv2rxoVzDAdZyPnyXBwATifSPuHYZVJMkVJr	28001	3NKmRTQJJG1JC4d6YWFNvJhrydKefS5as4mkE7je1WCyFZx9yR5Z	1513	1379	547	12463	18974	jw9EeU9K1D6zaVvsuxCQJKv5j2TxbLA6fXdVM1seo8Wo76ReKV5	13846	19637	19637	1619473860000
28171	3NK8qhT5W1Y93mnmXA9WXYDBs8rSZGemkAmBiTGebwUW6ZErkKtx	28154	3NKTvSAFtFzeG5HWqL5akhiyZHx1iqwQs617fZN7JVAZYLFmq3y3	1553	776	549	12463	18974	jxHh4zdTfnCY5m89WrvcyajiMfQUsfevtGh7xwBwVaxsSxoQ8Rv	13875	19638	19638	1619474040000
28184	3NLkX4yMLkG43X9isnRHvqVRrAYHbgq3y1rFanq7fPwLAyDauft8	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwaqBn3NM9NJQxEg2LKQcTW5R4k5PSoeNEYyw1EbhocyYR6dxYp	13932	19646	19646	1619475480000
28186	3NL6NctReexZqt2tKYGQiPxvWV37qUKKN6khoHcitcb6SipAesd5	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1637	816	552	12463	18974	jxkQhXyGQpH4PVmQCFCgkaPztYVM4bQhUvwqELcdxFjNRZvyfex	13932	19646	19646	1619475480000
28187	3NKzviQD4Wh8Gq8ezvci34U6igqt5YxjG3EGGc2GUsZsw1aGY3uB	28185	3NKHEtdiHhakoz3m4vhbQJgWUEG43cBmMhHWdLGwxEC1Diji3FsW	1406	1393	552	12463	18974	jwXwcvpUdkwzrgjNtGc6oqMgfSRvGhm6S9RpeBNYizCQnkZMxsP	13933	19647	19647	1619475660000
28192	3NKAnFsmX7gFJ5K1UNPJAzv7xxM7HnnesKRnArafri39uu5GCWEB	28189	3NKzBXmvq8424Q74bNVzn3bjKxpxFbhif16aEv7x8mDBbwfAa9SU	1439	913	552	12463	18974	jw7duNAtAeMtz7Nk47sQqM7yFjButpT8o619Auba9KxBR4kS8oX	13936	19651	19651	1619476380000
28197	3NKLoQ9D3dTxR7rBZCXM2irPVYKCnhkhg6MmegHYSNJZ8xVKoE6f	28196	3NLtLWo3ioKi1vTUEHh1ZUMLTv7jYSjikHKmvntTFQfqBsDGD4Rt	1406	1393	552	12463	18974	jxFGnts11viiRKTvsUfMdLJ3Bq8reZA3EC9Yhte8Q1Nd3PS9dxX	13940	19655	19655	1619477100000
28207	3NLKQcMRAXk6uvhR4NxopL2siEa7oLDZi9WuHiSx1jFeoZw9j33q	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1407	1395	552	12463	18974	jws8ejBRviQ6pPTsggJWZ99CK1dEKfwFSjvU8sNVeMoUFSWkA8c	13945	19661	19661	1619478180000
28209	3NLqn4KYdyakPASxhB7E5i6CMUNmGP5LmXGiadGsbt7TtBH83JRL	28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	1662	218	552	12463	18974	jxuGTSTV4vBErmZ2uczmGvU9kaiA1rBWxtbmUDBM5CytAUMHzBp	13947	19663	19663	1619478540000
28214	3NLVNhg75JxYSprQjwYNFiud97u4952ZK6sAhthEA3pc4tRHTySq	28212	3NL5YqST5u2Bq5wP5srsRSyp9mS1foDU7eCYFLaHW2sWHFyrydW2	1406	1393	552	12463	18974	jwJpDNd5xDRSp5dDk545gzAJKgpyT8Buce98uhLFFiN92yuCRaK	13950	19666	19666	1619479080000
28217	3NLqBB9NSW1qSpgr2cQ2LzvDou2WNq59rJhFEgNQobJNSwUKkTo6	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000
28221	3NKdZPizzXsUxN2P44PpSLEaDfhD2M6QYUDUW2z8ypW6DQESspvv	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1403	824	553	12463	18974	jxR2AHLsSrCxnwnjhLZbKb5uJHJDUC3R6YGi1vN7zFuX9JHP9KV	13953	19669	19669	1619479620000
28223	3NKBkPFPLPmTxSre4EF7k1soaYuHpsnvVRRhLANbyvFJFArRvt5W	28009	3NKcVFuLD3DQD4VmXs6ho8z7jewBSr5n96BSrvT3zQKyDMATAV8M	1560	1045	544	12463	18974	jwQ7hTVkJk2Gkb1d99mxtocjbgFrjRtqAWMpSAAVAAXESPrCeC8	13743	19670	19670	1619479800000
28228	3NKNV7h5Jy3raJ6a5htiDo1CVGDUKucK4ZTPwyoWALG1xUs22JYg	28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	1599	1161	553	12463	18974	jxudC5xc3S5zvV2b3dBmGmZFZQMsrFbZ1Nbwgj28oguS1Zm38Rp	13956	19672	19672	1619480160000
28231	3NKBUeFaS9HHiLy5eLHC1WJrRFfeFt6EjrGaacWfEBhnXEAeX3ou	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1534	1317	553	12463	18974	jxhdqqm454gsJefPVNPfpCm5EWZ6pHiPvKzQeDRPqRdEfFNxHAy	13958	19675	19675	1619480700000
28238	3NKiK82utVXSmsGkyKkBJQwgDgxbennUfeiaqfw4z6dy6Xy9TnNW	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1623	839	552	12463	18974	jwhaWFdtE88JGECTyGcmSthxXxJJ6j5s1P9PEoTuLcwfENdxBnS	13943	19678	19678	1619481240000
28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	28240	3NLkshjxpch5shHqaAyAL5FjbS2ohfHLFAfGZmteetVB8ARU2MNN	1407	1395	553	12463	18974	jwn359DLMePNqn5Fv1QMBBBe5CwRryVhTNstLRT89teqMAQe3hv	13963	19680	19680	1619481600000
28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1407	1395	553	12463	18974	jwGwhipw9AmF8w9PDBAWZzZigiUiGGbNoKrGnL9u86U1kjuzEzm	13967	19684	19684	1619482320000
28249	3NLgAbwyRyiojL1Kh9wSgdTDbh1PpCZPt6usWPp6aoeK2Q4eyDWC	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1440	1131	553	12463	18974	jwyTYMFs4zDTwXXfY5BEB9HNjPThuURp5KGjkcxkWrBW5QuhJQg	13967	19684	19684	1619482320000
28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	1668	1370	553	12463	18974	jxxnJornY8xtsFZWTkpmCKFd5Hf3NRzZe4rD5HSA55Vz6Tt4DAo	13970	19688	19688	1619483040000
28256	3NLsP8NYHw89PbUzTwsqnLuFsfCdN61sXxbRxb8evUYUeuLMfRzV	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1406	1393	553	12463	18974	jxii59HdXqztN1vr7snrdDN1dizQ2K9XC7HAfq8ez3Eb2e2GzfZ	13971	19689	19689	1619483220000
28259	3NKALd5Ub9CkJ7txUsKbPsjD2h13VxKfzZhj9BZYyd88Nb1uyHFN	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1542	1304	553	12463	18974	jxCjFWnVsu3w1wyzy6ncQgUZ8dQHrdJdbUqfBxKgNgqpGgxbi9C	13971	19689	19689	1619483220000
28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1406	1393	553	12463	18974	jxnesMHATGUCrnDwmENNPPt53pzBxLYNVXwxeUreds6B7Fs4NWR	13972	19690	19690	1619483400000
28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	28264	3NKy1jgpnBBUebNWN5GverytCZCPgNRmruLhTj9KFE4hja6XE7Uo	1407	1395	553	12463	18974	jwxdtxc6CYYJK8gVMdsRC4GuVPySZzKe5BMw61LaJgzx1VPgDxB	13975	19693	19693	1619483940000
28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	1646	1108	553	12463	18974	jxNGUifPgSnLF68hyqY2LkD8oVWY38XdZSuUYNy6e2Mu9sktWxj	13978	19696	19696	1619484480000
28279	3NLYjMXYkUcrVVjE9kyfVN24nnWpGW8ArbyG3WkUJ5qgxgDZo79T	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	1406	1393	554	12463	18974	jw7ksD5o57vuNWBFPHddenZMCBcHksZT9omPU7k3ZaX7dbXgHKn	13980	19698	19698	1619484840000
28174	3NKXxRSTmJJQst2p7gm76EsRhQwSQEzwG9tevbn7mA1VwBsFNkhy	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1671	1365	552	12463	18974	jxFDwBdCvu5JQr7NadPZLFEV8dkcZXyCNo7JC1LnWo2USgn7SoU	13929	19641	19641	1619474580000
28176	3NKFBG5rxkixMGmjBdLQ4AKAN1JESQdwNzs1suEFDTbG8z5S4bQq	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1407	1395	552	12463	18974	jwEsA7kTk6inwdKnApvTMJT3Sdb3FqjedPc6uwBwfHJkU9RFpog	13929	19641	19641	1619474580000
28177	3NL7r2jNDDDgCwBc2uB3CMpiSUytmTGpeTsdbWaeNBG5jcpW3RAY	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jxeq6UK1iNgo1x6NXdQQYgPL34tWLDHK7jGKPJBrLr54oSU5r4H	13929	19641	19641	1619474580000
28179	3NKaTStpetkiFCsfM4G7vZLZCT2gHfKbXdGnvG4RLP6tm675xy5s	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1607	1348	552	12463	18974	jxxBJPQgXKEvXfhGXcRe4kuZbryUvn7g3ep1P2GYi3GLD4Q1KdF	13929	19641	19641	1619474580000
28180	3NK8YPDgtQVeHTjDRoEva4qm9AERiaW78ZRtAFY4qYBetcXZRrfi	28174	3NKXxRSTmJJQst2p7gm76EsRhQwSQEzwG9tevbn7mA1VwBsFNkhy	1648	1284	552	12463	18974	jxShAuJSuaKKYht9gEtuu7LHs54JTgEG5bMJLCtdGq71k2ZeUiC	13930	19644	19644	1619475120000
28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	28180	3NK8YPDgtQVeHTjDRoEva4qm9AERiaW78ZRtAFY4qYBetcXZRrfi	1403	824	552	12463	18974	jxiiEoymhm8xmjSsv83y8eyJMYSM6EtxUWpHois8dUEvtsrNXbY	13931	19645	19645	1619475300000
28183	3NKxcBcH6abx96pcjzPg4NS3rUEeZSyi9q7oJ8G5w45L8u9Hu4zA	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwBgVfQyZUM6bdfgCu7cjSeSFgF2f3iqpu7TgGVvY7R2wNUfrRS	13932	19646	19646	1619475480000
28185	3NKHEtdiHhakoz3m4vhbQJgWUEG43cBmMhHWdLGwxEC1Diji3FsW	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwUBDrYmKdXPuaCP8uFjm9CtriLtScQgWJWgJabEh9KQaE5uNRW	13932	19646	19646	1619475480000
28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	28187	3NKzviQD4Wh8Gq8ezvci34U6igqt5YxjG3EGGc2GUsZsw1aGY3uB	1646	1354	552	12463	18974	jxP2r7mc3Mrnf2PUR1vnBmQHZkAwrnBraWPeBwPdfmS1r2aqeiq	13934	19648	19648	1619475840000
28190	3NKqXWnAdBv8Zi1rFpeeSMCHEdc146jfe14VH5GuymGHNgksxFvQ	28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	484	1319	552	12463	18974	jwhcLnK3uC8dXLTzgq4QPUbFboVLxAKr9wE2pJ6oQgEaqjRJHBf	13935	19650	19650	1619476200000
28193	3NKchsZmaaqeJS9wxtrzsWqqBV5Mz4Y8bb7Jfi1vnt1mVM9RmvLk	28191	3NKgPb7HgwQP5j2f3zvXRz9A8iXiV7UdGYjMRHyVr4ip4DocGvsg	1553	776	549	12463	18974	jxvHG91kjT8jiPg6FZnRnAaLkGrm6dEsUBig4CzhZZ71gbEeGJt	13877	19652	19652	1619476560000
28194	3NLLXaSEjCW3cdaFaFRYcSQAkzNagjGpS5iqfBmbkB8pvXF48tFk	28192	3NKAnFsmX7gFJ5K1UNPJAzv7xxM7HnnesKRnArafri39uu5GCWEB	1526	290	552	12463	18974	jxTnyNeV4DvC59nBwGgbLA71sf3cxatPUiH9pHLspakVECLuNT2	13937	19652	19652	1619476560000
28195	3NKDvvYg6SyTDuhrsRzqeFnGDtxQQ9SWZupmthScVtJfvP3vJxaR	28194	3NLLXaSEjCW3cdaFaFRYcSQAkzNagjGpS5iqfBmbkB8pvXF48tFk	1422	971	552	12463	18974	jxHUMDc8RyiqqsvK57tVgBpKRufLJskY8dA4GCUWRyqtnra9p5g	13938	19653	19653	1619476740000
28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	28197	3NKLoQ9D3dTxR7rBZCXM2irPVYKCnhkhg6MmegHYSNJZ8xVKoE6f	1471	1386	552	12463	18974	jxezcXpQrRA2dWJNsNHLZw4Y3XbJZ4xmdKVCsJjyak2kS1bBarp	13941	19656	19656	1619477280000
28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	470	1309	552	12463	18974	jx3r1BQW3GueR9mQ6rCsA2pze1y4KUKEXMXnq5ismh7Z5Tuc2gR	13942	19657	19657	1619477460000
28200	3NKPZXCf1oVrcZLcyTsQP6ainGX3DzV5XNqMakhaBUGycMWruT7n	28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	470	1309	552	12463	18974	jwHzrh4K9W4Hen53XGhbYvto9Q9sQMaZHYTwCLakKGm96GcKJrB	13942	19657	19657	1619477460000
28202	3NLV8NdXjsT4ptNsh1XCBrbeFSmpwF96Nt4tAT7aX64iALMemvza	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1406	1393	552	12463	18974	jxETq5QtfHMbUrqzebHq2SKGCrKb2snoT3yvxugEs93wL3MQTkT	13943	19658	19658	1619477640000
28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	28201	3NKtPHvJQ87ECuueoNQW1gWZM5o2W7Z8TeLjvx3px1wDnfesf2xE	1637	816	552	12463	18974	jwnomGz97LFR7CPhfu2UGjv2PtWG8BabrEpK5Xate3SnDWgnNmC	13944	19660	19660	1619478000000
28205	3NKaAdFGyY15AyjSH75QbCwVq72DK1yfJEhhSt4d4VSqK9fhkEFA	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1642	1241	552	12463	18974	jx8o3hf5xbiGDSCMroxqDeGWPdhtgvfEYfQxGF8zr2SywGwLjK2	13945	19661	19661	1619478180000
28210	3NLp5szkAJo48pQKkQAfpp4x2pU7mr5V42zEtsyCNcU3vigrGC8u	28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	80	907	552	12463	18974	jwtei6jzdps3KqZ6eiz7aqZN9teCk4bf1e2cbDapNbXekLQ3Fhk	13947	19663	19663	1619478540000
28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	28209	3NLqn4KYdyakPASxhB7E5i6CMUNmGP5LmXGiadGsbt7TtBH83JRL	1596	1117	552	12463	18974	jwyeopC8aqjyrRmikPa5mWxCAmFmetG6z4wajRHRbyfmZ7xnGcP	13948	19664	19664	1619478720000
28212	3NL5YqST5u2Bq5wP5srsRSyp9mS1foDU7eCYFLaHW2sWHFyrydW2	28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	1589	920	552	12463	18974	jxq8ciWgbFgScFwwfUqL7pHmL2pjq1jHfbQijcbPZRTNxdLU3Dw	13949	19665	19665	1619478900000
28213	3NL14ne2EVngNsUthWMhckSEk4Vpni2FrcP2PKdLpcAkSMQthXZK	28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	1593	1346	552	12463	18974	jwd6c5LaFaKktL2y1rDFrjd7Pxw28Vk3KovGgWjJ7XF1mjD37PJ	13949	19665	19665	1619478900000
28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000
28219	3NK4md7wnNG9dQwD2GG1EYVUwctRKEvndL2LAT59BU4R69aJNw5g	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1406	1393	553	12463	18974	jx5at5CVm9mpuqVtjuE5sEqQTrgQ88UwZTMtyHttFDUQEABw7e5	13953	19669	19669	1619479620000
28225	3NKr4NQRaMA8bsBhQuo1feUHaoikTEeqz7kTsdFnM8UPvKhiXnJJ	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1426	1364	552	12463	18974	jxo8n4pKy2JxpehrLV6ZEUwX3kkLCFETBDEYLkcbs5hHYVTfPBK	13932	19671	19671	1619479980000
28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	28224	3NKd8rzswzBvTXBSsE8eX1tb6Bx8nqQjBQueycFTGUqU1N3ZBzHa	1426	1364	553	12463	18974	jwVbFs8fem3237RHYBFodyR2BBJ5zuUqoYvcGZdipfbiPaXvKSv	13955	19671	19671	1619479980000
28230	3NKSMpz9EGjjBJEazqUzEQF3LcpkBFGdK2ihC2c77ecHYht3e1yx	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1501	1234	553	12463	18974	jx1BrSoF4vR6AJv84eWeoet1573k8hSDaNicem4NCQCWfoh4sJp	13958	19675	19675	1619480700000
28233	3NL5eEmsxb6ij2VAZg6h2M9ogyczZH89pbT8jMJfJo2RXo1HZ7JG	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1577	1327	553	12463	18974	jxqs8JmUoJCTQYBx6dv9xyzcj2F4dbvzfesNTtfcVrmmoznowen	13958	19675	19675	1619480700000
28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	28234	3NKAAc7E4aRAF9g7epFqJ2f2dRakxM19LtmyZt9KsdoCNPa8btYV	188	188	553	12463	18974	jxysZ2bXX6f764tv5xLhsNxDdmPP21hxhEi5iYVmjTZK8yeZbKg	13960	19677	19677	1619481060000
28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	44	1199	553	12463	18974	jwGgxZ2a4PzWmFdmWdXedp7ja56f7FNL8mjqbjZcHCBFDQ6QQ3E	13961	19678	19678	1619481240000
28239	3NL7QVYnTLkMdG3KVikbzrLMq52JzjU9NjTCn9aqpQEKA2bsSuM8	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	1403	824	553	12463	18974	jwDZ7VDG4EFE1puGMDuCYgqgfvuRQPdo9LBmPXZhewsEW9gSUCv	13961	19678	19678	1619481240000
28196	3NLtLWo3ioKi1vTUEHh1ZUMLTv7jYSjikHKmvntTFQfqBsDGD4Rt	28195	3NKDvvYg6SyTDuhrsRzqeFnGDtxQQ9SWZupmthScVtJfvP3vJxaR	1403	824	552	12463	18974	jwbc92xcrrnS74VgVQzdk2LL6Hawe5T7xwDKV4mBs5a7CuPPjaJ	13939	19654	19654	1619476920000
28201	3NKtPHvJQ87ECuueoNQW1gWZM5o2W7Z8TeLjvx3px1wDnfesf2xE	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1467	1130	552	12463	18974	jwmQFpcrngQM11rHbb5Gu6uwxdu2PF9cjBMPT1dao5nPu7r4TNU	13943	19658	19658	1619477640000
28203	3NLCzmi7VxzPLUyXH4AMfaLmFRyVVGKNKPGdQDV9CvxDFd6S3qMR	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1555	1221	552	12463	18974	jxyqFnmVbew4hDjQmbH3zb4mEgrP81nBX95EnmDKfbthCX9P3aV	13943	19658	19658	1619477640000
28206	3NKLY9NTbByzv1T9mtbbaeuXMPCy4n7nG2E3pKDZAbwjo93qM5iZ	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1656	1343	552	12463	18974	jwcz4dxdC18wJJxTpzPd69vy3HMkWkWtAFZiwTAwUqJoQxSackA	13945	19661	19661	1619478180000
28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	28207	3NLKQcMRAXk6uvhR4NxopL2siEa7oLDZi9WuHiSx1jFeoZw9j33q	1406	1393	552	12463	18974	jxAWbZcpAETnPu1dQVEkqLnHSuZS6rs1MqsDWvsfdD3mKuu6VWE	13946	19662	19662	1619478360000
28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	28214	3NLVNhg75JxYSprQjwYNFiud97u4952ZK6sAhthEA3pc4tRHTySq	1476	1371	552	12463	18974	jxbbQ4p8Z9xYVG7Yvgafyqr1JM72wqs6BbJAz1HgaeCmy9xxaPe	13951	19667	19667	1619479260000
28218	3NKFgSGukVqJUS9spvzxb9coyT9CZ9BHqokznRLN4K26FyXtPc6U	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000
28220	3NKJXRusTDozaHyZvtsdPZYt1o9P72x6gH6zCQxkLSYhrYvnAKfz	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1585	1366	553	12463	18974	jxWMP9vnUj5AvrvwecakgNcvkhkAKbQEPkZRFF5bxfV3ZCkKGnL	13953	19669	19669	1619479620000
28222	3NKGA5soHkgeVgMUeRw8ed8Lotb1RhXfMXrodL17Gce4NdcFwpFZ	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1549	1362	553	12463	18974	jwRVR78DUssKf23JtESJK1FtCzJjDnizXxUyd7fh2f8e6r97P29	13953	19669	19669	1619479620000
28224	3NKd8rzswzBvTXBSsE8eX1tb6Bx8nqQjBQueycFTGUqU1N3ZBzHa	28219	3NK4md7wnNG9dQwD2GG1EYVUwctRKEvndL2LAT59BU4R69aJNw5g	1560	1045	553	12463	18974	jxMMF4h4A2DHMCHAuAsry1CShXuPAVTSMihjNM33qcL6PyzdiK7	13954	19670	19670	1619479800000
28227	3NLFepbczgXy9Bsy18E2MYTqLfMwvC5KrRzL6yyckf9yZZTMMVvY	28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	1476	1371	553	12463	18974	jxYJTVKEvWvnKc6La92L1bG6ukoAQT9JyKnR724EdY4FbYCrK6w	13956	19672	19672	1619480160000
28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	28228	3NKNV7h5Jy3raJ6a5htiDo1CVGDUKucK4ZTPwyoWALG1xUs22JYg	1536	947	553	12463	18974	jxRi3bNtrY9YFcPJi8MtbMZ1tf2DdguzyUqQ65Swi6Vni3rNEKP	13957	19673	19673	1619480340000
28232	3NKVx9GK1usGvrT4rGYN6jJBu2CwmhYMFHHg2wpZh3Yiph4vxyaV	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1419	814	553	12463	18974	jwYw9B5MDCPTFHgkNKLDQMP2SPVdoswfo3WJxkof9i3vV5mnULc	13958	19675	19675	1619480700000
28234	3NKAAc7E4aRAF9g7epFqJ2f2dRakxM19LtmyZt9KsdoCNPa8btYV	28230	3NKSMpz9EGjjBJEazqUzEQF3LcpkBFGdK2ihC2c77ecHYht3e1yx	1500	931	553	12463	18974	jwRR6PRf7f6rxCcHgLJs1QUhXg8pfa8CRGHArKnDzXFZcLVqb99	13959	19676	19676	1619480880000
28237	3NKvGmsGsv7sfSV7Vu6Be8xn8ZkgxNHLn63YVvTT5QJ43SVctveP	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	1406	1393	553	12463	18974	jxFYUSUffmD6hh9v2UAbCVMtXnHRW8M7HUAnGJBtN7xCsXTx9iG	13961	19678	19678	1619481240000
28241	3NLs1VbsruiuJUNYkdEmeJdWG4XSaGNnVKKPfU3pV18qddSMvtHr	28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	58	1035	553	12463	18974	jwcYctpXsbtSHj2jNcJUACuDY7K4pkk4cYuyjASf82Kta8aAa61	13962	19679	19679	1619481420000
28243	3NLT2cSmrBEEcncgv7efxFXpTqxuCwHpP35ZM23jzcvHBoAEJyJi	28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	1467	1130	553	12463	18974	jxN54J1eDmE5qtZXoZYNWKJSvMyjPkadafRWS3piB4iboHHQZHE	13964	19681	19681	1619481780000
28250	3NLvynfpPEyKq6YePPZAka77REE4CDW3cKqwatT1pT9Py78DXkh2	27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	1440	1131	542	12463	18974	jxiBNXz5n39Hfpdy5AkwkzyNg1LUn8PStBEeFrkrAoGydEprK3e	13730	19684	19684	1619482320000
28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	1637	816	553	12463	18974	jwHUDjV6dxwCvDkCaeY5YAL9da5oBXNSQEMYJDUK4MzbV17zedJ	13973	19691	19691	1619483580000
28266	3NKXjMnG79uBqf7nU1AscmtFFGgvUAFhyvGXhnQADpWoe9JAm6dP	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	80	1147	553	12463	18974	jwsJVByY3A5cmFbzMpJ9R9YvuVC6sZpqBvX8otsoXCAk4456iFb	13974	19692	19692	1619483760000
28268	3NLQbsocT1FnSzt8JHsYYvP4sMr66xQZvM4aD4KWFQ8oRk5STt3k	28193	3NKchsZmaaqeJS9wxtrzsWqqBV5Mz4Y8bb7Jfi1vnt1mVM9RmvLk	1553	776	549	12463	18974	jw82wErrcPDebo23s4PdNo32BRcRLQbFjpDSsbthvwXDgKRrmig	13878	19694	19694	1619484120000
28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	1546	1213	553	12463	18974	jwDceQM7soConBS8SRR9rGVouudY7gcCGVdJLy7rcBdVp6enDHH	13977	19695	19695	1619484300000
28275	3NKjH5iKPr5VEFbr7mQNb7SmedA8UBQQtb9URHXM4Cfm4iXSuvjd	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1613	1349	553	12463	18974	jwGCxfgsrioCCc1hwkghbpCp48svVVkjAXHSBkxz4QfjyZMdJ2g	13979	19697	19697	1619484660000
28277	3NLSNWbq4zAwbprPoiusP6pMfp4wUvvepF2jtiSzgZEyhwj3AuyW	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1651	935	553	12463	18974	jwje451HLgH5DZPXLXmGVpBv5MDreStZ975oXELmgpbEraaPVKR	13979	19697	19697	1619484660000
28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	28279	3NLYjMXYkUcrVVjE9kyfVN24nnWpGW8ArbyG3WkUJ5qgxgDZo79T	1407	1395	554	12463	18974	jwGkWd7vRsLL3MyNpcB87DXMHrZxWbfUKWqUstV7EScx2ck3k2S	13981	19699	19699	1619485020000
28289	3NKfL2n3vFxn5ada9gyVQcwqbW9HUbo7Hhr7jHCqaPi6DpheFqB5	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1599	1287	554	12463	18974	jwzLTTNLRkQJgdQXMzx9LutewuYgWXPFGA314nwskPrA4FwcdBa	13984	19702	19702	1619485560000
28290	3NKdt7okqZBhXhEmdikXv3GQtJszuaGc6pPnDeCf9utjhbNwvAF3	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1407	1395	554	12463	18974	jxpEXzKVS1mmJ3JUgkqxUXYJJjW5xha6xC7PJvK2Ww8C5oNx7bZ	13985	19703	19703	1619485740000
28293	3NK3p9oYE6VPZkJ8jEBGCLsjZ5pVqiMD9dpNpYbAjn61JaEYbCie	28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	448	1179	553	12463	18974	jw7V7V3V4NGsBSxJF3sbTPvVde6pEFAm8hp6s3RYsZxa4U4MybJ	13978	19704	19704	1619485920000
28302	3NKQ6ZSKaT7ER8kotqP2uVkEXMXW33Z8ektT2EuPwaTwLD9CaPSp	28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	1419	813	554	12463	18974	jx6JXeD5cN8J44FW9wmo2VNCx5fnVAV1JYFrbVgCfSXqZ9v6GuD	13990	19711	19711	1619487180000
28306	3NKsEpRLgWb1d2F5S1frvzRvz2YWau7dnBytqt85EY9oF4paRoZ4	28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	1651	1175	554	12463	18974	jx4yoaurqxMZiyjG7PsW3vxJ9eGPU3F4WnEJCL7reNcj1szDTdY	13993	19715	19715	1619487900000
28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	1585	1366	554	12463	18974	jxt9JUzBFnCiL2CBkeEyT4DkkuB8TXjFGNPKayibtGPdp3LXgCH	13997	19724	19724	1619489520000
28316	3NKmJcvihPBLcEgQ9uexDJ2ptUaYsrcmo4oJ3TRqH7Ja5DMwnbQN	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	152	1084	554	12463	18974	jwXanY4JG5BWgiTcmt7bmneKuhTeCY6yq9JDzFbDqg4mSAYAg7e	13999	19727	19727	1619490060000
28240	3NLkshjxpch5shHqaAyAL5FjbS2ohfHLFAfGZmteetVB8ARU2MNN	28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	1670	1282	553	12463	18974	jxAmn1xkCrFBTKjvUNZRx3oqiRFL1U6VooSc3osvfqGZjXTd5GY	13962	19679	19679	1619481420000
28245	3NKjVsUYG5eumYGrT9RrYrVEuExo6SdqumMVumrqXfTAvk2na6YH	28244	3NKPRKPwkmqGajTDxYxoBCg1KCCnGqTvoN1Z3W7Zemrwj1fNbvEv	641	1090	553	12463	18974	jxdXowx6Jf5Po1ymx9qBJJJdzc6YNwttKCQLVZihvR1N5e3NYWR	13965	19682	19682	1619481960000
28248	3NKFWCMKMgJGWBbnbLJpvsfpfoc9DpHuVy2kyFZgXTf8vVQYPXGR	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1440	1131	553	12463	18974	jwvwCAmUCTmiX2SXmM4EMyFcWBRf3XPscf4VDBq7sV92pUyXbzp	13967	19684	19684	1619482320000
28252	3NKPnFQtXgfMiQzq3sXPWjZ1k33gAybMMPy1UyrVJzqZEqakCPud	28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	1403	824	553	12463	18974	jxVKJpAgteMuewbLGjCoY6zpyQ4MBwKhJZKZk73vyofcDLFiHXX	13968	19686	19686	1619482680000
28258	3NL7KbXbhX5fJ7r9KQ4dFMwARbhMY6pEWSvbQVFkGwxcJNj6ptCu	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1477	1224	553	12463	18974	jwZSdSwvgzhQvBDtaeFjoFs8juSCV6shcsQuWYMPHwM6Fnuhdtb	13971	19689	19689	1619483220000
28260	3NLE9SZ1MLZbSjwZu8okPZgxv5KiKfNcA9mgMu7nt5uhHth46Xwu	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1483	320	553	12463	18974	jwqTALnsct2VcYpbMD2SEBRT7Pgw9dbbW3LeDDujfG6YuNp5Sng	13972	19690	19690	1619483400000
28262	3NKktibwiwHQ8MTx1r2jfHTkJsCYmkSbks2ojq6LFWF8B6fCu8Fw	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1481	790	553	12463	18974	jwqkBffsoU4JBk1np5DYEXstBquHPpwK11TQjduPrpiQ4ixJXtb	13972	19690	19690	1619483400000
28265	3NKaab5Kp5ybZ8M4BqGLn6FMq3SWkyPhLPQBBXi63rtN6h15eY52	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	1581	778	553	12463	18974	jwYeHDNG4mjd4PBCCRjZBmzZYRDcG4mhkahgTjZr6BMxUaB5eqS	13974	19692	19692	1619483760000
28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1637	815	553	12463	18974	jweEuDHmEHvxBk79QaMv2sXr4rGNiC9Ukr3UUS8RwYS2SZidbNc	13979	19697	19697	1619484660000
28278	3NKKggvwUityPpT4vd2PXGfHPBQaX5qEZz1mxtPScYD3H4fTEYTE	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	58	1155	554	12463	18974	jwipfJq4zs2eQeJb1jFQaJKvgGErm1v6PJ8fMhTi5ENCRi4wL2e	13980	19698	19698	1619484840000
28280	3NKwVdXjZuHeXraHriuCiPb95DYParhEnwshdCsYE5pctHLG1irs	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	58	1155	554	12463	18974	jwipfJq4zs2eQeJb1jFQaJKvgGErm1v6PJ8fMhTi5ENCRi4wL2e	13980	19698	19698	1619484840000
28283	3NLmrGqP4XfAtx7iZH1rrCUDMMxUSDSj7N3uW4EYWoW87S23gw6q	28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	1532	253	554	12463	18974	jxFvQ9BpZ3FjRDYShnfWDUk9M7mMKwKYTvdKRyMdV1RW4DcEYeV	13982	19700	19700	1619485200000
28285	3NLqHUfTNBCGMNtkVKexiJ9V2nAKn4F7KyoYLpYkuKM7SoaNVzwT	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1406	1393	554	12463	18974	jxuDMpZ31VcGY6kGamsEiHnwWWxTPPEQ14woWsx7LwUoguAmgoM	13984	19702	19702	1619485560000
28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1559	1107	554	12463	18974	jwtyuEnfKQx9GwvJocqQ59Zw7MXJ6j5omRhgceyy9EWyJdxvkHq	13985	19703	19703	1619485740000
28294	3NKDucvNKQy1WeSJ9hntFJ5VQFwAKZmEddxyTnncAVf1WVPGJt44	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	1509	1074	554	12463	18974	jxYjG5ppQ8avxjKFBCHN9Vzy9dQrSoL4wkAUmzBGGNqdvPgj5Wt	13986	19704	19704	1619485920000
28296	3NL3XKQtkLT8pikcoehBY8k8BYmvRDF7z8Ftt1AwNv1eiYp2aSkM	28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	1405	881	554	12463	18974	jwJSywN3pKPkCk7j7t1HSowmFe4x9mk3SQJyUZg3FStVzDNkDck	13987	19706	19706	1619486280000
28301	3NKVm5RDsZLhbqpq67UB5vVMGDNX3AW8aZs23LjtdxbAr7xZ5XWi	28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	1403	824	554	12463	18974	jwxxGDEcAtdcfgStcVsPcH2c5Ezv6N9GVWvcKBqDFbpT7jcHck9	13990	19711	19711	1619487180000
28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	28309	3NLLpSR6Gx9EyqzcSwE6LAm2fN1BHETnM7yn6PoKqru6Nvi7wXia	1579	1389	554	12463	18974	jwNmwEfpMEsu9SaQJTjUw9kinN5RQ9mhVWfa2YEEPum5yNuZCsJ	13996	19723	19723	1619489340000
28315	3NKomps2UjbqqPfuLLNAcKLPDQm1Tg5Wes78nLEpwueRWaiRdyP7	28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	1578	1296	554	12463	18974	jwX4dCPUJeQkBxWRxqux9fcaf5oD5UqRHA8ce4h6bRoyUhMsEy7	13998	19725	19725	1619489700000
28317	3NKBDNqGUjyBUwV1U6avFVAJnVi4yrtDmzJJfnLiZGzCWKymt6fF	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	1631	794	554	12463	18974	jxcid9DhwXqovWfi3gQqF4MRYf33j6LRAHGNEiiPzsKsPyHouWj	13999	19727	19727	1619490060000
28320	3NKDrCML2LVfqEeRa7EjHYmMdvp7EGs8Hqxk39SJ9ZtsJr5kYUbJ	28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	1547	1132	553	12463	18974	jweSwbQt2n4j4U8bHtxSdtCo8wrxnT8Gs1Uh4VvWtojYRXvXbYr	13976	19730	19730	1619490600000
28325	3NLb8TtnXQAavsSdSrw5n3PLdVGk4aKmV8dncEJZqPBpx1icH831	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1451	926	555	12463	18974	jxTqSUdSqvhNmFjCzDPnusMjbFkkznyrNycdDLoPS2Ftph59ahC	14004	19734	19734	1619491320000
28330	3NKNSTf9URzWL5CWp175eEaFq98oVWTzXPzF5PPvya2MdFcNt9fN	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	1536	1313	555	12463	18974	jxytzhv2QjWgi9f9CAUkgBb5dT3wNdHy2Ht6XUHuVoi9qEbeFpv	14006	19738	19738	1619492040000
28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	641	1090	555	12463	18974	jwXzsWFnkjVu4sQ1yfQ6xNP9vEjS11StrvGdx24vRipJtzxcQ9v	14006	19738	19738	1619492040000
28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwNr1XGhyaANrHjetPsAxXnqHiNgrd6J896ZQGs2Q5QaEfui1cN	14007	19739	19739	1619492220000
28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	1617	1042	555	12463	18974	jwtqRFydUEDw4deRBxvqCXio66h5BJ8y2DL44M4RZb2uwdmWpfa	14008	19743	19743	1619492940000
28348	3NLEmeiGQJ22DUFJGU6bZQ8d9dwYZmioZSiXSPixLbkW41np3sL3	28268	3NLQbsocT1FnSzt8JHsYYvP4sMr66xQZvM4aD4KWFQ8oRk5STt3k	1553	775	549	12463	18974	jxggTwHi8TxY6TiqzuFW1hdVdtKpQ9cNWkgQiuNq2bxpnsxqWW1	13879	19755	19755	1619495100000
28351	3NLnrxhwPRokvJbsENNs63v2BAmddcy1Ci99qgwySoPPy87ezbe3	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1590	198	555	12463	18974	jxNgZUcd3F2Uki96PX2dUzq4Wqk8eW1TCv5T1j6yvJJ6NwPN6eQ	14015	19756	19756	1619495280000
28355	3NLbbE6yg5MKQ1f59nhaJFKiqD1Asz1vvALAprkFfXCJYy1uNa1u	28354	3NLNDmUhr5zk4QvTF1CHe8ZBcq7q2egeWswAQniWW8Spp6NjsyzW	1403	824	555	12463	18974	jwqgcTW4tLrGAHWqDE3LFqbve8mtgmhSydi73v57Z1b1GmHQJbQ	14017	19759	19759	1619495820000
28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	152	1330	555	12463	18974	jx6gDnWBBwp532jBNn9MD8U7PWKc9Gk8hktaQ4xYq9DZ85CzVAZ	14020	19762	19762	1619496360000
28362	3NK7ZtzRG2rq9HqJJyJXmJhcFEoRem3mTpCrWkXJnWLLEEbLfovW	28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	1458	1077	555	12463	18974	jxJ5QHhBRibTDcmYq2kzyNJViAFqocTibYMUb9G3f9MD8zWQy6u	14021	19763	19763	1619496540000
28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	28363	3NLQSJUcVTCfyThFcxXE2187zrEmyF81xUJeD5p7vy7B67Tx8Yow	1610	1068	555	12463	18974	jxoEfdY6knjYLWqxCDG6WR9LfAg8ZswDaEt9zpkhPcJS9xqHVFt	14023	19766	19766	1619497080000
28244	3NKPRKPwkmqGajTDxYxoBCg1KCCnGqTvoN1Z3W7Zemrwj1fNbvEv	28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	1489	1380	553	12463	18974	jxEChkaKEUadybXNK4FjBpic1ktWPEgQtLS9WFSgV5yE3qrrabY	13964	19681	19681	1619481780000
28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	28245	3NKjVsUYG5eumYGrT9RrYrVEuExo6SdqumMVumrqXfTAvk2na6YH	42	1361	553	12463	18974	jxaZTr1WHcfsQWzVrmecXQuBwynoCGjdyHDNXHcr5gLJcnRp6yd	13966	19683	19683	1619482140000
28251	3NLiTSViDULdp2vntyNLtsLcgnS45wPNJAmwUHyUXUy5NzAcNfqv	28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	1483	41	553	12463	18974	jxj1PgbjuwLTznpDVZkpVbLKiMPdFx7op2Y1fMcN8pSzPxYxU86	13968	19686	19686	1619482680000
28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	28252	3NKPnFQtXgfMiQzq3sXPWjZ1k33gAybMMPy1UyrVJzqZEqakCPud	1460	1324	553	12463	18974	jx9kg7voF2AQogUQbxk2KRd9b4oXGRw7GZ8ScHrBmdvnMcJK5Uc	13969	19687	19687	1619482860000
28255	3NL3eb7sUsu7sp3eUmkzgNY79VdvmEFVYAmrhjjfRTcRfFwqqyjb	28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	1406	1393	553	12463	18974	jxCVCnp1WKrDBexVwLugSSVPsxKHtC3qRmFNE3G3Rp96DiFAfW1	13970	19688	19688	1619483040000
28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1402	850	553	12463	18974	jx7H3HeyFRdQb4UzmkftNwuFkJnmh8aDxYRgjvS8WV2gpUDxrqW	13971	19689	19689	1619483220000
28264	3NKy1jgpnBBUebNWN5GverytCZCPgNRmruLhTj9KFE4hja6XE7Uo	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	1406	1393	553	12463	18974	jx8WrXccBSYHex19c359n6QrgGmFR4KmAstS8s5H8T2tPXvdzvi	13974	19692	19692	1619483760000
28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	1509	1194	553	12463	18974	jxtQ4dj1C29FvUrf4ZfP9o9uj6ANjDD412deAzw2FA4qoTvwheN	13976	19694	19694	1619484120000
28271	3NLLzpFRP5ttry4bfaeTNFdvwp53XD1GVviRiwmDC6y4fSoNfq68	28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	1649	1017	553	12463	18974	jwXAHRTFL1Q6wnNHVLn9mZDLxSEA5wYSKauqPGpqQwBZcaKcjzz	13977	19695	19695	1619484300000
28273	3NLPX1xxeLWoNrJQuzCrLh6pv6mrknjHmxga6mmnQXhvbJShuofv	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1542	938	553	12463	18974	jwFTo9fPgcTUbLxMC2DjcAyH9JDEAnhZrMLfiCUF72CJsU6W1Jz	13979	19697	19697	1619484660000
28276	3NLB8wXsnkioek16fMk1BHJqcwqoTgMB8trtgp93abMVnf6T1tDw	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1651	935	553	12463	18974	jxjKN1NP85qWeQ8yF2uVPaVnTV11CYYqHuHrsSpGdaHjZSYzr4Q	13979	19697	19697	1619484660000
28282	3NLKTdpwcmcBVxyv7xuRjaoCt7rdbYEdZc3CcpaLvqvCfFH1wtcC	28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	1407	1395	554	12463	18974	jwd8G53coxD7dj8aWcnPT8dB9VVJXX4DEeEkSUG8e4U5eds2cEX	13982	19700	19700	1619485200000
28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	28283	3NLmrGqP4XfAtx7iZH1rrCUDMMxUSDSj7N3uW4EYWoW87S23gw6q	42	1115	554	12463	18974	jx3Ppt3HgBKauRbrTrZpCb4sXKsq4G2i79CdhoHDFVhrX8cqxnS	13983	19701	19701	1619485380000
28287	3NLyNDUvyGM8evUEoAbJ7rKrvUsTe9ZEDC13m6B3aTc6PGPbvEBD	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	43	944	554	12463	18974	jwaPqnhLotrBEMMpfQpcLSoL632rz91EeDPraJcHzPqdEzk2xLx	13984	19702	19702	1619485560000
28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	448	1179	554	12463	18974	jxXZzc3MJjdtGbETxY6EQfoUPxZPUiciixcYcHZMWg8sfUHjCCR	13986	19704	19704	1619485920000
28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	28297	3NLXS7nds37PegEXzNCQwak38iYQUUukb4pc26ApJbQ2csMvYJbi	58	1281	554	12463	18974	jw6d2yd3dszpAkdm4F73LDNHQpbzfXtv9xrBydJjYhJNHA6P8Ra	13988	19708	19708	1619486640000
28300	3NLWadHvfEEzckf1y3j9fgPxvSGzvK6isB85QF7ZLjjZRcuoPf9w	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	1474	963	554	12463	18974	jwjnDnX3EBe8Q38R39SAhinM1gPDvN6GdA6bVPuN842JtctBjYg	13989	19709	19709	1619486820000
28303	3NLR1j7irUUtswt7iMBmXKi9U1hNwUDkxsCAuY3jCM2b3wRpA4HK	28302	3NKQ6ZSKaT7ER8kotqP2uVkEXMXW33Z8ektT2EuPwaTwLD9CaPSp	1419	814	554	12463	18974	jxboRxK4x2c4MNedVcehpnNskud3DgGvGsW4WSePtTZKstWTE78	13991	19712	19712	1619487360000
28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	311	1061	554	12463	18974	jwgPpoUTCsLa5prMMUJrPYkKT6ZaV7fCjPs8CNsENAQAa3pATuV	13994	19716	19716	1619488080000
28309	3NLLpSR6Gx9EyqzcSwE6LAm2fN1BHETnM7yn6PoKqru6Nvi7wXia	28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	1406	1393	554	12463	18974	jxnJdM8yne5i6qReJQfXLvmEmAEsYVw5BhArtsLkxgMu5FpUYwr	13995	19721	19721	1619488980000
28314	3NLH1pxZpUQ36pgkwoaMpbz7CYorRDqpaYH3dZCGcfwkX4SSCYTp	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1578	1296	554	12463	18974	jxHJwbhWHczsbufUDMMsTSb3WEW5P5ZQg7edYJCczZHTHxVc2rP	13985	19725	19725	1619489700000
28319	3NLAWCty2dpkvZLWk7P4Bk6mQvTXZ2mBJigKpjYqcm4dD9Kb5vJP	28318	3NKRFbk8kmdcK9bdMEh3jST4RmAU6EPVwtQ46665BqRJQeFWkoiD	1402	810	554	12463	18974	jwYoAsaKm2WEDQzZjWcocnB9gvJq82bPwt7nkf1W622XD4wwPYu	14001	19729	19729	1619490420000
28322	3NLihba6daaGLK4mT1aeWq3zNRVGdyUvjwc8HQBXvBn2GTgtoPfc	28238	3NKiK82utVXSmsGkyKkBJQwgDgxbennUfeiaqfw4z6dy6Xy9TnNW	1623	830	552	12463	18974	jx65BqpNG6ibdJXKkLWnu5Znk4sQoLar9B4DasszVCQvCTTyT39	13944	19733	19733	1619491140000
28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1445	924	555	12463	18974	jxSk4ftH7NNf12MiJzEgXJXZafcJKnPGPnyT3zJ1ovgXPe1yQDv	14004	19734	19734	1619491320000
28329	3NKUbGDUgu7U82pNWVuLHynUdsJwuJbfY17Q5AW1JnQxv1aY3xq7	28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	1549	1362	555	12463	18974	jweXvQGA6ibH4NufZbV15oDZzysZCZehGyyAHssP1TsSRVrkrwM	14005	19735	19735	1619491500000
28334	3NLUQvojqbux2fPmQuRqxiMxhU88JxUBkF9ZMRSTvfu1yXcmaKfQ	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwjSjFqYNViTB3kUjnkGtEPdBML8vjER2qpEW9jr3uYBJf5JYMM	14007	19739	19739	1619492220000
28339	3NKhQeLYxiq5NKYa2Ci1QnM7VwdEjpHrvU1zBMzo37FAPQHgZMxv	28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	55	278	555	12463	18974	jxtKzWvT383aPzkxM5i7cZneMgCH71k78eH3VYv9BZt3M1UgfMS	14009	19744	19744	1619493120000
28345	3NLDMzPk9kRHHT1CtoLRHota3y2hVBgcex3As3TSigDBhCQWuJDn	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1617	1288	555	12463	18974	jwURZ6ggNFcUCJkume7RXvbWY83CYtfDDEgCQbzx6cH6WDD6kKK	14012	19750	19750	1619494200000
28350	3NK9EYWdbWkxehGNnmxoxYHH5U2yjCc7GsuAFK8bryfKKx6EU1DZ	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	43	1064	555	12463	18974	jxPoPMbqBi4LtCxZ3eQZ6MTDbvoPjTA6aciC8QgqRSuWZKX98Wh	14015	19756	19756	1619495280000
28354	3NLNDmUhr5zk4QvTF1CHe8ZBcq7q2egeWswAQniWW8Spp6NjsyzW	28352	3NLMhNTaUpoFgyurQ564FUHDSXnd7dRH6pHzU6E7h9EDcuz9Fvcj	1559	1353	555	12463	18974	jwHtvjXfdXcGSTgT8Uv1xVhXZRdMnKChvzAVnqVhbihWeMjcXZ5	14016	19757	19757	1619495460000
28357	3NL69qAzPPUUQUD98fFyNH6fwzUPiCLo32xxSGPbxTCMxCKYmWQ4	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	1675	1342	555	12463	18974	jx7yuaXxkazMjcrLJpwub9idCYyEowv2D3UUTWSAiEXDA1smRJo	14019	19761	19761	1619496180000
28364	3NK8FAstAcT3GGcQKmztaf5BBggP9fjvuNJnmMeBqDRYe2Xo2XR8	28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	1509	1509	555	12463	18974	jxB9stTM7EnSMcM2qow71pyXy7HhHEFKcFWZKYDMDDymzL5YRbA	14021	19765	19765	1619496900000
28286	3NL356rxfnmKb8S4wXNurGoNSUjhJ8i38tBzq5qpmBbiTF2xLgyv	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1609	1333	554	12463	18974	jwLqEUxHHcEJ8SZTZBYJsqbr7scWswKxC97XLerCxzsVnj1JnVB	13984	19702	19702	1619485560000
28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1476	1371	554	12463	18974	jwqTC1riXScibgDR3dw7nRhDTHGKw8uG9p58eiitU7HHaBy8i7t	13984	19702	19702	1619485560000
28292	3NLLjeeB1GZXs6s2QPXPYLsVGtw3TYnsvf9wdET2pkoQp8V4VoFQ	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	1668	1004	554	12463	18974	jwguPR9bUA6SRx28EPjsVy6zSE769GdADkoSGhtw28XLVCLji6u	13986	19704	19704	1619485920000
28297	3NLXS7nds37PegEXzNCQwak38iYQUUukb4pc26ApJbQ2csMvYJbi	28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	1483	877	554	12463	18974	jx1gtP8zWyHrdtT1ueYTU8D1LNW2VpihXMSYqxKURF3JAPCSBQy	13987	19706	19706	1619486280000
28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	1402	868	554	12463	18974	jwMzv2wWsMtiAcfzdFH7QKFkD3kEduPUs58W4vDbi7gk857jhvc	13989	19709	19709	1619486820000
28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	28303	3NLR1j7irUUtswt7iMBmXKi9U1hNwUDkxsCAuY3jCM2b3wRpA4HK	1451	1292	554	12463	18974	jwSsrKyywYLH2hDXFYBBsSmLGXeJRWscRfGSfXq2bD4aNz4BtvD	13992	19713	19713	1619487540000
28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	1651	1175	554	12463	18974	jwZ2WF1GVN3txb7f2g9q5XB9ojpTECsCbHHbuiFKNnLqPQmDnoW	13993	19715	19715	1619487900000
28307	3NKzaq9PBUM5CyekYgWLB5yXRrrbYSTsj3CtMRmtEV5jyxAAYsmP	28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	311	1061	554	12463	18974	jxHifTTLsAhVqVpbeBLakDB8TAQoXqvKj9KeWopN5cH7hQ3r85N	13994	19716	19716	1619488080000
28311	3NKBH9HCkJoywCAsBb6vzGWZc6eePk9e8iUPAjWMeRfUsMyZJBPp	28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	149	1037	554	12463	18974	jxB2o3nCjWDXCfdUkRdctDLozTesQ2z9caJxzDLwFSH9GskeTbo	13997	19724	19724	1619489520000
28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	1406	1393	554	12463	18974	jxZkUovQM1tfGX4dqJerTxEyBaRn3z32AdbRj6Vb2Zz2TD1FWrw	13998	19725	19725	1619489700000
28318	3NKRFbk8kmdcK9bdMEh3jST4RmAU6EPVwtQ46665BqRJQeFWkoiD	28316	3NKmJcvihPBLcEgQ9uexDJ2ptUaYsrcmo4oJ3TRqH7Ja5DMwnbQN	1407	1395	554	12463	18974	jwRXjxZKn6h9JJey1LUvxFmUVjakwpfVr8nPfDDTjd5QvPHE11v	14000	19728	19728	1619490240000
28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	28321	3NKnr9qvWLpcWsAmheRAb1qvY3WFpw7J5rXViqFNq3v3X8AEf7Eq	1581	777	554	12463	18974	jwb7AYvXtjrTCjhpvgKtgbdEXDBtyxBDsXppk95bAs4eGB3qVkd	14003	19733	19733	1619491140000
28326	3NLfjrNxxTVEvUNMLfQ66oC3fqiokap6v44TrEHvZpQ3GQfcbSLm	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1501	1114	555	12463	18974	jwAqwB97WthMtzRu633YtL7KRYbs441nKj9MGjiqJt392mCxqqm	14004	19734	19734	1619491320000
28331	3NL6kZ1f99Njsw4DcRhZ1nFKje3umW7ckWPBfoaLmqAHupYuBzV2	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	1608	1043	555	12463	18974	jx4GSQA8nj8Y7jwzfNzBNzGWCQfn6aMatvrXFUQYMZgchdRPmM2	14006	19738	19738	1619492040000
28338	3NKQ6kixnHmPRYL3mUCv18sANJKZfEshXyFW3jhCF9B5Jb7kzdF2	28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	1522	1322	555	12463	18974	jxqRRqNhtbWyEEKTRfT1shdzVXd81AXvtYQ8LQCudFp4R1Htc7p	14009	19744	19744	1619493120000
28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	28338	3NKQ6kixnHmPRYL3mUCv18sANJKZfEshXyFW3jhCF9B5Jb7kzdF2	1670	916	555	12463	18974	jwoW9qheMXveNb2F8AF3qxfm8GzQhhqroms4KG1hUcR5oEfbxim	14010	19745	19745	1619493300000
28341	3NL1MqeJULovMtcUFGmDj4jNY5uuiQS8MD3fDcy2ze6DRyESSHAF	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1406	1393	555	12463	18974	jwvqHk939MWZUM1JKymcsvWh7DXsym5byzWPR7bGgL8QinHM4r9	14011	19749	19749	1619494020000
28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1403	782	555	12463	18974	jxtMkCLiShC2JDdoPr7gJvQscBnMEBS3Jniz87ktgZ2qLWejDoT	14011	19749	19749	1619494020000
28346	3NLrR9TbisjkC1fVD6ZaVYJWisLdQcmtqvvvvnSCo7afdEJUTfAE	28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	1542	1058	555	12463	18974	jx6icTxpTEB2vdYiyTjCb4f3DFrhHN8UzHXKNysGUUDQuj1Xep6	14013	19753	19753	1619494740000
28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	28346	3NLrR9TbisjkC1fVD6ZaVYJWisLdQcmtqvvvvnSCo7afdEJUTfAE	1585	1000	555	12463	18974	jxgZLwfeBpGiWXTWNqM2Cwj2BdN3TnTMEf1YxEy13KHt8sTDgkm	14014	19755	19755	1619495100000
28353	3NLkinYNyErKVX52bBjQu1fhwhXw1CtNrDpSqg3MJhzQGUuRMeHH	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1590	198	555	12463	18974	jxU6b7VZon5wRM4ZndR9AgMRCsjxRsXt6XPkXxzCZUprUDCKRma	14015	19756	19756	1619495280000
28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	28355	3NLbbE6yg5MKQ1f59nhaJFKiqD1Asz1vvALAprkFfXCJYy1uNa1u	1668	1124	555	12463	18974	jwdS1t72B2ZGfAK42Nwa9ah5Uz2TdmHPv4jGw1mHnBfJ4QiZtGg	14018	19760	19760	1619496000000
28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	632	1136	555	12463	18974	jwzxY2fPQsB1HijNQeymppjB8ADyuvmzwKFAohCKfnRKNfbCZux	14019	19761	19761	1619496180000
28361	3NKGFTQdh1cCdDJDWijbvcwgxomgsaZdN2PwDR9888z6dbMZwLxY	28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	1619	1149	555	12463	18974	jwBgarKrroNeqno41fd6JtCSjLyP8FNendZzkSE21uk745b7PrX	14020	19762	19762	1619496360000
28363	3NLQSJUcVTCfyThFcxXE2187zrEmyF81xUJeD5p7vy7B67Tx8Yow	28362	3NK7ZtzRG2rq9HqJJyJXmJhcFEoRem3mTpCrWkXJnWLLEEbLfovW	1509	1509	555	12463	18974	jwwjjAERQNqhMMj4RGk6VdcebNZXfreYat5mziV9zJ6gm2wrEPZ	14022	19765	19765	1619496900000
28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1571	1209	555	12463	18974	jxDGvpV16qYujHLgDs1JUa2jkmx1jqGQ7bxLVVAQjRPFR2xQfrn	14025	19768	19768	1619497440000
28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	1406	1393	555	12463	18974	jwiQYjdQqziXGcpsrWpHAHhSS92mV7Fx38Uthpv7x8e4CagTBEC	14026	19769	19769	1619497620000
28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	1403	31	555	12463	18974	jwLpAHdZHEexqQcqXPZjs8ZL7WkXhPK6hTub2iUeSUdxtSqrsx2	14027	19770	19770	1619497800000
28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	28382	3NLW8C1Bc54TxLw6wDBTPXhs23tugYu6uoxEzjnRebaHKXBnkrG6	1587	1111	556	12463	18974	jwAPASgtzL4NHdKf39nJLQZ4sNh1mSiuHeQNwwR6NekkvosRbmy	14031	19774	19774	1619498520000
28386	3NLRc7MQ2ToM6eGFXFPi6Veiw2XwCq5dHKXhz5DoLkFKf57XkuSn	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1406	1393	556	12463	18974	jxQEhQb8QMEws8FjyZdho8wQNzy3iMaJTSdg4gBxjoYKVmPJMsd	14032	19775	19775	1619498700000
28390	3NK9tQMB126Cj3yNKQSJjFtBsztnnUjiXJfEQbLs7f2F61QJ8sMv	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1593	980	556	12463	18974	jx7AturpJxmTXZYR3Br5cjDpEjxxzN24ds8TuJRYUqEihLfiTvw	14033	19776	19776	1619498880000
28392	3NKnstvEjhXgVGgjN6xNvs7HsY84U9VGt8XShYqyRLyqL7wFuTx9	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	448	939	556	12463	18974	jxCA1v2zkGnmGtU6drAuUzKT3qfsaBY2bLo8UpvhUALGrPpW5nV	14033	19776	19776	1619498880000
28321	3NKnr9qvWLpcWsAmheRAb1qvY3WFpw7J5rXViqFNq3v3X8AEf7Eq	28319	3NLAWCty2dpkvZLWk7P4Bk6mQvTXZ2mBJigKpjYqcm4dD9Kb5vJP	1547	1132	554	12463	18974	jwRshw1oBESrTC1nmrmtAr73h1HspBsr82PHGQ3K2SJKUjZSYQM	14002	19730	19730	1619490600000
28324	3NKSwFWCybWN2vb4URnCZYyPywo6FrEdiP8AjxoJkcnpGDjBuftC	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1451	926	555	12463	18974	jxTqSUdSqvhNmFjCzDPnusMjbFkkznyrNycdDLoPS2Ftph59ahC	14004	19734	19734	1619491320000
28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	1467	1376	555	12463	18974	jx6w1kg5eVMRenSZqYujt33Tj2yvUEUjtv25VSDd8E2Uvg8p7FA	14005	19735	19735	1619491500000
28333	3NKoDLzgwf1DNZHY9dePPnoQiPSpEUPnaqqxmrwh9aBs5WPBToZo	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwZSWPobaGFL9uckqJ4FRzX58NbWFYqf3hFcea6aGfbCBiAoThn	14007	19739	19739	1619492220000
28336	3NLwBDkMXabgwbfXiYsaEtpWRNTutZoq2siNQvmZSC93nJqzV8UC	28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	1509	1074	555	12463	18974	jwP92urMcPyt9VLZamooh3f33gEoRaMaCTwgooRRANaPPBmtap4	14008	19743	19743	1619492940000
28342	3NLGRYrNATfjUAT4t4NnML1rx9NrceDeH4TNn3pVNPTuPWzKdFzC	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1609	1333	555	12463	18974	jxM4aLGpChyPhJ1Ds65e1NL4uESG2BGD3FWAakDhk9TFVpgDZ9H	14011	19749	19749	1619494020000
28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1627	1139	555	12463	18974	jxYnhhPfEVdCbsqUZosfVdMUHBiktmpx81mp9MpbSo81zwGNJtr	14012	19750	19750	1619494200000
28347	3NLAvattKqMcvXzbzNYG7hKSVrT99hzr53dHRzYDMWCVMnWZZ9ys	28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	532	1303	555	12463	18974	jwqMQQ9VNfWUb6CPhJtshWj5S89c48Rp6wg2hdYqPuariieYeSB	14013	19753	19753	1619494740000
28352	3NLMhNTaUpoFgyurQ564FUHDSXnd7dRH6pHzU6E7h9EDcuz9Fvcj	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1481	790	555	12463	18974	jwBkEPDkSj3EHEeLkzc5Zm61QfoPm8MaVxLX1TUpnVgZ1r9nDVM	14015	19756	19756	1619495280000
28359	3NKxKzcunuX2fux6GXpLMqWV1WgrPFzKj3gJ1BXjj6CuyPQBcizv	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	1559	1107	555	12463	18974	jwUDuMgiDXLcxWwEfADMxFkewE2jB2qrRaChZMsLimYNW5sb7Bm	14019	19761	19761	1619496180000
28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1589	1040	555	12463	18974	jwdQwRaVQiqP4a7WmAabGojZW5Ck8NUKtyqVd1nkbn6ijwvRCQK	14024	19767	19767	1619497260000
28369	3NLVsEzvh8j1zWjQxD55DvW9HDVZq1xwTDEf5L9U3VomBgyU2r8X	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1501	1360	555	12463	18974	jwBU8gweEtqXBKGtuQgsombp1D9SQTaq8HrLLF4YnzCfYXMkf6v	14025	19768	19768	1619497440000
28373	3NKmKyQYo8oJ2LEdv6vDerdxNKzKmrbR636LTCjbmbUikumwQajC	28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	1633	1390	555	12463	18974	jx9G2Dn7y7vG44aQ6sP8MEr7BMoAtm6USgLZnL1AzD4ok9gNxN5	14026	19769	19769	1619497620000
28376	3NKVvqwmEtfrFi8svc1ehfggriWdTegGYG46Aeht579D6xCYrShL	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	484	1319	555	12463	18974	jxk7K3SVuWDjPekPH4JyQ5EY5BRUUPBQbKznoRT4nnsiSfaqiDF	14027	19770	19770	1619497800000
28377	3NLSqR7kCykK1ajCG8SRn3AorTrSfe5Pz84p2qn5BxfUCoiKVgC8	27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	1508	1387	546	12463	18974	jxeFZ1XSGn6rSzFqEL53dW9idEjKvpThBvPfj317yPGELVzecdQ	13824	19771	19771	1619497980000
28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	1419	814	556	12463	18974	jxTGWwR7HhMmdCSeVjPNi2SXXF31TjgLdX6hnFKmDxMw9y3AFbD	14028	19771	19771	1619497980000
28381	3NKv8Lvc9GkfcbU4ELj4dwczAJaxkHphdKKTN2qQxiuK5W6k1RTe	28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	1506	598	556	12463	18974	jwvT1kfi1opTfCBzZPQ7qWCXa7kjRSrhDEJtWJmJXhaUyZiqG6H	14029	19772	19772	1619498160000
28388	3NLssJZifJ7NzYaGUdfET5jSZVhTokU6dywdvyCcaLsg79JAyYyS	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1503	1277	556	12463	18974	jwxpNqvtq8CLi5xXKBtq82n9qBd2s6HvZEbGE1LysFAqPnxWr26	14033	19776	19776	1619498880000
28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	28388	3NLssJZifJ7NzYaGUdfET5jSZVhTokU6dywdvyCcaLsg79JAyYyS	1407	1395	556	12463	18974	jwLhSMU9q5kb7b7vHVBm8qvNg9qAshRMF5FHc5pwgzCRBMyJkeA	14034	19777	19777	1619499060000
28399	3NKdRjLE3HAoGzdt8gE2Nk1c9pK4BdVFdoZZkgyDosrcKShLwC1B	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1407	1395	556	12463	18974	jx7cVm2x1ZvVmw4bjF46woShQ85LriWqFrGebBEJGcDWjzLApKu	14037	19780	19780	1619499600000
28404	3NKUgVVaScH9cAK9uUrvCc25CKSBUV5FTi7Sk35w3G84FjBFH5wp	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1407	1395	556	12463	18974	jwmtpMQrTHnCYVJqKEYx7rkSVzZcZAfS9F4zXDMV9KG36eSaMBs	14039	19783	19783	1619500140000
28406	3NLRAApmycER9rMKGpvkbo9e6vj1ch2kycDafCoa5RQNtncDeP6H	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1541	1298	556	12463	18974	jxowiJQCZqDffL3CytpSCcAS8qa8uJr1hvuoA855r3Ug8VArtc1	14039	19783	19783	1619500140000
28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	298	357	556	12463	18974	jwizybFMqCQxvYcX1zauFS49SLQgsM91iCSRpfDFfSsbBVXwzhg	14040	19784	19784	1619500320000
28412	3NLqUaZUvbkyKofNBLu5TchHkT6eAA21BfhNhkDXPwqjpobSsr8J	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1509	1194	556	12463	18974	jxL6byXjzayb6D4bt4yXhEY5ihQGPvK7ck1jesFJGSMFJTgG7uo	14041	19785	19785	1619500500000
28417	3NKjfcwPPJVtf7ZjQBo72zfZXJKhSo7UpvtsHweJM9BsrQLL71Af	28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	519	536	556	12463	18974	jwgpfAA2Lskfx715DsCvTLBeibTYTa2yMWSkJ4PcmcRP4xr2XXr	14044	19789	19789	1619501220000
28420	3NKMMH2e3oNc41qXJSrP4YsD1vfYLyUzLoWjvm8z8byAKVSB6BTs	28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	1559	1353	556	12463	18974	jxEG7bZCzfTpvorJxHhJ2tP7WTiP6UUmW9sc986rXwUzWkwSMWT	14046	19793	19793	1619501940000
28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	28422	3NLrVyRWArZmwBhhbF86x5LKxQULK4nQpC3jFvCd2EWm6Tbn2YkD	1654	1340	556	12463	18974	jwss1DrRrRfA78NphC7k7bR7NrYYxvhVfbxmZjefLbqofGhtJ7a	14048	19801	19801	1619503380000
28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	28425	3NL5yofKp4nP91aGuJSoLtjhaM13k2vyK4HMTBfuZBvUBqnLDWWQ	1637	816	556	12463	18974	jwJkdLm1HPaVxWX8bbZ1rXpnMoVih9niyANjCfZVVc9uE23QJF8	14050	19804	19804	1619503920000
28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	28432	3NLaQyVc2citK5fFpyDPpExHRrv4s3sN3Jp42tkpLxLnJn7Lcus4	1407	1395	557	12463	18974	jxxZipEti46p3fKXTydUrxyzCBz7LmSwsvvonM95Qoof98SyY7Y	14053	19809	19809	1619504820000
28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	28440	3NLs49vM6f5pDCXQx9xnz2UiVhtzwwbw4qrwQHpq2UVm1uwHPDqt	1599	1287	557	12463	18974	jy37J5rPusXHtAxpnDWZNnRCpNirQbg18CZoNw8WAHGrrS6ZyrL	14056	19812	19812	1619505360000
28446	3NL1jNYwTvzfgpdT4SBUpY5TFx2aiqdxKWB4puVsNFURsKkGLbaW	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jxh6Y3WPvgT5yV42QrhWM8uYU5nWSPeAu1R87rKLZcYBZUyriFV	14059	19817	19817	1619506260000
28451	3NKxMR2roYBARWFisY8zXscoNHTBbBf63msHrUuPabArMdgdxR2p	28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	1406	1393	557	12463	18974	jxhHaUuHJ5rfh7SNiisthYpbgBiJg5v8uDkKeXt2DKdXPahWib5	14060	19818	19818	1619506440000
28367	3NKideQLmg53wDtYomDWzNa9VPwGSKojiV5wYYLuxY43jSeFrEMb	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1593	1100	555	12463	18974	jx14T9wzYk1U7qDcWrM6kdKmo3YfryPUEUmYasxorzpgkBeHA4V	14024	19767	19767	1619497260000
28370	3NLCzgaRVvbEbarP47bWqTziM1KueA63Qu2FUsXjF7mao9wZTGns	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1671	1119	555	12463	18974	jwFcSEb5Kx3gZ1WDvpCMMwar8zBu3vwgRS4v1BUk9gnzQveCxCg	14025	19768	19768	1619497440000
28371	3NKLBp1DdXTYjkb2YQoEe7kqzbegpCGBEh2Mc41r6oYH7h9uyog1	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1611	1341	555	12463	18974	jxNcmQbDBgJrjFoVGKYarRBGtwBpNjP9cePHoraf7HrtELrmqxi	14025	19768	19768	1619497440000
28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1440	1011	556	12463	18974	jx7vQRvxjRAUaznjk9XAuv3n7np1aQ54EiNZ7eTgYk9FpJTLwhJ	14032	19775	19775	1619498700000
28387	3NLpFeSKD7ctv5RtDKo1aQMgRuTRRotSq2CfJCUu1qik1zobxuL8	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1440	1011	556	12463	18974	jw9f1joSRN8vKV3pfJHW8t7QTncquyxFNhjToxqt88zvJbPcSvW	14032	19775	19775	1619498700000
28389	3NKfdtHQMmvxARsnEaKzRD7YQvxWyhppVfyvg6gM6gEiLtfpGiS3	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	448	939	554	12463	18974	jwzhJCtzhXMuvY3GAdt2dyqRy2UTeVKJFKkUkMqknpzVPqZeq8K	13989	19776	19776	1619498880000
28391	3NKN3Y9qYNk6nYviq5ka1ujxuPrDKoL9bvQ8TA45MmJmvJJjcTGe	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1506	1373	556	12463	18974	jxBuXJe1EAc5wGtttr9qvEHivrrcs9s4aGNT8qWtaxEjTH8KVoV	14033	19776	19776	1619498880000
28395	3NL3jekfbwVusZ85n7xQGxScMwAkkwx7eEsf4JcpTL4UBosJFUon	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	532	1177	556	12463	18974	jx4xgX1uuaQbao4e23pKyYcz3ehQHH31uwPsstoEyn2sXGCWEPm	14035	19778	19778	1619499240000
28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1542	1178	556	12463	18974	jxSqEAogNGaM9edECkiUdhYPdyea2J7LS2imkUpnLXSUanSuRHs	14037	19780	19780	1619499600000
28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	1403	782	556	12463	18974	jwgNmvfupQJK7dGjrt3jBBZWWN7KdV7bAT7Yay2KtB5RYCAGmb2	14038	19782	19782	1619499960000
28405	3NLoLKrKU16LJhfw3Fpb2neYcTmdahrX47Q6isqMszqXVM1FjLms	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1542	1696	556	12463	18974	jxtaVPzTtWSHY8rKpqbQ1XEJzfC8rCP9iM7GGcfnZ7aH7doZwf8	14039	19783	19783	1619500140000
28409	3NL8bN9JVNYf1Y6taktnZ5yZxTRgrejJqvvtqdMv17gNJcewYVo2	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1406	1393	556	12463	18974	jwjsucfEL4prxJLmmGBKSRwYsyUWVvU5EZz9jhowMMc4pjC53CB	14040	19784	19784	1619500320000
28415	3NKXp722Mw3sy8Lfw9A3FtaZ3u2qtKoCUxaMPggpPuLw7Q8EmPTU	28413	3NKozPVSP1Ebki5YvNndxs618aTfDP54PhsyM2RKKw5xtP7Mpov8	42	1361	556	12463	18974	jxHofEhhgfEtrhKtPCSobURCSYcKRV4jDkoXDQ2TuK79bQ8ruop	14042	19787	19787	1619500860000
28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	28417	3NKjfcwPPJVtf7ZjQBo72zfZXJKhSo7UpvtsHweJM9BsrQLL71Af	1559	1353	556	12463	18974	jxBy1DcR9gpCD3qxgtgRhi4Ru8URCHWP7oEcWxKXRxhntb89juH	14045	19791	19791	1619501580000
28421	3NLtZ94HhCHjxP6eUZUj7KpkL8WoF2z1nsBC8ontnoaBvdQBDKiM	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1654	1340	556	12463	18974	jwTep8jx3sEtxodgncCG8bG6c6on6BisjRYguSgvyLN73XRBG1u	14047	19794	19794	1619502120000
28425	3NL5yofKp4nP91aGuJSoLtjhaM13k2vyK4HMTBfuZBvUBqnLDWWQ	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	1483	894	556	12463	18974	jw8LAhrcFjMhCeVUWAanKxYw7QJgDVTCYczvoMccSwkSv2xHTES	14049	19802	19802	1619503560000
28432	3NLaQyVc2citK5fFpyDPpExHRrv4s3sN3Jp42tkpLxLnJn7Lcus4	28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	1647	1302	556	12463	18974	jwMQEqrqhtqKusUoNVpahnorYDDuGvfSRHdi5CkNCSrnci15cvw	14052	19806	19806	1619504280000
28435	3NK3ZtwCGHrio9f6a9eAPwU1FbCde3hYc1KPcy4Qt2XjvYkdWLCg	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1447	1099	557	12463	18974	jwemz52G6Mmn77uj2pS43U9VuWPB7fseRbqmXBHewEercgCk1Xw	14054	19810	19810	1619505000000
28437	3NK4iJNvVbfKkJ9SUfcyytHWGmzMHf5FQUxapikmV8t6GPFUPY2r	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1601	1388	557	12463	18974	jxbAiYjdQNdj21wSNjXf9qATgnk451aKYwqecNMhmRzoe1xsrBg	14054	19810	19810	1619505000000
28439	3NKwue6qSw3FfnwzkdM3S2E5tdvUYRb33zHjaKxsAvJSjVgXMzW7	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1651	462	557	12463	18974	jxBF9puXsvDCY3o48EmDaTe3BCQAPkdMVZ8pGVsFGktCL2zQnSZ	14054	19810	19810	1619505000000
28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	1656	1343	557	12463	18974	jxAGxshPQpCgaPJvwLNn4BYGZ2tBBRERcwKqfFgp1N45fGBR1j3	14058	19815	19815	1619505900000
28447	3NL1b4pviyPmQoD4DHetiRqvmYqqg2HSogGTvpkWtXiufAYxrm7P	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1406	1393	557	12463	18974	jy3CA5d72zniZJFFxx8R4NDMu1pb9EudxzqvUYYzFtHBKLH1N5E	14059	19817	19817	1619506260000
28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jwmQpALEbpEkR2w9CnR3ihjksHzN8EuyGvp2t2Dsj1tAUPy9AEG	14059	19817	19817	1619506260000
28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1668	1370	557	12463	18974	jwEw8jXePfkdrc8gNUMAQZJ7N4ycc9xmHdGsMSnnDzB7AkACJye	14062	19822	19822	1619507160000
28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	1448	1185	557	12463	18974	jweQvmYDcnwbeiirZ5oN6SxXZDexaehdp5WnugXCqrn8EN3qotX	14063	19823	19823	1619507340000
28459	3NKapqAbQhfrJX57V2qDobsmirt5rdJciuHhTqBLFZncN5dgzUfZ	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	1642	1241	557	12463	18974	jw9bRvwWZj5ppjEnQHSheQ5EPCPuDzWRzk8mcibyAkoLm1uMNw3	14064	19824	19824	1619507520000
28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	1529	950	557	12463	18974	jxyzk4x9XkF5hagS3D5bWnj2uoGkKyJWhHv9z5HjqK3dSn48bXn	14065	19825	19825	1619507700000
28463	3NL7QixsqBvu8pwu873NRZJ9rU5JALb5LbzjkHaaEKVPpQkEirHx	28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	1529	950	557	12463	18974	jwf74vyiUv7V8eV9QAqv54N7Uh1zpkJfjrhwgktjaRtCV9g7GFD	14065	19825	19825	1619507700000
28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	28465	3NLZCD22vZ1QXTcDUq7ej4WwDt4hb9Nzg6sNw9HDqpNaHv6nYbQf	1403	786	557	12463	18974	jxVtW1zau94CS9EAa4WoUZsBenE4qPAg1Bn4MRSHywWNantHRHk	14067	19827	19827	1619508060000
28469	3NLYYWwn2EoXqGjc9rvoPyX2vCoVYKXhXX6vC3zKaznWqgjCd2mR	28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	1402	852	557	12463	18974	jxd5a29Txun8o3ajnimSecc3fPJdr2UdJEcViZsqrWpys28AEsJ	14068	19829	19829	1619508420000
28471	3NKAS1taJG8crrm2itVJbEW586UpnkjKc7itTzwJ6HrYCxEaHErQ	28470	3NLDnRhJL4DSeVMVff3cZ4in2qDWCU9LheS1EWWtAkrazX6vfA5h	1406	1393	557	12463	18974	jxeHVJQGDRPCqTwzEfoX3VzK9qvDWJA4G693fUdqEYn7wVan1tF	14069	19831	19831	1619508780000
28474	3NKjKtvJrBMx9AWQrMq3Z4yqPwerA9zh2MxGNaoPu6bnwbAcn8UV	28473	3NL8y6SYobShNCkKP5GNKDcyfPJ72fpXHkiYKgy56WhGZeBQugKB	1590	1300	557	12463	18974	jwectwUsP4HV4Zbn8nqKTuxvKjQY2ZjVwXT3g4Prg1qR2SMJvuk	14072	19834	19834	1619509320000
28374	3NL7hXGsK2EPBBRCMvC7KCL7w5DVjdvP1WaXuEUKzaGX7Nm33tDU	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	484	1319	555	12463	18974	jxk7K3SVuWDjPekPH4JyQ5EY5BRUUPBQbKznoRT4nnsiSfaqiDF	14027	19770	19770	1619497800000
28378	3NLF71uZyeNZKtK3XFbZJEFb3kfdsJFPz5Lt5sCooLwV2u4EXpcN	28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	1508	1387	556	12463	18974	jx2r6mNo64FF7txtUTfD3KMH1v5xxxwbgFQN8DwypiSxmo62vSL	14028	19771	19771	1619497980000
28380	3NLXyuFYbQfZMNhKPM1dijXAknqv6yGLtQMboz3ChAkNbe5mEusQ	28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	1506	598	556	12463	18974	jxY1uTwMmfNm2E6BdiveXzG4gujX6THJZmStDo7SuDoN2L3zpdu	14029	19772	19772	1619498160000
28382	3NLW8C1Bc54TxLw6wDBTPXhs23tugYu6uoxEzjnRebaHKXBnkrG6	28381	3NKv8Lvc9GkfcbU4ELj4dwczAJaxkHphdKKTN2qQxiuK5W6k1RTe	576	1109	556	12463	18974	jx97eQn69fTKz4sQXt5rNPXs4E1kHGwPZrb7CF8NCvJMJmRF5EP	14030	19773	19773	1619498340000
28385	3NKvpGCuFfrgvY1y4ofNMhoHMcPWwyDrueuhLJqpsdN8oFDywLdE	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	623	623	556	12463	18974	jxxL9nYr2F8AqGPVbyfAPkW1aZ1JwJiRjqKJwoybnn8c8xBi962	14032	19775	19775	1619498700000
28393	3NKiHzS1LSzLvxgC4hmJmKwMgyFZRQoaRf5FaJzvBYDa7eMKrR75	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1506	1373	556	12463	18974	jwbn3fWhd1R4n5F9HREaoS9tnJ3dvpm5sbGYD1EfSHWrAUW8wky	14033	19776	19776	1619498880000
28396	3NKpRFaiXUnbeePG2CvmFDC5Nb9QZDopC1K1RHvYXeZVJX2QCkGH	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	1617	1162	556	12463	18974	jxzj3LVwH2iTYVxVAnLTxGJuuczjE1PHcpzWGXZmbpTtBLYVpbg	14035	19778	19778	1619499240000
28407	3NKXuqUSvrhY88A8oFthtB4FWcghqzcq9GkK1T3rgZWUehqh7UaG	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1541	1298	556	12463	18974	jxFDXBDumDYsRfkxBEJbN3rRPhciHGyYnBEhx9BfNMPKf4iPzeq	14039	19783	19783	1619500140000
28410	3NLL3ug76w9MUBqRGvm4EhVf6ckHSbtZwn2cedevXurVK1eGq9ei	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1403	812	556	12463	18974	jxTfGgAWvbZmxUHjwVVw8fUgmkdqdr129EA2RaXs2vWEs7b3Jg5	14040	19784	19784	1619500320000
28413	3NKozPVSP1Ebki5YvNndxs618aTfDP54PhsyM2RKKw5xtP7Mpov8	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1631	793	556	12463	18974	jxiKvSRij3vv9cHQSn1u64XsWACxcakvHAXpUx8toT3np6czfGk	14041	19785	19785	1619500500000
28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	28415	3NKXp722Mw3sy8Lfw9A3FtaZ3u2qtKoCUxaMPggpPuLw7Q8EmPTU	1609	1087	556	12463	18974	jxrppigg4n4QJ8ayeSYALwFfqZKzodVVmAmccDND1GJB5QF6s6M	14043	19788	19788	1619501040000
28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	1672	1285	556	12463	18974	jwx1gimi9LNVnwfvsGJWKGbZsBY1gm2FXF7PHPPntPcYJTUx9PC	14046	19793	19793	1619501940000
28426	3NKViXmKsHR9LMft16bhigBSFjJGJGvnZnUBEA7fMi5JBmxW1tXv	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	44	1199	556	12463	18974	jwmqb8mnjQj2fq16doNRt4BRy75nmTGgix4Pj9tskH3rQnRc56J	14049	19802	19802	1619503560000
28430	3NLWFNvxsNuwyXNvjZV9jXUjztdbnCYAVEedM4qgHYLzY9TcErUG	28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	1406	1393	556	12463	18974	jwxaqN5KkPaqNSBwhxprmN22Y3jPrgTqjTJSF8tnVbv3zcGNfBB	14051	19805	19805	1619504100000
28442	3NKjNuZsB62U8RE4mJC7yUzVtZUS7uv8A6mLawThi1Snf7jVYN2t	28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	1460	595	557	12463	18974	jwpLPzw6mg6tvxhdGtHe3HKGvbuShFw92TVP94fQghE1wJhuXup	14057	19813	19813	1619505540000
28455	3NKyG3vb4LrHcpzx7NGXf656UQXgogSFAsajUqfNY8R8XTHfMTWF	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1407	1395	557	12463	18974	jwT2QbFbUVEBKpw3KYyzGHdQauNSaHhFMnD7toEXvzCFrJh2Df1	14062	19822	19822	1619507160000
28460	3NKx8wQCdds3n9Qse9CMYosYjjyv8USwprm5J6GhGLAF9UjWpjaA	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	470	1309	557	12463	18974	jxmZRTcWUgNHQeAPbxmpLJHRGn2Sn4ApQoeAiffZQQy9EH8oeXv	14064	19824	19824	1619507520000
28466	3NKx2nazzqF44r4a31Srz2zew9bBXXuma7H6zi2bDVuRi7FoGmLu	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1407	1395	557	12463	18974	jwSocaYEMs6dPPYrDytet73GNVDbXv4cZBiBfH26PAGuXoGjKgw	14066	19826	19826	1619507880000
28472	3NLrSpS1GK6XAjfQBFM6dRaBhzH43YkP45UG48KKYoBRTbCNSqV6	28471	3NKAS1taJG8crrm2itVJbEW586UpnkjKc7itTzwJ6HrYCxEaHErQ	1516	1294	557	12463	18974	jw7gEv2yGrsT2PNkiMn7kLMyWrmge3LuKcaJUBTcXfQraQ6E1TG	14070	19832	19832	1619508960000
28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	1673	1368	557	12463	18974	jx9B4bPkrk7dBiN7LxAWJA2yGKt5g77Zcp5mbCzPF85rCbB8Ywn	14074	19836	19836	1619509680000
28482	3NLHM9qiE5wLSryL6TTbhEFV44a9SCattpYPmyiTSKYQ6JS11E3z	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	369	1312	557	12463	18974	jxaWRWz29w6gDbPv5a5d8edH6UfmsdsH77HPwcrisyenRHGTAcW	14076	19838	19838	1619510040000
28484	3NLi8cxsUEBL7gp99ZKwavMwhTdo1WdJ7KCFsoGqEq5kukfGx6Ei	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	1403	824	557	12463	18974	jx5RH755xuew87T1Rep1LPLUioeSXs9mgNeD6urZw5Gju24FjBb	14076	19838	19838	1619510040000
28488	3NLZckrxzTVXsSY2JtykhJrbiQPKv7mKrwrXZT11GNZmayCieP82	28485	3NKaJodQC5qSzkJaSazZrgS4CVmb264TRo4C2ZUGa45NGRVwkw6A	1633	1144	557	12463	18974	jxyPqW8HhCqiFrJnt4hQEXf92BQWubK3AbzRDoCWYMimkFaVkM6	14078	19840	19840	1619510400000
28491	3NLefxxwA7h3ZdDcdQrMxKwp6otH2GfkC1sYpSQF2Qjk4Y37uAFb	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1506	1247	558	12463	18974	jxRC5mGGpVY1iHiigUoap6oJQcpgUYSuZb6Rp8UPvGWvtyUsS7h	14080	19844	19844	1619511120000
28493	3NKvYhLEE1McKDTNdzFpcaUKX2RW8L6e352xNN3mVWks2rTAv3QV	28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	1483	240	558	12463	18974	jwC75oKWFea81jZjxv6URivtBUHo13wshrYy116iEjm5EgUMPri	14081	19845	19845	1619511300000
28498	3NKzxEaKz47bjjxpSPsmYNX38VAbXrmH5cbJPJ4UHpeVz1s4bzVv	28496	3NL3oYYybXcYFveitV6Q8CmMw9cWBjqdn8jfhavQ6283JsLbMMXW	1646	1108	558	12463	18974	jxCSWtqwNGFb9oACKhbwFexVhFkHoCN4qR973X8FLfFCVQD8jba	14083	19849	19849	1619512020000
28503	3NLBTxsmA3gZX16AdFX9mvCjs8kcrSMmmSWZrQCrC3EWwh9e1uY3	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1654	1214	558	12463	18974	jwjqKBKUYSCianvRaANcjym5DwJmg9okAvumWmovCBo27SojVrF	14086	19852	19852	1619512560000
28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	28503	3NLBTxsmA3gZX16AdFX9mvCjs8kcrSMmmSWZrQCrC3EWwh9e1uY3	1426	1364	558	12463	18974	jxRBVqTKj2q8wBe7122gQnasMVxp61SZV8yXX77zNnJdzdY4bjb	14087	19853	19853	1619512740000
28509	3NLuaYSQpV62SDDbo1eBBLKMh4aumZJejAc4221TdWZmjHAsK9rw	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1668	1370	558	12463	18974	jwjPPbsGaKW9dxbDaWEvSrNVJR5bHrEaDrVc2ddRcBeeuFXm63R	14088	19854	19854	1619512920000
28513	3NKiiTCe8XmSXX21azV7kMiyxtCBjsVxEfqkfWHwsbyKr8rjEdFq	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1462	471	558	12463	18974	jwFeKn4Qa8jVD9bALAoe2N4zwbvXD4AzE5PZx9FiZhg31W19sk2	14089	19855	19855	1619513100000
28516	3NKMRcdLjxuWQ8GD4DcKzrTyCEE2eqGX4MVEuaT7yuePdA5DeXH5	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1602	1369	558	12463	18974	jwnzP9FLptpwxubZ9CaBHznf8dLoM2es3EUW3o23yG851MJ7szr	14090	19856	19856	1619513280000
28520	3NKsSzdyyx7FSdZEz238KCn6mhG29rcKPv7BVdfE1v7YZ3Akjxdn	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1483	240	558	12463	18974	jy2ptrKMv8AxepYHN3jmhPZbmgL4eEqMrzCrfpX2ZGqNbmj8dVa	14092	19858	19858	1619513640000
28397	3NKV3BxmvW7ntQKzjtTxm4hNef3pFiFu5s1BjUzU7SZdM4fJMnSr	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	1631	794	556	12463	18974	jwz6ijEnUygd7ynVqkFFAKizhhZiQCWYcDnrqG6oRqGMSc85mHs	14035	19778	19778	1619499240000
28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	28395	3NL3jekfbwVusZ85n7xQGxScMwAkkwx7eEsf4JcpTL4UBosJFUon	1406	1393	556	12463	18974	jw8Kg8oohoRPcYm8Q9orwN123mzDatgVtTvpCUHck7mtiLqYSUV	14036	19779	19779	1619499420000
28401	3NLd5Kb12g7gT8WGuM8iif3ap4C4N33X2oUiUJrRFsZ4CRgtixr7	28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	1406	1393	556	12463	18974	jwpFydkfvVc9XVt7QgDNh1kNY1BGL8vwnDZCRLC3X5NjBW9quJ9	14038	19782	19782	1619499960000
28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1406	1393	556	12463	18974	jx4b3HaoYwKSzuV2d8UTunRWMqPunf4ffMGYZjxqUtNHJndWUQw	14039	19783	19783	1619500140000
28411	3NKkmk7ZQ7eMpEYPHD2Cea9jPXSh1gyyHypGEQSGcDHbGouQUQ7N	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1608	1289	556	12463	18974	jxBhiUwFMtBqwjmxTydTUZ8vN73Sx3KNofKPFg6BetKk8NoS4FE	14040	19784	19784	1619500320000
28414	3NLeVMnTKyq984yj6bJ6mowQHWJTGNEQGJnCmR7C2DMw8uyLLzij	28364	3NK8FAstAcT3GGcQKmztaf5BBggP9fjvuNJnmMeBqDRYe2Xo2XR8	1509	1194	555	12463	18974	jwyXjUdzBok8he2ekeDbT3GajUgc72yXj7w2YB86gKJUzpN2a9x	14022	19785	19785	1619500500000
28422	3NLrVyRWArZmwBhhbF86x5LKxQULK4nQpC3jFvCd2EWm6Tbn2YkD	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1573	1318	556	12463	18974	jxCaYEQuNeY1W71yxHantzrAMSCjF6sh1aWDhhkGMXkHoDFQeYX	14047	19794	19794	1619502120000
28423	3NLLGeUBZiVgfvQinziJ6ikqRJ2yrhvU51hpJGX5PPoUvtCEHbC4	28348	3NLEmeiGQJ22DUFJGU6bZQ8d9dwYZmioZSiXSPixLbkW41np3sL3	1553	776	549	12463	18974	jwMaaggaQ1mHcSpZDzXRH9Dp4326A9kccVLtrWc81uUxKWbpqFK	13880	19798	19798	1619502840000
28427	3NKQ1mK6xXzmtpRD7DLHoAitCXUsXjSnbAR3YCxzkVQC8FHdJP35	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	1637	816	556	12463	18974	jx7ZhVXgtgHUhRw2jaK9M24y52dyNEaMJvDoS4DR6cwbSCyRL4Q	14049	19802	19802	1619503560000
28428	3NLeqfJTSyz4Xa1mxrcFaqfd8p9wTTfuRsfwe82VvPYTiNZvZcMx	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1483	894	556	12463	18974	jwSjs5JtvvYC29BiDSFeo2bBWVgyNx943G9LM1ZcQbNKjXQ7tci	14041	19802	19802	1619503560000
28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	1631	794	556	12463	18974	jwpNfHtcnbHf7d2xvfi7u1zWVPzMi5wJmRT8J9yLgbHLVUbRugw	14051	19805	19805	1619504100000
28433	3NKow8imXjFJtkECZMrU23GyHLWUXWMPmJmCjhvWCYWqdRaoMLwN	28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	1647	1302	556	12463	18974	jwMQEqrqhtqKusUoNVpahnorYDDuGvfSRHdi5CkNCSrnci15cvw	14052	19806	19806	1619504280000
28436	3NKgnUKx1cTry5RGhLPSaUKEokzhkZGxDyUwd23wjPfAAvSyfjA4	28169	3NL9qNrjbKdnt8KtDv2rxoVzDAdZyPnyXBwATifSPuHYZVJMkVJr	1513	1253	547	12463	18974	jx2XZ9cYuLyzersFYsLgbuBu7gWEN9wZsCyhxCtn6Rsds794N8u	13847	19810	19810	1619505000000
28438	3NLL1FDCgUKJZVdD332esrarXywuLg3fS9uzSbnTcvSN1ssArZTH	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1651	462	557	12463	18974	jxWLdweWDtXDzYVQ5AJS1Mn5AN49RpvwqxHRgnXDFbSRxHJSqs2	14054	19810	19810	1619505000000
28440	3NLs49vM6f5pDCXQx9xnz2UiVhtzwwbw4qrwQHpq2UVm1uwHPDqt	28435	3NK3ZtwCGHrio9f6a9eAPwU1FbCde3hYc1KPcy4Qt2XjvYkdWLCg	42	995	557	12463	18974	jxzaqsnTZFDZ693d39Wz2oi3zi7Ksuv5sc1a248YMeEvjL1nMVt	14055	19811	19811	1619505180000
28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	1406	1393	557	12463	18974	jxGyEzCsUwFtekg8vyfMV7hdmxMHBfYBZbMuTfVg5X15h3RFF63	14057	19813	19813	1619505540000
28445	3NKQnjaPjVGHDVxRdrnnduR5Pzx57ok1mFfPwsYNKHLovTfpTRzF	28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	1559	1227	557	12463	18974	jwgVFBWdBLS2FvX1NNpQAf72Vs7xoHy5dKzuXr24GSSJJbGp8cf	14058	19815	19815	1619505900000
28448	3NKRsiJGR1b8sibJnyw65W969QkJ9NCTJVdh2pBGUZLqHQrVwUes	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jwkDVHGZ3QysRaMGgM8JJMsvppuHszeFFpyBLFasahD9f8pfL6o	14059	19817	19817	1619506260000
28450	3NL9TNFqDioQLpQx4PvLc7Z6byoxdZhAY5ZnjxerV17qYJFqpCqJ	28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	1507	1034	557	12463	18974	jxMj4uPKQXSQnipwtYFoTc6YH6B6PHcWfMBSxVp23bs6bRj8Cie	14060	19818	19818	1619506440000
28456	3NKge5YXvBoKsykhxwmEifKNMoGf9xzWXoJ5gciwZNVhM75obG6J	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1555	1347	557	12463	18974	jxijTsHjA2UCHmrHJaDDf2L5SRsUBghSn26QiSTJ2zJphxLkJM8	14062	19822	19822	1619507160000
28464	3NLH5muZSirhUg7AA7KdfACVyo8is658CLZs9B2Mjkih1ZGKgdnp	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1460	333	557	12463	18974	jxLdhbqYGRR7mgXzMXmcfj9Mj5cwxmQVePB3a1uELphtGjGnJm7	14066	19826	19826	1619507880000
28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	28474	3NKjKtvJrBMx9AWQrMq3Z4yqPwerA9zh2MxGNaoPu6bnwbAcn8UV	1508	1141	557	12463	18974	jxo6VqoGyd1YimRax34uGu1jSJhY1jFiK1VKqs1SNfGaqJeQhBr	14073	19835	19835	1619509500000
28486	3NLZGTL73VYqiVFy6TDf3wBiTWrLcHo1ydZJgJWR3K4nUJw55zKh	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1601	1388	557	12463	18974	jxQRTcSaozvSh5gVh8ruuB645KLRJhgs6UPXc6peZWh64u3kbji	14077	19839	19839	1619510220000
28496	3NL3oYYybXcYFveitV6Q8CmMw9cWBjqdn8jfhavQ6283JsLbMMXW	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1407	1395	558	12463	18974	jwVKuwjkg5SHPomzuoyTvEyL6i75HUYG5ds67E7neYuTsyUh2Hy	14082	19846	19846	1619511480000
28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	28498	3NKzxEaKz47bjjxpSPsmYNX38VAbXrmH5cbJPJ4UHpeVz1s4bzVv	1559	1353	558	12463	18974	jwipba6E7orNqKdpcLP6Kb78jyJJs7o8Pc3PkZq3eGfFHY9e1Zm	14084	19850	19850	1619512200000
28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jwND1BAJWNXkptm5oV5gyk6HkePiSgWZd2b1j5RJwcvGwCBvZur	14085	19851	19851	1619512380000
28504	3NKsGoQ6RmnodBLFiTfqDhsxrk6PGNwk3vY4xsKZDe4HUZb5MEax	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1471	1260	558	12463	18974	jx3wrW45YZzGeD432AE9hTEVyDmNmVoxCZsfAoDtRc4ZLys5xqh	14086	19852	19852	1619512560000
28506	3NLeFZjCYg3BoN7Us5D7Cz6yfnj31pL5aDx2XnRHcVp46m3E3GXP	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1406	1393	558	12463	18974	jwaQ7tnV2PsUn4wNthyjRYF3muErjsgc56V2RmCDfTNgHKW4yCw	14086	19852	19852	1619512560000
28508	3NLNTgeoUEJsfJaQC1VSiYV3Cxc6tXftZDapnQ6yGL4oSGosNoQJ	28225	3NKr4NQRaMA8bsBhQuo1feUHaoikTEeqz7kTsdFnM8UPvKhiXnJJ	1426	1364	552	12463	18974	jwr2t373v7HtMU272qGVRUTjBFtCtZMTK2pSYoBiks8coKYXpij	13933	19853	19853	1619512740000
28518	3NLTJ3Q7yYPDAnHeQ8EMGSQuvsjhbZ7vx5BGsB3ZUF5GXmc75AjW	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1406	1393	558	12463	18974	jxLAj8BeGwnv9GTWMmn6zeymw1F7NDWqaB9WmkuumrmrKTDKsp6	14090	19856	19856	1619513280000
28525	3NKPtJseT6YDD8NvCEN6zuM7WTDdEkmxuKaJmpwAwNaPRt2S3fMo	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1651	1055	558	12463	18974	jwvYtdbQA2iEDmcfTyjWNLEEFumwhQECGuNmhYDTAysYVMmzbH1	14093	19859	19859	1619513820000
28527	3NLdgh3QBfDD3NPLpxaiAaNPhKCBfUjX9iHqJybvNc5qtAAX8oWx	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1407	1395	558	12463	18974	jxaFor7emQ3ruSG12GQ4xcfQCfAVzjQU6m8BGsM5Gz2vrZh6Y3S	14095	19861	19861	1619514180000
28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	28451	3NKxMR2roYBARWFisY8zXscoNHTBbBf63msHrUuPabArMdgdxR2p	1407	1395	557	12463	18974	jwtJk9yPZ6MGu8R4YhmYemS9fic1823ZEPN8JWfvSdGWvZBrRr9	14061	19821	19821	1619506980000
28453	3NLhRpNpCzUQBK8rWYMzWJ4RLUpaS2qZfE5mAH8yHoukU8iguV6e	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1405	853	557	12463	18974	jx1RcuSQHjvDMi6Mz9C8Fo7kAjKRVftAicJ8n4oAFQSMd87XWWn	14062	19822	19822	1619507160000
28457	3NKVX8peM9pDLxGpKvMnGw6RXUTDGmtcMg8sF6xrMPtE4m1dwYfo	28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	1448	1185	557	12463	18974	jxD2zdon2KTqYVhX5YyZazmsfRd6qxKeCAsD6ENQVryq9g2xYzL	14063	19823	19823	1619507340000
28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	1652	949	557	12463	18974	jwW5UbaZKFCJ5bufg3HFLfCc4LHGqXhjBEUUspvf7tB94HGiWg1	14064	19824	19824	1619507520000
28465	3NLZCD22vZ1QXTcDUq7ej4WwDt4hb9Nzg6sNw9HDqpNaHv6nYbQf	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1406	1393	557	12463	18974	jwsoGRcK2Y2Yreon7RQXu5fzfLgD6yk3ZCmeeM4o9Xx2gs8A14G	14066	19826	19826	1619507880000
28468	3NKNrGaha9h3hBdTtshhimtXZukPXzahhHqTGty88nXW6SF2zT2X	28423	3NLLGeUBZiVgfvQinziJ6ikqRJ2yrhvU51hpJGX5PPoUvtCEHbC4	1553	776	549	12463	18974	jwBeFWWje6i8cvW7LggGh9ReNaCsE83JxN7QZqLjPsb2Vhsd9fN	13881	19828	19828	1619508240000
28470	3NLDnRhJL4DSeVMVff3cZ4in2qDWCU9LheS1EWWtAkrazX6vfA5h	28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	1637	816	557	12463	18974	jwAmcFZ42mU6CWM114WsFN6NBminGUZUrbWgqhrsBbnzMS9bAAo	14068	19829	19829	1619508420000
28473	3NL8y6SYobShNCkKP5GNKDcyfPJ72fpXHkiYKgy56WhGZeBQugKB	28472	3NLrSpS1GK6XAjfQBFM6dRaBhzH43YkP45UG48KKYoBRTbCNSqV6	641	1090	557	12463	18974	jx8Q66ods9tUSouEtQinc4vEE7kzgzw21F35xHoob3L8hTsKV2H	14071	19833	19833	1619509140000
28476	3NL2PuAaquK7nK56hB4tyr7fnKYLVTTiQzar8v3fc4meHjCLXYvs	28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	1587	991	557	12463	18974	jxf9NBi8x84kBQVESXrHf58ZFRkSwbeJ9iAN5VgUknrVxonxSHf	14074	19836	19836	1619509680000
28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1407	1395	557	12463	18974	jxAF97AiqA29eEfwqXRou4WiKsa51RR4b4WNYHntGpAWkCrUSdE	14075	19837	19837	1619509860000
28480	3NLAoVmoAox4hoEv51W28RQm58kQQhDudTjKCLcTrvMCzd3BGCPz	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1631	794	557	12463	18974	jx6P3uqW8igxzxWqXeJmwWYNetgspzay1EQedmSyZPnprPpaXDH	14075	19837	19837	1619509860000
28487	3NL2g2SCLChcYm1Nb2gMhEVLi9aWDz9aRL93cn85AUmFSXcWSk2Z	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1637	816	557	12463	18974	jxqzqeYENSzQfr8j6QoyN8pHU7QeNF3TjyxkKDVX1baBd47MLq5	14077	19839	19839	1619510220000
28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	28488	3NLZckrxzTVXsSY2JtykhJrbiQPKv7mKrwrXZT11GNZmayCieP82	1405	849	558	12463	18974	jwd9EdZz99gZUqKvtvreHcw2co9ouUMqptoGWEoy3zcb36FnkWz	14079	19841	19841	1619510580000
28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1402	850	558	12463	18974	jwnFgnrrnckMruYzHHaUJdWQfyYrYcLUuk2KMnwZQa8r7ikr2BY	14080	19844	19844	1619511120000
28492	3NLAf3AbiaP4C9UTVKbD7wjmucd2qqKWnwnvuUVhj7712bsYeR9G	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1506	1247	558	12463	18974	jwqHYQeDhsTVgWEBJdiZW4Gfure8RPdKd13n2McZZfSfNFDqB3o	14080	19844	19844	1619511120000
28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	1461	1271	558	12463	18974	jxWmCuSE8ewPsQ9pNqhSVcHoyVPXKW6cL6udinhUpG2CbdkLXnM	14081	19845	19845	1619511300000
28497	3NL7BqpkVe4rePkzya5ty8WTi3SGvuGHewF19oha7rTGWokzBc8t	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1599	1287	558	12463	18974	jxKqEY3vJ53Dkrbz4eyTebMFeozQiZhLgrehnmWzT4VsQhSr8VP	14082	19846	19846	1619511480000
28502	3NLmMYT3m6bjDxUKC65V4iCHYWLsgMPWnjiDUXb6StXaj314c7oR	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jxSHrNs4gTTvjkkvtMh8i4pYKVGCxVusNpoPH6evwiSr9u1wY8W	14085	19851	19851	1619512380000
28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1648	1284	558	12463	18974	jwEc11RTDKT3hnR8ANyrqo5ADxCQHk8aKGkJa4nWU9acqH4wZUW	14088	19854	19854	1619512920000
28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1405	867	558	12463	18974	jxNEj6JEP6gjRAa5xpBLXVeXABNYEPcbi68bjdA68ZCf8kwFfAa	14089	19855	19855	1619513100000
28514	3NLpuamjE9Lu864JBxCNdSUjPDqNvASnz8Ko5GVEPcsSSWgLZqdf	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1581	778	558	12463	18974	jxs82VvRcetPAQ9t8zQMih8Vmv8ioFipVBZjev2ot86rSFTVBmw	14089	19855	19855	1619513100000
28517	3NLZftUsGcAUvZ8NcuZHGidZCZ6J35ssce3EWGJDzY1vchWGsGig	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1602	1369	556	12463	18974	jxdccayBy38oRzgDEwotjQ4wTMn7DVPMkYFNRxWweBtdNbVWc3q	14047	19856	19856	1619513280000
28521	3NKjTQP6PSdyDSknhgfShvDZELRwzzk2B87JCfsLv9eVi8Khd4TC	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1406	1393	558	12463	18974	jxjwPR7mEZgZkd61qcGnKrGEJctb73fozVEkzJM9DhUUy2WgeUi	14092	19858	19858	1619513640000
28523	3NL2HXGewXXicU9y5wzWMBpJfiGDbjiR2ieKwbzsnBc6DTwVpsyS	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1656	977	558	12463	18974	jx6RkBkN7AhkiRwMVqdYYuzotRTnvD7UQsnbC7BusDWxSx4jvYW	14093	19859	19859	1619513820000
28528	3NLaukAzBmeDzsASMmFhEHBuPKF7tZvHEtnupzMwW21vhnoG5cR9	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1596	1363	558	12463	18974	jwvndjNVBmDJ4ZJn6LThZ8WSA9HkLf7s91XqSrkBuHkLp6itkJq	14095	19861	19861	1619514180000
28530	3NKhPTmrvgm3Q3TnkYL5J2vy1AxQQvmeq1Vxnet8DmqGHKZNEKcc	28528	3NLaukAzBmeDzsASMmFhEHBuPKF7tZvHEtnupzMwW21vhnoG5cR9	1407	1395	558	12463	18974	jwBN45FVrJp7oNKQCtq1J4whXZq2HpbV5mG1k5yC3gaBhcE3hyS	14096	19862	19862	1619514360000
28533	3NKyk5niXjWuGUYWMBpVaPwEkTU6xfFWZtGsQc4H7Qm6XHXTokX1	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1406	1393	558	12463	18974	jwVratWMQyGDgetYoGbkuHTXTMSnsvqabEjX5zDmkzMu1v4ibUG	14098	19865	19865	1619514900000
28537	3NKsb2zBdYuWaTWi1Edr26adygfcArduxGjDqzkNCAQAJbcJNM2b	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jwpBQNCQr21QX29QvLrnN5ZxRuCUyNw4UvXkS4Kkx4LBEDYTLm9	14100	19867	19867	1619515260000
28540	3NL2VTDMfZG7jgoqhpGeuv7n2wHkBbeeWv35DePrjDE9ZQLKJmPM	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jxeD6H1bH2Dc3MJEndVK3fQKRGyZcmt6eJBYrP2qiH7owcmCpfa	14100	19867	19867	1619515260000
28542	3NKgR8u4NaEcNAVTQZTSoyCEG9PL8wxjRUGjaFobMUdyC2M6VW82	28436	3NKgnUKx1cTry5RGhLPSaUKEokzhkZGxDyUwd23wjPfAAvSyfjA4	1513	1013	547	12463	18974	jws4ts7jCRjaCbf5ju1EYGqyn3Lj6ERDUrm67KvjKoitAVkx2oG	13848	19870	19870	1619515800000
28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	632	1256	559	12463	18974	jwutcWi3kreub6wkfyk2SaQV5AzhLqFmzTSwm3WaD7JDMwYqd9A	14103	19871	19871	1619515980000
28550	3NKDnuL83rqjbwxBowqwY5icznFZofyZ35z58YYpMUxrEXvcpPrJ	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	369	1066	559	12463	18974	jwhyp9sBP8bpJWWQK1rp4r65rH9Hd3TgcaeT3EnELaNdZEo1BmA	14104	19872	19872	1619516160000
28479	3NKxfNF3wVQoXhtgLrk6C5HMDZVYiRmmrr8vGwNeGJEgJbeLy6Vn	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1406	1393	557	12463	18974	jwd2NPT6FFJv144aURg1xiPf5V7micjZUmbTSbQmrKkX4xcyrou	14075	19837	19837	1619509860000
28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	1522	1322	557	12463	18974	jwniiF6pbveAvjmwtBEkN4euKpjuM7WnNtfBXC11ABT1CjaVAbe	14076	19838	19838	1619510040000
28483	3NL1EkbD95dseX5ji4twvds2fiebTivioZ73s2kABbPYFP742GM5	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	367	367	557	12463	18974	jwcpNFDih1H1wfHDd54RAvcc62bB8XCtGtpnMfkLTktHZvyyNLZ	14076	19838	19838	1619510040000
28485	3NKaJodQC5qSzkJaSazZrgS4CVmb264TRo4C2ZUGa45NGRVwkw6A	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1467	1130	557	12463	18974	jxgNBuEGY6M5TKrvJXBwDMu14dB4wtmsB92JQRGM2ftiyGTMPuU	14077	19839	19839	1619510220000
28495	3NLZohQxhFTVLS1AsjGZp2J7ocrU67wrBLvvof7BkoSgWbDQbn4M	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1672	1285	558	12463	18974	jwEFRvpTFhVfuJpy7ywEPaR1uN6Xvp8UXiNg9NNAMFAf5tEAJ77	14082	19846	19846	1619511480000
28500	3NLetrhQiTo78vbLrq68v6pN5Y9vWgsfLspD9xD8izG52brS9eow	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jxmwqVZRFbmMUv1yjwSf8ptYVovQnrCittbhuhT44V3GhDX4L7r	14085	19851	19851	1619512380000
28505	3NL6pKj2Ah3jY7vuJVxV9pQteMUL7zEFc487M7z4hhUnuUAvy27U	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1534	220	558	12463	18974	jxMe2cpx6WexPofM6GotJLMjoXvhyKCUxqqeN8rur5boFU1GciW	14086	19852	19852	1619512560000
28511	3NLJ8FQ42i4XA4UwxLDuJ8XypsefWkP3r96GkG3LRamq1sDKrT6S	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1573	1318	558	12463	18974	jwr8pYjYryrDM6ZzAuScGu3dLZnfzgdmRh1wg5F3MbnBM4tCMEp	14088	19854	19854	1619512920000
28515	3NKgX81Eh6VrLFSZtbfMZJkBfr3GZiLSrqkpqnf5xzAMzEmdGjxE	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1402	892	558	12463	18974	jy2BCar2NPpiYDyEempmSMrRQgmxCh8CQ559hrXoBEzpT1Q3ynN	14090	19856	19856	1619513280000
28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	28518	3NLTJ3Q7yYPDAnHeQ8EMGSQuvsjhbZ7vx5BGsB3ZUF5GXmc75AjW	1631	793	558	12463	18974	jx3bPtSJwETiiFuoLZGvurE7KSKGm71yByfA38AacTqvXkJxmnu	14091	19857	19857	1619513460000
28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	28523	3NL2HXGewXXicU9y5wzWMBpJfiGDbjiR2ieKwbzsnBc6DTwVpsyS	1403	782	558	12463	18974	jwHsNeJC9aVpAEgASNmrMqhPHstKLto6oUhX6M27vV2JmG1BcTN	14094	19860	19860	1619514000000
28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	28530	3NKhPTmrvgm3Q3TnkYL5J2vy1AxQQvmeq1Vxnet8DmqGHKZNEKcc	1407	1395	558	12463	18974	jxGi62BNSpNoWrsixDP6jBE2DwzkcQ98aw65S7GXVUof6aTSHDV	14097	19864	19864	1619514720000
28538	3NKd6CNfn8kEes9TbPpW2Lq5wBKX9muj7eW3xGqVR3QDXM9dUV19	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1405	891	558	12463	18974	jwbid1Uat5MZwAJMYDY8DiLx1k1QyKgwpLA8gYeQJXKoN8f2yyy	14100	19867	19867	1619515260000
28545	3NKbq9nMqTVGgYeW3Ndnk2vxZ8pCrpjVa8UF3rccTWmXQB5DKsAm	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	641	1336	559	12463	18974	jwmJLX6TKpod1SLEz2NmK38oZfG7UgSQtfTatDBF63VjZd3tU6v	14103	19871	19871	1619515980000
28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1458	1323	559	12463	18974	jxfpaNsnpTFNT2hpGzUxAKUh4meHuNBiC2ZA8G2Hs59CUWSnaFf	14104	19872	19872	1619516160000
28551	3NKL4qQiMHxuqVcVFjAYPfXddLLi8xJCTXj2VtR6tD8vsKLk5rfx	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jw8rWYZm2QJ9sXES99rmt5zzeSkVnCmzzcMTrQUf4u2m7x1oEpR	14104	19872	19872	1619516160000
28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1483	191	559	12463	18974	jweQxHJ1GdhYg6P4UPf2qTLmNVo685hJhQX6r4ZFQWGQiJJGw2e	14105	19873	19873	1619516340000
28555	3NLAqWAyUKXFL2BrwuTvWwfCcpTZJHDB2t3NAaiPKiFHV6dBfyba	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1577	961	559	12463	18974	jxbqmMakEQ7nkden6v8c4bqs2fFPTEFNUj3DY8JD28g1VVejpRM	14105	19873	19873	1619516340000
28558	3NLqTJkJhkowhJVdiZS8kkgfTB7LAZaqxfNL77BcP14uEbmb5tjG	28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	1631	794	559	12463	18974	jxD76smutyfyPrNVdAWsiXQ4qfmz2iBeqZDKYVyTNzyeZVmu8rv	14107	19876	19876	1619516880000
28561	3NKhEodXYgwMMrLhXesdRRiLCdJNkYU4LRraKyXRLjuzNgCq5upG	28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	448	1179	559	12463	18974	jwparWFUWsJJn1guGXTPq254NxgVsAXo6GVvCAoah639BoAgazB	14109	19880	19880	1619517600000
28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	28561	3NKhEodXYgwMMrLhXesdRRiLCdJNkYU4LRraKyXRLjuzNgCq5upG	1654	1094	559	12463	18974	jwCNxMqcdrBKt96ahDoXCN7ab8heo4gVNB8jz5f8paCypaAaSbg	14110	19881	19881	1619517780000
28571	3NLdyMPVB4i6ZPXxtdf2RU1LYZUxUkdhGR1ADbdsF5sGsmxcCGLY	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1406	1393	559	12463	18974	jxC3Za2sJgueB5amLRXAzWgg6DiCycSzXNpe5WrQQxfu1qeF4oi	14113	19888	19888	1619519040000
28573	3NKKnnXp3qcxvtH5YuZcKU4ov37yAuZJonuGkSzWWM6EUMNG961P	28520	3NKsSzdyyx7FSdZEz238KCn6mhG29rcKPv7BVdfE1v7YZ3Akjxdn	1610	1068	558	12463	18974	jwW64m1mFT1Dzv7YCDhoTzcoqCbwEodh2PfoZuorUzuiZuSxQb6	14093	19888	19888	1619519040000
28575	3NLecSiXr6EgyDYWA9Jv5q92jgpFbHm74JaCwmknjfLQxpEdNXeL	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1651	1055	559	12463	18974	jwAcwBDJoFw1JRU1jKfTYG6R5Fr17cFYiKyyH6cx7n2sSeSVP14	14113	19888	19888	1619519040000
28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1397	828	559	12463	18974	jxkXgtYJSUajUya9Kub7TRNSPmwhYC8N1giMKtLTkWTL41cpXxB	14114	19890	19890	1619519400000
28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1536	1067	559	12463	18974	jwajAR1o1QKSidjjBsNAuKXfK1Rk4WsjdLHG6e3rFXgxnmbCKhj	14115	19892	19892	1619519760000
28584	3NLehyWmga7HT6sWm9dLCSMomJdwMscHGzqp5iFe43KeZTfPb4jW	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	1536	947	559	12463	18974	jwJ62EJGDL9Unk1f7cyrdNTMtM5Kfe2dYSe2CCtF83XcGo8p7sK	14116	19893	19893	1619519940000
28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	28583	3NKSnnDffnnweFeHPqFs1T6QsSKopPRsBKHFwL9cDNuP5CPTmwfG	1406	1393	559	12463	18974	jxYmyQSqd4DsrMQdWXsAUBWsFChvwgQuPTvnLTxNUXyA5U6bg33	14117	19896	19896	1619520480000
28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	1406	1393	559	12463	18974	jxM2EXDLoJGNfKbbWYUMzoJPrth6Kt75UzVGKZ2Ba9RJZR6LRKA	14118	19897	19897	1619520660000
28596	3NKi9uZFjHdnnjk6TLrubgeBQRjotcPeoirSAxGv38JH62r7h72e	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jwjy1MP8DEAR5K6L1Fqysq7F399EhjbaxchQon1KMRT7CzWc4Cy	14121	19901	19901	1619521380000
28598	3NKLViyPPH5vsYF1BTKH2nPFLPKdAxDHDh7mjGnu95n6eEoANKa7	28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	1650	1375	560	12463	18974	jxoWiqSTt1xEDHMHLq4pGK2ELs9TooZyoYvAYd56EptjUfBQ7wm	14122	19902	19902	1619521560000
28601	3NKGTxoPqsnoxziMpthCkKFU2qGK7p37BVMNeML9Dj65eBNWsbQU	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	80	80	560	12463	18974	jwXaWAtb8d3PxDJ2U9LjmL9fr1VLQJVJTz2ExNNYnHmUSU55XU6	14124	19904	19904	1619521920000
28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1599	1161	558	12463	18974	jw84ECHWCpwogmmMjvAjZ8zyX4eKd79U4uB4hLJokZzAfPwq1gf	14092	19858	19858	1619513640000
28524	3NKiud5SmMy6uvFRRJpUkeEBHsXoPuSNfYdEP6auhhtuMKnRMeBz	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1651	1055	558	12463	18974	jxMLJNcNxDYJgTTmGbgjnHVDSFWAfay2SqWoPZpo1oN2NMj1Wp4	14093	19859	19859	1619513820000
28529	3NKBEZuiXjEzqwo7PoP8gzst7sUHFEhZMRNmF55puE4PmAgw1CeF	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1616	116	558	12463	18974	jxikqnpfysFqbnJBLsrZtXtxMRHKWQsv95AqyfoLq3EkifA7J9Y	14095	19861	19861	1619514180000
28534	3NLddC2jZVTd151r9yV7HVWJACujwd9ATQ54yfhUe1TE16u9k28U	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1633	1390	558	12463	18974	jxqwjmdZaJ6LqURDWi7snHs9TPuWyrvyKNZdGSGtEg3LSSmjRnz	14098	19865	19865	1619514900000
28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	28533	3NKyk5niXjWuGUYWMBpVaPwEkTU6xfFWZtGsQc4H7Qm6XHXTokX1	1407	1395	558	12463	18974	jwzFjEpPWZuEgNDF9QJjHpKf99s8n6ABsa3eT4ish4Zn3T9wEgU	14099	19866	19866	1619515080000
28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	28541	3NKGEG5QGcaTYy4tbFvxVYzB2tGsKJmxDNtMnQiU8yiJhSnM64tf	1616	2	559	12463	18974	jxMjrC467wPGPnNidJFBF6Kmxe8FrjhjUKvxg5w4Xzx76g9n5tQ	14102	19870	19870	1619515800000
28548	3NLVexaZNBRU8B5CvUvUFn4sGh6nk84tWiC4BeW2vKov6MRdCuYW	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1460	1324	559	12463	18974	jwhYk1RD7FpdsKbbPYZuGPrx2VStoXp8WCxbz3pGXgdUqid6UEa	14104	19872	19872	1619516160000
28552	3NKMiyr4g3v3nhsUHJar7sJF6JeWbcu6M6sMyTKZDv3sWRM35AQn	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jx9FY2LeLwcu4563eMUBBhUtta8FvctQFb1u63kuwFzQjxE5rUc	14104	19872	19872	1619516160000
28554	3NKEkUeu2hqoUknE9rdqz9yF6JipJiKMaT3ZRbcW9NZbvc9WVNvK	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1613	983	559	12463	18974	jwbpVNACgma2QxNTrpkupUxihv7LQe9yYtvyj4VpP3zwMQVc6mD	14105	19873	19873	1619516340000
28562	3NKxSsyx4GhC6FGrfyGCheE5h9uBLy99zyJpXRLA3FeAQBL4uKAM	28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	1642	1121	559	12463	18974	jwVNBuQhAiYv7t7nGXpSpwJ3APgTzHBfvt9JSpM28zbNQnk9c7u	14109	19880	19880	1619517600000
28564	3NK47SCQPkeVSYXXRKQ6pneEUmSFJpmNkaV2tjFTfoRgeZ9b9TEN	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1534	951	559	12463	18974	jwrsUzB6wTBUXbsUSjk822Z9tBVuB7uF8BN6gffaGg36c9hXD9R	14111	19883	19883	1619518140000
28566	3NLwcfvQTCyRoSXEWQsBzhgcSL1Ynkd1ByjC6xek6dT3TPSqJKQa	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1631	794	559	12463	18974	jxjYvaWA14xYTsaoYA8iVvZ7nMhkKigfAPxFUmSF4TDpC1YGVBj	14111	19883	19883	1619518140000
28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1610	1068	559	12463	18974	jxXTx7qeXCoNrPNmztC5zGKxQXCxVqDAzkPcEHtvsFd72RGtLag	14113	19888	19888	1619519040000
28576	3NKTgh2qxqCHWzvK7Uw6HQ91hBgWrfz5MXZsr8UBMDxKsndL4Bqr	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1546	1213	559	12463	18974	jxtvDQm32jzJLPBzSvJYkdqFj9KyZhMEqgDCoU25iyRvbCaus4p	14114	19890	19890	1619519400000
28581	3NLxdBgxUqbmJS3aQBgxsqtVBMuyfXwhyYshxQnLjNLTVQUrsn2t	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1454	130	559	12463	18974	jxV23uGTzN2KPfQtxQU8Wdc4dqhdtKKr2WTUZR6R7Lk4EHfhw3E	14115	19892	19892	1619519760000
28588	3NKWgPGwh1pG9qSJAn1kkph7BamBggxgEtZvTDhQUTkgzriGEpam	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	1672	919	559	12463	18974	jxMsjxoVGmaWuYJiXpjXUtXTmbsw63uxtpHUzXj185echezAVoM	14116	19898	19898	1619520840000
28590	3NLVSweiUoPZXL9hbZ2hs7aXwTBb86Ays92Envb7Tb23PvUxzvTa	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1406	1393	559	12463	18974	jwBn917WKRe7L5EpHmVFexMjtYwQfXRRGwbgZ2uMMY8RuUBgNse	14119	19898	19898	1619520840000
28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	28591	3NLDtryZNnZnFX3qvjRVHPTeZTF4fheiDnEbMnmQ7buh9PUp37V8	1654	1340	560	12463	18974	jwMVKikpYveoe5mE9D6d8LuHFhHUid3xbTtVLFYLJXzgMth3r5o	14120	19899	19899	1619521020000
28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	1406	1393	560	12463	18974	jxi4pUTxTCNNAWKvx79rcrNAMXqHEJjpMQCZBx4tHHQVdssonGJ	14125	19905	19905	1619522100000
28608	3NLYmoofkzuSpfYbW3GKkXV4K9JWmRDAzSfWCSMPkvecJadyK9Qr	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1672	919	560	12463	18974	jwjzJZbsiXfDNvJiJXFyBYnDWXWPxqj1r82LQCaukmiS9QWNqNu	14127	19907	19907	1619522460000
28610	3NLcgms2FLGqan662WYQXEMCg9ieaLE2ZsznMENLjoauhzHMn5bf	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1651	1175	560	12463	18974	jwe5rNUtsXs4JuLez12GL4ianVqkzAsc8bbdag4X2bDartuTKp5	14127	19907	19907	1619522460000
28612	3NLUJ9EksJ3dysMfnY8prQae1X9JcYg4LzpLbZSbZiA7z8XDaK5d	28607	3NKdTd9WEbX26vERkUe3AJDW3r35LTjnRqxB5Cq8xoJ7USMRHRLs	1672	1039	559	12463	18974	jxFXEno9FcPcLvDRmrpxK3bdgZQcNLqHes8CbScWCaAP3SHh371	14118	19908	19908	1619522640000
28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	28616	3NKqV9ygpXoZv3EZBjnh2vZF3pAZq9MD5ZwRQhGWHEfVF2B8ZYa1	1607	1102	560	12463	18974	jwrFPzsH9yDF2qkTSDJPPGAQucNgnvC1HSPGzNWUcKKpSftw1H3	14131	19912	19912	1619523360000
28619	3NLo1M8XkTtvmL9hhB6MyCAikuzNmby2wLePCT994CE9BT78cRZu	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	633	1138	560	12463	18974	jwMNve7iNbZ4rBdcb1LV5QKiZGRjhjiA16empJA1XB3UxKUvGe5	14132	19913	19913	1619523540000
28621	3NKTK6YBo14BtWjQp9Lf2Y8ZNk7NQhvoXh2cECDpDPoB8iQ4VgfJ	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1403	812	560	12463	18974	jxRhiv44KoTDkf9n7eeh7nYR99LG48bGKGchK2ZThJqCfs9sYcW	14132	19913	19913	1619523540000
28628	3NLPHE8wzVZMZZHqnpZyX9wYJomcj3uhGBZiWgERWh5CMhvkQ1nm	28627	3NK5GRAWH8JxDoZw4DXgKHpTqJAActfsNyocuiuHMM8P5iGVWdMB	1581	778	560	12463	18974	jxKG1fBQKubY1k8YGDrVyTbwmkJAY8SSj7vHBpjoE9sLg1dSvX6	14136	19917	19917	1619524260000
28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	28628	3NLPHE8wzVZMZZHqnpZyX9wYJomcj3uhGBZiWgERWh5CMhvkQ1nm	1619	1275	560	12463	18974	jxhdXegRFKchiMTN4128ZUK1w5neZV2FcZ5w1dLwnH522dyqjj6	14137	19921	19921	1619524980000
28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	1476	1371	560	12463	18974	jxTt2Z7UMtcom9utUnMkxZsfmEapxfRYqRASUJBsKCixsvXokB9	14139	19924	19924	1619525520000
28636	3NKVDb8coS21d75ePbS22usAzPm3Sqq8XsPy9AAnn9RBbQXj1HUJ	28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	555	555	560	12463	18974	jxrpKzW2aaCLxMXyYvJgpBCFzpEnZq1TxjZWi7me1UqCMX3ydKa	14140	19925	19925	1619525700000
28639	3NKBHZhN1JS4hcU2bdjBwGdsw15d3776g82QqkgBpnGdpDcmCyUV	28508	3NLNTgeoUEJsfJaQC1VSiYV3Cxc6tXftZDapnQ6yGL4oSGosNoQJ	1426	1364	552	12463	18974	jwWbL3pgiuJTDGsBuYu8mHgAqCZBb8k7ayTha7zger4UUW2AF71	13934	19926	19926	1619525880000
28643	3NKUEZpXi5su5BywzXqARqLDjTLY7moZ1bdVYjHTJjueQfC7L2NJ	28623	3NL7CFambEjLDbDRbB7b7evvEurffbBkmu79KPe75fdUW3iEwhiw	563	1359	558	12463	18974	jx1zLxR4fZBUYAaBBLBeVspv4HnVdHa8gNtaB6QP7wc9C1pPJVg	14090	19928	19928	1619526240000
28645	3NK3vjcYyBphaN4tvwAM4WFyHfST6t5CUpy5oaDGetDkXCsKj3NK	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1670	1036	561	12463	18974	jxSxwqqVLmJbR2Srm6Zear9vhUC9SSNiuEFVSM2ip5v48YUmiUM	14143	19929	19929	1619526420000
28532	3NLdaPMrt4wb5bCwyb9Nv6PD75SDrJJByRWuA5rQm7du3v55yxZ6	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1455	966	558	12463	18974	jwpEqX2cKBSd32E8gLLADxKPLYueaJR9ifdJYEXacitwKDPjsTa	14098	19865	19865	1619514900000
28535	3NLCkonCroud9SuUYvq5ZWKETirBYUWxK9xELBx9yu4rcVb4yWD9	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1419	814	558	12463	18974	jwLDdobCCA2RiyiP9HQFokTkhLM1J1gTRqFWSEZenvwpC8t9urR	14098	19865	19865	1619514900000
28539	3NL71XRaGuLWhCVP7abdxexN8QqxLzV23tPxbo5X7VvLkJ2Ka6cj	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jxE8S2L7KUFfw1EsZXGn2iEzAmRQTfVKM6PG9wvFPGyBeTCb24N	14100	19867	19867	1619515260000
28541	3NKGEG5QGcaTYy4tbFvxVYzB2tGsKJmxDNtMnQiU8yiJhSnM64tf	28539	3NL71XRaGuLWhCVP7abdxexN8QqxLzV23tPxbo5X7VvLkJ2Ka6cj	1637	816	558	12463	18974	jwZ3jpQM3xKS6UrVybhyw2V8dNQAN5NXD8MffMm1YMb84V9zhsv	14101	19868	19868	1619515440000
28546	3NK45Rk52eA4cxVCCugbt8Eci8LzvMQDXaEU7ENvafgiB6RD7CDK	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	641	1336	559	12463	18974	jwrFFoAy9uMZ7TTmXPWoAtPz8wAipuG1YDaKnzupffi4NZfz7Xf	14103	19871	19871	1619515980000
28549	3NKfAnEmMmnVZRgG7DTyBgMJNRiYfyYfbdbutDADiLwCw9r43AFC	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jxUQTYn2f48rDQoADxr3YcAyyVFnuYmbzJe37y4qKf6UkbeVWux	14104	19872	19872	1619516160000
28556	3NKVw7bz1RsYmkPVGJmnYZN5YY4rJ2knF9zo7xY8j6vFD3VML76h	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1577	961	555	12463	18974	jwVe8z625URWcKJRuuZWVZfTy63c24Vu6a1bVJA2yc9CtLvAjRm	14015	19873	19873	1619516350499
28559	3NL198NoU5V7856AQvkAdgE4ZN9frMbibkTvoDxmzpFiyp9scwPN	28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	1670	1156	559	12463	18974	jxwhb6tsfx4E1Lu5yHZ2ExTTgnrW44VLqrutt2gAzXo8d2s5BQX	14106	19877	19877	1619517060000
28567	3NKpSvTVtkyoqNAAL1CsVnx1WNiPt8bfcRYy7sXfZqAzcztWg33V	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1529	1070	559	12463	18974	jwRzdXnYdCX3cfyodQDGG26Gs1mYQ3SoEExzx5ghPPE4N6q47W5	14112	19886	19886	1619518680000
28569	3NKsYQ9XtP9X391L5iq74A7aaaH4zet1HB4X2BeRMEFpdjALStiH	28468	3NKNrGaha9h3hBdTtshhimtXZukPXzahhHqTGty88nXW6SF2zT2X	1553	776	549	12463	18974	jxrSyyppNBvwfC2FjF397LwqCv96GqGhKzdWAf67V9Sk2WiKEHx	13882	19886	19886	1619518680000
28574	3NKCSyD5v3zJuRuAVUsMgtazSULTCEPAMboTe1vfJiybEJemSTCw	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1651	1055	559	12463	18974	jwhzMmQJy1L2tCANFgcVTdD694fivF6zYEcoYpWCaFmDTfouYjo	14113	19888	19888	1619519040000
28582	3NLrRhfqTkWvuZ9tR9i6HKg8xuCc4RGKUJxDeJywSgcjW6N8EyPp	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1406	1393	559	12463	18974	jwgdm368kmQrXYP2kn4gJQSQzgnhz7LcgkrFEGdN3hb9xzXv2au	14115	19892	19892	1619519760000
28583	3NKSnnDffnnweFeHPqFs1T6QsSKopPRsBKHFwL9cDNuP5CPTmwfG	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	80	1273	559	12463	18974	jw9PpZR1Jm362qVP5UEHJckHj1Ez1v8mB6QjkSxCJ7paZ9kyym6	14116	19893	19893	1619519940000
28586	3NLhcX2juPF5TbLbChSi24fezP32r3j5WVMae9vcTp8AyzFCNBd6	28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	1483	878	559	12463	18974	jxmCmRDQDSHR9gkHRsCpnrcnQzgN3KHh2Zj4JNuL4trcGmN1sRn	14118	19897	19897	1619520660000
28589	3NLJAxbAUxMu1YMZN3EQECJ84LhLW3HTNNpUuVQUjbW7TBNRkR49	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1672	919	559	12463	18974	jwcZTzS8cM3ozE3h47FS3DWhGKny65E3HNMqHn49hQcJ2tG38Xj	14119	19898	19898	1619520840000
28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1402	874	560	12463	18974	jxjFEbVE9Sqi1peSYe1oPCGmTjYTtmez1YDr5rdbXZ7fUjxqQDU	14121	19901	19901	1619521380000
28595	3NKmg3DVBS3ZVXtVQ84TieXn8CBifWB3G52qtepz3JSc863iAHYq	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jwprE6VbhBnYp2rwjcSqPpLyQimNa5GksrHwdQ8zPZHGhn2mCBv	14121	19901	19901	1619521380000
28597	3NLUS5cV7SS9cmgenTM55MrVu8dg76xCiBKvCfv6LFKxs22CFaZ1	28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	1406	1393	560	12463	18974	jwYWudNfbgLBGdX7x5pLAVLZxHhJZLaThGUkj6eaT8jnEQpaydB	14122	19902	19902	1619521560000
28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	28597	3NLUS5cV7SS9cmgenTM55MrVu8dg76xCiBKvCfv6LFKxs22CFaZ1	1542	1058	560	12463	18974	jwTVvJjYckyfhHPqwMPiG1UgHDTZ2cWrxTNLqfNvwrVtnjq7Yy4	14123	19903	19903	1619521740000
28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	1649	1257	560	12463	18974	jwVWDD5ej1ssKbSKJ9Cn2XVvYtGv1FgTK5TKtj1oNWdGTFLxkKw	14124	19904	19904	1619521920000
28604	3NKfo8SdNqzyYdFoFpwciPdk4ixaKSf59aVHLMajs4GpE9UDDg2o	28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	641	1090	560	12463	18974	jwoZy7dunmR5Loq97Wh6x8ChaoTYL8cPjPcVGZKQ56eE7qubDTv	14125	19905	19905	1619522100000
28606	3NL7xKpg9sSvdz4rbEu2h2yYucT6ZJvB5p71Q12u68JyJKYArnyg	28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	1403	824	560	12463	18974	jxXLYtxgQXRe4q4HkeVvMxSQeWxswEafmvvGyP8TbMYj14LptPC	14126	19906	19906	1619522280000
28609	3NKcx3BjFSyGGfkdFMT9iGr7bgNG9bWrvj2ZhZRgs78Czv5737N3	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1406	1393	560	12463	18974	jxiKp86AKrkrvk9xmnpzQjk6ygySRnJpXWsRhfhPbK6uHuXZvVb	14127	19907	19907	1619522460000
28613	3NLHKWeiyGuqcQoZDzYTf8TbsnvntLuwqfb3m3Q1XQBK5d3XeUvb	28611	3NKpye78asT8eNa5nyfMRi7nM7DrmYudaqbAyQGgF2aYxGZzjqCf	1672	1039	560	12463	18974	jwxfEqQ7nguoRh2oQp77Wy6VodgFn3ZVznZrjwz2vCHDBDRHDu4	14128	19908	19908	1619522640000
28615	3NKGTosyta2uVqY4q3j8HGhbEFoJuSwaiKaDicWLaZ9Zknewsrzw	28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	1627	1385	560	12463	18974	jwUX8vbFF4XQpjJois3dP8qQKxdF37RKzE1SNWtmSkpd2CP5Wib	14130	19911	19911	1619523180000
28622	3NKL62qYoXKzpaqUomk6TWqQxJUMDA5VyKAuzsS5TD7GdbXjrzpn	28621	3NKTK6YBo14BtWjQp9Lf2Y8ZNk7NQhvoXh2cECDpDPoB8iQ4VgfJ	1403	824	560	12463	18974	jx7CY97StEJgRumLRtTMUBcQhz3A7sbPP8dA8AcoNz6mRiZSexE	14133	19914	19914	1619523720000
28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	28622	3NKL62qYoXKzpaqUomk6TWqQxJUMDA5VyKAuzsS5TD7GdbXjrzpn	563	1233	560	12463	18974	jww9vVHWPSYxB8X8jGXmurvaAcVxUCEn8ptwHe3EgYwVtUMRb3x	14134	19915	19915	1619523900000
28627	3NK5GRAWH8JxDoZw4DXgKHpTqJAActfsNyocuiuHMM8P5iGVWdMB	28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	311	941	560	12463	18974	jwmVyoDdCKr1bjygyL1B1GVsZ3KDS6BEqoFyoqYTTTWyccyrjKo	14135	19916	19916	1619524080000
28630	3NKV8Y8Yks3suBZAeU2pPvRgiooSZTnMLaDqKZAxtVqraHgCa11J	28626	3NLhusdXsL3iJR7S7qWMcj6tVGzfHNtuMZs9ZwDaExqshEMVJn1u	1553	776	549	12463	18974	jx5Db31Hoz4tqogqrrCvNo5iN7CQfAsH5RhWmn3Z5nYBS132GAk	13885	19922	19922	1619525160000
28632	3NKK9P2FPo7aCkPvux77RYPC8rWTSL8o243Pxmy6R9FZdCjgNLxe	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1654	1094	560	12463	18974	jwwJpekD1xQQ7zDLt6SfLV7CoWg4bbV8GVZrvWwQyerZH7FuJy2	14138	19922	19922	1619525160000
28635	3NLKd22JQ5HuTMwmEf6yLyRT6opkgCBPBHxrEAkqK99U7NU7eTw1	28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	1648	1038	560	12463	18974	jwav5w419uudXvh2ndEsmUL6TzmQbgQ4F8b6iD612Dsri4TsJoQ	14139	19924	19924	1619525520000
28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	1405	873	561	12463	18974	jxkoFcQNT6tqHDQD8H3QszLvKeK4XyAVzkiMVD5BTrwXz1ir9v7	14142	19928	19928	1619526240000
28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	1631	794	559	12463	18974	jwBrK7BfwbKR6ZUX3x4LusSeNACNvybfKwKWMGYD2m4o3hr9YdG	14106	19874	19874	1619516520000
28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	28558	3NLqTJkJhkowhJVdiZS8kkgfTB7LAZaqxfNL77BcP14uEbmb5tjG	1670	1156	559	12463	18974	jxeyjY3vpiqo27qCpLsmWhnwAWdcVG9uVQKVs4mGjvqzZTKxzXG	14108	19877	19877	1619517060000
28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1581	778	559	12463	18974	jxLjFeKHEobFYFMVSeLFLMNGZn8wsRmG3ecSgnYZy15eAMrsU6X	14111	19883	19883	1619518140000
28568	3NLsuWc4DeSzc8NB1ThMAio7Jo52CifxnjdXnVnPegrfmM7DQY2k	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1529	1070	559	12463	18974	jxafYgJkr84hVwxuLZ5WN6cFQPmYaiHTEQdJRiTxr1GCswBZY8q	14112	19886	19886	1619518680000
28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1419	814	559	12463	18974	jwWaRjmyebseThUshTUqSwm2HCH5KPYvXihqtqQ2cQxEGMFgLVn	14112	19886	19886	1619518680000
28577	3NL4V9jwAY1KyE4sQnEXWWLvFdb19QCe2ywrtLUQSdJQGfo5Atki	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1406	1393	559	12463	18974	jwDC7dagAgUGC6zQfowTsVEUMJpNpJTWU3KRkbo48pitKNan5aL	14114	19890	19890	1619519400000
28579	3NLi9KR9qNMApSH9srxxbteBB5eD1D16Da3kwPwVGuGsori8sJJN	28569	3NKsYQ9XtP9X391L5iq74A7aaaH4zet1HB4X2BeRMEFpdjALStiH	1553	776	549	12463	18974	jxiEc6syNXQbSkwbzPGmudpjs8kiiY6Ycz3ewxjK5bZX7mSzB3r	13883	19891	19891	1619519580000
28591	3NLDtryZNnZnFX3qvjRVHPTeZTF4fheiDnEbMnmQ7buh9PUp37V8	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1596	1117	559	12463	18974	jw7S2veZoMnsyxUteYt3LAtfdkt1qPVV4dd78BinxCD6qYmx8R3	14119	19898	19898	1619520840000
28594	3NKozTc6djWtYo8eDegmw855TQuthRgsCU2AoaHLMRmKnqRE9VsY	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jw9x9KaLZpTYy4HeAymvR2GPAdszNJHvPWJ2a26nr21jrE3jJqd	14121	19901	19901	1619521380000
28600	3NKF7WRwqBt3fSuMrjjCvxkjMkuisDD2BBGCUoRWzV8PrwirVRnG	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	1516	1294	560	12463	18974	jxS6ek7a9T6xFEqNeFf2BrsXwoCrYBN4UpVGtNx9ckuYzvsQWH9	14124	19904	19904	1619521920000
28611	3NKpye78asT8eNa5nyfMRi7nM7DrmYudaqbAyQGgF2aYxGZzjqCf	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1651	1175	560	12463	18974	jwDcBTmK6i7TbMbqKmBEDqvqELaAcuqhDDSuYHaF9dryWHnG6PX	14127	19907	19907	1619522460000
28616	3NKqV9ygpXoZv3EZBjnh2vZF3pAZq9MD5ZwRQhGWHEfVF2B8ZYa1	28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	641	1336	560	12463	18974	jwdJXvy3yz61pUo6BQhUE5mbAu29GVZaKmfCoFr9BM2DEGP9sNb	14130	19911	19911	1619523180000
28618	3NKjFEAEzJHJ5mF8N2MupTj1juxmJFsDYC33KaQtbJrmtawHzkvs	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1444	1135	560	12463	18974	jwMEVRWr2SUgovxqaYHn3YDJzS8vZR5iGKgZY28u7AZTA8Ecnas	14132	19913	19913	1619523540000
28620	3NKoXgDvBsXE41XrQRukFdL1in6acVPJURMVU7usDZNgUpGEYEyK	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1675	1342	560	12463	18974	jwVx2pbffK8muQPF7CVtnppJQcCE5aLNxgBG8LnfjC78Wz5uWQA	14132	19913	19913	1619523540000
28625	3NLrUjkkzUMReM2xEGF5ZoMeJgxd9bngfzbLQSkQUAPHxT6mm6Ug	28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	1607	1102	560	12463	18974	jxRGc7cdRSm1Q6bTLPpKVsW4mPWqMo5Y5N1BMrPMcKcFD8Zjs5b	14135	19916	19916	1619524080000
28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1627	1259	560	12463	18974	jwVqnUWmjT55aFVPHr2qndDTd8h6SbthhUYmbCNnVBs2u4VLe7V	14138	19922	19922	1619525160000
28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	555	555	560	12463	18974	jxrpKzW2aaCLxMXyYvJgpBCFzpEnZq1TxjZWi7me1UqCMX3ydKa	14140	19925	19925	1619525700000
28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1403	792	561	12463	18974	jxTxqukmBWqvHumjdZ9YDYFEHLLUhiE3jYsf4bnu5AZeXewqAr7	14141	19926	19926	1619525880000
28646	3NKBZwrJ2wxkXPmisLzGbppsRUgG3wmJfkhgQ4yzw9v9HwzozzQE	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1670	1036	561	12463	18974	jwVxS33dngbJ8cswbDwMqc4LQfya5mPhuz8NJcYHyQGByouSL2m	14143	19929	19929	1619526420000
28648	3NLDDxf86FfAAtgd2kEKN2R5nJcGwcovxJuSdKApmRYjmVascdCT	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1406	1393	561	12463	18974	jwUDCCnfquhNXB9LxHJ9CkGf4774qsKB7bgwFcGPpdf6vpJ5z2B	14143	19929	19929	1619526420000
28650	3NL2pFSCNMMxUdMk2HzJofYsiejMZE8zFV1dxRkatUy67bU2JFKV	28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	684	1106	561	12463	18974	jxa1BiVWAcLXf9ezfacGqTtmj4ABaZftqbW2NBDCf3kszoVZ4SN	14144	19930	19930	1619526600000
28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1593	1346	561	12463	18974	jwL82pZQXjnNDw9LpmgVWB6kDGtLhdfoXka7B4793iBJKxKYmku	14148	19940	19940	1619528400000
28657	3NKiJZEKxzFYAAMEcm8khrwYkZF2ojS3Yzdw1oXXvCEAMWypdyVG	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1596	1363	561	12463	18974	jwcmFwTuAjuF22PM45ZSU7xXZByXuFHtKkYmZ8Lbp5iHws4sJAC	14148	19940	19940	1619528400000
28661	3NKKecESB776jdrgNhu34eQQiKh3szjEFp9J7MRQA63e7dSEX2fz	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	1406	1393	561	12463	18974	jxkjM5KjAjoxDtRpcvwzSAvc7ay5kwVXRBJyX7R9UCLhrBvartk	14150	19942	19942	1619528760000
28663	3NLEcH82bjcBPLRx5RM1GuydEWZrB25ws2Kze8V4BMi3kTW2V7Xa	28661	3NKKecESB776jdrgNhu34eQQiKh3szjEFp9J7MRQA63e7dSEX2fz	1588	1392	561	12463	18974	jxas5AswzcWT9M7eDnFnpjjj8RKahcHeYTiHSvpxLCrhUD7RdWR	14151	19943	19943	1619528940000
28667	3NKHND8MYDpW6ptk4mGqu3D93SzU25sP9mNzHeSSoUGWkVogZaG4	28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	1631	794	561	12463	18974	jxwpJzd1rJ8EB2RGqUz7enDyLtoyfhWmsvXyCoXNMiXQBcxojFS	14153	19945	19945	1619529300000
28681	3NKtigbryVc3RecyR5jY7jLyhoTnbHEk3fU5dpRuP1aBtfo5KpeR	28679	3NLCNiVfaDg6wAuDDSWqCqh2XPGFfyFRHoJNCKmR6N7qJNZ7BiqQ	1508	1387	561	12463	18974	jwE4aqUQgpmUk3PRtmqCqvKNwgzaWyudyRuAGZ4Lj6thcfhJQDQ	14159	19954	19954	1619530920000
28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	28681	3NKtigbryVc3RecyR5jY7jLyhoTnbHEk3fU5dpRuP1aBtfo5KpeR	1444	1255	561	12463	18974	jwSLNaud47iK4XuS7dfqMCquBTaHUUxev8sJg5yQsAxkNkcJs5c	14160	19955	19955	1619531100000
28686	3NKyijieL166eDBUYATaJtvSzNoeuzHdTFpLVu6gMv2PF8SC8qGL	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	1581	778	561	12463	18974	jwtBeUxb5dswMyY22yoP9nfmh2ossJcyPm6p7NCHto73jegKzsm	14161	19956	19956	1619531280000
28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	28689	3NLpBsW6FPtcZr4n3maQYWpTKX6jrKb2KJi53Kk9kZhDZX6YaFbx	1652	949	561	12463	18974	jwotgPEG8agCS6pe2wbZj3TtDGkC3AU1Nuy75oDuW3V1L4uyYYd	14164	19959	19959	1619531820000
28697	3NLXQ2PX9hNKqhbUixo5ghB9fnogmQqWsoBdoRJ6v6wPjXKYsWE9	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	562	12463	18974	jx26DoZ5rPd3FQrWfxxjUep96ooy7GqTp2FLYTPY2JjN241QGU8	14167	19962	19962	1619532360000
28699	3NKKE5gVN4iUjXCcnfGijfWxyQaQKJoWaiEnsyQhdok81sABSLiY	28698	3NLVDNRo3fQwEBsKDMdcG2PUatcVreNCkpfv6LMgksvsRDR3nRQk	1405	861	562	12463	18974	jxZUsHpm7GssDwcaYBcRs2uayzTpJD5kRJL4xzLQEDZmZjQmFJL	14168	19963	19963	1619532540000
28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	1483	1150	560	12463	18974	jxw8TPUtb1jBXLixDSS2nDZMERnTtUhuk4XYwmmUiYQ9JFoVFwV	14126	19906	19906	1619522280000
28607	3NKdTd9WEbX26vERkUe3AJDW3r35LTjnRqxB5Cq8xoJ7USMRHRLs	28588	3NKWgPGwh1pG9qSJAn1kkph7BamBggxgEtZvTDhQUTkgzriGEpam	1672	919	559	12463	18974	jx2aEkLJtzHwnRhHsoEhedWhYJzuKRCZ6kMJ1rqAggmLAiZbytD	14117	19907	19907	1619522460000
28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	28613	3NLHKWeiyGuqcQoZDzYTf8TbsnvntLuwqfb3m3Q1XQBK5d3XeUvb	1657	1344	560	12463	18974	jwpMcL1FpsiwtWogGXRYc2tAp8HZthSG8G732uWiT2pCnt1R8Q1	14129	19910	19910	1619523000000
28623	3NL7CFambEjLDbDRbB7b7evvEurffbBkmu79KPe75fdUW3iEwhiw	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	563	1233	558	12463	18974	jxCfxMB8gQ2UR7qT71rcs4MvdXsPdcXqAFDyGeDxgsPjBeKKYp4	14089	19915	19915	1619523900000
28626	3NLhusdXsL3iJR7S7qWMcj6tVGzfHNtuMZs9ZwDaExqshEMVJn1u	28579	3NLi9KR9qNMApSH9srxxbteBB5eD1D16Da3kwPwVGuGsori8sJJN	1553	776	549	12463	18974	jwa5J7fHEfD2toJYuFRAvH6yqvo6bwwGikneQzijpuGFGFgZ2i3	13884	19916	19916	1619524080000
28631	3NKgVU71EVL5fzvAbXhPnww7e6eAUZ5uvEArA9SG5j6ArgcKYWPw	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1405	873	560	12463	18974	jwyJ8ZpLdbCgv2aFUKqXPsjMc52ideTVsykd7hwCw4P6b1sR7To	14138	19922	19922	1619525160000
28638	3NLWEhXPkmDsmHRSAZbsxBV4N1ppEacC35U1Eghc2StxsunSoeX1	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1426	1364	561	12463	18974	jwxKG2pXyEtpmh4FE7c3gUaD1dSB2fMXTkdtX72hZReUfSHDB4R	14141	19926	19926	1619525880000
28640	3NLEHafGSGuu3s1D56EiYG6KsgdKRfYipCXedLrGNwr5YywXMreA	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1406	1393	561	12463	18974	jxiEk6aVmcV4BL7USEndEFZAHHU7rhuC9FZL15S3KR17nDFD6xJ	14141	19926	19926	1619525880000
28649	3NL1Wb86RLXAb1eqHkyxYkKFzzhfbwFBYpbzzceVrEU3jSGjh6SA	28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	1467	1010	561	12463	18974	jxha253jKv4MWKJcixiAtG3pYqUgrgk3CBzNB38Tt6UH2e5K44a	14144	19930	19930	1619526600000
28652	3NLVmWYQYXXvUqF1okqLsE6ofSWrTNVh9xvFG4kGn3ES84rvPV89	28651	3NKL4V8qT3U9GM9J7ji4Smu6iwJToeye6HpDn5Qypf6sEAAgTAYX	1581	778	561	12463	18974	jwgg3w8ycmeLyRFbkjMD38Lb35mB4QSoNYQ8SjJRNtmLTdysCcw	14146	19934	19934	1619527320000
28660	3NKX4eKc38W8kFWFSeooQhzb9Jjsy8K1VwpekUPMCMYcHiXLMxJ3	28658	3NKaNEQN6ZeghcgTAnz2PRuF5pYaV8g8ETLnN4CtteFFVzgXoebb	563	993	558	12463	18974	jwo93XfjY4kA2m3mFtx8dSEnhrjkFS3NA3XWsPGRcDxRZHVjqMt	14092	19942	19942	1619528760000
28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	28667	3NKHND8MYDpW6ptk4mGqu3D93SzU25sP9mNzHeSSoUGWkVogZaG4	1402	874	561	12463	18974	jy1rsyLVm6AitdcYbstmykHGLkJNRhwqNLxgTyrA3DmtehxixwZ	14154	19947	19947	1619529660000
28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1610	1314	561	12463	18974	jwE27uyFAvNst5zTa2TzYJzjACTWfosurgj7pnF1kzCgEsgq8W4	14155	19948	19948	1619529840000
28673	3NKxup1roBVzHNRq5gfmxzFL9BdwAhXs8bpWhLhwx5qywABVHmgq	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1578	1296	561	12463	18974	jxXK5Vfmz2P1ndR4TnBHJjEHSZgygLbpTX1aRykQaYZyoLuro5C	14156	19950	19950	1619530200000
28676	3NLrCUqRknG94mWvY8eW9JpdSx7BB7wspRerX4RFrkEoUZFr3pWp	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	298	1308	561	12463	18974	jxDACmD2aNacqssx69ce6oKbstehj71CnHbXc4qpkhbJoMkfJTT	14156	19950	19950	1619530200000
28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	1406	1393	561	12463	18974	jxtePFJmomZxpr7WeD9LexDcuF4isqoAfaMLCRCwVRkRfqXbecS	14157	19952	19952	1619530560000
28680	3NLw4WzdD2TKnHESXnRUZQV3YbDhaJWX6oYVKGMwzcBn1BwPYtD1	28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	1406	1393	561	12463	18974	jx59nBgjMDHHGuv5yQWCnsxvjTumFDwjpD59d7VgPCAyz791Q3Y	14158	19953	19953	1619530740000
28682	3NL6QRniz6jAFWbZA45JoLTtNnu5zJoWuzjt6ZQq57CnmgsJPGy3	28677	3NKnny9sMGLGRwm1TL6fH7uds3xSMEcih77yRj9ng8wjR2L5Bb2U	1553	775	549	12463	18974	jwHRpLHUat18boRNoS4TWSqhJv6tv5i4CvgeGAuZUabhgHGetcv	13887	19955	19955	1619531100000
28687	3NKXxh8cbYA9fdBdNWU2rrhHMD6e3dpkmS3TJs8ZxkJECtAQjbCF	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	1403	824	561	12463	18974	jx4pLJYBJEXJJNPvVGfxFjVKMyPPhkdv1Dxmp9wHHG4uUVqWYMZ	14161	19956	19956	1619531280000
28689	3NLpBsW6FPtcZr4n3maQYWpTKX6jrKb2KJi53Kk9kZhDZX6YaFbx	28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	1455	1206	561	12463	18974	jwbGuAqyqukKcDieX6riuEQTxb5qrgmS8EZdPmHgn7HirczDXz6	14163	19958	19958	1619531640000
28692	3NKgwGcRMQASnPVbQUFNB3JurHCZAunCR51Psjf18ic47nKy36Zi	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1588	1392	562	12463	18974	jwg9EnoDfhhJF165KXjfu5pxChWQYL1PNHkK55prbuTf9rJxi3q	14165	19960	19960	1619532000000
28696	3NKVw9Em8cPmH5QsbMAgEuUdYvMPUoCC9h5RNFUGurRd3sZYqkjG	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	561	12463	18974	jwUEAMb3jGY6Kzk4idcxs19uhiXo9rn6AkgZnFRF3wuLAecG65C	14167	19962	19962	1619532360000
28698	3NLVDNRo3fQwEBsKDMdcG2PUatcVreNCkpfv6LMgksvsRDR3nRQk	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	562	12463	18974	jx26DoZ5rPd3FQrWfxxjUep96ooy7GqTp2FLYTPY2JjN241QGU8	14167	19962	19962	1619532360000
28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	28702	3NKbbRT1g8QL3WW4bSEbbcjXWMG555H6bN9D4z2guM6Y8KPR6hnu	1406	1393	562	12463	18974	jxX1pwivVJYDF3N91BZdr77DAGrCj1wCbdxwnxLB1vtZqnBELr3	14171	19966	19966	1619533080000
28710	3NKWsSCE8n8gZDqCB9zTj1QADMPMF2nxgrM7vQtHwR8VNdjeipNW	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	152	1330	557	12463	18974	jxB65SSYTMQWydwBPxMNnb8VJQNhJpAtQgFhA4qZXvooMLeAqq8	14075	19968	19968	1619533440000
28714	3NKGmFCygSo3ww1C5xukpDi5qiMSzPwPSSEkH8SveZYctiCH1Yow	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1406	1393	562	12463	18974	jxtQBfFG5Byqx3CiUABVh5THLX8vKoPEdQzEciLr4zfkx5EMibP	14173	19968	19968	1619533440000
28720	3NLP5u3bvLwnbXb62dtH43C1NzsPF3B2ArckZyWzpQsEUK5hmuyf	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1451	1292	562	12463	18974	jxBwfXqprdm6KfxNUDgXrDj7W1ygQX1NikVyvTqZyUWZTDGkDmd	14174	19969	19969	1619533620000
28722	3NKFTQ18Wbgw5mEgKXYUEBJL2rEDRNHNS46nVM2VCEgugeE6rVeU	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	1654	1094	562	12463	18974	jwYbzNrxuW8C5UFn441sMYB1saTCJBy1bgkQqAhWzQb6S7dt34U	14175	19971	19971	1619533980000
28727	3NLbxi3wp1argtCEd3NN5Znx7THHcsgbpcdDp2v2SmPnwGdv8qgh	28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	1403	824	561	12463	18974	jwiZdo1i95F8BRXafdMV2zkYSTHGAjPs2sLt5q1HaJHNS7W3KUU	14163	19972	19972	1619534197375
28733	3NLgoL5qisXvob9heviTtvthuRr4ExcTFuzdrHQ6pYQF9AxHv96H	28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	44	1199	562	12463	18974	jwQTKuwzMQ1vHuuzaekU5DJVqZ5eMhLuC37dTYKLmV28J47VhHj	14178	19974	19974	1619534520000
28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	28732	3NLjFXFy3BnhB7d62jXJ2UbCL2xs4BXmEYpMq4sYhUePeh4Doovs	1609	1087	562	12463	18974	jy1yo8jpCK5n2hCqMA5Wgvgm3C4SfnZrDUAx5rENzL9eKXh5DrU	14179	19975	19975	1619534700000
28740	3NK6KZisfAmXws15Q75UW4yBTGo7cxymCggBtb8GQHLuxdfqQJAN	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	1407	1395	562	12463	18974	jxjVPpUXRLfKtUZq7xZpNYBw7UfMjizyBTvfSiWVAhxfSs94VDB	14181	19977	19977	1619535060000
28644	3NKqkbU5oxKAU2sWBz7F9VUMqcJgzMBNWjwkdGhVNUje78Aoqjmn	28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	563	1359	561	12463	18974	jxp3S2YsKG8MNPU7F5Wi8oTqGevbgA27YQ9qNBc29xz2wqqyXj9	14142	19928	19928	1619526240000
28651	3NKL4V8qT3U9GM9J7ji4Smu6iwJToeye6HpDn5Qypf6sEAAgTAYX	28650	3NL2pFSCNMMxUdMk2HzJofYsiejMZE8zFV1dxRkatUy67bU2JFKV	1631	794	561	12463	18974	jwThra8c2snf25NiU35hd3NQWdWHKp8rLuLjX6vL1tWwEeEz9w5	14145	19932	19932	1619526960000
28656	3NKKouaJcGozNmfpxXdqJ6pqpkGhDca6XizKNLwBC1CSq1XtJQyk	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	684	986	561	12463	18974	jxT75FpeaShyBYGKYA1R957D4W7Kn3YM8Mn8td893RojrhB4RgU	14148	19940	19940	1619528400000
28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	563	1233	561	12463	18974	jxTv17u6ohgZTanwZ2Ex8HdW5F2sv7xTcse3yWDf84PDrW78mLy	14149	19941	19941	1619528580000
28662	3NLWN8mKftdRswSL74CxS46dRBdjGig1nPLkQLVBHsD2bSLb5aLY	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	563	993	561	12463	18974	jxinSk4srs7Fc1DiRWBEnCpFHoMJx57h4NXfVy2rEhWNeyygmNA	14150	19942	19942	1619528760000
28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	28663	3NLEcH82bjcBPLRx5RM1GuydEWZrB25ws2Kze8V4BMi3kTW2V7Xa	1402	862	561	12463	18974	jxPS9xKaNw8CRUWKCtQU3TDwnosupUxUQvcDZ61mXmaxcx3dp1Y	14152	19944	19944	1619529120000
28665	3NLEykqhQoFum3zo8GxeFCUe7SwKibqhqk5NVP8ZAhgdqxbcYfd5	28322	3NLihba6daaGLK4mT1aeWq3zNRVGdyUvjwc8HQBXvBn2GTgtoPfc	1623	839	552	12463	18974	jxH7VM2q4h2MewYA4TZNSV7q1FyASb9ug2PNQTe6Nb4jrBFMRX1	13945	19944	19944	1619529120000
28670	3NLNE6uqM8UEXMg3pRQMBoTziDrCbfX5JzNHMrqQY74BoH6MvsAQ	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1607	982	561	12463	18974	jxuXuawZJJAzqMKwjigGcY9zpwMzGg3CBW71wchLSEb3oKs5eM6	14155	19948	19948	1619529840000
28672	3NLFYgYHbywPjGe92Yj2Kj9HyBuVwZnqc9ZWqdEYVnZfxcT7vnVb	28573	3NKKnnXp3qcxvtH5YuZcKU4ov37yAuZJonuGkSzWWM6EUMNG961P	1610	1314	559	12463	18974	jwpUG9T3SPZJbx2obKFZKTyzQcZanbe5VzdkTYMyeensb8xG8pP	14094	19948	19948	1619529840000
28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1460	1078	561	12463	18974	jxbxbGL4JSJBR41QPtEDaCGYDRU8dzvy465LwC9eobJkQjePqUL	14156	19950	19950	1619530200000
28677	3NKnny9sMGLGRwm1TL6fH7uds3xSMEcih77yRj9ng8wjR2L5Bb2U	28630	3NKV8Y8Yks3suBZAeU2pPvRgiooSZTnMLaDqKZAxtVqraHgCa11J	1553	776	549	12463	18974	jy2svANo6QtJBzwz4GJ4eoBtFAwFLVnB3GnMDxVDwFuh1b5Xibn	13886	19952	19952	1619530560000
28679	3NLCNiVfaDg6wAuDDSWqCqh2XPGFfyFRHoJNCKmR6N7qJNZ7BiqQ	28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	1407	1395	561	12463	18974	jwuJAznGbsh7rKJrJrDcee9YHVqgQNyBKHPLVHxjWUX361Teamg	14158	19953	19953	1619530740000
28684	3NKDSsbmrsrqCAf9mVKKhvCWg94Xa6bEfr8rsFT9fjxzrXP7bPzg	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	1444	1255	561	12463	18974	jxbstDqTubRPRnUyQAdhB5svCZNKvKEkX18noVR3depjJesyuWJ	14150	19955	19955	1619531100000
28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	1471	1140	561	12463	18974	jx3ypkE4D1mqZZKoDZMkUvVJhmLyJXB3T7CCKLtp6yxJCSTgDoU	14162	19957	19957	1619531460000
28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1647	1176	561	12463	18974	jxmfZWaffWPpshLK58HDVUzRHr4mnoFosNrNgppbADeWUC6yKNP	14165	19960	19960	1619532000000
28693	3NLAjRyANbMhjXpXTH9DZDZQPAU9cckU1aMpknL2CdTH7bcjx4Sw	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1631	794	562	12463	18974	jxbkyYVTUw9T71Q46FNxX1Jkq25VTWsQ6HnKSyb4BkyfxkgESYd	14165	19960	19960	1619532000000
28695	3NKRraViHhyDhpcJV4FaQcgduNcQmSQVA66yxo1z81NAUigcQVHH	28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	1602	1369	562	12463	18974	jwuusEP9d8TinyKLKadL9deKq1gqWhMd5TamGEEkhDNACVTucdE	14166	19961	19961	1619532180000
28700	3NLZUGtaXqJX32gytKvKHA7YSRzXMAbzBaWgkqgxL2a5Jka4emrg	28699	3NKKE5gVN4iUjXCcnfGijfWxyQaQKJoWaiEnsyQhdok81sABSLiY	484	953	562	12463	18974	jxmeKMnABHX9Kv8Bd1DfTkeWDysHRBaxA478cVz4jScXTej1X7d	14169	19964	19964	1619532720000
28702	3NKbbRT1g8QL3WW4bSEbbcjXWMG555H6bN9D4z2guM6Y8KPR6hnu	28700	3NLZUGtaXqJX32gytKvKHA7YSRzXMAbzBaWgkqgxL2a5Jka4emrg	1649	1649	562	12463	18974	jxgH9w6hH6RiSDhLBQsQaLprQpidwn2ZuMTBXLoFpxU1ZuK4rP3	14170	19965	19965	1619532900000
28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jwJ7SpPGybLUCqTRZJxMSeXofzH3sAnR9cAuon3NF6rk5EPvjet	14172	19967	19967	1619533260000
28707	3NKwSBDf447wEwcUBJQYGEXtTUYfjXBYnhnmBXvJwU7gDb89fRxS	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jwCNmyuwBDm3x4JhdwqRmVwyNTqxiJ4eQ6JJ5JgQgDUQDvjuRzR	14173	19968	19968	1619533440000
28711	3NLibEJPpK8pQTPaeajSM2T943kGQ3z3N3T4hHnPffJ4wuGEWJGG	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jwjuP9kAn7r8kwgLAg88eHFJ6ou55j19rM62m3vybG7t3Kc9qaW	14173	19968	19968	1619533440000
28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1451	1292	562	12463	18974	jwWDdN4r8DqgY3t7vukRfvVgqRnvJVssDVrtvBmpyqtJumtjmry	14174	19969	19969	1619533620000
28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	576	989	562	12463	18974	jwHy6p7QM7TY1XpjaDJf7b7MmMM76TZRdeHjorCTbGEXdtLYbYM	14175	19971	19971	1619533980000
28730	3NLJTrsk13is531CaAvs2HBg5r4hMXcz4bNwH55hcJgv2yJNEGdn	28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	1609	1333	562	12463	18974	jwU189kGZAt6cMeCGc7e7syj1if9M9AxzGMSnxsZSK26M1dsPWu	14177	19973	19973	1619534340000
28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	1406	1393	562	12463	18974	jxZSMsBj9UsgUnYkhxyvqrda6xWMTRUjP2raGxy45aMDNZHoaMx	14180	19976	19976	1619534880000
28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	1536	1067	562	12463	18974	jxgr4cC6bZLso8MMscZnpJYKdouiVdUsTaKVnVBxz6h4oLpeA1D	14181	19977	19977	1619535060000
28744	3NL88WxmQYKrLr72sEfcBRAr82v3Q9aQSV9aMWGQ2kkHSs6q5KVH	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1407	1395	562	12463	18974	jxFAAYqdgGdpUA8eXCsFuYsq2iCzQwF1rT4bKmCttFbnqgtsN27	14182	19978	19978	1619535240000
28746	3NKHMeEAuwN768tPy52VfP1uouGvYUXCLac8z959XPXmZVkdS2Z4	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	1553	775	550	12463	18974	jwje1vu9hVA5vCEMUZpPUttWaDDhCV6zkjsvKK7Fp7xpHpGpvPv	13893	19979	19979	1619535468008
28748	3NKyjkbZWN98ae3iEmJnwAzRwb6BCQq8FcWGdEQ4gieyqW9co3Nj	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1451	1046	562	12463	18974	jwtFnmQzYB3XBixhN7tFsGwa4twgSiMmupoeuWfd5PwbedAhvyh	14183	19980	19980	1619535600000
28750	3NLwDV8jCAxhaPimV1CcE1r8DQrCNve2kB4Pwhgcsq8virhbtsMm	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1407	1395	562	12463	18974	jxL2J9WS6iDUriF1Tx2fbh42bZVpPKujq2Tofd14paMnmpNpngz	14183	19980	19980	1619535600000
28759	3NKr2Dt6ieoim6iwByCz4gcxGK1jyiVq3rgS2NBNQwB8xoGuTRAE	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1422	1337	562	12463	18974	jw7znbbodFwbzxZ27WZ1RdGdmbU9URuWyzSb5jfXh75KVTXKtpi	14187	19984	19984	1619536320000
28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	448	1059	561	12463	18974	jwsDfNzhDcTc9eV43g8WiYx7hzoHoqQ7uJ8FUtN7KL44iJjquu2	14143	19929	19929	1619526420000
28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	28652	3NLVmWYQYXXvUqF1okqLsE6ofSWrTNVh9xvFG4kGn3ES84rvPV89	149	1037	561	12463	18974	jwedTkQtsXGRet8mj8uWJJ11C9S88RzNF6NPG9GSaHBi7DiViuQ	14147	19937	19937	1619527860000
28654	3NKnXwKa5B1vchgKfi3ycicrFPX9eXLdDZPMK7YHaoSxFePfEwmj	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1407	1395	561	12463	18974	jwWy9FCUKBZNBrWtiE5nybGgsbXUdKx5THxqbYi6wvSDvVYFn6s	14148	19940	19940	1619528400000
28658	3NKaNEQN6ZeghcgTAnz2PRuF5pYaV8g8ETLnN4CtteFFVzgXoebb	28643	3NKUEZpXi5su5BywzXqARqLDjTLY7moZ1bdVYjHTJjueQfC7L2NJ	563	1233	558	12463	18974	jwyDrbkW3AxCY6nhqXU8dm4Br53vu9NA8HP7DZ69U4AhXM41mBT	14091	19941	19941	1619528580000
28666	3NLcNSbRwSua69xhnqJUJYqGenqp33VuPhAAtXxZz1DK9rrkA9A5	28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	311	1307	561	12463	18974	jwPwRZUgk1cJ71DPfQbC7hZd9Ct3MPwTkmMwggWMS6vnkRvCCGg	14153	19945	19945	1619529300000
28669	3NKGDBkq9USykPU8Euw1LhrkesDfUuPEDdRKgZETZfPVZF51Aice	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1457	1391	561	12463	18974	jwX8E54kMRTPEy2CbfMYtoPDSFJjvGbe1ev4aa2AePAMwei6gN4	14155	19948	19948	1619529840000
28674	3NLbSMCeUSHSa4u1YKAoWNmUSDU5ZUE5KyX4eDSr3MYzt4zmCo6J	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1672	1285	561	12463	18974	jxD4S9hfF3bfMy2EctaLScKGuDTJhooUeeJiNvRvkALmLadpFYH	14156	19950	19950	1619530200000
28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	484	1073	561	12463	18974	jwn6wmv49JLzxv2mRYwkNSuGsEWdEyE7nqqBqqNSViz66HEH8fZ	14161	19956	19956	1619531280000
28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	1602	1369	561	12463	18974	jwPbtcUkygQ59uQ9jiGUqUVzuuX2PHh2o3SAk1SMtMQU8RoCrMs	14166	19961	19961	1619532180000
28701	3NKmcvDDUy4dhMbpRUJnY5MLKLrbafMKc9R85W8k3mLCpT7ftNLR	28692	3NKgwGcRMQASnPVbQUFNB3JurHCZAunCR51Psjf18ic47nKy36Zi	1649	1649	562	12463	18974	jxp97WcZbUDjNzCtv6eNXUZ8LGUbJousWHV6Wq6vQ92zQRLNwhK	14166	19965	19965	1619532900000
28706	3NLjfWjgdSCvudGpmTPsoxmH3rymDMYCDuavmZgGNeViAmSuMg8Q	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jxgVUHwCLra622XyPWsUr3XVKTHwWG8sTaY2wAoEZnZhcnzSWcc	14172	19967	19967	1619533260000
28708	3NKbL9YhDv9d5G6r7TkhiC73svMx1KD1RfG7616ziprQBaJqsUAR	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	298	1308	562	12463	18974	jxpwuzxQCKiPVQWoxud95fmktRF7eDT1r5NkVGQabe2Xp5YDhQG	14173	19968	19968	1619533440000
28712	3NLRiaDrmjKw4tkeR3m5wbx4ztcuDBhopNWTTW6PyRRfrteKPCeY	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jx7MHQc8Mv91doZxx93XmEB7nVCWKKQ87zcDvQW1QLQbtNmAtDk	14173	19968	19968	1619533440000
28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	152	1330	562	12463	18974	jx5YrakEUHhskyiZu2thMKBDGgEwJM5zLV6tzLbXJY7tTZPwvDd	14173	19968	19968	1619533440000
28718	3NLx6mBTVPcQAEQLac9cSHy7jvHE4GG89yMusenWY9gtmFQjmdBW	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	152	1330	560	12463	18974	jx8agZkYFc9m7yK2puVtn3WM31G4va4fWeiwB8SK75CFhBaFLh1	14121	19968	19968	1619533564243
28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	1675	1216	562	12463	18974	jxRdTqxMfz7DbYi4bVEKAY6mo2YTXi9g9onsx1QPWf7ht991cED	14176	19972	19972	1619534160000
28728	3NKNg7bgCjjjeC5UBC1UChcCkZqQ83CYivHTVvTZk1gaUGsMVDwT	28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	1403	824	561	12463	18974	jwrBwcTTqgDSM9uLaNN7Qkz5Po7VhRmdDjWmmBeddKQg9i5S4A1	14149	19972	19972	1619534160000
28729	3NK4kXGYbHcYaLgCeK3eYUKMiPHgdz9FG97year9qCe45DHGVACC	28711	3NLibEJPpK8pQTPaeajSM2T943kGQ3z3N3T4hHnPffJ4wuGEWJGG	1403	824	562	12463	18974	jwGQ3fkgkdL843qhGhig5iLrzGSbPs1NDpVjdYyHsL8K9BrQE1u	14174	19972	19972	1619534232627
28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	1407	1395	562	12463	18974	jxqQQX14ipZZqmN5Kx3eKLHwUEqHEi7Z2iUj2je79XvAZLS5T13	14177	19973	19973	1619534340000
28736	3NLLacAXYUwoqPMbwzvNBtLomZ3Gc2tXLn814tLXSbZ73EGxYFh8	28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	1483	893	562	12463	18974	jwvEfxoQ3fWCP5JybpEjQNiHv1jNRydWgafBpTUxF2gNQ89BhAg	14180	19976	19976	1619534880000
28738	3NLCSwfJ6QkMnqizq9PqtJQ78sHJPEDhQrdjTMwyNtUyibveSEHV	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	532	1303	562	12463	18974	jxtNgTWHtneM1UnbzsiZcsMsGgSULaoW63DCFBwAt7brXAsCzSk	14181	19977	19977	1619535060000
28747	3NKmtdUTyoZv3FkQuRG6E5tAq1KhrzMW2cAZptsQJTPSVrctxyv4	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1553	775	551	12463	18974	jx4RUwNpzMMZpdVGpqSyRemu9ykk71J9LB5aHr2iaZH5Z6bvoNx	13906	19979	19979	1619535522330
28749	3NKBsPdshoKdAvDu8kdGvsNnnFXSw39wDwvzksz2HfMTNaW8yuLP	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1406	1393	562	12463	18974	jwEAow8cnAyKTH1pzXHhNYKxsey6DZecvXPevcL2tdxsdzteb9p	14183	19980	19980	1619535600000
28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	28748	3NKyjkbZWN98ae3iEmJnwAzRwb6BCQq8FcWGdEQ4gieyqW9co3Nj	1509	1194	562	12463	18974	jwqkDy9AY13fwqWmFJZV8nSKAcTk8aoHmttcM6mwCprVeJYpRMm	14184	19981	19981	1619535780000
28761	3NLYJLR8RQjgg2bA1QLLUQ3kxALhdPWVd2z5dAMSUSKFFYu5oTJx	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1440	1251	562	12463	18974	jwD2wahyzgvxeAkcT2c45A5qc25xWGkNosrroPhrsCJbk6gkLFw	14187	19984	19984	1619536320000
28765	3NLiLkPxH48tLCmdGMr4sFFspMW6G8tBKMf5fqht6YMohxXDMsE2	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1403	824	562	12463	18974	jwrsZjTzQ9nSaZGVXPsT2Avvn9bk9ST5PmsDv999WiAdywxRTGt	14186	19987	19987	1619536995832
28768	3NKiGSj5CnrDfprVJDqWqW1eLsibQXfC1jAFdC6acR5iKUSiHDqe	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxTYUTC1hYmXCrhMvDQsHHs6jdpSMyYNwLp5kiiZW5iKwgqrtzv	14190	19989	19989	1619537220000
28770	3NKLqxVSLHCFG9vUY7TFc9ZbwjtaLAdLBv3BHcyf44fhQtFYckR8	28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	1647	1056	563	12463	18974	jxT191yrfsrG9dXWkhNn6RYoR5iwqeBFXw1QHCQ52XVcPVKjBF1	14192	19992	19992	1619537760000
28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	28770	3NKLqxVSLHCFG9vUY7TFc9ZbwjtaLAdLBv3BHcyf44fhQtFYckR8	1422	1337	563	12463	18974	jxsVCvmLZBGt7cFeKpAV1xpSLa3eqXux5JmemTYNaynjV7Ztyi4	14193	19993	19993	1619537940000
28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	1474	1083	563	12463	18974	jxFm27PwG2qGt6N2jxLeUqJBLCzoc7TpGJQC7MsWEsFdNyY8Jcs	14195	19996	19996	1619538480000
28780	3NLT9K3dprzxz1QzVT2NruUCAP9bPcK7LzjhYRRS8MtuCJF3RmjT	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	448	1305	563	12463	18974	jwALfAb4ei5Y6K98j3iVWEE8szNpdzY5Tv4WTRJxq95ADmaXRNb	14196	19998	19998	1619538840000
28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	28783	3NLsThMMyRquo6WMo1rSrXFnAAd1hsPzJVhfPzMT1EkYwdkN6EY1	1671	1365	563	12463	18974	jxqNYDtjaq5WY3GYoiDCEQpuupPz75EZ9fdo1r9o5wCQ3ysfwGn	14198	20001	20001	1619539380000
28704	3NKCpP5KevpAUdEUb6aN2SGBh76oz777QQVuv4KR8Y7S5NNHdRte	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jxnpB4jsJpTSAnpRRXEskaGKZwLdieLm1hsFmvDoEkLeDpbDFyM	14172	19967	19967	1619533260000
28709	3NLEWs6JHFfSPriwSneRj2JsMWxpFUsiZ7HfgGxkEUh2PCoXE2Tg	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	298	1308	562	12463	18974	jxFht3nTv5xCwAsNrmobrfjWGmLDRuScr4nAqAvP1fJw1FYjxrq	14173	19968	19968	1619533440000
28713	3NLfcPmhNUUMUBh3654PM86ppqtmajTEUi4VikFQuJj3Zx68Ay7n	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1407	1395	562	12463	18974	jxehXgNHSDY4eeANVMUtjRACAFqpCde2pog9cU5p2GbeqtZFXQz	14173	19968	19968	1619533440000
28715	3NKkYKUJko5gqaBM29AbPkVdN7rVfkVrNBtZjtvRAhEUAmXSVLuH	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	152	1330	558	12463	18974	jwPu33DgmkCYYkuruJrVGnqbPMYQ8PMjKkFoxb8kKwxQ7xeVJ8Q	14092	19968	19968	1619533482257
28717	3NLJ8GeJBBVjBWzq2sKbtD75BEcx3B76wtc768ozFt4scccycFsi	28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	152	1330	559	12463	18974	jwUoZVg42wrBodWqGu4uo7CYbxec6SD3VtpaUyNm9kDKZyvRBKw	14107	19968	19968	1619533523114
28721	3NLJKwBTo15Q1VzZSQMLw7fUhJLsULvunWTXLRstoHcqPZ2S7xrH	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1631	793	562	12463	18974	jxRwNPHy1UK8xtJqoQDAmDv6TRQmkcJd4HYsVR5moS3AHPkoAEK	14174	19969	19969	1619533620000
28723	3NKhpqNb1NFzk1LuZkQjvyLYB7W18VZRZaEbhxQWzVhG8Cyaz8bt	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	1577	1327	562	12463	18974	jxFgpHPQwrs2hdKmUdfBCxFB6csMXgKbsVZjvpwdGymfcaoah6F	14175	19971	19971	1619533980000
28726	3NLZ7Lg98XMWBPfNFGjggBu877wiJ8A5BJThbmzMuuLqHtZYhb6f	28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	1637	815	562	12463	18974	jwcDdyGxZvR85UTTqBALcV7rRTatVzRkuSxZ2rk1rNpCnpihXmH	14176	19972	19972	1619534160000
28732	3NLjFXFy3BnhB7d62jXJ2UbCL2xs4BXmEYpMq4sYhUePeh4Doovs	28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	1549	1236	562	12463	18974	jxD2dHdk2KxXpgqXppRA8WrqQDzr4qCNDfcMA9tYXKWZAEo9bvz	14178	19974	19974	1619534520000
28734	3NLBJtonqEbNNkJ15Mzuzt2v6oMqBmppWNSmoKP6EuxeQwnRmNyz	28726	3NLZ7Lg98XMWBPfNFGjggBu877wiJ8A5BJThbmzMuuLqHtZYhb6f	1403	782	562	12463	18974	jwEKh9YoorGR8HeTmZJAJasUVwT7LiyfFKdGWNeFi3e7kGVuDVw	14177	19975	19975	1619534700000
28741	3NLbkWwcTaaktE33vaa2Hdjf5FsB7bz6q7qyE5HKr4dWSeZkUXHd	28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	532	1303	556	12463	18974	jwLpL5xnrdSUhuppHVmoACbbDszWPPuR8SP2GqJaPx11Znhf3aX	14044	19977	19977	1619535060000
28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	448	1305	562	12463	18974	jweAg8pMSckF6GpRQaKqTncYi2AVtyVd2RdvQP9Ha2nv6ZgbVVn	14182	19978	19978	1619535240000
28752	3NKaVitQkwkiyjo8z2Fsfiafy6ERrWKcoYVv3LhfAug4eNi6jUvY	28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	1553	776	553	12463	18974	jwoFKFYNYLc6TmvJFyLUN6FQLVjUYWqnkWNAro34EyEpCxTAjoS	13973	19981	19981	1619535780000
28754	3NKSC9SM5dZ6XbpzV5rvQbR5x1EzuyxN2NEKBUiHWWKEiYDaKFGS	28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	1553	776	554	12463	18974	jwnCLGENyp1BLZkmxKTBvRJFKg3MyVK4QQDmvRwkt7RLT9BCMVh	13995	19981	19981	1619535890792
28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	1577	1327	562	12463	18974	jwAndVkS1qM3BN6Uuz37MzDQM5HTEvGGYPVXWfr6m3jRUQrTLmG	14185	19982	19982	1619535960000
28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1467	1376	562	12463	18974	jxNmRKUY6nMg4ZBvLLs4B6mYJ5DKuMqYakL8YU9q4TEoc6ShuKM	14186	19983	19983	1619536140000
28763	3NKc7iUGEdRTDSKknK8HYkzBzg9hvKjrGdUCsPGkQriCQx8637L2	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1553	776	562	12463	18974	jwUiH1B1yu24jBBhpjz3gV4NNhb6QUHAEY726STzzodwRPR2S35	14189	19986	19986	1619536680000
28773	3NLeHpifJVMxurSZUeqbtHr8wX8cjzpdFoZyFp2wf5at36QyPcQm	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1403	824	563	12463	18974	jxce3f5ReLfW4eL4JrsdogNtiG35YJqPhHGtN7DgajikFwvLy6n	14194	19994	19994	1619538120000
28775	3NKuWWvJyjUBTddbx9G6eTjfcsuvYCW3HPUQAHjnYfGD7i2mFRcx	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1522	956	563	12463	18974	jwKkvsAmoGDfZiVvUHXMgNBzBxtBfoNzEBWgtxr1YgoHQKkgscF	14194	19994	19994	1619538120000
28781	3NLF3LXhMej8GSu9zR5h2CSYQP9wrKimuUouwFsuHq1XbafBZwRf	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1439	1033	563	12463	18974	jxKd3rkS6SJeUB9wZPoJBjtWEuKzoAfa5671QmgJHwyRUKqxpVk	14196	19998	19998	1619538840000
28785	3NLuKt13F7WwQVtvgVU4gTJKoxVU4YGomdu9p3RmRpXBXk9a9XQf	28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	1506	1127	563	12463	18974	jwTSUf2Zbcn8fwfvKY16tXG6ozfC3qgdUdP7HGozRwDq88SAT3F	14199	20002	20002	1619539560000
28796	3NLxYZvRJPZSmfP2nwK8o9hXyJ12yFb2xwP9sKumJ8yHfNpJfYUf	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1607	372	563	12463	18974	jwASmQcWcMEu8YvuZGjbq97oDqdJhgy14ds7M9Jp29jn59Pp6w3	14206	20012	20012	1619541360000
28800	3NLwvJqFUL37khtg9uTyV5feBxKRrZLR9tVbs8WEGSYhqFjgBmWo	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	1406	1393	554	12463	18974	jxzCxXZN7EiBStQnrEEra3PFVWBDMDLoF4uYzhuukMjWbmAScCW	13999	20014	20014	1619541720000
28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	28799	3NLmzRTgvxB3ah25t9k49hXseZSA6nPe2LxnjxrnLzNwyKEemfMF	1573	1318	563	12463	18974	jx2NAdZHn1uaPQ1YS13R6sFRBzSSqCa1NxZ4xbhGYqe93pPiC1i	14208	20014	20014	1619541720000
28804	3NLduaAY5FiAMSKhBsSz9KCqZVVSSUWxZojZNGJjxjyhJDwNN52Y	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1406	1393	556	12463	18974	jxdgw5ixV4T8uCUxsSKn8fPnHS2xismnoh8nWnw869fv6G4MQr8	14037	20014	20014	1619541829297
28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	28806	3NLM6Lq13SxSutTsTpJsYXauyeo4Jd3hxp2VPTW8ZEPoQFUevWSb	1434	642	564	12463	18974	jxUK5twUS6mFZqhiLMSa2EpJYopeo3h8dnxRzQAPrHkL4tEy8Eg	14210	20017	20017	1619542260000
28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	1571	1335	564	12463	18974	jwPGkrNBESgcd3THghh6Xtnvy4pPgm8JYT7CFZ6g4TJREPV2MT2	14211	20018	20018	1619542440000
28813	3NLLbzQdp45QGaejpNHD2NkKuLNtEHGwkDsp1DrQun3H2p1xooTd	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1672	1285	564	12463	18974	jxZJhLLCS4ALJ4DousqSzqUMZLF98eDrURRmxtUWkMRyea3TbfS	14212	20019	20019	1619542620000
28820	3NLkEatKd1m1Sy5iMHN8fMNwBXf1nWN5gymniYpTPeKrTXPA3EpX	28819	3NLtdoKJwTgrCmLtofVQaX9HpXJ28A1EoNNQ4cgQp5SLAFmtMxD5	1407	1395	564	12463	18974	jwVjope9K5wMpKb8s9inUJuUMafEiwAhyxbC91yDusmt4nQrDQB	14215	20022	20022	1619543160000
28823	3NLGNa3y2QHBrGAh1Bo2zhRAMtWimrbjca1jiYdKZsEkqoMGTe7m	28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	1500	1051	561	12463	18974	jxmcLuTt2NHtfskTzDEakVeVQD4YmR1BRf1tSgcQocumVhkVAe3	14162	20026	20026	1619543880000
28825	3NLacbvUuku7AnJeJ53WicpB3WnerskNDHxgt6v3TPpsZP1xSN2i	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	171	1128	564	12463	18974	jx1YLwB6pF7ZoJSLoZMoGcyxJaAEevY2wTuuDTzav6zHMybW8yP	14218	20026	20026	1619543880000
28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	28834	3NL83ambGEVK7cVb2ABHprNtV347zkPvD6nmoZimbrodZ4niFGKA	1402	874	564	12463	18974	jxfoUvyGFF249roJ8RTtR62RPJGYpUcbLqHkw4nyL26apr2wDbg	14223	20034	20034	1619545320000
28742	3NK3MAU6cNcED91wknDugNA1AzDSpiDuNsBnYYaSH9UvhVR6oFWj	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1506	1247	562	12463	18974	jwM5nJY1iimWuTbNdfhcY2UHzXWuyhtiA3Wkps5AQdpi6tHZPCU	14182	19978	19978	1619535240000
28745	3NL8PmZTXxL8UBnhRGQJYNC5Xg8UyQWhxX5m6SF6x9hyXm2R6q49	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1506	1247	562	12463	18974	jy1eqb4KJV6mtatTmia4imtFFnZpMbZJKiZ1afZ8huFm3FUDLFg	14182	19978	19978	1619535240000
28753	3NKCq2xLUvd1k7xWojTX9dBxZ6irQHnfSz56qVbyLCAW8j1NVxgG	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1553	776	553	12463	18974	jxq1d4PuMgvFav1rBizpQTjTb9JYEZ2EjHjifzdoWMb8ifB5XSi	13979	19981	19981	1619535834719
28755	3NKULnb6jb5aCCBd3iQG5fys622ZnJx1NtRNW2KSum2cGHrwXnSQ	28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	1406	1393	562	12463	18974	jwPUYgdFaN5565F6go69vwQJQnLfHbtthTNDJt9vbD6DkDxJEbF	14185	19982	19982	1619535960000
28757	3NLCcmGfrt4jAtBVudJvhd1PzfqbGrKUoHKaL7fztcpL1GUXgRBY	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1403	824	562	12463	18974	jw9KBUMJjZQ9gZp5xg5GZeqeQhfSYnihqSryMnwPhC4VUA3kAT2	14186	19983	19983	1619536140000
28760	3NLRkGqRJyJwychZ9gahaHzrmuQSjE2jtT2UdU2mzYrLRMR9R9zK	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1440	1251	562	12463	18974	jy1boPSCjvmSvVaJCrnhMMicRUtTQ3EbST44BVXwGb5TSy1DVS4	14187	19984	19984	1619536320000
28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	28759	3NKr2Dt6ieoim6iwByCz4gcxGK1jyiVq3rgS2NBNQwB8xoGuTRAE	1631	794	562	12463	18974	jxnQuGtAYfVkaxUmNeQ3B1xnQ9TqkRiVKxtrvwFwnA6uvJgBG5f	14188	19985	19985	1619536500000
28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1599	1287	562	12463	18974	jxiKrujqR9CyTja44cBCeejqBbsgfpfmMif2i5Sdf1MMCraaSSm	14189	19986	19986	1619536680000
28767	3NL3cdWNCwK3t8aRQqyL9WCgmvt3SCRvwsUW1nwfhdVqG9gQqYhA	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxn9Q9Sv9r7PcsRHwbpUDX868tMpp2NcD8dahAazMvkzLhJrtnu	14190	19989	19989	1619537220000
28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	28766	3NKe4Gap1qJae5B4x16cgHJbBVS7x7nvZVNwbpfcRiS7dY2ytXGH	1407	1395	563	12463	18974	jxRUxkSinM2GMSxgavNFP6xcNfmkSZMqGtsGwU9mhgZJTP8ozzN	14191	19991	19991	1619537580000
28774	3NLK2rD58mgsgadqTT5tFynAmrJr1nX8i6suckdiavZYvBJ1tieV	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1579	1389	563	12463	18974	jxz69geY5Jp5yVkr336Wr2xo1SBBnTze1W1BegEgFgSQz5GWvzE	14194	19994	19994	1619538120000
28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1579	1389	563	12463	18974	jwr5YwTet7Kh9DfjnCQZiDprrwCZgzfCHqrXm9fnmSKdNWM1q8g	14194	19994	19994	1619538120000
28779	3NLby4FWGjLzUu1FmCMn5DYXmd4AGMZ9LU4FL6ZRcagfCTFxwrhA	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1406	1393	563	12463	18974	jwmwhxKhDKP6BAWu1bq6FfPf549YZ1pCYHyFGKxZ2fcgafaRpJ7	14196	19998	19998	1619538840000
28782	3NK3DLGrx1Zyhh93gPtdcgTWU5bTw3JHFjdtfP4kAc1tVyiyvEpi	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1627	1139	563	12463	18974	jwo1Pkm9rURMVH4ZYzUYRUv9YrmrCmQozaskioMKLD18ca9ha82	14196	19998	19998	1619538840000
28783	3NLsThMMyRquo6WMo1rSrXFnAAd1hsPzJVhfPzMT1EkYwdkN6EY1	28779	3NLby4FWGjLzUu1FmCMn5DYXmd4AGMZ9LU4FL6ZRcagfCTFxwrhA	1405	873	563	12463	18974	jxU94HYPgfiaxiCXJgkSAZNGymW2uqkDvYk8MdJ8nRSLL9YbztL	14197	19999	19999	1619539020000
28786	3NKxgpUieX33zQhM8UV7MVcoPwAKRC7o6CeG8it7SzRGgUrTCnnv	28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	1506	1127	563	12463	18974	jwoKm8ehgbGx9d3wvPzxLohR3eN1aoux9PJiG1VrCkt8xns3MSZ	14199	20002	20002	1619539560000
28789	3NLVDtEsXSfNx8kcx2G9H2WXWRG8n5TuVm2fKfaCzXz8ZwwPvPJn	28788	3NLjmZmoUNT6tySjuUhmCsC1ZdGGbEZSxBw19VhqY1o4ciKRMqCE	298	1062	563	12463	18974	jxHrAhxJF8o4Xf7y6Z9spyT1bUPGE16ih6zKVPDh7QJmFeFffm2	14202	20007	20007	1619540460000
28792	3NKTihdGhv2DLuRTm7yWgNb6sWtHQoEqHYCG5P6j3F6jDmQ9jAyW	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	1654	1340	563	12463	18974	jwy12qgHvtAgzNgJeSaMQqtTpr9dpoaEiCE4BowJeuMTLWDVXBa	14205	20011	20011	1619541180000
28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	1559	1227	563	12463	18974	jwPmpyF8rnRJXWFBaYN9w4rf7MXwRozRZfLCB3JNBoKHWRhLM5R	14205	20011	20011	1619541180000
28799	3NLmzRTgvxB3ah25t9k49hXseZSA6nPe2LxnjxrnLzNwyKEemfMF	28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	1553	776	563	12463	18974	jwTx5XSGnqyA1KFQbHDmJbLwPYE8FyLytzPRL3BcgMPiWNxPTpo	14207	20013	20013	1619541540000
28801	3NL8U67cJeYdszYRpRRwPE6trjGjgJLjLFYU4Dy8AQVAgjBfn9pt	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1406	1393	555	12463	18974	jxZfstks5q7fwJzQ9KPZ9wGRFKUjVWi5aWeGnW6XFrvuHCDLVCN	14012	20014	20014	1619541755872
28803	3NLGzsa9mG3kN3RT2oVBMd42ZsnyY6FB2Sv1SxnurJrAGsbM7gRb	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1406	1393	555	12463	18974	jwm4r2jpYNk2mD4th9nj3gnyNT2dxZGJjMCRwaND59Hce4ip23a	14024	20014	20014	1619541792267
28806	3NLM6Lq13SxSutTsTpJsYXauyeo4Jd3hxp2VPTW8ZEPoQFUevWSb	28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	1631	794	563	12463	18974	jxo7QWNnJ7Ux2mJrRxYKrjioFGHm4g58nXoM9L4greujwhh5EFw	14209	20016	20016	1619542080000
28810	3NKSnFhhcT31Az8Nt94f1AKeHX1feKMJAsNy7T7F8cgeb1QUhpBL	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1434	642	564	12463	18974	jxvKrncPaUSerJ8EDE85PkpdoH22HRxzJ99mf3ehrfnti8WFWtq	14210	20017	20017	1619542260000
28812	3NLeWc2SpV1dzBb6QPTzP7n4u8w83e9ZXnsiABd4dyHNv31rmXSn	28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	1553	776	564	12463	18974	jxtb41ntjhcGdd5ZEMpLjax7GtLCH6LSNKJWsYWnW4hnDnj1UkP	14211	20018	20018	1619542440000
28814	3NLDC4yZp4W8r22puP6GVBKdQgEpahhbDnMMiDruiFBDjjcDbUji	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1671	1365	564	12463	18974	jwcwP9PhEduGYHx1opxQRVebeVHzWkpam1Wu4k1xeHKWVZ1XmuD	14212	20019	20019	1619542620000
28816	3NLqsm98bWQ5uxjZ9KBzFdsLMfUhisD75vp7GLVx6rMEkWQh8wGH	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1402	852	564	12463	18974	jxG8cJ8BYBgrNax1HvM72btTHNFpftxgzN52uXbzAKMNbPWLypp	14212	20019	20019	1619542620000
28821	3NL9E4kV4pHpxuh6LMiFgrckmdHLxyzcKj9XCAz8o9RR7TkKX4rX	28820	3NLkEatKd1m1Sy5iMHN8fMNwBXf1nWN5gymniYpTPeKrTXPA3EpX	1406	1393	564	12463	18974	jxZLxPMjJVJzwov7iXeVF54fb5DHbAW6PPy3VfsGhGMDSUkz4Jd	14216	20023	20023	1619543340000
28824	3NLNptJsE42UbNcp4ZG7CpVYxfGpZmEjcLYecbHyZZCug2ELigeK	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	632	1016	564	12463	18974	jwdXr7bv2DZjhfqrnMRn5dqTqz8D39nwbM5ZShFEX1ka53ufjXT	14218	20026	20026	1619543880000
28826	3NL3PvVDdUeXEz4NWwWjYVBz6t1oZLHyMTdeEZqXgSqzu52Vubho	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	1500	1051	564	12463	18974	jxHc7EvGpVbSFJZJzs7U7JutY6RHw9Ls1pKjJyBn5N9Y5u1nUyw	14218	20026	20026	1619543880000
28831	3NLPGyqjPVr1drJkYYJYmZ8kbAnb2NUNE7DdMNAvjbbfYtBVGpSx	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1613	983	564	12463	18974	jwnsfSMJkrXKaST4PGWfgRkND543LHpGqDeKML9AH8jJf6b6Vm3	14220	20029	20029	1619544420000
28833	3NL2XM3vzxZ4ThMhYMsLexP2QVrEMAiZJkfPACTimSiHVbJRvfpN	28831	3NLPGyqjPVr1drJkYYJYmZ8kbAnb2NUNE7DdMNAvjbbfYtBVGpSx	1627	1385	564	12463	18974	jxiWQz1tR3FrSHotoZPD2CWmQgmdp1SHWk7Rd4adVSPquadqvH3	14221	20030	20030	1619544600000
28766	3NKe4Gap1qJae5B4x16cgHJbBVS7x7nvZVNwbpfcRiS7dY2ytXGH	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxkukSAN6AtY2nzgAwuijHDgAxyEEQqVL84fBdyy6vPBUdiLbf9	14190	19989	19989	1619537220000
28771	3NLChNwQ7AbC6x2RUG1z9EZ94qyMJ7kYXp6CWv1z6PZ3HvBgdmRM	28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	1596	1363	563	12463	18974	jx8i3LEhZUBgQZ5tjncofLkueoeivwVPtyAMd4w981FQGxNRKGb	14192	19992	19992	1619537760000
28778	3NLDTZXNgmRq9oJa2SmDfmmxubChov9fERZ1w6VhnPyi441VYBbk	28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	1650	1129	563	12463	18974	jw7S7z2Em51YCL45v4yXYmfoC3JQ8GZqmmo2kRi393Q3CuVZNqi	14195	19996	19996	1619538480000
28788	3NLjmZmoUNT6tySjuUhmCsC1ZdGGbEZSxBw19VhqY1o4ciKRMqCE	28787	3NKopbFdC9Q7ZZD1beWGrXeRnboUdKMXCeKGbcfBTfb2WuUe3Aku	1581	777	563	12463	18974	jxC9fmYwPfRTSFsFPcW73vxA8j9oNhbogrYgJYWnoL9dYnzdTk4	14201	20004	20004	1619539920000
28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	28790	3NLC4EDPL3QUGtNvsiTMPsjuKV6D94iYfxDiHc935FMYESpsSKXA	1407	1395	563	12463	18974	jwZqZCa8yn2Ct1Q5tHqELecHXdKyyDU13U6BzhJA9Sif58qxtsb	14204	20009	20009	1619540820000
28798	3NLX8eng3zSPmqWTn1hCS6HdjB3vSNZmGg2oKj7M86uMFbqXiiab	28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	1489	1254	563	12463	18974	jxJA8Yin1yzgfXrpVY2BUCYbzC9mwfFwZeiTwLrTqUGmsm24GjV	14207	20013	20013	1619541540000
28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	1474	1329	563	12463	18974	jxszYyDfcViwVdkAxt3VcdACfEABmQ5mXKy76WfpQKqmdyvBB2V	14209	20016	20016	1619542080000
28807	3NKcXYavR58TadWgYsRMQreqhXTcDfNVtTFk7HVYAwkvDyfoYevL	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1656	1097	564	12463	18974	jwsoHCUychrbJjJQBn12VFqS5TzE6uZwXdBvgGsJsN9TFbaf2UC	14210	20017	20017	1619542260000
28818	3NKYNby6QHHRwoir8RMUc8RbEHiYoS5FTUsWypqP9V6UizE7BBxS	28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	1546	1339	564	12463	18974	jy2gExpHCPXA4qFuBWw7YftMkdUKDeG7M1oCMGaKVEgTSihGQRc	14214	20021	20021	1619542980000
28828	3NKusgWL55Mw2VdZ7iWdEYHjWB87aK3hJ8jnozC4oKfbSidSFWya	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1403	782	564	12463	18974	jwRE6sF1FvZaw87iukaqNukJKQABgvoFmmcbmkSqzrHVWr2HV2h	14220	20029	20029	1619544420000
28830	3NKnaK9vtn1jh3cz7VfbGsp36tvUsyanWV8jXrgM5mntWGcNALYt	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	369	1186	564	12463	18974	jxNHRmRQEN1BDWFtzSB9fdKM1XNv3XYwHoa422eJa9NcXpnWAcK	14220	20029	20029	1619544420000
28840	3NKJo8AAWdR4xDmHYKtRQiTZeuoznqzrmXkRcUjUbCEScetgzznV	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1513	1379	564	12463	18974	jxVQdLShSLbAtodtLpuxQSpH2YWmuYCVN4XKWeg3KbVjRJThLmT	14225	20037	20037	1619545860000
28841	3NLAowm5n2rDy4LfFjALt6E1LKa8gwd3TS7CkXzbMs3gVUaTB6bi	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1651	1175	564	12463	18974	jx6XweNYf73QmsH729Up7HQHSwybPrAG3aoU2mUsPZJgyAC5keu	14225	20037	20037	1619545860000
28847	3NLgCL4oAqAVJr6g2HazqyVkZzeZ5rgqPmifK3UM1dBGShMzdfaz	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1599	1287	564	12463	18974	jx17cGFgYoKdkSLgwwfktQYv1fYPiqL7RbZFgmVKE2h7QQ8rsXy	14227	20039	20039	1619546220000
28849	3NLh8YwYxtCkfZpE5RC8eSxyx9iGzsnBk7i1nXKj8Dk7no9eTyJJ	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1602	1123	562	12463	18974	jxkua65HPrMSrLrUbKStYwE7M399u8atxHQw7XRZ9JtWXHzSNNC	14189	20039	20039	1619546304099
28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	28851	3NKa7gis8MSDYYZewXPARPuAUSiwYdLLmZLHByx43iNJQMDQLQ7e	1406	1393	564	12463	18974	jxGctT2NCowrHqUdxcyitcZoYrqv9r1uwGYP6drr2TY42TA6LG3	14230	20044	20044	1619547120000
28854	3NKj3F8fpEvaJmrusjrJbRXYnshNgeayaLxzYWYKccB3PoyBcfWU	28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	1540	110	565	12463	18974	jxcyWfzHnWqbNHRFi7d4GHeJsQsmddJL6qGfCcVRJvmNZMBZFG1	14231	20046	20046	1619547480000
28858	3NKsMrZxcjG8io3yYkps6nG224FPaLSxfnSzkVeHj1mddbQsSBW4	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1631	794	565	12463	18974	jxbbwfzW5y4frdJifaEB8nZZhxZP9Uecxz9G6mPcbCgtgtMwrkF	14233	20054	20054	1619548920000
28862	3NLZwk62rTskA1ZNonadvQNAHcgYXFshx6MZTKakkT1apTDCoELr	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1513	1379	565	12463	18974	jx9ygna3QvDsRiZKuymDdFuCZj6Fuaxxhw9snACkVkFPaGKddbf	14234	20055	20055	1619549100000
28864	3NKA8hc1oNriZW4FQVVno8iewi868yrSPq9e3XZEnhXQcZ7Mrd9Z	28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	1622	990	565	12463	18974	jxRbCAddz7pizAJvRtEoQPfhF7C986prABMqVxHbSnyvyc6XDvg	14236	20057	20057	1619549460000
28869	3NKwbTJA945KCZ6YZB9MdzsTTm2AUm7WxfhX2pHwPJmJRRjpxqN2	28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	1553	776	565	12463	18974	jwmNzAFDTAVGWKoUeoYDGxb7WQoPWDrCcKmVyHpYAkQsHpkuFNR	14240	20061	20061	1619550180000
28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1607	1348	565	12463	18974	jwYMjuEvEqM3DmwN6WavKNVVuj6cPxwgFeWLQQwcvDgBLp8JksK	14244	20065	20065	1619550900000
28882	3NK3QtF9T2qV3vHSreWMgnwdnBGdCRVw2kGcYg195xxSQ2SyTMH1	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1631	794	565	12463	18974	jx3EMxxuCZTW7gDwVbjev5tfiVWZjgbfk4Sb32D1McjFQg3tDUz	14246	20067	20067	1619551260000
28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	1406	1393	565	12463	18974	jxxdhkSo3LEo6RmhWqxMZ4FgngcnW57jmahRf6QrKk5t8jF3YaS	14248	20069	20069	1619551620000
28885	3NKnPmkQgTggfjVJmRdgPBXnfZVa8C8Dtc1keepeQJu4NfPNfnmR	28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	1651	1055	565	12463	18974	jxcETFbjR9V6U6TQEoMfHz2BqKA2rruBbKJxqxAGKoT7ERTj6wA	14249	20071	20071	1619551980000
28887	3NK32HC2BmFE2Zx3VfJjwjNraUFaCxD3JHsRxUnKCydvWeFKvhuu	28886	3NKYedTCKBvPepkzvkbYX98iGPaT98XN4fkoAQPiF1VUJPTHT4sc	1406	1393	565	12463	18974	jxJSeYMzkgxrzHzYB5sraMN9gza3ybnL2cQP74gmr9LKxT4CpkM	14250	20072	20072	1619552160000
28889	3NLJDGZiZ3Ejjsbg5pjBANGscXJrzaaj9AKxhvQhkjw2pMwZmV1T	28885	3NKnPmkQgTggfjVJmRdgPBXnfZVa8C8Dtc1keepeQJu4NfPNfnmR	576	1355	565	12463	18974	jx3uHewZftvdzZPw1uq25sLbDtKyv6dPXGBVvLANa2YDdpN7WDB	14250	20075	20075	1619552700000
28891	3NKMGkEqWY5e4G2kwYED12oEvtDe1hGgB6x2bppcHKCDqRpHNbCb	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	1654	1094	566	12463	18974	jxCeHbpt4jcvmYjecLokea9KTom2NPWavS5c3x15dwRrDG9dDcy	14252	20075	20075	1619552700000
28896	3NL2it4ssXACp3DNiZiAYTjWCUQgFDkcQ9B2oEHRTo3E6jFnJSJf	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	632	1136	566	12463	18974	jwQutvVgmuYEFVd4k9mnQBFQankM4KM895rokXEGv7eXviGSbWs	14253	20076	20076	1619552880000
28898	3NKLMdZRXe5coXtxxN8Ai5T5zk3X3zQs1Tf2RLWnnr7bRLJUV7MA	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	1483	301	566	12463	18974	jwinYCJBUTseHLBwLRugR4h8HPVJgz5DfCZ5UPjP7ztYyrADuuj	14254	20077	20077	1619553060000
28900	3NKy4AN8F4M6rfbHvSS1srVSN1rDRistpot2BWE64cXHQPy3hfL5	28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	1623	830	566	12463	18974	jxTdXxbZvpJEPoPpV49AEK6Yqwbr4FTYAAVjEA87d1Et2wKZmba	14255	20078	20078	1619553240000
28902	3NLuRqyw3Wi8yHtaD5ZwLWWKvE3N3wqewn2a357LQexpEDaUqjNo	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1403	824	566	12463	18974	jy3Fkr91CvXarY4Yvt2b1PzW4XJPQKoCvnx9s9bNoZiQbC8mqeA	14256	20081	20081	1619553780000
28787	3NKopbFdC9Q7ZZD1beWGrXeRnboUdKMXCeKGbcfBTfb2WuUe3Aku	28785	3NLuKt13F7WwQVtvgVU4gTJKoxVU4YGomdu9p3RmRpXBXk9a9XQf	1631	794	563	12463	18974	jxcaZcLobcEHLjjVp7Hyce8ZsMU7LBUZQ1UTqRro5qo89xYMWzb	14200	20003	20003	1619539740000
28790	3NLC4EDPL3QUGtNvsiTMPsjuKV6D94iYfxDiHc935FMYESpsSKXA	28789	3NLVDtEsXSfNx8kcx2G9H2WXWRG8n5TuVm2fKfaCzXz8ZwwPvPJn	1637	816	563	12463	18974	jwHee5o6N6KykCVqJbEe1SYsejsZ96JoYpFdC1CsHimd7eeskcU	14203	20008	20008	1619540640000
28793	3NKFMGQzypMkfpEYDcviN8UK2huaRhRrvf26zrXwRjQL6naN4NeW	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	149	1283	563	12463	18974	jxF2NXoiMGKeE3Ahx7PbzjdqbRe8VxCPZiC6js7zDvTBgRg5DtB	14205	20011	20011	1619541180000
28795	3NKtWTZzYT7kQY7SwZYMVW6jQsEeDLBZrkT95cpWtRf52DRQ3QbU	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1403	823	563	12463	18974	jwZpQ5rXPoPWjFMydhESZPzMmNttU1935ajGnnodikqThkgAQe5	14206	20012	20012	1619541360000
28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1483	1030	563	12463	18974	jxh5XzE4LDKA74G4F5CJ3hLkexbGZAfJnMCZ52fh33irNznF1ed	14206	20012	20012	1619541360000
28808	3NKs5EqAjkKC5dFJEit4ZFaMyJrAGpUmiT7vP5AiLhMDxF6Z8SZF	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1405	849	564	12463	18974	jxBQPouPWrCiqQaKZvFDsLQKLX774UfbGohf1b8ZK2y9AKUfdmf	14210	20017	20017	1619542260000
28815	3NKv6uLSmrK4va7oKv4FstRFs4mQq2dZsRscbYYSWNTbGZo5mkhW	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1671	1365	564	12463	18974	jwRcaU4bysLZzr5x5vLinF2VPYY9w8Fpx2k8t7vSKVGbekUudjy	14212	20019	20019	1619542620000
28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	28816	3NLqsm98bWQ5uxjZ9KBzFdsLMfUhisD75vp7GLVx6rMEkWQh8wGH	44	1325	564	12463	18974	jxYHUv1siLs9wbgwLnDVJphvFBmpEdJ1p72FHZrRkXCvWWjG4EN	14213	20020	20020	1619542800000
28819	3NLtdoKJwTgrCmLtofVQaX9HpXJ28A1EoNNQ4cgQp5SLAFmtMxD5	28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	1402	850	564	12463	18974	jxqfHwtCzscfx2PEABPDv6HdeKDA34msY7a8UC2ad2sjL9ENU6P	14214	20021	20021	1619542980000
28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	28821	3NL9E4kV4pHpxuh6LMiFgrckmdHLxyzcKj9XCAz8o9RR7TkKX4rX	1406	1393	564	12463	18974	jx7B7wP27qWpEeGqN56mJZvxqt3VsEjnVgzfTeR6F3GnpAaPyVR	14217	20024	20024	1619543520000
28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	28826	3NL3PvVDdUeXEz4NWwWjYVBz6t1oZLHyMTdeEZqXgSqzu52Vubho	1637	816	564	12463	18974	jxV4bYMQVmTgTWF1VrmtF8bDzSXHVYzTFHcXRwk8zYpQ5gBWHzP	14219	20027	20027	1619544060000
28829	3NLLEQRsfjW93siFWQCCqKC3N4AsZYYKQgQ32CKXc6rgjybXK6Gm	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1600	1372	564	12463	18974	jwNmHW2Ma7X6TCMvDYVqZKXQBGHirbEsDJF3ryNh8QaqvdoSURJ	14220	20029	20029	1619544420000
28832	3NLMmj5CcVrBK5oXxpSL2WkKmu5pMhKduir5Drei3DD7QtUKusQK	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1652	1315	564	12463	18974	jxi1V6t1pg9RaMSRzaGce1nWEM6mV6h4rMv5K8aeaFExRo3AEg7	14220	20029	20029	1619544420000
28834	3NL83ambGEVK7cVb2ABHprNtV347zkPvD6nmoZimbrodZ4niFGKA	28833	3NL2XM3vzxZ4ThMhYMsLexP2QVrEMAiZJkfPACTimSiHVbJRvfpN	1407	1395	564	12463	18974	jxkM1L1EX33SapDU3w88AL3hvYB9g2n5deay2qqfHzxmzeqaeTh	14222	20032	20032	1619544960000
28839	3NL2obcJB8k3iWLYKA3VbZBZwftGph4vAgGXypZ74SH7tvWWZdA5	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1637	815	564	12463	18974	jxrTd3bKg5FjF7ZacYWYFMbVHRRqwWDkDkrNbDErzmtXwAY9Y5k	14224	20035	20035	1619545500000
28842	3NL4wc5TqZGaeh3ASf6dDqYHWhdnrQrymfun8kD2SbZGZ2XCM8td	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1651	1175	564	12463	18974	jxrQoJvH8iG3JLAYZ3Mi6NSfiZN6BBBHeoXH5uyeYhCCRxVcHZG	14225	20037	20037	1619545860000
28848	3NKwgF9wHJUKupWZj7qdPJYnkoSFAd3hZaRNCzGQQAAKWtB1Ac69	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1602	1123	562	12463	18974	jxz3289vEWcmbLvpy1ooKKALAi1t3AX5oSq94xWBzMcLKfqRzFX	14173	20039	20039	1619546260852
28850	3NKbXyhyjCethzFvvfEAnpmdGXbEbg4D8BxFKaLKmiMg4dxDCrZD	28846	3NKdPgoHT3mwUDncz3n9kVUfupNNr9xEDtjgBJEhozC1yJMRje9h	1654	1340	564	12463	18974	jxYhCjbE3VpZ1p6xM9kVPL4Rr83XHipi8h6pc6m9c3bQSLQKrJY	14228	20041	20041	1619546580000
28853	3NKPwUvu1KeF6jbeHR8Tbx8WQ2Kj52K7rFREAiXtujD8WEf4YqcR	28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	1578	1050	565	12463	18974	jxbqLVJ1kYPXremMECYR8anJnCzGHaihvbJRaezCren1ERGfREu	14231	20046	20046	1619547480000
28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1532	253	565	12463	18974	jwpTSFPkftmHaGxY1JEM8CjkfoENfyEKheqWzx9iwur3JcDoSgq	14233	20054	20054	1619548920000
28860	3NLxwv945WugTioGWeqyeaTipe5NTmmuPKGEpmY4ZJAcQToF6xWp	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1457	1145	565	12463	18974	jxSsm4ZvZGMeYTNvtz5Hgf5CPZGoUGqC8a829oHA7iPFHt48m4P	14234	20055	20055	1619549100000
28865	3NKwidqQ8afktJmaXrFjivW7bxHTbXn18ch6CJffZBKjB6NLaSHK	28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	1406	1393	565	12463	18974	jxXuk6aG2NF1VrzKRQUBFAkJyysyQvMuiEsoMKmPPZKYEn9SLv6	14236	20057	20057	1619549460000
28867	3NKrMdTmzF12owHVF5jegjsKUCWJXk2RqvsM8Rikc9zyY83auME4	28866	3NKhuPDCPkB7qfq3yxHnC4WdD6prkaQXQAZLgW4PDGAmh7UQrH1y	152	1084	565	12463	18974	jxUFdFHahzgNuMq7yx9geZf4RgCF8XUrSm9u1xWW5M5HUbBEBdp	14238	20059	20059	1619549820000
28873	3NLKyJLjpjmwcsXPEDzzh9jSvw9kXUKyJGvDnUQRwuELiEQyhDAw	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1481	790	565	12463	18974	jxViZY7G7vzt5umt8os9xEfrm6iKNJuYeqbZyujtRiccnDg6VmV	14242	20063	20063	1619550540000
28875	3NKEXTp4c4P1o38fkNTK1ACKNM3v2M4vmC1ZSi56o7E1rht7Q9iA	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1406	1393	565	12463	18974	jxpej1wqYwjRgAgRAeV9gxznH98MafN7ZV8SP8QJ5y9Noy6f5hH	14244	20065	20065	1619550900000
28879	3NL49PwK75KkySwGALXTW6m3QFaGBn3Lg1dCbyQ7hSMmawk5STPg	28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	1624	1334	565	12463	18974	jwitxY3EH9xa9AvURZfKMyhYqcCFiqznk9E8SMWrLN1UdFE15im	14245	20066	20066	1619551080000
28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	28880	3NLBD9bHqAeV8LkMtNiCh8vPt6Z1KirtNDP6tmaUd9mRhSR3zKqc	1403	824	565	12463	18974	jwvSrC4N7ndFb5aENaChnvxHcjGAAyxi7Bd63T4t8YqNWbg1TT8	14247	20068	20068	1619551440000
28894	3NKjnsc79k8F452d5X8R7WC8NePKsHAsPNTzWHSRfxHLsyAyssHw	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1579	1143	566	12463	18974	jxrEfz2tvYGvroEUMjB1bLz5cWE5Db4qs523HQnJ6cntVDGMkXb	14253	20076	20076	1619552880000
28901	3NLcQic49yZuF3tEFqPrBvpQhprUvR8CSnYsLFZsLMdefuAo4pXR	28875	3NKEXTp4c4P1o38fkNTK1ACKNM3v2M4vmC1ZSi56o7E1rht7Q9iA	1455	966	565	12463	18974	jwzLH3omXohPq85hegAWgcidYyXnLz337tZX2NwbG6Spdb1jqWz	14245	20080	20080	1619553600000
28903	3NLQztquW7SEYhx4a82ugr2Tbb3sJe98hRbEgoTGYd9ySNXA8UPV	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1458	957	566	12463	18974	jwu3vKEgoUVGLD1yTHTmSG7vh9VBUW5kcBKqJhrgdd6K61jQ1HH	14256	20081	20081	1619553780000
28908	3NLUwCG7vesC6hbRV41cTRvQvJAH3fn12Hahi2FufFJaXz97VsYF	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1671	1365	566	12463	18974	jx4kqi49XJhuqLebv2moJVZmnAUVz7QNuovyd5RcRtNUaevr9sZ	14259	20084	20084	1619554320000
28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	28911	3NLwHwPt5eEBPAEfoyQqwJpGjXEeUiA52KTgxEEPQXbTfEo9rZ7A	1467	1250	566	12463	18974	jwwayAhp1LtFD7EjmbrGNjGotDmRvuy5xKJVgmviJxYcmMuKVgD	14261	20087	20087	1619554860000
28836	3NLWmMmfrMspR9fF8tzpHtVMt8FJLHrjUd8778BdtD2V7Z4hVkb5	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1656	977	564	12463	18974	jxQPeToqgeTdg42o6KdVkWxhecLbYC5XE5XjsPwypdR77e2rEmD	14224	20035	20035	1619545500000
28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1627	1385	564	12463	18974	jx917U1HAKYJTcLeUr78zWNeoXCjtDygrudAr6Adz9vTuSGPXzC	14224	20035	20035	1619545500000
28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	28840	3NKJo8AAWdR4xDmHYKtRQiTZeuoznqzrmXkRcUjUbCEScetgzznV	1637	816	564	12463	18974	jxrPKj2myv1QKmZ8JamRQxe5SDwSGrrt6mkYq2CHuhFfDX4Tbbj	14226	20038	20038	1619546040000
28845	3NKrULGHRE7s1Yga6qTdXjYD7Jt9e4MkaSi4fAf4wHJBZF3h6MWG	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1602	1123	564	12463	18974	jxVoMZDzXJMTuj44NhkoW4TxW31ofKifmsor9ciZeeMyJ9iKKUt	14227	20039	20039	1619546220000
28857	3NLbBrcN2U7sA5m1ekNwDNBSqQztzGGzcrydpWQfb75eXvAbARkv	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1407	1395	565	12463	18974	jwfjtJmhH1KRiqCJRzJRTTXmuzLkdSg2H8XyRTFySNRqJWLLECb	14233	20054	20054	1619548920000
28861	3NLy3BRndwNuqg6fAneJGfXpU7ZR1q2zyP28hxnMHBvtKusuX1RU	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1439	1153	565	12463	18974	jxtBXugLdBVKDPRFBTwbY9qyqZMJ7T9GSgNWpLu58GDiq6akCbh	14234	20055	20055	1619549100000
28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	28860	3NLxwv945WugTioGWeqyeaTipe5NTmmuPKGEpmY4ZJAcQToF6xWp	1607	1102	565	12463	18974	jx4gMh6LumFQnZcjZPTgZyDZ4BzrH8s61d2HoGmPiPky3EA6WhK	14235	20056	20056	1619549280000
28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	28867	3NKrMdTmzF12owHVF5jegjsKUCWJXk2RqvsM8Rikc9zyY83auME4	1407	1395	565	12463	18974	jxRydzrSQ8wBTJqfW89Cv3SJEVQJEq6NbDojZd6EUW89K6VqhPj	14239	20060	20060	1619550000000
28870	3NLmuYBUy4gRovkPsX5J5d8keSDm6JtCZ85JL2iDVMVJtYMDfRyc	28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	1508	1387	565	12463	18974	jxvoqMysXz8EPt3crULDoweZqQ7SNdhoi15BRMYk5E6dgk1MJHD	14240	20061	20061	1619550180000
28872	3NKZ6zdb2norYJuBtpj9grykcSQJ4vkMDY9mGkMq3Zn7s828s4kN	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1503	1277	565	12463	18974	jx2pkGK8CN9xSmB6BEy2uS9Gu75gdfYev191Ut4HuCotM1rNVcx	14242	20063	20063	1619550540000
28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	28873	3NLKyJLjpjmwcsXPEDzzh9jSvw9kXUKyJGvDnUQRwuELiEQyhDAw	1581	778	565	12463	18974	jxXTXTzAAT6o8DT2Gx9s9uD3AmN7c6Yk1tFMNz9aBjRp7jSzRPr	14243	20064	20064	1619550720000
28881	3NL7Trs1yqP22y2F21rZ1rdasYsA7R8863thST4zbpWbQAhyuC2i	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1403	824	565	12463	18974	jxdKYgCuK1Krx9YEoU7zPKnPtuTPC6yXTuuqgKrUttjLYynvZLJ	14246	20067	20067	1619551260000
28886	3NKYedTCKBvPepkzvkbYX98iGPaT98XN4fkoAQPiF1VUJPTHT4sc	28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	1651	1055	565	12463	18974	jxS1gNk8YLqkXnuecxg666NuT3oEGRwJay8nKGfzxWD8kq1GjNn	14249	20071	20071	1619551980000
28893	3NK6ieYePXqG7X4iLiW7TA1iocbccCV7KqBniYuQWigHWQEQ5A8S	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1536	1313	566	12463	18974	jwsb5zp4w348pCWgJnidaRFKCPxc3FeV2RGvFQQbyF2KDbxcfLe	14253	20076	20076	1619552880000
28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1579	1143	566	12463	18974	jw961Z9tujj2VnjYe69dssguUgSkFQeUcys7fsCz78u3ijEeP2J	14253	20076	20076	1619552880000
28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	1483	301	566	12463	18974	jxT7fna2PdfE97Cnsq23drPEPmrSruwAD4bAUWAgsA6QZfoCp5d	14254	20077	20077	1619553060000
28905	3NLcYQ6DccXAwrFjEmtv6k5qnGHW9KciJUFvVFvE5uGMdvXDEnsG	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1650	1249	565	12463	18974	jwuoiyhu5B5vNvmmG3XgzBhAS6jA4Q8FhpATXR168T9jCRHkGy5	14242	20081	20081	1619553780000
28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	28906	3NLJZ6MSC1PA2i9YY85QZ5DJccohZjVkmbzzB61ud3FcfziGQQra	1637	816	566	12463	18974	jy2R8GPrq1a2xKmNwamJhbV6TsoHTsv767VbXU1c8HEjxceonAS	14258	20083	20083	1619554140000
28910	3NKUwR2cMk2Ka8aFV56TatZ8SkWojCkHDUVS42kG5z51u59dzK7Y	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1654	1094	566	12463	18974	jxQfGkTYF174sh6529uK6FS9XRYfz99dqGFzWjChrWneubdk3Fx	14259	20084	20084	1619554320000
28922	3NLihHcw7ZyAiW2ZBHTdoVGtFmPr12aDSA3pMGNwc1fDzzoYpVFU	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1506	1127	566	12463	18974	jxqJ95NpVbB56K6scsUwu5kBhyFeSTq3Yz7q7HoCGDT71ARwD2L	14264	20091	20091	1619555580000
28924	3NKEnxNWxBZFuGT6LxXpWYpYyHuMjunrPznqWFZy456pcmSHTKkc	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	484	1319	566	12463	18974	jwVWJAsxEUMDhSab12TKXha3iJCwL2X1TuB6a6pkiRgQyNEgDRw	14265	20093	20093	1619555940000
28926	3NL6FCHBEaRRiqW34MwF2enrmuGtDR2YT2nUGEDVKqKtkfCkoJ6u	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1627	1385	566	12463	18974	jx85p6hMoXkLTuWoAWfLTv84UYC1p5W38jmHHW1Y2SEFnaPokZo	14265	20093	20093	1619555940000
28931	3NKn8NBdsTPhBosrGfBmbEKR7zNonhXYZt2KfpfPRbW3pH9xmRkF	28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	1646	988	566	12463	18974	jwCwroFh2CXhQhQwKehKQsjsfBMpeYLz5XY8EaNCkNqgUHbYANu	14268	20097	20097	1619556660000
28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	28935	3NLo6cVM7w9KzehLzTdArcPPsmYy3BrXp5eL4i5wfVNyPokhpNkK	1646	1354	567	12463	18974	jxBbmMcTd3e5MgSppYLzN1LKDUx4f2w4sfkybQEnuc8KffS8xXT	14271	20100	20100	1619557200000
28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1476	1371	567	12463	18974	jxHRXhWwMeG6vjMgXKv1GbDo8TqDBfqiPjRHMWqas2pLFUvTv89	14272	20101	20101	1619557380000
28945	3NL9RKH5xZw14CqfNit1MmZNEFXCmxcKRmyPr1PzqwUo12uxpJfm	28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	1607	1102	567	12463	18974	jwcbr8Jft3LXxeBsWXwqWM25V5T7kko5QRh7W4R5p2GXGwYwRWX	14274	20103	20103	1619557740000
28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1406	1393	567	12463	18974	jxanVZ3MVS7Co6gzMQdb9VTheWdZNtZ4xD9crfWvATa7JTTUib9	14275	20106	20106	1619558280000
28950	3NLE169YD7crqbE7TGRbgybuTY2pFdZbHuYtfHDNqAuenUG7xZuv	28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	1651	1175	567	12463	18974	jxXR3pf6gnesChP3Epo18sQSQvkxCm3oYPoVisu8xzrqaSkatHX	14276	20107	20107	1619558460000
28955	3NK3dozS6Xdy4o5XahL7HxUv6bs4ZyKf7mZzFa6MJwBVTKVhwNwz	28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	1403	824	567	12463	18974	jxeKh4wVYgsDF2zZBx4tMtQZdeJjqwH6eZUsJpe6iRhCjnz9KcV	14281	20112	20112	1619559360000
28958	3NKy7az3MjZjcUaupZeXFdwWWt5r5fXdYYkCDYwwaGrcb6M41zGR	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1609	1333	567	12463	18974	jx2PacHGj4C7r5aMSMgePKAaffAHU63GxSoF9ZT1vdm82UAJFHY	14282	20114	20114	1619559720000
28962	3NK47fbA1YwLAqU2tvb7ejhydZ7Yo2y6DUiaSfqaWDNtZvdSSknF	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1448	1065	567	12463	18974	jwaBHqAxsCiWL89TGfWfA7pAt4fJbqi2fmv5nzPJvMpS5pbinHj	14283	20115	20115	1619559900000
28966	3NKU3ic5o6rtMLCRWR6bp1Ji8o6YFDoYCVrjwYYMY4XKbTBnxvdE	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1610	1188	567	12463	18974	jy13UbnmNQ2aaXdCGusNng2BtGTdzGK8jQRy5xtUS7XPxTdLwMK	14285	20118	20118	1619560440000
28837	3NKm8kqTxLuoJ63DY6LPgw91MA9en8kBfmfmbPaSBPUmzJn2N5Gb	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	576	1109	564	12463	18974	jxsq9enw6eVk8jy4wMTAuiKmRg6hDedbEnfBAyUgVAiMMj1EVT2	14224	20035	20035	1619545500000
28844	3NLfXZ5va3bJNY8xFK6i4BbysWVDvtGHHLD22FfNnu75321YDKPq	28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	1602	1123	561	12463	18974	jwywFvEca6fXkW53CYAzjp5V4PbfxwBipmXM6Dad66fja9cTtu9	14157	20039	20039	1619546220000
28846	3NKdPgoHT3mwUDncz3n9kVUfupNNr9xEDtjgBJEhozC1yJMRje9h	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1460	625	564	12463	18974	jxcMDiJDRM5AAaj5nfPZCr8Lvm8u9GnDmm8Ttprq1rUMLxYKJpo	14227	20039	20039	1619546220000
28851	3NKa7gis8MSDYYZewXPARPuAUSiwYdLLmZLHByx43iNJQMDQLQ7e	28850	3NKbXyhyjCethzFvvfEAnpmdGXbEbg4D8BxFKaLKmiMg4dxDCrZD	1482	226	564	12463	18974	jwYAbt1fs19FSix8MsaqLzYquKCk5PB3BkcFzyUyDBRtVY1jRXS	14229	20043	20043	1619546940000
28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	28853	3NKPwUvu1KeF6jbeHR8Tbx8WQ2Kj52K7rFREAiXtujD8WEf4YqcR	1637	816	565	12463	18974	jwg9UmPcqnkCFg4koj7Yg54Ni7BPp8kQg4ashFKPeKbsPz6CfYj	14232	20049	20049	1619548020000
28859	3NK3FH64YmpQQ6Hth11Y7tymGBS1JrAFRgLfpoWjksCi16HLJuGU	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1602	1123	565	12463	18974	jwGd5VgqeoHx6Tp4QeSMQTm9dfFhoui4iPnHxuBPn6fCNkJ6wdx	14234	20055	20055	1619549100000
28866	3NKhuPDCPkB7qfq3yxHnC4WdD6prkaQXQAZLgW4PDGAmh7UQrH1y	28864	3NKA8hc1oNriZW4FQVVno8iewi868yrSPq9e3XZEnhXQcZ7Mrd9Z	470	1063	565	12463	18974	jxAxwULh2Au4mh5xJpz9BX7cTxqX7z6Y1LBr1mHNdqLnmfnmDUd	14237	20058	20058	1619549640000
28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	28869	3NKwbTJA945KCZ6YZB9MdzsTTm2AUm7WxfhX2pHwPJmJRRjpxqN2	1671	999	565	12463	18974	jxy2JAZBe1A2vV7nLChrPTCG6dEacGD8yvdzCVWedRisK4EtB4s	14241	20062	20062	1619550360000
28876	3NLLUXRBgvF52kbmcNZ4RqiaGXmt3GzYr9tfrfuVrJ1XG3gSTUzL	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1403	824	565	12463	18974	jwPxfLavUhn6YwPpBW53XWXpjiQfK9bn1z3Nx1ZZsNkaRLrpEmo	14244	20065	20065	1619550900000
28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	1407	1395	565	12463	18974	jxQr1wVee9Cr8Z8n6jmzJqDjjLG4bGLHE562ygNPK4fgBkxDqAv	14245	20066	20066	1619551080000
28880	3NLBD9bHqAeV8LkMtNiCh8vPt6Z1KirtNDP6tmaUd9mRhSR3zKqc	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1406	1393	565	12463	18974	jx8SzrmNFKcMDsM3sSdtUjJKbdozxyxCj2YnaqCncdN2zoS9Hkg	14246	20067	20067	1619551260000
28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	28887	3NK32HC2BmFE2Zx3VfJjwjNraUFaCxD3JHsRxUnKCydvWeFKvhuu	1617	922	566	12463	18974	jxFCRBu9iP2EwkVwBDDwanmDFa5FKoJexD6adUZLys4frrzDa8T	14251	20073	20073	1619552340000
28890	3NLq9NUjqjYjYTxVn1hkP6tPWgNmcsxQ7oWoAoHHxx8bvJy7oVbP	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	1406	1393	566	12463	18974	jwgxCKXE5QDW3MSwMaUMvLdhqyBxMVLaKdtW4uQ3CDaa7iegYpk	14252	20075	20075	1619552700000
28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	576	1355	566	12463	18974	jxedd9NmDknraY5GSRGV4SV2yU4hYFQg8GofvnjfbKk7Ds4oLCN	14252	20075	20075	1619552700000
28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	1406	1393	566	12463	18974	jxZt6K18A4WC2vXQSB58nmmMDwoWNUCVKg6gjm4PsYB48QfLRQG	14255	20078	20078	1619553240000
28913	3NKsZVNwBDoiPWBN2c4QBWHoziT3i4M9i4FHUxXCfPiJZqyZhKgR	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	44	1325	566	12463	18974	jy3Jw1ZVaPe8TGwiSupKmRMyi1mNm3pnmZBjCF46eH8vVJfmTUw	14262	20088	20088	1619555040000
28915	3NLsWnFPxJSN2cEz2tAAvDenCaKoGfDGosRgfhvm8Ya5KzGtzitT	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1642	1367	566	12463	18974	jwPvaG3qn6QcdHZxhui2iazwNCNWavF2q6SysdP42YbUaZQYYmE	14262	20088	20088	1619555040000
28918	3NLfjJ41RTMuQdmKSpHRk9vfB4DxGn4eHgcX2jvsCyF2j3QiMWvj	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	171	1008	566	12463	18974	jwy7QqbB1Pbp7SabBjh9cWbJxDsTgoDWkb7WH93yWDviMgXRNgT	14262	20088	20088	1619555040000
28919	3NKw1ERzcL6GHp96n35AEZ2c6idPvbqVnKbDGKcbEqrU8KFhLC1V	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	44	1325	566	12463	18974	jwe2JtaAHZCxL2YLn66fKaLQAuAY2xFid6RUjsghacdMNJjz2iZ	14254	20088	20088	1619555068122
28928	3NLECA3g5AYJwWbahV9c3WGzpxiwpx7DAcYCYwpXWFG285zoDEMf	28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	1403	812	566	12463	18974	jwcBSs5AM59NSxKescvxeByB8fAMT6bF6tc9XwMHf5WMs48pa9L	14266	20094	20094	1619556120000
28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	1407	1395	566	12463	18974	jxpbEQtUgVmU17N7iFGayTFBUhcon6XCr3xX69RuxD4u9uJLxJJ	14268	20097	20097	1619556660000
28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	44	959	567	12463	18974	jxeMMY79TiRpzEisXcnn1YQ5ADAyvhfFw66ARaB3kGiv3EU5xdf	14273	20102	20102	1619557560000
28942	3NLrX4KSaEmwCRv9rxZvFPNCBaw2ppGyt3RAYCez3f1PAJwmycVy	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	641	1336	567	12463	18974	jwHJHrciSX5jmEfQ6vrMgbEkFJnyrhh2DvTKw4jSzMiRmzqSFZG	14273	20102	20102	1619557560000
28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	1406	1393	567	12463	18974	jwWaNkNCvD7GF6a9vnMJrXP3dgv5vzgp3evZM8Aa1jApeu5A9nC	14274	20103	20103	1619557740000
28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	28953	3NLiURFFrowFCMWcFHeVSA2QFz2r9msFWAbxcB7dHaQAFZsMo2LJ	1673	1002	567	12463	18974	jwZKFreMQ49eV1TJhtBykqkX65qzvyW9ZwB4HPyW69asWuEvQKP	14280	20111	20111	1619559180000
28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	1508	1261	567	12463	18974	jxwVMLZeAtForgTK2dHSvGE9r1A6L3yAkovXNMa9Mgs98CPuMWi	14281	20112	20112	1619559360000
28960	3NKxFrbViN2798iuMH17sHPDz2LCGpgsGmi548JiuzodCVxAYu6i	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1619	1275	567	12463	18974	jw8LgN3XiLLuN9buh6S2A9asXe1kFHpQfoapvYVuGtcbSNxSFE5	14283	20115	20115	1619559900000
28965	3NL8CAhNHN8Nv9Bn8UEP51CzymWgB6hyGPQ8L5cQAGgpLTpxTzb9	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1407	1395	567	12463	18974	jwkAHyQ1SRtsKC18KMLF7jioKAn41xaJyeBN1LfmuPem9znGn5J	14285	20118	20118	1619560440000
28976	3NLTibAuTR1KBzCsi9eCrhTSmUadnzhwtijDKgoXhiS6gJmztiVf	28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	448	1305	567	12463	18974	jw9KRoHm18ctWsZzDTw4AGpXkaNqW6VZRvHjPKD4ciZ4ebZm5fH	14289	20123	20123	1619561340000
28978	3NLaNcznzpkpaxZxWtfCGHr9zVgB5bLTYtpQN5SaWk7rPaKUcmwg	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1516	1294	567	12463	18974	jwaTWH2XsPrq9oqice8DqQtwdeFCXQqnxsz7835ixNb7LYBXJZd	14290	20124	20124	1619561520000
28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	152	1330	567	12463	18974	jxhxucFXwxpFN2qgcbSTRKCe3CJrUxg55zxg4r9irZ1FmkJPYge	14291	20125	20125	1619561700000
28983	3NLcBPNH27JTsZE3VAXuAsVcnqyydcj53ZAngpofQ56aP7PeNsFP	28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	1407	1395	567	12463	18974	jxetXKmao3vJkyAw3cyp5SsEbVCChcHm2mRS9sJDN72siZecZDm	14292	20127	20127	1619562060000
28904	3NLikYpMe43DTeWqs6HCMoRAFkGZR7kVb1rQKoTMuKfohMSHSBr2	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1623	839	566	12463	18974	jxa2i4qSqfhS7sQFMem734aUqGmDpmkDRwQvk6nor2Qwagyw1fp	14256	20081	20081	1619553780000
28906	3NLJZ6MSC1PA2i9YY85QZ5DJccohZjVkmbzzB61ud3FcfziGQQra	28904	3NLikYpMe43DTeWqs6HCMoRAFkGZR7kVb1rQKoTMuKfohMSHSBr2	448	939	566	12463	18974	jwLhtberSdPenuSqTvxZM5CRVZbFuEQCN9qhvJfEapf3FEbthge	14257	20082	20082	1619553960000
28909	3NK7iov93TJKDeK6peQAassnD7gThbmWHJVxkqebE1HT7zUpvK5V	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1610	1068	566	12463	18974	jwfTMYgpJTTihicjfDtTng2kbwcL57Pp4zxVXUay1HJpF7h6yXc	14259	20084	20084	1619554320000
28911	3NLwHwPt5eEBPAEfoyQqwJpGjXEeUiA52KTgxEEPQXbTfEo9rZ7A	28910	3NKUwR2cMk2Ka8aFV56TatZ8SkWojCkHDUVS42kG5z51u59dzK7Y	1623	830	566	12463	18974	jxqyTDTamcvtsAYaCrGY68kYSZFrQ7RJe9zFVScngwxFjmsa3TB	14260	20086	20086	1619554680000
28916	3NKkpAP4x5Gs6mPZMkirhbtTDCX42dVUnT9MWrxuhqtGJhfW9djB	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	58	1035	566	12463	18974	jxh1jK9yBBSgZ3Yk3MfGekNnSnBHwxWbHHJfHQ4RMs7e2okbxDk	14262	20088	20088	1619555040000
28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	28916	3NKkpAP4x5Gs6mPZMkirhbtTDCX42dVUnT9MWrxuhqtGJhfW9djB	43	1310	566	12463	18974	jwnckPrdCHDc3oHxFDhUa7tujwXY7p2t11UZ77KT4KxuenVYQSd	14263	20089	20089	1619555220000
28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1483	402	566	12463	18974	jwhaC21kQchACVCGvTfeyti42tMBDjHaCkjEo2YPqHocvs4zgL3	14265	20093	20093	1619555940000
28927	3NKik2WmDo3acwiMLByUMwP4RGcZddYfzs4imVJNk8obiKYLxBW5	28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	1406	1393	566	12463	18974	jw9teELj8B1nhEoMueZrebVqBrnnzRNwaAEzTURPJ5AEkiEStcb	14266	20094	20094	1619556120000
28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	28928	3NLECA3g5AYJwWbahV9c3WGzpxiwpx7DAcYCYwpXWFG285zoDEMf	298	1308	566	12463	18974	jxsy8M7QEurnv1HqzPGJm9rE6wNEZnzTrzn4tCBKrBCD14moWmn	14267	20095	20095	1619556300000
28933	3NKg8RNoWPoxsPu5jN6dKkoXmyZk6vpR6mJmkktVnZoYzwHwtUY9	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1555	1347	566	12463	18974	jwJdvqkGi93zrxsTK1GCh62qpnc8BitLw4Nhqsg89abXtCYMG5Q	14269	20098	20098	1619556840000
28935	3NLo6cVM7w9KzehLzTdArcPPsmYy3BrXp5eL4i5wfVNyPokhpNkK	28934	3NL1hcHusDs8douLhhgXyD4LP9nRMDyxZrS9REUybCZYMPR3u3su	1406	1393	566	12463	18974	jxcAPRzGMZWW9GjLfaPVAiNV6XX9cyPWQ2vz3XrHV9rQCQbZyPL	14270	20099	20099	1619557020000
28937	3NLZj7sswNEdTBYrsdpFqj6Kb7irnK49WT4jVbWKg6YbKLtuyNP6	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1547	1378	567	12463	18974	jxhLBK67FdA1boMz39Wrs8Tnexjx3AsHk63bk9thuqLoFajiw6J	14272	20101	20101	1619557380000
28947	3NLiFvsp16DUBUTaEizDm4Nt8R9xBuHPwzrGuksqP2daazQDHsDK	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1642	1001	567	12463	18974	jwV5TJnifuetf3i9Y2x5ZSjoMXmZnac2MfSpVYsr2Wi4pqghpDe	14275	20106	20106	1619558280000
28949	3NL5HBRmxNdxcV8SJB35FygXRspfvAJyBLMpsGRrXunqVD3GTWEy	28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	1651	1175	567	12463	18974	jwXjDXfWnaG6pmFb1Z6a487t5AKu55kq5kAHiZbsHF3GBAsp4jc	14276	20107	20107	1619558460000
28951	3NLqPFwN5uarD2EcyZfgf4LZCLH589vFrYuFnQwa7XSoStNpgPHL	28950	3NLE169YD7crqbE7TGRbgybuTY2pFdZbHuYtfHDNqAuenUG7xZuv	1627	1385	567	12463	18974	jxLLgUMFHP7SBmNqL5tZKvtxMi8LYURaU2H4yURwu6mM2h8naLZ	14277	20108	20108	1619558640000
28953	3NLiURFFrowFCMWcFHeVSA2QFz2r9msFWAbxcB7dHaQAFZsMo2LJ	28952	3NLiehxMGd1ktjugC6Y8K9A1GdfuXgdM772Z4nFykuLBAG3anCbH	1593	1220	567	12463	18974	jwzY6zwq5Mwf67oTGPButQPsiXpDgadDf6X94oti1wJw5uz4n78	14279	20110	20110	1619559000000
28959	3NLXhKMUG3eUkgLCqa32VX3B2hTSAQbDxUHfFmvEJ8ULRVMywRXj	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1407	1395	567	12463	18974	jxRNh38vUVJD3DUoq9nx7BMPGAYckNCWUhiq1FHra5RCj1t3hXH	14282	20114	20114	1619559720000
28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	28960	3NKxFrbViN2798iuMH17sHPDz2LCGpgsGmi548JiuzodCVxAYu6i	1637	816	567	12463	18974	jxLFC7cxn9Qq9UwHjYEUGkRnm8YZAQUzfxkPPPGUwor2EW9aHwg	14284	20116	20116	1619560080000
28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1474	1329	567	12463	18974	jxexTW6VtKM5nFfSdkJEEmYu1bFLECnBGhq9zk5B5N45shYjCMw	14285	20118	20118	1619560440000
28971	3NLTQmpDgA1dVKTmVxmsC5X5CbSHRPoYKZe4ZegQTXYtNQkoboDG	28969	3NKo35t8ySGFE7GK8AJYS5KEY6iJ4VVcv37ef89ToWUsr8P7AJ2U	1602	1369	567	12463	18974	jwpN3hPbxfT85rU6UE2Wt6voTAQhdgmyw8Lamsub68QAQ6Ri8tp	14287	20120	20120	1619560800000
28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1547	683	567	12463	18974	jwWLNpwYeVn8JDk3y7ZdqqeGFDafyLUsvm3oPREXdb7U2AZLDkS	14290	20124	20124	1619561520000
28981	3NLtjBDytSwqxXKNeVmWz4Az79K9LGYVjkVnqFepvZX2y3onaZzi	28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	1406	1393	567	12463	18974	jwZB2iwQshqWcDqdNoxf8iH5LEms3W7iTBATktFJJcYx9KGEqGr	14291	20125	20125	1619561700000
28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1405	851	568	12463	18974	jxyrx5kDVdPMGRTAgAegFXKa6NMuavCRQ5o5mWMborEv7sFjmor	14293	20128	20128	1619562240000
28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	1651	1301	568	12463	18974	jwMkSyLA6AtqvLFZAhs9mVRriUjb5f47h8B3bnf2dwiuSnCVkQr	14295	20130	20130	1619562600000
28996	3NLgKjsLR7xab18fCyYHxaD9A7PWNGmTTcqewYVGkNtbvVmQ3e6x	28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	1406	1393	568	12463	18974	jx8gi2RQzwncZ46HptAnsWKbFvRTuXCmfZSUZaEyHh5kE48Kzaf	14296	20131	20131	1619562780000
28999	3NKWD7jtswCHyvvG4iMPVKXRxLz4kwqpymXoUiUwmdS4pUQR5rT5	28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	1673	1368	568	12463	18974	jxaTSKin6ia44VZYCcHmdC5Z7qXEcYCSuunbgP4W1ngu82UBdsi	14298	20133	20133	1619563140000
29001	3NKG6kEAUqpFJZdFAyBjDH1cZymMTNtJsVfkYUhB7oAKtA9QKmAL	28999	3NKWD7jtswCHyvvG4iMPVKXRxLz4kwqpymXoUiUwmdS4pUQR5rT5	298	1182	568	12463	18974	jxQD8VchV5KfwYVQZB9HJ9yjWTXtHHTNyiJFZUTyBzHWEqwuiM7	14299	20135	20135	1619563500000
29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	29002	3NKz8vT1BvbVtzBz9CkFUnfS9xyupJYu4srms2woqHL5UzNpCxGY	1406	1393	568	12463	18974	jxE7QeVNoECYLRi2G2bUjzGYrr9Zu2J8rqcE9FbLRqLq37KCJaT	14301	20137	20137	1619563860000
29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1659	548	568	12463	18974	jy2KSBqoJs52kGtDGmQei8YzXNufvQLoqwiXWfFJRLy3QSXhrk2	14305	20143	20143	1619564940000
29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	1406	1393	568	12463	18974	jxco3Upbx81Bfuq7bQGo5xckbT2KDtmnYbeXE6v72CkthcjePex	14306	20144	20144	1619565120000
29017	3NKj5RBaVTY8XFcnLML5bLyVnPGVJZqfe9KWQ41KzYLiq3PDPjL2	29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	1547	1132	568	12463	18974	jxxxxc151SLR2jMNnGdWY7yscdb2v3TK2xkFYm2W2SST3fiXdJf	14309	20149	20149	1619566020000
29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	29018	3NKbvjin3kfZYrtivPyxMNCaXuLuDLbtM7Z2yeF4CcT5jACP3uWz	1406	1393	568	12463	18974	jxmDdrnDQjMGdZfZxaf8uQCDjgu1zfcH2dhWAqt5DWMuiax8dVp	14311	20151	20151	1619566380000
28914	3NKXiEi77tVauf79i2ASujQTKZ6poivcVko24KULdgm3czEPfyki	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1642	1367	566	12463	18974	jxXk2YmJWdeyopcBcbT2Kwb4UzByWKW1oDGxXU9VGanN1hMUzEQ	14262	20088	20088	1619555040000
28917	3NKfH72DF8Q4tui7mSmJWMQKudTz4bFwYeKLcK8YfGs7jc72Jhur	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1599	1161	566	12463	18974	jxf6ejmeuscRrd35hGEmPxrteFy3YducPM5dAJcpVCKPWbGTuHW	14262	20088	20088	1619555040000
28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1506	1127	566	12463	18974	jwGe4FDM2WXsFV4ajwogviVXxbXdk3VmuaF7Kn7v9nuvdUFoNkM	14264	20091	20091	1619555580000
28923	3NL4jdxLN7hf4nnJgPYWBQNeTbYCL2JDzv5ERu8L6n7zLcHH2h8x	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1474	1329	566	12463	18974	jxEGDQrBYa5bBk6BWbRzjKSQRg6r5QNMbj3w44WNCTWgzLPkkJi	14264	20091	20091	1619555580000
28932	3NLhUxUSVV1yN1PfJxnC7YXKySNvXkoW8VqwC7PMUf9VFr29Ncs2	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1406	1393	566	12463	18974	jxSfvoE8JH8nnRgDTpmk3sQgR3CKDeY7dzx27ipd6NfLsuC3vUj	14269	20098	20098	1619556840000
28934	3NL1hcHusDs8douLhhgXyD4LP9nRMDyxZrS9REUybCZYMPR3u3su	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1555	1347	566	12463	18974	jxoM8K5UA9k2ANRMdSH2tBX1SRtuqC4U37AyeiJJCBkD6rkV3RK	14269	20098	20098	1619556840000
28939	3NLXJJh44vA42zu4LtBjpDauxBvHGWXGPviYpx7RLZZeSKP5LMho	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1631	794	567	12463	18974	jxx6fXWk5cC3Z99d7UkAKsR5V1QZPugNJuZT3bFwU6U7PFVjTaR	14272	20101	20101	1619557380000
28941	3NKPZUA2dGmHejB5RPphCa7tpQDkYpV44M8ysfBnuyRgU5gWNe4q	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	44	959	567	12463	18974	jwJDwMAYbZReSKDGU6vZFRW3ggZtyXi9Tv1Bm9y9kTd4FpZ2YV9	14273	20102	20102	1619557560000
28943	3NLLRkVfQ4Laa8fSAuiE2aNfBSMTTrg5EsXMstwmsvRBKQ9jyc5P	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	641	1336	567	12463	18974	jxswi7eqhBh7mcTj8ygnGtpfAa1XXqMZBXVbx743VgRoV7ejvjX	14273	20102	20102	1619557560000
28948	3NKhQX17dGuAGZaBY7KXMwERWjPhXLXE9ffYoKJHyPzac73LnPbw	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1642	1001	567	12463	18974	jxCc2cohRBN8iogAt3TSQNjjLpbiWcLmjyLQhFXenjDWHbZxthz	14275	20106	20106	1619558280000
28952	3NLiehxMGd1ktjugC6Y8K9A1GdfuXgdM772Z4nFykuLBAG3anCbH	28951	3NLqPFwN5uarD2EcyZfgf4LZCLH589vFrYuFnQwa7XSoStNpgPHL	1617	1288	567	12463	18974	jwyYkNTFHUWF8DVc5ZytGZ2jSefYJfqZArW8eDoK9RYqXUsEv9F	14278	20109	20109	1619558820000
28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	298	298	567	12463	18974	jxGozZGfoMTVJgz2TwSaQfJTQKGB48rRfeSEfztjYYsS2aNfyv3	14282	20114	20114	1619559720000
28961	3NKJj8q9NB2c72qeNXYdm8aEiA3UQCi1YS2Np2cXaEnCR7VNxKFY	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1448	1065	567	12463	18974	jwTz6Ymgd8gdpfxEptG12zwjXmDAE9usr3SSftDzGDnSvitbv2t	14283	20115	20115	1619559900000
28964	3NLiGx2JawgtUsAXs6e1qZNCyhJ4DDKUjPtAFWpoMzSkKddSpwVZ	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1610	1188	567	12463	18974	jwGKiZFQzcnYGHMsEKb9AvJJbLyg1W4x9qMpNVt6BNfVsTGdNAu	14285	20118	20118	1619560440000
28969	3NKo35t8ySGFE7GK8AJYS5KEY6iJ4VVcv37ef89ToWUsr8P7AJ2U	28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	1599	1287	567	12463	18974	jwjj8iNbo9pJjj7NZCdL6vJvQuwjXnw7gaqGpAsyGNPwZ3o5fnw	14286	20119	20119	1619560620000
28973	3NL9jqTRH6PzGmFgrXV87nXhW3j2HKj5oryNVT25b3nzWcBDPJsd	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1611	1341	567	12463	18974	jwjDENxGecYoLvYJ8B6jZQXbdhvBrRn2xGQH9h4fKdS3fX6xQn6	14287	20120	20120	1619560800000
28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	1457	1391	567	12463	18974	jx5HK3zcjcAybn29NzbZNZzhWPdhkUQSuuL7JTy25WmDcyAFY4V	14289	20123	20123	1619561340000
28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	1402	850	567	12463	18974	jxPB1EAkba9Q4FvTUyj5QX2LvynYRm19W1kXxhoWwvfS1dHEjpz	14292	20127	20127	1619562060000
28984	3NLHnzvksiVS3f75B2SBSCcgGcJ1RwhEynepwE8Yy7ffzyAGYUkG	28905	3NLcYQ6DccXAwrFjEmtv6k5qnGHW9KciJUFvVFvE5uGMdvXDEnsG	1471	1140	565	12463	18974	jwz16VHzaeVocvZzSHKqxenyT9zgsK2E8d81zNdWvjoodZv4YbJ	14243	20128	20128	1619562240000
28988	3NKbe5ZP5uSzxT6UJkanggcmAU4eu6yGiJzDzbsKnGdCbg6DV2Bn	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1637	816	566	12463	18974	jxaywrysNVU4P1ru1FCzTrN88bScgt4wqGnMxvfphwbjsn5YsNG	14265	20128	20128	1619562288421
28990	3NLhABsk66PjrFtKGDx3BGHtvBiR2PPgdenm6VsS54Be8mrJzdsj	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1637	816	567	12463	18974	jwrbcCThLZPPMtqGN2vighVeZNfQfm8Bd6TAMJyrZJwbpxGHYrr	14282	20128	20128	1619562339164
28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	1483	894	568	12463	18974	jwVZFZJsKDZ8HL2NVQUqmsgi9Jo4FunFzV7o7xXKz27ifpzDzkf	14294	20129	20129	1619562420000
28995	3NKHmNLRoES8aGB6s7RWRhdtG9ob5P3bkTdjZhSbj3Ev9QRe6awC	28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	1651	1301	568	12463	18974	jwxkvVJgQHKEvPAch3YZvdsZveB76EtwnFqbpMTzWpichAHLkcv	14295	20130	20130	1619562600000
29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1642	1241	568	12463	18974	jxqVaGoqsNFa9regAWxjwBs2fdrynUFo3Q61ifXbkbUeBAWUTYd	14302	20139	20139	1619564220000
29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	1406	1393	568	12463	18974	jwkeZc83WQMnDMQTkBZMZZzf8W4Ahp5m6JFaNnfYURnWut3yVxU	14304	20142	20142	1619564760000
29009	3NKitMk3NiiJUxYQQzvyr4aL6HvNHvyt5NS3EHdGntiD3c9upYDC	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1571	1089	568	12463	18974	jwg6rbw5sgWD8LBBJjZdAddtB5uqRj1LKajSkKQxpUznvUododH	14305	20143	20143	1619564940000
29015	3NLr94MbCc6pzDSiRpCybsGRRdTfXsQXXZpM15S9kjYaaTCx1ZFi	29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	1623	830	568	12463	18974	jxBS6UqbdRaNCi16tmyj84fVH5Jhb6gM3X1PqNSqrN3MCuQHBED	14307	20146	20146	1619565480000
29018	3NKbvjin3kfZYrtivPyxMNCaXuLuDLbtM7Z2yeF4CcT5jACP3uWz	29017	3NKj5RBaVTY8XFcnLML5bLyVnPGVJZqfe9KWQ41KzYLiq3PDPjL2	1573	1318	568	12463	18974	jwNJGsQpc3RcyGn3x445eoek8sxpn8bRBx1npYY438GsMWupnmd	14310	20150	20150	1619566200000
29021	3NLRd1UzT8RVxGqAahA762TS13kCg9SMGuDjckh8P1JyW4KBMxgP	29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	1407	1395	568	12463	18974	jwWQZ3tsPN8ha7Skq7W2U1AUQs61iDkd1ceFbY8P5VDq7UwqVPL	14312	20152	20152	1619566560000
29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	1501	1114	568	12463	18974	jwMuKZw9RC31jJiHRYZpkeusGo9TGkX1piEDk3HubU9S6tz32cC	14313	20153	20153	1619566740000
29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	1522	1196	569	12463	18974	jwWhMfRrayN43Pg7WA9heyRukTvizZXycbte8orUBgFLfjZPYSP	14315	20157	20157	1619567460000
29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	1501	1360	569	12463	18974	jxX8JpsRrM48EkgxJ7qDHZ7WiXH6PtF4rN6Nd5kSjAcSSEbAsPP	14317	20160	20160	1619568000000
28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	1599	1287	567	12463	18974	jw89bd6BixxP8iC4zXcpGLABdHVx14ETD94o9C1KHn7x1sGP7co	14286	20119	20119	1619560620000
28970	3NLfnwAd1sH6LumkvokSEPrVb1ZqpkwJtVnhpkPXs1pKYRnwrWPf	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1602	1369	567	12463	18974	jwvTWHSjYZ3mTfx5YRXViDADTLYkodnkjaRTG4hpiNJQ7wZyBqa	14287	20120	20120	1619560800000
28972	3NKT2wQg1jEjcFvQnetgH1vtjMtJ1RcJ88wUsadJVYZTnU6nWkNb	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1599	1041	567	12463	18974	jxHtq5NZyqaYV55JgGs3EtMLcxyxu5eATGadYLmWJhHfeoGDsrB	14287	20120	20120	1619560800000
28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	28972	3NKT2wQg1jEjcFvQnetgH1vtjMtJ1RcJ88wUsadJVYZTnU6nWkNb	1549	1116	567	12463	18974	jwMutgTHSwUSdJNptS93boxnghXX5Z792iyLqYebLmwBLR5gL5U	14288	20121	20121	1619560980000
28977	3NLWu81KDBRHNsjLcLH5meFzTj1LFKjE3MTMf3Jn4u5jJ81u7jAj	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1467	1376	567	12463	18974	jwvhKUbmwnqDzQp778wCCPvzVaqLALdjW4epC1YST6FDpcxLzZL	14290	20124	20124	1619561520000
28987	3NLQpf1kjmPFRjtgxVxVTfzkpFWnVy3ZiYYGSqRkNgTK22GvahyH	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1471	1140	568	12463	18974	jx3HRRY72ZsCk3P8nN6JyoVYRZpAq6iVRg3QM27phEJhk2Q3Sjj	14293	20128	20128	1619562240000
28989	3NKbnEW3L4eVYqtuFAvYU4ohsyCq6P9kYG2ZB2qTK9R6L1kRkH6B	28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	1637	816	565	12463	18974	jwCyGkB1Fr7SAXCSM1uy31vLL3AiWpu9B5Tsd4pQj3zztJ4APYq	14248	20128	20128	1619562240000
28993	3NK3CyVJs8J8WFDnnGFFKZscCrzXMTu2sfc4DjgMeWDf9YRix14M	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	369	946	568	12463	18974	jwNxc9C54QujSQkYQwqY6YL4h29TSE9STPeqkizUtwQ5suD58W2	14294	20129	20129	1619562420000
28997	3NLuPm9MAWmsLhzH4AJMC66FFRRuuUfwQPUcaEZCYqC1t4XSRZnB	28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	1646	1354	568	12463	18974	jxb1NyaSbg5zAJmetZG8ELVPAoq4mVF9CERPFwraAtbMmxGWJXk	14296	20131	20131	1619562780000
29002	3NKz8vT1BvbVtzBz9CkFUnfS9xyupJYu4srms2woqHL5UzNpCxGY	29001	3NKG6kEAUqpFJZdFAyBjDH1cZymMTNtJsVfkYUhB7oAKtA9QKmAL	1403	824	568	12463	18974	jwYY4yNUWnTLXmrRFRCnhQ7bGmvKD8pRD14khXwLJUZ66vdv6FS	14300	20136	20136	1619563680000
29005	3NKaxrrccySTKPQnc2mK8jUZDCSs7q5bmYrPzZDTcpwyAyhxvnSX	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1607	1348	568	12463	18974	jx1a8tdbGNvFkaEndbRpUc5y6qAqceJyabpiKc6Ni2S6cnXK7S1	14302	20139	20139	1619564220000
29011	3NKoj6PuPVV7TCncsN2FJp3XsbQSUhoYNxWA1SEFxeR9mvMLs8ZC	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1405	873	568	12463	18974	jxN2RHhPwE5cBMpi1zFi6FTqXSkbi2tWyA1TbescGp6HQunZPnG	14305	20143	20143	1619564940000
29014	3NL8TW6rvp42JMrLdv4eMspxn14dX9LtEfag8bmFHvsdoY5A4MT4	29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	152	1084	568	12463	18974	jwQyeLXqMyPefwxt5Cf4eGExkjJUbrfQkXh13PPEfV2Qyd72ojS	14307	20146	20146	1619565480000
29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	29015	3NLr94MbCc6pzDSiRpCybsGRRdTfXsQXXZpM15S9kjYaaTCx1ZFi	684	986	568	12463	18974	jws7UsmMCh9bjzwTTZk5CZP3aGJo8m84GABHeWKYnzoRjAYbFAA	14308	20147	20147	1619565660000
29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	1623	839	568	12463	18974	jxzEMw32T9ZBxnbNE1eRBHfP3X86RQcyMpx7a4p1hxjkLE1b59N	14312	20152	20152	1619566560000
29022	3NKwcD1ndTW8RGdfpa7EAGpAoLzHAs3PS6BkRqqkPKDmS4fc6vjK	29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	1553	776	568	12463	18974	jxZ1ZkiEMfDprSdzhofQKyepyocLmjKqBz5KHcZrhMaqDnYwDgS	14313	20153	20153	1619566740000
29025	3NKAcXD9jC5PQqR2Gdxt8jNaCDp9CeTcnJTuk7rthiiyrN51PhWm	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	1656	1343	569	12463	18974	jxeLC5Z2mBiercVhZFgSrQ5iRhHohKuqASr1jEpQBadk1VjoQLE	14314	20155	20155	1619567100000
29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	1656	1343	569	12463	18974	jxeLC5Z2mBiercVhZFgSrQ5iRhHohKuqASr1jEpQBadk1VjoQLE	14314	20155	20155	1619567100000
29029	3NKgdUh5nUGYrcXyzZm7HpkRvptf5pPvZaKAoP8Z99FR1eBKTAqi	29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	1483	399	569	12463	18974	jxk2TQywRURDn23ybzFTbp6TvQyXHQX2WLsrS89bx7VeemBBNTe	14316	20159	20159	1619567820000
29032	3NKzpvDLVcxZ9xdguRXDP6q29oHfDEnNx4ykdddZjm9kyeefAM8v	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	1477	1104	569	12463	18974	jxoZTrk2yyR8eg4jdAuEe4aHvWLU3UCEJDab4eQoSDJ9rXEFyHY	14317	20160	20160	1619568000000
29034	3NLVePsVf2jXjoodCVBA8RsjnU6xtgKAwtnWyMHnLLTZLaMsk4sg	29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	1406	1393	569	12463	18974	jwhfLqVmUDU5JryAdMwF7Zb3cBPK1AYPxZwfazLNt2J5Axx5FBy	14318	20161	20161	1619568180000
29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	29035	3NKShtZHXP7zV7jhLgDk5HZLAXis4PCvuxa98GS9Ljx3aABo3AMG	1407	1395	569	12463	18974	jwUCLrWyiTu3vhJLB6iesZHddnNrZzyN1sch47QYKiEcEdaQtWM	14319	20162	20162	1619568360000
29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	29040	3NKK2U19D3HdZgSPqZBvKchNGeykjUQhG1cvC12A4pSoJzp6Zu3D	470	1063	569	12463	18974	jw6ybykNrF9gzMV7gKKb4ATN7k6y33XdQkgxHmFcquCqBA1ez9P	14322	20165	20165	1619568900000
29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	1672	1285	569	12463	18974	jwtrNFBkKSJDwuKXMRbSxhNqwYakadpLGPQ51xetboGNTJfZW24	14323	20167	20167	1619569260000
29045	3NLLBgUzS6GorRJAEmESuGSRY1bCYEM4K9oaypKfye2aoAGRyjCd	29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	1670	1036	569	12463	18974	jwkA5TBQXfZ1U7fjh3vAAyKEzGx6ReH4kfAqGrWKPkau3sw4esa	14324	20168	20168	1619569440000
29048	3NKUgP2ChYLhiAxkTkW8uph4UHKqMp2rXmYbXnZjgQTcaXMc4fPR	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1513	1379	569	12463	18974	jxFe1BJnoyu8k6SSXaRm3eMXwFRv2XVQp1YaLAYPhnLPSgAFrxM	14325	20170	20170	1619569800000
29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1406	1393	569	12463	18974	jwYioBBMsnBrVUHdFtJLtgcpcaWeZCT7VeG6jbAjfAEgAwsjaHf	14326	20171	20171	1619569980000
29068	3NKqLgwRbTC1ccMk51kKf5KM16YpK32c89MbrGRSvwRCTE48qchC	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jwpkTKKuPNK4uRpwsyp87srgN9wBGUtwvHKJ4rX4VxhCUYqJnDw	14331	20179	20179	1619571420000
29069	3NK6rWiP9FzAa9tE5mpskCDrdp6txoqdasN57ZZmkb2f6BENpdAL	29066	3NKw7FMTGZhdT5nWg49AjZd5giPfPDAkpeRkGHBLAPvDCcwxm2hg	1668	1370	569	12463	18974	jwNkRzFB2AhZMPHcwp4S8Tjb7MGYYwmEAFqeHYyZVzWv7RAkhHW	14332	20180	20180	1619571600000
29072	3NLLC5BRXDBLxNW9hsd8PqXhGW75Cx87tVsKD24kGQEMUanRYJv7	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1609	1333	569	12463	18974	jx1yksXFKokwnRJbqo6b73snNNnxr2YsDsRcJux9TALTjMKmHJ9	14334	20182	20182	1619571960000
29076	3NLYZv3PT7MoMHUwfGCxiC7fkvwWXtCtqce9vWGhHqPZipsJ5FDB	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1642	1121	570	12463	18974	jwdyCwQSW57nB659rgZcdh6g9gBgXUzMU1V9hCgewJSox8BQ949	14335	20183	20183	1619572140000
29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	29076	3NLYZv3PT7MoMHUwfGCxiC7fkvwWXtCtqce9vWGhHqPZipsJ5FDB	1599	1161	570	12463	18974	jxKAMenXcYGHP1TiNprjdNn8ZWs6Fh74FjQ2uHtaH8fDS4o4bni	14336	20184	20184	1619572320000
28985	3NLxi1yEDGE2kUVmE19Hbo7SS3HeA3A34z5w7LZkF2LMxXyXYKwJ	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1471	1140	567	12463	18974	jweVDgzqTESgVakzgGiiVv5TYTXBJ7TyLfEaFgMkd39X1PeSeto	14293	20128	20128	1619562240000
28991	3NK3drc2wbZ2a5aJWfH1xzdcDgLBuG9vzit93nNGC35crCbLAqg3	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	1406	1393	568	12463	18974	jxs8f57poAng7oWKwNZmfuQwrzcmuYifw2aTPCBJxpXUi2CYJ54	14294	20129	20129	1619562420000
28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	28996	3NLgKjsLR7xab18fCyYHxaD9A7PWNGmTTcqewYVGkNtbvVmQ3e6x	1536	1313	568	12463	18974	jwWAqQyBEquQ6p17u4JJbfVBTW2bwxoFjDz8zHQFmJw8rkcP7YJ	14297	20132	20132	1619562960000
29000	3NK3i4cjgG7N34wfJvn6PMnoBNZAzEtvAYETMWcLx2B26tmKpD54	28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	1631	793	568	12463	18974	jwJoSf4yX4KVYnRbyeX4RwUTaESrrEy72aCqWG9rmgX3q6pqSF2	14298	20133	20133	1619563140000
29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	1600	50	568	12463	18974	jwgxG1VjvksvwRx4pefyWLt3xcsREpQGvuqCcFKB5NUhNb1asEm	14303	20140	20140	1619564400000
29008	3NKKWbniFq7pFEjarYKHL2FT7A2nh5Kj4W6aWkvFaYwvoaEcQ9mq	29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	1559	1353	568	12463	18974	jxwFVBNkcH4aQehuxfQY1hxbVuT13wtnpj1W26Qv4ZLW81bwvsz	14304	20142	20142	1619564760000
29013	3NLj6iRKhsMiv7ygBnwSChxjt5iosWok5VqPBEF6Y75AUCMe9qUX	29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	80	1273	568	12463	18974	jwA2zrWscC38VAKV2J8gQD7JdYi517QfNrm1WUbyLSBxgzyfXwE	14306	20144	20144	1619565120000
29024	3NLoFWQuffzqSmyypHuJLZ81wbeDyBqc9e7BUKrfknL4uH7yrccH	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	298	1062	569	12463	18974	jxAo9aVWPcBWQN1CAQBBkqbVSWhM5edXEZmcZb6QYb89sV6Yazk	14314	20155	20155	1619567100000
29036	3NKrYZbgA5NUhzALs65X6JoCH7QcpbwKrYrJZqyYSEg3kuHvqZM7	29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	55	59	569	12463	18974	jws17rrvQWbkZekkxhVCbzBkkYWWUNcF6YFpxGoosik6ezPGzRe	14315	20162	20162	1619568360000
29038	3NLJ2n8JLvXmPpQAxaxbDZHEsQtmdPphzUpXdd8H6sV1JNjHR6U5	29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	1403	782	569	12463	18974	jwkT1SvfnDSRhm2XCs4KsmM2Xpt3uXtjLMKbE1fxnFQcm4D4KEP	14320	20163	20163	1619568540000
29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	1406	1393	569	12463	18974	jwEYqJvF64YyWyQjmm6vszVC3mnSuj1HjZoEjynJu71QyywsCVo	14324	20168	20168	1619569440000
29047	3NLbmYaYpWVSYFezKcZSxGyjDFxiyDqN6SjXRGVX5bmrGfKd5mW6	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1448	449	569	12463	18974	jw9SnZDGTwW3emXgvsNdsWMFh89JLDJiPkRhaAFMd8nSPpC24qR	14325	20170	20170	1619569800000
29052	3NLjFeSRcq5a3dxyRtVAoqdFFLEDdbQSmdHkt1Yrq7XTwSXpMNRs	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jwtxXVH6o87wwhU6Bq6DgAW6RMJdX2dDVQDjzsUHUG2hTJudv5r	14326	20171	20171	1619569980000
29053	3NKEfzSY91zyyBUGLD7Nrog4FRCmZJvRGkgucQEGHFerYJUCUNLG	29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	1403	824	569	12463	18974	jwW2Tg33ZHDFBecJx9ddHsmrEgcTHx58vESP8Fv6SjUA6BeCRs3	14327	20172	20172	1619570160000
29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	1631	794	569	12463	18974	jx89nzHpSeTTM8forq8kBc2fFCRuEC1584DFJfEVvPiiQg8gsso	14329	20175	20175	1619570700000
29061	3NLnTNPFiuvMBzEUy7ibyDDrXGCqg6mnqhhBLBy55i1ZVsbyfDfr	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1529	1070	569	12463	18974	jw8C7NEBgnZ3DPBR9drZaqZpBYe4oBDbGLwevQMxQV9Awn9d929	14330	20178	20178	1619571240000
29062	3NLufN9hoKn1socytWJbT2UwSLDjCTy1hn8pGcnyrmzVb9ZnB71Q	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1483	1276	569	12463	18974	jxzb6NNELKZXP5wBgD9DFDsA59FJioMJU17JqjTjk65MCaqC4tC	14330	20178	20178	1619571240000
29067	3NKkd5oT6FicYFWwtxjfmP5jnFTSoYTGUajpKsPnU94bgsh1gcmc	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jwdx18z4QgQFDQKcpmCt7DciaK3suHz1dxLzku2ysydtSZr5D5H	14331	20179	20179	1619571420000
29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	29069	3NK6rWiP9FzAa9tE5mpskCDrdp6txoqdasN57ZZmkb2f6BENpdAL	1601	1388	569	12463	18974	jx3H5nPQGkzwa1fBJzG6LMLkJh1rzQmYZFdSbAU7KQJaz3g2NH8	14333	20181	20181	1619571780000
29075	3NKK3gNTQuQ1NvwErfHPZtv9DuY7gAZHSNwtkx2SJR16hw4D1Vcu	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1633	1144	569	12463	18974	jxrGQ98xMtMFJseACB3zzKLKQ6hA1x3jrq3tXboMWWzSvjfrRvx	14334	20182	20182	1619571960000
29077	3NKLJ8zsKEiC1pazXXR1D3QNhgYs34QQnQdAjDWP1QLcd3NSNGhm	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1642	1121	570	12463	18974	jwdyCwQSW57nB659rgZcdh6g9gBgXUzMU1V9hCgewJSox8BQ949	14335	20183	20183	1619572140000
29083	3NLKDi7SVWz2fapu7eT5rQRZgu2S8JWNK4GRQnGDJEysyLjDowV6	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1442	288	570	12463	18974	jwbutXB1PFowZUiP5cUoJXjbureRMtNFNcUnubGDkggR9pPZZu5	14337	20185	20185	1619572500000
29085	3NLdzakyjr167AVoAVRNLk7Z2fHFyYfGaUmoH3gJFbDyBs4NwYUF	29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	1406	1393	570	12463	18974	jwdBJwrGWb8kfE9ZgCqWdogvc5YheQgUFB4To13ebtr4dGfz6K9	14338	20186	20186	1619572680000
29087	3NL7V3uQ8EY8n9y6U2wKYKVtaz1w2ceYGtiNArkoPVKm6v6CfoKH	29086	3NLX9vDQc97bEYgcv8ncdvkYfF5gUz7JYrCsynsWRAr767auCtWR	1476	1371	570	12463	18974	jwfaGf59djUzJ9jFeCC4SkZxhftnfU8XhfWa6V4CwVE3jQT5CTc	14339	20187	20187	1619572860000
29093	3NLtPuzHjN38a8JvYAhRSPLDLDRawgEZBHESrqaiBej7xAg3yijJ	29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	532	1177	570	12463	18974	jwZiteJ7g3fqiMayWXgfU2A9YtTbw3TSjaZe6NkwndoHwv1bNu5	14343	20192	20192	1619573760000
29097	3NLXDrDaEu7UJd28PJKn8oEHTzT21oawqvpVk5Ag6toErbJRvo6R	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1444	1381	570	12463	18974	jwpv6K8FMSQsZyNAXxkSrDpp8X9k2cfXt33ytD2t4JKqsMaHjha	14344	20193	20193	1619573940000
29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	1406	1393	570	12463	18974	jxmfcE9rm43RmNgZF8eJ9iiGpPduVppoNeU2F52uQr7CsqtrqBn	14345	20194	20194	1619574120000
29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	1407	1395	570	12463	18974	jwVzrDHFE9vTonTPG3Mr5mhnnBZS9LgU1UXLFPcCvVxBF62BuYy	14346	20197	20197	1619574660000
29104	3NKtjsdrvYmk2e9ASqFRZ4C7wLAtVX4JM3yYskrKdPwRZzVVm8vk	29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	1407	1395	570	12463	18974	jw8VmLwEpyvpN3GmRR1EbdKCeSWgnXsF1LUvZ64YZwHwfmsrbfp	14347	20198	20198	1619574840000
29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	29104	3NKtjsdrvYmk2e9ASqFRZ4C7wLAtVX4JM3yYskrKdPwRZzVVm8vk	576	989	570	12463	18974	jxgtggketH2ChBy1PvUBk7MdCQA8x5jznJm9ddn1uRNES3JcqCs	14348	20199	20199	1619575020000
29110	3NLbj7BSVFW3fDRfWqninJ8CfZUYPzfusrfmebENyFR89xapiWPG	29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	1448	1311	570	12463	18974	jwjJ4aVFV89R1jBNb3aUsQdqwfmKsSynMWAgJoaHdovJztGdrTK	14351	20203	20203	1619575740000
29114	3NKxvTTkq6JWyZNMWYh72YXjT5hnMiof3Zq14SWfAcTpjQaszeBg	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1460	576	570	12463	18974	jwcaKFCh7eWggdpt7qL1dA3vAqfyFuGJFj9U7qwABeJBvHX3uq9	14354	20209	20209	1619576820000
29026	3NKN9GT7qsuQaSQz2Tpe2EYp6MWDtRBQoTM95ugc1GwkTdRAipMY	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	298	1062	569	12463	18974	jxAo9aVWPcBWQN1CAQBBkqbVSWhM5edXEZmcZb6QYb89sV6Yazk	14314	20155	20155	1619567100000
29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	1458	1197	569	12463	18974	jxoZ7nTYC1hkpFAt58SbkAi7MyTmCozwSrDpu7y6qAUPUMFKqD8	14316	20159	20159	1619567820000
29039	3NLLxPExmHYjEhqsPMf9ruk4wWAYyRCtzJTLCpaha6ao2xKpoxss	29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	1542	938	569	12463	18974	jxHzGayfg3mx5n4zX1LJtgPSm7tcrVpD1rZ2zT97UdRae83hdbC	14320	20163	20163	1619568540000
29042	3NK3YN9RsDhHMFtHipjjXwxycEVyNTJ5DCxqiFyZx2Lx1cG6pyrX	29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	1403	824	569	12463	18974	jxSXTUvh6azXWnjodh7AjLyEfte8uidRYZPjkCXKw1HSXpkDaZw	14323	20167	20167	1619569260000
29050	3NKuJdxLeHM97C8XW6HNtunv2pjCwpwqSAozu14wZdKPNQbKan3J	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jxwKzYEWff1mdpgkQh6xhL9ijritmAG9dsHcdNsr9yzAxcbZ8u1	14326	20171	20171	1619569980000
29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	1633	1264	569	12463	18974	jwtc3yf2Y14TopudaGKqdAEmRxxxzC57tjH9uUMAQXJsY6NrqF6	14327	20172	20172	1619570160000
29056	3NL5ZaTDTp2WpjR5RqBFLNFKos7VBipZFXP5A86P1EFTqNf2mduK	29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	1607	1222	569	12463	18974	jwYypzYnqUZjfy1inbHrbh6QABviXRriJXzjwXuXDb479TxpWqM	14328	20174	20174	1619570520000
29059	3NLpJiq958SBTQHMX6QbuWa783KHb7jmFehPcWVu771PJ4TJ2srg	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1529	1070	569	12463	18974	jwNs9tcpUG537tw1eLqAEZ3ifatCNrz4UMekkGkgw9ywPqHGZyF	14330	20178	20178	1619571240000
29063	3NLb2uCBUQTNJmWUdmtXKPysrSQaFLD7ntToUc7YYACoYC5NjxAb	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1508	1387	569	12463	18974	jwSYWjRGJSE1XkMCM7VmvZAJg5izVq5GrcyBbefxAaF6EMLLMYs	14330	20178	20178	1619571240000
29065	3NKt6cr9UijLrCAszW2EJZgoYjZ5xysByrAzPGcmSBfqxXmSsKeD	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jxqwLbjZzoz8mvyjWRi4g4L9ovTJzMCbPsQbumYpSLnuq6docRq	14331	20179	20179	1619571420000
29074	3NK9frKLLbKVPBxVxr99g52CaH43ph5szoJJgea8ALAKvAnFVMD1	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1590	1300	569	12463	18974	jwmH8HBqAeEjtx85VHCMkHEwSRtwd24DSaVFa8Zk4auRzVXi1FC	14334	20182	20182	1619571960000
29078	3NKkJ8p3Jx6wzb8DnioPG7TjraYMcJjfBHGcpstUJFQ5sR4MGrW5	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1444	1255	570	12463	18974	jxzzNHhdtKfU1tZ5S7GSJpSXZWREoeRTxbWAPp2NcYYAeYWBfpY	14335	20183	20183	1619572140000
29080	3NLX7iBMbXdpBMR3gDe7G1dn7JmxDtEhuhJp12j6pdQnkaLi7kKX	29074	3NK9frKLLbKVPBxVxr99g52CaH43ph5szoJJgea8ALAKvAnFVMD1	1407	1395	570	12463	18974	jwEDyWqvY7YGegJuiUnLQbeBQqz9daQbaLYtS2ad6qKzKgLoud1	14335	20183	20183	1619572140000
29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1426	1238	570	12463	18974	jxFBsTZHuMaxN9tCmtYX65XEx45xAsy5MDyAhfTEvkcgsL9im8e	14337	20185	20185	1619572500000
29086	3NLX9vDQc97bEYgcv8ncdvkYfF5gUz7JYrCsynsWRAr767auCtWR	29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	484	1319	570	12463	18974	jwKLVNpxuTQ46JZjunS6YD76yGjaZfxr7Eya5tXobAdKpXAm7wb	14338	20186	20186	1619572680000
29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	58	1035	570	12463	18974	jx425TLk2ewYtaVEm4zXSgW9Hb8nmbz2bfLdaxFV4cLxnRndZSx	14341	20189	20189	1619573220000
29096	3NKXSQMV2pNifWoUyfTvTJPMBR6JrHRPvxNBYtuDhSxZKcMa5Eps	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1547	1132	570	12463	18974	jwRe9UJCYCkiJmbQtQ5RpbcnBnaEMKwJFPefyGkR4YEUeTq6AZf	14344	20193	20193	1619573940000
29098	3NL8UqfGY5Jztrf193abyv7TkzLzRwpNSKSmLTdJpbpFi6cvQocy	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	606	1049	562	12463	18974	jwNkfjUtTEDPKtDcPJvBEkjS6y8wci4PEdWV8fWF4RuxvFEDdJ4	14190	20193	20193	1619573940000
29107	3NKTD3fMQWhXGQeMPZanQg8dgY64Pi8fbNgs9gFw7XAUvMbH752a	29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	1489	1134	570	12463	18974	jxR1ogQdTYegNNpXWAk26yzVAGAVQgDra5su4vmbAEA55vyWVnW	14349	20200	20200	1619575200000
29112	3NKr7g78pXHjEmzidQqoKh7AynCPV1JqVX9seyGguKbfgf1J21Xt	29110	3NLbj7BSVFW3fDRfWqninJ8CfZUYPzfusrfmebENyFR89xapiWPG	1637	816	570	12463	18974	jxRPgpZeSsuymZNVHWQizuz7K3NVkBUXKa6LxRuz2gZMKUB6qTA	14352	20204	20204	1619575920000
29116	3NLG7stL1DP7RGZB7Q7wp3cVKvFr3zmx7LjWWAbdtGxNZnJbWP5S	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1483	1276	570	12463	18974	jxyZ6Y7aQ85L8hsW32jgWyfg9rMCR5wTpadv4NujsGs5xoo63zt	14354	20209	20209	1619576820000
29121	3NLNgQA1bd62TuNP9Vuco91Xn3VSQVnZvWWoVXbKExbWFZ53Gp9g	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	684	1352	571	12463	18974	jx6ieBabac43WMuZSrSAKPqqtF7zYiuJk94mrENDW9WmEM9VN4u	14357	20213	20213	1619577540000
29125	3NKJK1B2Zmc7zthDWRdLUUSEehEB4EkPWGSCZmta6QjPnTjrerCE	29124	3NKDTeeSQ5Zbfh5VYcyofALafZQt6MznvnAgfAfGoXsEBB3EkKmY	1610	1314	571	12463	18974	jwQn5DYk4j4hugzjkhpjgNkY6Z3MXTa3vj3NmAKtEUgJNBkuJAK	14359	20216	20216	1619578080000
29131	3NLya2P8dfiTNKBCP7kvNdonVRnu57g4GRydBDSis2yUV9nSrbsU	29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	1403	824	571	12463	18974	jy2sJFpp2FhFTzxVzDtPZcHvQxT7veHxmWvBbmv8r5kDscFsE8J	14362	20224	20224	1619579520000
29134	3NLig89FfDmqnJr4XMMPPY3LKonrFxA7kvVAKayaErrCxArLty8J	29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	1419	814	571	12463	18974	jxcBKiqrDFB9DqRahFv5YidGb6718wV9gYvVyrFrQuRK9UdzTtk	14364	20228	20228	1619580240000
29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	29135	3NKRkjGTWXXEcxB5zg7YjWo3L4qtXju98AmPiKAycEPeUzXFqej5	1483	1030	571	12463	18974	jwcdSxU3bbBVBXeiDyBVbVQdzGgZfBmA97jrhaTnTC9QgaPR8BH	14366	20231	20231	1619580780000
29147	3NKofUqMvCr1vorUDtgKp3WyEapkpWiEz2995mx9qL2PaaW9dSsS	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	44	1325	571	12463	18974	jx3x68LvnbmbVoZwkSRBJ98FaC58M7Zn9uFYBs3mkoLzU1zMJb7	14372	20240	20240	1619582400000
29150	3NLVvCNzGBKxoBdQwKYJBb5x5zqPRxGoKVNZSt8v9MP6wGbM3xXV	29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	1403	782	572	12463	18974	jxCDLDMUoVeWiNTeMZAJKhmFnFP2zyeF3PytbPzAf32Po1PLSA1	14374	20244	20244	1619583120000
29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1607	982	572	12463	18974	jx6PxAFvZvMXP5U39QzZZtG67ufvPsz7djwwemBEpkjgwg16AVo	14376	20246	20246	1619583480000
29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	1668	1370	572	12463	18974	jx6jLC4eo6om5qa8s3JyBeTSnffTYQVeSWBcgyHN9BttPDHaLgP	14377	20249	20249	1619584020000
29158	3NKNMcqrkGAnKshnQvPVjAbs84yPFAyUkGpNyEWV5gzAMAqbamZW	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	58	1155	572	12463	18974	jxPDXmh8GkmVmVEeinymtDhMxDg2yjitbd3rWgZgrhfQy5wCohn	14378	20250	20250	1619584200000
29160	3NKNXBEFvdnnQDk3rRa4bJNKpytqWvGt3cP8eJm8Qrirbzxq3UBa	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	563	1233	572	12463	18974	jwSv3EYeVzQXqJGYWhKMpRFaufBLeMJ6rxaM7Bpq2Z7CoeXGR1M	14378	20250	20250	1619584200000
29033	3NKgCtvn2mHxnU7nom5GBnU7d5ifQF89cZERde6yMaHyLs8BMtFw	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	641	1336	569	12463	18974	jx4EaVHQwN7aioD6yC6Zt1kjBVA1fwMv6oaa2ibuVpBtihh5fH2	14317	20160	20160	1619568000000
29035	3NKShtZHXP7zV7jhLgDk5HZLAXis4PCvuxa98GS9Ljx3aABo3AMG	29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	1405	873	569	12463	18974	jxZrSPcahShdkA9LjUmaFoKCwvW2DLy7JQXggEggSNND9hPcVAT	14318	20161	20161	1619568180000
29040	3NKK2U19D3HdZgSPqZBvKchNGeykjUQhG1cvC12A4pSoJzp6Zu3D	29038	3NLJ2n8JLvXmPpQAxaxbDZHEsQtmdPphzUpXdd8H6sV1JNjHR6U5	1489	1380	569	12463	18974	jxzukjGrHLWsRkiiYDcMgXqeFAhw9JQ3G79SDWjr9cvwsD62YYu	14321	20164	20164	1619568720000
29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1448	449	569	12463	18974	jxvNyUoqV3qJc6egTzdpH3dHFKDjZMBsazA3PkUn31r1YgC2hgg	14325	20170	20170	1619569800000
29051	3NK7wkLM3i1HgwEeyFRydHz3kEShbsT8T2kR8VBYfcxe3iMJWAhy	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jxWymgygsUbVAAKUywAZZRG2iDQYpiBpgDhbbDzUuVVNnknAYDs	14326	20171	20171	1619569980000
29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	1402	852	569	12463	18974	jxYEkLV4M6ttmZnRWYh1p3c15xnTsDE9cNayERGy8Wx7zM4Y4xy	14328	20174	20174	1619570520000
29057	3NLqZWckiuP8wtuYepr9kyYjux9RhMDZ3d3kfrWVQznd3cLGB1Lp	29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	1406	1393	569	12463	18974	jwC5osA9dXHCTHm5nXNFdLT93We3Y7JCQz3ydUiBiQrzF7ERR44	14329	20175	20175	1619570700000
29060	3NKjHdPzwrPyZ21kDNG53nfTKQSdR61hUjZq638Ft6dztSZ5phUo	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1406	1393	569	12463	18974	jxpCsJtTj2dvPgY8B2VNSmmcF9pGtkW9JczstwZkDjiLmsAZQ13	14330	20178	20178	1619571240000
29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	369	1312	569	12463	18974	jx5BR9Z3uC11vRehaSB3d1Sbd1LXVYM9CLG5NQ4VLRe5FostFNV	14330	20178	20178	1619571240000
29066	3NKw7FMTGZhdT5nWg49AjZd5giPfPDAkpeRkGHBLAPvDCcwxm2hg	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1402	868	569	12463	18974	jwj8rGqF44mn3FnRK5BGhuJ7qCUo1JUxrtCkzcAKa2qFQGK5yTQ	14331	20179	20179	1619571420000
29071	3NLMhjrCT5fzXraf6cAGn79aWErBmAhmHmKtEY3bqWXQwTntuQK3	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1609	1333	569	12463	18974	jxKSrLfHt3Je4so2pkKzALtj4U7J6qB4C9AJmFXAFr4EyN4tPVj	14334	20182	20182	1619571960000
29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1593	1220	569	12463	18974	jxyGLQ37Amz1vtEyLbWSPdHCdEpJkMixy5JVPwF9SEFSQQ2gkEf	14334	20182	20182	1619571960000
29079	3NKynnUEgmTFrCP7nicmecyYXktDBtydAgbkxXKTnvjKqm4rJu68	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1444	1255	570	12463	18974	jxoiwk3jbxQAWXqMKCrwij5AVNYjqyfKzsT6mLZmiUc4M4guw3t	14335	20183	20183	1619572140000
29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	1631	794	570	12463	18974	jwSmDuck6Cok8bwJQ38syLhTnNhqk9fHZa9bVj97GbNKK1U8GeZ	14342	20191	20191	1619573580000
29095	3NKAvaXbhERszECkpxn5HgtmF6rTLbSGpbkq85XRpvzcKfvp66PQ	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1654	1094	570	12463	18974	jx1nGgrhwExBzsyVHbryJT4WVx3s5b2uwcK8GiFfgarzTEnVcF3	14344	20193	20193	1619573940000
29100	3NLg44ExKDPVVtq7RzBCbczCD2yPq5dsWqiFAWbiVPHyca9zQRMG	29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	1405	873	570	12463	18974	jx2BSFXXcCa8vDb6tnSEfPp1h1t1mHbHZBKjhKFjuXaKKJ27k8N	14345	20194	20194	1619574120000
29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	29107	3NKTD3fMQWhXGQeMPZanQg8dgY64Pi8fbNgs9gFw7XAUvMbH752a	1599	1287	570	12463	18974	jxrsrfG7h9or9ccW8Ke2US3boBS3cNp3cqD1SXu2JuYYkvj87Cp	14350	20202	20202	1619575560000
29118	3NLNsfxWFaYTSMvS8bCr7S7CTPpcLkoDV82Nzsu1bPEdf27Q384m	28985	3NLxi1yEDGE2kUVmE19Hbo7SS3HeA3A34z5w7LZkF2LMxXyXYKwJ	1460	576	568	12463	18974	jy2fXiLLBDr3Bc2bueUK5p3GPJcAFvSzw8WAHtJ2fLAvhrncyAG	14294	20209	20209	1619576820000
29122	3NKNuktMUAD7JnmbVTkcbVHsEeF8r7xxpHth4fTAL28x1CocuvAK	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	1419	814	571	12463	18974	jxc4sMqZE1EgZ8TbzGWeT6SW9P9oopComAP8hsTtZ2X2LZ4hYL7	14357	20213	20213	1619577540000
29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	1407	1395	571	12463	18974	jxiqb8uJkRvAdy4dYt4Q1BGfAQHq4XdAZ9drGNHbn1Fe8SYLLHm	14357	20213	20213	1619577540000
29126	3NLXbsrcujTWMCrQ9MS5DmCZ6GJVf3UTbZvS1TZFh7akaTtFcPHe	28861	3NLy3BRndwNuqg6fAneJGfXpU7ZR1q2zyP28hxnMHBvtKusuX1RU	132	132	565	12463	18974	jwrrWnTrFcibAbNcgvdi4sH9WxUwo6V2WHq46WQyRTUmnXnTgh3	14235	20216	20216	1619578080000
29130	3NKhAWXeZSDfSHkV2DCff2eFXKdan7HP2kpzWKo9N95jbvNbzzzP	29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	42	1361	571	12463	18974	jwapqcnTNwMPhMp9PiSb8t6GRxzd8tYcmNKYyucmnBMAWo5qNHx	14362	20224	20224	1619579520000
29133	3NLMmDtwQqaYAeF7WKSr2YjsPDGbG6fUUk7y5uVipKrcGtdnDuaC	29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	43	1310	571	12463	18974	jwLDPfWPBdVKvNBNUjEwjEeGY7yV2uXvr7kGc1kMfhRvpcVLWc3	14364	20228	20228	1619580240000
29139	3NLooJYDtdDSaAN42BwHnHUyWwihRsSFD8hw889rfMgXve83MBxz	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1579	1389	571	12463	18974	jxDipW76paUmwYxbGsU5kzJd5YWsexNHxusgS3gVG1DRdeG2SfD	14368	20234	20234	1619581320000
29143	3NKPkghiQjAehKJKc7Jtk8XJx8Pv3V6XmsPCkCvYxty7iQGy9KEc	29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	1601	1142	571	12463	18974	jxgE6H6N6ASwtriAyrBvq4gJK8fsF3C1g57mKtgpaytdez1wLek	14369	20237	20237	1619581860000
29146	3NLaV6FvZ79UtcYd9E3vTKebwZLM8ooPmi8Jr117qdBK4oDrN792	29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	532	1177	571	12463	18974	jwUAYmuuhHeVYLu1jfzx3RGHLnVPUSzvz9QZRFDowybYaM4koZQ	14371	20239	20239	1619582220000
29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	29148	3NKMmWCzkE3aWN4eagsK3cNNLBCSNNFBBJXVotRi3nYsCGdivbQ5	1622	1356	572	12463	18974	jxDPR6cVQkJbYf2mqG3r8KX4vCJK5zNc3XHKHY5AP9rhR2TeE5b	14373	20242	20242	1619582760000
29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	29150	3NLVvCNzGBKxoBdQwKYJBb5x5zqPRxGoKVNZSt8v9MP6wGbM3xXV	1622	990	572	12463	18974	jx2ybshScsjKtwT8UwS43wnF7dtuFGKxTbPeiTogqYLXmidCgYH	14375	20245	20245	1619583300000
29157	3NK452zRMhxNDTV97yjz3v1pFEMFu9B1Qj9TtXpSz7Z2vqrzT9gz	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	1671	1365	572	12463	18974	jwQ4qQKKL9fWUVNWBWUVJibnEq5VELceoPvhC7KmCWFV7ot6PAX	14378	20250	20250	1619584200000
29159	3NLpgnqFnuDW7Rq4SnyDAGWFnNp8of7q1eJaeLuMnj2GdJ4qmE5K	28660	3NKX4eKc38W8kFWFSeooQhzb9Jjsy8K1VwpekUPMCMYcHiXLMxJ3	563	1233	558	12463	18974	jxqPSanz3tg3ioxLKVPNs1gHPigzVDTj5gxDp44LzWbUKRhCACr	14093	20250	20250	1619584200000
29166	3NLTPUFm6vBzUFygWbEyVodzbqMbm5xtz14fdBJhxPK74Qbtq81H	29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	1527	182	572	12463	18974	jwUuTmN6tcACGPugsFMeP6r1XztkYsByiMo4DjD3yJi6ZiYzqbj	14374	20252	20252	1619584581798
29170	3NKMBP6djiRcvgpHnWjgiBL9NFR82pKi1Todbxy9ijXTLtQBjD9w	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jwHH6qMwoo6G3Es69ExL12kJicYVVVpdi9Vo99CrhTdhvCdv6Cc	14381	20255	20255	1619585100000
29084	3NL5MiEdE9ZgoJFLD34CBpSRzW1QXxxZQrPFUJsqUevqKFrDVeqE	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1483	1030	570	12463	18974	jx5QNxu87SHYXswzN45WevWfcu2tTuXCLDfqFSypHpdMZVQUSbK	14337	20185	20185	1619572500000
29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	29087	3NL7V3uQ8EY8n9y6U2wKYKVtaz1w2ceYGtiNArkoPVKm6v6CfoKH	1407	1395	570	12463	18974	jwr6owQN2AVo4PJ4e5XQof2UpCuQhT4U9soX2CAinQvMFjoEFbB	14340	20188	20188	1619573040000
29090	3NLegL2fkbyHvSEVqBzQ1BHkDZACHCeujd5UnPUjdpcyR8Caobg9	29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	532	1057	570	12463	18974	jwMejDXGej8t1G317eyngKMb3U7oN3bitwLhakqkCyPkDG6tYAg	14342	20191	20191	1619573580000
29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	1522	1322	570	12463	18974	jxwA9GHTJaBXZZnYaxrTQ2xeLDvaiRSQVCfFoAXxZwpBtn3Uy9G	14343	20192	20192	1619573760000
29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	606	1049	570	12463	18974	jwQ7bY19Rs8qdGuiijWoMZNqZfTE1kKtREYbi42qe4L71m1XHhX	14344	20193	20193	1619573940000
29101	3NKrYj49ix19eA9GwLd3eKY5MqBDXu8LT2fRkfDm2h4eWrPx8RLy	29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	448	939	570	12463	18974	jxkdkmYqDPpZQFjQj3jhpdSozNK39DemPYYSArXhuRGwsakeqt5	14346	20197	20197	1619574660000
29103	3NL3ryScuzQwSeXPDrejT4MwnRHukWDD1pFG4HR5kthrZYkZAxAw	29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	1406	1393	570	12463	18974	jxZAGvCqbWFRftLPEMdFpx8UM8kTB9iFTtZm8cA3636SPug6ppK	14347	20198	20198	1619574840000
29105	3NKGWhkydLivpysWwmmJcj4VM8vApPbWf6GVXQramokEKpLGxjHK	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1611	1215	568	12463	18974	jxyxtryN85UGoUzrZcqoR7TEZXNa8r9QwTTvHxEGZs4HNv1wPqF	14302	20198	20198	1619574840000
29108	3NKKi5RaGgKSPYHx6x2HKG6XjsTBkNdRpXCteCKLKhnaRqWBxrST	29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	1419	814	570	12463	18974	jwHVUqZ1bjPHrJikXQ8tf8Ta9B4vQVp5HPvmRdB5uYvorVdGuLQ	14349	20200	20200	1619575200000
29111	3NLsyrRmLtqw5fdmsdQKBQLyR9k8U95uos2hB9rkQTu6CzpwdKPs	29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	1448	1311	570	12463	18974	jwyusRTv42Rhe7kAxShdevr81BHN3uhWni8bxhyimmesv3rE99V	14351	20203	20203	1619575740000
29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	29112	3NKr7g78pXHjEmzidQqoKh7AynCPV1JqVX9seyGguKbfgf1J21Xt	1637	816	570	12463	18974	jxBnRbYKJMY8nrAjREkrVEjbaXAx8SYo7S3B81C8ToHC8aDCjbK	14353	20206	20206	1619576280000
29117	3NLEWtDwmPTE5JoXFUnT8Jwuja8N6hSKMEj2HQJaXA8gJjzUiiZb	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1647	936	570	12463	18974	jwNwmTpGmWemmGzQS3EjsVWMhqfZLeetCmTy8yJ9vj8PME2u1A6	14354	20209	20209	1619576820000
29124	3NKDTeeSQ5Zbfh5VYcyofALafZQt6MznvnAgfAfGoXsEBB3EkKmY	29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	1406	1393	571	12463	18974	jwA7NvzGS8Wvkn18ZsSAqRs8voL4Z5u96Piyvv13X2DafRi8yTr	14358	20214	20214	1619577720000
29128	3NKGCETcA3YRyHnzpxJJz5AC9Yw6qYnaSfhyGTKMaLBi6LtnSJjc	28901	3NLcQic49yZuF3tEFqPrBvpQhprUvR8CSnYsLFZsLMdefuAo4pXR	1455	1332	566	12463	18974	jxkCRptjo3hX4rdNaHZuEvtBUBLn6KFFPERrgLtTHNnsmGLoGS1	14246	20221	20221	1619578980000
29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	1406	1393	571	12463	18974	jxvyvQEXGtPpsWksEiQC4mGb5pgKqDYSP6f3x3syaokSghpwCkP	14361	20222	20222	1619579160000
29137	3NKrUhhvmibrACmCNUWenxCrD9DcH8oZMhoc4foD9cXCbgfYw6vS	29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	1610	1068	571	12463	18974	jxiekWMHPJGJgrnranbvTDacrkKBcFUgVKqPCKz5NviG4jyk9wN	14367	20233	20233	1619581140000
29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1402	868	571	12463	18974	jwRrQ91cJyBZvZ1eTZFHcMLbfbz4axujjc5e5XKdMn2VyuJ4YAx	14368	20234	20234	1619581320000
29142	3NL7tKvBJVGiq7sPVD5rWVokE9pTHbkntFQYJbpVZ5dH7uqrq9Cq	29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	1407	1395	571	12463	18974	jx8BQ5WYctuLFLRqJtjjs2NhbBLMtHMAEucXU91mvj4tESuTJEb	14369	20237	20237	1619581860000
29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	1578	930	571	12463	18974	jxgoyDP6wtWJm2ruMreC7E56AhUUdGbuNQmDwxAoY47XLhqY4JP	14371	20239	20239	1619582220000
29148	3NKMmWCzkE3aWN4eagsK3cNNLBCSNNFBBJXVotRi3nYsCGdivbQ5	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	1670	1156	571	12463	18974	jwzmmbJGie1KuqeXsnRh1wG24MPYeceQe4Q1YPEMXWWoW9dEN8N	14372	20240	20240	1619582400000
29152	3NKgkoKad3LWw3q89VrfrFVf5zkvJrWKBeRPaRxUfXBLgAtFKVo6	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1546	1093	572	12463	18974	jwFR7N12ZrHhQPsvmk71t9EYkGKXZzvgEvkkmaq81nUMje7BjG3	14376	20246	20246	1619583480000
29156	3NLouyWzviwWsNXziv75R3xsec32U22d9gLN9vFqTonKxQqAJBJE	29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	1581	778	572	12463	18974	jxgVy9JAcTpXeF5pg3mJ3knPz8cAXVN742dEEPgdpBmpSGWQWSe	14377	20249	20249	1619584020000
29162	3NLwXVzZfBoSVMrfVXzFcYpS8u9Q2LHwYLkwDFsNKWPdhgpvhjoh	29128	3NKGCETcA3YRyHnzpxJJz5AC9Yw6qYnaSfhyGTKMaLBi6LtnSJjc	1455	1086	567	12463	18974	jwcdP6UfzaHtCzXnUAxXrEBVpxs8x3L5SehysRHDHFJRm7JavLq	14247	20251	20251	1619584380000
29165	3NLe63VZvtx2iamGbxnu2KVtJkBhHJhqytSQGZfssLZBCo6Czajn	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	596	940	572	12463	18974	jwuhy8TrpmQrZhgrnxXFnV2YLXv7jXKd4x5eP3BTJriC6acy6mQ	14380	20252	20252	1619584560000
29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jy1UgCiPBroMBctsd9iSBh5BeRk2nsaV8jwxDdQLaevG7629fWm	14381	20255	20255	1619585100000
29171	3NKvkEcWGpKRc279m2Kw9JBrs3GQ7uNUvJAaG7mqTAPaoz45TL2E	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jwVt198yMVu1AogU5Qut1CBaWVoEr4NivxfZbbduvwtUH9Kd7bT	14381	20255	20255	1619585100000
29175	3NKMR2TwA8fweRwbXVP5hM2AZRn3BEHsbDoYcy5NHDvfyAjKFWrE	29173	3NLebam3hDkSxK8E96goFFddwDV6876EVWQpmm8WMgiib5RFFbJ7	1407	1395	572	12463	18974	jxhswPd3db95djr16ygatX9xvLr3BMchNNQtPvDUHo2yiiCELwL	14383	20257	20257	1619585460000
29179	3NL21XtsaRD3qS9WV3f26ycgybCJa8Wh6QGyGLJuGKA9CqveDx5N	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	1668	1244	572	12463	18974	jxZS7myk1t89rco3HBWZQDwBjGUpda8Dx3WjRE1bkbAia9vxL1E	14386	20260	20260	1619586000000
29187	3NLPsfUfJqBRwU2GXRCWKW5UVrjX3AtKxjP1vxkuYML9WBmF5Sio	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1405	887	572	12463	18974	jw86UMEKdSiZe7NoY3hR9zagLUdFGetKKbV5w8xyJZRagZqD2cm	14388	20263	20263	1619586540000
29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	29188	3NLNGG68X77KHd8rDMVLh8QmswJpwoUjZyPaK8PBkEcXnukfvMC9	1593	1346	572	12463	18974	jx63UTHNCTGYjw7cofJKr8bwjx8qd6suQpUg6y1oNtDdhuFEsG8	14390	20265	20265	1619586900000
29194	3NLUXbKpvUn1Rh5Eiab2cwPB8XZ1Z3MXkEZLyXXnv1DnxGnxSfdY	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	1587	1231	572	12463	18974	jwXTaUcFfwgQznv6oEMEtLvCQBQvVVeR6TgUvp6scpEBL5xxSRj	14392	20268	20268	1619587440000
29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxaKDJYCUq3S95n19j5CGZJ4uCgs5Ff9syF8nVeveRUTDADmqMS	14394	20272	20272	1619588160000
29115	3NKve8V64zaB735zAUTKT7YS3rPkV1oyPEdW5un5c1cuguZ5mEbG	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1564	1338	570	12463	18974	jwqKjxwQuhkkikk7XtrhDphGPhUhdwVEiGYw3uMMFanNahBd6YR	14354	20209	20209	1619576820000
29119	3NLZNKtLz64xYRYNsb7fWMrbLKdRyD5HhyLEQ2xpXBZo6qg8ygpA	29115	3NKve8V64zaB735zAUTKT7YS3rPkV1oyPEdW5un5c1cuguZ5mEbG	1406	1393	570	12463	18974	jxCEB84BokBMawSKrpkrdmVdh2QZhusC6Z6Xb5sJf8LFdwz71x5	14355	20210	20210	1619577000000
29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	29119	3NLZNKtLz64xYRYNsb7fWMrbLKdRyD5HhyLEQ2xpXBZo6qg8ygpA	1406	1393	571	12463	18974	jxbveTpSy9E95ouSL72H1oUxi9fBfmajGuaQVCE8AYJiEwQymru	14356	20212	20212	1619577360000
29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	29125	3NKJK1B2Zmc7zthDWRdLUUSEehEB4EkPWGSCZmta6QjPnTjrerCE	1633	1144	571	12463	18974	jxGBd8TDkrCqFzucadG1NLCpZEcqsXQE9KqVU2xpzzVBu3rLU89	14360	20220	20220	1619578800000
29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	29130	3NKhAWXeZSDfSHkV2DCff2eFXKdan7HP2kpzWKo9N95jbvNbzzzP	1633	1390	571	12463	18974	jwQGpLBpGvvbhQSBb8gu7MG982SaukabyU4qiVXhiLMTcnMrDzw	14363	20227	20227	1619580060000
29135	3NKRkjGTWXXEcxB5zg7YjWo3L4qtXju98AmPiKAycEPeUzXFqej5	29134	3NLig89FfDmqnJr4XMMPPY3LKonrFxA7kvVAKayaErrCxArLty8J	632	1136	571	12463	18974	jwuqfTSE2KXXUfmSSZNYv6warFJmAzV2qXt6wbCJrAREXH6EJPY	14365	20230	20230	1619580600000
29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	369	1312	571	12463	18974	jwGT3h1EBDT1GtSr5fGPKh7yK78JWkzMQ3m6raNSUjNs977TaX3	14367	20233	20233	1619581140000
29141	3NLfomyeHD1jFn7aoTravEfGLspQmhGw494KTdQiu7QwbHY4DoEh	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1600	1246	571	12463	18974	jwD6EiJHLNrKMgwL8qN6TTHRM4qxxesahFBmoCfRS5s6C7pGvTc	14368	20234	20234	1619581320000
29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	29142	3NL7tKvBJVGiq7sPVD5rWVokE9pTHbkntFQYJbpVZ5dH7uqrq9Cq	1578	1050	571	12463	18974	jy2ifMzyPBQjQzLbk8YYyyhe8gWadKsjaatrAgEKPPMSpd5kUF8	14370	20238	20238	1619582040000
29154	3NK84kZxXVzWo7rTjtCWuM7J672woUxAwYHnjttPF797MPGkU2Cg	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1607	982	572	12463	18974	jwWgV4Tnm5aWYpQ1aWdBqKCy96jhKbJsFcdrkkaJosXFVA4ys1f	14376	20246	20246	1619583480000
29163	3NKJR9JYyoANLk33njNryrwwNseD7uFJuNYPxwsk3M15D9sFeh9R	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1527	182	572	12463	18974	jwiiDeMoqgYHYq5JrYXFVMTXNTbcfsuqbXF5ND7bzheNVfkwrj5	14380	20252	20252	1619584560000
29167	3NKh52CTApRd2GHUntX8JLho9g7oTg3uB2ddGywpxq44SdcjiqGm	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1508	1021	572	12463	18974	jwQ1u88M3BpgAeHcRfUkDtzVQxmDbNCbpebaxvSvxMnYJUiVrBa	14380	20252	20252	1619584560000
29177	3NLaSGGy5hXcDuKh2PtprTKdz5Um39FLVE9yhp3HXhpk9TrKXWb8	29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	448	939	572	12463	18974	jxDUup2tjtV39pqcPVigpYupcwaA1wy8pCzfHaejpM1dhfXeMzM	14385	20259	20259	1619585820000
29182	3NK5dUXUUUkUajCkTUbSK5H4t1Jw3L7VQGWTCfgozC5xu9cdkxKB	28949	3NL5HBRmxNdxcV8SJB35FygXRspfvAJyBLMpsGRrXunqVD3GTWEy	1576	605	567	12463	18974	jwZLZoojPtBgqd5ioLfKgfB3hopaXG7vCNHsqq8b6EB8B6a1E38	14277	20261	20261	1619586180000
29193	3NKqrAQvvGwwJW8V7Vcd1fEj2CieJdcJQ5fhoH9DbjJcpRvWKzrv	28823	3NLGNa3y2QHBrGAh1Bo2zhRAMtWimrbjca1jiYdKZsEkqoMGTe7m	1500	1051	561	12463	18974	jx1ysVKQ96kLTnqyzbBwigwfwEezChJQw5DGeVgp9QZAsvBKwRH	14163	20268	20268	1619587440000
29195	3NL96aJSJQBPdbUzLTNY6x2jsgb4XTszCerLZr5DSRTexURK1ELr	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	448	1305	572	12463	18974	jwN9vodGqv9go4PadYuS9bJAw6P2dLRUfkLMt76VmjFGSuwejNC	14392	20268	20268	1619587440000
29198	3NKQHjm9YagKejBZRNsHPo5hEYyXe4HxjRbWpYQU1poHjqwGv5Cx	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000
29201	3NLwvexAwcqrRJVsae7geCwM3Cx69aDnBNw7cTALYTKCx4r8RK2Y	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000
29204	3NK3s7rK7vcN2qySga2pkri7UhH5rTQH1rJLzJTye2jEiFPjtvwX	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxTeAF1eSoBk9UZR7wjv5xvHxvDmeMj4h9VRiS3GRQaLttXfk4b	14394	20272	20272	1619588160000
29218	3NKpo7Ti8CsABdwtB2J4YeMmkRTFF391vQt2e8KBBXbAi8K7Sn7e	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	641	1090	573	12463	18974	jxXAGDinrg6nFk6ZR5A5HfY225jS4vR7PGPmpLSV3u7DDUzsJee	14399	20277	20277	1619589060000
29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	1471	1020	573	12463	18974	jxSkB1kXA3DDVNx4AUtKecXGzYcvsMUkM4N6wZBKMgnpmQ21ej2	14400	20278	20278	1619589240000
29222	3NK6xcmiNPdez2vDGiW2oSWswAKa4eU1A9fdSfJV1wJUoYZGxwNj	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	80	1273	573	12463	18974	jxrD5hxLkFTWhVJg8cmqLF5YeS4edikT9fEGvypp9E6okapadFg	14401	20279	20279	1619589420000
29224	3NKFpftgMJqigqSXZRVRcJKRBoVV8P7jVkr7kAoTLiRzRBVB2MJM	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	1407	1395	573	12463	18974	jwdQfJWA6wSFgUcznJUGompfZrkuqj2ydSDVNFbPzDSNzjifaVY	14401	20279	20279	1619589420000
29226	3NLRU4dtox6saK6PX5LJpKezzH6jgLjrugCwLHoEjWdbb7HuyKxL	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1590	1174	573	12463	18974	jxrUZU1XCHdUCcuVAVbW4nHc2LsK3gzhp1XyHz4gtUYj1HkWgBQ	14402	20280	20280	1619589600000
29233	3NKCZ27aqSXc29mAR5RaRjfiiXsWi9HcXsLLWg5nrHM6U3Ni6rqa	29232	3NK5LPTZFJthP2hVtNhW5XEMhLsRbTNnUq6G1QzdUeg55vu2JAR5	470	1309	573	12463	18974	jxboT61G5XSni4s2PycFra6dnqAC1p8KbAP5EEEtz5qvdvmiavQ	14406	20286	20286	1619590680000
29235	3NKZxMfoA9bXFFcS38droHhSipx85vzmVpuYagXecY8nWH2RKoMT	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jxEZptuxL2jWX4vNxq6R751djm9yMjWZwVp4cP4Xj2kHLT2fLHm	14408	20289	20289	1619591220000
29242	3NLtKwEKESe7favNxPwQP2tcyCA3NH7w2iyVT24hWS3iXyUyDKaW	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1403	782	573	12463	18974	jxESE7PZqFonZjJNezsPj7VonU6vhQWfpJyGh3ozqJu7CdBP84i	14411	20292	20292	1619591760000
29248	3NKit44Rk4PivHjXgNvpatDmKTGS6QKgnFdKLpMomzvyryfnp2Cx	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	1578	1170	573	12463	18974	jxaTkTz83GgunFx5uq5BshApxMjUuCzeJSHnwjFP25fMYN1zYDV	14414	20296	20296	1619592480000
29252	3NK6wo3MnEZ5HnixFKeeNGvyBNscCcdK8Ud7pXRBeKbubVdvXizP	29251	3NLEoTqW5GYXjYKMDyPo7LDz5YefU4Txk2qMymandddao3B4Km2Q	633	1258	573	12463	18974	jxskLeizVRCsXQUHvmRKw79XVCPVRjwVLZPEVgF1MArUHnh6VLg	14416	20298	20298	1619592840000
29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	1564	972	574	12463	18974	jwWdSfP54jvQgzL6hEuGPpdNhbLsrRv5EUp2x3ddXvmhgmVJ1aP	14418	20300	20300	1619593200000
29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	171	1248	574	12463	18974	jxKL6iqYCeZRciN4wL12KGs3z1rSVSWuiLs2XAURCxLt34ayqiQ	14419	20301	20301	1619593380000
29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	29260	3NLPXRi3f9R4FtuSoGiLvyiTw8jZHVx25Z3EbE8WLQPSnoYV4VzJ	1585	1366	574	12463	18974	jxPZ7ZiNEiRe4MvWDE8wUSzvEF1BFKaEdPUxWs7vXKF9h3Euzam	14422	20304	20304	1619593920000
29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	29157	3NK452zRMhxNDTV97yjz3v1pFEMFu9B1Qj9TtXpSz7Z2vqrzT9gz	1623	839	572	12463	18974	jwY7pFTcPvFe9vTc9nwaphnu2jetQjhbKLXwJecQVpbh82Bxrov	14379	20251	20251	1619584380000
29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1527	182	572	12463	18974	jxxfkzqXztCeggZRmkdFXZaCTpC2UxP1wAVFdQJDVGEjsoULhs4	14380	20252	20252	1619584560000
29168	3NKXJVHAfeKUwpzwvcefPcTe6D9vzmkMvDfyCssDbe9irZ9iCKX6	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1406	1393	572	12463	18974	jxAPSK34P4j2SUxhCKp8cSkPJo15g2QTRNNXEzGMKCqjTPTG9qr	14381	20255	20255	1619585100000
29174	3NKUpAZn1JvMCZAb6dXdnbpVPJwvULwE6qwtPM1sG4L1gHvTVHYc	29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	171	1248	572	12463	18974	jxYoenRaJJRtZ8SUckMmVfhgFxCgW93m7Cc4XgKdY8j23wmAwDe	14382	20256	20256	1619585280000
29180	3NLuwvnrtZJ4BM92DuC1oW9BByFR5jzsoHdzECMLaFyHR1wpGCPd	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	596	1060	572	12463	18974	jxqza1vQfuCrXDFPkd16UKTj6TyWwRhnQfyAFx2R44maaxERcU3	14386	20260	20260	1619586000000
29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	29181	3NKehreegkPWiQoUEztUgc1NLC6jPhZ7HxYAmjwpiRVF2TEfzFoD	1576	605	572	12463	18974	jx4Ksa1gCZgkDVBqD8GNubyz3g1ddF2eduMEy2fHFMxzMAJoFYa	14387	20261	20261	1619586180000
29185	3NKi8y4qry6MvYKHaB7FSCgME1emAdLrKeuUdAV1oUPWdDdVtxbV	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1671	1365	572	12463	18974	jwXukMRhLg3u1uffcQnGradpL12ZXPMrScr43LNBJxHMrna81w1	14388	20263	20263	1619586540000
29190	3NLHzFnxKmu8ijHtvox7ToP6oY9YLMX2y9KXXuqkXngZAg8b1s3S	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	1642	1121	572	12463	18974	jwVycF3qczXAVVpF3aYFpL7SjRV7jDrBFfgWeFNpgDuELFNmkqS	14391	20266	20266	1619587080000
29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	1407	1395	572	12463	18974	jxyXyzd2iEy47Ejq74NhxwWp2X2qFrNdhezfFinyqPfic5f3REQ	14391	20266	20266	1619587080000
29196	3NKF85bZHZZUcjVoLcRgWpFbwirUskPjdwH9jHMohkK61DQLtU2U	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	1500	1051	572	12463	18974	jxydeL4aqBcYbSzHqSa4Kt3br2TbWddc5r7ZwBBv5Ef6pkHRSBs	14392	20268	20268	1619587440000
29199	3NKHL6PDevkeWNLaMJvXmp1ZWt7J7WFLpow8EE5bi64P6sHrxFhZ	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxTeAF1eSoBk9UZR7wjv5xvHxvDmeMj4h9VRiS3GRQaLttXfk4b	14394	20272	20272	1619588160000
29207	3NLNuDrzMkjG38AS22QWRvooAxKCESzT81xAHrbMBxpvVMpPqbzd	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	573	12463	18974	jwzBX7FTiXXy5V8HUngaLyWboQytW5qCWhWAR7zrPyVwM19hvWG	14395	20273	20273	1619588340000
29209	3NKKnWMiBcPynVJ579c8xrDgioVQie7pgAkwoBuuVLUdQ96CD6SR	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1611	1215	572	12463	18974	jxB1rXYsRHNotfHeUFHpmavVqhuot8YNvEF17RgCN6YGsVjc8bD	14396	20274	20274	1619588520000
29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	29209	3NKKnWMiBcPynVJ579c8xrDgioVQie7pgAkwoBuuVLUdQ96CD6SR	58	1035	573	12463	18974	jwBqSWamLj7F2KbHzmyebVQ88XZpfaTtwpK1QzzULnAUKaRHCbh	14397	20275	20275	1619588700000
29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	1406	1393	573	12463	18974	jxP25t9rC15vxfDqTeF7r4JFCFJmZ3a9GzJBCvV1nmiS7q4jUSW	14398	20276	20276	1619588880000
29217	3NKqVaVRcxfh6MaHuoSH4kipEfPruxihVGir5GBJ4KatASXtueLf	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	641	1090	573	12463	18974	jwxTJAKcCsJXon4tMu9wWTsDTUa9UdKn6EyfwpymaW9LCbKsb6i	14399	20277	20277	1619589060000
29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1407	1395	573	12463	18974	jxw2CYXUdGjjW3gz5ebNq4TwpQuipBZEBo4n6caBa8iLRXBaGZA	14403	20282	20282	1619589960000
29231	3NLdrVkji33Uj8Hxjv6SeuEvtsDJ2qfcC7Pk4XEzqNXB8HQ5z7Ft	29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	1633	1390	573	12463	18974	jxTgJG7szbMwFHte2pMvzf7v7LVGvsB4uLNJ2TRiHxmThLzrjQf	14404	20283	20283	1619590140000
29236	3NL4RA7SDRRKqkmgAy8A3SuJ5rkfPKWe74c26AYPEKwXYKfVsrom	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1406	1393	573	12463	18974	jwCBgDFhDu5RvrmGJh13gYqxguWAsuTQjXdF6y1SDuobTtxxa5s	14408	20289	20289	1619591220000
29240	3NLpyvaM7eStC8w9BsiAHxf34oS8YsYecNeb7yRri9Z2A8Lmmowh	29238	3NKyFGguywc7XXArbsv1W5AmqNYfRFHyT7rTPkYZYMZ1BNK654u9	58	1035	573	12463	18974	jxpjm9LnbDYvWCN7MxKSVPQwjLPhCLEXcZ7WzcEppYfmqnLoXpm	14409	20290	20290	1619591400000
29243	3NKtMxkr1aHyKmjX9D6k7kobwgnAP22g4RUrbx42WA83SrkEHXDL	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1553	776	573	12463	18974	jwpz6xBLxx5kUyBAL3PYnXkE99trTDKr44owLu76D89XEkFJEjY	14411	20292	20292	1619591760000
29245	3NLq8W5qwmxomA3cAMt6G21DQ18AVVMSnGaAGNso3Yv5t6KTDVNU	29243	3NKtMxkr1aHyKmjX9D6k7kobwgnAP22g4RUrbx42WA83SrkEHXDL	1407	1395	573	12463	18974	jwMsN3MqHcotVPj2MExe2zreaLJnshWMv5tjUBqM6pw9DT75cum	14412	20293	20293	1619591940000
29259	3NLhsKn13VGqaMuwg6dEJnpjvCRe4HZLwwf7ReDVJZ7VDAFRFaVw	29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	1633	1390	574	12463	18974	jxkxxVXhz6ULo4TnDNjno8zu2zvYToAqmbZiRAyMsgfzzfLUfgo	14420	20302	20302	1619593560000
29263	3NL9sgR516vkuSM1wQv2AmD61NUqkmDBEsuGUCtCS9Qh9sUpuEdi	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1405	897	574	12463	18974	jwAGXPZqkjQJyZKeUZAx933St27DmMjFtKQKzAH2Xe1NDzT4q4G	14423	20308	20308	1619594640000
29268	3NLK7owzyo6VjUmDQSy2ZGD6hdfVcCr6uxqsngQMxjjxU3JSvqfQ	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	303	303	574	12463	18974	jxzpQYpgcVUUHqFWfB6L2t2QdUC34mUvDjk4yFP7LEoJw25rpd4	14425	20311	20311	1619595180000
29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	29270	3NKXsFkgp4LUrVvSFrhqpr1xh2vBhXh3LzXt1K52N3W2EJm9JZuB	1599	1287	574	12463	18974	jxqfkTKbHqytUkp1Puj88uPv8sAs7wkQwibvGYy64etr8Xa2qcg	14427	20317	20317	1619596260000
29276	3NLYhHame1h46k6WdauPJpXursjXEmS5f4mNDCNvS38BjpX1VkgB	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	1637	816	574	12463	18974	jwEgJ2KXh24zfxUKXwwujZuMSq1jtRTgRQU1b25XcWFVDPasyqi	14428	20318	20318	1619596440000
29282	3NKc28QU3DpnLfApfZcDpEBPNo3h5VNFf7DXLwJBP7sQEAwvY9b3	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1483	103	574	12463	18974	jwQeBKou24qDJbpxgCeQynS1FnHzbCgEKnRVLRFntcrsuuNzrMK	14431	20323	20323	1619597340000
29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1654	1094	574	12463	18974	jxW166FBUzycuNv4o9qXg2a4GtbEjWwV8pZSom5vExbPcneErTM	14432	20324	20324	1619597520000
29288	3NKiRxCBzCShaMWJLHWcVPLZMmaF27xxx5heEQQe12ZESdJ4qwY7	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1651	1055	574	12463	18974	jxqbP9grh88spLWVt3nQqrNHJbHqNVMPwcpEEVeaC7R7ExfhFbQ	14432	20324	20324	1619597520000
29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	1406	1393	574	12463	18974	jxy9U6K2be8F64AQayDZrQHP4WuA4XEY37kxVNA8hDDNdy6yrYp	14434	20327	20327	1619598060000
29292	3NK7M5m3oxGEHBx5x4xaNRhEB3ckwi9tcjYyE362qYU316w9nSx1	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jx7VvNvn6X2uggwx3QAuB2GRV7mFTGcJnJdPGM4WKA6HMUPxuho	14435	20328	20328	1619598240000
29172	3NKMDh4qk9KBkoPtDfJwd3sGFemWWzp7gRShPgV1xao6uTrwvAwV	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1668	1244	572	12463	18974	jwtTf8RjrxtvUQtxMtRgXo5NXk8ZHnnd5UXksS7FdJ5MMFidvhy	14381	20255	20255	1619585100000
29173	3NLebam3hDkSxK8E96goFFddwDV6876EVWQpmm8WMgiib5RFFbJ7	29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	1402	850	572	12463	18974	jwoQCV5b13TucU41Y9tTR2WaZHDkqMmYHUrd7xs4DUWarotrE2Q	14382	20256	20256	1619585280000
29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	29175	3NKMR2TwA8fweRwbXVP5hM2AZRn3BEHsbDoYcy5NHDvfyAjKFWrE	149	917	572	12463	18974	jxHWuzjbLdzwhrQSg8oK4WJp4B6CX559AVqN7NzFnCWWykMjo6z	14384	20258	20258	1619585640000
29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	1474	1083	572	12463	18974	jwGhCQjrGHVuPGERhERvJCVT9wHPwvuFLvk2emJLNTfBkjmDaao	14385	20259	20259	1619585820000
29181	3NKehreegkPWiQoUEztUgc1NLC6jPhZ7HxYAmjwpiRVF2TEfzFoD	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	1407	1395	572	12463	18974	jwT3AVDmDPCWcRifcZDWC8LSfLgJizbTSDLFMZeY2CQMcYHGp15	14386	20260	20260	1619586000000
29184	3NLxrQF45663i4QML3Ai3HRwkhKyZwHEXePtERMLe6YX9XXBB4md	29147	3NKofUqMvCr1vorUDtgKp3WyEapkpWiEz2995mx9qL2PaaW9dSsS	1576	605	572	12463	18974	jx9PaT69YCM96J6BS2DFzCvMb8iJER1BiHykomHCZTX8oYm9tcN	14373	20261	20261	1619586180000
29186	3NKPUvt2EFSrDnQeWxsBpQW8b6yn7iJoZ4MZJjUo9EhHbGWkyniL	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1403	824	572	12463	18974	jxnGHuzoESwVFjFFHtb5FQF6xk3buLvLSd1nbnRMNhPqUegaroB	14388	20263	20263	1619586540000
29188	3NLNGG68X77KHd8rDMVLh8QmswJpwoUjZyPaK8PBkEcXnukfvMC9	29185	3NKi8y4qry6MvYKHaB7FSCgME1emAdLrKeuUdAV1oUPWdDdVtxbV	1619	1029	572	12463	18974	jxcJQSZr3XzYf9a7MqVNwvSHLPphHhvHRr9VMgZ8oCHeS7Xvdev	14389	20264	20264	1619586720000
29191	3NLx4bPMfQyL8Fmm34cHU3YTWEj4E5omuCoC92Q2VhvSoB7ebPGc	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	484	1193	572	12463	18974	jwkuYTazTGZ6v1tUD7FraiWvL2ZcJyqa22QgzCt7a5noXgDf1q1	14391	20266	20266	1619587080000
29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	29195	3NL96aJSJQBPdbUzLTNY6x2jsgb4XTszCerLZr5DSRTexURK1ELr	1457	1145	572	12463	18974	jw9TcfQ79dYGCxSCq9g8tRCUc58FECd8chjih1roede91x228Zg	14393	20269	20269	1619587620000
29200	3NKHpPKkLh3DiqknJE8mPwPNCbEeZf1qcoTpo5v85LFP34QykDDd	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000
29202	3NKjWeFHC6pvbUYnEeLbSe5GMUraZVWg2zz6qgqJ5acSw5HvZ5EF	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000
29205	3NKjMGw6JTvHktJ3h71tXx1Ei8VDGvcY5VSY1i6jKzbo2tokDJQn	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	573	12463	18974	jwAYxkD9morKtX9tMjBUr4GMfrvjsVXLJcjpkpQqYnErapbeKUa	14395	20273	20273	1619588340000
29210	3NKLgSi3nDamaKAoNUBc9tdq1o1SyYbbmdfWrpL8sXRqc5EizHS8	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1613	1349	573	12463	18974	jwipB3fmXAh8SdmHxRwfJ3fpbdi4sC9Bgrt74mHaKXKL2tSRbin	14396	20274	20274	1619588520000
29212	3NLZWh4JUvdrjSja7pGwZeHxqXXNpR6aAQxtTEEY78GnegJgmfUH	29210	3NKLgSi3nDamaKAoNUBc9tdq1o1SyYbbmdfWrpL8sXRqc5EizHS8	58	1035	573	12463	18974	jwd8e8ovDNT39bAsCHXTdPR9DZ5c2gMskXPkECJ48da4r6ygP1a	14397	20275	20275	1619588700000
29214	3NLFmVuLuLCNFaGuW2w9LCqPqw8LX3vpjN57pEbBJNWEvFxjy514	29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	1588	1266	573	12463	18974	jwv16jkytZFSuYCjkjf63nW8N4gAkv5uZ3D7bT8fwq8SA9H15md	14398	20276	20276	1619588880000
29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	1406	1393	573	12463	18974	jxUi2i3mYupkpHyjyPytwhixCg6yoXiVXVyFZC5iNrhchrpgGMQ	14399	20277	20277	1619589060000
29219	3NLRCGY36xEVm874henPr2bDDqEY4qQUa9uELbyPMLEKe6zrQHYg	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	1471	1020	573	12463	18974	jwCiBQnZGRghShpBS89t9BbQonmN9oL2bzfDhTDMcPkRgCYkqGg	14400	20278	20278	1619589240000
29221	3NLNoNj1YcBLnUjB4MSRY5LKMB6cH7VqS7fUiCYqsd91KVdqRJXR	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	641	970	573	12463	18974	jwLiotVM27bwyioAw8Hb4naF8GGR17Qq4R9pcUhbHCRbm932vcn	14400	20278	20278	1619589240000
29228	3NKuqMVtSQpZTpTzuak2WnBAcwv2df7be7t4MVwGzViar1q1Jtip	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1656	1343	573	12463	18974	jxdSKfgE7bcyPkrTx64JAdPt7Z5grEq4A6ZLEiq7WE7Ey2KMcFo	14403	20282	20282	1619589960000
29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	1407	1395	573	12463	18974	jxwkwBwnyvCQr5Asaao9Z3KpjMmvkBrWeeeB2xQsbt658JpRTc8	14404	20283	20283	1619590140000
29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	29233	3NKCZ27aqSXc29mAR5RaRjfiiXsWi9HcXsLLWg5nrHM6U3Ni6rqa	1407	1395	573	12463	18974	jwz2ycEckat3ZTWJm1zLGfEpDs748f9bof5PdWz6HQcAyHSW5FS	14407	20288	20288	1619591040000
29237	3NLes2DmkhqJWry3sZW7hqmbcArxZNnMHat5A62w2VAGB1YfoTxq	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jwom5Uejq183Q5BXaaeq3L14D58WAXRrV7E6xyiuis76AibSrYM	14408	20289	20289	1619591220000
29239	3NKPYTuCHMtXzFdR72YzF43RAWVuASMD9GvyqegoVx8woFrEWzMj	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1623	830	573	12463	18974	jwkEz58wy1Y5aa9hsXWVnwdNCxbMLQDYQaM94EU4g29hVZPdxvf	14408	20289	20289	1619591220000
29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	29240	3NLpyvaM7eStC8w9BsiAHxf34oS8YsYecNeb7yRri9Z2A8Lmmowh	1403	824	573	12463	18974	jwfD586FZkwmZTXTEqk1qNXDypAtf3GvvdSC6vEemj8eCjznQW5	14410	20291	20291	1619591580000
29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	29245	3NLq8W5qwmxomA3cAMt6G21DQ18AVVMSnGaAGNso3Yv5t6KTDVNU	1406	1393	573	12463	18974	jxTgsdTDSyuUTehAZnu6XqryjwLrK4L3qfti3o3NJR8nwaBqnTr	14413	20295	20295	1619592300000
29250	3NLCaMUPmSsGeenRj6bFbYBFzcyRiLEMPEVWEng2Af8VywqfykJ3	29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	1444	1381	573	12463	18974	jwKVtUZZQ4twHhbwyfNWNrVsChAhbjzHfdjuXxphuGPsntrSEjz	14415	20297	20297	1619592660000
29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	29252	3NK6wo3MnEZ5HnixFKeeNGvyBNscCcdK8Ud7pXRBeKbubVdvXizP	1654	1214	574	12463	18974	jwuvGrQRLmNPvQBHsVmaGNfMcChdf9bTUmGxsZGUkK4XQXxt5M4	14417	20299	20299	1619593020000
29260	3NLPXRi3f9R4FtuSoGiLvyiTw8jZHVx25Z3EbE8WLQPSnoYV4VzJ	29258	3NLyLD6ACR2CT1rMndbuR783ZLMrUGTKkgndujNpRCGiLtvB8FvP	1673	1122	574	12463	18974	jwi6AaHKnfATVBfDfnH8K8UVQqAXGc7K7SPxu4tvCXCo1zjjHVq	14421	20303	20303	1619593740000
29264	3NLwTAtdbuYF2PYsfz6YzwwQ7aPq8hRMkgi4rWNFA41vbduHETa4	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1623	830	574	12463	18974	jwPWD8UJ5mXd7qqbxt65vkwikCPy4GAQnYX4SQbkNdE4xQ4mtdn	14423	20308	20308	1619594640000
29266	3NLVqk7Y8oMaQgYG8JzsXbR9cbhfahmvPY3qCQ5o5gCCD3FWqX2j	29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	1481	790	568	12463	18974	jwWdAwBzWfZBDHr8MKtnu4Gabd5kde25MuYbwcZPW3fiUCqsr3k	14309	20311	20311	1619595180000
29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	1407	1395	574	12463	18974	jxQhrzf2sohZegVA5J1Qnc6FBen9snGhgoL4BP1usKj6Bax8PwW	14425	20311	20311	1619595180000
29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	572	12463	18974	jy1a8NYYDzfc1XLq7XerRFPen9scNnoSJzdgqM9QEfSBTuqJsLs	14395	20273	20273	1619588340000
29208	3NKMxF7Cj2yJSjH1SL6Z49UHYCTMxjtXfcDyEGBm6PuWYGCxUzVD	29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	1513	1379	571	12463	18974	jwcpRev3JaoUEJh4ePdYcTY1XTAteHKc4Zv2kH1jEPQzxnLBArn	14361	20274	20274	1619588520000
29211	3NLP9xYCqWEAeeUhQxhU26vioFwAuzrzBk4rm3zDF83sPJMFJzzC	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1613	1349	573	12463	18974	jxDK88LgETQYM2TT9CnCTtN6Kx3QcpMgNNaJQ4ZW3RatCFkS75e	14396	20274	20274	1619588520000
29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	80	1273	573	12463	18974	jxsVmofKjmNNgQUVH7BsxATjS4ZN5eGPzsEHicTe9tdUQsWLyag	14401	20279	20279	1619589420000
29225	3NKGdQ32EEf6KfYeb6FG47Lgqvme6S1fJY7ErPSJqXZ5VJDZRA9A	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1668	1370	573	12463	18974	jxA6Nx7zYzw2QV42kmvHg86UUSQ8BW6wq3YAyb9JdTLjsvio1gD	14402	20280	20280	1619589600000
29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1633	1390	573	12463	18974	jxHfGQZ1jARTsBPNmmNaThWUAAyJrZE12xTGYNk2XV79ZCtJnoa	14402	20280	20280	1619589600000
29232	3NK5LPTZFJthP2hVtNhW5XEMhLsRbTNnUq6G1QzdUeg55vu2JAR5	29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	171	1374	573	12463	18974	jxFZnJmbzdmjbP7b8K2NVSjdfWyuLkYuZ5TSYrLUWxYcGwagoZs	14405	20284	20284	1619590320000
29238	3NKyFGguywc7XXArbsv1W5AmqNYfRFHyT7rTPkYZYMZ1BNK654u9	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jw9RAUMrBEsDDhyEfq2YQQkfkhGzAXjXYmgyWiWS2Usu4nN1Zhg	14408	20289	20289	1619591220000
29244	3NKZ3zJsqhDZrNAk7tAMwH6VWD3b4XTAe1GimgSe9Mu9EM6F75PA	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1407	1395	573	12463	18974	jxVthqNBmwHtLER7FxBkJUGmPY4B6vsAeAvuHbJzkquSqrkH8Kr	14411	20292	20292	1619591760000
29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	576	1355	573	12463	18974	jxQuMoT4PCC3iPRNLuVxwq8tts6chBiMsG6NcritaVtZxz4dX5B	14414	20296	20296	1619592480000
29249	3NKeJJbDLHT6kuuJUEjzyQ6Enhr8o66pHiWCEywqWGwRhSMN1cKb	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	1578	1170	573	12463	18974	jy2eByBjvekr36nNy7LVAKY4AiQnAPQC5nqFeG5ZZzyK6M57tT2	14414	20296	20296	1619592480000
29251	3NLEoTqW5GYXjYKMDyPo7LDz5YefU4Txk2qMymandddao3B4Km2Q	29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	1581	777	573	12463	18974	jwfy4eQNCrSxL1mXXZmd2FR6sgdHZjbw4Vhm826LfddjtHNjAsF	14415	20297	20297	1619592660000
29254	3NLSPWuWC8m2Cngy4m8TZZpTa3f4vNBXdHtdzXkTXK1V8iGBU7An	29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	1547	1378	574	12463	18974	jxmff4faMKiXvB8rhRYzQq7Q8PuQUvwH9rQTegJyQWTNQmt2mNX	14418	20300	20300	1619593200000
29256	3NLsCijupEyeV8ECx7PhfPnPTT7aiuECKHNC4hSs462KrygcpQtq	29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	1476	1371	574	12463	18974	jx71MXFBK6zNYDZ1V1bKswuiBBkK8W2MMEaUagq8pkqqxmS2iza	14419	20301	20301	1619593380000
29258	3NLyLD6ACR2CT1rMndbuR783ZLMrUGTKkgndujNpRCGiLtvB8FvP	29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	1407	1395	574	12463	18974	jx7Wimuxs4dDU6YvFM7SG558d54GPCYStactXuhbKk1sG3ygvFJ	14420	20302	20302	1619593560000
29262	3NLLXUE6fmPb1HEEGcjCd71FjBxAwXgQEj7zCHCm9Qs9rgsStSc4	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1406	1393	574	12463	18974	jxEyhqu9gU9C4HX8tLbsw1QZTh8bxCwmCWPqpMR1ynShTawvdKX	14423	20308	20308	1619594640000
29271	3NL4bKJhuS2NJ1pqzsMbxvoM3ykrxypBLozxjxNRUeDRpAfBRKDF	29162	3NLwXVzZfBoSVMrfVXzFcYpS8u9Q2LHwYLkwDFsNKWPdhgpvhjoh	1455	1086	567	12463	18974	jwbZXYSztMyTSjVQFtSUPvwEBc3aeJw2jT8Qn41QY5nXR3LHMTz	14248	20315	20315	1619595900000
29275	3NKXLDsf9oSUaxnXBZpQnDu4cRHi7Y34h49JNQZ89nifGzjMHJZk	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	1406	1393	574	12463	18974	jx4BQH3DiHPQmqT7EEuGAqpdsexvbdFZ3TjWzF3t9pGg25G7CkY	14428	20318	20318	1619596440000
29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	29279	3NK7DWRoaR9RDrXXWpPkA3qg78JsFRpubA4kx1bxJczyTGRbmTme	1405	873	574	12463	18974	jwTrBVPwoK16bo2sG7JCwaccN9XvLoQL2HddApQw8oaHJFMWMxH	14430	20322	20322	1619597160000
29283	3NKDx2ygjE3RiyQ8B2aky2A5SiRQGAiaJT2DWQEkLcjyRuyGupEw	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1672	1159	574	12463	18974	jx9iDCAq8DYR4H9EHUracwECHJZLrYeSUPijaEKiqYCWaX1LRRo	14431	20323	20323	1619597340000
29285	3NLQzhHg5AwxZSMDVPmVXVp6L2sB7MPW4YmGK5keuLWjtvTZXjSy	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1407	1395	574	12463	18974	jwQ3e9JJZyN6b7mvBBC1KfNV4VuerR2vxqpPk2DuSregonZYWZS	14431	20323	20323	1619597340000
29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	448	1059	574	12463	18974	jxemDyEAyeP3JEMs6HVn9bWNzA7SJZWxxiY9yCnaq9JNXSS8SKc	14433	20326	20326	1619597880000
29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	29303	3NKocKTkXYmoJRGvUwZTQCLnaUkcvk1DCZj8ur9rTcmdnjCrxmfY	1627	1139	575	12463	18974	jxDDjKKFCf3bo8fd1kLrnk6DY9pomGFYWnZ88fXvQsk1onkugyW	14440	20335	20335	1619599500000
29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1407	1395	575	12463	18974	jwWHLWHzzS9o6HM96K2PHDtaFsU6kZj2xtJmevyr9rZdXAqTHyp	14441	20336	20336	1619599680000
29311	3NLqSxqLCid5XDQ4dDwPtSMSwsQiLCGNKozvXR3CfscMWZhEMCbT	29309	3NLwS859mHzQuNi2MVShuj12AmyFcPHZK6WPWzWKufLY4YK2JSdc	1406	1393	575	12463	18974	jwpM4AjhdRGvHR6BqF6E1uASBgts7RiQ7xTERWprVp2EHdHEk4o	14444	20340	20340	1619600400000
29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	1406	1393	575	12463	18974	jwS1ZfL1NMojyeATGL3z4ZGjr3tE8YF8V9ryxA7jtZEJs6PapGK	14448	20344	20344	1619601120000
29320	3NLxQZHZjEs567wBzY83NNg9tDBhV3coVjmxZvvPrX5UVmBqrRtk	29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	1483	251	575	12463	18974	jwKjDjipiCpyrcbQd78V5ZK4EAvRPnpXcRiqeXcH39Mks9pUvXU	14449	20345	20345	1619601300000
29323	3NLdeUrikt4kzHqHRb3SDTJt27Ka3R5xSpvQ723qLNxxY2Q47326	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1622	1110	575	12463	18974	jxRMapZVTPsNiNHta8czFEoegZEqGJBgJgca1Ntd9T44KrowQcP	14451	20347	20347	1619601660000
29325	3NKw4DrpRkXuREp6BzZu2vgtfTuAQxHR9g7VcMDG9L6H6ApdRRyM	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1407	1395	575	12463	18974	jx92T75cexoLqPKVJD7j1X28Duai6ZM6qKRxKQoaMUSvRBVB55M	14451	20347	20347	1619601660000
29336	3NLMPvzvjEM62VojnaGLBZzkk8NhqHL5FcxWXqC2CSRnm6iBfdzd	29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	1426	1364	575	12463	18974	jwQDHBXSjvdRfYUPYXVYkSpEBjrFnconudvtXTpZd49T7b8pTtx	14456	20353	20353	1619602740000
29339	3NLKK6WRsuKuE97wF5Ck3rs8MTnpcqR4KKsWuXfha23JcWDrYoDR	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1646	1354	576	12463	18974	jx5ZbsXdLaeXC7DPLmr3tQh7QzAytDTXG5gibWEEZpp391WTPPT	14458	20356	20356	1619603280000
29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	29340	3NLS7qtw3zo2JGduKUqXS3mNNPoBkyt54EM8krrXaspkigwhnZAu	1406	1393	576	12463	18974	jwnQ6GZqV3McQzWjP1A2XDbUARU9Yzobfab7aqH3eehKsqrnrFT	14460	20358	20358	1619603640000
29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	29262	3NLLXUE6fmPb1HEEGcjCd71FjBxAwXgQEj7zCHCm9Qs9rgsStSc4	1406	1393	574	12463	18974	jx6kbfyRT4PAdUHKdxx7sZZwdprByNJzqr7vvcYNWHypeZeLTfp	14424	20309	20309	1619594820000
29267	3NKRb2RuccDxQxSyTJnfDzdQ9kFjYsV5k9mheCJoxfNPJAqwjxWc	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	303	303	574	12463	18974	jxtWpEUJixxAXENu1qzw5T9yrrhMEENmXAe7ikJtfjJ2ohA4yEG	14425	20311	20311	1619595180000
29270	3NKXsFkgp4LUrVvSFrhqpr1xh2vBhXh3LzXt1K52N3W2EJm9JZuB	29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	1589	1040	574	12463	18974	jxMajzpgwd13mAjB2habPcupszfB6aUPy76riWUUfYWZrf3DxFe	14426	20315	20315	1619595900000
29272	3NLPYGjr9h2rdEmdkHCoXCFSVXDrEbfAtBpYQ2ksCFnynoKURGpz	29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	1474	1329	574	12463	18974	jwfjLHJ1Mij6LwrkZst3zkRKaDprJFizvP3jdA9E8pQKnwMd2Fo	14426	20315	20315	1619595900000
29274	3NLuZZ16K3NcW4RevA8jtfKoYDheUyH1Tm2RXzHxk1ihEYb6Yq4z	29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	1648	918	568	12463	18974	jxfgabLh9ZF5cAsjwL8UKibvvfxotsvmZwQeYVWU3Lc381bNuCs	14303	20317	20317	1619596260000
29277	3NL4i1s6S5vd7LrCfzNiUxsUst6t9o1Ryj77QNy3ZvwupcUDXDpP	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	149	917	574	12463	18974	jwJpygsirdVj3wU6UP9M9yFaJUJzjUpCYDyXxTAAZ6yzemRF4Fr	14428	20318	20318	1619596440000
29278	3NKWTqQv1dHuvdxGjENHyB2smjS3wUpxsMfmQoTMUxEmnRkrn2CP	29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	1516	1294	573	12463	18974	jx4jNHDzyWWzm5qtR7U1bbvwqNHGY8AxaQrPAPYjH3t6dah4Peh	14405	20319	20319	1619596620000
29284	3NLFBmt6W9swf7px4j4FL4RwRHFx3Ri1CsC5RpiEM4j9kT5RDea3	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1656	1217	574	12463	18974	jxeBjjoTySKCabX1cxFEbSdVN2JjMfdAnJLTf4uQ4nrV4ue333v	14431	20323	20323	1619597340000
29291	3NKJaGDoXTKV6URtLxSxGy8vpeztp7ycUUnbKBEDiRkog2HC8eXa	29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	1407	1395	574	12463	18974	jxH3mgjPf2zNGF4vvyhHLZjsTKf3N5pW2FeFPDqhiSHS3fnEyJM	14434	20327	20327	1619598060000
29298	3NLu22qKfGBqhQ9fAX5BZtV6xr4SkCL6TEgx6tbfAZkQpQNyc8Ub	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1477	1104	575	12463	18974	jxBq1VAD6gCfWziigsuCKb5srAkHetaAsiL9b3ZqLKy3qBrcu1D	14438	20332	20332	1619598960000
29301	3NKU4JbhXM4T7Ycpd9yt8hCAMiFDefab3SHWYfWnZuqbAG8DHXnE	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1440	1377	575	12463	18974	jx1zvU7DW3CW8UagLoDwpHyS1ksVY32p8WT4HQf27FzZMeRKGoj	14438	20332	20332	1619598960000
29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	1633	1264	575	12463	18974	jxQ5YGAJt3yPm2FbnPJR1uPwHfZ4aLC4zC2DYaejpC5qC649duV	14442	20337	20337	1619599860000
29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	29311	3NLqSxqLCid5XDQ4dDwPtSMSwsQiLCGNKozvXR3CfscMWZhEMCbT	1406	1393	575	12463	18974	jxH4AsAj7toJhR4mAbXYHZfFkcu4WX3PrePSLc8Z2BMQ5HpAGJM	14445	20341	20341	1619600580000
29314	3NLFhr1wuRupFA3rpw7iFuihoU2UVbKPuDzXYKJKZpHZKRV3zBXY	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1569	485	574	12463	18974	jxs63XynpKHGV6WRswvGmVgfR6NoZtjh7gYbLwhUBjyW7ARoxfL	14432	20342	20342	1619600760000
29316	3NLRiaKrEZRH6CxsgunXwb4duX3V5y8axF8RGB2ZKMA2Zu9qxQdN	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	1555	1347	575	12463	18974	jxwFhELpQQMt88YwjgZMggnAcWNkJp6z6ijN7xGJnFKMq6pgyAb	14446	20342	20342	1619600760000
29319	3NL5tMxPpdqJtReF6Tuqm1UrNR6Hfgb77A7HN1Jsiw8o2TSzXaKb	29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	1460	1324	575	12463	18974	jwxK6RiKQue9cLFyDke14tAauPmEsMDRKczekPHzxDAi1g5pGGN	14448	20344	20344	1619601120000
29328	3NLG6aixKRmw25rnzigaHwuKoxbdJ6fUoderF3g6QqgF7gxgyVzD	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jxEPeAEebRrgoBVbUNue4VuBAhqyXw3bX1exwNT7FnHWXPKqXmg	14452	20348	20348	1619601840000
29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	44	1199	575	12463	18974	jwa34Fmo8uQwUtUzGVoG3VCR9yTeXy1KuHMYfTiEkJXYer19RXN	14455	20352	20352	1619602560000
29342	3NLZCvtrsZJEzHUNFMRtfxGxerqkaw2xxDKTvnjJ8EiSRLQJCVyk	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1402	870	576	12463	18974	jxLoxXjtmtxr5CQWwdrbAmmGjHsLRYowpVTfuPqzVCshYbfe4sf	14461	20360	20360	1619604000000
29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	1509	1320	576	12463	18974	jx9QbUgkkzDe7EMBySnZL8113krR6iAJgcgnaAkwv2QnW5KX7d4	14465	20365	20365	1619604900000
29354	3NLsmHS5gK2g9uEanCC4FrEXgvhM2Zr2e85fJ21susmK92p1k768	29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	1573	1072	576	12463	18974	jxe3JsxM9mVWr5i7R3nARecaT5gw31Y7GXfxSpKLnLUiPJSK6wJ	14467	20368	20368	1619605440000
29362	3NLQGPVfkuBMLmq3r2jUuthSN2AvejraaNmRCUZwdfFQPMv3z5KU	29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	1483	910	576	12463	18974	jwNHxuDh67FuXPQzifNcekD1BtJcTcuU2Aot1k7PS3yVeqaHGhp	14470	20371	20371	1619605980000
29365	3NKd9H42xT9yaeBKYv2fg8qn97KbiXgSCDW3TN52A3EVKGNpgrtH	29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	1460	476	576	12463	18974	jxzv6PkGWfwNYHrqN99qYoHSDq8pEawnzGgfLHM5LcknykhP27s	14473	20374	20374	1619606520000
29370	3NKYbyheErsf5BwRZV1tgbWvGu2SuXfV9CerupVseZWT9yDXzt6f	29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	1589	1286	576	12463	18974	jwi8mff4sjEfEpq41qrRX6o9YeT5HEUHvzwDTNEYJpGHYxTjbyT	14476	20377	20377	1619607060000
29374	3NKWU84f41MWAod2Un4pFEuVhw9mDHRzMupsErqPrNd9C5vRY6TS	29373	3NKfqvvNucTMQnZrFiFC7VSfQLLQBukMGiZZyYU73X7hTTvK3rsJ	1610	1314	576	12463	18974	jxRztWyh47fkszLC3Hv4PEYtDS7DYRsXQgHZEFfm2paTGivnpGg	14479	20381	20381	1619607780000
29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	29380	3NKY2YxkTysyAi5z9xrYsmDDgRLbJL7bEWn4Z756fLxEiZ7TWFWA	1439	1279	577	12463	18974	jxnt1s6iU3m114QzSpk4qgk7NzWUDYQWv3phcBDWYUU1ZkfSf1f	14484	20387	20387	1619608860000
29386	3NLp2HCyupsJSfLNUiGLi2tD5ZB4unLNPukqSioB9SRF5E3he85W	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1501	1360	577	12463	18974	jxgyQdNqWLkg4V5XSS1fopBDFNmWQBLy6cqHjBhzaBbGjPV9dFb	14488	20395	20395	1619610300000
29388	3NKMnXjdaFw5bt2VSAUFZm9jqJ9DRfcureEWtKArrufuYwcRsuzy	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1460	1198	577	12463	18974	jw9Ha7koZowCDZxRSdDkiV8hwsYtMEPtjoKzmotCirFJ5yiDrX1	14488	20395	20395	1619610300000
29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	1406	1393	577	12463	18974	jxR38DBtFfaw1bJ5fEh4ho1jucwEEFAvqCzegNy7f3SLvAPRiPW	14490	20397	20397	1619610660000
29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	29395	3NLrjey8DUcynD5dj1DxB7tD3DCKa8bCxawuWJExXpAw94Cxkq87	1406	1393	577	12463	18974	jxBoPVGR2Q8RTz1QQEFuLTrzqENsTr18uqRYKiRAMjZ4UyRHghT	14493	20400	20400	1619611200000
29398	3NKfqjtoFpDXRDNKHZXG6D5x8j3M5UvwZDeBot2xM9GyZLrVDtPt	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	1440	1131	577	12463	18974	jwhUBifGPWg7uAnHrwxo6pastCnsdBaTxWzuCJ1dUBcz72Y5NmG	14494	20401	20401	1619611380000
29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	29400	3NKXKEDVtXUaQGEDeKrk66Jt2bhPrt3SSxfHgwbA3uu3oN2vHMap	1407	1395	577	12463	18974	jx7jjcr9S9Ccw8NiXa2yEhbjUD5umk5itYxWjKFHMxKX6ZwuptB	14496	20404	20404	1619611920000
29279	3NK7DWRoaR9RDrXXWpPkA3qg78JsFRpubA4kx1bxJczyTGRbmTme	29277	3NL4i1s6S5vd7LrCfzNiUxsUst6t9o1Ryj77QNy3ZvwupcUDXDpP	1601	1142	574	12463	18974	jwQJdH6xwJfqXHDT2MQ5scpW3Lcwer8W5964GmddZMaN6fKaCfp	14429	20320	20320	1619596800000
29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1668	1244	574	12463	18974	jwaaeh4B2Cd1z26f2AjU9VufrxkomRQ8JaGeTtDMJARiQuv41yH	14431	20323	20323	1619597340000
29287	3NKHKDd1mYgsbHJvEqtb7umyDZsPmVrS77V8c5KgJUd7JFV4Ha7Q	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1651	1055	574	12463	18974	jwZjvhhBijpvq4tWeEbxHHVUnZHtTnUwSese3XgfFLNi241Y9fC	14432	20324	20324	1619597520000
29293	3NLicnZMBi73eHSHe6BQHwUWexE54CbY6dPVo4WLQCtpxxWDkdug	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jx8VMMdWDXiafX6xvcE7ZZ5M8KzpsoRByhNDeSYfdPMRgT2smVr	14435	20328	20328	1619598240000
29295	3NLWQrtzEkN4sepxTn81y8RRLXp3P6bQxKptFfzGvSs1wuEGgBC8	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jxa69qiffQ3GRREDsytWzJc67vww8EL53b8fogJfNa4szrfXo6j	14435	20328	20328	1619598240000
29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	29296	3NLVMNHjmvxgEv2ZyEp2MCyRKaxWY5Si81vA3ZXoefoKvdM2mFvZ	448	1305	575	12463	18974	jx47VVLfn8Ratm9eqbvS6vsC8hXbAuD64sSbHyXLTep2Mm3kowJ	14437	20330	20330	1619598600000
29300	3NKiszJMbHWdHucmmRTHW6Zsm2jBi94VcUEozrCkQGvEXC6WxHHA	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1440	1377	575	12463	18974	jwHcTLeAyVaPxqZ5tbjk2pYv1T2ZnTBebREkJWHd87JWSiCz4TP	14438	20332	20332	1619598960000
29303	3NKocKTkXYmoJRGvUwZTQCLnaUkcvk1DCZj8ur9rTcmdnjCrxmfY	29301	3NKU4JbhXM4T7Ycpd9yt8hCAMiFDefab3SHWYfWnZuqbAG8DHXnE	484	1073	575	12463	18974	jwotTDACRVBmSNsvEmStNRaLzo8mAwq1KoUpbNCVfoHYzY8TNzj	14439	20333	20333	1619599140000
29310	3NLM3AHkvpQQGFb7ZpTKZiQcoBaCJrWSR6hLHBDcTd7ce3d3Mf63	29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	1657	1344	575	12463	18974	jxGjFXvxFghq2veGNbwbQCArhnnGnpUpaiAuFGycsocQEZnbiee	14443	20338	20338	1619600040000
29313	3NLeHuFuJT6wz7o1vbHo1KZ6hzutSBpP3cuqB4ZRQu29LzKJqNrz	29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	1569	485	574	12463	18974	jwGpX9u4MKxmUcPVQ4mVWsfWiqPLipBLZgs1agWWRa9VaiqGH2h	14433	20342	20342	1619600760000
29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	29316	3NLRiaKrEZRH6CxsgunXwb4duX3V5y8axF8RGB2ZKMA2Zu9qxQdN	470	943	575	12463	18974	jwWMuNVoSs5uUG3UgEQ8AGqw6pmYb7TG9TPYSYW5uCuso9Atyep	14447	20343	20343	1619600940000
29321	3NLaSAWV3zLcb4qwLVfjQ1TAWpXwHGrK6qcXzSY6ayTUauppHSyg	29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	1407	1395	575	12463	18974	jwefwL7xtnobHabLzgdAaVzgXcw7N4PQ1gufmmkc8GP5ghKbmWv	14449	20345	20345	1619601300000
29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1403	786	575	12463	18974	jxeZjGRMtDPCCCDvetpuDrfeqnGhaF9WqLvDZbzMRfzvqkvRnU9	14451	20347	20347	1619601660000
29326	3NL5cdcEtxUmNRqM9S1xpw1tSiyC94ikJzX5kVM568WtdGPmJU8X	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jwjCQ9xF7Jbt1Z9TA6PQSSm5Emy8sHRyTZipW14k8DQtxMDbWD7	14452	20348	20348	1619601840000
29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	29329	3NLpfQ6u31MPdZf6mHm77Lw7mV18tCrB3piGJ9wfj7W4xq5KKKyc	80	1147	575	12463	18974	jwjC2gUJRXEahC1pmBQSW7EvmWaecxc2ue1QcxUx3A7nz1Rcdv1	14454	20351	20351	1619602380000
29333	3NKtnutqBD2F6eA5DBW75iM7og2NZ8ot1CTZkRFJQjigF2AvZHoF	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	1405	849	575	12463	18974	jxYz8jZi5Zfkzzkmh3wsX9j6i8DPWZPFfLuotTVadit7MYM8Cv7	14455	20352	20352	1619602560000
29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	29335	3NKcpQVbzPN7ESXrrxgqTehbBATuvXrpZJN4ai4xzm9pq5oMJKue	1607	1102	575	12463	18974	jx7pTFADZqUPoCa5K4xu2UvYfYP8PZEmkq9uNAP6rc8e1tmnpSK	14457	20355	20355	1619603100000
29346	3NKYGSo2R41WT8MDXaARmuyUpSzTKczTgPCNVFMo8Rg6Lio9xxhQ	29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	1406	1393	576	12463	18974	jxBt9VeTbndqSHPNte6gFGvT1ok81bVgw7tjY2vmAkVGBBCaTLV	14463	20362	20362	1619604360000
29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	29346	3NKYGSo2R41WT8MDXaARmuyUpSzTKczTgPCNVFMo8Rg6Lio9xxhQ	1483	138	576	12463	18974	jxVUdoq4UCtEK1qbshxwA8AkN6VEgwswf7jeGVMSBeMNG4gEv6B	14464	20363	20363	1619604540000
29350	3NKYqvPP7qbvLbxDLm6YsA2S6QC4PTf5tFpTJ825GbXcZRQDNrsj	29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	1419	814	576	12463	18974	jxrLBYzjU6iwjG3FTAmnanSMXjrxK1XJm7eGPHUC3B1RHZq5TjQ	14465	20365	20365	1619604900000
29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	1407	1395	576	12463	18974	jwL7wgwyEQWBs2KKDQH9BW3PEjhcg6iXw2LMzF136voF6euN9ax	14466	20367	20367	1619605260000
29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1594	1326	576	12463	18974	jwzRdMR5FdHGpLY2gZ7aor5VFFBKrCmycc3GKcr9fgsezK9pki9	14469	20370	20370	1619605800000
29361	3NLyMHYeTB5zwEvgmb1vF7VqhoArVBVeajGR7E2uL2PXfjhnwjcm	29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	1585	1366	576	12463	18974	jwrSS53Qen9vQmuRGpZy7YkPjUoJxjSiY4uMNdAqdL44stVPkJr	14470	20371	20371	1619605980000
29380	3NKY2YxkTysyAi5z9xrYsmDDgRLbJL7bEWn4Z756fLxEiZ7TWFWA	29379	3NLTUg7DeAn3Lk69XD5NtidGtcTCdGBVG899pwdncUyr1vS6EkYU	1668	1370	577	12463	18974	jxAdJdzTKoZ293o6vQeKRSF8JawfDM7pTFWT1iHFtSvMkdhUKRy	14483	20386	20386	1619608680000
29383	3NK6iTXTy26e86fQiFua8uKseey7LQrTeigkK6ZGNSc6SbF6SaNi	29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	1577	1081	577	12463	18974	jxNhyYWET5aCg2PSXiroTtJjZomWSRfXdosgyf8XvVn9dJnRcP4	14485	20388	20388	1619609040000
29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	29384	3NKLG7NCYJkxKZYqf6YnjJiCbcpFk7GBj7FvxhPVikUHSY4oCPPS	484	1319	577	12463	18974	jwsbLJg5o67JE9asCiGPxKmQdGtb8p7GHeirGtfTp17UuetUGxY	14487	20391	20391	1619609580000
29387	3NLfHYA5kc6tAZ1qCcNufvvAL2p5ALxWYTJzBP9vtYoCRtdFAo2Z	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1460	1198	577	12463	18974	jwvv9pxChRmZWkumbBEffeXUEKrefhDuYNvVK2x1tQf5cS9Se9D	14488	20395	20395	1619610300000
29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	1483	237	577	12463	18974	jxPNaDmtNTT52wA3iaCWxBHEaq3zyoBw3xhET7SWjqyrEtRoMtp	14491	20398	20398	1619610840000
29394	3NK8Q5B3Bs6gpkGy1vJyr1jupCQhrC2yrYjLuUhsaQ9iKnpZQ8zL	29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	1397	828	577	12463	18974	jwuYCcUKbc6PuFdZsK5EgCjNRF9CtvTgc3ZQ1ujGwhNqzGkA9go	14492	20399	20399	1619611020000
29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	1419	814	577	12463	18974	jxjx1KRNW9a6KZ1vvGbBdeF1P3odNyhq8aNLhjEGHoU74mHav5S	14497	20405	20405	1619612100000
29405	3NLXd7yk9cw72Rbb8KwYAUi1ZHDk3Avc9bvFsY79GTH8sVAZ2ETJ	29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	684	1106	577	12463	18974	jwC4HvmJZZqNv3YQdcndvQwPfRjksLdtF5P3MLSM6WsEvksMaei	14490	20406	20406	1619612280000
29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	29406	3NKUFDThmpoEdtUPtWBH1fNjqeZ9piQF3yfx3eznjqVpUtg669oV	1637	816	577	12463	18974	jwR8L8HQeAHQyLYC56gHT2Pmze2CYR4FgBiBtLwdrP1xZbEYkdg	14499	20407	20407	1619612460000
29294	3NKTc7ptxt9viFz6SXxA8KXrgbxVMyfaetv8Hp4FvzbTtSNDoAYC	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1633	1144	574	12463	18974	jxVMXdyUmeXeD1F7iFG54ryNnvigYQC3WPXNz7Yg7gPcF9vJPZD	14435	20328	20328	1619598240000
29296	3NLVMNHjmvxgEv2ZyEp2MCyRKaxWY5Si81vA3ZXoefoKvdM2mFvZ	29294	3NKTc7ptxt9viFz6SXxA8KXrgbxVMyfaetv8Hp4FvzbTtSNDoAYC	1403	824	575	12463	18974	jxDNzhJaBLWkADZjsYiJCyR2PH4jPhc4yShKQo3U2CuJE5pK1e7	14436	20329	20329	1619598420000
29299	3NKrtvzeJzi8AeB68gzkrT4vV5nRnbBAbaZEq6EbQx8K7Bq7QNdh	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1637	815	575	12463	18974	jxnBWQXVpERz7xh51gAjr2jcvZrj5CqZBzrPVASz4daFJZvPc7K	14438	20332	20332	1619598960000
29302	3NLseYX3ARtfp8gRivCK6Mhw4tts3RJ5xZCZYrWgkg35MfhUbtrT	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1407	1395	575	12463	18974	jxB3CunCvsk4m8HiQ2fg6CeHHxXF44V1bKuevMgF8Qu287YHGTt	14438	20332	20332	1619598960000
29305	3NLRZqpjdkAFFzhFUxrKs6oKnBJFVDtEEA7vo6rtzK1n2FcankNV	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1637	816	575	12463	18974	jxY1YpiAGHkvnsFrQakvBCnt8mh7E7acKEiAU3PHdxf8Fyet5mP	14441	20336	20336	1619599680000
29307	3NL5MivbNyu6hkxF7fhVQpXJn8frckpGPzPtVoM66hVeE5Dtjj7y	29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	1637	816	575	12463	18974	jw8xCkSwAt9y5J3LU2zVAqRxbWat9NcZypakaCjcf9KtpdbJQyw	14442	20337	20337	1619599860000
29309	3NLwS859mHzQuNi2MVShuj12AmyFcPHZK6WPWzWKufLY4YK2JSdc	29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	606	1295	575	12463	18974	jwcG1E4Ajp4d6LGFrPV1A9gYGShK2Ky1XPKCCfH9w55Hy43W5HF	14443	20338	20338	1619600040000
29315	3NKn3vXFSt4hAYnLbEpVrxMYS5zkiVHv3pVkQZLc9ZLz8i3Kara7	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	1569	485	575	12463	18974	jxtB9SeetZnkHt6FXdon4BrzcAdbi4RgaEWX5u5KTQYZwBMk1C2	14446	20342	20342	1619600760000
29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	29321	3NLaSAWV3zLcb4qwLVfjQ1TAWpXwHGrK6qcXzSY6ayTUauppHSyg	519	519	575	12463	18974	jwcQJrLJkmcRZojGLL1os95VccQQDoZFHMRcFbxHZZyLvMLfTvs	14450	20346	20346	1619601480000
29327	3NLfo25Wk8KRUwv1J1dSi9f7CGyZhDt9xwEmnzHsq1Lgmh4xzThv	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jwzGsmd95ctq9igTnNkZWG815yTCaRF9hykPX3Dq68f87XuabNM	14452	20348	20348	1619601840000
29329	3NLpfQ6u31MPdZf6mHm77Lw7mV18tCrB3piGJ9wfj7W4xq5KKKyc	29326	3NL5cdcEtxUmNRqM9S1xpw1tSiyC94ikJzX5kVM568WtdGPmJU8X	1403	812	575	12463	18974	jxQUzGsjdphK1SDSGL8hmaFLPCirRL6yvanBrFQ38Xq4eGjMmYt	14453	20350	20350	1619602200000
29331	3NKwjMKpr6cruhfPy8WmJ3SzBRGTCGRC96tRA6tTeA9YW2CDMZjM	29274	3NLuZZ16K3NcW4RevA8jtfKoYDheUyH1Tm2RXzHxk1ihEYb6Yq4z	1648	1284	569	12463	18974	jxX3wJhSHvFoZE5RwoBG8ZvRQysd1rs29bqXpVKLmhjEmeNQPbj	14304	20351	20351	1619602380000
29334	3NL6pwgse78uCA37aBeEzUnDgjJFGyTwvwyWRYPkv53vV5SE4mkB	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	1407	1395	575	12463	18974	jxHiHi3yqV2AQFQQmTkmmRPKZczyNYAQZvefbBbd23QRw2WSAhW	14455	20352	20352	1619602560000
29335	3NKcpQVbzPN7ESXrrxgqTehbBATuvXrpZJN4ai4xzm9pq5oMJKue	29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	1406	1393	575	12463	18974	jxubEJCkzAh2bAkrJFG7gacmrSp6fkFLaMfzjWT9gKnMEYzT99U	14456	20353	20353	1619602740000
29338	3NLiygR4Mt8jNrDwsGw27smcJHBzWceG1BgWXB5qbySLcYrKh9Hg	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1405	897	576	12463	18974	jwRmpNwWmCbcb35KbHUQzPQAbHSUTzhuhpU9FQjKP4B9DouYmnJ	14458	20356	20356	1619603280000
29340	3NLS7qtw3zo2JGduKUqXS3mNNPoBkyt54EM8krrXaspkigwhnZAu	29338	3NLiygR4Mt8jNrDwsGw27smcJHBzWceG1BgWXB5qbySLcYrKh9Hg	1403	824	576	12463	18974	jwFxV8dftvXcmtEEZavjdS5MGTKA93WubGzQS6Xd8KD7w1xwx7u	14459	20357	20357	1619603460000
29343	3NLRyEwJFU3A72CtrSjeY3izNSG2Nt1iWHmgYy4BKxD8Ux4rnqLy	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1406	1393	576	12463	18974	jwjfHCpZVVBRq4th57TGMohvSnuFfG6pJKkDcEYdgaFRdEcCPZq	14461	20360	20360	1619604000000
29351	3NKMWkMGpzfAkHZ2mWJU7DnEvSfbCAurFmCBur5L3HjE8BveNXum	29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	1425	184	576	12463	18974	jwmMJVSFPwLTTN2ppaekiGAdD3gEwwYhDxcMC7ToaSMMdvGDaCJ	14466	20367	20367	1619605260000
29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1448	1311	576	12463	18974	jw9zGoQ1CKkaJooTvBTiDAGvhQeEsE1DGgbyVSgNYLoVfhj23St	14468	20369	20369	1619605620000
29357	3NKAAsMKYnji4QBzsp42B9Q68KWiZdmZ4hRpw3JHDigPyKCzayBL	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1590	1300	576	12463	18974	jwy7PNzwxvn5wGDP5YVow4P6JMCp7kttKmC1s31RRm8boiedFWT	14468	20369	20369	1619605620000
29363	3NKepb6uSLgStZ1pLzfhQGWL34mgprc5RsKAo4KvyQjt7nz2pJ9T	29362	3NLQGPVfkuBMLmq3r2jUuthSN2AvejraaNmRCUZwdfFQPMv3z5KU	1483	1276	576	12463	18974	jxCPzRddcyU4p7SJN4EpLAQ9BgZKwXiNkJPrgQ5sLnb5knFdGN4	14471	20372	20372	1619606160000
29366	3NLMdi3jR96DSXbbUJeZnGhZuaemr6zoisrskhW8K8YvsAvYEVJ1	29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	1451	1046	576	12463	18974	jxkz2cphG89Pi4BFQoiwcQy6mo4uxHQZY9ZzLKTJVKfSDRohKud	14473	20374	20374	1619606520000
29368	3NL2RncViKf85SWJbX4x12JnbrHHRxoAJ1voccgzFPEftgwdWP31	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1402	882	576	12463	18974	jxZ9q2vYY8nRipTFjFencxxnwPfNepGGRhnAHKakSRf6hFBi5Vx	14475	20376	20376	1619606880000
29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1593	1100	576	12463	18974	jxLrd458pQBxfjm62FtBQgpPeSRpH5NVZLtvpQVCAMB91QDow3e	14475	20376	20376	1619606880000
29371	3NKo7yZoJ7yYRSRWosJw5FvecQJHLYSdDbBPpN2cXwYmSgnmHYHK	29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	1483	1276	576	12463	18974	jwhMtCxTpBGwzzYmNWwSGv3GgTsaxCZFt1QvPpzJddGRnRUA9rd	14476	20377	20377	1619607060000
29372	3NKBxtiaqJTc5S2tMttW5CpCA81ZZL3ViJ3FBpfRgm2Z25EBNf7g	29370	3NKYbyheErsf5BwRZV1tgbWvGu2SuXfV9CerupVseZWT9yDXzt6f	1407	1395	576	12463	18974	jxp6uqp699n8WAzmYBS6QReQiGHaGMJ3Rfw8D7bHA7ZwHYkNSM6	14477	20378	20378	1619607240000
29373	3NKfqvvNucTMQnZrFiFC7VSfQLLQBukMGiZZyYU73X7hTTvK3rsJ	29372	3NKBxtiaqJTc5S2tMttW5CpCA81ZZL3ViJ3FBpfRgm2Z25EBNf7g	1522	1196	576	12463	18974	jxnJVmc4B4hAiPWKi84TxPjL679M2t7HkCJAyxPzVjoRJ5CecYE	14478	20379	20379	1619607420000
29376	3NKnFfFXX8bUVjXNVSBqjFWCpTXo2jQThF6EYMFwezon5FJ5YSd4	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1406	1393	577	12463	18974	jxcmJr5c31e1GrkEYjiqgsXaBXU2c2wKNyz1Jd9JBvVHpr19x5Z	14481	20384	20384	1619608320000
29378	3NKnWoJw4ESsrjTgEcb1QYL5A5kMyTz6pME6idAaWNbsMsfwna3c	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1419	814	576	12463	18974	jwbuGyHXt5qiyBwAAUVMw1WGjd4DAtZhuxeGZXgcj2jKRjXM2ek	14481	20384	20384	1619608320000
29384	3NKLG7NCYJkxKZYqf6YnjJiCbcpFk7GBj7FvxhPVikUHSY4oCPPS	29382	3NKJ1inVzMvkVrD8pTQ21F4KrtfAwzQhdxkGKPcxC3JcZ5g1vU2N	1403	824	577	12463	18974	jxn1yJJF4hhXGvJs3aSQkQL82vsbUwBCs6SqtTdwb3oiQqEh7Yj	14486	20390	20390	1619609400000
29391	3NKD9jYsB6oJNXczkbH6HXd4WyNBGoMx6JA46sofMSnWkFVqRJ4J	29278	3NKWTqQv1dHuvdxGjENHyB2smjS3wUpxsMfmQoTMUxEmnRkrn2CP	1516	1294	574	12463	18974	jxvgDD7cGAiMq6zW6KzqjAEXpkGjP1ovosMJ7u1Z7JQvr14RAwB	14406	20397	20397	1619610660000
29397	3NKNC6G7VdRp3EzrWGW4QbjNZWf5CQdfw6QkJAJvohvdYgWPoHY2	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	1440	1131	577	12463	18974	jxBn7K4tDSzYtQoPNUhnr6yB18Hrj4ZvnXHCm24xDHXfMbyq9et	14494	20401	20401	1619611380000
29344	3NLnSvog8rndVXHEPQX5xzbaUMHUg458W1UDuSQpuF5oBW58WRg2	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1403	824	576	12463	18974	jxXz51RPQHhadfFHGsinFjsqiCLg5o1vRvmctF5HsvZsbiVvSKd	14461	20360	20360	1619604000000
29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	29343	3NLRyEwJFU3A72CtrSjeY3izNSG2Nt1iWHmgYy4BKxD8Ux4rnqLy	1637	816	576	12463	18974	jx2SYJfcQ6o19zDqtFGmkWxhVS8XTS6md9gkLwcgjuFCxmD22jS	14462	20361	20361	1619604180000
29347	3NK7u6hENafikNrcSLprnQEpLi2JSW1y5jEuTJtMBPfxMTnG4ZtX	29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	1617	1288	576	12463	18974	jxkiYcgnWjNyRsB3KtCz5UcDsHkENXWEGS2qzTmQSfaaLnxv5kr	14463	20362	20362	1619604360000
29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	1619	1149	576	12463	18974	jwRPd9QMk6xUTTmocP4vKtsxSNwXC5T7spz4EKwAUyAeRHDgts6	14467	20368	20368	1619605440000
29355	3NKcFnEw3FTK9ighYsEkyhwwa8qFGeU66pmB4zUZN4AqySc2UifJ	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1448	1311	576	12463	18974	jy3DzHKhCT9NivrkZV75H7PcQVwaUrVevgpubDnF6WFQyygzmBy	14468	20369	20369	1619605620000
29358	3NK5dosCdZUJEbKW1KyEbBg29gTfTqPUAvVVbHYQK252EkzTxJQ4	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1646	1354	576	12463	18974	jx7it7Ve9YfzHqyuck78CoTCfVwKnUDrsCPay6rCrWfHy5uU9Fi	14469	20370	20370	1619605800000
29360	3NKwbhGLwAn5Y3mxZgEcKSq7ctRj1DiEF6y14GQoNzffPVijDYVf	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1646	1354	576	12463	18974	jxHiyY6emMmuBUWmwHX5y1w5BamfC8jrCFyZ3SdtF8LkDVwojLx	14469	20370	20370	1619605800000
29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	29363	3NKepb6uSLgStZ1pLzfhQGWL34mgprc5RsKAo4KvyQjt7nz2pJ9T	1670	1036	576	12463	18974	jwpwj83FGzGhQzqYLwNhFxYzwK4EjkMMM3HeE3UnpkbExajWPEn	14472	20373	20373	1619606340000
29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	29365	3NKd9H42xT9yaeBKYv2fg8qn97KbiXgSCDW3TN52A3EVKGNpgrtH	1619	1275	576	12463	18974	jxMaKeuzhgkNFdq7mp7dhmra5YgfboRQ1bT8S9SsgUF2a4h3ypM	14474	20375	20375	1619606700000
29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	29374	3NKWU84f41MWAod2Un4pFEuVhw9mDHRzMupsErqPrNd9C5vRY6TS	1403	824	576	12463	18974	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee	14480	20383	20383	1619608140000
29377	3NLW1P3Cab6pYo74RC6myKDfvLVcexrg7iNVe1BHmUapTxjhZezK	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1419	814	577	12463	18974	jxH3n8ygVVEJRgjYESySRNAwnRYb4a1oyB3wEnNsRd5nA1pcaEo	14481	20384	20384	1619608320000
29379	3NLTUg7DeAn3Lk69XD5NtidGtcTCdGBVG899pwdncUyr1vS6EkYU	29377	3NLW1P3Cab6pYo74RC6myKDfvLVcexrg7iNVe1BHmUapTxjhZezK	1637	816	577	12463	18974	jx5AFzWtPB8wYvqSHNxEmhjjDngZ9GwbibtgF6A83g2N8aMhurY	14482	20385	20385	1619608500000
29382	3NKJ1inVzMvkVrD8pTQ21F4KrtfAwzQhdxkGKPcxC3JcZ5g1vU2N	29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	1577	1081	577	12463	18974	jwaTiNF26a4c96K1DGQZUnUUHPQHd9buSfFJRqaJ5tUJ5As8uki	14485	20388	20388	1619609040000
29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	29386	3NLp2HCyupsJSfLNUiGLi2tD5ZB4unLNPukqSioB9SRF5E3he85W	1637	816	577	12463	18974	jxbBoqSuWBcLeQpSPCLChnAH9zgQpsPQbdLX1otY2gSewP7topV	14489	20396	20396	1619610480000
29393	3NKDuQycEyEophXcuDoAY2fvquKhq2xbghjQwvwdjvKpo2FmdqTg	29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	1405	901	577	12463	18974	jxyjhNXnmKWbfWQeJiR3yGKfhwtUX7L5WEDpoxUz6iQcNgQJt5t	14491	20398	20398	1619610840000
29395	3NLrjey8DUcynD5dj1DxB7tD3DCKa8bCxawuWJExXpAw94Cxkq87	29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	1402	882	577	12463	18974	jwj9Gx9c6AYeaAvNf9Fje3x1SbS59rYSWy1cSNsTvHJSK9ZmaKn	14492	20399	20399	1619611020000
29400	3NKXKEDVtXUaQGEDeKrk66Jt2bhPrt3SSxfHgwbA3uu3oN2vHMap	29399	3NK9krJkZgpBWbg9dit8NC8XM9B6cryotjUEimCtrM1dz3wVXfNj	1439	1279	577	12463	18974	jx4D5hgzRoXqjAPdJi2RpbWREswiwcptnNBYUfrioMSoe5R7HmG	14495	20403	20403	1619611740000
29402	3NK4N8qqBDb4E7CQD8EkBrAmrPnyDX13XijT8Ai61JioZjKLdVYN	29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	1419	814	577	12463	18974	jwAFmXCa1QY9DzvooQ498zQg4C3AxArckeovyKt8iE3HRH95uVX	14497	20405	20405	1619612100000
29404	3NKfkcnyBvTjKmgrAhCbkFNnFU1h8bzrAW4qUteHtb2qZJCHc9PT	29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	684	1106	577	12463	18974	jxui5Fn2QwyWmXNy4Uq2YxnaRUrPQbiLLzHdcBB8v1VVLtnJH4R	14498	20406	20406	1619612280000
29406	3NKUFDThmpoEdtUPtWBH1fNjqeZ9piQF3yfx3eznjqVpUtg669oV	29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	1631	794	577	12463	18974	jy2txVn1nPTBRc92JHmep3Ct8gv1V2dddvM7JmnbcmHWWiabdk5	14498	20406	20406	1619612280000
29412	3NL2UzeHA6QVYfDgjdj7Bouz1GUVdYDDygmn4sHiQnT1gK11F6Ep	29271	3NL4bKJhuS2NJ1pqzsMbxvoM3ykrxypBLozxjxNRUeDRpAfBRKDF	1455	1332	567	12463	18974	jwbZXYSztMyTSjVQFtSUPvwEBc3aeJw2jT8Qn41QY5nXR3LHMTz	14249	20412	20412	1619613360000
29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	44	1325	577	12463	18974	jwKh1jgeS7tiZxU1wirkB2nmSyDeunUA8xQvUtTckX8uCrVXswD	14502	20414	20414	1619613720000
29420	3NKs9nwSy7Sz9bMmpWker5C3gkeTmLmwJ9qsryKJevYXEW9M5AWn	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jxC4PhrL9K7ARVwK1Ag6qBzLwUoRisXX6UJpRAkr34ca1KZgbjw	14504	20416	20416	1619614080000
29422	3NLDHTMbopjZzMdjFQCn9J3tgeeu8BYfz82Gpxw7ss8mGbhosnc9	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1457	1265	578	12463	18974	jx3jWhtZQ768dbcpFDoUtDwgGzLnNJbJk4kwBazhcLtCAxDeL4Q	14506	20418	20418	1619614440000
29424	3NLmcbhr7DWN7ciLqxRfD5wXbFH4v7CzPwVERYd4RAgdcTvu8jJZ	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1407	1395	578	12463	18974	jxt4Fz8ZRFGbphAqNhf7pBcvT4XkeUbXoygNmrYEWkv9v3Myjci	14506	20418	20418	1619614440000
29436	3NKQbQZ2ZaZ9ae9XAUS3RTEwPi5uWyh1hehvotQH7TzKiWAA6vGW	29435	3NKbbDmcEPfcFQnaYhEbNssNz6YX2RDaCDeFSYshebv9iH4bnCTo	1507	1154	578	12463	18974	jwpBA6YpmZX5vWM8WWkCkqDUyU97VrtwJ6WpVuaB19HyecFWDM3	14512	20424	20424	1619615520000
29440	3NLMouWJp8gjArUgnzjrtcMgQGmpsMzHMQWYLeJNQuHxY31qNjE1	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	1447	1345	578	12463	18974	jxJXiModPyYEeftqZDXq9PVSZ7G71a9u6q2JgmjLAUBBEf2J366	14516	20431	20431	1619616780000
29442	3NKtuJupCnm19t1x5TrLc6UeJT5H6M71sZXVkMWcdH6rUnyJjGQ9	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	1407	1395	578	12463	18974	jxE9N3zAdeSzjrjE1u9qpzhikgszviBaDaLSt3TFWvbR14Suhen	14516	20431	20431	1619616780000
29444	3NLmxf7YGBKrs9iTRAuLZVzc1asBKw937sG1Z832mbnVS91dneUZ	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	1624	968	578	12463	18974	jw7FPNesRVPVnamfrBMgHfwHZURN8EKuSdCtBdtJgSVkoqLNm8h	14517	20432	20432	1619616960000
29446	3NLivxHoWtZ9xtWVBsW11szVSAsQ33znvUMuqUaYqQPR18cLJULZ	29444	3NLmxf7YGBKrs9iTRAuLZVzc1asBKw937sG1Z832mbnVS91dneUZ	1578	1050	578	12463	18974	jwSJEDRyvSBgyhgeS3X3o2tTATpcBAqiT2WsZNSkta6WUiVD3DZ	14518	20433	20433	1619617140000
29449	3NLUBntMiqoMEkvevRjrT67QKmYTbUnHtV6bb4xTGP9Cq6nGfhXH	29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	1542	938	579	12463	18974	jxZaHAmGEH3mmmeKgsb3rRPQkfis26UkQ8L4Rn9Hz13DWWwGVEx	14521	20438	20438	1619618040000
29454	3NLG2E8788dhqyZLXWNS3saovr1Rd1wfkaeW6mbbmPh8AViFEPah	29452	3NLqDoyMyDBWrqpYYqfudRCzQCGXh3NY6MZEMThFMuQtrgdQKPRZ	80	1273	579	12463	18974	jwVu75B7KyhBaV4Z8HmpHk2rcwoR3dSgR99zpFzfNcSD4pvHFP6	14524	20442	20442	1619618760000
29399	3NK9krJkZgpBWbg9dit8NC8XM9B6cryotjUEimCtrM1dz3wVXfNj	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	632	1016	577	12463	18974	jxqghTvC66bRpZGbVBnghoz7tUSNAWFjyeQPx6X2N66vTCaLavR	14494	20401	20401	1619611380000
29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	1622	1356	577	12463	18974	jxSWK2YuvpPZzcQC5S8hvUeAdxcFc839yHpXdjEnNkAmUZYczyh	14500	20408	20408	1619612640000
29418	3NLTNtvx9rkq1n8QB2R6x236MrVMpDktw4JXc5G2aZisFbXeCHSP	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jxr2TeY2Zj3BT9s2aPDCSfNBwosijCkreQLFtXi9mht8j7SKMS8	14504	20416	20416	1619614080000
29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	1631	794	578	12463	18974	jwXTV7UBYmZVVvpCiZyn5ZA87mSCKVXRkUyjMzaNEGUYzqKXZja	14509	20421	20421	1619614980000
29430	3NLQAaH1zy1UtwmAWfxE2VQBRb9t8xBDeLjrs3J753dZuMgFmvMb	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1406	1393	578	12463	18974	jwekUD2xpoy6286ZMmcXGx6ugj95voZi3tQga9cBQXAbn9TQ3EH	14510	20422	20422	1619615160000
29432	3NLwZevDHHtCQ7cYEzN1D3eF2147b97QYfht9TkZVLFXXm5oW6i4	29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	1668	1370	578	12463	18974	jwRtWopcouJHovoUG8QJrxig1DjU4uwGk5svSzzAyXSuFJMXAii	14510	20422	20422	1619615160000
29434	3NKJZSu2KKLuGDpVwG1XX3MyPEjgn5pvVyQrEfBFUTpZra1Xinfe	29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	1522	1322	578	12463	18974	jwi3RYk7bzFEFq2JDpN8X3fwPczjSNAbYrgpXci2MtHJxicGLuD	14510	20422	20422	1619615160000
29443	3NLH18z4c1kfGTwxyYSPLXkGKy4h737PBSTSUzKK9HmpzFSz7kC2	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	42	1115	578	12463	18974	jwUjct4gLmwwmkhjTGatGb35Axykq55HQXJ7MgrszHLLPub45Fy	14517	20432	20432	1619616960000
29445	3NKLtALrXwQCCPqqzGYotxeLBrs3cgCsAqwTqANciv7pMVp2hDuk	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	171	1374	578	12463	18974	jxF7c2oGMfBCwz87CJ6VkFsckHLSVK3nSma7aiuyY73umrUbwcP	14517	20432	20432	1619616960000
29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	29447	3NKENnchUQKH1CxArnrWZ1TDQBCVxi6MVsKsvBDSssuywfLA97iM	1637	816	579	12463	18974	jxpYGseQ9qq1yEaA6jWPhLV1R1J8XxnLjYssJJKGq8iCXJRceoT	14520	20437	20437	1619617860000
29450	3NKekZJWq6yKaYj9s4rRdcz9LmNAxj9Um7agV7soo4rjEkKGBVvp	29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	1542	938	579	12463	18974	jxS7AGZyMW3CzNb3AynSCQPWkFUgpkpr4Cru5wFU4VQ1KHptwSM	14521	20438	20438	1619618040000
29452	3NLqDoyMyDBWrqpYYqfudRCzQCGXh3NY6MZEMThFMuQtrgdQKPRZ	29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	1564	1092	579	12463	18974	jwFg6DHwz53JixrDVsD8kH8coXn3LMDADiUJgf2W3P1BijKvMZD	14523	20441	20441	1619618580000
29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	1503	1031	579	12463	18974	jxMuhvJQrTsVDmdTzL9g6pJSgefrWfAK2Qa1AHXanLdrSnbCihB	14529	20448	20448	1619619840000
29466	3NKwr9FxtHhAbT658cntvN4xVHHuREuZ9sJdusrosTES3mnap1b4	29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	1501	1114	579	12463	18974	jw8SziZr45khWFPve4Awrj9FqgXB7pUqq89ekw98YjkKoeGMcrR	14530	20450	20450	1619620200000
29468	3NKRa7L3JdvZ3Y2Ak5zJyijcP7HwkCBz84SEPaJGCM3fkMsudbrB	29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	1637	815	579	12463	18974	jw9bAoXgruLVu2drggGBNxFmrMLnBjx3dKKeyAvWjkrGHgBLQw8	14532	20453	20453	1619620740000
29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	29471	3NLh458BtnBw2y5QeBYVTWpjWxevq9cwxNuP4GVn2NZrqtaSBT3b	1402	850	579	12463	18974	jxRp68J6CqxLmT7aKcj56A7S8pPfgippuasCKBCRXyhdJ5nUYKa	14535	20456	20456	1619621280000
29477	3NK9eVnqrcpHXV9pFGaQhUogo1sSgD7qg1hTFRgtiyscr4oGQvnv	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000
29479	3NKpbQdN3Uvgi1sxrxQiPJtHWrihQzYDKmwZBSrgav15QyCH66LN	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000
29481	3NKad9gmoBaJztoo9R4r23V9edqVf2PQhfCp2RP7hNXwa7FQpKRn	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000
29483	3NKRM5oZtsWNBsq3Z1taNGVgBNVWnezCZnW9cjWegZtvDmp3xSVF	29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	1406	1393	580	12463	18974	jx3huzmcwNbgYNPM94xeAkAqs96EaARMbEBrN7rjaHyyX7amJkC	14538	20462	20462	1619622360000
29485	3NKnqWU6aS8tAa9Kfo1SgjHrmxyaZi8C3yQgTjwEfQXzyyNuDmN4	29477	3NK9eVnqrcpHXV9pFGaQhUogo1sSgD7qg1hTFRgtiyscr4oGQvnv	1483	383	580	12463	18974	jwXwzxHuX3Tco2xo1zqohcZoKiBUHJUqhjCs9vwB3vn9Zxf6y6o	14538	20462	20462	1619622360000
29486	3NLdDUS8KjyYEfmyBFCwynYb4n23gmruPxpSr5FrrADtofEorSJA	29485	3NKnqWU6aS8tAa9Kfo1SgjHrmxyaZi8C3yQgTjwEfQXzyyNuDmN4	1647	1302	580	12463	18974	jxL1FEji5dn3tR8SFGtDCRWJpkh5DnwFzm1uzpDfZBKr1JCebcQ	14539	20465	20465	1619622900000
29492	3NKSzdjidDTa9qTV7Vq3scG1punSi7UZHq96JjYNDwiznLbVYHYE	29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	1406	1393	580	12463	18974	jwwpUs7WEBX5gyxhPKsFFpgcUH3TzroqkrMA5YFwywegCCWoJ62	14543	20474	20474	1619624520000
29494	3NL1ewtRAfYhCPxzjW869aDkUcnD62yvWLZmKS8hgDSCHbYFK9XW	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1422	1091	580	12463	18974	jx7VMAwWDiWTCHu5ZFXdALxuXXEJnzU7onnCWUn7M1266gBGcwq	14544	20475	20475	1619624700000
29496	3NL1RmNW1w8PgRiBc7Sj885Wo28zijE1huv4ujFKcc6k7urPHtZe	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1541	1298	580	12463	18974	jxFsEh8A5ACAXsAbAZaMmBn9A6JVpccnKsb7xi2QwYRAoAzqcWy	14544	20475	20475	1619624700000
29505	3NLVzdgzq7eLmHqo2Cjft6ZjtC1GwwChYAUDw16fAsXTR4k3R4Vc	29504	3NKkGbB9LU1EpXQLmgXM5ELAJzbN9ueoKaHKEZt9TQGrZawccvZn	1406	1393	580	12463	18974	jxZeeZz48jjJANQJxQKjAEj23v1SmnY4jpeUg6fKznC23qb3XaF	14551	20482	20482	1619625960000
29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1522	1322	580	12463	18974	jxagTXLbnhSmpFpCFqCdZGbAiVub9Jr5XzrC7BQMWrtvbpnbyg9	14555	20487	20487	1619626860000
29512	3NKTmod7L5hn345QMQxWJX4NBVh6n5yjzqLXQAtmFii9REHWmrAG	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1419	813	580	12463	18974	jxp7c6wowkjhfDgbKX7FsJK1Wnp9PmXw6gU22UjeFuXPrNFS9Fa	14555	20487	20487	1619626860000
29514	3NKjyaMnkgvnnSdB7iCUcdY8MuMEnuiC9HfyCrigrjET9TvMhzYt	29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	1407	1395	580	12463	18974	jwsGxmNftd3EYxNrwxUivkf3CZU1YwiLx8wtaZLLn4jnNWfiDZP	14556	20488	20488	1619627040000
29517	3NKoJCSbx7J5tnU7UG9ZBLLKMcSYvbjmEQ1XuKw2UV14LbzNyVrF	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1672	1039	580	12463	18974	jwZ5vSHaDWkF1b8XFLStVFWqgoSVpoZqjwwtaVF8HaoD8RKJDxD	14557	20490	20490	1619627400000
29521	3NLhadGY7ZUG6DFaS7WT6rEnoxm3wMf2GWakyHtGHMdmmWW23zL4	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	152	1084	581	12463	18974	jwrnRpZF4tXdyr4mLacJqYWAqhH4cRyNMtH1nshBFrZ6yBYApT8	14559	20494	20494	1619628120000
29526	3NKCksyjwq9sqryuTSHjMAcD5YqAaidMbWabwNPZtrCPRUVduTKu	29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	1407	1395	581	12463	18974	jwFwRss6sUSuTKDhiEQUUdFVggzrGdiyaT7GSgeDHjhJ88jAhja	14561	20497	20497	1619628660000
29408	3NLEAT34MzkQn1prtP7HXQBW9gGP4TvZDtJQczoKGENq4KyMvC5E	29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	1587	1357	577	12463	18974	jxuwqXgdw4z8b9Kv3bfdhVwseNndAbUpVopcc9uxCBV7L5gHTGk	14500	20408	20408	1619612640000
29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	606	1049	577	12463	18974	jwtSBawJfE7dHXwyPtfyARbmtkFC88J2cUCV2iqiuNFMsB1SZBP	14501	20411	20411	1619613180000
29413	3NLsinr13bKsg7FnNjCptH6Aj8Cy1P5AmL2Fhkz8pF9BioTPou4J	29266	3NLVqk7Y8oMaQgYG8JzsXbR9cbhfahmvPY3qCQ5o5gCCD3FWqX2j	1481	790	568	12463	18974	jxt4xspUMUQ6CpxPxezf3Pu84aCy3J9CK3d8eGrxDQQKFkNsjQd	14310	20412	20412	1619613360000
29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	1460	1324	578	12463	18974	jxEYwAz6Gn9RUqk1f3Aow9bUwxuq4mwtHdHmM8uSRx1keVLpF5L	14503	20415	20415	1619613900000
29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	29419	3NL3aV7JeEjATFSXwfAyyfvXaGV7MuNyS4a5Ren2BN4D3Bf4xHR8	532	1303	578	12463	18974	jxQmkkSWt7bTrtTZEss7kuoF9eM2zBT5uw2Sm3rL5zKc2FAt1hN	14505	20417	20417	1619614260000
29423	3NLwS5UkXJkh2LMMatdvL3yDNbLVSVBxwr4bQXaVEYA3HK6mXg9W	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1593	1100	578	12463	18974	jwYACcgydCjvMdQfTVRKa99HvLgx74LzXjem58iERWrtFdnPHDD	14506	20418	20418	1619614440000
29425	3NLWjL7haXGHT3fdzZpQwbSdfCv5UeV5ha2JieqX1no7j6ZNDSmH	29424	3NLmcbhr7DWN7ciLqxRfD5wXbFH4v7CzPwVERYd4RAgdcTvu8jJZ	1406	1393	578	12463	18974	jwrEr4CSvHv9d9YVutBHJtnRN2eyaqq95MrFRtCdDHTJcy9jjFQ	14507	20419	20419	1619614620000
29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	1587	1111	578	12463	18974	jwehGNDbJCVMV6mpauBhVwYSvmgmKUK4WcVAnnjqjLpKpReNVra	14509	20421	20421	1619614980000
29429	3NLB42QJ5jZp4w1vpfE8mfayL3jHdAgAvFrYg6ewnqeQfmo3sWww	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1668	1370	578	12463	18974	jy2E6iBb1xnVQBAkGx7LcMom6MaztU9Dhixi6s7RvTmsX9UKCou	14510	20422	20422	1619615160000
29435	3NKbbDmcEPfcFQnaYhEbNssNz6YX2RDaCDeFSYshebv9iH4bnCTo	29431	3NLCE2yZd1XMWMyYeBiFvQVXFa2ujMuybYVKVX6aNPSF93LwfXGg	1594	1326	578	12463	18974	jwgNY7DGTtBDz35JJfGMBFs7FpotDAiM2udiui5x6jCdd69axRy	14511	20423	20423	1619615340000
29437	3NLt9w7j5Z8B6434UyUbZaXHJsj3LC4HRA4BQ5kYzoDuxqzk1fQJ	29436	3NKQbQZ2ZaZ9ae9XAUS3RTEwPi5uWyh1hehvotQH7TzKiWAA6vGW	1422	1337	578	12463	18974	jwnnQSmLukBHZwJ9VnaN72ogUTgKsEM4S4rMxSYafzoaMfRbM6g	14513	20425	20425	1619615700000
29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	29438	3NLDc1gK12Siuct31K3jnGrTRFmVVmf8xnAFHmynqebXYRE1ceaD	1445	1044	578	12463	18974	jx8i2kgaK36JQBNoAfhH4eNjE6f36CUeHqEvcbc6222v4i59nZ1	14515	20427	20427	1619616060000
29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	298	1062	578	12463	18974	jxyfiNqAR3gLjsYPKCDbD1GkWkMLcDqkuWGfJfyUjQNKtS5LiyA	14516	20431	20431	1619616780000
29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	29449	3NLUBntMiqoMEkvevRjrT67QKmYTbUnHtV6bb4xTGP9Cq6nGfhXH	1609	1087	579	12463	18974	jwsi4ygm3TZL6s1R4hyFV9CZimKpuse4qnLp6jHxxh3KCbsmTzw	14522	20440	20440	1619618400000
29453	3NLDNKUS6a1cvYZyeN1FiLS8okM6qc13xT29p8ni13apbLwcR4kA	29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	1534	1317	579	12463	18974	jxKZX1FRaw6aEMmiQuUfg5TQVT9AsF3LyyqivCdCCENB3Ry9Nur	14523	20441	20441	1619618580000
29455	3NKW7nNoLnXy6GBbKNVENq4KJSYS86Gtf5HErY6mu3nY4VK4qUhe	29454	3NLG2E8788dhqyZLXWNS3saovr1Rd1wfkaeW6mbbmPh8AViFEPah	1675	1096	579	12463	18974	jwHhnq7vbxEvW6B5qXkah532ngYHq3REkhiSa2RuobMHArccJ3a	14525	20443	20443	1619618940000
29462	3NKwK7zRS3DZKeTSqwNYtmyF72kYsxeaRqBr3f8fGiqVLdagHkSX	29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	1529	1190	579	12463	18974	jwH2qQLiKvzrgwrsQYotK6JBtre2xGHaunuH8nGGyqJP8cLyXBK	14528	20447	20447	1619619660000
29464	3NLq5mFtq8j88aUhGYC12h9UXKoG1un16FmRcnG8sRWE3UYUHcpm	29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	1623	830	579	12463	18974	jwtRoGZmNF5GeVa1u4Perc1mjYi5KG8EXeaVvCrAuFfLmvNHjoc	14529	20448	20448	1619619840000
29476	3NKukmMoaof24pBH5rZeSNvQxCcU3RNh9wNrUq6AgXrpS9ZF11nf	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1622	1356	579	12463	18974	jwVuf2z2pNmt28wtGn7MEVvZma4iziyDR5anBgGkrtWycqYrsNM	14537	20461	20461	1619622180000
29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	29486	3NLdDUS8KjyYEfmyBFCwynYb4n23gmruPxpSr5FrrADtofEorSJA	152	1330	580	12463	18974	jxuuewvtwGg7R2qoAXpAaByMgcowQAvQwAJHTLansVz28LpXaPz	14540	20467	20467	1619623260000
29489	3NL6UpaXzZYmPSfhtTPTPfMDdFtMa7NMT5DWT2dHgNk8NMC1fLES	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1407	1395	580	12463	18974	jxcyqKcCzCwJfvD3iHghtkirUXw5KibpEXMhaCK3PRQN1xn1WNg	14541	20469	20469	1619623620000
29500	3NLWApfZVHFrekR7s12oAwgBK7VYe4ajeV3tUKkJLRU7NKDA9JmR	29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	1406	1393	580	12463	18974	jwd2E3CvHWcyjXZTwEZm4pDwy1qUxHgN1jw8RbfutVCrATXbEpw	14547	20478	20478	1619625240000
29502	3NL3i56r8eccgmbVKiX5xfjoeHzwkcikdHahxku8wkDiz9qk92iP	29501	3NKmHBz4RQwE8Zvddzv16Hromb9aWtweMC9aorMtr1pbNKsBUAVj	1656	1343	580	12463	18974	jwC5K7eXsLeU1MmAv954xmHCE66aBZrHC4xe4e5Zhf147vGmBFq	14548	20479	20479	1619625420000
29504	3NKkGbB9LU1EpXQLmgXM5ELAJzbN9ueoKaHKEZt9TQGrZawccvZn	29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	1407	1395	580	12463	18974	jxeaWL9hQ3kqCqKCrgL7bY2QciyRxJuDYPpwwF2dEEeQq2tCdLZ	14550	20481	20481	1619625780000
29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	29505	3NLVzdgzq7eLmHqo2Cjft6ZjtC1GwwChYAUDw16fAsXTR4k3R4Vc	1406	1393	580	12463	18974	jwJsAVUfTWAPSnBAjCFAXAoVwiCAZtiWXRv9nJrnzozgRyhfQwr	14552	20483	20483	1619626140000
29508	3NKPK2479cCbWz6ZkKa5pt21LnTvyBugokPc6UY8zTZJZBA1Y6Ac	29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	1440	1131	580	12463	18974	jwbTDp1pYLCRYURwZvL9wCRRQ2W6rZYJ6Cj7VDsvXUV6jqSfRvn	14553	20484	20484	1619626320000
29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	1402	34	580	12463	18974	jwMCLgnxMrXhzHLe94faGJa9HDGRD5xz13WKrrbRD7TvxyrxVHF	14556	20488	20488	1619627040000
29516	3NLWZHeciQJZ8ZCYesZa8KJC37KE4f4DyGADxtVtkwGTx64Ujyg8	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1637	816	580	12463	18974	jxn9GhEURpxjLEv5NCp5DrKFrQaR8R1qA3LbNqsgEFktFrmFCm1	14557	20490	20490	1619627400000
29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	29515	3NKFds7A8npnpxBXe4vGgUYF4EpSDF28aCCqxSxt3BbW5ohPjhFr	152	964	581	12463	18974	jwEpToZnDtVqFkLxddHJZVeE9YpLe137bRGy4R4xxrVVSoPEJBX	14558	20493	20493	1619627940000
29523	3NKzq4FsNVX9ZiQJ3hxL3dgjQVh5TxuZbQrgukdki456EZaUGvy3	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	43	1310	581	12463	18974	jw9nk5LCmari3AQY276HSMiv21bqVmzvvwidCoDkfokBQkvYdpK	14559	20494	20494	1619628120000
29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	298	1308	581	12463	18974	jxgm93oeGD1Uw9G9ui1ebBQMmvaNZr2bms2hTBgNMsxXR5XbDzz	14560	20496	20496	1619628480000
29537	3NLR8A1E8MfH8CmJkacS1SqhgiikTc4FgWymEb72rtXj2X2NWX5x	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1637	816	581	12463	18974	jxRb2NpU4UGgDzAZ1dkaGx1szQMvYL8MMQxAM5nMWsVsJqB2xP3	14564	20500	20500	1619629200000
29410	3NLpikT9FTgTdvi4JTSfXVjunuAKEusxEMg8gAsJf9d5x1MWLndG	29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	1553	776	577	12463	18974	jy1nhRAKfJs1uRNWo1SiAxZgu4N3Pdope2FXAaDEvs8iMAVQWSR	14501	20411	20411	1619613180000
29414	3NLVz4rKfsMwpJ6Bn16TZxwtYk7NroxQ998FVwfYG8g1mudtgui2	29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	44	1325	578	12463	18974	jwSSZxGrR9tzN2HVe7x6eVdMQssGTWdcRJWtGS3dCwhkZY2nBxP	14502	20414	20414	1619613720000
29416	3NLZmDEQaQqMfvdWm8WfBiDsU3v8zHMmriyR3hXrF4noWE9X1yjG	29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	1460	1324	578	12463	18974	jwzperPppNjBV5pBV2j6vf7n5L9XxnwPNS66DiDT8u2Nb5Cra4C	14503	20415	20415	1619613900000
29419	3NL3aV7JeEjATFSXwfAyyfvXaGV7MuNyS4a5Ren2BN4D3Bf4xHR8	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jwbiGdj6kvkg6ZsmriJyJffQ7BpTyqRUwLSWiKfgwwtXuPL3Hch	14504	20416	20416	1619614080000
29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	29425	3NLWjL7haXGHT3fdzZpQwbSdfCv5UeV5ha2JieqX1no7j6ZNDSmH	1550	434	578	12463	18974	jwTBFw9FkqHRWxwdAvwKyAVhogV2ijKSRRxwYq7PrWLysYv3iSX	14508	20420	20420	1619614800000
29431	3NLCE2yZd1XMWMyYeBiFvQVXFa2ujMuybYVKVX6aNPSF93LwfXGg	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1627	1259	578	12463	18974	jxHGCsPrk9BZfm5ne3P2NsqSSBj9YWDoqjwjFsvZjLViyzeGfny	14510	20422	20422	1619615160000
29433	3NL6vYYHhNuGu9K1D3xxodt5tH1oUk8Zd2TGN9k88S1uYYVoqCvY	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1522	1322	578	12463	18974	jxZa37GAzvVHGkGHK22x9n6U94aF6NZgRxGBKisq7jGvJChE1JJ	14510	20422	20422	1619615160000
29438	3NLDc1gK12Siuct31K3jnGrTRFmVVmf8xnAFHmynqebXYRE1ceaD	29437	3NLt9w7j5Z8B6434UyUbZaXHJsj3LC4HRA4BQ5kYzoDuxqzk1fQJ	1673	1122	578	12463	18974	jwvwbYubMFespjg5jVC8iL2YJAFCDWaWc3DfdX497RjFpiYZiDa	14514	20426	20426	1619615880000
29447	3NKENnchUQKH1CxArnrWZ1TDQBCVxi6MVsKsvBDSssuywfLA97iM	29446	3NLivxHoWtZ9xtWVBsW11szVSAsQ33znvUMuqUaYqQPR18cLJULZ	1673	1122	578	12463	18974	jxrLiTfG2CLF2VzdKhwsbbhY9oAAmK7jj1t6JoyczxvL7Nfkahe	14519	20434	20434	1619617320000
29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	29455	3NKW7nNoLnXy6GBbKNVENq4KJSYS86Gtf5HErY6mu3nY4VK4qUhe	1553	776	579	12463	18974	jxAEsq9aDoux277bz4T9YNZNy9L2dudpYgydJiyop2PRRszjs5U	14526	20444	20444	1619619120000
29458	3NKTEHPfKmKP3EVPiiSpRKoM6kf4bYi8J3ajMBfmrZK5CMyjUNtq	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1596	1363	579	12463	18974	jwvuDBMD7Cu9xLPGhpXSdJMRwsyLpzVLpnyVswmPGG6h5fnByeR	14527	20446	20446	1619619480000
29460	3NKtG3D3KfJE3XXNs97KEWZxSPTAf3mYsjmr1BWCESbhJcZZB7q9	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1541	1298	579	12463	18974	jxh8mNSy4r7k3RGn9gDDpAX9Qoqk2fHUneivCgS85XwyFkmhVQt	14527	20446	20446	1619619480000
29465	3NL6G4pN5nsM43Xc1tga4fKHjjPNjfjeCAgmcexveUSZWmvQ2J8Z	29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	80	1027	579	12463	18974	jwyfahncMHsVrX8tJWdAX1hxrx352aWCZd1kUQb2nweQwi6kVEA	14530	20450	20450	1619620200000
29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	29465	3NL6G4pN5nsM43Xc1tga4fKHjjPNjfjeCAgmcexveUSZWmvQ2J8Z	1483	205	579	12463	18974	jxNaxoXe9YmwArQ2wdCxrds4LtWSwHMuvbmj6Jb2j1kpKe8iSkB	14531	20451	20451	1619620380000
29469	3NKxQ9gTygfznVJHZozNjvQwvkKzjVUeGWDZWBLssjM9o5BrnRoJ	29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	1407	1395	579	12463	18974	jxQafmTYQwuQcqcURhwBv4uxjyGqfiMhZ7aDzQy8o5Q2zBA9V6b	14532	20453	20453	1619620740000
29471	3NLh458BtnBw2y5QeBYVTWpjWxevq9cwxNuP4GVn2NZrqtaSBT3b	29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	1406	1393	579	12463	18974	jwjWUvjKY3Es8zkUS5mf6a8Asf8RjU1anaTmvnS8BG89C7GRyMi	14534	20455	20455	1619621100000
29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	1403	786	579	12463	18974	jxoXtNnPgKFW1bifZF4g5VWRDiPTaPWopCFs3DyRMU62Wc8vQFT	14536	20458	20458	1619621640000
29478	3NK5x6Cpws7uzbRiszZqZLGmY64r27UxXQB82NjKBCJaXNMASHTq	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1622	1356	579	12463	18974	jwVuf2z2pNmt28wtGn7MEVvZma4iziyDR5anBgGkrtWycqYrsNM	14537	20461	20461	1619622180000
29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1405	861	579	12463	18974	jwf8ACZvhUUyGEFtQvz5K6PdkpnsWHQNid9d1xidfj3q1SJA3ss	14537	20461	20461	1619622180000
29484	3NKiCUEjJhEzxW7tNtBhWX51NK768vkLcDCcM965Qapx9t8Rr75v	29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	1483	383	580	12463	18974	jw9frcmVgAAs85wXuMLgMCjv4sfi2QKvGPe19z1BaKxdwdvg2mt	14538	20462	20462	1619622360000
29488	3NKspaSYWrA1rhoM1wrNchNnmXmhvBcC91jH6wPcrUyxyPJkUo8r	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1403	782	580	12463	18974	jxiEnLYaR626RUwsaYWDGfrkak2xZYSSwQ7wVPcUcEVVkxuf46B	14541	20469	20469	1619623620000
29497	3NK7WzNyN3LGQGj3M6a5TMWF5QKiC6614bni2TmAnNTcKR3L6j6J	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1541	1298	580	12463	18974	jwkuVn8X2d2LoxZNwpyDEgpANVTxTvY5zp6qqEbMNk9Fs4J71S3	14544	20475	20475	1619624700000
29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	29498	3NLcYJ4qRZU9vgwjCesiX42n3zcoWysZXia1q83BEWD4a6uAo8bY	1607	1348	580	12463	18974	jx1BtF8QhRDhexB5PtdPJDjHbohrtSdV6iAKkwagzzmrmiDSN9z	14546	20477	20477	1619625060000
29501	3NKmHBz4RQwE8Zvddzv16Hromb9aWtweMC9aorMtr1pbNKsBUAVj	29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	1407	1395	580	12463	18974	jwyyyCo47GMVk7BXGHioTcaqVzz39n1L595TBtf9V8iUb3sPauc	14547	20478	20478	1619625240000
29507	3NKi3jSTHtJvYgbeLKwmxkVYdAVNxgxxzcw68wmiUNb8fMvVF7j1	29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	1440	1131	580	12463	18974	jxtyFpNBqgxrWXNQ1ne9PRQQwTKLtRtNfmfTv7t6ctu1aLtdmAa	14553	20484	20484	1619626320000
29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	29507	3NKi3jSTHtJvYgbeLKwmxkVYdAVNxgxxzcw68wmiUNb8fMvVF7j1	1670	1036	580	12463	18974	jwPMKWGFffHw7oAVxzbYnzVTVX11SPjaFLS9fLoghAs68UBCvat	14554	20485	20485	1619626500000
29515	3NKFds7A8npnpxBXe4vGgUYF4EpSDF28aCCqxSxt3BbW5ohPjhFr	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1439	1033	580	12463	18974	jwnHUSjNYvVKYpFtK7gqDA5BDqDJGQ1XNyF1aNdmcTUwGW5ureV	14557	20490	20490	1619627400000
29520	3NKNP2xuPSMYSCNsmwmFYbKeLCvVTMvLqvV75XqT5nqAYi162cRH	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	1406	1393	581	12463	18974	jw8Q9SJajBFijPKnqsGnSDfAJmHpU9Wgv5eBiqfBYiTTAzBPjMh	14559	20494	20494	1619628120000
29522	3NL9KpLXLyFZxoNVLB55g7AFnvgNHcZKesPEa6TuEv1ywavZj9Li	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	1564	1338	581	12463	18974	jwxjRw8uEjQzaBtqoPw69BX6o7SkNmbcBfL3GCCeF7njnU1VjDo	14559	20494	20494	1619628120000
29524	3NLmH4UtByk1W5XuJ1bVbdUMCf4CiFTCct9XDnxv4epKRM3TiJfo	29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	1547	1378	581	12463	18974	jwB5f2mrbDfDzxKgxHfyNxMwth9tU8gDcyn7Uqi12yoSZiNu3kt	14560	20496	20496	1619628480000
29531	3NLFPcZDquZCkDhTjHJTRXUsZFDyZkPwG6jfWKxcQyhbPRVzsToq	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jxFMtVqiprkBNLhVxgrQ72D67L8URKyesRXGv8RbBjqsAe8jxkQ	14563	20499	20499	1619629020000
29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1549	1236	581	12463	18974	jwvmziXUNBm6DwzWcn7meiAvQsmoTroAPQ3AK2pV4A6QZT2pnaF	14563	20499	20499	1619629020000
29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	42	1235	579	12463	18974	jy25X4BS898qKn6hNVknETWNZXtx9q6wSMaEyuwv7LnjBihCTS3	14527	20446	20446	1619619480000
29459	3NK9vf9cNGiF13hs56Utwcohx28Vfuhvg9HDM62jCe8vAu8Hg2gK	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1541	1298	579	12463	18974	jwfoXBFncEu7D32e4W44S8xZnE2idx386buqMycV2ADnXtmwMU4	14527	20446	20446	1619619480000
29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	1529	1190	579	12463	18974	jwK8isndttAjTXhzpZNQF5sEkSCJQzVN9tnCCqqNqYVbZJ5AhBE	14528	20447	20447	1619619660000
29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	29468	3NKRa7L3JdvZ3Y2Ak5zJyijcP7HwkCBz84SEPaJGCM3fkMsudbrB	1631	794	579	12463	18974	jwzJ54dgLe6N9tb4JsbgCfGigoRKLLftaFmr2wQ8YfcQpSGVmaY	14533	20454	20454	1619620920000
29472	3NLPEAZYGFLug6RhWGsXcwiC8zP1hUHnUzpuAy3BreH8JRtSrCcU	29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	576	1355	579	12463	18974	jxKsJcp1RgoCRMTKjZUoZCFmzJCotkBBq4G8rSyb1dkPoUqyHi7	14534	20455	20455	1619621100000
29475	3NLc5AA4CYR8163sCywtaTWCsjr8Jntr6R8EfrEVV2vNfvPUvcVS	29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	1596	1117	579	12463	18974	jwShA7r3tpsFKCdg1fqGU9kn7XfumZw4FfLSeoZatPDF6SXtHvw	14536	20458	20458	1619621640000
29482	3NKNi9UPjBfuVHQxRBU8om55hWLywCUxn8BvEeFpXaKu9gkQnMhF	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	641	1090	579	12463	18974	jx7L3QFz2ekyD2AFS6tGbmHGYgr24AMFv2osLi3Gbwxb9VUj2WP	14537	20461	20461	1619622180000
29490	3NKQQB77z8s9gtk1drs4ds51XKMQKXzwuX8pnphDUCSg5tfX7Zy1	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1611	1341	580	12463	18974	jxqaCsJyHMX1a3EeoajrQ4sCProVY7BXpdL4Enk2mpPGadvN5Gw	14541	20469	20469	1619623620000
29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	29490	3NKQQB77z8s9gtk1drs4ds51XKMQKXzwuX8pnphDUCSg5tfX7Zy1	1672	1159	580	12463	18974	jxkVUKuuTnwpAQfTAG5qY8jy7h79e8jBvHZ2bjB2PivmfGz7RF5	14542	20473	20473	1619624340000
29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	1600	1006	580	12463	18974	jwNManLeD8oyARCpp75yKqcMz24u74jXZMFnzBch4k5hsUzBX8i	14543	20474	20474	1619624520000
29495	3NKq2d6QhMrrztQLmmpVwPfnwPPorHe2dcxszifaSB7GS4YMBhhf	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	58	1035	580	12463	18974	jwCivP9qZsNu1ex7wZ3n8eKg6eHx82SgE7KGeo6Rk6dSwy6WxzS	14544	20475	20475	1619624700000
29498	3NLcYJ4qRZU9vgwjCesiX42n3zcoWysZXia1q83BEWD4a6uAo8bY	29496	3NL1RmNW1w8PgRiBc7Sj885Wo28zijE1huv4ujFKcc6k7urPHtZe	1581	778	580	12463	18974	jxWEP8GRThBCFdD5U6eNMUkkqWfB3MH5NSUB2Z1AFGChkMQSjnG	14545	20476	20476	1619624880000
29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	29502	3NL3i56r8eccgmbVKiX5xfjoeHzwkcikdHahxku8wkDiz9qk92iP	1610	1314	580	12463	18974	jxUpYJzcstDR8V988ZdwGmsZWTZngoFDkoQGCVuRmn1Cc6YP3QJ	14549	20480	20480	1619625600000
29511	3NKJwEx21dh3iw8sLvsXmdSgLYqVohuf6ExWrZFtLCtxgQiKqf4V	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1542	1304	580	12463	18974	jx3ttsVymofpTjc5eqXLhCBQgnPQNW2t6W8fN5WD96QFuearBDP	14555	20487	20487	1619626860000
29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	596	1180	581	12463	18974	jwitee3KND4pbzHdC9b2nJg2tYTTzSEdLsNkNGRskJamoc8yS39	14559	20494	20494	1619628120000
29527	3NKr3tYGPHQaBpiLs6yoAAp2fnokE3QxbqBq7WeGeBGRogYmDnBy	29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	1623	829	581	12463	18974	jw7hfHZvBjUkUVVx1Vcm6yzkLejBVUydKF79NEHJ5deWG17ckHD	14561	20497	20497	1619628660000
29529	3NLToFcRTLpMjLqW2yPx18KWKrJoEZRss5pqDznjPQamGiBrTTid	29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	1608	1043	570	12463	18974	jxdWmd8Tz8Ggi4zxcwCC7qA5y4vBYSiUGBBPuyivNucERn43cRx	14341	20498	20498	1619628840000
29546	3NKFcd8r1kwczw5Tb4N4GPmpZMdJCsF1wE4FDpFV8oqkZhAHJgcA	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1564	972	581	12463	18974	jxEnUoW4P1eFv87FjcsiHeKHHpZCZTijCGdDN7gVKGouF8vwPnu	14568	20507	20507	1619630460000
29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	1585	1366	581	12463	18974	jwLZ3F9ZUG9e7wWCMyVJzVBtjRjMV21k4eCfLWHjP3bE6MBysoD	14570	20510	20510	1619631000000
29555	3NKwtGS3bGftja9MXaYQBRNq24vJPLe5okVdV9ADkAMvH2Ynj3Ua	29208	3NKMxF7Cj2yJSjH1SL6Z49UHYCTMxjtXfcDyEGBm6PuWYGCxUzVD	1513	1379	572	12463	18974	jwChZqCfwjw5ZUnxgBXaRKxDY1scETzehaiWLHfCeoh4ywuTaMS	14362	20510	20510	1619631000000
29557	3NKS6Jqw1k1Zbr8cSyg9oHXS3Ja7x6W1iG5B544AEjHMnxh9SDyV	29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	211	211	581	12463	18974	jwRMZRTmNWjSwYMhxnFt4qNpRma2xYw7UVmaci68U6nxR6RK81N	14571	20511	20511	1619631180000
29568	3NLdZo8c7d7mcrLxTen4HKvaC7exwWw29aCHvraCKXDdKLyCi95v	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1405	867	582	12463	18974	jwBjPfp4mNGzPq4tMT8GCktBCymZNfJc9gKmBjSA76WghuZnNvZ	14578	20521	20521	1619632980000
29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	29568	3NLdZo8c7d7mcrLxTen4HKvaC7exwWw29aCHvraCKXDdKLyCi95v	1649	1383	582	12463	18974	jxaCWBuy8EkA1B6H6f5SExwHQa1hsnhR4qQ787XjQxchb5iYRd7	14579	20523	20523	1619633340000
29572	3NLvCc65qH2jRqCJdcZMQ3PnhVyuhzcEvgjHWQKVLXPTd1fKiuNJ	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1483	275	582	12463	18974	jxypFSSuHbosnLErgkCJESBM8VNF6MVDxUJRNWjRt5MG8Wb2gGb	14580	20524	20524	1619633520000
29574	3NLffNrZToPxv3ZoQAC52r6hgwqbCA31Bg9zW9S6HnwejRPeZXon	29573	3NKKY1fxkzSvr7xR2suyaKYdzkzYjonCYNr77WYwAGYzEkUeMN4c	1553	776	582	12463	18974	jxxy8ioyN7YNGxFwLdBY5wjBTDfoUu3NqdgEkEf7apPKWmu21Hx	14581	20525	20525	1619633700000
29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	29575	3NKw6QxBHdtKrMEaDJTXU6gx37Q9wKUgy3snCjf4eotMrTzDgbuV	58	1035	582	12463	18974	jwn9WFdqjiAjhAjHQ1JVaE2kW8UNZcsrWWpqgLKqw1hhvkXgA4y	14583	20527	20527	1619634060000
29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	1599	1287	582	12463	18974	jx477qa9tfjabfVeEKAVcrpZCR9zeLiXkoYBj99b9azYhC33EQj	14587	20533	20533	1619635140000
29585	3NKPg8m2KKDHqMBDF3ycQbvBX8trDU8gXFQrjqobngiKvYP6SDUc	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jxE37mZoKXFv88PJ9z5kJgp7669yhXbdwvDCNYXDdBDdnAYMtzL	14588	20534	20534	1619635320000
29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	1573	1192	582	12463	18974	jxs3kH3bWf6WytbG86uD1udDJXbfWVm9iAH5cxMGumkRmMmCrh3	14589	20536	20536	1619635680000
29591	3NLeLCzTTyC2MPYWzNbiLnHdphrxiAsXAFgyUCeDrHvZkDcwfgRM	29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	1553	776	582	12463	18974	jxRMbVCy2kowtpLTynnVM9mrWqxEXaHB65BdT2qbHpiciARg5Um	14590	20538	20538	1619636040000
29595	3NLCBj7USiZmA9KrshLuDHpdSdXi55voRzSuczThM6DzWMwLtThq	29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	1483	266	582	12463	18974	jxnTicCW6hWa9FmxxxwRiNBLesrQGzfteQJ2LzFrNLxMuQ9nMVy	14593	20545	20545	1619637300000
29602	3NLqH86dWmmBNEDGMThHk4JJ5Z48JHGR3rbZ1eagxccpoV7RPrSE	29601	3NLnyh5cDZz2hXYCYA4rn8YU5u4JMWPx9D2cXsHFrHvHZC5AKPjN	1631	794	583	12463	18974	jxygbc6LgqbFGeiTqEzkxHn5y1z7SgA3xzbGVhf8Q3ZByr4t76y	14598	20551	20551	1619638380000
29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	29527	3NKr3tYGPHQaBpiLs6yoAAp2fnokE3QxbqBq7WeGeBGRogYmDnBy	1608	1043	581	12463	18974	jwTZqs6LaBChnGoDocjjeky6jSmTLnHiLBvNTy7QgPYTRk2ksxq	14562	20498	20498	1619628840000
29530	3NKXSySmVB9XNAsCYESWuubdtqWMaprN85Xa4iMntjzKfvY68AFb	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jxEfX1iLPNm46Y8n68yk8pXcD8XdPzCaQUVDgcxC6VUk5GdyoqG	14563	20499	20499	1619629020000
29532	3NKiuQtgR3bdAfKvtwEjZmg4aD6UPcV1RvWan4jy3ggLYa8BZezm	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	149	917	581	12463	18974	jwtPU9NX28upN3pE7ckkFZnMGqq4So8wd1nZB7RvZijAybthvhx	14563	20499	20499	1619629020000
29534	3NKukAeDBRhd4vCZd3JVvUf4x9abMBhn4bj4Zu5VnFXKxCcbYsv4	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jx4QPT7t2ebxmoNvG39N69LykgMR2zr2HK7JAsr84mXpzdmR2Xi	14563	20499	20499	1619629020000
29536	3NLMUgcoCTe1sqm7yfc7L1Y2iu7iaJebGaKvJShrji1rbqSLv4Ca	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1610	1068	581	12463	18974	jwecURHeRMt8KKDzzga4PhNDGBrxpr5ZpQMaWw6LdvwnqkVEwU5	14564	20500	20500	1619629200000
29538	3NKqqcUrKw7A8swb43ijTWrtw8JCBzsQfkeBCQdAzY5cdDwN655n	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1581	778	581	12463	18974	jwaMUH3pLU5gkWQ4LhUdKyDCZqyyrvPbHHzfurLtWUGrzjDqfqS	14564	20500	20500	1619629200000
29540	3NKqsbQWrAdYqKvac2FtR48bfZFXGqRYF57v7ETbdYgdB9uygzUi	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1610	1068	576	12463	18974	jxDPo8nZDHzPfTyWjNDphPM2RwJvNcQq9suT4oRGQZwnQaa27t6	14475	20500	20500	1619629282165
29548	3NKP4UvDQJaqVn7qpjwTHeWfh8WnzFQS3yXRb9VUGYqYehAy8at5	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1406	1393	581	12463	18974	jxDgP5iHidSGBxQYMLR5AETgxh5xZnwqmcLqDaEHXGRnC9doN78	14568	20507	20507	1619630460000
29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	29547	3NL1dmAYEVzd43whyF4bZu53z8cF3GVHHjkjosS9MimtQMzeBvK5	1403	824	581	12463	18974	jxE6ZKShwTJmnGjuE2kcXZxAUeQUbzo31hwSzsPsabSwTJQR1vY	14569	20508	20508	1619630640000
29552	3NKAdtDQaeFLmmY12xEEY6QjSsCqJc1YpEtyMXL12LxPoSo6bW2y	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	532	1057	581	12463	18974	jxPRhAabT8y3fY1h9rZCYT1DU5FYbomkNKYdj8F5zv6nSmvZ7Vw	14570	20510	20510	1619631000000
29554	3NLhcdmdJH9YnwxyA96hupazTurFNGjBwnGmsbfuYmVWGpFt6hH2	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	1407	1395	581	12463	18974	jxqKUpP7xQrGEvL3Qc96m4oxQQrhZKvkNax3VJWsP9s5wqSyucP	14570	20510	20510	1619631000000
29558	3NL83Ua5nguZaXc71yEzm4PEoznEaFXbJLLA5dXrEQCCkbt98J6Y	29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	1406	1393	581	12463	18974	jxo7B9sztKWGKpdrMqSRyWUpLjhordA5Mcoc2LBaEepF9eUzWqB	14572	20512	20512	1619631360000
29560	3NL1mbRzXN1sDNRgc1rjaTkVZX6DDPuDxe1YCZW9LNtwfBz74yYG	29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	1507	1034	580	12463	18974	jwi5mXxgGsreXUQ8jvbmQbDWdcnzNSxcrhktjLWNTL2GzbdGm7m	14550	20513	20513	1619631540000
29563	3NL9RDPzx7VEFPbYCXaUUQ66BJRg1hrqf3EtcffAh6qwG4hgNqmH	29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	1588	1266	581	12463	18974	jxRQD7acmddScwyziVakEGTdANWGAmF25Jx2C15fdiFMgtvRyHW	14576	20518	20518	1619632440000
29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	29564	3NKwnF3VSz2PtqeyHUqkPENhRmjaokjHEgPGsi8y9oeq2GAsobTo	1444	1381	582	12463	18974	jy1TTpibQC1oNTFCrwQ7qj9pgjWxvTw4jJebaqpkSZM7E2nAhz1	14577	20519	20519	1619632620000
29567	3NKy1oszaPPJC3oZ4cXJQpHjggG3zSwsa1t1xzYj7qQq7nojNGD6	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1642	1367	582	12463	18974	jxS1QajCf33jm89hFPXbRcSNec5xHNvoYTigZAJNFPDHmewqZZu	14578	20521	20521	1619632980000
29575	3NKw6QxBHdtKrMEaDJTXU6gx37Q9wKUgy3snCjf4eotMrTzDgbuV	29574	3NLffNrZToPxv3ZoQAC52r6hgwqbCA31Bg9zW9S6HnwejRPeZXon	1624	1334	582	12463	18974	jwgsU7AeBkJQVjAmRj6uqNPyx3MYH2A3AnopcuKWwddt61gZuiR	14582	20526	20526	1619633880000
29578	3NLm2f7ywXZKG3jcjTNNimdBk1y4HcJ4L47gVeVzjX1W9pJ7EHmX	29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	1448	1311	582	12463	18974	jw9XiwXvnnfy35jRYNAebb5b4p76zEbSGjyTJjiPtFhAdXSzRzz	14584	20528	20528	1619634240000
29584	3NLPT5KwFUQ5WLca3Cj2ndiX4fFyf4d7MRgZfkC1MeNAed2ac3Kc	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jwqyknucHfj3tCGiojmoSM6dxaP9mgNAbQmqBD4p2MKNHuTCw3L	14588	20534	20534	1619635320000
29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	1536	1187	582	12463	18974	jwdxtSUYA56khxXTKLErdMzpbYoTTJfwr7NFnUVD8xkC9jUE3S5	14590	20538	20538	1619636040000
29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	29597	3NLDxNfCSXkpSWUioyRSCMHjn58iEzhtTriJ1r9qMxcmUqTN6ckx	1581	778	583	12463	18974	jwsFJug4kpZsa6qRWLWZJfHDMBHekGitfQBqzVUqjXUKj3c7CVV	14595	20548	20548	1619637840000
29604	3NKBBaEaFBtSDjs64BgwddpeRjr5D48aRQbJKpayzGAvCzDofH3J	29602	3NLqH86dWmmBNEDGMThHk4JJ5Z48JHGR3rbZ1eagxccpoV7RPrSE	1672	1285	583	12463	18974	jwQ6Dt8LYz3mhnZy9UHW3X7wtAkqf3FgtXBEAEV9pe7bwvDDkqe	14599	20552	20552	1619638560000
29606	3NL2P3ibPGV9gPCEdBjU16UuugxvQrcWU8dTrci6zmkxsy4Y33bK	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	298	1182	583	12463	18974	jwH6KucgfxQCJUCwMeevXA6aE6goptdvdLPTyBFQ6M8cTpegYmT	14601	20554	20554	1619638920000
29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	29612	3NLQ1XdRxxvZ7qLUnxQzGKW36V5tUUhnWg5cuMNK8e7HNgJRWpW6	1581	778	583	12463	18974	jwq6kQhh3AF77dGbxZw1bBStPj7QCXGwQ7CRoYWioFZkNA7QU1G	14605	20562	20562	1619640360000
29619	3NLeiAaSpH9582U7oQqDeHH4DzWJMp6GEbQuknpCiV9kgxPHS4WG	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1506	598	583	12463	18974	jwpqGzQdBfMnTy7feWguu99xvDmgb3wmk1LsCsYB2eWiNQRbDZd	14607	20565	20565	1619640900000
29621	3NKaokZByvUCetuEJVKU8UzpU2XeR4hvMxpK5R2oV7Cw8JcN3MFj	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1406	1393	583	12463	18974	jwfpdSPGPv97x4VgASkpjaLrzWGkwwssNSZi7QhwTftuFyq53Ug	14608	20567	20567	1619641260000
29623	3NK7bUk3KzHm7WhyT8WptNSX1RbutBBuAZrdGjr2BrsFKeok3Ve4	29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	1649	1257	583	12463	18974	jxWNxwaUhzPHV2s2Yf8JPKGBM39PC38sxVrQs2FQNhd1Uhm3v3x	14609	20569	20569	1619641620000
29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	29623	3NK7bUk3KzHm7WhyT8WptNSX1RbutBBuAZrdGjr2BrsFKeok3Ve4	1474	1329	583	12463	18974	jxV93xDVSLKd8b4JSrUv8HaS3UGA4gT7cFotGjQzkMee7EpAGNH	14610	20573	20573	1619642340000
29628	3NL8HuMjnDvidLDaiE4jM5ezWm8MZgXc77NRurJkN91EcgcmDSBh	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1407	1395	583	12463	18974	jxgZNfRGqrrtJyNtq7yHXQqA7XKoj5fgmsP45zPuktWTeesgwzk	14611	20574	20574	1619642520000
29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	29629	3NKhTZ2dVHekWbqFGaj2XvRUxdp5rRGMeSkG84PuWhwNHLiandKZ	1406	1393	583	12463	18974	jxmYdpaC5GoAyKTarheY5op4Qrxik6rJACj74isUvd67CErTweJ	14612	20575	20575	1619642700000
29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	29632	3NKmNGi8QhwJFrMmZZhUHYhqk2zMdrBqF26RzX6DVSEghopTefVh	1624	1334	584	12463	18974	jwcpYSVwRriuiH9eSWxeeq5Dxesd61oB3zU5jiai2GnkBwyq2jD	14614	20578	20578	1619643240000
29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	29635	3NK6oWoprogNtNWeFEWhsQGDgwi8dfQ9ABeSF12HPKWCxoGv2yC4	1406	1393	584	12463	18974	jwbKSVJMj9jBP32dk1hSNPfevxVV8yrRnjHoBcgpEo7h7L9xTXb	14616	20580	20580	1619643600000
29535	3NLcpN1x4HnhgXJ9GYDuAjAWyigj6mrQ9cQd8Phh7hSTGmRMgpDp	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1610	1068	575	12463	18974	jwPbG1APqhYPWHfdNnedkJzC6bcy9LNER5GeoAinjwDjdiiDovv	14441	20500	20500	1619629200000
29539	3NLg4ob9VkFqAbGR8SpCYciAJEgAMTDXTCbEDr3c4i6N1dPAvifP	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1610	1068	575	12463	18974	jxrHw76A2FgF2fpEigQa1US7o8NcvGscwEECpBcoayLNtnu5sKL	14458	20500	20500	1619629241815
29542	3NLhSRrEZm3PenpCm91fbB8PiqUK3wZbYH9t4j2Yje2fHUfKCzFT	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	1602	1369	581	12463	18974	jxjn3VvhRjfkM5eETxDSiPni48XRuMQn32mfKVn2hUHHgTLA1MF	14566	20504	20504	1619629920000
29544	3NKQgzRCXaQ232copghGcpC9Q8HYH1FxR3sUEhoUfKYLwE5Tw27b	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	1553	776	581	12463	18974	jxTXQnS98gLN3s4xbeRhNonx5NYPzVuM8w25Pr8CvzPj8EUCY6q	14566	20504	20504	1619629920000
29547	3NL1dmAYEVzd43whyF4bZu53z8cF3GVHHjkjosS9MimtQMzeBvK5	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1670	916	581	12463	18974	jxGWRTDTGJZm6o4q1niCWTq5TTRaMEV1uGj4kJpW7kFoqGSNHB9	14568	20507	20507	1619630460000
29553	3NKcoQwiYmeczrv7hHNU3194u6wuLjNVdwuUXM2gLdKVzAqhD8vz	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	532	1057	581	12463	18974	jwpBRrKuiyJGNCwHMxyjgkXFxqyietgaBc3Rkbp3DykLqcB9sW5	14570	20510	20510	1619631000000
29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	1536	1187	581	12463	18974	jxXcsFnMTeuxJcsZ3yytfpnA7Ba8UtDWctKpzf27fG5pVrKZLyZ	14571	20511	20511	1619631180000
29561	3NKyejZb4sZQNZZ7Ctm3Z5W1oNYbtnsgwqvUSssFf43hkpa83Z8Y	29559	3NLiJMFc1nyTKuKDCH7TZ4Gjt4dGHmJrH38GvytRuJp9X5DMcKd4	1546	1339	581	12463	18974	jwxf5SvQ5vu9gcqMYatAgB9rz8A1FeUmXsG9mCX1bRWrh2J2QvR	14574	20514	20514	1619631720000
29566	3NLkyrkyb89Lr5i1CTN6Exr9fJbSGVMRRBZMPGYdcrmvngfAtgkb	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1467	1130	582	12463	18974	jw9E4QYjT2z2RsyB6eV8z7dfLfzqNCsmbjcBQh86AbxqnpfhgTM	14578	20521	20521	1619632980000
29577	3NLBNJKfuEUiZqEZpPK2pkpHE5ZXNkdCUEoX1C5ZmmkcRLdM8DdK	29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	1448	1311	582	12463	18974	jw7J9MDTAxLfA8fnev47KavVrCRkiqsiwVzRQYz5MyMvpHo6dB6	14584	20528	20528	1619634240000
29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	29578	3NLm2f7ywXZKG3jcjTNNimdBk1y4HcJ4L47gVeVzjX1W9pJ7EHmX	1648	1158	582	12463	18974	jx2kmQAXB8NHLbEYwnPRHgjvckFLcek15ymMKauG1wHgy6547z6	14585	20529	20529	1619634420000
29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	1407	1395	582	12463	18974	jxvoebskGVWfrdjBZNCpQnsVZxaPnqYDaicu89MSuFbg5AXyZKK	14586	20530	20530	1619634600000
29587	3NKvQweJLtHvjTpsFeLbt3cbr28YMb5fq9PL416Rb6UC5ggWKVaX	29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	1407	1395	582	12463	18974	jwnBKxJr6MmcW1ioiemCMoYPBjtAcxhWCvq16W9SMjXfqFGowkf	14589	20536	20536	1619635680000
29589	3NKLJWfmP8wisPhr7SmPkijMwve2zx4igRc2j6Lv9JuGt13wFWPU	29555	3NKwtGS3bGftja9MXaYQBRNq24vJPLe5okVdV9ADkAMvH2Ynj3Ua	1513	1013	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14363	20537	20537	1619635860000
29593	3NLSQTFPimdvQLwM58WViEmFfxjGmuLVfepqGxNgin8SgJasVHRV	29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	1601	1142	582	12463	18974	jwA2ZrzYAk86oTBidt2jDbcfvpmvTFa7wXzEupRJcGGacA5p8TP	14591	20540	20540	1619636400000
29597	3NLDxNfCSXkpSWUioyRSCMHjn58iEzhtTriJ1r9qMxcmUqTN6ckx	29596	3NLvbN8oY5LPk9E24PcWyuEiXcMNRGUnWhqSSTMECRnJPsiVMBid	1406	1393	582	12463	18974	jxEFyfiUEZ6ocNTo3dk33r4jBakgDBLmctWYgEdpmbKQh2JA6Le	14594	20547	20547	1619637660000
29599	3NKAMwGB7LeAqJ8j4kHXdCbRwto8WGbi8EHTU4niXgyC2L7YjvwF	29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	1619	1275	583	12463	18974	jy2mvj4M6Esz6EuqmsVKXDZ4CzN8vbcu8fDUiUqy7xLy6hDx8fT	14596	20549	20549	1619638020000
29601	3NLnyh5cDZz2hXYCYA4rn8YU5u4JMWPx9D2cXsHFrHvHZC5AKPjN	29600	3NKBYTiTAoahiofRgnPi59QYzUuAfcRqftzRSy5RqFKQit676Rdc	1613	1103	583	12463	18974	jwkKLUYAGkK2zCipU7UQfKTzKYhTgKNUvsYoqNQAFcc12tmArZ1	14597	20550	20550	1619638200000
29603	3NKNQsUmu1pHb6YbFoXXTKC9haN7e2Eb3XK7P1QVvmAFjjvEqr31	29560	3NL1mbRzXN1sDNRgc1rjaTkVZX6DDPuDxe1YCZW9LNtwfBz74yYG	1507	1154	581	12463	18974	jxB2FaThpjqzN46pqTZ1UzCoWN6ZrAZoQxRtePhueQYGojVVvpp	14551	20552	20552	1619638560000
29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	29604	3NKBBaEaFBtSDjs64BgwddpeRjr5D48aRQbJKpayzGAvCzDofH3J	1445	1290	583	12463	18974	jwYtVLCARnvH1ivVPiWz7tuycgqvjPhP9zhqV1XRXFcfT4PfviH	14600	20553	20553	1619638740000
29607	3NK3kNSQcPszYbWvzPGgdJGfBKorKphDY1gDmcBzXeUQLFXAWv5b	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	632	1382	583	12463	18974	jxKGemXsqZVEBp6n6WJg4BC56qVpnudcCRpqRqkjh27t8Uzq6WY	14601	20554	20554	1619638920000
29609	3NKoQXicp3xNjdMHeEL69R3QeGJmdP1JyM2er3cjaamsV4w2oGP3	29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	1588	1392	583	12463	18974	jxx3cNvupSwqVz7LioeaybYECPnb9dLvP57y9JEed9gBC9S3DPA	14602	20555	20555	1619639100000
29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	29609	3NKoQXicp3xNjdMHeEL69R3QeGJmdP1JyM2er3cjaamsV4w2oGP3	1616	116	583	12463	18974	jxQCJaJq9zGbMm7nsyHcGbH1oWCeGf6suaKXtM9bkRS7Frd1KSZ	14603	20559	20559	1619639820000
29613	3NK9jkWUksSzkSRWCpkmQv4KsuWhJh93E6jXDUqNFnk9NArfowR5	29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	1405	849	583	12463	18974	jwXh4kEjsMLkZLdoZGnkPYriLwrris5KYSUvpdLxsfj6Wz1BG2Y	14604	20561	20561	1619640180000
29615	3NKLUoiULKhdMi8yC4XXAKgc6r9sVQxHYUmboUN3uYU2568JytLT	29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	1500	1051	583	12463	18974	jxdCgecxE9Fbx1XoDwFL4wKrLEDZqVsscsaPL8GyG3u32WHohcS	14606	20563	20563	1619640540000
29617	3NLyYgmXD1CbS7EoDit5ZYSxefDvTh15cXKcwLrSzT31akKcRhfm	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1506	598	583	12463	18974	jwymg53hSw6z3G4dof322WiWgmaq8aQwCYbEcL2unwmcdEeH3Dx	14607	20565	20565	1619640900000
29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	1406	1393	584	12463	18974	jxae81zivzKD492NhB2mXXtZ2L94kKqaRMgkLCRj6PFAQ2zo6q6	14620	20584	20584	1619644320000
29648	3NLmPsuHCfKpJwuhWozVNKLaJPDRUof812P3ocsGKw6rB1F4EtQL	29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	1529	1316	584	12463	18974	jx1eQxbL7e5aNVBAmLr1aTaQqqJcdggBDgXcttcFtccmbZfpnyr	14621	20585	20585	1619644500000
29651	3NK4W8QE83SG4CSqC3bXzbFfwpTv4TLJwPPLZP1dJLyDse7BXo6U	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	606	929	584	12463	18974	jxCwnD3aiBvcoPwqL5Uq3Ki5RSGhaANtvmP7iqu2paUcKuG2inC	14623	20588	20588	1619645040000
29653	3NLwF6J1yNPy8CtWwesH78MuRiLhHSZywEgQpUnjx6B7ckA2ZTTs	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	563	1359	584	12463	18974	jxQgyur1MYdCi3mLFEUHzkCyb7NEc3uxPGrdGhDge6cABPL1KzU	14623	20588	20588	1619645040000
29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	29659	3NLbmPNzxmaHZNUSg3rrhfQW3pQpYfVaLhyWZ7K5zjAb2HN3Hj9L	1405	867	585	12463	18974	jxrFAKHqBo4YRSQikodpEoFszzX6j4haojeK5p3PLXUMQY2cNC8	14629	20598	20598	1619646840000
29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	1403	791	585	12463	18974	jwafkJAbtXQfEh9xCgfJ9A8DkgqY5abT9CQzmeguYCtbkJz5NDh	14632	20603	20603	1619647740000
29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	29537	3NLR8A1E8MfH8CmJkacS1SqhgiikTc4FgWymEb72rtXj2X2NWX5x	1403	824	581	12463	18974	jw85m3QPQVCeNrWqsJC6gWVabXYiXEXaaNUsKSLazpKMLugswmQ	14565	20502	20502	1619629560000
29543	3NK4J1MsVKsacmN2QyL1B249QGm2Hew2EQ83qvkBLwuNSTvrktD1	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	369	1186	581	12463	18974	jxoTsr3PG2WEL8fdFKyghTpfz7NfsmqazASogzwaehvjpYpWEp9	14566	20504	20504	1619629920000
29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	29543	3NK4J1MsVKsacmN2QyL1B249QGm2Hew2EQ83qvkBLwuNSTvrktD1	1406	1393	581	12463	18974	jxetNHSv8ZuGzxaPWwJPnsFR4MYTPZhefQAoQW4w759kDmdaqq2	14567	20505	20505	1619630100000
29549	3NLtMda9PLA89UkJ9xyvt4ExKvLuhpLJKXm9zanC2HbZzrK1hxh2	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1581	778	581	12463	18974	jxQGh67yqGRjM3wKmRSbaRwnMWD9K85zmYMXWwZDFZNv99vE6in	14568	20507	20507	1619630460000
29559	3NLiJMFc1nyTKuKDCH7TZ4Gjt4dGHmJrH38GvytRuJp9X5DMcKd4	29558	3NL83Ua5nguZaXc71yEzm4PEoznEaFXbJLLA5dXrEQCCkbt98J6Y	1444	1381	581	12463	18974	jwFr3xrwfbXRKNT4H7WgJowKcLrUqcnnSpzmd3Q7sQ95NEPpJ91	14573	20513	20513	1619631540000
29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	29561	3NKyejZb4sZQNZZ7Ctm3Z5W1oNYbtnsgwqvUSssFf43hkpa83Z8Y	1617	1042	581	12463	18974	jwhtNVz6HZ7Y9TPo5MHWvQ7FUhouURw5S1SC52uY7FuGXYJEUrf	14575	20517	20517	1619632260000
29564	3NKwnF3VSz2PtqeyHUqkPENhRmjaokjHEgPGsi8y9oeq2GAsobTo	29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	1588	1266	582	12463	18974	jwDiZwUGmDdELyiRtydkfKXc2EdDs5WhwVMMEC1xNXgWH4Kx5E2	14576	20518	20518	1619632440000
29569	3NL8vWTCYp8KBUSeyDh5Vyp9RpgweRkmPQ9tQh44vvtLFHBMw7q4	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1407	1395	582	12463	18974	jxft3xWxcMJaVFEgYisHZN5MK9YYoUxBSMz8H9mRP3AxzCEk3dM	14578	20521	20521	1619632980000
29571	3NKZuqTFPL5PZm2U3CiVTUHRL5nwRmSzisS8EpuMoU7TYfLGyk8A	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1664	545	582	12463	18974	jwoGaAQZtNE2rztrsoEjobiZWsx57g8Z9mGmtu3LMH8imqZuSR4	14580	20524	20524	1619633520000
29573	3NKKY1fxkzSvr7xR2suyaKYdzkzYjonCYNr77WYwAGYzEkUeMN4c	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1483	275	582	12463	18974	jwuXGoBtJPaytLjPgWRnjwsjFGufunUV2LPupFAjkD7SKFQqEMh	14580	20524	20524	1619633520000
29580	3NLvoe4pwZQhzhk6dC5mznjLusB52rcwKrZsoVFZ81MaMq9US1Jc	29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	1609	1087	582	12463	18974	jwyG3L8sFvWZsy794th8BiRLuS1hNkkd8B1DbtyYGy86y9Mt6Xj	14586	20530	20530	1619634600000
29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1406	1393	582	12463	18974	jxzszV7oPnC4DSvLqespi3W9UzsM1iVikaoY5VTHYFFPt82BeYP	14588	20534	20534	1619635320000
29586	3NKPKjjWfTwTebq9ogPaL4p5Lr1BSodMzHVYSjbASztBKmd7jEXe	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jxk6T1sJVHrNTe1FfDsv3Bx4nVjJHSYxLJRXDmeshuQBQ7QrKC6	14588	20534	20534	1619635320000
29592	3NKs3sFyfzicC2MSGhAAb3NpvFNeMXJSyztVtbZqX8iujefAbWq2	29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	1457	1391	582	12463	18974	jwSujedNJsDRc19FQwjApofcJdfzGf959wuWnFPRo9XW5VT4zBh	14591	20540	20540	1619636400000
29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	29592	3NKs3sFyfzicC2MSGhAAb3NpvFNeMXJSyztVtbZqX8iujefAbWq2	1668	1370	582	12463	18974	jxsPjsktt9KGm2wvyaA9E2sxEjYU5c8oS3pareCFSjcFsZwMJG9	14592	20541	20541	1619636580000
29596	3NLvbN8oY5LPk9E24PcWyuEiXcMNRGUnWhqSSTMECRnJPsiVMBid	29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	1407	1395	582	12463	18974	jwmJ3B2q1DgdR7Bn4nqJUbo3o4NLq79UeRpNjrtpkFcQG78Mpub	14593	20545	20545	1619637300000
29600	3NKBYTiTAoahiofRgnPi59QYzUuAfcRqftzRSy5RqFKQit676Rdc	29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	1619	1275	583	12463	18974	jwNyuhocnvZmxTDs7o88HueTPfe16ooAeTRQDzQBpKW4uAD9Abj	14596	20549	20549	1619638020000
29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	1436	87	583	12463	18974	jxGc1duUNn2vUAbvmZG9ghfApf4mWReAu1AkRe6Lwmkvn7GJjrb	14601	20554	20554	1619638920000
29610	3NLQDP3wa8fYtuu4quXwicAFqE8Ui3NPVQDWNosGYkrjjTVxCYPF	29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	1668	1370	583	12463	18974	jwSsTfZQ1cwPM5b7uZbBaHj1LYUa1MzsSvcT57EWGkNXyknXNYE	14602	20555	20555	1619639100000
29612	3NLQ1XdRxxvZ7qLUnxQzGKW36V5tUUhnWg5cuMNK8e7HNgJRWpW6	29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	298	1308	583	12463	18974	jxhKCxrpVCvXKhGkXmW3RT4FvwymTuqohGaeGethzHLod7g784j	14604	20561	20561	1619640180000
29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1579	1263	583	12463	18974	jwYbJhZ3LT7MEaGWa23Qec2E3ekadsdZER5Dj6e9e8goboHyf5N	14608	20567	20567	1619641260000
29622	3NLJoTA7HQt2QoRc2ZXtdFovN92FsfPfaPT76z4RW6FPJD5LPcP9	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1601	1262	583	12463	18974	jxQ9iAeoZSRgPnYx1fjmFqn8CBftXsCUehPpbZQTaSy2M91fXSA	14608	20567	20567	1619641260000
29625	3NL3CQstwkHvCGmRhUKRRfW6972agK6D6dR5kNitfQ8YUKAniMmA	29624	3NKPNVKozbUHiYQpA1M13Qi1x8VDb7WcC9iGuWKVxE1JTND86xfg	1406	1393	583	12463	18974	jxvAP4DLvHSfcKDuCpa79VhwJ34yYCLNvo6zDyvTgt8m3Xht9h4	14610	20573	20573	1619642340000
29627	3NKhZ4uu7nxfQ2MrXPc27oCC5iviU2qe7uemE4LAxeScbD8iNbnV	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1460	333	583	12463	18974	jwwFNyxGoeQiTEEYHfSESCgkvYE6fvdYXezQ4GyLiKMt1YyNyRz	14611	20574	20574	1619642520000
29632	3NKmNGi8QhwJFrMmZZhUHYhqk2zMdrBqF26RzX6DVSEghopTefVh	29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	1402	874	584	12463	18974	jxsmmED1ff6M5pzbwLbN3WzTWuv9LSKjdwdH8oVwrDuWWeG86ef	14613	20577	20577	1619643060000
29636	3NKaxAntT4HRe6a1U7bGeMjrMG68nautx4Brv9TxyKHtPwJyBGoA	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	484	1319	584	12463	18974	jwZ1trUnuN3vuDWKDwSoTP22LE9wADbQJgy3pZtqsgJSSuZPLg7	14615	20579	20579	1619643420000
29638	3NKjyQnzhxZq5xi9WbSbYXd3rcphwRmZwdJeTDhaY15wMdDGKLoQ	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1581	778	576	12463	18974	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee	14481	20579	20579	1619643420000
29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	1602	1369	584	12463	18974	jxFriiGKirFAYSBCspQvLjisV4DGPegQgUhz76gcLkTQWSJQiaf	14617	20581	20581	1619643780000
29643	3NLiEzhHyFbf6V6GT1DMzhbHECoKvxsPRZevca3eBjGD7vbRVXfJ	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1588	1266	584	12463	18974	jxRvE6XL2KWU9MVFAruS9Te4igmTbVErHsp2sEqijq47anLy38k	14618	20582	20582	1619643960000
29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	29649	3NL2mbJ8CmQtTRPBLdUz4SHfwYZXG1ujpU5284FTEFihp3H6u7F9	470	1309	584	12463	18974	jwuYyoac6jchUjhK9TR4U5UVfLjRKbEZ7b1kBAv7vRJM7DtvnxR	14622	20587	20587	1619644860000
29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	29654	3NLfGCZScEiF8HHdeDPLRdgdicoNhHs5AX4DEtWdF3LyFLfySigM	1573	1318	584	12463	18974	jxJpsKU3XcxvwYx4vQrRMj6KBgoSBcJRyXSZWiUHYzKRHUUsi9G	14625	20593	20593	1619645940000
29657	3NL4aJYzao626ZcSDwpRAUYBAkconVS17MdS51WGxXMrzCg3bDJZ	29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	1637	816	585	12463	18974	jy1aVYMCniXHa3WTsSEMuaomMNEGDrPBMmsmmEj4rooigTDQo2R	14626	20595	20595	1619646300000
29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	1500	1051	583	12463	18974	jxoGdMjyZisFepcMUYkTLfBL8WJyo2BaieAoWJit3WU8xY2uKE1	14606	20563	20563	1619640540000
29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1654	1340	583	12463	18974	jxKdpKt53gB3XWPTFhQXXkpqQRUNU2z5CyjDyP8chqChejKK8AJ	14607	20565	20565	1619640900000
29624	3NKPNVKozbUHiYQpA1M13Qi1x8VDb7WcC9iGuWKVxE1JTND86xfg	29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	1631	794	583	12463	18974	jxgWNsCsWpKU9NuzbZQn7f2ZMaQJEyXvhjJScfdCMFsJvVRiqBc	14609	20569	20569	1619641620000
29629	3NKhTZ2dVHekWbqFGaj2XvRUxdp5rRGMeSkG84PuWhwNHLiandKZ	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1611	1341	583	12463	18974	jwSboHPRpuU2ej4wmUrWMB16QpmC8iSAmqxcHzJHbMKXMPZFTyQ	14611	20574	20574	1619642520000
29631	3NKvgVQ98gTALMnRgPx47yvQNXsV4p4sWgaWyKn9FK3kt455Psid	29589	3NKLJWfmP8wisPhr7SmPkijMwve2zx4igRc2j6Lv9JuGt13wFWPU	1513	1379	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14364	20577	20577	1619643060000
29633	3NKNhr1H5Mtzeg6jcTm22cVRqAdTok5vAq7a8saZ84srAZch1qh8	29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	1553	776	584	12463	18974	jx4jUsw1Wbtx9VCDmFJxzhsL4FqUfyxwDbehWsGKfqz4MfYtc3p	14613	20577	20577	1619643060000
29635	3NK6oWoprogNtNWeFEWhsQGDgwi8dfQ9ABeSF12HPKWCxoGv2yC4	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	1406	1393	584	12463	18974	jxD9aeb9r4nY3fJPuFTz12fyU6m9u68QoqABf2WiCC2NJyyLYkZ	14615	20579	20579	1619643420000
29637	3NKy5GkzDsZ9m9xnTc8p65Kj8K1LM38xNQkWAEvefR7LCuJcYR7T	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	484	1319	584	12463	18974	jwhuwTP3cEkyaDAYN6WQFFZt16hPk3kfFqefwBBsoKqMeNLK1q1	14615	20579	20579	1619643420000
29642	3NKpL4cJ1bbx47Y98LsM2ZoR89hnvBoXp2SVtS33kJ1LXjD9a6vT	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1588	1266	584	12463	18974	jwpn2te2kRg5FxoMhfMRU5YSCZs3SpBGiMbPNkfYGWt41ZgcbDd	14618	20582	20582	1619643960000
29644	3NKiWGTT36XFXHBnpfgsGucELMsQpbZQKsNrBu1Uke5thr8etFVB	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1474	1329	584	12463	18974	jwHoReyYJcwAFtCmXmcjEJN3jdY1b86RDh4hZ9ZtQrxAHm76MaX	14618	20582	20582	1619643960000
29647	3NKWBR1EDr59xeR6qkjLQTGv7Z6EGyAxXgo12CyEsEuTyGborn6v	29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	1622	1230	584	12463	18974	jy1oBjAt5ECVLDh3giAJM4Hkdn2wb5hPNcTBrfD1mY7dnJa96Mj	14620	20584	20584	1619644320000
29658	3NKS9usVo28RyXacN34VccHygrYw5ee8fTo54DHHUY9MgizcBUFE	29656	3NKBqAR9PRt8nADGKd6i6DNWhhCH8dWdZrH4vTbJrg3eRtH6ELRV	1637	816	585	12463	18974	jx6JEUjbuo4YtDo5qKMADDxyAcD2mV4YcdUipgoow6xGQJ25Q7q	14627	20595	20595	1619646347215
29677	3NKb7Pzo4axc4DBfu8FeWwPTngXXDtLML9mosUxjHhzRuroPMtgx	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1403	792	586	12463	18974	jxCeZp8vrkKYjL9jKWNnTFyoSzLCerettGCtLAGMiaKyMZdkhVw	14639	20614	20614	1619649720000
29679	3NLHPQdaMUwLtxjRspFabnepW7KQixp1HkwGFFjYX73BD45RmJJq	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1633	1144	586	12463	18974	jwezsQaznRNySWYextKjQFFNEP3fWZpWvihojR4mbPQyNubn2fR	14639	20614	20614	1619649720000
29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1622	990	586	12463	18974	jx2hbozGFJmmkaSN5R96vjhJyAckypcaakWMGoAZ6hvCWJcs17e	14641	20617	20617	1619650260000
29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	29689	3NL7jU17MyqGa4kKN3V9hj2HjRirKq7T2PMbgpnENqkQ7oQB8W7t	1407	1395	587	12463	18974	jx1eFBnSxhEgjeroGZCkvRBLkfDBRGJdvY3j11GamNCsPuLMQ26	14645	20621	20621	1619650980000
29692	3NLq41PTWyR3xtkWNHUxZd31z2btYd6wvpVB4Y2g4qWAe2Yp5reX	29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	1490	1028	587	12463	18974	jwfCvcXNrrf7ws5Vc8w6QcVdHAyFvDd5B9hXL7kgcvaN29JT4yf	14646	20622	20622	1619651160000
29695	3NK7LzH35g8QVXU4YXzEgsGqrpJdN4RNpBobLSqoSsu98BwZDDYx	29631	3NKvgVQ98gTALMnRgPx47yvQNXsV4p4sWgaWyKn9FK3kt455Psid	1513	1379	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14365	20623	20623	1619651340000
29698	3NKW7ZktHyrTPTf34vvSmh6cYdf2VUKMRdpqDHE6F8DjiPsEj1xw	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1647	936	587	12463	18974	jwaPK7USBcbFNSDgu4ZuvEviCriJGVdfGt1RJXhXWxypXvepJ4D	14647	20623	20623	1619651340000
29701	3NKERjBaED6XC8LRZQMN2LMRjRoJjop2LGKCQpGQCL1veZFRKV1R	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	149	1283	571	12463	18974	jxaseTRJR2yKYccombnWEGERwKM6eJDfmnGUBMpb9FUmkJpehss	14372	20623	20623	1619651437793
29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1509	1320	587	12463	18974	jxdhN8BD3nZgEGGLEjc1zd3NJqwCg5wmpemDvYVk8hiMDS4tuHt	14648	20624	20624	1619651520000
29707	3NL147sZNrTdTJ7ybxPF5cBS8uqrzLdq7Fvbwzn3XiFKKxZZ8X6Z	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1637	816	587	12463	18974	jxPjCxsT8RrprSsRwVXcmwvGSN7KfZ4rQLUMgFh42MTCqFeBrTG	14649	20625	20625	1619651700000
29715	3NKDVpwcu5fQnBmax59X2CYeBJUTQ3tmvHdqXYR31Scj1macDhsY	29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	1439	1279	587	12463	18974	jwRxxrtVLS4GHXge2qThgcCjWhAUZ2kPNtSxAos4h8mEAxFGsgU	14651	20629	20629	1619652420000
29717	3NKbBFMPFr8TvTEezALnwAq4TTmVVY5QxofedTeLWRjJqD9jSFsE	29715	3NKDVpwcu5fQnBmax59X2CYeBJUTQ3tmvHdqXYR31Scj1macDhsY	1406	1393	588	12463	18974	jwBhS9x3rnEDhQ5fcFA9Fb9UcHPhLKHJDmQAXDgSfGazzhmi2wS	14652	20630	20630	1619652600000
29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	29717	3NKbBFMPFr8TvTEezALnwAq4TTmVVY5QxofedTeLWRjJqD9jSFsE	700	840	588	12463	18974	jwQN6YaRPB3UTwMgfCM6BXYzfXnK9tizoDVoCPWf5AfjpSHPQFx	14653	20631	20631	1619652780000
29724	3NKyZ6nGKuBNTrLi5UGmBCq9wsEdAJzFTDzJPjX9NSD7WR3SAByh	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1444	1381	588	12463	18974	jwuDEbK2wzEuQYESNXNzsQtfPgexvmC5RwVKX1iu6XRra9pXZne	14654	20632	20632	1619652960000
29738	3NLhKEVtq9TaDWVu3kmnPaVdZtTKeM74UwwJ8i8XSa83SQGqpxB5	29732	3NLxSviH9AXHRwcWNZQuqqvrTvk1YTx4eUGnan9ZkaSeu29fqxNk	1652	1069	588	12463	18974	jxeLvyo27qBKqGkfUKooG7AipoeaGv2Lzb3r3wMLfwtXYqHd2oo	14658	20637	20637	1619653860000
29740	3NKpfotXpF5txfA3HYR41VW5wtnadB6TJHSkBnpZ6mpM612ZDKHM	29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	1406	1393	589	12463	18974	jxrhnVt8pvChf4MBx3TxB7ZxwUR544Wyyg4A3pi81oz8CooP7jo	14660	20641	20641	1619654580000
29747	3NKonRcXwdphLaCHet2NdBRTQP32Nrt8og3n3nG41HfFgigMXU5S	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jxWJu4PXvavGqLrc6GEDUtmX31crMPZDawCYRVDebUC5Er4YGNi	14663	20648	20648	1619655840000
29749	3NLtVm61bo8PdCmAr2gyKAmtS7KpBYdouncfgrmT1SMPbuGqXmpZ	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1581	778	589	12463	18974	jxiLqAb47ApSkgbozHoCZCW1bT1yWvyKBLwZbtFYjhgwNsFgKMB	14663	20648	20648	1619655840000
29751	3NL97bkrb2y7FPhbxkVDmagzhfo38MYTVEbaGSMw7mRc9gxixjsL	29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	1549	1362	589	12463	18974	jxjzHmsZziMRtF8UsuoYGKjGn2xQBKqpQCizGEHRUTLvjcKQ2Xp	14664	20649	20649	1619656020000
29753	3NKwYQixHqegakFQQsVL55eFxMp36RUoxiJAfPp8bbL67a4LxjNc	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1407	1395	589	12463	18974	jx4yYV3wyy8sqyo2FvcRcqZgVonw8UrsvM5JMVG2qUpAwjRFwMw	14665	20650	20650	1619656200000
29641	3NKUHXTRbSPDpieTtYBZtvp8sGad6FhEdY7eMbxsGPGmvvdZeAL6	29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	1419	814	584	12463	18974	jx9SKq9QuUipt5e9rSR5VniN4JfTYmH8Tb37zqAo8kX9kuZWwom	14617	20581	20581	1619643780000
29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	29642	3NKpL4cJ1bbx47Y98LsM2ZoR89hnvBoXp2SVtS33kJ1LXjD9a6vT	1585	1366	584	12463	18974	jwk67ATk2K9tz77oNKPPNz5a8P34tMMgNdd9Z4e6pTuxgV4Mwy3	14619	20583	20583	1619644140000
29649	3NL2mbJ8CmQtTRPBLdUz4SHfwYZXG1ujpU5284FTEFihp3H6u7F9	29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	1529	1316	584	12463	18974	jwqMsr1FH9qQrrWSdasiejCHrBBKxbPphMyNVqsX3gBLp19pFjR	14621	20585	20585	1619644500000
29652	3NKJyd99Un4c51hekzX5ZEskfj1TTDp4zvomKFHvAjEKG24T1Kwb	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	1617	1042	584	12463	18974	jxHfiqUHZ18Cakajr2aCDomHbZ23RRFVKoVaj3PQeGMXMZha9BE	14623	20588	20588	1619645040000
29654	3NLfGCZScEiF8HHdeDPLRdgdicoNhHs5AX4DEtWdF3LyFLfySigM	29651	3NK4W8QE83SG4CSqC3bXzbFfwpTv4TLJwPPLZP1dJLyDse7BXo6U	1405	867	584	12463	18974	jxvwugvD6tLkNcTtNAnonNwxjye3Ef5TrSTgMz7modCeV4gS161	14624	20590	20590	1619645400000
29656	3NKBqAR9PRt8nADGKd6i6DNWhhCH8dWdZrH4vTbJrg3eRtH6ELRV	29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	171	1008	585	12463	18974	jwfNMz6Tz4tZWUMbiZeK6o12VLUSvvHgDCSNDVp5Xs3NNrA8H5X	14626	20594	20594	1619646120000
29662	3NKi4bbyZTgz7HtPNnZ8dbALMm1h2dALPZvoZwkCtE8w9fMadjCv	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1503	1277	585	12463	18974	jxY1CPjHoKaJ8gwDR2qzoETSpiCxBhfVKRWXVKpo5mQsvC3VYvw	14630	20599	20599	1619647020000
29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	29663	3NK3Nv2uGogYLkdYoQPc6hegr4tGEdayRmM2BnswrqBfEUHZv2ry	1407	1395	585	12463	18974	jwcnBU8z7VgZycW9C1Sz6t824gBXUgWvTDEtLy45LqpuzTzf6H7	14631	20600	20600	1619647200000
29669	3NKJ55tJtD8HDMj7ZgyuBZ8DZKEATQ75zro9zTU8NEA9GitJgAP5	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1656	1217	586	12463	18974	jxzgyz5KvNSDCaHaAoRu3fe13sLWE6ZZJhck5AeRpiWmSjUTTGj	14634	20606	20606	1619648280000
29674	3NLyNVadEx9qaEsnEJ8GujiuKnGbAaRYYAk8trXtJAPReD7UXP9C	29672	3NKMCqb3WyZYhf6J6SghqA9UC79StCJfKjUngiqxWEUKoTYkvm68	1553	776	586	12463	18974	jx6zv97uS4PT4KHWZTCsekqhP1Ejr7UVtSZEE76BS359eKCHc6z	14636	20610	20610	1619649000000
29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	29675	3NKjth8padGjQTnyhmg53CBdSJuXTe4y9g2XHCoFs1R2o6KR2rhJ	1610	1068	586	12463	18974	jwPi9qJmLW7co4rJWxr5VTa1dcWT3VYxpH9QMvJMFDkexmGkpV3	14638	20613	20613	1619649540000
29678	3NLMAadQqou4f7TfS9777XgEG85P1at1MrKPP2UfwX564ugR4tNY	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1633	1144	586	12463	18974	jxWUcyvFMPcYKooKyL6pePsPHt8MRbQp5FvWgNGg2uGdGnYy1wV	14639	20614	20614	1619649720000
29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	29678	3NLMAadQqou4f7TfS9777XgEG85P1at1MrKPP2UfwX564ugR4tNY	1589	1286	586	12463	18974	jxNBV1ZTpSj2aBKX4KvRts3MfAxP9qC9GM3pZui4Qijth27ZdY5	14640	20615	20615	1619649900000
29684	3NKc6hha9ZRtVaZh11tWrm6FxBJWn6JqHkNYm3CzX7PshBwZVmhH	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1407	1395	586	12463	18974	jwdEqoHQoL787tBrHWPMoP5sPwf4EPCC9KR7vn6WafnHDxGK1Rk	14641	20617	20617	1619650260000
29686	3NKR9DT6R4UMZxMkN7aV4fSBHZX2aDcQqnj2YdPAw5duVoQhfJac	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	369	1066	587	12463	18974	jxUV5djR2Th1YiojvhYxqqsgsRfRyV6tKLzZqj5hgEQK55h1KVB	14642	20618	20618	1619650440000
29694	3NKUZRvtLrpj8iEjSeKQo8N5RtC5VhgyoxTPhvqmQ7Dj1SBAh9ci	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1406	1393	587	12463	18974	jxT9CEcRJgmX61WtJoRCu6w1o2JHxwrcnAiHeVfQhwUj25ftAJy	14647	20623	20623	1619651340000
29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1553	776	587	12463	18974	jx1yaGUbv7iEAVvmW58x6h3NYkgL7pet7pNoWoZFqiq8ASvgx3Z	14647	20623	20623	1619651340000
29700	3NL3r6rmKhFRF32tB6rbSWtZFSqqht4DKoEJjqv8v1gUAVZVfny7	29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	149	1283	571	12463	18974	jxds5q2eS8qFZs9FnpXEjWoyupWP3inetiXM265ff5vjMWGVq1W	14358	20623	20623	1619651396504
29705	3NLC7v9PBC3wNzJTeY1SsJSNqmypRcrTjMnTqK1LxvKPsBCQZNXq	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1590	1054	587	12463	18974	jwcuyD6dEvYA779xBA1D86N1A1UuskNgPbccPe3wjh4mGLJsnTv	14648	20624	20624	1619651520000
29710	3NKZfGoSnjkWCWBgX7eUq2oAoeH7JV2pzQSyYzFgW41a9kgzcBZ5	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1542	1178	587	12463	18974	jxFBv6mMUCgdVvMtrrAnYYbk8KEhWWkeNFDfKsiDBB9pJXuai89	14650	20628	20628	1619652240000
29713	3NLrr38PozejXNWssf9VMhnp4BqS6dZk2wuEfFb5Kk6tPmAnPd2F	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1593	1100	587	12463	18974	jwmmdqF4ijF7nEE8ZPZpRfTVJj8kxdjTDkv4DukNRi4t1ALyMSS	14650	20628	20628	1619652240000
29723	3NLJ6ad5RF6D6uwunjwA6ExwBSnBSuTMNRrXstc7JkL2dWNjWmke	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1444	1381	588	12463	18974	jwmCWE6dcuX4DfYfTXutJptifXUaRyWGLhHCDvbZp5FMmX32985	14654	20632	20632	1619652960000
29725	3NKt83ottSqxUHkL47jEtchnv3tJomWoMrqXKaV2QYsLZLQ5iJrP	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1559	1107	588	12463	18974	jwUYLZbkoJeKkmKTrALPL5DBRP5hS4M16UmiZ5CKigmRNTXDPHP	14654	20632	20632	1619652960000
29727	3NKqLJTtXwephyoppLtoPWg8XrHmiRDJTWJyrf7PnGW8doamhgc3	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1406	1393	588	12463	18974	jy1sQ8wNjrpGr3tGP685dudVmdSniwWTXAG6QogyjDjiC87DHQh	14656	20635	20635	1619653500000
29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1654	1094	588	12463	18974	jxkFQjet5v2ZFppP8vH89TePYEBdxFQZKEFHSQxQSkTz6M4PipA	14656	20635	20635	1619653500000
29731	3NKo8cni6hT7jHfQg4ePpxPimb3GXn5SWUpzCD4DnS28a3bbbDcy	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1483	562	588	12463	18974	jwFsHne2sENrCqTHuPJLUG33NdStPtmF48jAk9Zc5LmoYfsAF7H	14657	20636	20636	1619653680000
29735	3NKtRWVt3CMNC3Q5PeRPyNCHNVBRrhnvvb975eo21L62M4QyX7Kx	29728	3NLGXcfyUxUmMv3iyD21t4sFWCQi89nkgDE69WW8Yri5XRCngnLd	1624	1334	588	12463	18974	jwMVicPiS6LS8d5xcScM6kQaYBqnNM2aXC8t3TZSftzDC1AzEZH	14657	20636	20636	1619653680000
29737	3NKXw6hQ5U3XUKGbyZtrSu5VmJR21oC7bb8HKY3Qs2SmsERVaJJq	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1624	1334	588	12463	18974	jxiw3pTW13cw6ZQfFPvugLUhRR7AyJkrUughwLrsrKWSkxYepjp	14657	20636	20636	1619653680000
29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	29740	3NKpfotXpF5txfA3HYR41VW5wtnadB6TJHSkBnpZ6mpM612ZDKHM	1406	1393	589	12463	18974	jwkKzGPTDWziMey4yAraWHR2feyEoEakNuCQD6Z7JCc2hsAhEBz	14661	20643	20643	1619654940000
29744	3NKbcFmgV36z6C7BQjE2tXiEEe2g7tkKb2dsKoRJKJwFaWBi2eJC	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1607	1348	589	12463	18974	jwxVF7MttSJmWUpTP2mYDZapdUg5Sh5W86yeb86NRn8HNccB1rS	14662	20645	20645	1619655300000
29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jx1jod5hzfAXR73yvDGSudHt4uuFxDTGYAwwwBbBGGVg4Hci3Xz	14663	20648	20648	1619655840000
29750	3NLcuTLa23iRgyQLWTMWVoZJbeP6fi6aGfsgxhnRwiyb937r8P68	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jxhkWpbqnQdoa8mPGe762r5raf8CJtP9b2aFFBispH341HdQcfE	14663	20648	20648	1619655840000
29659	3NLbmPNzxmaHZNUSg3rrhfQW3pQpYfVaLhyWZ7K5zjAb2HN3Hj9L	29658	3NKS9usVo28RyXacN34VccHygrYw5ee8fTo54DHHUY9MgizcBUFE	1594	1080	585	12463	18974	jx75zvnGHu1ALt4j48qxLgp7RHn9xsmSj1za3ZsH188McP5aeDS	14628	20597	20597	1619646660000
29661	3NKt2bLqAENUQfhSz98Tbk81qpmr3pCPMa8zxrQAjCVXasQ7XsVu	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1503	1277	585	12463	18974	jxxDKvrFA1VHPqgDpEKjykkMjox93cWK6K9YvHLLwHTfY1QQEGv	14630	20599	20599	1619647020000
29663	3NK3Nv2uGogYLkdYoQPc6hegr4tGEdayRmM2BnswrqBfEUHZv2ry	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1602	1369	585	12463	18974	jwxnuaUS6Ez7oWW7uKGVSTEodNs3t7PRsZ8Z4RoME832CVcaVGv	14630	20599	20599	1619647020000
29666	3NL3SbsKR1jv7g6j4QfbZfD9ko9KqYm9TF8rT1WRULopcvoHVmLf	29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	1444	1381	585	12463	18974	jwDz7pBTsnrBRnipp6MyNhjqjKDSVHSdrujZJWhTJmPG2hUgX1m	14633	20605	20605	1619648100000
29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	1444	1381	585	12463	18974	jwDz7pBTsnrBRnipp6MyNhjqjKDSVHSdrujZJWhTJmPG2hUgX1m	14633	20605	20605	1619648100000
29671	3NKRC88mvdx16s9J33msbUsL2hNYaHLygtvMMqC2SGkvid8NVg16	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1671	1119	586	12463	18974	jx8Ud8afK1xR6j2jnDnVVgvB9XcCjJZFsteZGkBW4WDiWy3y75K	14635	20608	20608	1619648640000
29673	3NLYgy2ZjgeFg4ctGWQ4uGEMtTNeXKM5sh8dKm9d1ZFtWdBg2wBL	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1440	1131	586	12463	18974	jxYntKbo3SSwePh4FptwAShK14kK2FP3uzTz5B7twvhycSDhze5	14635	20608	20608	1619648640000
29682	3NLmgA2kF1GS4NnD2EXeHPNMAmUsnvgMFZmCbQHgZMb65T5GSbvm	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1622	990	586	12463	18974	jx2hbozGFJmmkaSN5R96vjhJyAckypcaakWMGoAZ6hvCWJcs17e	14641	20617	20617	1619650260000
29688	3NLhuEtiwYDkCwWYiQY7MFGddo44zTvH6ksDSx5UrPvzWkx6j3Wp	29686	3NKR9DT6R4UMZxMkN7aV4fSBHZX2aDcQqnj2YdPAw5duVoQhfJac	1623	830	587	12463	18974	jy2LFXVBzxYwi5qZAYVgPmosvzw8cou5R8kuJYE4TN5UjhNmvKy	14643	20619	20619	1619650620000
29699	3NKmrGbiyiULkPYRxgrNgbGV73VsB9V6n8uvkqwAojAChQYsem8k	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	149	1283	587	12463	18974	jx16E4zGbDr22LLppMBDMNbEk4upJnMEuUkP4Sx4KAUQaQffJ3w	14647	20623	20623	1619651340000
29702	3NKhQhM2wfhnFxWJzi3KgcFJu7G57yDfrPpr6Cj3nmv5qaRHdDaG	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1637	816	587	12463	18974	jwhonjMjmbZdbm26XRHTf24HKAGoRb7TwTYzNezqJrAVMV425of	14648	20624	20624	1619651520000
29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1402	852	587	12463	18974	jwjip6GL9fvMTurRLCexzoG9wmrktN9R4ouAzGfbuFJmFPRkfxh	14649	20625	20625	1619651700000
29708	3NK4A8FZoPFo7zoGhP89rhPv5QYZNMWEkizbXJNqdCqz2NnFFQLu	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1407	1395	587	12463	18974	jwjkfCCD1qZtdUd3vJzKosjxm2b8nicGDBE16fk4jmAoTmZvB1y	14649	20625	20625	1619651700000
29711	3NKysQ9rACeiRJzW5dCAyvdQNLxhRXmL7GtfvMNcbY45KCGgVBcW	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	369	946	587	12463	18974	jxV4R2PHrFmcivVvPoQy84ThAaSHhCi8Tg4dT5VEw66iXqjQUx1	14650	20628	20628	1619652240000
29716	3NLUb6q83RtaMuXoyW3kbYw57sPSSQAUBn2Tky3XUAPS5neP2i7a	29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	1439	1279	587	12463	18974	jxXbbLFPg8YmzLz1VHDsR6qksX2pyZ53kJFcHGn8nRNo8RfvMYp	14651	20629	20629	1619652420000
29718	3NLFU4qZmsH8yktEyhMXW571RUXTCheeX9XTF9dSWeiFBeGkN6Ha	29716	3NLUb6q83RtaMuXoyW3kbYw57sPSSQAUBn2Tky3XUAPS5neP2i7a	1627	1139	588	12463	18974	jxUTHDTN564jQde16ruJ8nWNAkzeQyLjb9MuWxQCuXe5fXX5hoG	14652	20630	20630	1619652600000
29721	3NLi1jRyzRhVosJq7TAcBENY2ZVmNszcCZJKCxYgZ8mQxViKhzfR	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1471	1386	588	12463	18974	jwJrzwyyHUeKh2D93qH6VAznJvPtMCsn79rzhRCSGmpJWp32mRF	14654	20632	20632	1619652960000
29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	29723	3NLJ6ad5RF6D6uwunjwA6ExwBSnBSuTMNRrXstc7JkL2dWNjWmke	1613	1349	588	12463	18974	jwt2YYDBrW2QvYKXCsUnDQWpV27wAas1JhDww5YPCxEcUFBbqJK	14655	20634	20634	1619653320000
29733	3NKrPpLiC8FpVdu95D5rbcQPypF7PWAhbZt1vAtm4xHumPxi4FC6	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1403	782	588	12463	18974	jwAjGpEjnponCyiKQJcP3WAoRtMZWdzBiwafTm2yCFdeVsL7FJF	14657	20636	20636	1619653680000
29741	3NLyAPxruZB1eiRHsfDjG3jG5fwn2ehDQz4GMP47jeQqxMQ3hKm2	29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	1403	824	589	12463	18974	jwfTqTha5CQJdbCbJKrATkyKx1PzDtdz16egPgu2tvWH1tysh1W	14660	20641	20641	1619654580000
29743	3NKfRRde1ugeKC6ynXQyjHWYYAXT2jTD7icDghcEvrnei2GLv1pW	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1607	1348	589	12463	18974	jy2aauMv18jiPQmyDZ4Lvu3NBEA9B552YbpCCVxtgcnmbwfsT1q	14662	20645	20645	1619655300000
29746	3NKsZtnf4xmru9mUcqKDb6tLaBZpYZzTPmgGBvhPAXtMdCJuhKhU	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1623	830	589	12463	18974	jw7EgzthSprRgWNs1VyLZfPENB5qfAXQd2HxGMRs6o7mzf6hWsX	14662	20645	20645	1619655300000
29756	3NLfhpDALJxiv5QNYfLVMhygTNbPpnGqj7BdvbkrsU7zFv5nmxJx	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1652	1069	589	12463	18974	jxUKqHGvqp1hi8andXfBha5ffahvMXpYw5ksD5wfRuYQjJv3MQS	14666	20652	20652	1619656560000
29758	3NLjQ53dB9mrXTpUdFbrM3bTw7xEdkFkpn7zXJe2BVq9kUXKQMk1	29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	1652	1069	589	12463	18974	jwmbGG7rUGk7qh582NeSraB9Ju3WWcqygXBbwEeFYajUXNmeU46	14666	20652	20652	1619656560000
29767	3NKicCGRjdXXqUE6XkUR4KXXnQkJh29Usp2nNobdTtbUt1JWw6T6	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	369	1186	590	12463	18974	jws7AwmVfckEsfrRwamBZsXacUh8iXqnWUeyUEQVRqyuDayyX46	14672	20659	20659	1619657820000
29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	369	1186	590	12463	18974	jxVL1KFVf21uVoNMNpjbZReLiEHhY9mgzcStMDigCnTJT1B3rnY	14672	20659	20659	1619657820000
29771	3NLM7kGQQTeTWZeixN4j5GoVcVpUmRSxStReJSVMJmDLgGL2AbSh	29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	576	1109	590	12463	18974	jxNEiapHkfySmimQvjnojK32ubz7qJbdxbvMZLNaSAdwu2q5Fkc	14673	20661	20661	1619658180000
29777	3NKmro3PnFaa2Lc8UCQEC1LhDcgqGt7YjjBxBAmAz8rdPDutjj7j	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1542	1304	591	12463	18974	jxFNBtQQuSvALLnzTnN4YfCxSEat6YBSs1tNnmLGmKAoyqMpfEk	14676	20666	20666	1619659080000
29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	29779	3NKCoTce8A57A5wki23nLyxZ4sYQsKA3uChbRyK63CFbvNSw9i3G	1579	1263	591	12463	18974	jwnc8aPhD6baAtYMDJAK8SteWpErVsVE3BGPEebLfMVCkm3gAxc	14677	20668	20668	1619659440000
29783	3NLEccXPuF2gjPj5kh5gdbr3Q1VLzrKi6pBDJQbctKCSk4zbdqcL	29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	1419	814	589	12463	18974	jwvSEx33NhdR4o7mAwf4srhL13d7GmvPJ65nZBH1Q85isv9Lhth	14666	20669	20669	1619659620000
29785	3NLXEM8EJUdfvtVuDjeyzbEPYnWE2AnonY2QfTS4gFVK4ntL52Q6	29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	1546	1339	592	12463	18974	jwBcoqG7vj5LtwtWvzTzq3nGFmRdP84XMiTVRrgoccdRsKfqTi8	14679	20671	20671	1619659980000
29788	3NLMGGidcFPRyvyasLRNDqz2jwE1w1737M7eYpi5VREgRWRZL1oM	29783	3NLEccXPuF2gjPj5kh5gdbr3Q1VLzrKi6pBDJQbctKCSk4zbdqcL	1419	814	590	12463	18974	jwRnP9V1wtbMrRhtX41H6Xt6a1BDSxMEUXDgoFpa89VeeoqAFct	14667	20671	20671	1619659980000
29668	3NLw1ZdLsEGFbuB6JHQEytUpsgEEGeAsPzLjS9gmBrPU5L1c6TV7	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1656	1217	586	12463	18974	jxzgyz5KvNSDCaHaAoRu3fe13sLWE6ZZJhck5AeRpiWmSjUTTGj	14634	20606	20606	1619648280000
29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1652	1315	586	12463	18974	jxcYmKU9rcYmXZKvrXHAqqXqeHZ65BFsQfFBXbge6HbDr8L149i	14634	20606	20606	1619648280000
29672	3NKMCqb3WyZYhf6J6SghqA9UC79StCJfKjUngiqxWEUKoTYkvm68	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1440	1131	586	12463	18974	jxXLytCs7sZJEEoCs4u8MaXryzGhfo6wChGaDmQ43SNqvG95dya	14635	20608	20608	1619648640000
29675	3NKjth8padGjQTnyhmg53CBdSJuXTe4y9g2XHCoFs1R2o6KR2rhJ	29674	3NLyNVadEx9qaEsnEJ8GujiuKnGbAaRYYAk8trXtJAPReD7UXP9C	1406	1393	586	12463	18974	jw7BMQs7u7aRTxksntKNaYfEeookXzmmF33YEEejtzkarLYXpNF	14637	20612	20612	1619649360000
29681	3NKUZN4SBWk6e5BZ8LGWydTNKghZhU8RP8itY5GpJbXLMcPMgo3j	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1549	1362	586	12463	18974	jxubG3rZcyEXwMUebqUpNqLQnZYSxq8uYuHvn39qTtjoNGkva3x	14641	20617	20617	1619650260000
29685	3NKko4Xq4QGfGwZnRPQqY7q7Bpy6aThMJoXdNkVDkSHFQFMek5Qg	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	1405	887	587	12463	18974	jwuAHQ9seEfK72AyADuQLFFBBmTzfZS9Nkc2maNu34JmKzP6nrq	14642	20618	20618	1619650440000
29687	3NLEoDdL6uGYiA4mrKHEjUaguipG8xCCSLH7bcN8JGtm1mhABpSU	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	369	1066	587	12463	18974	jxHmyniyZRzMKGGVYqhH1nABMyXdtvkSyZS3XG1KtpEsPhnG7dK	14642	20618	20618	1619650440000
29689	3NL7jU17MyqGa4kKN3V9hj2HjRirKq7T2PMbgpnENqkQ7oQB8W7t	29688	3NLhuEtiwYDkCwWYiQY7MFGddo44zTvH6ksDSx5UrPvzWkx6j3Wp	152	1084	587	12463	18974	jxcmuMGyZZkgPemchGh2Dq2hTDnNJYR2xZMNPgMBwS63PnyDV5x	14644	20620	20620	1619650800000
29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	1490	1028	587	12463	18974	jxjpGWVpjzR3ytYHzmYS2aduLZ71L2gCHgwiayJrG2VKj1pBwwC	14646	20622	20622	1619651160000
29693	3NL752Bv27rMjfSFQJVfeReQnyHMRqNAsE2mBwNKwLC7iUcy9XK3	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	149	1283	571	12463	18974	jx2Q7KcxfX4RSAovqXbuZsh7xdCK1ZB3uFxYJxAWeMJvHjUFWRv	14357	20623	20623	1619651354772
29696	3NLtMXCPDUGVMq6qu9XnKrrNae66KSoJ1Grw4SJBqN3prHpebJwu	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1407	1395	587	12463	18974	jwoY81DWLbcHvFmvVhEe3k8q8eexrDKnumoxa2dhK5gAs96MPmu	14647	20623	20623	1619651340000
29704	3NLSQqvM64toktWrbkKQgbuxL6qqt3yrVLRqq7qWZMtrUzPAs6ve	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1509	1320	587	12463	18974	jwJJ5vqXbV9mseKe3zcVeQagU769x2AhLwmAJfbiTdjGa1DcJ1P	14648	20624	20624	1619651520000
29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1406	1393	587	12463	18974	jy2LYXtTBj53UKftw1CDBtp4QGU3L6VcxuXPbwroPRWM8hQXXxw	14650	20628	20628	1619652240000
29712	3NKyfmSfXCK6N2qYdneqzHRS7o5FvFcMyDBCHX8YNdizEikjfx5f	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1542	1178	587	12463	18974	jwUXU4DnXMn5bBM6zcg8eLoepyS1Lpyee1Q4hk7Czz9F5uQppdu	14650	20628	20628	1619652240000
29714	3NLgsrz6ebiXUh6TFmqqbbE9sykppwWZzq8MFu4geowY7bme3w87	29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	1593	1100	581	12463	18974	jw9JMqxXVjjSqnAdDbHkQJeYCTnpwbTKYsY9g8xWuYhhg4CwXHE	14572	20628	20628	1619652240000
29720	3NKoVNU5p6L4yUDTUCdnTpCd7UDpzKLqupaGoatFRggWU9DaZmRZ	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	700	840	575	12463	18974	jxVDX7Hhx155apBzRVhhjATZuVqmrzA9AwM9CmaRdRQZEgSXrjW	14446	20631	20631	1619652780000
29722	3NLMoyxJyF2ywi2hqkrrEwLbkxDHGmxjuTUZYkrWN2WTzm9hVfHB	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	369	1312	588	12463	18974	jwDjvJZDRFNcLgpxWc15MMnVo4t8thbMSCjut1PsWfex6odJUHu	14654	20632	20632	1619652960000
29728	3NLGXcfyUxUmMv3iyD21t4sFWCQi89nkgDE69WW8Yri5XRCngnLd	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1654	1094	588	12463	18974	jwvj6g6vhopBtxUdyPSS8PtR9Rr7MY9gLhAvVC7sSCwzxdQHUSX	14656	20635	20635	1619653500000
29730	3NLP2qtrpg5fUYUzymkaQnF4V6aue8BJt45s4ikSQuJbnZQFzDQw	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1422	971	588	12463	18974	jxnvUvRL8rAPicXpEwN7CDEPjdQoWpnb17KNi3xGpTdE4cbyBsX	14657	20636	20636	1619653680000
29732	3NLxSviH9AXHRwcWNZQuqqvrTvk1YTx4eUGnan9ZkaSeu29fqxNk	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1547	1252	588	12463	18974	jxZL6caPavh1NAxBrK2xzcpF3fFfcKmRVHHDojSdhd5NkpF64ZQ	14657	20636	20636	1619653680000
29734	3NLhdxFrtRw5b8Sqfgzpfq6NNHjbuSQAVogDsZ2W2C4bUAjJ4zvs	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1624	1334	588	12463	18974	jx8QnkSQa2p7RAvAYCJmn2r8yv4A77kaVkyc5vyYKo3fHXbhNrH	14657	20636	20636	1619653680000
29736	3NLFGnMm1LckbVGHBLDhZXJUrMnTFJ8aw9g9x94qEM7THKpUUCWL	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1483	562	588	12463	18974	jxbYUwZd7ErwuJBCaoHnAyp3eALqkNeZbygn6VFTpHjfvs4Xvfy	14657	20636	20636	1619653680000
29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	29738	3NLhKEVtq9TaDWVu3kmnPaVdZtTKeM74UwwJ8i8XSa83SQGqpxB5	1406	1393	588	12463	18974	jx6teiJWfj7YhDXdEgY87q1tNiE2Yn2ghvtY9YBsBjc3TXqhuKd	14659	20640	20640	1619654400000
29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1637	816	589	12463	18974	jxPsMmY6i94GDjEXFhr85uaaHD12W563EXi9DWkELVQyKD8Qfpp	14662	20645	20645	1619655300000
29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	1549	1362	589	12463	18974	jxgob3izkjuRWASJvf7ST4vBWe2yWoZrhvLL3nxsGvcXAak9zih	14664	20649	20649	1619656020000
29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1588	1146	589	12463	18974	jx1yTP3iAyCFwaJTY8Kq2RT5AixuUGKTc4F3Sy3U8TDX2Z41hF3	14665	20650	20650	1619656200000
29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1652	1069	589	12463	18974	jx5hYq2ooEsqET6ibuM1rergrXDtSz2LGwrdTLkndZbCNyi28Rt	14666	20652	20652	1619656560000
29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	1617	1042	590	12463	18974	jw91Cx9jnfTeeLDxTiKbGobLvcijqgXdoxc68tgU7cUn3T93yEj	14667	20653	20653	1619656740000
29761	3NL9qEMz957bHVVT3hqXFN4jhrjrhyPEoZW5fJQanG9eqDmWPTWj	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jxonkLWidT6mfNBLY6kPYSQHNXtZsVgR9zMMZJZyWvxqW5x8wfc	14668	20654	20654	1619656920000
29763	3NKEqmECwWW4tqyT4KSGJ3GApBxDQNmoSvzQgon84j54Vjgj6MrJ	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jwBLePx9RoF6nxxQdTAdwK65C6TiWPGKM71Di7RDFczfoU6kwzx	14668	20654	20654	1619656920000
29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	576	1109	590	12463	18974	jwHLmArBGe7ps5p85Af6KdqWWdmcHH2kunaJKT2f1fEd68C6ieq	14673	20661	20661	1619658180000
29772	3NLjyCkZpc3Kk1eyEQrW32fSs53UGd9JHKFKjZZBLZEgMdrCmTzN	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1467	1250	591	12463	18974	jxfCexCc5drzY5qGmN9D2Yi1Mg11HY9tP9wQ1Y3DDLYdA62TwMR	14674	20663	20663	1619658540000
29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1651	1301	589	12463	18974	jxPug9T7N51fVb2Pc9w6XdMdEyFDv83mx3ecrxhvYZiQ1w8sWtg	14665	20650	20650	1619656200000
29760	3NKzKdB9AMiZhXfw9d6hzrtrhd3cuMokHzLfMzmJXMvL9DBfbTJ7	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jwk7pqaJ5c2A2pHxfZv3YJc8ZbrmXADt3fCJWEbfjA38N1QC59d	14668	20654	20654	1619656920000
29762	3NLADPCCj678JBCmhfuuGgPcPKif5SN9DoHR5SpUFVEapBteh4jy	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	563	1233	590	12463	18974	jwrtC3rizBjNug5vMGfkkqbidmbX28K4CeHqSSBp9Hfn4JtApkc	14668	20654	20654	1619656920000
29764	3NLD1by6T9JNgvWT3dAjKQWbyqve4ZYA18TDa2KhPNg11rd9h79i	29762	3NLADPCCj678JBCmhfuuGgPcPKif5SN9DoHR5SpUFVEapBteh4jy	1460	496	590	12463	18974	jx66s9QRndFdhtiGazzq124wRSQ8toPheEc4dH7WAMg3NSKuRQ4	14669	20655	20655	1619657100000
29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	29765	3NLwDVdBkqWt8FbhkUjnd37C5HotMjsPUF3A7mhEyzza6URQxMtA	1406	1393	590	12463	18974	jxtgRww2Jy59VRb5Rfcn5cat4B9CtHx71WV8odCvukMshN7cMbK	14671	20657	20657	1619657460000
29774	3NKJhiZhDs6ZGdMEDvL9ExdsviByiJCtddHrYuGfxhxpkr6CoBJx	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1623	839	591	12463	18974	jwAQziWcczVPsb8WtCCdmzrmzf4zgczysUvrDQSXUuQeq79n9vz	14674	20663	20663	1619658540000
29776	3NK4HTG3HvL6FeHYEfcXAea98vXToSf5napzkbZxnEaRFviDH2oQ	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1406	1393	591	12463	18974	jxvVh2cagVkt2F4TKGEiRU1Rxmpx4xYa1YL1AS1xh8LKHXY3sts	14676	20666	20666	1619659080000
29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	1419	814	591	12463	18974	jxteG1CbxnQPyhKYvWw2dYq95FX5X7fGKYwYAEgcySjGeUQQ2Y6	14678	20669	20669	1619659620000
29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	1650	1129	591	12463	18974	jwJHJHJP7fTbmHgHxLkKGEf8A6i42ZRW58Xa1ZhLPuT4QTp9D4M	14678	20669	20669	1619659620000
29793	3NKpvFZJAvLPMBGtYDfHJ4SKxiUZJy3e6zNhBgFvoNJ3RMY8L1Bp	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1656	1097	592	12463	18974	jxR9XcQgKHWeqUEvy7qFn54kkAwXsfKpJTNY2zm2J3UtHxZSDpF	14681	20673	20673	1619660340000
29795	3NLg7pjMiZiG4HjXfBRmED8ejgTixwvAwD2NdMiqfe48vG5zQVse	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1590	1174	592	12463	18974	jwav3BpM4pa8E6HHy9k7qQ8ffsUbXN1BcqWhomfC5SFQFzvvfie	14681	20673	20673	1619660340000
29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	29795	3NLg7pjMiZiG4HjXfBRmED8ejgTixwvAwD2NdMiqfe48vG5zQVse	1590	1300	592	12463	18974	jwkWVzDv3ATWopXk5GpPZje3oTqrzm56CdaspXM8VcNUTA7Q7Nn	14682	20677	20677	1619661060000
29801	3NKLu1Lc7gMPADR8Yhomsr5rvUEef2BoGnXkFX4Lcw5RjjiaKqGQ	29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	298	1062	593	12463	18974	jwWCyEQ38okQvgSaqJ4jrLKD4KeELU4qT4id3sVPwMHVQGsnm7o	14684	20679	20679	1619661420000
29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	29802	3NKuszyx4YdhJLaeK1S3sxm5YmEf3xHGbybi4A6nU6huJbMYgFZS	1549	1362	593	12463	18974	jxaSqr9R7zfLxdCFuKZwMb4zgrHcPy7rjHB4Yk8ccft3dnPE74z	14685	20681	20681	1619661780000
29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	1622	1230	593	12463	18974	jxp6ehTZQci7Wxm5AkDYdUymtEjA1BFeqWyri1nTdYQ74Ug2e6G	14686	20682	20682	1619661960000
29807	3NLNtfaA3QTsU1FgX32FJmqmXbFFndSBEFmLodSUHi8keyNkMDs4	29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	298	1182	593	12463	18974	jwX557DsvkW2fgx8zi6hseyboR5Duy7onX6QVbFDMJg3WukMpSU	14687	20683	20683	1619662140000
29810	3NLji2B5bSDKD4YJmYkMmcPqvwK97QqGQD1nuG2h6avDJU3ekKpR	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1637	816	593	12463	18974	jxHVKjMqfoKFUeYBa6qUw8NgKPevyaNBZtJCQUZ1iToZEaHHx8Y	14688	20684	20684	1619662320000
29820	3NKP2tYiWEwMcqWYCrcnzPBVisFeu8n4FEqMSvyKeNtxto7Z9yXp	29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	1578	1296	594	12463	18974	jx1p3Jbrpv3RfUMk8PPHHQeiQqxiPpgVCkRVv9jhMEvD2jAuCod	14693	20691	20691	1619663580000
29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	29836	3NKs3aUodGyJ1Bn1C7Eh4noNNyn8ceB7kQJMfvMYu3tJSC8TMbeF	1403	823	595	12463	18974	jxj1d7PpF3ei8ZpFLWJ1RCEtrFuLKeVktMY2mHVywp1BSFSybfj	14703	20701	20701	1619665380000
29840	3NKM4PWvQfcgGHZzndWNZyZ6mNJzZa87Ct7ysth8h5TVD8HpNuB4	29838	3NK8ANhJTsamWXkxo5hB2THGc4pHyCuaFvu3WTMjgKxz9DunnW5K	1406	1393	595	12463	18974	jxEJcN8aPsTSD3wjxwjDugnRGAWsz3wi5dS3XtPts2jNUNJjuEC	14705	20706	20706	1619666280000
29845	3NLHGPvSdq9XqEXr4t5zMpz5dNhGhXa8yK5g3SQcR4dwH5hd75DM	29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	55	59	595	12463	18974	jwzohvDRhVBjM9n187D2tViE2caTwEFtzhPQYz3C375DGKF2NVB	14709	20713	20713	1619667540000
29850	3NLZibFsvkwTTCx85F4LB8Dw2ENfT4w8Kxt1H2FzbW1iGMcLUWdm	29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	1406	1393	596	12463	18974	jx6qztNnncKMib8cEswsujAbv65K7WfGGP8FojeEYwiSXTA6rK1	14711	20716	20716	1619668080000
29852	3NKwLcVuWWAovBdvJU3ivBGScE6rkZi4dV6GhRsM4SFxu1t5HPLo	29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	1590	1174	596	12463	18974	jwqVTDd6BAv8xYhQDbKCLDJ6XUXQteHQUwrpt7ghDXBfdKjQUNa	14712	20717	20717	1619668260000
29857	3NLadxQFSH1SzTEcystMP5wqP8V9frzXU6Rro64jwchcRQAPVtZ9	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	1474	1083	596	12463	18974	jwHtxRntU9vJPcFqiU7Jmpb3nSJ5vFyPHnQqFb5NHiQmTLHAQUu	14715	20721	20721	1619668980000
29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	29858	3NLVZkkzPF7Gr82nXnnLcBoRLYbFapCUHCNeVHPSKPRPtRenRBGB	1426	998	596	12463	18974	jxZAmbXZ8sghnhEHSUuUs4ug8zuVWMVnQZBUReYvXouHJ6nJUVm	14717	20723	20723	1619669340000
29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	532	1303	597	12463	18974	jx3dF56h1KahspqtnstJ81N3TxKdR21TWe7TavVhT1Togez1Qvp	14720	20727	20727	1619670060000
29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1406	1393	597	12463	18974	jw7NuCPaBVTBh5ghMkNnszpWghaizQxPTYfJJNKjiG3gFMvDQPT	14721	20728	20728	1619670240000
29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1406	1393	597	12463	18974	jx27QG7LK4ie3bvA2CAfDg4GXexzegM9r28NUpSWe3yC6XCavS8	14722	20730	20730	1619670600000
29874	3NKCiLH6prszaTpnVmAvnjVe8JgCPaJnGHZ9SuEyJQoMwpg3aeSd	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	42	1235	597	12463	18974	jxgCUkvwvqKk28sdsZRFEXiaySup8M9tCQw7QaHvh2XKhioZszW	14723	20731	20731	1619670780000
29880	3NKu9x5RybQ3CAW8LQn6XeQ88PM9ioBsUYrG19USEhPhZLZAo3yt	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1559	1353	597	12463	18974	jxTvbnLu4DvN2WpxoxbtmrHYTwQGs1VmTsM1xwAdKjjhBgRxuLf	14725	20734	20734	1619671320000
29884	3NKEoE2Fm8SV1V3BsPgB5YzsELz5zVGaUZxnW1cPFeRbgBZZafsB	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1651	1301	598	12463	18974	jx3FtxwbAFbDGfrFaBQ3dsFvPXVtZPM1xM6hnK6CoxDN9sHzVUL	14727	20738	20738	1619672040000
29886	3NKqsK4RCpBFCKBcV5tfWyesV1RfrpziCBBLbeKNr9x9JHaaoLJ2	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1406	1393	598	12463	18974	jwTxVmTqkHW6cdgxHniN8mjREtAT2EbKrcB6z1eTxKq9k99PERb	14728	20739	20739	1619672220000
29765	3NLwDVdBkqWt8FbhkUjnd37C5HotMjsPUF3A7mhEyzza6URQxMtA	29764	3NLD1by6T9JNgvWT3dAjKQWbyqve4ZYA18TDa2KhPNg11rd9h79i	95	95	590	12463	18974	jwnQfkVbBpGHrEcxQw8PAgKjp5KNvW5Ju33MSkfvXbsFMaQ22zm	14670	20656	20656	1619657280000
29768	3NKyzfiU9QfPW69w6NvRsuwoxi1vBk5zF6ksLJbHH2MyZceBpEDD	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	1647	1302	590	12463	18974	jxadf5MMs6NR88XwKW5Jxd3EGCsMS4gb3R6jciVgT1ymBSwruv1	14672	20659	20659	1619657820000
29773	3NK54r4NwTsygDX4LrBjeKRU4a11eBWneEGgJVAH11HUcFLETYDg	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1645	460	591	12463	18974	jwpo4Zmhg1U9Mu933d5rJvTT1uAmZnhWg4eVWuLUCbzDfZeSaew	14674	20663	20663	1619658540000
29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	29772	3NLjyCkZpc3Kk1eyEQrW32fSs53UGd9JHKFKjZZBLZEgMdrCmTzN	1532	253	591	12463	18974	jxDnBtu1J8o8SYoSLCTu7y85YpXDowv2pHgXVdUHP8MVaRUZLZh	14675	20665	20665	1619658900000
29778	3NKjQnXLnxgcsdrB4Q43GpXycYeik2AiWftuGMmrxTq44vwEFE2x	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1501	1114	591	12463	18974	jxfWuLtv35XKe5uRhax9ryq2AJKTSpZ3yoREaj3j8NHTomXnypj	14676	20666	20666	1619659080000
29779	3NKCoTce8A57A5wki23nLyxZ4sYQsKA3uChbRyK63CFbvNSw9i3G	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1542	1304	591	12463	18974	jxvGm2cBMvM4mYKXcvg9AW2tLh6N5ELNtYVHSpfDvy1i4VurvTo	14676	20666	20666	1619659080000
29787	3NLjynDPVHSFXwWp7W72ZPBgWmsKYhTw7jnToguLjoNt3pE4LQU7	29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	1419	814	592	12463	18974	jxMR93B4XstG4KR9L7pyr7Ub83AhpkoNgQTCwNHpXSHHNdwJzmP	14679	20671	20671	1619659980000
29791	3NKijusexbDhwmV6J36MjW4jiEQvPJcpfRuSw1y5uWGaWhc16Ef1	29789	3NKLc1wXCYwKgAhURoEe3na5pSAFFmaDJEBhXmkZzTWF3emw7mNX	1618	527	592	12463	18974	jxM6YhNRfSnXkE9yF67mha4CVznd8Y7QgnyTYwgX5ucsVfGYjg2	14680	20672	20672	1619660160000
29796	3NLssuHhJqdouNFnA3L9dBkUAxbfGzEciSiGPBetiGTvBVRS2cd2	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1624	1334	592	12463	18974	jxEJAfd4gYMEfPsU32vmPKd4BfEnep8Ez3cuVKH1xxJuCyLbqJf	14681	20673	20673	1619660340000
29798	3NLmrBuo7Bxv4myywNqRWA9PLezvDKw2fLzZ1i6YbtQZFB9JAXFS	29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	1490	1148	593	12463	18974	jxyF8ojrv6G3gFVh4T9xK2t447dXKLaRVVg23JQfsC4Y5U1quGq	14683	20678	20678	1619661240000
29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1406	1393	593	12463	18974	jwCEugEp7pwnrNzD5KAPFqpBFNtYwT5b2FiN3VmxA4WR9iyxRGS	14688	20684	20684	1619662320000
29812	3NLUMun5cYgKUEhis1tRFAjQu88wnNF3ar8ezrWRp6psD4gsNzuZ	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1619	1275	573	12463	18974	jxV5oZWxtn5ZsA1fpoeyd4hDJ1Ct4Z7vXQZLmEMR9Mw3FSEzKjG	14403	20684	20684	1619662443560
29814	3NLUfr7UgQSjuMfLRxJgd2rf4JzqUCCSmC2XRxr4wC8vXiVcdpQf	29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	1601	1262	593	12463	18974	jxKW1znJEXPGcF2hYgNmnn2TYvFxM4FVF8CBaVW2mX55Uay1Hmn	14689	20686	20686	1619662680000
29816	3NLYS8GjLApbPg35SJfWHPJZfb1Td9et2JdZddt7NR9xJqmGntCT	29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	1503	1031	593	12463	18974	jxyqwfZqY1cWEmXEV8hzcrmKT2BnV5ZFurvsuv7HcmHDCQpujUh	14689	20687	20687	1619662860000
29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	29820	3NKP2tYiWEwMcqWYCrcnzPBVisFeu8n4FEqMSvyKeNtxto7Z9yXp	1617	1288	594	12463	18974	jwUvSc3thewfwZgjhUB9atmzcqgQVLJA637xHkQTKypFYBkM7Tk	14694	20692	20692	1619663760000
29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	1460	609	594	12463	18974	jx9aAvsgBWKb1bAx4PreKs7H3UhcZ1MBNMrGyH9Mj5wCR3NGRjC	14695	20693	20693	1619663940000
29825	3NLR23zpWkmvGhuqqgvYDJ5QS4vWsvY1qYCEtsFmsSuH5Mnjh96Q	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jx4ER2o4aLp4NaEY9iPuKwp1AkQXqzd1Rf23nh5BgyiUef9Urig	14696	20694	20694	1619664120000
29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	1426	1364	594	12463	18974	jy2JEPzGfkTvEMuTUZBmaeAJTc9Z2f5CxoQK82tXtKC8h68w44A	14697	20695	20695	1619664300000
29832	3NLLahDjrEEufYGo8zrPzec7ZyDo3qKh44w9usrMRfPt3GA9wRBm	29830	3NKzoRwUDNLUSck9ZvYF9VG7ErRiXHKMcNGVVYGJgZUi1WrjWMGR	1646	1228	594	12463	18974	jwmeiffow1DGY9v6Z62Yq1vMYzzJpS3ggXtAQvXkGs9CFnjqYyh	14699	20697	20697	1619664660000
29834	3NKN7guVjZXn195JSqfPmJWKutfDVuLdKvDGMYx5nuEJunw4K7eM	29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	1501	1360	594	12463	18974	jx8asMM7FYkEKnkuF2Zpii3spP1wKqfuQyPPwph2Cyr4WuuH4HF	14701	20699	20699	1619665020000
29836	3NKs3aUodGyJ1Bn1C7Eh4noNNyn8ceB7kQJMfvMYu3tJSC8TMbeF	29835	3NLvTuN92b1vGfbZkyRMZ252zimM7tmRT3ub75hujD592jPnTrKz	1503	1031	594	12463	18974	jxpxMEn74RyAgLxcDVKi9ZjkZcuD5uvEEoNPGKq2FjNarxkU6aZ	14702	20700	20700	1619665200000
29838	3NK8ANhJTsamWXkxo5hB2THGc4pHyCuaFvu3WTMjgKxz9DunnW5K	29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	1405	873	595	12463	18974	jx1uJPVQcrdDj7zSfseAh8v4zCGRod2RLQRARTaPbuFKD8js32K	14704	20703	20703	1619665740000
29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	29841	3NKJH3PSN5zooQSb9hjeSCMkxkeZSFonuCgivM8cTBSVBFgHyqLN	1407	1395	595	12463	18974	jxAWQLShpjG1DsxkR2GdhH11PBwRcrFmpguYrhJVxh7NzkPPMSf	14707	20711	20711	1619667180000
29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	1578	1050	595	12463	18974	jwZJY6o9xLJSMBMWmtsfK1WtAcnAM1NKuzmgZHAe3KFxPxya8ED	14709	20713	20713	1619667540000
29846	3NKYri2aGPrrY4cJ4JRmF87YfNBcq6ubtMi8pV7N9WEs7vgAegg3	29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	1578	1050	595	12463	18974	jxnm3KTVs3MaUxjP7Ks2GDG1L4yubEbnwavsnLUi9vtr2GiJori	14708	20713	20713	1619667540000
29848	3NLCuczniMWJEcaAMEMCK8DwQzskCStVUu2QQDibDoAoPMMDMQpB	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1405	867	595	12463	18974	jx69JVnEZVLFULLNZw5bU5QHurEwBGn7TgpGEtM2evGmZrxgDXx	14710	20715	20715	1619667900000
29860	3NKRQdeXikKqcKTEJUuuwjmp5fP1ZivSUhVcJg2nK82Xn6Q7nhkD	29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	1402	906	597	12463	18974	jwFWovP5XLEXPP6HgfYK4QzxcS9Sv51ErHBme4TEn15YdJhiUkK	14718	20724	20724	1619669520000
29865	3NLHhUkk2gqs7grDSGGJwcAzWXnmExmaqLacRup3e6sW8s9gxG4Z	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	1553	776	597	12463	18974	jxbpUW9qpD8WgURhFmeq7iJp1vA4n5q6D348UyHE3J9npXS1rKg	14720	20727	20727	1619670060000
29869	3NLFrnZ6Lg1MvFtiFP1U13mYawbbqDLrqadPLWifZHQXLuzaQC3V	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jxPKppcihbv1rxJ2uezs62JXxxNrF5CbX77QcqBzX5PrZ939FBm	14721	20728	20728	1619670240000
29872	3NLKwux9BjLnxsDYWGWKZayAKf2YwaMCCUwvooKxGHCy3mk6yuoz	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1405	887	597	12463	18974	jxm8LTg7pR91mF9VmMtySNRoNdbgDeJQg3e43oumbZmNpUZ5sfP	14722	20730	20730	1619670600000
29878	3NLH3eNkmb2X7mtHL9L1FW1ZwX5Sxfya4nqhQ2A5HdQ7D8JqT63s	29593	3NLSQTFPimdvQLwM58WViEmFfxjGmuLVfepqGxNgin8SgJasVHRV	1516	1294	582	12463	18974	jx385gvpSp7qgUfUNVZZkkYRTh3QMQ6vJg5UkkkTgqVGdETeYit	14592	20734	20734	1619671320000
29883	3NKnKpUTjYUQ82gcWpj7Eqdn9vatZxudVgsuAmN9ZcVqKyZiHTFS	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1651	1301	598	12463	18974	jxFAQvHwvYb1QnTb8HP9WHn9svYzmE9Zo6Qb7pwZRAuUrXZH33w	14727	20738	20738	1619672040000
29780	3NKxG7SfKBXa1hh8qQbg1ccqCXJ6PcM6UBss43uHpXhmRBrpZW5e	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1637	816	591	12463	18974	jwFNNc8eq9pbtNUr9VoM8cyUgahcLLNGtw8fHDXFircQwsgxX4A	14676	20666	20666	1619659080000
29786	3NLVqvAddmtyyJCZQXvXQ6GakEGnjRs8jRjvPRYttmEPaU87XW5L	29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	1546	1339	592	12463	18974	jwvauxbQsTWBGRdBGokANmhncTmc7NS9ViKtHPadYxpYjgr8DYt	14679	20671	20671	1619659980000
29789	3NKLc1wXCYwKgAhURoEe3na5pSAFFmaDJEBhXmkZzTWF3emw7mNX	29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	1419	814	592	12463	18974	jxeUTZw1p3CKcdWQbjaUJFx93Rcoqj1c7N4qJevQqREsxWmMsf5	14679	20671	20671	1619659980000
29790	3NLSvRbXRRbUe9RCD3qaF4izfxszCEJvDdpiDFtHPX4iY5XAwvC1	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	1618	527	590	12463	18974	jx4KV9CbfiWsRLZYFcgh6SNzp84jPSnTL3ykC5nSeVgYGDhZaHi	14672	20672	20672	1619660160000
29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	29787	3NLjynDPVHSFXwWp7W72ZPBgWmsKYhTw7jnToguLjoNt3pE4LQU7	1599	1287	592	12463	18974	jwGWhsUNewYLxPEYWspaDPjGTqHaSFJCgGGySE22vZQAL6seJzy	14680	20672	20672	1619660160000
29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	1490	1148	593	12463	18974	jxW9SNY76rt9URjHF6983idnwhmvbbZtqodK8xi2wcN6UfZj3fi	14683	20678	20678	1619661240000
29804	3NKe1SmLuzfaztPQgrJoehNpfRNWCqFE21gva83uimwEUhBYB4X7	29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	1622	1230	593	12463	18974	jwq1BhVN37TKZRQa76evHhycd3zkSXekHvDchGtxrVgthT79SNK	14686	20682	20682	1619661960000
29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	298	1182	593	12463	18974	jwkSjCFEkzFMB8FqhoecuXayge3PwvrhZCgQwrqsZKMyYnL6pFT	14687	20683	20683	1619662140000
29809	3NKCCcoEN9PdxXnx97JiLcY7ETitzPwHKFdjo8h2Hqrv1TBqreAd	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1405	1	593	12463	18974	jxRESSTJQsW6hPgWg1EeRpQYZHeZdsA6fvGiHwwiu5SDAi4Gevc	14688	20684	20684	1619662320000
29813	3NKYgnSzRp7eQj42RP96dbXWS1CVSjZPgqpvLRPA7x55bqbmNC7w	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1601	1262	589	12463	18974	jxNhxRbsnuQrMz19rmPgQv5nmhhgj6H1QCcBmTZxzsMXKgMKSsE	14666	20686	20686	1619662680000
29815	3NLj76yuDCzmzfCWUTC8vemroNuCVpzSBW7SzLwqd1676PL6dX89	29814	3NLUfr7UgQSjuMfLRxJgd2rf4JzqUCCSmC2XRxr4wC8vXiVcdpQf	1503	1031	593	12463	18974	jxXu3QZiyXEGPdKfebrR8kPfnXs9uTYhU7yFjcJ7ijwWxbULMLX	14690	20687	20687	1619662860000
29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	29817	3NKqJ4KzoVV5EyJUdxq1UQuTdE8nBXh6FNFyadvVvGM534g4P3WH	1476	1371	594	12463	18974	jwmUEKHwm528nnWxxmhfTZ5aLNyjZye5ZLAv2nNXKJsqGYZWsuK	14692	20689	20689	1619663220000
29822	3NKmEUadiGtB8rzcR9LmPGbprpm1hxFHMJWfSgRbtftQfakiGBA5	29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	1407	1395	594	12463	18974	jxQ4y8r9PVc4heS1hJXx1kAckzHy9JTzia7YuzXfqxD7AWtsMnM	14695	20693	20693	1619663940000
29829	3NKQWxELCwbJSMZynGwMQ2z8yzLMU7Q6raEc3tfysgRq7mJuQ2uo	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1610	948	594	12463	18974	jxw1u9WM9DqDsnXDPN6pPG3nBRXEFfe1U9mrK59WLLbbwRFgfLK	14698	20696	20696	1619664480000
29831	3NLPv52nykzixR3vdjfs9DCyDMS6AuTy3QfQ4Mg3jf4fAAB2shMu	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1624	968	594	12463	18974	jwERZwpfkUKY3RhQmX6HQrbEf7i6ZNQvMDU4cr7qrTH9ZUvyqET	14698	20696	20696	1619664480000
29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	29832	3NLLahDjrEEufYGo8zrPzec7ZyDo3qKh44w9usrMRfPt3GA9wRBm	1613	1349	594	12463	18974	jxV44qavrDwH1hccvpyz7stLY9gr2Yo8KxaF2jouB2E2NytJ6Uv	14700	20698	20698	1619664840000
29839	3NLjfdoFBuRL4Rn65btWsJf4NMFuTBhU3WKK37su4yuEmGw8JSou	29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	1637	816	595	12463	18974	jwNEr9wqeLsCwoRbAWzacBQHaRdhfUhfuB5PS8wt8Zw2b6H4Cx3	14704	20703	20703	1619665740000
29841	3NKJH3PSN5zooQSb9hjeSCMkxkeZSFonuCgivM8cTBSVBFgHyqLN	29840	3NKM4PWvQfcgGHZzndWNZyZ6mNJzZa87Ct7ysth8h5TVD8HpNuB4	1622	1356	595	12463	18974	jwi8dzX6cF2LkWJyQpdfADf3P3LvXJEfPGCm9yyRd7XR9qG2gTm	14706	20707	20707	1619666460000
29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1403	824	595	12463	18974	jwZ6WamdMysr3y1ivr7xZwNykMWYRvBgkioHGUw34XiZHsxeutd	14710	20715	20715	1619667900000
29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	1407	1395	596	12463	18974	jxWDnyGKwqjWX7YG4zKHA1WL1SuWKyp762JfK57u5BauoSBuwZ2	14711	20716	20716	1619668080000
29851	3NKm9M8Z3zYeAbeNL71tHPqmLVaVpiYUaCmHs52b8Q63it5mkobo	29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	484	1319	596	12463	18974	jxC5tnsLJFJ9j8T5bn6WJ4ukYUrLngaJHpxgUPM1HjVsZDy7q1G	14712	20717	20717	1619668260000
29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	29851	3NKm9M8Z3zYeAbeNL71tHPqmLVaVpiYUaCmHs52b8Q63it5mkobo	1451	1046	596	12463	18974	jwgYDx7rovPbzaziXvJkYTVpcrvbKFotwJvF66ffaRUELcPR32e	14713	20719	20719	1619668620000
29855	3NL8cVdsnRQiLYpw1pkQ9dqwgcgAgDPWLStsRDwGg4QbBj4BPWe3	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	1407	1395	596	12463	18974	jwceaMh9Cx2wWHoVuA1UJJqhZxjSvZXdTrPYhajZ7i6PYZ5rKT6	14715	20721	20721	1619668980000
29858	3NLVZkkzPF7Gr82nXnnLcBoRLYbFapCUHCNeVHPSKPRPtRenRBGB	29856	3NK97Xj1j6ufSdqQj8u5LPUbYUvQABFCjoLxhxP5KJDtxj1BqvTQ	1622	1356	596	12463	18974	jwbBgS29GPD3ZPPtWQizz2voT8NbXabnZNoYSXeStt8xM3MGM3d	14716	20722	20722	1619669160000
29861	3NKYTX12NzCgV7jwydiGJHwrR4pKZFih1Q3KqNekSkr4C17ZdP5r	29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	1673	1368	597	12463	18974	jxWRi3gLN4UyPqah2mLYTSquD1RHm7NLcs42j4FpA4qLAPkBsDR	14718	20724	20724	1619669520000
29864	3NKsf8SbuhXyEPu9pvNvQa97qN3gBfdSYhMhASV22gujRfkbD4Dd	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	1600	1006	597	12463	18974	jw9Ntf8g3czsEQPRLBk1uWWTdFVAbdSQbCihJU3LkfoBv2BgZe9	14720	20727	20727	1619670060000
29866	3NKdKnPeGb2oMDmghYztk61mX5NyguJ2h76kkShseEkP1xAW98ZV	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jxkeK8z3XyZbzU5PxUdVndJzMieL5Qx4kavou6tN6CBdGTP4xKv	14721	20728	20728	1619670240000
29871	3NLxxedUxyLGjqTNPm2EtECUKTSeogFCtKNwpYqunmdxP2YQUqJx	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1422	1337	597	12463	18974	jwboKR7pTZkDX7JXvXErMPWJu3t3KHCDNhkTWr3U2x3GNT8cwre	14722	20730	20730	1619670600000
29875	3NKCUXHdDMsUQW9QEfArjqFbkzG73Uv3hP7D9ep2eBcCRMSBZEqu	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	1439	1033	597	12463	18974	jxX1zCmzAFiXeDCJxciRPdgoKYq3SGF2VJPYUNLMTN8T8pLYqV7	14723	20731	20731	1619670780000
29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	29874	3NKCiLH6prszaTpnVmAvnjVe8JgCPaJnGHZ9SuEyJQoMwpg3aeSd	1588	1266	597	12463	18974	jwqfwnxhW7g7HofXGn8Yqey3S2sG2rmxR8ZCodddbuEKNEFHPWw	14724	20733	20733	1619671140000
29879	3NLmsNwngxhH2NbS3YMG34dqd42gApdv8TeLU5a7CUeLWjBPLKkN	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1406	1393	597	12463	18974	jxyAxYbyteWXvze8YzsGXPFLAFkCgTf9MN2PjRGqYFB51kJAtKV	14725	20734	20734	1619671320000
29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1547	1012	598	12463	18974	jxPEVpxt92SU6gBky2PGJevptBPFXKStFyC5MX3t4QkBmB7YbT4	14727	20738	20738	1619672040000
29794	3NKtVYvXjwgp6QhEXUANjxio3rjJKg6zn89jWBMwc6EZVPXFYd31	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1624	1334	592	12463	18974	jwu8qtQjQSSTbNyT2VmQgLHnKJsNc3fHKnr3pUys5gyUFEXPokP	14681	20673	20673	1619660340000
29800	3NKtzMSaPyxcoQrJjJVatsCZBurukzC57f4QAkxRnFtD9cisrgH4	29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	1490	1148	589	12463	18974	jwSbUixaDkgKEXUAzSHs2uDT69bhL24vbX8T2aGDUidQcEotqPB	14667	20678	20678	1619661240000
29802	3NKuszyx4YdhJLaeK1S3sxm5YmEf3xHGbybi4A6nU6huJbMYgFZS	29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	1402	874	593	12463	18974	jwCujxXAcdQSeu8Ze3MDnK1dp3ASCUi9gCmGdNkAksVwV4dMdVW	14684	20679	20679	1619661420000
29811	3NKa1Qw7f4EVyzy5AmsHKUUKNAhK5KELdfbM1qCRdU5cYYWCdcJU	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1619	1275	593	12463	18974	jwALdAJSUaAGRzk3hnN1ubcViSmV6zrbysbXncHtjav9PgjP4Wb	14688	20684	20684	1619662320000
29817	3NKqJ4KzoVV5EyJUdxq1UQuTdE8nBXh6FNFyadvVvGM534g4P3WH	29815	3NLj76yuDCzmzfCWUTC8vemroNuCVpzSBW7SzLwqd1676PL6dX89	1407	1395	593	12463	18974	jxFugyNpUeZtG6MqtdVAJrnM2duAeXczZHdwmhpxu79pvc3Z5Bh	14691	20688	20688	1619663040000
29819	3NKyYtdGj7rccnBptyjK8pYYVRAeK1dmDpuMbPXKwoCCHjWifFJ5	29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	1406	1393	594	12463	18974	jxdeG53jE49DAXwvRAZVK9HBrG6cLhkvLcvNqrKixfBXRSfdqbP	14693	20691	20691	1619663580000
29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jwcEwiDNQc5XkdwdJ8ZZuSmDqzJDYKhWubR7TfAkH9e3bMi57Do	14696	20694	20694	1619664120000
29826	3NKte59rsGoF7vK23LziTy9QyKqENbvBsntChef4a7Kzah5YcbCe	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jwe71REYXGpwxQRCqZMRN3K5kXpCJ73G7ZUw3Mynu8VLBHa4RUx	14696	20694	20694	1619664120000
29828	3NLL7edpRUigzSU68W9Kj6rqgP8rdQvmKsnxcv4R3Xsv1QaWozmK	29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	1596	1363	594	12463	18974	jwULhy1KLH2X65FePw7KqQzjtZYewLQBGwJPsuxSfXATk5eb5Cq	14697	20695	20695	1619664300000
29830	3NKzoRwUDNLUSck9ZvYF9VG7ErRiXHKMcNGVVYGJgZUi1WrjWMGR	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1624	968	594	12463	18974	jx5CqvFZPd66iegLrn4ezrKSdMLr3swujj56H4WyJSc9TkQBhg3	14698	20696	20696	1619664480000
29835	3NLvTuN92b1vGfbZkyRMZ252zimM7tmRT3ub75hujD592jPnTrKz	29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	1590	1174	594	12463	18974	jx1RVZqxMUzWqjuA1KWu6EsEmWHcChdep3FfSaBKmWexdLkT8GM	14701	20699	20699	1619665020000
29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	1553	775	595	12463	18974	jxy314BoWmqUyhVJwW8hN6nSenJWcmBG4gXvyAHkk3YKDcUPwaN	14708	20712	20712	1619667360000
29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	1471	1140	596	12463	18974	jwh53wK738yZf7D6F5xPYLPkMYhu7k4okdJT6VUqSTcoGNwKEdm	14714	20720	20720	1619668800000
29856	3NK97Xj1j6ufSdqQj8u5LPUbYUvQABFCjoLxhxP5KJDtxj1BqvTQ	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	596	1180	596	12463	18974	jwrdv8D9FvnMj79qGN1KRtM6WNARJRAiXpHDm5ecPinV5EirADi	14715	20721	20721	1619668980000
29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	29860	3NKRQdeXikKqcKTEJUuuwjmp5fP1ZivSUhVcJg2nK82Xn6Q7nhkD	1403	802	597	12463	18974	jwcLogyL2jxyFsAwS7bgHvHcDCQJcUajVaKi5ay2XCHjUFaw4gy	14719	20726	20726	1619669880000
29867	3NLSxffnCjqGo36o7ZASHQeF2FvTwRPRnr8VUvzvDFykiaiJFJq7	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jx2fCRGXgWz9KmU5jeALMCGxKPsHDdzREKEDLtvHadV98zdBApz	14721	20728	20728	1619670240000
29873	3NKTenmTEkaBncNbBxrdSjvezRjGVa4a4yseAbaN1TP1f9tKLdFg	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	1439	1033	597	12463	18974	jxeqhZ5HEGKZns3ALvDrBath8sRypNFXnTX9va8AFz5UERbovtv	14723	20731	20731	1619670780000
29876	3NKgLpdzKThUtdgJoiqENopinikgNDH6jtbzbct64Sc8NFy732mH	29816	3NLYS8GjLApbPg35SJfWHPJZfb1Td9et2JdZddt7NR9xJqmGntCT	1439	1033	593	12463	18974	jwTs8ZbNTC2WH3N89pxWTVep8QoXoPT5qaj61fndRGXCmKDYCUh	14690	20731	20731	1619670780000
29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	29880	3NKu9x5RybQ3CAW8LQn6XeQ88PM9ioBsUYrG19USEhPhZLZAo3yt	369	1312	598	12463	18974	jx88mzLk3d21xKz4rvZDixZAYciF7jbzBpAdh4B55zVhyEe1Vrv	14726	20736	20736	1619671680000
29885	3NLB3GHAvj5SUVH9mqXrTUynzNwt9HVr9GxCmQL57JQhYDac4a9v	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1407	1395	598	12463	18974	jxW56DK82iE4mB4N8mPWcNkv6Zv166x1u9xJQYN66K5XYFx6gsX	14728	20739	20739	1619672220000
29892	3NK59Vh6XVtKptKuta3GjaUCawFqJ7PbV8bN4GG7HZyDCBA3ND9u	29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	311	1307	598	12463	18974	jwXHFs55Kjf2ci51ffNvzgNmwwaxXUQhojrhMND8WpmNWygZz8A	14730	20741	20741	1619672580000
29894	3NLwXiUcApqwwQzFdmRwYssBKoMMdpEg33ajpVwnzw9s8fmNZP1k	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jxNuFEufZjTpscQGLwv8yYSTYejA1jR1bcZVtiTr1mqodEV4FJi	14731	20742	20742	1619672760000
29898	3NL6QMZSH4WqZD5zPQeijLG65ASfRtkbcNzwxtNM4UEnrycZcZ15	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1407	1395	598	12463	18974	jwBNpNE2zopS58eH1Xr7K71gXRspatNwzUjE1AMrE3RHYcGywsC	14732	20743	20743	1619672940000
29901	3NLw6qqeJtz37QrZz44s6r1yWtjHGTLHiYyi8d1RKsW12GSEXLVZ	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1624	1334	598	12463	18974	jwtcZ6hLHTqGQYL3Ln8digEya5f6vTKiAsKqxDh38wUuCdrtdgn	14732	20743	20743	1619672940000
29905	3NLtwm1URHAtv78CzvLNoSKnGFNagFMAhLKK7FEwpJb7g1mX19B3	29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	1675	1342	599	12463	18974	jxrpp8kgYcHR44NyYSEyz991aGbFAeh55MwPt4c5JrRiaUWmjSe	14734	20745	20745	1619673300000
29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	1481	790	599	12463	18974	jwXA5rNLen5yuJ7k2XiGBB3B31qM1qSWf3RoFreJusbz3LyTE2Q	14735	20746	20746	1619673480000
29909	3NKYpCDZedpb53cE54S4ohibT7tkhGUZJfTZK455tjS7PMy1W3rG	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jwW4rVxFSkSRdrbPWwSd9smSPL8Viip2MbK3kPDjsY5neq9BA45	14736	20747	20747	1619673660000
29912	3NL9nQzwhRmwLzEtTZVP3EjyquB7X3UkZqaHiJYByAeWgx6MV9VF	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1419	814	599	12463	18974	jxfyajs7xkMWeHCThPqRVDmQeMA2as1LKWZZq6WZuFt54TS7Rvu	14737	20748	20748	1619673840000
29914	3NLZfY7UJuFXR6tege71HVk9pKgJZ5S6bZqbviFgEq5hQZvJEUWj	29788	3NLMGGidcFPRyvyasLRNDqz2jwE1w1737M7eYpi5VREgRWRZL1oM	1419	814	590	12463	18974	jxKiNax4c3nTyF3uwN6gBgZyn7zy5eA1CKwd15YwXSyQ3SAzMSD	14668	20748	20748	1619673840000
29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	684	1226	599	12463	18974	jwE5nKZFqos3rPqLYVSdqEjscXLJW9pMungcVW6hNgP8xMtZRpz	14741	20752	20752	1619674560000
29927	3NKYuKh1twhyn8eH6xWdVNzVxhAmeVyFumsi7D16oExSE79qcHqM	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1460	539	599	12463	18974	jx4B6VvaoB5XiRJBGQyemwfSbCTUC9EXAS6cCsepT7y6GKbohxC	14742	20754	20754	1619674920000
29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	29925	3NKwmKQzjg8XxpDbtVtjsx8uPLaGPRN1X7QSkeD9bzhLuFkSLgde	1500	1051	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14743	20755	20755	1619675100000
29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1553	776	598	12463	18974	jxnGBeShFk6o4hANR3m9KWpXXwtLJsGN2jC3oaaBdi73kms1huJ	14728	20739	20739	1619672220000
29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1647	1056	598	12463	18974	jxUPqLZU6aEHwsTmuKWqUJs6fYw5jo3AZtLMxjQZaRQPXzhucP2	14729	20740	20740	1619672400000
29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	311	1307	598	12463	18974	jxB2iEQz3u7DrEppe4kxeaLe6fjywtq8LeUML2sf6aRqWtAMMnX	14730	20741	20741	1619672580000
29896	3NLwpNLh38ZBvu1f9CaJkkT2e6eVkqG9Zf5kiXr2j17pS85sV6xQ	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1602	1369	598	12463	18974	jwR2XzMrDKDNh8CUfgSsPaRbEjfeh4KvPPzTKw24pHhhtHxK1ok	14731	20742	20742	1619672760000
29900	3NKUqUKB3xvGEvEUUmskapcA7KxuvdzM1eTg8Rnv175ndTZoePRC	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	596	1306	598	12463	18974	jwmkyfq2s81rCVKsoBfJmDJYLFQ1eAS31bXb4esAZSgUWjTAW8s	14732	20743	20743	1619672940000
29902	3NLAbka4tTcTLKbZjUj1GSUbfah4XsxoqppeAgFjG1ygjdGNzHUh	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1624	1334	598	12463	18974	jxuWegh42yGK5P8GcvdwDhB9WaDHtTyuzUPsN1Qv1NdyWwDcAEN	14732	20743	20743	1619672940000
29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	1670	916	599	12463	18974	jxNjkMby9787YQqkKG9bf1CBK9fZFRoDpeh3pgXbiwrC457D7w1	14734	20745	20745	1619673300000
29906	3NLdz9BYbKJJZetTab5pjdStVLGeZNMSzBFYi5jrFfvU5CHAqsfD	29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	1406	1393	599	12463	18974	jw9AnVkvs9pTUK6NFT7CnnDAVqvhGkgZhPPRQFjzaa5RM5Ro9VM	14735	20746	20746	1619673480000
29908	3NKbhDhSeHYthsLUmc1Be3vvREFjixWbBnJoqTRnLerUGHAhTVkv	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jxvJpYhvWQfSU93gyGyZRTRNd5YZvTH7K1AuDg6CmoSsEVLTcPC	14736	20747	20747	1619673660000
29915	3NKGVQMHoj46docNsry4V1ngRhWUR1cbEzgrgxf82mQiEHyqx34N	29911	3NLDJh5Wzk4URYNUVbhDqRBwQwNwL3Xcbr5RUxMZvksP4ifMf1Uu	1613	1223	599	12463	18974	jwuojqaxanCRX72TGyedPeUbEFzLg1Hy8AvVKaYvqKNqhovKBxK	14738	20749	20749	1619674020000
29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	29916	3NLyQZdvAedFpbV6zGireD33o68LP7xWgU9nB5eYovck7BtJmh6y	58	1281	599	12463	18974	jxMEihwRfjaVGwV1kDjYGzuBgN2fgZZZtJjyQNVBus789pMbEG8	14739	20750	20750	1619674200000
29919	3NLqBJ3MwQeDkmPEHseWqhTyMhvN35MJ6xtzuJTfQrFe559f3dSh	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1406	1393	599	12463	18974	jwiHZTTEf8nkenQXnDjetzAHZnokTbG5opFfBWmELxeRrQG8MWf	14740	20751	20751	1619674380000
29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1581	778	599	12463	18974	jxhgFpe2KKXQrURcqiMmEBC1K9rpAQked7XY6qee688abRNYLb1	14740	20751	20751	1619674380000
29923	3NKpfxq23j3riPn54MUA4ZJoZvyXULSova43kvaQ8e6Foj6yvGQV	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	1406	1393	599	12463	18974	jxqUXjsWqyKKZCj83Sc5whu6RAiAZxXxvMXt2DJEz4GAZsJZt1f	14741	20752	20752	1619674560000
29938	3NLdkqoTgdAEZBEonnDnDwpwdQs67QsmS9qVnLva6tC2ribJw4y3	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1527	1047	599	12463	18974	jx8K8pcHeskBkZ6W2ceM9mJZHgunhxQoaq8MSGLGsPdinU46j8k	14742	20759	20759	1619675820000
29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	29939	3NLkYAucMi4oyVrmroq9fLaNjR9TcTCXBtwFNyMFC8YWWc9h19MN	1672	1039	600	12463	18974	jxLJpjdHPpivK9C2cxFxHaZbXoB99N3C5h5jSzKshMxQMKHT3w5	14747	20761	20761	1619676180000
29942	3NKabg6ApBecPUphUzY6LaPxpP11HN3G7Z2TRv1APFVw7WRVzDyp	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1672	1039	597	12463	18974	jwYn4sfvVnqqTxpPjiRd1nH9y7UWujZSd528nn1pVhfzVQpeopE	14725	20761	20761	1619676223872
29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	1507	914	600	12463	18974	jwTisWVpk9QkupVN37v93ocDUnG2SaxfEMzFKw3SPbDcTZXiwHH	14748	20762	20762	1619676360000
29946	3NKJjxnsaByvnTKKx1rihnA3eSnH1DHVXWLLZPLgiDHzLZ8JTGsH	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	1670	1036	600	12463	18974	jxpLUfrBS6Qmuck3BtF6EQyVZjT29Y4qJJJNDSNSNCykT7xodwH	14749	20763	20763	1619676540000
29948	3NLeMXSJK2yiM5zxSGCG4mv13tqKWTSc5pcBA2uhfXJgRD1nWAYQ	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	414	414	600	12463	18974	jxBFxNuojDywtbfFh4qdLHmRRSDS3qrPAmV5w4s19sM48WYcH43	14749	20763	20763	1619676540000
29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	1559	1107	600	12463	18974	jwcWjLEsD36Bk3xDzToTHtzKs6RxxZF6Y5qUCzjc8YeWSeCZwVG	14754	20769	20769	1619677620000
29958	3NLQQfuQUZMGivPW3DPFgg77X494onojDHaXPQ8jK9thLGfRSqEN	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	1406	1393	601	12463	18974	jwCzT1NwafHzU2SL7vTPGX8FduR3jJW5eb1q93HAFwbt2Tjm5Qw	14755	20770	20770	1619677800000
29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	29959	3NLU79ozLzD3L5Xq2aRiEgd9RJomox8qEScyePT2kzQEUx6YMSEn	1483	1030	601	12463	18974	jxafBbNPRt3JeiLFPa7toiM6YLMx646T3qDGMGsiviqcSnEkB9v	14756	20771	20771	1619677980000
29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1405	873	601	12463	18974	jxES3pDD3eV1fHGkE3Lde2VJajxAUnHUcpjcThHZshH6Wiut9qj	14760	20775	20775	1619678700000
29973	3NL6RYKyt7X3Zk6mjMpmswNbbNW9DKmGmALvv6yYCTsERAnbSiKt	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1579	1023	601	12463	18974	jwq8MszvbgQpcEiF4HKAZPgn4i877Ymx21CtvaH1a3bJv78zyDs	14760	20775	20775	1619678700000
29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1560	1045	601	12463	18974	jwanxdMnptzMpunmiok37iTick2FzTTMmK98Lwdy3TLGoKuAynE	14761	20777	20777	1619679060000
29978	3NLKH8ecDXo4qg3SFR362997hsNF8saiBK6MPe9RSntJbnLFjJMe	29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	1406	1393	601	12463	18974	jxCVJpHYkykKq69KpXj674qoP6jeE5UtcwC2DJyBtPcb297ZE5U	14762	20779	20779	1619679420000
29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	29978	3NLKH8ecDXo4qg3SFR362997hsNF8saiBK6MPe9RSntJbnLFjJMe	700	832	601	12463	18974	jxsyQJkotiPCeLvohj3FcsamFkERNx8MvAXjNve9v1LcFSVTdkv	14763	20781	20781	1619679780000
29981	3NKCrMkSLq1EGJ7dmqUzzzqaGbY3NxpKamutGs8U2zj3JLV3R8QU	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1476	1371	602	12463	18974	jwTaZDrCRjKi3qobNjB8QjPBtgKMLiqQ7zweL82789S2GGFhAjb	14764	20782	20782	1619679960000
29997	3NLWMGsGrrJLEBSct8sFPQ8R5qR1jFUUwq8fXYk2tJKZiZMRW9BF	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1671	1365	602	12463	18974	jxh8HTVuKfWGrt2jN34Hg2yHeWuFe3K8kGbD4KvtvLMcE8GoFUb	14770	20790	20790	1619681400000
30005	3NLTjhoynE5NfpFk526qGB8fBuyowXzqpaUgQ95BP8uQ75ULrvLX	30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	1602	1602	603	12463	18974	jxe93NYYmNmbrre5EJe5nNCsMg5kSwPdLoy8LxTp3xTnZ4aVyWH	14775	20797	20797	1619682660000
30011	3NKtHSnQmkDKfqtio2VkUoiic7x16uDhhyFisNTibApTTz64GM3W	30008	3NKGA4waPvVkECxVGJ4U9bNS5AmxiJeEcSDqZ9SF8cfTFuDX3kD8	1637	816	603	12463	18974	jx4rBU9b9yZiDfPC22e3Ngk83PrxEoswpUBWtdFnXjGWJ41CjpG	14778	20802	20802	1619683560000
29888	3NKTLS8otFYHzgDusPFSe5RmjEyHy9utNyeNNea2cQ2uNThFvspK	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1406	1393	598	12463	18974	jxRzCZpgaZYPEE5zzX9b32TTrKVqNAenx1i55gbxHD3BAFjD3F8	14729	20740	20740	1619672400000
29890	3NLUc9DeBx47vv6GiDG1WW3LCsLPtcE197TDEa8wNzciZKvm7P8w	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1647	1056	598	12463	18974	jxNXGXcCFeZbyMS6ZdmSSR4Ro3f5cxhg7LXzyYbpBd9acEikQf4	14729	20740	20740	1619672400000
29893	3NKCzPUZd4F22nPy5A2vHuMpt9m8FjtVu8QbpPN49XmYrBafwyNg	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jy2DVP4JvRNDabU9zVP5jRznyN52TZU977NCe1Ynwwif2tyTyvy	14731	20742	20742	1619672760000
29899	3NL3pD9vdybCkW9bQ5JvZPWosMFNXxbSkegyWcMzsNPuHneZia4g	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1422	1211	598	12463	18974	jx4YjqqA32PVdRn98TDcpt4MjP7S3b6YnSttx1H2irtx1DXc2Hf	14732	20743	20743	1619672940000
29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	29900	3NKUqUKB3xvGEvEUUmskapcA7KxuvdzM1eTg8Rnv175ndTZoePRC	1447	1099	598	12463	18974	jwsSHnnqCdjYf8rz4KiTrPvk9iMTvyQaFGdCAtxFiaoteMtkhfG	14733	20744	20744	1619673120000
29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jxSgHKNVmEmrD78AkRydVPNe5SvCwY3TdXn7oZmBK7xW1RS2Pcp	14736	20747	20747	1619673660000
29913	3NKbo38gN6wSyLXNYG5F4Pj7zyucikib8BiTq7XuzLWDvtPJiFu1	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1581	778	599	12463	18974	jw92FJeLaedfavDt8nTi7bkvSo95MTvhHmKH84kWwn2BpT6JPgu	14737	20748	20748	1619673840000
29916	3NLyQZdvAedFpbV6zGireD33o68LP7xWgU9nB5eYovck7BtJmh6y	29912	3NL9nQzwhRmwLzEtTZVP3EjyquB7X3UkZqaHiJYByAeWgx6MV9VF	1613	1223	599	12463	18974	jxZ61aMRXUpdxF646DmcMYdkuxZ3QZ6Ay6kAdUvNF8wt58shPiu	14738	20749	20749	1619674020000
29918	3NLNiA3vMwuaTRdEPd7SssWV4QCoewAoyVhNMgZyofTeETdzkGZc	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1593	1346	599	12463	18974	jwUSNKePcK3qjdh2bt5Z8xMV8rZ9zN9wxD8WppU6a48DYaURFSR	14740	20751	20751	1619674380000
29925	3NKwmKQzjg8XxpDbtVtjsx8uPLaGPRN1X7QSkeD9bzhLuFkSLgde	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1460	539	599	12463	18974	jwwtuQnAwiYpCXsyJH8pVJCWaF1bm8MBiWgz2EKHTCu92SCcDmx	14742	20754	20754	1619674920000
29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1460	673	600	12463	18974	jxLHEhnosgB1Zw1ZgkBSDWehG27sTD4jAsZ8hp2p8pcRW8zQfK5	14744	20757	20757	1619675460000
29934	3NLbWbm268S9duB8eyNZCagWrmL4TL7c3J495x6KxZgo441pHvZP	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1527	1047	600	12463	18974	jxvhp3JKiW6YqMvKQB89tMf2LtbxzXKY728saZFaX7FDVN3LJv2	14745	20759	20759	1619675820000
29936	3NKczHwtNYwRUebJPZquduLaLQrsnLAAQj4XYhTkNK6gkM5aYzrc	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1527	1047	600	12463	18974	jxb7FvevAmBdspwosx4D1HaXFzqu365wRto8MKW1dY8YmAiKjsk	14745	20759	20759	1619675820000
29941	3NLHqST7Bz1aqFJPvMaJF8h6cY7KwPs9Zxte6X9GtEcxkGnsxBLo	29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	1672	1039	596	12463	18974	jwh5pvgxoTw9TsSN1gXYv4j5k3GzQvLsxEZuut7fJf12ZbVW4CB	14714	20761	20761	1619676180000
29943	3NLRW19fWYBmky6ruD1hA7FDNBhU7ahEAW4gNUKtRXBPbC7azyg2	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1672	1039	599	12463	18974	jwpCpbSecBYmr7NwtL6cvhhkm44gceypFumsPWSc27ucehJHU6B	14736	20761	20761	1619676270320
29950	3NKr7nzcJmLb3Yd4n2sqdmn5ELLNuM3L7oXuhEykLc3oSUi931H4	29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	1622	1230	600	12463	18974	jxxpgD555ysgxj1UVzip8HqtbZVMRXskQRhsui3ViBWWrxAz3L9	14751	20766	20766	1619677080000
29963	3NKfrFNp8qQy2bQcQhzaaKR1UYCmHoBpkyzk742EtB3UJ2PrurD2	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	43	944	601	12463	18974	jwCwVnBDzr1T4ytANEeTsMeXEctWGX9doeakmu5YM2pfi3PAxsJ	14757	20772	20772	1619678160000
29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	1587	1111	601	12463	18974	jwsVw3WagsSCRpp9A1nL7YkC7rLGDA6SyZgZbRfEMSidHt26HCJ	14759	20774	20774	1619678520000
29969	3NLufAEhgDHoMn5keUGFWw8GWfkX7LGNpxv5dyeyB4RhVnp6g5ej	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1588	1026	601	12463	18974	jxx6W3XYbxuHVLGQ3HCMSsmtpYRwXTzLAePQDvWRJf3bV5GWWjn	14760	20775	20775	1619678700000
29976	3NKw5qj9aezk8chRdTrnsNxZsWrZBESVacZsEpNDzgtZwPKPSPkE	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1560	1045	601	12463	18974	jxw3JGShHbtkWEbhjrSVen2NXG9D4S2BQWYkkHZH6fxCkGvsQBg	14761	20777	20777	1619679060000
29980	3NKdb6nazespoTyX3uavWMiZTYyjp1ktMcFpLaVDiqGiseRkxnPY	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1406	1393	602	12463	18974	jxSsH7s5Xwr9RunGbMR7P6h8xMjPdBri2HuXePs1UiRxgzRn5tv	14764	20782	20782	1619679960000
29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1476	1371	602	12463	18974	jxDUTsEUavkoZisXxbXz78bkbFdJJLWqcivi7HxhdcwkBXediqu	14764	20782	20782	1619679960000
29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	684	1106	602	12463	18974	jxfjur3KrriYwto91qRfGqT6jNFbGfSUTdrdsRm13Lygow4myok	14765	20784	20784	1619680320000
29986	3NLPVHqg1KTKDNtsEWSrCNjZuGwAocQnHSwUmZBuVtj3gPNCZC7H	29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	58	149	600	12463	18974	jxiF9dBo4Z13AKfzE6wyJwf5tixvJ8oiFa6bzwzqLfja9JxJ3Xq	14751	20784	20784	1619680320000
29990	3NKdTfadMzuT2sP95bPUbsEe9UijUJBzHybx7KcKtdSYryJrgaDE	29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	298	316	602	12463	18974	jx49WpQbRitDLsdGKQ3eFr1hc2Rs18A2mJFP88SghD6q4oUu1n1	14767	20787	20787	1619680860000
29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1397	828	602	12463	18974	jxSG67X1QpTN6cqz9reiQPWyMqDpcPxyMckpSCNJD6vQgyTS4tT	14770	20790	20790	1619681400000
29999	3NLtEMwL4daHzGAmsxnu3v6VjdZmo2G4ujwJ8MCJaeG8ut8uL3L7	29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	1553	776	602	12463	18974	jwgfp2k32syJaC1NiCDj8t9eTbQT3xkTLmQ6J9bEmsTYGQ9HnRN	14771	20792	20792	1619681760000
30009	3NLqpEeaJ7hVducwgG9Q7JEVi6ixJPdZi4GvKDdM5a2RxZQHCkd3	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1460	1078	603	12463	18974	jxQpgz43ixV3RvZBKoRLEs2EPf2ACo5dmtVrGodeHpnwpFtQKX8	14777	20799	20799	1619683020000
30015	3NKb4wFmu6zwQZWLPTDiGFMFMXP5DmXdd5WQB3FtGZUsT1vuX9cq	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1523	1195	595	12463	18974	jxakaHEey1BkLoMofKHmUsr5kupc67HhtCARKhvZUSFzHMaMzH9	14710	20808	20808	1619684640000
30017	3NKpAc9BgXLtoXbqmYvJw2G1nYoJVmUgo7QVfaBu4uia5cCxEFT5	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1523	1195	604	12463	18974	jwm2pWHPsimSpbjCoHwidVb13wd6gVVcYwMQMcBy5zX3Hbr2KjA	14782	20808	20808	1619684640000
30019	3NL7KcWSEnbvWwhZEqLsNKr6MmT9Ui4A2AmAs2ogjyke5k3sdh5w	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1523	1195	604	12463	18974	jxjZxKmSJSQP5RoNwUVQdB5ujbiqHieapHhYPPus2qxYjpuWx29	14782	20808	20808	1619684640000
30021	3NKu9nF799KC824NaSCwapH4kHz3tWzbJj5oPLZDMjd7Fi2uRPYp	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1523	1195	598	12463	18974	jxj7pLKcp9FfMJbsqKiL4gsd6CKrDp1P8kCocPv2RVsLo196x6j	14732	20808	20808	1619684702030
29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1406	1393	598	12463	18974	jxSaedxcRNMvTjqgKt8qLagw1oXG29ZPyvXsBGPmPAsfYvfaSej	14731	20742	20742	1619672760000
29897	3NKG3TAUUNzgcPNHPXELeje95sYhgouMA72D2YzRGicv6JupuhBV	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jxLRhoKjLGeSDUiC3qdJcUpV27ABvEGYkHrne5TaUsEMpLCc3kT	14731	20742	20742	1619672760000
29911	3NLDJh5Wzk4URYNUVbhDqRBwQwNwL3Xcbr5RUxMZvksP4ifMf1Uu	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1419	814	599	12463	18974	jxEtFw49TDjBLnZG9TWfgKiYbH39uZA2yQiYYeTpjA9ZZwEMeWc	14737	20748	20748	1619673840000
29920	3NLt54wM7bkfDEi97Sr95oEM4T7PVPY9CQPYEr9z6r4rmrFM4GP3	29898	3NL6QMZSH4WqZD5zPQeijLG65ASfRtkbcNzwxtNM4UEnrycZcZ15	1593	1346	598	12463	18974	jxdqJg33XzxcRVVf5Vy1iH8WyAv2taN3T9Cc6tGdh9FBvF2xnAb	14733	20751	20751	1619674380000
29922	3NK2xi4LcJAXGdCyzd6QaUxNNYFNpJnVKvT3ErQQ8nrDWS4Cyg4X	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	1407	1395	599	12463	18974	jxma4CaEmwUCx3GQjvnuK3cgewy9HqvwGyqz6atHJ6wovpTSkaQ	14741	20752	20752	1619674560000
29926	3NKUMqLKUEHXPKJCp1fvY5mY15VfFMMsXpqDHNraCPvyR54QiCtN	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	484	1319	599	12463	18974	jwJQ56SQ3g7TjNQv3J4PQi5RMnt5118ZXoDtjRhSbSCAg6Vod1x	14742	20754	20754	1619674920000
29928	3NLoJSNRTyApiWHTLpVwUiy2Z2iCyFS1XfVvrJJCS8Xafn7KkrZN	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1646	1354	599	12463	18974	jxoKsySdBYXhxyQMaNNkLB6GaQbS8FgQDVT6obpEyjKLimGB8us	14742	20754	20754	1619674920000
29930	3NLpeS6Gc19pNo89bQucReySx6muQWaYdGB16fNPHF2Wtb33KNiB	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1500	1051	598	12463	18974	jwQmYXSSLBuJ4BarsyoJJNBtC5siFHQqqVuYx7LrZEnp1DTrQrF	14727	20755	20755	1619675100000
29933	3NKa7hqq3D2jBzSjWfaPgFe1MAtWpZBSn8TNeNrRzEYKHYQkeUcR	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1581	778	600	12463	18974	jwLZAbj8xPRcTH9Snn8aCYjFywieLSn7cZXuCr5pw8Ltdv4E5Qy	14744	20757	20757	1619675460000
29945	3NKi8v5JDFVULsKrFve5ro7YGVNq4fvQqBQxj81vR1AmxLuoFZ2y	29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	1585	1240	600	12463	18974	jw75F5vA8Xj8PsJwF9CMLQtY6Tqx1A3Bo5NAmR4ju9mb9pQKov6	14748	20762	20762	1619676360000
29947	3NKsFdhyEPt7gNHeGNyvA5kyvMLeY8S4PbPGjJW6htcrnPqeFQvo	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	1670	1036	600	12463	18974	jx2cRj3KuqDNAQd6Cvrp1LmJKvFQrq2gaXgFk6wDM5AtbyyPfz1	14749	20763	20763	1619676540000
29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	29948	3NLeMXSJK2yiM5zxSGCG4mv13tqKWTSc5pcBA2uhfXJgRD1nWAYQ	1581	778	600	12463	18974	jw8R5LvzxgQbNCGfd4QXyHu46BpyNwNq63pcfk7mknQ9zQ7vpWv	14750	20764	20764	1619676720000
29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	29950	3NKr7nzcJmLb3Yd4n2sqdmn5ELLNuM3L7oXuhEykLc3oSUi931H4	1649	1137	600	12463	18974	jx1nWYvMHEAG95CbxCcjDqYLk7o4kEfmrobhcKf9NgEc7EjgwyN	14752	20767	20767	1619677260000
29953	3NKjJdQY2EnLxsaUKGa6SP6SkazZGQbqXKo8B2ipynjjkYWa26se	29952	3NKMXTzwMYu3qGNhgRq7QUdp9ao8EFoa4i912zbFFDMiuymyNzX8	1672	1285	600	12463	18974	jxZomSfCGqCoaJCnza8NPmxMWNDQ45BZJbxDVx3FHCQyrTcHUcn	14746	20768	20768	1619677440000
29955	3NLxgVL16ciQty1uADgTUDJ8ijxVVJsZNXGxdLCd9mgwLRpJuSwU	29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	1553	776	600	12463	18974	jxqd7WSEDXsE5HfQYv6fs5wszMc2vNvVwHDMjeMDQL5TANMSDYC	14753	20768	20768	1619677440000
29957	3NLAgjey9YeSMRBHSoNJyEptZLKHoiTjFXsenvcveEK7pZUtZbVp	29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	1581	778	600	12463	18974	jx3bVEuoeYRhd6tV2NvGuobmaXGgn6WggayQk68wpmGcpZhjFVM	14754	20769	20769	1619677620000
29959	3NLU79ozLzD3L5Xq2aRiEgd9RJomox8qEScyePT2kzQEUx6YMSEn	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	470	1063	601	12463	18974	jx35T2Fm1tY3n3asvUBLP8sqwFMxtG7bm3JtudfFCBYSwfM3UjE	14755	20770	20770	1619677800000
29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1403	824	601	12463	18974	jwcp9gPC6fGimEZzzxmG7TLvvyM7D6KS4xaYPQCGtDjrrPAzgEr	14757	20772	20772	1619678160000
29966	3NKN6TSne8Wg5PJmYxXphppNRL5DFN4x13WvmKHQSo1jvqdXxvt2	29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	1403	824	601	12463	18974	jwUiomcCh6dqtrqydYsoZjifvbgcfb7Gt7BovNyvzKpsV4DHFzj	14758	20773	20773	1619678340000
29968	3NLbwme5etGSAiNkeVLbm5bncQXW8KyYAWqjoxwhmBdL6rKvm2Ni	29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	700	832	601	12463	18974	jwpRbmCbXvdtmpRLQsCEa3eVAZW3UbaavuRdtHUs6RXmubYAsp4	14759	20774	20774	1619678520000
29970	3NLDaC3xt7gQvk3mLbwCRqSNJ2wt4iHrXtQzpjEgZYf1bQ2oKb3f	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1579	1023	601	12463	18974	jxKXHu4X8S88ZgCHez1HUE3f2t5X65A34K7SKgNjfvA6ADDeTvf	14760	20775	20775	1619678700000
29987	3NKQzDN11himtMMCQrxBemCt6gcVGWcEwLLeGhNBtJiJVUE8yx48	29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	1439	1033	602	12463	18974	jxavAfiVRo6iWjRHeCM47nt1FdUkZjPV9vTWCZ7c13XYaCSC2Dq	14766	20786	20786	1619680680000
29989	3NLgpA2UP3RjVp8JP4fDqFhKbAyUt9Av9KPDAq1NHdJdTeaMYphL	29985	3NKnpsDAtYbqsggFHqopZWqAFEdcntku9v4mSVQ4dNA39u9RRUN1	1439	1033	602	12463	18974	jw9g3YFzbmEz7UCZ5dGBqwaZfxmaPzJLxuXpohjYU19q6xjH15X	14766	20786	20786	1619680680000
29991	3NKhRLfYE6xQ31CqJ2aUbV2XqEN7i4WBq412CJChkY6QQ7J8Zf7W	29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	1623	839	602	12463	18974	jxQAYv8j8d3hrGNjkPJJvST2psW6fSJK9bjPNrwqCKNBomLePu6	14767	20787	20787	1619680860000
29993	3NL3iEi1U6etfe3tRnUvzK63CHPjVJuiz8HDLvu7RXvdSZu4d6xF	29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	1656	1343	602	12463	18974	jw7eMUyeKP52joEx8V6jDBDReYarFhWc4epCUXn4KQxZXA2nA7n	14769	20789	20789	1619681220000
29996	3NKKMZJ6pzaZbUi7LLAZmSyw1ri87rsSdHpjnfMYDXm7VxdXR1qT	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1671	1365	602	12463	18974	jxzjReZQUdG95gTb8AGitcTETWaQcVeS2Suh6eYT1bUpcdDR63n	14770	20790	20790	1619681400000
29998	3NKKxPF2tCVRQMf7d9j9CX7J7bJPR1zGafPq7KnS2w1BLhu2wUVE	29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	1490	1274	602	12463	18974	jxpEi1Qzh2q2XZpTxgLYheMVDUSrv9Unb1CfNY2saezcvqC3fCz	14771	20792	20792	1619681760000
30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	29998	3NKKxPF2tCVRQMf7d9j9CX7J7bJPR1zGafPq7KnS2w1BLhu2wUVE	1593	1220	603	12463	18974	jy1VaozRVGMHJE6pur2heoVLeeCf7MMYoFYQ8FhopCqstoNWU3A	14772	20793	20793	1619681940000
30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	1581	778	603	12463	18974	jwpVGyZA8ANcsgxh3y8VTVUaXZtmVEeB4DhXgMuwvQ73rAX2Nyu	14773	20794	20794	1619682120000
30004	3NLGjikxSFTVPkwFsrLRvUwWa3uNBmTovu31i2VbQoYSWBQNJMer	30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	1585	1120	603	12463	18974	jxyRyw5wRi38NrMxgbqhxYPCQ3WBoNK7w6Wf93TqBsBXRPbGb4c	14774	20795	20795	1619682300000
30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	30005	3NLTjhoynE5NfpFk526qGB8fBuyowXzqpaUgQ95BP8uQ75ULrvLX	1405	867	603	12463	18974	jxvfqmMUPumUuYiozHFALcQ1UzuuTLcKEMwZyGhCUcRNU8S8gj9	14776	20798	20798	1619682840000
30013	3NKnvESZMdfA1Lyj64kppba4KiFn5kPhTqorzFjGVKycsvDgKheZ	30012	3NL9uNn1uSSsrEkGGtFPq61JLyaouVdQNK3JY2PNRDGvKiPtAQAW	1610	1188	604	12463	18974	jxU5e6571AeMwttopqL5M9tia9dmyW2DYtjYWq77XtzMqWEiMnV	14780	20804	20804	1619683920000
29931	3NKqAA2Ni6NMqSYkwr1m8K5BMGij7j8u4svLkKGbnn8FV8p3GKDA	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1460	673	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14744	20757	20757	1619675460000
29935	3NLSSFwsrxwDLfF9poFp6NagkMZfbprT13PS3gVYGXD86aSV7o5f	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1407	1395	600	12463	18974	jwKbA7KnrN7H73HeiTd2sum1zfN6UAg6a1829fsrvvPrg1MHLV1	14745	20759	20759	1619675820000
29937	3NKkULRFc1xZMDQzbW34qqT6srrvB3hHaMwcULnTbPfKdxoC8hbj	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1547	1132	600	12463	18974	jxRwxBeosWedxUoHvhsNFBPe6V9Ci3UWe1CGDNYf3jANz5hRpGx	14745	20759	20759	1619675820000
29939	3NLkYAucMi4oyVrmroq9fLaNjR9TcTCXBtwFNyMFC8YWWc9h19MN	29935	3NLSSFwsrxwDLfF9poFp6NagkMZfbprT13PS3gVYGXD86aSV7o5f	1547	1252	600	12463	18974	jxpsqjFobjA3K7MBHqkuPXitMzby4nLBMkxN24NtX4wnUskj5GE	14746	20760	20760	1619676000000
29952	3NKMXTzwMYu3qGNhgRq7QUdp9ao8EFoa4i912zbFFDMiuymyNzX8	29933	3NKa7hqq3D2jBzSjWfaPgFe1MAtWpZBSn8TNeNrRzEYKHYQkeUcR	1672	1039	600	12463	18974	jxXi6CzjmRd1wQLvjRG1PSuj9V3ffYoQoF8yeYTHjQwDPf2VTiN	14745	20761	20761	1619676314712
29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	1672	1285	600	12463	18974	jwVrDye8agJrEAVbefwSRF87unvf3Kdaa6MayWTJ724oWHPZzA6	14753	20768	20768	1619677440000
29961	3NK6CY7SHcJVqarhTNjVEhdN3aEZxWfM53n2zb8w8dD1ch2WbQHd	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1522	1076	601	12463	18974	jwP6cNvAsFDgVAJFkCb59HmA6MT8R7atTY1S8kj9HXHP4sSJwgw	14757	20772	20772	1619678160000
29964	3NKprrqScWyA6Uk6nUZ7PS1pQH6zqENpGRm86RyBV3uAU48DdkG8	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1637	816	601	12463	18974	jwswnpVWyJK2q6GiJKwcP9ESQeqTe5hU26CpDRdKk2sMtnuosdv	14757	20772	20772	1619678160000
29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	1571	1089	601	12463	18974	jwyZkuqLwjHVykrabvSDh4L35MeUFfSwDtoJ3bM6UY6kQsmjYY9	14758	20773	20773	1619678340000
29972	3NKctd96f694jfNRbNRaJYFSno1oMrqBeGPV34uavKmaAF9H564a	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1673	1368	601	12463	18974	jxnxBXAhCM6VwzUDMjGy7m1PmJa5Vxow8WEFKYUdpVnHDua9Bs3	14760	20775	20775	1619678700000
29974	3NKRzYAfrbYNSsKAUSUpHjjTx6FR7WAiRhs5xezPZHPgU1pTQxJX	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1407	1395	601	12463	18974	jwwvpbfQ2uTRKox1iwjKvvgSrJQg66yvwCRC5H69YnS4enfEzc6	14761	20777	20777	1619679060000
29977	3NKRoD9p3HDZbEmrtsrip5H4EBu3juYyocLTFo5Q4djHqW1eguFY	29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	596	940	601	12463	18974	jxn3U6i38xdyQfZNh5UF3zAhHJ3r9FeGwhggPb1NNk8eJ3F8bdx	14762	20779	20779	1619679420000
29983	3NKdCT83PR83UCmnno4X9ct4HdTfHMQqvjkCs4BV52tVCNbymzSg	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	1407	1395	602	12463	18974	jwwyuUeSU5tJUFFa3ZhFh5jrfE7UUkdu3VAks9kz6jVqTVuaQaS	14765	20784	20784	1619680320000
29985	3NKnpsDAtYbqsggFHqopZWqAFEdcntku9v4mSVQ4dNA39u9RRUN1	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	58	149	602	12463	18974	jwhz9aHeCmSk8TYaNKoWRoybSHzpo7HaCQ9C1DpRAS4RZU4bUEv	14765	20784	20784	1619680320000
29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	1439	1033	602	12463	18974	jxTc6X8ybXJmU7KkQnHBB1JdxgUdNPkvd4gzXWn4YUoeRgmbRxf	14766	20786	20786	1619680680000
29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	29990	3NKdTfadMzuT2sP95bPUbsEe9UijUJBzHybx7KcKtdSYryJrgaDE	1501	1114	602	12463	18974	jwe1wjiwasaX3FnFoFWDi7JCJ1s5JH7P72FJxpKVwUxkacmuTHS	14768	20788	20788	1619681040000
29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	1656	1343	602	12463	18974	jwcvQy4PcstTLiDH7E2T43peSyCF4Nm746K2Qtg9vAQnsDfgwyN	14769	20789	20789	1619681220000
30001	3NLv6UwsRR68LXhbiYGn8ms3vY8hZG4Q1zJk3w1oYqY9XaWTV7Zz	29920	3NLt54wM7bkfDEi97Sr95oEM4T7PVPY9CQPYEr9z6r4rmrFM4GP3	1593	1220	599	12463	18974	jwvnofJTUa3K8YRaEYhvjKTVFmBXC226dhUAKepR3cyhcHDnugd	14734	20793	20793	1619681940000
30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	1585	1120	603	12463	18974	jxd5esqQdRKMbN5V2MVyQNZhGScVYrdUkn7QEM88BCaNKTxWtj3	14774	20795	20795	1619682300000
30006	3NKKmadqFekUgZZLYDCMNLEm3KyFyBJFwMQBBmkerZzGvudpQaRN	30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	1403	824	603	12463	18974	jwmBAcyKL9PGVDrU8sPvvP6F74PhN49FX9VLhZXY4N5EJi2C7N5	14775	20797	20797	1619682660000
30008	3NKGA4waPvVkECxVGJ4U9bNS5AmxiJeEcSDqZ9SF8cfTFuDX3kD8	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1500	1051	603	12463	18974	jxjwS8DX1vihv3hxyxm8uBuMsY2MXrxNZ16hkQgBaKAsbLSjgir	14777	20799	20799	1619683020000
30010	3NLLj1dAN31qkd3sgBs2uPk3YsMz2f1wceYj3v4x6wDa3gL3cxsJ	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1596	1117	603	12463	18974	jxStQZKAAx61ygrFSg4JYMesdmBJNjW9S6N9B6uPB7tG455dNjk	14777	20799	20799	1619683020000
30012	3NL9uNn1uSSsrEkGGtFPq61JLyaouVdQNK3JY2PNRDGvKiPtAQAW	30011	3NKtHSnQmkDKfqtio2VkUoiic7x16uDhhyFisNTibApTTz64GM3W	1406	1393	604	12463	18974	jwwvi58NxnzBcfpL8y1UnHMzSFZ26hQiJiScRFkTcEHvZnT6cQW	14779	20803	20803	1619683740000
30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jwVA99ptWpyPR3cwUhqocTwHKYc7gzq1hkiorKRraRivqhwrKm7	14783	20809	20809	1619684820000
30027	3NKpYCKCqcnbyB5FF1aLLwqBxRDe6VBrEeRsHcnJJd1B1qm2NqN1	30016	3NLd8mqQvMmuFbLGsQX25AZfDNWSNTgHyvyd3eQBP9EUHyCEuwRD	1474	1203	604	12463	18974	jwqUS59KErbtrXhbToTC5Qg49DcyQB3BnkszD3KH9NHiy2JJWh9	14783	20809	20809	1619684820000
30029	3NLrDHybUbCKwDHnSmGdf5L7RRtFGY4Lwpzsu4Q3Vomyn1ivgkhV	30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	1608	923	604	12463	18974	jwunEwYnQyhYGXmmLjG8Aq4H4rQSMPp6BAgAZLDUnVr6FEnqr4m	14784	20810	20810	1619685000000
30032	3NKxEAuiTuY2A88Z3peLYXeeNjk3padob7F2TSL4UGqeaKSa6K1a	30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	1507	914	604	12463	18974	jxMi3bJdLvvRgfXneRes5oMWs4W4ijxv6rasMVDybCXUp6kz9Di	14786	20813	20813	1619685540000
30037	3NLrgfZWBeE2z3FPPqFsFiVMBARVqRYELiMAkNUXroSMgqDQRe82	30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	1403	824	605	12463	18974	jxEKrNR93XyWAcaY1iD1XZBmPzCNxjmcMyoiW7tjP3tLWQxarL9	14789	20817	20817	1619686260000
30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	684	1352	605	12463	18974	jxH5R1aSnWEmYUSiBjz8aZsZbhZiEYi8bUpYcAqP6ev485Pxek2	14790	20819	20819	1619686620000
30046	3NLwrGYpL2qfeYSpvZq8DLBrGbN8ctj8og3gwsC747wUaYT2prSp	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1403	786	605	12463	18974	jwaJRHpx8Z1UFtU5VRoXugyHHLiCXmZDeuQWiVu1ETRMUr4kmf3	14792	20823	20823	1619687340000
30049	3NLSsU5f1PBsfFB8AhZ7rJkpRvhNtB9U32ucidsXQFeZj5WrADLm	30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	497	497	605	12463	18974	jwBSuiCASfhDrtnNt3SsH98ZGNSEM5Y3z4n5hcFuzVySQjKGSWE	14793	20824	20824	1619687520000
30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	1549	1236	606	12463	18974	jxixkKTxAHUPEqpnj3xDX5iHUqvcWt6P5S7kDXaDBNvrPsF8NJH	14795	20826	20826	1619687880000
30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	30013	3NKnvESZMdfA1Lyj64kppba4KiFn5kPhTqorzFjGVKycsvDgKheZ	1406	1393	604	12463	18974	jxrojdeF65qordRnQb4RWGQZto4wjS1ZMojQfQeu36NWsE9jcry	14781	20805	20805	1619684100000
30016	3NLd8mqQvMmuFbLGsQX25AZfDNWSNTgHyvyd3eQBP9EUHyCEuwRD	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1672	1039	604	12463	18974	jwWLsbA51n6QsFwK2igqmfayN9x85znH6krQDdofa4zd88jXMZF	14782	20808	20808	1619684640000
30018	3NKbnMutjLxPYPX4MU9oKxxkWnhtD9irfT16aLPeLEcbDnMYn12N	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1523	1195	597	12463	18974	jx3jhccVJCD4oNTgR9Z6XUXfubCYPwezwjnvA1QiDXZ1ge3nvMg	14721	20808	20808	1619684671373
30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1547	1012	604	12463	18974	jxjahED8WahvaYkNuAGEVc4HXuchTNqBZYnLYuQT8Xx4CKJ9H3m	14782	20808	20808	1619684640000
30022	3NKrDaFfys7vsN6bvNYwhnNJmMkR68hxLMYwg8yq6NNJWYgvcJFd	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1523	1195	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14744	20808	20808	1619684733531
30024	3NK8tWLRJaAD4oeaU7Dvht9KakPagy69FL7rF7TYY9XdTRfYBWdq	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jxtVt1NRnBVf9GATGo2vxmhWTcy3Rf2rb9PJtJorCwcBz43Jk9y	14783	20809	20809	1619684820000
30026	3NLGMkfVLvNL4d2j8ZGhNKHow4rKp9vbpKmxS53tWPFbenykS5RK	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jwK2fKFxQFrsD8iTp5U23CjFyXNLPR25zJuxLasCAEFp91FRijt	14783	20809	20809	1619684820000
30028	3NL8Ly3vx3tgrdJfjTk3sD7XJNGoM8dge8g9pxd57HJdFdZRe3hg	30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	1608	923	604	12463	18974	jy3HwiFRpGeEsF93FRFYMcDCrEBvVT8a1AHuEUFcLQXtHCCk5Tz	14784	20810	20810	1619685000000
30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	30028	3NL8Ly3vx3tgrdJfjTk3sD7XJNGoM8dge8g9pxd57HJdFdZRe3hg	1407	1395	604	12463	18974	jxMyUG8jVhHm1Zg2LyoKD6LxxxPD3RpDbugX7Jp9wpJuxYt2Quf	14785	20811	20811	1619685180000
30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	30031	3NLm8GjNG6HtLbxxcawsziKsXZnexbZRWrq7Yn6fR9T1DMck1bv9	1403	802	604	12463	18974	jy1rMWYRpMsjHSs3Z2p3m7bbCn5jpxEvNRSSE9ZVDD8U4LjA4kq	14787	20815	20815	1619685900000
30035	3NKH6iy26GVi4TRHJ9SQo1e7qmGSJbxEM4MBjs1Ko4vzn5AZRH2S	30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	1419	814	605	12463	18974	jwVwjfAgmDYrFQ4WwRRxAbVv4GW7hZ3wnWyjKQqMYqc8K31G15d	14788	20816	20816	1619686080000
30041	3NK6VLP8B2qjHaimP9CPjWK3ScfCw1D863NSNwnTtpNUbHk1sAwm	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	1637	816	605	12463	18974	jwDPJnEGJBLmtCfLU1HBpyRKhh5NMPwPdNGd1eCKUGc1o8mPbae	14790	20819	20819	1619686620000
30047	3NLTAJSKHCeQUHvo7oYVcmPjaBvSpARCpAqEBnzap88n7pjcDD98	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1585	1366	605	12463	18974	jwJJhgJfPduV2GfKAy8re8BbsqJcbPP2mjs3YgvnyPLcUoDmGiJ	14792	20823	20823	1619687340000
30051	3NL8rW8NEQ3Ht4QPCyYfsNZm1dRUNvNS9UrwTnQbJX83BKWhRpjP	30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	1406	1393	606	12463	18974	jwBUr11PETR9WsZkGECDG9ixb6RLqhZ8XHn9CoQzypPLzvZZnvR	14795	20826	20826	1619687880000
30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	1549	1116	606	12463	18974	jxgLmea53FWAbG2hBRPkXm1PZC2MiNJtNcMKdgcMQTkh4SQZJ8C	14797	20829	20829	1619688420000
30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	30058	3NLXdsAy1uEEDFjbwoHrvSiMdEZr31wMJ6zf2EDFdJrL5YkoZEX5	1406	1393	606	12463	18974	jwB1Kd2dKgHEFxzeJL6xZwRcVn1oijBXAqgfPCgxidsihbgMMzC	14799	20832	20832	1619688960000
30068	3NLFXrgwk6fFfnpzUVSNc1B6Ah9V7q5ps9f9SZYHurffB5eMoneg	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1471	1386	607	12463	18974	jwGb2WUg54ppksC2D7fFh8LTZrKxySRsXazkfgtPcC7v3FJzEL7	14805	20840	20840	1619690400000
30070	3NKw7Furi9UE8Efae9CsHhg2Qou1fepRb69bgskCWf1Hze6AVqzD	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1599	1161	607	12463	18974	jx68nntWMF3UdQMncQ3po6bdpXNhvnXintdBXhoTEbGHZmaaR5V	14805	20840	20840	1619690400000
30076	3NLZ4makkKxGEnyuc1j3fSW3B7CSs31zS2jr2kkdQKc3oV6oqWXP	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1448	1311	607	12463	18974	jwudbHjryro5BKUpw6xEb4xUopqKbNCS6eYm7dtwrnSwpjYCWsi	14808	20844	20844	1619691120000
30078	3NLiJwYSrqTqCzNfk5Y7QZY41vobn7MZ1dAycHtZh68t5hRERUrh	30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	1549	1236	607	12463	18974	jx5XFktXrBVUbrM65dyXnoEW3jccMYycLnu9bEeMm9bFhGnCbLi	14810	20846	20846	1619691480000
30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1407	1395	607	12463	18974	jwN9XUpK21kJ36qf1DV5RbxsEuw7bUiq4gsCSB17JNZCiHFSfmK	14811	20847	20847	1619691660000
30081	3NKB1g2QsqL6wKdMjR9v8rsfTJB6tkQPvSztsGBH5AFKPkLBXrNA	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jwabLtjENxJ8TNJNEQquWDMnFnq5xaLsaZqQnNEXDuUCASo4zX6	14811	20847	20847	1619691660000
30089	3NKyCQt7cfKMNW6huLRV6d1NpAtQYtVmMPQ2WUer6Y2fMDzwmq6h	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1657	1344	608	12463	18974	jxnLyS27DdyDAyTGJBJnUQJpKJwsdr1Tqo3BLrp9yR5iGuASb9S	14814	20852	20852	1619692560000
30093	3NLoTM3b2tQBjwd7CpgJd4MvBdPuMDomxcD5qrWhPNeLruNcDmfK	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1668	1124	608	12463	18974	jwnB1Ld5ZUWgPJyUq3jXfHVe33cbTXghdUDvxGjRy5NTaWHCmu3	14815	20853	20853	1619692740000
30100	3NKNYPQE7iNBHU8HuwLD18gV7jpDhrm1CzPGc6hsN96Foiuenvj6	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1560	1045	608	12463	18974	jxP5h26gYs5xZKT5TUuucpodDTxCZremFN12GvSHCwaDm7G9Jmc	14818	20857	20857	1619693460000
30103	3NKJ8R3c6uD3ucP793Mjcdrz99G3oooNvrkf84usQZEG4PsikSgn	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1602	1369	608	12463	18974	jwEG68jGaJmZbYfUfey2gQQhzPPHJZKVEsf2TCYdSv3wZGDf8xQ	14818	20857	20857	1619693460000
30109	3NLXd1sviDgXEvCBwo6cL94q6ix7m9h9tq3VKjGeaBdUAfwvW8YQ	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1407	1395	608	12463	18974	jxwiFTiTo1GLkKips9KGzJJRuUheA4wFu2XKoCXqSzwpy5Pebih	14820	20862	20862	1619694360000
30113	3NL3ZYrs2QULsRGMYteVgKUPaUStszAYDpq72k22S1J3YyYcS2vi	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1522	1322	608	12463	18974	jwFCvt1wijyduecEE2sun3znviwRXgCAWP9m1GJf6TgQtrsjVXX	14820	20862	20862	1619694360000
30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1547	1012	609	12463	18974	jwTYwWu4LgnYpp15UYq16DwJx8VU57sGzJUjQFDw4cPiAFx2TaB	14821	20863	20863	1619694540000
30121	3NK7QvtkPLYvNyYErCJ9xWX7DrbPGgn1GH9dnmfWGEVekJ5w4Xqk	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1440	1251	609	12463	18974	jxPLywBRoqETWngbHa3VpJ1BXUdSZrw3BCkioTJWrEysURDoWye	14822	20865	20865	1619694900000
30123	3NLScUbGdLoKnkw4S38eKPz2DUFPKhTB2jXbU2skHMRRdR8WQH4k	30120	3NLu7jAEm3RbUbt3aQZKxB1WrRtUYouLX8X7QG6EgC8JKbvm5bYb	1668	1004	609	12463	18974	jwygNMS1L5jjZXesF6qeE5f1xUsrCJoZxPdpbJYj17ndaZxDUBR	14823	20868	20868	1619695440000
30131	3NLhazy4hH4yXRs5JgzS8gRwb6tbjjX5uL3MjF6JYj7p9um9tx2V	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	1581	778	610	12463	18974	jxoaxCepHydhRk8AEJvFFPCFDbggzWXTDQDZqoQ973iqSBuKkEf	14827	20874	20874	1619696520000
30023	3NL5CqbZHb6QXp8eQBN2QPhFbJyh4RdQgKxBCG84ANSoy2kQbVza	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	1523	1195	600	12463	18974	jwpUQYbDJbKAZdx1FS5njYvmc7fjoMbg8Eoke8LPeMVsJAwBsBJ	14755	20808	20808	1619684764103
30039	3NK6zLdDNYLybX3Tv9jB49QL1VkhqsgSpixMuc7Gd4ynQUNVr5f6	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	369	1066	605	12463	18974	jwwGRf57NVbigdAhvVcLjHFwz5skqk9WpMiqSQ4bKQUnAeyD6cc	14790	20819	20819	1619686620000
30043	3NKCpkvYVBmPUFdcxjdi6xvxhbYE8WPDATUvGVVuQGjpc1viCFPG	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1627	1385	605	12463	18974	jxErHTgvK1gNoyj3TqaQYanAZkrB14kERiHXP1Py9cWJiPEQA7d	14791	20821	20821	1619686980000
30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1534	61	605	12463	18974	jxWsSFarNGbKVBKG2zWdh3NHE1goFkxw7pmNLrq6QJGAFuRVkRL	14791	20821	20821	1619686980000
30048	3NKhBrGD6vT9gR6PRHHcRmeEFJqHr6CZ8m3yZdriJ8dPU7LjtWAZ	30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	298	298	605	12463	18974	jwdy3rPXFSBHbXUz354BHA1GFeqMxEweHwor9pKRoRbroUsbT1S	14793	20824	20824	1619687520000
30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	30049	3NLSsU5f1PBsfFB8AhZ7rJkpRvhNtB9U32ucidsXQFeZj5WrADLm	1578	1050	605	12463	18974	jwmQtpH4qSqE5iJ4eHin4bQpQGbgxEwRfMExDeD7eDqjbnJyKSw	14794	20825	20825	1619687700000
30054	3NKhQmSQdMA5UAp31m9Y767bHYBEQ1tSUYvbXdDEKAv1CdcJSGLE	30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	1581	778	606	12463	18974	jwP7ANJew8o4a9eMsYybTydccyJhZgMA4WqzP1sWrGMWsxjLo5k	14796	20827	20827	1619688060000
30057	3NKfNcfwM2DBsbb1nnYtKM4uoMu4rsToG6L5R74qhLcYBA9ZNA2c	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	1483	453	606	12463	18974	jwJhZjT5F5cTYxQF1u7J8MgP46XvseF5bAWoM3oxhsCTGk5oM6Q	14797	20829	20829	1619688420000
30063	3NLA6Kdkmc5r91afz3Z4VWdzE8v2XZ8JJ8fQT5oHj1PrYDpqJkpR	30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	1607	1348	606	12463	18974	jxBpNthkcqFvuo1tUEdyDNeYc2nYq22vsCwCwmMxXCeATEKqcXV	14801	20836	20836	1619689680000
30065	3NKVpbvQrMrGkqu3Ay7aN3ZxkB4HmjATeth1CvVwJHC1yGpAHEbx	30063	3NLA6Kdkmc5r91afz3Z4VWdzE8v2XZ8JJ8fQT5oHj1PrYDpqJkpR	1585	1120	607	12463	18974	jxGE36gkDnBvXKxvKn7YPmiqQ6sfsnHRX6QREXxRYbWVisrxpgr	14802	20837	20837	1619689860000
30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	30066	3NKqSHHpepjY9j1jCyH1QmgzqGoTgrpXrCt1S9E7B8RWXZpWgiH6	1407	1395	607	12463	18974	jxAHyijYxW93py3qFCgoyoEQe3XUoty96y8PW93nsyeagHYQWVJ	14804	20839	20839	1619690220000
30069	3NLWG96q5Kv2EDoDi3ETQ4wUc9fXPSgQCDSnTSmn2B4XgvK5FX4P	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1407	1395	607	12463	18974	jwSBiCTriXBmoHkPM4sfikUe7GgxSLuWBgUdFjSeU9g1it3XPhv	14805	20840	20840	1619690400000
30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	30072	3NKuET4oceW9oLHxJMw8yHUbF6GhXtPgnsa68RiSZR6v9chXGoVc	1672	1285	607	12463	18974	jx9F2CsiwiTRVWTGnPPXgchVPGc9J3oWSeYjLss8GQzkfDtMCCg	14807	20842	20842	1619690760000
30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	30075	3NKZMtNUt4cw5wBKKt295eNJf5e1vEiQFtLJwZtLTi6m5yGTvdKg	1547	1012	607	12463	18974	jxLt5id5ndXx7F73dGaPs5BxmUNh6UQ9tkYAMdhtyDyCx5wx1XP	14809	20845	20845	1619691300000
30082	3NLpq6CEKcc6TzUu9WBcjLSrBeyHVvRuT2hNUJ46v519WajmanD6	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jwabLtjENxJ8TNJNEQquWDMnFnq5xaLsaZqQnNEXDuUCASo4zX6	14811	20847	20847	1619691660000
30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	30085	3NLMYJVQfSX2o1hPnkpfSmCog6KWLWHfuoVXkLW2xeyEN9jyQgti	1407	1395	608	12463	18974	jwUYj7822WAAEewEHGaW1kpWgd2EmZiogXCqsobCXeUH1b2YFJP	14813	20851	20851	1619692380000
30088	3NLvmSSU4Unbn5mmfAyJc1qk2wb5CxNXFnuizcV4npT7Fd2NBSgK	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1657	1344	608	12463	18974	jxT8d2tJVmwYAH8XUCSwnHYSgsJrxTxgVEjhX5NzDVuH2DngFpa	14814	20852	20852	1619692560000
30090	3NLSWvLzLVhhgJZhvLuEbaYeDRbiyHpNJXaCAuKhKyHzC51K9WDp	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1534	951	608	12463	18974	jwVXv6pwCw6nRLk4Th6D4bHUrMDUSfum79hpyfCrkqnCRHuJrQE	14814	20852	20852	1619692560000
30092	3NKcJ8mdC2dvcxxEaUCdTHxp7kLnkuqoC1rSx2WJnBXwJ74bPsQP	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1668	1124	608	12463	18974	jwSBjrEreyCQSSzvKddKQtTr7ymHRPbSbXrCFYs7eX9qkNPUZwg	14815	20853	20853	1619692740000
30095	3NLVaxYtS1ZFsBDVNoTLNDijbzo17YbetGLkWCd34mkUrCFUbtZw	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1407	1395	608	12463	18974	jwyidNY2Y9ExVwctH313gsj7r3EaUFF7Sy364XmYYcdTARjhaU9	14816	20854	20854	1619692920000
30097	3NK9pCNeF7BjTksdDuT4Em26Df6wu9oWfCSRp68d3RV8DDYjEjrV	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1542	1178	608	12463	18974	jxcZu9rbmCsgL3LXUaqDKR2Ruq2u2rDs7dc8BWM8hNHcBrLN2f5	14816	20854	20854	1619692920000
30099	3NKCjMX55eJgYyvcytptXBRd8AbAN5TUFmKjERM9UbMmRjYPgPPV	30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	1589	1160	603	12463	18974	jws9kTTrHGkzhFqhWsmV2gCXJG7UvwvyzZADbNZTdbM7nCYFnBA	14773	20856	20856	1619693280000
30102	3NLiG5qQrqUng9A9FNXX6N7iFddh98tMK8XwLXV1rXCiQFGHnyUE	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1602	1369	608	12463	18974	jwuNaSQgfqDjkDjfGur9PCWNUTH2m1YxUUMCMb1xeiCkthGwBMs	14818	20857	20857	1619693460000
30104	3NKhPxMyD6vWcEU57TDgRQUbkXHn9kSSXQTZzsgRSgd1ai9dmZzv	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1651	1055	608	12463	18974	jy1AvWFYCQSAKbHQM5kYxEJdRF7rYdkF5BRxHpy7vYYZ32Wgwm9	14818	20857	20857	1619693460000
30105	3NKQkzBX7kzutAAycoik276oyWhCiPKXir4nfAaBGRNm4Cft45NM	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1560	1045	608	12463	18974	jwyHVied1qp1vx1ZFwYf4SxftD3kvy3HhX9PJHm3bbsLRFsPQhq	14818	20857	20857	1619693460000
30107	3NL1dVj19r3MEd8hvNN79KJNkbjfXpe71JNcZhKQk6o2QKrm6RTE	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jwnz2rHxx4mirvmq7NsjiEA3qB6NmE5Vfi8caDQpNL9Wy1EkUSj	14819	20860	20860	1619694000000
30110	3NKGasNXQEndomddsKRiTCyuWnU4bDkCz2G77AmjBxf3tEgsWyes	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1405	873	608	12463	18974	jxSwSsGTaDgiY4VCmhqnUcsSjR4D3bbWhVWy8yPBoUvQVP527RA	14820	20862	20862	1619694360000
30114	3NLxrmM5V7RwPPkPE69Ni3yM5gf1iCSX3j9ypiwgnCm1mCLkM9ha	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	341	341	608	12463	18974	jwmAXhdDBrzvHnhvUY9UZCaB3g7S6AnrP1bEvXamdPLP9Suirhm	14820	20862	20862	1619694360000
30119	3NKZ8zEjcCTPkoKHkVenAntABDG8Xn3ebJZRqhrAUAL476Juhw1q	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1403	786	609	12463	18974	jwGpn4tuA9DBiYJmXXxuLpJtLUAcj4mqMfpFpxZp77iGVTzXqB8	14821	20863	20863	1619694540000
30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	30125	3NLUX5bbc3HD4APX1Qy5F2Xm4STMr93hpPnLJE97trn5Qky6tebc	1406	1393	610	12463	18974	jwVTbo9ibceyZkP7BXwzzZkPJX1r5QVdrzBoeHCKJtXFDmFXZTi	14826	20873	20873	1619696340000
30129	3NLoPah2c6PpEgT7Y6rj5qoFAkp9LC7SjDap27mNWJF1dkXvKrb1	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jxJX1YCqgPJpU5m72Gm12MmdFz88QKCgYzqh7fnJHHfb7sz9Bqa	14827	20874	20874	1619696520000
30133	3NLKhtC43xJFuqM78s3wsXnf1dAjH7xzjJErWrHmhybpCWMSp2w3	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	563	563	610	12463	18974	jxXdG5rUe1EJDZHE2M5JyECU2qsg7Wt2tPCNJwn4fLMqQoUxCYJ	14827	20874	20874	1619696520000
30031	3NLm8GjNG6HtLbxxcawsziKsXZnexbZRWrq7Yn6fR9T1DMck1bv9	30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	1407	1395	604	12463	18974	jwLxh1Ghm2W1x6pZLtmqrxYDkmeZHKRjKWYxy4HeC8wFCLDCTM1	14786	20813	20813	1619685540000
30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	1622	1110	605	12463	18974	jwVNagN1idjtgJSCBFZfKMBCR2SR9fZRUDV2yZvm6G2rgU8AuG7	14788	20816	20816	1619686080000
30036	3NKfW1ipxaSrEE3drFDjBwVsm12QnUPJRqEZtGehDjbwB4dgy2Nj	29914	3NLZfY7UJuFXR6tege71HVk9pKgJZ5S6bZqbviFgEq5hQZvJEUWj	1419	814	590	12463	18974	jwLKQK5dqGWaCuF4T3ZcRQ6TtX1b4eKUMqHEpjd7HiT9oju9c5n	14669	20816	20816	1619686080000
30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	684	1106	605	12463	18974	jwXDS2iBTEZwHjtuUdKp9rDJenFSW6AZdRV3MPhPgAFCeRFCwcn	14789	20817	20817	1619686260000
30042	3NLK9TsL865CYUmz5dqr9cApWTZmEso3CTTRJPhD3dxPUH12VQxi	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1460	1078	605	12463	18974	jx8diMkFUv9TwJU5xz4n8mJSExb6TtD8sJCGmAhE3W3UEmmPiiT	14791	20821	20821	1619686980000
30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1460	1078	605	12463	18974	jxTuvbBRnCUXzXP3S5qYTgLSkjmZ6MMzbSmbKfPdjdRh656nhEx	14792	20823	20823	1619687340000
30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	42	1235	606	12463	18974	jxgdqkWDbuW6uakfheL6VdCNGwUw4nwWM6nCySdRUehheweY3oh	14796	20827	20827	1619688060000
30055	3NKn7TLNexfENY3F3RkG9n34YKyAWS61m54LCshoCHYjKQKRbr1D	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	80	80	606	12463	18974	jxa5SVSqQA9zx6SZUQCBGjNax83u4A47JurSBwMo7n7C7oJTrWS	14797	20829	20829	1619688420000
30058	3NLXdsAy1uEEDFjbwoHrvSiMdEZr31wMJ6zf2EDFdJrL5YkoZEX5	30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	1407	1395	606	12463	18974	jxMcAKLrkJ1e5sHihQLYGVmCyevRV8tx6i6PzzEUDSuYWqkbp6E	14798	20831	20831	1619688780000
30061	3NLU3mk1bLUNkbuX86VsiZjzQ3gLXSuMf3PgrmegwMTdQnK4jtgm	30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	1657	79	606	12463	18974	jxJVAutT1fTq8h9bRjnuJmZVQ2BnQHuTzJ7HDJm41YaSefqt2na	14800	20835	20835	1619689500000
30064	3NLi979kBc7CF6wiVJwwrMaW9AvKSKMLUbQHS8wbruiyquztpMYt	30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	1607	1348	606	12463	18974	jxBpNthkcqFvuo1tUEdyDNeYc2nYq22vsCwCwmMxXCeATEKqcXV	14801	20836	20836	1619689680000
30066	3NKqSHHpepjY9j1jCyH1QmgzqGoTgrpXrCt1S9E7B8RWXZpWgiH6	30065	3NKVpbvQrMrGkqu3Ay7aN3ZxkB4HmjATeth1CvVwJHC1yGpAHEbx	1407	1395	607	12463	18974	jwwZDrFgT1uBVnfT7oLWdp4HwQr3kKzkVTW3rog6yG3h33okXEv	14803	20838	20838	1619690040000
30071	3NLUxtRiakhbpbJ1UrbG4ZZhe7rkf9Btn52dBRGSBDuxCGNPKGEc	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1471	1386	607	12463	18974	jwuzbLNYEVPXYg74XyHMoJjWXaA8cnpuBaYEUnukS37Tm977uqA	14805	20840	20840	1619690400000
30074	3NKKpffe9MkakcQBU2ssong4G8wRsjmZ6FEqWxGSAnmPaqVEpAmf	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1406	1393	607	12463	18974	jxMr83PVXvJ793Fz62WeuA1yJbvDTtG7UB4zZjq5e93JyTdv3Rq	14808	20844	20844	1619691120000
30083	3NKmFSPd9aBorJjxUHe8GRH6CPAe6sZZwKRoRMBTXAGq3Xi2WhjZ	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1403	786	607	12463	18974	jwdLXEbvyStVXThCXGvJFTL4qAak5TenfYwYNN9Poysfhg1dQ3u	14811	20847	20847	1619691660000
30087	3NKW1ozjUTwiieSZ7vZQgJyNiiSHYUbbs3uWv7W6rvhx6S1L7Qik	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1500	1297	608	12463	18974	jx4qjfN9tHpzsxJpn8MsjkJbj1Sjt4BdKyDKTfntwpjK3Cj3ytq	14814	20852	20852	1619692560000
30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1477	1350	608	12463	18974	jxmVfNzXPgFqk4v33CTDoPnqCvWceWUZaLLyVXRFkqzKhLDUeRE	14814	20852	20852	1619692560000
30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1403	31	608	12463	18974	jxFnN9vFm2NXYyH7YNubHEpPFkws1MU1BtDMonB1DHbh28onByj	14815	20853	20853	1619692740000
30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	30097	3NK9pCNeF7BjTksdDuT4Em26Df6wu9oWfCSRp68d3RV8DDYjEjrV	1407	1395	608	12463	18974	jxXDcTp9t9uzZoRoDezaLXL4FQvqJUDg8t7pEHa3xZEvuMYYKby	14817	20856	20856	1619693280000
30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1651	1055	608	12463	18974	jwKtEtd6WZoZ1ow8CMuUgZKbDoQ1Ekywjr8BskejfsUUzn8oKgi	14818	20857	20857	1619693460000
30115	3NKQLgucxzXZWUd8kY5mAnLEi1wJNyrDwnhfwRxxDUieVzajGoHo	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1476	1125	608	12463	18974	jxv87PQ7sRTeeXrXiSguqqwtHqEambMQT7FedRjr5tRGEYp43D9	14820	20862	20862	1619694360000
30117	3NLbDPTD9B4nAUKuau61hB1wr5g2Q19uCgLkuNG3BHGzE4MeLZEu	30110	3NKGasNXQEndomddsKRiTCyuWnU4bDkCz2G77AmjBxf3tEgsWyes	1547	1012	609	12463	18974	jwrBd7U5TNqvwrzbBkjuJkrb7dUXPNDNEro2omZMpp9xZ1LfC5B	14821	20863	20863	1619694540000
30122	3NKQG2DqXqEHFJepbitFZihap2nSQNTcud1Z8wEjRN1zDrZR64Tm	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1440	1251	609	12463	18974	jxGsTzPxRz7wEHzK8vEfPAGQ5YziqhJ3KbxKMMShCRWe2NPVDvr	14822	20865	20865	1619694900000
30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	30123	3NLScUbGdLoKnkw4S38eKPz2DUFPKhTB2jXbU2skHMRRdR8WQH4k	1633	1390	609	12463	18974	jxwsrvvAWPx5CgRxoPSw3DfgyuDDkWkmP3rDsZoZs8P77EGQZMB	14824	20870	20870	1619695800000
30126	3NLRz9H5QyK3QrAocLpt6k3jDFTFvJSUuYmpjPJcEhKtLEfjW2tB	30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	1602	1243	610	12463	18974	jxdnzpokvq5gAZ8Fxq89d79ADxCy3gKHmZnMU9ZETD8peZ4XfpJ	14825	20872	20872	1619696160000
30128	3NK9qu9TNdXvMx9Bs2WHo255Adns4TuUkHnAD36FTrtNXytWA2qw	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jx3ZHamxGkzsZgwZ3xXJRdqnbMrgnZ1igT7AHTj328zqrZaYQMC	14827	20874	20874	1619696520000
30135	3NL8rpRYW89NeQZRFGF5fs9WkqMpmsCiqZpktZJTQLnGdHc8HGMr	30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	1619	1029	610	12463	18974	jy2rZUqu7CDUjHYQiiGjmmvytw8Ln3BgnutMN7PPMCbYEHrA1By	14829	20876	20876	1619696880000
30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jwuAyuTbhzKULV9JAbZeJKGzJmuVvXjpKj1vN9g6gDCfxnLDwif	14830	20877	20877	1619697060000
30166	3NKUCYKv2393HqmE4qxxKNXuz1CYtAYPzM5zQ8XqZHWZtwG8TtxT	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1599	1287	611	12463	18974	jwnpbNFo9EGxYUdBJzFiUASQoCWmiCrw6rUKDgh5FyExEVr8NPi	14842	20894	20894	1619700120000
30168	3NLdgEjdvxAuiDgqtUhq7w9vCvqSEM4bU8Fs8M1dZ3ohgNrLxhAd	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1617	922	612	12463	18974	jx2PqFrnAH12r7xqXEfoZsqXGtmuZAcYT1mHLcF3X9CzrBi5m7N	14843	20895	20895	1619700300000
30170	3NKyTUUhjQhCEu778LoQE3LkyBSaTQErfci7FMVLwiZVQ5oddNkK	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jwEPWPiSNh8Y47NH2tPkWanitmR5iSRAZHrZ2RViHw8ARex8qWx	14844	20896	20896	1619700480000
30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jxopAPTVSjxKDBf3YS1nAJWg7PgmWEvJoY73T168AEQf18XJcP3	14844	20896	20896	1619700480000
30059	3NKRDEzYwhkQ2iLKHCcV6Bx6XCvawuF6wbemNAbVXLFX4owqABAk	30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	1602	552	606	12463	18974	jwG77L4KBCY566QYVsgTMQjRbJqWEvJTUSKk1gJSj4mcw4mDJ8h	14798	20831	20831	1619688780000
30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	1657	79	606	12463	18974	jxrWPF87nmjUFtqyQvyNWgUoDhvt67GMVDTsYrQY3JuaNTTDA6W	14800	20835	20835	1619689500000
30072	3NKuET4oceW9oLHxJMw8yHUbF6GhXtPgnsa68RiSZR6v9chXGoVc	30070	3NKw7Furi9UE8Efae9CsHhg2Qou1fepRb69bgskCWf1Hze6AVqzD	1637	816	607	12463	18974	jwfuKcsNJfj6STPBEmVcqoNmEfgu4LD3miHGAZi2ibMd2LWbzMg	14806	20841	20841	1619690580000
30075	3NKZMtNUt4cw5wBKKt295eNJf5e1vEiQFtLJwZtLTi6m5yGTvdKg	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1448	1311	607	12463	18974	jwbDQVrca9yJnhnaCkpvNk8P5mP2wkuoaKzjE6G3cLyEdQbudjY	14808	20844	20844	1619691120000
30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	1549	1236	607	12463	18974	jx8U5W4XA6v4XDAS2AgdEfgXpM4VSH5uvyuYYNRgHYYFv4rAdbu	14810	20846	20846	1619691480000
30084	3NL5pHc7fthCEAti2wUGa6W6WJSAraYosmCi792mAmbeDMkcZ1gj	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jxRt57L1Xo3ZgSjz9bVum9nm19wRWgrhKTfB2BohLrmFv6ijCCY	14811	20847	20847	1619691660000
30085	3NLMYJVQfSX2o1hPnkpfSmCog6KWLWHfuoVXkLW2xeyEN9jyQgti	30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	1611	1095	608	12463	18974	jxk2AwiBf3Ye2LNVK8k1kweAiXzVtsdXjc4YyssMs8E5ZDgb1sJ	14812	20848	20848	1619691840000
30096	3NLvH8EDReLSHzrxa37xCa96bgGhCm4SsNoggpLsm7dCX3vykWGM	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1542	1178	608	12463	18974	jxFRs3SLKpRvKAtaDPKR4q8eERAn1LPXa6oCaDk3Xs5CtPPiNYg	14816	20854	20854	1619692920000
30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jxucKhqSVacUvbgREinzaLt28p8SHio2LnBjXUM6PiyA5YVSWbn	14819	20860	20860	1619694000000
30108	3NKVrWKyiNwjokw11mEwg9PHmCyCUZkTyL297ap5HqMxrvQ6htDU	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jxsE3EsnmPGZzghjFNEBJyw4FGrLEMD3LKwn9cpjMcLHZMw5htV	14819	20860	20860	1619694000000
30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1522	1322	608	12463	18974	jwFCvt1wijyduecEE2sun3znviwRXgCAWP9m1GJf6TgQtrsjVXX	14820	20862	20862	1619694360000
30112	3NK9rNk5934oXbhns91dKKPb4YFA6cGBnnT1sFKV3duoszQE9jmX	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1476	1125	608	12463	18974	jwgVBBa64BQTbMYe2yMhPJ7fhAK3dgPGazSBUFvzRVsWHsgUHC3	14820	20862	20862	1619694360000
30118	3NLWwRh5FAGnHeDhonFpJbUVnhy4bg4HKCb4HFR1E22ubktwq7Pi	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1547	1012	609	12463	18974	jxt4bJxt6xUhzznBz25Ks5uSLACyLSaYM6u4zDdTbSDmd4FePWk	14821	20863	20863	1619694540000
30120	3NLu7jAEm3RbUbt3aQZKxB1WrRtUYouLX8X7QG6EgC8JKbvm5bYb	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1549	1362	609	12463	18974	jxa15nw8FbnXsMhXX93qTnMeCygfaV2t4nJ887BYZj3Y1VCMmgM	14822	20865	20865	1619694900000
30125	3NLUX5bbc3HD4APX1Qy5F2Xm4STMr93hpPnLJE97trn5Qky6tebc	30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	1407	1395	610	12463	18974	jwGAgDj5cK5dw4VHsuRpLG7NZJnSXTD1TAvemngoV4fqSn2DAxA	14825	20872	20872	1619696160000
30130	3NLprv3QY4e7zjj7LAc4dJEogFBUsWKveawTqYrCq4BEa5dvjUSm	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jwnH9DE8BAoceRBqxDCiNNVuHMeHDBUMf4gDjCZZP34tBX3bB58	14827	20874	20874	1619696520000
30132	3NLBSsZp2wkw3vyVEg5s3c2LifRcF95FVQPtoVy7ZzvZyybf3fbx	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	563	563	610	12463	18974	jy2otkzVDatvm1zLXDSxcDpLoMkRwVJ2xL5zaxogGbUst28wzfw	14827	20874	20874	1619696520000
30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	30131	3NLhazy4hH4yXRs5JgzS8gRwb6tbjjX5uL3MjF6JYj7p9um9tx2V	1406	1393	610	12463	18974	jxRtm6Wx1bmNQtsh6h1pJ8AiWUEZoKQezx7Qafu7Jpj3TwPViKD	14828	20875	20875	1619696700000
30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	1594	1200	610	12463	18974	jwZPcEgQtmen7RvtdbABVQ43zioS3A4uEfZrjkcgkouPp3scNpb	14832	20879	20879	1619697420000
30147	3NLqJAcEj8yz13wfngRwUGgpfj39HW7V677gevV22k49HSkW6weJ	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	1457	1145	610	12463	18974	jwgXrjZXnEmBUpszQi5hLuJcrZs9hcGQxbf9S4Pv9izepw7hCnd	14833	20880	20880	1619697600000
30149	3NLCvxKRc5bKrGn7S4WcMUoQN6wyPDsSWML3bdA4fDFF9z42y7o2	30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	1407	1395	610	12463	18974	jwyNsd3eFk1MEGARAU8dQDpQQkKFvubwivcrFeVkx4mfxJCab6P	14834	20881	20881	1619697780000
30151	3NKXJaac9qfeV2UdVS23qVRZn9RaVXpyLv9JZ5EbBeBM5Un9bn8E	30149	3NLCvxKRc5bKrGn7S4WcMUoQN6wyPDsSWML3bdA4fDFF9z42y7o2	1553	775	610	12463	18974	jy1JqTNnbsv5ujqX7rbpVwCLF5n3KA8WYJHbcaQkoNw5gFxNUHv	14835	20883	20883	1619698140000
30156	3NKXhNa3vuEnjdYMwqHmedpiqoU76V6Tjdxf84WbPqHVmngwzMCN	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1670	1036	611	12463	18974	jxuDcydCBxTtVnTzRnonX4VXSBq6tZbs2GbTFSKxw46BefQyjxt	14838	20887	20887	1619698860000
30158	3NKs2qoEAEiK6UBuLtc8ht7SRtJhYhHNJbB6g9NDodLwLhdQYQnH	30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	216	216	611	12463	18974	jwZvBmLEm8twtpPbMPjPSNQ4uuASkMKJ9Y4kZqzMyS4DHxpgf7B	14839	20888	20888	1619699040000
30160	3NLaxjJm5wRr4r7JjqXaA3Pu1QAjJrSxorG64dUAs1d6zBtzjF3s	29878	3NLH3eNkmb2X7mtHL9L1FW1ZwX5Sxfya4nqhQ2A5HdQ7D8JqT63s	1516	1294	582	12463	18974	jwo9NdAx3jaPnFpGFjAJh41piZxM7sq9fzTiUojbX9vow9jCvw2	14593	20889	20889	1619699220000
30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	30161	3NKZANShucbvi6Shru8KQYYYhW9r93NwF7ktmdkNZyTBXEHHfH1Q	1407	1395	611	12463	18974	jxJ7Ci2kHc1BYwtgrPofL9frySSPLeNxnyaQt16mgnYLw523NeD	14841	20890	20890	1619699400000
30164	3NKNZQ69NHMpTR6bjesQ7RC3h5P8udQVo5NwyE4zjxZ3ALEAU61p	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1509	1320	611	12463	18974	jwmzCxaeQcg4zwKHpDfJ8Rhkg9jjLKNh9XqUESvPZMEdcdWT8bt	14842	20894	20894	1619700120000
30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1587	991	612	12463	18974	jxojAXSfJszXCdH2cLLBHx7qhCU6CExPWiv3ysQFsopecKP3UGR	14843	20895	20895	1619700300000
30173	3NLYkbayCQDUMym2pUrDqsiSuJZQEouQY9YW2mYMktPVxn3WtEvA	30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	42	1235	612	12463	18974	jxjCN9qtWSnrg5iArXzj57PfRD21XypXCAqVs8z2W54tTsrDj4t	14845	20897	20897	1619700660000
30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	30174	3NKohjC2RNzRtzu5dTaHkAMFj3WCXmMK5kPzS6YPcK27KMeYymzu	1581	778	612	12463	18974	jwgFjaYXmeD7SN2VtcdcBYVvJxqd7GJaGyw8myNS82z8jK93u5y	14846	20898	20898	1619700840000
30177	3NKLDdHMwUbLL48D3hJStLt41QTaBN42UuzXgQvYwsxGxBfyehfF	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1483	397	612	12463	18974	jxQ68mWAu2oDxEb2fGKLRu61MjrzYaSJfyoy972YfxKuqiExgPh	14847	20900	20900	1619701200000
30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1637	816	612	12463	18974	jxDENFoVZxkYSDcni5Sv8XBw36GA868c8Wdqox81aTTuzqQm76b	14847	20900	20900	1619701200000
30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	1619	1029	610	12463	18974	jx7aQncwdFoWuVPPPfXTz1oQqZJjWeLP8RgKBuGCkzTyTAD8RHF	14829	20876	20876	1619696880000
30138	3NL4LH1VkohzhysAkbB4kziTUodoYCPeZAdTsUza8mXTywNqs7mT	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	684	1106	610	12463	18974	jwiiQDcDEEQZ5cxZ2NVWVijBjCe1z9NHVYrZSWrWFCCnjD4YzPU	14830	20877	20877	1619697060000
30140	3NK5iXf63Xu67CqmT7nfkA9kT6YY2v8qfYaQ2Lk8e3GAzrKNGZVx	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jx4s8q6Neu8awbhrypduiXuUf9XHVukPKQeV3B4GPWDW1WRxYSk	14830	20877	20877	1619697060000
30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	1608	1289	610	12463	18974	jxjJERGwZxcLRmDXh7p2Zq6pKKMH2uazttqSJhLQMwqJ4mbDyA7	14831	20878	20878	1619697240000
30144	3NK67hAfmpTqXTcvL9L3NnLRptT6W73QaXds63dgSWX46zgY95ze	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	1406	1393	610	12463	18974	jw8DDcowuenb8R9h5SD7Xx83nL2KXGSzutANozxQSoC97iSrJPa	14832	20879	20879	1619697420000
30146	3NLKySEVr3xhkXYrdNaPun8uVY1kn3oZZe9NbNCchBZGMfv2ECwK	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	1509	954	610	12463	18974	jxmvS8W7GExSi4orY5HUe23m7tFzD9aoR9DQncNLp6MQxvdpEQb	14833	20880	20880	1619697600000
30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	326	326	610	12463	18974	jwrmXiNgscouYmGSYyvvZ7gPVehSdPsHbyvamXHWzChmv2BQ8mN	14833	20880	20880	1619697600000
30150	3NKSYmJrthTgcM3RoWcZmYHEt4RjQabWHvhZKjavTX71cNquhc3b	30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	632	632	610	12463	18974	jwkutyJLpg2PzPQTjQrj6xGcVrJwU1ZrC95MSuoryMusbtYNgKD	14834	20881	20881	1619697780000
30153	3NLFMajibWF7SJsZZHviuoy2hRGJgFERq8W3MXD4Tptmrju1TqtP	30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	1657	1344	611	12463	18974	jw8vwmYHtaA4dAhrCK3fdYvKKviBwyj5QnjiktPXrcThGR1GTTS	14837	20886	20886	1619698680000
30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1405	883	611	12463	18974	jw7N6CFv2CgJtwEEjJf6q6Upo8s3LN8GtGtXbovzSGUFW8Hw8Fu	14838	20887	20887	1619698860000
30159	3NL1mJZ1xJ58pG2fF7pRZJ68ajpcyvsnkGYgeSqTr1kyfane2ieL	30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	1631	794	611	12463	18974	jxrEX16DLRTVXLG2hPhLJxjr1EPNPuNU8WeFJjWJX4bPk1FKTjN	14839	20888	20888	1619699040000
30163	3NKE4L6XsAAApmbFNzmMgrXFY7k1MihvuaKMZwCGCTDpbx8xKUHx	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1509	1320	611	12463	18974	jwkGeSGA1UcwjoFjVnbfkyngg5abWwdS92tHkP51aMg4njkGTpo	14842	20894	20894	1619700120000
30167	3NLHMSKXGJaxobMZWoDfm4DoLGLxE8ZoERrVxD7j2J2YB9jKrviP	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1397	828	612	12463	18974	jwr8bxuB7HrfCK9N4A2wRo66sGmWKvrkCPH2FgwGEP3Nrok8eAf	14843	20895	20895	1619700300000
30171	3NKBzhYiRmEkJ9YA8LW5xhQi5scrLV6T4mudNvgScgDP1LUuA5oU	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jxNHAEzfATDoAxuQW4ahZ2FPDqpqCr8aEojFFgF3MGykNuEjxm1	14844	20896	20896	1619700480000
30176	3NLJyR6AoGxKezwMVLdCXybAeGjx9WA8iqQbPqws2foAv7afZZ7X	30160	3NLaxjJm5wRr4r7JjqXaA3Pu1QAjJrSxorG64dUAs1d6zBtzjF3s	1516	1294	582	12463	18974	jxpapMcfKYzz8i8kdHqyfteGyNYWUwAfFtRpL7rhwmV3616y9pn	14594	20900	20900	1619701200000
30178	3NK8ort4gvc2FehmpKbmqhrHohiek3Y6hRBmP2xWskUR7yubQau3	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1483	397	612	12463	18974	jwC4h6VN5RSw9Zmx9rKZsMGZxGHSWLq3MRHCQt8nX7ZhmvoKJqz	14847	20900	20900	1619701200000
30183	3NLbaRwdRHB67A8eEMqcB4cUFMUqgJsRJYipqp4bzkyTEXmm3ACe	30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	1610	1068	612	12463	18974	jxk5MMtJ1aSUDJcADy15wxxUgfLEp114p52eQNtsDfAyiqtMGXA	14849	20902	20902	1619701560000
30185	3NKWJWNbD3St9YoCccuLdGsYLcLb7rdxtCojL4H86CCVcNY1WAE7	29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	1634	1085	582	12463	18974	jwHfMJfyrYmzmPxCmEpLJPXWEicZFYXT1GRnR8X2fQNwCmjLHFW	14587	20902	20902	1619701560000
30189	3NK78UGnn73T5MRAxJb8zw2JVyVbNuNkVe9euVZ74j2iXX6dxGAe	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1553	776	612	12463	18974	jwe8wBLYAgjE9U4bcpZL3dPPMZcCdj6HHVGfNNQav8WreaZZhUb	14851	20905	20905	1619702100000
30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jx1rP77TCQBUqSYHF9BbzvS45ZUcoudpoU3DeHQeDHfCfBVVu9x	14851	20905	20905	1619702100000
30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	1637	816	613	12463	18974	jxM4hrYjnw1ywJvccChuEMjcTY7mZepFD2Bpr565yKsrkafuL1o	14852	20906	20906	1619702280000
30197	3NLCJJkEVLqAAk9qcLmVJixk7HSMxP2UnPz6121nVK53HDYD2bTe	30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	1590	1174	613	12463	18974	jxcsvJnptbABStUcG7DkY4ci2mBRRTxrqxPmCmELpXUAv6ftiNv	14854	20909	20909	1619702820000
30209	3NLg5Vi8dvByWhwE8s8aKHa38E3Nb9A2Uup6vDS3dBXTXi4PYw1j	30185	3NKWJWNbD3St9YoCccuLdGsYLcLb7rdxtCojL4H86CCVcNY1WAE7	1634	1331	582	12463	18974	jxLQkC2M6wJZgijnNVyTVF3MVbn8SuMPqz8m9pAB6aUsZE7e25d	14588	20916	20916	1619704080000
30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxK7Vx4Qn5oTj2qRCoNVRo5VatttTnxbyDRBoLUARn8RNnnoP4B	14858	20916	20916	1619704080000
30222	3NK6xFiCE9tj1iao5p6MXUtMDfGowwxS4CuPUcahMM7j48dDo2zu	30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	1593	1100	614	12463	18974	jwYgdX7AbgQXqygv3xsjWZyGUpyWW8pQ1aHMksD1c8geTXRNHZi	14861	20919	20919	1619704620000
30227	3NLjjwHNNmUZoV7oLgKqx8m7B5ZSVgUF25PbbACVUZfr18tjUqRi	30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	1529	1316	614	12463	18974	jwNweowYX2p7n5kgG6LXgdaKXx48b7fwC3Vxp8iHrYNey5PTBhJ	14861	20921	20921	1619704980000
30228	3NLmKcVGJdUiwsNnLFCMKkaeAJPHFqQyJpfNfo6M8VyEC3FwNFeH	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1406	1393	614	12463	18974	jxPokrfDANjTYukVSzA6N9DWTi9vvHJLftALUb5No4M7S2dUirg	14863	20921	20921	1619704980000
30229	3NKmXEnNxbmAznGS62CxmSp5fXa23eq1UKWbe1F5cyZ9zCBBUTA6	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1529	1316	614	12463	18974	jxFVYwC4xoJm7nVhN7pAMD9iaXMk4cpYjawsADnSrrjWspp7JNm	14863	20921	20921	1619704980000
30231	3NK5nq7EUVhLX86mTX17m3WkziQbLqK4sLv5nBVTDvWGmaHvUAig	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1483	421	614	12463	18974	jxX3jASDXSrMJP8vkb5z7dbu9R5suxLXnKrzuZaNkU6HGWGEXRk	14865	20925	20925	1619705700000
30234	3NKyw3uHCoT8mQn6KPQv5Z3JEsjTJGG8T5oCv8eppFGjh7wwZFQs	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1637	816	614	12463	18974	jwuoQp2LTSwdY7zSjaR6UNGiXa5Tjc3uA2KkjRckPYA2ga7vD9q	14865	20925	20925	1619705700000
30236	3NLx18qFWoFbXo2QwBSar4gLDLH7W7w1LmbmfdqGyFA2YLBomPyz	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1541	1298	614	12463	18974	jxArn27oh4QiNnDiPeRLzgsRAPSRi1d7yV1bDy2KPp1EHbDcG6j	14865	20925	20925	1619705700000
30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	1402	888	614	12463	18974	jwiqJJAcYTtV4wL2QaKqRUH2VeNHbJyT2BbVkgWGd24jZC1AuWy	14866	20927	20927	1619706060000
30139	3NKZuMZdDCkDZuPFHfkzehrPbUaAUV1XNGCo68rs6Ga1XNPTpTw6	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	684	1106	610	12463	18974	jxdK3nuEgEj4jDxCRgzMouGgUbERuVnJCJekFVt1AToCocQac6T	14830	20877	20877	1619697060000
30141	3NLfon1Tz3dHy9CnKNCZDZdsumm12ijXmLd7QarQVckMcWTrDcGq	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jwV319rBwnhiz7kxQg9ybcqz2NVDMUqkYJ8ksRSk1R9oWkBNXft	14830	20877	20877	1619697060000
30143	3NKdjBDTcXezn3KjFfMWHLfjUQzaKKr7KSeXbPViWyYZ4UcbPfjF	30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	1608	1289	610	12463	18974	jwEm2UCEBqrWNEt129kEuMALiMpYBQGzRmfe1guRYUS1qeZYnhd	14831	20878	20878	1619697240000
30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	30151	3NKXJaac9qfeV2UdVS23qVRZn9RaVXpyLv9JZ5EbBeBM5Un9bn8E	1542	1178	610	12463	18974	jwPwVsSPZ2tmmGbp8UrWGmDgFDrrzTPpYcjpWosckmcVZV2kcW7	14836	20884	20884	1619698320000
30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	1508	1387	611	12463	18974	jxdA9X8qx9VqrVwXZL38hV8seUSwM3S8vAs98y3rtrswZkLUpTo	14837	20886	20886	1619698680000
30157	3NLHQqSjoWPLATzxcwqhQabLoK7G97U6YM23AngaQa7cbjfjuy2o	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1670	1036	611	12463	18974	jxiFxudZTzb9NqimtLXvQ2z75hU6RVTC5R2SgEh9YHhPip2MNTn	14838	20887	20887	1619698860000
30161	3NKZANShucbvi6Shru8KQYYYhW9r93NwF7ktmdkNZyTBXEHHfH1Q	30158	3NKs2qoEAEiK6UBuLtc8ht7SRtJhYhHNJbB6g9NDodLwLhdQYQnH	1457	1145	611	12463	18974	jwienHXzqU1HLmzTwCnjcPoFY9ux2PGtaZXNuQm6bWuUPAMRo4h	14840	20889	20889	1619699220000
30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1599	1287	611	12463	18974	jwnpbNFo9EGxYUdBJzFiUASQoCWmiCrw6rUKDgh5FyExEVr8NPi	14842	20894	20894	1619700120000
30180	3NL5cYeajLbLHXEyUagQktd2mgB3gB8farE1fSNDG1QcxkEpgSuM	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1444	1381	612	12463	18974	jwJKWsW6BijTAJ1sdjZ58TmCy79zgZeSfkiMt9KpmN8x4tZb9dB	14848	20901	20901	1619701380000
30182	3NK3nD2aF19o7sc599RSBJRifDShM4fyUr612yhaAA6LBpdvxifc	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1444	1381	612	12463	18974	jwSp9d8MXGZNMB5ZPJe1t7HZMizxTNRayKW3UxU2pDdnFnWnBFB	14848	20901	20901	1619701380000
30187	3NK9X3sjg4hcJHH4goH8pVNevEP7738hZr2Ko4j1Dpvp3kMoMKJJ	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jxE1XScX3a2VRKDqzjQkxifs8FZAwZqiaw3e4AE5jFTEMVRH8J9	14851	20905	20905	1619702100000
30200	3NKsEgfdhA3pKbxKix2Wd9mr3p8hDRRHJheGumnEDaDjuuQwWcLF	30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	1590	1174	613	12463	18974	jxzLEgb34H3Ucr9HJGVVCgaTtAzuWQaLsB1sSHiFG8LxhfYyLPt	14855	20911	20911	1619703180000
30202	3NKRjfcakgAYC1ztupaNPsGxynmwCPtyBgoQN5jYbdxnpjczn8iH	30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	80	907	613	12463	18974	jwaeg27szxDeCKk3WaiztoobyzZBVepvapY5ScCsns29caYLtob	14856	20913	20913	1619703540000
30204	3NKFm4gSJEApYEuceuFFvBsw599WpQ25ze4VyUDjfhM5rHfCAL6S	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1609	1087	613	12463	18974	jxNRPRQkpVNZkCrhdM4EB9oiQmiM6yPRoLJqodkULmsY66Yapan	14857	20914	20914	1619703720000
30206	3NL8ZGX3isofXJgoVeRLXvcxthfjLaw8soGKLenXwLDD9p7r6Rh8	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1637	816	613	12463	18974	jwJ4N5aAqHuh3mM31p9Zvg6nrdXzjL9d2VmekPJkPLNoMijaF8d	14857	20914	20914	1619703720000
30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1609	1087	613	12463	18974	jwcUJYTuTNvk1YZe1r5JqaYmr8u6ZhHjySHxn4PcfyVmskmVPZd	14857	20914	20914	1619703720000
30210	3NKSyARDY9e8pK537NxGnkXc4wm7wgUfmSg6wdVE7vThZyEjYdSo	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	1406	1393	613	12463	18974	jxZZb2MZ1VKMqGNZnyZ4Pocat1V2QHTpJ1dieiaUTtfHwUMaEpE	14858	20916	20916	1619704080000
30212	3NL3SuLsPPqW37myzTzjvDRwEhjdrn8w1KYJ2YUTj8wDLf3SzrBJ	29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	1403	824	585	12463	18974	jxhycYKNGuLmtyvGL1k87UQtUrbC4NuAE398ZiDjvt8Cs761nNp	14632	20917	20917	1619704260000
30217	3NLPZ9SrUTvKbAYWuz7yza7f6TT7q67ox7obguHipCmMVnhkZan7	30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	1523	1321	614	12463	18974	jxSPpjuBQvSz7PWJJqja3fbWxmR7Qk3yXKeoRBE6XiCJTbaN7sP	14859	20917	20917	1619704260000
30220	3NKs9GTu2R7XigYTWtrKd2D624PnErtnR83gkRGY9xmqYqY5wHLA	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1439	913	614	12463	18974	jwVDZBvZF29Ewiif6B5zcSauQtJT5trEiv1FGcay8VphrXabd4x	14859	20917	20917	1619704260000
30223	3NL5D3HJJCgsWXCqLA31GYuVMJTy3ACWYeqC2Z63Nsyq5jFfUcEf	30001	3NLv6UwsRR68LXhbiYGn8ms3vY8hZG4Q1zJk3w1oYqY9XaWTV7Zz	1593	1100	600	12463	18974	jxyLgc6xhxp9USWpV3oqcbytdCTDRfNYKQ8rQXXrakVQkviHzGR	14735	20919	20919	1619704620000
30225	3NL2chMDae3zdxU92cyu9SVr3xKgeVDuAWW6Zo1WSoAQmr3RyLLe	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1588	1146	614	12463	18974	jwTb8MaKAAMLXvRPWAg1xt4d4BzdgRfdFRW8U6KTWbPkm8h6xp6	14863	20921	20921	1619704980000
30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	30228	3NLmKcVGJdUiwsNnLFCMKkaeAJPHFqQyJpfNfo6M8VyEC3FwNFeH	1402	874	614	12463	18974	jy1mtbsdjch168hgubJ2wefM5iH9PsCNgU5XWe1i15JCwmznnbb	14864	20924	20924	1619705520000
30232	3NKd4GUSHQQfKsvCcvR4mwFJwZGtSuq1BBfBg9gC6BJMarxZCT6a	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1619	1275	614	12463	18974	jwXYfr7cYTtQPLMWneEx35jyZ3bMeS4emf6hZdk2ZRWpMxgmiEu	14865	20925	20925	1619705700000
30235	3NK4gAMtfFdvG437BSTRrECT9YuPfVSf8dTGRevVBSPrPi2uFKUB	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1619	1275	614	12463	18974	jxBAFZnAyDndWrfpm1McVdgwuqiXhi83TnrrQJvKYmJZjgSw7MU	14865	20925	20925	1619705700000
30241	3NLjEpiagyYsjJv7mPXK1faV7JuhmLnVqHRtZFJjBUUk4TqMS838	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jxxCM6kFfz14A789r6rYfXszbY7aV4kSJUXwFmxKc4g9enR41vs	14867	20928	20928	1619706240000
30248	3NL4yHToErMwEnrY1sa8RswzM3VQJxHHiiteBuV3FSGathJnidxz	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1541	1298	615	12463	18974	jwhkPTsJ7XVfx8YHXa7CcCWUNfy67Zuo1Gn155A6ywzfE6xkRBh	14873	20935	20935	1619707500000
30252	3NL7LasWkSvBf6813uY9nkA1kVofBbPYZ3FnfsWzu1ozSunWDZmE	30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	1406	1393	615	12463	18974	jwYDBpDVoHq7uSd6ZbNiHBre4DPWiYXPyPoxFLMDD4Jv5wUqHbd	14874	20936	20936	1619707680000
30255	3NLsxGSWJzm6Yn2NjQRhJ9L98FVsYxL3PgaQoyDJTdngEMysQUx5	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1673	1368	616	12463	18974	jwmUULT6XR3L99EB58PZZMC7omuDmuqVHkmV5FCNQgBxUu738B3	14876	20939	20939	1619708220000
30174	3NKohjC2RNzRtzu5dTaHkAMFj3WCXmMK5kPzS6YPcK27KMeYymzu	30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	1559	1107	612	12463	18974	jxxqpNoC2UZMzoiR2dKTxjihaFxJAMswnFbJvsiw4GgqvEN98mN	14845	20897	20897	1619700660000
30184	3NLJzMycdbTSQ3znBB4hgVTwGbWSkGthEBsW6Mi7pR6NhAtqwisH	30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	1610	1068	612	12463	18974	jxu5PtTgEAoaZUfeaNaEgLjvtNSGK7Eha1utSTV2kzVxVYfrN6Q	14849	20902	20902	1619701560000
30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	30183	3NLbaRwdRHB67A8eEMqcB4cUFMUqgJsRJYipqp4bzkyTEXmm3ACe	1407	1395	612	12463	18974	jxvtev35HpMAHctzCvyVxViMc9cTSGxb6Bn9BCZrq28RXC5BqFB	14850	20903	20903	1619701740000
30193	3NLfh4cg3HcMcF1WkZjSMTzS6AYaAcuDVhgJtbuXJ7TUuc63ZWw7	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1490	1274	613	12463	18974	jxr6xwRa4bvkxbKz2b56C5pfADzMWfXNbnDi8bfwLQVFAzRTnYb	14853	20908	20908	1619702640000
30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1631	794	613	12463	18974	jxRSRHXymBL6sTr3EGozcoC3MvvsKsUzME7Gk8WaL2kVEzvLZys	14853	20908	20908	1619702640000
30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	1460	1324	613	12463	18974	jxyBgt3Lr3xMMgmrhv9sWkahTw3P99sUpTnbvLaM4ingF8W8XDG	14855	20911	20911	1619703180000
30201	3NKhQkQ46nF9eDXYvLyq9sshW8jUN2GxCSuw5VXd3HrGVrim2mSE	30198	3NKQrdVoSTHk4DDxDBi24xwL2X9S35qDspdBNvmBhG4LBJC3P68n	1590	1174	611	12463	18974	jwnU4E1R6DysxZLn3j46Gi4PNEZkiYT2ACV2k9zYycz6nUw3ECX	14839	20911	20911	1619703180000
30213	3NKj6dj6vnjZBoZ9DyRZcaWxYbCUNqz78qyRrRgKZNc4fvPsZpka	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxvCVQSdhjspRhSbkDvxMBCtmS8VZswrTHdKZPWra3JuN1Ac2UN	14858	20916	20916	1619704080000
30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxvCVQSdhjspRhSbkDvxMBCtmS8VZswrTHdKZPWra3JuN1Ac2UN	14858	20916	20916	1619704080000
30216	3NKdi6mraFQFasnaawjYDkDUo4wjvdgYjACcpWvwSFPbRntUKsCr	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1523	1321	614	12463	18974	jxwkt6ubLhNWzSzvaKY44TPhkz6tBrP17Madbaw4mkR2DEfsnGo	14859	20917	20917	1619704260000
30219	3NK32bRk7cxgKEoAAsS8wo42kHAdvA7GcGVJWyFBwY2fWLjqJQnn	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	632	1382	614	12463	18974	jwAG9e7GUiCRSDNW4xTLooqwyRM4CzaSFiFw95SpzvDuQbQab7t	14859	20917	20917	1619704260000
30240	3NKyD4xLBkEAUrV12qgaENNgyc2Mmzhm8TyYRpReV6NAmRS28CGv	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jwMw3FJfPwt83GQ7ohioqrR33UhDQmbHcqet1iK77zNECNHCAeG	14867	20928	20928	1619706240000
30242	3NKfvGhga6Rv8f2ngLhbLWyVqs6rurqJbEjc9NLaez3vdyX6LbBq	30239	3NKsWEHLSD99MdNhJ1HfcvreG2ZpHSP26tZnViL97RtpVcnysYHM	1637	816	615	12463	18974	jx1S5HQTg1HYW1DjuaY1PCUf5NqKsKWkquh5dYCH25ZMWzwK1hA	14868	20929	20929	1619706420000
30244	3NLWW8D9r6Ac8j933nQ7GvgU962BrtSUMqGrwEsaoK9mXTSpimZ3	30243	3NKc8xaFd8CY7UrfcfbCemcMWE7DbhgVDywKB3WyzGypHgp8EZ92	1403	786	615	12463	18974	jxV3MPnbtK2qu47qp99xfccjPRYRMCZDWRRrndqxad9259GPcB5	14870	20931	20931	1619706780000
30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	1637	816	615	12463	18974	jwHxm7siPvEM6pVZJvwhQFj3FJxDukttSRs1JHfUCq8x9ryoQRb	14872	20934	20934	1619707320000
30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1600	1126	615	12463	18974	jxTSyWLTsioVNeVHBjoXkpzVAaMssPZ2BGQxCR3vZs6poWDmq8N	14873	20935	20935	1619707500000
30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	30253	3NLbtVZRrZroDFZuK16ZGJufqxHrDzSNwewRHR3CAFLCqgs54Wiv	1457	1145	615	12463	18974	jwgaQwZsfPnc9GqS7radx5QRoRRdYHEE4cohf4vSR1ciUD5gksS	14875	20937	20937	1619707860000
30256	3NKHtkSg7TAcrWor8xFVBSHQAj9p9rQoahArPLsBtUB32hXwrKSv	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1564	1338	616	12463	18974	jwtWu5Xg5pYi5KMECJwfSy2aXpKE9g2kpWt8dM8w6J9CcPLJARS	14876	20939	20939	1619708220000
30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	30260	3NKP1qSq2v6d7RteACaygpBjSULKowLKu6KBt3QcbFR1ciJfFSc3	1402	868	616	12463	18974	jww8Z4trz2eCK7mRKxoxUffj9wbqbkJpV4S7v8KaDtGKaD9gDP3	14878	20944	20944	1619709120000
30263	3NKQjBaFrKCL17JNBuqzba2itUWLuttun1dLWwQZNXjEBW5Q1cNp	30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	1609	967	616	12463	18974	jx1CjkTQbSpLkCti9nsGpabMa75fucugNdMYXRNXkVjzgyT5MyF	14879	20946	20946	1619709480000
30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1577	1201	612	12463	18974	jwF4XceTx5Cjv8gA8PKhkkY6QEYWr5ydjA414h3p2mB1HfS8By9	14848	20901	20901	1619701380000
30188	3NLSuskWHw9bqeHzuXZJ57LmFs2up8F64Ma2AJQMs8i1LvHekhx1	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jx1rP77TCQBUqSYHF9BbzvS45ZUcoudpoU3DeHQeDHfCfBVVu9x	14851	20905	20905	1619702100000
30191	3NLdBtQwEHoxkzu7FpD6Kxycda9knzu6191d1esJt9yMHQkmMKZ5	30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	1407	1395	613	12463	18974	jxQdb27Q1rX46ufE1Y2J9EFQk1YQxNNvcC3fMwbfu9CtsZMzVfw	14852	20906	20906	1619702280000
30194	3NLKa5qdaN69wDK441duVe3Cbm1e293mp1RELoykWAaAW3Gqrsiv	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1490	1274	613	12463	18974	jxhvyppRsoMqoDE7Jr7hyp9nQ9nAm6JxfLqycrXELkHnaEHZoZ6	14853	20908	20908	1619702640000
30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	1403	824	613	12463	18974	jxv7qez6P16pL6HFzRx1xfSTD9c6KEv4S4kAeZEVicsk7GUyZhA	14854	20909	20909	1619702820000
30198	3NKQrdVoSTHk4DDxDBi24xwL2X9S35qDspdBNvmBhG4LBJC3P68n	30153	3NLFMajibWF7SJsZZHviuoy2hRGJgFERq8W3MXD4Tptmrju1TqtP	1590	1174	611	12463	18974	jxbLks4oJ5ruK9ycuzoMjXHsD8yP6Wfd6xaphZ6NGrsnkX8PQth	14838	20909	20909	1619702820000
30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	1407	1395	613	12463	18974	jwCHdd5TEvcPC1xUhLGgopgP9gcDGBi1joC9BWJjuigKdAE1UHF	14856	20913	20913	1619703540000
30205	3NKU9rEWf7nSkaFUoEG4jeEZcaXoEgeMZA2uc2ZETFWnfJeoqvih	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1596	997	613	12463	18974	jwEaZHN6YfLqynMzC6taRELaDDtNZP2gSVyxEQFaEtZEX3VaE3U	14857	20914	20914	1619703720000
30207	3NKLQyaa7P5SFytSyZDvRssQ9y3cYkjsXw8fzr9PgWkiFz2BXvmR	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	369	1312	610	12463	18974	jwBcQQxhjU9urCC68u7kirm83k6zT4DJUVnGoLokBXcjcU3iMK9	14832	20914	20914	1619703720000
30215	3NL2jdoRuDRFCDmBYXyRToV6zTseo3n25ZF9i6upS7jxwYg6914k	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1523	1321	614	12463	18974	jxb8hvEtpQpgDjJR1U7Tmq6k3DLgLwMLkiQtGtnVpR2iqPoVZXy	14859	20917	20917	1619704260000
30218	3NLXZ6qjX2Cq4jkw7CiT78DESVVbsEeuYE4jwYygiUHYKBoUVj2c	30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	632	1382	614	12463	18974	jxRmnb7w5cEVNzrZSgTiX6SqpSXs3aNgQcFRFmYiLgbQG4NuvSh	14859	20917	20917	1619704260000
30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	30220	3NKs9GTu2R7XigYTWtrKd2D624PnErtnR83gkRGY9xmqYqY5wHLA	1407	1395	614	12463	18974	jwSH8npEHiyykxjhzXgpcnUDHAMf4heha1UQRPVooLtY6wTC7Zi	14860	20918	20918	1619704440000
30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	30222	3NK6xFiCE9tj1iao5p6MXUtMDfGowwxS4CuPUcahMM7j48dDo2zu	484	1319	614	12463	18974	jwXt9h2WQsZaDUc4z2QB56PcAZAqnzWZKRfn96e19mY8K9XbAQU	14862	20920	20920	1619704800000
30226	3NK35LhKxhwXupcbQNqEhis9rcMCCqEeMasLmpqf4j7g5vQ31Rue	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1529	1316	614	12463	18974	jx1eGeZ9yU9sMHKHcAv4M27asuMc15aDMQNKSMTU4nLZyJEreL2	14863	20921	20921	1619704980000
30233	3NKPJxmQHQZNTu52CeUtoYFEWLEcGqcBkpzd18VoWgvpvuuvKVr4	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1541	1298	614	12463	18974	jwgcsmsXphnGjBtoeGE7E3Xzydwy5N2EBecEAi2Gm5gKTZ7C3b4	14865	20925	20925	1619705700000
30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1483	421	614	12463	18974	jxk2De3bWUdzjopkdoMVG91N3puin6FV179FXkGpGHbiUGdynPy	14865	20925	20925	1619705700000
30239	3NKsWEHLSD99MdNhJ1HfcvreG2ZpHSP26tZnViL97RtpVcnysYHM	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jxAqsFsPX8MJxWQPoVBagAejtohvLgujzbUJ29M5hpSejcX715z	14867	20928	20928	1619706240000
30243	3NKc8xaFd8CY7UrfcfbCemcMWE7DbhgVDywKB3WyzGypHgp8EZ92	30242	3NKfvGhga6Rv8f2ngLhbLWyVqs6rurqJbEjc9NLaez3vdyX6LbBq	1607	1222	615	12463	18974	jwLbze7xqdfzBU1jJHQaXibqmt65hw2N7X3fVt1eG2LrdDXonsn	14869	20930	20930	1619706600000
30246	3NK57NJjsdWJxV91bSX5JRn8qQqcQNyKX35v5W1MHp5tD89hbw8H	30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	1600	1006	615	12463	18974	jxnVFR3ANxxyPnHXbezvGBg7az4uSfgCyoTb4Wm9zK8wWepHfKN	14872	20934	20934	1619707320000
30251	3NKSw61MeeuohKbJPBkXbNQEQLzeCBDXJqKTDMkjU38nzWPHRidn	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1581	778	615	12463	18974	jwMy9mmXnsHz56yJgN4YUXsn4zofpJo85MXjkpANfd8kRgUffKQ	14873	20935	20935	1619707500000
30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1406	1393	616	12463	18974	jwkrHRc3gRKQ4w8UipCThxMLVMXWv9Yf2GohxT7Yc1sjLbJzfdo	14876	20939	20939	1619708220000
30260	3NKP1qSq2v6d7RteACaygpBjSULKowLKu6KBt3QcbFR1ciJfFSc3	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	1609	1333	616	12463	18974	jwoQQrRserNYhRqFJUw6bEsH9FNjhD8ehvug7SPouBnuFCaSsGm	14877	20943	20943	1619708940000
30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	1609	967	616	12463	18974	jwfpDLm6BTMAD6eUJBHMkxjVy9ZvXtY2WhHgpeA6PnVsiX83V6U	14879	20946	20946	1619709480000
30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	30244	3NLWW8D9r6Ac8j933nQ7GvgU962BrtSUMqGrwEsaoK9mXTSpimZ3	1405	873	615	12463	18974	jwEYG8F8S1UDvusxdKzj2LQ3MYKss4RPsG7KoHNZhnVkG8QAmBG	14871	20932	20932	1619706960000
30249	3NLPXjzxb17q2RGE2THVWTr9CfK8JhsYo4MypSwF2j7zPCzi1dV4	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1541	1298	615	12463	18974	jwkML7D1dpevUHXFR46kcsNkwqsr6nL2qivYdaAuzHYa3YEY9hv	14873	20935	20935	1619707500000
30253	3NLbtVZRrZroDFZuK16ZGJufqxHrDzSNwewRHR3CAFLCqgs54Wiv	30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	1573	1192	615	12463	18974	jwLTwy8wmtRvsxJrTgwR5drzEyGJjbrBNhwPAcySY31uGb2rnXW	14874	20936	20936	1619707680000
30258	3NK99pAtBs8Z1XhQJybzNQ5zFomLYgPzDtjqQP4NkDnX1RTDDMSb	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	1609	1333	616	12463	18974	jwdkDewynvnXV1K1KCBqJARGXaj1XcqYCKspgC53LntDjdEQ8Te	14877	20943	20943	1619708940000
30259	3NLozTx9fgdxNLPAaEUd5WmzpUGNFDQ8gWorZNqZ3SnxbpuD8Zcz	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	632	1382	616	12463	18974	jxri7TiY9njGJPzY65Jdx1kh7XJq4A6VKmvCpX2cccga2Db6363	14877	20943	20943	1619708940000
30264	3NKV4yeXvPRECBYbBrDds8kzoTGvnNxMyDdib35EPCPZqV8i3uSr	30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	1577	1327	616	12463	18974	jxmaH2T5weP6DdqJ8ssx5BakCq99ztei1fSkEryym3S9Wo9pQm1	14880	20947	20947	1619709660000
30265	3NKpEusGuGbfwxivMYqFq39Pb7uPkVAXiTJ1yBStBpoe1v8F6p6z	30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	1577	1327	616	12463	18974	jwieeNxKLZea7qWH4T4ddqRFzoiVwDkAXcfSR4p7fpQtPFQdtFA	14880	20947	20947	1619709660000
30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	30264	3NKV4yeXvPRECBYbBrDds8kzoTGvnNxMyDdib35EPCPZqV8i3uSr	1467	1250	616	12463	18974	jxqLLTHGDtr7FEE2PKskeSALmFiiGFGhwU6h2dExeyA196P9LHN	14881	20950	20950	1619710200000
30267	3NLq4DhZyncrcvf8VqfmuooKHgDr6LuE2Vg5NFMJikEWABBbQdQp	30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	43	944	608	12463	18974	jxSc4QbpdS2ueNtu4eLAisQkzKiEhmmbqLy8FP2eAqTYLGQSTQC	14812	20950	20950	1619710200000
30268	3NK5wpmBgNAFbCCgB9JFDXJyMJ21TForMsWXEUyeJYT2Pb4VCfEg	30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	1672	1039	617	12463	18974	jwMcUUHMYGek6mMHvMy7prAStTD5we5Tf4uvzvd1jqfXi3s1nLW	14882	20952	20952	1619710560000
30269	3NKt8Zu3uUCEAQNXSPDQyc7hC3jzM3LfqAM81UvweqAwaWKPmi7P	30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	1672	1039	617	12463	18974	jx69NPLkpSieqbMfKcP8RKhb6TEjRGgfB9FpDSGj3Rvuy1FpuDo	14882	20952	20952	1619710560000
30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	30269	3NKt8Zu3uUCEAQNXSPDQyc7hC3jzM3LfqAM81UvweqAwaWKPmi7P	1407	1395	617	12463	18974	jwF4f1QaTecL3tHCpYURFhFKk8o8NSjufLDHLzyXHdQGMymcVTZ	14883	20953	20953	1619710740000
30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	1642	1367	617	12463	18974	jw84zdtheJWaPRNLvQxR6Md1rTaz3S6wXe8Z3b2hoTYxjv76qnN	14884	20954	20954	1619710920000
30272	3NL6e1hKcDYA9AwPcRxTPPN3yHFTd2CK8bvdqCXs7CQzEkh55wQ3	30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	1623	830	617	12463	18974	jxhATZAQMEkxjP9TQVbPYXuLBA733TfGnBYfmcHP7PGwC2MNwkr	14884	20954	20954	1619710920000
30273	3NLHBJJ9GXJNF1J7vtZ3roBJHa3umP4Q6ULXxfYxcCrduVJvLsGP	30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	1602	1003	617	12463	18974	jxsrk6iite77ESmNonfNVa1umY6j9R5hmHnb71BPhpQDFZ5FGzM	14885	20958	20958	1619711640000
30274	3NKgYu6zxonkqLnMQw54n9c4AUzija8ncZ83xZuxDMpBPoNcCeJG	30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	1602	1003	617	12463	18974	jwaiLzo2akguqzG1pqwsMzRHMr2fyX7tUCiVVbJanxmQjb3tfC7	14885	20958	20958	1619711640000
30275	3NKnbhgrbJAzhH3wKhDX4VM6fjjTBKqxZGpLFUFYmZN3z2Y1acRf	30273	3NLHBJJ9GXJNF1J7vtZ3roBJHa3umP4Q6ULXxfYxcCrduVJvLsGP	1474	1203	617	12463	18974	jx5kfWVtZcwbZwFEf8wc2aojzbc7TbYFvxhQju3FCoKbLTfvho1	14886	20959	20959	1619711820000
30276	3NL5vHpXV7At6w46BgC26q9s14tnuKzD3CQvU1kMuT1G8gMm2NCv	30275	3NKnbhgrbJAzhH3wKhDX4VM6fjjTBKqxZGpLFUFYmZN3z2Y1acRf	1501	1234	617	12463	18974	jxhq4ujAFrdco4pTmvxb4HVwWwpo2PRTGSb4tXoRMpZLVUdNYBe	14887	20960	20960	1619712000000
30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	30276	3NL5vHpXV7At6w46BgC26q9s14tnuKzD3CQvU1kMuT1G8gMm2NCv	1405	869	618	12463	18974	jx9mmLPFHK417NcDDsrH7VYkZDECXsNeh3uXijDunUPVDB4FBAk	14888	20961	20961	1619712180000
30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1579	1389	618	12463	18974	jwHqnJyxNkixpiTTo8xPS1QtzURpsC6Ned2JPDgc1GGoFN9cvrh	14889	20962	20962	1619712360000
30279	3NKugYhxkPb8YYEMQxDBVhyQoVZGuJDBWq3gzZjYw4QP1WFSNx2W	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1529	1316	618	12463	18974	jxLt57Lrb75aKVLHq41HMoRL4wSubiscCBBdFEHgm2qprVNPkNR	14889	20962	20962	1619712360000
30280	3NLvZe6SbFPvEJyfwQrX2wq5Han4aSiN5QNq4pAKRkrAgUua9KuY	30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	1529	1316	614	12463	18974	jy1xKCwfiiodQDqFv16tMfnrii1XQV5vrc61THpk7ozQvau9LQW	14866	20962	20962	1619712360000
30281	3NLtKLhqUx5ma1cCwRAx73nAwEQTtogrQgkR69yNBMvPfYYhFHnW	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1529	1316	618	12463	18974	jxU2Kf8cyuiJqkqaCBpGQARdDppaF8PSLECcaf9RejNo2YKE8xQ	14889	20962	20962	1619712360000
30282	3NL3WMoAU3P3Yco36gTuCm7xkF11GD6LRQMzyZr7WRqrxy5YeYga	30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	1406	1393	618	12463	18974	jwxz4tr6njU9em9hfTZXraqUXX2ZwuyUkXVhK1GTmyNENTWzcqe	14890	20963	20963	1619712540000
30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	1600	1372	618	12463	18974	jwJ6bzfDDxsikohxe9VSSJtstWH5adSbVh36LJ74JxbN6jVR3eu	14890	20963	20963	1619712540000
30284	3NLunwQk8mev4nKPFGR62sMSep5dMGMww3FLcciMnzsLj5JUzWHV	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1403	824	618	12463	18974	jxhNkDtkgqZ9Q4ccwfaDungSCqbaJYgkWvAD3BesMHhdKhtyyT4	14891	20964	20964	1619712720000
30285	3NKrXfawRPT8AJCJUF6wwLzSyuWQcrqC9B2LCRA2V2kzWKw6Znf8	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1407	1395	618	12463	18974	jwib5RfNmhvdNLYoL8Yxor8we9NUSYzT4GRRhwjdsMciBrUqvBr	14891	20964	20964	1619712720000
30286	3NLbNxsY58tjRADqbiAzzeYHSJ3yCSSb8HT3JAEapDcgaRXizc1G	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1541	1298	618	12463	18974	jxDnzJPpmDKDiiyVRvYixCFd55TJAVRN8E2yFj4jFfwrZKicfZG	14891	20964	20964	1619712720000
30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1541	1298	618	12463	18974	jxZHF1xckzEHNriANUPRrmWmCivBDkQMiDVtA9roq6PycjhNL3V	14891	20964	20964	1619712720000
30288	3NLgmz883ArmrNPBQjuGH3tpcx4zJphJcyjx2UgR9jfFWJuM1B8r	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1610	1314	618	12463	18974	jxNrXBDg714DHgZsffuf2wcx5SH37yYc18fD8i9RK5nuXYfkKio	14892	20966	20966	1619713080000
30289	3NLPGjbYccG7sna9eWcKPauneutGfKCEHyVa62biX4puxBR7rx7V	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1407	1395	618	12463	18974	jx3WRWibLVtVSie5gbjb76sFkqKr9L4LSRmm11WMLHkmA2E8tbY	14892	20966	20966	1619713080000
30290	3NLoJKD2Jw1AwgbKDKDFCC62w3coTshQECqE5WUjLzHrXbdjBnSG	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1610	1314	618	12463	18974	jxPHnjMiCpPVgixQUJo9jCy3mSVzzwoATwSp4NGw7kQDEBuUw7j	14892	20966	20966	1619713080000
30291	3NLGGGTyeEe8c5yURV86AyiwAb916FhKnWAi1NgB4RbRppP1c2G4	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1471	1386	618	12463	18974	jxsLP58ey226zDDfxcMyTdFSxyAz3Wj6wEcHWRcYSkKbi2CyLuU	14892	20966	20966	1619713080000
30296	3NKruY4o6U3oq4rUp8SpYYmy7yzRiPsL1YWT4brUfDBJp95EAgxn	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1455	1332	618	12463	18974	jxvRSGc9jTUt8A64PqmMvaTruRHDn5iYR9aqKGjgKM9GRzCkiRU	14893	20967	20967	1619713260000
30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	1439	1279	618	12463	18974	jx2TGFmZ1Xh2t2FYY97jUpEsnaxDjrnToirTPXkdWgUxSsX7uPt	14895	20969	20969	1619713620000
30311	3NLVrGS28dWs2ucixMRe5gGzpJ93JWpNG7BLMu8147sjWu6MQsHE	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1490	1274	618	12463	18974	jx2G1vmd5PZzpMn8HGvKEYfgYq8BHScMRLjSXRYKZTLW5kknNo8	14897	20972	20972	1619714160000
30313	3NLyYFgirM6ZDymk4vmZhSELQmc7kTQiaqttbiJAkfiNpKNpbrb9	30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	1509	954	618	12463	18974	jwPM4WcgFPtqg7k5Zav3mby8kMy4apxkDoeZ2sbSbJSV4iPTLGf	14898	20973	20973	1619714340000
30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	30313	3NLyYFgirM6ZDymk4vmZhSELQmc7kTQiaqttbiJAkfiNpKNpbrb9	1631	794	618	12463	18974	jxYEXU9Y8qYBBQjmpJyWjX1rF8wk8miFrh34VDDj7riHSMyybuz	14899	20974	20974	1619714520000
30318	3NKmi5p6dANCUHASVnou6faUB4aPS4FrqhB9UtdYowcXf32yYqvk	30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	1587	1111	618	12463	18974	jwmLe35uCwvWLeJhhz1QMcsCAkCwZYh6eb6KZNk15WaMmhbTvMj	14900	20975	20975	1619714700000
30292	3NK77SA8ZBbyUE52KmoGDKsNRKZ4ZsziEGCGVpGHrs6AWjeYBeHF	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1673	1122	618	12463	18974	jxuKFFAiiQra884oL8NVfADWasCByyby5gzDyxJ1Rzud9xMHFmS	14892	20966	20966	1619713080000
30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1637	816	618	12463	18974	jxnUMXsf1oi5sJTbfa3xcfiXnUWKbHwdkzCsquQFjFnZRqoHizF	14892	20966	20966	1619713080000
30299	3NKkDAciuF2KjEA3y87L7pWWo3jxniFR2yZkkmzDhJgDEWyptQEr	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jwZHQpyo7wE3yBPwS43vbrm4u2xGU9ULsLhks86JXXV4BTRZBHQ	14894	20968	20968	1619713440000
30303	3NKbpM5sJaP6dsMaKp2HxJQ3rXXqdwVW48oRifJckHepM6of29ji	30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	1439	1279	618	12463	18974	jxnwg8SLPfSywT8GTdS7JyVMKr21mkrLE8SXiMFm2FqNUecYZzq	14895	20969	20969	1619713620000
30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	1534	951	618	12463	18974	jxvyWaroEQ1ZWejGwXpRYFkybDHNHroxRX4NYvhfvKhm95vUg4a	14896	20971	20971	1619713980000
30307	3NKrSoomyfH9JcTe95Svq1ZGK8zgYz7Hp82CPsJJdPjy8X4tzv3q	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1451	1292	618	12463	18974	jx1DusVj9aqqRvY6c2VrX66GCc6pxcEQZPZHdJDiEFnZbMNG8Ng	14897	20972	20972	1619714160000
30312	3NLJVTSBw6KG8S58ctg1irxvz6eJ26q12efkxkUfey85cS7ySbzN	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1483	1276	618	12463	18974	jxqeAozJCbWQrUkTr3b2ac4Gb1Qf3kkFVgCFYkYZLgW7ntH26tV	14897	20972	20972	1619714160000
30314	3NL3PjgizqqeWMANdZSjqQxHhZu3kBG1T6pFqoFirPdp7BRb8qdv	30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	1581	778	618	12463	18974	jxBpErZBThNa3u5XZ6o2ma8dEAuFV3MDCKLpcVAfnH4TorHpSuR	14898	20973	20973	1619714340000
30294	3NKA8bdFFmjHnACybeCFDqcttmtSK5UEzyJceV8FxWjqZy5VmJpS	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1405	867	618	12463	18974	jwhD1YYQBbnAk1rvnfdtcvHqJiaTPc4odWHmeFaxyUQ3S8yHMsC	14893	20967	20967	1619713260000
30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1406	1393	618	12463	18974	jy2YVJU5btMKwJ9dsvTqHCZq4tYi7At6o7TYKWqJJayrLQEdAaa	14893	20967	20967	1619713260000
30298	3NLAHREf3AjbLinqxuqYYimszcEYi7B3FUHV46tsk5CBggUCXUg6	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jwKXZnhuV4EpiAh5oqXR5ZCUd3i1CfRoLv7iHaeG8y9M8MNjBCv	14894	20968	20968	1619713440000
30300	3NLuSay24d8a9DZKj9JG3fH2m7FWqGTwZNvKXYx2Ga8xx5Xs6PAL	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jx9cM2nQrPvgy97JBCbQeje5UcVDSELvDuZmJFAtJVLLzKgCjU1	14894	20968	20968	1619713440000
30308	3NKdEDUKAbdFJ6X37jg9WBVBpS7v51b1AcoDNtFG3YS1cVGGv8t5	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1483	1276	618	12463	18974	jxSJeicT2Ch9Sa5Y3AahhmGHZqyTFSLDPSkreJQrEJiMrkGnGbu	14897	20972	20972	1619714160000
30317	3NLA5KYve8vX5RwfFru3mP2ikZooRdstmWyirR5wULfKw6WxvZhU	30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	1553	776	618	12463	18974	jwgbt9QHP6HbpRfKQrk7fUyprTgzdhb5PwQk2psFWyTUc4bfkYz	14900	20975	20975	1619714700000
30295	3NLp8YRcdAqFB7GHBJWwR9WVfw8WWbbbudqhsAfYbamcKHrAhqFu	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1608	1289	618	12463	18974	jwf3U6bQkrLCBcxHodMEdy1NFG7HYVh2WPiWtn1Ja1HzsoaxkXE	14893	20967	20967	1619713260000
30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1407	1395	618	12463	18974	jwB8ScUrmJH7QKNi8WddzNnXemhqG19D8XPdG4NRF1GtyjjkkkT	14894	20968	20968	1619713440000
30304	3NLiP1aBccAqtscSVu2dcFTuntCPxLy3KhTQJir6ZQMxaCJuyYMg	30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	1608	1289	618	12463	18974	jwFFWeumB4huU3TVAzpZVZNjUNFzEeLLz62BYpHv5CHBXrEELj9	14896	20971	20971	1619713980000
30306	3NKLgzVzKD31JEjvRzjt6ybt1GhjJsRo9FbjJED5zw6TpZmxbm1h	30299	3NKkDAciuF2KjEA3y87L7pWWo3jxniFR2yZkkmzDhJgDEWyptQEr	1608	1289	618	12463	18974	jxj6z1N12cFnSRRtiRpn1eu4ZSyWRGK5QvNkiJzCfgQ3GwtAsvL	14895	20971	20971	1619713980000
30309	3NKNs6XD7p6xNT5UEujkmzsVKMUnHfXUN911PLoLDeq525gLmFxm	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1490	1274	618	12463	18974	jwj1cqP2neqMbDgLYdR2tqt4nb3hXcJi2b5DzgZqtpw8sbcMtcF	14897	20972	20972	1619714160000
30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1402	874	618	12463	18974	jwaiWQEjBGnEBq7KMH2WZekkRggFgR1uEb2BvrpeCePem7iNSs4	14897	20972	20972	1619714160000
30315	3NLByAURuUPkaK4A8xPicpwez53oogAZoAYfHanvCm8GT12jVmxZ	30307	3NKrSoomyfH9JcTe95Svq1ZGK8zgYz7Hp82CPsJJdPjy8X4tzv3q	1509	954	618	12463	18974	jxkQG2YkvV4P6hxXw5Qyr2gqZz1sG2jFk5TWEWfo4q1FAUPrr6p	14898	20973	20973	1619714340000
\.


--
-- Data for Name: blocks_internal_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks_internal_commands (block_id, internal_command_id, sequence_no, secondary_sequence_no, receiver_balance, receiver_account_creation_fee_paid) FROM stdin;
3	3	5	0	7	\N
4	5	3	0	11	\N
5	7	4	0	16	\N
6	9	2	0	19	\N
7	11	2	0	21	\N
8	12	1	0	22	\N
8	13	2	0	23	\N
9	15	2	0	25	\N
10	10	1	0	27	\N
10	11	2	0	28	\N
11	16	1	0	29	\N
11	17	2	0	30	\N
12	19	2	0	33	\N
14	20	0	0	34	\N
15	21	0	0	35	\N
16	10	0	0	27	\N
17	22	0	0	36	\N
18	24	3	0	41	\N
19	4	1	0	43	\N
19	25	2	0	44	\N
20	2	1	0	45	\N
20	26	2	0	46	\N
21	28	2	0	48	\N
22	10	2	0	52	\N
22	29	3	0	53	\N
23	30	2	0	54	\N
23	31	3	0	55	\N
24	20	3	0	61	\N
24	32	4	0	62	\N
25	33	2	0	67	\N
25	34	3	0	68	\N
26	35	2	0	69	\N
26	36	3	0	70	\N
27	16	1	0	73	\N
27	17	2	0	74	\N
28	37	3	0	79	\N
29	38	2	0	80	\N
29	39	3	0	81	\N
30	41	2	0	85	\N
31	42	1	0	86	\N
31	43	2	0	87	\N
32	10	1	0	90	\N
32	11	2	0	91	\N
33	10	1	0	94	\N
33	11	2	0	95	\N
34	44	1	0	96	\N
34	45	2	0	97	\N
35	44	1	0	100	\N
35	45	2	0	101	\N
36	15	2	0	25	\N
37	46	3	0	110	\N
37	47	4	0	111	\N
38	1	3	0	118	\N
38	48	4	0	119	\N
39	49	1	0	122	\N
39	50	2	0	123	\N
40	52	2	0	125	\N
41	4	1	0	128	\N
41	25	2	0	129	\N
42	10	1	0	94	\N
42	11	2	0	95	\N
43	16	1	0	130	\N
43	17	2	0	131	\N
44	1	1	0	134	\N
44	53	2	0	135	\N
45	54	1	0	136	\N
45	55	2	0	137	\N
46	10	1	0	94	\N
46	11	2	0	95	\N
47	57	2	0	139	\N
48	58	1	0	142	\N
48	59	2	0	143	\N
49	60	1	0	144	\N
49	61	2	0	145	\N
50	62	1	0	146	\N
50	63	2	0	147	\N
51	60	1	0	144	\N
51	61	2	0	145	\N
52	10	1	0	94	\N
52	11	2	0	95	\N
53	64	1	0	152	\N
53	65	2	0	153	\N
54	66	3	0	158	\N
55	67	2	0	159	\N
55	68	3	0	160	\N
56	69	1	0	163	\N
56	70	2	0	164	\N
57	58	1	0	167	\N
57	59	2	0	168	\N
58	72	2	0	170	\N
59	10	1	0	173	\N
59	11	2	0	174	\N
60	10	1	0	177	\N
60	11	2	0	178	\N
61	73	1	0	179	\N
61	74	2	0	180	\N
62	76	2	0	182	\N
63	77	1	0	185	\N
63	78	2	0	186	\N
64	1	1	0	187	\N
64	53	2	0	188	\N
65	52	2	0	125	\N
66	54	1	0	136	\N
66	55	2	0	137	\N
67	10	2	0	177	\N
67	29	3	0	195	\N
68	80	3	0	197	\N
69	81	2	0	200	\N
70	53	1	0	203	\N
70	1	2	0	188	\N
71	82	1	0	206	\N
71	83	2	0	207	\N
72	84	1	0	208	\N
72	85	2	0	209	\N
73	86	1	0	212	\N
73	87	2	0	213	\N
74	89	2	0	217	\N
75	62	1	0	146	\N
75	63	2	0	147	\N
76	90	2	0	224	\N
76	91	3	0	225	\N
77	92	2	0	230	\N
77	93	3	0	231	\N
78	94	2	0	232	\N
78	95	3	0	233	\N
79	96	1	0	236	\N
79	97	2	0	237	\N
80	98	1	0	240	\N
80	99	2	0	241	\N
81	101	3	0	247	\N
82	103	2	0	251	\N
83	104	1	0	254	\N
83	105	2	0	255	\N
84	1	3	0	262	\N
84	48	4	0	263	\N
13	8	0	0	18	1000000000
21	27	1	0	47	1000000000
7	10	1	0	20	1000000000
18	23	2	0	40	1000000000
62	75	1	0	181	1000000000
74	88	1	0	216	1000000000
12	18	1	0	32	1000000000
36	14	1	0	24	1000000000
47	56	1	0	138	1000000000
81	100	2	0	246	1000000000
4	4	2	0	10	1000000000
5	6	3	0	15	1000000000
40	51	1	0	124	1000000000
58	71	1	0	169	1000000000
65	51	1	0	124	1000000000
68	79	2	0	196	1000000000
88	108	1	0	277	\N
88	109	2	0	278	\N
89	110	2	0	283	\N
89	111	3	0	284	\N
92	114	3	0	293	\N
85	84	3	0	264	\N
85	106	4	0	265	\N
86	33	2	0	270	\N
86	34	3	0	271	\N
87	94	1	0	232	\N
87	107	2	0	274	\N
91	1	2	0	262	\N
91	112	3	0	291	\N
90	10	2	0	289	\N
90	29	3	0	290	\N
93	115	1	0	296	\N
93	116	2	0	297	\N
94	117	3	0	304	\N
94	118	4	0	305	\N
95	102	1	0	308	\N
95	103	2	0	309	\N
96	120	2	0	311	\N
97	122	2	0	313	\N
98	44	1	0	314	\N
98	45	2	0	315	\N
99	123	1	0	318	\N
99	124	2	0	319	\N
100	126	4	0	327	\N
101	18	3	0	328	\N
101	127	4	0	329	\N
102	128	4	0	336	\N
103	119	3	0	337	\N
103	129	4	0	338	\N
104	64	3	0	152	\N
104	130	4	0	339	\N
105	73	1	0	179	\N
105	74	2	0	180	\N
106	2	2	0	45	\N
106	131	3	0	346	\N
107	1	2	0	262	\N
107	112	3	0	291	\N
108	10	2	0	351	\N
108	29	3	0	352	\N
109	132	2	0	353	\N
109	133	3	0	354	\N
110	41	2	0	85	\N
111	1	1	0	262	\N
111	53	2	0	357	\N
112	110	1	0	360	\N
112	134	2	0	361	\N
113	79	1	0	362	\N
113	81	2	0	363	\N
114	136	2	0	365	\N
115	138	2	0	367	\N
116	117	4	0	376	\N
116	139	5	0	377	\N
117	140	1	0	380	\N
117	141	2	0	381	\N
118	18	1	0	328	\N
118	19	2	0	382	\N
119	10	1	0	351	\N
119	11	2	0	385	\N
120	142	1	0	386	\N
120	143	2	0	387	\N
121	20	1	0	390	\N
121	144	2	0	391	\N
122	44	1	0	314	\N
122	45	2	0	315	\N
123	18	1	0	328	\N
123	19	2	0	382	\N
124	145	3	0	398	\N
124	146	4	0	399	\N
125	148	4	0	401	\N
126	149	3	0	402	\N
126	150	4	0	403	\N
127	151	3	0	410	\N
127	152	4	0	411	\N
128	153	1	0	414	\N
128	145	2	0	415	\N
129	88	2	0	420	\N
129	154	3	0	421	\N
130	16	2	0	130	\N
130	155	3	0	422	\N
131	10	2	0	427	\N
131	29	3	0	428	\N
132	2	1	0	431	\N
132	26	2	0	432	\N
133	157	2	0	436	\N
134	102	2	0	308	\N
134	158	3	0	441	\N
135	75	2	0	442	\N
135	159	3	0	443	\N
136	9	2	0	19	\N
137	2	1	0	446	\N
137	26	2	0	447	\N
138	100	1	0	448	\N
138	160	2	0	449	\N
139	44	2	0	454	\N
139	161	3	0	455	\N
140	64	2	0	456	\N
140	162	3	0	457	\N
141	16	1	0	130	\N
141	17	2	0	131	\N
142	33	1	0	462	\N
142	163	2	0	463	\N
143	18	1	0	328	\N
143	19	2	0	382	\N
144	60	1	0	466	\N
144	61	2	0	467	\N
145	164	1	0	470	\N
145	165	2	0	471	\N
146	52	2	0	125	\N
147	57	2	0	139	\N
148	10	1	0	476	\N
148	11	2	0	477	\N
149	60	2	0	482	\N
149	166	3	0	483	\N
150	167	2	0	484	\N
150	168	3	0	485	\N
151	56	2	0	486	\N
151	169	3	0	487	\N
152	2	1	0	446	\N
152	26	2	0	447	\N
153	2	1	0	492	\N
153	26	2	0	493	\N
154	104	1	0	494	\N
154	105	2	0	495	\N
155	10	1	0	498	\N
155	11	2	0	499	\N
156	16	2	0	504	\N
156	155	3	0	505	\N
157	171	5	0	515	\N
158	75	4	0	516	\N
158	172	5	0	517	\N
159	173	3	0	524	\N
159	174	4	0	525	\N
160	117	2	0	530	\N
160	175	3	0	531	\N
161	21	2	0	35	\N
161	176	3	0	532	\N
162	177	2	0	533	\N
162	178	3	0	534	\N
163	6	2	0	539	\N
163	179	3	0	540	\N
164	10	1	0	543	\N
102	40	3	0	84	1000000000
110	40	1	0	84	1000000000
136	8	1	0	18	1000000000
97	121	1	0	312	1000000000
125	147	3	0	400	1000000000
133	156	1	0	435	1000000000
147	56	1	0	138	1000000000
157	170	4	0	514	1000000000
164	11	2	0	544	\N
165	92	3	0	551	\N
165	180	4	0	552	\N
166	1	1	0	555	\N
166	53	2	0	556	\N
167	182	5	0	566	\N
168	183	4	0	567	\N
168	184	5	0	568	\N
169	56	4	0	486	\N
169	185	5	0	569	\N
170	187	2	0	573	\N
174	41	2	0	85	\N
177	33	1	0	462	\N
177	163	2	0	463	\N
180	4	1	0	598	\N
180	25	2	0	599	\N
183	6	1	0	606	\N
183	194	2	0	607	\N
186	195	1	0	621	\N
186	125	4	0	622	\N
186	188	5	0	623	\N
187	196	3	0	628	\N
190	123	1	0	634	\N
190	124	2	0	635	\N
193	198	1	0	641	\N
193	199	2	0	642	\N
196	4	1	0	649	\N
196	25	2	0	650	\N
197	202	1	0	653	\N
197	203	2	0	654	\N
200	10	1	0	584	\N
200	11	2	0	585	\N
203	211	2	0	672	\N
206	96	1	0	677	\N
206	97	2	0	678	\N
171	28	2	0	48	\N
173	125	2	0	580	\N
173	188	3	0	581	\N
176	189	1	0	586	\N
176	190	2	0	587	\N
179	92	1	0	594	\N
179	191	2	0	595	\N
182	41	2	0	85	\N
185	11	1	0	615	\N
185	10	4	0	585	\N
185	29	5	0	620	\N
189	1	1	0	632	\N
189	53	2	0	633	\N
194	201	2	0	644	\N
199	206	1	0	657	\N
199	207	2	0	658	\N
204	212	1	0	673	\N
204	213	2	0	674	\N
172	1	2	0	578	\N
172	112	3	0	579	\N
175	10	1	0	584	\N
175	11	2	0	585	\N
178	2	1	0	590	\N
178	26	2	0	591	\N
181	192	1	0	602	\N
181	193	2	0	603	\N
184	100	2	0	448	\N
184	101	3	0	612	\N
188	197	3	0	629	\N
191	115	1	0	636	\N
191	116	2	0	637	\N
192	75	0	0	638	\N
195	75	1	0	645	\N
195	76	2	0	646	\N
198	204	1	0	655	\N
198	205	2	0	656	\N
201	208	1	0	661	\N
201	209	2	0	662	\N
202	16	2	0	667	\N
202	155	3	0	668	\N
205	1	1	0	632	\N
205	53	2	0	633	\N
207	214	1	0	679	\N
207	215	2	0	680	\N
208	64	1	0	683	\N
208	65	2	0	684	\N
209	75	1	0	645	\N
209	76	2	0	646	\N
210	77	2	0	689	\N
210	216	3	0	690	\N
211	125	2	0	691	\N
211	188	3	0	692	\N
212	40	1	0	695	\N
212	41	2	0	696	\N
213	94	1	0	697	\N
213	107	2	0	698	\N
214	23	1	0	701	\N
214	217	2	0	702	\N
215	18	2	0	707	\N
215	218	3	0	708	\N
216	219	4	0	713	\N
217	220	1	0	716	\N
217	221	2	0	717	\N
218	1	1	0	720	\N
218	53	2	0	721	\N
219	222	1	0	724	\N
219	223	2	0	725	\N
220	6	1	0	726	\N
220	194	2	0	727	\N
221	202	1	0	730	\N
221	203	2	0	731	\N
222	100	1	0	732	\N
222	160	2	0	733	\N
223	58	1	0	167	\N
223	59	2	0	168	\N
224	119	1	0	337	\N
224	120	2	0	736	\N
225	224	1	0	739	\N
225	225	2	0	740	\N
226	1	1	0	743	\N
226	53	2	0	744	\N
227	100	1	0	732	\N
227	160	2	0	733	\N
228	164	2	0	748	\N
228	226	3	0	749	\N
229	214	2	0	679	\N
229	227	3	0	750	\N
230	67	2	0	755	\N
230	68	3	0	756	\N
231	40	1	0	695	\N
231	41	2	0	696	\N
232	228	1	0	759	\N
232	229	2	0	760	\N
233	228	1	0	763	\N
233	229	2	0	764	\N
234	208	1	0	765	\N
234	209	2	0	766	\N
235	79	2	0	362	\N
235	80	3	0	771	\N
236	10	2	0	584	\N
236	29	3	0	776	\N
237	10	2	0	781	\N
237	29	3	0	782	\N
238	230	2	0	783	\N
238	231	3	0	784	\N
239	222	2	0	724	\N
239	232	3	0	785	\N
240	12	1	0	22	\N
240	13	2	0	23	\N
241	233	1	0	788	\N
241	234	2	0	789	\N
242	54	1	0	792	\N
242	55	2	0	793	\N
243	52	2	0	125	\N
171	27	1	0	47	1000000000
194	200	1	0	643	1000000000
216	200	3	0	643	1000000000
203	210	1	0	671	1000000000
188	137	2	0	366	1000000000
244	10	1	0	796	\N
244	11	2	0	797	\N
245	235	1	0	798	\N
245	236	2	0	799	\N
246	237	4	0	807	\N
246	238	5	0	808	\N
247	239	4	0	809	\N
247	240	5	0	810	\N
248	2	2	0	815	\N
248	131	3	0	816	\N
249	10	2	0	796	\N
249	29	3	0	817	\N
250	1	3	0	743	\N
250	48	4	0	824	\N
251	56	0	0	486	\N
252	241	0	0	825	\N
253	44	0	0	454	\N
255	88	5	0	836	\N
255	243	6	0	837	\N
256	10	1	0	840	\N
256	11	2	0	841	\N
257	28	2	0	48	\N
258	136	2	0	365	\N
259	137	1	0	846	\N
259	138	2	0	847	\N
260	244	1	0	848	\N
260	245	2	0	849	\N
261	246	1	0	850	\N
261	247	2	0	851	\N
262	10	1	0	854	\N
262	11	2	0	855	\N
263	117	1	0	530	\N
263	248	2	0	856	\N
264	117	0	0	530	\N
265	119	3	0	337	\N
265	129	4	0	338	\N
266	88	3	0	867	\N
266	249	4	0	868	\N
267	100	3	0	869	\N
267	250	4	0	870	\N
268	251	1	0	873	\N
268	252	2	0	874	\N
269	214	1	0	875	\N
269	215	2	0	876	\N
270	1	1	0	879	\N
270	53	2	0	880	\N
271	145	1	0	883	\N
271	153	2	0	884	\N
272	253	2	0	885	\N
273	10	1	0	854	\N
273	11	2	0	855	\N
274	1	1	0	888	\N
274	53	2	0	889	\N
275	254	1	0	890	\N
275	255	2	0	891	\N
278	256	1	0	898	\N
278	257	2	0	899	\N
281	22	1	0	36	\N
281	259	2	0	903	\N
284	4	1	0	910	\N
284	25	2	0	911	\N
286	261	2	0	915	\N
287	198	1	0	916	\N
287	199	2	0	917	\N
290	264	2	0	926	\N
290	265	3	0	927	\N
293	269	2	0	935	\N
297	1	3	0	953	\N
297	48	4	0	954	\N
301	269	2	0	935	\N
304	274	6	0	981	\N
307	64	2	0	990	\N
307	277	3	0	991	\N
276	79	1	0	894	\N
276	81	2	0	895	\N
279	244	1	0	848	\N
279	245	2	0	849	\N
282	10	1	0	854	\N
282	11	2	0	855	\N
285	10	1	0	912	\N
285	11	2	0	913	\N
288	10	1	0	912	\N
288	11	2	0	913	\N
291	266	1	0	930	\N
291	267	2	0	931	\N
294	264	1	0	938	\N
294	270	2	0	939	\N
302	84	1	0	961	\N
302	85	2	0	962	\N
303	79	3	0	894	\N
303	272	4	0	969	\N
306	200	2	0	988	\N
306	276	3	0	989	\N
277	75	1	0	645	\N
277	76	2	0	646	\N
280	258	0	0	900	\N
283	16	1	0	906	\N
283	17	2	0	907	\N
289	262	1	0	920	\N
289	263	2	0	921	\N
292	40	1	0	695	\N
292	41	2	0	696	\N
295	16	2	0	906	\N
295	155	3	0	944	\N
296	173	3	0	951	\N
296	174	4	0	952	\N
298	260	3	0	955	\N
298	271	4	0	956	\N
299	102	1	0	308	\N
299	103	2	0	309	\N
300	204	1	0	655	\N
300	205	2	0	656	\N
305	10	2	0	986	\N
305	275	3	0	987	\N
308	18	1	0	994	\N
308	19	2	0	995	\N
309	262	1	0	920	\N
309	263	2	0	921	\N
310	1	1	0	953	\N
310	53	2	0	1000	\N
311	54	1	0	792	\N
311	55	2	0	793	\N
312	8	2	0	1005	\N
312	278	3	0	1006	\N
313	10	2	0	1011	\N
313	29	3	0	1012	\N
314	280	3	0	1014	\N
315	241	2	0	1015	\N
315	281	3	0	1016	\N
316	1	1	0	953	\N
316	53	2	0	1000	\N
317	40	2	0	1023	\N
317	282	3	0	1024	\N
318	1	2	0	1025	\N
318	283	3	0	1026	\N
319	75	2	0	1027	\N
319	284	3	0	1028	\N
320	10	1	0	1031	\N
320	11	2	0	1032	\N
321	286	2	0	1034	\N
322	56	2	0	486	\N
322	169	3	0	487	\N
323	230	1	0	783	\N
323	287	2	0	1041	\N
324	10	2	0	1046	\N
324	29	3	0	1047	\N
325	288	2	0	1048	\N
258	135	1	0	364	1000000000
321	285	1	0	1033	1000000000
272	242	1	0	826	1000000000
286	260	1	0	914	1000000000
304	273	5	0	980	1000000000
314	279	2	0	1013	1000000000
301	268	1	0	934	1000000000
325	289	3	0	1049	\N
326	79	2	0	1050	\N
326	80	3	0	1051	\N
327	1	2	0	1056	\N
327	112	3	0	1057	\N
328	290	1	0	1060	\N
328	291	2	0	1061	\N
329	292	1	0	1062	\N
329	293	2	0	1063	\N
330	123	1	0	1066	\N
330	124	2	0	1067	\N
331	140	1	0	1070	\N
331	141	2	0	1071	\N
332	262	1	0	1072	\N
332	263	2	0	1073	\N
333	18	1	0	1074	\N
333	19	2	0	1075	\N
334	268	1	0	1078	\N
334	269	2	0	1079	\N
335	294	1	0	1080	\N
335	295	2	0	1081	\N
336	10	2	0	1046	\N
336	29	3	0	1047	\N
337	46	2	0	1086	\N
337	296	3	0	1087	\N
338	75	2	0	1027	\N
338	159	3	0	1088	\N
339	10	1	0	1046	\N
339	11	2	0	1091	\N
340	75	1	0	1092	\N
340	76	2	0	1093	\N
341	2	2	0	815	\N
341	131	3	0	816	\N
342	16	2	0	1098	\N
342	155	3	0	1099	\N
343	119	1	0	1102	\N
343	120	2	0	1103	\N
344	10	3	0	1110	\N
344	297	4	0	1111	\N
345	2	3	0	815	\N
345	298	4	0	1112	\N
346	233	3	0	1113	\N
346	299	4	0	1114	\N
347	1	1	0	1117	\N
347	53	2	0	1118	\N
348	10	1	0	1110	\N
348	11	2	0	1121	\N
349	300	3	0	1128	\N
349	301	4	0	1129	\N
350	2	1	0	1132	\N
350	26	2	0	1133	\N
351	151	1	0	1134	\N
351	302	2	0	1135	\N
352	303	0	0	1136	\N
353	303	1	0	1136	\N
353	304	2	0	1137	\N
354	1	3	0	1144	\N
354	48	4	0	1145	\N
355	233	3	0	1113	\N
355	305	4	0	1146	\N
356	14	3	0	1153	\N
356	306	4	0	1154	\N
357	164	3	0	748	\N
357	307	4	0	1155	\N
358	51	4	0	1163	\N
358	308	5	0	1164	\N
359	10	2	0	1169	\N
359	29	3	0	1170	\N
360	164	2	0	1171	\N
360	226	3	0	1172	\N
361	224	1	0	1175	\N
361	225	2	0	1176	\N
362	10	2	0	1181	\N
362	29	3	0	1182	\N
363	258	1	0	900	\N
363	309	2	0	1183	\N
364	1	1	0	1144	\N
364	53	2	0	1186	\N
365	6	1	0	1187	\N
365	194	2	0	1188	\N
366	10	2	0	1193	\N
366	29	3	0	1194	\N
367	183	2	0	567	\N
367	310	3	0	1195	\N
368	189	2	0	1196	\N
368	311	3	0	1197	\N
369	167	2	0	1202	\N
369	168	3	0	1203	\N
370	79	2	0	1050	\N
370	80	3	0	1051	\N
371	220	2	0	1208	\N
371	312	3	0	1209	\N
372	10	1	0	1193	\N
372	11	2	0	1212	\N
373	313	1	0	1215	\N
373	314	2	0	1216	\N
374	2	1	0	1132	\N
374	26	2	0	1133	\N
375	12	1	0	22	\N
375	13	2	0	23	\N
376	1	1	0	1144	\N
376	53	2	0	1186	\N
377	18	1	0	1074	\N
377	19	2	0	1075	\N
380	317	2	0	1233	\N
383	14	1	0	1153	\N
383	15	2	0	1242	\N
386	1	1	0	1259	\N
386	53	2	0	1260	\N
387	237	2	0	807	\N
387	319	3	0	1264	\N
390	322	1	0	1271	\N
390	323	2	0	1272	\N
391	1	1	0	1275	\N
391	53	2	0	1276	\N
398	38	2	0	1294	\N
398	39	3	0	1295	\N
399	14	3	0	1153	\N
399	306	4	0	1154	\N
402	16	2	0	1310	\N
402	155	3	0	1311	\N
403	145	2	0	1316	\N
403	331	3	0	1317	\N
404	1	2	0	1275	\N
404	112	3	0	1321	\N
407	241	1	0	1015	\N
407	333	2	0	1328	\N
408	1	1	0	1275	\N
408	53	2	0	1276	\N
411	10	1	0	1322	\N
411	11	2	0	1339	\N
414	320	1	0	1267	\N
414	334	2	0	1348	\N
415	10	2	0	1353	\N
415	29	3	0	1354	\N
420	336	3	0	1376	\N
420	337	4	0	1377	\N
426	264	1	0	1388	\N
426	270	2	0	1389	\N
378	290	1	0	1219	\N
378	291	2	0	1220	\N
381	16	1	0	1236	\N
381	17	2	0	1237	\N
384	266	1	0	1243	\N
384	267	2	0	1244	\N
385	269	1	0	1247	\N
385	268	6	0	1079	\N
385	318	7	0	1256	\N
388	10	2	0	1265	\N
388	29	3	0	1266	\N
392	325	2	0	1278	\N
395	18	1	0	1285	\N
395	19	2	0	1286	\N
396	40	2	0	1023	\N
396	66	3	0	1291	\N
409	40	1	0	1333	\N
409	41	2	0	1334	\N
413	60	2	0	482	\N
413	166	3	0	483	\N
416	256	2	0	898	\N
416	335	3	0	1355	\N
419	125	3	0	1369	\N
419	126	4	0	692	\N
423	84	1	0	961	\N
423	85	2	0	962	\N
424	260	1	0	955	\N
424	261	2	0	1385	\N
379	2	4	0	1132	\N
379	315	5	0	1229	\N
382	1	1	0	1240	\N
382	53	2	0	1241	\N
389	320	2	0	1267	\N
389	321	3	0	1268	\N
393	18	1	0	1074	\N
393	19	2	0	1075	\N
394	326	1	0	1283	\N
394	327	2	0	1284	\N
397	49	2	0	1292	\N
397	328	3	0	1293	\N
400	51	3	0	1302	\N
400	329	4	0	1303	\N
401	214	3	0	1304	\N
401	330	4	0	1305	\N
405	10	2	0	1322	\N
405	29	3	0	1323	\N
406	316	2	0	1324	\N
406	332	3	0	1325	\N
410	212	1	0	1335	\N
410	213	2	0	1336	\N
412	2	1	0	1340	\N
412	26	2	0	1341	\N
417	1	2	0	1360	\N
417	112	3	0	1361	\N
418	40	3	0	1333	\N
418	128	4	0	1368	\N
421	338	3	0	1378	\N
421	339	4	0	1379	\N
422	35	1	0	69	\N
422	340	2	0	1382	\N
425	117	1	0	1386	\N
425	248	2	0	1387	\N
427	2	1	0	1340	\N
427	26	2	0	1341	\N
428	33	1	0	462	\N
428	163	2	0	463	\N
429	58	1	0	1394	\N
429	59	2	0	1395	\N
430	341	1	0	1398	\N
430	342	2	0	1399	\N
431	58	1	0	1400	\N
431	59	2	0	1401	\N
432	18	1	0	1285	\N
432	19	2	0	1286	\N
433	82	2	0	206	\N
433	343	3	0	1406	\N
434	18	2	0	1285	\N
434	218	3	0	1407	\N
435	90	1	0	1410	\N
435	344	2	0	1411	\N
436	75	1	0	1092	\N
436	76	2	0	1093	\N
437	286	2	0	1034	\N
438	266	1	0	1243	\N
438	267	2	0	1244	\N
439	345	1	0	1414	\N
439	346	2	0	1415	\N
440	336	3	0	1422	\N
440	337	4	0	1423	\N
441	10	3	0	1353	\N
441	347	4	0	1424	\N
442	173	3	0	1425	\N
442	174	4	0	1426	\N
443	348	3	0	1427	\N
443	349	4	0	1428	\N
444	23	3	0	1429	\N
444	350	4	0	1430	\N
445	222	3	0	724	\N
445	351	4	0	1431	\N
446	56	2	0	1436	\N
446	169	3	0	1437	\N
447	92	1	0	1440	\N
447	191	2	0	1441	\N
448	292	1	0	1062	\N
448	293	2	0	1063	\N
449	40	1	0	1333	\N
449	41	2	0	1334	\N
450	11	1	0	1323	\N
450	10	3	0	1450	\N
450	11	4	0	1354	\N
451	10	1	0	1453	\N
451	11	2	0	1454	\N
452	123	1	0	1455	\N
452	124	2	0	1456	\N
453	326	1	0	1457	\N
453	327	2	0	1458	\N
454	60	2	0	1463	\N
454	166	3	0	1464	\N
455	256	2	0	1465	\N
455	335	3	0	1466	\N
456	1	1	0	1469	\N
456	53	2	0	1470	\N
457	140	1	0	1471	\N
457	141	2	0	1472	\N
458	136	2	0	365	\N
459	137	1	0	1473	\N
459	138	2	0	1474	\N
460	239	1	0	1477	\N
460	352	2	0	1478	\N
461	94	1	0	1479	\N
461	107	2	0	1480	\N
462	1	1	0	1469	\N
462	53	2	0	1470	\N
463	123	1	0	1455	\N
463	124	2	0	1456	\N
464	354	2	0	1486	\N
465	300	1	0	1489	\N
465	355	2	0	1490	\N
466	336	1	0	1422	\N
466	356	2	0	1493	\N
467	2	1	0	1494	\N
467	26	2	0	1495	\N
468	88	1	0	1496	\N
468	89	2	0	1497	\N
469	12	4	0	22	\N
469	357	5	0	1506	\N
470	90	4	0	1410	\N
470	358	5	0	1507	\N
471	20	1	0	390	\N
471	144	2	0	391	\N
472	1	1	0	1510	\N
472	53	2	0	1511	\N
473	1	3	0	1518	\N
473	48	4	0	1519	\N
474	10	3	0	1453	\N
474	347	4	0	1520	\N
475	79	3	0	1521	\N
475	272	4	0	1522	\N
476	16	3	0	1523	\N
476	359	4	0	1524	\N
477	75	2	0	1529	\N
477	284	3	0	1530	\N
478	360	2	0	1535	\N
478	361	3	0	1536	\N
479	363	3	0	1538	\N
480	44	1	0	454	\N
480	45	2	0	1541	\N
481	42	1	0	1544	\N
481	43	2	0	1545	\N
482	8	1	0	1548	\N
482	9	2	0	1549	\N
483	79	1	0	1550	\N
464	353	1	0	1485	1000000000
483	81	2	0	1551	\N
484	10	1	0	1453	\N
484	11	2	0	1454	\N
485	212	1	0	1554	\N
485	213	2	0	1555	\N
486	136	2	0	365	\N
487	137	1	0	1473	\N
487	138	2	0	1474	\N
488	253	2	0	885	\N
491	365	1	0	1568	\N
491	366	2	0	1569	\N
494	10	1	0	1453	\N
494	11	2	0	1454	\N
489	40	3	0	1562	\N
489	128	4	0	1563	\N
492	367	1	0	1570	\N
492	368	2	0	1571	\N
493	145	1	0	1574	\N
493	153	2	0	1575	\N
490	290	3	0	1564	\N
490	364	4	0	1565	\N
495	125	3	0	1582	\N
495	126	4	0	1583	\N
496	27	1	0	1586	\N
496	28	2	0	1587	\N
497	77	2	0	1592	\N
497	216	3	0	1593	\N
498	20	2	0	390	\N
498	369	3	0	1598	\N
499	222	1	0	724	\N
499	223	2	0	725	\N
500	119	1	0	1603	\N
500	120	2	0	1604	\N
501	230	1	0	1605	\N
501	287	2	0	1606	\N
502	370	2	0	1611	\N
502	371	3	0	1612	\N
503	40	3	0	1562	\N
503	372	4	0	1619	\N
504	373	1	0	1622	\N
504	374	2	0	1623	\N
505	14	3	0	1153	\N
505	306	4	0	1154	\N
506	94	3	0	1479	\N
506	375	4	0	1630	\N
507	18	3	0	1285	\N
507	127	4	0	1631	\N
508	92	1	0	1634	\N
508	191	2	0	1635	\N
509	294	1	0	1636	\N
509	295	2	0	1637	\N
510	2	1	0	1640	\N
510	26	2	0	1641	\N
511	376	1	0	1642	\N
511	377	2	0	1643	\N
512	379	2	0	1645	\N
513	16	4	0	1523	\N
513	380	5	0	1654	\N
514	14	1	0	1153	\N
514	15	2	0	1242	\N
515	79	1	0	1550	\N
515	81	2	0	1551	\N
516	14	0	0	1657	\N
517	381	3	0	1664	\N
517	382	4	0	1665	\N
518	14	2	0	1670	\N
518	383	3	0	1671	\N
519	123	2	0	1455	\N
519	384	3	0	1672	\N
520	40	5	0	1683	\N
520	385	6	0	1684	\N
521	367	5	0	1570	\N
521	386	6	0	1685	\N
522	132	2	0	1690	\N
522	133	3	0	1691	\N
523	224	3	0	1698	\N
523	387	4	0	1699	\N
524	10	1	0	1453	\N
524	11	2	0	1454	\N
525	1	1	0	1518	\N
525	53	2	0	1704	\N
526	40	2	0	1709	\N
526	282	3	0	1710	\N
527	16	2	0	1711	\N
527	388	3	0	1712	\N
528	211	2	0	672	\N
529	186	1	0	1717	\N
529	187	2	0	1718	\N
530	390	2	0	1722	\N
531	75	1	0	1725	\N
531	76	2	0	1726	\N
532	391	1	0	1729	\N
532	392	2	0	1730	\N
533	1	1	0	1733	\N
533	53	2	0	1734	\N
534	92	1	0	1634	\N
534	191	2	0	1635	\N
535	151	1	0	1737	\N
535	302	2	0	1738	\N
536	16	1	0	1739	\N
536	17	2	0	1740	\N
537	10	2	0	1744	\N
537	275	3	0	1745	\N
538	326	2	0	1746	\N
538	393	3	0	1747	\N
539	67	2	0	1748	\N
539	394	3	0	1749	\N
540	395	2	0	1752	\N
541	10	1	0	1755	\N
541	11	2	0	1756	\N
542	2	1	0	1640	\N
542	26	2	0	1641	\N
543	173	1	0	1425	\N
543	396	2	0	1757	\N
544	4	1	0	910	\N
544	25	2	0	911	\N
545	94	1	0	1479	\N
545	107	2	0	1480	\N
546	71	3	0	1766	\N
546	397	4	0	1767	\N
547	10	3	0	1768	\N
547	347	4	0	1769	\N
548	10	1	0	1772	\N
548	11	2	0	1773	\N
549	10	1	0	1776	\N
549	11	2	0	1777	\N
550	398	2	0	1778	\N
551	365	1	0	1781	\N
551	366	2	0	1782	\N
552	336	1	0	1422	\N
552	356	2	0	1493	\N
553	100	1	0	1785	\N
553	160	2	0	1786	\N
554	51	1	0	1302	\N
554	52	2	0	1787	\N
555	75	1	0	1788	\N
555	76	2	0	1789	\N
556	38	1	0	1294	\N
556	399	2	0	1792	\N
557	288	1	0	1793	\N
557	400	2	0	1794	\N
558	10	1	0	1776	\N
558	11	2	0	1777	\N
559	40	1	0	1709	\N
559	41	2	0	1799	\N
560	40	2	0	1804	\N
560	66	3	0	1805	\N
561	71	2	0	1766	\N
561	401	3	0	1806	\N
562	110	2	0	1807	\N
562	111	3	0	1808	\N
530	389	1	0	1721	1000000000
488	242	1	0	826	1000000000
528	210	1	0	671	1000000000
550	170	1	0	514	1000000000
563	49	1	0	1292	\N
563	50	2	0	1811	\N
564	40	1	0	1814	\N
564	41	2	0	1815	\N
565	228	1	0	1816	\N
565	229	2	0	1817	\N
566	10	1	0	1820	\N
566	11	2	0	1821	\N
567	241	1	0	1822	\N
567	333	2	0	1823	\N
568	40	1	0	1814	\N
568	41	2	0	1815	\N
569	262	1	0	1072	\N
569	263	2	0	1073	\N
570	18	1	0	1828	\N
570	19	2	0	1829	\N
571	402	1	0	1832	\N
571	403	2	0	1833	\N
572	10	1	0	1836	\N
572	11	2	0	1837	\N
573	51	1	0	1302	\N
573	52	2	0	1787	\N
576	140	3	0	1848	\N
576	404	4	0	1849	\N
579	1	3	0	1862	\N
579	48	4	0	1863	\N
584	16	1	0	1840	\N
584	17	2	0	1841	\N
587	294	1	0	1877	\N
587	295	2	0	1878	\N
592	186	1	0	1897	\N
592	187	2	0	1898	\N
594	96	1	0	1901	\N
594	97	2	0	1902	\N
597	38	1	0	1914	\N
597	399	2	0	1915	\N
600	1	1	0	1924	\N
600	53	2	0	1925	\N
603	292	1	0	1931	\N
603	293	2	0	1932	\N
606	10	1	0	1938	\N
606	11	2	0	1939	\N
610	49	1	0	1944	\N
610	50	2	0	1945	\N
612	273	1	0	1948	\N
612	410	2	0	1949	\N
613	79	1	0	1550	\N
613	81	2	0	1551	\N
615	1	1	0	1924	\N
615	53	2	0	1925	\N
616	413	1	0	1954	\N
616	414	2	0	1955	\N
618	20	1	0	1960	\N
618	144	2	0	1961	\N
619	338	1	0	1378	\N
619	409	2	0	1933	\N
622	338	2	0	1964	\N
622	415	3	0	1969	\N
628	367	1	0	1570	\N
628	368	2	0	1571	\N
631	391	1	0	1991	\N
631	392	2	0	1992	\N
634	1	1	0	1978	\N
634	53	2	0	1993	\N
639	33	1	0	462	\N
639	163	2	0	463	\N
642	10	1	0	2002	\N
642	11	2	0	2003	\N
645	260	2	0	2027	\N
645	419	3	0	2028	\N
648	228	1	0	2038	\N
648	229	2	0	2039	\N
652	112	2	0	2050	\N
652	1	5	0	2051	\N
652	112	6	0	2052	\N
574	125	1	0	1838	\N
574	195	2	0	1839	\N
577	266	3	0	1850	\N
577	405	4	0	1851	\N
580	156	3	0	1864	\N
580	407	4	0	1865	\N
583	173	1	0	1425	\N
583	396	2	0	1757	\N
585	320	1	0	1873	\N
585	334	2	0	1874	\N
588	10	1	0	1836	\N
588	11	2	0	1837	\N
589	14	1	0	1670	\N
589	15	2	0	1883	\N
598	268	1	0	1916	\N
598	269	2	0	1917	\N
601	16	1	0	1926	\N
601	17	2	0	1927	\N
607	35	1	0	69	\N
607	340	2	0	1382	\N
611	1	1	0	1924	\N
611	53	2	0	1925	\N
614	411	1	0	1952	\N
614	412	2	0	1953	\N
617	12	1	0	1958	\N
617	13	2	0	1959	\N
620	338	0	0	1964	\N
623	10	1	0	1938	\N
623	11	2	0	1939	\N
625	1	2	0	1978	\N
625	112	3	0	1979	\N
627	92	2	0	1634	\N
627	93	3	0	1986	\N
629	2	1	0	1640	\N
629	26	2	0	1641	\N
630	206	1	0	657	\N
630	207	2	0	658	\N
632	1	1	0	1978	\N
632	53	2	0	1993	\N
633	10	1	0	1996	\N
633	11	2	0	1997	\N
635	173	1	0	2000	\N
635	396	2	0	2001	\N
637	417	2	0	2007	\N
640	391	1	0	2014	\N
640	392	2	0	2015	\N
643	38	1	0	2018	\N
643	399	2	0	2019	\N
647	10	2	0	2002	\N
647	29	3	0	2035	\N
650	75	1	0	1788	\N
650	76	2	0	1789	\N
651	154	2	0	2043	\N
651	88	5	0	2048	\N
651	154	6	0	2049	\N
575	16	1	0	1840	\N
575	17	2	0	1841	\N
578	406	2	0	1855	\N
578	391	3	0	1856	\N
581	96	1	0	677	\N
581	97	2	0	678	\N
582	110	1	0	1807	\N
582	134	2	0	1870	\N
586	286	2	0	1034	\N
590	10	1	0	1886	\N
590	11	2	0	1887	\N
591	16	3	0	1840	\N
591	408	4	0	1894	\N
593	1	1	0	1899	\N
593	53	2	0	1900	\N
595	10	1	0	1905	\N
595	11	2	0	1906	\N
596	1	2	0	1899	\N
596	112	3	0	1911	\N
599	173	1	0	1920	\N
599	396	2	0	1921	\N
602	189	1	0	1196	\N
602	190	2	0	1928	\N
604	338	1	0	1378	\N
604	409	2	0	1933	\N
605	214	1	0	1934	\N
605	215	2	0	1935	\N
608	56	1	0	1940	\N
608	57	2	0	1941	\N
609	1	1	0	1924	\N
609	53	2	0	1925	\N
621	338	0	0	1378	\N
624	391	2	0	1976	\N
624	406	3	0	1977	\N
626	16	2	0	1980	\N
626	155	3	0	1981	\N
636	10	1	0	2002	\N
636	11	2	0	2003	\N
638	1	1	0	2010	\N
638	53	2	0	2011	\N
641	2	1	0	1640	\N
641	26	2	0	1641	\N
644	30	1	0	54	\N
644	418	2	0	2022	\N
646	1	2	0	2029	\N
646	112	3	0	2030	\N
649	204	1	0	655	\N
649	205	2	0	656	\N
653	101	2	0	2053	\N
653	100	5	0	2054	\N
653	101	6	0	2055	\N
654	179	2	0	2056	\N
654	6	5	0	2057	\N
654	179	6	0	2058	\N
655	16	2	0	1980	\N
655	155	3	0	1981	\N
656	362	2	0	2063	\N
656	420	3	0	2064	\N
657	75	2	0	1788	\N
657	159	3	0	2065	\N
658	258	1	0	900	\N
658	309	2	0	1183	\N
659	6	1	0	2068	\N
659	194	2	0	2069	\N
660	292	4	0	2078	\N
660	421	5	0	2079	\N
661	1	4	0	2080	\N
661	422	5	0	2052	\N
662	119	4	0	1603	\N
662	423	5	0	2081	\N
663	10	1	0	2084	\N
663	11	2	0	2085	\N
664	424	1	0	2086	\N
664	425	2	0	2087	\N
665	367	1	0	1570	\N
665	368	2	0	1571	\N
666	94	1	0	2090	\N
666	107	2	0	2091	\N
667	202	1	0	2094	\N
667	203	2	0	2095	\N
668	1	1	0	2080	\N
668	53	2	0	2096	\N
669	10	2	0	2084	\N
669	29	3	0	2101	\N
670	10	6	0	2114	\N
670	426	7	0	2115	\N
671	40	1	0	1814	\N
671	41	2	0	1815	\N
672	2	1	0	1640	\N
672	26	2	0	1641	\N
673	1	1	0	2080	\N
673	53	2	0	2096	\N
674	411	1	0	1952	\N
674	412	2	0	1953	\N
675	73	1	0	2122	\N
675	74	2	0	2123	\N
676	35	5	0	2134	\N
676	427	6	0	2135	\N
677	10	1	0	2138	\N
677	11	2	0	2139	\N
678	1	1	0	2140	\N
678	53	2	0	2141	\N
679	233	2	0	2146	\N
679	428	3	0	2147	\N
680	75	2	0	1788	\N
680	429	3	0	2148	\N
681	322	2	0	2152	\N
681	430	3	0	2153	\N
682	56	1	0	1940	\N
682	57	2	0	1941	\N
683	60	1	0	2158	\N
683	61	2	0	2159	\N
684	10	1	0	2160	\N
684	11	2	0	2161	\N
685	431	1	0	2164	\N
685	432	2	0	2165	\N
686	73	1	0	2166	\N
686	74	2	0	2167	\N
687	12	2	0	1958	\N
687	433	3	0	2172	\N
688	84	2	0	2173	\N
688	434	3	0	2174	\N
689	10	1	0	2177	\N
689	11	2	0	2178	\N
690	204	1	0	2179	\N
690	205	2	0	2180	\N
691	142	1	0	386	\N
691	143	2	0	387	\N
692	436	2	0	2182	\N
693	75	1	0	2185	\N
693	76	2	0	2186	\N
694	437	2	0	2189	\N
695	235	1	0	2190	\N
695	236	2	0	2191	\N
696	244	1	0	2192	\N
696	245	2	0	2193	\N
697	391	2	0	2198	\N
697	406	3	0	2199	\N
698	1	2	0	2140	\N
698	112	3	0	2200	\N
699	244	2	0	2192	\N
699	438	3	0	2205	\N
700	391	1	0	2198	\N
700	392	2	0	2208	\N
701	20	1	0	2209	\N
701	144	2	0	2210	\N
702	233	3	0	2146	\N
702	305	4	0	2217	\N
703	18	3	0	2218	\N
703	127	4	0	2219	\N
704	10	2	0	2177	\N
704	29	3	0	2224	\N
705	16	1	0	2227	\N
705	17	2	0	2228	\N
706	338	1	0	2231	\N
706	409	2	0	2232	\N
711	2	1	0	2249	\N
711	26	2	0	2250	\N
714	440	1	0	2251	\N
714	443	2	0	2254	\N
719	1	2	0	2255	\N
719	444	3	0	2275	\N
722	220	1	0	2285	\N
722	221	2	0	2286	\N
725	100	4	0	1785	\N
725	448	5	0	2055	\N
727	16	1	0	2276	\N
727	17	2	0	2301	\N
728	452	3	0	2307	\N
731	110	1	0	2318	\N
731	134	2	0	2319	\N
734	132	1	0	2325	\N
734	455	2	0	2326	\N
738	316	1	0	2341	\N
738	317	2	0	2342	\N
740	23	1	0	2343	\N
740	217	2	0	2344	\N
742	18	1	0	2352	\N
742	19	2	0	2353	\N
707	42	3	0	2239	\N
707	439	4	0	2240	\N
710	90	1	0	1410	\N
710	344	2	0	1411	\N
713	440	3	0	2251	\N
713	442	4	0	2253	\N
716	1	0	0	2255	\N
717	10	3	0	2262	\N
717	347	4	0	2263	\N
720	16	2	0	2276	\N
720	445	3	0	2277	\N
723	75	1	0	2287	\N
723	76	2	0	2288	\N
724	33	4	0	462	\N
724	447	5	0	2296	\N
730	79	1	0	2314	\N
730	81	2	0	2315	\N
732	326	1	0	1746	\N
732	327	2	0	2320	\N
733	453	1	0	2323	\N
733	454	2	0	2324	\N
739	411	1	0	1952	\N
739	412	2	0	1953	\N
741	2	2	0	2249	\N
741	131	3	0	2349	\N
708	198	1	0	916	\N
708	199	2	0	917	\N
709	82	1	0	2245	\N
709	83	2	0	2246	\N
712	440	5	0	2251	\N
712	441	6	0	2252	\N
715	40	0	0	1814	\N
718	10	3	0	2270	\N
718	347	4	0	2271	\N
721	292	3	0	2078	\N
721	446	4	0	2282	\N
726	449	1	0	2299	\N
726	450	2	0	2300	\N
729	10	1	0	2310	\N
729	11	2	0	2311	\N
735	300	1	0	2329	\N
735	355	2	0	2330	\N
736	132	2	0	2335	\N
736	133	3	0	2336	\N
737	290	1	0	2339	\N
737	291	2	0	2340	\N
743	316	2	0	2341	\N
743	332	3	0	2358	\N
744	202	1	0	2361	\N
744	203	2	0	2362	\N
745	10	1	0	2363	\N
745	11	2	0	2364	\N
746	262	1	0	2365	\N
746	263	2	0	2366	\N
747	23	1	0	2369	\N
747	217	2	0	2370	\N
748	456	1	0	2371	\N
748	457	2	0	2372	\N
749	1	1	0	2375	\N
749	53	2	0	2376	\N
750	290	1	0	2339	\N
750	291	2	0	2340	\N
751	264	1	0	1388	\N
751	270	2	0	1389	\N
752	88	1	0	1496	\N
752	89	2	0	1497	\N
753	62	1	0	2379	\N
753	63	2	0	2380	\N
754	260	1	0	2027	\N
754	261	2	0	2383	\N
755	64	1	0	990	\N
755	65	2	0	2384	\N
756	210	2	0	2389	\N
756	458	3	0	2390	\N
757	100	2	0	1785	\N
757	101	3	0	2054	\N
758	459	1	0	2393	\N
758	460	2	0	2394	\N
759	125	1	0	1838	\N
759	195	2	0	1839	\N
760	79	1	0	2395	\N
760	81	2	0	2396	\N
761	241	1	0	1822	\N
761	333	2	0	1823	\N
762	461	6	0	2397	\N
762	462	7	0	2398	\N
763	461	1	0	2397	\N
763	463	2	0	2399	\N
764	210	1	0	2402	\N
764	211	2	0	2403	\N
765	73	3	0	2166	\N
765	464	4	0	2410	\N
766	10	3	0	2363	\N
766	465	4	0	2411	\N
767	18	3	0	2412	\N
767	466	4	0	2413	\N
768	316	1	0	2416	\N
768	317	2	0	2417	\N
769	1	1	0	2418	\N
769	53	2	0	2419	\N
770	360	4	0	2427	\N
770	467	5	0	2428	\N
771	56	4	0	2429	\N
771	185	5	0	2430	\N
772	424	3	0	2436	\N
772	468	4	0	2437	\N
773	233	1	0	2146	\N
773	234	2	0	2440	\N
774	469	2	0	2444	\N
774	470	3	0	2445	\N
775	2	2	0	2446	\N
775	471	3	0	2447	\N
776	79	2	0	2448	\N
776	472	3	0	2449	\N
777	326	1	0	1746	\N
777	327	2	0	2320	\N
778	473	2	0	2452	\N
779	251	1	0	873	\N
779	252	2	0	874	\N
780	367	3	0	2459	\N
780	474	4	0	2460	\N
781	16	3	0	2276	\N
781	359	4	0	2461	\N
782	56	3	0	2429	\N
782	475	4	0	2462	\N
783	75	0	0	2287	\N
784	54	3	0	2469	\N
784	476	4	0	2470	\N
785	1	3	0	2471	\N
785	48	4	0	2472	\N
786	56	3	0	2473	\N
786	475	4	0	2474	\N
787	220	3	0	2475	\N
787	477	4	0	2476	\N
788	170	1	0	2479	\N
788	398	2	0	2480	\N
789	67	1	0	1748	\N
789	478	2	0	2481	\N
790	391	1	0	2484	\N
790	392	2	0	2485	\N
791	391	1	0	2488	\N
791	392	2	0	2489	\N
792	260	1	0	2027	\N
792	261	2	0	2383	\N
793	360	1	0	2492	\N
793	479	2	0	2493	\N
794	173	2	0	2000	\N
794	480	3	0	2498	\N
795	202	1	0	2501	\N
795	203	2	0	2502	\N
796	10	1	0	2503	\N
796	11	2	0	2504	\N
797	40	1	0	2507	\N
797	41	2	0	2508	\N
798	300	1	0	2509	\N
798	355	2	0	2510	\N
799	16	1	0	2276	\N
799	17	2	0	2301	\N
800	151	1	0	1737	\N
800	302	2	0	1738	\N
801	16	1	0	2513	\N
801	17	2	0	2514	\N
802	123	1	0	2515	\N
802	124	2	0	2516	\N
803	90	2	0	1410	\N
803	91	3	0	2521	\N
804	481	3	0	2522	\N
805	49	1	0	2525	\N
805	50	2	0	2526	\N
806	338	3	0	2533	\N
806	339	4	0	2534	\N
807	56	3	0	2535	\N
807	475	4	0	2536	\N
808	1	1	0	2471	\N
808	53	2	0	2539	\N
809	6	2	0	2068	\N
809	179	3	0	2544	\N
810	75	2	0	2545	\N
810	159	3	0	2546	\N
811	16	1	0	2513	\N
811	17	2	0	2514	\N
812	345	1	0	1414	\N
812	346	2	0	1415	\N
815	125	1	0	1838	\N
815	195	2	0	1839	\N
821	206	1	0	2570	\N
821	207	2	0	2571	\N
826	110	2	0	2581	\N
826	111	3	0	2582	\N
827	10	1	0	2576	\N
827	11	2	0	2585	\N
830	336	1	0	2593	\N
830	356	2	0	2594	\N
833	67	1	0	2597	\N
833	478	2	0	2598	\N
836	18	1	0	2412	\N
836	19	2	0	2603	\N
837	54	2	0	2469	\N
837	485	3	0	2608	\N
838	324	2	0	2613	\N
838	486	3	0	2614	\N
840	79	2	0	2448	\N
840	80	3	0	2621	\N
813	49	1	0	2551	\N
813	50	2	0	2552	\N
817	49	2	0	2551	\N
817	328	3	0	2561	\N
820	92	1	0	2568	\N
820	191	2	0	2569	\N
823	10	2	0	2576	\N
823	29	3	0	2577	\N
828	1	1	0	2578	\N
828	53	2	0	2586	\N
831	56	1	0	2535	\N
831	57	2	0	2557	\N
839	338	2	0	2619	\N
839	415	3	0	2620	\N
842	79	1	0	2448	\N
842	81	2	0	2626	\N
814	242	1	0	2553	\N
814	253	2	0	2554	\N
816	56	1	0	2535	\N
816	57	2	0	2557	\N
818	362	1	0	2063	\N
818	395	2	0	2564	\N
819	75	1	0	2545	\N
819	76	2	0	2565	\N
822	62	1	0	2379	\N
822	63	2	0	2380	\N
824	1	2	0	2578	\N
824	112	3	0	2579	\N
825	96	2	0	1901	\N
825	482	3	0	2580	\N
829	10	1	0	2589	\N
829	11	2	0	2590	\N
832	16	1	0	2513	\N
832	17	2	0	2514	\N
834	484	2	0	2600	\N
835	320	1	0	1873	\N
835	334	2	0	1874	\N
841	10	1	0	2624	\N
841	11	2	0	2625	\N
843	173	1	0	2629	\N
843	396	2	0	2630	\N
844	435	1	0	2631	\N
844	436	2	0	2632	\N
845	316	1	0	2416	\N
845	317	2	0	2417	\N
846	1	1	0	2578	\N
846	53	2	0	2586	\N
847	140	2	0	1848	\N
847	487	3	0	2641	\N
848	10	1	0	2624	\N
848	11	2	0	2625	\N
849	20	1	0	2209	\N
849	144	2	0	2210	\N
850	292	1	0	2648	\N
850	293	2	0	2649	\N
851	488	1	0	2652	\N
851	489	2	0	2653	\N
852	69	0	0	2654	\N
853	64	4	0	2663	\N
853	490	5	0	2664	\N
854	208	4	0	765	\N
854	491	5	0	2665	\N
855	228	3	0	2038	\N
855	492	4	0	2672	\N
856	38	3	0	2673	\N
856	493	4	0	2674	\N
857	136	2	0	365	\N
858	137	1	0	1473	\N
858	138	2	0	1474	\N
859	67	1	0	2677	\N
859	478	2	0	2678	\N
860	316	4	0	2687	\N
860	494	5	0	2688	\N
861	189	4	0	1196	\N
861	495	5	0	2689	\N
862	100	1	0	1785	\N
862	160	2	0	1786	\N
863	2	1	0	2446	\N
863	26	2	0	2692	\N
864	208	1	0	765	\N
864	209	2	0	766	\N
865	402	2	0	2697	\N
865	496	3	0	2698	\N
866	451	2	0	2699	\N
866	497	3	0	2700	\N
867	14	1	0	2703	\N
867	15	2	0	2704	\N
868	177	1	0	533	\N
868	498	2	0	2707	\N
869	149	1	0	2710	\N
869	499	2	0	2711	\N
870	16	1	0	2712	\N
870	17	2	0	2713	\N
871	10	1	0	2716	\N
871	11	2	0	2717	\N
872	58	1	0	1400	\N
872	59	2	0	1401	\N
873	290	1	0	2339	\N
873	291	2	0	2340	\N
874	18	2	0	2722	\N
874	218	3	0	2723	\N
875	1	2	0	2728	\N
875	112	3	0	2729	\N
876	69	2	0	2734	\N
876	500	3	0	2735	\N
877	54	3	0	2742	\N
877	476	4	0	2743	\N
878	1	1	0	2746	\N
878	53	2	0	2747	\N
879	10	2	0	2716	\N
879	29	3	0	2752	\N
880	108	2	0	2753	\N
880	501	3	0	2754	\N
881	113	1	0	2757	\N
881	437	2	0	2758	\N
882	170	1	0	2759	\N
882	398	2	0	2760	\N
883	16	1	0	2712	\N
883	17	2	0	2713	\N
884	260	1	0	2765	\N
884	261	2	0	2766	\N
885	88	2	0	2770	\N
885	154	3	0	2771	\N
886	16	2	0	2772	\N
886	155	3	0	2773	\N
887	292	2	0	2774	\N
887	502	3	0	2775	\N
888	30	2	0	2776	\N
888	31	3	0	2777	\N
889	316	1	0	2687	\N
889	317	2	0	2780	\N
890	391	3	0	2488	\N
890	503	4	0	2787	\N
891	290	3	0	2788	\N
891	504	4	0	2789	\N
892	260	3	0	2790	\N
892	505	4	0	2791	\N
893	228	1	0	2794	\N
893	229	2	0	2795	\N
894	1	1	0	2796	\N
894	53	2	0	2797	\N
895	170	3	0	2804	\N
895	506	4	0	2805	\N
896	167	2	0	1202	\N
896	168	3	0	1203	\N
897	10	1	0	2812	\N
897	11	2	0	2813	\N
898	10	1	0	2816	\N
898	11	2	0	2817	\N
899	16	1	0	2772	\N
899	17	2	0	2818	\N
900	10	1	0	2821	\N
900	11	2	0	2822	\N
901	16	1	0	2772	\N
901	17	2	0	2818	\N
902	233	3	0	2829	\N
902	507	4	0	2830	\N
903	2	3	0	2446	\N
903	3	4	0	2831	\N
904	10	3	0	2832	\N
904	465	4	0	2833	\N
905	12	2	0	1958	\N
905	433	3	0	2172	\N
906	224	2	0	2838	\N
906	508	3	0	2839	\N
907	10	1	0	2832	\N
907	11	2	0	2842	\N
908	4	1	0	910	\N
908	25	2	0	911	\N
909	16	1	0	2772	\N
909	17	2	0	2818	\N
910	391	2	0	2488	\N
910	406	3	0	2849	\N
912	360	2	0	2856	\N
912	510	3	0	2857	\N
916	164	2	0	1171	\N
916	512	3	0	2866	\N
919	88	1	0	2879	\N
919	89	2	0	2880	\N
922	198	2	0	2888	\N
922	513	3	0	2889	\N
925	173	1	0	2629	\N
925	396	2	0	2630	\N
927	514	1	0	2900	\N
927	515	2	0	2901	\N
929	1	1	0	2904	\N
929	53	2	0	2905	\N
931	1	2	0	2904	\N
931	112	3	0	2912	\N
934	10	1	0	2920	\N
934	11	2	0	2921	\N
937	224	1	0	2928	\N
937	225	2	0	2929	\N
940	10	1	0	2920	\N
940	11	2	0	2921	\N
945	10	1	0	2920	\N
945	11	2	0	2921	\N
952	77	2	0	2974	\N
952	216	3	0	2975	\N
911	86	2	0	2854	\N
911	509	3	0	2855	\N
913	228	2	0	2858	\N
913	511	3	0	2859	\N
914	1	1	0	2796	\N
914	53	2	0	2797	\N
917	1	4	0	2875	\N
917	422	5	0	2876	\N
918	40	1	0	2507	\N
918	41	2	0	2508	\N
921	84	1	0	2883	\N
921	85	2	0	2884	\N
930	391	2	0	2910	\N
930	406	3	0	2911	\N
933	1	2	0	2904	\N
933	112	3	0	2912	\N
936	517	1	0	2924	\N
936	518	2	0	2925	\N
939	40	1	0	2507	\N
939	41	2	0	2508	\N
942	18	3	0	2942	\N
942	127	4	0	2943	\N
943	1	1	0	2922	\N
943	53	2	0	2923	\N
946	10	2	0	2952	\N
946	29	3	0	2953	\N
947	33	1	0	2956	\N
947	163	2	0	2957	\N
951	424	2	0	2968	\N
951	520	3	0	2969	\N
915	2	2	0	2446	\N
915	471	3	0	2447	\N
920	56	1	0	2535	\N
920	57	2	0	2557	\N
923	186	1	0	2892	\N
923	187	2	0	2893	\N
924	338	1	0	2896	\N
924	409	2	0	2897	\N
926	151	1	0	1737	\N
926	302	2	0	1738	\N
928	58	1	0	1400	\N
928	59	2	0	1401	\N
932	516	3	0	2917	\N
935	1	1	0	2922	\N
935	53	2	0	2923	\N
938	411	1	0	1952	\N
938	412	2	0	1953	\N
941	51	1	0	2934	\N
941	52	2	0	2935	\N
944	94	1	0	2090	\N
944	107	2	0	2091	\N
948	1	1	0	2922	\N
948	53	2	0	2923	\N
949	20	1	0	2960	\N
949	144	2	0	2961	\N
950	365	2	0	2966	\N
950	519	3	0	2967	\N
953	51	1	0	2934	\N
953	52	2	0	2935	\N
954	286	2	0	1034	\N
955	18	1	0	2978	\N
955	19	2	0	2979	\N
956	167	3	0	2986	\N
956	521	4	0	2987	\N
957	365	1	0	2966	\N
957	366	2	0	2990	\N
958	140	1	0	2991	\N
958	141	2	0	2992	\N
959	40	6	0	3005	\N
959	522	7	0	3006	\N
960	1	6	0	2922	\N
960	523	7	0	3007	\N
961	360	2	0	3012	\N
961	510	3	0	3013	\N
962	1	2	0	2922	\N
962	112	3	0	3014	\N
963	51	2	0	3015	\N
963	524	3	0	3016	\N
964	1	2	0	2922	\N
964	112	3	0	3014	\N
965	488	1	0	3023	\N
965	489	2	0	3024	\N
966	149	1	0	3025	\N
966	499	2	0	3026	\N
967	40	1	0	3029	\N
967	41	2	0	3030	\N
968	241	1	0	1822	\N
968	333	2	0	1823	\N
969	18	1	0	2978	\N
969	19	2	0	2979	\N
970	525	1	0	3033	\N
970	526	2	0	3034	\N
971	10	1	0	3035	\N
971	11	2	0	3036	\N
972	186	1	0	3039	\N
972	187	2	0	3040	\N
973	10	1	0	3035	\N
973	11	2	0	3036	\N
974	75	1	0	3041	\N
974	76	2	0	3042	\N
975	260	1	0	3045	\N
975	261	2	0	3046	\N
976	88	1	0	2879	\N
976	89	2	0	2880	\N
977	16	1	0	2772	\N
977	17	2	0	2818	\N
978	41	1	0	3049	\N
978	40	2	0	3050	\N
979	237	1	0	807	\N
979	527	2	0	3053	\N
980	202	1	0	2501	\N
980	203	2	0	2502	\N
981	1	1	0	3054	\N
981	53	2	0	3055	\N
982	189	1	0	3056	\N
982	190	2	0	3057	\N
983	1	1	0	3054	\N
983	53	2	0	3055	\N
984	453	1	0	2323	\N
984	454	2	0	2324	\N
985	204	1	0	3062	\N
985	205	2	0	3063	\N
986	10	1	0	3064	\N
986	11	2	0	3065	\N
987	119	1	0	3066	\N
987	120	2	0	3067	\N
988	16	1	0	2772	\N
988	17	2	0	2818	\N
989	528	1	0	3070	\N
989	529	2	0	3071	\N
990	10	1	0	3064	\N
990	11	2	0	3065	\N
991	286	2	0	1034	\N
992	389	1	0	3072	\N
992	390	2	0	3073	\N
993	40	1	0	3076	\N
993	41	2	0	3077	\N
994	12	1	0	1958	\N
994	13	2	0	1959	\N
995	40	1	0	3076	\N
995	41	2	0	3077	\N
996	181	1	0	3080	\N
996	530	2	0	3081	\N
997	40	1	0	3084	\N
997	41	2	0	3085	\N
998	20	1	0	3088	\N
998	144	2	0	3089	\N
999	88	1	0	3092	\N
999	89	2	0	3093	\N
1000	2	1	0	3096	\N
1000	26	2	0	3097	\N
1001	170	1	0	3098	\N
1001	398	2	0	3099	\N
1002	268	1	0	1916	\N
1002	269	2	0	1917	\N
1003	1	1	0	3104	\N
1003	53	2	0	3105	\N
1004	453	1	0	2323	\N
1004	454	2	0	2324	\N
1005	10	0	0	3064	\N
1006	173	1	0	3108	\N
1006	396	2	0	3109	\N
1007	431	2	0	3112	\N
1007	531	3	0	3113	\N
1008	33	5	0	3124	\N
1008	532	6	0	3125	\N
1009	69	1	0	3128	\N
1009	70	2	0	3129	\N
1010	110	1	0	2581	\N
1010	134	2	0	3130	\N
1011	324	1	0	3131	\N
1011	325	2	0	3132	\N
1012	110	2	0	2581	\N
1012	111	3	0	2582	\N
1013	362	1	0	2063	\N
1013	395	2	0	2564	\N
1014	233	1	0	3137	\N
1014	234	2	0	3138	\N
1015	170	1	0	3139	\N
1015	398	2	0	3140	\N
1016	77	1	0	3143	\N
1016	78	2	0	3144	\N
1017	40	1	0	3147	\N
1017	41	2	0	3148	\N
1018	367	1	0	2459	\N
1018	368	2	0	3149	\N
1021	149	1	0	3025	\N
1021	499	2	0	3026	\N
1024	16	1	0	2772	\N
1024	17	2	0	2818	\N
1027	100	1	0	1785	\N
1027	160	2	0	1786	\N
1031	362	1	0	3181	\N
1031	395	2	0	3182	\N
1032	292	1	0	2774	\N
1032	293	2	0	3185	\N
1033	316	1	0	3188	\N
1033	317	2	0	3189	\N
1036	140	1	0	2991	\N
1036	141	2	0	2992	\N
1039	2	1	0	3096	\N
1039	26	2	0	3097	\N
1042	391	1	0	3208	\N
1042	392	2	0	3209	\N
1045	536	1	0	3216	\N
1045	537	2	0	3217	\N
1047	391	1	0	3220	\N
1047	392	2	0	3221	\N
1050	29	2	0	3237	\N
1050	540	3	0	3238	\N
1050	541	3	0	3239	\N
1053	192	36	0	602	\N
1053	544	37	0	3333	\N
1056	547	18	0	3371	\N
1058	186	17	0	3039	\N
1058	549	18	0	3373	\N
1059	147	43	0	3375	\N
1059	551	44	0	3376	\N
1061	1	3	0	3214	\N
1061	48	4	0	3417	\N
1066	10	1	0	3431	\N
1066	11	2	0	3432	\N
1069	1	1	0	3441	\N
1069	53	2	0	3442	\N
1072	16	1	0	3447	\N
1072	17	2	0	3448	\N
1019	1	1	0	3104	\N
1019	53	2	0	3105	\N
1022	167	1	0	3158	\N
1022	533	2	0	3159	\N
1025	69	2	0	3128	\N
1025	500	3	0	3166	\N
1028	534	1	0	3171	\N
1028	535	2	0	3172	\N
1034	167	1	0	3158	\N
1034	533	2	0	3159	\N
1037	6	1	0	3198	\N
1037	194	2	0	3199	\N
1038	18	1	0	2978	\N
1038	19	2	0	2979	\N
1041	10	1	0	3206	\N
1041	11	2	0	3207	\N
1044	1	1	0	3214	\N
1044	53	2	0	3215	\N
1048	260	4	0	3045	\N
1048	538	5	0	3230	\N
1051	2	9	0	3096	\N
1051	542	10	0	3258	\N
1054	86	36	0	2854	\N
1054	545	37	0	3334	\N
1057	1	17	0	3214	\N
1057	548	18	0	3372	\N
1060	56	16	0	3409	\N
1060	552	17	0	3410	\N
1062	528	3	0	3070	\N
1062	553	4	0	3418	\N
1063	251	3	0	3419	\N
1063	554	4	0	3420	\N
1064	10	2	0	3425	\N
1064	29	3	0	3426	\N
1067	16	1	0	3433	\N
1067	17	2	0	3434	\N
1070	224	1	0	3443	\N
1070	225	2	0	3444	\N
1020	251	1	0	3154	\N
1020	252	2	0	3155	\N
1023	60	1	0	2158	\N
1023	61	2	0	2159	\N
1026	94	2	0	3167	\N
1026	95	3	0	3168	\N
1029	145	1	0	3175	\N
1029	153	2	0	3176	\N
1030	23	1	0	3179	\N
1030	217	2	0	3180	\N
1035	10	1	0	3194	\N
1035	11	2	0	3195	\N
1040	413	1	0	1954	\N
1040	414	2	0	1955	\N
1043	27	1	0	3210	\N
1043	28	2	0	3211	\N
1046	173	1	0	3108	\N
1046	396	2	0	3109	\N
1049	391	4	0	3231	\N
1049	539	5	0	3232	\N
1052	18	9	0	3259	\N
1052	543	10	0	3260	\N
1055	23	36	0	3335	\N
1055	546	37	0	3336	\N
1065	122	2	0	313	\N
1068	2	1	0	3437	\N
1068	26	2	0	3438	\N
1071	353	1	0	3445	\N
1071	354	2	0	3446	\N
1073	10	2	0	3431	\N
1073	29	3	0	3453	\N
1074	75	2	0	3041	\N
1074	159	3	0	3454	\N
1075	30	1	0	2776	\N
1075	418	2	0	3457	\N
1076	268	1	0	3460	\N
1076	269	2	0	3461	\N
1077	92	1	0	3464	\N
1077	191	2	0	3465	\N
1078	316	3	0	3472	\N
1078	555	4	0	3473	\N
1079	224	3	0	3443	\N
1079	387	4	0	3474	\N
1080	460	1	0	3477	\N
1080	459	2	0	2394	\N
1081	44	1	0	3480	\N
1081	45	2	0	3481	\N
1082	290	1	0	2788	\N
1082	291	2	0	3484	\N
1083	69	1	0	3485	\N
1083	70	2	0	3486	\N
1084	424	1	0	3487	\N
1084	425	2	0	3488	\N
1085	556	1	0	3489	\N
1085	557	2	0	3490	\N
1086	108	1	0	2753	\N
1086	109	2	0	3493	\N
1087	108	0	0	2753	\N
1088	424	1	0	3494	\N
1088	425	2	0	3495	\N
1089	2	16	0	3528	\N
1089	558	17	0	3529	\N
1090	115	9	0	636	\N
1090	559	10	0	3548	\N
1091	115	8	0	636	\N
1091	560	9	0	3549	\N
1092	561	9	0	3550	\N
1092	562	10	0	3551	\N
1093	121	10	0	3572	\N
1093	563	11	0	3573	\N
1094	40	4	0	3582	\N
1094	564	5	0	3583	\N
1095	1	4	0	3584	\N
1095	422	5	0	3585	\N
1096	210	4	0	3586	\N
1096	565	5	0	3587	\N
1097	1	1	0	3590	\N
1097	53	2	0	3591	\N
1098	119	1	0	3066	\N
1098	120	2	0	3067	\N
1099	353	1	0	3445	\N
1099	354	2	0	3446	\N
1100	449	1	0	3594	\N
1100	450	2	0	3595	\N
1101	1	1	0	3590	\N
1101	53	2	0	3591	\N
1102	202	1	0	2501	\N
1102	203	2	0	2502	\N
1103	75	1	0	3041	\N
1103	76	2	0	3042	\N
1104	256	1	0	1465	\N
1104	257	2	0	3602	\N
1105	64	1	0	3603	\N
1105	65	2	0	3604	\N
1106	10	1	0	3607	\N
1106	11	2	0	3608	\N
1107	186	1	0	3609	\N
1107	187	2	0	3610	\N
1108	360	1	0	3613	\N
1108	479	2	0	3614	\N
1109	10	1	0	3615	\N
1109	11	2	0	3616	\N
1110	411	1	0	3617	\N
1110	412	2	0	3618	\N
1111	208	1	0	3619	\N
1111	209	2	0	3620	\N
1112	516	3	0	2917	\N
1113	212	2	0	1554	\N
1113	566	3	0	3625	\N
1114	6	2	0	3626	\N
1114	179	3	0	3627	\N
1115	88	1	0	3630	\N
1115	89	2	0	3631	\N
1116	58	1	0	3632	\N
1116	59	2	0	3633	\N
1117	40	1	0	3582	\N
1117	41	2	0	3636	\N
1118	181	1	0	3080	\N
1118	530	2	0	3081	\N
1119	12	2	0	3641	\N
1119	433	3	0	3642	\N
1120	16	2	0	3447	\N
1120	155	3	0	3643	\N
1121	94	2	0	3167	\N
1121	95	3	0	3168	\N
1122	10	2	0	3648	\N
1122	29	3	0	3649	\N
1123	4	1	0	3652	\N
1123	25	2	0	3653	\N
1124	40	1	0	3654	\N
1124	41	2	0	3655	\N
1125	567	28	0	3656	\N
1125	4	71	0	3657	\N
1125	568	72	0	3658	\N
1126	40	2	0	3662	\N
1126	569	3	0	3663	\N
1127	79	1	0	3666	\N
1127	81	2	0	3667	\N
1128	336	1	0	2593	\N
1128	356	2	0	2594	\N
1129	156	1	0	3670	\N
1129	157	2	0	3671	\N
1130	10	1	0	3674	\N
1130	11	2	0	3675	\N
1131	58	1	0	3678	\N
1131	59	2	0	3679	\N
1132	16	2	0	3447	\N
1132	155	3	0	3643	\N
1133	18	1	0	3259	\N
1133	19	2	0	3686	\N
1134	204	2	0	3691	\N
1134	570	3	0	3692	\N
1135	38	2	0	2673	\N
1135	39	3	0	3693	\N
1136	78	1	0	3696	\N
1136	77	2	0	3697	\N
1139	113	1	0	3701	\N
1139	437	2	0	3702	\N
1142	242	1	0	3709	\N
1142	253	2	0	3710	\N
1145	75	1	0	3041	\N
1145	76	2	0	3042	\N
1148	121	1	0	3723	\N
1148	122	2	0	3724	\N
1151	156	2	0	3735	\N
1151	571	3	0	3736	\N
1154	573	3	0	3747	\N
1154	574	4	0	3748	\N
1155	208	1	0	3619	\N
1155	209	2	0	3620	\N
1158	121	1	0	3723	\N
1158	122	2	0	3724	\N
1161	10	2	0	3743	\N
1161	29	3	0	3764	\N
1164	326	1	0	1746	\N
1164	327	2	0	2320	\N
1166	290	2	0	2788	\N
1166	575	3	0	3776	\N
1167	33	1	0	3779	\N
1167	163	2	0	3780	\N
1169	1	1	0	3781	\N
1169	53	2	0	3782	\N
1173	1	1	0	3791	\N
1173	53	2	0	3792	\N
1174	151	2	0	1737	\N
1174	576	3	0	3797	\N
1177	577	1	0	3806	\N
1177	578	2	0	3807	\N
1178	4	2	0	3652	\N
1178	579	3	0	3812	\N
1181	2	1	0	3745	\N
1181	26	2	0	3819	\N
1184	82	2	0	3830	\N
1184	343	3	0	3831	\N
1185	88	3	0	3630	\N
1185	580	4	0	3837	\N
1188	164	0	0	1171	\N
1191	411	2	0	3617	\N
1191	582	3	0	3855	\N
1194	18	2	0	3860	\N
1194	218	3	0	3861	\N
1197	391	1	0	3838	\N
1197	392	2	0	3866	\N
1200	4	1	0	3652	\N
1200	25	2	0	3653	\N
1203	10	1	0	3882	\N
1203	11	2	0	3883	\N
1206	67	1	0	3887	\N
1206	478	2	0	3888	\N
1137	138	1	0	3698	\N
1137	137	2	0	1474	\N
1138	117	1	0	1386	\N
1138	248	2	0	1387	\N
1141	14	1	0	3707	\N
1141	15	2	0	3708	\N
1144	230	1	0	3715	\N
1144	287	2	0	3716	\N
1147	1	1	0	3721	\N
1147	53	2	0	3722	\N
1150	192	1	0	3729	\N
1150	193	2	0	3730	\N
1153	2	3	0	3745	\N
1153	572	4	0	3746	\N
1156	75	1	0	3041	\N
1156	76	2	0	3042	\N
1159	1	1	0	3757	\N
1159	53	2	0	3758	\N
1162	256	2	0	3765	\N
1162	335	3	0	3766	\N
1165	360	2	0	3613	\N
1165	510	3	0	3775	\N
1170	64	1	0	3603	\N
1170	65	2	0	3604	\N
1171	391	1	0	3785	\N
1171	392	2	0	3786	\N
1176	177	1	0	3802	\N
1176	498	2	0	3803	\N
1179	56	2	0	3813	\N
1179	169	3	0	3814	\N
1182	10	1	0	3822	\N
1182	11	2	0	3823	\N
1186	391	3	0	3838	\N
1186	581	4	0	3839	\N
1187	164	3	0	1171	\N
1187	307	4	0	3846	\N
1189	164	0	0	1171	\N
1190	367	1	0	3849	\N
1190	368	2	0	3850	\N
1193	449	2	0	3858	\N
1193	583	3	0	3859	\N
1196	30	1	0	3725	\N
1196	418	2	0	3726	\N
1199	86	1	0	2854	\N
1199	87	2	0	3871	\N
1204	1	1	0	3884	\N
1204	53	2	0	3885	\N
1140	79	1	0	3703	\N
1140	81	2	0	3704	\N
1143	391	1	0	3713	\N
1143	392	2	0	3714	\N
1146	40	1	0	3719	\N
1146	41	2	0	3720	\N
1149	30	1	0	3725	\N
1149	418	2	0	3726	\N
1152	10	3	0	3743	\N
1152	347	4	0	3744	\N
1157	367	1	0	2459	\N
1157	368	2	0	3149	\N
1160	204	1	0	3691	\N
1160	205	2	0	3759	\N
1163	365	1	0	3769	\N
1163	366	2	0	3770	\N
1168	40	1	0	3719	\N
1168	41	2	0	3720	\N
1172	60	1	0	2158	\N
1172	61	2	0	2159	\N
1175	18	2	0	3798	\N
1175	218	3	0	3799	\N
1180	40	1	0	3719	\N
1180	41	2	0	3720	\N
1183	84	1	0	3824	\N
1183	85	2	0	3825	\N
1192	79	2	0	3856	\N
1192	80	3	0	3857	\N
1195	10	1	0	3822	\N
1195	11	2	0	3823	\N
1198	435	1	0	3867	\N
1198	436	2	0	3868	\N
1201	222	1	0	3874	\N
1201	223	2	0	3875	\N
1202	10	1	0	3878	\N
1202	11	2	0	3879	\N
1205	220	1	0	2475	\N
1205	221	2	0	3886	\N
1207	411	2	0	3617	\N
1207	582	3	0	3855	\N
1208	43	1	0	3895	\N
1208	42	2	0	3896	\N
1209	269	1	0	3897	\N
1209	268	2	0	3898	\N
1210	584	1	0	3899	\N
1210	451	2	0	3900	\N
1211	528	1	0	3070	\N
1211	529	2	0	3071	\N
1212	58	1	0	3903	\N
1212	59	2	0	3904	\N
1213	75	1	0	3905	\N
1213	76	2	0	3906	\N
1214	1	1	0	3909	\N
1214	53	2	0	3910	\N
1215	10	3	0	3882	\N
1215	347	4	0	3917	\N
1216	8	1	0	3920	\N
1216	9	2	0	3921	\N
1217	14	1	0	3707	\N
1217	15	2	0	3708	\N
1218	241	1	0	1822	\N
1218	333	2	0	1823	\N
1219	435	1	0	3867	\N
1219	436	2	0	3868	\N
1220	451	1	0	3926	\N
1220	584	2	0	3927	\N
1221	258	2	0	3932	\N
1221	585	3	0	3933	\N
1222	1	3	0	3940	\N
1222	48	4	0	3941	\N
1223	273	3	0	1948	\N
1223	586	4	0	3942	\N
1224	235	3	0	2190	\N
1224	587	4	0	3943	\N
1225	391	1	0	3946	\N
1225	392	2	0	3947	\N
1226	10	1	0	3950	\N
1226	11	2	0	3951	\N
1227	73	1	0	2166	\N
1227	74	2	0	2167	\N
1228	206	1	0	2570	\N
1228	207	2	0	2571	\N
1229	198	1	0	3956	\N
1229	199	2	0	3957	\N
1230	84	2	0	3962	\N
1230	434	3	0	3963	\N
1231	320	2	0	1873	\N
1231	321	3	0	3964	\N
1232	40	1	0	3967	\N
1232	41	2	0	3968	\N
1233	71	1	0	1766	\N
1233	72	2	0	3971	\N
1234	69	2	0	3485	\N
1234	500	3	0	3976	\N
1235	10	1	0	3950	\N
1235	11	2	0	3951	\N
1236	136	2	0	365	\N
1237	137	1	0	1473	\N
1237	138	2	0	1474	\N
1238	40	1	0	3983	\N
1238	41	2	0	3984	\N
1239	10	1	0	3985	\N
1239	11	2	0	3986	\N
1240	42	1	0	3987	\N
1240	43	2	0	3896	\N
1241	4	1	0	3990	\N
1241	25	2	0	3991	\N
1242	411	1	0	3994	\N
1242	412	2	0	3995	\N
1243	10	1	0	3985	\N
1243	11	2	0	3986	\N
1244	1	1	0	3940	\N
1244	53	2	0	4000	\N
1245	338	1	0	4003	\N
1245	409	2	0	4004	\N
1246	391	1	0	4005	\N
1246	392	2	0	4006	\N
1247	206	1	0	4007	\N
1247	207	2	0	4008	\N
1248	88	1	0	4011	\N
1248	89	2	0	4012	\N
1249	316	1	0	3472	\N
1249	317	2	0	4013	\N
1250	290	1	0	4016	\N
1250	291	2	0	4017	\N
1251	1	1	0	4018	\N
1251	53	2	0	4019	\N
1252	1	2	0	4018	\N
1252	112	3	0	4024	\N
1253	125	2	0	4025	\N
1253	188	3	0	4026	\N
1254	320	0	0	1873	\N
1255	273	1	0	1948	\N
1255	410	2	0	1949	\N
1256	320	1	0	4029	\N
1256	334	2	0	4030	\N
1257	1	1	0	4033	\N
1257	53	2	0	4034	\N
1258	14	4	0	4043	\N
1258	588	5	0	4044	\N
1259	237	1	0	4047	\N
1259	527	2	0	4048	\N
1260	1	1	0	4049	\N
1260	53	2	0	4050	\N
1261	75	1	0	3905	\N
1261	76	2	0	3906	\N
1262	79	4	0	3856	\N
1262	589	5	0	4059	\N
1263	18	4	0	3860	\N
1263	590	5	0	4060	\N
1264	591	4	0	4061	\N
1264	592	5	0	4062	\N
1265	56	19	0	4065	\N
1265	593	20	0	4066	\N
1266	16	3	0	4071	\N
1266	359	4	0	4072	\N
1267	69	3	0	4073	\N
1267	594	4	0	4074	\N
1271	599	2	0	4083	\N
1276	10	1	0	4095	\N
1276	11	2	0	4096	\N
1279	125	1	0	4025	\N
1279	195	2	0	4103	\N
1282	1	1	0	4049	\N
1282	53	2	0	4050	\N
1285	402	1	0	4115	\N
1285	403	2	0	4116	\N
1286	528	1	0	4117	\N
1286	529	2	0	4118	\N
1291	151	1	0	1737	\N
1291	302	2	0	1738	\N
1294	189	2	0	3056	\N
1294	311	3	0	4135	\N
1295	2	1	0	4138	\N
1295	26	2	0	4139	\N
1297	88	4	0	4011	\N
1297	601	5	0	4149	\N
1301	391	1	0	4157	\N
1301	392	2	0	4158	\N
1304	88	1	0	4011	\N
1304	89	2	0	4012	\N
1307	10	0	0	4095	\N
1310	391	1	0	4183	\N
1310	392	2	0	4184	\N
1313	110	1	0	2581	\N
1313	134	2	0	3130	\N
1315	170	1	0	3139	\N
1315	398	2	0	3140	\N
1316	10	1	0	4113	\N
1316	11	2	0	4114	\N
1321	115	5	0	636	\N
1321	607	6	0	4211	\N
1322	140	0	0	1848	\N
1325	18	3	0	4220	\N
1325	609	4	0	4221	\N
1328	82	1	0	4234	\N
1328	83	2	0	4235	\N
1334	611	35	0	4247	\N
1334	56	55	0	4251	\N
1334	612	56	0	4252	\N
1335	4	2	0	4255	\N
1335	579	3	0	4256	\N
1337	100	1	0	4259	\N
1337	160	2	0	4260	\N
1338	10	1	0	4263	\N
1338	11	2	0	4264	\N
1340	88	1	0	4267	\N
1340	89	2	0	4268	\N
1341	451	1	0	4271	\N
1341	584	2	0	4272	\N
1342	140	1	0	4275	\N
1342	141	2	0	4276	\N
1345	18	1	0	4245	\N
1345	19	2	0	4246	\N
1347	325	1	0	4284	\N
1347	324	2	0	4285	\N
1350	325	1	0	4284	\N
1350	324	2	0	4285	\N
1351	367	1	0	4290	\N
1351	368	2	0	4291	\N
1354	528	2	0	4300	\N
1354	613	3	0	4301	\N
1268	113	1	0	3701	\N
1268	437	2	0	3702	\N
1270	598	2	0	4082	\N
1273	84	1	0	3962	\N
1273	85	2	0	4088	\N
1277	336	1	0	2593	\N
1277	356	2	0	2594	\N
1280	198	1	0	4106	\N
1280	199	2	0	4107	\N
1281	16	1	0	4071	\N
1281	17	2	0	4110	\N
1283	40	1	0	3983	\N
1283	41	2	0	3984	\N
1287	142	1	0	386	\N
1287	143	2	0	387	\N
1288	256	2	0	3765	\N
1288	335	3	0	3766	\N
1290	288	1	0	1793	\N
1290	400	2	0	1794	\N
1293	100	2	0	1785	\N
1293	101	3	0	2054	\N
1296	10	4	0	4113	\N
1296	600	5	0	4148	\N
1299	1	4	0	4151	\N
1299	422	5	0	4152	\N
1305	204	1	0	3691	\N
1305	205	2	0	3759	\N
1306	96	3	0	4179	\N
1306	605	4	0	4180	\N
1308	10	0	0	3985	\N
1309	10	0	0	4113	\N
1312	362	1	0	3181	\N
1312	395	2	0	3182	\N
1314	60	1	0	4191	\N
1314	61	2	0	4192	\N
1318	181	1	0	3080	\N
1318	530	2	0	3081	\N
1324	102	3	0	4218	\N
1324	608	4	0	4219	\N
1327	64	1	0	3603	\N
1327	65	2	0	3604	\N
1330	119	1	0	4239	\N
1330	120	2	0	4240	\N
1333	18	1	0	4245	\N
1333	19	2	0	4246	\N
1336	10	1	0	4113	\N
1336	11	2	0	4114	\N
1339	56	3	0	4265	\N
1339	475	4	0	4266	\N
1344	56	3	0	4279	\N
1344	475	4	0	4280	\N
1349	325	1	0	4284	\N
1349	324	2	0	4285	\N
1353	67	1	0	3887	\N
1353	478	2	0	3888	\N
1355	1	2	0	4302	\N
1355	112	3	0	4303	\N
1269	596	2	0	4080	\N
1272	54	1	0	4086	\N
1272	55	2	0	4087	\N
1274	35	1	0	4089	\N
1274	340	2	0	4090	\N
1275	140	1	0	2991	\N
1275	141	2	0	2992	\N
1278	198	1	0	4099	\N
1278	199	2	0	4100	\N
1284	10	1	0	4113	\N
1284	11	2	0	4114	\N
1289	1	1	0	4049	\N
1289	53	2	0	4050	\N
1292	449	1	0	4129	\N
1292	450	2	0	4130	\N
1298	220	4	0	2475	\N
1298	602	5	0	4150	\N
1300	324	4	0	4153	\N
1300	603	5	0	4154	\N
1302	224	1	0	4159	\N
1302	225	2	0	4160	\N
1303	237	3	0	4167	\N
1303	604	4	0	4168	\N
1311	42	1	0	4185	\N
1311	43	2	0	4186	\N
1317	40	1	0	3983	\N
1317	41	2	0	3984	\N
1319	16	1	0	4197	\N
1319	17	2	0	4198	\N
1320	292	5	0	4209	\N
1320	606	6	0	4210	\N
1323	140	0	0	1848	\N
1326	268	3	0	4228	\N
1326	610	4	0	4229	\N
1329	18	1	0	4220	\N
1329	19	2	0	4236	\N
1331	224	1	0	4159	\N
1331	225	2	0	4160	\N
1332	16	1	0	4243	\N
1332	17	2	0	4244	\N
1343	8	1	0	3920	\N
1343	9	2	0	3921	\N
1346	109	1	0	4283	\N
1346	108	2	0	3493	\N
1348	234	1	0	4286	\N
1348	233	2	0	4287	\N
1352	198	1	0	4294	\N
1352	199	2	0	4295	\N
1356	391	4	0	4183	\N
1356	614	5	0	4312	\N
1357	10	1	0	4263	\N
1357	11	2	0	4264	\N
1358	1	1	0	4315	\N
1358	53	2	0	4316	\N
1359	424	1	0	4317	\N
1359	425	2	0	4318	\N
1360	1	1	0	4321	\N
1360	53	2	0	4322	\N
1361	84	1	0	3962	\N
1361	85	2	0	4088	\N
1362	10	2	0	4263	\N
1362	275	3	0	4327	\N
1363	365	2	0	3769	\N
1363	615	3	0	4328	\N
1364	79	2	0	4329	\N
1364	616	3	0	4330	\N
1365	1	1	0	4321	\N
1365	53	2	0	4322	\N
1366	10	1	0	4335	\N
1366	11	2	0	4336	\N
1367	365	1	0	3769	\N
1367	366	2	0	3770	\N
1368	10	1	0	4339	\N
1368	11	2	0	4340	\N
1369	35	1	0	4089	\N
1369	340	2	0	4090	\N
1370	210	1	0	3586	\N
1370	211	2	0	4343	\N
1371	170	1	0	3139	\N
1371	398	2	0	3140	\N
1372	10	1	0	4339	\N
1372	11	2	0	4340	\N
1373	125	1	0	4346	\N
1373	195	2	0	4347	\N
1374	237	2	0	4352	\N
1374	319	3	0	4353	\N
1375	54	1	0	4356	\N
1375	55	2	0	4357	\N
1376	1	1	0	4358	\N
1376	53	2	0	4359	\N
1377	362	1	0	4360	\N
1377	395	2	0	4361	\N
1378	367	1	0	4364	\N
1378	368	2	0	4365	\N
1379	324	3	0	4153	\N
1379	617	4	0	4371	\N
1380	56	26	0	4377	\N
1380	618	27	0	4378	\N
1381	27	2	0	3210	\N
1381	619	3	0	4379	\N
1382	242	2	0	4380	\N
1382	620	3	0	4381	\N
1383	10	6	0	4394	\N
1383	426	7	0	4395	\N
1384	10	1	0	4398	\N
1384	11	2	0	4399	\N
1385	453	1	0	4402	\N
1385	454	2	0	4403	\N
1386	186	6	0	3609	\N
1386	621	7	0	4415	\N
1387	210	6	0	4416	\N
1387	622	7	0	4417	\N
1388	88	6	0	4418	\N
1388	623	7	0	4419	\N
1389	300	1	0	2509	\N
1389	355	2	0	2510	\N
1390	44	1	0	4422	\N
1390	45	2	0	4423	\N
1391	235	1	0	4424	\N
1391	236	2	0	4425	\N
1392	2	1	0	4426	\N
1392	26	2	0	4427	\N
1393	88	1	0	4428	\N
1393	89	2	0	4429	\N
1394	10	1	0	4432	\N
1394	11	2	0	4433	\N
1395	453	1	0	4434	\N
1395	454	2	0	4435	\N
1396	119	1	0	4436	\N
1396	120	2	0	4437	\N
1397	151	2	0	4442	\N
1397	576	3	0	4443	\N
1398	40	2	0	4444	\N
1398	66	3	0	4445	\N
1399	119	5	0	4436	\N
1399	624	6	0	4456	\N
1400	110	1	0	4459	\N
1400	134	2	0	4460	\N
1401	258	1	0	4463	\N
1401	309	2	0	4464	\N
1402	20	1	0	4465	\N
1402	144	2	0	4466	\N
1403	40	1	0	4444	\N
1403	41	2	0	4467	\N
1404	108	1	0	2753	\N
1404	109	2	0	3493	\N
1405	10	2	0	4472	\N
1405	29	3	0	4473	\N
1406	121	2	0	4474	\N
1406	625	3	0	4475	\N
1407	1	2	0	4358	\N
1407	112	3	0	4476	\N
1408	94	2	0	4477	\N
1408	95	3	0	4478	\N
1409	596	2	0	4080	\N
1410	598	2	0	4082	\N
1418	110	1	0	4497	\N
1418	134	2	0	4498	\N
1420	132	1	0	4502	\N
1420	455	2	0	4503	\N
1421	220	1	0	2475	\N
1421	221	2	0	3886	\N
1424	18	2	0	4512	\N
1424	218	3	0	4513	\N
1427	391	1	0	4491	\N
1427	392	2	0	4492	\N
1432	224	3	0	4159	\N
1432	387	4	0	4542	\N
1440	4	1	0	4564	\N
1440	25	2	0	4565	\N
1441	44	2	0	4570	\N
1441	161	3	0	4571	\N
1444	56	55	0	4584	\N
1444	628	56	0	4585	\N
1447	40	1	0	4594	\N
1447	41	2	0	4595	\N
1450	94	3	0	4477	\N
1450	631	4	0	4604	\N
1456	16	2	0	4621	\N
1456	388	3	0	4622	\N
1458	18	1	0	4626	\N
1458	19	2	0	4627	\N
1461	391	1	0	4641	\N
1461	392	2	0	4642	\N
1464	113	1	0	4648	\N
1464	437	2	0	4649	\N
1467	638	2	0	4662	\N
1470	1	1	0	4695	\N
1470	53	2	0	4696	\N
1472	212	1	0	1554	\N
1472	213	2	0	1555	\N
1476	268	5	0	4717	\N
1476	642	6	0	4718	\N
1478	242	1	0	4721	\N
1478	253	2	0	4722	\N
1480	60	3	0	4191	\N
1480	643	4	0	4731	\N
1481	112	2	0	4736	\N
1481	1	3	0	4737	\N
1484	145	1	0	4746	\N
1484	153	2	0	4747	\N
1485	1	2	0	4751	\N
1485	283	3	0	4752	\N
1490	449	2	0	4643	\N
1490	646	3	0	4766	\N
1491	88	1	0	4714	\N
1491	89	2	0	4769	\N
1494	10	1	0	4780	\N
1494	11	2	0	4781	\N
1500	10	2	0	4828	\N
1500	29	3	0	4829	\N
1503	88	1	0	4838	\N
1503	89	2	0	4839	\N
1506	79	1	0	4848	\N
1506	81	2	0	4849	\N
1508	16	1	0	4851	\N
1508	17	2	0	4852	\N
1511	164	2	0	4861	\N
1511	226	3	0	4862	\N
1512	256	2	0	4863	\N
1512	335	3	0	4864	\N
1514	33	2	0	3779	\N
1514	34	3	0	4871	\N
1515	113	1	0	4874	\N
1515	437	2	0	4875	\N
1411	147	1	0	4481	\N
1411	599	2	0	4482	\N
1413	251	3	0	3419	\N
1413	554	4	0	3420	\N
1415	391	1	0	4491	\N
1415	392	2	0	4492	\N
1417	212	1	0	1554	\N
1417	213	2	0	1555	\N
1422	10	0	0	4506	\N
1425	192	3	0	4516	\N
1425	627	4	0	4517	\N
1430	40	3	0	4444	\N
1430	128	4	0	4531	\N
1435	338	1	0	4548	\N
1435	409	2	0	4549	\N
1436	1	2	0	4358	\N
1436	112	3	0	4476	\N
1438	79	2	0	4329	\N
1438	80	3	0	4560	\N
1439	121	1	0	4474	\N
1439	122	2	0	4563	\N
1443	79	2	0	4329	\N
1443	80	3	0	4560	\N
1445	629	2	0	4586	\N
1445	630	3	0	4587	\N
1451	18	1	0	4512	\N
1451	19	2	0	4607	\N
1454	100	2	0	4259	\N
1454	633	3	0	4620	\N
1457	241	2	0	1822	\N
1457	634	3	0	4623	\N
1460	16	4	0	4621	\N
1460	380	5	0	4638	\N
1463	244	0	0	4645	\N
1466	115	2	0	636	\N
1466	636	3	0	4658	\N
1469	639	11	0	4678	\N
1469	56	25	0	4691	\N
1469	640	26	0	4692	\N
1473	288	2	0	1793	\N
1473	289	3	0	4703	\N
1474	88	5	0	4714	\N
1474	243	6	0	4715	\N
1477	273	1	0	1948	\N
1477	410	2	0	1949	\N
1483	451	1	0	4742	\N
1483	584	2	0	4743	\N
1486	338	2	0	4753	\N
1486	644	3	0	4754	\N
1487	1	2	0	4751	\N
1487	112	3	0	4737	\N
1493	324	1	0	4776	\N
1493	325	2	0	4777	\N
1497	2	4	0	4426	\N
1497	315	5	0	4818	\N
1501	186	1	0	3609	\N
1501	187	2	0	3610	\N
1502	256	1	0	4834	\N
1502	257	2	0	4835	\N
1505	449	1	0	4643	\N
1505	450	2	0	4644	\N
1507	228	1	0	2858	\N
1507	229	2	0	4850	\N
1509	6	1	0	4853	\N
1509	194	2	0	4854	\N
1412	151	3	0	4487	\N
1412	152	4	0	4488	\N
1414	86	1	0	2854	\N
1414	87	2	0	3871	\N
1416	119	1	0	4493	\N
1416	120	2	0	4494	\N
1419	110	2	0	4497	\N
1419	626	3	0	4501	\N
1423	424	2	0	4317	\N
1423	520	3	0	4511	\N
1426	424	3	0	4317	\N
1426	468	4	0	4518	\N
1428	235	1	0	4424	\N
1428	236	2	0	4425	\N
1429	10	1	0	4523	\N
1429	11	2	0	4524	\N
1431	431	1	0	4534	\N
1431	432	2	0	4535	\N
1433	260	3	0	3045	\N
1433	271	4	0	4543	\N
1434	367	1	0	4546	\N
1434	368	2	0	4547	\N
1437	38	2	0	4558	\N
1437	39	3	0	4559	\N
1442	82	2	0	4234	\N
1442	343	3	0	4572	\N
1446	391	1	0	4590	\N
1446	392	2	0	4591	\N
1448	365	1	0	3769	\N
1448	366	2	0	3770	\N
1449	449	1	0	4129	\N
1449	450	2	0	4130	\N
1452	119	1	0	4493	\N
1452	120	2	0	4494	\N
1453	88	3	0	4428	\N
1453	632	4	0	4615	\N
1455	79	2	0	4329	\N
1455	616	3	0	4330	\N
1459	258	4	0	4636	\N
1459	635	5	0	4637	\N
1462	449	1	0	4643	\N
1462	450	2	0	4644	\N
1465	10	1	0	4652	\N
1465	11	2	0	4653	\N
1468	322	1	0	4665	\N
1468	323	2	0	4666	\N
1471	54	1	0	4356	\N
1471	55	2	0	4357	\N
1475	79	5	0	4329	\N
1475	641	6	0	4716	\N
1479	237	3	0	4729	\N
1479	604	4	0	4730	\N
1482	155	2	0	4738	\N
1482	16	3	0	4739	\N
1488	362	2	0	4759	\N
1488	420	3	0	4760	\N
1489	27	2	0	3210	\N
1489	645	3	0	4765	\N
1492	324	1	0	4772	\N
1492	325	2	0	4773	\N
1495	56	25	0	4808	\N
1495	647	26	0	4809	\N
1496	51	4	0	3015	\N
1496	648	5	0	4817	\N
1498	214	4	0	1934	\N
1498	649	5	0	4819	\N
1499	10	1	0	4822	\N
1499	11	2	0	4823	\N
1504	1	1	0	4842	\N
1504	53	2	0	4843	\N
1510	40	2	0	4859	\N
1510	66	3	0	4860	\N
1513	391	2	0	4869	\N
1513	406	3	0	4870	\N
1516	23	5	0	3335	\N
1516	650	6	0	4886	\N
1517	71	1	0	4889	\N
1517	72	2	0	4890	\N
1518	338	1	0	4891	\N
1518	409	2	0	4892	\N
1519	156	2	0	4897	\N
1519	571	3	0	4898	\N
1520	367	2	0	4546	\N
1520	651	3	0	4899	\N
1521	10	2	0	4904	\N
1521	29	3	0	4905	\N
1522	33	2	0	4906	\N
1522	34	3	0	4907	\N
1523	324	2	0	4908	\N
1523	486	3	0	4909	\N
1524	44	1	0	4570	\N
1524	45	2	0	4912	\N
1525	1	4	0	4921	\N
1525	422	5	0	4922	\N
1526	64	4	0	4923	\N
1526	490	5	0	4924	\N
1527	10	1	0	4904	\N
1527	11	2	0	4927	\N
1528	117	1	0	1386	\N
1528	248	2	0	1387	\N
1529	51	1	0	3015	\N
1529	52	2	0	4930	\N
1530	113	1	0	4931	\N
1530	437	2	0	4932	\N
1531	10	1	0	4935	\N
1531	11	2	0	4936	\N
1532	360	1	0	3613	\N
1532	479	2	0	3614	\N
1533	84	1	0	4939	\N
1533	85	2	0	4940	\N
1534	18	1	0	4941	\N
1534	19	2	0	4942	\N
1535	10	1	0	4945	\N
1535	11	2	0	4946	\N
1536	135	1	0	4947	\N
1536	136	2	0	4948	\N
1537	137	1	0	1473	\N
1537	138	2	0	1474	\N
1538	84	1	0	4939	\N
1538	85	2	0	4940	\N
1539	10	1	0	4945	\N
1539	11	2	0	4946	\N
1540	164	0	0	4861	\N
1541	164	1	0	4861	\N
1541	165	2	0	4953	\N
1542	1	1	0	4954	\N
1542	53	2	0	4955	\N
1543	164	0	0	4861	\N
1544	164	0	0	4861	\N
1545	10	1	0	4945	\N
1545	11	2	0	4946	\N
1546	1	1	0	4958	\N
1546	53	2	0	4959	\N
1547	56	40	0	4999	\N
1547	652	41	0	5000	\N
1548	204	1	0	5003	\N
1548	205	2	0	5004	\N
1549	64	1	0	4923	\N
1549	65	2	0	5005	\N
1550	54	0	0	5006	\N
1551	73	0	0	5007	\N
1552	653	0	0	5008	\N
1552	654	0	0	5009	\N
1553	117	3	0	5016	\N
1553	118	4	0	5017	\N
1554	210	3	0	4416	\N
1554	655	4	0	5018	\N
1555	156	3	0	4897	\N
1555	407	4	0	5019	\N
1556	117	3	0	5016	\N
1556	118	4	0	5017	\N
1557	242	1	0	5022	\N
1557	253	2	0	5023	\N
1558	251	1	0	5026	\N
1558	252	2	0	5027	\N
1559	1	2	0	5032	\N
1559	112	3	0	5033	\N
1560	142	2	0	5034	\N
1560	656	3	0	5035	\N
1561	156	1	0	5038	\N
1561	157	2	0	5039	\N
1566	49	1	0	5052	\N
1566	50	2	0	5053	\N
1567	12	2	0	3641	\N
1567	433	3	0	3642	\N
1570	251	1	0	5062	\N
1570	252	2	0	5063	\N
1573	10	1	0	4945	\N
1573	11	2	0	4946	\N
1578	657	1	0	5080	\N
1578	658	2	0	5081	\N
1579	75	1	0	3905	\N
1579	76	2	0	3906	\N
1581	1	3	0	5089	\N
1581	48	4	0	5090	\N
1582	54	1	0	5093	\N
1582	55	2	0	5094	\N
1584	27	1	0	5096	\N
1584	28	2	0	5097	\N
1587	367	1	0	5104	\N
1587	368	2	0	5105	\N
1588	110	1	0	5108	\N
1588	134	2	0	5109	\N
1591	1	2	0	5119	\N
1591	112	3	0	5120	\N
1593	108	1	0	2753	\N
1593	109	2	0	3493	\N
1595	142	1	0	5034	\N
1595	143	2	0	5129	\N
1597	202	1	0	5130	\N
1597	203	2	0	5131	\N
1598	38	1	0	5132	\N
1598	399	2	0	5133	\N
1600	662	6	0	5134	\N
1600	663	7	0	5135	\N
1600	664	7	0	5136	\N
1602	58	2	0	3903	\N
1602	665	3	0	5141	\N
1608	667	95	0	5154	\N
1608	431	126	0	5185	\N
1608	668	127	0	5186	\N
1612	108	4	0	2753	\N
1612	669	5	0	5206	\N
1613	6	4	0	4853	\N
1613	670	5	0	5207	\N
1615	353	1	0	3445	\N
1615	354	2	0	3446	\N
1621	1	1	0	5221	\N
1621	53	2	0	5222	\N
1623	156	1	0	5227	\N
1623	157	2	0	5228	\N
1624	671	43	0	5272	\N
1624	56	46	0	5275	\N
1624	169	47	0	5276	\N
1627	189	1	0	3056	\N
1627	190	2	0	3057	\N
1630	92	1	0	5291	\N
1630	191	2	0	5292	\N
1633	224	2	0	4159	\N
1633	508	3	0	5299	\N
1634	75	2	0	3905	\N
1634	159	3	0	5300	\N
1637	75	1	0	5311	\N
1637	76	2	0	5312	\N
1638	17	1	0	5315	\N
1638	16	2	0	5075	\N
1642	147	1	0	4481	\N
1642	599	2	0	4482	\N
1644	16	1	0	5326	\N
1644	17	2	0	5327	\N
1647	56	12	0	5344	\N
1647	676	13	0	5345	\N
1649	336	1	0	2593	\N
1649	356	2	0	2594	\N
1652	264	1	0	1388	\N
1652	270	2	0	1389	\N
1655	214	1	0	5369	\N
1655	215	2	0	5370	\N
1658	678	1	0	5381	\N
1658	679	2	0	5382	\N
1662	1	4	0	5221	\N
1662	422	5	0	5396	\N
1665	324	2	0	4908	\N
1665	486	3	0	4909	\N
1667	62	2	0	2379	\N
1667	683	3	0	5405	\N
1670	391	2	0	4869	\N
1670	406	3	0	4870	\N
1672	10	1	0	5394	\N
1672	11	2	0	5416	\N
1673	4	4	0	5425	\N
1673	684	5	0	5426	\N
1676	142	1	0	5034	\N
1676	143	2	0	5129	\N
1679	206	1	0	4007	\N
1679	207	2	0	4008	\N
1682	449	1	0	5441	\N
1682	450	2	0	5442	\N
1685	228	1	0	2858	\N
1685	229	2	0	4850	\N
1688	2	1	0	4426	\N
1688	26	2	0	4427	\N
1691	56	8	0	5469	\N
1691	689	9	0	5470	\N
1562	82	1	0	5040	\N
1562	83	2	0	5041	\N
1563	1	1	0	5044	\N
1563	53	2	0	5045	\N
1569	16	1	0	4851	\N
1569	17	2	0	4852	\N
1572	206	1	0	4007	\N
1572	207	2	0	4008	\N
1575	35	1	0	5072	\N
1575	340	2	0	5073	\N
1583	210	1	0	4416	\N
1583	211	2	0	5095	\N
1585	79	1	0	5098	\N
1585	81	2	0	5099	\N
1589	1	1	0	5110	\N
1589	53	2	0	5111	\N
1590	117	1	0	5016	\N
1590	248	2	0	5114	\N
1599	75	1	0	3905	\N
1599	76	2	0	3906	\N
1603	14	11	0	5142	\N
1603	666	12	0	5143	\N
1605	10	2	0	5123	\N
1605	29	3	0	5149	\N
1609	96	2	0	5191	\N
1609	482	3	0	5192	\N
1616	204	1	0	5212	\N
1616	205	2	0	5213	\N
1618	288	1	0	5216	\N
1618	400	2	0	5217	\N
1619	75	1	0	3905	\N
1619	76	2	0	3906	\N
1622	115	1	0	5225	\N
1622	116	2	0	5226	\N
1632	672	1	0	5293	\N
1632	673	2	0	5294	\N
1635	674	2	0	5305	\N
1635	675	3	0	5306	\N
1640	598	2	0	4082	\N
1645	451	1	0	5328	\N
1645	584	2	0	5329	\N
1646	663	0	0	5330	\N
1646	664	0	0	5331	\N
1648	164	1	0	4861	\N
1648	165	2	0	4953	\N
1650	40	1	0	5350	\N
1650	41	2	0	5351	\N
1651	86	1	0	5354	\N
1651	87	2	0	5355	\N
1653	18	1	0	5358	\N
1653	19	2	0	5359	\N
1654	56	5	0	5366	\N
1654	677	6	0	5367	\N
1657	290	1	0	5379	\N
1657	291	2	0	5380	\N
1659	244	1	0	4645	\N
1659	245	2	0	5383	\N
1661	10	4	0	5394	\N
1661	600	5	0	5395	\N
1664	324	13	0	4908	\N
1664	682	14	0	5403	\N
1668	391	2	0	4869	\N
1668	406	3	0	4870	\N
1671	210	1	0	4416	\N
1671	211	2	0	5095	\N
1680	663	0	0	5433	\N
1680	664	0	0	5434	\N
1686	687	1	0	5449	\N
1686	688	2	0	5450	\N
1689	10	1	0	5394	\N
1689	11	2	0	5416	\N
1692	391	2	0	5475	\N
1692	406	3	0	5476	\N
1564	322	1	0	5046	\N
1564	323	2	0	5047	\N
1565	167	1	0	5050	\N
1565	533	2	0	5051	\N
1568	453	1	0	4434	\N
1568	454	2	0	4435	\N
1571	16	1	0	5066	\N
1571	17	2	0	5067	\N
1574	251	1	0	5062	\N
1574	252	2	0	5063	\N
1576	16	1	0	5074	\N
1576	17	2	0	5075	\N
1577	10	1	0	5078	\N
1577	11	2	0	5079	\N
1580	208	3	0	3619	\N
1580	659	4	0	5088	\N
1586	10	1	0	5102	\N
1586	11	2	0	5103	\N
1592	10	1	0	5123	\N
1592	11	2	0	5124	\N
1594	660	88	0	5127	\N
1594	653	89	0	5008	\N
1594	661	89	0	5128	\N
1596	208	1	0	3619	\N
1596	209	2	0	3620	\N
1601	164	2	0	4861	\N
1601	226	3	0	4862	\N
1604	14	2	0	5142	\N
1604	383	3	0	5144	\N
1606	121	2	0	5150	\N
1606	625	3	0	5151	\N
1607	10	1	0	5123	\N
1607	11	2	0	5124	\N
1610	1	1	0	5195	\N
1610	53	2	0	5196	\N
1611	108	0	0	5197	\N
1614	121	1	0	5210	\N
1614	122	2	0	5211	\N
1617	8	1	0	3920	\N
1617	9	2	0	3921	\N
1620	40	1	0	4859	\N
1620	41	2	0	5220	\N
1625	672	1	0	5277	\N
1625	673	2	0	5278	\N
1626	96	1	0	5281	\N
1626	97	2	0	5282	\N
1628	242	1	0	5285	\N
1628	253	2	0	5286	\N
1629	117	1	0	5289	\N
1629	248	2	0	5290	\N
1631	167	1	0	5050	\N
1631	533	2	0	5051	\N
1636	292	1	0	5309	\N
1636	293	2	0	5310	\N
1639	292	1	0	5318	\N
1639	293	2	0	5319	\N
1641	595	1	0	5322	\N
1641	596	2	0	5323	\N
1643	4	1	0	4564	\N
1643	25	2	0	4565	\N
1656	10	2	0	5375	\N
1656	29	3	0	5376	\N
1660	256	4	0	5392	\N
1660	680	5	0	5393	\N
1663	42	2	0	5401	\N
1663	681	3	0	5402	\N
1666	75	2	0	5311	\N
1666	159	3	0	5404	\N
1669	360	2	0	3613	\N
1669	510	3	0	3775	\N
1674	20	4	0	4465	\N
1674	685	5	0	5427	\N
1675	241	4	0	1822	\N
1675	686	5	0	5428	\N
1677	79	1	0	5098	\N
1677	81	2	0	5099	\N
1678	300	1	0	2509	\N
1678	355	2	0	2510	\N
1681	164	1	0	5437	\N
1681	165	2	0	5438	\N
1683	262	1	0	2365	\N
1683	263	2	0	2366	\N
1684	75	1	0	5311	\N
1684	76	2	0	5312	\N
1687	79	1	0	5098	\N
1687	81	2	0	5099	\N
1690	8	2	0	5459	\N
1690	37	3	0	5460	\N
1693	18	2	0	5477	\N
1693	218	3	0	5478	\N
1694	402	1	0	4115	\N
1694	403	2	0	4116	\N
1695	338	1	0	4891	\N
1695	409	2	0	4892	\N
1696	16	1	0	5485	\N
1696	17	2	0	5486	\N
1697	18	4	0	5494	\N
1697	590	5	0	5495	\N
1698	40	1	0	5350	\N
1698	41	2	0	5351	\N
1700	324	0	0	4908	\N
1701	324	31	0	5500	\N
1701	690	32	0	5501	\N
1702	90	1	0	1410	\N
1702	344	2	0	1411	\N
1703	324	1	0	4908	\N
1703	325	2	0	5502	\N
1704	691	1	0	5503	\N
1704	692	2	0	5504	\N
1705	324	0	0	4908	\N
1706	88	2	0	5507	\N
1706	154	3	0	5508	\N
1707	206	2	0	5509	\N
1707	693	3	0	5510	\N
1708	431	73	0	5582	\N
1708	694	74	0	5583	\N
1709	290	4	0	5379	\N
1709	695	5	0	5590	\N
1710	186	2	0	5595	\N
1710	696	3	0	5596	\N
1711	40	2	0	5597	\N
1711	66	3	0	5598	\N
1712	40	0	0	5599	\N
1713	212	0	0	1554	\N
1714	75	0	0	5600	\N
1715	149	2	0	5605	\N
1715	697	3	0	5606	\N
1716	204	1	0	5212	\N
1716	205	2	0	5213	\N
1717	10	1	0	5611	\N
1717	11	2	0	5612	\N
1718	324	11	0	5613	\N
1718	698	12	0	5614	\N
1719	324	1	0	5615	\N
1719	325	2	0	5616	\N
1720	577	1	0	5617	\N
1720	578	2	0	5618	\N
1721	113	4	0	4931	\N
1721	699	5	0	5627	\N
1722	1	4	0	5221	\N
1722	422	5	0	5396	\N
1723	156	2	0	5227	\N
1723	571	3	0	5632	\N
1724	16	2	0	5633	\N
1724	155	3	0	5634	\N
1725	10	1	0	5611	\N
1725	11	2	0	5612	\N
1726	164	1	0	5639	\N
1726	165	2	0	5434	\N
1727	324	1	0	5615	\N
1727	325	2	0	5616	\N
1728	324	9	0	5642	\N
1728	700	10	0	5643	\N
1729	10	1	0	5646	\N
1729	11	2	0	5647	\N
1730	49	2	0	5652	\N
1730	328	3	0	5653	\N
1731	389	2	0	5654	\N
1731	701	3	0	5655	\N
1733	290	1	0	5660	\N
1733	291	2	0	5661	\N
1737	18	1	0	5670	\N
1737	19	2	0	5671	\N
1739	4	1	0	5672	\N
1739	25	2	0	5675	\N
1740	20	2	0	4465	\N
1740	702	3	0	5678	\N
1743	10	1	0	5658	\N
1743	11	2	0	5659	\N
1745	10	1	0	5687	\N
1745	11	2	0	5688	\N
1746	73	2	0	5007	\N
1746	703	3	0	5693	\N
1748	1	2	0	5221	\N
1748	112	3	0	5679	\N
1754	38	1	0	5706	\N
1754	399	2	0	5707	\N
1755	10	1	0	5687	\N
1755	11	2	0	5688	\N
1761	251	1	0	5062	\N
1761	252	2	0	5063	\N
1764	84	1	0	5728	\N
1764	85	2	0	5729	\N
1767	49	1	0	5652	\N
1767	50	2	0	5736	\N
1770	16	3	0	5633	\N
1770	359	4	0	5747	\N
1773	210	1	0	5761	\N
1773	211	2	0	5762	\N
1775	173	1	0	3108	\N
1775	396	2	0	3109	\N
1776	75	1	0	5600	\N
1776	76	2	0	5765	\N
1778	10	1	0	5770	\N
1778	11	2	0	5771	\N
1782	40	2	0	5599	\N
1782	66	3	0	5694	\N
1785	49	1	0	5781	\N
1785	50	2	0	5782	\N
1786	56	5	0	4065	\N
1786	677	6	0	5793	\N
1792	186	1	0	5595	\N
1792	187	2	0	5699	\N
1795	338	1	0	5772	\N
1795	409	2	0	5773	\N
1798	1	3	0	5221	\N
1798	711	4	0	5827	\N
1801	273	1	0	1948	\N
1801	410	2	0	1949	\N
1803	353	1	0	5835	\N
1803	354	2	0	5836	\N
1804	10	3	0	5842	\N
1804	297	4	0	5843	\N
1807	391	1	0	5475	\N
1807	392	2	0	5852	\N
1813	119	1	0	5867	\N
1813	120	2	0	5868	\N
1816	90	0	0	1410	\N
1820	200	1	0	5856	\N
1820	201	2	0	5857	\N
1826	92	1	0	5291	\N
1826	191	2	0	5292	\N
1834	90	0	0	5913	\N
1835	10	2	0	5917	\N
1835	29	3	0	5918	\N
1838	73	1	0	5925	\N
1838	74	2	0	5926	\N
1841	360	1	0	5933	\N
1841	479	2	0	5934	\N
1845	12	2	0	5939	\N
1845	433	3	0	5942	\N
1847	115	1	0	5225	\N
1847	116	2	0	5226	\N
1848	189	1	0	5947	\N
1848	190	2	0	5948	\N
1854	115	1	0	5225	\N
1854	116	2	0	5226	\N
1857	200	1	0	5962	\N
1857	201	2	0	5963	\N
1859	170	2	0	3139	\N
1859	718	3	0	5970	\N
1860	94	2	0	5971	\N
1860	95	3	0	5972	\N
1863	10	1	0	5981	\N
1863	11	2	0	5982	\N
1866	1	1	0	5987	\N
1866	53	2	0	5988	\N
1871	132	1	0	6000	\N
1871	455	2	0	6001	\N
1874	160	1	0	6004	\N
1874	100	3	0	6007	\N
1874	160	4	0	6008	\N
1876	424	1	0	5828	\N
1876	425	2	0	6015	\N
1879	40	2	0	6022	\N
1879	66	3	0	6023	\N
1881	58	1	0	3903	\N
1881	59	2	0	3904	\N
1882	10	1	0	5981	\N
1882	11	2	0	5982	\N
1884	10	1	0	6034	\N
1884	11	2	0	6035	\N
1891	200	1	0	6051	\N
1891	201	2	0	6052	\N
1732	10	1	0	5658	\N
1732	11	2	0	5659	\N
1734	79	1	0	5662	\N
1734	81	2	0	5663	\N
1738	4	0	0	5672	\N
1744	119	1	0	5685	\N
1744	120	2	0	5686	\N
1750	186	1	0	5595	\N
1750	187	2	0	5699	\N
1752	220	1	0	5702	\N
1752	221	2	0	5703	\N
1753	657	1	0	5080	\N
1753	658	2	0	5081	\N
1758	1	2	0	5221	\N
1758	112	3	0	5679	\N
1759	108	1	0	2753	\N
1759	109	2	0	3493	\N
1762	88	3	0	5722	\N
1762	580	4	0	5723	\N
1765	88	1	0	5732	\N
1765	89	2	0	5733	\N
1771	64	2	0	4923	\N
1771	162	3	0	5752	\N
1777	705	2	0	5769	\N
1780	338	1	0	5772	\N
1780	409	2	0	5773	\N
1783	18	2	0	5695	\N
1783	218	3	0	5696	\N
1788	209	1	0	5798	\N
1788	208	2	0	3620	\N
1791	10	2	0	5770	\N
1791	29	3	0	5807	\N
1794	338	0	0	5772	\N
1797	79	1	0	5662	\N
1797	81	2	0	5663	\N
1799	424	3	0	5828	\N
1799	712	4	0	5829	\N
1800	60	1	0	4191	\N
1800	61	2	0	4192	\N
1805	75	3	0	5844	\N
1805	713	4	0	5845	\N
1808	10	1	0	5842	\N
1808	11	2	0	5853	\N
1809	200	1	0	5856	\N
1809	201	2	0	5857	\N
1812	230	2	0	3715	\N
1812	231	3	0	5864	\N
1814	88	1	0	5869	\N
1814	89	2	0	5870	\N
1817	2	4	0	5668	\N
1817	315	5	0	5879	\N
1818	14	1	0	5882	\N
1818	15	2	0	5883	\N
1822	338	0	0	5893	\N
1824	18	1	0	5695	\N
1824	19	2	0	5896	\N
1827	391	1	0	5475	\N
1827	392	2	0	5852	\N
1829	300	1	0	5906	\N
1829	355	2	0	5907	\N
1832	1	1	0	5911	\N
1832	53	2	0	5912	\N
1836	54	1	0	5093	\N
1836	55	2	0	5094	\N
1839	449	1	0	5441	\N
1839	450	2	0	5442	\N
1844	40	1	0	5599	\N
1844	41	2	0	5941	\N
1850	56	1	0	4065	\N
1850	57	2	0	5953	\N
1853	115	1	0	5225	\N
1853	116	2	0	5226	\N
1856	268	1	0	5858	\N
1856	269	2	0	5859	\N
1862	719	1	0	5977	\N
1862	720	2	0	5978	\N
1865	42	1	0	5985	\N
1865	43	2	0	5986	\N
1868	721	80	0	5991	\N
1868	722	81	0	5992	\N
1868	723	81	0	5993	\N
1872	160	1	0	6004	\N
1872	100	3	0	6007	\N
1872	160	4	0	6008	\N
1875	145	1	0	6013	\N
1875	153	2	0	6014	\N
1878	251	1	0	5062	\N
1878	252	2	0	5063	\N
1887	362	1	0	4759	\N
1887	395	2	0	6044	\N
1890	67	1	0	3887	\N
1890	478	2	0	3888	\N
1735	18	1	0	5664	\N
1735	19	2	0	5665	\N
1736	2	1	0	5668	\N
1736	26	2	0	5669	\N
1741	1	2	0	5221	\N
1741	112	3	0	5679	\N
1742	192	1	0	4516	\N
1742	193	2	0	5682	\N
1747	40	2	0	5599	\N
1747	66	3	0	5694	\N
1749	18	2	0	5695	\N
1749	218	3	0	5696	\N
1751	27	1	0	5700	\N
1751	28	2	0	5701	\N
1756	181	1	0	3080	\N
1756	530	2	0	3081	\N
1757	528	2	0	4300	\N
1757	613	3	0	4301	\N
1760	1	1	0	5221	\N
1760	53	2	0	5222	\N
1763	264	1	0	1388	\N
1763	270	2	0	1389	\N
1766	82	0	0	5040	\N
1769	292	1	0	5739	\N
1769	293	2	0	5740	\N
1772	528	2	0	5757	\N
1772	613	3	0	5758	\N
1774	149	1	0	5763	\N
1774	499	2	0	5764	\N
1779	288	1	0	5216	\N
1779	400	2	0	5217	\N
1781	300	2	0	2509	\N
1781	706	3	0	5778	\N
1784	117	1	0	5289	\N
1784	248	2	0	5290	\N
1787	16	5	0	5794	\N
1787	707	6	0	5795	\N
1789	72	1	0	5799	\N
1789	71	2	0	5800	\N
1790	17	1	0	5801	\N
1790	16	2	0	5802	\N
1793	708	26	0	5810	\N
1793	709	27	0	5811	\N
1793	710	27	0	5812	\N
1796	14	3	0	5817	\N
1796	306	4	0	5818	\N
1802	268	1	0	4717	\N
1802	269	2	0	5834	\N
1806	75	1	0	5848	\N
1806	76	2	0	5849	\N
1810	268	1	0	5858	\N
1810	269	2	0	5859	\N
1811	132	1	0	4502	\N
1811	455	2	0	4503	\N
1815	90	2	0	1410	\N
1815	91	3	0	2521	\N
1819	292	2	0	1062	\N
1819	502	3	0	5888	\N
1821	714	1	0	5891	\N
1821	715	2	0	5892	\N
1823	709	0	0	5894	\N
1823	710	0	0	5895	\N
1825	338	1	0	5893	\N
1825	409	2	0	5897	\N
1828	164	1	0	5904	\N
1828	165	2	0	5905	\N
1830	38	1	0	5706	\N
1830	399	2	0	5707	\N
1831	292	1	0	1932	\N
1831	293	2	0	5910	\N
1833	90	1	0	5913	\N
1833	344	2	0	5914	\N
1837	716	1	0	5921	\N
1837	717	2	0	5922	\N
1840	64	1	0	5929	\N
1840	65	2	0	5930	\N
1842	33	1	0	5935	\N
1842	163	2	0	5936	\N
1843	12	1	0	5939	\N
1843	13	2	0	5940	\N
1846	54	1	0	5945	\N
1846	55	2	0	5946	\N
1849	75	1	0	5949	\N
1849	76	2	0	5950	\N
1851	1	1	0	5911	\N
1851	53	2	0	5912	\N
1852	244	1	0	5954	\N
1852	245	2	0	5955	\N
1855	149	1	0	5763	\N
1855	499	2	0	5764	\N
1858	2	2	0	5968	\N
1858	131	3	0	5969	\N
1861	140	1	0	5975	\N
1861	141	2	0	5976	\N
1864	27	1	0	5700	\N
1864	28	2	0	5701	\N
1867	1	1	0	5987	\N
1867	53	2	0	5988	\N
1869	86	1	0	5996	\N
1869	87	2	0	5997	\N
1870	23	1	0	5998	\N
1870	217	2	0	5999	\N
1873	533	1	0	6009	\N
1873	167	3	0	5051	\N
1873	533	4	0	6010	\N
1877	16	1	0	6016	\N
1877	17	2	0	6017	\N
1880	40	1	0	6026	\N
1880	41	2	0	6027	\N
1883	8	1	0	6032	\N
1883	9	2	0	6033	\N
1885	110	1	0	5108	\N
1885	134	2	0	5109	\N
1886	64	2	0	6040	\N
1886	162	3	0	6041	\N
1888	123	1	0	6045	\N
1888	124	2	0	6046	\N
1889	51	1	0	3015	\N
1889	52	2	0	4930	\N
1892	256	1	0	6055	\N
1892	257	2	0	6056	\N
1893	411	1	0	6059	\N
1893	412	2	0	6060	\N
1894	244	1	0	5954	\N
1894	245	2	0	5955	\N
1895	51	1	0	3015	\N
1895	52	2	0	4930	\N
1896	1	3	0	6069	\N
1896	48	4	0	6070	\N
1897	121	1	0	5210	\N
1897	122	2	0	5211	\N
1898	264	1	0	6073	\N
1898	270	2	0	6074	\N
1899	181	3	0	3080	\N
1899	724	4	0	6081	\N
1900	119	1	0	5867	\N
1900	120	2	0	5868	\N
1901	10	1	0	6034	\N
1901	11	2	0	6035	\N
1902	18	1	0	5695	\N
1902	19	2	0	5896	\N
1903	725	1	0	6086	\N
1903	726	2	0	6087	\N
1904	727	1	0	6088	\N
1904	728	2	0	6089	\N
1905	54	1	0	5945	\N
1905	55	2	0	5946	\N
1906	10	1	0	6034	\N
1906	11	2	0	6035	\N
1907	242	1	0	5285	\N
1907	253	2	0	5286	\N
1908	8	1	0	6032	\N
1908	9	2	0	6033	\N
1909	208	1	0	3619	\N
1909	209	2	0	3620	\N
1910	18	1	0	5695	\N
1910	19	2	0	5896	\N
1911	316	3	0	6100	\N
1911	555	4	0	6101	\N
1914	488	2	0	6113	\N
1914	729	3	0	6114	\N
1917	1	1	0	6121	\N
1917	53	2	0	6122	\N
1919	164	1	0	5904	\N
1919	165	2	0	5905	\N
1921	170	1	0	3139	\N
1921	398	2	0	3140	\N
1923	10	1	0	6034	\N
1923	11	2	0	6035	\N
1926	56	3	0	4065	\N
1926	475	4	0	6137	\N
1928	424	3	0	5828	\N
1928	468	4	0	6139	\N
1929	10	1	0	6142	\N
1929	11	2	0	6143	\N
1932	115	1	0	6152	\N
1932	116	2	0	6153	\N
1934	228	1	0	6156	\N
1934	229	2	0	6157	\N
1937	1	1	0	6154	\N
1937	53	2	0	6155	\N
1938	62	1	0	2379	\N
1938	63	2	0	2380	\N
1940	260	1	0	6167	\N
1940	261	2	0	6168	\N
1943	73	2	0	6174	\N
1943	703	3	0	6175	\N
1944	142	1	0	6178	\N
1944	143	2	0	6179	\N
1947	242	1	0	6181	\N
1947	253	2	0	6182	\N
1953	365	1	0	3769	\N
1953	366	2	0	3770	\N
1956	38	2	0	5706	\N
1956	39	3	0	6205	\N
1958	6	1	0	6208	\N
1958	194	2	0	6209	\N
1962	353	1	0	5835	\N
1962	354	2	0	5836	\N
1971	173	1	0	3108	\N
1971	396	2	0	3109	\N
1973	2	1	0	6245	\N
1973	26	2	0	6253	\N
1975	737	42	0	6257	\N
1975	324	126	0	6258	\N
1975	738	127	1	6259	\N
1975	124	127	0	6260	\N
1977	60	1	0	6267	\N
1977	61	2	0	6268	\N
1980	391	1	0	6243	\N
1980	392	2	0	6249	\N
1982	164	1	0	5904	\N
1982	165	2	0	5905	\N
1983	10	1	0	6280	\N
1983	11	2	0	6281	\N
1986	202	1	0	5130	\N
1986	203	2	0	5131	\N
1991	285	1	0	6301	\N
1991	286	2	0	6302	\N
1993	1	1	0	6154	\N
1993	53	2	0	6155	\N
1995	235	1	0	4424	\N
1995	236	2	0	4425	\N
1996	100	2	0	6315	\N
1996	101	3	0	6008	\N
1999	84	1	0	6322	\N
1999	85	2	0	6323	\N
2001	18	1	0	6210	\N
2001	19	2	0	6211	\N
2005	60	2	0	6267	\N
2005	166	3	0	6337	\N
2007	2	2	0	6245	\N
2007	131	3	0	6246	\N
2010	82	1	0	5040	\N
2010	83	2	0	5041	\N
2014	320	1	0	6359	\N
2014	334	2	0	6360	\N
2016	1	3	0	6367	\N
2016	48	4	0	6368	\N
2022	2	2	0	6245	\N
2022	131	3	0	6246	\N
2030	16	1	0	6016	\N
2030	17	2	0	6017	\N
2032	84	2	0	6414	\N
2032	749	3	1	6415	\N
2032	748	3	0	6416	\N
2035	16	1	0	6423	\N
2035	17	2	0	6424	\N
2036	256	2	0	6429	\N
2036	335	3	0	6430	\N
2045	752	13	0	6454	\N
2045	94	49	0	6455	\N
2045	753	50	0	6456	\N
2047	338	1	0	6473	\N
2047	409	2	0	6474	\N
2052	353	2	0	5835	\N
2052	755	3	0	6487	\N
2056	757	2	0	6495	\N
2059	365	1	0	6498	\N
2059	366	2	0	6499	\N
2062	260	1	0	6167	\N
2062	261	2	0	6168	\N
2065	125	1	0	4346	\N
2065	195	2	0	4347	\N
2069	1	1	0	6522	\N
2069	53	2	0	6523	\N
2072	40	2	0	6534	\N
2072	66	3	0	6535	\N
2075	79	1	0	6540	\N
2075	81	2	0	6541	\N
2078	18	1	0	6548	\N
2078	19	2	0	6549	\N
2083	170	1	0	3139	\N
2083	398	2	0	3140	\N
2088	233	0	0	6575	\N
2090	268	1	0	6542	\N
2090	269	2	0	6543	\N
2091	115	1	0	6587	\N
2091	116	2	0	6588	\N
2094	156	1	0	6293	\N
2094	157	2	0	6294	\N
2097	239	2	0	6597	\N
2097	760	3	0	6598	\N
2099	10	1	0	6607	\N
2099	11	2	0	6608	\N
2101	1	1	0	6611	\N
2101	53	2	0	6612	\N
1912	391	1	0	6104	\N
1912	392	2	0	6105	\N
1915	242	2	0	5285	\N
1915	620	3	0	6115	\N
1918	360	1	0	6125	\N
1918	479	2	0	6126	\N
1920	1	1	0	6127	\N
1920	53	2	0	6128	\N
1930	75	1	0	5949	\N
1930	76	2	0	5950	\N
1936	156	1	0	6161	\N
1936	157	2	0	6162	\N
1939	336	1	0	6165	\N
1939	356	2	0	6166	\N
1942	56	2	0	4065	\N
1942	169	3	0	6173	\N
1946	142	47	0	6178	\N
1946	733	48	0	6180	\N
1948	734	2	0	6187	\N
1948	735	3	0	6188	\N
1950	10	1	0	6142	\N
1950	11	2	0	6143	\N
1951	262	1	0	6193	\N
1951	263	2	0	6194	\N
1954	365	1	0	3769	\N
1954	366	2	0	3770	\N
1957	10	1	0	6142	\N
1957	11	2	0	6143	\N
1959	18	1	0	6210	\N
1959	19	2	0	6211	\N
1960	10	2	0	6216	\N
1960	29	3	0	6217	\N
1965	18	1	0	6210	\N
1965	19	2	0	6211	\N
1966	110	6	0	6235	\N
1966	736	7	0	6236	\N
1968	391	2	0	6243	\N
1968	406	3	0	6244	\N
1972	10	1	0	6216	\N
1972	11	2	0	6252	\N
1978	115	1	0	6152	\N
1978	116	2	0	6153	\N
1981	1	1	0	6154	\N
1981	53	2	0	6155	\N
1984	16	2	0	6016	\N
1984	155	3	0	6286	\N
1988	10	1	0	6295	\N
1988	11	2	0	6296	\N
1990	23	1	0	5998	\N
1990	217	2	0	5999	\N
1994	151	1	0	6309	\N
1994	302	2	0	6310	\N
1998	10	1	0	6303	\N
1998	11	2	0	6304	\N
2004	336	2	0	6335	\N
2004	740	3	0	6336	\N
2008	1	3	0	6346	\N
2008	48	4	0	6347	\N
2011	743	81	0	6354	\N
2011	744	82	0	6355	\N
2011	745	82	0	6356	\N
2012	290	1	0	5660	\N
2012	291	2	0	5661	\N
2015	273	3	0	1948	\N
2015	586	4	0	3942	\N
2018	336	1	0	6335	\N
2018	356	2	0	6375	\N
2019	100	1	0	6376	\N
2019	160	2	0	6377	\N
2021	54	2	0	6384	\N
2021	485	3	0	6385	\N
2026	326	2	0	6398	\N
2026	747	3	0	6399	\N
2031	75	1	0	6195	\N
2031	76	2	0	6196	\N
2034	750	2	0	6418	\N
2034	751	2	0	6419	\N
2034	434	3	0	6420	\N
2038	1	2	0	6367	\N
2038	112	3	0	6435	\N
2041	16	2	0	6446	\N
2041	155	3	0	6447	\N
2044	75	1	0	6195	\N
2044	76	2	0	6196	\N
2046	212	6	0	6469	\N
2046	754	7	0	6470	\N
2048	10	1	0	6408	\N
2048	11	2	0	6409	\N
2049	170	1	0	3139	\N
2049	398	2	0	3140	\N
2050	113	1	0	6479	\N
2050	437	2	0	6480	\N
2054	6	1	0	6208	\N
2054	194	2	0	6209	\N
2055	10	1	0	6492	\N
2055	11	2	0	6493	\N
2058	10	1	0	6500	\N
2058	11	2	0	6501	\N
2060	1	1	0	6504	\N
2060	53	2	0	6505	\N
2061	77	1	0	6508	\N
2061	78	2	0	6509	\N
2064	10	1	0	6500	\N
2064	11	2	0	6501	\N
2066	338	1	0	6516	\N
2066	409	2	0	6517	\N
2067	10	1	0	6500	\N
2067	11	2	0	6501	\N
2068	40	1	0	6520	\N
2068	41	2	0	6521	\N
2071	40	1	0	6528	\N
2071	41	2	0	6529	\N
2074	391	1	0	6538	\N
2074	392	2	0	6539	\N
2077	113	1	0	6546	\N
2077	437	2	0	6547	\N
2079	54	1	0	6384	\N
2079	55	2	0	6552	\N
2080	758	1	0	6553	\N
2080	759	2	0	6554	\N
2082	10	1	0	6524	\N
2082	11	2	0	6525	\N
2085	353	1	0	5835	\N
2085	354	2	0	5836	\N
2087	40	3	0	6573	\N
2087	128	4	0	6574	\N
2089	149	3	0	5763	\N
2089	150	4	0	6582	\N
2093	1	1	0	6522	\N
2093	53	2	0	6523	\N
2096	10	2	0	6524	\N
2096	29	3	0	6596	\N
2098	42	2	0	6603	\N
2098	681	3	0	6604	\N
2100	121	1	0	5210	\N
2100	122	2	0	5211	\N
2103	121	1	0	5210	\N
2103	122	2	0	5211	\N
1913	6	1	0	6108	\N
1913	194	2	0	6109	\N
1916	151	1	0	4487	\N
1916	302	2	0	6118	\N
1922	362	1	0	4759	\N
1922	395	2	0	6044	\N
1924	16	1	0	6016	\N
1924	17	2	0	6017	\N
1925	75	1	0	5949	\N
1925	76	2	0	5950	\N
1927	730	4	0	6138	\N
1931	262	2	0	6148	\N
1931	731	3	0	6149	\N
1933	1	1	0	6154	\N
1933	53	2	0	6155	\N
1935	115	3	0	6152	\N
1935	732	4	0	6158	\N
1941	56	1	0	4065	\N
1941	57	2	0	5953	\N
1945	10	1	0	6142	\N
1945	11	2	0	6143	\N
1949	14	1	0	6191	\N
1949	15	2	0	6192	\N
1952	75	1	0	6195	\N
1952	76	2	0	6196	\N
1955	88	2	0	6203	\N
1955	154	3	0	6204	\N
1961	338	2	0	5893	\N
1961	415	3	0	6218	\N
1963	449	1	0	5441	\N
1963	450	2	0	5442	\N
1964	338	1	0	6221	\N
1964	409	2	0	6222	\N
1967	102	2	0	6241	\N
1967	158	3	0	6242	\N
1969	2	2	0	6245	\N
1969	131	3	0	6246	\N
1970	391	1	0	6243	\N
1970	392	2	0	6249	\N
1974	324	1	0	6254	\N
1974	325	2	0	6255	\N
1976	237	1	0	6263	\N
1976	527	2	0	6264	\N
1979	8	3	0	6032	\N
1979	739	4	0	6275	\N
1985	189	2	0	6287	\N
1985	311	3	0	6288	\N
1987	156	1	0	6293	\N
1987	157	2	0	6294	\N
1989	67	1	0	6297	\N
1989	478	2	0	6298	\N
1992	10	1	0	6303	\N
1992	11	2	0	6304	\N
1997	38	2	0	6316	\N
1997	39	3	0	6317	\N
2000	324	1	0	6254	\N
2000	325	2	0	6255	\N
2002	737	42	0	6324	\N
2002	324	54	0	6325	\N
2002	698	55	0	6326	\N
2003	1	1	0	6329	\N
2003	53	2	0	6330	\N
2006	10	2	0	6338	\N
2006	29	3	0	6339	\N
2009	741	1	0	6350	\N
2009	742	2	0	6351	\N
2013	177	1	0	6357	\N
2013	498	2	0	6358	\N
2017	14	1	0	6371	\N
2017	15	2	0	6372	\N
2020	338	1	0	6378	\N
2020	409	2	0	6379	\N
2023	198	2	0	6386	\N
2023	746	3	0	6387	\N
2024	79	2	0	6392	\N
2024	80	3	0	6393	\N
2025	10	2	0	6338	\N
2025	29	3	0	6339	\N
2027	18	1	0	6210	\N
2027	19	2	0	6211	\N
2028	10	1	0	6404	\N
2028	11	2	0	6405	\N
2029	10	1	0	6408	\N
2029	11	2	0	6409	\N
2033	84	2	0	6414	\N
2033	434	3	0	6417	\N
2037	256	2	0	6429	\N
2037	335	3	0	6430	\N
2039	402	1	0	6438	\N
2039	403	2	0	6439	\N
2040	1	2	0	6444	\N
2040	112	3	0	6445	\N
2042	20	1	0	6450	\N
2042	144	2	0	6451	\N
2043	290	1	0	5660	\N
2043	291	2	0	5661	\N
2051	1	2	0	6485	\N
2051	112	3	0	6486	\N
2053	391	1	0	6243	\N
2053	392	2	0	6249	\N
2057	365	1	0	6498	\N
2057	366	2	0	6499	\N
2063	411	1	0	6059	\N
2063	412	2	0	6060	\N
2070	10	1	0	6524	\N
2070	11	2	0	6525	\N
2073	16	2	0	6446	\N
2073	155	3	0	6447	\N
2076	268	1	0	6542	\N
2076	269	2	0	6543	\N
2081	123	1	0	6557	\N
2081	124	2	0	6558	\N
2084	40	1	0	6561	\N
2084	41	2	0	6562	\N
2086	40	1	0	6565	\N
2086	41	2	0	6566	\N
2092	56	1	0	6589	\N
2092	57	2	0	6590	\N
2095	23	2	0	5998	\N
2095	24	3	0	6595	\N
2102	67	1	0	6297	\N
2102	478	2	0	6298	\N
2104	96	1	0	6615	\N
2104	97	2	0	6616	\N
2105	10	1	0	6617	\N
2105	11	2	0	6618	\N
2106	96	1	0	6615	\N
2106	97	2	0	6616	\N
2107	761	101	0	6619	\N
2107	451	126	0	6620	\N
2107	762	127	0	6621	\N
2108	16	1	0	6446	\N
2108	17	2	0	6624	\N
2109	451	1	0	5328	\N
2109	584	2	0	5329	\N
2110	237	1	0	6627	\N
2110	527	2	0	6628	\N
2111	6	1	0	6208	\N
2111	194	2	0	6209	\N
2112	763	1	0	6631	\N
2112	764	2	0	6632	\N
2113	56	1	0	6589	\N
2113	57	2	0	6590	\N
2114	268	1	0	6635	\N
2114	269	2	0	6636	\N
2115	338	2	0	6516	\N
2115	415	3	0	6641	\N
2116	1	2	0	6646	\N
2116	112	3	0	6647	\N
2117	92	2	0	6648	\N
2117	93	3	0	6649	\N
2118	40	1	0	6652	\N
2118	41	2	0	6653	\N
2119	62	1	0	2379	\N
2119	63	2	0	2380	\N
2120	204	1	0	6656	\N
2120	205	2	0	6657	\N
2122	10	1	0	6617	\N
2122	11	2	0	6618	\N
2124	224	2	0	4159	\N
2124	508	3	0	5299	\N
2128	362	1	0	4759	\N
2128	395	2	0	6044	\N
2131	35	1	0	6684	\N
2131	340	2	0	6685	\N
2132	75	1	0	6195	\N
2132	76	2	0	6196	\N
2133	273	1	0	6688	\N
2133	410	2	0	6689	\N
2135	51	1	0	6692	\N
2135	52	2	0	6693	\N
2137	92	1	0	6690	\N
2137	191	2	0	6691	\N
2140	6	1	0	6208	\N
2140	194	2	0	6209	\N
2142	212	1	0	6704	\N
2142	213	2	0	6705	\N
2143	56	1	0	6589	\N
2143	57	2	0	6590	\N
2145	251	1	0	5062	\N
2145	252	2	0	5063	\N
2147	115	2	0	6587	\N
2147	636	3	0	6722	\N
2158	595	2	0	5322	\N
2158	768	3	0	6750	\N
2160	10	1	0	6699	\N
2160	11	2	0	6700	\N
2163	27	1	0	6759	\N
2163	28	2	0	6760	\N
2165	10	1	0	6763	\N
2165	11	2	0	6764	\N
2166	266	1	0	6765	\N
2166	267	2	0	6766	\N
2168	597	2	0	6772	\N
2168	771	3	0	6773	\N
2172	459	3	0	6785	\N
2172	773	4	0	6786	\N
2174	220	1	0	6791	\N
2174	777	2	1	6792	\N
2174	776	2	0	6793	\N
2175	220	1	0	6791	\N
2175	221	2	0	6794	\N
2181	75	2	0	6812	\N
2181	159	3	0	6813	\N
2183	402	1	0	6816	\N
2183	403	2	0	6817	\N
2188	10	1	0	6834	\N
2188	11	2	0	6835	\N
2191	16	1	0	6842	\N
2191	17	2	0	6843	\N
2195	12	62	0	5939	\N
2195	783	63	0	6854	\N
2197	40	1	0	6755	\N
2197	41	2	0	6756	\N
2202	10	1	0	6870	\N
2202	11	2	0	6871	\N
2204	71	2	0	6876	\N
2204	401	3	0	6877	\N
2207	64	2	0	6888	\N
2207	162	3	0	6889	\N
2210	117	2	0	5289	\N
2210	175	3	0	6897	\N
2214	2	1	0	6245	\N
2214	26	2	0	6253	\N
2220	268	1	0	6921	\N
2220	269	2	0	6922	\N
2223	18	1	0	6795	\N
2223	19	2	0	6796	\N
2226	233	1	0	6575	\N
2226	234	2	0	6946	\N
2228	140	1	0	5975	\N
2228	141	2	0	5976	\N
2231	242	0	0	6957	\N
2233	38	2	0	6316	\N
2233	39	3	0	6317	\N
2234	338	2	0	6968	\N
2234	788	3	0	6969	\N
2238	1	1	0	6857	\N
2238	53	2	0	6858	\N
2240	71	2	0	6986	\N
2240	401	3	0	6987	\N
2245	230	0	0	6998	\N
2247	167	0	0	7000	\N
2249	288	0	0	5216	\N
2250	338	0	0	6968	\N
2253	300	3	0	6908	\N
2253	301	4	0	7011	\N
2255	488	3	0	6113	\N
2255	796	4	1	7013	\N
2255	729	4	0	7014	\N
2258	27	1	0	6890	\N
2258	28	2	0	7020	\N
2261	744	2	0	7037	\N
2261	745	2	0	7038	\N
2261	800	3	1	7039	\N
2261	799	3	0	7040	\N
2261	801	4	0	7041	\N
2263	320	4	0	7015	\N
2263	803	5	0	7051	\N
2264	290	2	0	7056	\N
2264	575	3	0	7057	\N
2267	528	1	0	7060	\N
2267	529	2	0	7061	\N
2270	94	1	0	5971	\N
2270	107	2	0	7068	\N
2274	40	2	0	7074	\N
2274	66	3	0	7075	\N
2276	338	1	0	6968	\N
2276	409	2	0	7078	\N
2278	391	1	0	6799	\N
2278	392	2	0	6800	\N
2279	142	1	0	6178	\N
2279	143	2	0	6179	\N
2282	75	2	0	7090	\N
2282	159	3	0	7091	\N
2285	10	1	0	6962	\N
2285	11	2	0	7094	\N
2290	56	0	0	7001	\N
2291	424	1	0	5828	\N
2291	425	2	0	6015	\N
2293	10	3	0	7115	\N
2293	347	4	0	7116	\N
2296	1	2	0	7104	\N
2296	112	3	0	7124	\N
2297	113	1	0	7127	\N
2297	437	2	0	7128	\N
2299	60	1	0	7131	\N
2299	61	2	0	7132	\N
2306	202	1	0	7144	\N
2306	203	2	0	7147	\N
2309	202	0	0	7144	\N
2313	237	13	0	7156	\N
2313	238	14	0	7160	\N
2318	774	0	0	6787	\N
2318	811	0	0	7176	\N
2319	86	1	0	5996	\N
2319	87	2	0	5997	\N
2325	132	1	0	7194	\N
2325	455	2	0	7195	\N
2327	202	2	0	7202	\N
2327	812	3	0	7203	\N
2332	1	3	0	7216	\N
2332	48	4	0	7217	\N
2337	816	0	0	7226	\N
2337	817	0	0	7227	\N
2339	365	1	0	7230	\N
2339	749	2	1	7232	\N
2339	818	2	0	7233	\N
2340	113	3	0	7238	\N
2340	778	4	0	7239	\N
2121	56	1	0	6589	\N
2121	57	2	0	6590	\N
2125	40	2	0	6664	\N
2125	66	3	0	6665	\N
2126	119	1	0	6668	\N
2126	120	2	0	6669	\N
2127	316	1	0	6672	\N
2127	317	2	0	6673	\N
2130	30	1	0	3725	\N
2130	418	2	0	3726	\N
2136	92	3	0	6690	\N
2136	180	4	0	6694	\N
2139	10	1	0	6699	\N
2139	11	2	0	6700	\N
2141	1	1	0	6646	\N
2141	53	2	0	6703	\N
2148	451	1	0	6725	\N
2148	584	2	0	6726	\N
2153	123	1	0	6557	\N
2153	124	2	0	6558	\N
2157	767	3	0	6749	\N
2162	40	1	0	6755	\N
2162	41	2	0	6756	\N
2164	35	1	0	6684	\N
2164	340	2	0	6685	\N
2167	147	2	0	4481	\N
2167	770	3	0	6771	\N
2170	58	1	0	3903	\N
2170	59	2	0	3904	\N
2173	774	0	0	6787	\N
2173	775	0	0	6788	\N
2178	10	1	0	6763	\N
2178	11	2	0	6764	\N
2179	113	3	0	6546	\N
2179	778	4	0	6807	\N
2182	33	1	0	5935	\N
2182	163	2	0	5936	\N
2185	79	2	0	6540	\N
2185	80	3	0	6824	\N
2186	744	13	0	6826	\N
2186	745	13	0	6827	\N
2186	780	14	1	6828	\N
2186	779	14	0	6829	\N
2186	781	15	0	6830	\N
2189	79	1	0	6540	\N
2189	81	2	0	6541	\N
2194	12	3	0	5939	\N
2194	782	4	0	6853	\N
2196	288	1	0	5216	\N
2196	400	2	0	5217	\N
2198	1	1	0	6857	\N
2198	53	2	0	6858	\N
2199	212	3	0	6704	\N
2199	784	4	0	6865	\N
2201	192	1	0	4516	\N
2201	193	2	0	5682	\N
2203	16	1	0	6842	\N
2203	17	2	0	6843	\N
2209	292	2	0	1932	\N
2209	502	3	0	6892	\N
2212	785	1	0	6900	\N
2212	786	2	0	6901	\N
2217	235	1	0	6914	\N
2217	236	2	0	6915	\N
2222	40	1	0	6923	\N
2222	41	2	0	6924	\N
2224	18	5	0	6937	\N
2224	787	6	0	6938	\N
2227	117	1	0	6949	\N
2227	248	2	0	6950	\N
2230	30	1	0	6955	\N
2230	418	2	0	6956	\N
2235	49	2	0	6970	\N
2235	789	3	0	6971	\N
2236	411	1	0	6974	\N
2236	412	2	0	6975	\N
2239	77	2	0	6980	\N
2239	216	3	0	6981	\N
2242	10	2	0	6962	\N
2242	792	3	0	6995	\N
2248	56	0	0	7001	\N
2251	200	3	0	7008	\N
2251	219	4	0	7009	\N
2256	320	3	0	7015	\N
2256	797	4	0	7016	\N
2257	181	1	0	6751	\N
2257	530	2	0	7019	\N
2260	132	2	0	7035	\N
2260	133	3	0	7036	\N
2262	765	4	0	7049	\N
2262	802	5	0	7050	\N
2265	10	2	0	6962	\N
2265	29	3	0	6963	\N
2269	260	2	0	7064	\N
2269	419	3	0	7065	\N
2271	40	0	0	7069	\N
2272	338	2	0	6968	\N
2272	415	3	0	7072	\N
2275	804	1	0	7076	\N
2275	805	2	0	7077	\N
2280	212	1	0	7083	\N
2280	213	2	0	7084	\N
2281	241	10	0	1822	\N
2281	806	11	0	7085	\N
2284	84	0	0	6868	\N
2287	411	1	0	6974	\N
2287	412	2	0	6975	\N
2294	56	3	0	7117	\N
2294	475	4	0	7118	\N
2301	807	85	0	7134	\N
2301	60	126	0	7135	\N
2301	808	127	0	7136	\N
2302	27	1	0	6890	\N
2302	28	2	0	7020	\N
2305	202	0	0	7144	\N
2307	202	0	0	7144	\N
2311	237	3	0	7156	\N
2311	809	4	0	7157	\N
2314	8	1	0	7163	\N
2314	9	2	0	7164	\N
2317	424	2	0	7174	\N
2317	520	3	0	7175	\N
2320	56	1	0	7179	\N
2320	57	2	0	7180	\N
2321	288	1	0	5216	\N
2321	400	2	0	5217	\N
2324	10	1	0	7190	\N
2324	11	2	0	7191	\N
2328	51	2	0	7204	\N
2328	524	3	0	7205	\N
2331	147	3	0	4481	\N
2331	148	4	0	7215	\N
2334	132	3	0	7219	\N
2334	814	4	0	7220	\N
2335	244	3	0	6818	\N
2335	815	4	0	7221	\N
2338	365	1	0	7230	\N
2338	366	2	0	7231	\N
2123	10	1	0	6617	\N
2123	11	2	0	6618	\N
2129	44	1	0	6678	\N
2129	45	2	0	6679	\N
2134	92	1	0	6690	\N
2134	191	2	0	6691	\N
2138	170	1	0	6697	\N
2138	398	2	0	6698	\N
2144	51	1	0	6692	\N
2144	52	2	0	6693	\N
2146	56	2	0	6716	\N
2146	169	3	0	6717	\N
2149	765	1	0	6729	\N
2149	766	2	0	6730	\N
2150	324	2	0	6254	\N
2150	486	3	0	6735	\N
2151	324	0	0	4908	\N
2152	16	2	0	6446	\N
2152	155	3	0	6447	\N
2154	132	2	0	6742	\N
2154	133	3	0	6743	\N
2156	147	2	0	4481	\N
2156	516	3	0	6748	\N
2159	181	2	0	6751	\N
2159	769	3	0	6752	\N
2161	113	1	0	6546	\N
2161	437	2	0	6547	\N
2169	595	2	0	5322	\N
2169	772	3	0	6774	\N
2171	16	1	0	6777	\N
2171	17	2	0	6778	\N
2176	18	1	0	6795	\N
2176	19	2	0	6796	\N
2177	391	1	0	6799	\N
2177	392	2	0	6800	\N
2180	181	2	0	6751	\N
2180	769	3	0	6752	\N
2184	244	1	0	6818	\N
2184	245	2	0	6819	\N
2187	320	2	0	6359	\N
2187	321	3	0	6831	\N
2190	56	1	0	6838	\N
2190	57	2	0	6839	\N
2192	189	1	0	6844	\N
2192	190	2	0	6845	\N
2193	12	4	0	5939	\N
2193	357	5	0	6852	\N
2200	84	1	0	6868	\N
2200	85	2	0	6869	\N
2205	40	2	0	6878	\N
2205	66	3	0	6879	\N
2206	266	1	0	6882	\N
2206	267	2	0	6883	\N
2208	27	2	0	6890	\N
2208	619	3	0	6891	\N
2211	117	1	0	5289	\N
2211	248	2	0	5290	\N
2213	75	1	0	6904	\N
2213	76	2	0	6905	\N
2215	300	1	0	6908	\N
2215	355	2	0	6909	\N
2216	12	3	0	6912	\N
2216	782	4	0	6913	\N
2218	12	1	0	6912	\N
2218	13	2	0	6916	\N
2219	92	1	0	6690	\N
2219	191	2	0	6691	\N
2221	71	1	0	6876	\N
2221	72	2	0	5800	\N
2225	260	2	0	6167	\N
2225	419	3	0	6943	\N
2229	132	1	0	6953	\N
2229	455	2	0	6954	\N
2232	10	2	0	6962	\N
2232	29	3	0	6963	\N
2237	40	1	0	6923	\N
2237	41	2	0	6924	\N
2241	790	3	0	6989	\N
2241	791	4	0	6990	\N
2243	1	2	0	6857	\N
2243	444	3	0	6996	\N
2244	102	0	0	6997	\N
2252	722	0	0	5992	\N
2252	794	0	0	7010	\N
2254	300	3	0	6908	\N
2254	795	4	0	7012	\N
2259	453	4	0	7029	\N
2259	798	5	0	7030	\N
2266	326	2	0	6398	\N
2266	747	3	0	6399	\N
2268	262	0	0	6193	\N
2273	156	2	0	6293	\N
2273	571	3	0	7073	\N
2277	224	1	0	4159	\N
2277	225	2	0	4160	\N
2283	84	1	0	6868	\N
2283	85	2	0	6869	\N
2286	10	2	0	7099	\N
2286	29	3	0	7100	\N
2288	258	1	0	4636	\N
2288	309	2	0	7103	\N
2289	1	0	0	7104	\N
2292	14	3	0	7113	\N
2292	306	4	0	7114	\N
2295	367	2	0	5104	\N
2295	651	3	0	7123	\N
2298	79	1	0	6540	\N
2298	81	2	0	6541	\N
2300	360	1	0	6125	\N
2300	479	2	0	6126	\N
2303	230	1	0	6998	\N
2303	287	2	0	7139	\N
2304	8	1	0	7142	\N
2304	9	2	0	7143	\N
2308	40	1	0	7148	\N
2308	41	2	0	7149	\N
2310	202	0	0	7144	\N
2312	82	3	0	7158	\N
2312	810	4	0	7159	\N
2315	391	1	0	6799	\N
2315	392	2	0	6800	\N
2316	40	2	0	7148	\N
2316	66	3	0	7169	\N
2322	10	1	0	7115	\N
2322	11	2	0	7183	\N
2323	173	1	0	7186	\N
2323	396	2	0	7187	\N
2326	1	2	0	7200	\N
2326	112	3	0	7201	\N
2329	56	2	0	7206	\N
2329	169	3	0	7207	\N
2330	597	0	0	7208	\N
2333	595	3	0	5322	\N
2333	813	4	0	7218	\N
2336	564	4	0	7224	\N
2336	40	5	0	7225	\N
2341	113	3	0	7238	\N
2341	778	4	0	7239	\N
2342	819	2	0	7244	\N
2342	820	3	0	7245	\N
2343	30	2	0	6955	\N
2343	31	3	0	7246	\N
2344	40	3	0	7253	\N
2344	128	4	0	7254	\N
2345	121	1	0	5210	\N
2345	122	2	0	5211	\N
2346	164	1	0	7257	\N
2346	165	2	0	7258	\N
2347	360	1	0	7261	\N
2347	479	2	0	7262	\N
2348	115	1	0	7265	\N
2348	116	2	0	7266	\N
2349	2	2	0	7271	\N
2349	131	3	0	7272	\N
2350	121	2	0	7273	\N
2350	625	3	0	7274	\N
2351	220	2	0	7275	\N
2351	821	3	0	7276	\N
2353	365	1	0	7230	\N
2353	366	2	0	7231	\N
2356	320	2	0	7015	\N
2356	321	3	0	7287	\N
2359	360	1	0	7297	\N
2359	479	2	0	7298	\N
2362	824	31	0	7303	\N
2362	822	126	0	7304	\N
2362	825	127	0	7305	\N
2364	189	3	0	7313	\N
2364	827	4	0	7314	\N
2365	353	1	0	5835	\N
2365	354	2	0	5836	\N
2374	228	1	0	7340	\N
2374	229	2	0	7341	\N
2376	79	1	0	6540	\N
2376	81	2	0	6541	\N
2377	142	1	0	6178	\N
2377	143	2	0	6179	\N
2380	117	1	0	6949	\N
2380	248	2	0	6950	\N
2383	94	1	0	5971	\N
2383	107	2	0	7068	\N
2386	137	1	0	7362	\N
2386	138	2	0	7363	\N
2389	10	1	0	7299	\N
2389	11	2	0	7300	\N
2395	266	4	0	7387	\N
2395	832	5	0	7388	\N
2398	1	1	0	7399	\N
2398	53	2	0	7400	\N
2401	79	1	0	7405	\N
2401	81	2	0	7406	\N
2403	18	1	0	7407	\N
2403	19	2	0	7408	\N
2404	20	1	0	7411	\N
2404	144	2	0	7412	\N
2407	10	2	0	7421	\N
2407	29	3	0	7422	\N
2409	173	1	0	7425	\N
2409	396	2	0	7426	\N
2410	391	1	0	7401	\N
2410	392	2	0	7402	\N
2413	90	1	0	7438	\N
2413	344	2	0	7439	\N
2416	360	2	0	7450	\N
2416	510	3	0	7451	\N
2419	164	3	0	7257	\N
2419	307	4	0	7459	\N
2425	51	1	0	7204	\N
2425	52	2	0	7479	\N
2430	102	1	0	6997	\N
2430	103	2	0	7487	\N
2431	10	1	0	7490	\N
2431	11	2	0	7491	\N
2434	251	2	0	7498	\N
2434	828	3	0	7499	\N
2438	10	3	0	7490	\N
2438	347	4	0	7510	\N
2440	94	1	0	5971	\N
2440	107	2	0	7068	\N
2443	94	1	0	7517	\N
2443	107	2	0	7518	\N
2447	10	1	0	7529	\N
2447	11	2	0	7530	\N
2454	46	1	0	1086	\N
2454	839	2	0	7547	\N
2456	208	4	0	3619	\N
2456	491	5	0	7558	\N
2459	90	1	0	7567	\N
2459	344	2	0	7568	\N
2465	69	1	0	7585	\N
2465	70	2	0	7586	\N
2468	4	1	0	7597	\N
2468	25	2	0	7598	\N
2471	251	1	0	7498	\N
2471	252	2	0	7603	\N
2475	840	5	0	7618	\N
2475	260	6	0	7619	\N
2477	1	1	0	7606	\N
2477	53	2	0	7607	\N
2480	132	2	0	7219	\N
2480	133	3	0	7632	\N
2481	75	0	0	7415	\N
2482	145	2	0	7571	\N
2482	331	3	0	7637	\N
2485	843	98	0	7640	\N
2485	844	103	0	7643	\N
2485	845	103	0	7644	\N
2485	847	104	1	7645	\N
2485	846	104	0	7646	\N
2487	435	1	0	7649	\N
2487	436	2	0	7650	\N
2489	338	1	0	6968	\N
2489	409	2	0	7078	\N
2490	228	1	0	7655	\N
2490	229	2	0	7656	\N
2493	16	1	0	7663	\N
2493	17	2	0	7664	\N
2496	121	4	0	7678	\N
2496	848	5	0	7679	\N
2501	189	69	0	7313	\N
2501	850	70	0	7697	\N
2502	285	4	0	7705	\N
2502	851	5	0	7706	\N
2507	208	2	0	7601	\N
2507	854	3	0	7721	\N
2508	391	3	0	7401	\N
2508	581	4	0	7728	\N
2510	202	1	0	7733	\N
2510	203	2	0	7734	\N
2512	64	2	0	6888	\N
2512	162	3	0	6889	\N
2514	10	1	0	7747	\N
2514	11	2	0	7748	\N
2515	60	1	0	7131	\N
2515	61	2	0	7132	\N
2518	12	3	0	7759	\N
2518	782	4	0	7760	\N
2519	64	3	0	7761	\N
2519	130	4	0	7762	\N
2522	60	1	0	7776	\N
2522	61	2	0	7777	\N
2525	242	2	0	7794	\N
2525	620	3	0	7795	\N
2528	64	1	0	7761	\N
2528	65	2	0	7802	\N
2530	336	1	0	6335	\N
2530	356	2	0	6375	\N
2538	137	2	0	7362	\N
2538	866	3	0	7830	\N
2544	10	1	0	7843	\N
2544	11	2	0	7844	\N
2546	73	1	0	7849	\N
2546	74	2	0	7850	\N
2550	1	1	0	7863	\N
2550	53	2	0	7864	\N
2553	868	68	0	7873	\N
2553	40	81	0	7874	\N
2553	869	82	0	7875	\N
2554	391	2	0	7880	\N
2554	406	3	0	7881	\N
2557	241	2	0	7892	\N
2557	281	3	0	7893	\N
2560	164	2	0	7659	\N
2560	226	3	0	7904	\N
2563	113	2	0	7909	\N
2563	114	3	0	7910	\N
2567	192	1	0	7923	\N
2567	193	2	0	7924	\N
2573	75	2	0	7947	\N
2573	159	3	0	7948	\N
2576	1	1	0	7961	\N
2576	53	2	0	7962	\N
2579	230	3	0	7971	\N
2579	876	4	0	7972	\N
2352	123	2	0	7277	\N
2352	384	3	0	7278	\N
2355	256	2	0	7285	\N
2355	335	3	0	7286	\N
2358	228	1	0	7293	\N
2358	229	2	0	7294	\N
2360	10	1	0	7299	\N
2360	11	2	0	7300	\N
2361	822	1	0	7301	\N
2361	823	2	0	7302	\N
2366	56	1	0	7206	\N
2366	57	2	0	7317	\N
2367	2	1	0	7320	\N
2367	26	2	0	7321	\N
2369	23	1	0	5998	\N
2369	217	2	0	5999	\N
2370	56	2	0	7326	\N
2370	169	3	0	7327	\N
2373	40	1	0	7336	\N
2373	41	2	0	7337	\N
2379	73	1	0	7353	\N
2379	74	2	0	7354	\N
2381	60	1	0	7131	\N
2381	61	2	0	7132	\N
2385	290	1	0	7056	\N
2385	291	2	0	7361	\N
2387	170	1	0	7364	\N
2387	398	2	0	7365	\N
2391	241	0	0	1822	\N
2393	262	1	0	7374	\N
2393	263	2	0	7375	\N
2394	262	2	0	7374	\N
2394	731	3	0	7378	\N
2397	92	2	0	7395	\N
2397	93	3	0	7396	\N
2399	100	1	0	6376	\N
2399	160	2	0	6377	\N
2402	186	1	0	5595	\N
2402	187	2	0	5699	\N
2406	75	1	0	7415	\N
2406	76	2	0	7416	\N
2411	42	1	0	7429	\N
2411	43	2	0	7430	\N
2412	322	2	0	5046	\N
2412	833	3	0	7435	\N
2414	10	1	0	7440	\N
2414	11	2	0	7441	\N
2415	353	1	0	7444	\N
2415	354	2	0	7445	\N
2417	353	2	0	7452	\N
2417	755	3	0	7453	\N
2420	96	3	0	7460	\N
2420	834	4	0	7461	\N
2421	88	1	0	6203	\N
2421	89	2	0	7464	\N
2424	835	1	0	7475	\N
2424	836	2	0	7476	\N
2426	16	1	0	6842	\N
2426	17	2	0	6843	\N
2427	186	1	0	5595	\N
2427	187	2	0	5699	\N
2432	90	1	0	7438	\N
2432	344	2	0	7439	\N
2436	151	3	0	7506	\N
2436	152	4	0	7507	\N
2439	402	1	0	6816	\N
2439	403	2	0	6817	\N
2441	2	1	0	7320	\N
2441	26	2	0	7321	\N
2444	10	1	0	7521	\N
2444	11	2	0	7522	\N
2445	2	1	0	7320	\N
2445	26	2	0	7321	\N
2446	273	1	0	7525	\N
2446	410	2	0	7526	\N
2450	237	1	0	7156	\N
2450	527	2	0	7537	\N
2455	18	1	0	7548	\N
2455	19	2	0	7549	\N
2457	94	1	0	7561	\N
2457	107	2	0	7562	\N
2458	228	1	0	7565	\N
2458	229	2	0	7566	\N
2460	145	1	0	7571	\N
2460	153	2	0	7572	\N
2462	237	2	0	7579	\N
2462	319	3	0	7580	\N
2463	30	2	0	6955	\N
2463	31	3	0	7246	\N
2464	1	1	0	7583	\N
2464	53	2	0	7584	\N
2467	411	2	0	7593	\N
2467	582	3	0	7594	\N
2470	208	1	0	7601	\N
2470	209	2	0	7602	\N
2473	1	1	0	7606	\N
2473	53	2	0	7607	\N
2478	365	1	0	7515	\N
2478	366	2	0	7516	\N
2483	391	2	0	7401	\N
2483	406	3	0	7638	\N
2486	96	3	0	7460	\N
2486	834	4	0	7461	\N
2488	262	1	0	7651	\N
2488	263	2	0	7652	\N
2494	1	2	0	7606	\N
2494	112	3	0	7669	\N
2498	10	1	0	7683	\N
2498	11	2	0	7684	\N
2499	56	1	0	7326	\N
2499	57	2	0	7687	\N
2500	189	4	0	7313	\N
2500	849	5	0	7696	\N
2503	853	5	0	7708	\N
2504	33	1	0	7711	\N
2504	163	2	0	7712	\N
2506	90	1	0	7567	\N
2506	344	2	0	7568	\N
2509	214	3	0	7729	\N
2509	330	4	0	7730	\N
2511	92	2	0	7739	\N
2511	93	3	0	7740	\N
2513	1	1	0	7743	\N
2513	53	2	0	7744	\N
2516	338	1	0	6968	\N
2516	409	2	0	7078	\N
2517	1	3	0	7757	\N
2517	48	4	0	7758	\N
2520	273	4	0	7525	\N
2520	855	5	0	7771	\N
2521	181	4	0	7772	\N
2521	856	5	0	7773	\N
2523	212	1	0	7780	\N
2523	213	2	0	7781	\N
2531	260	1	0	7809	\N
2531	261	2	0	7810	\N
2534	92	2	0	7739	\N
2537	135	2	0	7828	\N
2537	865	3	0	7829	\N
2540	140	1	0	7482	\N
2540	141	2	0	7483	\N
2543	10	1	0	7835	\N
2543	11	2	0	7836	\N
2549	391	4	0	7401	\N
2549	539	5	0	7860	\N
2552	14	1	0	7113	\N
2552	15	2	0	7872	\N
2556	4	1	0	7886	\N
2556	25	2	0	7887	\N
2559	58	1	0	7898	\N
2534	863	5	0	138403	\N
2534	864	5	1	138404	\N
2534	860	3	1	138400	\N
2534	862	4	1	138402	\N
2357	73	1	0	6174	\N
2357	74	2	0	7290	\N
2363	451	3	0	7311	\N
2363	826	4	0	7312	\N
2368	151	1	0	6309	\N
2368	302	2	0	6310	\N
2371	251	2	0	7328	\N
2371	828	3	0	7329	\N
2372	40	1	0	7332	\N
2372	41	2	0	7333	\N
2375	1	1	0	7216	\N
2375	53	2	0	7344	\N
2378	829	1	0	7349	\N
2378	830	2	0	7350	\N
2382	322	1	0	5046	\N
2382	323	2	0	5047	\N
2384	40	1	0	7357	\N
2384	41	2	0	7358	\N
2388	135	1	0	4947	\N
2388	136	2	0	4948	\N
2390	121	2	0	7273	\N
2390	831	3	0	7371	\N
2392	40	1	0	7357	\N
2392	41	2	0	7358	\N
2396	1	1	0	7216	\N
2396	53	2	0	7344	\N
2400	391	1	0	7401	\N
2400	392	2	0	7402	\N
2405	288	1	0	5216	\N
2405	400	2	0	5217	\N
2408	353	1	0	5835	\N
2408	354	2	0	5836	\N
2418	54	2	0	6384	\N
2418	485	3	0	6385	\N
2422	10	1	0	7465	\N
2422	11	2	0	7466	\N
2423	360	2	0	7471	\N
2423	510	3	0	7472	\N
2428	140	1	0	7482	\N
2428	141	2	0	7483	\N
2429	202	1	0	7202	\N
2429	203	2	0	7486	\N
2433	16	1	0	7492	\N
2433	17	2	0	7493	\N
2435	206	2	0	5509	\N
2435	693	3	0	5510	\N
2437	108	3	0	7508	\N
2437	837	4	0	7509	\N
2442	365	1	0	7515	\N
2442	366	2	0	7516	\N
2448	137	1	0	7362	\N
2448	138	2	0	7363	\N
2449	135	1	0	7533	\N
2449	136	2	0	7534	\N
2451	38	1	0	7538	\N
2451	399	2	0	7539	\N
2452	192	2	0	4516	\N
2452	838	3	0	7544	\N
2453	54	1	0	6384	\N
2453	55	2	0	6552	\N
2461	326	1	0	7573	\N
2461	327	2	0	7574	\N
2466	16	1	0	7492	\N
2466	17	2	0	7493	\N
2469	88	1	0	6203	\N
2469	89	2	0	7464	\N
2472	300	1	0	6908	\N
2472	355	2	0	6909	\N
2474	210	1	0	5761	\N
2474	211	2	0	5762	\N
2476	360	1	0	7622	\N
2476	479	2	0	7623	\N
2479	842	2	0	7627	\N
2484	241	0	0	7639	\N
2491	164	1	0	7659	\N
2491	165	2	0	7660	\N
2492	75	1	0	7661	\N
2492	76	2	0	7662	\N
2495	145	2	0	7571	\N
2495	331	3	0	7637	\N
2497	108	1	0	7508	\N
2497	109	2	0	7682	\N
2505	58	1	0	3903	\N
2505	59	2	0	3904	\N
2524	75	3	0	7788	\N
2524	857	4	0	7789	\N
2526	79	1	0	7798	\N
2526	81	2	0	7799	\N
2527	110	1	0	7800	\N
2527	134	2	0	7801	\N
2529	16	1	0	7663	\N
2529	17	2	0	7664	\N
2532	367	51	0	5104	\N
2532	858	52	0	7813	\N
2533	367	0	0	5104	\N
2535	92	2	0	7739	\N
2535	93	3	0	7740	\N
2536	528	1	0	7060	\N
2536	529	2	0	7061	\N
2539	2	1	0	7833	\N
2539	26	2	0	7834	\N
2541	10	1	0	7835	\N
2541	11	2	0	7836	\N
2542	64	1	0	7761	\N
2542	65	2	0	7802	\N
2545	210	1	0	7847	\N
2545	211	2	0	7848	\N
2547	73	0	0	7849	\N
2548	23	4	0	5998	\N
2548	867	5	0	7859	\N
2551	27	2	0	7869	\N
2551	619	3	0	7020	\N
2555	170	2	0	7882	\N
2555	718	3	0	7883	\N
2558	2	1	0	7833	\N
2558	26	2	0	7834	\N
2561	870	41	0	7905	\N
2561	113	47	0	7906	\N
2561	871	48	0	7907	\N
2570	256	1	0	7285	\N
2570	257	2	0	7931	\N
2571	1	2	0	7925	\N
2571	112	3	0	7936	\N
2574	241	2	0	7953	\N
2574	281	3	0	7954	\N
2577	71	1	0	7963	\N
2577	72	2	0	7964	\N
2580	90	3	0	7973	\N
2580	877	4	0	7974	\N
2583	1	1	0	7981	\N
2583	53	2	0	7982	\N
2586	879	0	0	7988	\N
2590	16	2	0	8000	\N
2590	155	3	0	8001	\N
2591	391	1	0	7977	\N
2591	392	2	0	7978	\N
2593	577	1	0	8007	\N
2593	578	2	0	8008	\N
2594	881	2	0	8010	\N
2596	94	2	0	8015	\N
2596	95	3	0	8016	\N
2597	10	2	0	8017	\N
2597	29	3	0	8018	\N
2559	59	2	0	7899	\N
2562	135	2	0	7828	\N
2562	196	3	0	7908	\N
2564	137	2	0	7911	\N
2564	197	3	0	7912	\N
2565	2	1	0	7915	\N
2565	26	2	0	7916	\N
2566	316	1	0	7919	\N
2566	317	2	0	7920	\N
2568	1	1	0	7925	\N
2568	53	2	0	7926	\N
2569	872	11	0	7927	\N
2569	844	13	0	7643	\N
2569	873	13	0	7928	\N
2569	875	14	1	7929	\N
2569	874	14	0	7930	\N
2572	192	2	0	7941	\N
2572	838	3	0	7942	\N
2575	56	1	0	7957	\N
2575	57	2	0	7958	\N
2581	391	1	0	7977	\N
2581	392	2	0	7978	\N
2589	69	2	0	7585	\N
2589	500	3	0	7999	\N
2592	167	1	0	7000	\N
2592	533	2	0	8006	\N
2595	290	2	0	7056	\N
2595	575	3	0	7057	\N
2582	173	1	0	7425	\N
2582	396	2	0	7426	\N
2584	2	1	0	7983	\N
2584	26	2	0	7984	\N
2585	75	1	0	7985	\N
2585	76	2	0	7986	\N
2587	119	1	0	7991	\N
2587	120	2	0	7992	\N
2588	56	1	0	7993	\N
2588	57	2	0	7994	\N
2598	79	1	0	7798	\N
2598	81	2	0	7799	\N
2599	8	0	0	7163	\N
2600	54	0	0	6384	\N
2601	82	0	0	8021	\N
2603	1	2	0	7981	\N
2603	112	3	0	8026	\N
2604	6	2	0	6208	\N
2604	886	5	0	8031	\N
2605	200	2	0	8036	\N
2605	887	3	0	8037	\N
2606	16	2	0	8000	\N
2606	155	3	0	8001	\N
2607	119	1	0	8040	\N
2607	120	2	0	8041	\N
2608	16	1	0	8000	\N
2608	17	2	0	8042	\N
2609	113	31	0	8043	\N
2609	888	32	0	8044	\N
2610	12	2	0	7759	\N
2610	433	3	0	8049	\N
2611	113	2	0	8050	\N
2611	114	3	0	8051	\N
2612	10	1	0	8017	\N
2612	11	2	0	8054	\N
2613	140	5	0	8065	\N
2613	889	6	0	8066	\N
2614	220	5	0	7275	\N
2614	890	6	0	8067	\N
2615	90	1	0	8070	\N
2615	344	2	0	8071	\N
2616	73	1	0	7849	\N
2616	74	2	0	7850	\N
2618	338	1	0	6968	\N
2618	409	2	0	7078	\N
2619	10	1	0	8076	\N
2619	11	2	0	8077	\N
2620	338	0	0	6968	\N
2621	18	1	0	8078	\N
2621	19	2	0	8079	\N
2622	262	1	0	7651	\N
2622	263	2	0	7652	\N
2623	224	2	0	8084	\N
2623	508	3	0	8085	\N
2624	119	2	0	8040	\N
2624	891	3	0	8090	\N
2625	1	1	0	7981	\N
2625	53	2	0	7982	\N
2626	402	1	0	6816	\N
2626	403	2	0	6817	\N
2627	167	1	0	7000	\N
2627	533	2	0	8006	\N
2628	8	1	0	7163	\N
2628	9	2	0	7164	\N
2629	75	1	0	8097	\N
2629	76	2	0	8098	\N
2630	145	2	0	7571	\N
2630	331	3	0	7637	\N
2631	44	2	0	8103	\N
2631	161	3	0	8104	\N
2632	44	1	0	8103	\N
2632	45	2	0	8107	\N
2633	10	1	0	8076	\N
2633	11	2	0	8077	\N
2634	42	1	0	8110	\N
2634	43	2	0	8111	\N
2635	338	1	0	6968	\N
2635	409	2	0	7078	\N
2636	411	1	0	8114	\N
2636	412	2	0	8115	\N
2637	16	1	0	8116	\N
2637	17	2	0	8117	\N
2638	1	1	0	8120	\N
2638	53	2	0	8121	\N
2639	119	1	0	8122	\N
2639	120	2	0	8123	\N
2640	6	1	0	8124	\N
2640	194	2	0	8125	\N
2641	206	1	0	8126	\N
2641	207	2	0	8127	\N
2642	10	1	0	8076	\N
2642	11	2	0	8077	\N
2643	88	2	0	8134	\N
2643	154	3	0	8135	\N
2644	12	1	0	8138	\N
2644	13	2	0	8139	\N
2645	411	1	0	8142	\N
2645	412	2	0	8143	\N
2646	892	1	0	8144	\N
2646	893	2	0	8145	\N
2647	35	1	0	6684	\N
2647	340	2	0	6685	\N
2648	69	1	0	8148	\N
2648	70	2	0	8149	\N
2649	167	1	0	7000	\N
2649	533	2	0	8006	\N
2650	235	1	0	6914	\N
2650	236	2	0	6915	\N
2651	6	2	0	8156	\N
2651	179	3	0	8157	\N
2652	212	2	0	8158	\N
2652	566	3	0	8159	\N
2653	16	2	0	8116	\N
2653	155	3	0	8160	\N
2654	189	5	0	8171	\N
2654	894	6	0	8172	\N
2655	895	36	0	8173	\N
2655	189	87	0	8174	\N
2655	897	88	1	8175	\N
2655	896	88	0	8176	\N
2655	898	89	0	8177	\N
2656	79	1	0	8180	\N
2656	81	2	0	8181	\N
2657	453	1	0	8182	\N
2657	454	2	0	8183	\N
2658	16	1	0	8116	\N
2658	17	2	0	8117	\N
2659	230	1	0	7971	\N
2659	287	2	0	8186	\N
2660	102	1	0	6997	\N
2660	103	2	0	7487	\N
2661	102	1	0	6997	\N
2661	103	2	0	7487	\N
2662	6	2	0	8191	\N
2662	179	3	0	8192	\N
2663	338	2	0	6968	\N
2663	415	3	0	7072	\N
2664	285	1	0	8195	\N
2664	286	2	0	8196	\N
2665	258	1	0	4636	\N
2665	309	2	0	7103	\N
2666	16	1	0	8197	\N
2666	17	2	0	8198	\N
2667	212	1	0	8158	\N
2667	213	2	0	8201	\N
2668	115	2	0	8206	\N
2668	636	3	0	8207	\N
2669	119	2	0	8122	\N
2669	891	3	0	8208	\N
2670	338	2	0	6968	\N
2670	415	3	0	7072	\N
2671	67	1	0	6297	\N
2671	478	2	0	6298	\N
2604	883	3	1	138406	\N
2604	885	4	1	14606	\N
2672	92	1	0	8213	\N
2672	191	2	0	8214	\N
2674	73	1	0	8219	\N
2674	74	2	0	8220	\N
2677	841	4	0	8231	\N
2677	900	5	0	8232	\N
2680	88	1	0	8245	\N
2680	89	2	0	8246	\N
2683	82	1	0	8251	\N
2683	83	2	0	8252	\N
2686	242	1	0	8258	\N
2686	253	2	0	8259	\N
2689	10	1	0	8264	\N
2689	11	2	0	8265	\N
2692	1	2	0	8120	\N
2692	112	3	0	8274	\N
2695	453	2	0	8182	\N
2695	902	3	0	8284	\N
2698	135	1	0	7828	\N
2698	136	2	0	8289	\N
2701	117	1	0	8295	\N
2701	248	2	0	8296	\N
2704	167	2	0	8306	\N
2704	168	3	0	8307	\N
2707	316	1	0	8316	\N
2707	317	2	0	8317	\N
2710	44	1	0	8324	\N
2710	45	2	0	8325	\N
2713	44	0	0	8324	\N
2716	10	1	0	8264	\N
2716	11	2	0	8265	\N
2719	1	2	0	8351	\N
2719	112	3	0	8352	\N
2722	16	1	0	8361	\N
2722	17	2	0	8362	\N
2724	1	2	0	8351	\N
2724	112	3	0	8352	\N
2725	117	2	0	8295	\N
2725	175	3	0	8368	\N
2728	906	28	0	8372	\N
2728	117	93	0	8373	\N
2728	907	94	0	8374	\N
2731	233	2	0	8386	\N
2731	910	3	0	8387	\N
2734	79	2	0	8180	\N
2734	80	3	0	8396	\N
2737	424	1	0	8401	\N
2737	425	2	0	8402	\N
2740	338	1	0	8408	\N
2740	409	2	0	8409	\N
2743	914	48	0	8416	\N
2743	23	71	0	8417	\N
2743	915	72	0	8418	\N
2746	94	1	0	8015	\N
2746	107	2	0	8425	\N
2749	121	1	0	8428	\N
2749	122	2	0	8431	\N
2752	121	0	0	8428	\N
2756	121	1	0	8428	\N
2756	122	2	0	8431	\N
2760	916	117	1	8441	\N
2760	859	117	0	8442	\N
2760	918	118	1	8443	\N
2760	917	118	0	8444	\N
2760	920	119	1	8445	\N
2760	919	119	0	8446	\N
2760	921	120	1	8447	\N
2760	885	120	0	8448	\N
2760	922	121	0	8449	\N
2760	844	126	0	8450	\N
2760	845	126	0	8451	\N
2760	924	127	1	8452	\N
2760	923	127	0	8453	\N
2761	383	2	0	7114	\N
2761	14	5	0	8462	\N
2761	383	6	0	8463	\N
2764	135	1	0	7828	\N
2764	136	2	0	8289	\N
2767	200	4	0	8229	\N
2767	899	5	0	8230	\N
2772	1	1	0	8423	\N
2772	53	2	0	8424	\N
2775	222	2	0	8314	\N
2775	232	3	0	8503	\N
2777	241	2	0	8504	\N
2777	281	3	0	8505	\N
2781	4	1	0	8515	\N
2781	25	2	0	8516	\N
2784	214	1	0	8521	\N
2784	215	2	0	8522	\N
2787	94	2	0	8015	\N
2787	95	3	0	8016	\N
2790	27	1	0	8540	\N
2790	28	2	0	8541	\N
2793	453	1	0	8548	\N
2793	454	2	0	8549	\N
2796	51	1	0	8554	\N
2796	52	2	0	8555	\N
2799	1	4	0	8552	\N
2799	422	5	0	8568	\N
2808	71	2	0	7963	\N
2808	401	3	0	8598	\N
2811	145	1	0	8605	\N
2811	153	2	0	8606	\N
2814	189	0	0	7313	\N
2817	119	2	0	8122	\N
2817	891	3	0	8208	\N
2820	10	0	0	8017	\N
2822	75	2	0	8586	\N
2822	159	3	0	8621	\N
2825	1	2	0	8627	\N
2825	283	3	0	8628	\N
2828	96	8	0	8421	\N
2828	933	9	0	8647	\N
2831	100	0	0	6376	\N
2836	2	4	0	8667	\N
2836	935	5	0	8668	\N
2837	1	0	0	8669	\N
2840	326	1	0	8680	\N
2840	327	2	0	8681	\N
2843	170	1	0	8695	\N
2843	398	2	0	8696	\N
2846	16	1	0	8511	\N
2846	17	2	0	8705	\N
2849	181	1	0	8713	\N
2849	530	2	0	8714	\N
2852	189	1	0	8720	\N
2852	190	2	0	8721	\N
2855	75	2	0	8728	\N
2855	159	3	0	8729	\N
2860	75	3	0	8728	\N
2860	713	4	0	8742	\N
2861	119	1	0	8745	\N
2861	120	2	0	8746	\N
2865	62	1	0	2379	\N
2865	63	2	0	2380	\N
2868	1	0	0	8766	\N
2871	35	2	0	8773	\N
2871	36	3	0	8774	\N
2874	10	0	0	8527	\N
2877	88	1	0	8781	\N
2877	89	2	0	8782	\N
2889	16	1	0	8801	\N
2889	17	2	0	8802	\N
2891	173	1	0	8807	\N
2891	396	2	0	8808	\N
2893	82	1	0	8810	\N
2893	83	2	0	8811	\N
2673	10	1	0	8215	\N
2673	11	2	0	8216	\N
2676	841	4	0	8231	\N
2676	900	5	0	8232	\N
2679	528	1	0	8241	\N
2679	529	2	0	8242	\N
2682	320	94	0	8247	\N
2682	901	95	0	8248	\N
2685	316	1	0	8256	\N
2685	317	2	0	8257	\N
2688	125	1	0	8262	\N
2688	195	2	0	8263	\N
2691	75	1	0	8268	\N
2691	76	2	0	8269	\N
2694	56	1	0	8278	\N
2694	57	2	0	8279	\N
2697	1	1	0	8120	\N
2697	53	2	0	8121	\N
2700	1	1	0	8293	\N
2700	53	2	0	8294	\N
2703	903	28	0	8298	\N
2703	117	126	0	8299	\N
2703	904	127	1	8300	\N
2703	874	127	0	8301	\N
2706	222	1	0	8314	\N
2706	223	2	0	8315	\N
2709	260	1	0	8320	\N
2709	261	2	0	8321	\N
2712	206	1	0	8126	\N
2712	207	2	0	8127	\N
2715	1	3	0	8337	\N
2715	48	4	0	8338	\N
2718	212	1	0	8345	\N
2718	213	2	0	8346	\N
2721	42	2	0	8357	\N
2721	681	3	0	8358	\N
2727	10	2	0	8370	\N
2727	29	3	0	8371	\N
2730	1	1	0	8351	\N
2730	53	2	0	8381	\N
2733	262	1	0	7651	\N
2733	263	2	0	7652	\N
2736	102	1	0	6997	\N
2736	103	2	0	7487	\N
2739	913	2	0	8407	\N
2742	35	2	0	8414	\N
2742	36	3	0	8415	\N
2745	1	1	0	8423	\N
2745	53	2	0	8424	\N
2748	121	0	0	8428	\N
2751	324	0	0	6254	\N
2759	56	2	0	8438	\N
2759	169	3	0	8439	\N
2763	10	1	0	8468	\N
2763	11	2	0	8469	\N
2766	322	0	0	8472	\N
2769	370	1	0	8483	\N
2769	925	2	0	8484	\N
2771	373	1	0	8491	\N
2771	374	2	0	8492	\N
2774	16	1	0	8403	\N
2774	17	2	0	8404	\N
2780	16	2	0	8511	\N
2780	155	3	0	8512	\N
2783	82	1	0	8251	\N
2783	83	2	0	8252	\N
2786	10	1	0	8527	\N
2786	11	2	0	8528	\N
2788	322	126	0	8534	\N
2788	926	127	0	8535	\N
2789	260	1	0	8538	\N
2789	261	2	0	8539	\N
2792	108	1	0	7508	\N
2792	109	2	0	7682	\N
2795	1	1	0	8552	\N
2795	53	2	0	8553	\N
2798	260	4	0	8566	\N
2798	538	5	0	8567	\N
2801	125	3	0	8577	\N
2801	126	4	0	8578	\N
2804	929	121	0	8583	\N
2804	208	126	0	8584	\N
2804	491	127	0	8585	\N
2807	73	2	0	8596	\N
2807	703	3	0	8597	\N
2810	235	1	0	6914	\N
2810	236	2	0	6915	\N
2813	930	1	0	8609	\N
2813	931	2	0	8610	\N
2816	10	0	0	7835	\N
2819	10	0	0	8017	\N
2827	1	0	0	8630	\N
2830	49	0	0	8650	\N
2833	117	3	0	8295	\N
2833	118	4	0	8659	\N
2839	10	0	0	8527	\N
2842	94	2	0	8691	\N
2842	95	3	0	8692	\N
2845	2	1	0	8703	\N
2845	26	2	0	8704	\N
2848	1	0	0	8710	\N
2851	189	0	0	8719	\N
2854	77	2	0	8726	\N
2854	216	3	0	8727	\N
2857	324	3	0	8737	\N
2857	937	4	0	8738	\N
2864	324	1	0	8737	\N
2864	325	2	0	8755	\N
2867	90	3	0	8764	\N
2867	877	4	0	8765	\N
2873	96	1	0	8421	\N
2873	97	2	0	8422	\N
2876	51	1	0	8554	\N
2876	52	2	0	8555	\N
2879	92	1	0	8213	\N
2879	191	2	0	8214	\N
2882	149	2	0	8786	\N
2882	697	3	0	8787	\N
2885	597	1	0	8791	\N
2885	598	2	0	8792	\N
2888	451	1	0	8799	\N
2888	584	2	0	8800	\N
2675	200	4	0	8229	\N
2675	899	5	0	8230	\N
2678	33	2	0	8237	\N
2678	34	3	0	8238	\N
2681	453	1	0	8182	\N
2681	454	2	0	8183	\N
2684	320	1	0	8247	\N
2684	334	2	0	8253	\N
2687	108	1	0	7508	\N
2687	109	2	0	7682	\N
2690	244	1	0	6818	\N
2690	245	2	0	6819	\N
2693	56	2	0	7993	\N
2693	169	3	0	8275	\N
2696	2	1	0	7983	\N
2696	26	2	0	7984	\N
2699	137	1	0	7911	\N
2699	138	2	0	8290	\N
2702	181	1	0	7772	\N
2702	530	2	0	8297	\N
2705	1	1	0	8310	\N
2705	53	2	0	8311	\N
2708	338	1	0	6968	\N
2708	409	2	0	7078	\N
2711	170	1	0	7882	\N
2711	398	2	0	8326	\N
2714	241	1	0	8329	\N
2714	333	2	0	8330	\N
2717	167	1	0	8343	\N
2717	533	2	0	8344	\N
2720	110	3	0	8355	\N
2720	905	4	0	8356	\N
2723	151	2	0	7506	\N
2723	576	3	0	8367	\N
2726	69	2	0	8148	\N
2726	500	3	0	8369	\N
2729	909	2	0	8378	\N
2732	528	2	0	8388	\N
2732	613	3	0	8389	\N
2735	911	2	0	8397	\N
2735	912	3	0	8398	\N
2738	16	1	0	8403	\N
2738	17	2	0	8404	\N
2741	23	2	0	5998	\N
2741	24	3	0	6595	\N
2744	96	1	0	8421	\N
2744	97	2	0	8422	\N
2747	75	1	0	8426	\N
2747	76	2	0	8427	\N
2750	324	1	0	6254	\N
2750	325	2	0	6255	\N
2753	189	1	0	8432	\N
2753	190	2	0	8433	\N
2755	1	2	0	8423	\N
2755	112	3	0	8436	\N
2757	121	2	0	8428	\N
2757	625	3	0	8437	\N
2758	51	2	0	7204	\N
2758	524	3	0	7205	\N
2762	230	1	0	8466	\N
2762	287	2	0	8467	\N
2765	137	1	0	7911	\N
2765	138	2	0	8290	\N
2770	326	1	0	8487	\N
2770	327	2	0	8488	\N
2773	181	1	0	7772	\N
2773	530	2	0	8297	\N
2776	256	2	0	7285	\N
2776	335	3	0	7286	\N
2778	56	2	0	8438	\N
2778	169	3	0	8439	\N
2779	10	2	0	8468	\N
2779	29	3	0	8510	\N
2785	338	1	0	8525	\N
2785	409	2	0	8526	\N
2791	927	1	0	8544	\N
2791	928	2	0	8545	\N
2794	242	1	0	8258	\N
2794	253	2	0	8259	\N
2797	290	1	0	8556	\N
2797	291	2	0	8557	\N
2800	18	4	0	8569	\N
2800	590	5	0	8570	\N
2802	237	3	0	8579	\N
2802	809	4	0	8580	\N
2803	208	3	0	8581	\N
2803	659	4	0	8582	\N
2805	75	3	0	8586	\N
2805	857	4	0	8587	\N
2806	908	1	0	8590	\N
2806	909	2	0	8591	\N
2809	251	1	0	7498	\N
2809	252	2	0	7603	\N
2812	79	1	0	8180	\N
2812	81	2	0	8181	\N
2815	189	1	0	8432	\N
2815	190	2	0	8433	\N
2821	10	0	0	8017	\N
2823	932	0	0	8622	\N
2826	1	0	0	8629	\N
2829	20	8	0	8648	\N
2829	934	9	0	8649	\N
2832	251	2	0	8655	\N
2832	828	3	0	8656	\N
2834	117	1	0	8295	\N
2834	248	2	0	8296	\N
2838	192	3	0	8676	\N
2838	627	4	0	8677	\N
2841	27	2	0	8540	\N
2841	619	3	0	8686	\N
2844	6	1	0	8699	\N
2844	194	2	0	8700	\N
2847	222	2	0	8314	\N
2847	232	3	0	8503	\N
2850	167	1	0	8717	\N
2850	533	2	0	8718	\N
2853	1	0	0	8710	\N
2856	258	3	0	4636	\N
2856	936	4	0	8736	\N
2858	373	3	0	8739	\N
2858	938	4	0	8740	\N
2859	324	1	0	8737	\N
2859	939	2	0	8741	\N
2862	30	1	0	6955	\N
2862	418	2	0	6956	\N
2863	237	2	0	8751	\N
2863	319	3	0	8752	\N
2866	391	3	0	8762	\N
2866	581	4	0	8763	\N
2869	181	1	0	8769	\N
2869	530	2	0	8770	\N
2872	56	2	0	8438	\N
2872	169	3	0	8439	\N
2875	108	1	0	7508	\N
2875	109	2	0	7682	\N
2878	411	1	0	8142	\N
2878	412	2	0	8143	\N
2880	88	0	0	8781	\N
2881	2	2	0	8703	\N
2881	131	3	0	8785	\N
2883	411	2	0	8142	\N
2883	582	3	0	8788	\N
2884	595	1	0	5322	\N
2884	596	2	0	5323	\N
2886	147	1	0	4481	\N
2886	599	2	0	4482	\N
2887	198	1	0	8795	\N
2887	199	2	0	8796	\N
2890	451	1	0	8805	\N
2890	584	2	0	8806	\N
2892	125	1	0	8577	\N
2892	195	2	0	8809	\N
2894	75	1	0	8728	\N
2894	76	2	0	8812	\N
2895	44	3	0	8819	\N
2895	940	4	0	8820	\N
2896	391	2	0	8825	\N
2896	406	3	0	8826	\N
2898	16	1	0	8801	\N
2898	17	2	0	8802	\N
2899	908	1	0	8832	\N
2899	909	2	0	8833	\N
2901	1	0	0	8834	\N
2902	121	1	0	8428	\N
2902	122	2	0	8431	\N
2904	273	1	0	8839	\N
2904	410	2	0	8840	\N
2906	601	4	0	8851	\N
2906	88	5	0	8852	\N
2907	88	0	0	8853	\N
2909	942	4	0	8856	\N
2909	27	5	0	8857	\N
2913	951	5	0	8877	\N
2913	952	5	0	8878	\N
2913	953	6	0	8879	\N
2914	954	5	0	8880	\N
2914	953	6	0	8881	\N
2916	77	1	0	8887	\N
2916	78	2	0	8888	\N
2918	320	3	0	8895	\N
2918	797	4	0	8896	\N
2922	4	2	0	8908	\N
2922	579	3	0	8909	\N
2923	58	2	0	8910	\N
2923	665	3	0	8911	\N
2925	528	2	0	8388	\N
2925	613	3	0	8389	\N
2926	10	0	0	8527	\N
2927	360	1	0	8916	\N
2927	479	2	0	8917	\N
2928	324	1	0	8737	\N
2928	325	2	0	8755	\N
2930	140	2	0	8920	\N
2930	487	3	0	8921	\N
2931	75	2	0	8728	\N
2931	159	3	0	8729	\N
2933	10	0	0	8926	\N
2934	16	1	0	8929	\N
2934	17	2	0	8930	\N
2936	108	1	0	7508	\N
2936	109	2	0	7682	\N
2937	108	0	0	7508	\N
2940	108	0	0	7508	\N
2942	338	1	0	8939	\N
2942	409	2	0	8940	\N
2943	202	1	0	8943	\N
2943	203	2	0	8944	\N
2944	10	0	0	8945	\N
2945	181	1	0	8769	\N
2945	530	2	0	8770	\N
2946	16	1	0	8929	\N
2946	17	2	0	8930	\N
2948	960	1	0	8954	\N
2948	961	2	0	8955	\N
2950	75	4	0	8728	\N
2950	172	5	0	8966	\N
2951	206	0	0	8126	\N
2953	56	1	0	8978	\N
2953	57	2	0	8979	\N
2954	149	1	0	8786	\N
2954	499	2	0	8982	\N
2955	200	1	0	8983	\N
2955	201	2	0	8984	\N
2956	841	1	0	8985	\N
2956	842	2	0	8986	\N
2958	164	1	0	7659	\N
2958	165	2	0	7660	\N
2960	110	1	0	8990	\N
2960	134	2	0	8991	\N
2962	49	1	0	8650	\N
2962	50	2	0	8996	\N
2964	210	1	0	9001	\N
2964	211	2	0	9002	\N
2965	212	1	0	8345	\N
2965	213	2	0	8346	\N
2967	237	1	0	9007	\N
2967	527	2	0	9008	\N
2968	1	1	0	9011	\N
2968	53	2	0	9012	\N
2970	1	1	0	9021	\N
2970	53	2	0	9022	\N
2971	1	3	0	9029	\N
2971	48	4	0	9030	\N
2973	110	1	0	8990	\N
2973	134	2	0	8991	\N
2974	241	1	0	8504	\N
2974	333	2	0	9034	\N
2976	316	1	0	8316	\N
2976	317	2	0	8317	\N
2978	49	1	0	9045	\N
2978	50	2	0	9046	\N
2980	202	1	0	9049	\N
2980	203	2	0	9050	\N
2981	79	1	0	9053	\N
2981	81	2	0	9054	\N
2983	1	1	0	9061	\N
2983	53	2	0	9062	\N
2984	156	1	0	6293	\N
2984	157	2	0	6294	\N
2986	964	1	0	9065	\N
2986	965	2	0	9066	\N
2987	10	1	0	8945	\N
2987	11	2	0	9069	\N
2990	144	1	0	9074	\N
2990	20	4	0	9079	\N
2990	702	5	0	9080	\N
2992	966	1	0	9085	\N
2992	967	1	0	9086	\N
2992	53	2	0	9087	\N
2993	42	1	0	8357	\N
2993	43	2	0	9088	\N
2995	44	2	0	9097	\N
2995	161	3	0	9098	\N
2996	242	2	0	8258	\N
2996	620	3	0	9099	\N
2998	181	1	0	8769	\N
2998	969	2	0	9104	\N
2999	170	1	0	9105	\N
2999	970	2	0	9106	\N
3001	64	0	0	9063	\N
3002	1	0	0	9102	\N
3004	971	34	0	9111	\N
3004	365	69	0	9112	\N
3004	973	70	1	9113	\N
3004	972	70	0	9114	\N
3005	10	0	0	9115	\N
3007	338	0	0	8939	\N
3008	167	0	0	9117	\N
3009	1	0	0	9118	\N
3010	290	2	0	9123	\N
3010	575	3	0	9124	\N
3011	391	1	0	9127	\N
3011	392	2	0	9128	\N
3013	260	1	0	8566	\N
3013	261	2	0	8989	\N
3014	94	1	0	9132	\N
3014	107	2	0	9133	\N
3016	258	1	0	9138	\N
3016	309	2	0	9139	\N
3019	326	1	0	9144	\N
3019	327	2	0	9145	\N
3020	1	1	0	9148	\N
3020	53	2	0	9149	\N
3022	20	1	0	9152	\N
3022	144	2	0	9153	\N
3023	362	1	0	9156	\N
3023	395	2	0	9157	\N
3025	58	1	0	9164	\N
3025	59	2	0	9165	\N
3028	290	1	0	9169	\N
3028	291	2	0	9170	\N
3029	10	1	0	9166	\N
2897	56	1	0	8438	\N
2897	57	2	0	8829	\N
2900	411	1	0	8142	\N
2900	412	2	0	8143	\N
2903	244	1	0	6818	\N
2903	245	2	0	6819	\N
2905	941	4	0	8849	\N
2905	192	5	0	8850	\N
2908	358	4	0	8854	\N
2908	90	5	0	8855	\N
2910	943	0	0	8858	\N
2910	944	0	0	8859	\N
2911	945	5	0	8870	\N
2911	946	5	0	8871	\N
2911	948	6	1	8872	\N
2911	947	6	0	8873	\N
2912	949	51	0	8874	\N
2912	750	52	0	8875	\N
2912	950	52	0	8876	\N
2915	945	1	0	8870	\N
2915	955	1	0	8884	\N
2915	957	2	1	8885	\N
2915	956	2	0	8886	\N
2919	210	1	0	8899	\N
2919	211	2	0	8900	\N
2920	10	0	0	8527	\N
2921	958	37	0	8901	\N
2921	156	126	0	8902	\N
2921	959	127	0	8903	\N
2924	142	2	0	8912	\N
2924	656	3	0	8913	\N
2929	23	2	0	5998	\N
2929	24	3	0	6595	\N
2932	56	2	0	8438	\N
2932	169	3	0	8439	\N
2935	110	2	0	8933	\N
2935	111	3	0	8934	\N
2938	108	0	0	7508	\N
2939	108	0	0	7508	\N
2941	913	2	0	8407	\N
2947	362	1	0	8950	\N
2947	395	2	0	8951	\N
2949	16	1	0	8956	\N
2949	17	2	0	8957	\N
2952	1	4	0	8834	\N
2952	422	5	0	8975	\N
2959	260	1	0	8566	\N
2959	261	2	0	8989	\N
2961	336	1	0	8992	\N
2961	356	2	0	8993	\N
2963	962	1	0	8997	\N
2963	963	2	0	8998	\N
2966	233	1	0	9003	\N
2966	234	2	0	9004	\N
2969	90	3	0	8764	\N
2969	877	4	0	8765	\N
2972	233	3	0	9003	\N
2972	305	4	0	9031	\N
2975	79	2	0	9039	\N
2975	80	3	0	9040	\N
2979	228	1	0	9047	\N
2979	229	2	0	9048	\N
2982	75	1	0	9057	\N
2982	76	2	0	9058	\N
2985	64	1	0	9063	\N
2985	65	2	0	9064	\N
2988	140	1	0	9070	\N
2988	141	2	0	9071	\N
2991	253	1	0	9081	\N
2991	242	4	0	8259	\N
2991	620	5	0	9082	\N
2994	202	1	0	9091	\N
2994	203	2	0	9092	\N
2997	1	1	0	9102	\N
2997	968	2	0	9103	\N
3000	86	0	0	5996	\N
3003	365	0	0	7515	\N
3006	852	0	0	9116	\N
3012	18	1	0	8569	\N
3012	19	2	0	9129	\N
3015	71	1	0	9134	\N
3015	72	2	0	9135	\N
3017	132	1	0	9140	\N
3017	455	2	0	9141	\N
3018	23	1	0	5998	\N
3018	217	2	0	5999	\N
3021	360	1	0	8916	\N
3021	479	2	0	8917	\N
3024	8	1	0	9160	\N
3024	9	2	0	9161	\N
3026	10	1	0	9166	\N
3026	11	2	0	9167	\N
3027	151	1	0	7506	\N
3027	302	2	0	9168	\N
3030	125	1	0	8577	\N
3030	195	2	0	8809	\N
3033	338	1	0	8939	\N
3033	409	2	0	8940	\N
3036	290	2	0	9188	\N
3036	575	3	0	9189	\N
3039	453	1	0	9198	\N
3039	454	2	0	9199	\N
3044	237	2	0	9213	\N
3044	319	3	0	9214	\N
3047	1	2	0	9148	\N
3047	112	3	0	9226	\N
3050	391	3	0	9127	\N
3050	581	4	0	9239	\N
3053	132	1	0	9140	\N
3053	455	2	0	9141	\N
3056	40	0	0	7357	\N
3059	40	0	0	7357	\N
3062	320	1	0	9262	\N
3062	977	2	0	9263	\N
3065	10	1	0	9273	\N
3065	11	2	0	9274	\N
3068	222	2	0	9283	\N
3068	232	3	0	9284	\N
3071	10	1	0	9294	\N
3071	11	2	0	9295	\N
3076	980	24	0	9304	\N
3076	54	126	0	9305	\N
3076	981	127	0	9306	\N
3077	1	1	0	9309	\N
3077	53	2	0	9310	\N
3079	96	1	0	9315	\N
3079	97	2	0	9316	\N
3082	264	1	0	9319	\N
3082	270	2	0	9320	\N
3083	132	1	0	9140	\N
3083	455	2	0	9141	\N
3086	242	1	0	8258	\N
3086	253	2	0	8259	\N
3089	285	1	0	8195	\N
3089	286	2	0	8196	\N
3092	322	126	0	9344	\N
3092	983	127	0	9345	\N
3094	192	8	0	9364	\N
3094	985	9	0	9365	\N
3097	202	3	0	9376	\N
3097	987	4	0	9377	\N
3100	1	1	0	9380	\N
3100	53	2	0	9381	\N
3103	362	2	0	9391	\N
3103	420	3	0	9392	\N
3111	908	2	0	9414	\N
3111	988	3	0	9415	\N
3112	989	2	0	9416	\N
3112	990	3	0	9417	\N
3115	1	3	0	9432	\N
3115	48	4	0	9433	\N
3118	336	1	0	8992	\N
3118	356	2	0	8993	\N
3121	121	12	0	8428	\N
3121	992	13	0	9472	\N
3126	2	0	0	9479	\N
3029	11	2	0	9167	\N
3032	140	1	0	9070	\N
3032	141	2	0	9071	\N
3035	16	1	0	9182	\N
3035	17	2	0	9183	\N
3038	198	1	0	9194	\N
3038	199	2	0	9195	\N
3041	189	0	0	9202	\N
3043	58	2	0	9164	\N
3043	665	3	0	9212	\N
3046	974	7	0	9219	\N
3046	137	35	0	9220	\N
3046	975	36	0	9221	\N
3049	100	1	0	9231	\N
3049	160	2	0	9232	\N
3052	1	2	0	9248	\N
3052	112	3	0	9249	\N
3055	38	1	0	7538	\N
3055	399	2	0	7539	\N
3058	264	3	0	9259	\N
3058	976	4	0	9260	\N
3061	40	0	0	7357	\N
3064	230	1	0	9269	\N
3064	287	2	0	9270	\N
3067	62	1	0	9277	\N
3067	63	2	0	9278	\N
3070	449	2	0	5441	\N
3070	583	3	0	9291	\N
3073	88	1	0	9299	\N
3073	89	2	0	9300	\N
3085	75	1	0	9323	\N
3085	76	2	0	9324	\N
3088	27	2	0	9333	\N
3088	619	3	0	9334	\N
3091	16	1	0	9341	\N
3091	17	2	0	9342	\N
3093	23	8	0	9362	\N
3093	984	9	0	9363	\N
3096	1	3	0	9374	\N
3096	48	4	0	9375	\N
3099	94	1	0	9132	\N
3099	107	2	0	9133	\N
3102	235	1	0	9313	\N
3102	236	2	0	9314	\N
3108	2	3	0	9405	\N
3108	572	4	0	9406	\N
3114	224	1	0	9424	\N
3114	225	2	0	9425	\N
3117	186	2	0	9438	\N
3117	696	3	0	9439	\N
3120	273	12	0	9470	\N
3120	991	13	0	9471	\N
3123	16	3	0	9481	\N
3123	359	4	0	9482	\N
3124	1	4	0	9432	\N
3124	422	5	0	9491	\N
3127	140	0	0	9499	\N
3130	268	1	0	6921	\N
3130	269	2	0	6922	\N
3133	320	1	0	9518	\N
3133	334	2	0	9519	\N
3142	102	1	0	9558	\N
3142	103	2	0	9559	\N
3145	353	1	0	9562	\N
3145	354	2	0	9563	\N
3148	391	2	0	9574	\N
3148	406	3	0	9575	\N
3151	16	3	0	9581	\N
3151	359	4	0	9582	\N
3154	996	1	0	9588	\N
3154	997	2	0	9589	\N
3156	1	1	0	9566	\N
3156	53	2	0	9567	\N
3163	10	1	0	9605	\N
3163	11	2	0	9606	\N
3166	10	1	0	9624	\N
3166	11	2	0	9625	\N
3169	2	1	0	9631	\N
3169	26	2	0	9632	\N
3172	67	1	0	9636	\N
3172	478	2	0	9637	\N
3175	16	1	0	9581	\N
3175	17	2	0	9583	\N
3178	140	2	0	9499	\N
3178	487	3	0	9648	\N
3180	10	2	0	9653	\N
3180	29	3	0	9654	\N
3188	140	1	0	9672	\N
3188	141	2	0	9673	\N
3191	214	1	0	9527	\N
3191	215	2	0	9528	\N
3195	75	1	0	9323	\N
3195	76	2	0	9324	\N
3197	10	2	0	9657	\N
3197	29	3	0	9698	\N
3199	360	1	0	9660	\N
3199	479	2	0	9661	\N
3202	88	7	0	9560	\N
3202	1002	8	0	9720	\N
3205	16	1	0	9685	\N
3205	17	2	0	9686	\N
3208	135	1	0	7828	\N
3208	136	2	0	8289	\N
3210	353	2	0	9738	\N
3210	755	3	0	9739	\N
3214	235	1	0	9754	\N
3214	236	2	0	9755	\N
3215	241	1	0	8504	\N
3215	333	2	0	9034	\N
3216	322	2	0	8472	\N
3216	833	3	0	9760	\N
3218	40	1	0	9765	\N
3218	41	2	0	9766	\N
3031	852	1	0	9116	\N
3031	913	2	0	9177	\N
3034	44	1	0	9180	\N
3034	45	2	0	9181	\N
3037	14	1	0	9192	\N
3037	15	2	0	9193	\N
3040	18	1	0	9200	\N
3040	19	2	0	9201	\N
3042	189	2	0	8720	\N
3042	311	3	0	9207	\N
3045	367	1	0	9217	\N
3045	368	2	0	9218	\N
3048	71	2	0	9227	\N
3048	401	3	0	9228	\N
3051	10	1	0	9242	\N
3051	11	2	0	9243	\N
3054	353	1	0	7452	\N
3054	354	2	0	9252	\N
3057	40	0	0	7357	\N
3060	40	0	0	7357	\N
3063	320	1	0	9262	\N
3063	334	2	0	9266	\N
3069	978	0	0	9285	\N
3069	979	0	0	9286	\N
3072	4	1	0	8908	\N
3072	25	2	0	9298	\N
3074	54	1	0	6384	\N
3074	55	2	0	6552	\N
3075	56	1	0	9301	\N
3075	57	2	0	9302	\N
3078	235	1	0	9313	\N
3078	236	2	0	9314	\N
3080	10	1	0	9317	\N
3080	11	2	0	9318	\N
3081	135	1	0	7828	\N
3081	136	2	0	8289	\N
3084	137	24	0	9321	\N
3084	982	25	0	9322	\N
3087	164	2	0	9331	\N
3087	226	3	0	9332	\N
3090	56	1	0	9301	\N
3090	57	2	0	9302	\N
3095	64	8	0	9366	\N
3095	986	9	0	9367	\N
3098	1	1	0	9380	\N
3098	53	2	0	9381	\N
3101	27	1	0	9333	\N
3101	28	2	0	9384	\N
3104	365	1	0	7515	\N
3104	366	2	0	7516	\N
3106	51	1	0	9395	\N
3106	52	2	0	9396	\N
3107	326	1	0	9144	\N
3107	327	2	0	9145	\N
3109	10	3	0	9317	\N
3109	347	4	0	9407	\N
3110	367	2	0	9412	\N
3110	651	3	0	9413	\N
3113	140	1	0	9420	\N
3113	141	2	0	9421	\N
3116	10	3	0	9317	\N
3116	347	4	0	9407	\N
3119	2	1	0	9444	\N
3119	26	2	0	9445	\N
3122	2	3	0	9479	\N
3122	572	4	0	9480	\N
3125	73	3	0	8596	\N
3125	993	4	0	9498	\N
3128	224	4	0	9508	\N
3128	994	5	0	9509	\N
3131	320	13	0	9512	\N
3131	995	14	0	9513	\N
3134	10	1	0	9522	\N
3134	11	2	0	9523	\N
3136	220	1	0	7275	\N
3136	221	2	0	9526	\N
3137	214	1	0	9527	\N
3137	215	2	0	9528	\N
3139	10	4	0	9539	\N
3139	600	5	0	9540	\N
3140	908	2	0	9414	\N
3140	988	3	0	9415	\N
3143	268	1	0	6921	\N
3143	269	2	0	6922	\N
3146	1	1	0	9566	\N
3146	53	2	0	9567	\N
3149	56	2	0	9576	\N
3149	169	3	0	9577	\N
3152	16	1	0	9581	\N
3152	17	2	0	9583	\N
3155	322	1	0	8472	\N
3155	323	2	0	9592	\N
3158	44	1	0	9180	\N
3158	45	2	0	9181	\N
3160	40	1	0	9597	\N
3160	41	2	0	9598	\N
3161	56	1	0	9599	\N
3161	57	2	0	9600	\N
3164	64	1	0	9366	\N
3164	65	2	0	9609	\N
3167	113	1	0	8050	\N
3167	437	2	0	9626	\N
3170	268	1	0	6921	\N
3170	269	2	0	6922	\N
3176	206	2	0	9640	\N
3176	999	3	0	9641	\N
3177	1	2	0	9646	\N
3177	112	3	0	9647	\N
3179	488	2	0	6113	\N
3179	729	3	0	6114	\N
3182	1	1	0	9646	\N
3182	53	2	0	9659	\N
3187	852	1	0	9116	\N
3187	913	2	0	9177	\N
3189	338	1	0	8939	\N
3189	409	2	0	8940	\N
3194	391	1	0	9574	\N
3194	392	2	0	9691	\N
3196	149	1	0	8786	\N
3196	499	2	0	8982	\N
3204	10	1	0	9657	\N
3204	11	2	0	9658	\N
3207	73	1	0	9729	\N
3207	74	2	0	9730	\N
3129	210	1	0	9001	\N
3129	211	2	0	9002	\N
3132	258	1	0	9516	\N
3132	309	2	0	9517	\N
3135	411	1	0	8142	\N
3135	412	2	0	8143	\N
3138	40	4	0	9537	\N
3138	564	5	0	9538	\N
3141	273	5	0	9470	\N
3141	274	6	0	9555	\N
3144	88	1	0	9560	\N
3144	89	2	0	9561	\N
3147	18	1	0	9568	\N
3147	19	2	0	9569	\N
3150	40	1	0	9537	\N
3150	41	2	0	9580	\N
3153	402	1	0	6816	\N
3153	403	2	0	6817	\N
3157	117	1	0	9593	\N
3157	248	2	0	9594	\N
3159	102	1	0	9558	\N
3159	103	2	0	9559	\N
3162	62	1	0	9601	\N
3162	63	2	0	9602	\N
3165	10	5	0	9620	\N
3165	998	6	0	9621	\N
3168	10	1	0	9629	\N
3168	11	2	0	9630	\N
3171	23	1	0	9362	\N
3171	217	2	0	9635	\N
3173	56	1	0	9599	\N
3173	57	2	0	9600	\N
3174	14	1	0	9192	\N
3174	15	2	0	9193	\N
3181	10	1	0	9657	\N
3181	11	2	0	9658	\N
3183	360	1	0	9660	\N
3183	479	2	0	9661	\N
3184	233	1	0	9003	\N
3184	234	2	0	9004	\N
3185	1000	1	0	9664	\N
3185	1001	2	0	9665	\N
3186	73	1	0	9668	\N
3186	74	2	0	9669	\N
3190	14	4	0	9192	\N
3190	588	5	0	9682	\N
3192	16	1	0	9685	\N
3192	17	2	0	9686	\N
3193	1	1	0	9689	\N
3193	53	2	0	9690	\N
3198	1	2	0	9699	\N
3198	112	3	0	9700	\N
3200	18	1	0	9703	\N
3200	19	2	0	9704	\N
3201	251	0	0	9705	\N
3203	149	7	0	9721	\N
3203	1003	8	0	9722	\N
3206	391	1	0	9574	\N
3206	392	2	0	9691	\N
3209	1004	72	0	9731	\N
3209	137	126	0	9732	\N
3209	1005	127	0	9733	\N
3211	268	1	0	9742	\N
3211	269	2	0	9743	\N
3212	360	1	0	9660	\N
3212	479	2	0	9661	\N
3213	149	2	0	9750	\N
3213	697	3	0	9751	\N
3217	1	2	0	9761	\N
3217	112	3	0	9762	\N
3219	90	1	0	9767	\N
3219	344	2	0	9768	\N
3220	1	1	0	9761	\N
3220	53	2	0	9771	\N
3221	595	1	0	5322	\N
3221	596	2	0	5323	\N
3222	110	1	0	9772	\N
3222	134	2	0	9773	\N
3223	597	1	0	9774	\N
3223	598	2	0	9775	\N
3224	125	1	0	9776	\N
3224	195	2	0	9777	\N
3225	147	1	0	4481	\N
3225	599	2	0	4482	\N
3226	435	13	0	9804	\N
3226	1006	14	0	9805	\N
3227	42	13	0	8357	\N
3227	1007	14	0	9806	\N
3228	170	13	0	9807	\N
3228	1008	14	0	9808	\N
3229	42	4	0	8357	\N
3229	1009	5	0	9809	\N
3230	16	6	0	9822	\N
3230	1010	7	0	9823	\N
3231	167	4	0	9117	\N
3231	1011	5	0	9832	\N
3232	10	6	0	9845	\N
3232	426	7	0	9846	\N
3233	1012	10	0	9848	\N
3233	978	11	0	9285	\N
3233	1013	11	0	9849	\N
3234	391	8	0	9574	\N
3234	1014	9	0	9866	\N
3235	262	4	0	9875	\N
3235	1015	5	0	9876	\N
3236	40	1	0	9879	\N
3236	41	2	0	9880	\N
3237	237	1	0	9881	\N
3237	527	2	0	9882	\N
3238	113	1	0	8050	\N
3238	437	2	0	9626	\N
3239	1	18	0	9761	\N
3239	1016	19	0	9919	\N
3240	16	18	0	9920	\N
3240	1017	19	0	9921	\N
3241	51	3	0	9928	\N
3241	329	4	0	9929	\N
3242	115	3	0	9930	\N
3242	732	4	0	9931	\N
3243	97	1	0	9934	\N
3243	1018	2	0	9935	\N
3243	1019	2	0	9936	\N
3244	97	1	0	9934	\N
3244	96	2	0	9937	\N
3245	186	2	0	9942	\N
3245	696	3	0	9943	\N
3246	424	2	0	8401	\N
3246	520	3	0	9944	\N
3247	186	66	0	9942	\N
3247	1020	67	0	9945	\N
3248	362	1	0	9948	\N
3248	395	2	0	9949	\N
3249	10	1	0	9952	\N
3249	11	2	0	9953	\N
3250	262	1	0	9954	\N
3250	263	2	0	9955	\N
3251	528	2	0	8388	\N
3251	613	3	0	8389	\N
3252	10	2	0	9952	\N
3252	29	3	0	9964	\N
3253	123	1	0	7277	\N
3253	124	2	0	9967	\N
3254	10	2	0	9972	\N
3254	29	3	0	9973	\N
3255	115	2	0	9930	\N
3255	636	3	0	9974	\N
3256	88	2	0	9560	\N
3256	154	3	0	9975	\N
3257	1021	1	0	9978	\N
3257	1022	2	0	9979	\N
3258	140	1	0	9672	\N
3258	141	2	0	9673	\N
3259	10	1	0	9972	\N
3259	11	2	0	9982	\N
3260	40	1	0	9879	\N
3260	41	2	0	9880	\N
3261	365	1	0	7515	\N
3261	366	2	0	7516	\N
3263	1	1	0	9999	\N
3263	53	2	0	10000	\N
3266	1	1	0	9999	\N
3266	53	2	0	10000	\N
3268	908	1	0	10009	\N
3268	909	2	0	10010	\N
3270	320	50	0	10011	\N
3270	1023	51	0	10012	\N
3271	181	2	0	8769	\N
3271	769	3	0	10017	\N
3273	10	2	0	10023	\N
3273	29	3	0	10024	\N
3275	273	1	0	10028	\N
3275	410	2	0	10029	\N
3278	290	4	0	10042	\N
3278	695	5	0	10043	\N
3279	1	2	0	10048	\N
3279	112	3	0	10049	\N
3280	16	2	0	9920	\N
3280	155	3	0	10054	\N
3283	449	3	0	10068	\N
3283	1025	4	0	10069	\N
3285	27	2	0	9333	\N
3285	619	3	0	9334	\N
3286	210	8	0	10091	\N
3286	1026	9	0	10092	\N
3294	192	0	0	9364	\N
3299	40	2	0	9879	\N
3299	66	3	0	10122	\N
3302	908	4	0	10133	\N
3302	1032	5	0	10134	\N
3305	10	5	0	10152	\N
3305	1033	6	0	10153	\N
3307	14	1	0	10158	\N
3307	15	2	0	10159	\N
3308	27	1	0	9333	\N
3308	28	2	0	9384	\N
3313	115	2	0	9930	\N
3313	1034	3	0	10173	\N
3316	40	2	0	10181	\N
3316	66	3	0	10182	\N
3318	79	2	0	10185	\N
3318	80	3	0	10186	\N
3320	140	2	0	9672	\N
3320	487	3	0	10193	\N
3323	16	19	0	10254	\N
3323	1038	20	0	10255	\N
3326	10	1	0	10179	\N
3326	11	2	0	10270	\N
3329	123	12	0	10292	\N
3329	1041	13	0	10293	\N
3333	324	4	0	10306	\N
3333	603	5	0	10307	\N
3336	77	3	0	10324	\N
3336	1043	4	0	10325	\N
3339	10	3	0	10338	\N
3339	347	4	0	10339	\N
3342	142	3	0	8912	\N
3342	1044	4	0	10349	\N
3345	1046	4	0	10362	\N
3345	173	7	0	10367	\N
3345	480	8	0	10368	\N
3348	451	5	0	10404	\N
3348	1050	6	0	10405	\N
3354	10	2	0	10502	\N
3354	29	3	0	10503	\N
3357	391	1	0	10510	\N
3357	392	2	0	10511	\N
3360	132	2	0	9140	\N
3360	133	3	0	10518	\N
3363	264	1	0	9319	\N
3363	270	2	0	9320	\N
3366	266	1	0	10540	\N
3366	267	2	0	10541	\N
3372	18	1	0	10550	\N
3372	19	2	0	10582	\N
3375	264	2	0	10600	\N
3375	265	3	0	10601	\N
3378	228	0	0	9047	\N
3383	79	1	0	10621	\N
3383	81	2	0	10622	\N
3384	167	1	0	10623	\N
3384	533	2	0	10624	\N
3387	360	1	0	10504	\N
3387	479	2	0	10629	\N
3393	1	1	0	10644	\N
3393	53	2	0	10645	\N
3396	4	1	0	8908	\N
3396	25	2	0	9298	\N
3399	117	1	0	9593	\N
3399	248	2	0	9594	\N
3402	300	41	0	6908	\N
3402	1066	42	0	10660	\N
3405	10	0	0	10667	\N
3408	147	8	0	10672	\N
3408	1067	9	0	10673	\N
3411	597	2	0	9774	\N
3411	767	3	0	10678	\N
3414	251	1	0	10684	\N
3414	252	2	0	10685	\N
3417	40	1	0	10692	\N
3417	41	2	0	10693	\N
3420	149	2	0	10166	\N
3420	697	3	0	10700	\N
3424	67	1	0	9636	\N
3424	478	2	0	9637	\N
3427	389	3	0	10713	\N
3427	1069	4	0	10714	\N
3430	2	1	0	10721	\N
3430	26	2	0	10722	\N
3431	18	1	0	10652	\N
3431	19	2	0	10653	\N
3434	49	0	0	10726	\N
3435	6	0	0	10727	\N
3437	220	0	0	7275	\N
3443	1018	0	0	10731	\N
3443	1053	0	0	10732	\N
3446	23	1	0	9362	\N
3446	217	2	0	9635	\N
3449	142	0	0	10745	\N
3452	110	0	0	10746	\N
3459	10	0	0	10766	\N
3462	362	0	0	10769	\N
3468	288	0	0	10774	\N
3471	64	0	0	10776	\N
3474	33	0	0	10777	\N
3477	1018	0	0	10731	\N
3477	1056	0	0	10778	\N
3478	92	0	0	8213	\N
3481	14	0	0	10780	\N
3484	33	0	0	10777	\N
3486	202	0	0	9376	\N
3487	1021	0	0	10783	\N
3490	1	0	0	10791	\N
3496	449	1	0	10068	\N
3496	1079	2	0	10851	\N
3499	1081	14	0	10855	\N
3499	186	62	0	10863	\N
3499	1083	63	1	10864	\N
3499	1082	63	0	10865	\N
3499	1084	64	0	10866	\N
3502	121	0	0	10869	\N
3505	16	1	0	10768	\N
3505	1087	2	0	10876	\N
3508	92	1	0	10879	\N
3508	191	2	0	10880	\N
3511	94	0	0	10885	\N
3513	40	0	0	10741	\N
3514	77	0	0	10886	\N
3517	10	0	0	10773	\N
3520	528	1	0	10893	\N
3520	529	2	0	10894	\N
3526	42	6	0	10899	\N
3526	1090	7	0	10904	\N
3528	2	1	0	10907	\N
3528	1091	2	0	10908	\N
3262	10	5	0	9995	\N
3262	998	6	0	9996	\N
3264	233	1	0	10001	\N
3264	234	2	0	10002	\N
3269	324	1	0	8737	\N
3269	325	2	0	8755	\N
3276	10	4	0	10038	\N
3276	600	5	0	10039	\N
3284	208	2	0	8581	\N
3284	854	3	0	10074	\N
3289	192	0	0	8676	\N
3292	192	0	0	9364	\N
3293	192	5	0	10106	\N
3293	1030	6	0	10107	\N
3297	241	2	0	10114	\N
3297	281	3	0	10115	\N
3298	42	2	0	8357	\N
3298	681	3	0	8358	\N
3301	431	4	0	10131	\N
3301	1031	5	0	10132	\N
3304	389	0	0	10141	\N
3310	1	1	0	10164	\N
3310	53	2	0	10165	\N
3317	1	2	0	10183	\N
3317	112	3	0	10184	\N
3319	288	2	0	10191	\N
3319	289	3	0	10192	\N
3322	113	19	0	10252	\N
3322	1037	20	0	10253	\N
3325	110	5	0	9772	\N
3325	1039	6	0	10267	\N
3328	2	7	0	9631	\N
3328	1040	8	0	10289	\N
3331	30	5	0	6955	\N
3331	1042	6	0	10298	\N
3332	210	4	0	10091	\N
3332	565	5	0	10305	\N
3335	10	1	0	10317	\N
3335	11	2	0	10318	\N
3338	1	2	0	10330	\N
3338	283	3	0	10331	\N
3341	56	1	0	9599	\N
3341	57	2	0	9600	\N
3344	167	1	0	10007	\N
3344	533	2	0	10008	\N
3346	1047	4	0	10369	\N
3346	1021	7	0	10370	\N
3346	1048	8	0	10371	\N
3347	49	10	0	10392	\N
3347	1049	11	0	10393	\N
3350	1052	79	0	10481	\N
3350	1018	80	0	9935	\N
3350	1053	80	0	10482	\N
3353	98	3	0	10496	\N
3353	1054	4	0	10497	\N
3356	1055	48	0	10506	\N
3356	1018	49	0	9935	\N
3356	1056	49	0	10507	\N
3358	92	1	0	8213	\N
3358	191	2	0	8214	\N
3359	75	1	0	10160	\N
3359	76	2	0	10161	\N
3362	10	1	0	10526	\N
3362	11	2	0	10527	\N
3365	20	2	0	10536	\N
3365	702	3	0	10537	\N
3368	18	2	0	10550	\N
3368	218	3	0	10551	\N
3371	10	1	0	10580	\N
3371	11	2	0	10581	\N
3374	235	2	0	10598	\N
3374	1061	3	0	10599	\N
3377	119	1	0	10607	\N
3377	120	2	0	10608	\N
3380	2	1	0	10613	\N
3380	26	2	0	10614	\N
3386	10	1	0	10580	\N
3386	11	2	0	10581	\N
3389	147	30	0	4481	\N
3389	1064	31	0	10636	\N
3392	77	1	0	10324	\N
3392	78	2	0	10641	\N
3395	1065	70	0	10647	\N
3395	212	126	0	10648	\N
3395	1063	127	0	10649	\N
3398	4	4	0	8908	\N
3398	684	5	0	10654	\N
3400	391	1	0	10657	\N
3400	392	2	0	10658	\N
3401	300	1	0	6908	\N
3401	355	2	0	6909	\N
3404	27	1	0	9333	\N
3404	28	2	0	9384	\N
3407	908	0	0	10133	\N
3409	595	2	0	10674	\N
3409	768	3	0	10675	\N
3410	4	2	0	10676	\N
3410	579	3	0	10677	\N
3413	1	3	0	10644	\N
3413	48	4	0	10681	\N
3416	453	1	0	9198	\N
3416	454	2	0	9199	\N
3418	12	1	0	10694	\N
3418	13	2	0	10695	\N
3419	140	1	0	9672	\N
3419	141	2	0	9673	\N
3422	79	1	0	10705	\N
3422	81	2	0	10706	\N
3425	290	3	0	10042	\N
3425	364	4	0	10711	\N
3428	338	3	0	10715	\N
3428	339	4	0	10716	\N
3432	10	0	0	10725	\N
3438	353	0	0	10728	\N
3445	40	1	0	10741	\N
3445	41	2	0	10742	\N
3447	73	1	0	9729	\N
3447	74	2	0	9730	\N
3448	841	1	0	10743	\N
3448	842	2	0	10744	\N
3451	16	0	0	10530	\N
3453	27	0	0	10747	\N
3454	79	0	0	10748	\N
3456	1070	14	0	10749	\N
3456	186	126	0	10763	\N
3456	1071	127	0	10764	\N
3458	251	0	0	10765	\N
3461	16	0	0	10768	\N
3464	35	0	0	10771	\N
3467	10	0	0	10773	\N
3470	71	0	0	9227	\N
3473	113	0	0	10252	\N
3476	237	0	0	9881	\N
3479	391	0	0	10779	\N
3480	488	0	0	6113	\N
3483	16	0	0	10768	\N
3489	1073	68	0	10787	\N
3489	170	85	0	10788	\N
3489	1075	86	1	10789	\N
3489	1074	86	0	10790	\N
3492	132	0	0	10792	\N
3493	1065	70	0	10818	\N
3493	212	96	0	10844	\N
3493	1076	97	0	10845	\N
3495	92	1	0	10849	\N
3495	1078	2	0	10850	\N
3498	186	1	0	9942	\N
3498	1080	2	0	10854	\N
3501	1	0	0	10868	\N
3504	49	1	0	10874	\N
3504	1086	2	0	10875	\N
3507	62	0	0	9601	\N
3510	18	1	0	10883	\N
3510	19	2	0	10884	\N
3516	56	0	0	10888	\N
3519	56	1	0	10888	\N
3519	1088	2	0	10891	\N
3265	75	1	0	9323	\N
3265	76	2	0	9324	\N
3267	167	1	0	10007	\N
3267	533	2	0	10008	\N
3272	320	2	0	9518	\N
3272	321	3	0	10018	\N
3274	260	2	0	8566	\N
3274	419	3	0	10025	\N
3277	316	4	0	10040	\N
3277	1024	5	0	10041	\N
3281	49	2	0	9045	\N
3281	328	3	0	10059	\N
3282	164	3	0	10066	\N
3282	307	4	0	10067	\N
3287	908	8	0	10009	\N
3287	1027	9	0	10093	\N
3288	220	8	0	7275	\N
3288	1028	9	0	10094	\N
3290	192	0	0	8676	\N
3291	241	13	0	8504	\N
3291	1029	14	0	10105	\N
3295	192	0	0	9364	\N
3296	353	1	0	10110	\N
3296	354	2	0	10111	\N
3300	260	2	0	8566	\N
3300	419	3	0	10025	\N
3303	14	2	0	10139	\N
3303	383	3	0	10140	\N
3306	285	1	0	10156	\N
3306	286	2	0	10157	\N
3309	75	1	0	10160	\N
3309	76	2	0	10161	\N
3311	149	1	0	10166	\N
3311	499	2	0	10167	\N
3312	40	2	0	9879	\N
3312	569	3	0	10172	\N
3314	73	2	0	9729	\N
3314	1035	3	0	10174	\N
3315	10	2	0	10179	\N
3315	29	3	0	10180	\N
3321	1	9	0	10212	\N
3321	1036	10	0	10213	\N
3324	40	5	0	10181	\N
3324	385	6	0	10266	\N
3327	40	2	0	10181	\N
3327	66	3	0	10182	\N
3330	20	2	0	10296	\N
3330	702	3	0	10297	\N
3334	391	3	0	10313	\N
3334	581	4	0	10314	\N
3337	14	3	0	10158	\N
3337	306	4	0	10326	\N
3340	145	1	0	10342	\N
3340	153	2	0	10343	\N
3343	16	3	0	10350	\N
3343	1045	4	0	10351	\N
3349	125	5	0	9776	\N
3349	1051	6	0	10406	\N
3351	75	1	0	10160	\N
3351	76	2	0	10161	\N
3352	16	3	0	10489	\N
3352	359	4	0	10490	\N
3355	360	2	0	10504	\N
3355	510	3	0	10505	\N
3361	90	2	0	9767	\N
3361	91	3	0	10523	\N
3364	16	1	0	10530	\N
3364	17	2	0	10531	\N
3367	1057	1	0	10544	\N
3367	1058	2	0	10545	\N
3369	1059	59	0	10573	\N
3369	38	61	0	10575	\N
3369	399	62	0	10576	\N
3370	38	2	0	7538	\N
3370	39	3	0	10577	\N
3373	2	5	0	10592	\N
3373	1060	6	0	10593	\N
3376	1062	70	0	10602	\N
3376	212	126	0	10603	\N
3376	1063	127	0	10604	\N
3379	264	2	0	10600	\N
3379	265	3	0	10601	\N
3381	402	1	0	10615	\N
3381	403	2	0	10616	\N
3382	336	1	0	10619	\N
3382	356	2	0	10620	\N
3385	79	0	0	10621	\N
3388	391	1	0	10632	\N
3388	392	2	0	10633	\N
3390	595	1	0	10637	\N
3390	596	2	0	10638	\N
3391	597	1	0	9774	\N
3391	598	2	0	9775	\N
3394	142	1	0	8912	\N
3394	143	2	0	10646	\N
3397	18	1	0	10652	\N
3397	19	2	0	10653	\N
3403	132	1	0	10663	\N
3403	455	2	0	10664	\N
3406	79	0	0	10621	\N
3412	4	0	0	10676	\N
3415	10	1	0	10688	\N
3415	11	2	0	10689	\N
3421	64	2	0	10701	\N
3421	162	3	0	10702	\N
3423	79	0	0	10705	\N
3426	852	3	0	9116	\N
3426	1068	4	0	10712	\N
3429	108	1	0	10719	\N
3429	109	2	0	10720	\N
3433	108	0	0	10719	\N
3436	86	0	0	5996	\N
3439	40	0	0	10692	\N
3440	1	0	0	10729	\N
3441	1	0	0	10730	\N
3442	316	0	0	10040	\N
3444	1	2	0	10737	\N
3444	112	3	0	10738	\N
3450	16	0	0	10530	\N
3455	186	0	0	9942	\N
3457	324	0	0	10306	\N
3460	189	0	0	10767	\N
3463	94	0	0	10770	\N
3465	391	0	0	10657	\N
3466	260	0	0	10772	\N
3469	793	0	0	10775	\N
3472	362	0	0	10769	\N
3475	793	0	0	10775	\N
3482	79	0	0	10781	\N
3485	244	0	0	10782	\N
3488	170	1	0	9807	\N
3488	1072	2	0	10786	\N
3491	10	0	0	10773	\N
3494	1077	0	0	10846	\N
3497	49	0	0	10726	\N
3500	235	0	0	10867	\N
3503	1	1	0	10872	\N
3503	1085	2	0	10873	\N
3506	202	0	0	9376	\N
3509	60	1	0	10881	\N
3509	61	2	0	10882	\N
3512	1	0	0	10872	\N
3515	27	0	0	10887	\N
3518	40	0	0	10741	\N
3521	23	1	0	10897	\N
3521	1089	2	0	10898	\N
3523	42	0	0	10899	\N
3524	10	0	0	10900	\N
3532	8	2	0	10918	\N
3532	1094	3	0	10919	\N
3540	38	0	0	10923	\N
3542	40	0	0	10925	\N
3543	30	9	0	10927	\N
3543	1097	10	0	10928	\N
3545	108	0	0	10719	\N
3548	38	0	0	10923	\N
3551	10	0	0	10900	\N
3522	220	0	0	7275	\N
3525	237	0	0	10901	\N
3527	67	0	0	9636	\N
3529	1	1	0	10909	\N
3529	1085	2	0	10910	\N
3533	908	2	0	10133	\N
3533	1095	3	0	10920	\N
3535	82	0	0	8810	\N
3536	27	0	0	10887	\N
3539	75	0	0	10922	\N
3541	1	0	0	10924	\N
3544	49	0	0	10929	\N
3546	2	0	0	10907	\N
3547	94	0	0	10930	\N
3549	10	0	0	10900	\N
3550	449	0	0	10068	\N
3553	10	0	0	10900	\N
3559	852	0	0	10933	\N
3562	60	0	0	10935	\N
3565	10	0	0	10936	\N
3568	242	0	0	10939	\N
3571	1	0	0	10942	\N
3574	18	0	0	10883	\N
3577	285	0	0	10946	\N
3580	149	0	0	10166	\N
3583	92	0	0	10879	\N
3585	79	0	0	10951	\N
3586	10	0	0	10952	\N
3589	40	0	0	10925	\N
3592	290	0	0	10042	\N
3595	373	0	0	8739	\N
3599	1	0	0	10958	\N
3601	360	0	0	10960	\N
3603	852	0	0	10961	\N
3604	82	0	0	10962	\N
3607	113	0	0	10965	\N
3609	10	0	0	10959	\N
3610	79	0	0	10957	\N
3613	62	0	0	10966	\N
3616	108	0	0	10719	\N
3622	75	0	0	10944	\N
3625	42	0	0	10968	\N
3628	42	1	0	10971	\N
3628	1100	2	0	10972	\N
3630	206	0	0	8126	\N
3633	113	1	0	10965	\N
3633	1102	2	0	10982	\N
3637	322	3	0	10991	\N
3637	1105	4	0	10992	\N
3639	1	0	0	10963	\N
3642	373	0	0	8739	\N
3646	113	0	0	11001	\N
3530	353	1	0	10728	\N
3530	1092	2	0	10911	\N
3531	528	1	0	10912	\N
3531	1093	2	0	10913	\N
3534	10	0	0	10900	\N
3537	1096	0	0	10921	\N
3538	16	0	0	10768	\N
3552	56	0	0	10931	\N
3555	841	0	0	10743	\N
3558	142	0	0	10932	\N
3561	449	0	0	10934	\N
3564	132	0	0	10792	\N
3567	60	0	0	10938	\N
3570	30	0	0	10941	\N
3573	2	0	0	10907	\N
3576	198	0	0	10945	\N
3579	18	0	0	10883	\N
3582	268	0	0	10949	\N
3588	210	0	0	10954	\N
3591	10	0	0	10955	\N
3594	79	0	0	10957	\N
3597	38	0	0	10950	\N
3602	300	0	0	6908	\N
3605	1	0	0	10963	\N
3606	16	0	0	10964	\N
3612	10	0	0	10959	\N
3615	220	0	0	7275	\N
3618	147	0	0	4481	\N
3620	595	0	0	10674	\N
3621	597	0	0	9774	\N
3624	528	0	0	10912	\N
3627	1099	0	0	10970	\N
3629	1	0	0	10963	\N
3632	6	2	0	10978	\N
3632	1101	3	0	10979	\N
3635	488	3	0	6113	\N
3635	1103	4	0	10988	\N
3638	435	0	0	10947	\N
3641	181	0	0	10996	\N
3644	202	1	0	9376	\N
3644	203	2	0	10999	\N
3647	14	0	0	11002	\N
3554	316	0	0	10040	\N
3556	18	0	0	10883	\N
3557	353	0	0	10728	\N
3560	35	0	0	10771	\N
3563	10	0	0	10900	\N
3566	244	0	0	10937	\N
3569	273	0	0	10940	\N
3572	1098	0	0	10943	\N
3575	75	0	0	10944	\N
3578	435	0	0	10947	\N
3581	10	0	0	10948	\N
3584	38	0	0	10950	\N
3587	256	0	0	10953	\N
3590	391	0	0	10779	\N
3593	2	0	0	10956	\N
3596	181	0	0	8769	\N
3598	79	0	0	10957	\N
3600	10	0	0	10959	\N
3608	40	0	0	10925	\N
3611	115	0	0	9930	\N
3614	119	0	0	10607	\N
3617	908	0	0	10133	\N
3619	336	0	0	10619	\N
3623	79	0	0	10967	\N
3626	251	0	0	10969	\N
3631	18	0	0	10973	\N
3634	117	0	0	10983	\N
3636	8	3	0	10989	\N
3636	1104	4	0	10990	\N
3640	30	5	0	10994	\N
3640	1106	6	0	10995	\N
3643	242	0	0	10939	\N
3645	82	0	0	11000	\N
3648	60	0	0	11003	\N
3649	1107	0	0	11004	\N
3650	230	0	0	11005	\N
3651	262	0	0	11006	\N
3652	82	0	0	11007	\N
3653	145	1	0	10342	\N
3653	1108	2	0	11009	\N
3654	115	0	0	9930	\N
3655	94	0	0	11010	\N
3656	338	0	0	11011	\N
3657	1109	0	0	11012	\N
3658	244	0	0	10937	\N
3659	79	0	0	11013	\N
3660	186	0	0	11014	\N
3661	186	0	0	11015	\N
3662	186	0	0	11015	\N
3663	242	0	0	11016	\N
3664	488	0	0	11017	\N
3665	1	1	0	11020	\N
3665	53	2	0	11021	\N
3666	10	1	0	10959	\N
3666	11	2	0	11022	\N
3667	10	0	0	11023	\N
3668	1	0	0	11020	\N
3669	214	3	0	11030	\N
3669	1110	4	0	11031	\N
3670	75	1	0	10944	\N
3670	76	2	0	11034	\N
3671	256	1	0	10953	\N
3671	257	2	0	11037	\N
3672	73	0	0	9729	\N
3673	73	1	0	9729	\N
3673	74	2	0	9730	\N
3674	360	1	0	10960	\N
3674	479	2	0	11040	\N
3675	258	1	0	11041	\N
3675	309	2	0	11042	\N
3676	1	1	0	11043	\N
3676	53	2	0	11044	\N
3677	206	1	0	8126	\N
3677	207	2	0	8127	\N
3678	14	1	0	11047	\N
3678	15	2	0	11048	\N
3679	16	1	0	10964	\N
3679	17	2	0	11051	\N
3680	79	1	0	11054	\N
3680	81	2	0	11055	\N
3681	1	1	0	11056	\N
3681	53	2	0	11057	\N
3682	108	1	0	11060	\N
3682	109	2	0	11061	\N
3683	435	1	0	11064	\N
3683	436	2	0	11065	\N
3684	451	3	0	10404	\N
3684	826	4	0	11071	\N
3685	316	3	0	11072	\N
3685	555	4	0	11073	\N
3686	10	2	0	11023	\N
3686	29	3	0	11078	\N
3687	391	2	0	11079	\N
3687	406	3	0	11080	\N
3688	16	2	0	11081	\N
3688	155	3	0	11082	\N
3689	117	1	0	11085	\N
3689	248	2	0	11086	\N
3690	210	1	0	11087	\N
3690	211	2	0	11088	\N
3691	338	1	0	11089	\N
3691	409	2	0	11090	\N
3692	1109	1	0	11012	\N
3692	1111	2	0	11091	\N
3693	18	1	0	11094	\N
3693	19	2	0	11095	\N
3694	167	1	0	11098	\N
3694	533	2	0	11099	\N
3695	137	3	0	11106	\N
3695	1112	4	0	11107	\N
3696	135	3	0	11108	\N
3696	1113	4	0	11109	\N
3697	10	1	0	11023	\N
3697	11	2	0	11112	\N
3698	56	1	0	11113	\N
3698	57	2	0	11114	\N
3699	1	1	0	11117	\N
3699	53	2	0	11118	\N
3700	10	1	0	11119	\N
3700	11	2	0	11120	\N
3701	1114	3	0	11127	\N
3701	1	4	0	11128	\N
3702	1115	3	0	11129	\N
3702	115	4	0	11130	\N
3703	1115	3	0	11129	\N
3703	115	4	0	11130	\N
3704	943	1	0	8858	\N
3704	1116	1	0	11133	\N
3704	1118	2	1	11134	\N
3704	1117	2	0	11135	\N
3704	1119	3	0	11136	\N
3705	123	1	0	10292	\N
3705	124	2	0	11137	\N
3706	92	1	0	11138	\N
3706	191	2	0	11139	\N
3707	132	1	0	10792	\N
3707	455	2	0	11142	\N
3708	2	1	0	11145	\N
3708	26	2	0	11146	\N
3709	230	4	0	11155	\N
3709	1120	5	0	11156	\N
3710	145	2	0	11161	\N
3710	331	3	0	11162	\N
3711	324	2	0	11163	\N
3711	486	3	0	11164	\N
3712	10	2	0	11165	\N
3712	29	3	0	11166	\N
3713	338	1	0	11089	\N
3713	409	2	0	11090	\N
3714	1109	1	0	11012	\N
3714	1111	2	0	11091	\N
3715	40	1	0	11171	\N
3715	41	2	0	11172	\N
3716	170	1	0	11175	\N
3716	398	2	0	11176	\N
3717	373	1	0	11177	\N
3717	374	2	0	11178	\N
3718	56	1	0	11113	\N
3718	57	2	0	11114	\N
3720	1121	3	0	11181	\N
3720	170	12	0	11182	\N
3720	1122	13	0	11183	\N
3722	88	1	0	11186	\N
3722	89	2	0	11187	\N
3725	69	1	0	8148	\N
3725	70	2	0	8149	\N
3729	10	1	0	11165	\N
3729	11	2	0	11206	\N
3731	40	1	0	11211	\N
3731	41	2	0	11212	\N
3733	202	1	0	11215	\N
3733	203	2	0	11216	\N
3736	135	2	0	11224	\N
3736	196	3	0	11225	\N
3738	348	1	0	11228	\N
3738	1123	2	0	11229	\N
3741	10	1	0	11234	\N
3741	11	2	0	11235	\N
3747	140	2	0	11252	\N
3747	487	3	0	11253	\N
3760	288	1	0	11300	\N
3760	400	2	0	11301	\N
3768	200	2	0	8983	\N
3768	887	3	0	11324	\N
3775	1131	2	0	11340	\N
3777	69	0	0	8148	\N
3780	137	1	0	11106	\N
3780	138	2	0	11347	\N
3782	383	2	0	11354	\N
3782	14	3	0	11355	\N
3785	383	2	0	11354	\N
3785	14	3	0	11355	\N
3786	95	2	0	11358	\N
3786	94	3	0	11359	\N
3790	123	4	0	11376	\N
3790	1133	5	0	11377	\N
3792	525	1	0	11378	\N
3792	526	2	0	11381	\N
3794	156	1	0	11384	\N
3794	157	2	0	11385	\N
3797	228	1	0	11396	\N
3797	229	2	0	11397	\N
3799	125	1	0	11402	\N
3799	195	2	0	11403	\N
3805	142	3	0	10932	\N
3805	1134	4	0	11424	\N
3807	60	1	0	11428	\N
3807	61	2	0	11429	\N
3812	1	2	0	11448	\N
3812	112	3	0	11449	\N
3817	10	1	0	11457	\N
3817	11	2	0	11458	\N
3821	40	1	0	11467	\N
3821	41	2	0	11468	\N
3824	10	2	0	11463	\N
3824	29	3	0	11479	\N
3826	1140	81	0	11487	\N
3826	1141	112	0	11488	\N
3826	1143	113	1	11489	\N
3826	1142	113	0	11490	\N
3829	12	1	0	10694	\N
3829	13	2	0	10695	\N
3831	288	2	0	11508	\N
3831	1144	3	0	11509	\N
3832	56	4	0	11113	\N
3832	1145	5	0	11517	\N
3835	435	1	0	11529	\N
3835	436	2	0	11530	\N
3838	1	1	0	11543	\N
3838	53	2	0	11544	\N
3846	100	2	0	11563	\N
3846	101	3	0	11564	\N
3847	224	1	0	11567	\N
3847	225	2	0	11568	\N
3852	23	1	0	11209	\N
3852	217	2	0	11210	\N
3854	214	1	0	11583	\N
3854	215	2	0	11584	\N
3855	100	4	0	11593	\N
3855	448	5	0	11594	\N
3862	1	1	0	11598	\N
3862	53	2	0	11599	\N
3870	192	1	0	11635	\N
3870	193	2	0	11636	\N
3872	316	1	0	11236	\N
3872	317	2	0	11237	\N
3877	20	1	0	11649	\N
3877	144	2	0	11650	\N
3879	391	1	0	11653	\N
3879	392	2	0	11654	\N
3884	10	2	0	11673	\N
3884	29	3	0	11674	\N
3887	1153	2	0	11684	\N
3887	1154	3	0	11685	\N
3889	224	2	0	11686	\N
3889	508	3	0	11687	\N
3891	224	0	0	11567	\N
3893	202	1	0	11692	\N
3893	203	2	0	11693	\N
3896	1157	1	0	11702	\N
3896	1158	2	0	11703	\N
3898	119	1	0	11706	\N
3898	120	2	0	11707	\N
3903	908	2	0	11718	\N
3903	988	3	0	11719	\N
3906	117	2	0	11573	\N
3906	175	3	0	11574	\N
3915	290	0	0	10042	\N
3920	411	1	0	11751	\N
3920	412	2	0	11752	\N
3922	1	1	0	11757	\N
3922	53	2	0	11758	\N
3925	206	2	0	8126	\N
3925	693	3	0	11764	\N
3927	320	62	0	11768	\N
3927	1160	63	0	11769	\N
3930	58	2	0	11606	\N
3930	665	3	0	11784	\N
3932	75	2	0	11275	\N
3932	159	3	0	11412	\N
3937	56	1	0	11803	\N
3937	57	2	0	11804	\N
3940	852	0	0	10961	\N
3942	852	1	0	10961	\N
3942	913	2	0	11819	\N
3945	1	3	0	11833	\N
3945	1114	4	0	11834	\N
3948	256	1	0	11849	\N
3948	257	2	0	11850	\N
3951	137	1	0	11863	\N
3951	138	2	0	11864	\N
3958	237	1	0	10901	\N
3958	527	2	0	11880	\N
3967	324	2	0	11901	\N
3967	486	3	0	11902	\N
3972	300	1	0	11915	\N
3972	355	2	0	11916	\N
3979	10	1	0	11925	\N
3979	11	2	0	11926	\N
3984	4	2	0	11948	\N
3984	579	3	0	11949	\N
3986	214	1	0	11953	\N
3986	215	2	0	11954	\N
3991	268	1	0	11963	\N
3991	269	2	0	11964	\N
3995	10	1	0	11957	\N
3995	11	2	0	11958	\N
3997	27	1	0	11975	\N
3997	28	2	0	11976	\N
3998	75	2	0	11892	\N
3998	159	3	0	11981	\N
4000	82	1	0	11616	\N
4000	83	2	0	11646	\N
3719	18	1	0	11179	\N
3719	19	2	0	11180	\N
3727	198	1	0	11198	\N
3727	199	2	0	11199	\N
3734	258	1	0	11041	\N
3734	309	2	0	11042	\N
3743	164	2	0	11242	\N
3743	1124	3	0	11243	\N
3745	71	2	0	9227	\N
3745	1125	3	0	11245	\N
3748	108	1	0	11256	\N
3748	109	2	0	11257	\N
3753	79	1	0	11273	\N
3753	81	2	0	11274	\N
3755	40	1	0	11279	\N
3755	41	2	0	11280	\N
3758	449	2	0	10934	\N
3758	583	3	0	11292	\N
3763	1	1	0	11263	\N
3763	53	2	0	11309	\N
3766	92	2	0	11138	\N
3766	93	3	0	11321	\N
3770	113	1	0	11333	\N
3770	437	2	0	11334	\N
3773	69	0	0	8148	\N
3779	244	1	0	11345	\N
3779	245	2	0	11346	\N
3781	135	1	0	11348	\N
3781	136	2	0	11349	\N
3788	60	2	0	11003	\N
3788	166	3	0	11366	\N
3789	77	4	0	11319	\N
3789	1132	5	0	11375	\N
3796	1	1	0	11392	\N
3796	53	2	0	11393	\N
3804	69	3	0	8148	\N
3804	594	4	0	11423	\N
3806	242	3	0	11016	\N
3806	1135	4	0	11425	\N
3809	1	1	0	11436	\N
3809	53	2	0	11437	\N
3814	137	2	0	11452	\N
3814	197	3	0	11453	\N
3816	210	1	0	11087	\N
3816	211	2	0	11088	\N
3818	198	1	0	11198	\N
3818	199	2	0	11199	\N
3823	220	2	0	7275	\N
3823	821	3	0	7276	\N
3828	268	1	0	11499	\N
3828	269	2	0	11500	\N
3840	1146	81	0	11549	\N
3840	320	126	0	11550	\N
3840	1119	127	1	11551	\N
3840	1147	127	0	11552	\N
3843	69	2	0	8148	\N
3843	500	3	0	8369	\N
3845	100	2	0	11563	\N
3845	101	3	0	11564	\N
3849	117	2	0	11573	\N
3849	175	3	0	11574	\N
3857	58	1	0	9164	\N
3857	59	2	0	9165	\N
3859	233	1	0	10001	\N
3859	234	2	0	10002	\N
3867	10	2	0	11561	\N
3867	29	3	0	11562	\N
3869	40	1	0	11631	\N
3869	41	2	0	11632	\N
3874	1	1	0	11637	\N
3874	53	2	0	11638	\N
3881	10	1	0	11661	\N
3881	11	2	0	11662	\N
3895	10	2	0	11673	\N
3895	29	3	0	11674	\N
3900	285	1	0	10946	\N
3900	286	2	0	11711	\N
3902	18	1	0	11179	\N
3902	19	2	0	11180	\N
3905	200	1	0	11724	\N
3905	201	2	0	11725	\N
3908	1	2	0	11698	\N
3908	112	3	0	11699	\N
3910	290	0	0	10042	\N
3914	290	0	0	10042	\N
3917	230	1	0	11745	\N
3917	287	2	0	11746	\N
3924	320	2	0	11545	\N
3924	321	3	0	11763	\N
3929	214	2	0	11778	\N
3929	227	3	0	11779	\N
3934	167	1	0	11793	\N
3934	533	2	0	11794	\N
3936	10	1	0	11799	\N
3936	11	2	0	11800	\N
3944	242	2	0	11825	\N
3944	620	3	0	11826	\N
3947	75	1	0	11845	\N
3947	76	2	0	11846	\N
3953	1	1	0	11867	\N
3953	53	2	0	11868	\N
3956	273	1	0	11739	\N
3956	410	2	0	11875	\N
3962	35	1	0	11651	\N
3962	340	2	0	11652	\N
3964	189	1	0	11890	\N
3964	190	2	0	11891	\N
3966	189	6	0	11890	\N
3966	1165	7	0	11896	\N
3969	264	1	0	11905	\N
3969	270	2	0	11906	\N
3971	1	1	0	11911	\N
3971	53	2	0	11912	\N
3974	1021	1	0	11919	\N
3974	1022	2	0	11920	\N
3976	10	1	0	11925	\N
3976	11	2	0	11926	\N
3981	40	1	0	11940	\N
3981	41	2	0	11941	\N
3983	206	1	0	11886	\N
3983	207	2	0	11887	\N
3988	6	1	0	11795	\N
3988	194	2	0	11796	\N
3993	365	1	0	11961	\N
3993	366	2	0	11962	\N
4004	170	1	0	11992	\N
4004	398	2	0	11993	\N
4009	198	1	0	12008	\N
4009	199	2	0	12009	\N
4012	51	2	0	12014	\N
4012	524	3	0	12015	\N
4014	27	2	0	12018	\N
4014	619	3	0	12019	\N
4016	233	1	0	10001	\N
4016	234	2	0	10002	\N
4018	336	1	0	12026	\N
4018	356	2	0	12027	\N
4021	117	2	0	12037	\N
4021	175	3	0	12038	\N
4026	192	1	0	12055	\N
4026	193	2	0	12056	\N
4028	135	1	0	12057	\N
4028	136	2	0	12058	\N
4033	156	1	0	11909	\N
4033	157	2	0	11910	\N
4038	92	1	0	12077	\N
4038	191	2	0	12078	\N
3721	1	1	0	11117	\N
3721	53	2	0	11118	\N
3723	391	1	0	11190	\N
3723	392	2	0	11191	\N
3730	23	1	0	11209	\N
3730	217	2	0	11210	\N
3732	10	1	0	11213	\N
3732	11	2	0	11214	\N
3735	137	2	0	11106	\N
3735	197	3	0	11223	\N
3737	54	1	0	6384	\N
3737	55	2	0	6552	\N
3739	67	1	0	11230	\N
3739	478	2	0	11231	\N
3744	1	2	0	11117	\N
3744	283	3	0	11244	\N
3746	88	2	0	11250	\N
3746	154	3	0	11251	\N
3749	40	2	0	11211	\N
3749	66	3	0	11262	\N
3751	40	1	0	11267	\N
3751	41	2	0	11268	\N
3756	451	2	0	10404	\N
3756	452	3	0	11285	\N
3761	113	1	0	11001	\N
3761	437	2	0	11304	\N
3764	362	2	0	10769	\N
3764	420	3	0	11314	\N
3769	149	2	0	11329	\N
3769	697	3	0	11330	\N
3771	10	1	0	11335	\N
3771	11	2	0	11336	\N
3776	69	0	0	8148	\N
3783	383	2	0	11354	\N
3783	14	3	0	11355	\N
3795	40	1	0	11388	\N
3795	41	2	0	11389	\N
3800	2	2	0	11408	\N
3800	131	3	0	11409	\N
3802	75	2	0	11275	\N
3802	159	3	0	11412	\N
3810	273	1	0	11440	\N
3810	410	2	0	11441	\N
3815	135	2	0	11348	\N
3815	196	3	0	11454	\N
3819	1137	1	0	11461	\N
3819	1138	2	0	11462	\N
3827	1021	2	0	11495	\N
3827	1048	3	0	11496	\N
3833	793	2	0	11450	\N
3833	1136	3	0	11451	\N
3836	198	2	0	11535	\N
3836	746	3	0	11536	\N
3839	320	1	0	11545	\N
3839	334	2	0	11546	\N
3841	1	1	0	11555	\N
3841	53	2	0	11556	\N
3844	10	2	0	11561	\N
3844	29	3	0	11562	\N
3850	402	2	0	10615	\N
3850	1148	3	0	11575	\N
3858	1	1	0	11598	\N
3858	53	2	0	11599	\N
3860	27	1	0	11602	\N
3860	28	2	0	11603	\N
3863	1	3	0	11614	\N
3863	48	4	0	11615	\N
3865	71	3	0	9227	\N
3865	397	4	0	11618	\N
3868	1151	2	0	11627	\N
3868	1152	3	0	11628	\N
3875	273	1	0	11440	\N
3875	410	2	0	11441	\N
3878	35	1	0	11651	\N
3878	340	2	0	11652	\N
3882	14	1	0	11665	\N
3882	15	2	0	11666	\N
3885	10	1	0	11673	\N
3885	11	2	0	11677	\N
3888	224	0	0	11567	\N
3894	1	2	0	11698	\N
3894	112	3	0	11699	\N
3897	691	1	0	5503	\N
3897	692	2	0	5504	\N
3899	1	1	0	11698	\N
3899	53	2	0	11708	\N
3901	1	1	0	11698	\N
3901	53	2	0	11708	\N
3907	100	2	0	11593	\N
3907	101	3	0	11730	\N
3911	273	2	0	11739	\N
3911	1159	3	0	11740	\N
3913	290	0	0	10042	\N
3918	228	1	0	11396	\N
3918	229	2	0	11397	\N
3921	14	1	0	11753	\N
3921	15	2	0	11754	\N
3923	151	2	0	7506	\N
3923	576	3	0	8367	\N
3926	62	2	0	11765	\N
3926	683	3	0	11766	\N
3935	6	1	0	11795	\N
3935	194	2	0	11796	\N
3938	242	2	0	11809	\N
3938	620	3	0	11810	\N
3941	326	1	0	11196	\N
3941	327	2	0	11197	\N
3943	391	2	0	11653	\N
3943	406	3	0	11824	\N
3946	1	5	0	11841	\N
3946	1162	6	0	11842	\N
3949	56	3	0	11857	\N
3949	475	4	0	11858	\N
3954	113	1	0	11871	\N
3954	437	2	0	11872	\N
3959	79	1	0	11322	\N
3959	81	2	0	11883	\N
3961	206	1	0	11886	\N
3961	207	2	0	11887	\N
3963	30	1	0	6955	\N
3963	418	2	0	6956	\N
3965	75	1	0	11892	\N
3965	76	2	0	11893	\N
3968	173	1	0	8807	\N
3968	396	2	0	8808	\N
3970	156	1	0	11909	\N
3970	157	2	0	11910	\N
3973	1	1	0	11917	\N
3973	53	2	0	11918	\N
3977	391	1	0	11927	\N
3977	392	2	0	11928	\N
3982	14	1	0	11942	\N
3982	15	2	0	11943	\N
3985	23	2	0	11209	\N
3985	24	3	0	11950	\N
3987	10	1	0	11957	\N
3987	11	2	0	11958	\N
3989	365	1	0	11961	\N
3989	366	2	0	11962	\N
3996	785	1	0	11973	\N
3996	786	2	0	11974	\N
4001	14	1	0	11942	\N
4001	15	2	0	11943	\N
4005	353	1	0	10728	\N
4005	354	2	0	11994	\N
4008	202	1	0	12006	\N
4008	203	2	0	12007	\N
4022	69	2	0	8148	\N
4022	1166	3	0	12043	\N
4025	10	1	0	12051	\N
4025	11	2	0	12052	\N
4027	137	1	0	11863	\N
4027	138	2	0	11864	\N
4034	362	1	0	12070	\N
4034	395	2	0	12071	\N
3724	100	1	0	11194	\N
3724	160	2	0	11195	\N
3726	326	1	0	11196	\N
3726	327	2	0	11197	\N
3728	214	1	0	11202	\N
3728	215	2	0	11203	\N
3740	173	1	0	8807	\N
3740	396	2	0	8808	\N
3742	316	1	0	11236	\N
3742	317	2	0	11237	\N
3750	1	2	0	11263	\N
3750	112	3	0	11264	\N
3752	79	1	0	11054	\N
3752	1126	2	0	11270	\N
3754	75	1	0	11275	\N
3754	76	2	0	11276	\N
3757	186	2	0	11290	\N
3757	696	3	0	11291	\N
3759	1127	2	0	11295	\N
3759	1128	3	0	11296	\N
3759	1129	3	0	11297	\N
3762	10	1	0	11307	\N
3762	11	2	0	11308	\N
3765	77	2	0	11319	\N
3765	216	3	0	11320	\N
3767	79	2	0	11322	\N
3767	80	3	0	11323	\N
3772	69	1	0	8148	\N
3772	70	2	0	8149	\N
3774	69	0	0	8148	\N
3778	10	1	0	11335	\N
3778	11	2	0	11336	\N
3784	66	2	0	11356	\N
3784	40	3	0	11357	\N
3787	1	1	0	11263	\N
3787	53	2	0	11309	\N
3791	525	0	0	11378	\N
3793	18	1	0	11179	\N
3793	19	2	0	11180	\N
3798	1	1	0	11398	\N
3798	53	2	0	11399	\N
3801	324	2	0	11410	\N
3801	486	3	0	11411	\N
3803	67	1	0	11415	\N
3803	478	2	0	11416	\N
3808	10	1	0	11432	\N
3808	11	2	0	11433	\N
3811	1	1	0	11442	\N
3811	53	2	0	11443	\N
3813	793	2	0	11450	\N
3813	1136	3	0	11451	\N
3820	10	1	0	11463	\N
3820	11	2	0	11464	\N
3822	1	1	0	11448	\N
3822	53	2	0	11471	\N
3825	198	2	0	11198	\N
3825	1139	3	0	11484	\N
3830	8	2	0	10989	\N
3830	278	3	0	11507	\N
3834	102	2	0	9558	\N
3834	158	3	0	11526	\N
3837	140	1	0	11539	\N
3837	141	2	0	11540	\N
3842	69	2	0	8148	\N
3842	500	3	0	8369	\N
3848	326	1	0	11196	\N
3848	327	2	0	11197	\N
3851	73	2	0	9729	\N
3851	703	3	0	11576	\N
3853	391	1	0	11579	\N
3853	392	2	0	11580	\N
3856	202	4	0	11215	\N
3856	1149	5	0	11595	\N
3861	58	1	0	11606	\N
3861	59	2	0	11607	\N
3864	82	3	0	11616	\N
3864	810	4	0	11617	\N
3866	793	1	0	11621	\N
3866	1150	2	0	11622	\N
3871	1	1	0	11637	\N
3871	53	2	0	11638	\N
3873	290	1	0	10042	\N
3873	291	2	0	11641	\N
3876	82	1	0	11616	\N
3876	83	2	0	11646	\N
3880	186	1	0	11657	\N
3880	187	2	0	11658	\N
3883	77	2	0	11671	\N
3883	216	3	0	11672	\N
3886	1	1	0	11678	\N
3886	53	2	0	11679	\N
3890	1155	0	0	11688	\N
3890	1156	0	0	11689	\N
3892	224	0	0	11567	\N
3904	242	2	0	11720	\N
3904	620	3	0	11721	\N
3909	40	1	0	11733	\N
3909	41	2	0	11734	\N
3912	290	2	0	11741	\N
3912	575	3	0	11742	\N
3916	290	0	0	10042	\N
3919	1	1	0	11698	\N
3919	53	2	0	11708	\N
3928	10	1	0	11772	\N
3928	11	2	0	11773	\N
3931	841	2	0	11785	\N
3931	1161	3	0	11786	\N
3933	64	1	0	11789	\N
3933	65	2	0	11790	\N
3939	56	2	0	11815	\N
3939	169	3	0	11816	\N
3950	14	1	0	11753	\N
3950	15	2	0	11754	\N
3952	135	1	0	11348	\N
3952	136	2	0	11349	\N
3955	119	1	0	11873	\N
3955	120	2	0	11874	\N
3957	58	1	0	11606	\N
3957	59	2	0	11607	\N
3960	1163	1	0	11884	\N
3960	1164	2	0	11885	\N
3975	64	1	0	11921	\N
3975	65	2	0	11922	\N
3978	38	2	0	10950	\N
3978	39	3	0	11933	\N
3980	64	1	0	11936	\N
3980	65	2	0	11937	\N
3990	268	1	0	11963	\N
3990	269	2	0	11964	\N
3992	391	1	0	11965	\N
3992	392	2	0	11966	\N
3994	79	1	0	11969	\N
3994	81	2	0	11970	\N
3999	10	1	0	11957	\N
3999	11	2	0	11958	\N
4003	214	1	0	11988	\N
4003	215	2	0	11989	\N
4006	10	2	0	11957	\N
4006	29	3	0	11999	\N
4011	92	2	0	11138	\N
4011	93	3	0	11321	\N
4013	56	2	0	12016	\N
4013	169	3	0	12017	\N
4015	92	1	0	11138	\N
4015	191	2	0	11139	\N
4017	132	1	0	12022	\N
4017	455	2	0	12023	\N
4020	210	2	0	11087	\N
4020	458	3	0	12032	\N
4023	2	1	0	11408	\N
4023	26	2	0	12046	\N
4030	10	1	0	12064	\N
4030	11	2	0	12065	\N
4032	930	1	0	8609	\N
4032	931	2	0	8610	\N
4035	841	1	0	11785	\N
4035	842	2	0	12072	\N
4002	212	1	0	11986	\N
4002	213	2	0	11987	\N
4007	10	1	0	12002	\N
4007	11	2	0	12003	\N
4010	1	0	0	11917	\N
4019	82	1	0	11616	\N
4019	83	2	0	11646	\N
4024	82	1	0	11616	\N
4024	83	2	0	11646	\N
4029	322	1	0	10991	\N
4029	323	2	0	12061	\N
4031	151	1	0	7506	\N
4031	302	2	0	9168	\N
4036	149	1	0	12073	\N
4036	499	2	0	12074	\N
4037	1	0	0	11917	\N
4039	56	1	0	12081	\N
4039	57	2	0	12082	\N
4040	8	3	0	10989	\N
4040	739	4	0	12089	\N
4041	75	3	0	12090	\N
4041	857	4	0	12091	\N
4042	1	2	0	11917	\N
4042	112	3	0	12096	\N
4043	1	1	0	12099	\N
4043	53	2	0	12100	\N
4044	10	1	0	12064	\N
4044	11	2	0	12065	\N
4045	88	1	0	11250	\N
4045	89	2	0	12103	\N
4046	413	1	0	12104	\N
4046	414	2	0	12105	\N
4047	424	3	0	12112	\N
4047	468	4	0	12113	\N
4048	1	1	0	12116	\N
4048	53	2	0	12117	\N
4049	164	1	0	11242	\N
4049	165	2	0	12118	\N
4050	316	1	0	11236	\N
4050	317	2	0	11237	\N
4051	1	1	0	12121	\N
4051	53	2	0	12122	\N
4052	164	2	0	11242	\N
4052	226	3	0	12127	\N
4053	224	2	0	12132	\N
4053	508	3	0	12133	\N
4054	1151	2	0	11627	\N
4054	1152	3	0	11628	\N
4055	345	2	0	12134	\N
4055	1167	3	0	12135	\N
4056	79	3	0	12142	\N
4056	1168	4	0	12143	\N
4057	69	1	0	12146	\N
4057	70	2	0	12147	\N
4058	389	1	0	12148	\N
4058	390	2	0	12149	\N
4059	53	1	0	12152	\N
4059	1	2	0	12153	\N
4060	396	1	0	12154	\N
4060	173	2	0	8808	\N
4061	260	1	0	12157	\N
4061	261	2	0	12158	\N
4062	10	3	0	12064	\N
4062	347	4	0	12165	\N
4063	793	3	0	12166	\N
4063	1169	4	0	12167	\N
4064	1	1	0	12170	\N
4064	53	2	0	12153	\N
4065	132	1	0	12022	\N
4065	455	2	0	12023	\N
4066	10	1	0	12064	\N
4066	11	2	0	12065	\N
4067	1	1	0	12175	\N
4067	53	2	0	12176	\N
4068	40	1	0	11940	\N
4068	41	2	0	11941	\N
4069	2	2	0	12181	\N
4069	131	3	0	12182	\N
4070	1	1	0	12185	\N
4070	53	2	0	12186	\N
4071	488	1	0	12187	\N
4071	489	2	0	12188	\N
4072	235	1	0	12191	\N
4072	236	2	0	12192	\N
4073	365	1	0	12193	\N
4073	366	2	0	12194	\N
4074	288	1	0	12195	\N
4074	400	2	0	12196	\N
4075	1	1	0	12185	\N
4075	53	2	0	12186	\N
4076	852	1	0	12199	\N
4076	913	2	0	12200	\N
4077	38	1	0	12203	\N
4077	399	2	0	12204	\N
4078	4	2	0	12209	\N
4078	579	3	0	12210	\N
4079	402	2	0	12211	\N
4079	1148	3	0	12212	\N
4080	71	2	0	9227	\N
4080	401	3	0	9228	\N
4081	125	2	0	12213	\N
4081	188	3	0	12214	\N
4082	173	1	0	12217	\N
4082	396	2	0	12218	\N
4083	908	1	0	11718	\N
4083	909	2	0	12219	\N
4084	214	1	0	12222	\N
4084	215	2	0	12223	\N
4085	1	1	0	12185	\N
4085	53	2	0	12186	\N
4086	49	1	0	12226	\N
4086	50	2	0	12227	\N
4087	224	1	0	12132	\N
4087	225	2	0	12230	\N
4088	214	1	0	12231	\N
4088	215	2	0	12232	\N
4089	220	2	0	12237	\N
4089	312	3	0	12238	\N
4090	2	2	0	12239	\N
4090	471	3	0	12240	\N
4091	322	5	0	12251	\N
4091	1170	6	0	12252	\N
4092	1171	5	0	12253	\N
4092	1172	6	0	12254	\N
4093	208	1	0	12257	\N
4093	209	2	0	12258	\N
4094	142	1	0	10932	\N
4094	143	2	0	12261	\N
4095	40	1	0	11940	\N
4095	41	2	0	11941	\N
4096	56	1	0	12264	\N
4096	57	2	0	12265	\N
4097	208	2	0	12270	\N
4097	854	3	0	12271	\N
4098	49	2	0	12276	\N
4098	328	3	0	12277	\N
4099	391	2	0	11965	\N
4099	406	3	0	12278	\N
4100	40	1	0	11940	\N
4100	41	2	0	11941	\N
4101	10	1	0	12281	\N
4101	11	2	0	12282	\N
4102	10	2	0	12281	\N
4102	792	3	0	12286	\N
4103	210	2	0	12287	\N
4103	1173	3	0	12288	\N
4104	79	2	0	12289	\N
4104	472	3	0	12290	\N
4105	18	3	0	12291	\N
4105	1174	4	0	12292	\N
4106	241	2	0	8504	\N
4106	1175	3	0	12293	\N
4107	40	2	0	12297	\N
4107	569	3	0	12298	\N
4108	40	1	0	12301	\N
4108	41	2	0	12302	\N
4109	10	2	0	12281	\N
4109	275	3	0	12307	\N
4110	268	1	0	11963	\N
4110	269	2	0	11964	\N
4111	44	1	0	9180	\N
4111	45	2	0	9181	\N
4112	46	1	0	1086	\N
4112	839	2	0	7547	\N
4113	14	1	0	12312	\N
4113	15	2	0	12313	\N
4114	151	1	0	12314	\N
4114	302	2	0	12315	\N
4115	202	1	0	12006	\N
4115	203	2	0	12007	\N
4116	35	2	0	11651	\N
4116	1176	3	0	12319	\N
4117	1177	113	0	12320	\N
4117	200	126	0	12321	\N
4117	1178	127	0	12322	\N
4123	411	1	0	12349	\N
4123	412	2	0	12350	\N
4125	266	1	0	12353	\N
4125	267	2	0	12354	\N
4130	23	2	0	11209	\N
4130	24	3	0	11950	\N
4137	79	1	0	12289	\N
4137	81	2	0	12384	\N
4138	362	9	0	12070	\N
4138	1179	10	0	12403	\N
4141	119	2	0	12412	\N
4141	891	3	0	12413	\N
4146	228	1	0	11396	\N
4146	229	2	0	11397	\N
4149	459	1	0	12438	\N
4149	460	2	0	12439	\N
4151	228	1	0	12442	\N
4151	229	2	0	12443	\N
4153	793	1	0	12446	\N
4153	1150	2	0	12447	\N
4155	164	1	0	12452	\N
4155	165	2	0	12453	\N
4160	220	1	0	12237	\N
4160	221	2	0	12466	\N
4162	6	1	0	12471	\N
4162	194	2	0	12472	\N
4165	40	2	0	12479	\N
4165	569	3	0	12480	\N
4170	35	1	0	12501	\N
4170	340	2	0	12502	\N
4172	173	1	0	12507	\N
4172	396	2	0	12508	\N
4174	8	1	0	12513	\N
4174	9	2	0	12514	\N
4179	49	2	0	12537	\N
4179	1183	3	0	12538	\N
4181	360	0	0	10960	\N
4186	56	3	0	12418	\N
4186	1188	4	0	12556	\N
4191	108	2	0	12581	\N
4191	501	3	0	12582	\N
4194	264	6	0	12598	\N
4194	1193	7	0	12599	\N
4197	264	2	0	12598	\N
4197	265	3	0	12610	\N
4202	88	1	0	11250	\N
4202	89	2	0	12103	\N
4207	14	1	0	12312	\N
4207	15	2	0	12313	\N
4209	224	1	0	12132	\N
4209	225	2	0	12230	\N
4216	56	1	0	12418	\N
4216	57	2	0	12419	\N
4218	793	1	0	12446	\N
4218	1150	2	0	12447	\N
4220	220	1	0	12237	\N
4220	221	2	0	12466	\N
4222	79	1	0	12664	\N
4222	81	2	0	12665	\N
4228	300	1	0	11915	\N
4228	355	2	0	11916	\N
4231	1	4	0	12505	\N
4231	422	5	0	12705	\N
4232	14	5	0	12716	\N
4232	1201	6	0	12717	\N
4234	73	1	0	9729	\N
4234	74	2	0	9730	\N
4236	6	1	0	12471	\N
4236	194	2	0	12472	\N
4243	77	1	0	12738	\N
4243	78	2	0	12739	\N
4245	1204	65	0	12742	\N
4245	140	81	0	12745	\N
4245	1205	82	0	12746	\N
4250	10	2	0	12763	\N
4250	29	3	0	12764	\N
4256	164	1	0	12786	\N
4256	165	2	0	12787	\N
4258	244	1	0	11345	\N
4258	245	2	0	11346	\N
4272	290	1	0	12333	\N
4272	291	2	0	12824	\N
4279	58	2	0	12843	\N
4279	665	3	0	12844	\N
4281	1	1	0	12829	\N
4281	53	2	0	12851	\N
4284	202	3	0	12862	\N
4284	987	4	0	12863	\N
4286	132	3	0	12022	\N
4286	814	4	0	12866	\N
4288	793	3	0	12446	\N
4288	1169	4	0	12868	\N
4291	121	1	0	10869	\N
4291	122	2	0	12879	\N
4296	1	1	0	12898	\N
4296	53	2	0	12899	\N
4298	42	0	0	10968	\N
4303	135	1	0	12057	\N
4303	136	2	0	12058	\N
4305	10	2	0	12912	\N
4305	792	3	0	12913	\N
4310	1109	1	0	12448	\N
4310	1111	2	0	12449	\N
4315	1	3	0	12930	\N
4315	48	4	0	12947	\N
4322	75	1	0	12960	\N
4322	76	2	0	12961	\N
4327	365	1	0	12193	\N
4327	366	2	0	12194	\N
4330	69	1	0	12982	\N
4330	70	2	0	12983	\N
4332	12	1	0	12988	\N
4332	13	2	0	12989	\N
4334	244	2	0	12998	\N
4334	438	3	0	12999	\N
4337	64	0	0	11936	\N
4346	189	1	0	11890	\N
4346	190	2	0	11891	\N
4349	262	1	0	13039	\N
4349	263	2	0	13040	\N
4352	202	1	0	13053	\N
4352	203	2	0	13054	\N
4354	367	2	0	12894	\N
4354	1227	3	0	13059	\N
4357	488	1	0	13066	\N
4357	489	2	0	13067	\N
4359	54	1	0	13009	\N
4359	55	2	0	13070	\N
4364	164	2	0	13090	\N
4364	226	3	0	13091	\N
4372	1	1	0	13124	\N
4372	53	2	0	13125	\N
4374	262	1	0	13126	\N
4374	263	2	0	13127	\N
4376	100	1	0	13130	\N
4376	160	2	0	13131	\N
4381	10	1	0	13143	\N
4381	11	2	0	13144	\N
4383	1109	1	0	13146	\N
4383	1111	2	0	13147	\N
4388	38	77	0	13154	\N
4388	1230	78	0	13212	\N
4390	391	3	0	13221	\N
4390	581	4	0	13222	\N
4392	367	8	0	13231	\N
4392	1232	9	0	13233	\N
4395	23	5	0	13285	\N
4395	650	6	0	13286	\N
4397	1235	10	0	13310	\N
4397	1236	10	0	13311	\N
4397	1237	11	0	13312	\N
4399	1	10	0	13335	\N
4399	968	11	0	13336	\N
4408	1	10	0	13380	\N
4118	49	2	0	12327	\N
4118	328	3	0	12328	\N
4120	40	2	0	12335	\N
4120	66	3	0	12336	\N
4122	10	2	0	12345	\N
4122	29	3	0	12346	\N
4127	75	0	0	12090	\N
4129	56	2	0	12362	\N
4129	169	3	0	12363	\N
4132	10	1	0	12374	\N
4132	11	2	0	12375	\N
4135	117	1	0	12380	\N
4135	248	2	0	12381	\N
4140	10	2	0	12410	\N
4140	29	3	0	12411	\N
4142	1	1	0	12185	\N
4142	53	2	0	12186	\N
4144	56	1	0	12418	\N
4144	57	2	0	12419	\N
4150	1	1	0	12440	\N
4150	53	2	0	12441	\N
4152	852	1	0	12444	\N
4152	913	2	0	12445	\N
4154	1109	1	0	12448	\N
4154	1111	2	0	12449	\N
4159	260	1	0	12464	\N
4159	261	2	0	12465	\N
4161	40	1	0	12416	\N
4161	41	2	0	12417	\N
4171	1	1	0	12505	\N
4171	53	2	0	12506	\N
4177	173	3	0	12527	\N
4177	174	4	0	12528	\N
4180	200	74	0	12539	\N
4180	1184	75	0	12540	\N
4184	18	10	0	12548	\N
4184	1186	11	0	12549	\N
4187	1189	4	0	12565	\N
4187	40	5	0	12566	\N
4189	20	2	0	12573	\N
4189	369	3	0	12574	\N
4195	94	1	0	12602	\N
4195	107	2	0	12603	\N
4198	1	4	0	12505	\N
4198	1194	5	0	12619	\N
4200	1	1	0	12505	\N
4200	53	2	0	12506	\N
4203	40	1	0	12625	\N
4203	41	2	0	12626	\N
4205	121	5	0	10869	\N
4205	1197	6	0	12639	\N
4210	1198	1	0	12647	\N
4210	1199	2	0	12648	\N
4212	262	1	0	11006	\N
4212	263	2	0	12651	\N
4214	4	1	0	12209	\N
4214	25	2	0	12656	\N
4223	51	2	0	12014	\N
4223	524	3	0	12015	\N
4225	233	2	0	10001	\N
4225	910	3	0	12671	\N
4229	145	1	0	11161	\N
4229	153	2	0	12696	\N
4237	69	1	0	12654	\N
4237	70	2	0	12655	\N
4239	67	1	0	12728	\N
4239	478	2	0	12729	\N
4241	132	1	0	12022	\N
4241	455	2	0	12023	\N
4246	77	4	0	12738	\N
4246	1206	5	0	12753	\N
4248	268	4	0	12756	\N
4248	1208	5	0	12757	\N
4251	67	1	0	12728	\N
4251	478	2	0	12729	\N
4257	424	1	0	12788	\N
4257	425	2	0	12789	\N
4259	908	1	0	11718	\N
4259	909	2	0	12219	\N
4261	79	1	0	12795	\N
4261	81	2	0	12796	\N
4263	65	1	0	12797	\N
4263	64	3	0	11937	\N
4263	65	4	0	12801	\N
4265	100	1	0	11593	\N
4265	160	2	0	12804	\N
4267	100	1	0	11593	\N
4267	160	2	0	12804	\N
4270	14	2	0	12817	\N
4270	383	3	0	12818	\N
4277	110	3	0	10746	\N
4277	1217	4	0	12838	\N
4282	273	1	0	12854	\N
4282	410	2	0	12855	\N
4285	230	3	0	12864	\N
4285	876	4	0	12865	\N
4287	852	3	0	12444	\N
4287	1068	4	0	12867	\N
4289	391	1	0	12871	\N
4289	392	2	0	12872	\N
4294	102	1	0	12892	\N
4294	103	2	0	12893	\N
4299	1	2	0	12898	\N
4299	444	3	0	12905	\N
4301	42	0	0	10968	\N
4306	1219	2	0	12914	\N
4306	251	126	0	12915	\N
4306	749	127	1	12916	\N
4306	1220	127	0	12917	\N
4308	1	2	0	12926	\N
4308	112	3	0	12927	\N
4311	1109	0	0	12448	\N
4313	79	2	0	12937	\N
4313	80	3	0	12938	\N
4316	10	1	0	12950	\N
4316	11	2	0	12951	\N
4318	75	1	0	12954	\N
4318	76	2	0	12955	\N
4320	10	1	0	12950	\N
4320	11	2	0	12951	\N
4325	260	2	0	12464	\N
4325	419	3	0	12973	\N
4335	164	1	0	12786	\N
4335	165	2	0	12787	\N
4340	186	1	0	13013	\N
4340	187	2	0	13014	\N
4344	142	1	0	13022	\N
4344	143	2	0	13023	\N
4347	828	2	0	13026	\N
4347	251	126	0	13027	\N
4347	1224	127	0	13028	\N
4353	10	1	0	12950	\N
4353	11	2	0	12951	\N
4355	908	1	0	11718	\N
4355	909	2	0	12219	\N
4362	10	1	0	13082	\N
4362	11	2	0	13083	\N
4365	77	1	0	13094	\N
4365	78	2	0	13095	\N
4367	75	1	0	13098	\N
4367	76	2	0	13099	\N
4370	102	1	0	13118	\N
4370	103	2	0	13119	\N
4373	56	0	0	12264	\N
4379	170	1	0	12754	\N
4379	398	2	0	13136	\N
4386	64	2	0	11936	\N
4386	162	3	0	12801	\N
4393	56	12	0	13258	\N
4393	676	13	0	13259	\N
4400	235	10	0	12191	\N
4400	1238	11	0	13337	\N
4404	424	10	0	12788	\N
4404	1241	11	0	13361	\N
4406	117	9	0	12773	\N
4406	1242	10	0	13382	\N
4411	10	10	0	13519	\N
4119	290	2	0	12333	\N
4119	575	3	0	12334	\N
4121	94	1	0	12339	\N
4121	107	2	0	12340	\N
4124	324	1	0	12351	\N
4124	325	2	0	12352	\N
4126	119	1	0	11873	\N
4126	120	2	0	11874	\N
4134	40	1	0	12378	\N
4134	41	2	0	12379	\N
4136	326	1	0	11196	\N
4136	327	2	0	11197	\N
4143	40	1	0	12416	\N
4143	41	2	0	12417	\N
4145	237	2	0	12424	\N
4145	319	3	0	12425	\N
4148	1	1	0	12434	\N
4148	53	2	0	12435	\N
4157	115	2	0	12460	\N
4157	1034	3	0	12461	\N
4164	360	2	0	10960	\N
4164	361	3	0	12478	\N
4169	10	1	0	12410	\N
4169	11	2	0	12498	\N
4182	360	1	0	10960	\N
4182	479	2	0	11040	\N
4185	228	3	0	12554	\N
4185	1187	4	0	12555	\N
4192	92	2	0	12583	\N
4192	93	3	0	12584	\N
4193	40	6	0	12596	\N
4193	1192	7	0	12597	\N
4199	40	4	0	12620	\N
4199	1195	5	0	12621	\N
4201	51	1	0	12014	\N
4201	52	2	0	12624	\N
4208	1	1	0	12505	\N
4208	53	2	0	12506	\N
4217	27	1	0	12018	\N
4217	28	2	0	12657	\N
4219	300	1	0	11915	\N
4219	355	2	0	11916	\N
4221	10	1	0	12660	\N
4221	11	2	0	12661	\N
4226	18	3	0	12672	\N
4226	609	4	0	12673	\N
4227	10	9	0	12692	\N
4227	1200	10	0	12693	\N
4233	256	5	0	12718	\N
4233	1202	6	0	12719	\N
4235	285	1	0	12722	\N
4235	286	2	0	12723	\N
4244	142	1	0	12740	\N
4244	143	2	0	12741	\N
4247	170	4	0	12754	\N
4247	1207	5	0	12755	\N
4252	1	2	0	12771	\N
4252	112	3	0	12772	\N
4254	320	2	0	12775	\N
4254	321	3	0	12776	\N
4268	33	1	0	12809	\N
4268	163	2	0	12810	\N
4273	1	2	0	12829	\N
4273	444	3	0	12830	\N
4275	110	2	0	10746	\N
4275	1214	3	0	12832	\N
4280	67	1	0	12847	\N
4280	478	2	0	12848	\N
4292	10	1	0	12882	\N
4292	11	2	0	12883	\N
4297	58	1	0	12843	\N
4297	59	2	0	12900	\N
4302	42	0	0	10968	\N
4304	137	1	0	11863	\N
4304	138	2	0	11864	\N
4309	1	1	0	12930	\N
4309	53	2	0	12931	\N
4323	79	2	0	12937	\N
4323	80	3	0	12938	\N
4326	92	1	0	12976	\N
4326	191	2	0	12977	\N
4328	1	1	0	12980	\N
4328	53	2	0	12981	\N
4336	40	0	0	13002	\N
4338	54	3	0	13009	\N
4338	476	4	0	13010	\N
4341	1	1	0	13015	\N
4341	53	2	0	13016	\N
4350	18	0	0	13041	\N
4358	10	1	0	12950	\N
4358	11	2	0	12951	\N
4360	100	2	0	11593	\N
4360	1228	3	0	13075	\N
4363	290	2	0	13088	\N
4363	575	3	0	13089	\N
4368	300	5	0	13110	\N
4368	1229	6	0	13111	\N
4375	1	1	0	13124	\N
4375	53	2	0	13125	\N
4377	100	1	0	13130	\N
4377	160	2	0	13131	\N
4380	132	1	0	13139	\N
4380	455	2	0	13140	\N
4382	115	1	0	12460	\N
4382	116	2	0	13145	\N
4384	241	1	0	8504	\N
4384	333	2	0	9034	\N
4389	1	3	0	13219	\N
4389	48	4	0	13220	\N
4391	367	4	0	13231	\N
4391	1231	5	0	13232	\N
4398	35	10	0	13313	\N
4398	1237	11	0	13314	\N
4402	235	10	0	12191	\N
4402	1238	11	0	13337	\N
4409	40	10	0	13020	\N
4409	1244	11	0	13478	\N
4412	75	10	0	13098	\N
4412	1245	11	0	13521	\N
4422	125	2	0	13120	\N
4422	188	3	0	13604	\N
4425	793	2	0	12446	\N
4425	1250	3	0	13614	\N
4427	10	1	0	13519	\N
4427	11	2	0	13619	\N
4432	362	4	0	12070	\N
4432	1252	5	0	13635	\N
4437	1	2	0	13651	\N
4437	112	3	0	13652	\N
4439	142	1	0	13022	\N
4439	143	2	0	13023	\N
4444	67	4	0	13672	\N
4444	1256	5	0	13673	\N
4446	117	2	0	13678	\N
4446	1257	3	0	13679	\N
4449	117	24	0	13684	\N
4449	1258	25	0	13685	\N
4128	360	2	0	10960	\N
4128	510	3	0	12361	\N
4131	40	1	0	12370	\N
4131	41	2	0	12371	\N
4133	391	1	0	11965	\N
4133	392	2	0	11966	\N
4139	33	9	0	12404	\N
4139	1180	10	0	12405	\N
4147	391	2	0	11965	\N
4147	406	3	0	12278	\N
4156	142	2	0	12458	\N
4156	1181	3	0	12459	\N
4158	1	1	0	12440	\N
4158	53	2	0	12441	\N
4163	242	1	0	11825	\N
4163	253	2	0	12473	\N
4166	10	2	0	12410	\N
4166	792	3	0	12481	\N
4167	1	1	0	12484	\N
4167	53	2	0	12485	\N
4168	167	4	0	12494	\N
4168	1182	5	0	12495	\N
4173	40	1	0	12511	\N
4173	41	2	0	12512	\N
4175	202	1	0	12517	\N
4175	203	2	0	12518	\N
4176	10	3	0	12525	\N
4176	347	4	0	12526	\N
4178	117	2	0	12380	\N
4178	175	3	0	12533	\N
4183	125	1	0	12544	\N
4183	1185	2	0	12545	\N
4188	1190	4	0	12567	\N
4188	10	5	0	12568	\N
4190	35	2	0	12575	\N
4190	1191	3	0	12576	\N
4196	60	2	0	12608	\N
4196	166	3	0	12609	\N
4204	40	5	0	12637	\N
4204	1196	6	0	12638	\N
4206	121	2	0	10869	\N
4206	625	3	0	12640	\N
4211	198	1	0	12649	\N
4211	199	2	0	12650	\N
4213	69	1	0	12654	\N
4213	70	2	0	12655	\N
4215	852	1	0	12444	\N
4215	913	2	0	12445	\N
4224	220	2	0	12237	\N
4224	821	3	0	12670	\N
4230	402	1	0	12211	\N
4230	403	2	0	12697	\N
4238	18	5	0	12726	\N
4238	1203	6	0	12727	\N
4240	94	1	0	12730	\N
4240	107	2	0	12731	\N
4242	102	1	0	12734	\N
4242	103	2	0	12735	\N
4249	27	4	0	12018	\N
4249	1209	5	0	12758	\N
4253	117	2	0	12773	\N
4253	175	3	0	12774	\N
4255	54	3	0	6384	\N
4255	476	4	0	12783	\N
4260	253	1	0	11826	\N
4260	242	2	0	12792	\N
4262	65	1	0	12797	\N
4262	64	3	0	11937	\N
4262	1211	4	1	12798	\N
4262	1210	4	0	12799	\N
4262	1212	5	0	12800	\N
4264	64	2	0	11936	\N
4264	162	3	0	12801	\N
4266	10	1	0	12805	\N
4266	11	2	0	12806	\N
4269	119	1	0	12811	\N
4269	120	2	0	12812	\N
4271	1	1	0	12771	\N
4271	53	2	0	12821	\N
4274	300	2	0	11915	\N
4274	1213	3	0	12831	\N
4276	1215	37	0	12833	\N
4276	200	80	0	12834	\N
4276	1216	81	0	12835	\N
4278	10	2	0	12841	\N
4278	29	3	0	12842	\N
4283	56	1	0	12418	\N
4283	57	2	0	12419	\N
4290	40	1	0	12875	\N
4290	41	2	0	12876	\N
4293	23	2	0	12888	\N
4293	1218	3	0	12889	\N
4295	367	1	0	12894	\N
4295	368	2	0	12895	\N
4300	42	0	0	10968	\N
4307	54	1	0	12920	\N
4307	55	2	0	12921	\N
4312	230	2	0	12864	\N
4312	231	3	0	12936	\N
4314	435	2	0	12939	\N
4314	481	3	0	12940	\N
4317	49	1	0	12952	\N
4317	50	2	0	12953	\N
4319	469	1	0	12958	\N
4319	1221	2	0	12959	\N
4321	469	0	0	12958	\N
4324	18	2	0	12967	\N
4324	1222	3	0	12968	\N
4329	10	1	0	12950	\N
4329	11	2	0	12951	\N
4331	44	1	0	12986	\N
4331	45	2	0	12987	\N
4333	77	1	0	12992	\N
4333	78	2	0	12993	\N
4339	132	3	0	12022	\N
4339	814	4	0	12866	\N
4342	108	1	0	12581	\N
4342	109	2	0	13017	\N
4343	40	1	0	13020	\N
4343	41	2	0	13021	\N
4345	189	39	0	11890	\N
4345	1223	40	0	13025	\N
4348	1226	4	0	13036	\N
4351	841	4	0	11785	\N
4351	900	5	0	13050	\N
4356	1	1	0	13064	\N
4356	53	2	0	13065	\N
4361	145	1	0	13078	\N
4361	153	2	0	13079	\N
4366	10	1	0	13096	\N
4366	11	2	0	13097	\N
4369	167	1	0	13114	\N
4369	533	2	0	13115	\N
4371	125	1	0	13120	\N
4371	195	2	0	13121	\N
4378	88	1	0	11250	\N
4378	89	2	0	12103	\N
4385	4	2	0	13150	\N
4385	579	3	0	13151	\N
4387	38	1	0	13154	\N
4387	399	2	0	13155	\N
4394	523	6	0	13272	\N
4394	1	12	0	13283	\N
4394	1233	13	0	13284	\N
4396	1234	6	0	13287	\N
4396	23	12	0	13288	\N
4396	650	13	0	13289	\N
4401	10	10	0	13143	\N
4401	1239	11	0	13338	\N
4403	230	10	0	13359	\N
4403	1240	11	0	13360	\N
4405	1	9	0	13380	\N
4405	1036	10	0	13381	\N
4407	1243	122	0	13434	\N
4407	117	126	0	13435	\N
4407	118	127	0	13436	\N
4408	968	11	0	13457	\N
4413	1021	13	0	11919	\N
4413	1246	14	0	13548	\N
4414	18	9	0	12291	\N
4414	543	10	0	13567	\N
4416	970	10	0	13570	\N
4416	170	13	0	13575	\N
4416	718	14	0	13576	\N
4421	1	2	0	13602	\N
4421	112	3	0	13603	\N
4426	119	1	0	12811	\N
4426	120	2	0	12812	\N
4443	96	4	0	13670	\N
4443	1255	5	0	13671	\N
4445	1	2	0	13668	\N
4445	283	3	0	13677	\N
4448	365	2	0	13682	\N
4448	615	3	0	13683	\N
4450	214	2	0	13686	\N
4450	1259	3	0	13687	\N
4451	51	2	0	12014	\N
4451	1260	3	0	13691	\N
4410	10	10	0	13143	\N
4410	1239	11	0	13338	\N
4419	164	9	0	13588	\N
4419	1248	10	0	13589	\N
4420	56	3	0	13596	\N
4420	676	4	0	13597	\N
4423	79	1	0	13607	\N
4423	81	2	0	13608	\N
4428	30	1	0	13620	\N
4428	418	2	0	13621	\N
4430	367	1	0	13624	\N
4430	368	2	0	13625	\N
4433	365	4	0	13636	\N
4433	1253	5	0	13637	\N
4435	258	2	0	13643	\N
4435	585	3	0	13644	\N
4438	10	2	0	13519	\N
4438	29	3	0	13653	\N
4440	10	1	0	13519	\N
4440	11	2	0	13619	\N
4442	1	4	0	13668	\N
4442	1254	5	0	13669	\N
4447	40	2	0	13680	\N
4447	282	3	0	13681	\N
4411	1239	11	0	13520	\N
4415	970	10	0	13570	\N
4415	170	13	0	13575	\N
4415	718	14	0	13576	\N
4417	1	9	0	13586	\N
4417	1247	10	0	13587	\N
4424	793	22	0	12446	\N
4424	1249	23	0	13611	\N
4429	212	1	0	11986	\N
4429	213	2	0	11987	\N
4431	367	29	0	13624	\N
4431	1251	30	0	13626	\N
4434	42	2	0	10968	\N
4434	681	3	0	13642	\N
4436	75	2	0	13645	\N
4436	159	3	0	13646	\N
4441	365	1	0	13658	\N
4441	366	2	0	13659	\N
4452	1	1	0	13668	\N
4452	53	2	0	13694	\N
4453	2	2	0	13698	\N
4453	131	3	0	13699	\N
4454	149	1	0	13702	\N
4454	499	2	0	13703	\N
4455	208	1	0	13706	\N
4455	209	2	0	13707	\N
4456	10	1	0	13519	\N
4456	11	2	0	13619	\N
4457	316	1	0	11236	\N
4457	317	2	0	11237	\N
4458	96	3	0	13670	\N
4458	1261	4	0	13714	\N
4459	20	1	0	12573	\N
4459	144	2	0	13717	\N
4460	123	4	0	11376	\N
4460	1262	5	0	13725	\N
4461	1263	75	0	13774	\N
4461	181	126	0	13825	\N
4461	1264	127	0	13826	\N
4462	142	1	0	13829	\N
4462	143	2	0	13830	\N
4463	324	1	0	12351	\N
4463	325	2	0	12352	\N
4464	75	1	0	13645	\N
4464	76	2	0	13831	\N
4465	435	1	0	12939	\N
4465	436	2	0	13832	\N
4466	411	1	0	13835	\N
4466	412	2	0	13836	\N
4467	268	1	0	12756	\N
4467	269	2	0	13837	\N
4468	411	0	0	13835	\N
4469	1	3	0	13842	\N
4469	48	4	0	13843	\N
4470	10	1	0	13519	\N
4470	11	2	0	13619	\N
4471	79	3	0	13852	\N
4471	1265	4	0	13853	\N
4472	140	3	0	13854	\N
4472	1266	4	0	13855	\N
4473	14	6	0	13868	\N
4473	1267	7	0	13869	\N
4474	16	1	0	11081	\N
4474	17	2	0	13872	\N
4475	260	1	0	13873	\N
4475	261	2	0	13874	\N
4476	75	1	0	13645	\N
4476	76	2	0	13831	\N
4477	569	2	0	13878	\N
4477	40	3	0	13879	\N
4478	242	0	0	13880	\N
4479	1268	1	0	13881	\N
4479	353	4	0	13884	\N
4479	755	5	0	13885	\N
4480	1269	1	0	13886	\N
4480	44	4	0	13887	\N
4480	161	5	0	13888	\N
4481	1269	1	0	13886	\N
4481	44	3	0	13887	\N
4481	45	4	0	13889	\N
4482	1268	1	0	13881	\N
4482	353	4	0	13884	\N
4482	755	5	0	13885	\N
4483	2	1	0	13892	\N
4483	26	2	0	13893	\N
4484	336	1	0	13894	\N
4484	356	2	0	13895	\N
4485	322	1	0	13898	\N
4485	323	2	0	13899	\N
4486	35	1	0	13902	\N
4486	340	2	0	13903	\N
4487	27	1	0	12018	\N
4487	28	2	0	12657	\N
4488	1	1	0	13906	\N
4488	53	2	0	13907	\N
4489	237	1	0	13910	\N
4489	527	2	0	13911	\N
4490	75	1	0	13912	\N
4490	76	2	0	13913	\N
4491	40	3	0	13920	\N
4491	128	4	0	13921	\N
4492	10	3	0	13922	\N
4492	347	4	0	13923	\N
4494	27	3	0	13924	\N
4494	1270	4	0	13925	\N
4495	793	3	0	13926	\N
4495	1169	4	0	13927	\N
4496	14	5	0	13938	\N
4496	1201	6	0	13939	\N
4497	38	5	0	13940	\N
4497	1271	6	0	13941	\N
4498	453	5	0	9198	\N
4498	1272	6	0	13942	\N
4499	453	2	0	9198	\N
4499	902	3	0	13943	\N
4500	10	4	0	13922	\N
4500	600	5	0	13952	\N
4501	16	1	0	11081	\N
4501	17	2	0	13872	\N
4502	10	2	0	13959	\N
4502	29	3	0	13960	\N
4503	56	2	0	13961	\N
4503	169	3	0	13962	\N
4504	14	1	0	13938	\N
4504	15	2	0	13965	\N
4505	151	1	0	12314	\N
4505	302	2	0	12315	\N
4506	75	1	0	13912	\N
4506	76	2	0	13913	\N
4507	1	1	0	13968	\N
4507	53	2	0	13969	\N
4508	92	1	0	12976	\N
4508	191	2	0	12977	\N
4509	4	1	0	13150	\N
4509	25	2	0	13970	\N
4510	90	1	0	13971	\N
4510	344	2	0	13972	\N
4511	90	54	0	13971	\N
4511	1273	55	0	13979	\N
4512	424	2	0	12788	\N
4512	520	3	0	13984	\N
4513	262	2	0	13126	\N
4513	731	3	0	13985	\N
4514	360	1	0	13988	\N
4514	479	2	0	13989	\N
4515	10	1	0	13992	\N
4515	11	2	0	13993	\N
4516	44	1	0	13994	\N
4516	45	2	0	13995	\N
4517	268	1	0	12756	\N
4517	269	2	0	13837	\N
4518	75	1	0	13912	\N
4518	76	2	0	13913	\N
4519	435	2	0	14000	\N
4519	481	3	0	14001	\N
4520	30	1	0	14004	\N
4520	418	2	0	14005	\N
4521	235	1	0	12191	\N
4521	236	2	0	12192	\N
4528	88	1	0	14024	\N
4528	89	2	0	14025	\N
4530	200	1	0	14028	\N
4530	201	2	0	14029	\N
4532	90	1	0	13971	\N
4532	344	2	0	13972	\N
4537	233	1	0	14045	\N
4537	234	2	0	14046	\N
4539	40	1	0	13920	\N
4539	41	2	0	14049	\N
4544	113	2	0	11871	\N
4544	1277	3	0	14067	\N
4545	27	2	0	14039	\N
4545	619	3	0	14072	\N
4547	793	1	0	13926	\N
4547	1150	2	0	14075	\N
4552	266	0	0	12353	\N
4555	1283	5	0	14119	\N
4555	73	15	0	14120	\N
4555	1284	16	0	14121	\N
4559	73	1	0	9729	\N
4559	74	2	0	9730	\N
4563	18	1	0	14137	\N
4563	19	2	0	14138	\N
4566	224	2	0	14150	\N
4566	1294	3	0	14152	\N
4568	56	1	0	14159	\N
4568	57	2	0	14160	\N
4573	1	2	0	14043	\N
4573	444	3	0	14178	\N
4576	1	2	0	14189	\N
4576	112	3	0	14190	\N
4578	140	1	0	13854	\N
4578	141	2	0	14195	\N
4581	10	1	0	14198	\N
4581	11	2	0	14199	\N
4586	10	5	0	14198	\N
4586	1298	6	0	14215	\N
4602	10	1	0	14198	\N
4602	11	2	0	14199	\N
4610	449	1	0	10934	\N
4610	450	2	0	14297	\N
4614	1	0	0	14189	\N
4621	214	1	0	13686	\N
4621	215	2	0	14325	\N
4623	273	1	0	12854	\N
4623	410	2	0	12855	\N
4625	228	1	0	14330	\N
4625	229	2	0	14331	\N
4628	1	3	0	14341	\N
4628	48	4	0	14342	\N
4631	10	1	0	14349	\N
4631	11	2	0	14350	\N
4633	33	1	0	14353	\N
4633	163	2	0	14354	\N
4635	237	1	0	14019	\N
4635	527	2	0	14020	\N
4637	113	2	0	14361	\N
4637	114	3	0	14362	\N
4640	147	1	0	4481	\N
4640	599	2	0	4482	\N
4648	132	1	0	14381	\N
4648	455	2	0	14382	\N
4651	56	3	0	14395	\N
4651	475	4	0	14396	\N
4654	35	2	0	14404	\N
4654	36	3	0	14405	\N
4656	156	7	0	14423	\N
4656	1313	8	0	14424	\N
4659	73	1	0	9729	\N
4659	74	2	0	9730	\N
4661	137	1	0	14010	\N
4661	138	2	0	14011	\N
4666	62	1	0	11765	\N
4666	63	2	0	14443	\N
4668	1	1	0	14448	\N
4668	53	2	0	14449	\N
4671	16	2	0	14183	\N
4671	445	3	0	14455	\N
4677	16	2	0	14183	\N
4677	155	3	0	14471	\N
4679	360	1	0	14475	\N
4679	479	2	0	14476	\N
4681	264	1	0	14479	\N
4681	270	2	0	14480	\N
4684	1316	1	0	14487	\N
4684	1317	2	0	14488	\N
4690	268	5	0	12756	\N
4690	642	6	0	14504	\N
4696	30	3	0	14516	\N
4696	1319	4	0	14517	\N
4700	290	1	0	13088	\N
4700	291	2	0	14526	\N
4704	852	1	0	12444	\N
4704	913	2	0	12445	\N
4706	167	1	0	14534	\N
4706	533	2	0	14535	\N
4711	20	1	0	14553	\N
4711	144	2	0	14554	\N
4715	288	1	0	14561	\N
4715	400	2	0	14562	\N
4718	1	2	0	14571	\N
4718	112	3	0	14572	\N
4722	186	1	0	13013	\N
4722	187	2	0	13014	\N
4723	597	2	0	14592	\N
4723	767	3	0	14593	\N
4724	595	2	0	10674	\N
4724	768	3	0	10675	\N
4727	79	2	0	14600	\N
4727	80	3	0	14601	\N
4734	324	1	0	14594	\N
4734	325	2	0	14617	\N
4739	435	1	0	14635	\N
4739	436	2	0	14636	\N
4742	115	23	0	14641	\N
4742	1323	24	0	14645	\N
4744	121	2	0	14650	\N
4744	625	3	0	14651	\N
4752	30	1	0	14668	\N
4752	418	2	0	14669	\N
4753	92	1	0	14672	\N
4753	191	2	0	14673	\N
4758	262	1	0	14682	\N
4758	263	2	0	14683	\N
4761	10	1	0	14693	\N
4761	11	2	0	14694	\N
4765	10	1	0	14693	\N
4765	11	2	0	14694	\N
4767	75	1	0	14383	\N
4767	76	2	0	14384	\N
4776	402	3	0	12211	\N
4776	1328	4	0	14735	\N
4780	108	1	0	12581	\N
4780	109	2	0	13017	\N
4782	528	1	0	10912	\N
4782	529	2	0	14284	\N
4785	10	1	0	14693	\N
4785	11	2	0	14694	\N
4788	233	2	0	14045	\N
4788	910	3	0	14770	\N
4791	125	2	0	13120	\N
4791	188	3	0	13604	\N
4793	1	1	0	14781	\N
4793	53	2	0	14782	\N
4798	177	7	0	6357	\N
4798	1329	8	0	14811	\N
4800	40	1	0	14816	\N
4800	41	2	0	14817	\N
4805	10	1	0	14830	\N
4805	11	2	0	14831	\N
4807	164	1	0	14836	\N
4807	165	2	0	14837	\N
4810	1	1	0	14846	\N
4810	53	2	0	14847	\N
4522	137	1	0	14010	\N
4522	138	2	0	14011	\N
4531	51	1	0	14032	\N
4531	52	2	0	14033	\N
4540	235	1	0	14052	\N
4540	236	2	0	14053	\N
4543	285	2	0	12722	\N
4543	1276	3	0	14062	\N
4551	266	0	0	12353	\N
4556	1285	0	0	14122	\N
4556	1286	0	0	14123	\N
4558	73	1	0	9729	\N
4558	74	2	0	9730	\N
4562	1291	1	0	14133	\N
4562	1292	2	0	14134	\N
4567	10	2	0	14155	\N
4567	792	3	0	14156	\N
4572	10	2	0	14172	\N
4572	29	3	0	14173	\N
4577	206	2	0	14191	\N
4577	693	3	0	14192	\N
4579	324	1	0	12351	\N
4579	325	2	0	12352	\N
4589	220	88	0	12237	\N
4589	1301	89	0	14220	\N
4592	210	1	0	14083	\N
4592	211	2	0	14084	\N
4595	1	3	0	14189	\N
4595	48	4	0	14253	\N
4601	40	2	0	14271	\N
4601	66	3	0	14272	\N
4608	326	1	0	11196	\N
4608	327	2	0	11197	\N
4611	8	1	0	14300	\N
4611	9	2	0	14301	\N
4613	94	1	0	14304	\N
4613	107	2	0	14305	\N
4620	264	1	0	14323	\N
4620	270	2	0	14324	\N
4622	244	1	0	14326	\N
4622	245	2	0	14327	\N
4627	73	3	0	9729	\N
4627	993	4	0	14340	\N
4629	10	1	0	14302	\N
4629	11	2	0	14303	\N
4639	595	1	0	10674	\N
4639	596	2	0	14365	\N
4645	1	1	0	14377	\N
4645	53	2	0	14378	\N
4647	793	1	0	14379	\N
4647	1150	2	0	14380	\N
4649	75	1	0	14383	\N
4649	76	2	0	14384	\N
4658	18	1	0	14366	\N
4658	19	2	0	14367	\N
4665	44	1	0	13994	\N
4665	45	2	0	13995	\N
4670	77	2	0	13094	\N
4670	1314	3	0	14454	\N
4672	451	2	0	14456	\N
4672	497	3	0	14457	\N
4674	1315	114	0	14460	\N
4674	49	126	0	14461	\N
4674	789	127	0	14462	\N
4683	135	1	0	14435	\N
4683	136	2	0	14436	\N
4689	16	1	0	14500	\N
4689	17	2	0	14501	\N
4694	86	0	0	5996	\N
4697	431	1	0	14520	\N
4697	432	2	0	14521	\N
4698	96	1	0	14522	\N
4698	97	2	0	14523	\N
4699	2	1	0	13892	\N
4699	26	2	0	13893	\N
4703	841	1	0	14056	\N
4703	842	2	0	14057	\N
4713	16	1	0	14500	\N
4713	17	2	0	14501	\N
4731	92	3	0	12976	\N
4731	1321	4	0	14611	\N
4733	451	1	0	14456	\N
4733	584	2	0	14616	\N
4736	88	1	0	14024	\N
4736	89	2	0	14025	\N
4738	391	2	0	14631	\N
4738	406	3	0	14632	\N
4743	10	2	0	14567	\N
4743	29	3	0	14602	\N
4748	488	3	0	14660	\N
4748	1324	4	0	14661	\N
4751	391	1	0	14666	\N
4751	392	2	0	14667	\N
4760	167	1	0	14691	\N
4760	533	2	0	14692	\N
4770	1	4	0	14712	\N
4770	422	5	0	14724	\N
4772	391	1	0	14666	\N
4772	392	2	0	14667	\N
4775	402	2	0	12211	\N
4775	1148	3	0	12212	\N
4777	92	1	0	14738	\N
4777	191	2	0	14739	\N
4779	40	1	0	14744	\N
4779	41	2	0	14745	\N
4787	2	1	0	14764	\N
4787	26	2	0	14765	\N
4790	10	2	0	14693	\N
4790	29	3	0	14776	\N
4792	167	1	0	14691	\N
4792	533	2	0	14692	\N
4795	353	1	0	14789	\N
4795	354	2	0	14790	\N
4797	75	1	0	14795	\N
4797	76	2	0	14796	\N
4802	449	2	0	14822	\N
4802	1331	3	0	14823	\N
4809	908	1	0	14844	\N
4809	909	2	0	14845	\N
4811	908	107	0	14844	\N
4811	1332	108	0	14901	\N
4813	18	2	0	14910	\N
4813	1222	3	0	14911	\N
4816	200	2	0	14921	\N
4816	1333	3	0	14922	\N
4823	285	2	0	14946	\N
4823	1276	3	0	14947	\N
4827	424	0	0	14975	\N
4832	285	2	0	14946	\N
4832	1276	3	0	14947	\N
4834	449	2	0	15013	\N
4834	583	3	0	15014	\N
4835	220	3	0	12237	\N
4835	477	4	0	15021	\N
4842	189	2	0	15036	\N
4842	311	3	0	15037	\N
4844	40	1	0	15023	\N
4844	41	2	0	15044	\N
4849	435	1	0	15053	\N
4849	436	2	0	15054	\N
4851	10	2	0	15063	\N
4851	792	3	0	15064	\N
4856	173	1	0	12527	\N
4856	396	2	0	15078	\N
4863	56	4	0	15097	\N
4863	1145	5	0	15098	\N
4865	33	1	0	15103	\N
4865	163	2	0	15104	\N
4873	49	1	0	15122	\N
4873	50	2	0	15123	\N
4874	1280	112	1	15126	\N
4874	1345	112	0	15127	\N
4874	1211	113	1	15128	\N
4874	59	113	0	15129	\N
4874	796	114	1	15130	\N
4874	1281	114	0	15131	\N
4874	49	126	0	15132	\N
4523	135	1	0	12057	\N
4523	136	2	0	12058	\N
4525	75	1	0	14015	\N
4525	76	2	0	14016	\N
4527	56	1	0	13961	\N
4527	57	2	0	14021	\N
4534	1	1	0	13968	\N
4534	53	2	0	13969	\N
4536	1	1	0	14043	\N
4536	53	2	0	14044	\N
4541	488	1	0	13066	\N
4541	489	2	0	13067	\N
4549	210	1	0	14083	\N
4549	211	2	0	14084	\N
4554	8	0	0	12513	\N
4565	224	3	0	14150	\N
4565	1293	4	0	14151	\N
4570	189	1	0	14163	\N
4570	190	2	0	14164	\N
4575	16	1	0	14183	\N
4575	17	2	0	14184	\N
4580	14	1	0	13938	\N
4580	15	2	0	13965	\N
4582	88	1	0	14024	\N
4582	89	2	0	14025	\N
4584	35	1	0	13902	\N
4584	340	2	0	13903	\N
4585	8	5	0	12513	\N
4585	1297	6	0	14214	\N
4588	200	5	0	14217	\N
4588	1300	6	0	14218	\N
4590	115	4	0	12460	\N
4590	1302	5	0	14229	\N
4593	930	2	0	8609	\N
4593	1304	3	0	14242	\N
4596	262	3	0	13126	\N
4596	1305	4	0	14254	\N
4598	117	1	0	13678	\N
4598	248	2	0	14257	\N
4599	75	3	0	14015	\N
4599	857	4	0	14264	\N
4604	60	1	0	12608	\N
4604	61	2	0	14279	\N
4606	528	1	0	10912	\N
4606	529	2	0	14284	\N
4609	10	2	0	14293	\N
4609	29	3	0	14294	\N
4612	10	1	0	14302	\N
4612	11	2	0	14303	\N
4616	367	3	0	13624	\N
4616	1307	4	0	14312	\N
4618	1310	1	0	14319	\N
4618	1311	2	0	14320	\N
4630	1	1	0	14347	\N
4630	53	2	0	14348	\N
4634	1	1	0	14347	\N
4634	53	2	0	14348	\N
4643	12	18	0	14372	\N
4643	1312	19	0	14373	\N
4646	10	1	0	14349	\N
4646	11	2	0	14350	\N
4650	149	1	0	14387	\N
4650	499	2	0	14388	\N
4652	40	2	0	14401	\N
4652	66	3	0	14402	\N
4657	1	1	0	14427	\N
4657	53	2	0	14428	\N
4662	135	1	0	14435	\N
4662	136	2	0	14436	\N
4664	237	1	0	14019	\N
4664	527	2	0	14020	\N
4673	49	1	0	12952	\N
4673	50	2	0	12953	\N
4675	58	1	0	14465	\N
4675	59	2	0	14466	\N
4678	365	2	0	13682	\N
4678	519	3	0	14472	\N
4682	137	1	0	14483	\N
4682	138	2	0	14484	\N
4685	10	1	0	14349	\N
4685	11	2	0	14350	\N
4687	212	1	0	14495	\N
4687	213	2	0	14496	\N
4692	266	1	0	12353	\N
4692	267	2	0	12354	\N
4695	86	0	0	5996	\N
4701	75	1	0	14383	\N
4701	76	2	0	14384	\N
4705	841	24	0	14056	\N
4705	1320	25	0	14531	\N
4707	230	1	0	14536	\N
4707	287	2	0	14537	\N
4708	10	1	0	14540	\N
4708	11	2	0	14541	\N
4712	67	1	0	14555	\N
4712	478	2	0	14556	\N
4714	54	1	0	13009	\N
4714	55	2	0	13070	\N
4716	453	1	0	14563	\N
4716	454	2	0	14564	\N
4717	10	1	0	14567	\N
4717	11	2	0	14568	\N
4720	149	1	0	14580	\N
4720	499	2	0	14581	\N
4726	324	2	0	14594	\N
4726	486	3	0	14595	\N
4728	10	2	0	14567	\N
4728	29	3	0	14602	\N
4730	75	2	0	14383	\N
4730	159	3	0	14604	\N
4732	170	3	0	14612	\N
4732	1322	4	0	14613	\N
4740	115	2	0	14641	\N
4740	636	3	0	14642	\N
4747	2	3	0	13892	\N
4747	572	4	0	14659	\N
4749	88	3	0	14662	\N
4749	580	4	0	14663	\N
4754	488	1	0	14660	\N
4754	489	2	0	14676	\N
4756	852	2	0	12444	\N
4756	1325	3	0	14681	\N
4762	35	1	0	14695	\N
4762	340	2	0	14696	\N
4763	322	1	0	14699	\N
4763	323	2	0	14700	\N
4768	1	1	0	14712	\N
4768	53	2	0	14713	\N
4771	75	4	0	14725	\N
4771	172	5	0	14726	\N
4773	345	0	0	14729	\N
4778	300	1	0	14740	\N
4778	355	2	0	14741	\N
4783	164	2	0	14754	\N
4783	226	3	0	14755	\N
4789	200	2	0	14217	\N
4789	887	3	0	14771	\N
4796	10	1	0	14793	\N
4796	11	2	0	14794	\N
4799	316	7	0	14812	\N
4799	1330	8	0	14813	\N
4801	30	1	0	14668	\N
4801	418	2	0	14669	\N
4803	233	1	0	14045	\N
4803	234	2	0	14046	\N
4806	82	1	0	14832	\N
4806	83	2	0	14833	\N
4808	2	1	0	14840	\N
4808	26	2	0	14841	\N
4812	73	1	0	14904	\N
4812	74	2	0	14905	\N
4819	266	1	0	14927	\N
4819	267	2	0	14928	\N
4822	852	1	0	14941	\N
4822	913	2	0	14942	\N
4826	1339	1	0	14973	\N
4826	1340	2	0	14974	\N
4524	110	1	0	10746	\N
4524	134	2	0	14014	\N
4526	237	1	0	14019	\N
4526	527	2	0	14020	\N
4529	258	1	0	14026	\N
4529	309	2	0	14027	\N
4533	1274	5	0	14034	\N
4533	90	14	0	14035	\N
4533	1275	15	0	14036	\N
4535	27	1	0	14039	\N
4535	28	2	0	14040	\N
4538	10	1	0	13992	\N
4538	11	2	0	13993	\N
4542	841	1	0	14056	\N
4542	842	2	0	14057	\N
4548	94	2	0	12730	\N
4548	1278	3	0	14080	\N
4550	142	1	0	13829	\N
4550	143	2	0	13830	\N
4553	1279	5	0	14095	\N
4553	94	15	0	14114	\N
4557	79	0	0	14124	\N
4560	1287	5	0	14127	\N
4560	79	15	0	14128	\N
4560	1288	16	0	14129	\N
4561	1289	5	0	14130	\N
4561	8	15	0	14131	\N
4561	1290	16	0	14132	\N
4564	222	2	0	14143	\N
4564	232	3	0	14144	\N
4569	125	1	0	13120	\N
4569	195	2	0	13121	\N
4571	1295	86	0	14165	\N
4571	189	126	0	14166	\N
4571	1296	127	0	14167	\N
4574	79	1	0	14181	\N
4574	81	2	0	14182	\N
4583	142	1	0	14200	\N
4583	143	2	0	14201	\N
4587	220	5	0	12237	\N
4587	1299	6	0	14216	\N
4591	181	26	0	14234	\N
4591	1303	27	0	14235	\N
4594	113	2	0	14246	\N
4594	114	3	0	14247	\N
4600	14	1	0	13938	\N
4600	15	2	0	13965	\N
4603	1021	1	0	14275	\N
4603	1022	2	0	14276	\N
4605	264	1	0	14280	\N
4605	270	2	0	14281	\N
4607	336	1	0	14285	\N
4607	356	2	0	14286	\N
4615	208	3	0	13706	\N
4615	1306	4	0	14311	\N
4617	1308	53	0	14314	\N
4617	367	99	0	14315	\N
4617	1309	100	0	14316	\N
4619	852	1	0	12444	\N
4619	913	2	0	12445	\N
4624	108	1	0	12581	\N
4624	109	2	0	13017	\N
4626	242	1	0	14332	\N
4626	253	2	0	14333	\N
4632	110	1	0	14351	\N
4632	134	2	0	14352	\N
4636	10	1	0	14349	\N
4636	11	2	0	14350	\N
4638	597	1	0	9774	\N
4638	598	2	0	9775	\N
4641	18	1	0	14366	\N
4641	19	2	0	14367	\N
4642	224	1	0	14370	\N
4642	225	2	0	14371	\N
4644	12	1	0	14372	\N
4644	13	2	0	14374	\N
4653	2	2	0	13892	\N
4653	131	3	0	14403	\N
4655	58	1	0	14408	\N
4655	59	2	0	14409	\N
4660	110	1	0	14351	\N
4660	134	2	0	14352	\N
4663	389	1	0	12148	\N
4663	390	2	0	12149	\N
4667	449	1	0	14444	\N
4667	450	2	0	14445	\N
4669	132	1	0	14381	\N
4669	455	2	0	14382	\N
4676	54	1	0	13009	\N
4676	55	2	0	13070	\N
4680	424	1	0	14477	\N
4680	425	2	0	14478	\N
4686	488	1	0	14491	\N
4686	489	2	0	14492	\N
4688	35	1	0	14404	\N
4688	340	2	0	14499	\N
4691	268	1	0	12756	\N
4691	269	2	0	13837	\N
4693	181	5	0	14508	\N
4693	1318	6	0	14509	\N
4702	10	1	0	14349	\N
4702	11	2	0	14350	\N
4709	260	2	0	13873	\N
4709	419	3	0	14546	\N
4710	170	1	0	14549	\N
4710	398	2	0	14550	\N
4719	40	2	0	14576	\N
4719	66	3	0	14577	\N
4721	33	1	0	14584	\N
4721	163	2	0	14585	\N
4725	147	2	0	4481	\N
4725	516	3	0	6748	\N
4729	164	2	0	13588	\N
4729	226	3	0	14603	\N
4735	290	1	0	14620	\N
4735	291	2	0	14621	\N
4737	214	2	0	13686	\N
4737	227	3	0	14626	\N
4741	123	2	0	14643	\N
4741	384	3	0	14644	\N
4746	367	2	0	13624	\N
4746	651	3	0	14652	\N
4750	258	1	0	14026	\N
4750	309	2	0	14027	\N
4755	121	1	0	14650	\N
4755	122	2	0	14677	\N
4757	262	1	0	14682	\N
4757	263	2	0	14683	\N
4759	424	2	0	14477	\N
4759	520	3	0	14688	\N
4764	1326	20	0	14701	\N
4764	100	30	0	14702	\N
4764	1327	31	0	14703	\N
4766	100	1	0	14706	\N
4766	160	2	0	14707	\N
4769	241	1	0	14714	\N
4769	333	2	0	14715	\N
4774	1	2	0	14712	\N
4774	112	3	0	14734	\N
4781	62	1	0	11765	\N
4781	63	2	0	14443	\N
4784	16	1	0	14500	\N
4784	17	2	0	14501	\N
4786	18	1	0	14760	\N
4786	19	2	0	14761	\N
4794	82	1	0	14785	\N
4794	83	2	0	14786	\N
4804	391	1	0	14826	\N
4804	392	2	0	14827	\N
4815	233	1	0	14045	\N
4815	234	2	0	14046	\N
4818	75	2	0	14795	\N
4818	1335	3	0	14924	\N
4553	1280	16	0	75666	\N
4553	1282	17	1	138410	\N
4814	145	1	0	14914	\N
4814	153	2	0	14915	\N
4817	88	2	0	14662	\N
4817	1334	3	0	14923	\N
4821	1	3	0	14937	\N
4821	1336	4	0	14938	\N
4824	1	2	0	14948	\N
4824	112	3	0	14949	\N
4828	10	0	0	14830	\N
4830	210	2	0	14980	\N
4830	458	3	0	14981	\N
4836	88	3	0	14662	\N
4836	580	4	0	14663	\N
4840	241	1	0	15026	\N
4840	333	2	0	15027	\N
4845	488	1	0	14660	\N
4845	489	2	0	14676	\N
4854	210	2	0	15072	\N
4854	1173	3	0	15073	\N
4857	1109	0	0	13146	\N
4859	411	1	0	15081	\N
4859	412	2	0	15082	\N
4861	40	4	0	15076	\N
4861	564	5	0	15094	\N
4868	79	1	0	14600	\N
4868	81	2	0	15113	\N
4876	451	1	0	15051	\N
4876	584	2	0	15052	\N
4879	10	3	0	15152	\N
4879	347	4	0	15153	\N
4882	228	3	0	14330	\N
4882	492	4	0	15157	\N
4886	151	2	0	15170	\N
4886	576	3	0	15171	\N
4888	273	1	0	12854	\N
4888	410	2	0	12855	\N
4891	10	1	0	15152	\N
4891	11	2	0	15187	\N
4893	189	1	0	15190	\N
4893	190	2	0	15191	\N
4900	451	1	0	15201	\N
4900	584	2	0	15202	\N
4907	367	0	0	13624	\N
4910	113	3	0	15224	\N
4910	1355	4	1	15225	\N
4910	1354	4	0	15226	\N
4820	326	1	0	14929	\N
4820	327	2	0	14930	\N
4825	1337	102	0	14950	\N
4825	285	126	0	14969	\N
4825	1338	127	0	14970	\N
4829	210	2	0	14980	\N
4829	458	3	0	14981	\N
4831	202	1	0	14984	\N
4831	203	2	0	14985	\N
4839	793	0	0	14379	\N
4841	10	1	0	15030	\N
4841	11	2	0	15031	\N
4848	451	1	0	15051	\N
4848	584	2	0	15052	\N
4850	16	1	0	15057	\N
4850	17	2	0	15058	\N
4853	73	2	0	15070	\N
4853	1035	3	0	15071	\N
4855	40	1	0	15076	\N
4855	41	2	0	15077	\N
4864	224	1	0	14370	\N
4864	225	2	0	14371	\N
4867	793	1	0	15079	\N
4867	1150	2	0	15080	\N
4870	40	1	0	15076	\N
4870	41	2	0	15077	\N
4872	322	1	0	15120	\N
4872	323	2	0	15121	\N
4877	10	1	0	15142	\N
4877	11	2	0	15143	\N
4881	198	3	0	12649	\N
4881	1347	4	0	15156	\N
4890	142	1	0	15183	\N
4890	143	2	0	15184	\N
4894	75	1	0	14795	\N
4894	76	2	0	14796	\N
4897	597	0	0	14592	\N
4906	391	1	0	15209	\N
4906	392	2	0	15210	\N
4908	360	3	0	14475	\N
4908	1353	4	0	15221	\N
4833	285	21	0	15011	\N
4833	1341	22	0	15012	\N
4837	108	3	0	12581	\N
4837	837	4	0	15022	\N
4838	40	0	0	15023	\N
4843	1342	86	0	15039	\N
4843	189	126	0	15040	\N
4843	1296	127	0	15041	\N
4846	288	1	0	14561	\N
4846	400	2	0	14562	\N
4847	18	1	0	15047	\N
4847	19	2	0	15048	\N
4852	79	2	0	14600	\N
4852	472	3	0	15069	\N
4858	793	1	0	15079	\N
4858	1150	2	0	15080	\N
4860	1343	116	0	15083	\N
4860	411	122	0	15084	\N
4860	1344	123	0	15085	\N
4862	12	4	0	15095	\N
4862	357	5	0	15096	\N
4866	10	1	0	15107	\N
4866	11	2	0	15108	\N
4869	200	1	0	15114	\N
4869	201	2	0	15115	\N
4871	235	1	0	15118	\N
4871	236	2	0	15119	\N
4880	121	3	0	15154	\N
4880	1346	4	0	15155	\N
4884	220	1	0	12237	\N
4884	221	2	0	12466	\N
4887	173	2	0	15172	\N
4887	480	3	0	15173	\N
4889	228	3	0	14330	\N
4889	492	4	0	15157	\N
4892	16	1	0	15188	\N
4892	17	2	0	15189	\N
4896	595	1	0	10674	\N
4896	596	2	0	14365	\N
4901	18	1	0	15203	\N
4901	19	2	0	15204	\N
4903	391	1	0	15209	\N
4903	392	2	0	15210	\N
4905	316	1	0	15214	\N
4905	317	2	0	15215	\N
4911	113	3	0	15224	\N
4911	778	4	0	15227	\N
4874	789	127	0	15133	\N
4875	10	1	0	15136	\N
4875	11	2	0	15137	\N
4878	173	1	0	12527	\N
4878	396	2	0	15078	\N
4883	33	3	0	15158	\N
4883	1348	4	0	15159	\N
4885	113	1	0	15164	\N
4885	437	2	0	15165	\N
4895	1349	86	0	15192	\N
4895	189	104	0	15193	\N
4895	1350	105	0	15194	\N
4898	147	1	0	15197	\N
4898	599	2	0	15198	\N
4899	451	0	0	14456	\N
4902	1351	0	0	15205	\N
4902	1352	0	0	15206	\N
4904	23	1	0	13285	\N
4904	217	2	0	15211	\N
4909	528	3	0	15222	\N
4909	553	4	0	15223	\N
4912	10	1	0	15230	\N
4912	11	2	0	15231	\N
4913	451	1	0	15232	\N
4913	584	2	0	15233	\N
4914	373	1	0	11177	\N
4914	374	2	0	11178	\N
4915	365	4	0	13682	\N
4915	1253	5	0	15242	\N
4916	1	2	0	15247	\N
4916	112	3	0	15248	\N
4917	40	2	0	15249	\N
4917	66	3	0	15250	\N
4918	167	1	0	15253	\N
4918	533	2	0	15254	\N
4919	241	1	0	15255	\N
4919	333	2	0	15256	\N
4920	488	1	0	14660	\N
4920	489	2	0	14676	\N
4921	181	1	0	15259	\N
4921	530	2	0	15260	\N
4922	1	1	0	15263	\N
4922	53	2	0	15264	\N
4923	40	1	0	15249	\N
4923	41	2	0	15265	\N
4924	40	1	0	15249	\N
4924	41	2	0	15265	\N
4925	402	1	0	12211	\N
4925	403	2	0	12697	\N
4926	459	1	0	12438	\N
4926	460	2	0	12439	\N
4927	79	1	0	14600	\N
4927	81	2	0	15113	\N
4928	170	1	0	14612	\N
4928	398	2	0	15272	\N
4929	90	3	0	15279	\N
4929	877	4	0	15280	\N
4930	23	2	0	15285	\N
4930	24	3	0	15286	\N
4931	88	2	0	15287	\N
4931	154	3	0	15288	\N
4932	260	3	0	15295	\N
4932	271	4	0	15296	\N
4933	198	2	0	15301	\N
4933	1139	3	0	15302	\N
4934	908	2	0	14844	\N
4934	1356	3	0	15306	\N
4936	10	1	0	15230	\N
4936	11	2	0	15231	\N
4937	1	1	0	15311	\N
4937	53	2	0	15312	\N
4938	16	1	0	15188	\N
4938	17	2	0	15189	\N
4939	86	17	0	15313	\N
4939	1357	18	0	15314	\N
4940	86	1	0	15313	\N
4940	87	2	0	15317	\N
4941	1	1	0	15311	\N
4941	53	2	0	15312	\N
4942	14	1	0	15320	\N
4942	15	2	0	15321	\N
4943	115	1	0	14641	\N
4943	116	2	0	15324	\N
4944	256	1	0	12718	\N
4944	257	2	0	15325	\N
4945	14	1	0	15328	\N
4945	15	2	0	15329	\N
4946	40	1	0	15330	\N
4946	41	2	0	15331	\N
4947	69	1	0	12982	\N
4947	70	2	0	12983	\N
4948	96	1	0	14522	\N
4948	97	2	0	14523	\N
4949	73	1	0	15070	\N
4949	74	2	0	15334	\N
4950	58	5	0	15345	\N
4950	1358	6	0	15346	\N
4951	14	1	0	15328	\N
4951	15	2	0	15329	\N
4952	117	1	0	15351	\N
4952	248	2	0	15352	\N
4953	56	1	0	15097	\N
4953	57	2	0	15355	\N
4954	1	1	0	15311	\N
4954	53	2	0	15312	\N
4955	2	1	0	15358	\N
4955	26	2	0	15359	\N
4956	2	1	0	15362	\N
4956	26	2	0	15363	\N
4957	413	1	0	15366	\N
4957	414	2	0	15367	\N
4958	186	1	0	15370	\N
4958	187	2	0	15371	\N
4959	1	1	0	15311	\N
4959	53	2	0	15312	\N
4960	220	3	0	15378	\N
4960	1359	4	0	15379	\N
4961	35	2	0	15384	\N
4961	36	3	0	15385	\N
4962	362	2	0	12070	\N
4962	420	3	0	15386	\N
4963	303	2	0	1136	\N
4963	1360	3	0	15387	\N
4964	10	1	0	15390	\N
4964	11	2	0	15391	\N
4965	1	2	0	15396	\N
4965	112	3	0	15397	\N
4966	30	2	0	14668	\N
4966	31	3	0	15398	\N
4967	123	1	0	15401	\N
4967	124	2	0	15402	\N
4968	160	1	0	15405	\N
4968	100	2	0	15406	\N
4969	10	2	0	15411	\N
4969	29	3	0	15412	\N
4970	453	2	0	15413	\N
4970	902	3	0	15414	\N
4971	10	1	0	15411	\N
4971	11	2	0	15417	\N
4972	14	1	0	15418	\N
4972	15	2	0	15419	\N
4973	54	1	0	15420	\N
4973	55	2	0	15421	\N
4974	10	2	0	15411	\N
4974	792	3	0	15425	\N
4975	1361	1	0	15428	\N
4975	1362	2	0	15429	\N
4976	1	3	0	15436	\N
4976	48	4	0	15437	\N
4977	27	3	0	15438	\N
4977	1270	4	0	15439	\N
4978	40	3	0	15330	\N
4978	128	4	0	15440	\N
4979	186	4	0	15370	\N
4979	1363	5	0	15448	\N
4980	14	4	0	15418	\N
4980	588	5	0	15449	\N
4981	173	4	0	15450	\N
4981	1046	5	0	15451	\N
4982	235	1	0	15118	\N
4982	236	2	0	15119	\N
4985	173	3	0	15450	\N
4985	174	4	0	15463	\N
4995	14	4	0	15496	\N
4995	1365	5	0	15497	\N
4997	40	3	0	15330	\N
4997	869	4	0	15505	\N
5004	228	1	0	15524	\N
5004	229	2	0	15525	\N
5008	16	2	0	15466	\N
5008	445	3	0	15536	\N
5010	94	1	0	15543	\N
5010	107	2	0	15544	\N
5017	75	2	0	15566	\N
5017	159	3	0	15567	\N
5019	10	2	0	15576	\N
5019	29	3	0	15577	\N
5020	360	1	0	15580	\N
5020	479	2	0	15581	\N
5021	10	2	0	15586	\N
5021	29	3	0	15587	\N
5025	2	1	0	15599	\N
5025	26	2	0	15600	\N
5029	115	1	0	15607	\N
5029	116	2	0	15608	\N
5037	210	2	0	15627	\N
5037	458	3	0	15628	\N
5038	210	2	0	15627	\N
5038	458	3	0	15628	\N
5039	210	2	0	15633	\N
5039	458	3	0	15634	\N
5040	1370	2	0	15635	\N
5040	1371	2	0	15636	\N
5040	458	3	0	15637	\N
5045	326	0	0	15644	\N
5052	132	1	0	14381	\N
5052	455	2	0	14382	\N
5059	320	1	0	15528	\N
5059	334	2	0	15529	\N
5061	336	1	0	15693	\N
5061	356	2	0	15694	\N
5062	62	1	0	15697	\N
5062	63	2	0	15698	\N
5066	186	2	0	15370	\N
5066	696	3	0	15709	\N
5069	214	1	0	15716	\N
5069	215	2	0	15717	\N
5076	10	2	0	15740	\N
5076	29	3	0	15741	\N
5081	214	1	0	15716	\N
5081	1382	2	0	15754	\N
5082	40	1	0	15603	\N
5082	1383	2	0	15755	\N
5084	170	2	0	15750	\N
5084	718	3	0	15759	\N
5087	260	2	0	15766	\N
5087	419	3	0	15767	\N
5090	88	2	0	15601	\N
5090	154	3	0	15777	\N
5095	908	2	0	15794	\N
5095	988	3	0	15795	\N
5098	324	3	0	14594	\N
5098	1384	4	0	15804	\N
5103	75	1	0	15816	\N
5103	76	2	0	15817	\N
5109	10	1	0	15834	\N
5109	11	2	0	15835	\N
5112	49	1	0	15122	\N
5112	50	2	0	15123	\N
5117	1109	1	0	13146	\N
5117	1111	2	0	13147	\N
5121	10	2	0	15834	\N
5121	29	3	0	15849	\N
5123	181	2	0	15856	\N
5123	769	3	0	15857	\N
5126	597	2	0	14592	\N
5126	767	3	0	14593	\N
5131	266	1	0	14927	\N
5131	267	2	0	14928	\N
5135	110	2	0	14351	\N
5135	111	3	0	15894	\N
5139	10	2	0	15854	\N
5139	792	3	0	15902	\N
5146	60	1	0	12608	\N
5146	61	2	0	14279	\N
5148	67	1	0	15931	\N
5148	478	2	0	15932	\N
5151	38	1	0	13940	\N
5151	399	2	0	15942	\N
5157	10	2	0	15854	\N
5157	29	3	0	15855	\N
5158	16	1	0	15960	\N
5158	17	2	0	15961	\N
5162	113	1	0	15224	\N
5162	437	2	0	15966	\N
5165	373	1	0	15975	\N
5165	374	2	0	15976	\N
5169	18	1	0	15989	\N
5169	19	2	0	15990	\N
5175	170	2	0	16009	\N
5175	718	3	0	16010	\N
5183	793	2	0	16042	\N
5183	1136	3	0	16043	\N
5188	16	2	0	15971	\N
5188	155	3	0	16060	\N
5191	88	1	0	16072	\N
5191	89	2	0	16073	\N
5196	90	1	0	16086	\N
5196	344	2	0	16087	\N
5198	2	1	0	16092	\N
5198	26	2	0	16093	\N
5203	40	1	0	16111	\N
5203	41	2	0	16112	\N
5206	841	0	0	14056	\N
5208	110	1	0	16123	\N
5208	134	2	0	16124	\N
5213	20	0	0	16131	\N
5215	164	3	0	16138	\N
5215	1405	4	0	16139	\N
5218	167	2	0	15547	\N
5218	168	3	0	16150	\N
5222	264	1	0	16157	\N
5222	270	2	0	16158	\N
5225	367	1	0	16165	\N
5225	368	2	0	16166	\N
5236	10	0	0	15854	\N
5242	10	0	0	16001	\N
5247	10	1	0	16163	\N
5247	11	2	0	16164	\N
5250	597	0	0	14592	\N
5259	12	0	0	16227	\N
5261	244	1	0	14326	\N
5261	245	2	0	14327	\N
5264	288	2	0	14561	\N
5264	289	3	0	16246	\N
5266	214	1	0	16249	\N
5266	215	2	0	16250	\N
5269	268	2	0	15847	\N
5269	1387	3	0	15848	\N
5271	320	1	0	15528	\N
5271	334	2	0	15529	\N
5278	326	2	0	16289	\N
5278	747	3	0	16290	\N
5286	88	1	0	16072	\N
5286	89	2	0	16073	\N
5289	108	1	0	16319	\N
5289	109	2	0	16320	\N
5291	14	1	0	16325	\N
5291	15	2	0	16326	\N
5296	121	1	0	16336	\N
5296	122	2	0	16337	\N
5301	67	1	0	16350	\N
5301	478	2	0	16351	\N
5303	16	1	0	16159	\N
4983	10	1	0	15454	\N
4983	11	2	0	15455	\N
4986	202	3	0	15464	\N
4986	987	4	0	15465	\N
4990	1	1	0	15436	\N
4990	53	2	0	15479	\N
4998	40	1	0	15508	\N
4998	41	2	0	15509	\N
5000	220	1	0	15514	\N
5000	221	2	0	15515	\N
5005	353	1	0	15526	\N
5005	354	2	0	15527	\N
5009	27	1	0	15539	\N
5009	28	2	0	15540	\N
5011	167	1	0	15547	\N
5011	533	2	0	15548	\N
5012	10	1	0	15549	\N
5012	11	2	0	15550	\N
5013	16	1	0	15466	\N
5013	17	2	0	15553	\N
5022	151	2	0	15170	\N
5022	1366	3	0	15592	\N
5026	88	1	0	15601	\N
5026	89	2	0	15602	\N
5033	87	1	0	15617	\N
5033	1368	2	0	15618	\N
5033	1369	2	0	15619	\N
5041	1372	1	0	15640	\N
5041	1373	1	0	15641	\N
5041	1374	2	0	15642	\N
5046	56	2	0	15648	\N
5046	169	3	0	15649	\N
5047	336	1	0	15652	\N
5047	356	2	0	15653	\N
5051	852	3	0	15675	\N
5051	1068	4	0	15676	\N
5053	1376	1	0	15681	\N
5053	1377	2	0	15682	\N
5060	189	1	0	15689	\N
5060	190	2	0	15690	\N
5063	16	1	0	15699	\N
5063	17	2	0	15700	\N
5067	186	1	0	15712	\N
5067	187	2	0	15713	\N
5070	214	3	0	15716	\N
5070	330	4	0	15718	\N
5071	2	1	0	15599	\N
5071	26	2	0	15600	\N
5074	123	1	0	15725	\N
5074	124	2	0	15726	\N
5078	149	2	0	15748	\N
5078	1379	3	0	15749	\N
5091	156	2	0	15482	\N
5091	571	3	0	15778	\N
5092	10	1	0	15775	\N
5092	11	2	0	15781	\N
5093	2	1	0	15784	\N
5093	26	2	0	15785	\N
5096	77	2	0	15796	\N
5096	216	3	0	15797	\N
5100	88	2	0	15601	\N
5100	154	3	0	15777	\N
5104	145	1	0	15820	\N
5104	153	2	0	15821	\N
5108	18	1	0	15830	\N
5108	19	2	0	15831	\N
5115	54	2	0	15842	\N
5115	485	3	0	15843	\N
5120	268	2	0	15847	\N
5120	1387	3	0	15848	\N
5127	10	2	0	15854	\N
5127	29	3	0	15855	\N
5130	75	2	0	15816	\N
5130	159	3	0	15874	\N
5132	40	3	0	15881	\N
5132	128	4	0	15882	\N
5138	173	2	0	15450	\N
5138	1391	3	0	15901	\N
5144	40	1	0	15603	\N
5144	41	2	0	15604	\N
5145	2	2	0	15923	\N
5145	131	3	0	15924	\N
5147	208	1	0	15929	\N
5147	209	2	0	15930	\N
5149	714	2	0	5891	\N
5149	1394	3	0	15937	\N
5154	16	1	0	15699	\N
5154	17	2	0	15700	\N
5155	121	1	0	15154	\N
5155	122	2	0	15951	\N
5168	210	1	0	15987	\N
5168	211	2	0	15988	\N
5173	73	0	0	16004	\N
5177	1398	0	0	16014	\N
5177	1399	0	0	16015	\N
5180	453	5	0	16024	\N
5182	14	1	0	16036	\N
5182	15	2	0	16037	\N
5185	79	1	0	16050	\N
5185	81	2	0	16051	\N
5187	16	1	0	15971	\N
5187	17	2	0	15972	\N
5193	94	1	0	16078	\N
5193	107	2	0	16079	\N
5195	353	1	0	15526	\N
5195	354	2	0	15527	\N
5201	2	2	0	16105	\N
5201	131	3	0	16106	\N
5207	40	1	0	16119	\N
5207	41	2	0	16120	\N
5210	20	0	0	16003	\N
5212	20	0	0	16003	\N
5217	206	1	0	16144	\N
5217	207	2	0	16145	\N
5224	10	1	0	16163	\N
5224	11	2	0	16164	\N
5229	402	2	0	16179	\N
5229	1148	3	0	16180	\N
5231	852	2	0	16181	\N
5231	1325	3	0	16182	\N
5238	597	3	0	14592	\N
5238	1406	4	0	16190	\N
5240	10	0	0	15854	\N
5244	79	1	0	16195	\N
5244	81	2	0	16196	\N
5249	595	0	0	15870	\N
5254	6	0	0	16217	\N
5256	12	2	0	16224	\N
5256	433	3	0	16225	\N
5260	2	1	0	16105	\N
5260	26	2	0	16230	\N
5263	38	2	0	16241	\N
5263	39	3	0	16242	\N
5274	488	1	0	14660	\N
5274	489	2	0	14676	\N
5277	164	2	0	16287	\N
5277	226	3	0	16288	\N
5282	451	1	0	16297	\N
5282	584	2	0	16298	\N
5283	75	1	0	16299	\N
5283	76	2	0	16300	\N
5293	30	1	0	16255	\N
5293	418	2	0	16327	\N
5295	54	1	0	15842	\N
5295	55	2	0	15844	\N
5298	360	1	0	16338	\N
5298	479	2	0	16339	\N
5305	1109	2	0	16364	\N
5305	1412	3	0	16365	\N
5308	54	1	0	16376	\N
5308	55	2	0	16377	\N
5180	1395	8	0	16031	\N
5180	1404	8	1	16030	\N
5180	1402	6	0	138412	\N
5180	1403	7	1	138414	\N
4984	10	3	0	15454	\N
4984	347	4	0	15462	\N
4987	16	3	0	15466	\N
4987	359	4	0	15467	\N
4988	58	1	0	15470	\N
4988	59	2	0	15471	\N
4989	75	2	0	14795	\N
4989	159	3	0	15476	\N
4992	156	1	0	15482	\N
4992	157	2	0	15483	\N
4993	108	1	0	12581	\N
4993	109	2	0	13017	\N
4994	411	4	0	15494	\N
4994	1364	5	0	15495	\N
4996	189	1	0	15190	\N
4996	190	2	0	15191	\N
5003	2	1	0	15522	\N
5003	26	2	0	15523	\N
5007	10	2	0	15534	\N
5007	792	3	0	15535	\N
5015	67	1	0	14555	\N
5015	478	2	0	14556	\N
5016	40	1	0	15508	\N
5016	41	2	0	15509	\N
5023	391	2	0	15593	\N
5023	1367	3	0	15594	\N
5024	258	1	0	15597	\N
5024	309	2	0	15598	\N
5028	88	0	0	15601	\N
5031	411	1	0	15613	\N
5031	412	2	0	15614	\N
5035	87	1	0	15617	\N
5035	86	2	0	15622	\N
5036	45	1	0	15620	\N
5036	44	2	0	15621	\N
5043	33	1	0	15158	\N
5043	163	2	0	15643	\N
5049	18	1	0	15203	\N
5049	19	2	0	15204	\N
5050	336	1	0	15667	\N
5050	356	2	0	15668	\N
5055	300	1	0	15683	\N
5055	355	2	0	15684	\N
5058	402	1	0	12211	\N
5058	403	2	0	12697	\N
5065	198	1	0	15703	\N
5065	199	2	0	15704	\N
5068	142	1	0	15714	\N
5068	143	2	0	15715	\N
5073	324	1	0	14594	\N
5073	325	2	0	14617	\N
5075	402	4	0	12211	\N
5075	1378	5	0	15735	\N
5077	14	1	0	15496	\N
5077	15	2	0	15744	\N
5080	391	2	0	15752	\N
5080	1381	3	0	15753	\N
5086	42	2	0	10968	\N
5086	681	3	0	13642	\N
5088	10	1	0	15764	\N
5088	11	2	0	15770	\N
5089	10	2	0	15775	\N
5089	29	3	0	15776	\N
5094	42	2	0	10968	\N
5094	681	3	0	13642	\N
5102	40	1	0	15603	\N
5102	1386	2	1	15814	\N
5102	1385	2	0	15815	\N
5110	488	1	0	14660	\N
5110	489	2	0	14676	\N
5116	54	1	0	15842	\N
5116	55	2	0	15844	\N
5122	10	2	0	15854	\N
5122	29	3	0	15855	\N
5128	147	2	0	15197	\N
5128	516	3	0	15872	\N
5129	40	2	0	15603	\N
5129	66	3	0	15873	\N
5136	110	1	0	14351	\N
5136	134	2	0	14352	\N
5140	202	2	0	15464	\N
5140	1392	3	0	15903	\N
5150	164	2	0	15938	\N
5150	226	3	0	15939	\N
5152	173	1	0	15450	\N
5152	396	2	0	15943	\N
5156	514	1	0	2900	\N
5156	515	2	0	2901	\N
5160	1021	1	0	14275	\N
5160	1022	2	0	14276	\N
5161	60	1	0	15964	\N
5161	61	2	0	15965	\N
5163	79	1	0	15969	\N
5163	81	2	0	15970	\N
5167	33	1	0	15158	\N
5167	163	2	0	15643	\N
5170	324	3	0	15997	\N
5170	1384	4	0	15998	\N
5171	10	1	0	16001	\N
5171	11	2	0	16002	\N
5176	170	2	0	16009	\N
5176	1396	3	1	16011	\N
5176	1395	3	0	16012	\N
5176	1397	4	0	16013	\N
5178	322	3	0	16018	\N
5178	1400	4	0	16019	\N
5186	6	1	0	16054	\N
5186	194	2	0	16055	\N
5189	189	1	0	15904	\N
5189	190	2	0	16063	\N
5192	75	1	0	16074	\N
5192	76	2	0	16075	\N
5194	117	1	0	16082	\N
5194	248	2	0	16083	\N
5197	324	1	0	16088	\N
5197	325	2	0	16089	\N
5199	367	2	0	16097	\N
5199	651	3	0	16098	\N
5204	10	1	0	16115	\N
5204	11	2	0	16116	\N
5209	86	2	0	16129	\N
5209	509	3	0	16130	\N
5211	20	0	0	16003	\N
5219	44	2	0	16151	\N
5219	161	3	0	16152	\N
5221	10	2	0	16115	\N
5221	29	3	0	16154	\N
5223	16	1	0	16159	\N
5223	17	2	0	16160	\N
5227	77	1	0	16169	\N
5227	78	2	0	16170	\N
5230	170	2	0	16009	\N
5230	718	3	0	16010	\N
5232	10	0	0	15107	\N
5234	10	0	0	15230	\N
5241	147	3	0	15197	\N
5241	148	4	0	16192	\N
5243	10	0	0	16103	\N
5245	64	1	0	16199	\N
5245	65	2	0	16200	\N
5252	42	2	0	16211	\N
5252	681	3	0	16212	\N
5257	12	0	0	16226	\N
5267	244	2	0	14326	\N
5267	438	3	0	16254	\N
5270	256	2	0	16261	\N
5270	335	3	0	16262	\N
5272	765	2	0	16269	\N
5272	1411	3	0	16270	\N
5275	451	1	0	15232	\N
5275	584	2	0	15233	\N
5280	10	1	0	16285	\N
5280	11	2	0	16294	\N
5284	2	1	0	16303	\N
5284	26	2	0	16304	\N
5287	86	2	0	16313	\N
5287	509	3	0	16314	\N
4991	145	1	0	15480	\N
4991	153	2	0	15481	\N
4999	336	1	0	15510	\N
4999	356	2	0	15511	\N
5001	224	1	0	15516	\N
5001	225	2	0	15517	\N
5002	77	1	0	15520	\N
5002	78	2	0	15521	\N
5006	320	1	0	15528	\N
5006	334	2	0	15529	\N
5014	10	1	0	15556	\N
5014	11	2	0	15557	\N
5018	181	1	0	15570	\N
5018	530	2	0	15571	\N
5027	40	1	0	15603	\N
5027	41	2	0	15604	\N
5030	10	1	0	15609	\N
5030	11	2	0	15610	\N
5032	2	1	0	15599	\N
5032	26	2	0	15600	\N
5034	45	1	0	15620	\N
5034	44	2	0	15621	\N
5042	10	1	0	15609	\N
5042	11	2	0	15610	\N
5044	326	3	0	15644	\N
5044	1375	4	0	15645	\N
5048	79	4	0	14600	\N
5048	589	5	0	15662	\N
5054	300	1	0	15683	\N
5054	355	2	0	15684	\N
5056	10	1	0	15609	\N
5056	11	2	0	15610	\N
5057	402	0	0	12211	\N
5064	189	1	0	15701	\N
5064	190	2	0	15702	\N
5072	77	1	0	15520	\N
5072	78	2	0	15521	\N
5079	170	2	0	15750	\N
5079	1380	3	0	15751	\N
5083	256	1	0	12718	\N
5083	257	2	0	15325	\N
5085	10	2	0	15764	\N
5085	29	3	0	15765	\N
5099	102	1	0	15807	\N
5099	103	2	0	15808	\N
5101	228	1	0	15524	\N
5101	229	2	0	15525	\N
5105	125	1	0	13120	\N
5105	195	2	0	13121	\N
5106	373	1	0	15822	\N
5106	374	2	0	15823	\N
5107	164	1	0	15826	\N
5107	165	2	0	15827	\N
5111	324	1	0	15836	\N
5111	325	2	0	15837	\N
5113	290	1	0	14620	\N
5113	291	2	0	14621	\N
5114	49	1	0	15122	\N
5114	50	2	0	15123	\N
5118	1109	0	0	13146	\N
5119	54	2	0	15842	\N
5119	485	3	0	15843	\N
5124	102	3	0	15864	\N
5124	1388	4	0	15865	\N
5125	595	2	0	15870	\N
5125	768	3	0	15871	\N
5133	391	4	0	15752	\N
5133	539	5	0	15887	\N
5134	1109	4	0	15888	\N
5134	1389	5	0	15889	\N
5137	102	2	0	15899	\N
5137	1390	3	0	15900	\N
5141	189	2	0	15904	\N
5141	1393	3	0	15905	\N
5142	69	2	0	15910	\N
5142	500	3	0	15911	\N
5143	94	2	0	15916	\N
5143	95	3	0	15917	\N
5153	40	1	0	15946	\N
5153	41	2	0	15881	\N
5159	208	1	0	15929	\N
5159	209	2	0	15930	\N
5164	16	1	0	15971	\N
5164	17	2	0	15972	\N
5166	367	2	0	15981	\N
5166	651	3	0	15982	\N
5172	20	0	0	16003	\N
5179	453	5	0	16024	\N
5179	1401	6	0	16025	\N
5181	96	1	0	14522	\N
5181	97	2	0	14523	\N
5184	1109	1	0	16046	\N
5184	1111	2	0	16047	\N
5190	6	2	0	16068	\N
5190	179	3	0	16069	\N
5200	10	2	0	16103	\N
5200	29	3	0	16104	\N
5202	435	2	0	16107	\N
5202	481	3	0	16108	\N
5205	841	1	0	14056	\N
5205	842	2	0	14057	\N
5214	20	0	0	16131	\N
5216	230	1	0	14536	\N
5216	287	2	0	14537	\N
5220	451	2	0	15232	\N
5220	452	3	0	16153	\N
5226	16	1	0	16159	\N
5226	17	2	0	16160	\N
5228	40	1	0	16173	\N
5228	41	2	0	16174	\N
5233	10	0	0	15152	\N
5235	10	0	0	15230	\N
5237	595	3	0	15870	\N
5237	813	4	0	16189	\N
5239	224	3	0	15516	\N
5239	387	4	0	16191	\N
5246	1021	1	0	14275	\N
5246	1022	2	0	14276	\N
5248	10	1	0	16205	\N
5248	11	2	0	16206	\N
5251	147	0	0	15197	\N
5253	42	2	0	16211	\N
5255	1409	0	0	16218	\N
5255	1410	0	0	16219	\N
5258	30	0	0	14668	\N
5262	156	2	0	16235	\N
5262	571	3	0	16236	\N
5265	54	1	0	15842	\N
5265	55	2	0	15844	\N
5268	30	2	0	16255	\N
5268	31	3	0	16256	\N
5273	235	2	0	16275	\N
5273	1061	3	0	16276	\N
5276	10	2	0	16285	\N
5276	29	3	0	16286	\N
5279	1021	2	0	14275	\N
5279	1048	3	0	16291	\N
5281	285	1	0	16295	\N
5281	286	2	0	16296	\N
5285	10	1	0	16285	\N
5285	11	2	0	16294	\N
5288	10	2	0	16315	\N
5288	29	3	0	16316	\N
5290	228	1	0	16321	\N
5290	229	2	0	16322	\N
5300	189	2	0	16346	\N
5300	311	3	0	16347	\N
5302	38	1	0	16354	\N
5302	399	2	0	16355	\N
5304	16	1	0	16358	\N
5304	17	2	0	16359	\N
5307	230	1	0	16374	\N
5307	287	2	0	16375	\N
5253	1407	3	0	138416	\N
5253	1408	4	0	138418	\N
5292	51	1	0	14032	\N
5292	52	2	0	14033	\N
5294	242	1	0	16330	\N
5294	253	2	0	16331	\N
5297	173	1	0	15450	\N
5297	396	2	0	15943	\N
5299	40	2	0	16344	\N
5299	66	3	0	16345	\N
5309	16	1	0	16380	\N
5309	17	2	0	16381	\N
5312	391	1	0	15752	\N
5312	392	2	0	16392	\N
5314	149	1	0	15748	\N
5314	499	2	0	16397	\N
5316	94	1	0	16399	\N
5316	107	2	0	16400	\N
5318	253	1	0	16405	\N
5318	242	2	0	16406	\N
5321	584	1	0	16153	\N
5321	451	2	0	16298	\N
5323	177	1	0	6357	\N
5323	498	2	0	6358	\N
5326	10	1	0	16415	\N
5326	11	2	0	16404	\N
5328	214	1	0	16418	\N
5328	215	2	0	16419	\N
5331	391	1	0	15752	\N
5331	392	2	0	16392	\N
5339	49	1	0	15122	\N
5339	50	2	0	15123	\N
5347	793	1	0	16464	\N
5347	1150	2	0	16465	\N
5349	67	0	0	16470	\N
5354	33	1	0	16485	\N
5354	163	2	0	16486	\N
5356	115	1	0	16487	\N
5356	116	2	0	16488	\N
5359	362	1	0	16498	\N
5359	395	2	0	16499	\N
5362	121	2	0	16336	\N
5362	625	3	0	16511	\N
5365	10	1	0	16496	\N
5365	11	2	0	16497	\N
5376	75	0	0	16299	\N
5379	10	1	0	16544	\N
5379	1416	2	0	16545	\N
5381	362	0	0	16548	\N
5384	79	0	0	16549	\N
5393	411	0	0	16556	\N
5395	320	0	0	16557	\N
5406	96	0	0	16432	\N
5410	233	1	0	16551	\N
5410	1418	2	0	16572	\N
5415	391	1	0	16579	\N
5415	1420	2	0	16580	\N
5418	14	2	0	16325	\N
5418	1421	3	0	16584	\N
5422	268	1	0	16588	\N
5422	1422	2	0	16589	\N
5423	75	0	0	16299	\N
5424	10	0	0	16590	\N
5426	12	0	0	16226	\N
5429	92	0	0	14738	\N
5432	132	3	0	16594	\N
5432	1423	4	0	16595	\N
5435	10	0	0	16597	\N
5440	237	1	0	16604	\N
5440	1425	2	0	16605	\N
5442	75	1	0	16608	\N
5442	1427	2	0	16609	\N
5453	1	39	0	15436	\N
5453	1429	40	0	16618	\N
5458	260	7	0	16636	\N
5458	1431	8	0	16637	\N
5303	17	2	0	16160	\N
5306	273	2	0	16370	\N
5306	1413	3	0	16371	\N
5311	58	1	0	16390	\N
5311	59	2	0	16391	\N
5313	189	1	0	16393	\N
5313	190	2	0	16394	\N
5322	71	1	0	9227	\N
5322	72	2	0	16409	\N
5335	119	1	0	16434	\N
5335	120	2	0	16435	\N
5337	18	1	0	15989	\N
5337	19	2	0	15990	\N
5344	79	3	0	16456	\N
5344	272	4	0	16457	\N
5346	16	1	0	16438	\N
5346	17	2	0	16439	\N
5361	88	22	0	16504	\N
5361	1415	23	0	16506	\N
5364	237	2	0	16518	\N
5364	319	3	0	16519	\N
5367	391	2	0	15752	\N
5367	406	3	0	16528	\N
5370	18	0	0	15989	\N
5373	16	0	0	16538	\N
5378	424	0	0	14975	\N
5383	208	0	0	15929	\N
5388	140	0	0	13854	\N
5390	58	0	0	16390	\N
5397	94	0	0	16559	\N
5399	42	0	0	16560	\N
5402	18	0	0	16563	\N
5405	4	0	0	16568	\N
5409	198	0	0	15703	\N
5413	12	0	0	16226	\N
5417	14	0	0	16325	\N
5420	262	0	0	14682	\N
5428	10	0	0	16590	\N
5434	181	0	0	16552	\N
5439	365	1	0	16602	\N
5439	1424	2	0	16603	\N
5444	44	0	0	16151	\N
5446	336	0	0	16611	\N
5450	64	1	0	16615	\N
5450	1428	2	0	16616	\N
5452	51	0	0	14032	\N
5455	336	0	0	16611	\N
5457	49	7	0	16634	\N
5457	1430	8	0	16635	\N
5310	42	2	0	16386	\N
5310	681	3	0	16387	\N
5315	86	1	0	16313	\N
5315	87	2	0	16398	\N
5324	488	1	0	16410	\N
5324	489	2	0	16411	\N
5325	177	105	0	6357	\N
5325	1414	106	0	16412	\N
5327	102	1	0	16416	\N
5327	103	2	0	16417	\N
5329	10	1	0	16422	\N
5329	11	2	0	16423	\N
5333	316	1	0	15214	\N
5333	317	2	0	15215	\N
5338	16	1	0	16438	\N
5338	17	2	0	16439	\N
5340	67	1	0	16442	\N
5340	478	2	0	16443	\N
5342	10	1	0	16422	\N
5342	11	2	0	16423	\N
5345	10	1	0	16460	\N
5345	11	2	0	16461	\N
5350	110	1	0	16473	\N
5350	134	2	0	16474	\N
5352	16	1	0	16438	\N
5352	17	2	0	16439	\N
5355	62	1	0	15697	\N
5355	63	2	0	15698	\N
5357	73	2	0	16004	\N
5357	703	3	0	16493	\N
5360	88	2	0	16504	\N
5360	154	3	0	16505	\N
5368	10	1	0	16496	\N
5368	11	2	0	16497	\N
5369	56	2	0	16535	\N
5369	169	3	0	16536	\N
5371	244	0	0	16537	\N
5374	244	0	0	16539	\N
5377	290	0	0	16541	\N
5382	256	0	0	16261	\N
5385	10	0	0	16550	\N
5391	10	0	0	16554	\N
5398	16	0	0	16546	\N
5400	242	0	0	16561	\N
5403	40	0	0	16344	\N
5407	149	0	0	15748	\N
5411	10	0	0	16573	\N
5414	88	13	0	16575	\N
5414	1419	14	0	16576	\N
5421	198	0	0	15703	\N
5427	256	0	0	16591	\N
5430	40	0	0	16344	\N
5436	108	0	0	16319	\N
5437	10	0	0	16598	\N
5441	18	1	0	16606	\N
5441	1426	2	0	16607	\N
5445	117	0	0	16610	\N
5447	90	0	0	16585	\N
5451	10	0	0	16617	\N
5456	1021	0	0	14275	\N
5317	11	1	0	16403	\N
5317	10	2	0	16404	\N
5319	584	1	0	16153	\N
5319	451	2	0	16298	\N
5320	584	1	0	16153	\N
5320	451	2	0	16298	\N
5330	192	1	0	16424	\N
5330	193	2	0	16425	\N
5332	258	1	0	16426	\N
5332	309	2	0	16427	\N
5334	96	1	0	16432	\N
5334	97	2	0	16433	\N
5336	156	1	0	16436	\N
5336	157	2	0	16437	\N
5341	449	1	0	15013	\N
5341	450	2	0	16446	\N
5343	40	4	0	16344	\N
5343	564	5	0	16453	\N
5348	841	1	0	16468	\N
5348	842	2	0	16469	\N
5351	222	1	0	16475	\N
5351	223	2	0	16476	\N
5353	220	1	0	16481	\N
5353	221	2	0	16482	\N
5358	10	1	0	16496	\N
5358	11	2	0	16497	\N
5363	125	1	0	13120	\N
5363	195	2	0	13121	\N
5366	320	1	0	16522	\N
5366	334	2	0	16523	\N
5372	230	0	0	16374	\N
5375	451	0	0	16540	\N
5380	16	1	0	16546	\N
5380	1087	2	0	16547	\N
5386	233	0	0	16551	\N
5387	181	0	0	16552	\N
5389	56	0	0	16553	\N
5392	228	0	0	16555	\N
5394	40	0	0	16344	\N
5396	242	0	0	16558	\N
5401	10	0	0	16562	\N
5404	273	1	0	16566	\N
5404	1417	2	0	16567	\N
5408	156	0	0	16569	\N
5412	88	0	0	16574	\N
5416	2	1	0	16581	\N
5416	1091	2	0	16582	\N
5419	90	0	0	16585	\N
5425	12	0	0	16226	\N
5431	18	0	0	16592	\N
5433	258	0	0	16596	\N
5438	10	0	0	16599	\N
5443	33	0	0	16485	\N
5448	75	0	0	16612	\N
5449	16	1	0	16546	\N
5449	1087	2	0	16547	\N
5454	10	0	0	16619	\N
5459	228	1	0	16555	\N
5459	1432	2	0	16639	\N
5460	233	0	0	16640	\N
5461	242	0	0	16641	\N
5462	206	0	0	16642	\N
5463	320	0	0	16643	\N
5464	56	0	0	16553	\N
5465	206	0	0	16644	\N
5466	2	0	0	16645	\N
5467	391	0	0	16579	\N
5468	115	0	0	16646	\N
5469	402	0	0	16179	\N
5470	16	0	0	16647	\N
5471	75	0	0	16648	\N
5472	320	0	0	16649	\N
5474	40	0	0	16344	\N
5475	1153	0	0	11684	\N
5476	145	0	0	15820	\N
5477	117	0	0	16650	\N
5478	10	0	0	16651	\N
5479	326	0	0	16289	\N
5480	71	0	0	16652	\N
5481	198	0	0	15703	\N
5482	1433	0	0	16653	\N
5483	40	0	0	16654	\N
5484	212	0	0	16655	\N
5485	290	0	0	16656	\N
5486	206	0	0	16657	\N
5487	10	0	0	16651	\N
5488	186	0	0	15712	\N
5489	453	0	0	16658	\N
5490	51	0	0	16659	\N
5492	391	0	0	16660	\N
5493	56	0	0	16661	\N
5494	10	0	0	16662	\N
5495	16	0	0	16647	\N
5496	10	0	0	16663	\N
5497	125	0	0	16664	\N
5499	18	0	0	16606	\N
5500	40	0	0	16654	\N
5501	235	0	0	16665	\N
5502	10	0	0	16663	\N
5503	320	0	0	16649	\N
5504	79	1	0	16549	\N
5504	1434	2	0	16668	\N
5505	60	0	0	15964	\N
5506	288	0	0	16669	\N
5507	10	0	0	16670	\N
5508	145	0	0	16671	\N
5509	230	0	0	16672	\N
5510	260	0	0	16673	\N
5511	10	0	0	16674	\N
5512	300	1	0	16677	\N
5512	355	2	0	16678	\N
5513	242	1	0	16641	\N
5513	253	2	0	16679	\N
5514	300	57	0	16677	\N
5514	1435	58	0	16680	\N
5515	6	0	0	16681	\N
5516	137	0	0	14483	\N
5517	135	0	0	16682	\N
5518	391	0	0	16660	\N
5519	94	0	0	16559	\N
5520	164	0	0	16683	\N
5521	151	0	0	15170	\N
5522	10	0	0	16674	\N
5523	75	0	0	16648	\N
5524	449	0	0	16684	\N
5525	320	0	0	16685	\N
5526	10	0	0	16674	\N
5527	40	0	0	16654	\N
5528	16	0	0	16647	\N
5529	79	0	0	16686	\N
5530	391	0	0	16687	\N
5531	451	0	0	16688	\N
5532	242	0	0	16689	\N
5533	391	0	0	16687	\N
5534	268	0	0	16690	\N
5535	2	0	0	16691	\N
5536	1109	0	0	16692	\N
5537	73	0	0	16693	\N
5538	75	0	0	16648	\N
5539	10	1	0	16695	\N
5539	1239	2	0	16696	\N
5540	16	1	0	16697	\N
5540	1436	2	0	16698	\N
5541	88	0	0	16699	\N
5542	413	0	0	16700	\N
5543	242	0	0	16701	\N
5544	10	0	0	16702	\N
5545	322	0	0	16018	\N
5546	288	0	0	16703	\N
5547	108	0	0	16319	\N
5548	88	0	0	16704	\N
5549	391	0	0	16705	\N
5550	18	0	0	16706	\N
5551	210	0	0	16707	\N
5552	56	0	0	16708	\N
5554	208	0	0	16709	\N
5555	266	0	0	16710	\N
5556	56	0	0	16711	\N
5560	841	1	0	16713	\N
5560	1437	2	0	16714	\N
5569	10	0	0	16702	\N
5574	235	0	0	16665	\N
5577	115	0	0	16724	\N
5583	336	0	0	16611	\N
5591	147	0	0	15197	\N
5599	137	0	0	16733	\N
5603	8	0	0	14300	\N
5605	208	0	0	16734	\N
5608	16	0	0	16697	\N
5611	10	0	0	16736	\N
5615	488	0	0	16410	\N
5618	56	0	0	16739	\N
5627	119	0	0	16434	\N
5633	10	0	0	16750	\N
5635	102	0	0	16416	\N
5646	228	0	0	16754	\N
5648	258	0	0	16756	\N
5651	228	0	0	16757	\N
5653	135	0	0	16682	\N
5658	360	0	0	16338	\N
5665	79	0	0	16767	\N
5668	345	0	0	14729	\N
5672	100	0	0	16770	\N
5674	793	0	0	16771	\N
5677	198	0	0	16774	\N
5679	268	1	0	16690	\N
5679	269	2	0	16778	\N
5683	94	1	0	16738	\N
5683	107	2	0	16785	\N
5687	56	0	0	16789	\N
5692	64	0	0	16615	\N
5695	123	0	0	16740	\N
5697	322	0	0	16018	\N
5700	316	1	0	16796	\N
5700	317	2	0	16797	\N
5702	10	0	0	16798	\N
5708	49	0	0	16634	\N
5713	260	0	0	16806	\N
5719	220	0	0	16816	\N
5722	235	0	0	16818	\N
5725	750	0	0	8875	\N
5725	1450	0	0	16820	\N
5726	60	1	0	16822	\N
5726	1451	2	0	16823	\N
5729	391	0	0	16826	\N
5731	40	0	0	16828	\N
5734	40	0	0	16830	\N
5739	16	1	0	16835	\N
5739	17	2	0	16836	\N
5742	360	1	0	16338	\N
5742	479	2	0	16339	\N
5744	121	2	0	16786	\N
5744	625	3	0	16845	\N
5759	33	2	0	16892	\N
5759	34	3	0	16893	\N
5762	1021	2	0	14275	\N
5762	1048	3	0	16291	\N
5766	164	2	0	16922	\N
5766	226	3	0	16923	\N
5768	852	1	0	16926	\N
5768	913	2	0	16927	\N
5771	436	1	0	16932	\N
5771	1457	2	0	16933	\N
5771	1458	2	0	16934	\N
5779	237	1	0	16604	\N
5779	527	2	0	16966	\N
5783	324	54	0	16088	\N
5783	1465	55	0	16986	\N
5785	2	3	0	16994	\N
5785	1466	4	0	16995	\N
5790	86	1	0	16313	\N
5790	87	2	0	16398	\N
5795	135	2	0	17014	\N
5795	196	3	0	17015	\N
5797	336	1	0	17019	\N
5797	356	2	0	17020	\N
5800	212	2	0	17030	\N
5800	566	3	0	17031	\N
5805	256	2	0	17043	\N
5805	335	3	0	17044	\N
5807	79	1	0	17047	\N
5807	81	2	0	17048	\N
5815	2	2	0	16994	\N
5815	131	3	0	17073	\N
5820	60	1	0	16822	\N
5820	61	2	0	17087	\N
5825	142	1	0	17095	\N
5825	143	2	0	17096	\N
5829	10	2	0	17059	\N
5829	29	3	0	17060	\N
5832	173	1	0	17109	\N
5832	396	2	0	17110	\N
5834	237	1	0	17117	\N
5834	527	2	0	17118	\N
5837	1269	1	0	17135	\N
5837	44	5	0	17136	\N
5837	1355	6	1	17137	\N
5837	1478	6	0	17138	\N
5837	1480	7	1	17139	\N
5837	1479	7	0	17140	\N
5846	290	1	0	17161	\N
5846	291	2	0	17162	\N
5851	391	1	0	17172	\N
5851	392	2	0	17173	\N
5853	16	2	0	17180	\N
5853	155	3	0	17181	\N
5856	1	0	0	15436	\N
5860	1	0	0	15436	\N
5863	56	2	0	16999	\N
5863	169	3	0	17196	\N
5873	145	2	0	17235	\N
5873	331	3	0	17236	\N
5875	94	1	0	16738	\N
5875	107	2	0	16785	\N
5883	1	0	0	15436	\N
5885	86	0	0	16313	\N
5891	181	5	0	17273	\N
5891	1484	6	0	17274	\N
5895	16	1	0	17282	\N
5895	17	2	0	17283	\N
5900	64	1	0	17306	\N
5900	65	2	0	17307	\N
5901	16	1	0	17302	\N
5901	17	2	0	17303	\N
5908	273	2	0	17325	\N
5908	1159	3	0	17326	\N
5911	237	1	0	17117	\N
5911	527	2	0	17118	\N
5915	256	3	0	17348	\N
5915	1488	4	0	17349	\N
5919	1491	4	0	17354	\N
5923	242	1	0	16730	\N
5923	253	2	0	17360	\N
5935	79	1	0	17417	\N
5935	81	2	0	17418	\N
5938	40	1	0	16996	\N
5938	41	2	0	17034	\N
5940	60	3	0	16822	\N
5940	1493	4	0	17436	\N
5943	14	1	0	17442	\N
5943	15	2	0	17443	\N
5946	27	2	0	17457	\N
5946	619	3	0	17458	\N
5951	121	1	0	17469	\N
5951	122	2	0	17470	\N
5953	16	1	0	17368	\N
5953	17	2	0	17369	\N
5956	113	1	0	17485	\N
5956	437	2	0	17486	\N
5959	1	5	0	17316	\N
5959	1233	6	0	17503	\N
5966	164	1	0	17262	\N
5966	165	2	0	17518	\N
5557	285	0	0	16712	\N
5562	192	0	0	16424	\N
5565	285	0	0	16717	\N
5568	147	0	0	15197	\N
5571	18	0	0	16719	\N
5573	288	0	0	16721	\N
5579	10	0	0	16726	\N
5582	10	0	0	16727	\N
5585	391	0	0	16705	\N
5588	10	0	0	16727	\N
5593	10	0	0	16727	\N
5595	353	0	0	15526	\N
5598	285	0	0	16717	\N
5602	16	0	0	16697	\N
5604	365	0	0	16602	\N
5610	40	0	0	16654	\N
5613	6	0	0	16681	\N
5619	123	0	0	16740	\N
5624	62	0	0	16743	\N
5634	10	0	0	16751	\N
5637	102	0	0	16416	\N
5645	230	0	0	16753	\N
5647	488	0	0	16755	\N
5652	258	0	0	16758	\N
5655	137	0	0	16733	\N
5657	16	0	0	16764	\N
5673	411	0	0	16556	\N
5676	108	0	0	16773	\N
5681	488	1	0	16755	\N
5681	489	2	0	16782	\N
5685	58	0	0	16787	\N
5691	402	0	0	16793	\N
5693	62	0	0	16743	\N
5698	75	0	0	16648	\N
5706	300	0	0	16677	\N
5711	353	0	0	16805	\N
5715	322	0	0	16018	\N
5718	1448	2	0	16814	\N
5718	1449	3	0	16815	\N
5723	156	0	0	16569	\N
5727	453	1	0	16658	\N
5727	1452	2	0	16824	\N
5745	33	1	0	16848	\N
5745	163	2	0	16849	\N
5748	73	1	0	16768	\N
5748	74	2	0	16860	\N
5750	4	1	0	16863	\N
5750	25	2	0	16864	\N
5753	10	3	0	16877	\N
5753	347	4	0	16878	\N
5758	528	1	0	16886	\N
5758	529	2	0	16887	\N
5764	435	3	0	16107	\N
5764	1456	4	0	16909	\N
5774	16	2	0	16835	\N
5778	40	2	0	16962	\N
5778	66	3	0	16963	\N
5781	224	1	0	16974	\N
5781	225	2	0	16975	\N
5784	324	2	0	16088	\N
5784	486	3	0	16987	\N
5787	40	3	0	16996	\N
5787	1467	4	0	16997	\N
5789	56	3	0	16999	\N
5789	1469	4	0	17000	\N
5791	200	1	0	17003	\N
5791	201	2	0	17004	\N
5799	10	2	0	16907	\N
5799	29	3	0	17025	\N
5801	40	1	0	16996	\N
5801	41	2	0	17034	\N
5809	908	1	0	15794	\N
5809	909	2	0	17052	\N
5811	10	2	0	17059	\N
5811	29	3	0	17060	\N
5813	1470	1	0	17064	\N
5813	1471	2	0	17065	\N
5817	156	2	0	16569	\N
5817	571	3	0	17080	\N
5822	459	1	0	17089	\N
5822	460	2	0	17090	\N
5823	597	1	0	16716	\N
5823	598	2	0	17093	\N
5828	20	1	0	16131	\N
5828	144	2	0	17099	\N
5830	4	1	0	16863	\N
5830	25	2	0	16864	\N
5839	1269	1	0	17135	\N
5839	44	5	0	17136	\N
5839	1481	6	0	17144	\N
5840	1269	1	0	17135	\N
5840	44	5	0	17136	\N
5840	1481	6	0	17144	\N
5843	266	3	0	16710	\N
5843	405	4	0	17155	\N
5845	40	1	0	16996	\N
5845	41	2	0	17034	\N
5848	244	1	0	17163	\N
5848	245	2	0	17164	\N
5849	145	1	0	16829	\N
5849	153	2	0	17167	\N
5855	40	1	0	16996	\N
5855	41	2	0	17034	\N
5857	10	2	0	17190	\N
5857	29	3	0	17191	\N
5859	1	0	0	15436	\N
5861	1	0	0	15436	\N
5864	10	2	0	17197	\N
5864	29	3	0	17198	\N
5867	324	2	0	17204	\N
5867	486	3	0	17205	\N
5868	108	3	0	17212	\N
5868	837	4	0	17213	\N
5871	841	1	0	16713	\N
5871	842	2	0	17224	\N
5877	453	1	0	17242	\N
5877	454	2	0	17243	\N
5879	16	2	0	17250	\N
5879	155	3	0	17251	\N
5881	14	1	0	17078	\N
5881	15	2	0	17088	\N
5884	1	3	0	15436	\N
5884	1483	4	0	17261	\N
5887	38	0	0	16354	\N
5889	10	0	0	17197	\N
5890	164	0	0	17262	\N
5893	206	5	0	17276	\N
5893	1486	6	0	17277	\N
5894	167	1	0	17280	\N
5894	533	2	0	17281	\N
5898	16	1	0	17302	\N
5898	17	2	0	17303	\N
5903	30	1	0	17304	\N
5903	418	2	0	17305	\N
5905	170	1	0	16009	\N
5905	398	2	0	17318	\N
5917	67	3	0	16442	\N
5917	1489	4	0	17352	\N
5921	151	1	0	17357	\N
5921	302	2	0	17358	\N
5925	10	1	0	17197	\N
5925	11	2	0	17367	\N
5926	16	1	0	17368	\N
5926	17	2	0	17369	\N
5929	488	2	0	16755	\N
5929	729	3	0	17378	\N
5932	402	1	0	17388	\N
5932	403	2	0	17389	\N
5934	365	1	0	17415	\N
5934	366	2	0	17416	\N
5936	268	1	0	17419	\N
5936	269	2	0	17420	\N
5939	202	1	0	15464	\N
5774	1460	3	1	138420	\N
5774	1462	4	1	138422	\N
5558	75	0	0	16648	\N
5563	181	0	0	16552	\N
5566	290	0	0	16656	\N
5570	40	1	0	16654	\N
5570	1244	2	0	16718	\N
5572	56	0	0	16720	\N
5581	79	0	0	16686	\N
5584	597	0	0	16716	\N
5587	595	0	0	15870	\N
5589	367	0	0	16729	\N
5592	348	0	0	11228	\N
5597	62	0	0	15697	\N
5601	391	0	0	16705	\N
5609	1440	0	0	16735	\N
5612	18	0	0	16719	\N
5628	10	0	0	16736	\N
5631	326	1	0	16747	\N
5631	327	2	0	16748	\N
5636	102	0	0	16416	\N
5639	264	0	0	16752	\N
5642	285	0	0	16717	\N
5643	285	0	0	16717	\N
5649	1021	0	0	14275	\N
5654	244	0	0	16759	\N
5656	1441	11	0	16760	\N
5656	132	13	0	16761	\N
5656	1442	14	1	16762	\N
5656	1355	14	0	16763	\N
5659	173	0	0	16765	\N
5663	10	0	0	16766	\N
5666	73	0	0	16768	\N
5669	6	0	0	16769	\N
5675	16	0	0	16772	\N
5678	389	13	0	12148	\N
5678	1443	14	0	16775	\N
5680	40	1	0	16654	\N
5680	41	2	0	16781	\N
5684	121	0	0	16786	\N
5688	244	0	0	16790	\N
5690	273	0	0	16792	\N
5705	2	0	0	16799	\N
5709	12	0	0	16801	\N
5710	167	1	0	15547	\N
5710	1444	2	0	16804	\N
5714	353	4	0	16807	\N
5714	1445	5	0	16808	\N
5717	16	2	0	16812	\N
5717	1447	3	0	16813	\N
5720	90	0	0	16817	\N
5732	145	0	0	16829	\N
5735	96	0	0	16432	\N
5740	75	1	0	16837	\N
5740	76	2	0	16838	\N
5747	10	1	0	16856	\N
5747	11	2	0	16857	\N
5752	852	1	0	16869	\N
5752	913	2	0	16870	\N
5757	10	1	0	16877	\N
5757	11	2	0	16885	\N
5760	908	2	0	15794	\N
5760	988	3	0	15795	\N
5763	10	3	0	16907	\N
5763	347	4	0	16908	\N
5769	316	1	0	16796	\N
5769	317	2	0	16797	\N
5777	1463	4	0	16956	\N
5777	1464	5	0	16957	\N
5780	264	2	0	16752	\N
5780	265	3	0	16971	\N
5793	449	1	0	16684	\N
5793	450	2	0	17007	\N
5796	137	2	0	16733	\N
5796	197	3	0	17016	\N
5798	908	2	0	15794	\N
5798	988	3	0	15795	\N
5803	12	1	0	16801	\N
5803	13	2	0	17038	\N
5808	210	1	0	16707	\N
5808	211	2	0	17051	\N
5816	14	2	0	17078	\N
5816	383	3	0	17079	\N
5818	42	1	0	17083	\N
5818	43	2	0	17084	\N
5821	14	1	0	17078	\N
5821	15	2	0	17088	\N
5827	210	1	0	16707	\N
5827	211	2	0	17051	\N
5835	262	1	0	14682	\N
5835	263	2	0	14683	\N
5838	1239	1	0	17141	\N
5838	10	5	0	17142	\N
5838	465	6	0	17143	\N
5841	108	1	0	16773	\N
5841	109	2	0	17147	\N
5842	96	3	0	16432	\N
5842	834	4	0	17154	\N
5844	62	1	0	16743	\N
5844	63	2	0	17158	\N
5847	241	1	0	15255	\N
5847	333	2	0	15256	\N
5854	908	1	0	17184	\N
5854	909	2	0	17185	\N
5866	1482	52	0	17201	\N
5866	324	56	0	17202	\N
5866	1384	57	0	17203	\N
5870	192	2	0	17220	\N
5870	838	3	0	17221	\N
5874	228	2	0	16757	\N
5874	511	3	0	17237	\N
5876	1	1	0	15436	\N
5876	53	2	0	15479	\N
5878	212	1	0	17244	\N
5878	213	2	0	17245	\N
5886	40	0	0	16996	\N
5888	230	0	0	16753	\N
5892	164	5	0	17262	\N
5892	1485	6	0	17275	\N
5897	58	1	0	17298	\N
5897	59	2	0	17299	\N
5902	4	1	0	17312	\N
5902	25	2	0	17313	\N
5904	1	1	0	17316	\N
5904	53	2	0	17317	\N
5907	1291	1	0	17319	\N
5907	1292	2	0	17320	\N
5909	71	1	0	16652	\N
5909	72	2	0	17329	\N
5912	233	0	0	16800	\N
5913	323	1	0	17336	\N
5913	322	2	0	17337	\N
5914	6	1	0	17340	\N
5914	194	2	0	17341	\N
5916	214	3	0	17350	\N
5916	330	4	0	17351	\N
5920	300	1	0	16677	\N
5920	355	2	0	16678	\N
5927	18	1	0	17370	\N
5927	19	2	0	17371	\N
5928	142	2	0	17376	\N
5928	656	3	0	17377	\N
5931	10	2	0	17384	\N
5931	29	3	0	17385	\N
5949	18	1	0	17370	\N
5949	19	2	0	17371	\N
5954	235	2	0	17477	\N
5954	1061	3	0	17478	\N
5962	1	1	0	17514	\N
5962	53	2	0	17515	\N
5967	79	2	0	17525	\N
5967	80	3	0	17526	\N
5970	322	2	0	17539	\N
5970	833	3	0	17540	\N
5972	841	1	0	17545	\N
5972	842	2	0	17546	\N
5977	489	1	0	16411	\N
5977	488	2	0	16782	\N
5982	528	2	0	16886	\N
5559	841	0	0	16713	\N
5561	206	0	0	16715	\N
5564	597	0	0	16716	\N
5567	595	0	0	15870	\N
5575	206	0	0	16722	\N
5576	258	0	0	16723	\N
5578	852	0	0	16725	\N
5580	86	0	0	16313	\N
5586	1438	0	0	16728	\N
5590	242	0	0	16730	\N
5594	69	0	0	16731	\N
5596	353	11	0	15526	\N
5596	1439	12	0	16732	\N
5600	135	0	0	16682	\N
5607	233	0	0	16640	\N
5614	251	0	0	16737	\N
5617	94	0	0	16738	\N
5620	56	0	0	16741	\N
5622	88	0	0	16742	\N
5625	145	0	0	16671	\N
5629	16	0	0	16744	\N
5630	149	1	0	15748	\N
5630	499	2	0	16397	\N
5632	288	0	0	16749	\N
5638	102	0	0	16416	\N
5640	264	0	0	16752	\N
5650	908	0	0	15794	\N
5660	324	0	0	16088	\N
5662	149	0	0	15748	\N
5664	214	0	0	16418	\N
5667	18	0	0	16719	\N
5671	69	0	0	16731	\N
5682	198	1	0	16783	\N
5682	199	2	0	16784	\N
5686	10	0	0	16788	\N
5689	18	0	0	16791	\N
5694	488	0	0	16755	\N
5696	88	0	0	16794	\N
5699	260	1	0	16673	\N
5699	261	2	0	16795	\N
5701	528	0	0	15222	\N
5704	214	0	0	16418	\N
5707	233	0	0	16800	\N
5712	71	0	0	16652	\N
5716	117	2	0	16650	\N
5716	1446	3	0	16811	\N
5724	251	0	0	16819	\N
5728	49	0	0	16825	\N
5730	167	0	0	16827	\N
5736	125	0	0	16831	\N
5738	1453	0	0	16832	\N
5741	360	1	0	16338	\N
5741	479	2	0	16339	\N
5746	1454	1	0	16852	\N
5746	1455	2	0	16853	\N
5749	94	1	0	16738	\N
5749	107	2	0	16785	\N
5751	360	1	0	16865	\N
5751	479	2	0	16866	\N
5754	75	3	0	16879	\N
5754	857	4	0	16880	\N
5756	200	1	0	15114	\N
5756	201	2	0	15115	\N
5761	56	1	0	16789	\N
5761	57	2	0	16896	\N
5765	149	3	0	16916	\N
5765	150	4	0	16917	\N
5770	41	1	0	16930	\N
5770	40	2	0	16931	\N
5775	51	2	0	16659	\N
5775	524	3	0	16947	\N
5782	79	2	0	16980	\N
5782	80	3	0	16981	\N
5788	391	3	0	16826	\N
5788	1468	4	0	16998	\N
5794	18	2	0	17012	\N
5794	218	3	0	17013	\N
5802	151	1	0	15170	\N
5802	302	2	0	17035	\N
5810	149	1	0	17053	\N
5810	499	2	0	17054	\N
5812	110	2	0	16473	\N
5812	111	3	0	17061	\N
5814	6	1	0	16769	\N
5814	194	2	0	17068	\N
5824	595	1	0	15870	\N
5824	596	2	0	17094	\N
5826	147	1	0	15197	\N
5826	599	2	0	15198	\N
5831	402	1	0	16793	\N
5831	403	2	0	17108	\N
5833	10	1	0	17113	\N
5833	11	2	0	17114	\N
5836	1244	1	0	17121	\N
5836	40	5	0	17128	\N
5836	1473	6	1	17129	\N
5836	1472	6	0	17130	\N
5836	1475	7	1	17131	\N
5836	1474	7	0	17132	\N
5836	1477	8	1	17133	\N
5836	1476	8	0	17134	\N
5850	79	1	0	17170	\N
5850	81	2	0	17171	\N
5852	391	1	0	17172	\N
5852	392	2	0	17173	\N
5858	1	0	0	15436	\N
5862	1	0	0	15436	\N
5865	156	2	0	17199	\N
5865	571	3	0	17200	\N
5869	164	3	0	17214	\N
5869	307	4	0	17215	\N
5872	362	2	0	17229	\N
5872	420	3	0	17230	\N
5880	714	2	0	5891	\N
5880	1394	3	0	15937	\N
5882	365	0	0	17254	\N
5896	431	5	0	17294	\N
5896	1487	6	0	17295	\N
5899	30	1	0	17304	\N
5899	418	2	0	17305	\N
5906	170	0	0	16009	\N
5910	42	1	0	17332	\N
5910	43	2	0	17333	\N
5918	206	3	0	17276	\N
5918	1490	4	0	17353	\N
5922	367	1	0	16729	\N
5922	368	2	0	17359	\N
5924	54	1	0	17363	\N
5924	55	2	0	17364	\N
5930	233	2	0	16800	\N
5930	910	3	0	17379	\N
5933	402	28	0	17388	\N
5933	1492	29	0	17412	\N
5937	10	1	0	17423	\N
5937	11	2	0	17424	\N
5941	167	3	0	17280	\N
5941	521	4	0	17437	\N
5945	79	2	0	17417	\N
5945	80	3	0	17452	\N
5948	273	1	0	17463	\N
5948	410	2	0	17464	\N
5950	49	1	0	17467	\N
5950	50	2	0	17468	\N
5952	242	1	0	16730	\N
5952	253	2	0	17360	\N
5955	94	1	0	17481	\N
5955	107	2	0	17482	\N
5958	67	2	0	16442	\N
5958	68	3	0	17492	\N
5961	360	1	0	17510	\N
5961	479	2	0	17511	\N
5964	362	1	0	17516	\N
5964	395	2	0	17517	\N
5971	233	2	0	17541	\N
5971	910	3	0	17542	\N
5976	362	1	0	17516	\N
5976	395	2	0	17517	\N
5939	203	2	0	17429	\N
5942	852	3	0	17438	\N
5942	1068	4	0	17439	\N
5944	285	1	0	17446	\N
5944	286	2	0	17447	\N
5947	536	2	0	17459	\N
5947	1494	3	0	17460	\N
5957	852	1	0	17438	\N
5957	913	2	0	17487	\N
5960	18	1	0	17506	\N
5960	19	2	0	17507	\N
5963	316	1	0	16796	\N
5963	317	2	0	16797	\N
5965	164	1	0	17262	\N
5965	165	2	0	17518	\N
5968	391	2	0	17527	\N
5968	406	3	0	17528	\N
5973	10	1	0	17549	\N
5973	11	2	0	17550	\N
5975	10	1	0	17549	\N
5975	11	2	0	17550	\N
5980	396	1	0	17561	\N
5980	173	2	0	17110	\N
5989	40	1	0	17585	\N
5989	41	2	0	17586	\N
5991	324	1	0	17204	\N
5991	325	2	0	17591	\N
5995	1495	2	0	17604	\N
5995	1496	3	0	17605	\N
5997	208	5	0	17617	\N
5997	1497	6	0	17618	\N
6000	56	4	0	16999	\N
6000	185	5	0	17630	\N
6002	10	1	0	17634	\N
6002	11	2	0	17635	\N
6007	1	2	0	17600	\N
6007	112	3	0	17601	\N
6016	77	1	0	17670	\N
6016	78	2	0	17671	\N
6019	92	1	0	17675	\N
6019	191	2	0	17676	\N
6021	35	3	0	15384	\N
6021	1499	4	0	17686	\N
6024	90	2	0	17693	\N
6024	91	3	0	17694	\N
6027	228	1	0	17710	\N
6027	229	2	0	17711	\N
6032	273	1	0	17463	\N
6032	410	2	0	17464	\N
6037	488	2	0	17750	\N
6037	729	3	0	17751	\N
6040	425	1	0	17760	\N
6040	424	2	0	17761	\N
6045	10	1	0	17781	\N
6045	11	2	0	17782	\N
6050	27	2	0	17457	\N
6050	619	3	0	17458	\N
6052	16	1	0	17799	\N
6052	17	2	0	17800	\N
6057	56	1	0	17644	\N
6057	57	2	0	17645	\N
6059	793	2	0	16771	\N
6059	1136	3	0	17815	\N
6062	6	2	0	17823	\N
6062	179	3	0	17824	\N
6064	235	1	0	17827	\N
6064	236	2	0	17828	\N
6070	258	1	0	17851	\N
6070	309	2	0	17852	\N
6072	1	1	0	17718	\N
6072	53	2	0	17857	\N
6074	198	1	0	16783	\N
6074	199	2	0	16784	\N
6079	69	2	0	17874	\N
6079	500	3	0	17875	\N
6086	210	1	0	16707	\N
6086	211	2	0	17051	\N
6090	110	2	0	17898	\N
6090	111	3	0	17899	\N
6091	33	3	0	17904	\N
6091	1348	4	0	17905	\N
6093	18	3	0	17907	\N
6093	127	4	0	17908	\N
6096	170	2	0	17923	\N
6096	718	3	0	17924	\N
6101	6	1	0	17823	\N
6101	194	2	0	17937	\N
6108	1	4	0	17957	\N
6108	1194	5	0	17958	\N
6110	10	1	0	17931	\N
6110	11	2	0	17936	\N
6117	268	0	0	17940	\N
6120	117	1	0	16650	\N
6120	248	2	0	17980	\N
6127	6	1	0	18001	\N
6127	194	2	0	18002	\N
6129	100	1	0	18007	\N
6129	160	2	0	18008	\N
6131	110	2	0	17898	\N
6131	111	3	0	17899	\N
6134	208	1	0	17617	\N
6134	209	2	0	18012	\N
6136	2	1	0	18017	\N
6136	26	2	0	18018	\N
6149	96	0	0	16432	\N
6156	244	1	0	18054	\N
6156	245	2	0	18055	\N
6158	73	1	0	18058	\N
6158	74	2	0	18059	\N
5969	40	2	0	17533	\N
5969	66	3	0	17534	\N
5974	214	1	0	17551	\N
5974	215	2	0	17552	\N
5979	409	1	0	17559	\N
5979	338	2	0	17560	\N
5981	528	2	0	16886	\N
5981	613	3	0	17566	\N
5984	192	2	0	17575	\N
5984	838	3	0	17576	\N
5986	125	2	0	17579	\N
5986	188	3	0	17580	\N
5994	69	2	0	17602	\N
5994	500	3	0	17603	\N
6004	92	1	0	17640	\N
6004	191	2	0	17641	\N
6006	244	1	0	17163	\N
6006	245	2	0	17164	\N
6009	326	1	0	17653	\N
6009	327	2	0	17654	\N
6011	10	1	0	17634	\N
6011	11	2	0	17635	\N
6014	60	1	0	17664	\N
6014	61	2	0	17665	\N
6018	69	1	0	17602	\N
6018	70	2	0	17674	\N
6020	71	1	0	17679	\N
6020	72	2	0	17680	\N
6029	793	3	0	16771	\N
6029	1169	4	0	17720	\N
6039	425	1	0	17760	\N
6039	424	2	0	17761	\N
6042	435	2	0	17769	\N
6042	481	3	0	17770	\N
6047	92	1	0	17675	\N
6047	191	2	0	17676	\N
6054	16	1	0	17803	\N
6054	17	2	0	17804	\N
6058	125	1	0	17579	\N
6058	195	2	0	17810	\N
6067	453	3	0	17242	\N
6067	1503	4	0	17840	\N
6069	402	1	0	17849	\N
6069	403	2	0	17850	\N
6081	75	2	0	17878	\N
6081	159	3	0	17879	\N
6083	79	0	0	17882	\N
6085	200	1	0	17885	\N
6085	201	2	0	17886	\N
6088	1	1	0	17890	\N
6088	53	2	0	17891	\N
6099	260	2	0	16806	\N
6099	419	3	0	17933	\N
6103	256	1	0	17348	\N
6103	257	2	0	17942	\N
6105	326	5	0	17943	\N
6105	1505	6	0	17944	\N
6107	235	4	0	17955	\N
6107	1506	5	0	17956	\N
6112	12	1	0	17962	\N
6112	13	2	0	17963	\N
6114	10	1	0	17931	\N
6114	11	2	0	17936	\N
6119	117	1	0	16650	\N
6119	248	2	0	17980	\N
6121	117	1	0	16650	\N
6121	248	2	0	17980	\N
6124	268	0	0	17991	\N
6133	108	1	0	17212	\N
6133	109	2	0	17633	\N
6135	167	1	0	17280	\N
6135	533	2	0	17281	\N
6140	1	1	0	18027	\N
6140	53	2	0	18028	\N
6144	734	1	0	18033	\N
6144	1508	2	0	18034	\N
6146	96	0	0	16432	\N
6151	10	1	0	18044	\N
6151	11	2	0	18045	\N
6153	1	1	0	18048	\N
6153	53	2	0	18049	\N
6160	841	1	0	18062	\N
6160	842	2	0	18063	\N
5978	409	1	0	17559	\N
5978	338	2	0	17560	\N
5983	113	1	0	17569	\N
5983	437	2	0	17570	\N
5988	316	1	0	16796	\N
5988	317	2	0	16797	\N
5990	10	1	0	17587	\N
5990	11	2	0	17588	\N
5993	1	2	0	17600	\N
5993	112	3	0	17601	\N
5996	40	5	0	17585	\N
5996	385	6	0	17616	\N
5999	360	4	0	17628	\N
5999	467	5	0	17629	\N
6001	108	1	0	17212	\N
6001	109	2	0	17633	\N
6003	228	1	0	17636	\N
6003	229	2	0	17637	\N
6013	1	1	0	17662	\N
6013	53	2	0	17663	\N
6017	135	1	0	17014	\N
6017	136	2	0	16682	\N
6023	44	2	0	16151	\N
6023	161	3	0	16152	\N
6026	40	1	0	17708	\N
6026	41	2	0	17709	\N
6031	18	3	0	17728	\N
6031	127	4	0	17729	\N
6034	488	1	0	16755	\N
6034	489	2	0	16782	\N
6036	77	1	0	17670	\N
6036	78	2	0	17671	\N
6041	23	2	0	15285	\N
6041	24	3	0	15286	\N
6044	10	1	0	17777	\N
6044	11	2	0	17778	\N
6046	18	1	0	17783	\N
6046	19	2	0	17784	\N
6049	678	2	0	5381	\N
6049	1501	3	0	17793	\N
6051	1502	7	0	17795	\N
6051	27	8	0	17796	\N
6056	260	1	0	16806	\N
6056	261	2	0	17809	\N
6061	4	2	0	17821	\N
6061	579	3	0	17822	\N
6063	10	1	0	17781	\N
6063	11	2	0	17782	\N
6065	100	1	0	17831	\N
6065	160	2	0	17832	\N
6066	10	3	0	17781	\N
6066	347	4	0	17839	\N
6073	71	1	0	17853	\N
6073	72	2	0	17854	\N
6076	365	2	0	17415	\N
6076	519	3	0	17866	\N
6078	167	2	0	17280	\N
6078	168	3	0	17869	\N
6080	94	1	0	17876	\N
6080	107	2	0	17877	\N
6087	391	1	0	17527	\N
6087	392	2	0	17889	\N
6089	10	1	0	17894	\N
6089	11	2	0	17895	\N
6095	54	3	0	17917	\N
6095	476	4	0	17918	\N
6098	10	2	0	17931	\N
6098	29	3	0	17932	\N
6100	10	1	0	17931	\N
6100	11	2	0	17936	\N
6102	268	1	0	17940	\N
6102	269	2	0	17941	\N
6104	326	1	0	17653	\N
6104	327	2	0	17654	\N
6106	75	1	0	17945	\N
6106	76	2	0	17946	\N
6109	256	4	0	17348	\N
6109	1507	5	0	17959	\N
6111	228	1	0	17710	\N
6111	229	2	0	17711	\N
6113	2	1	0	17966	\N
6113	26	2	0	17967	\N
6116	1	1	0	17957	\N
6116	53	2	0	17970	\N
6123	10	2	0	17989	\N
6123	792	3	0	17990	\N
6126	1	1	0	17957	\N
6126	53	2	0	17970	\N
6138	14	1	0	18021	\N
6138	15	2	0	18022	\N
6139	60	1	0	17664	\N
6139	61	2	0	17665	\N
6142	54	1	0	17917	\N
6142	55	2	0	18030	\N
6148	96	0	0	16432	\N
6150	10	2	0	18019	\N
6150	29	3	0	18041	\N
6155	214	1	0	18050	\N
6155	215	2	0	18051	\N
6157	110	1	0	17898	\N
6157	134	2	0	18011	\N
6159	256	1	0	17348	\N
6159	257	2	0	17942	\N
6162	16	1	0	18066	\N
6162	17	2	0	18067	\N
5982	613	3	0	17566	\N
5985	10	2	0	17577	\N
5985	29	3	0	17578	\N
5987	42	1	0	17332	\N
5987	43	2	0	17333	\N
5992	1	1	0	17594	\N
5992	53	2	0	17595	\N
5998	67	1	0	17621	\N
5998	478	2	0	17622	\N
6005	56	1	0	17644	\N
6005	57	2	0	17645	\N
6008	322	1	0	17539	\N
6008	323	2	0	17652	\N
6010	326	10	0	17653	\N
6010	1498	11	0	17655	\N
6012	75	1	0	17658	\N
6012	76	2	0	17659	\N
6015	71	1	0	17666	\N
6015	72	2	0	17667	\N
6022	113	2	0	17691	\N
6022	114	3	0	17692	\N
6025	1	5	0	17662	\N
6025	1233	6	0	17705	\N
6028	1	3	0	17718	\N
6028	48	4	0	17719	\N
6030	132	3	0	16594	\N
6030	814	4	0	17721	\N
6033	237	1	0	17734	\N
6033	527	2	0	17735	\N
6035	123	3	0	17742	\N
6035	1500	4	0	17743	\N
6038	58	2	0	17756	\N
6038	665	3	0	17757	\N
6043	82	1	0	17773	\N
6043	83	2	0	17774	\N
6048	338	1	0	17787	\N
6048	409	2	0	17788	\N
6053	56	1	0	17644	\N
6053	57	2	0	17645	\N
6055	33	1	0	17807	\N
6055	163	2	0	17808	\N
6060	220	2	0	16816	\N
6060	821	3	0	17820	\N
6068	373	2	0	17845	\N
6068	1504	3	0	17846	\N
6071	71	1	0	17853	\N
6071	72	2	0	17854	\N
6075	300	2	0	17864	\N
6075	706	3	0	17865	\N
6077	224	2	0	17867	\N
6077	508	3	0	17868	\N
6082	102	2	0	17880	\N
6082	158	3	0	17881	\N
6084	102	0	0	17880	\N
6092	151	3	0	17357	\N
6092	152	4	0	17906	\N
6094	92	3	0	17915	\N
6094	180	4	0	17916	\N
6097	40	2	0	17929	\N
6097	66	3	0	17930	\N
6115	10	1	0	17931	\N
6115	11	2	0	17936	\N
6118	268	3	0	17940	\N
6118	610	4	0	17977	\N
6122	10	1	0	17983	\N
6122	11	2	0	17984	\N
6125	94	3	0	17876	\N
6125	375	4	0	17998	\N
6128	12	1	0	18003	\N
6128	13	2	0	18004	\N
6130	365	1	0	17415	\N
6130	366	2	0	17416	\N
6132	110	1	0	17898	\N
6132	134	2	0	18011	\N
6137	10	1	0	18019	\N
6137	11	2	0	18020	\N
6141	142	1	0	17376	\N
6141	143	2	0	18029	\N
6143	96	0	0	16432	\N
6145	96	1	0	18035	\N
6145	97	2	0	18036	\N
6147	96	0	0	16432	\N
6152	173	1	0	17109	\N
6152	396	2	0	17110	\N
6154	391	1	0	17527	\N
6154	392	2	0	17889	\N
6161	908	1	0	18064	\N
6161	909	2	0	18065	\N
6163	365	3	0	18074	\N
6163	1509	4	0	18075	\N
6164	42	1	0	18078	\N
6164	43	2	0	18079	\N
6165	268	1	0	18080	\N
6165	269	2	0	18081	\N
6166	173	1	0	18082	\N
6166	396	2	0	18083	\N
6167	233	1	0	18086	\N
6167	234	2	0	18087	\N
6168	20	1	0	18088	\N
6168	144	2	0	18089	\N
6169	149	1	0	17053	\N
6169	499	2	0	17054	\N
6170	40	1	0	18092	\N
6170	41	2	0	18093	\N
6171	18	1	0	17907	\N
6171	19	2	0	18094	\N
6172	324	1	0	18097	\N
6172	325	2	0	18098	\N
6173	10	4	0	18044	\N
6173	600	5	0	18107	\N
6174	391	4	0	18108	\N
6174	539	5	0	18109	\N
6175	151	4	0	17357	\N
6175	1510	5	0	18110	\N
6176	10	1	0	18113	\N
6176	11	2	0	18114	\N
6177	391	5	0	18108	\N
6177	1511	6	0	18125	\N
6178	20	5	0	18126	\N
6178	1512	6	0	18127	\N
6179	18	5	0	18128	\N
6179	1513	6	0	18129	\N
6180	16	1	0	18132	\N
6180	17	2	0	18133	\N
6181	30	1	0	17304	\N
6181	418	2	0	17305	\N
6182	40	2	0	18092	\N
6182	66	3	0	18138	\N
6183	10	2	0	18139	\N
6183	29	3	0	18140	\N
6184	75	2	0	17945	\N
6184	159	3	0	18141	\N
6185	10	4	0	18150	\N
6185	1190	5	0	18151	\N
6186	431	1	0	18154	\N
6186	432	2	0	18155	\N
6187	137	3	0	16733	\N
6187	1514	4	0	18161	\N
6188	135	3	0	18162	\N
6188	1515	4	0	18163	\N
6189	40	1	0	18092	\N
6189	41	2	0	18093	\N
6190	288	1	0	18166	\N
6190	400	2	0	18167	\N
6191	73	1	0	18058	\N
6191	74	2	0	18059	\N
6192	413	1	0	16700	\N
6192	414	2	0	18168	\N
6193	67	3	0	18175	\N
6193	1516	4	0	18176	\N
6194	391	1	0	18108	\N
6194	392	2	0	18179	\N
6195	42	1	0	18078	\N
6195	43	2	0	18079	\N
6196	595	1	0	15870	\N
6196	596	2	0	17094	\N
6197	734	1	0	18182	\N
6197	1508	2	0	18183	\N
6206	10	2	0	18206	\N
6206	29	3	0	18219	\N
6210	373	1	0	18229	\N
6210	374	2	0	18230	\N
6213	220	4	0	18239	\N
6213	1521	5	0	18240	\N
6215	391	1	0	18245	\N
6215	392	2	0	18246	\N
6220	27	1	0	18260	\N
6220	28	2	0	18261	\N
6223	402	1	0	18279	\N
6223	403	2	0	18280	\N
6226	324	1	0	18283	\N
6226	325	2	0	18284	\N
6236	1	2	0	18048	\N
6236	112	3	0	18315	\N
6240	62	2	0	18325	\N
6240	683	3	0	18326	\N
6243	1	2	0	18048	\N
6243	112	3	0	18315	\N
6245	453	1	0	18339	\N
6245	454	2	0	18340	\N
6247	391	1	0	18347	\N
6247	392	2	0	18348	\N
6253	336	1	0	18251	\N
6253	356	2	0	18371	\N
6255	16	2	0	18376	\N
6255	155	3	0	18377	\N
6256	27	4	0	18386	\N
6256	942	5	0	18387	\N
6266	260	2	0	16806	\N
6266	419	3	0	17933	\N
6269	262	1	0	18432	\N
6269	263	2	0	18433	\N
6270	260	3	0	18440	\N
6270	271	4	0	18441	\N
6271	40	4	0	18450	\N
6271	564	5	0	18451	\N
6278	90	1	0	17693	\N
6278	344	2	0	18461	\N
6284	18	1	0	18477	\N
6284	19	2	0	18478	\N
6289	119	2	0	18493	\N
6289	891	3	0	18494	\N
6295	435	1	0	18507	\N
6295	436	2	0	18508	\N
6296	230	1	0	18511	\N
6296	287	2	0	18512	\N
6299	137	1	0	18515	\N
6299	138	2	0	18516	\N
6305	156	1	0	18533	\N
6305	157	2	0	18534	\N
6310	734	1	0	18182	\N
6310	1508	2	0	18183	\N
6318	391	1	0	18578	\N
6318	392	2	0	18579	\N
6320	27	1	0	18582	\N
6320	28	2	0	18583	\N
6322	262	1	0	18586	\N
6322	263	2	0	18587	\N
6325	140	1	0	18592	\N
6325	141	2	0	18593	\N
6327	10	1	0	18418	\N
6327	11	2	0	18500	\N
6329	235	1	0	18281	\N
6329	236	2	0	18282	\N
6330	149	3	0	18608	\N
6330	150	4	0	18609	\N
6335	264	1	0	18616	\N
6335	270	2	0	18617	\N
6339	1540	58	0	18626	\N
6339	145	126	0	18691	\N
6339	1541	127	0	18692	\N
6341	100	1	0	18551	\N
6341	160	2	0	18552	\N
6343	56	1	0	17644	\N
6343	57	2	0	17645	\N
6346	1542	58	0	18757	\N
6346	145	126	0	18825	\N
6346	1541	127	0	18826	\N
6350	10	1	0	18834	\N
6350	11	2	0	18835	\N
6364	1546	2	0	18889	\N
6368	316	1	0	16796	\N
6368	317	2	0	16797	\N
6372	220	3	0	18919	\N
6372	477	4	0	18920	\N
6375	1	1	0	18926	\N
6375	53	2	0	18927	\N
6379	62	2	0	18325	\N
6379	1547	3	0	18938	\N
6382	10	1	0	18950	\N
6382	11	2	0	18951	\N
6384	10	1	0	18950	\N
6384	11	2	0	18951	\N
6387	435	1	0	18507	\N
6387	436	2	0	18508	\N
6392	30	1	0	18979	\N
6392	418	2	0	18980	\N
6394	56	2	0	18987	\N
6394	169	3	0	18988	\N
6397	288	0	0	18316	\N
6399	262	3	0	18996	\N
6399	1552	4	1	18997	\N
6399	1551	4	0	18998	\N
6399	1554	5	1	18999	\N
6399	1553	5	0	19000	\N
6401	75	3	0	19002	\N
6401	857	4	0	19003	\N
6408	2	4	0	19036	\N
6408	315	5	0	19037	\N
6411	186	2	0	15712	\N
6411	696	3	0	19050	\N
6414	147	6	0	15197	\N
6414	1557	7	0	19063	\N
6418	1	2	0	19072	\N
6418	112	3	0	19073	\N
6427	40	4	0	19180	\N
6427	564	5	0	19181	\N
6430	241	4	0	19185	\N
6430	686	5	0	19186	\N
6436	237	2	0	17734	\N
6436	319	3	0	19203	\N
6442	16	2	0	18844	\N
6442	155	3	0	18845	\N
6444	10	2	0	19233	\N
6444	29	3	0	19234	\N
6446	33	2	0	19240	\N
6446	34	3	0	19241	\N
6449	10	2	0	19250	\N
6449	29	3	0	19251	\N
6451	75	1	0	19257	\N
6451	76	2	0	19258	\N
6456	260	4	0	19278	\N
6456	538	5	0	19279	\N
6462	27	4	0	19306	\N
6462	942	5	0	19307	\N
6467	2	2	0	19328	\N
6467	131	3	0	19329	\N
6469	435	1	0	18507	\N
6469	436	2	0	18508	\N
6472	151	2	0	19349	\N
6472	576	3	0	19350	\N
6482	16	2	0	19383	\N
6482	155	3	0	19384	\N
6486	264	2	0	18616	\N
6486	265	3	0	19397	\N
6491	73	2	0	18058	\N
6491	703	3	0	19419	\N
6496	16	4	0	19442	\N
6496	380	5	0	19443	\N
6498	119	0	0	19446	\N
6503	40	2	0	19467	\N
6503	66	3	0	19468	\N
6505	66	2	0	19475	\N
6198	597	1	0	16716	\N
6198	598	2	0	17093	\N
6201	16	0	0	18132	\N
6203	142	10	0	17376	\N
6203	1520	11	0	18210	\N
6207	33	2	0	18217	\N
6207	34	3	0	18220	\N
6208	40	1	0	18223	\N
6208	41	2	0	18224	\N
6218	353	1	0	18256	\N
6218	354	2	0	18257	\N
6224	235	1	0	18281	\N
6224	236	2	0	18282	\N
6228	38	20	0	16354	\N
6228	1526	21	0	18290	\N
6231	326	3	0	18302	\N
6231	1375	4	0	18303	\N
6233	151	1	0	17357	\N
6233	302	2	0	17358	\N
6248	56	1	0	17644	\N
6248	57	2	0	17645	\N
6250	151	2	0	18355	\N
6250	576	3	0	18356	\N
6259	396	1	0	18398	\N
6259	173	2	0	18399	\N
6260	75	2	0	18404	\N
6260	159	3	0	18405	\N
6262	12	1	0	18003	\N
6262	13	2	0	18004	\N
6264	82	1	0	18412	\N
6264	83	2	0	18413	\N
6267	1	1	0	18422	\N
6267	53	2	0	18423	\N
6272	595	4	0	15870	\N
6272	1530	5	0	18452	\N
6280	424	1	0	18468	\N
6280	425	2	0	18469	\N
6282	251	1	0	16819	\N
6282	252	2	0	18472	\N
6287	290	1	0	17161	\N
6287	291	2	0	17162	\N
6290	33	1	0	18217	\N
6290	163	2	0	18497	\N
6292	151	1	0	18501	\N
6292	302	2	0	18502	\N
6300	135	1	0	18162	\N
6300	136	2	0	18517	\N
6306	96	5	0	18035	\N
6306	1535	6	0	18545	\N
6308	214	5	0	18050	\N
6308	1537	6	0	18548	\N
6311	241	2	0	18557	\N
6311	281	3	0	18558	\N
6313	173	1	0	18561	\N
6313	396	2	0	18562	\N
6314	4	3	0	17821	\N
6314	1538	4	0	18569	\N
6316	424	1	0	18468	\N
6316	425	2	0	18469	\N
6319	1	1	0	18580	\N
6319	53	2	0	18581	\N
6323	75	1	0	18588	\N
6323	76	2	0	18589	\N
6333	402	1	0	18279	\N
6333	403	2	0	18280	\N
6337	2	1	0	18620	\N
6337	26	2	0	18621	\N
6344	140	1	0	18592	\N
6344	141	2	0	18593	\N
6347	119	1	0	18827	\N
6347	120	2	0	18828	\N
6348	96	1	0	18035	\N
6348	97	2	0	18036	\N
6351	79	2	0	18840	\N
6351	80	3	0	18841	\N
6353	16	2	0	18844	\N
6353	155	3	0	18845	\N
6356	38	2	0	18860	\N
6356	39	3	0	18861	\N
6359	10	1	0	18873	\N
6359	11	2	0	18874	\N
6362	1	1	0	18884	\N
6362	53	2	0	18885	\N
6369	79	1	0	18901	\N
6369	81	2	0	18902	\N
6376	38	1	0	18928	\N
6376	399	2	0	18929	\N
6377	77	1	0	18932	\N
6377	78	2	0	18933	\N
6380	156	3	0	18897	\N
6380	1548	4	0	18945	\N
6385	51	1	0	18958	\N
6385	52	2	0	18959	\N
6390	528	1	0	18973	\N
6390	529	2	0	18974	\N
6395	391	0	0	18578	\N
6400	262	3	0	18996	\N
6400	1305	4	0	19001	\N
6405	94	2	0	18475	\N
6405	1555	3	0	19017	\N
6409	324	1	0	19040	\N
6409	325	2	0	19041	\N
6412	132	2	0	19051	\N
6412	133	3	0	19052	\N
6415	1021	6	0	19064	\N
6415	1558	7	0	19065	\N
6419	170	2	0	18924	\N
6419	718	3	0	19074	\N
6421	123	2	0	19077	\N
6421	384	3	0	19078	\N
6423	156	2	0	19167	\N
6423	571	3	0	19168	\N
6425	10	2	0	18985	\N
6425	29	3	0	18986	\N
6428	170	4	0	18924	\N
6428	171	5	0	19182	\N
6432	1470	2	0	19194	\N
6432	1565	3	0	19195	\N
6434	51	2	0	19070	\N
6434	524	3	0	19071	\N
6437	2	2	0	19204	\N
6437	131	3	0	19205	\N
6439	2	6	0	19204	\N
6439	1566	7	0	19216	\N
6440	367	6	0	16729	\N
6440	1567	7	0	19226	\N
6445	79	2	0	19235	\N
6445	80	3	0	19236	\N
6447	16	2	0	18844	\N
6447	155	3	0	18845	\N
6452	16	3	0	19264	\N
6452	359	4	0	19265	\N
6454	16	2	0	19269	\N
6454	155	3	0	19270	\N
6457	212	4	0	19286	\N
6457	1568	5	0	19287	\N
6460	353	4	0	18256	\N
6460	1570	5	0	19297	\N
6465	117	1	0	19320	\N
6465	248	2	0	19321	\N
6470	251	1	0	19336	\N
6470	252	2	0	19337	\N
6474	1	2	0	19072	\N
6474	112	3	0	19073	\N
6476	1470	2	0	19362	\N
6476	1565	3	0	19363	\N
6479	192	2	0	19379	\N
6479	838	3	0	19380	\N
6481	251	2	0	19381	\N
6481	828	3	0	19382	\N
6483	77	2	0	18932	\N
6483	216	3	0	19389	\N
6488	1572	54	0	19405	\N
6488	1573	55	0	19406	\N
6490	2	4	0	19328	\N
6490	315	5	0	19414	\N
6493	841	2	0	19424	\N
6199	322	1	0	18184	\N
6199	323	2	0	18185	\N
6202	10	10	0	18206	\N
6202	1518	11	1	18207	\N
6202	1517	11	0	18208	\N
6202	1519	12	0	18209	\N
6205	33	3	0	18217	\N
6205	1348	4	0	18218	\N
6212	1	4	0	18048	\N
6212	1194	5	0	18238	\N
6217	10	3	0	18241	\N
6217	1524	4	0	18253	\N
6222	67	2	0	18275	\N
6222	68	3	0	18276	\N
6227	38	2	0	16354	\N
6227	39	3	0	18289	\N
6229	10	1	0	18293	\N
6229	11	2	0	18294	\N
6230	353	3	0	18256	\N
6230	1527	4	0	18301	\N
6235	100	2	0	18313	\N
6235	101	3	0	18314	\N
6238	373	2	0	18229	\N
6238	1504	3	0	18318	\N
6239	142	2	0	18323	\N
6239	656	3	0	18324	\N
6242	10	2	0	18333	\N
6242	29	3	0	18334	\N
6244	40	1	0	18337	\N
6244	41	2	0	18338	\N
6249	88	2	0	18353	\N
6249	154	3	0	18354	\N
6252	16	4	0	18258	\N
6252	1529	5	0	18368	\N
6258	1	1	0	18394	\N
6258	53	2	0	18395	\N
6261	14	1	0	18408	\N
6261	15	2	0	18409	\N
6274	597	4	0	16716	\N
6274	1531	5	0	18454	\N
6277	82	1	0	18459	\N
6277	83	2	0	18460	\N
6279	30	1	0	18464	\N
6279	418	2	0	18465	\N
6286	115	1	0	16724	\N
6286	116	2	0	18485	\N
6288	451	1	0	16688	\N
6288	584	2	0	18488	\N
6291	10	1	0	18418	\N
6291	11	2	0	18500	\N
6294	86	1	0	18505	\N
6294	87	2	0	18506	\N
6298	324	1	0	18513	\N
6298	325	2	0	18514	\N
6302	326	1	0	18522	\N
6302	327	2	0	18523	\N
6304	79	2	0	17882	\N
6304	80	3	0	18530	\N
6307	224	5	0	18546	\N
6307	1536	6	0	18547	\N
6312	16	1	0	18376	\N
6312	17	2	0	18458	\N
6315	64	3	0	18570	\N
6315	130	4	0	18571	\N
6324	1	1	0	18580	\N
6324	53	2	0	18581	\N
6326	18	1	0	18596	\N
6326	19	2	0	18597	\N
6332	402	1	0	18279	\N
6332	403	2	0	18280	\N
6334	326	2	0	18612	\N
6334	1539	3	0	18613	\N
6345	88	1	0	18353	\N
6345	89	2	0	18699	\N
6352	92	2	0	18842	\N
6352	93	3	0	18843	\N
6355	10	3	0	18854	\N
6355	347	4	0	18855	\N
6358	102	2	0	18869	\N
6358	158	3	0	18870	\N
6361	75	2	0	18588	\N
6361	159	3	0	18881	\N
6363	40	1	0	18450	\N
6363	41	2	0	18831	\N
6366	1	1	0	18893	\N
6366	53	2	0	18894	\N
6371	198	1	0	18503	\N
6371	199	2	0	18504	\N
6374	170	1	0	18924	\N
6374	398	2	0	18925	\N
6378	173	1	0	18561	\N
6378	396	2	0	18562	\N
6381	40	1	0	18450	\N
6381	41	2	0	18831	\N
6386	40	1	0	18962	\N
6386	41	2	0	18963	\N
6389	233	2	0	18086	\N
6389	910	3	0	18970	\N
6391	132	1	0	18977	\N
6391	455	2	0	18978	\N
6398	793	0	0	18989	\N
6404	1	4	0	19015	\N
6404	422	5	0	19016	\N
6407	1	3	0	19026	\N
6407	48	4	0	19027	\N
6416	597	6	0	16716	\N
6416	1559	7	0	19066	\N
6420	181	2	0	19075	\N
6420	769	3	0	19076	\N
6422	1560	58	0	19129	\N
6422	145	90	0	19161	\N
6422	1562	91	1	19162	\N
6422	1561	91	0	19163	\N
6431	121	2	0	17469	\N
6431	625	3	0	19190	\N
6433	10	2	0	19196	\N
6433	29	3	0	19197	\N
6435	18	2	0	19198	\N
6435	218	3	0	19199	\N
6441	10	2	0	19196	\N
6441	29	3	0	19197	\N
6448	33	2	0	19248	\N
6448	34	3	0	19249	\N
6459	237	4	0	19295	\N
6459	1569	5	0	19296	\N
6461	23	4	0	19304	\N
6461	867	5	0	19305	\N
6464	451	3	0	19316	\N
6464	1571	4	0	19317	\N
6475	908	2	0	18064	\N
6475	988	3	0	19357	\N
6477	198	2	0	19322	\N
6477	746	3	0	19364	\N
6480	233	2	0	18086	\N
6480	910	3	0	18970	\N
6484	20	2	0	18126	\N
6484	702	3	0	19390	\N
6489	10	4	0	19250	\N
6489	600	5	0	19413	\N
6494	10	2	0	19430	\N
6494	29	3	0	19431	\N
6501	16	2	0	19442	\N
6501	155	3	0	19457	\N
6504	235	2	0	19469	\N
6504	1061	3	0	19470	\N
6506	10	4	0	19430	\N
6506	600	5	0	19484	\N
6511	137	2	0	18515	\N
6511	197	3	0	19501	\N
6513	258	2	0	17851	\N
6513	585	3	0	19507	\N
6516	27	0	0	17457	\N
6522	108	2	0	19539	\N
6522	501	3	0	19540	\N
6527	1021	2	0	19064	\N
6527	1048	3	0	19561	\N
6530	56	2	0	19518	\N
6200	147	1	0	15197	\N
6200	599	2	0	15198	\N
6204	75	1	0	17945	\N
6204	76	2	0	17946	\N
6209	341	1	0	18227	\N
6209	342	2	0	18228	\N
6211	149	1	0	17053	\N
6211	499	2	0	17054	\N
6214	10	4	0	18241	\N
6214	1522	5	0	18242	\N
6216	336	3	0	18251	\N
6216	1523	4	0	18252	\N
6219	16	1	0	18258	\N
6219	17	2	0	18259	\N
6221	100	4	0	18007	\N
6221	1525	5	0	18270	\N
6225	56	1	0	17644	\N
6225	57	2	0	17645	\N
6232	326	11	0	18305	\N
6232	1528	12	0	18306	\N
6234	300	2	0	17864	\N
6234	706	3	0	17865	\N
6237	288	2	0	18316	\N
6237	289	3	0	18317	\N
6241	453	1	0	17242	\N
6241	454	2	0	17243	\N
6246	528	1	0	18343	\N
6246	529	2	0	18344	\N
6251	192	1	0	17575	\N
6251	193	2	0	18359	\N
6254	1	2	0	18048	\N
6254	112	3	0	18315	\N
6257	224	1	0	18390	\N
6257	225	2	0	18391	\N
6263	852	1	0	17438	\N
6263	913	2	0	17487	\N
6265	10	2	0	18418	\N
6265	29	3	0	18419	\N
6268	449	2	0	18428	\N
6268	583	3	0	18429	\N
6273	2	4	0	18017	\N
6273	315	5	0	18453	\N
6275	147	4	0	15197	\N
6275	551	5	0	18455	\N
6276	16	1	0	18376	\N
6276	17	2	0	18458	\N
6281	1532	1	0	18470	\N
6281	1533	2	0	18471	\N
6283	94	1	0	18475	\N
6283	107	2	0	18476	\N
6285	18	1	0	18481	\N
6285	19	2	0	18482	\N
6293	198	1	0	18503	\N
6293	199	2	0	18504	\N
6297	841	1	0	18062	\N
6297	842	2	0	18063	\N
6301	285	1	0	18520	\N
6301	286	2	0	18521	\N
6303	326	1	0	18524	\N
6303	1534	2	0	18525	\N
6309	100	1	0	18551	\N
6309	160	2	0	18552	\N
6317	1	1	0	18574	\N
6317	53	2	0	18575	\N
6321	258	1	0	17851	\N
6321	309	2	0	17852	\N
6328	324	1	0	18513	\N
6328	325	2	0	18514	\N
6331	402	1	0	18279	\N
6331	403	2	0	18280	\N
6336	326	1	0	18522	\N
6336	327	2	0	18523	\N
6338	10	2	0	18418	\N
6338	29	3	0	18419	\N
6340	54	1	0	17917	\N
6340	55	2	0	18030	\N
6342	75	1	0	18588	\N
6342	76	2	0	18589	\N
6349	40	1	0	18450	\N
6349	41	2	0	18831	\N
6354	1021	3	0	18852	\N
6354	1543	4	0	18853	\N
6357	10	1	0	18854	\N
6357	11	2	0	18864	\N
6360	719	11	0	18875	\N
6360	1544	12	0	18876	\N
6365	300	1	0	17864	\N
6365	355	2	0	18892	\N
6367	156	1	0	18897	\N
6367	157	2	0	18898	\N
6370	10	3	0	18909	\N
6370	347	4	0	18910	\N
6373	88	3	0	18353	\N
6373	580	4	0	18921	\N
6383	1549	1	0	18952	\N
6383	1550	2	0	18953	\N
6388	58	2	0	18968	\N
6388	665	3	0	18969	\N
6393	10	2	0	18985	\N
6393	29	3	0	18986	\N
6396	322	0	0	18184	\N
6402	1	1	0	18926	\N
6402	53	2	0	18927	\N
6403	10	4	0	18985	\N
6403	600	5	0	19014	\N
6406	40	3	0	19024	\N
6406	128	4	0	19025	\N
6410	40	3	0	19024	\N
6410	128	4	0	19025	\N
6413	595	6	0	15870	\N
6413	1556	7	0	19062	\N
6417	51	2	0	19070	\N
6417	524	3	0	19071	\N
6424	10	2	0	18985	\N
6424	29	3	0	18986	\N
6426	94	8	0	19172	\N
6426	1563	9	0	19173	\N
6429	222	4	0	19183	\N
6429	1564	5	0	19184	\N
6438	222	2	0	19183	\N
6438	232	3	0	19206	\N
6450	6	2	0	18001	\N
6450	179	3	0	19255	\N
6453	852	3	0	17438	\N
6453	1068	4	0	17439	\N
6455	16	0	0	19271	\N
6458	79	4	0	19235	\N
6458	589	5	0	19294	\N
6463	1470	2	0	19194	\N
6463	1565	3	0	19195	\N
6466	198	1	0	19322	\N
6466	199	2	0	19323	\N
6468	121	2	0	19330	\N
6468	625	3	0	19331	\N
6471	40	3	0	19180	\N
6471	869	4	0	19344	\N
6473	16	2	0	19351	\N
6473	155	3	0	19352	\N
6478	79	4	0	19373	\N
6478	589	5	0	19374	\N
6485	1	2	0	19395	\N
6485	112	3	0	19396	\N
6487	230	2	0	18511	\N
6487	231	3	0	19402	\N
6492	10	2	0	19250	\N
6492	29	3	0	19251	\N
6497	449	4	0	19444	\N
6497	1574	5	0	19445	\N
6499	852	2	0	17438	\N
6499	1325	3	0	19451	\N
6507	10	2	0	19489	\N
6507	29	3	0	19490	\N
6509	1	2	0	19497	\N
6509	112	3	0	19498	\N
6514	200	4	0	19516	\N
6514	899	5	0	19517	\N
6518	244	2	0	18054	\N
6493	1161	3	0	19425	\N
6495	367	2	0	19432	\N
6495	651	3	0	19433	\N
6500	119	2	0	19446	\N
6500	891	3	0	19452	\N
6502	228	2	0	17710	\N
6502	511	3	0	19462	\N
6508	123	2	0	19491	\N
6508	384	3	0	19492	\N
6510	402	2	0	19499	\N
6510	1148	3	0	19500	\N
6515	56	4	0	19518	\N
6515	1145	5	0	19519	\N
6519	38	2	0	19529	\N
6519	39	3	0	19530	\N
6521	189	2	0	19533	\N
6521	311	3	0	19534	\N
6528	73	2	0	19566	\N
6528	703	3	0	19567	\N
6533	75	2	0	19575	\N
6533	159	3	0	19576	\N
6535	10	2	0	19587	\N
6535	29	3	0	19588	\N
6537	326	2	0	19589	\N
6537	747	3	0	19590	\N
6539	108	2	0	19597	\N
6539	501	3	0	19598	\N
6544	30	2	0	18979	\N
6544	31	3	0	19616	\N
6547	202	2	0	19541	\N
6547	812	3	0	19542	\N
6554	262	3	0	18996	\N
6554	1579	4	0	19653	\N
6556	119	0	0	19446	\N
6561	20	2	0	19668	\N
6561	702	3	0	19669	\N
6564	435	1	0	19672	\N
6564	1580	2	0	19673	\N
6569	1148	2	0	19692	\N
6569	402	3	0	19500	\N
6576	40	2	0	19608	\N
6576	66	3	0	19609	\N
6579	841	2	0	19424	\N
6579	1161	3	0	19425	\N
6581	121	2	0	19722	\N
6581	625	3	0	19723	\N
6583	212	3	0	19730	\N
6583	784	4	0	19731	\N
6587	18	1	0	19748	\N
6587	1426	2	0	19749	\N
6588	212	9	0	19767	\N
6588	1590	10	0	19768	\N
6590	10	2	0	19718	\N
6590	29	3	0	19719	\N
6593	1	2	0	19744	\N
6593	112	3	0	19786	\N
6595	164	2	0	19702	\N
6595	226	3	0	19792	\N
6610	115	2	0	19804	\N
6610	636	3	0	19860	\N
6614	23	0	0	19845	\N
6616	10	2	0	19870	\N
6616	29	3	0	19871	\N
6619	79	2	0	19888	\N
6619	80	3	0	19889	\N
6621	125	2	0	17579	\N
6621	188	3	0	17580	\N
6629	391	0	0	17527	\N
6631	356	1	0	19926	\N
6631	336	5	0	19933	\N
6631	337	6	0	19934	\N
6633	102	2	0	19941	\N
6633	158	3	0	19942	\N
6638	488	6	0	19965	\N
6638	1601	7	0	19966	\N
6642	119	4	0	19999	\N
6642	423	5	0	20000	\N
6645	16	2	0	19894	\N
6645	155	3	0	19895	\N
6649	54	4	0	17917	\N
6649	1604	5	0	20029	\N
6657	147	2	0	20062	\N
6657	516	3	0	20063	\N
6659	431	2	0	20068	\N
6659	531	3	0	20069	\N
6663	27	3	0	19306	\N
6663	1270	4	0	20080	\N
6666	10	2	0	20087	\N
6666	29	3	0	20088	\N
6671	90	4	0	19863	\N
6671	358	5	0	20104	\N
6675	18	1	0	20119	\N
6675	19	2	0	20120	\N
6683	322	4	0	18184	\N
6683	1616	5	0	20175	\N
6688	424	4	0	18468	\N
6688	1620	5	0	19936	\N
6693	1470	2	0	19362	\N
6693	1565	3	0	19363	\N
6694	242	6	0	16730	\N
6694	1630	7	0	20396	\N
6696	10	4	0	20407	\N
6696	600	5	0	20408	\N
6699	326	2	0	20424	\N
6699	747	3	0	20425	\N
6701	324	2	0	20430	\N
6701	486	3	0	20431	\N
6710	151	2	0	19349	\N
6710	576	3	0	19350	\N
6712	353	2	0	20495	\N
6712	755	3	0	20496	\N
6715	60	2	0	19720	\N
6715	166	3	0	19721	\N
6718	1	4	0	20529	\N
6718	422	5	0	20530	\N
6721	1	4	0	20557	\N
6721	422	5	0	20558	\N
6723	595	2	0	15870	\N
6723	768	3	0	15871	\N
6728	94	0	0	20577	\N
6730	92	2	0	20586	\N
6730	93	3	0	20587	\N
6733	75	4	0	19575	\N
6733	172	5	0	20600	\N
6742	10	2	0	20493	\N
6742	29	3	0	20494	\N
6752	2	2	0	20668	\N
6752	131	3	0	20669	\N
6764	10	3	0	20722	\N
6764	465	4	0	20731	\N
6766	200	1	0	20735	\N
6766	201	2	0	20736	\N
6769	10	4	0	20722	\N
6769	600	5	0	20751	\N
6505	40	3	0	19468	\N
6512	135	2	0	18162	\N
6512	196	3	0	19502	\N
6517	27	4	0	19306	\N
6517	942	5	0	19307	\N
6520	1	2	0	19531	\N
6520	112	3	0	19532	\N
6524	214	2	0	19543	\N
6524	227	3	0	19544	\N
6526	51	2	0	19555	\N
6526	524	3	0	19556	\N
6529	1	2	0	19531	\N
6529	112	3	0	19532	\N
6531	1575	2	0	19573	\N
6531	1576	3	0	19574	\N
6542	40	2	0	19608	\N
6542	66	3	0	19609	\N
6550	77	2	0	18932	\N
6550	216	3	0	19389	\N
6567	573	2	0	19680	\N
6567	1581	3	0	19681	\N
6572	10	4	0	19666	\N
6572	600	5	0	19701	\N
6574	1583	4	0	19704	\N
6574	1584	4	0	19705	\N
6574	1586	5	1	19706	\N
6574	1585	5	0	19707	\N
6586	1	5	0	19744	\N
6586	1233	6	0	19745	\N
6591	96	2	0	19778	\N
6591	482	3	0	19779	\N
6594	208	2	0	17617	\N
6594	854	3	0	19787	\N
6596	86	0	0	19793	\N
6598	115	4	0	19804	\N
6598	1302	5	0	19805	\N
6600	12	4	0	19807	\N
6600	357	5	0	19808	\N
6602	841	6	0	19424	\N
6602	1594	7	0	19814	\N
6605	30	2	0	19658	\N
6605	31	3	0	19659	\N
6606	23	8	0	19845	\N
6606	984	9	0	19846	\N
6608	2	2	0	19853	\N
6608	131	3	0	19854	\N
6611	273	2	0	19861	\N
6611	1159	3	0	19862	\N
6613	115	0	0	19865	\N
6617	16	2	0	19876	\N
6617	155	3	0	19877	\N
6625	77	7	0	19914	\N
6625	1597	8	0	19922	\N
6627	391	0	0	17527	\N
6636	10	2	0	19951	\N
6636	29	3	0	19952	\N
6639	6	4	0	19975	\N
6639	670	5	0	19976	\N
6647	40	2	0	20018	\N
6647	66	3	0	20019	\N
6650	56	2	0	19518	\N
6650	169	3	0	19568	\N
6652	40	2	0	20039	\N
6652	66	3	0	20040	\N
6655	595	2	0	15870	\N
6655	768	3	0	15871	\N
6664	27	4	0	19306	\N
6664	942	5	0	19307	\N
6667	1	2	0	20072	\N
6667	112	3	0	20073	\N
6668	20	2	0	19668	\N
6668	702	3	0	19669	\N
6673	2	2	0	20115	\N
6673	131	3	0	20116	\N
6678	268	2	0	18080	\N
6678	1387	3	0	20138	\N
6681	619	2	0	20143	\N
6681	27	6	0	20157	\N
6681	28	7	1	20158	\N
6681	1615	7	0	20159	\N
6686	18	7	0	20191	\N
6686	1618	8	0	20192	\N
6689	1621	104	0	20291	\N
6689	94	125	0	20312	\N
6689	1623	126	1	20313	\N
6689	1622	126	0	20314	\N
6689	1624	127	0	20315	\N
6691	164	4	0	20376	\N
6691	1582	5	0	20377	\N
6697	1	4	0	20417	\N
6697	422	5	0	20418	\N
6702	486	2	0	20433	\N
6702	324	126	0	20431	\N
6702	1632	127	1	20434	\N
6702	1355	127	0	20435	\N
6705	10	2	0	20463	\N
6705	29	3	0	20464	\N
6708	40	2	0	20085	\N
6708	66	3	0	20086	\N
6713	288	2	0	18316	\N
6713	289	3	0	18317	\N
6719	108	4	0	20539	\N
6719	669	5	0	20540	\N
6726	40	2	0	20569	\N
6726	66	3	0	20570	\N
6731	528	2	0	20588	\N
6731	613	3	0	20589	\N
6738	212	2	0	19767	\N
6738	566	3	0	20611	\N
6740	137	2	0	18515	\N
6740	197	3	0	19501	\N
6743	908	2	0	20626	\N
6743	988	3	0	20627	\N
6747	200	2	0	20643	\N
6747	887	3	0	20644	\N
6750	391	2	0	20660	\N
6750	406	3	0	20661	\N
6757	1470	2	0	20690	\N
6757	1565	3	0	20691	\N
6760	230	8	0	20709	\N
6760	1643	9	0	20710	\N
6762	10	5	0	20722	\N
6762	1645	6	0	20723	\N
6767	1648	0	0	20737	\N
6767	1649	0	0	20738	\N
6518	438	3	0	19524	\N
6523	202	2	0	19541	\N
6523	812	3	0	19542	\N
6525	2	2	0	19549	\N
6525	131	3	0	19550	\N
6532	1	2	0	19531	\N
6532	112	3	0	19532	\N
6534	90	2	0	19581	\N
6534	91	3	0	19582	\N
6541	908	2	0	18064	\N
6541	988	3	0	19357	\N
6546	12	6	0	18003	\N
6546	1577	7	0	19630	\N
6549	77	0	0	18932	\N
6552	44	2	0	19644	\N
6552	161	3	0	19645	\N
6553	92	3	0	18842	\N
6553	1578	4	0	19652	\N
6558	30	2	0	19658	\N
6558	31	3	0	19659	\N
6560	10	2	0	19666	\N
6560	29	3	0	19667	\N
6563	142	2	0	19670	\N
6563	656	3	0	19671	\N
6566	149	2	0	19674	\N
6566	697	3	0	19675	\N
6571	1148	2	0	19692	\N
6571	402	3	0	19500	\N
6578	10	2	0	19718	\N
6578	29	3	0	19719	\N
6582	18	1	0	19198	\N
6582	1426	2	0	19724	\N
6585	233	5	0	18086	\N
6585	1589	6	0	19743	\N
6592	10	2	0	19784	\N
6592	29	3	0	19785	\N
6597	10	4	0	19802	\N
6597	600	5	0	19803	\N
6601	115	2	0	19804	\N
6601	1593	3	0	19809	\N
6604	49	4	0	19823	\N
6604	1595	5	0	19824	\N
6607	189	8	0	19847	\N
6607	1596	9	0	19848	\N
6618	10	2	0	19882	\N
6618	29	3	0	19883	\N
6623	79	4	0	19904	\N
6623	589	5	0	19905	\N
6624	77	4	0	19914	\N
6624	1132	5	0	19915	\N
6626	206	7	0	17276	\N
6626	1598	8	0	19923	\N
6635	244	2	0	19945	\N
6635	438	3	0	19946	\N
6641	1	4	0	19744	\N
6641	422	5	0	19990	\N
6644	40	2	0	19741	\N
6644	66	3	0	20011	\N
6651	353	2	0	18256	\N
6651	755	3	0	20034	\N
6654	173	6	0	20055	\N
6654	1605	7	0	20056	\N
6656	597	2	0	16716	\N
6656	767	3	0	20061	\N
6658	132	2	0	19051	\N
6658	133	3	0	19052	\N
6661	1	2	0	20072	\N
6661	112	3	0	20073	\N
6665	40	2	0	20085	\N
6665	66	3	0	20086	\N
6670	62	4	0	20102	\N
6670	1606	5	0	20103	\N
6672	804	2	0	20109	\N
6672	1607	3	0	20110	\N
6677	10	2	0	20087	\N
6677	29	3	0	20088	\N
6680	31	2	0	20154	\N
6680	30	6	0	20155	\N
6680	1319	7	0	20156	\N
6682	90	3	0	19863	\N
6682	877	4	0	20166	\N
6685	360	4	0	17628	\N
6685	1617	5	0	20178	\N
6690	1625	40	0	20331	\N
6690	449	126	0	20368	\N
6690	1627	127	1	20369	\N
6690	1626	127	0	20370	\N
6698	16	4	0	19894	\N
6698	380	5	0	20419	\N
6703	258	4	0	20444	\N
6703	635	5	0	20445	\N
6704	322	6	0	18184	\N
6704	1633	7	0	20458	\N
6707	1	6	0	20478	\N
6707	523	7	0	20479	\N
6714	336	2	0	20505	\N
6714	740	3	0	20506	\N
6717	112	2	0	20519	\N
6717	1	3	0	20520	\N
6720	435	12	0	20547	\N
6720	1634	13	0	20548	\N
6725	147	2	0	20062	\N
6725	516	3	0	20063	\N
6727	33	2	0	20575	\N
6727	34	3	0	20576	\N
6732	316	4	0	20598	\N
6732	1024	5	0	20599	\N
6735	10	2	0	20493	\N
6735	29	3	0	20494	\N
6737	10	2	0	20493	\N
6737	29	3	0	20494	\N
6739	135	2	0	18162	\N
6739	196	3	0	19502	\N
6741	1	2	0	20620	\N
6741	112	3	0	20621	\N
6744	1636	2	0	20628	\N
6744	1637	3	0	20629	\N
6746	10	2	0	20493	\N
6746	29	3	0	20494	\N
6749	246	4	0	850	\N
6749	1639	5	0	20655	\N
6751	1640	2	0	20666	\N
6751	1641	3	0	20667	\N
6754	100	2	0	20676	\N
6754	101	3	0	20677	\N
6756	10	2	0	20684	\N
6756	29	3	0	20685	\N
6758	2	2	0	20668	\N
6758	131	3	0	20669	\N
6759	228	8	0	20405	\N
6759	1642	9	0	20708	\N
6761	852	8	0	17438	\N
6761	1644	9	0	20711	\N
6763	220	5	0	18919	\N
6763	1646	6	0	20724	\N
6768	1650	4	0	20747	\N
6768	1651	4	0	20748	\N
6768	1653	5	1	20749	\N
6768	1652	5	0	20750	\N
6530	169	3	0	19568	\N
6536	119	0	0	19446	\N
6538	119	2	0	19591	\N
6538	891	3	0	19592	\N
6540	242	2	0	16730	\N
6540	620	3	0	19599	\N
6543	117	2	0	19610	\N
6543	175	3	0	19611	\N
6545	435	0	0	19617	\N
6548	10	2	0	19587	\N
6548	29	3	0	19588	\N
6551	27	2	0	19306	\N
6551	619	3	0	19643	\N
6555	233	2	0	18086	\N
6555	910	3	0	18970	\N
6557	119	2	0	19591	\N
6557	891	3	0	19592	\N
6559	86	1	0	18505	\N
6559	87	2	0	18506	\N
6562	151	2	0	19349	\N
6562	576	3	0	19350	\N
6565	75	2	0	19575	\N
6565	159	3	0	19576	\N
6568	202	2	0	19686	\N
6568	812	3	0	19687	\N
6570	1148	2	0	19692	\N
6570	402	3	0	19500	\N
6573	164	4	0	19702	\N
6573	1582	5	0	19703	\N
6575	1588	3	0	19713	\N
6577	192	2	0	19379	\N
6577	838	3	0	19380	\N
6580	60	2	0	19720	\N
6580	166	3	0	19721	\N
6584	40	5	0	19741	\N
6584	385	6	0	19742	\N
6589	793	9	0	18989	\N
6589	1591	10	0	19769	\N
6599	86	4	0	19793	\N
6599	1592	5	0	19806	\N
6603	10	4	0	19802	\N
6603	600	5	0	19803	\N
6609	23	2	0	19845	\N
6609	24	3	0	19859	\N
6612	90	2	0	19863	\N
6612	91	3	0	19864	\N
6615	23	0	0	19845	\N
6620	56	2	0	19518	\N
6620	169	3	0	19568	\N
6622	16	2	0	19894	\N
6622	155	3	0	19895	\N
6628	391	0	0	17527	\N
6630	424	0	0	18468	\N
6632	425	1	0	19935	\N
6632	424	5	0	18469	\N
6632	468	6	0	19936	\N
6634	1599	2	0	19943	\N
6634	1600	3	0	19944	\N
6637	56	2	0	19518	\N
6637	169	3	0	19568	\N
6640	453	2	0	18339	\N
6640	902	3	0	19981	\N
6643	10	2	0	20005	\N
6643	29	3	0	20006	\N
6646	1603	3	0	20013	\N
6648	1109	2	0	16692	\N
6648	1412	3	0	20020	\N
6653	260	2	0	20041	\N
6653	419	3	0	20042	\N
6660	258	1	0	20070	\N
6660	309	2	0	20071	\N
6662	192	3	0	20078	\N
6662	627	4	0	20079	\N
6669	40	4	0	20085	\N
6669	564	5	0	20101	\N
6674	1608	16	0	20117	\N
6674	1609	17	0	20118	\N
6676	251	4	0	19381	\N
6676	1610	5	0	20129	\N
6679	619	2	0	20143	\N
6679	1611	6	0	20150	\N
6679	1612	6	0	20151	\N
6679	1614	7	1	20152	\N
6679	1613	7	0	20153	\N
6684	402	4	0	20176	\N
6684	1378	5	0	20177	\N
6687	10	11	0	20210	\N
6687	1619	12	0	20211	\N
6692	1628	4	0	20378	\N
6692	1629	5	0	20379	\N
6695	228	4	0	20405	\N
6695	1631	5	0	20406	\N
6700	300	2	0	17864	\N
6700	706	3	0	17865	\N
6706	18	0	0	20465	\N
6709	140	2	0	18592	\N
6709	487	3	0	20488	\N
6711	10	2	0	20493	\N
6711	29	3	0	20494	\N
6716	16	4	0	19894	\N
6716	380	5	0	20419	\N
6722	132	4	0	20559	\N
6722	1635	5	0	20560	\N
6724	597	2	0	16716	\N
6724	767	3	0	20061	\N
6729	56	2	0	19518	\N
6729	169	3	0	19568	\N
6734	170	2	0	18924	\N
6734	718	3	0	19074	\N
6736	198	2	0	20609	\N
6736	746	3	0	20610	\N
6745	290	2	0	17161	\N
6745	575	3	0	20634	\N
6748	326	4	0	20653	\N
6748	1638	5	0	20654	\N
6753	40	2	0	20674	\N
6753	66	3	0	20675	\N
6755	40	2	0	20682	\N
6755	66	3	0	20683	\N
6765	852	3	0	17438	\N
6765	1647	4	0	20732	\N
6770	115	2	0	20756	\N
6770	636	3	0	20757	\N
6771	115	0	0	20756	\N
6772	362	2	0	20762	\N
6772	420	3	0	20763	\N
6773	1	2	0	20764	\N
6773	112	3	0	20765	\N
6774	1654	2	0	20766	\N
6774	1655	3	0	20767	\N
6775	67	2	0	20768	\N
6775	68	3	0	20769	\N
6776	1656	2	0	20774	\N
6776	1657	3	0	20775	\N
6777	10	2	0	20780	\N
6777	29	3	0	20781	\N
6778	113	2	0	17691	\N
6778	114	3	0	17692	\N
6779	198	2	0	20609	\N
6779	746	3	0	20610	\N
6780	435	0	0	20790	\N
6781	79	2	0	20795	\N
6781	80	3	0	20796	\N
6782	40	2	0	20801	\N
6782	66	3	0	20802	\N
6783	424	2	0	20803	\N
6783	520	3	0	20804	\N
6784	258	2	0	20809	\N
6784	585	3	0	20810	\N
6785	1659	0	0	20812	\N
6786	58	4	0	20821	\N
6786	1660	5	0	20822	\N
6787	140	4	0	20823	\N
6787	1661	5	0	20824	\N
6788	58	2	0	20829	\N
6788	665	3	0	20830	\N
6790	75	2	0	20831	\N
6790	159	3	0	20832	\N
6793	79	2	0	20849	\N
6793	80	3	0	20850	\N
6795	56	2	0	20855	\N
6795	169	3	0	20856	\N
6798	10	6	0	20877	\N
6798	1663	7	0	20878	\N
6801	324	2	0	20891	\N
6801	486	3	0	20892	\N
6805	16	1	0	20897	\N
6805	17	2	0	20898	\N
6807	326	2	0	20903	\N
6807	747	3	0	20904	\N
6812	56	2	0	20901	\N
6812	169	3	0	20902	\N
6817	242	3	0	20843	\N
6817	1668	4	0	20954	\N
6819	244	2	0	20961	\N
6819	438	3	0	20962	\N
6828	132	8	0	20559	\N
6828	1670	9	0	21016	\N
6832	208	2	0	17617	\N
6832	854	3	0	19787	\N
6839	40	4	0	20801	\N
6839	564	5	0	20946	\N
6841	79	2	0	21053	\N
6841	80	3	0	21054	\N
6846	12	6	0	19807	\N
6846	1577	7	0	21078	\N
6855	56	4	0	21107	\N
6855	1145	5	0	21108	\N
6862	10	4	0	21152	\N
6862	600	5	0	21153	\N
6865	10	5	0	21170	\N
6865	1298	6	0	21171	\N
6870	531	2	0	21195	\N
6870	431	3	0	21196	\N
6873	452	2	0	21199	\N
6873	1675	3	0	21200	\N
6873	1676	3	0	21201	\N
6876	14	2	0	21207	\N
6876	383	3	0	21208	\N
6883	595	5	0	15870	\N
6883	1682	6	0	21353	\N
6884	1109	3	0	16692	\N
6884	1683	4	0	21354	\N
6889	18	2	0	21365	\N
6889	1685	3	0	21366	\N
6892	2	4	0	21387	\N
6892	315	5	0	21388	\N
6897	18	0	0	21408	\N
6899	391	2	0	21419	\N
6899	406	3	0	21420	\N
6904	60	4	0	19720	\N
6904	1687	5	0	21436	\N
6915	75	2	0	21462	\N
6915	159	3	0	21463	\N
6919	147	2	0	21351	\N
6919	516	3	0	21470	\N
6924	10	2	0	21489	\N
6924	29	3	0	21490	\N
6929	1470	2	0	21504	\N
6929	1565	3	0	21505	\N
6931	367	4	0	21516	\N
6931	1231	5	0	21517	\N
6933	10	0	0	20493	\N
6936	10	0	0	20722	\N
6938	16	2	0	21537	\N
6938	155	3	0	21538	\N
6943	12	1	0	19807	\N
6943	13	2	0	21555	\N
6945	233	4	0	21565	\N
6945	1689	5	0	21566	\N
6957	930	2	0	21613	\N
6957	1304	3	0	21614	\N
6960	262	2	0	21621	\N
6960	731	3	0	18996	\N
6964	189	2	0	21635	\N
6964	311	3	0	21636	\N
6966	285	2	0	21646	\N
6966	1276	3	0	21647	\N
6973	424	2	0	21684	\N
6973	520	3	0	21685	\N
6976	268	3	0	21682	\N
6976	610	4	0	21694	\N
6981	73	4	0	21714	\N
6981	1696	5	0	21715	\N
6984	200	4	0	21730	\N
6984	899	5	0	21731	\N
6989	1	2	0	21686	\N
6989	112	3	0	21687	\N
6993	1640	9	0	21785	\N
6993	1701	10	0	21790	\N
6997	360	2	0	21803	\N
6997	510	3	0	21804	\N
6999	16	2	0	21809	\N
6999	155	3	0	21810	\N
7008	96	5	0	21829	\N
7008	1702	6	0	21830	\N
7010	132	5	0	21832	\N
7010	1704	6	0	21833	\N
7012	58	2	0	21815	\N
7012	665	3	0	21816	\N
7020	316	4	0	21362	\N
7020	1024	5	0	21871	\N
7025	100	4	0	20676	\N
7025	448	5	0	21904	\N
7030	1	4	0	21924	\N
7030	422	5	0	21925	\N
7033	75	2	0	21462	\N
7033	159	3	0	21463	\N
7036	322	2	0	21961	\N
7036	833	3	0	21962	\N
7039	1	2	0	21975	\N
7039	112	3	0	21976	\N
7041	67	2	0	20768	\N
7041	68	3	0	20769	\N
7044	288	4	0	22005	\N
7044	1710	5	0	22006	\N
7047	1	4	0	21975	\N
7047	422	5	0	22021	\N
7051	10	2	0	22038	\N
7051	29	3	0	22039	\N
7053	16	2	0	22042	\N
7053	155	3	0	22043	\N
7056	79	2	0	21481	\N
7056	80	3	0	21484	\N
7061	115	0	0	22082	\N
7066	391	3	0	22105	\N
7066	1691	4	0	22106	\N
7068	189	3	0	22109	\N
7068	1713	4	0	22110	\N
7070	1714	53	0	22111	\N
7070	189	73	0	22112	\N
7070	1715	74	0	22113	\N
7075	930	0	0	21613	\N
7076	58	13	0	21815	\N
7076	1717	14	0	22155	\N
7078	1719	104	0	22158	\N
7078	44	123	0	22159	\N
7078	1720	124	0	22160	\N
7081	94	4	0	22181	\N
7081	1706	5	0	22182	\N
7086	1	2	0	21975	\N
7086	112	3	0	21976	\N
7088	86	2	0	22210	\N
7088	509	3	0	22211	\N
7091	113	1	0	21023	\N
7091	437	2	0	22225	\N
7093	23	3	0	19845	\N
7093	350	4	0	22234	\N
7098	908	2	0	22052	\N
7098	988	3	0	22248	\N
7101	1	2	0	21975	\N
6789	208	2	0	17617	\N
6789	854	3	0	19787	\N
6791	424	4	0	20841	\N
6791	1620	5	0	20842	\N
6796	251	2	0	20857	\N
6796	828	3	0	20858	\N
6799	235	2	0	20883	\N
6799	1061	3	0	20884	\N
6802	324	1	0	20891	\N
6802	325	2	0	20893	\N
6806	56	2	0	20901	\N
6806	169	3	0	20902	\N
6808	149	4	0	20913	\N
6808	1664	5	0	20914	\N
6815	40	4	0	20801	\N
6815	564	5	0	20946	\N
6820	11	1	0	20965	\N
6820	10	3	0	20968	\N
6820	11	4	0	20969	\N
6823	198	2	0	20990	\N
6823	746	3	0	20991	\N
6825	222	2	0	19183	\N
6825	232	3	0	19206	\N
6833	208	1	0	17617	\N
6833	209	2	0	18012	\N
6835	391	2	0	21037	\N
6835	406	3	0	21038	\N
6842	2	2	0	21055	\N
6842	131	3	0	21056	\N
6844	10	3	0	21062	\N
6844	347	4	0	21063	\N
6851	110	2	0	21082	\N
6851	111	3	0	21089	\N
6853	793	2	0	21095	\N
6853	1136	3	0	21096	\N
6858	424	2	0	21132	\N
6858	520	3	0	21133	\N
6860	186	2	0	21140	\N
6860	696	3	0	21141	\N
6863	40	2	0	20801	\N
6863	66	3	0	20802	\N
6875	452	2	0	21199	\N
6875	451	3	0	21202	\N
6877	10	2	0	21213	\N
6877	29	3	0	21214	\N
6880	54	5	0	21342	\N
6880	1679	6	0	21348	\N
6882	147	5	0	21351	\N
6882	1681	6	0	21352	\N
6886	40	2	0	21360	\N
6886	66	3	0	21361	\N
6890	10	3	0	21371	\N
6890	347	4	0	21372	\N
6898	220	2	0	21413	\N
6898	821	3	0	21414	\N
6905	391	2	0	21419	\N
6905	406	3	0	21420	\N
6910	40	2	0	21360	\N
6910	66	3	0	21361	\N
6913	841	1	0	21452	\N
6913	842	2	0	21455	\N
6914	10	2	0	21460	\N
6914	29	3	0	21461	\N
6916	595	2	0	21468	\N
6916	768	3	0	21469	\N
6923	79	2	0	21481	\N
6923	80	3	0	21484	\N
6925	102	2	0	21495	\N
6925	158	3	0	21496	\N
6927	793	2	0	21497	\N
6927	1136	3	0	21499	\N
6930	40	4	0	21514	\N
6930	564	5	0	21515	\N
6932	10	0	0	20493	\N
6934	132	2	0	21522	\N
6934	133	3	0	21523	\N
6939	86	2	0	21543	\N
6939	509	3	0	21544	\N
6942	208	2	0	17617	\N
6942	854	3	0	19787	\N
6944	18	0	0	21556	\N
6947	391	3	0	21575	\N
6947	1691	4	0	21576	\N
6949	94	1	0	18475	\N
6949	107	2	0	18476	\N
6952	1	7	0	21597	\N
6952	1336	8	0	21598	\N
6956	424	2	0	21611	\N
6956	520	3	0	21612	\N
6958	288	2	0	21619	\N
6958	289	3	0	21620	\N
6963	242	2	0	21633	\N
6963	620	3	0	21634	\N
6965	210	2	0	16707	\N
6965	458	3	0	21641	\N
6971	10	1	0	21678	\N
6971	11	2	0	21679	\N
6975	125	2	0	21688	\N
6975	188	3	0	21689	\N
6982	75	4	0	21462	\N
6982	172	5	0	21716	\N
6985	110	2	0	21736	\N
6985	111	3	0	21737	\N
6988	56	2	0	21749	\N
6988	169	3	0	21750	\N
6991	453	4	0	21765	\N
6991	798	5	0	21766	\N
6996	288	2	0	21797	\N
6996	289	3	0	21798	\N
6998	841	0	0	21452	\N
7001	841	0	0	21452	\N
7009	230	5	0	20709	\N
7009	1703	6	0	21831	\N
7013	115	2	0	21839	\N
7013	636	3	0	21840	\N
7016	10	4	0	21856	\N
7016	600	5	0	21857	\N
7021	411	4	0	16556	\N
7021	1665	5	0	20915	\N
7024	10	4	0	21902	\N
7024	600	5	0	21903	\N
7029	40	4	0	21795	\N
7029	564	5	0	21923	\N
7031	264	2	0	18616	\N
7031	265	3	0	19397	\N
7034	10	2	0	21902	\N
7034	29	3	0	21946	\N
7037	258	2	0	21967	\N
7037	585	3	0	21968	\N
7042	1691	3	0	21988	\N
7042	391	6	0	21993	\N
7042	406	7	0	21994	\N
7045	424	2	0	21684	\N
7045	520	3	0	21685	\N
7048	90	4	0	22022	\N
7048	358	5	0	22023	\N
7050	266	2	0	16710	\N
7050	1711	3	0	22033	\N
7055	1109	4	0	16692	\N
7055	1389	5	0	22054	\N
7057	88	2	0	22063	\N
7057	154	3	0	22064	\N
7060	75	4	0	22080	\N
7060	172	5	0	22081	\N
7065	56	4	0	21749	\N
7065	1145	5	0	22098	\N
7069	242	0	0	21633	\N
7071	56	6	0	22120	\N
7071	1716	7	0	22121	\N
7077	44	13	0	19644	\N
7077	1718	14	0	22156	\N
7087	79	2	0	22204	\N
7087	80	3	0	22205	\N
7090	75	2	0	22193	\N
7090	159	3	0	22222	\N
7092	360	3	0	22232	\N
7092	1353	4	0	22233	\N
6792	242	4	0	20843	\N
6792	1662	5	0	20844	\N
6800	42	2	0	20889	\N
6800	681	3	0	20890	\N
6803	324	0	0	20430	\N
6810	56	4	0	20901	\N
6810	1145	5	0	20916	\N
6811	268	2	0	20921	\N
6811	1387	3	0	20922	\N
6814	30	4	0	20936	\N
6814	1667	5	0	20937	\N
6816	2	4	0	20668	\N
6816	315	5	0	20947	\N
6822	156	2	0	20988	\N
6822	571	3	0	20989	\N
6824	202	2	0	20992	\N
6824	812	3	0	20993	\N
6826	27	2	0	20998	\N
6826	619	3	0	20157	\N
6827	102	8	0	19941	\N
6827	1669	9	0	21015	\N
6830	113	2	0	21023	\N
6830	114	3	0	21024	\N
6834	206	2	0	21031	\N
6834	693	3	0	21032	\N
6837	86	2	0	21039	\N
6837	509	3	0	21040	\N
6843	79	1	0	21053	\N
6843	81	2	0	21057	\N
6848	12	3	0	19807	\N
6848	782	4	0	21081	\N
6850	110	7	0	21082	\N
6850	1672	8	0	21086	\N
6857	2	9	0	21055	\N
6857	1674	10	0	21127	\N
6859	202	2	0	21134	\N
6859	812	3	0	21135	\N
6864	453	5	0	21168	\N
6864	1272	6	0	21169	\N
6866	453	0	0	21168	\N
6869	768	2	0	21194	\N
6869	595	3	0	15871	\N
6872	516	2	0	21198	\N
6872	147	3	0	20063	\N
6878	1625	40	0	21249	\N
6878	449	126	0	21335	\N
6878	1677	127	0	21336	\N
6887	391	2	0	21037	\N
6887	406	3	0	21038	\N
6891	10	2	0	21377	\N
6891	29	3	0	21378	\N
6894	18	0	0	21391	\N
6896	170	2	0	21406	\N
6896	718	3	0	21407	\N
6901	75	2	0	20831	\N
6901	159	3	0	20832	\N
6903	2	2	0	21426	\N
6903	131	3	0	21427	\N
6906	230	2	0	20709	\N
6906	231	3	0	21441	\N
6908	16	2	0	20897	\N
6908	155	3	0	21421	\N
6911	841	2	0	21452	\N
6911	1161	3	0	21453	\N
6917	597	2	0	21349	\N
6917	767	3	0	21197	\N
6921	79	4	0	21481	\N
6921	589	5	0	21482	\N
6926	793	1	0	21497	\N
6926	1150	2	0	21498	\N
6928	40	2	0	21360	\N
6928	66	3	0	21361	\N
6935	10	0	0	20493	\N
6937	362	4	0	20762	\N
6937	1688	5	0	21532	\N
6940	112	2	0	21549	\N
6940	1	3	0	21143	\N
6948	18	0	0	21577	\N
6950	10	3	0	21586	\N
6950	347	4	0	21587	\N
6953	208	7	0	17617	\N
6953	1692	8	0	21599	\N
6954	228	76	0	21602	\N
6954	1693	77	0	21603	\N
6959	121	2	0	19722	\N
6959	625	3	0	19723	\N
6961	360	1	0	21624	\N
6961	479	2	0	21625	\N
6968	56	2	0	21107	\N
6968	169	3	0	21653	\N
6972	268	2	0	21682	\N
6972	1387	3	0	21683	\N
6978	16	2	0	21573	\N
6978	155	3	0	21648	\N
6980	353	2	0	20495	\N
6980	755	3	0	20496	\N
6983	49	2	0	19823	\N
6983	328	3	0	21721	\N
6986	40	2	0	21514	\N
6986	66	3	0	21742	\N
6992	1640	9	0	21785	\N
6992	1698	10	1	21786	\N
6992	1697	10	0	21787	\N
6992	1700	11	1	21788	\N
6992	1699	11	0	21789	\N
7002	841	0	0	21452	\N
7003	841	0	0	21452	\N
7005	58	2	0	21815	\N
7005	665	3	0	21816	\N
7007	177	2	0	6357	\N
7007	178	3	0	21818	\N
7014	224	2	0	18546	\N
7014	508	3	0	21841	\N
7017	33	4	0	21076	\N
7017	447	5	0	21858	\N
7019	94	4	0	21869	\N
7019	1706	5	0	21870	\N
7022	164	6	0	20376	\N
7022	662	7	0	21892	\N
7027	173	2	0	21911	\N
7027	480	3	0	21912	\N
7032	1	4	0	21924	\N
7032	422	5	0	21925	\N
7035	2	4	0	21955	\N
7035	315	5	0	21956	\N
7038	258	2	0	21973	\N
7038	585	3	0	21974	\N
7040	54	2	0	21342	\N
7040	485	3	0	21981	\N
7043	285	4	0	22003	\N
7043	1709	5	0	22004	\N
7046	391	4	0	22019	\N
7046	539	5	0	22020	\N
7058	79	2	0	22069	\N
7058	80	3	0	22070	\N
7063	18	0	0	22088	\N
7072	56	1	0	22124	\N
7072	57	2	0	22125	\N
7074	27	2	0	22131	\N
7074	619	3	0	22132	\N
7080	56	4	0	22171	\N
7080	1145	5	0	22172	\N
7083	69	4	0	17874	\N
7083	1721	5	0	22192	\N
7085	77	2	0	19914	\N
7085	216	3	0	22199	\N
7095	233	2	0	22237	\N
7095	910	3	0	22241	\N
7097	268	2	0	22246	\N
7097	1387	3	0	22247	\N
7100	237	2	0	19295	\N
7100	319	3	0	21817	\N
7106	1109	2	0	22274	\N
7106	1412	3	0	22275	\N
7111	27	4	0	22131	\N
7111	942	5	0	22311	\N
7114	222	3	0	19183	\N
6794	362	2	0	20762	\N
6794	420	3	0	20763	\N
6797	16	2	0	20863	\N
6797	155	3	0	20864	\N
6804	42	1	0	20889	\N
6804	43	2	0	20894	\N
6809	411	4	0	16556	\N
6809	1665	5	0	20915	\N
6813	316	4	0	20598	\N
6813	1666	5	0	20935	\N
6818	453	2	0	20959	\N
6818	902	3	0	20960	\N
6821	322	6	0	20982	\N
6821	1633	7	0	20983	\N
6829	96	2	0	21021	\N
6829	482	3	0	21022	\N
6831	1	2	0	21025	\N
6831	112	3	0	21026	\N
6836	69	2	0	17874	\N
6836	500	3	0	17875	\N
6838	198	2	0	20990	\N
6838	746	3	0	20991	\N
6840	132	4	0	20559	\N
6840	1635	5	0	20560	\N
6845	33	6	0	21076	\N
6845	1671	7	0	21077	\N
6847	1	6	0	21079	\N
6847	523	7	0	21080	\N
6849	110	6	0	21082	\N
6849	736	7	0	21083	\N
6852	110	3	0	21082	\N
6852	905	4	0	21092	\N
6854	424	4	0	21105	\N
6854	1620	5	0	21106	\N
6856	96	9	0	21021	\N
6856	1673	10	0	21126	\N
6861	1	2	0	21142	\N
6861	112	3	0	21143	\N
6867	10	2	0	21170	\N
6867	29	3	0	21176	\N
6868	2	6	0	21055	\N
6868	1566	7	0	21189	\N
6871	767	2	0	18454	\N
6871	597	3	0	21197	\N
6874	452	2	0	21199	\N
6874	451	3	0	21202	\N
6879	54	3	0	21342	\N
6879	1678	4	0	21343	\N
6881	597	5	0	21349	\N
6881	1680	6	0	21350	\N
6885	1109	5	0	16692	\N
6885	1684	6	0	21355	\N
6888	316	2	0	21362	\N
6888	332	3	0	21363	\N
6893	488	4	0	21389	\N
6893	1686	5	0	21390	\N
6895	173	4	0	21400	\N
6895	1046	5	0	21401	\N
6900	16	2	0	20897	\N
6900	155	3	0	21421	\N
6902	222	2	0	19183	\N
6902	232	3	0	19206	\N
6907	373	2	0	18229	\N
6907	1504	3	0	18318	\N
6909	117	1	0	21448	\N
6909	248	2	0	21449	\N
6912	117	2	0	21448	\N
6912	175	3	0	21454	\N
6918	23	2	0	19845	\N
6918	24	3	0	19859	\N
6920	852	2	0	21471	\N
6920	1325	3	0	21472	\N
6922	16	4	0	20897	\N
6922	380	5	0	21483	\N
6941	12	2	0	19807	\N
6941	433	3	0	21554	\N
6946	16	3	0	21573	\N
6946	1690	4	0	21574	\N
6951	338	3	0	17787	\N
6951	339	4	0	21588	\N
6955	1	6	0	21597	\N
6955	523	7	0	21606	\N
6962	360	2	0	21624	\N
6962	510	3	0	21628	\N
6967	16	2	0	21573	\N
6967	155	3	0	21648	\N
6969	10	1	0	21586	\N
6969	11	2	0	21656	\N
6970	4	9	0	17821	\N
6970	1694	10	0	21675	\N
6974	1	2	0	21686	\N
6974	112	3	0	21687	\N
6977	911	3	0	8397	\N
6977	1695	4	0	21695	\N
6979	212	2	0	21704	\N
6979	566	3	0	21705	\N
6987	10	2	0	21747	\N
6987	29	3	0	21748	\N
6990	322	4	0	21763	\N
6990	1616	5	0	21764	\N
6994	1640	9	0	21785	\N
6994	1701	10	0	21790	\N
6995	40	2	0	21795	\N
6995	66	3	0	21796	\N
7000	841	2	0	21452	\N
7000	1161	3	0	21453	\N
7004	841	0	0	21452	\N
7006	237	2	0	19295	\N
7006	319	3	0	21817	\N
7011	75	5	0	21462	\N
7011	1705	6	0	21834	\N
7015	10	2	0	21846	\N
7015	29	3	0	21847	\N
7018	88	4	0	21867	\N
7018	601	5	0	21868	\N
7023	224	6	0	18546	\N
7023	1707	7	0	21893	\N
7026	110	4	0	21905	\N
7026	1708	5	0	21906	\N
7028	88	2	0	21913	\N
7028	154	3	0	21914	\N
7049	94	2	0	21869	\N
7049	95	3	0	22028	\N
7052	528	2	0	22040	\N
7052	613	3	0	22041	\N
7054	908	4	0	22052	\N
7054	1032	5	0	22053	\N
7059	451	2	0	22071	\N
7059	452	3	0	21202	\N
7062	115	2	0	22082	\N
7062	636	3	0	22087	\N
7064	300	4	0	17864	\N
7064	1712	5	0	22097	\N
7067	40	3	0	22107	\N
7067	869	4	0	22108	\N
7073	391	2	0	22105	\N
7073	406	3	0	22130	\N
7079	1021	4	0	22169	\N
7079	1047	5	0	22170	\N
7082	10	4	0	22038	\N
7082	600	5	0	22191	\N
7084	75	4	0	22193	\N
7084	172	5	0	22194	\N
7089	1722	2	0	22216	\N
7089	1723	3	0	22217	\N
7094	233	1	0	22237	\N
7094	234	2	0	22238	\N
7096	10	2	0	22038	\N
7096	29	3	0	22039	\N
7102	237	1	0	19295	\N
7102	527	2	0	22253	\N
7113	1	6	0	22272	\N
7113	523	7	0	22326	\N
7116	852	4	0	22350	\N
7116	1727	5	0	22351	\N
7118	908	11	0	22376	\N
7118	1728	12	0	22377	\N
7099	391	2	0	22105	\N
7099	406	3	0	22130	\N
7103	1	2	0	22258	\N
7103	112	3	0	22259	\N
7104	704	3	0	22266	\N
7104	1724	4	0	22267	\N
7105	1	2	0	22272	\N
7105	112	3	0	22273	\N
7110	51	4	0	22301	\N
7110	648	5	0	22302	\N
7126	324	2	0	20891	\N
7126	486	3	0	20892	\N
7131	453	2	0	21765	\N
7131	902	3	0	22439	\N
7134	69	3	0	22453	\N
7134	594	4	0	22454	\N
7136	192	2	0	20078	\N
7136	838	3	0	22461	\N
7141	79	1	0	22470	\N
7141	81	2	0	22471	\N
7146	198	1	0	20990	\N
7146	199	2	0	22483	\N
7151	260	2	0	20041	\N
7151	419	3	0	20042	\N
7154	49	1	0	22511	\N
7154	50	2	0	22512	\N
7160	149	3	0	22527	\N
7160	1739	4	0	22528	\N
7163	10	1	0	22535	\N
7163	11	2	0	22536	\N
7165	10	1	0	22540	\N
7165	11	2	0	22541	\N
7173	488	2	0	21389	\N
7173	729	3	0	22568	\N
7176	300	1	0	17864	\N
7176	355	2	0	18892	\N
7183	16	1	0	22597	\N
7183	17	2	0	22598	\N
7186	40	1	0	22609	\N
7186	41	2	0	22610	\N
7191	424	2	0	22615	\N
7191	520	3	0	22628	\N
7194	53	1	0	22636	\N
7194	1	3	0	22637	\N
7194	53	4	0	22638	\N
7197	402	2	0	20176	\N
7197	1148	3	0	22651	\N
7199	336	1	0	22654	\N
7199	356	2	0	22655	\N
7204	1	2	0	22656	\N
7204	112	3	0	22664	\N
7209	264	1	0	22680	\N
7209	270	2	0	22681	\N
7211	51	1	0	22688	\N
7211	52	2	0	22689	\N
7219	10	1	0	22662	\N
7219	11	2	0	22717	\N
7223	49	2	0	22725	\N
7223	789	3	0	22726	\N
7225	1	2	0	22713	\N
7225	444	3	0	22729	\N
7228	2	1	0	22719	\N
7228	26	2	0	22720	\N
7235	424	2	0	22759	\N
7235	520	3	0	22760	\N
7238	177	1	0	22767	\N
7238	498	2	0	22768	\N
7242	18	0	0	22773	\N
7245	714	2	0	5891	\N
7245	1394	3	0	15937	\N
7248	88	2	0	22798	\N
7248	154	3	0	22799	\N
7251	4	1	0	22806	\N
7251	25	2	0	22807	\N
7253	10	1	0	22752	\N
7253	11	2	0	22753	\N
7255	102	1	0	22816	\N
7255	103	2	0	22817	\N
7264	14	1	0	22842	\N
7264	15	2	0	22843	\N
7266	260	1	0	22846	\N
7266	261	2	0	22847	\N
7272	1	1	0	22859	\N
7272	53	2	0	22860	\N
7279	186	0	0	22874	\N
7291	202	1	0	21134	\N
7291	203	2	0	22910	\N
7294	10	2	0	22918	\N
7294	29	3	0	22919	\N
7296	46	0	0	1086	\N
7298	1021	3	0	22169	\N
7298	1543	4	0	22928	\N
7304	10	1	0	22949	\N
7304	11	2	0	22950	\N
7306	402	2	0	20176	\N
7306	1148	3	0	22651	\N
7309	431	3	0	22964	\N
7309	1751	4	0	22965	\N
7310	222	4	0	22877	\N
7310	1564	5	0	22973	\N
7312	102	1	0	22943	\N
7312	103	2	0	22978	\N
7315	77	2	0	22374	\N
7315	216	3	0	22988	\N
7318	27	3	0	22131	\N
7318	1270	4	0	22997	\N
7323	326	1	0	22761	\N
7323	327	2	0	23008	\N
7330	27	1	0	22131	\N
7330	28	2	0	23020	\N
7331	27	0	0	22131	\N
7337	1	5	0	22891	\N
7337	1233	6	0	23041	\N
7339	164	1	0	23053	\N
7339	165	2	0	23054	\N
7341	1754	85	0	23057	\N
7341	189	126	0	23058	\N
7341	1755	127	0	23059	\N
7344	58	1	0	23074	\N
7344	59	2	0	23075	\N
7347	173	7	0	23093	\N
7347	1757	8	0	23094	\N
7349	186	8	0	23133	\N
7349	1759	9	0	23134	\N
7354	1763	44	0	23183	\N
7354	300	59	0	23184	\N
7354	1764	60	0	23185	\N
7356	424	9	0	23206	\N
7356	1766	10	0	23207	\N
7364	27	8	0	22131	\N
7364	1773	9	0	23290	\N
7372	424	30	0	23206	\N
7372	1779	31	0	23388	\N
7375	424	1	0	23394	\N
7375	425	2	0	23395	\N
7381	16	1	0	23407	\N
7381	17	2	0	23408	\N
7389	113	3	0	23427	\N
7389	778	4	0	23435	\N
7394	1	2	0	23447	\N
7394	112	3	0	23459	\N
7399	38	1	0	23475	\N
7399	399	2	0	23476	\N
7409	54	2	0	21342	\N
7409	485	3	0	21981	\N
7411	16	1	0	23535	\N
7411	17	2	0	23536	\N
7417	1783	1	0	23548	\N
7417	88	2	0	23549	\N
7420	391	0	0	23555	\N
7425	40	3	0	22904	\N
7425	128	4	0	23614	\N
7428	1109	2	0	23136	\N
7428	1412	3	0	23622	\N
7430	110	1	0	23627	\N
7430	134	2	0	23628	\N
7432	79	1	0	23632	\N
7101	112	3	0	21976	\N
7107	365	2	0	22280	\N
7107	519	3	0	22281	\N
7108	173	4	0	21911	\N
7108	1046	5	0	22290	\N
7109	365	4	0	22291	\N
7109	1725	5	0	22292	\N
7112	6	4	0	22312	\N
7112	670	5	0	22313	\N
7115	10	4	0	22038	\N
7115	600	5	0	22191	\N
7117	77	11	0	22374	\N
7117	1314	12	0	22375	\N
7119	181	2	0	19075	\N
7119	769	3	0	19076	\N
7125	2	2	0	22415	\N
7125	131	3	0	22416	\N
7127	16	2	0	22425	\N
7127	155	3	0	22426	\N
7132	322	2	0	22444	\N
7132	833	3	0	22445	\N
7139	224	1	0	22466	\N
7139	225	2	0	22467	\N
7142	391	3	0	22105	\N
7142	581	4	0	22478	\N
7144	82	1	0	18459	\N
7144	83	2	0	18460	\N
7147	206	1	0	22484	\N
7147	207	2	0	22485	\N
7149	189	2	0	22109	\N
7149	1393	3	0	22492	\N
7153	353	2	0	22507	\N
7153	755	3	0	22508	\N
7156	1736	1	0	22515	\N
7156	1737	2	0	22516	\N
7158	1	3	0	22513	\N
7158	711	4	0	22525	\N
7164	110	1	0	21905	\N
7164	134	2	0	22537	\N
7167	121	1	0	19722	\N
7167	122	2	0	22542	\N
7169	56	1	0	22547	\N
7169	57	2	0	22548	\N
7171	285	1	0	22003	\N
7171	286	2	0	22553	\N
7175	49	3	0	22577	\N
7175	1740	4	0	22578	\N
7178	56	1	0	22547	\N
7178	57	2	0	22548	\N
7182	108	1	0	22593	\N
7182	109	2	0	22594	\N
7187	10	1	0	22613	\N
7187	11	2	0	22614	\N
7201	198	1	0	20990	\N
7201	199	2	0	22483	\N
7203	10	2	0	22662	\N
7203	29	3	0	22663	\N
7210	220	1	0	22684	\N
7210	221	2	0	22685	\N
7216	108	3	0	22707	\N
7216	837	4	0	22708	\N
7218	1	1	0	22713	\N
7218	53	2	0	22714	\N
7221	2	1	0	22719	\N
7221	26	2	0	22720	\N
7229	44	1	0	19644	\N
7229	45	2	0	22738	\N
7232	18	2	0	22748	\N
7232	218	3	0	22749	\N
7241	110	1	0	21905	\N
7241	134	2	0	22537	\N
7257	181	1	0	19075	\N
7257	530	2	0	22822	\N
7259	266	1	0	22827	\N
7259	267	2	0	22828	\N
7262	14	1	0	22842	\N
7262	15	2	0	22843	\N
7265	1	1	0	22844	\N
7265	53	2	0	22845	\N
7267	14	1	0	22842	\N
7267	15	2	0	22843	\N
7268	192	1	0	20078	\N
7268	193	2	0	22850	\N
7276	10	1	0	22752	\N
7276	11	2	0	22753	\N
7280	222	2	0	22877	\N
7280	232	3	0	22878	\N
7282	841	1	0	22882	\N
7282	842	2	0	22883	\N
7285	1	1	0	22891	\N
7285	53	2	0	22892	\N
7288	16	2	0	22900	\N
7288	155	3	0	22901	\N
7290	42	1	0	22906	\N
7290	43	2	0	22907	\N
7297	46	0	0	1086	\N
7300	264	3	0	22680	\N
7300	1748	4	0	22929	\N
7303	94	5	0	22945	\N
7303	1750	6	0	22946	\N
7305	75	0	0	22951	\N
7319	44	1	0	23000	\N
7319	45	2	0	23001	\N
7321	391	1	0	23004	\N
7321	392	2	0	23005	\N
7326	1	1	0	22891	\N
7326	53	2	0	22892	\N
7328	151	1	0	23017	\N
7328	302	2	0	23018	\N
7333	56	1	0	22547	\N
7333	57	2	0	22548	\N
7335	33	5	0	23037	\N
7335	532	6	0	23038	\N
7343	79	1	0	23070	\N
7343	81	2	0	23071	\N
7352	300	8	0	23154	\N
7352	1762	9	0	23155	\N
7357	181	18	0	23244	\N
7357	1767	19	0	23245	\N
7359	14	9	0	22842	\N
7359	1769	10	0	23266	\N
7368	67	7	0	23310	\N
7368	1775	8	0	23311	\N
7370	1777	7	0	23328	\N
7370	262	8	0	23329	\N
7373	424	29	0	23206	\N
7373	1780	30	0	23389	\N
7376	290	1	0	23392	\N
7376	291	2	0	23393	\N
7377	151	1	0	23017	\N
7377	302	2	0	23018	\N
7382	595	1	0	21468	\N
7382	596	2	0	23411	\N
7387	10	1	0	23288	\N
7387	11	2	0	23398	\N
7390	49	5	0	22725	\N
7390	1781	6	0	23446	\N
7392	170	1	0	23451	\N
7392	398	2	0	23452	\N
7395	73	2	0	22523	\N
7395	703	3	0	23464	\N
7397	285	1	0	23469	\N
7397	286	2	0	23470	\N
7401	186	1	0	23133	\N
7401	187	2	0	23497	\N
7404	16	1	0	23508	\N
7404	17	2	0	23509	\N
7406	113	1	0	23514	\N
7406	437	2	0	23515	\N
7410	573	2	0	23531	\N
7410	1581	3	0	23532	\N
7412	110	1	0	21905	\N
7412	134	2	0	22537	\N
7414	89	1	0	23540	\N
7414	88	3	0	23543	\N
7414	1783	4	0	23544	\N
7418	14	2	0	22842	\N
7114	1726	4	0	22333	\N
7121	30	5	0	20936	\N
7121	1729	6	0	22394	\N
7122	140	6	0	20823	\N
7122	1730	7	0	22407	\N
7124	40	2	0	22107	\N
7124	66	3	0	22414	\N
7129	1731	2	0	22431	\N
7129	1732	3	0	22432	\N
7133	1470	3	0	21504	\N
7133	1733	4	0	22452	\N
7138	367	2	0	22462	\N
7138	651	3	0	22463	\N
7140	40	0	0	22107	\N
7143	16	3	0	22455	\N
7143	359	4	0	22456	\N
7145	841	1	0	21452	\N
7145	842	2	0	21455	\N
7159	125	3	0	21688	\N
7159	1738	4	0	22526	\N
7161	110	3	0	21905	\N
7161	1217	4	0	22529	\N
7162	40	1	0	22107	\N
7162	41	2	0	22532	\N
7172	18	5	0	19198	\N
7172	1513	6	0	22563	\N
7179	1109	1	0	22581	\N
7179	1111	2	0	22582	\N
7180	10	1	0	22585	\N
7180	11	2	0	22586	\N
7185	142	1	0	22605	\N
7185	143	2	0	22606	\N
7188	424	1	0	22615	\N
7188	425	2	0	22616	\N
7190	14	1	0	22622	\N
7190	15	2	0	22623	\N
7193	479	1	0	22631	\N
7193	360	3	0	22634	\N
7193	479	4	0	22635	\N
7196	40	2	0	22649	\N
7196	66	3	0	22650	\N
7198	402	4	0	20176	\N
7198	1378	5	0	20177	\N
7208	200	1	0	22678	\N
7208	201	2	0	22679	\N
7213	79	1	0	22694	\N
7213	81	2	0	22695	\N
7222	164	1	0	20376	\N
7222	165	2	0	22721	\N
7227	365	1	0	22734	\N
7227	366	2	0	22735	\N
7230	1743	93	0	22739	\N
7230	44	116	0	22740	\N
7230	1744	117	0	22741	\N
7234	38	1	0	19529	\N
7234	399	2	0	22754	\N
7237	416	1	0	22765	\N
7237	417	2	0	22766	\N
7239	30	1	0	22769	\N
7239	418	2	0	22770	\N
7244	1109	3	0	22581	\N
7244	1745	4	0	22782	\N
7247	75	1	0	22792	\N
7247	76	2	0	22793	\N
7250	64	1	0	22804	\N
7250	65	2	0	22805	\N
7252	1	1	0	22780	\N
7252	53	2	0	22810	\N
7260	1746	43	0	22829	\N
7260	244	126	0	22830	\N
7260	1747	127	0	22831	\N
7263	336	1	0	22654	\N
7263	356	2	0	22655	\N
7269	20	1	0	22490	\N
7269	144	2	0	22851	\N
7271	33	2	0	21076	\N
7271	34	3	0	22856	\N
7274	1	2	0	22859	\N
7274	112	3	0	22867	\N
7277	113	1	0	22872	\N
7277	437	2	0	22873	\N
7281	186	2	0	22874	\N
7281	696	3	0	22879	\N
7283	2	1	0	22719	\N
7283	26	2	0	22720	\N
7286	288	1	0	22893	\N
7286	400	2	0	22894	\N
7293	453	2	0	22916	\N
7293	902	3	0	22917	\N
7308	88	1	0	22798	\N
7308	89	2	0	22957	\N
7314	222	1	0	22982	\N
7314	223	2	0	22983	\N
7317	2	3	0	22995	\N
7317	572	4	0	22996	\N
7320	1	1	0	22891	\N
7320	53	2	0	22892	\N
7322	64	1	0	22804	\N
7322	65	2	0	22805	\N
7327	206	1	0	22484	\N
7327	207	2	0	22485	\N
7329	453	1	0	22916	\N
7329	454	2	0	23019	\N
7336	2	5	0	23039	\N
7336	1060	6	0	23040	\N
7338	11	1	0	23044	\N
7338	10	4	0	23049	\N
7338	29	5	0	23050	\N
7346	230	7	0	23091	\N
7346	1756	8	0	23092	\N
7348	88	10	0	23115	\N
7348	1758	11	0	23116	\N
7351	1109	8	0	23136	\N
7351	1761	9	0	23137	\N
7353	210	8	0	22690	\N
7353	1026	9	0	23156	\N
7355	391	9	0	23204	\N
7355	1765	10	0	23205	\N
7361	210	9	0	22690	\N
7361	1771	10	0	23269	\N
7363	10	8	0	23288	\N
7363	1772	9	0	23289	\N
7367	2	7	0	23308	\N
7367	1040	8	0	23309	\N
7369	1776	7	0	23326	\N
7369	10	8	0	23327	\N
7374	290	1	0	23392	\N
7374	291	2	0	23393	\N
7379	262	1	0	23399	\N
7379	263	2	0	23400	\N
7384	147	1	0	21351	\N
7384	599	2	0	23413	\N
7386	51	2	0	23423	\N
7386	524	3	0	23424	\N
7400	336	8	0	23493	\N
7400	1782	9	0	23494	\N
7403	164	3	0	23504	\N
7403	307	4	0	23505	\N
7408	1	3	0	23510	\N
7408	48	4	0	23526	\N
7416	89	1	0	23540	\N
7416	88	3	0	23543	\N
7416	1783	4	0	23544	\N
7422	10	1	0	23502	\N
7422	11	2	0	23564	\N
7427	264	2	0	22680	\N
7427	265	3	0	23621	\N
7429	290	1	0	23625	\N
7429	291	2	0	23626	\N
7440	149	1	0	22727	\N
7440	499	2	0	23658	\N
7441	10	2	0	23663	\N
7441	29	3	0	23664	\N
7120	322	2	0	22382	\N
7120	833	3	0	22383	\N
7123	186	6	0	22408	\N
7123	621	7	0	22409	\N
7128	1731	2	0	22431	\N
7128	1732	3	0	22432	\N
7130	49	2	0	22437	\N
7130	328	3	0	22438	\N
7135	16	3	0	22455	\N
7135	359	4	0	22456	\N
7137	54	2	0	21342	\N
7137	485	3	0	21981	\N
7148	20	2	0	22490	\N
7148	1734	3	0	22491	\N
7150	1735	106	0	22494	\N
7150	189	126	0	22495	\N
7150	1715	127	0	22496	\N
7152	10	2	0	22505	\N
7152	29	3	0	22506	\N
7155	1	1	0	22513	\N
7155	53	2	0	22514	\N
7157	73	3	0	22523	\N
7157	464	4	0	22524	\N
7166	237	1	0	19295	\N
7166	527	2	0	22253	\N
7168	365	1	0	22545	\N
7168	366	2	0	22546	\N
7170	60	1	0	22551	\N
7170	61	2	0	22552	\N
7174	451	2	0	22569	\N
7174	452	3	0	22570	\N
7177	1	1	0	22513	\N
7177	53	2	0	22514	\N
7181	16	1	0	22589	\N
7181	17	2	0	22590	\N
7184	285	1	0	22601	\N
7184	286	2	0	22602	\N
7189	123	1	0	19491	\N
7189	124	2	0	22619	\N
7192	479	1	0	22631	\N
7192	360	3	0	22634	\N
7192	479	4	0	22635	\N
7195	75	2	0	22643	\N
7195	159	3	0	22644	\N
7200	1	1	0	22656	\N
7200	53	2	0	22657	\N
7202	1470	2	0	21504	\N
7202	1565	3	0	21505	\N
7205	123	2	0	22665	\N
7205	384	3	0	22666	\N
7206	1	1	0	22656	\N
7206	53	2	0	22657	\N
7207	453	3	0	21765	\N
7207	1503	4	0	22675	\N
7212	210	1	0	22690	\N
7212	211	2	0	22691	\N
7214	424	1	0	22698	\N
7214	425	2	0	22699	\N
7215	96	3	0	21829	\N
7215	834	4	0	22706	\N
7217	18	1	0	22711	\N
7217	19	2	0	22712	\N
7220	1440	1	0	16735	\N
7220	1741	2	0	22718	\N
7224	149	2	0	22727	\N
7224	1742	3	0	22728	\N
7226	10	1	0	22662	\N
7226	11	2	0	22717	\N
7231	108	2	0	22746	\N
7231	501	3	0	22747	\N
7233	10	1	0	22752	\N
7233	11	2	0	22753	\N
7236	326	2	0	22761	\N
7236	747	3	0	22762	\N
7240	300	1	0	17864	\N
7240	355	2	0	18892	\N
7243	1	3	0	22780	\N
7243	48	4	0	22781	\N
7246	391	1	0	22105	\N
7246	392	2	0	22789	\N
7249	38	2	0	22800	\N
7249	39	3	0	22801	\N
7254	268	1	0	22246	\N
7254	269	2	0	22813	\N
7256	40	1	0	22820	\N
7256	41	2	0	22821	\N
7258	181	1	0	19075	\N
7258	530	2	0	22822	\N
7261	391	3	0	22838	\N
7261	581	4	0	22839	\N
7270	1	1	0	22844	\N
7270	53	2	0	22845	\N
7273	241	1	0	22861	\N
7273	333	2	0	22862	\N
7275	100	1	0	22870	\N
7275	160	2	0	22871	\N
7278	113	0	0	22872	\N
7284	10	2	0	22752	\N
7284	29	3	0	22888	\N
7287	20	2	0	22490	\N
7287	702	3	0	22899	\N
7289	40	1	0	22904	\N
7289	41	2	0	22905	\N
7292	108	1	0	22746	\N
7292	109	2	0	22911	\N
7295	30	2	0	22920	\N
7295	31	3	0	22921	\N
7299	264	0	0	22680	\N
7301	173	1	0	21911	\N
7301	396	2	0	22932	\N
7302	102	5	0	22943	\N
7302	1749	6	0	22944	\N
7307	10	2	0	22949	\N
7307	29	3	0	22954	\N
7311	137	4	0	22974	\N
7311	1752	5	0	22975	\N
7313	212	1	0	21704	\N
7313	213	2	0	22979	\N
7316	192	2	0	20078	\N
7316	838	3	0	22461	\N
7324	1	1	0	22891	\N
7324	53	2	0	22892	\N
7325	18	1	0	23011	\N
7325	19	2	0	23012	\N
7332	16	1	0	22900	\N
7332	17	2	0	23023	\N
7334	1470	1	0	21504	\N
7334	1471	2	0	23026	\N
7340	189	6	0	23055	\N
7340	1753	7	0	23056	\N
7342	10	3	0	23066	\N
7342	347	4	0	23067	\N
7345	75	1	0	23076	\N
7345	76	2	0	23077	\N
7350	435	8	0	19617	\N
7350	1760	9	0	23135	\N
7358	435	18	0	23246	\N
7358	1768	19	0	23247	\N
7360	290	9	0	23267	\N
7360	1770	10	0	23268	\N
7362	908	8	0	23286	\N
7362	1027	9	0	23287	\N
7365	64	8	0	23291	\N
7365	986	9	0	23292	\N
7366	402	7	0	20176	\N
7366	1774	8	0	23307	\N
7371	262	6	0	21621	\N
7371	1778	7	0	23330	\N
7378	10	1	0	23288	\N
7378	11	2	0	23398	\N
7380	18	1	0	23403	\N
7380	19	2	0	23404	\N
7383	597	1	0	21349	\N
7383	598	2	0	23412	\N
7385	1	2	0	22891	\N
7385	112	3	0	23418	\N
7388	113	1	0	23427	\N
7388	437	2	0	23428	\N
7391	1	5	0	23447	\N
7391	1233	6	0	23448	\N
7393	241	1	0	23453	\N
7393	333	2	0	23454	\N
7396	10	2	0	23465	\N
7396	29	3	0	23466	\N
7398	94	1	0	23471	\N
7398	107	2	0	23472	\N
7402	10	3	0	23502	\N
7402	347	4	0	23503	\N
7405	1	1	0	23510	\N
7405	53	2	0	23511	\N
7407	16	1	0	23518	\N
7407	17	2	0	23519	\N
7413	110	2	0	21905	\N
7413	111	3	0	23539	\N
7415	410	1	0	23545	\N
7415	273	3	0	23546	\N
7415	1784	4	0	23547	\N
7421	212	2	0	23560	\N
7421	566	3	0	23561	\N
7424	1787	24	0	23573	\N
7424	228	126	0	23606	\N
7424	1788	127	0	23607	\N
7426	18	3	0	23615	\N
7426	127	4	0	23616	\N
7436	16	1	0	23535	\N
7436	17	2	0	23536	\N
7439	4	1	0	23656	\N
7439	25	2	0	23657	\N
7443	121	1	0	19722	\N
7443	122	2	0	22542	\N
7418	1785	3	0	23553	\N
7419	14	3	0	22842	\N
7419	1786	4	0	23554	\N
7423	1	1	0	23567	\N
7423	53	2	0	23568	\N
7431	110	2	0	23627	\N
7431	111	3	0	23631	\N
7433	268	1	0	23634	\N
7433	269	2	0	23635	\N
7435	1021	2	0	23644	\N
7435	1048	3	0	23645	\N
7438	268	1	0	23654	\N
7438	269	2	0	23655	\N
7432	81	2	0	23633	\N
7434	411	1	0	23638	\N
7434	412	2	0	23639	\N
7437	75	1	0	23650	\N
7437	76	2	0	23651	\N
7442	75	1	0	23667	\N
7442	76	2	0	23668	\N
7444	290	1	0	23625	\N
7444	291	2	0	23626	\N
7445	256	1	0	23671	\N
7445	257	2	0	23672	\N
7446	71	1	0	17853	\N
7446	72	2	0	17854	\N
7447	119	1	0	23677	\N
7447	120	2	0	23678	\N
7448	110	1	0	23681	\N
7448	134	2	0	23682	\N
7449	167	2	0	23687	\N
7449	168	3	0	23688	\N
7450	186	2	0	23693	\N
7450	696	3	0	23694	\N
7451	1	2	0	23695	\N
7451	112	3	0	23696	\N
7452	16	2	0	23701	\N
7452	155	3	0	23702	\N
7453	125	3	0	21688	\N
7453	126	4	0	23709	\N
7454	258	1	0	23712	\N
7454	309	2	0	23713	\N
7455	908	1	0	23286	\N
7455	909	2	0	23714	\N
7456	10	1	0	23717	\N
7456	11	2	0	23718	\N
7457	12	1	0	23719	\N
7457	13	2	0	23720	\N
7458	16	1	0	23721	\N
7458	17	2	0	23722	\N
7459	1	1	0	23695	\N
7459	53	2	0	23725	\N
7460	10	3	0	23717	\N
7460	347	4	0	23732	\N
7461	113	3	0	23733	\N
7461	778	4	0	23734	\N
7462	1	3	0	23735	\N
7462	48	4	0	23736	\N
7463	16	1	0	23721	\N
7463	17	2	0	23722	\N
7464	79	1	0	23632	\N
7464	81	2	0	23633	\N
7465	170	1	0	23743	\N
7465	398	2	0	23744	\N
7466	763	1	0	23747	\N
7466	764	2	0	23748	\N
7467	1789	1	0	23749	\N
7467	1790	2	0	23750	\N
7468	451	1	0	23751	\N
7468	584	2	0	23752	\N
7469	1	1	0	23753	\N
7469	53	2	0	23754	\N
7470	121	2	0	19722	\N
7470	625	3	0	19723	\N
7471	230	1	0	23761	\N
7471	287	2	0	23762	\N
7472	456	1	0	2371	\N
7472	457	2	0	2372	\N
7473	1791	20	0	23764	\N
7473	322	22	0	23765	\N
7473	323	23	0	23766	\N
7474	10	2	0	23717	\N
7474	29	3	0	23771	\N
7475	10	2	0	23775	\N
7475	29	3	0	23776	\N
7476	200	2	0	23777	\N
7476	887	3	0	23778	\N
7477	1	2	0	23753	\N
7477	112	3	0	23779	\N
7478	75	2	0	23780	\N
7478	159	3	0	23781	\N
7479	20	1	0	23784	\N
7479	144	2	0	23785	\N
7480	1792	0	0	23786	\N
7481	10	3	0	23775	\N
7481	297	4	0	23792	\N
7482	324	3	0	23793	\N
7482	937	4	0	23794	\N
7483	324	3	0	23793	\N
7483	937	4	0	23794	\N
7484	181	1	0	23797	\N
7484	530	2	0	23798	\N
7485	353	1	0	22507	\N
7485	354	2	0	23799	\N
7486	123	1	0	23802	\N
7486	124	2	0	23803	\N
7487	10	2	0	23808	\N
7487	29	3	0	23809	\N
7488	488	2	0	23810	\N
7488	729	3	0	23811	\N
7489	1	2	0	23753	\N
7489	112	3	0	23779	\N
7490	18	2	0	23812	\N
7490	218	3	0	23813	\N
7491	27	1	0	22131	\N
7491	28	2	0	23020	\N
7492	149	1	0	22727	\N
7492	499	2	0	23658	\N
7493	56	1	0	22547	\N
7493	57	2	0	22548	\N
7494	94	2	0	23821	\N
7494	95	3	0	23822	\N
7495	391	2	0	23555	\N
7495	406	3	0	23827	\N
7496	220	2	0	23832	\N
7496	821	3	0	23833	\N
7497	1	1	0	23753	\N
7497	53	2	0	23754	\N
7498	10	3	0	23842	\N
7498	347	4	0	23843	\N
7499	1793	1	0	23846	\N
7499	1794	2	0	23847	\N
7500	237	1	0	19295	\N
7500	527	2	0	22253	\N
7501	1151	1	0	11627	\N
7501	1795	2	0	23848	\N
7502	528	1	0	22040	\N
7502	529	2	0	23851	\N
7503	16	2	0	23856	\N
7503	155	3	0	23857	\N
7504	1	2	0	23858	\N
7504	112	3	0	23859	\N
7505	67	2	0	23864	\N
7505	68	3	0	23865	\N
7506	459	2	0	23870	\N
7506	1796	3	0	23871	\N
7507	206	1	0	23874	\N
7507	207	2	0	23875	\N
7508	16	1	0	23878	\N
7508	17	2	0	23879	\N
7509	49	4	0	23888	\N
7509	1797	5	0	23889	\N
7510	10	4	0	23890	\N
7510	1798	5	0	23891	\N
7511	1799	57	0	23892	\N
7511	49	117	0	23893	\N
7511	1800	118	0	23894	\N
7512	1	4	0	23858	\N
7512	1801	5	0	23895	\N
7513	67	4	0	23896	\N
7513	1802	5	0	23897	\N
7514	1	1	0	23899	\N
7514	53	2	0	23900	\N
7515	79	1	0	23903	\N
7515	81	2	0	23904	\N
7516	132	1	0	21832	\N
7516	455	2	0	23907	\N
7517	431	1	0	23910	\N
7517	432	2	0	23911	\N
7518	67	1	0	23896	\N
7518	478	2	0	23912	\N
7521	1109	3	0	23136	\N
7521	1745	4	0	23922	\N
7523	92	1	0	20586	\N
7523	191	2	0	23929	\N
7528	1803	43	0	23946	\N
7528	244	126	0	23974	\N
7528	1804	127	0	23975	\N
7530	256	2	0	24044	\N
7530	1806	3	0	24045	\N
7532	164	1	0	24049	\N
7532	165	2	0	24050	\N
7537	268	1	0	23654	\N
7537	269	2	0	23655	\N
7542	10	1	0	24074	\N
7542	11	2	0	24075	\N
7545	10	2	0	24082	\N
7545	29	3	0	24083	\N
7547	132	2	0	24092	\N
7547	133	3	0	24093	\N
7549	40	1	0	24099	\N
7549	41	2	0	24100	\N
7552	10	2	0	24110	\N
7552	29	3	0	24111	\N
7554	12	1	0	24116	\N
7554	13	2	0	24117	\N
7559	149	1	0	22727	\N
7559	499	2	0	23658	\N
7561	67	1	0	23896	\N
7561	478	2	0	23912	\N
7566	214	1	0	19543	\N
7566	215	2	0	24143	\N
7570	40	1	0	24151	\N
7570	41	2	0	24152	\N
7573	56	1	0	24154	\N
7573	57	2	0	24155	\N
7579	54	54	0	24166	\N
7579	1810	55	0	24167	\N
7594	268	7	0	23654	\N
7594	1812	8	0	24216	\N
7596	86	1	0	24223	\N
7596	87	2	0	24224	\N
7598	49	57	0	24226	\N
7598	1813	58	0	24227	\N
7602	170	1	0	24249	\N
7602	398	2	0	24250	\N
7605	132	1	0	24261	\N
7605	455	2	0	24262	\N
7612	23	3	0	24278	\N
7612	350	4	0	24279	\N
7621	177	3	0	22767	\N
7621	1821	4	0	24303	\N
7628	164	0	0	24322	\N
7630	71	1	0	24339	\N
7630	72	2	0	24340	\N
7633	16	1	0	24286	\N
7633	17	2	0	24352	\N
7636	18	1	0	24361	\N
7636	19	2	0	24362	\N
7639	16	1	0	24368	\N
7639	17	2	0	24369	\N
7641	82	1	0	24389	\N
7641	83	2	0	24390	\N
7648	64	2	0	24416	\N
7648	162	3	0	24417	\N
7650	4	0	0	24419	\N
7653	42	2	0	24433	\N
7653	681	3	0	24434	\N
7656	125	1	0	24444	\N
7656	195	2	0	24445	\N
7658	54	0	0	24166	\N
7661	40	2	0	24457	\N
7661	66	3	0	24458	\N
7663	192	2	0	24460	\N
7663	838	3	0	24461	\N
7670	71	1	0	24480	\N
7670	72	2	0	24481	\N
7672	258	1	0	23712	\N
7672	309	2	0	23713	\N
7675	117	5	0	24500	\N
7675	1831	6	0	24501	\N
7678	10	1	0	24515	\N
7678	11	2	0	24516	\N
7683	156	3	0	24530	\N
7683	407	4	0	24531	\N
7691	1470	0	0	24558	\N
7696	10	1	0	24524	\N
7696	11	2	0	24525	\N
7698	273	1	0	24577	\N
7698	410	2	0	24578	\N
7703	597	1	0	24475	\N
7703	598	2	0	24584	\N
7707	202	3	0	21134	\N
7707	987	4	0	24588	\N
7712	75	1	0	24599	\N
7712	76	2	0	24600	\N
7714	316	1	0	24607	\N
7714	317	2	0	24608	\N
7720	125	1	0	24619	\N
7720	195	2	0	24620	\N
7726	151	1	0	24636	\N
7726	302	2	0	24637	\N
7735	241	1	0	23453	\N
7735	333	2	0	23454	\N
7742	56	1	0	24690	\N
7742	57	2	0	24691	\N
7744	10	0	0	24681	\N
7749	16	1	0	24709	\N
7749	17	2	0	24710	\N
7752	51	1	0	24721	\N
7752	52	2	0	24722	\N
7754	135	1	0	24725	\N
7754	136	2	0	24726	\N
7756	56	1	0	24690	\N
7756	57	2	0	24691	\N
7759	424	1	0	23395	\N
7759	425	2	0	24736	\N
7761	1	0	0	24738	\N
7764	402	1	0	20176	\N
7764	403	2	0	24751	\N
7779	4	1	0	24792	\N
7779	25	2	0	24793	\N
7791	326	1	0	22761	\N
7791	327	2	0	23008	\N
7793	198	1	0	24836	\N
7793	199	2	0	24837	\N
7797	360	1	0	22232	\N
7797	479	2	0	22634	\N
7800	220	1	0	24856	\N
7800	221	2	0	24857	\N
7802	75	1	0	24860	\N
7802	76	2	0	24861	\N
7805	113	1	0	24870	\N
7805	437	2	0	24871	\N
7807	734	1	0	24876	\N
7807	1508	2	0	24877	\N
7819	77	4	0	22374	\N
7819	1838	5	1	24913	\N
7819	1837	5	0	24914	\N
7819	1840	6	1	24915	\N
7819	1839	6	0	24916	\N
7825	488	1	0	24929	\N
7825	489	2	0	24930	\N
7831	100	1	0	22870	\N
7831	160	2	0	22871	\N
7835	35	1	0	24954	\N
7835	340	2	0	24955	\N
7855	149	1	0	25014	\N
7855	499	2	0	25015	\N
7858	279	1	0	25020	\N
7858	473	2	0	25021	\N
7860	285	1	0	23469	\N
7860	286	2	0	23470	\N
7862	102	1	0	22943	\N
7862	103	2	0	22978	\N
7865	214	1	0	19543	\N
7865	215	2	0	24143	\N
7519	79	3	0	23919	\N
7519	272	4	0	23920	\N
7526	189	0	0	22109	\N
7533	164	3	0	24049	\N
7533	1807	4	0	24051	\N
7535	391	2	0	24056	\N
7535	1381	3	0	24057	\N
7538	362	1	0	24064	\N
7538	395	2	0	24065	\N
7550	10	1	0	24082	\N
7550	11	2	0	24103	\N
7555	92	1	0	24118	\N
7555	191	2	0	24119	\N
7557	242	1	0	24122	\N
7557	253	2	0	24123	\N
7568	1021	1	0	24147	\N
7568	1022	2	0	24148	\N
7571	237	1	0	19295	\N
7571	527	2	0	22253	\N
7580	10	1	0	24114	\N
7580	11	2	0	24115	\N
7582	264	1	0	24169	\N
7582	270	2	0	24170	\N
7583	10	1	0	24114	\N
7583	11	2	0	24115	\N
7591	230	2	0	24199	\N
7591	231	3	0	24200	\N
7597	49	1	0	23888	\N
7597	50	2	0	24225	\N
7600	149	2	0	22727	\N
7600	697	3	0	24236	\N
7601	10	5	0	24186	\N
7601	1814	6	0	24246	\N
7606	2	1	0	24265	\N
7606	26	2	0	24266	\N
7611	220	3	0	24134	\N
7611	477	4	0	24275	\N
7613	135	3	0	18162	\N
7613	1817	4	0	24280	\N
7616	1	2	0	24288	\N
7616	112	3	0	24289	\N
7618	115	1	0	24290	\N
7618	116	2	0	24293	\N
7620	273	0	0	24296	\N
7623	10	4	0	24312	\N
7623	600	5	0	24313	\N
7626	224	2	0	24314	\N
7626	508	3	0	24321	\N
7629	40	6	0	24151	\N
7629	522	7	0	24336	\N
7632	67	2	0	24348	\N
7632	68	3	0	24349	\N
7637	79	1	0	23919	\N
7637	81	2	0	24365	\N
7643	38	9	0	24393	\N
7643	1825	10	0	24394	\N
7646	411	2	0	24366	\N
7646	582	3	0	24407	\N
7649	75	2	0	24066	\N
7649	159	3	0	24418	\N
7652	49	3	0	24391	\N
7652	1740	4	0	24428	\N
7659	54	1	0	24166	\N
7659	55	2	0	24168	\N
7664	10	4	0	24446	\N
7664	600	5	0	24466	\N
7667	595	2	0	21468	\N
7667	768	3	0	21469	\N
7671	10	1	0	24482	\N
7671	11	2	0	24483	\N
7680	852	1	0	24519	\N
7680	913	2	0	24520	\N
7682	10	1	0	24524	\N
7682	11	2	0	24525	\N
7687	151	1	0	24545	\N
7687	302	2	0	24546	\N
7690	841	1	0	22882	\N
7690	842	2	0	22883	\N
7695	251	1	0	20857	\N
7695	252	2	0	24570	\N
7697	67	1	0	24573	\N
7697	478	2	0	24574	\N
7700	10	1	0	24524	\N
7700	11	2	0	24525	\N
7705	147	1	0	21351	\N
7705	599	2	0	23413	\N
7706	202	1	0	21134	\N
7706	203	2	0	22910	\N
7709	16	2	0	24368	\N
7709	155	3	0	24595	\N
7711	2	1	0	24265	\N
7711	26	2	0	24266	\N
7713	192	1	0	24603	\N
7713	193	2	0	24604	\N
7718	597	1	0	24615	\N
7718	598	2	0	24616	\N
7722	2	1	0	24623	\N
7722	26	2	0	24624	\N
7728	6	0	0	24644	\N
7730	4	1	0	24655	\N
7730	25	2	0	24656	\N
7733	186	3	0	23932	\N
7733	1834	4	0	24665	\N
7738	27	2	0	24679	\N
7738	619	3	0	24680	\N
7743	1	0	0	24692	\N
7746	402	3	0	20176	\N
7746	1328	4	0	24700	\N
7748	367	1	0	24705	\N
7748	368	2	0	24706	\N
7762	56	3	0	24745	\N
7762	475	4	0	24746	\N
7765	300	1	0	24752	\N
7765	355	2	0	24753	\N
7768	40	3	0	24749	\N
7768	128	4	0	24769	\N
7771	391	1	0	24778	\N
7771	392	2	0	24779	\N
7775	10	1	0	24786	\N
7775	11	2	0	24787	\N
7777	77	1	0	22374	\N
7777	78	2	0	24791	\N
7784	10	2	0	24806	\N
7784	29	3	0	24807	\N
7787	113	1	0	23733	\N
7787	437	2	0	24190	\N
7789	233	3	0	24828	\N
7789	1836	4	0	24829	\N
7796	200	1	0	24843	\N
7796	201	2	0	24844	\N
7803	49	1	0	24864	\N
7803	50	2	0	24865	\N
7810	60	2	0	24885	\N
7810	166	3	0	24886	\N
7813	16	1	0	24892	\N
7813	17	2	0	24893	\N
7815	2	1	0	24898	\N
7815	26	2	0	24899	\N
7817	1	1	0	24874	\N
7817	53	2	0	24875	\N
7820	77	4	0	22374	\N
7820	1132	5	0	24917	\N
7824	2	1	0	24898	\N
7824	26	2	0	24899	\N
7826	1841	1	0	24933	\N
7826	1842	2	0	24934	\N
7829	117	1	0	24500	\N
7829	248	2	0	24943	\N
7833	704	1	0	24948	\N
7833	705	2	0	24949	\N
7837	453	1	0	24136	\N
7837	454	2	0	24137	\N
7840	1843	0	0	24961	\N
7840	1844	0	0	24962	\N
7841	135	6	0	24975	\N
7841	1845	7	0	24976	\N
7843	260	1	0	22846	\N
7520	156	3	0	20988	\N
7520	407	4	0	23921	\N
7524	40	1	0	22904	\N
7524	41	2	0	22905	\N
7529	1805	85	0	24007	\N
7529	189	126	0	24039	\N
7529	1755	127	0	24040	\N
7531	10	2	0	23890	\N
7531	275	3	0	24046	\N
7539	75	1	0	24066	\N
7539	76	2	0	24067	\N
7540	256	1	0	24044	\N
7540	257	2	0	24070	\N
7543	273	2	0	19861	\N
7543	1159	3	0	19862	\N
7548	96	1	0	21829	\N
7548	97	2	0	24096	\N
7551	123	1	0	24104	\N
7551	124	2	0	24105	\N
7553	10	1	0	24114	\N
7553	11	2	0	24115	\N
7560	14	1	0	24130	\N
7560	15	2	0	24131	\N
7562	220	1	0	24134	\N
7562	221	2	0	24135	\N
7564	18	1	0	23812	\N
7564	19	2	0	24138	\N
7567	30	1	0	22920	\N
7567	418	2	0	24144	\N
7569	241	1	0	23453	\N
7569	333	2	0	23454	\N
7575	256	1	0	24160	\N
7575	257	2	0	24161	\N
7577	56	1	0	24154	\N
7577	57	2	0	24155	\N
7584	16	1	0	24175	\N
7584	17	2	0	24176	\N
7585	2	4	0	23308	\N
7585	315	5	0	24185	\N
7587	113	1	0	23733	\N
7587	437	2	0	24190	\N
7589	110	1	0	24192	\N
7589	134	2	0	24193	\N
7592	200	1	0	23777	\N
7592	201	2	0	24201	\N
7599	1	1	0	24230	\N
7599	53	2	0	24231	\N
7603	1815	1	0	24253	\N
7603	1816	2	0	24254	\N
7608	300	1	0	24267	\N
7608	355	2	0	24268	\N
7610	220	1	0	24134	\N
7610	221	2	0	24135	\N
7615	16	2	0	24286	\N
7615	155	3	0	24287	\N
7617	115	0	0	24290	\N
7622	177	3	0	22767	\N
7622	1821	4	0	24303	\N
7625	23	2	0	24278	\N
7625	24	3	0	24320	\N
7631	23	1	0	24278	\N
7631	217	2	0	24343	\N
7634	40	1	0	24355	\N
7634	41	2	0	24356	\N
7642	49	9	0	24391	\N
7642	1824	10	0	24392	\N
7645	10	1	0	24401	\N
7645	11	2	0	24402	\N
7651	49	8	0	24424	\N
7651	1828	9	0	24425	\N
7654	841	2	0	22882	\N
7654	1161	3	0	24435	\N
7657	10	1	0	24446	\N
7657	11	2	0	24447	\N
7662	198	0	0	24459	\N
7666	597	2	0	24475	\N
7666	767	3	0	24476	\N
7669	90	2	0	22022	\N
7669	91	3	0	24477	\N
7673	58	1	0	23074	\N
7673	59	2	0	23075	\N
7676	82	0	0	24502	\N
7679	16	1	0	24368	\N
7679	17	2	0	24369	\N
7681	1	0	0	24521	\N
7684	16	3	0	24368	\N
7684	359	4	0	24532	\N
7686	125	1	0	24541	\N
7686	195	2	0	24542	\N
7689	431	3	0	24554	\N
7689	1751	4	0	24555	\N
7692	1470	1	0	24558	\N
7692	1471	2	0	24561	\N
7694	285	1	0	23469	\N
7694	286	2	0	23470	\N
7699	316	1	0	21362	\N
7699	317	2	0	24579	\N
7701	60	1	0	22551	\N
7701	61	2	0	22552	\N
7704	230	1	0	24199	\N
7704	287	2	0	24585	\N
7708	132	2	0	24593	\N
7708	133	3	0	24594	\N
7710	40	1	0	24457	\N
7710	41	2	0	24598	\N
7715	10	1	0	24524	\N
7715	11	2	0	24525	\N
7717	595	1	0	21468	\N
7717	596	2	0	23411	\N
7721	147	1	0	21351	\N
7721	599	2	0	23413	\N
7724	75	2	0	24599	\N
7724	159	3	0	24631	\N
7727	60	2	0	24642	\N
7727	166	3	0	24643	\N
7732	10	1	0	24524	\N
7732	11	2	0	24525	\N
7736	528	19	0	24668	\N
7736	1835	20	0	24670	\N
7737	16	1	0	24673	\N
7737	17	2	0	24674	\N
7740	279	1	0	24684	\N
7740	473	2	0	24685	\N
7745	488	3	0	23810	\N
7745	1324	4	0	24699	\N
7747	391	1	0	24703	\N
7747	392	2	0	24704	\N
7750	288	2	0	24715	\N
7750	289	3	0	24716	\N
7753	90	1	0	24723	\N
7753	344	2	0	24724	\N
7755	137	1	0	22974	\N
7755	138	2	0	24727	\N
7757	18	1	0	24361	\N
7757	19	2	0	24362	\N
7766	10	0	0	24754	\N
7767	75	3	0	24761	\N
7767	857	4	0	24762	\N
7770	10	1	0	24776	\N
7770	11	2	0	24777	\N
7774	30	1	0	22920	\N
7774	418	2	0	24144	\N
7780	4	0	0	24792	\N
7781	2	1	0	24796	\N
7781	26	2	0	24797	\N
7783	235	1	0	24800	\N
7783	236	2	0	24801	\N
7786	79	3	0	24816	\N
7786	272	4	0	24817	\N
7794	56	1	0	24838	\N
7794	57	2	0	24839	\N
7798	40	1	0	24847	\N
7798	41	2	0	24848	\N
7801	58	1	0	24858	\N
7801	59	2	0	24859	\N
7808	10	1	0	24806	\N
7808	11	2	0	24878	\N
7522	56	1	0	23925	\N
7522	57	2	0	23926	\N
7525	186	1	0	23932	\N
7525	187	2	0	23933	\N
7527	189	2	0	23055	\N
7527	311	3	0	23938	\N
7534	164	4	0	24049	\N
7534	1808	5	0	24054	\N
7536	10	1	0	24060	\N
7536	11	2	0	24061	\N
7541	173	1	0	23093	\N
7541	396	2	0	24073	\N
7544	391	2	0	24080	\N
7544	406	3	0	24081	\N
7546	56	1	0	24086	\N
7546	57	2	0	24087	\N
7556	10	1	0	24114	\N
7556	11	2	0	24115	\N
7558	16	1	0	24126	\N
7558	17	2	0	24127	\N
7563	453	1	0	24136	\N
7563	454	2	0	24137	\N
7565	1021	1	0	24141	\N
7565	1022	2	0	24142	\N
7572	237	3	0	19295	\N
7572	1809	4	0	24153	\N
7574	1	1	0	24156	\N
7574	53	2	0	24157	\N
7576	123	1	0	24104	\N
7576	124	2	0	24105	\N
7578	908	1	0	24164	\N
7578	909	2	0	24165	\N
7581	54	1	0	24166	\N
7581	55	2	0	24168	\N
7586	10	4	0	24186	\N
7586	600	5	0	24187	\N
7588	10	1	0	24186	\N
7588	11	2	0	24191	\N
7590	110	2	0	24192	\N
7590	111	3	0	24196	\N
7593	115	7	0	24214	\N
7593	1811	8	0	24215	\N
7595	273	1	0	24219	\N
7595	410	2	0	24220	\N
7604	69	1	0	24257	\N
7604	70	2	0	24258	\N
7607	300	0	0	24267	\N
7609	220	0	0	24134	\N
7614	137	3	0	22974	\N
7614	1818	4	0	24281	\N
7619	1819	1	0	24294	\N
7619	1820	2	0	24295	\N
7624	224	6	0	24314	\N
7624	1822	7	0	24315	\N
7627	164	2	0	24322	\N
7627	226	3	0	24323	\N
7635	38	1	0	24359	\N
7635	399	2	0	24360	\N
7638	411	1	0	24366	\N
7638	412	2	0	24367	\N
7640	1470	9	0	24387	\N
7640	1823	10	0	24388	\N
7644	1826	7	0	24395	\N
7644	49	44	0	24397	\N
7644	1827	45	0	24398	\N
7647	266	1	0	24410	\N
7647	267	2	0	24411	\N
7655	1470	2	0	24440	\N
7655	1565	3	0	24441	\N
7660	391	1	0	24080	\N
7660	392	2	0	24452	\N
7665	82	3	0	24389	\N
7665	1829	4	0	24470	\N
7668	147	2	0	21351	\N
7668	516	3	0	21470	\N
7674	156	5	0	24498	\N
7674	1830	6	0	24499	\N
7677	193	1	0	20079	\N
7677	192	5	0	24511	\N
7677	627	6	0	24512	\N
7685	58	2	0	24537	\N
7685	665	3	0	24538	\N
7688	435	1	0	23246	\N
7688	436	2	0	24547	\N
7693	75	3	0	24566	\N
7693	1832	4	0	24567	\N
7702	595	1	0	21468	\N
7702	596	2	0	23411	\N
7716	51	1	0	24611	\N
7716	52	2	0	24612	\N
7719	373	1	0	24617	\N
7719	374	2	0	24618	\N
7723	189	1	0	24625	\N
7723	190	2	0	24626	\N
7725	40	1	0	24457	\N
7725	41	2	0	24598	\N
7729	90	3	0	24651	\N
7729	1833	4	0	24652	\N
7731	10	1	0	24524	\N
7731	11	2	0	24525	\N
7734	528	1	0	24668	\N
7734	529	2	0	24669	\N
7739	10	0	0	24681	\N
7741	1	1	0	24688	\N
7741	53	2	0	24689	\N
7751	62	1	0	24719	\N
7751	63	2	0	24720	\N
7758	40	1	0	24734	\N
7758	41	2	0	24735	\N
7760	424	2	0	23395	\N
7760	520	3	0	24737	\N
7763	40	1	0	24749	\N
7763	41	2	0	24750	\N
7769	75	1	0	24772	\N
7769	76	2	0	24773	\N
7772	453	1	0	24136	\N
7772	454	2	0	24137	\N
7773	40	1	0	24782	\N
7773	41	2	0	24783	\N
7776	140	1	0	20823	\N
7776	141	2	0	24788	\N
7778	10	1	0	24786	\N
7778	11	2	0	24787	\N
7782	71	1	0	24480	\N
7782	72	2	0	24481	\N
7785	18	2	0	24808	\N
7785	218	3	0	24809	\N
7788	151	1	0	24820	\N
7788	302	2	0	24821	\N
7790	119	1	0	24832	\N
7790	120	2	0	24833	\N
7792	260	1	0	22846	\N
7792	261	2	0	22847	\N
7795	132	1	0	24593	\N
7795	455	2	0	24840	\N
7799	189	2	0	24625	\N
7799	311	3	0	24853	\N
7804	170	1	0	24868	\N
7804	398	2	0	24869	\N
7806	1	1	0	24874	\N
7806	53	2	0	24875	\N
7809	2	1	0	24879	\N
7809	26	2	0	24880	\N
7811	75	2	0	24860	\N
7811	159	3	0	24887	\N
7816	75	1	0	24900	\N
7816	76	2	0	24901	\N
7818	58	0	0	24904	\N
7821	10	2	0	24806	\N
7821	29	3	0	24807	\N
7823	233	1	0	24925	\N
7823	234	2	0	24926	\N
7828	92	1	0	24939	\N
7828	191	2	0	24940	\N
7832	326	1	0	22761	\N
7832	327	2	0	23008	\N
7836	10	1	0	24806	\N
7812	40	1	0	24890	\N
7812	41	2	0	24891	\N
7814	198	1	0	24896	\N
7814	199	2	0	24897	\N
7822	220	2	0	24856	\N
7822	821	3	0	24922	\N
7827	852	1	0	24935	\N
7827	913	2	0	24936	\N
7830	1	1	0	24944	\N
7830	53	2	0	24945	\N
7834	1	1	0	24952	\N
7834	53	2	0	24953	\N
7838	324	1	0	23793	\N
7838	325	2	0	24958	\N
7842	137	6	0	22974	\N
7842	1846	7	0	24977	\N
7844	1	2	0	24952	\N
7844	112	3	0	24984	\N
7847	268	1	0	23654	\N
7847	269	2	0	23655	\N
7849	10	2	0	24806	\N
7849	29	3	0	24807	\N
7852	10	3	0	25004	\N
7852	347	4	0	25005	\N
7857	391	1	0	24778	\N
7857	392	2	0	24779	\N
7859	192	1	0	25024	\N
7859	193	2	0	25025	\N
7864	214	0	0	19543	\N
7868	44	1	0	25041	\N
7868	45	2	0	25042	\N
7875	164	2	0	24322	\N
7875	226	3	0	24323	\N
7881	210	1	0	22690	\N
7881	211	2	0	22691	\N
7885	94	1	0	25082	\N
7885	107	2	0	25083	\N
7887	1109	1	0	23136	\N
7887	1111	2	0	25088	\N
7890	355	1	0	25097	\N
7890	300	2	0	24753	\N
7894	1	1	0	24952	\N
7894	53	2	0	24953	\N
7897	64	1	0	24416	\N
7897	65	2	0	25108	\N
7899	365	2	0	25113	\N
7899	519	3	0	25114	\N
7901	75	2	0	24900	\N
7901	159	3	0	25117	\N
7903	233	2	0	24925	\N
7903	1849	3	0	25123	\N
7908	290	1	0	23625	\N
7908	291	2	0	23626	\N
7910	841	1	0	25142	\N
7910	842	2	0	25143	\N
7913	40	2	0	25115	\N
7913	66	3	0	25116	\N
7919	391	3	0	25174	\N
7919	581	4	0	25175	\N
7924	235	1	0	25197	\N
7924	236	2	0	25198	\N
7927	18	2	0	25154	\N
7927	218	3	0	25155	\N
7929	367	1	0	25210	\N
7929	368	2	0	25211	\N
7932	1855	37	0	25213	\N
7932	528	126	0	25214	\N
7932	1856	127	0	25215	\N
7936	173	1	0	25223	\N
7936	396	2	0	25224	\N
7941	16	1	0	25231	\N
7941	17	2	0	25232	\N
7946	147	1	0	21351	\N
7946	599	2	0	23413	\N
7949	1021	1	0	25247	\N
7949	1022	2	0	25248	\N
7951	285	1	0	25253	\N
7951	286	2	0	25254	\N
7962	10	3	0	25291	\N
7962	347	4	0	25292	\N
7967	1861	0	0	25300	\N
7968	793	0	0	25301	\N
7970	64	1	0	24416	\N
7970	65	2	0	25108	\N
7975	189	3	0	25333	\N
7975	827	4	0	25334	\N
7980	1	3	0	25353	\N
7980	48	4	0	25354	\N
7986	123	3	0	24104	\N
7986	1041	4	0	25383	\N
7989	1	2	0	25353	\N
7989	112	3	0	25396	\N
7998	1	1	0	25421	\N
7998	53	2	0	25422	\N
8001	147	1	0	21351	\N
8001	599	2	0	23413	\N
8006	536	2	0	25431	\N
8006	1494	3	0	25432	\N
8008	411	0	0	25439	\N
8014	378	2	0	25454	\N
8014	1867	3	0	25455	\N
8018	4	1	0	25471	\N
8018	25	2	0	25472	\N
8021	453	2	0	24136	\N
8021	902	3	0	25481	\N
8024	167	2	0	25495	\N
8024	168	3	0	25496	\N
8032	147	3	0	21351	\N
8032	148	4	0	25512	\N
8036	173	1	0	25223	\N
8036	396	2	0	25224	\N
8043	88	1	0	25339	\N
8043	89	2	0	25340	\N
8057	40	1	0	25568	\N
8057	41	2	0	25580	\N
8062	10	2	0	25595	\N
8062	792	3	0	25596	\N
8069	235	1	0	25613	\N
8069	236	2	0	25614	\N
8078	88	1	0	25339	\N
8078	89	2	0	25340	\N
8080	1	2	0	25651	\N
8080	283	3	0	25657	\N
8087	235	1	0	25681	\N
8087	236	2	0	25682	\N
8092	391	1	0	25690	\N
8092	392	2	0	25691	\N
8098	75	2	0	25702	\N
8098	284	3	0	25703	\N
8101	210	1	0	22690	\N
8101	211	2	0	22691	\N
8103	10	4	0	25718	\N
8103	1881	5	0	25719	\N
8105	279	1	0	25020	\N
8105	473	2	0	25021	\N
8114	260	7	0	25757	\N
8114	1884	8	0	25758	\N
8119	10	1	0	25771	\N
8119	11	2	0	25772	\N
8122	40	2	0	25780	\N
8122	66	3	0	25781	\N
8124	224	5	0	25788	\N
8124	1885	6	0	25789	\N
8130	40	1	0	25780	\N
8130	41	2	0	25800	\N
8134	75	2	0	25765	\N
8134	159	3	0	25815	\N
8136	20	1	0	25798	\N
8136	144	2	0	25799	\N
8139	391	2	0	25830	\N
8139	406	3	0	25831	\N
8144	42	2	0	25054	\N
8144	681	3	0	25844	\N
8146	75	2	0	25845	\N
8146	159	3	0	25846	\N
8148	40	1	0	25780	\N
8148	41	2	0	25800	\N
7836	11	2	0	24878	\N
7839	16	1	0	24959	\N
7839	17	2	0	24960	\N
7845	367	2	0	24705	\N
7845	651	3	0	24985	\N
7850	16	1	0	24996	\N
7850	17	2	0	24997	\N
7853	192	1	0	25008	\N
7853	193	2	0	25009	\N
7863	167	1	0	25028	\N
7863	533	2	0	25029	\N
7866	102	16	0	22943	\N
7866	1847	17	0	25034	\N
7870	173	2	0	23093	\N
7870	480	3	0	25048	\N
7877	2	2	0	25049	\N
7877	131	3	0	25050	\N
7879	285	1	0	23469	\N
7879	286	2	0	23470	\N
7886	40	1	0	24890	\N
7886	41	2	0	24891	\N
7892	26	1	0	25100	\N
7892	2	2	0	25101	\N
7902	10	2	0	25121	\N
7902	275	3	0	25122	\N
7905	251	2	0	25126	\N
7905	1851	3	0	25127	\N
7917	1852	1	0	25164	\N
7917	1853	2	0	25165	\N
7920	40	2	0	25180	\N
7920	66	3	0	25181	\N
7923	353	3	0	22507	\N
7923	1854	4	0	25194	\N
7928	1057	1	0	25206	\N
7928	1058	2	0	25207	\N
7931	38	1	0	24393	\N
7931	399	2	0	25212	\N
7937	51	1	0	24721	\N
7937	52	2	0	24722	\N
7939	1	1	0	25229	\N
7939	53	2	0	25230	\N
7944	597	1	0	24615	\N
7944	598	2	0	24616	\N
7948	10	1	0	25121	\N
7948	11	2	0	25246	\N
7950	75	1	0	25249	\N
7950	76	2	0	25250	\N
7953	10	1	0	25121	\N
7953	11	2	0	25246	\N
7955	14	1	0	24130	\N
7955	15	2	0	24131	\N
7958	528	1	0	24668	\N
7958	529	2	0	24669	\N
7960	56	1	0	25276	\N
7960	57	2	0	25277	\N
7966	140	0	0	25299	\N
7973	202	1	0	25320	\N
7973	203	2	0	25321	\N
7977	88	1	0	25339	\N
7977	89	2	0	25340	\N
7982	79	3	0	25357	\N
7982	272	4	0	25358	\N
7984	14	3	0	25369	\N
7984	1863	4	0	25370	\N
7993	10	2	0	25407	\N
7993	29	3	0	25408	\N
7996	595	1	0	25236	\N
7996	596	2	0	25237	\N
7999	597	0	0	24615	\N
8003	597	0	0	24615	\N
8007	75	2	0	25437	\N
8007	159	3	0	25438	\N
8012	322	2	0	25450	\N
8012	1866	3	0	25451	\N
8015	123	2	0	25456	\N
8015	1868	3	0	25457	\N
8017	164	1	0	25467	\N
8017	165	2	0	25468	\N
8020	35	2	0	25479	\N
8020	36	3	0	25480	\N
8026	16	2	0	25499	\N
8026	155	3	0	25500	\N
8028	214	1	0	19543	\N
8028	215	2	0	24143	\N
8030	595	3	0	25236	\N
8030	813	4	0	25509	\N
8037	117	1	0	24500	\N
8037	248	2	0	24943	\N
8046	10	1	0	25543	\N
8046	11	2	0	25544	\N
8049	10	1	0	25543	\N
8049	11	2	0	25544	\N
8051	40	3	0	25568	\N
8051	128	4	0	25569	\N
8054	262	1	0	23399	\N
8054	263	2	0	23400	\N
8056	224	1	0	25355	\N
8056	225	2	0	25577	\N
8059	92	2	0	25586	\N
8059	93	3	0	25587	\N
8061	435	1	0	23246	\N
8061	436	2	0	24547	\N
8066	210	2	0	22690	\N
8066	1874	3	0	25607	\N
8068	10	0	0	25610	\N
8071	391	2	0	25560	\N
8071	406	3	0	25625	\N
8074	35	4	0	25479	\N
8074	1875	5	0	25640	\N
8079	94	1	0	25082	\N
8079	107	2	0	25083	\N
8081	77	3	0	25663	\N
8081	1877	4	0	25664	\N
8084	597	1	0	25673	\N
8084	598	2	0	25674	\N
8086	149	2	0	25345	\N
8086	1379	3	0	25678	\N
8089	360	1	0	22232	\N
8089	479	2	0	22634	\N
8093	235	1	0	25692	\N
8093	236	2	0	25693	\N
8095	10	2	0	25688	\N
8095	275	3	0	25699	\N
8099	210	2	0	22690	\N
8099	1874	3	0	25607	\N
8104	75	4	0	25702	\N
8104	1882	5	0	25720	\N
8107	6	1	0	25725	\N
8107	194	2	0	25726	\N
8109	16	1	0	25732	\N
8109	17	2	0	25733	\N
8112	424	1	0	23395	\N
8112	425	2	0	24736	\N
8116	206	1	0	25763	\N
8116	207	2	0	25764	\N
8125	10	1	0	25771	\N
8125	11	2	0	25772	\N
8128	20	0	0	25798	\N
8132	214	2	0	19543	\N
8132	227	3	0	19544	\N
8135	198	1	0	25257	\N
8135	199	2	0	25258	\N
8138	360	0	0	22232	\N
8143	16	1	0	25838	\N
8143	17	2	0	25839	\N
8150	373	4	0	24617	\N
8150	1887	5	0	25860	\N
8152	151	1	0	25641	\N
8152	302	2	0	25864	\N
8154	117	1	0	25868	\N
8154	248	2	0	25869	\N
8156	258	1	0	25873	\N
8156	309	2	0	25874	\N
8161	151	1	0	25886	\N
8161	302	2	0	25887	\N
8164	79	0	0	25608	\N
8171	391	1	0	25830	\N
7843	261	2	0	22847	\N
7846	10	1	0	24806	\N
7846	11	2	0	24878	\N
7848	378	1	0	24988	\N
7848	379	2	0	24989	\N
7851	14	1	0	24130	\N
7851	15	2	0	24131	\N
7854	10	1	0	25012	\N
7854	11	2	0	25013	\N
7856	273	1	0	24577	\N
7856	410	2	0	24578	\N
7861	10	1	0	25012	\N
7861	11	2	0	25013	\N
7867	2	1	0	25037	\N
7867	26	2	0	25038	\N
7871	2	2	0	25049	\N
7871	131	3	0	25050	\N
7874	56	1	0	24838	\N
7874	57	2	0	24839	\N
7880	453	1	0	24136	\N
7880	454	2	0	24137	\N
7882	132	2	0	24593	\N
7882	133	3	0	24594	\N
7884	164	1	0	25080	\N
7884	165	2	0	25081	\N
7889	40	1	0	25093	\N
7889	41	2	0	25094	\N
7896	60	1	0	24885	\N
7896	61	2	0	25107	\N
7907	1	1	0	25134	\N
7907	53	2	0	25135	\N
7912	67	1	0	25148	\N
7912	478	2	0	25149	\N
7915	16	1	0	25158	\N
7915	17	2	0	25159	\N
7918	1	3	0	25172	\N
7918	48	4	0	25173	\N
7921	10	2	0	25121	\N
7921	29	3	0	25186	\N
7926	113	2	0	24870	\N
7926	114	3	0	25203	\N
7935	1	1	0	25221	\N
7935	53	2	0	25222	\N
7938	210	1	0	22690	\N
7938	211	2	0	22691	\N
7940	324	1	0	23793	\N
7940	325	2	0	24958	\N
7945	258	1	0	25238	\N
7945	309	2	0	25239	\N
7956	242	2	0	25269	\N
7956	620	3	0	25270	\N
7959	528	31	0	25274	\N
7959	1860	32	0	25275	\N
7961	2	3	0	25049	\N
7961	572	4	0	25284	\N
7964	391	1	0	25174	\N
7964	392	2	0	25297	\N
7969	64	5	0	24416	\N
7969	1862	6	0	25312	\N
7971	56	5	0	25313	\N
7971	677	6	0	25314	\N
7974	10	2	0	25295	\N
7974	29	3	0	25326	\N
7979	149	1	0	25345	\N
7979	499	2	0	25346	\N
7985	1021	3	0	25247	\N
7985	1864	4	0	25377	\N
7988	1109	3	0	25390	\N
7988	1745	4	0	25391	\N
7991	10	1	0	25399	\N
7991	11	2	0	25400	\N
7994	258	2	0	25409	\N
7994	585	3	0	25410	\N
7997	10	1	0	25419	\N
7997	11	2	0	25420	\N
8000	16	1	0	25231	\N
8000	17	2	0	25232	\N
8005	1130	2	0	25429	\N
8005	1865	3	0	25430	\N
8010	90	1	0	24723	\N
8010	344	2	0	24724	\N
8013	14	2	0	25452	\N
8013	1785	3	0	25453	\N
8023	79	1	0	25427	\N
8023	81	2	0	25490	\N
8031	1869	0	0	25510	\N
8031	1870	0	0	25511	\N
8033	1	12	0	25421	\N
8033	1871	13	0	25531	\N
8038	2	1	0	25539	\N
8038	26	2	0	25540	\N
8040	4	1	0	25545	\N
8040	25	2	0	25546	\N
8042	258	1	0	25409	\N
8042	309	2	0	25549	\N
8045	30	1	0	22920	\N
8045	418	2	0	24144	\N
8047	18	1	0	25554	\N
8047	19	2	0	25555	\N
8050	391	1	0	25560	\N
8050	392	2	0	25561	\N
8052	64	3	0	24416	\N
8052	130	4	0	25570	\N
8060	56	2	0	25588	\N
8060	169	3	0	25589	\N
8064	10	1	0	25600	\N
8064	11	2	0	25601	\N
8067	79	2	0	25608	\N
8067	616	3	0	25609	\N
8072	40	2	0	25626	\N
8072	66	3	0	25627	\N
8075	151	4	0	25641	\N
8075	1876	5	0	25642	\N
8077	1	1	0	25651	\N
8077	53	2	0	25652	\N
8082	117	4	0	24500	\N
8082	1878	5	0	25670	\N
8085	147	1	0	21351	\N
8085	599	2	0	23413	\N
8090	367	1	0	25550	\N
8090	368	2	0	25551	\N
8091	10	1	0	25688	\N
8091	11	2	0	25689	\N
8094	353	1	0	25694	\N
8094	354	2	0	25695	\N
8096	119	2	0	25700	\N
8096	1879	3	0	25701	\N
8100	18	2	0	25707	\N
8100	1685	3	0	25708	\N
8102	62	2	0	24719	\N
8102	1880	3	0	25710	\N
8110	44	2	0	25738	\N
8110	161	3	0	25739	\N
8113	1883	2	0	25743	\N
8117	75	1	0	25765	\N
8117	76	2	0	25766	\N
8118	256	1	0	24160	\N
8118	257	2	0	24161	\N
8121	113	0	0	25775	\N
8123	113	2	0	25775	\N
8123	114	3	0	25782	\N
8126	35	1	0	25792	\N
8126	340	2	0	25793	\N
8129	20	1	0	25798	\N
8129	144	2	0	25799	\N
8133	10	2	0	25813	\N
8133	29	3	0	25814	\N
8141	121	1	0	25834	\N
8141	122	2	0	25835	\N
8151	741	4	0	25850	\N
8151	1888	5	0	25861	\N
8153	151	44	0	25641	\N
8153	1889	45	0	25865	\N
8157	4	1	0	25875	\N
8157	25	2	0	25876	\N
8159	1	1	0	25883	\N
7869	10	2	0	25012	\N
7869	29	3	0	25047	\N
7872	56	2	0	24838	\N
7872	169	3	0	25051	\N
7873	42	1	0	25054	\N
7873	43	2	0	25055	\N
7876	212	2	0	25060	\N
7876	566	3	0	25061	\N
7878	852	3	0	25068	\N
7878	1848	4	0	25069	\N
7883	10	1	0	25078	\N
7883	11	2	0	25079	\N
7888	10	1	0	25078	\N
7888	11	2	0	25079	\N
7891	213	1	0	25098	\N
7891	212	2	0	25099	\N
7893	76	1	0	25102	\N
7893	75	2	0	24901	\N
7895	62	1	0	24719	\N
7895	63	2	0	24720	\N
7898	793	1	0	21497	\N
7898	1150	2	0	21498	\N
7900	40	2	0	25115	\N
7900	66	3	0	25116	\N
7904	186	2	0	25124	\N
7904	1850	3	0	25125	\N
7906	198	1	0	25130	\N
7906	199	2	0	25131	\N
7909	16	1	0	25138	\N
7909	17	2	0	25139	\N
7911	4	1	0	24792	\N
7911	25	2	0	24793	\N
7914	18	2	0	25154	\N
7914	218	3	0	25155	\N
7916	1	1	0	25162	\N
7916	53	2	0	25163	\N
7922	268	2	0	23654	\N
7922	1387	3	0	25187	\N
7925	123	1	0	24104	\N
7925	124	2	0	24105	\N
7930	528	1	0	24668	\N
7930	529	2	0	24669	\N
7933	38	4	0	24393	\N
7933	1857	5	0	25216	\N
7934	173	1	0	23093	\N
7934	396	2	0	24073	\N
7942	18	1	0	25154	\N
7942	19	2	0	25233	\N
7943	595	1	0	25236	\N
7943	596	2	0	25237	\N
7947	322	1	0	25242	\N
7947	323	2	0	25243	\N
7952	198	1	0	25257	\N
7952	199	2	0	25258	\N
7954	1858	1	0	25261	\N
7954	1859	2	0	25262	\N
7957	16	1	0	25231	\N
7957	17	2	0	25232	\N
7963	10	1	0	25295	\N
7963	11	2	0	25296	\N
7965	51	0	0	25298	\N
7972	6	1	0	24644	\N
7972	194	2	0	25317	\N
7976	1	1	0	25337	\N
7976	53	2	0	25338	\N
7978	1	1	0	25343	\N
7978	53	2	0	25344	\N
7981	224	3	0	25355	\N
7981	387	4	0	25356	\N
7983	75	1	0	25361	\N
7983	76	2	0	25362	\N
7987	224	3	0	25355	\N
7987	387	4	0	25356	\N
7990	18	2	0	25154	\N
7990	218	3	0	25155	\N
7992	86	1	0	24223	\N
7992	87	2	0	24224	\N
7995	10	2	0	25415	\N
7995	29	3	0	25416	\N
8004	79	2	0	25427	\N
8004	80	3	0	25428	\N
8009	316	1	0	25442	\N
8009	317	2	0	25443	\N
8011	33	1	0	23037	\N
8011	163	2	0	25446	\N
8016	451	3	0	23751	\N
8016	826	4	0	25464	\N
8019	10	1	0	25419	\N
8019	11	2	0	25420	\N
8022	123	2	0	25486	\N
8022	384	3	0	25487	\N
8025	793	2	0	25497	\N
8025	1136	3	0	25498	\N
8027	60	1	0	24885	\N
8027	61	2	0	25107	\N
8029	18	1	0	25154	\N
8029	19	2	0	25233	\N
8034	391	12	0	25532	\N
8034	1872	13	0	25533	\N
8035	326	12	0	22761	\N
8035	1873	13	0	25534	\N
8039	10	1	0	25543	\N
8039	11	2	0	25544	\N
8041	10	1	0	25543	\N
8041	11	2	0	25544	\N
8044	367	1	0	25550	\N
8044	368	2	0	25551	\N
8048	192	1	0	25558	\N
8048	193	2	0	25559	\N
8053	1	1	0	25421	\N
8053	53	2	0	25422	\N
8055	151	1	0	24820	\N
8055	302	2	0	24821	\N
8058	198	2	0	25257	\N
8058	746	3	0	25585	\N
8063	100	2	0	22870	\N
8063	1228	3	0	25597	\N
8065	10	2	0	25605	\N
8065	275	3	0	25606	\N
8070	488	2	0	25619	\N
8070	729	3	0	25620	\N
8073	123	2	0	25631	\N
8073	1868	3	0	25632	\N
8076	224	2	0	25647	\N
8076	508	3	0	25648	\N
8083	595	1	0	25236	\N
8083	596	2	0	25237	\N
8088	14	1	0	25452	\N
8088	15	2	0	25685	\N
8097	119	2	0	25700	\N
8097	1879	3	0	25701	\N
8106	192	1	0	25558	\N
8106	193	2	0	25559	\N
8108	10	1	0	25718	\N
8108	11	2	0	25729	\N
8111	40	1	0	25626	\N
8111	41	2	0	25742	\N
8115	115	1	0	25761	\N
8115	116	2	0	25762	\N
8120	4	1	0	25773	\N
8120	25	2	0	25774	\N
8127	117	1	0	25796	\N
8127	248	2	0	25797	\N
8131	260	1	0	25803	\N
8131	261	2	0	25804	\N
8137	391	2	0	25824	\N
8137	406	3	0	25825	\N
8140	360	2	0	22232	\N
8140	510	3	0	22635	\N
8142	115	1	0	25836	\N
8142	116	2	0	25837	\N
8145	167	2	0	25495	\N
8145	168	3	0	25496	\N
8147	206	2	0	25763	\N
8147	693	3	0	25847	\N
8158	23	1	0	25879	\N
8158	217	2	0	25880	\N
8149	741	2	0	25850	\N
8149	1886	3	0	25851	\N
8155	10	1	0	25813	\N
8155	11	2	0	25872	\N
8160	51	1	0	25298	\N
8160	52	2	0	25885	\N
8165	79	1	0	25608	\N
8165	81	2	0	25896	\N
8168	362	2	0	25905	\N
8168	420	3	0	25906	\N
8174	10	1	0	25917	\N
8174	11	2	0	25918	\N
8177	1890	2	0	25926	\N
8177	1891	3	0	25927	\N
8183	16	4	0	25838	\N
8183	380	5	0	25951	\N
8185	92	1	0	25958	\N
8185	191	2	0	25959	\N
8190	1	1	0	25883	\N
8190	53	2	0	25884	\N
8193	108	0	0	25979	\N
8159	53	2	0	25884	\N
8162	151	4	0	25888	\N
8162	1510	5	0	25889	\N
8167	170	2	0	25903	\N
8167	718	3	0	25904	\N
8169	362	2	0	25905	\N
8169	420	3	0	25906	\N
8172	435	1	0	25912	\N
8172	436	2	0	25913	\N
8181	35	2	0	25792	\N
8181	36	3	0	25941	\N
8182	119	4	0	25700	\N
8182	423	5	0	25950	\N
8192	108	2	0	25979	\N
8192	501	3	0	25980	\N
8163	10	2	0	25813	\N
8163	29	3	0	25814	\N
8166	242	1	0	25897	\N
8166	253	2	0	25898	\N
8170	198	1	0	25909	\N
8170	199	2	0	25910	\N
8173	56	1	0	25588	\N
8173	57	2	0	25914	\N
8175	1	2	0	25883	\N
8175	112	3	0	25923	\N
8178	391	2	0	25928	\N
8178	406	3	0	25929	\N
8179	20	1	0	25932	\N
8179	144	2	0	25933	\N
8186	1	1	0	25883	\N
8186	53	2	0	25884	\N
8188	852	1	0	25966	\N
8188	913	2	0	25967	\N
8191	40	1	0	25973	\N
8191	41	2	0	25974	\N
8171	392	2	0	25911	\N
8176	220	2	0	25924	\N
8176	821	3	0	25925	\N
8180	244	1	0	20961	\N
8180	245	2	0	25936	\N
8184	10	1	0	25954	\N
8184	11	2	0	25955	\N
8187	10	1	0	25962	\N
8187	11	2	0	25963	\N
8189	322	1	0	25450	\N
8189	323	2	0	25970	\N
8194	113	3	0	25983	\N
8194	778	4	0	25984	\N
8195	793	3	0	25497	\N
8195	1169	4	0	25985	\N
8196	40	3	0	25973	\N
8196	128	4	0	25986	\N
8197	1	1	0	25989	\N
8197	53	2	0	25990	\N
8198	10	1	0	25991	\N
8198	11	2	0	25992	\N
8199	33	1	0	25995	\N
8199	163	2	0	25996	\N
8200	67	1	0	25997	\N
8200	478	2	0	25998	\N
8201	235	1	0	25692	\N
8201	236	2	0	25693	\N
8202	54	3	0	26007	\N
8202	1892	4	0	26008	\N
8203	119	3	0	26009	\N
8203	1893	4	0	26010	\N
8204	852	3	0	26011	\N
8204	1894	4	0	26012	\N
8205	336	1	0	26015	\N
8205	356	2	0	26016	\N
8206	56	1	0	25588	\N
8206	57	2	0	25914	\N
8207	10	1	0	25991	\N
8207	11	2	0	25992	\N
8208	14	1	0	26021	\N
8208	15	2	0	26022	\N
8209	2	1	0	26023	\N
8209	26	2	0	26024	\N
8210	1895	56	0	26025	\N
8210	14	59	0	26026	\N
8210	383	60	0	26027	\N
8211	336	1	0	26030	\N
8211	356	2	0	26031	\N
8212	56	2	0	26036	\N
8212	169	3	0	26037	\N
8213	1	1	0	26040	\N
8213	53	2	0	26041	\N
8214	765	1	0	26042	\N
8214	766	2	0	26043	\N
8215	10	1	0	25991	\N
8215	11	2	0	25992	\N
8216	94	1	0	25082	\N
8216	107	2	0	25083	\N
8217	1470	2	0	26050	\N
8217	1896	3	0	26051	\N
8218	1	2	0	26040	\N
8218	444	3	0	26052	\N
8219	51	2	0	25298	\N
8219	1897	3	0	26053	\N
8220	237	2	0	19295	\N
8220	1898	3	0	26054	\N
8221	793	1	0	25497	\N
8221	1150	2	0	26057	\N
8222	10	1	0	26060	\N
8222	11	2	0	26061	\N
8223	79	1	0	26062	\N
8223	81	2	0	26063	\N
8224	142	1	0	26066	\N
8224	143	2	0	26067	\N
8225	56	1	0	26068	\N
8225	57	2	0	26069	\N
8226	235	1	0	26072	\N
8226	236	2	0	26073	\N
8227	16	1	0	25838	\N
8227	17	2	0	25839	\N
8228	94	1	0	25082	\N
8228	107	2	0	25083	\N
8229	10	1	0	26076	\N
8229	11	2	0	26077	\N
8230	595	3	0	25236	\N
8230	813	4	0	25509	\N
8231	42	3	0	25054	\N
8231	439	4	0	26084	\N
8232	597	3	0	26085	\N
8232	1406	4	0	26086	\N
8233	453	3	0	26087	\N
8233	1503	4	0	26088	\N
8234	147	3	0	21351	\N
8234	148	4	0	25512	\N
8235	1	2	0	26040	\N
8235	112	3	0	26093	\N
8236	279	0	0	26094	\N
8237	279	1	0	26094	\N
8237	473	2	0	26097	\N
8238	164	1	0	26100	\N
8238	165	2	0	26101	\N
8239	23	1	0	26102	\N
8239	217	2	0	26103	\N
8240	285	1	0	26104	\N
8240	286	2	0	26105	\N
8241	164	0	0	26100	\N
8242	56	1	0	26106	\N
8242	57	2	0	26107	\N
8243	29	2	0	26110	\N
8243	10	4	0	26113	\N
8243	11	5	0	26114	\N
8244	218	2	0	26115	\N
8244	18	3	0	26116	\N
8245	1048	2	0	26117	\N
8245	1021	4	0	26118	\N
8245	1022	5	0	26119	\N
8246	169	2	0	26120	\N
8246	56	4	0	26121	\N
8246	340	5	0	26122	\N
8247	10	1	0	26125	\N
8247	11	2	0	26126	\N
8248	94	1	0	25082	\N
8248	107	2	0	25083	\N
8249	1	1	0	26129	\N
8249	53	2	0	26130	\N
8250	10	1	0	26133	\N
8250	11	2	0	26134	\N
8251	151	1	0	26135	\N
8251	302	2	0	26136	\N
8252	391	1	0	26137	\N
8252	392	2	0	26138	\N
8253	167	1	0	25495	\N
8253	533	2	0	26139	\N
8254	113	2	0	26144	\N
8254	1899	3	0	26145	\N
8255	316	2	0	25442	\N
8255	1900	3	0	26146	\N
8256	75	2	0	25845	\N
8256	284	3	0	26147	\N
8257	10	0	0	26133	\N
8258	391	1	0	26137	\N
8258	392	2	0	26138	\N
8259	230	2	0	24199	\N
8259	231	3	0	24200	\N
8260	233	2	0	26154	\N
8260	910	3	0	26155	\N
8261	38	2	0	24393	\N
8261	39	3	0	26156	\N
8262	14	6	0	26021	\N
8262	1901	7	0	26168	\N
8263	16	6	0	26169	\N
8263	1902	7	0	26170	\N
8264	119	2	0	26174	\N
8264	1879	3	0	26175	\N
8265	92	2	0	26180	\N
8265	93	3	0	26181	\N
8266	10	3	0	26188	\N
8266	297	4	0	26189	\N
8271	75	1	0	25845	\N
8271	76	2	0	26200	\N
8274	40	3	0	25973	\N
8274	128	4	0	25986	\N
8281	132	1	0	26235	\N
8281	455	2	0	26236	\N
8283	244	1	0	26241	\N
8283	245	2	0	26242	\N
8288	2	2	0	26261	\N
8288	1911	3	0	26262	\N
8293	224	2	0	26280	\N
8293	508	3	0	26281	\N
8302	326	2	0	22761	\N
8302	393	3	0	26300	\N
8304	170	1	0	25903	\N
8304	398	2	0	26304	\N
8307	73	1	0	22523	\N
8307	74	2	0	26306	\N
8309	353	3	0	25694	\N
8309	1919	4	0	26314	\N
8311	10	1	0	26324	\N
8311	11	2	0	26325	\N
8314	1922	1	0	26337	\N
8314	1923	2	0	26338	\N
8317	64	5	0	26349	\N
8317	1925	6	0	26350	\N
8319	1	1	0	26239	\N
8319	53	2	0	26240	\N
8321	173	1	0	26356	\N
8321	1927	2	0	26357	\N
8322	528	1	0	24668	\N
8322	1093	2	0	26358	\N
8324	10	2	0	26324	\N
8324	29	3	0	26368	\N
8331	30	1	0	22920	\N
8331	418	2	0	24144	\N
8334	170	1	0	25903	\N
8334	398	2	0	26304	\N
8337	75	1	0	26243	\N
8337	76	2	0	26244	\N
8340	16	1	0	26404	\N
8340	17	2	0	26405	\N
8346	4	1	0	25875	\N
8346	25	2	0	25876	\N
8351	30	3	0	26452	\N
8351	1932	4	0	26453	\N
8356	123	2	0	26469	\N
8356	384	3	0	26470	\N
8359	1470	2	0	26481	\N
8359	1565	3	0	26482	\N
8362	10	1	0	26324	\N
8362	11	2	0	26325	\N
8365	353	1	0	26507	\N
8365	354	2	0	26508	\N
8368	121	1	0	25834	\N
8368	122	2	0	25835	\N
8370	60	2	0	24885	\N
8370	166	3	0	24886	\N
8375	320	2	0	26537	\N
8375	1937	3	0	26538	\N
8379	96	4	0	26551	\N
8379	1941	5	0	26552	\N
8385	793	1	0	26577	\N
8385	1150	2	0	26578	\N
8390	2	2	0	26591	\N
8390	1911	3	0	26592	\N
8392	46	1	0	1086	\N
8392	839	2	0	7547	\N
8394	10	2	0	26604	\N
8394	1946	3	0	26605	\N
8396	1	2	0	26515	\N
8396	1948	3	0	26608	\N
8399	54	1	0	26007	\N
8399	55	2	0	26616	\N
8401	102	1	0	22943	\N
8401	103	2	0	22978	\N
8410	1949	1	0	26635	\N
8410	1950	2	0	26636	\N
8415	75	0	0	26243	\N
8420	14	0	0	26558	\N
8423	1	0	0	26649	\N
8425	10	0	0	26604	\N
8430	16	0	0	26653	\N
8432	10	0	0	26654	\N
8435	40	0	0	26517	\N
8439	62	0	0	26657	\N
8441	18	0	0	26658	\N
8445	35	0	0	26660	\N
8448	266	1	0	26668	\N
8448	1954	2	0	26669	\N
8451	140	1	0	25299	\N
8451	141	2	0	26681	\N
8453	10	1	0	26659	\N
8453	11	2	0	26684	\N
8458	12	1	0	24116	\N
8458	13	2	0	24117	\N
8460	1577	6	0	26694	\N
8460	12	7	0	26695	\N
8464	260	1	0	26193	\N
8464	261	2	0	26705	\N
8467	71	1	0	26711	\N
8467	72	2	0	26712	\N
8476	94	1	0	25082	\N
8476	107	2	0	25083	\N
8487	88	1	0	26771	\N
8487	89	2	0	26772	\N
8490	90	3	0	26583	\N
8490	877	4	0	26785	\N
8492	198	1	0	26790	\N
8492	199	2	0	26791	\N
8495	202	1	0	26732	\N
8495	203	2	0	26733	\N
8497	391	1	0	26798	\N
8497	392	2	0	26799	\N
8499	40	1	0	26517	\N
8499	41	2	0	26518	\N
8501	228	1	0	26805	\N
8501	229	2	0	26806	\N
8508	16	1	0	26728	\N
8508	17	2	0	26729	\N
8513	1021	1	0	26835	\N
8513	1022	2	0	26836	\N
8519	192	2	0	26851	\N
8519	838	3	0	26852	\N
8528	353	1	0	26879	\N
8528	354	2	0	26880	\N
8530	142	2	0	26066	\N
8530	656	3	0	26885	\N
8535	16	1	0	26728	\N
8535	17	2	0	26729	\N
8538	10	1	0	26843	\N
8538	11	2	0	26844	\N
8543	30	2	0	26916	\N
8543	31	3	0	26917	\N
8545	110	1	0	26599	\N
8545	134	2	0	26600	\N
8548	212	1	0	25060	\N
8548	213	2	0	25099	\N
8550	322	1	0	26933	\N
8550	323	2	0	26934	\N
8555	40	1	0	26918	\N
8555	41	2	0	26946	\N
8560	10	1	0	26929	\N
8560	11	2	0	26930	\N
8563	300	2	0	26969	\N
8563	706	3	0	26970	\N
8565	1	1	0	26975	\N
8565	53	2	0	26976	\N
8570	1	2	0	26975	\N
8570	112	3	0	26987	\N
8573	49	2	0	26271	\N
8573	328	3	0	26995	\N
8575	121	1	0	27000	\N
8575	122	2	0	27001	\N
8580	23	1	0	26102	\N
8580	217	2	0	26103	\N
8267	300	3	0	26190	\N
8267	1903	4	0	26191	\N
8269	51	1	0	25298	\N
8269	1905	2	0	26195	\N
8277	1907	2	0	26227	\N
8277	1908	3	0	26228	\N
8284	75	1	0	26243	\N
8284	76	2	0	26244	\N
8285	206	1	0	26245	\N
8285	207	2	0	26246	\N
8286	16	2	0	26251	\N
8286	155	3	0	26252	\N
8289	266	2	0	26263	\N
8289	1912	3	0	26264	\N
8291	214	3	0	26273	\N
8291	1110	4	0	26274	\N
8294	69	2	0	26275	\N
8294	500	3	0	26282	\N
8295	38	2	0	24393	\N
8295	39	3	0	26156	\N
8298	1916	3	0	26289	\N
8300	35	1	0	26294	\N
8300	340	2	0	26295	\N
8303	40	2	0	25973	\N
8303	282	3	0	26301	\N
8305	100	1	0	22870	\N
8305	160	2	0	22871	\N
8312	365	1	0	25113	\N
8312	366	2	0	26326	\N
8315	56	0	0	26106	\N
8327	40	1	0	26373	\N
8327	41	2	0	26374	\N
8329	279	1	0	26377	\N
8329	473	2	0	26378	\N
8332	14	1	0	26354	\N
8332	15	2	0	26387	\N
8335	18	2	0	25707	\N
8335	218	3	0	26116	\N
8341	18	1	0	26406	\N
8341	19	2	0	26407	\N
8344	88	6	0	26427	\N
8344	1930	7	0	26428	\N
8347	10	3	0	26324	\N
8347	347	4	0	26441	\N
8349	40	3	0	26443	\N
8349	128	4	0	26444	\N
8352	16	3	0	26404	\N
8352	1045	4	0	26454	\N
8354	1	4	0	26463	\N
8354	1933	5	0	26464	\N
8357	1376	2	0	15681	\N
8357	1934	3	0	26475	\N
8360	73	2	0	26487	\N
8360	703	3	0	26488	\N
8363	1	2	0	26501	\N
8363	112	3	0	26502	\N
8369	40	1	0	26517	\N
8369	41	2	0	26518	\N
8373	113	2	0	26144	\N
8373	114	3	0	26531	\N
8376	10	4	0	26546	\N
8376	1938	5	0	26547	\N
8380	1	4	0	26515	\N
8380	1942	5	0	26553	\N
8383	198	5	0	26571	\N
8383	1943	6	0	26572	\N
8388	90	126	0	26583	\N
8388	1944	127	0	26585	\N
8393	110	1	0	26599	\N
8393	134	2	0	26600	\N
8395	391	2	0	26606	\N
8395	1947	3	0	26607	\N
8397	125	1	0	24619	\N
8397	195	2	0	24620	\N
8402	2	1	0	26591	\N
8402	26	2	0	26619	\N
8404	285	1	0	26104	\N
8404	286	2	0	26105	\N
8407	75	1	0	26243	\N
8407	76	2	0	26244	\N
8411	10	3	0	26604	\N
8411	465	4	0	26643	\N
8413	18	3	0	26406	\N
8413	466	4	0	26646	\N
8414	841	0	0	26647	\N
8417	100	0	0	22870	\N
8426	10	0	0	26651	\N
8429	1	0	0	26649	\N
8431	262	0	0	23399	\N
8436	20	0	0	26450	\N
8438	326	0	0	22761	\N
8443	1793	0	0	23846	\N
8446	316	0	0	26661	\N
8447	266	1	0	26664	\N
8447	1953	2	0	26665	\N
8450	1	3	0	26649	\N
8450	711	4	0	26678	\N
8454	233	1	0	26685	\N
8454	234	2	0	26686	\N
8465	170	1	0	26708	\N
8465	398	2	0	26709	\N
8468	367	5	0	25550	\N
8468	386	6	0	26723	\N
8471	16	1	0	26728	\N
8471	17	2	0	26729	\N
8473	192	1	0	25558	\N
8473	193	2	0	25559	\N
8477	42	2	0	26744	\N
8477	681	3	0	26745	\N
8479	96	1	0	26551	\N
8479	97	2	0	26750	\N
8482	23	2	0	26102	\N
8482	1957	3	0	26757	\N
8484	1	2	0	26764	\N
8484	112	3	0	26765	\N
8486	279	2	0	26767	\N
8486	280	3	0	26768	\N
8500	206	1	0	26245	\N
8500	207	2	0	26246	\N
8505	79	1	0	26062	\N
8505	81	2	0	26063	\N
8507	10	1	0	26822	\N
8507	11	2	0	26823	\N
8509	40	1	0	26824	\N
8509	41	2	0	26825	\N
8512	300	1	0	26190	\N
8512	355	2	0	26832	\N
8514	33	1	0	26839	\N
8514	163	2	0	26840	\N
8517	212	2	0	25060	\N
8517	566	3	0	25061	\N
8520	1	2	0	26764	\N
8520	112	3	0	26765	\N
8521	30	1	0	26452	\N
8521	418	2	0	26855	\N
8525	79	1	0	26873	\N
8525	81	2	0	26874	\N
8527	1	1	0	26877	\N
8527	53	2	0	26878	\N
8537	16	4	0	26728	\N
8537	380	5	0	26904	\N
8542	33	2	0	26914	\N
8542	34	3	0	26915	\N
8547	10	2	0	26843	\N
8547	29	3	0	26926	\N
8552	1	0	0	26877	\N
8556	35	1	0	26949	\N
8556	340	2	0	26950	\N
8561	1	1	0	26877	\N
8561	53	2	0	26878	\N
8576	10	2	0	26993	\N
8576	29	3	0	26994	\N
8579	10	1	0	27016	\N
8579	11	2	0	27017	\N
8582	186	1	0	25124	\N
8582	187	2	0	27020	\N
8268	260	1	0	26193	\N
8268	1904	2	0	26194	\N
8270	119	1	0	26198	\N
8270	120	2	0	26199	\N
8273	228	3	0	21602	\N
8273	492	4	0	26211	\N
8276	10	1	0	26222	\N
8276	11	2	0	26223	\N
8279	44	2	0	26230	\N
8279	1910	3	0	26231	\N
8280	16	2	0	26169	\N
8280	388	3	0	26232	\N
8290	49	3	0	26271	\N
8290	1913	4	0	26272	\N
8297	1915	2	0	26286	\N
8299	336	1	0	26292	\N
8299	356	2	0	26293	\N
8306	1907	1	0	26227	\N
8306	1917	2	0	26305	\N
8308	4	3	0	25875	\N
8308	1918	4	0	26313	\N
8313	40	3	0	26333	\N
8313	1921	4	0	26334	\N
8316	71	5	0	26347	\N
8316	1924	6	0	26348	\N
8323	2	2	0	26261	\N
8323	131	3	0	26363	\N
8326	10	1	0	26324	\N
8326	11	2	0	26325	\N
8333	360	1	0	26390	\N
8333	479	2	0	26391	\N
8336	88	1	0	26400	\N
8336	89	2	0	26401	\N
8339	687	1	0	5449	\N
8339	688	2	0	5450	\N
8343	46	3	0	1086	\N
8343	1929	4	0	26414	\N
8345	322	1	0	26431	\N
8345	323	2	0	26432	\N
8367	1	1	0	26515	\N
8367	53	2	0	26516	\N
8372	258	1	0	26525	\N
8372	309	2	0	26526	\N
8374	198	1	0	25909	\N
8374	199	2	0	25910	\N
8378	119	4	0	26198	\N
8378	1940	5	0	26550	\N
8382	35	2	0	26294	\N
8382	36	3	0	26560	\N
8387	90	1	0	26583	\N
8387	344	2	0	26584	\N
8389	42	2	0	25054	\N
8389	1945	3	0	26590	\N
8391	121	1	0	26595	\N
8391	122	2	0	26596	\N
8398	453	1	0	26087	\N
8398	454	2	0	26613	\N
8409	56	1	0	26633	\N
8409	57	2	0	26634	\N
8419	1951	0	0	26648	\N
8422	290	0	0	23625	\N
8427	33	0	0	25995	\N
8434	202	0	0	26655	\N
8437	113	0	0	26656	\N
8444	10	0	0	26659	\N
8455	113	1	0	26656	\N
8455	437	2	0	26689	\N
8457	40	1	0	26517	\N
8457	41	2	0	26518	\N
8461	10	1	0	26698	\N
8461	11	2	0	26699	\N
8463	1	1	0	26649	\N
8463	53	2	0	26692	\N
8466	391	1	0	26606	\N
8466	392	2	0	26710	\N
8469	367	5	0	25550	\N
8469	386	6	0	26723	\N
8475	115	1	0	26736	\N
8475	116	2	0	26737	\N
8478	51	2	0	26746	\N
8478	524	3	0	26747	\N
8480	285	1	0	26751	\N
8480	286	2	0	26752	\N
8485	71	2	0	26711	\N
8485	401	3	0	26766	\N
8489	1109	1	0	26777	\N
8489	1111	2	0	26778	\N
8494	20	1	0	26794	\N
8494	144	2	0	26795	\N
8496	212	1	0	25060	\N
8496	213	2	0	25099	\N
8498	56	1	0	26758	\N
8498	57	2	0	26800	\N
8503	220	1	0	25924	\N
8503	221	2	0	26811	\N
8506	6	1	0	26818	\N
8506	194	2	0	26819	\N
8510	10	1	0	26828	\N
8510	11	2	0	26829	\N
8515	10	1	0	26843	\N
8515	11	2	0	26844	\N
8518	230	2	0	24199	\N
8518	231	3	0	24200	\N
8522	73	3	0	26862	\N
8522	1958	4	0	26863	\N
8523	1109	2	0	26868	\N
8523	1412	3	0	26869	\N
8529	353	0	0	26879	\N
8532	10	1	0	26843	\N
8532	11	2	0	26844	\N
8534	90	1	0	26583	\N
8534	344	2	0	26584	\N
8540	35	1	0	26660	\N
8540	340	2	0	26907	\N
8554	1470	1	0	26942	\N
8554	1471	2	0	26943	\N
8557	18	1	0	26953	\N
8557	19	2	0	26954	\N
8559	1	1	0	26877	\N
8559	53	2	0	26878	\N
8562	220	2	0	26963	\N
8562	821	3	0	26964	\N
8567	75	1	0	26977	\N
8567	76	2	0	26978	\N
8569	324	1	0	23793	\N
8569	325	2	0	24958	\N
8572	10	2	0	26993	\N
8572	29	3	0	26994	\N
8574	49	1	0	26998	\N
8574	50	2	0	26999	\N
8577	285	1	0	27008	\N
8577	286	2	0	27009	\N
8584	1959	43	0	27026	\N
8584	181	102	0	27027	\N
8584	1960	103	0	27028	\N
8594	1109	1	0	27053	\N
8594	1111	2	0	27054	\N
8596	10	1	0	27063	\N
8596	11	2	0	27064	\N
8598	119	1	0	26198	\N
8598	120	2	0	26199	\N
8608	1	1	0	26975	\N
8608	53	2	0	26976	\N
8610	1964	22	0	27129	\N
8610	424	23	0	27130	\N
8613	30	2	0	27139	\N
8613	31	3	0	27140	\N
8616	391	1	0	27146	\N
8616	392	2	0	27147	\N
8618	1965	1	0	27152	\N
8618	1966	2	0	27153	\N
8620	189	1	0	27158	\N
8620	190	2	0	27159	\N
8625	996	2	0	27166	\N
8625	1967	3	0	27168	\N
8627	149	2	0	27181	\N
8272	488	1	0	26203	\N
8272	489	2	0	26204	\N
8275	273	3	0	26218	\N
8275	1906	4	0	26219	\N
8278	290	2	0	23625	\N
8278	1909	3	0	26229	\N
8282	1	1	0	26239	\N
8282	53	2	0	26240	\N
8287	132	1	0	26255	\N
8287	455	2	0	26256	\N
8292	69	0	0	26275	\N
8296	285	2	0	26104	\N
8296	1276	3	0	26283	\N
8301	71	1	0	24480	\N
8301	72	2	0	24481	\N
8310	1694	9	0	26315	\N
8310	4	105	0	26320	\N
8310	1920	106	0	26321	\N
8318	64	5	0	26349	\N
8318	1925	6	0	26350	\N
8320	14	1	0	26354	\N
8320	1926	2	0	26355	\N
8325	16	2	0	26369	\N
8325	155	3	0	26370	\N
8328	75	1	0	26243	\N
8328	76	2	0	26244	\N
8330	16	1	0	26381	\N
8330	17	2	0	26382	\N
8338	687	0	0	5449	\N
8342	228	3	0	26412	\N
8342	1928	4	0	26413	\N
8348	54	3	0	26007	\N
8348	476	4	0	26442	\N
8350	20	3	0	26450	\N
8350	1931	4	0	26451	\N
8353	18	3	0	26406	\N
8353	609	4	0	26455	\N
8355	10	2	0	26324	\N
8355	29	3	0	26368	\N
8358	30	2	0	26452	\N
8358	1127	3	0	26476	\N
8361	88	2	0	26493	\N
8361	154	3	0	26494	\N
8364	431	1	0	26505	\N
8364	432	2	0	26506	\N
8366	1935	1	0	26511	\N
8366	1936	2	0	26512	\N
8371	336	1	0	26292	\N
8371	356	2	0	26293	\N
8377	210	4	0	26548	\N
8377	1939	5	0	26549	\N
8381	14	2	0	26558	\N
8381	383	3	0	26559	\N
8384	1470	1	0	26575	\N
8384	1471	2	0	26576	\N
8386	365	1	0	26581	\N
8386	366	2	0	26582	\N
8400	242	1	0	25897	\N
8400	253	2	0	25898	\N
8403	852	1	0	26011	\N
8403	913	2	0	26620	\N
8405	40	1	0	26517	\N
8405	41	2	0	26518	\N
8406	88	1	0	26625	\N
8406	89	2	0	26626	\N
8408	1	1	0	26629	\N
8408	53	2	0	26630	\N
8412	156	3	0	26644	\N
8412	1548	4	0	26645	\N
8416	102	0	0	22943	\N
8418	251	0	0	25126	\N
8421	1	0	0	26649	\N
8428	88	0	0	26652	\N
8433	18	0	0	26406	\N
8440	1	0	0	26649	\N
8442	102	0	0	22943	\N
8449	82	3	0	26676	\N
8449	1955	4	0	26677	\N
8452	431	1	0	26505	\N
8452	432	2	0	26506	\N
8456	1	1	0	26649	\N
8456	53	2	0	26692	\N
8459	435	1	0	25912	\N
8459	436	2	0	25913	\N
8462	16	1	0	26653	\N
8462	17	2	0	26700	\N
8470	1841	1	0	26726	\N
8470	1842	2	0	26727	\N
8472	202	1	0	26732	\N
8472	203	2	0	26733	\N
8474	206	1	0	26245	\N
8474	207	2	0	26246	\N
8481	1470	2	0	26575	\N
8481	1956	3	0	26756	\N
8483	56	2	0	26758	\N
8483	1469	3	0	26759	\N
8488	251	1	0	26773	\N
8488	252	2	0	26774	\N
8491	173	3	0	26786	\N
8491	174	4	0	26787	\N
8493	10	1	0	26698	\N
8493	11	2	0	26699	\N
8502	18	1	0	26807	\N
8502	19	2	0	26808	\N
8504	453	1	0	26814	\N
8504	454	2	0	26815	\N
8511	235	1	0	26072	\N
8511	236	2	0	26073	\N
8516	132	1	0	26845	\N
8516	455	2	0	26846	\N
8524	69	1	0	26275	\N
8524	70	2	0	26872	\N
8526	198	1	0	26790	\N
8526	199	2	0	26791	\N
8531	264	2	0	26886	\N
8531	265	3	0	26887	\N
8533	1021	1	0	26890	\N
8533	1022	2	0	26891	\N
8536	40	1	0	26824	\N
8536	41	2	0	26825	\N
8539	35	1	0	26660	\N
8539	340	2	0	26907	\N
8541	391	1	0	26798	\N
8541	392	2	0	26799	\N
8544	40	2	0	26918	\N
8544	66	3	0	26919	\N
8546	224	2	0	26280	\N
8546	508	3	0	26281	\N
8549	10	1	0	26929	\N
8549	11	2	0	26930	\N
8551	56	0	0	26935	\N
8553	367	1	0	26938	\N
8553	368	2	0	26939	\N
8558	75	1	0	26243	\N
8558	76	2	0	26244	\N
8564	10	2	0	26971	\N
8564	29	3	0	26972	\N
8566	237	1	0	19295	\N
8566	527	2	0	22253	\N
8568	237	1	0	26981	\N
8568	527	2	0	26982	\N
8571	235	2	0	26072	\N
8571	1061	3	0	26988	\N
8578	123	1	0	27012	\N
8578	124	2	0	27013	\N
8581	142	1	0	26066	\N
8581	143	2	0	26067	\N
8583	142	1	0	27023	\N
8583	143	2	0	27024	\N
8585	488	1	0	27031	\N
8585	489	2	0	27032	\N
8588	192	1	0	26851	\N
8588	193	2	0	27040	\N
8590	224	2	0	26280	\N
8590	508	3	0	26281	\N
8597	167	1	0	27065	\N
8586	488	1	0	27035	\N
8586	489	2	0	27036	\N
8591	10	1	0	27047	\N
8591	11	2	0	27048	\N
8593	94	1	0	27051	\N
8593	107	2	0	27052	\N
8595	320	2	0	27059	\N
8595	1937	3	0	27060	\N
8602	94	1	0	27051	\N
8602	107	2	0	27052	\N
8605	1961	7	0	27089	\N
8605	451	19	0	27112	\N
8605	452	20	0	27115	\N
8607	10	4	0	27063	\N
8607	600	5	0	27126	\N
8612	10	2	0	27137	\N
8612	29	3	0	27138	\N
8614	40	2	0	27049	\N
8614	66	3	0	27141	\N
8619	230	1	0	24199	\N
8619	287	2	0	24585	\N
8626	1968	9	0	27169	\N
8626	996	124	0	27170	\N
8626	124	125	1	27171	\N
8626	1969	125	0	27172	\N
8626	1971	126	1	27173	\N
8626	1970	126	0	27174	\N
8626	1973	127	1	27175	\N
8626	1972	127	0	27176	\N
8628	42	2	0	27183	\N
8628	681	3	0	27184	\N
8637	88	1	0	27206	\N
8637	89	2	0	27207	\N
8642	300	1	0	26969	\N
8642	355	2	0	27039	\N
8645	210	0	0	26548	\N
8648	260	2	0	27239	\N
8648	419	3	0	27240	\N
8653	10	2	0	27255	\N
8653	29	3	0	27261	\N
8659	12	1	0	27270	\N
8659	13	2	0	27271	\N
8660	262	1	0	27272	\N
8660	263	2	0	27273	\N
8662	147	1	0	21351	\N
8662	599	2	0	23413	\N
8667	117	4	0	27298	\N
8667	139	5	0	27299	\N
8675	391	0	0	27214	\N
8682	1976	42	0	27336	\N
8682	908	88	0	27337	\N
8682	1977	89	0	27338	\N
8692	14	2	0	27371	\N
8692	383	3	0	27372	\N
8699	852	1	0	26011	\N
8699	913	2	0	26620	\N
8702	108	5	0	27401	\N
8702	1980	6	0	27402	\N
8705	164	1	0	27411	\N
8705	165	2	0	27412	\N
8706	241	4	0	27421	\N
8706	686	5	0	27422	\N
8709	79	1	0	27432	\N
8709	81	2	0	27433	\N
8710	1	8	0	27450	\N
8710	1982	9	0	27451	\N
8722	793	4	0	27508	\N
8722	1986	5	0	27509	\N
8725	1018	0	0	27528	\N
8725	1979	0	0	27529	\N
8727	12	2	0	27539	\N
8727	433	3	0	27540	\N
8730	61	1	0	27543	\N
8730	60	3	0	27550	\N
8730	61	4	0	27551	\N
8737	10	2	0	27592	\N
8737	29	3	0	27593	\N
8743	402	2	0	27630	\N
8743	1148	3	0	27631	\N
8750	75	2	0	27656	\N
8750	159	3	0	27657	\N
8753	10	2	0	27666	\N
8753	29	3	0	27667	\N
8757	360	2	0	27685	\N
8757	510	3	0	27686	\N
8759	16	2	0	27634	\N
8759	155	3	0	27635	\N
8761	186	2	0	25124	\N
8761	696	3	0	27691	\N
8764	1	2	0	27664	\N
8764	112	3	0	27665	\N
8773	51	6	0	26746	\N
8773	1994	7	0	27728	\N
8775	75	2	0	27707	\N
8775	159	3	0	27708	\N
8778	449	2	0	27747	\N
8778	583	3	0	27748	\N
8780	357	4	0	27763	\N
8780	1995	5	0	27764	\N
8780	1996	5	0	27765	\N
8784	1018	2	0	27358	\N
8784	1999	2	0	27774	\N
8800	10	1	0	27838	\N
8800	11	2	0	27839	\N
8803	75	2	0	27707	\N
8803	159	3	0	27708	\N
8810	353	3	0	26879	\N
8810	1527	4	0	27879	\N
8812	10	2	0	27884	\N
8812	29	3	0	27885	\N
8820	18	3	0	27831	\N
8820	127	4	0	27914	\N
8821	345	2	0	14729	\N
8821	1167	3	0	27919	\N
8837	2023	4	0	28009	\N
8837	2024	4	0	28010	\N
8837	2026	5	1	28011	\N
8837	2025	5	0	28012	\N
8838	189	4	0	28013	\N
8838	849	5	0	28014	\N
8844	69	2	0	26275	\N
8844	500	3	0	26282	\N
8846	1914	1	0	28039	\N
8846	2031	2	0	28040	\N
8851	595	2	0	27276	\N
8851	768	3	0	28059	\N
8855	597	2	0	26085	\N
8855	767	3	0	28064	\N
8860	962	2	0	8997	\N
8860	2033	3	0	28091	\N
8863	10	2	0	28098	\N
8863	29	3	0	28099	\N
8867	44	2	0	27956	\N
8867	161	3	0	28113	\N
8872	135	2	0	24975	\N
8872	196	3	0	27700	\N
8873	137	2	0	27701	\N
8873	197	3	0	27702	\N
8874	51	2	0	28135	\N
8874	524	3	0	28136	\N
8876	94	9	0	27051	\N
8876	2034	10	0	28137	\N
8891	1021	2	0	28225	\N
8891	1048	3	0	28226	\N
8895	75	4	0	28237	\N
8898	121	4	0	28244	\N
8898	848	5	0	28251	\N
8903	597	3	0	26085	\N
8903	1406	4	0	26086	\N
8906	258	2	0	26525	\N
8906	585	3	0	28269	\N
8895	2037	5	0	138426	\N
8895	2038	5	1	138427	\N
8784	2001	3	1	138424	\N
8784	2003	4	1	27784	\N
8587	300	1	0	26969	\N
8587	355	2	0	27039	\N
8589	435	1	0	25912	\N
8589	436	2	0	25913	\N
8592	40	1	0	27049	\N
8592	41	2	0	27050	\N
8599	71	1	0	26711	\N
8599	72	2	0	26712	\N
8601	170	1	0	26708	\N
8601	398	2	0	26709	\N
8603	1961	7	0	27089	\N
8603	451	19	0	27112	\N
8603	1211	20	1	27113	\N
8603	1962	20	0	27114	\N
8606	181	33	0	27122	\N
8606	1963	34	0	27123	\N
8621	75	1	0	26977	\N
8621	76	2	0	26978	\N
8623	235	0	0	27162	\N
8630	79	2	0	27190	\N
8630	80	3	0	27191	\N
8635	132	0	0	27199	\N
8636	1	2	0	27144	\N
8636	112	3	0	27203	\N
8639	94	1	0	27051	\N
8639	107	2	0	27052	\N
8641	841	1	0	27212	\N
8641	842	2	0	27213	\N
8647	173	2	0	27237	\N
8647	480	3	0	27238	\N
8651	10	1	0	27255	\N
8651	11	2	0	27256	\N
8655	391	1	0	27214	\N
8655	392	2	0	27215	\N
8661	595	1	0	27276	\N
8661	596	2	0	27277	\N
8664	597	1	0	26085	\N
8664	598	2	0	27280	\N
8666	224	1	0	27288	\N
8666	225	2	0	27289	\N
8670	108	0	0	27308	\N
8672	79	0	0	27314	\N
8677	110	0	0	27317	\N
8680	113	1	0	27328	\N
8680	437	2	0	27329	\N
8684	424	1	0	27343	\N
8684	425	2	0	27344	\N
8687	102	2	0	27150	\N
8687	158	3	0	27350	\N
8689	10	1	0	27361	\N
8689	11	2	0	27362	\N
8691	18	1	0	26953	\N
8691	19	2	0	26954	\N
8694	156	1	0	27376	\N
8694	157	2	0	27377	\N
8701	449	1	0	27390	\N
8701	450	2	0	27391	\N
8704	121	2	0	27000	\N
8704	625	3	0	27408	\N
8708	237	1	0	26981	\N
8708	527	2	0	26982	\N
8712	156	2	0	27458	\N
8712	571	3	0	27459	\N
8719	316	4	0	26661	\N
8719	1024	5	0	27492	\N
8724	164	7	0	27526	\N
8724	1987	8	0	27527	\N
8729	41	1	0	27546	\N
8729	40	2	0	27547	\N
8731	1018	2	0	27358	\N
8731	1990	2	0	27556	\N
8731	1992	3	1	27557	\N
8731	1991	3	0	27558	\N
8734	10	2	0	27566	\N
8734	29	3	0	27567	\N
8740	435	2	0	27262	\N
8740	481	3	0	27263	\N
8747	10	2	0	27624	\N
8747	29	3	0	27625	\N
8752	1	2	0	27664	\N
8752	112	3	0	27665	\N
8756	40	2	0	27679	\N
8756	66	3	0	27680	\N
8769	10	2	0	27666	\N
8769	29	3	0	27667	\N
8772	140	6	0	25299	\N
8772	1730	7	0	27727	\N
8777	367	2	0	27745	\N
8777	651	3	0	27746	\N
8779	164	2	0	27753	\N
8779	226	3	0	27754	\N
8782	1015	4	0	27768	\N
8782	262	5	0	27769	\N
8787	279	2	0	27785	\N
8787	280	3	0	27786	\N
8788	391	2	0	27696	\N
8788	406	3	0	27697	\N
8791	1	4	0	27803	\N
8791	422	5	0	27804	\N
8794	186	4	0	27809	\N
8794	1363	5	0	27810	\N
8795	242	4	0	27819	\N
8795	1662	5	0	27820	\N
8798	244	2	0	27268	\N
8798	438	3	0	27833	\N
8802	251	2	0	26773	\N
8802	828	3	0	27849	\N
8805	367	4	0	27850	\N
8805	1231	5	0	27859	\N
8807	459	2	0	27870	\N
8807	1796	3	0	27871	\N
8814	268	4	0	27888	\N
8814	318	5	0	27889	\N
8816	966	0	0	27895	\N
8816	2009	0	0	27896	\N
8819	10	3	0	27884	\N
8819	347	4	0	27913	\N
8824	69	2	0	26275	\N
8824	500	3	0	26282	\N
8827	44	6	0	27956	\N
8827	2016	7	0	27957	\N
8831	35	3	0	27969	\N
8831	2019	4	0	27970	\N
8832	206	6	0	27983	\N
8832	2020	7	0	27984	\N
8840	75	4	0	28015	\N
8840	2028	5	1	28016	\N
8840	2027	5	0	28017	\N
8843	244	6	0	28033	\N
8843	2030	7	0	28034	\N
8848	49	3	0	28046	\N
8848	1740	4	0	28047	\N
8850	262	2	0	27272	\N
8850	731	3	0	28054	\N
8854	1	2	0	28062	\N
8854	112	3	0	28063	\N
8857	18	2	0	27831	\N
8857	218	3	0	27832	\N
8862	40	2	0	28096	\N
8862	66	3	0	28097	\N
8869	1	4	0	28062	\N
8869	422	5	0	28124	\N
8878	268	5	0	28149	\N
8878	642	6	0	28150	\N
8881	536	4	0	28163	\N
8881	2036	5	0	28164	\N
8884	228	2	0	26805	\N
8884	511	3	0	28188	\N
8888	16	2	0	27634	\N
8888	155	3	0	27635	\N
8890	451	0	0	28224	\N
8893	75	2	0	28015	\N
8893	159	3	0	28228	\N
8894	322	0	0	27991	\N
8897	121	8	0	28244	\N
8897	2039	9	0	28250	\N
8899	251	4	0	26773	\N
8597	533	2	0	27066	\N
8600	320	1	0	27071	\N
8600	334	2	0	27072	\N
8604	1961	7	0	27089	\N
8604	451	19	0	27112	\N
8604	452	20	0	27115	\N
8609	424	1	0	23395	\N
8609	425	2	0	24736	\N
8611	1	1	0	26975	\N
8611	53	2	0	26976	\N
8615	1	1	0	27144	\N
8615	53	2	0	27145	\N
8617	102	1	0	27150	\N
8617	103	2	0	27151	\N
8622	235	1	0	27162	\N
8622	236	2	0	27163	\N
8624	996	1	0	27166	\N
8624	997	2	0	27167	\N
8629	189	2	0	27158	\N
8629	311	3	0	27185	\N
8631	362	2	0	27192	\N
8631	420	3	0	27193	\N
8633	170	0	0	27197	\N
8643	391	1	0	27214	\N
8643	392	2	0	27215	\N
8644	10	2	0	27137	\N
8644	29	3	0	27138	\N
8649	40	4	0	27249	\N
8649	564	5	0	27250	\N
8652	326	1	0	22761	\N
8652	327	2	0	23008	\N
8656	2	1	0	27266	\N
8656	26	2	0	27267	\N
8668	119	2	0	27304	\N
8668	891	3	0	27305	\N
8673	14	0	0	27315	\N
8676	206	0	0	26245	\N
8678	67	2	0	27322	\N
8678	68	3	0	27323	\N
8683	151	1	0	26135	\N
8683	302	2	0	26136	\N
8690	391	1	0	27214	\N
8690	392	2	0	27215	\N
8695	237	1	0	26981	\N
8695	527	2	0	26982	\N
8697	125	1	0	27382	\N
8697	195	2	0	27383	\N
8700	1109	1	0	27053	\N
8700	1111	2	0	27054	\N
8703	62	5	0	26657	\N
8703	1981	6	0	27403	\N
8707	23	2	0	26102	\N
8707	24	3	0	27427	\N
8711	220	8	0	27452	\N
8711	1028	9	0	27453	\N
8713	1983	36	0	27470	\N
8713	704	119	0	27471	\N
8713	1984	120	0	27472	\N
8715	38	2	0	27479	\N
8715	39	3	0	27480	\N
8717	12	2	0	27481	\N
8717	433	3	0	27482	\N
8720	96	2	0	26551	\N
8720	482	3	0	27497	\N
8723	402	4	0	27510	\N
8723	1378	5	0	27511	\N
8726	10	2	0	27506	\N
8726	29	3	0	27534	\N
8728	61	1	0	27543	\N
8728	1988	2	0	27544	\N
8728	1989	2	0	27545	\N
8732	264	2	0	27559	\N
8732	265	3	0	27560	\N
8735	930	6	0	27580	\N
8735	1993	7	0	27581	\N
8738	10	4	0	27602	\N
8738	600	5	0	27603	\N
8741	391	2	0	27622	\N
8741	406	3	0	27623	\N
8744	268	2	0	27632	\N
8744	1387	3	0	27633	\N
8748	40	2	0	27650	\N
8748	66	3	0	27651	\N
8755	23	2	0	27673	\N
8755	24	3	0	27674	\N
8758	10	2	0	27666	\N
8758	29	3	0	27667	\N
8762	33	2	0	26914	\N
8762	34	3	0	26915	\N
8765	10	2	0	27666	\N
8765	29	3	0	27667	\N
8767	135	2	0	24975	\N
8767	196	3	0	27700	\N
8770	75	2	0	27707	\N
8770	159	3	0	27708	\N
8781	357	4	0	27763	\N
8781	1997	5	0	27766	\N
8781	1998	5	0	27767	\N
8785	44	2	0	26230	\N
8785	2005	3	1	27779	\N
8785	2004	3	0	27780	\N
8785	2006	4	0	27781	\N
8789	966	0	0	27791	\N
8789	2009	0	0	27792	\N
8792	391	4	0	27805	\N
8792	539	5	0	27806	\N
8796	35	2	0	27825	\N
8796	36	3	0	27826	\N
8801	113	3	0	27328	\N
8801	778	4	0	27844	\N
8806	108	2	0	27864	\N
8806	501	3	0	27865	\N
8808	2011	3	0	27874	\N
8808	2012	4	0	27875	\N
8815	268	3	0	27888	\N
8815	610	4	0	27894	\N
8817	51	3	0	27903	\N
8817	329	4	0	27904	\N
8822	10	4	0	27928	\N
8822	600	5	0	27929	\N
8828	71	6	0	27958	\N
8828	2017	7	0	27959	\N
8833	115	2	0	27989	\N
8833	636	3	0	27990	\N
8835	1	3	0	27998	\N
8835	2021	4	0	27999	\N
8841	132	6	0	27199	\N
8841	2029	7	0	28030	\N
8845	69	1	0	26275	\N
8845	70	2	0	26872	\N
8847	1914	2	0	28039	\N
8847	2032	3	0	28041	\N
8849	156	2	0	28052	\N
8849	571	3	0	28053	\N
8852	147	2	0	21351	\N
8852	516	3	0	21470	\N
8858	212	2	0	28079	\N
8858	566	3	0	28080	\N
8861	262	2	0	27272	\N
8861	731	3	0	28054	\N
8864	391	2	0	27805	\N
8864	406	3	0	28100	\N
8865	79	2	0	28105	\N
8865	80	3	0	28106	\N
8868	2	2	0	28114	\N
8868	131	3	0	28115	\N
8870	54	2	0	26007	\N
8870	485	3	0	28129	\N
8875	51	0	0	28135	\N
8877	100	5	0	22870	\N
8877	2035	6	0	28148	\N
8879	268	2	0	28151	\N
8879	1387	3	0	28152	\N
8882	14	4	0	28173	\N
8882	588	5	0	27372	\N
8885	10	2	0	28193	\N
8885	29	3	0	28194	\N
8627	697	3	0	27182	\N
8632	1974	67	0	27194	\N
8632	362	95	0	27195	\N
8632	1975	96	0	27196	\N
8634	142	0	0	27198	\N
8638	40	1	0	27049	\N
8638	41	2	0	27050	\N
8640	431	1	0	27210	\N
8640	432	2	0	27211	\N
8646	210	6	0	26548	\N
8646	622	7	0	27232	\N
8650	119	1	0	27253	\N
8650	120	2	0	27254	\N
8654	435	2	0	27262	\N
8654	481	3	0	27263	\N
8657	244	1	0	27268	\N
8657	245	2	0	27269	\N
8663	288	1	0	27278	\N
8663	400	2	0	27279	\N
8665	6	2	0	26818	\N
8665	179	3	0	27285	\N
8669	108	1	0	27308	\N
8669	109	2	0	27309	\N
8671	212	1	0	27312	\N
8671	213	2	0	27313	\N
8674	198	0	0	27316	\N
8679	142	1	0	27326	\N
8679	143	2	0	27327	\N
8681	908	1	0	24164	\N
8681	909	2	0	24165	\N
8686	117	2	0	27348	\N
8686	175	3	0	27349	\N
8688	1978	13	0	27357	\N
8688	1018	14	0	27358	\N
8688	1979	14	0	27359	\N
8693	2	2	0	27266	\N
8693	131	3	0	27373	\N
8696	1	1	0	27380	\N
8696	53	2	0	27381	\N
8698	16	1	0	27386	\N
8698	17	2	0	27387	\N
8714	704	2	0	27473	\N
8714	1985	3	0	27474	\N
8716	12	0	0	27270	\N
8718	14	4	0	27371	\N
8718	588	5	0	27491	\N
8721	10	4	0	27506	\N
8721	600	5	0	27507	\N
8733	1	2	0	27450	\N
8733	112	3	0	27565	\N
8736	206	2	0	27586	\N
8736	693	3	0	27587	\N
8739	151	4	0	27612	\N
8739	1510	5	0	27613	\N
8742	10	2	0	27624	\N
8742	29	3	0	27625	\N
8745	16	2	0	27634	\N
8745	155	3	0	27635	\N
8746	67	2	0	27640	\N
8746	68	3	0	27641	\N
8749	1	2	0	27450	\N
8749	112	3	0	27565	\N
8751	4	1	0	27660	\N
8751	25	2	0	27661	\N
8754	4	2	0	27660	\N
8754	579	3	0	27668	\N
8760	75	2	0	27656	\N
8760	159	3	0	27657	\N
8763	391	2	0	27696	\N
8763	406	3	0	27697	\N
8766	2	2	0	27698	\N
8766	131	3	0	27699	\N
8768	137	2	0	27701	\N
8768	197	3	0	27702	\N
8771	10	2	0	27713	\N
8771	29	3	0	27714	\N
8774	10	2	0	27733	\N
8774	29	3	0	27734	\N
8776	164	2	0	27739	\N
8776	226	3	0	27740	\N
8783	1015	4	0	27768	\N
8783	262	5	0	27769	\N
8786	44	2	0	26230	\N
8786	2001	3	1	27782	\N
8786	2007	3	0	27783	\N
8786	2008	4	0	27784	\N
8790	966	0	0	27793	\N
8790	2009	0	0	27794	\N
8793	279	4	0	27807	\N
8793	2010	5	0	27808	\N
8797	18	2	0	27831	\N
8797	218	3	0	27832	\N
8799	33	2	0	26914	\N
8799	34	3	0	26915	\N
8804	367	0	0	27850	\N
8809	2011	1	0	27874	\N
8809	2013	2	0	27876	\N
8811	353	1	0	26879	\N
8811	354	2	0	26880	\N
8813	2	2	0	27698	\N
8813	131	3	0	27699	\N
8818	411	3	0	27911	\N
8818	2014	4	0	27912	\N
8823	20	2	0	26794	\N
8823	702	3	0	27934	\N
8825	189	3	0	27158	\N
8825	827	4	0	27941	\N
8826	58	6	0	27954	\N
8826	2015	7	0	27955	\N
8829	2	6	0	27960	\N
8829	1566	7	0	27961	\N
8830	94	6	0	27051	\N
8830	2018	7	0	27962	\N
8834	322	2	0	27991	\N
8834	833	3	0	27992	\N
8836	459	3	0	27870	\N
8836	2022	4	0	28000	\N
8839	189	4	0	28013	\N
8839	849	5	0	28014	\N
8842	164	6	0	28031	\N
8842	662	7	0	28032	\N
8853	10	2	0	28060	\N
8853	29	3	0	28061	\N
8856	264	2	0	28069	\N
8856	265	3	0	28070	\N
8859	10	2	0	28085	\N
8859	29	3	0	28086	\N
8866	181	2	0	28107	\N
8866	769	3	0	28108	\N
8871	88	2	0	27206	\N
8871	154	3	0	28130	\N
8880	214	4	0	28161	\N
8880	649	5	0	28162	\N
8883	224	4	0	28182	\N
8883	994	5	0	28183	\N
8887	10	2	0	28217	\N
8887	29	3	0	28218	\N
8889	140	2	0	25299	\N
8889	487	3	0	28223	\N
8892	451	2	0	28224	\N
8892	452	3	0	28227	\N
8896	121	2	0	28244	\N
8896	625	3	0	28245	\N
8901	40	3	0	28096	\N
8901	128	4	0	28260	\N
8904	2	2	0	28114	\N
8904	131	3	0	28115	\N
8913	290	2	0	23625	\N
8913	575	3	0	28314	\N
8918	210	2	0	28340	\N
8918	458	3	0	28341	\N
8920	285	2	0	28348	\N
8920	1276	3	0	28349	\N
8930	202	3	0	28399	\N
8930	2044	4	0	28400	\N
8934	279	4	0	27807	\N
8934	2010	5	0	27808	\N
8886	1	8	0	28211	\N
8886	1982	9	0	28212	\N
8900	595	3	0	27276	\N
8900	813	4	0	28259	\N
8907	10	4	0	28278	\N
8907	600	5	0	28279	\N
8910	10	6	0	28300	\N
8910	426	7	0	28301	\N
8915	2	1	0	28114	\N
8915	26	2	0	28321	\N
8923	94	2	0	28366	\N
8923	2043	3	0	28367	\N
8925	198	2	0	28378	\N
8925	746	3	0	28379	\N
8928	320	2	0	27071	\N
8928	321	3	0	28388	\N
8933	69	4	0	26275	\N
8933	1721	5	0	28424	\N
8935	1	2	0	28284	\N
8935	112	3	0	28285	\N
8938	198	0	0	28436	\N
8940	12	0	0	28448	\N
8943	167	2	0	28468	\N
8943	168	3	0	28469	\N
8950	140	2	0	25299	\N
8950	487	3	0	28223	\N
8953	411	4	0	27911	\N
8953	1665	5	0	28521	\N
8958	2049	67	0	28535	\N
8958	186	126	0	28536	\N
8958	2051	127	1	28537	\N
8958	2050	127	0	28538	\N
8960	71	5	0	28550	\N
8960	2053	6	0	28551	\N
8974	322	2	0	28631	\N
8974	833	3	0	28632	\N
8976	119	2	0	28641	\N
8976	891	3	0	28642	\N
8978	835	2	0	28649	\N
8978	2061	3	0	28650	\N
8981	75	2	0	28494	\N
8981	159	3	0	28657	\N
8983	908	1	0	28662	\N
8983	909	2	0	28664	\N
8985	2	1	0	28114	\N
8985	26	2	0	28321	\N
8988	28	1	0	28688	\N
8988	27	7	0	28689	\N
8988	2064	8	1	28690	\N
8988	2069	8	0	28691	\N
8988	1623	9	1	28692	\N
8988	2070	9	0	28693	\N
8988	2071	10	0	28694	\N
8990	28	1	0	28688	\N
8990	27	7	0	28689	\N
8990	2073	8	0	28697	\N
8995	14	5	0	28720	\N
8995	2077	6	0	28721	\N
8998	10	6	0	28603	\N
8998	426	7	0	28738	\N
9005	1	2	0	28763	\N
9005	112	3	0	28764	\N
9010	210	4	0	28781	\N
9010	565	5	0	28782	\N
8899	1610	5	0	28252	\N
8902	147	3	0	21351	\N
8902	148	4	0	25512	\N
8905	10	2	0	28217	\N
8905	29	3	0	28218	\N
8908	1	2	0	28284	\N
8908	112	3	0	28285	\N
8911	40	2	0	28306	\N
8911	66	3	0	28307	\N
8916	167	5	0	28332	\N
8916	2040	6	0	28333	\N
8921	10	5	0	28360	\N
8921	2042	6	0	28361	\N
8926	10	2	0	28384	\N
8926	29	3	0	28385	\N
8931	10	4	0	28384	\N
8931	600	5	0	28409	\N
8936	230	2	0	28429	\N
8936	231	3	0	28430	\N
8939	267	1	0	28439	\N
8939	266	5	0	28446	\N
8939	405	6	0	28447	\N
8944	324	3	0	28476	\N
8944	617	4	0	28477	\N
8959	1	5	0	28533	\N
8959	2052	6	0	28549	\N
8964	10	4	0	28569	\N
8964	600	5	0	28570	\N
8967	96	4	0	28589	\N
8967	2055	5	0	28590	\N
8984	10	2	0	28603	\N
8984	29	3	0	28669	\N
8993	1	2	0	28643	\N
8993	112	3	0	28644	\N
8996	140	5	0	28722	\N
8996	2078	6	0	28723	\N
9001	258	2	0	28755	\N
9001	585	3	0	28756	\N
8909	324	2	0	28286	\N
8909	486	3	0	28287	\N
8912	288	2	0	28308	\N
8912	289	3	0	28309	\N
8914	210	2	0	28319	\N
8914	458	3	0	28320	\N
8917	51	5	0	28334	\N
8917	2041	6	0	28335	\N
8919	345	2	0	28342	\N
8919	1167	3	0	28343	\N
8922	1021	2	0	28225	\N
8922	1048	3	0	28226	\N
8924	20	2	0	28372	\N
8924	702	3	0	28373	\N
8927	42	2	0	28386	\N
8927	681	3	0	28387	\N
8929	132	2	0	27199	\N
8929	133	3	0	28393	\N
8932	237	2	0	28414	\N
8932	319	3	0	28415	\N
8937	71	2	0	27958	\N
8937	401	3	0	28435	\N
8942	4	2	0	28466	\N
8942	579	3	0	28467	\N
8945	94	2	0	28478	\N
8945	753	3	0	28479	\N
8947	10	5	0	28492	\N
8947	1298	6	0	28493	\N
8952	10	2	0	28511	\N
8952	29	3	0	28512	\N
8955	94	2	0	28523	\N
8955	2048	3	0	28524	\N
8957	186	4	0	27809	\N
8957	1363	5	0	27810	\N
8962	391	2	0	27805	\N
8962	406	3	0	28100	\N
8965	1	2	0	28575	\N
8965	112	3	0	28576	\N
8968	82	4	0	28591	\N
8968	2056	5	0	28592	\N
8970	413	5	0	16700	\N
8970	2058	6	0	28605	\N
8973	453	2	0	28629	\N
8973	902	3	0	28630	\N
8975	2059	20	0	28634	\N
8975	453	63	0	28635	\N
8975	2060	64	0	28636	\N
8980	137	2	0	28655	\N
8980	197	3	0	28656	\N
8982	908	2	0	28662	\N
8982	988	3	0	28663	\N
8987	1471	1	0	28670	\N
8987	1470	7	0	28686	\N
8987	2068	8	0	28687	\N
8997	1	6	0	28736	\N
8997	523	7	0	28737	\N
9000	273	2	0	28753	\N
9000	1159	3	0	28754	\N
9003	2	1	0	28757	\N
9003	26	2	0	28758	\N
9004	149	2	0	27181	\N
9004	697	3	0	27182	\N
9009	40	4	0	28779	\N
9009	564	5	0	28780	\N
8941	64	10	0	26349	\N
8941	2045	11	0	28461	\N
8946	206	2	0	28484	\N
8946	693	3	0	28485	\N
8948	75	5	0	28494	\N
8948	2046	6	0	28495	\N
8951	10	3	0	28505	\N
8951	2047	4	0	28506	\N
8954	1	4	0	28284	\N
8954	422	5	0	28522	\N
8956	1	4	0	28533	\N
8956	422	5	0	28534	\N
8961	1	2	0	28533	\N
8961	112	3	0	28556	\N
8963	1	2	0	28533	\N
8963	112	3	0	28556	\N
8966	94	1	0	28579	\N
8966	2054	2	0	28580	\N
8969	10	5	0	28603	\N
8969	2057	6	0	28604	\N
8971	528	2	0	24668	\N
8971	613	3	0	28610	\N
8972	40	6	0	28623	\N
8972	522	7	0	28624	\N
8977	1	2	0	28643	\N
8977	112	3	0	28644	\N
8979	135	2	0	24975	\N
8979	196	3	0	27700	\N
8986	1471	1	0	28670	\N
8986	2062	7	0	28680	\N
8986	2063	7	0	28681	\N
8986	2065	8	1	28682	\N
8986	2064	8	0	28683	\N
8986	2067	9	1	28684	\N
8986	2066	9	0	28685	\N
8989	19	1	0	27914	\N
8989	18	7	0	28695	\N
8989	2072	8	0	28696	\N
8991	1471	1	0	28670	\N
8991	1470	7	0	28686	\N
8991	2068	8	0	28687	\N
8992	2074	2	0	28702	\N
8992	2075	2	0	28703	\N
8994	322	2	0	28631	\N
8994	833	3	0	28632	\N
8999	79	4	0	28747	\N
8999	589	5	0	28748	\N
9002	38	2	0	27479	\N
9002	39	3	0	27480	\N
9006	453	2	0	28769	\N
9006	902	3	0	28770	\N
9011	79	4	0	28783	\N
9011	589	5	0	28784	\N
9012	411	2	0	27911	\N
9012	582	3	0	28789	\N
9013	60	4	0	28798	\N
9013	1687	5	0	28799	\N
9014	2079	2	0	28804	\N
9014	2080	3	0	28805	\N
9015	10	2	0	28603	\N
9015	29	3	0	28669	\N
9016	30	2	0	28810	\N
9016	31	3	0	28811	\N
9017	60	4	0	28820	\N
9017	1687	5	0	28821	\N
9018	2081	5	0	28831	\N
9018	2082	6	0	28832	\N
9019	23	2	0	28837	\N
9019	24	3	0	28838	\N
9020	151	2	0	28839	\N
9020	576	3	0	28840	\N
9021	151	1	0	28839	\N
9021	302	2	0	28841	\N
9022	1	2	0	28763	\N
9022	112	3	0	28764	\N
9023	14	4	0	28854	\N
9023	588	5	0	28855	\N
9024	360	4	0	27685	\N
9024	1617	5	0	28856	\N
9025	40	2	0	28779	\N
9025	66	3	0	28861	\N
9026	1	2	0	28862	\N
9026	112	3	0	28863	\N
9027	23	2	0	28837	\N
9027	24	3	0	28838	\N
9028	362	2	0	27192	\N
9028	420	3	0	27193	\N
9029	273	2	0	28753	\N
9029	1159	3	0	28754	\N
9030	14	2	0	28872	\N
9030	383	3	0	28873	\N
9031	841	3	0	27212	\N
9031	2083	4	0	28880	\N
9032	198	3	0	28881	\N
9032	1347	4	0	28882	\N
9033	251	3	0	28883	\N
9033	554	4	0	28884	\N
9034	360	4	0	27685	\N
9034	1617	5	0	28856	\N
9035	115	2	0	28897	\N
9035	636	3	0	28898	\N
9036	1	2	0	28899	\N
9036	112	3	0	28900	\N
9037	193	1	0	28903	\N
9037	192	3	0	27040	\N
9038	193	1	0	28903	\N
9038	192	3	0	27040	\N
9038	193	4	0	26852	\N
9039	322	2	0	28631	\N
9039	833	3	0	28632	\N
9040	69	2	0	26275	\N
9040	500	3	0	26282	\N
9041	18	2	0	28916	\N
9041	218	3	0	28917	\N
9042	102	5	0	27150	\N
9042	2086	6	0	28928	\N
9043	1368	0	0	28929	\N
9043	2087	0	0	28930	\N
9044	10	5	0	28603	\N
9044	2042	6	0	28931	\N
9045	2088	3	0	28932	\N
9045	2089	3	0	28933	\N
9045	677	4	1	28934	\N
9045	2090	4	0	28935	\N
9046	10	4	0	28944	\N
9046	600	5	0	28945	\N
9047	528	4	0	28946	\N
9047	2091	5	0	28947	\N
9048	192	13	0	28974	\N
9048	2092	14	0	28975	\N
9049	1	13	0	28899	\N
9049	2093	14	0	28976	\N
9050	241	13	0	28977	\N
9050	2094	14	0	28978	\N
9051	156	2	0	28983	\N
9051	571	3	0	28984	\N
9052	230	2	0	28985	\N
9052	231	3	0	28986	\N
9053	115	2	0	28991	\N
9053	636	3	0	28992	\N
9054	391	2	0	28993	\N
9054	406	3	0	28994	\N
9055	44	5	0	29004	\N
9055	2095	6	0	29005	\N
9056	64	5	0	29006	\N
9056	2096	6	0	29007	\N
9057	326	5	0	22761	\N
9057	2097	6	0	29008	\N
9058	40	2	0	28779	\N
9058	66	3	0	28861	\N
9059	92	2	0	29017	\N
9059	93	3	0	29018	\N
9060	262	2	0	29019	\N
8992	2076	3	1	138429	\N
9037	2085	4	1	138431	\N
9060	731	3	0	29020	\N
9065	362	2	0	27192	\N
9065	420	3	0	27193	\N
9071	46	2	0	29088	\N
9071	296	3	0	29089	\N
9074	10	2	0	29110	\N
9074	29	3	0	29111	\N
9086	206	35	0	28484	\N
9086	2104	36	0	29162	\N
9089	290	11	0	29195	\N
9089	2106	12	0	29196	\N
9092	16	11	0	29200	\N
9092	2109	12	0	29201	\N
9095	54	1	0	26007	\N
9095	55	2	0	26616	\N
9098	18	2	0	29208	\N
9098	218	3	0	29209	\N
9102	181	2	0	28107	\N
9102	769	3	0	28108	\N
9107	1	2	0	28899	\N
9107	112	3	0	28900	\N
9109	228	2	0	29245	\N
9109	511	3	0	29246	\N
9111	16	2	0	29200	\N
9111	155	3	0	29253	\N
9114	300	4	0	26969	\N
9114	1712	5	0	29274	\N
9117	10	4	0	29285	\N
9117	600	5	0	29286	\N
9123	123	2	0	29294	\N
9123	384	3	0	29295	\N
9128	94	18	0	29318	\N
9128	2110	19	0	29319	\N
9130	2111	1	0	29330	\N
9130	2112	2	0	29331	\N
9133	198	2	0	29341	\N
9133	746	3	0	29342	\N
9135	264	2	0	29351	\N
9135	265	3	0	29352	\N
9137	26	1	0	28115	\N
9137	2	3	0	28758	\N
9137	2116	5	0	29361	\N
9143	285	5	0	29390	\N
9143	2118	6	0	29391	\N
9146	51	4	0	28334	\N
9146	648	5	0	29418	\N
9155	793	2	0	27508	\N
9155	1136	3	0	29448	\N
9160	10	2	0	29468	\N
9160	29	3	0	29469	\N
9163	224	4	0	29498	\N
9163	994	5	0	29499	\N
9166	156	2	0	28983	\N
9166	571	3	0	28984	\N
9168	14	0	0	29515	\N
9170	18	2	0	29521	\N
9170	218	3	0	29522	\N
9176	14	2	0	29515	\N
9176	383	3	0	29520	\N
9180	1302	4	0	29578	\N
9180	115	7	0	29579	\N
9180	636	8	0	29580	\N
9186	1	4	0	29618	\N
9186	422	5	0	29619	\N
9188	71	4	0	29622	\N
9188	2127	5	0	29623	\N
9191	79	4	0	28783	\N
9191	589	5	0	28784	\N
9193	10	3	0	29644	\N
9193	347	4	0	29645	\N
9200	2	2	0	29459	\N
9200	131	3	0	29460	\N
9206	449	8	0	27747	\N
9206	2136	9	0	29734	\N
9212	402	4	0	29772	\N
9212	1378	5	0	29773	\N
9214	264	4	0	29776	\N
9214	2137	5	0	29777	\N
9217	214	6	0	29793	\N
9217	2138	7	0	29794	\N
9223	453	2	0	29818	\N
9223	902	3	0	29819	\N
9230	44	3	0	29832	\N
9230	940	4	0	29833	\N
9232	177	2	0	29842	\N
9232	178	3	0	29843	\N
9237	326	4	0	22761	\N
9237	1638	5	0	29867	\N
9240	10	2	0	29791	\N
9240	29	3	0	29811	\N
9243	10	3	0	29898	\N
9243	347	4	0	29899	\N
9245	6	3	0	29902	\N
9245	2140	4	0	29903	\N
9248	10	8	0	29898	\N
9248	1772	9	0	29984	\N
9251	426	6	0	30070	\N
9251	10	25	0	30071	\N
9251	2145	26	0	30072	\N
9252	2146	43	0	30074	\N
9252	285	126	0	30076	\N
9252	2147	127	0	30077	\N
9258	121	8	0	30114	\N
9258	2039	9	0	30115	\N
9260	316	8	0	30133	\N
9260	2121	9	0	30134	\N
9262	113	8	0	30153	\N
9262	2154	9	0	30154	\N
9266	1	0	0	30189	\N
9270	2	3	0	29896	\N
9270	572	4	0	29897	\N
9273	88	3	0	27206	\N
9273	580	4	0	30241	\N
9274	56	2	0	29900	\N
9274	169	3	0	30246	\N
9279	488	2	0	29830	\N
9279	729	3	0	30271	\N
9282	524	2	0	30278	\N
9282	51	3	0	30280	\N
9286	10	3	0	30185	\N
9286	347	4	0	30293	\N
9302	79	2	0	30381	\N
9302	80	3	0	30382	\N
9308	353	4	0	30424	\N
9308	1570	5	0	30425	\N
9311	391	3	0	30433	\N
9311	503	4	0	30434	\N
9313	75	3	0	30437	\N
9313	713	4	0	30438	\N
9317	102	2	0	27150	\N
9317	158	3	0	27350	\N
9320	96	2	0	30455	\N
9320	482	3	0	30456	\N
9322	10	6	0	30470	\N
9322	426	7	0	30471	\N
9324	23	2	0	30486	\N
9324	24	3	0	30487	\N
9327	169	2	0	30504	\N
9327	56	6	0	30510	\N
9327	475	7	0	30511	\N
9335	40	7	0	30549	\N
9335	2173	8	0	30550	\N
9337	10	2	0	30561	\N
9337	29	3	0	30562	\N
9340	402	2	0	30570	\N
9340	1148	3	0	30571	\N
9342	230	2	0	30580	\N
9342	231	3	0	30581	\N
9349	94	6	0	27051	\N
9349	2174	7	0	30608	\N
9354	18	2	0	30629	\N
9354	218	3	0	30630	\N
9359	40	0	0	28779	\N
9366	362	2	0	30654	\N
9366	420	3	0	30655	\N
9061	33	4	0	26914	\N
9061	447	5	0	29029	\N
9063	40	3	0	29037	\N
9063	128	4	0	29038	\N
9068	14	2	0	28872	\N
9068	383	3	0	28873	\N
9072	10	5	0	28944	\N
9072	1298	6	0	29099	\N
9075	391	2	0	29116	\N
9075	406	3	0	29117	\N
9080	167	4	0	28468	\N
9080	1011	5	0	29149	\N
9084	173	2	0	29158	\N
9084	2102	3	0	29159	\N
9100	402	2	0	27630	\N
9100	1148	3	0	27631	\N
9103	35	2	0	29225	\N
9103	36	3	0	29226	\N
9112	10	4	0	29262	\N
9112	600	5	0	29263	\N
9115	56	0	0	26935	\N
9118	1	4	0	28899	\N
9118	422	5	0	29287	\N
9120	56	0	0	26935	\N
9121	123	2	0	29294	\N
9121	384	3	0	29295	\N
9126	58	2	0	27954	\N
9126	665	3	0	29313	\N
9136	75	2	0	29353	\N
9136	159	3	0	29354	\N
9138	16	2	0	29264	\N
9138	155	3	0	29366	\N
9140	290	2	0	29195	\N
9140	575	3	0	29373	\N
9147	27	4	0	29419	\N
9147	942	5	0	29420	\N
9151	119	2	0	29283	\N
9151	891	3	0	29436	\N
9153	2011	2	0	29441	\N
9153	2120	3	0	29442	\N
9158	189	2	0	29461	\N
9158	311	3	0	29462	\N
9161	316	8	0	29486	\N
9161	2121	9	0	29487	\N
9164	10	2	0	29468	\N
9164	29	3	0	29469	\N
9169	14	2	0	29515	\N
9169	383	3	0	29520	\N
9171	1	3	0	29416	\N
9171	1114	4	0	29529	\N
9173	241	4	0	28977	\N
9173	2122	5	0	29539	\N
9177	10	2	0	29557	\N
9177	29	3	0	29558	\N
9181	539	4	0	29581	\N
9181	391	7	0	29582	\N
9181	406	8	0	29583	\N
9183	10	2	0	29557	\N
9183	29	3	0	29558	\N
9184	1	5	0	29602	\N
9184	1233	6	0	29603	\N
9187	279	4	0	29620	\N
9187	2010	5	0	29621	\N
9189	117	4	0	29632	\N
9189	139	5	0	29633	\N
9192	94	3	0	29636	\N
9192	2128	4	0	29637	\N
9196	186	5	0	29671	\N
9196	2130	6	0	29672	\N
9198	469	2	0	12958	\N
9198	2135	3	0	29689	\N
9201	40	2	0	29698	\N
9201	66	3	0	29699	\N
9203	251	2	0	28883	\N
9203	828	3	0	29710	\N
9209	14	2	0	29515	\N
9209	383	3	0	29520	\N
9219	288	4	0	29805	\N
9219	1710	5	0	29806	\N
9222	300	2	0	29812	\N
9222	706	3	0	29813	\N
9226	102	3	0	27150	\N
9226	1388	4	0	29828	\N
9235	1	2	0	29618	\N
9235	112	3	0	29858	\N
9238	56	2	0	29872	\N
9238	169	3	0	29873	\N
9249	362	16	0	30017	\N
9249	2142	17	0	30018	\N
9253	2148	6	0	30078	\N
9253	285	25	0	30079	\N
9253	2149	26	0	30080	\N
9254	121	7	0	28244	\N
9254	2150	8	0	30095	\N
9256	2	8	0	29896	\N
9256	2151	9	0	30112	\N
9261	210	8	0	30135	\N
9261	1026	9	0	30136	\N
9263	10	15	0	30185	\N
9263	1663	16	0	30186	\N
9271	40	3	0	30238	\N
9271	128	4	0	30239	\N
9275	256	2	0	30251	\N
9275	335	3	0	30252	\N
9277	62	2	0	30259	\N
9277	683	3	0	30260	\N
9280	241	2	0	30272	\N
9280	281	3	0	30273	\N
9284	198	2	0	29341	\N
9284	746	3	0	29342	\N
9287	82	2	0	28591	\N
9287	343	3	0	29447	\N
9289	2	2	0	29896	\N
9289	131	3	0	30308	\N
9292	449	4	0	30322	\N
9292	1574	5	0	30323	\N
9294	908	2	0	30335	\N
9294	988	3	0	30336	\N
9297	242	2	0	30348	\N
9297	620	3	0	30349	\N
9303	38	2	0	30383	\N
9303	39	3	0	30384	\N
9306	49	4	0	29307	\N
9306	2164	5	0	30413	\N
9315	40	4	0	30444	\N
9315	2167	5	0	30445	\N
9323	1157	4	0	30480	\N
9323	2169	5	0	30481	\N
9326	1	5	0	30189	\N
9326	1233	6	0	30499	\N
9329	79	2	0	30381	\N
9329	80	3	0	30382	\N
9331	92	2	0	29017	\N
9331	93	3	0	29018	\N
9334	181	4	0	30541	\N
9334	2172	5	0	30542	\N
9339	40	2	0	30549	\N
9339	66	3	0	30569	\N
9344	16	2	0	30582	\N
9344	155	3	0	30583	\N
9346	33	2	0	30592	\N
9346	34	3	0	30593	\N
9351	1	2	0	30619	\N
9351	112	3	0	30620	\N
9358	2	1	0	29896	\N
9358	26	2	0	30639	\N
9360	40	0	0	28779	\N
9362	40	0	0	29037	\N
9365	94	2	0	30652	\N
9365	95	3	0	30653	\N
9369	228	2	0	29245	\N
9369	511	3	0	29246	\N
9374	94	3	0	30652	\N
9374	375	4	0	30693	\N
9381	1347	3	0	30714	\N
9381	198	5	0	30715	\N
9381	199	6	0	30716	\N
9062	288	4	0	28308	\N
9062	1710	5	0	29030	\N
9064	1491	4	0	17354	\N
9067	173	5	0	27237	\N
9067	2098	6	0	29055	\N
9077	1068	3	0	29124	\N
9077	852	8	0	29133	\N
9077	1727	9	0	29136	\N
9079	54	1	0	26007	\N
9079	55	2	0	26616	\N
9082	192	3	0	29150	\N
9082	627	4	0	29152	\N
9083	125	2	0	27382	\N
9083	188	3	0	29153	\N
9085	266	2	0	29160	\N
9085	2103	3	0	29161	\N
9091	54	11	0	29198	\N
9091	2108	12	0	29199	\N
9094	54	1	0	26007	\N
9094	55	2	0	26616	\N
9097	288	2	0	28308	\N
9097	289	3	0	28309	\N
9099	18	3	0	29208	\N
9099	466	4	0	29215	\N
9106	391	2	0	29239	\N
9106	406	3	0	29240	\N
9108	1	2	0	28899	\N
9108	112	3	0	28900	\N
9125	49	4	0	29307	\N
9125	1595	5	0	29308	\N
9132	10	2	0	29339	\N
9132	29	3	0	29340	\N
9139	1	2	0	29367	\N
9139	112	3	0	29368	\N
9142	320	5	0	27071	\N
9142	2117	6	0	29389	\N
9145	1	4	0	29416	\N
9145	422	5	0	29417	\N
9148	10	4	0	29421	\N
9148	600	5	0	29422	\N
9150	1	4	0	29416	\N
9150	422	5	0	29417	\N
9157	2	2	0	29459	\N
9157	131	3	0	29460	\N
9159	40	2	0	29037	\N
9159	66	3	0	29467	\N
9165	12	2	0	29508	\N
9165	433	3	0	29509	\N
9175	164	2	0	29555	\N
9175	226	3	0	29556	\N
9178	18	2	0	29559	\N
9178	218	3	0	29560	\N
9182	451	2	0	28224	\N
9182	452	3	0	28227	\N
9185	156	2	0	29608	\N
9185	571	3	0	29609	\N
9190	56	4	0	29634	\N
9190	1145	5	0	29635	\N
9195	402	5	0	29669	\N
9195	2129	6	0	29670	\N
9197	2131	67	0	29680	\N
9197	186	125	0	29681	\N
9197	2133	126	1	29682	\N
9197	2132	126	0	29683	\N
9197	2134	127	0	29684	\N
9202	181	2	0	29704	\N
9202	769	3	0	29705	\N
9208	235	2	0	29749	\N
9208	1061	3	0	29750	\N
9211	40	4	0	29770	\N
9211	564	5	0	29771	\N
9216	10	6	0	29791	\N
9216	426	7	0	29792	\N
9218	42	4	0	29803	\N
9218	2139	5	0	29804	\N
9221	300	2	0	29812	\N
9221	706	3	0	29813	\N
9225	73	2	0	29820	\N
9225	703	3	0	29821	\N
9228	1	3	0	29618	\N
9228	48	4	0	29829	\N
9229	488	3	0	29830	\N
9229	1324	4	0	29831	\N
9234	210	2	0	29852	\N
9234	458	3	0	29853	\N
9239	40	2	0	29878	\N
9239	66	3	0	29879	\N
9242	2	3	0	29896	\N
9242	572	4	0	29897	\N
9244	56	3	0	29900	\N
9244	475	4	0	29901	\N
9247	1	20	0	29966	\N
9247	2141	21	0	29967	\N
9265	1	0	0	29966	\N
9267	1	1	0	30189	\N
9267	53	2	0	30191	\N
9269	18	11	0	29559	\N
9269	2156	12	0	30231	\N
9281	524	2	0	30278	\N
9281	1650	3	0	20747	\N
9281	2157	3	0	30279	\N
9283	524	2	0	30278	\N
9283	51	3	0	30280	\N
9288	23	2	0	30302	\N
9288	24	3	0	30303	\N
9290	1096	2	0	30309	\N
9290	2158	3	0	30310	\N
9291	2159	16	0	30311	\N
9291	1096	126	0	30312	\N
9291	2160	127	0	30313	\N
9293	77	3	0	30329	\N
9293	2161	4	0	30330	\N
9298	360	2	0	30354	\N
9298	510	3	0	30355	\N
9300	14	2	0	30362	\N
9300	383	3	0	30363	\N
9301	140	6	0	28722	\N
9301	1730	7	0	30376	\N
9304	156	8	0	30401	\N
9304	2162	9	0	30402	\N
9307	451	4	0	30414	\N
9307	2165	5	0	30415	\N
9309	88	4	0	27206	\N
9309	601	5	0	30426	\N
9314	123	1	0	30435	\N
9314	124	2	0	30439	\N
9318	14	2	0	30452	\N
9318	383	3	0	30453	\N
9321	96	1	0	30455	\N
9321	97	2	0	30457	\N
9325	241	1	0	30488	\N
9325	333	2	0	30489	\N
9328	79	2	0	30381	\N
9328	80	3	0	30382	\N
9333	202	2	0	30532	\N
9333	812	3	0	30533	\N
9336	10	5	0	30555	\N
9336	998	6	0	30556	\N
9341	125	2	0	27382	\N
9341	188	3	0	29153	\N
9345	69	2	0	26275	\N
9345	500	3	0	26282	\N
9348	75	2	0	30437	\N
9348	159	3	0	30596	\N
9353	10	2	0	30623	\N
9353	29	3	0	30624	\N
9355	137	2	0	30635	\N
9355	197	3	0	30636	\N
9356	135	2	0	24975	\N
9356	196	3	0	27700	\N
9364	2	2	0	30650	\N
9364	131	3	0	30651	\N
9371	164	2	0	30675	\N
9371	226	3	0	30676	\N
9373	79	4	0	30381	\N
9373	2175	5	0	30686	\N
9066	966	0	0	29043	\N
9066	2009	0	0	29044	\N
9069	300	2	0	26969	\N
9069	706	3	0	26970	\N
9070	192	11	0	29082	\N
9070	2099	12	0	29083	\N
9073	44	2	0	29104	\N
9073	161	3	0	29105	\N
9076	1068	3	0	29124	\N
9076	852	8	0	29133	\N
9078	10	2	0	29141	\N
9078	29	3	0	29142	\N
9081	192	4	0	29150	\N
9081	941	5	0	29151	\N
9087	841	5	0	27212	\N
9087	2105	6	0	29173	\N
9088	54	1	0	26007	\N
9088	55	2	0	26616	\N
9090	10	11	0	29141	\N
9090	2107	12	0	29197	\N
9093	54	1	0	26007	\N
9093	55	2	0	26616	\N
9096	424	2	0	29206	\N
9096	520	3	0	29207	\N
9101	233	2	0	26685	\N
9101	910	3	0	29224	\N
9104	324	2	0	29227	\N
9104	486	3	0	29228	\N
9105	288	2	0	29233	\N
9105	289	3	0	29234	\N
9110	262	2	0	29247	\N
9110	731	3	0	29248	\N
9113	16	4	0	29264	\N
9113	380	5	0	29265	\N
9116	119	4	0	29283	\N
9116	423	5	0	29284	\N
9119	214	4	0	29288	\N
9119	649	5	0	29289	\N
9122	262	2	0	29296	\N
9122	731	3	0	29297	\N
9124	115	4	0	28991	\N
9124	1302	5	0	29306	\N
9127	115	2	0	29314	\N
9127	636	3	0	29315	\N
9129	10	4	0	29285	\N
9129	600	5	0	29286	\N
9131	2111	2	0	29330	\N
9131	2113	3	0	29334	\N
9134	75	2	0	28494	\N
9134	159	3	0	28657	\N
9141	214	2	0	29288	\N
9141	227	3	0	29378	\N
9144	14	7	0	29406	\N
9144	2119	8	0	29407	\N
9149	62	4	0	26657	\N
9149	1606	5	0	29431	\N
9152	228	2	0	29245	\N
9152	511	3	0	29246	\N
9154	82	2	0	28591	\N
9154	343	3	0	29447	\N
9156	373	2	0	29453	\N
9156	1504	3	0	29454	\N
9162	237	4	0	29496	\N
9162	1569	5	0	29497	\N
9167	241	2	0	28977	\N
9167	281	3	0	29514	\N
9172	92	3	0	29017	\N
9172	1578	4	0	29530	\N
9174	56	6	0	26935	\N
9174	2123	7	0	29550	\N
9179	1024	4	0	29569	\N
9179	844	7	0	29574	\N
9179	2124	7	0	29575	\N
9194	10	6	0	29658	\N
9194	426	7	0	29659	\N
9199	75	2	0	29353	\N
9199	159	3	0	29354	\N
9204	360	2	0	29715	\N
9204	510	3	0	29716	\N
9205	192	8	0	29150	\N
9205	985	9	0	29733	\N
9207	56	4	0	29743	\N
9207	2123	5	0	29744	\N
9210	16	3	0	29264	\N
9210	359	4	0	29761	\N
9213	260	4	0	29774	\N
9213	538	5	0	29775	\N
9215	40	6	0	29770	\N
9215	522	7	0	29790	\N
9220	10	2	0	29791	\N
9220	29	3	0	29811	\N
9224	10	2	0	29791	\N
9224	29	3	0	29811	\N
9227	102	1	0	27150	\N
9227	103	2	0	27151	\N
9231	251	1	0	29836	\N
9231	252	2	0	29837	\N
9233	2	2	0	29459	\N
9233	131	3	0	29460	\N
9236	10	2	0	29791	\N
9236	29	3	0	29811	\N
9241	189	2	0	29888	\N
9241	311	3	0	29889	\N
9246	230	10	0	29924	\N
9246	1240	11	0	29925	\N
9250	2143	6	0	30031	\N
9250	411	25	0	30068	\N
9250	2144	26	0	30069	\N
9255	121	7	0	28244	\N
9255	2150	8	0	30095	\N
9257	54	8	0	29198	\N
9257	2152	9	0	30113	\N
9259	18	8	0	29559	\N
9259	2153	9	0	30116	\N
9264	40	15	0	30187	\N
9264	1192	16	0	30188	\N
9268	23	9	0	30208	\N
9268	2155	10	0	30209	\N
9272	264	3	0	29776	\N
9272	1748	4	0	30240	\N
9276	793	2	0	30253	\N
9276	1136	3	0	30254	\N
9278	40	2	0	30265	\N
9278	66	3	0	30266	\N
9285	6	1	0	30285	\N
9285	194	2	0	30286	\N
9295	214	2	0	29793	\N
9295	227	3	0	30337	\N
9296	132	2	0	30342	\N
9296	133	3	0	30343	\N
9299	132	2	0	30356	\N
9299	133	3	0	30357	\N
9305	320	8	0	30403	\N
9305	2163	9	0	30404	\N
9310	79	3	0	30381	\N
9310	1168	4	0	30432	\N
9312	123	3	0	30435	\N
9312	2166	4	0	30436	\N
9316	12	4	0	30446	\N
9316	2168	5	0	30447	\N
9319	40	2	0	30444	\N
9319	66	3	0	30454	\N
9330	793	2	0	30253	\N
9332	220	2	0	30526	\N
9332	821	3	0	30527	\N
9338	266	2	0	30563	\N
9338	1711	3	0	30564	\N
9343	324	2	0	29227	\N
9343	486	3	0	29228	\N
9347	10	2	0	30594	\N
9347	29	3	0	30595	\N
9330	2170	3	0	138438	\N
9330	2171	3	1	138439	\N
9076	2101	9	1	138433	\N
9179	2126	8	1	138437	\N
9350	10	2	0	30613	\N
9350	29	3	0	30614	\N
9352	108	2	0	30621	\N
9352	501	3	0	30622	\N
9357	40	0	0	28623	\N
9361	40	0	0	28779	\N
9363	94	2	0	30644	\N
9363	95	3	0	30645	\N
9368	10	2	0	30623	\N
9368	29	3	0	30624	\N
9370	1109	2	0	27053	\N
9370	1412	3	0	30670	\N
9377	1	2	0	30619	\N
9377	112	3	0	30620	\N
9380	347	3	0	30711	\N
9380	10	5	0	30712	\N
9380	11	6	0	30713	\N
9382	40	1	0	30680	\N
9382	41	2	0	30719	\N
9386	256	2	0	30735	\N
9386	335	3	0	30736	\N
9389	10	4	0	30623	\N
9389	600	5	0	30713	\N
9392	210	4	0	30135	\N
9392	565	5	0	30774	\N
9394	435	4	0	30776	\N
9394	2180	5	0	30777	\N
9398	100	2	0	30809	\N
9398	101	3	0	30810	\N
9400	40	4	0	30680	\N
9400	564	5	0	30821	\N
9406	260	2	0	29774	\N
9406	419	3	0	30857	\N
9408	62	2	0	30868	\N
9408	683	3	0	30869	\N
9409	10	8	0	30886	\N
9409	1772	9	0	30887	\N
9412	90	2	0	30896	\N
9412	91	3	0	30897	\N
9421	290	0	0	30927	\N
9423	290	0	0	30927	\N
9427	2183	1	0	30961	\N
9427	2184	2	0	30962	\N
9429	2183	1	0	30961	\N
9429	2184	2	0	30962	\N
9432	230	2	0	30580	\N
9432	231	3	0	30581	\N
9435	260	2	0	30978	\N
9435	419	3	0	30979	\N
9442	10	2	0	31017	\N
9442	29	3	0	31018	\N
9447	241	2	0	30488	\N
9447	281	3	0	31038	\N
9453	167	5	0	31064	\N
9453	2040	6	0	31065	\N
9454	35	2	0	29225	\N
9454	36	3	0	29226	\N
9456	12	0	0	31070	\N
9461	10	2	0	31086	\N
9461	29	3	0	31087	\N
9465	192	3	0	31101	\N
9465	627	4	0	31102	\N
9472	260	3	0	31145	\N
9472	2197	4	0	31146	\N
9476	51	2	0	31171	\N
9476	524	3	0	31172	\N
9478	112	2	0	30923	\N
9478	1	5	0	31078	\N
9478	112	6	0	31183	\N
9483	170	2	0	31194	\N
9483	718	3	0	31195	\N
9488	40	2	0	31209	\N
9488	66	3	0	31229	\N
9494	206	5	0	28484	\N
9494	2204	6	0	31259	\N
9496	58	2	0	27954	\N
9496	665	3	0	29313	\N
9501	2	2	0	30650	\N
9501	131	3	0	30651	\N
9503	4	3	0	31289	\N
9503	2206	4	0	31290	\N
9506	597	3	0	26085	\N
9506	2209	4	0	31294	\N
9507	1	2	0	31291	\N
9507	112	3	0	31299	\N
9509	77	2	0	31306	\N
9509	216	3	0	31307	\N
9512	16	3	0	31317	\N
9512	359	4	0	31318	\N
9522	908	6	0	30335	\N
9522	2212	7	0	31359	\N
9523	16	6	0	31317	\N
9523	1902	7	0	31360	\N
9526	230	5	0	31384	\N
9526	2214	6	0	31385	\N
9531	402	5	0	30570	\N
9531	2215	6	0	31417	\N
9538	16	2	0	31439	\N
9538	445	3	0	31440	\N
9541	147	4	0	21351	\N
9541	551	5	0	31461	\N
9543	424	2	0	29206	\N
9543	520	3	0	29207	\N
9546	164	2	0	31478	\N
9546	226	3	0	31479	\N
9548	300	2	0	31493	\N
9548	706	3	0	31494	\N
9557	54	0	0	31504	\N
9560	75	2	0	31428	\N
9560	159	3	0	31429	\N
9570	206	9	0	31581	\N
9570	2220	10	0	31582	\N
9578	64	1	0	29006	\N
9578	65	2	0	31617	\N
9583	119	4	0	31647	\N
9583	423	5	0	31648	\N
9585	4	2	0	31289	\N
9585	579	3	0	31655	\N
9592	597	2	0	31462	\N
9592	767	3	0	31677	\N
9597	82	4	0	31703	\N
9597	2056	5	0	31704	\N
9605	82	6	0	31737	\N
9605	2222	7	0	31738	\N
9607	18	4	0	31749	\N
9607	590	5	0	31750	\N
9610	288	5	0	31768	\N
9610	2224	6	0	31769	\N
9612	206	2	0	31581	\N
9612	693	3	0	31774	\N
9614	1	2	0	31780	\N
9614	112	3	0	31781	\N
9617	220	2	0	31786	\N
9617	821	3	0	31787	\N
9620	44	9	0	31807	\N
9620	2226	10	0	31808	\N
9622	523	6	0	31823	\N
9622	1	7	0	31824	\N
9623	94	7	0	31838	\N
9623	2228	8	0	31839	\N
9628	262	2	0	31921	\N
9628	731	3	0	31922	\N
9632	86	1	0	31949	\N
9632	87	2	0	31950	\N
9635	49	4	0	31983	\N
9635	1595	5	0	31984	\N
9644	235	0	0	31987	\N
9646	10	2	0	32009	\N
9646	29	3	0	32010	\N
9649	40	3	0	32024	\N
9649	128	4	0	32025	\N
9651	793	2	0	32032	\N
9651	1136	3	0	32033	\N
9659	10	2	0	32086	\N
9659	29	3	0	32087	\N
9661	75	2	0	32094	\N
9661	159	3	0	32095	\N
9367	90	2	0	30660	\N
9367	91	3	0	30661	\N
9372	40	2	0	30680	\N
9372	282	3	0	30681	\N
9375	170	3	0	27197	\N
9375	1121	4	0	30694	\N
9379	118	3	0	30707	\N
9379	117	5	0	30710	\N
9379	248	6	0	29633	\N
9384	2177	43	0	30726	\N
9384	285	126	0	30727	\N
9384	2179	127	1	30728	\N
9384	2178	127	0	30729	\N
9391	268	4	0	28149	\N
9391	318	5	0	30765	\N
9397	1	2	0	30807	\N
9397	112	3	0	30808	\N
9399	300	2	0	30811	\N
9399	706	3	0	30812	\N
9402	435	4	0	30823	\N
9402	2180	5	0	30824	\N
9405	94	2	0	30652	\N
9405	95	3	0	30653	\N
9407	10	2	0	30862	\N
9407	29	3	0	30863	\N
9411	56	2	0	30894	\N
9411	169	3	0	30895	\N
9418	18	4	0	30925	\N
9418	590	5	0	30926	\N
9422	290	0	0	30927	\N
9431	1470	2	0	30976	\N
9431	1565	3	0	30977	\N
9434	58	2	0	27954	\N
9434	665	3	0	29313	\N
9437	192	3	0	29150	\N
9437	627	4	0	29152	\N
9439	322	2	0	30999	\N
9439	833	3	0	31000	\N
9444	14	4	0	31029	\N
9444	588	5	0	31030	\N
9449	316	2	0	31045	\N
9449	332	3	0	31046	\N
9452	40	5	0	30680	\N
9452	2192	6	0	31063	\N
9458	1	2	0	31077	\N
9458	112	3	0	31078	\N
9460	156	2	0	30401	\N
9460	571	3	0	31085	\N
9463	1109	2	0	31090	\N
9463	1412	3	0	31094	\N
9468	123	27	0	31117	\N
9468	2194	28	0	31119	\N
9471	852	2	0	31142	\N
9471	2196	3	0	31144	\N
9475	20	4	0	31165	\N
9475	685	5	0	31166	\N
9481	147	2	0	21351	\N
9481	516	3	0	21470	\N
9482	10	2	0	31192	\N
9482	29	3	0	31193	\N
9485	10	7	0	31211	\N
9485	2202	8	0	31212	\N
9493	58	5	0	27954	\N
9493	2203	6	0	31258	\N
9495	40	2	0	31264	\N
9495	66	3	0	31265	\N
9498	18	2	0	30925	\N
9498	218	3	0	31072	\N
9500	40	2	0	31264	\N
9500	66	3	0	31265	\N
9502	595	3	0	31287	\N
9502	2205	4	0	31288	\N
9514	353	2	0	30424	\N
9514	755	3	0	31325	\N
9516	10	2	0	31330	\N
9516	29	3	0	31331	\N
9521	44	6	0	31357	\N
9521	2211	7	0	31358	\N
9528	411	0	0	31392	\N
9533	1	2	0	31424	\N
9533	112	3	0	31425	\N
9540	595	4	0	31287	\N
9540	1530	5	0	31460	\N
9545	268	2	0	31476	\N
9545	1387	3	0	31477	\N
9550	164	2	0	31501	\N
9550	226	3	0	31502	\N
9552	54	0	0	31504	\N
9556	54	0	0	31504	\N
9559	264	4	0	31527	\N
9559	2137	5	0	31528	\N
9562	391	4	0	30433	\N
9562	539	5	0	29582	\N
9565	20	3	0	31555	\N
9565	1931	4	0	31556	\N
9567	908	2	0	30335	\N
9567	988	3	0	30336	\N
9572	40	2	0	31594	\N
9572	66	3	0	31595	\N
9575	262	2	0	29296	\N
9575	731	3	0	29297	\N
9577	64	2	0	29006	\N
9577	162	3	0	31616	\N
9580	18	3	0	31626	\N
9580	127	4	0	31627	\N
9582	198	2	0	31638	\N
9582	746	3	0	31639	\N
9587	56	2	0	30894	\N
9587	169	3	0	30895	\N
9596	23	2	0	31693	\N
9596	24	3	0	31694	\N
9599	140	3	0	31712	\N
9599	404	4	0	31713	\N
9601	16	3	0	31439	\N
9601	359	4	0	31715	\N
9604	40	6	0	31594	\N
9604	2221	7	0	31736	\N
9609	353	5	0	30424	\N
9609	2223	6	0	31767	\N
9616	73	2	0	29820	\N
9616	703	3	0	29821	\N
9618	16	1	0	31788	\N
9618	17	2	0	31789	\N
9619	156	9	0	30401	\N
9619	2225	10	0	31806	\N
9625	222	2	0	31355	\N
9625	232	3	0	31852	\N
9631	75	3	0	31663	\N
9631	857	4	0	31946	\N
9639	285	2	0	31994	\N
9639	1276	3	0	31995	\N
9642	82	2	0	31737	\N
9642	343	3	0	31998	\N
9647	56	2	0	32015	\N
9647	169	3	0	32016	\N
9652	12	2	0	31436	\N
9652	433	3	0	32038	\N
9654	10	3	0	32047	\N
9654	347	4	0	32048	\N
9657	10	6	0	32078	\N
9657	426	7	0	32079	\N
9660	18	2	0	32088	\N
9660	218	3	0	32089	\N
9662	402	3	0	30570	\N
9662	1328	4	0	32102	\N
9669	391	2	0	32121	\N
9669	406	3	0	32122	\N
9676	16	3	0	32158	\N
9676	359	4	0	32159	\N
9679	60	4	0	32169	\N
9679	1687	5	0	32170	\N
9687	40	2	0	32192	\N
9687	66	3	0	32193	\N
9691	167	10	0	31064	\N
9691	1444	11	0	32236	\N
9693	10	1	0	32143	\N
9693	11	2	0	32241	\N
9376	714	3	0	30695	\N
9376	2176	4	0	30696	\N
9378	73	2	0	29820	\N
9378	703	3	0	29821	\N
9387	316	2	0	30741	\N
9387	332	3	0	30742	\N
9393	2	4	0	30650	\N
9393	315	5	0	30775	\N
9395	1	4	0	30786	\N
9395	422	5	0	30787	\N
9413	244	2	0	30898	\N
9413	438	3	0	30899	\N
9414	75	2	0	30437	\N
9414	159	3	0	30596	\N
9419	290	0	0	30927	\N
9424	112	2	0	30937	\N
9424	1	3	0	30938	\N
9425	10	4	0	30947	\N
9425	600	5	0	30948	\N
9436	192	2	0	29150	\N
9436	838	3	0	30980	\N
9440	224	2	0	31001	\N
9440	508	3	0	31002	\N
9443	451	2	0	31019	\N
9443	452	3	0	31020	\N
9445	260	4	0	30978	\N
9445	538	5	0	31031	\N
9450	62	2	0	31051	\N
9450	2191	3	0	31052	\N
9457	18	2	0	30925	\N
9457	218	3	0	31072	\N
9459	16	2	0	31079	\N
9459	155	3	0	31080	\N
9466	10	4	0	31111	\N
9466	600	5	0	31112	\N
9469	40	7	0	31134	\N
9469	2173	8	0	31135	\N
9477	10	2	0	31173	\N
9477	29	3	0	31174	\N
9479	595	2	0	27276	\N
9479	768	3	0	28059	\N
9484	40	7	0	31209	\N
9484	2201	8	0	31210	\N
9486	108	2	0	31217	\N
9486	501	3	0	31218	\N
9489	362	2	0	31234	\N
9489	420	3	0	31235	\N
9491	132	2	0	30356	\N
9491	133	3	0	30357	\N
9497	10	2	0	31266	\N
9497	29	3	0	31267	\N
9504	1	3	0	31291	\N
9504	2207	4	0	31292	\N
9510	77	3	0	31314	\N
9510	1043	4	0	31315	\N
9517	121	2	0	30114	\N
9517	625	3	0	31336	\N
9519	322	2	0	31341	\N
9519	833	3	0	31342	\N
9524	181	5	0	31370	\N
9524	2213	6	0	31371	\N
9529	40	5	0	31403	\N
9529	1196	6	0	31404	\N
9534	264	2	0	31426	\N
9534	265	3	0	31427	\N
9536	12	3	0	31436	\N
9536	2217	4	0	31437	\N
9542	597	4	0	31462	\N
9542	1531	5	0	31463	\N
9549	411	2	0	31499	\N
9549	582	3	0	31500	\N
9551	164	1	0	31501	\N
9551	165	2	0	31503	\N
9553	151	1	0	31507	\N
9553	302	2	0	31508	\N
9555	54	1	0	31504	\N
9555	55	2	0	31509	\N
9563	10	4	0	31545	\N
9563	600	5	0	31546	\N
9568	18	2	0	30925	\N
9568	218	3	0	31072	\N
9571	10	3	0	31545	\N
9571	465	4	0	31589	\N
9573	10	2	0	31596	\N
9573	29	3	0	31597	\N
9576	18	2	0	30925	\N
9576	218	3	0	31072	\N
9584	1	4	0	31649	\N
9584	422	5	0	31650	\N
9586	62	2	0	31656	\N
9586	683	3	0	31657	\N
9588	18	2	0	31626	\N
9588	218	3	0	31662	\N
9590	10	2	0	31669	\N
9590	29	3	0	31670	\N
9593	595	2	0	31678	\N
9593	768	3	0	31679	\N
9595	285	4	0	29390	\N
9595	1709	5	0	31688	\N
9600	90	3	0	30896	\N
9600	877	4	0	31714	\N
9602	149	2	0	31671	\N
9602	697	3	0	31672	\N
9608	94	4	0	30652	\N
9608	1706	5	0	31759	\N
9615	137	2	0	30635	\N
9615	197	3	0	30636	\N
9621	1109	9	0	31809	\N
9621	2227	10	0	31810	\N
9626	40	31	0	31747	\N
9626	2229	32	0	31914	\N
9629	56	7	0	30894	\N
9629	2230	8	0	31937	\N
9634	1021	10	0	31973	\N
9634	2232	11	0	31974	\N
9637	235	4	0	31987	\N
9637	2233	5	0	31988	\N
9640	235	2	0	31987	\N
9640	1061	3	0	31996	\N
9643	164	2	0	31501	\N
9643	226	3	0	31502	\N
9645	336	2	0	32003	\N
9645	740	3	0	32004	\N
9648	96	3	0	30455	\N
9648	834	4	0	32023	\N
9650	2	2	0	32030	\N
9650	131	3	0	32031	\N
9653	230	2	0	32039	\N
9653	231	3	0	32040	\N
9655	833	2	0	32053	\N
9655	322	4	0	32056	\N
9655	323	5	0	32057	\N
9658	1	2	0	32084	\N
9658	112	3	0	32085	\N
9663	391	3	0	32103	\N
9663	581	4	0	32104	\N
9665	264	4	0	32115	\N
9665	2137	5	0	32116	\N
9667	10	2	0	32086	\N
9667	29	3	0	32087	\N
9670	488	2	0	29830	\N
9670	729	3	0	30271	\N
9672	391	5	0	32121	\N
9672	2235	6	0	32142	\N
9674	75	5	0	32145	\N
9674	1705	6	0	32146	\N
9677	119	4	0	31647	\N
9677	423	5	0	31648	\N
9681	1109	4	0	31809	\N
9681	1389	5	0	32172	\N
9683	224	2	0	31001	\N
9683	508	3	0	31002	\N
9685	10	2	0	32143	\N
9685	29	3	0	32186	\N
9688	140	5	0	31712	\N
9688	889	6	0	32204	\N
9696	320	23	0	32251	\N
9383	1	2	0	30722	\N
9383	112	3	0	30723	\N
9385	173	2	0	29158	\N
9385	480	3	0	30734	\N
9388	173	2	0	29158	\N
9388	480	3	0	30734	\N
9390	264	3	0	29776	\N
9390	1748	4	0	30240	\N
9396	244	7	0	28033	\N
9396	2181	8	0	30802	\N
9401	1	4	0	30807	\N
9401	422	5	0	30822	\N
9403	23	2	0	30829	\N
9403	24	3	0	30830	\N
9404	18	10	0	30851	\N
9404	2182	11	0	30852	\N
9410	841	2	0	30892	\N
9410	1161	3	0	30893	\N
9415	1	4	0	30912	\N
9415	422	5	0	30913	\N
9416	1	4	0	30922	\N
9416	422	5	0	30923	\N
9417	14	4	0	30452	\N
9417	588	5	0	30924	\N
9420	290	2	0	30927	\N
9420	575	3	0	30932	\N
9426	316	4	0	30957	\N
9426	1024	5	0	30958	\N
9428	2185	2	0	30965	\N
9428	2186	3	0	30966	\N
9430	2183	4	0	30961	\N
9430	2187	5	0	30971	\N
9433	94	2	0	30652	\N
9433	95	3	0	30653	\N
9438	2188	20	0	30990	\N
9438	2189	26	0	30993	\N
9438	2190	27	0	30994	\N
9441	16	4	0	31011	\N
9441	380	5	0	31012	\N
9446	528	2	0	31036	\N
9446	613	3	0	31037	\N
9448	108	2	0	31043	\N
9448	501	3	0	31044	\N
9451	402	5	0	30570	\N
9451	2129	6	0	31062	\N
9455	12	2	0	31070	\N
9455	433	3	0	31071	\N
9462	1109	1	0	31090	\N
9462	1111	2	0	31091	\N
9464	192	2	0	31095	\N
9464	2193	3	0	31096	\N
9467	123	2	0	31117	\N
9467	384	3	0	31118	\N
9470	852	3	0	31142	\N
9470	2195	4	0	31143	\N
9473	2198	67	0	31149	\N
9473	30	126	0	31150	\N
9473	2199	127	0	31151	\N
9474	279	3	0	29620	\N
9474	2200	4	0	31156	\N
9480	597	2	0	26085	\N
9480	767	3	0	28064	\N
9487	16	2	0	31223	\N
9487	155	3	0	31224	\N
9490	260	2	0	31145	\N
9490	419	3	0	31236	\N
9492	1	3	0	31247	\N
9492	711	4	0	31248	\N
9499	1	4	0	31276	\N
9499	422	5	0	31277	\N
9505	147	3	0	21351	\N
9505	2208	4	0	31293	\N
9508	16	2	0	31300	\N
9508	155	3	0	31301	\N
9511	10	3	0	31266	\N
9511	347	4	0	31316	\N
9513	79	2	0	31323	\N
9513	80	3	0	31324	\N
9515	1470	2	0	30976	\N
9515	1565	3	0	30977	\N
9518	1	2	0	31291	\N
9518	112	3	0	31299	\N
9520	222	6	0	31355	\N
9520	2210	7	0	31356	\N
9525	1	5	0	31372	\N
9525	2052	6	0	31373	\N
9527	40	2	0	31390	\N
9527	66	3	0	31391	\N
9530	322	5	0	31405	\N
9530	1170	6	0	31406	\N
9532	58	5	0	31418	\N
9532	2216	6	0	31419	\N
9535	75	2	0	31428	\N
9535	159	3	0	31429	\N
9537	10	3	0	31330	\N
9537	465	4	0	31438	\N
9539	40	5	0	31403	\N
9539	2218	6	0	31451	\N
9544	102	2	0	27150	\N
9544	158	3	0	27350	\N
9547	164	4	0	31478	\N
9547	1582	5	0	31488	\N
9554	54	0	0	31504	\N
9558	1	4	0	31424	\N
9558	422	5	0	31518	\N
9561	2	2	0	30650	\N
9561	131	3	0	30651	\N
9564	79	3	0	31553	\N
9564	1168	4	0	31554	\N
9566	362	2	0	31234	\N
9566	420	3	0	31235	\N
9569	108	9	0	31579	\N
9569	2219	10	0	31580	\N
9574	2	2	0	31602	\N
9574	131	3	0	31603	\N
9579	10	3	0	31624	\N
9579	347	4	0	31625	\N
9581	336	2	0	31632	\N
9581	740	3	0	31633	\N
9589	75	2	0	31663	\N
9589	159	3	0	31664	\N
9591	149	2	0	31671	\N
9591	697	3	0	31672	\N
9594	147	2	0	21351	\N
9594	516	3	0	21470	\N
9598	16	4	0	31439	\N
9598	380	5	0	31705	\N
9603	1	2	0	31724	\N
9603	112	3	0	31725	\N
9606	40	4	0	31747	\N
9606	564	5	0	31748	\N
9611	402	2	0	30570	\N
9611	1148	3	0	30571	\N
9613	16	2	0	31439	\N
9613	155	3	0	31775	\N
9624	391	3	0	31846	\N
9624	503	4	0	31847	\N
9627	841	2	0	31919	\N
9627	1161	3	0	31920	\N
9630	449	7	0	31938	\N
9630	2231	8	0	31939	\N
9633	326	1	0	31951	\N
9633	327	2	0	31952	\N
9636	1021	4	0	31985	\N
9636	1047	5	0	31986	\N
9638	54	2	0	31504	\N
9638	485	3	0	31993	\N
9641	79	2	0	31553	\N
9641	80	3	0	31997	\N
9656	58	3	0	32064	\N
9656	2234	4	0	32065	\N
9664	44	3	0	32105	\N
9664	940	4	0	32106	\N
9666	391	2	0	32121	\N
9666	406	3	0	32122	\N
9671	424	2	0	32131	\N
9671	520	3	0	32132	\N
9668	266	2	0	30563	\N
9668	1711	3	0	30564	\N
9673	10	5	0	32143	\N
9673	2042	6	0	32144	\N
9675	793	5	0	32032	\N
9675	2236	6	0	32157	\N
9678	181	6	0	31370	\N
9678	2237	7	0	32168	\N
9680	1109	6	0	31809	\N
9680	2238	7	0	32171	\N
9684	115	2	0	32184	\N
9684	636	3	0	32185	\N
9694	40	3	0	32248	\N
9694	128	4	0	32249	\N
9700	10	3	0	32272	\N
9700	465	4	0	32273	\N
9703	40	6	0	32248	\N
9703	522	7	0	32297	\N
9712	156	1	0	30401	\N
9712	157	2	0	32318	\N
9723	2254	40	0	32379	\N
9723	2255	43	0	32382	\N
9723	2256	43	0	32383	\N
9723	2258	44	1	32384	\N
9723	2257	44	0	32385	\N
9723	2260	45	1	32386	\N
9723	2259	45	0	32387	\N
9723	2261	46	0	32388	\N
9729	264	13	0	32437	\N
9729	2267	14	0	32438	\N
9730	170	2	0	31194	\N
9730	718	3	0	31195	\N
9733	20	13	0	32469	\N
9733	2268	14	0	32470	\N
9738	132	7	0	32496	\N
9738	2271	8	0	32497	\N
9740	12	7	0	31436	\N
9740	2273	8	0	32513	\N
9747	67	3	0	32540	\N
9747	1489	4	0	32541	\N
9752	102	3	0	32570	\N
9752	608	4	0	32571	\N
9754	10	2	0	32578	\N
9754	29	3	0	32579	\N
9759	16	2	0	32158	\N
9759	155	3	0	32187	\N
9761	228	3	0	32615	\N
9761	492	4	0	32616	\N
9767	595	11	0	31678	\N
9767	2279	12	0	32662	\N
9769	16	11	0	32665	\N
9769	2281	12	0	32666	\N
9771	102	2	0	32676	\N
9771	158	3	0	32677	\N
9778	251	4	0	32551	\N
9778	1610	5	0	32705	\N
9781	198	3	0	32722	\N
9781	1347	4	0	32723	\N
9783	40	4	0	32734	\N
9783	564	5	0	32735	\N
9786	10	4	0	32601	\N
9786	600	5	0	32758	\N
9791	10	3	0	32818	\N
9791	347	4	0	32819	\N
9794	173	4	0	29158	\N
9794	1046	5	0	32834	\N
9797	391	3	0	32121	\N
9797	581	4	0	32849	\N
9799	16	11	0	32665	\N
9799	2289	12	0	32871	\N
9801	202	2	0	32878	\N
9801	812	3	0	32879	\N
9810	123	9	0	32916	\N
9810	2294	10	0	32917	\N
9813	391	6	0	32121	\N
9813	2297	7	0	32934	\N
9815	1	6	0	32880	\N
9815	2252	7	0	32937	\N
9817	23	12	0	32958	\N
9817	350	13	0	32959	\N
9820	132	12	0	32964	\N
9820	814	13	0	32965	\N
9821	2299	9	0	32977	\N
9821	528	10	0	32978	\N
9824	2303	107	0	33016	\N
9824	528	116	0	33018	\N
9824	2304	117	0	33019	\N
9826	40	26	0	32932	\N
9826	2306	27	0	33049	\N
9827	79	8	0	33065	\N
9827	2307	9	0	33066	\N
9829	2308	75	0	33074	\N
9829	324	76	0	33075	\N
9832	110	2	0	33102	\N
9832	111	3	0	33103	\N
9836	260	2	0	33141	\N
9836	419	3	0	33142	\N
9841	235	2	0	33156	\N
9841	1061	3	0	33157	\N
9843	1	2	0	33164	\N
9843	112	3	0	33165	\N
9846	110	5	0	33184	\N
9846	1039	6	0	33185	\N
9848	56	1	0	33191	\N
9848	57	2	0	33192	\N
9851	2	4	0	32935	\N
9851	315	5	0	33208	\N
9856	117	7	0	33236	\N
9856	2313	8	0	33237	\N
9869	135	4	0	33301	\N
9869	2315	5	0	33302	\N
9871	142	2	0	33311	\N
9871	656	3	0	33312	\N
9874	77	2	0	33297	\N
9874	216	3	0	33319	\N
9879	1	2	0	33344	\N
9879	112	3	0	33345	\N
9882	10	2	0	33348	\N
9882	29	3	0	33349	\N
9884	210	0	0	32962	\N
9886	793	2	0	33355	\N
9886	1136	3	0	33356	\N
9890	2	2	0	33363	\N
9890	131	3	0	33364	\N
9682	1	3	0	32084	\N
9682	48	4	0	32179	\N
9686	16	2	0	32158	\N
9686	155	3	0	32187	\N
9689	96	5	0	30455	\N
9689	2239	6	0	32215	\N
9690	181	10	0	31370	\N
9690	969	11	0	32235	\N
9692	94	1	0	32239	\N
9692	107	2	0	32240	\N
9701	2243	8	0	32280	\N
9701	2244	9	0	32281	\N
9701	2245	9	0	32282	\N
9706	56	4	0	32304	\N
9706	1145	5	0	32305	\N
9708	316	3	0	31045	\N
9708	555	4	0	32313	\N
9710	156	1	0	30401	\N
9710	157	2	0	32318	\N
9717	285	6	0	31994	\N
9717	2251	7	0	32348	\N
9719	64	5	0	32353	\N
9719	2096	6	0	32354	\N
9721	391	4	0	32121	\N
9721	614	5	0	32364	\N
9734	488	13	0	29830	\N
9734	2269	14	0	32471	\N
9741	10	7	0	32472	\N
9741	2274	8	0	32514	\N
9745	10	5	0	32532	\N
9745	2042	6	0	32533	\N
9750	64	4	0	32561	\N
9750	490	5	0	32562	\N
9755	288	2	0	31768	\N
9755	289	3	0	32584	\N
9757	1	2	0	32599	\N
9757	112	3	0	32600	\N
9762	288	7	0	32631	\N
9762	2276	8	0	32632	\N
9765	411	11	0	32659	\N
9765	2277	12	0	32660	\N
9772	142	2	0	32682	\N
9772	656	3	0	32683	\N
9774	2282	0	0	32684	\N
9774	2283	0	0	32685	\N
9776	192	2	0	32690	\N
9776	838	3	0	32691	\N
9789	266	8	0	32792	\N
9789	2288	9	0	32793	\N
9792	235	2	0	31987	\N
9792	1061	3	0	31996	\N
9802	1	1	0	32880	\N
9802	53	2	0	32881	\N
9804	79	2	0	32885	\N
9804	80	3	0	32886	\N
9806	230	3	0	32892	\N
9806	2290	4	0	32893	\N
9809	202	4	0	32903	\N
9809	2293	5	0	32904	\N
9811	75	9	0	32918	\N
9811	2295	10	0	32919	\N
9818	10	12	0	32960	\N
9818	347	13	0	32961	\N
9822	2300	9	0	32979	\N
9822	10	11	0	32981	\N
9822	1416	12	0	32982	\N
9828	79	1	0	33065	\N
9828	1434	2	0	33067	\N
9830	324	9	0	33080	\N
9830	2309	10	0	33081	\N
9833	110	3	0	33102	\N
9833	905	4	0	33106	\N
9834	4	13	0	31289	\N
9834	2311	14	0	33131	\N
9837	18	2	0	32850	\N
9837	218	3	0	33143	\N
9839	1021	2	0	33150	\N
9839	1048	3	0	33151	\N
9849	435	1	0	30823	\N
9849	436	2	0	33193	\N
9854	86	1	0	33219	\N
9854	87	2	0	33220	\N
9857	242	2	0	33242	\N
9857	620	3	0	33243	\N
9860	10	2	0	33273	\N
9860	29	3	0	33274	\N
9863	266	2	0	33280	\N
9863	1711	3	0	33281	\N
9867	77	4	0	33297	\N
9867	1132	5	0	33298	\N
9872	86	2	0	33313	\N
9872	509	3	0	33314	\N
9877	210	0	0	30135	\N
9883	210	0	0	33350	\N
9888	33	2	0	33361	\N
9888	34	3	0	33362	\N
9695	10	3	0	32143	\N
9695	347	4	0	32250	\N
9697	14	3	0	31029	\N
9697	1863	4	0	32258	\N
9699	110	8	0	32263	\N
9699	2242	9	0	32271	\N
9702	262	4	0	32291	\N
9702	1015	5	0	32292	\N
9704	77	4	0	31314	\N
9704	1132	5	0	32302	\N
9707	77	2	0	31314	\N
9707	216	3	0	32306	\N
9711	316	1	0	32319	\N
9711	317	2	0	32320	\N
9713	402	4	0	30570	\N
9713	1378	5	0	32329	\N
9715	2249	126	0	32333	\N
9715	2250	127	0	32334	\N
9724	40	9	0	32248	\N
9724	2262	10	0	32404	\N
9726	192	9	0	32406	\N
9726	2264	10	0	32407	\N
9727	1	13	0	32351	\N
9727	2265	14	0	32434	\N
9731	1	2	0	32351	\N
9731	112	3	0	32443	\N
9735	10	13	0	32472	\N
9735	1881	14	0	32473	\N
9736	79	3	0	31553	\N
9736	272	4	0	32480	\N
9739	12	4	0	31436	\N
9739	2272	5	0	32498	\N
9743	300	2	0	32519	\N
9743	706	3	0	32520	\N
9746	40	3	0	32248	\N
9746	128	4	0	32249	\N
9748	384	2	0	32546	\N
9748	123	4	0	32549	\N
9748	2275	5	0	32550	\N
9753	322	2	0	32576	\N
9753	833	3	0	32577	\N
9758	10	2	0	32601	\N
9758	29	3	0	32602	\N
9760	23	2	0	32607	\N
9760	24	3	0	32608	\N
9763	2	3	0	32638	\N
9763	572	4	0	32639	\N
9766	597	11	0	31462	\N
9766	2278	12	0	32661	\N
9770	40	2	0	32248	\N
9770	66	3	0	32671	\N
9773	10	2	0	32601	\N
9773	29	3	0	32602	\N
9777	1	6	0	32599	\N
9777	523	7	0	32704	\N
9779	73	4	0	29820	\N
9779	2284	5	0	32714	\N
9782	336	4	0	32732	\N
9782	2285	5	0	32733	\N
9784	453	2	0	32740	\N
9784	902	3	0	32741	\N
9787	2286	3	0	32765	\N
9787	1914	8	0	32774	\N
9787	2287	9	0	32775	\N
9788	2286	3	0	32765	\N
9788	1914	8	0	32774	\N
9788	2287	9	0	32775	\N
9790	10	8	0	32810	\N
9790	1772	9	0	32811	\N
9793	268	2	0	32824	\N
9793	1387	3	0	32825	\N
9795	288	2	0	32839	\N
9795	289	3	0	32840	\N
9800	140	2	0	32876	\N
9800	487	3	0	32877	\N
9803	202	1	0	32878	\N
9803	203	2	0	32882	\N
9807	14	4	0	31029	\N
9807	2291	5	0	32900	\N
9819	210	12	0	32962	\N
9819	655	13	0	32963	\N
9825	75	1	0	32918	\N
9831	75	7	0	33096	\N
9831	2310	8	0	33097	\N
9835	10	2	0	32960	\N
9835	29	3	0	33136	\N
9844	262	2	0	33166	\N
9844	731	3	0	33167	\N
9847	110	6	0	33184	\N
9847	736	7	0	33188	\N
9852	268	3	0	32824	\N
9852	610	4	0	33215	\N
9855	1	0	0	33221	\N
9858	40	7	0	33258	\N
9858	2314	8	0	33259	\N
9861	49	2	0	31983	\N
9861	328	3	0	33279	\N
9864	2	2	0	33282	\N
9864	131	3	0	33283	\N
9865	27	1	0	29419	\N
9865	28	2	0	33286	\N
9870	391	2	0	32121	\N
9870	406	3	0	32122	\N
9880	210	0	0	30135	\N
9889	100	2	0	30809	\N
9889	101	3	0	30810	\N
9825	1395	2	1	138440	\N
9825	2305	2	0	138441	\N
9696	2240	24	0	32252	\N
9698	110	5	0	32263	\N
9698	2241	6	0	32264	\N
9705	51	4	0	31171	\N
9705	648	5	0	32303	\N
9709	2246	3	0	32314	\N
9709	2247	4	0	32315	\N
9714	42	4	0	32330	\N
9714	2139	5	0	32331	\N
9716	16	4	0	32158	\N
9716	380	5	0	32335	\N
9718	1	6	0	32351	\N
9718	2252	7	0	32352	\N
9720	64	6	0	32353	\N
9720	2253	7	0	32355	\N
9722	2	4	0	32365	\N
9722	935	5	0	32366	\N
9725	1	9	0	32351	\N
9725	2263	10	0	32405	\N
9728	273	13	0	32435	\N
9728	2266	14	0	32436	\N
9732	170	2	0	31194	\N
9732	718	3	0	31195	\N
9737	362	7	0	31234	\N
9737	2270	8	0	32495	\N
9742	12	4	0	31436	\N
9742	2272	5	0	32498	\N
9744	40	5	0	32248	\N
9744	2192	6	0	32531	\N
9749	251	1	0	32551	\N
9749	252	2	0	32552	\N
9751	14	3	0	31029	\N
9751	1786	4	0	32569	\N
9756	1	4	0	32593	\N
9756	2093	5	0	32594	\N
9764	228	3	0	32640	\N
9764	492	4	0	32641	\N
9768	147	11	0	32663	\N
9768	2280	12	0	32664	\N
9775	4	2	0	31289	\N
9775	579	3	0	31655	\N
9780	119	3	0	31647	\N
9780	129	4	0	32721	\N
9785	230	3	0	32748	\N
9785	876	4	0	32749	\N
9796	40	3	0	32847	\N
9796	128	4	0	32848	\N
9798	18	3	0	32850	\N
9798	127	4	0	32851	\N
9805	79	2	0	32885	\N
9805	80	3	0	32886	\N
9808	20	4	0	32901	\N
9808	2292	5	0	32902	\N
9812	40	6	0	32932	\N
9812	2296	7	0	32933	\N
9814	2	6	0	32935	\N
9814	2298	7	0	32936	\N
9816	79	2	0	32942	\N
9816	80	3	0	32943	\N
9823	2301	9	0	32983	\N
9823	18	23	0	32996	\N
9823	2302	24	0	32997	\N
9838	1952	2	0	33148	\N
9838	2312	3	0	33149	\N
9840	156	2	0	30401	\N
9840	571	3	0	31085	\N
9842	793	2	0	33158	\N
9842	1136	3	0	33159	\N
9845	16	2	0	33172	\N
9845	155	3	0	33173	\N
9850	92	2	0	33198	\N
9850	93	3	0	33199	\N
9853	290	3	0	1060	\N
9853	364	4	0	33216	\N
9859	793	4	0	33158	\N
9859	1986	5	0	33268	\N
9862	54	2	0	31504	\N
9862	485	3	0	31993	\N
9866	10	1	0	33287	\N
9866	11	2	0	33288	\N
9868	137	4	0	33299	\N
9868	1752	5	0	33300	\N
9873	140	2	0	32876	\N
9873	487	3	0	32877	\N
9875	10	2	0	33324	\N
9875	29	3	0	33325	\N
9876	10	5	0	33336	\N
9876	998	6	0	33337	\N
9878	391	2	0	33342	\N
9878	406	3	0	33343	\N
9881	210	2	0	33346	\N
9881	458	3	0	33347	\N
9885	1	2	0	33344	\N
9885	112	3	0	33345	\N
9887	793	2	0	33355	\N
9887	1136	3	0	33356	\N
9891	1914	4	0	33373	\N
9891	2287	5	0	33374	\N
9892	40	1	0	33377	\N
9892	41	2	0	33378	\N
9893	2	1	0	33379	\N
9893	26	2	0	33380	\N
9894	16	5	0	33381	\N
9894	707	6	0	33382	\N
9895	79	4	0	33391	\N
9895	589	5	0	33392	\N
9896	40	2	0	33397	\N
9896	66	3	0	33398	\N
9897	230	2	0	33399	\N
9897	231	3	0	33400	\N
9898	40	2	0	33405	\N
9898	66	3	0	33406	\N
9899	10	2	0	33411	\N
9899	29	3	0	33412	\N
9900	67	2	0	33413	\N
9900	68	3	0	33414	\N
9901	1	2	0	33419	\N
9901	112	3	0	33420	\N
9902	1	2	0	33425	\N
9902	112	3	0	33426	\N
9903	449	2	0	31938	\N
9903	583	3	0	33431	\N
9904	151	2	0	33436	\N
9904	576	3	0	33437	\N
9905	151	4	0	33436	\N
9905	1510	5	0	33438	\N
9906	145	2	0	33443	\N
9906	331	3	0	33444	\N
9907	365	0	0	33445	\N
9908	62	0	0	33446	\N
9909	1	8	0	33463	\N
9909	1982	9	0	33464	\N
9910	256	2	0	33469	\N
9910	335	3	0	33470	\N
9911	145	4	0	33479	\N
9911	2316	5	0	33480	\N
9912	10	4	0	33411	\N
9912	600	5	0	33481	\N
9913	10	1	0	33411	\N
9913	11	2	0	33484	\N
9914	145	2	0	33489	\N
9914	331	3	0	33490	\N
9915	62	4	0	33446	\N
9915	1606	5	0	33499	\N
9916	16	2	0	33381	\N
9916	155	3	0	33504	\N
9917	121	3	0	30114	\N
9917	2317	4	0	33511	\N
9918	488	3	0	33512	\N
9918	2318	4	0	33513	\N
9919	841	7	0	31919	\N
9919	2319	8	0	33528	\N
9920	212	2	0	33533	\N
9920	566	3	0	33534	\N
9921	170	2	0	31194	\N
9921	718	3	0	31195	\N
9922	170	1	0	31194	\N
9922	398	2	0	33539	\N
9929	62	0	0	33570	\N
9932	27	2	0	29419	\N
9932	619	3	0	33584	\N
9937	60	7	0	33618	\N
9937	2323	8	0	33619	\N
9939	322	2	0	32576	\N
9939	833	3	0	32577	\N
9943	242	3	0	33636	\N
9943	1135	4	0	33637	\N
9950	244	2	0	33688	\N
9950	438	3	0	33689	\N
9952	51	1	0	33698	\N
9952	52	2	0	33699	\N
9957	1	0	0	31424	\N
9959	1	0	0	31724	\N
9961	18	1	0	33720	\N
9961	19	2	0	33721	\N
9966	149	7	0	33746	\N
9966	2334	8	0	33747	\N
9970	326	4	0	31951	\N
9970	1638	5	0	33769	\N
9975	1	3	0	33626	\N
9975	48	4	0	33777	\N
9979	279	2	0	33795	\N
9979	280	3	0	33796	\N
9984	214	5	0	33825	\N
9984	2338	6	0	33826	\N
9987	79	6	0	33856	\N
9987	2340	7	0	33857	\N
9991	235	2	0	33156	\N
9991	1061	3	0	33157	\N
9994	198	2	0	33894	\N
9994	746	3	0	33895	\N
9998	2345	22	0	33900	\N
9998	320	126	0	33904	\N
9998	2346	127	0	33905	\N
10003	391	2	0	33342	\N
10003	406	3	0	33343	\N
10006	2020	6	0	33938	\N
10006	206	17	0	33959	\N
10006	207	18	0	33960	\N
10008	62	2	0	33968	\N
10008	683	3	0	33969	\N
10011	10	3	0	33982	\N
10011	347	4	0	33983	\N
10021	75	4	0	34074	\N
10021	2357	5	0	34075	\N
10024	1	3	0	34100	\N
10024	48	4	0	34110	\N
10030	49	2	0	31983	\N
10030	328	3	0	33279	\N
10040	1	4	0	34218	\N
10040	422	5	0	34219	\N
10043	10	2	0	34228	\N
10043	29	3	0	34229	\N
10047	1	2	0	34258	\N
10047	112	3	0	34259	\N
10049	10	2	0	34228	\N
10049	29	3	0	34229	\N
10053	123	1	0	34278	\N
10053	124	2	0	34279	\N
10056	40	3	0	34297	\N
10056	128	4	0	34298	\N
10058	202	2	0	34304	\N
10058	812	3	0	34305	\N
10070	16	10	0	34393	\N
10070	1436	11	0	34394	\N
10074	2377	0	0	34469	\N
10074	2378	0	0	34470	\N
10077	241	5	0	34497	\N
10077	2379	6	0	34498	\N
10079	322	6	0	32576	\N
10079	2380	7	0	34513	\N
10085	2	26	0	34593	\N
10085	2384	27	0	34594	\N
10092	2392	7	0	34712	\N
10092	102	22	0	34741	\N
10092	2393	23	0	34742	\N
10097	264	4	0	34756	\N
10097	2398	5	0	34757	\N
10102	10	1	0	34503	\N
10102	11	2	0	34792	\N
10105	793	2	0	34812	\N
10105	1136	3	0	34813	\N
10107	1	3	0	34639	\N
10107	48	4	0	34820	\N
10117	2407	3	0	34908	\N
10117	2408	4	0	34909	\N
10119	10	3	0	34868	\N
10119	347	4	0	34918	\N
10129	300	2	0	34591	\N
10129	706	3	0	34983	\N
10131	300	3	0	34591	\N
10131	2418	4	0	34992	\N
10136	424	4	0	35016	\N
10136	2421	5	0	35017	\N
10139	431	4	0	35110	\N
10139	2424	5	0	35111	\N
10144	1	2	0	34639	\N
10144	112	3	0	35141	\N
10149	56	2	0	35152	\N
10149	169	3	0	35153	\N
10154	92	2	0	35166	\N
10154	93	3	0	35167	\N
10155	14	4	0	34916	\N
10155	588	5	0	35176	\N
10159	725	2	0	35186	\N
10159	2428	3	0	35187	\N
10162	10	2	0	35195	\N
10162	29	3	0	35196	\N
10167	288	2	0	35235	\N
10167	289	3	0	35236	\N
10172	69	1	0	163	\N
10172	70	2	0	164	\N
10178	2432	4	0	35298	\N
10178	2433	5	0	35299	\N
10183	411	4	0	32659	\N
10183	1665	5	0	35308	\N
10187	94	2	0	33716	\N
10187	95	3	0	35317	\N
10188	149	5	0	35328	\N
10188	2441	6	0	35329	\N
10194	18	4	0	35108	\N
10194	590	5	0	35361	\N
10199	1	2	0	34639	\N
10199	112	3	0	35141	\N
10200	391	2	0	35221	\N
10200	406	3	0	35379	\N
10205	251	2	0	35400	\N
10205	828	3	0	35401	\N
10210	362	3	0	35348	\N
10210	2367	4	0	35419	\N
10212	119	6	0	35432	\N
10212	2444	7	0	35433	\N
10216	186	2	0	35442	\N
10216	696	3	0	35443	\N
10228	251	1	0	35501	\N
10228	252	2	0	35502	\N
10229	2079	4	0	35511	\N
10229	2448	5	0	35512	\N
10230	2449	15	0	35513	\N
10230	2079	76	0	35517	\N
10230	2450	77	0	35518	\N
10231	242	6	0	33749	\N
10231	1630	7	0	35531	\N
10235	793	3	0	35543	\N
10235	2453	4	0	35544	\N
10240	322	2	0	35487	\N
10240	833	3	0	35558	\N
10241	73	0	0	179	\N
10246	73	0	0	179	\N
10254	1	2	0	35662	\N
10254	112	3	0	35663	\N
10260	10	5	0	35195	\N
10260	998	6	0	35684	\N
10261	173	4	0	35693	\N
9923	1	3	0	33544	\N
9923	48	4	0	33545	\N
9928	62	1	0	33570	\N
9928	63	2	0	33571	\N
9930	123	2	0	33576	\N
9930	384	3	0	33577	\N
9933	40	4	0	33593	\N
9933	564	5	0	33594	\N
9935	79	2	0	33600	\N
9935	80	3	0	33601	\N
9945	18	2	0	32850	\N
9945	218	3	0	33143	\N
9946	2324	6	0	33660	\N
9946	198	7	0	33661	\N
9951	431	2	0	33694	\N
9951	531	3	0	33695	\N
9954	2330	1	0	33702	\N
9954	2331	2	0	33703	\N
9956	94	5	0	33716	\N
9956	2332	6	0	33717	\N
9958	1	0	0	31649	\N
9960	1	0	0	31780	\N
9962	1	0	0	32084	\N
9969	326	61	0	31951	\N
9969	2337	62	0	33764	\N
9973	230	1	0	33399	\N
9973	287	2	0	33774	\N
9976	1	7	0	33626	\N
9976	1336	8	0	33778	\N
9978	273	2	0	33793	\N
9978	1159	3	0	33794	\N
9981	1	6	0	33626	\N
9981	523	7	0	33811	\N
9992	256	2	0	33876	\N
9992	335	3	0	33877	\N
9995	353	2	0	33896	\N
9995	755	3	0	33897	\N
10000	46	2	0	110	\N
10000	2348	3	0	33912	\N
10002	10	2	0	33550	\N
10002	29	3	0	33551	\N
10005	20	5	0	32901	\N
10005	1512	6	0	33935	\N
10007	2353	6	0	33961	\N
10007	20	17	0	33962	\N
10007	144	18	0	33963	\N
10010	108	3	0	33980	\N
10010	837	4	0	33981	\N
10012	908	4	0	33992	\N
10012	1032	5	0	33993	\N
10015	40	5	0	34013	\N
10015	385	6	0	34014	\N
10018	212	2	0	34033	\N
10018	566	3	0	34034	\N
10020	181	4	0	34072	\N
10020	2356	5	0	34073	\N
10025	96	5	0	33910	\N
10025	1702	6	0	34121	\N
10028	1	4	0	34147	\N
10028	422	5	0	34148	\N
10034	2364	5	0	34190	\N
10034	453	6	0	34191	\N
10035	2365	5	0	34192	\N
10035	260	6	0	34193	\N
10036	1	2	0	34198	\N
10036	112	3	0	34199	\N
10041	841	2	0	34224	\N
10041	1161	3	0	34225	\N
10048	56	2	0	34260	\N
10048	169	3	0	34261	\N
10052	1	2	0	34274	\N
10052	112	3	0	34275	\N
10057	10	3	0	34228	\N
10057	347	4	0	34299	\N
10059	202	1	0	34304	\N
10059	203	2	0	34306	\N
10060	140	14	0	34333	\N
10060	2370	15	0	34334	\N
10062	189	1	0	34337	\N
10062	190	2	0	34338	\N
10072	10	7	0	34439	\N
10072	2274	8	0	34440	\N
10073	1454	13	0	34467	\N
10073	2376	14	0	34468	\N
10075	10	3	0	34477	\N
10075	297	4	0	34478	\N
10078	10	7	0	34503	\N
10078	1776	8	0	34504	\N
10083	1	2	0	34537	\N
10083	112	3	0	34538	\N
10086	233	22	0	26685	\N
10086	2385	23	0	34638	\N
10101	214	1	0	34788	\N
10101	215	2	0	34789	\N
10104	79	2	0	33856	\N
10104	80	3	0	34811	\N
10111	170	7	0	34839	\N
10111	2401	8	0	34840	\N
10113	149	11	0	34380	\N
10113	2404	12	0	34867	\N
10118	14	3	0	34916	\N
10118	306	4	0	34917	\N
10121	852	13	0	34947	\N
10121	2409	14	0	34948	\N
10124	192	2	0	34960	\N
10124	838	3	0	34961	\N
10128	300	1	0	34591	\N
10128	355	2	0	34980	\N
10130	954	2	0	34984	\N
10130	2417	3	0	34985	\N
10137	2422	22	0	35028	\N
10137	320	126	0	35106	\N
10137	2346	127	0	35107	\N
10141	113	0	0	35114	\N
10146	10	2	0	35144	\N
10146	29	3	0	35145	\N
10147	1	2	0	34639	\N
10147	112	3	0	35141	\N
10151	56	2	0	35152	\N
10151	169	3	0	35153	\N
10152	132	2	0	35158	\N
10152	133	3	0	35159	\N
10157	2427	3	0	35183	\N
10164	212	12	0	34033	\N
10164	2430	13	0	35223	\N
10165	2	2	0	35228	\N
10165	131	3	0	35229	\N
10169	12	2	0	31436	\N
10169	433	3	0	32038	\N
10175	88	2	0	33854	\N
10175	154	3	0	35234	\N
10181	411	4	0	32659	\N
10181	1665	5	0	35308	\N
10185	108	2	0	35315	\N
10185	501	3	0	35316	\N
10190	266	5	0	35332	\N
10190	2442	6	0	35333	\N
10191	362	7	0	35348	\N
10191	2142	8	0	35349	\N
10197	360	2	0	33616	\N
10197	510	3	0	35370	\N
10202	2	2	0	35386	\N
10202	131	3	0	35387	\N
10203	1	2	0	35392	\N
10203	112	3	0	35393	\N
10208	100	2	0	35410	\N
10208	101	3	0	35411	\N
10214	75	6	0	34268	\N
10214	2445	7	0	35435	\N
10220	18	2	0	35108	\N
10220	218	3	0	35457	\N
10226	200	1	0	35497	\N
10226	201	2	0	35498	\N
10233	1	3	0	35499	\N
10233	711	4	0	35540	\N
10238	192	14	0	35549	\N
9924	10	2	0	33550	\N
9924	29	3	0	33551	\N
9926	82	5	0	33564	\N
9926	2320	6	0	33565	\N
9931	268	2	0	33582	\N
9931	1387	3	0	33583	\N
9934	10	4	0	33550	\N
9934	600	5	0	33595	\N
9936	360	7	0	33616	\N
9936	2322	8	0	33617	\N
9938	488	2	0	33624	\N
9938	729	3	0	33625	\N
9941	1	2	0	33626	\N
9941	112	3	0	33627	\N
9942	244	2	0	33628	\N
9942	438	3	0	33629	\N
9947	260	6	0	33674	\N
9947	2325	7	0	33675	\N
9949	56	8	0	33682	\N
9949	689	9	0	33683	\N
9963	1	0	0	33722	\N
9965	10	7	0	33550	\N
9965	2274	8	0	33745	\N
9967	149	8	0	33746	\N
9967	2335	9	0	33748	\N
9972	222	4	0	33770	\N
9972	1564	5	0	33771	\N
9974	1	3	0	33626	\N
9974	48	4	0	33777	\N
9982	595	6	0	31678	\N
9982	1556	7	0	33812	\N
9986	88	6	0	33854	\N
9986	623	7	0	33855	\N
9988	125	6	0	33858	\N
9988	2341	7	0	33859	\N
9990	121	2	0	33866	\N
9990	625	3	0	33867	\N
9993	54	6	0	31504	\N
9993	2343	7	0	33889	\N
9996	353	33	0	33896	\N
9996	2344	34	0	33898	\N
10001	2349	2	0	33913	\N
10001	2350	3	0	33914	\N
10013	10	4	0	33982	\N
10013	600	5	0	33994	\N
10016	10	5	0	34025	\N
10016	2042	6	0	34026	\N
10023	58	12	0	34102	\N
10023	2359	13	0	34103	\N
10026	51	4	0	33698	\N
10026	2360	5	0	34130	\N
10029	266	4	0	33280	\N
10029	832	5	0	34157	\N
10032	326	5	0	31951	\N
10032	2097	6	0	34179	\N
10037	54	2	0	34200	\N
10037	485	3	0	34201	\N
10039	362	3	0	31234	\N
10039	2367	4	0	34215	\N
10042	528	2	0	34226	\N
10042	613	3	0	34227	\N
10044	18	2	0	34230	\N
10044	218	3	0	34231	\N
10046	164	2	0	31501	\N
10046	226	3	0	31502	\N
10050	1	2	0	34266	\N
10050	112	3	0	34267	\N
10055	2	4	0	33379	\N
10055	315	5	0	34290	\N
10061	391	14	0	33342	\N
10061	2371	15	0	34335	\N
10063	189	4	0	34347	\N
10063	849	5	0	34348	\N
10065	235	10	0	34370	\N
10065	1238	11	0	34371	\N
10067	149	17	0	34380	\N
10067	2373	18	0	34381	\N
10069	10	3	0	34384	\N
10069	297	4	0	34385	\N
10076	10	7	0	34477	\N
10076	2274	8	0	34486	\N
10081	108	2	0	34519	\N
10081	501	3	0	34520	\N
10084	300	26	0	34591	\N
10084	2383	27	0	34592	\N
10087	1	22	0	34639	\N
10087	2386	23	0	34640	\N
10089	77	12	0	33297	\N
10089	2388	13	0	34666	\N
10091	177	12	0	34696	\N
10091	2391	13	0	34697	\N
10094	2392	7	0	34712	\N
10094	102	22	0	34741	\N
10094	2395	23	1	34743	\N
10094	2394	23	0	34744	\N
10095	2392	7	0	34712	\N
10095	102	22	0	34741	\N
10095	2393	23	0	34742	\N
10096	2396	4	0	34753	\N
10096	2397	4	0	34754	\N
10096	2398	5	0	34755	\N
10098	56	3	0	34260	\N
10098	676	4	0	34764	\N
10099	86	10	0	33313	\N
10099	2399	11	0	34785	\N
10109	10	3	0	34821	\N
10109	347	4	0	34822	\N
10112	2402	114	0	34842	\N
10112	170	126	0	34843	\N
10112	2403	127	0	34844	\N
10114	10	11	0	34868	\N
10114	2405	12	0	34869	\N
10116	40	10	0	34297	\N
10116	2406	11	0	34902	\N
10122	10	13	0	34868	\N
10122	2410	14	0	34949	\N
10125	170	2	0	34839	\N
10125	2412	3	1	34962	\N
10125	1697	3	0	34963	\N
10125	2414	4	1	34964	\N
10125	2413	4	0	34965	\N
10125	2416	5	1	34966	\N
10125	2415	5	0	34967	\N
10133	300	3	0	34591	\N
10133	2418	4	0	34992	\N
10138	18	6	0	35108	\N
10138	2423	7	0	35109	\N
10142	56	3	0	35121	\N
10142	1188	4	0	35122	\N
10143	58	6	0	35135	\N
10143	2015	7	0	35136	\N
10148	156	2	0	35150	\N
10148	571	3	0	35151	\N
10153	58	2	0	35164	\N
10153	665	3	0	35165	\N
10158	391	2	0	35184	\N
10158	406	3	0	35185	\N
10163	391	12	0	35221	\N
10163	1691	13	0	35222	\N
10168	431	2	0	35237	\N
10168	531	3	0	35238	\N
10173	56	17	0	35152	\N
10173	2431	18	0	35276	\N
10174	40	2	0	35281	\N
10174	66	3	0	35282	\N
10179	326	4	0	35300	\N
10179	2435	5	1	35301	\N
10179	2434	5	0	35302	\N
10179	2437	6	1	35303	\N
10179	2436	6	0	35304	\N
10179	2438	7	0	35305	\N
10180	326	4	0	35300	\N
10180	2439	5	1	35306	\N
10180	1518	5	0	35307	\N
10184	326	3	0	35300	\N
10184	2440	4	1	35309	\N
10184	1697	4	0	35310	\N
9925	200	2	0	33552	\N
9925	887	3	0	33553	\N
9927	264	5	0	33566	\N
9927	2321	6	0	33567	\N
9940	10	2	0	33550	\N
9940	29	3	0	33551	\N
9944	264	2	0	33642	\N
9944	265	3	0	33643	\N
9948	2326	0	0	33676	\N
9948	2327	0	0	33677	\N
9953	2328	1	0	33700	\N
9953	2329	2	0	33701	\N
9955	1109	5	0	33714	\N
9955	1684	6	0	33715	\N
9964	16	13	0	33735	\N
9964	2333	14	0	33736	\N
9968	242	7	0	33749	\N
9968	2336	8	0	33750	\N
9971	10	4	0	33550	\N
9971	600	5	0	33595	\N
9977	181	5	0	31370	\N
9977	2213	6	0	31371	\N
9980	597	6	0	33809	\N
9980	1559	7	0	33810	\N
9983	147	6	0	33813	\N
9983	1557	7	0	33814	\N
9985	16	28	0	33840	\N
9985	2339	29	0	33841	\N
9989	18	6	0	33860	\N
9989	2342	7	0	33861	\N
9997	125	2	0	33858	\N
9997	188	3	0	33899	\N
9999	96	2	0	33910	\N
9999	2347	3	0	33911	\N
10004	2352	3	0	33924	\N
10009	1	2	0	33626	\N
10009	112	3	0	33627	\N
10014	435	5	0	30823	\N
10014	2354	6	0	34002	\N
10017	140	2	0	34031	\N
10017	487	3	0	34032	\N
10019	16	53	0	34062	\N
10019	2355	54	0	34063	\N
10022	1	12	0	34100	\N
10022	2358	13	0	34101	\N
10027	1	3	0	34137	\N
10027	1114	4	0	34138	\N
10031	2361	23	0	34167	\N
10031	2362	24	0	34168	\N
10031	2363	24	0	34169	\N
10033	2364	5	0	34190	\N
10033	453	6	0	34191	\N
10038	362	6	0	31234	\N
10038	2366	7	0	34214	\N
10045	528	60	0	34251	\N
10045	2369	61	1	34252	\N
10045	2368	61	0	34253	\N
10051	75	2	0	34268	\N
10051	159	3	0	34269	\N
10054	373	1	0	34280	\N
10054	374	2	0	34281	\N
10064	75	4	0	34268	\N
10064	172	5	0	34349	\N
10066	2	10	0	34372	\N
10066	2372	11	0	34373	\N
10068	149	3	0	34380	\N
10068	2374	4	0	34383	\N
10071	151	14	0	34423	\N
10071	2375	15	0	34424	\N
10080	18	6	0	34230	\N
10080	2381	7	0	34514	\N
10082	1	5	0	34531	\N
10082	2382	6	0	34532	\N
10088	18	22	0	34230	\N
10088	2387	23	0	34641	\N
10090	2389	85	0	34669	\N
10090	113	114	0	34670	\N
10090	2390	115	0	34671	\N
10093	2392	7	0	34712	\N
10093	102	22	0	34741	\N
10093	2393	23	0	34742	\N
10103	77	6	0	34805	\N
10103	2400	7	0	34806	\N
10106	38	2	0	80	\N
10106	39	3	0	81	\N
10110	100	7	0	34837	\N
10110	2035	8	0	34838	\N
10115	56	5	0	34880	\N
10115	677	6	0	34881	\N
10120	316	3	0	34919	\N
10120	555	4	0	34920	\N
10123	2411	114	0	34955	\N
10123	170	126	0	34958	\N
10123	970	127	0	34959	\N
10126	192	2	0	34960	\N
10126	838	3	0	34961	\N
10127	40	4	0	34976	\N
10127	564	5	0	34977	\N
10132	300	4	0	34591	\N
10132	2419	5	0	34995	\N
10134	353	6	0	35006	\N
10134	2420	7	0	35007	\N
10140	2425	21	0	35112	\N
10140	113	22	0	35113	\N
10145	2351	2	0	35142	\N
10145	2352	3	0	35143	\N
10150	10	2	0	35144	\N
10150	29	3	0	35145	\N
10156	224	4	0	739	\N
10156	994	5	0	35177	\N
10160	727	2	0	6088	\N
10160	2429	3	0	35188	\N
10161	149	2	0	35193	\N
10161	697	3	0	35194	\N
10166	88	2	0	33854	\N
10166	154	3	0	35234	\N
10170	75	2	0	34268	\N
10170	159	3	0	34269	\N
10171	69	2	0	163	\N
10171	500	3	0	35243	\N
10176	132	2	0	35287	\N
10176	133	3	0	35288	\N
10177	2	0	0	35289	\N
10182	2432	4	0	35298	\N
10182	2433	5	0	35299	\N
10186	108	2	0	35315	\N
10186	501	3	0	35316	\N
10192	40	7	0	35330	\N
10192	2201	8	0	35350	\N
10193	40	4	0	35359	\N
10193	564	5	0	35360	\N
10198	198	2	0	33894	\N
10198	746	3	0	33895	\N
10204	88	2	0	35394	\N
10204	154	3	0	35395	\N
10209	69	3	0	2654	\N
10209	594	4	0	35418	\N
10215	20	2	0	35440	\N
10215	702	3	0	35441	\N
10221	94	2	0	33716	\N
10221	95	3	0	35317	\N
10227	1	1	0	35499	\N
10227	53	2	0	35500	\N
10234	266	3	0	35541	\N
10234	2452	4	0	35542	\N
10239	200	2	0	35556	\N
10239	887	3	0	35557	\N
10244	73	0	0	179	\N
10245	73	4	0	179	\N
10245	1696	5	0	35569	\N
10253	49	18	0	35656	\N
10253	2457	19	0	35657	\N
10259	62	5	0	35682	\N
10259	2459	6	0	35683	\N
10264	322	2	0	35702	\N
10264	833	3	0	35703	\N
10189	40	5	0	35330	\N
10189	385	6	0	35331	\N
10195	67	4	0	35362	\N
10195	2443	5	0	35363	\N
10196	102	2	0	35368	\N
10196	158	3	0	35369	\N
10201	365	2	0	35384	\N
10201	519	3	0	35385	\N
10206	6	2	0	35402	\N
10206	179	3	0	35403	\N
10207	82	2	0	35408	\N
10207	343	3	0	35409	\N
10213	12	6	0	31436	\N
10213	1577	7	0	35434	\N
10217	186	0	0	35442	\N
10218	79	4	0	33856	\N
10218	589	5	0	35452	\N
10219	206	2	0	31581	\N
10219	693	3	0	31774	\N
10223	2446	22	0	35471	\N
10223	320	61	0	35472	\N
10223	1518	62	1	35473	\N
10223	2447	62	0	35474	\N
10224	322	6	0	35487	\N
10224	1633	7	0	35488	\N
10225	2	8	0	35493	\N
10225	2151	9	0	35494	\N
10232	20	3	0	35538	\N
10232	2451	4	0	35539	\N
10237	192	2	0	35549	\N
10237	838	3	0	35550	\N
10242	1	4	0	35567	\N
10242	422	5	0	35568	\N
10247	132	2	0	35287	\N
10247	133	3	0	35288	\N
10248	140	6	0	34333	\N
10248	1730	7	0	35586	\N
10249	411	2	0	35591	\N
10249	582	3	0	35592	\N
10250	113	28	0	35603	\N
10250	2455	29	0	35604	\N
10252	200	7	0	35556	\N
10252	2456	8	0	35619	\N
10255	54	2	0	34200	\N
10255	485	3	0	34201	\N
10256	64	2	0	35668	\N
10256	162	3	0	35669	\N
10262	1	4	0	35662	\N
10262	422	5	0	35695	\N
10268	100	2	0	35410	\N
10268	101	3	0	35411	\N
10276	407	2	0	35785	\N
10276	156	8	0	35796	\N
10276	1830	9	0	35797	\N
10280	1818	2	0	35810	\N
10280	137	8	0	35811	\N
10280	2468	9	0	35812	\N
10282	10	11	0	35195	\N
10282	465	12	0	35841	\N
10286	140	4	0	35860	\N
10286	1661	5	0	35861	\N
10291	67	3	0	35362	\N
10291	2443	4	0	35363	\N
10297	40	2	0	35890	\N
10297	66	3	0	35901	\N
10304	56	4	0	35864	\N
10304	1145	5	0	35940	\N
10305	365	5	0	35951	\N
10305	2471	6	0	35952	\N
10309	40	5	0	35958	\N
10309	385	6	0	35959	\N
10310	10	3	0	35902	\N
10310	347	4	0	35964	\N
10318	2477	9	0	36027	\N
10318	121	11	0	36028	\N
10318	122	12	0	36030	\N
10319	94	2	0	33716	\N
10319	95	3	0	35317	\N
10320	77	4	0	36043	\N
10320	1132	5	0	36044	\N
10325	170	4	0	34839	\N
10325	171	5	0	36064	\N
10335	40	3	0	36143	\N
10335	128	4	0	36144	\N
10336	108	2	0	36149	\N
10336	501	3	0	36150	\N
10342	167	2	0	36174	\N
10342	168	3	0	36175	\N
10348	16	2	0	36204	\N
10348	155	3	0	36205	\N
10354	597	2	0	33809	\N
10354	767	3	0	36222	\N
10358	336	0	0	32732	\N
10363	336	0	0	32732	\N
10369	2486	2	0	36263	\N
10369	27	6	0	36264	\N
10369	1270	7	0	36265	\N
10373	2489	1	0	36275	\N
10373	2491	2	0	36277	\N
10382	56	3	0	36345	\N
10382	676	4	0	36346	\N
10388	121	3	0	36384	\N
10388	2317	4	0	36385	\N
10392	113	2	0	35603	\N
10392	114	3	0	36402	\N
10397	235	2	0	34370	\N
10397	1061	3	0	36416	\N
10404	1171	2	0	12253	\N
10404	2499	3	0	36443	\N
10405	123	6	0	36456	\N
10405	2500	7	0	36457	\N
10406	42	2	0	32330	\N
10406	681	3	0	36462	\N
10413	473	1	0	36501	\N
10413	279	3	0	36502	\N
10413	2505	4	1	36503	\N
10413	2504	4	0	36504	\N
10415	86	5	0	36530	\N
10415	2507	6	0	36531	\N
10426	6	2	0	35402	\N
10426	179	3	0	35403	\N
10427	353	15	0	36625	\N
10427	2420	16	0	36626	\N
10429	1	2	0	36577	\N
10429	112	3	0	36578	\N
10449	398	1	0	34840	\N
10449	170	14	0	36774	\N
10449	2508	15	0	36775	\N
10454	103	1	0	36747	\N
10454	102	14	0	36772	\N
10454	2516	15	0	36773	\N
10460	285	5	0	36806	\N
10460	2526	6	0	36807	\N
10462	10	5	0	36706	\N
10462	1298	6	0	36818	\N
10464	453	0	0	36821	\N
10467	23	9	0	32958	\N
10467	2155	10	0	36856	\N
10469	1	4	0	36866	\N
10469	422	5	0	36867	\N
10472	167	2	0	36903	\N
10472	168	3	0	36904	\N
10474	56	2	0	36541	\N
10474	169	3	0	36914	\N
10477	75	5	0	34268	\N
10477	2046	6	0	36935	\N
10479	54	2	0	36936	\N
10479	485	3	0	36942	\N
10480	40	6	0	36955	\N
10480	522	7	0	36956	\N
10483	58	9	0	36978	\N
10483	2533	10	0	36979	\N
10486	69	2	0	36987	\N
10486	500	3	0	36988	\N
10489	10	2	0	36927	\N
10489	29	3	0	36819	\N
10493	117	22	0	36648	\N
10238	2454	15	0	35551	\N
10243	73	0	0	179	\N
10258	230	5	0	35680	\N
10258	2458	6	0	35681	\N
10263	214	4	0	35696	\N
10263	649	5	0	35697	\N
10269	40	2	0	35721	\N
10269	66	3	0	35733	\N
10270	33	2	0	33361	\N
10270	34	3	0	33362	\N
10278	407	2	0	35785	\N
10278	156	8	0	35796	\N
10278	2464	9	1	35801	\N
10278	2368	9	0	35802	\N
10278	2465	10	0	35803	\N
10284	242	3	0	35849	\N
10284	1135	4	0	35850	\N
10288	1	4	0	35862	\N
10288	422	5	0	35863	\N
10294	279	5	0	35892	\N
10294	2469	6	0	35893	\N
10295	18	5	0	35108	\N
10295	2342	6	0	35894	\N
10301	266	3	0	35541	\N
10301	405	4	0	35925	\N
10307	69	6	0	2654	\N
10307	2473	7	0	35956	\N
10313	1109	3	0	35980	\N
10313	1683	4	0	35981	\N
10322	77	4	0	36043	\N
10322	2067	5	1	36048	\N
10322	2480	5	0	36049	\N
10328	64	5	0	36086	\N
10328	2482	6	0	36087	\N
10333	33	7	0	36133	\N
10333	2483	8	0	36134	\N
10339	110	2	0	36165	\N
10339	111	3	0	36166	\N
10346	56	2	0	36196	\N
10346	169	3	0	36197	\N
10351	198	4	0	33894	\N
10351	2484	5	0	36214	\N
10352	10	4	0	36215	\N
10352	600	5	0	36216	\N
10356	336	0	0	32732	\N
10360	88	2	0	35394	\N
10360	154	3	0	35395	\N
10366	1	4	0	36248	\N
10366	422	5	0	36249	\N
10367	1214	2	0	36254	\N
10367	110	6	0	36261	\N
10367	905	7	0	36262	\N
10371	365	2	0	36273	\N
10371	519	3	0	36274	\N
10376	488	5	0	33624	\N
10376	2492	6	0	36290	\N
10379	262	6	0	36325	\N
10379	2495	7	0	36326	\N
10380	391	4	0	36335	\N
10380	539	5	0	36336	\N
10385	290	2	0	1060	\N
10385	575	3	0	36358	\N
10390	49	3	0	36387	\N
10390	1913	4	0	36388	\N
10391	290	4	0	1060	\N
10391	695	5	0	36397	\N
10396	75	3	0	34268	\N
10396	857	4	0	36411	\N
10401	852	3	0	34947	\N
10401	1068	4	0	36429	\N
10402	38	1	0	80	\N
10402	399	2	0	36432	\N
10403	10	2	0	36437	\N
10403	29	3	0	36438	\N
10412	53	1	0	36495	\N
10412	1	3	0	36498	\N
10414	18	7	0	36278	\N
10414	2506	8	0	36519	\N
10419	10	2	0	36543	\N
10419	29	3	0	36544	\N
10420	300	12	0	36567	\N
10420	2418	13	0	36568	\N
10421	170	12	0	36569	\N
10421	2508	13	0	36570	\N
10423	1	2	0	36577	\N
10423	112	3	0	36578	\N
10424	424	2	0	36579	\N
10424	520	3	0	36580	\N
10432	56	3	0	36541	\N
10432	475	4	0	36542	\N
10433	110	4	0	36644	\N
10433	1708	5	0	36645	\N
10438	142	4	0	36669	\N
10438	2510	5	0	36670	\N
10441	35	2	0	29225	\N
10441	36	3	0	29226	\N
10443	4	3	0	36704	\N
10443	1538	4	0	36705	\N
10446	115	10	0	36729	\N
10446	2513	11	0	36730	\N
10448	103	1	0	36747	\N
10448	102	14	0	36772	\N
10448	2516	15	0	36773	\N
10450	398	1	0	34840	\N
10450	170	14	0	36774	\N
10450	2508	15	0	36775	\N
10459	584	1	0	36785	\N
10459	451	14	0	36786	\N
10459	2521	15	0	36789	\N
10461	1	5	0	36816	\N
10461	1233	6	0	36817	\N
10465	453	7	0	36821	\N
10465	2527	8	0	36836	\N
10466	125	9	0	33858	\N
10466	2528	10	0	36855	\N
10471	170	2	0	36569	\N
10471	718	3	0	36902	\N
10476	10	5	0	36927	\N
10476	2042	6	0	36928	\N
10485	365	2	0	36985	\N
10485	519	3	0	36986	\N
10492	117	22	0	36648	\N
10492	2535	23	0	37036	\N
10497	14	11	0	37067	\N
10497	666	12	0	37068	\N
10499	264	11	0	37069	\N
10499	2537	12	0	37070	\N
10501	326	2	0	35300	\N
10501	747	3	0	37076	\N
10504	453	2	0	37092	\N
10504	902	3	0	37093	\N
10505	71	9	0	36638	\N
10505	2538	10	0	37112	\N
10510	336	2	0	32732	\N
10510	740	3	0	36229	\N
10514	1109	6	0	35980	\N
10514	2238	7	0	37138	\N
10516	262	2	0	36325	\N
10516	731	3	0	37143	\N
10521	181	4	0	37165	\N
10521	856	5	0	37166	\N
10526	244	8	0	37190	\N
10526	2546	9	0	37191	\N
10529	435	4	0	37207	\N
10529	2180	5	0	37208	\N
10532	121	4	0	36384	\N
10532	2550	5	0	37228	\N
10534	228	2	0	32640	\N
10534	511	3	0	37244	\N
10539	224	3	0	37269	\N
10539	2551	4	0	37270	\N
10542	16	2	0	36204	\N
10542	155	3	0	36205	\N
10545	86	4	0	36530	\N
10545	1592	5	0	37284	\N
10261	1046	5	0	35694	\N
10266	40	8	0	35721	\N
10266	2461	9	0	35722	\N
10267	108	2	0	35727	\N
10267	501	3	0	35728	\N
10273	373	2	0	35754	\N
10273	1504	3	0	35755	\N
10274	117	3	0	35762	\N
10274	118	4	0	35763	\N
10275	64	8	0	35779	\N
10275	2462	9	0	35780	\N
10279	1817	2	0	35804	\N
10279	135	8	0	35805	\N
10279	2435	9	1	35806	\N
10279	2368	9	0	35807	\N
10279	2467	10	1	35808	\N
10279	2466	10	0	35809	\N
10279	2465	11	0	35803	\N
10285	119	3	0	35432	\N
10285	129	4	0	35851	\N
10289	56	3	0	35864	\N
10289	475	4	0	35865	\N
10290	40	3	0	35872	\N
10290	564	4	0	35873	\N
10296	1	2	0	35899	\N
10296	112	3	0	35900	\N
10303	819	2	0	35930	\N
10303	820	3	0	35931	\N
10308	69	5	0	2654	\N
10308	2474	6	0	35957	\N
10314	10	3	0	35982	\N
10314	297	4	0	35983	\N
10315	40	6	0	35958	\N
10315	522	7	0	35996	\N
10316	119	5	0	36007	\N
10316	2476	6	0	36008	\N
10317	2477	9	0	36027	\N
10317	121	10	0	36028	\N
10323	164	4	0	36045	\N
10323	1582	5	0	36050	\N
10324	10	2	0	35982	\N
10324	29	3	0	36055	\N
10329	10	5	0	36088	\N
10329	1645	6	0	36089	\N
10330	40	5	0	36100	\N
10330	2192	6	0	36101	\N
10331	16	2	0	33735	\N
10331	155	3	0	36106	\N
10332	79	6	0	36119	\N
10332	2340	7	0	36120	\N
10334	121	3	0	36141	\N
10334	1346	4	0	36142	\N
10340	110	3	0	36165	\N
10340	905	4	0	36169	\N
10341	202	2	0	36172	\N
10341	812	3	0	36173	\N
10347	449	2	0	36198	\N
10347	583	3	0	36199	\N
10353	147	2	0	33813	\N
10353	516	3	0	36221	\N
10357	336	2	0	32732	\N
10357	740	3	0	36229	\N
10361	336	0	0	32732	\N
10362	336	0	0	32732	\N
10368	2486	2	0	36263	\N
10368	27	6	0	36264	\N
10368	1270	7	0	36265	\N
10372	2489	2	0	36275	\N
10372	2490	3	0	36276	\N
10381	145	4	0	36337	\N
10381	2316	5	0	36338	\N
10386	192	2	0	36359	\N
10386	838	3	0	36360	\N
10387	2496	10	0	36362	\N
10387	192	126	0	36375	\N
10387	1395	127	1	36376	\N
10387	2497	127	0	36377	\N
10394	40	2	0	36143	\N
10394	66	3	0	36405	\N
10395	10	2	0	36215	\N
10395	29	3	0	36410	\N
10400	266	2	0	35541	\N
10400	1711	3	0	36422	\N
10410	266	5	0	35541	\N
10410	2442	6	0	36486	\N
10411	10	2	0	36491	\N
10411	29	3	0	36492	\N
10418	56	3	0	36541	\N
10418	475	4	0	36542	\N
10422	40	12	0	36571	\N
10422	869	13	0	36572	\N
10425	189	4	0	36589	\N
10425	849	5	0	36590	\N
10428	132	15	0	36463	\N
10428	2509	16	0	36627	\N
10431	200	3	0	36640	\N
10431	219	4	0	36641	\N
10435	16	2	0	36204	\N
10435	155	3	0	36205	\N
10437	2	4	0	36176	\N
10437	315	5	0	36660	\N
10440	151	5	0	36689	\N
10440	2511	6	0	36690	\N
10445	69	10	0	2654	\N
10445	2512	11	0	36728	\N
10447	2514	74	0	36740	\N
10447	115	126	0	36743	\N
10447	2515	127	0	36744	\N
10453	103	1	0	36747	\N
10453	102	14	0	36772	\N
10453	2518	15	1	36781	\N
10453	2435	15	0	36782	\N
10453	2519	16	1	36783	\N
10453	2100	16	0	36784	\N
10456	584	1	0	36785	\N
10456	451	14	0	36786	\N
10456	2521	15	0	36789	\N
10458	2525	5	0	36804	\N
10458	2526	6	0	36805	\N
10473	10	3	0	36706	\N
10473	465	4	0	36909	\N
10478	54	2	0	36936	\N
10478	2532	3	0	36937	\N
10482	94	6	0	36958	\N
10482	2018	7	0	36959	\N
10488	156	2	0	36989	\N
10488	571	3	0	36990	\N
10494	206	22	0	37037	\N
10494	2536	23	0	37038	\N
10496	1470	11	0	37065	\N
10496	1896	12	0	37066	\N
10503	20	2	0	35538	\N
10503	702	3	0	37091	\N
10507	56	9	0	37114	\N
10507	2540	10	0	37115	\N
10509	360	2	0	37121	\N
10509	510	3	0	37122	\N
10512	79	2	0	37123	\N
10512	80	3	0	37124	\N
10513	40	4	0	36955	\N
10513	564	5	0	37129	\N
10518	214	2	0	35696	\N
10518	227	3	0	37148	\N
10520	391	2	0	37155	\N
10520	406	3	0	37156	\N
10524	431	4	0	37170	\N
10524	1031	5	0	37171	\N
10528	73	4	0	179	\N
10528	1696	5	0	35569	\N
10531	102	4	0	37226	\N
10531	2549	5	0	37227	\N
10536	10	2	0	37250	\N
10536	29	3	0	37251	\N
10541	1	2	0	37281	\N
10541	112	3	0	37282	\N
10548	431	5	0	37298	\N
10265	365	8	0	35384	\N
10265	2460	9	0	35720	\N
10271	40	2	0	35742	\N
10271	66	3	0	35743	\N
10272	121	2	0	35748	\N
10272	625	3	0	35749	\N
10277	180	2	0	35798	\N
10277	92	8	0	35799	\N
10277	2463	9	0	35800	\N
10281	1	2	0	35817	\N
10281	112	3	0	35818	\N
10283	119	2	0	35432	\N
10283	891	3	0	35846	\N
10287	173	4	0	35693	\N
10287	1046	5	0	35694	\N
10292	1	3	0	35862	\N
10292	48	4	0	35879	\N
10293	40	5	0	35890	\N
10293	522	6	0	35891	\N
10298	10	2	0	35902	\N
10298	29	3	0	35903	\N
10299	149	7	0	35328	\N
10299	2470	8	0	35918	\N
10300	14	3	0	34916	\N
10300	306	4	0	34917	\N
10306	365	6	0	35951	\N
10306	2472	7	0	35955	\N
10311	92	4	0	35166	\N
10311	2475	5	0	35972	\N
10312	79	3	0	35978	\N
10312	1168	4	0	35979	\N
10321	164	4	0	36045	\N
10326	6	4	0	35402	\N
10326	670	5	0	36065	\N
10327	2	4	0	36074	\N
10327	2481	5	0	36075	\N
10337	123	2	0	34278	\N
10337	384	3	0	36151	\N
10338	181	4	0	34072	\N
10338	856	5	0	36160	\N
10343	2	2	0	36176	\N
10343	131	3	0	36177	\N
10344	40	6	0	36143	\N
10344	522	7	0	36190	\N
10345	10	6	0	36088	\N
10345	426	7	0	36191	\N
10349	1	2	0	35899	\N
10349	112	3	0	35900	\N
10350	75	4	0	34268	\N
10350	172	5	0	34349	\N
10355	595	2	0	36223	\N
10355	768	3	0	36224	\N
10359	54	2	0	36230	\N
10359	485	3	0	36231	\N
10364	459	2	0	36236	\N
10364	1796	3	0	36237	\N
10365	1470	4	0	36246	\N
10365	2485	5	0	36247	\N
10370	2487	2	0	36270	\N
10370	2488	2	0	36271	\N
10370	519	3	0	36272	\N
10374	2489	2	0	36275	\N
10374	2490	3	0	36276	\N
10375	18	1	0	36278	\N
10375	19	2	0	36279	\N
10377	56	9	0	36309	\N
10377	2493	10	0	36310	\N
10378	151	6	0	36323	\N
10378	2494	7	0	36324	\N
10383	10	2	0	36215	\N
10383	792	3	0	36347	\N
10384	841	2	0	36352	\N
10384	1161	3	0	36353	\N
10389	121	2	0	36384	\N
10389	2498	3	0	36386	\N
10393	79	2	0	36403	\N
10393	80	3	0	36404	\N
10398	18	2	0	36278	\N
10398	218	3	0	36417	\N
10399	40	2	0	36143	\N
10399	66	3	0	36405	\N
10407	132	2	0	36463	\N
10407	133	3	0	36464	\N
10408	244	4	0	36473	\N
10408	2501	5	0	36474	\N
10409	1	5	0	36248	\N
10409	1233	6	0	36485	\N
10416	391	5	0	36335	\N
10416	1511	6	0	36532	\N
10417	12	3	0	36539	\N
10417	782	4	0	36540	\N
10430	71	3	0	36638	\N
10430	397	4	0	36639	\N
10434	117	2	0	36648	\N
10434	175	3	0	36649	\N
10436	10	2	0	36650	\N
10436	29	3	0	36651	\N
10439	54	3	0	36677	\N
10439	476	4	0	36678	\N
10442	35	3	0	29225	\N
10442	1499	4	0	36697	\N
10444	10	3	0	36706	\N
10444	347	4	0	36707	\N
10451	11	1	0	36776	\N
10451	10	14	0	36777	\N
10451	465	15	0	36778	\N
10452	103	1	0	36747	\N
10452	102	14	0	36772	\N
10452	2100	15	1	36779	\N
10452	2517	15	0	36780	\N
10455	584	1	0	36785	\N
10455	451	14	0	36786	\N
10457	2523	6	0	36802	\N
10457	2524	7	0	36803	\N
10463	10	5	0	36819	\N
10463	998	6	0	36820	\N
10468	10	9	0	36706	\N
10468	2529	10	0	36857	\N
10470	79	19	0	36896	\N
10470	2530	20	0	36897	\N
10475	449	3	0	36921	\N
10475	2531	4	0	36922	\N
10481	1021	6	0	33150	\N
10481	1558	7	0	36957	\N
10484	251	9	0	35501	\N
10484	2534	10	0	36980	\N
10487	102	2	0	35368	\N
10487	158	3	0	35369	\N
10490	69	11	0	36987	\N
10490	1166	12	0	36991	\N
10491	365	0	0	36985	\N
10498	264	11	0	37069	\N
10498	2537	12	0	37070	\N
10500	40	11	0	36955	\N
10500	569	12	0	37071	\N
10508	336	1	0	32732	\N
10508	356	2	0	37118	\N
10523	2544	4	0	37168	\N
10523	2545	5	0	37169	\N
10525	1	8	0	37188	\N
10525	1982	9	0	37189	\N
10530	402	4	0	37217	\N
10530	2548	5	0	37218	\N
10533	600	4	0	37237	\N
10533	10	6	0	37239	\N
10533	1416	7	0	36928	\N
10538	115	2	0	36729	\N
10538	636	3	0	37262	\N
10544	86	2	0	36530	\N
10544	509	3	0	37283	\N
10547	1	5	0	37281	\N
10547	2052	6	0	37297	\N
10321	2479	5	1	138443	\N
10455	2520	15	1	138446	\N
10493	2535	23	0	37036	\N
10495	123	1	0	37041	\N
10495	124	2	0	37042	\N
10502	411	4	0	37085	\N
10502	1665	5	0	37086	\N
10506	273	9	0	33793	\N
10506	2539	10	0	37113	\N
10511	360	2	0	37121	\N
10511	510	3	0	37122	\N
10515	40	6	0	36955	\N
10515	522	7	0	36956	\N
10517	214	2	0	35696	\N
10517	227	3	0	37148	\N
10519	2541	2	0	37149	\N
10519	2542	3	0	37150	\N
10522	156	4	0	36989	\N
10522	2543	5	0	37167	\N
10527	73	39	0	179	\N
10527	2547	40	0	37204	\N
10535	435	2	0	37207	\N
10535	481	3	0	37245	\N
10537	1	2	0	37256	\N
10537	112	3	0	37257	\N
10540	75	2	0	37275	\N
10540	159	3	0	37276	\N
10543	79	2	0	37123	\N
10543	80	3	0	37124	\N
10546	90	2	0	37285	\N
10546	91	3	0	37286	\N
10549	40	5	0	36955	\N
10549	2192	6	0	37300	\N
10552	198	7	0	37342	\N
10552	2555	8	0	37343	\N
10554	42	2	0	37350	\N
10554	681	3	0	37351	\N
10558	2558	10	0	37367	\N
10558	192	126	0	37424	\N
10558	2559	127	0	37425	\N
10560	1157	2	0	37436	\N
10560	2560	3	0	37437	\N
10562	288	2	0	35235	\N
10562	289	3	0	35236	\N
10582	1148	2	0	37536	\N
10582	402	3	0	37537	\N
10586	391	2	0	37448	\N
10586	406	3	0	37547	\N
10589	264	0	0	37069	\N
10592	2561	4	0	37568	\N
10592	2562	5	0	37569	\N
10596	10	4	0	37588	\N
10596	600	5	0	37589	\N
10601	1	2	0	37574	\N
10601	112	3	0	37575	\N
10608	58	2	0	37630	\N
10608	665	3	0	37631	\N
10610	353	4	0	37642	\N
10610	1570	5	0	37643	\N
10615	1	2	0	37574	\N
10615	112	3	0	37575	\N
10617	192	2	0	37669	\N
10617	838	3	0	37670	\N
10619	38	2	0	37675	\N
10619	39	3	0	1792	\N
10623	242	6	0	37699	\N
10623	1630	7	0	37700	\N
10625	1109	2	0	37707	\N
10625	1412	3	0	37708	\N
10627	200	3	0	37715	\N
10627	2565	4	0	37716	\N
10630	40	2	0	37727	\N
10630	66	3	0	37728	\N
10634	6	2	0	37744	\N
10634	179	3	0	37745	\N
10636	164	3	0	37751	\N
10636	307	4	0	37752	\N
10637	359	3	0	37759	\N
10637	16	8	0	37768	\N
10637	1529	9	0	37769	\N
10642	82	2	0	2245	\N
10642	343	3	0	37792	\N
10644	54	4	0	37821	\N
10644	2570	5	0	37822	\N
10650	391	2	0	37843	\N
10650	406	3	0	37844	\N
10651	151	4	0	37853	\N
10651	1510	5	0	37854	\N
10656	1	4	0	37877	\N
10656	422	5	0	37878	\N
10659	40	4	0	37727	\N
10659	564	5	0	37883	\N
10663	258	2	0	37897	\N
10663	585	3	0	37898	\N
10665	373	2	0	37901	\N
10665	1504	3	0	37902	\N
10671	1	6	0	37877	\N
10671	523	7	0	37932	\N
10675	125	2	0	37950	\N
10675	188	3	0	37951	\N
10687	264	0	0	37069	\N
10689	262	5	0	38001	\N
10689	2577	6	0	38002	\N
10694	222	0	0	38012	\N
10697	233	8	0	38049	\N
10697	2580	9	0	38050	\N
10700	326	8	0	38051	\N
10700	2581	9	0	38052	\N
10701	326	8	0	38051	\N
10701	2582	9	1	38053	\N
10701	2260	9	0	38054	\N
10701	2584	10	1	38055	\N
10701	2583	10	0	38056	\N
10704	322	4	0	38070	\N
10704	1616	5	0	38071	\N
10705	326	9	0	38051	\N
10705	2585	10	0	38090	\N
10707	90	2	0	37285	\N
10707	91	3	0	37286	\N
10708	10	2	0	38097	\N
10708	29	3	0	38098	\N
10712	62	2	0	38113	\N
10712	683	3	0	38114	\N
10716	40	2	0	38117	\N
10716	66	3	0	38118	\N
10719	597	2	0	33809	\N
10719	767	3	0	36222	\N
10721	177	6	0	38143	\N
10721	2587	7	0	38144	\N
10723	149	2	0	38150	\N
10723	697	3	0	38151	\N
10725	2589	23	0	38153	\N
10725	149	126	0	38155	\N
10725	1971	127	1	38156	\N
10725	2590	127	0	38157	\N
10727	10	9	0	38173	\N
10727	2591	10	0	38174	\N
10730	2595	2	0	38188	\N
10734	92	2	0	38201	\N
10734	93	3	0	38202	\N
10737	10	4	0	38221	\N
10737	600	5	0	38222	\N
10742	289	2	0	38243	\N
10742	288	4	0	38246	\N
10742	400	5	0	38247	\N
10744	56	2	0	38255	\N
10744	169	3	0	38256	\N
10745	132	2	0	38257	\N
10745	133	3	0	38258	\N
10749	151	3	0	37853	\N
10749	152	4	0	38272	\N
10755	258	0	0	37897	\N
10760	1815	4	0	24253	\N
10760	2597	5	0	38332	\N
10764	145	2	0	38345	\N
10764	331	3	0	38346	\N
10769	4	4	0	38374	\N
10769	684	5	0	38375	\N
10548	2552	6	0	37299	\N
10550	449	2	0	37305	\N
10550	583	3	0	37306	\N
10551	2553	32	0	37328	\N
10551	73	43	0	37337	\N
10551	2554	44	0	37338	\N
10561	10	2	0	37442	\N
10561	29	3	0	37443	\N
10566	367	2	0	37462	\N
10566	651	3	0	37463	\N
10568	75	2	0	37466	\N
10568	159	3	0	37467	\N
10570	77	2	0	36043	\N
10570	216	3	0	37474	\N
10572	110	2	0	36644	\N
10572	111	3	0	37481	\N
10575	10	3	0	37468	\N
10575	347	4	0	37498	\N
10578	10	6	0	37519	\N
10578	426	7	0	37520	\N
10581	10	2	0	37530	\N
10581	29	3	0	37531	\N
10595	391	4	0	37586	\N
10595	539	5	0	37587	\N
10597	40	2	0	37594	\N
10597	66	3	0	37595	\N
10600	852	2	0	37608	\N
10600	1325	3	0	37609	\N
10604	75	2	0	37466	\N
10604	159	3	0	37467	\N
10611	2	4	0	37644	\N
10611	315	5	0	37645	\N
10618	2563	10	0	37671	\N
10618	192	36	0	37672	\N
10618	796	37	1	37673	\N
10618	2564	37	0	37674	\N
10621	181	4	0	37165	\N
10621	856	5	0	37166	\N
10626	40	2	0	37650	\N
10626	66	3	0	37651	\N
10628	40	2	0	37650	\N
10628	66	3	0	37651	\N
10633	102	3	0	37742	\N
10633	1388	4	0	37743	\N
10638	2566	2	0	37774	\N
10638	2567	2	0	37775	\N
10638	480	3	0	37776	\N
10643	54	30	0	37811	\N
10643	2569	31	0	37812	\N
10648	170	2	0	37841	\N
10648	718	3	0	37842	\N
10653	164	4	0	37857	\N
10653	1582	5	0	37858	\N
10658	212	4	0	37881	\N
10658	1568	5	0	37882	\N
10662	54	0	0	37892	\N
10666	94	2	0	37663	\N
10666	95	3	0	37664	\N
10669	56	5	0	37475	\N
10669	677	6	0	37917	\N
10674	42	4	0	37944	\N
10674	2139	5	0	37945	\N
10677	10	2	0	37954	\N
10677	29	3	0	37955	\N
10681	1	2	0	37970	\N
10681	112	3	0	37971	\N
10683	40	2	0	37727	\N
10683	66	3	0	37728	\N
10686	86	3	0	36530	\N
10686	2576	4	0	37989	\N
10691	173	2	0	38007	\N
10691	480	3	0	38008	\N
10695	10	5	0	38023	\N
10695	2579	6	0	38024	\N
10696	10	3	0	38031	\N
10696	347	4	0	38032	\N
10699	326	8	0	38051	\N
10699	2581	9	0	38052	\N
10703	75	2	0	37466	\N
10703	159	3	0	37467	\N
10714	56	2	0	38115	\N
10714	169	3	0	38116	\N
10715	273	2	0	33793	\N
10715	1159	3	0	33794	\N
10717	147	2	0	33813	\N
10717	516	3	0	36221	\N
10722	56	6	0	38115	\N
10722	2588	7	0	38145	\N
10724	23	2	0	32958	\N
10724	24	3	0	38152	\N
10726	1	7	0	37970	\N
10726	1247	8	0	38172	\N
10728	362	2	0	38179	\N
10728	420	3	0	38180	\N
10731	367	2	0	38189	\N
10731	651	3	0	38190	\N
10735	10	2	0	38173	\N
10735	29	3	0	38203	\N
10738	1	2	0	38227	\N
10738	112	3	0	38228	\N
10751	262	3	0	38274	\N
10751	1305	4	0	38275	\N
10753	279	6	0	35892	\N
10753	2469	7	0	35893	\N
10758	451	2	0	38320	\N
10758	452	3	0	38321	\N
10766	10	4	0	38357	\N
10766	600	5	0	38358	\N
10771	108	4	0	38376	\N
10771	669	5	0	38377	\N
10775	69	5	0	36987	\N
10775	2474	6	0	38408	\N
10783	224	4	0	38436	\N
10783	994	5	0	38437	\N
10787	10	3	0	38357	\N
10787	347	4	0	38424	\N
10790	64	5	0	38484	\N
10790	2096	6	0	38485	\N
10793	230	5	0	38511	\N
10793	2601	6	0	38512	\N
10800	367	5	0	38189	\N
10800	386	6	0	38531	\N
10803	79	4	0	37123	\N
10803	589	5	0	38581	\N
10817	391	3	0	38760	\N
10817	581	4	0	38761	\N
10819	202	2	0	38767	\N
10819	812	3	0	38768	\N
10824	75	3	0	37466	\N
10824	857	4	0	38786	\N
10834	1470	4	0	38837	\N
10834	2485	5	0	38838	\N
10837	453	9	0	38860	\N
10837	2609	10	0	38862	\N
10846	1	2	0	38917	\N
10846	112	3	0	38918	\N
10849	94	6	0	38942	\N
10849	2614	7	0	38943	\N
10553	73	7	0	37344	\N
10553	2556	8	0	37345	\N
10555	40	9	0	37352	\N
10555	2557	10	0	37353	\N
10557	192	4	0	37363	\N
10557	941	5	0	37364	\N
10563	391	4	0	37448	\N
10563	539	5	0	37449	\N
10565	60	2	0	37460	\N
10565	166	3	0	37461	\N
10567	206	2	0	37464	\N
10567	693	3	0	37465	\N
10569	10	2	0	37468	\N
10569	29	3	0	37469	\N
10574	435	3	0	37207	\N
10574	1456	4	0	37491	\N
10577	852	2	0	37505	\N
10577	1325	3	0	37506	\N
10580	353	2	0	36625	\N
10580	755	3	0	37529	\N
10583	112	2	0	37538	\N
10583	1	3	0	37282	\N
10585	218	2	0	37541	\N
10585	18	3	0	37542	\N
10587	40	2	0	37352	\N
10587	66	3	0	37540	\N
10590	264	4	0	37069	\N
10590	2137	5	0	37566	\N
10594	10	2	0	37576	\N
10594	29	3	0	37577	\N
10599	241	2	0	37606	\N
10599	281	3	0	37607	\N
10602	214	2	0	35696	\N
10602	227	3	0	37148	\N
10606	451	2	0	37624	\N
10606	452	3	0	37625	\N
10609	49	2	0	37632	\N
10609	328	3	0	37633	\N
10613	40	2	0	37650	\N
10613	66	3	0	37651	\N
10616	94	2	0	37663	\N
10616	95	3	0	37664	\N
10620	16	4	0	37684	\N
10620	380	5	0	37685	\N
10632	10	3	0	37734	\N
10632	297	4	0	37735	\N
10635	102	2	0	37742	\N
10635	158	3	0	37746	\N
10640	10	3	0	37784	\N
10640	2568	4	0	37785	\N
10645	2351	4	0	37831	\N
10645	2571	5	0	37832	\N
10647	290	2	0	37839	\N
10647	575	3	0	37840	\N
10652	228	4	0	37855	\N
10652	1631	5	0	37856	\N
10654	10	0	0	37833	\N
10657	16	4	0	37879	\N
10657	380	5	0	37880	\N
10661	140	2	0	35860	\N
10661	487	3	0	37891	\N
10664	54	2	0	37899	\N
10664	485	3	0	37900	\N
10668	435	5	0	37915	\N
10668	2573	6	0	37916	\N
10672	110	6	0	37933	\N
10672	736	7	0	37934	\N
10676	1	2	0	37952	\N
10676	112	3	0	37953	\N
10678	1	2	0	37952	\N
10678	112	3	0	37953	\N
10680	10	2	0	37954	\N
10680	29	3	0	37955	\N
10685	16	3	0	37987	\N
10685	2575	4	0	37988	\N
10688	264	2	0	37069	\N
10688	265	3	0	37994	\N
10690	102	2	0	37742	\N
10690	158	3	0	37746	\N
10698	233	8	0	38049	\N
10698	2580	9	0	38050	\N
10702	251	2	0	35501	\N
10702	828	3	0	38061	\N
10706	241	9	0	38091	\N
10706	2586	10	0	38092	\N
10710	156	2	0	36989	\N
10710	571	3	0	36990	\N
10713	62	2	0	38113	\N
10713	683	3	0	38114	\N
10740	12	2	0	38229	\N
10740	433	3	0	38230	\N
10743	155	2	0	38248	\N
10743	16	4	0	38249	\N
10743	17	5	0	38250	\N
10747	35	2	0	38263	\N
10747	36	3	0	38264	\N
10750	86	3	0	36530	\N
10750	2596	4	0	38273	\N
10752	56	7	0	38290	\N
10752	2230	8	0	38291	\N
10757	1021	2	0	33150	\N
10757	1048	3	0	33151	\N
10761	56	4	0	38333	\N
10761	1145	5	0	38334	\N
10765	431	4	0	38355	\N
10765	1031	5	0	38356	\N
10770	108	4	0	38376	\N
10770	669	5	0	38377	\N
10772	202	4	0	38386	\N
10772	1149	5	0	38387	\N
10774	1	4	0	38396	\N
10774	422	5	0	38397	\N
10777	119	1	0	38412	\N
10777	120	2	0	38413	\N
10782	1	4	0	38434	\N
10782	422	5	0	38435	\N
10784	2598	112	0	38440	\N
10784	244	126	0	38441	\N
10784	2599	127	0	38442	\N
10786	69	3	0	38458	\N
10786	594	4	0	38459	\N
10789	281	2	0	38472	\N
10789	241	3	0	38473	\N
10798	88	2	0	35394	\N
10798	154	3	0	35395	\N
10802	2603	112	0	38570	\N
10802	244	126	0	38571	\N
10802	2599	127	0	38572	\N
10805	10	2	0	38586	\N
10805	29	3	0	38587	\N
10808	149	3	0	38150	\N
10808	150	4	0	38596	\N
10809	2604	23	0	38608	\N
10809	149	126	0	38711	\N
10809	2605	127	0	38712	\N
10814	115	2	0	38729	\N
10814	636	3	0	38730	\N
10816	528	10	0	38753	\N
10816	2606	11	0	38754	\N
10823	82	3	0	3831	\N
10823	810	4	0	38785	\N
10826	27	3	0	38793	\N
10826	1270	4	0	38794	\N
10828	92	4	0	38803	\N
10828	2607	5	0	38804	\N
10831	167	2	0	36903	\N
10831	168	3	0	36904	\N
10833	1470	6	0	38827	\N
10833	2608	7	0	38828	\N
10836	453	10	0	38860	\N
10836	1452	11	0	38861	\N
10841	391	7	0	38760	\N
10841	2611	8	0	38884	\N
10844	125	6	0	38900	\N
10844	2341	7	0	38901	\N
10851	92	2	0	38950	\N
10851	93	3	0	38951	\N
10556	40	3	0	37352	\N
10556	128	4	0	37356	\N
10559	49	2	0	37430	\N
10559	328	3	0	37431	\N
10564	1470	2	0	37454	\N
10564	1565	3	0	37455	\N
10571	56	2	0	37475	\N
10571	169	3	0	37476	\N
10573	110	3	0	36644	\N
10573	905	4	0	37484	\N
10576	16	2	0	37503	\N
10576	155	3	0	37504	\N
10579	360	2	0	37121	\N
10579	510	3	0	37122	\N
10584	66	2	0	37539	\N
10584	40	3	0	37540	\N
10588	233	2	0	37556	\N
10588	910	3	0	37557	\N
10591	10	4	0	37530	\N
10591	600	5	0	37567	\N
10593	1	2	0	37574	\N
10593	112	3	0	37575	\N
10598	94	2	0	37600	\N
10598	95	3	0	37601	\N
10603	75	2	0	37466	\N
10603	159	3	0	37467	\N
10605	373	2	0	37618	\N
10605	1504	3	0	37619	\N
10607	1	2	0	37574	\N
10607	112	3	0	37575	\N
10612	16	2	0	37503	\N
10612	155	3	0	37504	\N
10614	20	3	0	35538	\N
10614	1931	4	0	37658	\N
10622	10	6	0	37588	\N
10622	426	7	0	37698	\N
10624	1	2	0	37705	\N
10624	112	3	0	37706	\N
10629	451	1	0	37723	\N
10629	584	2	0	37724	\N
10631	451	2	0	37723	\N
10631	452	3	0	37729	\N
10639	198	2	0	37342	\N
10639	746	3	0	37777	\N
10641	1	2	0	37790	\N
10641	112	3	0	37791	\N
10646	10	2	0	37833	\N
10646	29	3	0	37834	\N
10649	290	2	0	37839	\N
10649	575	3	0	37840	\N
10655	260	4	0	37867	\N
10655	538	5	0	37868	\N
10660	71	1	0	36638	\N
10660	72	2	0	37886	\N
10667	235	5	0	37913	\N
10667	2572	6	0	37914	\N
10670	140	6	0	37930	\N
10670	1730	7	0	37931	\N
10673	110	8	0	37933	\N
10673	2574	9	0	37939	\N
10679	212	2	0	37964	\N
10679	566	3	0	37965	\N
10682	391	2	0	37843	\N
10682	406	3	0	37844	\N
10684	16	2	0	37879	\N
10684	155	3	0	37980	\N
10692	528	2	0	38009	\N
10692	613	3	0	38010	\N
10693	2578	0	0	38011	\N
10709	290	1	0	38101	\N
10709	291	2	0	38102	\N
10711	189	2	0	38107	\N
10711	311	3	0	38108	\N
10718	595	2	0	38123	\N
10718	768	3	0	38124	\N
10720	16	2	0	38129	\N
10720	155	3	0	38130	\N
10729	2592	2	0	38185	\N
10729	2593	3	0	38186	\N
10732	75	2	0	37466	\N
10732	159	3	0	37467	\N
10733	16	3	0	38195	\N
10733	359	4	0	38196	\N
10736	10	4	0	38173	\N
10736	600	5	0	38212	\N
10739	12	2	0	38229	\N
10739	433	3	0	38230	\N
10741	228	4	0	37855	\N
10741	1631	5	0	37856	\N
10746	156	2	0	36989	\N
10746	571	3	0	36990	\N
10748	79	3	0	37123	\N
10748	272	4	0	38271	\N
10754	125	2	0	38308	\N
10754	188	3	0	38309	\N
10756	264	2	0	38314	\N
10756	265	3	0	38315	\N
10759	233	4	0	38330	\N
10759	1689	5	0	38331	\N
10762	18	4	0	38335	\N
10762	590	5	0	38336	\N
10763	1	2	0	38227	\N
10763	112	3	0	38228	\N
10767	75	4	0	37466	\N
10767	172	5	0	38359	\N
10768	1	2	0	38364	\N
10768	283	3	0	38365	\N
10773	202	4	0	38386	\N
10773	1149	5	0	38387	\N
10776	173	5	0	38007	\N
10776	2098	6	0	38409	\N
10778	391	3	0	38420	\N
10778	581	4	0	38421	\N
10780	10	3	0	38357	\N
10780	347	4	0	38424	\N
10785	56	4	0	38333	\N
10785	2600	5	0	38451	\N
10791	2	6	0	38498	\N
10791	1566	7	0	38499	\N
10794	230	5	0	38511	\N
10794	2601	6	0	38512	\N
10796	1470	2	0	38519	\N
10796	1565	3	0	38520	\N
10799	1470	2	0	38519	\N
10799	1565	3	0	38520	\N
10801	262	4	0	38274	\N
10801	1015	5	0	38540	\N
10804	79	4	0	37123	\N
10804	589	5	0	38581	\N
10806	96	3	0	38594	\N
10806	834	4	0	38595	\N
10810	353	3	0	37642	\N
10810	1854	4	0	38719	\N
10812	353	2	0	37642	\N
10812	755	3	0	38722	\N
10818	1	3	0	38434	\N
10818	48	4	0	38762	\N
10820	86	2	0	38422	\N
10820	509	3	0	38769	\N
10822	82	3	0	2245	\N
10822	810	4	0	38778	\N
10827	27	3	0	38793	\N
10827	1270	4	0	38794	\N
10829	82	1	0	38807	\N
10829	83	2	0	38808	\N
10838	75	9	0	37466	\N
10838	2610	10	0	38863	\N
10839	391	2	0	38760	\N
10839	406	3	0	38868	\N
10842	173	4	0	38893	\N
10842	1046	5	0	38894	\N
10847	391	5	0	38929	\N
10847	1511	6	0	38930	\N
10779	86	3	0	38422	\N
10779	2596	4	0	38423	\N
10781	69	4	0	36987	\N
10781	1721	5	0	38433	\N
10788	156	4	0	36989	\N
10788	2543	5	0	37167	\N
10792	10	6	0	38500	\N
10792	426	7	0	38501	\N
10795	488	5	0	38513	\N
10795	2602	6	0	38514	\N
10797	1470	2	0	38519	\N
10797	1565	3	0	38520	\N
10807	96	3	0	38594	\N
10807	834	4	0	38595	\N
10811	60	3	0	38720	\N
10811	643	4	0	38721	\N
10813	228	2	0	38727	\N
10813	511	3	0	38728	\N
10815	18	1	0	38731	\N
10815	19	2	0	38732	\N
10821	241	2	0	38770	\N
10821	281	3	0	38771	\N
10825	391	3	0	38760	\N
10825	581	4	0	38761	\N
10830	58	2	0	37630	\N
10830	665	3	0	37631	\N
10832	10	4	0	38813	\N
10832	600	5	0	38814	\N
10835	1	0	0	38839	\N
10840	10	2	0	38813	\N
10840	29	3	0	38869	\N
10843	14	6	0	37067	\N
10843	1267	7	0	38899	\N
10845	210	7	0	33346	\N
10845	2612	8	0	38912	\N
10848	2185	5	0	30965	\N
10848	2613	6	0	38931	\N
10850	322	2	0	38948	\N
10850	833	3	0	38949	\N
10852	1	4	0	38960	\N
10852	422	5	0	38961	\N
10853	18	6	0	38731	\N
10853	2342	7	0	38974	\N
10854	2603	112	0	39032	\N
10854	244	116	0	39033	\N
10854	815	117	0	39034	\N
10855	10	2	0	39039	\N
10855	29	3	0	39040	\N
10856	79	2	0	39045	\N
10856	80	3	0	39046	\N
10857	200	2	0	39047	\N
10857	887	3	0	39048	\N
10858	167	2	0	36903	\N
10858	168	3	0	36904	\N
10859	181	2	0	39049	\N
10859	769	3	0	39050	\N
10860	96	4	0	38594	\N
10860	2055	5	0	39059	\N
10861	117	4	0	36648	\N
10861	139	5	0	39060	\N
10862	2615	4	0	39061	\N
10862	2616	5	0	39062	\N
10863	1021	4	0	33150	\N
10863	1047	5	0	39063	\N
10864	1	2	0	39068	\N
10864	112	3	0	39069	\N
10865	367	2	0	39070	\N
10865	651	3	0	39071	\N
10866	256	3	0	39078	\N
10866	1488	4	0	39079	\N
10867	6	3	0	39080	\N
10867	2140	4	0	39081	\N
10868	360	5	0	39092	\N
10868	2617	6	0	39093	\N
10869	391	5	0	38929	\N
10869	1511	6	0	38930	\N
10870	360	41	0	39092	\N
10870	2618	42	0	39094	\N
10871	324	0	0	39095	\N
10872	264	2	0	39100	\N
10872	265	3	0	39101	\N
10873	324	2	0	39095	\N
10873	486	3	0	39102	\N
10874	242	2	0	37699	\N
10874	620	3	0	39103	\N
10875	228	5	0	38727	\N
10875	2619	6	0	39114	\N
10876	90	5	0	37285	\N
10876	1274	6	0	39115	\N
10877	10	5	0	39116	\N
10877	998	6	0	39117	\N
10878	228	2	0	39122	\N
10878	511	3	0	39123	\N
10879	2620	6	0	39130	\N
10879	2621	7	0	39131	\N
10880	2622	5	0	39136	\N
10880	2620	6	0	39137	\N
10881	2620	4	0	39130	\N
10881	2623	5	0	39138	\N
10882	2622	5	0	39136	\N
10882	2620	6	0	39137	\N
10883	2622	5	0	39136	\N
10883	2620	6	0	39137	\N
10884	2622	5	0	39136	\N
10884	2620	6	0	39137	\N
10885	2622	5	0	39136	\N
10885	2620	6	0	39137	\N
10886	121	4	0	36384	\N
10886	848	5	0	39147	\N
10887	121	4	0	36384	\N
10887	848	5	0	39147	\N
10888	121	4	0	36384	\N
10888	848	5	0	39147	\N
10889	96	2	0	38594	\N
10889	482	3	0	39152	\N
10890	10	3	0	39116	\N
10890	347	4	0	39155	\N
10891	402	5	0	39165	\N
10891	2624	6	0	39166	\N
10892	402	5	0	39165	\N
10892	2624	6	0	39166	\N
10893	488	2	0	38513	\N
10893	729	3	0	39171	\N
10894	90	2	0	37285	\N
10894	91	3	0	37286	\N
10895	18	46	0	39172	\N
10895	2625	47	0	39173	\N
10896	2578	7	0	38011	\N
10896	2626	8	0	39188	\N
10897	2627	7	0	39189	\N
10897	2628	8	0	39190	\N
10898	10	7	0	39191	\N
10898	1776	8	0	39192	\N
10899	10	1	0	39191	\N
10899	11	2	0	39195	\N
10900	16	2	0	39200	\N
10900	155	3	0	38249	\N
10901	10	5	0	39211	\N
10901	998	6	0	39212	\N
10902	121	2	0	39217	\N
10902	625	3	0	39218	\N
10903	151	11	0	37853	\N
10903	2629	12	0	39241	\N
10904	56	7	0	39256	\N
10904	2630	8	0	39257	\N
10905	67	4	0	35362	\N
10905	2443	5	0	35363	\N
10906	10	4	0	39266	\N
10906	600	5	0	39267	\N
10907	266	5	0	39278	\N
10907	2631	6	0	39279	\N
10908	60	1	0	39281	\N
10908	1451	2	0	39282	\N
10909	60	3	0	39281	\N
10909	2632	4	0	39287	\N
10910	10	4	0	39292	\N
10910	600	5	0	39293	\N
10911	2351	2	0	39298	\N
10911	2352	3	0	39299	\N
10916	322	1	0	39327	\N
10916	323	2	0	39328	\N
10923	162	2	0	39360	\N
10923	64	5	0	39365	\N
10923	2519	6	1	39366	\N
10923	2638	6	0	39367	\N
10924	169	2	0	39368	\N
10924	56	5	0	39369	\N
10924	169	6	0	39370	\N
10930	135	2	0	39388	\N
10930	2643	3	1	39389	\N
10930	2503	3	0	39390	\N
10933	262	2	0	39386	\N
10933	731	3	0	39395	\N
10936	241	4	0	38770	\N
10936	686	5	0	39402	\N
10937	322	2	0	39407	\N
10937	833	3	0	39408	\N
10940	110	2	0	37933	\N
10940	111	3	0	39417	\N
10942	198	2	0	39424	\N
10942	746	3	0	39425	\N
10944	96	2	0	38594	\N
10944	482	3	0	39152	\N
10956	10	1	0	39400	\N
10956	11	2	0	39476	\N
10958	18	51	0	39487	\N
10958	2651	52	0	39488	\N
10963	40	2	0	39519	\N
10963	66	3	0	39520	\N
10969	51	2	0	39530	\N
10969	524	3	0	39531	\N
10972	110	3	0	37933	\N
10972	905	4	0	39543	\N
10977	44	2	0	39564	\N
10977	161	3	0	39565	\N
10982	264	2	0	39584	\N
10982	265	3	0	39585	\N
10984	449	2	0	39592	\N
10984	583	3	0	39593	\N
10987	102	0	0	37742	\N
10989	2351	4	0	39298	\N
10989	2571	5	0	39619	\N
10994	326	4	0	39644	\N
10994	1638	5	0	39645	\N
10997	198	2	0	39424	\N
10997	746	3	0	39425	\N
11003	79	0	0	36896	\N
11005	79	0	0	36896	\N
11007	1	4	0	39662	\N
11007	422	5	0	39677	\N
11012	92	6	0	39694	\N
11012	2667	7	0	39695	\N
11014	290	6	0	39457	\N
11014	2668	7	0	39712	\N
11016	10	13	0	39523	\N
11016	2669	14	0	39713	\N
11019	14	2	0	37067	\N
11019	383	3	0	39728	\N
11024	1	1	0	39662	\N
11024	53	2	0	39663	\N
11027	212	10	0	39767	\N
11027	2671	11	0	39768	\N
11031	30	2	0	39783	\N
11031	31	3	0	39784	\N
11036	431	2	0	39810	\N
11036	531	3	0	39811	\N
11038	10	2	0	39523	\N
11038	29	3	0	39524	\N
11040	2351	2	0	39823	\N
11040	2352	3	0	39824	\N
11045	1096	2	0	39831	\N
11045	2158	3	0	39832	\N
11047	147	2	0	33813	\N
11047	516	3	0	36221	\N
11054	1	4	0	39662	\N
11054	422	5	0	39677	\N
11056	367	4	0	39070	\N
11056	1231	5	0	39874	\N
11057	367	4	0	39070	\N
11057	2678	5	1	39875	\N
11057	2677	5	0	39876	\N
11058	322	0	0	39572	\N
11066	69	2	0	38458	\N
11066	500	3	0	39529	\N
11071	1	2	0	39662	\N
11071	112	3	0	39934	\N
11073	100	2	0	35410	\N
11073	101	3	0	35411	\N
11075	10	2	0	39970	\N
11075	29	3	0	39971	\N
11080	1	2	0	39662	\N
11080	112	3	0	39934	\N
11082	56	4	0	39996	\N
11082	1145	5	0	39997	\N
11084	75	2	0	37466	\N
11084	159	3	0	37467	\N
11087	40	4	0	40020	\N
11087	564	5	0	40021	\N
11095	40	2	0	40055	\N
11095	66	3	0	40056	\N
11099	192	2	0	37669	\N
11099	838	3	0	37670	\N
11104	2687	49	0	40095	\N
11104	18	79	0	40106	\N
11104	2688	80	0	40107	\N
11108	392	1	0	40127	\N
11108	391	3	0	40128	\N
11108	392	4	0	40129	\N
11116	451	4	0	40159	\N
11116	2692	5	0	40160	\N
11119	288	4	0	40170	\N
11119	1710	5	0	40171	\N
11122	1	2	0	39662	\N
11122	112	3	0	39934	\N
11124	230	2	0	39825	\N
11124	231	3	0	39826	\N
11126	391	2	0	40194	\N
11126	406	3	0	40129	\N
11131	2655	65	0	40209	\N
11131	242	126	0	40216	\N
11131	2694	127	0	40217	\N
11133	597	2	0	33809	\N
11133	767	3	0	36222	\N
11136	147	2	0	33813	\N
11136	516	3	0	36221	\N
11141	94	2	0	40252	\N
11141	95	3	0	40253	\N
11143	40	3	0	40055	\N
11143	128	4	0	40262	\N
11146	1	4	0	40274	\N
11146	422	5	0	40275	\N
11150	60	0	0	40285	\N
11155	132	2	0	40197	\N
11155	133	3	0	40198	\N
11162	40	0	0	38117	\N
11165	224	2	0	38436	\N
11165	508	3	0	40347	\N
11167	40	0	0	40348	\N
11169	56	0	0	40157	\N
11172	2699	4	0	40359	\N
11172	2700	5	0	40360	\N
11175	402	4	0	40357	\N
11175	1378	5	0	40358	\N
11177	2701	108	0	40363	\N
11177	1021	126	0	40364	\N
11177	2702	127	0	40365	\N
11179	793	4	0	40374	\N
11179	1986	5	0	40375	\N
11182	164	4	0	40386	\N
11182	1582	5	0	40387	\N
11186	841	2	0	40010	\N
11186	1161	3	0	40395	\N
11197	10	2	0	40240	\N
11197	29	3	0	40394	\N
10912	135	2	0	39300	\N
10912	196	3	0	39301	\N
10914	1	8	0	39321	\N
10914	1982	9	0	39322	\N
10919	30	8	0	39347	\N
10919	2635	9	0	39348	\N
10922	38	2	0	1914	\N
10922	39	3	0	39355	\N
10925	66	2	0	37883	\N
10925	40	3	0	38118	\N
10928	793	8	0	35543	\N
10928	2640	9	1	39384	\N
10928	2639	9	0	30517	\N
10928	2641	10	0	39385	\N
10931	793	2	0	35543	\N
10934	186	2	0	35442	\N
10934	696	3	0	35443	\N
10938	123	2	0	39413	\N
10938	384	3	0	39414	\N
10945	96	2	0	38594	\N
10945	482	3	0	39152	\N
10950	145	19	0	39453	\N
10950	2646	20	0	39454	\N
10954	2648	6	0	39471	\N
10959	27	3	0	39495	\N
10959	2652	4	0	39496	\N
10964	365	2	0	39521	\N
10964	519	3	0	39522	\N
10966	69	2	0	38458	\N
10966	500	3	0	39529	\N
10970	424	2	0	39532	\N
10970	520	3	0	39533	\N
10975	113	2	0	39551	\N
10975	114	3	0	39552	\N
10980	1	3	0	39576	\N
10980	1114	4	0	39577	\N
10983	316	2	0	39586	\N
10983	332	3	0	39587	\N
10985	242	6	0	39606	\N
10985	1630	7	0	39607	\N
10992	841	4	0	39631	\N
10992	2661	6	0	39634	\N
10999	79	1	0	39511	\N
10999	81	2	0	39661	\N
11004	56	1	0	39666	\N
11004	57	2	0	39667	\N
11008	170	4	0	37841	\N
11008	171	5	0	39678	\N
11010	40	6	0	39690	\N
11010	1192	7	0	39691	\N
11015	290	6	0	39457	\N
11015	2668	7	0	39712	\N
11017	10	2	0	39718	\N
11017	29	3	0	39719	\N
11029	156	2	0	39574	\N
11029	571	3	0	39774	\N
11032	123	2	0	39789	\N
11032	384	3	0	39790	\N
11034	40	2	0	39690	\N
11034	66	3	0	39807	\N
11037	12	2	0	39808	\N
11037	433	3	0	39812	\N
11041	230	2	0	39825	\N
11041	231	3	0	39826	\N
11049	402	2	0	39843	\N
11049	1148	3	0	39844	\N
11062	10	4	0	39523	\N
11062	600	5	0	39904	\N
11064	77	2	0	39909	\N
11064	216	3	0	39910	\N
11067	362	2	0	39917	\N
11067	420	3	0	39918	\N
11078	56	3	0	39982	\N
11078	475	4	0	39983	\N
11085	10	3	0	39970	\N
11085	347	4	0	40009	\N
11090	56	2	0	40036	\N
11090	169	3	0	40037	\N
11096	2	2	0	38498	\N
11096	131	3	0	40057	\N
11102	151	9	0	40074	\N
11102	2686	10	0	40086	\N
11106	75	5	0	40087	\N
11106	2690	6	0	40119	\N
11109	199	1	0	40130	\N
11109	198	3	0	40131	\N
11109	199	4	0	39425	\N
11113	94	4	0	39426	\N
11113	1706	5	0	40156	\N
11120	212	2	0	39767	\N
11120	566	3	0	40176	\N
11127	288	2	0	40195	\N
11127	289	3	0	40196	\N
11129	841	4	0	40010	\N
11129	900	5	0	40207	\N
11134	38	2	0	1914	\N
11134	39	3	0	39355	\N
11144	10	4	0	40240	\N
11144	600	5	0	40271	\N
11147	391	4	0	40276	\N
11147	539	5	0	40277	\N
11148	1	2	0	40274	\N
11148	112	3	0	40282	\N
11153	2578	2	0	40306	\N
11153	2696	3	0	40307	\N
11156	79	3	0	39511	\N
11156	272	4	0	40318	\N
11158	391	2	0	40276	\N
11158	406	3	0	40323	\N
11163	258	6	0	39980	\N
11163	2697	7	0	40336	\N
11166	206	2	0	37464	\N
11166	693	3	0	37465	\N
11168	10	0	0	40240	\N
11170	402	4	0	40357	\N
11170	1378	5	0	40358	\N
11176	75	4	0	40361	\N
11176	172	5	0	40362	\N
11183	164	0	0	40386	\N
11189	62	3	0	38113	\N
11189	2703	4	0	40402	\N
11192	2	2	0	38498	\N
11192	131	3	0	40057	\N
11194	119	2	0	40414	\N
11194	891	3	0	40415	\N
11196	391	2	0	40421	\N
11196	406	3	0	40422	\N
11199	40	2	0	40440	\N
11199	66	3	0	40441	\N
11201	324	2	0	39095	\N
11201	486	3	0	39102	\N
11204	597	6	0	33809	\N
11204	2705	7	0	40469	\N
11211	10	3	0	40442	\N
11211	465	4	0	40500	\N
11215	264	3	0	40531	\N
11215	1748	4	0	40532	\N
11218	56	2	0	40157	\N
11218	169	3	0	40553	\N
11223	336	4	0	40144	\N
11223	2285	5	0	40579	\N
11229	40	5	0	40616	\N
11229	2714	6	0	40617	\N
11231	727	5	0	6088	\N
11231	2716	6	0	40619	\N
11234	30	6	0	40636	\N
11234	2719	7	0	40637	\N
11236	290	2	0	40643	\N
11236	1909	3	0	40644	\N
11241	1	6	0	40604	\N
11241	2723	7	0	40669	\N
11244	353	4	0	37642	\N
10931	2645	3	1	138448	\N
10992	2665	5	1	43754	\N
10913	2633	2	0	39302	\N
10913	18	53	0	39307	\N
10913	2634	54	0	39308	\N
10918	10	2	0	39331	\N
10918	29	3	0	39332	\N
10921	2636	2	0	39353	\N
10921	2637	3	0	39354	\N
10926	64	1	0	39371	\N
10926	65	2	0	39372	\N
10927	10	5	0	39331	\N
10927	2042	6	0	39379	\N
10929	262	8	0	39386	\N
10929	2642	9	0	39387	\N
10932	137	1	0	39393	\N
10932	138	2	0	39394	\N
10941	402	2	0	39422	\N
10941	1148	3	0	39423	\N
10946	16	2	0	39432	\N
10946	155	3	0	39433	\N
10949	1	6	0	39321	\N
10949	523	7	0	39452	\N
10953	1	1	0	39321	\N
10953	53	2	0	39459	\N
10961	2	7	0	38498	\N
10961	2654	8	0	39513	\N
10965	10	2	0	39523	\N
10965	29	3	0	39524	\N
10968	51	2	0	39530	\N
10968	524	3	0	39531	\N
10974	113	2	0	39551	\N
10974	114	3	0	39552	\N
10976	40	3	0	39519	\N
10976	2656	4	0	39559	\N
10979	156	3	0	39574	\N
10979	2658	4	0	39575	\N
10981	167	2	0	39582	\N
10981	168	3	0	39583	\N
10986	102	0	0	37742	\N
10991	2662	4	0	39628	\N
10991	2663	4	0	39629	\N
10991	900	5	0	39630	\N
10996	235	2	0	37913	\N
10996	1061	3	0	39656	\N
11001	1	1	0	39662	\N
11001	53	2	0	39663	\N
11002	16	1	0	39664	\N
11002	17	2	0	39665	\N
11009	233	4	0	38330	\N
11009	1689	5	0	38331	\N
11018	96	4	0	38594	\N
11018	2055	5	0	39059	\N
11021	10	4	0	39731	\N
11021	600	5	0	39732	\N
11023	365	1	0	39743	\N
11023	366	2	0	39744	\N
11026	210	10	0	39765	\N
11026	2670	11	0	39766	\N
11033	2673	22	0	39798	\N
11033	18	99	0	39800	\N
11033	2675	100	1	39801	\N
11033	2674	100	0	39802	\N
11043	230	2	0	39825	\N
11043	231	3	0	39826	\N
11044	142	2	0	39829	\N
11044	656	3	0	39830	\N
11046	597	2	0	33809	\N
11046	767	3	0	36222	\N
11051	402	2	0	39843	\N
11051	1148	3	0	39844	\N
11053	58	4	0	39863	\N
11053	1660	5	0	39864	\N
11061	391	6	0	38929	\N
11061	2680	7	0	39895	\N
11065	273	2	0	39911	\N
11065	1159	3	0	39912	\N
11070	365	2	0	39743	\N
11070	519	3	0	39933	\N
11072	27	2	0	39893	\N
11072	619	3	0	39939	\N
11077	258	3	0	39980	\N
11077	2683	4	0	39981	\N
11079	40	2	0	39690	\N
11079	66	3	0	39807	\N
11089	402	1	0	40030	\N
11089	403	2	0	40031	\N
11092	16	3	0	40046	\N
11092	359	4	0	40047	\N
11094	210	2	0	39765	\N
11094	458	3	0	40054	\N
11098	192	2	0	37669	\N
11098	838	3	0	37670	\N
11101	69	9	0	40084	\N
11101	2685	10	0	40085	\N
11105	14	5	0	37067	\N
11105	2689	6	0	40118	\N
11107	437	1	0	40122	\N
11107	113	3	0	40125	\N
11107	437	4	0	40126	\N
11112	268	5	0	40146	\N
11112	642	6	0	40147	\N
11115	451	4	0	40159	\N
11115	2692	5	0	40160	\N
11121	44	2	0	40181	\N
11121	161	3	0	40182	\N
11130	16	4	0	40046	\N
11130	380	5	0	40208	\N
11135	595	2	0	40226	\N
11135	768	3	0	40227	\N
11138	300	6	0	40242	\N
11138	2695	7	0	40243	\N
11140	353	2	0	37642	\N
11140	755	3	0	38722	\N
11149	82	2	0	40283	\N
11149	343	3	0	40284	\N
11152	92	2	0	40300	\N
11152	93	3	0	40301	\N
11157	40	0	0	38117	\N
11160	40	0	0	38117	\N
11164	1361	2	0	40341	\N
11164	2698	3	0	40342	\N
11171	402	4	0	40357	\N
11171	1378	5	0	40358	\N
11174	451	4	0	40159	\N
11174	2692	5	0	40160	\N
11181	79	4	0	40384	\N
11181	589	5	0	40385	\N
11185	10	2	0	40240	\N
11185	29	3	0	40394	\N
11188	88	2	0	35394	\N
11188	154	3	0	35395	\N
11190	320	3	0	32251	\N
11190	797	4	0	40403	\N
11200	10	2	0	40442	\N
11200	29	3	0	40443	\N
11202	88	3	0	40454	\N
11202	580	4	0	40455	\N
11205	147	6	0	33813	\N
11205	2706	7	0	40470	\N
11209	40	2	0	40486	\N
11209	66	3	0	40487	\N
11213	285	10	0	40522	\N
11213	2711	11	0	40523	\N
11221	112	2	0	40565	\N
11221	1	3	0	40566	\N
11224	228	4	0	40580	\N
11224	1631	5	0	40581	\N
11226	10	2	0	40442	\N
11226	29	3	0	40443	\N
11230	2715	6	0	40618	\N
11235	14	6	0	37067	\N
11235	2720	7	0	40638	\N
11237	121	2	0	40645	\N
11237	2498	3	0	40646	\N
11239	135	2	0	39388	\N
11239	2722	3	0	40648	\N
11245	14	4	0	40693	\N
10915	10	8	0	39323	\N
10915	1772	9	0	39324	\N
10917	40	2	0	38117	\N
10917	66	3	0	38118	\N
10920	38	1	0	1914	\N
10920	399	2	0	1915	\N
10935	10	4	0	39400	\N
10935	600	5	0	39401	\N
10939	142	2	0	39415	\N
10939	656	3	0	39416	\N
10943	94	2	0	39426	\N
10943	95	3	0	39427	\N
10947	316	1	0	39436	\N
10947	317	2	0	39437	\N
10948	212	6	0	39450	\N
10948	754	7	0	39451	\N
10951	212	6	0	39450	\N
10951	754	7	0	39451	\N
10952	290	1	0	39457	\N
10952	291	2	0	39458	\N
10955	35	5	0	39472	\N
10955	2649	6	0	39473	\N
10957	156	4	0	39485	\N
10957	2650	5	0	39486	\N
10960	79	7	0	39511	\N
10960	2653	8	0	39512	\N
10962	242	7	0	37699	\N
10962	2655	8	0	39514	\N
10967	69	2	0	38458	\N
10967	500	3	0	39529	\N
10971	132	1	0	38257	\N
10971	455	2	0	39536	\N
10973	110	4	0	37933	\N
10973	1708	5	0	39546	\N
10978	322	3	0	39572	\N
10978	2657	4	0	39573	\N
10988	2351	4	0	39298	\N
10988	2661	6	0	39618	\N
10990	2351	4	0	39298	\N
10990	2571	5	0	39619	\N
10993	841	4	0	39631	\N
10993	900	5	0	39635	\N
10995	40	2	0	39650	\N
10995	66	3	0	39651	\N
10998	16	2	0	39657	\N
10998	155	3	0	39658	\N
11000	79	0	0	36896	\N
11006	10	3	0	39523	\N
11006	347	4	0	39672	\N
11011	424	6	0	39692	\N
11011	2666	7	0	39693	\N
11013	266	1	0	39698	\N
11013	267	2	0	39699	\N
11020	16	2	0	39729	\N
11020	155	3	0	39730	\N
11022	96	3	0	39739	\N
11022	834	4	0	39740	\N
11025	56	1	0	39666	\N
11025	57	2	0	39667	\N
11028	316	10	0	39586	\N
11028	2672	11	0	39769	\N
11030	123	2	0	39413	\N
11030	384	3	0	39414	\N
11035	12	1	0	39808	\N
11035	13	2	0	39809	\N
11039	110	2	0	39817	\N
11039	111	3	0	39818	\N
11042	20	2	0	39827	\N
11042	702	3	0	39828	\N
11048	595	2	0	39837	\N
11048	768	3	0	39838	\N
11050	402	2	0	39843	\N
11050	1148	3	0	39844	\N
11052	167	4	0	39853	\N
11052	1011	5	0	39854	\N
11055	58	42	0	39863	\N
11055	2676	43	0	39873	\N
11059	258	2	0	37897	\N
11059	585	3	0	37898	\N
11060	27	6	0	39893	\N
11060	2679	7	0	39894	\N
11063	1	4	0	39662	\N
11063	422	5	0	39677	\N
11068	453	2	0	39919	\N
11068	902	3	0	39920	\N
11069	56	3	0	39927	\N
11069	475	4	0	39928	\N
11074	2681	47	0	39952	\N
11074	100	126	0	39964	\N
11074	2682	127	0	39965	\N
11076	326	2	0	39972	\N
11076	747	3	0	39973	\N
11081	75	2	0	37466	\N
11081	159	3	0	37467	\N
11083	140	2	0	37930	\N
11083	487	3	0	40002	\N
11086	841	3	0	40010	\N
11086	2083	4	0	40011	\N
11088	290	2	0	40026	\N
11088	575	3	0	40027	\N
11091	10	3	0	40044	\N
11091	347	4	0	40045	\N
11093	86	2	0	40052	\N
11093	509	3	0	40053	\N
11097	449	2	0	40058	\N
11097	583	3	0	40059	\N
11100	151	10	0	40074	\N
11100	2684	11	0	40075	\N
11103	75	9	0	40087	\N
11103	2610	10	0	40088	\N
11110	26	1	0	40132	\N
11110	2	3	0	40133	\N
11110	26	4	0	40057	\N
11111	336	5	0	40144	\N
11111	2691	6	0	40145	\N
11114	56	4	0	40157	\N
11114	1145	5	0	40158	\N
11118	140	4	0	37930	\N
11118	1661	5	0	40169	\N
11123	142	2	0	40183	\N
11123	656	3	0	40184	\N
11125	46	78	0	110	\N
11125	2693	79	0	40189	\N
11128	132	2	0	40197	\N
11128	133	3	0	40198	\N
11132	264	2	0	39584	\N
11132	265	3	0	39585	\N
11137	10	6	0	40240	\N
11137	426	7	0	40241	\N
11139	1	2	0	39662	\N
11139	112	3	0	39934	\N
11142	170	2	0	40254	\N
11142	718	3	0	40255	\N
11145	4	4	0	40272	\N
11145	684	5	0	40273	\N
11151	290	4	0	40294	\N
11151	695	5	0	40295	\N
11154	2351	2	0	39823	\N
11154	2352	3	0	39824	\N
11159	40	0	0	38117	\N
11161	40	0	0	38117	\N
11173	451	4	0	40159	\N
11173	2692	5	0	40160	\N
11178	10	4	0	40240	\N
11178	600	5	0	40271	\N
11180	793	4	0	40374	\N
11180	1986	5	0	40375	\N
11184	251	4	0	40388	\N
11184	1610	5	0	40389	\N
11187	88	2	0	35394	\N
11187	154	3	0	35395	\N
11191	16	2	0	40408	\N
11191	155	3	0	40409	\N
11193	841	2	0	40010	\N
11193	1161	3	0	40395	\N
11195	67	2	0	35362	\N
11195	68	3	0	40416	\N
11198	2351	4	0	39823	\N
11198	2571	5	0	40435	\N
11207	125	6	0	38900	\N
11207	2708	7	0	40472	\N
11208	35	4	0	39472	\N
11208	2709	5	0	40481	\N
11217	113	4	0	40547	\N
11217	699	5	0	40548	\N
11220	1858	2	0	25261	\N
11220	2712	3	0	40560	\N
11222	200	2	0	39047	\N
11222	887	3	0	39048	\N
11225	1	2	0	40586	\N
11225	112	3	0	40587	\N
11228	1	5	0	40604	\N
11228	2052	6	0	40605	\N
11233	10	6	0	40634	\N
11233	2718	7	0	40635	\N
11238	137	2	0	39393	\N
11238	2721	3	0	40647	\N
11240	16	3	0	40655	\N
11240	1045	4	0	40656	\N
11243	35	2	0	40674	\N
11243	1191	3	0	40675	\N
11248	58	5	0	40708	\N
11248	2726	6	0	40709	\N
11251	73	15	0	40742	\N
11251	2728	16	0	40743	\N
11253	40	8	0	40776	\N
11253	2730	9	0	40777	\N
11256	1	0	0	40796	\N
11260	488	24	0	40848	\N
11260	2733	25	0	40849	\N
11269	79	8	0	40997	\N
11269	2739	9	0	40998	\N
11273	30	2	0	40636	\N
11273	1127	3	0	41008	\N
11276	1	8	0	40796	\N
11276	2742	9	0	41030	\N
11278	262	2	0	39386	\N
11278	2743	3	0	41037	\N
11280	165	1	0	41049	\N
11280	164	5	0	41056	\N
11280	1807	6	0	41057	\N
11282	194	1	0	41062	\N
11282	6	5	0	41063	\N
11282	2750	6	0	41064	\N
11289	424	2	0	39692	\N
11289	2755	3	0	41092	\N
11291	235	2	0	37913	\N
11291	2757	3	0	41098	\N
11294	290	4	0	40643	\N
11294	2759	5	0	41118	\N
11302	316	1	0	41135	\N
11302	317	2	0	41136	\N
11304	402	2	0	40357	\N
11304	2760	3	0	41143	\N
11306	16	1	0	41151	\N
11306	1087	2	0	41152	\N
11308	16	1	0	41151	\N
11308	1087	2	0	41152	\N
11316	16	1	0	41184	\N
11316	1087	2	0	41185	\N
11319	149	2	0	41191	\N
11319	1379	3	0	41192	\N
11323	42	1	0	41203	\N
11323	43	2	0	41204	\N
11328	365	3	0	41172	\N
11328	2769	4	0	41223	\N
11331	1	2	0	41233	\N
11331	283	3	0	41234	\N
11336	206	2	0	37464	\N
11336	2773	3	0	41264	\N
11339	181	4	0	41277	\N
11339	2356	5	0	41278	\N
11346	264	2	0	40531	\N
11346	2780	3	0	41315	\N
11359	206	1	0	41362	\N
11359	207	2	0	41363	\N
11360	88	10	0	41384	\N
11360	2787	11	0	41385	\N
11362	62	2	0	41392	\N
11362	2191	3	0	41393	\N
11365	316	4	0	41408	\N
11365	2790	5	0	41409	\N
11368	140	6	0	37930	\N
11368	2792	7	0	41429	\N
11370	16	2	0	41184	\N
11370	388	3	0	41436	\N
11373	40	4	0	41307	\N
11373	2796	5	0	41452	\N
11376	115	2	0	41463	\N
11376	2797	3	0	41464	\N
11379	1470	4	0	41473	\N
11379	2798	5	0	41474	\N
11380	71	2	0	41481	\N
11380	1125	3	0	41482	\N
11383	268	2	0	41490	\N
11383	2800	3	0	41491	\N
11385	2594	2	0	41496	\N
11385	2801	3	0	41497	\N
11387	10	1	0	41461	\N
11387	1416	2	0	41501	\N
11390	97	1	0	41514	\N
11390	96	5	0	41515	\N
11390	2803	6	0	41516	\N
11397	1	2	0	41530	\N
11397	283	3	0	41531	\N
11398	1	1	0	41530	\N
11398	53	2	0	41534	\N
11404	1109	2	0	37707	\N
11404	2809	3	0	41565	\N
11409	12	3	0	39808	\N
11409	2812	4	0	41601	\N
11414	40	1	0	41613	\N
11414	1383	2	0	41614	\N
11416	6	2	0	41620	\N
11416	2805	3	0	41621	\N
11418	10	2	0	41626	\N
11418	275	3	0	41627	\N
11421	1	4	0	41643	\N
11421	2814	5	0	41644	\N
11423	79	2	0	41275	\N
11423	616	3	0	41354	\N
11426	2817	18	0	41660	\N
11426	119	126	0	41661	\N
11426	2818	127	1	41662	\N
11426	1970	127	0	41663	\N
11428	117	5	0	41674	\N
11428	2819	6	0	41675	\N
11431	42	4	0	41689	\N
11431	2821	5	0	41690	\N
11433	391	2	0	41697	\N
11433	1381	3	0	41698	\N
11438	117	2	0	41674	\N
11438	1257	3	0	41715	\N
11441	2825	93	0	41730	\N
11441	151	126	0	41731	\N
11441	2826	127	0	41732	\N
11447	14	1	0	41757	\N
11447	15	2	0	41758	\N
11451	40	4	0	41613	\N
11451	2796	5	0	41772	\N
11454	2432	3	0	35298	\N
11454	2831	4	0	41795	\N
11460	10	2	0	41819	\N
11460	275	3	0	41820	\N
11461	79	2	0	41825	\N
11461	616	3	0	41826	\N
11464	40	2	0	41842	\N
11464	282	3	0	41843	\N
11467	1	2	0	41656	\N
11467	283	3	0	41657	\N
11469	453	3	0	39919	\N
11469	2838	4	0	41862	\N
11203	1545	3	0	40456	\N
11203	2704	4	0	40457	\N
11206	595	6	0	40226	\N
11206	2707	7	0	40471	\N
11210	16	3	0	40493	\N
11210	1690	4	0	40494	\N
11212	362	3	0	39917	\N
11212	2710	4	0	40501	\N
11214	1	3	0	40274	\N
11214	48	4	0	40530	\N
11216	2351	2	0	40537	\N
11216	2352	3	0	40538	\N
11219	27	2	0	40558	\N
11219	619	3	0	40559	\N
11227	488	5	0	40602	\N
11227	2713	6	0	40603	\N
11232	132	5	0	40620	\N
11232	2717	6	0	40621	\N
11246	258	4	0	40695	\N
11246	2725	5	0	40696	\N
11250	73	15	0	40742	\N
11250	2728	16	0	40743	\N
11255	10	0	0	40634	\N
11258	137	0	0	39393	\N
11262	449	7	0	40058	\N
11262	2734	8	0	40866	\N
11266	167	36	0	40964	\N
11266	2737	37	0	40965	\N
11271	206	3	0	37464	\N
11271	2741	4	0	41001	\N
11275	79	1	0	40997	\N
11275	1126	2	0	41013	\N
11284	2752	2	0	41071	\N
11284	2753	2	0	41072	\N
11284	2751	3	0	41073	\N
11286	40	2	0	41078	\N
11286	282	3	0	41079	\N
11293	79	4	0	41108	\N
11293	2758	5	0	41109	\N
11297	1	2	0	41127	\N
11297	283	3	0	41128	\N
11303	235	2	0	41141	\N
11303	2757	3	0	41142	\N
11305	192	2	0	41132	\N
11305	2761	3	0	41148	\N
11313	290	2	0	41176	\N
11313	1909	3	0	41177	\N
11315	10	2	0	41182	\N
11315	275	3	0	41183	\N
11318	202	2	0	38767	\N
11318	2764	3	0	41190	\N
11321	27	2	0	41199	\N
11321	645	3	0	41200	\N
11327	242	1	0	41217	\N
11327	2768	2	0	41218	\N
11330	14	2	0	40693	\N
11330	1785	3	0	41232	\N
11333	60	4	0	41254	\N
11333	2771	5	0	41255	\N
11338	79	4	0	41275	\N
11338	2758	5	0	41276	\N
11340	74	1	0	41281	\N
11340	73	3	0	41284	\N
11340	2775	4	0	41210	\N
11343	40	6	0	41307	\N
11343	2777	7	0	41308	\N
11351	1	2	0	41336	\N
11351	283	3	0	41337	\N
11353	200	1	0	41342	\N
11353	2785	2	0	41343	\N
11355	79	2	0	41275	\N
11355	616	3	0	41354	\N
11357	16	1	0	41184	\N
11357	17	2	0	41359	\N
11361	391	10	0	41386	\N
11361	2788	11	0	41387	\N
11363	2	2	0	38498	\N
11363	2789	3	0	41398	\N
11369	322	6	0	41430	\N
11369	2793	7	0	41431	\N
11371	94	2	0	41437	\N
11371	2794	3	0	41438	\N
11381	192	2	0	41487	\N
11381	2761	3	0	41488	\N
11391	97	1	0	41514	\N
11391	96	5	0	41515	\N
11391	2803	6	0	41516	\N
11392	16	2	0	41521	\N
11392	388	3	0	41522	\N
11399	6	2	0	41539	\N
11399	2805	3	0	41540	\N
11407	200	4	0	41342	\N
11407	2811	5	0	41584	\N
11412	75	2	0	41262	\N
11412	284	3	0	41263	\N
11419	322	2	0	41628	\N
11419	1866	3	0	41629	\N
11424	119	2	0	40414	\N
11424	1879	3	0	41655	\N
11434	33	2	0	41699	\N
11434	2822	3	0	41700	\N
11436	42	1	0	41705	\N
11436	2823	2	0	41706	\N
11439	10	2	0	41695	\N
11439	275	3	0	41696	\N
11444	262	6	0	39386	\N
11444	2828	7	0	41752	\N
11448	1	1	0	41656	\N
11448	53	2	0	41759	\N
11452	2	4	0	41781	\N
11452	2830	5	0	41782	\N
11455	908	2	0	41800	\N
11455	2832	3	0	41801	\N
11457	10	2	0	41809	\N
11457	275	3	0	41810	\N
11462	2	2	0	41831	\N
11462	2789	3	0	41832	\N
11475	16	2	0	41898	\N
11475	388	3	0	41899	\N
11477	288	2	0	40195	\N
11477	2842	3	0	41904	\N
11498	151	89	0	41981	\N
11498	2855	90	0	41982	\N
11500	322	6	0	42000	\N
11500	2857	7	0	42001	\N
11505	94	3	0	41437	\N
11505	2864	4	0	42025	\N
11508	528	2	0	41937	\N
11508	2765	3	0	42041	\N
11515	200	2	0	42055	\N
11515	276	3	0	42056	\N
11517	235	2	0	41141	\N
11517	2757	3	0	41142	\N
11521	1	4	0	41932	\N
11521	2814	5	0	42070	\N
11525	2869	98	0	42098	\N
11525	145	126	0	42099	\N
11525	2870	127	0	42100	\N
11528	1	5	0	42125	\N
11528	2382	6	0	42126	\N
11530	40	2	0	42136	\N
11530	282	3	0	42137	\N
11533	411	5	0	42159	\N
11533	2874	6	0	42160	\N
11536	2876	7	0	42186	\N
11536	2877	7	0	42187	\N
11536	2878	8	1	42188	\N
11536	1970	8	0	42189	\N
11536	2879	9	0	42190	\N
11540	488	7	0	42194	\N
11540	2883	8	0	42195	\N
11542	10	2	0	41819	\N
11542	275	3	0	41820	\N
11545	391	2	0	41885	\N
11545	1381	3	0	42207	\N
11547	1109	2	0	42212	\N
11547	2809	3	0	42213	\N
11244	2724	5	0	40684	\N
11254	1	8	0	40794	\N
11254	2731	9	0	40795	\N
11261	10	7	0	40864	\N
11261	2274	8	0	40865	\N
11263	110	10	0	40887	\N
11263	2735	11	0	40888	\N
11274	273	2	0	41009	\N
11274	1413	3	0	41010	\N
11281	165	1	0	41049	\N
11281	164	5	0	41056	\N
11281	2747	6	1	41058	\N
11281	2746	6	0	41059	\N
11281	2749	7	1	41060	\N
11281	2748	7	0	41061	\N
11285	4	2	0	41069	\N
11285	2751	3	0	41070	\N
11287	2351	2	0	41084	\N
11287	2754	3	0	41085	\N
11292	241	2	0	38770	\N
11292	634	3	0	41099	\N
11295	40	2	0	41123	\N
11295	282	3	0	41124	\N
11298	44	2	0	40181	\N
11298	1910	3	0	41129	\N
11300	192	1	0	41132	\N
11300	193	2	0	41133	\N
11307	149	2	0	41155	\N
11307	1379	3	0	41156	\N
11309	164	3	0	40386	\N
11309	1807	4	0	41165	\N
11311	365	2	0	41172	\N
11311	615	3	0	41173	\N
11324	73	2	0	41209	\N
11324	2766	3	0	41210	\N
11326	360	2	0	41215	\N
11326	2767	3	0	41216	\N
11334	431	2	0	41260	\N
11334	2772	3	0	41261	\N
11344	135	6	0	40797	\N
11344	2778	7	0	41309	\N
11347	58	4	0	41324	\N
11347	2781	5	0	41325	\N
11349	2782	2	0	41332	\N
11349	2784	3	0	41333	\N
11356	73	2	0	41355	\N
11356	2766	3	0	41356	\N
11358	362	1	0	41360	\N
11358	395	2	0	41361	\N
11367	488	2	0	40848	\N
11367	2791	3	0	41416	\N
11372	56	2	0	40710	\N
11372	2795	3	0	41443	\N
11375	10	2	0	41461	\N
11375	275	3	0	41462	\N
11378	54	4	0	41475	\N
11378	2570	5	0	41476	\N
11384	360	2	0	41215	\N
11384	2767	3	0	41216	\N
11389	41	1	0	41505	\N
11389	40	5	0	41512	\N
11389	372	6	0	41513	\N
11394	214	2	0	41523	\N
11394	1259	3	0	41524	\N
11396	12	2	0	39808	\N
11396	2804	3	0	41529	\N
11401	362	4	0	41551	\N
11401	2807	5	0	41552	\N
11403	324	2	0	41563	\N
11403	2808	3	0	41564	\N
11406	435	4	0	37915	\N
11406	2810	5	0	41575	\N
11411	2	3	0	41603	\N
11411	298	4	0	41604	\N
11413	224	1	0	41611	\N
11413	2813	2	0	41612	\N
11420	51	2	0	39530	\N
11420	1260	3	0	41634	\N
11430	10	2	0	41626	\N
11430	275	3	0	41627	\N
11437	391	2	0	41697	\N
11437	1381	3	0	41698	\N
11440	266	4	0	41724	\N
11440	2824	5	0	41725	\N
11443	73	4	0	41738	\N
11443	2827	5	0	41739	\N
11446	10	1	0	41695	\N
11446	11	2	0	41756	\N
11449	94	1	0	41437	\N
11449	107	2	0	41760	\N
11450	198	1	0	39424	\N
11450	2829	2	0	41763	\N
11459	2636	2	0	41817	\N
11459	2836	3	0	41818	\N
11463	251	2	0	40388	\N
11463	1851	3	0	41837	\N
11466	40	2	0	41852	\N
11466	282	3	0	41853	\N
11468	2636	3	0	41860	\N
11468	2837	4	0	41861	\N
11470	242	3	0	41863	\N
11470	2839	4	0	41864	\N
11471	2578	10	0	41883	\N
11471	2840	11	0	41884	\N
11476	488	2	0	40848	\N
11476	2791	3	0	41416	\N
11479	411	4	0	41915	\N
11479	2806	5	0	41916	\N
11481	16	2	0	41898	\N
11481	388	3	0	41899	\N
11483	20	3	0	41926	\N
11483	2844	4	0	41927	\N
11485	140	1	0	37930	\N
11485	141	2	0	41931	\N
11490	528	1	0	41937	\N
11490	529	2	0	41938	\N
11491	453	1	0	39919	\N
11491	454	2	0	41939	\N
11492	2846	2	0	41943	\N
11492	125	8	0	41954	\N
11492	2847	9	0	41955	\N
11497	151	2	0	41979	\N
11497	2854	3	0	41980	\N
11499	123	3	0	41988	\N
11499	2856	4	0	41989	\N
11502	75	6	0	42004	\N
11502	2859	7	0	42005	\N
11504	2861	18	0	42015	\N
11504	119	39	0	42016	\N
11504	2863	40	1	42017	\N
11504	2862	40	0	42018	\N
11509	121	2	0	40645	\N
11509	2498	3	0	40646	\N
11511	46	2	0	110	\N
11511	2348	3	0	33912	\N
11513	300	2	0	42052	\N
11513	2786	3	0	42053	\N
11518	132	2	0	40620	\N
11518	2756	3	0	41093	\N
11520	92	28	0	41174	\N
11520	2866	29	0	42061	\N
11524	54	14	0	42093	\N
11524	2868	15	0	42095	\N
11526	214	6	0	41523	\N
11526	2871	7	0	42113	\N
11529	852	2	0	37608	\N
11529	2872	3	0	42131	\N
11534	1933	4	0	42169	\N
11534	1	5	0	42170	\N
11538	1	7	0	42125	\N
11538	2881	8	0	42192	\N
11543	1	2	0	42125	\N
11543	283	3	0	42200	\N
11548	27	1	0	41199	\N
11548	2885	2	0	42216	\N
11553	173	1	0	42230	\N
11553	1927	2	0	42231	\N
11245	2291	5	0	40694	\N
11247	181	4	0	39049	\N
11247	2356	5	0	40697	\N
11249	56	5	0	40710	\N
11249	2727	6	0	40711	\N
11252	391	7	0	40758	\N
11252	2729	8	0	40759	\N
11257	135	0	0	40797	\N
11259	10	24	0	40846	\N
11259	2732	25	0	40847	\N
11265	110	11	0	40887	\N
11265	2736	12	0	40891	\N
11267	82	7	0	7159	\N
11267	2738	8	0	40980	\N
11270	391	8	0	40999	\N
11270	2740	9	0	41000	\N
11272	96	2	0	41006	\N
11272	2347	3	0	41007	\N
11277	100	2	0	41035	\N
11277	633	3	0	41036	\N
11279	2744	47	1	41043	\N
11279	2674	47	0	41044	\N
11279	100	84	0	41045	\N
11279	2745	85	0	41046	\N
11283	4	2	0	41069	\N
11283	2751	3	0	41070	\N
11288	75	2	0	41086	\N
11288	284	3	0	41087	\N
11290	132	2	0	40620	\N
11290	2756	3	0	41093	\N
11296	100	2	0	41125	\N
11296	633	3	0	41126	\N
11301	125	1	0	38900	\N
11301	195	2	0	41134	\N
11310	44	3	0	41166	\N
11310	2762	4	0	41167	\N
11312	92	2	0	41174	\N
11312	2763	3	0	41175	\N
11314	40	2	0	41123	\N
11314	282	3	0	41124	\N
11320	528	2	0	41197	\N
11320	2765	3	0	41198	\N
11322	42	1	0	41203	\N
11322	43	2	0	41204	\N
11325	1	2	0	41127	\N
11325	283	3	0	41128	\N
11329	10	2	0	41182	\N
11329	275	3	0	41183	\N
11332	10	5	0	41244	\N
11332	2770	6	0	41245	\N
11335	75	2	0	41262	\N
11335	284	3	0	41263	\N
11337	841	4	0	41273	\N
11337	2774	5	0	41274	\N
11342	71	4	0	41293	\N
11342	2776	5	0	41294	\N
11345	137	6	0	39393	\N
11345	2779	7	0	41310	\N
11348	2782	4	0	41326	\N
11348	2783	5	0	41327	\N
11350	10	2	0	41334	\N
11350	275	3	0	41335	\N
11352	113	1	0	41340	\N
11352	1102	2	0	41341	\N
11354	300	2	0	41348	\N
11354	2786	3	0	41349	\N
11364	10	4	0	41334	\N
11364	2568	5	0	41407	\N
11366	391	2	0	41414	\N
11366	1381	3	0	41415	\N
11374	10	2	0	41334	\N
11374	275	3	0	41335	\N
11377	1470	4	0	41473	\N
11377	2798	5	0	41474	\N
11382	88	2	0	41384	\N
11382	2799	3	0	41489	\N
11386	2592	2	0	38185	\N
11386	2802	3	0	41498	\N
11388	125	1	0	38900	\N
11388	1185	2	0	41502	\N
11393	214	2	0	41523	\N
11393	1259	3	0	41524	\N
11395	14	2	0	40693	\N
11395	1785	3	0	41232	\N
11400	411	4	0	41549	\N
11400	2806	5	0	41550	\N
11402	164	2	0	41557	\N
11402	1124	3	0	41558	\N
11405	10	4	0	41461	\N
11405	2568	5	0	41574	\N
11408	40	4	0	41593	\N
11408	2796	5	0	41594	\N
11410	1109	3	0	37707	\N
11410	1683	4	0	41602	\N
11415	2	1	0	41603	\N
11415	1091	2	0	41615	\N
11417	88	2	0	41384	\N
11417	2799	3	0	41489	\N
11422	2816	5	0	41646	\N
11425	1	2	0	41656	\N
11425	283	3	0	41657	\N
11427	389	0	0	12148	\N
11429	20	5	0	39827	\N
11429	2820	6	0	41676	\N
11432	10	2	0	41695	\N
11432	275	3	0	41696	\N
11435	75	2	0	41701	\N
11435	284	3	0	41702	\N
11442	151	4	0	40074	\N
11442	1876	5	0	41737	\N
11445	40	1	0	41613	\N
11445	41	2	0	41755	\N
11453	10	2	0	41787	\N
11453	275	3	0	41788	\N
11456	2833	65	0	41802	\N
11456	2834	66	0	41803	\N
11456	2835	66	0	41804	\N
11458	290	2	0	41815	\N
11458	1909	3	0	41816	\N
11465	360	2	0	41215	\N
11465	2767	3	0	41216	\N
11473	1	3	0	41892	\N
11473	1114	4	0	41893	\N
11478	156	4	0	41913	\N
11478	2843	5	0	41914	\N
11480	2782	2	0	41332	\N
11480	2784	3	0	41333	\N
11482	10	2	0	41819	\N
11482	275	3	0	41820	\N
11487	1	1	0	41932	\N
11487	53	2	0	41933	\N
11489	233	1	0	38330	\N
11489	234	2	0	41936	\N
11494	167	5	0	41970	\N
11494	2851	6	0	41971	\N
11496	58	2	0	41324	\N
11496	2853	3	0	41978	\N
11501	2	6	0	42002	\N
11501	2858	7	0	42003	\N
11503	119	3	0	42012	\N
11503	2860	4	0	42013	\N
11506	2782	5	0	41332	\N
11506	2865	6	0	42036	\N
11519	92	0	0	41174	\N
11522	1	2	0	42075	\N
11522	283	3	0	42076	\N
11523	54	8	0	42093	\N
11523	2867	9	0	42094	\N
11531	362	2	0	41551	\N
11531	2873	3	0	42142	\N
11537	210	7	0	39765	\N
11537	2880	8	0	42191	\N
11541	177	7	0	38143	\N
11541	2882	8	0	42193	\N
11550	40	1	0	42220	\N
11550	1383	2	0	42221	\N
11472	391	10	0	41885	\N
11472	2841	11	0	41886	\N
11474	40	2	0	41852	\N
11474	282	3	0	41853	\N
11484	2351	3	0	41084	\N
11484	2845	4	0	41928	\N
11486	453	0	0	39919	\N
11488	360	1	0	41934	\N
11488	479	2	0	41935	\N
11493	2848	2	0	41956	\N
11493	316	8	0	41957	\N
11493	2850	9	1	41958	\N
11493	2849	9	0	41959	\N
11495	6	5	0	41972	\N
11495	2852	6	0	41973	\N
11507	40	2	0	41852	\N
11507	282	3	0	41853	\N
11510	121	0	0	40645	\N
11512	198	2	0	42046	\N
11512	513	3	0	42047	\N
11514	233	2	0	38330	\N
11514	1849	3	0	42054	\N
11516	40	2	0	41852	\N
11516	282	3	0	41853	\N
11527	40	5	0	41852	\N
11527	2714	6	0	42124	\N
11532	56	2	0	42147	\N
11532	2795	3	0	42148	\N
11535	2875	4	0	42171	\N
11535	1109	5	0	42172	\N
11539	177	7	0	38143	\N
11539	2882	8	0	42193	\N
11544	353	2	0	42205	\N
11544	2884	3	0	42206	\N
11546	391	2	0	41885	\N
11546	1381	3	0	42207	\N
11551	360	1	0	42224	\N
11551	2886	2	0	42225	\N
11554	10	2	0	41819	\N
11554	2887	3	0	42236	\N
11556	40	1	0	42240	\N
11556	1383	2	0	42241	\N
11560	10	2	0	42261	\N
11560	2887	3	0	42262	\N
11565	177	1	0	38143	\N
11565	2894	2	0	42278	\N
11567	100	1	0	41125	\N
11567	2895	2	0	42283	\N
11572	181	1	0	42295	\N
11572	2898	2	0	42296	\N
11577	125	2	0	42314	\N
11577	2902	3	0	42315	\N
11580	12	1	0	39808	\N
11580	2903	2	0	42325	\N
11583	40	0	0	42328	\N
11587	125	1	0	42339	\N
11587	1185	2	0	42340	\N
11592	14	1	0	41757	\N
11592	1926	2	0	42353	\N
11598	2909	2	0	42365	\N
11598	300	3	0	42366	\N
11599	140	2	0	37930	\N
11599	2910	3	0	42371	\N
11602	16	0	0	42382	\N
11612	241	2	0	38770	\N
11612	2923	3	0	42432	\N
11614	1	1	0	42437	\N
11614	1085	2	0	42438	\N
11622	35	0	0	42461	\N
11626	431	2	0	42486	\N
11626	2932	3	0	42487	\N
11629	262	1	0	42492	\N
11629	2935	2	0	42493	\N
11631	40	1	0	42498	\N
11631	1383	2	0	42499	\N
11638	1	0	0	42467	\N
11641	360	2	0	42532	\N
11641	2943	3	0	42533	\N
11643	192	1	0	41487	\N
11643	2944	2	0	42537	\N
11648	147	2	0	42549	\N
11648	2948	3	0	42550	\N
11651	10	2	0	42522	\N
11651	2887	3	0	42554	\N
11656	79	1	0	42265	\N
11656	1126	2	0	42266	\N
11658	14	1	0	42568	\N
11658	1926	2	0	42569	\N
11661	2953	0	0	42576	\N
11661	2954	0	0	42577	\N
11664	597	1	0	42547	\N
11664	2956	2	0	42593	\N
11667	2782	1	0	42596	\N
11667	2959	2	0	42597	\N
11671	244	1	0	37190	\N
11671	2960	2	0	42603	\N
11676	14	1	0	42613	\N
11676	1926	2	0	42614	\N
11683	149	9	0	42652	\N
11683	2963	10	0	42653	\N
11690	322	1	0	42672	\N
11690	2968	2	0	42673	\N
11692	2	1	0	42678	\N
11692	1091	2	0	42679	\N
11694	336	1	0	42684	\N
11694	2970	2	0	42685	\N
11697	100	1	0	42695	\N
11697	2895	2	0	42696	\N
11699	1109	1	0	42700	\N
11699	2971	2	0	42701	\N
11704	793	1	0	42716	\N
11704	2972	2	0	42717	\N
11711	16	2	0	42731	\N
11711	2974	3	0	42732	\N
11714	79	1	0	42740	\N
11714	1126	2	0	42741	\N
11716	79	0	0	42265	\N
11718	1789	1	0	23749	\N
11718	2976	2	0	42745	\N
11720	79	1	0	42740	\N
11720	1126	2	0	42741	\N
11729	192	1	0	41487	\N
11729	2944	2	0	42537	\N
11734	2	4	0	42775	\N
11734	315	5	0	42776	\N
11738	189	0	0	42789	\N
11743	353	1	0	42803	\N
11743	1092	2	0	42804	\N
11748	6	1	0	42819	\N
11748	2261	2	0	42820	\N
11753	40	0	0	42761	\N
11758	411	2	0	42674	\N
11758	2988	3	0	42849	\N
11766	44	2	0	41166	\N
11766	1910	3	0	42885	\N
11771	10	2	0	42902	\N
11771	275	3	0	42903	\N
11773	2993	51	0	42906	\N
11773	316	125	0	42907	\N
11773	2994	126	0	42908	\N
11775	35	2	0	42913	\N
11775	2996	3	0	42914	\N
11776	75	2	0	42919	\N
11776	2989	3	0	42920	\N
11778	88	1	0	42926	\N
11778	2896	2	0	42927	\N
11785	2	2	0	42856	\N
11785	2990	3	0	42857	\N
11789	3001	63	0	42946	\N
11789	288	126	0	42947	\N
11789	3003	127	1	42948	\N
11789	3002	127	0	42949	\N
11792	230	2	0	42960	\N
11792	3006	3	0	42961	\N
11796	3007	32	0	42968	\N
11796	64	125	0	42970	\N
11796	3008	126	1	42971	\N
11549	69	0	0	42217	\N
11552	1	1	0	42226	\N
11552	1085	2	0	42227	\N
11555	373	2	0	37901	\N
11555	2888	3	0	42237	\N
11557	402	1	0	42244	\N
11557	2889	2	0	42245	\N
11563	2892	2	0	42272	\N
11563	2893	3	0	42273	\N
11566	75	1	0	42279	\N
11566	1427	2	0	42280	\N
11570	90	1	0	42291	\N
11570	2897	2	0	42292	\N
11575	206	1	0	41362	\N
11575	2900	2	0	42304	\N
11578	10	2	0	42276	\N
11578	2887	3	0	42320	\N
11581	167	1	0	41970	\N
11581	2503	2	0	42326	\N
11585	235	1	0	42333	\N
11585	2904	2	0	42334	\N
11588	2905	2	0	42343	\N
11590	96	1	0	42348	\N
11590	2899	2	0	42349	\N
11595	2887	2	0	42363	\N
11595	10	3	0	42364	\N
11600	2088	2	0	42372	\N
11600	2911	2	0	42373	\N
11605	10	3	0	42394	\N
11605	2917	4	0	42395	\N
11608	69	2	0	42407	\N
11608	2920	3	0	42408	\N
11609	16	3	0	42382	\N
11609	2921	4	0	42415	\N
11613	316	73	0	42433	\N
11613	2924	74	0	42434	\N
11617	210	1	0	39765	\N
11617	2926	2	0	42445	\N
11620	1	1	0	42457	\N
11620	1085	2	0	42458	\N
11623	1	3	0	42467	\N
11623	2930	4	0	42468	\N
11627	202	1	0	38767	\N
11627	2933	2	0	42490	\N
11637	10	0	0	42522	\N
11639	264	1	0	42525	\N
11639	2941	2	0	42526	\N
11642	402	0	0	42534	\N
11645	852	1	0	42539	\N
11645	2945	2	0	42540	\N
11650	38	2	0	42344	\N
11650	2901	3	0	42553	\N
11655	75	1	0	42279	\N
11655	1427	2	0	42280	\N
11662	94	1	0	42578	\N
11662	2054	2	0	42579	\N
11666	595	1	0	42551	\N
11666	2958	2	0	42595	\N
11669	27	1	0	42600	\N
11669	2885	2	0	42601	\N
11672	38	1	0	42344	\N
11672	2906	2	0	42345	\N
11678	10	1	0	42619	\N
11678	1416	2	0	42620	\N
11680	1109	3	0	42212	\N
11680	2961	4	0	42627	\N
11685	1	9	0	42656	\N
11685	2965	10	0	42657	\N
11686	100	2	0	42662	\N
11686	2918	3	0	42663	\N
11693	56	1	0	42680	\N
11693	1088	2	0	42681	\N
11696	125	2	0	42691	\N
11696	2902	3	0	42692	\N
11698	1	1	0	42656	\N
11698	1085	2	0	42699	\N
11701	113	1	0	42706	\N
11701	1102	2	0	42707	\N
11703	40	1	0	42498	\N
11703	1383	2	0	42499	\N
11706	200	1	0	42055	\N
11706	2785	2	0	42722	\N
11710	10	0	0	42720	\N
11722	79	0	0	42740	\N
11723	79	0	0	42740	\N
11726	192	1	0	41487	\N
11726	2944	2	0	42537	\N
11728	30	2	0	42757	\N
11728	2980	3	0	42758	\N
11732	10	1	0	42720	\N
11732	1416	2	0	42721	\N
11736	1	7	0	42785	\N
11736	2881	8	0	42786	\N
11742	10	1	0	42720	\N
11742	1416	2	0	42721	\N
11745	233	2	0	38330	\N
11745	2987	3	0	42810	\N
11747	365	1	0	42817	\N
11747	1424	2	0	42818	\N
11752	86	1	0	42833	\N
11752	2967	2	0	42834	\N
11754	10	0	0	42720	\N
11757	38	1	0	42843	\N
11757	2906	2	0	42844	\N
11759	75	2	0	42850	\N
11759	2989	3	0	42851	\N
11762	241	2	0	42864	\N
11762	2923	3	0	42865	\N
11765	360	2	0	42532	\N
11765	2767	3	0	42880	\N
11777	44	1	0	41166	\N
11777	2997	2	0	42923	\N
11782	86	1	0	42936	\N
11782	2967	2	0	42937	\N
11787	2982	2	0	42787	\N
11787	2999	3	0	42944	\N
11790	123	1	0	42952	\N
11790	2275	2	0	42953	\N
11793	64	1	0	39371	\N
11793	1428	2	0	42964	\N
11795	75	1	0	42966	\N
11795	1427	2	0	42967	\N
11797	40	1	0	42761	\N
11797	1383	2	0	42762	\N
11800	88	2	0	42926	\N
11800	3010	3	0	42986	\N
11807	6	1	0	42819	\N
11807	2261	2	0	42820	\N
11809	1654	1	0	20766	\N
11809	3013	2	0	43000	\N
11815	2982	1	0	42787	\N
11815	3014	2	0	43008	\N
11822	391	1	0	42664	\N
11822	1420	2	0	43041	\N
11824	108	1	0	43045	\N
11824	3022	2	0	43046	\N
11827	16	1	0	42994	\N
11827	1087	2	0	42995	\N
11830	262	2	0	42492	\N
11830	3027	3	0	43081	\N
11834	16	5	0	43101	\N
11834	3031	6	0	43102	\N
11839	10	1	0	43127	\N
11839	1416	2	0	43128	\N
11842	353	1	0	43141	\N
11842	1092	2	0	43142	\N
11844	40	1	0	43147	\N
11844	1383	2	0	43148	\N
11847	115	1	0	43153	\N
11847	2908	2	0	43154	\N
11849	2782	0	0	42596	\N
11851	285	2	0	43162	\N
11851	3036	3	0	43163	\N
11854	2351	9	0	43166	\N
11558	86	2	0	42250	\N
11558	2890	3	0	42251	\N
11561	79	1	0	42265	\N
11561	1126	2	0	42266	\N
11564	10	1	0	42276	\N
11564	1416	2	0	42277	\N
11568	16	1	0	42284	\N
11568	1087	2	0	42285	\N
11571	75	1	0	42279	\N
11571	1427	2	0	42280	\N
11573	96	1	0	41006	\N
11573	2899	2	0	42299	\N
11576	38	2	0	2019	\N
11576	2901	3	0	42309	\N
11579	1	1	0	42226	\N
11579	1085	2	0	42227	\N
11586	10	1	0	42331	\N
11586	1416	2	0	42332	\N
11589	38	1	0	42344	\N
11589	2906	2	0	42345	\N
11593	841	1	0	41273	\N
11593	2907	2	0	42356	\N
11596	2909	2	0	42365	\N
11596	300	3	0	42366	\N
11601	56	2	0	42380	\N
11601	2914	3	0	42381	\N
11603	156	0	0	41913	\N
11606	100	2	0	41125	\N
11606	2918	3	0	42400	\N
11615	273	1	0	41009	\N
11615	1417	2	0	42439	\N
11618	132	2	0	40620	\N
11618	2927	3	0	42446	\N
11621	35	1	0	42461	\N
11621	2929	2	0	42462	\N
11632	206	1	0	42500	\N
11632	2900	2	0	42501	\N
11633	92	1	0	42504	\N
11633	1078	2	0	42505	\N
11636	279	4	0	42520	\N
11636	2940	5	0	42521	\N
11644	402	1	0	42534	\N
11644	2889	2	0	42538	\N
11646	362	1	0	42541	\N
11646	2946	2	0	42542	\N
11649	595	2	0	42551	\N
11649	2949	3	0	42552	\N
11652	1	2	0	42555	\N
11652	2950	3	0	42556	\N
11654	82	1	0	42561	\N
11654	2951	2	0	42562	\N
11657	290	1	0	41815	\N
11657	2952	2	0	42565	\N
11659	264	1	0	42570	\N
11659	2941	2	0	42571	\N
11665	147	1	0	42549	\N
11665	2957	2	0	42594	\N
11668	79	1	0	42598	\N
11668	1126	2	0	42599	\N
11674	290	1	0	41815	\N
11674	2952	2	0	42565	\N
11677	35	1	0	42617	\N
11677	2929	2	0	42618	\N
11679	75	1	0	42279	\N
11679	1427	2	0	42280	\N
11684	156	9	0	42654	\N
11684	2964	10	0	42655	\N
11688	79	1	0	42598	\N
11688	1126	2	0	42599	\N
11691	411	1	0	42674	\N
11691	2969	2	0	42675	\N
11695	10	2	0	42619	\N
11695	2887	3	0	42690	\N
11700	2351	1	0	42704	\N
11700	2925	2	0	42705	\N
11702	16	1	0	42710	\N
11702	1087	2	0	42711	\N
11705	10	1	0	42720	\N
11705	1416	2	0	42721	\N
11709	117	0	0	42725	\N
11712	202	1	0	42735	\N
11712	2933	2	0	42736	\N
11717	79	0	0	42265	\N
11719	212	1	0	42746	\N
11719	2977	2	0	42747	\N
11721	79	5	0	42598	\N
11721	2978	6	0	42750	\N
11725	2	0	0	42678	\N
11727	214	2	0	42755	\N
11727	2979	3	0	42756	\N
11730	40	1	0	42761	\N
11730	1383	2	0	42762	\N
11735	324	7	0	42783	\N
11735	2981	8	0	42784	\N
11739	189	5	0	42789	\N
11739	2984	6	0	42794	\N
11741	149	1	0	42652	\N
11741	2985	2	0	42800	\N
11744	170	2	0	40254	\N
11744	2986	3	0	42809	\N
11746	198	1	0	42813	\N
11746	2829	2	0	42814	\N
11749	373	2	0	37901	\N
11749	2888	3	0	42237	\N
11751	1	1	0	42829	\N
11751	1085	2	0	42830	\N
11756	10	1	0	42841	\N
11756	1416	2	0	42842	\N
11761	488	2	0	42858	\N
11761	2991	3	0	42859	\N
11764	300	4	0	42874	\N
11764	2992	5	0	42875	\N
11767	1	2	0	42886	\N
11767	283	3	0	42887	\N
11769	1	3	0	42886	\N
11769	1114	4	0	42895	\N
11772	110	2	0	42904	\N
11772	626	3	0	42905	\N
11774	110	3	0	42904	\N
11774	2995	4	0	42911	\N
11779	14	1	0	42928	\N
11779	1926	2	0	42929	\N
11781	202	1	0	42934	\N
11781	2933	2	0	42935	\N
11786	324	0	0	42783	\N
11799	12	1	0	39808	\N
11799	2903	2	0	42325	\N
11802	156	1	0	42654	\N
11802	3012	2	0	42991	\N
11805	147	1	0	42549	\N
11805	2957	2	0	42594	\N
11806	16	1	0	42994	\N
11806	1087	2	0	42995	\N
11814	1	1	0	43006	\N
11814	1085	2	0	43007	\N
11819	3015	3	0	43025	\N
11819	20	4	0	43028	\N
11821	10	2	0	43037	\N
11821	2887	3	0	43038	\N
11826	224	11	0	41611	\N
11826	3024	12	0	43071	\N
11829	264	2	0	42570	\N
11829	3026	3	0	43080	\N
11833	192	5	0	41487	\N
11833	3030	6	0	43100	\N
11836	268	1	0	43115	\N
11836	1422	2	0	43116	\N
11841	40	2	0	43137	\N
11841	3034	3	0	43138	\N
11846	38	1	0	42843	\N
11846	2906	2	0	42844	\N
11853	2351	1	0	43166	\N
11853	2925	2	0	43167	\N
11858	2782	0	0	42596	\N
11860	49	1	0	42405	\N
11860	1086	2	0	43180	\N
11865	10	1	0	43198	\N
11559	322	2	0	42000	\N
11559	2891	3	0	42256	\N
11562	75	1	0	42004	\N
11562	1427	2	0	42267	\N
11569	88	1	0	41384	\N
11569	2896	2	0	42288	\N
11574	23	1	0	42300	\N
11574	1089	2	0	42301	\N
11582	10	0	0	42327	\N
11584	10	1	0	42331	\N
11584	1416	2	0	42332	\N
11591	40	1	0	42328	\N
11591	1383	2	0	42350	\N
11594	115	1	0	42357	\N
11594	2908	2	0	42358	\N
11597	2909	2	0	42365	\N
11597	300	3	0	42366	\N
11604	2915	32	0	42383	\N
11604	67	125	0	42384	\N
11604	2916	126	1	42385	\N
11604	1970	126	0	42386	\N
11604	2171	127	0	42387	\N
11607	49	2	0	42405	\N
11607	2919	3	0	42406	\N
11610	268	1	0	42418	\N
11610	1422	2	0	42419	\N
11611	167	3	0	42426	\N
11611	2922	4	0	42427	\N
11616	2351	1	0	41084	\N
11616	2925	2	0	42442	\N
11619	365	3	0	42453	\N
11619	2928	4	0	42454	\N
11624	10	3	0	42469	\N
11624	2917	4	0	42470	\N
11625	30	5	0	42480	\N
11625	2931	6	0	42481	\N
11628	77	1	0	39909	\N
11628	2934	2	0	42491	\N
11630	58	1	0	42496	\N
11630	2936	2	0	42497	\N
11634	2937	83	0	42506	\N
11634	92	113	0	42507	\N
11634	1075	114	1	42508	\N
11634	2938	114	0	42509	\N
11635	326	4	0	42518	\N
11635	2939	5	0	42519	\N
11640	96	2	0	42348	\N
11640	2942	3	0	42531	\N
11647	597	2	0	42547	\N
11647	2947	3	0	42548	\N
11653	10	1	0	42559	\N
11653	1416	2	0	42560	\N
11660	92	1	0	42574	\N
11660	1078	2	0	42575	\N
11663	326	5	0	42518	\N
11663	2955	6	0	42590	\N
11670	1	1	0	42555	\N
11670	1085	2	0	42602	\N
11673	1416	1	0	42606	\N
11673	10	2	0	42560	\N
11675	1	1	0	42555	\N
11675	1085	2	0	42602	\N
11681	1	2	0	42632	\N
11681	2950	3	0	42633	\N
11682	336	9	0	40144	\N
11682	2962	10	0	42651	\N
11687	391	2	0	42664	\N
11687	2966	3	0	42665	\N
11689	86	1	0	42670	\N
11689	2967	2	0	42671	\N
11707	1	1	0	42723	\N
11707	1085	2	0	42724	\N
11708	117	7	0	42725	\N
11708	2973	8	0	42726	\N
11713	20	0	0	42737	\N
11715	20	1	0	42737	\N
11715	2975	2	0	42742	\N
11724	79	0	0	42740	\N
11731	793	1	0	42763	\N
11731	2972	2	0	42764	\N
11733	75	1	0	42279	\N
11733	1427	2	0	42280	\N
11737	2982	7	0	42787	\N
11737	2983	8	0	42788	\N
11740	1	1	0	42785	\N
11740	1085	2	0	42797	\N
11750	56	2	0	42825	\N
11750	2914	3	0	42826	\N
11755	75	1	0	42837	\N
11755	1427	2	0	42838	\N
11760	2	2	0	42856	\N
11760	2990	3	0	42857	\N
11763	75	2	0	42850	\N
11763	2989	3	0	42851	\N
11768	30	2	0	42757	\N
11768	1127	3	0	42888	\N
11770	10	3	0	42896	\N
11770	297	4	0	42897	\N
11780	362	1	0	42930	\N
11780	2946	2	0	42931	\N
11783	212	1	0	42746	\N
11783	2977	2	0	42747	\N
11784	251	1	0	42938	\N
11784	2998	2	0	42939	\N
11788	324	2	0	42783	\N
11788	3000	3	0	42945	\N
11791	3005	3	0	42959	\N
11794	1	1	0	42886	\N
11794	1085	2	0	42965	\N
11798	40	1	0	42978	\N
11798	1383	2	0	42979	\N
11803	595	1	0	42551	\N
11803	2958	2	0	42595	\N
11810	322	1	0	42672	\N
11810	2968	2	0	42673	\N
11812	202	1	0	42934	\N
11812	2933	2	0	42935	\N
11816	10	1	0	43011	\N
11816	1416	2	0	43012	\N
11820	3018	1	0	43031	\N
11820	3019	2	0	43032	\N
11825	117	1	0	43047	\N
11825	3023	2	0	43048	\N
11828	908	2	0	43078	\N
11828	3025	3	0	43079	\N
11837	326	2	0	43121	\N
11837	393	3	0	43122	\N
11843	793	1	0	43143	\N
11843	2972	2	0	43144	\N
11845	20	1	0	43151	\N
11845	2975	2	0	43152	\N
11852	2782	0	0	42596	\N
11855	75	1	0	42966	\N
11855	1427	2	0	42967	\N
11857	90	2	0	43174	\N
11857	3039	3	0	43175	\N
11859	2782	1	0	42596	\N
11859	2959	2	0	42597	\N
11864	3042	46	0	43193	\N
11864	54	126	0	43194	\N
11864	3043	127	0	43195	\N
11871	224	3	0	43221	\N
11871	3045	4	0	43222	\N
11874	528	1	0	43234	\N
11874	1093	2	0	43235	\N
11884	258	4	0	40695	\N
11884	3057	5	0	43269	\N
11886	40	1	0	43205	\N
11886	1383	2	0	43206	\N
11888	435	1	0	37915	\N
11888	1580	2	0	43277	\N
11896	704	1	0	43310	\N
11896	3064	2	0	43311	\N
11900	75	2	0	42966	\N
11900	2989	3	0	43326	\N
11902	40	2	0	43335	\N
11796	124	126	0	42972	\N
11796	3009	127	0	42973	\N
11801	251	2	0	42987	\N
11801	3011	3	0	42988	\N
11804	597	1	0	42547	\N
11804	2956	2	0	42593	\N
11808	77	1	0	39909	\N
11808	2934	2	0	42491	\N
11811	273	1	0	43001	\N
11811	1417	2	0	43002	\N
11813	324	1	0	42783	\N
11813	939	2	0	43005	\N
11817	10	2	0	43017	\N
11817	2887	3	0	43018	\N
11818	3015	3	0	43025	\N
11818	3016	4	0	43026	\N
11818	3017	4	0	43027	\N
11823	3020	0	0	25665	\N
11823	3021	0	0	43042	\N
11831	12	2	0	43086	\N
11831	3028	3	0	43087	\N
11832	2	5	0	43098	\N
11832	3029	6	0	43099	\N
11835	10	4	0	43111	\N
11835	3032	5	0	43112	\N
11838	424	1	0	43125	\N
11838	3033	2	0	43126	\N
11840	173	1	0	43131	\N
11840	1927	2	0	43132	\N
11848	71	1	0	43155	\N
11848	3035	2	0	43156	\N
11850	2782	2	0	42596	\N
11850	2784	3	0	43161	\N
11862	73	3	0	41738	\N
11862	3040	4	0	43189	\N
11869	94	1	0	43207	\N
11869	2054	2	0	43208	\N
11872	10	3	0	43223	\N
11872	2917	4	0	43224	\N
11875	3047	10	0	43236	\N
11875	528	68	0	43237	\N
11875	3049	69	1	43238	\N
11875	3048	69	0	43239	\N
11879	3053	2	0	43250	\N
11879	2088	3	0	43251	\N
11879	3054	3	0	43252	\N
11881	275	2	0	43255	\N
11881	10	3	0	43256	\N
11882	2088	4	0	43251	\N
11882	3055	4	0	43265	\N
11882	3056	5	0	43266	\N
11887	200	1	0	42055	\N
11887	2785	2	0	42722	\N
11889	488	1	0	43278	\N
11889	3059	2	0	43279	\N
11891	10	1	0	43284	\N
11891	1416	2	0	43285	\N
11894	2171	94	1	43297	\N
11894	3061	94	0	43298	\N
11894	1075	95	0	43299	\N
11894	92	126	0	43300	\N
11894	3062	127	0	43301	\N
11897	367	2	0	43316	\N
11897	3065	3	0	43317	\N
11903	262	2	0	42492	\N
11903	3027	3	0	43081	\N
11908	198	1	0	43353	\N
11908	2829	2	0	43354	\N
11913	206	1	0	42500	\N
11913	2900	2	0	42501	\N
11915	79	25	0	43370	\N
11915	3067	26	0	43371	\N
11917	79	1	0	43376	\N
11917	1126	2	0	43377	\N
11920	115	1	0	43153	\N
11920	2908	2	0	43154	\N
11854	3037	10	0	43168	\N
11856	424	2	0	43125	\N
11856	3038	3	0	43173	\N
11861	56	1	0	43181	\N
11861	1088	2	0	43182	\N
11863	54	3	0	43190	\N
11863	3041	4	0	43191	\N
11866	3044	2	0	43200	\N
11868	40	1	0	43205	\N
11868	1383	2	0	43206	\N
11870	10	2	0	43213	\N
11870	275	3	0	43214	\N
11873	151	3	0	41979	\N
11873	3046	4	0	43231	\N
11876	1	1	0	43006	\N
11876	1085	2	0	43007	\N
11878	3050	6	0	43245	\N
11878	3051	7	0	43246	\N
11878	3052	7	0	43247	\N
11883	51	4	0	43267	\N
11883	3056	5	0	43268	\N
11885	320	1	0	32251	\N
11885	3058	2	0	43272	\N
11890	212	1	0	42746	\N
11890	2977	2	0	42747	\N
11893	92	2	0	42574	\N
11893	3060	3	0	43293	\N
11899	96	2	0	43203	\N
11899	2942	3	0	43325	\N
11901	10	1	0	43329	\N
11901	1416	2	0	43330	\N
11904	12	1	0	43339	\N
11904	2903	2	0	43340	\N
11912	16	1	0	43101	\N
11912	1087	2	0	43365	\N
11914	411	1	0	43368	\N
11914	2969	2	0	43369	\N
11921	186	2	0	43388	\N
11921	3068	3	0	43389	\N
11924	10	1	0	43398	\N
11924	1416	2	0	43399	\N
11865	1416	2	0	43199	\N
11867	96	1	0	43203	\N
11867	2899	2	0	43204	\N
11877	10	1	0	43223	\N
11877	1416	2	0	43242	\N
11880	1379	2	0	43253	\N
11880	149	3	0	43254	\N
11892	51	1	0	43267	\N
11892	1905	2	0	43288	\N
11895	60	2	0	43306	\N
11895	3063	3	0	43307	\N
11898	67	1	0	35362	\N
11898	3066	2	0	43320	\N
11906	336	1	0	43345	\N
11906	2970	2	0	43346	\N
11909	75	1	0	43357	\N
11909	1427	2	0	43358	\N
11911	51	1	0	43363	\N
11911	1905	2	0	43364	\N
11916	77	1	0	43374	\N
11916	2934	2	0	43375	\N
11918	200	1	0	42055	\N
11918	2785	2	0	42722	\N
11923	16	1	0	43101	\N
11923	1087	2	0	43365	\N
11902	3034	3	0	43336	\N
11905	75	1	0	42966	\N
11905	1427	2	0	42967	\N
11907	362	1	0	43349	\N
11907	2946	2	0	43350	\N
11910	113	1	0	42706	\N
11910	1102	2	0	42707	\N
11919	40	1	0	43382	\N
11919	1383	2	0	43383	\N
11922	1	1	0	43392	\N
11922	1085	2	0	43393	\N
11925	1	2	0	43404	\N
11925	2950	3	0	43405	\N
11926	365	1	0	43408	\N
11926	1424	2	0	43409	\N
11927	140	1	0	43412	\N
11927	3069	2	0	43413	\N
11928	94	1	0	43416	\N
11928	2054	2	0	43417	\N
11929	75	1	0	43418	\N
11929	1427	2	0	43419	\N
11930	212	3	0	43426	\N
11930	3070	4	0	43427	\N
11931	322	3	0	42672	\N
11931	3071	4	0	43428	\N
11932	49	1	0	42405	\N
11932	1086	2	0	43180	\N
11933	10	1	0	43431	\N
11933	1416	2	0	43432	\N
11934	149	32	0	43435	\N
11934	3072	33	0	43436	\N
11935	151	1	0	43437	\N
11935	3073	2	0	43438	\N
11936	251	1	0	43439	\N
11936	2998	2	0	43440	\N
11937	2	0	0	43441	\N
11938	10	3	0	43448	\N
11938	2917	4	0	43449	\N
11939	2	0	0	43450	\N
11940	51	2	0	43363	\N
11940	3074	3	0	43455	\N
11941	40	8	0	43472	\N
11941	3075	9	0	43473	\N
11942	852	8	0	42539	\N
11942	3076	9	0	43474	\N
11943	51	1	0	43477	\N
11943	1905	2	0	43478	\N
11944	10	1	0	43479	\N
11944	1416	2	0	43480	\N
11945	362	1	0	43483	\N
11945	2946	2	0	43484	\N
11946	1	2	0	43489	\N
11946	2950	3	0	43490	\N
11947	92	5	0	43498	\N
11947	3077	6	0	43499	\N
11948	324	2	0	42783	\N
11948	3000	3	0	42945	\N
11949	2982	2	0	42787	\N
11949	2999	3	0	42944	\N
11950	324	0	0	42783	\N
11951	92	16	0	43509	\N
11951	3079	17	1	43510	\N
11951	3078	17	0	43511	\N
11951	1075	18	0	42973	\N
11952	149	20	0	43514	\N
11952	3080	21	0	43515	\N
11953	96	4	0	43518	\N
11953	3081	5	0	43519	\N
11954	14	4	0	42928	\N
11954	3082	5	0	43520	\N
11955	224	2	0	43525	\N
11955	3083	3	0	43526	\N
11956	38	2	0	42843	\N
11956	2901	3	0	43527	\N
11957	40	1	0	43472	\N
11957	1383	2	0	43530	\N
11958	10	1	0	43531	\N
11958	1416	2	0	43532	\N
11959	69	2	0	43537	\N
11959	2920	3	0	43538	\N
11960	198	2	0	43543	\N
11960	3084	3	0	43544	\N
11961	164	2	0	43545	\N
11961	3085	3	0	43546	\N
11962	108	5	0	43547	\N
11962	3086	6	0	43548	\N
11963	360	1	0	43551	\N
11963	2886	2	0	43552	\N
11964	108	1	0	43547	\N
11964	3022	2	0	43553	\N
11965	230	1	0	42960	\N
11965	3087	2	0	43554	\N
11966	260	1	0	43555	\N
11966	1904	2	0	43556	\N
11967	10	1	0	43531	\N
11967	1416	2	0	43532	\N
11968	435	1	0	43559	\N
11968	1580	2	0	43560	\N
11969	40	2	0	43565	\N
11969	3034	3	0	43566	\N
11970	135	2	0	43567	\N
11970	3088	3	0	43568	\N
11971	137	2	0	39393	\N
11971	3089	3	0	43569	\N
11972	77	1	0	43374	\N
11972	2934	2	0	43375	\N
11973	16	1	0	43574	\N
11973	1087	2	0	43575	\N
11974	40	1	0	43565	\N
11974	1383	2	0	43576	\N
11975	852	1	0	43579	\N
11975	2945	2	0	43580	\N
11976	262	2	0	42492	\N
11976	3027	3	0	43081	\N
11977	135	2	0	43567	\N
11977	3088	3	0	43568	\N
11978	137	2	0	43585	\N
11978	3089	3	0	43586	\N
11979	3090	1	0	43589	\N
11979	3091	2	0	43590	\N
11980	16	1	0	43574	\N
11980	1087	2	0	43575	\N
11981	164	1	0	43545	\N
11981	3092	2	0	43593	\N
11982	336	1	0	43596	\N
11982	2970	2	0	43597	\N
11983	230	1	0	42960	\N
11983	3087	2	0	43554	\N
11984	10	1	0	43600	\N
11984	1416	2	0	43601	\N
11985	290	1	0	43604	\N
11985	2952	2	0	43605	\N
11986	233	1	0	38330	\N
11986	1418	2	0	43608	\N
11987	14	1	0	43609	\N
11987	1926	2	0	43610	\N
11988	10	1	0	43611	\N
11988	1416	2	0	43612	\N
11989	94	1	0	43613	\N
11989	2054	2	0	43614	\N
11990	156	2	0	43619	\N
11990	3093	3	0	43620	\N
11991	367	2	0	43621	\N
11991	3065	3	0	43622	\N
11992	241	1	0	43625	\N
11992	3094	2	0	43626	\N
11993	16	1	0	43574	\N
11993	1087	2	0	43575	\N
11994	10	1	0	43611	\N
11994	1416	2	0	43612	\N
11995	453	1	0	39919	\N
11995	3095	2	0	43629	\N
11996	431	1	0	43632	\N
11996	3096	2	0	43633	\N
11997	40	1	0	43634	\N
11997	1383	2	0	43635	\N
11998	1151	1	0	43636	\N
11998	3097	2	0	43637	\N
12001	424	2	0	43647	\N
12001	3038	3	0	43648	\N
12003	75	1	0	43418	\N
12003	1427	2	0	43419	\N
12006	40	1	0	43634	\N
12006	1383	2	0	43635	\N
12009	251	1	0	43439	\N
12009	2998	2	0	43440	\N
12014	528	1	0	43234	\N
12014	1093	2	0	43235	\N
12016	200	2	0	43699	\N
12016	3109	3	0	43700	\N
12020	1	1	0	43711	\N
12020	1085	2	0	43712	\N
12030	40	1	0	43634	\N
12030	1383	2	0	43635	\N
12041	132	1	0	40620	\N
12041	3116	2	0	43777	\N
12044	35	1	0	43786	\N
12044	2929	2	0	43787	\N
12048	14	1	0	43609	\N
12048	1926	2	0	43610	\N
12051	56	1	0	43801	\N
12051	1088	2	0	43802	\N
12052	86	1	0	43805	\N
12052	2967	2	0	43806	\N
12054	2782	1	0	43818	\N
12054	2959	2	0	43819	\N
12058	82	1	0	43799	\N
12058	2951	2	0	43800	\N
12063	391	4	0	43844	\N
12063	3123	5	0	43845	\N
12066	214	1	0	43850	\N
12066	1382	2	0	43851	\N
12072	119	1	0	43876	\N
12072	3128	2	0	43877	\N
12075	10	3	0	43892	\N
12075	2917	4	0	43893	\N
12078	67	1	0	43902	\N
12078	3066	2	0	43903	\N
12083	453	2	0	39919	\N
12083	3133	3	0	43923	\N
12096	132	1	0	43968	\N
12096	3116	2	0	43969	\N
12099	135	2	0	43567	\N
12099	3088	3	0	43568	\N
12106	1572	1	0	19405	\N
12106	3141	2	0	43998	\N
12108	320	1	0	44000	\N
12108	3058	2	0	44001	\N
12114	224	1	0	43525	\N
12114	2813	2	0	44017	\N
12116	198	1	0	44022	\N
12116	2829	2	0	44023	\N
12118	930	0	0	44028	\N
12125	488	1	0	43278	\N
12125	3059	2	0	43279	\N
12131	113	0	0	44065	\N
12137	88	1	0	42926	\N
12137	2896	2	0	42927	\N
12140	1	0	0	44084	\N
12142	324	2	0	44092	\N
12142	3000	3	0	44093	\N
12144	2982	2	0	42787	\N
12144	2999	3	0	42944	\N
12149	33	1	0	41699	\N
12149	3119	2	0	43822	\N
12151	10	1	0	44121	\N
12151	1416	2	0	44122	\N
12154	212	1	0	43426	\N
12154	2977	2	0	44004	\N
12166	82	4	0	44164	\N
12166	3155	5	0	44165	\N
12171	115	1	0	43153	\N
12171	2908	2	0	43154	\N
12177	42	1	0	44200	\N
12177	2823	2	0	44201	\N
12181	300	4	0	44215	\N
12181	3161	5	0	44216	\N
12182	96	2	0	44066	\N
12182	2347	3	0	44221	\N
12187	115	1	0	43153	\N
12187	2908	2	0	43154	\N
12192	177	28	0	44253	\N
12192	3167	29	0	44257	\N
12197	40	1	0	44272	\N
12197	1383	2	0	44273	\N
12200	424	1	0	43709	\N
12200	3033	2	0	43710	\N
12203	31	1	0	44304	\N
12203	30	3	0	44307	\N
12203	3171	4	0	44308	\N
12206	324	1	0	44319	\N
12206	939	2	0	44320	\N
12213	2489	1	0	36275	\N
12213	3174	2	0	44334	\N
12216	290	2	0	44345	\N
12216	3176	3	0	44346	\N
12218	173	2	0	44354	\N
12218	3179	3	0	44355	\N
12221	75	2	0	44039	\N
12221	2989	3	0	44360	\N
12222	10	1	0	44358	\N
12222	1416	2	0	44363	\N
12225	198	3	0	44332	\N
12225	3181	4	0	44374	\N
12232	2351	5	0	44399	\N
12232	3185	6	0	44400	\N
12236	324	0	0	44403	\N
12239	49	1	0	44413	\N
12239	1086	2	0	44414	\N
12241	210	1	0	44417	\N
12241	2926	2	0	44418	\N
12243	1	1	0	44423	\N
12243	1085	2	0	44424	\N
12246	88	2	0	44446	\N
12246	2799	3	0	44447	\N
12249	23	4	0	44459	\N
12249	3189	5	0	44460	\N
12251	40	1	0	44464	\N
12251	1383	2	0	44465	\N
12264	1	1	0	44517	\N
12264	1085	2	0	44518	\N
12269	10	0	0	44523	\N
12275	10	1	0	44549	\N
12275	1416	2	0	44550	\N
12278	2636	1	0	41860	\N
12278	3207	2	0	44553	\N
12280	10	1	0	44549	\N
12280	1416	2	0	44550	\N
12290	3210	13	0	44595	\N
12290	92	22	0	44604	\N
12290	3211	23	0	44605	\N
12303	10	2	0	44666	\N
12303	3169	3	0	44667	\N
12305	142	4	0	43645	\N
12305	3219	5	0	44680	\N
12310	10	2	0	44701	\N
12310	3169	3	0	44702	\N
12313	2578	2	0	44713	\N
12313	3224	3	0	44714	\N
12324	58	2	0	43770	\N
12324	3228	3	0	44757	\N
12325	2	4	0	44766	\N
12325	3229	5	0	44767	\N
12328	908	4	0	44768	\N
12328	3230	5	0	44769	\N
12329	10	0	0	44723	\N
12334	1	1	0	44645	\N
12334	1085	2	0	44783	\N
12339	210	1	0	44791	\N
12339	2926	2	0	44792	\N
12353	147	1	0	42549	\N
12353	2957	2	0	42594	\N
12355	908	2	0	44768	\N
12355	3025	3	0	44845	\N
11999	121	1	0	40645	\N
11999	3098	2	0	43640	\N
12005	79	1	0	43663	\N
12005	1126	2	0	43664	\N
12007	453	1	0	39919	\N
12007	3095	2	0	43629	\N
12008	3101	1	0	43667	\N
12008	3102	2	0	43668	\N
12013	3104	68	0	43687	\N
12013	528	120	0	43688	\N
12013	1075	121	1	43689	\N
12013	3105	121	0	43690	\N
12015	3106	33	0	43691	\N
12015	528	80	0	43692	\N
12015	3108	81	1	43693	\N
12015	3107	81	0	43694	\N
12018	235	1	0	43707	\N
12018	2904	2	0	43708	\N
12023	20	2	0	43721	\N
12023	3111	3	0	43722	\N
12024	58	1	0	43725	\N
12024	2936	2	0	43726	\N
12026	241	2	0	43735	\N
12026	2923	3	0	43736	\N
12028	4	1	0	43741	\N
12028	3114	2	0	43742	\N
12032	170	1	0	43747	\N
12032	1072	2	0	43748	\N
12035	56	1	0	43760	\N
12035	1088	2	0	43761	\N
12038	316	1	0	42433	\N
12038	3115	2	0	43772	\N
12040	58	1	0	43770	\N
12040	2936	2	0	43771	\N
12042	10	1	0	43780	\N
12042	1416	2	0	43781	\N
12047	391	1	0	43793	\N
12047	1420	2	0	43794	\N
12050	82	1	0	43799	\N
12050	2951	2	0	43800	\N
12056	94	1	0	43820	\N
12056	2054	2	0	43821	\N
12067	3125	28	0	43852	\N
12067	149	88	0	43859	\N
12067	3126	89	0	43860	\N
12068	56	4	0	43801	\N
12068	3127	5	0	43863	\N
12071	67	1	0	43872	\N
12071	3066	2	0	43873	\N
12074	2	3	0	43890	\N
12074	3129	4	0	43891	\N
12079	10	1	0	43906	\N
12079	1416	2	0	43907	\N
12082	316	2	0	43921	\N
12082	3132	3	0	43922	\N
12085	241	2	0	43926	\N
12085	2923	3	0	43927	\N
12089	1	2	0	43940	\N
12089	2950	3	0	43941	\N
12091	3135	31	0	43944	\N
12091	3051	32	0	43246	\N
12091	3136	32	0	43945	\N
12094	75	3	0	43418	\N
12094	3139	4	0	43958	\N
12097	402	1	0	42534	\N
12097	2889	2	0	42538	\N
12100	16	2	0	43980	\N
12100	2974	3	0	43981	\N
12105	266	1	0	43994	\N
12105	1954	2	0	43995	\N
12110	852	1	0	43713	\N
12110	2945	2	0	43714	\N
12112	73	3	0	41738	\N
12112	3040	4	0	43189	\N
12117	54	1	0	44026	\N
12117	3142	2	0	44027	\N
12124	142	1	0	43645	\N
12124	3117	2	0	43788	\N
12129	1654	1	0	44055	\N
12129	3013	2	0	44056	\N
12134	1	3	0	44069	\N
12134	2930	4	0	44070	\N
12136	402	1	0	44075	\N
12136	2889	2	0	44076	\N
12141	268	2	0	44020	\N
12141	3146	3	1	44089	\N
12141	3145	3	0	44090	\N
12141	2583	4	0	44091	\N
12145	10	5	0	44106	\N
12145	3148	6	0	44107	\N
12148	33	0	0	41699	\N
12152	1	1	0	44123	\N
12152	1085	2	0	44124	\N
12157	224	1	0	43525	\N
12157	225	2	0	44135	\N
12160	1361	5	0	44149	\N
12160	3151	6	0	44150	\N
12164	290	0	0	44155	\N
12168	10	1	0	44169	\N
12168	1416	2	0	44170	\N
12172	435	2	0	44179	\N
12172	3156	3	0	44180	\N
12173	2	3	0	43890	\N
12173	3129	4	0	43891	\N
12176	60	3	0	44196	\N
12176	3158	4	0	44197	\N
12178	94	1	0	44202	\N
12178	2054	2	0	44203	\N
12179	49	4	0	42405	\N
12179	3159	5	0	44212	\N
12186	27	2	0	42600	\N
12186	3164	3	0	44241	\N
12189	268	3	0	44020	\N
12189	3165	4	0	44252	\N
12193	10	1	0	44255	\N
12193	1416	2	0	44260	\N
12196	16	2	0	44268	\N
12196	2974	3	0	44269	\N
12199	1	3	0	44153	\N
12199	2814	4	0	44286	\N
12202	113	4	0	44065	\N
12202	3170	5	0	44301	\N
12208	2982	1	0	42787	\N
12208	3014	2	0	43008	\N
12212	198	1	0	44332	\N
12212	2829	2	0	44333	\N
12214	1	1	0	44337	\N
12214	1085	2	0	44338	\N
12220	10	2	0	44358	\N
12220	2887	3	0	44359	\N
12224	75	1	0	44039	\N
12224	1427	2	0	44040	\N
12229	140	2	0	44383	\N
12229	3183	3	0	44387	\N
12234	10	1	0	44405	\N
12234	1416	2	0	44406	\N
12245	75	4	0	44039	\N
12245	3187	5	0	44441	\N
12247	285	2	0	44407	\N
12247	3036	3	0	44448	\N
12254	77	1	0	44411	\N
12254	2934	2	0	44412	\N
12256	56	1	0	44471	\N
12256	1088	2	0	44472	\N
12260	173	3	0	44488	\N
12260	3192	4	0	44489	\N
12266	10	1	0	44523	\N
12266	1416	2	0	44524	\N
12268	16	1	0	44529	\N
12268	1087	2	0	44530	\N
12273	14	1	0	43609	\N
12273	1926	2	0	43610	\N
12277	14	0	0	43609	\N
12284	435	2	0	44569	\N
12284	3156	3	0	44570	\N
12287	108	1	0	43547	\N
12287	3022	2	0	43553	\N
12000	142	2	0	43645	\N
12000	3099	3	0	43646	\N
12002	110	2	0	42904	\N
12002	3100	3	0	43653	\N
12010	10	1	0	43611	\N
12010	1416	2	0	43612	\N
12011	189	6	0	43683	\N
12011	3103	7	0	43684	\N
12019	424	1	0	43709	\N
12019	3033	2	0	43710	\N
12027	108	3	0	43737	\N
12027	3113	4	0	43738	\N
12029	108	1	0	43547	\N
12029	3022	2	0	43553	\N
12031	10	1	0	43743	\N
12031	1416	2	0	43744	\N
12033	56	1	0	43751	\N
12033	1088	2	0	43752	\N
12036	16	2	0	43766	\N
12036	2974	3	0	43767	\N
12043	336	1	0	43784	\N
12043	2970	2	0	43785	\N
12055	27	1	0	42600	\N
12055	2885	2	0	42601	\N
12059	3120	56	0	43825	\N
12059	123	63	0	43826	\N
12059	3121	64	0	43827	\N
12061	3122	114	0	43832	\N
12061	123	126	0	43833	\N
12061	1868	127	0	43834	\N
12064	94	4	0	43846	\N
12064	3124	5	0	43847	\N
12070	1	2	0	43711	\N
12070	2950	3	0	43869	\N
12073	1085	1	0	43880	\N
12073	1	3	0	43883	\N
12073	1085	4	0	43884	\N
12076	285	1	0	43896	\N
12076	3112	2	0	43897	\N
12081	96	3	0	43518	\N
12081	3131	4	0	43916	\N
12084	167	2	0	43924	\N
12084	2260	3	0	43925	\N
12088	353	2	0	43938	\N
12088	3134	3	0	43939	\N
12090	132	2	0	43942	\N
12090	2927	3	0	43943	\N
12093	2544	43	0	37168	\N
12093	3138	44	0	43951	\N
12102	258	2	0	43988	\N
12102	3140	3	0	43989	\N
12104	10	1	0	43906	\N
12104	1416	2	0	43907	\N
12107	1	0	0	43999	\N
12109	212	1	0	43426	\N
12109	2977	2	0	44004	\N
12111	10	1	0	43906	\N
12111	1416	2	0	43907	\N
12119	2	2	0	43890	\N
12119	2990	3	0	44033	\N
12121	189	2	0	44034	\N
12121	3143	3	0	44035	\N
12123	75	1	0	44039	\N
12123	1427	2	0	44040	\N
12126	1	1	0	44043	\N
12126	1085	2	0	44044	\N
12128	140	1	0	44053	\N
12128	3069	2	0	44054	\N
12132	96	3	0	44066	\N
12132	3131	4	0	44067	\N
12135	360	1	0	43551	\N
12135	2886	2	0	43552	\N
12138	71	1	0	44081	\N
12138	3035	2	0	44082	\N
12143	268	2	0	44020	\N
12143	2583	3	1	44094	\N
12143	3147	3	0	44095	\N
12147	10	1	0	44113	\N
12147	1416	2	0	44114	\N
12150	132	1	0	44117	\N
12150	3116	2	0	44118	\N
12155	266	1	0	44128	\N
12155	1954	2	0	44129	\N
12156	224	2	0	43525	\N
12156	3150	3	0	44134	\N
12162	94	5	0	43846	\N
12162	3153	6	0	44152	\N
12167	12	0	0	44166	\N
12175	86	3	0	44194	\N
12175	3157	4	0	44195	\N
12183	202	1	0	44224	\N
12183	2933	2	0	44225	\N
12185	3162	66	0	44234	\N
12185	149	103	0	44237	\N
12185	3163	104	0	44238	\N
12188	186	1	0	44244	\N
12188	1080	2	0	44245	\N
12191	10	3	0	44255	\N
12191	2917	4	0	44256	\N
12195	300	1	0	44215	\N
12195	3168	2	0	44263	\N
12198	10	2	0	44278	\N
12198	3169	3	0	44279	\N
12201	10	1	0	44291	\N
12201	1416	2	0	44292	\N
12204	200	1	0	44311	\N
12204	2785	2	0	44312	\N
12207	324	0	0	44319	\N
12209	46	6	0	110	\N
12209	3172	7	0	44321	\N
12211	336	1	0	43784	\N
12211	2970	2	0	43785	\N
12217	3177	113	0	44347	\N
12217	459	126	0	44348	\N
12217	3178	127	0	44349	\N
12219	79	2	0	44356	\N
12219	3180	3	0	44357	\N
12223	1	1	0	44366	\N
12223	1085	2	0	44367	\N
12226	30	3	0	44375	\N
12226	3182	4	0	44376	\N
12228	140	1	0	44383	\N
12228	141	2	0	44384	\N
12231	132	1	0	44117	\N
12231	3116	2	0	44118	\N
12233	324	1	0	44403	\N
12233	939	2	0	44404	\N
12237	2982	1	0	42787	\N
12237	3014	2	0	43008	\N
12240	453	1	0	39919	\N
12240	3095	2	0	43629	\N
12242	852	1	0	44419	\N
12242	2945	2	0	44420	\N
12244	228	3	0	44431	\N
12244	3186	4	0	44432	\N
12252	132	0	0	44117	\N
12258	1	1	0	44479	\N
12258	1085	2	0	44480	\N
12259	117	3	0	43047	\N
12259	3191	4	0	44487	\N
12261	3193	38	0	44494	\N
12261	117	125	0	44495	\N
12261	3195	126	1	44496	\N
12261	3194	126	0	44497	\N
12261	2583	127	1	44498	\N
12261	3196	127	0	44499	\N
12263	102	13	0	44508	\N
12263	1970	14	1	44509	\N
12263	3198	14	0	44510	\N
12263	3200	15	1	44511	\N
12263	3199	15	0	44512	\N
12263	3202	16	1	44513	\N
12263	3201	16	0	44514	\N
12263	3204	17	1	44515	\N
12263	3203	17	0	44516	\N
12265	16	1	0	44521	\N
12265	1087	2	0	44522	\N
12004	20	3	0	43151	\N
12004	3015	4	0	43660	\N
12012	86	1	0	42936	\N
12012	2967	2	0	42937	\N
12017	79	1	0	43703	\N
12017	1126	2	0	43704	\N
12021	852	1	0	43713	\N
12021	2945	2	0	43714	\N
12022	279	1	0	43715	\N
12022	3110	2	0	43716	\N
12025	285	1	0	43729	\N
12025	3112	2	0	43730	\N
12034	40	2	0	43634	\N
12034	282	3	0	43757	\N
12037	58	1	0	43770	\N
12037	2936	2	0	43771	\N
12039	242	1	0	43773	\N
12039	2768	2	0	43774	\N
12045	142	1	0	43645	\N
12045	3117	2	0	43788	\N
12046	40	1	0	43791	\N
12046	1383	2	0	43792	\N
12049	44	1	0	43797	\N
12049	2997	2	0	43798	\N
12053	16	4	0	43814	\N
12053	3118	5	0	43815	\N
12057	33	1	0	41699	\N
12057	3119	2	0	43822	\N
12060	391	1	0	43830	\N
12060	1420	2	0	43831	\N
12062	90	2	0	43174	\N
12062	3039	3	0	43175	\N
12065	40	1	0	43791	\N
12065	1383	2	0	43792	\N
12069	4	1	0	43741	\N
12069	3114	2	0	43742	\N
12077	62	1	0	43900	\N
12077	3130	2	0	43901	\N
12080	170	1	0	43908	\N
12080	1072	2	0	43909	\N
12086	1	2	0	43928	\N
12086	2950	3	0	43929	\N
12087	326	1	0	43932	\N
12087	1534	2	0	43933	\N
12092	2544	2	0	37168	\N
12092	3137	3	0	43950	\N
12095	1	3	0	43940	\N
12095	2930	4	0	43965	\N
12098	137	2	0	43585	\N
12098	3089	3	0	43586	\N
12101	12	2	0	43982	\N
12101	3028	3	0	43983	\N
12103	391	2	0	43990	\N
12103	2966	3	0	43991	\N
12113	40	1	0	44015	\N
12113	1383	2	0	44016	\N
12115	268	1	0	44020	\N
12115	1422	2	0	44021	\N
12120	189	0	0	44034	\N
12122	16	1	0	43980	\N
12122	1087	2	0	44038	\N
12127	391	2	0	44049	\N
12127	2966	3	0	44050	\N
12130	365	3	0	44063	\N
12130	2928	4	0	44064	\N
12133	113	3	0	44065	\N
12133	3144	4	0	44068	\N
12139	326	0	0	44083	\N
12146	908	1	0	43078	\N
12146	3149	2	0	44110	\N
12153	96	1	0	44066	\N
12153	2899	2	0	44127	\N
12158	262	2	0	44136	\N
12158	2743	3	0	44137	\N
12159	262	1	0	44136	\N
12159	263	2	0	44138	\N
12161	156	5	0	43619	\N
12161	3152	6	0	44151	\N
12163	1	5	0	44153	\N
12163	3154	6	0	44154	\N
12165	10	0	0	44121	\N
12169	12	1	0	44166	\N
12169	2903	2	0	44171	\N
12170	290	1	0	44155	\N
12170	2952	2	0	44174	\N
12174	1	3	0	44153	\N
12174	2930	4	0	44187	\N
12180	362	4	0	44213	\N
12180	3160	5	0	44214	\N
12184	94	1	0	44226	\N
12184	2054	2	0	44227	\N
12190	177	3	0	44253	\N
12190	3166	4	0	44254	\N
12194	242	1	0	43773	\N
12194	2768	2	0	43774	\N
12205	2	1	0	44315	\N
12205	1091	2	0	44316	\N
12210	10	3	0	44328	\N
12210	3173	4	0	44329	\N
12215	459	2	0	44343	\N
12215	3175	3	0	44344	\N
12227	1	1	0	44379	\N
12227	1085	2	0	44380	\N
12230	260	2	0	43555	\N
12230	3184	3	0	44388	\N
12235	285	1	0	44407	\N
12235	3112	2	0	44408	\N
12238	77	1	0	44411	\N
12238	2934	2	0	44412	\N
12248	424	4	0	44457	\N
12248	3188	5	0	44458	\N
12250	23	17	0	44459	\N
12250	3190	18	0	44461	\N
12253	1	1	0	44466	\N
12253	1085	2	0	44467	\N
12255	320	0	0	44470	\N
12257	27	1	0	44475	\N
12257	2885	2	0	44476	\N
12262	102	1	0	44502	\N
12262	3197	2	0	44503	\N
12271	14	0	0	42928	\N
12274	14	0	0	43609	\N
12282	10	2	0	44549	\N
12282	275	3	0	44562	\N
12285	453	4	0	39919	\N
12285	798	5	0	44579	\N
12288	3208	1	0	44586	\N
12288	3209	2	0	44587	\N
12292	94	3	0	44616	\N
12292	3212	4	0	44617	\N
12295	230	10	0	42960	\N
12295	3214	11	0	44644	\N
12297	14	1	0	43609	\N
12297	1926	2	0	43610	\N
12300	210	1	0	44658	\N
12300	2926	2	0	44659	\N
12302	132	2	0	44117	\N
12302	3218	3	0	44665	\N
12304	10	2	0	44666	\N
12304	3169	3	0	44667	\N
12307	75	1	0	44685	\N
12307	1427	2	0	44686	\N
12312	164	2	0	44707	\N
12312	3223	3	0	44708	\N
12318	367	1	0	44727	\N
12318	3225	2	0	44728	\N
12320	23	1	0	44459	\N
12320	1089	2	0	44737	\N
12323	214	2	0	43850	\N
12323	2979	3	0	44752	\N
12331	167	1	0	43924	\N
12331	2503	2	0	44774	\N
12336	320	0	0	44470	\N
12338	164	1	0	44787	\N
12338	3092	2	0	44788	\N
12347	75	4	0	44826	\N
12347	3234	5	0	44827	\N
12267	2185	1	0	44527	\N
12267	3205	2	0	44528	\N
12270	75	7	0	44545	\N
12270	3206	8	0	44546	\N
12272	336	1	0	43784	\N
12272	2970	2	0	43785	\N
12276	14	0	0	43609	\N
12279	2636	1	0	41860	\N
12279	3207	2	0	44553	\N
12281	266	1	0	44556	\N
12281	1954	2	0	44557	\N
12283	1	1	0	44517	\N
12283	1085	2	0	44518	\N
12286	235	1	0	44582	\N
12286	2904	2	0	44583	\N
12293	10	2	0	44622	\N
12293	3169	3	0	44623	\N
12296	1	4	0	44645	\N
12296	3215	5	0	44646	\N
12298	56	2	0	44471	\N
12298	3216	3	0	44653	\N
12308	82	2	0	44691	\N
12308	3220	3	0	44692	\N
12311	86	0	0	44194	\N
12314	121	1	0	44717	\N
12314	3098	2	0	44718	\N
12316	10	1	0	44723	\N
12316	1416	2	0	44724	\N
12321	3226	52	0	44739	\N
12321	23	58	0	44740	\N
12321	3227	59	0	44741	\N
12326	908	4	0	44768	\N
12326	3230	5	0	44769	\N
12330	16	0	0	44770	\N
12332	300	1	0	44777	\N
12332	3168	2	0	44778	\N
12337	164	1	0	44787	\N
12337	3092	2	0	44788	\N
12340	108	2	0	44797	\N
12340	3231	3	0	44798	\N
12342	1	2	0	44799	\N
12342	2950	3	0	44800	\N
12343	2636	4	0	44809	\N
12343	3232	5	0	44810	\N
12345	300	1	0	44814	\N
12345	3168	2	0	44815	\N
12348	365	1	0	44063	\N
12348	1424	2	0	44830	\N
12354	597	1	0	42547	\N
12354	2956	2	0	42593	\N
12356	793	2	0	43143	\N
12356	3236	3	0	44850	\N
12361	200	1	0	44863	\N
12361	2785	2	0	44864	\N
12366	44	1	0	44879	\N
12366	2997	2	0	44880	\N
12370	170	1	0	44893	\N
12370	1072	2	0	44894	\N
12372	3239	79	0	44914	\N
12372	528	126	0	44915	\N
12372	3240	127	0	44916	\N
12373	33	1	0	44919	\N
12373	3119	2	0	44920	\N
12376	56	1	0	44925	\N
12376	1088	2	0	44926	\N
12378	10	1	0	44723	\N
12378	1416	2	0	44724	\N
12380	258	1	0	43988	\N
12380	3241	2	0	44935	\N
12388	1	1	0	44923	\N
12388	1085	2	0	44924	\N
12390	56	0	0	44925	\N
12392	62	1	0	44963	\N
12392	3130	2	0	44964	\N
12395	73	2	0	44975	\N
12395	3243	3	0	44976	\N
12397	793	1	0	44855	\N
12397	2972	2	0	44856	\N
12400	10	2	0	44989	\N
12400	2887	3	0	44990	\N
12402	360	2	0	44996	\N
12402	2943	3	0	44997	\N
12405	210	1	0	45004	\N
12405	2926	2	0	45005	\N
12407	79	1	0	44356	\N
12407	1126	2	0	45014	\N
12412	62	1	0	45023	\N
12412	3130	2	0	45024	\N
12416	64	1	0	39371	\N
12416	1428	2	0	42964	\N
12421	1	1	0	45044	\N
12421	1085	2	0	45045	\N
12427	10	0	0	45056	\N
12429	67	0	0	43902	\N
12431	262	0	0	44136	\N
12434	1792	0	0	45059	\N
12439	110	0	0	45062	\N
12441	33	0	0	45063	\N
12450	71	0	0	45074	\N
12452	10	0	0	45056	\N
12455	316	0	0	43921	\N
12460	908	1	0	45082	\N
12460	3149	2	0	45083	\N
12463	54	0	0	45055	\N
12465	75	7	0	45099	\N
12465	3252	8	0	45100	\N
12468	16	0	0	45102	\N
12470	244	0	0	37190	\N
12473	38	0	0	45108	\N
12475	453	1	0	45113	\N
12475	3095	2	0	45114	\N
12477	108	3	0	44797	\N
12477	3255	4	0	45122	\N
12479	56	3	0	45125	\N
12479	1188	4	0	45126	\N
12482	108	1	0	44797	\N
12482	3022	2	0	45139	\N
12490	16	1	0	45102	\N
12490	1087	2	0	45167	\N
12493	73	1	0	44975	\N
12493	2775	2	0	45173	\N
12494	10	1	0	45174	\N
12494	1416	2	0	45175	\N
12496	135	1	0	43567	\N
12496	3262	2	0	45178	\N
12499	513	2	0	45191	\N
12499	198	3	0	45192	\N
12503	3265	2	0	45206	\N
12503	3266	2	0	45207	\N
12503	3268	3	1	45208	\N
12503	3267	3	0	45209	\N
12505	3271	9	0	45213	\N
12505	121	10	0	45214	\N
12507	1	1	0	45218	\N
12507	1085	2	0	45219	\N
12510	10	2	0	45174	\N
12510	275	3	0	45259	\N
12513	258	2	0	45085	\N
12513	3275	3	0	45280	\N
12515	1	2	0	45287	\N
12515	283	3	0	45288	\N
12525	94	6	0	45329	\N
12525	3277	7	0	45330	\N
12527	10	2	0	45340	\N
12527	275	3	0	45341	\N
12533	10	1	0	45340	\N
12533	1416	2	0	45359	\N
12537	362	2	0	45379	\N
12537	2873	3	0	45380	\N
12542	2782	4	0	43818	\N
12542	2783	5	0	45394	\N
12544	192	5	0	45021	\N
12544	3284	6	0	45407	\N
12546	597	2	0	42547	\N
12546	3286	3	0	45413	\N
12548	51	0	0	45416	\N
12550	1988	0	0	27544	\N
12289	192	1	0	41487	\N
12289	2944	2	0	42537	\N
12291	71	1	0	44608	\N
12291	3035	2	0	44609	\N
12294	365	10	0	44063	\N
12294	3213	11	0	44643	\N
12299	192	1	0	44656	\N
12299	2944	2	0	44657	\N
12301	233	2	0	38330	\N
12301	3217	3	0	44664	\N
12306	56	4	0	44681	\N
12306	1978	5	0	44682	\N
12309	3221	1	0	44695	\N
12309	3222	2	0	44696	\N
12315	391	1	0	44719	\N
12315	1420	2	0	44720	\N
12317	285	1	0	44725	\N
12317	3112	2	0	44726	\N
12319	156	2	0	44733	\N
12319	3093	3	0	44734	\N
12322	2578	2	0	44746	\N
12322	3224	3	0	44747	\N
12327	16	4	0	44770	\N
12327	3118	5	0	44771	\N
12333	266	1	0	44779	\N
12333	1954	2	0	44780	\N
12335	16	0	0	44784	\N
12341	79	2	0	44356	\N
12341	3180	3	0	44357	\N
12344	316	4	0	43921	\N
12344	3233	5	0	44811	\N
12346	841	1	0	41273	\N
12346	2907	2	0	42356	\N
12349	391	2	0	44835	\N
12349	2966	3	0	44836	\N
12351	58	0	0	44838	\N
12359	192	1	0	44656	\N
12359	2944	2	0	44657	\N
12362	16	1	0	44784	\N
12362	1087	2	0	44865	\N
12367	264	3	0	44887	\N
12367	3237	4	0	44888	\N
12374	16	1	0	44784	\N
12374	1087	2	0	44865	\N
12379	264	1	0	44931	\N
12379	2941	2	0	44932	\N
12383	110	1	0	44943	\N
12383	3242	2	0	44944	\N
12389	2982	1	0	42787	\N
12389	3014	2	0	43008	\N
12396	186	2	0	44977	\N
12396	3068	3	0	44978	\N
12398	402	2	0	44985	\N
12398	3244	3	0	44986	\N
12408	224	1	0	45015	\N
12408	2813	2	0	45016	\N
12413	435	1	0	45025	\N
12413	1580	2	0	45026	\N
12414	367	1	0	45027	\N
12414	3225	2	0	45028	\N
12417	186	1	0	45033	\N
12417	1080	2	0	45034	\N
12422	1	0	0	45046	\N
12424	391	2	0	45052	\N
12424	2966	3	0	45053	\N
12430	1	0	0	45044	\N
12432	75	0	0	45058	\N
12435	391	0	0	45060	\N
12437	391	0	0	45061	\N
12442	151	0	0	45064	\N
12444	1	0	0	45065	\N
12446	391	0	0	45072	\N
12448	192	0	0	45021	\N
12458	10	0	0	45056	\N
12461	1	1	0	45084	\N
12461	1085	2	0	45047	\N
12466	1000	0	0	9664	\N
12471	60	0	0	45104	\N
12478	35	3	0	45123	\N
12478	3256	4	0	45124	\N
12480	793	3	0	45133	\N
12480	3257	4	0	45134	\N
12486	56	4	0	45158	\N
12486	3259	5	0	45159	\N
12488	424	1	0	45164	\N
12488	3033	2	0	45165	\N
12501	51	2	0	43477	\N
12504	3269	2	0	45210	\N
12504	3270	2	0	45211	\N
12504	2498	3	0	45212	\N
12509	198	4	0	45253	\N
12509	3273	5	0	45254	\N
12514	1	2	0	45281	\N
12514	283	3	0	45282	\N
12518	10	2	0	45299	\N
12518	275	3	0	45300	\N
12523	40	6	0	45111	\N
12523	2777	7	0	45326	\N
12528	94	2	0	45329	\N
12528	2794	3	0	45342	\N
12530	244	3	0	45353	\N
12530	3278	4	0	45354	\N
12538	10	2	0	45340	\N
12538	275	3	0	45341	\N
12540	1171	4	0	45391	\N
12540	3282	5	0	45392	\N
12549	206	0	0	45417	\N
12551	1819	4	0	24294	\N
12551	3289	5	0	45427	\N
12557	132	2	0	45463	\N
12557	2756	3	0	45464	\N
12559	132	4	0	45463	\N
12559	3293	5	0	45474	\N
12566	1	2	0	45500	\N
12566	283	3	0	45501	\N
12570	391	2	0	45529	\N
12570	1381	3	0	45530	\N
12574	10	2	0	45547	\N
12574	275	3	0	45548	\N
12577	23	6	0	45573	\N
12577	3299	7	0	45574	\N
12586	79	4	0	44356	\N
12586	2758	5	0	45628	\N
12596	212	8	0	43426	\N
12596	3312	9	0	45680	\N
12601	322	2	0	45708	\N
12601	1866	3	0	45709	\N
12607	10	2	0	45739	\N
12607	275	3	0	45740	\N
12609	16	2	0	45750	\N
12609	388	3	0	45751	\N
12611	1	2	0	45757	\N
12611	283	3	0	45758	\N
12617	132	2	0	45794	\N
12617	2756	3	0	45795	\N
12620	214	2	0	44929	\N
12620	1259	3	0	45818	\N
12624	86	0	0	45847	\N
12627	86	0	0	45847	\N
12633	75	2	0	45860	\N
12633	284	3	0	45861	\N
12638	1470	6	0	41473	\N
12638	3324	7	0	45895	\N
12640	3326	38	0	45910	\N
12640	117	126	0	45925	\N
12640	3327	127	0	45926	\N
12642	16	2	0	45932	\N
12642	388	3	0	45933	\N
12646	367	2	0	45945	\N
12646	3329	3	0	45946	\N
12648	75	2	0	45860	\N
12648	284	3	0	45861	\N
12651	75	7	0	45860	\N
12651	3331	8	0	45969	\N
12654	119	7	0	45792	\N
12350	266	2	0	44779	\N
12350	3235	3	0	44837	\N
12352	595	1	0	42551	\N
12352	2958	2	0	42595	\N
12357	54	1	0	44853	\N
12357	3142	2	0	44854	\N
12364	142	2	0	43645	\N
12364	3099	3	0	43646	\N
12368	156	1	0	44891	\N
12368	3012	2	0	44892	\N
12375	1	1	0	44923	\N
12375	1085	2	0	44924	\N
12381	362	1	0	44213	\N
12381	2946	2	0	44938	\N
12384	167	1	0	44947	\N
12384	2503	2	0	44948	\N
12386	16	1	0	44951	\N
12386	1087	2	0	44952	\N
12391	1085	1	0	44957	\N
12391	1	3	0	44924	\N
12391	1085	4	0	44960	\N
12393	62	1	0	44963	\N
12393	3130	2	0	44964	\N
12399	40	2	0	44987	\N
12399	3034	3	0	44988	\N
12401	391	0	0	44991	\N
12403	189	2	0	44998	\N
12403	3143	3	0	44999	\N
12406	181	2	0	45010	\N
12406	3245	3	0	45011	\N
12409	285	1	0	44725	\N
12409	3112	2	0	44726	\N
12418	186	0	0	45033	\N
12419	2636	3	0	45041	\N
12419	3246	4	0	45042	\N
12425	391	0	0	45054	\N
12428	3248	0	0	45057	\N
12433	262	0	0	44136	\N
12436	264	0	0	44931	\N
12438	488	0	0	43278	\N
12440	241	0	0	43926	\N
12443	177	0	0	44253	\N
12447	16	0	0	45073	\N
12449	156	0	0	44891	\N
12451	1	0	0	45065	\N
12453	10	0	0	45056	\N
12456	206	0	0	45076	\N
12459	92	10	0	45077	\N
12459	3251	11	1	45078	\N
12459	3250	11	0	45079	\N
12464	56	0	0	44925	\N
12469	20	0	0	45103	\N
12472	3253	7	0	45105	\N
12472	60	27	0	45106	\N
12472	3254	28	0	45107	\N
12476	10	0	0	45115	\N
12483	206	1	0	45142	\N
12483	2900	2	0	45143	\N
12487	10	4	0	45160	\N
12487	3032	5	0	45161	\N
12489	451	1	0	40159	\N
12489	3260	2	0	45166	\N
12491	33	1	0	45063	\N
12491	3119	2	0	45170	\N
12495	137	1	0	45176	\N
12495	3261	2	0	45177	\N
12497	16	2	0	45183	\N
12497	388	3	0	45184	\N
12502	51	2	0	43477	\N
12502	1260	3	0	45201	\N
12506	121	2	0	44717	\N
12506	2498	3	0	45215	\N
12512	1453	4	0	45274	\N
12512	3274	5	0	45275	\N
12517	16	2	0	45293	\N
12517	388	3	0	45294	\N
12520	852	2	0	44419	\N
12520	2872	3	0	45303	\N
12522	435	4	0	45025	\N
12522	2810	5	0	45313	\N
12529	1	1	0	45345	\N
12529	1085	2	0	45346	\N
12532	186	5	0	45033	\N
12532	3280	6	0	45358	\N
12536	224	4	0	45015	\N
12536	3281	5	0	45374	\N
12539	75	2	0	45381	\N
12539	284	3	0	45382	\N
12541	258	4	0	45085	\N
12541	2725	5	0	45393	\N
12543	336	5	0	45405	\N
12543	3283	6	0	45406	\N
12545	595	2	0	42551	\N
12545	3285	3	0	45412	\N
12552	3290	3	0	45428	\N
12552	90	126	0	45431	\N
12552	3291	127	0	45432	\N
12554	10	2	0	45441	\N
12554	275	3	0	45442	\N
12555	10	6	0	45455	\N
12555	2718	7	0	45456	\N
12558	266	2	0	44779	\N
12558	2103	3	0	45465	\N
12560	453	4	0	45475	\N
12560	3294	5	0	45476	\N
12562	33	2	0	45063	\N
12562	2822	3	0	45482	\N
12564	132	2	0	45463	\N
12564	2756	3	0	45464	\N
12567	3295	2	0	45502	\N
12567	3296	3	0	45503	\N
12571	1	2	0	45531	\N
12571	283	3	0	45532	\N
12572	202	2	0	44224	\N
12572	2764	3	0	45537	\N
12581	233	1	0	38330	\N
12581	234	2	0	41936	\N
12583	10	1	0	45596	\N
12583	11	2	0	45597	\N
12587	320	4	0	45629	\N
12587	3305	5	0	45630	\N
12588	230	16	0	45635	\N
12588	3306	17	0	45636	\N
12593	285	4	0	44725	\N
12593	3309	5	1	45655	\N
12593	1970	5	0	45656	\N
12595	42	2	0	44200	\N
12595	3108	3	1	45662	\N
12595	3311	3	0	45663	\N
12599	431	2	0	45696	\N
12599	2772	3	0	45697	\N
12602	181	2	0	45710	\N
12602	3313	3	0	45711	\N
12610	451	2	0	40159	\N
12610	3317	3	0	45752	\N
12612	449	2	0	40058	\N
12612	646	3	0	45763	\N
12615	290	2	0	44345	\N
12615	1909	3	0	45787	\N
12621	6	6	0	45075	\N
12621	3320	7	0	45831	\N
12623	10	2	0	45781	\N
12623	275	3	0	45846	\N
12625	86	2	0	45847	\N
12625	3321	3	0	45852	\N
12628	86	0	0	45847	\N
12632	424	2	0	45164	\N
12632	2755	3	0	45859	\N
12636	4	2	0	45866	\N
12636	2751	3	0	45867	\N
12649	10	2	0	45953	\N
12649	275	3	0	45954	\N
12650	1	7	0	45947	\N
12650	3330	8	0	45968	\N
12652	326	2	0	45974	\N
12652	393	3	0	45975	\N
12656	10	7	0	45997	\N
12358	793	1	0	44855	\N
12358	2972	2	0	44856	\N
12360	192	1	0	44861	\N
12360	2944	2	0	44862	\N
12363	1	1	0	44866	\N
12363	1085	2	0	44867	\N
12365	1	2	0	44866	\N
12365	2950	3	0	44876	\N
12369	40	1	0	44464	\N
12369	1383	2	0	44465	\N
12371	528	2	0	43234	\N
12371	3238	3	0	44899	\N
12377	214	1	0	44929	\N
12377	1382	2	0	44930	\N
12382	186	1	0	44244	\N
12382	1080	2	0	44245	\N
12385	56	1	0	44925	\N
12385	1088	2	0	44926	\N
12387	324	1	0	44403	\N
12387	939	2	0	44404	\N
12394	75	2	0	44969	\N
12394	284	3	0	44970	\N
12404	14	1	0	45002	\N
12404	1926	2	0	45003	\N
12410	10	1	0	45017	\N
12410	1416	2	0	45018	\N
12411	192	1	0	45021	\N
12411	2944	2	0	45022	\N
12415	362	1	0	45031	\N
12415	2946	2	0	45032	\N
12420	40	3	0	44987	\N
12420	3247	4	0	45043	\N
12423	1	0	0	45047	\N
12426	54	0	0	45055	\N
12445	177	58	0	45070	\N
12445	3249	59	0	45071	\N
12454	6	0	0	45075	\N
12457	262	0	0	44136	\N
12462	258	0	0	45085	\N
12467	113	0	0	45101	\N
12474	40	1	0	45111	\N
12474	1383	2	0	45112	\N
12481	1	1	0	45084	\N
12481	1085	2	0	45047	\N
12484	230	1	0	45146	\N
12484	3087	2	0	45147	\N
12485	58	4	0	45156	\N
12485	3258	5	0	45157	\N
12492	2351	1	0	45171	\N
12492	2925	2	0	45172	\N
12498	282	2	0	45189	\N
12498	40	3	0	45190	\N
12500	283	2	0	45193	\N
12500	1	3	0	45194	\N
12508	273	12	0	43001	\N
12508	3272	13	0	45244	\N
12511	35	3	0	45123	\N
12511	3256	4	0	45124	\N
12516	258	2	0	45085	\N
12516	3275	3	0	45280	\N
12519	1	2	0	45301	\N
12519	283	3	0	45302	\N
12521	10	4	0	45299	\N
12521	2568	5	0	45312	\N
12524	38	6	0	45327	\N
12524	3276	7	0	45328	\N
12526	391	2	0	45072	\N
12526	1381	3	0	45335	\N
12531	1153	1	0	11684	\N
12531	3279	2	0	45357	\N
12534	186	1	0	45033	\N
12534	1080	2	0	45034	\N
12535	35	2	0	45364	\N
12535	1191	3	0	45365	\N
12547	147	2	0	45414	\N
12547	3287	3	0	45415	\N
12556	10	2	0	45461	\N
12556	275	3	0	45462	\N
12563	447	4	0	45483	\N
12563	33	9	0	45484	\N
12563	447	10	0	45485	\N
12569	353	2	0	43938	\N
12569	2884	3	0	45528	\N
12576	365	4	0	45559	\N
12576	3298	5	0	45560	\N
12578	3300	0	0	45575	\N
12578	3301	0	0	45576	\N
12580	75	6	0	45381	\N
12580	3303	7	0	45591	\N
12584	51	2	0	45416	\N
12584	1260	3	0	45602	\N
12585	316	8	0	43921	\N
12585	3304	9	0	45619	\N
12592	10	4	0	45653	\N
12592	2568	5	0	45654	\N
12598	56	2	0	45158	\N
12598	2795	3	0	45691	\N
12604	488	6	0	43278	\N
12604	3315	7	0	45726	\N
12606	79	2	0	45737	\N
12606	616	3	0	45738	\N
12608	151	2	0	45064	\N
12608	2854	3	0	45745	\N
12614	10	8	0	45781	\N
12614	1798	9	0	45782	\N
12616	119	2	0	45792	\N
12616	1879	3	0	45793	\N
12619	852	4	0	44419	\N
12619	3319	5	0	45813	\N
12626	268	2	0	45853	\N
12626	2800	3	0	45854	\N
12629	86	0	0	45847	\N
12630	86	0	0	45847	\N
12634	4	2	0	45866	\N
12634	2751	3	0	45867	\N
12637	35	6	0	45881	\N
12637	3323	7	0	45882	\N
12641	92	2	0	43498	\N
12641	2763	3	0	45931	\N
12644	110	3	0	45062	\N
12644	3328	4	0	45937	\N
12645	170	2	0	44893	\N
12645	1380	3	0	45940	\N
12653	336	2	0	45980	\N
12653	3332	3	0	45981	\N
12663	108	1	0	45594	\N
12663	3022	2	0	46033	\N
12665	79	5	0	45737	\N
12665	3341	6	0	46044	\N
12672	137	5	0	45176	\N
12672	3346	6	0	46072	\N
12674	908	2	0	46078	\N
12674	2832	3	0	46079	\N
12679	10	2	0	46098	\N
12679	275	3	0	46099	\N
12681	112	2	0	46106	\N
12681	1	5	0	46111	\N
12693	1	1	0	46151	\N
12693	53	2	0	46152	\N
12695	51	2	0	46156	\N
12695	1260	3	0	46157	\N
12698	10	2	0	46172	\N
12698	275	3	0	46173	\N
12700	258	2	0	45085	\N
12700	3275	3	0	45280	\N
12705	391	2	0	46192	\N
12705	1381	3	0	46207	\N
12710	214	4	0	46223	\N
12710	3355	5	0	46224	\N
12715	453	6	0	45475	\N
12715	3358	7	0	46249	\N
12717	75	6	0	45860	\N
12717	3361	7	0	46253	\N
12721	336	2	0	46291	\N
12721	3332	3	0	46292	\N
12550	3288	0	0	45418	\N
12553	90	6	0	45435	\N
12553	3292	7	0	45436	\N
12561	10	4	0	45461	\N
12561	2568	5	0	45477	\N
12565	115	2	0	45494	\N
12565	2797	3	0	45495	\N
12568	10	9	0	45522	\N
12568	2057	10	0	45523	\N
12573	125	2	0	42691	\N
12573	3297	3	0	45542	\N
12575	528	2	0	45549	\N
12575	2765	3	0	45550	\N
12579	27	6	0	45589	\N
12579	3302	7	0	45590	\N
12582	108	1	0	45594	\N
12582	109	2	0	45595	\N
12589	230	2	0	45635	\N
12589	3307	3	0	45637	\N
12590	244	2	0	45642	\N
12590	3308	3	0	45643	\N
12591	10	0	0	45644	\N
12594	42	2	0	44200	\N
12594	3310	3	0	45661	\N
12597	1	2	0	45685	\N
12597	283	3	0	45686	\N
12600	1	2	0	45702	\N
12600	283	3	0	45703	\N
12603	167	6	0	45724	\N
12603	3314	7	0	45725	\N
12605	841	2	0	45731	\N
12605	3316	3	0	45732	\N
12613	268	8	0	45779	\N
12613	3318	9	0	45780	\N
12618	181	4	0	45710	\N
12618	2356	5	0	45804	\N
12622	73	4	0	45840	\N
12622	2827	5	0	45841	\N
12631	424	2	0	45164	\N
12631	2755	3	0	45859	\N
12635	167	2	0	45724	\N
12635	3322	3	0	45868	\N
12639	117	6	0	43047	\N
12639	3325	7	0	45896	\N
12643	110	2	0	45062	\N
12643	626	3	0	45934	\N
12647	1	2	0	45947	\N
12647	283	3	0	45948	\N
12655	391	7	0	45529	\N
12655	3334	8	0	45996	\N
12657	3336	3	0	46004	\N
12657	3337	4	0	46005	\N
12659	326	3	0	46012	\N
12659	3339	4	0	46013	\N
12667	235	3	0	46052	\N
12667	3343	4	0	46053	\N
12670	300	2	0	46059	\N
12670	2786	3	0	46060	\N
12683	35	2	0	46120	\N
12683	1191	3	0	46121	\N
12685	360	2	0	44996	\N
12685	2767	3	0	46128	\N
12687	27	2	0	45589	\N
12687	645	3	0	46135	\N
12689	69	2	0	46140	\N
12689	3350	3	0	46141	\N
12692	44	2	0	46149	\N
12692	1910	3	0	46150	\N
12696	86	4	0	46166	\N
12696	2576	5	0	46167	\N
12702	528	4	0	45549	\N
12702	3353	5	0	46194	\N
12704	42	2	0	46201	\N
12704	3310	3	0	46202	\N
12707	16	2	0	46210	\N
12707	388	3	0	46211	\N
12713	1	2	0	46233	\N
12713	283	3	0	46234	\N
12719	10	4	0	46273	\N
12719	2568	5	0	46274	\N
12720	75	6	0	45860	\N
12720	3361	7	0	46253	\N
12723	326	4	0	46303	\N
12723	3362	5	0	46304	\N
12730	75	2	0	46337	\N
12730	284	3	0	46338	\N
12740	251	2	0	46367	\N
12740	1851	3	0	46368	\N
12741	1109	2	0	42700	\N
12741	2809	3	0	46373	\N
12752	1470	10	0	46421	\N
12752	3375	11	0	46435	\N
12754	1	11	0	46233	\N
12754	3377	12	0	46460	\N
12757	336	4	0	46481	\N
12757	3378	5	0	46482	\N
12762	40	4	0	46388	\N
12762	3381	5	0	46508	\N
12770	3384	3	0	46543	\N
12773	164	3	0	46080	\N
12773	3385	4	0	46551	\N
12782	231	2	0	46572	\N
12782	230	8	0	46583	\N
12782	3389	9	0	46588	\N
12789	108	0	0	45594	\N
12799	214	2	0	46223	\N
12799	1259	3	0	46677	\N
12805	1	2	0	46678	\N
12805	283	3	0	46679	\N
12806	391	2	0	46704	\N
12806	406	3	0	46705	\N
12811	40	1	0	46549	\N
12811	41	2	0	46716	\N
12816	10	1	0	46556	\N
12816	11	2	0	46735	\N
12824	16	1	0	46759	\N
12824	17	2	0	46760	\N
12827	322	1	0	46129	\N
12827	323	2	0	46130	\N
12829	852	2	0	46772	\N
12829	1325	3	0	46773	\N
12831	192	1	0	46777	\N
12831	193	2	0	46778	\N
12834	110	1	0	45062	\N
12834	134	2	0	46783	\N
12842	10	2	0	46814	\N
12842	275	3	0	46815	\N
12851	230	2	0	46844	\N
12851	3307	3	0	46845	\N
12853	10	2	0	46852	\N
12853	275	3	0	46853	\N
12856	10	4	0	46868	\N
12856	2568	5	0	46869	\N
12858	285	2	0	44725	\N
12858	3036	3	0	46876	\N
12861	82	8	0	46895	\N
12861	3414	9	0	46896	\N
12865	316	7	0	46916	\N
12865	3417	8	0	46917	\N
12872	170	2	0	46877	\N
12872	1380	3	0	46878	\N
12875	35	4	0	46120	\N
12875	1875	5	0	46987	\N
12879	424	2	0	47001	\N
12879	2755	3	0	47002	\N
12881	391	2	0	46704	\N
12881	1381	3	0	47010	\N
12895	2578	0	0	47035	\N
12897	1163	2	0	11884	\N
12897	3427	3	0	47042	\N
12902	1470	4	0	47064	\N
12902	2798	5	0	47065	\N
12907	241	4	0	47085	\N
12907	2122	5	0	47086	\N
12909	125	1	0	46225	\N
12909	1185	2	0	47093	\N
12654	3333	8	0	45995	\N
12661	10	6	0	45997	\N
12661	2579	7	0	46026	\N
12664	108	2	0	45594	\N
12664	3340	3	0	46034	\N
12666	33	3	0	46050	\N
12666	3342	4	0	46051	\N
12675	164	2	0	46080	\N
12675	1124	3	0	46081	\N
12677	206	4	0	46092	\N
12677	3348	5	0	46093	\N
12680	1	2	0	46100	\N
12680	283	3	0	46101	\N
12682	300	2	0	46118	\N
12682	2786	3	0	46119	\N
12684	230	2	0	46126	\N
12684	3307	3	0	46127	\N
12691	54	2	0	45055	\N
12691	3351	3	0	46148	\N
12701	391	4	0	46192	\N
12701	3352	5	0	46193	\N
12703	92	2	0	46199	\N
12703	2763	3	0	46200	\N
12706	40	2	0	46208	\N
12706	282	3	0	46209	\N
12708	94	2	0	46212	\N
12708	2794	3	0	46213	\N
12711	125	4	0	46225	\N
12711	3356	5	0	46226	\N
12712	79	2	0	46231	\N
12712	616	3	0	46232	\N
12716	3359	61	0	46250	\N
12716	453	126	0	46251	\N
12716	3360	127	0	46252	\N
12718	260	5	0	46263	\N
12718	2365	6	0	46264	\N
12722	200	4	0	46301	\N
12722	2811	5	0	46302	\N
12726	102	2	0	46314	\N
12726	3053	3	0	46315	\N
12727	362	6	0	45379	\N
12727	3365	7	0	46328	\N
12732	1470	2	0	46341	\N
12732	3368	3	0	46345	\N
12734	1	2	0	46233	\N
12734	283	3	0	46234	\N
12736	16	6	0	46210	\N
12736	3369	7	0	46359	\N
12739	121	2	0	46364	\N
12739	2498	3	0	46366	\N
12743	206	2	0	46380	\N
12743	2773	3	0	46381	\N
12748	1	5	0	46233	\N
12748	2382	6	0	46403	\N
12751	1470	4	0	46421	\N
12751	3374	5	0	46422	\N
12756	2782	4	0	46471	\N
12756	2783	5	0	46472	\N
12765	320	0	0	45629	\N
12767	1	2	0	46233	\N
12767	283	3	0	46234	\N
12772	40	2	0	46549	\N
12772	282	3	0	46550	\N
12775	164	2	0	46080	\N
12775	1124	3	0	46081	\N
12780	1	1	0	46566	\N
12780	1085	2	0	46567	\N
12781	231	2	0	46572	\N
12781	230	8	0	46583	\N
12781	3386	9	1	46584	\N
12781	1697	9	0	46585	\N
12781	3388	10	1	46586	\N
12781	3387	10	0	46587	\N
12784	2	4	0	46599	\N
12784	2830	5	0	46600	\N
12786	449	0	0	46346	\N
12792	841	9	0	46247	\N
12792	3395	10	0	46643	\N
12794	4	2	0	45866	\N
12794	2751	3	0	45867	\N
12796	56	6	0	46657	\N
12796	3398	7	0	46658	\N
12801	336	3	0	46686	\N
12801	3400	4	0	46687	\N
12804	1470	2	0	46421	\N
12804	3368	3	0	46699	\N
12808	56	2	0	46657	\N
12808	169	3	0	46708	\N
12810	10	0	0	46556	\N
12814	266	3	0	46725	\N
12814	405	4	0	46726	\N
12821	1	2	0	46678	\N
12821	112	3	0	46751	\N
12826	40	1	0	46766	\N
12826	41	2	0	46767	\N
12828	10	1	0	46770	\N
12828	11	2	0	46771	\N
12830	852	1	0	46772	\N
12830	913	2	0	46774	\N
12837	3403	1	0	46788	\N
12837	3404	1	0	46789	\N
12839	2	1	0	46599	\N
12839	26	2	0	46798	\N
12846	40	2	0	46816	\N
12846	282	3	0	46817	\N
12848	3411	17	0	46830	\N
12848	424	90	0	46831	\N
12848	3412	91	0	46832	\N
12850	435	2	0	45025	\N
12850	3413	3	0	46839	\N
12855	16	2	0	46854	\N
12855	388	3	0	46855	\N
12860	110	2	0	45062	\N
12860	626	3	0	45934	\N
12863	56	9	0	46899	\N
12863	3415	10	0	46900	\N
12864	58	7	0	45156	\N
12864	3416	8	0	46915	\N
12869	285	9	0	44725	\N
12869	3421	10	0	46966	\N
12874	391	4	0	46704	\N
12874	3352	5	0	46986	\N
12883	242	2	0	47012	\N
12883	3425	3	0	47013	\N
12885	10	2	0	46868	\N
12885	275	3	0	46975	\N
12887	741	2	0	25850	\N
12887	3426	3	0	47023	\N
12898	230	2	0	47047	\N
12898	3307	3	0	47048	\N
12901	14	2	0	45002	\N
12901	1785	3	0	47055	\N
12904	322	4	0	46129	\N
12904	3429	5	0	47068	\N
12905	202	2	0	47073	\N
12905	2764	3	0	47074	\N
12908	20	2	0	47091	\N
12908	369	3	0	47092	\N
12910	92	1	0	46199	\N
12910	1078	2	0	47096	\N
12911	60	8	0	47113	\N
12911	3431	9	0	47114	\N
12924	16	2	0	47161	\N
12924	388	3	0	47162	\N
12929	326	2	0	46303	\N
12929	393	3	0	47185	\N
12931	75	2	0	46562	\N
12931	284	3	0	46563	\N
12933	224	2	0	47194	\N
12933	3150	3	0	47195	\N
12936	1	8	0	47147	\N
12936	3432	9	0	47220	\N
12938	20	2	0	47226	\N
12938	369	3	0	47227	\N
12943	43	1	0	47241	\N
12656	3335	8	0	45998	\N
12658	200	3	0	44863	\N
12658	3338	4	0	46006	\N
12660	10	3	0	45997	\N
12660	3173	4	0	46014	\N
12662	186	2	0	46031	\N
12662	1850	3	0	46032	\N
12668	62	3	0	45023	\N
12668	3344	4	0	46054	\N
12671	411	5	0	46070	\N
12671	3345	6	0	46071	\N
12673	135	5	0	43567	\N
12673	3347	6	0	46073	\N
12676	365	4	0	46090	\N
12676	3298	5	0	46091	\N
12678	16	2	0	45932	\N
12678	388	3	0	45933	\N
12686	322	1	0	46129	\N
12686	323	2	0	46130	\N
12688	10	2	0	46098	\N
12688	275	3	0	46099	\N
12690	10	2	0	46142	\N
12690	275	3	0	46143	\N
12694	58	2	0	45156	\N
12694	2853	3	0	46155	\N
12697	54	2	0	45055	\N
12697	3351	3	0	46148	\N
12699	10	2	0	46178	\N
12699	275	3	0	46179	\N
12709	251	4	0	43439	\N
12709	3354	5	0	46222	\N
12714	841	6	0	46247	\N
12714	3357	7	0	46248	\N
12725	3363	35	0	46307	\N
12725	2244	36	0	46308	\N
12725	3364	36	0	46309	\N
12728	453	2	0	46333	\N
12728	3366	3	0	46334	\N
12737	40	2	0	46208	\N
12737	282	3	0	46209	\N
12744	96	2	0	46386	\N
12744	2347	3	0	46387	\N
12746	10	2	0	46390	\N
12746	275	3	0	46391	\N
12753	90	10	0	46436	\N
12753	3376	11	0	46437	\N
12755	16	11	0	46461	\N
12755	2281	12	0	46462	\N
12758	27	4	0	45589	\N
12758	3379	5	0	46483	\N
12760	233	5	0	38330	\N
12760	3380	6	0	46494	\N
12763	528	2	0	46513	\N
12763	2765	3	0	46514	\N
12768	324	2	0	44403	\N
12768	2808	3	0	46536	\N
12774	324	2	0	44403	\N
12774	2808	3	0	46536	\N
12776	2982	2	0	46552	\N
12776	3383	3	0	46553	\N
12777	10	1	0	46556	\N
12777	1416	2	0	46557	\N
12779	75	2	0	46562	\N
12779	284	3	0	46563	\N
12785	451	4	0	40159	\N
12785	3391	5	0	46609	\N
12787	82	6	0	46614	\N
12787	3392	7	0	46615	\N
12790	108	2	0	45594	\N
12790	3340	3	0	46034	\N
12795	260	7	0	46655	\N
12795	3397	8	0	46656	\N
12797	260	3	0	46665	\N
12797	3399	4	0	46666	\N
12800	1	2	0	46678	\N
12800	283	3	0	46679	\N
12802	82	2	0	46692	\N
12802	3401	3	0	46693	\N
12807	151	3	0	46706	\N
12807	3402	4	0	46707	\N
12809	30	3	0	44375	\N
12809	1932	4	0	46713	\N
12812	92	3	0	46199	\N
12812	180	4	0	46723	\N
12817	453	0	0	46736	\N
12819	200	1	0	46301	\N
12819	201	2	0	46742	\N
12822	86	1	0	46754	\N
12822	87	2	0	46755	\N
12832	273	1	0	46779	\N
12832	410	2	0	46780	\N
12840	402	4	0	46807	\N
12840	3409	5	0	46808	\N
12843	40	2	0	46816	\N
12843	282	3	0	46817	\N
12847	424	2	0	46828	\N
12847	2755	3	0	46829	\N
12849	79	2	0	46837	\N
12849	616	3	0	46838	\N
12852	273	2	0	46846	\N
12852	1413	3	0	46847	\N
12854	16	2	0	46854	\N
12854	388	3	0	46855	\N
12857	40	4	0	46870	\N
12857	2796	5	0	46871	\N
12859	170	2	0	46877	\N
12859	1380	3	0	46878	\N
12866	56	6	0	46897	\N
12866	3418	7	0	46930	\N
12867	192	8	0	46777	\N
12867	3419	9	0	46947	\N
12870	1	2	0	46781	\N
12870	283	3	0	46818	\N
12873	16	2	0	46976	\N
12873	388	3	0	46977	\N
12876	82	4	0	46988	\N
12876	3422	5	0	46989	\N
12877	100	2	0	46994	\N
12877	633	3	0	46995	\N
12880	3423	53	0	47003	\N
12880	424	63	0	47004	\N
12880	3424	64	0	47005	\N
12882	33	2	0	46050	\N
12882	2822	3	0	47011	\N
12886	86	2	0	46754	\N
12886	3321	3	0	47018	\N
12888	451	2	0	40159	\N
12888	3317	3	0	45752	\N
12890	451	2	0	40159	\N
12890	3317	3	0	45752	\N
12891	741	2	0	25850	\N
12891	3426	3	0	47023	\N
12894	10	2	0	46868	\N
12894	275	3	0	46975	\N
12896	214	2	0	47036	\N
12896	1259	3	0	47037	\N
12899	1	2	0	47049	\N
12899	283	3	0	47050	\N
12906	279	4	0	47083	\N
12906	3430	5	0	47084	\N
12914	10	2	0	46868	\N
12914	275	3	0	46975	\N
12916	3433	15	0	47124	\N
12916	164	44	0	47125	\N
12916	3434	45	0	47126	\N
12917	290	4	0	47135	\N
12917	2759	5	0	47136	\N
12919	16	2	0	46976	\N
12919	388	3	0	46977	\N
12930	424	61	0	47186	\N
12930	3437	62	0	47187	\N
12939	137	2	0	45176	\N
12939	2721	3	0	47232	\N
12941	69	2	0	46140	\N
12941	3350	3	0	46141	\N
12946	88	2	0	44446	\N
12946	2799	3	0	44447	\N
12724	10	4	0	46305	\N
12724	2568	5	0	46306	\N
12729	453	59	0	46335	\N
12729	3367	60	0	46336	\N
12731	1470	1	0	46341	\N
12731	1471	2	0	46342	\N
12733	449	2	0	46346	\N
12733	646	3	0	46347	\N
12735	10	0	0	46348	\N
12738	121	1	0	46364	\N
12738	122	2	0	46365	\N
12742	411	2	0	46378	\N
12742	3370	3	0	46379	\N
12745	40	2	0	46388	\N
12745	282	3	0	46389	\N
12747	362	5	0	46401	\N
12747	3371	6	0	46402	\N
12749	362	3	0	46401	\N
12749	3372	4	0	46404	\N
12750	56	5	0	46411	\N
12750	3373	6	0	46412	\N
12759	435	4	0	45025	\N
12759	2810	5	0	45313	\N
12761	242	2	0	43773	\N
12761	620	3	0	46499	\N
12764	402	6	0	44985	\N
12764	3382	7	0	46527	\N
12766	320	0	0	45629	\N
12769	2982	2	0	46537	\N
12769	3383	3	0	46538	\N
12771	192	2	0	45021	\N
12771	2761	3	0	46548	\N
12778	1	2	0	46560	\N
12778	283	3	0	46561	\N
12783	273	4	0	46597	\N
12783	3390	5	0	46598	\N
12788	1	3	0	46622	\N
12788	3393	4	0	46623	\N
12791	841	5	0	46247	\N
12791	3394	6	0	46636	\N
12793	4	7	0	45866	\N
12793	3396	8	0	46650	\N
12798	16	2	0	46671	\N
12798	388	3	0	46672	\N
12803	1470	1	0	46421	\N
12803	1471	2	0	46696	\N
12813	156	3	0	44891	\N
12813	407	4	0	46724	\N
12815	402	2	0	46731	\N
12815	1148	3	0	46732	\N
12818	453	1	0	46333	\N
12818	454	2	0	46739	\N
12820	71	1	0	46745	\N
12820	72	2	0	46746	\N
12823	164	1	0	46080	\N
12823	165	2	0	46756	\N
12825	60	1	0	45104	\N
12825	61	2	0	46763	\N
12833	1	1	0	46781	\N
12833	53	2	0	46782	\N
12835	110	1	0	45062	\N
12835	134	2	0	46783	\N
12836	235	1	0	46786	\N
12836	236	2	0	46787	\N
12838	235	1	0	46786	\N
12838	3204	2	1	46792	\N
12838	3407	2	0	46793	\N
12838	1075	3	1	46794	\N
12838	3408	3	0	46795	\N
12841	251	4	0	46367	\N
12841	3410	5	0	46809	\N
12844	1	2	0	46781	\N
12844	283	3	0	46818	\N
12845	151	2	0	46706	\N
12845	2854	3	0	46823	\N
12862	56	1	0	46897	\N
12862	57	2	0	46898	\N
12868	365	8	0	46090	\N
12868	3420	9	0	46948	\N
12871	10	2	0	46868	\N
12871	275	3	0	46975	\N
12878	264	2	0	44931	\N
12878	2780	3	0	46996	\N
12889	451	2	0	40159	\N
12889	3317	3	0	45752	\N
12892	181	0	0	47024	\N
12893	167	2	0	47029	\N
12893	3322	3	0	47030	\N
12900	10	2	0	46868	\N
12900	275	3	0	46975	\N
12903	167	4	0	47066	\N
12903	3428	5	0	47067	\N
12913	56	8	0	47116	\N
12913	2431	9	0	47117	\N
12915	164	2	0	47122	\N
12915	1124	3	0	47123	\N
12921	1	2	0	47147	\N
12921	283	3	0	47148	\N
12923	10	2	0	47159	\N
12923	275	3	0	47160	\N
12926	189	4	0	47173	\N
12926	3436	5	0	47174	\N
12928	424	2	0	47183	\N
12928	2755	3	0	47184	\N
12932	411	2	0	47192	\N
12932	3370	3	0	47193	\N
12940	135	2	0	43567	\N
12940	2722	3	0	47233	\N
12942	69	1	0	46140	\N
12942	70	2	0	47238	\N
12947	1470	2	0	47064	\N
12947	3368	3	0	47257	\N
12951	42	4	0	47277	\N
12951	2821	5	0	47278	\N
12953	189	2	0	47289	\N
12953	3441	3	0	47290	\N
12956	290	1	0	47302	\N
12956	2952	2	0	47303	\N
12960	1109	0	0	47316	\N
12964	40	6	0	47350	\N
12964	2777	7	0	47351	\N
12966	285	2	0	47362	\N
12966	3036	3	0	47363	\N
12971	360	2	0	44996	\N
12971	2767	3	0	46128	\N
12975	10	2	0	47368	\N
12975	275	3	0	47369	\N
12978	16	3	0	47389	\N
12978	1045	4	0	47390	\N
12980	202	2	0	47400	\N
12980	2764	3	0	47401	\N
12983	233	1	0	47402	\N
12983	1418	2	0	47405	\N
12984	73	2	0	47410	\N
12984	2766	3	0	47411	\N
12990	142	4	0	47433	\N
12990	3446	5	0	47434	\N
12991	391	2	0	47439	\N
12991	1381	3	0	47440	\N
12994	3051	4	0	43246	\N
12994	3448	4	0	47460	\N
12994	3451	6	0	47463	\N
13011	488	2	0	47518	\N
13011	2791	3	0	47519	\N
13012	391	1	0	47522	\N
13012	392	2	0	47523	\N
13015	326	2	0	47538	\N
13015	393	3	0	47539	\N
13022	290	2	0	47580	\N
13022	1909	3	0	47581	\N
13025	16	0	0	47389	\N
13027	2351	4	0	45171	\N
13027	3463	5	0	47595	\N
13030	6	5	0	47613	\N
13030	2852	6	0	47614	\N
12912	1	8	0	47049	\N
12912	3432	9	0	47115	\N
12918	2	4	0	47137	\N
12918	2830	5	0	47138	\N
12920	10	2	0	46868	\N
12920	275	3	0	46975	\N
12922	10	2	0	47153	\N
12922	275	3	0	47154	\N
12925	90	4	0	47171	\N
12925	3435	5	0	47172	\N
12927	391	2	0	46704	\N
12927	1381	3	0	47010	\N
12934	336	2	0	47200	\N
12934	3332	3	0	47201	\N
12935	40	8	0	47218	\N
12935	3438	9	0	47219	\N
12937	75	8	0	46562	\N
12937	3439	9	0	47221	\N
12944	107	1	0	47246	\N
12944	94	4	0	47247	\N
12944	2043	5	0	47248	\N
12950	10	4	0	47275	\N
12950	2568	5	0	47276	\N
12952	90	2	0	47283	\N
12952	3442	3	0	47284	\N
12955	4	2	0	47300	\N
12955	2751	3	0	47301	\N
12963	33	6	0	47348	\N
12963	3444	7	0	47349	\N
12970	595	2	0	42551	\N
12970	3285	3	0	45412	\N
12974	597	2	0	47375	\N
12974	3286	3	0	47376	\N
12977	38	3	0	45327	\N
12977	3445	4	0	47388	\N
12979	64	2	0	39371	\N
12979	277	3	0	47395	\N
12987	453	2	0	47420	\N
12987	3366	3	0	47421	\N
12989	79	4	0	46837	\N
12989	2758	5	0	47432	\N
12998	75	4	0	46562	\N
12998	2357	5	0	47467	\N
13001	82	2	0	46988	\N
13001	3401	3	0	47474	\N
13002	322	1	0	47477	\N
13002	2968	2	0	47478	\N
13008	67	2	0	43902	\N
13008	394	3	0	47404	\N
13013	38	3	0	47530	\N
13013	3457	4	0	47531	\N
13018	214	6	0	47564	\N
13018	3460	7	0	47565	\N
13021	1151	3	0	47574	\N
13021	3462	4	0	47575	\N
13023	266	2	0	46725	\N
13023	2103	3	0	47582	\N
13034	3467	3	0	47640	\N
13034	258	4	0	47641	\N
13041	1	8	0	47712	\N
13041	3471	9	0	47713	\N
13044	77	3	0	47734	\N
13044	1877	4	0	47735	\N
13049	2636	5	0	45041	\N
13049	3476	6	0	47774	\N
13053	94	2	0	47784	\N
13053	2794	3	0	47785	\N
13056	125	5	0	46225	\N
13056	2847	6	0	47804	\N
13059	147	16	0	45414	\N
13059	3481	17	0	47840	\N
13063	54	19	0	45055	\N
13063	3485	20	0	47890	\N
13066	6	4	0	47901	\N
13066	3487	5	0	47902	\N
13072	263	1	0	47936	\N
13072	262	5	0	47937	\N
13072	3492	6	0	47938	\N
13076	10	4	0	47957	\N
13076	3493	5	0	47958	\N
13079	214	3	0	47968	\N
13079	3496	4	0	47969	\N
13083	151	4	0	46706	\N
13083	3499	5	0	47981	\N
13087	40	8	0	48002	\N
13087	3503	9	0	48003	\N
13090	10	3	0	48020	\N
13090	3173	4	0	48021	\N
13092	54	6	0	45055	\N
13092	3507	7	0	48038	\N
13095	908	8	0	47903	\N
13095	3509	9	0	48071	\N
13100	360	4	0	44996	\N
13100	3513	5	0	48101	\N
13108	326	4	0	48133	\N
13108	3519	5	0	48134	\N
13109	451	6	0	48147	\N
13109	3520	7	0	48148	\N
13114	1368	3	0	28929	\N
13114	3532	3	0	48193	\N
13114	3533	4	0	48194	\N
13116	23	3	0	47587	\N
13116	3497	4	0	47971	\N
13122	10	3	0	48263	\N
13122	3173	4	0	48264	\N
13125	94	3	0	48283	\N
13125	2864	4	0	48284	\N
12943	42	4	0	47244	\N
12943	3440	5	0	47245	\N
12945	88	2	0	44446	\N
12945	2799	3	0	44447	\N
12949	189	2	0	47173	\N
12949	3441	3	0	47266	\N
12954	322	2	0	46129	\N
12954	1866	3	0	47295	\N
12959	40	2	0	47218	\N
12959	282	3	0	47315	\N
12962	23	2	0	47334	\N
12962	3443	3	0	47335	\N
12965	1	2	0	47356	\N
12965	283	3	0	47357	\N
12968	2	2	0	47137	\N
12968	2789	3	0	47370	\N
12973	147	2	0	45414	\N
12973	3287	3	0	45415	\N
12976	75	3	0	46562	\N
12976	713	4	0	47381	\N
12982	67	2	0	43902	\N
12982	394	3	0	47404	\N
12986	316	2	0	47418	\N
12986	1900	3	0	47419	\N
12988	10	4	0	47430	\N
12988	2568	5	0	47431	\N
12993	210	0	0	47451	\N
12996	35	4	0	47465	\N
12996	1875	5	0	47466	\N
12997	35	4	0	47465	\N
12997	1875	5	0	47466	\N
13000	140	2	0	47472	\N
13000	3183	3	0	47473	\N
13004	1572	2	0	19405	\N
13004	3453	3	0	47492	\N
13007	40	6	0	47507	\N
13007	2777	7	0	47508	\N
13010	2627	2	0	39189	\N
13010	3456	3	0	47517	\N
13014	86	2	0	47536	\N
13014	3321	3	0	47537	\N
13017	12	5	0	47551	\N
13017	3459	6	0	47552	\N
13020	79	3	0	47573	\N
13020	1168	4	0	46838	\N
13024	23	2	0	47587	\N
13024	3443	3	0	47588	\N
13026	51	4	0	47593	\N
13026	2360	5	0	47594	\N
13029	40	5	0	47611	\N
13029	2714	6	0	47612	\N
13032	244	2	0	47635	\N
13032	3308	3	0	47636	\N
13035	40	18	0	47611	\N
13035	3468	19	0	47678	\N
13038	40	3	0	47693	\N
13038	372	4	0	47694	\N
13040	60	8	0	47113	\N
13040	3470	9	0	47711	\N
13045	200	8	0	47752	\N
13045	3473	9	0	47753	\N
13051	62	5	0	45023	\N
13051	3478	6	0	47777	\N
13054	1	2	0	47790	\N
13054	2950	3	0	47791	\N
13057	595	16	0	47837	\N
13057	3479	17	0	47838	\N
13060	16	16	0	47778	\N
13060	3482	17	0	47841	\N
13061	115	3	0	47848	\N
13061	3483	4	0	47849	\N
13064	44	4	0	46149	\N
13064	3486	5	0	47899	\N
13069	10	8	0	47775	\N
13069	3490	9	0	47923	\N
13074	263	1	0	47936	\N
13074	262	2	0	47937	\N
13075	10	6	0	47947	\N
13075	1946	7	0	47948	\N
13080	242	3	0	47012	\N
13080	2839	4	0	47970	\N
13091	1	1	0	48024	\N
13091	53	2	0	48025	\N
13097	2	4	0	47137	\N
13097	3510	5	0	48082	\N
13103	251	3	0	46367	\N
13103	3514	4	0	48111	\N
13106	3517	0	0	48125	\N
13111	1	2	0	48171	\N
13111	112	3	0	48172	\N
13113	3529	4	0	48184	\N
13113	3530	4	0	48185	\N
13113	3531	5	0	48186	\N
13118	1722	8	0	48218	\N
13118	3534	9	0	48219	\N
13120	210	4	0	47571	\N
13120	3536	5	0	48230	\N
13121	687	12	0	48255	\N
13121	3537	13	0	48256	\N
13127	200	12	0	48309	\N
13127	3540	13	0	48310	\N
12948	262	2	0	44136	\N
12948	2743	3	0	44137	\N
12957	290	2	0	47302	\N
12957	1909	3	0	47304	\N
12958	200	2	0	47309	\N
12958	276	3	0	47310	\N
12961	10	6	0	47275	\N
12961	2718	7	0	47329	\N
12967	10	2	0	47368	\N
12967	275	3	0	47369	\N
12969	16	2	0	47161	\N
12969	388	3	0	47162	\N
12972	10	2	0	47368	\N
12972	275	3	0	47369	\N
12981	233	2	0	47402	\N
12981	1849	3	0	47403	\N
12985	453	1	0	47412	\N
12985	454	2	0	47413	\N
12992	244	4	0	47449	\N
12992	3447	5	0	47450	\N
12995	290	4	0	47302	\N
12995	2759	5	0	47464	\N
12999	140	2	0	47472	\N
12999	3183	3	0	47473	\N
13003	12	6	0	44166	\N
13003	3452	7	0	47491	\N
13005	12	5	0	44166	\N
13005	3454	6	0	47493	\N
13006	16	5	0	47389	\N
13006	3455	6	0	47494	\N
13009	326	2	0	46303	\N
13009	393	3	0	47185	\N
13016	336	5	0	47549	\N
13016	3458	6	0	47550	\N
13019	210	3	0	47571	\N
13019	3461	4	0	47572	\N
13028	3464	2	0	47600	\N
13028	3465	3	0	47601	\N
13031	192	7	0	47629	\N
13031	3466	8	0	47630	\N
13037	2636	3	0	45041	\N
13037	2837	4	0	47692	\N
13042	60	8	0	47113	\N
13042	3470	9	0	47711	\N
13050	10	5	0	47775	\N
13050	3477	6	0	47776	\N
13067	908	4	0	47903	\N
13067	3488	5	0	47904	\N
13068	14	8	0	47921	\N
13068	3489	9	0	47922	\N
13073	53	1	0	47939	\N
13073	1	2	0	47940	\N
13077	2351	4	0	47959	\N
13077	3494	5	0	47960	\N
13084	324	4	0	44403	\N
13084	3500	5	0	47982	\N
13088	435	3	0	48010	\N
13088	3504	4	0	48011	\N
13093	151	3	0	46706	\N
13093	3046	4	0	48045	\N
13096	40	4	0	48080	\N
13096	3381	5	0	48081	\N
13098	206	4	0	46380	\N
13098	3511	5	0	48091	\N
13099	242	4	0	47012	\N
13099	3512	5	0	48092	\N
13101	10	4	0	48020	\N
13101	3493	5	0	48102	\N
13105	119	1	0	45792	\N
13105	120	2	0	48123	\N
13110	3521	6	0	48161	\N
13110	3522	9	0	48166	\N
13110	3523	9	0	48167	\N
13110	3525	10	1	48168	\N
13110	3524	10	0	48169	\N
13110	3526	11	0	48170	\N
13112	3527	6	0	48173	\N
13112	1949	9	0	48174	\N
13112	3528	10	0	48175	\N
13115	51	3	0	47593	\N
13115	3533	4	0	48195	\N
13117	10	3	0	48020	\N
13117	3173	4	0	48021	\N
13123	177	4	0	48273	\N
13123	3538	5	0	48274	\N
13033	1	2	0	47637	\N
13033	283	3	0	47638	\N
13036	1381	2	0	47683	\N
13036	3051	3	0	47684	\N
13036	3469	3	0	47685	\N
13039	2636	3	0	45041	\N
13039	2837	4	0	47692	\N
13043	40	6	0	47726	\N
13043	3472	7	0	47727	\N
13046	266	3	0	47760	\N
13046	3474	4	0	47761	\N
13048	391	5	0	47772	\N
13048	3475	6	0	47773	\N
13052	16	5	0	47778	\N
13052	3455	6	0	47779	\N
13055	1	5	0	47802	\N
13055	2382	6	0	47803	\N
13058	597	16	0	47375	\N
13058	3480	17	0	47839	\N
13062	431	19	0	47888	\N
13062	3484	20	0	47889	\N
13065	18	4	0	39172	\N
13065	2302	5	0	47900	\N
13070	54	8	0	45055	\N
13070	3491	9	0	47924	\N
13071	455	1	0	47927	\N
13071	132	5	0	47934	\N
13071	1423	6	0	47935	\N
13078	1109	3	0	47316	\N
13078	3495	4	0	47967	\N
13081	23	3	0	47587	\N
13081	3497	4	0	47971	\N
13082	14	4	0	47921	\N
13082	3498	5	0	47980	\N
13085	2982	4	0	46552	\N
13085	3501	5	0	47983	\N
13086	279	4	0	47984	\N
13086	3502	5	0	47985	\N
13089	3505	3	0	48018	\N
13089	3506	4	0	48019	\N
13094	82	4	0	46988	\N
13094	3508	5	0	48054	\N
13102	40	4	0	48103	\N
13102	3381	5	0	48104	\N
13104	96	4	0	46386	\N
13104	3515	5	0	48120	\N
13107	119	4	0	45792	\N
13107	3518	5	0	48132	\N
13119	224	8	0	48220	\N
13119	3535	9	0	48221	\N
13124	210	3	0	48281	\N
13124	3539	4	0	48282	\N
13128	2	12	0	47137	\N
13128	3541	13	0	48311	\N
13129	56	10	0	47116	\N
13129	3542	11	0	48312	\N
13130	56	7	0	47116	\N
13130	3543	8	0	48327	\N
13132	30	17	0	48362	\N
13132	3544	18	0	48363	\N
13133	119	4	0	45792	\N
13133	3518	5	0	48132	\N
13134	18	4	0	39172	\N
13134	2302	5	0	47900	\N
13135	14	4	0	47921	\N
13135	3498	5	0	47980	\N
13136	73	4	0	48380	\N
13136	2284	5	0	48381	\N
13137	1	3	0	48171	\N
13137	3393	4	0	48382	\N
13138	10	4	0	48391	\N
13138	3493	5	0	48392	\N
13139	35	4	0	47465	\N
13139	3545	5	0	48393	\N
13140	16	4	0	48394	\N
13140	3546	5	0	48395	\N
13141	1150	1	0	48398	\N
13141	793	9	0	48413	\N
13141	3547	10	0	48414	\N
13142	1150	1	0	48398	\N
13142	793	9	0	48413	\N
13142	3547	10	0	48414	\N
13143	2	3	0	47137	\N
13143	3548	4	0	48421	\N
13144	1109	3	0	47316	\N
13144	3495	4	0	47967	\N
13145	1109	3	0	47316	\N
13145	3495	4	0	47967	\N
13146	1	7	0	48171	\N
13146	1336	8	0	48436	\N
13147	56	21	0	48465	\N
13147	3549	22	0	48466	\N
13148	18	5	0	48477	\N
13148	3550	6	0	48478	\N
13149	56	5	0	48479	\N
13149	3551	6	0	48480	\N
13150	73	2	0	48485	\N
13150	2766	3	0	48486	\N
13151	908	7	0	48487	\N
13151	3552	8	0	48488	\N
13152	908	2	0	48487	\N
13152	2832	3	0	48489	\N
13153	908	2	0	48487	\N
13153	2832	3	0	48489	\N
13154	391	9	0	48508	\N
13154	3553	10	0	48509	\N
13155	1	5	0	48171	\N
13155	1233	6	0	48510	\N
13156	79	4	0	48519	\N
13156	2758	5	0	48520	\N
13157	200	4	0	48521	\N
13157	2811	5	0	48522	\N
13158	79	2	0	48519	\N
13158	80	3	0	48523	\N
13159	212	6	0	48532	\N
13159	3554	7	0	48533	\N
13160	908	6	0	48487	\N
13160	3555	7	0	48534	\N
13161	56	4	0	48535	\N
13161	3556	5	0	48536	\N
13162	235	10	0	48557	\N
13162	3557	11	0	48558	\N
13163	1	1	0	48171	\N
13163	53	2	0	48561	\N
13164	391	5	0	48572	\N
13164	3558	6	0	48573	\N
13165	92	5	0	48574	\N
13165	3559	6	0	48575	\N
13166	33	5	0	47348	\N
13166	3560	6	0	48576	\N
13167	260	2	0	48581	\N
13167	3184	3	0	48582	\N
13168	14	2	0	47921	\N
13168	1785	3	0	48587	\N
13169	4	2	0	48588	\N
13169	2751	3	0	48589	\N
13170	3561	37	0	48590	\N
13170	167	126	0	48591	\N
13170	1075	127	1	48592	\N
13170	3562	127	0	48593	\N
13171	35	3	0	47465	\N
13171	3563	4	0	48600	\N
13172	69	4	0	48609	\N
13172	3564	5	0	48610	\N
13173	431	4	0	48611	\N
13173	3565	5	0	48612	\N
13174	200	4	0	48521	\N
13174	2811	5	0	48522	\N
13175	40	10	0	48633	\N
13175	3566	11	0	48634	\N
13176	264	10	0	44931	\N
13176	3567	11	0	48635	\N
13177	337	3	0	48642	\N
13177	336	13	0	48661	\N
13177	3568	14	0	48662	\N
13178	2596	3	0	48663	\N
13178	86	13	0	48664	\N
13178	3569	14	0	48665	\N
13180	367	9	0	48687	\N
13180	3571	10	0	48688	\N
13189	10	9	0	48391	\N
13189	3578	10	0	48773	\N
13192	1109	9	0	48777	\N
13192	3580	10	0	48783	\N
13196	164	6	0	48790	\N
13196	3583	7	0	48796	\N
13198	60	3	0	47113	\N
13198	3585	4	0	48805	\N
13203	228	2	0	48784	\N
13203	3589	3	0	48840	\N
13208	435	3	0	48863	\N
13208	3504	4	0	48864	\N
13211	53	1	0	48887	\N
13211	1	3	0	48888	\N
13216	102	3	0	48923	\N
13216	3597	4	0	48924	\N
13224	224	3	0	48220	\N
13224	3603	4	0	48963	\N
13233	102	2	0	48988	\N
13233	3574	3	0	48992	\N
13237	424	3	0	48999	\N
13237	3611	4	0	49007	\N
13240	241	3	0	47085	\N
13240	3613	4	0	49009	\N
13247	2636	2	0	49037	\N
13247	2836	3	0	49038	\N
13254	235	6	0	49015	\N
13254	3622	7	0	49081	\N
13257	402	2	0	49100	\N
13257	1148	3	0	49101	\N
13259	94	1	0	49109	\N
13259	107	2	0	49110	\N
13262	1	0	0	49082	\N
13265	3629	8	0	49145	\N
13269	44	3	0	46149	\N
13269	3631	4	0	49160	\N
13274	18	2	0	49172	\N
13274	1685	3	0	49173	\N
13275	241	2	0	47085	\N
13275	634	3	0	49174	\N
13278	1	0	0	49146	\N
13281	1914	0	0	49212	\N
13285	273	3	0	46846	\N
13285	3638	4	0	49239	\N
13290	279	3	0	49265	\N
13290	3641	4	0	49266	\N
13295	2	3	0	48990	\N
13295	3548	4	0	49303	\N
13298	2	3	0	49334	\N
13298	3548	4	0	49335	\N
13301	3647	7	0	49346	\N
13301	92	95	0	49359	\N
13301	3648	96	0	49360	\N
13303	260	9	0	49368	\N
13303	3649	10	0	49369	\N
13310	449	2	0	49396	\N
13310	646	3	0	49397	\N
13313	88	3	0	49406	\N
13313	3655	4	0	49407	\N
13319	2782	3	0	49429	\N
13319	3659	4	0	49430	\N
13322	365	44	0	46090	\N
13322	3661	45	0	49464	\N
13327	56	110	0	48535	\N
13327	3387	111	1	49494	\N
13327	3663	111	0	49495	\N
13327	3664	112	0	49496	\N
13333	3625	10	0	49279	\N
13333	3669	11	0	49547	\N
13349	908	4	0	49654	\N
13349	3488	5	0	49655	\N
13351	908	1	0	49654	\N
13351	909	2	0	49656	\N
13359	793	3	0	49677	\N
13359	2644	4	0	49678	\N
13360	54	4	0	49689	\N
13360	3685	5	0	49690	\N
13364	435	6	0	49712	\N
13364	3688	7	0	49713	\N
13377	16	4	0	49819	\N
13377	3546	5	0	49820	\N
13380	30	1	0	49257	\N
13380	418	2	0	49842	\N
13385	177	3	0	49897	\N
13385	3703	4	0	49898	\N
13397	132	7	0	49961	\N
13397	3709	8	0	49962	\N
13399	69	7	0	49978	\N
13399	3711	8	0	49979	\N
13402	189	6	0	49993	\N
13402	3713	7	0	49994	\N
13406	27	1	0	49995	\N
13406	28	2	0	50001	\N
13419	54	3	0	50105	\N
13419	3041	4	0	50106	\N
13423	186	9	0	50125	\N
13423	3724	10	0	50140	\N
13429	260	4	0	49368	\N
13429	3728	5	0	50173	\N
13431	132	3	0	50182	\N
13431	3729	4	0	50183	\N
13432	10	12	0	50208	\N
13432	3730	13	0	50209	\N
13435	212	4	0	50230	\N
13435	3732	5	0	50231	\N
13437	96	4	0	50242	\N
13437	3515	5	0	50243	\N
13445	3658	3	0	50300	\N
13445	362	10	0	50307	\N
13445	3736	11	0	50308	\N
13448	3738	3	0	50310	\N
13448	137	9	0	50311	\N
13448	3593	10	1	50312	\N
13448	3739	10	0	50313	\N
13448	3740	11	0	50314	\N
13450	908	1	0	50321	\N
13450	909	2	0	50325	\N
13456	181	0	0	47024	\N
13459	336	0	0	49737	\N
13462	300	3	0	50377	\N
13462	3747	4	0	50378	\N
13464	10	3	0	50387	\N
13464	3173	4	0	50388	\N
13474	49	1	0	50439	\N
13474	50	2	0	50443	\N
13475	1	1	0	50163	\N
13475	53	2	0	50164	\N
13478	1	1	0	50454	\N
13478	53	2	0	50455	\N
13484	212	9	0	50230	\N
13484	3757	10	0	50511	\N
13487	186	6	0	50569	\N
13487	3759	7	0	50570	\N
13490	27	6	0	49995	\N
13490	3302	7	0	50584	\N
13497	841	6	0	50625	\N
13497	3769	7	0	50626	\N
13499	2351	3	0	47959	\N
13499	2845	4	0	50633	\N
13504	123	3	0	50651	\N
13504	2856	4	0	50652	\N
13518	233	4	0	47402	\N
13518	3775	5	0	50733	\N
13521	244	4	0	47635	\N
13521	3778	5	0	50745	\N
13525	18	4	0	50413	\N
13525	3779	5	0	50765	\N
13527	3780	5	0	50776	\N
13527	2636	7	0	50779	\N
13527	3207	8	0	50780	\N
13532	16	3	0	50379	\N
13179	1509	3	0	48666	\N
13179	365	13	0	48667	\N
13179	3570	14	0	48668	\N
13181	1	1	0	48691	\N
13181	53	2	0	48692	\N
13183	3573	123	0	48703	\N
13183	102	126	0	48704	\N
13183	3574	127	0	48705	\N
13186	1	2	0	48719	\N
13186	112	3	0	48720	\N
13193	228	8	0	48784	\N
13193	3581	9	0	48785	\N
13199	360	5	0	44996	\N
13199	3586	6	0	48816	\N
13204	373	3	0	37901	\N
13204	3590	4	0	48847	\N
13214	18	5	0	48477	\N
13214	3550	6	0	48478	\N
13219	1	2	0	48941	\N
13219	112	3	0	48942	\N
13221	198	7	0	48951	\N
13221	3601	8	0	48952	\N
13225	841	3	0	48961	\N
13225	3604	4	0	48964	\N
13226	224	69	0	48220	\N
13226	3605	70	0	48965	\N
13228	173	6	0	48979	\N
13228	3606	7	0	48980	\N
13230	67	7	0	48981	\N
13230	3608	8	0	48985	\N
13241	173	4	0	48979	\N
13241	3614	5	0	49014	\N
13243	235	4	0	49015	\N
13243	3615	5	0	49025	\N
13245	212	2	0	49032	\N
13245	3616	3	0	49033	\N
13248	2636	4	0	49037	\N
13248	3617	5	0	49043	\N
13252	18	3	0	49066	\N
13252	3621	4	0	49067	\N
13255	1	0	0	49082	\N
13258	402	4	0	49100	\N
13258	2548	5	0	49106	\N
13260	2575	4	0	49119	\N
13260	16	6	0	49122	\N
13260	1087	7	0	49123	\N
13266	1	0	0	49146	\N
13267	10	3	0	48940	\N
13267	297	4	0	49151	\N
13270	264	3	0	49161	\N
13270	3632	4	0	49162	\N
13282	18	3	0	49172	\N
13282	3621	4	0	49218	\N
13286	10	3	0	49170	\N
13286	3173	4	0	49240	\N
13288	96	3	0	49255	\N
13288	2803	4	0	49256	\N
13291	3625	6	0	49279	\N
13291	3642	7	0	49280	\N
13296	322	4	0	49312	\N
13296	3429	5	0	49313	\N
13299	42	3	0	49336	\N
13299	3645	4	0	49337	\N
13304	2	9	0	49334	\N
13304	3650	10	0	49370	\N
13306	841	3	0	48961	\N
13306	3604	4	0	48964	\N
13308	793	3	0	49044	\N
13308	2644	4	0	49387	\N
13314	597	3	0	47375	\N
13314	3656	4	0	49408	\N
13316	147	3	0	45414	\N
13316	3657	4	0	49409	\N
13317	362	3	0	48908	\N
13317	3658	4	0	49416	\N
13323	365	9	0	46090	\N
13323	3570	10	0	49465	\N
13325	1	1	0	49476	\N
13325	53	2	0	49477	\N
13328	58	3	0	49503	\N
13328	3665	4	0	49504	\N
13330	451	4	0	49514	\N
13330	3666	5	0	49515	\N
13334	119	10	0	45792	\N
13334	3670	11	0	49548	\N
13337	27	12	0	45589	\N
13337	1270	13	0	49561	\N
13340	74	1	0	49576	\N
13340	73	9	0	49591	\N
13340	3675	10	0	49592	\N
13342	113	4	0	49604	\N
13342	3677	5	0	49605	\N
13347	324	5	0	44403	\N
13347	3680	6	0	49644	\N
13348	2982	5	0	46552	\N
13348	3681	6	0	49645	\N
13350	908	4	0	49654	\N
13350	3488	5	0	49655	\N
13354	273	3	0	49674	\N
13354	3638	4	0	49675	\N
13361	40	4	0	49691	\N
13361	3381	5	0	49692	\N
13365	40	3	0	49691	\N
13365	372	4	0	49720	\N
13368	440	7	0	49721	\N
13368	3691	8	0	49739	\N
13370	475	3	0	49758	\N
13370	56	8	0	49759	\N
13370	3694	9	1	49760	\N
13370	3693	9	0	49761	\N
13370	1075	10	0	49762	\N
13373	96	4	0	49797	\N
13373	3515	5	0	49798	\N
13383	79	8	0	49887	\N
13383	3701	9	0	49888	\N
13388	16	3	0	49914	\N
13388	3634	4	0	49915	\N
13390	411	3	0	49922	\N
13390	3596	4	0	49923	\N
13395	279	7	0	49943	\N
13395	3707	8	0	49944	\N
13398	110	8	0	48848	\N
13398	3710	9	0	49965	\N
13400	10	7	0	49840	\N
13400	3705	8	0	49940	\N
13403	27	3	0	49995	\N
13403	3714	4	0	49996	\N
13407	132	4	0	49961	\N
13407	3716	5	0	50008	\N
13409	40	8	0	50026	\N
13409	3718	9	0	50027	\N
13411	40	4	0	50036	\N
13411	3381	5	0	50037	\N
13414	2770	5	0	50062	\N
13414	10	6	0	50063	\N
13420	210	6	0	50118	\N
13420	3721	7	0	50119	\N
13425	360	4	0	50159	\N
13425	3513	5	0	50160	\N
13428	1	1	0	50163	\N
13428	53	2	0	50164	\N
13430	2	4	0	50174	\N
13430	3510	5	0	50175	\N
13438	595	1	0	47837	\N
13438	596	2	0	50244	\N
13443	3735	6	0	50294	\N
13443	672	7	0	50295	\N
13446	3658	3	0	50300	\N
13446	362	10	0	50307	\N
13446	3736	11	0	50308	\N
13451	908	3	0	50321	\N
13451	3741	4	0	50322	\N
13452	841	5	0	50334	\N
13452	3742	6	0	50335	\N
13457	424	8	0	50361	\N
13457	3744	9	0	50362	\N
13460	336	0	0	49737	\N
13182	102	4	0	48701	\N
13182	3572	5	0	48702	\N
13185	1	2	0	48719	\N
13185	112	3	0	48720	\N
13188	362	6	0	48753	\N
13188	3577	7	0	48754	\N
13191	1109	7	0	48777	\N
13191	3579	8	0	48778	\N
13195	164	2	0	48790	\N
13195	226	3	0	48791	\N
13201	151	6	0	48831	\N
13201	3588	7	0	48832	\N
13206	110	1	0	48848	\N
13206	134	2	0	48850	\N
13207	2	3	0	47137	\N
13207	3548	4	0	48421	\N
13210	11	1	0	48874	\N
13210	10	7	0	48885	\N
13210	3592	8	0	48886	\N
13213	362	5	0	48908	\N
13213	3371	6	0	48909	\N
13215	411	3	0	47192	\N
13215	3596	4	0	48916	\N
13218	10	6	0	48940	\N
13218	3599	7	0	48886	\N
13220	149	7	0	48949	\N
13220	3600	8	0	48950	\N
13223	841	1	0	48961	\N
13223	842	2	0	48962	\N
13227	1	0	0	48966	\N
13232	2	2	0	48990	\N
13232	2990	3	0	48991	\N
13236	71	2	0	49003	\N
13236	1125	3	0	49004	\N
13239	852	1	0	46772	\N
13239	913	2	0	46774	\N
13242	235	4	0	49015	\N
13242	2233	5	0	49016	\N
13244	23	4	0	49026	\N
13244	3189	5	0	49027	\N
13246	94	1	0	48283	\N
13246	107	2	0	49034	\N
13251	113	3	0	49058	\N
13251	3620	4	0	49059	\N
13256	316	6	0	49095	\N
13256	3623	7	0	49096	\N
13264	119	8	0	45792	\N
13264	3627	9	0	49143	\N
13268	135	3	0	49158	\N
13268	3630	4	0	49159	\N
13273	10	2	0	49170	\N
13273	275	3	0	49171	\N
13277	290	3	0	47580	\N
13277	3635	4	0	49189	\N
13280	1914	1	0	49212	\N
13280	2031	2	0	49213	\N
13287	212	3	0	49247	\N
13287	3639	4	0	49248	\N
13293	119	6	0	45792	\N
13293	3644	7	0	49282	\N
13300	49	3	0	49344	\N
13300	3646	4	0	49345	\N
13305	92	6	0	49377	\N
13305	3651	7	0	49378	\N
13307	79	3	0	49385	\N
13307	3652	4	0	49386	\N
13312	595	3	0	47837	\N
13312	3654	4	0	49405	\N
13318	132	2	0	49421	\N
13318	2756	3	0	49422	\N
13321	2782	3	0	49444	\N
13321	3659	4	0	49445	\N
13324	40	3	0	49472	\N
13324	372	4	0	49473	\N
13329	94	3	0	49505	\N
13329	2864	4	0	49506	\N
13332	69	3	0	48609	\N
13332	3668	4	0	49532	\N
13336	69	10	0	48609	\N
13336	3672	11	0	49551	\N
13339	285	4	0	49572	\N
13339	3674	5	0	49573	\N
13344	367	4	0	49615	\N
13344	3679	5	0	49616	\N
13346	10	4	0	49632	\N
13346	3493	5	0	49633	\N
13353	79	3	0	49665	\N
13353	3652	4	0	49667	\N
13356	793	3	0	49677	\N
13356	2644	4	0	49678	\N
13358	264	2	0	49679	\N
13358	2780	3	0	49681	\N
13367	336	7	0	49737	\N
13367	3690	8	0	49738	\N
13369	94	8	0	49756	\N
13369	3692	9	0	49757	\N
13372	1	3	0	49787	\N
13372	48	4	0	49788	\N
13375	137	4	0	45176	\N
13375	3697	5	0	49800	\N
13376	10	4	0	49809	\N
13376	3493	5	0	49810	\N
13379	10	4	0	49840	\N
13379	3493	5	0	49841	\N
13382	2636	8	0	49885	\N
13382	3700	9	0	49886	\N
13387	264	3	0	49679	\N
13387	3632	4	0	49907	\N
13392	164	3	0	48790	\N
13392	3385	4	0	49925	\N
13394	12	7	0	49941	\N
13394	3706	8	0	49942	\N
13396	177	7	0	49959	\N
13396	3708	8	0	49960	\N
13401	424	6	0	48999	\N
13401	3712	7	0	49992	\N
13405	189	2	0	49993	\N
13405	311	3	0	49998	\N
13413	181	2	0	47024	\N
13413	769	3	0	50055	\N
13416	12	10	0	50089	\N
13416	3720	11	0	50090	\N
13422	58	9	0	49503	\N
13422	3723	10	0	50139	\N
13424	214	10	0	50149	\N
13424	3725	11	0	50150	\N
13427	285	4	0	49572	\N
13427	3674	5	0	49573	\N
13434	90	4	0	50228	\N
13434	3731	5	0	50229	\N
13436	147	1	0	50234	\N
13436	599	2	0	50235	\N
13442	40	1	0	50280	\N
13442	41	2	0	50281	\N
13447	3630	3	0	46073	\N
13447	135	10	0	49159	\N
13447	3737	11	0	50309	\N
13449	908	3	0	50321	\N
13449	3741	4	0	50322	\N
13454	451	4	0	50336	\N
13454	3666	5	0	50338	\N
13455	18	3	0	49172	\N
13455	3621	4	0	49218	\N
13461	86	3	0	47536	\N
13461	3746	4	0	50370	\N
13470	18	3	0	50413	\N
13470	3621	4	0	50414	\N
13473	10	4	0	50441	\N
13473	3493	5	0	50442	\N
13477	324	7	0	44403	\N
13477	3753	8	0	50453	\N
13483	322	9	0	50509	\N
13483	3756	10	0	50510	\N
13486	2718	6	0	50544	\N
13486	10	12	0	50555	\N
13486	2770	13	0	50556	\N
13489	1018	2	0	50576	\N
13184	58	6	0	45156	\N
13184	3575	7	0	48718	\N
13187	264	7	0	48739	\N
13187	3576	8	0	48740	\N
13190	488	3	0	47518	\N
13190	1324	4	0	48774	\N
13194	1	6	0	48786	\N
13194	3582	7	0	48787	\N
13197	435	6	0	48797	\N
13197	3584	7	0	48798	\N
13200	113	6	0	48829	\N
13200	3587	7	0	48830	\N
13202	10	3	0	48391	\N
13202	3173	4	0	48839	\N
13205	110	3	0	48848	\N
13205	2995	4	0	48849	\N
13209	908	3	0	48487	\N
13209	3591	4	0	48871	\N
13212	40	7	0	48633	\N
13212	3595	8	0	48897	\N
13217	3598	123	0	48925	\N
13217	102	126	0	48926	\N
13217	3574	127	0	48927	\N
13222	360	3	0	48959	\N
13222	3602	4	0	48960	\N
13229	67	6	0	48981	\N
13229	3607	7	0	48982	\N
13231	102	1	0	48988	\N
13231	3197	2	0	48989	\N
13234	102	56	0	48993	\N
13234	3609	57	1	48994	\N
13234	1970	57	0	48995	\N
13234	3610	58	0	48996	\N
13235	424	1	0	48999	\N
13235	425	2	0	49000	\N
13238	852	3	0	46772	\N
13238	3612	4	0	49008	\N
13249	793	4	0	49044	\N
13249	3618	5	0	49045	\N
13250	77	4	0	49050	\N
13250	3619	5	0	49051	\N
13253	235	0	0	49068	\N
13261	2	5	0	48990	\N
13261	3624	6	0	49134	\N
13263	3626	8	0	49140	\N
13271	137	3	0	45176	\N
13271	3633	4	0	49163	\N
13272	260	2	0	49168	\N
13272	3184	3	0	49169	\N
13276	16	3	0	49181	\N
13276	3634	4	0	49182	\N
13279	16	9	0	49208	\N
13279	3636	10	0	49209	\N
13283	1914	3	0	49212	\N
13283	3637	4	0	49219	\N
13284	212	6	0	49032	\N
13284	3554	7	0	49232	\N
13289	30	3	0	49257	\N
13289	3640	4	0	49258	\N
13292	3643	7	0	49281	\N
13294	16	6	0	49295	\N
13294	3369	7	0	49296	\N
13297	40	6	0	49326	\N
13297	2777	7	0	49327	\N
13302	1	0	0	49361	\N
13309	210	3	0	49394	\N
13309	3539	4	0	49395	\N
13311	117	3	0	43047	\N
13311	3653	4	0	49404	\N
13315	424	3	0	48999	\N
13315	3611	4	0	49007	\N
13320	391	3	0	48572	\N
13320	3660	4	0	49437	\N
13326	391	7	0	49492	\N
13326	3662	8	0	49493	\N
13331	51	5	0	47593	\N
13331	3667	6	0	49526	\N
13335	3628	10	0	49549	\N
13335	3671	11	0	49550	\N
13338	202	4	0	49570	\N
13338	3673	5	0	49571	\N
13341	11	1	0	49593	\N
13341	10	9	0	49594	\N
13341	3676	10	0	49595	\N
13343	79	4	0	49385	\N
13343	3678	5	0	49614	\N
13345	10	3	0	49170	\N
13345	2917	4	0	49623	\N
13352	79	7	0	49665	\N
13352	3682	8	0	49666	\N
13355	367	3	0	49615	\N
13355	3683	4	0	49676	\N
13357	264	4	0	49679	\N
13357	3684	5	0	49680	\N
13362	3686	91	0	49693	\N
13362	181	126	0	49694	\N
13362	3687	127	0	49695	\N
13363	1	1	0	49698	\N
13363	53	2	0	49699	\N
13366	440	13	0	49721	\N
13366	3689	14	0	49722	\N
13371	27	11	0	49785	\N
13371	3695	12	0	49786	\N
13374	135	4	0	49158	\N
13374	3696	5	0	49799	\N
13378	96	5	0	49830	\N
13378	3698	6	0	49831	\N
13381	173	15	0	49867	\N
13381	3699	16	0	49868	\N
13384	528	8	0	49889	\N
13384	3702	9	0	49890	\N
13386	16	3	0	49905	\N
13386	3634	4	0	49906	\N
13391	233	3	0	47402	\N
13391	3704	4	0	49924	\N
13393	10	7	0	49840	\N
13393	3705	8	0	49940	\N
13404	27	6	0	49995	\N
13404	3715	7	0	49997	\N
13408	27	4	0	49995	\N
13408	3717	5	0	50009	\N
13412	793	6	0	49677	\N
13412	3719	7	0	50050	\N
13415	1	2	0	49787	\N
13415	112	3	0	50068	\N
13418	16	3	0	50097	\N
13418	3634	4	0	50098	\N
13421	186	3	0	50125	\N
13421	3722	4	0	50126	\N
13426	3726	1	0	50161	\N
13426	3727	2	0	50162	\N
13433	40	4	0	50218	\N
13433	3381	5	0	50219	\N
13439	597	4	0	47375	\N
13439	3733	5	0	50245	\N
13441	10	15	0	50276	\N
13441	3734	16	0	50277	\N
13444	40	1	0	50296	\N
13444	41	2	0	50297	\N
13453	451	5	0	50336	\N
13453	3743	6	0	50337	\N
13458	336	3	0	49737	\N
13458	3745	4	0	50363	\N
13466	3561	37	0	50391	\N
13466	167	76	0	50392	\N
13466	3748	77	1	50393	\N
13466	2132	77	0	50394	\N
13466	1075	78	1	50395	\N
13466	3108	78	0	50396	\N
13469	54	3	0	50411	\N
13469	3041	4	0	50412	\N
13472	49	4	0	50439	\N
13472	3751	5	0	50440	\N
13476	233	7	0	47402	\N
13476	3752	8	0	50452	\N
13463	16	3	0	50379	\N
13463	3634	4	0	50380	\N
13465	367	3	0	50389	\N
13465	3683	4	0	50390	\N
13467	67	3	0	50403	\N
13467	3749	4	0	50404	\N
13471	96	7	0	50429	\N
13471	3750	8	0	50430	\N
13479	2982	4	0	50456	\N
13479	3501	5	0	50457	\N
13481	42	18	0	50488	\N
13481	3754	19	0	50489	\N
13488	186	4	0	50569	\N
13488	3009	6	0	42973	\N
13495	353	1	0	43938	\N
13495	354	2	0	50614	\N
13498	1	1	0	50454	\N
13498	53	2	0	50455	\N
13500	71	3	0	49003	\N
13500	3770	4	0	50634	\N
13507	62	10	0	45023	\N
13507	3771	11	0	50675	\N
13509	908	16	0	50690	\N
13509	3772	17	0	50691	\N
13511	908	3	0	50690	\N
13511	3591	4	0	50693	\N
13516	235	1	0	50716	\N
13516	236	2	0	50720	\N
13523	71	4	0	49003	\N
13523	2776	5	0	50762	\N
13530	18	1	0	50413	\N
13530	1426	2	0	50786	\N
13533	189	3	0	49993	\N
13533	3782	4	0	50801	\N
13539	135	3	0	49158	\N
13539	3630	4	0	49159	\N
13541	3625	3	0	49279	\N
13541	3784	4	0	50826	\N
13546	58	1	0	49503	\N
13546	59	2	0	50837	\N
13550	54	5	0	50849	\N
13550	3787	6	0	50850	\N
13554	336	0	0	49737	\N
13560	79	3	0	50868	\N
13560	3652	4	0	50869	\N
13565	10	8	0	50921	\N
13565	3792	9	0	50922	\N
13570	273	3	0	50743	\N
13570	3638	4	0	50941	\N
13574	367	3	0	50389	\N
13574	3683	4	0	50390	\N
13580	3800	5	0	51024	\N
13580	96	13	0	51039	\N
13580	3801	14	0	51040	\N
13583	3628	4	0	49549	\N
13583	3803	5	0	51050	\N
13585	326	5	0	51061	\N
13585	3805	6	0	51062	\N
13587	214	4	0	51072	\N
13587	3807	5	0	51073	\N
13590	2636	5	0	49885	\N
13590	3780	6	0	50779	\N
13592	35	3	0	50924	\N
13592	3563	4	0	51094	\N
13594	210	4	0	51104	\N
13594	3536	5	0	51105	\N
13596	192	3	0	50866	\N
13596	3790	4	0	50867	\N
13599	411	3	0	49922	\N
13599	3596	4	0	49923	\N
13611	268	3	0	45853	\N
13611	3815	4	0	51227	\N
13614	1109	4	0	51238	\N
13614	3816	5	0	51239	\N
13616	3321	2	0	51254	\N
13616	86	5	0	51259	\N
13616	2890	6	0	51260	\N
13618	1685	2	0	50414	\N
13618	18	5	0	51261	\N
13618	3817	6	0	51262	\N
13621	140	4	0	51283	\N
13621	3821	5	0	51284	\N
13625	137	1	0	45176	\N
13625	138	2	0	51298	\N
13626	102	12	0	50809	\N
13626	3825	13	0	51323	\N
13630	88	16	0	51336	\N
13630	3828	17	0	51337	\N
13637	2982	14	0	50456	\N
13637	3832	15	0	51394	\N
13641	10	4	0	51440	\N
13641	3493	5	0	51441	\N
13644	100	3	0	50741	\N
13644	3836	4	0	51460	\N
13648	1470	3	0	51200	\N
13648	3838	4	0	51472	\N
13653	53	1	0	51496	\N
13653	3051	4	0	51501	\N
13653	3840	4	0	51502	\N
13653	3842	5	1	51503	\N
13653	3841	5	0	51504	\N
13653	3843	6	0	51505	\N
13656	170	0	0	51510	\N
13658	3846	0	0	51591	\N
13664	360	16	0	51651	\N
13664	3852	17	0	51663	\N
13670	793	3	0	51681	\N
13670	2644	4	0	51682	\N
13675	290	3	0	51704	\N
13675	3635	4	0	51705	\N
13677	763	3	0	51714	\N
13677	3854	4	0	51715	\N
13685	353	2	0	51615	\N
13685	2884	3	0	51751	\N
13686	135	2	0	51752	\N
13686	2722	3	0	51753	\N
13689	2982	2	0	50456	\N
13689	3383	3	0	51758	\N
13694	3858	41	0	51782	\N
13694	488	89	0	51783	\N
13694	3859	90	0	51784	\N
13697	266	2	0	51749	\N
13697	2103	3	0	51750	\N
13699	459	2	0	51813	\N
13699	3860	3	0	51814	\N
13703	3273	4	0	51829	\N
13703	198	5	0	51830	\N
13711	212	4	0	50230	\N
13711	3732	5	0	50231	\N
13715	192	9	0	50866	\N
13715	3864	10	0	51922	\N
13718	145	4	0	51965	\N
13718	3867	5	0	51966	\N
13721	1	4	0	51978	\N
13721	3820	5	0	51979	\N
13723	459	4	0	51988	\N
13723	3869	5	0	51989	\N
13728	140	7	0	51283	\N
13728	3874	8	0	52022	\N
13730	10	4	0	52032	\N
13730	3493	5	0	52033	\N
13731	3875	4	0	52042	\N
13731	3876	5	0	52043	\N
13735	212	3	0	50230	\N
13735	3639	4	0	52055	\N
13736	3173	3	0	52062	\N
13736	10	4	0	52063	\N
13740	595	4	0	47837	\N
13740	3878	5	0	52077	\N
13749	251	7	0	52150	\N
13749	3883	8	0	52151	\N
13750	102	7	0	52166	\N
13750	3884	8	0	52167	\N
13757	10	8	0	52219	\N
13757	3889	9	0	52220	\N
13480	324	4	0	44403	\N
13480	3500	5	0	47982	\N
13482	58	9	0	49503	\N
13482	3755	10	0	50508	\N
13485	79	9	0	50530	\N
13485	3758	10	0	50531	\N
13491	262	5	0	50595	\N
13491	3763	6	0	50596	\N
13493	44	9	0	46149	\N
13493	3765	10	0	50606	\N
13501	40	1	0	50635	\N
13501	41	2	0	50636	\N
13502	273	3	0	49674	\N
13502	3638	4	0	49675	\N
13505	10	3	0	50653	\N
13505	3173	4	0	50654	\N
13512	10	3	0	50700	\N
13512	3173	4	0	50701	\N
13517	235	3	0	50716	\N
13517	3343	4	0	50725	\N
13519	100	4	0	50741	\N
13519	3776	5	0	50742	\N
13524	10	4	0	50763	\N
13524	2568	5	0	50764	\N
13526	142	0	0	47433	\N
13528	3780	5	0	50776	\N
13528	2636	7	0	50779	\N
13528	3207	8	0	50780	\N
13529	3781	5	0	50781	\N
13529	142	7	0	50782	\N
13529	3117	8	0	50783	\N
13535	102	5	0	50809	\N
13535	3783	6	0	50810	\N
13538	102	3	0	50809	\N
13538	3597	4	0	50813	\N
13540	137	3	0	45176	\N
13540	3633	4	0	49163	\N
13542	3628	3	0	49549	\N
13542	3785	4	0	50827	\N
13544	362	3	0	50829	\N
13544	3658	4	0	50830	\N
13547	38	1	0	50838	\N
13547	399	2	0	50839	\N
13551	336	1	0	49737	\N
13551	356	2	0	50851	\N
13555	336	0	0	49737	\N
13558	597	7	0	47375	\N
13558	3789	8	0	50859	\N
13561	79	2	0	50868	\N
13561	616	3	0	50870	\N
13563	365	10	0	50895	\N
13563	3791	11	0	50896	\N
13566	100	8	0	50741	\N
13566	3793	9	0	50923	\N
13571	908	33	0	50947	\N
13571	3797	34	0	50948	\N
13577	202	9	0	50987	\N
13577	3798	10	0	50988	\N
13581	3625	4	0	49279	\N
13581	3802	5	0	51049	\N
13595	16	4	0	50379	\N
13595	3546	5	0	51106	\N
13597	260	3	0	50649	\N
13597	3399	4	0	50650	\N
13607	33	8	0	47348	\N
13607	3812	9	0	51199	\N
13612	228	3	0	48784	\N
13612	3186	4	0	51228	\N
13617	3321	2	0	51254	\N
13617	86	5	0	51259	\N
13617	2890	6	0	51260	\N
13627	132	12	0	51324	\N
13627	3826	13	0	51325	\N
13631	173	4	0	51346	\N
13631	3614	5	0	51347	\N
13634	241	14	0	47085	\N
13634	3829	15	0	51390	\N
13638	324	2	0	51391	\N
13638	486	3	0	51395	\N
13639	181	16	0	51428	\N
13639	3833	17	0	51429	\N
13647	40	3	0	51464	\N
13647	372	4	0	51465	\N
13649	135	2	0	51477	\N
13649	2722	3	0	51478	\N
13651	365	3	0	51485	\N
13651	3839	4	0	51486	\N
13657	3844	68	0	51531	\N
13657	170	126	0	51589	\N
13657	3845	127	0	51590	\N
13661	345	14	0	28342	\N
13662	360	17	0	51651	\N
13662	3850	18	0	51652	\N
13666	336	3	0	51664	\N
13666	3400	4	0	51671	\N
13673	2636	3	0	49885	\N
13673	2837	4	0	51696	\N
13678	300	3	0	51177	\N
13678	3747	4	0	51722	\N
13680	1	2	0	51458	\N
13680	283	3	0	51728	\N
13683	10	7	0	51462	\N
13683	3856	8	0	51744	\N
13692	173	4	0	51774	\N
13692	3857	5	0	51775	\N
13695	40	6	0	51797	\N
13695	2777	7	0	51798	\N
13700	135	2	0	51819	\N
13700	2722	3	0	51820	\N
13705	235	2	0	51841	\N
13705	2757	3	0	51842	\N
13708	10	4	0	51867	\N
13708	3493	5	0	51868	\N
13712	2	4	0	51881	\N
13712	3510	5	0	51882	\N
13713	96	9	0	51901	\N
13713	3862	10	0	51902	\N
13716	228	9	0	48784	\N
13716	3865	10	0	51940	\N
13724	360	5	0	51999	\N
13724	3870	6	0	52000	\N
13726	2782	4	0	52011	\N
13726	3872	5	0	52012	\N
13729	56	7	0	48535	\N
13729	3543	8	0	52023	\N
13732	10	4	0	52052	\N
13732	3493	5	0	52053	\N
13737	372	3	0	52064	\N
13737	40	4	0	52065	\N
13744	170	20	0	52120	\N
13744	3880	21	0	52121	\N
13745	3846	5	0	51591	\N
13745	3881	6	0	52123	\N
13751	82	7	0	52168	\N
13751	3885	8	0	52169	\N
13752	18	4	0	52178	\N
13752	2302	5	0	52179	\N
13756	73	8	0	52217	\N
13756	3888	9	0	52218	\N
13758	40	8	0	52221	\N
13758	3718	9	0	52222	\N
13762	3891	4	0	52228	\N
13762	3893	5	0	52236	\N
13764	2	4	0	52247	\N
13764	3510	5	0	52248	\N
13777	142	0	0	52310	\N
13781	3900	59	0	52345	\N
13781	2578	126	0	52348	\N
13781	3901	127	0	52349	\N
13784	391	6	0	51092	\N
13784	3521	7	0	52371	\N
13787	170	8	0	52120	\N
13787	3904	9	0	52402	\N
13791	88	4	0	52417	\N
13791	3809	5	0	52419	\N
13489	3761	2	0	50577	\N
13489	1075	3	1	50578	\N
13489	3762	3	0	50579	\N
13492	262	9	0	50595	\N
13492	3764	10	0	50605	\N
13494	353	3	0	43938	\N
13494	3766	4	0	50613	\N
13496	3767	4	0	50619	\N
13496	3768	5	0	50620	\N
13503	260	3	0	50649	\N
13503	3399	4	0	50650	\N
13506	40	1	0	50635	\N
13506	41	2	0	50636	\N
13508	42	3	0	50682	\N
13508	3645	4	0	50683	\N
13510	908	44	0	50690	\N
13510	3773	45	0	50692	\N
13513	10	6	0	50714	\N
13513	3599	7	0	50715	\N
13515	235	3	0	50716	\N
13515	3774	4	0	50717	\N
13520	273	4	0	50743	\N
13520	3777	5	0	50744	\N
13522	86	3	0	50752	\N
13522	3746	4	0	50753	\N
13531	10	3	0	50793	\N
13531	3173	4	0	50794	\N
13534	189	1	0	49993	\N
13534	190	2	0	50802	\N
13536	54	3	0	50811	\N
13536	3041	4	0	50812	\N
13548	38	3	0	50838	\N
13548	3457	4	0	50840	\N
13552	1	1	0	50454	\N
13552	53	2	0	50455	\N
13557	595	1	0	47837	\N
13557	596	2	0	50244	\N
13564	10	3	0	50903	\N
13564	3173	4	0	50904	\N
13567	35	8	0	50924	\N
13567	3794	9	0	50925	\N
13572	908	3	0	50949	\N
13572	3591	4	0	50950	\N
13575	10	3	0	50965	\N
13575	3173	4	0	50966	\N
13578	40	4	0	50635	\N
13578	2714	5	0	50997	\N
13586	224	4	0	48220	\N
13586	3806	5	0	51071	\N
13588	360	5	0	50159	\N
13588	3586	6	0	51084	\N
13598	10	3	0	50965	\N
13598	3173	4	0	50966	\N
13600	210	3	0	51104	\N
13600	3539	4	0	51113	\N
13604	316	27	0	51179	\N
13604	3811	28	0	51180	\N
13606	367	4	0	51181	\N
13606	3679	5	0	51190	\N
13609	75	0	0	46562	\N
13613	10	4	0	50965	\N
13613	3493	5	0	51237	\N
13615	10	4	0	51248	\N
13615	3493	5	0	51249	\N
13620	260	4	0	50649	\N
13620	3728	5	0	51282	\N
13623	320	4	0	45629	\N
13623	3824	5	0	51287	\N
13624	135	4	0	51296	\N
13624	3696	5	0	51297	\N
13632	10	3	0	51354	\N
13632	3173	4	0	51355	\N
13633	94	2	0	51360	\N
13633	95	3	0	51361	\N
13636	132	14	0	51324	\N
13636	3831	15	0	51393	\N
13643	1	3	0	51458	\N
13643	3393	4	0	51459	\N
13646	10	3	0	51462	\N
13646	3173	4	0	51463	\N
13655	19	1	0	51507	\N
13655	18	4	0	51508	\N
13655	3817	5	0	51509	\N
13660	353	13	0	51615	\N
13660	3848	14	0	51616	\N
13665	336	0	0	51664	\N
13668	210	1	0	51104	\N
13668	2926	2	0	51672	\N
13669	77	3	0	51679	\N
13669	1877	4	0	51680	\N
13672	88	2	0	51688	\N
13672	2799	3	0	51689	\N
13679	75	3	0	46562	\N
13679	3855	4	0	51723	\N
13682	451	2	0	50336	\N
13682	3317	3	0	51730	\N
13684	266	2	0	51749	\N
13684	2103	3	0	51750	\N
13691	64	2	0	51764	\N
13691	277	3	0	51765	\N
13693	16	4	0	51776	\N
13693	2575	5	0	51777	\N
13696	1	2	0	51803	\N
13696	283	3	0	51804	\N
13702	3273	4	0	51829	\N
13702	198	5	0	51830	\N
13704	235	15	0	51835	\N
13704	3861	16	0	51836	\N
13707	27	2	0	51857	\N
13707	645	3	0	51858	\N
13710	2636	4	0	51879	\N
13710	3617	5	0	51880	\N
13720	3868	5	0	51969	\N
13734	212	4	0	50230	\N
13734	3732	5	0	50231	\N
13739	597	4	0	52075	\N
13739	3733	5	0	52076	\N
13741	360	20	0	52118	\N
13741	3879	21	0	52119	\N
13747	16	1	0	52132	\N
13747	17	2	0	52133	\N
13748	14	7	0	52148	\N
13748	3882	8	0	52149	\N
13754	18	4	0	52190	\N
13754	2302	5	0	52191	\N
13755	71	4	0	49003	\N
13755	3887	5	0	52200	\N
13760	164	3	0	52223	\N
13760	1807	4	0	52225	\N
13763	60	4	0	52245	\N
13763	3894	5	0	52246	\N
13765	192	4	0	52001	\N
13765	3895	5	0	52257	\N
13768	10	8	0	52286	\N
13768	3889	9	0	52287	\N
13770	96	1	0	52290	\N
13770	97	2	0	52291	\N
13773	10	4	0	52308	\N
13773	3493	5	0	52309	\N
13779	142	0	0	52310	\N
13780	142	0	0	52310	\N
13785	360	5	0	52382	\N
13785	3870	6	0	52383	\N
13794	64	1	0	52431	\N
13794	65	2	0	52432	\N
13796	285	5	0	52369	\N
13796	3912	6	0	52444	\N
13801	1	10	0	51978	\N
13801	3915	11	0	52480	\N
13803	202	4	0	52491	\N
13803	3673	5	0	52492	\N
13806	96	1	0	52509	\N
13806	97	2	0	52510	\N
13810	266	5	0	52534	\N
13810	3920	6	0	52535	\N
13813	353	8	0	51615	\N
13532	3634	4	0	50380	\N
13543	119	3	0	45792	\N
13543	2860	4	0	50828	\N
13545	58	3	0	49503	\N
13545	3665	4	0	49504	\N
13549	113	5	0	50847	\N
13549	3786	6	0	50848	\N
13553	336	0	0	49737	\N
13556	147	7	0	50234	\N
13556	3788	8	0	50858	\N
13559	192	3	0	50866	\N
13559	3790	4	0	50867	\N
13562	156	1	0	50873	\N
13562	157	2	0	50874	\N
13568	488	40	0	50931	\N
13568	3795	41	0	50932	\N
13569	173	3	0	50939	\N
13569	3796	4	0	50940	\N
13573	51	3	0	50957	\N
13573	3533	4	0	50958	\N
13576	73	3	0	50967	\N
13576	3040	4	0	50968	\N
13579	852	7	0	51012	\N
13579	3799	8	0	51013	\N
13582	119	4	0	45792	\N
13582	3518	5	0	48132	\N
13584	117	5	0	43047	\N
13584	3804	6	0	51060	\N
13589	149	5	0	48949	\N
13589	3808	6	0	51085	\N
13591	391	3	0	51092	\N
13591	3660	4	0	51093	\N
13593	88	4	0	49406	\N
13593	3809	5	0	51103	\N
13601	411	1	0	49922	\N
13601	412	2	0	51114	\N
13602	16	4	0	50379	\N
13602	3546	5	0	51106	\N
13603	300	27	0	51177	\N
13603	3810	28	0	51178	\N
13605	367	0	0	51181	\N
13608	1470	8	0	51200	\N
13608	3813	9	0	51201	\N
13610	20	9	0	51219	\N
13610	3814	10	0	51220	\N
13619	3818	4	0	51271	\N
13619	3819	4	0	51272	\N
13619	3820	5	0	51273	\N
13622	3822	1	0	50314	\N
13622	3823	1	0	51285	\N
13622	76	2	0	51286	\N
13628	18	12	0	51326	\N
13628	3827	13	0	51327	\N
13629	102	0	0	50809	\N
13635	324	14	0	51391	\N
13635	3830	15	0	51392	\N
13640	1	16	0	51430	\N
13640	3834	17	0	51431	\N
13642	117	4	0	51450	\N
13642	3835	5	0	51451	\N
13645	4	3	0	48588	\N
13645	3837	4	0	51461	\N
13650	137	1	0	45176	\N
13650	138	2	0	51298	\N
13652	18	3	0	51326	\N
13652	3621	4	0	51493	\N
13654	40	0	0	51506	\N
13659	10	14	0	51462	\N
13659	3847	15	0	51614	\N
13663	353	17	0	51653	\N
13663	3851	18	0	51654	\N
13667	210	3	0	51104	\N
13667	3539	4	0	51113	\N
13671	77	2	0	51679	\N
13671	3853	3	0	51683	\N
13674	279	3	0	49943	\N
13674	3641	4	0	51697	\N
13676	841	3	0	51706	\N
13676	3604	4	0	51707	\N
13681	56	2	0	48535	\N
13681	2795	3	0	51729	\N
13687	137	2	0	45176	\N
13687	2721	3	0	47232	\N
13688	324	2	0	51391	\N
13688	2808	3	0	51757	\N
13690	210	2	0	51104	\N
13690	1874	3	0	51763	\N
13698	1	2	0	51803	\N
13698	283	3	0	51804	\N
13701	137	2	0	45176	\N
13701	2721	3	0	47232	\N
13706	1	4	0	51851	\N
13706	2814	5	0	51852	\N
13709	10	4	0	51877	\N
13709	3493	5	0	51878	\N
13714	125	9	0	46225	\N
13714	3863	10	0	51903	\N
13717	316	7	0	51955	\N
13717	3866	8	0	51956	\N
13719	1	4	0	51967	\N
13719	3820	5	0	51968	\N
13722	10	4	0	51877	\N
13722	3493	5	0	51878	\N
13725	192	5	0	52001	\N
13725	3871	6	0	52002	\N
13727	2782	1	0	52011	\N
13727	3873	2	0	52013	\N
13733	56	4	0	48535	\N
13733	3127	5	0	52054	\N
13738	147	4	0	50234	\N
13738	3877	5	0	52074	\N
13742	170	20	0	52120	\N
13742	3880	21	0	52121	\N
13743	10	20	0	52052	\N
13743	1619	21	0	52122	\N
13746	10	4	0	52052	\N
13746	3493	5	0	52053	\N
13753	841	4	0	52188	\N
13753	3886	5	0	52189	\N
13759	164	8	0	52223	\N
13759	3890	9	0	52224	\N
13767	268	4	0	52268	\N
13767	3897	5	0	52269	\N
13772	73	4	0	52217	\N
13772	2284	5	0	52307	\N
13774	125	0	0	46225	\N
13775	142	0	0	52310	\N
13778	142	16	0	52310	\N
13778	3899	17	0	52344	\N
13782	2578	4	0	47035	\N
13782	3902	5	0	52356	\N
13788	86	8	0	52403	\N
13788	3905	9	0	52404	\N
13789	244	8	0	52405	\N
13789	3906	9	0	52406	\N
13792	123	5	0	50651	\N
13792	3908	6	0	52420	\N
13800	2	5	0	52458	\N
13800	3914	6	0	52459	\N
13812	391	8	0	52445	\N
13812	3922	9	0	52554	\N
13814	353	2	0	51615	\N
13814	755	3	0	52556	\N
13818	123	16	0	52605	\N
13818	3926	17	0	52606	\N
13820	391	7	0	52625	\N
13820	3927	8	0	52626	\N
13822	75	7	0	52629	\N
13822	3928	8	0	52630	\N
13825	451	0	0	50336	\N
13831	137	6	0	45176	\N
13831	3932	7	0	52759	\N
13833	273	1	0	50743	\N
13833	410	2	0	52772	\N
13835	451	3	0	52779	\N
13835	3934	4	0	52780	\N
13838	44	20	0	52781	\N
13761	3891	1	0	52228	\N
13761	3892	2	0	52229	\N
13766	42	4	0	52258	\N
13766	3896	5	0	52259	\N
13769	40	8	0	52221	\N
13769	3718	9	0	52222	\N
13771	96	4	0	52290	\N
13771	3515	5	0	52298	\N
13776	10	16	0	52308	\N
13776	3898	17	0	52343	\N
13783	285	6	0	52369	\N
13783	3903	7	0	52370	\N
13786	79	8	0	52400	\N
13786	3701	9	0	52401	\N
13790	88	5	0	52417	\N
13790	3907	6	0	52418	\N
13795	64	4	0	52431	\N
13795	3911	5	0	52433	\N
13797	391	4	0	52445	\N
13797	3913	5	0	52446	\N
13799	10	4	0	52308	\N
13799	3493	5	0	52309	\N
13804	110	5	0	48848	\N
13804	3916	6	0	52503	\N
13807	96	7	0	52509	\N
13807	3918	8	0	52521	\N
13811	244	5	0	52536	\N
13811	3921	6	0	52537	\N
13816	41	1	0	52568	\N
13816	40	5	0	52575	\N
13816	128	6	0	52576	\N
13824	10	3	0	52653	\N
13824	347	4	0	52654	\N
13826	451	12	0	50336	\N
13826	3929	13	0	52673	\N
13827	56	16	0	52706	\N
13827	3930	17	0	52707	\N
13832	110	21	0	52768	\N
13832	905	22	0	52769	\N
13836	44	3	0	52781	\N
13836	3631	4	0	52782	\N
13846	18	16	0	52855	\N
13846	3941	17	0	52856	\N
13847	10	13	0	52859	\N
13847	2568	14	0	52860	\N
13849	2	1	0	52458	\N
13849	26	2	0	52869	\N
13852	92	7	0	52872	\N
13852	3943	8	0	52881	\N
13856	1	8	0	52489	\N
13856	3946	9	0	52910	\N
13861	40	1	0	52941	\N
13861	41	2	0	52942	\N
13866	1	7	0	52989	\N
13866	3951	8	0	52990	\N
13875	857	3	0	53052	\N
13875	75	14	0	53071	\N
13875	76	15	0	53072	\N
13878	20	8	0	53091	\N
13878	3955	9	0	53092	\N
13880	6	2	0	53095	\N
13880	179	3	0	53096	\N
13884	367	13	0	53132	\N
13884	3958	14	0	53133	\N
13887	367	4	0	53150	\N
13887	3679	5	0	53151	\N
13891	40	1	0	53165	\N
13891	41	2	0	53166	\N
13894	258	14	0	53193	\N
13894	3962	15	0	53194	\N
13897	40	2	0	53198	\N
13897	66	3	0	53199	\N
13899	14	31	0	52148	\N
13899	3966	32	0	53239	\N
13905	75	4	0	53152	\N
13905	3959	5	0	53153	\N
13908	77	8	0	51679	\N
13908	3972	9	0	53281	\N
13910	841	4	0	53291	\N
13910	3886	5	0	53292	\N
13915	424	3	0	53298	\N
13915	3973	4	0	53299	\N
13921	597	4	0	53339	\N
13921	3733	5	0	53340	\N
13925	210	4	0	51104	\N
13925	3536	5	0	51105	\N
13927	35	1	0	53345	\N
13927	340	2	0	53346	\N
13932	266	11	0	53384	\N
13932	3977	12	0	53385	\N
13938	326	1	0	51061	\N
13938	327	2	0	53400	\N
13941	230	7	0	53191	\N
13941	3978	8	0	53411	\N
13946	1	4	0	53438	\N
13946	3820	5	0	53439	\N
13950	2636	4	0	51879	\N
13950	3617	5	0	51880	\N
13955	75	7	0	53152	\N
13955	2859	8	0	53503	\N
13964	54	13	0	50849	\N
13964	3985	14	0	53594	\N
13966	49	1	0	50439	\N
13966	50	2	0	50443	\N
13971	132	3	0	53397	\N
13971	814	4	0	53635	\N
13973	12	2	0	53652	\N
13973	433	3	0	53654	\N
13976	147	4	0	50234	\N
13976	3877	5	0	52074	\N
13978	10	12	0	53530	\N
13978	3730	13	0	53632	\N
13981	30	16	0	52867	\N
13981	3990	17	0	53710	\N
13983	189	4	0	53012	\N
13983	3992	5	0	53720	\N
13993	212	1	0	50230	\N
13993	213	2	0	53790	\N
13995	40	5	0	53802	\N
13995	3999	6	0	53803	\N
14003	16	1	0	53869	\N
14003	17	2	0	53870	\N
14006	40	4	0	53928	\N
14006	2221	5	0	53929	\N
14011	266	5	0	53968	\N
14011	4007	6	0	53969	\N
14014	1	5	0	53438	\N
14014	1162	6	0	53992	\N
14019	1997	0	0	27766	\N
14019	4012	0	0	54002	\N
14023	77	3	0	54021	\N
14023	2161	4	0	54032	\N
14027	230	5	0	54048	\N
14027	3389	6	0	54049	\N
14028	16	1	0	54052	\N
14028	17	2	0	54053	\N
14038	49	2	0	54090	\N
14038	328	3	0	54091	\N
14040	10	8	0	53831	\N
14040	3889	9	0	54118	\N
14043	212	2	0	54137	\N
14043	566	3	0	54139	\N
14045	88	11	0	52417	\N
14045	580	12	0	54150	\N
14048	90	11	0	54154	\N
14048	877	12	0	54155	\N
14051	71	5	0	54167	\N
14051	4033	6	0	54168	\N
14056	285	4	0	53195	\N
14056	3674	5	0	54199	\N
14065	149	0	0	54231	\N
14068	69	4	0	49978	\N
14068	4041	5	0	54250	\N
14071	424	13	0	54255	\N
14071	4042	14	0	54256	\N
14072	12	4	0	54265	\N
14072	4043	5	0	54266	\N
13793	3909	4	0	52429	\N
13793	3910	5	0	52430	\N
13798	285	4	0	52369	\N
13798	3674	5	0	52447	\N
13802	1	4	0	52489	\N
13802	3820	5	0	52490	\N
13805	110	6	0	48848	\N
13805	3917	7	0	52506	\N
13808	322	7	0	52522	\N
13808	3919	8	0	52523	\N
13809	528	1	0	49889	\N
13809	529	2	0	52524	\N
13817	322	16	0	52603	\N
13817	3925	17	0	52604	\N
13819	10	1	0	52609	\N
13819	11	2	0	52610	\N
13828	10	1	0	52653	\N
13828	11	2	0	52710	\N
13830	135	23	0	52757	\N
13830	3931	24	0	52758	\N
13837	451	126	0	52783	\N
13837	3935	127	0	52784	\N
13839	18	8	0	52190	\N
13839	3937	9	0	52802	\N
13842	1154	2	0	52807	\N
13842	1153	9	0	11685	\N
13842	3938	10	0	52820	\N
13843	164	16	0	52223	\N
13843	3939	17	0	52853	\N
13851	79	7	0	52400	\N
13851	3682	8	0	52880	\N
13855	75	10	0	52892	\N
13855	3945	11	0	52893	\N
13858	1	4	0	52929	\N
13858	3820	5	0	52930	\N
13863	40	1	0	52953	\N
13863	41	2	0	52954	\N
13865	142	4	0	52973	\N
13865	3950	5	0	52974	\N
13869	230	8	0	53009	\N
13869	3952	9	0	53011	\N
13871	189	2	0	53012	\N
13871	311	3	0	53014	\N
13873	75	7	0	53039	\N
13873	2859	8	0	53040	\N
13874	1456	3	0	53047	\N
13874	435	5	0	53050	\N
13874	1580	6	0	53051	\N
13877	35	0	0	50924	\N
13879	35	8	0	53093	\N
13879	3956	9	0	53094	\N
13886	42	4	0	52258	\N
13886	3896	5	0	52259	\N
13888	75	4	0	53152	\N
13888	3959	5	0	53153	\N
13890	320	7	0	53163	\N
13890	3960	8	0	53164	\N
13893	230	14	0	53191	\N
13893	3961	15	0	53192	\N
13896	18	14	0	52855	\N
13896	3964	15	0	53197	\N
13898	1	31	0	53007	\N
13898	3965	32	0	53238	\N
13901	102	31	0	52166	\N
13901	3968	32	0	53241	\N
13907	411	8	0	53279	\N
13907	3971	9	0	53280	\N
13909	77	2	0	51679	\N
13909	216	3	0	53282	\N
13912	841	3	0	53291	\N
13912	3604	4	0	53293	\N
13914	362	1	0	53296	\N
13914	395	2	0	53297	\N
13918	10	0	0	53312	\N
13920	10	11	0	53312	\N
13920	3974	12	0	53330	\N
13924	147	4	0	50234	\N
13924	3877	5	0	52074	\N
13937	113	4	0	50847	\N
13937	3677	5	0	53399	\N
13943	88	4	0	52417	\N
13943	3809	5	0	52419	\N
13945	100	4	0	50741	\N
13945	3776	5	0	50742	\N
13947	360	1	0	53442	\N
13947	479	2	0	53443	\N
13954	145	7	0	51965	\N
13954	3981	8	0	53488	\N
13957	40	1	0	53470	\N
13957	41	2	0	53471	\N
13960	264	11	0	49679	\N
13960	3982	12	0	53532	\N
13963	2636	13	0	53591	\N
13963	3984	14	0	53593	\N
13968	2636	1	0	53611	\N
13968	3980	2	0	53613	\N
13975	597	4	0	53339	\N
13975	3733	5	0	53340	\N
13980	1	16	0	53438	\N
13980	3330	17	0	53709	\N
13985	424	6	0	53298	\N
13985	3994	7	0	53737	\N
13988	230	4	0	53757	\N
13988	3954	5	0	53758	\N
13990	3996	4	0	53785	\N
13990	3997	4	0	53786	\N
13990	3513	5	0	53787	\N
13992	212	4	0	50230	\N
13992	3732	5	0	50231	\N
13997	18	9	0	52855	\N
13997	2301	10	0	53822	\N
13999	40	1	0	53802	\N
13999	41	2	0	53833	\N
14000	424	5	0	53835	\N
14000	4000	6	0	53836	\N
14002	132	2	0	53397	\N
14002	2756	3	0	53866	\N
14008	186	5	0	53949	\N
14008	4005	6	0	53950	\N
14013	38	2	0	53979	\N
14013	4009	3	0	53981	\N
14016	18	5	0	52855	\N
14016	4010	6	0	53994	\N
14018	449	17	0	54000	\N
14018	4011	18	0	54001	\N
14022	4015	10	0	54024	\N
14022	4016	10	0	54025	\N
14022	4022	11	1	54030	\N
14022	4021	11	0	54031	\N
14022	4020	12	1	54028	\N
14022	4019	12	0	54029	\N
14026	42	10	0	54037	\N
14026	4025	11	0	54038	\N
14029	164	1	0	52223	\N
14029	165	2	0	54056	\N
14034	77	3	0	54079	\N
14034	1877	4	0	54080	\N
14035	391	1	0	54081	\N
14035	392	2	0	54082	\N
14042	212	8	0	54137	\N
14042	4031	9	0	54138	\N
14044	42	8	0	54037	\N
14044	4032	9	0	54143	\N
14047	88	10	0	52417	\N
14047	154	11	0	54153	\N
14053	1636	2	0	20628	\N
14053	1637	3	0	20629	\N
14055	73	4	0	54197	\N
14055	2284	5	0	54198	\N
14060	142	8	0	54218	\N
14060	4039	9	0	54219	\N
14067	69	1	0	49978	\N
14067	70	2	0	54243	\N
14070	424	4	0	54253	\N
14070	3188	5	0	54254	\N
14074	411	0	0	53279	\N
14076	16	0	0	54267	\N
13813	3923	9	0	52555	\N
13815	253	1	0	52559	\N
13815	242	5	0	52566	\N
13815	3924	6	0	52567	\N
13821	198	7	0	52627	\N
13821	3601	8	0	52628	\N
13823	132	7	0	52645	\N
13823	3709	8	0	52646	\N
13834	431	3	0	52777	\N
13834	3933	4	0	52778	\N
13841	1154	2	0	52807	\N
13841	1153	9	0	11685	\N
13841	3938	10	0	52820	\N
13845	164	5	0	52223	\N
13845	3940	6	0	52854	\N
13850	92	1	0	52872	\N
13850	191	2	0	52873	\N
13857	336	4	0	52919	\N
13857	3947	5	0	52920	\N
13860	18	4	0	52855	\N
13860	2302	5	0	52940	\N
13862	117	7	0	52951	\N
13862	3948	8	0	52952	\N
13864	316	10	0	52963	\N
13864	3949	11	0	52964	\N
13868	230	2	0	53009	\N
13868	231	3	0	53010	\N
13872	230	4	0	53023	\N
13872	3954	5	0	53024	\N
13876	10	8	0	53089	\N
13876	3889	9	0	53090	\N
13883	362	3	0	53113	\N
13883	3372	4	0	53115	\N
13885	75	3	0	53140	\N
13885	3855	4	0	53141	\N
13892	16	1	0	52132	\N
13892	17	2	0	52133	\N
13902	135	31	0	52757	\N
13902	3969	32	0	53242	\N
13904	1	4	0	53007	\N
13904	3820	5	0	53253	\N
13906	10	4	0	53089	\N
13906	3493	5	0	53262	\N
13913	2	1	0	52458	\N
13913	26	2	0	52869	\N
13916	3658	3	0	53304	\N
13916	362	5	0	53307	\N
13916	2946	6	0	53308	\N
13923	51	4	0	50957	\N
13923	3975	5	0	53341	\N
13926	210	1	0	51104	\N
13926	211	2	0	53342	\N
13929	35	3	0	53345	\N
13929	3563	4	0	53352	\N
13931	449	0	0	49396	\N
13934	336	4	0	53386	\N
13934	3947	5	0	53395	\N
13936	132	1	0	53397	\N
13936	455	2	0	53398	\N
13940	230	4	0	53191	\N
13940	3954	5	0	53410	\N
13942	391	4	0	52625	\N
13942	3913	5	0	52939	\N
13944	90	4	0	53428	\N
13944	3731	5	0	53429	\N
13949	92	4	0	53459	\N
13949	3979	5	0	53460	\N
13952	40	1	0	53470	\N
13952	41	2	0	53471	\N
13959	10	11	0	53530	\N
13959	3974	12	0	53531	\N
13965	49	4	0	50439	\N
13965	3751	5	0	50440	\N
13967	2636	4	0	53611	\N
13967	3617	5	0	53612	\N
13970	431	12	0	53633	\N
13970	3986	13	0	53634	\N
13972	12	8	0	53652	\N
13972	3987	9	0	53653	\N
13979	44	4	0	53691	\N
13979	3989	5	0	53692	\N
13982	189	11	0	53012	\N
13982	3991	12	0	53713	\N
13987	20	4	0	53091	\N
13987	3995	5	0	53756	\N
13994	49	8	0	53800	\N
13994	3998	9	0	53801	\N
14005	117	13	0	52951	\N
14005	4003	14	0	53927	\N
14010	149	6	0	48949	\N
14010	4006	7	0	53959	\N
14021	4015	10	0	54024	\N
14021	4016	10	0	54025	\N
14021	4018	11	1	54026	\N
14021	4017	11	0	54027	\N
14021	4020	12	1	54028	\N
14021	4019	12	0	54029	\N
14025	3891	10	0	54033	\N
14025	4024	11	0	54036	\N
14031	40	2	0	54069	\N
14031	66	3	0	54070	\N
14033	40	1	0	54069	\N
14033	41	2	0	54072	\N
14037	77	1	0	54079	\N
14037	78	2	0	54085	\N
14039	75	8	0	54100	\N
14039	4029	9	0	54101	\N
14050	42	11	0	54037	\N
14050	439	12	0	54157	\N
14052	75	5	0	54169	\N
14052	4034	6	0	54170	\N
14059	96	8	0	52509	\N
14059	4038	9	0	54217	\N
14062	102	1	0	52166	\N
14062	103	2	0	54229	\N
14064	75	4	0	54169	\N
14064	3959	5	0	54230	\N
14066	149	4	0	54231	\N
14066	4040	5	0	54240	\N
14078	2	0	0	54286	\N
14081	2	0	0	54286	\N
14082	2	0	0	54286	\N
14087	852	9	0	54300	\N
14087	4046	10	0	54324	\N
14092	365	4	0	54338	\N
14092	4049	5	0	54339	\N
14097	1	9	0	54359	\N
14097	4050	10	0	54360	\N
14100	86	4	0	52403	\N
14100	4052	5	0	51260	\N
14103	449	5	0	54380	\N
14103	4055	6	0	54381	\N
14104	10	4	0	54322	\N
14104	3493	5	0	54390	\N
14109	110	5	0	54404	\N
14109	3916	6	0	54405	\N
14115	64	15	0	54442	\N
14115	4057	16	0	54443	\N
14118	181	4	0	51428	\N
14118	4058	5	0	54470	\N
14123	264	4	0	54483	\N
14123	3684	5	0	54484	\N
14141	210	6	0	51104	\N
14141	3721	7	0	54609	\N
14145	326	9	0	54610	\N
14145	4073	10	0	54614	\N
14146	77	3	0	54079	\N
14146	1877	4	0	54080	\N
14149	279	3	0	49943	\N
14149	3641	4	0	51697	\N
14153	793	8	0	54391	\N
14153	4076	9	0	54645	\N
14156	402	0	0	54555	\N
14162	2636	1	0	54669	\N
14162	3207	2	0	54671	\N
14165	1	3	0	54690	\N
14165	3393	4	0	54691	\N
13838	3936	21	0	52785	\N
13840	1154	2	0	52807	\N
13840	1153	9	0	11685	\N
13840	3938	10	0	52820	\N
13844	40	4	0	52221	\N
13844	564	5	0	52576	\N
13848	30	16	0	52867	\N
13848	3942	17	0	52868	\N
13853	79	1	0	52400	\N
13853	81	2	0	52882	\N
13854	224	10	0	48220	\N
13854	3944	11	0	52891	\N
13859	391	4	0	52625	\N
13859	3913	5	0	52939	\N
13867	1	8	0	53007	\N
13867	3946	9	0	53008	\N
13870	189	8	0	53012	\N
13870	3953	9	0	53013	\N
13881	35	0	0	50924	\N
13882	362	23	0	53113	\N
13882	3957	24	0	53114	\N
13889	42	1	0	52258	\N
13889	43	2	0	53154	\N
13895	285	14	0	53195	\N
13895	3963	15	0	53196	\N
13900	14	17	0	52148	\N
13900	3967	18	0	53240	\N
13903	137	17	0	53243	\N
13903	3970	18	0	53244	\N
13911	273	4	0	50743	\N
13911	3777	5	0	50744	\N
13917	3611	3	0	53309	\N
13917	424	5	0	53310	\N
13917	3033	6	0	53311	\N
13919	94	0	0	53313	\N
13922	595	4	0	47837	\N
13922	3878	5	0	52077	\N
13928	30	3	0	52867	\N
13928	3640	4	0	53351	\N
13930	320	6	0	53163	\N
13930	3976	7	0	53361	\N
13933	336	0	0	53386	\N
13935	326	4	0	51061	\N
13935	3519	5	0	53396	\N
13939	242	0	0	53401	\N
13948	360	4	0	53442	\N
13948	3513	5	0	53450	\N
13951	2636	1	0	51879	\N
13951	3980	2	0	53469	\N
13953	16	3	0	53472	\N
13953	2921	4	0	53473	\N
13956	1	4	0	53438	\N
13956	3820	5	0	53439	\N
13958	228	1	0	53512	\N
13958	229	2	0	53513	\N
13961	79	0	0	52400	\N
13962	2636	29	0	53591	\N
13962	3983	30	0	53592	\N
13969	10	12	0	53530	\N
13969	3730	13	0	53632	\N
13974	373	8	0	53655	\N
13974	3988	9	0	53656	\N
13977	595	4	0	53665	\N
13977	3878	5	0	53666	\N
13984	424	3	0	53723	\N
13984	3993	4	0	53724	\N
13986	27	4	0	53746	\N
13986	3717	5	0	53747	\N
13989	3705	7	0	53772	\N
13989	10	9	0	53775	\N
13989	1416	10	0	53776	\N
13991	360	4	0	53788	\N
13991	3513	5	0	53789	\N
13996	10	9	0	53820	\N
13996	2300	10	0	53821	\N
13998	10	4	0	53831	\N
13998	3493	5	0	53832	\N
14001	424	16	0	53861	\N
14001	4001	17	0	53862	\N
14004	1109	14	0	53899	\N
14004	4002	15	0	53900	\N
14007	30	13	0	53938	\N
14007	4004	14	0	53939	\N
14009	40	2	0	53951	\N
14009	282	3	0	53952	\N
14012	38	5	0	53979	\N
14012	4008	6	0	53980	\N
14015	10	5	0	53831	\N
14015	3592	6	0	53993	\N
14017	316	1	0	53997	\N
14017	317	2	0	53998	\N
14020	77	10	0	54021	\N
14024	3891	10	0	54033	\N
14024	4023	11	1	54034	\N
14024	2435	11	0	54035	\N
14030	12	6	0	54067	\N
14030	4026	7	0	54068	\N
14032	164	6	0	52223	\N
14032	4027	7	0	54071	\N
14036	167	3	0	54083	\N
14036	4028	4	0	54084	\N
14041	30	8	0	54119	\N
14041	4030	9	0	54120	\N
14046	214	11	0	54151	\N
14046	330	12	0	54152	\N
14049	214	2	0	54151	\N
14049	1110	3	0	54156	\N
14054	44	8	0	54187	\N
14054	4035	9	0	54188	\N
14057	285	3	0	53195	\N
14057	4036	4	0	54200	\N
14058	73	3	0	54197	\N
14058	4037	4	0	54201	\N
14061	102	4	0	52166	\N
14061	3572	5	0	54228	\N
14069	79	4	0	54251	\N
14069	3678	5	0	54252	\N
14073	10	4	0	53831	\N
14073	3493	5	0	53832	\N
14077	10	8	0	54284	\N
14077	3889	9	0	54285	\N
14084	852	6	0	54300	\N
14084	4044	7	0	54301	\N
14091	167	4	0	54083	\N
14091	4048	5	0	54337	\N
14095	198	7	0	52627	\N
14095	3601	8	0	52628	\N
14099	86	1	0	52403	\N
14099	87	2	0	54364	\N
14101	4053	0	0	54371	\N
14108	367	4	0	53150	\N
14108	3679	5	0	53151	\N
14117	1	4	0	54460	\N
14117	3820	5	0	54461	\N
14120	135	1	0	52757	\N
14120	136	2	0	54472	\N
14122	273	4	0	50743	\N
14122	3777	5	0	50744	\N
14127	108	3	0	54493	\N
14127	3113	4	0	54497	\N
14131	4063	7	0	54517	\N
14131	79	12	0	54526	\N
14131	4064	13	0	54527	\N
14134	4066	7	0	54531	\N
14134	1109	12	0	54532	\N
14134	4067	13	0	54533	\N
14137	10	15	0	54541	\N
14137	3734	16	0	54542	\N
14140	4069	83	0	54564	\N
14140	402	126	0	54607	\N
14140	4070	127	0	54608	\N
14148	77	1	0	54079	\N
14148	2934	2	0	54622	\N
14152	16	1	0	54267	\N
14152	17	2	0	54632	\N
14075	290	0	0	51704	\N
14080	2	0	0	54286	\N
14083	1	6	0	53438	\N
14083	2723	7	0	54299	\N
14086	10	9	0	54322	\N
14086	3578	10	0	54323	\N
14088	18	9	0	54325	\N
14088	4047	10	0	54326	\N
14090	273	4	0	50743	\N
14090	3777	5	0	50744	\N
14093	365	1	0	54338	\N
14093	366	2	0	54340	\N
14094	198	2	0	52627	\N
14094	513	3	0	54344	\N
14096	75	7	0	54349	\N
14096	3928	8	0	54350	\N
14102	264	6	0	54378	\N
14102	4054	7	0	54379	\N
14106	793	4	0	54391	\N
14106	3618	5	0	54393	\N
14107	260	4	0	50649	\N
14107	3728	5	0	51282	\N
14110	110	6	0	54404	\N
14110	3917	7	0	54408	\N
14112	125	4	0	54415	\N
14112	4056	5	0	54416	\N
14114	64	0	0	51764	\N
14119	137	4	0	53243	\N
14119	3697	5	0	54471	\N
14121	62	4	0	54481	\N
14121	4059	5	0	54482	\N
14126	391	4	0	54495	\N
14126	3913	5	0	54496	\N
14128	16	3	0	54267	\N
14128	3634	4	0	54498	\N
14130	4062	7	0	54515	\N
14130	2782	8	0	54516	\N
14133	4063	7	0	54517	\N
14133	79	12	0	54526	\N
14133	4064	13	0	54527	\N
14136	49	3	0	54090	\N
14136	3646	4	0	54540	\N
14139	402	6	0	54555	\N
14139	4068	7	0	54556	\N
14143	4071	6	0	54612	\N
14143	4072	7	0	54613	\N
14144	326	6	0	54610	\N
14144	3805	7	0	54611	\N
14147	90	3	0	54154	\N
14147	4074	4	0	54621	\N
14154	402	3	0	54652	\N
14154	4077	4	0	54653	\N
14158	402	0	0	54555	\N
14163	908	7	0	50949	\N
14163	4078	8	0	54682	\N
14168	202	6	0	54714	\N
14168	4079	7	0	54715	\N
14171	841	4	0	54749	\N
14171	3886	5	0	54750	\N
14174	367	8	0	53150	\N
14174	4083	9	0	54780	\N
14180	235	6	0	54796	\N
14180	3622	7	0	54797	\N
14188	2796	4	0	54819	\N
14188	40	7	0	54822	\N
14188	3034	8	0	54823	\N
14190	4089	5	0	54841	\N
14197	360	1	0	53788	\N
14197	479	2	0	54864	\N
14200	1	8	0	54894	\N
14200	3946	9	0	54895	\N
14203	10	2	0	54918	\N
14203	29	3	0	54919	\N
14215	266	4	0	55006	\N
14215	4100	5	0	55007	\N
14222	40	2	0	54069	\N
14222	3034	3	0	55063	\N
14225	40	10	0	55087	\N
14225	4104	11	0	55088	\N
14235	10	4	0	55141	\N
14235	3493	5	0	55142	\N
14239	212	7	0	55159	\N
14239	4105	8	0	55161	\N
14241	391	9	0	54630	\N
14241	4107	10	0	55179	\N
14249	18	4	0	55246	\N
14249	2302	5	0	55247	\N
14252	353	8	0	51615	\N
14252	3923	9	0	52555	\N
14254	90	8	0	55275	\N
14254	4112	9	0	55276	\N
14256	3919	7	0	55280	\N
14256	322	11	0	55287	\N
14256	3071	12	0	55288	\N
14259	326	4	0	54610	\N
14259	3519	5	0	55313	\N
14263	4119	109	0	55373	\N
14263	44	126	0	55401	\N
14263	4120	127	0	55402	\N
14266	300	12	0	51177	\N
14266	4121	13	0	55439	\N
14273	210	8	0	51104	\N
14273	4124	9	0	55471	\N
14281	16	8	0	55190	\N
14281	4130	9	0	55534	\N
14283	362	14	0	53296	\N
14283	4133	15	0	55568	\N
14286	10	4	0	55580	\N
14286	3493	5	0	55581	\N
14290	181	7	0	51428	\N
14290	4137	8	0	55599	\N
14292	4125	0	0	55601	\N
14295	2896	1	0	55616	\N
14295	88	4	0	55617	\N
14295	3010	5	0	55618	\N
14296	1	2	0	55271	\N
14296	2950	3	0	55623	\N
14305	2	7	0	54286	\N
14305	2858	8	0	55896	\N
14308	167	7	0	54083	\N
14308	4147	8	0	55915	\N
14310	64	4	0	55932	\N
14310	3911	5	0	55933	\N
14313	170	3	0	52120	\N
14313	4148	4	0	55944	\N
14318	10	3	0	55957	\N
14318	3173	4	0	55958	\N
14319	147	4	0	50234	\N
14319	3877	5	0	52074	\N
14324	224	4	0	55993	\N
14324	3806	5	0	55994	\N
14326	326	3	0	54610	\N
14326	3339	4	0	56003	\N
14329	73	3	0	56030	\N
14329	3040	4	0	56031	\N
14334	391	4	0	55578	\N
14334	3913	5	0	55579	\N
14337	145	4	0	56104	\N
14337	3867	5	0	56105	\N
14340	10	4	0	56133	\N
14340	3493	5	0	56134	\N
14343	362	7	0	56152	\N
14343	4154	8	0	56153	\N
14345	290	8	0	51704	\N
14345	4155	9	0	56172	\N
14347	117	4	0	52951	\N
14347	3835	5	0	56183	\N
14350	1	7	0	56209	\N
14350	4136	8	0	56210	\N
14352	2578	4	0	56220	\N
14352	3902	5	0	56221	\N
14357	852	6	0	56255	\N
14357	4160	7	0	56256	\N
14360	852	4	0	56255	\N
14360	4162	5	0	56269	\N
14370	108	3	0	54493	\N
14079	2	0	0	54286	\N
14085	3090	9	0	54320	\N
14085	4045	10	0	54321	\N
14089	391	1	0	54329	\N
14089	392	2	0	54330	\N
14098	10	9	0	54322	\N
14098	4051	10	0	54361	\N
14105	793	1	0	54391	\N
14105	1150	2	0	54392	\N
14111	235	4	0	54413	\N
14111	3615	5	0	54414	\N
14113	235	1	0	54413	\N
14113	236	2	0	54417	\N
14116	12	4	0	54265	\N
14116	4043	5	0	54266	\N
14125	108	4	0	54493	\N
14125	4060	5	0	54494	\N
14129	10	34	0	54499	\N
14129	4061	35	0	54500	\N
14132	3330	7	0	54528	\N
14132	1	12	0	54529	\N
14132	4065	13	0	54530	\N
14135	4066	7	0	54531	\N
14135	1109	12	0	54532	\N
14135	4067	13	0	54533	\N
14138	49	3	0	54090	\N
14138	3646	4	0	54540	\N
14142	326	6	0	54610	\N
14142	3805	7	0	54611	\N
14150	244	3	0	52536	\N
14150	4075	4	0	54623	\N
14151	391	3	0	54630	\N
14151	3660	4	0	54631	\N
14157	18	3	0	54325	\N
14157	3621	4	0	54654	\N
14160	18	3	0	54325	\N
14160	3621	4	0	54654	\N
14166	67	3	0	54692	\N
14166	3749	4	0	54693	\N
14167	100	3	0	54700	\N
14167	3836	4	0	54701	\N
14173	198	5	0	54762	\N
14173	4082	6	0	54763	\N
14176	373	8	0	53655	\N
14176	3988	9	0	53656	\N
14179	69	6	0	49978	\N
14179	4084	7	0	54795	\N
14183	140	6	0	54798	\N
14183	4086	7	0	54802	\N
14187	10	1	0	54499	\N
14187	11	2	0	54818	\N
14189	1	4	0	54830	\N
14189	3820	5	0	54831	\N
14193	123	4	0	52605	\N
14193	4090	5	0	54846	\N
14199	54	3	0	50849	\N
14199	3041	4	0	54877	\N
14202	431	6	0	54912	\N
14202	4092	7	0	54913	\N
14207	224	4	0	48220	\N
14207	3806	5	0	51071	\N
14210	10	4	0	54968	\N
14210	3493	5	0	54969	\N
14212	77	4	0	54079	\N
14212	3619	5	0	54988	\N
14214	121	4	0	46364	\N
14214	4099	5	0	55005	\N
14217	10	4	0	55018	\N
14217	3493	5	0	55019	\N
14220	94	0	0	55054	\N
14227	30	4	0	55107	\N
14227	4095	5	0	55108	\N
14230	135	4	0	52757	\N
14230	3696	5	0	55119	\N
14232	10	4	0	55130	\N
14232	3493	5	0	55131	\N
14234	424	4	0	54253	\N
14234	3188	5	0	54254	\N
14238	212	1	0	55159	\N
14238	213	2	0	55160	\N
14240	149	6	0	55157	\N
14240	4106	7	0	55162	\N
14245	51	3	0	55208	\N
14245	3533	4	0	55209	\N
14250	75	3	0	54349	\N
14250	3855	4	0	55254	\N
14253	27	8	0	55273	\N
14253	4111	9	0	55274	\N
14260	4	4	0	48588	\N
14260	4117	5	0	55322	\N
14262	1636	4	0	20628	\N
14262	4118	5	0	55333	\N
14268	108	12	0	54493	\N
14268	4123	13	0	55441	\N
14270	75	4	0	55413	\N
14270	3959	5	0	55414	\N
14272	79	8	0	55469	\N
14272	3701	9	0	55470	\N
14277	88	12	0	55506	\N
14277	4127	13	0	55507	\N
14280	140	8	0	54798	\N
14280	4129	9	0	55533	\N
14285	391	4	0	55578	\N
14285	3913	5	0	55579	\N
14289	1	7	0	55271	\N
14289	4136	8	0	55598	\N
14294	11	1	0	55613	\N
14294	10	5	0	55614	\N
14294	2917	6	0	55615	\N
14299	1	8	0	55670	\N
14299	3946	9	0	55671	\N
14302	268	12	0	55680	\N
14302	4141	13	0	55700	\N
14307	23	7	0	55913	\N
14307	4146	8	0	55914	\N
14312	1	3	0	55942	\N
14312	3393	4	0	55943	\N
14317	597	3	0	55955	\N
14317	3656	4	0	55956	\N
14323	268	4	0	55680	\N
14323	3897	5	0	55992	\N
14331	10	4	0	55957	\N
14331	3493	5	0	56041	\N
14339	391	8	0	56123	\N
14339	3922	9	0	56124	\N
14342	285	7	0	53195	\N
14342	4153	8	0	56151	\N
14349	367	3	0	56193	\N
14349	3683	4	0	56194	\N
14359	198	4	0	56267	\N
14359	4161	5	0	56268	\N
14363	461	4	0	56270	\N
14363	4166	5	0	56315	\N
14368	137	3	0	55117	\N
14368	3633	4	0	56340	\N
14376	4173	116	0	56361	\N
14376	189	126	0	56362	\N
14376	4174	127	0	56363	\N
14378	4178	4	0	56374	\N
14378	4179	5	0	56375	\N
14383	230	3	0	56418	\N
14383	4181	4	0	56419	\N
14389	322	14	0	56476	\N
14389	4188	15	0	56477	\N
14396	16	0	0	55190	\N
14399	79	3	0	56521	\N
14399	3652	4	0	56522	\N
14403	177	4	0	56542	\N
14403	3538	5	0	56543	\N
14405	290	2	0	56549	\N
14405	3176	3	0	56550	\N
14408	212	2	0	55159	\N
14408	4193	3	0	56554	\N
14413	4172	6	0	56596	\N
14413	4197	7	0	56597	\N
14415	181	10	0	56635	\N
14415	4199	11	0	56636	\N
14155	402	0	0	54555	\N
14159	322	3	0	54661	\N
14159	1105	4	0	54662	\N
14161	2636	3	0	54669	\N
14161	2837	4	0	54670	\N
14164	60	3	0	52245	\N
14164	3585	4	0	54689	\N
14169	16	1	0	54718	\N
14169	17	2	0	54719	\N
14172	313	4	0	1215	\N
14172	4081	5	0	54751	\N
14177	235	0	0	50716	\N
14181	140	2	0	54798	\N
14181	487	3	0	54799	\N
14184	16	2	0	54803	\N
14184	155	3	0	54804	\N
14191	233	4	0	54842	\N
14191	3775	5	0	54843	\N
14194	86	4	0	54844	\N
14194	4052	5	0	54847	\N
14198	360	4	0	53788	\N
14198	3513	5	0	53789	\N
14204	262	8	0	50595	\N
14204	4093	9	0	54932	\N
14208	1	4	0	54957	\N
14208	3820	5	0	54958	\N
14213	1132	4	0	54989	\N
14213	77	15	0	54992	\N
14213	4096	16	1	54993	\N
14213	59	16	0	54994	\N
14213	4098	17	1	54995	\N
14213	4097	17	0	54996	\N
14218	10	11	0	55018	\N
14218	4101	12	0	55042	\N
14221	17	1	0	55055	\N
14221	16	5	0	55056	\N
14221	4103	6	1	55057	\N
14221	2519	6	0	55058	\N
14223	16	6	0	54803	\N
14223	3369	7	0	55076	\N
14228	123	4	0	52605	\N
14228	4090	5	0	54846	\N
14237	149	7	0	55157	\N
14237	3600	8	0	55158	\N
14243	16	2	0	55190	\N
14243	2974	3	0	55191	\N
14246	56	3	0	55210	\N
14246	4109	4	0	55211	\N
14248	1	4	0	55128	\N
14248	3820	5	0	55129	\N
14251	1	8	0	55271	\N
14251	3946	9	0	55272	\N
14258	86	4	0	55311	\N
14258	4052	5	0	55312	\N
14261	62	4	0	55323	\N
14261	4059	5	0	55324	\N
14265	75	4	0	55413	\N
14265	3959	5	0	55414	\N
14274	210	2	0	51104	\N
14274	458	3	0	55472	\N
14275	10	3	0	55141	\N
14275	3173	4	0	55479	\N
14278	266	10	0	55006	\N
14278	4128	11	0	55516	\N
14287	110	4	0	54404	\N
14287	4134	5	0	55582	\N
14288	110	6	0	54404	\N
14288	4135	7	0	55587	\N
14291	75	7	0	55413	\N
14291	2859	8	0	55600	\N
14297	322	9	0	55642	\N
14297	4139	10	0	55643	\N
14300	1151	5	0	47574	\N
14300	2583	6	1	55672	\N
14300	4140	6	0	55673	\N
14303	1636	12	0	55701	\N
14303	4142	13	0	55702	\N
14306	1109	7	0	55897	\N
14306	4145	8	0	55898	\N
14311	30	4	0	55934	\N
14311	4095	5	0	55935	\N
14314	140	3	0	55945	\N
14314	4149	4	0	55946	\N
14315	595	3	0	53665	\N
14315	3654	4	0	55953	\N
14320	595	4	0	53665	\N
14320	3878	5	0	53666	\N
14322	1	7	0	55942	\N
14322	4136	8	0	55983	\N
14327	18	4	0	56012	\N
14327	2302	5	0	56013	\N
14330	73	2	0	56030	\N
14330	2766	3	0	56032	\N
14332	435	4	0	56042	\N
14332	3531	5	0	56043	\N
14335	67	8	0	54692	\N
14335	4151	9	0	56085	\N
14338	164	4	0	52223	\N
14338	4152	5	0	56106	\N
14341	56	4	0	56135	\N
14341	3127	5	0	56136	\N
14344	73	7	0	56154	\N
14344	3675	8	0	56155	\N
14346	35	8	0	56173	\N
14346	3956	9	0	56174	\N
14348	4156	74	0	56184	\N
14348	117	126	0	56185	\N
14348	4157	127	0	56186	\N
14351	927	7	0	8544	\N
14351	4158	8	0	56211	\N
14353	360	4	0	56230	\N
14353	3513	5	0	56231	\N
14355	2	1	0	56234	\N
14355	26	2	0	56235	\N
14361	461	4	0	56270	\N
14361	4163	5	1	56271	\N
14361	59	5	0	56272	\N
14364	4167	74	0	56319	\N
14364	117	126	0	56320	\N
14364	4168	127	0	56321	\N
14366	125	3	0	54415	\N
14366	4170	4	0	56337	\N
14369	135	3	0	52757	\N
14369	3630	4	0	56341	\N
14373	4172	0	0	56352	\N
14375	40	0	0	55087	\N
14377	4175	38	0	56364	\N
14377	189	67	0	56365	\N
14377	4177	68	1	56366	\N
14377	4176	68	0	56367	\N
14379	142	11	0	54218	\N
14379	656	12	0	56394	\N
14381	18	11	0	56396	\N
14381	218	12	0	56397	\N
14390	149	3	0	56484	\N
14390	4189	4	0	56485	\N
14392	206	1	0	46380	\N
14392	207	2	0	56488	\N
14395	741	3	0	25850	\N
14395	4190	4	0	56511	\N
14397	4172	2	0	56352	\N
14397	4191	3	0	56516	\N
14407	173	2	0	51774	\N
14407	3179	3	0	56553	\N
14410	449	1	0	56555	\N
14410	1079	2	0	56556	\N
14411	455	1	0	56559	\N
14411	4195	2	0	56561	\N
14417	235	3	0	56644	\N
14417	3343	4	0	56645	\N
14170	51	10	0	50957	\N
14170	4080	11	0	54740	\N
14175	367	2	0	53150	\N
14175	651	3	0	54781	\N
14178	69	2	0	49978	\N
14178	500	3	0	54786	\N
14182	288	6	0	54800	\N
14182	4085	7	0	54801	\N
14185	235	2	0	54796	\N
14185	1061	3	0	54805	\N
14186	4087	8	0	54814	\N
14186	38	9	0	54815	\N
14192	86	1	0	54844	\N
14192	87	2	0	54845	\N
14195	123	1	0	52605	\N
14195	124	2	0	54848	\N
14196	453	6	0	47420	\N
14196	4091	7	0	54861	\N
14201	10	1	0	54898	\N
14201	11	2	0	54899	\N
14205	528	8	0	49889	\N
14205	3702	9	0	49890	\N
14206	316	9	0	54939	\N
14206	4094	10	0	54940	\N
14209	391	4	0	54630	\N
14209	3913	5	0	54967	\N
14211	30	4	0	54978	\N
14211	4095	5	0	54979	\N
14216	79	4	0	55016	\N
14216	3678	5	0	55017	\N
14219	57	1	0	55045	\N
14219	56	5	0	55052	\N
14219	4102	6	0	55053	\N
14224	23	4	0	55085	\N
14224	3189	5	0	55086	\N
14226	1	4	0	55097	\N
14226	3820	5	0	55098	\N
14229	137	4	0	55117	\N
14229	3697	5	0	55118	\N
14231	1	4	0	55128	\N
14231	3820	5	0	55129	\N
14233	2	4	0	54286	\N
14233	3510	5	0	55140	\N
14236	365	4	0	54338	\N
14236	4049	5	0	54339	\N
14242	453	4	0	55188	\N
14242	4108	5	0	55189	\N
14244	35	4	0	55200	\N
14244	3545	5	0	55201	\N
14247	177	8	0	55228	\N
14247	4110	9	0	55229	\N
14255	90	2	0	55275	\N
14255	91	3	0	55277	\N
14257	4113	4	0	55297	\N
14257	4114	4	0	55298	\N
14264	235	4	0	55411	\N
14264	3615	5	0	55412	\N
14267	1	12	0	55271	\N
14267	4122	13	0	55440	\N
14269	262	1	0	50595	\N
14269	263	2	0	55444	\N
14271	18	4	0	55451	\N
14271	2302	5	0	55452	\N
14276	4125	6	0	55492	\N
14276	4126	7	0	55493	\N
14279	140	2	0	54798	\N
14279	487	3	0	54799	\N
14282	4131	95	0	55535	\N
14282	228	114	0	55550	\N
14282	4132	115	0	55551	\N
14284	1	4	0	55271	\N
14284	3820	5	0	55577	\N
14293	89	1	0	55604	\N
14293	88	5	0	55611	\N
14293	4138	6	0	55612	\N
14298	841	4	0	55652	\N
14298	3886	5	0	55653	\N
14301	268	3	0	55680	\N
14301	610	4	0	55681	\N
14304	4143	109	0	55854	\N
14304	44	126	0	55880	\N
14304	4144	127	0	55881	\N
14309	10	3	0	55922	\N
14309	3173	4	0	55923	\N
14316	147	3	0	50234	\N
14316	3657	4	0	55954	\N
14321	597	4	0	55967	\N
14321	3733	5	0	55968	\N
14325	326	4	0	54610	\N
14325	3519	5	0	55313	\N
14328	18	4	0	56022	\N
14328	2302	5	0	56023	\N
14333	56	8	0	55210	\N
14333	4150	9	0	56060	\N
14336	1	4	0	56094	\N
14336	3820	5	0	56095	\N
14354	10	4	0	56133	\N
14354	3493	5	0	56134	\N
14356	4159	8	0	56252	\N
14356	38	9	0	56253	\N
14358	10	4	0	56265	\N
14358	3493	5	0	56266	\N
14362	4164	12	0	56273	\N
14362	198	126	0	56313	\N
14362	4165	127	0	56314	\N
14365	117	4	0	56329	\N
14365	4169	5	0	56330	\N
14367	200	3	0	56338	\N
14367	3338	4	0	56339	\N
14371	75	3	0	56349	\N
14371	3855	4	0	56350	\N
14374	391	3	0	56359	\N
14374	3660	4	0	56360	\N
14380	241	1	0	47085	\N
14380	333	2	0	56395	\N
14382	18	6	0	56410	\N
14382	4180	7	0	56411	\N
14385	251	6	0	56434	\N
14385	4183	7	0	56435	\N
14387	4186	0	0	56444	\N
14388	449	6	0	56446	\N
14388	4187	7	0	56447	\N
14391	266	3	0	56486	\N
14391	3474	4	0	56487	\N
14393	18	3	0	56495	\N
14393	3621	4	0	56496	\N
14398	453	3	0	56519	\N
14398	2838	4	0	56520	\N
14402	12	4	0	56540	\N
14402	4043	5	0	56541	\N
14412	4172	11	0	56352	\N
14412	4196	12	0	56584	\N
14257	4115	5	1	138603	\N
14257	3268	6	1	138604	\N
14257	4116	6	0	138605	\N
14257	1374	5	0	138602	\N
14370	4171	4	0	56348	\N
14372	2	0	0	56351	\N
14384	230	6	0	56432	\N
14384	4182	7	0	56433	\N
14386	181	3	0	51428	\N
14386	4184	4	0	56442	\N
14394	75	3	0	56503	\N
14394	3855	4	0	56504	\N
14400	793	3	0	56523	\N
14400	2644	4	0	56524	\N
14401	149	3	0	56531	\N
14401	4189	4	0	56532	\N
14404	12	6	0	56540	\N
14404	4192	7	0	56544	\N
14406	56	2	0	56551	\N
14406	2914	3	0	56552	\N
14409	212	2	0	55159	\N
14409	4193	3	0	56554	\N
14414	260	13	0	56617	\N
14414	4198	14	0	56618	\N
14416	4125	3	0	55601	\N
14416	4200	4	0	56643	\N
14418	132	1	0	56646	\N
14418	455	2	0	56647	\N
14419	4172	1	0	56650	\N
14419	4201	2	0	56651	\N
14420	16	1	0	55190	\N
14420	17	2	0	56652	\N
14421	4178	5	0	56663	\N
14421	4202	6	0	56664	\N
14422	27	5	0	55273	\N
14422	4203	6	0	56665	\N
14423	75	2	0	56670	\N
14423	284	3	0	56671	\N
14424	12	3	0	56540	\N
14424	4204	4	0	56678	\N
14425	12	2	0	56679	\N
14425	3028	3	0	56680	\N
14426	4178	4	0	56663	\N
14426	4205	5	0	56689	\N
14427	75	4	0	56690	\N
14427	3959	5	0	56691	\N
14428	170	8	0	52120	\N
14428	3904	9	0	52402	\N
14429	189	0	0	56708	\N
14430	189	45	0	56709	\N
14430	4206	46	0	56710	\N
14431	189	1	0	56708	\N
14431	190	2	0	56713	\N
14432	75	11	0	56690	\N
14432	4207	12	0	56736	\N
14433	27	5	0	56746	\N
14433	4208	6	0	56747	\N
14434	27	4	0	56746	\N
14434	4209	5	0	56748	\N
14435	300	8	0	56763	\N
14435	4210	9	0	56764	\N
14436	4178	3	0	56771	\N
14436	4211	4	0	56772	\N
14437	62	3	0	55323	\N
14437	3344	4	0	56773	\N
14438	110	4	0	54404	\N
14438	4134	5	0	55582	\N
14439	273	6	0	50743	\N
14439	4212	7	0	56794	\N
14440	1785	2	0	56799	\N
14440	14	5	0	56804	\N
14440	1421	6	0	56805	\N
14441	58	4	0	49503	\N
14441	4213	5	0	56814	\N
14442	210	4	0	51104	\N
14442	3536	5	0	51105	\N
14443	115	3	0	56821	\N
14443	3483	4	0	56822	\N
14444	258	10	0	53193	\N
14444	4214	11	0	56823	\N
14445	4178	3	0	56771	\N
14445	4211	4	0	56772	\N
14446	210	3	0	56836	\N
14446	4215	4	0	56837	\N
14447	86	3	0	56838	\N
14447	3157	4	0	56839	\N
14448	33	6	0	56852	\N
14448	4216	7	0	56853	\N
14449	40	2	0	56858	\N
14449	3034	3	0	56859	\N
14450	164	2	0	52223	\N
14450	3085	3	0	56860	\N
14451	164	3	0	56867	\N
14451	3385	4	0	56868	\N
14452	62	3	0	56875	\N
14452	3344	4	0	56876	\N
14453	64	3	0	55932	\N
14453	4217	4	0	56877	\N
14454	71	4	0	56886	\N
14454	3887	5	0	56887	\N
14455	244	4	0	52536	\N
14455	3778	5	0	56888	\N
14456	4178	8	0	56905	\N
14456	4218	9	0	56906	\N
14457	4172	4	0	56915	\N
14457	4219	5	0	56916	\N
14458	75	7	0	56931	\N
14458	2859	8	0	56932	\N
14459	102	4	0	52166	\N
14459	3572	5	0	54228	\N
14460	2782	4	0	56941	\N
14460	3872	5	0	56942	\N
14461	365	4	0	56951	\N
14461	4049	5	0	56952	\N
14462	142	4	0	54218	\N
14462	3950	5	0	56953	\N
14463	260	4	0	56617	\N
14463	3728	5	0	56954	\N
14464	451	4	0	52779	\N
14464	3666	5	0	56955	\N
14465	451	1	0	52779	\N
14465	584	2	0	56956	\N
14466	100	8	0	56973	\N
14466	4220	9	0	56974	\N
14467	40	4	0	56858	\N
14467	3381	5	0	56983	\N
14468	4178	4	0	56984	\N
14468	4205	5	0	56985	\N
14469	90	4	0	56986	\N
14469	3731	5	0	56987	\N
14470	90	16	0	56986	\N
14470	4221	17	0	56988	\N
14471	51	3	0	56995	\N
14471	3533	4	0	56996	\N
14472	69	1	0	49978	\N
14472	70	2	0	54243	\N
14473	69	4	0	49978	\N
14473	4041	5	0	54250	\N
14474	4222	10	0	57025	\N
14474	125	16	0	57036	\N
14474	4223	17	0	57037	\N
14475	189	1	0	57038	\N
14475	4224	2	0	57039	\N
14477	189	5	0	57040	\N
14477	4225	6	0	57041	\N
14478	33	8	0	57058	\N
14478	3812	9	0	57059	\N
14479	75	8	0	57060	\N
14479	4029	9	0	57061	\N
14480	40	12	0	56858	\N
14480	4226	13	0	57086	\N
14481	2	4	0	57095	\N
14481	3510	5	0	57096	\N
14482	362	0	0	56152	\N
14483	362	1	0	56152	\N
14483	395	2	0	57097	\N
14484	212	4	0	55159	\N
14484	3732	5	0	57098	\N
14485	113	1	0	50847	\N
14485	437	2	0	57101	\N
14486	40	4	0	57108	\N
14486	3381	5	0	57109	\N
14494	4172	4	0	57110	\N
14494	4219	5	0	57111	\N
14498	852	1	0	56255	\N
14498	913	2	0	57226	\N
14500	79	3	0	57232	\N
14500	272	4	0	57233	\N
14506	908	8	0	57304	\N
14506	3509	9	0	57305	\N
14509	79	1	0	57321	\N
14509	81	2	0	57322	\N
14514	233	6	0	54842	\N
14514	4245	7	0	57351	\N
14522	316	3	0	57389	\N
14522	4249	4	0	57390	\N
14531	266	2	0	56486	\N
14531	2103	3	0	57440	\N
14533	391	2	0	56359	\N
14533	1381	3	0	57446	\N
14538	4172	4	0	57470	\N
14538	4252	5	0	57471	\N
14541	40	6	0	57108	\N
14541	4255	7	0	57504	\N
14547	230	12	0	56432	\N
14547	4258	13	0	57550	\N
14552	60	10	0	52245	\N
14552	4260	11	0	57573	\N
14555	528	3	0	57585	\N
14555	4262	4	0	57586	\N
14558	290	3	0	56549	\N
14558	3635	4	0	57595	\N
14563	115	2	0	57583	\N
14563	2797	3	0	57616	\N
14566	135	2	0	52757	\N
14566	2722	3	0	57619	\N
14568	33	6	0	57643	\N
14568	3444	7	0	57644	\N
14573	264	2	0	57587	\N
14573	2780	3	0	57655	\N
14577	40	2	0	57108	\N
14577	282	3	0	57366	\N
14579	121	1	0	57431	\N
14579	3098	2	0	57673	\N
14582	326	1	0	57681	\N
14582	1534	2	0	57682	\N
14589	210	3	0	56836	\N
14589	3539	4	0	57712	\N
14591	62	3	0	56875	\N
14591	3344	4	0	56876	\N
14594	14	3	0	57737	\N
14594	4272	4	0	57738	\N
14598	117	3	0	57751	\N
14598	3653	4	0	57752	\N
14604	4172	3	0	57669	\N
14604	4275	4	0	57769	\N
14607	4178	3	0	57784	\N
14607	4211	4	0	57785	\N
14610	264	11	0	57587	\N
14610	4278	12	0	57812	\N
14612	4172	3	0	57825	\N
14612	4275	4	0	57826	\N
14615	135	3	0	52757	\N
14615	3630	4	0	56341	\N
14617	316	9	0	57854	\N
14617	4279	10	0	57855	\N
14621	451	3	0	52779	\N
14621	3934	4	0	52780	\N
14624	40	3	0	57878	\N
14624	372	4	0	57879	\N
14629	2	3	0	57095	\N
14629	3548	4	0	57910	\N
14634	264	0	0	54483	\N
14637	16	6	0	57948	\N
14637	3369	7	0	57949	\N
14639	285	2	0	53195	\N
14639	4282	3	0	57956	\N
14643	4172	2	0	57825	\N
14643	4285	3	0	57966	\N
14653	435	3	0	56042	\N
14653	3504	4	0	58039	\N
14656	4289	3	0	58035	\N
14656	4293	3	0	58040	\N
14656	3782	4	0	58041	\N
14657	14	3	0	57737	\N
14657	4272	4	0	57738	\N
14662	79	5	0	58063	\N
14662	3341	6	0	58064	\N
14664	4172	3	0	58033	\N
14664	4275	4	0	58034	\N
14666	4178	8	0	58102	\N
14666	4298	9	0	58103	\N
14667	4178	24	0	58152	\N
14667	4299	25	0	58153	\N
14669	149	7	0	58170	\N
14669	1003	8	0	58172	\N
14672	402	3	0	58199	\N
14672	1328	4	0	58200	\N
14680	453	33	0	56519	\N
14680	4311	34	0	58371	\N
14684	362	9	0	56152	\N
14684	4317	10	0	58395	\N
14691	435	6	0	56042	\N
14691	4324	7	0	58432	\N
14693	4172	2	0	58439	\N
14693	4191	3	0	58440	\N
14697	30	2	0	58459	\N
14697	1127	3	0	58460	\N
14703	4172	4	0	58549	\N
14703	4252	5	0	58550	\N
14704	488	2	0	50931	\N
14704	2791	3	0	58555	\N
14707	4332	3	0	58562	\N
14710	42	6	0	54037	\N
14710	4334	7	0	58587	\N
14712	4337	36	0	58696	\N
14712	4315	37	0	58375	\N
14712	4338	37	0	58697	\N
14718	790	2	0	58732	\N
14718	4343	3	0	58733	\N
14720	2351	4	0	58748	\N
14720	3463	5	0	58749	\N
14723	353	2	0	58428	\N
14723	2884	3	0	58760	\N
14730	164	2	0	58774	\N
14730	1124	3	0	58783	\N
14740	18	2	0	57864	\N
14740	1685	3	0	58837	\N
14746	16	2	0	58071	\N
14746	388	3	0	58895	\N
14749	2	2	0	57095	\N
14749	2789	3	0	58915	\N
14754	14	2	0	58937	\N
14754	1785	3	0	58938	\N
14756	4178	2	0	58943	\N
14756	4247	3	0	58944	\N
14761	4178	2	0	58964	\N
14761	4247	3	0	58965	\N
14769	3628	2	0	49549	\N
14769	4360	3	0	58999	\N
14774	2	0	0	57095	\N
14776	2	0	0	59019	\N
14781	793	2	0	56523	\N
14781	4363	3	0	59041	\N
14783	145	2	0	59051	\N
14783	1108	3	0	59052	\N
14786	224	2	0	59068	\N
14786	3150	3	0	59069	\N
14788	167	2	0	59076	\N
14788	3322	3	0	59077	\N
14791	4178	2	0	59097	\N
14791	4247	3	0	59098	\N
14797	228	3	0	53512	\N
14797	1187	4	0	59134	\N
14799	40	2	0	59039	\N
14799	282	3	0	59040	\N
14802	4178	5	0	59167	\N
14487	4172	4	0	57110	\N
14487	4219	5	0	57111	\N
14490	198	17	0	56267	\N
14490	4229	18	0	57157	\N
14492	4231	12	0	57169	\N
14492	198	46	0	57203	\N
14492	4232	47	0	57204	\N
14495	49	4	0	57215	\N
14495	3751	5	0	57216	\N
14496	852	3	0	57217	\N
14496	4235	4	0	57218	\N
14501	4178	8	0	56984	\N
14501	4237	9	0	57244	\N
14503	56	1	0	56551	\N
14503	57	2	0	57248	\N
14507	4240	5	0	57316	\N
14507	4241	6	0	51505	\N
14507	4242	6	0	57317	\N
14515	4246	7	0	57361	\N
14516	40	2	0	57108	\N
14516	282	3	0	57366	\N
14521	262	6	0	50595	\N
14521	4248	7	0	57382	\N
14523	4178	2	0	56984	\N
14523	4247	3	0	57367	\N
14526	4178	2	0	57427	\N
14526	4247	3	0	57428	\N
14529	75	2	0	57060	\N
14529	284	3	0	57433	\N
14534	167	2	0	54083	\N
14534	3322	3	0	57447	\N
14539	79	6	0	57321	\N
14539	4253	7	0	57484	\N
14542	181	6	0	57505	\N
14542	4256	7	0	57506	\N
14544	4172	2	0	57513	\N
14544	4191	3	0	57514	\N
14548	56	12	0	57551	\N
14548	4259	13	0	57552	\N
14550	60	10	0	52245	\N
14550	4260	11	0	57573	\N
14559	198	3	0	56267	\N
14559	4263	4	0	57602	\N
14561	90	2	0	57607	\N
14561	3442	3	0	57608	\N
14562	4264	25	0	57609	\N
14562	90	126	0	57610	\N
14562	4265	127	0	57611	\N
14564	137	2	0	55117	\N
14564	2721	3	0	57617	\N
14569	336	6	0	53386	\N
14569	4267	7	0	57645	\N
14575	96	2	0	57661	\N
14575	2347	3	0	57662	\N
14578	4172	2	0	57669	\N
14578	4191	3	0	57670	\N
14580	35	1	0	56173	\N
14580	2929	2	0	57676	\N
14587	4178	3	0	57427	\N
14587	4211	4	0	57703	\N
14590	16	3	0	57713	\N
14590	3634	4	0	57714	\N
14595	260	3	0	57739	\N
14595	3399	4	0	57740	\N
14599	1858	0	0	25261	\N
14600	1858	3	0	25261	\N
14600	4273	4	0	57753	\N
14603	75	3	0	57647	\N
14603	3855	4	0	57762	\N
14605	16	3	0	57713	\N
14605	3634	4	0	57714	\N
14613	288	3	0	54800	\N
14613	3003	4	0	57827	\N
14618	365	3	0	56951	\N
14618	3839	4	0	57760	\N
14625	73	3	0	57880	\N
14625	3040	4	0	57881	\N
14627	424	6	0	57438	\N
14627	3712	7	0	57896	\N
14630	173	3	0	57911	\N
14630	3796	4	0	57912	\N
14632	528	9	0	57931	\N
14632	4280	10	0	57932	\N
14638	4178	6	0	57950	\N
14638	4250	7	0	57951	\N
14640	908	2	0	57749	\N
14640	3025	3	0	57957	\N
14642	4283	63	0	57959	\N
14642	214	126	0	57960	\N
14642	4284	127	0	57961	\N
14645	56	3	0	57551	\N
14645	4109	4	0	57998	\N
14648	4286	63	0	58007	\N
14648	214	126	0	58008	\N
14648	4287	127	0	58009	\N
14650	365	3	0	58031	\N
14650	3839	4	0	58032	\N
14658	4172	3	0	58033	\N
14658	4275	4	0	58034	\N
14660	156	5	0	58059	\N
14660	4295	6	0	58060	\N
14670	262	9	0	58189	\N
14670	4300	10	0	58190	\N
14673	300	24	0	58243	\N
14673	4302	25	0	58244	\N
14676	402	24	0	58199	\N
14676	4305	25	0	58247	\N
14677	2782	24	0	58248	\N
14677	4306	25	0	58249	\N
14681	54	24	0	58333	\N
14681	4312	25	0	58372	\N
14698	402	2	0	58199	\N
14698	2760	3	0	58465	\N
14705	108	2	0	54493	\N
14705	3340	3	0	58560	\N
14721	125	1	0	58752	\N
14721	195	2	0	58753	\N
14724	212	2	0	58761	\N
14724	3616	3	0	58762	\N
14728	82	4	0	58776	\N
14728	3422	5	0	58777	\N
14731	192	8	0	58800	\N
14731	3419	9	0	58801	\N
14734	4348	0	0	58806	\N
14734	4349	0	0	58807	\N
14736	453	8	0	58824	\N
14736	4350	9	0	58825	\N
14738	435	2	0	56042	\N
14738	3413	3	0	58832	\N
14741	4125	4	0	57685	\N
14741	4351	5	0	58846	\N
14747	121	4	0	58904	\N
14747	4356	5	0	58905	\N
14752	365	2	0	58926	\N
14752	615	3	0	58927	\N
14757	40	1	0	58947	\N
14757	1383	2	0	58948	\N
14759	40	2	0	58947	\N
14759	282	3	0	58954	\N
14762	75	2	0	57647	\N
14762	284	3	0	58966	\N
14765	163	1	0	58983	\N
14765	33	5	0	58990	\N
14765	3342	6	0	58991	\N
14767	3625	2	0	49279	\N
14767	4359	3	0	58996	\N
14772	4178	2	0	58964	\N
14772	4247	3	0	58965	\N
14775	2	0	0	57095	\N
14777	391	6	0	59032	\N
14777	4361	7	0	59033	\N
14779	40	2	0	59039	\N
14779	282	3	0	59040	\N
14784	224	4	0	59061	\N
14784	3281	5	0	59062	\N
14787	16	2	0	59070	\N
14488	94	8	0	57112	\N
14488	4227	9	0	57113	\N
14489	353	7	0	51615	\N
14489	4228	8	0	57124	\N
14493	4234	5	0	57214	\N
14505	528	19	0	49889	\N
14505	4239	20	0	57287	\N
14508	2566	0	0	37774	\N
14508	4243	0	0	57318	\N
14511	79	7	0	57321	\N
14511	3682	8	0	57338	\N
14513	4172	6	0	57359	\N
14513	4197	7	0	57360	\N
14518	198	2	0	56267	\N
14518	513	3	0	57368	\N
14520	264	2	0	54483	\N
14520	2780	3	0	57369	\N
14525	4178	6	0	57421	\N
14525	4250	7	0	57422	\N
14528	121	2	0	57431	\N
14528	2498	3	0	57432	\N
14530	424	2	0	57438	\N
14530	2755	3	0	57439	\N
14537	264	4	0	57460	\N
14537	4251	5	0	57461	\N
14540	142	3	0	54218	\N
14540	4254	4	0	57491	\N
14546	151	4	0	48831	\N
14546	1876	5	0	57525	\N
14549	206	0	0	46380	\N
14554	115	3	0	57583	\N
14554	3483	4	0	57584	\N
14557	264	3	0	57587	\N
14557	3632	4	0	57588	\N
14567	212	6	0	57629	\N
14567	4266	7	0	57630	\N
14571	75	6	0	57647	\N
14571	3361	7	0	57648	\N
14572	170	2	0	57653	\N
14572	1380	3	0	57654	\N
14574	3846	2	0	51591	\N
14574	4269	3	0	57656	\N
14581	880	1	0	57679	\N
14581	2905	2	0	57680	\N
14584	16	1	0	57687	\N
14584	1087	2	0	57688	\N
14586	100	3	0	57701	\N
14586	3836	4	0	57702	\N
14588	40	3	0	57710	\N
14588	372	4	0	57711	\N
14593	514	3	0	57735	\N
14593	4271	4	0	57736	\N
14597	908	3	0	57749	\N
14597	3591	4	0	57750	\N
14602	3726	3	0	50161	\N
14602	4274	4	0	57761	\N
14606	852	2	0	57776	\N
14606	4276	3	0	57777	\N
14609	92	11	0	57810	\N
14609	4277	12	0	57811	\N
14614	137	3	0	55117	\N
14614	3633	4	0	56340	\N
14616	40	3	0	57834	\N
14616	372	4	0	57835	\N
14620	367	3	0	57862	\N
14620	3683	4	0	57863	\N
14622	18	3	0	57864	\N
14622	3621	4	0	57865	\N
14623	4178	3	0	57784	\N
14623	4211	4	0	57785	\N
14628	268	3	0	55680	\N
14628	3815	4	0	57903	\N
14631	18	3	0	57864	\N
14631	3621	4	0	57865	\N
14636	173	6	0	57946	\N
14636	3606	7	0	57947	\N
14644	391	12	0	56359	\N
14644	581	13	0	57991	\N
14647	214	3	0	54151	\N
14647	3496	4	0	58006	\N
14649	4288	5	0	58020	\N
14649	71	7	0	58023	\N
14649	3035	8	0	58024	\N
14652	4289	3	0	58035	\N
14652	4290	3	0	58036	\N
14652	4292	4	1	58037	\N
14652	4291	4	0	58038	\N
14655	189	0	0	56708	\N
14659	186	3	0	53949	\N
14659	4294	4	0	58048	\N
14663	16	3	0	58071	\N
14663	3634	4	0	58072	\N
14675	2	24	0	57095	\N
14675	4304	25	0	58246	\N
14678	869	12	0	58274	\N
14678	40	17	0	58283	\N
14678	2796	18	0	58284	\N
14679	54	24	0	58333	\N
14683	4314	30	0	58374	\N
14683	4315	31	0	58375	\N
14683	4316	31	0	58376	\N
14686	367	3	0	57862	\N
14686	3683	4	0	57863	\N
14688	353	7	0	58414	\N
14688	4320	8	0	58415	\N
14690	4322	6	0	58430	\N
14690	4323	7	0	58431	\N
14692	2578	2	0	58437	\N
14692	4325	3	0	58438	\N
14695	424	4	0	58451	\N
14695	4326	5	0	58452	\N
14700	4327	68	0	58536	\N
14700	4328	69	0	58537	\N
14700	4329	69	0	58538	\N
14702	4178	4	0	58396	\N
14702	4331	5	0	58548	\N
14709	14	6	0	57737	\N
14709	2720	7	0	58586	\N
14715	62	10	0	58719	\N
14715	4340	11	0	58720	\N
14717	200	2	0	56338	\N
14717	276	3	0	58731	\N
14719	151	2	0	58738	\N
14719	2854	3	0	58739	\N
14722	424	2	0	58758	\N
14722	2755	3	0	58759	\N
14727	164	4	0	58774	\N
14727	4345	5	0	58775	\N
14729	411	2	0	58449	\N
14729	3370	3	0	58782	\N
14733	4172	8	0	58804	\N
14733	4347	9	0	58805	\N
14737	2636	2	0	58830	\N
14737	2836	3	0	58831	\N
14743	135	4	0	52757	\N
14743	4353	5	0	58849	\N
14744	4178	2	0	58854	\N
14744	4247	3	0	58855	\N
14748	235	2	0	56644	\N
14748	2757	3	0	58910	\N
14751	4332	3	0	58562	\N
14753	20	2	0	53091	\N
14753	369	3	0	58932	\N
14764	4178	6	0	58964	\N
14764	4358	7	0	58980	\N
14766	163	1	0	58983	\N
14766	33	5	0	58990	\N
14766	3342	6	0	58991	\N
14771	4172	2	0	58804	\N
14771	4191	3	0	59014	\N
14778	189	6	0	57040	\N
14679	4308	25	1	138609	\N
14679	4310	26	1	138610	\N
14491	241	17	0	47085	\N
14491	4230	18	0	57158	\N
14497	852	3	0	56255	\N
14497	3612	4	0	57225	\N
14499	852	2	0	56255	\N
14499	4236	3	0	57227	\N
14502	79	8	0	57232	\N
14502	4238	9	0	57245	\N
14504	4178	4	0	56984	\N
14504	4205	5	0	56985	\N
14510	86	7	0	57335	\N
14512	233	6	0	54842	\N
14512	4245	7	0	57351	\N
14517	4178	2	0	56984	\N
14517	4247	3	0	57367	\N
14524	273	6	0	57407	\N
14524	4212	7	0	57408	\N
14527	4172	2	0	57429	\N
14527	4191	3	0	57430	\N
14532	2636	0	0	57441	\N
14535	4178	2	0	57427	\N
14535	4247	3	0	57428	\N
14536	4172	2	0	57429	\N
14536	4191	3	0	57430	\N
14543	73	6	0	57507	\N
14543	4257	7	0	57508	\N
14545	1470	4	0	57523	\N
14545	2798	5	0	57524	\N
14551	241	10	0	57574	\N
14551	4261	11	0	57575	\N
14553	40	3	0	57108	\N
14553	372	4	0	57582	\N
14556	264	3	0	57587	\N
14556	3632	4	0	57588	\N
14565	2636	1	0	57441	\N
14565	3207	2	0	57618	\N
14570	288	6	0	54800	\N
14570	4268	7	0	57646	\N
14576	27	2	0	57663	\N
14576	645	3	0	57664	\N
14583	4125	1	0	57685	\N
14583	4270	2	0	57686	\N
14585	18	2	0	57693	\N
14585	3817	3	0	57694	\N
14592	411	3	0	57727	\N
14592	3596	4	0	57728	\N
14596	64	3	0	57741	\N
14596	4217	4	0	57742	\N
14601	365	3	0	56951	\N
14601	3839	4	0	57760	\N
14608	852	3	0	57786	\N
14608	3612	4	0	57787	\N
14611	79	2	0	57817	\N
14611	616	3	0	57818	\N
14619	367	0	0	57862	\N
14626	4178	3	0	57882	\N
14626	4211	4	0	57883	\N
14633	451	9	0	52779	\N
14633	4281	10	0	57933	\N
14635	264	0	0	54483	\N
14641	214	2	0	54151	\N
14641	2979	3	0	57958	\N
14646	4178	3	0	57950	\N
14646	4211	4	0	58005	\N
14651	4172	3	0	58033	\N
14651	4275	4	0	58034	\N
14654	75	3	0	57647	\N
14654	3855	4	0	57762	\N
14661	1640	5	0	58061	\N
14661	4296	6	0	58062	\N
14665	4178	6	0	57950	\N
14665	4297	7	0	58085	\N
14668	149	8	0	58170	\N
14668	2335	9	0	58171	\N
14671	96	9	0	58191	\N
14671	4301	10	0	58192	\N
14674	132	24	0	56646	\N
14674	4303	25	0	58245	\N
14682	453	24	0	56519	\N
14682	4313	25	0	58373	\N
14685	4178	9	0	58396	\N
14685	4318	10	0	58397	\N
14687	77	7	0	58412	\N
14687	4319	8	0	58413	\N
14689	353	6	0	58428	\N
14689	4321	7	0	58429	\N
14694	411	4	0	58449	\N
14694	2806	5	0	58450	\N
14696	268	2	0	58457	\N
14696	2800	3	0	58458	\N
14699	852	2	0	58466	\N
14699	2872	3	0	58467	\N
14701	360	4	0	56230	\N
14701	4330	5	0	58547	\N
14706	233	2	0	54842	\N
14706	1849	3	0	58561	\N
14708	4178	5	0	58396	\N
14708	4333	6	0	58573	\N
14711	4335	23	0	58588	\N
14711	42	126	0	58659	\N
14711	4336	127	0	58660	\N
14714	453	10	0	56519	\N
14714	4339	11	0	58718	\N
14716	4341	2	0	58725	\N
14716	4342	3	0	58726	\N
14725	451	2	0	58763	\N
14725	3317	3	0	58764	\N
14726	268	4	0	58457	\N
14726	4344	5	0	58773	\N
14732	33	8	0	58802	\N
14732	4346	9	0	58803	\N
14739	268	2	0	58457	\N
14739	2800	3	0	58458	\N
14742	137	4	0	58847	\N
14742	4352	5	0	58848	\N
14745	4354	45	0	58856	\N
14745	94	101	0	58888	\N
14745	4098	102	1	58889	\N
14745	4355	102	0	58890	\N
14750	233	2	0	58920	\N
14750	1849	3	0	58921	\N
14755	18	2	0	57864	\N
14755	1685	3	0	58837	\N
14758	2636	1	0	58830	\N
14758	3207	2	0	58949	\N
14760	132	2	0	56646	\N
14760	2756	3	0	58959	\N
14763	1021	6	0	33150	\N
14763	4357	7	0	58979	\N
14768	119	2	0	58997	\N
14768	1879	3	0	58998	\N
14770	202	4	0	59008	\N
14770	2293	5	0	59009	\N
14773	2	0	0	57095	\N
14780	793	0	0	56523	\N
14782	210	2	0	56836	\N
14782	1874	3	0	59046	\N
14790	75	2	0	59091	\N
14790	284	3	0	59092	\N
14793	4172	6	0	59117	\N
14793	4365	7	0	59118	\N
14798	230	2	0	59139	\N
14798	3307	3	0	59140	\N
14800	56	2	0	59145	\N
14800	2795	3	0	59146	\N
14806	852	2	0	58466	\N
14806	1325	3	0	59185	\N
14811	4368	2	0	59199	\N
14811	4369	2	0	59200	\N
14811	4371	3	1	59201	\N
14811	4370	3	0	59202	\N
14817	73	2	0	59241	\N
14817	2766	3	0	59242	\N
14820	320	2	0	59263	\N
14820	1937	3	0	59264	\N
14778	4362	7	0	59034	\N
14785	242	4	0	53401	\N
14785	4364	5	0	59063	\N
14794	4366	0	0	59119	\N
14794	4367	0	0	59120	\N
14796	362	3	0	59132	\N
14796	3372	4	0	59133	\N
14801	189	4	0	59155	\N
14801	3436	5	0	59156	\N
14804	20	2	0	59175	\N
14804	369	3	0	59176	\N
14830	3628	4	0	49549	\N
14830	4375	5	0	59316	\N
14832	300	2	0	58243	\N
14832	2786	3	0	59324	\N
14835	16	2	0	59326	\N
14835	388	3	0	59327	\N
14840	16	8	0	59326	\N
14840	4379	9	0	59359	\N
14841	2636	3	0	59365	\N
14841	2837	4	0	59366	\N
14844	200	2	0	56338	\N
14844	276	3	0	58731	\N
14846	326	76	0	57681	\N
14846	4380	77	0	59379	\N
14849	4178	6	0	59395	\N
14849	4358	7	0	59396	\N
14851	51	2	0	59405	\N
14851	1260	3	0	59406	\N
14853	4172	2	0	59283	\N
14853	4191	3	0	59413	\N
14854	1538	3	0	59420	\N
14854	4	9	0	59431	\N
14854	4382	10	1	59432	\N
14854	4381	10	0	59433	\N
14854	4383	11	0	59434	\N
14859	3265	2	0	59447	\N
14859	4388	2	0	59448	\N
14859	4390	3	1	59449	\N
14859	4389	3	0	59450	\N
14859	3268	4	0	59451	\N
14861	1538	3	0	59420	\N
14861	4	6	0	59431	\N
14861	2751	7	0	59454	\N
14864	4178	2	0	59407	\N
14864	4247	3	0	59408	\N
14869	4178	2	0	59475	\N
14869	4247	3	0	59476	\N
14871	40	7	0	59492	\N
14871	4394	8	0	59493	\N
14873	119	2	0	59499	\N
14873	1879	3	0	59500	\N
14878	4	4	0	59523	\N
14878	4117	5	0	59524	\N
14883	100	5	0	57701	\N
14883	4400	6	0	59564	\N
14886	258	12	0	53193	\N
14886	4401	13	0	59598	\N
14889	4172	4	0	59641	\N
14889	4219	5	0	59642	\N
14892	731	2	0	59659	\N
14892	262	9	0	59672	\N
14892	4403	10	0	59673	\N
14895	731	2	0	59659	\N
14895	262	9	0	59672	\N
14895	4403	10	0	59673	\N
14898	367	4	0	57862	\N
14898	4407	5	1	59687	\N
14898	4406	5	0	59688	\N
14898	4408	6	0	59689	\N
14902	77	4	0	58412	\N
14902	3619	5	0	59713	\N
14905	260	4	0	57739	\N
14905	3728	5	0	59717	\N
14906	92	3	0	59724	\N
14906	4410	4	0	59725	\N
14909	2636	4	0	59741	\N
14909	3617	5	0	59742	\N
14911	285	4	0	53195	\N
14911	3674	5	0	54199	\N
14913	322	4	0	59762	\N
14913	3429	5	0	59763	\N
14915	2	2	0	59019	\N
14915	2789	3	0	59797	\N
14917	908	3	0	59806	\N
14917	3591	4	0	59807	\N
14926	56	2	0	59572	\N
14926	2795	3	0	59836	\N
14929	4172	1	0	59851	\N
14929	4201	2	0	59852	\N
14935	367	5	0	57862	\N
14935	4414	6	0	59870	\N
14940	4172	2	0	59851	\N
14940	4191	3	0	59879	\N
14942	1636	2	0	59885	\N
14942	4416	3	0	59886	\N
14944	365	1	0	59891	\N
14944	366	2	0	59892	\N
14948	224	5	0	59938	\N
14948	4419	6	0	59939	\N
14954	4178	3	0	59798	\N
14954	4211	4	0	59810	\N
14956	2636	3	0	59741	\N
14956	2837	4	0	59961	\N
14959	181	3	0	57505	\N
14959	4184	4	0	59964	\N
14963	69	2	0	59986	\N
14963	3350	3	0	59987	\N
14976	123	3	0	60065	\N
14976	2856	4	0	60066	\N
14978	233	2	0	58920	\N
14978	1849	3	0	58921	\N
14981	4088	2	0	60077	\N
14981	4332	3	0	60078	\N
14990	2351	3	0	60112	\N
14990	2845	4	0	60113	\N
14999	341	0	0	18227	\N
15001	451	4	0	58763	\N
15001	3391	5	0	60161	\N
15003	113	2	0	60197	\N
15003	1899	3	0	60198	\N
15006	121	5	0	60213	\N
15006	4430	6	0	60214	\N
15013	2578	3	0	58437	\N
15013	4431	4	0	60243	\N
15018	119	3	0	60276	\N
15018	2860	4	0	60277	\N
15024	244	10	0	60307	\N
15024	4434	11	0	60308	\N
15026	40	3	0	60318	\N
15026	372	4	0	60319	\N
15033	149	44	0	60335	\N
15033	4435	45	0	60343	\N
15035	4088	5	0	60077	\N
15035	4436	6	0	60355	\N
15043	76	1	0	60375	\N
15043	75	4	0	60376	\N
15043	2989	5	0	60068	\N
15044	4178	2	0	60381	\N
15044	4247	3	0	60382	\N
15046	12	2	0	60389	\N
15046	2804	3	0	60390	\N
15049	4178	2	0	60381	\N
15049	4247	3	0	60382	\N
15051	18	1	0	60401	\N
15051	19	2	0	60402	\N
15053	391	0	0	60403	\N
15061	3625	4	0	60359	\N
15061	4443	5	0	60435	\N
15067	273	2	0	59183	\N
15067	1413	3	0	60452	\N
15069	353	1	0	58428	\N
15069	354	2	0	60457	\N
15074	102	2	0	52166	\N
15074	3053	3	0	60469	\N
15077	260	5	0	57739	\N
15077	4447	6	0	60489	\N
14787	388	3	0	59071	\N
14789	73	4	0	57880	\N
14789	2827	5	0	59086	\N
14792	202	2	0	59103	\N
14792	2764	3	0	59104	\N
14795	132	2	0	59125	\N
14795	2756	3	0	59126	\N
14803	316	2	0	59173	\N
14803	1900	3	0	59174	\N
14805	273	3	0	59183	\N
14805	1906	4	0	59184	\N
14808	852	1	0	58466	\N
14808	913	2	0	59187	\N
14810	110	0	0	59195	\N
14813	4125	9	0	59217	\N
14813	4372	10	0	59218	\N
14815	79	2	0	59229	\N
14815	616	3	0	59230	\N
14818	117	4	0	59251	\N
14818	4169	5	0	59252	\N
14821	266	2	0	59265	\N
14821	2103	3	0	59266	\N
14823	18	1	0	59271	\N
14823	1426	2	0	59272	\N
14826	35	6	0	59297	\N
14826	3323	7	0	59298	\N
14829	3625	4	0	49279	\N
14829	4374	5	0	59315	\N
14831	69	58	0	59320	\N
14831	4376	59	0	59321	\N
14834	69	0	0	59320	\N
14839	1021	8	0	59357	\N
14839	4378	9	0	59358	\N
14845	288	2	0	54800	\N
14845	2842	3	0	59378	\N
14848	1021	6	0	59357	\N
14848	4357	7	0	59394	\N
14850	27	2	0	57663	\N
14850	645	3	0	57664	\N
14858	235	2	0	59445	\N
14858	2757	3	0	59446	\N
14865	56	2	0	59466	\N
14865	2795	3	0	59467	\N
14868	18	2	0	59271	\N
14868	1685	3	0	59474	\N
14870	192	7	0	58800	\N
14870	4393	8	0	59491	\N
14876	3628	2	0	49549	\N
14876	4360	3	0	58999	\N
14877	4178	7	0	59475	\N
14877	4396	8	0	59514	\N
14880	40	9	0	59492	\N
14880	4397	10	0	59551	\N
14885	56	3	0	59572	\N
14885	4109	4	0	59573	\N
14891	4178	4	0	59653	\N
14891	4205	5	0	59654	\N
14894	731	2	0	59659	\N
14894	262	9	0	59672	\N
14894	4403	10	0	59673	\N
14897	16	4	0	59326	\N
14897	3546	5	0	59686	\N
14901	362	2	0	59132	\N
14901	2873	3	0	59704	\N
14904	14	4	0	58937	\N
14904	3498	5	0	59716	\N
14908	40	4	0	59739	\N
14908	3381	5	0	59740	\N
14914	4178	14	0	59690	\N
14914	4411	15	0	59792	\N
14924	251	1	0	59822	\N
14924	252	2	0	59823	\N
14928	4172	3	0	59847	\N
14928	4275	4	0	59848	\N
14931	251	1	0	59822	\N
14931	252	2	0	59823	\N
14934	210	5	0	59868	\N
14934	4413	6	0	59869	\N
14938	4172	5	0	59851	\N
14938	4415	6	0	59872	\N
14939	285	2	0	59877	\N
14939	3036	3	0	59878	\N
14945	206	13	0	46380	\N
14945	4417	14	0	59919	\N
14947	251	2	0	59926	\N
14947	1851	3	0	59927	\N
14953	38	3	0	59949	\N
14953	3457	4	0	59950	\N
14955	230	1	0	59953	\N
14955	287	2	0	59954	\N
14958	4178	3	0	59798	\N
14958	4211	4	0	59810	\N
14960	62	5	0	58719	\N
14960	4422	6	0	59975	\N
14965	793	3	0	60001	\N
14965	2644	4	0	60002	\N
14968	56	1	0	60007	\N
14968	57	2	0	60008	\N
14970	90	6	0	60029	\N
14970	3292	7	0	60030	\N
14973	264	2	0	57587	\N
14973	2780	3	0	57655	\N
14975	4172	4	0	59851	\N
14975	4252	5	0	60058	\N
14980	4172	2	0	60075	\N
14980	4191	3	0	60076	\N
14982	362	3	0	60085	\N
14982	3658	4	0	60086	\N
14985	2782	1	0	60092	\N
14985	3873	2	0	60093	\N
14987	230	3	0	60101	\N
14987	4181	4	0	60102	\N
14989	230	3	0	60110	\N
14989	4181	4	0	60111	\N
14994	123	5	0	60134	\N
14994	4427	6	0	60135	\N
14996	56	3	0	60007	\N
14996	4109	4	0	60114	\N
14998	186	1	0	60152	\N
14998	187	2	0	60153	\N
15005	4178	5	0	60211	\N
15005	4429	6	0	60212	\N
15008	4178	2	0	60211	\N
15008	4247	3	0	60219	\N
15010	251	2	0	60226	\N
15010	1851	3	0	60227	\N
15012	142	2	0	59924	\N
15012	4418	3	0	59925	\N
15015	18	5	0	60256	\N
15015	3550	6	0	60257	\N
15023	18	10	0	60305	\N
15023	4433	11	0	60306	\N
15025	6	1	0	53095	\N
15025	194	2	0	60311	\N
15028	4172	3	0	60320	\N
15028	4275	4	0	60321	\N
15030	117	3	0	60199	\N
15030	3653	4	0	60334	\N
15032	4178	2	0	60341	\N
15032	4247	3	0	60342	\N
15038	3628	1	0	49549	\N
15038	4438	2	0	60361	\N
15042	4201	1	0	60372	\N
15042	4172	4	0	60373	\N
15042	4285	5	0	60374	\N
15050	173	1	0	57946	\N
15050	396	2	0	60400	\N
15055	27	2	0	60404	\N
15055	645	3	0	60410	\N
15060	119	4	0	60276	\N
15060	4442	5	0	60434	\N
15063	35	4	0	60438	\N
15063	4445	5	0	60439	\N
15066	908	2	0	60446	\N
15066	2832	3	0	60447	\N
15071	115	1	0	57583	\N
15071	116	2	0	60459	\N
14802	4333	6	0	59168	\N
14807	16	3	0	59070	\N
14807	1045	4	0	59186	\N
14809	235	3	0	59193	\N
14809	3343	4	0	59194	\N
14812	4125	9	0	59217	\N
14812	4372	10	0	59218	\N
14814	4178	2	0	59223	\N
14814	4247	3	0	59224	\N
14816	16	2	0	59235	\N
14816	388	3	0	59236	\N
14819	33	2	0	59257	\N
14819	2822	3	0	59258	\N
14824	71	4	0	59281	\N
14824	2776	5	0	59282	\N
14827	4178	2	0	59303	\N
14827	4247	3	0	59304	\N
14836	4178	2	0	59332	\N
14836	4247	3	0	59333	\N
14842	100	2	0	57701	\N
14842	633	3	0	59371	\N
14847	326	2	0	59380	\N
14847	393	3	0	59381	\N
14852	4178	2	0	59407	\N
14852	4247	3	0	59408	\N
14855	814	3	0	59435	\N
14855	132	9	0	59436	\N
14855	4384	10	0	59437	\N
14857	1538	3	0	59420	\N
14857	4	9	0	59431	\N
14857	4387	10	0	59440	\N
14860	51	2	0	59452	\N
14860	1260	3	0	59453	\N
14862	145	5	0	59455	\N
14862	4391	6	0	59456	\N
14866	40	2	0	59039	\N
14866	282	3	0	59040	\N
14874	3625	2	0	49279	\N
14874	4359	3	0	58996	\N
14881	108	9	0	54493	\N
14881	4398	10	0	59552	\N
14887	40	12	0	59492	\N
14887	4402	13	0	59623	\N
14890	4178	4	0	59643	\N
14890	4205	5	0	59644	\N
14900	198	3	0	59698	\N
14900	4263	4	0	59699	\N
14903	258	4	0	59714	\N
14903	4409	5	0	59715	\N
14907	4172	2	0	59641	\N
14907	4191	3	0	59730	\N
14912	2	4	0	59019	\N
14912	3510	5	0	59753	\N
14916	4178	2	0	59798	\N
14916	4247	3	0	59799	\N
14918	16	3	0	59808	\N
14918	3634	4	0	59809	\N
14920	142	3	0	59816	\N
14920	4254	4	0	59817	\N
14922	316	1	0	59173	\N
14922	317	2	0	59820	\N
14927	320	2	0	59263	\N
14927	1937	3	0	59264	\N
14932	431	5	0	59864	\N
14932	4412	6	0	59865	\N
14941	16	2	0	59808	\N
14941	388	3	0	59880	\N
14943	44	2	0	59887	\N
14943	1910	3	0	59888	\N
14946	142	2	0	59924	\N
14946	4418	3	0	59925	\N
14949	852	5	0	59940	\N
14949	4420	6	0	59941	\N
14951	279	5	0	49943	\N
14951	4421	6	0	59942	\N
14952	852	0	0	59940	\N
14957	96	3	0	59962	\N
14957	2803	4	0	59963	\N
14961	4178	2	0	59798	\N
14961	4247	3	0	59799	\N
14966	79	1	0	59866	\N
14966	81	2	0	60005	\N
14971	2782	2	0	60035	\N
14971	2784	3	0	60036	\N
14977	75	3	0	60067	\N
14977	3855	4	0	60068	\N
14979	82	2	0	60073	\N
14979	3401	3	0	60074	\N
14983	4424	2	0	60089	\N
14991	56	3	0	60007	\N
14991	4109	4	0	60114	\N
14992	270	1	0	60117	\N
14992	264	3	0	60120	\N
14992	2941	4	0	60121	\N
14997	16	3	0	59808	\N
14997	3634	4	0	59809	\N
15002	451	126	0	58763	\N
15002	4428	127	0	60192	\N
15004	117	2	0	60199	\N
15004	1257	3	0	60200	\N
15011	40	2	0	59751	\N
15011	282	3	0	60232	\N
15014	4178	3	0	60244	\N
15014	4211	4	0	60245	\N
15016	12	1	0	60260	\N
15016	13	2	0	60261	\N
15019	3625	3	0	49279	\N
15019	3784	4	0	50826	\N
15021	2	2	0	60282	\N
15021	2789	3	0	60283	\N
15031	149	4	0	60335	\N
15031	3808	5	0	60336	\N
15036	119	1	0	60276	\N
15036	120	2	0	60358	\N
15039	2782	1	0	60092	\N
15039	3873	2	0	60093	\N
15040	309	1	0	60364	\N
15040	258	4	0	60369	\N
15040	3140	5	0	60370	\N
15047	453	2	0	60395	\N
15047	3366	3	0	60396	\N
15056	4172	3	0	60417	\N
15056	4440	4	0	60418	\N
15058	51	2	0	59452	\N
15058	1260	3	0	59453	\N
15064	3628	4	0	49549	\N
15064	4446	5	0	60440	\N
15065	40	2	0	60318	\N
15065	282	3	0	60445	\N
15068	365	2	0	60453	\N
15068	615	3	0	60454	\N
15072	391	1	0	60403	\N
15072	1420	2	0	60462	\N
15078	1021	5	0	60490	\N
15078	4448	6	0	60491	\N
15080	192	3	0	60499	\N
15080	4449	4	0	60500	\N
15083	4178	2	0	60419	\N
15083	4247	3	0	60515	\N
15088	192	1	0	60535	\N
15088	193	2	0	60536	\N
15090	224	2	0	59938	\N
15090	3150	3	0	60543	\N
15093	4451	0	0	60550	\N
15096	303	1	0	1136	\N
15096	4452	2	0	60557	\N
15097	4178	0	0	60558	\N
15102	4172	0	0	58549	\N
15105	75	2	0	60586	\N
15105	284	3	0	60587	\N
15107	793	6	0	60602	\N
15107	4454	7	0	60603	\N
15110	2	2	0	60609	\N
15110	2789	3	0	60610	\N
15115	300	1	0	60638	\N
15115	355	2	0	60639	\N
14822	852	2	0	58466	\N
14822	2872	3	0	58467	\N
14825	4172	4	0	59283	\N
14825	4252	5	0	59284	\N
14828	119	4	0	59313	\N
14828	4373	5	0	59314	\N
14833	69	2	0	59320	\N
14833	3350	3	0	59325	\N
14837	528	2	0	57931	\N
14837	2765	3	0	59338	\N
14838	4	8	0	59355	\N
14838	4377	9	0	59356	\N
14843	908	2	0	59372	\N
14843	2832	3	0	59373	\N
14856	814	3	0	59435	\N
14856	4385	4	0	59438	\N
14856	4386	4	0	59439	\N
14863	51	5	0	59452	\N
14863	4392	6	0	59457	\N
14867	4172	2	0	59472	\N
14867	4191	3	0	59473	\N
14872	244	7	0	52536	\N
14872	4395	8	0	59494	\N
14875	4172	2	0	59472	\N
14875	4191	3	0	59473	\N
14879	4178	3	0	59531	\N
14879	4211	4	0	59532	\N
14882	353	9	0	58428	\N
14882	4399	10	0	59553	\N
14884	4172	3	0	59472	\N
14884	4275	4	0	59571	\N
14888	391	4	0	59032	\N
14888	3913	5	0	59632	\N
14893	218	2	0	59674	\N
14893	18	9	0	59675	\N
14893	4404	10	0	59676	\N
14896	3265	0	0	59447	\N
14896	4405	0	0	59677	\N
14899	4178	4	0	59690	\N
14899	4205	5	0	59691	\N
14910	40	4	0	59751	\N
14910	3381	5	0	59752	\N
14919	4178	3	0	59798	\N
14919	4211	4	0	59810	\N
14921	56	3	0	59572	\N
14921	4109	4	0	59573	\N
14923	235	1	0	59445	\N
14923	236	2	0	59821	\N
14925	18	3	0	59830	\N
14925	3621	4	0	59831	\N
14930	14	1	0	58937	\N
14930	15	2	0	59853	\N
14933	79	5	0	59866	\N
14933	3341	6	0	59867	\N
14937	353	5	0	58428	\N
14937	2223	6	0	59871	\N
14950	852	0	0	59940	\N
14962	435	2	0	59980	\N
14962	3413	3	0	59981	\N
14964	416	3	0	22765	\N
14964	4423	4	0	59994	\N
14967	264	1	0	57587	\N
14967	270	2	0	60006	\N
14969	75	3	0	60015	\N
14969	3855	4	0	60016	\N
14972	73	2	0	60041	\N
14972	2766	3	0	60042	\N
14974	300	3	0	58243	\N
14974	3747	4	0	60049	\N
14984	288	1	0	60090	\N
14984	400	2	0	60091	\N
14986	244	1	0	52536	\N
14986	245	2	0	60094	\N
14988	4425	4	0	60109	\N
14993	322	5	0	60132	\N
14993	4426	6	0	60133	\N
14995	117	3	0	60142	\N
14995	3653	4	0	60143	\N
15000	56	4	0	60007	\N
15000	3556	5	0	60160	\N
15007	353	2	0	58428	\N
15007	2884	3	0	58760	\N
15009	4172	2	0	60224	\N
15009	4191	3	0	60225	\N
15017	424	3	0	60268	\N
15017	3611	4	0	60269	\N
15020	3628	3	0	49549	\N
15020	3785	4	0	50827	\N
15022	1021	2	0	59357	\N
15022	4432	3	0	60284	\N
15027	200	3	0	56338	\N
15027	3338	4	0	56339	\N
15029	4172	2	0	60326	\N
15029	4191	3	0	60327	\N
15034	233	5	0	58920	\N
15034	3380	6	0	60354	\N
15037	3625	1	0	60359	\N
15037	4437	2	0	60360	\N
15041	57	1	0	60371	\N
15041	56	4	0	60008	\N
15041	2914	5	0	60114	\N
15045	206	2	0	60383	\N
15045	2773	3	0	60384	\N
15048	42	2	0	54037	\N
15048	3310	3	0	60397	\N
15052	391	0	0	60403	\N
15054	27	76	0	60404	\N
15054	4439	77	0	60405	\N
15057	4178	3	0	60419	\N
15057	4441	4	0	60420	\N
15059	77	2	0	58412	\N
15059	3853	3	0	60425	\N
15062	33	4	0	60436	\N
15062	4444	5	0	60437	\N
15070	210	1	0	59868	\N
15070	211	2	0	60458	\N
15073	75	1	0	60067	\N
15073	76	2	0	60376	\N
15075	300	2	0	60474	\N
15075	2786	3	0	60475	\N
15081	100	3	0	60507	\N
15081	250	4	0	60508	\N
15086	316	2	0	60530	\N
15086	1900	3	0	60531	\N
15091	186	2	0	60152	\N
15091	1850	3	0	60548	\N
15098	20	1	0	60561	\N
15098	2975	2	0	60562	\N
15100	4178	2	0	60569	\N
15100	4247	3	0	60570	\N
15108	140	6	0	60600	\N
15108	4455	7	0	60604	\N
15116	2	3	0	60646	\N
15116	3548	4	0	60647	\N
15120	64	2	0	57741	\N
15120	277	3	0	60659	\N
15121	16	2	0	60664	\N
15121	388	3	0	60665	\N
15126	268	3	0	60677	\N
15126	4456	4	0	60678	\N
15127	56	3	0	60007	\N
15127	4109	4	0	60114	\N
15131	322	1	0	60700	\N
15131	323	2	0	60701	\N
15134	4172	3	0	60719	\N
15134	4440	4	0	60720	\N
15137	251	1	0	60226	\N
15137	252	2	0	60725	\N
15144	142	2	0	60751	\N
15144	4418	3	0	60752	\N
15146	262	26	0	60753	\N
15146	4458	27	0	60755	\N
15147	18	7	0	60770	\N
15147	4459	8	0	60771	\N
15157	4125	2	0	60827	\N
15157	4467	3	0	60828	\N
15076	200	1	0	56338	\N
15076	201	2	0	60478	\N
15079	18	5	0	60401	\N
15079	3964	6	0	60492	\N
15082	4172	3	0	60509	\N
15082	4440	4	0	60510	\N
15084	320	2	0	60520	\N
15084	1937	3	0	60521	\N
15087	288	2	0	60090	\N
15087	2842	3	0	60532	\N
15089	4178	1	0	60537	\N
15089	4450	2	0	60538	\N
15094	38	1	0	60553	\N
15094	2906	2	0	60554	\N
15101	4172	0	0	58439	\N
15103	2	3	0	60282	\N
15103	298	4	0	60577	\N
15106	140	8	0	60600	\N
15106	4453	9	0	60601	\N
15109	140	6	0	60600	\N
15109	4455	7	0	60604	\N
15111	4125	4	0	60619	\N
15111	4351	5	0	60620	\N
15112	852	0	0	59940	\N
15114	151	3	0	60634	\N
15114	3046	4	0	60635	\N
15117	4172	1	0	60549	\N
15117	4201	2	0	60650	\N
15125	435	1	0	59980	\N
15125	436	2	0	60670	\N
15129	115	5	0	57583	\N
15129	4457	6	0	60695	\N
15136	852	0	0	60722	\N
15138	77	2	0	60730	\N
15138	3853	3	0	60731	\N
15140	793	2	0	60602	\N
15140	4363	3	0	60738	\N
15148	35	6	0	60438	\N
15148	3323	7	0	60784	\N
15153	214	2	0	60811	\N
15153	4466	4	0	60814	\N
15155	4178	2	0	60745	\N
15155	4247	3	0	60820	\N
15158	4178	3	0	60835	\N
15158	4211	4	0	60836	\N
15165	4178	3	0	60863	\N
15165	4211	4	0	60864	\N
15168	4172	4	0	60876	\N
15168	4219	5	0	60877	\N
15176	121	3	0	60899	\N
15176	4471	4	0	60900	\N
15178	73	3	0	60041	\N
15178	3040	4	0	60909	\N
15183	164	3	0	58774	\N
15183	1807	4	0	60935	\N
15193	117	3	0	60986	\N
15193	3653	4	0	60987	\N
15200	2782	3	0	60901	\N
15200	3659	4	0	60902	\N
15202	2636	2	0	59741	\N
15202	2836	3	0	61017	\N
15209	235	4	0	59445	\N
15209	4479	5	0	61040	\N
15216	4178	2	0	61068	\N
15216	4247	3	0	61069	\N
15225	4178	3	0	61068	\N
15225	4211	4	0	61108	\N
15227	18	3	0	61111	\N
15227	3621	4	0	61112	\N
15229	362	1	0	60881	\N
15229	395	2	0	61117	\N
15236	326	2	0	59380	\N
15236	393	3	0	59381	\N
15238	290	2	0	61140	\N
15238	1909	3	0	61141	\N
15241	322	7	0	61168	\N
15241	4486	8	0	61169	\N
15247	40	7	0	61213	\N
15247	4488	8	0	61214	\N
15252	273	4	0	61241	\N
15252	3390	5	0	61242	\N
15254	12	4	0	61244	\N
15254	2272	5	0	61245	\N
15257	3421	9	0	61265	\N
15257	285	11	0	61268	\N
15257	3112	12	0	61269	\N
15264	79	1	0	61138	\N
15264	81	2	0	61300	\N
15269	4172	5	0	61286	\N
15269	4415	6	0	61317	\N
15271	30	4	0	61181	\N
15271	4004	5	0	61327	\N
15274	435	8	0	61060	\N
15274	4493	9	0	61351	\N
15281	82	2	0	60073	\N
15281	3401	3	0	60074	\N
15291	2782	1	0	61454	\N
15291	3873	2	0	61455	\N
15296	336	10	0	53386	\N
15296	4497	11	0	61480	\N
15298	58	2	0	49503	\N
15298	2853	3	0	61486	\N
15301	27	0	0	61490	\N
15304	167	47	0	60883	\N
15304	4501	48	0	61510	\N
15310	4178	3	0	61512	\N
15310	4211	4	0	61527	\N
15312	6	2	0	61533	\N
15312	2805	3	0	61534	\N
15315	56	4	0	61553	\N
15315	3556	5	0	61554	\N
15320	273	5	0	61241	\N
15320	4503	6	0	61586	\N
15325	181	3	0	61607	\N
15325	4184	4	0	61608	\N
15333	123	4	0	60134	\N
15333	4507	5	0	61657	\N
15335	56	2	0	61663	\N
15335	2795	3	0	61664	\N
15336	71	7	0	61679	\N
15336	4508	8	0	61680	\N
15338	1636	7	0	59885	\N
15338	4510	8	0	61682	\N
15341	86	3	0	61706	\N
15341	3746	4	0	61707	\N
15343	4172	2	0	61525	\N
15343	4191	3	0	61713	\N
15350	324	3	0	51391	\N
15350	4514	4	0	61737	\N
15352	14	2	0	58937	\N
15352	1785	3	0	58938	\N
15357	4088	3	0	61647	\N
15357	4506	4	0	61648	\N
15359	360	0	0	56230	\N
15361	18	2	0	61763	\N
15361	1685	3	0	61764	\N
15363	391	0	0	61765	\N
15368	4233	5	0	60910	\N
15368	4518	6	0	61792	\N
15370	75	2	0	60855	\N
15370	284	3	0	61797	\N
15377	30	31	0	61826	\N
15377	4519	32	0	61827	\N
15380	4	2	0	61843	\N
15380	4522	3	0	61845	\N
15385	115	3	0	61109	\N
15385	3483	4	0	61110	\N
15387	1952	2	0	61875	\N
15387	4523	3	0	61876	\N
15396	4172	2	0	61525	\N
15396	4191	3	0	61713	\N
15398	4178	3	0	61910	\N
15398	4211	4	0	61911	\N
15401	69	5	0	61934	\N
15401	4526	6	0	61935	\N
15085	156	1	0	60524	\N
15085	157	2	0	60525	\N
15092	4172	0	0	60549	\N
15095	54	1	0	60555	\N
15095	3142	2	0	60556	\N
15099	258	2	0	60567	\N
15099	3275	3	0	60568	\N
15104	392	1	0	60580	\N
15104	391	2	0	60581	\N
15113	852	3	0	59940	\N
15113	3612	4	0	60627	\N
15118	6	2	0	60655	\N
15118	2805	3	0	60656	\N
15123	119	1	0	60276	\N
15123	120	2	0	60358	\N
15128	75	2	0	60683	\N
15128	284	3	0	60684	\N
15132	96	2	0	60706	\N
15132	2347	3	0	60707	\N
15135	192	3	0	60535	\N
15135	4449	4	0	60721	\N
15141	102	1	0	60741	\N
15141	103	2	0	60742	\N
15143	4178	1	0	60745	\N
15143	4450	2	0	60746	\N
15145	262	2	0	60753	\N
15145	2743	3	0	60754	\N
15149	4429	5	0	60795	\N
15149	4178	7	0	60798	\N
15149	4460	8	0	60799	\N
15151	4463	5	0	60803	\N
15151	44	7	0	60804	\N
15151	2997	8	0	60805	\N
15160	4178	4	0	60847	\N
15160	4468	5	0	60848	\N
15162	69	1	0	60849	\N
15162	70	2	0	60853	\N
15164	75	1	0	60855	\N
15164	76	2	0	60856	\N
15167	258	4	0	60567	\N
15167	4409	5	0	60875	\N
15170	224	4	0	60879	\N
15170	3806	5	0	60880	\N
15171	362	4	0	60881	\N
15171	4470	5	0	60882	\N
15173	35	4	0	60885	\N
15173	3545	5	0	60886	\N
15175	206	1	0	60891	\N
15175	207	2	0	60892	\N
15180	90	6	0	60924	\N
15180	4472	7	0	60925	\N
15185	391	2	0	60732	\N
15185	1381	3	0	60733	\N
15187	189	2	0	60943	\N
15187	3441	3	0	60944	\N
15190	391	11	0	60732	\N
15190	2841	12	0	60969	\N
15195	262	2	0	60753	\N
15195	2743	3	0	60754	\N
15197	173	2	0	61000	\N
15197	2102	3	0	61001	\N
15206	322	3	0	61028	\N
15206	1105	4	0	61029	\N
15211	200	2	0	61051	\N
15211	276	3	0	61052	\N
15213	4178	2	0	60863	\N
15213	4247	3	0	61059	\N
15219	119	5	0	60276	\N
15219	4482	6	0	61093	\N
15221	75	5	0	60855	\N
15221	4484	6	0	61095	\N
15223	90	2	0	60924	\N
15223	3442	3	0	61100	\N
15226	115	3	0	61109	\N
15226	3483	4	0	61110	\N
15232	4172	3	0	61010	\N
15232	4275	4	0	61011	\N
15234	290	3	0	61132	\N
15234	3635	4	0	61133	\N
15237	4178	2	0	61068	\N
15237	4247	3	0	61069	\N
15242	4172	3	0	61010	\N
15242	4275	4	0	61011	\N
15244	30	2	0	61181	\N
15244	1127	3	0	61182	\N
15250	279	3	0	61225	\N
15250	3641	4	0	61226	\N
15260	264	2	0	61278	\N
15260	2780	3	0	61279	\N
15262	300	3	0	61288	\N
15262	3747	4	0	61289	\N
15265	90	1	0	61301	\N
15265	344	2	0	61302	\N
15267	149	5	0	61314	\N
15267	3808	6	0	61315	\N
15275	4178	4	0	61360	\N
15275	4331	5	0	61361	\N
15277	142	1	0	61364	\N
15277	3117	2	0	61365	\N
15279	4178	3	0	61373	\N
15279	4211	4	0	61374	\N
15284	1109	2	0	61396	\N
15284	2809	3	0	61397	\N
15285	4172	10	0	61286	\N
15285	4494	11	0	61418	\N
15288	4178	5	0	61437	\N
15288	4429	6	0	61438	\N
15293	285	3	0	61470	\N
15293	4496	4	0	61471	\N
15300	4172	0	0	61489	\N
15305	167	8	0	60883	\N
15305	4502	9	0	61511	\N
15309	4172	3	0	61525	\N
15309	4275	4	0	61526	\N
15311	260	2	0	57739	\N
15311	3184	3	0	61532	\N
15314	71	3	0	61543	\N
15314	3770	4	0	61544	\N
15316	90	3	0	61561	\N
15316	4074	4	0	61562	\N
15324	16	3	0	61605	\N
15324	3634	4	0	61606	\N
15326	391	3	0	61541	\N
15326	3660	4	0	61542	\N
15329	16	7	0	61605	\N
15329	4504	8	0	61637	\N
15334	362	2	0	60881	\N
15334	2873	3	0	61662	\N
15337	4178	7	0	61621	\N
15337	4509	8	0	61681	\N
15342	4178	3	0	61621	\N
15342	4211	4	0	61708	\N
15351	2982	3	0	61738	\N
15351	4515	4	0	61739	\N
15353	260	2	0	61744	\N
15353	3184	3	0	61745	\N
15360	360	2	0	56230	\N
15360	2767	3	0	61762	\N
15362	391	0	0	61765	\N
15365	324	5	0	51391	\N
15365	4516	6	0	61778	\N
15369	4178	5	0	61621	\N
15369	4429	6	0	61779	\N
15378	892	6	0	61828	\N
15378	4520	7	0	61829	\N
15379	4	7	0	61843	\N
15379	4521	8	0	61844	\N
15386	251	0	0	60821	\N
15388	320	2	0	61877	\N
15388	1937	3	0	61878	\N
15390	251	0	0	60821	\N
15397	35	2	0	61902	\N
15397	1191	3	0	61903	\N
15403	4450	1	0	61945	\N
15403	4178	4	0	61946	\N
15403	4527	5	0	61947	\N
15408	202	4	0	60743	\N
15119	210	2	0	60657	\N
15119	1874	3	0	60658	\N
15122	3625	1	0	60668	\N
15122	4437	2	0	60669	\N
15124	3628	1	0	49549	\N
15124	4438	2	0	60361	\N
15130	132	5	0	60696	\N
15130	3831	6	0	60697	\N
15133	181	2	0	57505	\N
15133	3313	3	0	60712	\N
15139	391	2	0	60732	\N
15139	1381	3	0	60733	\N
15142	202	1	0	60743	\N
15142	203	2	0	60744	\N
15150	4461	5	0	60800	\N
15150	1636	7	0	60801	\N
15150	4462	8	0	60802	\N
15152	23	0	0	60806	\N
15154	214	1	0	60811	\N
15154	1382	2	0	60815	\N
15156	251	2	0	60821	\N
15156	1851	3	0	60822	\N
15159	228	3	0	60837	\N
15159	3186	4	0	60838	\N
15161	69	1	0	60849	\N
15161	4469	2	0	60850	\N
15163	453	1	0	60395	\N
15163	454	2	0	60854	\N
15169	40	4	0	60318	\N
15169	3381	5	0	60878	\N
15172	167	4	0	60883	\N
15172	4048	5	0	60884	\N
15174	113	1	0	60889	\N
15174	437	2	0	60890	\N
15181	373	6	0	53655	\N
15181	4473	7	0	60926	\N
15186	285	2	0	60941	\N
15186	3036	3	0	60942	\N
15188	16	1	0	60947	\N
15188	17	2	0	60948	\N
15189	4172	11	0	60876	\N
15189	4474	12	0	60968	\N
15191	149	2	0	60335	\N
15191	1379	3	0	60974	\N
15196	4475	44	0	60993	\N
15196	262	77	0	60994	\N
15196	4476	78	0	60995	\N
15198	2	2	0	61002	\N
15198	2789	3	0	61003	\N
15203	4125	3	0	61024	\N
15203	4200	4	0	61025	\N
15205	716	2	0	5921	\N
15205	4478	3	0	61027	\N
15207	189	3	0	60943	\N
15207	3782	4	0	61030	\N
15212	62	2	0	61057	\N
15212	2191	3	0	61058	\N
15214	435	2	0	61060	\N
15214	3413	3	0	61061	\N
15217	102	5	0	61080	\N
15217	4480	6	0	61081	\N
15228	40	1	0	61115	\N
15228	41	2	0	61116	\N
15230	242	1	0	53401	\N
15230	253	2	0	61118	\N
15235	79	2	0	61138	\N
15235	616	3	0	61139	\N
15239	156	2	0	61146	\N
15239	4485	3	0	61147	\N
15245	402	5	0	61193	\N
15245	4487	6	0	61194	\N
15248	841	7	0	61215	\N
15248	4489	8	0	61216	\N
15253	258	4	0	60567	\N
15253	2725	5	0	61243	\N
15255	132	4	0	60696	\N
15255	3293	5	0	61246	\N
15256	3421	9	0	61265	\N
15256	285	11	0	61268	\N
15256	3112	12	0	61269	\N
15258	3421	9	0	61265	\N
15258	285	11	0	61268	\N
15258	3108	12	1	61270	\N
15258	4491	12	0	61271	\N
15263	20	3	0	61296	\N
15263	2844	4	0	61297	\N
15268	33	5	0	60436	\N
15268	4492	6	0	61316	\N
15270	75	4	0	60855	\N
15270	2357	5	0	61326	\N
15272	268	2	0	61332	\N
15272	2800	3	0	61333	\N
15273	4178	8	0	61068	\N
15273	4237	9	0	61350	\N
15280	793	3	0	61375	\N
15280	2644	4	0	61376	\N
15282	1470	1	0	57523	\N
15282	1471	2	0	61383	\N
15287	186	2	0	61425	\N
15287	1850	3	0	61426	\N
15290	77	3	0	61450	\N
15290	1877	4	0	61451	\N
15295	402	2	0	61478	\N
15295	2760	3	0	61479	\N
15299	88	2	0	61487	\N
15299	2799	3	0	61488	\N
15302	167	4	0	60883	\N
15302	4499	5	1	61499	\N
15302	4498	5	0	61500	\N
15308	42	1	0	54037	\N
15308	43	2	0	61518	\N
15313	391	3	0	61541	\N
15313	3660	4	0	61542	\N
15318	40	2	0	61213	\N
15318	282	3	0	61569	\N
15321	411	3	0	61593	\N
15321	3596	4	0	61594	\N
15323	64	1	0	57741	\N
15323	65	2	0	61598	\N
15328	4178	2	0	61621	\N
15328	4247	3	0	61622	\N
15331	82	3	0	61645	\N
15331	4505	4	0	61646	\N
15339	44	7	0	61683	\N
15339	4511	8	0	61684	\N
15344	212	2	0	58761	\N
15344	3616	3	0	58762	\N
15346	70	1	0	61717	\N
15346	69	4	0	60853	\N
15346	2920	5	0	61722	\N
15348	102	1	0	61727	\N
15348	103	2	0	61728	\N
15355	233	0	0	58920	\N
15364	273	5	0	61776	\N
15364	4503	6	0	61777	\N
15366	4178	5	0	61621	\N
15366	4429	6	0	61779	\N
15371	88	3	0	61487	\N
15371	3655	4	0	61804	\N
15373	42	1	0	61809	\N
15373	43	2	0	61810	\N
15375	62	1	0	61057	\N
15375	63	2	0	61813	\N
15381	40	6	0	61858	\N
15381	4255	7	0	61859	\N
15383	4178	2	0	61863	\N
15383	4247	3	0	61864	\N
15392	4	2	0	61891	\N
15392	2751	3	0	61892	\N
15394	279	2	0	61894	\N
15394	4525	3	0	61895	\N
15400	38	2	0	61922	\N
15400	4009	3	0	61923	\N
15405	4172	1	0	61953	\N
15405	4201	2	0	61954	\N
15417	793	3	0	61375	\N
15417	2644	4	0	61376	\N
15166	1109	3	0	60865	\N
15166	3495	4	0	60866	\N
15177	2782	3	0	60901	\N
15177	3659	4	0	60902	\N
15179	4233	3	0	60910	\N
15179	4425	4	0	60911	\N
15182	79	3	0	60933	\N
15182	1168	4	0	60934	\N
15184	4178	3	0	60863	\N
15184	4441	4	0	60936	\N
15192	4172	2	0	60876	\N
15192	4191	3	0	60979	\N
15194	167	3	0	60883	\N
15194	4028	4	0	60988	\N
15199	4172	3	0	61010	\N
15199	4275	4	0	61011	\N
15201	4172	2	0	61010	\N
15201	4191	3	0	61016	\N
15204	716	3	0	5921	\N
15204	4477	4	0	61026	\N
15208	4172	4	0	61010	\N
15208	4252	5	0	61039	\N
15210	40	3	0	60318	\N
15210	372	4	0	60319	\N
15215	79	2	0	61066	\N
15215	616	3	0	61067	\N
15218	3625	5	0	60668	\N
15218	4481	6	0	61092	\N
15220	3628	5	0	49549	\N
15220	4483	6	0	61094	\N
15222	90	2	0	60924	\N
15222	3442	3	0	61100	\N
15224	244	2	0	60307	\N
15224	3308	3	0	61101	\N
15231	113	3	0	60889	\N
15231	3620	4	0	61125	\N
15233	228	3	0	60837	\N
15233	3186	4	0	60838	\N
15240	40	2	0	61152	\N
15240	282	3	0	61153	\N
15243	56	2	0	60007	\N
15243	2795	3	0	61180	\N
15246	365	2	0	60453	\N
15246	615	3	0	60454	\N
15249	208	3	0	61223	\N
15249	4490	4	0	61224	\N
15251	841	2	0	61231	\N
15251	3316	3	0	61232	\N
15259	16	2	0	61276	\N
15259	388	3	0	61277	\N
15261	4172	3	0	61286	\N
15261	4275	4	0	61287	\N
15266	4178	1	0	61068	\N
15266	4450	2	0	61303	\N
15276	528	4	0	61362	\N
15276	3353	5	0	61363	\N
15278	142	3	0	61364	\N
15278	4254	4	0	61372	\N
15283	4178	3	0	61390	\N
15283	4211	4	0	61391	\N
15286	268	10	0	61419	\N
15286	4495	11	0	61420	\N
15289	4172	2	0	61286	\N
15289	4191	3	0	61443	\N
15292	4178	3	0	61462	\N
15292	4211	4	0	61463	\N
15294	30	3	0	61472	\N
15294	3640	4	0	61473	\N
15297	336	2	0	53386	\N
15297	3332	3	0	61485	\N
15303	4172	8	0	61489	\N
15303	4500	9	0	61509	\N
15306	4178	8	0	61512	\N
15306	4237	9	0	61513	\N
15307	2	1	0	61516	\N
15307	26	2	0	61517	\N
15317	113	2	0	61567	\N
15317	1899	3	0	61568	\N
15319	82	2	0	61574	\N
15319	3401	3	0	61575	\N
15322	142	1	0	61364	\N
15322	143	2	0	61597	\N
15327	411	2	0	61619	\N
15327	3370	3	0	61620	\N
15330	233	3	0	58920	\N
15330	3704	4	0	61644	\N
15332	4088	3	0	61647	\N
15332	4506	4	0	61648	\N
15340	56	7	0	61663	\N
15340	4512	8	0	61699	\N
15345	94	2	0	55054	\N
15345	2794	3	0	61714	\N
15347	26	1	0	61723	\N
15347	2	4	0	61517	\N
15347	2990	5	0	61724	\N
15349	102	1	0	61727	\N
15354	233	0	0	58920	\N
15356	233	3	0	58920	\N
15356	3704	4	0	61644	\N
15358	16	2	0	61756	\N
15358	388	3	0	61757	\N
15367	2982	5	0	61780	\N
15367	4517	6	0	61781	\N
15372	1109	3	0	61805	\N
15372	3495	4	0	61806	\N
15374	2636	1	0	61811	\N
15374	3980	2	0	61812	\N
15376	2636	0	0	61811	\N
15382	251	0	0	60226	\N
15384	251	0	0	60226	\N
15391	60	3	0	61885	\N
15391	3585	4	0	61886	\N
15393	208	2	0	61223	\N
15393	4524	3	0	61893	\N
15395	4	1	0	61896	\N
15395	3114	2	0	61897	\N
15399	273	2	0	61916	\N
15399	1413	3	0	61917	\N
15402	28	1	0	61938	\N
15402	27	4	0	61943	\N
15402	3164	5	0	61944	\N
15404	334	1	0	61948	\N
15404	320	4	0	61949	\N
15404	4528	5	0	61950	\N
15407	38	4	0	61977	\N
15407	4529	5	0	61978	\N
15411	4172	2	0	61988	\N
15411	4191	3	0	61989	\N
15416	4178	3	0	62019	\N
15416	4211	4	0	62020	\N
15418	435	3	0	61060	\N
15418	3504	4	0	62021	\N
15423	69	3	0	62047	\N
15423	4536	4	0	62048	\N
15425	16	2	0	62055	\N
15425	388	3	0	62056	\N
15433	18	7	0	61763	\N
15433	4538	8	0	62092	\N
15440	262	28	0	62125	\N
15440	4541	29	0	62128	\N
15442	4172	2	0	62135	\N
15442	4191	3	0	62136	\N
15444	210	2	0	60657	\N
15444	1874	3	0	60658	\N
15448	528	3	0	62175	\N
15448	4262	4	0	62176	\N
15450	121	0	0	62179	\N
15457	528	2	0	62175	\N
15457	2765	3	0	62202	\N
15460	149	2	0	61314	\N
15460	1379	3	0	62214	\N
15466	40	0	0	61213	\N
15471	198	3	0	62258	\N
15471	4263	4	0	62259	\N
15473	3625	2	0	60668	\N
15406	40	6	0	61967	\N
15406	4255	7	0	61968	\N
15409	316	4	0	61980	\N
15409	4531	5	0	61981	\N
15413	2351	4	0	60112	\N
15413	4534	5	0	62000	\N
15415	4178	3	0	62011	\N
15415	4211	4	0	62012	\N
15420	54	2	0	60555	\N
15420	3351	3	0	62036	\N
15427	233	2	0	62063	\N
15427	1849	3	0	62064	\N
15429	4088	2	0	61647	\N
15429	4332	3	0	62067	\N
15431	4178	3	0	62019	\N
15431	4211	4	0	62020	\N
15432	4172	7	0	62090	\N
15432	4537	8	0	62091	\N
15435	40	4	0	62061	\N
15435	2796	5	0	62112	\N
15438	262	5	0	62125	\N
15438	4539	6	0	62126	\N
15447	4178	7	0	62019	\N
15447	4509	8	0	62168	\N
15452	202	7	0	60743	\N
15452	4543	8	0	62195	\N
15454	202	7	0	60743	\N
15454	4543	8	0	62195	\N
15459	167	2	0	60883	\N
15459	3322	3	0	62213	\N
15461	4545	16	0	62215	\N
15461	167	126	0	62216	\N
15461	4546	127	0	62217	\N
15463	67	3	0	62226	\N
15463	3749	4	0	62227	\N
15465	40	0	0	61213	\N
15468	4172	1	0	62240	\N
15468	4201	2	0	62241	\N
15470	4178	2	0	62180	\N
15470	4247	3	0	62251	\N
15477	94	5	0	55054	\N
15477	4547	6	0	62281	\N
15482	77	3	0	62301	\N
15482	1877	4	0	62302	\N
15493	251	4	0	60821	\N
15493	1610	5	0	62328	\N
15497	2	6	0	61516	\N
15497	4550	7	0	62358	\N
15498	320	0	0	62359	\N
15500	16	3	0	62367	\N
15500	3634	4	0	62368	\N
15510	242	2	0	53401	\N
15510	3425	3	0	62408	\N
15512	80	1	0	62412	\N
15512	79	6	0	62419	\N
15512	2758	7	0	62420	\N
15514	111	1	0	62421	\N
15514	110	6	0	62422	\N
15514	438	7	1	62424	\N
15514	3100	7	0	62425	\N
15517	121	4	0	62442	\N
15517	4099	5	0	62443	\N
15520	4555	0	0	62458	\N
15520	4556	0	0	62459	\N
15532	189	3	0	62527	\N
15532	3782	4	0	62528	\N
15537	4178	6	0	62558	\N
15537	4250	7	0	62559	\N
15540	402	3	0	62580	\N
15540	4077	4	0	62581	\N
15545	42	3	0	62601	\N
15545	3645	4	0	62602	\N
15546	316	9	0	61980	\N
15546	4561	10	0	62621	\N
15554	23	5	0	60806	\N
15554	4564	6	0	62677	\N
15562	79	0	0	62712	\N
15567	90	2	0	62728	\N
15567	91	3	0	62729	\N
15570	110	1	0	62740	\N
15570	134	2	0	62741	\N
15579	100	3	0	60507	\N
15579	250	4	0	60508	\N
15584	793	2	0	61375	\N
15584	4363	3	0	62794	\N
15587	4178	4	0	62805	\N
15587	4331	5	0	62806	\N
15592	212	4	0	62836	\N
15592	4574	5	0	62837	\N
15593	170	2	0	57653	\N
15593	2986	3	0	62842	\N
15595	100	2	0	60507	\N
15595	2918	3	0	62845	\N
15600	217	1	0	62861	\N
15600	23	3	0	62864	\N
15600	1089	4	0	62865	\N
15602	4178	2	0	62874	\N
15602	4247	3	0	62875	\N
15610	113	3	0	61567	\N
15610	3620	4	0	62913	\N
15612	326	3	0	62914	\N
15612	3339	4	0	62915	\N
15614	40	2	0	62911	\N
15614	282	3	0	62924	\N
15617	212	5	0	62939	\N
15617	4580	6	0	62940	\N
15619	4178	2	0	62941	\N
15619	4247	3	0	62947	\N
15624	140	4	0	62974	\N
15624	3821	5	0	62975	\N
15633	18	3	0	62665	\N
15633	3621	4	0	63000	\N
15635	233	4	0	63008	\N
15635	3775	5	0	63009	\N
15637	189	4	0	63011	\N
15637	3992	5	0	63012	\N
15639	233	17	0	63008	\N
15639	4583	18	0	63023	\N
15644	2782	4	0	63045	\N
15644	3872	5	0	63046	\N
15646	3248	4	0	63049	\N
15646	4585	5	0	63050	\N
15661	123	4	0	63149	\N
15661	4090	5	0	63150	\N
15664	285	4	0	61470	\N
15664	3674	5	0	63177	\N
15671	170	7	0	57653	\N
15671	4591	8	0	63209	\N
15673	3846	7	0	63212	\N
15673	4593	8	0	63213	\N
15678	597	4	0	55967	\N
15678	3733	5	0	55968	\N
15682	365	3	0	63238	\N
15682	3839	4	0	63239	\N
15684	2782	2	0	63045	\N
15684	2784	3	0	63247	\N
15687	264	3	0	63251	\N
15687	3632	4	0	63252	\N
15693	149	3	0	63270	\N
15693	4189	4	0	63275	\N
15698	181	4	0	63290	\N
15698	4058	5	0	63291	\N
15700	325	1	0	63294	\N
15700	324	3	0	63297	\N
15700	796	4	0	63298	\N
15702	4596	1	0	63304	\N
15702	2982	8	0	63308	\N
15702	4597	9	0	63309	\N
15704	102	6	0	63318	\N
15704	4599	7	0	63319	\N
15706	102	9	0	63318	\N
15706	4601	10	0	63323	\N
15716	173	4	0	61000	\N
15716	3614	5	0	63375	\N
15721	4178	3	0	63464	\N
15721	4211	4	0	63465	\N
15724	391	3	0	63230	\N
15408	4530	5	0	61979	\N
15410	453	4	0	61982	\N
15410	4532	5	0	61983	\N
15412	4	4	0	61998	\N
15412	4533	5	0	61999	\N
15414	4	2	0	62003	\N
15414	579	3	0	62004	\N
15419	1109	4	0	62030	\N
15419	4535	5	0	62031	\N
15421	156	2	0	62037	\N
15421	4485	3	0	62038	\N
15426	40	2	0	62061	\N
15426	282	3	0	62062	\N
15428	125	2	0	62065	\N
15428	3297	3	0	62066	\N
15430	300	3	0	62074	\N
15430	3747	4	0	62075	\N
15436	4178	4	0	62019	\N
15436	4331	5	0	62113	\N
15445	528	5	0	61362	\N
15445	4542	6	0	62149	\N
15453	4172	7	0	62196	\N
15453	4537	8	0	62197	\N
15455	202	7	0	60743	\N
15455	4543	8	0	62195	\N
15462	4172	3	0	62224	\N
15462	4275	4	0	62225	\N
15464	40	0	0	61213	\N
15469	18	3	0	61763	\N
15469	3621	4	0	62246	\N
15474	2	2	0	61516	\N
15474	2789	3	0	62266	\N
15483	18	2	0	62307	\N
15483	1685	3	0	62308	\N
15486	424	0	0	62316	\N
15494	1109	6	0	62341	\N
15494	4548	7	0	62342	\N
15495	230	6	0	60110	\N
15495	4549	7	0	62355	\N
15507	119	2	0	62402	\N
15507	1879	3	0	62403	\N
15511	4178	1	0	62269	\N
15511	4460	2	0	62409	\N
15513	111	1	0	62421	\N
15513	110	6	0	62422	\N
15513	4552	7	0	62423	\N
15518	230	2	0	62448	\N
15518	3307	3	0	62449	\N
15528	2	2	0	62501	\N
15528	2789	3	0	62502	\N
15531	4172	3	0	62482	\N
15531	4275	4	0	62526	\N
15539	266	4	0	62572	\N
15539	2824	5	0	62573	\N
15550	88	2	0	61487	\N
15550	2799	3	0	61488	\N
15563	79	1	0	62712	\N
15563	81	2	0	62715	\N
15565	2782	1	0	62716	\N
15565	3873	2	0	62717	\N
15571	189	2	0	62527	\N
15571	3441	3	0	62746	\N
15573	3625	1	0	60668	\N
15573	4437	2	0	60669	\N
15575	3628	1	0	62267	\N
15575	4438	2	0	62755	\N
15578	40	3	0	62590	\N
15578	1921	4	0	62767	\N
15582	12	1	0	61244	\N
15582	13	2	0	62788	\N
15586	132	4	0	60696	\N
15586	3293	5	0	61246	\N
15589	38	6	0	61977	\N
15589	3276	7	0	62824	\N
15591	322	6	0	62826	\N
15591	2793	7	0	62827	\N
15597	242	2	0	53401	\N
15597	4576	3	0	62852	\N
15604	2	2	0	62882	\N
15604	2789	3	0	62883	\N
15606	362	2	0	62888	\N
15606	2873	3	0	62889	\N
15609	40	3	0	62911	\N
15609	372	4	0	62912	\N
15611	56	3	0	62375	\N
15611	4109	4	0	62376	\N
15616	186	2	0	62929	\N
15616	1850	3	0	62930	\N
15621	4088	4	0	61647	\N
15621	4089	5	0	62956	\N
15626	14	3	0	58937	\N
15626	4272	4	0	62983	\N
15628	440	3	0	62984	\N
15628	4581	4	0	62989	\N
15631	1470	3	0	62996	\N
15631	3838	4	0	62997	\N
15641	206	3	0	63032	\N
15641	4584	4	0	63033	\N
15648	453	4	0	63068	\N
15648	4108	5	0	63069	\N
15651	96	3	0	63090	\N
15651	2803	4	0	63091	\N
15656	100	3	0	63113	\N
15656	3836	4	0	63114	\N
15675	156	3	0	63219	\N
15675	4594	4	0	63220	\N
15677	192	4	0	60535	\N
15677	3895	5	0	63229	\N
15680	147	4	0	50234	\N
15680	3877	5	0	52074	\N
15686	288	3	0	63249	\N
15686	3003	4	0	63250	\N
15688	2782	3	0	63045	\N
15688	3659	4	0	63253	\N
15695	135	3	0	52757	\N
15695	3630	4	0	56341	\N
15697	56	4	0	63288	\N
15697	3127	5	0	63289	\N
15699	75	4	0	63194	\N
15699	3959	5	0	63195	\N
15708	336	3	0	53386	\N
15708	3400	4	0	63334	\N
15711	77	1	0	63354	\N
15711	2934	2	0	63355	\N
15718	4606	11	0	63451	\N
15723	4172	3	0	63190	\N
15723	4275	4	0	63473	\N
15730	1021	3	0	60490	\N
15730	4551	4	0	62366	\N
15733	4178	3	0	63533	\N
15733	4211	4	0	63534	\N
15735	488	3	0	63539	\N
15735	1103	4	0	63540	\N
15736	4610	8	0	63555	\N
15736	258	12	0	63561	\N
15736	4611	13	0	63562	\N
15738	210	3	0	62880	\N
15738	4612	4	0	63571	\N
15743	4178	3	0	63592	\N
15743	4211	4	0	63593	\N
15749	102	14	0	63318	\N
15749	4619	15	0	63638	\N
15751	1109	7	0	63651	\N
15751	4145	8	0	63652	\N
15756	391	6	0	63680	\N
15756	3521	7	0	63681	\N
15764	4172	3	0	63665	\N
15764	4275	4	0	63722	\N
15769	67	3	0	63749	\N
15769	3749	4	0	63750	\N
15773	75	10	0	63194	\N
15773	4628	11	0	63785	\N
15777	451	8	0	63807	\N
15777	4631	9	0	63808	\N
15779	16	3	0	63815	\N
15779	3634	4	0	63816	\N
15422	75	2	0	62039	\N
15422	284	3	0	62040	\N
15424	90	3	0	62049	\N
15424	4074	4	0	62050	\N
15434	79	5	0	61138	\N
15434	3341	6	0	62103	\N
15437	4178	5	0	62019	\N
15437	4429	6	0	62124	\N
15439	189	5	0	60943	\N
15439	4540	6	0	62127	\N
15441	58	2	0	62133	\N
15441	2853	3	0	62134	\N
15443	268	2	0	62137	\N
15443	2800	3	0	62138	\N
15446	4172	2	0	62135	\N
15446	4191	3	0	62136	\N
15449	4178	3	0	62177	\N
15449	4211	4	0	62178	\N
15451	4178	0	0	62180	\N
15456	353	2	0	58428	\N
15456	2884	3	0	58760	\N
15458	60	2	0	62207	\N
15458	4544	3	0	62208	\N
15467	273	4	0	62236	\N
15467	3390	5	0	62237	\N
15472	119	2	0	60276	\N
15472	1879	3	0	62264	\N
15476	4178	2	0	62269	\N
15476	4247	3	0	62270	\N
15479	173	4	0	61000	\N
15479	3857	5	0	62291	\N
15481	189	4	0	62293	\N
15481	3436	5	0	62294	\N
15484	4172	3	0	62240	\N
15484	4275	4	0	62315	\N
15488	117	0	0	62320	\N
15490	117	0	0	62320	\N
15492	117	0	0	62320	\N
15496	42	6	0	62356	\N
15496	4334	7	0	62357	\N
15502	56	3	0	62375	\N
15502	4109	4	0	62376	\N
15505	3625	0	0	60668	\N
15509	164	2	0	58774	\N
15509	1124	3	0	58783	\N
15516	3265	3	0	59447	\N
15516	4553	3	0	62431	\N
15519	4172	3	0	62456	\N
15519	4275	4	0	62457	\N
15522	4172	6	0	62482	\N
15522	4537	7	0	62483	\N
15524	210	6	0	60657	\N
15524	4558	7	0	62486	\N
15526	82	2	0	62493	\N
15526	3401	3	0	62494	\N
15529	322	7	0	62517	\N
15529	4486	8	0	62518	\N
15534	224	5	0	60879	\N
15534	4419	6	0	62539	\N
15536	360	6	0	62544	\N
15536	4560	7	0	62545	\N
15542	4172	4	0	62592	\N
15542	4252	5	0	62593	\N
15544	132	4	0	60696	\N
15544	3293	5	0	61246	\N
15548	242	5	0	53401	\N
15548	4562	6	0	62633	\N
15551	4201	1	0	62642	\N
15551	4172	9	0	62657	\N
15551	4383	11	0	62660	\N
15553	18	1	0	62665	\N
15553	19	2	0	62666	\N
15556	14	6	0	58937	\N
15556	4565	7	0	62691	\N
15558	241	6	0	57574	\N
15558	4567	7	0	62693	\N
15559	4568	16	0	62694	\N
15559	200	126	0	62701	\N
15559	4569	127	0	62702	\N
15561	4178	6	0	62710	\N
15561	4570	7	0	62711	\N
15564	192	1	0	60535	\N
15564	193	2	0	60536	\N
15566	42	2	0	62722	\N
15566	681	3	0	62723	\N
15569	264	3	0	61278	\N
15569	1748	4	0	62737	\N
15572	117	2	0	62750	\N
15572	4571	3	0	62751	\N
15574	119	1	0	62402	\N
15574	120	2	0	62754	\N
15576	75	1	0	62495	\N
15576	76	2	0	62756	\N
15580	300	7	0	62782	\N
15580	4572	8	0	62783	\N
15583	56	1	0	62375	\N
15583	57	2	0	62789	\N
15585	123	2	0	62795	\N
15585	1868	3	0	62796	\N
15590	173	6	0	61000	\N
15590	4573	7	0	62825	\N
15598	242	2	0	62857	\N
15598	3425	3	0	62858	\N
15603	210	2	0	62880	\N
15603	1874	3	0	62881	\N
15605	69	2	0	62047	\N
15605	3350	3	0	62887	\N
15607	4178	2	0	62890	\N
15607	4247	3	0	62891	\N
15608	4178	7	0	62890	\N
15608	4509	8	0	62905	\N
15620	262	2	0	62125	\N
15620	2743	3	0	62948	\N
15622	233	4	0	62063	\N
15622	3775	5	0	62957	\N
15627	440	0	0	62984	\N
15629	1021	3	0	60490	\N
15629	4551	4	0	62366	\N
15640	316	3	0	63030	\N
15640	4249	4	0	63031	\N
15642	51	2	0	59452	\N
15642	1260	3	0	59453	\N
15647	4172	6	0	63047	\N
15647	4197	7	0	63061	\N
15649	242	4	0	63070	\N
15649	3512	5	0	63071	\N
15652	4172	3	0	63092	\N
15652	4275	4	0	63093	\N
15654	56	4	0	62375	\N
15654	3127	5	0	63104	\N
15657	260	7	0	63126	\N
15657	4589	8	0	63127	\N
15659	16	3	0	63133	\N
15659	3634	4	0	63134	\N
15662	16	6	0	63159	\N
15662	3369	7	0	63160	\N
15665	42	6	0	63188	\N
15665	1090	7	0	63189	\N
15667	453	6	0	63068	\N
15667	4091	7	0	63192	\N
15669	75	4	0	63194	\N
15669	3959	5	0	63195	\N
15672	242	7	0	63210	\N
15672	4592	8	0	63211	\N
15674	42	3	0	63188	\N
15674	3645	4	0	63218	\N
15676	595	4	0	63227	\N
15676	3878	5	0	63228	\N
15689	186	5	0	63263	\N
15689	3280	6	0	63264	\N
15691	67	7	0	62226	\N
15691	3608	8	0	63269	\N
15696	40	4	0	62911	\N
15516	4554	4	0	138616	\N
15551	4563	10	0	138618	\N
15473	4359	3	0	62265	\N
15475	3628	2	0	62267	\N
15475	4360	3	0	62268	\N
15478	4178	5	0	62269	\N
15478	4429	6	0	62282	\N
15480	4178	4	0	62269	\N
15480	4331	5	0	62292	\N
15485	424	3	0	62316	\N
15485	3611	4	0	62317	\N
15487	86	3	0	62318	\N
15487	3746	4	0	62319	\N
15489	117	1	0	62320	\N
15489	248	2	0	62323	\N
15491	117	0	0	62320	\N
15499	1021	3	0	60490	\N
15499	4551	4	0	62366	\N
15501	2	3	0	61516	\N
15501	3548	4	0	61724	\N
15503	42	1	0	62356	\N
15503	43	2	0	62379	\N
15504	79	8	0	62396	\N
15504	4238	9	0	62397	\N
15506	3625	0	0	60668	\N
15508	3628	2	0	62267	\N
15508	4360	3	0	62268	\N
15515	80	1	0	62412	\N
15515	79	5	0	62419	\N
15515	3652	6	0	62426	\N
15521	360	4	0	62468	\N
15521	4330	5	0	62469	\N
15523	411	6	0	62484	\N
15523	4557	7	0	62485	\N
15525	198	2	0	62491	\N
15525	513	3	0	62492	\N
15527	75	2	0	62495	\N
15527	284	3	0	62496	\N
15530	132	7	0	60696	\N
15530	4559	8	0	62519	\N
15533	224	0	0	60879	\N
15535	4555	0	0	62540	\N
15535	4556	0	0	62541	\N
15538	35	2	0	61902	\N
15538	1191	3	0	61903	\N
15541	40	4	0	62590	\N
15541	2796	5	0	62591	\N
15543	86	4	0	62318	\N
15543	2576	5	0	62594	\N
15547	4172	5	0	62592	\N
15547	4415	6	0	62632	\N
15549	186	2	0	62638	\N
15549	1850	3	0	62639	\N
15552	210	1	0	62663	\N
15552	211	2	0	62664	\N
15555	18	5	0	62665	\N
15555	3550	6	0	62678	\N
15557	18	6	0	62665	\N
15557	4566	7	0	62692	\N
15560	224	6	0	62709	\N
15560	1707	7	0	14371	\N
15568	94	3	0	62736	\N
15568	375	4	0	57113	\N
15577	73	1	0	62759	\N
15577	74	2	0	62760	\N
15581	2	1	0	62786	\N
15581	26	2	0	62787	\N
15588	4178	2	0	62805	\N
15588	4247	3	0	62811	\N
15594	4172	2	0	62843	\N
15594	4285	3	0	62844	\N
15596	3846	2	0	62846	\N
15596	4575	3	0	62847	\N
15599	217	1	0	62861	\N
15599	23	3	0	62864	\N
15599	1089	4	0	62865	\N
15601	4577	2	0	62870	\N
15601	4578	2	0	62871	\N
15601	4014	3	1	62872	\N
15601	4579	3	0	62873	\N
15613	4172	2	0	62843	\N
15613	4191	3	0	62919	\N
15615	100	2	0	60507	\N
15615	633	3	0	62925	\N
15618	4178	5	0	62941	\N
15618	4429	6	0	62942	\N
15623	73	6	0	62967	\N
15623	4257	7	0	62968	\N
15625	4178	4	0	62941	\N
15625	4205	5	0	62976	\N
15630	224	3	0	62709	\N
15630	3603	4	0	62995	\N
15632	230	3	0	62998	\N
15632	4181	4	0	62999	\N
15634	4088	4	0	61647	\N
15634	4089	5	0	62956	\N
15636	88	4	0	61487	\N
15636	3809	5	0	63010	\N
15638	241	4	0	63013	\N
15638	4582	5	0	63014	\N
15643	290	2	0	61140	\N
15643	1909	3	0	61141	\N
15645	4172	4	0	63047	\N
15645	4219	5	0	63048	\N
15650	4586	5	0	63082	\N
15650	241	7	0	63084	\N
15650	3094	8	0	63085	\N
15653	4587	3	0	63094	\N
15653	4588	3	0	63095	\N
15653	2803	4	0	63096	\N
15655	198	3	0	63111	\N
15655	4263	4	0	63112	\N
15658	793	7	0	61375	\N
15658	4590	8	0	63128	\N
15660	391	3	0	61765	\N
15660	3660	4	0	63141	\N
15663	18	3	0	63167	\N
15663	3621	4	0	63168	\N
15666	4172	6	0	63190	\N
15666	4197	7	0	63191	\N
15668	288	6	0	60090	\N
15668	4085	7	0	63193	\N
15670	453	6	0	63068	\N
15670	4091	7	0	63192	\N
15679	391	4	0	63230	\N
15679	3913	5	0	63231	\N
15681	908	3	0	63236	\N
15681	3591	4	0	63237	\N
15683	58	3	0	63245	\N
15683	3665	4	0	63246	\N
15685	62	3	0	61057	\N
15685	3344	4	0	63248	\N
15690	186	7	0	63263	\N
15690	4595	8	0	63268	\N
15692	149	0	0	63270	\N
15694	137	3	0	58847	\N
15694	3633	4	0	63280	\N
15701	325	1	0	63294	\N
15701	324	6	0	63297	\N
15701	3500	7	0	61778	\N
15703	325	1	0	63294	\N
15703	324	8	0	63297	\N
15703	4598	9	0	63310	\N
15705	16	6	0	63320	\N
15705	4600	7	0	63321	\N
15713	14	3	0	63363	\N
15713	4272	4	0	63364	\N
15715	2	4	0	63373	\N
15715	3510	5	0	63374	\N
15717	4603	16	0	63376	\N
15717	200	126	0	63433	\N
15717	4604	127	0	63434	\N
15720	402	3	0	63457	\N
15720	4077	4	0	63458	\N
15722	206	3	0	63466	\N
15722	4584	4	0	63467	\N
15725	4178	3	0	63475	\N
15725	4211	4	0	63476	\N
15727	262	4	0	63484	\N
15696	3381	5	0	63287	\N
15707	228	3	0	60837	\N
15707	3186	4	0	60838	\N
15709	336	0	0	53386	\N
15710	56	10	0	63350	\N
15710	4602	11	0	63351	\N
15712	77	3	0	63354	\N
15712	1877	4	0	63362	\N
15714	1109	3	0	63365	\N
15714	3495	4	0	63366	\N
15719	4606	11	0	63451	\N
15726	4178	4	0	63475	\N
15726	4205	5	0	63483	\N
15731	244	7	0	60307	\N
15731	4608	8	0	63511	\N
15734	40	3	0	62911	\N
15734	372	4	0	62912	\N
15739	210	2	0	62880	\N
15739	1173	3	0	63572	\N
15742	14	3	0	63363	\N
15742	4272	4	0	63364	\N
15744	113	4	0	63601	\N
15744	3677	5	0	63602	\N
15758	54	3	0	60555	\N
15758	3041	4	0	63689	\N
15760	71	4	0	61679	\N
15760	3887	5	0	63696	\N
15763	326	3	0	62914	\N
15763	3339	4	0	62915	\N
15765	210	4	0	63728	\N
15765	3536	5	0	63729	\N
15770	164	5	0	63759	\N
15770	4626	6	0	63760	\N
15776	734	8	0	24876	\N
15776	4630	9	0	63806	\N
15778	200	1	0	63811	\N
15778	201	2	0	63812	\N
15785	391	6	0	63847	\N
15785	3521	7	0	63848	\N
15791	33	3	0	63897	\N
15791	3342	4	0	63898	\N
15793	202	4	0	63908	\N
15793	3673	5	0	63909	\N
15796	4635	6	0	63942	\N
15796	367	17	0	63957	\N
15796	368	18	0	63958	\N
15801	200	3	0	63811	\N
15801	2565	4	0	63984	\N
15804	27	3	0	63999	\N
15804	4636	4	0	61944	\N
15806	27	3	0	64015	\N
15806	4636	4	0	64016	\N
15811	597	11	0	55967	\N
15811	4637	12	0	64051	\N
15815	147	14	0	50234	\N
15815	4641	15	0	64060	\N
15821	4647	7	0	64148	\N
15821	353	20	0	64169	\N
15821	4649	21	1	64170	\N
15821	4648	21	0	64171	\N
15826	4654	7	0	64179	\N
15826	326	20	0	64180	\N
15826	4655	21	0	64181	\N
15828	4647	7	0	64148	\N
15828	353	20	0	64169	\N
15828	4653	21	0	64178	\N
15830	16	5	0	64197	\N
15830	3455	6	0	64198	\N
15832	18	5	0	64210	\N
15832	3964	6	0	64211	\N
15834	4178	7	0	64227	\N
15834	4659	8	0	64228	\N
15838	115	2	0	64282	\N
15838	2797	3	0	64283	\N
15724	3660	4	0	63474	\N
15728	115	3	0	63492	\N
15728	3483	4	0	63493	\N
15737	4150	8	0	63563	\N
15737	56	12	0	63564	\N
15737	4102	13	0	63565	\N
15741	4172	7	0	63190	\N
15741	4614	8	0	63585	\N
15746	77	7	0	63354	\N
15746	4616	8	0	63615	\N
15752	4172	7	0	63665	\N
15752	4614	8	0	63666	\N
15754	4178	7	0	63592	\N
15754	4396	8	0	63669	\N
15757	258	3	0	63687	\N
15757	4401	4	0	63688	\N
15759	268	4	0	62137	\N
15759	3897	5	0	63695	\N
15762	1722	3	0	63716	\N
15762	4623	4	0	63717	\N
15767	23	7	0	63741	\N
15767	4625	8	0	63742	\N
15775	117	8	0	63790	\N
15775	4629	9	0	63799	\N
15780	360	3	0	63822	\N
15780	3602	4	0	63823	\N
15782	40	4	0	62911	\N
15782	3381	5	0	63287	\N
15784	75	3	0	63835	\N
15784	3855	4	0	63836	\N
15788	18	5	0	63879	\N
15788	3550	6	0	63880	\N
15790	4172	5	0	63890	\N
15790	4634	6	0	63891	\N
15795	4178	4	0	63743	\N
15795	4205	5	0	63930	\N
15803	27	2	0	63999	\N
15803	645	3	0	64000	\N
15808	149	9	0	64021	\N
15808	2963	10	0	64022	\N
15810	285	0	0	64031	\N
15817	2578	19	0	58437	\N
15817	4643	20	0	64096	\N
15819	75	5	0	63835	\N
15819	4645	6	0	64108	\N
15820	4172	13	0	64132	\N
15820	4646	14	0	64133	\N
15823	2314	7	0	64175	\N
15823	40	20	0	64176	\N
15823	4652	21	0	64177	\N
15829	4172	5	0	64195	\N
15829	4644	6	0	64196	\N
15831	94	5	0	62736	\N
15831	4657	6	0	64209	\N
15837	14	3	0	64280	\N
15837	4272	4	0	64281	\N
15840	115	3	0	64282	\N
15840	3483	4	0	64286	\N
15727	4607	5	0	63485	\N
15729	192	3	0	63499	\N
15729	3790	4	0	63500	\N
15732	202	8	0	60743	\N
15732	4609	9	0	63527	\N
15740	60	7	0	63583	\N
15740	4613	8	0	63584	\N
15745	77	4	0	63605	\N
15745	4615	5	0	63606	\N
15747	177	7	0	63616	\N
15747	4617	8	0	63617	\N
15748	424	14	0	62316	\N
15748	4618	15	0	63637	\N
15750	244	14	0	63639	\N
15750	4620	15	0	63640	\N
15753	110	7	0	63667	\N
15753	4621	8	0	63668	\N
15755	110	8	0	63667	\N
15755	3710	9	0	63671	\N
15761	73	9	0	63710	\N
15761	4622	10	0	63711	\N
15766	140	7	0	62974	\N
15766	4624	8	0	63740	\N
15768	4178	7	0	63743	\N
15768	4509	8	0	63744	\N
15771	164	3	0	63766	\N
15771	3385	4	0	63767	\N
15772	266	10	0	63783	\N
15772	4627	11	0	63784	\N
15774	117	3	0	63790	\N
15774	3653	4	0	63791	\N
15781	4172	3	0	63824	\N
15781	4275	4	0	63825	\N
15783	241	4	0	63833	\N
15783	4582	5	0	63834	\N
15786	4172	4	0	63855	\N
15786	4219	5	0	63856	\N
15789	266	3	0	63783	\N
15789	4633	4	0	63881	\N
15797	71	3	0	61679	\N
15797	3770	4	0	63964	\N
15799	1858	3	0	25261	\N
15799	4273	4	0	57753	\N
15802	4172	5	0	63965	\N
15802	4634	6	0	63994	\N
15807	27	4	0	64015	\N
15807	3717	5	0	64019	\N
15812	595	14	0	63227	\N
15812	4638	15	0	64057	\N
15816	285	11	0	64031	\N
15816	4642	12	0	64061	\N
15818	4172	5	0	64106	\N
15818	4644	6	0	64107	\N
15822	4650	7	0	64172	\N
15822	212	20	0	64173	\N
15822	4651	21	0	64174	\N
15824	4650	7	0	64172	\N
15824	212	20	0	64173	\N
15824	4651	21	0	64174	\N
15827	2506	7	0	64182	\N
15827	18	20	0	64183	\N
15827	4649	21	1	64184	\N
15827	4656	21	0	64185	\N
15839	841	3	0	64284	\N
15839	3604	4	0	64285	\N
15787	23	6	0	63867	\N
15787	4632	7	0	63868	\N
15792	173	4	0	63906	\N
15792	3614	5	0	63907	\N
15794	40	6	0	63920	\N
15794	4255	7	0	63921	\N
15798	4172	3	0	63965	\N
15798	4275	4	0	63966	\N
15800	69	3	0	63976	\N
15800	4536	4	0	63977	\N
15805	4178	5	0	64009	\N
15805	4429	6	0	64010	\N
15809	149	4	0	64029	\N
15809	4040	5	0	64030	\N
15813	353	14	0	58428	\N
15813	4639	15	0	64058	\N
15814	285	14	0	64031	\N
15814	4640	15	0	64059	\N
15825	4647	7	0	64148	\N
15825	353	20	0	64169	\N
15825	4653	21	0	64178	\N
15833	40	7	0	64225	\N
15833	4658	8	0	64226	\N
15835	264	6	0	64239	\N
15835	4660	7	0	64240	\N
15836	16	17	0	64273	\N
15836	4661	18	0	64274	\N
15841	140	4	0	62974	\N
15841	3821	5	0	62975	\N
15842	56	4	0	64294	\N
15842	3127	5	0	64295	\N
15843	424	4	0	62316	\N
15843	3188	5	0	64296	\N
15844	164	4	0	64297	\N
15844	4152	5	0	64298	\N
15845	260	3	0	64304	\N
15845	3399	4	0	64305	\N
15846	4172	3	0	64195	\N
15846	4275	4	0	64306	\N
15847	51	10	0	64323	\N
15847	4662	11	0	64324	\N
15848	4172	10	0	64195	\N
15848	4663	11	0	64325	\N
15849	12	10	0	61244	\N
15849	4664	11	0	64326	\N
15850	4178	10	0	64327	\N
15850	4665	11	0	64328	\N
15851	135	4	0	52757	\N
15851	4666	5	0	64337	\N
15852	242	4	0	63210	\N
15852	4667	5	0	64338	\N
15853	137	4	0	64339	\N
15853	4668	5	0	64340	\N
15854	192	6	0	64351	\N
15854	4669	7	0	64352	\N
15855	262	6	0	63484	\N
15855	4248	7	0	64353	\N
15856	56	3	0	64294	\N
15856	4109	4	0	64359	\N
15857	151	3	0	64366	\N
15857	3046	4	0	64367	\N
15858	228	3	0	64368	\N
15858	3186	4	0	64369	\N
15859	4670	3	0	64370	\N
15859	4671	4	0	64371	\N
15860	156	7	0	64382	\N
15860	4672	8	0	64383	\N
15861	4172	7	0	64384	\N
15861	4614	8	0	64385	\N
15862	4673	42	0	64405	\N
15862	251	43	0	64406	\N
15863	1685	2	0	64410	\N
15863	18	4	0	64413	\N
15863	1426	5	0	64414	\N
15864	4674	4	0	64421	\N
15864	4675	4	0	64422	\N
15864	4676	5	0	64423	\N
15865	1225	4	0	64424	\N
15865	4676	5	0	64425	\N
15866	94	4	0	64426	\N
15866	4677	5	0	64427	\N
15867	4678	3	0	64433	\N
15867	4679	4	0	64434	\N
15868	16	3	0	64441	\N
15868	3634	4	0	64442	\N
15869	79	3	0	62712	\N
15869	3652	4	0	64447	\N
15870	14	4	0	64280	\N
15870	3498	5	0	64454	\N
15871	4178	4	0	64327	\N
15871	4205	5	0	64455	\N
15872	40	3	0	64225	\N
15872	372	4	0	64461	\N
15873	108	4	0	64469	\N
15873	4060	5	0	64470	\N
15874	40	4	0	64471	\N
15874	3381	5	0	64472	\N
15875	170	4	0	64481	\N
15875	4680	5	0	64482	\N
15876	264	4	0	64483	\N
15876	3684	5	0	64484	\N
15877	4172	0	0	61489	\N
15878	110	1	0	63667	\N
15878	3242	2	0	64485	\N
15879	110	1	0	63667	\N
15879	3242	2	0	64485	\N
15880	4178	1	0	64327	\N
15880	4450	2	0	64488	\N
15881	18	3	0	64491	\N
15881	3621	4	0	64492	\N
15882	4172	0	0	61525	\N
15883	206	3	0	63466	\N
15883	4584	4	0	63467	\N
15885	110	4	0	63667	\N
15885	4552	5	0	64495	\N
15886	110	1	0	63667	\N
15886	3242	2	0	64485	\N
15887	391	6	0	64505	\N
15887	3521	7	0	64506	\N
15888	214	6	0	64507	\N
15888	4681	7	0	64508	\N
15889	4178	9	0	64327	\N
15889	4682	10	0	64523	\N
15890	200	4	0	64530	\N
15890	4683	5	0	64531	\N
15891	100	4	0	63113	\N
15891	3776	5	0	64532	\N
15892	202	4	0	64533	\N
15892	3673	5	0	64534	\N
15893	790	3	0	64541	\N
15893	4684	4	0	64542	\N
15894	14	3	0	64548	\N
15894	4272	4	0	64549	\N
15895	75	9	0	63835	\N
15895	4685	10	0	64567	\N
15896	391	3	0	64505	\N
15896	3660	4	0	64573	\N
15897	4233	3	0	60910	\N
15897	4425	4	0	60911	\N
15898	16	3	0	64574	\N
15898	3634	4	0	64575	\N
15899	96	3	0	63090	\N
15899	2803	4	0	63091	\N
15900	230	3	0	62998	\N
15900	4181	4	0	62999	\N
15901	79	6	0	64596	\N
15901	4253	7	0	64597	\N
15902	391	6	0	64598	\N
15902	3521	7	0	64599	\N
15903	16	6	0	64574	\N
15903	3369	7	0	64600	\N
15904	4686	6	0	64611	\N
15904	121	7	0	64612	\N
15905	4686	6	0	64611	\N
15905	121	7	0	64612	\N
15906	4180	6	0	64613	\N
15906	18	7	0	64614	\N
15907	4686	6	0	64611	\N
15907	121	7	0	64612	\N
15908	16	2	0	64618	\N
15908	388	3	0	64619	\N
15911	88	3	0	61487	\N
15911	3655	4	0	61804	\N
15913	60	3	0	63583	\N
15913	3585	4	0	64641	\N
15916	4605	5	0	64666	\N
15916	4688	6	0	64667	\N
15919	16	6	0	64618	\N
15919	3369	7	0	64675	\N
15920	260	3	0	64681	\N
15920	3399	4	0	64682	\N
15923	1021	6	0	60490	\N
15923	4691	7	0	64700	\N
15925	56	3	0	64705	\N
15925	4109	4	0	64706	\N
15930	88	9	0	64731	\N
15930	4692	10	0	64732	\N
15933	4172	3	0	64384	\N
15933	4275	4	0	64742	\N
15937	4178	3	0	64757	\N
15937	4211	4	0	64758	\N
15939	4172	3	0	64764	\N
15939	4275	4	0	64765	\N
15947	4172	3	0	64764	\N
15947	4275	4	0	64765	\N
15949	75	6	0	64707	\N
15949	4694	7	0	64818	\N
15954	3625	3	0	60668	\N
15954	3784	4	0	64848	\N
15956	3628	3	0	62267	\N
15956	3785	4	0	64850	\N
15965	300	3	0	64880	\N
15965	3747	4	0	64881	\N
15968	4172	6	0	64764	\N
15968	4197	7	0	64894	\N
15972	92	3	0	64904	\N
15972	4410	4	0	64905	\N
15975	228	3	0	64368	\N
15975	3186	4	0	64369	\N
15978	108	3	0	64469	\N
15978	4171	4	0	64955	\N
15983	1549	3	0	64981	\N
15983	4702	4	0	64982	\N
15986	391	3	0	64598	\N
15986	3660	4	0	64992	\N
15988	3625	3	0	60668	\N
15988	3784	4	0	64848	\N
15990	3628	3	0	65010	\N
15990	3785	4	0	65011	\N
15995	4178	3	0	64797	\N
15995	4211	4	0	64798	\N
15998	137	10	0	64339	\N
15998	4704	11	0	65067	\N
16001	100	3	0	63113	\N
16001	3836	4	0	63114	\N
16004	4178	10	0	65118	\N
16004	4665	11	0	65119	\N
16008	402	16	0	65155	\N
16008	4709	17	0	65156	\N
16010	285	4	0	64031	\N
16010	3674	5	0	65166	\N
16013	262	4	0	65169	\N
16013	4607	5	0	65170	\N
16014	1470	3	0	62996	\N
16014	3838	4	0	62997	\N
16016	2185	3	0	44527	\N
16016	4710	4	0	65178	\N
16019	244	3	0	65185	\N
16019	4075	4	0	65186	\N
16021	2	3	0	64628	\N
16021	3548	4	0	64629	\N
16024	2791	2	0	65216	\N
16024	488	5	0	65217	\N
16024	2991	6	0	65218	\N
16026	40	9	0	64897	\N
16026	4712	10	0	65233	\N
16031	192	7	0	65262	\N
16031	4713	8	0	65263	\N
16034	20	7	0	65281	\N
16034	4714	8	0	65282	\N
16039	4172	4	0	65309	\N
16039	4219	5	0	65310	\N
16042	12	4	0	61244	\N
16042	4043	5	0	65315	\N
16043	69	3	0	65032	\N
16043	4536	4	0	65033	\N
16046	54	4	0	64766	\N
16046	3685	5	0	65335	\N
16048	121	3	0	65348	\N
16048	4471	4	0	65349	\N
16063	18	4	0	64653	\N
16063	2302	5	0	65410	\N
16067	71	4	0	65434	\N
16067	3887	5	0	65435	\N
16070	125	7	0	65465	\N
16070	4719	8	0	65466	\N
16073	137	7	0	65469	\N
16073	4722	8	0	65470	\N
16076	23	2	0	65478	\N
16076	3443	3	0	65479	\N
16083	300	3	0	65495	\N
16083	3747	4	0	65496	\N
16085	4178	3	0	65386	\N
16085	4211	4	0	65486	\N
16089	360	3	0	63822	\N
16089	3602	4	0	63823	\N
16094	56	3	0	65575	\N
16094	4109	4	0	65576	\N
16096	4178	4	0	65553	\N
16096	4205	5	0	65585	\N
16099	100	3	0	65604	\N
16099	3836	4	0	65605	\N
16101	391	4	0	64598	\N
16101	3913	5	0	65632	\N
16106	40	7	0	65577	\N
16106	4718	8	0	65654	\N
16110	4178	3	0	65668	\N
16110	4211	4	0	65669	\N
16114	92	3	0	64989	\N
16114	4410	4	0	64990	\N
16116	402	4	0	65155	\N
16116	4731	5	0	65716	\N
16121	192	3	0	65744	\N
16121	3790	4	0	65745	\N
16124	4172	7	0	65764	\N
16124	4614	8	0	65765	\N
16126	1470	3	0	62996	\N
16126	3838	4	0	62997	\N
16131	4178	4	0	65729	\N
16131	4205	5	0	65797	\N
16138	4197	6	0	65833	\N
16138	4172	7	0	65834	\N
16140	4735	6	0	65837	\N
16140	373	7	0	65838	\N
16143	235	3	0	64870	\N
16143	3343	4	0	65857	\N
16150	4172	4	0	65764	\N
16150	4219	5	0	65890	\N
16152	4172	3	0	65898	\N
16152	4275	4	0	65899	\N
16154	266	28	0	63783	\N
16154	4739	29	0	65913	\N
16163	852	3	0	65946	\N
16163	3612	4	0	65947	\N
16166	4172	3	0	65966	\N
16166	4275	4	0	65967	\N
16169	244	3	0	65185	\N
16169	4075	4	0	65186	\N
16177	2782	3	0	66052	\N
16177	3659	4	0	66053	\N
16183	595	11	0	66088	\N
16183	4748	12	0	66089	\N
16189	268	4	0	66101	\N
16189	3897	5	0	66102	\N
15909	132	2	0	64620	\N
15909	2756	3	0	64621	\N
15914	18	6	0	64653	\N
15914	4180	7	0	64654	\N
15917	4605	6	0	64666	\N
15917	4689	7	0	64672	\N
15921	2636	3	0	61811	\N
15921	2837	4	0	64688	\N
15926	2	3	0	64628	\N
15926	3548	4	0	64629	\N
15928	4172	2	0	64384	\N
15928	4191	3	0	64713	\N
15931	316	9	0	63030	\N
15931	4279	10	0	64733	\N
15934	96	3	0	64743	\N
15934	2803	4	0	64744	\N
15935	4172	3	0	64384	\N
15935	4275	4	0	64742	\N
15938	4172	3	0	64384	\N
15938	4275	4	0	64742	\N
15942	4178	6	0	64757	\N
15942	4250	7	0	64780	\N
15945	16	3	0	64799	\N
15945	3634	4	0	64800	\N
15950	189	6	0	63011	\N
15950	3713	7	0	64819	\N
15952	123	3	0	64833	\N
15952	2856	4	0	64834	\N
15957	4178	3	0	64797	\N
15957	4211	4	0	64798	\N
15960	98	3	0	64855	\N
15960	4695	4	0	64856	\N
15966	435	0	0	64808	\N
15969	595	6	0	63227	\N
15969	4698	7	0	64895	\N
15971	40	6	0	64897	\N
15971	4255	7	0	64898	\N
15979	79	3	0	64596	\N
15979	3652	4	0	64956	\N
15989	119	3	0	62402	\N
15989	2860	4	0	64849	\N
15993	4172	3	0	64764	\N
15993	4275	4	0	64765	\N
15999	135	10	0	52757	\N
15999	4705	11	0	65068	\N
16002	18	3	0	64653	\N
16002	3621	4	0	65091	\N
16005	79	10	0	64596	\N
16005	4707	11	0	65120	\N
16009	56	16	0	65157	\N
16009	2588	17	0	65158	\N
16011	142	4	0	61364	\N
16011	3950	5	0	65167	\N
16017	1470	3	0	62996	\N
16017	3838	4	0	62997	\N
16027	2	9	0	65234	\N
16027	3650	10	0	65235	\N
16029	4178	3	0	65248	\N
16029	4211	4	0	65249	\N
16035	4178	7	0	65248	\N
16035	4396	8	0	65283	\N
16037	132	6	0	64673	\N
16037	4690	7	0	64674	\N
16040	113	4	0	65311	\N
16040	3677	5	0	65312	\N
16044	4178	3	0	65326	\N
16044	4211	4	0	65327	\N
16049	40	3	0	64897	\N
16049	372	4	0	65350	\N
16051	2	3	0	65363	\N
16051	3548	4	0	65364	\N
16056	189	4	0	63011	\N
16056	3992	5	0	63012	\N
16061	173	4	0	63906	\N
16061	3614	5	0	63907	\N
16065	132	6	0	65418	\N
16065	4690	7	0	65425	\N
16068	40	6	0	64897	\N
16068	4717	7	0	65438	\N
16071	1636	7	0	59885	\N
16071	4720	8	0	65467	\N
16074	16	7	0	65471	\N
16074	4723	8	0	65472	\N
16077	424	0	0	65375	\N
16079	4178	3	0	65386	\N
16079	4211	4	0	65486	\N
16081	35	3	0	65488	\N
16081	3563	4	0	65489	\N
16086	353	3	0	65504	\N
16086	3766	4	0	65505	\N
16092	4172	7	0	65309	\N
16092	4614	8	0	65567	\N
16095	40	3	0	65577	\N
16095	372	4	0	65578	\N
16097	75	6	0	65313	\N
16097	4694	7	0	65596	\N
16104	3053	2	0	65637	\N
16104	102	4	0	65640	\N
16104	3197	5	0	65641	\N
16111	40	4	0	65577	\N
16111	3381	5	0	65676	\N
16112	18	13	0	64653	\N
16112	4730	14	0	65698	\N
16117	841	4	0	65717	\N
16117	3886	5	0	65718	\N
16119	251	6	0	65731	\N
16119	4183	7	0	65732	\N
16127	431	3	0	65777	\N
16127	3933	4	0	65778	\N
16129	186	35	0	63263	\N
16129	4732	36	0	65791	\N
16134	391	7	0	65816	\N
16134	3662	8	0	65817	\N
16136	75	7	0	65820	\N
16136	2859	8	0	65821	\N
16139	3521	6	0	65835	\N
16139	391	7	0	65836	\N
16141	18	6	0	65848	\N
16141	4180	7	0	65849	\N
16146	149	6	0	65873	\N
16146	4737	7	0	65874	\N
16148	4178	3	0	65881	\N
16148	4211	4	0	65882	\N
16151	16	4	0	65891	\N
16151	3546	5	0	65892	\N
16153	38	3	0	61977	\N
16153	3457	4	0	65900	\N
16155	528	3	0	65919	\N
16155	4262	4	0	65920	\N
16157	230	3	0	65926	\N
16157	4181	4	0	65927	\N
16161	2	3	0	65931	\N
16161	3548	4	0	65932	\N
16164	56	3	0	65575	\N
16164	4109	4	0	65576	\N
16171	4743	5	0	65986	\N
16175	4745	57	0	66020	\N
16175	100	126	0	66039	\N
16175	4746	127	0	66040	\N
16178	18	3	0	66054	\N
16178	3621	4	0	66055	\N
16180	132	4	0	66065	\N
16180	3716	5	0	66066	\N
16185	930	11	0	66091	\N
16185	4750	12	0	66092	\N
16187	268	4	0	66101	\N
16187	3897	5	0	66102	\N
16192	4178	7	0	65881	\N
16192	4396	8	0	66130	\N
16195	1021	4	0	66157	\N
16195	4752	5	0	66158	\N
16198	151	3	0	64366	\N
16198	3046	4	0	64367	\N
16204	353	6	0	65504	\N
16204	4754	7	0	66187	\N
16207	115	3	0	66190	\N
15910	2	3	0	64628	\N
15910	3548	4	0	64629	\N
15912	113	3	0	64634	\N
15912	3620	4	0	64635	\N
15929	262	2	0	64714	\N
15929	2743	3	0	64715	\N
15932	73	3	0	64740	\N
15932	3040	4	0	64741	\N
15936	67	3	0	64750	\N
15936	3749	4	0	64751	\N
15941	40	3	0	64768	\N
15941	372	4	0	64769	\N
15944	4178	3	0	64797	\N
15944	4211	4	0	64798	\N
15946	268	3	0	64806	\N
15946	3815	4	0	64807	\N
15951	16	3	0	64826	\N
15951	3634	4	0	64827	\N
15959	2	3	0	64628	\N
15959	3548	4	0	64629	\N
15961	16	3	0	64857	\N
15961	3634	4	0	64858	\N
15963	94	6	0	64872	\N
15963	4696	7	0	64873	\N
15967	597	6	0	55967	\N
15967	4697	7	0	64893	\N
15974	56	3	0	64916	\N
15974	4109	4	0	64917	\N
15977	67	16	0	64947	\N
15977	4700	17	0	64948	\N
15982	200	6	0	64530	\N
15982	4701	7	0	64976	\N
15985	51	3	0	64323	\N
15985	3533	4	0	64991	\N
15987	56	6	0	65003	\N
15987	4703	7	0	65004	\N
15992	57	1	0	65021	\N
15992	56	4	0	65025	\N
15992	2914	5	0	65026	\N
15997	228	3	0	64368	\N
15997	3186	4	0	64369	\N
16003	75	4	0	65099	\N
16003	3959	5	0	65100	\N
16006	316	3	0	63030	\N
16006	4249	4	0	63031	\N
16007	4178	16	0	65153	\N
16007	4708	17	0	65154	\N
16020	35	4	0	65193	\N
16020	3545	5	0	65194	\N
16023	2754	2	0	65211	\N
16023	2351	5	0	65214	\N
16023	4711	6	0	65215	\N
16025	2754	2	0	65211	\N
16025	2351	5	0	65214	\N
16025	4711	6	0	65215	\N
16028	56	4	0	65157	\N
16028	3127	5	0	65242	\N
16030	16	3	0	64857	\N
16030	3634	4	0	64858	\N
16033	336	3	0	65268	\N
16033	3400	4	0	65269	\N
16036	132	4	0	64673	\N
16036	3293	5	0	65291	\N
16038	123	3	0	65301	\N
16038	2856	4	0	65302	\N
16041	75	4	0	65313	\N
16041	3959	5	0	65314	\N
16045	4178	4	0	65333	\N
16045	4205	5	0	65334	\N
16050	117	4	0	65357	\N
16050	3835	5	0	65358	\N
16053	424	6	0	65375	\N
16053	3712	7	0	65376	\N
16055	4178	4	0	65386	\N
16055	4205	5	0	65387	\N
16058	4	7	0	61998	\N
16058	4716	8	0	65401	\N
16060	79	4	0	64596	\N
16060	3678	5	0	65409	\N
16064	132	4	0	65418	\N
16064	3293	5	0	65419	\N
16069	40	7	0	64897	\N
16069	4718	8	0	65452	\N
16072	135	7	0	52757	\N
16072	4721	8	0	65468	\N
16075	44	7	0	65473	\N
16075	4144	8	0	65474	\N
16082	1021	3	0	60490	\N
16082	4551	4	0	62366	\N
16091	2578	22	0	65555	\N
16091	4726	23	0	65556	\N
16093	4172	3	0	65573	\N
16093	4275	4	0	65574	\N
16098	4178	3	0	65602	\N
16098	4211	4	0	65603	\N
16100	4727	57	0	65606	\N
16100	100	126	0	65623	\N
16100	4728	127	0	65624	\N
16103	3053	2	0	65637	\N
16103	102	4	0	65640	\N
16103	3197	5	0	65641	\N
16105	488	7	0	65652	\N
16105	4729	8	0	65653	\N
16108	16	3	0	65471	\N
16108	3634	4	0	65660	\N
16113	4178	3	0	65704	\N
16113	4211	4	0	65705	\N
16118	4178	6	0	65729	\N
16118	4250	7	0	65730	\N
16123	181	3	0	63290	\N
16123	4184	4	0	65751	\N
16130	186	4	0	63263	\N
16130	4733	5	0	65796	\N
16133	16	2	0	65471	\N
16133	388	3	0	65803	\N
16135	51	7	0	65818	\N
16135	4734	8	0	65819	\N
16142	577	3	0	65855	\N
16142	4736	4	0	65856	\N
16145	42	3	0	63188	\N
16145	3645	4	0	63218	\N
16147	71	6	0	65779	\N
16147	4738	7	0	65875	\N
16159	38	3	0	61977	\N
16159	3457	4	0	65900	\N
16160	424	3	0	65375	\N
16160	3611	4	0	65930	\N
16165	198	4	0	65960	\N
16165	4161	5	0	65961	\N
16168	1109	3	0	65974	\N
16168	3495	4	0	65975	\N
16170	4741	5	0	65984	\N
16173	1109	4	0	65974	\N
16173	3816	5	0	65988	\N
16174	100	2	0	65604	\N
16174	633	3	0	65993	\N
16179	273	4	0	66063	\N
16179	3777	5	0	66064	\N
16181	214	2	0	66070	\N
16181	2979	3	0	66071	\N
16182	597	11	0	55967	\N
16182	4747	12	0	66087	\N
16184	147	11	0	50234	\N
16184	4749	12	0	66090	\N
16194	164	6	0	64297	\N
16194	3583	7	0	66150	\N
16196	40	4	0	66159	\N
16196	3381	5	0	66160	\N
16199	198	3	0	66167	\N
16199	4263	4	0	66168	\N
16203	75	3	0	66177	\N
16203	3855	4	0	66178	\N
16206	115	6	0	66190	\N
16206	4755	7	0	66191	\N
16210	167	10	0	66224	\N
16210	4757	11	0	66225	\N
15915	852	6	0	64655	\N
15915	4687	7	0	64656	\N
15918	132	6	0	64673	\N
15918	4690	7	0	64674	\N
15922	367	3	0	64689	\N
15922	3683	4	0	64690	\N
15924	262	6	0	63484	\N
15924	4248	7	0	64353	\N
15927	75	3	0	64707	\N
15927	3855	4	0	64708	\N
15940	54	3	0	64766	\N
15940	3041	4	0	64767	\N
15943	115	6	0	64282	\N
15943	4693	7	0	64791	\N
15948	435	0	0	64808	\N
15953	125	3	0	64840	\N
15953	4170	4	0	64841	\N
15955	119	3	0	62402	\N
15955	2860	4	0	64849	\N
15958	73	3	0	64740	\N
15958	3040	4	0	64741	\N
15962	235	6	0	64870	\N
15962	3622	7	0	64871	\N
15964	793	6	0	61375	\N
15964	3719	7	0	64874	\N
15970	147	6	0	50234	\N
15970	4699	7	0	64896	\N
15973	2782	3	0	63045	\N
15973	3659	4	0	63253	\N
15976	82	2	0	62493	\N
15976	3220	3	0	64918	\N
15980	58	3	0	63245	\N
15980	3665	4	0	63246	\N
15981	2782	3	0	64963	\N
15981	3659	4	0	64964	\N
15984	92	3	0	64989	\N
15984	4410	4	0	64990	\N
15991	75	3	0	65017	\N
15991	3855	4	0	65018	\N
15994	69	3	0	65032	\N
15994	4536	4	0	65033	\N
15996	453	3	0	63068	\N
15996	2838	4	0	65044	\N
16000	402	9	0	65084	\N
16000	4706	10	0	65085	\N
16012	4	4	0	61998	\N
16012	4117	5	0	65168	\N
16015	27	3	0	65176	\N
16015	4636	4	0	65177	\N
16018	251	3	0	60821	\N
16018	3514	4	0	65184	\N
16022	20	3	0	65205	\N
16022	2844	4	0	65206	\N
16032	192	0	0	65262	\N
16047	64	3	0	65340	\N
16047	4217	4	0	65341	\N
16052	140	6	0	62974	\N
16052	4086	7	0	65374	\N
16054	140	117	0	62974	\N
16054	4715	118	0	65378	\N
16057	60	7	0	65399	\N
16057	4613	8	0	65400	\N
16059	4178	4	0	65386	\N
16059	4205	5	0	65387	\N
16062	79	4	0	64596	\N
16062	3678	5	0	65409	\N
16066	170	4	0	65432	\N
16066	4680	5	0	65433	\N
16078	424	1	0	65375	\N
16078	425	2	0	65480	\N
16080	4	3	0	61998	\N
16080	3837	4	0	65487	\N
16084	266	2	0	63783	\N
16084	3235	3	0	65497	\N
16087	142	3	0	65506	\N
16087	4254	4	0	65507	\N
16088	353	4	0	65504	\N
16088	4724	5	0	65509	\N
16090	4178	22	0	65553	\N
16090	4725	23	0	65554	\N
16102	3053	2	0	65637	\N
16102	102	4	0	65640	\N
16102	3197	5	0	65641	\N
16107	362	3	0	62888	\N
16107	3658	4	0	65659	\N
16109	214	3	0	65661	\N
16109	3496	4	0	65662	\N
16115	94	3	0	64872	\N
16115	2864	4	0	65710	\N
16120	92	4	0	64989	\N
16120	3979	5	0	65739	\N
16122	62	3	0	61057	\N
16122	3344	4	0	63248	\N
16125	75	7	0	65766	\N
16125	2859	8	0	65767	\N
16128	71	3	0	65779	\N
16128	3770	4	0	65780	\N
16132	367	2	0	65801	\N
16132	3329	3	0	65802	\N
16137	56	0	0	65575	\N
16144	4178	3	0	65729	\N
16144	4211	4	0	65863	\N
16149	14	3	0	65883	\N
16149	4272	4	0	65884	\N
16156	16	3	0	65891	\N
16156	3634	4	0	65921	\N
16158	4172	3	0	65928	\N
16158	4275	4	0	65929	\N
16162	4172	4	0	65928	\N
16162	4219	5	0	65939	\N
16167	38	3	0	61977	\N
16167	3457	4	0	65900	\N
16172	1440	4	0	16735	\N
16172	4744	5	0	65987	\N
16176	18	3	0	66046	\N
16176	3621	4	0	66047	\N
16186	12	11	0	61244	\N
16186	4751	12	0	66093	\N
16188	268	4	0	66101	\N
16188	3897	5	0	66102	\N
16190	167	2	0	60883	\N
16190	2260	3	0	66103	\N
16193	2	4	0	66138	\N
16193	3510	5	0	66139	\N
16200	841	3	0	65717	\N
16200	3604	4	0	66166	\N
16202	82	2	0	62493	\N
16202	4753	3	0	66176	\N
16205	4172	6	0	66188	\N
16205	4365	7	0	66189	\N
16209	77	3	0	66220	\N
16209	1877	4	0	66221	\N
16212	4178	5	0	66249	\N
16212	4429	6	0	66250	\N
16214	110	7	0	63667	\N
16214	4758	8	0	66256	\N
16217	1914	3	0	66275	\N
16217	3637	4	0	66276	\N
16219	16	4	0	65891	\N
16219	3546	5	0	65892	\N
16224	449	8	0	66321	\N
16224	4762	9	0	66322	\N
16229	4233	3	0	60910	\N
16229	4425	4	0	60911	\N
16232	260	3	0	66367	\N
16232	3399	4	0	66368	\N
16236	300	4	0	65495	\N
16236	4770	5	0	66380	\N
16239	62	61	0	61057	\N
16239	4773	62	0	66394	\N
16243	4178	3	0	66412	\N
16243	4211	4	0	66413	\N
16245	18	4	0	66421	\N
16245	2302	5	0	66422	\N
16248	79	2	0	64596	\N
16248	616	3	0	66428	\N
16251	279	2	0	61894	\N
16191	167	7	0	60883	\N
16191	4147	8	0	66117	\N
16197	841	3	0	65717	\N
16197	3604	4	0	66166	\N
16201	360	3	0	66174	\N
16201	3602	4	0	66175	\N
16218	4178	4	0	66249	\N
16218	4205	5	0	66283	\N
16220	449	3	0	49396	\N
16220	4760	4	0	66289	\N
16223	3328	3	0	66305	\N
16223	110	8	0	66310	\N
16223	4761	9	0	66311	\N
16227	58	7	0	63245	\N
16227	4764	8	0	66341	\N
16233	4766	3	0	66369	\N
16233	4767	4	0	66370	\N
16235	258	14	0	63687	\N
16235	4769	15	0	66374	\N
16238	62	5	0	61057	\N
16238	4772	6	0	66390	\N
16240	4774	7	0	66395	\N
16240	38	29	0	66398	\N
16240	4775	30	0	66399	\N
16242	75	3	0	66177	\N
16242	3855	4	0	66178	\N
16244	266	4	0	63783	\N
16244	4100	5	0	66420	\N
16249	208	2	0	61223	\N
16249	4524	3	0	61893	\N
16253	79	4	0	64596	\N
16253	3678	5	0	65409	\N
16256	92	3	0	66456	\N
16256	4410	4	0	66457	\N
16258	4779	54	0	66459	\N
16258	451	126	0	66497	\N
16258	4780	127	0	66498	\N
16262	62	7	0	66518	\N
16262	4781	8	0	66525	\N
16265	18	3	0	66548	\N
16265	3621	4	0	66549	\N
16267	64	0	0	66550	\N
16271	262	8	0	65169	\N
16271	4093	9	0	66601	\N
16274	391	3	0	66611	\N
16274	3660	4	0	66612	\N
16280	147	4	0	50234	\N
16280	3877	5	0	52074	\N
16287	88	2	0	66645	\N
16287	2799	3	0	66646	\N
16289	88	2	0	66645	\N
16289	2799	3	0	66646	\N
16291	908	2	0	63236	\N
16291	2832	3	0	66655	\N
16294	42	6	0	63188	\N
16294	1090	7	0	63189	\N
16296	123	4	0	66738	\N
16296	4090	5	0	66739	\N
16301	214	3	0	66761	\N
16301	3496	4	0	66762	\N
16306	4789	23	0	66779	\N
16306	90	96	0	66791	\N
16306	4790	97	0	66792	\N
16308	14	7	0	66810	\N
16308	3882	8	0	66811	\N
16311	71	7	0	66815	\N
16311	4793	8	0	66816	\N
16315	2578	6	0	66839	\N
16315	4795	7	0	66840	\N
16318	288	5	0	63249	\N
16318	4798	6	0	66850	\N
16322	18	3	0	66868	\N
16322	3621	4	0	66869	\N
16325	16	3	0	66886	\N
16325	3634	4	0	66887	\N
16329	4178	21	0	66938	\N
16329	4802	22	0	66939	\N
16334	353	4	0	66958	\N
16334	4724	5	0	66959	\N
16339	4178	4	0	66992	\N
16342	4178	3	0	67013	\N
16342	4211	4	0	67014	\N
16344	33	4	0	67022	\N
16344	4806	5	0	67023	\N
16352	125	14	0	65465	\N
16352	4807	15	0	67067	\N
16363	40	2	0	67137	\N
16363	282	3	0	67138	\N
16365	40	11	0	67137	\N
16365	4813	12	0	67161	\N
16370	453	3	0	67182	\N
16370	2838	4	0	67183	\N
16372	51	4	0	65818	\N
16372	3975	5	0	67192	\N
16375	391	7	0	67217	\N
16375	3662	8	0	67218	\N
16378	75	3	0	66177	\N
16378	3855	4	0	66178	\N
16380	4172	6	0	67238	\N
16380	4197	7	0	67239	\N
16383	4178	3	0	67253	\N
16383	4211	4	0	67254	\N
16391	151	4	0	67311	\N
16391	3499	5	0	67312	\N
16393	367	2	0	65801	\N
16393	3065	3	0	67320	\N
16398	58	8	0	63245	\N
16398	4820	9	0	67355	\N
16400	488	3	0	67362	\N
16400	1103	4	0	67363	\N
16403	4172	3	0	67337	\N
16403	4275	4	0	67338	\N
16405	79	3	0	66649	\N
16405	3652	4	0	66650	\N
16408	62	3	0	66546	\N
16408	3344	4	0	66547	\N
16413	4178	4	0	67429	\N
16413	4205	5	0	67430	\N
16417	79	2	0	67439	\N
16417	3180	3	0	67441	\N
16419	4172	4	0	67427	\N
16419	4252	5	0	67449	\N
16421	214	4	0	67457	\N
16421	3807	5	0	67458	\N
16426	4178	4	0	67429	\N
16426	4205	5	0	67430	\N
16428	2	4	0	67486	\N
16428	3510	5	0	67487	\N
16433	320	7	0	67506	\N
16433	4827	8	0	67507	\N
16438	102	2	0	67030	\N
16438	3574	3	0	67545	\N
16440	244	3	0	65185	\N
16440	4075	4	0	65186	\N
16446	27	10	0	65176	\N
16446	4830	11	0	67592	\N
16449	18	7	0	67612	\N
16449	1618	8	0	67613	\N
16451	4178	8	0	67632	\N
16451	4237	9	0	67633	\N
16461	260	3	0	66367	\N
16461	3399	4	0	66368	\N
16463	324	2	0	67730	\N
16463	2808	3	0	67731	\N
16470	4178	3	0	67756	\N
16470	4211	4	0	67757	\N
16472	1316	10	0	67760	\N
16472	4836	11	0	67761	\N
16479	597	3	0	67791	\N
16479	3656	4	0	67792	\N
16485	1470	3	0	67834	\N
16485	4843	4	1	67835	\N
16485	4842	4	0	67836	\N
16491	4178	4	0	67861	\N
16491	4331	5	0	67862	\N
16207	1115	4	0	66193	\N
16208	285	11	0	64031	\N
16208	4756	12	0	66215	\N
16211	167	7	0	66238	\N
16211	4147	8	0	66239	\N
16216	268	3	0	66273	\N
16216	3815	4	0	66274	\N
16221	18	2	0	66054	\N
16221	1685	3	0	66294	\N
16228	58	10	0	63245	\N
16228	4765	11	0	66344	\N
16231	4172	2	0	66188	\N
16231	4191	3	0	66360	\N
16234	1376	3	0	15681	\N
16234	4768	4	0	66371	\N
16247	290	2	0	61140	\N
16247	1909	3	0	61141	\N
16250	228	2	0	66429	\N
16250	4776	3	0	66430	\N
16260	40	3	0	66507	\N
16260	372	4	0	66508	\N
16263	177	7	0	63616	\N
16263	3708	8	0	66540	\N
16268	4172	7	0	66505	\N
16268	4614	8	0	66562	\N
16277	597	4	0	55967	\N
16277	3733	5	0	55968	\N
16281	841	2	0	65717	\N
16281	3316	3	0	66633	\N
16284	82	3	0	66638	\N
16284	4505	4	0	66639	\N
16288	79	3	0	66649	\N
16288	3652	4	0	66650	\N
16290	88	3	0	66645	\N
16290	3655	4	0	66651	\N
16292	451	4	0	66662	\N
16292	3666	5	0	66663	\N
16297	94	3	0	66744	\N
16297	2864	4	0	66745	\N
16299	4788	4	0	66753	\N
16304	224	3	0	62709	\N
16304	3603	4	0	62995	\N
16309	56	7	0	66812	\N
16309	4791	8	0	66813	\N
16313	4178	3	0	66823	\N
16313	4211	4	0	66824	\N
16316	4088	5	0	61647	\N
16316	4796	6	0	66847	\N
16319	233	5	0	66851	\N
16319	4799	6	0	66852	\N
16320	4178	3	0	66857	\N
16320	4211	4	0	66858	\N
16323	1021	4	0	66157	\N
16323	4752	5	0	66158	\N
16328	268	6	0	66906	\N
16328	4801	7	0	66907	\N
16330	4172	21	0	66940	\N
16330	4803	22	0	66941	\N
16332	2351	4	0	66954	\N
16332	3494	5	0	66955	\N
16337	96	3	0	66981	\N
16337	2803	4	0	66982	\N
16340	113	4	0	67001	\N
16340	3677	5	0	67002	\N
16343	300	3	0	67015	\N
16343	3747	4	0	67016	\N
16345	4178	3	0	67028	\N
16345	4211	4	0	67029	\N
16347	268	3	0	67036	\N
16347	3815	4	0	67037	\N
16349	449	3	0	67040	\N
16349	4760	4	0	67041	\N
16353	451	10	0	67081	\N
16353	4808	11	0	67082	\N
16356	4	4	0	61998	\N
16356	4117	5	0	65168	\N
16358	40	4	0	67110	\N
16358	3381	5	0	67111	\N
16361	4766	4	0	67128	\N
16361	4811	5	0	67129	\N
16366	140	11	0	67170	\N
16366	4814	12	0	67171	\N
16368	121	2	0	67174	\N
16368	4815	3	0	67175	\N
16371	453	2	0	67182	\N
16371	3366	3	0	67184	\N
16373	132	5	0	67201	\N
16373	2717	6	0	67202	\N
16376	140	3	0	67225	\N
16376	4149	4	0	67226	\N
16385	202	4	0	67263	\N
16385	3673	5	0	67264	\N
16388	16	7	0	67282	\N
16388	4723	8	0	67283	\N
16396	4172	3	0	67337	\N
16396	4275	4	0	67338	\N
16401	520	2	0	67368	\N
16401	424	8	0	67376	\N
16401	4000	9	0	67377	\N
16404	316	3	0	67383	\N
16404	4249	4	0	67384	\N
16406	320	3	0	67395	\N
16406	4821	4	0	67396	\N
16415	64	4	0	67433	\N
16415	3911	5	0	67434	\N
16422	75	4	0	66177	\N
16422	3959	5	0	67459	\N
16424	2	6	0	67471	\N
16424	4825	7	0	67472	\N
16427	75	4	0	66177	\N
16427	3959	5	0	67459	\N
16431	100	7	0	67047	\N
16431	4826	8	0	67503	\N
16434	88	12	0	67528	\N
16434	4828	13	0	67529	\N
16436	51	4	0	67537	\N
16436	3975	5	0	67538	\N
16443	18	4	0	67564	\N
16443	2302	5	0	67565	\N
16452	391	8	0	67634	\N
16452	4831	9	0	67635	\N
16454	4833	31	0	67637	\N
16454	181	126	0	67674	\N
16454	4834	127	0	67675	\N
16456	96	3	0	67688	\N
16456	2803	4	0	67689	\N
16459	90	4	0	67716	\N
16459	3731	5	0	67717	\N
16464	2982	2	0	61780	\N
16464	3383	3	0	67732	\N
16466	192	4	0	67746	\N
16466	3895	5	0	67747	\N
16468	56	4	0	66812	\N
16468	3127	5	0	67749	\N
16471	75	3	0	67758	\N
16471	3855	4	0	67759	\N
16477	4172	3	0	67783	\N
16477	4275	4	0	67784	\N
16480	595	3	0	66088	\N
16480	3654	4	0	67405	\N
16486	23	3	0	67837	\N
16486	3497	4	0	67838	\N
16488	4178	3	0	67840	\N
16488	4211	4	0	67841	\N
16489	212	3	0	67846	\N
16489	3639	4	0	67847	\N
16492	40	4	0	67863	\N
16492	2796	5	0	67864	\N
16495	115	4	0	66190	\N
16495	4844	5	0	67882	\N
16498	785	4	0	11973	\N
16498	4846	5	0	67915	\N
16503	4178	8	0	67945	\N
16503	4237	9	0	67946	\N
16509	90	7	0	67988	\N
16509	4849	8	0	67989	\N
16213	110	6	0	63667	\N
16213	3917	7	0	66253	\N
16215	365	6	0	66267	\N
16215	4759	7	0	66268	\N
16222	2995	3	0	66300	\N
16222	110	4	0	66301	\N
16225	345	3	0	66329	\N
16225	4763	4	0	66330	\N
16226	391	7	0	65816	\N
16226	3662	8	0	65817	\N
16230	320	4	0	62359	\N
16230	3824	5	0	66356	\N
16237	38	5	0	66388	\N
16237	4771	6	0	66389	\N
16241	316	3	0	66405	\N
16241	4249	4	0	66406	\N
16246	4178	2	0	66426	\N
16246	4247	3	0	66427	\N
16252	64	3	0	66435	\N
16252	4217	4	0	66436	\N
16255	451	3	0	66454	\N
16255	3934	4	0	66455	\N
16259	4172	3	0	66505	\N
16259	4275	4	0	66506	\N
16269	16	3	0	65891	\N
16269	3634	4	0	65921	\N
16270	4178	13	0	66426	\N
16270	4782	14	0	66588	\N
16273	6	8	0	61533	\N
16273	4784	9	0	66604	\N
16276	108	4	0	66625	\N
16276	4060	5	0	66626	\N
16279	40	4	0	66628	\N
16279	3381	5	0	66629	\N
16283	841	3	0	65717	\N
16283	3604	4	0	66166	\N
16285	38	3	0	66388	\N
16285	3457	4	0	66640	\N
16293	4785	54	0	66706	\N
16293	451	126	0	66718	\N
16293	4786	127	0	66719	\N
16298	58	3	0	63245	\N
16298	3665	4	0	63246	\N
16300	18	3	0	66754	\N
16300	3621	4	0	66755	\N
16303	94	3	0	66770	\N
16303	2864	4	0	66771	\N
16305	90	3	0	66777	\N
16305	4074	4	0	66778	\N
16307	4172	3	0	66798	\N
16307	4275	4	0	66799	\N
16310	367	7	0	65801	\N
16310	4792	8	0	66814	\N
16314	6	4	0	61533	\N
16314	3487	5	0	66830	\N
16317	173	5	0	66848	\N
16317	4797	6	0	66849	\N
16324	16	3	0	66880	\N
16324	3634	4	0	66881	\N
16327	64	4	0	66894	\N
16327	3911	5	0	66895	\N
16331	4178	3	0	66947	\N
16331	4211	4	0	66948	\N
16336	326	4	0	62914	\N
16336	3519	5	0	66975	\N
16341	164	3	0	66636	\N
16341	3385	4	0	66637	\N
16351	100	3	0	67047	\N
16351	3836	4	0	67048	\N
16355	4178	3	0	67098	\N
16355	4211	4	0	67099	\N
16357	908	4	0	67108	\N
16357	3488	5	0	67109	\N
16360	1376	4	0	15681	\N
16360	4810	5	0	67127	\N
16362	18	3	0	67135	\N
16362	3621	4	0	67136	\N
16367	121	2	0	67174	\N
16367	4815	3	0	67175	\N
16379	244	3	0	65185	\N
16379	4075	4	0	65186	\N
16382	2351	3	0	66954	\N
16382	2845	4	0	67252	\N
16387	198	3	0	66167	\N
16387	4263	4	0	66168	\N
16390	4	4	0	67309	\N
16390	4117	5	0	67310	\N
16392	181	7	0	67318	\N
16392	4137	8	0	67319	\N
16395	206	10	0	63466	\N
16395	4819	11	0	67331	\N
16397	18	3	0	67339	\N
16397	3621	4	0	67340	\N
16402	520	2	0	67368	\N
16402	424	8	0	67376	\N
16402	4000	9	0	67377	\N
16407	147	2	0	50234	\N
16407	3287	3	0	67400	\N
16410	595	3	0	66088	\N
16410	3654	4	0	67405	\N
16412	4172	4	0	67427	\N
16412	4219	5	0	67428	\N
16414	132	4	0	67431	\N
16414	3716	5	0	67432	\N
16416	79	3	0	67439	\N
16416	3652	4	0	67440	\N
16418	6	3	0	67442	\N
16418	4823	4	0	67443	\N
16423	528	6	0	67469	\N
16423	4824	7	0	67470	\N
16430	4172	4	0	67490	\N
16430	4219	5	0	67491	\N
16435	336	4	0	67360	\N
16435	3947	5	0	67536	\N
16442	16	3	0	67473	\N
16442	3634	4	0	67556	\N
16445	198	10	0	66167	\N
16445	4829	11	0	67591	\N
16448	4178	7	0	67610	\N
16448	4396	8	0	67611	\N
16450	4172	3	0	67490	\N
16450	4275	4	0	67618	\N
16453	241	8	0	63833	\N
16453	4832	9	0	67636	\N
16455	4178	3	0	67682	\N
16455	4211	4	0	67683	\N
16458	16	10	0	67708	\N
16458	4835	11	0	67709	\N
16465	4178	3	0	67737	\N
16465	4211	4	0	67738	\N
16467	1636	4	0	59885	\N
16467	4118	5	0	67748	\N
16474	198	3	0	67769	\N
16474	4263	4	0	67770	\N
16476	71	4	0	66815	\N
16476	3887	5	0	67778	\N
16484	1470	3	0	67834	\N
16484	4843	4	1	67835	\N
16484	4842	4	0	67836	\N
16487	1470	3	0	67834	\N
16487	3838	4	0	67839	\N
16493	23	6	0	67837	\N
16493	4632	7	0	67875	\N
16499	4847	5	0	67923	\N
16502	391	8	0	67634	\N
16502	4831	9	0	67635	\N
16507	244	11	0	67973	\N
16507	4848	12	0	67974	\N
16511	4850	4	0	68024	\N
16511	4851	4	0	68025	\N
16511	3678	5	0	68026	\N
16514	954	4	0	68032	\N
16514	4855	5	1	68033	\N
16514	4842	5	0	68034	\N
16523	30	9	0	68065	\N
16523	4859	10	0	68066	\N
16251	4525	3	0	61895	\N
16254	2647	3	0	66448	\N
16254	4777	4	0	66449	\N
16257	262	3	0	65169	\N
16257	4778	4	0	66458	\N
16261	62	5	0	66518	\N
16261	4422	6	0	66519	\N
16264	62	3	0	66546	\N
16264	3344	4	0	66547	\N
16266	908	0	0	63236	\N
16272	413	8	0	66602	\N
16272	4783	9	0	66603	\N
16275	322	3	0	66617	\N
16275	1105	4	0	66618	\N
16278	595	4	0	66088	\N
16278	3878	5	0	66627	\N
16282	164	3	0	66636	\N
16282	3385	4	0	66637	\N
16295	86	4	0	66736	\N
16295	4052	5	0	66737	\N
16302	40	3	0	66628	\N
16302	372	4	0	66769	\N
16312	451	7	0	66817	\N
16312	4794	8	0	66818	\N
16321	14	2	0	66810	\N
16321	1785	3	0	66862	\N
16326	228	4	0	66429	\N
16326	4800	5	0	66893	\N
16333	4178	4	0	66956	\N
16333	4205	5	0	66957	\N
16335	4178	6	0	66956	\N
16335	4804	7	0	66969	\N
16338	2636	3	0	61811	\N
16338	2837	4	0	64688	\N
16346	102	3	0	67030	\N
16346	3597	4	0	67031	\N
16348	290	3	0	67038	\N
16348	3635	4	0	67039	\N
16350	360	3	0	66174	\N
16350	3602	4	0	66175	\N
16354	123	6	0	67092	\N
16354	4809	7	0	67093	\N
16359	4172	6	0	66940	\N
16359	4197	7	0	67120	\N
16364	4	4	0	61998	\N
16364	4812	5	0	67147	\N
16369	121	2	0	67174	\N
16369	4815	3	0	67175	\N
16374	30	17	0	61826	\N
16374	4816	18	0	67203	\N
16377	164	3	0	67227	\N
16377	3385	4	0	67228	\N
16381	4178	3	0	67245	\N
16381	4211	4	0	67246	\N
16384	251	3	0	67255	\N
16384	3514	4	0	67256	\N
16386	4	3	0	67269	\N
16386	3837	4	0	67270	\N
16389	290	11	0	67038	\N
16389	4817	12	0	67301	\N
16394	367	10	0	65801	\N
16394	4818	11	0	67330	\N
16399	336	3	0	67360	\N
16399	3400	4	0	67361	\N
16409	597	3	0	67403	\N
16409	3656	4	0	67404	\N
16411	672	6	0	67418	\N
16411	4822	7	0	67419	\N
16420	4178	4	0	67429	\N
16420	4205	5	0	67430	\N
16425	16	6	0	67473	\N
16425	3369	7	0	67474	\N
16429	4178	4	0	67488	\N
16429	4205	5	0	67489	\N
16432	4178	7	0	67504	\N
16432	4396	8	0	67505	\N
16437	102	3	0	67030	\N
16437	3597	4	0	67031	\N
16439	353	3	0	67549	\N
16439	3766	4	0	67550	\N
16441	353	2	0	67549	\N
16441	3134	3	0	67551	\N
16444	4450	1	0	67568	\N
16444	4178	4	0	67573	\N
16444	4527	5	0	67574	\N
16447	431	2	0	67596	\N
16447	2772	3	0	67597	\N
16457	102	3	0	67690	\N
16457	3597	4	0	67691	\N
16460	16	4	0	67718	\N
16460	3546	5	0	67719	\N
16462	40	3	0	67137	\N
16462	372	4	0	67725	\N
16469	44	4	0	65473	\N
16469	3486	5	0	67750	\N
16473	18	3	0	67612	\N
16473	3621	4	0	67768	\N
16475	1316	3	0	67760	\N
16475	4837	4	0	67771	\N
16478	147	3	0	50234	\N
16478	3657	4	0	55954	\N
16481	262	3	0	65169	\N
16481	4778	4	0	66458	\N
16482	4838	4	0	67799	\N
16482	4839	5	0	67800	\N
16483	4840	3	0	67807	\N
16483	4178	15	0	67826	\N
16483	4841	16	0	67827	\N
16490	108	4	0	66625	\N
16490	4060	5	0	66626	\N
16496	224	13	0	62709	\N
16496	4845	14	0	67902	\N
16501	4178	3	0	67931	\N
16501	4211	4	0	67932	\N
16504	40	8	0	67863	\N
16504	3503	9	0	67947	\N
16506	18	3	0	67612	\N
16506	3621	4	0	67768	\N
16513	79	4	0	68030	\N
16513	3678	5	0	68031	\N
16519	79	4	0	68052	\N
16519	3678	5	0	68053	\N
16522	4172	4	0	68062	\N
16522	4219	5	0	68063	\N
16526	42	5	0	68084	\N
16526	4860	6	0	68085	\N
16530	235	3	0	64870	\N
16530	3343	4	0	65857	\N
16534	88	3	0	68125	\N
16534	3655	4	0	68126	\N
16537	123	3	0	68043	\N
16537	2856	4	0	68044	\N
16540	242	0	0	68130	\N
16543	402	0	0	68157	\N
16546	424	14	0	68161	\N
16546	4866	15	0	68162	\N
16550	4178	4	0	68158	\N
16550	4205	5	0	68171	\N
16558	75	3	0	67758	\N
16558	3855	4	0	67759	\N
16563	908	3	0	67108	\N
16563	3591	4	0	68246	\N
16565	75	4	0	67758	\N
16565	3959	5	0	68274	\N
16566	345	6	0	68287	\N
16566	4870	7	0	68288	\N
16570	40	14	0	67863	\N
16570	4871	15	0	68306	\N
16573	40	6	0	67863	\N
16573	4255	7	0	68317	\N
16575	40	4	0	68332	\N
16575	3381	5	0	68333	\N
16578	4178	10	0	68354	\N
16578	4665	11	0	68355	\N
16580	300	4	0	67015	\N
16580	2992	5	0	68366	\N
16583	18	6	0	68372	\N
16494	273	4	0	66063	\N
16494	3777	5	0	66064	\N
16497	12	3	0	61244	\N
16497	4204	4	0	67908	\N
16500	14	3	0	67929	\N
16500	4272	4	0	67930	\N
16505	4178	3	0	67952	\N
16505	4211	4	0	67953	\N
16508	4178	7	0	67952	\N
16508	4396	8	0	67987	\N
16512	4850	4	0	68024	\N
16512	4852	4	0	68027	\N
16512	4854	5	1	68028	\N
16512	4853	5	0	68029	\N
16516	202	3	0	68041	\N
16516	4857	4	0	68042	\N
16518	202	2	0	68041	\N
16518	2764	3	0	68046	\N
16520	411	4	0	62484	\N
16520	4858	5	0	68054	\N
16528	167	3	0	68105	\N
16528	4028	4	0	68106	\N
16539	242	0	0	68130	\N
16541	242	0	0	68130	\N
16545	402	14	0	68157	\N
16545	4865	15	0	68160	\N
16548	402	0	0	68157	\N
16551	135	4	0	52757	\N
16551	3696	5	0	55119	\N
16553	16	1	0	68175	\N
16553	1087	2	0	68176	\N
16557	40	3	0	67863	\N
16557	372	4	0	68218	\N
16559	156	3	0	68224	\N
16559	4594	4	0	68225	\N
16561	206	3	0	63466	\N
16561	4584	4	0	63467	\N
16564	4869	65	0	68266	\N
16564	326	70	0	68272	\N
16564	2939	71	0	68273	\N
16567	4172	4	0	68062	\N
16567	4252	5	0	68297	\N
16576	258	28	0	68336	\N
16576	4873	29	0	68337	\N
16582	353	6	0	67549	\N
16582	4876	7	0	68371	\N
16586	4878	63	0	68387	\N
16586	1096	126	0	68388	\N
16586	4879	127	0	68389	\N
16588	18	6	0	68372	\N
16588	4180	7	0	68373	\N
16591	285	2	0	68422	\N
16591	1709	3	0	68424	\N
16594	121	3	0	68433	\N
16594	4471	4	0	68434	\N
16595	258	4	0	68437	\N
16595	4881	5	0	68438	\N
16602	285	1	0	68468	\N
16602	3112	2	0	68469	\N
16610	353	28	0	68489	\N
16610	4883	29	0	68490	\N
16615	164	0	0	67227	\N
16622	94	3	0	66770	\N
16622	2864	4	0	66771	\N
16624	113	2	0	68547	\N
16624	1899	3	0	68548	\N
16626	18	3	0	68556	\N
16626	3621	4	0	68557	\N
16629	4887	121	0	68599	\N
16629	326	122	0	68600	\N
16636	145	6	0	68117	\N
16636	4889	7	0	68637	\N
16639	56	7	0	68657	\N
16639	4791	8	0	68658	\N
16641	132	4	0	68673	\N
16641	3716	5	0	68674	\N
16649	42	3	0	68717	\N
16649	3645	4	0	68718	\N
16654	119	7	0	62402	\N
16654	4891	8	0	68746	\N
16658	391	3	0	67634	\N
16658	3660	4	0	68763	\N
16659	279	9	0	61894	\N
16659	4892	10	0	68778	\N
16661	320	9	0	68780	\N
16661	4894	10	0	68781	\N
16663	4178	3	0	68790	\N
16663	4211	4	0	68791	\N
16670	4172	3	0	68817	\N
16670	4275	4	0	68818	\N
16679	40	3	0	68713	\N
16679	372	4	0	68714	\N
16683	4902	5	0	68887	\N
16683	173	8	0	68888	\N
16683	3179	9	0	68889	\N
16685	279	2	0	61894	\N
16685	4525	3	0	61895	\N
16686	1914	0	0	66275	\N
16699	132	3	0	69007	\N
16699	3729	4	0	69008	\N
16702	241	4	0	69022	\N
16702	4582	5	0	69023	\N
16708	235	3	0	64870	\N
16708	3343	4	0	65857	\N
16709	4917	63	0	69082	\N
16709	235	126	0	69088	\N
16709	4918	127	0	69089	\N
16713	165	1	0	69122	\N
16713	4920	2	0	69123	\N
16713	4921	2	0	69124	\N
16715	165	1	0	69122	\N
16715	164	4	0	69127	\N
16715	3085	5	0	69128	\N
16718	124	1	0	69125	\N
16718	123	4	0	69126	\N
16718	4862	5	0	68044	\N
16727	4172	5	0	69274	\N
16727	4415	6	0	69275	\N
16728	56	3	0	68657	\N
16728	4109	4	0	69282	\N
16734	58	4	0	69303	\N
16734	4213	5	0	69304	\N
16736	597	5	0	69316	\N
16736	4929	6	0	69317	\N
16741	260	8	0	66367	\N
16741	4933	9	0	69336	\N
16744	1852	1	0	25164	\N
16744	1853	2	0	25165	\N
16746	4172	10	0	69274	\N
16746	4663	11	0	69361	\N
16750	14	4	0	69294	\N
16750	2291	5	0	69373	\N
16752	841	3	0	65717	\N
16752	3604	4	0	66166	\N
16756	1324	3	0	69397	\N
16756	488	126	0	69437	\N
16756	4937	127	0	69438	\N
16759	4172	3	0	69274	\N
16759	4940	4	0	69448	\N
16765	167	2	0	69334	\N
16765	3322	3	0	69467	\N
16770	4944	7	0	69513	\N
16770	4945	8	0	69514	\N
16774	88	13	0	68125	\N
16774	4948	14	0	69554	\N
16776	56	3	0	69561	\N
16776	4109	4	0	69562	\N
16779	4172	3	0	69274	\N
16779	4275	4	0	69388	\N
16781	88	7	0	69601	\N
16781	4949	8	0	69602	\N
16787	135	3	0	52757	\N
16787	3630	4	0	56341	\N
16792	123	3	0	69653	\N
16792	2856	4	0	69654	\N
16794	241	3	0	69022	\N
16794	3613	4	0	69662	\N
16510	4179	4	0	67998	\N
16510	4178	17	0	68016	\N
16510	4441	18	0	68017	\N
16515	954	4	0	68032	\N
16515	4856	5	0	68035	\N
16517	123	3	0	68043	\N
16517	2856	4	0	68044	\N
16521	79	4	0	68052	\N
16521	3678	5	0	68053	\N
16525	132	3	0	67431	\N
16525	3729	4	0	68074	\N
16529	164	3	0	67227	\N
16529	3385	4	0	67228	\N
16531	145	7	0	68117	\N
16531	4861	8	0	68118	\N
16533	233	3	0	66851	\N
16533	3704	4	0	68124	\N
16536	4088	3	0	61647	\N
16536	4506	4	0	61648	\N
16542	77	14	0	68155	\N
16542	4863	15	0	68156	\N
16552	137	4	0	68172	\N
16552	3697	5	0	68173	\N
16554	4178	5	0	68158	\N
16554	4429	6	0	68185	\N
16555	86	13	0	66736	\N
16555	4868	14	0	68210	\N
16560	125	3	0	68226	\N
16560	4170	4	0	68227	\N
16562	4178	6	0	68240	\N
16562	4250	7	0	68241	\N
16568	137	4	0	68298	\N
16568	4352	5	0	68299	\N
16572	4172	8	0	68315	\N
16572	4500	9	0	68316	\N
16577	51	10	0	68352	\N
16577	4662	11	0	68353	\N
16589	4178	5	0	68354	\N
16589	4358	6	0	68413	\N
16598	4450	1	0	68451	\N
16598	4178	4	0	68456	\N
16598	4527	5	0	68457	\N
16600	143	1	0	68458	\N
16600	142	4	0	68459	\N
16600	3099	5	0	65507	\N
16603	285	3	0	68468	\N
16603	4496	4	0	68474	\N
16606	4787	3	0	68476	\N
16606	4788	4	0	68477	\N
16609	67	3	0	68482	\N
16609	3749	4	0	68483	\N
16613	4178	3	0	68510	\N
16613	4211	4	0	68511	\N
16616	164	3	0	67227	\N
16616	3385	4	0	67228	\N
16620	62	3	0	66546	\N
16620	3344	4	0	66547	\N
16623	4885	84	0	68538	\N
16623	591	102	0	68542	\N
16623	4886	103	0	68543	\N
16627	14	7	0	68571	\N
16627	3882	8	0	68572	\N
16632	262	5	0	65169	\N
16632	2828	6	0	68614	\N
16634	4172	4	0	68315	\N
16634	4219	5	0	68623	\N
16642	2351	0	0	66954	\N
16645	4178	15	0	68704	\N
16645	4570	16	0	68705	\N
16647	40	3	0	68713	\N
16647	372	4	0	68714	\N
16652	3625	7	0	68743	\N
16652	3626	8	0	68744	\N
16655	3628	7	0	68747	\N
16655	3629	8	0	68748	\N
16656	449	7	0	67040	\N
16656	801	8	0	68749	\N
16660	208	9	0	61223	\N
16660	4893	10	0	68779	\N
16666	2782	4	0	68802	\N
16666	3872	5	0	68803	\N
16668	40	7	0	68713	\N
16668	4718	8	0	68812	\N
16671	242	3	0	68130	\N
16671	2839	4	0	68819	\N
16673	793	6	0	68829	\N
16673	3719	7	0	68830	\N
16680	67	3	0	68482	\N
16680	3749	4	0	68483	\N
16687	1601	3	0	68894	\N
16687	488	126	0	68897	\N
16687	4903	127	0	68898	\N
16689	132	7	0	68939	\N
16689	3709	8	0	68940	\N
16694	79	2	0	68970	\N
16694	616	3	0	68971	\N
16697	453	3	0	68993	\N
16697	2838	4	0	68994	\N
16700	73	2	0	69012	\N
16700	2766	3	0	69013	\N
16707	4910	19	0	69049	\N
16707	353	123	0	69069	\N
16707	4911	124	1	69070	\N
16707	4498	124	0	69071	\N
16707	4913	125	1	69072	\N
16707	4912	125	0	69073	\N
16707	4914	126	1	69074	\N
16707	2466	126	0	69075	\N
16707	4916	127	1	69076	\N
16707	4915	127	0	69077	\N
16710	18	10	0	69107	\N
16710	4919	11	0	69108	\N
16719	165	1	0	69122	\N
16719	164	4	0	69127	\N
16719	3085	5	0	69128	\N
16724	189	7	0	69260	\N
16724	4927	8	0	69261	\N
16729	367	0	0	69283	\N
16730	4178	2	0	69047	\N
16730	4247	3	0	69287	\N
16732	14	3	0	69294	\N
16732	4272	4	0	69295	\N
16735	4178	4	0	69305	\N
16735	4205	5	0	69306	\N
16737	595	5	0	66088	\N
16737	4930	6	0	69318	\N
16742	145	8	0	69030	\N
16742	4934	9	0	69337	\N
16747	3628	10	0	68747	\N
16747	3671	11	0	69362	\N
16751	4178	4	0	69374	\N
16751	4331	5	0	69375	\N
16755	117	3	0	69395	\N
16755	3653	4	0	69396	\N
16760	4178	3	0	69449	\N
16760	4941	4	0	69450	\N
16761	1470	3	0	67834	\N
16761	3838	4	0	67839	\N
16766	69	2	0	68402	\N
16766	3350	3	0	69468	\N
16771	326	7	0	69515	\N
16771	4946	8	0	69516	\N
16772	4947	126	0	69527	\N
16772	326	127	0	69528	\N
16782	4172	7	0	69274	\N
16782	4614	8	0	69603	\N
16784	4951	18	1	69606	\N
16784	4950	18	0	69607	\N
16784	4916	19	1	69608	\N
16784	4952	19	0	69609	\N
16784	353	66	0	69625	\N
16784	3693	67	1	69626	\N
16784	4953	67	0	69627	\N
16797	4178	11	0	69552	\N
16797	4957	12	0	69691	\N
16799	360	3	0	69698	\N
16799	3602	4	0	69699	\N
16524	40	4	0	67863	\N
16524	3381	5	0	68067	\N
16527	79	7	0	68097	\N
16527	4063	8	0	68098	\N
16532	16	7	0	67718	\N
16532	4723	8	0	68119	\N
16535	23	3	0	68127	\N
16535	3497	4	0	68128	\N
16538	123	2	0	68043	\N
16538	4862	3	0	68129	\N
16544	4178	14	0	68158	\N
16544	4864	15	0	68159	\N
16547	206	6	0	63466	\N
16547	4867	7	0	68163	\N
16556	2636	3	0	68216	\N
16556	2837	4	0	68217	\N
16569	135	4	0	52757	\N
16569	4353	5	0	58849	\N
16571	228	8	0	66429	\N
16571	4872	9	0	68314	\N
16574	40	5	0	68323	\N
16574	2714	6	0	68324	\N
16579	75	10	0	68356	\N
16579	4874	11	0	68357	\N
16581	300	6	0	67015	\N
16581	4875	7	0	68370	\N
16584	353	12	0	67549	\N
16584	4653	13	0	68375	\N
16585	1096	8	0	39831	\N
16585	4877	9	0	68386	\N
16590	285	5	0	68422	\N
16590	4880	6	0	68423	\N
16593	151	3	0	68431	\N
16593	3046	4	0	68432	\N
16597	96	5	0	68447	\N
16597	4882	6	0	68448	\N
16601	411	3	0	68465	\N
16601	3596	4	0	68466	\N
16605	4172	3	0	68315	\N
16605	4275	4	0	68475	\N
16608	56	3	0	68480	\N
16608	4109	4	0	68481	\N
16612	151	3	0	68431	\N
16612	3046	4	0	68432	\N
16617	164	0	0	67227	\N
16619	56	4	0	68480	\N
16619	3373	5	0	68530	\N
16621	591	3	0	68536	\N
16621	4884	4	0	68537	\N
16631	262	6	0	65169	\N
16631	4888	7	0	68613	\N
16633	60	4	0	68621	\N
16633	3894	5	0	68622	\N
16635	198	4	0	68624	\N
16635	4161	5	0	68625	\N
16638	4178	7	0	68655	\N
16638	4396	8	0	68656	\N
16643	4178	0	0	68675	\N
16644	16	12	0	68695	\N
16644	4890	13	0	68696	\N
16646	4178	3	0	68704	\N
16646	4211	4	0	68706	\N
16648	4172	3	0	68715	\N
16648	4275	4	0	68716	\N
16651	56	6	0	68657	\N
16651	4703	7	0	68731	\N
16653	336	7	0	67360	\N
16653	3690	8	0	68745	\N
16665	4896	3	0	68794	\N
16665	4897	4	0	68795	\N
16667	167	3	0	68810	\N
16667	4028	4	0	68811	\N
16672	56	6	0	68657	\N
16672	4703	7	0	68731	\N
16675	528	7	0	67469	\N
16675	4899	8	0	68843	\N
16677	75	7	0	68356	\N
16677	2859	8	0	68844	\N
16682	4415	5	0	68880	\N
16682	4172	8	0	68884	\N
16682	3108	9	1	68885	\N
16682	4901	9	0	68886	\N
16688	1914	16	0	66275	\N
16688	4904	17	0	68926	\N
16691	113	7	0	68956	\N
16691	4906	8	0	68957	\N
16693	431	3	0	68965	\N
16693	3933	4	0	68966	\N
16695	40	2	0	68972	\N
16695	282	3	0	68973	\N
16696	241	9	0	63833	\N
16696	4907	10	0	68987	\N
16701	4172	4	0	69020	\N
16701	4219	5	0	69021	\N
16704	40	3	0	69032	\N
16704	372	4	0	69033	\N
16712	187	1	0	63264	\N
16712	186	4	0	69120	\N
16712	3068	5	0	69121	\N
16717	187	1	0	63264	\N
16717	186	4	0	69120	\N
16717	3068	5	0	69121	\N
16721	4923	56	0	69162	\N
16721	54	126	0	69230	\N
16721	4924	127	0	69231	\N
16723	266	7	0	63783	\N
16723	4926	8	0	69259	\N
16726	528	5	0	67469	\N
16726	4542	6	0	69273	\N
16739	147	5	0	50234	\N
16739	4932	6	0	69321	\N
16740	167	8	0	69334	\N
16740	4502	9	0	69335	\N
16743	4935	68	0	69340	\N
16743	1852	126	0	69341	\N
16743	4936	127	0	69342	\N
16745	3625	10	0	68743	\N
16745	3669	11	0	69360	\N
16749	528	4	0	69371	\N
16749	3353	5	0	69372	\N
16754	4172	3	0	69274	\N
16754	4275	4	0	69388	\N
16758	2592	3	0	69446	\N
16758	4939	4	0	69447	\N
16763	4178	3	0	69457	\N
16763	4211	4	0	69458	\N
16764	4178	3	0	69457	\N
16764	4211	4	0	69458	\N
16767	1324	3	0	69472	\N
16767	488	64	0	69488	\N
16767	4942	65	0	69489	\N
16769	4943	3	0	69500	\N
16769	1890	4	0	69501	\N
16773	4178	13	0	69552	\N
16773	4782	14	0	69553	\N
16775	149	3	0	65873	\N
16775	4189	4	0	69560	\N
16778	23	3	0	69582	\N
16778	3497	4	0	69583	\N
16780	82	3	0	66638	\N
16780	4505	4	0	66639	\N
16789	137	3	0	68298	\N
16789	3633	4	0	69639	\N
16791	391	3	0	69651	\N
16791	3660	4	0	69652	\N
16793	18	3	0	69660	\N
16793	3621	4	0	69661	\N
16796	4	11	0	67309	\N
16796	4956	12	0	69690	\N
16801	115	4	0	69709	\N
16801	4844	5	0	69710	\N
16803	38	3	0	69717	\N
16803	3457	4	0	69718	\N
16810	367	8	0	69744	\N
16810	4959	9	0	69745	\N
16812	1109	11	0	65974	\N
16812	4961	12	1	69765	\N
16583	4180	7	0	68373	\N
16587	69	6	0	68402	\N
16587	4084	7	0	68403	\N
16592	2	3	0	67486	\N
16592	3548	4	0	68430	\N
16596	14	5	0	67929	\N
16596	2720	6	0	68446	\N
16599	143	1	0	68458	\N
16599	142	4	0	68459	\N
16599	3099	5	0	65507	\N
16604	353	3	0	67549	\N
16604	3766	4	0	67550	\N
16607	142	3	0	68478	\N
16607	4254	4	0	68479	\N
16611	4178	6	0	68498	\N
16611	4250	7	0	68499	\N
16614	86	4	0	68519	\N
16614	4052	5	0	68520	\N
16618	164	0	0	67227	\N
16625	451	3	0	68554	\N
16625	3934	4	0	68555	\N
16628	2636	3	0	68577	\N
16628	2837	4	0	68578	\N
16630	40	3	0	68602	\N
16630	372	4	0	68603	\N
16637	4172	3	0	68315	\N
16637	4275	4	0	68475	\N
16640	360	3	0	68664	\N
16640	3602	4	0	68665	\N
16650	18	6	0	68729	\N
16650	4180	7	0	68730	\N
16657	212	3	0	68756	\N
16657	3639	4	0	68757	\N
16662	367	24	0	68782	\N
16662	4895	25	0	68783	\N
16664	367	3	0	68792	\N
16664	3683	4	0	68793	\N
16669	4178	3	0	68790	\N
16669	4211	4	0	68791	\N
16674	202	7	0	68841	\N
16674	4898	8	0	68842	\N
16676	100	7	0	67047	\N
16676	4826	8	0	67503	\N
16678	4172	3	0	68849	\N
16678	4275	4	0	68850	\N
16681	62	10	0	66546	\N
16681	4900	11	0	68871	\N
16684	208	2	0	61223	\N
16684	4524	3	0	61893	\N
16690	108	7	0	68954	\N
16690	4905	8	0	68955	\N
16692	4172	7	0	68849	\N
16692	4614	8	0	68958	\N
16698	4178	4	0	68790	\N
16698	4205	5	0	69002	\N
16703	145	3	0	69030	\N
16703	4908	4	0	69031	\N
16705	353	7	0	67549	\N
16705	4909	8	0	69046	\N
16706	4178	7	0	69047	\N
16706	4396	8	0	69048	\N
16711	23	3	0	68127	\N
16711	3497	4	0	68128	\N
16714	124	1	0	69125	\N
16714	123	4	0	69126	\N
16714	4862	5	0	68044	\N
16716	187	1	0	63264	\N
16716	186	4	0	69120	\N
16716	3068	5	0	69121	\N
16720	54	7	0	64766	\N
16720	4922	8	0	69139	\N
16722	4925	43	0	69250	\N
16722	273	44	0	69251	\N
16725	51	5	0	69271	\N
16725	4928	6	0	69272	\N
16731	367	2	0	68792	\N
16731	3329	3	0	69288	\N
16733	4178	3	0	69047	\N
16733	4211	4	0	69296	\N
16738	73	5	0	69319	\N
16738	4931	6	0	69320	\N
16748	119	10	0	62402	\N
16748	3670	11	0	69363	\N
16753	300	3	0	69386	\N
16753	3747	4	0	69387	\N
16757	2594	3	0	41496	\N
16757	4938	4	0	69445	\N
16762	4233	3	0	69455	\N
16762	4425	4	0	69456	\N
16768	266	4	0	63783	\N
16768	4100	5	0	66420	\N
16777	113	7	0	68956	\N
16777	4906	8	0	68957	\N
16783	353	7	0	69604	\N
16783	4909	8	0	69605	\N
16785	113	3	0	69633	\N
16785	3620	4	0	69634	\N
16786	30	18	0	69635	\N
16786	4954	19	0	69636	\N
16788	244	3	0	69637	\N
16788	4075	4	0	69638	\N
16790	142	3	0	68478	\N
16790	4254	4	0	68479	\N
16795	79	4	0	68970	\N
16795	4955	5	0	69670	\N
16798	56	11	0	69561	\N
16798	4958	12	0	69692	\N
16800	100	4	0	69707	\N
16800	3776	5	0	69708	\N
16802	4172	3	0	69274	\N
16802	4275	4	0	69388	\N
16805	92	3	0	66456	\N
16805	4410	4	0	66457	\N
16807	67	2	0	69731	\N
16807	394	3	0	69732	\N
16809	16	0	0	69741	\N
16814	1109	11	0	65974	\N
16814	4966	12	0	69771	\N
16819	4172	2	0	69800	\N
16819	4191	3	0	69801	\N
16824	391	2	0	69776	\N
16824	1381	3	0	69777	\N
16826	320	4	0	69823	\N
16826	3824	5	0	69824	\N
16831	528	3	0	69371	\N
16831	4262	4	0	69839	\N
16835	4178	4	0	69552	\N
16835	4205	5	0	69851	\N
16837	4	2	0	67309	\N
16837	2751	3	0	69859	\N
16842	4178	3	0	69552	\N
16842	4211	4	0	69808	\N
16844	90	3	0	67988	\N
16844	4074	4	0	69890	\N
16846	82	3	0	69896	\N
16846	4505	4	0	69897	\N
16852	119	3	0	69921	\N
16852	2860	4	0	69922	\N
16855	4971	19	0	69926	\N
16855	262	81	0	69941	\N
16855	4972	82	0	69942	\N
16856	170	0	0	65432	\N
16859	170	0	0	65432	\N
16862	170	0	0	65432	\N
16875	100	4	0	69707	\N
16875	3776	5	0	69708	\N
16877	4172	4	0	70096	\N
16877	4219	5	0	70097	\N
16878	102	0	0	67690	\N
16880	198	3	0	70124	\N
16880	4263	4	0	70125	\N
16885	4979	126	0	70154	\N
16885	273	127	0	70155	\N
16894	4172	4	0	70191	\N
16894	4219	5	0	70192	\N
16896	173	7	0	70206	\N
16896	4982	8	0	70207	\N
16804	4	3	0	67309	\N
16804	3837	4	0	69724	\N
16806	71	2	0	69729	\N
16806	1125	3	0	69730	\N
16816	206	2	0	69778	\N
16816	2773	3	0	69779	\N
16821	4178	3	0	69552	\N
16821	4211	4	0	69808	\N
16823	73	2	0	69813	\N
16823	2766	3	0	69814	\N
16828	181	3	0	67318	\N
16828	4184	4	0	69830	\N
16830	233	3	0	66851	\N
16830	3704	4	0	68124	\N
16834	202	4	0	68841	\N
16834	3673	5	0	69850	\N
16836	4969	26	0	69852	\N
16836	170	70	0	69853	\N
16836	4969	71	0	69854	\N
16841	100	3	0	69707	\N
16841	3836	4	0	69871	\N
16843	360	7	0	69884	\N
16843	4970	8	0	69885	\N
16848	18	4	0	69660	\N
16848	2302	5	0	69904	\N
16851	4172	3	0	69919	\N
16851	4275	4	0	69920	\N
16858	170	0	0	65432	\N
16864	841	3	0	69962	\N
16864	3604	4	0	69963	\N
16866	4178	4	0	69971	\N
16866	4205	5	0	69972	\N
16870	235	13	0	70051	\N
16870	4975	14	0	70052	\N
16874	113	4	0	69633	\N
16874	3677	5	0	70068	\N
16876	4172	9	0	70086	\N
16876	4977	10	0	70087	\N
16884	173	4	0	70141	\N
16884	3614	5	0	70142	\N
16887	181	3	0	70162	\N
16887	4184	4	0	70163	\N
16889	4980	103	0	70172	\N
16889	210	126	0	70173	\N
16889	4981	127	0	70174	\N
16893	336	4	0	67360	\N
16893	3947	5	0	67536	\N
16899	2351	1	0	66954	\N
16899	4983	2	0	70210	\N
16902	75	7	0	70219	\N
16902	3331	8	0	70220	\N
16907	186	10	0	70254	\N
16907	4985	11	0	70255	\N
16911	241	7	0	70271	\N
16911	4987	8	0	70272	\N
16913	336	3	0	70278	\N
16913	3400	4	0	70279	\N
16915	4178	3	0	70282	\N
16915	4211	4	0	70283	\N
16921	56	4	0	70128	\N
16921	3127	5	0	70302	\N
16925	92	12	0	70327	\N
16925	4989	13	0	70328	\N
16927	142	3	0	70233	\N
16927	4254	4	0	70234	\N
16929	214	21	0	69862	\N
16929	4990	22	0	70352	\N
16934	192	3	0	67746	\N
16934	3790	4	0	70371	\N
16937	4178	7	0	70282	\N
16937	4396	8	0	70392	\N
16951	164	5	0	70511	\N
16951	4994	6	0	70512	\N
16953	40	4	0	70520	\N
16953	2796	5	0	70521	\N
16956	534	6	0	70537	\N
16956	4995	7	0	70538	\N
16960	100	1	0	70551	\N
16960	160	2	0	70552	\N
16963	230	6	0	70572	\N
16963	4549	7	0	70573	\N
16966	145	6	0	70577	\N
16966	4998	7	0	70578	\N
16969	102	3	0	70581	\N
16969	1388	4	0	70582	\N
16975	595	2	0	66088	\N
16975	3285	3	0	70598	\N
16985	140	5	0	70628	\N
16985	5000	6	0	70629	\N
16991	288	3	0	70646	\N
16991	3003	4	0	70647	\N
16998	62	5	0	70663	\N
16998	4422	6	0	70664	\N
17006	137	4	0	68298	\N
17006	4352	5	0	68299	\N
17008	64	2	0	70708	\N
17008	277	3	0	70709	\N
17016	4191	2	0	70761	\N
17016	4172	4	0	70421	\N
17016	5004	5	0	70762	\N
17019	4178	3	0	70599	\N
17019	4211	4	0	70771	\N
17021	40	7	0	70787	\N
17021	4718	8	0	70788	\N
17025	451	2	0	68554	\N
17025	5006	3	0	70797	\N
17031	149	2	0	70824	\N
17031	5008	3	0	70825	\N
17039	273	4	0	66063	\N
17039	3777	5	0	66064	\N
17047	411	4	0	70905	\N
17047	4858	5	0	70906	\N
17049	206	2	0	69831	\N
17049	5010	3	0	70912	\N
17051	316	3	0	67383	\N
17051	4249	4	0	67384	\N
17058	451	7	0	68554	\N
17058	4794	8	0	70970	\N
17061	27	4	0	70987	\N
17061	3717	5	0	70988	\N
17066	123	13	0	69653	\N
17066	5018	14	0	71021	\N
17068	954	3	0	68032	\N
17068	5019	4	0	71028	\N
17071	266	4	0	71045	\N
17071	4100	5	0	71046	\N
17073	60	2	0	68621	\N
17073	4544	3	0	71052	\N
17081	488	4	0	71113	\N
17081	5021	5	0	71114	\N
17083	1021	4	0	70837	\N
17083	4752	5	0	70838	\N
17086	5022	39	0	71142	\N
17086	115	126	0	71169	\N
17086	5023	127	0	71170	\N
17088	4178	3	0	71184	\N
17088	4211	4	0	71185	\N
17096	115	5	0	71221	\N
17096	5025	6	0	71222	\N
17100	30	2	0	61826	\N
17100	4014	3	1	71239	\N
17100	5028	3	0	71240	\N
17106	16	2	0	71191	\N
17106	388	3	0	71261	\N
17114	841	2	0	71291	\N
17114	3316	3	0	71292	\N
17120	38	2	0	69717	\N
17120	4009	3	0	71316	\N
17123	360	2	0	71328	\N
17123	2767	3	0	71329	\N
17125	27	2	0	70987	\N
17125	645	3	0	71335	\N
17142	411	9	0	70905	\N
17142	5039	10	0	71423	\N
17144	92	3	0	71430	\N
17144	4410	4	0	70760	\N
17150	4787	4	0	68476	\N
16808	140	3	0	69739	\N
16808	4149	4	0	69740	\N
16811	367	0	0	69746	\N
16813	1109	11	0	65974	\N
16818	4172	5	0	69795	\N
16818	4634	6	0	69796	\N
16827	1470	3	0	67834	\N
16827	3838	4	0	67839	\N
16839	214	2	0	69862	\N
16839	1259	3	0	69863	\N
16840	2636	3	0	69869	\N
16840	2837	4	0	69870	\N
16850	3625	3	0	68743	\N
16850	3784	4	0	62265	\N
16854	262	3	0	69924	\N
16854	4778	4	0	69925	\N
16857	58	7	0	69303	\N
16857	4764	8	0	69953	\N
16861	170	0	0	65432	\N
16863	54	3	0	69960	\N
16863	3041	4	0	69961	\N
16869	18	13	0	70049	\N
16869	4730	14	0	70050	\N
16873	77	4	0	70066	\N
16873	3619	5	0	70067	\N
16879	102	11	0	67690	\N
16879	4978	12	0	70117	\N
16882	56	3	0	70128	\N
16882	4109	4	0	70129	\N
16886	54	3	0	69960	\N
16886	3041	4	0	69961	\N
16888	210	3	0	70170	\N
16888	3539	4	0	70171	\N
16891	75	3	0	70177	\N
16891	3855	4	0	70178	\N
16898	2351	1	0	66954	\N
16898	4983	2	0	70210	\N
16901	2351	1	0	66954	\N
16901	4983	2	0	70210	\N
16904	94	3	0	66770	\N
16904	2864	4	0	66771	\N
16906	71	3	0	69729	\N
16906	3770	4	0	70235	\N
16910	424	7	0	68161	\N
16910	4986	8	0	70270	\N
16916	336	3	0	70278	\N
16916	3400	4	0	70279	\N
16918	18	3	0	70193	\N
16918	3621	4	0	70292	\N
16924	30	12	0	61826	\N
16924	4988	13	0	70326	\N
16926	224	4	0	70337	\N
16926	3281	5	0	70338	\N
16931	2	3	0	70360	\N
16931	3548	4	0	70361	\N
16933	16	3	0	69741	\N
16933	3634	4	0	70370	\N
16936	88	7	0	70390	\N
16936	4949	8	0	70391	\N
16941	18	3	0	70193	\N
16941	3621	4	0	70292	\N
16943	449	1	0	70413	\N
16943	450	2	0	70414	\N
16946	4178	2	0	70422	\N
16946	4247	3	0	70423	\N
16947	4992	103	0	70480	\N
16947	210	126	0	70490	\N
16947	4993	127	0	70491	\N
16950	164	0	0	67227	\N
16952	164	0	0	67227	\N
16955	40	6	0	70535	\N
16955	2777	7	0	70536	\N
16959	4432	2	0	70547	\N
16959	1021	3	0	70548	\N
16962	75	3	0	70559	\N
16962	3855	4	0	70560	\N
16965	79	6	0	70575	\N
16965	4997	7	0	70576	\N
16968	230	6	0	70572	\N
16968	4549	7	0	70573	\N
16971	73	3	0	69813	\N
16971	3040	4	0	70591	\N
16974	597	2	0	69316	\N
16974	3286	3	0	70597	\N
16977	241	0	0	70271	\N
16979	6	1	0	67442	\N
16979	194	2	0	70604	\N
16982	3628	2	0	68747	\N
16982	4360	3	0	70615	\N
16984	336	5	0	70626	\N
16984	3283	6	0	70627	\N
16989	597	2	0	69316	\N
16989	3286	3	0	70597	\N
16995	273	0	0	66063	\N
16997	273	0	0	66063	\N
17000	135	2	0	70671	\N
17000	2722	3	0	70672	\N
17002	75	2	0	70678	\N
17002	284	3	0	70679	\N
17005	135	4	0	70671	\N
17005	4353	5	0	70694	\N
17007	73	5	0	69813	\N
17007	4931	6	0	70704	\N
17010	75	5	0	70721	\N
17010	4484	6	0	70722	\N
17013	75	2	0	70721	\N
17013	284	3	0	70738	\N
17015	2763	2	0	70756	\N
17015	92	4	0	70759	\N
17015	1078	5	0	70760	\N
17018	38	3	0	69717	\N
17018	3457	4	0	69718	\N
17020	391	7	0	70785	\N
17020	3662	8	0	70786	\N
17024	451	3	0	68554	\N
17024	3934	4	0	68555	\N
17027	1323	23	0	70800	\N
17027	115	110	0	70818	\N
17027	5007	111	0	70819	\N
17030	4172	5	0	70828	\N
17030	4634	6	0	70829	\N
17034	244	2	0	69637	\N
17034	3308	3	0	70839	\N
17041	75	3	0	70721	\N
17041	3855	4	0	70875	\N
17044	2782	6	0	70895	\N
17044	5009	7	0	70896	\N
17046	16	4	0	70903	\N
17046	3546	5	0	70904	\N
17048	4172	3	0	70828	\N
17048	4275	4	0	70855	\N
17053	102	2	0	70938	\N
17053	158	3	0	70939	\N
17056	288	5	0	70949	\N
17056	2224	6	0	70950	\N
17057	2782	3	0	70895	\N
17057	3659	4	0	70957	\N
17060	285	3	0	70299	\N
17060	4496	4	0	70980	\N
17063	326	25	0	70990	\N
17063	5014	26	1	70991	\N
17063	4914	26	0	70992	\N
17070	40	4	0	71043	\N
17070	3381	5	0	71044	\N
17077	42	4	0	71064	\N
17077	3896	5	0	71065	\N
17080	353	11	0	71104	\N
17080	5020	12	0	71105	\N
17087	4178	3	0	71176	\N
17087	4211	4	0	71177	\N
17090	16	3	0	71191	\N
17090	3634	4	0	71192	\N
17095	82	5	0	69896	\N
17095	5024	6	0	71220	\N
17098	115	30	0	71234	\N
16812	4960	12	0	69766	\N
16812	4963	13	1	69767	\N
16812	4962	13	0	69768	\N
16815	391	2	0	69776	\N
16815	1381	3	0	69777	\N
16817	373	2	0	69784	\N
16817	4967	3	0	69785	\N
16820	123	2	0	69653	\N
16820	1868	3	0	69802	\N
16822	75	3	0	68356	\N
16822	3855	4	0	69809	\N
16825	251	2	0	67255	\N
16825	1851	3	0	69815	\N
16829	206	3	0	69831	\N
16829	4584	4	0	69832	\N
16832	4088	3	0	69840	\N
16832	4506	4	0	69841	\N
16833	170	45	0	65432	\N
16833	4968	46	0	69842	\N
16838	212	2	0	69860	\N
16838	3616	3	0	69861	\N
16845	230	3	0	65926	\N
16845	4181	4	0	65927	\N
16847	42	3	0	68717	\N
16847	3645	4	0	68718	\N
16849	224	3	0	69911	\N
16849	3603	4	0	69912	\N
16853	3628	3	0	68747	\N
16853	3785	4	0	69923	\N
16865	244	3	0	69637	\N
16865	4075	4	0	69638	\N
16867	75	0	0	69973	\N
16868	4973	63	0	69990	\N
16868	235	126	0	70026	\N
16868	4974	127	0	70027	\N
16871	235	13	0	70051	\N
16871	4952	14	1	70053	\N
16871	4976	14	0	70054	\N
16872	4172	2	0	69919	\N
16872	4191	3	0	70059	\N
16881	156	3	0	70126	\N
16881	4594	4	0	70127	\N
16883	88	3	0	69601	\N
16883	3655	4	0	70134	\N
16890	132	3	0	70175	\N
16890	3729	4	0	70176	\N
16892	20	3	0	65281	\N
16892	2844	4	0	70184	\N
16895	18	4	0	70193	\N
16895	2302	5	0	70194	\N
16897	2351	3	0	66954	\N
16897	2845	4	0	67252	\N
16903	908	3	0	70227	\N
16903	3591	4	0	70228	\N
16909	23	7	0	70268	\N
16909	4146	8	0	70269	\N
16912	424	7	0	68161	\N
16912	4986	8	0	70270	\N
16914	1021	3	0	70280	\N
16914	4551	4	0	70281	\N
16917	1109	3	0	70290	\N
16917	3495	4	0	70291	\N
16920	4178	4	0	70282	\N
16920	4205	5	0	70301	\N
16923	244	4	0	69637	\N
16923	3778	5	0	70304	\N
16928	56	3	0	70343	\N
16928	4109	4	0	70344	\N
16930	214	3	0	69862	\N
16930	4991	4	0	70354	\N
16935	402	2	0	68157	\N
16935	2760	3	0	70376	\N
16940	4172	3	0	70191	\N
16940	4275	4	0	70409	\N
16942	4178	1	0	70282	\N
16942	4450	2	0	70412	\N
16945	4172	2	0	70420	\N
16945	4191	3	0	70421	\N
16949	4178	2	0	70422	\N
16949	4247	3	0	70423	\N
16958	4178	6	0	70541	\N
16958	4358	7	0	70542	\N
16961	90	3	0	67988	\N
16961	4074	4	0	69890	\N
16970	102	3	0	70589	\N
16970	3597	4	0	70590	\N
16973	224	2	0	70595	\N
16973	3150	3	0	70596	\N
16978	18	1	0	70193	\N
16978	19	2	0	70603	\N
16981	3625	2	0	68743	\N
16981	4359	3	0	60669	\N
16988	595	2	0	70634	\N
16988	3285	3	0	70635	\N
16990	424	2	0	68161	\N
16990	2755	3	0	70640	\N
16999	79	2	0	70669	\N
16999	616	3	0	70670	\N
17001	137	2	0	68298	\N
17001	2721	3	0	70673	\N
17004	67	4	0	70393	\N
17004	5001	5	0	70693	\N
17012	18	2	0	70193	\N
17012	1685	3	0	70737	\N
17017	16	3	0	70769	\N
17017	3634	4	0	70770	\N
17029	96	2	0	68447	\N
17029	2942	3	0	70826	\N
17033	1021	4	0	70837	\N
17033	4752	5	0	70838	\N
17036	4178	3	0	70847	\N
17036	4211	4	0	70848	\N
17038	4172	3	0	70828	\N
17038	4275	4	0	70855	\N
17040	268	3	0	70867	\N
17040	3815	4	0	70868	\N
17043	230	6	0	70572	\N
17043	4182	7	0	70894	\N
17050	4178	3	0	70919	\N
17050	4211	4	0	70920	\N
17052	5011	46	0	70926	\N
17052	2578	126	0	70934	\N
17052	5012	127	0	70935	\N
17055	102	5	0	70939	\N
17055	4480	6	0	70948	\N
17064	424	0	0	70993	\N
17065	3051	1	0	51501	\N
17065	5015	1	0	70996	\N
17065	5017	2	1	70997	\N
17065	5016	2	0	70998	\N
17067	954	5	0	68032	\N
17067	953	6	0	71022	\N
17075	60	1	0	68621	\N
17075	61	2	0	71055	\N
17076	202	4	0	71062	\N
17076	3673	5	0	71063	\N
17079	4172	8	0	71086	\N
17079	4500	9	0	71087	\N
17085	115	6	0	71140	\N
17085	4693	7	0	71141	\N
17089	192	3	0	67746	\N
17089	3790	4	0	70371	\N
17092	189	0	0	70362	\N
17094	181	2	0	71209	\N
17094	3313	3	0	71210	\N
17101	100	4	0	71241	\N
17101	5029	5	0	71242	\N
17108	242	2	0	68130	\N
17108	3425	3	0	71267	\N
17113	16	2	0	71289	\N
17113	388	3	0	71290	\N
17117	322	3	0	71305	\N
17117	1105	4	0	71306	\N
17122	142	2	0	70233	\N
17122	4418	3	0	71327	\N
17124	121	2	0	68433	\N
17124	2498	3	0	71334	\N
16900	2351	7	0	66954	\N
16900	4984	8	0	70211	\N
16905	142	3	0	70233	\N
16905	4254	4	0	70234	\N
16908	23	7	0	70268	\N
16908	4146	8	0	70269	\N
16919	285	4	0	70299	\N
16919	3674	5	0	70300	\N
16922	94	4	0	66770	\N
16922	4677	5	0	70303	\N
16932	189	3	0	70362	\N
16932	3782	4	0	70363	\N
16938	67	7	0	70393	\N
16938	3608	8	0	70394	\N
16939	186	3	0	70401	\N
16939	4294	4	0	70402	\N
16944	210	2	0	70170	\N
16944	1874	3	0	70419	\N
16948	27	3	0	65176	\N
16948	4636	4	0	65177	\N
16954	424	4	0	68161	\N
16954	4326	5	0	70522	\N
16957	167	6	0	70539	\N
16957	3314	7	0	70540	\N
16964	1636	8	0	59885	\N
16964	4996	9	0	70574	\N
16967	44	6	0	70579	\N
16967	4999	7	0	70580	\N
16972	147	2	0	50234	\N
16972	3287	3	0	67400	\N
16976	4178	2	0	70599	\N
16976	4247	3	0	70600	\N
16980	40	3	0	70535	\N
16980	372	4	0	70610	\N
16983	119	2	0	69921	\N
16983	1879	3	0	70616	\N
16986	4178	5	0	70599	\N
16986	4429	6	0	70630	\N
16987	147	2	0	50234	\N
16987	3287	3	0	67400	\N
16994	56	2	0	70652	\N
16994	2795	3	0	70653	\N
16996	273	0	0	66063	\N
17003	181	3	0	70162	\N
17003	4184	4	0	70163	\N
17009	424	5	0	70719	\N
17009	5002	6	0	70720	\N
17011	35	4	0	70731	\N
17011	1875	5	0	70732	\N
17014	224	7	0	70595	\N
17014	5003	8	0	70752	\N
17022	16	7	0	70769	\N
17022	4723	8	0	70789	\N
17023	94	7	0	66770	\N
17023	5005	8	0	70790	\N
17026	115	3	0	70798	\N
17026	3483	4	0	70799	\N
17028	149	2	0	70824	\N
17028	5008	3	0	70825	\N
17032	96	1	0	68447	\N
17032	2899	2	0	70830	\N
17035	140	3	0	70845	\N
17035	4149	4	0	70846	\N
17037	16	3	0	70853	\N
17037	3634	4	0	70854	\N
17042	69	3	0	68402	\N
17042	4536	4	0	70882	\N
17045	230	0	0	70572	\N
17054	102	4	0	70939	\N
17054	5013	5	0	70945	\N
17059	40	3	0	70787	\N
17059	372	4	0	70975	\N
17062	326	4	0	69515	\N
17062	3519	5	0	70989	\N
17069	77	3	0	70066	\N
17069	1877	4	0	71034	\N
17072	214	3	0	71047	\N
17072	3496	4	0	71048	\N
17074	77	2	0	71053	\N
17074	3853	3	0	71054	\N
17078	16	3	0	71070	\N
17078	3634	4	0	71071	\N
17082	290	4	0	71115	\N
17082	2759	5	0	71116	\N
17084	4172	3	0	71128	\N
17084	4275	4	0	71129	\N
17091	189	3	0	71199	\N
17091	3782	4	0	71200	\N
17093	260	2	0	66367	\N
17093	3184	3	0	71204	\N
17097	151	5	0	71223	\N
17097	5026	6	0	71224	\N
17103	100	4	0	71241	\N
17103	5031	5	0	71249	\N
17105	56	3	0	71255	\N
17105	4109	4	0	71256	\N
17107	117	2	0	71265	\N
17107	1257	3	0	71266	\N
17110	244	3	0	71276	\N
17110	5032	4	0	71277	\N
17112	224	2	0	71287	\N
17112	3150	3	0	71288	\N
17116	145	0	0	70577	\N
17119	451	2	0	71311	\N
17119	3317	3	0	71312	\N
17121	4178	3	0	71322	\N
17121	4211	4	0	71323	\N
17126	115	3	0	71221	\N
17126	3483	4	0	71341	\N
17128	4178	1	0	71351	\N
17128	4450	2	0	71352	\N
17131	734	3	0	24876	\N
17131	5037	4	0	71366	\N
17133	30	4	0	61826	\N
17133	4004	5	0	71376	\N
17136	40	2	0	71043	\N
17136	282	3	0	71383	\N
17138	260	2	0	71393	\N
17138	3184	3	0	71394	\N
17140	51	3	0	69271	\N
17140	5038	4	0	71401	\N
17147	4178	8	0	71450	\N
17147	4237	9	0	71451	\N
17152	56	3	0	71480	\N
17152	4109	4	0	71481	\N
17153	488	10	0	71499	\N
17153	5044	11	0	71500	\N
17161	4088	7	0	69840	\N
17161	5049	8	0	71521	\N
17165	4172	3	0	71558	\N
17165	4275	4	0	71559	\N
17168	132	10	0	71580	\N
17168	5050	11	0	71581	\N
17170	300	7	0	71582	\N
17170	5054	8	0	71597	\N
17176	4172	4	0	71622	\N
17176	4219	5	0	71623	\N
17186	198	0	0	70124	\N
17189	123	9	0	71661	\N
17189	5063	10	0	71668	\N
17191	4178	3	0	71502	\N
17191	4211	4	0	71682	\N
17197	18	4	0	71630	\N
17197	2302	5	0	71701	\N
17201	151	3	0	71724	\N
17201	3046	4	0	71725	\N
17207	96	2	0	71644	\N
17207	2347	3	0	71744	\N
17211	189	4	0	71756	\N
17211	3992	5	0	71757	\N
17214	431	3	0	71770	\N
17214	3933	4	0	71771	\N
17219	56	7	0	71787	\N
17219	4791	8	0	71788	\N
17226	2351	3	0	71819	\N
17226	2845	4	0	71820	\N
17229	6	6	0	71842	\N
17098	5027	31	0	71235	\N
17102	285	4	0	71247	\N
17102	5030	5	0	71248	\N
17104	16	3	0	71191	\N
17104	3634	4	0	71192	\N
17109	132	4	0	70175	\N
17109	3716	5	0	71275	\N
17111	4178	2	0	71282	\N
17111	4247	3	0	71283	\N
17115	224	84	0	71287	\N
17115	5033	85	0	71299	\N
17118	2	2	0	70360	\N
17118	2789	3	0	71310	\N
17130	186	3	0	71364	\N
17130	4294	4	0	71365	\N
17135	268	2	0	71381	\N
17135	2800	3	0	71382	\N
17137	132	2	0	71388	\N
17137	2756	3	0	71389	\N
17143	69	3	0	71428	\N
17143	4536	4	0	71429	\N
17145	27	3	0	70987	\N
17145	4636	4	0	71436	\N
17148	1109	5	0	71461	\N
17148	5040	6	0	71462	\N
17151	5042	101	0	71471	\N
17151	235	126	0	71473	\N
17151	5043	127	0	71474	\N
17154	40	10	0	71043	\N
17154	4104	11	0	71501	\N
17158	149	7	0	70824	\N
17158	5046	8	0	71517	\N
17162	23	4	0	71528	\N
17162	3189	5	0	71529	\N
17163	132	10	0	71547	\N
17163	5050	11	0	71548	\N
17166	145	126	0	71566	\N
17166	5051	127	0	71567	\N
17171	258	3	0	63687	\N
17171	4401	4	0	63688	\N
17173	2	3	0	70360	\N
17173	3548	4	0	70361	\N
17177	251	4	0	67255	\N
17177	5055	5	0	71624	\N
17180	140	6	0	70845	\N
17180	5056	7	0	71643	\N
17183	140	1	0	70845	\N
17183	3069	2	0	71647	\N
17187	4172	0	0	71622	\N
17194	233	4	0	71506	\N
17194	3775	5	0	71697	\N
17198	4178	3	0	71707	\N
17198	4211	4	0	71708	\N
17202	212	3	0	69860	\N
17202	3639	4	0	71726	\N
17203	86	3	0	71732	\N
17203	3746	4	0	71733	\N
17208	451	3	0	71746	\N
17208	3934	4	0	71747	\N
17210	96	3	0	71644	\N
17210	2803	4	0	71748	\N
17212	75	3	0	71762	\N
17212	3855	4	0	71763	\N
17215	16	3	0	71772	\N
17215	3634	4	0	71773	\N
17222	4233	3	0	71805	\N
17222	4425	4	0	71806	\N
17232	1148	2	0	71848	\N
17232	402	8	0	71854	\N
17232	5068	9	0	71855	\N
17234	167	7	0	71868	\N
17234	4147	8	0	71869	\N
17242	62	7	0	71896	\N
17242	4781	8	0	71897	\N
17244	391	3	0	71903	\N
17244	3660	4	0	71904	\N
17248	5073	106	0	71912	\N
17248	365	126	0	71930	\N
17248	5074	127	0	71931	\N
17250	4	3	0	71768	\N
17250	3837	4	0	71769	\N
17253	147	6	0	71958	\N
17253	4699	7	0	71959	\N
17259	4178	4	0	71894	\N
17259	4331	5	0	71977	\N
17264	336	0	0	70626	\N
17269	214	0	0	71047	\N
17274	214	3	0	72032	\N
17274	3496	4	0	72033	\N
17276	214	0	0	71047	\N
17279	369	2	0	72046	\N
17279	20	4	0	72049	\N
17279	2975	5	0	72050	\N
17286	27	6	0	72078	\N
17286	3715	7	0	72079	\N
17292	186	2	0	71364	\N
17292	1850	3	0	72118	\N
17296	14	9	0	72138	\N
17296	5082	10	0	72139	\N
17300	35	6	0	72184	\N
17300	5084	7	0	72185	\N
17303	102	6	0	70939	\N
17303	5086	7	0	72191	\N
17304	198	4	0	72198	\N
17304	3273	5	0	72199	\N
17310	56	3	0	71787	\N
17310	4109	4	0	72229	\N
17312	4233	3	0	72231	\N
17312	4425	4	0	72236	\N
17314	2771	4	0	72241	\N
17314	60	6	0	72243	\N
17314	5088	7	0	72244	\N
17319	40	2	0	72266	\N
17319	282	3	0	72267	\N
17322	121	3	0	72276	\N
17322	4471	4	0	72277	\N
17324	82	7	0	72289	\N
17324	5090	8	0	72290	\N
17331	260	9	0	72327	\N
17331	5097	10	0	72328	\N
17333	2	6	0	72248	\N
17333	4825	7	0	72339	\N
17338	40	3	0	72272	\N
17338	372	4	0	72273	\N
17343	4178	3	0	72274	\N
17343	4211	4	0	72275	\N
17347	365	0	0	72396	\N
17355	5100	8	0	72434	\N
17355	852	10	0	72437	\N
17355	2945	11	0	72438	\N
17357	528	3	0	69371	\N
17357	5101	4	0	72439	\N
17364	233	5	0	71506	\N
17364	3380	6	0	72463	\N
17368	73	7	0	72477	\N
17368	5104	8	0	72478	\N
17374	4172	3	0	72496	\N
17374	4275	4	0	72497	\N
17380	79	8	0	72034	\N
17380	4238	9	0	72541	\N
17386	4178	3	0	72572	\N
17386	4211	4	0	72573	\N
17387	260	5	0	72327	\N
17387	2365	6	0	72580	\N
17388	5105	124	0	72616	\N
17388	336	126	0	72618	\N
17388	2970	127	0	72619	\N
17400	353	9	0	72713	\N
17400	5110	10	0	72714	\N
17127	5034	7	0	71342	\N
17127	115	36	0	71347	\N
17127	5035	37	0	71348	\N
17129	1470	3	0	67834	\N
17129	5036	4	0	71359	\N
17132	4178	3	0	71367	\N
17132	4211	4	0	71368	\N
17134	244	4	0	71276	\N
17134	3447	5	0	71377	\N
17139	206	2	0	69831	\N
17139	2773	3	0	71395	\N
17141	451	4	0	71409	\N
17141	3666	5	0	71410	\N
17146	4178	0	0	71367	\N
17149	235	4	0	70051	\N
17149	3615	5	0	71469	\N
17155	4178	10	0	71502	\N
17155	4665	11	0	71503	\N
17159	210	7	0	71518	\N
17159	5047	8	0	71519	\N
17169	300	11	0	71582	\N
17169	5053	12	0	71583	\N
17172	431	3	0	71603	\N
17172	3933	4	0	71604	\N
17174	20	4	0	71618	\N
17174	3995	5	0	71619	\N
17178	18	3	0	71630	\N
17178	3621	4	0	71631	\N
17181	96	6	0	71644	\N
17181	3698	7	0	71645	\N
17192	793	3	0	71687	\N
17192	2644	4	0	71688	\N
17195	40	4	0	71698	\N
17195	3381	5	0	71699	\N
17199	23	6	0	71717	\N
17199	4632	7	0	71718	\N
17204	60	3	0	71734	\N
17204	3585	4	0	71735	\N
17216	4	1	0	71768	\N
17216	3114	2	0	71774	\N
17217	4172	7	0	71622	\N
17217	4614	8	0	71784	\N
17220	167	6	0	70539	\N
17220	5066	7	0	71797	\N
17223	233	3	0	71506	\N
17223	3704	4	0	71807	\N
17227	391	4	0	71828	\N
17227	3913	5	0	71829	\N
17230	1148	2	0	71848	\N
17230	402	8	0	71854	\N
17230	5068	9	0	71855	\N
17233	1148	2	0	71848	\N
17233	402	8	0	71854	\N
17233	5068	9	0	71855	\N
17235	42	3	0	71064	\N
17235	3645	4	0	71874	\N
17237	137	2	0	68298	\N
17237	2721	3	0	70673	\N
17239	135	0	0	70671	\N
17245	4787	3	0	68476	\N
17245	4788	4	0	68477	\N
17246	365	2	0	71908	\N
17246	5072	3	0	71909	\N
17251	33	3	0	71946	\N
17251	3342	4	0	71947	\N
17254	595	6	0	70634	\N
17254	4698	7	0	71960	\N
17255	38	3	0	71965	\N
17255	3457	4	0	71966	\N
17257	38	1	0	71965	\N
17257	2906	2	0	71968	\N
17260	35	7	0	71988	\N
17260	5077	8	0	71989	\N
17262	44	3	0	71739	\N
17262	3631	4	0	71740	\N
17267	200	1	0	72008	\N
17267	2785	2	0	72009	\N
17275	79	3	0	72034	\N
17275	3652	4	0	72035	\N
17280	4247	2	0	72051	\N
17280	4178	4	0	72052	\N
17280	4460	5	0	72053	\N
17281	4191	2	0	72054	\N
17281	4172	4	0	72055	\N
17281	5004	5	0	72056	\N
17283	228	3	0	72064	\N
17283	3186	4	0	72065	\N
17289	40	3	0	72110	\N
17289	372	4	0	72111	\N
17301	102	9	0	72187	\N
17301	5085	10	0	72188	\N
17305	235	6	0	72209	\N
17305	3622	7	0	72210	\N
17317	18	3	0	71630	\N
17317	3621	4	0	71631	\N
17325	42	7	0	72291	\N
17325	5091	8	0	72292	\N
17336	230	9	0	72342	\N
17336	5099	10	0	72354	\N
17341	449	3	0	70413	\N
17341	4760	4	0	72379	\N
17348	300	3	0	72402	\N
17348	3747	4	0	72403	\N
17352	77	3	0	71053	\N
17352	1877	4	0	72417	\N
17360	16	3	0	72076	\N
17360	3634	4	0	72448	\N
17363	75	3	0	72454	\N
17363	3855	4	0	72455	\N
17365	170	5	0	65432	\N
17365	5102	6	0	72464	\N
17369	156	2	0	72483	\N
17369	4485	3	0	72484	\N
17371	69	3	0	71428	\N
17371	4536	4	0	71429	\N
17375	69	2	0	71428	\N
17375	2920	3	0	72498	\N
17378	4178	6	0	72494	\N
17378	4250	7	0	72523	\N
17382	4172	6	0	72496	\N
17382	4197	7	0	72524	\N
17384	108	1	0	68954	\N
17384	3022	2	0	72566	\N
17389	453	12	0	72630	\N
17389	4339	13	0	72631	\N
17394	132	5	0	71580	\N
17394	2717	6	0	72666	\N
17397	5108	4	0	72682	\N
17397	431	10	0	72693	\N
17397	5109	11	0	72694	\N
17398	353	9	0	72713	\N
17398	5110	10	0	72714	\N
17150	5041	5	0	71470	\N
17156	258	10	0	63687	\N
17156	5045	11	0	71504	\N
17157	233	9	0	71506	\N
17157	2580	10	0	71507	\N
17160	233	7	0	71506	\N
17160	5048	8	0	71520	\N
17164	1316	3	0	67760	\N
17164	4837	4	0	67771	\N
17167	82	10	0	69896	\N
17167	5052	11	0	71579	\N
17175	181	4	0	71620	\N
17175	4058	5	0	71621	\N
17179	206	3	0	69831	\N
17179	4584	4	0	69832	\N
17182	113	6	0	69633	\N
17182	5057	7	0	71646	\N
17184	140	1	0	70845	\N
17184	3069	2	0	71647	\N
17185	140	1	0	70845	\N
17185	3069	2	0	71647	\N
17188	123	9	0	71661	\N
17190	391	4	0	70785	\N
17190	3913	5	0	71675	\N
17193	233	1	0	71689	\N
17193	1418	2	0	71690	\N
17196	4088	3	0	69840	\N
17196	4506	4	0	69841	\N
17200	16	3	0	71289	\N
17200	3634	4	0	71723	\N
17205	1636	11	0	71737	\N
17205	5064	12	0	71738	\N
17206	44	3	0	71739	\N
17206	3631	4	0	71740	\N
17209	14	3	0	69294	\N
17209	4272	4	0	69295	\N
17213	4	3	0	71768	\N
17213	3837	4	0	71769	\N
17218	841	7	0	71785	\N
17218	5065	8	0	71786	\N
17221	233	0	0	71798	\N
17224	4088	3	0	69840	\N
17224	4506	4	0	69841	\N
17225	92	3	0	71812	\N
17225	4410	4	0	71813	\N
17228	288	6	0	71840	\N
17228	4085	7	0	71841	\N
17231	5069	2	0	71856	\N
17231	4172	8	0	71857	\N
17231	5070	9	0	71784	\N
17236	79	3	0	71875	\N
17236	3652	4	0	71876	\N
17238	79	2	0	71875	\N
17238	616	3	0	71880	\N
17240	38	7	0	71892	\N
17240	5071	8	0	71893	\N
17247	435	1	0	71910	\N
17247	1580	2	0	71911	\N
17256	210	3	0	71518	\N
17256	3539	4	0	71967	\N
17258	908	5	0	71974	\N
17258	5076	6	0	71975	\N
17263	336	3	0	70626	\N
17263	3400	4	0	72000	\N
17265	268	3	0	72005	\N
17265	3815	4	0	72006	\N
17270	214	2	0	71047	\N
17270	1259	3	0	72021	\N
17272	4178	3	0	72026	\N
17272	4211	4	0	72027	\N
17277	14	3	0	72040	\N
17277	4272	4	0	72041	\N
17282	3308	2	0	72057	\N
17282	244	4	0	72058	\N
17282	2960	5	0	72059	\N
17284	96	6	0	71644	\N
17284	5078	7	0	72075	\N
17287	2636	9	0	69869	\N
17287	5079	10	0	72094	\N
17290	92	1	0	72114	\N
17290	191	2	0	72115	\N
17293	186	0	0	71364	\N
17294	149	4	0	72123	\N
17294	4040	5	0	72124	\N
17295	258	9	0	63687	\N
17295	5081	10	0	72137	\N
17297	260	3	0	72144	\N
17297	3399	4	0	72145	\N
17298	4178	12	0	72164	\N
17298	5083	13	0	72165	\N
17302	4178	6	0	72189	\N
17302	4250	7	0	72190	\N
17306	214	3	0	72215	\N
17306	3496	4	0	72216	\N
17308	2351	2	0	72221	\N
17308	2754	3	0	72222	\N
17313	2771	4	0	72241	\N
17313	60	6	0	72243	\N
17313	5088	7	0	72244	\N
17315	2	2	0	72248	\N
17315	2789	3	0	72249	\N
17320	40	3	0	72272	\N
17320	372	4	0	72273	\N
17326	1109	7	0	72293	\N
17326	5092	8	0	72294	\N
17327	262	2	0	72298	\N
17327	2743	3	0	72299	\N
17329	132	11	0	71580	\N
17329	5095	12	0	72325	\N
17334	251	1	0	67255	\N
17334	2998	2	0	72341	\N
17339	453	3	0	72371	\N
17339	2838	4	0	72372	\N
17344	2351	3	0	72392	\N
17344	2845	4	0	72393	\N
17346	18	3	0	72373	\N
17346	3621	4	0	72374	\N
17349	300	2	0	72402	\N
17349	2786	3	0	72404	\N
17353	411	2	0	72421	\N
17353	3370	3	0	72422	\N
17356	5100	8	0	72434	\N
17356	852	10	0	72437	\N
17356	2945	11	0	72438	\N
17358	173	3	0	70206	\N
17358	3796	4	0	72445	\N
17361	164	3	0	72446	\N
17361	3385	4	0	72447	\N
17366	285	5	0	72465	\N
17366	5103	6	0	72466	\N
17370	391	2	0	71903	\N
17370	1381	3	0	72485	\N
17372	198	3	0	72492	\N
17372	4263	4	0	72493	\N
17376	40	3	0	72394	\N
17376	372	4	0	72395	\N
17379	4172	6	0	72496	\N
17379	4197	7	0	72524	\N
17385	108	3	0	68954	\N
17385	4171	4	0	72571	\N
17390	336	12	0	72632	\N
17390	5106	13	0	72633	\N
17392	110	7	0	72651	\N
17392	4621	8	0	72652	\N
17395	4172	5	0	72496	\N
17395	4415	6	0	72667	\N
17399	353	9	0	72713	\N
17399	5112	10	1	72715	\N
17399	5111	10	0	72716	\N
17188	5060	11	0	138625	\N
17188	5061	11	1	138626	\N
17188	116	12	1	138627	\N
17188	5062	12	0	138628	\N
17188	5058	10	0	138623	\N
17188	5059	10	1	138624	\N
17229	5067	7	0	71843	\N
17241	4178	7	0	71894	\N
17241	4396	8	0	71895	\N
17243	60	3	0	71734	\N
17243	3585	4	0	71735	\N
17249	4787	6	0	68476	\N
17249	5075	7	0	71941	\N
17252	597	6	0	69316	\N
17252	4697	7	0	71957	\N
17261	1636	0	0	71990	\N
17266	251	3	0	67255	\N
17266	3514	4	0	67256	\N
17268	244	4	0	72016	\N
17268	3447	5	0	72017	\N
17271	214	0	0	71047	\N
17273	214	0	0	71047	\N
17278	369	2	0	72046	\N
17278	20	4	0	72049	\N
17278	2975	5	0	72050	\N
17285	16	6	0	72076	\N
17285	3369	7	0	72077	\N
17288	2636	6	0	72104	\N
17288	5080	7	0	72105	\N
17291	92	2	0	72114	\N
17291	2763	3	0	72117	\N
17299	228	3	0	72171	\N
17299	3186	4	0	72172	\N
17307	79	3	0	72034	\N
17307	3652	4	0	72035	\N
17309	88	3	0	72227	\N
17309	3655	4	0	72228	\N
17311	4233	1	0	72231	\N
17311	5087	2	0	72232	\N
17316	2636	2	0	72250	\N
17316	2836	3	0	72251	\N
17318	121	3	0	72261	\N
17318	4471	4	0	72262	\N
17321	4178	3	0	72274	\N
17321	4211	4	0	72275	\N
17323	4178	7	0	72274	\N
17323	5089	8	0	72288	\N
17328	5093	62	0	72307	\N
17328	262	68	0	72308	\N
17328	5094	69	0	72309	\N
17330	451	11	0	71746	\N
17330	5096	12	0	72326	\N
17332	288	4	0	71840	\N
17332	5098	5	0	72336	\N
17335	230	1	0	72342	\N
17335	1240	2	0	72343	\N
17337	4172	3	0	72360	\N
17337	4275	4	0	72361	\N
17340	18	3	0	72373	\N
17340	3621	4	0	72374	\N
17342	149	3	0	72385	\N
17342	4189	4	0	72386	\N
17345	40	3	0	72394	\N
17345	372	4	0	72395	\N
17350	365	3	0	72396	\N
17350	3839	4	0	72405	\N
17351	123	5	0	72410	\N
17351	3908	6	0	72411	\N
17354	5100	8	0	72434	\N
17354	852	10	0	72437	\N
17354	2945	11	0	72438	\N
17359	164	3	0	72446	\N
17359	3385	4	0	72447	\N
17362	164	3	0	72446	\N
17362	3385	4	0	72447	\N
17367	4088	4	0	69840	\N
17367	4089	5	0	72467	\N
17373	4178	3	0	72494	\N
17373	4211	4	0	72495	\N
17377	20	3	0	71618	\N
17377	2844	4	0	72050	\N
17381	4178	6	0	72554	\N
17381	4250	7	0	72555	\N
17383	192	3	0	72562	\N
17383	3790	4	0	72563	\N
17391	336	9	0	72635	\N
17391	5107	10	0	72636	\N
17393	110	8	0	72651	\N
17393	3710	9	0	72655	\N
17396	4172	2	0	72672	\N
17396	4191	3	0	72673	\N
17401	230	2	0	72721	\N
17401	3006	3	0	72722	\N
17402	4178	2	0	72572	\N
17402	4527	3	0	72723	\N
17403	4172	3	0	72730	\N
17403	4275	4	0	72731	\N
17404	18	3	0	72738	\N
17404	3621	4	0	72739	\N
17405	300	3	0	72402	\N
17405	3747	4	0	72403	\N
17406	16	3	0	72746	\N
17406	3634	4	0	72747	\N
17407	132	6	0	71580	\N
17407	4690	7	0	72760	\N
17408	4172	6	0	72761	\N
17408	4197	7	0	72762	\N
17409	235	5	0	72773	\N
17409	5113	6	0	72774	\N
17410	77	3	0	72781	\N
17410	1877	4	0	72782	\N
17411	528	3	0	69371	\N
17411	4262	4	0	69839	\N
17412	173	3	0	70206	\N
17412	3796	4	0	72445	\N
17413	4178	3	0	72783	\N
17413	4211	4	0	72784	\N
17414	324	2	0	72789	\N
17414	3000	3	0	72790	\N
17415	4172	2	0	72761	\N
17415	4285	3	0	72791	\N
17416	5114	2	0	72792	\N
17416	5115	3	0	72793	\N
17417	353	2	0	72798	\N
17417	3134	3	0	72799	\N
17418	345	3	0	72806	\N
17418	4763	4	0	72807	\N
17419	38	2	0	72812	\N
17419	2901	3	0	72813	\N
17420	64	2	0	72814	\N
17420	5116	3	0	72815	\N
17421	202	6	0	72828	\N
17421	4079	7	0	72829	\N
17422	279	6	0	72830	\N
17422	5117	7	0	72831	\N
17423	208	6	0	61223	\N
17423	5118	7	0	72832	\N
17424	51	4	0	72841	\N
17424	5119	5	0	72842	\N
17425	326	4	0	72843	\N
17425	5120	5	0	72844	\N
17426	115	8	0	72861	\N
17426	5121	9	0	72862	\N
17427	86	2	0	72867	\N
17427	3321	3	0	72868	\N
17428	200	2	0	72869	\N
17428	276	3	0	72870	\N
17429	192	3	0	72877	\N
17429	3790	4	0	72878	\N
17430	224	4	0	71287	\N
17430	3281	5	0	18391	\N
17431	33	4	0	72887	\N
17431	5122	5	0	72888	\N
17432	5123	29	0	72890	\N
17432	33	126	0	72916	\N
17432	5124	127	0	72917	\N
17433	198	3	0	72924	\N
17433	4263	4	0	72925	\N
17434	353	3	0	72926	\N
17434	3766	4	0	72927	\N
17435	40	3	0	72928	\N
17435	372	4	0	72929	\N
17436	20	3	0	72935	\N
17436	5125	4	0	72936	\N
17439	2758	4	0	72953	\N
17439	79	7	0	72954	\N
17439	3180	8	0	72955	\N
17442	2758	4	0	72953	\N
17442	79	7	0	72954	\N
17442	3180	8	0	72955	\N
17444	16	2	0	72965	\N
17444	388	3	0	72966	\N
17445	16	6	0	72979	\N
17445	3369	7	0	72980	\N
17452	149	6	0	72385	\N
17452	5130	7	0	73055	\N
17458	2	36	0	72248	\N
17458	5137	37	0	73169	\N
17463	1470	25	0	73189	\N
17463	5141	26	0	73195	\N
17464	5142	9	0	73214	\N
17464	793	14	0	73223	\N
17464	3618	15	0	73224	\N
17471	264	0	0	64483	\N
17477	2	9	0	73382	\N
17477	5150	10	0	73383	\N
17482	147	7	0	73424	\N
17482	5155	8	0	73425	\N
17484	595	8	0	70634	\N
17484	5157	9	0	73441	\N
17491	27	8	0	73485	\N
17491	5164	9	0	73486	\N
17493	424	2	0	73493	\N
17493	2755	3	0	73494	\N
17495	75	2	0	73501	\N
17495	284	3	0	73502	\N
17498	273	2	0	73517	\N
17498	1413	3	0	73518	\N
17506	449	6	0	73570	\N
17506	5168	7	0	73571	\N
17508	96	1	0	73578	\N
17508	2899	2	0	73581	\N
17511	1470	14	0	73608	\N
17511	5170	15	0	73613	\N
17518	132	3	0	73643	\N
17518	3729	4	0	73644	\N
17525	23	8	0	73678	\N
17525	5172	9	0	73679	\N
17529	4172	5	0	73719	\N
17529	4634	6	0	73720	\N
17533	64	3	0	72814	\N
17533	4217	4	0	73744	\N
17534	5176	7	0	73759	\N
17534	230	13	0	73770	\N
17534	5177	14	0	73771	\N
17537	1914	3	0	73781	\N
17537	3637	4	0	73782	\N
17541	208	5	0	61223	\N
17541	5182	6	0	73805	\N
17544	4172	5	0	73719	\N
17544	4415	6	0	73812	\N
17553	79	3	0	73845	\N
17553	3652	4	0	73846	\N
17555	595	3	0	70634	\N
17555	3654	4	0	73854	\N
17563	56	3	0	73876	\N
17563	4109	4	0	73877	\N
17569	1545	3	0	40456	\N
17569	5184	4	0	73900	\N
17573	5185	37	0	73915	\N
17573	5187	38	0	73930	\N
17575	12	3	0	73939	\N
17575	4204	4	0	73940	\N
17578	18	0	0	73817	\N
17579	40	3	0	73949	\N
17579	372	4	0	73950	\N
17585	4172	9	0	73719	\N
17585	4977	10	0	73984	\N
17587	214	6	0	73998	\N
17587	4681	7	0	73999	\N
17590	852	2	0	74008	\N
17590	2872	3	0	74012	\N
17594	40	5	0	74024	\N
17594	2714	6	0	74025	\N
17598	528	20	0	69371	\N
17598	5195	21	0	74050	\N
17600	322	21	0	74073	\N
17600	5198	22	0	74074	\N
17602	18	2	0	74096	\N
17602	1685	3	0	74097	\N
17610	147	4	0	73443	\N
17610	3877	5	0	74146	\N
17614	4172	3	0	73719	\N
17614	4275	4	0	74156	\N
17616	4178	3	0	74165	\N
17616	4211	4	0	74166	\N
17618	102	3	0	70939	\N
17618	3597	4	0	74175	\N
17628	206	6	0	74214	\N
17628	5205	7	0	74215	\N
17630	360	3	0	74224	\N
17630	3602	4	0	74225	\N
17634	56	3	0	74331	\N
17634	4109	4	0	74332	\N
17637	18	3	0	74167	\N
17637	3621	4	0	74168	\N
17646	173	7	0	74390	\N
17646	5211	8	0	74391	\N
17655	44	4	0	74554	\N
17655	5215	5	0	74555	\N
17663	35	4	0	74589	\N
17663	1875	5	0	74590	\N
17666	264	2	0	64483	\N
17666	2780	3	0	74597	\N
17672	4172	2	0	74663	\N
17672	4191	3	0	74664	\N
17673	353	10	0	74685	\N
17673	5217	11	0	74686	\N
17675	4178	2	0	74387	\N
17675	4247	3	0	74567	\N
17684	94	3	0	66770	\N
17684	631	4	0	74722	\N
17687	189	2	0	74728	\N
17687	3441	3	0	74730	\N
17693	200	4	0	74783	\N
17693	2811	5	0	74784	\N
17699	793	1	0	74816	\N
17699	4842	3	0	68024	\N
17704	51	2	0	74833	\N
17704	524	3	0	74834	\N
17707	4178	2	0	74842	\N
17707	4247	3	0	74843	\N
17710	3628	2	0	68747	\N
17710	4360	3	0	70615	\N
17713	33	4	0	72887	\N
17713	5122	5	0	72888	\N
17715	3628	4	0	74873	\N
17715	4375	5	0	74874	\N
17717	4178	4	0	74860	\N
17717	4331	5	0	74861	\N
17722	4178	2	0	74909	\N
17722	4247	3	0	74910	\N
17727	4322	7	0	74939	\N
17727	5231	8	0	74940	\N
17732	132	6	0	74978	\N
17732	4690	7	0	74979	\N
17739	852	2	0	75060	\N
17739	4236	3	0	75061	\N
17749	149	4	0	75096	\N
17749	4040	5	0	75097	\N
17757	96	12	0	75153	\N
17757	5245	13	0	75154	\N
17759	1470	3	0	75162	\N
17759	3838	4	0	75163	\N
17761	181	3	0	73874	\N
17761	4184	4	0	73875	\N
17775	266	10	0	75279	\N
17775	5251	11	0	75280	\N
17437	4172	3	0	72761	\N
17437	5126	4	0	72937	\N
17440	4252	4	0	72956	\N
17440	4172	7	0	72957	\N
17440	4285	8	0	72762	\N
17443	2758	4	0	72953	\N
17443	79	7	0	72954	\N
17443	3180	8	0	72955	\N
17446	4172	6	0	72761	\N
17446	4197	7	0	72762	\N
17450	35	18	0	72184	\N
17450	5127	19	0	73025	\N
17455	38	8	0	73090	\N
17455	5133	9	0	73091	\N
17460	1470	9	0	73189	\N
17460	5139	10	0	73190	\N
17465	793	5	0	73225	\N
17465	5143	6	0	73226	\N
17467	1061	2	0	73292	\N
17467	235	13	0	73300	\N
17467	5146	14	0	73301	\N
17472	326	29	0	72843	\N
17472	5148	30	0	73347	\N
17474	264	29	0	64483	\N
17474	5149	30	0	73348	\N
17480	67	8	0	73404	\N
17480	5153	9	0	73405	\N
17483	597	8	0	69316	\N
17483	5156	9	0	73426	\N
17485	147	6	0	73443	\N
17485	5158	7	0	73444	\N
17489	391	9	0	73466	\N
17489	5162	10	0	73467	\N
17496	4178	2	0	72783	\N
17496	4247	3	0	73507	\N
17499	228	2	0	73519	\N
17499	4776	3	0	73520	\N
17503	4178	3	0	73521	\N
17503	4211	4	0	73553	\N
17512	167	9	0	73614	\N
17512	5171	10	0	73615	\N
17513	35	2	0	73620	\N
17513	1191	3	0	73621	\N
17519	4088	3	0	73645	\N
17519	4506	4	0	73646	\N
17520	121	2	0	73651	\N
17520	2498	3	0	73652	\N
17523	14	2	0	73659	\N
17523	1785	3	0	73660	\N
17526	56	9	0	71787	\N
17526	5173	10	0	73698	\N
17530	16	5	0	72979	\N
17530	5175	6	0	73721	\N
17531	459	3	0	73728	\N
17531	3178	4	0	73729	\N
17535	5176	7	0	73759	\N
17535	230	13	0	73770	\N
17535	5177	14	0	73771	\N
17539	5178	3	0	73790	\N
17539	5181	3	0	73791	\N
17539	3934	4	0	73792	\N
17542	210	6	0	73808	\N
17542	3721	7	0	73809	\N
17546	60	3	0	73825	\N
17546	3585	4	0	73826	\N
17556	597	3	0	69316	\N
17556	3656	4	0	73855	\N
17558	67	3	0	73856	\N
17558	3749	4	0	73857	\N
17559	40	3	0	73864	\N
17559	372	4	0	73865	\N
17564	64	6	0	73890	\N
17564	5183	7	0	73891	\N
17566	60	3	0	73825	\N
17566	3585	4	0	73826	\N
17570	4178	3	0	73901	\N
17570	4211	4	0	73902	\N
17580	4178	9	0	73960	\N
17580	4682	10	0	73961	\N
17582	145	0	0	73963	\N
17592	5192	35	0	74014	\N
17592	30	36	0	74015	\N
17596	5193	82	0	74034	\N
17596	2351	126	0	74035	\N
17596	5194	127	0	74036	\N
17601	5199	35	0	74075	\N
17601	100	126	0	74093	\N
17601	5200	127	0	74094	\N
17603	4178	2	0	73901	\N
17603	4527	3	0	74102	\N
17611	597	4	0	69316	\N
17611	3733	5	0	74147	\N
17612	212	4	0	69860	\N
17612	3732	5	0	74148	\N
17615	40	3	0	74157	\N
17615	372	4	0	74158	\N
17617	18	3	0	74167	\N
17617	3621	4	0	74168	\N
17619	424	3	0	74176	\N
17619	3611	4	0	74177	\N
17623	4233	3	0	74196	\N
17623	4425	4	0	74197	\N
17631	117	3	0	71265	\N
17631	3653	4	0	74226	\N
17635	75	3	0	73653	\N
17635	3855	4	0	74333	\N
17644	4178	7	0	74387	\N
17644	5210	8	0	74388	\N
17649	4201	1	0	74410	\N
17649	4172	3	0	74413	\N
17649	5004	4	0	74414	\N
17652	117	2	0	74545	\N
17652	1257	3	0	74546	\N
17656	79	2	0	73845	\N
17656	616	3	0	74560	\N
17660	4172	2	0	74568	\N
17660	4191	3	0	74414	\N
17667	14	2	0	74598	\N
17667	1785	3	0	74599	\N
17670	5216	35	0	74611	\N
17670	100	126	0	74655	\N
17670	5200	127	0	74656	\N
17674	1914	10	0	74687	\N
17674	5218	11	0	74688	\N
17676	186	2	0	71364	\N
17676	1850	3	0	72118	\N
17680	4172	2	0	74705	\N
17680	4191	3	0	74706	\N
17685	4178	2	0	74387	\N
17685	4247	3	0	74567	\N
17689	488	16	0	71499	\N
17689	5222	17	0	74766	\N
17691	224	2	0	18546	\N
17691	3150	3	0	74772	\N
17694	35	4	0	74785	\N
17694	1875	5	0	74786	\N
17696	173	2	0	74390	\N
17696	2102	3	0	74797	\N
17697	4172	6	0	74810	\N
17697	4365	7	0	74811	\N
17705	51	3	0	74833	\N
17705	5038	4	0	74835	\N
17708	228	2	0	73519	\N
17708	4776	3	0	73520	\N
17716	125	4	0	68226	\N
17716	3356	5	0	74875	\N
17718	230	7	0	74898	\N
17718	5228	8	0	74899	\N
17720	793	7	0	74901	\N
17720	5229	8	0	74902	\N
17725	391	3	0	74022	\N
17725	3660	4	0	74023	\N
17730	233	4	0	71506	\N
17730	3775	5	0	71697	\N
17733	16	8	0	74995	\N
17733	5232	9	0	74996	\N
17736	75	11	0	75035	\N
17438	3352	4	0	72946	\N
17438	391	7	0	72951	\N
17438	2966	8	0	72952	\N
17441	3779	4	0	72958	\N
17441	18	7	0	72959	\N
17441	3817	8	0	72960	\N
17449	16	2	0	72979	\N
17449	388	3	0	72988	\N
17451	5128	46	0	73040	\N
17451	2578	126	0	73041	\N
17451	5129	127	0	73042	\N
17454	2782	7	0	73072	\N
17454	5132	8	0	73073	\N
17457	210	36	0	71518	\N
17457	5136	37	0	73168	\N
17459	210	17	0	71518	\N
17459	5138	18	0	73170	\N
17462	1470	24	0	73189	\N
17462	5140	25	0	73194	\N
17469	1061	2	0	73292	\N
17469	235	5	0	73300	\N
17469	1061	6	0	73332	\N
17473	264	0	0	64483	\N
17476	2	3	0	72248	\N
17476	3548	4	0	73363	\N
17479	411	8	0	73402	\N
17479	5152	9	0	73403	\N
17481	595	8	0	70634	\N
17481	5154	9	0	73422	\N
17487	4178	8	0	72783	\N
17487	5160	9	0	73446	\N
17490	40	8	0	72928	\N
17490	5163	9	0	73484	\N
17497	324	2	0	72789	\N
17497	2808	3	0	73512	\N
17502	200	3	0	73545	\N
17502	3338	4	0	73546	\N
17505	18	6	0	73568	\N
17505	4180	7	0	73569	\N
17507	96	3	0	73578	\N
17507	2803	4	0	73579	\N
17509	75	5	0	73588	\N
17509	4484	6	0	73589	\N
17510	1470	9	0	73608	\N
17510	5169	10	0	73609	\N
17515	251	3	0	73630	\N
17515	3514	4	0	73631	\N
17517	233	3	0	71506	\N
17517	3704	4	0	71807	\N
17522	75	2	0	73653	\N
17522	284	3	0	73654	\N
17528	459	5	0	73717	\N
17528	5174	6	0	73718	\N
17536	5178	3	0	73778	\N
17536	5179	3	0	73779	\N
17536	3637	4	0	73780	\N
17538	145	3	0	70577	\N
17538	5180	4	0	73783	\N
17545	18	2	0	73817	\N
17545	1685	3	0	73818	\N
17548	27	3	0	73485	\N
17548	4636	4	0	73827	\N
17550	4178	3	0	73566	\N
17550	4211	4	0	73836	\N
17552	251	3	0	73630	\N
17552	3514	4	0	73631	\N
17554	147	3	0	73443	\N
17554	3657	4	0	73853	\N
17561	4178	3	0	73566	\N
17561	4211	4	0	73836	\N
17568	60	0	0	73825	\N
17572	4178	6	0	73901	\N
17572	4250	7	0	73917	\N
17574	4787	3	0	73937	\N
17574	4788	4	0	73938	\N
17577	18	0	0	73817	\N
17584	135	9	0	70671	\N
17584	5189	10	0	73983	\N
17586	137	9	0	68298	\N
17586	5190	10	0	73985	\N
17589	4172	4	0	73719	\N
17589	4252	5	0	74010	\N
17591	449	4	0	73570	\N
17591	5191	5	0	74013	\N
17595	2754	2	0	74030	\N
17595	2351	4	0	74033	\N
17595	2925	5	0	72393	\N
17597	142	3	0	70233	\N
17597	4254	4	0	70234	\N
17605	285	9	0	72465	\N
17605	5201	10	0	74117	\N
17607	200	10	0	74130	\N
17607	5203	11	0	74131	\N
17609	595	4	0	70634	\N
17609	3878	5	0	74145	\N
17613	285	3	0	72465	\N
17613	4496	4	0	74155	\N
17622	4178	3	0	74188	\N
17622	4211	4	0	74189	\N
17625	279	3	0	73810	\N
17625	3641	4	0	74198	\N
17627	40	6	0	74157	\N
17627	4255	7	0	74213	\N
17629	273	3	0	74222	\N
17629	3638	4	0	74223	\N
17632	5206	50	0	74248	\N
17632	117	126	0	74315	\N
17632	5207	127	0	74316	\N
17633	285	3	0	74323	\N
17633	4496	4	0	74324	\N
17636	4	3	0	71768	\N
17636	3837	4	0	71769	\N
17639	5208	20	0	74342	\N
17639	90	126	0	74343	\N
17639	5209	127	0	74344	\N
17641	262	3	0	74353	\N
17641	4778	4	0	74354	\N
17643	4172	5	0	73719	\N
17643	4415	6	0	73812	\N
17648	2782	7	0	73072	\N
17648	4062	8	0	74407	\N
17651	5213	50	0	74463	\N
17651	117	126	0	74539	\N
17651	5207	127	0	74540	\N
17653	1021	6	0	74548	\N
17653	5214	7	0	74549	\N
17658	1109	2	0	72293	\N
17658	2809	3	0	74562	\N
17659	4178	2	0	74387	\N
17659	4247	3	0	74567	\N
17662	285	4	0	74587	\N
17662	5030	5	0	74588	\N
17665	115	2	0	74595	\N
17665	2797	3	0	74596	\N
17669	100	2	0	71241	\N
17669	633	3	0	74610	\N
17671	316	2	0	74661	\N
17671	1900	3	0	74662	\N
17678	186	6	0	71364	\N
17678	5219	7	0	74694	\N
17679	235	2	0	74699	\N
17679	2757	3	0	74700	\N
17682	164	2	0	72446	\N
17682	1124	3	0	74713	\N
17695	214	2	0	74791	\N
17695	1259	3	0	74792	\N
17698	793	2	0	74816	\N
17698	874	3	1	74817	\N
17698	5224	3	0	74818	\N
17701	244	2	0	74822	\N
17701	5226	3	1	74823	\N
17701	4842	3	0	74824	\N
17701	5227	4	0	74825	\N
17703	186	1	0	74831	\N
17703	187	2	0	74832	\N
17709	3625	2	0	68743	\N
17709	4359	3	0	60669	\N
17447	56	6	0	71787	\N
17447	4703	7	0	72981	\N
17448	88	2	0	72986	\N
17448	2799	3	0	72987	\N
17453	60	7	0	73070	\N
17453	5131	8	0	73071	\N
17456	5134	19	0	73130	\N
17456	5135	20	0	73131	\N
17461	4178	9	0	72783	\N
17461	4318	10	0	73191	\N
17466	5144	35	0	73252	\N
17466	793	126	0	73290	\N
17466	5145	127	0	73291	\N
17468	1061	2	0	73292	\N
17468	235	27	0	73300	\N
17468	5147	28	0	73331	\N
17470	264	0	0	64483	\N
17475	4172	3	0	73355	\N
17475	4275	4	0	73356	\N
17478	431	8	0	73400	\N
17478	5151	9	0	73401	\N
17486	597	8	0	69316	\N
17486	5159	9	0	73445	\N
17488	27	8	0	73447	\N
17488	5161	9	0	73448	\N
17492	4172	8	0	73487	\N
17492	5165	9	0	73488	\N
17494	92	2	0	73499	\N
17494	2763	3	0	73500	\N
17500	4178	2	0	73521	\N
17500	4247	3	0	73522	\N
17501	76	1	0	73525	\N
17501	75	7	0	73536	\N
17504	4178	6	0	73566	\N
17504	4250	7	0	73567	\N
17514	20	3	0	73628	\N
17514	2844	4	0	73629	\N
17516	2	2	0	73636	\N
17516	2789	3	0	73637	\N
17521	16	2	0	72979	\N
17521	388	3	0	72988	\N
17524	4178	2	0	73566	\N
17524	4247	3	0	73661	\N
17527	4172	3	0	73705	\N
17527	4275	4	0	73706	\N
17532	23	3	0	73736	\N
17532	3497	4	0	73737	\N
17540	451	3	0	73793	\N
17540	3934	4	0	73794	\N
17543	279	5	0	73810	\N
17543	4421	6	0	73811	\N
17547	40	3	0	72928	\N
17547	372	4	0	72929	\N
17549	200	3	0	73834	\N
17549	3338	4	0	73835	\N
17551	2636	3	0	73843	\N
17551	2837	4	0	73844	\N
17557	4178	3	0	73566	\N
17557	4211	4	0	73836	\N
17560	82	3	0	73866	\N
17560	4505	4	0	73867	\N
17562	181	3	0	73874	\N
17562	4184	4	0	73875	\N
17565	40	6	0	73864	\N
17565	4255	7	0	73892	\N
17567	264	3	0	64483	\N
17567	3632	4	0	73899	\N
17571	5185	6	0	73915	\N
17571	5186	7	0	73916	\N
17576	288	3	0	73941	\N
17576	3003	4	0	73942	\N
17581	77	3	0	72781	\N
17581	1877	4	0	72782	\N
17583	4787	9	0	73937	\N
17583	5188	10	0	73982	\N
17588	852	4	0	74008	\N
17588	3319	5	0	74009	\N
17593	391	3	0	74022	\N
17593	3660	4	0	74023	\N
17599	5196	9	0	74057	\N
17599	100	13	0	74061	\N
17599	5197	14	0	74062	\N
17604	285	5	0	72465	\N
17604	3963	6	0	74109	\N
17606	4178	5	0	74122	\N
17606	5202	6	0	74123	\N
17608	4178	2	0	74122	\N
17608	4247	3	0	74136	\N
17620	2	3	0	74178	\N
17620	3548	4	0	74179	\N
17621	320	1	0	74180	\N
17621	3058	2	0	74181	\N
17624	208	3	0	61223	\N
17624	4490	4	0	61224	\N
17626	54	6	0	74211	\N
17626	5204	7	0	74212	\N
17638	75	3	0	74340	\N
17638	3855	4	0	74341	\N
17640	4178	3	0	74351	\N
17640	4211	4	0	74352	\N
17642	402	3	0	74361	\N
17642	4077	4	0	74362	\N
17645	300	7	0	72402	\N
17645	4572	8	0	74389	\N
17647	198	7	0	72924	\N
17647	5212	8	0	74392	\N
17650	76	1	0	74415	\N
17650	75	3	0	74416	\N
17650	1427	4	0	74417	\N
17654	1636	2	0	59885	\N
17654	4416	3	0	59886	\N
17657	151	2	0	71724	\N
17657	2854	3	0	74561	\N
17661	235	4	0	74577	\N
17661	4479	5	0	74578	\N
17664	4178	2	0	74387	\N
17664	4247	3	0	74567	\N
17668	4172	2	0	74604	\N
17668	4191	3	0	74605	\N
17677	316	2	0	74661	\N
17677	1900	3	0	74662	\N
17681	149	2	0	74711	\N
17681	1379	3	0	74712	\N
17683	102	3	0	74720	\N
17683	608	4	0	74721	\N
17686	189	9	0	74728	\N
17686	5220	10	0	74729	\N
17688	145	8	0	74732	\N
17688	5221	9	0	74733	\N
17690	156	16	0	72483	\N
17690	5223	17	0	74767	\N
17692	4172	2	0	74773	\N
17692	4191	3	0	74774	\N
17700	793	2	0	74816	\N
17700	4363	3	0	74821	\N
17702	186	3	0	71364	\N
17702	3722	4	0	74830	\N
17706	71	2	0	74836	\N
17706	1125	3	0	74837	\N
17711	4178	4	0	74860	\N
17711	4331	5	0	74861	\N
17719	18	7	0	74167	\N
17719	4538	8	0	74900	\N
17721	373	7	0	74903	\N
17721	5230	8	0	74904	\N
17723	716	3	0	5921	\N
17723	4477	4	0	61026	\N
17726	273	3	0	74222	\N
17726	3638	4	0	74223	\N
17728	16	3	0	72979	\N
17728	3634	4	0	74947	\N
17731	4088	4	0	73645	\N
17731	4089	5	0	74965	\N
17734	1470	7	0	75010	\N
17734	5233	8	0	75011	\N
17712	1021	1	0	74862	\N
17712	1022	2	0	74863	\N
17714	3625	4	0	68743	\N
17714	4374	5	0	74872	\N
17724	2351	3	0	74917	\N
17724	2845	4	0	74918	\N
17729	233	11	0	71506	\N
17729	1849	12	0	74958	\N
17735	228	7	0	75012	\N
17735	5234	8	0	75013	\N
17738	4420	5	0	75056	\N
17738	5236	6	0	75057	\N
17738	5237	6	0	75058	\N
17741	3341	5	0	75066	\N
17741	79	8	0	75067	\N
17741	3180	9	0	75068	\N
17743	3341	5	0	75066	\N
17743	79	8	0	75067	\N
17743	3180	9	0	75068	\N
17746	4178	6	0	75083	\N
17746	4250	7	0	75084	\N
17751	5242	9	0	75100	\N
17751	322	70	0	75101	\N
17751	5244	71	1	75102	\N
17751	5243	71	0	75103	\N
17753	402	3	0	75110	\N
17753	4077	4	0	75111	\N
17755	167	4	0	73614	\N
17755	4048	5	0	75127	\N
17756	4178	12	0	75083	\N
17756	5083	13	0	75152	\N
17764	64	3	0	73890	\N
17764	4217	4	0	75172	\N
17768	365	7	0	75203	\N
17768	5248	8	0	75204	\N
17771	75	15	0	75243	\N
17771	5250	16	0	75244	\N
17774	56	10	0	75277	\N
17774	4602	11	0	75278	\N
17776	841	4	0	75098	\N
17776	3886	5	0	75099	\N
17781	273	3	0	75317	\N
17781	3638	4	0	75318	\N
17787	198	0	0	72924	\N
17791	198	0	0	72924	\N
17792	198	0	0	72924	\N
17798	16	3	0	75381	\N
17798	3634	4	0	75382	\N
17800	264	3	0	64483	\N
17800	3632	4	0	73899	\N
17803	264	1	0	64483	\N
17803	270	2	0	75393	\N
17808	241	1	0	70271	\N
17808	333	2	0	75414	\N
17809	4172	10	0	75433	\N
17809	4663	11	0	75434	\N
17812	4787	2	0	73937	\N
17812	5258	3	0	75446	\N
17814	181	3	0	73874	\N
17814	5260	4	0	75455	\N
17819	212	3	0	75467	\N
17819	3639	4	0	75468	\N
17824	273	6	0	75505	\N
17824	4212	7	0	75506	\N
17829	40	3	0	75525	\N
17829	372	4	0	75526	\N
17834	1470	7	0	75543	\N
17834	5261	8	0	75544	\N
17839	88	6	0	75553	\N
17839	5263	7	0	75565	\N
17844	177	4	0	75580	\N
17844	3538	5	0	75581	\N
17848	14	3	0	74598	\N
17848	4272	4	0	75527	\N
17853	151	4	0	71724	\N
17853	3499	5	0	75613	\N
17854	595	3	0	70634	\N
17854	3654	4	0	73854	\N
17858	258	3	0	75631	\N
17858	4401	4	0	75632	\N
17859	3004	3	0	75639	\N
17859	5266	4	0	75640	\N
17863	67	4	0	75652	\N
17863	5267	5	0	75653	\N
17866	4889	36	0	75682	\N
17866	5268	37	0	75683	\N
17866	5269	37	0	75684	\N
17872	189	3	0	74728	\N
17872	3782	4	0	75738	\N
17873	40	3	0	75525	\N
17873	372	4	0	75526	\N
17878	228	3	0	75012	\N
17878	3186	4	0	75641	\N
17879	260	10	0	75784	\N
17879	5270	11	0	75785	\N
17880	2761	2	0	75790	\N
17880	192	4	0	75793	\N
17880	2944	5	0	75794	\N
17885	367	7	0	75815	\N
17885	4792	8	0	75816	\N
17890	360	6	0	75843	\N
17890	5271	7	0	75844	\N
17895	451	3	0	75859	\N
17895	3934	4	0	75860	\N
17897	202	17	0	75938	\N
17897	5275	18	0	75939	\N
17903	110	7	0	75563	\N
17903	4621	8	0	75569	\N
17908	320	2	0	74180	\N
17908	4528	3	0	75987	\N
17913	2782	6	0	76008	\N
17913	5279	7	0	76009	\N
17921	4178	4	0	76040	\N
17921	4205	5	0	76059	\N
17922	2	3	0	74178	\N
17922	3548	4	0	74179	\N
17927	3806	4	0	76085	\N
17927	224	5	0	76086	\N
17931	79	4	0	76074	\N
17931	3678	5	0	76097	\N
17932	424	7	0	74176	\N
17932	4986	8	0	76113	\N
17933	4172	4	0	76122	\N
17933	4219	5	0	76123	\N
17937	449	3	0	73570	\N
17937	4760	4	0	76135	\N
17938	35	3	0	76142	\N
17938	3563	4	0	76143	\N
17943	449	3	0	76166	\N
17943	4760	4	0	76167	\N
17948	64	7	0	73890	\N
17948	5286	8	0	76193	\N
17949	170	3	0	65432	\N
17949	4148	4	0	76200	\N
17955	5290	4	0	76244	\N
17961	5293	94	0	76342	\N
17961	2111	95	0	76343	\N
17962	2246	7	0	32314	\N
17962	5294	8	0	76358	\N
17963	230	3	0	76191	\N
17963	4181	4	0	76365	\N
17964	2636	10	0	76386	\N
17964	5295	11	0	76387	\N
17969	113	2	0	69633	\N
17969	1899	3	0	76399	\N
17974	113	8	0	69633	\N
17974	5299	9	0	76426	\N
17979	320	3	0	74180	\N
17979	4821	4	0	76450	\N
17980	56	6	0	75756	\N
17980	4703	7	0	76463	\N
17990	4172	5	0	76564	\N
17990	4415	6	0	76565	\N
17992	4178	12	0	76591	\N
17992	5304	13	0	76592	\N
17993	77	3	0	76599	\N
17736	5235	12	0	75036	\N
17740	4516	5	0	75062	\N
17740	324	8	0	75063	\N
17740	5239	9	1	75064	\N
17740	5238	9	0	75065	\N
17742	3341	5	0	75066	\N
17742	79	8	0	75067	\N
17742	3180	9	0	75068	\N
17744	4516	5	0	75062	\N
17744	324	8	0	75063	\N
17744	3000	9	0	75069	\N
17747	324	6	0	75085	\N
17750	841	4	0	75098	\N
17750	3886	5	0	75099	\N
17754	202	3	0	72828	\N
17754	4857	4	0	75118	\N
17758	69	12	0	71428	\N
17758	5246	13	0	75155	\N
17760	79	3	0	73845	\N
17760	3652	4	0	73846	\N
17762	4178	3	0	75170	\N
17762	4211	4	0	75171	\N
17766	258	7	0	63687	\N
17766	5247	8	0	75187	\N
17769	75	3	0	75211	\N
17769	3855	4	0	75212	\N
17770	4172	15	0	75241	\N
17770	5249	16	0	75242	\N
17772	4178	4	0	75253	\N
17772	4205	5	0	75254	\N
17780	411	6	0	73402	\N
17780	5252	7	0	75310	\N
17783	4172	3	0	75241	\N
17783	4275	4	0	75327	\N
17785	198	3	0	75334	\N
17785	4263	4	0	75335	\N
17789	927	3	0	8544	\N
17789	5253	4	0	75338	\N
17793	268	7	0	75353	\N
17793	5254	8	0	75354	\N
17795	40	7	0	74157	\N
17795	4718	8	0	75357	\N
17797	242	5	0	75373	\N
17797	4562	6	0	75374	\N
17801	110	3	0	75391	\N
17801	2995	4	0	75392	\N
17805	110	5	0	75391	\N
17805	5256	6	0	75398	\N
17807	110	7	0	75391	\N
17807	5257	8	0	75411	\N
17810	94	2	0	75439	\N
17810	2043	3	0	75440	\N
17816	132	3	0	75457	\N
17816	1423	4	0	75458	\N
17818	16	3	0	75465	\N
17818	3634	4	0	75466	\N
17820	56	3	0	75336	\N
17820	4109	4	0	75337	\N
17827	214	4	0	75517	\N
17827	3807	5	0	75518	\N
17831	251	3	0	73630	\N
17831	3514	4	0	73631	\N
17832	20	0	0	75528	\N
17837	54	6	0	75561	\N
17837	5204	7	0	75562	\N
17841	110	7	0	75563	\N
17841	4621	8	0	75569	\N
17846	40	9	0	75525	\N
17846	4712	10	0	75586	\N
17850	71	2	0	74836	\N
17850	1125	3	0	74837	\N
17851	360	3	0	75602	\N
17851	3602	4	0	75603	\N
17856	51	3	0	74833	\N
17856	3533	4	0	75624	\N
17861	35	3	0	75642	\N
17861	3563	4	0	75643	\N
17870	4178	4	0	75729	\N
17870	4205	5	0	75730	\N
17875	4172	4	0	75754	\N
17875	4219	5	0	75755	\N
17882	2761	2	0	75790	\N
17882	192	4	0	75793	\N
17882	2944	5	0	75794	\N
17888	151	4	0	75829	\N
17888	1876	5	0	75833	\N
17892	360	4	0	75843	\N
17892	3513	5	0	75848	\N
17893	4172	3	0	75855	\N
17893	4275	4	0	75856	\N
17900	365	7	0	75203	\N
17900	5248	8	0	75204	\N
17901	117	7	0	75970	\N
17901	5276	8	0	75971	\N
17905	110	10	0	75563	\N
17905	5277	11	0	75978	\N
17906	4178	2	0	75983	\N
17906	4527	3	0	75984	\N
17910	391	2	0	74022	\N
17910	2966	3	0	75993	\N
17911	4172	6	0	75855	\N
17911	5278	7	0	76006	\N
17917	4178	3	0	76040	\N
17917	4211	4	0	76041	\N
17924	264	3	0	64483	\N
17924	3632	4	0	73899	\N
17929	79	4	0	76074	\N
17929	3678	5	0	76097	\N
17935	2	3	0	76132	\N
17935	3548	4	0	76133	\N
17940	12	3	0	76152	\N
17940	4204	4	0	76153	\N
17946	62	7	0	71896	\N
17946	4781	8	0	71897	\N
17952	27	3	0	73485	\N
17952	4636	4	0	73827	\N
17957	54	4	0	75561	\N
17957	3685	5	0	76255	\N
17960	2111	6	0	76296	\N
17960	5292	7	0	76297	\N
17966	251	10	0	76389	\N
17966	5297	11	0	76390	\N
17967	1470	2	0	76395	\N
17967	3368	3	0	76396	\N
17972	16	7	0	76416	\N
17972	4723	8	0	76417	\N
17977	16	4	0	76416	\N
17977	2575	5	0	76439	\N
17986	241	4	0	70271	\N
17986	2122	5	0	76534	\N
17987	273	4	0	76543	\N
17987	3390	5	0	76544	\N
17991	56	5	0	75756	\N
17991	3551	6	0	76566	\N
17995	233	3	0	76652	\N
17995	3704	4	0	76653	\N
17997	4088	3	0	73645	\N
17997	4506	4	0	73646	\N
18002	164	3	0	72446	\N
18002	3385	4	0	72447	\N
18004	164	3	0	72446	\N
18004	3385	4	0	72447	\N
18013	102	7	0	74720	\N
18013	5310	8	0	76728	\N
18015	242	4	0	76739	\N
18015	3512	5	0	76740	\N
18018	73	3	0	76756	\N
18018	3040	4	0	76757	\N
18020	4178	4	0	76766	\N
18020	4205	5	0	76767	\N
18025	4172	2	0	76805	\N
18025	4191	3	0	76806	\N
18028	42	3	0	72291	\N
18028	3645	4	0	76818	\N
18041	2	2	0	76862	\N
17737	3551	5	0	75047	\N
17737	56	8	0	75052	\N
17737	2914	9	0	75053	\N
17745	4420	5	0	75056	\N
17745	852	6	0	75070	\N
17748	324	6	0	75085	\N
17748	5241	7	0	75087	\N
17752	360	3	0	74224	\N
17752	3602	4	0	74225	\N
17763	262	3	0	74353	\N
17763	4778	4	0	74354	\N
17765	402	3	0	75110	\N
17765	4077	4	0	75111	\N
17767	4178	7	0	75170	\N
17767	4396	8	0	75202	\N
17773	23	4	0	75255	\N
17773	3189	5	0	75256	\N
17778	140	0	0	75296	\N
17786	528	3	0	69371	\N
17786	4262	4	0	69839	\N
17790	198	0	0	72924	\N
17799	4178	3	0	75389	\N
17799	4211	4	0	75390	\N
17802	18	3	0	74167	\N
17802	3621	4	0	74168	\N
17806	71	5	0	74836	\N
17806	4033	6	0	75405	\N
17811	230	2	0	74898	\N
17811	3006	3	0	75445	\N
17813	38	3	0	75453	\N
17813	5259	4	0	75454	\N
17821	4178	4	0	75389	\N
17821	4205	5	0	75483	\N
17823	4172	3	0	75484	\N
17823	4275	4	0	75492	\N
17828	391	3	0	74022	\N
17828	3660	4	0	74023	\N
17833	1470	7	0	75543	\N
17833	5261	8	0	75544	\N
17838	110	6	0	75563	\N
17838	3917	7	0	75564	\N
17842	18	6	0	75570	\N
17842	4180	7	0	75571	\N
17843	60	4	0	75578	\N
17843	3894	5	0	75579	\N
17847	40	4	0	75525	\N
17847	3381	5	0	75587	\N
17852	4178	4	0	75611	\N
17852	4205	5	0	75612	\N
17857	597	3	0	69316	\N
17857	3656	4	0	73855	\N
17862	4178	4	0	75611	\N
17862	4205	5	0	75612	\N
17871	92	4	0	73499	\N
17871	3979	5	0	75731	\N
17876	56	4	0	75756	\N
17876	3127	5	0	75757	\N
17877	288	3	0	73941	\N
17877	3003	4	0	73942	\N
17883	282	2	0	75798	\N
17883	40	4	0	75799	\N
17883	1383	5	0	75800	\N
17884	367	7	0	75815	\N
17884	4792	8	0	75816	\N
17889	42	6	0	72291	\N
17889	1945	7	0	75842	\N
17894	288	3	0	75857	\N
17894	3003	4	0	75858	\N
17902	18	7	0	75972	\N
17902	1618	8	0	75973	\N
17907	132	2	0	75985	\N
17907	2927	3	0	75986	\N
17912	96	6	0	75153	\N
17912	3698	7	0	76007	\N
17918	1470	3	0	76042	\N
17918	3838	4	0	76043	\N
17923	100	3	0	76072	\N
17923	3836	4	0	76073	\N
17928	4178	4	0	76095	\N
17928	4205	5	0	76096	\N
17934	23	2	0	75255	\N
17934	3443	3	0	76128	\N
17939	35	4	0	76142	\N
17939	3545	5	0	76145	\N
17944	365	3	0	75203	\N
17944	3839	4	0	76174	\N
17945	33	7	0	76189	\N
17945	5284	8	0	76190	\N
17950	151	3	0	76207	\N
17950	3046	4	0	76208	\N
17951	140	4	0	75296	\N
17951	3821	5	0	76217	\N
17956	142	3	0	76245	\N
17956	4254	4	0	76246	\N
17959	1021	59	0	76282	\N
17959	5291	60	0	76283	\N
17965	2	10	0	76132	\N
17965	5296	11	0	76388	\N
17970	40	2	0	76400	\N
17970	282	3	0	75799	\N
17971	40	2	0	76400	\N
17971	66	3	0	76405	\N
17975	69	8	0	71428	\N
17975	5301	9	1	76427	\N
17975	5300	9	0	76428	\N
17976	117	4	0	76437	\N
17976	4169	5	0	76438	\N
17981	40	6	0	76464	\N
17981	4255	7	0	76465	\N
17982	75	8	0	76482	\N
17982	5302	9	0	76483	\N
17983	94	8	0	76010	\N
17983	5303	9	0	76500	\N
17984	4178	8	0	76516	\N
17984	4237	9	0	76517	\N
17985	260	3	0	76524	\N
17985	3399	4	0	76525	\N
17988	137	3	0	76551	\N
17988	3633	4	0	76552	\N
17989	135	3	0	70671	\N
17989	3630	4	0	76553	\N
17999	4233	5	0	76670	\N
17999	4518	6	0	76671	\N
18001	40	5	0	76673	\N
18001	2714	6	0	76674	\N
18006	151	6	0	76688	\N
18006	5308	7	1	76691	\N
18006	5238	7	0	76692	\N
18009	56	4	0	76707	\N
18009	3127	5	0	76708	\N
18010	16	4	0	76717	\N
18010	3546	5	0	76718	\N
18017	402	3	0	76754	\N
18017	4077	4	0	76755	\N
18022	260	6	0	76782	\N
18022	5311	7	0	76783	\N
18027	1470	2	0	76395	\N
18027	3368	3	0	76396	\N
18031	16	3	0	76822	\N
18031	3634	4	0	76823	\N
18034	451	15	0	75859	\N
18034	5312	16	0	76837	\N
18035	451	4	0	75859	\N
18035	3391	5	0	76838	\N
18036	391	3	0	76845	\N
18036	3660	4	0	76846	\N
18037	4172	3	0	76805	\N
18037	4275	4	0	76847	\N
18047	4172	2	0	76891	\N
18047	4191	3	0	76892	\N
18049	16	2	0	76894	\N
18049	388	3	0	76895	\N
18051	71	3	0	74836	\N
18051	3770	4	0	76902	\N
18054	2636	3	0	76386	\N
18054	5314	4	0	76919	\N
18057	1048	2	0	76921	\N
17777	206	3	0	74214	\N
17777	4584	4	0	75295	\N
17779	367	0	0	75297	\N
17782	4178	3	0	75325	\N
17782	4211	4	0	75326	\N
17784	198	0	0	72924	\N
17788	56	3	0	75336	\N
17788	4109	4	0	75337	\N
17794	149	7	0	75355	\N
17794	5255	8	0	75356	\N
17796	4172	2	0	75241	\N
17796	4285	3	0	75362	\N
17804	110	5	0	75391	\N
17804	5256	6	0	75398	\N
17815	56	3	0	75336	\N
17815	4102	4	0	75456	\N
17822	4172	4	0	75484	\N
17822	4219	5	0	75485	\N
17825	2	6	0	74178	\N
17825	4825	7	0	75507	\N
17826	181	4	0	73874	\N
17826	4058	5	0	75516	\N
17830	14	3	0	74598	\N
17830	4272	4	0	75527	\N
17835	1470	7	0	75543	\N
17835	5261	8	0	75544	\N
17836	88	4	0	75553	\N
17836	5262	5	0	75554	\N
17840	678	0	0	75566	\N
17845	60	3	0	75578	\N
17845	3585	4	0	75583	\N
17849	841	3	0	75594	\N
17849	3604	4	0	75595	\N
17855	5264	19	0	75620	\N
17855	147	126	0	75622	\N
17855	5265	127	0	75623	\N
17860	228	3	0	75012	\N
17860	3186	4	0	75641	\N
17864	206	4	0	75654	\N
17864	3511	5	0	75655	\N
17865	117	3	0	75662	\N
17865	3653	4	0	75663	\N
17867	4178	8	0	75611	\N
17867	4218	9	0	75699	\N
17868	73	9	0	75718	\N
17868	4622	10	0	75719	\N
17869	92	1	0	73499	\N
17869	1078	2	0	75720	\N
17874	86	4	0	72867	\N
17874	4052	5	0	75753	\N
17881	4247	2	0	75795	\N
17881	4178	4	0	75796	\N
17881	4460	5	0	75797	\N
17887	151	6	0	75829	\N
17887	3588	7	0	75830	\N
17891	251	6	0	75845	\N
17891	5272	7	0	75846	\N
17896	5273	104	0	75889	\N
17896	451	126	0	75902	\N
17896	5274	127	0	75903	\N
17898	23	17	0	75255	\N
17898	3190	18	0	75940	\N
17899	4178	7	0	75729	\N
17899	4396	8	0	75955	\N
17904	71	7	0	74836	\N
17904	4793	8	0	75974	\N
17909	365	2	0	75203	\N
17909	5072	3	0	75992	\N
17914	94	6	0	76010	\N
17914	5280	7	0	76011	\N
17915	79	3	0	73845	\N
17915	3652	4	0	73846	\N
17916	242	7	0	76032	\N
17916	4592	8	0	76033	\N
17919	5281	0	0	76044	\N
17919	5282	0	0	76045	\N
17920	212	2	0	75467	\N
17920	3616	3	0	76050	\N
17925	79	3	0	76074	\N
17925	3652	4	0	76075	\N
17926	4219	4	0	76083	\N
17926	4172	5	0	76084	\N
17930	79	4	0	76074	\N
17930	2435	5	1	76098	\N
17930	5283	5	0	76099	\N
17936	23	3	0	75255	\N
17936	3497	4	0	76134	\N
17941	12	4	0	76152	\N
17941	4043	5	0	76157	\N
17942	2636	3	0	76164	\N
17942	2837	4	0	76165	\N
17947	230	7	0	76191	\N
17947	5285	8	0	76192	\N
17953	5287	62	0	76224	\N
17953	27	126	0	76233	\N
17953	5288	127	0	76234	\N
17954	202	3	0	76241	\N
17954	4857	4	0	76242	\N
17958	56	4	0	75756	\N
17958	3127	5	0	75757	\N
17968	4178	2	0	76397	\N
17968	4247	3	0	76398	\N
17973	69	8	0	71428	\N
17973	5298	9	0	76425	\N
17978	140	4	0	76448	\N
17978	3821	5	0	76449	\N
17998	4172	2	0	76564	\N
17998	4191	3	0	76660	\N
18000	285	5	0	74587	\N
18000	5103	6	0	76672	\N
18007	453	10	0	72630	\N
18007	5309	11	0	76705	\N
18011	16	5	0	76717	\N
18011	5175	6	0	76722	\N
18014	40	7	0	76729	\N
18014	4718	8	0	76730	\N
18016	4233	3	0	76670	\N
18016	4425	4	0	76747	\N
18019	73	2	0	76756	\N
18019	2766	3	0	76759	\N
18023	4178	3	0	76766	\N
18023	4211	4	0	76790	\N
18029	140	3	0	76819	\N
18029	4149	4	0	76820	\N
18032	16	2	0	76822	\N
18032	388	3	0	76828	\N
18033	117	4	0	76437	\N
18033	4169	5	0	76438	\N
18038	4172	2	0	76852	\N
18038	4191	3	0	76853	\N
18039	181	2	0	76854	\N
18039	3313	3	0	76855	\N
18044	88	3	0	75553	\N
18044	3655	4	0	76877	\N
18048	132	2	0	75985	\N
18048	2756	3	0	76893	\N
18050	228	3	0	75012	\N
18050	3186	4	0	75641	\N
18055	960	3	0	8954	\N
18055	5315	4	0	76920	\N
18061	18	6	0	75972	\N
18061	5318	7	0	76950	\N
18063	110	1	0	75563	\N
18063	134	2	0	76954	\N
18065	110	3	0	75563	\N
18065	3328	4	0	76960	\N
18068	42	2	0	76977	\N
18068	3310	3	0	76978	\N
18070	181	2	0	76854	\N
18070	3313	3	0	76855	\N
18072	793	2	0	76982	\N
18072	4363	3	0	76983	\N
18075	1151	7	0	47574	\N
18075	5321	8	0	77009	\N
18078	224	2	0	18546	\N
18078	3150	3	0	74772	\N
18084	62	7	0	71896	\N
17993	1877	4	0	76600	\N
17994	5305	20	0	76608	\N
17994	77	98	0	76644	\N
17994	5306	99	0	76645	\N
17996	94	3	0	76654	\N
17996	2864	4	0	76655	\N
18003	40	0	0	76681	\N
18005	151	6	0	76688	\N
18008	453	4	0	72630	\N
18008	4108	5	0	76706	\N
18012	102	2	0	74720	\N
18012	3053	3	0	76727	\N
18021	16	4	0	76768	\N
18021	3546	5	0	76769	\N
18024	113	4	0	76799	\N
18024	3677	5	0	76800	\N
18026	266	2	0	75279	\N
18026	2103	3	0	76807	\N
18030	132	3	0	75985	\N
18030	3729	4	0	76821	\N
18040	336	2	0	76860	\N
18040	3332	3	0	76861	\N
18042	435	19	0	71910	\N
18042	5313	20	0	76868	\N
18046	4178	3	0	76885	\N
18046	4441	4	0	76886	\N
18056	2636	3	0	76386	\N
18056	5314	4	0	76919	\N
18058	38	6	0	75453	\N
18058	3276	7	0	76935	\N
18059	373	6	0	74903	\N
18059	5316	7	0	76936	\N
18066	2	1	0	76963	\N
18066	26	2	0	76964	\N
18073	360	4	0	75843	\N
18073	4330	5	0	76992	\N
18076	94	5	0	76654	\N
18076	4547	6	0	77020	\N
18086	88	7	0	75553	\N
18086	5323	8	0	77066	\N
18089	5287	62	0	77074	\N
18089	27	126	0	77077	\N
18089	5324	127	0	77078	\N
18091	453	3	0	77089	\N
18091	2838	4	0	77090	\N
18093	18	3	0	75972	\N
18093	3621	4	0	77093	\N
18096	258	2	0	77104	\N
18096	3275	3	0	77105	\N
18098	16	2	0	76894	\N
18098	388	3	0	76895	\N
18101	56	4	0	76707	\N
18101	3556	5	0	77138	\N
18108	164	3	0	72446	\N
18108	1807	4	0	77163	\N
18110	56	3	0	77175	\N
18110	4109	4	0	77176	\N
18113	4172	2	0	77185	\N
18113	4191	3	0	77186	\N
18120	2351	3	0	74917	\N
18120	2845	4	0	74918	\N
18125	4172	5	0	77185	\N
18125	4415	6	0	77254	\N
18128	12	7	0	77281	\N
18128	5332	8	0	77282	\N
18131	2351	3	0	74917	\N
18131	2845	4	0	74918	\N
18145	4088	2	0	77408	\N
18145	4332	3	0	77409	\N
18147	12	2	0	77281	\N
18147	2804	3	0	77411	\N
18150	5336	13	0	77444	\N
18150	453	16	0	77449	\N
18150	3133	17	0	77450	\N
18152	5336	13	0	77444	\N
18152	453	16	0	77449	\N
18152	3133	17	0	77450	\N
18154	5339	13	0	77489	\N
18154	132	16	0	77490	\N
18154	2927	17	0	77491	\N
18155	189	14	0	77519	\N
18155	5340	15	0	77520	\N
18160	145	6	0	70577	\N
18160	5341	7	0	77553	\N
18165	4178	3	0	77582	\N
18165	4211	4	0	77583	\N
18168	56	10	0	77620	\N
18168	4602	11	0	77621	\N
18171	4178	6	0	77644	\N
18171	4250	7	0	77645	\N
18174	140	5	0	77668	\N
18174	5000	6	0	77669	\N
18177	5344	0	0	77694	\N
18177	5345	0	0	77695	\N
18179	79	2	0	76074	\N
18179	616	3	0	77701	\N
18184	4172	0	0	77709	\N
18186	4787	5	0	73937	\N
18186	5349	6	0	77727	\N
18197	60	2	0	77751	\N
18197	4544	3	0	77752	\N
18199	56	4	0	77757	\N
18199	3556	5	0	77758	\N
18208	852	1	0	75060	\N
18208	2945	2	0	77784	\N
18210	40	3	0	77539	\N
18210	1921	4	0	77790	\N
18211	285	10	0	74587	\N
18211	5366	11	0	77806	\N
18213	451	10	0	77807	\N
18213	5367	11	0	77809	\N
18215	121	4	0	77818	\N
18215	4099	5	0	77819	\N
18217	121	0	0	77818	\N
18224	42	5	0	76977	\N
18224	4860	6	0	77855	\N
18229	4172	3	0	77780	\N
18229	4275	4	0	77920	\N
18238	336	2	0	77930	\N
18238	3332	3	0	77931	\N
18240	94	2	0	77959	\N
18240	2794	3	0	77960	\N
18245	230	2	0	76979	\N
18245	3307	3	0	76980	\N
18248	2644	3	0	78008	\N
18248	793	4	0	78009	\N
18251	16	2	0	78029	\N
18251	388	3	0	78030	\N
18255	18	2	0	77378	\N
18255	1685	3	0	77379	\N
18257	367	1	0	78048	\N
18257	3225	2	0	78049	\N
18267	135	2	0	78097	\N
18267	2722	3	0	78098	\N
18269	244	1	0	74822	\N
18269	245	2	0	78102	\N
18273	4178	5	0	78130	\N
18273	4429	6	0	78131	\N
18275	1109	4	0	78140	\N
18275	4535	5	0	78141	\N
18279	94	2	0	77959	\N
18279	2794	3	0	77960	\N
18285	4172	3	0	78215	\N
18285	4275	4	0	78216	\N
18287	110	4	0	78217	\N
18287	4552	5	0	78221	\N
18292	595	3	0	70634	\N
18292	3654	4	0	73854	\N
18297	4178	2	0	78130	\N
18297	4247	3	0	78268	\N
18305	5319	2	0	78287	\N
18305	5383	3	0	78288	\N
18307	86	3	0	72867	\N
18307	3746	4	0	78296	\N
18318	4178	2	0	78130	\N
18041	2789	3	0	76863	\N
18043	4	3	0	76875	\N
18043	3837	4	0	76876	\N
18045	40	3	0	76729	\N
18045	372	4	0	76878	\N
18052	4178	4	0	76911	\N
18052	4331	5	0	76912	\N
18067	5319	3	0	76971	\N
18067	5320	4	0	76972	\N
18074	135	4	0	76993	\N
18074	4353	5	0	76994	\N
18080	4172	3	0	77035	\N
18080	4275	4	0	77036	\N
18082	4178	2	0	77041	\N
18082	4247	3	0	77042	\N
18092	113	3	0	77091	\N
18092	3620	4	0	77092	\N
18094	324	2	0	77098	\N
18094	2808	3	0	77099	\N
18099	2636	2	0	77122	\N
18099	2836	3	0	77123	\N
18102	388	2	0	77143	\N
18102	5325	3	0	77144	\N
18102	5326	3	0	77145	\N
18109	5327	16	0	77167	\N
18109	164	17	0	77168	\N
18112	4178	2	0	77183	\N
18112	4247	3	0	77184	\N
18119	841	3	0	77230	\N
18119	3604	4	0	77231	\N
18121	251	3	0	77232	\N
18121	3514	4	0	77233	\N
18124	142	5	0	76245	\N
18124	3781	6	0	77253	\N
18126	241	58	0	77263	\N
18126	5331	59	0	77264	\N
18129	4172	4	0	77291	\N
18129	4252	5	0	77292	\N
18134	186	2	0	77308	\N
18134	1850	3	0	77309	\N
18136	4178	7	0	77183	\N
18136	4509	8	0	77370	\N
18138	79	7	0	76074	\N
18138	4063	8	0	77373	\N
18140	18	2	0	77378	\N
18140	1685	3	0	77379	\N
18143	149	5	0	75355	\N
18143	3808	6	0	77397	\N
18158	149	7	0	77537	\N
18158	5255	8	0	77538	\N
18161	2351	4	0	77562	\N
18161	3494	5	0	77563	\N
18163	82	4	0	73866	\N
18163	3508	5	0	77566	\N
18169	2	3	0	77628	\N
18169	3548	4	0	77629	\N
18178	488	2	0	77395	\N
18178	2791	3	0	77700	\N
18180	96	3	0	75153	\N
18180	2803	4	0	77708	\N
18182	189	3	0	77711	\N
18182	3782	4	0	77712	\N
18187	40	5	0	77539	\N
18187	5350	6	1	77728	\N
18187	3013	6	0	77729	\N
18187	1075	7	0	77730	\N
18189	79	5	0	77731	\N
18189	3341	6	0	77732	\N
18192	189	5	0	77711	\N
18192	5353	6	1	77735	\N
18192	5352	6	0	77736	\N
18192	5355	7	1	77737	\N
18192	5354	7	0	77738	\N
18192	5357	8	1	77739	\N
18192	5356	8	0	77740	\N
18192	5358	9	0	77741	\N
18193	79	5	0	77731	\N
18193	2519	6	1	77742	\N
18193	5359	6	0	77743	\N
18193	1075	7	0	77730	\N
18196	79	5	0	77731	\N
18196	3593	6	1	77745	\N
18196	5360	6	0	77746	\N
18196	4014	7	0	62870	\N
18198	60	2	0	77751	\N
18198	4544	3	0	77752	\N
18202	40	6	0	77766	\N
18202	2777	7	0	77767	\N
18204	113	6	0	77091	\N
18204	5363	7	0	77778	\N
18206	4172	6	0	77780	\N
18206	5365	7	0	77781	\N
18216	233	4	0	76652	\N
18216	3775	5	0	77820	\N
18218	273	5	0	77828	\N
18218	5368	6	0	77829	\N
18220	164	2	0	77836	\N
18220	1124	3	0	77837	\N
18222	5369	14	0	77841	\N
18222	435	15	0	77842	\N
18225	1470	3	0	77862	\N
18225	3838	4	0	77863	\N
18227	5371	13	0	77864	\N
18227	1470	126	0	77903	\N
18227	5372	127	0	77904	\N
18232	40	2	0	77539	\N
18232	282	3	0	77932	\N
18234	73	2	0	77942	\N
18234	2766	3	0	77943	\N
18241	202	5	0	76241	\N
18241	5374	6	0	77971	\N
18243	79	5	0	77974	\N
18243	3341	6	0	77975	\N
18249	1018	2	0	77730	\N
18249	5376	2	0	78014	\N
18249	5378	3	1	78015	\N
18249	5377	3	0	78016	\N
18249	1075	4	0	78017	\N
18253	75	2	0	78032	\N
18253	284	3	0	78033	\N
18258	367	3	0	78048	\N
18258	3683	4	0	78054	\N
18262	4178	2	0	78066	\N
18262	4247	3	0	78067	\N
18265	4178	2	0	78085	\N
18265	4247	3	0	78086	\N
18270	4178	2	0	78085	\N
18270	4247	3	0	78086	\N
18280	173	2	0	78159	\N
18280	2102	3	0	78160	\N
18281	33	2	0	78165	\N
18281	2822	3	0	78166	\N
18282	156	5	0	78177	\N
18282	4295	6	0	78178	\N
18286	110	3	0	78217	\N
18286	2995	4	0	78218	\N
18289	30	6	0	61826	\N
18289	2719	7	0	78245	\N
18291	173	3	0	78251	\N
18291	3796	4	0	78252	\N
18298	391	2	0	78269	\N
18298	1381	3	0	78270	\N
18299	60	2	0	77751	\N
18299	4544	3	0	77752	\N
18301	40	3	0	78044	\N
18301	372	4	0	78278	\N
18303	4172	3	0	78279	\N
18303	4275	4	0	78280	\N
18309	266	19	0	78335	\N
18309	5385	20	0	78336	\N
18311	69	2	0	78343	\N
18311	3350	3	0	78344	\N
18314	54	3	0	78353	\N
18314	3041	4	0	78354	\N
18319	135	2	0	78097	\N
18319	2722	3	0	78098	\N
18326	123	3	0	78417	\N
18057	1021	4	0	76922	\N
18057	1022	5	0	76923	\N
18060	54	6	0	76948	\N
18060	5317	7	0	76949	\N
18062	2	6	0	76862	\N
18062	4550	7	0	76951	\N
18064	6	1	0	76955	\N
18064	194	2	0	76956	\N
18069	230	2	0	76979	\N
18069	3307	3	0	76980	\N
18071	30	2	0	61826	\N
18071	1127	3	0	76981	\N
18077	170	2	0	77025	\N
18077	1380	3	0	77026	\N
18079	365	3	0	77033	\N
18079	3839	4	0	77034	\N
18081	264	3	0	64483	\N
18081	3632	4	0	73899	\N
18085	62	19	0	71896	\N
18085	4340	20	0	77065	\N
18087	27	2	0	77071	\N
18087	645	3	0	77072	\N
18104	33	4	0	76189	\N
18104	4806	5	0	77154	\N
18106	73	2	0	77159	\N
18106	2766	3	0	77160	\N
18111	121	2	0	77181	\N
18111	2498	3	0	77182	\N
18115	44	35	0	74554	\N
18115	5328	36	0	77198	\N
18118	391	11	0	76845	\N
18118	5330	12	0	77223	\N
18123	69	0	0	71428	\N
18133	56	2	0	77306	\N
18133	2795	3	0	77307	\N
18141	90	2	0	67988	\N
18141	3442	3	0	77384	\N
18146	233	2	0	76652	\N
18146	1849	3	0	77410	\N
18148	56	3	0	77306	\N
18148	4109	4	0	77418	\N
18151	5336	13	0	77444	\N
18151	453	16	0	77449	\N
18151	3133	17	0	77450	\N
18153	5337	63	0	77455	\N
18153	132	126	0	77487	\N
18153	5338	127	0	77488	\N
18156	189	14	0	77519	\N
18156	5340	15	0	77520	\N
18166	449	4	0	76166	\N
18166	5343	5	0	77592	\N
18172	210	6	0	77646	\N
18172	3721	7	0	77647	\N
18175	4172	5	0	77670	\N
18175	4415	6	0	77671	\N
18176	170	11	0	77692	\N
18176	3880	12	0	77693	\N
18185	4787	5	0	73937	\N
18185	4014	6	1	77723	\N
18185	5346	6	0	77724	\N
18185	5348	7	1	77725	\N
18185	5347	7	0	77726	\N
18188	4787	5	0	73937	\N
18188	5349	6	0	77727	\N
18190	1914	5	0	77733	\N
18190	5351	6	0	77734	\N
18194	189	5	0	77711	\N
18194	4540	6	0	77744	\N
18200	214	4	0	75517	\N
18200	3355	5	0	77759	\N
18205	262	6	0	74353	\N
18205	5364	7	0	77779	\N
18207	852	0	0	75060	\N
18209	852	3	0	75060	\N
18209	1848	4	0	77789	\N
18212	451	3	0	77807	\N
18212	5274	4	0	77808	\N
18214	4088	4	0	77408	\N
18214	4089	5	0	77817	\N
18219	4178	5	0	77830	\N
18219	4202	6	0	77831	\N
18221	424	2	0	77838	\N
18221	2755	3	0	77839	\N
18230	142	2	0	76245	\N
18230	4418	3	0	77925	\N
18235	90	1	0	77946	\N
18235	2897	2	0	77947	\N
18237	40	2	0	77951	\N
18237	282	3	0	77952	\N
18239	235	2	0	77957	\N
18239	2757	3	0	77958	\N
18244	202	2	0	76241	\N
18244	2764	3	0	77980	\N
18246	4178	2	0	77985	\N
18246	4247	3	0	77986	\N
18247	156	7	0	72483	\N
18247	5375	8	0	78001	\N
18250	140	27	0	77668	\N
18250	5379	28	0	78028	\N
18256	40	4	0	78044	\N
18256	2796	5	0	78045	\N
18260	75	3	0	78032	\N
18260	3855	4	0	78055	\N
18263	4178	5	0	78078	\N
18263	4429	6	0	78079	\N
18268	137	2	0	76551	\N
18268	2721	3	0	78099	\N
18271	4172	5	0	78117	\N
18271	4415	6	0	78118	\N
18276	4172	3	0	78148	\N
18276	4275	4	0	78149	\N
18277	841	2	0	77230	\N
18277	3316	3	0	78154	\N
18283	54	2	0	76948	\N
18283	3351	3	0	78183	\N
18288	200	7	0	74783	\N
18288	5382	8	0	78233	\N
18293	56	3	0	77757	\N
18293	4109	4	0	78259	\N
18295	595	3	0	70634	\N
18295	3654	4	0	73854	\N
18304	108	2	0	78285	\N
18304	3340	3	0	78286	\N
18306	453	2	0	77089	\N
18306	3366	3	0	78289	\N
18312	367	3	0	78351	\N
18312	3683	4	0	78352	\N
18316	279	3	0	73810	\N
18316	3641	4	0	74198	\N
18320	137	2	0	78393	\N
18320	2721	3	0	78394	\N
18324	4178	2	0	78130	\N
18324	4247	3	0	78268	\N
18329	56	5	0	78434	\N
18329	3373	6	0	78435	\N
18331	88	5	0	75553	\N
18331	3907	6	0	78447	\N
18339	597	0	0	78260	\N
18341	595	0	0	70634	\N
18347	82	4	0	78545	\N
18347	5394	5	0	78546	\N
18349	595	7	0	70634	\N
18349	5396	8	0	78549	\N
18351	4172	2	0	78566	\N
18351	4191	3	0	78567	\N
18354	4172	2	0	78588	\N
18354	4191	3	0	78589	\N
18357	841	4	0	77230	\N
18357	2774	5	0	78608	\N
18368	140	5	0	78661	\N
18368	5000	6	0	78662	\N
18371	142	2	0	78679	\N
18371	4418	3	0	78680	\N
18376	4172	3	0	78703	\N
18376	4275	4	0	78704	\N
18387	1021	3	0	74548	\N
18387	4551	4	0	78807	\N
18084	5322	8	0	77057	\N
18088	40	2	0	76729	\N
18088	282	3	0	77073	\N
18090	4172	1	0	77081	\N
18090	4201	2	0	77082	\N
18095	23	2	0	75255	\N
18095	3443	3	0	76128	\N
18097	4172	3	0	77112	\N
18097	4275	4	0	77113	\N
18100	60	2	0	77128	\N
18100	4544	3	0	77129	\N
18103	33	4	0	76189	\N
18103	4806	5	0	77154	\N
18105	33	4	0	76189	\N
18105	4806	5	0	77154	\N
18107	73	0	0	77159	\N
18114	1636	2	0	77187	\N
18114	4416	3	0	77188	\N
18117	56	11	0	77221	\N
18117	5329	12	0	77222	\N
18122	69	4	0	71428	\N
18122	3564	5	0	77242	\N
18127	16	7	0	77279	\N
18127	4504	8	0	77280	\N
18130	117	3	0	76437	\N
18130	3653	4	0	77299	\N
18132	115	3	0	77300	\N
18132	3483	4	0	77301	\N
18135	5333	40	0	77315	\N
18135	186	112	0	77354	\N
18135	5334	113	0	77355	\N
18137	18	7	0	77371	\N
18137	4538	8	0	77372	\N
18139	4178	2	0	77183	\N
18139	4247	3	0	77184	\N
18142	488	5	0	77395	\N
18142	5335	6	0	77396	\N
18144	75	2	0	77402	\N
18144	284	3	0	77403	\N
18149	449	0	0	76166	\N
18157	4172	7	0	77535	\N
18157	4614	8	0	77536	\N
18159	40	7	0	77539	\N
18159	4718	8	0	77540	\N
18162	4178	4	0	77564	\N
18162	4205	5	0	77565	\N
18164	140	6	0	76819	\N
18164	5342	7	0	77575	\N
18167	4172	3	0	77535	\N
18167	4275	4	0	77599	\N
18170	326	3	0	77630	\N
18170	3339	4	0	77631	\N
18173	56	4	0	77656	\N
18173	3556	5	0	77657	\N
18181	4172	3	0	77709	\N
18181	4275	4	0	77710	\N
18183	189	0	0	77711	\N
18195	1914	5	0	77733	\N
18195	5351	6	0	77734	\N
18201	2183	2	0	77764	\N
18201	5361	3	0	77765	\N
18203	488	6	0	77395	\N
18203	5362	7	0	77777	\N
18223	164	60	0	77843	\N
18223	5370	61	0	77844	\N
18226	125	3	0	68226	\N
18226	4170	4	0	68227	\N
18228	113	4	0	77091	\N
18228	3677	5	0	77913	\N
18231	336	2	0	77930	\N
18231	3332	3	0	77931	\N
18233	320	84	0	74180	\N
18233	5373	85	0	77937	\N
18236	90	2	0	77946	\N
18236	3442	3	0	77950	\N
18242	149	5	0	77972	\N
18242	3808	6	0	77973	\N
18252	140	2	0	77668	\N
18252	3183	3	0	78031	\N
18254	67	2	0	78038	\N
18254	394	3	0	78039	\N
18259	264	3	0	64483	\N
18259	3632	4	0	73899	\N
18261	67	2	0	78060	\N
18261	394	3	0	78061	\N
18264	391	2	0	76845	\N
18264	1381	3	0	78084	\N
18266	82	3	0	73866	\N
18266	4505	4	0	73867	\N
18272	40	5	0	78044	\N
18272	2714	6	0	78129	\N
18274	79	5	0	77974	\N
18274	3341	6	0	77975	\N
18278	86	2	0	72867	\N
18278	3321	3	0	72868	\N
18284	5380	31	0	78184	\N
18284	54	80	0	78206	\N
18284	1075	81	1	78207	\N
18284	5381	81	0	78208	\N
18290	597	3	0	69316	\N
18290	3656	4	0	73855	\N
18294	597	3	0	78260	\N
18294	3656	4	0	78261	\N
18296	142	2	0	78266	\N
18296	4418	3	0	78267	\N
18300	60	1	0	77751	\N
18300	61	2	0	78271	\N
18302	300	3	0	72402	\N
18302	3747	4	0	72403	\N
18308	40	19	0	78044	\N
18308	5384	20	0	78334	\N
18310	42	19	0	78337	\N
18310	5386	20	0	78338	\N
18313	208	3	0	61223	\N
18313	4490	4	0	61224	\N
18315	54	56	0	78368	\N
18315	5387	57	0	78369	\N
18317	210	9	0	77646	\N
18317	5388	10	0	78388	\N
18321	33	2	0	78399	\N
18321	2822	3	0	78400	\N
18323	1109	2	0	78407	\N
18323	2809	3	0	78408	\N
18325	123	2	0	78417	\N
18325	4862	3	0	78418	\N
18330	4178	5	0	78432	\N
18330	4429	6	0	78446	\N
18333	300	5	0	78464	\N
18333	5389	6	0	78465	\N
18336	4172	5	0	78279	\N
18336	4415	6	0	78485	\N
18338	391	2	0	78269	\N
18338	1381	3	0	78270	\N
18343	79	2	0	78517	\N
18343	616	3	0	78518	\N
18346	597	7	0	78543	\N
18346	5393	8	0	78544	\N
18348	181	7	0	78547	\N
18348	5395	8	0	78548	\N
18356	100	3	0	78598	\N
18356	3836	4	0	78599	\N
18359	102	2	0	78619	\N
18359	3053	3	0	78620	\N
18361	4088	2	0	77408	\N
18361	4332	3	0	77409	\N
18363	908	2	0	71974	\N
18363	2832	3	0	78627	\N
18366	1109	2	0	78644	\N
18366	2809	3	0	78645	\N
18370	5404	10	0	78665	\N
18370	140	126	0	78673	\N
18370	5405	127	0	78674	\N
18373	4178	2	0	78687	\N
18373	4247	3	0	78688	\N
18378	4178	2	0	78715	\N
18378	4247	3	0	78716	\N
18381	5406	10	0	78732	\N
18318	4247	3	0	78268	\N
18322	18	2	0	78401	\N
18322	1685	3	0	78402	\N
18328	4178	5	0	78432	\N
18328	4333	6	0	78433	\N
18332	94	2	0	78452	\N
18332	2794	3	0	78453	\N
18335	40	1	0	78473	\N
18335	41	2	0	78474	\N
18345	4178	5	0	78432	\N
18345	4202	6	0	78529	\N
18350	58	7	0	78560	\N
18350	5397	8	0	78561	\N
18353	322	2	0	74073	\N
18353	1866	3	0	78583	\N
18358	149	2	0	78613	\N
18358	1379	3	0	78614	\N
18365	4178	5	0	78638	\N
18365	4429	6	0	78639	\N
18367	5401	43	0	78646	\N
18367	241	125	0	78647	\N
18367	5403	126	1	78648	\N
18367	5402	126	0	78649	\N
18367	3108	127	0	78650	\N
18372	908	2	0	78681	\N
18372	2832	3	0	78682	\N
18375	35	3	0	78701	\N
18375	3563	4	0	78702	\N
18377	56	2	0	78709	\N
18377	2795	3	0	78710	\N
18380	4450	1	0	78720	\N
18380	4178	6	0	78729	\N
18380	4205	7	0	78730	\N
18385	82	2	0	78545	\N
18385	3401	3	0	78790	\N
18388	4178	3	0	78808	\N
18388	4211	4	0	78809	\N
18390	2636	2	0	78816	\N
18390	2836	3	0	78817	\N
18397	962	2	0	8997	\N
18397	5411	3	0	78846	\N
18400	137	4	0	78393	\N
18400	4352	5	0	78865	\N
18403	235	3	0	78880	\N
18403	3343	4	0	78881	\N
18405	2	3	0	77628	\N
18405	298	4	0	78890	\N
18407	67	3	0	78820	\N
18407	3749	4	0	78898	\N
18410	4172	3	0	78818	\N
18410	4275	4	0	78915	\N
18415	262	10	0	78492	\N
18415	5412	11	0	78944	\N
18417	4178	3	0	78878	\N
18417	4211	4	0	78879	\N
18420	453	3	0	78960	\N
18420	2838	4	0	78967	\N
18429	14	3	0	74598	\N
18429	4272	4	0	75527	\N
18439	115	2	0	79069	\N
18439	1593	3	0	79074	\N
18442	14	3	0	74598	\N
18442	4272	4	0	75527	\N
18444	4172	3	0	79056	\N
18444	4275	4	0	79071	\N
18452	181	3	0	79137	\N
18452	4184	4	0	79138	\N
18453	285	118	0	79133	\N
18453	5421	119	0	79166	\N
18460	279	4	0	73810	\N
18460	3502	5	0	79191	\N
18463	92	2	0	79203	\N
18463	2763	3	0	79204	\N
18468	181	7	0	79224	\N
18468	4137	8	0	79225	\N
18471	44	3	0	74554	\N
18471	3631	4	0	79257	\N
18475	5424	8	0	79278	\N
18475	119	9	0	79279	\N
18478	5423	8	0	79276	\N
18478	96	9	0	79277	\N
18482	5427	8	0	79284	\N
18482	324	9	0	79285	\N
18486	100	8	0	78598	\N
18486	5431	9	0	79326	\N
18490	18	3	0	78486	\N
18490	3621	4	0	79350	\N
18495	4178	4	0	79175	\N
18495	4331	5	0	79374	\N
18497	2782	4	0	79384	\N
18497	3872	5	0	79385	\N
18504	71	3	0	79440	\N
18504	3770	4	0	79441	\N
18511	192	3	0	79469	\N
18511	3790	4	0	79470	\N
18513	4172	3	0	79135	\N
18513	5441	4	0	79477	\N
18515	453	5	0	79500	\N
18515	2364	6	0	79501	\N
18518	4178	3	0	79175	\N
18518	4211	4	0	79176	\N
18520	92	0	0	79203	\N
18527	4	3	0	79572	\N
18527	3837	4	0	79573	\N
18530	4178	3	0	79560	\N
18530	4211	4	0	79596	\N
18533	14	3	0	74598	\N
18533	4272	4	0	75527	\N
18535	115	3	0	79637	\N
18535	3483	4	0	79638	\N
18538	4178	3	0	79664	\N
18538	4211	4	0	79665	\N
18547	290	4	0	71115	\N
18547	5450	5	0	79716	\N
18549	123	4	0	79635	\N
18549	5451	5	0	79718	\N
18553	260	0	0	79756	\N
18560	4178	3	0	79814	\N
18560	4211	4	0	79815	\N
18566	2	7	0	79858	\N
18566	5459	8	0	79859	\N
18568	181	2	0	79224	\N
18568	3313	3	0	79864	\N
18570	360	0	0	75843	\N
18572	4178	4	0	79882	\N
18572	4468	5	0	79883	\N
18574	360	0	0	75843	\N
18577	2782	1	0	79888	\N
18577	3873	2	0	79889	\N
18579	391	5	0	79905	\N
18579	5462	6	0	79906	\N
18583	117	4	0	79943	\N
18583	4169	5	0	79944	\N
18587	4172	2	0	79955	\N
18587	4191	3	0	79956	\N
18590	411	2	0	79977	\N
18590	3370	3	0	79978	\N
18593	3328	3	0	79993	\N
18593	110	6	0	79994	\N
18593	3100	7	0	79995	\N
18601	4178	2	0	80015	\N
18601	4247	3	0	80016	\N
18603	230	1	0	80025	\N
18603	287	2	0	80026	\N
18610	1109	2	0	80052	\N
18610	2809	3	0	80053	\N
18612	18	3	0	79949	\N
18612	3621	4	0	80061	\N
18614	149	17	0	80098	\N
18614	5470	18	0	80099	\N
18619	170	2	0	80118	\N
18619	1380	3	0	80119	\N
18621	852	3	0	80128	\N
18621	3612	4	0	80129	\N
18626	4172	2	0	80156	\N
18626	4191	3	0	80157	\N
18629	94	5	0	80171	\N
18326	2856	4	0	78421	\N
18327	113	3	0	78422	\N
18327	3620	4	0	78423	\N
18334	40	2	0	78044	\N
18334	282	3	0	78470	\N
18337	18	5	0	78486	\N
18337	3550	6	0	78487	\N
18340	262	0	0	78492	\N
18342	260	9	0	78509	\N
18342	4952	11	0	78512	\N
18344	79	2	0	78517	\N
18352	38	5	0	75453	\N
18352	5398	6	0	78578	\N
18355	5399	3	0	78596	\N
18355	5400	4	0	78597	\N
18360	73	2	0	78621	\N
18360	2766	3	0	78622	\N
18362	233	2	0	76652	\N
18362	1849	3	0	77410	\N
18364	16	2	0	78029	\N
18364	388	3	0	78030	\N
18369	324	5	0	78663	\N
18369	4516	6	0	78664	\N
18374	4178	2	0	78693	\N
18374	4247	3	0	78694	\N
18379	244	0	0	78717	\N
18382	141	1	0	78770	\N
18382	140	6	0	78771	\N
18382	3821	7	0	78662	\N
18384	5409	0	0	78784	\N
18384	5410	0	0	78785	\N
18392	67	2	0	78820	\N
18392	394	3	0	78821	\N
18402	4178	3	0	78878	\N
18402	4211	4	0	78879	\N
18409	123	3	0	78810	\N
18409	2856	4	0	78811	\N
18412	4088	3	0	77408	\N
18412	4506	4	0	78922	\N
18419	367	3	0	78351	\N
18419	3683	4	0	78352	\N
18421	268	4	0	75353	\N
18421	3897	5	0	78976	\N
18424	194	1	0	78990	\N
18424	6	4	0	76956	\N
18424	1101	5	0	78995	\N
18426	4178	3	0	79006	\N
18426	4211	4	0	79007	\N
18428	451	4	0	77807	\N
18428	3666	5	0	79030	\N
18431	40	7	0	79053	\N
18431	4718	8	0	79054	\N
18435	5417	63	0	79060	\N
18435	132	126	0	79061	\N
18435	5418	127	0	79062	\N
18437	4172	3	0	79056	\N
18437	4275	4	0	79071	\N
18441	40	6	0	79053	\N
18441	4255	7	0	79088	\N
18446	260	3	0	79111	\N
18446	3399	4	0	79112	\N
18448	135	4	0	79123	\N
18448	3696	5	0	79124	\N
18451	4172	3	0	79135	\N
18451	4275	4	0	79136	\N
18455	4178	3	0	79175	\N
18455	4211	4	0	79176	\N
18459	30	4	0	79189	\N
18459	4095	5	0	79190	\N
18462	336	3	0	77930	\N
18462	3400	4	0	79198	\N
18467	40	7	0	79222	\N
18467	4718	8	0	79223	\N
18470	1636	2	0	77187	\N
18470	4416	3	0	77188	\N
18472	326	3	0	79258	\N
18472	3339	4	0	79259	\N
18479	5426	8	0	79282	\N
18479	3625	9	0	79283	\N
18481	5427	8	0	79284	\N
18481	324	9	0	79285	\N
18485	1021	8	0	74548	\N
18485	5430	9	0	79325	\N
18487	279	8	0	73810	\N
18487	5432	9	0	79327	\N
18492	92	4	0	79203	\N
18492	3979	5	0	79361	\N
18494	391	4	0	79372	\N
18494	3352	5	0	79373	\N
18499	1470	7	0	79409	\N
18499	5261	8	0	79410	\N
18501	86	3	0	79422	\N
18501	3746	4	0	79423	\N
18503	316	4	0	79432	\N
18503	5437	5	0	79433	\N
18506	1935	7	0	79458	\N
18506	5438	8	0	79459	\N
18508	1935	0	0	79458	\N
18522	200	7	0	79542	\N
18522	5445	8	0	79543	\N
18525	322	4	0	79562	\N
18525	5447	5	0	79563	\N
18529	18	3	0	79588	\N
18529	3621	4	0	79589	\N
18537	4172	7	0	79135	\N
18537	4614	8	0	79657	\N
18540	360	3	0	79674	\N
18540	3602	4	0	79675	\N
18542	16	4	0	79686	\N
18542	3546	5	0	79687	\N
18545	200	3	0	79704	\N
18545	3338	4	0	79705	\N
18552	94	4	0	79754	\N
18552	5452	5	0	79755	\N
18555	4172	13	0	79676	\N
18555	5454	14	0	79785	\N
18558	4172	4	0	79676	\N
18558	5456	5	0	79805	\N
18563	285	5	0	79133	\N
18563	5103	6	0	79843	\N
18565	285	7	0	79850	\N
18565	5458	8	0	79857	\N
18567	73	2	0	78621	\N
18567	2766	3	0	78622	\N
18576	4178	1	0	79886	\N
18576	4450	2	0	79887	\N
18578	4172	2	0	79676	\N
18578	4191	3	0	79894	\N
18581	4787	4	0	73937	\N
18581	4847	5	0	79919	\N
18582	2	7	0	79858	\N
18582	5463	8	0	79934	\N
18592	5465	3	0	79986	\N
18592	86	6	0	79991	\N
18592	2890	7	0	79992	\N
18597	2317	3	0	80002	\N
18597	121	6	0	80003	\N
18597	4815	7	0	80004	\N
18600	16	2	0	80013	\N
18600	388	3	0	80014	\N
18605	4178	2	0	80039	\N
18605	4247	3	0	80040	\N
18608	200	2	0	79704	\N
18608	276	3	0	80049	\N
18616	132	1	0	80108	\N
18616	455	2	0	80109	\N
18618	2578	2	0	80116	\N
18618	4325	3	0	80117	\N
18623	303	3	0	1136	\N
18623	5471	4	0	80140	\N
18628	18	5	0	80169	\N
18628	3550	6	0	80170	\N
18631	353	5	0	74685	\N
18342	5390	10	1	138637	\N
18344	5392	3	1	138639	\N
18381	140	118	0	78768	\N
18381	5407	119	0	78769	\N
18383	326	5	0	78782	\N
18383	5408	6	0	78783	\N
18386	4178	4	0	78799	\N
18386	4331	5	0	78800	\N
18389	123	3	0	78810	\N
18389	2856	4	0	78811	\N
18391	4172	2	0	78818	\N
18391	4191	3	0	78819	\N
18393	102	2	0	78826	\N
18393	3053	3	0	78827	\N
18395	402	3	0	76754	\N
18395	4077	4	0	76755	\N
18398	235	3	0	78853	\N
18398	3343	4	0	78854	\N
18406	4178	3	0	78878	\N
18406	4441	4	0	78891	\N
18408	115	2	0	77300	\N
18408	2797	3	0	78903	\N
18418	453	7	0	78960	\N
18418	5413	8	0	78961	\N
18422	268	34	0	75353	\N
18422	5414	35	0	78987	\N
18427	451	54	0	77807	\N
18427	5415	55	0	79029	\N
18432	198	7	0	75334	\N
18432	5416	8	0	79055	\N
18434	132	7	0	79058	\N
18434	3709	8	0	79059	\N
18445	431	3	0	79109	\N
18445	3933	4	0	79110	\N
18447	4178	4	0	79121	\N
18447	4205	5	0	79122	\N
18449	137	4	0	79125	\N
18449	3697	5	0	79126	\N
18456	208	3	0	61223	\N
18456	4490	4	0	61224	\N
18458	4172	4	0	79135	\N
18458	4219	5	0	79188	\N
18464	35	2	0	78701	\N
18464	1191	3	0	79205	\N
18466	16	2	0	78029	\N
18466	388	3	0	78030	\N
18473	75	3	0	78032	\N
18473	3855	4	0	78055	\N
18476	5425	8	0	79280	\N
18476	181	9	0	79281	\N
18480	5427	8	0	79284	\N
18480	324	9	0	79285	\N
18483	5428	8	0	69362	\N
18483	3628	9	0	79286	\N
18488	449	4	0	79336	\N
18488	5343	5	0	79337	\N
18493	20	4	0	79362	\N
18493	3995	5	0	79363	\N
18500	5435	13	0	79411	\N
18500	1470	126	0	79414	\N
18500	5436	127	0	79415	\N
18502	4178	3	0	79175	\N
18502	4211	4	0	79176	\N
18505	288	3	0	79442	\N
18505	3003	4	0	79443	\N
18507	1935	0	0	79458	\N
18509	117	3	0	79466	\N
18509	3653	4	0	79467	\N
18516	785	7	0	79515	\N
18516	5443	8	0	79516	\N
18519	453	3	0	79525	\N
18519	2838	4	0	79526	\N
18523	16	4	0	78029	\N
18523	5446	5	0	79551	\N
18528	16	3	0	79580	\N
18528	3634	4	0	79581	\N
18531	2	7	0	79611	\N
18531	5448	8	0	79612	\N
18536	42	7	0	79641	\N
18536	5449	8	0	79642	\N
18541	4172	3	0	79676	\N
18541	4275	4	0	79677	\N
18543	186	3	0	79694	\N
18543	4294	4	0	79695	\N
18546	1109	3	0	79706	\N
18546	3495	4	0	79707	\N
18550	117	2	0	79466	\N
18550	1257	3	0	79723	\N
18554	40	13	0	79783	\N
18554	5453	14	0	79784	\N
18556	4178	4	0	79794	\N
18556	4205	5	0	79795	\N
18561	4178	7	0	79830	\N
18561	5089	8	0	79831	\N
18564	285	3	0	79850	\N
18564	5457	4	0	79851	\N
18573	360	0	0	75843	\N
18580	27	2	0	77071	\N
18580	645	3	0	77072	\N
18584	391	4	0	79945	\N
18584	3352	5	0	79946	\N
18588	4178	6	0	79969	\N
18588	4358	7	0	79970	\N
18594	5466	3	0	79996	\N
18594	235	6	0	79997	\N
18594	5467	7	0	79998	\N
18596	2317	3	0	80002	\N
18596	121	6	0	80003	\N
18596	4815	7	0	80004	\N
18598	4440	3	0	80005	\N
18598	4172	6	0	80006	\N
18598	4285	7	0	80007	\N
18604	4172	3	0	80033	\N
18604	4275	4	0	80034	\N
18606	4172	2	0	80041	\N
18606	4191	3	0	80042	\N
18609	56	2	0	80050	\N
18609	2795	3	0	80051	\N
18617	4172	1	0	80110	\N
18617	4201	2	0	80111	\N
18624	38	3	0	79072	\N
18624	3457	4	0	79075	\N
18627	4178	5	0	80039	\N
18627	4429	6	0	80168	\N
18638	145	4	0	80242	\N
18638	5475	5	0	80243	\N
18643	167	2	0	80096	\N
18643	3322	3	0	80269	\N
18645	1636	2	0	77187	\N
18645	4416	3	0	77188	\N
18647	38	5	0	80283	\N
18647	5398	6	0	80284	\N
18652	4178	3	0	80302	\N
18652	4211	4	0	80303	\N
18655	202	6	0	76241	\N
18655	4079	7	0	80327	\N
18658	67	6	0	80330	\N
18658	3607	7	0	80331	\N
18664	431	3	0	80385	\N
18664	3933	4	0	80386	\N
18666	40	2	0	80392	\N
18666	282	3	0	80393	\N
18668	18	2	0	80186	\N
18668	1685	3	0	80396	\N
18671	212	4	0	80407	\N
18671	4574	5	0	80408	\N
18679	40	3	0	80448	\N
18679	372	4	0	80449	\N
18683	164	2	0	80534	\N
18683	1124	3	0	80535	\N
18688	13	1	0	80547	\N
18688	12	3	0	80548	\N
18688	2903	4	0	80551	\N
18701	40	4	0	80613	\N
18701	2796	5	0	80614	\N
18704	186	2	0	80636	\N
18704	1850	3	0	80637	\N
18706	4172	2	0	80639	\N
18706	4191	3	0	80640	\N
18394	40	2	0	78828	\N
18394	282	3	0	78829	\N
18396	79	2	0	78840	\N
18396	616	3	0	78841	\N
18399	79	4	0	78863	\N
18399	2758	5	0	78864	\N
18401	142	2	0	78870	\N
18401	4418	3	0	78871	\N
18404	411	3	0	78882	\N
18404	3596	4	0	78883	\N
18411	4178	3	0	78878	\N
18411	4211	4	0	78879	\N
18413	233	3	0	76652	\N
18413	3704	4	0	76653	\N
18414	40	10	0	78828	\N
18414	4104	11	0	78943	\N
18416	262	7	0	78492	\N
18416	4888	8	0	78948	\N
18423	194	1	0	78990	\N
18423	6	4	0	76956	\N
18423	1101	5	0	78995	\N
18425	40	2	0	78828	\N
18425	282	3	0	78829	\N
18430	4172	3	0	79037	\N
18430	4275	4	0	79038	\N
18433	4172	7	0	79056	\N
18433	4614	8	0	79057	\N
18436	115	3	0	79069	\N
18436	3483	4	0	79070	\N
18438	38	2	0	79072	\N
18438	2901	3	0	79073	\N
18440	38	3	0	79072	\N
18440	3457	4	0	79075	\N
18443	5419	3	0	79095	\N
18443	5420	4	0	79096	\N
18450	285	3	0	79133	\N
18450	4496	4	0	79134	\N
18454	2	3	0	79173	\N
18454	3548	4	0	79174	\N
18457	164	4	0	77836	\N
18457	4152	5	0	79187	\N
18465	58	2	0	79206	\N
18465	2853	3	0	79207	\N
18469	96	11	0	79248	\N
18469	5422	12	0	79249	\N
18474	5423	8	0	79276	\N
18474	96	9	0	79277	\N
18477	5423	8	0	79276	\N
18477	96	9	0	79277	\N
18484	244	10	0	78717	\N
18489	2	2	0	79342	\N
18489	2789	3	0	79343	\N
18491	5433	3	0	79351	\N
18491	5434	4	0	79352	\N
18496	16	4	0	78029	\N
18496	2575	5	0	79375	\N
18498	145	4	0	79394	\N
18498	3867	5	0	79395	\N
18510	117	2	0	79466	\N
18510	5439	3	0	79468	\N
18512	360	3	0	75843	\N
18512	5440	4	0	79476	\N
18514	453	56	0	79491	\N
18514	5442	57	0	79492	\N
18517	453	4	0	79518	\N
18517	5444	5	0	79519	\N
18521	4178	0	0	79527	\N
18524	4178	4	0	79560	\N
18524	4205	5	0	79561	\N
18526	411	4	0	79564	\N
18526	4858	5	0	79565	\N
18532	260	7	0	79627	\N
18532	4589	8	0	79628	\N
18534	123	3	0	79635	\N
18534	2856	4	0	79636	\N
18539	4178	3	0	79672	\N
18539	4211	4	0	79673	\N
18544	4178	3	0	79702	\N
18544	4211	4	0	79703	\N
18548	4178	4	0	79702	\N
18548	4468	5	0	79717	\N
18551	40	10	0	79744	\N
18551	4104	11	0	79745	\N
18557	224	4	0	18546	\N
18557	5455	5	0	79804	\N
18559	62	3	0	79812	\N
18559	3344	4	0	79813	\N
18562	285	2	0	79133	\N
18562	1276	3	0	79836	\N
18569	16	3	0	79871	\N
18569	5460	4	0	79872	\N
18571	360	4	0	79674	\N
18571	5461	5	0	79881	\N
18575	360	0	0	75843	\N
18585	2183	4	0	79947	\N
18585	5464	5	0	79948	\N
18586	18	4	0	79949	\N
18586	3779	5	0	79950	\N
18589	373	2	0	79975	\N
18589	4967	3	0	79976	\N
18591	125	2	0	68226	\N
18591	3297	3	0	79979	\N
18595	5468	3	0	79999	\N
18595	82	6	0	80000	\N
18595	4753	7	0	80001	\N
18599	110	1	0	78217	\N
18599	3242	2	0	80008	\N
18602	841	2	0	80021	\N
18602	3316	3	0	80022	\N
18607	40	2	0	80047	\N
18607	282	3	0	80048	\N
18611	322	3	0	79562	\N
18611	1105	4	0	80060	\N
18613	167	17	0	80096	\N
18613	5469	18	0	80097	\N
18615	18	2	0	80104	\N
18615	1685	3	0	80105	\N
18620	1021	3	0	80126	\N
18620	4551	4	0	80127	\N
18622	40	2	0	80047	\N
18622	282	3	0	80048	\N
18625	79	5	0	78863	\N
18625	3341	6	0	80151	\N
18630	40	5	0	80183	\N
18630	2714	6	0	80184	\N
18632	18	5	0	80186	\N
18632	3550	6	0	80187	\N
18635	4172	5	0	80208	\N
18635	4415	6	0	80209	\N
18641	449	7	0	80262	\N
18641	5478	8	0	80263	\N
18644	156	2	0	80270	\N
18644	4485	3	0	80271	\N
18646	44	2	0	74554	\N
18646	1910	3	0	80272	\N
18650	451	1	0	80291	\N
18650	3260	2	0	80293	\N
18653	288	4	0	80312	\N
18653	5098	5	0	80313	\N
18656	264	6	0	64483	\N
18656	5480	7	0	80328	\N
18659	18	6	0	80186	\N
18659	4180	7	0	80332	\N
18662	4178	3	0	80353	\N
18662	4211	4	0	80354	\N
18667	367	2	0	80394	\N
18667	3329	3	0	80395	\N
18673	5482	67	0	80418	\N
18673	212	114	0	80419	\N
18673	5483	115	0	80420	\N
18675	16	3	0	80013	\N
18675	1045	4	0	80428	\N
18677	62	2	0	79812	\N
18677	2191	3	0	80391	\N
18681	262	92	0	80472	\N
18629	4547	6	0	80172	\N
18634	60	5	0	77751	\N
18634	5473	6	0	80207	\N
18637	5474	8	0	80232	\N
18637	198	9	0	80233	\N
18640	82	7	0	80260	\N
18640	5477	8	0	80261	\N
18642	228	2	0	75012	\N
18642	4776	3	0	80268	\N
18649	451	2	0	80291	\N
18649	3317	3	0	80292	\N
18651	4178	2	0	80039	\N
18651	4247	3	0	80040	\N
18657	200	6	0	79704	\N
18657	4701	7	0	80329	\N
18661	2782	3	0	79888	\N
18661	3659	4	0	80346	\N
18663	75	43	0	78032	\N
18663	5481	44	0	80378	\N
18670	14	4	0	80405	\N
18670	2291	5	0	80406	\N
18674	62	3	0	79812	\N
18674	5484	4	0	80427	\N
18680	262	11	0	80472	\N
18680	5486	12	0	80473	\N
18685	266	3	0	78335	\N
18685	4633	4	0	80539	\N
18692	224	7	0	80565	\N
18692	5493	8	0	80570	\N
18696	135	3	0	79123	\N
18696	3630	4	0	80589	\N
18709	264	1	0	64483	\N
18709	270	2	0	75393	\N
18720	4178	2	0	80741	\N
18720	4247	3	0	80742	\N
18722	75	3	0	78032	\N
18722	3855	4	0	78055	\N
18725	4178	3	0	80771	\N
18725	4211	4	0	80772	\N
18727	336	2	0	80778	\N
18727	3332	3	0	80779	\N
18732	4178	5	0	80798	\N
18732	4429	6	0	80799	\N
18737	4172	7	0	80828	\N
18737	4537	8	0	80829	\N
18742	214	4	0	80862	\N
18742	3807	5	0	80863	\N
18748	96	3	0	80895	\N
18748	2803	4	0	80899	\N
18750	117	5	0	80915	\N
18750	5505	6	0	80916	\N
18753	235	4	0	78880	\N
18753	4479	5	0	80934	\N
18755	264	2	0	80941	\N
18755	2780	3	0	80942	\N
18760	117	3	0	80962	\N
18760	3653	4	0	80963	\N
18762	4178	3	0	80965	\N
18762	4211	4	0	80966	\N
18766	40	3	0	80977	\N
18766	5506	4	0	80978	\N
18769	20	2	0	80985	\N
18769	369	3	0	80986	\N
18773	453	2	0	79525	\N
18773	3366	3	0	81002	\N
18776	2073	5	0	81015	\N
18776	27	11	0	81026	\N
18776	5508	12	0	81027	\N
18779	40	3	0	81037	\N
18779	372	4	0	81038	\N
18781	514	2	0	81045	\N
18781	5509	3	0	81046	\N
18783	173	3	0	81053	\N
18783	3796	4	0	81054	\N
18788	2	5	0	81085	\N
18788	3624	6	0	81086	\N
18790	793	3	0	81087	\N
18790	5510	4	0	81089	\N
18793	16	6	0	81109	\N
18793	5512	7	0	81110	\N
18797	1636	3	0	81144	\N
18797	5514	4	0	81145	\N
18801	324	2	0	81157	\N
18801	2808	3	0	81158	\N
18806	4178	3	0	81188	\N
18806	4211	4	0	81189	\N
18818	214	2	0	81227	\N
18818	1259	3	0	81228	\N
18820	96	1	0	81231	\N
18820	97	2	0	81232	\N
18825	4172	2	0	81244	\N
18825	4191	3	0	81245	\N
18827	6	1	0	81251	\N
18827	194	2	0	81252	\N
18830	170	1	0	80118	\N
18830	398	2	0	81257	\N
18832	4178	1	0	81268	\N
18832	4450	2	0	81269	\N
18837	320	1	0	81286	\N
18837	334	2	0	81287	\N
18843	4172	3	0	81244	\N
18843	4440	4	0	81319	\N
18846	242	3	0	81331	\N
18846	5519	4	0	81332	\N
18848	75	1	0	81339	\N
18848	76	2	0	81340	\N
18851	40	1	0	81037	\N
18851	41	2	0	81351	\N
18855	69	2	0	81362	\N
18855	500	3	0	81363	\N
18858	841	1	0	81376	\N
18858	842	2	0	81377	\N
18861	2636	3	0	81384	\N
18861	5314	4	0	81385	\N
18863	54	2	0	81391	\N
18863	3351	3	0	81392	\N
18868	1470	1	0	81412	\N
18868	1471	2	0	81413	\N
18873	230	1	0	81431	\N
18873	287	2	0	81432	\N
18880	108	1	0	78285	\N
18880	109	2	0	81458	\N
18883	170	1	0	81471	\N
18883	398	2	0	81472	\N
18885	40	2	0	81479	\N
18885	282	3	0	81480	\N
18888	27	1	0	81492	\N
18888	28	2	0	81493	\N
18891	3625	2	0	81506	\N
18891	4359	3	0	81507	\N
18894	391	2	0	79945	\N
18894	1381	3	0	81004	\N
18897	2351	1	0	77562	\N
18897	4983	2	0	81516	\N
18910	88	1	0	81558	\N
18910	89	2	0	81559	\N
18915	54	2	0	81577	\N
18915	3351	3	0	81578	\N
18917	4172	1	0	81579	\N
18917	4201	2	0	81583	\N
18920	164	46	0	81594	\N
18920	5530	47	0	81595	\N
18929	4178	1	0	81570	\N
18929	4450	2	0	81600	\N
18932	1636	2	0	81144	\N
18932	4416	3	0	81628	\N
18936	75	1	0	81636	\N
18936	76	2	0	81637	\N
18946	140	1	0	81669	\N
18946	141	2	0	81672	\N
18953	198	2	0	81690	\N
18953	746	3	0	81691	\N
18955	4178	1	0	81570	\N
18955	4450	2	0	81600	\N
18962	4088	3	0	77408	\N
18962	4506	4	0	78922	\N
18964	56	1	0	81721	\N
18631	2223	6	0	80185	\N
18633	367	4	0	78351	\N
18633	5472	5	0	80196	\N
18636	40	2	0	80214	\N
18636	282	3	0	80215	\N
18639	4172	4	0	80244	\N
18639	5476	5	0	80245	\N
18648	242	5	0	80285	\N
18648	4562	6	0	80286	\N
18654	23	4	0	80314	\N
18654	5479	5	0	80315	\N
18660	449	3	0	80262	\N
18660	4760	4	0	80339	\N
18665	62	2	0	79812	\N
18665	2191	3	0	80391	\N
18669	62	0	0	79812	\N
18672	121	4	0	80409	\N
18672	4356	5	0	80410	\N
18676	4172	3	0	80429	\N
18676	4440	4	0	80430	\N
18678	121	5	0	80409	\N
18678	5485	6	0	80441	\N
18682	4172	6	0	80429	\N
18682	4365	7	0	80529	\N
18687	13	1	0	80547	\N
18687	12	3	0	80548	\N
18687	5489	4	1	80549	\N
18687	5488	4	0	80550	\N
18691	224	7	0	80565	\N
18694	20	4	0	80579	\N
18694	2292	5	0	80580	\N
18698	38	3	0	80283	\N
18698	3457	4	0	80591	\N
18700	77	4	0	80611	\N
18700	5497	5	0	80612	\N
18703	82	2	0	80630	\N
18703	3401	3	0	80631	\N
18705	353	2	0	74685	\N
18705	2884	3	0	80638	\N
18712	224	10	0	80694	\N
18712	1822	11	0	80695	\N
18714	242	3	0	80704	\N
18714	2839	4	0	80705	\N
18717	88	2	0	80717	\N
18717	2799	3	0	80718	\N
18719	142	4	0	80735	\N
18719	3446	5	0	80736	\N
18729	4178	2	0	80771	\N
18729	4247	3	0	80785	\N
18735	908	3	0	78681	\N
18735	5501	4	0	80825	\N
18740	262	3	0	80839	\N
18740	4778	4	0	80841	\N
18744	488	3	0	77395	\N
18744	1103	4	0	80872	\N
18747	96	5	0	80895	\N
18747	5504	6	0	80896	\N
18749	4172	2	0	80828	\N
18749	4191	3	0	80904	\N
18752	58	2	0	79206	\N
18752	2853	3	0	79207	\N
18757	365	2	0	77033	\N
18757	615	3	0	80947	\N
18759	279	3	0	73810	\N
18759	3641	4	0	74198	\N
18768	336	2	0	80796	\N
18768	3332	3	0	80984	\N
18770	235	2	0	78880	\N
18770	2757	3	0	80987	\N
18772	40	3	0	80996	\N
18772	372	4	0	80997	\N
18775	391	2	0	79945	\N
18775	1381	3	0	81004	\N
18778	258	3	0	77104	\N
18778	4401	4	0	81036	\N
18780	228	2	0	81043	\N
18780	4776	3	0	81044	\N
18782	56	2	0	80050	\N
18782	2795	3	0	80051	\N
18785	132	5	0	80108	\N
18785	2717	6	0	81066	\N
18787	16	2	0	81073	\N
18787	388	3	0	81074	\N
18792	173	2	0	81095	\N
18792	2102	3	0	81096	\N
18796	156	3	0	80270	\N
18796	4594	4	0	81143	\N
18798	4172	3	0	80968	\N
18798	4275	4	0	80969	\N
18800	23	2	0	80314	\N
18800	3443	3	0	81152	\N
18803	18	5	0	81067	\N
18803	3550	6	0	81068	\N
18808	75	3	0	81190	\N
18808	3855	4	0	81191	\N
18810	135	2	0	79123	\N
18810	2722	3	0	81197	\N
18813	20	5	0	80985	\N
18813	2820	6	0	81211	\N
18815	214	1	0	81215	\N
18815	215	2	0	81216	\N
18817	69	1	0	81221	\N
18817	70	2	0	81222	\N
18822	35	1	0	81209	\N
18822	340	2	0	81237	\N
18824	173	2	0	81242	\N
18824	2102	3	0	81243	\N
18829	16	1	0	81255	\N
18829	17	2	0	81256	\N
18831	132	3	0	81264	\N
18831	5516	4	0	81265	\N
18834	4178	2	0	81277	\N
18834	4247	3	0	81278	\N
18839	71	1	0	81298	\N
18839	72	2	0	81299	\N
18842	14	2	0	80696	\N
18842	383	3	0	81312	\N
18845	75	3	0	81190	\N
18845	713	4	0	81330	\N
18850	167	1	0	81349	\N
18850	533	2	0	81350	\N
18853	4178	1	0	81354	\N
18853	4450	2	0	81355	\N
18857	192	1	0	81372	\N
18857	193	2	0	81373	\N
18860	62	3	0	79812	\N
18860	5484	4	0	80427	\N
18865	16	2	0	81399	\N
18865	155	3	0	81400	\N
18875	2782	1	0	81434	\N
18875	3873	2	0	81435	\N
18877	4172	1	0	81443	\N
18877	4201	2	0	81444	\N
18882	962	1	0	81467	\N
18882	963	2	0	81468	\N
18890	841	2	0	81500	\N
18890	1161	3	0	81501	\N
18893	110	2	0	78217	\N
18893	626	3	0	81510	\N
18899	108	2	0	81524	\N
18899	3340	3	0	81525	\N
18902	2185	6	0	81531	\N
18902	5527	7	0	81532	\N
18904	110	4	0	78217	\N
18904	5526	5	0	81513	\N
18906	181	1	0	79224	\N
18906	530	2	0	81543	\N
18907	60	5	0	77751	\N
18907	5528	6	0	81554	\N
18909	18	0	0	81555	\N
18912	33	2	0	78399	\N
18912	34	3	0	81569	\N
18922	4178	1	0	81570	\N
18691	5490	8	1	138643	\N
18691	5492	9	1	138645	\N
18681	5487	93	0	80516	\N
18684	164	3	0	80534	\N
18684	1807	4	0	80538	\N
18686	25	1	0	80542	\N
18686	4	3	0	80545	\N
18686	3114	4	0	80546	\N
18689	4	0	0	80552	\N
18690	14	0	0	80553	\N
18693	20	4	0	80579	\N
18693	2292	5	0	80580	\N
18695	1495	3	0	80587	\N
18695	5494	4	0	80588	\N
18697	137	3	0	79125	\N
18697	3633	4	0	80590	\N
18699	5495	32	0	80596	\N
18699	38	38	0	80601	\N
18699	5496	39	0	80602	\N
18702	435	5	0	71910	\N
18702	2354	6	0	80625	\N
18708	16	5	0	80667	\N
18708	4240	6	0	80668	\N
18711	42	27	0	80673	\N
18711	5498	28	0	80674	\N
18716	40	2	0	80715	\N
18716	282	3	0	80716	\N
18718	4172	3	0	80725	\N
18718	4275	4	0	80726	\N
18721	30	3	0	79189	\N
18721	3640	4	0	80749	\N
18724	33	3	0	78399	\N
18724	3342	4	0	80770	\N
18726	121	3	0	80671	\N
18726	4471	4	0	80773	\N
18731	336	5	0	80796	\N
18731	3283	6	0	80797	\N
18734	908	7	0	78681	\N
18734	3552	8	0	80824	\N
18736	214	7	0	80826	\N
18736	5502	8	0	80827	\N
18739	262	4	0	80839	\N
18739	4607	5	0	80840	\N
18741	71	5	0	80852	\N
18741	5503	6	0	80853	\N
18746	1021	2	0	80883	\N
18746	4432	3	0	80884	\N
18754	173	4	0	80935	\N
18754	3857	5	0	80936	\N
18756	18	2	0	80186	\N
18756	1685	3	0	80396	\N
18761	2351	3	0	77562	\N
18761	2845	4	0	80964	\N
18764	4172	3	0	80968	\N
18764	4275	4	0	80969	\N
18765	75	3	0	80970	\N
18765	3855	4	0	80971	\N
18774	123	2	0	79635	\N
18774	1868	3	0	81003	\N
18777	285	3	0	81034	\N
18777	4496	4	0	81035	\N
18789	793	5	0	81087	\N
18789	5143	6	0	81088	\N
18794	94	6	0	81111	\N
18794	5513	7	0	81112	\N
18795	56	11	0	81135	\N
18795	5329	12	0	81136	\N
18805	4178	2	0	80965	\N
18805	4247	3	0	81181	\N
18807	4172	3	0	80968	\N
18807	4275	4	0	80969	\N
18812	35	5	0	81209	\N
18812	5515	6	0	81210	\N
18821	69	1	0	81233	\N
18821	70	2	0	81234	\N
18826	4178	1	0	81188	\N
18826	4450	2	0	81248	\N
18828	51	1	0	81253	\N
18828	52	2	0	81254	\N
18833	18	1	0	81067	\N
18833	19	2	0	81272	\N
18836	151	1	0	81284	\N
18836	302	2	0	81285	\N
18841	56	2	0	81306	\N
18841	2795	3	0	81307	\N
18844	18	1	0	81322	\N
18844	19	2	0	81323	\N
18847	316	1	0	81335	\N
18847	317	2	0	81336	\N
18854	260	1	0	81356	\N
18854	261	2	0	81357	\N
18859	16	1	0	81255	\N
18859	17	2	0	81256	\N
18862	51	2	0	81253	\N
18862	1260	3	0	81390	\N
18867	40	2	0	81037	\N
18867	282	3	0	81409	\N
18870	88	3	0	80717	\N
18870	249	4	0	81422	\N
18872	285	1	0	81427	\N
18872	286	2	0	81428	\N
18874	164	1	0	80534	\N
18874	165	2	0	81433	\N
18879	18	1	0	81454	\N
18879	19	2	0	81455	\N
18887	77	3	0	80611	\N
18887	2161	4	0	81489	\N
18896	110	4	0	78217	\N
18896	5526	5	0	81513	\N
18901	88	1	0	80717	\N
18901	89	2	0	81530	\N
18911	62	2	0	81541	\N
18911	2191	3	0	81564	\N
18914	4178	2	0	81570	\N
18914	4247	3	0	81576	\N
18916	4172	2	0	81579	\N
18916	4191	3	0	81580	\N
18919	164	2	0	80534	\N
18919	1124	3	0	80535	\N
18921	2011	1	0	81598	\N
18921	2013	2	0	81599	\N
18923	852	1	0	80128	\N
18923	913	2	0	81601	\N
18926	5532	2	0	81615	\N
18928	235	1	0	81617	\N
18928	236	2	0	81618	\N
18930	391	1	0	79945	\N
18930	392	2	0	81621	\N
18935	30	1	0	79189	\N
18935	418	2	0	81635	\N
18937	451	1	0	81640	\N
18937	584	2	0	81641	\N
18947	4178	3	0	81570	\N
18947	4441	4	0	81679	\N
18950	69	1	0	81683	\N
18950	70	2	0	81684	\N
18954	4	3	0	81352	\N
18954	5535	4	0	81698	\N
18963	40	1	0	81719	\N
18963	41	2	0	81720	\N
18965	132	1	0	81725	\N
18965	455	2	0	81726	\N
18970	132	2	0	81743	\N
18970	133	3	0	81744	\N
18973	595	2	0	70634	\N
18973	3285	3	0	70635	\N
18982	77	2	0	81780	\N
18982	3853	3	0	81781	\N
18984	285	1	0	81784	\N
18984	286	2	0	81785	\N
18987	3767	4	0	50619	\N
18987	3768	5	0	50620	\N
18991	597	2	0	78543	\N
18991	3286	3	0	81753	\N
18995	77	1	0	81810	\N
18995	78	2	0	81811	\N
19000	137	1	0	79125	\N
19000	138	2	0	81825	\N
18707	73	7	0	80655	\N
18707	5104	8	0	80656	\N
18710	121	1	0	80671	\N
18710	122	2	0	80672	\N
18713	14	10	0	80696	\N
18713	5499	11	0	80697	\N
18715	94	2	0	80171	\N
18715	2794	3	0	80710	\N
18723	64	6	0	80762	\N
18723	4057	7	0	80763	\N
18728	14	2	0	80696	\N
18728	1785	3	0	80780	\N
18730	173	0	0	78251	\N
18733	149	4	0	80808	\N
18733	5500	5	0	80809	\N
18738	167	4	0	80096	\N
18738	4048	5	0	80838	\N
18743	251	4	0	80864	\N
18743	5055	5	0	80865	\N
18745	167	2	0	80877	\N
18745	3322	3	0	80878	\N
18751	273	2	0	77828	\N
18751	1413	3	0	80921	\N
18758	4172	2	0	80948	\N
18758	4191	3	0	80949	\N
18763	373	3	0	79975	\N
18763	3590	4	0	80967	\N
18767	4178	3	0	80965	\N
18767	5507	4	0	80979	\N
18771	279	2	0	80988	\N
18771	4525	3	0	80989	\N
18784	411	3	0	79977	\N
18784	3596	4	0	81055	\N
18786	18	5	0	81067	\N
18786	3550	6	0	81068	\N
18791	313	2	0	1215	\N
18791	5511	3	0	81094	\N
18799	44	3	0	81146	\N
18799	3631	4	0	81147	\N
18802	2	5	0	81169	\N
18802	3624	6	0	81170	\N
18804	2636	2	0	81175	\N
18804	2836	3	0	81176	\N
18809	4178	2	0	81188	\N
18809	4247	3	0	81196	\N
18811	137	2	0	79125	\N
18811	2721	3	0	81198	\N
18814	16	5	0	81109	\N
18814	3455	6	0	81212	\N
18816	125	1	0	81219	\N
18816	195	2	0	81220	\N
18823	4178	2	0	81188	\N
18823	4247	3	0	81196	\N
18835	353	1	0	74685	\N
18835	354	2	0	81281	\N
18838	326	3	0	81294	\N
18838	5517	4	0	81295	\N
18840	2578	1	0	81300	\N
18840	5518	2	0	81301	\N
18849	324	2	0	81345	\N
18849	2808	3	0	81346	\N
18852	4	1	0	81352	\N
18852	25	2	0	81353	\N
18856	14	2	0	81368	\N
18856	1785	3	0	81369	\N
18864	62	2	0	81397	\N
18864	683	3	0	81398	\N
18866	4172	1	0	81403	\N
18866	4201	2	0	81404	\N
18869	56	3	0	81420	\N
18869	1188	4	0	81421	\N
18871	4172	3	0	81423	\N
18871	4440	4	0	81424	\N
18876	5520	35	0	81436	\N
18876	164	72	0	81441	\N
18876	5521	73	0	81442	\N
18878	841	3	0	81376	\N
18878	5522	4	0	81451	\N
18881	100	2	0	78598	\N
18884	488	1	0	81473	\N
18884	489	2	0	81474	\N
18886	170	1	0	81471	\N
18886	398	2	0	81472	\N
18889	4233	2	0	81498	\N
18889	5525	3	0	81499	\N
18892	119	2	0	81508	\N
18892	1879	3	0	81509	\N
18895	3628	2	0	81511	\N
18895	4360	3	0	81512	\N
18898	16	1	0	81399	\N
18898	17	2	0	81519	\N
18900	214	2	0	81526	\N
18900	1259	3	0	81527	\N
18903	110	3	0	78217	\N
18903	3328	4	0	79994	\N
18905	62	1	0	81541	\N
18905	63	2	0	81542	\N
18908	18	0	0	81454	\N
18913	4178	2	0	81570	\N
18913	5529	3	0	81571	\N
18918	402	2	0	81588	\N
18918	1148	3	0	81589	\N
18925	156	2	0	81610	\N
18925	4485	3	0	81611	\N
18934	279	1	0	80988	\N
18934	473	2	0	81632	\N
18939	4172	2	0	81646	\N
18939	4191	3	0	81647	\N
18942	5534	4	0	81661	\N
18942	4172	5	0	81662	\N
18944	140	2	0	81669	\N
18944	487	3	0	81670	\N
18949	4178	1	0	81570	\N
18949	4450	2	0	81600	\N
18951	69	0	0	81683	\N
18956	16	1	0	81701	\N
18956	17	2	0	81702	\N
18958	18	1	0	81555	\N
18958	19	2	0	81706	\N
18960	2	3	0	81713	\N
18960	3548	4	0	81714	\N
18972	597	2	0	78543	\N
18972	3286	3	0	81753	\N
18976	435	2	0	81757	\N
18976	3413	3	0	81758	\N
18977	214	5	0	81769	\N
18977	5536	6	0	81770	\N
18981	64	0	0	81774	\N
18986	202	4	0	76241	\N
18986	3673	5	0	81794	\N
18988	242	4	0	81331	\N
18988	3512	5	0	81795	\N
18990	56	1	0	81800	\N
18990	57	2	0	81801	\N
18997	132	1	0	81814	\N
18997	455	2	0	81815	\N
18999	181	2	0	81821	\N
18999	3313	3	0	81822	\N
19009	1470	1	0	81842	\N
19009	1471	2	0	81843	\N
19013	75	2	0	81852	\N
19013	284	3	0	81853	\N
19016	62	2	0	81667	\N
19016	2191	3	0	81849	\N
19017	449	2	0	81862	\N
19017	646	3	0	81863	\N
19022	4983	1	0	81883	\N
19022	2351	2	0	81884	\N
19035	88	1	0	81928	\N
19035	89	2	0	81929	\N
19038	1793	2	0	23846	\N
19038	5540	3	0	81942	\N
19040	402	1	0	81947	\N
19040	403	2	0	81948	\N
19041	4172	0	0	81949	\N
18922	4450	2	0	81600	\N
18924	38	1	0	81604	\N
18924	399	2	0	81605	\N
18927	258	1	0	77104	\N
18927	309	2	0	81616	\N
18931	2351	2	0	81626	\N
18931	2754	3	0	81627	\N
18933	44	2	0	81146	\N
18933	1910	3	0	81629	\N
18938	228	2	0	81043	\N
18938	4776	3	0	81044	\N
18940	4172	1	0	81646	\N
18940	4201	2	0	81650	\N
18941	5533	4	0	81659	\N
18941	149	5	0	81660	\N
18943	62	2	0	81667	\N
18943	683	3	0	81668	\N
18945	56	2	0	81420	\N
18945	169	3	0	81671	\N
18948	262	3	0	80839	\N
18948	1579	4	0	81680	\N
18952	115	2	0	79637	\N
18952	636	3	0	81689	\N
18957	411	1	0	79977	\N
18957	412	2	0	81705	\N
18959	411	0	0	79977	\N
18961	233	3	0	81715	\N
18961	3704	4	0	81716	\N
18966	300	2	0	81731	\N
18966	2786	3	0	81732	\N
18968	320	2	0	81735	\N
18968	1937	3	0	81736	\N
18974	147	2	0	73443	\N
18974	3287	3	0	81754	\N
18975	181	2	0	81755	\N
18975	3313	3	0	81756	\N
18978	336	1	0	80796	\N
18978	356	2	0	81773	\N
18980	64	1	0	81774	\N
18980	65	2	0	81775	\N
18983	4178	2	0	81733	\N
18983	4247	3	0	81734	\N
18985	16	1	0	81701	\N
18985	17	2	0	81702	\N
18989	391	1	0	81798	\N
18989	392	2	0	81799	\N
18992	595	2	0	70634	\N
18992	3285	3	0	70635	\N
18996	40	1	0	81719	\N
18996	41	2	0	81720	\N
18998	140	2	0	81669	\N
18998	3183	3	0	81820	\N
19005	73	30	0	81831	\N
19005	5537	31	0	81832	\N
19007	336	1	0	80796	\N
19007	356	2	0	81773	\N
19010	2	1	0	81713	\N
19010	26	2	0	81844	\N
19014	79	2	0	81858	\N
19014	616	3	0	81859	\N
19018	94	2	0	81868	\N
19018	95	3	0	81869	\N
19025	391	1	0	81798	\N
19025	392	2	0	81799	\N
19026	2	5	0	81713	\N
19026	3914	6	0	81897	\N
19029	4233	3	0	81498	\N
19029	5539	4	0	81912	\N
19032	316	1	0	81919	\N
19032	317	2	0	81920	\N
19034	12	2	0	81925	\N
19034	2804	3	0	80551	\N
19039	4178	2	0	81943	\N
19039	4247	3	0	81944	\N
19042	56	6	0	81962	\N
19042	5541	7	0	81963	\N
19045	597	1	0	78543	\N
19045	598	2	0	81977	\N
19059	113	2	0	78422	\N
19059	1899	3	0	82032	\N
19063	40	10	0	82055	\N
19063	5548	11	0	82056	\N
19068	4178	1	0	82008	\N
19068	4450	2	0	82077	\N
19070	4178	1	0	82008	\N
19070	4450	2	0	82077	\N
19073	320	2	0	82086	\N
19073	1937	3	0	82087	\N
19077	56	2	0	82101	\N
19077	2795	3	0	82102	\N
19082	40	2	0	82117	\N
19082	282	3	0	82118	\N
19085	4	8	0	82140	\N
19085	5552	9	0	82141	\N
19088	391	1	0	82147	\N
19088	392	2	0	82148	\N
19091	3505	6	0	82177	\N
19091	5555	7	0	82179	\N
19093	51	3	0	81253	\N
19093	3533	4	0	82188	\N
19097	113	3	0	78422	\N
19097	3620	4	0	78423	\N
19100	4172	6	0	82071	\N
19100	4197	7	0	82222	\N
19102	4178	6	0	82225	\N
19102	4250	7	0	82226	\N
19104	173	2	0	82233	\N
19104	3179	3	0	82234	\N
19110	251	3	0	80864	\N
19110	3410	4	0	82285	\N
18964	57	2	0	81722	\N
18967	4178	2	0	81733	\N
18967	4247	3	0	81734	\N
18969	244	2	0	81737	\N
18969	3308	3	0	81738	\N
18971	268	1	0	81747	\N
18971	269	2	0	81748	\N
18979	71	1	0	81298	\N
18979	72	2	0	81299	\N
18993	147	2	0	73443	\N
18993	3287	3	0	81754	\N
18994	206	2	0	81806	\N
18994	2773	3	0	81807	\N
19001	135	1	0	81826	\N
19001	136	2	0	81827	\N
19003	3628	0	0	81511	\N
19006	73	2	0	81831	\N
19006	2766	3	0	81835	\N
19008	224	1	0	81840	\N
19008	225	2	0	81841	\N
19012	121	2	0	81850	\N
19012	2498	3	0	81851	\N
19015	1470	2	0	81860	\N
19015	3368	3	0	81861	\N
19019	96	0	0	81870	\N
19021	149	4	0	81879	\N
19021	5500	5	0	81880	\N
19024	4983	1	0	81883	\N
19024	2351	2	0	81884	\N
19027	4178	2	0	81733	\N
19027	4247	3	0	81734	\N
19030	4178	1	0	81915	\N
19030	4450	2	0	81916	\N
19033	16	1	0	81701	\N
19033	17	2	0	81702	\N
19037	56	1	0	81936	\N
19037	57	2	0	81937	\N
19043	94	6	0	81964	\N
19043	5542	7	0	81965	\N
19046	595	1	0	70634	\N
19046	596	2	0	81978	\N
19048	4172	2	0	81949	\N
19048	4191	3	0	81984	\N
19049	273	5	0	81995	\N
19049	5544	6	0	81996	\N
19051	4178	1	0	82000	\N
19051	4450	2	0	82001	\N
19055	147	2	0	82028	\N
19055	3287	3	0	82029	\N
19057	595	2	0	70634	\N
19057	3285	3	0	70635	\N
19060	94	2	0	81964	\N
19060	2794	3	0	82033	\N
19066	4172	2	0	82071	\N
19066	5549	3	0	82072	\N
19071	119	2	0	81508	\N
19071	1879	3	0	81509	\N
19075	75	1	0	81852	\N
19075	76	2	0	82092	\N
19078	214	2	0	82103	\N
19078	1259	3	0	82104	\N
19080	224	1	0	81840	\N
19080	225	2	0	81841	\N
19083	1141	3	0	82124	\N
19083	5551	4	0	82125	\N
19086	316	8	0	81919	\N
19086	5553	9	0	82142	\N
19096	451	24	0	82197	\N
19096	5556	25	0	82199	\N
19103	5557	6	0	82227	\N
19103	5558	7	0	82228	\N
19105	300	4	0	81731	\N
19105	2992	5	0	82243	\N
19108	5561	7	0	82273	\N
19002	119	0	0	81508	\N
19004	3625	0	0	81828	\N
19011	62	2	0	81667	\N
19011	2191	3	0	81849	\N
19020	96	4	0	81231	\N
19020	5538	5	0	81878	\N
19023	4983	1	0	81883	\N
19023	2351	2	0	81884	\N
19028	258	1	0	81904	\N
19028	309	2	0	81905	\N
19031	40	1	0	81719	\N
19031	41	2	0	81720	\N
19036	1021	1	0	81932	\N
19036	1022	2	0	81933	\N
19047	147	1	0	73443	\N
19047	599	2	0	81979	\N
19050	30	5	0	79189	\N
19050	5545	6	0	81997	\N
19053	18	3	0	81555	\N
19053	609	4	0	82010	\N
19054	108	6	0	81524	\N
19054	5546	7	0	82023	\N
19056	597	2	0	78543	\N
19056	3286	3	0	81753	\N
19058	4172	2	0	82030	\N
19058	4191	3	0	82031	\N
19065	27	4	0	82066	\N
19065	3717	5	0	82067	\N
19067	12	2	0	82073	\N
19067	5550	3	0	82074	\N
19072	3628	2	0	81511	\N
19072	4360	3	0	81512	\N
19074	3625	2	0	82088	\N
19074	4359	3	0	82089	\N
19079	40	1	0	82107	\N
19079	41	2	0	82108	\N
19081	4178	1	0	82111	\N
19081	4450	2	0	82112	\N
19087	4178	1	0	82145	\N
19087	4450	2	0	82146	\N
19090	3505	29	0	82177	\N
19090	5554	30	0	82178	\N
19095	451	3	0	82197	\N
19095	3934	4	0	82198	\N
19099	4178	3	0	82208	\N
19099	4211	4	0	82209	\N
19107	4172	6	0	82071	\N
19107	4365	7	0	82271	\N
19109	4172	3	0	82071	\N
19109	4275	4	0	82279	\N
19044	435	4	0	81757	\N
19044	5543	5	0	81974	\N
19052	4178	3	0	82008	\N
19052	4441	4	0	82009	\N
19061	75	2	0	81852	\N
19061	284	3	0	81853	\N
19062	4787	10	0	82053	\N
19062	5547	11	0	82054	\N
19064	198	1	0	81690	\N
19064	199	2	0	82059	\N
19069	206	1	0	82078	\N
19069	207	2	0	82079	\N
19076	14	1	0	82095	\N
19076	15	2	0	82096	\N
19084	4172	8	0	82071	\N
19084	5165	9	0	82139	\N
19089	4178	7	0	82145	\N
19089	4708	8	0	82162	\N
19092	285	3	0	82186	\N
19092	4496	4	0	82187	\N
19094	33	3	0	82195	\N
19094	3342	4	0	82196	\N
19098	4178	3	0	82200	\N
19098	4211	4	0	82201	\N
19101	391	6	0	82223	\N
19101	3521	7	0	82224	\N
19106	242	8	0	82258	\N
19106	5559	9	0	82259	\N
19111	18	2	0	82290	\N
19111	1685	3	0	82291	\N
19112	2636	1	0	81384	\N
19112	3207	2	0	82294	\N
19113	322	1	0	79562	\N
19113	2968	2	0	82295	\N
19114	16	0	0	81701	\N
19115	113	0	0	78422	\N
19116	40	6	0	82308	\N
19116	2777	7	0	82309	\N
19117	60	2	0	82314	\N
19117	4544	3	0	82315	\N
19118	360	2	0	79674	\N
19118	2767	3	0	82316	\N
19119	996	2	0	82317	\N
19119	5562	3	0	82318	\N
19120	279	2	0	82319	\N
19120	4525	3	0	82320	\N
19121	5563	27	0	82334	\N
19121	841	29	0	82335	\N
19121	2907	30	0	82336	\N
19122	4172	4	0	82345	\N
19122	4252	5	0	82346	\N
19123	841	4	0	82347	\N
19123	2774	5	0	82348	\N
19124	200	2	0	82353	\N
19124	276	3	0	82354	\N
19125	40	2	0	82355	\N
19125	282	3	0	82356	\N
19126	6	2	0	81251	\N
19126	2805	3	0	82361	\N
19127	1636	2	0	82362	\N
19127	4416	3	0	82363	\N
19128	242	2	0	82364	\N
19128	3425	3	0	82365	\N
19129	44	2	0	82366	\N
19129	1910	3	0	82367	\N
19130	145	53	0	80242	\N
19130	5564	54	0	82398	\N
19131	164	6	0	82406	\N
19131	3583	7	0	82407	\N
19132	391	6	0	82223	\N
19132	3521	7	0	82224	\N
19133	198	6	0	82420	\N
19133	5565	7	0	82421	\N
19134	4178	10	0	82442	\N
19134	4665	11	0	82443	\N
19135	12	3	0	82450	\N
19135	4204	4	0	82451	\N
19136	75	3	0	82458	\N
19136	3855	4	0	82459	\N
19137	908	4	0	78681	\N
19137	3488	5	0	82468	\N
19138	908	3	0	78681	\N
19138	3591	4	0	82470	\N
19139	40	4	0	82355	\N
19139	3381	5	0	82471	\N
19140	2578	3	0	82478	\N
19140	4431	4	0	82479	\N
19141	1914	3	0	77733	\N
19141	3637	4	0	82480	\N
19142	908	7	0	78681	\N
19142	4078	8	0	82495	\N
19143	908	5	0	78681	\N
19143	5076	6	0	82496	\N
19144	35	3	0	82503	\N
19144	3563	4	0	82504	\N
19145	40	3	0	82505	\N
19145	372	4	0	82506	\N
19146	224	3	0	81840	\N
19146	3603	4	0	82513	\N
19147	4172	3	0	82520	\N
19147	4275	4	0	82521	\N
19148	960	4	0	8954	\N
19148	5566	5	0	82530	\N
19149	224	4	0	82531	\N
19149	3806	5	0	82532	\N
19150	326	19	0	82571	\N
19150	5567	20	0	82572	\N
19151	78	1	0	82575	\N
19151	77	5	0	82582	\N
19151	5568	6	0	82583	\N
19152	201	1	0	82584	\N
19152	200	5	0	82585	\N
19152	5569	6	0	82586	\N
19153	78	1	0	82575	\N
19153	77	5	0	82582	\N
19153	5568	6	0	82583	\N
19154	455	1	0	82587	\N
19154	132	5	0	82588	\N
19154	1423	6	0	82589	\N
19155	455	1	0	82587	\N
19155	132	5	0	82588	\N
19155	1423	6	0	82589	\N
19156	4178	4	0	82598	\N
19156	4205	5	0	82599	\N
19157	18	3	0	82606	\N
19157	3621	4	0	82607	\N
19158	5570	3	0	82608	\N
19158	5571	4	0	82609	\N
19159	94	4	0	81964	\N
19159	4677	5	0	82618	\N
19160	202	6	0	76241	\N
19160	4079	7	0	80327	\N
19161	202	8	0	76241	\N
19161	4609	9	0	82636	\N
19162	4172	3	0	82643	\N
19162	4275	4	0	82644	\N
19163	488	3	0	82645	\N
19163	1103	4	0	82646	\N
19164	2	3	0	82647	\N
19164	3548	4	0	82648	\N
19165	75	3	0	82649	\N
19165	3855	4	0	82650	\N
19166	268	7	0	82665	\N
19166	5254	8	0	82666	\N
19167	40	7	0	82667	\N
19167	4718	8	0	82668	\N
19168	4178	7	0	82683	\N
19168	4396	8	0	82684	\N
19169	453	3	0	79525	\N
19169	2838	4	0	79526	\N
19170	58	3	0	82697	\N
19170	3665	4	0	82698	\N
19171	431	3	0	82699	\N
19171	3933	4	0	82700	\N
19172	210	3	0	82707	\N
19172	3539	4	0	82708	\N
19173	181	14	0	81821	\N
19173	5572	15	0	82737	\N
19176	322	3	0	82756	\N
19176	1105	4	0	82757	\N
19183	164	4	0	82801	\N
19183	5576	5	0	82802	\N
19197	4172	7	0	82900	\N
19197	4614	8	0	82901	\N
19208	4172	3	0	82943	\N
19208	4275	4	0	82998	\N
19210	121	4	0	82754	\N
19210	4099	5	0	83008	\N
19214	115	20	0	83059	\N
19214	5585	21	0	83060	\N
19217	4537	7	0	83086	\N
19217	4172	11	0	83093	\N
19217	4940	12	0	83094	\N
19218	5588	7	0	83095	\N
19218	290	11	0	83096	\N
19218	5589	12	0	83097	\N
19222	102	6	0	83109	\N
19222	5086	7	0	83117	\N
19225	595	5	0	70634	\N
19225	4930	6	0	83129	\N
19228	424	5	0	83132	\N
19228	5002	6	0	83133	\N
19230	597	5	0	78543	\N
19230	4929	6	0	83135	\N
19231	40	5	0	83136	\N
19231	2714	6	0	83137	\N
19235	108	3	0	83153	\N
19235	4171	4	0	83154	\N
19239	40	3	0	83165	\N
19239	372	4	0	83166	\N
19244	4178	7	0	83198	\N
19244	4509	8	0	83199	\N
19247	92	3	0	79203	\N
19247	4410	4	0	83216	\N
19249	6	7	0	81251	\N
19249	5595	8	0	83233	\N
19254	322	8	0	83265	\N
19254	5596	9	0	83266	\N
19261	4178	10	0	83241	\N
19261	4665	11	0	83330	\N
19263	92	3	0	83345	\N
19263	4410	4	0	83346	\N
19266	1109	16	0	83373	\N
19266	5605	17	0	83374	\N
19269	3495	3	0	83375	\N
19269	1109	4	0	83376	\N
19276	597	3	0	78543	\N
19276	3656	4	0	83403	\N
19277	145	4	0	80242	\N
19277	5607	5	0	83412	\N
19282	322	4	0	83443	\N
19282	5447	5	0	83444	\N
19287	4178	8	0	83483	\N
19287	5610	9	0	83484	\N
19290	4172	7	0	82943	\N
19290	4614	8	0	83538	\N
19292	320	7	0	83267	\N
19292	4827	8	0	83540	\N
19295	77	3	0	83551	\N
19295	1877	4	0	83552	\N
19297	285	3	0	82186	\N
19297	4496	4	0	82187	\N
19299	145	3	0	83580	\N
19299	4908	4	0	83581	\N
19302	5611	0	0	83600	\N
19307	6	7	0	83659	\N
19307	5595	8	0	83660	\N
19312	595	3	0	83706	\N
19312	3654	4	0	83707	\N
19317	102	8	0	83741	\N
19317	5616	9	0	83742	\N
19319	108	3	0	83751	\N
19319	4171	4	0	83752	\N
19321	189	46	0	77711	\N
19321	5618	47	0	83784	\N
19322	5209	105	0	83791	\N
19322	90	126	0	83796	\N
19322	5619	127	0	83797	\N
19325	4178	9	0	83831	\N
19325	5622	10	0	83832	\N
19332	108	4	0	83894	\N
19332	4060	5	0	83895	\N
19337	2636	3	0	81384	\N
19337	2837	4	0	83939	\N
19340	402	10	0	83966	\N
19340	5634	11	0	83967	\N
19342	16	10	0	83970	\N
19342	5636	11	0	83971	\N
19344	391	3	0	82223	\N
19344	3660	4	0	82840	\N
19347	2636	4	0	83995	\N
19347	3617	5	0	83996	\N
19350	2	3	0	84023	\N
19350	3548	4	0	84024	\N
19357	424	15	0	83132	\N
19357	5645	16	0	84093	\N
19360	322	3	0	84104	\N
19360	1105	4	0	84105	\N
19363	14	5	0	84126	\N
19363	5648	6	0	84127	\N
19370	324	5	0	84168	\N
19370	3680	6	0	84169	\N
19373	4178	3	0	84180	\N
19373	4211	4	0	84181	\N
19375	115	3	0	84189	\N
19375	3483	4	0	84190	\N
19378	206	3	0	84194	\N
19378	4584	4	0	84195	\N
19382	170	2	0	82791	\N
19382	1380	3	0	84204	\N
19385	38	4	0	84216	\N
19385	5656	5	0	84217	\N
19392	273	2	0	83155	\N
19392	5658	3	0	84276	\N
19394	324	0	0	84277	\N
19397	35	4	0	84297	\N
19397	3545	5	0	84298	\N
19403	324	2	0	84277	\N
19403	2808	3	0	84324	\N
19407	173	4	0	84343	\N
19407	3614	5	0	84344	\N
19409	4178	3	0	84180	\N
19409	4211	4	0	84181	\N
19412	186	0	0	80636	\N
19415	367	3	0	80394	\N
19415	3683	4	0	84415	\N
19417	14	4	0	84426	\N
19417	3498	5	0	84427	\N
19421	20	7	0	80985	\N
19421	4714	8	0	84455	\N
19425	391	4	0	84480	\N
19425	3913	5	0	84481	\N
19430	4178	10	0	84522	\N
19430	5667	11	0	84523	\N
19433	142	8	0	84191	\N
19433	5668	9	0	84550	\N
19443	4178	3	0	84532	\N
19443	4211	4	0	84533	\N
19448	353	7	0	84636	\N
19448	4909	8	0	84647	\N
19450	108	5	0	84657	\N
19450	5674	6	0	84658	\N
19452	4178	5	0	84648	\N
19452	4202	6	0	84661	\N
19455	125	3	0	81219	\N
19455	4170	4	0	84692	\N
19457	224	4	0	84703	\N
19457	3806	5	0	84704	\N
19458	75	10	0	84725	\N
19458	4874	11	0	84726	\N
19460	40	2	0	84734	\N
19460	282	3	0	84735	\N
19463	4178	2	0	84742	\N
19463	4247	3	0	84743	\N
19174	27	4	0	82746	\N
19174	3717	5	0	82747	\N
19181	170	5	0	82791	\N
19181	5102	6	0	82792	\N
19185	4233	2	0	82809	\N
19185	5577	3	0	82811	\N
19188	391	3	0	82223	\N
19188	3660	4	0	82840	\N
19190	4178	3	0	82849	\N
19190	4211	4	0	82850	\N
19193	4172	3	0	82874	\N
19193	4275	4	0	82875	\N
19195	4178	3	0	82878	\N
19195	4211	4	0	82879	\N
19198	117	7	0	80962	\N
19198	5276	8	0	82902	\N
19202	4233	5	0	82926	\N
19202	4518	6	0	82930	\N
19206	115	3	0	82988	\N
19206	3483	4	0	82989	\N
19211	324	4	0	83009	\N
19211	3500	5	0	83010	\N
19213	4178	3	0	82903	\N
19213	4211	4	0	83018	\N
19215	115	14	0	83059	\N
19215	5586	15	0	83069	\N
19223	102	6	0	83109	\N
19223	5086	7	0	83117	\N
19226	147	5	0	82028	\N
19226	4932	6	0	83130	\N
19233	5319	3	0	78287	\N
19233	5320	4	0	83146	\N
19236	273	3	0	83155	\N
19236	3638	4	0	83156	\N
19240	1021	3	0	83167	\N
19240	4551	4	0	83168	\N
19248	5594	4	0	83218	\N
19252	360	3	0	79674	\N
19252	3602	4	0	79675	\N
19255	320	8	0	83267	\N
19255	5597	9	0	83268	\N
19257	2351	10	0	83323	\N
19257	5603	11	0	83324	\N
19260	18	10	0	83328	\N
19260	4919	11	0	83329	\N
19264	268	4	0	82665	\N
19264	3897	5	0	83355	\N
19267	3495	3	0	83375	\N
19267	1109	4	0	83376	\N
19270	4109	3	0	83377	\N
19270	56	4	0	83378	\N
19273	595	3	0	70634	\N
19273	3654	4	0	73854	\N
19278	115	6	0	83059	\N
19278	4693	7	0	83425	\N
19280	228	3	0	83433	\N
19280	3186	4	0	83434	\N
19283	40	7	0	83459	\N
19283	4488	8	0	83460	\N
19285	140	8	0	83479	\N
19285	5609	9	0	83480	\N
19291	241	7	0	77263	\N
19291	4987	8	0	83539	\N
19298	228	3	0	83433	\N
19298	3186	4	0	83434	\N
19300	102	4	0	83590	\N
19300	3572	5	0	83591	\N
19303	42	20	0	79641	\N
19303	5612	21	0	83640	\N
19306	56	20	0	83643	\N
19306	5614	21	0	83644	\N
19308	56	7	0	83643	\N
19308	4791	8	0	83661	\N
19310	16	3	0	83674	\N
19310	3634	4	0	83675	\N
19313	147	3	0	82028	\N
19313	3657	4	0	83400	\N
19318	258	8	0	83743	\N
19318	5617	9	0	83744	\N
19320	189	4	0	77711	\N
19320	3992	5	0	83761	\N
19323	90	9	0	77946	\N
19323	5620	10	0	83810	\N
19328	4178	11	0	83831	\N
19328	5625	12	0	83857	\N
19330	5627	4	0	83868	\N
19330	5628	11	0	83881	\N
19330	5629	12	0	83882	\N
19333	288	4	0	82764	\N
19333	5631	5	0	83896	\N
19335	75	15	0	83858	\N
19335	5632	16	0	83928	\N
19341	228	10	0	83968	\N
19341	5635	11	0	83969	\N
19343	4178	10	0	83897	\N
19343	5637	11	0	83972	\N
19348	189	0	0	83997	\N
19349	5638	9	0	84006	\N
19349	189	22	0	84014	\N
19349	5238	23	1	84015	\N
19349	5639	23	0	84016	\N
19351	4178	3	0	84031	\N
19351	4211	4	0	84032	\N
19358	121	15	0	84094	\N
19358	5646	16	0	84095	\N
19361	4172	4	0	83854	\N
19361	4219	5	0	84114	\N
19366	4178	3	0	84031	\N
19366	4211	4	0	84032	\N
19368	2351	7	0	83323	\N
19368	5652	8	0	84152	\N
19371	391	5	0	84170	\N
19371	3558	6	0	84171	\N
19376	142	3	0	84191	\N
19376	4254	4	0	84192	\N
19388	258	5	0	83743	\N
19388	5657	6	0	84266	\N
19391	16	5	0	83970	\N
19391	4240	6	0	84271	\N
19393	324	2	0	84277	\N
19393	3000	3	0	84278	\N
19398	16	4	0	84299	\N
19398	3546	5	0	84300	\N
19401	189	1	0	84312	\N
19401	5660	2	1	84313	\N
19401	1970	2	0	84314	\N
19404	40	4	0	84267	\N
19404	3381	5	0	84325	\N
19405	4172	5	0	83854	\N
19405	4634	6	0	84333	\N
19422	841	3	0	82347	\N
19422	5666	4	0	84457	\N
19426	18	4	0	83328	\N
19426	2302	5	0	84482	\N
19428	51	3	0	84498	\N
19428	3533	4	0	84499	\N
19431	140	3	0	84530	\N
19431	4149	4	0	84531	\N
19434	241	0	0	77263	\N
19439	38	18	0	84216	\N
19439	5671	19	0	84598	\N
19441	167	4	0	84608	\N
19441	4048	5	0	84609	\N
19444	230	0	0	81431	\N
19446	353	5	0	84636	\N
19451	108	2	0	84657	\N
19451	3340	3	0	84660	\N
19453	4178	10	0	84648	\N
19453	5637	11	0	84677	\N
19456	4178	3	0	84693	\N
19456	4211	4	0	84694	\N
19461	137	3	0	79125	\N
19461	3633	4	0	80590	\N
19465	75	4	0	84754	\N
19175	121	3	0	82754	\N
19175	4471	4	0	82755	\N
19178	322	3	0	82766	\N
19178	1105	4	0	82767	\N
19180	5573	47	0	82780	\N
19180	170	126	0	82789	\N
19180	5574	127	0	82790	\N
19182	167	4	0	81349	\N
19182	5575	5	0	82800	\N
19184	4233	3	0	82809	\N
19184	4425	4	0	82810	\N
19187	5579	8	0	82831	\N
19187	40	10	0	82832	\N
19187	1383	11	0	82833	\N
19192	44	7	0	82866	\N
19192	4144	8	0	82867	\N
19196	4172	3	0	82874	\N
19196	4275	4	0	82875	\N
19200	5580	58	0	82909	\N
19200	117	126	0	82910	\N
19200	5581	127	0	82911	\N
19201	4233	7	0	82926	\N
19201	5582	8	0	82927	\N
19204	258	6	0	82945	\N
19204	5583	7	0	82946	\N
19205	73	17	0	82980	\N
19205	5584	18	0	82981	\N
19221	102	4	0	83109	\N
19221	5013	5	0	83110	\N
19224	2636	4	0	81384	\N
19224	5592	5	0	83120	\N
19227	60	5	0	82314	\N
19227	5473	6	0	83131	\N
19229	2636	5	0	81384	\N
19229	3780	6	0	83134	\N
19242	4178	3	0	83171	\N
19242	4211	4	0	83172	\N
19243	4178	5	0	83183	\N
19243	4429	6	0	83184	\N
19246	35	3	0	82503	\N
19246	3563	4	0	82504	\N
19251	4178	3	0	83241	\N
19251	4211	4	0	83242	\N
19253	75	3	0	82649	\N
19253	3855	4	0	82650	\N
19256	5598	78	0	83293	\N
19256	5599	85	0	83299	\N
19256	5600	85	0	83300	\N
19256	5602	86	1	83301	\N
19256	5601	86	0	83302	\N
19259	132	10	0	83326	\N
19259	5050	11	0	83327	\N
19265	16	3	0	83169	\N
19265	3634	4	0	83170	\N
19272	488	4	0	82645	\N
19272	5606	5	0	83393	\N
19275	4178	3	0	83401	\N
19275	4211	4	0	83402	\N
19286	40	8	0	83481	\N
19286	5163	9	0	83482	\N
19289	16	14	0	83522	\N
19289	3455	15	0	83523	\N
19294	336	3	0	83549	\N
19294	3400	4	0	83550	\N
19296	360	7	0	79674	\N
19296	4970	8	0	83567	\N
19301	4172	3	0	83598	\N
19301	4275	4	0	83599	\N
19305	6	20	0	83641	\N
19305	5613	21	0	83642	\N
19309	4178	2	0	83666	\N
19309	4527	3	0	83667	\N
19316	4178	7	0	83723	\N
19316	4396	8	0	83724	\N
19324	16	9	0	83829	\N
19324	5621	10	0	83830	\N
19327	285	11	0	82186	\N
19327	5624	12	0	83856	\N
19329	75	11	0	83858	\N
19329	5626	12	0	83859	\N
19339	336	10	0	83549	\N
19339	5633	11	0	83965	\N
19346	35	4	0	82503	\N
19346	3545	5	0	83994	\N
19353	1109	1	0	84033	\N
19353	2971	2	0	84035	\N
19356	5642	11	0	84090	\N
19356	5643	12	0	84091	\N
19356	5644	12	0	84092	\N
19362	113	4	0	78422	\N
19362	3677	5	0	84115	\N
19365	230	3	0	81431	\N
19365	4181	4	0	84137	\N
19367	2351	7	0	83323	\N
19367	5652	8	0	84152	\N
19372	2	3	0	84178	\N
19372	3548	4	0	84179	\N
19374	424	3	0	83132	\N
19374	3611	4	0	84188	\N
19377	189	3	0	83997	\N
19377	3782	4	0	84193	\N
19380	189	2	0	83997	\N
19380	3441	3	0	84199	\N
19384	40	4	0	84214	\N
19384	3381	5	0	84215	\N
19386	449	3	0	84224	\N
19386	4760	4	0	84225	\N
19387	214	14	0	84254	\N
19387	2338	15	0	84255	\N
19390	23	5	0	84269	\N
19390	4564	6	0	84270	\N
19396	716	4	0	84295	\N
19396	5659	5	0	84296	\N
19399	12	4	0	84301	\N
19399	4043	5	0	84302	\N
19400	189	4	0	83997	\N
19400	3992	5	0	84311	\N
19402	324	4	0	84277	\N
19402	3500	5	0	84323	\N
19411	4178	7	0	84392	\N
19411	4396	8	0	84393	\N
19414	40	3	0	84267	\N
19414	372	4	0	84414	\N
19416	4172	4	0	84424	\N
19416	4219	5	0	84425	\N
19419	5663	3	0	84436	\N
19419	5664	3	0	84437	\N
19419	5665	4	1	84438	\N
19419	842	4	0	84439	\N
19420	841	7	0	82347	\N
19420	5065	8	0	84454	\N
19427	33	4	0	82195	\N
19427	5122	5	0	84491	\N
19437	4178	3	0	84532	\N
19437	4211	4	0	84533	\N
19438	5669	0	0	84560	\N
19438	5670	0	0	84561	\N
19454	181	3	0	84684	\N
19454	4184	4	0	84685	\N
19462	4172	2	0	84740	\N
19462	4191	3	0	84741	\N
19464	488	4	0	84752	\N
19464	5606	5	0	84753	\N
19467	125	11	0	81219	\N
19467	5675	12	0	84784	\N
19470	142	3	0	84794	\N
19470	4254	4	0	84800	\N
19472	488	4	0	84809	\N
19472	5606	5	0	84810	\N
19479	1618	7	0	84866	\N
19479	18	9	0	84867	\N
19479	1426	10	0	84868	\N
19482	198	3	0	84879	\N
19482	4263	4	0	84880	\N
19486	4178	3	0	84742	\N
19486	4211	4	0	84894	\N
19488	202	4	0	84903	\N
19177	288	3	0	82764	\N
19177	3003	4	0	82765	\N
19179	16	5	0	82778	\N
19179	4240	6	0	82779	\N
19186	5578	8	0	82826	\N
19186	4172	10	0	82829	\N
19186	5004	11	0	82830	\N
19189	4178	3	0	82841	\N
19189	4211	4	0	82842	\N
19191	1636	7	0	82362	\N
19191	4720	8	0	82865	\N
19194	123	3	0	82876	\N
19194	2856	4	0	82877	\N
19199	4178	7	0	82903	\N
19199	4396	8	0	82904	\N
19203	4172	6	0	82943	\N
19203	4197	7	0	82944	\N
19207	115	2	0	82988	\N
19207	2797	3	0	82991	\N
19209	316	3	0	81919	\N
19209	4249	4	0	82999	\N
19212	121	3	0	82754	\N
19212	4471	4	0	82755	\N
19216	40	20	0	83070	\N
19216	5587	21	0	83071	\N
19219	5590	7	0	83098	\N
19219	324	11	0	83099	\N
19219	5591	12	0	83100	\N
19220	5590	7	0	83098	\N
19220	324	11	0	83099	\N
19220	5591	12	0	83100	\N
19232	60	1	0	82314	\N
19232	5088	2	0	83139	\N
19234	4172	3	0	82943	\N
19234	4275	4	0	82998	\N
19237	528	3	0	69371	\N
19237	4262	4	0	69839	\N
19238	279	2	0	83157	\N
19238	5593	3	0	83158	\N
19241	16	3	0	83169	\N
19241	3634	4	0	83170	\N
19245	336	4	0	83208	\N
19245	3947	5	0	83209	\N
19250	290	3	0	71115	\N
19250	3635	4	0	83240	\N
19258	528	10	0	69371	\N
19258	5604	11	0	83325	\N
19262	2	3	0	83337	\N
19262	3548	4	0	83338	\N
19268	3495	3	0	83375	\N
19268	1109	4	0	83376	\N
19271	40	3	0	83165	\N
19271	372	4	0	83166	\N
19274	147	3	0	82028	\N
19274	3657	4	0	83400	\N
19279	365	6	0	77033	\N
19279	4759	7	0	83426	\N
19281	4178	3	0	83401	\N
19281	4211	4	0	83402	\N
19284	94	7	0	83461	\N
19284	5608	8	0	83462	\N
19288	4178	4	0	83483	\N
19288	4205	5	0	83493	\N
19293	192	3	0	83547	\N
19293	3790	4	0	83548	\N
19304	6	20	0	83641	\N
19304	5613	21	0	83642	\N
19311	262	11	0	83698	\N
19311	5615	12	0	83699	\N
19314	597	3	0	78543	\N
19314	3656	4	0	83403	\N
19315	241	3	0	77263	\N
19315	3613	4	0	83708	\N
19326	4172	11	0	83854	\N
19326	5623	12	0	83855	\N
19331	2443	4	0	83883	\N
19331	67	11	0	83884	\N
19331	5630	12	0	83885	\N
19334	4178	4	0	83897	\N
19334	4205	5	0	83898	\N
19336	2636	4	0	81384	\N
19336	3617	5	0	83937	\N
19338	140	4	0	83479	\N
19338	3821	5	0	83947	\N
19345	4178	3	0	83897	\N
19345	4211	4	0	83985	\N
19352	1109	3	0	84033	\N
19352	3495	4	0	84034	\N
19354	40	12	0	84057	\N
19354	5640	13	0	84058	\N
19355	77	15	0	83551	\N
19355	5641	16	0	84089	\N
19359	262	15	0	84096	\N
19359	5647	16	0	84097	\N
19364	230	3	0	81431	\N
19364	5650	4	1	84134	\N
19364	5649	4	0	46584	\N
19364	5651	5	1	84135	\N
19364	1699	5	0	84136	\N
19364	4408	6	0	59689	\N
19369	98	3	0	64855	\N
19369	4695	4	0	64856	\N
19379	5653	5	0	84196	\N
19379	5654	5	0	84197	\N
19379	4225	6	0	84198	\N
19381	170	2	0	82791	\N
19381	1380	3	0	84204	\N
19383	1470	4	0	81860	\N
19383	5655	5	0	84213	\N
19389	40	5	0	84267	\N
19389	2714	6	0	84268	\N
19395	391	4	0	84170	\N
19395	3352	5	0	84286	\N
19406	56	3	0	83643	\N
19406	4109	4	0	83378	\N
19408	5661	98	0	84345	\N
19408	88	126	0	84368	\N
19408	5662	127	0	84369	\N
19410	88	3	0	84376	\N
19410	3655	4	0	84377	\N
19413	4172	6	0	84406	\N
19413	4197	7	0	84407	\N
19418	4178	3	0	84434	\N
19418	4211	4	0	84435	\N
19423	16	7	0	84299	\N
19423	4723	8	0	84458	\N
19424	424	6	0	83132	\N
19424	3712	7	0	84471	\N
19429	4172	3	0	84500	\N
19429	4275	4	0	84501	\N
19432	4178	3	0	84532	\N
19432	4211	4	0	84533	\N
19435	241	8	0	77263	\N
19435	4230	9	0	84551	\N
19436	4172	3	0	84558	\N
19436	4275	4	0	84559	\N
19440	132	18	0	83326	\N
19440	5672	19	0	84599	\N
19442	4172	4	0	84618	\N
19442	4634	5	0	84619	\N
19445	451	0	0	82197	\N
19447	230	7	0	84645	\N
19447	5285	8	0	84646	\N
19449	4178	7	0	84648	\N
19449	4396	8	0	84649	\N
19459	391	3	0	84480	\N
19459	3660	4	0	84733	\N
19466	528	3	0	69371	\N
19466	4262	4	0	69839	\N
19469	142	1	0	84794	\N
19469	143	2	0	84795	\N
19474	115	7	0	84189	\N
19474	5676	8	0	84832	\N
19477	4178	5	0	84742	\N
19477	4202	6	0	84848	\N
19485	819	3	0	84886	\N
19485	5678	4	0	84887	\N
19465	3959	5	0	84755	\N
19471	391	3	0	84480	\N
19471	3660	4	0	84733	\N
19473	62	3	0	81667	\N
19473	3344	4	0	84817	\N
19476	77	4	0	84843	\N
19476	3619	5	0	84847	\N
19478	3709	7	0	84861	\N
19478	132	9	0	84864	\N
19478	3116	10	0	84865	\N
19481	27	2	0	84875	\N
19481	645	3	0	84876	\N
19492	435	5	0	84921	\N
19492	2354	6	0	84922	\N
19497	100	3	0	84961	\N
19497	3836	4	0	84962	\N
19499	147	4	0	82028	\N
19499	3877	5	0	84979	\N
19503	260	4	0	81356	\N
19503	3728	5	0	84985	\N
19507	16	6	0	85003	\N
19507	3369	7	0	85004	\N
19508	108	4	0	85013	\N
19508	4060	5	0	85014	\N
19514	391	3	0	85000	\N
19514	3660	4	0	85027	\N
19517	18	4	0	85045	\N
19517	2302	5	0	85046	\N
19519	2782	3	0	81434	\N
19519	3659	4	0	85055	\N
19526	279	3	0	83157	\N
19526	3641	4	0	85074	\N
19528	595	4	0	84980	\N
19528	3878	5	0	84981	\N
19535	60	0	0	82314	\N
19537	4178	3	0	85127	\N
19537	4211	4	0	85128	\N
19539	230	4	0	84645	\N
19539	3954	5	0	85148	\N
19549	58	7	0	85210	\N
19549	4764	8	0	85211	\N
19552	79	6	0	81858	\N
19552	4253	7	0	85227	\N
19555	4172	4	0	85238	\N
19555	4219	5	0	85239	\N
19559	121	2	0	84094	\N
19559	2498	3	0	85264	\N
19561	411	4	0	85279	\N
19561	4858	5	0	85280	\N
19569	402	3	0	83966	\N
19569	4077	4	0	85339	\N
19587	324	3	0	85431	\N
19587	4514	4	0	85432	\N
19591	40	3	0	85442	\N
19591	372	4	0	85443	\N
19595	14	3	0	84426	\N
19595	4272	4	0	85452	\N
19599	4	3	0	85491	\N
19599	3837	4	0	85492	\N
19608	2544	7	0	85532	\N
19608	5692	8	0	85548	\N
19611	4178	7	0	85433	\N
19611	4396	8	0	85572	\N
19614	241	9	0	77263	\N
19614	5694	10	0	85608	\N
19617	128	3	0	85619	\N
19617	5697	10	0	85632	\N
19617	5698	10	0	85633	\N
19622	241	7	0	85699	\N
19622	4987	8	0	85700	\N
19624	79	7	0	85421	\N
19624	5706	8	0	85721	\N
19625	90	13	0	85748	\N
19625	5707	14	0	85749	\N
19630	391	3	0	85781	\N
19630	3660	4	0	85782	\N
19639	230	3	0	85173	\N
19639	4181	4	0	85858	\N
19642	44	3	0	82866	\N
19642	3631	4	0	85863	\N
19644	56	7	0	85879	\N
19644	4791	8	0	85880	\N
19647	5712	32	0	85896	\N
19647	88	109	0	85927	\N
19647	5713	110	1	85928	\N
19647	5243	110	0	85929	\N
19652	453	6	0	85972	\N
19652	4091	7	0	85973	\N
19657	75	7	0	86005	\N
19657	2859	8	0	86006	\N
19662	290	5	0	86042	\N
19662	5714	6	0	86043	\N
19667	71	10	0	86083	\N
19667	5715	11	0	86084	\N
19669	40	8	0	86102	\N
19669	5163	9	0	86103	\N
19674	262	18	0	84096	\N
19674	5721	19	0	86147	\N
19678	5725	6	0	86202	\N
19678	30	9	0	86207	\N
19678	2980	10	0	86208	\N
19683	56	9	0	86106	\N
19683	5731	10	0	86253	\N
19685	4	10	0	85491	\N
19685	5733	11	0	86273	\N
19692	88	8	0	84376	\N
19692	5740	9	0	86298	\N
19699	300	3	0	86493	\N
19699	3747	4	0	86494	\N
19702	5746	81	0	86501	\N
19702	233	126	0	86506	\N
19702	5747	127	0	86507	\N
19704	108	6	0	85013	\N
19704	5748	7	0	86522	\N
19707	5750	5	0	86545	\N
19707	528	6	0	86546	\N
19709	5749	5	0	86543	\N
19709	92	6	0	86544	\N
19711	266	3	0	85750	\N
19711	3474	4	0	86557	\N
19714	285	3	0	82186	\N
19714	4496	4	0	82187	\N
19716	170	9	0	86627	\N
19716	5756	10	0	86628	\N
19719	353	4	0	86653	\N
19719	2724	5	0	86654	\N
19721	4	3	0	85491	\N
19721	3837	4	0	85492	\N
19728	75	6	0	86749	\N
19728	4694	7	0	86750	\N
19732	156	3	0	86767	\N
19732	4594	4	0	86768	\N
19736	365	2	0	77033	\N
19736	5072	3	0	86789	\N
19737	88	2	0	84376	\N
19737	3010	3	0	86790	\N
19739	79	3	0	86745	\N
19739	3652	4	0	86835	\N
19742	140	3	0	86844	\N
19742	4149	4	0	86845	\N
19744	2351	7	0	86865	\N
19744	5652	8	0	86866	\N
19745	4178	12	0	86891	\N
19745	5083	13	0	86892	\N
19748	4178	3	0	86909	\N
19748	4211	4	0	86910	\N
19750	35	3	0	84297	\N
19750	3563	4	0	86940	\N
19753	16	3	0	86755	\N
19753	3634	4	0	86947	\N
19755	290	2	0	86042	\N
19755	3176	3	0	86955	\N
19757	336	0	0	83549	\N
19762	852	3	0	80128	\N
19762	3612	4	0	80129	\N
19468	40	3	0	84734	\N
19468	372	4	0	84791	\N
19475	77	5	0	84843	\N
19475	5677	6	0	84844	\N
19480	40	1	0	84871	\N
19480	1383	2	0	84872	\N
19483	198	3	0	84879	\N
19483	4263	4	0	84880	\N
19484	4178	3	0	84742	\N
19484	4941	4	0	84885	\N
19487	40	4	0	84871	\N
19487	2796	5	0	84896	\N
19489	228	4	0	84905	\N
19489	5679	5	0	84906	\N
19491	14	5	0	84426	\N
19491	5648	6	0	84920	\N
19496	62	3	0	84959	\N
19496	3344	4	0	84960	\N
19502	4172	4	0	84983	\N
19502	4219	5	0	84984	\N
19506	198	6	0	84879	\N
19506	5565	7	0	85002	\N
19511	121	4	0	84094	\N
19511	4099	5	0	85018	\N
19516	4178	4	0	85043	\N
19516	4205	5	0	85044	\N
19523	4178	3	0	85043	\N
19523	4211	4	0	85056	\N
19525	86	3	0	85069	\N
19525	3746	4	0	85073	\N
19527	147	4	0	82028	\N
19527	3877	5	0	84979	\N
19530	40	4	0	85083	\N
19530	3381	5	0	85084	\N
19532	27	7	0	85107	\N
19532	5681	8	0	85108	\N
19544	230	10	0	85173	\N
19544	5683	11	0	85183	\N
19548	56	3	0	83643	\N
19548	4109	4	0	83378	\N
19551	79	79	0	81858	\N
19551	5684	80	0	85214	\N
19553	60	3	0	82314	\N
19553	3585	4	0	85126	\N
19557	2323	7	0	85241	\N
19557	60	38	0	85254	\N
19557	5650	39	1	85255	\N
19557	5685	39	0	85256	\N
19562	75	4	0	84754	\N
19562	3959	5	0	84755	\N
19565	16	3	0	85311	\N
19565	3634	4	0	85312	\N
19567	181	3	0	85324	\N
19567	4184	4	0	85325	\N
19570	402	1	0	83966	\N
19570	2889	2	0	85341	\N
19572	435	4	0	85348	\N
19572	2810	5	0	85349	\N
19574	210	1	0	85346	\N
19574	2926	2	0	85351	\N
19576	411	4	0	85367	\N
19576	4858	5	0	85368	\N
19579	96	1	0	81231	\N
19579	2899	2	0	85395	\N
19581	117	3	0	85406	\N
19581	3653	4	0	85407	\N
19584	273	4	0	85419	\N
19584	3777	5	0	85420	\N
19589	324	0	0	85431	\N
19590	251	3	0	85186	\N
19590	3514	4	0	85435	\N
19593	189	0	0	85019	\N
19597	326	10	0	85481	\N
19597	5690	11	0	85482	\N
19600	40	7	0	85507	\N
19600	4718	8	0	85508	\N
19602	100	3	0	84961	\N
19602	3836	4	0	84962	\N
19605	4172	3	0	85238	\N
19605	4275	4	0	85531	\N
19607	2544	11	0	85532	\N
19607	5691	12	0	85533	\N
19613	4178	7	0	85588	\N
19613	4396	8	0	85589	\N
19616	27	9	0	85611	\N
19616	5696	10	0	85612	\N
19619	1493	3	0	85636	\N
19619	60	10	0	85640	\N
19619	5704	11	0	85641	\N
19620	5705	95	0	85667	\N
19620	60	126	0	85683	\N
19620	1493	127	0	85684	\N
19627	4178	13	0	85752	\N
19627	4782	14	0	85753	\N
19629	30	3	0	79189	\N
19629	3640	4	0	80749	\N
19632	3628	7	0	81511	\N
19632	3629	8	0	85798	\N
19634	4178	3	0	85831	\N
19634	4211	4	0	85832	\N
19637	424	3	0	85194	\N
19637	3611	4	0	85195	\N
19640	92	3	0	85859	\N
19640	4410	4	0	85860	\N
19643	108	7	0	85013	\N
19643	4905	8	0	85878	\N
19648	192	7	0	85944	\N
19648	4713	8	0	85945	\N
19653	453	6	0	85972	\N
19653	4091	7	0	85973	\N
19656	4172	3	0	85990	\N
19656	4275	4	0	85991	\N
19661	75	3	0	86030	\N
19661	3855	4	0	86031	\N
19663	290	3	0	86042	\N
19663	364	4	0	86044	\N
19668	115	10	0	85609	\N
19668	5716	11	0	86085	\N
19672	3464	5	0	86104	\N
19672	5719	6	0	86108	\N
19675	164	18	0	86184	\N
19675	5722	19	0	86185	\N
19680	214	8	0	86227	\N
19680	5728	9	0	86231	\N
19687	424	9	0	85194	\N
19687	5735	10	0	86275	\N
19688	4	9	0	85491	\N
19688	5736	10	0	86276	\N
19695	132	9	0	86409	\N
19695	5744	10	0	86410	\N
19698	4172	18	0	86485	\N
19698	5720	19	0	86486	\N
19701	4088	3	0	77408	\N
19701	4506	4	0	78922	\N
19710	5751	3	0	86553	\N
19710	5752	3	0	86554	\N
19710	5753	4	1	86555	\N
19710	5726	4	0	86556	\N
19717	210	3	0	86635	\N
19717	3539	4	0	86636	\N
19722	189	3	0	85019	\N
19722	3782	4	0	85444	\N
19725	4	2	0	85491	\N
19725	2751	3	0	86732	\N
19727	16	4	0	86747	\N
19727	2575	5	0	86748	\N
19729	16	2	0	86755	\N
19729	388	3	0	86756	\N
19731	1021	3	0	83167	\N
19731	4551	4	0	83168	\N
19734	88	3	0	84376	\N
19734	3655	4	0	84377	\N
19738	5760	49	0	86801	\N
19738	88	95	0	86827	\N
19738	632	96	0	86828	\N
19749	35	84	0	84297	\N
19749	5761	85	0	86938	\N
19488	2293	5	0	84904	\N
19498	113	3	0	84969	\N
19498	3620	4	0	84970	\N
19501	597	4	0	78543	\N
19501	3733	5	0	84982	\N
19505	391	6	0	85000	\N
19505	3521	7	0	85001	\N
19510	264	4	0	80941	\N
19510	3684	5	0	85017	\N
19513	75	4	0	84754	\N
19513	3959	5	0	84755	\N
19518	2782	8	0	81434	\N
19518	5680	9	0	85048	\N
19521	62	3	0	85057	\N
19521	3344	4	0	85058	\N
19522	391	3	0	85000	\N
19522	3660	4	0	85027	\N
19531	210	3	0	85091	\N
19531	3539	4	0	85092	\N
19534	248	1	0	85118	\N
19534	117	4	0	85119	\N
19534	5439	5	0	80963	\N
19536	60	3	0	82314	\N
19536	3585	4	0	85126	\N
19541	4178	4	0	85150	\N
19541	4205	5	0	85151	\N
19543	230	7	0	85173	\N
19543	5228	8	0	85174	\N
19546	251	10	0	85186	\N
19546	5297	11	0	85187	\N
19554	60	4	0	82314	\N
19554	3894	5	0	85237	\N
19556	212	4	0	80407	\N
19556	3732	5	0	85240	\N
19558	121	4	0	84094	\N
19558	4099	5	0	85018	\N
19560	2	2	0	85269	\N
19560	2789	3	0	85270	\N
19563	71	3	0	85295	\N
19563	3770	4	0	85296	\N
19566	224	4	0	85316	\N
19566	3806	5	0	85317	\N
19568	5686	86	0	85326	\N
19568	402	126	0	85337	\N
19568	5687	127	0	85338	\N
19577	16	4	0	85311	\N
19577	2575	5	0	85377	\N
19580	96	2	0	81231	\N
19580	2942	3	0	85399	\N
19582	202	3	0	85408	\N
19582	4857	4	0	85409	\N
19585	79	4	0	85421	\N
19585	3678	5	0	85422	\N
19586	353	3	0	85429	\N
19586	3766	4	0	85430	\N
19598	192	3	0	85489	\N
19598	3790	4	0	85490	\N
19601	300	7	0	85509	\N
19601	5054	8	0	85510	\N
19603	16	3	0	85523	\N
19603	3634	4	0	85524	\N
19606	4178	3	0	85433	\N
19606	4211	4	0	85434	\N
19610	210	3	0	85556	\N
19610	3539	4	0	85557	\N
19621	241	7	0	85699	\N
19621	4987	8	0	85700	\N
19623	391	3	0	85000	\N
19623	3660	4	0	85027	\N
19635	164	7	0	82801	\N
19635	5711	8	0	85847	\N
19638	1636	3	0	85856	\N
19638	5514	4	0	85857	\N
19641	140	3	0	85861	\N
19641	4149	4	0	85862	\N
19646	75	6	0	85894	\N
19646	4694	7	0	85895	\N
19649	181	3	0	85324	\N
19649	4184	4	0	85325	\N
19651	4217	3	0	85958	\N
19651	64	4	0	85959	\N
19654	86	3	0	85980	\N
19654	3746	4	0	85981	\N
19659	18	3	0	86014	\N
19659	3621	4	0	86015	\N
19664	451	3	0	82197	\N
19664	826	4	0	86045	\N
19666	235	10	0	81617	\N
19666	5146	11	0	86082	\N
19671	56	8	0	86106	\N
19671	5718	9	0	86107	\N
19673	4172	18	0	86145	\N
19673	5720	19	0	86146	\N
19676	4178	18	0	86186	\N
19676	5723	19	0	86187	\N
19682	119	9	0	81508	\N
19682	5730	10	0	86252	\N
19684	3628	8	0	86254	\N
19684	5732	9	0	86255	\N
19689	214	10	0	86277	\N
19689	5737	11	0	86278	\N
19691	908	8	0	86296	\N
19691	5739	9	0	86297	\N
19696	4178	9	0	86411	\N
19696	4318	10	0	86412	\N
19706	5749	5	0	86543	\N
19706	92	6	0	86544	\N
19713	285	2	0	82186	\N
19713	3036	3	0	86564	\N
19718	4178	3	0	86643	\N
19718	4211	4	0	86644	\N
19723	189	96	0	86725	\N
19723	5757	97	0	86726	\N
19730	373	5	0	79975	\N
19730	5759	6	0	86760	\N
19735	365	3	0	77033	\N
19735	3839	4	0	77034	\N
19741	411	3	0	85988	\N
19741	3596	4	0	85989	\N
19743	56	2	0	86106	\N
19743	2795	3	0	86850	\N
19747	4172	3	0	86907	\N
19747	4275	4	0	86908	\N
19752	365	0	0	77033	\N
19754	290	3	0	86042	\N
19754	3635	4	0	86954	\N
19756	4172	3	0	86962	\N
19756	4275	4	0	86963	\N
19759	212	3	0	80407	\N
19759	3639	4	0	86970	\N
19761	4178	6	0	86909	\N
19761	4250	7	0	86987	\N
19770	206	3	0	87059	\N
19770	4584	4	0	87060	\N
19779	132	7	0	86409	\N
19779	3709	8	0	84864	\N
19782	38	0	0	84216	\N
19787	92	7	0	87198	\N
19787	5768	8	0	87199	\N
19789	391	3	0	87216	\N
19789	3660	4	0	87217	\N
19795	145	3	0	87247	\N
19795	4908	4	0	87248	\N
19799	3625	8	0	82088	\N
19799	5772	9	0	87276	\N
19801	3628	8	0	87278	\N
19801	5774	9	0	87279	\N
19808	365	3	0	87340	\N
19808	3839	4	0	87341	\N
19814	108	2	0	87359	\N
19814	3340	3	0	87360	\N
19815	113	7	0	85854	\N
19815	5779	8	0	87375	\N
19819	75	4	0	86749	\N
19819	2357	5	0	87403	\N
19824	23	3	0	87442	\N
19824	3497	4	0	87443	\N
19490	14	4	0	84426	\N
19490	2291	5	0	84915	\N
19493	173	4	0	84923	\N
19493	3614	5	0	84924	\N
19494	23	3	0	84269	\N
19494	3497	4	0	84931	\N
19495	16	10	0	84299	\N
19495	4835	11	0	84952	\N
19500	595	4	0	84980	\N
19500	3878	5	0	84981	\N
19504	167	6	0	84998	\N
19504	5066	7	0	84999	\N
19509	224	4	0	85015	\N
19509	3806	5	0	85016	\N
19512	189	4	0	85019	\N
19512	3992	5	0	85020	\N
19515	40	6	0	84871	\N
19515	4255	7	0	85034	\N
19520	4178	3	0	85043	\N
19520	4211	4	0	85056	\N
19524	86	2	0	85069	\N
19524	3321	3	0	85070	\N
19529	597	4	0	78543	\N
19529	3733	5	0	84982	\N
19533	43	1	0	85111	\N
19533	42	4	0	85116	\N
19533	3440	5	0	85117	\N
19538	60	36	0	82314	\N
19538	5682	37	0	85139	\N
19540	230	3	0	84645	\N
19540	4181	4	0	85149	\N
19542	4178	3	0	85150	\N
19542	4211	4	0	85158	\N
19545	40	10	0	85184	\N
19545	4104	11	0	85185	\N
19547	424	3	0	85194	\N
19547	3611	4	0	85195	\N
19550	58	7	0	85210	\N
19550	4764	8	0	85211	\N
19564	4178	3	0	85303	\N
19564	4211	4	0	85304	\N
19571	210	4	0	85346	\N
19571	4993	5	0	85347	\N
19573	173	2	0	84923	\N
19573	2102	3	0	85350	\N
19575	793	4	0	81087	\N
19575	5688	5	0	85358	\N
19578	5689	4	0	85386	\N
19578	528	7	0	85391	\N
19578	3238	8	0	85392	\N
19583	181	4	0	85324	\N
19583	4058	5	0	85418	\N
19588	4178	3	0	85433	\N
19588	4211	4	0	85434	\N
19592	189	3	0	85019	\N
19592	3782	4	0	85444	\N
19594	94	3	0	83461	\N
19594	2864	4	0	85445	\N
19596	260	4	0	81356	\N
19596	3728	5	0	84985	\N
19604	51	3	0	84498	\N
19604	3533	4	0	84499	\N
19609	2544	19	0	85532	\N
19609	5693	20	0	85549	\N
19612	424	7	0	85194	\N
19612	4986	8	0	85587	\N
19615	115	9	0	85609	\N
19615	5695	10	0	85610	\N
19618	1493	3	0	85636	\N
19618	5599	10	0	83299	\N
19618	5701	10	0	85637	\N
19618	5703	11	1	85638	\N
19618	5702	11	0	85639	\N
19626	266	13	0	85750	\N
19626	5708	14	0	85751	\N
19628	4178	7	0	85752	\N
19628	4396	8	0	85768	\N
19631	119	7	0	81508	\N
19631	4891	8	0	85797	\N
19633	5709	14	0	85799	\N
19633	3625	69	0	85823	\N
19633	5710	70	0	85824	\N
19636	113	3	0	85854	\N
19636	3620	4	0	85855	\N
19645	88	6	0	84376	\N
19645	5263	7	0	85893	\N
19650	4217	3	0	85958	\N
19650	64	4	0	85959	\N
19655	411	3	0	85988	\N
19655	3596	4	0	85989	\N
19658	258	3	0	83743	\N
19658	4401	4	0	86013	\N
19660	156	3	0	86022	\N
19660	4594	4	0	86023	\N
19665	4178	9	0	86060	\N
19665	5622	10	0	86061	\N
19670	3464	8	0	86104	\N
19670	5717	9	0	86105	\N
19677	793	18	0	86188	\N
19677	5724	19	0	86189	\N
19679	214	9	0	86227	\N
19679	5727	10	1	86228	\N
19679	5726	10	0	86229	\N
19681	3625	10	0	82088	\N
19681	5729	11	0	86250	\N
19686	424	10	0	85194	\N
19686	5734	11	0	86274	\N
19690	4	7	0	85491	\N
19690	5738	8	0	86279	\N
19693	488	8	0	86299	\N
19693	5741	9	0	86300	\N
19694	5742	49	0	86349	\N
19694	88	126	0	86389	\N
19694	5743	127	0	86390	\N
19697	125	17	0	86447	\N
19697	5745	18	0	86448	\N
19700	42	3	0	79641	\N
19700	3645	4	0	85117	\N
19703	233	3	0	86508	\N
19703	3704	4	0	86509	\N
19705	4172	6	0	86535	\N
19705	4197	7	0	86536	\N
19708	5750	5	0	86545	\N
19708	528	6	0	86546	\N
19712	326	3	0	86558	\N
19712	3339	4	0	86559	\N
19715	5754	109	0	86606	\N
19715	285	126	0	86607	\N
19715	5755	127	0	86608	\N
19720	353	6	0	86653	\N
19720	4876	7	0	86661	\N
19724	189	12	0	85019	\N
19724	5758	13	0	86730	\N
19726	79	6	0	86745	\N
19726	4253	7	0	86746	\N
19733	260	6	0	86781	\N
19733	5311	7	0	86782	\N
19740	4178	3	0	86836	\N
19740	4211	4	0	86837	\N
19746	2	3	0	86899	\N
19746	3548	4	0	86900	\N
19765	2636	10	0	83995	\N
19765	5762	11	0	87021	\N
19767	189	10	0	87024	\N
19767	5763	11	0	87025	\N
19769	4172	3	0	87057	\N
19769	4275	4	0	87058	\N
19772	140	6	0	87081	\N
19772	5056	7	0	87082	\N
19775	79	3	0	86745	\N
19775	3652	4	0	86835	\N
19777	4178	3	0	87119	\N
19777	4211	4	0	87120	\N
19780	4172	7	0	87057	\N
19780	4614	8	0	87137	\N
19785	4180	6	0	87177	\N
19785	18	8	0	87180	\N
19751	365	3	0	77033	\N
19751	3839	4	0	77034	\N
19758	336	3	0	83549	\N
19758	3400	4	0	83550	\N
19760	16	2	0	86755	\N
19760	388	3	0	86756	\N
19763	164	0	0	86184	\N
19766	189	6	0	87022	\N
19766	3103	7	0	87023	\N
19768	5764	86	0	87043	\N
19768	189	94	0	87049	\N
19768	5765	95	0	87050	\N
19773	2	7	0	87097	\N
19773	2858	8	0	87098	\N
19776	142	3	0	84794	\N
19776	4254	4	0	84800	\N
19778	353	7	0	87135	\N
19778	4909	8	0	87136	\N
19781	38	9	0	84216	\N
19781	5766	10	0	87156	\N
19783	266	3	0	85750	\N
19783	3474	4	0	86557	\N
19786	86	7	0	87196	\N
19786	5767	8	0	87197	\N
19791	30	3	0	87226	\N
19791	3640	4	0	87227	\N
19794	40	3	0	86102	\N
19794	372	4	0	87246	\N
19798	149	8	0	87274	\N
19798	5771	9	0	87275	\N
19800	119	8	0	81508	\N
19800	5773	9	0	87277	\N
19804	79	10	0	87312	\N
19804	5776	11	0	87313	\N
19806	4838	4	0	87330	\N
19806	5777	5	0	87331	\N
19807	2	3	0	87338	\N
19807	3548	4	0	87339	\N
19811	4172	1	0	87345	\N
19811	4201	2	0	87346	\N
19812	6	2	0	87351	\N
19812	2805	3	0	87352	\N
19813	268	2	0	87357	\N
19813	2800	3	0	87358	\N
19816	262	5	0	84096	\N
19816	4539	6	0	87386	\N
19821	241	5	0	87417	\N
19821	5780	6	0	87418	\N
19826	75	2	0	87450	\N
19826	284	3	0	87451	\N
19829	38	3	0	87462	\N
19829	5259	4	0	87463	\N
19835	391	4	0	87492	\N
19835	3913	5	0	87493	\N
19838	424	3	0	85194	\N
19838	3611	4	0	85195	\N
19840	391	4	0	87526	\N
19840	3913	5	0	87527	\N
19842	2351	3	0	87536	\N
19842	2845	4	0	87537	\N
19851	4178	5	0	87590	\N
19851	4429	6	0	87591	\N
19855	324	0	0	87600	\N
19857	449	6	0	87615	\N
19857	4055	7	0	87616	\N
19860	5789	3	0	87644	\N
19860	1736	6	0	87649	\N
19860	5790	7	0	87650	\N
19864	4178	3	0	87590	\N
19864	4211	4	0	87664	\N
19871	56	3	0	87729	\N
19871	4109	4	0	87730	\N
19872	40	3	0	87737	\N
19872	372	4	0	87652	\N
19875	189	16	0	87753	\N
19875	5798	17	0	87754	\N
19886	86	3	0	87828	\N
19886	3746	4	0	87833	\N
19891	88	11	0	87881	\N
19891	5801	12	0	87882	\N
19894	241	4	0	87895	\N
19894	4582	5	0	87896	\N
19897	3835	4	0	87909	\N
19897	117	5	0	87910	\N
19900	3531	4	0	87913	\N
19900	435	5	0	87914	\N
19902	242	7	0	82364	\N
19902	4592	8	0	87930	\N
19910	16	4	0	87975	\N
19910	5446	5	0	87976	\N
19911	1470	6	0	81860	\N
19911	5803	7	0	87989	\N
19916	173	5	0	88019	\N
19916	4902	6	0	88020	\N
19919	242	7	0	82364	\N
19919	5808	8	0	88047	\N
19923	40	1	0	88066	\N
19923	1383	2	0	88067	\N
19926	16	3	0	87975	\N
19926	3634	4	0	88076	\N
19928	108	3	0	88091	\N
19928	4171	4	0	88092	\N
19930	192	5	0	88102	\N
19930	3284	6	0	88103	\N
19940	273	3	0	88136	\N
19940	3638	4	0	88137	\N
19947	16	7	0	88116	\N
19947	4723	8	0	88231	\N
19948	273	15	0	88262	\N
19948	5813	16	0	88263	\N
19950	2782	3	0	88271	\N
19950	3659	4	0	88272	\N
19953	2636	10	0	83995	\N
19953	5295	11	0	88295	\N
19954	262	13	0	88322	\N
19954	5815	14	0	88323	\N
19956	4178	11	0	87961	\N
19956	5529	12	0	88338	\N
19966	164	4	0	88405	\N
19966	4152	5	0	88406	\N
19971	597	7	0	78543	\N
19971	5820	8	0	88461	\N
19978	4	9	0	85491	\N
19978	5824	10	0	88488	\N
19985	4178	3	0	88534	\N
19985	4941	4	0	88535	\N
19988	82	5	0	88548	\N
19988	5024	6	0	88549	\N
19997	4178	5	0	88534	\N
19997	5828	6	0	88610	\N
19999	453	5	0	87937	\N
19999	5830	6	0	88623	\N
20006	189	5	0	88056	\N
20006	5837	6	0	88696	\N
20011	51	3	0	84498	\N
20011	3533	4	0	84499	\N
20015	16	3	0	88744	\N
20015	3634	4	0	88745	\N
20018	4172	4	0	88392	\N
20018	4219	5	0	88757	\N
20020	852	4	0	88767	\N
20020	4162	5	0	88768	\N
20026	198	5	0	84879	\N
20026	5843	6	0	88840	\N
20030	51	0	0	84498	\N
20032	230	4	0	88860	\N
20032	3954	5	0	88861	\N
20035	16	3	0	88744	\N
20035	3634	4	0	88745	\N
20039	4088	0	0	77408	\N
20044	4172	4	0	88916	\N
20044	4219	5	0	88917	\N
20046	228	7	0	88934	\N
20046	5491	8	0	88935	\N
20048	164	3	0	88405	\N
20048	3385	4	0	88944	\N
20053	86	3	0	89026	\N
19764	164	3	0	86184	\N
19764	3385	4	0	87000	\N
19771	353	3	0	87067	\N
19771	3766	4	0	87068	\N
19774	734	3	0	87105	\N
19774	5037	4	0	87106	\N
19784	30	3	0	87163	\N
19784	3640	4	0	87164	\N
19790	4178	3	0	87224	\N
19790	4211	4	0	87225	\N
19792	117	4	0	87236	\N
19792	3835	5	0	87237	\N
19809	94	3	0	83461	\N
19809	2864	4	0	85445	\N
19817	16	2	0	87391	\N
19817	388	3	0	87392	\N
19820	66	2	0	87406	\N
19820	40	7	0	87415	\N
19820	2796	8	0	87416	\N
19822	241	2	0	87417	\N
19822	634	3	0	87423	\N
19825	431	2	0	87448	\N
19825	2772	3	0	87449	\N
19827	102	3	0	87458	\N
19827	5781	4	0	87459	\N
19836	88	3	0	87500	\N
19836	3655	4	0	87501	\N
19841	64	4	0	87528	\N
19841	3911	5	0	87529	\N
19844	2351	3	0	87536	\N
19844	2845	4	0	87537	\N
19850	100	6	0	87579	\N
19850	5787	7	0	87580	\N
19853	151	6	0	81284	\N
19853	3588	7	0	87597	\N
19856	40	6	0	87613	\N
19856	4717	7	0	87614	\N
19862	2856	3	0	87654	\N
19862	123	6	0	82877	\N
19862	4862	7	0	87655	\N
19867	793	20	0	86188	\N
19867	5795	21	0	87717	\N
19869	228	3	0	84905	\N
19869	3186	4	0	87726	\N
19873	819	2	0	87739	\N
19873	5797	3	0	87740	\N
19878	326	3	0	87768	\N
19878	3339	4	0	87769	\N
19881	164	3	0	87803	\N
19881	3385	4	0	87804	\N
19882	132	3	0	86409	\N
19882	3729	4	0	87805	\N
19884	96	7	0	87822	\N
19884	3750	8	0	87823	\N
19889	908	7	0	87855	\N
19889	4078	8	0	87856	\N
19892	4178	4	0	87891	\N
19892	4205	5	0	87892	\N
19896	4172	4	0	87899	\N
19896	4219	5	0	87900	\N
19899	3835	4	0	87909	\N
19899	117	5	0	87910	\N
19903	453	3	0	87937	\N
19903	2838	4	0	87938	\N
19906	230	10	0	85173	\N
19906	5683	11	0	85183	\N
19908	4178	4	0	87961	\N
19908	4468	5	0	87972	\N
19917	40	5	0	87893	\N
19917	5806	6	0	88031	\N
19920	189	4	0	88056	\N
19920	3992	5	0	88057	\N
19932	391	5	0	87526	\N
19932	5462	6	0	88105	\N
19934	16	4	0	88116	\N
19934	3546	5	0	88117	\N
19936	4172	2	0	88124	\N
19936	4191	3	0	88125	\N
19938	202	3	0	85408	\N
19938	4857	4	0	85409	\N
19942	35	3	0	88139	\N
19942	3563	4	0	88140	\N
19944	5810	35	0	88146	\N
19944	35	126	0	88193	\N
19944	5811	127	0	88194	\N
19949	56	15	0	87729	\N
19949	5814	16	0	88264	\N
19952	852	3	0	87718	\N
19952	3612	4	0	88274	\N
19955	262	5	0	88322	\N
19955	5816	6	0	88325	\N
19960	62	3	0	88380	\N
19960	3344	4	0	88381	\N
19962	86	3	0	88390	\N
19962	3746	4	0	88391	\N
19967	4178	6	0	88419	\N
19967	4250	7	0	88420	\N
19970	4178	3	0	88445	\N
19970	4211	4	0	88446	\N
19973	235	7	0	88463	\N
19973	5822	8	0	88464	\N
19976	56	7	0	88467	\N
19976	4791	8	0	88468	\N
19982	4172	3	0	88392	\N
19982	4940	4	0	88523	\N
19984	75	4	0	87450	\N
19984	3959	5	0	88527	\N
19986	132	3	0	86409	\N
19986	1423	4	0	88536	\N
19992	908	9	0	88583	\N
19992	5827	10	0	88586	\N
19994	123	3	0	88594	\N
19994	2856	4	0	88595	\N
20003	14	5	0	88681	\N
20003	5835	6	0	88682	\N
20005	367	5	0	80394	\N
20005	5836	6	0	88695	\N
20008	852	5	0	87718	\N
20008	5839	6	0	88698	\N
20010	273	6	0	88262	\N
20010	5841	7	0	88733	\N
20013	73	3	0	88742	\N
20013	3040	4	0	88743	\N
20016	326	3	0	88746	\N
20016	3339	4	0	88747	\N
20021	113	4	0	88777	\N
20021	3677	5	0	88778	\N
20024	449	4	0	88828	\N
20024	5343	5	0	88829	\N
20027	51	5	0	84498	\N
20027	4392	6	0	88841	\N
20033	4172	3	0	88868	\N
20033	4275	4	0	88869	\N
20041	233	3	0	88898	\N
20041	3704	4	0	88899	\N
20042	117	3	0	88906	\N
20042	3653	4	0	88907	\N
20047	5846	0	0	88936	\N
20047	5847	0	0	88937	\N
20050	451	3	0	88918	\N
20050	3934	4	0	88946	\N
20054	4178	4	0	88693	\N
20054	4205	5	0	88766	\N
20059	488	3	0	86299	\N
20059	1103	4	0	89050	\N
20063	115	3	0	85609	\N
20063	3483	4	0	89117	\N
20070	4233	4	0	89169	\N
20070	4234	5	0	89170	\N
20072	4178	4	0	89179	\N
20072	4205	5	0	89180	\N
20076	300	3	0	89197	\N
20076	3747	4	0	89198	\N
20084	1470	8	0	89271	\N
20084	5857	9	0	89276	\N
20091	4172	19	0	89181	\N
20091	5864	20	0	89453	\N
19785	1426	9	0	87181	\N
19788	4178	4	0	87208	\N
19788	4205	5	0	87209	\N
19793	1153	2	0	87242	\N
19793	5769	3	0	87243	\N
19796	1153	3	0	87242	\N
19796	5770	4	0	87249	\N
19797	391	3	0	87256	\N
19797	3660	4	0	87257	\N
19802	4172	4	0	87288	\N
19802	4252	5	0	87289	\N
19803	192	10	0	87310	\N
19803	5775	11	0	87311	\N
19805	4172	3	0	87320	\N
19805	4275	4	0	87321	\N
19810	536	3	0	28163	\N
19810	5778	4	0	87342	\N
19818	4172	2	0	87393	\N
19818	4191	3	0	87394	\N
19823	40	5	0	87434	\N
19823	2714	6	0	87435	\N
19828	459	3	0	87460	\N
19828	5782	4	0	87461	\N
19831	1109	3	0	87466	\N
19831	2961	4	0	87467	\N
19832	16	3	0	87391	\N
19832	3634	4	0	87474	\N
19834	173	3	0	84923	\N
19834	3796	4	0	87483	\N
19837	20	3	0	87508	\N
19837	2844	4	0	87509	\N
19839	58	3	0	87516	\N
19839	3665	4	0	87517	\N
19845	51	3	0	84498	\N
19845	3533	4	0	84499	\N
19846	324	7	0	85431	\N
19846	5784	8	0	87552	\N
19848	4178	3	0	87224	\N
19848	4211	4	0	87225	\N
19854	324	6	0	87598	\N
19854	5241	7	0	87599	\N
19859	4172	5	0	87636	\N
19859	4634	6	0	87637	\N
19863	2856	3	0	87654	\N
19863	123	6	0	82877	\N
19868	852	20	0	87718	\N
19868	5796	21	0	87719	\N
19870	206	3	0	87727	\N
19870	4584	4	0	87728	\N
19874	170	4	0	87749	\N
19874	4680	5	0	87750	\N
19879	18	7	0	87784	\N
19879	1618	8	0	87785	\N
19885	86	2	0	87828	\N
19885	3321	3	0	87829	\N
19890	40	11	0	87879	\N
19890	5800	12	0	87880	\N
19893	40	4	0	87893	\N
19893	3381	5	0	87894	\N
19901	16	7	0	87897	\N
19901	4723	8	0	87929	\N
19904	431	3	0	87939	\N
19904	3933	4	0	87940	\N
19907	424	10	0	85194	\N
19907	5802	11	0	87963	\N
19909	290	4	0	87973	\N
19909	5450	5	0	87974	\N
19913	262	4	0	88000	\N
19913	5805	5	0	88001	\N
19915	86	3	0	87828	\N
19915	3746	4	0	87833	\N
19918	360	7	0	87595	\N
19918	5807	8	0	88046	\N
19921	189	15	0	88061	\N
19921	5809	16	0	88062	\N
19925	4178	3	0	87961	\N
19925	4211	4	0	88075	\N
19927	4172	4	0	87899	\N
19927	4219	5	0	87900	\N
19937	206	2	0	88126	\N
19937	2773	3	0	88127	\N
19939	40	3	0	88134	\N
19939	372	4	0	88135	\N
19943	18	3	0	88141	\N
19943	3621	4	0	88142	\N
19946	4172	3	0	88124	\N
19946	4275	4	0	88138	\N
19958	5817	22	0	88348	\N
19958	62	126	0	88364	\N
19958	5818	127	0	88365	\N
19961	71	3	0	88382	\N
19961	3770	4	0	88383	\N
19963	4172	3	0	88392	\N
19963	4275	4	0	88393	\N
19965	142	4	0	84794	\N
19965	3950	5	0	88404	\N
19968	16	7	0	88435	\N
19968	4723	8	0	88436	\N
19974	147	7	0	82028	\N
19974	5823	8	0	88465	\N
19977	64	0	0	88469	\N
19980	264	6	0	80941	\N
19980	5480	7	0	88503	\N
19983	94	3	0	83461	\N
19983	2128	4	0	88524	\N
19987	167	5	0	84998	\N
19987	2851	6	0	88547	\N
19989	75	5	0	88550	\N
19989	4484	6	0	88551	\N
19995	132	3	0	88596	\N
19995	3729	4	0	88597	\N
20001	75	5	0	88550	\N
20001	5833	6	0	88669	\N
20014	4172	3	0	88392	\N
20014	4275	4	0	88393	\N
20017	841	4	0	82347	\N
20017	3886	5	0	88756	\N
20019	4178	4	0	88693	\N
20019	4205	5	0	88766	\N
20022	173	10	0	88799	\N
20022	5842	11	0	88800	\N
20025	51	0	0	84498	\N
20028	51	0	0	84498	\N
20031	285	4	0	88850	\N
20031	3674	5	0	88851	\N
20034	2	3	0	88876	\N
20034	3548	4	0	88877	\N
20038	251	5	0	85186	\N
20038	5845	6	0	88889	\N
20043	40	4	0	88134	\N
20043	3381	5	0	88915	\N
20052	1885	14	0	88983	\N
20052	224	32	0	89018	\N
20052	5848	33	0	89019	\N
20055	6	28	0	88598	\N
20055	5849	29	0	89036	\N
20057	6	28	0	88598	\N
20057	5849	29	0	89036	\N
20060	2	14	0	88876	\N
20060	1060	15	0	89078	\N
20061	75	15	0	88550	\N
20061	5850	16	0	89108	\N
20064	4172	3	0	89118	\N
20064	4275	4	0	89119	\N
20073	4172	4	0	89181	\N
20073	4219	5	0	89182	\N
20077	16	3	0	89199	\N
20077	3634	4	0	89200	\N
20079	16	5	0	89219	\N
20079	4240	6	0	89220	\N
20085	115	8	0	85609	\N
20085	5858	9	0	89277	\N
20086	75	12	0	89302	\N
20086	5859	13	0	89303	\N
20089	145	13	0	89411	\N
19830	214	3	0	87464	\N
19830	4991	4	0	87465	\N
19833	1731	3	0	87481	\N
19833	5783	4	0	87482	\N
19843	51	3	0	84498	\N
19843	3533	4	0	84499	\N
19847	5785	25	0	87557	\N
19847	324	26	0	87558	\N
19849	2351	6	0	87577	\N
19849	5786	7	0	87578	\N
19852	360	6	0	87595	\N
19852	5788	7	0	87596	\N
19858	4172	4	0	87624	\N
19858	5456	5	0	87625	\N
19861	372	3	0	87651	\N
19861	40	6	0	87652	\N
19861	3034	7	0	87653	\N
19865	4178	4	0	87673	\N
19866	235	20	0	81617	\N
19866	5794	21	0	87716	\N
19876	189	4	0	87753	\N
19876	3992	5	0	87755	\N
19877	40	2	0	87760	\N
19877	282	3	0	87761	\N
19880	164	51	0	87795	\N
19880	5799	52	0	87796	\N
19883	132	2	0	86409	\N
19883	2756	3	0	87807	\N
19887	228	3	0	84905	\N
19887	3186	4	0	87726	\N
19888	149	3	0	87274	\N
19888	4189	4	0	87840	\N
19895	16	4	0	87897	\N
19895	3546	5	0	87898	\N
19898	3979	4	0	87911	\N
19898	92	5	0	87912	\N
19905	4178	10	0	87961	\N
19905	4665	11	0	87962	\N
19912	235	6	0	87990	\N
19912	5804	7	0	87991	\N
19914	56	4	0	87729	\N
19914	1978	5	0	88002	\N
19922	449	4	0	87615	\N
19922	5343	5	0	88063	\N
19924	167	1	0	84998	\N
19924	2503	2	0	88068	\N
19929	108	1	0	88091	\N
19929	3022	2	0	88094	\N
19931	202	5	0	85408	\N
19931	5374	6	0	88104	\N
19933	69	4	0	88114	\N
19933	4041	5	0	88115	\N
19935	528	2	0	88122	\N
19935	2765	3	0	88123	\N
19941	4172	3	0	88124	\N
19941	4275	4	0	88138	\N
19945	5812	7	0	88209	\N
19945	285	8	0	88210	\N
19951	793	3	0	86188	\N
19951	2644	4	0	88273	\N
19957	62	4	0	85057	\N
19957	4059	5	0	88347	\N
19959	528	3	0	88372	\N
19959	4262	4	0	88373	\N
19964	5819	10	0	88394	\N
19964	164	11	0	88395	\N
19969	192	3	0	88443	\N
19969	3790	4	0	88444	\N
19972	595	7	0	84980	\N
19972	5821	8	0	88462	\N
19975	4172	7	0	88392	\N
19975	4614	8	0	88466	\N
19979	4	9	0	85491	\N
19981	30	6	0	88516	\N
19981	2931	7	0	88517	\N
19990	14	3	0	88558	\N
19990	4272	4	0	88559	\N
19991	908	12	0	88583	\N
19991	5826	13	0	88584	\N
19993	4178	3	0	88534	\N
19993	4211	4	0	88593	\N
19996	6	3	0	88598	\N
19996	4823	4	0	88599	\N
19998	30	5	0	88611	\N
19998	5829	6	0	88612	\N
20000	5831	78	0	88651	\N
20000	453	113	0	88667	\N
20000	5832	114	0	88668	\N
20002	2	5	0	87338	\N
20002	5834	6	0	88680	\N
20004	4178	5	0	88693	\N
20004	5828	6	0	88694	\N
20007	852	4	0	87718	\N
20007	5838	5	0	88697	\N
20009	451	11	0	88719	\N
20009	5840	12	0	88720	\N
20012	908	3	0	88740	\N
20012	3591	4	0	88741	\N
20023	1470	9	0	81860	\N
20023	5139	10	0	88819	\N
20029	51	0	0	84498	\N
20036	123	3	0	88594	\N
20036	2856	4	0	88595	\N
20037	336	5	0	88887	\N
20037	5844	6	0	88888	\N
20040	16	3	0	88896	\N
20040	3634	4	0	88897	\N
20045	451	4	0	88918	\N
20045	3666	5	0	88919	\N
20049	79	3	0	87312	\N
20049	3652	4	0	88945	\N
20051	391	4	0	87526	\N
20051	3913	5	0	87527	\N
20056	6	3	0	89042	\N
20056	4823	4	0	89043	\N
20058	424	3	0	85194	\N
20058	3611	4	0	85195	\N
20062	391	3	0	89115	\N
20062	3660	4	0	89116	\N
20066	793	3	0	86188	\N
20066	2644	4	0	88273	\N
20068	793	2	0	86188	\N
20068	4363	3	0	89120	\N
20069	285	4	0	89167	\N
20069	3674	5	0	89168	\N
20071	40	4	0	88134	\N
20071	3381	5	0	88915	\N
20078	1021	3	0	89207	\N
20078	5852	4	0	89208	\N
20081	40	7	0	89237	\N
20081	5853	8	0	89238	\N
20083	1470	8	0	89271	\N
20088	67	13	0	80330	\N
20088	5861	14	0	89384	\N
20093	62	17	0	88380	\N
20093	5866	18	0	89488	\N
20099	69	12	0	89539	\N
20099	5871	13	0	89540	\N
20102	4178	11	0	89566	\N
20102	5874	12	0	89567	\N
20105	4172	9	0	89589	\N
20105	5876	10	0	89590	\N
20111	793	7	0	86188	\N
20111	5878	8	0	89626	\N
20117	324	7	0	87598	\N
20117	2981	8	0	89663	\N
20118	4178	7	0	89678	\N
20118	4396	8	0	89679	\N
20123	320	8	0	89721	\N
20083	1970	9	1	138658	\N
20083	5855	9	0	138659	\N
20083	2171	10	1	42387	\N
20083	5856	10	0	138660	\N
19865	5793	5	1	138655	\N
19979	5825	10	0	138657	\N
20053	3746	4	0	89027	\N
20065	793	2	0	86188	\N
20065	4363	3	0	89120	\N
20067	5851	79	0	89144	\N
20067	56	96	0	89157	\N
20067	3543	97	0	89158	\N
20074	18	4	0	88141	\N
20074	2302	5	0	89183	\N
20075	4178	3	0	89179	\N
20075	4211	4	0	89190	\N
20080	4178	7	0	89235	\N
20080	5210	8	0	89236	\N
20082	5854	6	0	89251	\N
20082	4178	8	0	89254	\N
20082	4460	9	0	89255	\N
20087	266	39	0	85750	\N
20087	5860	40	0	89358	\N
20090	71	4	0	89413	\N
20090	5863	5	0	89414	\N
20092	75	19	0	89302	\N
20092	5865	20	0	89454	\N
20098	159	2	0	89512	\N
20098	75	8	0	89513	\N
20098	5870	9	0	89514	\N
20101	2636	11	0	89564	\N
20101	5873	12	0	89565	\N
20104	4178	9	0	89566	\N
20104	5622	10	0	89588	\N
20108	4172	4	0	89589	\N
20108	4252	5	0	89601	\N
20110	12	2	0	84301	\N
20110	3028	3	0	89611	\N
20113	290	4	0	89640	\N
20113	5879	5	0	89641	\N
20116	324	5	0	85431	\N
20116	700	6	0	89662	\N
20120	212	7	0	80407	\N
20120	3312	8	0	89700	\N
20126	852	11	0	89764	\N
20126	5891	12	0	89765	\N
20130	365	7	0	89776	\N
20130	5893	8	1	89780	\N
20130	5892	8	0	89781	\N
20133	16	6	0	89796	\N
20133	5895	7	0	89797	\N
20135	4178	10	0	89819	\N
20135	5897	11	0	89820	\N
20137	4178	2	0	89819	\N
20137	4247	3	0	89826	\N
20140	40	3	0	89837	\N
20140	372	4	0	89838	\N
20141	94	3	0	83461	\N
20141	2864	4	0	85445	\N
20144	123	5	0	88594	\N
20144	5901	6	0	89863	\N
20148	125	3	0	89907	\N
20148	4170	4	0	89908	\N
20153	285	6	0	36806	\N
20153	3903	7	0	89946	\N
20156	2	3	0	89963	\N
20156	3548	4	0	89964	\N
20159	198	15	0	90010	\N
20159	2324	16	0	90011	\N
20164	69	13	0	90072	\N
20164	5912	14	0	90073	\N
20167	62	6	0	90141	\N
20167	4781	7	0	90142	\N
20172	58	2	0	90190	\N
20172	3228	3	0	90191	\N
20175	4172	5	0	90222	\N
20175	4634	6	0	90223	\N
20178	264	4	0	90256	\N
20178	3684	5	0	90257	\N
20180	121	3	0	90266	\N
20180	4471	4	0	90267	\N
20184	18	3	0	88141	\N
20184	3621	4	0	88142	\N
20187	4178	3	0	90162	\N
20187	4211	4	0	90440	\N
20193	56	5	0	88467	\N
20193	3551	6	0	90493	\N
20196	262	6	0	90510	\N
20196	2828	7	0	90511	\N
20198	113	4	0	90521	\N
20198	5924	5	0	90522	\N
20200	5885	3	0	90546	\N
20200	5926	4	0	90547	\N
20205	214	3	0	87464	\N
20205	3496	4	0	90565	\N
20207	4172	3	0	90600	\N
20207	4275	4	0	90601	\N
20210	326	3	0	88746	\N
20210	3339	4	0	88747	\N
20215	79	7	0	90070	\N
20215	5706	8	0	90655	\N
20218	4172	7	0	90662	\N
20218	4614	8	0	90663	\N
20223	273	10	0	90687	\N
20223	5932	11	0	90688	\N
20224	1470	3	0	90695	\N
20224	3838	4	0	90696	\N
20227	20	6	0	90710	\N
20227	5933	7	0	90711	\N
20229	202	4	0	90722	\N
20229	3673	5	0	90723	\N
20235	528	4	0	90756	\N
20235	5689	5	0	90757	\N
20238	64	3	0	90794	\N
20238	4217	4	0	90795	\N
20241	4172	4	0	90662	\N
20241	4252	5	0	90808	\N
20246	224	7	0	90875	\N
20246	5003	8	0	90876	\N
20247	4237	8	0	90893	\N
20247	4178	10	0	90896	\N
20247	4460	11	0	90897	\N
20249	2351	3	0	90907	\N
20249	2845	4	0	90908	\N
20253	4172	13	0	90959	\N
20253	5454	14	0	90960	\N
20255	42	3	0	79641	\N
20255	3645	4	0	85117	\N
20257	18	3	0	90970	\N
20257	3621	4	0	90971	\N
20258	365	7	0	90986	\N
20258	5248	8	0	90987	\N
20261	200	4	0	91008	\N
20261	4683	5	0	91009	\N
20270	391	5	0	91055	\N
20270	3558	6	0	91056	\N
20275	367	7	0	91092	\N
20275	4792	8	0	91093	\N
20280	4178	4	0	91076	\N
20280	4205	5	0	91130	\N
20284	298	3	0	91151	\N
20284	2	7	0	91158	\N
20284	3129	8	0	91159	\N
20290	300	7	0	89197	\N
20290	5054	8	0	91186	\N
20293	75	7	0	90224	\N
20293	2859	8	0	91191	\N
20299	79	3	0	91245	\N
20299	3652	4	0	91246	\N
20301	4172	3	0	91268	\N
20301	4275	4	0	91269	\N
20309	82	3	0	91324	\N
20309	4505	4	0	91325	\N
20312	316	3	0	91348	\N
20312	4249	4	0	91349	\N
20314	110	3	0	91359	\N
20314	2995	4	0	91360	\N
20317	6	4	0	91371	\N
20317	3487	5	0	91373	\N
20319	5954	11	0	91398	\N
20319	6	13	0	91400	\N
20319	2261	14	0	91401	\N
20322	4172	4	0	91446	\N
20089	5862	14	0	89412	\N
20095	38	17	0	87462	\N
20095	5868	18	0	89490	\N
20097	401	2	0	89502	\N
20097	71	8	0	89510	\N
20097	5869	9	0	89511	\N
20103	2636	9	0	89586	\N
20103	5875	10	0	89587	\N
20107	117	4	0	89599	\N
20107	4169	5	0	89600	\N
20112	132	2	0	88596	\N
20112	2756	3	0	89631	\N
20115	5881	0	0	89658	\N
20115	5882	0	0	89659	\N
20119	4178	3	0	89686	\N
20119	4211	4	0	89687	\N
20122	4178	8	0	89719	\N
20122	5883	9	0	89720	\N
20125	5887	8	0	89752	\N
20132	108	6	0	89794	\N
20132	5894	7	0	89795	\N
20134	33	10	0	89817	\N
20134	5896	11	0	89818	\N
20139	4178	3	0	89835	\N
20139	4211	4	0	89836	\N
20143	4178	6	0	89861	\N
20143	5900	7	0	89862	\N
20147	5904	68	0	89881	\N
20147	242	99	0	89899	\N
20147	1135	100	0	89900	\N
20150	170	3	0	87749	\N
20150	4148	4	0	89915	\N
20152	4178	4	0	89932	\N
20152	4205	5	0	89933	\N
20155	54	3	0	89961	\N
20155	3041	4	0	89962	\N
20158	79	6	0	87312	\N
20158	4253	7	0	89979	\N
20163	79	13	0	90070	\N
20163	5911	14	0	90071	\N
20166	40	6	0	89837	\N
20166	4718	7	0	90140	\N
20169	4178	9	0	90162	\N
20169	5897	10	0	90163	\N
20171	192	4	0	88443	\N
20171	3895	5	0	90185	\N
20174	908	5	0	90210	\N
20174	5915	6	0	90211	\N
20177	528	10	0	90246	\N
20177	5604	11	0	90247	\N
20189	132	3	0	90443	\N
20189	3729	4	0	90444	\N
20192	167	4	0	84998	\N
20192	4048	5	0	90482	\N
20195	198	6	0	90508	\N
20195	5923	7	0	90509	\N
20197	2	4	0	89963	\N
20197	2830	5	0	90520	\N
20202	4172	3	0	90554	\N
20202	4275	4	0	90555	\N
20204	528	3	0	90563	\N
20204	4262	4	0	90564	\N
20209	235	3	0	88463	\N
20209	3343	4	0	90608	\N
20212	528	6	0	90613	\N
20212	4824	7	0	90614	\N
20214	4178	3	0	90639	\N
20214	4211	4	0	90640	\N
20219	1109	7	0	87466	\N
20219	4145	8	0	90664	\N
20222	4172	10	0	90662	\N
20222	4663	11	0	90686	\N
20226	42	3	0	79641	\N
20226	3645	4	0	85117	\N
20234	156	4	0	86767	\N
20234	5935	5	0	90755	\N
20237	90	3	0	90786	\N
20237	4074	4	0	90787	\N
20240	4178	4	0	90806	\N
20240	4331	5	0	90807	\N
20242	4172	7	0	90662	\N
20242	5880	8	0	90823	\N
20245	1952	6	0	90859	\N
20245	5939	7	0	90860	\N
20252	56	7	0	90931	\N
20252	4791	8	0	90932	\N
20260	62	3	0	91002	\N
20260	3344	4	0	91003	\N
20265	117	7	0	89599	\N
20265	5276	8	0	91026	\N
20279	2	4	0	91128	\N
20279	3510	5	0	91129	\N
20289	233	7	0	88898	\N
20289	5948	8	0	91185	\N
20292	214	7	0	87464	\N
20292	5951	8	0	91190	\N
20295	4178	3	0	91200	\N
20295	4211	4	0	91201	\N
20298	4178	3	0	91243	\N
20298	4211	4	0	91244	\N
20306	40	7	0	89837	\N
20306	4718	8	0	90140	\N
20311	4178	3	0	91243	\N
20311	4211	4	0	91244	\N
20316	6	2	0	91371	\N
20316	1101	3	0	91372	\N
20321	42	6	0	91436	\N
20321	1090	7	0	91437	\N
20325	56	4	0	91450	\N
20325	3127	5	0	91451	\N
20330	4172	4	0	91497	\N
20330	4219	5	0	91498	\N
20336	102	6	0	87458	\N
20336	5086	7	0	91543	\N
20338	841	6	0	82347	\N
20338	5958	7	0	91566	\N
20341	266	38	0	91580	\N
20341	5959	39	0	91581	\N
20343	16	5	0	91594	\N
20343	4240	6	0	91595	\N
20346	4172	3	0	91617	\N
20346	4275	4	0	91618	\N
20355	4201	1	0	91668	\N
20355	4172	4	0	91673	\N
20355	5963	6	0	91676	\N
20358	46	6	0	110	\N
20358	5965	7	0	91699	\N
20360	132	3	0	91727	\N
20360	3729	4	0	91728	\N
20363	435	6	0	91752	\N
20363	5969	7	0	91753	\N
20365	4172	3	0	91766	\N
20365	4275	4	0	91767	\N
20368	2	6	0	91128	\N
20368	4825	7	0	91159	\N
20371	367	17	0	91826	\N
20371	4083	18	0	91827	\N
20387	186	3	0	91939	\N
20387	4294	4	0	91940	\N
20396	597	3	0	78543	\N
20396	3656	4	0	83403	\N
20400	4178	3	0	91850	\N
20400	4211	4	0	91851	\N
20409	4787	6	0	92129	\N
20409	5982	7	0	92134	\N
20413	183	16	0	1195	\N
20413	5984	17	0	92171	\N
20420	1636	6	0	85856	\N
20420	5988	7	0	92206	\N
20422	4178	3	0	92187	\N
20422	4211	4	0	92214	\N
20355	5961	5	0	138665	\N
20355	5962	5	1	138666	\N
20125	5888	9	1	138662	\N
20125	5890	10	1	138664	\N
20094	62	17	0	88380	\N
20094	5867	18	0	89489	\N
20096	1937	2	0	89495	\N
20096	320	4	0	89498	\N
20096	3058	5	0	89499	\N
20100	528	12	0	89541	\N
20100	5872	13	0	89542	\N
20106	123	9	0	88594	\N
20106	5877	10	0	89591	\N
20109	75	2	0	89302	\N
20109	284	3	0	89606	\N
20114	4172	7	0	89656	\N
20114	5880	8	0	89657	\N
20121	75	7	0	89701	\N
20121	3439	8	0	89702	\N
20124	5886	7	0	89736	\N
20127	852	11	0	89764	\N
20127	5891	12	0	89765	\N
20129	793	7	0	89778	\N
20129	4590	8	0	89779	\N
20138	224	3	0	89833	\N
20138	3603	4	0	89834	\N
20149	411	3	0	85988	\N
20149	3596	4	0	85989	\N
20157	51	6	0	89977	\N
20157	5906	7	0	89978	\N
20161	4172	9	0	89656	\N
20161	5908	10	0	90032	\N
20168	2351	9	0	90160	\N
20168	5914	10	0	90161	\N
20173	4172	3	0	90198	\N
20173	4275	4	0	90199	\N
20181	121	99	0	90266	\N
20181	5916	100	0	90317	\N
20183	4172	10	0	90350	\N
20183	4663	11	0	90351	\N
20186	285	10	0	90432	\N
20186	5921	11	0	90433	\N
20191	54	9	0	90472	\N
20191	5922	10	0	90473	\N
20194	230	6	0	90506	\N
20194	4549	7	0	90507	\N
20199	365	8	0	89776	\N
20199	5925	9	0	90539	\N
20208	40	3	0	89837	\N
20208	372	4	0	89838	\N
20217	316	5	0	90660	\N
20217	5929	6	0	90661	\N
20221	164	10	0	90684	\N
20221	5931	11	0	90685	\N
20231	156	3	0	86767	\N
20231	4594	4	0	86768	\N
20233	173	4	0	90753	\N
20233	3614	5	0	90754	\N
20236	5936	37	0	90767	\N
20236	528	54	0	90778	\N
20236	5937	55	0	90779	\N
20239	56	4	0	90804	\N
20239	3556	5	0	90805	\N
20244	5885	8	0	90546	\N
20244	5938	9	0	90846	\N
20251	210	7	0	90929	\N
20251	5940	8	0	90930	\N
20256	42	2	0	79641	\N
20256	3310	3	0	90969	\N
20263	62	4	0	91002	\N
20263	4059	5	0	91011	\N
20264	285	7	0	91024	\N
20264	5812	8	0	91025	\N
20267	4172	3	0	90959	\N
20267	4275	4	0	91034	\N
20269	64	3	0	91043	\N
20269	4217	4	0	91044	\N
20272	88	5	0	91059	\N
20272	5942	6	0	91061	\N
20274	235	7	0	88463	\N
20274	5822	8	0	88464	\N
20277	4172	6	0	90959	\N
20277	4197	7	0	91107	\N
20278	5943	73	0	91114	\N
20278	288	126	0	91118	\N
20278	5944	127	0	91119	\N
20283	1316	6	0	91143	\N
20283	5945	7	0	91144	\N
20286	609	3	0	91163	\N
20286	18	7	0	91164	\N
20286	5946	8	0	91165	\N
20288	4088	7	0	77408	\N
20288	5947	8	0	91184	\N
20291	5949	7	0	91187	\N
20291	5950	7	0	91188	\N
20291	5948	8	0	91189	\N
20294	5885	3	0	91198	\N
20294	5926	4	0	91199	\N
20297	4172	7	0	91235	\N
20297	4614	8	0	91236	\N
20300	18	7	0	90970	\N
20300	1618	8	0	91261	\N
20303	18	3	0	91276	\N
20303	3621	4	0	91277	\N
20305	67	3	0	91294	\N
20305	3749	4	0	91295	\N
20308	18	3	0	91276	\N
20308	3621	4	0	91277	\N
20315	4178	4	0	91369	\N
20315	4205	5	0	91370	\N
20318	6	8	0	91388	\N
20318	5953	9	0	91389	\N
20320	225	1	0	91404	\N
20320	224	13	0	91422	\N
20320	3150	14	0	91423	\N
20324	266	4	0	91448	\N
20324	4100	5	0	91449	\N
20328	92	5	0	87198	\N
20328	5955	6	0	91465	\N
20332	62	3	0	91507	\N
20332	3344	4	0	91508	\N
20335	4172	6	0	91497	\N
20335	4197	7	0	91542	\N
20342	391	5	0	91592	\N
20342	5462	6	0	91593	\N
20345	1021	3	0	91615	\N
20345	4551	4	0	91616	\N
20348	4	3	0	91644	\N
20348	3837	4	0	91645	\N
20351	40	3	0	91568	\N
20351	372	4	0	91656	\N
20357	391	3	0	91592	\N
20357	3660	4	0	91686	\N
20362	164	6	0	90684	\N
20362	5968	7	0	91751	\N
20367	14	3	0	91775	\N
20367	1786	4	0	91776	\N
20370	4178	17	0	91824	\N
20370	4218	18	0	91825	\N
20372	40	4	0	91568	\N
20372	2796	5	0	91835	\N
20375	1636	3	0	85856	\N
20375	5514	4	0	85857	\N
20377	44	3	0	82866	\N
20377	3631	4	0	85863	\N
20379	132	6	0	91894	\N
20379	4690	7	0	91895	\N
20382	56	3	0	91450	\N
20382	4109	4	0	91908	\N
20384	391	3	0	91921	\N
20384	3660	4	0	91922	\N
20386	167	3	0	91937	\N
20386	4028	4	0	91938	\N
20389	2636	9	0	89586	\N
20389	5079	10	0	91959	\N
20395	147	3	0	92000	\N
20395	3657	4	0	92001	\N
20399	5976	89	1	92021	\N
20399	5975	89	0	92022	\N
20399	973	90	0	92023	\N
20123	5884	9	0	89722	\N
20128	365	7	0	89776	\N
20128	5248	8	0	89777	\N
20131	793	7	0	89778	\N
20131	4590	8	0	89779	\N
20136	16	10	0	89796	\N
20136	5898	11	0	89821	\N
20142	4178	5	0	89835	\N
20142	5899	6	0	89849	\N
20145	4172	5	0	89656	\N
20145	5902	6	0	89864	\N
20146	242	5	0	82364	\N
20146	5903	6	0	89865	\N
20151	132	3	0	89922	\N
20151	3729	4	0	89923	\N
20154	1656	3	0	89953	\N
20154	5905	4	0	89954	\N
20160	273	9	0	90030	\N
20160	5907	10	0	90031	\N
20162	5909	109	0	90040	\N
20162	56	125	0	90041	\N
20162	5910	126	1	90042	\N
20162	5238	126	0	90043	\N
20162	1075	127	0	90044	\N
20165	453	26	0	90126	\N
20165	5913	27	0	90127	\N
20170	4172	6	0	89656	\N
20170	4197	7	0	90176	\N
20176	75	5	0	90224	\N
20176	4034	6	0	90225	\N
20179	528	4	0	90258	\N
20179	5689	5	0	90259	\N
20182	56	43	0	90328	\N
20182	5917	44	0	90329	\N
20185	5918	35	0	90379	\N
20185	35	125	0	90408	\N
20185	5920	126	1	90409	\N
20185	5919	126	0	90410	\N
20185	1075	127	0	90411	\N
20188	192	3	0	90441	\N
20188	3790	4	0	90442	\N
20190	4178	4	0	90162	\N
20190	4205	5	0	90453	\N
20201	391	3	0	89115	\N
20201	3660	4	0	89116	\N
20203	79	3	0	90070	\N
20203	3652	4	0	90562	\N
20206	528	75	0	90563	\N
20206	5927	76	0	90593	\N
20211	528	3	0	90609	\N
20211	4262	4	0	90610	\N
20213	4172	8	0	90631	\N
20213	5928	9	0	90632	\N
20216	4178	7	0	90656	\N
20216	4396	8	0	90657	\N
20220	200	10	0	90682	\N
20220	5930	11	0	90683	\N
20225	4178	3	0	90656	\N
20225	4211	4	0	90697	\N
20228	4178	6	0	90712	\N
20228	4250	7	0	90713	\N
20230	23	3	0	90730	\N
20230	3497	4	0	90731	\N
20232	115	6	0	85609	\N
20232	5934	7	0	90744	\N
20243	4178	3	0	90806	\N
20243	4211	4	0	90830	\N
20248	4872	8	0	90898	\N
20248	228	10	0	90899	\N
20248	1432	11	0	90900	\N
20250	79	3	0	90070	\N
20250	3652	4	0	90562	\N
20254	100	13	0	87579	\N
20254	5941	14	0	90961	\N
20259	4178	3	0	90994	\N
20259	4211	4	0	90995	\N
20262	40	4	0	89837	\N
20262	3381	5	0	91010	\N
20266	113	3	0	90521	\N
20266	3620	4	0	91033	\N
20268	365	3	0	91041	\N
20268	3839	4	0	91042	\N
20271	88	3	0	91059	\N
20271	3655	4	0	91060	\N
20273	4178	7	0	91076	\N
20273	4396	8	0	91077	\N
20276	73	6	0	179	\N
20276	4257	7	0	91106	\N
20281	244	1	0	81737	\N
20281	2960	2	0	91132	\N
20282	424	6	0	91141	\N
20282	3712	7	0	91142	\N
20285	4441	3	0	91160	\N
20285	4178	7	0	91161	\N
20285	4941	8	0	91162	\N
20287	300	5	0	89197	\N
20287	5389	6	0	91176	\N
20296	4172	9	0	90959	\N
20296	4977	10	0	91220	\N
20302	488	3	0	86299	\N
20302	1103	4	0	89050	\N
20304	12	4	0	91286	\N
20304	4043	5	0	91287	\N
20307	64	3	0	91316	\N
20307	4217	4	0	91317	\N
20310	56	7	0	91340	\N
20310	4791	8	0	91341	\N
20313	5611	2	0	91351	\N
20313	5952	3	0	91352	\N
20323	4178	4	0	91369	\N
20323	4205	5	0	91370	\N
20327	4172	5	0	91446	\N
20327	4415	6	0	91464	\N
20329	5956	90	0	91467	\N
20329	320	126	0	91486	\N
20329	1075	127	1	91487	\N
20329	5957	127	0	91488	\N
20331	16	4	0	91499	\N
20331	3546	5	0	91500	\N
20334	852	7	0	89764	\N
20334	3799	8	0	91529	\N
20337	360	4	0	91552	\N
20337	3513	5	0	91553	\N
20340	40	6	0	91568	\N
20340	4717	7	0	91569	\N
20344	4178	6	0	91369	\N
20344	4250	7	0	91608	\N
20347	173	9	0	90753	\N
20347	5960	10	0	91637	\N
20350	4178	3	0	91654	\N
20350	4211	4	0	91655	\N
20353	75	3	0	90224	\N
20353	3855	4	0	91659	\N
20354	62	2	0	91664	\N
20354	2191	3	0	91665	\N
20359	5966	46	0	91724	\N
20359	132	47	0	91725	\N
20364	16	3	0	91657	\N
20364	3634	4	0	91658	\N
20369	1021	16	0	91615	\N
20369	5970	17	0	91821	\N
20374	4178	3	0	91850	\N
20374	4211	4	0	91851	\N
20376	27	3	0	85611	\N
20376	4636	4	0	91852	\N
20381	4178	3	0	91850	\N
20381	4211	4	0	91851	\N
20383	56	2	0	91913	\N
20383	2795	3	0	91914	\N
20388	1109	0	0	87466	\N
20392	125	9	0	91988	\N
20392	5974	10	0	91989	\N
20394	424	1	0	91998	\N
20394	425	2	0	91999	\N
20397	424	3	0	91998	\N
20397	3611	4	0	92002	\N
20405	82	12	0	92095	\N
20322	4219	5	0	91447	\N
20326	40	4	0	91452	\N
20326	3381	5	0	91453	\N
20333	123	3	0	88594	\N
20333	2856	4	0	88595	\N
20339	266	6	0	91448	\N
20339	1912	7	0	91567	\N
20349	4172	3	0	91652	\N
20349	4275	4	0	91653	\N
20352	16	3	0	91657	\N
20352	3634	4	0	91658	\N
20356	153	1	0	91677	\N
20356	145	4	0	91678	\N
20356	5964	5	0	91679	\N
20361	71	4	0	91737	\N
20361	5967	5	0	91738	\N
20366	77	3	0	91768	\N
20366	1877	4	0	91769	\N
20373	4172	3	0	91842	\N
20373	4275	4	0	91843	\N
20378	132	58	0	91891	\N
20378	5971	59	0	91892	\N
20380	5885	3	0	91198	\N
20380	5926	4	0	91199	\N
20385	167	28	0	91929	\N
20385	5972	29	0	91930	\N
20390	54	3	0	91966	\N
20390	3041	4	0	91967	\N
20391	2351	9	0	91986	\N
20391	5973	10	0	91987	\N
20393	595	3	0	91996	\N
20393	3654	4	0	91997	\N
20398	260	2	0	92007	\N
20398	3184	3	0	92008	\N
20401	125	3	0	91988	\N
20401	4170	4	0	92051	\N
20403	108	3	0	92062	\N
20403	4171	4	0	92068	\N
20404	113	12	0	92093	\N
20404	5979	13	0	92094	\N
20406	391	3	0	92103	\N
20406	3660	4	0	92104	\N
20410	33	6	0	89817	\N
20410	5983	7	0	92135	\N
20416	4178	5	0	92187	\N
20416	4202	6	0	92188	\N
20421	44	6	0	82866	\N
20421	5989	7	0	92207	\N
20423	23	3	0	92221	\N
20423	3497	4	0	92222	\N
20426	1381	2	0	92231	\N
20426	391	4	0	92232	\N
20426	1420	5	0	92233	\N
20432	96	6	0	92272	\N
20432	3698	7	0	92273	\N
20437	927	11	0	8544	\N
20437	5995	12	0	92301	\N
20443	734	2	0	92325	\N
20443	5996	3	0	92326	\N
20448	391	3	0	92347	\N
20448	3660	4	0	92233	\N
20452	5885	6	0	92370	\N
20452	5997	7	0	92371	\N
20456	365	3	0	91041	\N
20456	3839	4	0	91042	\N
20459	90	3	0	92392	\N
20459	4074	4	0	92393	\N
20465	42	3	0	92416	\N
20465	3645	4	0	92420	\N
20470	156	3	0	92496	\N
20470	4594	4	0	92497	\N
20473	2782	4	0	92515	\N
20473	3872	5	0	92516	\N
20478	6000	66	0	92539	\N
20478	132	126	0	92566	\N
20478	6001	127	0	92567	\N
20480	365	0	0	92622	\N
20481	149	2	0	92627	\N
20481	1379	3	0	92628	\N
20484	402	5	0	92641	\N
20484	4487	6	0	92642	\N
20489	38	4	0	80	\N
20489	6006	5	0	92665	\N
20492	6	9	0	92348	\N
20492	6007	10	0	92694	\N
20499	595	4	0	91996	\N
20499	3878	5	0	92730	\N
20504	266	0	0	92746	\N
20506	266	0	0	92746	\N
20509	453	2	0	92756	\N
20509	3133	3	0	92768	\N
20513	79	3	0	92388	\N
20513	3652	4	0	92389	\N
20517	6012	11	0	92836	\N
20517	3625	23	0	92837	\N
20517	4359	24	0	92838	\N
20518	367	4	0	91826	\N
20518	5472	5	0	92847	\N
20522	322	4	0	92866	\N
20522	5447	5	0	92867	\N
20528	210	4	0	90929	\N
20528	4413	5	0	92931	\N
20533	151	5	0	92953	\N
20533	6018	6	0	92954	\N
20538	285	6	0	91024	\N
20538	3903	7	0	92375	\N
20539	4172	3	0	92983	\N
20539	4275	4	0	92984	\N
20546	135	3	0	93044	\N
20546	3630	4	0	93045	\N
20547	137	3	0	93046	\N
20547	3633	4	0	93047	\N
20551	77	7	0	91768	\N
20551	6022	8	0	93063	\N
20552	1470	3	0	93070	\N
20552	3838	4	0	93071	\N
20556	285	4	0	93085	\N
20556	3674	5	0	93086	\N
20562	1636	2	0	93149	\N
20562	6032	3	0	93150	\N
20567	262	8	0	93175	\N
20567	6036	9	0	93176	\N
20571	121	6	0	93181	\N
20571	6038	7	0	93182	\N
20576	117	4	0	92955	\N
20576	6043	5	0	93227	\N
20580	102	3	0	87458	\N
20580	3597	4	0	93252	\N
20586	2782	10	0	93296	\N
20586	6051	11	0	93297	\N
20590	224	3	0	93306	\N
20590	3603	4	0	93311	\N
20591	4172	3	0	93318	\N
20591	4275	4	0	93319	\N
20595	1722	6	0	93337	\N
20595	6054	7	0	93338	\N
20596	6055	85	0	93358	\N
20596	149	126	0	93375	\N
20596	1664	127	0	93376	\N
20601	92	3	0	93406	\N
20601	4410	4	0	93407	\N
20602	224	2	0	93306	\N
20602	3150	3	0	93412	\N
20606	224	2	0	93306	\N
20606	3150	3	0	93412	\N
20613	40	3	0	92940	\N
20613	372	4	0	92941	\N
20620	113	23	0	92093	\N
20620	6060	24	0	93523	\N
20625	132	7	0	93579	\N
20625	6064	8	0	93580	\N
20626	110	6	0	93592	\N
20626	4135	7	0	93593	\N
20627	5885	5	0	92370	\N
20627	6065	6	0	93604	\N
20628	27	12	0	93629	\N
20628	6066	13	0	93630	\N
20399	320	126	0	92043	\N
20399	5977	127	0	92044	\N
20402	108	31	0	92062	\N
20402	5978	32	0	92063	\N
20408	4787	5	0	92129	\N
20408	5981	6	0	92130	\N
20412	449	6	0	92148	\N
20412	4055	7	0	92149	\N
20415	38	10	0	80	\N
20415	5986	11	0	92176	\N
20418	18	5	0	92190	\N
20418	4010	6	0	92191	\N
20424	3368	2	0	92227	\N
20424	1470	4	0	92230	\N
20424	5990	5	0	90696	\N
20428	2872	2	0	92237	\N
20428	852	4	0	92238	\N
20428	2945	5	0	92239	\N
20435	927	10	0	8544	\N
20435	5994	11	0	92295	\N
20440	113	3	0	92093	\N
20440	3620	4	0	92311	\N
20445	88	2	0	91059	\N
20445	2799	3	0	92329	\N
20446	4178	4	0	92338	\N
20446	4205	5	0	92339	\N
20450	164	3	0	92350	\N
20450	3385	4	0	92351	\N
20454	200	6	0	91008	\N
20454	4701	7	0	92374	\N
20458	40	3	0	92390	\N
20458	372	4	0	92391	\N
20462	4178	3	0	92409	\N
20462	4211	4	0	92410	\N
20464	42	2	0	92416	\N
20464	3310	3	0	92417	\N
20467	5999	100	0	92460	\N
20467	100	126	0	92477	\N
20467	4826	127	0	92478	\N
20469	56	4	0	92136	\N
20469	3127	5	0	92489	\N
20471	145	3	0	92504	\N
20471	4908	4	0	91679	\N
20477	132	4	0	92533	\N
20477	3293	5	0	92534	\N
20485	322	5	0	92643	\N
20485	6003	6	0	92644	\N
20490	170	3	0	92672	\N
20490	4148	4	0	92673	\N
20493	224	4	0	92703	\N
20493	3806	5	0	92704	\N
20496	170	2	0	92672	\N
20496	1380	3	0	92718	\N
20501	597	4	0	92732	\N
20501	3733	5	0	92733	\N
20502	424	3	0	91998	\N
20502	3611	4	0	92002	\N
20507	453	4	0	92756	\N
20507	4108	5	0	92757	\N
20511	2351	2	0	92775	\N
20511	4711	3	0	92777	\N
20519	110	6	0	92854	\N
20519	3917	7	0	92855	\N
20523	528	4	0	90756	\N
20523	5689	5	0	90757	\N
20529	4178	4	0	92409	\N
20529	4429	5	0	92932	\N
20530	4172	3	0	92513	\N
20530	4275	4	0	92939	\N
20534	117	5	0	92955	\N
20534	6019	6	0	92956	\N
20540	210	5	0	90929	\N
20540	4413	6	0	92931	\N
20541	4233	2	0	92999	\N
20541	5577	3	0	93000	\N
20548	14	0	0	93048	\N
20553	181	3	0	93072	\N
20553	4184	4	0	93073	\N
20557	285	3	0	93085	\N
20557	4496	4	0	93088	\N
20558	167	14	0	93117	\N
20558	6023	15	0	93118	\N
20563	44	3	0	93151	\N
20563	3631	4	0	93152	\N
20564	6033	0	0	93153	\N
20564	6034	0	0	93154	\N
20568	145	8	0	93177	\N
20568	4934	9	0	93178	\N
20572	121	8	0	93181	\N
20572	6039	9	0	93183	\N
20578	6045	4	0	93237	\N
20583	110	7	0	92854	\N
20583	4758	8	0	93273	\N
20584	2	10	0	93293	\N
20584	6049	11	0	93294	\N
20588	4178	4	0	93139	\N
20588	4331	5	0	93308	\N
20593	92	6	0	87198	\N
20593	6052	7	0	93334	\N
20598	100	3	0	93387	\N
20598	3836	4	0	93388	\N
20599	4172	4	0	93318	\N
20599	4219	5	0	93397	\N
20604	16	2	0	93414	\N
20604	388	3	0	93415	\N
20609	324	6	0	92242	\N
20609	5241	7	0	93435	\N
20610	4178	10	0	93456	\N
20610	4665	11	0	93457	\N
20615	40	3	0	92940	\N
20615	372	4	0	92941	\N
20616	300	5	0	93485	\N
20616	6057	6	0	93486	\N
20617	71	5	0	93496	\N
20617	4288	6	0	93497	\N
20623	6063	27	0	93549	\N
20623	181	80	0	93577	\N
20623	3833	81	0	93578	\N
20634	4172	3	0	93731	\N
20634	4275	4	0	93732	\N
20640	1021	3	0	91615	\N
20640	4551	4	0	91616	\N
20641	16	6	0	93779	\N
20641	3369	7	0	93780	\N
20642	4	3	0	93787	\N
20642	3837	4	0	93788	\N
20646	6072	38	0	93801	\N
20646	326	123	0	93809	\N
20646	4912	124	1	93810	\N
20646	2132	124	0	93811	\N
20646	3108	125	1	93812	\N
20646	3013	125	0	93813	\N
20646	2583	126	1	93814	\N
20646	6073	126	0	93815	\N
20646	6074	127	0	93816	\N
20647	6	0	0	92348	\N
20651	6075	74	0	93839	\N
20651	852	126	0	93840	\N
20651	6076	127	0	93841	\N
20656	4172	4	0	93795	\N
20656	4219	5	0	93866	\N
20661	4088	3	0	77408	\N
20661	4506	4	0	78922	\N
20667	3625	13	0	93915	\N
20667	6079	14	0	93916	\N
20668	212	3	0	93923	\N
20668	3639	4	0	93924	\N
20673	4178	3	0	93869	\N
20673	4211	4	0	93946	\N
20674	360	9	0	93965	\N
20674	6080	10	0	93966	\N
20679	4678	3	0	93981	\N
20679	4679	4	0	93982	\N
20683	6083	73	0	94014	\N
20683	181	126	0	94044	\N
20683	3833	127	0	94045	\N
20405	5980	13	0	92096	\N
20407	79	6	0	92117	\N
20407	4253	7	0	92118	\N
20411	56	6	0	92136	\N
20411	3398	7	0	92137	\N
20414	2	10	0	92174	\N
20414	5985	11	0	92175	\N
20417	125	5	0	91988	\N
20417	5987	6	0	92189	\N
20419	4172	6	0	92204	\N
20419	4197	7	0	92205	\N
20430	324	8	0	92242	\N
20430	5427	9	0	92258	\N
20433	79	6	0	92274	\N
20433	5992	7	0	92275	\N
20439	4178	3	0	92309	\N
20439	4211	4	0	92310	\N
20444	2	2	0	92327	\N
20444	2789	3	0	92328	\N
20449	6	3	0	92348	\N
20449	4823	4	0	92349	\N
20453	4178	6	0	92372	\N
20453	4250	7	0	92373	\N
20457	79	3	0	92388	\N
20457	3652	4	0	92389	\N
20460	90	2	0	92392	\N
20460	3442	3	0	92394	\N
20461	765	3	0	92401	\N
20461	5998	4	0	92402	\N
20466	16	5	0	92429	\N
20466	4240	6	0	92430	\N
20468	4172	4	0	92487	\N
20468	4219	5	0	92488	\N
20475	186	2	0	92519	\N
20475	1850	3	0	92523	\N
20476	173	4	0	92531	\N
20476	3857	5	0	92532	\N
20482	88	2	0	91059	\N
20482	2799	3	0	92329	\N
20487	38	6	0	80	\N
20487	6005	7	0	92662	\N
20495	20	2	0	90710	\N
20495	369	3	0	92717	\N
20500	147	4	0	92000	\N
20500	3877	5	0	92731	\N
20505	88	3	0	91059	\N
20505	3655	4	0	91060	\N
20514	251	3	0	85186	\N
20514	3514	4	0	85435	\N
20515	6010	11	0	92808	\N
20515	119	23	0	92831	\N
20515	1879	24	0	92832	\N
20520	264	6	0	90256	\N
20520	5480	7	0	92856	\N
20524	110	4	0	92854	\N
20524	4134	5	0	92868	\N
20525	35	13	0	92312	\N
20525	6014	14	0	92895	\N
20531	40	3	0	92940	\N
20531	372	4	0	92941	\N
20535	56	5	0	92136	\N
20535	3930	6	0	92957	\N
20536	320	21	0	92962	\N
20536	6020	22	0	92963	\N
20542	1109	4	0	93009	\N
20542	3816	5	0	93010	\N
20543	1470	9	0	90695	\N
20543	6021	10	0	93028	\N
20544	200	3	0	91008	\N
20544	3338	4	0	93035	\N
20549	38	0	0	80	\N
20554	60	3	0	93074	\N
20554	3585	4	0	93075	\N
20559	6024	14	0	93121	\N
20559	167	62	0	93132	\N
20559	6026	63	1	93133	\N
20559	6025	63	0	93134	\N
20559	6028	64	1	93135	\N
20559	6027	64	0	93136	\N
20559	6030	65	1	93137	\N
20559	6029	65	0	93138	\N
20565	4172	8	0	93171	\N
20565	4500	9	0	93172	\N
20569	402	8	0	92641	\N
20569	6037	9	0	93179	\N
20573	6040	89	0	93199	\N
20573	402	99	0	93207	\N
20573	6041	100	0	93208	\N
20577	230	3	0	93234	\N
20577	4181	4	0	93235	\N
20581	132	3	0	93253	\N
20581	3729	4	0	93254	\N
20582	110	8	0	92854	\N
20582	6048	9	0	93271	\N
20587	224	4	0	93306	\N
20587	3281	5	0	93307	\N
20592	27	3	0	93320	\N
20592	4636	4	0	93321	\N
20597	149	2	0	93379	\N
20597	1379	3	0	93380	\N
20603	145	2	0	93177	\N
20603	1108	3	0	93413	\N
20607	90	2	0	92392	\N
20607	3442	3	0	92394	\N
20608	324	23	0	93421	\N
20608	690	24	0	93422	\N
20614	4172	3	0	93474	\N
20614	4275	4	0	93475	\N
20621	151	5	0	92953	\N
20621	6061	6	0	93533	\N
20622	181	7	0	93072	\N
20622	6062	8	0	93547	\N
20633	210	11	0	93723	\N
20633	6071	12	0	93724	\N
20638	241	4	0	93751	\N
20638	4582	5	0	93752	\N
20639	4172	3	0	93759	\N
20639	4275	4	0	93760	\N
20645	1109	3	0	93799	\N
20645	3495	4	0	93800	\N
20650	6	0	0	93825	\N
20655	5885	3	0	93856	\N
20655	5926	4	0	93857	\N
20659	322	4	0	93458	\N
20659	5447	5	0	93871	\N
20660	233	3	0	88898	\N
20660	3704	4	0	88899	\N
20664	40	2	0	92940	\N
20664	282	3	0	93884	\N
20666	300	13	0	93913	\N
20666	6078	14	0	93914	\N
20671	107	1	0	93936	\N
20671	94	4	0	93937	\N
20671	2043	5	0	85445	\N
20672	459	3	0	93944	\N
20672	3178	4	0	93945	\N
20677	4	9	0	93971	\N
20677	5824	10	0	93972	\N
20678	908	3	0	93979	\N
20678	3591	4	0	93980	\N
20682	322	3	0	94004	\N
20682	1105	4	0	94005	\N
20687	741	3	0	94060	\N
20687	4190	4	0	94061	\N
20688	16	4	0	93925	\N
20688	3546	5	0	94070	\N
20694	56	8	0	93404	\N
20694	6085	9	0	94106	\N
20700	1636	8	0	93149	\N
20700	6092	9	0	94154	\N
20704	251	3	0	94164	\N
20704	3514	4	0	94165	\N
20705	156	8	0	94182	\N
20705	6095	9	0	94183	\N
20706	1792	2	0	94188	\N
20706	6096	3	0	94189	\N
20710	4178	4	0	93969	\N
20425	3368	2	0	92227	\N
20425	1470	4	0	92230	\N
20425	5990	5	0	90696	\N
20427	4363	2	0	92234	\N
20427	793	4	0	92235	\N
20427	2972	5	0	92236	\N
20429	324	1	0	92242	\N
20429	939	2	0	92243	\N
20431	186	8	0	91939	\N
20431	5991	9	0	92259	\N
20434	79	5	0	92274	\N
20434	5993	6	0	92276	\N
20436	16	11	0	92299	\N
20436	155	12	0	92300	\N
20438	75	10	0	90224	\N
20438	3945	11	0	92302	\N
20441	35	2	0	92312	\N
20441	1191	3	0	92313	\N
20442	230	3	0	90506	\N
20442	4181	4	0	92320	\N
20447	210	3	0	90929	\N
20447	3539	4	0	92346	\N
20451	4172	3	0	92204	\N
20451	4275	4	0	92358	\N
20455	285	6	0	91024	\N
20455	3903	7	0	92375	\N
20463	290	3	0	1060	\N
20463	3635	4	0	92411	\N
20472	4172	4	0	92513	\N
20472	4219	5	0	92514	\N
20474	186	1	0	92519	\N
20474	1080	2	0	92520	\N
20479	365	26	0	92620	\N
20479	6002	27	0	92621	\N
20483	202	5	0	92639	\N
20483	5374	6	0	92640	\N
20486	402	30	0	92641	\N
20486	6004	31	0	92649	\N
20488	27	6	0	92663	\N
20488	3715	7	0	92664	\N
20491	16	3	0	92674	\N
20491	3634	4	0	92675	\N
20494	27	3	0	92711	\N
20494	4636	4	0	92712	\N
20497	186	1	0	92719	\N
20497	1080	2	0	92720	\N
20498	186	2	0	92719	\N
20498	1850	3	0	92721	\N
20503	266	3	0	92746	\N
20503	3474	4	0	92747	\N
20508	6008	20	0	92763	\N
20508	453	126	0	92764	\N
20508	6009	127	0	92765	\N
20510	2351	3	0	92775	\N
20510	2845	4	0	92776	\N
20512	79	2	0	92388	\N
20512	616	3	0	92782	\N
20516	6011	11	0	92833	\N
20516	4178	23	0	92834	\N
20516	4247	24	0	92835	\N
20521	367	6	0	91826	\N
20521	6013	7	0	92857	\N
20526	18	8	0	92190	\N
20526	6015	9	0	92912	\N
20527	42	4	0	92921	\N
20527	6016	5	0	92922	\N
20532	1021	5	0	91615	\N
20532	6017	6	0	92952	\N
20537	79	6	0	92388	\N
20537	4253	7	0	92976	\N
20545	4172	3	0	93042	\N
20545	4275	4	0	93043	\N
20550	326	0	0	88746	\N
20555	4172	4	0	93042	\N
20555	4219	5	0	93084	\N
20560	4178	14	0	93139	\N
20560	6031	15	0	93140	\N
20561	4172	3	0	93147	\N
20561	4275	4	0	93148	\N
20566	108	8	0	93173	\N
20566	6035	9	0	93174	\N
20570	94	8	0	83461	\N
20570	5303	9	0	93180	\N
20574	56	4	0	93216	\N
20574	3127	5	0	93217	\N
20575	258	4	0	93225	\N
20575	6042	5	0	93226	\N
20579	6046	66	0	93247	\N
20579	132	101	0	93250	\N
20579	6047	102	0	93251	\N
20585	262	10	0	93175	\N
20585	6050	11	0	93295	\N
20589	117	4	0	93309	\N
20589	4169	5	0	93310	\N
20594	92	4	0	87198	\N
20594	6053	5	0	93336	\N
20600	56	3	0	93404	\N
20600	4109	4	0	93405	\N
20605	90	1	0	92392	\N
20605	2897	2	0	93416	\N
20611	322	10	0	93458	\N
20611	6056	11	0	93459	\N
20612	20	3	0	93466	\N
20612	2844	4	0	93467	\N
20618	241	7	0	87895	\N
20618	6058	8	0	93511	\N
20619	113	5	0	92093	\N
20619	6059	6	0	93522	\N
20635	140	3	0	93733	\N
20635	4149	4	0	93734	\N
20636	4178	2	0	93739	\N
20636	4247	3	0	93740	\N
20643	4172	3	0	93795	\N
20643	4275	4	0	93796	\N
20648	6	4	0	93825	\N
20648	3487	5	0	93826	\N
20652	6	0	0	93825	\N
20657	12	4	0	93867	\N
20657	4043	5	0	93868	\N
20662	40	1	0	92940	\N
20662	1383	2	0	93879	\N
20669	16	3	0	93925	\N
20669	3634	4	0	93926	\N
20675	58	9	0	93967	\N
20675	3755	10	0	93968	\N
20680	6081	21	0	93988	\N
20680	4678	33	0	93996	\N
20680	6082	34	0	93997	\N
20685	4	3	0	93971	\N
20685	3837	4	0	94053	\N
20691	264	3	0	94081	\N
20691	3632	4	0	94085	\N
20696	79	6	0	92388	\N
20696	6088	7	0	94127	\N
20702	44	8	0	93151	\N
20702	6094	9	0	94157	\N
20708	1792	0	0	94188	\N
20712	90	4	0	92392	\N
20712	3731	5	0	94203	\N
20713	3625	3	0	93915	\N
20713	3784	4	0	94210	\N
20717	200	3	0	94250	\N
20717	3338	4	0	94251	\N
20722	14	0	0	93048	\N
20727	4088	10	0	94310	\N
20727	6102	11	0	94311	\N
20728	18	10	0	94312	\N
20728	4919	11	0	94313	\N
20734	40	3	0	94360	\N
20734	372	4	0	94361	\N
20740	90	10	0	92392	\N
20740	6105	11	0	94402	\N
20741	156	7	0	94417	\N
20741	6106	8	0	94418	\N
20749	212	6	0	94476	\N
20749	6111	7	0	94477	\N
20754	290	5	0	94509	\N
20629	1952	7	0	93645	\N
20629	6067	8	0	93646	\N
20630	6068	9	0	93665	\N
20630	4172	13	0	93672	\N
20630	4940	14	0	93673	\N
20631	18	12	0	93698	\N
20631	6069	13	0	93699	\N
20632	33	11	0	89817	\N
20632	6070	12	0	93722	\N
20637	4178	4	0	93749	\N
20637	4205	5	0	93750	\N
20644	326	3	0	93797	\N
20644	3339	4	0	93798	\N
20649	852	4	0	93827	\N
20649	4162	5	0	93828	\N
20653	214	3	0	87464	\N
20653	3496	4	0	90565	\N
20654	4178	3	0	93854	\N
20654	4211	4	0	93855	\N
20658	4178	4	0	93869	\N
20658	4205	5	0	93870	\N
20663	145	2	0	93177	\N
20663	1108	3	0	93413	\N
20665	119	13	0	93911	\N
20665	6077	14	0	93912	\N
20670	63	1	0	93929	\N
20670	62	4	0	93934	\N
20670	1880	5	0	93935	\N
20676	4178	9	0	93969	\N
20676	4682	10	0	93970	\N
20681	181	3	0	93072	\N
20681	4184	4	0	93073	\N
20686	322	3	0	94004	\N
20686	1105	4	0	94005	\N
20692	2351	3	0	94086	\N
20692	2845	4	0	94087	\N
20693	4172	8	0	94104	\N
20693	6084	9	0	94105	\N
20697	54	6	0	94128	\N
20697	6089	7	0	94129	\N
20698	1151	2	0	94134	\N
20698	6090	3	0	94135	\N
20699	71	8	0	94152	\N
20699	6091	9	0	94153	\N
20703	5885	3	0	93856	\N
20703	5926	4	0	93857	\N
20709	1792	0	0	94188	\N
20714	316	3	0	91348	\N
20714	4249	4	0	91349	\N
20718	102	3	0	87458	\N
20718	3597	4	0	93252	\N
20723	75	0	0	90224	\N
20724	4172	10	0	94190	\N
20724	4663	11	0	94308	\N
20729	75	10	0	90224	\N
20729	4874	11	0	94314	\N
20730	4178	10	0	93969	\N
20730	4665	11	0	94334	\N
20735	102	4	0	94358	\N
20735	2549	5	0	94363	\N
20736	69	3	0	94370	\N
20736	4536	4	0	94371	\N
20742	488	7	0	94419	\N
20742	2883	8	0	94420	\N
20747	451	7	0	88918	\N
20747	6110	8	0	94461	\N
20748	4178	6	0	94474	\N
20748	5854	7	0	94475	\N
20753	3625	5	0	93915	\N
20753	6114	6	0	94508	\N
20758	110	0	0	94525	\N
20763	6122	14	0	94601	\N
20763	244	38	0	94602	\N
20763	6124	39	1	94603	\N
20763	6123	39	0	94604	\N
20763	6125	40	0	94605	\N
20767	244	14	0	94618	\N
20767	6129	15	0	94619	\N
20773	367	12	0	91826	\N
20773	6133	13	0	94655	\N
20778	1952	5	0	94682	\N
20778	6137	6	0	94684	\N
20779	75	2	0	94689	\N
20779	284	3	0	94690	\N
20780	40	8	0	94707	\N
20780	3438	9	0	94708	\N
20781	170	2	0	94713	\N
20781	1380	3	0	94714	\N
20785	16	6	0	94730	\N
20785	5895	7	0	94731	\N
20791	108	4	0	93173	\N
20791	6142	5	0	94767	\N
20797	392	1	0	94807	\N
20797	391	2	0	94808	\N
20798	402	2	0	92641	\N
20798	2760	3	0	94813	\N
20805	4178	7	0	94864	\N
20805	5507	8	0	94865	\N
20806	2351	2	0	94870	\N
20806	2754	3	0	94871	\N
20811	137	2	0	93046	\N
20811	2721	3	0	94890	\N
20816	4178	2	0	94888	\N
20816	4247	3	0	94889	\N
20824	6045	4	0	93237	\N
20831	528	3	0	94981	\N
20831	4262	4	0	94982	\N
20835	2	2	0	95000	\N
20835	2789	3	0	95001	\N
20841	125	3	0	95030	\N
20841	2846	4	0	95031	\N
20843	96	2	0	92272	\N
20843	2347	3	0	95038	\N
20848	244	4	0	95059	\N
20848	2501	5	0	95060	\N
20851	195	1	0	95080	\N
20851	125	4	0	95081	\N
20851	2902	5	0	95082	\N
20857	4787	4	0	95127	\N
20857	6163	5	0	95128	\N
20863	73	5	0	95192	\N
20863	6165	6	0	95193	\N
20865	40	2	0	95210	\N
20865	282	3	0	95211	\N
20870	156	3	0	95245	\N
20870	4594	4	0	95246	\N
20872	300	2	0	94847	\N
20872	2786	3	0	94848	\N
20875	33	4	0	89817	\N
20875	5122	5	0	95278	\N
20880	6170	21	0	95304	\N
20880	228	90	0	95321	\N
20880	6171	91	0	95322	\N
20882	192	4	0	90441	\N
20882	6172	5	0	95334	\N
20886	58	2	0	95343	\N
20886	2853	3	0	95344	\N
20889	2760	2	0	95352	\N
20889	402	3	0	95353	\N
20891	282	2	0	95354	\N
20891	40	3	0	95355	\N
20893	115	3	0	95367	\N
20893	3483	4	0	95368	\N
20895	4178	2	0	95375	\N
20895	4247	3	0	95376	\N
20898	4178	3	0	95389	\N
20898	4211	4	0	95390	\N
20901	233	2	0	88898	\N
20901	1849	3	0	95399	\N
20904	14	2	0	95243	\N
20904	1785	3	0	95405	\N
20907	40	5	0	95418	\N
20907	2714	6	0	95419	\N
20913	192	4	0	90441	\N
20913	6172	5	0	95334	\N
20920	90	4	0	95508	\N
20684	14	3	0	93048	\N
20684	4272	4	0	94052	\N
20689	4172	3	0	93795	\N
20689	4275	4	0	93796	\N
20690	264	2	0	94081	\N
20690	2780	3	0	94082	\N
20695	6086	27	0	94114	\N
20695	54	29	0	94115	\N
20695	6087	30	1	94116	\N
20695	1970	30	0	94117	\N
20701	189	8	0	94155	\N
20701	6093	9	0	94156	\N
20707	4172	2	0	94190	\N
20707	4191	3	0	94191	\N
20711	488	4	0	94201	\N
20711	5606	5	0	94202	\N
20716	6097	66	1	94239	\N
20716	5975	66	0	94240	\N
20716	3251	67	0	94241	\N
20716	320	79	0	94242	\N
20716	2519	80	1	94243	\N
20716	6098	80	0	92021	\N
20721	6100	95	0	94267	\N
20721	6099	126	0	94286	\N
20721	180	127	0	94287	\N
20726	233	10	0	88898	\N
20726	6101	11	0	94309	\N
20733	102	3	0	94358	\N
20733	3597	4	0	94359	\N
20738	88	4	0	91059	\N
20738	3809	5	0	94380	\N
20739	4172	10	0	94190	\N
20739	6104	11	0	94401	\N
20744	18	6	0	94312	\N
20744	4566	7	0	94434	\N
20745	908	5	0	93979	\N
20745	6108	6	0	94445	\N
20750	16	6	0	94478	\N
20750	5895	7	0	94479	\N
20751	1470	8	0	93070	\N
20751	6112	9	0	94496	\N
20756	449	6	0	94523	\N
20756	6116	7	0	94524	\N
20761	181	14	0	94563	\N
20761	3108	16	0	78650	\N
20765	4172	7	0	94190	\N
20765	6127	8	0	94615	\N
20770	528	2	0	90756	\N
20770	2765	3	0	94627	\N
20771	4178	12	0	94474	\N
20771	6131	13	0	94652	\N
20775	367	6	0	91826	\N
20775	6135	7	0	94657	\N
20783	841	6	0	94728	\N
20783	6139	7	0	94729	\N
20788	90	1	0	94740	\N
20788	344	2	0	94741	\N
20794	4178	6	0	94786	\N
20794	4297	7	0	94787	\N
20795	4233	7	0	94802	\N
20795	6143	8	0	94803	\N
20800	4178	3	0	94820	\N
20800	4211	4	0	94821	\N
20801	140	2	0	93733	\N
20801	3183	3	0	94826	\N
20802	42	7	0	94841	\N
20802	6145	8	0	94842	\N
20803	300	2	0	94847	\N
20803	2786	3	0	94848	\N
20808	6146	3	0	94880	\N
20808	6147	4	0	94881	\N
20809	674	2	0	94886	\N
20809	6148	3	0	94887	\N
20813	841	3	0	94728	\N
20813	3604	4	0	94899	\N
20814	102	2	0	94904	\N
20814	3053	3	0	94905	\N
20823	6153	2	0	94953	\N
20827	125	2	0	94966	\N
20827	3297	3	0	94967	\N
20830	5885	3	0	93856	\N
20830	5926	4	0	93857	\N
20834	173	4	0	94994	\N
20834	3857	5	0	94995	\N
20836	244	37	0	95003	\N
20836	6154	38	1	95004	\N
20836	5352	38	0	95005	\N
20836	3079	39	1	95006	\N
20836	6155	39	0	95007	\N
20836	6156	40	0	95008	\N
20840	117	3	0	93309	\N
20840	6158	4	0	95029	\N
20845	391	2	0	94949	\N
20845	1381	3	0	94950	\N
20849	244	5	0	94618	\N
20849	6159	6	0	95070	\N
20852	60	4	0	95091	\N
20852	2771	5	0	95092	\N
20853	300	10	0	94847	\N
20853	6160	11	0	95113	\N
20855	3625	4	0	93915	\N
20855	6161	5	0	95124	\N
20861	451	3	0	95178	\N
20861	5274	4	0	95179	\N
20864	18	5	0	95204	\N
20864	3550	6	0	95205	\N
20869	14	3	0	95243	\N
20869	4272	4	0	95244	\N
20871	164	4	0	92350	\N
20871	4345	5	0	95255	\N
20878	77	3	0	95296	\N
20878	1877	4	0	95297	\N
20899	167	2	0	95395	\N
20899	3322	3	0	95396	\N
20903	167	2	0	95395	\N
20903	3322	3	0	95396	\N
20906	202	5	0	92639	\N
20906	5374	6	0	92640	\N
20908	4172	2	0	95424	\N
20908	4191	3	0	95425	\N
20912	6175	61	0	95464	\N
20912	6173	126	0	95468	\N
20912	6176	127	0	95469	\N
20915	841	4	0	95479	\N
20915	2774	5	0	95480	\N
20917	56	5	0	95493	\N
20917	3373	6	0	95494	\N
20919	4172	2	0	95491	\N
20919	4191	3	0	95499	\N
20921	56	2	0	95514	\N
20921	2795	3	0	95515	\N
20926	233	2	0	88898	\N
20926	1849	3	0	95399	\N
20934	4	9	0	95601	\N
20934	6180	10	0	95602	\N
20939	73	6	0	95192	\N
20939	6183	7	0	95627	\N
20945	4172	7	0	95688	\N
20945	4537	8	0	95689	\N
20950	4172	2	0	95688	\N
20950	4191	3	0	95707	\N
20952	71	2	0	94152	\N
20952	1125	3	0	95718	\N
20960	852	3	0	93827	\N
20960	6192	4	0	95762	\N
20761	6118	15	0	138667	\N
20761	6119	15	1	138668	\N
20710	4205	5	0	94200	\N
20715	38	3	0	80	\N
20715	3457	4	0	94211	\N
20719	102	0	0	87458	\N
20720	6099	2	0	94256	\N
20720	2763	3	0	94257	\N
20725	233	10	0	88898	\N
20725	6101	11	0	94309	\N
20731	27	10	0	94335	\N
20731	4830	11	0	94336	\N
20732	173	7	0	92531	\N
20732	6103	8	0	94351	\N
20737	170	3	0	92672	\N
20737	4148	4	0	92673	\N
20743	4172	6	0	94190	\N
20743	6107	7	0	94433	\N
20746	224	7	0	93306	\N
20746	6109	8	0	94460	\N
20752	119	5	0	93911	\N
20752	6113	6	0	94507	\N
20757	459	0	0	93944	\N
20762	6120	73	0	94590	\N
20762	181	119	0	94599	\N
20762	6121	120	0	94600	\N
20766	73	5	0	94616	\N
20766	6128	6	0	94617	\N
20772	1636	12	0	94653	\N
20772	6132	13	0	94654	\N
20776	391	5	0	94668	\N
20776	2235	6	0	94669	\N
20777	1952	6	0	94682	\N
20777	6136	7	0	94683	\N
20784	326	0	0	93797	\N
20789	60	5	0	94750	\N
20789	5528	6	0	94751	\N
20790	4178	3	0	94474	\N
20790	4441	4	0	94758	\N
20796	4233	6	0	94802	\N
20796	6144	7	0	94804	\N
20804	2	2	0	94849	\N
20804	2789	3	0	94850	\N
20810	4178	2	0	94888	\N
20810	4247	3	0	94889	\N
20815	260	2	0	94738	\N
20815	3184	3	0	94739	\N
20818	6151	97	0	94935	\N
20818	102	126	0	94937	\N
20818	6152	127	0	94938	\N
20819	170	0	0	94939	\N
20820	170	2	0	94939	\N
20820	1380	3	0	94944	\N
20821	4172	2	0	94190	\N
20821	4191	3	0	94191	\N
20825	38	2	0	94959	\N
20825	4009	3	0	94960	\N
20838	273	5	0	95020	\N
20838	6157	6	0	95021	\N
20846	14	2	0	95041	\N
20846	1785	3	0	95045	\N
20847	40	4	0	94983	\N
20847	3381	5	0	95053	\N
20850	4450	1	0	95073	\N
20850	4178	4	0	95078	\N
20850	4527	5	0	95079	\N
20854	4172	10	0	95114	\N
20854	4474	11	0	95115	\N
20856	119	4	0	95125	\N
20856	6162	5	0	95126	\N
20858	264	2	0	94081	\N
20858	2780	3	0	94082	\N
20859	4178	15	0	95163	\N
20859	6164	16	0	95164	\N
20862	4172	5	0	95190	\N
20862	6107	6	0	95191	\N
20867	6166	87	0	95225	\N
20867	27	107	0	95233	\N
20867	6167	108	0	95234	\N
20874	451	3	0	95268	\N
20874	3934	4	0	95269	\N
20877	6168	48	0	95280	\N
20877	33	102	0	95288	\N
20877	6169	103	0	95289	\N
20879	75	2	0	95302	\N
20879	284	3	0	95303	\N
20881	115	1	0	95325	\N
20881	116	2	0	95326	\N
20884	181	4	0	95337	\N
20884	2356	5	0	95338	\N
20888	1413	2	0	95350	\N
20888	273	3	0	95351	\N
20892	488	2	0	94419	\N
20892	2791	3	0	95360	\N
20897	202	3	0	92639	\N
20897	4857	4	0	95388	\N
20900	42	2	0	95397	\N
20900	3310	3	0	95398	\N
20909	56	7	0	95440	\N
20909	4512	8	0	95441	\N
20910	4178	7	0	95456	\N
20910	4509	8	0	95457	\N
20922	145	2	0	93177	\N
20922	1108	3	0	93413	\N
20924	841	5	0	95479	\N
20924	6177	6	0	95534	\N
20927	4088	2	0	94310	\N
20927	4332	3	0	95400	\N
20929	12	2	0	93867	\N
20929	2804	3	0	95558	\N
20930	6178	6	0	95570	\N
20930	210	9	0	95575	\N
20930	6179	10	0	95576	\N
20932	1636	2	0	94653	\N
20932	4416	3	0	95581	\N
20935	1470	9	0	95603	\N
20935	6181	10	0	95604	\N
20942	35	5	0	95605	\N
20942	6185	6	0	95652	\N
20946	264	7	0	95690	\N
20946	6187	8	0	95691	\N
20948	14	3	0	95416	\N
20948	4272	4	0	95700	\N
20953	1021	2	0	95719	\N
20953	4432	3	0	95720	\N
20955	60	2	0	95733	\N
20955	4544	3	0	95734	\N
20958	908	3	0	95759	\N
20958	6190	4	0	95760	\N
20961	449	3	0	95763	\N
20961	6193	4	0	95764	\N
20754	6115	6	0	94510	\N
20755	4178	6	0	94474	\N
20755	5854	7	0	94475	\N
20759	1109	0	0	94526	\N
20760	2627	60	0	39189	\N
20760	6117	61	0	94555	\N
20764	2627	12	0	39189	\N
20764	6126	13	0	94606	\N
20768	73	5	0	94616	\N
20768	6128	6	0	94617	\N
20769	528	3	0	90756	\N
20769	6130	4	0	94626	\N
20774	44	12	0	93151	\N
20774	6134	13	0	94656	\N
20782	198	6	0	90508	\N
20782	6138	7	0	94727	\N
20786	6140	38	0	94732	\N
20786	5653	39	0	94241	\N
20786	6141	39	0	94733	\N
20787	260	2	0	94738	\N
20787	3184	3	0	94739	\N
20792	200	4	0	94250	\N
20792	2811	5	0	94768	\N
20793	16	2	0	94730	\N
20793	388	3	0	94773	\N
20807	2351	3	0	94870	\N
20807	2845	4	0	94875	\N
20812	135	2	0	94891	\N
20812	2722	3	0	94892	\N
20817	6149	2	0	94906	\N
20817	6150	3	0	94907	\N
20822	391	2	0	94949	\N
20822	1381	3	0	94950	\N
20826	38	3	0	94959	\N
20826	3457	4	0	94961	\N
20828	56	2	0	93404	\N
20828	2795	3	0	94972	\N
20829	4172	3	0	94979	\N
20829	4275	4	0	94980	\N
20832	40	3	0	94983	\N
20832	372	4	0	94984	\N
20833	16	3	0	94990	\N
20833	1045	4	0	94991	\N
20837	244	2	0	94618	\N
20837	3308	3	0	95009	\N
20839	40	5	0	94983	\N
20839	5806	6	0	95022	\N
20842	75	3	0	95032	\N
20842	713	4	0	95033	\N
20844	14	1	0	95041	\N
20844	15	2	0	95042	\N
20860	4233	3	0	95171	\N
20860	4425	4	0	95172	\N
20866	285	2	0	93085	\N
20866	3036	3	0	95212	\N
20868	2351	3	0	95241	\N
20868	2845	4	0	95242	\N
20873	365	2	0	95260	\N
20873	615	3	0	95261	\N
20876	16	4	0	94990	\N
20876	2575	5	0	95279	\N
20883	4172	4	0	95335	\N
20883	4252	5	0	95336	\N
20887	94	2	0	83461	\N
20887	2794	3	0	95345	\N
20894	4178	3	0	95369	\N
20894	4211	4	0	95370	\N
20896	4172	2	0	95335	\N
20896	4191	3	0	95381	\N
20902	4088	2	0	94310	\N
20902	4332	3	0	95400	\N
20905	14	5	0	95416	\N
20905	5648	6	0	95417	\N
20911	6173	2	0	95462	\N
20911	6174	3	0	95463	\N
20914	40	4	0	95418	\N
20914	2796	5	0	95478	\N
20916	4172	5	0	95491	\N
20916	4644	6	0	95492	\N
20918	186	2	0	92719	\N
20918	1850	3	0	92721	\N
20923	16	3	0	95522	\N
20923	1045	4	0	95523	\N
20928	4178	3	0	95552	\N
20928	4211	4	0	95553	\N
20937	1470	9	0	95603	\N
20937	6181	10	0	95604	\N
20938	4178	3	0	95613	\N
20938	5507	4	0	95614	\N
20941	40	2	0	95640	\N
20941	282	3	0	95641	\N
20944	16	4	0	95672	\N
20944	2575	5	0	95673	\N
20949	6044	2	0	95705	\N
20949	6188	3	0	95706	\N
20954	2	3	0	95727	\N
20954	3548	4	0	95728	\N
20956	40	2	0	95735	\N
20956	282	3	0	95736	\N
20957	151	7	0	95751	\N
20957	6189	8	0	95752	\N
20920	3435	5	0	95509	\N
20925	391	3	0	94949	\N
20925	503	4	0	95541	\N
20931	6178	6	0	95570	\N
20931	210	9	0	95575	\N
20931	6179	10	0	95576	\N
20933	44	2	0	93151	\N
20933	1910	3	0	95582	\N
20936	35	9	0	95605	\N
20936	6182	10	0	95606	\N
20940	4172	4	0	95491	\N
20940	6184	5	0	95635	\N
20943	336	5	0	95662	\N
20943	6186	6	0	95663	\N
20947	4178	7	0	95692	\N
20947	4509	8	0	95693	\N
20951	18	2	0	95712	\N
20951	1685	3	0	95713	\N
20959	115	3	0	95367	\N
20959	6191	4	0	95761	\N
20962	16	4	0	95773	\N
20962	2575	5	0	95774	\N
20963	145	2	0	93177	\N
20963	1108	3	0	93413	\N
20964	173	16	0	95782	\N
20964	6194	17	0	95783	\N
20965	852	5	0	95794	\N
20965	4420	6	0	95795	\N
20966	285	2	0	93085	\N
20966	6196	3	1	95800	\N
20966	6195	3	0	95801	\N
20966	6198	4	1	95802	\N
20966	6197	4	0	95803	\N
20966	5358	5	1	95804	\N
20966	6199	5	0	95805	\N
20967	77	2	0	95806	\N
20967	3853	3	0	95807	\N
20968	77	2	0	95806	\N
20968	3853	3	0	95807	\N
20969	285	2	0	93085	\N
20969	1075	3	1	95808	\N
20969	6200	3	0	95809	\N
20970	285	2	0	93085	\N
20970	3036	3	0	95212	\N
20971	102	2	0	95814	\N
20971	3053	3	0	95815	\N
20972	102	4	0	95819	\N
20972	6201	5	0	95820	\N
20973	170	6	0	95833	\N
20973	6202	7	0	95834	\N
20974	2578	2	0	95839	\N
20974	4325	3	0	95840	\N
20975	40	3	0	95847	\N
20975	1921	4	0	95848	\N
20976	132	3	0	95849	\N
20976	5516	4	0	95850	\N
20977	73	3	0	95857	\N
20977	3040	4	0	95858	\N
20978	56	3	0	95859	\N
20978	4109	4	0	95860	\N
20979	4178	2	0	95692	\N
20979	4247	3	0	95865	\N
20980	300	2	0	94847	\N
20980	2786	3	0	94848	\N
20981	391	2	0	95870	\N
20981	1381	3	0	95871	\N
20982	4172	2	0	95688	\N
20982	4191	3	0	95707	\N
20983	4172	2	0	95688	\N
20983	4191	3	0	95707	\N
20984	391	2	0	95876	\N
20984	1381	3	0	95877	\N
20985	38	3	0	94959	\N
20985	3457	4	0	94961	\N
20986	58	2	0	95888	\N
20986	2853	3	0	95889	\N
20987	51	2	0	89977	\N
20987	1260	3	0	95890	\N
20988	40	2	0	95847	\N
20988	282	3	0	95891	\N
20989	4172	2	0	95688	\N
20989	4191	3	0	95707	\N
20990	459	2	0	93944	\N
20990	3860	3	0	95896	\N
20991	113	2	0	95897	\N
20991	1899	3	0	95898	\N
20992	1316	3	0	91143	\N
20992	4837	4	0	95905	\N
20993	2782	2	0	95910	\N
20993	6203	3	0	95911	\N
20994	4787	4	0	95127	\N
20994	4847	5	0	95916	\N
20995	4787	4	0	95127	\N
20995	4847	5	0	95916	\N
20996	2782	4	0	95910	\N
20996	2783	5	0	95917	\N
20997	62	13	0	95944	\N
20997	6204	14	0	95945	\N
20998	137	13	0	93046	\N
20998	6205	14	0	95946	\N
20999	135	13	0	94891	\N
20999	6206	14	0	95947	\N
21000	6207	36	0	95948	\N
21000	62	126	0	95971	\N
21000	6208	127	0	95972	\N
21001	285	5	0	93085	\N
21001	5103	6	0	95983	\N
21002	167	5	0	95395	\N
21002	2851	6	0	95984	\N
21003	391	2	0	95989	\N
21003	1381	3	0	95990	\N
21004	4172	2	0	95991	\N
21004	4191	3	0	95992	\N
21005	1636	2	0	95993	\N
21005	4416	3	0	95994	\N
21006	44	2	0	93151	\N
21006	1910	3	0	95582	\N
21007	115	5	0	95367	\N
21007	5025	6	0	96005	\N
21008	241	5	0	93751	\N
21008	4586	6	0	96006	\N
21009	115	3	0	95367	\N
21009	1115	4	0	96007	\N
21010	92	2	0	96012	\N
21010	2763	3	0	96013	\N
21011	6209	95	0	96031	\N
21011	92	126	0	96032	\N
21011	6210	127	0	96033	\N
21012	20	3	0	96040	\N
21012	2844	4	0	96041	\N
21013	6146	3	0	96042	\N
21013	6147	4	0	96043	\N
21014	145	7	0	96058	\N
21014	6211	8	0	96059	\N
21015	5885	5	0	93856	\N
21015	6212	6	0	96070	\N
21016	56	5	0	95859	\N
21016	3551	6	0	96071	\N
21018	54	2	0	94128	\N
21018	3351	3	0	96076	\N
21019	40	2	0	96077	\N
21019	282	3	0	96078	\N
21020	18	2	0	96079	\N
21020	1685	3	0	96080	\N
21021	167	6	0	95395	\N
21021	3314	7	0	96093	\N
21022	167	6	0	95395	\N
21022	3314	7	0	96093	\N
21023	4233	6	0	96094	\N
21023	6213	7	0	96095	\N
21024	167	6	0	95395	\N
21024	3314	7	0	96093	\N
21025	4172	6	0	95991	\N
21025	4365	7	0	96096	\N
21026	4233	6	0	96094	\N
21026	6213	7	0	96095	\N
21027	4233	6	0	96094	\N
21027	6213	7	0	96095	\N
21029	719	2	0	18875	\N
21029	6214	3	0	96103	\N
21036	451	0	0	96120	\N
21040	14	3	0	96135	\N
21040	4272	4	0	96136	\N
21042	40	3	0	96104	\N
21042	372	4	0	96139	\N
21047	4172	3	0	95991	\N
21047	4275	4	0	96166	\N
21053	121	2	0	93181	\N
21053	2498	3	0	96174	\N
21054	14	4	0	96185	\N
21054	2291	5	0	96186	\N
21056	71	2	0	94152	\N
21056	1125	3	0	95718	\N
21059	16	5	0	96208	\N
21059	4240	6	0	96209	\N
21063	149	10	0	96244	\N
21063	6218	11	0	96252	\N
21067	336	3	0	96269	\N
21067	3400	4	0	96270	\N
21079	170	3	0	96315	\N
21079	4148	4	0	96316	\N
21081	56	2	0	95859	\N
21081	2795	3	0	96321	\N
21084	4352	4	0	96341	\N
21084	137	6	0	96342	\N
21084	3261	7	0	96343	\N
21093	597	4	0	92732	\N
21093	6224	5	0	96377	\N
21100	198	3	0	96390	\N
21100	4263	4	0	96391	\N
21101	16	1	0	96396	\N
21101	17	2	0	96397	\N
21106	40	7	0	96416	\N
21106	4488	8	0	96417	\N
21108	4178	4	0	96423	\N
21108	4331	5	0	96424	\N
21111	4178	1	0	96423	\N
21111	4450	2	0	96429	\N
21115	4178	2	0	96423	\N
21115	4247	3	0	96445	\N
21117	40	2	0	96451	\N
21117	282	3	0	96452	\N
21120	73	3	0	96476	\N
21120	3040	4	0	96477	\N
21123	79	2	0	96498	\N
21123	3180	3	0	96499	\N
21125	75	2	0	96504	\N
21125	2989	3	0	96505	\N
21130	336	3	0	96522	\N
21130	3400	4	0	96523	\N
21135	4172	4	0	96526	\N
21135	4252	5	0	96537	\N
21137	121	2	0	93181	\N
21137	625	3	0	96538	\N
21139	75	4	0	96514	\N
21139	2357	5	0	96541	\N
21141	115	2	0	95367	\N
21141	2797	3	0	96555	\N
21147	40	0	0	96600	\N
21150	488	6	0	96614	\N
21150	3315	7	0	96615	\N
21152	40	2	0	96631	\N
21152	282	3	0	96632	\N
21155	38	2	0	96638	\N
21155	4009	3	0	96639	\N
21157	326	2	0	93797	\N
21157	393	3	0	96644	\N
21160	102	2	0	96669	\N
21160	3053	3	0	96670	\N
21165	4178	2	0	96685	\N
21165	4247	3	0	96686	\N
21167	33	2	0	89817	\N
21167	2822	3	0	96696	\N
21171	4	8	0	96706	\N
21171	6235	9	0	96708	\N
21173	4178	2	0	96685	\N
21173	4247	3	0	96686	\N
21178	96	5	0	96724	\N
21178	3800	6	0	96725	\N
21180	4172	2	0	96671	\N
21180	4191	3	0	96672	\N
21188	6236	57	0	96768	\N
21188	228	108	0	96771	\N
21188	6237	109	0	96772	\N
21193	177	3	0	75580	\N
21193	3538	4	0	75581	\N
21195	598	1	0	96809	\N
21195	597	3	0	96812	\N
21195	2956	4	0	96813	\N
21200	96	1	0	96724	\N
21200	2899	2	0	96845	\N
21205	6243	106	0	96866	\N
21205	27	126	0	96867	\N
21205	6244	127	0	96868	\N
21207	20	2	0	96392	\N
21207	369	3	0	96874	\N
21212	16	2	0	96894	\N
21212	388	3	0	96895	\N
21214	82	2	0	96901	\N
21214	3401	3	0	96902	\N
21216	4178	2	0	96858	\N
21216	4247	3	0	96907	\N
21219	241	2	0	96313	\N
21219	281	3	0	96918	\N
21227	322	4	0	96967	\N
21227	3429	5	0	96968	\N
21232	1470	2	0	96990	\N
21232	3368	3	0	96991	\N
21237	4	10	0	97024	\N
21237	6247	11	0	97025	\N
21239	852	10	0	97035	\N
21239	6249	11	0	97036	\N
21242	78	1	0	97045	\N
21242	77	3	0	97046	\N
21242	2934	4	0	97047	\N
21244	451	2	0	97048	\N
21244	3317	3	0	97054	\N
21249	102	8	0	97088	\N
21249	5616	9	0	97089	\N
21252	4178	8	0	97094	\N
21252	5610	9	0	97095	\N
21253	2636	1	0	97098	\N
21253	3980	2	0	97099	\N
21258	4178	2	0	97094	\N
21258	4247	3	0	97116	\N
21262	142	8	0	96998	\N
21262	6258	9	0	97146	\N
21264	86	4	0	97155	\N
21264	2576	5	0	97156	\N
21266	38	4	0	96638	\N
21266	6259	5	0	97159	\N
21270	77	1	0	97166	\N
21270	2934	2	0	97167	\N
21271	4178	9	0	97186	\N
21271	4682	10	0	97187	\N
21274	6	27	0	97250	\N
21274	6261	28	0	97251	\N
21277	4	32	0	97268	\N
21277	6262	33	0	97269	\N
21280	402	56	0	96367	\N
21280	6263	57	0	97279	\N
21283	4429	5	0	97295	\N
21283	4178	7	0	97296	\N
21283	4460	8	0	97297	\N
21285	18	4	0	97314	\N
21285	2302	5	0	97315	\N
21288	2636	4	0	97339	\N
21288	3617	5	0	97340	\N
21293	16	4	0	97366	\N
21293	3546	5	0	97367	\N
21296	4172	6	0	96760	\N
21296	4197	7	0	97384	\N
21298	4178	3	0	97392	\N
21298	4211	4	0	97393	\N
21028	75	6	0	96097	\N
21028	3361	7	0	96098	\N
21032	402	3	0	96112	\N
21032	4077	4	0	96113	\N
21034	451	2	0	96120	\N
21034	3317	3	0	96121	\N
21037	451	0	0	96120	\N
21041	264	3	0	96137	\N
21041	3632	4	0	96138	\N
21043	77	5	0	96150	\N
21043	6215	6	0	96151	\N
21046	75	2	0	96097	\N
21046	284	3	0	96124	\N
21048	2	3	0	96167	\N
21048	3548	4	0	96168	\N
21050	121	2	0	93181	\N
21050	2498	3	0	96174	\N
21055	40	4	0	96104	\N
21055	2796	5	0	96187	\N
21057	4172	2	0	95991	\N
21057	4191	3	0	95992	\N
21065	6219	57	0	96257	\N
21065	228	126	0	96258	\N
21065	6220	127	0	96259	\N
21068	233	3	0	96264	\N
21068	3704	4	0	96271	\N
21070	16	6	0	96285	\N
21070	6221	7	0	96286	\N
21072	4178	3	0	96294	\N
21072	4211	4	0	96295	\N
21075	137	2	0	93046	\N
21075	2721	3	0	94890	\N
21085	4353	4	0	96344	\N
21085	135	6	0	96345	\N
21085	3262	7	0	96346	\N
21086	60	2	0	95733	\N
21086	4544	3	0	95734	\N
21088	90	2	0	96353	\N
21088	3442	3	0	96354	\N
21094	595	4	0	96378	\N
21094	6225	5	0	96379	\N
21104	233	3	0	96264	\N
21104	3704	4	0	96271	\N
21109	75	4	0	96097	\N
21109	2357	5	0	96425	\N
21113	210	3	0	96438	\N
21113	3539	4	0	96439	\N
21116	40	2	0	96416	\N
21116	282	3	0	96446	\N
21118	108	3	0	93173	\N
21118	4171	4	0	96459	\N
21124	6230	3	0	96502	\N
21124	6231	4	0	96503	\N
21126	4172	2	0	96250	\N
21126	4191	3	0	96300	\N
21128	2	2	0	96512	\N
21128	2789	3	0	96513	\N
21131	69	3	0	96524	\N
21131	4536	4	0	96525	\N
21142	16	2	0	96556	\N
21142	388	3	0	96557	\N
21144	6232	4	0	96567	\N
21144	6233	5	0	96568	\N
21148	4178	2	0	96423	\N
21148	4247	3	0	96445	\N
21153	336	2	0	96522	\N
21153	3332	3	0	96633	\N
21161	102	2	0	96669	\N
21161	3053	3	0	96670	\N
21168	235	2	0	96697	\N
21168	2757	3	0	96698	\N
21169	6234	72	0	96699	\N
21169	33	126	0	96700	\N
21169	6168	127	0	96701	\N
21172	110	2	0	96709	\N
21172	626	3	0	96710	\N
21174	16	2	0	96556	\N
21174	388	3	0	96557	\N
21176	40	5	0	96631	\N
21176	5806	6	0	96723	\N
21183	18	2	0	96745	\N
21183	1685	3	0	96746	\N
21186	453	2	0	96766	\N
21186	2838	3	0	96767	\N
21191	18	8	0	96792	\N
21191	6241	9	0	96793	\N
21198	734	2	0	92325	\N
21198	5996	3	0	92326	\N
21210	391	2	0	96886	\N
21210	1381	3	0	96887	\N
21213	4172	2	0	96760	\N
21213	4191	3	0	96896	\N
21215	38	2	0	96638	\N
21215	4009	3	0	96639	\N
21217	241	0	0	96313	\N
21222	16	2	0	96894	\N
21222	388	3	0	96895	\N
21228	71	4	0	96969	\N
21228	2776	5	0	96970	\N
21230	4178	1	0	96974	\N
21230	4450	2	0	96975	\N
21233	4178	2	0	96992	\N
21233	4247	3	0	96993	\N
21235	56	2	0	97000	\N
21235	2795	3	0	97001	\N
21238	4	10	0	96706	\N
21238	6248	11	0	97034	\N
21250	230	8	0	97090	\N
21250	6255	9	0	97091	\N
21254	4178	1	0	97094	\N
21254	4450	2	0	97100	\N
21256	202	2	0	97105	\N
21256	2764	3	0	97106	\N
21263	360	8	0	93965	\N
21263	6257	9	0	97145	\N
21265	300	4	0	97157	\N
21265	2992	5	0	97158	\N
21267	38	4	0	96638	\N
21267	6259	5	0	97159	\N
21278	402	4	0	96367	\N
21278	4731	5	0	97270	\N
21286	326	3	0	97322	\N
21286	3339	4	0	97323	\N
21289	4172	4	0	96760	\N
21289	4219	5	0	97341	\N
21291	449	6	0	95763	\N
21291	5168	7	0	97356	\N
21299	149	3	0	96244	\N
21299	4189	4	0	97391	\N
21300	62	4	0	97402	\N
21300	4059	5	0	97403	\N
21305	18	3	0	97419	\N
21305	3621	4	0	97420	\N
21307	212	3	0	94476	\N
21307	3639	4	0	97429	\N
21311	244	3	0	97431	\N
21311	4075	4	0	97432	\N
21316	326	3	0	97460	\N
21316	3339	4	0	97461	\N
21317	262	13	0	93175	\N
21317	5815	14	0	97488	\N
21319	262	13	0	93175	\N
21319	5815	14	0	97488	\N
21324	23	4	0	96436	\N
21324	3189	5	0	97525	\N
21329	451	3	0	97545	\N
21329	3934	4	0	97546	\N
21338	230	3	0	97090	\N
21338	4181	4	0	97575	\N
21342	198	3	0	97598	\N
21342	4263	4	0	97599	\N
21345	79	6	0	97613	\N
21345	4253	7	0	97614	\N
21347	79	0	0	96498	\N
21349	324	4	0	97650	\N
21349	3500	5	0	97651	\N
21352	14	6	0	96185	\N
21030	40	2	0	96104	\N
21030	282	3	0	96105	\N
21033	402	4	0	96112	\N
21033	2548	5	0	96115	\N
21039	4178	1	0	96127	\N
21039	4450	2	0	96128	\N
21044	4178	2	0	96156	\N
21044	4247	3	0	96157	\N
21051	16	2	0	96175	\N
21051	388	3	0	96176	\N
21060	40	4	0	96218	\N
21060	6216	5	0	96219	\N
21062	4172	6	0	96250	\N
21062	5249	7	0	96251	\N
21064	18	6	0	96079	\N
21064	2381	7	0	96253	\N
21069	4088	3	0	94310	\N
21069	4506	4	0	96272	\N
21073	71	2	0	94152	\N
21073	1125	3	0	95718	\N
21077	391	2	0	95989	\N
21077	1381	3	0	95990	\N
21082	1021	2	0	96326	\N
21082	4432	3	0	96327	\N
21087	324	2	0	96351	\N
21087	2808	3	0	96352	\N
21089	324	2	0	96351	\N
21089	2808	3	0	96352	\N
21091	1141	5	0	96365	\N
21091	6222	6	0	96366	\N
21095	402	4	0	96367	\N
21095	2548	5	0	96380	\N
21098	198	3	0	96390	\N
21098	4263	4	0	96391	\N
21102	75	1	0	96097	\N
21102	76	2	0	96398	\N
21105	4088	3	0	94310	\N
21105	4506	4	0	96272	\N
21107	40	5	0	96416	\N
21107	2714	6	0	96418	\N
21114	456	3	0	2371	\N
21114	6227	4	0	96440	\N
21119	6	4	0	96468	\N
21119	6228	5	0	96469	\N
21121	40	3	0	96478	\N
21121	372	4	0	96479	\N
21122	156	6	0	96492	\N
21122	6229	7	0	96493	\N
21127	4178	2	0	96423	\N
21127	4247	3	0	96445	\N
21129	75	2	0	96514	\N
21129	284	3	0	96515	\N
21132	4172	3	0	96526	\N
21132	4275	4	0	96527	\N
21136	206	0	0	88126	\N
21138	242	4	0	96539	\N
21138	4364	5	0	96540	\N
21143	4172	2	0	96526	\N
21143	4191	3	0	96558	\N
21151	56	5	0	96625	\N
21151	4703	6	0	96626	\N
21158	156	2	0	96649	\N
21158	4485	3	0	96650	\N
21162	4172	2	0	96671	\N
21162	4191	3	0	96672	\N
21163	4178	2	0	96677	\N
21163	4247	3	0	96678	\N
21175	64	2	0	96711	\N
21175	277	3	0	96712	\N
21177	96	5	0	96724	\N
21177	3800	6	0	96725	\N
21181	4172	4	0	96671	\N
21181	4252	5	0	96740	\N
21184	4178	6	0	96685	\N
21184	4358	7	0	96759	\N
21187	453	2	0	96766	\N
21187	2838	3	0	96767	\N
21189	6238	76	0	96773	\N
21189	4605	126	0	96774	\N
21189	6239	127	0	96775	\N
21194	4178	2	0	96790	\N
21194	4247	3	0	96806	\N
21196	596	1	0	96814	\N
21196	595	3	0	96815	\N
21196	2958	4	0	96816	\N
21199	96	10	0	96843	\N
21199	2055	11	0	96844	\N
21201	96	1	0	96724	\N
21201	2899	2	0	96845	\N
21202	4178	6	0	96858	\N
21202	4358	7	0	96859	\N
21204	58	2	0	95888	\N
21204	2853	3	0	95889	\N
21206	20	2	0	96392	\N
21206	3015	3	0	96869	\N
21208	230	2	0	96879	\N
21208	3307	3	0	96880	\N
21223	411	2	0	96941	\N
21223	3370	3	0	96942	\N
21225	4178	2	0	96947	\N
21225	4247	3	0	96948	\N
21229	4172	4	0	96760	\N
21229	4252	5	0	96971	\N
21231	4178	4	0	96984	\N
21231	4331	5	0	96985	\N
21240	41	1	0	97039	\N
21240	1675	3	0	21200	\N
21240	6250	3	0	97042	\N
21243	451	18	0	97048	\N
21243	6253	19	0	97049	\N
21245	451	2	0	97048	\N
21245	3317	3	0	97054	\N
21247	4178	2	0	96992	\N
21247	4247	3	0	96993	\N
21251	324	8	0	97092	\N
21251	6256	9	0	97093	\N
21259	4178	2	0	97121	\N
21259	4247	3	0	97122	\N
21268	75	4	0	97160	\N
21268	2357	5	0	97161	\N
21269	77	2	0	97166	\N
21269	3853	3	0	97047	\N
21272	451	10	0	97208	\N
21272	6260	11	0	97209	\N
21275	4	4	0	96706	\N
21275	4117	5	0	97260	\N
21281	402	0	0	96367	\N
21284	5885	3	0	97304	\N
21284	5926	4	0	97305	\N
21294	2	6	0	97380	\N
21294	4825	7	0	97381	\N
21301	77	4	0	97404	\N
21301	3619	5	0	97405	\N
21303	181	3	0	97415	\N
21303	4184	4	0	97416	\N
21308	115	1	0	97427	\N
21308	2908	2	0	97430	\N
21310	6267	46	0	97433	\N
21310	212	126	0	97434	\N
21310	6268	127	0	97435	\N
21314	145	4	0	97450	\N
21314	5607	5	0	97451	\N
21318	262	13	0	93175	\N
21318	5815	14	0	97488	\N
21322	16	3	0	97513	\N
21322	3634	4	0	97514	\N
21327	16	3	0	97513	\N
21327	3634	4	0	97514	\N
21330	451	2	0	97545	\N
21330	5006	3	0	97547	\N
21331	1470	5	0	97558	\N
21331	5803	6	0	97559	\N
21333	142	3	0	97560	\N
21333	6273	4	0	97562	\N
21339	1636	3	0	95993	\N
21031	402	3	0	96112	\N
21031	4077	4	0	96113	\N
21035	251	2	0	96122	\N
21035	1851	3	0	96123	\N
21038	75	2	0	96097	\N
21038	284	3	0	96124	\N
21045	2578	2	0	96158	\N
21045	4325	3	0	96159	\N
21049	18	3	0	96079	\N
21049	3621	4	0	96169	\N
21052	391	2	0	95989	\N
21052	1381	3	0	95990	\N
21058	16	2	0	96196	\N
21058	388	3	0	96197	\N
21061	149	67	0	96244	\N
21061	6217	68	0	96245	\N
21066	233	2	0	96264	\N
21066	1849	3	0	96265	\N
21071	4787	3	0	95127	\N
21071	4788	4	0	96293	\N
21074	4172	2	0	96250	\N
21074	4191	3	0	96300	\N
21076	135	2	0	96301	\N
21076	2722	3	0	96302	\N
21078	241	3	0	96313	\N
21078	3613	4	0	96314	\N
21080	4172	2	0	96250	\N
21080	4191	3	0	96300	\N
21083	4331	4	0	96336	\N
21083	4178	6	0	96339	\N
21083	4460	7	0	96340	\N
21090	324	2	0	96351	\N
21090	2808	3	0	96352	\N
21092	402	6	0	96367	\N
21092	6223	7	0	96368	\N
21096	147	4	0	92000	\N
21096	6226	5	0	96381	\N
21097	251	4	0	96382	\N
21097	3354	5	0	96383	\N
21099	20	3	0	96392	\N
21099	2844	4	0	96393	\N
21103	4178	2	0	96403	\N
21103	4247	3	0	96404	\N
21110	258	1	0	93225	\N
21110	309	2	0	96428	\N
21112	23	3	0	96436	\N
21112	3497	4	0	96437	\N
21133	264	3	0	96137	\N
21133	3632	4	0	96138	\N
21134	121	4	0	93181	\N
21134	4356	5	0	96536	\N
21140	75	7	0	96514	\N
21140	3331	8	0	96550	\N
21145	6044	3	0	96575	\N
21145	6045	4	0	96576	\N
21146	5069	2	0	96581	\N
21146	4172	11	0	96598	\N
21146	4500	12	0	96599	\N
21149	4178	6	0	96423	\N
21149	4358	7	0	96613	\N
21154	4178	2	0	96423	\N
21154	4247	3	0	96445	\N
21156	326	2	0	93797	\N
21156	393	3	0	96644	\N
21159	198	6	0	96663	\N
21159	5923	7	0	96664	\N
21164	1470	2	0	96683	\N
21164	3368	3	0	96684	\N
21166	64	2	0	91316	\N
21166	277	3	0	96691	\N
21170	4	2	0	96706	\N
21170	2751	3	0	96707	\N
21179	2782	2	0	96730	\N
21179	2784	3	0	96731	\N
21182	4178	2	0	96685	\N
21182	4247	3	0	96686	\N
21185	4172	6	0	96760	\N
21185	4365	7	0	96761	\N
21190	4178	8	0	96790	\N
21190	6240	9	0	96791	\N
21192	5885	3	0	96800	\N
21192	6242	4	0	96801	\N
21197	599	1	0	96817	\N
21197	147	3	0	96818	\N
21197	2957	4	0	96819	\N
21203	214	6	0	96860	\N
21203	2871	7	0	96861	\N
21209	4787	2	0	95127	\N
21209	6245	3	0	96881	\N
21211	42	2	0	96892	\N
21211	3310	3	0	96893	\N
21218	577	4	0	96916	\N
21218	6246	5	0	96917	\N
21220	241	0	0	96313	\N
21221	4178	6	0	96931	\N
21221	4358	7	0	96932	\N
21224	411	2	0	96941	\N
21224	3370	3	0	96942	\N
21226	206	4	0	96957	\N
21226	3348	5	0	96958	\N
21234	142	2	0	96998	\N
21234	4418	3	0	96999	\N
21236	2	2	0	97006	\N
21236	2789	3	0	97007	\N
21241	78	1	0	97045	\N
21241	77	3	0	97046	\N
21241	2934	4	0	97047	\N
21246	451	2	0	97048	\N
21246	3317	3	0	97054	\N
21248	62	6	0	95944	\N
21248	6254	7	0	97071	\N
21255	202	2	0	97105	\N
21255	2764	3	0	97106	\N
21257	79	2	0	96498	\N
21257	616	3	0	97111	\N
21260	18	2	0	97127	\N
21260	1685	3	0	97128	\N
21261	360	8	0	93965	\N
21261	6257	9	0	97145	\N
21273	451	2	0	97208	\N
21273	452	3	0	97210	\N
21276	402	0	0	96367	\N
21279	402	0	0	96367	\N
21282	2714	5	0	97290	\N
21282	40	7	0	97293	\N
21282	1383	8	0	97294	\N
21287	300	3	0	97157	\N
21287	3747	4	0	97330	\N
21290	115	6	0	97354	\N
21290	4693	7	0	97355	\N
21292	192	4	0	90441	\N
21292	3895	5	0	97365	\N
21295	6044	6	0	97382	\N
21295	6264	7	0	97383	\N
21297	149	3	0	96244	\N
21297	4189	4	0	97391	\N
21304	44	3	0	97417	\N
21304	3631	4	0	97418	\N
21309	244	3	0	97431	\N
21309	4075	4	0	97432	\N
21312	115	3	0	97427	\N
21312	3483	4	0	97428	\N
21320	56	4	0	97496	\N
21320	3259	5	0	97497	\N
21323	279	3	0	97515	\N
21323	3641	4	0	97516	\N
21325	141	1	0	97528	\N
21325	140	4	0	97533	\N
21325	2910	5	0	97534	\N
21328	3265	3	0	97541	\N
21328	6270	3	0	97542	\N
21328	3108	4	1	97543	\N
21328	6271	4	0	97544	\N
21332	142	5	0	97560	\N
21332	6272	6	0	97561	\N
21334	264	2	0	96137	\N
21334	3026	3	0	97567	\N
21302	6265	106	0	97406	\N
21302	1636	126	0	97407	\N
21302	6266	127	0	97408	\N
21306	115	3	0	97427	\N
21306	3483	4	0	97428	\N
21313	734	2	0	97440	\N
21313	6269	3	0	97441	\N
21315	4172	4	0	97452	\N
21315	4252	5	0	97453	\N
21321	110	4	0	96709	\N
21321	4552	5	0	97506	\N
21326	141	1	0	97528	\N
21326	140	4	0	97533	\N
21326	2910	5	0	97534	\N
21335	264	4	0	96137	\N
21335	6274	5	0	97568	\N
21337	4172	3	0	97576	\N
21337	4275	4	0	97577	\N
21341	102	3	0	97088	\N
21341	3597	4	0	97597	\N
21344	2	6	0	97380	\N
21344	4825	7	0	97381	\N
21351	14	6	0	96185	\N
21351	6277	7	0	97666	\N
21356	235	3	0	97693	\N
21356	3343	4	0	97694	\N
21363	5013	4	0	97775	\N
21363	102	7	0	97776	\N
21363	3574	8	0	97777	\N
21365	3348	4	0	97781	\N
21365	206	7	0	97782	\N
21365	3268	8	1	97783	\N
21365	6280	8	0	97784	\N
21367	189	4	0	94155	\N
21367	3992	5	0	97795	\N
21374	62	4	0	97818	\N
21374	4059	5	0	97819	\N
21377	132	4	0	97820	\N
21377	3716	5	0	97821	\N
21381	64	6	0	96711	\N
21381	5183	7	0	97844	\N
21388	365	4	0	97880	\N
21388	3298	5	0	97881	\N
21390	71	3	0	97888	\N
21390	3770	4	0	97889	\N
21400	235	11	0	97996	\N
21400	6285	12	0	97997	\N
21404	75	7	0	98016	\N
21404	3439	8	0	98017	\N
21407	2351	4	0	95241	\N
21407	3494	5	0	98028	\N
21409	1532	5	0	18470	\N
21409	6290	6	0	98041	\N
21414	92	3	0	98065	\N
21414	4410	4	0	98066	\N
21416	6293	8	0	98093	\N
21416	5643	12	0	84091	\N
21416	6294	12	0	98094	\N
21416	6295	13	0	98095	\N
21420	75	3	0	98113	\N
21420	3855	4	0	98114	\N
21425	4172	4	0	98141	\N
21425	4219	5	0	98142	\N
21428	453	10	0	98176	\N
21428	5309	11	0	98177	\N
21431	16	3	0	98188	\N
21431	3634	4	0	98189	\N
21438	189	4	0	98237	\N
21438	3992	5	0	98238	\N
21441	4172	6	0	98141	\N
21441	4365	7	0	98262	\N
21443	56	8	0	98279	\N
21443	2431	9	0	98280	\N
21449	285	4	0	98335	\N
21449	5030	5	0	98336	\N
21451	451	4	0	98348	\N
21451	3666	5	0	98349	\N
21455	4	3	0	98381	\N
21455	3837	4	0	98382	\N
21461	316	3	0	91348	\N
21461	4249	4	0	91349	\N
21466	2351	10	0	98465	\N
21466	5603	11	0	98466	\N
21468	391	10	0	97861	\N
21468	6306	11	0	98468	\N
21470	35	3	0	98476	\N
21470	3563	4	0	98477	\N
21472	189	3	0	98480	\N
21472	3782	4	0	98481	\N
21474	4172	0	0	95335	\N
21477	147	4	0	92000	\N
21477	3877	5	0	92731	\N
21480	595	4	0	98512	\N
21480	3878	5	0	98513	\N
21481	140	4	0	97955	\N
21481	3821	5	0	97956	\N
21486	4178	3	0	98543	\N
21486	4211	4	0	98544	\N
21488	451	3	0	98551	\N
21488	3934	4	0	98552	\N
21491	4172	1	0	98570	\N
21491	4201	2	0	98571	\N
21493	18	1	0	98576	\N
21493	19	2	0	98577	\N
21495	40	3	0	98583	\N
21495	372	4	0	98584	\N
21498	453	2	0	98176	\N
21498	3366	3	0	98601	\N
21501	40	2	0	98613	\N
21501	282	3	0	98614	\N
21503	273	4	0	98625	\N
21503	3390	5	0	98626	\N
21508	279	4	0	97970	\N
21508	3502	5	0	98657	\N
21514	266	3	0	98711	\N
21514	3474	4	0	98712	\N
21515	6314	108	0	98722	\N
21515	123	126	0	98730	\N
21515	6316	127	1	98731	\N
21515	6315	127	0	98732	\N
21519	212	3	0	98751	\N
21519	3639	4	0	98752	\N
21522	3295	3	0	45502	\N
21522	6318	4	0	98768	\N
21526	18	1	0	98781	\N
21526	19	2	0	98782	\N
21535	4178	3	0	98820	\N
21535	4211	4	0	98821	\N
21537	16	3	0	98829	\N
21537	3634	4	0	98830	\N
21539	241	3	0	96313	\N
21539	3613	4	0	96314	\N
21546	290	3	0	98900	\N
21546	364	4	0	98901	\N
21548	4233	2	0	98898	\N
21548	5577	3	0	98905	\N
21549	411	2	0	98910	\N
21549	2988	3	0	98911	\N
21553	69	2	0	98926	\N
21553	2920	3	0	98927	\N
21554	6329	109	0	98936	\N
21554	69	126	0	98937	\N
21554	6330	127	0	98938	\N
21555	416	3	0	98945	\N
21555	4423	4	0	98946	\N
21560	94	3	0	98972	\N
21560	2864	4	0	98973	\N
21562	119	3	0	98980	\N
21562	2860	4	0	98981	\N
21565	88	4	0	98992	\N
21565	3809	5	0	98993	\N
21573	167	3	0	99022	\N
21573	4028	4	0	99023	\N
21576	60	3	0	95733	\N
21576	3585	4	0	99033	\N
21585	186	3	0	99076	\N
21585	4294	4	0	99077	\N
21336	230	3	0	97090	\N
21336	4181	4	0	97575	\N
21343	260	6	0	94738	\N
21343	5311	7	0	97612	\N
21346	324	6	0	97615	\N
21346	5241	7	0	97616	\N
21348	6276	13	0	97641	\N
21353	156	4	0	97675	\N
21353	5935	5	0	97676	\N
21360	391	19	0	97758	\N
21360	6279	20	0	97759	\N
21369	189	4	0	94155	\N
21369	3992	5	0	97795	\N
21380	16	4	0	97513	\N
21380	3546	5	0	97831	\N
21386	167	3	0	95395	\N
21386	4028	4	0	97871	\N
21392	6281	111	0	97934	\N
21392	290	125	0	97944	\N
21392	6283	126	1	97945	\N
21392	6282	126	0	97946	\N
21392	2519	127	0	48166	\N
21395	1109	4	0	94526	\N
21395	3816	5	0	97958	\N
21397	18	2	0	97967	\N
21397	1685	3	0	97968	\N
21399	2782	11	0	97994	\N
21399	6284	12	0	97995	\N
21408	4172	5	0	98039	\N
21408	6289	6	0	98040	\N
21413	322	3	0	96967	\N
21413	1105	4	0	98067	\N
21415	6292	8	0	98084	\N
21415	198	12	0	98091	\N
21415	3181	13	0	98092	\N
21418	6292	8	0	98084	\N
21418	198	12	0	98091	\N
21418	3181	13	0	98092	\N
21424	266	3	0	98131	\N
21424	3474	4	0	98132	\N
21427	79	6	0	97613	\N
21427	4253	7	0	97614	\N
21430	20	3	0	98186	\N
21430	2844	4	0	98187	\N
21435	279	6	0	97970	\N
21435	5117	7	0	98211	\N
21437	285	1	0	98226	\N
21437	3112	2	0	98228	\N
21440	402	6	0	96367	\N
21440	3382	7	0	98261	\N
21446	4172	3	0	98141	\N
21446	4275	4	0	98301	\N
21453	18	18	0	98365	\N
21453	6300	19	0	98366	\N
21454	326	3	0	98373	\N
21454	3339	4	0	98374	\N
21458	4178	7	0	98423	\N
21458	4396	8	0	98424	\N
21460	75	3	0	98433	\N
21460	3855	4	0	98434	\N
21463	793	3	0	98442	\N
21463	2644	4	0	92236	\N
21465	262	10	0	98463	\N
21465	5412	11	0	98464	\N
21476	528	10	0	94981	\N
21476	5604	11	0	98502	\N
21479	597	4	0	92732	\N
21479	3733	5	0	92733	\N
21483	4178	4	0	98516	\N
21483	4205	5	0	98517	\N
21485	4178	7	0	98516	\N
21485	4396	8	0	98536	\N
21490	40	2	0	98566	\N
21490	282	3	0	98567	\N
21497	4178	5	0	98595	\N
21497	4333	6	0	98596	\N
21500	2636	2	0	98611	\N
21500	2836	3	0	98612	\N
21502	4178	2	0	98615	\N
21502	4247	3	0	98616	\N
21506	411	6	0	98646	\N
21506	6310	7	0	98647	\N
21511	322	6	0	96967	\N
21511	6313	7	0	98693	\N
21517	4172	3	0	98702	\N
21517	4275	4	0	98747	\N
21521	4172	3	0	98702	\N
21521	4275	4	0	98747	\N
21524	367	3	0	98770	\N
21524	3683	4	0	98772	\N
21525	79	3	0	98779	\N
21525	3652	4	0	98780	\N
21528	88	2	0	98801	\N
21528	2799	3	0	98802	\N
21530	88	3	0	98801	\N
21530	3655	4	0	98805	\N
21532	424	3	0	98812	\N
21532	6320	4	1	98813	\N
21532	6319	4	0	98814	\N
21532	6321	5	1	98815	\N
21532	2922	5	0	98816	\N
21532	6322	6	1	98817	\N
21532	3268	6	0	98818	\N
21541	6325	108	0	98858	\N
21541	90	126	0	98867	\N
21541	6326	127	0	98868	\N
21543	391	7	0	97861	\N
21543	6327	8	0	98889	\N
21552	402	2	0	98924	\N
21552	3244	3	0	98925	\N
21559	6331	3	0	98964	\N
21559	6332	4	0	98965	\N
21564	4172	4	0	98990	\N
21564	4219	5	0	98991	\N
21566	62	4	0	98994	\N
21566	4059	5	0	98995	\N
21568	1021	3	0	98190	\N
21568	4551	4	0	98191	\N
21570	264	3	0	97822	\N
21570	3632	4	0	99005	\N
21575	402	3	0	98924	\N
21575	4077	4	0	99032	\N
21582	92	11	0	99066	\N
21582	6333	12	0	99067	\N
21584	102	3	0	98644	\N
21584	3597	4	0	99075	\N
21591	6337	106	0	99116	\N
21591	1636	126	0	99117	\N
21591	6266	127	0	99118	\N
21593	6339	6	0	99134	\N
21593	6340	7	0	99135	\N
21605	54	3	0	94128	\N
21605	3041	4	0	99168	\N
21606	2396	0	0	99169	\N
21606	6341	0	0	99170	\N
21608	4178	1	0	99003	\N
21608	4450	2	0	99174	\N
21613	181	3	0	99202	\N
21613	4184	4	0	99203	\N
21615	20	3	0	98186	\N
21615	2844	4	0	98187	\N
21622	4172	6	0	99153	\N
21622	4197	7	0	99232	\N
21625	360	6	0	93965	\N
21625	5788	7	0	99235	\N
21628	322	3	0	99297	\N
21628	1105	4	0	99298	\N
21631	4178	3	0	99328	\N
21631	4441	4	0	99329	\N
21635	149	5	0	99348	\N
21635	6348	6	0	99349	\N
21637	75	4	0	98433	\N
21637	172	5	0	99354	\N
21643	14	3	0	98953	\N
21643	4272	4	0	98954	\N
21645	71	5	0	99379	\N
21339	5514	4	0	97578	\N
21340	56	5	0	97589	\N
21340	6275	6	0	97590	\N
21350	326	4	0	97652	\N
21350	3519	5	0	97653	\N
21355	4233	4	0	97685	\N
21355	4234	5	0	97686	\N
21359	16	19	0	97513	\N
21359	5512	20	0	97757	\N
21362	5013	4	0	97775	\N
21362	102	7	0	97776	\N
21362	3574	8	0	97777	\N
21364	2575	4	0	97778	\N
21364	16	7	0	97779	\N
21364	2974	8	0	97780	\N
21366	4331	4	0	97785	\N
21366	4178	7	0	97786	\N
21366	4527	8	0	97297	\N
21371	58	6	0	97808	\N
21371	3575	7	0	97809	\N
21373	62	4	0	97818	\N
21373	4059	5	0	97819	\N
21376	264	4	0	97822	\N
21376	3684	5	0	97823	\N
21379	192	0	0	90441	\N
21383	391	7	0	97861	\N
21383	3662	8	0	97862	\N
21385	167	3	0	95395	\N
21385	4028	4	0	97871	\N
21387	167	3	0	95395	\N
21387	4028	4	0	97871	\N
21389	365	4	0	97880	\N
21389	3298	5	0	97881	\N
21394	4178	4	0	97392	\N
21394	4205	5	0	97957	\N
21396	58	3	0	97965	\N
21396	3665	4	0	97966	\N
21398	279	2	0	97970	\N
21398	4525	3	0	97971	\N
21402	110	11	0	97999	\N
21402	6287	12	0	98000	\N
21403	391	7	0	97861	\N
21403	6288	8	0	98015	\N
21406	2351	4	0	95241	\N
21406	3494	5	0	98028	\N
21412	92	3	0	98065	\N
21412	4410	4	0	98066	\N
21419	4172	3	0	98105	\N
21419	4275	4	0	98106	\N
21422	156	3	0	98122	\N
21422	4594	4	0	98123	\N
21434	94	6	0	83461	\N
21434	4696	7	0	98210	\N
21439	135	5	0	96301	\N
21439	3347	6	0	96346	\N
21445	2782	3	0	97994	\N
21445	3659	4	0	98121	\N
21448	4172	4	0	98141	\N
21448	4252	5	0	98327	\N
21457	14	7	0	98407	\N
21457	3882	8	0	98408	\N
21464	793	3	0	98442	\N
21464	2644	4	0	92236	\N
21467	140	10	0	97955	\N
21467	6305	11	0	98467	\N
21469	145	3	0	97450	\N
21469	4908	4	0	98475	\N
21473	4172	0	0	95190	\N
21484	459	2	0	93944	\N
21484	3860	3	0	95896	\N
21487	145	3	0	97450	\N
21487	4908	4	0	98475	\N
21494	75	2	0	98433	\N
21494	284	3	0	98578	\N
21499	1107	2	0	11004	\N
21499	6308	3	0	98606	\N
21504	145	2	0	97450	\N
21504	1108	3	0	98631	\N
21505	102	6	0	98644	\N
21505	6309	7	0	98645	\N
21507	208	4	0	61223	\N
21507	6311	5	0	98656	\N
21510	2782	7	0	98679	\N
21510	6312	8	0	98680	\N
21513	40	4	0	98613	\N
21513	3381	5	0	98704	\N
21516	123	3	0	98739	\N
21516	2856	4	0	98740	\N
21518	6317	46	0	98748	\N
21518	212	126	0	98749	\N
21518	6268	127	0	98750	\N
21520	316	4	0	91348	\N
21520	5437	5	0	98761	\N
21527	23	6	0	98795	\N
21527	4632	7	0	98796	\N
21534	595	3	0	98512	\N
21534	3654	4	0	98819	\N
21536	424	3	0	98812	\N
21536	3611	4	0	98822	\N
21540	241	2	0	96313	\N
21540	634	3	0	98834	\N
21545	4233	3	0	98898	\N
21545	4425	4	0	98899	\N
21547	1018	0	0	98902	\N
21547	6328	0	0	98903	\N
21551	4172	2	0	98702	\N
21551	4285	3	0	98923	\N
21557	108	3	0	98955	\N
21557	4171	4	0	98956	\N
21561	3625	3	0	93915	\N
21561	3784	4	0	94210	\N
21572	852	4	0	99014	\N
21572	4162	5	0	99015	\N
21574	391	6	0	99024	\N
21574	3521	7	0	99025	\N
21579	69	3	0	98926	\N
21579	4536	4	0	99041	\N
21581	431	1	0	99046	\N
21581	432	2	0	99047	\N
21586	132	3	0	99084	\N
21586	3729	4	0	99085	\N
21592	5215	4	0	99119	\N
21592	44	8	0	99120	\N
21592	6338	9	0	99121	\N
21597	4172	3	0	99145	\N
21597	4275	4	0	99146	\N
21599	4172	3	0	99153	\N
21599	4275	4	0	99154	\N
21602	132	3	0	99157	\N
21602	3729	4	0	99158	\N
21604	402	3	0	99166	\N
21604	4077	4	0	99167	\N
21610	242	5	0	96539	\N
21610	6342	6	0	99188	\N
21617	793	3	0	99212	\N
21617	2644	4	0	99213	\N
21619	18	0	0	99217	\N
21621	4178	4	0	99226	\N
21621	4331	5	0	99227	\N
21630	6044	3	0	99320	\N
21630	6045	4	0	99321	\N
21633	316	4	0	99335	\N
21633	2790	5	0	99336	\N
21647	1132	4	0	99411	\N
21647	77	9	0	99420	\N
21647	6352	10	0	99421	\N
21650	40	3	0	99430	\N
21650	372	4	0	99431	\N
21652	4787	3	0	99436	\N
21652	4788	4	0	99437	\N
21654	181	9	0	99202	\N
21654	6359	10	0	99471	\N
21659	102	3	0	99503	\N
21659	3597	4	0	99504	\N
21664	164	1	0	99527	\N
21664	165	2	0	99528	\N
21666	6362	89	0	99535	\N
21352	6277	7	0	97666	\N
21354	4233	4	0	97685	\N
21354	4234	5	0	97686	\N
21357	56	10	0	97715	\N
21357	4602	11	0	97716	\N
21358	18	7	0	97717	\N
21358	6278	8	0	97718	\N
21361	2796	4	0	97768	\N
21361	40	7	0	97773	\N
21361	3034	8	0	97774	\N
21368	189	4	0	94155	\N
21368	3992	5	0	97795	\N
21370	58	6	0	97808	\N
21370	3575	7	0	97809	\N
21372	192	4	0	90441	\N
21372	3895	5	0	97365	\N
21375	132	4	0	97820	\N
21375	3716	5	0	97821	\N
21378	192	0	0	90441	\N
21382	23	7	0	97859	\N
21382	4146	8	0	97860	\N
21384	300	3	0	97869	\N
21384	3747	4	0	97870	\N
21391	290	3	0	94509	\N
21391	3635	4	0	97896	\N
21393	140	4	0	97955	\N
21393	3821	5	0	97956	\N
21401	324	11	0	97650	\N
21401	6286	12	0	97998	\N
21405	336	4	0	98026	\N
21405	3947	5	0	98027	\N
21410	4178	3	0	98042	\N
21410	5202	4	0	98043	\N
21411	6291	106	0	98056	\N
21411	27	123	0	98057	\N
21411	1502	124	0	98058	\N
21417	6296	8	0	98098	\N
21417	151	13	0	98099	\N
21417	6297	14	0	98100	\N
21421	2782	3	0	97994	\N
21421	3659	4	0	98121	\N
21423	79	3	0	97613	\N
21423	3652	4	0	98130	\N
21426	4178	4	0	98042	\N
21426	4205	5	0	98143	\N
21429	4178	10	0	98178	\N
21429	4665	11	0	98179	\N
21432	1021	3	0	98190	\N
21432	4551	4	0	98191	\N
21433	73	3	0	96476	\N
21433	3040	4	0	96477	\N
21436	285	7	0	98226	\N
21436	5812	8	0	98227	\N
21444	100	6	0	98293	\N
21444	6298	7	0	98294	\N
21447	5024	5	0	98312	\N
21447	82	8	0	98317	\N
21447	4753	9	0	98318	\N
21450	285	11	0	98338	\N
21450	6299	12	0	98339	\N
21452	6044	3	0	97382	\N
21452	6045	4	0	98356	\N
21456	6301	42	0	98391	\N
21456	1675	43	0	21200	\N
21456	6302	43	0	98392	\N
21459	6303	3	0	98431	\N
21459	6304	4	0	98432	\N
21462	324	3	0	97650	\N
21462	4514	4	0	98441	\N
21471	14	3	0	98478	\N
21471	4272	4	0	98479	\N
21475	4172	0	0	95491	\N
21478	2	4	0	97380	\N
21478	3510	5	0	98511	\N
21482	214	4	0	98514	\N
21482	3807	5	0	98515	\N
21489	2575	4	0	98560	\N
21489	16	5	0	98561	\N
21492	2351	2	0	98574	\N
21492	2754	3	0	98575	\N
21496	113	5	0	95897	\N
21496	6307	6	0	98594	\N
21509	4178	3	0	98615	\N
21509	4211	4	0	98664	\N
21512	4172	4	0	98702	\N
21512	4219	5	0	98703	\N
21523	367	2	0	98770	\N
21523	3329	3	0	98771	\N
21529	88	3	0	98801	\N
21529	3655	4	0	98805	\N
21533	147	3	0	92000	\N
21533	3657	4	0	92001	\N
21538	6323	1	0	98831	\N
21538	6324	2	0	98832	\N
21542	79	10	0	98887	\N
21542	4707	11	0	98888	\N
21544	56	9	0	98890	\N
21544	5173	10	0	98891	\N
21550	4178	3	0	98820	\N
21550	4941	4	0	98918	\N
21556	14	3	0	98953	\N
21556	4272	4	0	98954	\N
21558	391	3	0	97861	\N
21558	3660	4	0	98963	\N
21563	3628	2	0	98982	\N
21563	4360	3	0	98983	\N
21567	264	2	0	97822	\N
21567	2780	3	0	99000	\N
21569	4178	3	0	99003	\N
21569	4211	4	0	99004	\N
21571	90	2	0	96353	\N
21571	3039	3	0	99006	\N
21577	60	3	0	95733	\N
21577	3585	4	0	99033	\N
21578	69	1	0	98926	\N
21578	70	2	0	99036	\N
21580	391	8	0	99042	\N
21580	3922	9	0	99043	\N
21583	4787	11	0	95127	\N
21583	6334	12	0	99068	\N
21588	156	3	0	99094	\N
21588	4594	4	0	99095	\N
21590	4252	4	0	99104	\N
21590	4172	8	0	99110	\N
21590	6322	11	0	99115	\N
21595	35	6	0	98476	\N
21595	5084	7	0	99138	\N
21601	453	3	0	99155	\N
21601	2838	4	0	99156	\N
21603	54	2	0	94128	\N
21603	3351	3	0	96076	\N
21609	200	3	0	99179	\N
21609	3338	4	0	99180	\N
21612	173	3	0	95782	\N
21612	3796	4	0	99195	\N
21618	6343	62	0	99214	\N
21618	488	126	0	99215	\N
21618	6344	127	0	99216	\N
21624	262	6	0	98463	\N
21624	4248	7	0	99234	\N
21626	6345	107	0	99278	\N
21626	360	126	0	99287	\N
21626	6346	127	0	99288	\N
21627	4178	2	0	99226	\N
21627	4247	3	0	99293	\N
21634	290	4	0	99330	\N
21634	2759	5	0	99337	\N
21639	230	5	0	97090	\N
21639	3389	6	0	99363	\N
21641	110	3	0	99377	\N
21641	2995	4	0	99378	\N
21644	14	5	0	98953	\N
21644	6351	6	0	99393	\N
21590	6336	9	1	138672	\N
21590	5963	10	0	138673	\N
21587	4233	3	0	99092	\N
21587	4425	4	0	99093	\N
21589	75	3	0	98433	\N
21589	3855	4	0	98434	\N
21594	18	2	0	99136	\N
21594	3817	3	0	99137	\N
21596	6339	6	0	99134	\N
21596	6340	7	0	99135	\N
21598	115	3	0	97427	\N
21598	3483	4	0	97428	\N
21600	181	3	0	97415	\N
21600	4184	4	0	97416	\N
21607	290	3	0	98900	\N
21607	3635	4	0	99171	\N
21611	4172	3	0	99153	\N
21611	4275	4	0	99154	\N
21614	40	3	0	99204	\N
21614	372	4	0	99205	\N
21616	16	3	0	98829	\N
21616	3634	4	0	98830	\N
21620	75	0	0	96097	\N
21623	360	4	0	93965	\N
21623	4330	5	0	99233	\N
21629	132	8	0	99157	\N
21629	6347	9	0	99313	\N
21632	290	3	0	99330	\N
21632	504	4	0	99331	\N
21636	149	6	0	99348	\N
21636	6349	7	0	99353	\N
21638	230	4	0	97090	\N
21638	3954	5	0	99360	\N
21640	300	4	0	97869	\N
21640	6350	5	0	99370	\N
21642	71	3	0	99379	\N
21642	3770	4	0	99380	\N
21653	6357	91	0	99450	\N
21653	435	126	0	99451	\N
21653	6358	127	0	99452	\N
21656	4172	3	0	99153	\N
21656	4275	4	0	99154	\N
21663	4172	4	0	99523	\N
21663	4252	5	0	99524	\N
21668	69	6	0	99544	\N
21668	4084	7	0	99550	\N
21675	110	3	0	99581	\N
21675	2995	4	0	99582	\N
21677	273	4	0	99592	\N
21677	3390	5	0	99593	\N
21680	12	14	0	99608	\N
21680	3459	15	0	99615	\N
21689	453	5	0	99155	\N
21689	6370	6	0	99723	\N
21691	6375	9	0	99751	\N
21691	42	12	0	99752	\N
21691	3440	13	0	99753	\N
21700	82	2	0	99795	\N
21700	3401	3	0	99796	\N
21702	4178	3	0	99328	\N
21702	4211	4	0	99805	\N
21703	40	12	0	99430	\N
21703	5640	13	0	99830	\N
21705	123	3	0	99835	\N
21705	2856	4	0	99840	\N
21708	117	3	0	93309	\N
21708	3653	4	0	99866	\N
21726	6303	2	0	99973	\N
21726	6381	3	0	99974	\N
21732	212	0	0	99984	\N
21736	140	9	0	100087	\N
21736	6384	10	0	100088	\N
21739	16	6	0	99956	\N
21739	3369	7	0	100117	\N
21741	135	6	0	100119	\N
21741	6389	7	0	100120	\N
21750	44	3	0	97417	\N
21750	3631	4	0	97418	\N
21754	12	7	0	100202	\N
21754	6391	8	0	100203	\N
21756	132	3	0	100211	\N
21756	3729	4	0	100212	\N
21763	16	4	0	99956	\N
21763	3546	5	0	100252	\N
21768	42	6	0	100278	\N
21768	1090	7	0	100279	\N
21770	64	3	0	100288	\N
21770	4217	4	0	100289	\N
21773	132	3	0	100211	\N
21773	3729	4	0	100212	\N
21784	251	2	0	100398	\N
21784	1851	3	0	100399	\N
21785	121	3	0	93181	\N
21785	4471	4	0	100396	\N
21788	3522	3	0	48166	\N
21788	6397	3	0	100414	\N
21788	3526	4	1	100415	\N
21788	6398	4	0	100416	\N
21790	189	8	0	98480	\N
21790	3953	9	0	100435	\N
21795	6402	39	0	100497	\N
21795	100	126	0	100500	\N
21795	6403	127	0	100501	\N
21798	4172	6	0	100541	\N
21798	4197	7	0	100542	\N
21802	4172	6	0	100564	\N
21802	4197	7	0	100565	\N
21805	164	6	0	100569	\N
21805	3583	7	0	100570	\N
21813	4172	6	0	100564	\N
21813	4197	7	0	100565	\N
21818	4787	6	0	99436	\N
21818	5075	7	0	100649	\N
21824	1470	6	0	97558	\N
21824	6409	7	0	100704	\N
21832	2351	2	0	98574	\N
21832	2754	3	0	98575	\N
21834	56	2	0	100763	\N
21834	2795	3	0	100764	\N
21837	38	3	0	96638	\N
21837	3457	4	0	100791	\N
21840	16	3	0	100725	\N
21840	3634	4	0	100808	\N
21844	132	6	0	100211	\N
21844	4690	7	0	100829	\N
21846	6413	91	0	100832	\N
21846	435	126	0	100833	\N
21846	6358	127	0	100834	\N
21851	156	3	0	100262	\N
21851	4594	4	0	100263	\N
21854	202	9	0	100890	\N
21854	3798	10	0	100891	\N
21860	449	3	0	95763	\N
21860	4760	4	0	100912	\N
21863	79	3	0	100933	\N
21863	3652	4	0	100934	\N
21865	4823	3	0	100944	\N
21865	6	4	0	100945	\N
21868	4272	3	0	100941	\N
21868	14	4	0	100949	\N
21873	235	8	0	97996	\N
21873	6424	9	0	100996	\N
21875	6425	18	0	101002	\N
21875	1109	19	0	101003	\N
21883	4172	3	0	101050	\N
21883	4275	4	0	101051	\N
21885	411	3	0	101060	\N
21885	3596	4	0	101061	\N
21888	4172	3	0	101050	\N
21888	4275	4	0	101051	\N
21897	16	3	0	101093	\N
21897	3634	4	0	101094	\N
21899	71	6	0	100131	\N
21899	4738	7	0	101123	\N
21904	96	3	0	101141	\N
21904	2803	4	0	101142	\N
21906	79	3	0	101184	\N
21906	3652	4	0	101185	\N
21911	2351	3	0	98574	\N
21645	4033	6	0	99402	\N
21648	4172	3	0	99153	\N
21648	4275	4	0	99154	\N
21657	1021	4	0	98190	\N
21657	6360	5	0	99487	\N
21660	33	2	0	99509	\N
21660	2822	3	0	99510	\N
21662	33	3	0	99509	\N
21662	3342	4	0	99514	\N
21665	164	3	0	99527	\N
21665	3385	4	0	99533	\N
21669	4233	6	0	99092	\N
21669	6364	7	0	99551	\N
21671	102	6	0	99565	\N
21671	5086	7	0	99566	\N
21676	18	0	0	99583	\N
21678	56	3	0	99600	\N
21678	4109	4	0	99601	\N
21682	56	3	0	99695	\N
21682	4109	4	0	99696	\N
21683	3625	4	0	93915	\N
21683	6161	5	0	95124	\N
21686	119	1	0	98980	\N
21686	891	2	0	99709	\N
21694	3625	6	0	93915	\N
21694	3642	7	0	99774	\N
21704	123	2	0	99835	\N
21704	1868	3	0	99836	\N
21707	79	8	0	99851	\N
21707	6378	9	0	99859	\N
21710	290	5	0	99330	\N
21710	6379	6	0	99879	\N
21714	16	6	0	99472	\N
21714	3369	7	0	99904	\N
21717	16	12	0	99472	\N
21717	4890	13	0	99931	\N
21720	2636	3	0	99954	\N
21720	2837	4	0	99955	\N
21722	4178	3	0	99877	\N
21722	4211	4	0	99964	\N
21729	4178	0	0	99982	\N
21733	6382	40	0	100017	\N
21733	391	126	0	100068	\N
21733	6383	127	0	100069	\N
21734	140	9	0	100087	\N
21734	6384	10	0	100088	\N
21738	4178	6	0	100115	\N
21738	4250	7	0	100116	\N
21740	137	6	0	93046	\N
21740	6388	7	0	100118	\N
21743	326	3	0	100129	\N
21743	3339	4	0	100130	\N
21747	40	3	0	100146	\N
21747	372	4	0	100147	\N
21749	88	3	0	100154	\N
21749	3655	4	0	100155	\N
21752	12	3	0	100164	\N
21752	4204	4	0	100165	\N
21755	4172	3	0	99971	\N
21755	4275	4	0	100210	\N
21760	40	2	0	100239	\N
21760	282	3	0	100240	\N
21762	75	3	0	99890	\N
21762	3855	4	0	100245	\N
21767	60	6	0	100276	\N
21767	6394	7	0	100277	\N
21777	324	6	0	97650	\N
21777	5241	7	0	100379	\N
21779	242	3	0	99797	\N
21779	2839	4	0	99798	\N
21791	4178	7	0	100433	\N
21791	6399	8	0	100450	\N
21793	94	7	0	100280	\N
21793	6401	8	0	100483	\N
21799	841	6	0	100543	\N
21799	3769	7	0	100544	\N
21803	40	6	0	100566	\N
21803	4255	7	0	100567	\N
21809	35	3	0	100597	\N
21809	3563	4	0	100598	\N
21811	1858	3	0	100607	\N
21811	4273	4	0	100608	\N
21814	149	6	0	100621	\N
21814	4737	7	0	100622	\N
21816	4178	6	0	100433	\N
21816	4250	7	0	100568	\N
21819	2	6	0	100662	\N
21819	4825	7	0	100663	\N
21822	117	12	0	100689	\N
21822	6407	13	0	100690	\N
21825	5885	6	0	100717	\N
21825	5997	7	0	100718	\N
21833	4172	2	0	100564	\N
21833	4191	3	0	100762	\N
21835	79	6	0	100777	\N
21835	4253	7	0	100778	\N
21841	233	3	0	100809	\N
21841	3704	4	0	100810	\N
21845	241	6	0	100830	\N
21845	6412	7	0	100831	\N
21847	40	9	0	100566	\N
21847	4712	10	0	100853	\N
21849	75	9	0	99890	\N
21849	4685	10	0	100856	\N
21861	365	3	0	100605	\N
21861	3839	4	0	100606	\N
21866	6	1	0	100947	\N
21866	2261	2	0	100948	\N
21870	1009	12	0	100951	\N
21870	42	123	0	100968	\N
21870	6417	124	1	100969	\N
21870	6416	124	0	100970	\N
21870	4952	125	1	100971	\N
21870	6418	125	0	100972	\N
21870	4916	126	1	100973	\N
21870	6419	126	0	100974	\N
21870	4098	127	0	100975	\N
21874	235	8	0	97996	\N
21874	6424	9	0	100996	\N
21876	4178	3	0	100900	\N
21876	4211	4	0	100901	\N
21878	4172	3	0	100806	\N
21878	4275	4	0	100807	\N
21884	16	3	0	101052	\N
21884	3634	4	0	101053	\N
21886	451	3	0	101068	\N
21886	3934	4	0	101069	\N
21889	145	3	0	99791	\N
21889	4908	4	0	99792	\N
21893	4178	3	0	101091	\N
21893	4211	4	0	101092	\N
21895	459	4	0	101101	\N
21895	6428	5	0	101102	\N
21900	40	3	0	100566	\N
21900	372	4	0	101130	\N
21902	316	3	0	101133	\N
21902	4249	4	0	101134	\N
21907	365	6	0	101198	\N
21907	4759	7	0	101199	\N
21909	208	6	0	99905	\N
21909	5118	7	0	99906	\N
21914	56	1	0	100763	\N
21914	1088	2	0	101226	\N
21916	93	2	0	101231	\N
21916	92	7	0	101240	\N
21916	6430	8	0	101241	\N
21919	841	6	0	100543	\N
21919	3769	7	0	100544	\N
21923	23	21	0	101312	\N
21923	6432	22	0	101313	\N
21929	2782	2	0	101327	\N
21929	2784	3	0	101330	\N
21932	4178	2	0	101091	\N
21932	4247	3	0	101347	\N
21937	734	3	0	101357	\N
21937	5037	4	0	101358	\N
21943	16	7	0	101380	\N
21646	1132	4	0	99411	\N
21646	77	9	0	99420	\N
21646	6352	10	0	99421	\N
21649	102	3	0	99428	\N
21649	3597	4	0	99429	\N
21651	6353	3	0	99432	\N
21651	6354	3	0	99433	\N
21655	16	9	0	99472	\N
21655	3636	10	0	99473	\N
21658	4	4	0	99495	\N
21658	6361	5	0	99496	\N
21661	33	3	0	99509	\N
21661	3342	4	0	99514	\N
21667	69	4	0	99544	\N
21667	3564	5	0	99545	\N
21670	453	6	0	99155	\N
21670	4091	7	0	99552	\N
21672	102	0	0	99503	\N
21674	60	3	0	95733	\N
21674	3585	4	0	99033	\N
21679	12	3	0	99608	\N
21679	4204	4	0	99609	\N
21684	23	4	0	99705	\N
21684	6367	5	0	99706	\N
21687	119	1	0	98980	\N
21687	891	2	0	99709	\N
21695	119	4	0	98980	\N
21695	4373	5	0	99775	\N
21697	2	5	0	97380	\N
21697	6376	6	0	99784	\N
21699	316	3	0	99793	\N
21699	4249	4	0	99794	\N
21701	242	3	0	99797	\N
21701	2839	4	0	99798	\N
21712	411	3	0	99887	\N
21712	3596	4	0	99888	\N
21715	208	6	0	99905	\N
21715	5118	7	0	99906	\N
21718	3101	3	0	99938	\N
21718	6380	4	0	99939	\N
21721	16	3	0	99956	\N
21721	3634	4	0	99957	\N
21723	290	3	0	99965	\N
21723	3635	4	0	99966	\N
21725	4172	2	0	99971	\N
21725	4285	3	0	99972	\N
21730	151	0	0	99983	\N
21735	264	9	0	100089	\N
21735	6385	10	0	100090	\N
21737	6386	62	0	100099	\N
21737	488	126	0	100100	\N
21737	4952	127	1	100101	\N
21737	6387	127	0	100102	\N
21744	71	3	0	100131	\N
21744	3770	4	0	100132	\N
21748	16	3	0	99956	\N
21748	3634	4	0	99957	\N
21758	4233	3	0	100227	\N
21758	4425	4	0	100228	\N
21761	4172	3	0	100243	\N
21761	4275	4	0	100244	\N
21764	18	0	0	100253	\N
21765	348	3	0	100260	\N
21765	6393	4	0	100261	\N
21772	264	3	0	100089	\N
21772	3632	4	0	100298	\N
21774	4178	3	0	100305	\N
21774	4211	4	0	100306	\N
21775	16	9	0	100325	\N
21775	3636	10	0	100326	\N
21781	33	3	0	100394	\N
21781	3342	4	0	100395	\N
21787	90	3	0	96353	\N
21787	4074	4	0	100413	\N
21792	125	68	0	95030	\N
21792	6400	69	0	100482	\N
21797	285	6	0	100392	\N
21797	3903	7	0	100540	\N
21800	18	0	0	100545	\N
21801	224	3	0	93306	\N
21801	3603	4	0	93311	\N
21806	164	12	0	100569	\N
21806	6405	13	0	100575	\N
21808	244	6	0	97431	\N
21808	6406	7	0	100590	\N
21810	365	3	0	100605	\N
21810	3839	4	0	100606	\N
21812	1858	3	0	100607	\N
21812	4273	4	0	100608	\N
21820	793	6	0	99212	\N
21820	3719	7	0	100664	\N
21827	208	6	0	99905	\N
21827	5118	7	0	99906	\N
21829	167	6	0	100737	\N
21829	5066	7	0	100738	\N
21839	4172	3	0	100806	\N
21839	4275	4	0	100807	\N
21843	326	3	0	100129	\N
21843	3339	4	0	100130	\N
21848	58	9	0	100854	\N
21848	3755	10	0	100855	\N
21850	113	3	0	95897	\N
21850	3620	4	0	100863	\N
21853	4178	9	0	100888	\N
21853	4682	10	0	100889	\N
21856	208	9	0	99905	\N
21856	4893	10	0	100893	\N
21858	251	3	0	100902	\N
21858	3514	4	0	100903	\N
21862	453	3	0	100925	\N
21862	2838	4	0	100926	\N
21869	42	0	0	100950	\N
21872	6422	0	0	100982	\N
21872	6423	0	0	100983	\N
21877	1163	3	0	101010	\N
21877	6426	4	0	101011	\N
21880	208	6	0	99905	\N
21880	5118	7	0	99906	\N
21882	198	6	0	101042	\N
21882	5565	7	0	101043	\N
21887	67	3	0	101076	\N
21887	3749	4	0	101077	\N
21892	33	3	0	100394	\N
21892	3342	4	0	100395	\N
21896	4178	3	0	101091	\N
21896	4211	4	0	101092	\N
21901	132	3	0	101131	\N
21901	3729	4	0	101132	\N
21903	96	3	0	101141	\N
21903	2803	4	0	101142	\N
21905	126	3	0	101143	\N
21905	125	126	0	101175	\N
21905	1075	127	1	101176	\N
21905	6429	127	0	101177	\N
21908	279	6	0	101200	\N
21908	5117	7	0	101201	\N
21910	75	3	0	101208	\N
21910	3855	4	0	101209	\N
21915	93	2	0	101231	\N
21915	92	7	0	101240	\N
21915	6430	8	0	101241	\N
21917	4102	2	0	101242	\N
21917	56	3	0	101243	\N
21924	367	3	0	98770	\N
21924	3683	4	0	98772	\N
21927	2782	3	0	101327	\N
21927	3659	4	0	101328	\N
21931	156	5	0	101341	\N
21931	4295	6	0	101342	\N
21934	214	2	0	98514	\N
21934	1259	3	0	101350	\N
21936	4088	3	0	94310	\N
21936	4506	4	0	96272	\N
21940	137	3	0	93046	\N
21940	3633	4	0	93047	\N
21666	164	126	0	99536	\N
21666	6363	127	0	99537	\N
21673	77	3	0	99573	\N
21673	1877	4	0	99574	\N
21681	6365	40	0	99629	\N
21681	391	126	0	99688	\N
21681	6366	127	0	99689	\N
21685	3628	4	0	99707	\N
21685	6368	5	0	99708	\N
21688	3628	7	0	99707	\N
21688	6369	8	0	99717	\N
21690	6371	9	0	99742	\N
21690	149	12	0	99747	\N
21690	6373	13	1	99748	\N
21690	6372	13	0	99749	\N
21690	6374	14	0	99750	\N
21692	6371	9	0	99742	\N
21692	149	12	0	99747	\N
21692	5008	13	0	99754	\N
21693	88	3	0	98992	\N
21693	3655	4	0	99761	\N
21696	3628	6	0	99776	\N
21696	3643	7	0	99777	\N
21698	145	3	0	99791	\N
21698	4908	4	0	99792	\N
21706	79	5	0	99851	\N
21706	6377	6	0	99852	\N
21709	4178	5	0	99877	\N
21709	4429	6	0	99878	\N
21711	290	3	0	99330	\N
21711	504	4	0	99331	\N
21713	75	2	0	99890	\N
21713	284	3	0	99891	\N
21716	279	6	0	97970	\N
21716	5117	7	0	98211	\N
21719	40	3	0	99946	\N
21719	372	4	0	99947	\N
21724	322	3	0	99297	\N
21724	1105	4	0	99298	\N
21727	20	2	0	98186	\N
21727	3111	3	0	99975	\N
21728	102	2	0	99980	\N
21728	3574	3	0	99981	\N
21731	214	0	0	98514	\N
21742	73	3	0	100127	\N
21742	3040	4	0	100128	\N
21745	23	3	0	99705	\N
21745	3497	4	0	100133	\N
21746	322	3	0	99297	\N
21746	1105	4	0	99298	\N
21751	4233	3	0	100162	\N
21751	4425	4	0	100163	\N
21753	6390	100	0	100200	\N
21753	4233	101	0	100201	\N
21757	6099	3	0	100219	\N
21757	4410	4	0	100220	\N
21759	4233	9	0	100233	\N
21759	6392	10	0	100234	\N
21766	156	3	0	100262	\N
21766	4594	4	0	100263	\N
21769	94	6	0	100280	\N
21769	4696	7	0	100281	\N
21771	198	3	0	100290	\N
21771	4263	4	0	100291	\N
21776	6395	40	0	100354	\N
21776	391	70	0	100367	\N
21776	6396	71	0	100368	\N
21780	285	3	0	100392	\N
21780	4496	4	0	100393	\N
21783	121	3	0	93181	\N
21783	4471	4	0	100396	\N
21786	3340	2	0	100402	\N
21786	108	4	0	100405	\N
21786	3022	5	0	100406	\N
21789	4178	8	0	100433	\N
21789	4218	9	0	100434	\N
21794	4172	6	0	100243	\N
21794	4197	7	0	100496	\N
21796	1525	13	0	100502	\N
21796	100	121	0	100531	\N
21796	6404	122	0	100532	\N
21804	4178	6	0	100433	\N
21804	4250	7	0	100568	\N
21807	94	6	0	100588	\N
21807	4696	7	0	100589	\N
21817	273	6	0	100635	\N
21817	4212	7	0	100636	\N
21823	4172	12	0	100564	\N
21823	6408	13	0	100691	\N
21826	279	6	0	100719	\N
21826	5117	7	0	100720	\N
21828	16	2	0	100725	\N
21828	2974	3	0	100726	\N
21831	44	9	0	97417	\N
21831	3765	10	0	100757	\N
21836	6410	112	0	100783	\N
21836	38	119	0	100784	\N
21836	6411	120	1	100785	\N
21836	1970	120	0	100786	\N
21838	264	3	0	100798	\N
21838	3632	4	0	100799	\N
21842	4088	3	0	94310	\N
21842	4506	4	0	96272	\N
21852	113	3	0	95897	\N
21852	3620	4	0	100863	\N
21855	279	9	0	100719	\N
21855	4892	10	0	100892	\N
21857	4178	3	0	100900	\N
21857	4211	4	0	100901	\N
21859	206	3	0	100904	\N
21859	4584	4	0	100905	\N
21864	4272	3	0	100941	\N
21864	6414	4	0	100942	\N
21864	6415	4	0	100943	\N
21867	4272	3	0	100941	\N
21867	14	4	0	100949	\N
21871	6025	11	1	100976	\N
21871	6420	11	0	100977	\N
21871	3108	12	1	93812	\N
21871	3013	12	0	100978	\N
21871	42	34	0	100979	\N
21871	1075	35	1	100980	\N
21871	6421	35	0	100981	\N
21879	279	6	0	100719	\N
21879	5117	7	0	100720	\N
21891	33	2	0	100394	\N
21891	6427	3	0	101088	\N
21894	16	3	0	101093	\N
21894	3634	4	0	101094	\N
21898	173	6	0	101121	\N
21898	3606	7	0	101122	\N
21912	2351	0	0	98574	\N
21920	40	6	0	100566	\N
21920	4255	7	0	100567	\N
21926	58	3	0	100854	\N
21926	3665	4	0	101326	\N
21930	137	3	0	93046	\N
21930	3633	4	0	93047	\N
21933	16	2	0	101348	\N
21933	388	3	0	101349	\N
21938	233	3	0	100809	\N
21938	3704	4	0	100810	\N
21939	135	3	0	100119	\N
21939	3630	4	0	101329	\N
21941	4172	3	0	101365	\N
21941	4275	4	0	101366	\N
21944	75	3	0	101388	\N
21944	3855	4	0	101389	\N
21947	16	3	0	101398	\N
21947	3634	4	0	101399	\N
21951	1021	9	0	101427	\N
21951	6433	10	0	101428	\N
21954	336	0	0	98026	\N
21957	79	9	0	101477	\N
21957	3758	10	0	101478	\N
21959	242	9	0	101481	\N
21959	6434	10	0	101482	\N
21911	2845	4	0	101216	\N
21913	14	3	0	101223	\N
21913	4272	4	0	100949	\N
21918	73	6	0	100127	\N
21918	4257	7	0	101256	\N
21921	841	4	0	100543	\N
21921	6431	5	0	101269	\N
21925	4178	3	0	101091	\N
21925	4211	4	0	101092	\N
21928	135	3	0	100119	\N
21928	3630	4	0	101329	\N
21945	4172	3	0	101396	\N
21945	4275	4	0	101397	\N
21950	4178	9	0	101091	\N
21950	4682	10	0	101426	\N
21953	4178	6	0	101455	\N
21953	4250	7	0	101456	\N
21956	79	9	0	101477	\N
21956	3758	10	0	101478	\N
21958	75	9	0	101479	\N
21958	4685	10	0	101480	\N
21964	40	3	0	101502	\N
21964	372	4	0	101503	\N
21965	2782	3	0	101504	\N
21965	3659	4	0	101505	\N
21968	2782	6	0	101504	\N
21968	5009	7	0	101511	\N
21969	228	0	0	101512	\N
21971	228	0	0	101512	\N
21974	908	6	0	95759	\N
21974	3555	7	0	101529	\N
21976	908	6	0	95759	\N
21976	3555	7	0	101529	\N
21978	142	3	0	101536	\N
21978	4254	4	0	101537	\N
21987	264	3	0	101583	\N
21987	3632	4	0	101584	\N
21990	54	3	0	94128	\N
21990	3041	4	0	99168	\N
21997	4178	3	0	101651	\N
21997	4211	4	0	101652	\N
21999	126	3	0	101655	\N
21999	125	126	0	101691	\N
21999	1075	127	1	101692	\N
21999	6439	127	0	101693	\N
22004	56	3	0	101614	\N
22004	4109	4	0	101615	\N
22009	26	1	0	97381	\N
22009	2	4	0	101750	\N
22009	2990	5	0	101499	\N
22011	455	1	0	101751	\N
22011	132	4	0	101753	\N
22011	2927	5	0	101132	\N
22018	233	4	0	100809	\N
22018	3775	5	0	101779	\N
22022	4172	3	0	101611	\N
22022	4275	4	0	101612	\N
22024	123	3	0	101798	\N
22024	2856	4	0	101799	\N
22029	228	2	0	101512	\N
22029	4776	3	0	101819	\N
22032	4178	2	0	101834	\N
22032	4247	3	0	101856	\N
22034	75	3	0	101491	\N
22034	3855	4	0	101492	\N
22039	4178	2	0	101834	\N
22039	4247	3	0	101856	\N
22042	56	4	0	101950	\N
22042	3127	5	0	101951	\N
22045	18	14	0	97717	\N
22045	1513	15	0	101987	\N
22049	1470	4	0	102002	\N
22049	5655	5	0	102003	\N
22056	324	0	0	101506	\N
22058	4172	3	0	102039	\N
22058	4275	4	0	102040	\N
22060	1098	3	0	102043	\N
22060	6446	4	0	102044	\N
22061	20	10	0	98186	\N
22061	6447	11	0	102065	\N
22068	2	6	0	102104	\N
22068	4825	7	0	102105	\N
22076	322	6	0	101653	\N
22076	6453	7	0	102139	\N
22077	16	6	0	101398	\N
22077	3369	7	0	102152	\N
22082	56	69	0	101950	\N
22082	6454	70	0	102214	\N
22091	241	2	0	102247	\N
22091	2923	3	0	102253	\N
22092	6456	9	0	102270	\N
22092	23	15	0	102280	\N
22092	3227	16	0	102281	\N
22094	16	3	0	102290	\N
22094	3634	4	0	102291	\N
22097	92	3	0	102316	\N
22097	4410	4	0	102317	\N
22100	719	7	0	102335	\N
22100	6458	8	0	102336	\N
22102	16	3	0	102290	\N
22102	3634	4	0	102291	\N
22108	4172	3	0	102423	\N
22108	4275	4	0	102424	\N
22110	198	3	0	102427	\N
22110	4263	4	0	102428	\N
22118	5233	7	0	102515	\N
22118	1470	8	0	102516	\N
22123	4172	3	0	102543	\N
22123	4275	4	0	102544	\N
22131	64	6	0	100288	\N
22131	5183	7	0	102602	\N
22139	224	3	0	102332	\N
22139	3603	4	0	102658	\N
22142	6471	5	0	102685	\N
22145	300	7	0	102682	\N
22145	5054	8	0	102691	\N
22146	4178	4	0	102700	\N
22146	4205	5	0	102701	\N
22149	4178	3	0	102730	\N
22149	4211	4	0	102731	\N
22152	54	10	0	102761	\N
22152	6472	11	0	102762	\N
22155	54	10	0	102761	\N
22155	6472	11	0	102762	\N
22158	4178	2	0	102774	\N
22158	4247	3	0	102775	\N
22163	4787	13	0	102806	\N
22163	6479	14	0	102807	\N
22165	4787	3	0	102806	\N
22165	4788	4	0	102810	\N
22168	173	5	0	102547	\N
22168	6480	6	0	102825	\N
22172	235	4	0	102870	\N
22172	3615	5	0	102871	\N
22178	241	6	0	102934	\N
22178	6412	7	0	102935	\N
22186	113	3	0	103008	\N
22186	3620	4	0	103009	\N
22191	40	4	0	103052	\N
22191	3381	5	0	103053	\N
22194	4178	4	0	103079	\N
22194	4205	5	0	103080	\N
22199	1558	6	0	103109	\N
22199	1021	126	0	103152	\N
22199	6488	127	0	103153	\N
22204	75	4	0	103185	\N
22204	3959	5	0	103186	\N
22206	4233	3	0	103166	\N
22206	4425	4	0	103203	\N
22209	4172	10	0	103257	\N
22209	4663	11	0	103258	\N
22213	336	9	0	103295	\N
22213	3568	10	0	103296	\N
22215	125	3	0	95030	\N
22215	4170	4	0	95082	\N
22216	40	0	0	100566	\N
21942	4178	3	0	101091	\N
21942	4211	4	0	101092	\N
21949	23	3	0	101400	\N
21949	3497	4	0	101407	\N
21955	4178	9	0	101475	\N
21955	4682	10	0	101476	\N
21962	2	3	0	100662	\N
21962	3548	4	0	101499	\N
21966	324	3	0	101506	\N
21966	4514	4	0	101507	\N
21970	228	0	0	101512	\N
21973	119	4	0	101527	\N
21973	4373	5	0	101528	\N
21975	3628	6	0	99776	\N
21975	3643	7	0	99777	\N
21981	6436	64	0	101541	\N
21981	142	126	0	101542	\N
21981	6437	127	0	101543	\N
21983	6303	6	0	101557	\N
21983	6438	7	0	101558	\N
21988	40	2	0	101589	\N
21988	282	3	0	101590	\N
21992	4178	3	0	101475	\N
21992	4211	4	0	101613	\N
21993	56	3	0	101614	\N
21993	4109	4	0	101615	\N
21996	67	3	0	101643	\N
21996	3749	4	0	101644	\N
22001	4178	3	0	101702	\N
22001	4211	4	0	101703	\N
22012	4172	3	0	101611	\N
22012	4275	4	0	101612	\N
22015	2782	3	0	101504	\N
22015	3659	4	0	101505	\N
22017	4088	4	0	94310	\N
22017	4089	5	0	101778	\N
22020	279	4	0	101781	\N
22020	3502	5	0	101782	\N
22025	123	1	0	101798	\N
22025	124	2	0	101800	\N
22028	230	3	0	101813	\N
22028	4181	4	0	101814	\N
22031	54	14	0	101850	\N
22031	2868	15	0	101851	\N
22033	214	3	0	98514	\N
22033	3496	4	0	101860	\N
22035	360	4	0	93965	\N
22035	3513	5	0	101869	\N
22040	113	4	0	101938	\N
22040	3677	5	0	101939	\N
22046	230	3	0	101813	\N
22046	4181	4	0	101814	\N
22051	6422	0	0	100982	\N
22051	6445	0	0	102004	\N
22052	1470	4	0	102002	\N
22052	5655	5	0	102003	\N
22055	170	3	0	102021	\N
22055	4148	4	0	102022	\N
22057	75	4	0	102031	\N
22057	3959	5	0	102032	\N
22062	4172	3	0	102039	\N
22062	4275	4	0	102040	\N
22067	73	3	0	102088	\N
22067	3040	4	0	102091	\N
22074	6451	7	0	102137	\N
22081	40	3	0	102175	\N
22081	372	4	0	102176	\N
22090	241	2	0	102247	\N
22090	634	3	0	102248	\N
22093	4233	3	0	102288	\N
22093	4425	4	0	102289	\N
22099	2578	7	0	96158	\N
22099	6457	8	0	102334	\N
22104	149	7	0	102385	\N
22104	5255	8	0	102386	\N
22107	156	8	0	102415	\N
22107	6460	9	0	102416	\N
22116	4172	5	0	102423	\N
22116	4644	6	0	102478	\N
22119	5233	7	0	102515	\N
22119	1470	8	0	102516	\N
22125	173	3	0	102547	\N
22125	3796	4	0	102548	\N
22126	1890	4	0	102557	\N
22126	6465	5	0	102558	\N
22129	75	7	0	102587	\N
22129	2859	8	0	102588	\N
22132	42	6	0	102603	\N
22132	1090	7	0	102604	\N
22135	597	4	0	92732	\N
22135	3733	5	0	92733	\N
22137	189	10	0	102636	\N
22137	6468	11	0	102637	\N
22141	300	11	0	102682	\N
22141	6470	12	0	102683	\N
22147	156	3	0	102425	\N
22147	4594	4	0	102426	\N
22150	14	3	0	102738	\N
22150	4272	4	0	102739	\N
22154	1171	10	0	45391	\N
22154	6477	11	0	102768	\N
22160	16	5	0	102787	\N
22160	5175	6	0	102788	\N
22162	16	3	0	102787	\N
22162	3634	4	0	102797	\N
22166	2	5	0	102821	\N
22166	4304	6	0	102822	\N
22171	451	3	0	102468	\N
22171	3934	4	0	102861	\N
22174	228	7	0	102894	\N
22174	5491	8	0	102895	\N
22176	258	3	0	102904	\N
22176	4401	4	0	102905	\N
22182	40	6	0	102395	\N
22182	4255	7	0	102966	\N
22187	4178	5	0	102823	\N
22187	4202	6	0	103020	\N
22190	264	3	0	103042	\N
22190	3632	4	0	103043	\N
22200	2	6	0	103164	\N
22200	4825	7	0	103165	\N
22205	908	4	0	103195	\N
22205	3488	5	0	103196	\N
22214	113	9	0	103293	\N
22214	6490	10	0	103294	\N
22217	140	8	0	103319	\N
22217	6491	9	0	103320	\N
22219	40	0	0	100566	\N
22225	12	3	0	103346	\N
22225	4204	4	0	103353	\N
22228	4172	5	0	103351	\N
22228	4634	6	0	103364	\N
22231	6495	47	0	103385	\N
22231	6303	70	0	103395	\N
22231	6496	71	0	103396	\N
22236	108	8	0	101573	\N
22236	6500	9	0	103442	\N
22251	75	6	0	103185	\N
22251	4694	7	0	103529	\N
22254	4	3	0	103553	\N
22254	3837	4	0	103554	\N
22261	228	2	0	103581	\N
22261	4776	3	0	103583	\N
22269	4178	3	0	103644	\N
22269	4211	4	0	103645	\N
22271	4178	3	0	103670	\N
22271	4211	4	0	103671	\N
22277	373	3	0	103718	\N
22277	3590	4	0	103719	\N
22286	2	3	0	103778	\N
22286	3548	4	0	103779	\N
22293	4178	7	0	103824	\N
22293	4396	8	0	103807	\N
22296	6518	63	0	103842	\N
22296	167	126	0	103852	\N
22296	6519	127	0	103853	\N
21943	4130	8	0	101381	\N
21946	186	3	0	99076	\N
21946	4294	4	0	99077	\N
21948	23	0	0	101400	\N
21952	40	6	0	101441	\N
21952	4255	7	0	101442	\N
21960	40	3	0	101489	\N
21960	372	4	0	101490	\N
21963	224	3	0	101500	\N
21963	3603	4	0	101501	\N
21967	324	2	0	101506	\N
21967	6435	3	0	101508	\N
21977	2	3	0	100662	\N
21977	3548	4	0	101499	\N
21982	208	3	0	99905	\N
21982	4490	4	0	101544	\N
21984	90	3	0	101565	\N
21984	4074	4	0	101566	\N
21986	94	3	0	101575	\N
21986	2864	4	0	101576	\N
21989	117	6	0	101603	\N
21989	3804	7	0	101604	\N
21994	4178	6	0	101475	\N
21994	4250	7	0	101628	\N
22002	64	3	0	100288	\N
22002	4217	4	0	100289	\N
22003	94	3	0	101710	\N
22003	2864	4	0	101711	\N
22006	40	3	0	101739	\N
22006	372	4	0	101740	\N
22008	241	3	0	100830	\N
22008	3613	4	0	101743	\N
22013	4178	3	0	101702	\N
22013	4211	4	0	101703	\N
22021	208	4	0	99905	\N
22021	6311	5	0	101783	\N
22026	224	3	0	101500	\N
22026	3603	4	0	101501	\N
22038	2627	4	0	39189	\N
22038	6443	5	0	101925	\N
22041	206	4	0	101948	\N
22041	3511	5	0	101949	\N
22043	4178	2	0	101956	\N
22043	4247	3	0	101957	\N
22044	2578	14	0	96158	\N
22044	6444	15	0	101986	\N
22047	40	3	0	101739	\N
22047	372	4	0	101740	\N
22053	94	3	0	102011	\N
22053	2864	4	0	102012	\N
22063	40	3	0	101739	\N
22063	372	4	0	101740	\N
22065	2	3	0	102078	\N
22065	3548	4	0	102079	\N
22070	12	4	0	100164	\N
22070	4043	5	0	102116	\N
22072	4178	6	0	102132	\N
22072	5854	7	0	102133	\N
22075	597	6	0	92732	\N
22075	6452	7	0	102138	\N
22079	170	2	0	102159	\N
22079	2986	3	0	102161	\N
22084	90	7	0	102219	\N
22084	4849	8	0	102227	\N
22086	56	3	0	102230	\N
22086	4109	4	0	102231	\N
22088	4178	3	0	102132	\N
22088	4211	4	0	102240	\N
22096	102	4	0	102308	\N
22096	3572	5	0	102309	\N
22101	60	3	0	100276	\N
22101	3585	4	0	100574	\N
22105	40	4	0	102395	\N
22105	2796	5	0	102396	\N
22112	6462	45	0	102442	\N
22112	56	60	0	102455	\N
22112	6463	61	0	102456	\N
22114	102	4	0	102463	\N
22114	3572	5	0	102467	\N
22117	44	10	0	102499	\N
22117	6464	11	0	102500	\N
22120	5233	7	0	102515	\N
22120	1470	8	0	102516	\N
22122	4172	3	0	102535	\N
22122	4275	4	0	102536	\N
22127	75	3	0	102241	\N
22127	3855	4	0	102242	\N
22130	62	6	0	98994	\N
22130	6466	7	0	102601	\N
22136	6467	5	0	102615	\N
22138	44	6	0	102650	\N
22138	5989	7	0	102651	\N
22144	1470	7	0	102680	\N
22144	5261	8	0	102690	\N
22148	44	7	0	102722	\N
22148	4144	8	0	102723	\N
22151	4178	0	0	102740	\N
22167	4178	5	0	102823	\N
22167	4299	6	0	102824	\N
22169	206	6	0	102837	\N
22169	6481	7	0	102838	\N
22175	2636	7	0	102896	\N
22175	6483	8	0	102897	\N
22177	4172	7	0	102920	\N
22177	4614	8	0	102921	\N
22180	16	3	0	102943	\N
22180	3634	4	0	102944	\N
22183	18	6	0	102967	\N
22183	4180	7	0	102968	\N
22185	693	2	0	102989	\N
22185	206	8	0	103000	\N
22185	6486	9	0	103001	\N
22188	18	3	0	102967	\N
22188	3621	4	0	103027	\N
22193	411	7	0	103069	\N
22193	6487	8	0	103070	\N
22196	117	10	0	103099	\N
22196	906	11	0	103100	\N
22198	75	3	0	103107	\N
22198	3139	4	0	103108	\N
22201	4233	6	0	103166	\N
22201	6364	7	0	103167	\N
22203	300	4	0	102682	\N
22203	6350	5	0	103184	\N
22208	1558	6	0	103214	\N
22208	1021	61	0	103235	\N
22208	6489	62	0	103236	\N
22211	852	6	0	103273	\N
22211	4687	7	0	103274	\N
22212	113	9	0	103293	\N
22212	6490	10	0	103294	\N
22222	206	4	0	103340	\N
22222	6493	5	0	103341	\N
22229	73	5	0	103365	\N
22229	6494	6	0	103366	\N
22232	6303	5	0	103397	\N
22232	6497	6	0	103398	\N
22233	42	6	0	102603	\N
22233	1090	7	0	102604	\N
22238	23	3	0	103451	\N
22238	3497	4	0	103452	\N
22245	156	9	0	102415	\N
22245	2225	10	0	103503	\N
22247	4178	4	0	103512	\N
22247	4205	5	0	103513	\N
22252	142	7	0	103544	\N
22252	6504	8	0	103545	\N
22257	3625	4	0	93915	\N
22257	3802	5	0	103572	\N
22259	3628	4	0	99776	\N
22259	3803	5	0	103574	\N
22272	181	8	0	103688	\N
22272	5425	9	0	103689	\N
22275	235	6	0	103710	\N
22275	3622	7	0	103711	\N
22282	4178	4	0	103742	\N
21961	75	3	0	101491	\N
21961	3855	4	0	101492	\N
21972	3625	6	0	93915	\N
21972	3642	7	0	99774	\N
21979	453	3	0	101538	\N
21979	2838	4	0	101539	\N
21980	279	3	0	101200	\N
21980	3641	4	0	101540	\N
21985	108	3	0	101573	\N
21985	4171	4	0	101574	\N
21991	4172	3	0	101611	\N
21991	4275	4	0	101612	\N
21995	908	3	0	101635	\N
21995	3591	4	0	101636	\N
21998	322	3	0	101653	\N
21998	1105	4	0	101654	\N
22000	173	3	0	101700	\N
22000	3796	4	0	101701	\N
22005	5885	7	0	101731	\N
22005	6440	8	0	101732	\N
22007	77	3	0	101741	\N
22007	1877	4	0	101742	\N
22010	455	1	0	101751	\N
22010	132	3	0	101753	\N
22010	3116	4	0	101754	\N
22014	2782	2	0	101504	\N
22014	2784	3	0	101765	\N
22016	4178	4	0	101776	\N
22016	4205	5	0	101777	\N
22019	64	4	0	100288	\N
22019	3911	5	0	101780	\N
22023	92	3	0	101790	\N
22023	4410	4	0	101791	\N
22027	4172	3	0	101611	\N
22027	4275	4	0	101612	\N
22030	4178	7	0	101834	\N
22030	4659	8	0	101835	\N
22036	6441	107	0	101876	\N
22036	360	126	0	101895	\N
22036	6442	127	0	101896	\N
22037	88	9	0	101915	\N
22037	4692	10	0	101916	\N
22048	214	3	0	98514	\N
22048	3496	4	0	101860	\N
22054	324	3	0	102019	\N
22054	4514	4	0	102020	\N
22059	264	3	0	102041	\N
22059	3632	4	0	102042	\N
22064	16	3	0	101398	\N
22064	3634	4	0	101399	\N
22066	73	4	0	102088	\N
22066	2284	5	0	102089	\N
22069	88	6	0	102106	\N
22069	5263	7	0	102107	\N
22071	12	11	0	102118	\N
22071	6448	12	0	102119	\N
22073	595	6	0	102134	\N
22073	6449	7	0	102135	\N
22078	170	3	0	102159	\N
22078	4148	4	0	102160	\N
22080	4172	4	0	102039	\N
22080	4252	5	0	102168	\N
22083	90	5	0	102219	\N
22083	6455	6	0	102220	\N
22085	177	7	0	75580	\N
22085	3708	8	0	102228	\N
22087	44	7	0	102232	\N
22087	4144	8	0	102233	\N
22089	75	3	0	102241	\N
22089	3855	4	0	102242	\N
22095	4178	3	0	102298	\N
22095	4211	4	0	102299	\N
22098	224	7	0	102332	\N
22098	5003	8	0	102333	\N
22103	167	10	0	102369	\N
22103	6459	11	0	102370	\N
22106	167	4	0	102397	\N
22106	3428	5	0	102398	\N
22109	156	3	0	102425	\N
22109	4594	4	0	102426	\N
22111	2	5	0	102438	\N
22111	6461	6	0	102439	\N
22113	102	3	0	102463	\N
22113	5781	4	0	102464	\N
22115	451	4	0	102468	\N
22115	3666	5	0	102469	\N
22121	16	5	0	102527	\N
22121	4240	6	0	102528	\N
22124	4178	3	0	102545	\N
22124	4211	4	0	102546	\N
22128	73	3	0	102571	\N
22128	1958	4	0	102572	\N
22133	42	0	0	102605	\N
22134	595	4	0	102134	\N
22134	3878	5	0	102614	\N
22140	1470	11	0	102680	\N
22140	6469	12	0	102681	\N
22143	4172	7	0	102543	\N
22143	4614	8	0	102689	\N
22153	241	10	0	102763	\N
22157	241	10	0	102763	\N
22157	6478	11	0	102769	\N
22159	4172	5	0	102543	\N
22159	4634	6	0	102786	\N
22161	2	3	0	102795	\N
22161	3548	4	0	102796	\N
22164	96	3	0	102808	\N
22164	2803	4	0	102809	\N
22170	273	8	0	100635	\N
22170	6482	9	0	102854	\N
22173	4172	3	0	102878	\N
22173	4275	4	0	102879	\N
22179	16	6	0	102787	\N
22179	3369	7	0	102936	\N
22181	142	4	0	101536	\N
22181	3950	5	0	102953	\N
22184	6484	6	0	102974	\N
22184	1021	126	0	102983	\N
22184	6485	127	0	102984	\N
22189	2782	3	0	103034	\N
22189	3659	4	0	103035	\N
22192	90	4	0	102219	\N
22192	3731	5	0	103054	\N
22195	16	4	0	103081	\N
22195	3546	5	0	103082	\N
22202	4172	3	0	103174	\N
22202	4275	4	0	103175	\N
22207	40	4	0	103212	\N
22207	3381	5	0	103213	\N
22210	230	10	0	103259	\N
22210	5683	11	0	103260	\N
22221	235	5	0	103331	\N
22221	6492	6	0	103332	\N
22224	4172	3	0	103351	\N
22224	4275	4	0	103352	\N
22227	1109	3	0	94526	\N
22227	3495	4	0	103355	\N
22235	125	8	0	103440	\N
22235	6499	9	0	103441	\N
22237	852	8	0	103443	\N
22237	6501	9	0	103444	\N
22240	164	7	0	103469	\N
22240	3939	8	0	103470	\N
22242	156	4	0	100262	\N
22242	2543	5	0	103483	\N
22244	156	8	0	103501	\N
22244	6503	9	0	103502	\N
22246	156	9	0	102415	\N
22246	2225	10	0	103503	\N
22253	214	7	0	98514	\N
22253	5951	8	0	103546	\N
22256	16	3	0	103081	\N
22256	3634	4	0	103563	\N
22153	6474	11	1	138677	\N
22153	6476	12	1	106166	\N
22220	40	0	0	100566	\N
22223	12	2	0	103346	\N
22223	2804	3	0	103347	\N
22226	1109	2	0	94526	\N
22226	2809	3	0	103354	\N
22230	73	4	0	103365	\N
22230	2284	5	0	103368	\N
22234	156	6	0	103422	\N
22234	6498	7	0	103423	\N
22239	110	7	0	103467	\N
22239	6502	8	0	103468	\N
22241	156	3	0	103477	\N
22241	4594	4	0	103478	\N
22243	156	4	0	101341	\N
22243	2543	5	0	103484	\N
22248	2782	4	0	103514	\N
22248	3872	5	0	103515	\N
22250	200	6	0	99179	\N
22250	4701	7	0	103528	\N
22255	40	3	0	103561	\N
22255	372	4	0	103562	\N
22262	360	3	0	103590	\N
22262	3602	4	0	103591	\N
22264	16	5	0	103081	\N
22264	5175	6	0	103603	\N
22265	23	11	0	103626	\N
22265	6505	12	0	103627	\N
22267	908	3	0	103636	\N
22267	3591	4	0	103637	\N
22270	365	8	0	103662	\N
22270	6507	9	0	103663	\N
22273	4172	3	0	103351	\N
22273	4275	4	0	103352	\N
22278	4178	3	0	103696	\N
22278	4211	4	0	103697	\N
22280	4178	2	0	103730	\N
22280	4527	3	0	103731	\N
22283	212	4	0	99984	\N
22283	3732	5	0	103744	\N
22288	264	3	0	103782	\N
22288	3632	4	0	103783	\N
22290	4441	3	0	103805	\N
22290	4178	8	0	103806	\N
22290	6516	9	0	103807	\N
22295	251	4	0	100902	\N
22295	3354	5	0	103841	\N
22300	4178	3	0	103862	\N
22300	4211	4	0	103863	\N
22302	79	3	0	101477	\N
22302	3652	4	0	103907	\N
22305	192	3	0	103938	\N
22305	3790	4	0	103939	\N
22307	113	3	0	103293	\N
22307	3620	4	0	103942	\N
22309	6522	71	0	103977	\N
22309	4233	104	0	103997	\N
22309	6523	105	0	103998	\N
22312	40	3	0	104022	\N
22312	372	4	0	104023	\N
22314	42	4	0	104034	\N
22314	3896	5	0	104035	\N
22317	94	8	0	104053	\N
22317	5303	9	0	104054	\N
22320	4488	7	0	104106	\N
22320	40	12	0	104107	\N
22320	6531	14	0	104110	\N
22323	6	5	0	104127	\N
22329	1368	3	0	28929	\N
22329	6537	3	0	104143	\N
22329	2803	4	0	104144	\N
22331	27	2	0	94335	\N
22331	3164	3	0	104152	\N
22334	125	10	0	103440	\N
22334	6539	11	0	104192	\N
22337	135	3	0	100119	\N
22337	3630	4	0	101329	\N
22339	4178	4	0	104230	\N
22339	4205	5	0	104231	\N
22340	181	10	0	104252	\N
22340	6541	11	0	104253	\N
22342	121	7	0	93181	\N
22342	6543	8	0	104255	\N
22349	852	2	0	104302	\N
22349	2872	3	0	104303	\N
22354	365	10	0	104345	\N
22354	6547	11	0	104346	\N
22356	5885	3	0	104355	\N
22356	5926	4	0	104356	\N
22361	4776	2	0	104379	\N
22361	228	5	0	104380	\N
22361	3589	6	0	104381	\N
22363	132	9	0	101131	\N
22363	6548	10	0	104403	\N
22369	2636	7	0	102896	\N
22369	6483	8	0	102897	\N
22373	4172	7	0	104470	\N
22373	4614	8	0	104471	\N
22376	170	7	0	104494	\N
22376	4591	8	0	104495	\N
22379	4172	3	0	104525	\N
22379	4275	4	0	104526	\N
22381	290	4	0	104537	\N
22381	5879	5	0	104538	\N
22386	411	3	0	104567	\N
22386	3596	4	0	104568	\N
22388	6550	12	0	104570	\N
22388	411	82	0	104604	\N
22388	6551	83	0	104605	\N
22393	18	4	0	104442	\N
22393	2302	5	0	104627	\N
22395	92	3	0	104642	\N
22395	4410	4	0	104643	\N
22398	4	6	0	104292	\N
22398	6552	7	0	104666	\N
22402	411	7	0	104684	\N
22402	6487	8	0	104685	\N
22404	411	26	0	104699	\N
22404	6553	27	0	104700	\N
22412	4178	10	0	104740	\N
22412	4665	11	0	104741	\N
22414	88	3	0	102106	\N
22414	3655	4	0	104757	\N
22421	1470	7	0	104795	\N
22421	5261	8	0	104796	\N
22428	4178	3	0	104777	\N
22428	4211	4	0	104823	\N
22430	54	3	0	104832	\N
22430	3041	4	0	104833	\N
22433	453	4	0	101538	\N
22433	4108	5	0	104854	\N
22446	54	4	0	105050	\N
22446	3685	5	0	105051	\N
22448	4172	3	0	104613	\N
22448	4275	4	0	104614	\N
22455	3625	4	0	93915	\N
22455	3802	5	0	103572	\N
22462	449	3	0	105122	\N
22462	4760	4	0	105123	\N
22467	6562	63	0	105143	\N
22467	167	126	0	105163	\N
22467	6563	127	0	105164	\N
22471	235	7	0	105187	\N
22471	5822	8	0	105188	\N
22474	4178	13	0	105216	\N
22474	4782	14	0	105217	\N
22479	316	9	0	105255	\N
22479	6566	10	0	105256	\N
22481	4178	8	0	105274	\N
22481	5610	9	0	105275	\N
22486	208	18	0	99905	\N
22486	6572	19	0	105376	\N
22489	360	8	0	105413	\N
22489	6575	9	0	105414	\N
22320	6530	13	1	138684	\N
22323	6533	6	1	138686	\N
22258	119	4	0	101527	\N
22258	3518	5	0	103573	\N
22260	228	3	0	103581	\N
22260	3186	4	0	103582	\N
22263	142	3	0	103544	\N
22263	4254	4	0	103592	\N
22266	2578	11	0	103628	\N
22266	6506	12	0	103629	\N
22268	4172	3	0	103351	\N
22268	4275	4	0	103352	\N
22274	4178	3	0	103696	\N
22274	4211	4	0	103697	\N
22276	200	3	0	99179	\N
22276	3338	4	0	99180	\N
22281	451	2	0	103732	\N
22281	5006	3	0	103733	\N
22285	360	3	0	103770	\N
22285	3602	4	0	103771	\N
22291	6158	3	0	103790	\N
22291	117	8	0	103808	\N
22291	6517	9	0	103809	\N
22292	173	0	0	102547	\N
22297	431	3	0	103860	\N
22297	3933	4	0	103861	\N
22306	4233	3	0	103940	\N
22306	4425	4	0	103941	\N
22310	4178	4	0	103862	\N
22310	4205	5	0	104007	\N
22321	6527	7	0	104095	\N
22321	687	12	0	104104	\N
22321	6528	13	0	104105	\N
22325	228	7	0	104130	\N
22325	6534	8	1	104132	\N
22325	6532	8	0	104133	\N
22327	389	7	0	12148	\N
22327	6535	8	0	104135	\N
22332	173	7	0	104165	\N
22332	4982	8	0	104166	\N
22335	290	7	0	99965	\N
22335	6540	8	0	104207	\N
22343	734	7	0	101357	\N
22343	6544	8	0	104267	\N
22345	16	5	0	104282	\N
22345	5175	6	0	104283	\N
22357	365	3	0	104345	\N
22357	3839	4	0	104357	\N
22364	4172	4	0	104412	\N
22364	4219	5	0	104413	\N
22366	40	3	0	104422	\N
22366	372	4	0	104423	\N
22371	14	1	0	104446	\N
22371	15	2	0	104447	\N
22374	142	3	0	103544	\N
22374	4254	4	0	103592	\N
22377	5399	6	0	104508	\N
22377	6549	7	0	104509	\N
22380	14	3	0	104527	\N
22380	4272	4	0	104528	\N
22382	365	1	0	104539	\N
22382	1424	2	0	104540	\N
22384	96	3	0	104557	\N
22384	2803	4	0	104558	\N
22387	94	3	0	104053	\N
22387	2864	4	0	104569	\N
22391	164	3	0	104615	\N
22391	3385	4	0	104616	\N
22403	16	7	0	104686	\N
22403	4723	8	0	104687	\N
22405	2	2	0	104705	\N
22405	2789	3	0	104377	\N
22407	262	2	0	104294	\N
22407	2743	3	0	104711	\N
22419	4178	2	0	104777	\N
22419	4247	3	0	104778	\N
22422	1470	5	0	104795	\N
22422	6556	6	0	104797	\N
22426	365	7	0	104815	\N
22426	5248	8	0	104816	\N
22434	852	4	0	104855	\N
22434	4162	5	0	104856	\N
22435	852	12	0	104857	\N
22435	1647	13	0	104858	\N
22437	6557	93	0	104953	\N
22437	4233	126	0	104971	\N
22437	6523	127	0	104972	\N
22440	6559	20	0	104992	\N
22440	214	97	0	105021	\N
22440	6560	98	0	105022	\N
22442	266	3	0	105027	\N
22442	3474	4	0	105031	\N
22444	2995	3	0	105040	\N
22444	110	4	0	105041	\N
22447	16	4	0	105052	\N
22447	3546	5	0	105053	\N
22449	69	3	0	99544	\N
22449	4536	4	0	105060	\N
22451	4172	6	0	105074	\N
22451	4197	7	0	105075	\N
22454	121	2	0	105084	\N
22454	2498	3	0	105087	\N
22456	119	4	0	101527	\N
22456	3518	5	0	103573	\N
22458	4172	3	0	105082	\N
22458	4275	4	0	105083	\N
22460	40	3	0	105110	\N
22460	372	4	0	105111	\N
22465	4178	4	0	105139	\N
22465	4205	5	0	105140	\N
22469	224	3	0	104125	\N
22469	3603	4	0	105172	\N
22475	4178	6	0	105230	\N
22475	5854	7	0	105231	\N
22477	62	8	0	98994	\N
22477	6564	9	0	105250	\N
22482	6567	12	0	105300	\N
22482	30	19	0	105313	\N
22482	2931	20	0	105314	\N
22484	6569	9	0	105334	\N
22484	6570	10	0	105335	\N
22487	279	18	0	101781	\N
22487	6573	19	0	105377	\N
22493	2636	8	0	102896	\N
22493	6576	9	0	105422	\N
22496	14	3	0	105435	\N
22496	1786	4	0	105436	\N
22510	273	4	0	105617	\N
22510	3390	5	0	105618	\N
22512	210	3	0	105627	\N
22512	3539	4	0	105628	\N
22515	4178	4	0	105419	\N
22515	4205	5	0	105639	\N
22517	151	6	0	105654	\N
22517	6587	7	0	105655	\N
22520	4178	9	0	105695	\N
22520	4318	10	0	105696	\N
22527	79	6	0	105776	\N
22527	4253	7	0	105777	\N
22530	135	7	0	105798	\N
22530	4721	8	0	105799	\N
22532	4441	3	0	105807	\N
22532	4178	7	0	105814	\N
22532	4941	8	0	105815	\N
22543	12	3	0	105914	\N
22543	4204	4	0	105915	\N
22545	200	5	0	105925	\N
22545	6598	6	0	105926	\N
22548	4178	13	0	105905	\N
22548	4782	14	0	105954	\N
22551	20	6	0	105984	\N
22551	5933	7	0	105985	\N
22560	75	3	0	106013	\N
22560	3855	4	0	106014	\N
22565	841	3	0	100543	\N
22565	3604	4	0	106046	\N
22568	27	12	0	106075	\N
22568	6066	13	0	106076	\N
22282	4205	5	0	103743	\N
22284	6508	45	0	103759	\N
22284	212	126	0	103762	\N
22284	6509	127	0	103763	\N
22287	4178	3	0	103780	\N
22287	4211	4	0	103781	\N
22289	6158	3	0	103790	\N
22289	6510	8	0	103799	\N
22289	6511	8	0	103800	\N
22294	167	6	0	103837	\N
22294	5066	7	0	103838	\N
22299	145	14	0	99791	\N
22299	6520	15	0	103892	\N
22311	4178	3	0	104014	\N
22311	4211	4	0	104015	\N
22316	210	8	0	96438	\N
22316	6525	9	0	104052	\N
22322	224	7	0	104125	\N
22322	5003	8	0	104126	\N
22328	1368	3	0	28929	\N
22328	6536	3	0	104141	\N
22328	3770	4	0	104142	\N
22333	206	11	0	104176	\N
22333	6538	12	0	104177	\N
22336	137	3	0	104214	\N
22336	3633	4	0	104215	\N
22347	262	4	0	104294	\N
22347	4607	5	0	104295	\N
22351	264	3	0	103782	\N
22351	3632	4	0	103783	\N
22353	4178	4	0	104343	\N
22353	4205	5	0	104344	\N
22360	2789	2	0	104372	\N
22360	2	5	0	104377	\N
22360	2990	6	0	104378	\N
22368	38	7	0	104440	\N
22368	5071	8	0	104441	\N
22372	4172	3	0	104454	\N
22372	4275	4	0	104455	\N
22378	75	4	0	103943	\N
22378	3959	5	0	104518	\N
22383	365	4	0	104549	\N
22383	4049	5	0	104550	\N
22390	4172	3	0	104613	\N
22390	4275	4	0	104614	\N
22392	35	4	0	104625	\N
22392	3545	5	0	104626	\N
22394	264	3	0	104634	\N
22394	3632	4	0	104635	\N
22397	233	6	0	100809	\N
22397	4245	7	0	104665	\N
22400	4088	6	0	94310	\N
22400	4246	7	0	104667	\N
22401	67	6	0	104668	\N
22401	3607	7	0	104669	\N
22409	117	3	0	104716	\N
22409	3653	4	0	104717	\N
22410	4178	3	0	104353	\N
22410	4211	4	0	104354	\N
22411	102	10	0	104738	\N
22411	6554	11	0	104739	\N
22413	38	4	0	104440	\N
22413	5656	5	0	104750	\N
22416	62	3	0	98994	\N
22416	3344	4	0	104766	\N
22418	242	16	0	101481	\N
22418	6555	17	0	104772	\N
22425	365	0	0	104800	\N
22432	273	4	0	104852	\N
22432	3777	5	0	104853	\N
22436	4233	3	0	104865	\N
22436	4425	4	0	104866	\N
22439	214	8	0	104990	\N
22439	6558	9	0	104991	\N
22441	266	2	0	105027	\N
22441	2103	3	0	105028	\N
22445	2995	3	0	105040	\N
22445	110	4	0	105041	\N
22453	121	3	0	105084	\N
22453	4471	4	0	105085	\N
22457	3628	4	0	105094	\N
22457	3803	5	0	105095	\N
22461	18	4	0	104442	\N
22461	2302	5	0	104627	\N
22464	251	3	0	100902	\N
22464	3514	4	0	100903	\N
22468	108	2	0	101573	\N
22468	3340	3	0	105169	\N
22485	4178	10	0	105274	\N
22485	6571	11	0	105339	\N
22488	6	9	0	104565	\N
22488	6574	10	0	105396	\N
22491	4178	8	0	105419	\N
22491	4237	9	0	105420	\N
22497	14	4	0	105435	\N
22497	2291	5	0	105437	\N
22502	279	9	0	101781	\N
22502	6581	10	0	105516	\N
22504	189	17	0	105551	\N
22504	6582	18	0	105552	\N
22509	241	20	0	105607	\N
22509	6586	21	0	105608	\N
22521	4178	13	0	105723	\N
22521	6589	14	0	105724	\N
22523	18	9	0	105744	\N
22523	6591	10	0	105745	\N
22528	79	4	0	105776	\N
22528	2758	5	0	105780	\N
22534	20	8	0	105860	\N
22534	6595	9	0	105861	\N
22537	18	12	0	105895	\N
22537	6596	13	0	105896	\N
22547	360	13	0	105413	\N
22547	6599	14	0	105953	\N
22549	82	3	0	99795	\N
22549	4505	4	0	105961	\N
22552	77	6	0	101741	\N
22552	6600	7	0	105986	\N
22554	113	3	0	103293	\N
22554	3620	4	0	103942	\N
22559	4178	3	0	105905	\N
22559	4211	4	0	105906	\N
22561	4172	8	0	105637	\N
22561	5928	9	0	106031	\N
22571	290	3	0	106092	\N
22571	3635	4	0	106093	\N
22573	4172	10	0	106115	\N
22573	6603	11	0	106116	\N
22576	82	17	0	106141	\N
22576	6605	18	0	106142	\N
22578	242	11	0	106157	\N
22578	6607	12	0	106158	\N
22583	1815	9	0	24253	\N
22583	6612	10	0	106217	\N
22591	71	16	0	106281	\N
22591	6615	17	0	106282	\N
22594	402	4	0	99166	\N
22594	2548	5	0	106296	\N
22599	911	15	0	8397	\N
22599	6620	16	0	106340	\N
22601	40	4	0	106354	\N
22601	2796	5	0	106355	\N
22611	2636	2	0	102896	\N
22611	2836	3	0	106413	\N
22613	4172	7	0	106424	\N
22613	6628	8	0	106425	\N
22615	79	4	0	106435	\N
22615	3678	5	0	106436	\N
22618	852	3	0	104855	\N
22618	3612	4	0	106440	\N
22620	20	3	0	105984	\N
22620	2844	4	0	106448	\N
22622	1470	4	0	104795	\N
22289	6513	9	1	138680	\N
22289	6515	10	1	138682	\N
22298	4178	3	0	103862	\N
22298	4211	4	0	103863	\N
22301	18	3	0	103899	\N
22301	3621	4	0	103900	\N
22303	30	3	0	88611	\N
22303	3640	4	0	103908	\N
22304	192	11	0	90441	\N
22304	6521	12	0	103931	\N
22308	75	3	0	103943	\N
22308	3855	4	0	103944	\N
22313	6044	4	0	104032	\N
22313	6524	5	0	104033	\N
22318	170	12	0	104079	\N
22318	6526	13	0	104080	\N
22319	6527	7	0	104095	\N
22319	687	12	0	104104	\N
22319	6528	13	0	104105	\N
22324	228	7	0	104130	\N
22324	5491	8	0	104131	\N
22326	6	7	0	104127	\N
22326	5595	8	0	104134	\N
22330	96	6	0	102808	\N
22330	3698	7	0	104150	\N
22338	2	3	0	103778	\N
22338	3548	4	0	103779	\N
22341	121	10	0	93181	\N
22341	6542	11	0	104254	\N
22344	336	9	0	104272	\N
22344	6545	10	0	104273	\N
22346	4	4	0	104292	\N
22346	4117	5	0	104293	\N
22348	200	4	0	104296	\N
22348	4683	5	0	104297	\N
22350	852	64	0	104302	\N
22350	6546	65	0	104328	\N
22355	4178	3	0	104353	\N
22355	4211	4	0	104354	\N
22358	258	3	0	104358	\N
22358	4401	4	0	104359	\N
22359	156	3	0	104366	\N
22359	4594	4	0	104367	\N
22362	1379	2	0	104382	\N
22362	149	5	0	104383	\N
22362	5008	6	0	104384	\N
22365	64	4	0	104414	\N
22365	3911	5	0	104415	\N
22367	40	7	0	104438	\N
22367	4718	8	0	104439	\N
22370	18	7	0	104442	\N
22370	1618	8	0	104443	\N
22375	173	7	0	104492	\N
22375	6103	8	0	104493	\N
22385	6	3	0	104565	\N
22385	4823	4	0	104566	\N
22389	336	3	0	104272	\N
22389	3400	4	0	104612	\N
22396	244	4	0	97431	\N
22396	3778	5	0	104652	\N
22406	4172	2	0	104613	\N
22406	4191	3	0	104706	\N
22408	262	3	0	104294	\N
22408	4778	4	0	104715	\N
22415	62	2	0	98994	\N
22415	2191	3	0	104762	\N
22417	242	3	0	101481	\N
22417	2839	4	0	104767	\N
22420	125	2	0	104779	\N
22420	3297	3	0	104780	\N
22423	117	7	0	104716	\N
22423	5276	8	0	104798	\N
22424	64	7	0	104414	\N
22424	5286	8	0	104799	\N
22429	67	3	0	104824	\N
22429	3749	4	0	104825	\N
22431	54	4	0	104842	\N
22431	3685	5	0	104843	\N
22438	212	8	0	99984	\N
22438	4031	9	0	104989	\N
22443	793	3	0	105032	\N
22443	2644	4	0	105033	\N
22450	16	3	0	105052	\N
22450	3634	4	0	105061	\N
22452	4172	3	0	105082	\N
22452	4275	4	0	105083	\N
22459	6232	3	0	105102	\N
22459	6561	4	0	105103	\N
22463	212	3	0	99984	\N
22463	3639	4	0	105130	\N
22466	167	4	0	105141	\N
22466	4048	5	0	105142	\N
22470	251	3	0	100902	\N
22470	3514	4	0	100903	\N
22472	16	7	0	105052	\N
22472	4723	8	0	105189	\N
22476	264	6	0	105232	\N
22476	4660	7	0	105233	\N
22478	62	9	0	98994	\N
22478	6565	10	0	105254	\N
22480	117	8	0	104716	\N
22480	1878	9	0	105273	\N
22490	14	6	0	104527	\N
22490	2720	7	0	105418	\N
22494	14	8	0	104527	\N
22494	6577	9	0	105423	\N
22499	4172	28	0	105082	\N
22499	6579	29	0	105495	\N
22501	208	9	0	105514	\N
22501	6580	10	0	105515	\N
22506	41	1	0	105562	\N
22506	2074	2	0	105563	\N
22506	6584	2	0	105564	\N
22508	241	20	0	105607	\N
22508	6586	21	0	105608	\N
22511	96	4	0	105619	\N
22511	5538	5	0	105620	\N
22516	316	4	0	105640	\N
22516	5437	5	0	105641	\N
22518	326	9	0	105674	\N
22518	2581	10	0	105675	\N
22525	4787	4	0	105762	\N
22525	5041	5	0	105763	\N
22533	2	13	0	105842	\N
22533	6594	14	0	105843	\N
22536	132	3	0	105869	\N
22536	3729	4	0	105870	\N
22539	4178	3	0	105905	\N
22539	4211	4	0	105906	\N
22541	69	1	0	99544	\N
22541	70	2	0	105909	\N
22556	244	4	0	106003	\N
22556	3778	5	0	106004	\N
22558	16	3	0	105052	\N
22558	3634	4	0	105061	\N
22563	2761	2	0	106036	\N
22563	192	4	0	106039	\N
22563	2944	5	0	103939	\N
22566	14	3	0	106047	\N
22566	4272	4	0	106048	\N
22575	449	3	0	106125	\N
22575	4760	4	0	106126	\N
22580	214	4	0	106179	\N
22580	6608	5	0	106180	\N
22585	79	9	0	106220	\N
22585	6614	10	0	106221	\N
22593	110	4	0	106294	\N
22593	4552	5	0	106295	\N
22598	4178	15	0	106338	\N
22598	4570	16	0	106339	\N
22603	4178	6	0	106369	\N
22603	6623	7	0	106370	\N
22606	12	2	0	105914	\N
22606	2804	3	0	106378	\N
22617	852	4	0	104855	\N
22617	4162	5	0	104856	\N
22626	189	3	0	106466	\N
22626	3782	4	0	106470	\N
22640	3634	3	0	106538	\N
22492	4172	8	0	105082	\N
22492	4500	9	0	105421	\N
22495	528	4	0	105432	\N
22495	3353	5	0	105433	\N
22498	528	3	0	105432	\N
22498	6578	4	0	105439	\N
22505	189	19	0	105551	\N
22505	6583	20	0	105559	\N
22507	368	1	0	105565	\N
22507	367	12	0	105584	\N
22507	6585	13	0	105585	\N
22514	4172	4	0	105637	\N
22514	4219	5	0	105638	\N
22519	4172	9	0	105637	\N
22519	6588	10	0	105694	\N
22522	16	13	0	105052	\N
22522	6590	14	0	105725	\N
22524	71	3	0	105752	\N
22524	3770	4	0	105753	\N
22529	4178	9	0	105796	\N
22529	6592	10	0	105797	\N
22531	137	9	0	104214	\N
22531	6593	10	0	105800	\N
22535	4172	3	0	105637	\N
22535	4275	4	0	105868	\N
22538	793	12	0	105897	\N
22538	6597	13	0	105898	\N
22540	5885	3	0	104355	\N
22540	5926	4	0	104356	\N
22542	69	3	0	99544	\N
22542	4536	4	0	105060	\N
22544	1109	2	0	94526	\N
22544	2809	3	0	103354	\N
22550	200	4	0	105970	\N
22550	4683	5	0	105971	\N
22555	4233	4	0	106001	\N
22555	4234	5	0	106002	\N
22557	23	3	0	106011	\N
22557	3497	4	0	106012	\N
22562	2761	2	0	106036	\N
22562	192	4	0	106039	\N
22562	2944	5	0	103939	\N
22564	58	3	0	100854	\N
22564	3665	4	0	101326	\N
22567	2	12	0	106073	\N
22567	3541	13	0	106074	\N
22569	4233	3	0	106001	\N
22569	4425	4	0	106083	\N
22572	6601	3	0	106094	\N
22572	6602	4	0	106095	\N
22574	241	10	0	106117	\N
22574	6604	11	0	106118	\N
22579	132	5	0	106169	\N
22579	4384	6	0	106170	\N
22581	6609	49	0	106182	\N
22581	214	126	0	106183	\N
22581	6610	127	0	106184	\N
22586	290	4	0	106230	\N
22586	5879	5	0	106231	\N
22588	242	3	0	106239	\N
22588	2839	4	0	106240	\N
22589	40	3	0	106247	\N
22589	1921	4	0	106248	\N
22592	6616	14	0	106284	\N
22592	402	17	0	106285	\N
22592	6618	18	1	106286	\N
22592	6617	18	0	106287	\N
22595	110	5	0	106294	\N
22595	6619	6	0	106299	\N
22596	300	3	0	106304	\N
22596	3747	4	0	106305	\N
22600	911	11	0	8397	\N
22600	6621	12	0	106345	\N
22602	90	6	0	102219	\N
22602	6622	7	0	106368	\N
22604	2	2	0	106073	\N
22604	2789	3	0	106375	\N
22607	170	7	0	104494	\N
22607	6624	8	0	106393	\N
22609	1470	6	0	104795	\N
22609	6626	7	0	106410	\N
22612	2636	6	0	102896	\N
22612	6627	7	0	106414	\N
22614	18	7	0	105895	\N
22614	6629	8	0	106426	\N
22623	79	4	0	106435	\N
22623	3678	5	0	106436	\N
22625	189	4	0	106466	\N
22625	3992	5	0	106467	\N
22628	16	6	0	105052	\N
22628	3369	7	0	106484	\N
22630	1470	4	0	106501	\N
22630	5655	5	0	106502	\N
22633	279	4	0	101781	\N
22633	3502	5	0	101782	\N
22639	336	4	0	104272	\N
22639	3947	5	0	106531	\N
22644	324	3	0	102019	\N
22644	4514	4	0	102020	\N
22648	75	7	0	106568	\N
22648	2859	8	0	106569	\N
22650	4172	3	0	106583	\N
22650	4275	4	0	106584	\N
22652	44	3	0	106585	\N
22652	3631	4	0	106586	\N
22657	121	3	0	106605	\N
22657	4471	4	0	106606	\N
22662	206	10	0	104176	\N
22662	4819	11	0	106647	\N
22667	4	4	0	106675	\N
22667	4117	5	0	106676	\N
22669	40	3	0	106685	\N
22669	372	4	0	106686	\N
22672	4172	3	0	106710	\N
22672	4275	4	0	106711	\N
22674	170	3	0	106720	\N
22674	4148	4	0	106721	\N
22677	266	3	0	105027	\N
22677	3474	4	0	105031	\N
22679	71	3	0	106748	\N
22679	3770	4	0	106749	\N
22682	73	7	0	103365	\N
22682	6635	8	0	106773	\N
22684	125	3	0	106780	\N
22684	4170	4	0	106781	\N
22686	40	4	0	106746	\N
22686	2796	5	0	106792	\N
22706	16	2	0	106607	\N
22706	388	3	0	106915	\N
22708	290	2	0	106918	\N
22708	1909	3	0	106919	\N
22711	233	6	0	100809	\N
22711	4245	7	0	104665	\N
22713	4088	6	0	94310	\N
22713	4246	7	0	104667	\N
22716	71	3	0	106967	\N
22716	3770	4	0	106968	\N
22723	2	4	0	106989	\N
22723	3510	5	0	106990	\N
22726	6643	4	0	107005	\N
22726	262	5	0	107006	\N
22731	6645	3	0	107028	\N
22731	6646	4	0	107029	\N
22737	30	14	0	107071	\N
22737	6647	15	0	107072	\N
22740	4178	4	0	107095	\N
22740	4205	5	0	107096	\N
22742	16	6	0	107119	\N
22742	3369	7	0	107120	\N
22745	113	5	0	107148	\N
22745	3786	6	0	107149	\N
22751	186	2	0	99076	\N
22751	1850	3	0	107172	\N
22754	6648	81	0	107180	\N
22754	365	121	0	107181	\N
22754	6649	122	0	107182	\N
22759	4172	4	0	107230	\N
22570	192	3	0	106090	\N
22570	3790	4	0	106091	\N
22577	77	11	0	106155	\N
22577	6606	12	0	106156	\N
22582	4172	6	0	106197	\N
22582	6611	7	0	106198	\N
22584	6303	9	0	106218	\N
22584	6613	10	0	106219	\N
22587	206	4	0	104176	\N
22587	3511	5	0	106232	\N
22597	273	3	0	106306	\N
22597	3638	4	0	106307	\N
22605	140	2	0	106376	\N
22605	3183	3	0	106377	\N
22608	170	10	0	104494	\N
22608	6625	11	0	106400	\N
22610	40	2	0	106411	\N
22610	282	3	0	106412	\N
22616	104	2	0	106438	\N
22616	6630	3	0	106439	\N
22619	18	4	0	105895	\N
22619	2302	5	0	106441	\N
22621	20	5	0	105984	\N
22621	6631	6	0	106449	\N
22624	4	4	0	104292	\N
22624	4117	5	0	104293	\N
22631	33	4	0	106503	\N
22631	4806	5	0	106504	\N
22635	453	6	0	101538	\N
22635	4091	7	0	106520	\N
22637	2636	4	0	102896	\N
22637	3617	5	0	106530	\N
22642	108	3	0	101573	\N
22642	4171	4	0	101574	\N
22646	64	7	0	106564	\N
22646	5286	8	0	106565	\N
22651	1636	3	0	95993	\N
22651	5514	4	0	97578	\N
22653	235	4	0	106594	\N
22653	3615	5	0	106595	\N
22655	2782	4	0	103514	\N
22655	3872	5	0	103515	\N
22658	16	3	0	106607	\N
22658	3634	4	0	106608	\N
22663	108	9	0	101573	\N
22663	6634	10	0	106666	\N
22665	16	0	0	103081	\N
22668	40	4	0	106677	\N
22668	3381	5	0	106678	\N
22670	212	3	0	106687	\N
22670	3639	4	0	106688	\N
22673	214	3	0	106712	\N
22673	3496	4	0	106713	\N
22675	92	4	0	106730	\N
22675	3979	5	0	106731	\N
22685	1316	3	0	106782	\N
22685	4837	4	0	106783	\N
22689	2	2	0	106073	\N
22689	2789	3	0	106375	\N
22694	4172	6	0	106738	\N
22694	5278	7	0	106842	\N
22697	69	4	0	99544	\N
22697	4041	5	0	106871	\N
22700	1000	4	0	106876	\N
22700	6640	5	0	106877	\N
22704	765	7	0	106908	\N
22704	6642	8	0	106909	\N
22707	4172	2	0	106916	\N
22707	4191	3	0	106917	\N
22709	4178	5	0	106872	\N
22709	4429	6	0	106930	\N
22712	244	6	0	106944	\N
22712	6406	7	0	106945	\N
22714	58	4	0	106954	\N
22714	2781	5	0	106955	\N
22717	181	3	0	104252	\N
22717	4184	4	0	106969	\N
22719	212	2	0	106687	\N
22719	3616	3	0	106975	\N
22721	135	2	0	105798	\N
22721	2722	3	0	106981	\N
22729	4178	2	0	106872	\N
22729	4247	3	0	106974	\N
22732	373	3	0	103718	\N
22732	3590	4	0	103719	\N
22735	18	0	0	102967	\N
22743	18	5	0	105895	\N
22743	3550	6	0	107131	\N
22748	125	3	0	107167	\N
22748	4170	4	0	107168	\N
22752	186	3	0	99076	\N
22752	4294	4	0	99077	\N
22757	4172	3	0	106916	\N
22757	4275	4	0	107213	\N
22760	2575	4	0	107240	\N
22760	16	7	0	107245	\N
22760	6650	8	1	107246	\N
22760	4017	8	0	107247	\N
22760	6651	9	0	107248	\N
22762	198	0	0	107253	\N
22786	4	4	0	106675	\N
22786	4117	5	0	106676	\N
22797	2578	6	0	103628	\N
22797	4795	7	0	107522	\N
22803	156	3	0	107547	\N
22803	4594	4	0	107548	\N
22805	4787	3	0	107555	\N
22805	4788	4	0	107556	\N
22807	58	6	0	107568	\N
22807	3575	7	0	107569	\N
22810	33	3	0	106503	\N
22810	3342	4	0	107592	\N
22815	208	3	0	106505	\N
22815	4490	4	0	107607	\N
22819	4172	7	0	107619	\N
22819	4614	8	0	107637	\N
22822	210	3	0	107661	\N
22822	3539	4	0	107662	\N
22824	200	0	0	106818	\N
22827	16	3	0	107605	\N
22827	3634	4	0	107606	\N
22829	285	4	0	100392	\N
22829	3674	5	0	107704	\N
22832	852	4	0	104855	\N
22832	4162	5	0	104856	\N
22834	60	3	0	107722	\N
22834	3585	4	0	107726	\N
22836	40	2	0	107515	\N
22836	282	3	0	107734	\N
22841	167	0	0	105141	\N
22847	113	3	0	107790	\N
22847	3620	4	0	107791	\N
22849	4178	3	0	107800	\N
22849	4211	4	0	107801	\N
22852	167	0	0	105141	\N
22858	268	5	0	107418	\N
22858	6673	6	0	107832	\N
22863	94	4	0	107844	\N
22863	4677	5	0	107845	\N
22864	212	5	0	107523	\N
22864	6675	6	0	107856	\N
22869	110	4	0	107869	\N
22869	4134	5	0	107870	\N
22873	228	5	0	104130	\N
22873	6677	6	0	107896	\N
22876	2	4	0	107920	\N
22876	3510	5	0	107921	\N
22878	82	4	0	106141	\N
22878	3508	5	0	107924	\N
22880	75	4	0	107595	\N
22880	3959	5	0	107927	\N
22883	6678	4	0	107949	\N
22883	6679	5	0	107950	\N
22886	16	3	0	107798	\N
22886	3634	4	0	107799	\N
22895	1636	3	0	108027	\N
22895	5514	4	0	108028	\N
22622	2798	5	0	106457	\N
22627	202	6	0	100890	\N
22627	4079	7	0	106483	\N
22629	173	3	0	106491	\N
22629	3796	4	0	106492	\N
22632	208	4	0	106505	\N
22632	6311	5	0	106506	\N
22634	6303	6	0	106218	\N
22634	6438	7	0	106519	\N
22636	75	6	0	106013	\N
22636	4694	7	0	106521	\N
22638	336	4	0	104272	\N
22638	3947	5	0	106531	\N
22641	3749	3	0	106539	\N
22641	67	4	0	104825	\N
22643	336	3	0	106546	\N
22643	3400	4	0	106547	\N
22645	336	2	0	106546	\N
22645	3332	3	0	106549	\N
22656	841	3	0	100543	\N
22656	3604	4	0	106046	\N
22659	121	2	0	106605	\N
22659	2498	3	0	106609	\N
22666	16	0	0	103081	\N
22671	260	7	0	94738	\N
22671	4589	8	0	106703	\N
22676	4172	3	0	106738	\N
22676	4275	4	0	106739	\N
22681	1470	7	0	106771	\N
22681	5261	8	0	106772	\N
22688	1109	4	0	106795	\N
22688	4535	5	0	106796	\N
22691	200	8	0	106818	\N
22691	6636	9	0	106819	\N
22693	92	6	0	106840	\N
22693	6637	7	0	106841	\N
22696	4178	9	0	106597	\N
22696	6639	10	0	106862	\N
22699	360	4	0	106874	\N
22699	3513	5	0	106875	\N
22703	6	6	0	106892	\N
22703	6641	7	0	106893	\N
22710	1109	5	0	106795	\N
22710	5040	6	0	106931	\N
22718	4178	2	0	106872	\N
22718	4247	3	0	106974	\N
22722	137	1	0	104214	\N
22722	138	2	0	106982	\N
22725	6643	4	0	107005	\N
22725	262	5	0	107006	\N
22728	69	2	0	107011	\N
22728	3350	3	0	107012	\N
22733	16	3	0	106607	\N
22733	3634	4	0	106608	\N
22734	18	0	0	102967	\N
22736	273	14	0	106306	\N
22736	274	15	0	107070	\N
22739	4172	4	0	106916	\N
22739	4219	5	0	107094	\N
22741	38	4	0	107105	\N
22741	5656	5	0	107106	\N
22747	266	3	0	107165	\N
22747	3474	4	0	107166	\N
22750	123	2	0	107170	\N
22750	1868	3	0	107171	\N
22756	365	10	0	107205	\N
22756	3791	11	0	107206	\N
22758	16	3	0	107220	\N
22758	3634	4	0	107221	\N
22761	3779	4	0	107251	\N
22761	18	5	0	107252	\N
22763	123	5	0	107170	\N
22763	6652	6	0	107261	\N
22768	137	4	0	107284	\N
22768	3697	5	0	107285	\N
22770	4178	4	0	107295	\N
22770	4205	5	0	107296	\N
22772	40	21	0	106746	\N
22772	6654	22	0	107352	\N
22774	18	21	0	107355	\N
22774	6656	22	0	107356	\N
22777	273	4	0	107373	\N
22777	3777	5	0	107374	\N
22780	262	4	0	107398	\N
22780	4607	5	0	107399	\N
22783	268	7	0	107418	\N
22783	6658	8	0	107419	\N
22790	75	7	0	107470	\N
22790	2859	8	0	107471	\N
22793	40	6	0	107515	\N
22793	4255	7	0	107516	\N
22795	79	6	0	107519	\N
22795	4253	7	0	107520	\N
22800	6661	4	0	107535	\N
22800	6662	5	0	107536	\N
22806	4787	1	0	107555	\N
22806	6663	2	0	107558	\N
22811	367	3	0	107593	\N
22811	3683	4	0	107594	\N
22813	71	3	0	107603	\N
22813	3770	4	0	107604	\N
22816	279	2	0	101781	\N
22816	5593	3	0	107608	\N
22818	4178	5	0	107621	\N
22818	4202	6	0	107622	\N
22823	200	1	0	106818	\N
22823	201	2	0	107663	\N
22828	151	3	0	107695	\N
22828	3046	4	0	107696	\N
22837	251	3	0	107737	\N
22837	3514	4	0	107738	\N
22840	424	3	0	98812	\N
22840	3611	4	0	98822	\N
22843	167	0	0	105141	\N
22848	16	3	0	107798	\N
22848	3634	4	0	107799	\N
22851	186	3	0	99076	\N
22851	4294	4	0	99077	\N
22855	908	5	0	107818	\N
22855	5076	6	0	107819	\N
22860	5885	4	0	107416	\N
22860	6674	5	0	107834	\N
22861	233	4	0	100809	\N
22861	3775	5	0	101779	\N
22865	2782	5	0	107857	\N
22865	6676	6	0	107858	\N
22872	262	3	0	107884	\N
22872	4778	4	0	107885	\N
22875	449	6	0	107910	\N
22875	5168	7	0	107911	\N
22877	4178	4	0	107922	\N
22877	4205	5	0	107923	\N
22882	4172	3	0	107816	\N
22882	4275	4	0	107940	\N
22885	419	2	0	107966	\N
22885	260	7	0	107967	\N
22885	6680	8	0	107968	\N
22887	4178	4	0	107922	\N
22887	4205	5	0	107923	\N
22889	908	4	0	107985	\N
22889	3488	5	0	107986	\N
22894	16	3	0	108025	\N
22894	3634	4	0	108026	\N
22903	3227	5	0	108063	\N
22903	5643	9	0	108068	\N
22903	6682	9	0	108069	\N
22903	6684	10	1	108070	\N
22903	6683	10	0	108071	\N
22906	16	3	0	108025	\N
22906	3634	4	0	108026	\N
22916	44	2	0	106585	\N
22916	6686	3	0	108178	\N
22923	12	3	0	108225	\N
22923	4204	4	0	108226	\N
22925	149	4	0	108228	\N
22925	4040	5	0	108229	\N
22927	4178	3	0	107922	\N
22640	16	4	0	105061	\N
22647	16	7	0	106566	\N
22647	4723	8	0	106567	\N
22649	316	3	0	105640	\N
22649	4249	4	0	106576	\N
22654	4178	3	0	106597	\N
22654	4211	4	0	106598	\N
22660	46	7	0	106624	\N
22660	6632	8	0	106625	\N
22661	96	10	0	105619	\N
22661	6633	11	0	106646	\N
22664	16	0	0	102787	\N
22678	40	3	0	106746	\N
22678	372	4	0	106747	\N
22680	79	3	0	106435	\N
22680	3652	4	0	106756	\N
22687	71	4	0	106793	\N
22687	2776	5	0	106794	\N
22690	192	8	0	106090	\N
22690	4393	9	0	106817	\N
22692	35	3	0	106826	\N
22692	3563	4	0	106827	\N
22695	18	6	0	105895	\N
22695	6638	7	0	106843	\N
22698	4178	4	0	106872	\N
22698	4205	5	0	106873	\N
22701	18	4	0	105895	\N
22701	2302	5	0	106441	\N
22702	140	6	0	106890	\N
22702	5056	7	0	106891	\N
22705	4178	7	0	106872	\N
22705	4509	8	0	106910	\N
22715	235	2	0	106594	\N
22715	2757	3	0	106960	\N
22720	115	2	0	97427	\N
22720	2797	3	0	106976	\N
22724	449	2	0	106995	\N
22724	646	3	0	106996	\N
22727	6643	4	0	107005	\N
22727	262	5	0	107006	\N
22730	94	4	0	104053	\N
22730	6644	5	0	107021	\N
22738	2	6	0	107085	\N
22738	4825	7	0	107086	\N
22744	336	7	0	107138	\N
22744	3690	8	0	107139	\N
22746	75	4	0	106568	\N
22746	3959	5	0	107158	\N
22749	23	3	0	106011	\N
22749	3497	4	0	106012	\N
22753	23	2	0	106011	\N
22753	3443	3	0	107173	\N
22755	4178	10	0	107203	\N
22755	4665	11	0	107204	\N
22765	451	5	0	103732	\N
22765	6653	6	0	107262	\N
22767	402	2	0	99166	\N
22767	2760	3	0	107275	\N
22776	123	3	0	107363	\N
22776	2856	4	0	107364	\N
22779	18	3	0	107388	\N
22779	3621	4	0	107389	\N
22782	5885	7	0	107416	\N
22782	6657	8	0	107417	\N
22784	230	7	0	103259	\N
22784	5228	8	0	107420	\N
22787	453	4	0	101538	\N
22787	4108	5	0	104854	\N
22789	4172	8	0	107454	\N
22789	4347	9	0	107455	\N
22792	40	3	0	106746	\N
22792	372	4	0	106747	\N
22799	4172	4	0	107533	\N
22799	4219	5	0	107534	\N
22804	424	3	0	98812	\N
22804	3611	4	0	98822	\N
22808	4178	3	0	107576	\N
22808	4211	4	0	107577	\N
22817	4172	5	0	107619	\N
22817	4634	6	0	107620	\N
22820	336	3	0	107138	\N
22820	3400	4	0	107644	\N
22825	1636	10	0	95993	\N
22825	6666	11	0	107684	\N
22830	145	4	0	107705	\N
22830	3867	5	0	107706	\N
22835	60	3	0	107722	\N
22835	6670	4	1	107727	\N
22835	749	4	0	107728	\N
22835	6671	5	0	107729	\N
22839	167	3	0	105141	\N
22839	4028	4	0	107761	\N
22842	167	0	0	105141	\N
22845	40	4	0	107515	\N
22845	2796	5	0	107778	\N
22850	167	3	0	107802	\N
22850	4028	4	0	107803	\N
22853	167	1	0	107804	\N
22853	2503	2	0	107805	\N
22854	4172	5	0	107816	\N
22854	4415	6	0	107817	\N
22856	908	4	0	107818	\N
22856	6672	5	0	107821	\N
22859	4178	5	0	107800	\N
22859	4429	6	0	107833	\N
22867	90	4	0	102219	\N
22867	3731	5	0	103054	\N
22870	110	5	0	107869	\N
22870	3916	6	0	107873	\N
22871	4178	3	0	107800	\N
22871	4211	4	0	107801	\N
22874	264	6	0	105232	\N
22874	5480	7	0	107909	\N
22879	132	4	0	107925	\N
22879	3716	5	0	107926	\N
22881	431	2	0	107932	\N
22881	2772	3	0	107933	\N
22884	585	2	0	107955	\N
22884	258	7	0	107964	\N
22884	3057	8	0	107965	\N
22891	113	3	0	108015	\N
22891	3620	4	0	108016	\N
22893	279	2	0	101781	\N
22893	4525	3	0	108018	\N
22896	288	4	0	82764	\N
22896	5631	5	0	83896	\N
22898	40	3	0	107515	\N
22898	372	4	0	108045	\N
22901	3628	3	0	108056	\N
22901	3785	4	0	108057	\N
22905	4172	3	0	108085	\N
22905	4275	4	0	108086	\N
22908	132	12	0	108117	\N
22908	3826	13	0	108120	\N
22913	4172	10	0	108085	\N
22913	4663	11	0	108157	\N
22918	71	4	0	108188	\N
22918	3887	5	0	108189	\N
22920	16	4	0	108210	\N
22920	3546	5	0	108211	\N
22922	149	4	0	108221	\N
22922	4040	5	0	108222	\N
22924	96	4	0	105619	\N
22924	3515	5	0	108227	\N
22926	145	4	0	108230	\N
22926	3867	5	0	108231	\N
22929	440	63	0	108243	\N
22929	6690	64	0	108255	\N
22933	440	3	0	108243	\N
22933	6692	4	1	108262	\N
22933	6691	4	0	108263	\N
22933	6701	5	1	108271	\N
22933	6700	5	0	108272	\N
22936	4172	4	0	108285	\N
22936	4219	5	0	108286	\N
22939	189	3	0	106466	\N
22939	3782	4	0	106470	\N
22759	4219	5	0	107231	\N
22764	451	5	0	103732	\N
22764	6653	6	0	107262	\N
22766	4178	3	0	107269	\N
22766	4211	4	0	107270	\N
22769	135	4	0	105798	\N
22769	3696	5	0	107286	\N
22771	2	6	0	107309	\N
22771	4825	7	0	107310	\N
22773	4178	21	0	107353	\N
22773	6655	22	0	107354	\N
22775	123	3	0	107363	\N
22775	2856	4	0	107364	\N
22778	4178	3	0	107353	\N
22778	4211	4	0	107381	\N
22781	4178	4	0	107400	\N
22781	4205	5	0	107401	\N
22785	373	3	0	107427	\N
22785	3590	4	0	107428	\N
22788	453	3	0	101538	\N
22788	6659	4	0	107437	\N
22791	4450	1	0	107474	\N
22791	4178	12	0	107495	\N
22791	6660	13	0	107496	\N
22794	108	6	0	107517	\N
22794	5748	7	0	107518	\N
22796	108	2	0	107517	\N
22796	501	3	0	107521	\N
22798	212	6	0	107523	\N
22798	3554	7	0	107524	\N
22801	164	4	0	107537	\N
22801	4152	5	0	107538	\N
22802	4172	3	0	107545	\N
22802	4275	4	0	107546	\N
22809	6665	4	0	107585	\N
22812	75	3	0	107595	\N
22812	3855	4	0	107596	\N
22814	16	3	0	107605	\N
22814	3634	4	0	107606	\N
22821	27	4	0	107653	\N
22821	3717	5	0	107654	\N
22826	44	7	0	106585	\N
22826	4511	8	0	107688	\N
22831	16	4	0	107605	\N
22831	3546	5	0	107715	\N
22833	60	3	0	107722	\N
22833	6669	5	0	107725	\N
22838	16	7	0	107753	\N
22838	4723	8	0	107754	\N
22844	16	3	0	107768	\N
22844	3634	4	0	107769	\N
22846	4178	5	0	107782	\N
22846	4429	6	0	107783	\N
22857	5885	5	0	107416	\N
22857	6212	6	0	107831	\N
22862	4088	4	0	107842	\N
22862	4089	5	0	107843	\N
22866	102	4	0	104738	\N
22866	3572	5	0	107867	\N
22868	2578	4	0	103628	\N
22868	3902	5	0	107868	\N
22888	88	4	0	107983	\N
22888	3809	5	0	107984	\N
22890	908	47	0	107985	\N
22890	6681	48	0	108008	\N
22892	208	3	0	106505	\N
22892	4490	4	0	107607	\N
22897	210	4	0	108037	\N
22897	3536	5	0	108038	\N
22899	145	3	0	108046	\N
22899	4908	4	0	108047	\N
22902	119	3	0	101527	\N
22902	2860	4	0	108058	\N
22909	16	3	0	108127	\N
22909	3634	4	0	108128	\N
22911	40	3	0	107515	\N
22911	372	4	0	108045	\N
22914	16	4	0	108166	\N
22914	3546	5	0	108167	\N
22919	149	29	0	108208	\N
22919	6688	30	0	108209	\N
22921	149	4	0	108208	\N
22921	4040	5	0	108212	\N
22934	1470	4	0	108281	\N
22934	5655	5	0	108282	\N
22938	2	3	0	107920	\N
22938	3548	4	0	108295	\N
22941	453	97	0	101538	\N
22941	6702	98	0	108325	\N
22943	4233	6	0	108342	\N
22943	6704	7	0	108344	\N
22946	20	3	0	108381	\N
22946	2844	4	0	108382	\N
22949	30	3	0	107071	\N
22949	3640	4	0	108386	\N
22955	453	3	0	108440	\N
22955	2838	4	0	108441	\N
22959	56	4	0	101950	\N
22959	3127	5	0	101951	\N
22963	4233	3	0	108510	\N
22963	4425	4	0	108511	\N
22968	4178	6	0	108508	\N
22968	4250	7	0	108539	\N
22974	64	3	0	106564	\N
22974	4217	4	0	108560	\N
22976	38	2	0	108567	\N
22976	4009	3	0	108570	\N
22979	170	2	0	108578	\N
22979	1380	3	0	108579	\N
22982	4178	8	0	108649	\N
22982	4237	9	0	108650	\N
22985	4233	10	0	108672	\N
22985	6719	11	0	108677	\N
22987	528	6	0	105432	\N
22987	6720	7	0	108689	\N
22995	210	6	0	108742	\N
22995	3721	7	0	108743	\N
22996	285	14	0	100392	\N
22996	2118	15	0	108772	\N
22998	2	3	0	108781	\N
22998	3548	4	0	108782	\N
23002	251	3	0	108795	\N
23002	3514	4	0	108796	\N
23005	6724	4	0	108822	\N
23007	77	3	0	106155	\N
23007	1877	4	0	108825	\N
23008	77	2	0	106155	\N
23008	3853	3	0	108827	\N
23011	1549	8	0	108843	\N
23011	6726	9	0	108844	\N
23013	40	3	0	108779	\N
23013	372	4	0	108780	\N
23018	108	13	0	108883	\N
23018	6731	14	0	108887	\N
23022	4178	3	0	108899	\N
23022	4211	4	0	108900	\N
23025	135	3	0	108903	\N
23025	3630	4	0	108904	\N
23027	137	1	0	107284	\N
23027	138	2	0	108907	\N
22833	6667	4	0	138687	\N
22833	6668	4	1	138688	\N
22900	3625	3	0	108054	\N
22900	3784	4	0	108055	\N
22904	23	4	0	106011	\N
22904	3189	5	0	108078	\N
22907	132	15	0	108117	\N
22907	6685	16	0	108118	\N
22910	92	3	0	106840	\N
22910	4410	4	0	108129	\N
22912	4178	3	0	107922	\N
22912	4211	4	0	108136	\N
22915	1636	4	0	108175	\N
22915	4118	5	0	108176	\N
22917	373	4	0	108179	\N
22917	6687	5	0	108180	\N
22928	440	20	0	108243	\N
22928	6689	21	0	108244	\N
22932	6695	0	0	108266	\N
22932	6696	0	0	108267	\N
22935	202	4	0	108283	\N
22935	3673	5	0	108284	\N
22944	4178	16	0	108287	\N
22944	4708	17	0	108373	\N
22947	4178	3	0	108287	\N
22947	4211	4	0	108383	\N
22950	6706	48	0	108387	\N
22950	326	126	0	108388	\N
22950	6707	127	0	108389	\N
22951	4178	8	0	108287	\N
22951	4218	9	0	108405	\N
22953	6709	14	0	108409	\N
22953	149	53	0	108431	\N
22953	6710	54	0	108432	\N
22956	6711	22	0	108442	\N
22956	453	40	0	108448	\N
22956	6712	41	0	108449	\N
22961	140	3	0	106890	\N
22961	4149	4	0	108507	\N
22965	4233	2	0	108510	\N
22965	6713	3	0	108514	\N
22970	58	2	0	108545	\N
22970	2853	3	0	108546	\N
22972	279	2	0	101781	\N
22972	4525	3	0	108018	\N
22977	56	2	0	101950	\N
22977	2795	3	0	108575	\N
22980	6716	102	0	108629	\N
22980	170	121	0	108630	\N
22980	6717	122	0	108631	\N
22983	449	7	0	107910	\N
22983	6718	8	0	108665	\N
22990	322	4	0	108700	\N
22990	6722	5	0	108701	\N
22999	1470	3	0	108789	\N
22999	3838	4	0	108790	\N
23003	4172	3	0	108803	\N
23003	4275	4	0	108804	\N
23014	64	3	0	108854	\N
23014	4217	4	0	108855	\N
23020	149	58	0	108893	\N
23020	6732	59	0	108894	\N
22927	4211	4	0	108136	\N
22930	440	3	0	108243	\N
22931	6695	1	0	108266	\N
22931	6696	1	0	108267	\N
22931	6698	2	1	108268	\N
22931	6697	2	0	108269	\N
22931	6699	3	0	108270	\N
22937	4178	4	0	108287	\N
22937	4205	5	0	108288	\N
22940	453	3	0	101538	\N
22940	2838	4	0	101539	\N
22945	164	16	0	107537	\N
22945	6705	17	0	108374	\N
22948	326	3	0	108384	\N
22948	3339	4	0	108385	\N
22954	149	3	0	108228	\N
22954	4189	4	0	108433	\N
22958	262	4	0	108497	\N
22958	4607	5	0	108498	\N
22960	300	4	0	108499	\N
22960	6350	5	0	108500	\N
22962	4178	3	0	108508	\N
22962	4211	4	0	108509	\N
22964	164	3	0	108512	\N
22964	3385	4	0	108513	\N
22967	35	3	0	108523	\N
22967	3563	4	0	108526	\N
22969	262	2	0	108497	\N
22969	2743	3	0	108544	\N
22971	208	2	0	108547	\N
22971	4524	3	0	108548	\N
22978	517	2	0	108576	\N
22978	6715	3	0	108577	\N
22981	56	8	0	101950	\N
22981	4150	9	0	108648	\N
22984	4233	3	0	108672	\N
22984	4425	4	0	108673	\N
22986	4233	2	0	108672	\N
22986	6713	3	0	108678	\N
22989	192	5	0	108697	\N
22989	6721	6	0	108698	\N
22992	18	5	0	108711	\N
22992	3550	6	0	108712	\N
22994	4178	4	0	108649	\N
22994	4205	5	0	108729	\N
23001	4178	3	0	108793	\N
23001	4211	4	0	108794	\N
23010	6044	8	0	104032	\N
23010	6725	9	0	108842	\N
23015	64	1	0	108854	\N
23015	65	2	0	108856	\N
23017	108	13	0	108883	\N
23017	6729	14	1	108884	\N
23017	6728	14	0	108885	\N
23017	6730	15	0	108886	\N
23019	108	13	0	108883	\N
23019	6731	14	0	108887	\N
23021	4172	0	0	108803	\N
23024	18	3	0	108901	\N
23024	3621	4	0	108902	\N
22930	6691	4	0	138689	\N
22930	6692	4	1	138690	\N
22930	6693	5	0	138691	\N
22930	6694	5	1	138692	\N
22942	4233	8	0	108342	\N
22942	6703	9	0	108343	\N
22952	56	8	0	101950	\N
22952	6708	9	0	108406	\N
22957	4172	19	0	108285	\N
22957	6603	20	0	108488	\N
22966	35	4	0	108523	\N
22966	3545	5	0	108524	\N
22973	3911	4	0	108557	\N
22973	6695	5	0	108558	\N
22973	6714	5	0	108559	\N
22975	38	3	0	108567	\N
22975	3457	4	0	108568	\N
22988	528	4	0	105432	\N
22988	5689	5	0	108690	\N
22991	186	5	0	99076	\N
22991	3280	6	0	108710	\N
22993	56	3	0	108719	\N
22993	4109	4	0	108720	\N
22997	40	3	0	108779	\N
22997	372	4	0	108780	\N
23000	2	3	0	108791	\N
23000	3548	4	0	108792	\N
23004	42	4	0	108813	\N
23004	3896	5	0	108814	\N
23006	123	3	0	108823	\N
23006	2856	4	0	108824	\N
23009	40	8	0	108779	\N
23009	3718	9	0	108841	\N
23012	6044	7	0	104032	\N
23012	6727	8	0	108847	\N
23016	4178	0	0	108793	\N
23023	4172	0	0	108803	\N
23026	149	3	0	108905	\N
23026	4189	4	0	108906	\N
23029	4172	2	0	108912	\N
23029	4191	3	0	108913	\N
23030	181	3	0	104252	\N
23030	4184	4	0	106969	\N
23031	56	3	0	108916	\N
23031	4109	4	0	108917	\N
23032	18	3	0	108901	\N
23032	3621	4	0	108902	\N
23033	33	7	0	106503	\N
23033	5284	8	0	108931	\N
23034	125	10	0	108952	\N
23034	6733	11	0	108953	\N
23035	42	10	0	108954	\N
23035	6734	11	0	108955	\N
23036	54	10	0	108976	\N
23036	6472	11	0	108977	\N
23037	954	10	0	108978	\N
23037	6735	11	0	108979	\N
23038	96	7	0	105619	\N
23038	3750	8	0	108994	\N
23039	4178	7	0	108995	\N
23039	4396	8	0	108996	\N
23040	4172	3	0	109003	\N
23040	4275	4	0	109004	\N
23041	1130	3	0	25429	\N
23041	6736	4	0	109005	\N
23042	528	3	0	109012	\N
23042	4262	4	0	109013	\N
23043	90	3	0	102219	\N
23043	4074	4	0	109014	\N
23044	181	4	0	104252	\N
23044	4058	5	0	109023	\N
23045	4178	4	0	108995	\N
23045	4205	5	0	109024	\N
23046	75	3	0	107595	\N
23046	3855	4	0	107596	\N
23047	142	23	0	109031	\N
23047	6737	24	0	109032	\N
23048	210	7	0	109047	\N
23048	5940	8	0	109048	\N
23049	142	7	0	109031	\N
23049	6504	8	0	109049	\N
23050	4172	3	0	109056	\N
23050	4275	4	0	109057	\N
23051	121	3	0	106605	\N
23051	4471	4	0	106606	\N
23052	637	2	0	109062	\N
23052	6738	3	0	109063	\N
23053	200	7	0	106818	\N
23053	5445	8	0	109078	\N
23054	1109	7	0	109079	\N
23054	4145	8	0	109080	\N
23055	16	3	0	108210	\N
23055	3634	4	0	109087	\N
23056	96	3	0	109094	\N
23056	2803	4	0	109095	\N
23057	142	0	0	109096	\N
23058	4211	3	0	108996	\N
23058	4178	5	0	109105	\N
23058	4460	6	0	109106	\N
23059	4254	3	0	109107	\N
23059	142	5	0	109108	\N
23059	3117	6	0	109109	\N
23060	3548	3	0	109110	\N
23060	2	5	0	108792	\N
23060	1091	6	0	109111	\N
23061	4178	6	0	109124	\N
23061	4250	7	0	109125	\N
23062	38	6	0	109126	\N
23062	6005	7	0	109127	\N
23064	908	4	0	109136	\N
23064	3488	5	0	109137	\N
23065	115	4	0	97427	\N
23065	4844	5	0	109138	\N
23066	149	4	0	108905	\N
23066	4040	5	0	109139	\N
23067	285	6	0	109152	\N
23067	3903	7	0	109153	\N
23068	251	6	0	108795	\N
23068	4183	7	0	109154	\N
23069	142	0	0	109155	\N
23070	181	3	0	104252	\N
23070	4184	4	0	106969	\N
23071	142	3	0	109162	\N
23071	4254	4	0	109108	\N
23072	92	4	0	106840	\N
23072	3979	5	0	109171	\N
23073	132	4	0	109172	\N
23073	3716	5	0	109173	\N
23074	4178	3	0	109124	\N
23074	4211	4	0	109180	\N
23075	16	3	0	109181	\N
23075	3634	4	0	109182	\N
23076	42	2	0	108954	\N
23076	3310	3	0	109187	\N
23077	123	5	0	108823	\N
23077	6652	6	0	109198	\N
23078	6739	5	0	109202	\N
23079	123	4	0	108823	\N
23079	4090	5	0	109203	\N
23080	402	3	0	109210	\N
23080	4077	4	0	109211	\N
23081	424	3	0	98812	\N
23081	3611	4	0	98822	\N
23082	4172	4	0	109056	\N
23082	4219	5	0	109226	\N
23083	16	3	0	109233	\N
23083	3634	4	0	109234	\N
23084	40	10	0	109255	\N
23084	4104	11	0	109256	\N
23085	451	2	0	103732	\N
23085	3317	3	0	109261	\N
23086	451	3	0	103732	\N
23086	3934	4	0	109264	\N
23087	135	3	0	108903	\N
23087	3630	4	0	108904	\N
23088	137	3	0	107284	\N
23088	3633	4	0	109265	\N
23089	94	72	0	107844	\N
23089	6740	73	0	109313	\N
23090	16	17	0	109328	\N
23090	6741	18	0	109329	\N
23093	4172	7	0	109358	\N
23093	4614	8	0	109359	\N
23100	18	1	0	108901	\N
23100	1426	2	0	109395	\N
23112	4178	3	0	109458	\N
23112	4211	4	0	109459	\N
23115	852	10	0	104855	\N
23115	6744	11	0	109489	\N
23122	244	3	0	106944	\N
23122	4075	4	0	109526	\N
23128	23	5	0	109565	\N
23128	6746	6	0	109566	\N
23131	793	5	0	109602	\N
23131	6750	6	0	109603	\N
23132	2291	4	0	109612	\N
23132	6751	7	0	109617	\N
23132	6752	7	0	109618	\N
23136	77	76	0	109663	\N
23136	6756	77	0	109664	\N
23137	16	9	0	109442	\N
23137	6757	10	0	109678	\N
23142	137	7	0	107284	\N
23142	4722	8	0	109700	\N
23143	38	3	0	109707	\N
23143	3457	4	0	5707	\N
23150	132	3	0	109172	\N
23150	3729	4	0	109763	\N
23155	244	2	0	109788	\N
23155	3308	3	0	109789	\N
23161	6763	3	0	109833	\N
23162	285	5	0	109844	\N
23162	5103	6	0	109845	\N
23167	3208	2	0	109862	\N
23167	6767	3	0	109863	\N
23172	4178	3	0	109875	\N
23172	4211	4	0	109876	\N
23178	908	2	0	109968	\N
23178	2832	3	0	109969	\N
23179	6770	98	0	109982	\N
23179	177	126	0	109987	\N
23179	6771	127	0	109988	\N
23181	588	4	0	109993	\N
23181	14	13	0	109999	\N
23181	6775	14	0	110015	\N
23185	2	7	0	110033	\N
23185	6780	8	0	110034	\N
23186	411	5	0	104684	\N
23186	3345	6	0	110045	\N
23187	20	2	0	108381	\N
23187	369	3	0	110050	\N
23191	241	2	0	110059	\N
23191	634	3	0	110060	\N
23192	5885	3	0	110067	\N
23192	5926	4	0	110068	\N
23196	79	3	0	107519	\N
23196	3652	4	0	110074	\N
23203	56	4	0	108916	\N
23203	3556	5	0	110110	\N
23207	451	2	0	103732	\N
23207	3317	3	0	109261	\N
23211	451	1	0	103732	\N
23211	3260	2	0	110125	\N
23212	4172	2	0	110069	\N
23212	4191	3	0	110130	\N
23216	56	3	0	110157	\N
23216	1188	4	0	110158	\N
23217	4178	2	0	110071	\N
23217	4247	3	0	110131	\N
23222	6785	32	0	110182	\N
23222	367	68	0	110197	\N
23222	6786	69	0	110198	\N
23227	424	5	0	110213	\N
23227	6790	6	0	110214	\N
23231	40	2	0	109780	\N
23231	282	3	0	110224	\N
23232	86	2	0	97155	\N
23232	3321	3	0	110229	\N
23237	266	2	0	110246	\N
23237	2103	3	0	110247	\N
23242	151	2	0	110260	\N
23242	2854	3	0	110261	\N
23243	2	2	0	110266	\N
23243	2789	3	0	110267	\N
23248	20	2	0	108381	\N
23248	6373	3	1	110285	\N
23248	6795	3	0	110286	\N
23248	6797	4	1	110287	\N
23248	6796	4	0	110288	\N
23252	258	2	0	110293	\N
23252	3275	3	0	110294	\N
23253	4178	2	0	110248	\N
23253	4247	3	0	110249	\N
23258	167	2	0	110277	\N
23258	3322	3	0	110318	\N
23264	75	3	0	110320	\N
23264	3855	4	0	110340	\N
23268	4178	2	0	110349	\N
23268	4247	3	0	110350	\N
23269	2351	2	0	110355	\N
23269	2754	3	0	110356	\N
23275	40	2	0	110238	\N
23275	282	3	0	110239	\N
23281	4172	2	0	110403	\N
23281	4191	3	0	110404	\N
23288	365	2	0	107205	\N
23288	615	3	0	110459	\N
23295	4178	4	0	110515	\N
23295	4331	5	0	110516	\N
23302	6807	88	0	110598	\N
23302	4	126	0	110636	\N
23302	6779	127	0	110637	\N
23306	2782	2	0	110644	\N
23306	2784	3	0	110645	\N
23307	56	2	0	110650	\N
23307	2795	3	0	110651	\N
23308	149	4	0	110660	\N
23308	5500	5	0	110661	\N
23314	373	0	0	110688	\N
23315	224	4	0	110697	\N
23315	3281	5	0	110698	\N
23321	2636	2	0	110726	\N
23321	2836	3	0	110727	\N
23327	18	0	0	110745	\N
23331	4178	2	0	110753	\N
23331	4247	3	0	110754	\N
23336	424	2	0	110213	\N
23336	2755	3	0	110771	\N
23337	79	2	0	110776	\N
23337	616	3	0	110777	\N
23342	16	4	0	110701	\N
23342	2575	5	0	110702	\N
23343	5611	5	0	110806	\N
23343	6814	6	0	110807	\N
23344	108	2	0	110812	\N
23344	3340	3	0	110813	\N
23350	4	4	0	110835	\N
23350	6361	5	0	110836	\N
23354	149	2	0	110941	\N
23354	1379	3	0	110942	\N
23360	195	1	0	110969	\N
23360	125	3	0	110970	\N
23360	1185	4	0	110971	\N
23361	40	3	0	110743	\N
23361	372	4	0	110976	\N
23369	4178	4	0	111023	\N
23369	4331	5	0	111024	\N
23373	42	2	0	111032	\N
23373	3310	3	0	111033	\N
23374	6825	3	0	111038	\N
23379	40	2	0	111054	\N
23379	282	3	0	111055	\N
23385	264	2	0	111079	\N
23091	224	3	0	104125	\N
23091	3603	4	0	105172	\N
23094	2	7	0	108791	\N
23094	2858	8	0	109360	\N
23096	1636	3	0	108175	\N
23096	5514	4	0	109368	\N
23099	6742	3	0	109391	\N
23099	6743	4	0	109392	\N
23101	189	3	0	106466	\N
23101	3782	4	0	106470	\N
23104	1636	3	0	109422	\N
23104	5514	4	0	109423	\N
23106	40	3	0	109430	\N
23106	372	4	0	109431	\N
23109	16	4	0	109442	\N
23109	3546	5	0	109443	\N
23113	262	4	0	108497	\N
23113	4607	5	0	108498	\N
23116	4172	4	0	109358	\N
23116	4219	5	0	109498	\N
23121	241	3	0	106117	\N
23121	3613	4	0	109519	\N
23124	75	7	0	109543	\N
23124	2859	8	0	109544	\N
23134	2291	4	0	109612	\N
23134	14	10	0	109628	\N
23134	6755	11	0	109629	\N
23140	4178	7	0	109696	\N
23140	4396	8	0	109697	\N
23146	2	3	0	108791	\N
23146	3548	4	0	108792	\N
23148	365	3	0	107205	\N
23148	3839	4	0	109760	\N
23153	189	4	0	109782	\N
23153	3992	5	0	109783	\N
23157	244	1	0	109788	\N
23157	245	2	0	109813	\N
23158	96	7	0	109824	\N
23158	6762	8	0	109825	\N
23165	212	4	0	107523	\N
23165	4574	5	0	109857	\N
23170	40	3	0	109780	\N
23170	372	4	0	109873	\N
23174	6768	67	0	109884	\N
23174	336	126	0	109943	\N
23174	6769	127	0	109944	\N
23175	14	3	0	109951	\N
23175	1786	4	0	109952	\N
23183	684	4	0	110019	\N
23183	4	13	0	110020	\N
23183	6777	14	0	110021	\N
23189	285	2	0	110056	\N
23189	3036	3	0	110057	\N
23194	4178	3	0	110071	\N
23194	4211	4	0	110072	\N
23198	324	2	0	102019	\N
23198	2808	3	0	110081	\N
23199	164	2	0	108512	\N
23199	1124	3	0	110086	\N
23205	110	4	0	107869	\N
23205	4552	5	0	110113	\N
23209	173	2	0	110121	\N
23209	2102	3	0	110122	\N
23214	1279	50	0	110132	\N
23214	94	126	0	110147	\N
23214	6782	127	1	110148	\N
23214	6781	127	0	110149	\N
23219	1109	5	0	110165	\N
23219	6783	6	0	110166	\N
23225	2	5	0	110210	\N
23225	6461	6	0	110211	\N
23229	62	0	0	98994	\N
23234	4178	1	0	110071	\N
23234	4460	2	0	110233	\N
23235	40	2	0	110238	\N
23235	282	3	0	110239	\N
23240	6723	2	0	110254	\N
23240	6763	3	0	110255	\N
23246	115	4	0	97427	\N
23246	6794	5	0	110279	\N
23250	206	7	0	110291	\N
23250	6798	8	0	110292	\N
23255	27	2	0	110301	\N
23255	645	3	0	110302	\N
23260	75	2	0	110320	\N
23260	284	3	0	110321	\N
23261	288	2	0	82764	\N
23261	2842	3	0	109864	\N
23266	119	2	0	101527	\N
23266	1879	3	0	110346	\N
23271	2351	1	0	110355	\N
23271	2925	2	0	110359	\N
23272	6800	7	0	110372	\N
23278	4178	1	0	110349	\N
23278	4450	2	0	110392	\N
23279	208	2	0	108547	\N
23279	4524	3	0	108548	\N
23284	6802	50	0	110413	\N
23284	94	111	0	110432	\N
23284	2018	112	0	110433	\N
23285	5885	6	0	110067	\N
23285	6803	7	0	110446	\N
23290	4952	81	1	110463	\N
23290	6805	81	0	110464	\N
23290	365	126	0	110486	\N
23290	3420	127	0	110487	\N
23291	224	4	0	110496	\N
23291	3281	5	0	110497	\N
23292	56	2	0	110502	\N
23292	2795	3	0	110503	\N
23293	528	4	0	109012	\N
23293	3353	5	0	110512	\N
23297	33	2	0	110118	\N
23297	2822	3	0	110119	\N
23298	16	4	0	110300	\N
23298	2575	5	0	110529	\N
23299	4172	2	0	110403	\N
23299	4191	3	0	110404	\N
23304	2782	2	0	110644	\N
23304	2784	3	0	110645	\N
23310	4178	2	0	110668	\N
23310	4247	3	0	110669	\N
23311	367	1	0	110672	\N
23311	368	2	0	110673	\N
23317	16	4	0	110701	\N
23317	2575	5	0	110702	\N
23318	88	4	0	107983	\N
23318	5262	5	0	110711	\N
23324	18	1	0	110733	\N
23324	1426	2	0	110734	\N
23329	137	4	0	107284	\N
23329	4352	5	0	110746	\N
23334	793	2	0	109602	\N
23334	4363	3	0	110764	\N
23339	14	2	0	110782	\N
23339	1785	3	0	110783	\N
23340	56	4	0	110792	\N
23340	3556	5	0	110793	\N
23346	324	1	0	110816	\N
23346	939	2	0	110817	\N
23352	4178	4	0	110837	\N
23352	4331	5	0	110838	\N
23358	26	1	0	110962	\N
23358	6817	2	0	110963	\N
23358	6818	2	0	110964	\N
23364	260	2	0	110987	\N
23364	3184	3	0	110988	\N
23365	4178	4	0	110997	\N
23365	4331	5	0	110998	\N
23371	167	2	0	111025	\N
23371	3322	3	0	111030	\N
23376	595	2	0	111039	\N
23376	3285	3	0	111040	\N
23377	110	5	0	107869	\N
23377	6619	6	0	111051	\N
23382	4178	2	0	111061	\N
23092	54	3	0	109342	\N
23092	3041	4	0	109343	\N
23095	266	7	0	107165	\N
23095	4926	8	0	109361	\N
23097	44	3	0	109369	\N
23097	3631	4	0	109370	\N
23102	214	4	0	106712	\N
23102	3807	5	0	109409	\N
23105	44	3	0	109369	\N
23105	3631	4	0	109370	\N
23107	2636	4	0	102896	\N
23107	3617	5	0	106530	\N
23111	2578	3	0	109450	\N
23111	4431	4	0	109451	\N
23114	206	0	0	109468	\N
23117	1109	1	0	109079	\N
23117	2971	2	0	109499	\N
23119	244	6	0	106944	\N
23119	6406	7	0	106945	\N
23125	228	1	0	109547	\N
23125	1432	2	0	109548	\N
23127	69	5	0	107011	\N
23127	6745	6	0	109564	\N
23130	6747	121	1	109595	\N
23130	6029	121	0	109596	\N
23130	6748	122	0	109597	\N
23130	23	125	0	109598	\N
23130	1699	126	1	109599	\N
23130	6698	126	0	109600	\N
23130	6749	127	0	109601	\N
23135	5497	4	0	109630	\N
23135	77	8	0	109632	\N
23135	5568	9	0	109633	\N
23141	135	7	0	109698	\N
23141	4721	8	0	109699	\N
23149	230	3	0	109761	\N
23149	4181	4	0	109762	\N
23154	77	0	0	109663	\N
23159	4178	7	0	109696	\N
23159	4509	8	0	109826	\N
23160	123	2	0	109831	\N
23160	1868	3	0	109832	\N
23166	58	2	0	108545	\N
23166	2853	3	0	108546	\N
23171	210	3	0	109047	\N
23171	3539	4	0	109874	\N
23176	14	5	0	109951	\N
23176	5648	6	0	109958	\N
23177	4172	4	0	109871	\N
23177	4219	5	0	109963	\N
23180	588	4	0	109993	\N
23180	14	8	0	109999	\N
23180	6774	10	0	110002	\N
23184	6778	88	0	110022	\N
23184	4	126	0	110023	\N
23184	6779	127	0	110024	\N
23188	156	2	0	107547	\N
23188	4485	3	0	110051	\N
23193	4172	3	0	110069	\N
23193	4275	4	0	110070	\N
23197	79	1	0	107519	\N
23197	1126	2	0	110076	\N
23204	145	4	0	110111	\N
23204	5607	5	0	110112	\N
23208	79	2	0	107519	\N
23208	616	3	0	110120	\N
23213	4178	2	0	110071	\N
23213	4247	3	0	110131	\N
23218	852	2	0	110163	\N
23218	2872	3	0	110164	\N
23223	6787	0	0	110199	\N
23223	6788	0	0	110200	\N
23224	62	0	0	98994	\N
23228	6791	124	0	110215	\N
23228	62	126	0	110216	\N
23228	3130	127	0	110217	\N
23233	6323	2	0	98831	\N
23233	6792	3	0	110230	\N
23238	4178	2	0	110248	\N
23238	4247	3	0	110249	\N
23239	123	2	0	109831	\N
23239	1868	3	0	109832	\N
23244	18	6	0	108901	\N
23244	6793	7	0	110268	\N
23245	167	4	0	110277	\N
23245	3428	5	0	110278	\N
23249	58	2	0	110289	\N
23249	2853	3	0	110290	\N
23254	6799	2	0	110299	\N
23254	388	3	0	110300	\N
23259	322	2	0	110123	\N
23259	1866	3	0	110319	\N
23265	3625	2	0	108054	\N
23265	4359	3	0	110345	\N
23270	14	2	0	110357	\N
23270	1785	3	0	110358	\N
23276	324	2	0	110379	\N
23276	2808	3	0	110380	\N
23277	244	4	0	109788	\N
23277	3447	5	0	110389	\N
23282	1151	2	0	110405	\N
23282	6801	3	0	110406	\N
23283	38	2	0	110411	\N
23283	4009	3	0	110412	\N
23289	6	2	0	110460	\N
23289	2805	3	0	110461	\N
23296	285	2	0	110056	\N
23296	3036	3	0	110057	\N
23303	14	2	0	110642	\N
23303	1785	3	0	110643	\N
23309	4172	2	0	110666	\N
23309	4191	3	0	110667	\N
23316	431	4	0	110699	\N
23316	3565	5	0	110700	\N
23322	528	2	0	109012	\N
23322	2765	3	0	110728	\N
23323	14	2	0	110642	\N
23323	1785	3	0	110643	\N
23328	135	0	0	109698	\N
23332	6810	86	0	110755	\N
23332	92	99	0	110756	\N
23332	6811	100	0	110757	\N
23333	6812	0	0	110758	\N
23333	6813	0	0	110759	\N
23338	79	0	0	107519	\N
23345	2636	2	0	110726	\N
23345	2836	3	0	110727	\N
23351	16	4	0	110701	\N
23351	2575	5	0	110702	\N
23355	264	2	0	110943	\N
23355	2780	3	0	110944	\N
23356	125	4	0	110953	\N
23356	3356	5	0	110954	\N
23357	140	2	0	106890	\N
23357	3183	3	0	110959	\N
23362	488	2	0	110981	\N
23362	2791	3	0	110982	\N
23363	186	2	0	99076	\N
23363	1850	3	0	107172	\N
23370	167	0	0	111025	\N
23375	597	2	0	92732	\N
23375	3286	3	0	96813	\N
23380	125	2	0	111056	\N
23380	3297	3	0	110971	\N
23381	4172	2	0	110666	\N
23381	4191	3	0	110667	\N
23386	841	2	0	111081	\N
23386	3316	3	0	111082	\N
23387	251	4	0	111083	\N
23387	6828	5	0	111084	\N
23388	18	1	0	111085	\N
23388	19	2	0	111086	\N
23390	4172	10	0	111108	\N
23390	6829	11	0	111109	\N
23391	40	10	0	111054	\N
23098	16	6	0	109383	\N
23098	3369	7	0	109384	\N
23103	4178	3	0	109124	\N
23103	4211	4	0	109180	\N
23108	230	4	0	109440	\N
23108	3954	5	0	109441	\N
23110	56	3	0	108916	\N
23110	4109	4	0	108917	\N
23118	18	0	0	105744	\N
23120	1109	6	0	109079	\N
23120	4548	7	0	109512	\N
23123	449	3	0	109527	\N
23123	4760	4	0	109528	\N
23126	228	3	0	109547	\N
23126	3186	4	0	109553	\N
23129	79	5	0	107519	\N
23129	5993	6	0	109567	\N
23133	2291	4	0	109612	\N
23133	14	10	0	109628	\N
23133	6755	11	0	109629	\N
23138	6044	9	0	109679	\N
23138	6758	10	0	109680	\N
23139	285	7	0	109152	\N
23139	5812	8	0	109695	\N
23144	4172	4	0	109716	\N
23144	4219	5	0	109717	\N
23145	4172	3	0	109724	\N
23145	4275	4	0	109725	\N
23147	4172	10	0	109752	\N
23147	4663	11	0	109753	\N
23151	6648	81	0	109764	\N
23151	365	126	0	109770	\N
23151	6759	127	0	109771	\N
23152	40	4	0	109780	\N
23152	3381	5	0	109781	\N
23156	6760	31	0	109800	\N
23156	77	48	0	109811	\N
23156	6761	49	0	109812	\N
23163	30	5	0	107071	\N
23163	6764	6	0	109846	\N
23164	6766	5	0	109856	\N
23168	288	2	0	82764	\N
23168	2842	3	0	109864	\N
23169	4172	3	0	109871	\N
23169	4275	4	0	109872	\N
23173	336	2	0	109881	\N
23173	3332	3	0	109882	\N
23182	4179	4	0	110016	\N
23182	4178	13	0	110017	\N
23182	6776	14	0	110018	\N
23190	4178	2	0	109875	\N
23190	4247	3	0	110058	\N
23195	268	3	0	107418	\N
23195	3815	4	0	110073	\N
23200	164	2	0	110091	\N
23200	1124	3	0	110092	\N
23201	273	3	0	110099	\N
23201	3638	4	0	110100	\N
23202	4178	4	0	110071	\N
23202	4331	5	0	110109	\N
23206	33	2	0	110118	\N
23206	2822	3	0	110119	\N
23210	322	1	0	110123	\N
23210	2968	2	0	110124	\N
23215	40	3	0	109780	\N
23215	1921	4	0	110156	\N
23220	1109	2	0	110171	\N
23220	2809	3	0	110172	\N
23221	367	3	0	110178	\N
23221	6784	4	0	110179	\N
23226	62	5	0	98994	\N
23226	6789	6	0	110212	\N
23230	411	2	0	110222	\N
23230	3370	3	0	110223	\N
23236	4178	2	0	110240	\N
23236	4247	3	0	110241	\N
23241	4178	2	0	110248	\N
23241	4247	3	0	110249	\N
23247	16	4	0	109442	\N
23247	2575	5	0	110280	\N
23251	20	2	0	108381	\N
23251	369	3	0	110050	\N
23256	16	2	0	109442	\N
23256	388	3	0	110307	\N
23257	100	2	0	110312	\N
23257	633	3	0	110313	\N
23262	488	2	0	110330	\N
23262	2791	3	0	110331	\N
23263	4178	3	0	110338	\N
23263	4211	4	0	110339	\N
23267	3628	2	0	110347	\N
23267	4360	3	0	110348	\N
23273	212	6	0	110373	\N
23273	4266	7	0	110374	\N
23274	33	2	0	110118	\N
23274	2822	3	0	110119	\N
23280	279	2	0	110397	\N
23280	4525	3	0	110398	\N
23286	268	6	0	110447	\N
23286	6804	7	0	110448	\N
23287	167	2	0	110453	\N
23287	3322	3	0	110454	\N
23294	230	4	0	110513	\N
23294	6806	5	0	110514	\N
23300	2636	2	0	102896	\N
23300	2836	3	0	106413	\N
23301	4	2	0	110542	\N
23301	2751	3	0	110543	\N
23305	14	2	0	110642	\N
23305	1785	3	0	110643	\N
23312	6808	90	0	110674	\N
23312	367	110	0	110677	\N
23312	6809	111	0	110678	\N
23313	285	5	0	110056	\N
23313	5103	6	0	110687	\N
23319	40	2	0	110238	\N
23319	282	3	0	110239	\N
23320	908	2	0	110720	\N
23320	2832	3	0	110721	\N
23325	75	2	0	110320	\N
23325	284	3	0	110321	\N
23326	40	4	0	110743	\N
23326	2796	5	0	110744	\N
23330	92	2	0	110751	\N
23330	2763	3	0	110752	\N
23335	58	2	0	110769	\N
23335	2853	3	0	110770	\N
23341	288	4	0	110794	\N
23341	5098	5	0	110795	\N
23347	173	1	0	110121	\N
23347	1927	2	0	110818	\N
23348	235	2	0	110823	\N
23348	2757	3	0	110824	\N
23349	336	4	0	110833	\N
23349	3378	5	0	110834	\N
23353	6778	88	0	110926	\N
23353	4	103	0	110932	\N
23353	6816	104	1	110933	\N
23353	6815	104	0	110934	\N
23353	6199	105	1	110935	\N
23353	4915	105	0	110936	\N
23353	2583	106	0	44091	\N
23359	4201	1	0	110965	\N
23359	4172	3	0	110968	\N
23359	5004	4	0	110667	\N
23366	6819	1	0	110999	\N
23366	6820	1	0	111000	\N
23366	6822	2	1	111001	\N
23366	6821	2	0	111002	\N
23366	6823	3	1	111003	\N
23366	3268	3	0	111004	\N
23367	94	4	0	107844	\N
23367	6644	5	0	111013	\N
23368	62	4	0	98994	\N
23368	6824	5	0	111022	\N
23372	4178	2	0	111023	\N
23372	4247	3	0	111031	\N
23378	110	4	0	107869	\N
23378	4552	5	0	110113	\N
23383	3248	12	0	111063	\N
23383	6826	13	0	111064	\N
23384	140	4	0	111073	\N
23384	6827	5	0	111074	\N
23395	79	2	0	111123	\N
23395	3180	3	0	111124	\N
23398	40	2	0	111054	\N
23398	282	3	0	111055	\N
23403	16	2	0	110701	\N
23403	388	3	0	111218	\N
23404	6	8	0	111235	\N
23404	5953	9	0	111236	\N
23409	77	2	0	111256	\N
23409	3853	3	0	111257	\N
23413	3818	4	0	111282	\N
23413	6836	4	0	111283	\N
23413	2827	5	0	111284	\N
23417	5885	2	0	111292	\N
23417	6838	3	0	111293	\N
23427	852	2	0	111333	\N
23427	2872	3	0	111334	\N
23430	212	2	0	111341	\N
23430	3616	3	0	111342	\N
23438	69	0	0	107011	\N
23442	268	2	0	111358	\N
23442	2800	3	0	111359	\N
23450	80	2	0	111374	\N
23450	79	11	0	111375	\N
23450	6843	12	1	111376	\N
23450	6842	12	0	111377	\N
23453	266	2	0	111390	\N
23453	2103	3	0	111391	\N
23455	290	3	0	111400	\N
23455	3635	4	0	111401	\N
23458	6723	3	0	110254	\N
23458	6724	4	0	111410	\N
23461	77	3	0	111413	\N
23461	1877	4	0	111414	\N
23462	973	108	1	111464	\N
23462	6845	108	0	111465	\N
23462	4952	109	0	111466	\N
23462	77	114	0	111467	\N
23462	3108	115	1	111468	\N
23462	6846	115	0	111469	\N
23463	75	9	0	111488	\N
23463	4685	10	0	111489	\N
23466	411	4	0	110222	\N
23466	4858	5	0	111513	\N
23471	56	4	0	111540	\N
23471	3127	5	0	111541	\N
23476	6847	4	0	111561	\N
23482	285	3	0	111600	\N
23482	4496	4	0	111601	\N
23486	14	0	0	111388	\N
23490	40	3	0	111635	\N
23490	372	4	0	111636	\N
23495	230	4	0	111664	\N
23495	3954	5	0	111665	\N
23498	92	4	0	110751	\N
23498	3979	5	0	111670	\N
23503	42	7	0	111032	\N
23503	6853	8	0	111700	\N
23507	164	3	0	111709	\N
23507	3385	4	0	111710	\N
23510	4172	4	0	111729	\N
23510	4219	5	0	111730	\N
23515	233	4	0	111747	\N
23515	3775	5	0	111748	\N
23519	2782	8	0	111698	\N
23519	5680	9	0	111770	\N
23522	4172	10	0	111729	\N
23522	4663	11	0	111794	\N
23526	40	0	0	111812	\N
23529	1109	15	0	111843	\N
23529	6859	16	0	111847	\N
23531	391	4	0	99024	\N
23531	3913	5	0	111864	\N
23533	20	3	0	108381	\N
23533	2844	4	0	108382	\N
23543	4172	3	0	111729	\N
23543	4275	4	0	111938	\N
23551	6861	8	0	111979	\N
23558	4178	6	0	112014	\N
23558	6623	7	0	112015	\N
23561	23	4	0	109565	\N
23561	3189	5	0	112040	\N
23563	391	4	0	112051	\N
23563	3352	5	0	112052	\N
23565	27	4	0	111542	\N
23565	3379	5	0	112055	\N
23568	38	6	0	112070	\N
23568	6005	7	0	112071	\N
23570	451	4	0	103732	\N
23570	3391	5	0	111122	\N
23573	44	3	0	111719	\N
23573	3631	4	0	111720	\N
23575	4	4	0	111927	\N
23575	4117	5	0	112099	\N
23579	186	4	0	112119	\N
23579	6866	5	0	112120	\N
23581	208	3	0	108547	\N
23581	4490	4	0	112129	\N
23585	3628	4	0	110347	\N
23585	3803	5	0	112142	\N
23588	224	3	0	110697	\N
23588	3603	4	0	112158	\N
23594	4178	6	0	112185	\N
23594	4250	7	0	112186	\N
23598	64	32	0	108854	\N
23598	6869	33	0	112227	\N
23600	73	14	0	111994	\N
23600	6870	15	0	112256	\N
23602	56	3	0	112264	\N
23602	4109	4	0	112265	\N
23605	115	3	0	112276	\N
23605	3483	4	0	112277	\N
23617	360	6	0	106874	\N
23617	5788	7	0	112338	\N
23618	1636	3	0	112088	\N
23618	5514	4	0	112089	\N
23621	16	4	0	112289	\N
23621	3546	5	0	112355	\N
23624	60	11	0	112271	\N
23624	6874	12	0	112382	\N
23626	6875	21	0	112401	\N
23626	322	126	0	112416	\N
23626	6876	127	0	112417	\N
23629	4178	3	0	112442	\N
23629	4211	4	0	112443	\N
23631	1792	2	0	112463	\N
23631	6096	3	0	112464	\N
23636	20	7	0	112492	\N
23636	4714	8	0	112493	\N
23639	4178	9	0	112442	\N
23639	6592	10	0	112516	\N
23641	260	3	0	112525	\N
23641	3399	4	0	112526	\N
23644	4178	7	0	112442	\N
23644	4396	8	0	112545	\N
23646	4178	3	0	112442	\N
23646	4211	4	0	112443	\N
23648	40	4	0	112570	\N
23648	3381	5	0	112571	\N
23651	6881	4	0	112581	\N
23651	2351	8	0	112588	\N
23651	2845	9	0	112589	\N
23656	793	3	0	112602	\N
23656	2644	4	0	112603	\N
23657	18	5	0	112608	\N
23657	6885	6	0	112609	\N
23663	121	2	0	112016	\N
23663	2498	3	0	112645	\N
23382	4247	3	0	111062	\N
23389	18	0	0	111087	\N
23393	1470	4	0	111120	\N
23393	2798	5	0	111121	\N
23399	4178	2	0	111061	\N
23399	4247	3	0	111062	\N
23410	6834	109	0	111258	\N
23410	77	126	0	111259	\N
23410	6835	127	0	111260	\N
23412	160	1	0	111269	\N
23412	100	3	0	111272	\N
23412	2895	4	0	111273	\N
23416	173	32	0	111286	\N
23416	6837	33	0	111287	\N
23419	56	3	0	110792	\N
23419	1188	4	0	111301	\N
23422	75	6	0	110320	\N
23422	3361	7	0	111320	\N
23425	2782	2	0	111323	\N
23425	2784	3	0	111328	\N
23429	2351	2	0	110355	\N
23429	2754	3	0	110356	\N
23434	4178	2	0	111061	\N
23434	4247	3	0	111062	\N
23436	279	2	0	111350	\N
23436	4525	3	0	111351	\N
23437	2	2	0	111339	\N
23437	2789	3	0	111340	\N
23441	4178	2	0	111061	\N
23441	4247	3	0	111062	\N
23444	674	2	0	111360	\N
23444	6148	3	0	111361	\N
23445	69	0	0	107011	\N
23448	4178	2	0	111061	\N
23448	4247	3	0	111062	\N
23452	14	2	0	111388	\N
23452	1785	3	0	111389	\N
23457	92	3	0	110751	\N
23457	4410	4	0	111409	\N
23465	145	4	0	110111	\N
23465	3867	5	0	111512	\N
23468	4178	3	0	111061	\N
23468	4211	4	0	111522	\N
23470	4172	4	0	111520	\N
23470	4219	5	0	111539	\N
23475	597	3	0	92732	\N
23475	3656	4	0	111560	\N
23484	4178	6	0	111616	\N
23484	4250	7	0	111617	\N
23491	206	3	0	109468	\N
23491	4584	4	0	111637	\N
23493	88	6	0	111652	\N
23493	5263	7	0	111653	\N
23496	54	4	0	111666	\N
23496	3685	5	0	111667	\N
23501	206	3	0	109468	\N
23501	4584	4	0	111637	\N
23504	40	3	0	111635	\N
23504	372	4	0	111636	\N
23508	1636	3	0	111717	\N
23508	5514	4	0	111718	\N
23511	135	4	0	109698	\N
23511	3696	5	0	111731	\N
23517	58	5	0	111758	\N
23517	6854	6	0	111759	\N
23520	4178	8	0	111668	\N
23520	6776	9	0	111771	\N
23524	4178	3	0	111804	\N
23524	4211	4	0	111805	\N
23527	930	0	0	8609	\N
23532	4178	4	0	111865	\N
23532	4205	5	0	111866	\N
23534	266	3	0	111873	\N
23534	3474	4	0	111874	\N
23536	181	9	0	111895	\N
23536	6860	10	0	111896	\N
23537	69	10	0	111356	\N
23537	3672	11	0	111917	\N
23539	6303	3	0	106218	\N
23539	6304	4	0	111926	\N
23544	4178	3	0	111945	\N
23544	4211	4	0	111946	\N
23547	12	3	0	108225	\N
23547	4204	4	0	108226	\N
23549	102	7	0	104738	\N
23549	5310	8	0	111978	\N
23554	4172	6	0	111996	\N
23554	4197	7	0	111997	\N
23556	170	6	0	108578	\N
23556	6862	7	0	112012	\N
23569	451	4	0	103732	\N
23569	3391	5	0	111122	\N
23571	23	3	0	112086	\N
23571	3497	4	0	112087	\N
23576	94	4	0	111654	\N
23576	4677	5	0	112100	\N
23583	88	4	0	112140	\N
23583	3809	5	0	112141	\N
23587	40	3	0	112053	\N
23587	372	4	0	112151	\N
23589	4172	4	0	112167	\N
23589	4219	5	0	112168	\N
23592	2351	6	0	112182	\N
23592	6867	7	0	112183	\N
23595	2351	13	0	112182	\N
23595	6868	14	0	112191	\N
23596	75	7	0	112206	\N
23596	2859	8	0	112207	\N
23607	18	7	0	112287	\N
23607	2506	8	0	112288	\N
23610	60	3	0	112271	\N
23610	3585	4	0	112291	\N
23613	4178	10	0	112185	\N
23613	4665	11	0	112322	\N
23615	181	6	0	112336	\N
23615	4256	7	0	112337	\N
23622	60	8	0	112271	\N
23622	6872	9	0	112371	\N
23627	4178	7	0	112432	\N
23627	4396	8	0	112433	\N
23630	69	7	0	111356	\N
23630	3711	8	0	112458	\N
23633	40	3	0	112053	\N
23633	372	4	0	112151	\N
23635	56	3	0	112476	\N
23635	4109	4	0	112477	\N
23637	577	7	0	112494	\N
23637	6878	8	0	112495	\N
23640	244	9	0	112517	\N
23640	6880	10	0	112518	\N
23642	326	3	0	112527	\N
23642	3339	4	0	112528	\N
23647	316	3	0	112560	\N
23647	4249	4	0	112561	\N
23652	6881	4	0	112581	\N
23652	2351	7	0	112588	\N
23652	2754	8	0	112590	\N
23654	212	3	0	111341	\N
23654	6883	4	1	112599	\N
23654	6882	4	0	112600	\N
23659	40	10	0	112631	\N
23659	4104	11	0	112632	\N
23661	121	3	0	112016	\N
23661	4471	4	0	112641	\N
23668	164	3	0	112662	\N
23668	3385	4	0	112666	\N
23671	110	7	0	112654	\N
23671	4621	8	0	112690	\N
23674	137	5	0	111732	\N
23674	3346	6	0	112694	\N
23679	4088	0	0	112716	\N
23682	92	8	0	112736	\N
23682	6888	9	0	112737	\N
23686	273	3	0	112770	\N
23686	3638	4	0	112771	\N
23689	117	4	0	112068	\N
23689	3835	5	0	112098	\N
23385	2780	3	0	111080	\N
23392	365	4	0	107205	\N
23392	3298	5	0	111119	\N
23397	749	81	1	111182	\N
23397	6830	81	0	111183	\N
23397	365	98	0	111193	\N
23397	3108	99	1	111194	\N
23397	6831	99	0	111195	\N
23397	2583	100	0	44091	\N
23400	2	2	0	111204	\N
23400	2789	3	0	111205	\N
23401	260	2	0	110987	\N
23401	3184	3	0	110988	\N
23405	100	8	0	111237	\N
23405	6832	9	0	111238	\N
23407	4172	4	0	111248	\N
23407	4252	5	0	111249	\N
23414	73	4	0	103365	\N
23414	2827	5	0	111285	\N
23418	268	2	0	110447	\N
23418	2800	3	0	111294	\N
23420	79	2	0	111123	\N
23420	616	3	0	111306	\N
23423	2782	1	0	111323	\N
23423	3873	2	0	111324	\N
23431	6841	3	0	111343	\N
23432	411	2	0	110222	\N
23432	3370	3	0	110223	\N
23435	208	2	0	108547	\N
23435	4524	3	0	108548	\N
23439	5885	2	0	111292	\N
23439	6838	3	0	111293	\N
23443	69	0	0	107011	\N
23446	69	0	0	107011	\N
23451	200	2	0	111382	\N
23451	276	3	0	111383	\N
23454	6844	95	0	111392	\N
23454	14	96	0	111393	\N
23459	123	3	0	111411	\N
23459	2856	4	0	111412	\N
23464	4172	6	0	111502	\N
23464	4197	7	0	111503	\N
23472	27	4	0	111542	\N
23472	3717	5	0	111543	\N
23473	290	3	0	111550	\N
23473	3635	4	0	111551	\N
23477	360	3	0	106874	\N
23477	3602	4	0	111562	\N
23478	230	0	0	110513	\N
23480	117	10	0	111585	\N
23480	6848	11	0	111586	\N
23483	6849	3	0	111602	\N
23483	6850	4	0	111603	\N
23488	14	0	0	111388	\N
23499	6851	17	0	111676	\N
23499	5643	18	0	108068	\N
23499	6852	18	0	111677	\N
23506	94	3	0	111654	\N
23506	2864	4	0	111708	\N
23512	137	4	0	111732	\N
23512	3697	5	0	111733	\N
23514	156	4	0	111745	\N
23514	5935	5	0	111746	\N
23516	4088	2	0	107842	\N
23516	4332	3	0	111750	\N
23521	4233	10	0	111792	\N
23521	6855	11	0	111793	\N
23523	6856	15	0	111795	\N
23523	4233	62	0	111796	\N
23523	6390	63	0	111797	\N
23525	285	3	0	111600	\N
23525	4496	4	0	111601	\N
23528	1109	15	0	111843	\N
23528	863	17	0	111846	\N
23530	453	3	0	111854	\N
23530	2838	4	0	111855	\N
23535	18	7	0	111879	\N
23535	2506	8	0	111880	\N
23541	4178	3	0	111865	\N
23541	4211	4	0	111929	\N
23545	164	4	0	111709	\N
23545	4152	5	0	111955	\N
23548	360	3	0	106874	\N
23548	3602	4	0	111562	\N
23550	212	0	0	111341	\N
23555	852	6	0	111998	\N
23555	4687	7	0	111999	\N
23557	202	6	0	108283	\N
23557	6863	7	0	112013	\N
23562	6864	4	0	112041	\N
23562	6865	5	0	112042	\N
23564	40	4	0	112053	\N
23564	2796	5	0	112054	\N
23580	23	4	0	112121	\N
23580	5479	5	0	112122	\N
23582	3625	4	0	112138	\N
23582	3802	5	0	112139	\N
23586	4787	3	0	112149	\N
23586	4788	4	0	112150	\N
23591	2782	6	0	111698	\N
23591	5009	7	0	112181	\N
23599	64	2	0	108854	\N
23599	277	3	0	112228	\N
23601	266	14	0	111873	\N
23601	6871	15	0	112257	\N
23603	4178	3	0	112185	\N
23603	4211	4	0	112266	\N
23606	181	3	0	112278	\N
23606	4184	4	0	112279	\N
23609	4178	3	0	112185	\N
23609	4211	4	0	112266	\N
23611	233	3	0	112298	\N
23611	3704	4	0	112299	\N
23612	285	10	0	112320	\N
23612	5921	11	0	112321	\N
23614	2351	0	0	112323	\N
23619	44	3	0	111719	\N
23619	3631	4	0	111720	\N
23632	1792	3	0	112463	\N
23632	6877	4	0	112468	\N
23634	4172	3	0	112167	\N
23634	4275	4	0	112475	\N
23649	4178	4	0	112442	\N
23649	4205	5	0	112572	\N
23653	40	3	0	112597	\N
23653	372	4	0	112598	\N
23658	54	10	0	111666	\N
23658	6472	11	0	112630	\N
23660	360	3	0	112639	\N
23660	3602	4	0	112640	\N
23666	206	4	0	112658	\N
23666	3511	5	0	112659	\N
23667	164	2	0	112662	\N
23667	1124	3	0	112663	\N
23670	20	7	0	112688	\N
23670	4714	8	0	112689	\N
23677	164	3	0	112703	\N
23677	3385	4	0	112705	\N
23681	145	8	0	112734	\N
23681	6887	9	0	112735	\N
23685	56	3	0	112476	\N
23685	4109	4	0	112477	\N
23688	132	3	0	109172	\N
23688	3729	4	0	109763	\N
23691	273	3	0	112813	\N
23691	3638	4	0	112814	\N
23694	3565	4	0	112832	\N
23694	431	8	0	112833	\N
23694	6890	9	0	112834	\N
23698	79	11	0	112860	\N
23698	6891	12	0	112861	\N
23703	2782	2	0	111698	\N
23703	2784	3	0	112900	\N
23708	391	4	0	112051	\N
23391	3566	11	0	111110	\N
23394	451	4	0	103732	\N
23394	3391	5	0	111122	\N
23396	79	4	0	111123	\N
23396	2758	5	0	111125	\N
23402	27	2	0	110301	\N
23402	645	3	0	110302	\N
23406	64	8	0	108854	\N
23406	6833	9	0	111239	\N
23408	235	2	0	111254	\N
23408	2757	3	0	111255	\N
23411	6044	2	0	111265	\N
23411	6188	3	0	111266	\N
23415	56	4	0	110792	\N
23415	3556	5	0	110793	\N
23421	79	37	0	111123	\N
23421	6839	38	0	111307	\N
23424	2782	8	0	111323	\N
23424	6840	9	0	111327	\N
23426	2782	2	0	111323	\N
23426	2784	3	0	111328	\N
23428	2	2	0	111339	\N
23428	2789	3	0	111340	\N
23433	6044	2	0	111348	\N
23433	6188	3	0	111349	\N
23440	69	2	0	111356	\N
23440	3350	3	0	111357	\N
23447	4172	2	0	111366	\N
23447	4191	3	0	111367	\N
23449	79	2	0	111372	\N
23449	616	3	0	111373	\N
23456	4	3	0	110835	\N
23456	3837	4	0	111408	\N
23467	4172	3	0	111520	\N
23467	4275	4	0	111521	\N
23469	4178	3	0	111529	\N
23469	4211	4	0	111530	\N
23474	595	3	0	111558	\N
23474	3654	4	0	111559	\N
23479	18	1	0	111563	\N
23479	19	2	0	111564	\N
23481	241	3	0	110059	\N
23481	3613	4	0	111593	\N
23485	214	6	0	111618	\N
23485	4681	7	0	111619	\N
23487	14	4	0	111388	\N
23487	3498	5	0	111628	\N
23489	14	0	0	111388	\N
23492	241	3	0	111638	\N
23492	3613	4	0	111639	\N
23494	94	6	0	111654	\N
23494	4696	7	0	111655	\N
23497	4178	4	0	111668	\N
23497	4205	5	0	111669	\N
23502	2782	7	0	111698	\N
23502	6312	8	0	111699	\N
23505	4178	3	0	111668	\N
23505	4211	4	0	111707	\N
23509	44	3	0	111719	\N
23509	3631	4	0	111720	\N
23513	113	1	0	108015	\N
23513	1102	2	0	111736	\N
23518	58	1	0	111758	\N
23518	59	2	0	111760	\N
23538	40	10	0	111918	\N
23538	4104	11	0	111919	\N
23540	4	3	0	111927	\N
23540	3837	4	0	111928	\N
23542	35	2	0	111930	\N
23542	1191	3	0	111931	\N
23546	528	3	0	111962	\N
23546	4262	4	0	111963	\N
23552	4178	7	0	111980	\N
23552	4396	8	0	111981	\N
23553	73	6	0	111994	\N
23553	4257	7	0	111995	\N
23559	121	6	0	112016	\N
23559	6038	7	0	112017	\N
23560	16	6	0	112030	\N
23560	3369	7	0	112031	\N
23567	117	6	0	112068	\N
23567	3804	7	0	112069	\N
23572	1636	3	0	112088	\N
23572	5514	4	0	112089	\N
23574	117	4	0	112068	\N
23574	3835	5	0	112098	\N
23577	42	3	0	112102	\N
23577	3645	4	0	112103	\N
23578	324	3	0	110816	\N
23578	4514	4	0	112110	\N
23584	119	4	0	101527	\N
23584	3518	5	0	103573	\N
23590	56	4	0	111540	\N
23590	3127	5	0	111541	\N
23593	4172	6	0	112167	\N
23593	4197	7	0	112184	\N
23597	4172	2	0	112167	\N
23597	4191	3	0	112212	\N
23604	60	2	0	112271	\N
23604	4544	3	0	112272	\N
23608	16	3	0	112289	\N
23608	3634	4	0	112290	\N
23616	360	6	0	106874	\N
23616	5788	7	0	112338	\N
23620	285	4	0	112353	\N
23620	3674	5	0	112354	\N
23623	6044	11	0	112380	\N
23623	6873	12	0	112381	\N
23625	4178	9	0	112185	\N
23625	6592	10	0	112396	\N
23628	285	3	0	112440	\N
23628	4496	4	0	112441	\N
23638	198	9	0	112514	\N
23638	6879	10	0	112515	\N
23643	73	7	0	112543	\N
23643	6635	8	0	112544	\N
23645	290	3	0	112552	\N
23645	3635	4	0	112553	\N
23650	6881	4	0	112581	\N
23650	2351	8	0	112588	\N
23650	2845	9	0	112589	\N
23655	6884	4	0	112601	\N
23662	4172	3	0	112642	\N
23662	4275	4	0	112643	\N
23664	110	4	0	112654	\N
23664	4134	5	0	112655	\N
23672	4172	7	0	112642	\N
23672	4614	8	0	112691	\N
23675	54	3	0	112701	\N
23675	3041	4	0	112702	\N
23684	290	9	0	112756	\N
23684	6889	10	0	112757	\N
23687	4178	7	0	112442	\N
23687	4396	8	0	112545	\N
23696	3273	4	0	112823	\N
23696	198	8	0	112830	\N
23696	3181	9	0	112831	\N
23702	4172	4	0	112642	\N
23702	4219	5	0	112895	\N
23705	228	3	0	112904	\N
23705	3186	4	0	112905	\N
23710	14	3	0	112931	\N
23710	4272	4	0	112933	\N
23715	4233	3	0	112961	\N
23715	4425	4	0	112967	\N
23724	360	6	0	112639	\N
23724	5788	7	0	113009	\N
23726	145	7	0	113042	\N
23726	4861	8	0	113043	\N
23729	4178	3	0	113007	\N
23729	4211	4	0	113074	\N
23730	285	10	0	113095	\N
23730	5921	11	0	113096	\N
23733	6898	80	0	113121	\N
23733	258	126	0	113154	\N
23733	6899	127	0	113155	\N
23665	435	3	0	91752	\N
23665	3504	4	0	112657	\N
23669	1130	4	0	25429	\N
23669	6886	5	0	112673	\N
23673	135	7	0	112692	\N
23673	4721	8	0	112693	\N
23676	164	2	0	112703	\N
23676	1124	3	0	112704	\N
23678	233	4	0	112714	\N
23678	3775	5	0	112715	\N
23680	18	0	0	112717	\N
23690	2	3	0	111339	\N
23690	3548	4	0	112806	\N
23693	3273	4	0	112823	\N
23693	198	8	0	112830	\N
23693	3181	9	0	112831	\N
23697	4479	4	0	112835	\N
23697	235	8	0	112836	\N
23697	3774	9	0	112837	\N
23700	18	0	0	112868	\N
23707	151	3	0	112920	\N
23707	3046	4	0	112921	\N
23712	4172	4	0	112955	\N
23712	4219	5	0	112956	\N
23716	140	3	0	112963	\N
23716	4149	4	0	112968	\N
23717	235	8	0	111254	\N
23717	6894	9	0	112983	\N
23719	528	3	0	111962	\N
23719	4262	4	0	111963	\N
23727	121	3	0	113050	\N
23727	4471	4	0	113051	\N
23731	115	6	0	112276	\N
23731	4693	7	0	113109	\N
23736	75	3	0	113169	\N
23736	3855	4	0	113170	\N
23740	233	4	0	113180	\N
23740	3775	5	0	113187	\N
23743	262	2	0	113195	\N
23743	2743	3	0	113196	\N
23747	841	7	0	111081	\N
23747	5065	8	0	113267	\N
23750	4178	1	0	113167	\N
23750	4460	2	0	113298	\N
23762	6909	105	0	113433	\N
23762	149	126	0	113444	\N
23762	697	127	0	113445	\N
23764	156	5	0	111745	\N
23764	3152	6	0	113461	\N
23773	38	7	0	113519	\N
23773	5071	8	0	113520	\N
23778	4178	3	0	113167	\N
23778	4211	4	0	113537	\N
23783	16	6	0	112289	\N
23783	3369	7	0	113565	\N
23785	2	4	0	113576	\N
23785	3510	5	0	113577	\N
23791	3625	3	0	112138	\N
23791	3784	4	0	113600	\N
23795	54	3	0	113601	\N
23795	3041	4	0	113604	\N
23798	228	4	0	113615	\N
23798	5679	5	0	113616	\N
23802	288	7	0	113637	\N
23802	6916	8	0	113638	\N
23807	69	5	0	113611	\N
23807	6917	6	0	113680	\N
23809	2	3	0	113576	\N
23809	3548	4	0	113688	\N
23814	92	3	0	113701	\N
23814	4410	4	0	113702	\N
23816	1109	4	0	113581	\N
23816	3816	5	0	113582	\N
23819	4348	7	0	113746	\N
23819	6919	7	0	113747	\N
23819	3707	8	0	113748	\N
23821	58	2	0	113755	\N
23821	2853	3	0	113756	\N
23825	58	8	0	113770	\N
23825	6923	9	0	113778	\N
23829	235	7	0	111254	\N
23829	5822	8	0	112837	\N
23833	16	7	0	113814	\N
23833	4723	8	0	113815	\N
23838	290	3	0	113842	\N
23838	3635	4	0	113843	\N
23840	75	3	0	113529	\N
23840	3855	4	0	113530	\N
23846	316	3	0	113899	\N
23846	4249	4	0	113900	\N
23851	4172	3	0	113811	\N
23851	4275	4	0	113957	\N
23856	110	0	0	113991	\N
23858	6931	0	0	113993	\N
23858	6932	0	0	113994	\N
23862	1470	10	0	111120	\N
23862	3375	11	0	114021	\N
23865	597	3	0	114045	\N
23865	3656	4	0	114046	\N
23870	391	3	0	114070	\N
23870	3660	4	0	114071	\N
23872	62	6	0	114084	\N
23872	6466	7	0	114085	\N
23875	75	10	0	114108	\N
23875	4874	11	0	114109	\N
23877	6936	40	0	114120	\N
23877	35	125	0	114132	\N
23877	6937	126	1	114133	\N
23877	2435	126	0	114134	\N
23877	2519	127	1	114135	\N
23877	6938	127	0	114136	\N
23880	16	14	0	113814	\N
23880	707	15	0	114164	\N
23884	56	3	0	113958	\N
23884	4109	4	0	113959	\N
23886	189	3	0	114229	\N
23886	3782	4	0	114230	\N
23892	290	3	0	114267	\N
23892	3635	4	0	114268	\N
23895	64	3	0	114271	\N
23895	4217	4	0	114273	\N
23900	4233	3	0	114301	\N
23900	4425	4	0	114302	\N
23903	132	3	0	114306	\N
23903	3729	4	0	114307	\N
23908	88	4	0	114326	\N
23908	3809	5	0	114327	\N
23913	233	7	0	114346	\N
23913	5948	8	0	114347	\N
23916	6942	80	0	114457	\N
23916	258	98	0	114475	\N
23916	6668	99	1	114476	\N
23916	2435	99	0	114477	\N
23916	1075	100	1	114478	\N
23916	6943	100	0	114479	\N
23921	285	3	0	114524	\N
23921	4496	4	0	114525	\N
23928	260	4	0	112525	\N
23928	3728	5	0	114556	\N
23930	33	10	0	114580	\N
23930	6947	11	0	114581	\N
23935	242	2	0	113462	\N
23935	3425	3	0	114607	\N
23937	235	4	0	111254	\N
23937	3615	5	0	114614	\N
23942	164	6	0	114206	\N
23942	3583	7	0	114634	\N
23945	2	3	0	113576	\N
23945	3548	4	0	113688	\N
23949	4233	6	0	114301	\N
23949	6364	7	0	114662	\N
23953	58	6	0	114685	\N
23953	6952	7	0	114686	\N
23955	69	3	0	114694	\N
23955	4536	4	0	114695	\N
23963	149	3	0	110941	\N
23963	4189	4	0	114749	\N
23692	4172	3	0	112642	\N
23692	4275	4	0	112643	\N
23695	4479	4	0	112835	\N
23695	235	8	0	112836	\N
23695	3774	9	0	112837	\N
23699	79	8	0	112860	\N
23701	69	10	0	112885	\N
23701	6893	11	0	112886	\N
23704	2782	3	0	111698	\N
23704	3659	4	0	112903	\N
23706	94	3	0	112912	\N
23706	2864	4	0	112913	\N
23709	14	4	0	112931	\N
23709	3498	5	0	112932	\N
23711	145	6	0	112734	\N
23711	5341	7	0	112946	\N
23714	140	2	0	112963	\N
23714	3183	3	0	112964	\N
23723	4178	6	0	113007	\N
23723	4250	7	0	113008	\N
23725	79	8	0	113026	\N
23725	3701	9	0	113027	\N
23732	336	5	0	110833	\N
23732	6897	6	0	113119	\N
23735	4178	5	0	113167	\N
23735	4202	6	0	113168	\N
23738	117	6	0	113182	\N
23738	6902	7	0	113183	\N
23744	367	3	0	113203	\N
23744	3683	4	0	113204	\N
23752	841	3	0	113300	\N
23752	3604	4	0	113301	\N
23755	56	3	0	113311	\N
23755	4109	4	0	113312	\N
23760	149	6	0	110941	\N
23760	4737	7	0	113420	\N
23765	242	7	0	113462	\N
23765	4592	8	0	113463	\N
23767	41	1	0	113474	\N
23767	40	5	0	113481	\N
23767	3247	6	0	113482	\N
23770	326	2	0	113491	\N
23770	6910	3	0	113492	\N
23772	79	4	0	113503	\N
23772	2758	5	0	113504	\N
23774	4	3	0	111927	\N
23774	3837	4	0	111928	\N
23776	75	3	0	113529	\N
23776	3855	4	0	113530	\N
23781	402	2	0	113553	\N
23781	3244	3	0	113554	\N
23787	453	4	0	113570	\N
23787	4108	5	0	113580	\N
23790	4787	5	0	113592	\N
23790	5349	6	0	113593	\N
23793	119	3	0	101527	\N
23793	2860	4	0	108058	\N
23796	69	4	0	113611	\N
23796	3564	5	0	113612	\N
23803	273	3	0	113645	\N
23803	3638	4	0	113646	\N
23805	14	4	0	112931	\N
23805	3498	5	0	112932	\N
23811	16	3	0	113691	\N
23811	3634	4	0	113692	\N
23813	67	3	0	104824	\N
23813	3749	4	0	104825	\N
23820	208	7	0	113749	\N
23820	6920	8	0	113750	\N
23823	58	5	0	113770	\N
23823	6921	6	0	113771	\N
23828	235	1	0	111254	\N
23828	6924	2	0	113794	\N
23831	4172	7	0	113811	\N
23831	4614	8	0	113812	\N
23835	402	6	0	113553	\N
23835	6925	7	0	113830	\N
23842	56	3	0	113873	\N
23842	4109	4	0	113874	\N
23845	453	3	0	113897	\N
23845	2838	4	0	113898	\N
23850	40	4	0	113949	\N
23850	3381	5	0	113950	\N
23853	6929	106	0	113964	\N
23853	30	126	0	113981	\N
23853	6930	127	0	113982	\N
23855	140	0	0	112963	\N
23861	6933	7	0	114012	\N
23861	6934	8	0	114013	\N
23864	4172	7	0	114037	\N
23864	4614	8	0	114038	\N
23869	322	3	0	110123	\N
23869	1105	4	0	114069	\N
23874	4178	0	0	112984	\N
23879	75	7	0	114145	\N
23879	2859	8	0	114146	\N
23883	164	3	0	114206	\N
23883	3385	4	0	114207	\N
23889	366	1	0	114251	\N
23889	365	4	0	114256	\N
23889	5072	5	0	114257	\N
23891	290	3	0	114267	\N
23891	3635	4	0	114268	\N
23894	64	1	0	114271	\N
23894	1428	2	0	114272	\N
23897	6044	1	0	112380	\N
23897	6153	2	0	114284	\N
23899	322	3	0	114299	\N
23899	1105	4	0	114300	\N
23907	316	1	0	114321	\N
23907	3115	2	0	114322	\N
23912	4088	7	0	112716	\N
23912	5947	8	0	114345	\N
23914	336	3	0	114354	\N
23914	3400	4	0	114355	\N
23915	285	12	0	113617	\N
23915	6941	13	0	114380	\N
23936	242	3	0	113462	\N
23936	2839	4	0	114609	\N
23938	170	5	0	114617	\N
23938	6948	6	0	114618	\N
23950	125	6	0	114663	\N
23950	6951	7	0	114664	\N
23951	852	9	0	111998	\N
23951	4046	10	0	114673	\N
23958	164	3	0	114702	\N
23958	3385	4	0	114703	\N
23960	94	3	0	114711	\N
23960	2864	4	0	114712	\N
23966	242	4	0	114790	\N
23966	4364	5	0	114794	\N
23968	4178	13	0	114565	\N
23968	6957	14	0	114827	\N
23971	4172	10	0	114853	\N
23971	6603	11	0	114854	\N
23973	40	8	0	114009	\N
23973	5163	9	0	114872	\N
23975	108	3	0	110812	\N
23975	4171	4	0	114888	\N
23980	186	29	0	114924	\N
23980	6962	30	0	114925	\N
23982	186	1	0	114924	\N
23982	187	2	0	114933	\N
23987	300	2	0	113613	\N
23987	2786	3	0	114957	\N
23996	86	3	0	97155	\N
23996	3746	4	0	115014	\N
23999	273	9	0	115037	\N
23999	6965	10	0	115038	\N
24008	94	2	0	114831	\N
24008	2794	3	0	115070	\N
24010	4178	6	0	115045	\N
24010	4250	7	0	115085	\N
24013	16	3	0	115097	\N
24013	3634	4	0	115098	\N
23708	3913	5	0	112930	\N
23713	4233	2	0	112961	\N
23713	5577	3	0	112962	\N
23718	4178	8	0	112984	\N
23718	4218	9	0	112985	\N
23720	23	3	0	112121	\N
23720	3497	4	0	112992	\N
23722	12	6	0	113005	\N
23722	6895	7	0	113006	\N
23728	453	7	0	113066	\N
23728	6896	8	0	113067	\N
23734	181	5	0	112336	\N
23734	6900	6	0	113166	\N
23737	233	6	0	113180	\N
23737	6901	7	0	113181	\N
23741	4178	4	0	113188	\N
23741	4205	5	0	113189	\N
23748	841	55	0	111081	\N
23748	6904	56	0	113289	\N
23751	20	3	0	112688	\N
23751	2844	4	0	113299	\N
23754	202	3	0	108283	\N
23754	4857	4	0	113310	\N
23759	6907	80	0	113393	\N
23759	258	126	0	113406	\N
23759	6908	127	0	113407	\N
23766	273	5	0	113470	\N
23766	6157	6	0	113471	\N
23769	40	3	0	113489	\N
23769	372	4	0	113490	\N
23771	6911	4	0	113499	\N
23771	6912	4	0	113500	\N
23779	251	0	0	113538	\N
23780	4172	4	0	113547	\N
23780	4219	5	0	113548	\N
23786	79	4	0	113578	\N
23786	3678	5	0	113579	\N
23789	391	5	0	113590	\N
23789	5462	6	0	113591	\N
23792	54	2	0	113601	\N
23792	6915	3	0	113602	\N
23799	285	4	0	113617	\N
23799	5030	5	0	113618	\N
23808	424	5	0	110213	\N
23808	6918	6	0	113681	\N
23810	244	3	0	113689	\N
23810	4075	4	0	113690	\N
23812	4178	3	0	113699	\N
23812	4211	4	0	113700	\N
23817	39	2	0	113721	\N
23817	38	7	0	113730	\N
23817	6006	8	0	113731	\N
23822	58	3	0	113755	\N
23822	3665	4	0	113759	\N
23827	288	3	0	113637	\N
23827	3003	4	0	113793	\N
23830	224	7	0	113809	\N
23830	5003	8	0	113810	\N
23834	402	4	0	113553	\N
23834	4731	5	0	113824	\N
23837	186	2	0	113831	\N
23837	3068	3	0	113835	\N
23839	12	3	0	113005	\N
23839	4204	4	0	113844	\N
23841	210	7	0	113865	\N
23841	5940	8	0	113866	\N
23844	4178	3	0	113699	\N
23844	4211	4	0	113700	\N
23847	6927	11	0	113904	\N
23847	173	126	0	113909	\N
23847	6928	127	0	113910	\N
23849	290	3	0	113939	\N
23849	3635	4	0	113940	\N
23852	56	3	0	113958	\N
23852	4109	4	0	113959	\N
23854	391	3	0	113989	\N
23854	3660	4	0	113990	\N
23857	1109	0	0	113992	\N
23859	40	7	0	114009	\N
23859	4718	8	0	114010	\N
23863	40	10	0	114009	\N
23863	4104	11	0	114022	\N
23866	595	3	0	114047	\N
23866	3654	4	0	114048	\N
23868	54	6	0	114061	\N
23868	5204	7	0	114062	\N
23871	92	3	0	113701	\N
23871	4410	4	0	113702	\N
23873	71	6	0	114086	\N
23873	4738	7	0	114087	\N
23878	4178	0	0	113699	\N
23881	58	9	0	113770	\N
23881	3755	10	0	114183	\N
23887	4172	8	0	114247	\N
23887	5928	9	0	114248	\N
23890	215	1	0	114258	\N
23890	214	4	0	114259	\N
23890	2979	5	0	114260	\N
23901	360	3	0	114303	\N
23901	3602	4	0	114304	\N
23904	391	4	0	114070	\N
23904	3913	5	0	114316	\N
23906	115	1	0	114317	\N
23906	2908	2	0	114320	\N
23909	424	3	0	110213	\N
23909	3611	4	0	114328	\N
23911	424	4	0	110213	\N
23911	3188	5	0	114330	\N
23917	140	11	0	112963	\N
23917	6944	12	0	114501	\N
23919	170	3	0	108578	\N
23919	4148	4	0	113647	\N
23922	60	3	0	114526	\N
23922	3585	4	0	114527	\N
23924	4172	3	0	114536	\N
23924	4275	4	0	114537	\N
23926	367	3	0	114544	\N
23926	3683	4	0	114545	\N
23929	4178	4	0	114565	\N
23929	6946	5	0	114566	\N
23932	79	3	0	113578	\N
23932	3652	4	0	114588	\N
23934	18	4	0	108901	\N
23934	2302	5	0	114605	\N
23940	4172	5	0	114536	\N
23940	4634	6	0	114620	\N
23941	367	6	0	114544	\N
23941	6013	7	0	114633	\N
23944	2111	3	0	114643	\N
23944	6950	4	0	114644	\N
23947	27	3	0	114647	\N
23947	4636	4	0	114648	\N
23948	336	0	0	114649	\N
23957	391	3	0	114070	\N
23957	3660	4	0	114071	\N
23962	117	7	0	114741	\N
23962	6954	8	0	114742	\N
23967	4172	2	0	114799	\N
23967	4285	3	0	114800	\N
23974	400	1	0	114875	\N
23974	288	4	0	114880	\N
23974	6960	5	0	114881	\N
23979	206	3	0	112658	\N
23979	4584	4	0	114913	\N
23981	186	3	0	114924	\N
23981	4294	4	0	114932	\N
23986	40	3	0	114951	\N
23986	372	4	0	114952	\N
23988	142	3	0	109162	\N
23988	4254	4	0	109108	\N
23991	54	3	0	114974	\N
23991	3041	4	0	114975	\N
23995	391	1	0	115006	\N
23995	392	2	0	115007	\N
24000	4178	3	0	115045	\N
23739	117	4	0	113182	\N
23739	3835	5	0	113186	\N
23742	4088	2	0	112716	\N
23742	4332	3	0	113190	\N
23746	92	23	0	113251	\N
23746	6903	24	0	113252	\N
23749	3505	3	0	113296	\N
23749	3506	4	0	113297	\N
23753	841	3	0	113302	\N
23753	3604	4	0	113303	\N
23756	113	3	0	113313	\N
23756	3620	4	0	113314	\N
23757	6905	60	0	113315	\N
23757	113	125	0	113344	\N
23757	973	126	1	113345	\N
23757	6906	126	0	113346	\N
23757	1075	127	0	113347	\N
23758	33	4	0	113356	\N
23758	4806	5	0	113357	\N
23761	56	6	0	113311	\N
23761	4703	7	0	113421	\N
23763	156	7	0	111745	\N
23763	4672	8	0	113460	\N
23775	73	3	0	113527	\N
23775	3040	4	0	113528	\N
23777	77	3	0	111413	\N
23777	1877	4	0	111414	\N
23782	402	6	0	113553	\N
23782	4068	7	0	113564	\N
23784	453	2	0	113570	\N
23784	3133	3	0	113571	\N
23788	1109	4	0	113581	\N
23788	3816	5	0	113582	\N
23794	3628	3	0	110347	\N
23794	3785	4	0	113603	\N
23797	300	4	0	113613	\N
23797	2992	5	0	113614	\N
23800	488	4	0	113619	\N
23800	5021	5	0	113620	\N
23801	4178	7	0	113635	\N
23801	4396	8	0	113636	\N
23804	170	3	0	108578	\N
23804	4148	4	0	113647	\N
23806	210	6	0	113668	\N
23806	3721	7	0	113669	\N
23815	40	3	0	113489	\N
23815	372	4	0	113490	\N
23818	39	2	0	113721	\N
23818	38	7	0	113730	\N
23818	6006	8	0	113731	\N
23824	841	8	0	113300	\N
23824	6922	9	0	113777	\N
23826	40	3	0	113785	\N
23826	372	4	0	113786	\N
23832	164	7	0	112703	\N
23832	5711	8	0	113813	\N
23836	186	6	0	113831	\N
23836	6926	7	0	113832	\N
23843	210	7	0	113889	\N
23843	5940	8	0	113890	\N
23848	451	10	0	113931	\N
23848	4808	11	0	113932	\N
23860	56	7	0	113958	\N
23860	4791	8	0	114011	\N
23867	6847	4	0	111561	\N
23876	35	20	0	111930	\N
23876	6935	21	0	114119	\N
23882	6939	7	0	114198	\N
23882	6940	8	0	114199	\N
23885	244	7	0	113689	\N
23885	4608	8	0	114222	\N
23888	366	1	0	114251	\N
23888	365	4	0	114256	\N
23888	5072	5	0	114257	\N
23893	1109	3	0	113992	\N
23893	3495	4	0	114269	\N
23896	6044	4	0	112380	\N
23896	6524	5	0	114282	\N
23898	200	3	0	114291	\N
23898	3338	4	0	114292	\N
23902	71	3	0	114086	\N
23902	3770	4	0	114305	\N
23905	115	4	0	114317	\N
23905	4844	5	0	114318	\N
23910	88	3	0	114326	\N
23910	3655	4	0	114329	\N
23918	117	11	0	113182	\N
23918	6945	12	0	114502	\N
23920	453	4	0	113897	\N
23920	4108	5	0	114517	\N
23923	528	3	0	114528	\N
23923	4262	4	0	114529	\N
23925	12	3	0	113005	\N
23925	4204	4	0	113844	\N
23927	324	3	0	114546	\N
23927	4514	4	0	114547	\N
23931	202	3	0	108283	\N
23931	4857	4	0	113310	\N
23933	4823	3	0	114595	\N
23933	6	4	0	114596	\N
23939	235	5	0	111254	\N
23939	6949	6	0	114619	\N
23943	145	3	0	114641	\N
23943	4908	4	0	114642	\N
23946	69	3	0	114645	\N
23946	4536	4	0	114646	\N
23952	852	6	0	111998	\N
23952	4044	7	0	114676	\N
23954	6331	6	0	98964	\N
23954	6953	7	0	114687	\N
23956	64	3	0	114271	\N
23956	4217	4	0	114273	\N
23959	164	2	0	114702	\N
23959	3085	3	0	114704	\N
23961	360	6	0	114725	\N
23961	5788	7	0	114726	\N
23964	6955	105	0	114761	\N
23964	149	126	0	114782	\N
23964	6956	127	0	114783	\N
23969	94	14	0	114831	\N
23969	6958	15	0	114832	\N
23976	4015	3	0	114889	\N
23976	6961	3	0	114890	\N
23976	3740	4	1	114891	\N
23976	3340	4	0	114892	\N
23978	192	3	0	108697	\N
23978	3790	4	0	114906	\N
23983	108	3	0	114940	\N
23983	4171	4	0	114941	\N
23985	411	3	0	110222	\N
23985	3596	4	0	114950	\N
23990	151	3	0	114972	\N
23990	3046	4	0	114973	\N
23993	6963	118	0	114992	\N
23993	151	126	0	114996	\N
23993	6964	127	0	114997	\N
23994	4178	3	0	115004	\N
23994	4211	4	0	115005	\N
23997	852	3	0	115015	\N
23997	3612	4	0	115016	\N
24006	132	3	0	114306	\N
24006	3729	4	0	114307	\N
24020	6674	4	0	115128	\N
24020	5885	5	0	115129	\N
24022	4178	3	0	115138	\N
24022	4211	4	0	115139	\N
24027	6971	12	0	115188	\N
24027	6972	12	0	115189	\N
24027	6973	13	0	115190	\N
24032	156	3	0	115209	\N
24032	4594	4	0	115210	\N
24034	27	6	0	114647	\N
24034	3715	7	0	115225	\N
24039	142	2	0	109162	\N
24039	4418	3	0	115242	\N
24041	391	2	0	115247	\N
23965	242	3	0	114790	\N
23965	5519	4	0	114791	\N
23970	1021	10	0	101427	\N
23970	6959	11	0	114852	\N
23972	4172	8	0	114853	\N
23972	5165	9	0	114871	\N
23977	230	3	0	111664	\N
23977	4181	4	0	114899	\N
23984	189	3	0	114942	\N
23984	3782	4	0	114943	\N
23989	210	3	0	114964	\N
23989	3539	4	0	114965	\N
23992	40	3	0	114951	\N
23992	372	4	0	114952	\N
23998	360	9	0	115035	\N
23998	6080	10	0	115036	\N
24001	4233	1	0	114301	\N
24001	5087	2	0	115047	\N
24003	367	3	0	114544	\N
24003	3683	4	0	114545	\N
24005	79	5	0	113578	\N
24005	5993	6	0	115058	\N
24007	4178	2	0	115045	\N
24007	4247	3	0	115069	\N
24012	67	3	0	115095	\N
24012	3749	4	0	115096	\N
24014	88	3	0	115105	\N
24014	3655	4	0	115106	\N
24016	88	0	0	111652	\N
24019	4344	4	0	110448	\N
24019	268	5	0	115127	\N
24024	285	6	0	114524	\N
24024	6968	7	0	115149	\N
24026	23	6	0	112121	\N
24026	6970	7	0	115163	\N
24029	908	3	0	115197	\N
24029	3591	4	0	115198	\N
24036	164	3	0	115233	\N
24036	3385	4	0	115234	\N
24038	4178	2	0	115240	\N
24038	4247	3	0	115241	\N
24045	40	2	0	114951	\N
24045	3034	3	0	115267	\N
24047	2782	6	0	111698	\N
24047	5009	7	0	112181	\N
24050	4178	4	0	115309	\N
24050	4331	5	0	115310	\N
24057	94	2	0	115332	\N
24057	2794	3	0	115333	\N
24062	151	2	0	114972	\N
24062	2854	3	0	115351	\N
24064	1021	0	0	115399	\N
24067	108	6	0	114940	\N
24067	6978	7	0	115412	\N
24073	793	2	0	115459	\N
24073	4363	3	0	115460	\N
24079	79	6	0	115494	\N
24079	4997	7	0	115495	\N
24081	60	2	0	115502	\N
24081	4544	3	0	115503	\N
24083	4178	4	0	115465	\N
24083	4331	5	0	115513	\N
24087	597	8	0	115536	\N
24087	6981	9	0	115537	\N
24091	16	2	0	115199	\N
24091	388	3	0	115551	\N
24094	235	2	0	111254	\N
24094	2757	3	0	111255	\N
24099	164	2	0	115233	\N
24099	1124	3	0	115582	\N
24103	135	2	0	112692	\N
24103	2722	3	0	115592	\N
24106	75	3	0	114145	\N
24106	3855	4	0	115605	\N
24108	27	1	0	115608	\N
24108	2885	2	0	115609	\N
24110	27	0	0	114647	\N
24115	273	1	0	115618	\N
24115	1417	2	0	115619	\N
24118	4233	10	0	115641	\N
24118	6719	11	0	115642	\N
24120	119	2	0	101527	\N
24120	1879	3	0	110346	\N
24125	365	2	0	115666	\N
24125	615	3	0	115667	\N
24133	60	6	0	115502	\N
24133	6394	7	0	115723	\N
24142	149	4	0	115772	\N
24142	5500	5	0	115773	\N
24146	151	0	0	114972	\N
24148	151	52	0	115892	\N
24148	6992	53	0	115893	\N
24151	391	1	0	115898	\N
24151	392	2	0	115899	\N
24156	230	3	0	115935	\N
24156	4181	4	0	115936	\N
24160	16	2	0	115947	\N
24160	388	3	0	115948	\N
24163	6995	8	0	115966	\N
24163	6996	9	0	115967	\N
24165	92	2	0	113701	\N
24165	2763	3	0	115972	\N
24168	4172	6	0	115572	\N
24168	4197	7	0	115986	\N
24173	6999	8	0	116022	\N
24173	7000	9	0	116023	\N
24189	285	2	0	116102	\N
24189	3036	3	0	116103	\N
24190	4	2	0	116096	\N
24190	2751	3	0	116104	\N
24194	2636	3	0	116065	\N
24194	2837	4	0	116066	\N
24197	4178	6	0	116136	\N
24197	4250	7	0	116137	\N
24200	852	4	0	115015	\N
24200	4162	5	0	116156	\N
24204	4824	6	0	116181	\N
24204	6695	7	0	116182	\N
24204	7003	7	0	116183	\N
24209	149	7	0	116211	\N
24209	5255	8	0	116212	\N
24214	391	3	0	116154	\N
24214	3660	4	0	116224	\N
24223	71	3	0	116269	\N
24223	3770	4	0	116270	\N
24225	151	4	0	114972	\N
24225	3499	5	0	116281	\N
24228	4787	4	0	113592	\N
24228	5041	5	0	116285	\N
24232	18	3	0	116297	\N
24232	3621	4	0	116298	\N
24234	4172	3	0	116288	\N
24234	4275	4	0	116307	\N
24236	40	4	0	115691	\N
24236	3381	5	0	116316	\N
24241	4178	3	0	116282	\N
24241	4211	4	0	116296	\N
24245	186	6	0	116352	\N
24245	7004	7	0	116353	\N
24248	181	13	0	116387	\N
24248	7005	14	0	116388	\N
24251	79	7	0	116407	\N
24251	5706	8	0	116408	\N
24266	42	15	0	112102	\N
24266	7011	16	0	116510	\N
24268	1021	0	0	116519	\N
24272	79	4	0	116407	\N
24272	2758	5	0	116540	\N
24277	326	4	0	116564	\N
24277	3519	5	0	116565	\N
24280	16	4	0	116571	\N
24280	3546	5	0	116572	\N
24282	360	3	0	116579	\N
24282	3602	4	0	116580	\N
24293	852	3	0	116610	\N
24293	3612	4	0	116611	\N
24299	264	6	0	116636	\N
24000	4211	4	0	115046	\N
24002	4233	3	0	114301	\N
24002	4425	4	0	114302	\N
24004	4178	5	0	115045	\N
24004	4202	6	0	115057	\N
24009	244	2	0	115071	\N
24009	3308	3	0	115072	\N
24011	75	4	0	114145	\N
24011	2357	5	0	115088	\N
24018	33	3	0	115119	\N
24018	3342	4	0	115120	\N
24021	3362	4	0	115130	\N
24021	326	5	0	115131	\N
24023	6966	6	0	115146	\N
24023	6967	6	0	115147	\N
24023	6968	7	0	115148	\N
24025	3265	6	0	115160	\N
24025	6969	6	0	115161	\N
24025	6970	7	0	115162	\N
24028	73	3	0	113527	\N
24028	3040	4	0	113528	\N
24033	453	3	0	115211	\N
24033	2838	4	0	115212	\N
24035	4172	3	0	114853	\N
24035	4275	4	0	115232	\N
24037	73	2	0	113527	\N
24037	2766	3	0	115239	\N
24042	4172	3	0	115251	\N
24042	4275	4	0	115252	\N
24044	12	2	0	115265	\N
24044	3028	3	0	115266	\N
24046	336	3	0	115274	\N
24046	3400	4	0	115275	\N
24053	233	4	0	114346	\N
24053	6975	5	0	115315	\N
24056	469	2	0	115326	\N
24056	6976	3	0	115327	\N
24059	285	2	0	115339	\N
24059	3036	3	0	115340	\N
24061	4178	2	0	115309	\N
24061	4247	3	0	115338	\N
24063	6977	118	0	115392	\N
24063	151	126	0	115397	\N
24063	6964	127	0	115398	\N
24066	108	6	0	114940	\N
24066	6978	7	0	115412	\N
24070	793	4	0	112602	\N
24070	5688	5	0	115448	\N
24075	14	2	0	115467	\N
24075	1785	3	0	115468	\N
24077	71	2	0	114086	\N
24077	1125	3	0	115479	\N
24078	488	6	0	115492	\N
24078	3315	7	0	115493	\N
24080	841	2	0	115500	\N
24080	3316	3	0	115501	\N
24086	595	8	0	114047	\N
24086	6980	9	0	115535	\N
24090	488	2	0	115545	\N
24090	2791	3	0	115546	\N
24093	54	4	0	115566	\N
24093	2570	5	0	115567	\N
24098	367	2	0	114544	\N
24098	3329	3	0	115581	\N
24100	6984	1	0	115585	\N
24100	6985	2	0	115586	\N
24105	113	2	0	115597	\N
24105	1899	3	0	115598	\N
24113	2899	1	0	115612	\N
24113	96	2	0	115613	\N
24114	115	1	0	114317	\N
24114	2908	2	0	114320	\N
24127	108	2	0	115681	\N
24127	3340	3	0	115682	\N
24130	40	2	0	115691	\N
24130	282	3	0	115692	\N
24136	908	2	0	115732	\N
24136	2832	3	0	115733	\N
24138	79	4	0	115494	\N
24138	2758	5	0	115743	\N
24141	92	2	0	113701	\N
24141	3060	3	0	115767	\N
24144	4098	105	1	115876	\N
24144	6990	105	0	115877	\N
24144	149	109	0	115881	\N
24144	3009	110	1	115882	\N
24144	6991	110	0	115883	\N
24145	2	2	0	115888	\N
24145	2789	3	0	115889	\N
24150	6044	1	0	115896	\N
24150	6993	2	0	115897	\N
24153	94	5	0	115911	\N
24153	4547	6	0	115912	\N
24155	18	4	0	108901	\N
24155	3779	5	0	115928	\N
24162	391	0	0	115937	\N
24167	79	6	0	115984	\N
24167	4253	7	0	115985	\N
24170	908	2	0	115732	\N
24170	2832	3	0	115733	\N
24177	251	2	0	111083	\N
24177	1851	3	0	115504	\N
24178	4178	7	0	115945	\N
24178	4509	8	0	116051	\N
24181	451	2	0	116054	\N
24181	3317	3	0	116058	\N
24183	58	3	0	114685	\N
24183	3665	4	0	116067	\N
24185	73	2	0	113527	\N
24185	2766	3	0	115239	\N
24188	4	0	0	116096	\N
24193	40	2	0	115691	\N
24193	282	3	0	115692	\N
24196	360	4	0	115035	\N
24196	3513	5	0	116123	\N
24199	391	4	0	116154	\N
24199	3913	5	0	116155	\N
24201	186	31	0	116158	\N
24201	7002	32	0	116159	\N
24208	367	3	0	116195	\N
24208	3683	4	0	116196	\N
24211	4172	7	0	116105	\N
24211	4614	8	0	116213	\N
24213	235	3	0	116222	\N
24213	3343	4	0	116223	\N
24216	40	3	0	115691	\N
24216	372	4	0	116233	\N
24218	164	3	0	115233	\N
24218	3385	4	0	115234	\N
24221	6044	3	0	115896	\N
24221	6045	4	0	116253	\N
24222	16	4	0	116261	\N
24222	3546	5	0	116262	\N
24227	228	4	0	113615	\N
24227	4800	5	0	116284	\N
24231	4178	3	0	116282	\N
24231	4211	4	0	116296	\N
24233	125	3	0	116305	\N
24233	4170	4	0	116306	\N
24238	214	3	0	116030	\N
24238	3496	4	0	116329	\N
24240	4088	3	0	115311	\N
24240	4506	4	0	116340	\N
24243	132	3	0	116342	\N
24243	3729	4	0	116343	\N
24247	373	3	0	110688	\N
24247	3590	4	0	116360	\N
24250	58	7	0	116405	\N
24250	4764	8	0	116406	\N
24253	4178	8	0	116282	\N
24253	5610	9	0	116427	\N
24255	210	0	0	115207	\N
24258	94	13	0	115911	\N
24258	7008	14	0	116457	\N
24260	233	4	0	116467	\N
24260	3775	5	0	116468	\N
24263	6723	3	0	110254	\N
24015	88	0	0	111652	\N
24017	145	3	0	114641	\N
24017	4908	4	0	114642	\N
24030	16	3	0	115199	\N
24030	3634	4	0	115200	\N
24031	210	3	0	115207	\N
24031	3539	4	0	115208	\N
24048	268	5	0	111358	\N
24048	6673	6	0	115298	\N
24051	4088	4	0	115311	\N
24051	6974	5	0	115312	\N
24054	79	4	0	115313	\N
24054	2758	5	0	115316	\N
24055	4172	4	0	115251	\N
24055	4219	5	0	115321	\N
24060	300	2	0	115345	\N
24060	2786	3	0	115346	\N
24065	16	0	0	115199	\N
24068	6678	10	0	115433	\N
24068	6979	11	0	115434	\N
24071	156	2	0	115209	\N
24071	4485	3	0	115453	\N
24076	33	2	0	115473	\N
24076	2822	3	0	115474	\N
24082	251	2	0	111083	\N
24082	1851	3	0	115504	\N
24084	793	1	0	115516	\N
24084	2972	2	0	115517	\N
24088	6982	9	0	115538	\N
24095	4172	2	0	115572	\N
24095	4191	3	0	115573	\N
24101	60	2	0	115502	\N
24101	4544	3	0	115503	\N
24109	27	0	0	114647	\N
24111	2899	1	0	115612	\N
24111	96	2	0	115613	\N
24119	40	10	0	115643	\N
24119	6986	11	0	115644	\N
24121	3625	2	0	112138	\N
24121	4359	3	0	115649	\N
24123	453	4	0	115658	\N
24123	3294	5	0	115659	\N
24126	40	4	0	115643	\N
24126	2796	5	0	115676	\N
24128	316	2	0	115683	\N
24128	1900	3	0	115684	\N
24131	6987	9	0	115709	\N
24134	4178	2	0	115728	\N
24134	4247	3	0	115729	\N
24143	92	4	0	113701	\N
24143	6053	5	0	115774	\N
24149	151	0	0	114972	\N
24157	391	3	0	115937	\N
24157	3660	4	0	115938	\N
24161	206	2	0	115949	\N
24161	2773	3	0	115950	\N
24164	6995	8	0	115966	\N
24164	6996	9	0	115967	\N
24166	40	2	0	115691	\N
24166	282	3	0	115692	\N
24171	27	5	0	116003	\N
24171	6997	6	0	116004	\N
24174	1021	2	0	116028	\N
24174	4432	3	0	116029	\N
24176	18	2	0	115939	\N
24176	1685	3	0	116032	\N
24179	451	1	0	116054	\N
24179	584	2	0	116055	\N
24186	23	3	0	116082	\N
24186	3497	4	0	116083	\N
24191	4172	2	0	116105	\N
24191	4191	3	0	116106	\N
24202	186	3	0	116166	\N
24202	4294	4	0	116167	\N
24205	3521	6	0	116184	\N
24205	391	7	0	116185	\N
24212	75	7	0	116214	\N
24212	2859	8	0	116215	\N
24219	6044	4	0	115896	\N
24219	6524	5	0	116250	\N
24224	4178	3	0	116271	\N
24224	4211	4	0	116272	\N
24226	4178	4	0	116282	\N
24226	4205	5	0	116283	\N
24229	365	4	0	116286	\N
24229	4049	5	0	116287	\N
24239	6975	13	0	116333	\N
24239	233	14	0	115315	\N
24242	233	3	0	114346	\N
24242	3704	4	0	116341	\N
24249	18	13	0	116389	\N
24249	4730	14	0	116390	\N
24256	4178	0	0	116282	\N
24261	56	3	0	116475	\N
24261	4109	4	0	116476	\N
24264	1021	7	0	116028	\N
24264	7009	8	0	116481	\N
24271	206	4	0	116531	\N
24271	3511	5	0	116532	\N
24273	121	4	0	116541	\N
24273	4356	5	0	116542	\N
24275	75	4	0	116214	\N
24275	7012	5	0	116553	\N
24278	132	4	0	116566	\N
24278	3716	5	0	116567	\N
24283	2	0	0	111339	\N
24286	2	0	0	113576	\N
24287	6044	3	0	115896	\N
24287	6045	4	0	116253	\N
24289	192	4	0	116597	\N
24289	3895	5	0	116598	\N
24291	40	4	0	116569	\N
24291	3381	5	0	116601	\N
24294	908	10	0	116632	\N
24294	7013	11	0	116633	\N
24301	151	3	0	114972	\N
24301	3046	4	0	114973	\N
24306	7017	3	0	116677	\N
24306	202	8	0	116686	\N
24306	7020	9	1	116688	\N
24306	7019	9	0	116689	\N
24306	7021	10	0	116690	\N
24311	94	3	0	115911	\N
24311	2864	4	0	116708	\N
24313	67	9	0	115095	\N
24313	7022	10	0	116729	\N
24316	290	3	0	114267	\N
24316	3635	4	0	114268	\N
24324	264	5	0	116840	\N
24324	5480	6	0	116841	\N
24326	1470	3	0	116744	\N
24326	3838	4	0	116863	\N
24331	7026	12	0	116897	\N
24340	16	2	0	116864	\N
24340	388	3	0	116928	\N
24345	266	3	0	111873	\N
24345	3474	4	0	111874	\N
24348	2351	3	0	115539	\N
24348	2845	4	0	116976	\N
24357	285	3	0	116102	\N
24357	4496	4	0	117014	\N
24359	135	2	0	117021	\N
24359	2722	3	0	117022	\N
24361	18	2	0	116389	\N
24361	1685	3	0	117027	\N
24364	4172	3	0	117038	\N
24364	4275	4	0	117039	\N
24370	7035	8	0	117089	\N
24370	7036	9	0	117090	\N
24372	69	2	0	117091	\N
24372	3350	3	0	117096	\N
24374	793	3	0	117103	\N
24374	2644	4	0	117104	\N
24379	79	1	0	117125	\N
24041	1381	3	0	115248	\N
24043	4178	4	0	115240	\N
24043	4205	5	0	115260	\N
24049	5885	5	0	115299	\N
24049	6212	6	0	115300	\N
24052	79	2	0	115313	\N
24052	80	3	0	115314	\N
24058	4178	2	0	115309	\N
24058	4247	3	0	115338	\N
24069	82	2	0	106141	\N
24069	3401	3	0	115439	\N
24072	2	2	0	113576	\N
24072	2789	3	0	115454	\N
24074	4178	2	0	115465	\N
24074	4247	3	0	115466	\N
24085	67	2	0	115095	\N
24085	394	3	0	115520	\N
24089	2351	8	0	115539	\N
24089	6983	9	0	115540	\N
24092	4178	2	0	115556	\N
24092	4247	3	0	115557	\N
24096	18	2	0	108901	\N
24096	1685	3	0	115574	\N
24097	90	2	0	115579	\N
24097	3442	3	0	115580	\N
24102	137	2	0	111732	\N
24102	2721	3	0	115591	\N
24104	113	2	0	115597	\N
24104	1899	3	0	115598	\N
24107	27	0	0	114647	\N
24112	2899	1	0	115612	\N
24112	96	2	0	115613	\N
24117	40	1	0	114951	\N
24117	1383	2	0	115620	\N
24122	3628	2	0	110347	\N
24122	4360	3	0	110348	\N
24124	14	4	0	115660	\N
24124	2291	5	0	115661	\N
24129	20	2	0	115689	\N
24129	369	3	0	115690	\N
24132	212	8	0	111341	\N
24132	6988	9	0	115710	\N
24135	288	2	0	115730	\N
24135	2842	3	0	115731	\N
24137	79	2	0	115494	\N
24137	3180	3	0	115738	\N
24139	2	2	0	115748	\N
24139	2789	3	0	115749	\N
24140	69	6	0	114694	\N
24140	6989	7	0	115762	\N
24147	56	2	0	115890	\N
24147	2795	3	0	115891	\N
24152	6303	5	0	106218	\N
24152	6994	6	0	115910	\N
24154	35	3	0	111930	\N
24154	3563	4	0	115919	\N
24158	18	3	0	115939	\N
24158	3621	4	0	115940	\N
24159	4178	2	0	115945	\N
24159	4247	3	0	115946	\N
24169	62	2	0	115991	\N
24169	2191	3	0	115992	\N
24172	264	5	0	116005	\N
24172	6998	6	0	116006	\N
24175	214	2	0	116030	\N
24175	1259	3	0	116031	\N
24180	16	2	0	115947	\N
24180	388	3	0	115948	\N
24182	2636	3	0	116065	\N
24182	2837	4	0	116066	\N
24184	4172	2	0	115572	\N
24184	4191	3	0	115573	\N
24187	4	34	0	116096	\N
24187	7001	35	0	116097	\N
24192	164	2	0	115233	\N
24192	1124	3	0	115582	\N
24195	132	3	0	116113	\N
24195	3729	4	0	116114	\N
24198	488	3	0	116144	\N
24198	1103	4	0	116145	\N
24203	125	3	0	114663	\N
24203	4170	4	0	116168	\N
24206	4824	6	0	116181	\N
24206	528	7	0	116186	\N
24207	4180	6	0	116187	\N
24207	18	7	0	116188	\N
24215	336	3	0	116231	\N
24215	3400	4	0	116232	\N
24217	435	3	0	116240	\N
24217	3504	4	0	116241	\N
24220	4172	3	0	116251	\N
24220	4275	4	0	116252	\N
24230	4172	4	0	116288	\N
24230	4219	5	0	116289	\N
24235	391	4	0	116154	\N
24235	3913	5	0	116155	\N
24237	4233	2	0	116321	\N
24237	5577	3	0	116322	\N
24244	4172	4	0	116288	\N
24244	4219	5	0	116289	\N
24246	186	3	0	116166	\N
24246	4294	4	0	116167	\N
24252	841	8	0	116425	\N
24252	7006	9	0	116426	\N
24254	4678	0	0	116428	\N
24257	2647	13	0	116455	\N
24257	7007	14	0	116456	\N
24259	4088	4	0	115311	\N
24259	4089	5	0	116466	\N
24262	123	3	0	111411	\N
24262	2856	4	0	111412	\N
24269	140	4	0	112963	\N
24269	3821	5	0	116528	\N
24284	102	3	0	104738	\N
24284	3597	4	0	116581	\N
24288	4178	3	0	116562	\N
24288	4211	4	0	116588	\N
24290	300	4	0	116599	\N
24290	6350	5	0	116600	\N
24295	908	1	0	116632	\N
24295	3149	2	0	116634	\N
24297	264	8	0	116636	\N
24297	7015	9	0	116637	\N
24302	360	3	0	116667	\N
24302	3602	4	0	116668	\N
24314	1470	7	0	116744	\N
24314	5261	8	0	116745	\N
24317	75	7	0	116768	\N
24317	2859	8	0	116769	\N
24323	230	7	0	116838	\N
24323	3952	8	0	116839	\N
24329	16	3	0	116864	\N
24329	3634	4	0	116865	\N
24330	79	4	0	116874	\N
24330	3678	5	0	116875	\N
24334	391	11	0	116154	\N
24334	7029	12	0	116901	\N
24337	4178	3	0	116727	\N
24337	4211	4	0	116911	\N
24339	4450	1	0	116921	\N
24339	4178	4	0	116922	\N
24339	4527	5	0	116923	\N
24342	4172	3	0	116936	\N
24342	4275	4	0	116937	\N
24344	4178	3	0	116952	\N
24344	4211	4	0	116953	\N
24347	170	3	0	114617	\N
24347	4148	4	0	116975	\N
24350	290	6	0	116991	\N
24350	7031	7	0	116992	\N
24352	595	2	0	116898	\N
24352	3285	3	0	116997	\N
24354	42	2	0	112102	\N
24354	3310	3	0	116999	\N
24356	79	3	0	117012	\N
24356	3652	4	0	117013	\N
24363	56	3	0	117036	\N
24263	6724	4	0	111410	\N
24265	142	15	0	116508	\N
24265	7010	16	0	116509	\N
24267	4172	3	0	116517	\N
24267	4275	4	0	116518	\N
24270	38	4	0	116529	\N
24270	5656	5	0	116530	\N
24274	200	4	0	116551	\N
24274	3473	5	0	116552	\N
24276	4178	4	0	116562	\N
24276	4205	5	0	116563	\N
24279	40	2	0	116569	\N
24279	282	3	0	116570	\N
24281	2	0	0	111339	\N
24285	2	0	0	113576	\N
24292	4178	3	0	116608	\N
24292	4211	4	0	116609	\N
24296	71	10	0	116269	\N
24296	7014	11	0	116635	\N
24298	391	6	0	116154	\N
24298	3521	7	0	116185	\N
24303	156	3	0	115209	\N
24303	4594	4	0	115210	\N
24307	1045	3	0	116691	\N
24307	16	8	0	116692	\N
24307	3118	9	0	116693	\N
24309	4178	3	0	116608	\N
24309	4211	4	0	116609	\N
24312	4178	9	0	116727	\N
24312	4682	10	0	116728	\N
24315	92	7	0	116746	\N
24315	5768	8	0	116747	\N
24318	108	6	0	116782	\N
24318	5748	7	0	116783	\N
24319	208	13	0	116810	\N
24319	7023	14	0	116811	\N
24321	40	4	0	116821	\N
24321	3381	5	0	116822	\N
24327	6723	3	0	110254	\N
24327	6724	4	0	111410	\N
24332	595	11	0	116898	\N
24332	7027	12	0	116899	\N
24335	156	11	0	115209	\N
24335	7030	12	0	116902	\N
24336	33	3	0	116909	\N
24336	3342	4	0	116910	\N
24338	412	1	0	116914	\N
24338	411	4	0	116919	\N
24338	2988	5	0	116920	\N
24343	4178	3	0	116944	\N
24343	4211	4	0	116945	\N
24355	4172	2	0	117004	\N
24355	4191	3	0	117005	\N
24360	137	2	0	111732	\N
24360	2721	3	0	115591	\N
24362	16	2	0	117028	\N
24362	388	3	0	117029	\N
24367	322	2	0	114299	\N
24367	1866	3	0	117069	\N
24373	69	0	0	117091	\N
24377	793	3	0	117115	\N
24377	7038	4	0	117116	\N
24380	16	1	0	117127	\N
24380	17	2	0	117128	\N
24382	411	4	0	117145	\N
24382	2806	5	0	117146	\N
24385	326	7	0	116564	\N
24385	7041	8	0	117162	\N
24387	198	2	0	112514	\N
24387	513	3	0	117168	\N
24392	40	5	0	117182	\N
24392	2714	6	0	117183	\N
24400	251	3	0	117219	\N
24400	3514	4	0	117220	\N
24403	273	3	0	115618	\N
24403	3638	4	0	117241	\N
24406	82	2	0	117249	\N
24406	3401	3	0	117250	\N
24408	391	3	0	116154	\N
24408	3660	4	0	116224	\N
24413	273	2	0	117294	\N
24413	1413	3	0	117295	\N
24416	435	2	0	116240	\N
24416	3413	3	0	117302	\N
24418	260	2	0	117322	\N
24418	3184	3	0	117323	\N
24427	40	2	0	117182	\N
24427	282	3	0	117394	\N
24428	198	3	0	112514	\N
24428	4263	4	0	117401	\N
24432	189	3	0	117407	\N
24432	3782	4	0	117408	\N
24437	367	7	0	117432	\N
24437	7051	8	0	117433	\N
24440	4172	2	0	117453	\N
24440	4191	3	0	117454	\N
24445	4172	2	0	117469	\N
24445	4191	3	0	117470	\N
24450	5885	4	0	117489	\N
24450	6674	5	0	117490	\N
24455	60	3	0	117515	\N
24455	3585	4	0	117516	\N
24458	2	4	0	115888	\N
24458	2830	5	0	117528	\N
24460	2	2	0	115888	\N
24460	2789	3	0	115889	\N
24462	300	0	0	116599	\N
24470	79	2	0	117590	\N
24470	616	3	0	117591	\N
24473	40	2	0	117182	\N
24473	66	3	0	117604	\N
24479	4172	2	0	117469	\N
24479	4191	3	0	117470	\N
24482	2782	0	0	117620	\N
24484	20	2	0	117636	\N
24484	369	3	0	117637	\N
24495	324	1	0	117704	\N
24495	325	2	0	117705	\N
24498	18	6	0	117242	\N
24498	4180	7	0	117720	\N
24500	108	2	0	117207	\N
24500	3340	3	0	117208	\N
24505	424	0	0	110213	\N
24507	125	5	0	117767	\N
24507	2847	6	0	117768	\N
24512	4178	5	0	117755	\N
24512	4429	6	0	117789	\N
24515	75	7	0	117809	\N
24515	3331	8	0	117810	\N
24521	391	2	0	117838	\N
24521	1381	3	0	117839	\N
24524	453	2	0	117842	\N
24524	3366	3	0	117843	\N
24534	6	4	0	117933	\N
24534	6228	5	0	117934	\N
24539	208	6	0	116810	\N
24539	7074	7	0	117958	\N
24542	14	4	0	117978	\N
24542	2291	5	0	117979	\N
24548	4178	2	0	117996	\N
24548	4247	3	0	117997	\N
24555	62	5	0	115991	\N
24555	4422	6	0	118018	\N
24557	7076	117	0	118021	\N
24557	54	126	0	118022	\N
24557	2152	127	0	118023	\N
24562	4178	2	0	118047	\N
24562	4247	3	0	118048	\N
24568	4178	4	0	118073	\N
24568	4331	5	0	118074	\N
24571	88	3	0	118083	\N
24571	3655	4	0	118084	\N
24572	208	9	0	116810	\N
24572	7077	10	0	118103	\N
24575	391	2	0	118111	\N
24575	1381	3	0	118112	\N
24577	7079	3	0	118119	\N
24299	5480	7	0	116650	\N
24300	835	4	0	116659	\N
24300	7016	5	0	116660	\N
24304	164	3	0	116669	\N
24304	3385	4	0	116670	\N
24305	7017	3	0	116677	\N
24305	202	8	0	116686	\N
24305	7018	9	0	116687	\N
24308	7017	3	0	116677	\N
24308	202	8	0	116686	\N
24308	7018	9	0	116687	\N
24310	69	3	0	116706	\N
24310	4536	4	0	116707	\N
24320	279	13	0	111350	\N
24320	7024	14	0	116812	\N
24322	142	7	0	116836	\N
24322	5668	8	0	116837	\N
24325	288	7	0	115730	\N
24325	7025	8	0	116856	\N
24328	123	3	0	111411	\N
24328	2856	4	0	111412	\N
24333	597	11	0	115536	\N
24333	7028	12	0	116900	\N
24341	365	3	0	116286	\N
24341	3839	4	0	116935	\N
24346	202	7	0	116968	\N
24346	4898	8	0	116687	\N
24349	115	6	0	116989	\N
24349	4693	7	0	116990	\N
24351	6825	3	0	111038	\N
24353	597	2	0	115536	\N
24353	3286	3	0	116998	\N
24358	181	2	0	117019	\N
24358	3313	3	0	117020	\N
24365	18	5	0	116389	\N
24365	7032	6	0	117050	\N
24368	4178	2	0	116952	\N
24368	4247	3	0	117070	\N
24375	4178	3	0	117111	\N
24375	5507	4	0	117112	\N
24378	38	30	0	117113	\N
24378	7039	31	0	117122	\N
24384	14	7	0	115660	\N
24384	7040	8	0	117161	\N
24388	528	2	0	114528	\N
24388	2765	3	0	117169	\N
24394	6044	2	0	115896	\N
24394	6188	3	0	117189	\N
24401	189	3	0	117227	\N
24401	7043	4	0	117228	\N
24404	18	3	0	117242	\N
24404	3621	4	0	117243	\N
24411	4178	3	0	117282	\N
24411	4441	4	0	117283	\N
24419	18	2	0	117242	\N
24419	1685	3	0	117324	\N
24421	7047	79	0	117350	\N
24421	64	126	0	117357	\N
24421	7048	127	0	117358	\N
24424	449	7	0	109527	\N
24424	6718	8	0	117385	\N
24429	391	3	0	117402	\N
24429	3660	4	0	117403	\N
24433	206	2	0	117413	\N
24433	2773	3	0	117414	\N
24438	206	2	0	117438	\N
24438	2773	3	0	117439	\N
24447	451	3	0	116054	\N
24447	3934	4	0	117478	\N
24451	18	4	0	117242	\N
24451	3779	5	0	117491	\N
24453	35	3	0	117500	\N
24453	3563	4	0	117501	\N
24456	27	3	0	116003	\N
24456	4636	4	0	117517	\N
24459	4172	4	0	117469	\N
24459	4252	5	0	117529	\N
24461	121	2	0	117534	\N
24461	2498	3	0	117535	\N
24466	200	3	0	116551	\N
24466	3338	4	0	117583	\N
24469	38	2	0	117113	\N
24469	4009	3	0	117585	\N
24471	4178	2	0	117592	\N
24471	4247	3	0	117593	\N
24474	60	0	0	117602	\N
24477	79	3	0	117590	\N
24477	3652	4	0	117614	\N
24480	2782	0	0	117620	\N
24485	455	1	0	117640	\N
24485	132	3	0	117643	\N
24488	100	3	0	117672	\N
24488	3836	4	0	117673	\N
24491	40	2	0	117182	\N
24491	282	3	0	117394	\N
24493	908	3	0	117698	\N
24493	3591	4	0	117699	\N
24496	324	2	0	117704	\N
24496	2808	3	0	117708	\N
24503	40	2	0	117749	\N
24503	282	3	0	117750	\N
24508	102	2	0	117773	\N
24508	3053	3	0	117774	\N
24511	94	2	0	115911	\N
24511	2794	3	0	117619	\N
24513	4172	5	0	117790	\N
24513	4415	6	0	117791	\N
24518	2	2	0	117832	\N
24518	2789	3	0	117833	\N
24525	7066	39	0	117844	\N
24525	453	126	0	117845	\N
24525	7067	127	0	117846	\N
24528	4172	2	0	117790	\N
24528	4191	3	0	117888	\N
24529	4178	5	0	117899	\N
24529	4429	6	0	117900	\N
24531	300	2	0	117907	\N
24531	2786	3	0	117908	\N
24535	6	20	0	117933	\N
24535	7070	21	0	117940	\N
24537	7071	0	0	117942	\N
24537	7072	0	0	117943	\N
24546	145	0	0	117980	\N
24549	56	2	0	117415	\N
24549	2795	3	0	117998	\N
24553	260	2	0	118004	\N
24553	3184	3	0	118005	\N
24556	54	5	0	118019	\N
24556	7075	6	0	118020	\N
24560	264	1	0	116840	\N
24560	270	2	0	118039	\N
24565	391	2	0	117838	\N
24565	1381	3	0	117839	\N
24569	14	4	0	117978	\N
24569	2291	5	0	117979	\N
24573	279	9	0	117956	\N
24573	7078	10	0	118104	\N
24581	4178	5	0	118159	\N
24581	4429	6	0	118160	\N
24585	7084	5	0	118184	\N
24585	6723	8	0	118185	\N
24585	7085	9	0	118186	\N
24587	7083	5	0	118181	\N
24587	90	8	0	118182	\N
24587	3039	9	0	118183	\N
24592	4787	7	0	118225	\N
24592	7089	8	0	118226	\N
24599	4787	1	0	118225	\N
24599	6663	2	0	118243	\N
24606	391	7	0	118284	\N
24606	3662	8	0	118285	\N
24611	2782	3	0	118299	\N
24611	3659	4	0	118300	\N
24615	16	3	0	118311	\N
24363	4109	4	0	117037	\N
24366	841	6	0	117063	\N
24366	7033	7	0	117064	\N
24369	4233	8	0	117087	\N
24369	7034	9	0	117088	\N
24371	69	0	0	117091	\N
24376	38	3	0	117113	\N
24376	7037	4	0	117114	\N
24386	132	7	0	116566	\N
24386	4559	8	0	117163	\N
24389	4172	2	0	117038	\N
24389	4191	3	0	117170	\N
24395	488	2	0	117190	\N
24395	2791	3	0	117191	\N
24397	108	2	0	117207	\N
24397	3340	3	0	117208	\N
24399	793	3	0	117217	\N
24399	2644	4	0	117218	\N
24402	4172	2	0	117233	\N
24402	4191	3	0	117234	\N
24409	56	1	0	117272	\N
24409	1088	2	0	117273	\N
24414	908	2	0	117300	\N
24414	2832	3	0	117301	\N
24417	33	7	0	116909	\N
24417	7044	8	0	117317	\N
24422	4178	7	0	117367	\N
24422	4509	8	0	117368	\N
24425	110	2	0	117390	\N
24425	626	3	0	117391	\N
24430	62	3	0	115991	\N
24430	3344	4	0	117404	\N
24434	56	0	0	117415	\N
24436	79	7	0	117430	\N
24436	4063	8	0	117431	\N
24441	4178	2	0	117367	\N
24441	4247	3	0	117459	\N
24443	40	4	0	117182	\N
24443	2796	5	0	117462	\N
24448	290	4	0	117487	\N
24448	2759	5	0	117488	\N
24454	149	3	0	116211	\N
24454	2374	4	0	117508	\N
24463	300	3	0	116599	\N
24463	3747	4	0	117542	\N
24464	88	7	0	117557	\N
24464	5323	8	0	117558	\N
24467	71	3	0	116269	\N
24467	3770	4	0	116270	\N
24475	2578	4	0	117605	\N
24475	7054	5	0	117606	\N
24478	94	2	0	115911	\N
24478	2794	3	0	117619	\N
24486	100	5	0	117656	\N
24486	7057	6	0	117657	\N
24489	202	4	0	117682	\N
24489	2293	5	0	117683	\N
24492	79	3	0	117692	\N
24492	3652	4	0	117693	\N
24501	54	3	0	117736	\N
24501	3041	4	0	117737	\N
24506	424	2	0	110213	\N
24506	2755	3	0	110771	\N
24509	7061	2	0	117775	\N
24509	2764	3	0	117776	\N
24519	151	2	0	117834	\N
24519	2854	3	0	117835	\N
24522	1171	2	0	45391	\N
24522	7065	3	0	117840	\N
24526	453	2	0	117842	\N
24526	3366	3	0	117843	\N
24532	121	2	0	117534	\N
24532	2498	3	0	117535	\N
24538	279	6	0	117956	\N
24538	7073	7	0	117957	\N
24540	285	9	0	116102	\N
24540	3421	10	0	117967	\N
24547	79	5	0	117692	\N
24547	3341	6	0	117991	\N
24550	244	2	0	115071	\N
24550	3308	3	0	115072	\N
24554	18	2	0	118006	\N
24554	1685	3	0	118007	\N
24558	125	2	0	118028	\N
24558	3297	3	0	118029	\N
24561	264	2	0	116840	\N
24561	2780	3	0	118042	\N
24563	18	3	0	118006	\N
24563	3621	4	0	118055	\N
24566	113	4	0	118070	\N
24566	5924	5	0	118071	\N
24570	4172	4	0	118075	\N
24570	4252	5	0	118076	\N
24578	391	2	0	118125	\N
24578	1381	3	0	118126	\N
24582	7082	5	0	118171	\N
24582	198	8	0	118176	\N
24582	3084	9	0	118177	\N
24593	300	7	0	118227	\N
24593	7090	8	0	118228	\N
24595	40	2	0	118109	\N
24595	282	3	0	118110	\N
24597	4787	2	0	118225	\N
24597	6245	3	0	118240	\N
24602	4178	3	0	118260	\N
24602	4441	4	0	118261	\N
24604	79	2	0	118268	\N
24604	616	3	0	118269	\N
24607	100	3	0	118292	\N
24607	3836	4	0	118293	\N
24613	164	3	0	116669	\N
24613	3385	4	0	116670	\N
24617	367	17	0	117432	\N
24617	7092	18	0	118348	\N
24619	140	3	0	112963	\N
24619	4149	4	0	112968	\N
24622	451	6	0	118369	\N
24622	7094	7	0	118370	\N
24624	3628	2	0	110347	\N
24624	4360	3	0	110348	\N
24637	81	1	0	118441	\N
24637	79	5	0	118442	\N
24637	7097	6	0	118443	\N
24640	40	8	0	118109	\N
24640	5163	9	0	118463	\N
24644	40	4	0	118482	\N
24644	7107	5	0	118483	\N
24649	4178	4	0	118496	\N
24649	4205	5	0	118497	\N
24651	4233	4	0	118507	\N
24651	7109	5	0	118508	\N
24658	140	3	0	118549	\N
24658	4149	4	0	118550	\N
24660	200	3	0	116551	\N
24660	3338	4	0	117583	\N
24663	7114	5	0	118569	\N
24666	86	2	0	118578	\N
24666	3321	3	0	118579	\N
24668	251	3	0	118586	\N
24668	3514	4	0	118587	\N
24670	210	4	0	115207	\N
24670	3536	5	0	118597	\N
24673	202	12	0	117776	\N
24673	7115	13	0	118624	\N
24675	228	3	0	113615	\N
24675	3186	4	0	118541	\N
24680	4172	3	0	118667	\N
24680	4275	4	0	118668	\N
24681	4644	5	0	118679	\N
24681	4172	12	0	118692	\N
24681	7116	13	0	118693	\N
24685	6044	10	0	115896	\N
24685	7118	11	0	118726	\N
24689	528	4	0	114528	\N
24689	5689	5	0	118738	\N
24692	4178	6	0	118760	\N
24379	81	2	0	117126	\N
24381	20	3	0	117135	\N
24381	2844	4	0	117136	\N
24390	16	2	0	117127	\N
24390	388	3	0	117171	\N
24391	411	3	0	117178	\N
24391	3596	4	0	117179	\N
24393	40	3	0	117182	\N
24393	372	4	0	117184	\N
24396	67	61	0	117201	\N
24396	7042	62	0	117202	\N
24398	290	2	0	117209	\N
24398	1909	3	0	117210	\N
24405	77	2	0	111413	\N
24405	3853	3	0	117248	\N
24407	4178	6	0	117111	\N
24407	6623	7	0	117263	\N
24410	4172	2	0	117276	\N
24410	4191	3	0	117277	\N
24412	102	3	0	104738	\N
24412	3597	4	0	116581	\N
24415	62	2	0	115991	\N
24415	2191	3	0	115992	\N
24420	7045	11	0	117325	\N
24420	64	48	0	117348	\N
24420	7046	49	0	117349	\N
24423	156	7	0	117369	\N
24423	5375	8	0	117370	\N
24426	7049	2	0	117392	\N
24426	7050	3	0	117393	\N
24431	90	3	0	117405	\N
24431	4074	4	0	117406	\N
24435	121	0	0	116541	\N
24439	4172	4	0	117276	\N
24439	4252	5	0	117448	\N
24442	40	8	0	117182	\N
24442	3438	9	0	117461	\N
24444	273	2	0	117467	\N
24444	1413	3	0	117468	\N
24446	451	9	0	116054	\N
24446	7052	10	0	117471	\N
24449	268	4	0	111358	\N
24449	4344	5	0	115127	\N
24452	58	3	0	117498	\N
24452	3665	4	0	117499	\N
24457	402	4	0	117526	\N
24457	2548	5	0	117527	\N
24465	336	8	0	117575	\N
24465	7053	9	0	117576	\N
24468	38	3	0	117113	\N
24468	3457	4	0	117584	\N
24472	60	4	0	117602	\N
24472	2771	5	0	117603	\N
24476	16	4	0	117127	\N
24476	2575	5	0	117607	\N
24481	2782	5	0	117620	\N
24481	2865	6	0	117631	\N
24483	2782	0	0	117620	\N
24487	16	4	0	117127	\N
24487	2575	5	0	117607	\N
24490	288	4	0	117684	\N
24490	5098	5	0	117685	\N
24494	7058	3	0	117700	\N
24494	7059	4	0	117701	\N
24497	56	6	0	117415	\N
24497	4703	7	0	117719	\N
24499	224	2	0	113809	\N
24499	3150	3	0	117725	\N
24502	7060	117	0	117742	\N
24502	54	126	0	117743	\N
24502	2152	127	0	117744	\N
24504	4178	2	0	117755	\N
24504	4247	3	0	117756	\N
24510	69	2	0	117777	\N
24510	3350	3	0	117778	\N
24514	7062	54	0	117792	\N
24514	1636	126	0	117793	\N
24514	7063	127	0	117794	\N
24516	1636	7	0	112088	\N
24516	4510	8	0	117811	\N
24517	7064	30	0	117826	\N
24517	186	31	0	117827	\N
24520	92	2	0	117836	\N
24520	2763	3	0	117837	\N
24523	186	2	0	116166	\N
24523	1850	3	0	117841	\N
24527	92	79	0	117836	\N
24527	7068	80	0	117887	\N
24530	1368	0	0	117901	\N
24530	7069	0	0	117902	\N
24533	77	5	0	117923	\N
24533	6215	6	0	117924	\N
24536	170	0	0	117941	\N
24541	4178	4	0	117976	\N
24541	4331	5	0	117977	\N
24543	145	0	0	117980	\N
24545	145	0	0	117980	\N
24551	75	2	0	117809	\N
24551	284	3	0	117999	\N
24559	4172	3	0	117790	\N
24559	4275	4	0	118036	\N
24564	336	2	0	118060	\N
24564	3332	3	0	118061	\N
24567	2	4	0	117832	\N
24567	2830	5	0	118072	\N
24574	40	2	0	118109	\N
24574	282	3	0	118110	\N
24576	58	3	0	117498	\N
24576	3665	4	0	117499	\N
24583	4427	5	0	118178	\N
24583	123	8	0	118179	\N
24583	4862	9	0	118180	\N
24588	202	2	0	118193	\N
24588	2764	3	0	118194	\N
24590	391	6	0	118207	\N
24590	4361	7	0	118208	\N
24591	7087	0	0	118209	\N
24591	7088	0	0	118210	\N
24600	71	3	0	118250	\N
24600	3770	4	0	118251	\N
24603	852	3	0	118262	\N
24603	1848	4	0	118263	\N
24605	38	2	0	117113	\N
24605	4009	3	0	117585	\N
24608	316	3	0	115683	\N
24608	4249	4	0	118294	\N
24610	262	3	0	118297	\N
24610	4778	4	0	118298	\N
24612	156	3	0	118301	\N
24612	4594	4	0	118302	\N
24614	73	3	0	118309	\N
24614	3040	4	0	118310	\N
24616	164	2	0	116669	\N
24616	3085	3	0	118313	\N
24618	391	17	0	118349	\N
24618	7093	18	0	118350	\N
24620	170	3	0	118357	\N
24620	4148	4	0	118358	\N
24625	451	3	0	118371	\N
24625	3934	4	0	118372	\N
24627	241	4	0	118383	\N
24627	4582	5	0	118384	\N
24629	40	3	0	118109	\N
24629	372	4	0	118413	\N
24632	137	3	0	118415	\N
24632	3633	4	0	118416	\N
24634	97	1	0	118432	\N
24634	96	5	0	118439	\N
24634	3131	6	0	118440	\N
24638	97	1	0	118432	\N
24638	96	5	0	118439	\N
24638	1075	6	1	118444	\N
24638	7098	6	0	118445	\N
24645	4178	4	0	118295	\N
24645	4468	5	0	118484	\N
24647	4088	4	0	118494	\N
24647	4089	5	0	118495	\N
24577	7080	4	0	118120	\N
24579	4178	2	0	118073	\N
24579	4247	3	0	118131	\N
24580	14	8	0	117978	\N
24580	7081	9	0	118148	\N
24584	7083	5	0	118181	\N
24584	90	8	0	118182	\N
24584	3039	9	0	118183	\N
24586	7082	5	0	118171	\N
24586	198	8	0	118176	\N
24586	6698	9	1	118187	\N
24586	7086	9	0	118188	\N
24589	202	2	0	118193	\N
24589	2764	3	0	118194	\N
24594	273	7	0	118229	\N
24594	7091	8	0	118230	\N
24596	2636	2	0	116065	\N
24596	2836	3	0	118235	\N
24598	262	2	0	118241	\N
24598	2743	3	0	118242	\N
24601	4178	3	0	118252	\N
24601	4211	4	0	118253	\N
24609	4178	3	0	118295	\N
24609	4211	4	0	118296	\N
24623	119	3	0	101527	\N
24623	2860	4	0	108058	\N
24630	4178	3	0	118295	\N
24630	4211	4	0	118296	\N
24635	81	1	0	118441	\N
24635	79	5	0	118442	\N
24635	7097	6	0	118443	\N
24641	115	8	0	116989	\N
24641	7100	9	0	118464	\N
24646	198	4	0	118461	\N
24646	7108	5	0	118485	\N
24648	233	4	0	116467	\N
24648	3775	5	0	116468	\N
24653	6765	4	0	118511	\N
24653	7111	5	0	118512	\N
24662	1636	4	0	118566	\N
24662	4118	5	0	118567	\N
24667	56	2	0	117415	\N
24667	2795	3	0	117998	\N
24672	18	4	0	118598	\N
24672	2302	5	0	118599	\N
24677	235	4	0	118641	\N
24677	3615	5	0	118642	\N
24679	4172	5	0	118659	\N
24679	4634	6	0	118660	\N
24686	16	10	0	118513	\N
24686	4835	11	0	118727	\N
24688	793	3	0	117217	\N
24688	5510	4	0	118737	\N
24693	4172	6	0	118762	\N
24693	4197	7	0	118763	\N
24695	71	5	0	118250	\N
24695	5503	6	0	118775	\N
24699	268	5	0	111358	\N
24699	7121	6	0	118781	\N
24707	102	10	0	117773	\N
24707	7128	11	0	118909	\N
24712	528	7	0	118950	\N
24712	7132	8	0	118951	\N
24715	4172	3	0	118776	\N
24715	4275	4	0	118968	\N
24717	16	6	0	118977	\N
24717	7135	7	0	118978	\N
24719	40	8	0	118482	\N
24719	5163	9	0	119011	\N
24722	56	0	0	117415	\N
24725	2782	44	0	119092	\N
24725	7140	45	0	119093	\N
24727	4178	6	0	119142	\N
24727	5854	7	0	119143	\N
24729	142	3	0	119152	\N
24729	4254	4	0	119153	\N
24734	876	3	0	119177	\N
24734	230	9	0	119188	\N
24734	3961	10	0	119189	\N
24736	876	3	0	119177	\N
24736	230	8	0	119188	\N
24736	6806	9	0	119193	\N
24746	336	8	0	119305	\N
24746	7147	9	0	119306	\N
24749	33	8	0	119335	\N
24749	7149	9	0	119336	\N
24752	1107	4	0	119363	\N
24752	7151	5	0	119364	\N
24754	258	3	0	110293	\N
24754	4401	4	0	119373	\N
24758	75	3	0	117809	\N
24758	3855	4	0	119377	\N
24761	322	7	0	119398	\N
24761	2857	8	0	119399	\N
24764	4331	4	0	119432	\N
24764	4178	8	0	119439	\N
24764	4941	9	0	119440	\N
24767	79	3	0	119452	\N
24767	3652	4	0	119453	\N
24774	244	2	0	115071	\N
24774	3308	3	0	115072	\N
24790	300	4	0	118227	\N
24790	6350	5	0	119650	\N
24792	94	10	0	119670	\N
24792	7157	11	0	119671	\N
24794	92	10	0	119677	\N
24794	7158	11	0	119678	\N
24797	264	4	0	119090	\N
24797	3684	5	0	119711	\N
24802	367	3	0	119750	\N
24802	3683	4	0	119751	\N
24812	367	5	0	119836	\N
24812	4414	6	0	119837	\N
24815	7165	82	0	119850	\N
24815	189	126	0	119869	\N
24815	7166	127	0	119870	\N
24816	16	3	0	119877	\N
24816	3634	4	0	119878	\N
24824	42	3	0	112102	\N
24824	3645	4	0	112103	\N
24828	262	3	0	118297	\N
24828	4778	4	0	118298	\N
24833	4178	3	0	119973	\N
24833	4211	4	0	119974	\N
24835	4172	3	0	119778	\N
24835	4275	4	0	119996	\N
24836	6872	9	0	120015	\N
24836	60	11	0	120018	\N
24836	5088	12	0	120019	\N
24839	4178	7	0	120038	\N
24839	4396	8	0	120039	\N
24843	16	3	0	120051	\N
24843	3634	4	0	120052	\N
24848	4178	4	0	120071	\N
24848	4205	5	0	120072	\N
24851	4178	7	0	120124	\N
24851	4396	8	0	120125	\N
24857	266	7	0	120161	\N
24857	4926	8	0	120162	\N
24858	4172	3	0	120040	\N
24858	4275	4	0	120169	\N
24861	391	8	0	120187	\N
24861	3922	9	0	120188	\N
24864	102	3	0	120220	\N
24864	3597	4	0	120221	\N
24866	6303	2	0	120225	\N
24866	7173	3	0	120226	\N
24869	56	3	0	119955	\N
24869	4109	4	0	120141	\N
24875	4178	3	0	120285	\N
24875	4211	4	0	120286	\N
24879	73	3	0	118309	\N
24879	3040	4	0	118310	\N
24884	262	3	0	120326	\N
24884	4778	4	0	120327	\N
24886	4178	3	0	120316	\N
24886	4211	4	0	120317	\N
24615	3634	4	0	118312	\N
24621	3625	3	0	118365	\N
24621	3784	4	0	118366	\N
24626	18	3	0	118373	\N
24626	3621	4	0	118374	\N
24628	316	10	0	118405	\N
24628	7095	11	0	118406	\N
24631	135	3	0	117021	\N
24631	3630	4	0	118414	\N
24633	2782	6	0	118299	\N
24633	7096	7	0	118429	\N
24636	81	1	0	118441	\N
24636	79	5	0	118442	\N
24636	7097	6	0	118443	\N
24639	198	8	0	118461	\N
24639	7099	9	0	118462	\N
24642	7101	8	0	118465	\N
24642	7102	8	0	118466	\N
24642	7104	9	1	118467	\N
24642	7103	9	0	118468	\N
24643	7105	65	0	118471	\N
24643	115	126	0	118472	\N
24643	7106	127	0	118473	\N
24654	16	4	0	118513	\N
24654	5446	5	0	118514	\N
24655	316	9	0	118533	\N
24655	7112	10	0	118534	\N
24657	326	3	0	116564	\N
24657	3339	4	0	118542	\N
24665	260	1	0	118574	\N
24665	1904	2	0	118575	\N
24683	4172	3	0	118703	\N
24683	4275	4	0	118704	\N
24684	262	10	0	118297	\N
24684	5412	11	0	118725	\N
24691	4178	4	0	118496	\N
24691	4205	5	0	118497	\N
24696	4172	5	0	118776	\N
24696	4644	6	0	118777	\N
24700	18	8	0	118598	\N
24700	7122	9	0	118798	\N
24703	4178	27	0	118869	\N
24703	7124	28	0	118870	\N
24710	7130	6	0	118931	\N
24710	4172	9	0	118932	\N
24710	4285	10	0	118933	\N
24720	2	8	0	119012	\N
24720	7136	9	0	119013	\N
24730	373	0	0	119154	\N
24732	18	7	0	119169	\N
24732	4459	8	0	119170	\N
24735	7141	3	0	119190	\N
24735	4172	8	0	119191	\N
24735	4252	9	0	119192	\N
24737	100	8	0	119208	\N
24737	3793	9	0	119209	\N
24739	4178	7	0	119225	\N
24739	5210	8	0	119226	\N
24744	235	8	0	119287	\N
24744	7146	9	0	119288	\N
24747	488	8	0	119307	\N
24747	7148	9	0	119308	\N
24753	102	4	0	119365	\N
24753	3572	5	0	119366	\N
24755	262	3	0	118297	\N
24755	4778	4	0	118298	\N
24759	62	7	0	119392	\N
24759	4781	8	0	119393	\N
24762	4172	7	0	119400	\N
24762	4614	8	0	119401	\N
24765	2356	4	0	119441	\N
24765	181	8	0	119442	\N
24765	5260	9	0	119443	\N
24768	5281	2	0	76044	\N
24768	7153	2	0	119454	\N
24768	616	3	0	119455	\N
24769	192	3	0	119462	\N
24769	3790	4	0	119463	\N
24775	241	2	0	119485	\N
24775	634	3	0	119486	\N
24777	156	4	0	118301	\N
24777	5935	5	0	119497	\N
24780	92	4	0	117836	\N
24780	3979	5	0	119521	\N
24785	35	4	0	118975	\N
24785	3545	5	0	119624	\N
24788	300	0	0	119639	\N
24793	258	4	0	119675	\N
24793	3057	5	0	119676	\N
24795	125	7	0	119693	\N
24795	4719	8	0	119694	\N
24800	273	4	0	119730	\N
24800	3390	5	0	119731	\N
24803	202	6	0	119764	\N
24803	7159	7	0	119765	\N
24805	149	4	0	119648	\N
24805	5500	5	0	119776	\N
24807	4172	3	0	119778	\N
24807	4440	4	0	119779	\N
24810	7161	112	0	119825	\N
24810	7162	112	0	119826	\N
24810	7164	113	1	119827	\N
24810	7163	113	0	119828	\N
24819	266	3	0	119898	\N
24819	3474	4	0	119899	\N
24822	402	3	0	119934	\N
24822	4077	4	0	119935	\N
24827	4178	8	0	119926	\N
24827	4237	9	0	119957	\N
24829	3625	3	0	118365	\N
24829	3784	4	0	118366	\N
24841	4787	3	0	118225	\N
24841	4788	4	0	120048	\N
24844	4787	0	0	118225	\N
24846	170	2	0	118357	\N
24846	1380	3	0	120060	\N
24854	90	3	0	120142	\N
24854	4074	4	0	120143	\N
24859	173	8	0	111286	\N
24859	7170	9	0	120185	\N
24862	67	7	0	117201	\N
24862	3608	8	0	120203	\N
24865	273	3	0	120222	\N
24865	3638	4	0	120223	\N
24870	6303	1	0	120225	\N
24870	7174	2	0	120229	\N
24873	488	4	0	119307	\N
24873	5606	5	0	120276	\N
24876	212	3	0	120287	\N
24876	3639	4	0	120288	\N
24880	12	4	0	120306	\N
24880	2272	5	0	120307	\N
24882	4178	3	0	120316	\N
24882	4211	4	0	120317	\N
24887	4178	3	0	120341	\N
24887	4211	4	0	120342	\N
24891	4172	2	0	120353	\N
24891	4285	3	0	120354	\N
24894	16	3	0	120378	\N
24894	3634	4	0	120379	\N
24897	391	4	0	120308	\N
24897	3913	5	0	120396	\N
24900	2636	4	0	120421	\N
24900	3617	5	0	120422	\N
24902	224	6	0	120436	\N
24902	7176	7	0	120437	\N
24907	597	4	0	120455	\N
24907	3733	5	0	120456	\N
24912	145	3	0	117980	\N
24912	4908	4	0	120473	\N
24915	6723	3	0	110254	\N
24915	6724	4	0	111410	\N
24918	2844	3	0	120482	\N
24918	20	5	0	120485	\N
24918	2975	6	0	118640	\N
24920	316	3	0	120500	\N
24920	4249	4	0	120501	\N
24650	181	4	0	117019	\N
24650	4058	5	0	118498	\N
24652	212	4	0	118509	\N
24652	7110	5	0	118510	\N
24656	228	3	0	113615	\N
24656	3186	4	0	118541	\N
24659	4178	3	0	118496	\N
24659	4211	4	0	118551	\N
24661	4178	4	0	118496	\N
24661	4205	5	0	118497	\N
24664	44	4	0	118570	\N
24664	3486	5	0	118571	\N
24669	4172	3	0	118075	\N
24669	4275	4	0	118588	\N
24671	4178	4	0	118496	\N
24671	4205	5	0	118497	\N
24674	202	0	0	116968	\N
24676	20	4	0	118639	\N
24676	3995	5	0	118640	\N
24678	100	3	0	118292	\N
24678	3836	4	0	118293	\N
24682	4645	5	0	118694	\N
24682	75	12	0	118695	\N
24682	7117	13	0	118696	\N
24687	69	4	0	117777	\N
24687	4041	5	0	118736	\N
24690	793	4	0	117217	\N
24690	3618	5	0	118739	\N
24698	5885	5	0	117489	\N
24698	7120	6	0	118780	\N
24701	4178	7	0	118760	\N
24701	5210	8	0	118813	\N
24702	173	27	0	111286	\N
24702	7123	28	0	118868	\N
24705	268	27	0	111358	\N
24705	7126	28	0	118872	\N
24706	132	7	0	118887	\N
24706	7127	8	0	118888	\N
24709	77	3	0	118929	\N
24709	1877	4	0	118930	\N
24711	2079	7	0	118948	\N
24711	7131	8	0	118949	\N
24714	38	7	0	118966	\N
24714	7133	8	0	118967	\N
24724	264	44	0	119090	\N
24724	7139	45	0	119091	\N
24726	4178	17	0	119128	\N
24726	5883	18	0	119129	\N
24731	373	0	0	119154	\N
24741	132	18	0	119265	\N
24741	7144	19	0	119266	\N
24743	14	8	0	119285	\N
24743	3967	9	0	119286	\N
24748	4172	4	0	119317	\N
24748	4252	5	0	119318	\N
24751	40	8	0	118482	\N
24751	3503	9	0	119354	\N
24757	262	2	0	118297	\N
24757	2743	3	0	119376	\N
24760	56	5	0	119396	\N
24760	3551	6	0	119397	\N
24766	336	3	0	119450	\N
24766	3400	4	0	119451	\N
24771	322	4	0	119398	\N
24771	5447	5	0	119474	\N
24773	75	3	0	117809	\N
24773	3855	4	0	119377	\N
24776	4178	4	0	119495	\N
24776	4205	5	0	119496	\N
24779	4178	6	0	119495	\N
24779	4250	7	0	119512	\N
24784	113	17	0	118070	\N
24784	7156	18	0	119615	\N
24789	149	4	0	119648	\N
24789	4040	5	0	119649	\N
24799	17	1	0	119715	\N
24799	16	4	0	119720	\N
24799	2974	5	0	119721	\N
24809	200	2	0	119791	\N
24809	3109	3	0	119792	\N
24814	189	5	0	117407	\N
24814	4540	6	0	119840	\N
24818	4178	5	0	119890	\N
24818	4429	6	0	119891	\N
24821	4178	13	0	119926	\N
24821	7167	14	0	119927	\N
24823	132	3	0	119265	\N
24823	3729	4	0	119936	\N
24826	56	8	0	119955	\N
24826	4150	9	0	119956	\N
24831	3628	2	0	110347	\N
24831	4360	3	0	110348	\N
24832	391	3	0	119971	\N
24832	3660	4	0	119972	\N
24838	360	7	0	116667	\N
24838	4970	8	0	120037	\N
24847	411	4	0	120069	\N
24847	4858	5	0	120070	\N
24850	4178	7	0	120071	\N
24850	4396	8	0	120109	\N
24853	56	3	0	119955	\N
24853	4109	4	0	120141	\N
24856	58	7	0	120159	\N
24856	4764	8	0	120160	\N
24872	290	3	0	119014	\N
24872	3635	4	0	120267	\N
24878	6765	3	0	118511	\N
24878	6884	4	0	120291	\N
24883	170	3	0	120318	\N
24883	4148	4	0	120319	\N
24889	73	3	0	120344	\N
24889	3040	4	0	120345	\N
24890	94	3	0	119670	\N
24890	2864	4	0	120352	\N
24893	322	9	0	119398	\N
24893	3756	10	0	120371	\N
24909	198	3	0	118461	\N
24909	4263	4	0	120464	\N
24928	326	7	0	120539	\N
24928	7041	8	0	120540	\N
24933	198	3	0	118461	\N
24933	4263	4	0	120464	\N
24935	230	3	0	120571	\N
24935	4181	4	0	120572	\N
24937	170	3	0	120593	\N
24937	4148	4	0	120594	\N
24940	88	6	0	120616	\N
24940	5263	7	0	120617	\N
24950	100	0	0	119208	\N
24953	198	26	0	120655	\N
24953	7183	27	0	120656	\N
24961	27	3	0	120686	\N
24961	4636	4	0	120687	\N
24962	58	8	0	120159	\N
24962	4820	9	0	120704	\N
24964	488	3	0	120712	\N
24964	1103	4	0	120713	\N
24968	842	1	0	120757	\N
24968	841	4	0	120758	\N
24968	7190	5	0	119375	\N
24970	411	2	0	120773	\N
24970	3370	3	0	120774	\N
24977	251	3	0	118586	\N
24977	3514	4	0	118587	\N
24979	3625	3	0	118365	\N
24979	3784	4	0	118366	\N
24981	3628	2	0	110347	\N
24981	4360	3	0	110348	\N
24985	3628	3	0	120833	\N
24985	3785	4	0	120834	\N
24986	2	11	0	120857	\N
24986	7192	12	0	120858	\N
24992	4233	2	0	118507	\N
24992	5577	3	0	120927	\N
24994	96	2	0	120930	\N
24994	7198	3	0	120931	\N
24996	96	5	0	119788	\N
24692	4250	7	0	118761	\N
24694	40	5	0	118482	\N
24694	5806	6	0	118774	\N
24697	181	5	0	118778	\N
24697	7119	6	0	118779	\N
24704	5885	27	0	117489	\N
24704	7125	28	0	118871	\N
24708	2400	6	0	118922	\N
24708	77	9	0	118927	\N
24708	7129	10	0	118928	\N
24713	2079	7	0	118948	\N
24713	7131	8	0	118949	\N
24716	35	7	0	118975	\N
24716	7134	8	0	118976	\N
24718	18	8	0	118993	\N
24718	6015	9	0	118994	\N
24721	290	8	0	119014	\N
24721	7137	9	0	119015	\N
24723	79	44	0	119088	\N
24723	7138	45	0	119089	\N
24728	79	3	0	119150	\N
24728	3652	4	0	119151	\N
24733	373	0	0	119154	\N
24738	90	8	0	117405	\N
24738	7142	9	0	119210	\N
24740	214	18	0	119263	\N
24740	7143	19	0	119264	\N
24742	241	18	0	119267	\N
24742	7145	19	0	119268	\N
24745	14	8	0	119285	\N
24745	3967	9	0	119286	\N
24750	27	8	0	116003	\N
24750	7150	9	0	119337	\N
24756	841	3	0	119374	\N
24756	3604	4	0	119375	\N
24763	140	10	0	119422	\N
24763	7152	11	0	119423	\N
24770	2636	4	0	119472	\N
24770	3617	5	0	119473	\N
24772	435	3	0	116240	\N
24772	3504	4	0	116241	\N
24778	285	6	0	119510	\N
24778	3903	7	0	119511	\N
24781	7154	23	0	119539	\N
24781	92	56	0	119572	\N
24781	7155	57	0	119573	\N
24782	92	3	0	119580	\N
24782	4410	4	0	119581	\N
24786	92	6	0	119637	\N
24786	3651	7	0	119638	\N
24796	16	3	0	119701	\N
24796	3634	4	0	119702	\N
24798	56	4	0	119396	\N
24798	3127	5	0	119712	\N
24801	40	5	0	119742	\N
24801	2714	6	0	119743	\N
24804	316	6	0	119766	\N
24804	7160	7	0	119767	\N
24806	54	4	0	118019	\N
24806	2570	5	0	119777	\N
24808	96	4	0	119788	\N
24808	3515	5	0	119789	\N
24811	67	4	0	117201	\N
24811	5267	5	0	119829	\N
24813	453	5	0	119838	\N
24813	2364	6	0	119839	\N
24817	2	5	0	119012	\N
24817	3624	6	0	119889	\N
24820	391	13	0	118349	\N
24820	1511	14	0	119925	\N
24825	192	8	0	119953	\N
24825	7168	9	0	119954	\N
24830	119	3	0	101527	\N
24830	2860	4	0	108058	\N
24834	316	7	0	119766	\N
24834	3866	8	0	119989	\N
24837	4682	9	0	120020	\N
24837	4178	11	0	120021	\N
24837	4460	12	0	120022	\N
24840	4172	7	0	120040	\N
24840	4614	8	0	120041	\N
24842	453	3	0	120049	\N
24842	2838	4	0	120050	\N
24845	170	3	0	118357	\N
24845	4148	4	0	118358	\N
24849	40	10	0	120093	\N
24849	6986	11	0	120094	\N
24852	33	4	0	119335	\N
24852	7169	5	0	120134	\N
24855	102	7	0	119365	\N
24855	5310	8	0	120158	\N
24860	288	8	0	117684	\N
24860	7171	9	0	120186	\N
24863	42	5	0	112102	\N
24863	7172	6	0	120213	\N
24867	6303	3	0	120225	\N
24867	6304	4	0	120227	\N
24868	71	1	0	118250	\N
24868	3035	2	0	120228	\N
24871	7175	15	0	120256	\N
24871	264	17	0	120259	\N
24871	2941	18	0	120260	\N
24874	1109	4	0	120277	\N
24874	3816	5	0	120278	\N
24877	181	3	0	120289	\N
24877	4184	4	0	120290	\N
24881	391	4	0	120308	\N
24881	3352	5	0	120309	\N
24885	266	3	0	120161	\N
24885	3474	4	0	120328	\N
24888	373	3	0	119154	\N
24888	3590	4	0	120343	\N
24892	4178	9	0	120341	\N
24892	4682	10	0	120370	\N
24895	449	3	0	120380	\N
24895	4760	4	0	120381	\N
24898	4178	6	0	120409	\N
24898	4250	7	0	120410	\N
24903	6044	6	0	115896	\N
24903	6264	7	0	120438	\N
24905	212	3	0	120287	\N
24905	3639	4	0	120288	\N
24908	595	4	0	116898	\N
24908	3878	5	0	120457	\N
24910	336	3	0	120465	\N
24910	3400	4	0	120466	\N
24914	324	3	0	120474	\N
24914	4514	4	0	120475	\N
24917	2844	3	0	120482	\N
24917	20	5	0	120485	\N
24917	2975	6	0	118640	\N
24919	16	3	0	120492	\N
24919	3634	4	0	120493	\N
24921	82	4	0	117249	\N
24921	3508	5	0	120510	\N
24927	927	7	0	8544	\N
24927	7177	8	0	120538	\N
24932	1470	4	0	120562	\N
24932	5655	5	0	120563	\N
24946	100	0	0	119208	\N
24949	100	0	0	119208	\N
24952	198	3	0	118461	\N
24952	4263	4	0	120464	\N
24955	2782	3	0	119092	\N
24955	3659	4	0	120665	\N
24957	4172	4	0	120541	\N
24957	4219	5	0	120674	\N
24960	90	3	0	120683	\N
24960	4074	4	0	120685	\N
24967	4450	1	0	120746	\N
24967	7185	4	0	120751	\N
24967	7186	4	0	120752	\N
24969	18	4	0	120767	\N
24967	7187	5	1	138706	\N
24967	7189	6	1	138708	\N
24896	102	3	0	120220	\N
24896	3597	4	0	120221	\N
24899	108	4	0	120419	\N
24899	4060	5	0	120420	\N
24901	56	4	0	119955	\N
24901	3127	5	0	120423	\N
24904	113	3	0	120445	\N
24904	3620	4	0	120446	\N
24906	6467	5	0	102615	\N
24911	198	3	0	118461	\N
24911	4263	4	0	120464	\N
24913	123	3	0	111411	\N
24913	2856	4	0	111412	\N
24916	123	3	0	111411	\N
24916	2856	4	0	111412	\N
24923	164	7	0	116669	\N
24923	5711	8	0	120519	\N
24925	4178	7	0	120534	\N
24925	4509	8	0	120535	\N
24929	4172	4	0	120541	\N
24929	7178	5	0	120542	\N
24934	38	3	0	118966	\N
24934	3457	4	0	120570	\N
24936	7181	8	0	120573	\N
24936	198	31	0	120585	\N
24936	7182	32	0	120586	\N
24938	14	4	0	119285	\N
24938	3498	5	0	120603	\N
24941	230	6	0	120618	\N
24941	4182	7	0	120619	\N
24943	230	0	0	116838	\N
24947	100	4	0	119208	\N
24947	3776	5	0	120635	\N
24958	192	3	0	119953	\N
24958	3790	4	0	120681	\N
24963	4172	8	0	120541	\N
24963	4500	9	0	120705	\N
24965	40	3	0	120720	\N
24965	372	4	0	120721	\N
24971	88	3	0	120778	\N
24971	3655	4	0	120779	\N
24973	908	8	0	117698	\N
24973	3509	9	0	120795	\N
24980	119	3	0	101527	\N
24980	2860	4	0	108058	\N
24982	2	5	0	120829	\N
24982	6376	6	0	120830	\N
24987	451	11	0	118371	\N
24987	7193	12	0	120859	\N
24997	62	7	0	119392	\N
24997	7200	8	0	120956	\N
25001	135	8	0	117021	\N
25001	7203	9	0	120977	\N
25002	145	3	0	117980	\N
25002	4908	4	0	120473	\N
25007	60	3	0	120925	\N
25007	3585	4	0	120926	\N
25009	79	2	0	119452	\N
25009	616	3	0	121012	\N
25013	4178	2	0	121038	\N
25013	4247	3	0	121039	\N
25017	4787	0	0	118225	\N
25018	672	0	0	121047	\N
25025	4178	1	0	121038	\N
25025	4450	2	0	121080	\N
25026	40	2	0	121085	\N
25026	282	3	0	121086	\N
25032	449	2	0	120380	\N
25032	646	3	0	121115	\N
25037	4178	2	0	121137	\N
25037	4247	3	0	121138	\N
25041	113	1	0	120445	\N
25041	1102	2	0	121148	\N
25050	242	2	0	121203	\N
25050	3425	3	0	121207	\N
25052	12	2	0	121216	\N
25052	2804	3	0	121217	\N
25057	2351	3	0	115539	\N
25057	2845	4	0	116976	\N
25060	58	3	0	121271	\N
25060	3665	4	0	121272	\N
25062	82	3	0	8252	\N
25062	4505	4	0	121281	\N
25067	4178	3	0	121316	\N
25067	4211	4	0	121317	\N
25070	186	7	0	116166	\N
25070	4595	8	0	121356	\N
25071	186	3	0	116166	\N
25071	7219	4	0	121357	\N
25073	1021	7	0	116028	\N
25073	7220	8	0	121368	\N
25085	156	13	0	121457	\N
25085	7222	14	0	121458	\N
25088	7224	6	0	121482	\N
25088	82	7	0	121483	\N
25094	117	3	0	121045	\N
25094	3653	4	0	121501	\N
25096	7225	3	0	121503	\N
25096	7226	4	0	121504	\N
25099	4233	3	0	121515	\N
25099	4425	4	0	121516	\N
25107	288	10	0	121560	\N
25107	7228	11	0	121561	\N
25109	940	3	0	121566	\N
25109	44	14	0	121569	\N
25109	7229	15	0	121570	\N
25112	145	3	0	121593	\N
25112	4908	4	0	121594	\N
25114	181	3	0	120289	\N
25114	4184	4	0	120290	\N
25119	189	6	0	117407	\N
25119	3713	7	0	121626	\N
25122	79	3	0	121641	\N
25122	3652	4	0	121642	\N
25127	4172	3	0	121539	\N
25127	4275	4	0	121670	\N
25130	56	3	0	121653	\N
25130	4109	4	0	121688	\N
25132	69	7	0	117777	\N
25132	3711	8	0	121705	\N
25134	595	7	0	116898	\N
25134	5821	8	0	121708	\N
25136	230	3	0	120618	\N
25136	4181	4	0	121716	\N
25145	83	1	0	121754	\N
25145	82	4	0	121759	\N
25148	164	3	0	121064	\N
25148	3385	4	0	121739	\N
25152	528	4	0	121807	\N
25152	7242	5	0	121808	\N
25154	56	4	0	121817	\N
25154	3127	5	0	121818	\N
25163	3625	3	0	118365	\N
25163	3784	4	0	118366	\N
25165	119	3	0	101527	\N
25165	2860	4	0	108058	\N
25168	96	4	0	121880	\N
25168	3515	5	0	121881	\N
25172	173	4	0	121830	\N
25172	3857	5	0	121898	\N
25177	391	3	0	121127	\N
25177	3660	4	0	121517	\N
25180	56	0	0	121300	\N
25182	56	0	0	121300	\N
25185	242	11	0	121989	\N
25185	6607	12	0	121990	\N
25191	479	1	0	122013	\N
25191	360	5	0	122020	\N
25191	7250	6	1	122021	\N
25191	7249	6	0	122022	\N
25191	3268	7	0	122023	\N
25195	6	4	0	122037	\N
25195	7253	5	0	122038	\N
25197	110	3	0	117390	\N
24922	164	3	0	116669	\N
24922	3385	4	0	116670	\N
24924	4172	2	0	120520	\N
24924	4285	3	0	120521	\N
24926	210	7	0	120536	\N
24926	4558	8	0	120537	\N
24930	7179	117	0	120550	\N
24930	326	126	0	120552	\N
24930	7180	127	0	120553	\N
24931	927	0	0	8544	\N
24939	230	0	0	116838	\N
24942	230	0	0	116838	\N
24944	230	0	0	116838	\N
24945	2	3	0	119012	\N
24945	3548	4	0	120626	\N
24948	4172	3	0	120541	\N
24948	4940	4	0	120636	\N
24951	100	0	0	119208	\N
24954	200	3	0	120663	\N
24954	3338	4	0	120664	\N
24956	2636	4	0	120421	\N
24956	3617	5	0	120422	\N
24959	90	2	0	120683	\N
24959	3442	3	0	120684	\N
24966	242	10	0	120742	\N
24966	7184	11	0	120743	\N
24972	94	1	0	119670	\N
24972	107	2	0	120780	\N
24974	336	8	0	120796	\N
24974	7191	9	0	120797	\N
24978	4178	3	0	120813	\N
24978	4211	4	0	120814	\N
24983	119	5	0	101527	\N
24983	6113	6	0	120831	\N
24988	7194	62	0	120866	\N
24988	451	126	0	120895	\N
24988	7195	127	0	120896	\N
24989	123	10	0	111411	\N
24989	7196	11	0	120917	\N
24991	60	3	0	120925	\N
24991	3585	4	0	120926	\N
24993	4233	3	0	118507	\N
24993	4425	4	0	120928	\N
24998	62	5	0	119392	\N
24998	6466	6	0	120957	\N
25003	228	3	0	120984	\N
25003	3186	4	0	120985	\N
25005	264	7	0	120999	\N
25005	7204	8	0	121000	\N
25010	90	2	0	120683	\N
25010	3442	3	0	120684	\N
25014	288	2	0	117684	\N
25014	2842	3	0	121040	\N
25021	164	7	0	121064	\N
25021	7210	8	0	121066	\N
25023	4172	4	0	120541	\N
25023	4252	5	0	121075	\N
25027	416	2	0	121087	\N
25027	7211	3	0	121088	\N
25033	4172	2	0	120541	\N
25033	4285	3	0	121120	\N
25034	391	3	0	121127	\N
25034	503	4	0	121128	\N
25038	7212	24	0	121141	\N
25038	7185	32	0	120751	\N
25038	7213	32	0	121143	\N
25038	7215	33	1	121144	\N
25038	7214	33	0	121145	\N
25042	100	6	0	121161	\N
25042	7216	7	0	121162	\N
25045	16	2	0	121185	\N
25045	388	3	0	121186	\N
25053	1636	2	0	118566	\N
25053	4416	3	0	121218	\N
25055	4172	4	0	121229	\N
25055	4219	5	0	121230	\N
25058	212	4	0	121262	\N
25058	3732	5	0	121263	\N
25065	56	4	0	121300	\N
25065	3127	5	0	121301	\N
25068	7218	7	0	121332	\N
25068	4713	8	0	121333	\N
25078	96	2	0	119788	\N
25078	2347	3	0	121392	\N
25090	360	3	0	116667	\N
25090	3602	4	0	116668	\N
25101	1636	3	0	118566	\N
25101	5514	4	0	121518	\N
25103	132	3	0	121520	\N
25103	3729	4	0	121521	\N
25105	132	3	0	121520	\N
25105	3729	4	0	121521	\N
25110	4178	3	0	121366	\N
25110	4211	4	0	121577	\N
25115	4	3	0	121607	\N
25115	7230	4	0	121608	\N
25123	2782	3	0	121643	\N
25123	3659	4	0	121644	\N
25125	132	4	0	121520	\N
25125	3716	5	0	121655	\N
25141	5885	3	0	117489	\N
25141	5926	4	0	121730	\N
25143	164	3	0	121064	\N
25143	3385	4	0	121739	\N
25150	16	42	0	121273	\N
25150	1902	43	0	121796	\N
25153	86	4	0	121803	\N
25153	7243	5	0	121809	\N
25155	33	6	0	121078	\N
25155	5284	7	0	121829	\N
25157	1109	6	0	120277	\N
25157	4145	7	0	121832	\N
25159	4178	3	0	121840	\N
25159	4211	4	0	121841	\N
25161	86	4	0	121857	\N
25161	4052	5	0	121858	\N
25170	4172	3	0	121859	\N
25170	4275	4	0	121890	\N
25175	117	3	0	121045	\N
25175	3653	4	0	121501	\N
25178	71	3	0	121944	\N
25178	3770	4	0	121945	\N
25183	268	30	0	111358	\N
25183	7245	31	0	121984	\N
25187	268	11	0	111358	\N
25187	7247	12	0	121993	\N
25189	431	6	0	122007	\N
25189	4092	7	0	122008	\N
25196	18	8	0	122055	\N
25196	3937	9	0	122056	\N
25199	40	3	0	122066	\N
25199	372	4	0	122067	\N
25201	841	7	0	119374	\N
25201	5065	8	0	122109	\N
25203	35	7	0	122112	\N
25203	5077	8	0	122113	\N
25209	208	3	0	116810	\N
25209	4490	4	0	121502	\N
25211	7225	3	0	121503	\N
25211	7226	4	0	121504	\N
25215	56	3	0	122110	\N
25215	4109	4	0	122188	\N
25218	260	4	0	122211	\N
25218	3728	5	0	122212	\N
25220	18	3	0	122219	\N
25220	3621	4	0	122220	\N
25222	38	4	0	118966	\N
25222	5656	5	0	122231	\N
25233	4178	5	0	122283	\N
25233	4202	6	0	122284	\N
25235	391	5	0	122158	\N
25235	3558	6	0	122286	\N
25237	4348	0	0	122288	\N
25237	7259	0	0	122289	\N
25242	4178	3	0	122324	\N
25242	4211	4	0	122325	\N
25250	4178	7	0	122417	\N
24969	2302	5	0	120768	\N
24975	251	8	0	118586	\N
24975	6851	9	0	120798	\N
24976	316	3	0	120805	\N
24976	4249	4	0	120806	\N
24984	3625	5	0	118365	\N
24984	6114	6	0	120832	\N
24990	6723	10	0	110254	\N
24990	7197	11	0	120918	\N
24995	96	25	0	119788	\N
24995	7199	26	0	120941	\N
25000	137	7	0	120975	\N
25000	7202	8	0	120976	\N
25006	164	7	0	116669	\N
25006	5968	8	0	121001	\N
25011	60	2	0	120925	\N
25011	4544	3	0	121021	\N
25012	107	1	0	121024	\N
25012	7185	4	0	121029	\N
25012	7205	4	0	121030	\N
25012	7207	6	0	121033	\N
25016	117	2	0	121045	\N
25016	1257	3	0	121046	\N
25019	528	9	0	118950	\N
25019	7208	10	0	121063	\N
25022	214	4	0	119263	\N
25022	3355	5	0	121074	\N
25024	33	1	0	121078	\N
25024	163	2	0	121079	\N
25030	73	5	0	121107	\N
25030	4931	6	0	121108	\N
25031	75	2	0	121113	\N
25031	284	3	0	121114	\N
25036	142	2	0	121135	\N
25036	4418	3	0	121136	\N
25040	113	2	0	120445	\N
25040	1899	3	0	121147	\N
25044	264	3	0	120999	\N
25044	3632	4	0	121180	\N
25047	16	2	0	121193	\N
25047	388	3	0	121194	\N
25049	242	1	0	121203	\N
25049	253	2	0	121204	\N
25051	200	3	0	120663	\N
25051	3338	4	0	120664	\N
25054	44	2	0	121219	\N
25054	1910	3	0	121220	\N
25064	156	3	0	121290	\N
25064	4594	4	0	121291	\N
25072	4178	7	0	121366	\N
25072	4509	8	0	121367	\N
25075	451	3	0	118371	\N
25075	3934	4	0	118372	\N
25077	260	4	0	118574	\N
25077	3728	5	0	121387	\N
25080	290	8	0	121411	\N
25080	4155	9	0	121412	\N
25081	30	8	0	107071	\N
25081	4030	9	0	121413	\N
25084	424	13	0	121455	\N
25084	7221	14	0	121456	\N
25087	5086	6	0	121480	\N
25087	102	7	0	121481	\N
25089	5086	6	0	121480	\N
25089	102	7	0	121481	\N
25092	360	4	0	116667	\N
25092	3513	5	0	121494	\N
25098	62	3	0	121513	\N
25098	3344	4	0	121514	\N
25102	4233	2	0	121515	\N
25102	6713	3	0	121519	\N
25104	44	46	0	121535	\N
25104	7227	47	0	121536	\N
25106	4172	4	0	121539	\N
25106	4219	5	0	121540	\N
25111	273	4	0	120222	\N
25111	3777	5	0	121586	\N
25117	4178	6	0	121623	\N
25117	4250	7	0	121624	\N
25120	7232	82	1	121627	\N
25120	7231	82	0	121628	\N
25120	189	125	0	121629	\N
25120	7234	126	1	121630	\N
25120	7233	126	0	121631	\N
25120	2519	127	1	121632	\N
25120	6693	127	0	121633	\N
25124	56	4	0	121653	\N
25124	3127	5	0	121654	\N
25126	2636	3	0	121662	\N
25126	2837	4	0	121663	\N
25129	140	3	0	121686	\N
25129	4149	4	0	121687	\N
25131	77	7	0	121703	\N
25131	6022	8	0	121704	\N
25138	170	3	0	121719	\N
25138	4148	4	0	121720	\N
25140	268	3	0	111358	\N
25140	3815	4	0	121729	\N
25142	40	3	0	121737	\N
25142	372	4	0	121738	\N
25147	164	3	0	121064	\N
25147	3385	4	0	121739	\N
25149	56	5	0	121653	\N
25149	6463	6	0	121782	\N
25151	86	3	0	121803	\N
25151	7241	4	0	121804	\N
25156	173	6	0	121830	\N
25156	6103	7	0	121831	\N
25158	373	6	0	119154	\N
25158	7244	7	0	121833	\N
25160	380	4	0	121842	\N
25160	16	15	0	121848	\N
25160	1045	16	0	121849	\N
25167	210	4	0	120536	\N
25167	3536	5	0	121879	\N
25169	242	3	0	121888	\N
25169	2839	4	0	121889	\N
25171	242	2	0	121888	\N
25171	4576	3	0	121891	\N
25174	40	3	0	121915	\N
25174	372	4	0	121916	\N
25179	214	3	0	121952	\N
25179	3496	4	0	121953	\N
25184	125	11	0	121987	\N
25184	5675	12	0	121988	\N
25186	5885	11	0	121991	\N
25186	7246	12	0	121992	\N
25188	242	8	0	121989	\N
25188	7248	9	0	121994	\N
25190	6	6	0	122009	\N
25190	6641	7	0	122010	\N
25193	479	1	0	122013	\N
25193	360	5	0	122020	\N
25193	7251	6	0	121494	\N
25204	88	3	0	122120	\N
25204	3655	4	0	122121	\N
25207	149	7	0	119648	\N
25207	5255	8	0	122151	\N
25219	40	3	0	122066	\N
25219	372	4	0	122067	\N
25221	908	4	0	122229	\N
25221	3488	5	0	122230	\N
25224	102	3	0	122240	\N
25224	3597	4	0	122241	\N
25228	88	5	0	122254	\N
25228	5942	6	0	122255	\N
25232	86	5	0	122271	\N
25232	7243	6	0	122272	\N
25234	151	5	0	117834	\N
25234	7258	6	0	122285	\N
25236	42	5	0	121189	\N
25236	7172	6	0	122287	\N
25241	528	4	0	121807	\N
25241	5689	5	0	122317	\N
25248	4172	3	0	121859	\N
24996	5078	6	0	120951	\N
24999	336	8	0	120796	\N
24999	7201	9	0	120974	\N
25004	151	3	0	117834	\N
25004	3046	4	0	120986	\N
25008	453	3	0	120049	\N
25008	2838	4	0	120050	\N
25015	4787	2	0	118225	\N
25015	6245	3	0	118240	\N
25020	164	9	0	121064	\N
25020	7209	10	0	121065	\N
25028	391	2	0	121093	\N
25028	1381	3	0	121094	\N
25029	4178	5	0	121105	\N
25029	4429	6	0	121106	\N
25035	235	3	0	121129	\N
25035	5466	4	0	121130	\N
25039	402	2	0	119934	\N
25039	2760	3	0	121146	\N
25043	173	5	0	111286	\N
25043	4902	6	0	121173	\N
25046	42	1	0	121189	\N
25046	43	2	0	121190	\N
25048	251	3	0	118586	\N
25048	3514	4	0	118587	\N
25056	40	8	0	121085	\N
25056	3503	9	0	121247	\N
25059	6765	4	0	118511	\N
25059	7217	5	0	121264	\N
25061	16	3	0	121273	\N
25061	3634	4	0	121274	\N
25063	18	3	0	121282	\N
25063	3621	4	0	121283	\N
25066	56	3	0	121308	\N
25066	4109	4	0	121309	\N
25069	324	3	0	121340	\N
25069	4514	4	0	121341	\N
25074	1021	3	0	121375	\N
25074	4551	4	0	121376	\N
25076	290	4	0	121385	\N
25076	5879	5	0	121386	\N
25079	96	3	0	119788	\N
25079	2803	4	0	121395	\N
25082	244	3	0	115071	\N
25082	4075	4	0	121420	\N
25083	198	3	0	121427	\N
25083	4263	4	0	121428	\N
25086	4071	4	0	54612	\N
25086	7223	5	0	121467	\N
25091	88	4	0	120778	\N
25091	3809	5	0	121493	\N
25093	88	4	0	120778	\N
25093	3809	5	0	121493	\N
25095	208	3	0	116810	\N
25095	4490	4	0	121502	\N
25097	279	3	0	121505	\N
25097	3641	4	0	121506	\N
25100	391	3	0	121127	\N
25100	3660	4	0	121517	\N
25108	4172	6	0	121564	\N
25108	4365	7	0	121565	\N
25113	391	3	0	121127	\N
25113	3660	4	0	121517	\N
25116	145	6	0	121621	\N
25116	5341	7	0	121622	\N
25118	4172	6	0	121539	\N
25118	4197	7	0	121625	\N
25121	4178	3	0	121623	\N
25121	4211	4	0	121640	\N
25128	4178	4	0	121623	\N
25128	4205	5	0	121679	\N
25133	6450	7	0	121706	\N
25133	7235	8	0	121707	\N
25135	597	7	0	120455	\N
25135	5820	8	0	121709	\N
25137	200	3	0	121717	\N
25137	3338	4	0	121718	\N
25139	54	3	0	121727	\N
25139	3041	4	0	121728	\N
25144	4172	5	0	121750	\N
25144	4634	6	0	121751	\N
25146	7237	3	0	121768	\N
25146	7238	3	0	121769	\N
25146	7240	4	1	121770	\N
25146	7239	4	0	121771	\N
25146	6730	5	0	121772	\N
25162	4172	4	0	121859	\N
25162	4219	5	0	121860	\N
25164	3628	3	0	120833	\N
25164	3785	4	0	120834	\N
25166	16	8	0	121869	\N
25166	4130	9	0	121870	\N
25173	4178	4	0	121907	\N
25173	4205	5	0	121908	\N
25176	12	4	0	121216	\N
25176	4043	5	0	121931	\N
25181	56	0	0	121300	\N
25192	4450	1	0	122024	\N
25192	4178	5	0	122025	\N
25192	4941	6	0	122026	\N
25194	7252	4	0	122035	\N
25194	7002	5	0	122036	\N
25198	488	3	0	122064	\N
25198	1103	4	0	122065	\N
25200	7254	126	0	122093	\N
25200	110	127	0	122094	\N
25205	4178	0	0	118073	\N
25208	391	3	0	122158	\N
25208	3660	4	0	122159	\N
25210	35	3	0	122160	\N
25210	3563	4	0	122161	\N
25212	279	3	0	122162	\N
25212	3641	4	0	122163	\N
25214	4178	3	0	122180	\N
25214	4211	4	0	122181	\N
25217	142	4	0	121135	\N
25217	3950	5	0	122210	\N
25226	411	5	0	122250	\N
25226	2874	6	0	122251	\N
25230	88	4	0	122254	\N
25230	3809	5	0	122259	\N
25239	79	8	0	121641	\N
25239	3701	9	0	122307	\N
25244	4178	7	0	122376	\N
25244	4396	8	0	122377	\N
25246	1572	7	0	122379	\N
25246	7262	8	0	122380	\N
25249	241	6	0	122401	\N
25249	6412	7	0	122402	\N
25253	453	10	0	122449	\N
25253	5309	11	0	122450	\N
25255	151	4	0	117834	\N
25255	3499	5	0	122460	\N
25257	4172	3	0	122475	\N
25257	4275	4	0	122476	\N
25264	18	2	0	122505	\N
25264	1685	3	0	122506	\N
25265	4787	17	0	122541	\N
25265	7265	18	0	122542	\N
25268	6450	7	0	122572	\N
25268	7235	8	0	122573	\N
25276	73	6	0	121107	\N
25276	4257	7	0	122658	\N
25278	595	6	0	116898	\N
25278	4698	7	0	122660	\N
25282	56	3	0	122680	\N
25282	4109	4	0	122681	\N
25285	119	6	0	101527	\N
25285	3644	7	0	122697	\N
25287	2	3	0	122713	\N
25287	3548	4	0	122714	\N
25289	391	2	0	122721	\N
25289	2966	3	0	122722	\N
25291	7270	105	0	122747	\N
25291	16	126	0	122760	\N
25291	155	127	0	122761	\N
25294	2	3	0	122785	\N
25197	2995	4	0	122063	\N
25202	56	7	0	122110	\N
25202	4791	8	0	122111	\N
25206	324	7	0	122136	\N
25206	5784	8	0	122137	\N
25213	186	4	0	122172	\N
25213	4733	5	0	122173	\N
25216	260	6	0	118574	\N
25216	7255	7	0	122201	\N
25223	181	3	0	122238	\N
25223	4184	4	0	122239	\N
25225	206	1	0	122242	\N
25225	207	2	0	122243	\N
25227	2351	5	0	122252	\N
25227	7256	6	0	122253	\N
25229	94	5	0	122256	\N
25229	7257	6	0	122257	\N
25231	2351	3	0	122252	\N
25231	2845	4	0	122260	\N
25238	1368	0	0	117901	\N
25238	7260	0	0	122290	\N
25240	40	8	0	122066	\N
25240	3718	9	0	122308	\N
25243	7261	105	0	122351	\N
25243	16	126	0	122362	\N
25243	155	127	0	122363	\N
25245	290	7	0	121411	\N
25245	6540	8	0	122378	\N
25247	121	7	0	122381	\N
25247	7263	8	0	122382	\N
25261	132	4	0	122495	\N
25261	3716	5	0	122496	\N
25263	241	4	0	122499	\N
25263	4582	5	0	122500	\N
25266	56	17	0	122543	\N
25266	5718	18	0	122544	\N
25270	595	7	0	116898	\N
25270	5821	8	0	121708	\N
25274	92	4	0	122643	\N
25274	3979	5	0	122644	\N
25281	58	4	0	122672	\N
25281	4213	5	0	122673	\N
25283	3625	6	0	122694	\N
25283	3642	7	0	122695	\N
25290	125	2	0	121987	\N
25290	2902	3	0	122723	\N
25295	164	4	0	122795	\N
25295	4152	5	0	122796	\N
25248	4275	4	0	121890	\N
25251	4172	3	0	122425	\N
25251	4275	4	0	122426	\N
25252	235	10	0	122447	\N
25252	7264	11	0	122448	\N
25254	2351	4	0	122252	\N
25254	3494	5	0	122459	\N
25256	4178	3	0	122467	\N
25256	4211	4	0	122468	\N
25259	242	4	0	122491	\N
25259	3512	5	0	122492	\N
25267	391	6	0	122158	\N
25267	3521	7	0	122557	\N
25272	18	3	0	122625	\N
25272	3621	4	0	122626	\N
25275	597	4	0	120455	\N
25275	6224	5	0	122653	\N
25277	6450	6	0	122572	\N
25277	7269	7	0	122659	\N
25279	18	6	0	122661	\N
25279	4180	7	0	122662	\N
25284	3628	6	0	120833	\N
25284	3643	7	0	122696	\N
25286	258	4	0	119675	\N
25286	4409	5	0	122706	\N
25293	391	3	0	122777	\N
25293	3660	4	0	122778	\N
25296	7271	18	0	122797	\N
25296	167	19	0	122798	\N
25298	167	3	0	111025	\N
25298	4028	4	0	122807	\N
25300	58	3	0	122672	\N
25300	3665	4	0	122815	\N
25250	4396	8	0	122418	\N
25258	360	3	0	116667	\N
25258	3602	4	0	116668	\N
25260	4172	4	0	122493	\N
25260	4219	5	0	122494	\N
25262	251	4	0	122497	\N
25262	5055	5	0	122498	\N
25269	151	7	0	117834	\N
25269	7266	8	0	122574	\N
25271	7267	13	0	122575	\N
25271	597	110	0	122617	\N
25271	7268	111	0	122618	\N
25273	94	3	0	122633	\N
25273	2864	4	0	122634	\N
25280	73	4	0	121107	\N
25280	2284	5	0	122671	\N
25288	40	3	0	122715	\N
25288	372	4	0	122716	\N
25292	235	4	0	122447	\N
25292	3615	5	0	122770	\N
25297	528	2	0	122803	\N
25297	2765	3	0	122804	\N
25299	528	3	0	122803	\N
25299	4262	4	0	122808	\N
25294	3548	4	0	122786	\N
25301	210	3	0	122822	\N
25301	3539	4	0	122823	\N
25302	2636	3	0	122824	\N
25302	2837	4	0	122825	\N
25303	365	4	0	116286	\N
25303	4049	5	0	116287	\N
25304	44	3	0	121535	\N
25304	3631	4	0	122840	\N
25305	1453	3	0	122847	\N
25305	7272	4	0	122848	\N
25306	4172	2	0	122493	\N
25306	4285	3	0	122853	\N
25308	7273	3	0	122860	\N
25308	1018	4	0	122861	\N
25308	7274	4	0	122862	\N
25309	595	0	0	116898	\N
25310	7275	3	0	122863	\N
25310	6450	6	0	122868	\N
25310	7276	7	0	122869	\N
25311	595	0	0	122870	\N
25312	7277	0	0	122871	\N
25312	7278	0	0	122872	\N
25313	264	5	0	122881	\N
25313	7279	6	1	122882	\N
25313	2435	6	0	122883	\N
25313	7281	7	1	122884	\N
25313	7280	7	0	122885	\N
25314	411	5	0	122250	\N
25314	2874	6	0	122251	\N
25315	140	5	0	122886	\N
25315	7282	6	0	122887	\N
25316	224	5	0	122888	\N
25316	7283	6	0	122889	\N
25317	30	5	0	122890	\N
25317	1106	6	0	122891	\N
25318	264	5	0	122881	\N
25318	7284	6	0	122892	\N
25319	4178	4	0	122901	\N
25319	4205	5	0	122902	\N
25320	4233	4	0	121515	\N
25320	4234	5	0	122903	\N
25321	4233	2	0	121515	\N
25321	5577	3	0	122905	\N
25322	4233	2	0	121515	\N
25322	5577	3	0	122905	\N
25323	4178	9	0	122924	\N
25323	4682	10	0	122925	\N
25324	360	10	0	122946	\N
25324	7285	11	0	122947	\N
25325	4178	10	0	122948	\N
25325	4665	11	0	122949	\N
25326	38	3	0	122956	\N
25326	3457	4	0	122957	\N
25327	258	4	0	122966	\N
25327	6042	5	0	122967	\N
25328	113	4	0	120445	\N
25328	7286	5	0	122968	\N
25329	75	4	0	122969	\N
25329	7287	5	0	122970	\N
25330	14	3	0	122977	\N
25330	4272	4	0	122978	\N
25331	56	3	0	122979	\N
25331	4109	4	0	122980	\N
25332	14	3	0	122977	\N
25332	4272	4	0	122978	\N
25333	4172	4	0	122989	\N
25333	7288	5	0	122990	\N
25334	4787	6	0	122541	\N
25334	7289	7	0	122995	\N
25335	4178	8	0	122948	\N
25335	5883	9	0	123001	\N
25336	4787	8	0	122541	\N
25336	7290	9	0	123002	\N
25337	2	3	0	123009	\N
25337	3548	4	0	123010	\N
25338	14	3	0	122977	\N
25338	4272	4	0	122978	\N
25339	121	3	0	122381	\N
25339	4471	4	0	123011	\N
25340	173	3	0	123012	\N
25340	3796	4	0	123013	\N
25341	121	2	0	122381	\N
25341	2498	3	0	123014	\N
25342	391	3	0	123015	\N
25342	3660	4	0	123016	\N
25343	14	5	0	122977	\N
25343	6351	6	0	123019	\N
25344	908	8	0	122229	\N
25344	7291	9	0	123036	\N
25345	4172	1	0	122989	\N
25345	5004	2	0	123039	\N
25346	391	3	0	123015	\N
25346	3660	4	0	123016	\N
25347	2578	6	0	117605	\N
25347	7292	7	0	123052	\N
25348	320	6	0	89721	\N
25348	7293	7	0	123053	\N
25349	210	4	0	122822	\N
25349	3536	5	0	123062	\N
25350	71	4	0	123063	\N
25350	3887	5	0	123064	\N
25351	189	1	0	117407	\N
25351	4224	2	0	123065	\N
25352	189	1	0	117407	\N
25352	7294	2	0	123067	\N
25353	189	4	0	117407	\N
25353	3992	5	0	123068	\N
25354	4178	7	0	122948	\N
25354	5089	8	0	123078	\N
25355	142	3	0	121135	\N
25355	4254	4	0	123085	\N
25356	142	2	0	121135	\N
25356	4418	3	0	121136	\N
25357	360	3	0	123087	\N
25357	3602	4	0	123088	\N
25358	18	3	0	122661	\N
25358	3621	4	0	123089	\N
25359	18	4	0	123098	\N
25359	7295	5	0	123099	\N
25360	4178	10	0	123120	\N
25360	4665	11	0	123121	\N
25361	3729	3	0	123128	\N
25361	132	5	0	123131	\N
25361	3116	6	0	122496	\N
25362	3729	3	0	123128	\N
25362	132	5	0	123131	\N
25363	4178	6	0	123146	\N
25363	4250	7	0	123147	\N
25364	64	6	0	123148	\N
25364	5183	7	0	123149	\N
25365	4172	2	0	123154	\N
25365	4285	3	0	123155	\N
25366	79	4	0	121641	\N
25366	3678	5	0	123161	\N
25367	4178	4	0	123162	\N
25367	4205	5	0	123163	\N
25368	140	4	0	123164	\N
25368	3821	5	0	123165	\N
25369	908	4	0	123174	\N
25369	7298	5	0	123175	\N
25370	56	3	0	123182	\N
25370	4109	4	0	123183	\N
25371	214	3	0	123184	\N
25371	3496	4	0	123185	\N
25372	4178	3	0	123162	\N
25372	4211	4	0	123192	\N
25373	451	3	0	123193	\N
25373	3934	4	0	123194	\N
25374	40	5	0	122715	\N
25374	7299	6	0	123205	\N
25375	16	13	0	123206	\N
25375	7300	14	1	123207	\N
25375	1970	14	0	123208	\N
25376	233	3	0	116467	\N
25376	3704	4	0	123215	\N
25390	453	3	0	123246	\N
25390	2838	4	0	123247	\N
25391	367	3	0	119836	\N
25391	3683	4	0	123248	\N
25393	4172	3	0	123154	\N
25393	4940	4	0	123256	\N
25400	40	8	0	123243	\N
25400	3718	9	0	123298	\N
25423	4172	2	0	123416	\N
25423	4191	3	0	123417	\N
25428	908	4	0	123443	\N
25428	7309	5	0	123447	\N
25430	7311	7	0	123450	\N
25430	7312	8	0	123451	\N
25432	189	3	0	123461	\N
25432	3782	4	0	123462	\N
25435	73	3	0	123480	\N
25435	3040	4	0	123481	\N
25439	208	3	0	116810	\N
25439	4490	4	0	121502	\N
25441	7225	3	0	123494	\N
25441	7226	4	0	123495	\N
25443	4178	3	0	123482	\N
25443	4211	4	0	123483	\N
25448	27	5	0	123367	\N
25448	4203	6	0	123516	\N
25450	115	3	0	123538	\N
25450	3483	4	0	123539	\N
25453	192	3	0	123550	\N
25453	3790	4	0	123551	\N
25461	14	4	0	122977	\N
25461	3498	5	0	123576	\N
25466	75	4	0	123607	\N
25466	3959	5	0	123608	\N
25475	412	1	0	123639	\N
25475	411	5	0	123640	\N
25475	7318	6	0	123641	\N
25479	2578	3	0	117605	\N
25479	4431	4	0	123662	\N
25481	77	3	0	121703	\N
25481	1877	4	0	123670	\N
25482	167	1	0	111025	\N
25482	1444	2	0	123671	\N
25486	94	3	0	123688	\N
25486	2864	4	0	123689	\N
25488	164	3	0	123696	\N
25488	3385	4	0	123697	\N
25493	4088	6	0	118494	\N
25493	4246	7	0	123720	\N
25495	6450	3	0	122572	\N
25495	6847	4	0	123729	\N
25498	108	3	0	123734	\N
25498	4171	4	0	123735	\N
25502	2782	3	0	123759	\N
25502	3659	4	0	123760	\N
25504	135	3	0	117021	\N
25504	3630	4	0	118414	\N
25509	18	3	0	123785	\N
25509	3621	4	0	123786	\N
25511	4178	3	0	123794	\N
25511	4211	4	0	123795	\N
25514	156	3	0	121457	\N
25514	4594	4	0	123376	\N
25515	262	3	0	123615	\N
25515	4778	4	0	123616	\N
25520	54	3	0	121727	\N
25520	3041	4	0	121728	\N
25524	4172	3	0	123774	\N
25524	4275	4	0	123775	\N
25526	365	3	0	123843	\N
25526	3839	4	0	123844	\N
25529	228	9	0	120984	\N
25529	7321	10	0	123865	\N
25531	170	3	0	121719	\N
25531	4148	4	0	121720	\N
25536	12	3	0	123899	\N
25536	4204	4	0	123900	\N
25541	230	5	0	120618	\N
25541	3389	6	0	123932	\N
25546	285	3	0	119510	\N
25546	4496	4	0	123962	\N
25549	86	1	0	123983	\N
25549	2967	2	0	123984	\N
25551	7323	49	0	124008	\N
25551	241	79	0	124025	\N
25551	7324	80	0	124026	\N
25554	60	6	0	124045	\N
25554	6394	7	0	124046	\N
25556	7326	94	0	124063	\N
25556	60	126	0	124083	\N
25556	7327	127	0	124084	\N
25563	135	3	0	117021	\N
25563	3630	4	0	118414	\N
25566	1141	9	0	124138	\N
25566	7329	10	0	124139	\N
25568	33	6	0	124154	\N
25568	7330	7	0	124155	\N
25573	7336	3	0	124188	\N
25573	2782	10	0	124189	\N
25573	7337	11	0	124190	\N
25575	306	3	0	124173	\N
25575	14	10	0	124186	\N
25575	7339	11	1	124194	\N
25575	7338	11	0	124195	\N
25576	18	15	0	124214	\N
25576	4566	16	0	124215	\N
25578	88	3	0	122254	\N
25578	3655	4	0	123776	\N
25580	33	0	0	124154	\N
25583	33	3	0	124232	\N
25583	3342	4	0	124233	\N
25592	960	4	0	8954	\N
25592	5566	5	0	82530	\N
25599	56	3	0	123845	\N
25599	4109	4	0	123846	\N
25605	597	6	0	123732	\N
25605	4697	7	0	124348	\N
25611	235	5	0	123225	\N
25611	6949	6	0	124380	\N
25616	4178	3	0	124397	\N
25616	4211	4	0	124398	\N
25618	40	3	0	124114	\N
25618	372	4	0	124115	\N
25623	14	6	0	123718	\N
25623	6277	7	0	123719	\N
25628	4787	6	0	124476	\N
25628	5075	7	0	124477	\N
25635	852	12	0	124549	\N
25635	7347	13	0	124550	\N
25637	1099	3	0	10970	\N
25637	7348	4	0	124557	\N
25644	285	6	0	124629	\N
25644	3903	7	0	124630	\N
25647	597	3	0	124652	\N
25647	3656	4	0	124653	\N
25649	6450	3	0	122572	\N
25649	6847	4	0	123729	\N
25651	242	3	0	122491	\N
25651	2839	4	0	124664	\N
25656	7351	2	0	124684	\N
25656	6450	7	0	124693	\N
25656	7352	8	0	122659	\N
25667	4178	3	0	124785	\N
25667	4211	4	0	124786	\N
25669	75	3	0	124576	\N
25669	3855	4	0	124577	\N
25677	5185	3	0	124816	\N
25677	7359	4	0	124818	\N
25681	2636	10	0	124399	\N
25681	5295	11	0	124845	\N
25685	4178	6	0	124785	\N
25685	4250	7	0	124868	\N
25687	156	6	0	124871	\N
25687	6498	7	0	124872	\N
25690	2	3	0	124885	\N
25690	3548	4	0	124886	\N
25377	142	2	0	121135	\N
25377	4418	3	0	121136	\N
25379	4088	3	0	118494	\N
25379	4506	4	0	123217	\N
25381	235	3	0	123225	\N
25381	3343	4	0	123226	\N
25383	35	3	0	122160	\N
25383	3563	4	0	122161	\N
25385	367	0	0	119836	\N
25386	268	3	0	111358	\N
25386	3815	4	0	121729	\N
25388	40	3	0	123243	\N
25388	372	4	0	123244	\N
25394	200	7	0	123267	\N
25394	5445	8	0	123268	\N
25396	251	7	0	122497	\N
25396	7302	8	0	123277	\N
25398	113	3	0	120445	\N
25398	3620	4	0	120446	\N
25403	262	7	0	120326	\N
25403	7304	8	0	123312	\N
25405	324	11	0	123313	\N
25405	7306	12	0	123315	\N
25408	27	3	0	123354	\N
25408	4636	4	0	123355	\N
25411	322	4	0	119398	\N
25411	5447	5	0	119474	\N
25415	156	1	0	121457	\N
25415	3012	2	0	123377	\N
25417	6130	3	0	123382	\N
25417	528	6	0	123383	\N
25417	3238	7	0	123387	\N
25419	1636	5	0	123398	\N
25419	7307	6	0	123399	\N
25421	1636	3	0	123398	\N
25421	5514	4	0	123402	\N
25426	908	10	0	123443	\N
25426	7013	11	0	123444	\N
25433	453	4	0	123471	\N
25433	4108	5	0	123472	\N
25436	4178	3	0	123482	\N
25436	4211	4	0	123483	\N
25437	4	0	0	123484	\N
25442	279	3	0	122162	\N
25442	3641	4	0	122163	\N
25446	40	5	0	123513	\N
25446	3999	6	0	123514	\N
25455	367	2	0	119836	\N
25455	3329	3	0	123555	\N
25457	4178	4	0	123482	\N
25457	4468	5	0	123563	\N
25459	132	0	0	123566	\N
25464	273	3	0	123597	\N
25464	3638	4	0	123598	\N
25469	58	3	0	123618	\N
25469	3665	4	0	123619	\N
25473	163	1	0	123630	\N
25473	33	5	0	123637	\N
25473	7317	6	0	123638	\N
25477	333	1	0	123645	\N
25477	241	5	0	123646	\N
25477	7320	6	1	123647	\N
25477	7319	6	0	123648	\N
25484	6303	3	0	120225	\N
25484	6304	4	0	120227	\N
25499	595	3	0	122870	\N
25499	3654	4	0	123736	\N
25500	908	3	0	123743	\N
25500	3591	4	0	123744	\N
25507	75	3	0	123777	\N
25507	3855	4	0	123778	\N
25521	40	3	0	123818	\N
25521	372	4	0	123819	\N
25522	38	1	0	123816	\N
25522	2906	2	0	123821	\N
25525	4178	3	0	123841	\N
25525	4211	4	0	123842	\N
25532	410	1	0	123875	\N
25532	273	4	0	123880	\N
25532	5658	5	0	123598	\N
25534	202	3	0	123889	\N
25534	4857	4	0	123890	\N
25537	181	6	0	122238	\N
25537	4256	7	0	123913	\N
25539	18	2	0	123919	\N
25539	1685	3	0	123920	\N
25542	132	1	0	123933	\N
25542	3116	2	0	123934	\N
25544	4172	6	0	123774	\N
25544	4197	7	0	123949	\N
25552	156	3	0	121457	\N
25552	4594	4	0	123376	\N
25569	3004	3	0	75639	\N
25569	5266	4	0	75640	\N
25572	306	3	0	124173	\N
25572	14	10	0	124186	\N
25572	7335	11	0	124187	\N
25581	260	3	0	124230	\N
25581	3399	4	0	124231	\N
25585	33	0	0	124154	\N
25588	6723	12	0	124262	\N
25588	7342	13	0	124263	\N
25590	4178	3	0	124272	\N
25590	4211	4	0	124273	\N
25593	4233	2	0	124291	\N
25593	5577	3	0	124292	\N
25595	242	0	0	122491	\N
25597	132	0	0	124303	\N
25602	210	6	0	122822	\N
25602	3721	7	0	124334	\N
25607	123	0	0	124355	\N
25614	214	3	0	124387	\N
25614	3496	4	0	124388	\N
25621	79	6	0	121641	\N
25621	4253	7	0	124429	\N
25624	4178	10	0	124397	\N
25624	5897	11	0	124458	\N
25626	170	10	0	124460	\N
25626	7344	11	0	124461	\N
25629	73	5	0	123480	\N
25629	4931	6	0	124488	\N
25632	156	6	0	124509	\N
25632	6498	7	0	124510	\N
25640	77	3	0	124572	\N
25640	1877	4	0	124573	\N
25642	75	3	0	124576	\N
25642	3855	4	0	124577	\N
25654	14	2	0	124667	\N
25654	1421	3	0	124671	\N
25657	767	2	0	124694	\N
25657	597	7	0	124695	\N
25657	7353	8	0	124696	\N
25659	94	7	0	124716	\N
25659	5005	8	0	124717	\N
25660	2578	12	0	124742	\N
25660	7356	13	0	124743	\N
25663	27	2	0	124766	\N
25663	645	3	0	124767	\N
25665	290	2	0	124773	\N
25665	1909	3	0	124774	\N
25672	242	2	0	124804	\N
25672	3425	3	0	124805	\N
25674	233	3	0	123721	\N
25674	3704	4	0	124813	\N
25678	5185	4	0	124816	\N
25678	7360	5	0	124820	\N
25679	2	6	0	124833	\N
25679	4550	7	0	124834	\N
25682	23	10	0	124835	\N
25682	7362	11	0	124846	\N
25683	391	10	0	124847	\N
25683	6306	11	0	124848	\N
25688	79	2	0	124877	\N
25688	616	3	0	124878	\N
25696	167	1	0	111025	\N
25696	1444	2	0	123671	\N
25698	533	1	0	124936	\N
25378	142	3	0	121135	\N
25378	4254	4	0	123085	\N
25382	56	3	0	123182	\N
25382	4109	4	0	123183	\N
25384	40	4	0	123235	\N
25384	3381	5	0	123236	\N
25389	5885	3	0	121991	\N
25389	5926	4	0	123245	\N
25395	113	7	0	120445	\N
25395	5779	8	0	123276	\N
25402	69	7	0	117777	\N
25402	7303	8	0	123311	\N
25404	324	7	0	123313	\N
25404	7305	8	0	123314	\N
25407	4178	3	0	123346	\N
25407	4211	4	0	123347	\N
25410	173	4	0	123012	\N
25410	3614	5	0	123366	\N
25414	156	3	0	121457	\N
25414	4594	4	0	123376	\N
25416	6130	3	0	123382	\N
25416	528	4	0	123383	\N
25418	198	5	0	123396	\N
25418	5843	6	0	123397	\N
25420	18	5	0	123400	\N
25420	4010	6	0	123401	\N
25425	75	3	0	123427	\N
25425	3855	4	0	123428	\N
25434	4172	3	0	123416	\N
25434	4275	4	0	123479	\N
25445	115	3	0	116989	\N
25445	3483	4	0	123503	\N
25449	4172	7	0	123530	\N
25449	4614	8	0	123531	\N
25452	4178	3	0	123482	\N
25452	4211	4	0	123483	\N
25456	367	3	0	119836	\N
25456	3683	4	0	123248	\N
25460	132	0	0	123566	\N
25463	6678	6	0	123589	\N
25463	7316	7	0	123590	\N
25465	62	3	0	121513	\N
25465	3344	4	0	121514	\N
25468	40	3	0	123513	\N
25468	372	4	0	123617	\N
25470	170	3	0	121719	\N
25470	4148	4	0	121720	\N
25472	908	3	0	123443	\N
25472	3591	4	0	123627	\N
25474	163	1	0	123630	\N
25474	33	5	0	123637	\N
25474	7317	6	0	123638	\N
25476	19	1	0	123642	\N
25476	18	5	0	123643	\N
25476	5946	6	0	123644	\N
25483	167	3	0	123672	\N
25483	4028	4	0	123673	\N
25490	391	3	0	123015	\N
25490	3660	4	0	123016	\N
25497	597	3	0	123732	\N
25497	3656	4	0	123733	\N
25501	86	3	0	123751	\N
25501	3746	4	0	123752	\N
25506	88	3	0	122254	\N
25506	3655	4	0	123776	\N
25508	181	3	0	122238	\N
25508	4184	4	0	122239	\N
25510	3625	3	0	122694	\N
25510	3784	4	0	123793	\N
25513	3628	3	0	120833	\N
25513	3785	4	0	120834	\N
25517	20	3	0	123806	\N
25517	2844	4	0	123807	\N
25519	38	3	0	123816	\N
25519	3457	4	0	123817	\N
25538	4172	2	0	123774	\N
25538	4191	3	0	123918	\N
25540	7322	3	0	123921	\N
25543	132	1	0	123935	\N
25543	3116	2	0	123936	\N
25548	110	8	0	123979	\N
25548	6048	9	0	123980	\N
25558	367	6	0	119836	\N
25558	6013	7	0	124105	\N
25561	40	3	0	124114	\N
25561	372	4	0	124115	\N
25565	69	9	0	117777	\N
25565	7328	10	0	124137	\N
25571	877	3	0	124168	\N
25571	7333	4	0	124171	\N
25571	7334	4	0	124172	\N
25582	33	0	0	124154	\N
25584	33	0	0	124154	\N
25587	123	12	0	111411	\N
25587	7341	13	0	124261	\N
25589	4172	3	0	124270	\N
25589	4275	4	0	124271	\N
25594	4233	3	0	124291	\N
25594	4425	4	0	124296	\N
25596	16	2	0	124301	\N
25596	388	3	0	124302	\N
25598	132	0	0	124304	\N
25601	20	6	0	123806	\N
25601	5933	7	0	124321	\N
25604	595	6	0	122870	\N
25604	4698	7	0	124347	\N
25606	2	3	0	123009	\N
25606	3548	4	0	123010	\N
25609	6723	6	0	124369	\N
25609	7343	7	0	124370	\N
25615	33	3	0	124395	\N
25615	3342	4	0	124396	\N
25620	79	0	0	121641	\N
25625	16	10	0	124301	\N
25625	5898	11	0	124459	\N
25627	320	10	0	124462	\N
25627	7345	11	0	124463	\N
25631	73	6	0	124507	\N
25631	4257	7	0	124508	\N
25639	4178	3	0	124397	\N
25639	4211	4	0	124398	\N
25641	241	3	0	124574	\N
25641	3613	4	0	124575	\N
25643	7349	96	0	124596	\N
25643	241	123	0	124614	\N
25643	1075	124	1	124615	\N
25643	7350	124	0	124616	\N
25646	4172	6	0	124270	\N
25646	4197	7	0	124645	\N
25653	14	1	0	124667	\N
25653	1926	2	0	124668	\N
25655	4178	3	0	124678	\N
25655	4211	4	0	124679	\N
25658	768	2	0	124697	\N
25658	595	7	0	124698	\N
25658	2171	9	0	124701	\N
25662	336	3	0	124764	\N
25662	3400	4	0	124765	\N
25664	27	3	0	124766	\N
25664	4636	4	0	124768	\N
25666	290	3	0	124773	\N
25666	3635	4	0	124778	\N
25671	181	3	0	124802	\N
25671	4184	4	0	124803	\N
25673	242	3	0	124804	\N
25673	2839	4	0	124806	\N
25676	5185	2	0	124816	\N
25676	7358	3	0	124817	\N
25684	2	3	0	124833	\N
25684	3548	4	0	124855	\N
25689	402	3	0	119934	\N
25689	4077	4	0	119935	\N
25697	533	1	0	124936	\N
25697	167	4	0	124941	\N
25380	258	3	0	122966	\N
25380	4401	4	0	123218	\N
25387	79	3	0	121641	\N
25387	3652	4	0	121642	\N
25392	378	3	0	25454	\N
25392	7301	4	0	123249	\N
25399	110	6	0	123290	\N
25399	3917	7	0	123291	\N
25401	110	8	0	123290	\N
25401	3710	9	0	123299	\N
25406	4178	11	0	123338	\N
25406	5625	12	0	123339	\N
25409	140	4	0	123364	\N
25409	3821	5	0	123365	\N
25412	27	4	0	123367	\N
25412	3717	5	0	123368	\N
25413	108	1	0	120419	\N
25413	3022	2	0	123371	\N
25422	2111	4	0	114643	\N
25422	7308	5	0	123411	\N
25424	40	3	0	123243	\N
25424	372	4	0	123244	\N
25427	908	1	0	123443	\N
25427	3149	2	0	123446	\N
25429	82	7	0	123448	\N
25429	7310	8	0	123449	\N
25431	435	7	0	116240	\N
25431	7313	8	0	123454	\N
25438	4	3	0	123484	\N
25438	3837	4	0	123491	\N
25440	18	3	0	123492	\N
25440	3621	4	0	123493	\N
25444	115	2	0	116989	\N
25444	2797	3	0	123502	\N
25447	4233	5	0	121515	\N
25447	7314	6	0	123515	\N
25451	115	4	0	123538	\N
25451	4844	5	0	123543	\N
25454	2351	3	0	123552	\N
25454	2845	4	0	123553	\N
25458	132	4	0	123566	\N
25458	7315	5	0	123567	\N
25462	27	4	0	123367	\N
25462	3717	5	0	123368	\N
25467	262	3	0	123615	\N
25467	4778	4	0	123616	\N
25471	170	2	0	121719	\N
25471	2986	3	0	123620	\N
25478	290	3	0	121411	\N
25478	3635	4	0	123655	\N
25480	64	3	0	123148	\N
25480	4217	4	0	123663	\N
25485	4178	3	0	123686	\N
25485	4211	4	0	123687	\N
25487	4178	3	0	123686	\N
25487	4211	4	0	123687	\N
25489	164	1	0	123696	\N
25489	3092	2	0	123699	\N
25492	14	6	0	123718	\N
25492	6277	7	0	123719	\N
25494	233	6	0	123721	\N
25494	4245	7	0	123722	\N
25496	186	3	0	123730	\N
25496	4294	4	0	123731	\N
25503	137	3	0	120975	\N
25503	3633	4	0	123767	\N
25505	4172	3	0	123774	\N
25505	4275	4	0	123775	\N
25512	119	3	0	123796	\N
25512	2860	4	0	123797	\N
25516	424	3	0	123804	\N
25516	3611	4	0	123805	\N
25518	18	3	0	123808	\N
25518	3621	4	0	123809	\N
25523	202	7	0	123833	\N
25523	4543	8	0	123834	\N
25527	56	3	0	123845	\N
25527	4109	4	0	123846	\N
25530	27	9	0	123367	\N
25530	5696	10	0	123866	\N
25533	41	1	0	123881	\N
25533	40	4	0	123882	\N
25533	3034	5	0	123819	\N
25535	4178	3	0	123897	\N
25535	4211	4	0	123898	\N
25545	40	3	0	123818	\N
25545	372	4	0	123819	\N
25550	241	3	0	123991	\N
25550	3613	4	0	123992	\N
25555	488	6	0	122064	\N
25555	7325	7	0	124047	\N
25557	115	3	0	124091	\N
25557	3483	4	0	124092	\N
25560	459	3	0	124112	\N
25560	3178	4	0	124113	\N
25562	18	3	0	123919	\N
25562	3621	4	0	124116	\N
25564	137	3	0	124117	\N
25564	3633	4	0	124118	\N
25567	316	9	0	124140	\N
25567	4279	10	0	124141	\N
25570	877	3	0	124168	\N
25570	7331	4	0	124169	\N
25570	7332	4	0	124170	\N
25574	127	3	0	124191	\N
25574	18	10	0	124192	\N
25574	4404	11	0	124193	\N
25577	4178	3	0	123897	\N
25577	4211	4	0	123898	\N
25579	18	3	0	124222	\N
25579	3621	4	0	124223	\N
25586	123	3	0	111411	\N
25586	7340	4	0	124236	\N
25591	16	2	0	121273	\N
25591	388	3	0	124278	\N
25600	4787	6	0	124319	\N
25600	5075	7	0	124320	\N
25603	6450	6	0	122572	\N
25603	7269	7	0	122659	\N
25608	123	4	0	111411	\N
25608	4507	5	0	124364	\N
25610	4172	5	0	124270	\N
25610	4634	6	0	124379	\N
25612	4172	3	0	124270	\N
25612	4275	4	0	124271	\N
25613	262	3	0	123615	\N
25613	4778	4	0	123616	\N
25617	2636	3	0	124399	\N
25617	2837	4	0	124400	\N
25619	33	7	0	124415	\N
25619	5284	8	0	124416	\N
25622	14	2	0	123718	\N
25622	1421	3	0	124434	\N
25630	40	3	0	124114	\N
25630	372	4	0	124115	\N
25633	88	6	0	122254	\N
25633	5263	7	0	124523	\N
25634	741	12	0	94060	\N
25634	7346	13	0	124548	\N
25636	6044	3	0	115896	\N
25636	6045	4	0	116253	\N
25638	75	3	0	124558	\N
25638	3855	4	0	124559	\N
25645	44	6	0	124631	\N
25645	5989	7	0	124632	\N
25648	595	3	0	122870	\N
25648	3654	4	0	123736	\N
25650	18	4	0	124222	\N
25650	2302	5	0	124662	\N
25652	242	4	0	122491	\N
25652	3512	5	0	122492	\N
25661	86	6	0	124756	\N
25661	7357	7	0	124757	\N
25668	71	3	0	123063	\N
25668	3770	4	0	124787	\N
25670	56	3	0	124794	\N
25670	4109	4	0	124795	\N
25675	4088	3	0	124814	\N
25675	4506	4	0	124815	\N
25680	23	6	0	124835	\N
25680	7361	7	0	124836	\N
25686	16	6	0	124869	\N
25686	3369	7	0	124870	\N
25691	230	6	0	124899	\N
25691	4182	7	0	124900	\N
25692	224	10	0	122888	\N
25692	7363	11	0	124921	\N
25694	244	3	0	124930	\N
25694	4075	4	0	124931	\N
25705	7225	3	0	124972	\N
25705	7226	4	0	124973	\N
25710	135	7	0	117021	\N
25710	4721	8	0	124990	\N
25717	75	3	0	125027	\N
25717	3855	4	0	125028	\N
25719	42	3	0	121189	\N
25719	3645	4	0	125037	\N
25722	3208	6	0	125066	\N
25722	7368	7	0	125067	\N
25735	151	6	0	125154	\N
25735	3588	7	0	125155	\N
25740	117	5	0	125171	\N
25740	7370	6	0	125172	\N
25744	234	1	0	125183	\N
25744	233	4	0	125187	\N
25744	2987	5	0	124813	\N
25746	132	4	0	125190	\N
25746	7371	5	0	125191	\N
25753	108	3	0	125004	\N
25753	4171	4	0	125224	\N
25755	242	3	0	125231	\N
25755	2839	4	0	125232	\N
25759	189	3	0	125243	\N
25759	3782	4	0	125244	\N
25762	595	3	0	125251	\N
25762	3654	4	0	125252	\N
25766	12	3	0	125269	\N
25766	4204	4	0	125270	\N
25768	132	1	0	125273	\N
25768	3116	2	0	125274	\N
25770	367	3	0	125014	\N
25770	3683	4	0	125283	\N
25775	4178	6	0	124785	\N
25775	4250	7	0	124868	\N
25777	212	5	0	121262	\N
25777	7378	6	0	125316	\N
25787	40	3	0	125370	\N
25787	372	4	0	125371	\N
25792	69	4	0	125386	\N
25792	4041	5	0	125387	\N
25800	391	2	0	125444	\N
25800	1381	3	0	125445	\N
25801	71	3	0	123063	\N
25801	3770	4	0	124787	\N
25808	202	4	0	125486	\N
25808	3673	5	0	125487	\N
25811	86	3	0	125498	\N
25811	3746	4	0	125499	\N
25816	241	6	0	125530	\N
25816	6412	7	0	125531	\N
25818	35	12	0	122160	\N
25818	7382	13	0	125547	\N
25820	75	2	0	125156	\N
25820	284	3	0	125553	\N
25833	4178	4	0	125645	\N
25833	4205	5	0	125646	\N
25835	30	8	0	125648	\N
25835	7385	9	0	125649	\N
25839	40	3	0	125660	\N
25839	372	4	0	125661	\N
25842	135	4	0	117021	\N
25842	3696	5	0	125672	\N
25844	908	4	0	125680	\N
25844	3488	5	0	125681	\N
25852	210	3	0	125747	\N
25852	3539	4	0	125748	\N
25854	595	3	0	125438	\N
25854	3654	4	0	125755	\N
25857	40	3	0	125660	\N
25857	372	4	0	125661	\N
25863	251	8	0	122497	\N
25863	7386	9	0	125780	\N
25868	16	3	0	125687	\N
25868	3634	4	0	125848	\N
25872	88	1	0	125852	\N
25872	2896	2	0	125854	\N
25876	4178	6	0	125645	\N
25876	4250	7	0	125870	\N
25879	151	6	0	125154	\N
25879	7389	7	0	125886	\N
25884	4178	2	0	125645	\N
25884	4247	3	0	125904	\N
25886	391	2	0	125850	\N
25886	1381	3	0	125910	\N
25891	42	2	0	121189	\N
25891	3310	3	0	125930	\N
25893	82	2	0	125936	\N
25893	3401	3	0	125937	\N
25895	844	11	0	125965	\N
25895	7390	11	0	125966	\N
25895	7392	12	1	125967	\N
25895	7391	12	0	125968	\N
25897	235	2	0	125975	\N
25897	2757	3	0	125976	\N
25900	181	3	0	125987	\N
25900	7394	4	0	125988	\N
25904	4172	2	0	125776	\N
25904	4191	3	0	125999	\N
25907	4178	7	0	125985	\N
25907	4509	8	0	126018	\N
25909	4178	2	0	126025	\N
25909	4247	3	0	126026	\N
25911	18	2	0	126029	\N
25911	1685	3	0	126030	\N
25918	4178	2	0	126025	\N
25918	4247	3	0	126026	\N
25920	3625	2	0	122694	\N
25920	4359	3	0	126060	\N
25922	119	2	0	123796	\N
25922	1879	3	0	126062	\N
25925	4178	6	0	126081	\N
25925	4358	7	0	126082	\N
25928	260	4	0	124230	\N
25928	7396	5	0	126096	\N
25930	18	2	0	126102	\N
25930	1685	3	0	126103	\N
25933	67	4	0	126125	\N
25933	5001	5	0	126126	\N
25941	7397	7	0	126168	\N
25941	841	10	0	126181	\N
25941	7190	11	0	126182	\N
25945	365	5	0	123843	\N
25945	7402	6	0	126196	\N
25951	360	4	0	123087	\N
25951	4330	5	0	126208	\N
25953	4233	2	0	126215	\N
25953	5577	3	0	126216	\N
25958	56	4	0	126238	\N
25958	3556	5	0	126239	\N
25960	167	2	0	126245	\N
25960	3322	3	0	126246	\N
25963	4172	5	0	126236	\N
25963	4415	6	0	126259	\N
25967	300	4	0	126272	\N
25967	6350	5	0	126273	\N
25974	94	2	0	126298	\N
25974	2794	3	0	126299	\N
25977	2	2	0	126308	\N
25977	2789	3	0	126309	\N
25979	18	2	0	126262	\N
25979	1685	3	0	126324	\N
25982	4178	2	0	126340	\N
25982	4247	3	0	126341	\N
25984	288	2	0	126342	\N
25693	6303	3	0	124928	\N
25693	6304	4	0	124929	\N
25695	7364	3	0	124932	\N
25695	3934	4	0	124933	\N
25702	16	4	0	124960	\N
25702	3546	5	0	124961	\N
25704	391	4	0	124964	\N
25704	3913	5	0	124965	\N
25707	181	3	0	124802	\N
25707	4184	4	0	124803	\N
25709	4172	7	0	124988	\N
25709	4614	8	0	124989	\N
25711	137	7	0	124117	\N
25711	4722	8	0	124991	\N
25716	44	3	0	125025	\N
25716	3631	4	0	125026	\N
25718	300	3	0	125035	\N
25718	3747	4	0	125036	\N
25723	75	6	0	125027	\N
25723	4694	7	0	125068	\N
25726	189	6	0	125095	\N
25726	3713	7	0	125096	\N
25729	2647	9	0	125123	\N
25729	7369	10	0	125124	\N
25734	33	6	0	125152	\N
25734	7330	7	0	125153	\N
25736	75	6	0	125156	\N
25736	4694	7	0	125157	\N
25745	7374	1	0	125188	\N
25745	4088	4	0	125189	\N
25745	7375	5	0	124815	\N
25747	4172	5	0	125198	\N
25747	4415	6	0	125199	\N
25749	125	2	0	121987	\N
25749	3297	3	0	125206	\N
25756	23	3	0	124835	\N
25756	3497	4	0	125239	\N
25758	164	3	0	123696	\N
25758	3385	4	0	123697	\N
25760	189	3	0	125243	\N
25760	3782	4	0	125244	\N
25765	132	1	0	125261	\N
25765	3116	2	0	125262	\N
25767	528	3	0	125271	\N
25767	4262	4	0	125272	\N
25769	852	3	0	125275	\N
25769	3612	4	0	125276	\N
25771	367	9	0	125014	\N
25771	3571	10	0	125015	\N
25776	125	6	0	125314	\N
25776	6951	7	0	125315	\N
25781	79	6	0	125346	\N
25781	4253	7	0	125347	\N
25784	7225	6	0	124972	\N
25784	7379	7	0	125362	\N
25786	192	3	0	123550	\N
25786	3790	4	0	123551	\N
25788	402	3	0	125378	\N
25788	4077	4	0	125379	\N
25796	595	2	0	125438	\N
25796	3285	3	0	125439	\N
25819	930	12	0	8609	\N
25819	7383	13	0	125548	\N
25827	181	3	0	125606	\N
25827	4184	4	0	125607	\N
25832	115	4	0	125643	\N
25832	4844	5	0	125644	\N
25834	2	4	0	125476	\N
25834	3510	5	0	125647	\N
25836	16	3	0	124960	\N
25836	3634	4	0	125656	\N
25845	4172	2	0	125622	\N
25845	4191	3	0	125686	\N
25848	35	2	0	122160	\N
25848	1191	3	0	125691	\N
25850	391	10	0	125725	\N
25850	6306	11	0	125726	\N
25853	40	3	0	125660	\N
25853	372	4	0	125661	\N
25856	6450	3	0	122572	\N
25856	6847	4	0	123729	\N
25860	4172	8	0	125776	\N
25860	4500	9	0	125777	\N
25862	40	8	0	125660	\N
25862	3503	9	0	125779	\N
25864	2	3	0	125787	\N
25864	3548	4	0	125788	\N
25867	73	3	0	125846	\N
25867	3040	4	0	125847	\N
25869	4178	3	0	125645	\N
25869	4211	4	0	125849	\N
25874	6450	6	0	125868	\N
25874	7269	7	0	125869	\N
25877	73	6	0	125871	\N
25877	4257	7	0	125872	\N
25878	4178	6	0	125645	\N
25878	4358	7	0	125885	\N
25883	258	2	0	122966	\N
25883	3275	3	0	125899	\N
25885	40	2	0	125660	\N
25885	282	3	0	125905	\N
25890	4178	2	0	125921	\N
25890	4247	3	0	125929	\N
25892	14	2	0	125383	\N
25892	1785	3	0	125935	\N
25896	391	11	0	125969	\N
25896	5330	12	0	125970	\N
25899	4178	3	0	125985	\N
25899	4441	4	0	125986	\N
25905	258	2	0	126000	\N
25905	3275	3	0	126001	\N
25910	110	2	0	126027	\N
25910	626	3	0	126028	\N
25912	102	2	0	122240	\N
25912	3053	3	0	126035	\N
25914	102	1	0	122240	\N
25914	103	2	0	126038	\N
25917	336	2	0	126054	\N
25917	3332	3	0	126055	\N
25919	40	2	0	125660	\N
25919	282	3	0	125905	\N
25921	3628	2	0	120833	\N
25921	4360	3	0	126061	\N
25923	40	2	0	125660	\N
25923	282	3	0	125905	\N
25929	20	2	0	123806	\N
25929	369	3	0	126101	\N
25932	1470	4	0	126123	\N
25932	2798	5	0	126124	\N
25939	7399	7	0	126171	\N
25939	1225	10	0	126176	\N
25939	6692	11	0	126177	\N
25943	75	1	0	126186	\N
25943	76	2	0	126187	\N
25946	765	5	0	126197	\N
25946	7403	6	0	126198	\N
25952	73	4	0	126209	\N
25952	2827	5	0	126210	\N
25954	16	3	0	125687	\N
25954	1045	4	0	126220	\N
25957	4172	4	0	126236	\N
25957	4252	5	0	126237	\N
25959	206	4	0	125460	\N
25959	3348	5	0	126240	\N
25961	251	2	0	122497	\N
25961	1851	3	0	126247	\N
25969	228	4	0	120984	\N
25969	4800	5	0	126275	\N
25973	100	2	0	126260	\N
25973	633	3	0	126293	\N
25975	16	1	0	126300	\N
25975	1087	2	0	126301	\N
25978	391	4	0	126318	\N
25978	3352	5	0	126319	\N
25983	6044	2	0	115896	\N
25983	6188	3	0	117189	\N
25986	69	2	0	125386	\N
25697	7365	5	1	124942	\N
25697	923	5	0	124943	\N
25699	453	3	0	124950	\N
25699	2838	4	0	124951	\N
25701	453	2	0	124950	\N
25701	3366	3	0	124953	\N
25706	208	3	0	116810	\N
25706	4490	4	0	121502	\N
25708	279	3	0	122162	\N
25708	3641	4	0	122163	\N
25713	367	9	0	125014	\N
25713	3571	10	0	125015	\N
25715	1858	9	0	125017	\N
25715	7367	10	0	125018	\N
25720	235	3	0	125044	\N
25720	3343	4	0	125045	\N
25725	18	3	0	124222	\N
25725	3621	4	0	124223	\N
25728	75	3	0	125103	\N
25728	3855	4	0	125104	\N
25731	135	3	0	117021	\N
25731	3630	4	0	118414	\N
25733	44	3	0	125138	\N
25733	3631	4	0	125139	\N
25738	290	5	0	125167	\N
25738	6115	6	0	125168	\N
25742	132	4	0	125174	\N
25742	7371	5	0	125175	\N
25751	73	4	0	124507	\N
25751	2284	5	0	125215	\N
25763	597	3	0	125253	\N
25763	3656	4	0	125254	\N
25764	2	3	0	124885	\N
25764	3548	4	0	124886	\N
25773	7376	3	0	125292	\N
25773	7377	4	0	125293	\N
25778	6765	3	0	125323	\N
25778	6884	4	0	125324	\N
25780	4178	3	0	125332	\N
25780	4211	4	0	125333	\N
25783	208	6	0	116810	\N
25783	5118	7	0	125361	\N
25790	14	4	0	125383	\N
25790	3498	5	0	125384	\N
25795	7381	14	0	125431	\N
25795	214	18	0	125432	\N
25795	4991	19	0	125433	\N
25798	597	2	0	125253	\N
25798	3286	3	0	125441	\N
25802	14	3	0	125383	\N
25802	4272	4	0	125458	\N
25804	391	3	0	125444	\N
25804	3660	4	0	125459	\N
25806	908	6	0	125474	\N
25806	3555	7	0	125475	\N
25807	2	6	0	125476	\N
25807	4825	7	0	125477	\N
25809	44	4	0	125488	\N
25809	3486	5	0	125489	\N
25813	94	3	0	125506	\N
25813	2864	4	0	125507	\N
25821	4787	7	0	125568	\N
25821	7384	8	0	125569	\N
25824	242	9	0	125591	\N
25824	6434	10	0	125592	\N
25826	449	3	0	120380	\N
25826	4760	4	0	120381	\N
25829	4178	7	0	125589	\N
25829	4396	8	0	125624	\N
25831	214	3	0	125633	\N
25831	3496	4	0	125634	\N
25838	132	3	0	123566	\N
25838	3729	4	0	125659	\N
25840	2	4	0	125476	\N
25840	3510	5	0	125647	\N
25847	27	2	0	125689	\N
25847	645	3	0	125690	\N
25849	262	6	0	125704	\N
25849	4248	7	0	125705	\N
25855	597	3	0	125253	\N
25855	3656	4	0	125254	\N
25859	23	1	0	124835	\N
25859	1089	2	0	125763	\N
25866	170	6	0	124460	\N
25866	7388	7	0	125839	\N
25871	88	3	0	125852	\N
25871	3655	4	0	125853	\N
25873	595	6	0	125438	\N
25873	4698	7	0	125867	\N
25880	2782	2	0	125891	\N
25880	2784	3	0	125892	\N
25882	200	2	0	123267	\N
25882	276	3	0	125898	\N
25887	488	4	0	125919	\N
25887	5021	5	0	125920	\N
25889	56	4	0	125923	\N
25889	3556	5	0	125924	\N
25894	4247	2	0	125942	\N
25894	4178	3	0	125929	\N
25898	2782	3	0	125983	\N
25898	7393	4	0	125984	\N
25902	156	2	0	124871	\N
25902	4485	3	0	125994	\N
25908	2349	7	0	126019	\N
25908	7395	8	0	126020	\N
25916	186	4	0	123730	\N
25916	6866	5	0	126049	\N
25926	173	2	0	123012	\N
25926	2102	3	0	126087	\N
25931	40	5	0	126113	\N
25931	5806	6	0	126114	\N
25934	290	2	0	125167	\N
25934	1909	3	0	126131	\N
25937	40	1	0	126152	\N
25937	41	2	0	126153	\N
25938	7397	7	0	126168	\N
25938	7372	8	0	126169	\N
25938	7398	8	0	126170	\N
25942	7399	7	0	126171	\N
25942	1225	10	0	126176	\N
25942	7401	11	0	126183	\N
25948	765	4	0	126197	\N
25948	7404	5	0	126199	\N
25949	365	0	0	123843	\N
25956	67	3	0	126125	\N
25956	7405	4	0	126227	\N
25964	100	5	0	126260	\N
25964	7057	6	0	126261	\N
25968	4178	4	0	126225	\N
25968	4205	5	0	126274	\N
25970	4172	2	0	126236	\N
25970	4191	3	0	126280	\N
25972	483	2	0	126287	\N
25972	7322	3	0	126288	\N
25980	121	2	0	126329	\N
25980	2498	3	0	126330	\N
25985	186	6	0	126356	\N
25985	7407	7	0	126357	\N
25990	75	2	0	126376	\N
25990	284	3	0	126377	\N
25995	488	4	0	125919	\N
25995	5021	5	0	125920	\N
26004	137	1	0	125670	\N
26004	138	2	0	126427	\N
26012	69	4	0	126488	\N
26012	4041	5	0	126489	\N
26014	7408	85	0	126570	\N
26014	459	126	0	126610	\N
26014	7409	127	0	126611	\N
26021	151	2	0	126634	\N
26021	2854	3	0	126635	\N
26023	40	2	0	126640	\N
26023	282	3	0	126641	\N
26028	1470	2	0	126660	\N
26028	3368	3	0	126661	\N
26030	4172	2	0	126664	\N
26030	4191	3	0	126665	\N
25698	167	4	0	124941	\N
25698	2260	5	0	123673	\N
25700	453	3	0	124950	\N
25700	2838	4	0	124951	\N
25703	30	2	0	122890	\N
25703	2980	3	0	124963	\N
25712	108	6	0	125004	\N
25712	6978	7	0	125005	\N
25714	424	9	0	123804	\N
25714	7366	10	0	125016	\N
25721	391	3	0	125052	\N
25721	3660	4	0	125053	\N
25724	4172	3	0	125075	\N
25724	4275	4	0	125076	\N
25727	4178	3	0	124785	\N
25727	4211	4	0	124786	\N
25730	200	3	0	123267	\N
25730	3338	4	0	125131	\N
25732	137	3	0	124117	\N
25732	3633	4	0	124118	\N
25737	4	5	0	123484	\N
25737	4387	6	0	125166	\N
25739	56	3	0	125169	\N
25739	4102	4	0	125170	\N
25741	75	5	0	125156	\N
25741	4034	6	0	125173	\N
25743	1088	1	0	125178	\N
25743	7372	2	0	125179	\N
25743	7373	2	0	125180	\N
25748	424	5	0	125200	\N
25748	5002	6	0	125201	\N
25750	4172	4	0	125198	\N
25750	4219	5	0	125214	\N
25752	79	3	0	125222	\N
25752	3652	4	0	125223	\N
25754	42	3	0	121189	\N
25754	3645	4	0	125037	\N
25757	164	6	0	123696	\N
25757	3583	7	0	125242	\N
25761	6450	3	0	122572	\N
25761	6847	4	0	123729	\N
25772	20	3	0	123806	\N
25772	2844	4	0	123807	\N
25774	94	3	0	125300	\N
25774	2864	4	0	125301	\N
25779	212	3	0	121262	\N
25779	3639	4	0	125325	\N
25782	411	6	0	122250	\N
25782	5252	7	0	125360	\N
25785	279	6	0	122162	\N
25785	5117	7	0	125363	\N
25789	402	4	0	125378	\N
25789	4731	5	0	125382	\N
25791	402	2	0	125378	\N
25791	3244	3	0	125385	\N
25793	4172	4	0	125198	\N
25793	4219	5	0	125214	\N
25794	7380	14	0	125423	\N
25794	411	18	0	125429	\N
25794	7318	19	0	125430	\N
25797	6450	2	0	122572	\N
25797	6825	3	0	125440	\N
25799	4178	2	0	125442	\N
25799	4247	3	0	125443	\N
25803	2636	3	0	124399	\N
25803	2837	4	0	124400	\N
25805	206	3	0	125460	\N
25805	4584	4	0	125461	\N
25810	4172	3	0	125496	\N
25810	4275	4	0	125497	\N
25812	200	3	0	123267	\N
25812	3338	4	0	125131	\N
25814	908	3	0	125514	\N
25814	3591	4	0	125515	\N
25815	79	6	0	125528	\N
25815	4253	7	0	125529	\N
25817	94	0	0	125532	\N
25822	164	7	0	123696	\N
25822	5711	8	0	125570	\N
25823	4178	9	0	125589	\N
25823	4682	10	0	125590	\N
25825	2	3	0	125476	\N
25825	3548	4	0	125599	\N
25828	4172	7	0	125622	\N
25828	4614	8	0	125623	\N
25830	40	3	0	125631	\N
25830	372	4	0	125632	\N
25837	110	3	0	125657	\N
25837	2995	4	0	125658	\N
25841	137	4	0	125670	\N
25841	3697	5	0	125671	\N
25843	908	4	0	125680	\N
25843	3488	5	0	125681	\N
25846	16	2	0	125687	\N
25846	388	3	0	125688	\N
25851	4172	6	0	125739	\N
25851	4197	7	0	125740	\N
25858	23	3	0	124835	\N
25858	3497	4	0	125239	\N
25861	336	8	0	124764	\N
25861	7201	9	0	125778	\N
25865	7387	79	0	125799	\N
25865	170	126	0	125829	\N
25865	7344	127	0	125830	\N
25870	391	3	0	125850	\N
25870	3660	4	0	125851	\N
25875	597	6	0	125253	\N
25875	4697	7	0	124696	\N
25881	110	2	0	125657	\N
25881	626	3	0	125893	\N
25888	4178	4	0	125921	\N
25888	4331	5	0	125922	\N
25901	60	2	0	124045	\N
25901	4544	3	0	125993	\N
25903	16	0	0	121273	\N
25906	367	7	0	126016	\N
25906	7051	8	0	126017	\N
25913	4172	2	0	126036	\N
25913	4191	3	0	126037	\N
25915	113	4	0	126047	\N
25915	5924	5	0	126048	\N
25924	94	2	0	126067	\N
25924	2794	3	0	126068	\N
25927	435	2	0	116240	\N
25927	3413	3	0	117302	\N
25935	102	2	0	122240	\N
25935	3053	3	0	126035	\N
25936	75	6	0	126148	\N
25936	3361	7	0	126149	\N
25940	7400	7	0	126178	\N
25940	908	10	0	126179	\N
25940	3025	11	0	126180	\N
25944	365	0	0	123843	\N
25947	365	0	0	123843	\N
25950	365	0	0	123843	\N
25955	4178	3	0	126225	\N
25955	4441	4	0	126226	\N
25962	96	5	0	121880	\N
25962	5504	6	0	126258	\N
25965	18	5	0	126262	\N
25965	3550	6	0	126263	\N
25966	206	5	0	125460	\N
25966	7406	6	0	126264	\N
25971	391	2	0	126281	\N
25971	1381	3	0	126282	\N
25976	260	2	0	126306	\N
25976	3184	3	0	126307	\N
25981	4178	2	0	126225	\N
25981	4247	3	0	126335	\N
25989	56	2	0	126374	\N
25989	2795	3	0	126375	\N
25991	230	2	0	126382	\N
25991	3307	3	0	126383	\N
25994	73	4	0	126400	\N
25994	2827	5	0	126401	\N
25996	908	0	0	126402	\N
26003	113	4	0	126423	\N
25984	2842	3	0	126343	\N
25987	4178	2	0	126367	\N
25987	4247	3	0	126368	\N
25992	4233	2	0	126388	\N
25992	5577	3	0	126389	\N
25997	23	0	0	126403	\N
25999	235	5	0	126404	\N
25999	5113	6	0	126414	\N
26001	264	7	0	122881	\N
26001	6187	8	0	126420	\N
26006	4172	7	0	126236	\N
26006	4614	8	0	126443	\N
26009	156	3	0	126472	\N
26009	4594	4	0	126473	\N
26016	228	3	0	120984	\N
26016	3186	4	0	120985	\N
26018	38	3	0	126618	\N
26018	3457	4	0	126625	\N
26020	18	3	0	126628	\N
26020	3621	4	0	126629	\N
26025	224	2	0	126648	\N
26025	3150	3	0	126649	\N
26027	33	0	0	125152	\N
26032	33	0	0	125152	\N
26040	4172	2	0	126791	\N
26040	4191	3	0	126792	\N
26051	285	10	0	124629	\N
26051	7415	11	0	126892	\N
26053	528	10	0	125271	\N
26053	7416	11	0	126898	\N
26056	77	2	0	124572	\N
26056	3853	3	0	126905	\N
26060	7419	58	0	126947	\N
26060	424	64	0	126948	\N
26060	4000	65	0	126949	\N
26063	94	4	0	126984	\N
26063	6644	5	0	126985	\N
26067	320	6	0	124462	\N
26067	7424	7	0	127050	\N
26070	117	6	0	127069	\N
26070	3325	7	0	127071	\N
26075	595	2	0	125438	\N
26075	3285	3	0	125439	\N
26079	4178	2	0	127099	\N
26079	4247	3	0	127100	\N
26087	251	2	0	122497	\N
26087	1851	3	0	126247	\N
26094	4178	2	0	127170	\N
26094	4247	3	0	127171	\N
26096	7431	92	0	127193	\N
26096	453	126	0	127198	\N
26096	7432	127	0	127199	\N
26106	4178	4	0	127243	\N
26106	4331	5	0	127244	\N
26109	14	2	0	127300	\N
26109	1785	3	0	127301	\N
26111	44	2	0	125488	\N
26111	1910	3	0	127304	\N
26115	411	2	0	127320	\N
26115	3370	3	0	127321	\N
26119	2636	4	0	124399	\N
26119	7436	5	0	127356	\N
26121	40	2	0	127363	\N
26121	282	3	0	127364	\N
26129	115	2	0	127397	\N
26129	7440	3	1	127399	\N
26129	6025	3	0	127400	\N
26135	290	2	0	127418	\N
26135	1909	3	0	127419	\N
26138	38	2	0	126618	\N
26138	4009	3	0	127436	\N
26140	391	2	0	127438	\N
26140	1381	3	0	127439	\N
26143	117	2	0	127452	\N
26143	1257	3	0	127453	\N
26150	33	6	0	126662	\N
26150	7330	7	0	127513	\N
26152	121	6	0	127516	\N
26152	4686	7	0	127517	\N
26157	186	5	0	127536	\N
26157	4005	6	0	127537	\N
26159	4172	8	0	127532	\N
26159	5928	9	0	127555	\N
26161	12	6	0	127570	\N
26161	4026	7	0	127571	\N
26164	100	6	0	127593	\N
26164	7216	7	0	127594	\N
26166	4787	3	0	127601	\N
26166	4788	4	0	127602	\N
26169	75	3	0	126376	\N
26169	3139	4	0	127635	\N
26172	210	0	0	127637	\N
26174	6044	14	0	115896	\N
26174	6025	15	1	127666	\N
26174	7443	15	0	127667	\N
26174	7445	16	1	127668	\N
26174	7444	16	0	127669	\N
26179	40	2	0	127403	\N
26179	282	3	0	127404	\N
26182	119	3	0	123796	\N
26182	2860	4	0	123797	\N
26184	3628	3	0	120833	\N
26184	3785	4	0	120834	\N
26188	38	4	0	126618	\N
26188	5656	5	0	127757	\N
26190	7449	117	0	127759	\N
26190	125	126	0	127760	\N
26190	7450	127	0	127761	\N
26195	793	6	0	127815	\N
26195	3719	7	0	127816	\N
26204	4178	4	0	127861	\N
26204	4205	5	0	127862	\N
26205	4172	13	0	127889	\N
26205	5454	14	0	127890	\N
26212	4178	3	0	127861	\N
26212	4211	4	0	127924	\N
26215	4172	4	0	127940	\N
26215	4219	5	0	127941	\N
26217	23	4	0	127944	\N
26217	3189	5	0	127945	\N
26220	210	4	0	127637	\N
26220	3536	5	0	127970	\N
26222	4172	3	0	127979	\N
26222	4275	4	0	127980	\N
26225	7455	117	0	128018	\N
26225	125	126	0	128024	\N
26225	7456	127	0	128025	\N
26232	27	3	0	125689	\N
26232	4636	4	0	128110	\N
26238	5570	3	0	82608	\N
26238	5571	4	0	82609	\N
26241	365	0	0	123843	\N
26245	453	3	0	128192	\N
26245	2838	4	0	128193	\N
26255	4178	3	0	128135	\N
26255	4211	4	0	128136	\N
26258	793	3	0	128283	\N
26258	2644	4	0	128284	\N
26260	18	3	0	127579	\N
26260	3621	4	0	127580	\N
26263	27	7	0	128195	\N
26263	5681	8	0	128323	\N
26265	4178	7	0	128135	\N
26265	4396	8	0	128346	\N
26276	260	4	0	126666	\N
26276	3728	5	0	128406	\N
26280	7468	76	0	128456	\N
26280	435	126	0	128457	\N
26280	7469	127	0	128458	\N
26283	173	7	0	123012	\N
26283	4982	8	0	128476	\N
26285	102	2	0	128483	\N
26285	3053	3	0	128484	\N
26287	14	2	0	128491	\N
26287	1785	3	0	128492	\N
26288	266	7	0	127850	\N
26288	7471	8	0	128507	\N
25986	3350	3	0	126362	\N
25988	316	2	0	124140	\N
25988	1900	3	0	126369	\N
25993	40	2	0	126390	\N
25993	282	3	0	126391	\N
25998	235	0	0	126404	\N
26000	113	7	0	126047	\N
26000	5779	8	0	126419	\N
26002	113	9	0	126047	\N
26002	5363	10	0	126421	\N
26005	135	2	0	117021	\N
26005	2722	3	0	117022	\N
26007	391	3	0	126450	\N
26007	3660	4	0	126451	\N
26010	200	3	0	123267	\N
26010	3338	4	0	125131	\N
26017	38	0	0	126618	\N
26019	38	1	0	126618	\N
26019	2906	2	0	126627	\N
26026	2578	2	0	126654	\N
26026	4325	3	0	126655	\N
26029	33	2	0	126662	\N
26029	2822	3	0	126663	\N
26034	33	0	0	125152	\N
26037	14	4	0	126783	\N
26037	2291	5	0	126784	\N
26046	42	4	0	126815	\N
26046	2821	5	0	126816	\N
26052	285	2	0	124629	\N
26052	3036	3	0	126893	\N
26059	424	6	0	126925	\N
26059	7418	7	0	126926	\N
26061	167	11	0	126972	\N
26061	7420	12	0	126973	\N
26069	117	8	0	127069	\N
26069	7425	9	0	127070	\N
26072	40	4	0	127081	\N
26072	2796	5	0	127082	\N
26078	167	2	0	127097	\N
26078	3322	3	0	127098	\N
26086	1572	2	0	122379	\N
26086	3453	3	0	127143	\N
26088	121	2	0	127148	\N
26088	2498	3	0	127149	\N
26095	453	2	0	127176	\N
26095	3366	3	0	127177	\N
26100	320	2	0	124462	\N
26100	1937	3	0	127216	\N
26103	273	4	0	127229	\N
26103	3390	5	0	127230	\N
26107	212	58	0	127292	\N
26107	7435	59	0	127293	\N
26110	6765	2	0	127302	\N
26110	6841	3	0	127303	\N
26114	2578	2	0	127314	\N
26114	4325	3	0	127315	\N
26117	4178	4	0	127336	\N
26117	4331	5	0	127337	\N
26120	4178	2	0	127361	\N
26120	4247	3	0	127362	\N
26123	186	2	0	127298	\N
26123	1850	3	0	127299	\N
26125	4172	2	0	126797	\N
26125	4191	3	0	126798	\N
26132	4178	2	0	127409	\N
26132	4247	3	0	127410	\N
26136	151	2	0	127420	\N
26136	2854	3	0	127421	\N
26139	132	2	0	123566	\N
26139	2756	3	0	127437	\N
26141	488	2	0	127444	\N
26141	2791	3	0	127445	\N
26144	151	2	0	127420	\N
26144	2854	3	0	127421	\N
26146	6	3	0	127464	\N
26146	4823	4	0	127465	\N
26151	235	6	0	127514	\N
26151	3622	7	0	127515	\N
26156	149	5	0	127534	\N
26156	7442	6	0	127535	\N
26160	170	8	0	127556	\N
26160	3904	9	0	127557	\N
26165	360	3	0	123087	\N
26165	3602	4	0	123088	\N
26168	411	3	0	127627	\N
26168	3596	4	0	127628	\N
26173	18	0	0	127579	\N
26175	6044	14	0	115896	\N
26175	7446	15	0	127670	\N
26180	258	5	0	127704	\N
26180	7447	6	0	127705	\N
26189	316	4	0	124140	\N
26189	5437	5	0	127758	\N
26192	424	5	0	127795	\N
26192	7451	6	0	127796	\N
26197	115	5	0	127397	\N
26197	7454	6	0	127828	\N
26201	391	2	0	127438	\N
26201	2966	3	0	127849	\N
26206	198	3	0	127897	\N
26206	4263	4	0	127898	\N
26209	100	4	0	127907	\N
26209	3776	5	0	127908	\N
26211	4172	3	0	127916	\N
26211	4275	4	0	127917	\N
26213	164	3	0	123696	\N
26213	3385	4	0	123697	\N
26216	56	4	0	127942	\N
26216	3127	5	0	127943	\N
26218	40	6	0	127958	\N
26218	4255	7	0	127959	\N
26223	79	7	0	125528	\N
26223	5706	8	0	127995	\N
26226	140	24	0	128068	\N
26226	7457	25	0	128069	\N
26228	12	3	0	128077	\N
26228	4204	4	0	128078	\N
26234	264	7	0	128127	\N
26234	7459	8	0	128128	\N
26242	4172	3	0	128143	\N
26242	4275	4	0	128144	\N
26243	782	3	0	128151	\N
26243	12	18	0	128180	\N
26243	7460	19	0	128181	\N
26250	12	4	0	128220	\N
26250	4043	5	0	128221	\N
26251	4172	13	0	128248	\N
26251	5454	14	0	128249	\N
26254	56	3	0	127942	\N
26254	4109	4	0	128274	\N
26261	251	6	0	128305	\N
26261	5272	7	0	128306	\N
26269	2	3	0	127520	\N
26269	3548	4	0	128369	\N
26271	2789	2	0	128374	\N
26271	2	5	0	128379	\N
26274	4172	4	0	128402	\N
26274	4219	5	0	128403	\N
26279	411	3	0	128434	\N
26279	3596	4	0	128435	\N
26282	285	7	0	128474	\N
26282	7470	8	0	128475	\N
26284	40	7	0	128477	\N
26284	4488	8	0	128478	\N
26286	42	2	0	128485	\N
26286	3310	3	0	128486	\N
26289	12	3	0	128514	\N
26289	4204	4	0	128515	\N
26292	142	2	0	121135	\N
26292	4418	3	0	121136	\N
26296	40	11	0	128477	\N
26296	7473	12	0	128559	\N
26297	4178	2	0	128555	\N
26297	4247	3	0	128564	\N
26300	2578	5	0	128577	\N
26003	5924	5	0	126424	\N
26008	4172	6	0	126464	\N
26008	4197	7	0	126465	\N
26011	841	3	0	119374	\N
26011	3604	4	0	119375	\N
26013	12	4	0	125269	\N
26013	4043	5	0	126490	\N
26015	459	3	0	124112	\N
26015	3178	4	0	124113	\N
26022	316	2	0	124140	\N
26022	1900	3	0	126369	\N
26024	4172	2	0	126646	\N
26024	4191	3	0	126647	\N
26031	260	2	0	126666	\N
26031	3184	3	0	126667	\N
26035	33	0	0	126662	\N
26038	16	4	0	125687	\N
26038	2575	5	0	126785	\N
26042	142	2	0	121135	\N
26042	4418	3	0	121136	\N
26044	40	2	0	126800	\N
26044	282	3	0	126801	\N
26047	7413	3	0	126822	\N
26050	333	1	0	126851	\N
26050	241	11	0	126870	\N
26050	2586	12	0	126871	\N
26055	164	0	0	123696	\N
26057	164	2	0	123696	\N
26057	1124	3	0	126906	\N
26062	4178	4	0	126982	\N
26062	4331	5	0	126983	\N
26066	75	9	0	126376	\N
26066	7423	10	0	127037	\N
26074	40	2	0	127081	\N
26074	282	3	0	127087	\N
26077	6450	2	0	125868	\N
26077	6825	3	0	127092	\N
26081	473	1	0	127107	\N
26081	279	3	0	127108	\N
26081	3110	4	0	127109	\N
26083	209	1	0	127113	\N
26083	208	3	0	127114	\N
26083	7429	4	0	127115	\N
26084	64	8	0	123148	\N
26084	6833	9	0	127132	\N
26089	156	2	0	127150	\N
26089	4485	3	0	127151	\N
26091	2	2	0	127158	\N
26091	2789	3	0	127159	\N
26093	4178	2	0	127164	\N
26093	4247	3	0	127165	\N
26098	4178	2	0	127204	\N
26098	4247	3	0	127205	\N
26101	6173	4	0	127225	\N
26101	7433	5	0	127226	\N
26105	20	2	0	123806	\N
26105	369	3	0	126101	\N
26108	186	2	0	127298	\N
26108	1850	3	0	127299	\N
26118	391	4	0	127346	\N
26118	3352	5	0	127347	\N
26124	7412	2	0	127156	\N
26124	7430	3	0	127157	\N
26126	4450	1	0	127384	\N
26126	4178	3	0	127387	\N
26126	4460	4	0	127388	\N
26128	115	2	0	127397	\N
26128	2797	3	0	127398	\N
26130	459	2	0	127401	\N
26130	3860	3	0	127402	\N
26133	2	2	0	127411	\N
26133	2789	3	0	127412	\N
26137	411	4	0	127430	\N
26137	2806	5	0	127431	\N
26142	4172	2	0	127450	\N
26142	4191	3	0	127451	\N
26147	4172	6	0	127478	\N
26147	4197	7	0	127479	\N
26149	2351	30	0	127486	\N
26149	7441	31	0	127500	\N
26154	2	6	0	127520	\N
26154	4825	7	0	127521	\N
26163	18	3	0	127579	\N
26163	3621	4	0	127580	\N
26171	2815	0	0	127636	\N
26176	198	7	0	123396	\N
26176	5416	8	0	127685	\N
26178	75	7	0	127688	\N
26178	2859	8	0	127689	\N
26181	3625	3	0	122694	\N
26181	3784	4	0	123793	\N
26185	2351	82	0	127736	\N
26185	7448	83	0	127737	\N
26187	54	4	0	121727	\N
26187	3685	5	0	127748	\N
26193	7452	120	0	127797	\N
26193	424	126	0	127799	\N
26193	7453	127	0	127800	\N
26194	132	6	0	127813	\N
26194	4690	7	0	127814	\N
26198	54	5	0	121727	\N
26198	3787	6	0	127829	\N
26199	170	3	0	127836	\N
26199	4148	4	0	127837	\N
26207	100	4	0	127907	\N
26207	3776	5	0	127908	\N
26210	224	4	0	126648	\N
26210	3806	5	0	127909	\N
26214	79	4	0	125528	\N
26214	3678	5	0	127939	\N
26219	115	4	0	127968	\N
26219	4844	5	0	127969	\N
26221	4178	3	0	127977	\N
26221	4211	4	0	127978	\N
26224	4178	7	0	127977	\N
26224	4396	8	0	127996	\N
26227	365	24	0	123843	\N
26227	7458	25	0	128070	\N
26229	4178	3	0	128085	\N
26229	4211	4	0	128086	\N
26236	365	3	0	123843	\N
26236	3839	4	0	123844	\N
26237	4178	3	0	128135	\N
26237	4211	4	0	128136	\N
26240	365	0	0	123843	\N
26244	7461	3	0	128188	\N
26244	7462	3	0	128189	\N
26244	7465	5	0	128191	\N
26247	27	3	0	128195	\N
26247	4636	4	0	128196	\N
26248	102	3	0	128203	\N
26248	3597	4	0	128204	\N
26252	320	3	0	128256	\N
26252	4821	4	0	128257	\N
26257	27	3	0	128195	\N
26257	4636	4	0	128196	\N
26259	7412	3	0	128291	\N
26259	7466	4	0	128292	\N
26262	391	7	0	128321	\N
26262	3662	8	0	128322	\N
26264	200	3	0	128330	\N
26264	3338	4	0	128331	\N
26267	4178	3	0	128359	\N
26267	4211	4	0	128360	\N
26270	1021	3	0	121375	\N
26270	4551	4	0	121376	\N
26272	40	2	0	128386	\N
26272	282	3	0	128387	\N
26275	4178	4	0	128404	\N
26275	4205	5	0	128405	\N
26277	4178	6	0	128404	\N
26277	4250	7	0	128419	\N
26290	4172	2	0	128520	\N
26290	4191	3	0	128521	\N
26033	7410	64	0	126726	\N
26033	33	126	0	126767	\N
26033	7411	127	0	126768	\N
26036	102	2	0	126773	\N
26036	3053	3	0	126774	\N
26039	241	4	0	125530	\N
26039	2122	5	0	126786	\N
26041	4172	2	0	126797	\N
26041	4191	3	0	126798	\N
26043	2636	2	0	124399	\N
26043	2836	3	0	126799	\N
26045	1636	2	0	123398	\N
26045	4416	3	0	126806	\N
26048	56	2	0	126823	\N
26048	169	3	0	126824	\N
26049	18	11	0	126847	\N
26049	7414	12	0	126848	\N
26054	1109	10	0	126899	\N
26054	7417	11	0	126900	\N
26058	18	2	0	126911	\N
26058	1685	3	0	126912	\N
26064	488	15	0	125919	\N
26064	7421	16	0	127016	\N
26065	6849	9	0	127035	\N
26065	7422	10	0	127036	\N
26068	449	6	0	127051	\N
26068	6116	7	0	127052	\N
26071	7426	5	0	127080	\N
26073	258	2	0	126000	\N
26073	3275	3	0	126001	\N
26076	597	2	0	125253	\N
26076	3286	3	0	125441	\N
26080	317	1	0	127103	\N
26080	316	3	0	127106	\N
26080	3115	4	0	126369	\N
26082	7427	1	0	127110	\N
26082	7225	3	0	127111	\N
26082	7428	4	0	127112	\N
26085	117	2	0	127137	\N
26085	1257	3	0	127138	\N
26090	7412	2	0	127156	\N
26090	7430	3	0	127157	\N
26092	251	2	0	122497	\N
26092	1851	3	0	126247	\N
26097	4233	2	0	126388	\N
26097	5577	3	0	126389	\N
26099	40	3	0	127081	\N
26099	372	4	0	127211	\N
26102	930	4	0	127227	\N
26102	7434	5	0	127228	\N
26104	20	2	0	123806	\N
26104	369	3	0	126101	\N
26112	212	2	0	121262	\N
26112	3616	3	0	127305	\N
26113	2	2	0	127158	\N
26113	2789	3	0	127159	\N
26116	4178	2	0	127326	\N
26116	4247	3	0	127327	\N
26122	4178	4	0	127361	\N
26122	4331	5	0	127373	\N
26127	7437	2	0	127393	\N
26127	7438	2	0	127394	\N
26127	7439	3	1	127395	\N
26127	6025	3	0	127396	\N
26131	40	2	0	127403	\N
26131	282	3	0	127404	\N
26134	94	2	0	126984	\N
26134	2794	3	0	127413	\N
26145	4178	2	0	127409	\N
26145	4247	3	0	127410	\N
26148	2351	3	0	127486	\N
26148	2845	4	0	127487	\N
26153	4178	6	0	127518	\N
26153	4250	7	0	127519	\N
26155	4172	5	0	127532	\N
26155	4634	6	0	127533	\N
26158	94	5	0	126984	\N
26158	7257	6	0	127538	\N
26162	4178	3	0	127518	\N
26162	4211	4	0	127578	\N
26167	4178	8	0	127619	\N
26167	4218	9	0	127620	\N
26170	7412	0	0	127156	\N
26177	4178	7	0	127686	\N
26177	4396	8	0	127687	\N
26183	2351	3	0	127712	\N
26183	2845	4	0	127713	\N
26186	102	4	0	127746	\N
26186	3572	5	0	127747	\N
26191	23	11	0	126403	\N
26191	6505	12	0	127784	\N
26196	192	5	0	123550	\N
26196	3871	6	0	127827	\N
26200	4178	3	0	127686	\N
26200	4211	4	0	127844	\N
26202	266	2	0	127850	\N
26202	3235	3	0	127851	\N
26203	4172	4	0	127532	\N
26203	4219	5	0	127860	\N
26208	224	4	0	126648	\N
26208	3806	5	0	127909	\N
26230	4178	7	0	128101	\N
26230	4396	8	0	128102	\N
26231	2	7	0	127520	\N
26231	2858	8	0	128103	\N
26233	4178	7	0	128125	\N
26233	4396	8	0	128126	\N
26235	365	0	0	123843	\N
26239	365	0	0	123843	\N
26246	14	3	0	127300	\N
26246	4272	4	0	128194	\N
26249	79	3	0	125528	\N
26249	3652	4	0	128211	\N
26253	835	4	0	128266	\N
26253	7016	5	0	128267	\N
26256	391	3	0	128281	\N
26256	3660	4	0	128282	\N
26266	35	3	0	122160	\N
26266	3563	4	0	122161	\N
26268	64	3	0	128361	\N
26268	4217	4	0	128362	\N
26273	4178	3	0	128359	\N
26273	4211	4	0	128360	\N
26278	210	4	0	127637	\N
26278	3536	5	0	127970	\N
26281	4787	7	0	127601	\N
26281	7089	8	0	128473	\N
26291	86	2	0	125498	\N
26291	3321	3	0	128526	\N
26295	451	11	0	128557	\N
26295	7193	12	0	128558	\N
26299	1470	5	0	126660	\N
26299	6556	6	0	128576	\N
26302	186	6	0	127536	\N
26302	7407	7	0	128593	\N
26305	4425	3	0	128618	\N
26305	4233	4	0	128619	\N
26307	4172	0	0	128621	\N
26311	268	6	0	111358	\N
26311	7477	7	1	128646	\N
26311	7476	7	0	128647	\N
26311	7463	8	0	128648	\N
26316	367	2	0	126016	\N
26316	3329	3	0	128661	\N
26318	4172	5	0	128621	\N
26318	4415	6	0	128672	\N
26321	167	5	0	127097	\N
26321	2851	6	0	128677	\N
26322	4172	5	0	128621	\N
26322	4415	6	0	128672	\N
26327	121	1	0	127516	\N
26327	122	2	0	128700	\N
26329	360	3	0	128708	\N
26329	7479	4	0	128709	\N
26336	40	4	0	128477	\N
26336	2796	5	0	128738	\N
26293	4178	2	0	128531	\N
26293	4247	3	0	128532	\N
26294	4178	11	0	128555	\N
26294	7472	12	0	128556	\N
26301	242	5	0	128579	\N
26301	4562	6	0	128580	\N
26304	6	2	0	128610	\N
26304	2805	3	0	128611	\N
26310	241	0	0	128636	\N
26315	79	3	0	128658	\N
26315	3652	4	0	128659	\N
26317	14	5	0	128670	\N
26317	5648	6	0	128671	\N
26320	115	5	0	128675	\N
26320	5025	6	0	128676	\N
26324	793	5	0	128283	\N
26324	5143	6	0	128689	\N
26326	4172	2	0	128621	\N
26326	4191	3	0	128699	\N
26332	6303	5	0	124928	\N
26332	6994	6	0	128716	\N
26335	4178	3	0	128673	\N
26335	4211	4	0	128729	\N
26343	1021	2	0	121375	\N
26343	4432	3	0	128766	\N
26346	242	3	0	128579	\N
26346	2839	4	0	128777	\N
26348	242	2	0	128579	\N
26348	3425	3	0	128779	\N
26349	288	1	0	126342	\N
26349	7481	2	0	128782	\N
26362	4172	3	0	128621	\N
26362	4275	4	0	128858	\N
26365	4172	0	0	128621	\N
26368	6303	3	0	128896	\N
26368	7480	4	0	128897	\N
26376	86	8	0	125498	\N
26376	3905	9	0	128962	\N
26378	75	3	0	127688	\N
26378	3855	4	0	128970	\N
26384	119	4	0	123796	\N
26384	3518	5	0	128994	\N
26387	210	3	0	129010	\N
26387	3539	4	0	129011	\N
26391	69	7	0	126488	\N
26391	3711	8	0	129058	\N
26399	841	4	0	119374	\N
26399	3886	5	0	129171	\N
26404	108	4	0	125004	\N
26404	4060	5	0	129208	\N
26406	71	21	0	129220	\N
26406	7498	22	0	129221	\N
26413	94	3	0	129257	\N
26413	2864	4	0	129258	\N
26414	38	18	0	129295	\N
26414	5671	19	0	129296	\N
26417	320	4	0	129309	\N
26417	3824	5	0	129310	\N
26419	4178	7	0	129331	\N
26419	4396	8	0	129332	\N
26423	262	3	0	129343	\N
26423	4778	4	0	129344	\N
26426	156	3	0	129362	\N
26426	4594	4	0	129363	\N
26428	75	3	0	127688	\N
26428	3855	4	0	128970	\N
26433	133	2	0	129401	\N
26433	132	8	0	129402	\N
26433	7504	9	0	129403	\N
26435	133	2	0	129401	\N
26435	132	8	0	129402	\N
26435	7504	9	0	129403	\N
26440	4172	3	0	129438	\N
26440	4275	4	0	129439	\N
26443	56	6	0	129198	\N
26443	4703	7	0	129456	\N
26447	7412	4	0	129454	\N
26447	7499	5	0	129468	\N
26451	170	3	0	129339	\N
26451	4148	4	0	129340	\N
26453	4172	2	0	129438	\N
26453	4191	3	0	129486	\N
26456	1021	4	0	129526	\N
26456	4752	5	0	129527	\N
26458	151	7	0	127420	\N
26458	7266	8	0	129550	\N
26466	189	3	0	129615	\N
26466	3782	4	0	129616	\N
26468	7515	56	0	129651	\N
26468	189	126	0	129672	\N
26468	7516	127	0	129673	\N
26476	58	6	0	123618	\N
26476	6952	7	0	129729	\N
26477	4109	3	0	129736	\N
26477	56	5	0	129739	\N
26477	1088	6	0	129740	\N
26485	4178	3	0	129772	\N
26485	4211	4	0	129773	\N
26486	4178	3	0	129780	\N
26486	4211	4	0	129781	\N
26489	4178	7	0	129813	\N
26489	4396	8	0	129814	\N
26494	7521	96	0	129842	\N
26494	71	126	0	129845	\N
26494	7522	127	0	129846	\N
26499	38	7	0	129892	\N
26499	5071	8	0	129893	\N
26502	42	7	0	128783	\N
26502	6853	8	0	129918	\N
26507	79	3	0	128658	\N
26507	3652	4	0	128659	\N
26509	7523	96	0	130010	\N
26509	71	105	0	130016	\N
26509	7524	106	0	130017	\N
26510	7083	5	0	130028	\N
26510	90	11	0	130039	\N
26510	7525	12	0	130040	\N
26512	75	4	0	127688	\N
26512	3959	5	0	130052	\N
26515	56	3	0	129760	\N
26515	4109	4	0	130068	\N
26518	326	3	0	130079	\N
26518	3339	4	0	130080	\N
26519	4178	4	0	130075	\N
26519	4205	5	0	130089	\N
26523	268	3	0	130101	\N
26523	3815	4	0	130102	\N
26528	1628	3	0	130130	\N
26528	7527	4	0	130131	\N
26534	40	9	0	128758	\N
26534	4712	10	0	130170	\N
26541	7412	7	0	130103	\N
26541	7528	8	0	130234	\N
26544	73	2	0	130242	\N
26544	3243	3	0	130243	\N
26546	4178	10	0	130265	\N
26546	4665	11	0	130266	\N
26551	367	3	0	130296	\N
26551	3683	4	0	130297	\N
26554	7412	6	0	130103	\N
26554	7507	7	0	130325	\N
26557	18	3	0	130334	\N
26557	3621	4	0	130335	\N
26559	73	4	0	130346	\N
26559	2284	5	0	130347	\N
26561	82	3	0	125936	\N
26561	4505	4	0	130356	\N
26563	793	3	0	128283	\N
26563	2644	4	0	128284	\N
26565	322	3	0	119398	\N
26565	1105	4	0	130421	\N
26569	90	3	0	130441	\N
26569	4074	4	0	130442	\N
26571	7412	7	0	130439	\N
26571	7528	8	0	130459	\N
26573	266	4	0	130467	\N
26573	4100	5	0	130468	\N
26298	40	2	0	128477	\N
26298	282	3	0	128565	\N
26306	4233	1	0	126388	\N
26306	5087	2	0	128620	\N
26313	268	6	0	111358	\N
26313	6804	7	0	128650	\N
26314	367	3	0	126016	\N
26314	3683	4	0	128657	\N
26325	14	2	0	128670	\N
26325	1785	3	0	128694	\N
26328	121	2	0	127516	\N
26328	2498	3	0	128701	\N
26331	360	5	0	128708	\N
26331	3586	6	0	128715	\N
26338	35	1	0	128743	\N
26338	340	2	0	128745	\N
26342	391	2	0	128764	\N
26342	1381	3	0	128765	\N
26345	852	3	0	128775	\N
26345	3612	4	0	128776	\N
26347	852	2	0	128775	\N
26347	4236	3	0	128778	\N
26352	7482	7	0	128800	\N
26352	7483	8	0	128801	\N
26354	6765	2	0	127302	\N
26354	6841	3	0	127303	\N
26357	88	7	0	125852	\N
26357	5323	8	0	128828	\N
26359	4178	3	0	128838	\N
26359	4211	4	0	128839	\N
26364	326	2	0	120539	\N
26364	393	3	0	128863	\N
26367	4178	4	0	128888	\N
26367	4331	5	0	128889	\N
26370	528	6	0	128913	\N
26370	7486	7	0	128914	\N
26375	192	8	0	123550	\N
26375	7488	9	0	128961	\N
26380	4	3	0	128979	\N
26380	3837	4	0	128980	\N
26383	3625	4	0	122694	\N
26383	3802	5	0	128993	\N
26386	90	3	0	129002	\N
26386	4074	4	0	129003	\N
26390	4172	7	0	129056	\N
26390	4614	8	0	129057	\N
26393	156	7	0	127150	\N
26393	4672	8	0	129125	\N
26396	61	1	0	129144	\N
26396	60	8	0	129157	\N
26396	7497	9	0	129158	\N
26398	1021	2	0	121375	\N
26398	4432	3	0	128766	\N
26401	7412	3	0	129188	\N
26401	7466	4	0	129189	\N
26408	94	6	0	126984	\N
26408	4696	7	0	129234	\N
26410	4172	4	0	129245	\N
26410	4219	5	0	129246	\N
26416	7501	4	0	129307	\N
26416	7502	5	0	129308	\N
26418	4178	3	0	129255	\N
26418	4211	4	0	129256	\N
26422	235	3	0	129341	\N
26422	3343	4	0	129342	\N
26425	841	3	0	129354	\N
26425	3604	4	0	129355	\N
26430	4172	4	0	129245	\N
26430	4219	5	0	129246	\N
26439	4178	4	0	129364	\N
26439	4205	5	0	129431	\N
26442	7412	6	0	129454	\N
26442	7507	7	0	129455	\N
26446	336	4	0	126054	\N
26446	3947	5	0	129467	\N
26457	56	3	0	129534	\N
26457	4109	4	0	129535	\N
26460	20	3	0	129582	\N
26460	2844	4	0	129583	\N
26463	94	6	0	129598	\N
26463	4696	7	0	129599	\N
26465	4178	3	0	129613	\N
26465	4211	4	0	129614	\N
26467	7514	79	0	129633	\N
26467	189	120	0	129649	\N
26467	849	121	0	129650	\N
26470	4172	8	0	129691	\N
26470	5928	9	0	129692	\N
26472	4088	3	0	124814	\N
26472	4506	4	0	124815	\N
26474	459	6	0	129726	\N
26474	7518	7	0	129727	\N
26475	4172	6	0	129691	\N
26475	5278	7	0	129728	\N
26484	6765	3	0	127302	\N
26484	6884	4	0	129771	\N
26488	4172	3	0	129691	\N
26488	4275	4	0	129798	\N
26491	4172	3	0	129823	\N
26491	4275	4	0	129824	\N
26496	198	3	0	129872	\N
26496	4263	4	0	129873	\N
26504	4172	3	0	129932	\N
26504	4275	4	0	129933	\N
26506	326	4	0	129944	\N
26506	3519	5	0	129945	\N
26514	192	3	0	129479	\N
26514	3790	4	0	129480	\N
26517	18	3	0	130077	\N
26517	3621	4	0	130078	\N
26522	5885	3	0	121991	\N
26522	5926	4	0	123245	\N
26525	320	3	0	130105	\N
26525	4821	4	0	130106	\N
26530	79	3	0	130140	\N
26530	3652	4	0	130141	\N
26533	54	9	0	130150	\N
26533	5922	10	0	130169	\N
26538	4178	7	0	130192	\N
26538	4396	8	0	130193	\N
26540	336	9	0	130218	\N
26540	6545	10	0	130219	\N
26543	156	2	0	130240	\N
26543	3093	3	0	130241	\N
26553	2	7	0	129232	\N
26553	2858	8	0	130312	\N
26558	230	4	0	130344	\N
26558	3954	5	0	130345	\N
26567	273	3	0	127229	\N
26567	3638	4	0	130438	\N
26568	7412	3	0	130439	\N
26568	7466	4	0	130440	\N
26570	186	7	0	130457	\N
26570	4595	8	0	130458	\N
26572	4178	4	0	130348	\N
26572	4205	5	0	130349	\N
26575	242	3	0	130469	\N
26575	2839	4	0	130476	\N
26580	2111	6	0	130524	\N
26580	7534	7	0	130526	\N
26583	4875	6	0	130545	\N
26583	300	8	0	130546	\N
26583	3168	9	0	130547	\N
26585	3903	6	0	130539	\N
26585	285	8	0	130548	\N
26585	3112	9	0	130549	\N
26587	4178	6	0	130348	\N
26587	4250	7	0	130564	\N
26589	40	6	0	130567	\N
26589	4255	7	0	130568	\N
26592	38	4	0	130598	\N
26592	5656	5	0	130599	\N
26596	208	6	0	116810	\N
26596	5118	7	0	125361	\N
26601	79	5	0	130641	\N
26601	5993	6	0	130642	\N
26604	20	10	0	130332	\N
26300	7474	6	0	128578	\N
26303	2636	5	0	128604	\N
26303	3780	6	0	128605	\N
26308	7412	0	0	128291	\N
26309	241	39	0	128636	\N
26309	7475	40	0	128637	\N
26312	5885	6	0	121991	\N
26312	6803	7	0	128649	\N
26319	4178	5	0	128673	\N
26319	4429	6	0	128674	\N
26323	7412	5	0	128291	\N
26323	7478	6	0	128688	\N
26330	6303	3	0	124928	\N
26330	7480	4	0	128710	\N
26333	30	5	0	122890	\N
26333	6764	6	0	128717	\N
26334	181	4	0	125987	\N
26334	4058	5	0	128722	\N
26337	35	2	0	128743	\N
26337	1191	3	0	128744	\N
26339	96	5	0	121880	\N
26339	5504	6	0	126258	\N
26340	18	5	0	128756	\N
26340	3550	6	0	128757	\N
26344	4178	3	0	128773	\N
26344	4211	4	0	128774	\N
26350	42	1	0	128783	\N
26350	2823	2	0	128784	\N
26351	4178	7	0	128773	\N
26351	4509	8	0	128799	\N
26353	212	2	0	121262	\N
26353	3616	3	0	127305	\N
26356	2	7	0	128826	\N
26356	5463	8	0	128827	\N
26358	7484	77	0	128829	\N
26358	88	126	0	128830	\N
26358	7485	127	0	128831	\N
26361	7412	2	0	128850	\N
26361	7430	3	0	128851	\N
26366	262	7	0	128878	\N
26366	4888	8	0	128879	\N
26372	14	6	0	128928	\N
26372	7487	7	0	128929	\N
26374	44	6	0	128943	\N
26374	5989	7	0	128944	\N
26377	324	3	0	123313	\N
26377	4514	4	0	128969	\N
26379	4178	3	0	128977	\N
26379	4211	4	0	128978	\N
26382	4178	4	0	128991	\N
26382	4205	5	0	128992	\N
26389	210	6	0	129040	\N
26389	3721	7	0	129041	\N
26392	7490	77	0	129097	\N
26392	1018	116	0	129103	\N
26392	7491	116	0	129104	\N
26392	7493	117	1	129105	\N
26392	7492	117	0	129106	\N
26392	7495	118	1	129107	\N
26392	7494	118	0	129108	\N
26392	1075	119	1	129109	\N
26392	7496	119	0	129110	\N
26395	4178	4	0	128991	\N
26395	4205	5	0	128992	\N
26400	64	4	0	129180	\N
26400	3911	5	0	129181	\N
26403	56	3	0	129198	\N
26403	4109	4	0	129199	\N
26412	4178	3	0	129255	\N
26412	4211	4	0	129256	\N
26421	170	3	0	129339	\N
26421	4148	4	0	129340	\N
26429	145	4	0	129374	\N
26429	3867	5	0	129375	\N
26432	5069	2	0	129388	\N
26432	4172	8	0	129399	\N
26432	5070	9	0	129400	\N
26436	1018	6	0	129103	\N
26436	7505	6	0	129416	\N
26436	4098	7	1	129417	\N
26436	7506	7	0	129418	\N
26437	77	6	0	129419	\N
26437	6600	7	0	129420	\N
26444	46	6	0	129457	\N
26444	5965	7	0	129458	\N
26448	285	4	0	128474	\N
26448	3674	5	0	129469	\N
26450	192	3	0	129479	\N
26450	3790	4	0	129480	\N
26455	7509	68	0	129515	\N
26455	391	88	0	129524	\N
26455	7510	89	0	129525	\N
26459	7511	115	0	129572	\N
26459	7512	118	0	129573	\N
26459	3108	119	1	129574	\N
26459	7513	119	0	129575	\N
26462	285	6	0	128474	\N
26462	3903	7	0	129597	\N
26464	117	3	0	127452	\N
26464	3191	4	0	129606	\N
26469	54	8	0	121727	\N
26469	7517	9	0	129690	\N
26471	233	3	0	123721	\N
26471	3704	4	0	124813	\N
26479	228	4	0	120984	\N
26479	4800	5	0	126275	\N
26481	56	5	0	129760	\N
26481	6463	6	0	129761	\N
26493	14	3	0	129832	\N
26493	4272	4	0	129833	\N
26498	75	1	0	127688	\N
26498	1427	2	0	129877	\N
26501	6044	7	0	129916	\N
26501	6727	8	0	129917	\N
26503	320	3	0	129309	\N
26503	4821	4	0	129925	\N
26508	156	3	0	129958	\N
26508	4594	4	0	129959	\N
26513	77	7	0	130060	\N
26513	6022	8	0	130061	\N
26516	4178	3	0	130075	\N
26516	4211	4	0	130076	\N
26521	402	2	0	130099	\N
26521	2760	3	0	130100	\N
26527	4178	4	0	130122	\N
26527	4205	5	0	130123	\N
26532	54	0	0	130150	\N
26536	135	9	0	117021	\N
26536	5189	10	0	130173	\N
26537	288	5	0	130184	\N
26537	2224	6	0	130185	\N
26539	56	4	0	129760	\N
26539	3127	5	0	130201	\N
26545	7412	2	0	130103	\N
26545	7529	3	0	130244	\N
26548	356	1	0	130269	\N
26548	336	4	0	130274	\N
26548	7530	5	0	130275	\N
26550	4	4	0	128979	\N
26550	4117	5	0	130289	\N
26556	4172	3	0	129932	\N
26556	4275	4	0	129933	\N
26562	4172	3	0	130363	\N
26562	4275	4	0	130364	\N
26564	7531	106	0	130407	\N
26564	391	126	0	130413	\N
26564	7510	127	0	130414	\N
26574	242	0	0	130469	\N
26577	4178	12	0	130348	\N
26577	7533	13	0	130502	\N
26582	4875	6	0	130545	\N
26582	300	8	0	130546	\N
26582	3168	9	0	130547	\N
26591	4178	6	0	130348	\N
26591	4250	7	0	130564	\N
26595	4233	6	0	130608	\N
26595	6364	7	0	130618	\N
26341	40	5	0	128758	\N
26341	2714	6	0	128759	\N
26355	149	2	0	128810	\N
26355	1379	3	0	128811	\N
26360	4178	2	0	128844	\N
26360	4247	3	0	128845	\N
26363	4	3	0	123484	\N
26363	3837	4	0	123491	\N
26369	6303	5	0	128896	\N
26369	6994	6	0	128902	\N
26371	113	6	0	126047	\N
26371	5057	7	0	128927	\N
26373	75	6	0	127688	\N
26373	3303	7	0	128930	\N
26381	6303	4	0	128989	\N
26381	7489	5	0	128990	\N
26385	3628	4	0	120833	\N
26385	3803	5	0	128995	\N
26388	266	7	0	129026	\N
26388	4926	8	0	129027	\N
26394	4172	3	0	129132	\N
26394	4275	4	0	129133	\N
26397	61	1	0	129144	\N
26397	60	8	0	129157	\N
26397	7497	9	0	129158	\N
26402	4178	3	0	129196	\N
26402	4211	4	0	129197	\N
26405	290	4	0	129209	\N
26405	5879	5	0	129210	\N
26407	2	6	0	129232	\N
26407	4825	7	0	129233	\N
26409	7449	117	0	129235	\N
26409	125	118	0	129236	\N
26411	7412	4	0	129247	\N
26411	7499	5	0	129248	\N
26415	224	18	0	129297	\N
26415	7500	19	0	129298	\N
26420	88	3	0	125852	\N
26420	3655	4	0	125853	\N
26424	7484	77	0	129345	\N
26424	88	89	0	129346	\N
26424	7503	90	0	129347	\N
26427	4178	3	0	129364	\N
26427	4211	4	0	129365	\N
26431	3004	3	0	129382	\N
26431	5266	4	0	129383	\N
26434	133	2	0	129401	\N
26434	132	8	0	129402	\N
26434	7504	9	0	129403	\N
26438	62	4	0	129429	\N
26438	4059	5	0	129430	\N
26441	90	3	0	129440	\N
26441	4074	4	0	129441	\N
26445	285	0	0	128474	\N
26449	285	2	0	128474	\N
26449	4282	3	0	129472	\N
26452	7482	3	0	128800	\N
26452	7508	4	0	129481	\N
26454	7412	4	0	129454	\N
26454	7499	5	0	129468	\N
26461	285	0	0	129584	\N
26473	14	7	0	128928	\N
26473	3882	8	0	129713	\N
26478	453	4	0	128192	\N
26478	4108	5	0	129748	\N
26480	7412	5	0	129454	\N
26480	7519	6	0	129759	\N
26482	33	3	0	126662	\N
26482	3342	4	0	129768	\N
26483	212	3	0	129769	\N
26483	3639	4	0	129770	\N
26487	841	4	0	129790	\N
26487	3886	5	0	129791	\N
26490	431	7	0	129815	\N
26490	7520	8	0	129816	\N
26492	4178	3	0	129813	\N
26492	4211	4	0	129831	\N
26495	4172	10	0	129864	\N
26495	4663	11	0	129865	\N
26497	181	3	0	129874	\N
26497	4184	4	0	129875	\N
26500	4178	3	0	129900	\N
26500	4211	4	0	129901	\N
26505	44	3	0	129934	\N
26505	3631	4	0	129935	\N
26511	3964	5	0	130041	\N
26511	18	11	0	130042	\N
26511	7526	12	0	130043	\N
26520	92	3	0	130096	\N
26520	4410	4	0	130097	\N
26524	7412	3	0	130103	\N
26524	7466	4	0	130104	\N
26526	69	3	0	126488	\N
26526	4536	4	0	130113	\N
26529	200	3	0	130132	\N
26529	3338	4	0	130133	\N
26531	316	4	0	124140	\N
26531	5437	5	0	127758	\N
26535	137	9	0	130171	\N
26535	5190	10	0	130172	\N
26542	18	7	0	130077	\N
26542	1618	8	0	130235	\N
26547	356	1	0	130269	\N
26547	336	4	0	130274	\N
26547	7530	5	0	130275	\N
26549	40	2	0	128758	\N
26549	282	3	0	130280	\N
26552	235	3	0	129341	\N
26552	3343	4	0	129342	\N
26555	20	3	0	130332	\N
26555	2844	4	0	130333	\N
26560	4178	4	0	130348	\N
26560	4205	5	0	130349	\N
26566	40	4	0	130430	\N
26566	3381	5	0	130431	\N
26576	86	12	0	125498	\N
26576	7532	13	0	130501	\N
26579	2111	6	0	130524	\N
26579	5292	7	0	130525	\N
26584	4875	6	0	130545	\N
26584	300	8	0	130546	\N
26584	3168	9	0	130547	\N
26586	3903	6	0	130539	\N
26586	285	8	0	130548	\N
26586	1075	9	1	130550	\N
26586	7537	9	0	130551	\N
26590	200	4	0	130132	\N
26590	4683	5	0	130577	\N
26594	279	6	0	130616	\N
26594	5117	7	0	130617	\N
26597	40	6	0	130567	\N
26597	4255	7	0	130568	\N
26600	228	4	0	120984	\N
26600	4800	5	0	126275	\N
26608	164	3	0	130697	\N
26608	3385	4	0	130698	\N
26611	56	3	0	130703	\N
26611	4109	4	0	130704	\N
26616	4172	8	0	130701	\N
26616	7540	9	0	130742	\N
26621	7545	21	0	130794	\N
26621	6723	23	0	130795	\N
26621	7546	24	0	130796	\N
26623	210	3	0	130806	\N
26623	3539	4	0	130807	\N
26625	4178	3	0	130814	\N
26625	4211	4	0	130815	\N
26629	7412	7	0	130842	\N
26629	7528	8	0	130843	\N
26630	4	4	0	130840	\N
26630	7548	5	0	130852	\N
26635	4088	4	0	124814	\N
26635	4089	5	0	130885	\N
26638	424	4	0	130888	\N
26638	3188	5	0	130889	\N
26640	4178	9	0	130861	\N
26640	4682	10	0	130910	\N
26578	167	4	0	127097	\N
26578	4048	5	0	130511	\N
26581	3903	6	0	130539	\N
26581	6751	8	0	130542	\N
26581	7535	8	0	130543	\N
26581	7536	9	0	130544	\N
26588	2	6	0	130565	\N
26588	4825	7	0	130566	\N
26593	4233	4	0	130608	\N
26593	7538	5	0	130609	\N
26599	4178	4	0	130629	\N
26599	4205	5	0	130630	\N
26602	18	5	0	130334	\N
26602	4010	6	0	130643	\N
26605	79	4	0	130681	\N
26605	3678	5	0	130682	\N
26607	79	3	0	130681	\N
26607	3652	4	0	130690	\N
26612	14	6	0	129832	\N
26612	7487	7	0	130717	\N
26619	264	8	0	128127	\N
26619	7543	9	0	130746	\N
26620	7544	21	0	130789	\N
26620	123	23	0	130792	\N
26620	2275	24	0	130793	\N
26622	7547	21	0	130797	\N
26622	4178	23	0	130798	\N
26622	4460	24	0	130799	\N
26628	4	7	0	130840	\N
26628	4716	8	0	130841	\N
26637	233	4	0	130886	\N
26637	3775	5	0	130887	\N
26644	367	6	0	130296	\N
26644	6013	7	0	130935	\N
26651	7555	106	0	131021	\N
26651	391	126	0	131031	\N
26651	7510	127	0	131032	\N
26655	200	4	0	131052	\N
26655	4683	5	0	131053	\N
26660	6044	8	0	131085	\N
26660	6725	9	0	131086	\N
26665	812	2	0	131103	\N
26665	202	8	0	131114	\N
26665	7559	9	1	131115	\N
26665	7558	9	0	131116	\N
26668	891	2	0	131118	\N
26668	119	8	0	131119	\N
26668	7561	9	0	131120	\N
26674	2	4	0	131152	\N
26674	3510	5	0	131153	\N
26676	4	3	0	131161	\N
26676	3837	4	0	131162	\N
26679	4172	3	0	130701	\N
26679	4275	4	0	130702	\N
26681	391	6	0	131199	\N
26681	2680	7	0	131200	\N
26696	367	4	0	131301	\N
26696	3679	5	0	131302	\N
26698	7412	3	0	131310	\N
26698	7466	4	0	131311	\N
26701	2	3	0	131322	\N
26701	3548	4	0	131323	\N
26703	40	7	0	131339	\N
26703	4718	8	0	131340	\N
26709	7576	58	0	131401	\N
26709	38	126	0	131428	\N
26709	7577	127	0	131429	\N
26711	90	3	0	130441	\N
26711	4074	4	0	130442	\N
26716	469	4	0	131477	\N
26716	7579	5	0	131478	\N
26728	4172	7	0	131220	\N
26728	4614	8	0	131557	\N
26729	214	7	0	125633	\N
26729	5951	8	0	131558	\N
26737	40	3	0	131613	\N
26737	372	4	0	131614	\N
26740	164	3	0	130697	\N
26740	3385	4	0	130698	\N
26742	164	4	0	130697	\N
26742	4152	5	0	131629	\N
26746	424	7	0	131654	\N
26746	4986	8	0	131655	\N
26748	54	3	0	131664	\N
26748	3041	4	0	131665	\N
26750	212	3	0	129769	\N
26750	3639	4	0	129770	\N
26752	212	2	0	129769	\N
26752	4193	3	0	131672	\N
26755	132	4	0	127813	\N
26755	3716	5	0	131682	\N
26759	2	0	0	131699	\N
26763	793	4	0	128283	\N
26763	3618	5	0	131714	\N
26768	453	6	0	131755	\N
26768	4091	7	0	131756	\N
26770	6044	20	0	131273	\N
26770	7586	21	0	131811	\N
26782	214	3	0	131889	\N
26782	3496	4	0	131890	\N
26786	230	4	0	131913	\N
26786	3954	5	0	131914	\N
26788	6765	4	0	131916	\N
26788	7217	5	0	131917	\N
26793	595	3	0	130908	\N
26793	3654	4	0	131957	\N
26800	40	3	0	131984	\N
26800	372	4	0	131985	\N
26802	60	3	0	131623	\N
26802	3585	4	0	131994	\N
26805	7412	4	0	132015	\N
26805	7426	5	0	132016	\N
26808	202	3	0	132051	\N
26808	4857	4	0	132052	\N
26813	7412	7	0	132073	\N
26813	7528	8	0	132074	\N
26825	123	4	0	132155	\N
26825	4090	5	0	132156	\N
26829	2351	3	0	132171	\N
26829	2845	4	0	132172	\N
26832	365	3	0	132190	\N
26832	3839	4	0	132191	\N
26834	75	2	0	127688	\N
26834	284	3	0	132194	\N
26837	192	3	0	132230	\N
26837	3790	4	0	132231	\N
26839	40	4	0	132240	\N
26839	3381	5	0	132241	\N
26844	4178	4	0	132268	\N
26844	4205	5	0	132269	\N
26845	94	13	0	132296	\N
26845	7008	14	0	132297	\N
26848	262	3	0	129343	\N
26848	4778	4	0	129344	\N
26852	119	3	0	123796	\N
26852	2860	4	0	123797	\N
26855	3628	3	0	132360	\N
26855	3785	4	0	132361	\N
26857	173	10	0	132425	\N
26857	7602	11	0	132426	\N
26864	14	7	0	132482	\N
26864	3882	8	0	132483	\N
26866	4172	3	0	132464	\N
26866	4275	4	0	132465	\N
26868	260	3	0	126666	\N
26868	3399	4	0	132506	\N
26869	164	3	0	132507	\N
26869	3385	4	0	132508	\N
26871	202	3	0	132051	\N
26871	4857	4	0	132052	\N
26875	64	3	0	132534	\N
26875	4217	4	0	132535	\N
26877	595	3	0	130908	\N
26877	3654	4	0	131957	\N
26880	597	3	0	125253	\N
26880	3656	4	0	125254	\N
26881	88	3	0	132545	\N
26598	7225	6	0	130619	\N
26598	7379	7	0	130620	\N
26603	4178	3	0	130650	\N
26603	4211	4	0	130651	\N
26606	42	3	0	128783	\N
26606	3645	4	0	130685	\N
26609	4178	3	0	130699	\N
26609	4211	4	0	130700	\N
26613	96	2	0	130722	\N
26613	2942	3	0	130723	\N
26614	5885	8	0	121991	\N
26614	7539	9	0	130740	\N
26617	6303	8	0	130743	\N
26617	7541	9	0	130744	\N
26626	2636	3	0	130822	\N
26626	2837	4	0	130823	\N
26631	4178	4	0	130861	\N
26631	4205	5	0	130862	\N
26633	2	3	0	130870	\N
26633	3548	4	0	130871	\N
26636	4178	4	0	130861	\N
26636	4205	5	0	130862	\N
26641	597	9	0	125253	\N
26641	7551	10	0	130911	\N
26648	170	4	0	130948	\N
26648	4680	5	0	130949	\N
26652	71	3	0	129220	\N
26652	3770	4	0	131039	\N
26659	228	2	0	120984	\N
26659	4776	3	0	131069	\N
26662	852	8	0	128775	\N
26662	7557	9	0	131088	\N
26669	7562	2	0	131121	\N
26669	3628	8	0	131122	\N
26669	7563	9	0	131123	\N
26677	100	3	0	127907	\N
26677	3836	4	0	131169	\N
26680	4172	7	0	130701	\N
26680	4614	8	0	131192	\N
26683	4172	9	0	131220	\N
26683	4977	10	0	131221	\N
26685	1470	8	0	131238	\N
26685	3813	9	0	131239	\N
26687	82	8	0	131242	\N
26687	7567	9	0	131243	\N
26690	1470	10	0	131238	\N
26690	3375	11	0	131272	\N
26705	142	11	0	131376	\N
26705	7570	12	1	131377	\N
26705	7569	12	0	131378	\N
26705	7572	13	1	131379	\N
26705	7571	13	0	131380	\N
26710	6044	3	0	131273	\N
26710	6045	4	0	131436	\N
26713	4178	6	0	131320	\N
26713	4250	7	0	131464	\N
26715	149	4	0	131475	\N
26715	4040	5	0	131476	\N
26720	449	3	0	131097	\N
26720	4760	4	0	131098	\N
26722	4178	4	0	131320	\N
26722	4205	5	0	131504	\N
26725	94	4	0	131531	\N
26725	4677	5	0	131532	\N
26731	2782	3	0	131567	\N
26731	3659	4	0	131568	\N
26734	40	5	0	131582	\N
26734	3999	6	0	131583	\N
26736	4172	6	0	131605	\N
26736	4197	7	0	131606	\N
26739	60	4	0	131623	\N
26739	3894	5	0	131624	\N
26741	835	4	0	131627	\N
26741	7016	5	0	131628	\N
26749	852	3	0	128775	\N
26749	3612	4	0	128776	\N
26751	6765	3	0	127302	\N
26751	6884	4	0	129771	\N
26754	2	15	0	130565	\N
26754	2858	16	0	131673	\N
26765	108	7	0	131735	\N
26765	7583	8	0	131739	\N
26771	4178	20	0	131812	\N
26771	5874	21	0	131813	\N
26774	189	6	0	129615	\N
26774	3713	7	0	131828	\N
26785	4178	3	0	131903	\N
26785	4211	4	0	131904	\N
26790	7591	3	0	131926	\N
26790	7592	4	0	131927	\N
26792	2782	10	0	131567	\N
26792	7593	11	0	131950	\N
26799	449	4	0	131097	\N
26799	5343	5	0	131977	\N
26807	4178	3	0	131928	\N
26807	4211	4	0	131929	\N
26811	4172	3	0	131924	\N
26811	4275	4	0	131925	\N
26815	4201	1	0	132105	\N
26815	4172	5	0	132112	\N
26815	4940	6	0	132113	\N
26817	360	3	0	128708	\N
26817	3602	4	0	132122	\N
26819	431	4	0	132132	\N
26819	3565	5	0	132133	\N
26827	54	4	0	131664	\N
26827	3685	5	0	132158	\N
26828	4178	2	0	132163	\N
26828	4247	3	0	132164	\N
26831	4178	4	0	132182	\N
26831	4205	5	0	132183	\N
26836	62	3	0	129429	\N
26836	3344	4	0	132223	\N
26843	4178	3	0	132258	\N
26843	4211	4	0	132259	\N
26847	4178	7	0	132318	\N
26847	4396	8	0	132319	\N
26849	7598	3	0	132326	\N
26849	3631	4	0	132327	\N
26854	4178	3	0	132358	\N
26854	4211	4	0	132359	\N
26856	7601	112	0	132392	\N
26856	56	126	0	132403	\N
26856	3127	127	0	132404	\N
26858	40	3	0	132433	\N
26858	372	4	0	132434	\N
26861	7603	79	0	132439	\N
26861	4233	126	0	132462	\N
26861	6719	127	0	132463	\N
26865	42	7	0	131054	\N
26865	6853	8	0	132484	\N
26867	911	4	0	8397	\N
26867	7604	5	0	132499	\N
26874	1109	5	0	126899	\N
26874	6783	6	0	132527	\N
26876	7412	3	0	132073	\N
26876	7466	4	0	132536	\N
26883	151	10	0	132606	\N
26883	7606	11	0	132607	\N
26890	4172	3	0	132637	\N
26890	4275	4	0	132638	\N
26894	7610	16	0	132661	\N
26894	56	31	0	132674	\N
26894	3108	32	1	132675	\N
26894	7611	32	0	132676	\N
26897	264	7	0	128127	\N
26897	7459	8	0	128128	\N
26900	4178	11	0	132734	\N
26900	7472	12	0	132735	\N
26901	12	6	0	132748	\N
26901	6895	7	0	132749	\N
26902	411	3	0	132756	\N
26902	3596	4	0	132757	\N
26907	96	6	0	132783	\N
26907	5078	7	0	132784	\N
26911	4178	3	0	132795	\N
26911	4211	4	0	132796	\N
26604	6447	11	0	130672	\N
26610	4172	3	0	130701	\N
26610	4275	4	0	130702	\N
26615	4178	8	0	130699	\N
26615	6776	9	0	130741	\N
26618	268	8	0	130101	\N
26618	7542	9	0	130745	\N
26624	18	3	0	130334	\N
26624	3621	4	0	130335	\N
26627	69	7	0	130838	\N
26627	3711	8	0	130839	\N
26632	40	4	0	130567	\N
26632	3381	5	0	130863	\N
26634	1470	2	0	126660	\N
26634	7549	3	0	130876	\N
26639	595	9	0	130908	\N
26639	7550	10	0	130909	\N
26642	6450	9	0	125868	\N
26642	7552	10	0	130912	\N
26643	6	4	0	130921	\N
26643	7553	5	0	130922	\N
26646	88	4	0	130936	\N
26646	7554	5	0	130938	\N
26650	4178	3	0	130956	\N
26650	4211	4	0	130957	\N
26653	6303	3	0	131040	\N
26653	6304	4	0	131041	\N
26657	94	3	0	129598	\N
26657	2864	4	0	131062	\N
26664	449	3	0	131097	\N
26664	4760	4	0	131098	\N
26667	812	2	0	131103	\N
26667	202	8	0	131114	\N
26667	7560	9	0	131117	\N
26670	7564	2	0	131124	\N
26670	3625	8	0	131125	\N
26670	7565	9	0	131126	\N
26671	7412	3	0	130842	\N
26671	7466	4	0	131133	\N
26673	6044	4	0	131150	\N
26673	6524	5	0	131151	\N
26678	1470	3	0	131176	\N
26678	3838	4	0	131177	\N
26686	69	8	0	131240	\N
26686	7566	9	0	131241	\N
26688	40	3	0	131250	\N
26688	372	4	0	131251	\N
26691	6044	10	0	131273	\N
26691	7118	11	0	131274	\N
26695	7412	3	0	131291	\N
26695	7466	4	0	131292	\N
26700	4178	3	0	131320	\N
26700	4211	4	0	131321	\N
26706	7573	38	0	131381	\N
26706	142	126	0	131382	\N
26706	7574	127	0	131383	\N
26708	38	7	0	131399	\N
26708	5071	8	0	131400	\N
26714	44	6	0	131465	\N
26714	5989	7	0	131466	\N
26718	44	3	0	131487	\N
26718	3631	4	0	131488	\N
26726	4178	3	0	131539	\N
26726	4211	4	0	131540	\N
26730	202	3	0	131565	\N
26730	4857	4	0	131566	\N
26735	4172	4	0	131220	\N
26735	4219	5	0	131592	\N
26743	60	4	0	131623	\N
26743	3894	5	0	131624	\N
26745	7412	7	0	131485	\N
26745	7528	8	0	131639	\N
26747	54	18	0	131656	\N
26747	7580	19	0	131657	\N
26756	2	12	0	130870	\N
26756	2830	13	0	131683	\N
26758	90	6	0	131697	\N
26758	7581	7	0	131698	\N
26762	4178	3	0	131569	\N
26762	4211	4	0	131570	\N
26766	96	10	0	131740	\N
26766	6633	11	0	131741	\N
26767	320	10	0	130105	\N
26767	7584	11	0	131742	\N
26772	69	6	0	131240	\N
26772	4084	7	0	131826	\N
26776	7515	56	0	131832	\N
26776	189	126	0	131833	\N
26776	850	127	0	131834	\N
26778	4178	3	0	131812	\N
26778	4211	4	0	131851	\N
26779	5534	4	0	131860	\N
26779	4172	13	0	131877	\N
26779	7589	14	0	131878	\N
26781	132	3	0	131887	\N
26781	3729	4	0	131888	\N
26783	4233	3	0	131555	\N
26783	4425	4	0	131897	\N
26784	1858	19	0	125017	\N
26784	7590	20	0	131902	\N
26791	4178	3	0	131928	\N
26791	4211	4	0	131929	\N
26795	597	3	0	125253	\N
26795	3656	4	0	125254	\N
26796	92	3	0	131959	\N
26796	4410	4	0	131960	\N
26797	322	2	0	131965	\N
26797	1866	3	0	131966	\N
26804	14	4	0	132005	\N
26804	3498	5	0	132006	\N
26810	4178	3	0	132055	\N
26810	4211	4	0	132056	\N
26812	142	7	0	132071	\N
26812	6504	8	0	132072	\N
26816	4450	1	0	132114	\N
26816	4178	5	0	132115	\N
26816	4941	6	0	132116	\N
26818	360	4	0	128708	\N
26818	4330	5	0	132125	\N
26820	3767	4	0	50619	\N
26820	7595	5	0	132134	\N
26822	2	3	0	131699	\N
26822	3548	4	0	132142	\N
26824	40	4	0	131984	\N
26824	3381	5	0	132154	\N
26841	449	3	0	132249	\N
26841	4760	4	0	132250	\N
26850	4431	3	0	132334	\N
26850	2578	4	0	132335	\N
26853	3625	3	0	122694	\N
26853	3784	4	0	123793	\N
26860	4178	3	0	132358	\N
26860	4211	4	0	132359	\N
26872	156	3	0	130240	\N
26872	4594	4	0	132515	\N
26873	793	3	0	132516	\N
26873	2644	4	0	132517	\N
26878	6450	3	0	125868	\N
26878	6847	4	0	131958	\N
26882	56	94	0	132584	\N
26882	7605	95	0	132585	\N
26885	14	3	0	132614	\N
26885	4272	4	0	132615	\N
26888	7607	4	0	132627	\N
26888	7608	5	0	132628	\N
26889	391	3	0	132635	\N
26889	3660	4	0	132636	\N
26893	431	4	0	132656	\N
26893	7609	5	0	132657	\N
26899	186	11	0	130457	\N
26899	7614	12	0	132733	\N
26906	58	6	0	123618	\N
26906	3575	7	0	132782	\N
26910	233	3	0	132793	\N
26910	3704	4	0	132794	\N
26914	326	3	0	132813	\N
26914	3339	4	0	132814	\N
26645	88	6	0	130936	\N
26645	5263	7	0	130937	\N
26647	186	4	0	130457	\N
26647	4733	5	0	130947	\N
26649	23	4	0	127944	\N
26649	3189	5	0	127945	\N
26654	4178	3	0	131042	\N
26654	4211	4	0	131043	\N
26656	42	4	0	131054	\N
26656	3896	5	0	131055	\N
26658	228	3	0	120984	\N
26658	3186	4	0	120985	\N
26661	7412	8	0	130842	\N
26661	7556	9	0	131087	\N
26663	4178	3	0	131095	\N
26663	4211	4	0	131096	\N
26666	812	2	0	131103	\N
26666	202	8	0	131114	\N
26666	7560	9	0	131117	\N
26672	69	3	0	131140	\N
26672	4536	4	0	131141	\N
26675	4172	4	0	130701	\N
26675	4219	5	0	131154	\N
26682	424	9	0	130888	\N
26682	7366	10	0	131219	\N
26692	7412	10	0	131275	\N
26692	7568	11	0	131276	\N
26694	2	4	0	131152	\N
26694	3510	5	0	131153	\N
26697	262	4	0	129343	\N
26697	4607	5	0	131303	\N
26699	324	3	0	131312	\N
26699	4514	4	0	131313	\N
26702	288	3	0	130184	\N
26702	3003	4	0	131324	\N
26704	4737	6	0	131353	\N
26704	149	7	0	131354	\N
26707	142	11	0	131376	\N
26707	7575	12	0	131384	\N
26712	6303	7	0	131040	\N
26712	7578	8	0	131451	\N
26717	7412	3	0	131485	\N
26717	7466	4	0	131486	\N
26719	244	3	0	124930	\N
26719	4075	4	0	124931	\N
26721	244	2	0	124930	\N
26721	3308	3	0	131495	\N
26724	4178	8	0	131521	\N
26724	4237	9	0	131522	\N
26727	4233	7	0	131555	\N
26727	5582	8	0	131556	\N
26732	4178	3	0	131569	\N
26732	4211	4	0	131570	\N
26733	4178	5	0	131569	\N
26733	4202	6	0	131581	\N
26738	164	0	0	130697	\N
26744	4172	7	0	131637	\N
26744	4614	8	0	131638	\N
26753	2	15	0	129232	\N
26753	2858	16	0	130312	\N
26757	2	5	0	131152	\N
26757	3029	6	0	131684	\N
26760	88	6	0	130936	\N
26760	5263	7	0	130937	\N
26761	2	0	0	131699	\N
26764	108	10	0	131735	\N
26764	7582	11	0	131736	\N
26769	228	6	0	131769	\N
26769	7585	7	0	131770	\N
26773	1163	6	0	101010	\N
26773	7587	7	0	131827	\N
26775	7588	85	0	131829	\N
26775	189	126	0	131830	\N
26775	1755	127	0	131831	\N
26777	1636	4	0	131843	\N
26777	4118	5	0	131844	\N
26780	75	3	0	127688	\N
26780	3139	4	0	131880	\N
26787	212	4	0	129769	\N
26787	3732	5	0	131915	\N
26789	4172	3	0	131924	\N
26789	4275	4	0	131925	\N
26794	6450	3	0	125868	\N
26794	6847	4	0	131958	\N
26798	852	2	0	131967	\N
26798	2872	3	0	131968	\N
26801	2351	3	0	131986	\N
26801	2845	4	0	131987	\N
26803	140	3	0	131995	\N
26803	4149	4	0	131996	\N
26806	60	10	0	132037	\N
26806	7594	11	0	132038	\N
26809	2636	3	0	132053	\N
26809	2837	4	0	132054	\N
26814	4172	13	0	132101	\N
26814	5454	14	0	132102	\N
26821	3767	69	0	50619	\N
26821	7596	70	0	132135	\N
26823	54	3	0	132144	\N
26823	3041	4	0	132145	\N
26826	6723	4	0	124369	\N
26826	6739	5	0	132157	\N
26830	7412	4	0	132073	\N
26830	7499	5	0	132181	\N
26833	316	3	0	132192	\N
26833	4249	4	0	132193	\N
26835	6303	10	0	132215	\N
26835	7597	11	0	132216	\N
26838	40	3	0	131984	\N
26838	372	4	0	131985	\N
26840	4172	4	0	132242	\N
26840	4219	5	0	132113	\N
26842	40	3	0	132240	\N
26842	372	4	0	132257	\N
26846	908	2	0	132302	\N
26846	2832	3	0	132303	\N
26851	40	7	0	132240	\N
26859	4233	3	0	131555	\N
26859	4425	4	0	131897	\N
26862	4172	3	0	132464	\N
26862	4275	4	0	132465	\N
26863	336	7	0	132480	\N
26863	3690	8	0	132481	\N
26870	40	3	0	132433	\N
26870	372	4	0	132434	\N
26879	391	3	0	132543	\N
26879	3660	4	0	132544	\N
26886	260	4	0	132624	\N
26886	3728	5	0	132625	\N
26891	4178	3	0	132645	\N
26891	4211	4	0	132646	\N
26903	320	3	0	130105	\N
26903	4821	4	0	130106	\N
26908	38	3	0	132791	\N
26908	3457	4	0	132792	\N
26912	110	3	0	132803	\N
26912	2995	4	0	132804	\N
26917	44	3	0	132827	\N
26917	3631	4	0	132828	\N
26925	4172	3	0	132902	\N
26925	4275	4	0	132903	\N
26930	6015	8	0	132939	\N
26930	18	10	0	132940	\N
26930	1426	11	0	132941	\N
26933	233	6	0	132793	\N
26933	4245	7	0	132958	\N
26935	4787	3	0	127601	\N
26935	4788	4	0	127602	\N
26940	4178	3	0	132910	\N
26940	4211	4	0	132911	\N
26948	6723	3	0	124369	\N
26948	6724	4	0	133060	\N
26950	40	3	0	133068	\N
26950	372	4	0	133069	\N
26956	71	4	0	129220	\N
26881	3655	4	0	132546	\N
26884	40	3	0	132433	\N
26884	372	4	0	132434	\N
26887	4178	4	0	132358	\N
26887	4205	5	0	132626	\N
26892	102	4	0	128483	\N
26892	3572	5	0	132655	\N
26895	6965	9	0	132691	\N
26895	273	10	0	132692	\N
26896	7612	9	0	132693	\N
26896	23	10	0	132694	\N
26898	77	11	0	132731	\N
26898	7613	12	0	132732	\N
26904	4172	3	0	132637	\N
26904	4275	4	0	132638	\N
26905	210	3	0	130806	\N
26905	3539	4	0	130807	\N
26909	4088	3	0	124814	\N
26909	4506	4	0	124815	\N
26913	115	3	0	132811	\N
26913	3483	4	0	132812	\N
26915	33	2	0	126662	\N
26915	2822	3	0	126663	\N
26918	14	6	0	132614	\N
26918	6277	7	0	132841	\N
26923	4178	3	0	132892	\N
26923	4211	4	0	132893	\N
26931	40	6	0	132954	\N
26931	4255	7	0	132955	\N
26938	4	3	0	132825	\N
26938	3837	4	0	132826	\N
26944	4233	3	0	133043	\N
26944	4425	4	0	133044	\N
26946	1099	3	0	10970	\N
26946	7348	4	0	124557	\N
26949	123	3	0	132155	\N
26949	2856	4	0	133061	\N
26951	156	3	0	130240	\N
26951	4594	4	0	132515	\N
26952	7412	3	0	133070	\N
26952	7466	4	0	133071	\N
26953	40	4	0	133068	\N
26953	3381	5	0	133080	\N
26962	38	5	0	132791	\N
26962	5398	6	0	133129	\N
26965	7412	3	0	133070	\N
26965	7466	4	0	133071	\N
26968	212	3	0	129769	\N
26968	3639	4	0	129770	\N
26969	6765	3	0	133154	\N
26969	6884	4	0	133155	\N
26973	3628	3	0	132360	\N
26973	3785	4	0	132361	\N
26975	3652	3	0	133198	\N
26975	79	4	0	133201	\N
26983	132	6	0	131887	\N
26983	4690	7	0	133263	\N
26988	6	3	0	133292	\N
26988	4823	4	0	133293	\N
26991	595	3	0	130908	\N
26991	3654	4	0	131957	\N
26993	4178	3	0	133320	\N
26993	4211	4	0	133321	\N
26995	4178	3	0	133320	\N
26995	4211	4	0	133321	\N
26996	60	8	0	133346	\N
26996	7625	9	0	133347	\N
26998	102	3	0	133355	\N
26998	3597	4	0	133356	\N
27003	365	3	0	133381	\N
27003	3839	4	0	133382	\N
27006	268	6	0	130101	\N
27006	4801	7	0	133399	\N
27010	121	1	0	133411	\N
27010	3098	2	0	133412	\N
27012	4172	6	0	133152	\N
27012	4197	7	0	133426	\N
27015	913	1	0	133437	\N
27015	852	4	0	133438	\N
27015	4236	5	0	133207	\N
27017	4172	2	0	133443	\N
27017	4191	3	0	133444	\N
27019	142	2	0	133453	\N
27019	4418	3	0	133454	\N
27024	2636	3	0	132053	\N
27024	2837	4	0	132054	\N
27026	88	2	0	132545	\N
27026	3010	3	0	133476	\N
27028	137	4	0	130171	\N
27028	4352	5	0	133510	\N
27030	7629	33	0	133525	\N
27030	3265	34	0	133199	\N
27030	7630	34	0	133526	\N
27033	264	3	0	133534	\N
27033	3632	4	0	133535	\N
27034	262	2	0	133530	\N
27034	2743	3	0	133537	\N
27036	793	4	0	133548	\N
27036	3618	5	0	133549	\N
27038	6723	5	0	133562	\N
27038	7631	6	0	133563	\N
27039	6146	4	0	96042	\N
27039	7632	5	0	133564	\N
27043	7412	5	0	133573	\N
27043	7519	6	0	133574	\N
27056	4178	6	0	133656	\N
27056	4250	7	0	133657	\N
27059	67	3	0	133666	\N
27059	3749	4	0	133667	\N
27084	391	6	0	133898	\N
27084	3521	7	0	133899	\N
27088	279	6	0	130616	\N
27088	5117	7	0	130617	\N
27097	200	0	0	133820	\N
27100	488	6	0	133962	\N
27100	7325	7	0	133963	\N
27103	77	6	0	132731	\N
27103	6600	7	0	133992	\N
27110	7651	58	0	134025	\N
27110	1021	126	0	134057	\N
27110	7652	127	0	134058	\N
27112	206	2	0	134065	\N
27112	2773	3	0	134066	\N
27117	170	3	0	134089	\N
27117	4148	4	0	134002	\N
27119	2782	3	0	134104	\N
27119	3659	4	0	134105	\N
27120	262	3	0	134106	\N
27120	4778	4	0	134107	\N
27122	4178	5	0	134131	\N
27122	4202	6	0	134132	\N
27125	58	3	0	133978	\N
27125	3665	4	0	134146	\N
27127	210	3	0	134161	\N
27127	3539	4	0	134162	\N
27130	4178	9	0	134169	\N
27130	4682	10	0	134190	\N
27133	1109	3	0	134198	\N
27133	3495	4	0	134199	\N
27139	4178	3	0	134218	\N
27139	4211	4	0	134219	\N
27142	123	3	0	132155	\N
27142	2856	4	0	133061	\N
27144	734	8	0	134245	\N
27144	7656	9	0	134246	\N
27146	1599	3	0	19943	\N
27146	7657	4	0	134254	\N
27149	1427	1	0	134259	\N
27149	75	5	0	129877	\N
27149	4098	8	0	134270	\N
27161	121	3	0	133411	\N
27161	4471	4	0	133413	\N
27162	149	3	0	134360	\N
27149	7658	6	1	138723	\N
27149	7659	7	0	138724	\N
26916	4	3	0	132825	\N
26916	3837	4	0	132826	\N
26919	4178	6	0	132795	\N
26919	4250	7	0	132854	\N
26921	73	3	0	130346	\N
26921	3040	4	0	132883	\N
26922	4178	3	0	132884	\N
26922	4211	4	0	132885	\N
26926	365	3	0	132190	\N
26926	3839	4	0	132191	\N
26928	4172	3	0	132902	\N
26928	4275	4	0	132903	\N
26929	7616	8	0	132934	\N
26929	92	10	0	132937	\N
26929	1078	11	0	132938	\N
26936	40	3	0	132954	\N
26936	372	4	0	132973	\N
26941	453	9	0	133008	\N
26941	7617	10	0	133009	\N
26942	4178	9	0	132910	\N
26942	4682	10	0	133010	\N
26954	79	4	0	133081	\N
26954	3678	5	0	133082	\N
26960	262	7	0	133115	\N
26960	4093	8	0	133116	\N
26963	181	5	0	133130	\N
26963	7620	6	0	133131	\N
26971	3625	3	0	133190	\N
26971	3784	4	0	133191	\N
26976	4189	3	0	133202	\N
26976	149	4	0	133203	\N
26978	3612	3	0	133206	\N
26978	852	4	0	133207	\N
26980	189	2	0	133214	\N
26980	3143	3	0	133215	\N
26986	4178	3	0	133100	\N
26986	4211	4	0	133279	\N
26989	33	6	0	133306	\N
26989	7330	7	0	133307	\N
26992	6450	3	0	125868	\N
26992	6847	4	0	131958	\N
26994	20	3	0	133322	\N
26994	2844	4	0	133323	\N
26997	288	8	0	130184	\N
26997	7626	9	0	133348	\N
26999	449	3	0	133357	\N
26999	4760	4	0	133358	\N
27001	244	2	0	133365	\N
27001	3308	3	0	133366	\N
27004	79	3	0	133383	\N
27004	3652	4	0	133384	\N
27007	841	6	0	133400	\N
27007	3769	7	0	133401	\N
27013	103	1	0	133429	\N
27013	102	4	0	133434	\N
27013	3574	5	0	133356	\N
27020	142	3	0	133453	\N
27020	4254	4	0	133455	\N
27022	4172	3	0	133456	\N
27022	4275	4	0	133457	\N
27040	123	5	0	132155	\N
27040	6652	6	0	133565	\N
27047	75	6	0	127688	\N
27047	4694	7	0	133597	\N
27052	189	1	0	133624	\N
27052	7294	2	0	133625	\N
27054	360	8	0	133626	\N
27054	6575	9	0	133641	\N
27055	241	8	0	133642	\N
27055	4832	9	0	133643	\N
27057	12	6	0	133612	\N
27057	6895	7	0	133613	\N
27062	273	8	0	133704	\N
27062	7638	9	0	133705	\N
27067	213	1	0	133732	\N
27067	212	7	0	133733	\N
27067	6675	8	0	133734	\N
27069	7643	101	0	133773	\N
27069	212	126	0	133788	\N
27069	3108	127	1	133789	\N
27069	7644	127	0	133790	\N
27074	4172	3	0	133622	\N
27074	4275	4	0	133623	\N
27076	230	5	0	131913	\N
27076	7647	6	0	133832	\N
27079	71	3	0	129220	\N
27079	3770	4	0	131039	\N
27081	18	3	0	132959	\N
27081	3621	4	0	133856	\N
27085	453	6	0	133900	\N
27085	4091	7	0	133901	\N
27091	18	3	0	133917	\N
27091	3621	4	0	133918	\N
27094	88	3	0	133946	\N
27094	3655	4	0	133947	\N
27098	200	0	0	133820	\N
27101	4178	6	0	133976	\N
27101	4250	7	0	133977	\N
27104	4211	3	0	133999	\N
27104	4178	4	0	134000	\N
27106	4148	3	0	134001	\N
27106	170	4	0	134002	\N
27108	411	3	0	134011	\N
27108	3596	4	0	134012	\N
27115	224	4	0	129297	\N
27115	3281	5	0	134081	\N
27123	4172	5	0	133839	\N
27123	4634	6	0	134133	\N
27128	4178	3	0	134169	\N
27128	4211	4	0	134170	\N
27131	142	9	0	133948	\N
27131	7653	10	0	134191	\N
27134	1109	2	0	134198	\N
27134	7654	3	0	134200	\N
27135	18	3	0	134201	\N
27135	3621	4	0	134202	\N
27140	360	3	0	134220	\N
27140	3602	4	0	134221	\N
27145	18	8	0	134201	\N
27145	6015	9	0	134247	\N
27147	202	3	0	132051	\N
27147	4857	4	0	132052	\N
27150	7660	62	0	134271	\N
27150	251	126	0	134272	\N
27150	7661	127	0	134273	\N
27152	7662	1	0	134282	\N
27152	5399	13	0	134296	\N
27152	7663	14	0	134297	\N
27153	4450	1	0	134298	\N
27153	4178	13	0	134299	\N
27153	7664	14	0	134300	\N
27159	79	3	0	133383	\N
27159	3652	4	0	133384	\N
27164	367	6	0	134369	\N
27164	7665	7	0	134370	\N
27167	1109	3	0	134198	\N
27167	3495	4	0	134199	\N
27169	288	5	0	130184	\N
27169	2224	6	0	130185	\N
27171	121	3	0	133411	\N
27171	4471	4	0	133413	\N
27174	4178	3	0	134424	\N
27174	4211	4	0	134425	\N
27177	40	6	0	134326	\N
27177	4255	7	0	134327	\N
27183	4201	1	0	134496	\N
27183	4172	7	0	134497	\N
27183	7667	8	1	134498	\N
27183	7666	8	0	134499	\N
27187	40	3	0	134516	\N
27187	372	4	0	134517	\N
27188	170	3	0	134518	\N
27188	4148	4	0	134519	\N
27189	320	2	0	134520	\N
27189	4528	3	0	134521	\N
27191	108	3	0	131735	\N
27191	4171	4	0	134529	\N
26920	56	71	0	132875	\N
26920	7615	72	0	132876	\N
26924	86	3	0	132900	\N
26924	3746	4	0	132901	\N
26927	4178	3	0	132910	\N
26927	4211	4	0	132911	\N
26932	4088	6	0	132956	\N
26932	4246	7	0	132957	\N
26934	18	6	0	132959	\N
26934	4180	7	0	132960	\N
26937	6303	3	0	132980	\N
26937	6304	4	0	132981	\N
26939	908	3	0	132988	\N
26939	3591	4	0	132989	\N
26943	4178	13	0	132910	\N
26943	4782	14	0	133036	\N
26945	121	3	0	133045	\N
26945	4471	4	0	133046	\N
26947	149	3	0	131475	\N
26947	4189	4	0	133053	\N
26955	62	4	0	133083	\N
26955	4059	5	0	133084	\N
26958	167	3	0	133093	\N
26958	4028	4	0	133094	\N
26961	285	7	0	133117	\N
26961	7619	8	0	133118	\N
26966	391	3	0	133150	\N
26966	3660	4	0	133151	\N
26972	119	3	0	123796	\N
26972	2860	4	0	123797	\N
26974	3652	3	0	133198	\N
26974	3265	4	0	133199	\N
26974	7623	4	0	133200	\N
26977	4594	3	0	133204	\N
26977	156	4	0	133205	\N
26981	453	7	0	133230	\N
26981	5832	8	0	133231	\N
26984	92	3	0	133270	\N
26984	4410	4	0	133271	\N
26985	92	2	0	133270	\N
26985	3060	3	0	133272	\N
27008	5885	6	0	121991	\N
27008	5997	7	0	133402	\N
27011	121	3	0	133411	\N
27011	4471	4	0	133413	\N
27014	193	1	0	133435	\N
27014	192	4	0	133436	\N
27014	2193	5	0	132231	\N
27018	4178	3	0	133451	\N
27018	4211	4	0	133452	\N
27021	4172	3	0	133456	\N
27021	4275	4	0	133457	\N
27025	88	3	0	132545	\N
27025	3655	4	0	132546	\N
27027	7627	58	0	133477	\N
27027	1021	126	0	133502	\N
27027	7628	127	0	133503	\N
27029	135	4	0	117021	\N
27029	4353	5	0	133511	\N
27031	262	3	0	133530	\N
27031	4778	4	0	133531	\N
27035	40	4	0	133546	\N
27035	3381	5	0	133547	\N
27037	793	3	0	133548	\N
27037	2644	4	0	133551	\N
27045	367	3	0	133575	\N
27045	3683	4	0	133583	\N
27048	2636	6	0	133610	\N
27048	5080	7	0	133611	\N
27050	40	3	0	133620	\N
27050	372	4	0	133621	\N
27060	170	3	0	130948	\N
27060	4148	4	0	133674	\N
27065	7639	1	0	133716	\N
27065	7640	2	0	133717	\N
27065	7641	2	0	133718	\N
27066	153	1	0	133719	\N
27066	145	7	0	133730	\N
27066	4391	8	0	133731	\N
27070	4787	6	0	133803	\N
27070	5075	7	0	133804	\N
27072	7645	2	0	133809	\N
27072	7646	2	0	133810	\N
27072	2743	3	0	133811	\N
27075	200	3	0	133820	\N
27075	3338	4	0	133821	\N
27077	4172	3	0	133839	\N
27077	4275	4	0	133840	\N
27086	208	6	0	116810	\N
27086	5118	7	0	125361	\N
27089	391	3	0	133908	\N
27089	3660	4	0	133909	\N
27095	142	3	0	133948	\N
27095	4254	4	0	133949	\N
27102	58	6	0	133978	\N
27102	3575	7	0	133979	\N
27107	4148	3	0	134001	\N
27107	7649	4	0	134003	\N
27107	7650	4	0	134004	\N
27111	86	2	0	134063	\N
27111	3321	3	0	134064	\N
27113	40	3	0	133620	\N
27113	372	4	0	133621	\N
27118	4178	3	0	134096	\N
27118	4211	4	0	134097	\N
27126	326	3	0	134153	\N
27126	3339	4	0	134154	\N
27129	285	3	0	133117	\N
27129	4496	4	0	134171	\N
27136	4172	3	0	133839	\N
27136	4275	4	0	133840	\N
27138	6751	0	0	130542	\N
27138	7655	0	0	134211	\N
27148	7412	3	0	134255	\N
27148	7466	4	0	134256	\N
27157	4178	6	0	134324	\N
27157	4250	7	0	134325	\N
27160	4172	9	0	134352	\N
27160	4977	10	0	134353	\N
27165	367	3	0	134377	\N
27165	3683	4	0	134378	\N
27170	6	5	0	134397	\N
27170	2852	6	0	134398	\N
27172	453	3	0	133900	\N
27172	2838	4	0	134411	\N
27175	82	3	0	134432	\N
27175	4505	4	0	134433	\N
27178	4172	6	0	134466	\N
27178	4197	7	0	134467	\N
27180	7660	62	0	134470	\N
27180	251	126	0	134471	\N
27180	7661	127	0	134472	\N
27184	81	1	0	134483	\N
27184	79	7	0	134494	\N
27184	5993	8	0	134495	\N
27185	40	3	0	134506	\N
27185	372	4	0	134507	\N
27192	12	3	0	133612	\N
27192	4204	4	0	134530	\N
27193	4233	6	0	134543	\N
27193	6364	7	0	134544	\N
27196	18	6	0	134201	\N
27196	4180	7	0	134609	\N
27197	4178	3	0	134616	\N
27197	4211	4	0	134617	\N
27199	244	5	0	133365	\N
27199	7670	6	0	134630	\N
27201	244	2	0	133365	\N
27201	7671	3	0	134633	\N
27204	88	7	0	134657	\N
27204	4949	8	0	134658	\N
27216	7675	36	0	134758	\N
27216	173	70	0	134778	\N
27216	7676	71	1	134779	\N
27216	2435	71	0	134780	\N
27221	4505	3	0	134804	\N
27221	82	4	0	134805	\N
26956	3887	5	0	133085	\N
26957	62	3	0	133083	\N
26957	7618	4	0	133086	\N
26959	4178	16	0	133100	\N
26959	4708	17	0	133101	\N
26964	4233	3	0	133043	\N
26964	4425	4	0	133044	\N
26967	4172	3	0	133152	\N
26967	4275	4	0	133153	\N
26970	7621	101	0	133170	\N
26970	212	126	0	133181	\N
26970	1075	127	1	133182	\N
26970	7622	127	0	133183	\N
26979	1103	3	0	133208	\N
26979	488	4	0	133209	\N
26982	64	9	0	132534	\N
26982	7624	10	0	133250	\N
26987	2351	2	0	133284	\N
26987	4711	3	0	133285	\N
26990	597	3	0	125253	\N
26990	3656	4	0	125254	\N
27000	113	2	0	133363	\N
27000	1899	3	0	133364	\N
27002	40	4	0	133068	\N
27002	3381	5	0	133080	\N
27005	4178	6	0	133397	\N
27005	4250	7	0	133398	\N
27009	4178	3	0	133397	\N
27009	4211	4	0	133409	\N
27016	103	1	0	133429	\N
27016	102	4	0	133434	\N
27016	3574	5	0	133356	\N
27023	198	3	0	129872	\N
27023	4263	4	0	129873	\N
27032	2	3	0	133532	\N
27032	3548	4	0	133533	\N
27041	7633	38	0	133566	\N
27041	56	41	0	133567	\N
27041	973	42	1	133568	\N
27041	6025	42	0	133569	\N
27041	7634	43	1	133570	\N
27041	7250	43	0	133571	\N
27042	6146	5	0	96042	\N
27042	7635	6	0	133572	\N
27044	367	14	0	133575	\N
27044	7636	15	0	133576	\N
27046	4178	6	0	133451	\N
27046	4250	7	0	133596	\N
27049	12	6	0	133612	\N
27049	6895	7	0	133613	\N
27051	4172	3	0	133622	\N
27051	4275	4	0	133623	\N
27053	360	17	0	133626	\N
27053	7637	18	0	133627	\N
27058	33	3	0	133664	\N
27058	3342	4	0	133665	\N
27061	35	6	0	133687	\N
27061	5084	7	0	133688	\N
27063	4178	3	0	133712	\N
27063	4211	4	0	133713	\N
27068	7642	1	0	133735	\N
27068	7412	7	0	133736	\N
27068	7519	8	0	133737	\N
27071	4787	6	0	133803	\N
27071	5075	7	0	133804	\N
27073	262	3	0	133530	\N
27073	4778	4	0	133531	\N
27078	324	3	0	131312	\N
27078	4514	4	0	131313	\N
27080	1563	8	0	133847	\N
27080	94	45	0	133848	\N
27080	7648	46	0	133849	\N
27082	4178	3	0	133863	\N
27082	4211	4	0	133864	\N
27083	42	10	0	131054	\N
27083	6734	11	0	133885	\N
27087	7225	6	0	130619	\N
27087	7379	7	0	130620	\N
27090	186	3	0	130457	\N
27090	4294	4	0	133910	\N
27092	156	3	0	133925	\N
27092	4594	4	0	133205	\N
27093	18	6	0	133938	\N
27093	4180	7	0	133939	\N
27096	4172	3	0	133839	\N
27096	4275	4	0	133840	\N
27099	200	0	0	133820	\N
27109	4178	3	0	134019	\N
27109	4211	4	0	134020	\N
27114	7412	2	0	134073	\N
27114	7529	3	0	134074	\N
27116	224	3	0	129297	\N
27116	3603	4	0	134082	\N
27121	115	6	0	132811	\N
27121	4693	7	0	134120	\N
27124	40	3	0	133620	\N
27124	372	4	0	133621	\N
27132	33	3	0	133664	\N
27132	3342	4	0	133665	\N
27137	7412	3	0	134209	\N
27137	7466	4	0	134210	\N
27141	6723	3	0	133562	\N
27141	6724	4	0	134228	\N
27143	7412	3	0	134209	\N
27143	7466	4	0	134210	\N
27151	75	2	0	134278	\N
27151	2989	3	0	134279	\N
27154	4178	6	0	134302	\N
27154	5854	7	0	134303	\N
27155	4172	3	0	134310	\N
27155	4275	4	0	134311	\N
27158	40	6	0	134326	\N
27158	4255	7	0	134327	\N
27163	4178	3	0	134367	\N
27163	4211	4	0	134368	\N
27173	198	3	0	129872	\N
27173	4263	4	0	129873	\N
27179	7412	6	0	134468	\N
27179	7507	7	0	134469	\N
27181	156	3	0	134479	\N
27181	4594	4	0	134480	\N
27190	224	3	0	134512	\N
27190	3603	4	0	134522	\N
27195	7668	36	0	134550	\N
27195	173	126	0	134598	\N
27195	7669	127	0	134599	\N
27209	268	3	0	130101	\N
27209	3815	4	0	130102	\N
27214	391	21	0	134744	\N
27214	7673	22	0	134745	\N
27219	7677	9	0	134794	\N
27219	7678	10	0	134795	\N
27223	4178	3	0	134812	\N
27223	4211	4	0	134813	\N
27230	424	3	0	134667	\N
27230	3611	4	0	134668	\N
27237	206	2	0	134866	\N
27237	2773	3	0	134867	\N
27246	6153	1	0	134920	\N
27246	6751	2	0	130542	\N
27246	7686	2	0	134921	\N
27249	322	3	0	131965	\N
27249	1105	4	0	134932	\N
27253	40	3	0	134836	\N
27253	372	4	0	134954	\N
27255	40	3	0	134836	\N
27255	372	4	0	134954	\N
27257	20	0	0	134971	\N
27260	20	0	0	134971	\N
27263	2	2	0	134985	\N
27263	2789	3	0	134986	\N
27268	4178	3	0	134907	\N
27268	4211	4	0	135000	\N
27273	2636	6	0	135059	\N
27273	5080	7	0	135060	\N
27276	4172	3	0	135068	\N
27276	4275	4	0	135069	\N
27162	4189	4	0	133203	\N
27166	230	3	0	134385	\N
27166	4181	4	0	134386	\N
27168	320	3	0	130105	\N
27168	4821	4	0	130106	\N
27176	224	3	0	134440	\N
27176	3603	4	0	134441	\N
27182	81	1	0	134483	\N
27182	79	7	0	134494	\N
27182	5993	8	0	134495	\N
27186	224	2	0	134512	\N
27186	3150	3	0	134513	\N
27194	40	2	0	134516	\N
27194	282	3	0	134549	\N
27198	300	5	0	134628	\N
27198	6057	6	0	134629	\N
27200	42	5	0	134631	\N
27200	7172	6	0	134632	\N
27202	4172	3	0	134466	\N
27202	4275	4	0	134640	\N
27205	79	3	0	134665	\N
27205	3652	4	0	134666	\N
27207	40	5	0	134679	\N
27207	2714	6	0	134680	\N
27210	4	3	0	134687	\N
27210	3837	4	0	134688	\N
27213	7627	58	0	134695	\N
27213	1021	90	0	134709	\N
27213	7672	91	1	134710	\N
27213	2171	91	0	134711	\N
27215	4172	21	0	134746	\N
27215	7674	22	0	134747	\N
27217	4178	9	0	134790	\N
27217	4682	10	0	134791	\N
27222	3342	3	0	134802	\N
27222	33	4	0	134803	\N
27224	7679	3	0	134814	\N
27224	7680	3	0	134815	\N
27224	7682	4	1	134816	\N
27224	7681	4	0	134817	\N
27228	40	6	0	134836	\N
27228	4255	7	0	134837	\N
27229	324	6	0	134838	\N
27229	5241	7	0	134839	\N
27233	132	3	0	134854	\N
27233	3729	4	0	134855	\N
27235	132	1	0	134854	\N
27235	455	2	0	134857	\N
27239	4178	9	0	134812	\N
27239	4682	10	0	134886	\N
27242	4178	4	0	134907	\N
27242	4205	5	0	134908	\N
27256	79	3	0	134969	\N
27256	3652	4	0	134970	\N
27264	268	3	0	130101	\N
27264	3815	4	0	130102	\N
27269	75	63	0	135022	\N
27269	2610	64	0	135023	\N
27281	145	9	0	135104	\N
27281	7692	10	0	135105	\N
27284	7695	97	0	135119	\N
27284	373	125	0	135128	\N
27284	7696	126	1	135129	\N
27284	973	126	0	135130	\N
27284	4098	127	0	134270	\N
27287	73	2	0	130346	\N
27287	2766	3	0	135147	\N
27296	451	3	0	135177	\N
27296	3934	4	0	135184	\N
27306	365	3	0	135252	\N
27306	3839	4	0	135253	\N
27318	4178	6	0	135311	\N
27318	4250	7	0	135325	\N
27321	6412	6	0	135347	\N
27321	241	7	0	135348	\N
27323	908	3	0	135357	\N
27323	3591	4	0	135358	\N
27324	273	3	0	135256	\N
27324	3638	4	0	135257	\N
27327	7699	3	0	135360	\N
27327	7701	3	0	135363	\N
27327	2644	4	0	135364	\N
27332	145	3	0	135382	\N
27332	4908	4	0	135383	\N
27337	285	3	0	135430	\N
27337	4496	4	0	135431	\N
27341	322	3	0	135450	\N
27341	1105	4	0	135451	\N
27345	4178	3	0	135311	\N
27345	4211	4	0	135312	\N
27352	54	9	0	135525	\N
27352	5922	10	0	135526	\N
27356	6044	9	0	134928	\N
27356	7702	10	0	135559	\N
27361	42	9	0	134631	\N
27361	7706	10	0	135608	\N
27368	40	3	0	135400	\N
27368	372	4	0	135401	\N
27371	411	3	0	135696	\N
27371	3596	4	0	135697	\N
27373	7412	3	0	135706	\N
27373	7466	4	0	135707	\N
27374	2	15	0	135738	\N
27374	1566	16	0	135739	\N
27379	4178	3	0	135766	\N
27379	4211	4	0	135767	\N
27382	18	9	0	135790	\N
27382	4047	10	0	135791	\N
27385	135	3	0	135798	\N
27385	3630	4	0	135799	\N
27392	228	3	0	135212	\N
27392	3186	4	0	135213	\N
27395	391	15	0	135868	\N
27395	2680	16	0	135869	\N
27398	228	3	0	135212	\N
27398	3186	4	0	135213	\N
27403	125	3	0	135906	\N
27403	4170	4	0	135907	\N
27405	244	3	0	133365	\N
27405	4075	4	0	135914	\N
27408	4088	3	0	135688	\N
27408	4506	4	0	135689	\N
27410	132	3	0	135939	\N
27410	3729	4	0	135940	\N
27417	58	3	0	135963	\N
27417	3665	4	0	135964	\N
27421	233	9	0	135951	\N
27421	7710	10	0	135986	\N
27422	4088	9	0	135688	\N
27422	7711	10	0	135987	\N
27423	4207	29	0	136008	\N
27423	75	42	0	136016	\N
27423	7712	43	1	136017	\N
27423	6698	43	0	136018	\N
27423	3108	44	1	136019	\N
27423	5889	44	0	136020	\N
27423	1075	45	0	136021	\N
27428	424	3	0	136055	\N
27428	3611	4	0	136056	\N
27432	4178	3	0	136057	\N
27432	4211	4	0	136058	\N
27436	367	3	0	136079	\N
27436	3683	4	0	136080	\N
27437	200	3	0	136087	\N
27437	3338	4	0	136088	\N
27440	6765	7	0	133154	\N
27440	6861	8	0	136105	\N
27443	170	1	0	134518	\N
27443	1072	2	0	136106	\N
27446	4178	6	0	136136	\N
27446	4250	7	0	136137	\N
27450	4088	6	0	135688	\N
27450	4246	7	0	136143	\N
27455	40	3	0	136150	\N
27455	372	4	0	136151	\N
27457	44	3	0	136174	\N
27457	3631	4	0	136175	\N
27203	145	7	0	134655	\N
27203	4861	8	0	134656	\N
27206	424	3	0	134667	\N
27206	3611	4	0	134668	\N
27208	4	0	0	132825	\N
27211	5885	3	0	121991	\N
27211	5926	4	0	123245	\N
27212	186	3	0	130457	\N
27212	4294	4	0	133910	\N
27218	4172	9	0	134792	\N
27218	4977	10	0	134793	\N
27220	3342	3	0	134802	\N
27220	33	4	0	134803	\N
27225	7679	3	0	134814	\N
27225	7683	3	0	134818	\N
27225	6692	4	1	134819	\N
27225	7684	4	0	134820	\N
27225	7685	5	0	134821	\N
27226	360	3	0	134220	\N
27226	3602	4	0	134221	\N
27231	365	3	0	134852	\N
27231	3839	4	0	134853	\N
27240	170	2	0	134891	\N
27240	1380	3	0	134892	\N
27243	391	4	0	134909	\N
27243	3913	5	0	134910	\N
27245	4172	3	0	134918	\N
27245	4275	4	0	134919	\N
27247	6044	3	0	134928	\N
27247	6045	4	0	134929	\N
27250	27	3	0	128195	\N
27250	4636	4	0	128196	\N
27251	7687	79	0	134933	\N
27251	27	126	0	134944	\N
27251	7688	127	0	134945	\N
27259	4172	3	0	134979	\N
27259	4275	4	0	134980	\N
27261	20	0	0	134971	\N
27267	75	0	0	134993	\N
27271	186	3	0	135045	\N
27271	4294	4	0	135046	\N
27275	200	3	0	133820	\N
27275	3338	4	0	133821	\N
27277	38	3	0	132791	\N
27277	3457	4	0	132792	\N
27292	266	2	0	135163	\N
27292	2103	3	0	135164	\N
27295	451	1	0	135177	\N
27295	3260	2	0	135178	\N
27297	181	6	0	135197	\N
27297	4256	7	0	135198	\N
27298	241	6	0	133642	\N
27298	6412	7	0	135199	\N
27305	64	3	0	135244	\N
27305	4217	4	0	135245	\N
27308	273	3	0	135256	\N
27308	3638	4	0	135257	\N
27309	23	3	0	135258	\N
27309	3497	4	0	135259	\N
27314	202	6	0	132051	\N
27314	4079	7	0	135295	\N
27317	4178	3	0	135311	\N
27317	4211	4	0	135312	\N
27325	30	3	0	122890	\N
27325	3640	4	0	135359	\N
27329	326	3	0	135365	\N
27329	3339	4	0	135366	\N
27333	40	4	0	135392	\N
27333	3381	5	0	135393	\N
27336	79	9	0	135422	\N
27336	3758	10	0	135423	\N
27346	2	3	0	135494	\N
27346	3548	4	0	135495	\N
27347	391	3	0	134909	\N
27347	3660	4	0	135496	\N
27358	71	9	0	135561	\N
27358	7704	10	0	135562	\N
27360	7705	11	0	135585	\N
27360	365	13	0	135588	\N
27360	1424	14	0	135589	\N
27365	678	3	0	75566	\N
27365	7707	4	0	135641	\N
27367	75	62	0	135674	\N
27367	7012	63	0	135675	\N
27370	4088	3	0	135688	\N
27370	4506	4	0	135689	\N
27376	125	6	0	125314	\N
27376	6951	7	0	125315	\N
27378	132	3	0	134854	\N
27378	3729	4	0	134855	\N
27381	100	9	0	135788	\N
27381	7708	10	0	135789	\N
27383	5885	3	0	134989	\N
27383	5926	4	0	134990	\N
27386	137	3	0	130171	\N
27386	3633	4	0	135800	\N
27388	4178	6	0	135766	\N
27388	4250	7	0	135815	\N
27389	453	6	0	135448	\N
27389	4091	7	0	135816	\N
27390	7412	6	0	135829	\N
27390	7507	7	0	135830	\N
27401	4172	3	0	135904	\N
27401	4275	4	0	135905	\N
27406	156	3	0	135921	\N
27406	4594	4	0	135922	\N
27413	233	3	0	135951	\N
27413	3704	4	0	135952	\N
27414	4088	3	0	135688	\N
27414	4506	4	0	135689	\N
27415	365	3	0	135959	\N
27415	3839	4	0	135960	\N
27419	528	3	0	135965	\N
27419	4262	4	0	135966	\N
27425	137	9	0	136041	\N
27425	5190	10	0	136042	\N
27427	268	3	0	130101	\N
27427	3815	4	0	130102	\N
27430	140	3	0	131995	\N
27430	4149	4	0	131996	\N
27434	4172	3	0	136075	\N
27434	4275	4	0	136076	\N
27438	170	1	0	134089	\N
27438	1072	2	0	136091	\N
27442	170	7	0	136107	\N
27442	4591	8	0	136108	\N
27444	170	1	0	134891	\N
27444	1072	2	0	136109	\N
27448	233	6	0	135951	\N
27448	4245	7	0	136140	\N
27452	71	3	0	135561	\N
27452	3770	4	0	136152	\N
27456	71	3	0	136172	\N
27456	3770	4	0	136173	\N
27459	18	9	0	136223	\N
27459	7719	10	0	136224	\N
27461	140	9	0	131995	\N
27461	7721	10	0	136245	\N
27465	300	8	0	136265	\N
27465	7724	9	0	136266	\N
27469	14	8	0	136335	\N
27469	7727	9	0	136336	\N
27471	4178	7	0	136351	\N
27471	7728	8	0	136352	\N
27484	100	24	0	136550	\N
27484	7734	25	0	136551	\N
27488	2192	14	0	136630	\N
27488	40	28	0	136631	\N
27488	3381	29	0	136632	\N
27492	77	4	0	136410	\N
27492	7737	5	0	136669	\N
27495	273	3	0	136077	\N
27495	3638	4	0	136078	\N
27497	23	3	0	136700	\N
27497	3497	4	0	136701	\N
27506	4178	3	0	136766	\N
27506	4211	4	0	136767	\N
27227	60	3	0	134822	\N
27227	3585	4	0	134823	\N
27232	224	3	0	134512	\N
27232	3603	4	0	134522	\N
27234	42	3	0	134631	\N
27234	3645	4	0	134856	\N
27236	391	3	0	134744	\N
27236	3660	4	0	134864	\N
27241	288	2	0	134897	\N
27241	2842	3	0	134898	\N
27244	4172	4	0	134792	\N
27244	4219	5	0	134911	\N
27248	841	3	0	134930	\N
27248	3604	4	0	134931	\N
27252	285	3	0	134952	\N
27252	4496	4	0	134953	\N
27254	12	3	0	134961	\N
27254	4204	4	0	134962	\N
27258	20	3	0	134971	\N
27258	2844	4	0	134978	\N
27262	20	0	0	134971	\N
27265	5885	3	0	134989	\N
27265	5926	4	0	134990	\N
27266	4172	3	0	134991	\N
27266	4275	4	0	134992	\N
27270	4694	24	0	135026	\N
27270	75	40	0	135038	\N
27270	7570	41	1	135039	\N
27270	6668	41	0	135040	\N
27270	7690	42	1	135041	\N
27270	7689	42	0	135042	\N
27270	3108	43	1	135043	\N
27270	7691	43	0	135044	\N
27274	44	6	0	132327	\N
27274	5989	7	0	135061	\N
27279	2782	3	0	135084	\N
27279	3659	4	0	135085	\N
27282	264	2	0	133534	\N
27282	3026	3	0	135110	\N
27285	7697	5	0	135139	\N
27285	7698	6	0	135140	\N
27288	241	2	0	133642	\N
27288	634	3	0	135148	\N
27289	75	1	0	135149	\N
27289	1427	2	0	135150	\N
27294	4172	4	0	135068	\N
27294	4252	5	0	135174	\N
27299	40	3	0	134836	\N
27299	372	4	0	134954	\N
27302	4172	6	0	135228	\N
27302	4197	7	0	135229	\N
27304	102	3	0	135242	\N
27304	3597	4	0	135243	\N
27307	151	3	0	135254	\N
27307	3046	4	0	135255	\N
27311	2	3	0	134985	\N
27311	3548	4	0	135274	\N
27316	2	3	0	135309	\N
27316	3548	4	0	135310	\N
27319	224	6	0	134512	\N
27319	7176	7	0	135326	\N
27322	4086	6	0	135349	\N
27322	140	7	0	135350	\N
27328	793	3	0	133548	\N
27328	2644	4	0	133551	\N
27330	62	3	0	133083	\N
27330	3344	4	0	135373	\N
27335	242	3	0	135402	\N
27335	2839	4	0	135403	\N
27338	424	3	0	135438	\N
27338	3611	4	0	135439	\N
27343	4172	3	0	135472	\N
27343	4275	4	0	135473	\N
27348	44	3	0	132327	\N
27348	3631	4	0	135497	\N
27350	1858	3	0	125017	\N
27350	4273	4	0	135506	\N
27353	391	6	0	134909	\N
27353	3521	7	0	135539	\N
27354	90	6	0	131697	\N
27354	7581	7	0	131698	\N
27357	6303	9	0	132980	\N
27357	7703	10	0	135560	\N
27359	7705	11	0	135585	\N
27359	365	13	0	135588	\N
27359	1424	14	0	135589	\N
27362	451	3	0	135615	\N
27362	3934	4	0	135616	\N
27364	224	4	0	135633	\N
27364	3806	5	0	135634	\N
27369	233	3	0	132793	\N
27369	3704	4	0	132794	\N
27372	4172	3	0	135698	\N
27372	4275	4	0	135699	\N
27375	186	15	0	135045	\N
27375	621	16	0	135740	\N
27380	117	3	0	135768	\N
27380	3653	4	0	135769	\N
27387	2	6	0	135813	\N
27387	4825	7	0	135814	\N
27396	424	6	0	135882	\N
27396	3712	7	0	135883	\N
27399	793	3	0	133548	\N
27399	2644	4	0	133551	\N
27400	4172	3	0	135698	\N
27400	4275	4	0	135699	\N
27411	288	3	0	135941	\N
27411	3003	4	0	135942	\N
27412	300	3	0	135949	\N
27412	3747	4	0	135950	\N
27418	4172	3	0	135904	\N
27418	4275	4	0	135905	\N
27424	135	9	0	135798	\N
27424	5189	10	0	136040	\N
27426	5885	3	0	134989	\N
27426	5926	4	0	134990	\N
27429	4178	3	0	136057	\N
27429	4211	4	0	136058	\N
27433	4178	3	0	136073	\N
27433	4211	4	0	136074	\N
27441	170	1	0	134518	\N
27441	1072	2	0	136106	\N
27447	7412	6	0	136138	\N
27447	7507	7	0	136139	\N
27451	40	3	0	136150	\N
27451	372	4	0	136151	\N
27453	262	3	0	134106	\N
27453	4778	4	0	134107	\N
27458	264	14	0	135374	\N
27458	7718	15	0	136204	\N
27464	132	5	0	135939	\N
27464	7504	6	0	136248	\N
27478	77	26	0	136410	\N
27478	7731	27	0	136411	\N
27480	4172	18	0	136075	\N
27480	4977	19	0	136466	\N
27481	224	18	0	136467	\N
27481	7732	19	0	136468	\N
27483	4233	6	0	136501	\N
27483	7733	7	0	136502	\N
27487	6737	14	0	136627	\N
27487	142	28	0	136628	\N
27487	3950	29	0	136629	\N
27489	6737	14	0	136627	\N
27489	142	28	0	136628	\N
27489	3950	29	0	136629	\N
27491	4172	3	0	136075	\N
27491	4275	4	0	136076	\N
27494	4178	6	0	136684	\N
27494	4250	7	0	136685	\N
27504	145	3	0	136745	\N
27504	4908	4	0	136746	\N
27509	14	9	0	136818	\N
27509	5082	10	0	136819	\N
27518	453	2	0	136853	\N
27518	3366	3	0	136855	\N
27521	4178	4	0	136905	\N
27278	115	3	0	135076	\N
27278	3483	4	0	135077	\N
27283	75	10	0	135116	\N
27283	7694	11	1	135117	\N
27283	7693	11	0	135118	\N
27286	4178	2	0	135145	\N
27286	4247	3	0	135146	\N
27290	285	2	0	135155	\N
27290	3036	3	0	135156	\N
27291	2782	2	0	135157	\N
27291	2784	3	0	135158	\N
27293	40	2	0	134836	\N
27293	282	3	0	135165	\N
27300	228	3	0	135212	\N
27300	3186	4	0	135213	\N
27301	326	3	0	135214	\N
27301	3339	4	0	135215	\N
27303	322	3	0	131965	\N
27303	1105	4	0	134932	\N
27310	40	3	0	135266	\N
27310	372	4	0	135267	\N
27312	2	3	0	135281	\N
27312	3548	4	0	135282	\N
27315	4178	3	0	135145	\N
27315	4211	4	0	135302	\N
27320	18	3	0	135333	\N
27320	3621	4	0	135334	\N
27326	7699	3	0	135360	\N
27326	7700	3	0	135361	\N
27326	3339	4	0	135362	\N
27331	264	3	0	135374	\N
27331	3632	4	0	135375	\N
27334	40	3	0	135400	\N
27334	372	4	0	135401	\N
27339	266	3	0	135446	\N
27339	3474	4	0	135447	\N
27340	453	3	0	135448	\N
27340	2838	4	0	135449	\N
27342	79	6	0	135464	\N
27342	4253	7	0	135465	\N
27344	2	3	0	135480	\N
27344	3548	4	0	135481	\N
27349	4172	3	0	135504	\N
27349	4275	4	0	135505	\N
27355	2	9	0	135494	\N
27355	3650	10	0	135558	\N
27363	198	3	0	135623	\N
27363	4263	4	0	135624	\N
27366	73	3	0	135642	\N
27366	3040	4	0	135643	\N
27377	4172	6	0	135698	\N
27377	4197	7	0	135753	\N
27384	268	3	0	130101	\N
27384	3815	4	0	130102	\N
27391	96	3	0	132783	\N
27391	2803	4	0	135837	\N
27394	273	0	0	135256	\N
27397	1463	3	0	135890	\N
27397	7709	4	0	135891	\N
27402	4178	3	0	135766	\N
27402	4211	4	0	135767	\N
27404	244	3	0	133365	\N
27404	4075	4	0	135914	\N
27407	233	3	0	135929	\N
27407	3704	4	0	135930	\N
27409	316	3	0	135937	\N
27409	4249	4	0	135938	\N
27416	4178	3	0	135961	\N
27416	4211	4	0	135962	\N
27420	4178	9	0	135961	\N
27420	4682	10	0	135985	\N
27431	451	3	0	136059	\N
27431	3934	4	0	136060	\N
27435	273	3	0	136077	\N
27435	3638	4	0	136078	\N
27439	212	7	0	129769	\N
27439	7713	8	0	136104	\N
27445	530	1	0	136112	\N
27445	181	4	0	136117	\N
27449	79	6	0	136141	\N
27449	4253	7	0	136142	\N
27454	4178	3	0	136136	\N
27454	4211	4	0	136165	\N
27462	132	9	0	135939	\N
27462	7722	10	0	136246	\N
27466	461	8	0	136267	\N
27466	7725	9	0	136268	\N
27468	86	24	0	134063	\N
27468	7726	25	0	136318	\N
27470	402	0	0	130099	\N
27476	1109	0	0	134198	\N
27477	4178	26	0	136351	\N
27477	5160	27	0	136409	\N
27479	4178	8	0	136428	\N
27479	6776	9	0	136429	\N
27482	4178	9	0	136487	\N
27482	7720	10	0	136488	\N
27486	6191	14	0	136598	\N
27486	115	28	0	136625	\N
27486	4844	29	0	136626	\N
27496	100	3	0	136698	\N
27496	3836	4	0	136699	\N
27498	4178	4	0	136710	\N
27498	4205	5	0	136711	\N
27499	156	4	0	136712	\N
27499	5935	5	0	136713	\N
27501	4172	3	0	136721	\N
27501	4275	4	0	136722	\N
27503	224	6	0	136737	\N
27503	7176	7	0	136738	\N
27511	113	3	0	136828	\N
27511	3620	4	0	136829	\N
27513	248	1	0	136834	\N
27513	117	3	0	136837	\N
27513	7717	4	0	136838	\N
27517	453	3	0	136853	\N
27517	2838	4	0	136854	\N
27520	230	14	0	134385	\N
27520	1703	15	0	136896	\N
27523	7412	7	0	136138	\N
27523	7528	8	0	136928	\N
27528	7741	87	0	137017	\N
27528	241	89	0	137019	\N
27528	3094	90	0	137020	\N
27539	4172	3	0	136721	\N
27539	4275	4	0	136722	\N
27541	108	3	0	131735	\N
27541	3255	4	0	137090	\N
27544	115	4	0	137097	\N
27544	6794	5	0	137098	\N
27547	44	9	0	136174	\N
27547	3765	10	0	137120	\N
27548	4178	6	0	137133	\N
27548	4250	7	0	137134	\N
27560	431	4	0	137187	\N
27560	7609	5	0	137188	\N
27562	326	4	0	135365	\N
27562	3519	5	0	137190	\N
27566	4178	3	0	137197	\N
27566	4211	4	0	137198	\N
27569	411	3	0	137228	\N
27569	3596	4	0	137229	\N
27571	64	3	0	137232	\N
27571	4217	4	0	137233	\N
27574	14	3	0	137254	\N
27574	4272	4	0	137255	\N
27575	40	3	0	136150	\N
27575	372	4	0	136151	\N
27587	300	4	0	137345	\N
27587	2992	5	0	137346	\N
27594	258	3	0	137385	\N
27445	7716	7	0	138729	\N
27445	7717	7	1	136705	\N
27445	7714	5	1	138726	\N
27445	7715	6	1	138728	\N
27460	4178	9	0	136243	\N
27460	7720	10	0	136244	\N
27463	140	6	0	131995	\N
27463	7723	7	0	136247	\N
27467	4178	24	0	136243	\N
27467	4297	25	0	136317	\N
27472	431	7	0	136353	\N
27472	7729	8	0	136354	\N
27473	402	7	0	130099	\N
27473	7730	8	0	136355	\N
27474	100	0	0	135788	\N
27475	71	0	0	136356	\N
27485	391	8	0	136568	\N
27485	7735	9	0	136569	\N
27490	96	10	0	136653	\N
27490	7736	11	0	136654	\N
27493	79	4	0	136670	\N
27493	7738	5	0	136671	\N
27500	4178	3	0	136710	\N
27500	4211	4	0	136720	\N
27502	42	3	0	136723	\N
27502	3645	4	0	136724	\N
27505	1470	6	0	131238	\N
27505	6409	7	0	136759	\N
27507	142	15	0	133948	\N
27507	7010	16	0	136798	\N
27508	40	15	0	136150	\N
27508	522	16	0	136799	\N
27515	248	1	0	136834	\N
27515	117	4	0	136837	\N
27515	5439	5	0	136843	\N
27519	181	6	0	136866	\N
27519	4256	7	0	136867	\N
27526	4172	3	0	136721	\N
27526	4275	4	0	136722	\N
27527	100	2	0	136698	\N
27527	633	3	0	136936	\N
27530	18	6	0	137035	\N
27530	4180	7	0	137036	\N
27532	35	3	0	137049	\N
27532	3563	4	0	137050	\N
27534	27	74	0	137052	\N
27534	7742	75	1	137053	\N
27534	2171	75	0	137054	\N
27534	7743	76	1	137055	\N
27534	3740	76	0	137056	\N
27537	7746	8	0	137075	\N
27538	40	3	0	136150	\N
27538	372	4	0	136151	\N
27543	58	4	0	135963	\N
27543	2781	5	0	137096	\N
27546	42	9	0	136723	\N
27546	7706	10	0	137119	\N
27550	23	3	0	137143	\N
27550	3497	4	0	137144	\N
27553	6765	4	0	137160	\N
27553	7217	5	0	137161	\N
27555	123	4	0	132155	\N
27555	4090	5	0	132156	\N
27557	200	2	0	137174	\N
27557	3109	3	0	137175	\N
27559	4178	4	0	137185	\N
27559	4205	5	0	137186	\N
27564	391	3	0	137199	\N
27564	3660	4	0	137200	\N
27568	6303	6	0	132980	\N
27568	6438	7	0	137221	\N
27578	242	1	0	137276	\N
27578	2768	2	0	137277	\N
27580	18	6	0	137292	\N
27580	4180	7	0	137293	\N
27582	242	0	0	137307	\N
27583	242	6	0	137276	\N
27583	7749	7	0	137320	\N
27589	4172	2	0	137358	\N
27589	4191	3	0	137359	\N
27591	233	6	0	137374	\N
27591	6901	7	0	137375	\N
27592	4088	6	0	135688	\N
27592	7750	7	0	137376	\N
27596	324	9	0	137406	\N
27596	7752	10	0	137407	\N
27602	528	6	0	135965	\N
27602	4824	7	0	137438	\N
27603	451	9	0	137456	\N
27603	7754	10	0	137457	\N
27605	77	3	0	137465	\N
27605	1877	4	0	137466	\N
27608	324	12	0	137492	\N
27608	7755	13	0	137493	\N
27619	316	3	0	137597	\N
27619	4249	4	0	137598	\N
27621	852	1	0	137599	\N
27621	913	2	0	133438	\N
27623	117	3	0	137606	\N
27623	3653	4	0	137607	\N
27626	7412	6	0	137623	\N
27626	7507	7	0	137624	\N
27628	18	4	0	137634	\N
27628	2302	5	0	137635	\N
27631	4178	3	0	137664	\N
27631	4211	4	0	137665	\N
27633	4178	3	0	137664	\N
27633	4211	4	0	137665	\N
27640	4172	12	0	137700	\N
27640	6408	13	0	137701	\N
27643	212	12	0	129769	\N
27643	7761	13	0	137702	\N
27647	1470	6	0	137727	\N
27647	6409	7	0	137728	\N
27651	7765	52	0	137763	\N
27651	453	126	0	137790	\N
27651	7766	127	0	137791	\N
27653	4172	3	0	137700	\N
27653	4275	4	0	137800	\N
27658	151	3	0	135254	\N
27658	3046	4	0	135255	\N
27672	181	2	0	137892	\N
27672	3245	3	0	137893	\N
27676	156	4	0	137898	\N
27676	2843	5	0	137899	\N
27678	4178	3	0	137890	\N
27678	4211	4	0	137891	\N
27683	7768	52	0	137947	\N
27683	453	78	0	137964	\N
27683	6896	79	0	137965	\N
27686	279	7	0	130616	\N
27686	7770	8	0	137984	\N
27688	7412	6	0	137623	\N
27688	7507	7	0	137624	\N
27695	79	2	0	138023	\N
27695	616	3	0	138024	\N
27697	2351	2	0	138031	\N
27697	2754	3	0	138032	\N
27700	2	6	0	137894	\N
27700	4550	7	0	138127	\N
27702	206	6	0	138129	\N
27702	7772	7	0	138130	\N
27709	4178	2	0	138021	\N
27709	4247	3	0	138022	\N
27711	135	2	0	138200	\N
27711	2722	3	0	138201	\N
27716	852	2	0	138221	\N
27716	2872	3	0	138222	\N
27718	90	2	0	131697	\N
27718	3442	3	0	138229	\N
27720	7776	70	0	138234	\N
27720	90	126	0	138235	\N
27720	7777	127	0	138236	\N
27725	1470	4	0	138262	\N
27725	2798	5	0	138263	\N
27729	42	4	0	136723	\N
27729	2821	5	0	138267	\N
27734	4178	6	0	138294	\N
27734	4358	7	0	138295	\N
27737	123	2	0	132155	\N
27510	678	3	0	136826	\N
27510	7707	4	0	136827	\N
27512	113	2	0	136828	\N
27512	1899	3	0	136831	\N
27514	4201	1	0	136839	\N
27514	4172	4	0	136842	\N
27514	4285	5	0	136722	\N
27516	7739	1	0	136844	\N
27516	1951	4	0	136845	\N
27516	7740	5	0	136846	\N
27522	206	3	0	134866	\N
27522	4584	4	0	136913	\N
27525	100	3	0	136698	\N
27525	3836	4	0	136699	\N
27529	241	6	0	137033	\N
27529	6412	7	0	137034	\N
27536	2	7	0	135813	\N
27536	5463	8	0	137073	\N
27540	262	3	0	137082	\N
27540	4778	4	0	137083	\N
27545	18	9	0	137117	\N
27545	4047	10	0	137118	\N
27552	6723	4	0	133562	\N
27552	6739	5	0	137159	\N
27556	4172	3	0	137168	\N
27556	4275	4	0	137169	\N
27563	4178	3	0	137197	\N
27563	4211	4	0	137198	\N
27565	64	3	0	137201	\N
27565	4217	4	0	137202	\N
27577	75	23	0	137274	\N
27577	4645	24	0	137275	\N
27586	18	3	0	137292	\N
27586	3621	4	0	137336	\N
27588	300	6	0	137345	\N
27588	4875	7	0	137353	\N
27593	235	3	0	137383	\N
27593	3343	4	0	137384	\N
27595	58	9	0	137404	\N
27595	7751	10	0	137405	\N
27598	7753	7	0	137422	\N
27598	35	8	0	137423	\N
27601	2782	0	0	135157	\N
27607	391	0	0	137467	\N
27611	7758	19	0	137518	\N
27611	62	80	0	137519	\N
27611	7759	81	1	137520	\N
27611	4912	81	0	137521	\N
27616	96	12	0	137558	\N
27616	5245	13	0	137559	\N
27617	285	17	0	137581	\N
27617	7760	18	0	137582	\N
27624	60	6	0	137071	\N
27624	6394	7	0	137620	\N
27629	4172	6	0	137648	\N
27629	4197	7	0	137649	\N
27636	6450	0	0	125868	\N
27639	597	0	0	137675	\N
27641	212	12	0	129769	\N
27641	7761	13	0	137702	\N
27644	6765	12	0	137160	\N
27644	7762	13	0	137705	\N
27645	4178	4	0	137664	\N
27645	4331	5	0	137713	\N
27648	27	6	0	128195	\N
27648	3715	7	0	137741	\N
27654	77	3	0	137807	\N
27654	1877	4	0	137808	\N
27656	2	3	0	137815	\N
27656	3548	4	0	137816	\N
27659	202	3	0	137823	\N
27659	4857	4	0	137824	\N
27661	113	3	0	137531	\N
27661	3620	4	0	137532	\N
27666	793	3	0	137871	\N
27666	2644	4	0	137872	\N
27668	2782	3	0	135157	\N
27668	3659	4	0	137879	\N
27673	2	3	0	137894	\N
27673	3548	4	0	137895	\N
27675	2636	3	0	137882	\N
27675	2837	4	0	137883	\N
27679	58	2	0	137404	\N
27679	2853	3	0	137911	\N
27681	6044	3	0	137920	\N
27681	6045	4	0	137921	\N
27684	189	0	0	137966	\N
27691	1376	3	0	15681	\N
27691	4768	4	0	66371	\N
27693	79	3	0	137853	\N
27693	3652	4	0	138016	\N
27703	7412	8	0	138147	\N
27703	7773	9	0	138148	\N
27704	4172	10	0	138169	\N
27704	6603	11	0	138170	\N
27706	64	10	0	137232	\N
27706	7774	11	0	138172	\N
27713	79	4	0	138212	\N
27713	2758	5	0	138213	\N
27722	322	2	0	135450	\N
27722	1866	3	0	138243	\N
27724	4178	3	0	138252	\N
27724	4441	4	0	138253	\N
27731	7412	2	0	138274	\N
27731	7430	3	0	138275	\N
27733	852	2	0	138221	\N
27733	2872	3	0	138222	\N
27743	597	2	0	137675	\N
27743	3286	3	0	138350	\N
27745	35	2	0	138352	\N
27745	1191	3	0	138353	\N
27750	1656	2	0	138376	\N
27750	7779	3	0	138377	\N
27754	242	2	0	138386	\N
27754	3425	3	0	138387	\N
27756	73	2	0	135642	\N
27756	2766	3	0	138393	\N
27521	4205	5	0	136906	\N
27524	69	3	0	131240	\N
27524	4536	4	0	136935	\N
27531	4178	2	0	137041	\N
27531	4247	3	0	137042	\N
27533	27	3	0	128195	\N
27533	4636	4	0	128196	\N
27535	60	7	0	137071	\N
27535	7744	8	0	137072	\N
27542	4172	4	0	137094	\N
27542	4252	5	0	137095	\N
27549	12	3	0	137141	\N
27549	4204	4	0	137142	\N
27551	7747	2	0	137149	\N
27551	2760	3	0	137150	\N
27554	212	4	0	129769	\N
27554	3732	5	0	131915	\N
27558	67	2	0	137176	\N
27558	7748	3	0	137177	\N
27561	102	4	0	135242	\N
27561	3572	5	0	137189	\N
27567	30	3	0	122890	\N
27567	3640	4	0	135359	\N
27570	142	3	0	137230	\N
27570	4254	4	0	137231	\N
27572	79	6	0	137246	\N
27572	4253	7	0	137247	\N
27576	164	3	0	132507	\N
27576	3385	4	0	132508	\N
27579	4178	6	0	137290	\N
27579	4250	7	0	137291	\N
27581	391	6	0	137199	\N
27581	3521	7	0	137306	\N
27584	58	4	0	135963	\N
27584	2781	5	0	137096	\N
27585	44	4	0	136174	\N
27585	5215	5	0	137329	\N
27590	88	5	0	134657	\N
27590	5942	6	0	137365	\N
27600	2782	6	0	135157	\N
27600	5009	7	0	137437	\N
27604	4178	0	0	137458	\N
27609	62	3	0	137500	\N
27609	3344	4	0	137501	\N
27612	115	3	0	137097	\N
27612	3483	4	0	137528	\N
27613	266	3	0	137529	\N
27613	3474	4	0	137530	\N
27615	4178	4	0	137458	\N
27615	4179	5	0	137541	\N
27618	149	3	0	137589	\N
27618	4189	4	0	137590	\N
27635	67	3	0	137672	\N
27635	3749	4	0	137673	\N
27638	4172	0	0	137674	\N
27649	7763	0	0	137742	\N
27649	7764	0	0	137743	\N
27655	6044	3	0	134928	\N
27655	6045	4	0	134929	\N
27657	367	3	0	136079	\N
27657	3683	4	0	136080	\N
27660	30	3	0	122890	\N
27660	3640	4	0	135359	\N
27663	79	8	0	137853	\N
27663	3701	9	0	137854	\N
27665	4172	3	0	137869	\N
27665	4275	4	0	137870	\N
27667	64	3	0	137232	\N
27667	4217	4	0	137233	\N
27670	2636	3	0	137882	\N
27670	2837	4	0	137883	\N
27674	324	3	0	137896	\N
27674	4514	4	0	137897	\N
27680	4172	2	0	137912	\N
27680	4191	3	0	137913	\N
27685	7225	7	0	130619	\N
27685	7769	8	1	137981	\N
27685	749	8	0	137982	\N
27685	4912	9	0	137983	\N
27690	140	3	0	138007	\N
27690	4149	4	0	138008	\N
27692	18	3	0	137634	\N
27692	3621	4	0	138009	\N
27694	4178	2	0	138021	\N
27694	4247	3	0	138022	\N
27699	151	6	0	138125	\N
27699	7389	7	0	138126	\N
27708	60	6	0	137071	\N
27708	7775	7	0	138194	\N
27710	137	2	0	136041	\N
27710	2721	3	0	138199	\N
27717	4178	2	0	138227	\N
27717	4247	3	0	138228	\N
27719	449	2	0	137792	\N
27719	646	3	0	138230	\N
27721	402	2	0	138241	\N
27721	2760	3	0	138242	\N
27727	285	4	0	138264	\N
27727	5030	5	0	138265	\N
27728	326	4	0	135365	\N
27728	3362	5	0	138266	\N
27730	424	2	0	138272	\N
27730	2755	3	0	138273	\N
27736	6723	2	0	138304	\N
27736	6763	3	0	138305	\N
27740	149	2	0	138314	\N
27740	1379	3	0	138315	\N
27742	6450	2	0	125868	\N
27742	6825	3	0	127092	\N
27747	125	4	0	135906	\N
27747	3356	5	0	138364	\N
27749	411	2	0	138374	\N
27749	3370	3	0	138375	\N
27753	4172	2	0	138280	\N
27753	4191	3	0	138281	\N
27758	4172	2	0	138398	\N
27758	4191	3	0	138399	\N
27594	4401	4	0	137386	\N
27597	7753	7	0	137422	\N
27597	35	8	0	137423	\N
27599	262	6	0	137082	\N
27599	4248	7	0	137436	\N
27606	125	3	0	135906	\N
27606	4170	4	0	135907	\N
27610	7756	55	0	137514	\N
27610	62	126	0	137516	\N
27610	7757	127	0	137517	\N
27614	113	3	0	137531	\N
27614	3620	4	0	137532	\N
27620	132	3	0	135939	\N
27620	3729	4	0	135940	\N
27622	852	3	0	137599	\N
27622	3612	4	0	133207	\N
27625	4172	6	0	137621	\N
27625	4197	7	0	137622	\N
27627	4233	4	0	137632	\N
27627	4234	5	0	137633	\N
27630	324	3	0	137656	\N
27630	4514	4	0	137657	\N
27632	14	3	0	137254	\N
27632	4272	4	0	137255	\N
27634	424	3	0	136055	\N
27634	3611	4	0	136056	\N
27637	595	0	0	130908	\N
27642	40	12	0	137703	\N
27642	5640	13	0	137704	\N
27646	96	4	0	137558	\N
27646	5538	5	0	137714	\N
27650	453	10	0	137761	\N
27650	3360	11	0	137762	\N
27652	449	10	0	137792	\N
27652	7767	11	0	137793	\N
27662	40	8	0	137703	\N
27662	3718	9	0	137852	\N
27664	33	3	0	137861	\N
27664	3342	4	0	137862	\N
27669	266	3	0	137880	\N
27669	3474	4	0	137881	\N
27671	4178	3	0	137890	\N
27671	4211	4	0	137891	\N
27677	156	3	0	137898	\N
27677	4594	4	0	137900	\N
27682	453	3	0	137928	\N
27682	2838	4	0	137929	\N
27687	391	6	0	137997	\N
27687	3521	7	0	137998	\N
27689	4766	3	0	138005	\N
27689	4767	4	0	138006	\N
27696	121	2	0	138029	\N
27696	2498	3	0	138030	\N
27698	121	99	0	138029	\N
27698	7771	100	0	138112	\N
27701	6	6	0	134397	\N
27701	3320	7	0	138128	\N
27705	4178	10	0	138021	\N
27705	6571	11	0	138171	\N
27707	2636	4	0	137882	\N
27707	7436	5	0	138181	\N
27712	4172	4	0	138210	\N
27712	4252	5	0	138211	\N
27714	2	2	0	137894	\N
27714	2789	3	0	138218	\N
27715	40	2	0	138219	\N
27715	282	3	0	138220	\N
27723	244	2	0	138244	\N
27723	3308	3	0	138245	\N
27732	4172	2	0	138280	\N
27732	4191	3	0	138281	\N
27735	7412	2	0	138274	\N
27735	7430	3	0	138275	\N
27738	242	2	0	138307	\N
27738	3425	3	0	138308	\N
27741	2782	14	0	138344	\N
27741	7778	15	0	138345	\N
27744	595	2	0	130908	\N
27744	3285	3	0	138351	\N
27746	92	4	0	138362	\N
27746	6053	5	0	138363	\N
27748	260	2	0	132624	\N
27748	3184	3	0	138369	\N
27755	242	1	0	138386	\N
27755	2768	2	0	138388	\N
27757	58	2	0	137404	\N
27757	2853	3	0	137911	\N
27737	1868	3	0	138306	\N
27739	192	2	0	132230	\N
27739	2761	3	0	138313	\N
27751	262	2	0	138378	\N
27751	2743	3	0	138379	\N
27752	18	2	0	138380	\N
27752	1685	3	0	138381	\N
27759	125	10	0	138489	\N
27759	7780	11	0	138490	\N
27760	23	10	0	138491	\N
27760	7781	11	0	138492	\N
27761	4178	2	0	138497	\N
27761	4247	3	0	138498	\N
27762	6765	2	0	137160	\N
27762	6841	3	0	138503	\N
27763	212	2	0	138504	\N
27763	3616	3	0	138505	\N
27764	7412	2	0	138510	\N
27764	7430	3	0	138511	\N
27765	192	2	0	138516	\N
27765	2761	3	0	138517	\N
27766	4178	2	0	138522	\N
27766	4247	3	0	138523	\N
27767	60	2	0	138524	\N
27767	4544	3	0	138525	\N
27768	71	2	0	136356	\N
27768	1125	3	0	138526	\N
27769	264	2	0	138527	\N
27769	2780	3	0	138528	\N
27770	96	2	0	137558	\N
27770	2347	3	0	138533	\N
27771	62	0	0	138534	\N
27772	326	4	0	138543	\N
27772	3362	5	0	138544	\N
27773	170	7	0	136107	\N
27773	6624	8	0	138559	\N
27774	528	2	0	135965	\N
27774	2765	3	0	138564	\N
27775	7412	2	0	138565	\N
27775	7430	3	0	138566	\N
27776	451	4	0	138575	\N
27776	3391	5	0	138576	\N
27777	424	2	0	138581	\N
27777	2755	3	0	138582	\N
27778	4172	2	0	138398	\N
27778	4191	3	0	138399	\N
27779	198	2	0	138583	\N
27779	513	3	0	138584	\N
27780	7782	3	0	138591	\N
27780	119	5	0	138594	\N
27780	3128	6	0	138595	\N
27781	7783	3	0	138596	\N
27781	3628	5	0	138597	\N
27781	7784	6	0	138598	\N
27782	7785	3	0	138599	\N
27782	3625	5	0	138600	\N
27782	7786	6	0	138601	\N
2534	861	4	0	138401	\N
2604	882	3	0	138405	\N
2604	884	4	0	138407	\N
4553	1211	16	1	138408	\N
4553	1281	17	0	138409	\N
5180	749	6	1	138411	\N
5180	1211	7	0	138413	\N
5253	1355	3	1	138415	\N
5253	1404	4	1	138417	\N
5774	1459	3	0	138419	\N
5774	1461	4	0	138421	\N
8784	2000	3	0	138423	\N
8784	2002	4	0	138425	\N
8992	1970	3	0	138428	\N
9037	2084	4	0	138430	\N
9076	2100	9	0	138432	\N
9137	2114	4	0	138434	\N
9137	2115	4	1	138435	\N
10321	2478	5	0	138442	\N
10412	2502	4	0	138444	\N
10412	2503	4	1	34168	\N
10931	2644	3	0	138447	\N
10988	2659	5	0	138449	\N
10988	2660	5	1	138450	\N
11600	2912	3	0	138452	\N
11600	2913	3	1	138453	\N
12501	3264	3	1	138455	\N
12681	3349	6	0	138457	\N
12837	3406	2	1	138459	\N
13211	3593	4	0	138462	\N
13211	3594	4	1	138463	\N
13488	3760	5	1	138464	\N
13661	3849	15	1	138466	\N
14020	4014	11	1	138468	\N
14679	4309	26	0	58806	\N
15153	4464	3	0	138611	\N
15349	777	2	1	138613	\N
15516	3108	4	1	138615	\N
15551	4014	10	1	138617	\N
16813	4964	12	0	138621	\N
17501	5166	8	0	138629	\N
17699	749	2	1	138630	\N
17747	5238	7	0	138632	\N
18005	4952	7	1	138634	\N
18342	4842	10	0	138636	\N
18344	5391	3	0	138638	\N
18484	4914	11	1	138640	\N
18691	2037	8	0	138642	\N
18691	5491	9	0	138644	\N
18881	5523	3	0	138646	\N
19446	973	6	1	138648	\N
19863	5791	7	0	138652	\N
19865	5238	5	0	138654	\N
19979	4914	10	1	138656	\N
20125	2435	9	0	138661	\N
20125	5889	10	0	138663	\N
21240	6251	4	0	138669	\N
21590	6335	9	0	138671	\N
21590	3108	10	1	97541	\N
21651	6355	4	0	138674	\N
22153	6473	11	0	138676	\N
22153	6475	12	0	138678	\N
22289	6512	9	0	138679	\N
22320	6529	13	0	138683	\N
22323	6532	6	0	138685	\N
23132	6753	8	0	138693	\N
23180	6772	9	0	138695	\N
23528	6857	16	0	138697	\N
23699	5992	9	0	138699	\N
23771	6913	5	0	138701	\N
24485	7055	4	0	138703	\N
24967	1970	5	0	138705	\N
24967	7188	6	0	138707	\N
25012	6668	5	0	138709	\N
25145	3268	5	1	138711	\N
25658	7354	8	0	138715	\N
26244	7463	4	0	138717	\N
26271	2171	6	1	138719	\N
26851	7599	8	0	138721	\N
2534	859	3	0	6826	\N
9179	2125	8	0	138436	\N
10455	497	15	0	138445	\N
10992	2664	5	0	138451	\N
12501	3263	3	0	138454	\N
12681	1992	6	1	138456	\N
12837	3405	2	0	138458	\N
12994	3449	5	0	138460	\N
13488	1615	5	0	106140	\N
13661	2368	15	0	138465	\N
14020	4013	11	0	138467	\N
14679	4307	25	0	138608	\N
27149	2435	6	0	114889	\N
27149	7250	7	1	121768	\N
27445	2435	5	0	138725	\N
27445	7187	6	0	138727	\N
27783	2782	7	0	138743	\N
27783	7787	8	0	138744	\N
27786	235	2	0	138767	\N
27786	2757	3	0	138768	\N
27789	4178	2	0	138785	\N
27789	4247	3	0	138786	\N
27791	4172	3	0	138794	\N
27791	5278	4	0	138795	\N
27792	18	3	0	138796	\N
27792	6638	4	0	138797	\N
27795	44	3	0	138826	\N
27795	3631	4	0	138827	\N
27798	453	4	0	138838	\N
27798	4108	5	0	138839	\N
27800	73	4	0	138842	\N
27800	2284	5	0	138843	\N
27801	206	4	0	138129	\N
27801	3511	5	0	138844	\N
27804	7412	6	0	138864	\N
27804	7507	7	0	138865	\N
27808	597	6	0	137675	\N
27808	4697	7	0	138881	\N
27810	40	6	0	138896	\N
27810	4255	7	0	138897	\N
27813	18	3	0	138796	\N
27813	3621	4	0	138925	\N
27815	1109	6	0	134198	\N
27815	4548	7	0	138939	\N
27816	27	3	0	138946	\N
27816	4636	4	0	138947	\N
27819	94	3	0	138964	\N
27819	2864	4	0	138965	\N
27822	142	3	0	137230	\N
27822	4254	4	0	137231	\N
27825	260	3	0	138996	\N
27825	3399	4	0	138997	\N
27828	79	3	0	138212	\N
27828	3652	4	0	139014	\N
27830	7412	12	0	139041	\N
27830	7791	13	0	139042	\N
27833	279	3	0	139053	\N
27833	3641	4	0	139054	\N
27837	94	3	0	139078	\N
27837	2864	4	0	139079	\N
27843	4178	9	0	139124	\N
27843	4682	10	0	139125	\N
27846	4172	3	0	139153	\N
27846	4275	4	0	139154	\N
27849	597	3	0	139165	\N
27849	3656	4	0	139166	\N
27852	230	3	0	139173	\N
27852	4181	4	0	139174	\N
27855	14	6	0	139196	\N
27855	6277	7	0	139197	\N
27858	40	3	0	139208	\N
27858	372	4	0	139209	\N
27861	224	3	0	139235	\N
27861	3603	4	0	139236	\N
27864	94	3	0	139251	\N
27864	2864	4	0	139252	\N
27867	290	3	0	139284	\N
27867	3635	4	0	139285	\N
27870	164	3	0	132507	\N
27870	3385	4	0	132508	\N
27876	206	3	0	138129	\N
27876	4584	4	0	139358	\N
27878	4178	3	0	139367	\N
27878	4211	4	0	139368	\N
27882	54	31	0	139391	\N
27882	7796	32	0	139392	\N
27886	4365	6	0	139439	\N
27886	4172	10	0	139446	\N
27886	4940	11	0	139447	\N
27888	765	3	0	139457	\N
27888	5998	4	0	139458	\N
27889	7798	3	0	139459	\N
27889	7799	3	0	139460	\N
27889	6692	4	0	139461	\N
27889	116	4	1	139462	\N
27892	4172	3	0	139485	\N
27892	4275	4	0	139486	\N
27894	145	3	0	139487	\N
27894	4908	4	0	139488	\N
27895	4178	7	0	139503	\N
27895	4396	8	0	139504	\N
27898	4178	3	0	139503	\N
27898	4211	4	0	139514	\N
27901	4178	6	0	139503	\N
27901	4250	7	0	139535	\N
27904	273	3	0	138840	\N
27904	3638	4	0	139556	\N
27907	424	6	0	138581	\N
27907	3712	7	0	139616	\N
27909	4172	3	0	139624	\N
27909	4275	4	0	139625	\N
27910	5114	3	0	139626	\N
27910	7800	4	0	139627	\N
27913	18	3	0	139649	\N
27913	3621	4	0	139650	\N
27916	4194	3	0	139454	\N
27916	7804	3	0	139679	\N
27916	4788	4	0	139680	\N
27918	7805	3	0	139683	\N
27918	7412	10	0	139686	\N
27918	7806	11	0	139687	\N
27919	12	3	0	137141	\N
27919	4204	4	0	137142	\N
27922	79	3	0	139710	\N
27922	3652	4	0	139711	\N
27925	453	4	0	138838	\N
27925	3294	5	0	139729	\N
27928	4178	3	0	139746	\N
27928	4211	4	0	139747	\N
27931	4172	9	0	139624	\N
27931	7807	10	0	139766	\N
27934	4178	7	0	139746	\N
27934	4396	8	0	139789	\N
27937	391	3	0	139122	\N
27937	3660	4	0	139810	\N
27940	4178	3	0	139819	\N
27940	4211	4	0	139820	\N
27944	4178	3	0	139870	\N
27944	4211	4	0	139871	\N
27947	4178	6	0	139870	\N
27947	4250	7	0	139888	\N
27950	4172	0	0	139893	\N
27953	4172	6	0	139918	\N
27953	4197	7	0	139919	\N
27956	4172	6	0	139918	\N
27956	4197	7	0	139919	\N
27959	260	5	0	138996	\N
27959	4447	6	0	139950	\N
27962	7225	7	0	139959	\N
27962	7810	8	0	139960	\N
27965	244	11	0	138244	\N
27965	7811	12	0	139983	\N
27968	336	11	0	140018	\N
27968	7814	12	0	140019	\N
27971	5885	11	0	140025	\N
27971	7246	12	0	140026	\N
27974	4172	3	0	140020	\N
27974	4275	4	0	140035	\N
27977	7793	46	0	140043	\N
27977	164	126	0	140060	\N
27977	7817	127	0	140061	\N
27980	424	3	0	140094	\N
27980	3611	4	0	140095	\N
27983	4178	6	0	140110	\N
27983	4250	7	0	140111	\N
27986	4172	6	0	140096	\N
27986	4197	7	0	140133	\N
27989	7820	9	0	140156	\N
27989	268	10	0	140157	\N
27992	4178	3	0	140167	\N
27992	4211	4	0	140168	\N
27995	6450	3	0	125868	\N
27995	6847	4	0	131958	\N
27784	365	4	0	135959	\N
27784	3298	5	0	138753	\N
27787	86	5	0	134063	\N
27787	7788	6	0	138779	\N
27790	290	3	0	129209	\N
27790	7789	4	0	138793	\N
27793	156	3	0	138804	\N
27793	4594	4	0	138805	\N
27797	6765	3	0	138829	\N
27797	6884	4	0	138830	\N
27802	115	3	0	137097	\N
27802	3483	4	0	137528	\N
27807	595	6	0	130908	\N
27807	4698	7	0	138880	\N
27811	4172	3	0	138794	\N
27811	4275	4	0	138904	\N
27814	140	6	0	138007	\N
27814	4086	7	0	138938	\N
27817	73	3	0	138954	\N
27817	3040	4	0	138955	\N
27820	4178	3	0	138972	\N
27820	4211	4	0	138973	\N
27823	7412	3	0	138987	\N
27823	7466	4	0	138988	\N
27826	7412	3	0	138998	\N
27826	7466	4	0	138999	\N
27829	246	12	0	139039	\N
27829	7790	13	0	139040	\N
27831	852	12	0	139043	\N
27831	7347	13	0	139044	\N
27832	930	3	0	139051	\N
27832	7792	4	0	139052	\N
27835	40	3	0	139062	\N
27835	372	4	0	139063	\N
27838	324	6	0	137896	\N
27838	5241	7	0	139092	\N
27840	170	3	0	139100	\N
27840	4148	4	0	139101	\N
27844	18	6	0	139138	\N
27844	4180	7	0	139139	\N
27853	141	1	0	139177	\N
27853	140	4	0	139182	\N
27853	2910	5	0	139183	\N
27856	40	6	0	139198	\N
27856	4255	7	0	139199	\N
27859	4172	6	0	139153	\N
27859	4197	7	0	139222	\N
27865	40	4	0	139261	\N
27865	3381	5	0	139262	\N
27868	1656	3	0	138376	\N
27868	5905	4	0	139292	\N
27871	7793	46	0	139295	\N
27871	164	126	0	139334	\N
27871	7794	127	0	139335	\N
27873	4172	3	0	139343	\N
27873	4275	4	0	139344	\N
27874	38	3	0	138882	\N
27874	3457	4	0	139351	\N
27877	290	3	0	139365	\N
27877	3635	4	0	139366	\N
27880	2578	8	0	139386	\N
27880	7795	9	0	139387	\N
27884	115	9	0	137097	\N
27884	5695	10	0	139418	\N
27887	4194	3	0	139454	\N
27887	7797	3	0	139455	\N
27887	5998	4	0	139456	\N
27890	4178	3	0	139469	\N
27890	4211	4	0	139470	\N
27897	251	7	0	139506	\N
27897	3883	8	0	139507	\N
27899	4	3	0	134687	\N
27899	3837	4	0	134688	\N
27902	202	3	0	137823	\N
27902	4857	4	0	137824	\N
27905	90	19	0	131697	\N
27905	6105	20	0	139595	\N
27908	14	3	0	139196	\N
27908	4272	4	0	139623	\N
27911	4178	6	0	139640	\N
27911	4250	7	0	139641	\N
27914	288	3	0	135941	\N
27914	7801	4	0	139657	\N
27923	79	2	0	139710	\N
27923	616	3	0	139712	\N
27926	125	4	0	139730	\N
27926	3356	5	0	139731	\N
27929	7225	3	0	130619	\N
27929	7226	4	0	139055	\N
27932	4178	3	0	139746	\N
27932	4211	4	0	139747	\N
27935	38	7	0	138882	\N
27935	5071	8	0	24394	\N
27939	841	3	0	139811	\N
27939	3604	4	0	139812	\N
27941	1137	4	0	139829	\N
27941	7808	5	0	139830	\N
27943	4172	9	0	139862	\N
27943	4977	10	0	139863	\N
27946	40	3	0	139874	\N
27946	372	4	0	139875	\N
27949	18	6	0	139891	\N
27949	4180	7	0	139892	\N
27952	241	6	0	137033	\N
27952	6412	7	0	137034	\N
27955	4178	6	0	139870	\N
27955	4250	7	0	139888	\N
27958	79	2	0	139939	\N
27958	3180	3	0	139941	\N
27961	279	7	0	139053	\N
27961	7770	8	0	139958	\N
27964	244	0	0	138244	\N
27967	459	11	0	140016	\N
27967	7813	12	0	140017	\N
27970	528	6	0	135965	\N
27970	6720	7	0	140024	\N
27973	268	11	0	130101	\N
27973	7247	12	0	140028	\N
27976	164	3	0	132507	\N
27976	3385	4	0	132508	\N
27979	100	3	0	140086	\N
27979	3836	4	0	140087	\N
27982	4178	3	0	139870	\N
27982	4211	4	0	139871	\N
27985	113	3	0	140119	\N
27985	3620	4	0	140120	\N
27988	5079	9	0	140154	\N
27988	2636	10	0	140155	\N
27991	7821	3	0	140164	\N
27991	7822	3	0	140165	\N
27991	4263	4	0	140166	\N
27994	198	3	0	140171	\N
27994	4263	4	0	140172	\N
27997	597	3	0	139165	\N
27997	3656	4	0	139166	\N
28000	64	3	0	137232	\N
28000	4217	4	0	137233	\N
28003	42	1	0	140196	\N
28003	43	2	0	140197	\N
28006	18	6	0	140211	\N
28006	4180	7	0	140212	\N
28009	7824	46	0	140242	\N
28009	164	85	0	140269	\N
28009	7825	86	0	140270	\N
28012	202	3	0	140284	\N
28012	4857	4	0	140285	\N
28015	1448	3	0	16814	\N
28015	7826	4	0	140305	\N
28018	316	9	0	137597	\N
28018	4279	10	0	140338	\N
28021	4172	2	0	140221	\N
28021	4191	3	0	140346	\N
28024	62	6	0	140369	\N
28024	6466	7	0	140370	\N
28027	33	3	0	140377	\N
28027	3342	4	0	140378	\N
28030	33	0	0	140377	\N
27785	4178	4	0	138522	\N
27785	4331	5	0	138762	\N
27788	4172	5	0	138398	\N
27788	4415	6	0	138780	\N
27794	214	6	0	138818	\N
27794	4681	7	0	138819	\N
27796	212	3	0	138504	\N
27796	3639	4	0	138828	\N
27799	273	4	0	138840	\N
27799	3777	5	0	138841	\N
27803	88	3	0	134657	\N
27803	3655	4	0	138851	\N
27805	214	6	0	138866	\N
27805	4681	7	0	138867	\N
27806	6450	6	0	125868	\N
27806	7269	7	0	125869	\N
27809	38	6	0	138882	\N
27809	6005	7	0	138883	\N
27812	88	6	0	138917	\N
27812	5263	7	0	138918	\N
27818	189	3	0	138962	\N
27818	3782	4	0	138963	\N
27821	241	3	0	137033	\N
27821	3613	4	0	138980	\N
27824	449	3	0	137792	\N
27824	4760	4	0	138989	\N
27827	4178	3	0	139006	\N
27827	4211	4	0	139007	\N
27834	7225	3	0	130619	\N
27834	7226	4	0	139055	\N
27836	4178	3	0	139070	\N
27836	4211	4	0	139071	\N
27839	391	3	0	137997	\N
27839	3660	4	0	139099	\N
27841	2636	3	0	139102	\N
27841	2837	4	0	139103	\N
27842	391	9	0	139122	\N
27842	4107	10	0	139123	\N
27845	852	3	0	139043	\N
27845	3612	4	0	139146	\N
27847	4178	3	0	139155	\N
27847	4211	4	0	139156	\N
27848	6645	3	0	139157	\N
27848	6646	4	0	139158	\N
27850	6450	3	0	125868	\N
27850	6847	4	0	131958	\N
27851	595	3	0	130908	\N
27851	3654	4	0	131957	\N
27854	141	1	0	139177	\N
27854	140	4	0	139182	\N
27854	2910	5	0	139183	\N
27857	4178	3	0	139206	\N
27857	4211	4	0	139207	\N
27860	4178	3	0	139206	\N
27860	4211	4	0	139207	\N
27862	4172	3	0	139237	\N
27862	4275	4	0	139238	\N
27863	4172	3	0	139237	\N
27863	4275	4	0	139238	\N
27866	4178	7	0	139276	\N
27866	4396	8	0	139277	\N
27869	27	3	0	139293	\N
27869	4636	4	0	139294	\N
27872	86	3	0	134063	\N
27872	3746	4	0	139342	\N
27875	266	3	0	137880	\N
27875	3474	4	0	137881	\N
27879	285	3	0	138264	\N
27879	4496	4	0	139369	\N
27881	30	8	0	139388	\N
27881	4030	9	0	139389	\N
27883	54	3	0	139391	\N
27883	3041	4	0	139399	\N
27885	4178	3	0	139425	\N
27885	4211	4	0	139426	\N
27891	4178	3	0	139477	\N
27891	4211	4	0	139478	\N
27893	69	3	0	131240	\N
27893	4536	4	0	136935	\N
27896	322	7	0	135450	\N
27896	2857	8	0	139505	\N
27900	266	3	0	139521	\N
27900	3474	4	0	139522	\N
27903	230	3	0	139548	\N
27903	4181	4	0	139549	\N
27906	6303	3	0	139602	\N
27906	6304	4	0	139603	\N
27912	228	6	0	135212	\N
27912	7585	7	0	139642	\N
27915	7802	3	0	139664	\N
27915	42	7	0	139671	\N
27915	7803	8	0	139672	\N
27917	4787	3	0	139681	\N
27917	4788	4	0	139682	\N
27920	324	3	0	139694	\N
27920	4514	4	0	139695	\N
27921	18	3	0	139702	\N
27921	3621	4	0	139703	\N
27924	30	3	0	139719	\N
27924	3640	4	0	139720	\N
27927	230	3	0	139738	\N
27927	4181	4	0	139739	\N
27930	279	3	0	139053	\N
27930	3641	4	0	139054	\N
27933	113	3	0	139773	\N
27933	3620	4	0	139774	\N
27936	4178	6	0	139802	\N
27936	4250	7	0	139803	\N
27938	2636	3	0	139102	\N
27938	2837	4	0	139103	\N
27942	181	6	0	137892	\N
27942	4256	7	0	139843	\N
27945	4172	3	0	139872	\N
27945	4275	4	0	139873	\N
27948	322	6	0	139889	\N
27948	6313	7	0	139890	\N
27951	241	6	0	137033	\N
27951	6412	7	0	137034	\N
27954	7412	6	0	139041	\N
27954	7507	7	0	139920	\N
27957	79	3	0	139939	\N
27957	3652	4	0	139940	\N
27960	208	5	0	116810	\N
27960	7809	6	0	139951	\N
27963	18	7	0	139961	\N
27963	4538	8	0	139962	\N
27966	2246	4	0	139992	\N
27966	7812	5	0	139993	\N
27969	4172	11	0	140020	\N
27969	7815	12	0	140021	\N
27972	528	11	0	135965	\N
27972	7816	12	0	140027	\N
27975	214	3	0	138866	\N
27975	3496	4	0	140042	\N
27978	453	8	0	140078	\N
27978	7818	9	0	140079	\N
27981	4172	3	0	140096	\N
27981	4275	4	0	140097	\N
27984	60	6	0	138524	\N
27984	6394	7	0	140112	\N
27987	7819	9	0	140152	\N
27987	5885	10	0	140153	\N
27990	7820	9	0	140156	\N
27990	268	10	0	140157	\N
27993	431	3	0	140169	\N
27993	3933	4	0	140170	\N
27996	595	3	0	140179	\N
27996	3654	4	0	140180	\N
27999	64	0	0	137232	\N
28002	18	3	0	139961	\N
28002	3621	4	0	140193	\N
28005	156	6	0	140208	\N
28005	6498	7	0	140210	\N
28008	4172	3	0	140221	\N
28008	4275	4	0	140222	\N
28011	258	2	0	137385	\N
28011	3275	3	0	140277	\N
27998	4178	3	0	140167	\N
27998	4211	4	0	140168	\N
28001	64	0	0	137232	\N
28004	156	5	0	140208	\N
28004	7823	6	0	140209	\N
28007	192	3	0	140219	\N
28007	3790	4	0	140220	\N
28010	164	3	0	140271	\N
28010	3385	4	0	140272	\N
28013	411	6	0	138374	\N
28013	5252	7	0	140298	\N
28016	23	3	0	138491	\N
28016	3497	4	0	140312	\N
28019	7827	1	0	140341	\N
28019	61	2	0	140342	\N
28022	4178	3	0	140353	\N
28022	4211	4	0	140354	\N
28025	14	6	0	139196	\N
28025	6277	7	0	139197	\N
28028	35	3	0	140379	\N
28028	3563	4	0	140380	\N
28031	33	0	0	140377	\N
28034	214	15	0	138866	\N
28034	2138	16	0	140422	\N
28037	27	3	0	139293	\N
28037	4636	4	0	139294	\N
28040	79	3	0	140445	\N
28040	3652	4	0	140449	\N
28043	4172	2	0	140462	\N
28043	4285	3	0	140463	\N
28046	167	0	0	140476	\N
28049	6765	3	0	138829	\N
28049	6884	4	0	138830	\N
28052	4178	3	0	140353	\N
28052	4211	4	0	140354	\N
28055	54	3	0	140499	\N
28055	3041	4	0	140500	\N
28058	597	3	0	140515	\N
28058	3656	4	0	140516	\N
28061	391	3	0	140420	\N
28061	3660	4	0	140525	\N
28064	852	3	0	140536	\N
28064	3612	4	0	140537	\N
28067	6044	6	0	140571	\N
28067	6264	7	0	140572	\N
28070	151	4	0	138125	\N
28070	1876	5	0	140592	\N
28073	7828	23	0	140602	\N
28073	488	126	0	140603	\N
28073	7829	127	0	140604	\N
28076	86	15	0	140636	\N
28076	7832	16	0	140638	\N
28079	35	19	0	140661	\N
28079	7834	20	0	140662	\N
28082	177	3	0	75580	\N
28082	3703	4	0	140673	\N
28085	202	6	0	140711	\N
28085	4079	7	0	140712	\N
28088	4088	4	0	140725	\N
28088	4089	5	0	140726	\N
28091	40	3	0	139874	\N
28091	372	4	0	139875	\N
28099	40	10	0	139874	\N
28099	4104	11	0	140778	\N
28102	7412	3	0	140787	\N
28102	7466	4	0	140788	\N
28103	90	3	0	140795	\N
28103	4074	4	0	140796	\N
28108	841	3	0	139811	\N
28108	3604	4	0	139812	\N
28109	214	3	0	140826	\N
28109	3496	4	0	140827	\N
28111	75	7	0	134993	\N
28111	2859	8	0	140843	\N
28112	40	4	0	140852	\N
28112	2796	5	0	140853	\N
28114	4178	7	0	140870	\N
28114	4396	8	0	140871	\N
28115	100	6	0	140884	\N
28115	7216	7	0	140885	\N
28117	4233	3	0	140894	\N
28117	4425	4	0	140895	\N
28118	4178	4	0	140870	\N
28118	4205	5	0	140904	\N
28121	142	2	0	140931	\N
28121	4418	3	0	140932	\N
28123	453	2	0	140600	\N
28123	3366	3	0	140933	\N
28125	453	2	0	140600	\N
28125	3366	3	0	140933	\N
28127	110	2	0	140938	\N
28127	626	3	0	140939	\N
28129	44	1	0	140941	\N
28129	45	2	0	140942	\N
28133	142	3	0	140931	\N
28133	1044	4	0	140957	\N
28136	7412	4	0	140969	\N
28136	7499	5	0	140970	\N
28139	435	2	0	140989	\N
28139	3413	3	0	140990	\N
28141	637	2	0	140997	\N
28141	7850	3	0	140998	\N
28145	687	3	0	141024	\N
28145	7852	4	0	141025	\N
28146	56	18	0	141034	\N
28146	3415	19	0	141035	\N
28147	75	2	0	134993	\N
28147	284	3	0	141040	\N
28150	151	5	0	141061	\N
28150	5026	6	0	141062	\N
28153	151	2	0	141085	\N
28153	2854	3	0	141086	\N
28156	75	10	0	141118	\N
28156	4628	11	0	141119	\N
28165	167	2	0	141167	\N
28165	3322	3	0	141168	\N
28167	4178	2	0	141171	\N
28167	4247	3	0	141172	\N
28169	7856	27	0	141186	\N
28169	7857	27	0	141187	\N
28169	7858	28	0	141188	\N
28169	7859	28	1	141189	\N
28171	56	4	0	141193	\N
28171	3259	5	0	141194	\N
28184	595	3	0	140179	\N
28184	3654	4	0	140180	\N
28186	7412	3	0	141251	\N
28186	7466	4	0	141252	\N
28187	4178	2	0	141171	\N
28187	4247	3	0	141172	\N
28192	528	2	0	135965	\N
28192	2765	3	0	138564	\N
28197	4178	2	0	141306	\N
28197	4247	3	0	141307	\N
28207	4172	2	0	141218	\N
28207	4191	3	0	141219	\N
28209	678	3	0	136826	\N
28209	7707	4	0	136827	\N
28214	4178	3	0	141379	\N
28214	4211	4	0	141380	\N
28217	6203	2	0	141390	\N
28217	2782	4	0	141393	\N
28217	2959	5	0	141394	\N
28221	40	2	0	141403	\N
28221	282	3	0	141404	\N
28228	140	2	0	141427	\N
28228	3183	3	0	141428	\N
28231	88	6	0	141447	\N
28231	5263	7	0	141448	\N
28238	94	4	0	141470	\N
28238	6644	5	0	141471	\N
28242	4172	3	0	141484	\N
28242	4275	4	0	141485	\N
28247	4172	3	0	141512	\N
28247	4275	4	0	141513	\N
28249	123	3	0	132155	\N
28249	2856	4	0	133061	\N
28014	102	3	0	135242	\N
28014	3597	4	0	135243	\N
28017	336	3	0	140018	\N
28017	3400	4	0	140319	\N
28020	7827	2	0	140341	\N
28020	4544	3	0	140345	\N
28023	73	3	0	140355	\N
28023	3040	4	0	140356	\N
28026	33	0	0	137861	\N
28029	33	0	0	140377	\N
28032	94	4	0	140388	\N
28032	4677	5	0	140389	\N
28035	7466	3	0	139687	\N
28035	7412	4	0	140429	\N
28038	852	3	0	140439	\N
28038	3612	4	0	140440	\N
28041	242	3	0	138386	\N
28041	2839	4	0	140456	\N
28044	167	6	0	140476	\N
28044	5066	7	0	140477	\N
28047	262	3	0	138378	\N
28047	4778	4	0	140484	\N
28050	54	8	0	140487	\N
28050	7517	9	0	140488	\N
28053	402	2	0	140491	\N
28053	2760	3	0	140497	\N
28056	113	3	0	140507	\N
28056	3620	4	0	140508	\N
28059	595	3	0	140179	\N
28059	3654	4	0	140180	\N
28062	336	3	0	140532	\N
28062	3400	4	0	140533	\N
28065	4172	9	0	140534	\N
28065	4977	10	0	140556	\N
28068	132	4	0	135939	\N
28068	3716	5	0	140581	\N
28071	151	6	0	138125	\N
28071	3588	7	0	140599	\N
28074	3208	15	0	125066	\N
28074	7830	16	0	140635	\N
28075	86	10	0	140636	\N
28075	7831	11	0	140637	\N
28077	3208	5	0	125066	\N
28077	7833	6	0	140639	\N
28080	258	19	0	140663	\N
28080	7835	20	0	140664	\N
28083	7837	3	0	140680	\N
28083	6044	11	0	140695	\N
28083	7838	12	0	140696	\N
28086	3628	6	0	132360	\N
28086	7839	7	0	140713	\N
28086	7840	7	1	140714	\N
28089	233	4	0	137374	\N
28089	3775	5	0	140727	\N
28092	7412	3	0	140735	\N
28092	7466	4	0	140736	\N
28096	170	4	0	139100	\N
28096	4680	5	0	140755	\N
28105	242	7	0	140814	\N
28105	4592	8	0	140815	\N
28120	7844	4	0	140920	\N
28120	7237	6	0	140923	\N
28120	7845	6	0	140924	\N
28120	7846	7	0	140925	\N
28120	7847	7	1	140926	\N
28122	142	2	0	140931	\N
28122	4418	3	0	140932	\N
28124	453	2	0	140600	\N
28124	3366	3	0	140933	\N
28126	142	2	0	140931	\N
28126	4418	3	0	140932	\N
28130	110	1	0	140938	\N
28130	134	2	0	140943	\N
28132	151	3	0	140946	\N
28132	3046	4	0	140950	\N
28134	242	3	0	140814	\N
28134	5519	4	0	140958	\N
28135	140	3	0	140959	\N
28135	7849	4	0	140960	\N
28138	58	3	0	140983	\N
28138	3665	4	0	140984	\N
28142	100	2	0	140999	\N
28142	633	3	0	141000	\N
28144	125	2	0	139730	\N
28144	3297	3	0	141017	\N
28149	793	2	0	137871	\N
28149	4363	3	0	141050	\N
28152	264	5	0	141079	\N
28152	6998	6	0	141080	\N
28155	40	3	0	141097	\N
28155	372	4	0	141098	\N
28158	453	7	0	141144	\N
28158	5832	8	0	141145	\N
28160	264	7	0	141148	\N
28160	6187	8	0	141149	\N
28163	189	7	0	138962	\N
28163	7853	8	0	141154	\N
28164	4201	1	0	141157	\N
28164	4172	4	0	141162	\N
28164	4285	5	0	140738	\N
28166	167	2	0	141167	\N
28166	7854	3	0	141169	\N
28166	7855	3	1	141170	\N
28168	4	0	0	141173	\N
28172	170	7	0	141209	\N
28172	6624	8	0	141210	\N
28174	33	2	0	140377	\N
28174	2822	3	0	141216	\N
28177	3625	2	0	141220	\N
28177	4359	3	0	141221	\N
28179	4233	2	0	140894	\N
28179	5577	3	0	141223	\N
28181	40	2	0	141241	\N
28181	282	3	0	141242	\N
28185	597	3	0	140515	\N
28185	3656	4	0	140516	\N
28188	170	2	0	141209	\N
28188	1380	3	0	141261	\N
28193	56	0	0	141283	\N
28195	108	3	0	131735	\N
28195	4171	4	0	134529	\N
28198	235	3	0	141314	\N
28198	3343	4	0	141315	\N
28200	110	2	0	140938	\N
28200	626	3	0	140939	\N
28205	210	2	0	141345	\N
28205	1874	3	0	141346	\N
28210	4	3	0	141359	\N
28210	3837	4	0	141360	\N
28212	273	2	0	141371	\N
28212	1413	3	0	141372	\N
28219	4178	2	0	141399	\N
28219	4247	3	0	141400	\N
28226	300	2	0	141414	\N
28226	2786	3	0	141420	\N
28236	2636	2	0	139102	\N
28236	2836	3	0	141467	\N
28239	40	2	0	141403	\N
28239	282	3	0	141404	\N
28240	360	2	0	134220	\N
28240	2767	3	0	141476	\N
28245	189	2	0	138962	\N
28245	3441	3	0	141498	\N
28248	6723	3	0	138304	\N
28248	6724	4	0	141514	\N
28252	40	6	0	141403	\N
28252	4255	7	0	141549	\N
28258	6	2	0	141565	\N
28258	2805	3	0	141566	\N
28260	79	3	0	141547	\N
28260	3652	4	0	141574	\N
28262	435	3	0	141576	\N
28262	3504	4	0	141577	\N
28265	18	2	0	140211	\N
28265	1685	3	0	141590	\N
28274	7412	2	0	141632	\N
28274	7430	3	0	141633	\N
28033	391	15	0	140420	\N
28033	2680	16	0	140421	\N
28036	7828	23	0	140430	\N
28036	488	126	0	140431	\N
28036	7829	127	0	140432	\N
28039	79	2	0	140445	\N
28039	616	3	0	140446	\N
28042	242	2	0	138386	\N
28042	4576	3	0	140457	\N
28045	167	0	0	140476	\N
28048	212	3	0	140485	\N
28048	3639	4	0	140486	\N
28051	402	1	0	140491	\N
28051	403	2	0	140492	\N
28054	402	3	0	140491	\N
28054	4077	4	0	140498	\N
28057	6450	3	0	125868	\N
28057	6847	4	0	131958	\N
28060	258	3	0	140517	\N
28060	4401	4	0	140518	\N
28063	4172	3	0	140534	\N
28063	4275	4	0	140535	\N
28066	4178	6	0	140569	\N
28066	4250	7	0	140570	\N
28069	4	4	0	140582	\N
28069	4117	5	0	140583	\N
28072	453	6	0	140600	\N
28072	4091	7	0	140601	\N
28078	56	1	0	140640	\N
28078	1088	2	0	140641	\N
28081	94	19	0	140665	\N
28081	7836	20	0	140666	\N
28084	119	6	0	140709	\N
28084	3644	7	0	140710	\N
28087	3625	6	0	140715	\N
28087	3642	7	0	140716	\N
28090	64	4	0	137232	\N
28090	3911	5	0	140728	\N
28093	4172	3	0	140737	\N
28093	4275	4	0	140738	\N
28094	18	3	0	140211	\N
28094	3621	4	0	140739	\N
28095	4178	3	0	140569	\N
28095	4211	4	0	140746	\N
28097	38	4	0	138882	\N
28097	5656	5	0	140756	\N
28098	4172	10	0	140737	\N
28098	4663	11	0	140777	\N
28100	2351	10	0	140779	\N
28100	5603	11	0	140780	\N
28101	20	3	0	134971	\N
28101	2844	4	0	134978	\N
28104	7841	63	0	140797	\N
28104	365	126	0	140798	\N
28104	7842	127	0	140799	\N
28106	365	7	0	140816	\N
28106	5248	8	0	140817	\N
28107	6044	3	0	140824	\N
28107	6045	4	0	140825	\N
28110	132	7	0	135939	\N
28110	3709	8	0	140842	\N
28113	908	7	0	140868	\N
28113	4078	8	0	140869	\N
28116	79	3	0	140892	\N
28116	3652	4	0	140893	\N
28119	7412	3	0	140787	\N
28119	7843	4	0	140911	\N
28128	71	1	0	136356	\N
28128	72	2	0	140940	\N
28131	151	2	0	140946	\N
28131	7848	3	0	140947	\N
28137	12	2	0	140975	\N
28137	2804	3	0	140976	\N
28140	14	2	0	140995	\N
28140	1785	3	0	140996	\N
28143	202	6	0	140711	\N
28143	7851	7	0	141012	\N
28148	200	2	0	137174	\N
28148	276	3	0	141045	\N
28151	453	2	0	141067	\N
28151	3366	3	0	141068	\N
28154	56	3	0	141090	\N
28154	4102	4	0	141091	\N
28157	40	4	0	141128	\N
28157	2796	5	0	141129	\N
28159	391	7	0	141146	\N
28159	3334	8	0	141147	\N
28161	94	7	0	141150	\N
28161	5608	8	0	141151	\N
28162	75	7	0	141152	\N
28162	3331	8	0	141153	\N
28170	4	2	0	141173	\N
28170	2751	3	0	141190	\N
28173	841	7	0	139811	\N
28173	4489	8	0	141211	\N
28175	119	2	0	140709	\N
28175	1879	3	0	141217	\N
28176	4172	2	0	141218	\N
28176	4191	3	0	141219	\N
28178	3628	2	0	132360	\N
28178	4360	3	0	141222	\N
28180	71	6	0	136356	\N
28180	4738	7	0	141236	\N
28182	20	3	0	141249	\N
28182	2844	4	0	141250	\N
28183	6450	3	0	125868	\N
28183	6847	4	0	131958	\N
28189	4178	5	0	141272	\N
28189	4429	6	0	141273	\N
28190	228	5	0	135212	\N
28190	7860	6	0	141274	\N
28191	56	4	0	141277	\N
28191	3259	5	0	141278	\N
28194	4451	2	0	141288	\N
28194	7861	3	0	141289	\N
28196	40	2	0	141300	\N
28196	282	3	0	141301	\N
28199	110	3	0	140938	\N
28199	3328	4	0	141322	\N
28201	192	1	0	140219	\N
28201	2944	2	0	141325	\N
28202	4178	1	0	141326	\N
28202	4460	2	0	141327	\N
14510	4244	8	0	138607	\N
15349	4513	2	0	138614	\N
16339	2466	5	0	138619	\N
16339	4805	5	1	138620	\N
16813	4965	12	1	138622	\N
17501	5167	8	1	89073	\N
17699	5225	2	0	138631	\N
17747	5240	7	1	138633	\N
18005	5307	7	0	138635	\N
18484	5429	11	0	138641	\N
18881	5524	3	1	138647	\N
19446	5673	6	0	138649	\N
19617	5699	11	0	138650	\N
19863	5792	7	1	138653	\N
21240	6252	4	1	138670	\N
21651	6356	4	1	138675	\N
22289	6514	10	0	138681	\N
23132	6754	8	1	138694	\N
23180	6773	9	1	138696	\N
23528	6858	16	1	138698	\N
23699	6892	9	1	138700	\N
23771	6914	5	1	138702	\N
24485	7056	4	1	138704	\N
25012	7206	5	1	138710	\N
25145	7236	5	0	138712	\N
25362	7297	6	1	138714	\N
25658	7355	8	1	138716	\N
26244	7464	4	1	138718	\N
26271	7467	6	0	138720	\N
26851	7600	8	1	138722	\N
28203	241	1	0	141328	\N
28203	3094	2	0	141329	\N
28206	20	2	0	141249	\N
28206	369	3	0	141347	\N
28208	4178	2	0	141326	\N
28208	4247	3	0	141352	\N
28215	38	3	0	138882	\N
28215	3445	4	0	141386	\N
28218	6203	2	0	141390	\N
28218	2782	4	0	141393	\N
28218	2959	5	0	141394	\N
28220	316	2	0	141401	\N
28220	1900	3	0	141402	\N
28222	198	2	0	140171	\N
28222	513	3	0	141405	\N
28224	164	3	0	141412	\N
28224	3385	4	0	141413	\N
28227	38	2	0	141425	\N
28227	4009	3	0	141426	\N
28229	290	3	0	139365	\N
28229	3635	4	0	139366	\N
28232	132	6	0	141449	\N
28232	4690	7	0	141450	\N
28234	186	3	0	135045	\N
28234	4294	4	0	135046	\N
28237	4178	2	0	141468	\N
28237	4247	3	0	141469	\N
28241	424	2	0	140094	\N
28241	2755	3	0	141477	\N
28243	192	2	0	141490	\N
28243	2761	3	0	141491	\N
28250	6723	53	0	138304	\N
28250	7864	54	0	141534	\N
28263	7412	2	0	141582	\N
28263	7430	3	0	141583	\N
28266	4	2	0	141359	\N
28266	2751	3	0	141591	\N
28268	56	17	0	141608	\N
28268	7865	18	0	141609	\N
28270	60	2	0	138524	\N
28270	4544	3	0	138525	\N
28275	90	2	0	141634	\N
28275	3442	3	0	141635	\N
28277	135	2	0	138200	\N
28277	2722	3	0	138201	\N
28281	4172	3	0	141647	\N
28281	4275	4	0	141648	\N
28289	140	2	0	141675	\N
28289	3183	3	0	141676	\N
28290	4172	3	0	141655	\N
28290	4275	4	0	141656	\N
28293	121	0	0	138029	\N
28302	132	6	0	141449	\N
28302	4690	7	0	141450	\N
28306	135	4	0	138200	\N
28306	4353	5	0	141755	\N
28312	316	2	0	141401	\N
28312	1900	3	0	141402	\N
28316	100	5	0	140999	\N
28316	7057	6	0	141840	\N
28321	62	2	0	140369	\N
28321	2191	3	0	141858	\N
28324	402	2	0	141882	\N
28324	2760	3	0	141883	\N
28328	192	2	0	141490	\N
28328	2761	3	0	141491	\N
28333	6450	2	0	125868	\N
28333	6825	3	0	127092	\N
28336	167	8	0	141689	\N
28336	7870	9	0	141933	\N
28342	4787	8	0	141671	\N
28342	7871	9	0	141964	\N
28344	181	2	0	141970	\N
28344	3313	3	0	141971	\N
28347	324	8	0	139694	\N
28347	7873	9	0	141991	\N
28352	435	2	0	141576	\N
28352	3413	3	0	142015	\N
28359	64	2	0	142044	\N
28359	277	3	0	142045	\N
28366	273	2	0	142080	\N
28366	1413	3	0	142081	\N
28369	156	2	0	141884	\N
28369	4485	3	0	141885	\N
28373	244	2	0	142096	\N
28373	3308	3	0	142097	\N
28376	229	1	0	142100	\N
28376	228	3	0	142103	\N
28376	1432	4	0	142104	\N
28377	7875	24	0	142112	\N
28377	1018	25	0	142113	\N
28377	7876	25	0	142114	\N
28379	132	2	0	142121	\N
28379	2756	3	0	142122	\N
28381	212	2	0	140485	\N
28381	3616	3	0	142129	\N
28388	1470	3	0	138262	\N
28388	5036	4	0	142156	\N
28394	4172	2	0	142170	\N
28394	4191	3	0	142171	\N
28399	4172	3	0	142188	\N
28399	4275	4	0	142189	\N
28404	4172	2	0	142188	\N
28404	4191	3	0	142209	\N
28406	7225	2	0	139959	\N
28406	7882	3	0	142212	\N
28408	908	3	0	142220	\N
28408	7883	4	0	142221	\N
28412	167	2	0	142231	\N
28412	3322	3	0	142232	\N
28417	657	2	0	142255	\N
28417	7888	3	0	142256	\N
28420	64	4	0	142277	\N
28420	7890	5	0	142278	\N
28424	54	14	0	140499	\N
28424	2868	15	0	142315	\N
28429	7412	4	0	142324	\N
28429	7426	5	0	142335	\N
28434	4172	7	0	142188	\N
28434	4537	8	0	142364	\N
28441	140	3	0	141675	\N
28441	4149	4	0	142405	\N
28446	208	4	0	116810	\N
28446	7894	5	0	142431	\N
28451	4178	2	0	142432	\N
28451	4247	3	0	142442	\N
28452	4172	6	0	142455	\N
28452	4365	7	0	142456	\N
28453	2	2	0	137894	\N
28453	2789	3	0	138218	\N
28457	233	2	0	137374	\N
28457	1849	3	0	142470	\N
28461	793	2	0	142479	\N
28461	4363	3	0	142480	\N
28465	4178	2	0	142493	\N
28465	4247	3	0	142494	\N
28468	56	2	0	142500	\N
28468	2914	3	0	142501	\N
28470	7412	4	0	142512	\N
28470	7426	5	0	142513	\N
28473	189	3	0	142535	\N
28473	7896	4	0	142536	\N
28476	73	2	0	142549	\N
28476	2766	3	0	142550	\N
28478	4172	2	0	142463	\N
28478	4191	3	0	142464	\N
28480	75	2	0	142558	\N
28480	284	3	0	142559	\N
28487	7412	2	0	142578	\N
28487	7430	3	0	142579	\N
28489	2	2	0	137894	\N
28489	2789	3	0	138218	\N
28490	391	7	0	142510	\N
28490	7898	8	0	142604	\N
28492	212	7	0	142164	\N
28492	7900	8	0	142606	\N
28494	373	2	0	142613	\N
28204	7412	5	0	141251	\N
28204	7478	6	0	141340	\N
28211	82	2	0	141365	\N
28211	3401	3	0	141366	\N
28213	149	2	0	138314	\N
28213	1379	3	0	138315	\N
28216	6203	2	0	141390	\N
28216	2782	4	0	141393	\N
28216	2959	5	0	141394	\N
12994	3450	5	1	138461	\N
14510	3843	8	1	138606	\N
15153	4465	3	1	138612	\N
19617	5700	11	1	138651	\N
25362	7296	6	0	138713	\N
28225	300	2	0	141414	\N
28225	706	3	0	141415	\N
28230	156	6	0	141445	\N
28230	6498	7	0	141446	\N
28233	1109	6	0	134198	\N
28233	4548	7	0	138939	\N
28235	7862	2	0	141461	\N
28235	7863	3	0	141462	\N
28244	115	2	0	141492	\N
28244	2797	3	0	141493	\N
28246	288	3	0	141505	\N
28246	3003	4	0	141506	\N
28251	79	6	0	141547	\N
28251	4253	7	0	141548	\N
28253	14	2	0	140995	\N
28253	1785	3	0	140996	\N
28255	4178	2	0	141468	\N
28255	4247	3	0	141469	\N
28257	391	2	0	141146	\N
28257	1381	3	0	141564	\N
28264	4178	2	0	141588	\N
28264	4247	3	0	141589	\N
28269	167	2	0	141167	\N
28269	3322	3	0	141168	\N
28271	96	2	0	141618	\N
28271	2347	3	0	141619	\N
28273	102	2	0	135242	\N
28273	3053	3	0	141567	\N
28276	137	2	0	136041	\N
28276	2721	3	0	138199	\N
28282	4172	3	0	141655	\N
28282	4275	4	0	141656	\N
28284	288	2	0	141663	\N
28284	2842	3	0	141664	\N
28287	12	2	0	141673	\N
28287	2804	3	0	141674	\N
28295	121	2	0	138029	\N
28295	2498	3	0	138030	\N
28298	424	5	0	140094	\N
28298	5002	6	0	141712	\N
28300	44	2	0	141719	\N
28300	1910	3	0	141720	\N
28303	132	2	0	141738	\N
28303	2756	3	0	141739	\N
28308	841	2	0	141762	\N
28308	3316	3	0	141764	\N
28309	4178	11	0	141669	\N
28309	6011	12	0	141785	\N
28314	113	54	0	141828	\N
28314	7867	55	0	141829	\N
28319	391	2	0	141851	\N
28319	1381	3	0	141852	\N
28322	94	5	0	141859	\N
28322	3153	6	0	141860	\N
28327	2782	2	0	141886	\N
28327	2784	3	0	141887	\N
28329	198	2	0	140171	\N
28329	513	3	0	141405	\N
28334	597	2	0	141914	\N
28334	3286	3	0	141915	\N
28339	46	2	0	129457	\N
28339	2348	3	0	29089	\N
28345	125	2	0	141972	\N
28345	3297	3	0	141973	\N
28350	12	2	0	141673	\N
28350	2804	3	0	141674	\N
28354	64	2	0	142020	\N
28354	277	3	0	142021	\N
28357	453	2	0	141144	\N
28357	3366	3	0	142042	\N
28364	7874	6	0	142067	\N
28364	3314	7	0	142069	\N
28367	149	2	0	138314	\N
28367	1379	3	0	138315	\N
28370	33	2	0	142087	\N
28370	2822	3	0	142088	\N
28371	206	2	0	142089	\N
28371	2773	3	0	142090	\N
28384	123	2	0	132155	\N
28384	1868	3	0	138306	\N
28387	6723	2	0	138304	\N
28387	6763	3	0	138305	\N
28389	121	7	0	142159	\N
28389	7878	8	0	142160	\N
28391	6765	3	0	142127	\N
28391	7879	4	0	142162	\N
28395	324	2	0	139694	\N
28395	2808	3	0	142176	\N
28400	102	3	0	142190	\N
28400	3597	4	0	142191	\N
28402	40	4	0	142202	\N
28402	2796	5	0	142203	\N
28405	7881	2	0	142210	\N
28405	3053	3	0	142211	\N
28409	4178	3	0	142222	\N
28409	4441	4	0	142223	\N
28415	288	5	0	142245	\N
28415	7887	6	0	142246	\N
28418	64	5	0	142044	\N
28418	7889	6	0	142266	\N
28421	54	2	0	140499	\N
28421	3351	3	0	142283	\N
28425	79	2	0	142320	\N
28425	616	3	0	142321	\N
28432	28	1	0	142345	\N
28432	27	3	0	142348	\N
28432	2885	4	0	142349	\N
28435	58	2	0	142369	\N
28435	2853	3	0	142370	\N
28437	214	2	0	142389	\N
28437	1259	3	0	142390	\N
28439	135	2	0	138200	\N
28439	2722	3	0	138201	\N
28444	20	5	0	141249	\N
28444	7893	6	0	142421	\N
28447	4178	4	0	142432	\N
28447	4331	5	0	142433	\N
28449	279	4	0	139053	\N
28449	3430	5	0	142435	\N
28454	202	2	0	142461	\N
28454	2764	3	0	142462	\N
28458	4088	2	0	142471	\N
28458	4332	3	0	142472	\N
28459	210	2	0	141345	\N
28459	1874	3	0	141346	\N
28462	5885	2	0	142485	\N
28462	6838	3	0	142486	\N
28463	268	2	0	142487	\N
28463	2800	3	0	142488	\N
28467	40	2	0	142224	\N
28467	282	3	0	142499	\N
28469	391	4	0	142510	\N
28469	3352	5	0	142511	\N
28471	4178	4	0	142522	\N
28471	4331	5	0	142523	\N
28474	242	2	0	140814	\N
28474	3425	3	0	142014	\N
28479	4178	2	0	142556	\N
28479	4247	3	0	142557	\N
28481	142	2	0	142564	\N
28481	4418	3	0	142565	\N
28483	1914	2	0	142568	\N
28483	1916	3	0	142569	\N
28254	202	2	0	141558	\N
28254	2764	3	0	141559	\N
28256	4178	2	0	141468	\N
28256	4247	3	0	141469	\N
28259	102	2	0	135242	\N
28259	3053	3	0	141567	\N
28261	4178	3	0	141468	\N
28261	4211	4	0	141575	\N
28267	4172	3	0	141598	\N
28267	4275	4	0	141599	\N
28272	170	3	0	141626	\N
28272	4148	4	0	141627	\N
28279	4178	2	0	141640	\N
28279	4247	3	0	141641	\N
28286	4787	2	0	141671	\N
28286	6245	3	0	141672	\N
28288	38	2	0	141425	\N
28288	4009	3	0	141426	\N
28292	202	2	0	141687	\N
28292	2764	3	0	141688	\N
28297	79	5	0	141547	\N
28297	3341	6	0	141702	\N
28299	391	2	0	141717	\N
28299	1381	3	0	141718	\N
28304	402	3	0	140491	\N
28304	4077	4	0	140498	\N
28305	137	4	0	136041	\N
28305	4352	5	0	141754	\N
28307	841	3	0	141762	\N
28307	3604	4	0	141763	\N
28311	266	2	0	141802	\N
28311	2103	3	0	141803	\N
28313	4178	2	0	141808	\N
28313	4247	3	0	141809	\N
28318	4172	2	0	141655	\N
28318	4191	3	0	141846	\N
28323	7868	4	0	141869	\N
28323	18	8	0	141876	\N
28323	5946	9	0	141877	\N
28326	156	2	0	141884	\N
28326	4485	3	0	141885	\N
28331	411	6	0	141906	\N
28331	6310	7	0	141907	\N
28338	142	2	0	140931	\N
28338	4418	3	0	140932	\N
28340	360	2	0	141944	\N
28340	2767	3	0	141945	\N
28341	4178	8	0	141962	\N
28341	6240	9	0	141963	\N
28343	40	8	0	141732	\N
28343	3438	9	0	141965	\N
28346	102	8	0	135242	\N
28346	7872	9	0	141990	\N
28349	316	4	0	142008	\N
28349	2790	5	0	142009	\N
28353	242	0	0	140814	\N
28356	202	2	0	141687	\N
28356	2764	3	0	141688	\N
28358	35	2	0	140661	\N
28358	1191	3	0	142043	\N
28361	6303	2	0	142052	\N
28361	7173	3	0	142053	\N
28363	7874	4	0	142067	\N
28363	3428	5	0	142068	\N
28368	145	2	0	139487	\N
28368	1108	3	0	142086	\N
28372	4178	2	0	141962	\N
28372	4247	3	0	142095	\N
28375	41	1	0	142105	\N
28375	40	3	0	142106	\N
28375	1383	4	0	142107	\N
28383	73	3	0	142141	\N
28383	1958	4	0	142142	\N
28386	4178	2	0	142148	\N
28386	4247	3	0	142149	\N
28390	149	3	0	138314	\N
28390	2374	4	0	142161	\N
28392	121	3	0	142159	\N
28392	2317	4	0	142163	\N
28397	75	1	0	141152	\N
28397	1427	2	0	142177	\N
28398	4178	2	0	142148	\N
28398	4247	3	0	142149	\N
28401	4178	4	0	142200	\N
28401	4331	5	0	142201	\N
28403	4178	2	0	142200	\N
28403	4247	3	0	142208	\N
28411	411	3	0	141906	\N
28411	7884	4	0	142226	\N
28414	7885	19	0	142233	\N
28414	167	42	0	142234	\N
28414	6697	43	0	142235	\N
28414	7886	43	1	142236	\N
28422	67	2	0	137672	\N
28422	394	3	0	142284	\N
28423	56	5	0	142285	\N
28423	2727	6	0	142286	\N
28427	7412	2	0	142324	\N
28427	7430	3	0	142325	\N
28428	79	37	0	142320	\N
28428	7891	38	0	142326	\N
28431	75	2	0	142341	\N
28431	284	3	0	142342	\N
28433	28	1	0	142345	\N
28433	27	3	0	142348	\N
28433	2885	4	0	142349	\N
28436	30	41	0	142387	\N
28436	7892	42	0	142388	\N
28438	137	2	0	142391	\N
28438	2721	3	0	142392	\N
28440	288	2	0	142397	\N
28440	2842	3	0	142398	\N
28443	4178	2	0	142222	\N
28443	4247	3	0	142340	\N
28445	64	5	0	142277	\N
28445	7889	6	0	142422	\N
28448	7225	4	0	139959	\N
28448	7895	5	0	142434	\N
28450	200	2	0	142440	\N
28450	276	3	0	142441	\N
28456	241	2	0	141328	\N
28456	634	3	0	142465	\N
28464	14	2	0	142410	\N
28464	1785	3	0	142411	\N
28475	326	2	0	142119	\N
28475	393	3	0	142120	\N
28486	214	2	0	142389	\N
28486	1259	3	0	142390	\N
28496	4172	2	0	142621	\N
28496	4191	3	0	142622	\N
28499	64	2	0	142277	\N
28499	277	3	0	142645	\N
28501	7225	3	0	139959	\N
28501	7226	4	0	142652	\N
28504	235	3	0	142663	\N
28504	3343	4	0	142664	\N
28506	4178	3	0	142556	\N
28506	4211	4	0	142666	\N
28508	300	21	0	142676	\N
28508	7901	22	0	142677	\N
28518	4178	4	0	142556	\N
28518	4205	5	0	142718	\N
28525	135	5	0	138200	\N
28525	7905	6	0	142749	\N
28527	4172	4	0	142765	\N
28527	4219	5	0	142766	\N
28532	258	2	0	140663	\N
28532	3275	3	0	142795	\N
28535	132	2	0	142799	\N
28535	2756	3	0	142800	\N
28539	597	2	0	141914	\N
28539	3286	3	0	141915	\N
28541	7642	1	0	142818	\N
28541	7412	3	0	142820	\N
28541	7908	4	0	142579	\N
28546	189	2	0	142847	\N
28546	3441	3	0	142849	\N
28278	424	2	0	140094	\N
28278	2755	3	0	141477	\N
28280	424	2	0	140094	\N
28280	2755	3	0	141477	\N
28283	2081	3	0	141657	\N
28283	7866	4	0	141658	\N
28285	4178	2	0	141669	\N
28285	4247	3	0	141670	\N
28291	64	3	0	137232	\N
28291	4217	4	0	137233	\N
28294	167	2	0	141689	\N
28294	3322	3	0	141690	\N
28296	2	5	0	137894	\N
28296	3624	6	0	141701	\N
28301	40	6	0	141732	\N
28301	4255	7	0	141733	\N
28310	23	5	0	141796	\N
28310	4564	6	0	141797	\N
28315	113	2	0	141828	\N
28315	1899	3	0	141830	\N
28317	75	5	0	141152	\N
28317	4484	6	0	141841	\N
28320	62	3	0	140369	\N
28320	7618	4	0	141853	\N
28325	402	2	0	141882	\N
28325	2760	3	0	141883	\N
28330	290	6	0	141904	\N
28330	7869	7	0	141905	\N
28332	189	6	0	141908	\N
28332	4362	7	0	141909	\N
28335	595	2	0	140179	\N
28335	3285	3	0	141916	\N
28337	125	8	0	141934	\N
28337	6499	9	0	141935	\N
28348	56	16	0	141998	\N
28348	4791	17	0	141999	\N
28351	242	2	0	140814	\N
28351	3425	3	0	142014	\N
28355	40	5	0	142032	\N
28355	5806	6	0	142033	\N
28360	100	2	0	142050	\N
28360	633	3	0	142051	\N
28362	92	2	0	138362	\N
28362	2763	3	0	142058	\N
28365	224	2	0	142074	\N
28365	3150	3	0	142075	\N
28374	229	1	0	142100	\N
28374	228	3	0	142103	\N
28374	1432	4	0	142104	\N
28378	326	2	0	142119	\N
28378	393	3	0	142120	\N
28380	6765	2	0	142127	\N
28380	6841	3	0	142128	\N
28382	367	2	0	136079	\N
28382	3329	3	0	142134	\N
28385	1463	2	0	135890	\N
28385	7877	3	0	142147	\N
28393	212	3	0	142164	\N
28393	7880	4	0	142165	\N
28396	125	2	0	141972	\N
28396	3297	3	0	141973	\N
28407	279	2	0	139053	\N
28407	4525	3	0	142213	\N
28410	40	3	0	142224	\N
28410	1921	4	0	142225	\N
28413	75	1	0	141152	\N
28413	1427	2	0	142177	\N
28416	4787	2	0	141671	\N
28416	6245	3	0	141672	\N
28419	230	4	0	142275	\N
28419	6806	5	0	142276	\N
28426	2636	2	0	142322	\N
28426	2836	3	0	142323	\N
28430	4178	2	0	142222	\N
28430	4247	3	0	142340	\N
28442	14	2	0	142410	\N
28442	1785	3	0	142411	\N
28455	4172	2	0	142463	\N
28455	4191	3	0	142464	\N
28460	110	2	0	142477	\N
28460	626	3	0	142478	\N
28466	4172	2	0	142463	\N
28466	4191	3	0	142464	\N
28472	1021	2	0	142528	\N
28472	4432	3	0	142529	\N
28477	322	2	0	139889	\N
28477	1866	3	0	142551	\N
28482	117	2	0	142566	\N
28482	1257	3	0	142567	\N
28484	40	2	0	142570	\N
28484	282	3	0	142571	\N
28488	244	3	0	142096	\N
28488	7897	4	0	142585	\N
28491	6765	7	0	142127	\N
28491	7899	8	0	142605	\N
28493	79	2	0	142611	\N
28493	616	3	0	142612	\N
28498	170	7	0	142639	\N
28498	6624	8	0	142640	\N
28503	54	3	0	142661	\N
28503	3041	4	0	142662	\N
28507	300	2	0	142671	\N
28507	2786	3	0	142672	\N
28509	202	3	0	142684	\N
28509	4857	4	0	142685	\N
28513	960	5	0	142702	\N
28513	7902	6	0	142703	\N
28516	69	4	0	131240	\N
28516	4041	5	0	142716	\N
28520	79	3	0	142611	\N
28520	3652	4	0	142732	\N
28522	140	3	0	142623	\N
28522	4149	4	0	142735	\N
28524	137	5	0	142391	\N
28524	7904	6	0	142748	\N
28529	345	4	0	142769	\N
28529	7906	5	0	142770	\N
28534	244	2	0	142797	\N
28534	3308	3	0	142798	\N
28536	4172	4	0	142807	\N
28536	4219	5	0	142808	\N
28543	345	5	0	142769	\N
28543	7910	6	0	142839	\N
28548	14	2	0	142410	\N
28548	1785	3	0	142411	\N
28552	3628	2	0	132360	\N
28552	4360	3	0	141222	\N
28554	90	4	0	141634	\N
28554	3731	5	0	142861	\N
28562	210	9	0	141345	\N
28562	7912	10	0	142902	\N
28564	88	7	0	141447	\N
28564	4949	8	0	142920	\N
28566	75	7	0	142922	\N
28566	2859	8	0	142923	\N
28572	224	6	0	142967	\N
28572	7176	7	0	142968	\N
28576	60	7	0	140345	\N
28576	4613	8	0	143019	\N
28581	637	5	0	143038	\N
28581	7921	6	0	143039	\N
28588	230	0	0	142619	\N
28590	4450	1	0	143083	\N
28590	4178	4	0	143084	\N
28590	4527	5	0	143085	\N
28592	54	4	0	143096	\N
28592	3685	5	0	143097	\N
28603	4178	3	0	143149	\N
28603	4211	4	0	143150	\N
28608	230	2	0	142619	\N
28608	3307	3	0	142620	\N
28610	137	2	0	142391	\N
28610	2721	3	0	142392	\N
28612	230	0	0	143168	\N
28617	4233	3	0	140894	\N
28617	4425	4	0	140895	\N
28619	365	4	0	143206	\N
28485	192	2	0	142576	\N
28485	2761	3	0	142577	\N
28495	230	2	0	142619	\N
28495	3307	3	0	142620	\N
28500	208	3	0	116810	\N
28500	4490	4	0	121502	\N
28505	88	3	0	141447	\N
28505	3655	4	0	142665	\N
28511	67	3	0	142688	\N
28511	3749	4	0	142689	\N
28515	391	4	0	142714	\N
28515	3913	5	0	142715	\N
28519	75	3	0	142558	\N
28519	3855	4	0	142725	\N
28526	40	6	0	142570	\N
28526	4717	7	0	142758	\N
28531	4172	8	0	142789	\N
28531	7907	9	0	142790	\N
28538	2	2	0	142812	\N
28538	2789	3	0	142813	\N
28545	189	3	0	142847	\N
28545	3782	4	0	142848	\N
28547	92	2	0	142853	\N
28547	2763	3	0	142854	\N
28551	3625	2	0	141220	\N
28551	4359	3	0	141221	\N
28553	79	4	0	142611	\N
28553	3678	5	0	142860	\N
28555	1109	4	0	134198	\N
28555	3816	5	0	142862	\N
28558	75	7	0	142879	\N
28558	2859	8	0	142880	\N
28561	121	9	0	142159	\N
28561	7911	10	0	142901	\N
28563	54	3	0	142907	\N
28563	3041	4	0	142908	\N
28571	4178	6	0	142965	\N
28571	4250	7	0	142966	\N
28573	7917	51	0	142977	\N
28573	224	98	0	143002	\N
28573	7918	99	0	143003	\N
28575	135	6	0	138200	\N
28575	6389	7	0	143005	\N
28578	431	7	0	143021	\N
28578	7520	8	0	143022	\N
28580	290	5	0	141904	\N
28580	6379	6	0	143037	\N
28584	290	4	0	143048	\N
28584	5879	5	0	143049	\N
28585	4178	9	0	142965	\N
28585	4682	10	0	143064	\N
28587	4178	3	0	143073	\N
28587	4211	4	0	143074	\N
28596	279	9	0	142653	\N
28596	7924	10	0	143120	\N
28598	449	3	0	137792	\N
28598	4760	4	0	138989	\N
28601	4	3	0	143141	\N
28601	3837	4	0	143142	\N
28605	79	4	0	143071	\N
28605	3678	5	0	143157	\N
28607	230	5	0	143160	\N
28607	1703	6	0	143161	\N
28614	151	7	0	143187	\N
28614	7266	8	0	143188	\N
28623	451	26	0	143226	\N
28623	7925	27	0	143227	\N
28626	56	13	0	143249	\N
28626	7926	14	0	143250	\N
28626	7570	14	1	143251	\N
28626	7854	15	0	141169	\N
28626	7927	15	1	143252	\N
28626	7928	16	0	143253	\N
28626	7929	16	1	143254	\N
28626	7915	17	0	143255	\N
28626	7930	17	1	143256	\N
28626	6730	18	0	143257	\N
28631	2	2	0	142812	\N
28631	2789	3	0	142813	\N
28638	300	2	0	143322	\N
28638	2786	3	0	143323	\N
28640	4178	2	0	143166	\N
28640	4247	3	0	143167	\N
28649	192	1	0	143382	\N
28649	193	2	0	143383	\N
28652	18	5	0	143402	\N
28652	3550	6	0	143403	\N
28660	451	0	0	143440	\N
28668	391	4	0	143478	\N
28668	3352	5	0	143479	\N
28671	224	3	0	143489	\N
28671	3603	4	0	143490	\N
28673	113	4	0	141828	\N
28673	5924	5	0	143577	\N
28676	908	4	0	143581	\N
28676	6672	5	0	143582	\N
28678	4178	4	0	143598	\N
28678	4331	5	0	143599	\N
28680	4178	4	0	143607	\N
28680	4205	5	0	143608	\N
28682	56	1	0	143616	\N
28682	1088	2	0	143617	\N
28687	40	4	0	143632	\N
28687	3381	5	0	143633	\N
28689	258	2	0	140663	\N
28689	3275	3	0	142795	\N
28692	336	3	0	143663	\N
28692	3400	4	0	143664	\N
28696	7954	3	0	143682	\N
28696	7955	3	0	143683	\N
28696	3483	4	0	143684	\N
28698	115	3	0	143685	\N
28698	3483	4	0	143686	\N
28703	4178	4	0	143607	\N
28703	4205	5	0	143608	\N
28710	100	0	0	143724	\N
28714	4178	1	0	143729	\N
28714	4460	2	0	143730	\N
28720	402	4	0	141882	\N
28720	4731	5	0	143739	\N
28722	54	7	0	143296	\N
28722	4922	8	0	143749	\N
28727	40	0	0	143632	\N
28733	2636	3	0	142322	\N
28733	2837	4	0	143772	\N
28735	4787	4	0	143765	\N
28735	4847	5	0	143780	\N
28740	4172	2	0	143794	\N
28740	4191	3	0	143795	\N
28742	212	2	0	142164	\N
28742	3616	3	0	143802	\N
28745	6765	2	0	142127	\N
28745	6841	3	0	142128	\N
28753	56	1	0	140640	\N
28753	57	2	0	143805	\N
28755	4178	2	0	143813	\N
28755	4247	3	0	143823	\N
28757	40	4	0	143632	\N
28757	3381	5	0	143633	\N
28760	123	2	0	143838	\N
28760	1868	3	0	143839	\N
28762	75	4	0	143665	\N
28762	7287	5	0	143847	\N
28764	140	4	0	143854	\N
28764	3821	5	0	143855	\N
28767	598	1	0	143870	\N
28767	597	9	0	143871	\N
28767	3789	10	0	143872	\N
28769	4172	7	0	143794	\N
28769	4614	8	0	143887	\N
28774	23	3	0	143910	\N
28774	3497	4	0	143911	\N
28776	23	1	0	143910	\N
28776	1089	2	0	143914	\N
28779	4178	6	0	143813	\N
28779	4250	7	0	143935	\N
28782	181	6	0	143940	\N
28494	4967	3	0	142614	\N
28497	140	2	0	142623	\N
28497	3183	3	0	142624	\N
28502	279	3	0	142653	\N
28502	3641	4	0	142654	\N
28510	71	3	0	142686	\N
28510	3770	4	0	142687	\N
28512	2	5	0	142700	\N
28512	6376	6	0	142701	\N
28514	18	5	0	142704	\N
28514	4010	6	0	142705	\N
28517	69	2	0	131240	\N
28517	2920	3	0	142717	\N
28521	4178	3	0	142733	\N
28521	4211	4	0	142734	\N
28523	20	5	0	142746	\N
28523	7903	6	0	142747	\N
28528	82	4	0	142767	\N
28528	3508	5	0	142768	\N
28530	4172	3	0	142765	\N
28530	4275	4	0	142777	\N
28533	4178	2	0	142733	\N
28533	4247	3	0	142796	\N
28537	6450	2	0	125868	\N
28537	6825	3	0	127092	\N
28540	595	2	0	142814	\N
28540	3285	3	0	142815	\N
28542	30	17	0	142831	\N
28542	7909	18	0	142832	\N
28544	35	3	0	142845	\N
28544	3563	4	0	142846	\N
28550	117	2	0	142566	\N
28550	1257	3	0	142567	\N
28557	75	3	0	142867	\N
28557	3855	4	0	142868	\N
28560	360	3	0	142885	\N
28560	3602	4	0	142887	\N
28565	18	7	0	142704	\N
28565	1618	8	0	142921	\N
28568	268	9	0	142487	\N
28568	7820	10	0	142941	\N
28570	132	9	0	142799	\N
28570	6548	10	0	142955	\N
28577	4178	7	0	142965	\N
28577	4396	8	0	143020	\N
28579	7919	2	0	143025	\N
28579	7920	2	0	143026	\N
28579	2914	3	0	143027	\N
28591	83	1	0	143086	\N
28591	82	4	0	143087	\N
28591	4753	5	0	143088	\N
28594	208	9	0	116810	\N
28594	7922	10	0	143117	\N
28600	1021	3	0	143139	\N
28600	4551	4	0	143140	\N
28611	135	2	0	138200	\N
28611	2722	3	0	138201	\N
28616	189	2	0	142847	\N
28616	3441	3	0	142849	\N
28618	77	4	0	137807	\N
28618	3619	5	0	143205	\N
28620	453	4	0	141144	\N
28620	4108	5	0	143208	\N
28625	4233	4	0	143238	\N
28625	4234	5	0	143239	\N
28633	181	2	0	143192	\N
28633	3313	3	0	143193	\N
28637	7932	2	0	143316	\N
28637	3464	3	0	143317	\N
28641	40	2	0	143355	\N
28641	282	3	0	143356	\N
28646	360	3	0	143372	\N
28646	3602	4	0	143376	\N
28648	4178	3	0	143166	\N
28648	4211	4	0	143379	\N
28650	285	1	0	138264	\N
28650	286	2	0	143384	\N
28655	149	6	0	138314	\N
28655	7940	7	0	143429	\N
28657	82	6	0	143432	\N
28657	3392	7	0	143433	\N
28661	4178	1	0	143166	\N
28661	4450	2	0	143443	\N
28663	336	3	0	143451	\N
28663	3400	4	0	143452	\N
28667	75	2	0	143468	\N
28667	284	3	0	143469	\N
28681	326	2	0	143613	\N
28681	393	3	0	143614	\N
28683	77	3	0	137807	\N
28683	1877	4	0	137808	\N
28686	18	4	0	143630	\N
28686	2302	5	0	143631	\N
28690	793	4	0	143651	\N
28690	3618	5	0	143652	\N
28697	115	3	0	143685	\N
28697	3483	4	0	143686	\N
28699	2	4	0	143694	\N
28699	3510	5	0	143695	\N
28704	5885	3	0	142939	\N
28704	5926	4	0	143718	\N
28709	908	1	0	143581	\N
28709	3149	2	0	143723	\N
28713	4172	1	0	143727	\N
28713	5004	2	0	143728	\N
28715	100	0	0	143724	\N
28717	100	0	0	143724	\N
28721	75	4	0	143665	\N
28721	3959	5	0	143740	\N
28723	1109	7	0	134198	\N
28723	4145	8	0	143750	\N
28726	7412	2	0	143756	\N
28726	7430	3	0	143757	\N
28732	198	3	0	140171	\N
28732	4263	4	0	140172	\N
28734	40	5	0	143632	\N
28734	2192	6	0	143777	\N
28741	7958	52	0	143796	\N
28741	324	126	0	143797	\N
28741	7959	127	0	143798	\N
28743	121	2	0	143803	\N
28743	2498	3	0	143804	\N
28752	56	1	0	140640	\N
28752	57	2	0	143805	\N
28754	56	1	0	140640	\N
28754	57	2	0	143805	\N
28756	1109	2	0	134198	\N
28756	2809	3	0	143824	\N
28758	192	4	0	143382	\N
28758	3895	5	0	143831	\N
28763	56	2	0	140640	\N
28763	2795	3	0	143851	\N
28773	40	1	0	143632	\N
28773	1383	2	0	143906	\N
28775	142	3	0	143912	\N
28775	4254	4	0	143913	\N
28781	528	6	0	143938	\N
28781	4824	7	0	143939	\N
28785	212	3	0	142164	\N
28785	3639	4	0	143964	\N
28796	4233	3	0	143238	\N
28796	4425	4	0	143488	\N
28800	4178	0	0	141962	\N
28802	67	4	0	142688	\N
28802	5267	5	0	144042	\N
28804	4178	0	0	142200	\N
28809	469	3	0	144069	\N
28809	7966	4	0	144070	\N
28811	145	3	0	144077	\N
28811	4908	4	0	144078	\N
28813	230	3	0	143578	\N
28813	4181	4	0	144086	\N
28820	4172	2	0	144107	\N
28820	4191	3	0	144108	\N
28823	7967	14	0	144122	\N
28823	1018	15	0	144123	\N
28823	7968	15	0	144124	\N
28549	119	2	0	140709	\N
28549	1879	3	0	141217	\N
28556	1109	0	0	134198	\N
28559	360	13	0	142885	\N
28559	6599	14	0	142886	\N
28567	5885	9	0	142939	\N
28567	7819	10	0	142940	\N
28569	7913	5	0	142943	\N
28569	56	22	0	142949	\N
28569	7570	23	0	142950	\N
28569	7914	23	1	142951	\N
28569	6474	24	0	142952	\N
28569	7846	24	1	142953	\N
28569	7915	25	0	48170	\N
28569	7916	25	1	142954	\N
28569	3108	26	0	133199	\N
28569	1075	26	1	142113	\N
28574	137	6	0	142391	\N
28574	6388	7	0	143004	\N
28582	4178	5	0	142965	\N
28582	4429	6	0	143040	\N
28583	4	4	0	141359	\N
28583	4117	5	0	143047	\N
28586	79	3	0	143071	\N
28586	3652	4	0	143072	\N
28589	287	1	0	143077	\N
28589	230	4	0	143081	\N
28589	3006	5	0	143082	\N
28593	391	9	0	142714	\N
28593	3553	10	0	143116	\N
28595	7225	9	0	143118	\N
28595	7923	10	0	143119	\N
28597	4178	3	0	143125	\N
28597	4211	4	0	143085	\N
28599	102	3	0	143132	\N
28599	3597	4	0	143133	\N
28602	96	3	0	141618	\N
28602	2803	4	0	143143	\N
28604	189	3	0	142847	\N
28604	3782	4	0	142848	\N
28606	40	4	0	143158	\N
28606	3381	5	0	143159	\N
28609	4178	2	0	143166	\N
28609	4247	3	0	143167	\N
28613	230	3	0	142619	\N
28613	4181	4	0	143082	\N
28615	181	2	0	143192	\N
28615	3313	3	0	143193	\N
28622	40	3	0	143215	\N
28622	372	4	0	143216	\N
28624	451	1	0	143226	\N
28624	584	2	0	143230	\N
28627	841	4	0	143258	\N
28627	3886	5	0	143259	\N
28630	56	1	0	143291	\N
28630	1088	2	0	143292	\N
28632	54	2	0	143296	\N
28632	3351	3	0	143297	\N
28635	71	6	0	143311	\N
28635	4738	7	0	143312	\N
28642	2	4	0	142812	\N
28642	2830	5	0	143363	\N
28644	451	4	0	143367	\N
28644	3391	5	0	143368	\N
28651	75	4	0	142922	\N
28651	2357	5	0	143392	\N
28656	285	6	0	143430	\N
28656	7941	7	0	143431	\N
28659	451	2	0	143367	\N
28659	3317	3	0	143439	\N
28662	451	1	0	143444	\N
28662	584	2	0	143445	\N
28664	391	2	0	143456	\N
28664	1381	3	0	143457	\N
28665	7943	30	0	143458	\N
28665	94	68	0	143459	\N
28665	2171	69	0	143351	\N
28665	7935	69	1	143352	\N
28665	7944	70	0	143460	\N
28665	7945	70	1	143461	\N
28665	3009	71	0	143462	\N
28670	4233	3	0	143238	\N
28670	4425	4	0	143488	\N
28672	7946	79	0	143553	\N
28672	224	119	0	143567	\N
28672	7947	120	0	143568	\N
28675	14	4	0	142410	\N
28675	2291	5	0	143580	\N
28677	56	11	0	143588	\N
28677	2795	12	0	143589	\N
28679	4172	4	0	143427	\N
28679	4219	5	0	143606	\N
28684	77	0	0	137807	\N
28688	235	3	0	142663	\N
28688	3343	4	0	142664	\N
28691	4241	3	0	143657	\N
28691	7948	3	0	143658	\N
28691	7949	4	0	143659	\N
28691	7950	4	1	143660	\N
28691	3264	5	0	143661	\N
28691	7951	5	1	143662	\N
28693	75	3	0	143665	\N
28693	3855	4	0	143666	\N
28695	69	2	0	131240	\N
28695	3350	3	0	143675	\N
28700	228	3	0	143701	\N
28700	3186	4	0	143702	\N
28702	7956	2	0	143703	\N
28702	2347	3	0	143707	\N
28705	268	3	0	142487	\N
28705	3815	4	0	143719	\N
28707	3625	1	0	141220	\N
28707	7786	2	0	143722	\N
28711	119	1	0	140709	\N
28711	3128	2	0	143725	\N
28719	402	3	0	141882	\N
28719	4077	4	0	143737	\N
28724	367	7	0	143751	\N
28724	4792	8	0	143752	\N
28730	4787	4	0	143765	\N
28730	5041	5	0	143766	\N
28737	4178	2	0	143729	\N
28737	4247	3	0	143787	\N
28739	290	2	0	143048	\N
28739	1909	3	0	143793	\N
28744	4172	2	0	143794	\N
28744	4191	3	0	143795	\N
28746	56	0	0	140640	\N
28748	402	3	0	143811	\N
28748	4077	4	0	143812	\N
28750	4172	3	0	143794	\N
28750	4275	4	0	143815	\N
28759	108	2	0	143836	\N
28759	3340	3	0	143837	\N
28766	7960	1	0	143858	\N
28766	6450	9	0	143868	\N
28766	7961	10	0	143869	\N
28771	82	3	0	143432	\N
28771	5468	4	0	143895	\N
28778	449	8	0	137792	\N
28778	7963	9	0	143926	\N
28788	18	2	0	143630	\N
28788	1685	3	0	143977	\N
28791	4172	4	0	144006	\N
28791	4219	5	0	144007	\N
28798	115	3	0	144034	\N
28798	7965	4	0	144035	\N
28805	4463	5	0	144052	\N
28805	44	7	0	144055	\N
28805	2997	8	0	144056	\N
28807	20	3	0	144065	\N
28807	2844	4	0	144066	\N
28818	60	3	0	140345	\N
28818	3585	4	0	144100	\N
28828	40	7	0	143632	\N
28828	4718	8	0	144160	\N
28830	117	7	0	142566	\N
28619	4049	5	0	143207	\N
28621	40	4	0	143158	\N
28621	3381	5	0	143159	\N
28628	18	3	0	143266	\N
28628	3621	4	0	143267	\N
28629	6303	12	0	142052	\N
28629	7931	13	0	143289	\N
28634	38	6	0	143309	\N
28634	6005	7	0	143310	\N
28636	7932	2	0	143316	\N
28636	3464	3	0	143317	\N
28639	7933	67	0	143341	\N
28639	300	84	0	143349	\N
28639	7934	85	0	143350	\N
28639	2171	85	1	143351	\N
28639	7935	86	0	143352	\N
28639	7936	86	1	143353	\N
28639	7937	87	0	133717	\N
28639	7938	87	1	143354	\N
28643	451	4	0	143365	\N
28643	7939	5	0	143366	\N
28645	360	2	0	143372	\N
28645	2943	3	0	143373	\N
28647	121	3	0	143377	\N
28647	4471	4	0	143378	\N
28653	266	7	0	141802	\N
28653	7471	8	0	143415	\N
28654	4172	6	0	143427	\N
28654	4365	7	0	143428	\N
28658	451	5	0	143434	\N
28658	7942	6	0	143435	\N
28666	841	2	0	143466	\N
28666	3316	3	0	143467	\N
28669	173	3	0	143486	\N
28669	3796	4	0	143487	\N
28674	230	4	0	143578	\N
28674	6806	5	0	143579	\N
28685	228	4	0	135212	\N
28685	4800	5	0	143629	\N
28694	4241	2	0	143671	\N
28694	7952	2	0	143672	\N
28694	7953	3	0	143673	\N
28694	6199	3	1	143674	\N
28701	7956	0	0	143703	\N
28706	268	2	0	142487	\N
28706	7957	3	0	143720	\N
28708	908	0	0	143581	\N
28712	3628	1	0	132360	\N
28712	7784	2	0	143726	\N
28716	100	1	0	143724	\N
28716	2895	2	0	143731	\N
28718	100	0	0	143724	\N
28725	453	2	0	141144	\N
28725	3366	3	0	142042	\N
28728	40	0	0	143632	\N
28729	40	0	0	143632	\N
28731	4172	4	0	143727	\N
28731	4219	5	0	143767	\N
28736	79	2	0	143785	\N
28736	616	3	0	143786	\N
28738	324	2	0	143791	\N
28738	2808	3	0	143792	\N
28747	56	1	0	140640	\N
28747	57	2	0	143805	\N
28749	4178	3	0	143813	\N
28749	4211	4	0	143814	\N
28751	167	2	0	142231	\N
28751	3322	3	0	142232	\N
28761	6723	2	0	138304	\N
28761	6763	3	0	138305	\N
28765	40	0	0	143632	\N
28768	596	1	0	143873	\N
28768	595	9	0	143874	\N
28768	7962	10	0	143875	\N
28770	27	3	0	143893	\N
28770	3714	4	0	143894	\N
28772	108	4	0	143902	\N
28772	4060	5	0	143903	\N
28777	44	8	0	141719	\N
28777	6094	9	0	143925	\N
28780	121	6	0	143936	\N
28780	4686	7	0	143937	\N
28784	33	5	0	142087	\N
28784	4492	6	0	143957	\N
28787	75	4	0	143972	\N
28787	3959	5	0	143973	\N
28790	7412	2	0	143756	\N
28790	7430	3	0	143757	\N
28793	266	5	0	144018	\N
28793	3920	6	0	144019	\N
28795	40	3	0	143632	\N
28795	372	4	0	144026	\N
28797	79	3	0	143785	\N
28797	3652	4	0	144027	\N
28808	2	3	0	144067	\N
28808	3548	4	0	144068	\N
28815	33	3	0	144087	\N
28815	3342	4	0	144089	\N
28817	2636	3	0	142322	\N
28817	2837	4	0	143772	\N
28819	391	3	0	144101	\N
28819	3660	4	0	144102	\N
28822	4178	2	0	144119	\N
28822	4247	3	0	144120	\N
28827	7412	3	0	144149	\N
28827	7466	4	0	144150	\N
28829	260	7	0	144161	\N
28829	4589	8	0	144162	\N
28832	793	7	0	144165	\N
28832	4590	8	0	144166	\N
28834	4172	6	0	144177	\N
28834	4197	7	0	144178	\N
28839	7412	3	0	144197	\N
28839	7466	4	0	144198	\N
28842	137	7	0	142391	\N
28842	4722	8	0	144213	\N
28848	69	0	0	144223	\N
28850	54	6	0	143296	\N
28850	5204	7	0	144240	\N
28853	113	6	0	141828	\N
28853	3587	7	0	144269	\N
28856	2081	17	0	144317	\N
28856	7971	18	0	144318	\N
28860	173	3	0	143486	\N
28860	3796	4	0	143487	\N
28865	4178	3	0	144343	\N
28865	4441	4	0	144344	\N
28867	100	5	0	144358	\N
28867	7057	6	0	144359	\N
28873	435	5	0	144392	\N
28873	2354	6	0	144393	\N
28875	4178	3	0	144343	\N
28875	4211	4	0	144402	\N
28879	852	5	0	140536	\N
28879	4420	6	0	144415	\N
28883	40	3	0	143632	\N
28883	372	4	0	144026	\N
28894	23	4	0	144484	\N
28894	3189	5	0	144485	\N
28901	7976	29	0	144508	\N
28901	258	52	0	144517	\N
28901	2725	53	0	144518	\N
28903	92	9	0	144528	\N
28903	7977	10	0	144529	\N
28908	33	3	0	144554	\N
28908	3342	4	0	144555	\N
28912	192	1	0	144571	\N
28912	2944	2	0	144572	\N
28914	210	1	0	141345	\N
28914	2926	2	0	144579	\N
28917	140	2	0	144227	\N
28917	2910	3	0	144583	\N
28921	212	5	0	144600	\N
28921	4580	6	0	144601	\N
28923	44	5	0	144603	\N
28923	4463	6	0	144055	\N
28932	4178	3	0	144629	\N
28782	4256	7	0	143941	\N
28783	2	4	0	143947	\N
28783	3510	5	0	143948	\N
28786	6765	3	0	142127	\N
28786	6884	4	0	143965	\N
28789	908	10	0	143581	\N
28789	7013	11	0	143995	\N
28792	54	5	0	143296	\N
28792	7075	6	0	144017	\N
28794	64	5	0	144020	\N
28794	7964	6	0	144021	\N
28799	56	2	0	140640	\N
28799	2914	3	0	144036	\N
28801	4178	0	0	141962	\N
28803	4178	0	0	141962	\N
28806	4484	5	0	144057	\N
28806	75	7	0	144058	\N
28806	1427	8	0	144059	\N
28810	469	3	0	144069	\N
28810	7966	4	0	144070	\N
28812	56	2	0	144079	\N
28812	2795	3	0	144080	\N
28814	33	1	0	144087	\N
28814	3119	2	0	144088	\N
28816	391	3	0	144090	\N
28816	3660	4	0	144091	\N
28821	4178	3	0	144114	\N
28821	4211	4	0	144115	\N
28824	35	8	0	144138	\N
28824	3956	9	0	144139	\N
28826	186	8	0	144141	\N
28826	5991	9	0	144142	\N
28831	90	7	0	141634	\N
28831	4849	8	0	144164	\N
28833	181	1	0	143940	\N
28833	2898	2	0	144168	\N
28836	20	3	0	144065	\N
28836	2844	4	0	144066	\N
28838	181	3	0	144195	\N
28838	4184	4	0	144196	\N
28843	7412	2	0	144197	\N
28843	7430	3	0	144217	\N
28845	69	4	0	144223	\N
28845	4041	5	0	144224	\N
28857	4172	17	0	144319	\N
28857	7972	18	0	144320	\N
28861	528	3	0	143938	\N
28861	4262	4	0	144329	\N
28863	4233	4	0	143238	\N
28863	4234	5	0	143239	\N
28868	4172	2	0	144319	\N
28868	4191	3	0	144364	\N
28870	326	3	0	144371	\N
28870	3339	4	0	144372	\N
28872	1470	5	0	144390	\N
28872	6556	6	0	144391	\N
28874	18	1	0	144395	\N
28874	1426	2	0	144396	\N
28881	40	3	0	143632	\N
28881	372	4	0	144026	\N
28886	3347	5	0	144446	\N
28886	135	8	0	144447	\N
28886	3088	9	0	144212	\N
28893	290	4	0	144482	\N
28893	5879	5	0	144483	\N
28895	23	3	0	144484	\N
28895	3497	4	0	144487	\N
28897	79	4	0	144494	\N
28897	3678	5	0	144495	\N
28905	7978	44	0	144533	\N
28905	449	64	0	144534	\N
28905	7979	65	0	144535	\N
28907	7412	3	0	144548	\N
28907	7466	4	0	144549	\N
28910	54	3	0	144473	\N
28910	3041	4	0	144558	\N
28922	6765	5	0	142127	\N
28922	7983	6	0	144602	\N
28924	228	7	0	144616	\N
28924	5491	8	0	144617	\N
28926	181	7	0	144620	\N
28926	4137	8	0	144621	\N
28931	170	7	0	144650	\N
28931	4591	8	0	144651	\N
28936	170	3	0	144650	\N
28936	4148	4	0	144666	\N
28938	38	3	0	144673	\N
28938	3457	4	0	144674	\N
28945	4233	3	0	144691	\N
28945	4425	4	0	144692	\N
28946	4178	10	0	144707	\N
28946	4665	11	0	144708	\N
28950	135	1	0	144713	\N
28950	136	2	0	144714	\N
28955	40	3	0	144747	\N
28955	372	4	0	144748	\N
28958	4787	7	0	144762	\N
28958	7384	8	0	144763	\N
28962	233	3	0	137374	\N
28962	3704	4	0	144775	\N
28966	224	5	0	144556	\N
28966	4419	6	0	144796	\N
28968	140	3	0	144227	\N
28968	4149	4	0	144801	\N
28970	69	4	0	144223	\N
28970	4041	5	0	144224	\N
28972	140	4	0	144809	\N
28972	3821	5	0	144810	\N
28974	198	3	0	144817	\N
28974	4263	4	0	144818	\N
28977	192	3	0	144838	\N
28977	3790	4	0	144839	\N
28987	235	3	0	144876	\N
28987	7989	4	0	144882	\N
28987	3843	4	1	144883	\N
28989	7412	2	0	144548	\N
28989	7990	3	0	144885	\N
28993	117	3	0	142566	\N
28993	3653	4	0	144893	\N
28997	170	3	0	144906	\N
28997	4148	4	0	144907	\N
29002	40	4	0	144747	\N
29002	3381	5	0	144940	\N
29005	4233	7	0	144691	\N
29005	5582	8	0	144959	\N
29011	2	4	0	144990	\N
29011	3510	5	0	144991	\N
29014	100	6	0	145008	\N
29014	7216	7	0	145009	\N
29016	285	3	0	143430	\N
29016	4496	4	0	145017	\N
29020	94	2	0	145049	\N
29020	2794	3	0	145050	\N
29022	56	4	0	145058	\N
29022	3127	5	0	145059	\N
29025	20	5	0	144065	\N
29025	6631	6	0	145071	\N
29027	20	5	0	144065	\N
29027	6631	6	0	145071	\N
29029	79	6	0	145092	\N
29029	4253	7	0	145093	\N
29032	6	3	0	141565	\N
29032	4823	4	0	145101	\N
29034	4178	4	0	145107	\N
29034	4331	5	0	145108	\N
29037	4172	2	0	144764	\N
29037	4191	3	0	145051	\N
29041	110	3	0	145135	\N
29041	2995	4	0	145136	\N
29043	230	6	0	143578	\N
29043	4182	7	0	145150	\N
29045	360	3	0	143372	\N
29045	3602	4	0	143376	\N
29048	30	6	0	144330	\N
29048	2931	7	0	145168	\N
29049	4178	3	0	145173	\N
29049	4211	4	0	145174	\N
28825	251	8	0	139506	\N
28825	6851	9	0	144140	\N
28835	391	6	0	144187	\N
28835	3521	7	0	144188	\N
28837	367	3	0	144193	\N
28837	3683	4	0	144194	\N
28844	69	0	0	131240	\N
28846	14	4	0	144225	\N
28846	3498	5	0	144226	\N
28851	370	6	0	144250	\N
28851	7969	7	0	144251	\N
28855	7412	10	0	144289	\N
28855	7568	11	0	144290	\N
28859	69	3	0	144223	\N
28859	4536	4	0	144328	\N
28866	110	3	0	142477	\N
28866	2995	4	0	144349	\N
28871	33	4	0	144087	\N
28871	5122	5	0	144380	\N
28876	40	3	0	143632	\N
28876	372	4	0	144026	\N
28878	4172	5	0	144413	\N
28878	4415	6	0	144414	\N
28880	4178	3	0	144343	\N
28880	4211	4	0	144402	\N
28888	125	4	0	141972	\N
28888	4056	5	0	144459	\N
28890	4178	6	0	144471	\N
28890	4250	7	0	144472	\N
28892	367	6	0	144193	\N
28892	6013	7	0	144475	\N
28899	4178	3	0	144471	\N
28899	4211	4	0	144501	\N
28913	2636	2	0	144577	\N
28913	7981	3	0	144578	\N
28915	210	2	0	141345	\N
28915	6179	3	0	144580	\N
28918	251	2	0	139506	\N
28918	3011	3	0	144584	\N
28919	2636	0	0	144577	\N
28928	40	4	0	144526	\N
28928	3381	5	0	144631	\N
28930	4172	7	0	144648	\N
28930	4614	8	0	144649	\N
28940	2636	3	0	144577	\N
28940	2837	4	0	144679	\N
28942	189	2	0	144682	\N
28942	3441	3	0	144683	\N
28944	4178	3	0	144689	\N
28944	4211	4	0	144690	\N
28954	322	3	0	144740	\N
28954	1105	4	0	144741	\N
28956	326	3	0	144371	\N
28956	3339	4	0	144372	\N
28960	6303	3	0	144771	\N
28960	6304	4	0	144772	\N
28965	4172	5	0	144764	\N
28965	4415	6	0	144795	\N
28976	121	6	0	144830	\N
28976	4686	7	0	144831	\N
28978	1021	3	0	143139	\N
28978	4551	4	0	143140	\N
28980	100	3	0	144845	\N
28980	3836	4	0	144846	\N
28983	7987	4	0	144866	\N
28983	4172	9	0	144867	\N
28983	7178	10	0	144868	\N
28985	235	3	0	144876	\N
28985	3343	4	0	144881	\N
28991	4178	3	0	144847	\N
28991	4211	4	0	144848	\N
28998	290	3	0	144482	\N
28998	3635	4	0	144913	\N
29000	75	3	0	144321	\N
29000	3855	4	0	144420	\N
29006	260	3	0	144161	\N
29006	3399	4	0	144966	\N
29008	64	5	0	144977	\N
29008	7964	6	0	144978	\N
29013	4	3	0	143141	\N
29013	3837	4	0	143142	\N
29024	908	5	0	145069	\N
29024	5076	6	0	145070	\N
29036	46	1	0	129457	\N
29036	839	2	0	145110	\N
29038	40	4	0	145120	\N
29038	3381	5	0	145121	\N
29044	4178	3	0	145107	\N
29044	4211	4	0	145155	\N
29047	4088	6	0	144773	\N
29047	4246	7	0	145167	\N
29052	3628	3	0	132360	\N
29052	3785	4	0	132361	\N
29053	40	3	0	145148	\N
29053	372	4	0	145181	\N
29058	75	3	0	144321	\N
29058	3855	4	0	144420	\N
29061	268	9	0	145213	\N
29061	7820	10	0	145214	\N
29062	79	9	0	145092	\N
29062	3758	10	0	145215	\N
29067	597	4	0	145229	\N
29067	3733	5	0	145230	\N
29070	214	3	0	142389	\N
29070	3496	4	0	145240	\N
29075	3308	2	0	145255	\N
29075	244	4	0	145256	\N
29075	2960	5	0	145257	\N
29077	210	4	0	145264	\N
29077	3536	5	0	145265	\N
29083	1587	3	0	145283	\N
29083	7996	4	0	145284	\N
29085	4178	4	0	145198	\N
29085	4205	5	0	145291	\N
29087	38	2	0	145296	\N
29087	4009	3	0	145297	\N
29093	324	3	0	143791	\N
29093	4514	4	0	145329	\N
29097	77	4	0	145266	\N
29097	3619	5	0	145267	\N
29099	4178	2	0	145198	\N
29099	4247	3	0	145349	\N
29102	4172	10	0	145370	\N
29102	4663	11	0	145371	\N
29104	4172	2	0	145377	\N
29104	4191	3	0	145378	\N
29106	367	4	0	145402	\N
29106	3679	5	0	145403	\N
29110	4088	4	0	144773	\N
29110	4089	5	0	145430	\N
29114	14	8	0	145465	\N
29114	6577	9	0	145466	\N
29115	488	8	0	145467	\N
29115	8002	9	0	145468	\N
29119	4247	2	0	145488	\N
29119	4178	5	0	145376	\N
29119	4527	6	0	145492	\N
29120	4178	5	0	145500	\N
29120	4429	6	0	145501	\N
29127	244	12	0	145559	\N
29127	8006	13	0	145560	\N
29132	244	10	0	145607	\N
29132	8009	11	0	145608	\N
29135	35	7	0	144138	\N
29135	5077	8	0	145628	\N
29138	117	6	0	145646	\N
29138	3804	7	0	145647	\N
29141	260	3	0	145657	\N
29141	3399	4	0	145658	\N
29144	113	3	0	145683	\N
29144	3620	4	0	145684	\N
29154	4233	3	0	144691	\N
29154	4425	4	0	144692	\N
29163	3625	2	0	141220	\N
29163	8015	3	0	145789	\N
29167	326	2	0	145216	\N
29167	6910	3	0	145792	\N
28830	5276	8	0	144163	\N
28840	30	7	0	144209	\N
28840	3942	8	0	144210	\N
28841	135	7	0	144211	\N
28841	4721	8	0	144212	\N
28847	140	4	0	144227	\N
28847	3821	5	0	144228	\N
28849	69	0	0	144223	\N
28852	4211	3	0	144257	\N
28852	4178	4	0	144258	\N
28854	927	6	0	8544	\N
28854	7970	7	0	144270	\N
28858	75	17	0	144321	\N
28858	7973	18	0	144322	\N
28862	30	3	0	144330	\N
28862	3640	4	0	144331	\N
28864	86	3	0	140636	\N
28864	5465	4	0	144342	\N
28869	56	3	0	144079	\N
28869	4109	4	0	144370	\N
28877	4233	3	0	144403	\N
28877	4425	4	0	144404	\N
28882	75	3	0	144321	\N
28882	3855	4	0	144420	\N
28884	4178	5	0	144432	\N
28884	4429	6	0	144433	\N
28885	3346	5	0	144441	\N
28885	137	8	0	144445	\N
28885	3089	9	0	144213	\N
28887	7974	2	0	144451	\N
28887	7975	2	0	144452	\N
28887	4247	3	0	144453	\N
28889	367	0	0	144193	\N
28891	54	6	0	144473	\N
28891	5204	7	0	144474	\N
28896	35	4	0	144138	\N
28896	3545	5	0	144488	\N
28898	79	3	0	144494	\N
28898	3652	4	0	144496	\N
28900	94	2	0	141470	\N
28900	2794	3	0	144502	\N
28902	40	9	0	144526	\N
28902	4712	10	0	144527	\N
28904	94	6	0	141470	\N
28904	3277	7	0	144530	\N
28906	121	6	0	143936	\N
28906	7980	7	0	144542	\N
28909	224	3	0	144556	\N
28909	3603	4	0	144557	\N
28911	94	5	0	144568	\N
28911	3153	6	0	144569	\N
28916	424	2	0	144581	\N
28916	3038	3	0	144582	\N
28920	12	3	0	141673	\N
28920	7982	4	0	144590	\N
28925	79	7	0	144618	\N
28925	5706	8	0	144619	\N
28927	4178	4	0	144629	\N
28927	4205	5	0	144630	\N
28929	908	2	0	144636	\N
28929	2832	3	0	144637	\N
28933	241	3	0	141328	\N
28933	3613	4	0	144657	\N
28935	4178	4	0	144629	\N
28935	4205	5	0	144630	\N
28937	62	3	0	144671	\N
28937	3344	4	0	144672	\N
28947	210	10	0	141345	\N
28947	7984	11	0	144709	\N
28949	137	2	0	142391	\N
28949	2721	3	0	142392	\N
28951	181	5	0	144620	\N
28951	7985	6	0	144720	\N
28953	149	2	0	144733	\N
28953	1379	3	0	144734	\N
28959	4172	7	0	144764	\N
28959	4614	8	0	144765	\N
28963	7412	4	0	144783	\N
28963	7499	5	0	144784	\N
28967	44	5	0	144603	\N
28967	4463	6	0	144055	\N
28971	69	3	0	144223	\N
28971	4536	4	0	144328	\N
28979	62	3	0	144671	\N
28979	3344	4	0	144672	\N
28981	4178	3	0	144847	\N
28981	4211	4	0	144848	\N
28986	2	3	0	144067	\N
28986	3548	4	0	144068	\N
28994	137	3	0	142391	\N
28994	3633	4	0	144898	\N
28996	4178	3	0	144847	\N
28996	4211	4	0	144848	\N
28999	322	3	0	144919	\N
28999	1105	4	0	144920	\N
29001	908	6	0	144931	\N
29001	3555	7	0	144932	\N
29003	4178	2	0	144944	\N
29003	4247	3	0	144945	\N
29010	5887	4	0	144988	\N
29010	7991	5	0	144989	\N
29012	4178	3	0	144996	\N
29012	4211	4	0	144997	\N
29017	62	7	0	145029	\N
29017	7992	8	0	145030	\N
29019	4178	3	0	145043	\N
29019	4211	4	0	145044	\N
29026	908	5	0	145069	\N
29026	5076	6	0	145070	\N
29030	92	6	0	144528	\N
29030	3651	7	0	145094	\N
29039	102	4	0	145122	\N
29039	3572	5	0	145123	\N
29042	40	6	0	145148	\N
29042	4255	7	0	145149	\N
29050	119	3	0	140709	\N
29050	2860	4	0	145175	\N
29054	244	3	0	142797	\N
29054	4075	4	0	145182	\N
29056	4233	6	0	144691	\N
29056	6364	7	0	145193	\N
29059	5885	9	0	142939	\N
29059	7819	10	0	142940	\N
29063	326	9	0	145216	\N
29063	4073	10	0	145217	\N
29065	6450	4	0	145225	\N
29065	6467	5	0	145226	\N
29074	3425	2	0	145252	\N
29074	242	4	0	145253	\N
29074	2768	5	0	145254	\N
29078	77	4	0	145266	\N
29078	3619	5	0	145267	\N
29080	4172	3	0	145269	\N
29080	4275	4	0	145270	\N
29082	300	3	0	143322	\N
29082	3747	4	0	145282	\N
29086	228	4	0	144616	\N
29086	4800	5	0	145292	\N
29089	424	4	0	145309	\N
29089	3188	5	0	145310	\N
29096	62	4	0	145339	\N
29096	4059	5	0	145340	\N
29098	7998	1	0	145341	\N
29098	262	13	0	145344	\N
29098	7999	14	0	145345	\N
29107	115	3	0	145408	\N
29107	3483	4	0	145409	\N
29112	7412	3	0	145437	\N
29112	7466	4	0	145438	\N
29116	79	8	0	145092	\N
29116	4238	9	0	145469	\N
29121	285	4	0	145509	\N
29121	3674	5	0	145510	\N
29125	224	6	0	144556	\N
29125	7176	7	0	145531	\N
29131	40	8	0	145148	\N
29131	3718	9	0	145590	\N
28932	4211	4	0	144656	\N
28934	241	2	0	141328	\N
28934	634	3	0	142465	\N
28939	75	3	0	144321	\N
28939	3855	4	0	144420	\N
28941	2636	2	0	144577	\N
28941	2836	3	0	144681	\N
28943	189	3	0	144682	\N
28943	3782	4	0	144684	\N
28948	210	0	0	141345	\N
28952	125	4	0	144728	\N
28952	4056	5	0	144729	\N
28957	908	7	0	144760	\N
28957	4078	8	0	144761	\N
28961	4088	3	0	144773	\N
28961	4506	4	0	144774	\N
28964	224	1	0	144556	\N
28964	2813	2	0	144787	\N
28969	140	4	0	144227	\N
28969	3821	5	0	144228	\N
28973	206	4	0	142089	\N
28973	3511	5	0	144811	\N
28975	173	6	0	144828	\N
28975	3606	7	0	144829	\N
28982	7986	4	0	144856	\N
28982	391	9	0	144864	\N
28982	3123	10	0	144865	\N
28984	235	60	0	144876	\N
28984	7988	61	0	144877	\N
28988	7412	2	0	144783	\N
28988	7990	3	0	144884	\N
28990	7412	2	0	144783	\N
28990	7990	3	0	144884	\N
28992	79	3	0	144891	\N
28992	3652	4	0	144892	\N
28995	135	3	0	144899	\N
28995	3630	4	0	144900	\N
29004	210	7	0	141345	\N
29004	5940	8	0	144958	\N
29007	4178	5	0	144975	\N
29007	4429	6	0	144976	\N
29009	145	4	0	144986	\N
29009	3867	5	0	144987	\N
29015	94	6	0	145010	\N
29015	4696	7	0	145011	\N
29018	67	3	0	145035	\N
29018	3749	4	0	145036	\N
29021	4172	2	0	144764	\N
29021	4191	3	0	145051	\N
29023	156	4	0	141884	\N
29023	5935	5	0	145060	\N
29028	142	7	0	143912	\N
29028	7993	8	0	145082	\N
29031	156	3	0	145099	\N
29031	4594	4	0	145100	\N
29033	189	3	0	144682	\N
29033	3782	4	0	144684	\N
29035	2	4	0	144990	\N
29035	2830	5	0	145109	\N
29040	115	3	0	144034	\N
29040	3483	4	0	145129	\N
29046	233	6	0	137374	\N
29046	4245	7	0	145166	\N
29051	3625	3	0	141220	\N
29051	3784	4	0	145176	\N
29055	391	6	0	145191	\N
29055	3521	7	0	145192	\N
29057	4178	3	0	145198	\N
29057	4211	4	0	145199	\N
29060	4178	9	0	145198	\N
29060	4682	10	0	145212	\N
29064	117	9	0	142566	\N
29064	7994	10	0	145218	\N
29066	391	4	0	145227	\N
29066	3913	5	0	145228	\N
29071	4787	1	0	144762	\N
29071	7995	2	0	145243	\N
29073	1379	2	0	145249	\N
29073	149	4	0	145250	\N
29073	2985	5	0	145251	\N
29079	77	3	0	145266	\N
29079	1877	4	0	145268	\N
29091	75	6	0	145320	\N
29091	3361	7	0	145321	\N
29095	54	4	0	145337	\N
29095	3685	5	0	145338	\N
29100	2	2	0	145350	\N
29100	2789	3	0	145351	\N
29109	140	5	0	145421	\N
29109	5000	6	0	145422	\N
29118	8003	116	0	145480	\N
29118	14	126	0	145483	\N
29118	7465	127	0	145484	\N
29122	132	4	0	145410	\N
29122	3716	5	0	145511	\N
29123	4172	4	0	145512	\N
29123	4219	5	0	145513	\N
29126	8004	63	0	145538	\N
29126	8005	64	0	145539	\N
29130	288	8	0	145588	\N
29130	7171	9	0	145589	\N
29133	12	2	0	145613	\N
29133	2804	3	0	145614	\N
29139	23	3	0	145653	\N
29139	3497	4	0	145654	\N
29143	214	9	0	145676	\N
29143	8010	10	0	145677	\N
29146	324	2	0	143791	\N
29146	2808	3	0	143792	\N
29149	86	6	0	145711	\N
29149	7357	7	0	145712	\N
29151	86	3	0	145728	\N
29151	3746	4	0	145729	\N
29157	33	2	0	144554	\N
29157	2822	3	0	145758	\N
29159	8011	32	0	145761	\N
29159	451	46	0	145762	\N
29159	8012	47	0	145763	\N
29159	8013	47	1	145764	\N
29166	119	0	0	140709	\N
29170	60	5	0	140345	\N
29170	8017	6	0	145808	\N
29172	202	8	0	145810	\N
29172	8018	9	0	145811	\N
29173	391	3	0	145817	\N
29173	3660	4	0	145818	\N
29176	266	2	0	144018	\N
29176	2103	3	0	145831	\N
29178	44	3	0	145838	\N
29178	3631	4	0	145839	\N
29181	4172	3	0	145848	\N
29181	4275	4	0	145849	\N
29184	254	54	0	890	\N
29184	8021	55	0	145860	\N
29186	40	6	0	145872	\N
29186	4255	7	0	145873	\N
29188	6303	3	0	145880	\N
29188	6304	4	0	145881	\N
29191	228	4	0	145896	\N
29191	4800	5	0	145897	\N
29197	173	4	0	145919	\N
29197	3614	5	0	145920	\N
29200	8022	6	0	145932	\N
29200	1935	9	0	145937	\N
29200	8023	10	0	145938	\N
29202	8022	6	0	145932	\N
29202	1935	9	0	145937	\N
29202	8023	10	0	145938	\N
29205	595	6	0	142814	\N
29205	8025	7	0	145951	\N
29210	90	3	0	146003	\N
29210	8035	4	0	146004	\N
29210	8036	4	1	146005	\N
29212	424	3	0	145759	\N
29212	3611	4	0	146012	\N
29214	336	4	0	143663	\N
29214	3947	5	0	146020	\N
29068	595	4	0	142814	\N
29068	3878	5	0	145231	\N
29069	202	2	0	142684	\N
29069	2764	3	0	145235	\N
29072	6245	2	0	145245	\N
29072	4787	4	0	145247	\N
29072	6663	5	0	145248	\N
29076	210	4	0	145264	\N
29076	3536	5	0	145265	\N
29081	140	2	0	145275	\N
29081	3183	3	0	145276	\N
29084	79	3	0	145092	\N
29084	3652	4	0	145285	\N
29088	4172	3	0	145269	\N
29088	4275	4	0	145270	\N
29090	324	6	0	143791	\N
29090	7997	7	0	145319	\N
29092	142	3	0	145327	\N
29092	4254	4	0	145328	\N
29094	262	4	0	138378	\N
29094	4607	5	0	145336	\N
29101	121	10	0	144830	\N
29101	6542	11	0	145369	\N
29103	4178	2	0	145375	\N
29103	4247	3	0	145376	\N
29105	8000	73	0	145380	\N
29105	206	126	0	145393	\N
29105	8001	127	0	145394	\N
29108	132	3	0	145410	\N
29108	3729	4	0	145411	\N
29111	233	4	0	145431	\N
29111	3775	5	0	145432	\N
29113	7412	6	0	145449	\N
29113	7507	7	0	145450	\N
29117	27	8	0	145470	\N
29117	7150	9	0	145471	\N
29124	4178	3	0	145519	\N
29124	4211	4	0	145520	\N
29128	8007	103	0	145561	\N
29128	258	126	0	145562	\N
29128	8008	127	0	145563	\N
29129	4178	4	0	145571	\N
29129	4331	5	0	145572	\N
29137	224	6	0	145644	\N
29137	7176	7	0	145645	\N
29140	391	3	0	145655	\N
29140	3660	4	0	145656	\N
29142	4172	9	0	145674	\N
29142	4977	10	0	145675	\N
29145	113	2	0	145688	\N
29145	1899	3	0	145689	\N
29148	360	4	0	143372	\N
29148	3513	5	0	145699	\N
29152	60	3	0	140345	\N
29152	3585	4	0	144100	\N
29156	18	9	0	145753	\N
29156	4047	10	0	145754	\N
29162	8014	103	0	145782	\N
29162	258	126	0	145784	\N
29162	2725	127	0	145785	\N
29165	2351	2	0	140779	\N
29165	4711	3	0	145791	\N
29169	60	8	0	140345	\N
29169	7625	9	0	145807	\N
29171	60	3	0	140345	\N
29171	1493	4	0	145809	\N
29175	4172	3	0	145826	\N
29175	4275	4	0	145827	\N
29179	202	3	0	145810	\N
29179	4857	4	0	145846	\N
29187	2	6	0	145350	\N
29187	4825	7	0	145874	\N
29189	149	2	0	145885	\N
29189	1379	3	0	145886	\N
29194	73	5	0	142549	\N
29194	4931	6	0	145908	\N
29203	2828	6	0	145939	\N
29203	7277	7	0	143351	\N
29203	8024	7	0	145942	\N
29206	7277	6	0	145952	\N
29206	8026	6	0	145953	\N
29206	8027	7	0	145954	\N
29206	8028	7	1	145955	\N
29206	8029	8	0	145956	\N
29206	7949	8	1	145957	\N
29208	8031	83	0	145969	\N
29208	30	126	0	145993	\N
29208	8032	127	0	145994	\N
29211	90	3	0	146003	\N
29211	4074	4	0	146006	\N
29223	4	3	0	143141	\N
29223	3837	4	0	143142	\N
29225	202	3	0	145810	\N
29225	4857	4	0	145846	\N
29227	244	3	0	146051	\N
29227	4075	4	0	146052	\N
29232	251	3	0	139506	\N
29232	3514	4	0	145819	\N
29238	597	4	0	146112	\N
29238	3733	5	0	146113	\N
29244	4172	3	0	146133	\N
29244	4275	4	0	146134	\N
29247	367	4	0	146154	\N
29247	3679	5	0	146155	\N
29249	113	3	0	146156	\N
29249	3620	4	0	146158	\N
29251	18	2	0	145753	\N
29251	1685	3	0	146163	\N
29254	62	3	0	145339	\N
29254	3344	4	0	146181	\N
29256	38	3	0	146188	\N
29256	3457	4	0	146189	\N
29258	4172	3	0	146197	\N
29258	4275	4	0	146198	\N
29262	4178	12	0	146233	\N
29262	5083	13	0	146234	\N
29271	258	20	0	146282	\N
29271	8042	21	0	146283	\N
29275	4178	3	0	146305	\N
29275	4211	4	0	146306	\N
29280	2	7	0	145350	\N
29280	2858	8	0	146344	\N
29283	230	3	0	146352	\N
29283	4181	4	0	146353	\N
29285	4172	3	0	146355	\N
29285	4275	4	0	146356	\N
29289	121	7	0	146377	\N
29289	7263	8	0	146378	\N
29304	181	5	0	146448	\N
29304	7620	6	0	146449	\N
29306	4172	4	0	146355	\N
29306	4219	5	0	146458	\N
29311	4178	7	0	146485	\N
29311	4396	8	0	146486	\N
29318	4178	2	0	146515	\N
29318	4247	3	0	146516	\N
29320	79	3	0	146350	\N
29320	3652	4	0	146351	\N
29323	86	3	0	146539	\N
29323	3746	4	0	146540	\N
29325	4172	3	0	146543	\N
29325	4275	4	0	146544	\N
29336	300	4	0	146603	\N
29336	6350	5	0	146604	\N
29339	170	4	0	144906	\N
29339	4680	5	0	146628	\N
29341	4178	3	0	146643	\N
29341	4211	4	0	146644	\N
29344	40	6	0	146659	\N
29344	4255	7	0	146660	\N
29345	7412	3	0	146307	\N
29345	7466	4	0	146308	\N
29347	125	3	0	146673	\N
29347	4170	4	0	146674	\N
29353	6303	3	0	146713	\N
29353	6304	4	0	146714	\N
29355	233	4	0	145431	\N
29134	132	2	0	145410	\N
29134	2756	3	0	145615	\N
29136	79	2	0	145092	\N
29136	616	3	0	145632	\N
29147	2636	4	0	145697	\N
29147	3617	5	0	145698	\N
29150	40	5	0	145148	\N
29150	2714	6	0	145722	\N
29153	4233	2	0	144691	\N
29153	5577	3	0	145735	\N
29155	202	9	0	145751	\N
29155	3798	10	0	145752	\N
29158	424	2	0	145759	\N
29158	2755	3	0	145760	\N
29160	451	2	0	143444	\N
29160	3317	3	0	145765	\N
29161	94	2	0	145770	\N
29161	2043	3	0	145771	\N
29164	3628	2	0	132360	\N
29164	8016	3	0	145790	\N
29168	4178	5	0	145801	\N
29168	4333	6	0	145802	\N
29174	251	3	0	139506	\N
29174	3514	4	0	145819	\N
29180	2351	3	0	140779	\N
29180	2845	4	0	145847	\N
29183	254	2	0	890	\N
29183	8020	3	0	145855	\N
29185	33	6	0	145870	\N
29185	7330	7	0	145871	\N
29190	210	4	0	145894	\N
29190	3536	5	0	145895	\N
29192	4172	4	0	145898	\N
29192	4219	5	0	145899	\N
29196	186	3	0	145910	\N
29196	3722	4	0	145911	\N
29199	2828	6	0	145939	\N
29199	262	9	0	145940	\N
29199	3027	10	0	145941	\N
29207	6450	6	0	145225	\N
29207	8030	7	0	145958	\N
29209	8033	3	0	146000	\N
29209	8034	3	0	146001	\N
29209	4584	4	0	146002	\N
29213	424	2	0	145759	\N
29213	2755	3	0	145760	\N
29215	4178	4	0	145801	\N
29215	4205	5	0	146021	\N
29217	189	3	0	144682	\N
29217	3782	4	0	144684	\N
29229	4172	5	0	146043	\N
29229	4415	6	0	146064	\N
29231	244	4	0	146073	\N
29231	3778	5	0	146074	\N
29236	4178	4	0	146110	\N
29236	4205	5	0	146111	\N
29240	424	2	0	146119	\N
29240	2755	3	0	146120	\N
29243	56	3	0	145058	\N
29243	4109	4	0	146132	\N
29245	4172	3	0	146133	\N
29245	4275	4	0	146134	\N
29259	244	3	0	146073	\N
29259	4075	4	0	146199	\N
29263	2	12	0	145350	\N
29263	8037	13	0	146235	\N
29268	1949	4	0	146256	\N
29268	8040	5	0	146258	\N
29273	140	6	0	146295	\N
29273	4086	7	0	146296	\N
29276	7412	3	0	146307	\N
29276	7466	4	0	146308	\N
29282	79	3	0	146350	\N
29282	3652	4	0	146351	\N
29286	54	3	0	146361	\N
29286	3041	4	0	146362	\N
29288	135	3	0	144899	\N
29288	3630	4	0	144900	\N
29290	4178	2	0	146305	\N
29290	4247	3	0	146383	\N
29292	236	1	0	146387	\N
29292	235	4	0	146392	\N
29292	2435	5	0	146393	\N
29292	8048	5	1	146394	\N
29292	7443	6	0	146395	\N
29294	245	1	0	146399	\N
29294	244	4	0	146400	\N
29294	7671	5	0	146199	\N
29296	40	4	0	146130	\N
29296	3381	5	0	146410	\N
29299	7412	5	0	146307	\N
29299	7478	6	0	146428	\N
29302	4172	5	0	146355	\N
29302	4415	6	0	146431	\N
29305	7412	4	0	146307	\N
29305	7499	5	0	146457	\N
29307	7412	1	0	146307	\N
29307	7642	2	0	146461	\N
29309	262	3	0	146470	\N
29309	4778	4	0	146471	\N
29315	440	3	0	146492	\N
29315	4581	4	0	146498	\N
29322	657	4	0	146532	\N
29322	8053	5	0	146533	\N
29327	119	2	0	140709	\N
29327	1879	3	0	141217	\N
29329	40	7	0	146564	\N
29329	4718	8	0	146565	\N
29331	8054	64	0	146578	\N
29331	71	126	0	146582	\N
29331	8055	127	0	146583	\N
29334	4172	3	0	146543	\N
29334	4275	4	0	146544	\N
29335	4178	4	0	146601	\N
29335	4205	5	0	146602	\N
29338	2	4	0	146591	\N
29338	3510	5	0	146627	\N
29340	40	3	0	146635	\N
29340	372	4	0	146636	\N
29343	4178	6	0	146657	\N
29343	4250	7	0	146658	\N
29351	5399	6	0	146705	\N
29351	6549	7	0	146706	\N
29356	4088	4	0	146723	\N
29356	4089	5	0	146724	\N
29357	242	4	0	146050	\N
29357	3512	5	0	146725	\N
29363	79	3	0	146747	\N
29363	3652	4	0	146748	\N
29366	402	3	0	146761	\N
29366	4077	4	0	146762	\N
29368	391	3	0	146655	\N
29368	3660	4	0	146775	\N
29369	149	3	0	146776	\N
29369	4189	4	0	146777	\N
29371	79	3	0	146785	\N
29371	3652	4	0	146786	\N
29372	4172	3	0	146792	\N
29372	4275	4	0	146793	\N
29373	142	3	0	146799	\N
29373	4254	4	0	146800	\N
29376	4178	9	0	146822	\N
29376	4682	10	0	146823	\N
29378	132	9	0	146693	\N
29378	2435	10	0	146393	\N
29378	8057	10	1	146825	\N
29384	40	7	0	146858	\N
29384	4718	8	0	146859	\N
29391	8060	86	0	146904	\N
29391	1021	126	0	146913	\N
29391	8047	127	0	146914	\N
29397	123	3	0	143838	\N
29397	2856	4	0	146942	\N
29399	35	3	0	146945	\N
29399	3563	4	0	146946	\N
29409	86	4	0	146539	\N
29409	4052	5	0	146995	\N
29177	121	3	0	144830	\N
29177	4471	4	0	145837	\N
29182	254	6	0	890	\N
29182	8019	7	0	145850	\N
29193	186	0	0	145900	\N
29195	121	5	0	144830	\N
29195	4430	6	0	145909	\N
29198	8022	6	0	145932	\N
29198	1935	9	0	145937	\N
29198	8023	10	0	145938	\N
29201	8022	6	0	145932	\N
29201	1935	9	0	145937	\N
29201	8023	10	0	145938	\N
29204	2828	6	0	145939	\N
29204	262	9	0	145940	\N
29204	3027	10	0	145941	\N
29218	189	2	0	144682	\N
29218	3143	3	0	146030	\N
29220	235	3	0	144876	\N
29220	3343	4	0	144881	\N
29222	4	2	0	143141	\N
29222	2751	3	0	146041	\N
29224	4172	3	0	146043	\N
29224	4275	4	0	146044	\N
29226	242	3	0	146050	\N
29226	2839	4	0	145254	\N
29233	110	6	0	146089	\N
29233	3917	7	0	146090	\N
29235	595	4	0	142814	\N
29235	3878	5	0	145231	\N
29242	40	3	0	146130	\N
29242	372	4	0	146131	\N
29248	113	4	0	146156	\N
29248	3677	5	0	146157	\N
29252	365	3	0	143206	\N
29252	3839	4	0	146169	\N
29255	488	2	0	146182	\N
29255	2791	3	0	146183	\N
29257	251	3	0	146190	\N
29257	3514	4	0	146191	\N
29261	316	4	0	146212	\N
29261	4531	5	0	146213	\N
29265	4178	4	0	146242	\N
29265	4205	5	0	146243	\N
29267	1949	6	0	146256	\N
29267	3527	7	0	146257	\N
29270	273	12	0	146280	\N
29270	8041	13	0	146281	\N
29272	44	12	0	146284	\N
29272	8043	13	0	146285	\N
29274	8044	64	0	146297	\N
29274	71	126	0	146298	\N
29274	8045	127	0	146299	\N
29277	266	3	0	146309	\N
29277	3474	4	0	146310	\N
29278	8046	69	0	146312	\N
29278	1021	109	0	146320	\N
29278	8047	110	0	146321	\N
29284	20	3	0	146062	\N
29284	2844	4	0	146354	\N
29291	4172	2	0	146355	\N
29291	4191	3	0	146384	\N
29298	6	5	0	141565	\N
29298	2852	6	0	146427	\N
29301	6723	5	0	138304	\N
29301	8052	6	0	146430	\N
29308	244	1	0	146462	\N
29308	245	2	0	146463	\N
29312	4178	2	0	146490	\N
29312	4247	3	0	146491	\N
29314	440	0	0	146492	\N
29316	241	3	0	146499	\N
29316	3613	4	0	146500	\N
29319	14	3	0	145465	\N
29319	4272	4	0	146519	\N
29328	3628	2	0	146549	\N
29328	4360	3	0	146550	\N
29332	2636	3	0	145697	\N
29332	2837	4	0	146590	\N
29342	391	6	0	146655	\N
29342	3521	7	0	146656	\N
29349	167	6	0	146691	\N
29349	5066	7	0	146692	\N
29354	67	3	0	146715	\N
29354	3749	4	0	146716	\N
29362	79	3	0	146740	\N
29362	3652	4	0	146741	\N
29365	14	3	0	145465	\N
29365	4272	4	0	146519	\N
29370	273	3	0	146783	\N
29370	3638	4	0	146784	\N
29374	224	5	0	145644	\N
29374	4419	6	0	146809	\N
29381	528	2	0	143938	\N
29381	2765	3	0	146842	\N
29386	156	12	0	146881	\N
29386	8058	13	0	146882	\N
29388	14	8	0	146883	\N
29388	6577	9	0	146885	\N
29390	4178	4	0	146822	\N
29390	4205	5	0	146901	\N
29396	4178	3	0	146935	\N
29396	4211	4	0	146936	\N
29398	6723	3	0	146943	\N
29398	6724	4	0	146944	\N
29401	4172	4	0	146963	\N
29401	4219	5	0	146964	\N
29408	73	4	0	142549	\N
29408	2284	5	0	146994	\N
29411	263	1	0	147013	\N
29411	262	10	0	147014	\N
29411	4093	11	0	147015	\N
29413	435	9	0	147019	\N
29413	8063	10	0	147020	\N
29417	14	1	0	147046	\N
29417	15	2	0	147048	\N
29421	324	3	0	143791	\N
29421	4514	4	0	145329	\N
29423	149	4	0	147068	\N
29423	5500	5	0	147069	\N
29425	4178	5	0	147081	\N
29425	4333	6	0	147082	\N
29427	73	4	0	142549	\N
29427	8067	5	0	147100	\N
29429	202	3	0	147108	\N
29429	4857	4	0	147109	\N
29435	264	3	0	147121	\N
29435	3632	4	0	147122	\N
29437	108	4	0	147138	\N
29437	8070	5	0	147139	\N
29439	256	3	0	147153	\N
29439	8071	4	0	147154	\N
29441	908	14	0	145069	\N
29441	8072	15	0	147180	\N
29451	4787	7	0	144762	\N
29451	7384	8	0	144763	\N
29453	88	4	0	141447	\N
29453	8077	5	0	147253	\N
29455	453	4	0	147266	\N
29455	4108	5	0	147267	\N
29462	5885	3	0	142939	\N
29462	5926	4	0	143718	\N
29464	94	3	0	146114	\N
29464	2864	4	0	147304	\N
29476	8086	11	0	147405	\N
29476	86	12	0	147406	\N
29487	100	6	0	145008	\N
29487	7216	7	0	145009	\N
29489	4172	7	0	147181	\N
29489	4614	8	0	147462	\N
29500	4178	2	0	147419	\N
29500	4247	3	0	147491	\N
29502	20	4	0	146062	\N
29502	3995	5	0	147530	\N
29504	4172	3	0	147542	\N
29504	4275	4	0	147543	\N
29506	4178	5	0	147556	\N
29216	4178	3	0	146028	\N
29216	4211	4	0	146029	\N
29219	235	2	0	144876	\N
29219	2757	3	0	146035	\N
29221	189	3	0	144682	\N
29221	3782	4	0	144684	\N
29228	20	5	0	146062	\N
29228	6631	6	0	146063	\N
29230	4172	4	0	146071	\N
29230	4219	5	0	146072	\N
29234	4172	7	0	146101	\N
29234	4614	8	0	146102	\N
29237	6450	4	0	145225	\N
29237	6467	5	0	145226	\N
29239	94	4	0	146114	\N
29239	4677	5	0	146115	\N
29241	40	3	0	145872	\N
29241	372	4	0	146125	\N
29246	4178	6	0	146110	\N
29246	4250	7	0	146148	\N
29250	77	2	0	145266	\N
29250	3853	3	0	146162	\N
29253	54	4	0	145337	\N
29253	3685	5	0	145338	\N
29260	322	3	0	146203	\N
29260	3071	4	0	146204	\N
29264	94	12	0	146114	\N
29264	8038	13	0	146236	\N
29266	435	5	0	146244	\N
29266	8039	6	0	146245	\N
29269	4172	6	0	146259	\N
29269	4197	7	0	146260	\N
29279	214	6	0	145676	\N
29279	4681	7	0	146332	\N
29281	202	3	0	145810	\N
29281	4857	4	0	145846	\N
29287	137	3	0	146363	\N
29287	3633	4	0	146364	\N
29293	236	1	0	146387	\N
29293	4015	4	0	146393	\N
29293	8049	4	0	146396	\N
29293	8050	5	0	146397	\N
29293	8051	5	1	146398	\N
29295	236	1	0	146387	\N
29295	235	4	0	146392	\N
29295	5467	5	0	146401	\N
29297	121	3	0	146417	\N
29297	4471	4	0	146418	\N
29300	123	5	0	143838	\N
29300	3908	6	0	146429	\N
29303	228	4	0	145896	\N
29303	4800	5	0	145897	\N
29310	151	3	0	146472	\N
29310	3046	4	0	146473	\N
29313	440	0	0	146492	\N
29317	110	4	0	146509	\N
29317	4134	5	0	146510	\N
29321	4172	3	0	146523	\N
29321	4275	4	0	146524	\N
29324	40	3	0	146541	\N
29324	372	4	0	146542	\N
29326	3625	2	0	141220	\N
29326	4359	3	0	141221	\N
29330	4	5	0	146576	\N
29330	4387	6	0	146577	\N
29333	2	3	0	146591	\N
29333	3548	4	0	146592	\N
29337	5539	3	0	146611	\N
29337	4233	7	0	146617	\N
29337	8056	8	0	146618	\N
29346	4178	3	0	146671	\N
29346	4211	4	0	146672	\N
29348	79	3	0	146350	\N
29348	3652	4	0	146351	\N
29350	132	6	0	146693	\N
29350	4690	7	0	146694	\N
29352	4172	6	0	146543	\N
29352	4197	7	0	146707	\N
29359	264	2	0	141148	\N
29359	2780	3	0	146731	\N
29361	316	3	0	146738	\N
29361	4249	4	0	146739	\N
29380	202	4	0	146837	\N
29380	3673	5	0	146838	\N
29383	1109	3	0	146847	\N
29383	3495	4	0	146848	\N
29385	228	2	0	146863	\N
29385	4776	3	0	146864	\N
29387	14	12	0	146883	\N
29387	8059	13	0	146884	\N
29392	79	2	0	146785	\N
29392	616	3	0	146918	\N
29394	431	5	0	146928	\N
29394	8061	6	0	146929	\N
29403	132	1	0	146968	\N
29403	3116	2	0	146970	\N
29405	285	33	0	145509	\N
29405	8062	34	0	146978	\N
29407	7412	3	0	146986	\N
29407	7466	4	0	146987	\N
29410	57	1	0	146998	\N
29410	56	10	0	147011	\N
29410	6708	11	0	147012	\N
29414	2636	11	0	147038	\N
29414	8064	12	0	147039	\N
29416	14	3	0	147046	\N
29416	4272	4	0	147047	\N
29419	597	4	0	147053	\N
29419	3733	5	0	147054	\N
29426	7677	5	0	134794	\N
29426	8066	6	0	147092	\N
29431	181	3	0	147112	\N
29431	4184	4	0	147113	\N
29433	142	3	0	147114	\N
29433	4254	4	0	147115	\N
29438	322	3	0	147145	\N
29438	1105	4	0	147146	\N
29447	322	3	0	147208	\N
29447	1105	4	0	147209	\N
29456	56	3	0	147273	\N
29456	4109	4	0	147274	\N
29458	82	7	0	143432	\N
29458	8079	8	0	147288	\N
29460	7225	7	0	143118	\N
29460	8081	8	0	147290	\N
29465	4	8	0	147318	\N
29465	4377	9	0	147319	\N
29467	79	4	0	147329	\N
29467	8083	5	0	147330	\N
29469	4172	8	0	147181	\N
29469	7815	9	0	147347	\N
29471	4178	3	0	147110	\N
29471	4211	4	0	147111	\N
29474	40	7	0	147383	\N
29474	4488	8	0	147384	\N
29478	8086	11	0	147405	\N
29478	86	12	0	147406	\N
29480	7192	11	0	147409	\N
29480	2	12	0	147410	\N
29484	79	3	0	147421	\N
29484	3652	4	0	147422	\N
29488	40	7	0	147460	\N
29488	4718	8	0	147461	\N
29497	7225	3	0	143118	\N
29497	7226	4	0	147502	\N
29499	4233	2	0	147517	\N
29499	5577	3	0	147518	\N
29501	4172	2	0	147181	\N
29501	4191	3	0	147522	\N
29507	123	3	0	143838	\N
29507	2856	4	0	146942	\N
29509	360	4	0	147569	\N
29509	3513	5	0	147570	\N
29515	6130	3	0	147604	\N
29515	528	8	0	147612	\N
29515	8090	9	0	147613	\N
29520	4178	2	0	147646	\N
29355	3775	5	0	145432	\N
29358	170	2	0	144906	\N
29358	1380	3	0	146730	\N
29360	170	0	0	144906	\N
29364	360	3	0	146754	\N
29364	3602	4	0	146755	\N
29367	6303	3	0	146768	\N
29367	6304	4	0	146769	\N
29375	40	0	0	146659	\N
29377	132	9	0	146693	\N
29377	6548	10	0	146824	\N
29379	7412	3	0	146830	\N
29379	7466	4	0	146831	\N
29382	852	3	0	140536	\N
29382	3612	4	0	140537	\N
29389	7412	4	0	146892	\N
29389	7499	5	0	146893	\N
29393	2	2	0	146919	\N
29393	2789	3	0	146920	\N
29395	391	5	0	146655	\N
29395	3558	6	0	146930	\N
29400	528	6	0	146955	\N
29400	4824	7	0	146956	\N
29402	132	2	0	146968	\N
29402	2756	3	0	146969	\N
29404	285	5	0	145509	\N
29404	5103	6	0	146977	\N
29406	75	5	0	146979	\N
29406	4484	6	0	146980	\N
29415	7699	11	0	135360	\N
29415	8065	11	0	147040	\N
29415	8064	12	0	147041	\N
29420	6450	4	0	145225	\N
29420	6467	5	0	145226	\N
29422	173	4	0	147066	\N
29422	3857	5	0	147067	\N
29424	4172	4	0	147070	\N
29424	4252	5	0	147071	\N
29436	200	4	0	142440	\N
29436	8069	5	0	147130	\N
29440	58	14	0	147178	\N
29440	1358	15	0	147179	\N
29442	4172	14	0	147181	\N
29442	8073	15	0	147182	\N
29444	852	2	0	147189	\N
29444	2872	3	0	147190	\N
29446	113	6	0	146156	\N
29446	8074	7	0	147202	\N
29449	102	2	0	145122	\N
29449	3053	3	0	147230	\N
29454	4	2	0	147258	\N
29454	2751	3	0	147259	\N
29457	288	7	0	147187	\N
29457	8078	8	0	147287	\N
29459	279	7	0	142653	\N
29459	8080	8	0	147289	\N
29461	268	3	0	145213	\N
29461	3815	4	0	147297	\N
29470	75	4	0	147101	\N
29470	2357	5	0	147355	\N
29472	367	3	0	147361	\N
29472	3683	4	0	147362	\N
29475	82	7	0	143432	\N
29475	8085	8	0	147385	\N
29482	8088	11	0	147411	\N
29482	189	12	0	147412	\N
29490	206	7	0	147463	\N
29490	8089	8	0	147464	\N
29491	230	12	0	146352	\N
29491	4258	13	0	147486	\N
29493	260	2	0	145657	\N
29493	3184	3	0	147492	\N
29495	424	3	0	147500	\N
29495	3611	4	0	147501	\N
29498	18	4	0	147511	\N
29498	2302	5	0	147512	\N
29503	224	2	0	147534	\N
29503	3150	3	0	147535	\N
29511	102	7	0	147584	\N
29511	5310	8	0	147585	\N
29519	2351	2	0	147644	\N
29519	4711	3	0	147645	\N
29527	94	4	0	146114	\N
29527	4677	5	0	146115	\N
29529	8094	94	0	147680	\N
29529	411	98	0	147681	\N
29529	2014	99	0	147682	\N
29546	488	7	0	147650	\N
29546	4729	8	0	147753	\N
29551	316	8	0	146738	\N
29551	8095	9	0	147778	\N
29555	8096	83	0	147783	\N
29555	30	126	0	147784	\N
29555	8097	127	0	147785	\N
29557	8098	4	0	147794	\N
29568	2	6	0	146919	\N
29568	4825	7	0	147886	\N
29570	96	6	0	147897	\N
29570	5078	7	0	147898	\N
29572	79	3	0	147907	\N
29572	3652	4	0	147908	\N
29574	56	3	0	147733	\N
29574	4109	4	0	147914	\N
29576	424	5	0	147500	\N
29576	6790	6	0	147932	\N
29582	140	11	0	147975	\N
29582	8104	12	0	147976	\N
29585	597	3	0	147986	\N
29585	3656	4	0	147987	\N
29588	67	8	0	146715	\N
29588	4151	9	0	148006	\N
29591	56	5	0	148021	\N
29591	3551	6	0	148022	\N
29595	79	12	0	148064	\N
29595	8107	13	0	148065	\N
29602	75	3	0	148111	\N
29602	3855	4	0	148112	\N
29616	186	1	0	145910	\N
29616	1080	2	0	148221	\N
29618	54	9	0	148235	\N
29618	8117	10	0	148236	\N
29624	75	6	0	148262	\N
29624	8120	7	0	148263	\N
29629	206	3	0	148297	\N
29629	4584	4	0	148298	\N
29633	56	11	0	148021	\N
29633	8123	12	0	148322	\N
29635	4178	3	0	148335	\N
29635	4211	4	0	148336	\N
29637	228	2	0	148337	\N
29637	4776	3	0	148339	\N
29642	336	2	0	148360	\N
29642	3332	3	0	148361	\N
29644	44	3	0	148365	\N
29644	3631	4	0	148366	\N
29647	86	5	0	148384	\N
29647	7243	6	0	148385	\N
29658	7412	14	0	148576	\N
29658	8135	15	0	148582	\N
29677	40	12	0	148866	\N
29677	8148	13	0	148867	\N
29679	244	12	0	148869	\N
29679	8150	13	0	148871	\N
29683	7788	5	0	148916	\N
29683	86	18	0	148917	\N
29683	3746	19	0	148918	\N
29690	4172	7	0	148976	\N
29690	6628	8	0	148977	\N
29692	6044	3	0	140824	\N
29692	8156	4	0	148996	\N
29698	27	6	0	149012	\N
29698	3302	7	0	149013	\N
29701	266	0	0	144018	\N
29703	167	9	0	149029	\N
29703	8158	10	0	149030	\N
29707	7412	7	0	149027	\N
29418	595	4	0	142814	\N
29418	3878	5	0	145231	\N
29428	75	4	0	147101	\N
29428	8068	5	0	147102	\N
29430	4178	3	0	147110	\N
29430	4211	4	0	147111	\N
29432	202	3	0	147108	\N
29432	4857	4	0	147109	\N
29434	142	3	0	147114	\N
29434	4254	4	0	147115	\N
29443	288	2	0	147187	\N
29443	2842	3	0	147188	\N
29445	251	2	0	147191	\N
29445	1851	3	0	147192	\N
29448	7412	9	0	147225	\N
29448	8075	10	0	147226	\N
29450	102	3	0	145122	\N
29450	3597	4	0	147232	\N
29452	488	4	0	147251	\N
29452	8076	5	0	147252	\N
29463	1470	3	0	144390	\N
29463	3838	4	0	147303	\N
29466	156	8	0	147320	\N
29466	8082	9	0	147321	\N
29468	7412	8	0	147345	\N
29468	8084	9	0	147346	\N
29473	391	4	0	147369	\N
29473	3913	5	0	147370	\N
29477	8087	11	0	147407	\N
29477	262	12	0	147408	\N
29479	8087	11	0	147407	\N
29479	262	12	0	147408	\N
29481	8087	11	0	147407	\N
29481	262	12	0	147408	\N
29483	4178	3	0	147419	\N
29483	4211	4	0	147420	\N
29485	79	3	0	147421	\N
29485	3652	4	0	147422	\N
29486	27	9	0	145470	\N
29486	5696	10	0	147439	\N
29492	4178	2	0	147419	\N
29492	4247	3	0	147491	\N
29494	108	3	0	147498	\N
29494	4171	4	0	147499	\N
29496	279	3	0	142653	\N
29496	3641	4	0	142654	\N
29505	4178	3	0	147419	\N
29505	4211	4	0	147420	\N
29510	142	7	0	147114	\N
29510	6504	8	0	147583	\N
29512	132	7	0	147586	\N
29512	3709	8	0	147587	\N
29514	4172	4	0	147596	\N
29514	4219	5	0	147597	\N
29517	2290	3	0	147617	\N
29517	230	8	0	147618	\N
29517	8092	9	0	147619	\N
29521	100	2	0	147648	\N
29521	2918	3	0	147649	\N
29526	4172	4	0	147596	\N
29526	4219	5	0	147597	\N
29528	411	2	0	141906	\N
29528	3370	3	0	147677	\N
29530	3625	4	0	147689	\N
29530	3802	5	0	147690	\N
29532	266	4	0	147692	\N
29532	4100	5	0	147693	\N
29534	3628	4	0	146549	\N
29534	3803	5	0	147696	\N
29536	224	3	0	147702	\N
29536	3603	4	0	147703	\N
29538	18	3	0	147706	\N
29538	3621	4	0	147707	\N
29540	224	0	0	145644	\N
29548	4178	7	0	147756	\N
29548	4396	8	0	147757	\N
29550	40	2	0	147763	\N
29550	282	3	0	147764	\N
29552	324	6	0	147779	\N
29552	5241	7	0	147780	\N
29554	4172	8	0	147596	\N
29554	5928	9	0	147782	\N
29558	4178	3	0	147756	\N
29558	4211	4	0	147799	\N
29560	8099	46	0	147806	\N
29560	200	110	0	147829	\N
29560	8100	111	0	147830	\N
29563	7437	2	0	147860	\N
29563	8101	2	0	147861	\N
29563	3332	3	0	147862	\N
29565	77	4	0	147871	\N
29565	3619	5	0	147872	\N
29567	210	6	0	145894	\N
29567	3721	7	0	147885	\N
29575	852	4	0	147922	\N
29575	4162	5	0	147923	\N
29578	4088	2	0	147938	\N
29578	4332	3	0	147939	\N
29584	595	3	0	142814	\N
29584	3654	4	0	147985	\N
29590	290	5	0	148019	\N
29590	6379	6	0	148020	\N
29598	18	2	0	147706	\N
29598	1685	3	0	148084	\N
29604	230	2	0	148139	\N
29604	3307	3	0	148140	\N
29606	908	3	0	148155	\N
29606	3591	4	0	148156	\N
29614	18	3	0	148213	\N
29614	3621	4	0	148214	\N
29619	212	9	0	148237	\N
29619	8118	10	0	148238	\N
29621	4178	6	0	148249	\N
29621	4250	7	0	148250	\N
29623	96	6	0	148260	\N
29623	8119	7	0	148261	\N
29626	44	13	0	146284	\N
29626	8121	14	0	148286	\N
29628	4172	2	0	148295	\N
29628	4285	3	0	148296	\N
29630	4178	0	0	148249	\N
29634	852	3	0	148329	\N
29634	3612	4	0	148330	\N
29639	4178	5	0	148349	\N
29639	4202	6	0	148350	\N
29641	132	3	0	147586	\N
29641	3729	4	0	148356	\N
29645	316	4	0	148372	\N
29645	5437	5	0	148373	\N
29649	268	9	0	148405	\N
29649	8125	10	0	148406	\N
29652	125	7	0	148454	\N
29652	8128	8	0	148455	\N
29654	2	20	0	148205	\N
29654	8130	21	0	148487	\N
29656	251	9	0	147191	\N
29656	8133	10	0	148552	\N
29662	1470	9	0	148631	\N
29662	8138	10	0	148637	\N
29664	4172	7	0	148295	\N
29664	6628	8	0	148651	\N
29669	20	9	0	148746	\N
29669	8141	10	0	148747	\N
29674	56	15	0	148021	\N
29674	3418	16	0	148805	\N
29676	224	9	0	147702	\N
29676	8147	10	0	148845	\N
29678	244	9	0	148869	\N
29678	8149	10	0	148870	\N
29680	273	12	0	148885	\N
29680	586	13	0	148886	\N
29684	4415	5	0	148919	\N
29684	4172	18	0	148920	\N
29684	8151	19	0	148921	\N
29684	1075	19	1	148922	\N
29686	117	10	0	148939	\N
29686	8153	11	0	148940	\N
29506	4429	6	0	147557	\N
29508	6723	3	0	146943	\N
29508	6724	4	0	146944	\N
29513	391	4	0	147594	\N
29513	3913	5	0	147595	\N
29516	7843	3	0	147614	\N
29516	7412	8	0	147615	\N
29516	8091	9	0	147616	\N
29518	100	11	0	147640	\N
29518	8093	12	0	147641	\N
29523	12	2	0	145613	\N
29523	3028	3	0	147652	\N
29525	908	6	0	147664	\N
29525	3555	7	0	147665	\N
29537	7412	3	0	147704	\N
29537	7466	4	0	147705	\N
29541	40	7	0	147460	\N
29541	4718	8	0	147461	\N
29543	117	6	0	147731	\N
29543	3804	7	0	147732	\N
29545	4178	3	0	147646	\N
29545	4211	4	0	147740	\N
29549	18	7	0	147706	\N
29549	1618	8	0	147758	\N
29559	77	4	0	145266	\N
29559	3619	5	0	145267	\N
29562	6733	10	0	147855	\N
29562	125	11	0	147856	\N
29564	336	2	0	143663	\N
29564	3332	3	0	147863	\N
29569	4172	6	0	147596	\N
29569	4197	7	0	147887	\N
29571	8102	3	0	147905	\N
29571	8103	4	0	147906	\N
29573	79	2	0	147907	\N
29573	616	3	0	147909	\N
29580	4787	3	0	147954	\N
29580	4788	4	0	147955	\N
29583	4178	3	0	147983	\N
29583	4211	4	0	147984	\N
29586	6450	3	0	145225	\N
29586	6847	4	0	147988	\N
29592	173	6	0	147066	\N
29592	3606	7	0	148034	\N
29594	202	3	0	147108	\N
29594	4857	4	0	147109	\N
29596	4172	12	0	148004	\N
29596	6408	13	0	148066	\N
29600	6303	3	0	148093	\N
29600	6304	4	0	148096	\N
29608	6864	3	0	112041	\N
29608	8112	4	0	148159	\N
29610	202	3	0	148168	\N
29610	8114	4	0	148169	\N
29612	908	7	0	148155	\N
29612	4078	8	0	148204	\N
29620	23	6	0	145653	\N
29620	4632	7	0	148248	\N
29622	214	6	0	148035	\N
29622	4681	7	0	148036	\N
29625	4178	13	0	148249	\N
29625	4782	14	0	148285	\N
29627	14	3	0	148293	\N
29627	4272	4	0	148294	\N
29632	391	11	0	148320	\N
29632	8122	12	0	148321	\N
29636	228	3	0	148337	\N
29636	3186	4	0	148338	\N
29640	69	3	0	144223	\N
29640	4536	4	0	144328	\N
29643	336	3	0	148360	\N
29643	3400	4	0	148364	\N
29650	110	19	0	148436	\N
29650	8126	20	0	148437	\N
29655	8131	12	0	148509	\N
29655	67	31	0	148538	\N
29655	8132	32	0	148539	\N
29657	7412	22	0	148576	\N
29657	8134	23	0	148577	\N
29659	264	15	0	148609	\N
29659	8136	16	0	148610	\N
29661	1470	6	0	148631	\N
29661	6626	7	0	148632	\N
29663	69	9	0	148638	\N
29663	8139	10	0	148639	\N
29666	216	2	0	148703	\N
29666	77	19	0	148729	\N
29666	6761	20	0	148730	\N
29667	216	2	0	148703	\N
29667	77	19	0	148729	\N
29667	6761	20	0	148730	\N
29671	33	18	0	148779	\N
29671	8143	19	0	148780	\N
29673	6723	18	0	146943	\N
29673	8145	19	0	148783	\N
29682	7788	5	0	148916	\N
29682	86	18	0	148917	\N
29682	3746	19	0	148918	\N
29688	94	6	0	148951	\N
29688	5280	7	0	148952	\N
29699	266	6	0	147692	\N
29699	1912	7	0	149014	\N
29702	7412	9	0	149027	\N
29702	8157	10	0	149028	\N
29706	391	7	0	149043	\N
29706	3927	8	0	149044	\N
29708	4172	6	0	149008	\N
29708	7116	7	0	149046	\N
29711	117	30	0	149089	\N
29711	8163	31	0	149090	\N
29716	2765	2	0	149100	\N
29716	528	20	0	149130	\N
29716	8169	21	0	149132	\N
29718	181	27	0	149181	\N
29718	6359	28	0	149182	\N
29721	235	9	0	149220	\N
29721	8173	10	0	149221	\N
29726	90	17	0	149250	\N
29726	8178	18	0	149251	\N
29733	40	7	0	148866	\N
29733	3595	8	0	149285	\N
29741	40	9	0	148866	\N
29741	8185	10	0	149379	\N
29743	4233	12	0	149422	\N
29743	8186	13	0	149423	\N
29746	94	18	0	149434	\N
29746	8187	19	0	149435	\N
29756	5688	4	0	149506	\N
29756	793	19	0	149530	\N
29756	8194	20	0	149531	\N
29756	4017	20	1	149532	\N
29756	8195	21	0	149533	\N
29756	8196	21	1	149534	\N
29756	8197	22	0	149535	\N
29756	7915	22	1	48170	\N
29756	8198	23	0	149536	\N
29756	8199	23	1	149537	\N
29758	1150	1	0	149542	\N
29758	793	25	0	149555	\N
29758	8203	26	0	149556	\N
29758	2435	26	1	146393	\N
29758	8204	27	0	149557	\N
29758	3526	27	1	149558	\N
29758	5348	28	0	149559	\N
29767	117	19	0	149089	\N
29767	6848	20	0	149720	\N
29769	117	17	0	149089	\N
29769	8209	18	0	149722	\N
29771	6013	6	0	149734	\N
29771	367	16	0	149769	\N
29771	2435	17	0	149532	\N
29771	8213	17	1	149774	\N
29771	8210	18	0	146005	\N
29771	8214	18	1	149775	\N
29771	8212	19	0	149771	\N
29771	6316	19	1	149772	\N
29777	102	15	0	147584	\N
29520	4527	3	0	147647	\N
29522	488	2	0	147650	\N
29522	2991	3	0	147651	\N
29524	62	6	0	145339	\N
29524	6466	7	0	147663	\N
29531	119	4	0	140709	\N
29531	3518	5	0	147691	\N
29533	198	4	0	147694	\N
29533	4161	5	0	147695	\N
29535	224	0	0	145644	\N
29539	224	0	0	145644	\N
29542	69	6	0	144223	\N
29542	4084	7	0	147730	\N
29544	56	6	0	147733	\N
29544	4703	7	0	147734	\N
29547	360	7	0	147754	\N
29547	4970	8	0	147755	\N
29553	324	8	0	147779	\N
29553	5427	9	0	147781	\N
29556	290	3	0	147792	\N
29556	7789	4	0	147793	\N
29561	60	2	0	147834	\N
29561	4544	3	0	147835	\N
29566	192	6	0	144838	\N
29566	4669	7	0	147884	\N
29577	233	2	0	145431	\N
29577	1849	3	0	147937	\N
29579	71	4	0	143311	\N
29579	3887	5	0	147947	\N
29581	4172	3	0	147596	\N
29581	4275	4	0	147956	\N
29587	4172	8	0	148004	\N
29587	5928	9	0	148005	\N
29589	8105	83	0	148007	\N
29589	30	97	0	148008	\N
29589	8106	98	0	148009	\N
29593	214	6	0	148035	\N
29593	4681	7	0	148036	\N
29597	4450	1	0	148069	\N
29597	4178	7	0	148079	\N
29597	4202	8	0	148080	\N
29599	6303	4	0	148093	\N
29599	7489	5	0	148094	\N
29601	90	5	0	146003	\N
29601	8108	6	0	148104	\N
29603	8109	62	0	148119	\N
29603	200	123	0	148137	\N
29603	8110	124	0	148138	\N
29605	256	4	0	148149	\N
29605	8111	5	0	148150	\N
29607	35	3	0	148157	\N
29607	3563	4	0	148158	\N
29609	336	3	0	148166	\N
29609	8113	4	0	148167	\N
29611	345	13	0	148191	\N
29611	8115	14	0	148192	\N
29613	2	7	0	148205	\N
29613	2858	8	0	148206	\N
29615	186	3	0	145910	\N
29615	4294	4	0	148220	\N
29617	6765	9	0	142127	\N
29617	8116	10	0	148234	\N
29646	4178	5	0	148382	\N
29646	4202	6	0	148383	\N
29648	5885	6	0	142939	\N
29648	8124	7	0	148396	\N
29651	262	7	0	148452	\N
29651	8127	8	0	148453	\N
29653	451	7	0	143444	\N
29653	8129	8	0	148456	\N
29660	2	8	0	148621	\N
29660	8137	9	0	148622	\N
29665	40	29	0	148697	\N
29665	8140	30	0	148698	\N
29668	20	9	0	148746	\N
29668	8141	10	0	148747	\N
29670	793	9	0	144165	\N
29670	8142	10	0	148748	\N
29672	123	18	0	148781	\N
29672	8144	19	0	148782	\N
29675	4178	18	0	148829	\N
29675	8146	19	0	148830	\N
29681	4082	5	0	148896	\N
29681	198	18	0	148914	\N
29681	4263	19	0	148915	\N
29685	2	10	0	148937	\N
29685	8152	11	0	148938	\N
29687	117	9	0	148939	\N
29687	8154	10	0	148941	\N
29689	100	8	0	147648	\N
29689	5431	9	0	148964	\N
29691	6044	10	0	140824	\N
29691	8155	11	0	148994	\N
29693	266	0	0	144018	\N
29696	4172	6	0	149008	\N
29696	5278	7	0	149009	\N
29704	167	6	0	149029	\N
29704	8159	7	0	149032	\N
29709	4178	30	0	149006	\N
29709	5304	31	0	149087	\N
29712	102	30	0	147584	\N
29712	8164	31	0	149091	\N
29714	8166	25	0	149093	\N
29714	149	126	0	149094	\N
29714	8167	127	0	149095	\N
29720	8171	65	0	149201	\N
29720	2578	126	0	149202	\N
29720	8172	127	0	149203	\N
29722	117	9	0	149089	\N
29722	8174	10	0	149222	\N
29728	54	6	0	149266	\N
29728	3507	7	0	149267	\N
29730	108	7	0	147498	\N
29730	8180	8	0	149282	\N
29732	62	7	0	145339	\N
29732	8181	8	0	149284	\N
29734	852	7	0	149286	\N
29734	8182	8	0	149287	\N
29736	79	5	0	148064	\N
29736	5993	6	0	149291	\N
29739	4237	8	0	149315	\N
29739	4178	38	0	149362	\N
29739	4841	39	0	149363	\N
29745	7412	18	0	149027	\N
29745	8075	19	0	149433	\N
29752	198	8	0	149474	\N
29752	8191	9	0	149484	\N
29754	336	8	0	149497	\N
29754	8192	9	0	149498	\N
29757	5688	4	0	149506	\N
29757	793	19	0	149530	\N
29757	8200	20	0	149538	\N
29757	4307	20	1	149539	\N
29757	8195	21	0	149533	\N
29757	8201	21	1	149540	\N
29757	7915	22	0	48170	\N
29757	8202	22	1	149541	\N
29759	125	23	0	148454	\N
29759	8205	24	0	149588	\N
29759	2171	24	1	149589	\N
29759	1075	25	0	149590	\N
29761	378	12	0	25454	\N
29761	7301	13	0	123249	\N
29763	378	11	0	25454	\N
29763	8207	12	0	149617	\N
29770	6013	6	0	149734	\N
29770	367	28	0	149769	\N
29770	2435	29	0	149532	\N
29770	8210	29	1	146005	\N
29770	8211	30	0	149770	\N
29770	8212	30	1	149771	\N
29770	6316	31	0	149772	\N
29772	192	31	0	144838	\N
29772	8215	32	0	149832	\N
29772	1075	32	1	149833	\N
29780	7412	15	0	149919	\N
29780	7507	16	0	149920	\N
29694	4178	6	0	149006	\N
29694	6623	7	0	149007	\N
29697	56	6	0	149010	\N
29697	3398	7	0	149011	\N
29700	266	0	0	144018	\N
29705	242	9	0	146050	\N
29705	8160	10	0	149033	\N
29710	102	22	0	147584	\N
29710	8162	23	0	149088	\N
29713	149	30	0	147068	\N
29713	8165	31	0	149092	\N
29723	77	9	0	149223	\N
29723	8175	10	0	149224	\N
29725	64	9	0	144977	\N
29725	8177	10	0	149226	\N
29727	4178	9	0	149263	\N
29727	7720	10	0	149264	\N
29729	54	9	0	149266	\N
29729	8179	10	0	149268	\N
29731	79	7	0	148064	\N
29731	3682	8	0	149283	\N
29735	852	9	0	149286	\N
29735	8183	10	0	149289	\N
29737	852	6	0	149286	\N
29737	8184	7	0	149292	\N
29742	4178	16	0	149404	\N
29742	4509	17	0	149405	\N
29744	4233	18	0	149422	\N
29744	6392	19	0	149432	\N
29748	6044	24	0	149456	\N
29748	8189	25	0	149466	\N
29750	6044	5	0	149456	\N
29750	8190	6	0	149469	\N
29765	1433	12	0	16653	\N
29765	8208	13	0	149662	\N
29768	27	19	0	149012	\N
29768	4830	20	0	149721	\N
29773	5560	31	0	149834	\N
29773	8216	32	0	149835	\N
29773	1075	32	1	149833	\N
29775	2081	28	0	149886	\N
29775	8218	29	0	149887	\N
29778	156	15	0	147320	\N
29778	6498	16	0	149917	\N
29779	102	13	0	147584	\N
29779	5013	14	0	149918	\N
29787	132	29	0	150069	\N
29787	8231	30	0	150070	\N
29791	785	13	0	150075	\N
29791	8233	14	0	150100	\N
29796	852	9	0	149286	\N
29796	8183	10	0	149289	\N
29798	6044	9	0	150262	\N
29798	2435	10	0	150263	\N
29798	1355	10	1	150264	\N
29798	8240	11	0	150265	\N
29798	8220	11	1	150266	\N
29798	8241	12	0	150267	\N
29798	8242	12	1	150268	\N
29798	3526	13	0	150269	\N
29798	8224	13	1	150270	\N
29798	8243	14	0	150271	\N
29798	8244	14	1	150272	\N
29808	4178	5	0	149912	\N
29808	4202	6	0	150364	\N
29812	6303	0	0	146713	\N
29814	214	11	0	148035	\N
29814	8252	12	0	150394	\N
29816	1470	29	0	148631	\N
29816	8254	30	0	150421	\N
29821	125	10	0	150501	\N
29821	8261	11	0	150502	\N
29823	14	9	0	150521	\N
29823	8262	10	0	150522	\N
29825	119	11	0	140709	\N
29825	8264	12	0	150542	\N
29827	300	9	0	146603	\N
29827	4770	10	0	150560	\N
29832	170	17	0	144906	\N
29832	8267	18	0	150590	\N
29834	156	5	0	147320	\N
29834	7823	6	0	150611	\N
29836	1470	5	0	150622	\N
29836	8268	6	0	150623	\N
29838	2	23	0	148937	\N
29838	3914	24	0	150675	\N
29842	4172	21	0	150519	\N
29842	4440	22	0	150768	\N
29844	113	5	0	150786	\N
29844	3786	6	0	150787	\N
29846	113	0	0	150786	\N
29848	8280	9	0	150862	\N
29848	2	38	0	150869	\N
29848	2435	39	0	150852	\N
29848	6025	39	1	150853	\N
29848	8195	40	0	150854	\N
29848	8281	40	1	150870	\N
29848	8213	41	0	150856	\N
29848	8197	41	1	150857	\N
29848	8278	42	0	150858	\N
29848	8279	42	1	150859	\N
29848	8243	43	0	150860	\N
29848	8282	43	1	150871	\N
29860	391	10	0	151052	\N
29860	8297	11	0	151053	\N
29860	8298	11	1	151054	\N
29860	2171	12	0	151055	\N
29860	8198	12	1	151056	\N
29860	8299	13	0	151057	\N
29865	56	9	0	151104	\N
29865	8303	10	0	151105	\N
29869	3628	10	0	146549	\N
29869	8306	11	0	151125	\N
29872	2	14	0	151152	\N
29872	5834	15	0	151153	\N
29878	8316	20	0	151221	\N
29878	1021	21	0	151222	\N
29883	135	20	0	144899	\N
29883	8323	21	0	151314	\N
29887	56	9	0	151104	\N
29887	8303	10	0	151105	\N
29889	27	10	0	149012	\N
29889	6167	11	0	151352	\N
29891	841	9	0	143466	\N
29891	8325	10	0	151370	\N
29896	69	10	0	151388	\N
29896	8329	11	0	151389	\N
29900	2351	10	0	151407	\N
29900	8333	11	0	151408	\N
29902	852	8	0	151409	\N
29902	8335	9	0	151412	\N
29904	360	9	0	151446	\N
29904	4017	10	0	151447	\N
29904	1355	10	1	151448	\N
29904	8269	11	0	151449	\N
29904	8236	11	1	151450	\N
29904	8258	12	0	151451	\N
29904	8029	12	1	151452	\N
29904	8336	13	0	151453	\N
29904	8239	13	1	151454	\N
29904	8225	14	0	151455	\N
29904	7281	14	1	151456	\N
29906	4178	11	0	151477	\N
29906	5529	12	0	151478	\N
29908	402	1	0	151481	\N
29908	2889	2	0	151482	\N
29915	90	7	0	151530	\N
29915	8344	8	0	151531	\N
29917	424	10	0	151551	\N
29917	8346	11	0	151552	\N
29919	4178	9	0	151477	\N
29919	7720	10	0	151568	\N
29921	18	9	0	149467	\N
29921	7719	10	0	151594	\N
29923	4178	8	0	151477	\N
29923	6776	9	0	151607	\N
29938	8364	32	0	151749	\N
29707	8161	8	0	149045	\N
29715	2765	2	0	149100	\N
29715	528	21	0	149130	\N
29715	8168	22	0	149131	\N
29717	4178	15	0	149157	\N
29717	4250	16	0	149158	\N
29719	2578	21	0	139386	\N
29719	8170	22	0	149200	\N
29724	77	6	0	149223	\N
29724	8176	7	0	149225	\N
29738	793	7	0	149302	\N
29738	3547	8	0	149303	\N
29740	4178	9	0	149377	\N
29740	7720	10	0	149378	\N
29747	6044	16	0	149456	\N
29747	8188	17	0	149457	\N
29749	18	24	0	149467	\N
29749	2381	25	0	149468	\N
29751	198	2	0	149474	\N
29751	513	3	0	149475	\N
29753	4172	3	0	149008	\N
29753	4275	4	0	149490	\N
29755	137	5	0	146363	\N
29755	8193	6	0	149499	\N
29760	378	14	0	25454	\N
29760	8206	15	0	149615	\N
29762	451	14	0	143444	\N
29762	3743	15	0	149616	\N
29764	14	11	0	148293	\N
29764	1785	12	0	149637	\N
29766	4178	13	0	149687	\N
29766	4331	14	0	149688	\N
29774	94	31	0	149434	\N
29774	8217	32	0	149836	\N
29774	1075	32	1	149833	\N
29776	4178	14	0	149912	\N
29776	4429	15	0	149913	\N
29782	2756	2	0	149956	\N
29782	132	13	0	149976	\N
29782	4307	14	0	149977	\N
29782	6025	14	1	147860	\N
29782	8219	15	0	149978	\N
29782	8220	15	1	149979	\N
29782	8221	16	0	149980	\N
29782	8210	16	1	149981	\N
29782	8222	17	0	149982	\N
29782	8223	17	1	149983	\N
29782	8224	18	0	149984	\N
29782	8225	18	1	149985	\N
29782	6316	19	0	149986	\N
29784	646	2	0	150013	\N
29784	449	13	0	138230	\N
29784	4307	14	0	149977	\N
29784	8229	14	1	150014	\N
29784	6025	15	0	147860	\N
29784	8219	15	1	149978	\N
29784	8220	16	0	149979	\N
29784	8221	16	1	149980	\N
29784	8210	17	0	149981	\N
29784	8222	17	1	149982	\N
29784	8224	18	0	149984	\N
29784	8225	18	1	149985	\N
29784	6316	19	0	149986	\N
29793	20	12	0	148746	\N
29793	1931	13	0	150125	\N
29795	242	12	0	146050	\N
29795	5519	13	0	150127	\N
29797	8234	50	0	150217	\N
29797	242	61	0	150235	\N
29797	8235	62	0	150236	\N
29797	8236	62	1	150237	\N
29797	8237	63	0	150238	\N
29797	8226	63	1	150239	\N
29797	8238	64	0	150240	\N
29797	7915	64	1	150241	\N
29797	8239	65	0	150242	\N
29797	8225	65	1	150243	\N
29797	3009	66	0	150244	\N
29801	908	11	0	150292	\N
29801	988	12	0	150293	\N
29803	198	19	0	150326	\N
29803	4829	20	0	150327	\N
29805	86	9	0	150337	\N
29805	8248	10	0	150344	\N
29807	908	1	0	150292	\N
29807	909	2	0	150354	\N
29810	7412	5	0	149919	\N
29810	7519	6	0	150366	\N
29820	113	19	0	150486	\N
29820	8260	20	0	150487	\N
29837	40	8	0	148866	\N
29837	2435	9	0	150634	\N
29837	7714	9	1	150635	\N
29837	8269	10	0	150636	\N
29837	8196	10	1	150637	\N
29837	8220	11	0	150638	\N
29837	8270	11	1	150639	\N
29837	8271	12	0	150640	\N
29837	8201	12	1	150641	\N
29837	8212	13	0	150642	\N
29837	8224	13	1	150643	\N
29837	8225	14	0	150644	\N
29837	8272	14	1	150645	\N
29840	4178	27	0	150484	\N
29840	4682	28	0	150720	\N
29845	46	5	0	129457	\N
29845	8275	6	0	150788	\N
29850	4178	9	0	150891	\N
29850	2435	10	0	150887	\N
29850	8226	10	1	150889	\N
29850	8285	11	0	150892	\N
29850	8284	11	1	150890	\N
29852	242	15	0	150922	\N
29852	1630	16	0	150923	\N
29857	44	7	0	148365	\N
29857	4120	8	0	150995	\N
29859	6057	5	0	151017	\N
29859	300	11	0	151025	\N
29859	8291	12	0	151026	\N
29859	8292	12	1	151027	\N
29859	6335	13	0	151028	\N
29859	8256	13	1	151029	\N
29859	8293	14	0	151030	\N
29859	8271	14	1	151031	\N
29859	8294	15	0	151032	\N
29859	8295	15	1	151033	\N
29859	3526	16	0	151034	\N
29859	8296	16	1	151035	\N
29859	8225	17	0	151036	\N
29859	2465	17	1	151037	\N
29863	324	9	0	147779	\N
29863	8301	10	0	151101	\N
29868	4178	10	0	150891	\N
29868	5637	11	0	151124	\N
29870	4178	20	0	151149	\N
29870	7664	21	0	151150	\N
29874	288	10	0	151168	\N
29874	8308	11	0	151169	\N
29880	277	2	0	151248	\N
29880	64	11	0	151249	\N
29880	8292	12	0	151238	\N
29880	8317	12	1	151239	\N
29880	8318	13	0	151240	\N
29880	8321	13	1	151250	\N
29880	8293	14	0	151241	\N
29880	8319	14	1	151242	\N
29880	8029	15	0	151243	\N
29880	8284	15	1	151245	\N
29880	8225	16	0	151246	\N
29880	8272	16	1	151247	\N
29884	137	20	0	151315	\N
29884	8324	21	0	151316	\N
29886	4178	9	0	151332	\N
29886	7720	10	0	151333	\N
29895	4178	10	0	151332	\N
29895	6660	11	0	151351	\N
29897	3628	10	0	146549	\N
29777	5086	16	0	149916	\N
29781	23	20	0	149951	\N
29781	6505	21	0	149952	\N
29783	455	1	0	149987	\N
29783	132	74	0	150007	\N
29783	4307	75	0	149539	\N
29783	8226	75	1	150008	\N
29783	8227	76	0	150009	\N
29783	7915	76	1	48170	\N
29783	8228	77	0	150010	\N
29783	3108	77	1	150011	\N
29783	6316	78	0	150012	\N
29785	60	29	0	150067	\N
29785	8230	30	0	150068	\N
29788	132	8	0	150072	\N
29788	8232	9	0	150073	\N
29794	852	12	0	149286	\N
29794	1848	13	0	150126	\N
29800	6044	102	0	150262	\N
29800	2171	103	0	149589	\N
29800	8246	103	1	150277	\N
29800	1075	104	0	149590	\N
29802	391	11	0	150294	\N
29802	406	12	0	150295	\N
29811	6303	5	0	150367	\N
29811	6497	6	0	150368	\N
29817	4219	4	0	150427	\N
29817	4172	5	0	150428	\N
29819	4178	19	0	150484	\N
29819	5637	20	0	150485	\N
29824	3625	11	0	147689	\N
29824	8263	12	0	150541	\N
29826	3628	6	0	146549	\N
29826	3643	7	0	150545	\N
29828	82	9	0	143432	\N
29828	8265	10	0	150561	\N
29830	852	0	0	149286	\N
29835	242	5	0	150612	\N
29835	6342	6	0	150613	\N
29843	56	6	0	150776	\N
29843	3398	7	0	150777	\N
29854	235	9	0	149220	\N
29854	8288	10	0	150973	\N
29856	2351	10	0	150991	\N
29856	8290	11	0	150992	\N
29862	40	19	0	151087	\N
29862	4104	20	0	151088	\N
29867	119	10	0	140709	\N
29867	8305	11	0	151123	\N
29873	528	7	0	151162	\N
29873	5937	8	0	151163	\N
29876	8309	6	0	151172	\N
29876	528	121	0	151187	\N
29876	4017	122	0	150444	\N
29876	8310	122	1	151188	\N
29876	8298	123	0	151189	\N
29876	8236	123	1	150449	\N
29876	8311	124	0	151190	\N
29876	8312	124	1	151191	\N
29876	8313	125	0	151192	\N
29876	8212	125	1	150452	\N
29876	3108	126	0	150011	\N
29876	8224	126	1	150453	\N
29876	8314	127	0	151193	\N
29876	8202	127	1	151194	\N
29881	117	20	0	151280	\N
29881	6945	21	0	151281	\N
29885	4172	9	0	150989	\N
29885	5365	10	0	151331	\N
29892	841	8	0	143466	\N
29892	8326	9	0	151371	\N
29894	119	10	0	140709	\N
29894	8328	11	0	151387	\N
29898	4172	10	0	150989	\N
29898	8331	11	0	151405	\N
29901	852	10	0	151409	\N
29901	8334	11	0	151410	\N
29905	453	9	0	151457	\N
29905	4017	10	0	151447	\N
29905	1355	10	1	151448	\N
29905	8269	11	0	151449	\N
29905	8236	11	1	151450	\N
29905	8337	12	0	151458	\N
29905	8258	12	1	151451	\N
29905	8029	13	0	151452	\N
29905	8239	13	1	151454	\N
29905	8225	14	0	151455	\N
29905	7281	14	1	151456	\N
29907	435	11	0	146244	\N
29907	481	12	0	151479	\N
29909	402	4	0	151481	\N
29909	8338	5	0	151488	\N
29912	132	8	0	151514	\N
29912	8341	9	0	151516	\N
29914	132	8	0	151520	\N
29914	8343	9	0	151521	\N
29924	285	8	0	145509	\N
29924	8353	9	0	151608	\N
29927	14	19	0	151617	\N
29927	8355	20	0	151639	\N
29929	186	24	0	151657	\N
29929	7407	25	0	151658	\N
29935	4172	10	0	150989	\N
29935	8362	11	0	151746	\N
29937	62	10	0	151747	\N
29937	8363	11	0	151748	\N
29939	62	5	0	151747	\N
29939	8367	6	0	151768	\N
29952	230	0	0	151777	\N
29954	230	10	0	151893	\N
29954	8376	11	0	151894	\N
29961	142	5	0	151956	\N
29961	8389	6	0	151957	\N
29964	7412	5	0	149919	\N
29964	7519	6	0	150366	\N
29965	145	17	0	151986	\N
29965	6887	18	0	151987	\N
29972	322	9	0	151058	\N
29972	8395	10	0	152031	\N
29974	4172	18	0	152061	\N
29974	4977	19	0	152062	\N
29977	2351	20	0	152097	\N
29977	8397	21	0	152098	\N
29983	4172	19	0	152061	\N
29983	4663	20	0	152183	\N
29985	424	19	0	152186	\N
29985	5802	20	0	152187	\N
29988	528	14	0	151162	\N
29988	5750	15	0	152257	\N
29992	156	10	0	147320	\N
29992	8411	11	0	152283	\N
29994	20	9	0	148746	\N
29994	8141	10	0	148747	\N
30001	6025	54	0	152370	\N
30001	8195	54	1	152371	\N
30001	8419	55	0	152372	\N
30001	8251	55	1	152373	\N
30001	149	121	0	152383	\N
30001	2435	122	0	151753	\N
30001	6319	122	1	152221	\N
30001	8256	123	0	152384	\N
30001	8420	123	1	152385	\N
30001	8421	124	0	152386	\N
30001	8293	124	1	152387	\N
30001	8213	125	0	151756	\N
30001	8351	125	1	151727	\N
30001	8422	126	0	152388	\N
30001	8239	126	1	151729	\N
30001	8423	127	0	152389	\N
30003	316	9	0	151792	\N
30003	4094	10	0	152420	\N
30006	40	20	0	151991	\N
30006	8426	21	0	152453	\N
30008	186	9	0	152485	\N
30008	8427	10	0	152486	\N
30010	82	9	0	143432	\N
30010	8265	10	0	150561	\N
29786	60	29	0	150067	\N
29786	8230	30	0	150068	\N
29789	132	29	0	147586	\N
29789	8231	30	0	150074	\N
29790	785	0	0	150075	\N
29792	140	13	0	150101	\N
29792	6827	14	0	150102	\N
29799	6044	8	0	150262	\N
29799	2435	9	0	150263	\N
29799	1355	9	1	150264	\N
29799	8240	10	0	150265	\N
29799	8220	10	1	150266	\N
29799	8241	11	0	150267	\N
29799	8242	11	1	150268	\N
29799	3526	12	0	150269	\N
29799	8224	12	1	150270	\N
29799	8243	13	0	150271	\N
29799	8245	13	1	150273	\N
29804	86	6	0	150337	\N
29804	8247	7	0	150338	\N
29806	908	6	0	150292	\N
29806	8249	7	0	150353	\N
29809	2	5	0	148937	\N
29809	6376	6	0	150365	\N
29813	649	4	0	150369	\N
29813	214	124	0	150375	\N
29813	4307	125	0	149539	\N
29813	8250	125	1	150376	\N
29813	8251	126	0	150377	\N
29813	7915	126	1	48170	\N
29813	5348	127	0	149559	\N
29815	1470	18	0	148631	\N
29815	8253	19	0	150420	\N
29818	38	10	0	146188	\N
29818	4017	11	0	150444	\N
29818	6319	11	1	150445	\N
29818	8255	12	0	150446	\N
29818	8256	12	1	150447	\N
29818	8257	13	0	150448	\N
29818	8236	13	1	150449	\N
29818	8258	14	0	150450	\N
29818	8201	14	1	150451	\N
29818	8212	15	0	150452	\N
29818	8224	15	1	150453	\N
29818	8225	16	0	150454	\N
29818	8259	16	1	150455	\N
29822	4172	9	0	150519	\N
29822	5365	10	0	150520	\N
29829	224	6	0	150571	\N
29829	8266	7	0	150572	\N
29831	852	4	0	149286	\N
29831	4162	5	0	150574	\N
29833	90	6	0	150601	\N
29833	6622	7	0	150602	\N
29839	7412	23	0	149919	\N
29839	8273	24	0	150676	\N
29841	86	9	0	150735	\N
29841	8274	10	0	150736	\N
29847	8276	9	0	150805	\N
29847	40	43	0	150851	\N
29847	2435	44	0	150852	\N
29847	6025	44	1	150853	\N
29847	8195	45	0	150854	\N
29847	8277	45	1	150855	\N
29847	8213	46	0	150856	\N
29847	8197	46	1	150857	\N
29847	8278	47	0	150858	\N
29847	8279	47	1	150859	\N
29847	8243	48	0	150860	\N
29847	7281	48	1	150861	\N
29849	4172	9	0	150886	\N
29849	2435	10	0	150887	\N
29849	8283	10	1	150888	\N
29849	8226	11	0	150889	\N
29849	8284	11	1	150890	\N
29851	228	14	0	148337	\N
29851	8286	15	0	150919	\N
29853	402	19	0	146761	\N
29853	8287	20	0	150958	\N
29855	4172	10	0	150989	\N
29855	8289	11	0	150990	\N
29858	86	9	0	151008	\N
29858	8248	10	0	151009	\N
29861	322	10	0	151058	\N
29861	8298	11	0	151054	\N
29861	2171	11	1	151055	\N
29861	8300	12	0	151059	\N
29861	8198	12	1	151056	\N
29861	8299	13	0	151057	\N
29864	260	9	0	151102	\N
29864	8302	10	0	151103	\N
29866	3625	10	0	151121	\N
29866	8304	11	0	151122	\N
29871	108	20	0	147498	\N
29871	8307	21	0	151151	\N
29875	528	6	0	151162	\N
29875	7486	7	0	151170	\N
29877	336	19	0	149497	\N
29877	8315	20	0	151220	\N
29879	4247	2	0	151226	\N
29879	4178	11	0	151237	\N
29879	8292	12	0	151238	\N
29879	8317	12	1	151239	\N
29879	8318	13	0	151240	\N
29879	8293	13	1	151241	\N
29879	8319	14	0	151242	\N
29879	8029	14	1	151243	\N
29879	8320	15	0	151244	\N
29879	8284	15	1	151245	\N
29879	8225	16	0	151246	\N
29879	8272	16	1	151247	\N
29882	62	20	0	151312	\N
29882	8322	21	0	151313	\N
29888	4178	10	0	151332	\N
29888	6660	11	0	151351	\N
29890	27	6	0	149012	\N
29890	3302	7	0	149013	\N
29893	3625	10	0	151121	\N
29893	8327	11	0	151386	\N
29899	108	10	0	147498	\N
29899	8332	11	0	151406	\N
29903	665	11	0	151430	\N
29903	58	12	0	151431	\N
29910	402	9	0	151481	\N
29910	8339	10	0	151498	\N
29913	18	10	0	149467	\N
29913	8342	11	0	151517	\N
29916	90	10	0	151530	\N
29916	8345	11	0	151535	\N
29918	149	4	0	147068	\N
29918	4040	5	0	151559	\N
29925	14	5	0	151617	\N
29925	5648	6	0	151618	\N
29932	14	15	0	151721	\N
29932	4307	16	0	151722	\N
29932	8317	16	1	151723	\N
29932	8256	17	0	151724	\N
29932	8236	17	1	151725	\N
29932	8359	18	0	151726	\N
29932	8197	18	1	151727	\N
29932	8360	19	0	151728	\N
29932	8239	19	1	151729	\N
29932	8225	20	0	151730	\N
29932	8259	20	1	151731	\N
29934	3625	10	0	151121	\N
29934	8304	11	0	151122	\N
29936	119	10	0	140709	\N
29936	8305	11	0	151123	\N
29941	230	0	0	151777	\N
29943	230	0	0	151777	\N
29950	86	19	0	151860	\N
29950	8374	20	0	151861	\N
29963	12	5	0	145613	\N
29963	8390	6	0	151960	\N
29967	73	13	0	152009	\N
29967	2827	14	0	152010	\N
29969	336	9	0	152026	\N
29897	8330	11	0	151390	\N
29911	132	10	0	151514	\N
29911	8340	11	0	151515	\N
29920	8347	11	0	151569	\N
29920	149	78	0	151585	\N
29920	4017	79	0	151447	\N
29920	8310	79	1	151586	\N
29920	8256	80	0	151587	\N
29920	8348	80	1	151588	\N
29920	8349	81	0	151589	\N
29920	8350	81	1	151590	\N
29920	8351	82	0	151591	\N
29920	8239	82	1	151454	\N
29920	8352	83	0	151592	\N
29920	8272	83	1	151593	\N
29922	4172	8	0	150989	\N
29922	7540	9	0	151606	\N
29926	228	19	0	151637	\N
29926	8354	20	0	151638	\N
29928	170	19	0	151640	\N
29928	6625	20	0	151641	\N
29930	8356	91	0	151684	\N
29930	186	96	0	151688	\N
29930	4017	97	0	151447	\N
29930	6335	97	1	151689	\N
29930	8298	98	0	151690	\N
29930	8196	98	1	151691	\N
29930	8319	99	0	151692	\N
29930	5889	99	1	151693	\N
29930	8357	100	0	151694	\N
29930	8224	100	1	151695	\N
29930	8358	101	0	151696	\N
29930	6374	101	1	151697	\N
29933	18	15	0	151732	\N
29933	4307	16	0	151722	\N
29933	8317	16	1	151723	\N
29933	8361	17	0	151733	\N
29933	8256	17	1	151724	\N
29933	8236	18	0	151725	\N
29933	8359	18	1	151726	\N
29933	8197	19	0	151727	\N
29933	8239	19	1	151729	\N
29933	8225	20	0	151730	\N
29933	8259	20	1	151731	\N
29945	316	8	0	151792	\N
29945	8370	9	0	151793	\N
29947	360	10	0	151808	\N
29947	8372	11	0	151811	\N
29949	18	9	0	151732	\N
29949	7719	10	0	151828	\N
29951	96	9	0	151877	\N
29951	8375	10	0	151878	\N
29953	230	0	0	151879	\N
29955	56	10	0	151895	\N
29955	8377	11	0	151896	\N
29957	1685	2	0	151918	\N
29957	18	11	0	151919	\N
29957	8310	12	0	151910	\N
29957	8384	12	1	151920	\N
29957	8378	13	0	151911	\N
29957	8220	13	1	151913	\N
29957	8380	14	0	151756	\N
29957	8381	14	1	151914	\N
29957	8382	15	0	151915	\N
29957	8383	15	1	151916	\N
29957	8366	16	0	151917	\N
29959	4015	7	0	151932	\N
29959	8387	7	0	151938	\N
29959	8388	8	0	151939	\N
29959	8349	8	1	151934	\N
29959	8213	9	0	151935	\N
29962	40	5	0	151958	\N
29962	3999	6	0	151959	\N
29966	40	19	0	151991	\N
29966	8391	20	0	151992	\N
29968	2578	13	0	152011	\N
29968	7054	14	0	152012	\N
29970	23	9	0	152028	\N
29970	8393	10	0	152029	\N
29987	528	19	0	151162	\N
29987	5604	20	0	152254	\N
29989	528	19	0	151162	\N
29989	5604	20	0	152254	\N
29991	94	14	0	149434	\N
29991	4547	15	0	152270	\N
29993	20	7	0	148746	\N
29993	8412	8	0	152293	\N
29996	33	6	0	148779	\N
29996	5983	7	0	152309	\N
29998	6727	7	0	152320	\N
29998	6044	20	0	152334	\N
29998	8292	21	0	152335	\N
29998	6335	21	1	152336	\N
29998	8298	22	0	152337	\N
29998	8349	22	1	152338	\N
29998	8271	23	0	152339	\N
29998	8201	23	1	152340	\N
29998	8224	24	0	152341	\N
29998	8415	24	1	152342	\N
29998	8416	25	0	152343	\N
29998	8366	25	1	152344	\N
30000	149	10	0	147068	\N
30000	6025	11	0	152362	\N
30000	8418	11	1	152363	\N
30000	8380	12	0	152364	\N
30002	18	9	0	152402	\N
30002	7719	10	0	152403	\N
30004	316	8	0	151792	\N
30004	8370	9	0	151793	\N
30007	2	10	0	152469	\N
30007	8152	11	0	152470	\N
30013	224	9	0	150571	\N
30013	8147	10	0	152566	\N
30031	4172	19	0	152682	\N
30031	4663	20	0	152683	\N
30034	86	11	0	152736	\N
30034	8439	12	0	152737	\N
30034	8195	12	1	152738	\N
30034	8213	13	0	152739	\N
30034	8198	13	1	152740	\N
30036	132	2	0	152743	\N
30036	2927	3	0	152744	\N
30038	285	10	0	152764	\N
30038	8442	11	0	152765	\N
30042	14	21	0	152487	\N
30042	8059	22	0	152830	\N
30045	14	20	0	152487	\N
30045	8448	21	0	152861	\N
29938	3628	55	0	151752	\N
29938	2435	56	0	151753	\N
29938	8310	56	1	151754	\N
29938	8298	57	0	151755	\N
29938	8236	57	1	151725	\N
29938	8319	58	0	151756	\N
29938	8242	58	1	151757	\N
29938	8198	59	0	151758	\N
29938	8225	59	1	151730	\N
29938	8365	60	0	151759	\N
29938	8366	60	1	151760	\N
29940	230	6	0	151777	\N
29940	8368	7	0	151778	\N
29942	230	0	0	151777	\N
29944	200	7	0	151788	\N
29944	8369	8	0	151789	\N
29946	360	11	0	151808	\N
29946	8371	12	0	151809	\N
29948	4341	11	0	58726	\N
29948	8373	12	0	151812	\N
29956	277	2	0	151900	\N
29956	64	11	0	151909	\N
29956	8310	12	0	151910	\N
29956	8378	12	1	151911	\N
29956	8379	13	0	151912	\N
29956	8220	13	1	151913	\N
29956	8380	14	0	151756	\N
29956	8381	14	1	151914	\N
29956	8382	15	0	151915	\N
29956	8383	15	1	151916	\N
29956	8366	16	0	151917	\N
29958	4015	6	0	151932	\N
29958	8385	6	0	151933	\N
29958	8349	7	0	151934	\N
29958	8213	7	1	151935	\N
29958	8386	8	0	151936	\N
29960	79	4	0	151946	\N
29960	3678	5	0	151947	\N
29971	2	9	0	151152	\N
29971	8394	10	0	152030	\N
29973	23	5	0	152028	\N
29973	6746	6	0	152032	\N
29975	164	18	0	152063	\N
29975	8396	19	0	152064	\N
29978	4178	20	0	151477	\N
29978	7664	21	0	152099	\N
29979	8398	3	0	152106	\N
29979	2578	20	0	152127	\N
29979	2435	21	0	152128	\N
29979	8310	21	1	152129	\N
29979	8256	22	0	152130	\N
29979	8399	22	1	152131	\N
29979	8349	23	0	152132	\N
29979	8400	23	1	152133	\N
29979	8401	24	0	152134	\N
29979	8239	24	1	152135	\N
29979	8402	25	0	152136	\N
29979	5348	25	1	152137	\N
29981	38	9	0	152158	\N
29981	8404	10	0	152159	\N
29981	3843	10	1	152155	\N
29997	33	8	0	148779	\N
29997	8414	9	0	152310	\N
30005	8424	20	0	152451	\N
30005	8425	21	0	152452	\N
30011	8428	29	0	152533	\N
30011	7412	30	0	152534	\N
30014	4178	9	0	152577	\N
30014	7720	10	0	152578	\N
30016	230	30	0	152614	\N
30016	8432	31	0	152615	\N
30018	595	0	0	142814	\N
30020	62	30	0	152618	\N
30020	8435	31	0	152619	\N
30024	262	8	0	152630	\N
30024	8436	9	0	152631	\N
30026	262	2	0	152630	\N
30026	2743	3	0	152634	\N
30028	411	6	0	152642	\N
30028	8437	7	0	152643	\N
30030	4172	13	0	152061	\N
30030	4252	14	0	152660	\N
30033	2796	4	0	152692	\N
30033	40	19	0	152712	\N
30033	2435	20	0	152713	\N
30033	6025	20	1	152714	\N
30033	8195	21	0	152715	\N
30033	8220	21	1	152716	\N
30033	8438	22	0	152717	\N
30033	8380	22	1	152718	\N
30033	8251	23	0	152719	\N
30033	8224	23	1	152720	\N
30033	8402	24	0	152721	\N
30035	132	11	0	152741	\N
30035	8195	12	0	152738	\N
30035	8213	12	1	152739	\N
30035	8440	13	0	152742	\N
30035	8198	13	1	152740	\N
30041	7412	22	0	152800	\N
30041	8445	23	0	152801	\N
30047	316	20	0	152863	\N
30047	8449	21	0	152864	\N
29969	8392	10	0	152027	\N
29976	164	9	0	152063	\N
29976	5968	10	0	152066	\N
29980	4178	10	0	152153	\N
29980	8403	11	0	152154	\N
29980	3843	11	1	152155	\N
29982	38	10	0	152158	\N
29982	8405	11	0	152160	\N
29982	3843	11	1	152155	\N
29984	285	19	0	152184	\N
29984	5921	20	0	152185	\N
29986	8406	46	0	152198	\N
29986	424	122	0	152220	\N
29986	2435	123	0	151932	\N
29986	7714	123	1	152221	\N
29986	8318	124	0	152222	\N
29986	8319	124	1	152133	\N
29986	8407	125	0	152223	\N
29986	8408	125	1	152224	\N
29986	8239	126	0	152225	\N
29986	8409	126	1	152226	\N
29986	8410	127	0	152227	\N
29990	908	14	0	152268	\N
29990	5076	15	0	152269	\N
29995	431	8	0	152307	\N
29995	8413	9	0	152308	\N
29999	4791	7	0	152345	\N
29999	56	20	0	152346	\N
29999	8292	21	0	152335	\N
29999	6335	21	1	152336	\N
29999	8298	22	0	152337	\N
29999	8349	22	1	152338	\N
29999	8271	23	0	152339	\N
29999	8201	23	1	152340	\N
29999	8417	24	0	152347	\N
29999	8224	24	1	152341	\N
29999	8415	25	0	152342	\N
29999	8366	25	1	152344	\N
30009	14	9	0	152487	\N
30009	8262	10	0	152488	\N
30015	595	0	0	142814	\N
30017	6450	30	0	145225	\N
30017	8433	31	0	152616	\N
30019	597	30	0	147986	\N
30019	8434	31	0	152617	\N
30021	595	0	0	142814	\N
30023	595	0	0	142814	\N
30039	117	22	0	152796	\N
30039	8443	23	0	152797	\N
30043	181	21	0	149181	\N
30043	8446	22	0	152831	\N
30044	88	21	0	141447	\N
30044	8447	22	0	152832	\N
30048	908	10	0	152877	\N
30048	8450	11	0	152878	\N
30012	4178	9	0	152153	\N
30012	4307	10	0	122883	\N
30012	8317	10	1	152547	\N
30012	8269	11	0	152548	\N
30012	8293	11	1	152549	\N
30012	8380	12	0	152550	\N
30012	8429	12	1	152551	\N
30012	8430	13	0	152552	\N
30012	8224	13	1	152553	\N
30012	8431	14	0	152554	\N
30012	3388	14	1	152555	\N
30025	262	7	0	152630	\N
30025	8127	8	0	152632	\N
30027	44	4	0	148365	\N
30027	3486	5	0	152635	\N
30029	411	5	0	152642	\N
30029	2874	6	0	152644	\N
30032	200	19	0	152684	\N
30032	5930	20	0	152685	\N
30037	40	10	0	152762	\N
30037	8441	11	0	152763	\N
30040	285	22	0	152798	\N
30040	8444	23	0	152799	\N
30046	40	20	0	152762	\N
30046	8426	21	0	152862	\N
30049	1858	10	0	152879	\N
30049	8451	11	0	152880	\N
30050	113	0	0	152881	\N
30051	4178	17	0	152901	\N
30051	4307	18	0	152902	\N
30051	7714	18	1	152903	\N
30051	8298	19	0	152904	\N
30051	8236	19	1	152905	\N
30051	8380	20	0	152906	\N
30051	8351	20	1	152907	\N
30051	8452	21	0	152908	\N
30051	8453	21	1	152909	\N
30052	198	17	0	152910	\N
30052	4307	18	0	152902	\N
30052	7714	18	1	152903	\N
30052	8298	19	0	152904	\N
30052	8454	19	1	152911	\N
30052	8236	20	0	152905	\N
30052	8380	20	1	152906	\N
30052	8351	21	0	152907	\N
30052	8453	21	1	152909	\N
30053	288	10	0	152925	\N
30053	8308	11	0	152926	\N
30054	18	10	0	152927	\N
30054	8342	11	0	152928	\N
30055	4	20	0	152959	\N
30055	8455	21	0	152960	\N
30056	198	20	0	152961	\N
30056	8456	21	0	152962	\N
30057	79	20	0	152963	\N
30057	6891	21	0	152964	\N
30058	4172	19	0	152995	\N
30058	4663	20	0	152996	\N
30059	69	19	0	152997	\N
30059	3672	20	0	152998	\N
30060	4178	8	0	152901	\N
30060	6776	9	0	153011	\N
30061	151	9	0	146472	\N
30061	8457	10	0	153028	\N
30062	151	32	0	146472	\N
30062	8458	33	0	153064	\N
30063	7733	6	0	153075	\N
30063	4233	9	0	153079	\N
30063	4017	10	0	153080	\N
30063	8459	10	1	153081	\N
30063	6025	11	0	153082	\N
30063	8349	11	1	153083	\N
30063	8460	12	0	153084	\N
30063	8382	12	1	153085	\N
30063	3843	13	0	153086	\N
30064	7733	6	0	153075	\N
30064	4233	9	0	153079	\N
30064	4017	10	0	153080	\N
30064	8459	10	1	153081	\N
30064	6025	11	0	153082	\N
30064	8349	11	1	153083	\N
30064	8460	12	0	153084	\N
30064	8382	12	1	153085	\N
30064	3843	13	0	153086	\N
30065	4015	9	0	153101	\N
30065	8461	9	0	153102	\N
30065	8195	10	0	153103	\N
30065	8462	10	1	153104	\N
30065	5889	11	0	153105	\N
30065	8198	11	1	153106	\N
30065	3843	12	0	153107	\N
30066	4172	11	0	153124	\N
30066	5069	12	0	153125	\N
30067	4172	8	0	153137	\N
30067	7540	9	0	153138	\N
30068	235	6	0	153147	\N
30068	8463	7	0	153148	\N
30069	4172	11	0	153158	\N
30069	5069	12	0	153159	\N
30070	140	11	0	153160	\N
30070	487	12	0	153161	\N
30071	235	11	0	153147	\N
30071	1061	12	0	153162	\N
30072	7412	8	0	152800	\N
30072	8464	9	0	153174	\N
30073	230	11	0	152614	\N
30073	8465	12	0	153194	\N
30074	4178	19	0	153222	\N
30074	4665	20	0	153223	\N
30075	233	19	0	145431	\N
30075	6101	20	0	153224	\N
30076	4088	5	0	153227	\N
30076	4436	6	0	153228	\N
30077	62	9	0	153240	\N
30077	8466	10	0	153241	\N
30078	198	10	0	153256	\N
30078	8467	11	0	153257	\N
30079	198	11	0	153256	\N
30079	746	12	0	153259	\N
30080	4275	3	0	153264	\N
30080	4172	10	0	153275	\N
30080	4307	11	0	153276	\N
30080	8310	11	1	153277	\N
30080	8195	12	0	153278	\N
30080	8468	12	1	153279	\N
30080	8359	13	0	153280	\N
30080	8407	13	1	153281	\N
30080	8284	14	0	153282	\N
30080	7951	14	1	153283	\N
30080	3009	15	0	153284	\N
30081	4272	3	0	153285	\N
30081	14	10	0	153286	\N
30081	4307	11	0	153276	\N
30081	8310	11	1	153277	\N
30081	8195	12	0	153278	\N
30081	8359	12	1	153280	\N
30081	8407	13	0	153281	\N
30081	8469	13	1	153287	\N
30081	8284	14	0	153282	\N
30081	7951	14	1	153283	\N
30081	3009	15	0	153284	\N
30082	4272	3	0	153285	\N
30082	14	10	0	153286	\N
30082	4307	11	0	153276	\N
30082	8310	11	1	153277	\N
30082	8195	12	0	153278	\N
30082	8359	12	1	153280	\N
30082	8407	13	0	153281	\N
30082	8469	13	1	153287	\N
30082	8284	14	0	153282	\N
30082	7951	14	1	153283	\N
30082	3009	15	0	153284	\N
30083	372	3	0	153288	\N
30083	40	10	0	153289	\N
30083	4307	11	0	153276	\N
30083	8310	11	1	153277	\N
30083	8195	12	0	153278	\N
30083	8470	12	1	153290	\N
30083	8359	13	0	153280	\N
30083	8407	13	1	153281	\N
30083	8284	14	0	153282	\N
30083	7951	14	1	153283	\N
30083	3009	15	0	153284	\N
30087	186	9	0	153377	\N
30087	8427	10	0	153378	\N
30091	6	9	0	141565	\N
30091	7553	10	0	153384	\N
30094	40	9	0	152762	\N
30094	8185	10	0	153401	\N
30098	4172	26	0	153417	\N
30098	4347	27	0	153455	\N
30101	137	2	0	151315	\N
30101	2721	3	0	153494	\N
30115	8489	11	0	153603	\N
30115	38	53	0	153606	\N
30115	8493	54	0	153615	\N
30117	62	11	0	153623	\N
30117	683	12	0	153633	\N
30122	6723	23	0	146943	\N
30122	8497	24	0	153669	\N
30124	7811	20	0	153737	\N
30124	244	21	0	153738	\N
30126	69	19	0	152997	\N
30126	4307	20	0	153768	\N
30126	1355	20	1	153769	\N
30126	8298	21	0	153770	\N
30126	8196	21	1	151691	\N
30126	8500	22	0	153772	\N
30126	8242	22	1	153773	\N
30126	8501	23	0	153776	\N
30126	8284	23	1	153774	\N
30126	7951	24	0	153775	\N
30128	4	6	0	152959	\N
30128	8502	7	0	153798	\N
30135	6303	10	0	150367	\N
30135	8503	11	0	153841	\N
30137	262	14	0	153857	\N
30137	4539	15	0	153858	\N
30166	8524	30	0	154128	\N
30166	140	40	0	154129	\N
30166	6025	41	0	154117	\N
30166	8298	41	1	154125	\N
30166	8525	42	0	154130	\N
30166	8500	42	1	154119	\N
30166	8521	43	0	154120	\N
30166	8226	43	1	154126	\N
30166	6753	44	0	154122	\N
30166	8198	44	1	154124	\N
30168	125	8	0	154151	\N
30168	8292	9	0	154143	\N
30168	6335	9	1	154144	\N
30168	8528	10	0	154152	\N
30168	8521	10	1	154145	\N
30168	8242	11	0	154146	\N
30168	8284	11	1	154148	\N
30168	8527	12	0	154149	\N
30170	6450	8	0	145225	\N
30170	8530	9	0	154166	\N
30172	597	8	0	147986	\N
30172	8532	9	0	154168	\N
30174	64	9	0	154184	\N
30174	8534	10	0	154185	\N
30184	224	8	0	154269	\N
30184	8542	9	0	154275	\N
30186	4172	7	0	154292	\N
30186	6628	8	0	154293	\N
30193	6044	24	0	154402	\N
30193	8552	25	0	154403	\N
30195	75	24	0	148262	\N
30195	8554	25	0	154405	\N
30199	14	20	0	154453	\N
30199	8556	21	0	154454	\N
30201	242	0	0	154456	\N
30213	8570	19	0	154606	\N
30213	285	34	0	154607	\N
30213	2435	35	0	154596	\N
30213	7714	35	1	154597	\N
30213	8195	36	0	154598	\N
30213	8568	36	1	154599	\N
30213	8500	37	0	154600	\N
30213	8226	37	1	154601	\N
30213	7846	38	0	154603	\N
30213	8572	38	1	154609	\N
30213	8224	39	0	154604	\N
30213	3843	39	1	154605	\N
30214	8570	19	0	154606	\N
30214	285	34	0	154607	\N
30214	2435	35	0	154596	\N
30214	7714	35	1	154597	\N
30214	8195	36	0	154598	\N
30214	8568	36	1	154599	\N
30214	8500	37	0	154600	\N
30214	8226	37	1	154601	\N
30214	7846	38	0	154603	\N
30214	8572	38	1	154609	\N
30214	8224	39	0	154604	\N
30214	3843	39	1	154605	\N
30216	6450	10	0	145225	\N
30216	2435	11	0	154628	\N
30216	7714	11	1	154629	\N
30216	4912	12	0	154630	\N
30216	8195	12	1	154631	\N
30216	8574	13	0	154635	\N
30216	5889	13	1	154633	\N
30216	7951	14	0	154634	\N
30219	35	10	0	148157	\N
30219	2435	11	0	154628	\N
30219	7714	11	1	154629	\N
30219	4912	12	0	154630	\N
30219	8195	12	1	154631	\N
30219	8577	13	0	154641	\N
30219	5889	13	1	154633	\N
30219	7951	14	0	154634	\N
30240	360	4	0	151808	\N
30240	8195	5	0	154936	\N
30240	8251	5	1	154937	\N
30240	8596	6	0	154942	\N
30240	7846	6	1	154939	\N
30240	8284	7	0	154940	\N
30240	3843	7	1	154941	\N
30242	7412	10	0	154518	\N
30242	8590	11	0	154886	\N
30244	40	1	0	154968	\N
30244	1244	2	0	154969	\N
30247	7412	19	0	155020	\N
30247	7568	20	0	155021	\N
30250	260	9	0	151102	\N
30250	8302	10	0	151103	\N
30254	8508	8	0	155075	\N
30254	173	10	0	155077	\N
30254	6025	11	0	155078	\N
30254	8195	11	1	155079	\N
30254	7296	12	0	155080	\N
30254	8601	12	1	155081	\N
30254	8198	13	0	155082	\N
30254	3843	13	1	155083	\N
30256	488	18	0	147650	\N
30256	4017	19	0	155112	\N
30256	8310	19	1	155113	\N
30256	8604	20	0	155121	\N
30256	8195	20	1	155114	\N
30256	7839	21	0	155115	\N
30256	8237	21	1	155116	\N
30256	8407	22	0	155117	\N
30256	8603	22	1	155119	\N
30256	8402	23	0	155120	\N
30261	391	49	0	155222	\N
30261	8609	50	0	155223	\N
30263	4787	1	0	155256	\N
30263	8611	2	0	155258	\N
30265	1109	9	0	155267	\N
30265	3580	10	0	155274	\N
30267	8614	115	0	155332	\N
30267	8349	115	1	153313	\N
30084	4272	3	0	153285	\N
30084	14	8	0	153286	\N
30084	4017	9	0	153292	\N
30084	8310	9	1	153277	\N
30084	8195	10	0	153278	\N
30084	8471	10	1	153293	\N
30084	8460	11	0	153294	\N
30084	8472	11	1	153295	\N
30084	8284	12	0	153282	\N
30084	7951	12	1	153283	\N
30084	4098	13	0	153296	\N
30085	206	9	0	153311	\N
30085	8473	10	0	153312	\N
30085	8349	10	1	153313	\N
30096	102	9	0	153419	\N
30096	4601	10	0	153420	\N
30106	8482	3	0	153506	\N
30106	8483	4	0	153507	\N
30108	8484	16	0	153520	\N
30108	8482	36	0	153527	\N
30108	8486	37	0	153551	\N
30111	7575	11	0	153600	\N
30111	142	53	0	153601	\N
30111	6737	54	0	153602	\N
30112	8489	11	0	153603	\N
30112	38	31	0	153606	\N
30112	4771	32	0	153607	\N
30118	62	10	0	153623	\N
30118	63	11	0	153634	\N
30120	198	23	0	153665	\N
30120	8495	24	0	153666	\N
30125	4172	19	0	153767	\N
30125	4307	20	0	153768	\N
30125	1355	20	1	153769	\N
30125	8298	21	0	153770	\N
30125	8196	21	1	151691	\N
30125	8499	22	0	153771	\N
30125	8500	22	1	153772	\N
30125	8242	23	0	153773	\N
30125	8284	23	1	153774	\N
30125	7951	24	0	153775	\N
30130	4	11	0	152959	\N
30130	579	12	0	153810	\N
30132	451	11	0	153813	\N
30132	452	12	0	153814	\N
30134	4178	15	0	153826	\N
30134	4250	16	0	153827	\N
30145	264	10	0	153901	\N
30145	8506	11	0	153902	\N
30147	173	8	0	153918	\N
30147	8508	9	0	153919	\N
30149	4172	10	0	153935	\N
30149	8289	11	0	153936	\N
30151	56	0	0	151895	\N
30156	360	10	0	151808	\N
30156	8372	11	0	151811	\N
30158	8515	8	0	154035	\N
30158	8516	9	0	154036	\N
30160	8517	0	0	154038	\N
30160	8518	0	0	154039	\N
30162	4172	11	0	154063	\N
30162	5069	12	0	154064	\N
30164	8519	30	0	154105	\N
30164	167	40	0	154115	\N
30164	6025	41	0	154117	\N
30164	8298	41	1	154125	\N
30164	8500	42	0	154119	\N
30164	8521	42	1	154120	\N
30164	8226	43	0	154126	\N
30164	6753	43	1	154122	\N
30164	8523	44	0	154127	\N
30164	8198	44	1	154124	\N
30169	73	9	0	154153	\N
30169	8292	10	0	154143	\N
30169	6335	10	1	154144	\N
30169	8529	11	0	154154	\N
30169	8521	11	1	154145	\N
30169	8242	12	0	154146	\N
30169	8284	12	1	154148	\N
30169	8527	13	0	154149	\N
30173	288	9	0	154182	\N
30173	8533	10	0	154183	\N
30175	18	10	0	154201	\N
30175	8342	11	0	154202	\N
30177	79	19	0	152963	\N
30177	4707	20	0	154237	\N
30179	7412	19	0	154239	\N
30179	7568	20	0	154240	\N
30181	1109	8	0	146847	\N
30181	8541	9	0	154254	\N
30188	8546	15	0	154320	\N
30188	6044	21	0	154329	\N
30188	8292	22	0	154330	\N
30188	6025	22	1	154331	\N
30188	4912	23	0	154332	\N
30188	8298	23	1	154333	\N
30188	8547	24	0	154334	\N
30188	8237	24	1	154335	\N
30188	8226	25	0	154336	\N
30188	8284	25	1	154337	\N
30188	8453	26	0	154338	\N
30188	8548	26	1	154339	\N
30191	4172	10	0	154359	\N
30191	6025	11	0	154360	\N
30191	8550	11	1	154361	\N
30191	8500	12	0	154362	\N
30191	8251	12	1	154363	\N
30191	7250	13	0	154364	\N
30191	3108	13	1	150011	\N
30191	8198	14	0	154365	\N
30194	6044	12	0	154402	\N
30194	8553	13	0	154404	\N
30196	40	5	0	153635	\N
30196	8555	6	0	154415	\N
30198	242	7	0	150922	\N
30198	4364	8	0	154425	\N
30203	4172	21	0	154359	\N
30203	5876	22	0	154493	\N
30205	82	12	0	143432	\N
30205	8560	13	0	154517	\N
30207	8562	35	0	154520	\N
30207	117	121	0	154537	\N
30207	8292	122	0	154538	\N
30207	6025	122	1	154117	\N
30207	8298	123	0	154125	\N
30207	8563	123	1	154539	\N
30207	8293	124	0	154540	\N
30207	8564	124	1	154541	\N
30207	8500	125	0	154119	\N
30207	8204	125	1	154542	\N
30207	7949	126	0	154543	\N
30207	8198	126	1	154124	\N
30207	8453	127	0	154544	\N
30215	595	10	0	142814	\N
30215	2435	11	0	154628	\N
30215	7714	11	1	154629	\N
30215	4912	12	0	154630	\N
30215	8195	12	1	154631	\N
30215	8573	13	0	154632	\N
30215	5889	13	1	154633	\N
30215	7951	14	0	154634	\N
30218	35	11	0	148157	\N
30218	2435	12	0	154628	\N
30218	7714	12	1	154629	\N
30218	4912	13	0	154630	\N
30218	8195	13	1	154631	\N
30218	8576	14	0	154640	\N
30218	5889	14	1	154633	\N
30218	7951	15	0	154634	\N
30221	4172	9	0	154659	\N
30221	5365	10	0	154660	\N
30224	228	9	0	151637	\N
30224	8587	10	0	154799	\N
30226	5885	11	0	142939	\N
30226	6674	12	0	154819	\N
30233	279	10	0	154884	\N
30233	8589	11	0	154885	\N
30086	4172	28	0	153360	\N
30086	6829	29	0	153361	\N
30088	151	9	0	153379	\N
30088	8474	10	0	153380	\N
30090	88	9	0	153382	\N
30090	8475	10	0	153383	\N
30092	202	9	0	148168	\N
30092	8476	10	0	153399	\N
30095	4172	9	0	153417	\N
30095	5365	10	0	153418	\N
30097	102	2	0	153419	\N
30097	3053	3	0	153421	\N
30099	8478	96	0	153461	\N
30099	273	123	0	153468	\N
30099	2435	124	0	153469	\N
30099	6025	124	1	153470	\N
30099	8298	125	0	153471	\N
30099	8479	125	1	153472	\N
30099	8471	126	0	153473	\N
30099	5889	126	1	153474	\N
30099	8239	127	0	153475	\N
30099	8453	127	1	153476	\N
30102	69	9	0	152997	\N
30102	8139	10	0	153495	\N
30104	135	9	0	144899	\N
30104	8481	10	0	153498	\N
30105	164	5	0	153492	\N
30105	4626	6	0	153499	\N
30107	8484	16	0	153520	\N
30107	8482	23	0	153527	\N
30107	8485	24	0	153528	\N
30110	8488	11	0	153597	\N
30110	2	53	0	153598	\N
30110	3914	54	0	153599	\N
30114	8490	11	0	153608	\N
30114	461	27	0	153612	\N
30114	8491	28	0	153613	\N
30114	8492	28	1	153614	\N
30119	40	11	0	153635	\N
30119	66	12	0	153636	\N
30127	4178	8	0	153222	\N
30127	6776	9	0	153788	\N
30129	4	9	0	152959	\N
30129	7548	10	0	153806	\N
30133	451	5	0	153813	\N
30133	6653	6	0	153815	\N
30139	285	12	0	153859	\N
30139	8504	13	0	153864	\N
30141	262	6	0	153857	\N
30141	4403	7	0	153868	\N
30143	411	4	0	153881	\N
30143	4858	5	0	153883	\N
30152	102	0	0	153938	\N
30154	326	49	0	145216	\N
30154	2435	50	0	154002	\N
30154	8251	50	1	154004	\N
30154	8512	51	0	154005	\N
30154	8513	51	1	154006	\N
30157	360	8	0	151808	\N
30157	8514	9	0	154025	\N
30161	173	8	0	153918	\N
30161	8508	9	0	153919	\N
30165	8524	30	0	154128	\N
30165	140	40	0	154129	\N
30165	6025	41	0	154117	\N
30165	8298	41	1	154125	\N
30165	8525	42	0	154130	\N
30165	8500	42	1	154119	\N
30165	8521	43	0	154120	\N
30165	8226	43	1	154126	\N
30165	6753	44	0	154122	\N
30165	8198	44	1	154124	\N
30180	77	8	0	154252	\N
30180	8540	9	0	154253	\N
30182	77	4	0	154252	\N
30182	3619	5	0	154255	\N
30187	6044	8	0	154304	\N
30187	6725	9	0	154305	\N
30200	242	20	0	150922	\N
30200	8557	21	0	154455	\N
30202	4	21	0	152959	\N
30202	8558	22	0	154492	\N
30204	4787	12	0	147954	\N
30204	8559	13	0	154516	\N
30206	7412	12	0	154518	\N
30206	8561	13	0	154519	\N
30208	4787	2	0	147954	\N
30208	8565	3	0	154545	\N
30210	5897	19	0	154570	\N
30210	4178	34	0	154595	\N
30210	2435	35	0	154596	\N
30210	7714	35	1	154597	\N
30210	8195	36	0	154598	\N
30210	8568	36	1	154599	\N
30210	8500	37	0	154600	\N
30210	8226	37	1	154601	\N
30210	8569	38	0	154602	\N
30210	7846	38	1	154603	\N
30210	8224	39	0	154604	\N
30210	3843	39	1	154605	\N
30212	40	0	0	148697	\N
30217	597	10	0	154638	\N
30217	2435	11	0	154628	\N
30217	7714	11	1	154629	\N
30217	4912	12	0	154630	\N
30217	8195	12	1	154631	\N
30217	8575	13	0	154639	\N
30217	5889	13	1	154633	\N
30217	7951	14	0	154634	\N
30220	528	10	0	154642	\N
30220	2435	11	0	154628	\N
30220	7714	11	1	154629	\N
30220	4912	12	0	154630	\N
30220	8195	12	1	154631	\N
30220	5889	13	0	154633	\N
30220	8578	13	1	154643	\N
30220	7951	14	0	154634	\N
30223	2435	50	0	151722	\N
30223	7493	50	1	152362	\N
30223	8298	51	0	151724	\N
30223	8580	51	1	154722	\N
30223	8581	52	0	154723	\N
30223	8220	52	1	151934	\N
30223	8251	53	0	154724	\N
30223	8582	53	1	154725	\N
30223	6476	54	0	154726	\N
30223	8239	54	1	152225	\N
30223	8225	55	0	154727	\N
30223	149	97	0	154769	\N
30223	2435	98	0	151932	\N
30223	8583	98	1	154770	\N
30223	7714	99	0	154771	\N
30223	6697	99	1	142235	\N
30223	6026	100	0	154772	\N
30223	8195	100	1	154773	\N
30223	8584	101	0	154774	\N
30223	7570	101	1	142950	\N
30223	8500	102	0	153772	\N
30223	2466	102	1	154775	\N
30223	2171	103	0	154776	\N
30223	8585	103	1	154777	\N
30223	1158	104	0	154778	\N
30223	7463	104	1	154779	\N
30223	7250	105	0	154364	\N
30223	636	105	1	154780	\N
30223	6476	106	0	154781	\N
30223	8586	106	1	154782	\N
30223	8284	107	0	154783	\N
30223	8299	107	1	154784	\N
30225	336	11	0	152026	\N
30225	3378	12	0	154818	\N
30230	391	27	0	154865	\N
30230	3553	28	0	154866	\N
30232	6303	10	0	154882	\N
30232	8503	11	0	154883	\N
30235	6303	6	0	154882	\N
30235	8591	7	0	154890	\N
30089	151	5	0	153379	\N
30089	7258	6	0	153381	\N
30093	202	8	0	148168	\N
30093	8477	9	0	153400	\N
30100	164	9	0	153492	\N
30100	8480	10	0	153493	\N
30103	69	8	0	152997	\N
30103	5298	9	0	153497	\N
30109	7815	11	0	153561	\N
30109	4172	53	0	153595	\N
30109	8487	54	0	153596	\N
30113	7575	11	0	153600	\N
30113	142	53	0	153601	\N
30113	6737	54	0	153602	\N
30116	62	7	0	153623	\N
30116	8494	8	0	153624	\N
30121	123	23	0	153667	\N
30121	8496	24	0	153668	\N
30123	202	28	0	148168	\N
30123	8498	29	0	153707	\N
30131	18	3	0	152927	\N
30131	3621	4	0	153812	\N
30136	6303	5	0	150367	\N
30136	6497	6	0	150368	\N
30138	285	14	0	153859	\N
30138	5103	15	0	153860	\N
30140	262	11	0	153857	\N
30140	731	12	0	153866	\N
30142	411	9	0	153881	\N
30142	8505	10	0	153882	\N
30144	4178	10	0	153899	\N
30144	6660	11	0	153900	\N
30146	167	8	0	153916	\N
30146	8507	9	0	153917	\N
30148	6331	8	0	153920	\N
30148	8509	9	0	153921	\N
30150	35	10	0	148157	\N
30150	8510	11	0	153937	\N
30153	151	49	0	153379	\N
30153	2435	50	0	154002	\N
30153	8511	50	1	154003	\N
30153	8251	51	0	154004	\N
30153	8512	51	1	154005	\N
30155	2	10	0	154023	\N
30155	5985	11	0	154024	\N
30159	75	6	0	148262	\N
30159	3303	7	0	154037	\N
30163	8519	30	0	154105	\N
30163	167	40	0	154115	\N
30163	8520	41	0	154116	\N
30163	6025	41	1	154117	\N
30163	8195	42	0	154118	\N
30163	8500	42	1	154119	\N
30163	8521	43	0	154120	\N
30163	8251	43	1	154121	\N
30163	6753	44	0	154122	\N
30163	8522	44	1	154123	\N
30163	8198	45	0	154124	\N
30167	431	9	0	154142	\N
30167	8292	10	0	154143	\N
30167	6335	10	1	154144	\N
30167	8521	11	0	154145	\N
30167	8242	11	1	154146	\N
30167	8526	12	0	154147	\N
30167	8284	12	1	154148	\N
30167	8527	13	0	154149	\N
30171	595	8	0	142814	\N
30171	8531	9	0	154167	\N
30176	6751	9	0	154204	\N
30176	8535	9	0	154205	\N
30176	8536	10	0	154206	\N
30176	8537	10	1	154207	\N
30176	8538	11	0	154208	\N
30178	79	10	0	152963	\N
30178	8539	11	0	154238	\N
30183	224	9	0	154269	\N
30183	8147	10	0	154270	\N
30185	8543	63	0	154280	\N
30185	42	75	0	154281	\N
30185	8544	76	0	154282	\N
30185	8536	76	1	154206	\N
30185	8545	77	0	130544	\N
30189	56	11	0	154341	\N
30189	8549	12	0	154342	\N
30190	8546	15	0	154320	\N
30190	6044	21	0	154329	\N
30190	8292	22	0	154330	\N
30190	6025	22	1	154331	\N
30190	4912	23	0	154332	\N
30190	8298	23	1	154333	\N
30190	8547	24	0	154334	\N
30190	8237	24	1	154335	\N
30190	8226	25	0	154336	\N
30190	8284	25	1	154337	\N
30190	8453	26	0	154338	\N
30190	8548	26	1	154339	\N
30192	7412	10	0	154366	\N
30192	6025	11	0	154360	\N
30192	8551	11	1	154367	\N
30192	8500	12	0	154362	\N
30192	8251	12	1	154363	\N
30192	7250	13	0	154364	\N
30192	3108	13	1	150011	\N
30192	8198	14	0	154365	\N
30197	242	9	0	150922	\N
30197	3425	10	0	154424	\N
30209	8567	0	0	154547	\N
30211	8570	19	0	154606	\N
30211	285	33	0	154607	\N
30211	2435	34	0	154596	\N
30211	7714	34	1	154597	\N
30211	8195	35	0	154598	\N
30211	8568	35	1	154599	\N
30211	8500	36	0	154600	\N
30211	8226	36	1	154601	\N
30211	7846	37	0	154603	\N
30211	8571	37	1	154608	\N
30211	8224	38	0	154604	\N
30211	3843	38	1	154605	\N
30222	149	8	0	154674	\N
30222	8579	9	0	154675	\N
30227	268	9	0	154820	\N
30227	8125	10	0	154821	\N
30228	4178	11	0	153899	\N
30228	4331	12	0	154822	\N
30229	268	11	0	154820	\N
30229	4344	12	0	154823	\N
30231	79	10	0	152963	\N
30231	8588	11	0	154881	\N
30234	7412	10	0	154518	\N
30234	8590	11	0	154886	\N
30236	7225	10	0	143118	\N
30236	8592	11	0	154891	\N
30238	8122	11	0	154903	\N
30238	391	24	0	154917	\N
30238	2435	25	0	154918	\N
30238	8594	25	1	154919	\N
30238	8298	26	0	154920	\N
30238	5650	26	1	154921	\N
30238	8521	27	0	154922	\N
30238	5889	27	1	154923	\N
30238	3268	28	0	154924	\N
30238	8198	28	1	154925	\N
30238	7951	29	0	154926	\N
30245	2	19	0	154993	\N
30245	5296	20	0	154994	\N
30249	7225	11	0	143118	\N
30249	8599	12	0	155040	\N
30253	67	10	0	155059	\N
30253	8600	11	0	155060	\N
30258	4787	41	0	155190	\N
30258	8606	42	0	155191	\N
30259	35	41	0	148157	\N
30259	8607	42	0	155192	\N
30264	1109	5	0	155267	\N
30264	6783	6	0	155268	\N
30237	79	5	0	152963	\N
30237	8593	6	0	154892	\N
30239	360	8	0	151808	\N
30239	8195	9	0	154936	\N
30239	8251	9	1	154937	\N
30239	8595	10	0	154938	\N
30239	7846	10	1	154939	\N
30239	8284	11	0	154940	\N
30239	3843	11	1	154941	\N
30243	4233	7	0	154964	\N
30243	8598	8	0	154965	\N
30246	260	19	0	151102	\N
30246	5270	20	0	155019	\N
30251	18	11	0	155042	\N
30251	218	12	0	155043	\N
30257	4178	18	0	155054	\N
30257	4017	19	0	155112	\N
30257	8310	19	1	155113	\N
30257	8195	20	0	155114	\N
30257	7839	20	1	155115	\N
30257	8237	21	0	155116	\N
30257	8407	21	1	155117	\N
30257	8605	22	0	155122	\N
30257	8603	22	1	155119	\N
30257	8402	23	0	155120	\N
30260	4787	2	0	155190	\N
30260	8608	3	0	155193	\N
30262	4787	20	0	155256	\N
30262	8610	21	0	155257	\N
30268	230	20	0	155367	\N
30268	2435	21	0	155368	\N
30268	8616	21	1	155369	\N
30268	8298	22	0	155370	\N
30268	2171	22	1	155371	\N
30268	7690	23	0	155372	\N
30268	1075	23	1	155373	\N
30270	4172	19	0	155394	\N
30270	8362	20	0	155395	\N
30274	69	39	0	152997	\N
30274	8621	40	0	155480	\N
30277	2	11	0	155544	\N
30277	2435	12	0	155545	\N
30277	6335	12	1	155546	\N
30277	4912	13	0	154772	\N
30277	8625	13	1	155547	\N
30277	8237	14	0	155548	\N
30277	8407	14	1	155549	\N
30277	7690	15	0	155550	\N
30277	7250	15	1	155551	\N
30277	3108	16	0	155552	\N
30277	8626	16	1	155553	\N
30277	8431	17	0	155554	\N
30279	5885	8	0	142939	\N
30279	7539	9	0	155569	\N
30284	40	2	0	155591	\N
30284	282	3	0	155592	\N
30286	279	6	0	154884	\N
30286	8629	7	0	155602	\N
30290	224	13	0	155613	\N
30290	8631	14	0	155632	\N
30292	322	13	0	151058	\N
30292	6722	14	0	155634	\N
30293	7412	13	0	155635	\N
30293	8633	14	0	155636	\N
30299	6450	10	0	145225	\N
30299	8637	11	0	155668	\N
30303	528	3	0	155683	\N
30303	4262	4	0	155685	\N
30305	88	7	0	153382	\N
30305	4949	8	0	155698	\N
30307	402	2	0	155704	\N
30307	2760	3	0	155705	\N
30312	79	1	0	155706	\N
30312	81	2	0	155712	\N
30314	18	5	0	155042	\N
30314	8641	6	0	155720	\N
30241	360	2	0	151808	\N
30241	8195	3	0	154936	\N
30241	8251	3	1	154937	\N
30241	8597	4	0	154943	\N
30241	7846	4	1	154939	\N
30241	8284	5	0	154940	\N
30241	3843	5	1	154941	\N
30248	279	11	0	154884	\N
30248	280	12	0	155039	\N
30252	4178	9	0	155054	\N
30252	7720	10	0	155055	\N
30255	322	18	0	151058	\N
30255	4017	19	0	155112	\N
30255	8310	19	1	155113	\N
30255	8195	20	0	155114	\N
30255	7839	20	1	155115	\N
30255	8237	21	0	155116	\N
30255	8407	21	1	155117	\N
30255	8602	22	0	155118	\N
30255	8603	22	1	155119	\N
30255	8402	23	0	155120	\N
30266	8612	14	0	155293	\N
30266	192	34	0	155323	\N
30266	4017	35	0	155324	\N
30266	6335	35	1	155325	\N
30266	8195	36	0	155326	\N
30266	8613	36	1	155327	\N
30266	8226	37	0	155328	\N
30266	7690	37	1	155329	\N
30266	7951	38	0	155330	\N
30266	1075	38	1	155331	\N
30269	230	11	0	155367	\N
30269	2435	12	0	155368	\N
30269	8617	12	1	155374	\N
30269	8298	13	0	155370	\N
30269	2171	13	1	155371	\N
30269	7690	14	0	155372	\N
30269	1075	14	1	155373	\N
30271	210	11	0	145894	\N
30271	8618	12	0	155413	\N
30275	44	4	0	148365	\N
30275	3486	5	0	152635	\N
30288	224	5	0	155613	\N
30288	4419	6	0	155614	\N
30295	411	7	0	155651	\N
30295	8634	8	0	155652	\N
30301	4172	10	0	155600	\N
30301	8639	11	0	155670	\N
30304	411	7	0	155651	\N
30304	6487	8	0	155697	\N
30306	411	8	0	155651	\N
30306	8640	9	0	155700	\N
30309	6044	2	0	154402	\N
30309	6188	3	0	155708	\N
30310	391	2	0	155709	\N
30310	1381	3	0	155710	\N
30315	167	5	0	153916	\N
30315	8507	6	0	153917	\N
30267	12	124	0	155333	\N
30267	6025	125	0	155334	\N
30267	8615	125	1	155335	\N
30267	8226	126	0	155336	\N
30267	8284	126	1	153774	\N
30267	3843	127	0	155337	\N
30272	94	11	0	149434	\N
30272	8619	12	0	155414	\N
30276	6229	24	0	155503	\N
30276	156	33	0	155516	\N
30276	7714	34	0	155517	\N
30276	8195	34	1	155518	\N
30276	8027	35	0	155519	\N
30276	8226	35	1	155520	\N
30276	8512	36	0	155521	\N
30276	6753	36	1	155522	\N
30276	8622	37	0	155523	\N
30276	8623	37	1	155524	\N
30276	8624	38	0	155525	\N
30276	1075	38	1	155526	\N
30278	23	8	0	152028	\N
30278	8627	9	0	155568	\N
30280	8628	11	0	155570	\N
30280	268	12	0	155571	\N
30282	4178	5	0	155582	\N
30282	4202	6	0	155583	\N
30289	4172	13	0	155600	\N
30289	5534	14	0	155631	\N
30291	235	13	0	153147	\N
30291	8632	14	0	155633	\N
30296	258	7	0	155653	\N
30296	8635	8	0	155654	\N
30302	528	7	0	155683	\N
30302	5937	8	0	155684	\N
30311	6044	1	0	154402	\N
30311	6993	2	0	155711	\N
30313	167	5	0	153916	\N
30313	8507	6	0	153917	\N
30316	75	2	0	155724	\N
30316	284	3	0	155725	\N
30318	2766	2	0	155740	\N
30318	73	4	0	155741	\N
30318	4017	5	0	155733	\N
30318	6335	5	1	155734	\N
30318	8644	6	0	155742	\N
30318	8251	6	1	155735	\N
30318	8643	7	0	155737	\N
30318	8431	7	1	155738	\N
30318	1075	8	0	155739	\N
30273	69	22	0	152997	\N
30273	8620	23	0	155450	\N
30281	268	8	0	154820	\N
30281	7542	9	0	155572	\N
30283	260	6	0	155585	\N
30283	7255	7	0	155586	\N
30285	4172	6	0	155600	\N
30285	5278	7	0	155601	\N
30287	7225	6	0	143118	\N
30287	8630	7	0	155603	\N
30294	2	7	0	155649	\N
30294	6780	8	0	155650	\N
30297	4178	5	0	155582	\N
30297	4202	6	0	155583	\N
30298	595	5	0	142814	\N
30298	8636	6	0	155661	\N
30300	597	10	0	154638	\N
30300	8638	11	0	155669	\N
30308	79	2	0	155706	\N
30308	616	3	0	155707	\N
30317	2795	2	0	142501	\N
30317	56	4	0	155732	\N
30317	4017	5	0	155733	\N
30317	6335	5	1	155734	\N
30317	8251	6	0	155735	\N
30317	8642	6	1	155736	\N
30317	8643	7	0	155737	\N
30317	8431	7	1	155738	\N
30317	1075	8	0	155739	\N
54	40	2	0	84	1000000000
92	113	2	0	292	1000000000
96	119	1	0	310	1000000000
182	40	1	0	84	1000000000
437	285	1	0	1033	1000000000
479	362	2	0	1537	1000000000
486	135	1	0	364	1000000000
540	362	1	0	1537	1000000000
586	285	1	0	1033	1000000000
694	113	1	0	292	1000000000
834	483	1	0	2599	1000000000
954	285	1	0	1033	1000000000
991	285	1	0	1033	1000000000
1236	135	1	0	364	1000000000
1409	595	1	0	4079	1000000000
1467	637	1	0	4661	1000000000
2056	756	1	0	6494	1000000000
5919	756	3	0	6494	1000000000
9064	756	3	0	6494	1000000000
10004	2351	2	0	33923	1000000000
11791	3004	2	0	42958	1000000000
11866	483	1	0	2599	1000000000
2	1	0	0	1	1000000000
254	242	0	0	826	1000000000
380	316	1	0	1232	1000000000
392	324	1	0	1277	1000000000
1065	121	1	0	312	1000000000
2246	793	0	0	6999	1000000000
2503	852	4	0	7707	1000000000
2594	880	1	0	8009	1000000000
2739	852	1	0	7707	1000000000
2941	852	1	0	7707	1000000000
4348	1225	3	0	13035	1000000000
6364	1545	1	0	18888	1000000000
8298	1914	2	0	26285	1000000000
8297	1914	1	0	26285	1000000000
10157	2426	2	0	35182	1000000000
11230	2426	5	0	35182	1000000000
11422	2815	4	0	41645	1000000000
11588	880	1	0	8009	1000000000
3	2	4	0	6	1000000000
9	14	1	0	24	1000000000
170	186	1	0	572	1000000000
637	416	1	0	2006	1000000000
778	279	1	0	1013	1000000000
1056	147	17	0	400	1000000000
1112	147	2	0	400	1000000000
1271	147	1	0	400	1000000000
1270	597	1	0	4081	1000000000
1410	597	1	0	4081	1000000000
1640	597	1	0	4081	1000000000
2157	597	2	0	4081	1000000000
6575	1587	2	0	19712	1000000000
6646	1602	2	0	20012	1000000000
8113	1602	1	0	20012	1000000000
8424	1952	0	0	26650	1000000000
10730	2594	1	0	38187	1000000000
10954	2647	5	0	39470	1000000000
12770	1587	2	0	19712	1000000000
146	51	1	0	124	1000000000
167	181	4	0	565	1000000000
243	51	1	0	124	1000000000
293	268	1	0	934	1000000000
692	435	1	0	2181	1000000000
728	451	2	0	2306	1000000000
804	435	2	0	2181	1000000000
1777	704	1	0	5768	1000000000
2479	841	1	0	7626	1000000000
3775	1130	1	0	11339	1000000000
13265	3628	7	0	49144	1000000000
13263	3625	7	0	49139	1000000000
6	8	1	0	18	1000000000
30	40	1	0	84	1000000000
100	125	3	0	326	1000000000
174	40	1	0	84	1000000000
187	135	2	0	364	1000000000
257	27	1	0	47	1000000000
458	135	1	0	364	1000000000
512	378	1	0	1644	1000000000
857	135	1	0	364	1000000000
1269	595	1	0	4079	1000000000
2586	878	0	0	7987	1000000000
2823	878	0	0	7987	1000000000
9715	2248	120	0	32332	1000000000
14411	4194	2	0	56560	1000000000
14387	4185	0	0	56443	1000000000
28	8	2	0	18	1000000000
114	135	1	0	364	1000000000
1927	285	3	0	1033	1000000000
13720	483	4	0	2599	1000000000
22074	6450	6	0	102136	1000000000
22136	6450	4	0	102136	1000000000
22809	6664	3	0	107584	1000000000
23374	6450	2	0	102136	1000000000
23476	6450	3	0	102136	1000000000
23867	6450	3	0	102136	1000000000
24088	6450	8	0	102136	1000000000
24331	6450	11	0	102136	1000000000
24351	6450	2	0	102136	1000000000
24663	7113	4	0	118568	1000000000
24906	6450	4	0	102136	1000000000
25540	483	2	0	2599	1000000000
10458	2522	5	0	36801	1000000000
10457	2522	6	0	36801	1000000000
13106	3516	0	0	48124	1000000000
22484	6568	9	0	105333	1000000000
30209	8566	0	0	154546	1000000000
2729	908	1	0	8377	1000000000
16170	4740	4	0	65983	1000000000
16299	4787	3	0	66752	1000000000
16499	4787	4	0	66752	1000000000
17955	5289	3	0	76243	1000000000
19108	5560	6	0	82272	1000000000
20124	5885	6	0	89735	1000000000
22142	2815	4	0	41645	1000000000
26047	7412	2	0	126821	1000000000
26071	7412	4	0	126821	1000000000
932	147	2	0	400	1000000000
15718	4605	10	0	63450	1000000000
15719	4605	10	0	63450	1000000000
16171	4742	4	0	65985	1000000000
18926	5531	1	0	81614	1000000000
19248	2249	3	0	83217	1000000000
21348	5531	12	0	81614	1000000000
23005	6723	3	0	108821	1000000000
23078	6723	4	0	108821	1000000000
23161	6723	2	0	108821	1000000000
27537	7745	7	0	137074	1000000000
29557	7745	3	0	137074	1000000000
82	102	1	0	250	1000000000
115	137	1	0	366	1000000000
1059	550	38	0	3374	1000000000
6785	1658	0	0	20811	1000000000
69	79	1	0	196	1000000000
13292	3628	6	0	49144	1000000000
14190	4088	4	0	54840	1000000000
14707	4088	2	0	54840	1000000000
14515	4088	6	0	54840	1000000000
14493	4233	4	0	57213	1000000000
14751	4088	2	0	54840	1000000000
14983	4233	1	0	57213	1000000000
14988	4233	3	0	57213	1000000000
20578	6044	3	0	93236	1000000000
20824	6044	3	0	93236	1000000000
20823	6044	1	0	93236	1000000000
23272	6765	6	0	109855	1000000000
23164	6765	4	0	109855	1000000000
23551	6765	7	0	109855	1000000000
23431	6765	2	0	109855	1000000000
23655	6765	3	0	109855	1000000000
24131	6765	8	0	109855	1000000000
\.


--
-- Data for Name: blocks_user_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks_user_commands (block_id, user_command_id, sequence_no, status, failure_reason, fee_payer_account_creation_fee_paid, receiver_account_creation_fee_paid, created_token, fee_payer_balance, source_balance, receiver_balance) FROM stdin;
3	1	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	2	2	\N
3	2	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	3	3	\N
3	3	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	4	4	\N
3	4	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	5	5	\N
4	5	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	8	8	\N
4	6	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	9	9	\N
5	7	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	12	12	\N
5	8	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13	13	\N
5	9	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	14	14	\N
6	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17	17	\N
7	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17	17	\N
8	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17	17	\N
9	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17	17	\N
10	11	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	26	26	\N
11	11	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	26	26	\N
12	12	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	31	31	\N
18	13	0	applied	\N	\N	1000000000	\N	37	37	38
18	14	1	applied	\N	\N	\N	\N	39	39	39
19	15	0	applied	\N	\N	\N	\N	42	42	42
20	15	0	applied	\N	\N	\N	\N	42	42	42
21	15	0	applied	\N	\N	\N	\N	42	42	42
22	16	0	applied	\N	\N	\N	\N	49	49	50
22	17	1	applied	\N	\N	\N	\N	51	51	51
23	16	0	applied	\N	\N	\N	\N	49	49	50
23	17	1	applied	\N	\N	\N	\N	51	51	51
24	18	0	applied	\N	\N	\N	\N	56	56	56
24	19	1	applied	\N	\N	\N	\N	57	57	58
24	20	2	applied	\N	\N	\N	\N	59	59	60
25	21	0	applied	\N	\N	\N	\N	63	63	64
25	22	1	applied	\N	\N	\N	\N	65	65	66
26	21	0	applied	\N	\N	\N	\N	63	63	64
26	22	1	applied	\N	\N	\N	\N	65	65	66
27	23	0	applied	\N	\N	\N	\N	71	71	72
28	24	0	applied	\N	\N	\N	\N	75	75	76
28	25	1	applied	\N	\N	\N	\N	77	77	78
29	24	0	applied	\N	\N	\N	\N	75	75	76
29	25	1	applied	\N	\N	\N	\N	77	77	78
30	26	0	applied	\N	\N	\N	\N	82	82	83
31	26	0	applied	\N	\N	\N	\N	82	82	83
32	27	0	applied	\N	\N	\N	\N	88	88	89
33	28	0	applied	\N	\N	\N	\N	92	92	93
34	28	0	applied	\N	\N	\N	\N	92	92	93
35	29	0	applied	\N	\N	\N	\N	98	98	99
36	30	0	applied	\N	\N	\N	\N	102	102	103
37	31	0	applied	\N	\N	\N	\N	104	104	105
37	32	1	applied	\N	\N	\N	\N	106	106	107
37	33	2	applied	\N	\N	\N	\N	108	108	109
38	34	0	applied	\N	\N	\N	\N	112	112	113
38	35	1	applied	\N	\N	\N	\N	114	114	115
38	36	2	applied	\N	\N	\N	\N	116	116	117
39	37	0	applied	\N	\N	\N	\N	120	120	121
40	37	0	applied	\N	\N	\N	\N	120	120	121
41	38	0	applied	\N	\N	\N	\N	126	126	127
42	38	0	applied	\N	\N	\N	\N	126	126	127
43	38	0	applied	\N	\N	\N	\N	126	126	127
44	39	0	applied	\N	\N	\N	\N	132	132	133
45	39	0	applied	\N	\N	\N	\N	132	132	133
46	39	0	applied	\N	\N	\N	\N	132	132	133
47	39	0	applied	\N	\N	\N	\N	132	132	133
48	40	0	applied	\N	\N	\N	\N	140	140	141
49	40	0	applied	\N	\N	\N	\N	140	140	141
50	40	0	applied	\N	\N	\N	\N	140	140	141
51	41	0	applied	\N	\N	\N	\N	148	148	149
52	42	0	applied	\N	\N	\N	\N	150	150	151
53	42	0	applied	\N	\N	\N	\N	150	150	151
54	43	0	applied	\N	\N	\N	\N	154	154	155
54	44	1	applied	\N	\N	\N	\N	156	156	157
55	43	0	applied	\N	\N	\N	\N	154	154	155
55	44	1	applied	\N	\N	\N	\N	156	156	157
56	45	0	applied	\N	\N	\N	\N	161	161	162
57	46	0	applied	\N	\N	\N	\N	165	165	166
58	46	0	applied	\N	\N	\N	\N	165	165	166
59	47	0	applied	\N	\N	\N	\N	171	171	172
60	48	0	applied	\N	\N	\N	\N	175	175	176
61	48	0	applied	\N	\N	\N	\N	175	175	176
62	48	0	applied	\N	\N	\N	\N	175	175	176
63	49	0	applied	\N	\N	\N	\N	183	183	184
64	49	0	applied	\N	\N	\N	\N	183	183	184
65	49	0	applied	\N	\N	\N	\N	183	183	184
66	50	0	applied	\N	\N	\N	\N	189	189	190
67	51	0	applied	\N	\N	\N	\N	191	191	192
67	52	1	applied	\N	\N	\N	\N	193	193	194
68	51	0	applied	\N	\N	\N	\N	191	191	192
68	52	1	applied	\N	\N	\N	\N	193	193	194
69	53	0	applied	\N	\N	\N	\N	198	198	199
70	54	0	applied	\N	\N	\N	\N	201	201	202
71	55	0	applied	\N	\N	\N	\N	204	204	205
72	55	0	applied	\N	\N	\N	\N	204	204	205
73	56	0	applied	\N	\N	\N	\N	210	210	211
74	57	0	applied	\N	\N	\N	\N	214	214	215
75	58	0	applied	\N	\N	\N	\N	218	218	219
76	59	0	applied	\N	\N	\N	\N	220	220	221
76	60	1	applied	\N	\N	\N	\N	222	222	223
77	61	0	applied	\N	\N	\N	\N	226	226	227
77	62	1	applied	\N	\N	\N	\N	228	228	229
78	61	0	applied	\N	\N	\N	\N	226	226	227
78	62	1	applied	\N	\N	\N	\N	228	228	229
79	63	0	applied	\N	\N	\N	\N	234	234	235
80	64	0	applied	\N	\N	\N	\N	238	238	239
81	65	0	applied	\N	\N	\N	\N	242	242	243
81	66	1	applied	\N	\N	\N	\N	244	244	245
82	67	0	applied	\N	\N	\N	\N	248	248	249
83	68	0	applied	\N	\N	\N	\N	252	252	253
84	69	0	applied	\N	\N	\N	\N	256	256	257
84	70	1	applied	\N	\N	\N	\N	258	258	259
84	71	2	applied	\N	\N	\N	\N	260	260	261
85	69	0	applied	\N	\N	\N	\N	256	256	257
85	70	1	applied	\N	\N	\N	\N	258	258	259
85	71	2	applied	\N	\N	\N	\N	260	260	261
86	72	0	applied	\N	\N	\N	\N	266	266	267
86	73	1	applied	\N	\N	\N	\N	268	268	269
87	74	0	applied	\N	\N	\N	\N	272	272	273
88	75	0	applied	\N	\N	\N	\N	275	275	276
89	76	0	applied	\N	\N	\N	\N	279	279	280
89	77	1	applied	\N	\N	\N	\N	281	281	282
90	78	0	applied	\N	\N	1000000000	\N	285	285	286
90	79	1	applied	\N	\N	\N	\N	287	287	288
92	78	0	applied	\N	\N	1000000000	\N	285	285	286
92	79	1	applied	\N	\N	\N	\N	287	287	288
93	80	0	applied	\N	\N	\N	\N	294	294	295
95	84	0	applied	\N	\N	\N	\N	306	306	307
96	84	0	applied	\N	\N	\N	\N	306	306	307
98	84	0	applied	\N	\N	\N	\N	306	306	307
99	85	0	applied	\N	\N	\N	\N	316	316	317
100	86	0	applied	\N	\N	\N	\N	320	320	321
100	87	1	applied	\N	\N	\N	\N	322	322	323
100	88	2	applied	\N	\N	\N	\N	324	324	325
101	86	0	applied	\N	\N	\N	\N	320	320	321
101	87	1	applied	\N	\N	\N	\N	322	322	323
101	88	2	applied	\N	\N	\N	\N	324	324	325
103	89	0	applied	\N	\N	\N	\N	330	330	331
103	90	1	applied	\N	\N	\N	\N	332	332	333
103	91	2	applied	\N	\N	\N	\N	334	334	335
104	89	0	applied	\N	\N	\N	\N	330	330	331
104	90	1	applied	\N	\N	\N	\N	332	332	333
104	91	2	applied	\N	\N	\N	\N	334	334	335
105	92	0	applied	\N	\N	\N	\N	340	340	341
106	93	0	applied	\N	\N	\N	\N	342	342	343
106	94	1	applied	\N	\N	\N	\N	344	344	345
108	95	0	applied	\N	\N	\N	\N	347	347	348
108	96	1	applied	\N	\N	\N	\N	349	349	350
109	95	0	applied	\N	\N	\N	\N	347	347	348
109	96	1	applied	\N	\N	\N	\N	349	349	350
111	97	0	applied	\N	\N	\N	\N	355	355	356
112	98	0	applied	\N	\N	\N	\N	358	358	359
114	98	0	applied	\N	\N	\N	\N	358	358	359
115	98	0	applied	\N	\N	\N	\N	358	358	359
116	99	0	applied	\N	\N	\N	\N	368	368	369
116	100	1	applied	\N	\N	\N	\N	370	370	371
116	101	2	applied	\N	\N	\N	\N	372	372	373
116	102	3	applied	\N	\N	\N	\N	374	374	375
117	103	0	applied	\N	\N	\N	\N	378	378	379
120	104	0	applied	\N	\N	\N	\N	383	383	384
121	105	0	applied	\N	\N	\N	\N	388	388	389
123	105	0	applied	\N	\N	\N	\N	388	388	389
91	78	0	applied	\N	\N	1000000000	\N	285	285	286
91	79	1	applied	\N	\N	\N	\N	287	287	288
94	81	0	applied	\N	\N	\N	\N	298	298	299
94	82	1	applied	\N	\N	\N	\N	300	300	301
94	83	2	applied	\N	\N	\N	\N	302	302	303
97	84	0	applied	\N	\N	\N	\N	306	306	307
102	89	0	applied	\N	\N	\N	\N	330	330	331
102	90	1	applied	\N	\N	\N	\N	332	332	333
102	91	2	applied	\N	\N	\N	\N	334	334	335
107	95	0	applied	\N	\N	\N	\N	347	347	348
107	96	1	applied	\N	\N	\N	\N	349	349	350
110	97	0	applied	\N	\N	\N	\N	355	355	356
113	98	0	applied	\N	\N	\N	\N	358	358	359
118	103	0	applied	\N	\N	\N	\N	378	378	379
119	104	0	applied	\N	\N	\N	\N	383	383	384
122	105	0	applied	\N	\N	\N	\N	388	388	389
124	106	0	applied	\N	\N	\N	\N	392	392	393
124	107	1	applied	\N	\N	\N	\N	394	394	395
124	108	2	applied	\N	\N	\N	\N	396	396	397
125	106	0	applied	\N	\N	\N	\N	392	392	393
125	107	1	applied	\N	\N	\N	\N	394	394	395
125	108	2	applied	\N	\N	\N	\N	396	396	397
126	106	0	applied	\N	\N	\N	\N	392	392	393
126	107	1	applied	\N	\N	\N	\N	394	394	395
126	108	2	applied	\N	\N	\N	\N	396	396	397
127	109	0	applied	\N	\N	\N	\N	404	404	405
127	110	1	applied	\N	\N	\N	\N	406	406	407
127	111	2	applied	\N	\N	\N	\N	408	408	409
128	112	0	applied	\N	\N	\N	\N	412	412	413
129	113	0	applied	\N	\N	\N	\N	416	416	417
129	114	1	applied	\N	\N	\N	\N	418	418	419
130	113	0	applied	\N	\N	\N	\N	416	416	417
130	114	1	applied	\N	\N	\N	\N	418	418	419
131	115	0	applied	\N	\N	\N	\N	423	423	424
131	116	1	applied	\N	\N	\N	\N	425	425	426
132	117	0	applied	\N	\N	\N	\N	429	429	430
133	118	0	applied	\N	\N	\N	\N	433	433	434
134	119	0	applied	\N	\N	\N	\N	437	437	438
134	120	1	applied	\N	\N	\N	\N	439	439	440
135	119	0	applied	\N	\N	\N	\N	437	437	438
135	120	1	applied	\N	\N	\N	\N	439	439	440
136	121	0	applied	\N	\N	\N	\N	444	444	445
137	121	0	applied	\N	\N	\N	\N	444	444	445
138	121	0	applied	\N	\N	\N	\N	444	444	445
139	122	0	applied	\N	\N	\N	\N	450	450	451
139	123	1	applied	\N	\N	\N	\N	452	452	453
140	122	0	applied	\N	\N	\N	\N	450	450	451
140	123	1	applied	\N	\N	\N	\N	452	452	453
141	124	0	applied	\N	\N	\N	\N	458	458	459
142	125	0	applied	\N	\N	\N	\N	460	460	461
143	125	0	applied	\N	\N	\N	\N	460	460	461
144	126	0	applied	\N	\N	\N	\N	464	464	465
145	127	0	applied	\N	\N	\N	\N	468	468	469
146	128	0	applied	\N	\N	\N	\N	472	472	473
147	128	0	applied	\N	\N	\N	\N	472	472	473
148	129	0	applied	\N	\N	\N	\N	474	474	475
149	130	0	applied	\N	\N	\N	\N	478	478	479
149	131	1	applied	\N	\N	\N	\N	480	480	481
150	130	0	applied	\N	\N	\N	\N	478	478	479
150	131	1	applied	\N	\N	\N	\N	480	480	481
151	130	0	applied	\N	\N	\N	\N	478	478	479
151	131	1	applied	\N	\N	\N	\N	480	480	481
152	132	0	applied	\N	\N	\N	\N	488	488	489
153	133	0	applied	\N	\N	\N	\N	490	490	491
154	133	0	applied	\N	\N	\N	\N	490	490	491
155	134	0	applied	\N	\N	\N	\N	496	496	497
156	135	0	applied	\N	\N	\N	\N	500	500	501
156	136	1	applied	\N	\N	\N	\N	502	502	503
157	137	0	applied	\N	\N	\N	\N	506	506	507
157	138	1	applied	\N	\N	\N	\N	508	508	509
157	139	2	applied	\N	\N	\N	\N	510	510	511
157	140	3	applied	\N	\N	\N	\N	512	512	513
158	137	0	applied	\N	\N	\N	\N	506	506	507
158	138	1	applied	\N	\N	\N	\N	508	508	509
158	139	2	applied	\N	\N	\N	\N	510	510	511
158	140	3	applied	\N	\N	\N	\N	512	512	513
159	141	0	applied	\N	\N	\N	\N	518	518	519
159	142	1	applied	\N	\N	\N	\N	520	520	521
159	143	2	applied	\N	\N	\N	\N	522	522	523
160	144	0	applied	\N	\N	\N	\N	526	526	527
160	145	1	applied	\N	\N	\N	\N	528	528	529
161	144	0	applied	\N	\N	\N	\N	526	526	527
161	145	1	applied	\N	\N	\N	\N	528	528	529
162	144	0	applied	\N	\N	\N	\N	526	526	527
162	145	1	applied	\N	\N	\N	\N	528	528	529
163	146	0	applied	\N	\N	\N	\N	535	535	536
163	147	1	applied	\N	\N	\N	\N	537	537	538
164	148	0	applied	\N	\N	\N	\N	541	541	542
165	149	0	applied	\N	\N	\N	\N	545	545	546
165	150	1	applied	\N	\N	\N	\N	547	547	548
165	151	2	applied	\N	\N	\N	\N	549	549	550
166	152	0	applied	\N	\N	\N	\N	553	553	554
167	153	0	applied	\N	\N	1000000000	\N	557	557	558
167	154	1	applied	\N	\N	\N	\N	559	559	560
167	155	2	applied	\N	\N	\N	\N	561	561	562
167	156	3	applied	\N	\N	\N	\N	563	563	564
168	153	0	applied	\N	\N	1000000000	\N	557	557	558
168	154	1	applied	\N	\N	\N	\N	559	559	560
168	155	2	applied	\N	\N	\N	\N	561	561	562
168	156	3	applied	\N	\N	\N	\N	563	563	564
169	153	0	applied	\N	\N	1000000000	\N	557	557	558
169	154	1	applied	\N	\N	\N	\N	559	559	560
169	155	2	applied	\N	\N	\N	\N	561	561	562
169	156	3	applied	\N	\N	\N	\N	563	563	564
170	157	0	applied	\N	\N	\N	\N	570	570	571
171	157	0	applied	\N	\N	\N	\N	570	570	571
172	158	0	applied	\N	\N	\N	\N	574	574	575
172	159	1	applied	\N	\N	\N	\N	576	576	577
173	158	0	applied	\N	\N	\N	\N	574	574	575
173	159	1	applied	\N	\N	\N	\N	576	576	577
174	160	0	applied	\N	\N	\N	\N	582	582	583
175	160	0	applied	\N	\N	\N	\N	582	582	583
176	160	0	applied	\N	\N	\N	\N	582	582	583
177	161	0	applied	\N	\N	\N	\N	588	588	589
178	161	0	applied	\N	\N	\N	\N	588	588	589
179	162	0	applied	\N	\N	\N	\N	592	592	593
180	163	0	applied	\N	\N	\N	\N	596	596	597
181	164	0	applied	\N	\N	\N	\N	600	600	601
182	164	0	applied	\N	\N	\N	\N	600	600	601
183	165	0	applied	\N	\N	\N	\N	604	604	605
186	168	0	applied	\N	\N	\N	\N	613	613	614
186	169	2	applied	\N	\N	\N	\N	616	616	617
186	170	3	applied	\N	\N	\N	\N	618	618	619
187	171	0	applied	\N	\N	\N	\N	624	624	625
187	172	1	applied	\N	\N	\N	\N	626	626	627
190	173	0	applied	\N	\N	\N	\N	630	630	631
193	174	0	applied	\N	\N	\N	\N	639	639	640
196	175	0	applied	\N	\N	\N	\N	647	647	648
197	176	0	applied	\N	\N	\N	\N	651	651	652
200	177	0	applied	\N	\N	\N	\N	659	659	660
203	180	0	applied	\N	\N	\N	\N	669	669	670
206	181	0	applied	\N	\N	\N	\N	675	675	676
212	185	0	applied	\N	\N	\N	\N	693	693	694
184	166	0	applied	\N	\N	\N	\N	608	608	609
184	167	1	applied	\N	\N	\N	\N	610	610	611
188	171	0	applied	\N	\N	\N	\N	624	624	625
188	172	1	applied	\N	\N	\N	\N	626	626	627
191	173	0	applied	\N	\N	\N	\N	630	630	631
195	174	0	applied	\N	\N	\N	\N	639	639	640
198	176	0	applied	\N	\N	\N	\N	651	651	652
201	177	0	applied	\N	\N	\N	\N	659	659	660
202	178	0	applied	\N	\N	\N	\N	663	663	664
202	179	1	applied	\N	\N	\N	\N	665	665	666
205	181	0	applied	\N	\N	\N	\N	675	675	676
209	182	0	applied	\N	\N	\N	\N	681	681	682
210	183	0	applied	\N	\N	\N	\N	685	685	686
210	184	1	applied	\N	\N	\N	\N	687	687	688
213	185	0	applied	\N	\N	\N	\N	693	693	694
185	168	0	applied	\N	\N	\N	\N	613	613	614
185	169	2	applied	\N	\N	\N	\N	616	616	617
185	170	3	applied	\N	\N	\N	\N	618	618	619
189	173	0	applied	\N	\N	\N	\N	630	630	631
194	174	0	applied	\N	\N	\N	\N	639	639	640
199	176	0	applied	\N	\N	\N	\N	651	651	652
204	180	0	applied	\N	\N	\N	\N	669	669	670
207	181	0	applied	\N	\N	\N	\N	675	675	676
208	182	0	applied	\N	\N	\N	\N	681	681	682
211	183	0	applied	\N	\N	\N	\N	685	685	686
211	184	1	applied	\N	\N	\N	\N	687	687	688
214	186	0	applied	\N	\N	\N	\N	699	699	700
215	187	0	applied	\N	\N	\N	\N	703	703	704
215	188	1	applied	\N	\N	\N	\N	705	705	706
216	189	0	applied	\N	\N	\N	\N	398	398	398
216	190	1	applied	\N	\N	\N	\N	709	709	710
216	191	2	applied	\N	\N	\N	\N	711	711	712
217	192	0	applied	\N	\N	\N	\N	714	714	715
218	193	0	applied	\N	\N	\N	\N	718	718	719
219	194	0	applied	\N	\N	\N	\N	722	722	723
220	194	0	applied	\N	\N	\N	\N	722	722	723
221	195	0	applied	\N	\N	\N	\N	728	728	729
222	195	0	applied	\N	\N	\N	\N	728	728	729
223	196	0	applied	\N	\N	\N	\N	734	734	735
224	196	0	applied	\N	\N	\N	\N	734	734	735
225	197	0	applied	\N	\N	\N	\N	737	737	738
226	198	0	applied	\N	\N	\N	\N	741	741	742
227	198	0	applied	\N	\N	\N	\N	741	741	742
228	199	0	applied	\N	\N	\N	\N	367	367	745
228	200	1	applied	\N	\N	\N	\N	746	746	747
229	199	0	applied	\N	\N	\N	\N	367	367	745
229	200	1	applied	\N	\N	\N	\N	746	746	747
230	201	0	applied	\N	\N	\N	\N	751	751	752
230	202	1	applied	\N	\N	1000000000	\N	753	753	754
231	203	0	applied	\N	\N	\N	\N	757	757	758
232	203	0	applied	\N	\N	\N	\N	757	757	758
233	204	0	applied	\N	\N	\N	\N	761	761	762
234	204	0	applied	\N	\N	\N	\N	761	761	762
235	205	0	applied	\N	\N	\N	\N	767	767	768
235	206	1	applied	\N	\N	\N	\N	769	769	770
236	207	0	applied	\N	\N	\N	\N	772	772	773
236	208	1	applied	\N	\N	\N	\N	774	774	775
237	209	0	applied	\N	\N	\N	\N	777	777	778
237	210	1	applied	\N	\N	\N	\N	779	779	780
238	209	0	applied	\N	\N	\N	\N	777	777	778
238	210	1	applied	\N	\N	\N	\N	779	779	780
239	209	0	applied	\N	\N	\N	\N	777	777	778
239	210	1	applied	\N	\N	\N	\N	779	779	780
240	211	0	applied	\N	\N	\N	\N	786	786	787
241	211	0	applied	\N	\N	\N	\N	786	786	787
242	212	0	applied	\N	\N	\N	\N	790	790	791
243	212	0	applied	\N	\N	\N	\N	790	790	791
244	213	0	applied	\N	\N	\N	\N	794	794	795
245	213	0	applied	\N	\N	\N	\N	794	794	795
246	214	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	800	800	\N
246	215	1	applied	\N	\N	\N	\N	801	801	802
246	216	2	applied	\N	\N	\N	\N	803	803	804
246	217	3	applied	\N	\N	\N	\N	805	805	806
247	214	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	800	800	\N
247	215	1	applied	\N	\N	\N	\N	801	801	802
247	216	2	applied	\N	\N	\N	\N	803	803	804
247	217	3	applied	\N	\N	\N	\N	805	805	806
248	218	0	applied	\N	\N	\N	\N	811	811	812
248	219	1	applied	\N	\N	\N	\N	813	813	814
249	218	0	applied	\N	\N	\N	\N	811	811	812
249	219	1	applied	\N	\N	\N	\N	813	813	814
250	220	0	applied	\N	\N	\N	\N	818	818	819
250	221	1	applied	\N	\N	\N	\N	820	820	821
250	222	2	applied	\N	\N	\N	\N	822	822	823
255	223	0	applied	\N	\N	\N	\N	581	581	827
255	224	1	applied	\N	\N	\N	\N	828	828	829
255	225	2	applied	\N	\N	\N	\N	830	830	831
255	226	3	applied	\N	\N	\N	\N	832	832	833
255	227	4	applied	\N	\N	\N	\N	834	834	835
256	228	0	applied	\N	\N	\N	\N	838	838	839
257	229	0	applied	\N	\N	\N	\N	842	842	843
258	230	0	applied	\N	\N	\N	\N	844	844	845
259	230	0	applied	\N	\N	\N	\N	844	844	845
260	230	0	applied	\N	\N	\N	\N	844	844	845
261	230	0	applied	\N	\N	\N	\N	844	844	845
262	231	0	applied	\N	\N	\N	\N	852	852	853
263	231	0	applied	\N	\N	\N	\N	852	852	853
265	231	0	applied	\N	\N	\N	\N	852	852	853
265	232	1	applied	\N	\N	\N	\N	857	857	858
265	233	2	applied	\N	\N	\N	\N	859	859	860
266	234	0	applied	\N	\N	\N	\N	861	861	862
266	235	1	applied	\N	\N	\N	\N	863	863	864
266	236	2	applied	\N	\N	\N	\N	865	865	866
267	234	0	applied	\N	\N	\N	\N	861	861	862
267	235	1	applied	\N	\N	\N	\N	863	863	864
267	236	2	applied	\N	\N	\N	\N	865	865	866
268	237	0	applied	\N	\N	\N	\N	871	871	872
269	237	0	applied	\N	\N	\N	\N	871	871	872
270	238	0	applied	\N	\N	\N	\N	877	877	878
271	239	0	applied	\N	\N	\N	\N	881	881	882
272	239	0	applied	\N	\N	\N	\N	881	881	882
273	240	0	applied	\N	\N	\N	\N	886	886	887
274	240	0	applied	\N	\N	\N	\N	886	886	887
275	240	0	applied	\N	\N	\N	\N	886	886	887
276	241	0	applied	\N	\N	\N	\N	892	892	893
277	241	0	applied	\N	\N	\N	\N	892	892	893
278	242	0	applied	\N	\N	\N	\N	896	896	897
279	242	0	applied	\N	\N	\N	\N	896	896	897
281	243	0	applied	\N	\N	\N	\N	901	901	902
282	244	0	applied	\N	\N	\N	\N	904	904	905
283	244	0	applied	\N	\N	\N	\N	904	904	905
284	245	0	applied	\N	\N	\N	\N	908	908	909
285	245	0	applied	\N	\N	\N	\N	908	908	909
286	245	0	applied	\N	\N	\N	\N	908	908	909
287	245	0	applied	\N	\N	\N	\N	908	908	909
288	246	0	applied	\N	\N	\N	\N	918	918	919
289	246	0	applied	\N	\N	\N	\N	918	918	919
290	247	0	applied	\N	\N	\N	\N	922	922	923
290	248	1	applied	\N	\N	\N	\N	924	924	925
291	249	0	applied	\N	\N	\N	\N	928	928	929
292	250	0	applied	\N	\N	\N	\N	932	932	933
293	250	0	applied	\N	\N	\N	\N	932	932	933
294	251	0	applied	\N	\N	\N	\N	936	936	937
295	252	0	applied	\N	\N	\N	\N	940	940	941
295	253	1	applied	\N	\N	\N	\N	942	942	943
296	254	0	applied	\N	\N	\N	\N	945	945	946
296	255	1	applied	\N	\N	\N	\N	947	947	948
296	256	2	applied	\N	\N	\N	\N	949	949	950
298	254	0	applied	\N	\N	\N	\N	945	945	946
298	255	1	applied	\N	\N	\N	\N	947	947	948
298	256	2	applied	\N	\N	\N	\N	949	949	950
299	257	0	applied	\N	\N	\N	\N	957	957	958
300	258	0	applied	\N	\N	\N	\N	959	959	960
305	267	0	applied	\N	\N	\N	\N	982	982	983
305	268	1	applied	\N	\N	\N	\N	984	984	985
308	269	0	applied	\N	\N	\N	\N	992	992	993
311	271	0	applied	\N	\N	\N	\N	998	998	999
314	274	0	applied	\N	\N	\N	\N	1007	1007	1008
314	275	1	applied	\N	\N	\N	\N	1009	1009	1010
318	277	0	applied	\N	\N	\N	\N	1019	1019	1020
318	278	1	applied	\N	\N	\N	\N	1021	1021	1022
321	279	0	applied	\N	\N	\N	\N	1029	1029	1030
329	287	0	applied	\N	\N	\N	\N	1058	1058	1059
332	289	0	applied	\N	\N	\N	\N	1068	1068	1069
297	254	0	applied	\N	\N	\N	\N	945	945	946
297	255	1	applied	\N	\N	\N	\N	947	947	948
297	256	2	applied	\N	\N	\N	\N	949	949	950
301	258	0	applied	\N	\N	\N	\N	959	959	960
304	262	0	applied	\N	\N	\N	\N	970	970	971
304	263	1	applied	\N	\N	\N	\N	972	972	973
304	264	2	applied	\N	\N	\N	\N	974	974	975
304	265	3	applied	\N	\N	\N	\N	976	976	977
304	266	4	applied	\N	\N	\N	\N	978	978	979
307	267	0	applied	\N	\N	\N	\N	982	982	983
307	268	1	applied	\N	\N	\N	\N	984	984	985
309	270	0	applied	\N	\N	\N	\N	996	996	997
310	271	0	applied	\N	\N	\N	\N	998	998	999
315	274	0	applied	\N	\N	\N	\N	1007	1007	1008
315	275	1	applied	\N	\N	\N	\N	1009	1009	1010
317	277	0	applied	\N	\N	\N	\N	1019	1019	1020
317	278	1	applied	\N	\N	\N	\N	1021	1021	1022
322	280	0	applied	\N	\N	\N	\N	1035	1035	1036
322	281	1	applied	\N	\N	\N	\N	1037	1037	1038
325	283	0	applied	\N	\N	\N	\N	1042	1042	1043
325	284	1	applied	\N	\N	\N	\N	1044	1044	1045
328	287	0	applied	\N	\N	\N	\N	1058	1058	1059
331	289	0	applied	\N	\N	\N	\N	1068	1068	1069
302	258	0	applied	\N	\N	\N	\N	959	959	960
303	259	0	applied	\N	\N	\N	\N	963	963	964
303	260	1	applied	\N	\N	\N	\N	965	965	966
303	261	2	applied	\N	\N	\N	\N	967	967	968
306	267	0	applied	\N	\N	\N	\N	982	982	983
306	268	1	applied	\N	\N	\N	\N	984	984	985
312	272	0	applied	\N	\N	\N	\N	1001	1001	1002
312	273	1	applied	\N	\N	\N	\N	1003	1003	1004
313	274	0	applied	\N	\N	\N	\N	1007	1007	1008
313	275	1	applied	\N	\N	\N	\N	1009	1009	1010
316	276	0	applied	\N	\N	\N	\N	1017	1017	1018
319	277	0	applied	\N	\N	\N	\N	1019	1019	1020
319	278	1	applied	\N	\N	\N	\N	1021	1021	1022
320	279	0	applied	\N	\N	\N	\N	1029	1029	1030
323	282	0	applied	\N	\N	\N	\N	1039	1039	1040
324	283	0	applied	\N	\N	\N	\N	1042	1042	1043
324	284	1	applied	\N	\N	\N	\N	1044	1044	1045
326	283	0	applied	\N	\N	\N	\N	1042	1042	1043
326	284	1	applied	\N	\N	\N	\N	1044	1044	1045
327	285	0	applied	\N	\N	\N	\N	1052	1052	1053
327	286	1	applied	\N	\N	\N	\N	1054	1054	1055
330	288	0	applied	\N	\N	\N	\N	1064	1064	1065
333	289	0	applied	\N	\N	\N	\N	1068	1068	1069
334	290	0	applied	\N	\N	\N	\N	1076	1076	1077
335	290	0	applied	\N	\N	\N	\N	1076	1076	1077
336	291	0	applied	\N	\N	\N	\N	1082	1082	1083
336	292	1	applied	\N	\N	\N	\N	1084	1084	1085
337	291	0	applied	\N	\N	\N	\N	1082	1082	1083
337	292	1	applied	\N	\N	\N	\N	1084	1084	1085
338	291	0	applied	\N	\N	\N	\N	1082	1082	1083
338	292	1	applied	\N	\N	\N	\N	1084	1084	1085
339	293	0	applied	\N	\N	\N	\N	1089	1089	1090
340	293	0	applied	\N	\N	\N	\N	1089	1089	1090
341	294	0	applied	\N	\N	\N	\N	1094	1094	1095
341	295	1	applied	\N	\N	\N	\N	1096	1096	1097
342	294	0	applied	\N	\N	\N	\N	1094	1094	1095
342	295	1	applied	\N	\N	\N	\N	1096	1096	1097
343	296	0	applied	\N	\N	\N	\N	1100	1100	1101
344	297	0	applied	\N	\N	\N	\N	1104	1104	1105
344	298	1	applied	\N	\N	\N	\N	1106	1106	1107
344	299	2	applied	\N	\N	\N	\N	1108	1108	1109
345	297	0	applied	\N	\N	\N	\N	1104	1104	1105
345	298	1	applied	\N	\N	\N	\N	1106	1106	1107
345	299	2	applied	\N	\N	\N	\N	1108	1108	1109
346	297	0	applied	\N	\N	\N	\N	1104	1104	1105
346	298	1	applied	\N	\N	\N	\N	1106	1106	1107
346	299	2	applied	\N	\N	\N	\N	1108	1108	1109
347	300	0	applied	\N	\N	\N	\N	1115	1115	1116
348	301	0	applied	\N	\N	\N	\N	1119	1119	1120
349	302	0	applied	\N	\N	\N	\N	1122	1122	1123
349	303	1	applied	\N	\N	1000000000	\N	1124	1124	1125
349	304	2	applied	\N	\N	1000000000	\N	1126	1126	1127
350	305	0	applied	\N	\N	\N	\N	1130	1130	1131
351	305	0	applied	\N	\N	\N	\N	1130	1130	1131
353	305	0	applied	\N	\N	\N	\N	1130	1130	1131
354	306	0	applied	\N	\N	\N	\N	1138	1138	1139
354	307	1	applied	\N	\N	\N	\N	1140	1140	1141
354	308	2	applied	\N	\N	\N	\N	1142	1142	1143
355	306	0	applied	\N	\N	\N	\N	1138	1138	1139
355	307	1	applied	\N	\N	\N	\N	1140	1140	1141
355	308	2	applied	\N	\N	\N	\N	1142	1142	1143
356	309	0	applied	\N	\N	\N	\N	1147	1147	1148
356	310	1	applied	\N	\N	\N	\N	1149	1149	1150
356	311	2	applied	\N	\N	\N	\N	1151	1151	1152
357	309	0	applied	\N	\N	\N	\N	1147	1147	1148
357	310	1	applied	\N	\N	\N	\N	1149	1149	1150
357	311	2	applied	\N	\N	\N	\N	1151	1151	1152
358	312	0	applied	\N	\N	\N	\N	1156	1156	1139
358	313	1	applied	\N	\N	\N	\N	1157	1157	1158
358	314	2	applied	\N	\N	\N	\N	1159	1159	1160
358	315	3	applied	\N	\N	\N	\N	1161	1161	1162
359	316	0	applied	\N	\N	\N	\N	1165	1165	1166
359	317	1	applied	\N	\N	\N	\N	1167	1167	1168
360	316	0	applied	\N	\N	\N	\N	1165	1165	1166
360	317	1	applied	\N	\N	\N	\N	1167	1167	1168
361	318	0	applied	\N	\N	\N	\N	1173	1173	1174
362	319	0	applied	\N	\N	\N	\N	1177	1177	1178
362	320	1	applied	\N	\N	\N	\N	1179	1179	1180
363	319	0	applied	\N	\N	\N	\N	1177	1177	1178
364	321	0	applied	\N	\N	\N	\N	1184	1184	1185
365	321	0	applied	\N	\N	\N	\N	1184	1184	1185
366	322	0	applied	\N	\N	\N	\N	1189	1189	1190
366	323	1	applied	\N	\N	\N	\N	1191	1191	1192
367	322	0	applied	\N	\N	\N	\N	1189	1189	1190
367	323	1	applied	\N	\N	\N	\N	1191	1191	1192
368	322	0	applied	\N	\N	\N	\N	1189	1189	1190
368	323	1	applied	\N	\N	\N	\N	1191	1191	1192
369	324	0	applied	\N	\N	\N	\N	1198	1198	1199
369	325	1	applied	\N	\N	\N	\N	1200	1200	1201
370	324	0	applied	\N	\N	\N	\N	1198	1198	1199
370	325	1	applied	\N	\N	\N	\N	1200	1200	1201
371	326	0	applied	\N	\N	\N	\N	1204	1204	1205
371	327	1	applied	\N	\N	\N	\N	1206	1206	1207
372	328	0	applied	\N	\N	\N	\N	1210	1210	1211
373	329	0	applied	\N	\N	\N	\N	1213	1213	1214
374	329	0	applied	\N	\N	\N	\N	1213	1213	1214
375	329	0	applied	\N	\N	\N	\N	1213	1213	1214
376	329	0	applied	\N	\N	\N	\N	1213	1213	1214
377	329	0	applied	\N	\N	\N	\N	1213	1213	1214
378	330	0	applied	\N	\N	\N	\N	1217	1217	1218
379	331	0	applied	\N	\N	\N	\N	1221	1221	1222
379	332	1	applied	\N	\N	\N	\N	1223	1223	1224
379	333	2	applied	\N	\N	1000000000	\N	1225	1225	1226
379	334	3	applied	\N	\N	\N	\N	1227	1227	1228
380	335	0	applied	\N	\N	\N	\N	1230	1230	1231
381	336	0	applied	\N	\N	\N	\N	1234	1234	1235
382	337	0	applied	\N	\N	\N	\N	1238	1238	1239
383	337	0	applied	\N	\N	\N	\N	1238	1238	1239
384	337	0	applied	\N	\N	\N	\N	1238	1238	1239
385	338	0	applied	\N	\N	\N	\N	1245	1245	1246
385	339	2	applied	\N	\N	\N	\N	1248	1248	1249
385	340	3	applied	\N	\N	\N	\N	1250	1250	1251
385	341	4	applied	\N	\N	\N	\N	1252	1252	1253
385	342	5	applied	\N	\N	\N	\N	1254	1254	1255
386	343	0	applied	\N	\N	\N	\N	1257	1257	1258
387	344	0	applied	\N	\N	\N	\N	1261	1261	1262
387	345	1	applied	\N	\N	\N	\N	1263	1263	1254
388	344	0	applied	\N	\N	\N	\N	1261	1261	1262
388	345	1	applied	\N	\N	\N	\N	1263	1263	1254
389	344	0	applied	\N	\N	\N	\N	1261	1261	1262
389	345	1	applied	\N	\N	\N	\N	1263	1263	1254
390	346	0	applied	\N	\N	\N	\N	1269	1269	1270
391	347	0	applied	\N	\N	\N	\N	1273	1273	1274
392	347	0	applied	\N	\N	\N	\N	1273	1273	1274
393	348	0	applied	\N	\N	\N	\N	1279	1279	1280
394	349	0	applied	\N	\N	\N	\N	1281	1281	1282
395	349	0	applied	\N	\N	\N	\N	1281	1281	1282
396	350	0	applied	\N	\N	\N	\N	1287	1287	1288
396	351	1	applied	\N	\N	\N	\N	1289	1289	1290
397	350	0	applied	\N	\N	\N	\N	1287	1287	1288
397	351	1	applied	\N	\N	\N	\N	1289	1289	1290
398	350	0	applied	\N	\N	\N	\N	1287	1287	1288
398	351	1	applied	\N	\N	\N	\N	1289	1289	1290
399	352	0	applied	\N	\N	\N	\N	1296	1296	1297
399	353	1	applied	\N	\N	\N	\N	1298	1298	1299
399	354	2	applied	\N	\N	\N	\N	1300	1300	1301
400	352	0	applied	\N	\N	\N	\N	1296	1296	1297
400	353	1	applied	\N	\N	\N	\N	1298	1298	1299
400	354	2	applied	\N	\N	\N	\N	1300	1300	1301
401	352	0	applied	\N	\N	\N	\N	1296	1296	1297
401	353	1	applied	\N	\N	\N	\N	1298	1298	1299
401	354	2	applied	\N	\N	\N	\N	1300	1300	1301
402	355	0	applied	\N	\N	\N	\N	1306	1306	1307
402	356	1	applied	\N	\N	\N	\N	1308	1308	1309
403	357	0	applied	\N	\N	\N	\N	1312	1312	1313
403	358	1	applied	\N	\N	\N	\N	1314	1314	1315
404	359	0	applied	\N	\N	\N	\N	1318	1318	1319
404	360	1	applied	\N	\N	\N	\N	1320	1320	1254
405	359	0	applied	\N	\N	\N	\N	1318	1318	1319
405	360	1	applied	\N	\N	\N	\N	1320	1320	1254
406	359	0	applied	\N	\N	\N	\N	1318	1318	1319
406	360	1	applied	\N	\N	\N	\N	1320	1320	1254
407	361	0	applied	\N	\N	\N	\N	1326	1326	1327
408	362	0	applied	\N	\N	\N	\N	1329	1329	1330
409	363	0	applied	\N	\N	\N	\N	1331	1331	1332
410	363	0	applied	\N	\N	\N	\N	1331	1331	1332
411	364	0	applied	\N	\N	\N	\N	1337	1337	1338
412	364	0	applied	\N	\N	\N	\N	1337	1337	1338
413	365	0	applied	\N	\N	\N	\N	1342	1342	1343
413	366	1	applied	\N	\N	\N	\N	1344	1344	1345
414	367	0	applied	\N	\N	\N	\N	1346	1346	1347
415	368	0	applied	\N	\N	\N	\N	1349	1349	1350
415	369	1	applied	\N	\N	\N	\N	1351	1351	1352
416	368	0	applied	\N	\N	\N	\N	1349	1349	1350
416	369	1	applied	\N	\N	\N	\N	1351	1351	1352
417	370	0	applied	\N	\N	\N	\N	1356	1356	1357
417	371	1	applied	\N	\N	\N	\N	1358	1358	1359
418	372	0	applied	\N	\N	1000000000	\N	1362	1362	1363
418	373	1	applied	\N	\N	1000000000	\N	1364	1364	1365
418	374	2	applied	\N	\N	\N	\N	1366	1366	1367
419	372	0	applied	\N	\N	1000000000	\N	1362	1362	1363
419	373	1	applied	\N	\N	1000000000	\N	1364	1364	1365
419	374	2	applied	\N	\N	\N	\N	1366	1366	1367
420	375	0	applied	\N	\N	\N	\N	1370	1370	1371
420	376	1	applied	\N	\N	\N	\N	1372	1372	1373
420	377	2	applied	\N	\N	\N	\N	1374	1374	1375
421	375	0	applied	\N	\N	\N	\N	1370	1370	1371
421	376	1	applied	\N	\N	\N	\N	1372	1372	1373
421	377	2	applied	\N	\N	\N	\N	1374	1374	1375
422	378	0	applied	\N	\N	\N	\N	1380	1380	1381
423	378	0	applied	\N	\N	\N	\N	1380	1380	1381
424	379	0	applied	\N	\N	\N	\N	1383	1383	1384
425	379	0	applied	\N	\N	\N	\N	1383	1383	1384
426	379	0	applied	\N	\N	\N	\N	1383	1383	1384
427	380	0	applied	\N	\N	\N	\N	1390	1390	1391
428	381	0	applied	\N	\N	\N	\N	1392	1392	1393
429	381	0	applied	\N	\N	\N	\N	1392	1392	1393
430	382	0	applied	\N	\N	\N	\N	1396	1396	1397
431	382	0	applied	\N	\N	\N	\N	1396	1396	1397
432	382	0	applied	\N	\N	\N	\N	1396	1396	1397
433	383	0	applied	\N	\N	\N	\N	1402	1402	1403
433	384	1	applied	\N	\N	\N	\N	1404	1404	1405
434	383	0	applied	\N	\N	\N	\N	1402	1402	1403
434	384	1	applied	\N	\N	\N	\N	1404	1404	1405
435	385	0	applied	\N	\N	\N	\N	1408	1408	1409
436	385	0	applied	\N	\N	\N	\N	1408	1408	1409
437	386	0	applied	\N	\N	\N	\N	1412	1412	1413
438	386	0	applied	\N	\N	\N	\N	1412	1412	1413
439	386	0	applied	\N	\N	\N	\N	1412	1412	1413
440	387	0	applied	\N	\N	\N	\N	1416	1416	1417
440	388	1	applied	\N	\N	\N	\N	1418	1418	1419
440	389	2	applied	\N	\N	\N	\N	1420	1420	1421
441	387	0	applied	\N	\N	\N	\N	1416	1416	1417
441	388	1	applied	\N	\N	\N	\N	1418	1418	1419
441	389	2	applied	\N	\N	\N	\N	1420	1420	1421
442	387	0	applied	\N	\N	\N	\N	1416	1416	1417
442	388	1	applied	\N	\N	\N	\N	1418	1418	1419
442	389	2	applied	\N	\N	\N	\N	1420	1420	1421
443	387	0	applied	\N	\N	\N	\N	1416	1416	1417
443	388	1	applied	\N	\N	\N	\N	1418	1418	1419
443	389	2	applied	\N	\N	\N	\N	1420	1420	1421
444	387	0	applied	\N	\N	\N	\N	1416	1416	1417
444	388	1	applied	\N	\N	\N	\N	1418	1418	1419
444	389	2	applied	\N	\N	\N	\N	1420	1420	1421
445	387	0	applied	\N	\N	\N	\N	1416	1416	1417
445	388	1	applied	\N	\N	\N	\N	1418	1418	1419
445	389	2	applied	\N	\N	\N	\N	1420	1420	1421
446	390	0	applied	\N	\N	\N	\N	1432	1432	1433
446	391	1	applied	\N	\N	\N	\N	1434	1434	1435
447	392	0	applied	\N	\N	\N	\N	1438	1438	1439
448	393	0	applied	\N	\N	\N	\N	1442	1442	1443
449	394	0	applied	\N	\N	\N	\N	1444	1444	1445
450	395	0	applied	\N	\N	\N	\N	1446	1446	1447
450	396	2	applied	\N	\N	\N	\N	1448	1448	1449
451	397	0	applied	\N	\N	\N	\N	1451	1451	1452
452	397	0	applied	\N	\N	\N	\N	1451	1451	1452
453	397	0	applied	\N	\N	\N	\N	1451	1451	1452
454	398	0	applied	\N	\N	\N	\N	1459	1459	1460
454	399	1	applied	\N	\N	\N	\N	1461	1461	1462
455	398	0	applied	\N	\N	\N	\N	1459	1459	1460
455	399	1	applied	\N	\N	\N	\N	1461	1461	1462
456	400	0	applied	\N	\N	\N	\N	1467	1467	1468
457	400	0	applied	\N	\N	\N	\N	1467	1467	1468
458	400	0	applied	\N	\N	\N	\N	1467	1467	1468
459	400	0	applied	\N	\N	\N	\N	1467	1467	1468
460	401	0	applied	\N	\N	\N	\N	1475	1475	1476
461	401	0	applied	\N	\N	\N	\N	1475	1475	1476
462	402	0	applied	\N	\N	\N	\N	1481	1481	1482
463	403	0	applied	\N	\N	\N	\N	1483	1483	1484
464	403	0	applied	\N	\N	\N	\N	1483	1483	1484
465	404	0	applied	\N	\N	\N	\N	1487	1487	1488
466	405	0	applied	\N	\N	\N	\N	1491	1491	1492
469	406	0	applied	\N	\N	\N	\N	1498	1498	1499
469	407	1	applied	\N	\N	\N	\N	1500	1500	1501
469	408	2	applied	\N	\N	\N	\N	1502	1502	1503
469	409	3	applied	\N	\N	\N	\N	1504	1504	1505
473	411	0	applied	\N	\N	\N	\N	1512	1512	1513
473	412	1	applied	\N	\N	\N	\N	1514	1514	1515
473	413	2	applied	\N	\N	\N	\N	1516	1516	1517
476	411	0	applied	\N	\N	\N	\N	1512	1512	1513
476	412	1	applied	\N	\N	\N	\N	1514	1514	1515
476	413	2	applied	\N	\N	\N	\N	1516	1516	1517
479	416	0	applied	\N	\N	1000000000	\N	1531	1531	1532
479	417	1	applied	\N	\N	\N	\N	1533	1533	1534
482	420	0	applied	\N	\N	\N	\N	1546	1546	1547
485	421	0	applied	\N	\N	\N	\N	1552	1552	1553
488	421	0	applied	\N	\N	\N	\N	1552	1552	1553
491	425	0	applied	\N	\N	\N	\N	1566	1566	1567
494	426	0	applied	\N	\N	\N	\N	1572	1572	1573
497	431	0	applied	\N	\N	\N	\N	1588	1588	1589
497	432	1	applied	\N	\N	\N	\N	1590	1590	1591
498	433	0	applied	\N	\N	\N	\N	1594	1594	1595
498	434	1	applied	\N	\N	1000000000	\N	1596	1596	1597
501	436	0	applied	\N	\N	\N	\N	1601	1601	1602
506	443	0	applied	\N	\N	\N	\N	1624	1624	1625
506	444	1	applied	\N	\N	\N	\N	1626	1626	1627
506	445	2	applied	\N	\N	\N	\N	1628	1628	1629
509	446	0	applied	\N	\N	\N	\N	1632	1632	1633
512	447	0	applied	\N	\N	\N	\N	1638	1638	1639
515	452	0	applied	\N	\N	\N	\N	1655	1655	1656
518	456	0	applied	\N	\N	\N	\N	1666	1666	1667
518	457	1	applied	\N	\N	\N	\N	1668	1668	1669
521	458	0	applied	\N	\N	\N	\N	1673	1673	1674
521	459	1	applied	\N	\N	\N	\N	1675	1675	1676
521	460	2	applied	\N	\N	\N	\N	1677	1677	1678
521	461	3	applied	\N	\N	\N	\N	1679	1679	1680
521	462	4	applied	\N	\N	\N	\N	1681	1681	1682
524	468	0	applied	\N	\N	\N	\N	1700	1700	1701
467	405	0	applied	\N	\N	\N	\N	1491	1491	1492
470	406	0	applied	\N	\N	\N	\N	1498	1498	1499
470	407	1	applied	\N	\N	\N	\N	1500	1500	1501
470	408	2	applied	\N	\N	\N	\N	1502	1502	1503
470	409	3	applied	\N	\N	\N	\N	1504	1504	1505
472	410	0	applied	\N	\N	\N	\N	1508	1508	1509
477	414	0	applied	\N	\N	\N	\N	1525	1525	1526
477	415	1	applied	\N	\N	\N	\N	1527	1527	1528
480	418	0	applied	\N	\N	\N	\N	1539	1539	1540
481	419	0	applied	\N	\N	\N	\N	1542	1542	1543
484	421	0	applied	\N	\N	\N	\N	1552	1552	1553
487	421	0	applied	\N	\N	\N	\N	1552	1552	1553
490	422	0	applied	\N	\N	\N	\N	1556	1556	1557
490	423	1	applied	\N	\N	\N	\N	1558	1558	1559
490	424	2	applied	\N	\N	\N	\N	1560	1560	1561
496	430	0	applied	\N	\N	\N	\N	1584	1584	1585
499	435	0	applied	\N	\N	\N	\N	1599	1599	1600
502	437	0	applied	\N	\N	\N	\N	1607	1607	1608
502	438	1	applied	\N	\N	\N	\N	1609	1609	1610
507	443	0	applied	\N	\N	\N	\N	1624	1624	1625
507	444	1	applied	\N	\N	\N	\N	1626	1626	1627
507	445	2	applied	\N	\N	\N	\N	1628	1628	1629
510	447	0	applied	\N	\N	\N	\N	1638	1638	1639
513	448	0	applied	\N	\N	\N	\N	1646	1646	1647
513	449	1	applied	\N	\N	\N	\N	1648	1648	1649
513	450	2	applied	\N	\N	\N	\N	1650	1650	1651
513	451	3	applied	\N	\N	\N	\N	1652	1652	1653
519	456	0	applied	\N	\N	\N	\N	1666	1666	1667
519	457	1	applied	\N	\N	\N	\N	1668	1668	1669
522	463	0	applied	\N	\N	\N	\N	1686	1686	1687
522	464	1	applied	\N	\N	\N	\N	1688	1688	1689
523	465	0	applied	\N	\N	\N	\N	1692	1692	1693
523	466	1	applied	\N	\N	\N	\N	1694	1694	1695
523	467	2	applied	\N	\N	\N	\N	1696	1696	1697
468	405	0	applied	\N	\N	\N	\N	1491	1491	1492
471	410	0	applied	\N	\N	\N	\N	1508	1508	1509
474	411	0	applied	\N	\N	\N	\N	1512	1512	1513
474	412	1	applied	\N	\N	\N	\N	1514	1514	1515
474	413	2	applied	\N	\N	\N	\N	1516	1516	1517
475	411	0	applied	\N	\N	\N	\N	1512	1512	1513
475	412	1	applied	\N	\N	\N	\N	1514	1514	1515
475	413	2	applied	\N	\N	\N	\N	1516	1516	1517
478	416	0	applied	\N	\N	1000000000	\N	1531	1531	1532
478	417	1	applied	\N	\N	\N	\N	1533	1533	1534
483	420	0	applied	\N	\N	\N	\N	1546	1546	1547
486	421	0	applied	\N	\N	\N	\N	1552	1552	1553
489	422	0	applied	\N	\N	\N	\N	1556	1556	1557
489	423	1	applied	\N	\N	\N	\N	1558	1558	1559
489	424	2	applied	\N	\N	\N	\N	1560	1560	1561
492	425	0	applied	\N	\N	\N	\N	1566	1566	1567
493	426	0	applied	\N	\N	\N	\N	1572	1572	1573
495	427	0	applied	\N	\N	\N	\N	1576	1576	1577
495	428	1	applied	\N	\N	\N	\N	1578	1578	1579
495	429	2	applied	\N	\N	\N	\N	1580	1580	1581
500	436	0	applied	\N	\N	\N	\N	1601	1601	1602
503	439	0	applied	\N	\N	\N	\N	1613	1613	1614
503	440	1	applied	\N	\N	1000000000	\N	1615	1615	1616
503	441	2	applied	\N	\N	1000000000	\N	1617	1617	1618
504	442	0	applied	\N	\N	\N	\N	1620	1620	1621
505	443	0	applied	\N	\N	\N	\N	1624	1624	1625
505	444	1	applied	\N	\N	\N	\N	1626	1626	1627
505	445	2	applied	\N	\N	\N	\N	1628	1628	1629
508	446	0	applied	\N	\N	\N	\N	1632	1632	1633
511	447	0	applied	\N	\N	\N	\N	1638	1638	1639
514	452	0	applied	\N	\N	\N	\N	1655	1655	1656
517	453	0	applied	\N	\N	\N	\N	1658	1658	1659
517	454	1	applied	\N	\N	\N	\N	1660	1660	1661
517	455	2	applied	\N	\N	\N	\N	1662	1662	1663
520	458	0	applied	\N	\N	\N	\N	1673	1673	1674
520	459	1	applied	\N	\N	\N	\N	1675	1675	1676
520	460	2	applied	\N	\N	\N	\N	1677	1677	1678
520	461	3	applied	\N	\N	\N	\N	1679	1679	1680
520	462	4	applied	\N	\N	\N	\N	1681	1681	1682
525	469	0	applied	\N	\N	\N	\N	1702	1702	1703
526	470	0	applied	\N	\N	\N	\N	1705	1705	1706
526	471	1	applied	\N	\N	1000000000	\N	1707	1707	1708
527	470	0	applied	\N	\N	\N	\N	1705	1705	1706
527	471	1	applied	\N	\N	1000000000	\N	1707	1707	1708
528	472	0	applied	\N	\N	\N	\N	1713	1713	1714
529	473	0	applied	\N	\N	\N	\N	1715	1715	1716
530	474	0	applied	\N	\N	\N	\N	1719	1719	1720
531	475	0	applied	\N	\N	\N	\N	1723	1723	1724
532	476	0	applied	\N	\N	\N	\N	1727	1727	1728
533	477	0	applied	\N	\N	\N	\N	1731	1731	1732
534	477	0	applied	\N	\N	\N	\N	1731	1731	1732
535	478	0	applied	\N	\N	\N	\N	1735	1735	1736
536	478	0	applied	\N	\N	\N	\N	1735	1735	1736
537	479	0	applied	\N	\N	\N	\N	1741	1741	1742
537	480	1	applied	\N	\N	\N	\N	1743	1743	1365
538	479	0	applied	\N	\N	\N	\N	1741	1741	1742
538	480	1	applied	\N	\N	\N	\N	1743	1743	1365
539	479	0	applied	\N	\N	\N	\N	1741	1741	1742
539	480	1	applied	\N	\N	\N	\N	1743	1743	1365
540	481	0	applied	\N	\N	\N	\N	1750	1750	1751
541	482	0	applied	\N	\N	\N	\N	1753	1753	1754
542	482	0	applied	\N	\N	\N	\N	1753	1753	1754
543	482	0	applied	\N	\N	\N	\N	1753	1753	1754
544	483	0	applied	\N	\N	\N	\N	1758	1758	1759
545	483	0	applied	\N	\N	\N	\N	1758	1758	1759
546	484	0	applied	\N	\N	\N	\N	1760	1760	1761
546	485	1	applied	\N	\N	\N	\N	1762	1762	1763
546	486	2	applied	\N	\N	\N	\N	1764	1764	1765
547	484	0	applied	\N	\N	\N	\N	1760	1760	1761
547	485	1	applied	\N	\N	\N	\N	1762	1762	1763
547	486	2	applied	\N	\N	\N	\N	1764	1764	1765
548	487	0	applied	\N	\N	\N	\N	1770	1770	1771
549	488	0	applied	\N	\N	\N	\N	1774	1774	1775
550	488	0	applied	\N	\N	\N	\N	1774	1774	1775
551	489	0	applied	\N	\N	\N	\N	1779	1779	1780
552	490	0	applied	\N	\N	\N	\N	1783	1783	1784
553	490	0	applied	\N	\N	\N	\N	1783	1783	1784
554	490	0	applied	\N	\N	\N	\N	1783	1783	1784
555	490	0	applied	\N	\N	\N	\N	1783	1783	1784
556	491	0	applied	\N	\N	\N	\N	1790	1790	1791
557	491	0	applied	\N	\N	\N	\N	1790	1790	1791
558	492	0	applied	\N	\N	\N	\N	1795	1795	1796
559	493	0	applied	\N	\N	\N	\N	1797	1797	1798
560	494	0	applied	\N	\N	\N	\N	1800	1800	1801
560	495	1	applied	\N	\N	\N	\N	1802	1802	1803
561	494	0	applied	\N	\N	\N	\N	1800	1800	1801
561	495	1	applied	\N	\N	\N	\N	1802	1802	1803
562	494	0	applied	\N	\N	\N	\N	1800	1800	1801
562	495	1	applied	\N	\N	\N	\N	1802	1802	1803
563	496	0	applied	\N	\N	\N	\N	1809	1809	1810
564	497	0	applied	\N	\N	\N	\N	1812	1812	1813
565	497	0	applied	\N	\N	\N	\N	1812	1812	1813
566	498	0	applied	\N	\N	\N	\N	1818	1818	1819
567	498	0	applied	\N	\N	\N	\N	1818	1818	1819
568	499	0	applied	\N	\N	\N	\N	1824	1824	1825
569	499	0	applied	\N	\N	\N	\N	1824	1824	1825
570	500	0	applied	\N	\N	\N	\N	1826	1826	1827
571	501	0	applied	\N	\N	\N	\N	1830	1830	1831
572	502	0	applied	\N	\N	\N	\N	1834	1834	1835
573	502	0	applied	\N	\N	\N	\N	1834	1834	1835
574	502	0	applied	\N	\N	\N	\N	1834	1834	1835
575	502	0	applied	\N	\N	\N	\N	1834	1834	1835
576	503	0	applied	\N	\N	\N	\N	1842	1842	1843
576	504	1	applied	\N	\N	\N	\N	1844	1844	1845
576	505	2	applied	\N	\N	\N	\N	1846	1846	1847
577	503	0	applied	\N	\N	\N	\N	1842	1842	1843
577	504	1	applied	\N	\N	\N	\N	1844	1844	1845
577	505	2	applied	\N	\N	\N	\N	1846	1846	1847
578	506	0	applied	\N	\N	\N	\N	1852	1852	1853
578	507	1	failed	Receiver_not_present	\N	\N	\N	1854	1854	\N
579	508	0	failed	Receiver_not_present	\N	\N	\N	1857	1857	\N
579	509	1	applied	\N	\N	\N	\N	1858	1858	1859
579	510	2	applied	\N	\N	\N	\N	1860	1860	1861
580	508	0	failed	Receiver_not_present	\N	\N	\N	1857	1857	\N
580	509	1	applied	\N	\N	\N	\N	1858	1858	1859
580	510	2	applied	\N	\N	\N	\N	1860	1860	1861
581	511	0	applied	\N	\N	\N	\N	1866	1866	1867
582	512	0	applied	\N	\N	\N	\N	1868	1868	1869
583	513	0	applied	\N	\N	\N	\N	1871	1871	1872
585	513	0	applied	\N	\N	\N	\N	1871	1871	1872
588	515	0	applied	\N	\N	\N	\N	1879	1879	1880
589	516	0	applied	\N	\N	\N	\N	1881	1881	1882
598	525	0	applied	\N	\N	\N	\N	1912	1912	1913
601	527	0	applied	\N	\N	\N	\N	1922	1922	1923
607	529	0	applied	\N	\N	\N	\N	1936	1936	1937
611	531	0	applied	\N	\N	\N	\N	1946	1946	1947
614	532	0	applied	\N	\N	\N	\N	1950	1950	1951
617	533	0	applied	\N	\N	\N	\N	1956	1956	1957
623	537	0	applied	\N	\N	\N	\N	1970	1970	1971
625	538	0	applied	\N	\N	\N	\N	1972	1972	1973
625	539	1	applied	\N	\N	\N	\N	1974	1974	1975
627	540	0	applied	\N	\N	\N	\N	1982	1982	1983
627	541	1	applied	\N	\N	\N	\N	1984	1984	1985
629	542	0	applied	\N	\N	\N	\N	1987	1987	1988
584	513	0	applied	\N	\N	\N	\N	1871	1871	1872
587	514	0	applied	\N	\N	\N	\N	1875	1875	1876
592	521	0	applied	\N	\N	\N	\N	1895	1895	1896
594	521	0	applied	\N	\N	\N	\N	1895	1895	1896
597	525	0	applied	\N	\N	\N	\N	1912	1912	1913
600	527	0	applied	\N	\N	\N	\N	1922	1922	1923
603	528	0	applied	\N	\N	\N	\N	1929	1929	1930
606	529	0	applied	\N	\N	\N	\N	1936	1936	1937
610	530	0	applied	\N	\N	\N	\N	1942	1942	1943
612	531	0	applied	\N	\N	\N	\N	1946	1946	1947
613	531	0	applied	\N	\N	\N	\N	1946	1946	1947
615	532	0	applied	\N	\N	\N	\N	1950	1950	1951
616	532	0	applied	\N	\N	\N	\N	1950	1950	1951
618	533	0	applied	\N	\N	\N	\N	1956	1956	1957
619	534	0	applied	\N	\N	\N	\N	1962	1962	1963
622	535	0	applied	\N	\N	\N	\N	1965	1965	1966
622	536	1	applied	\N	\N	\N	\N	1967	1967	1968
628	542	0	applied	\N	\N	\N	\N	1987	1987	1988
586	514	0	applied	\N	\N	\N	\N	1875	1875	1876
590	517	0	applied	\N	\N	\N	\N	1884	1884	1885
591	518	0	applied	\N	\N	\N	\N	1888	1888	1889
591	519	1	applied	\N	\N	1000000000	\N	1890	1890	1891
591	520	2	applied	\N	\N	\N	\N	1892	1892	1893
593	521	0	applied	\N	\N	\N	\N	1895	1895	1896
595	522	0	applied	\N	\N	\N	\N	1903	1903	1904
596	523	0	applied	\N	\N	\N	\N	1907	1907	1908
596	524	1	applied	\N	\N	\N	\N	1909	1909	1910
599	526	0	applied	\N	\N	\N	\N	1918	1918	1919
602	527	0	applied	\N	\N	\N	\N	1922	1922	1923
604	528	0	applied	\N	\N	\N	\N	1929	1929	1930
605	528	0	applied	\N	\N	\N	\N	1929	1929	1930
608	529	0	applied	\N	\N	\N	\N	1936	1936	1937
609	530	0	applied	\N	\N	\N	\N	1942	1942	1943
624	538	0	applied	\N	\N	\N	\N	1972	1972	1973
624	539	1	applied	\N	\N	\N	\N	1974	1974	1975
626	538	0	applied	\N	\N	\N	\N	1972	1972	1973
626	539	1	applied	\N	\N	\N	\N	1974	1974	1975
630	542	0	applied	\N	\N	\N	\N	1987	1987	1988
631	543	0	applied	\N	\N	\N	\N	1989	1989	1990
632	543	0	applied	\N	\N	\N	\N	1989	1989	1990
633	544	0	applied	\N	\N	\N	\N	1994	1994	1995
634	545	0	applied	\N	\N	\N	\N	1998	1998	1999
635	545	0	applied	\N	\N	\N	\N	1998	1998	1999
636	545	0	applied	\N	\N	\N	\N	1998	1998	1999
637	546	0	applied	\N	\N	\N	\N	2004	2004	2005
638	547	0	applied	\N	\N	\N	\N	2008	2008	2009
639	548	0	applied	\N	\N	\N	\N	2012	2012	2013
640	548	0	applied	\N	\N	\N	\N	2012	2012	2013
641	549	0	applied	\N	\N	\N	\N	2016	2016	2017
642	549	0	applied	\N	\N	\N	\N	2016	2016	2017
643	549	0	applied	\N	\N	\N	\N	2016	2016	2017
644	550	0	applied	\N	\N	\N	\N	2020	2020	2021
645	551	0	applied	\N	\N	\N	\N	2023	2023	2024
645	552	1	applied	\N	\N	\N	\N	2025	2025	2026
646	551	0	applied	\N	\N	\N	\N	2023	2023	2024
646	552	1	applied	\N	\N	\N	\N	2025	2025	2026
647	553	0	applied	\N	\N	\N	\N	2031	2031	2032
647	554	1	applied	\N	\N	\N	\N	2033	2033	2034
648	555	0	applied	\N	\N	\N	\N	2036	2036	2037
649	555	0	applied	\N	\N	\N	\N	2036	2036	2037
650	555	0	applied	\N	\N	\N	\N	2036	2036	2037
651	556	0	applied	\N	\N	\N	\N	1187	1187	2040
651	557	1	applied	\N	\N	\N	\N	2041	2041	2042
651	558	3	applied	\N	\N	\N	\N	2044	2044	2045
651	559	4	applied	\N	\N	\N	\N	2046	2046	2047
652	556	0	applied	\N	\N	\N	\N	1187	1187	2040
652	557	1	applied	\N	\N	\N	\N	2041	2041	2042
652	558	3	applied	\N	\N	\N	\N	2044	2044	2045
652	559	4	applied	\N	\N	\N	\N	2046	2046	2047
653	556	0	applied	\N	\N	\N	\N	1187	1187	2040
653	557	1	applied	\N	\N	\N	\N	2041	2041	2042
653	558	3	applied	\N	\N	\N	\N	2044	2044	2045
653	559	4	applied	\N	\N	\N	\N	2046	2046	2047
654	556	0	applied	\N	\N	\N	\N	1187	1187	2040
654	557	1	applied	\N	\N	\N	\N	2041	2041	2042
654	558	3	applied	\N	\N	\N	\N	2044	2044	2045
654	559	4	applied	\N	\N	\N	\N	2046	2046	2047
655	560	0	applied	\N	\N	\N	\N	2059	2059	2060
655	561	1	applied	\N	\N	\N	\N	2061	2061	2062
656	560	0	applied	\N	\N	\N	\N	2059	2059	2060
656	561	1	applied	\N	\N	\N	\N	2061	2061	2062
657	560	0	applied	\N	\N	\N	\N	2059	2059	2060
657	561	1	applied	\N	\N	\N	\N	2061	2061	2062
658	562	0	applied	\N	\N	\N	\N	2066	2066	2067
659	562	0	applied	\N	\N	\N	\N	2066	2066	2067
660	563	0	applied	\N	\N	\N	\N	2070	2070	2071
660	564	1	applied	\N	\N	\N	\N	2072	2072	2073
660	565	2	applied	\N	\N	\N	\N	2074	2074	2075
660	566	3	applied	\N	\N	\N	\N	2076	2076	2077
661	563	0	applied	\N	\N	\N	\N	2070	2070	2071
661	564	1	applied	\N	\N	\N	\N	2072	2072	2073
661	565	2	applied	\N	\N	\N	\N	2074	2074	2075
661	566	3	applied	\N	\N	\N	\N	2076	2076	2077
662	563	0	applied	\N	\N	\N	\N	2070	2070	2071
662	564	1	applied	\N	\N	\N	\N	2072	2072	2073
662	565	2	applied	\N	\N	\N	\N	2074	2074	2075
662	566	3	applied	\N	\N	\N	\N	2076	2076	2077
663	567	0	applied	\N	\N	\N	\N	2082	2082	2083
664	567	0	applied	\N	\N	\N	\N	2082	2082	2083
665	568	0	applied	\N	\N	\N	\N	2088	2088	2089
666	568	0	applied	\N	\N	\N	\N	2088	2088	2089
667	569	0	applied	\N	\N	\N	\N	2092	2092	2093
668	569	0	applied	\N	\N	\N	\N	2092	2092	2093
669	570	0	applied	\N	\N	\N	\N	2097	2097	2098
669	571	1	applied	\N	\N	\N	\N	2099	2099	2100
670	572	0	applied	\N	\N	\N	\N	2102	2102	2103
670	573	1	applied	\N	\N	\N	\N	2104	2104	2105
670	574	2	applied	\N	\N	\N	\N	2106	2106	2107
670	575	3	applied	\N	\N	\N	\N	2108	2108	2109
670	576	4	applied	\N	\N	\N	\N	2110	2110	2111
670	577	5	applied	\N	\N	\N	\N	2112	2112	2113
671	578	0	applied	\N	\N	\N	\N	2116	2116	2117
672	578	0	applied	\N	\N	\N	\N	2116	2116	2117
673	579	0	applied	\N	\N	\N	\N	2118	2118	2119
674	580	0	applied	\N	\N	\N	\N	2120	2120	2121
675	580	0	applied	\N	\N	\N	\N	2120	2120	2121
676	581	0	applied	\N	\N	\N	\N	2124	2124	2125
676	582	1	applied	\N	\N	\N	\N	2126	2126	2127
676	583	2	applied	\N	\N	\N	\N	2128	2128	2129
676	584	3	applied	\N	\N	\N	\N	2130	2130	2131
676	585	4	applied	\N	\N	\N	\N	2132	2132	2133
677	586	0	applied	\N	\N	\N	\N	2136	2136	2137
678	586	0	applied	\N	\N	\N	\N	2136	2136	2137
679	587	0	applied	\N	\N	\N	\N	2142	2142	2143
679	588	1	applied	\N	\N	\N	\N	2144	2144	2145
680	587	0	applied	\N	\N	\N	\N	2142	2142	2143
680	588	1	applied	\N	\N	\N	\N	2144	2144	2145
681	589	0	applied	\N	\N	\N	\N	2149	2149	2143
681	590	1	applied	\N	\N	\N	\N	2150	2150	2151
682	591	0	applied	\N	\N	\N	\N	2154	2154	2155
683	592	0	applied	\N	\N	\N	\N	2156	2156	2157
684	592	0	applied	\N	\N	\N	\N	2156	2156	2157
685	593	0	applied	\N	\N	\N	\N	2162	2162	2163
686	593	0	applied	\N	\N	\N	\N	2162	2162	2163
687	594	0	applied	\N	\N	\N	\N	2168	2168	2169
687	595	1	applied	\N	\N	\N	\N	2170	2170	2171
688	594	0	applied	\N	\N	\N	\N	2168	2168	2169
688	595	1	applied	\N	\N	\N	\N	2170	2170	2171
689	596	0	applied	\N	\N	\N	\N	2175	2175	2176
691	596	0	applied	\N	\N	\N	\N	2175	2175	2176
692	596	0	applied	\N	\N	\N	\N	2175	2175	2176
695	598	0	applied	\N	\N	\N	\N	2187	2187	2188
706	610	0	applied	\N	\N	\N	\N	2229	2229	2230
711	616	0	applied	\N	\N	\N	\N	2247	2247	2248
714	616	0	applied	\N	\N	\N	\N	2247	2247	2248
690	596	0	applied	\N	\N	\N	\N	2175	2175	2176
693	597	0	applied	\N	\N	\N	\N	2183	2183	2184
696	598	0	applied	\N	\N	\N	\N	2187	2187	2188
697	599	0	applied	\N	\N	\N	\N	2194	2194	2195
697	600	1	applied	\N	\N	\N	\N	2196	2196	2197
701	603	0	applied	\N	\N	\N	\N	2206	2206	2207
702	604	0	applied	\N	\N	\N	\N	2211	2211	2212
702	605	1	applied	\N	\N	\N	\N	2213	2213	2214
702	606	2	applied	\N	\N	\N	\N	2215	2215	2216
705	609	0	applied	\N	\N	\N	\N	2225	2225	2226
708	614	0	applied	\N	\N	\N	\N	2241	2241	2242
709	615	0	applied	\N	\N	\N	\N	2243	2243	2244
712	587	0	applied	\N	\N	\N	\N	2142	2142	2143
712	589	1	applied	\N	\N	\N	\N	2149	2149	2143
712	518	2	applied	\N	\N	\N	\N	1888	1888	1889
712	519	3	applied	\N	\N	1000000000	\N	1890	1890	1891
712	556	4	applied	\N	\N	\N	\N	1187	1187	2040
694	598	0	applied	\N	\N	\N	\N	2187	2187	2188
698	599	0	applied	\N	\N	\N	\N	2194	2194	2195
698	600	1	applied	\N	\N	\N	\N	2196	2196	2197
699	601	0	applied	\N	\N	\N	\N	2201	2201	2202
699	602	1	applied	\N	\N	\N	\N	2203	2203	2204
700	603	0	applied	\N	\N	\N	\N	2206	2206	2207
703	604	0	applied	\N	\N	\N	\N	2211	2211	2212
703	605	1	applied	\N	\N	\N	\N	2213	2213	2214
703	606	2	applied	\N	\N	\N	\N	2215	2215	2216
704	607	0	applied	\N	\N	\N	\N	2220	2220	2221
704	608	1	applied	\N	\N	\N	\N	2222	2222	2223
707	611	0	applied	\N	\N	\N	\N	2233	2233	2234
707	612	1	applied	\N	\N	\N	\N	2235	2235	2236
707	613	2	applied	\N	\N	\N	\N	2237	2237	2238
710	615	0	applied	\N	\N	\N	\N	2243	2243	2244
713	587	0	applied	\N	\N	\N	\N	2142	2142	2143
713	589	1	applied	\N	\N	\N	\N	2149	2149	2143
713	556	2	applied	\N	\N	\N	\N	1187	1187	2040
717	617	0	applied	\N	\N	\N	\N	2256	2256	2257
717	618	1	applied	\N	\N	\N	\N	2258	2258	2259
717	619	2	applied	\N	\N	\N	\N	2260	2260	2261
718	620	0	applied	\N	\N	\N	\N	2264	2264	2265
718	621	1	applied	\N	\N	\N	\N	2266	2266	2267
718	622	2	applied	\N	\N	\N	\N	2268	2268	2269
719	623	0	failed	Receiver_not_present	\N	\N	\N	2272	2272	\N
719	624	1	applied	\N	\N	\N	\N	2273	2273	2274
720	623	0	failed	Receiver_not_present	\N	\N	\N	2272	2272	\N
720	624	1	applied	\N	\N	\N	\N	2273	2273	2274
721	625	0	failed	Receiver_not_present	\N	\N	\N	2278	2278	\N
721	626	1	applied	\N	\N	\N	\N	2279	2279	2280
721	627	2	applied	\N	\N	\N	\N	2281	2281	1435
722	628	0	applied	\N	\N	\N	\N	2283	2283	2284
723	628	0	applied	\N	\N	\N	\N	2283	2283	2284
724	629	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	2289	2289	\N
724	630	1	applied	\N	\N	\N	\N	2290	2290	2291
724	631	2	applied	\N	\N	\N	\N	2292	2292	2293
724	632	3	applied	\N	\N	\N	\N	2294	2294	2295
725	629	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	2289	2289	\N
725	630	1	applied	\N	\N	\N	\N	2290	2290	2291
725	631	2	applied	\N	\N	\N	\N	2292	2292	2293
725	632	3	applied	\N	\N	\N	\N	2294	2294	2295
726	633	0	applied	\N	\N	\N	\N	2297	2297	2298
727	633	0	applied	\N	\N	\N	\N	2297	2297	2298
728	634	0	applied	\N	\N	\N	\N	2302	2302	2303
728	635	1	applied	\N	\N	\N	\N	2304	2304	2305
729	636	0	applied	\N	\N	\N	\N	2308	2308	2309
730	637	0	applied	\N	\N	\N	\N	2312	2312	2313
731	638	0	applied	\N	\N	\N	\N	2316	2316	2317
732	638	0	applied	\N	\N	\N	\N	2316	2316	2317
733	639	0	applied	\N	\N	\N	\N	2321	2321	2322
734	639	0	applied	\N	\N	\N	\N	2321	2321	2322
735	640	0	applied	\N	\N	\N	\N	2327	2327	2328
736	641	0	applied	\N	\N	\N	\N	2331	2331	2332
736	642	1	applied	\N	\N	\N	\N	2333	2333	2334
737	643	0	applied	\N	\N	\N	\N	2337	2337	2338
738	643	0	applied	\N	\N	\N	\N	2337	2337	2338
739	643	0	applied	\N	\N	\N	\N	2337	2337	2338
740	643	0	applied	\N	\N	\N	\N	2337	2337	2338
741	644	0	applied	\N	\N	\N	\N	2345	2345	2346
741	645	1	applied	\N	\N	\N	\N	2347	2347	2348
742	646	0	applied	\N	\N	\N	\N	2350	2350	2351
743	647	0	applied	\N	\N	\N	\N	2354	2354	2355
743	648	1	applied	\N	\N	\N	\N	2356	2356	2357
744	649	0	applied	\N	\N	\N	\N	2359	2359	2360
745	649	0	applied	\N	\N	\N	\N	2359	2359	2360
746	649	0	applied	\N	\N	\N	\N	2359	2359	2360
747	650	0	applied	\N	\N	\N	\N	2367	2367	2368
748	650	0	applied	\N	\N	\N	\N	2367	2367	2368
749	651	0	applied	\N	\N	\N	\N	2373	2373	2374
750	651	0	applied	\N	\N	\N	\N	2373	2373	2374
751	651	0	applied	\N	\N	\N	\N	2373	2373	2374
752	652	0	applied	\N	\N	\N	\N	2377	2377	2378
753	652	0	applied	\N	\N	\N	\N	2377	2377	2378
754	653	0	applied	\N	\N	\N	\N	2381	2381	2382
755	653	0	applied	\N	\N	\N	\N	2381	2381	2382
756	654	0	applied	\N	\N	\N	\N	2385	2385	2386
756	655	1	applied	\N	\N	\N	\N	2387	2387	2388
757	654	0	applied	\N	\N	\N	\N	2385	2385	2386
757	655	1	applied	\N	\N	\N	\N	2387	2387	2388
758	656	0	applied	\N	\N	\N	\N	2391	2391	2392
759	656	0	applied	\N	\N	\N	\N	2391	2391	2392
760	656	0	applied	\N	\N	\N	\N	2391	2391	2392
761	656	0	applied	\N	\N	\N	\N	2391	2391	2392
762	587	0	applied	\N	\N	\N	\N	2142	2142	2143
762	589	1	applied	\N	\N	\N	\N	2149	2149	2143
762	625	2	failed	Receiver_not_present	\N	\N	\N	2278	2278	\N
762	623	3	failed	Receiver_not_present	\N	\N	\N	2272	2272	\N
762	629	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	2289	2289	\N
762	627	5	applied	\N	\N	\N	\N	2281	2281	1435
763	656	0	applied	\N	\N	\N	\N	2391	2391	2392
764	657	0	applied	\N	\N	\N	\N	2400	2400	2401
765	658	0	applied	\N	\N	\N	\N	2404	2404	2405
765	659	1	applied	\N	\N	1000000000	\N	2406	2406	2407
765	660	2	applied	\N	\N	\N	\N	2408	2408	2409
766	658	0	applied	\N	\N	\N	\N	2404	2404	2405
766	659	1	applied	\N	\N	1000000000	\N	2406	2406	2407
766	660	2	applied	\N	\N	\N	\N	2408	2408	2409
767	658	0	applied	\N	\N	\N	\N	2404	2404	2405
767	659	1	applied	\N	\N	1000000000	\N	2406	2406	2407
767	660	2	applied	\N	\N	\N	\N	2408	2408	2409
768	661	0	applied	\N	\N	\N	\N	2414	2414	2415
769	661	0	applied	\N	\N	\N	\N	2414	2414	2415
770	662	0	applied	\N	\N	\N	\N	2420	2420	2421
770	663	1	applied	\N	\N	\N	\N	2422	2422	2423
770	664	2	applied	\N	\N	\N	\N	2424	2424	2425
770	665	3	applied	\N	\N	\N	\N	2426	2426	2407
771	662	0	applied	\N	\N	\N	\N	2420	2420	2421
771	663	1	applied	\N	\N	\N	\N	2422	2422	2423
771	664	2	applied	\N	\N	\N	\N	2424	2424	2425
771	665	3	applied	\N	\N	\N	\N	2426	2426	2407
772	666	0	applied	\N	\N	\N	\N	2431	2431	2407
772	667	1	applied	\N	\N	\N	\N	2432	2432	2433
772	668	2	applied	\N	\N	\N	\N	2434	2434	2435
773	669	0	applied	\N	\N	\N	\N	2438	2438	2439
774	670	0	applied	\N	\N	\N	\N	2441	2441	2420
774	671	1	applied	\N	\N	\N	\N	2442	2442	2443
775	670	0	applied	\N	\N	\N	\N	2441	2441	2420
775	671	1	applied	\N	\N	\N	\N	2442	2442	2443
781	673	0	applied	\N	\N	\N	\N	2453	2453	2454
781	674	1	applied	\N	\N	\N	\N	2455	2455	2456
781	675	2	applied	\N	\N	\N	\N	2457	2457	2458
784	676	0	applied	\N	\N	\N	\N	2463	2463	2464
784	677	1	applied	\N	\N	\N	\N	2465	2465	2466
784	678	2	applied	\N	\N	\N	\N	2467	2467	2468
790	680	0	applied	\N	\N	\N	\N	2482	2482	2483
792	681	0	applied	\N	\N	\N	\N	2486	2486	2487
795	685	0	applied	\N	\N	\N	\N	2499	2499	2500
798	686	0	applied	\N	\N	\N	\N	2505	2505	2506
801	687	0	applied	\N	\N	\N	\N	2511	2511	2512
804	688	0	applied	\N	\N	\N	\N	2517	2517	2518
804	689	1	applied	\N	\N	\N	\N	2519	2519	2520
810	695	0	applied	\N	\N	\N	\N	2540	2540	2541
810	696	1	applied	\N	\N	\N	\N	2542	2542	2543
813	698	0	applied	\N	\N	\N	\N	2549	2549	2550
776	670	0	applied	\N	\N	\N	\N	2441	2441	2420
776	671	1	applied	\N	\N	\N	\N	2442	2442	2443
778	672	0	applied	\N	\N	\N	\N	2450	2450	2451
782	673	0	applied	\N	\N	\N	\N	2453	2453	2454
782	674	1	applied	\N	\N	\N	\N	2455	2455	2456
782	675	2	applied	\N	\N	\N	\N	2457	2457	2458
787	676	0	applied	\N	\N	\N	\N	2463	2463	2464
787	677	1	applied	\N	\N	\N	\N	2465	2465	2466
787	678	2	applied	\N	\N	\N	\N	2467	2467	2468
788	679	0	applied	\N	\N	\N	\N	2477	2477	2478
789	679	0	applied	\N	\N	\N	\N	2477	2477	2478
793	682	0	applied	\N	\N	\N	\N	2490	2490	2491
796	685	0	applied	\N	\N	\N	\N	2499	2499	2500
799	686	0	applied	\N	\N	\N	\N	2505	2505	2506
802	687	0	applied	\N	\N	\N	\N	2511	2511	2512
805	690	0	applied	\N	\N	\N	\N	2523	2523	2524
806	691	0	applied	\N	\N	\N	\N	2527	2527	2528
806	692	1	applied	\N	\N	\N	\N	2529	2529	2530
806	693	2	applied	\N	\N	\N	\N	2531	2531	2532
809	695	0	applied	\N	\N	\N	\N	2540	2540	2541
809	696	1	applied	\N	\N	\N	\N	2542	2542	2543
814	698	0	applied	\N	\N	\N	\N	2549	2549	2550
816	699	0	applied	\N	\N	\N	\N	2555	2555	2556
777	672	0	applied	\N	\N	\N	\N	2450	2450	2451
779	672	0	applied	\N	\N	\N	\N	2450	2450	2451
780	673	0	applied	\N	\N	\N	\N	2453	2453	2454
780	674	1	applied	\N	\N	\N	\N	2455	2455	2456
780	675	2	applied	\N	\N	\N	\N	2457	2457	2458
785	676	0	applied	\N	\N	\N	\N	2463	2463	2464
785	677	1	applied	\N	\N	\N	\N	2465	2465	2466
785	678	2	applied	\N	\N	\N	\N	2467	2467	2468
786	676	0	applied	\N	\N	\N	\N	2463	2463	2464
786	677	1	applied	\N	\N	\N	\N	2465	2465	2466
786	678	2	applied	\N	\N	\N	\N	2467	2467	2468
791	681	0	applied	\N	\N	\N	\N	2486	2486	2487
794	683	0	applied	\N	\N	\N	\N	2494	2494	2495
794	684	1	applied	\N	\N	\N	\N	2496	2496	2497
797	686	0	applied	\N	\N	\N	\N	2505	2505	2506
800	687	0	applied	\N	\N	\N	\N	2511	2511	2512
803	688	0	applied	\N	\N	\N	\N	2517	2517	2518
803	689	1	applied	\N	\N	\N	\N	2519	2519	2520
807	691	0	applied	\N	\N	\N	\N	2527	2527	2528
807	692	1	applied	\N	\N	\N	\N	2529	2529	2530
807	693	2	applied	\N	\N	\N	\N	2531	2531	2532
808	694	0	applied	\N	\N	\N	\N	2537	2537	2538
811	697	0	applied	\N	\N	\N	\N	2547	2547	2548
812	697	0	applied	\N	\N	\N	\N	2547	2547	2548
815	699	0	applied	\N	\N	\N	\N	2555	2555	2556
817	700	0	applied	\N	\N	\N	\N	2558	2558	2559
817	701	1	applied	\N	\N	\N	\N	2560	2560	2455
818	702	0	applied	\N	\N	\N	\N	2562	2562	2563
819	702	0	applied	\N	\N	\N	\N	2562	2562	2563
820	703	0	applied	\N	\N	\N	\N	2566	2566	2567
821	703	0	applied	\N	\N	\N	\N	2566	2566	2567
822	703	0	applied	\N	\N	\N	\N	2566	2566	2567
823	704	0	applied	\N	\N	\N	\N	2572	2572	2573
823	705	1	applied	\N	\N	\N	\N	2574	2574	2575
824	704	0	applied	\N	\N	\N	\N	2572	2572	2573
824	705	1	applied	\N	\N	\N	\N	2574	2574	2575
825	704	0	applied	\N	\N	\N	\N	2572	2572	2573
825	705	1	applied	\N	\N	\N	\N	2574	2574	2575
826	704	0	applied	\N	\N	\N	\N	2572	2572	2573
826	705	1	applied	\N	\N	\N	\N	2574	2574	2575
827	706	0	applied	\N	\N	\N	\N	2583	2583	2584
828	706	0	applied	\N	\N	\N	\N	2583	2583	2584
829	707	0	applied	\N	\N	\N	\N	2587	2587	2588
830	708	0	applied	\N	\N	\N	\N	2591	2591	2592
831	708	0	applied	\N	\N	\N	\N	2591	2591	2592
832	708	0	applied	\N	\N	\N	\N	2591	2591	2592
833	709	0	applied	\N	\N	\N	\N	2595	2595	2596
834	709	0	applied	\N	\N	\N	\N	2595	2595	2596
835	710	0	applied	\N	\N	\N	\N	2601	2601	2602
836	710	0	applied	\N	\N	\N	\N	2601	2601	2602
837	711	0	applied	\N	\N	\N	\N	2604	2604	2605
837	712	1	applied	\N	\N	\N	\N	2606	2606	2607
838	713	0	applied	\N	\N	\N	\N	2609	2609	2610
838	714	1	applied	\N	\N	\N	\N	2611	2611	2612
839	715	0	applied	\N	\N	\N	\N	2615	2615	2616
839	716	1	applied	\N	\N	\N	\N	2617	2617	2618
840	715	0	applied	\N	\N	\N	\N	2615	2615	2616
840	716	1	applied	\N	\N	\N	\N	2617	2617	2618
841	717	0	applied	\N	\N	\N	\N	2622	2622	2623
842	717	0	applied	\N	\N	\N	\N	2622	2622	2623
843	718	0	applied	\N	\N	\N	\N	2627	2627	2628
844	718	0	applied	\N	\N	\N	\N	2627	2627	2628
845	719	0	applied	\N	\N	\N	\N	2633	2633	2634
846	720	0	applied	\N	\N	\N	\N	2635	2635	2636
847	721	0	applied	\N	\N	\N	\N	2637	2637	2638
847	722	1	applied	\N	\N	\N	\N	2639	2639	2640
848	723	0	applied	\N	\N	\N	\N	2642	2642	2643
849	724	0	applied	\N	\N	\N	\N	2644	2644	2645
850	725	0	applied	\N	\N	\N	\N	2646	2646	2647
851	726	0	applied	\N	\N	\N	\N	2650	2650	2651
853	727	0	applied	\N	\N	\N	\N	2655	2655	2656
853	728	1	applied	\N	\N	\N	\N	2657	2657	2658
853	729	2	applied	\N	\N	\N	\N	2659	2659	2660
853	730	3	applied	\N	\N	\N	\N	2661	2661	2662
854	727	0	applied	\N	\N	\N	\N	2655	2655	2656
854	728	1	applied	\N	\N	\N	\N	2657	2657	2658
854	729	2	applied	\N	\N	\N	\N	2659	2659	2660
854	730	3	applied	\N	\N	\N	\N	2661	2661	2662
855	731	0	applied	\N	\N	\N	\N	2666	2666	2667
855	732	1	applied	\N	\N	\N	\N	2668	2668	2669
855	733	2	applied	\N	\N	\N	\N	2670	2670	2671
856	731	0	applied	\N	\N	\N	\N	2666	2666	2667
856	732	1	applied	\N	\N	\N	\N	2668	2668	2669
856	733	2	applied	\N	\N	\N	\N	2670	2670	2671
857	734	0	applied	\N	\N	\N	\N	2675	2675	2676
858	734	0	applied	\N	\N	\N	\N	2675	2675	2676
859	734	0	applied	\N	\N	\N	\N	2675	2675	2676
860	735	0	applied	\N	\N	\N	\N	2679	2679	2680
860	736	1	applied	\N	\N	\N	\N	2681	2681	2682
860	737	2	applied	\N	\N	\N	\N	2683	2683	2684
860	738	3	applied	\N	\N	\N	\N	2685	2685	2686
861	735	0	applied	\N	\N	\N	\N	2679	2679	2680
861	736	1	applied	\N	\N	\N	\N	2681	2681	2682
861	737	2	applied	\N	\N	\N	\N	2683	2683	2684
861	738	3	applied	\N	\N	\N	\N	2685	2685	2686
862	739	0	applied	\N	\N	\N	\N	2690	2690	2691
863	739	0	applied	\N	\N	\N	\N	2690	2690	2691
864	739	0	applied	\N	\N	\N	\N	2690	2690	2691
865	740	0	applied	\N	\N	\N	\N	2693	2693	2694
865	741	1	applied	\N	\N	\N	\N	2695	2695	2696
866	740	0	applied	\N	\N	\N	\N	2693	2693	2694
866	741	1	applied	\N	\N	\N	\N	2695	2695	2696
867	742	0	applied	\N	\N	\N	\N	2701	2701	2702
868	743	0	applied	\N	\N	\N	\N	2705	2705	2706
869	744	0	applied	\N	\N	\N	\N	2708	2708	2709
870	744	0	applied	\N	\N	\N	\N	2708	2708	2709
871	745	0	applied	\N	\N	\N	\N	2714	2714	2715
872	745	0	applied	\N	\N	\N	\N	2714	2714	2715
873	745	0	applied	\N	\N	\N	\N	2714	2714	2715
874	746	0	applied	\N	\N	\N	\N	2718	2718	2719
874	747	1	applied	\N	\N	\N	\N	2720	2720	2721
875	748	0	applied	\N	\N	\N	\N	2724	2724	2725
875	749	1	applied	\N	\N	\N	\N	2726	2726	2727
876	750	0	applied	\N	\N	\N	\N	2730	2730	2731
876	751	1	applied	\N	\N	\N	\N	2732	2732	2733
877	752	0	applied	\N	\N	\N	\N	2736	2736	2737
877	753	1	applied	\N	\N	\N	\N	2738	2738	2739
877	754	2	applied	\N	\N	\N	\N	2740	2740	2741
878	755	0	applied	\N	\N	\N	\N	2744	2744	2745
879	756	0	applied	\N	\N	\N	\N	2748	2748	2749
879	757	1	applied	\N	\N	\N	\N	2750	2750	2751
882	758	0	applied	\N	\N	\N	\N	2755	2755	2756
885	761	0	applied	\N	\N	\N	\N	2767	2767	1435
885	762	1	applied	\N	\N	\N	\N	2768	2768	2769
888	761	0	applied	\N	\N	\N	\N	2767	2767	1435
888	762	1	applied	\N	\N	\N	\N	2768	2768	2769
897	773	0	applied	\N	\N	\N	\N	2810	2810	2811
900	775	0	applied	\N	\N	\N	\N	2819	2819	2820
904	776	0	applied	\N	\N	\N	\N	2823	2823	2824
904	777	1	applied	\N	\N	\N	\N	2825	2825	2826
904	778	2	applied	\N	\N	\N	\N	2827	2827	2828
907	781	0	applied	\N	\N	\N	\N	2840	2840	2841
910	783	0	applied	\N	\N	\N	\N	2845	2845	2846
910	784	1	applied	\N	\N	\N	\N	2847	2847	2848
912	785	0	applied	\N	\N	\N	\N	2850	2850	2851
912	786	1	applied	\N	\N	\N	\N	2852	2852	2853
916	788	0	applied	\N	\N	1000000000	\N	2862	2862	2863
916	789	1	applied	\N	\N	\N	\N	2864	2864	2865
919	794	0	applied	\N	\N	\N	\N	2877	2877	2878
922	796	0	applied	\N	\N	\N	\N	2885	2885	2886
922	797	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	2887	2887	\N
925	800	0	applied	\N	\N	\N	\N	2898	2898	2899
927	800	0	applied	\N	\N	\N	\N	2898	2898	2899
880	756	0	applied	\N	\N	\N	\N	2748	2748	2749
880	757	1	applied	\N	\N	\N	\N	2750	2750	2751
883	759	0	applied	\N	\N	\N	\N	2761	2761	2762
887	761	0	applied	\N	\N	\N	\N	2767	2767	1435
887	762	1	applied	\N	\N	\N	\N	2768	2768	2769
889	763	0	applied	\N	\N	\N	\N	2778	2778	2779
891	764	0	applied	\N	\N	\N	\N	2781	2781	2782
891	765	1	applied	\N	\N	\N	\N	2783	2783	2784
891	766	2	applied	\N	\N	1000000000	\N	2785	2785	2786
894	767	0	applied	\N	\N	\N	\N	2792	2792	2793
895	768	0	applied	\N	\N	\N	\N	2798	2798	2799
895	769	1	applied	\N	\N	\N	\N	2800	2800	2801
895	770	2	applied	\N	\N	1000000000	\N	2802	2802	2803
896	771	0	applied	\N	\N	\N	\N	2806	2806	2807
896	772	1	applied	\N	\N	\N	\N	2808	2808	2809
899	774	0	applied	\N	\N	\N	\N	2814	2814	2815
902	776	0	applied	\N	\N	\N	\N	2823	2823	2824
902	777	1	applied	\N	\N	\N	\N	2825	2825	2826
902	778	2	applied	\N	\N	\N	\N	2827	2827	2828
905	779	0	applied	\N	\N	\N	\N	2834	2834	2835
905	780	1	applied	\N	\N	\N	\N	2836	2836	2837
908	782	0	applied	\N	\N	\N	\N	2843	2843	2844
911	785	0	applied	\N	\N	\N	\N	2850	2850	2851
911	786	1	applied	\N	\N	\N	\N	2852	2852	2853
913	785	0	applied	\N	\N	\N	\N	2850	2850	2851
913	786	1	applied	\N	\N	\N	\N	2852	2852	2853
914	787	0	applied	\N	\N	\N	\N	2860	2860	2861
917	790	0	applied	\N	\N	\N	\N	2867	2867	2868
917	791	1	applied	\N	\N	\N	\N	2869	2869	2870
917	792	2	applied	\N	\N	\N	\N	2871	2871	2872
917	793	3	applied	\N	\N	\N	\N	2873	2873	2874
918	794	0	applied	\N	\N	\N	\N	2877	2877	2878
921	795	0	applied	\N	\N	\N	\N	2881	2881	2882
881	758	0	applied	\N	\N	\N	\N	2755	2755	2756
884	760	0	applied	\N	\N	\N	\N	2763	2763	2764
886	761	0	applied	\N	\N	\N	\N	2767	2767	1435
886	762	1	applied	\N	\N	\N	\N	2768	2768	2769
890	764	0	applied	\N	\N	\N	\N	2781	2781	2782
890	765	1	applied	\N	\N	\N	\N	2783	2783	2784
890	766	2	applied	\N	\N	1000000000	\N	2785	2785	2786
892	764	0	applied	\N	\N	\N	\N	2781	2781	2782
892	765	1	applied	\N	\N	\N	\N	2783	2783	2784
892	766	2	applied	\N	\N	1000000000	\N	2785	2785	2786
893	767	0	applied	\N	\N	\N	\N	2792	2792	2793
898	774	0	applied	\N	\N	\N	\N	2814	2814	2815
901	775	0	applied	\N	\N	\N	\N	2819	2819	2820
903	776	0	applied	\N	\N	\N	\N	2823	2823	2824
903	777	1	applied	\N	\N	\N	\N	2825	2825	2826
903	778	2	applied	\N	\N	\N	\N	2827	2827	2828
906	779	0	applied	\N	\N	\N	\N	2834	2834	2835
906	780	1	applied	\N	\N	\N	\N	2836	2836	2837
909	782	0	applied	\N	\N	\N	\N	2843	2843	2844
915	788	0	applied	\N	\N	1000000000	\N	2862	2862	2863
915	789	1	applied	\N	\N	\N	\N	2864	2864	2865
920	794	0	applied	\N	\N	\N	\N	2877	2877	2878
923	798	0	applied	\N	\N	\N	\N	2890	2890	2891
924	799	0	applied	\N	\N	\N	\N	2894	2894	2895
926	800	0	applied	\N	\N	\N	\N	2898	2898	2899
928	801	0	applied	\N	\N	\N	\N	2902	2902	2903
929	801	0	applied	\N	\N	\N	\N	2902	2902	2903
930	802	0	applied	\N	\N	\N	\N	2906	2906	2907
930	803	1	applied	\N	\N	\N	\N	2908	2908	2909
931	802	0	applied	\N	\N	\N	\N	2906	2906	2907
931	803	1	applied	\N	\N	\N	\N	2908	2908	2909
932	804	0	applied	\N	\N	\N	\N	2913	2913	2914
932	805	1	applied	\N	\N	\N	\N	2915	2915	2916
933	804	0	applied	\N	\N	\N	\N	2913	2913	2914
933	805	1	applied	\N	\N	\N	\N	2915	2915	2916
934	806	0	applied	\N	\N	\N	\N	2918	2918	2919
935	806	0	applied	\N	\N	\N	\N	2918	2918	2919
936	806	0	applied	\N	\N	\N	\N	2918	2918	2919
937	807	0	applied	\N	\N	\N	\N	2926	2926	2927
938	808	0	applied	\N	\N	\N	\N	2930	2930	2931
939	809	0	applied	\N	\N	\N	\N	2932	2932	2933
940	809	0	applied	\N	\N	\N	\N	2932	2932	2933
941	809	0	applied	\N	\N	\N	\N	2932	2932	2933
942	810	0	applied	\N	\N	\N	\N	2936	2936	2937
942	811	1	applied	\N	\N	\N	\N	2938	2938	2939
942	812	2	applied	\N	\N	\N	\N	2940	2940	2941
943	813	0	applied	\N	\N	\N	\N	2944	2944	2945
944	813	0	applied	\N	\N	\N	\N	2944	2944	2945
945	814	0	applied	\N	\N	\N	\N	2946	2946	2947
946	815	0	applied	\N	\N	\N	\N	2948	2948	2949
946	816	1	applied	\N	\N	\N	\N	2950	2950	2951
947	817	0	applied	\N	\N	\N	\N	2954	2954	2955
948	817	0	applied	\N	\N	\N	\N	2954	2954	2955
949	818	0	applied	\N	\N	\N	\N	2958	2958	2959
950	819	0	applied	\N	\N	\N	\N	2962	2962	2963
950	820	1	applied	\N	\N	\N	\N	2964	2964	2965
951	819	0	applied	\N	\N	\N	\N	2962	2962	2963
951	820	1	applied	\N	\N	\N	\N	2964	2964	2965
952	821	0	applied	\N	\N	\N	\N	2970	2970	2971
952	822	1	applied	\N	\N	\N	\N	2972	2972	2973
953	823	0	applied	\N	\N	\N	\N	2976	2976	2977
954	823	0	applied	\N	\N	\N	\N	2976	2976	2977
955	823	0	applied	\N	\N	\N	\N	2976	2976	2977
956	824	0	applied	\N	\N	\N	\N	2980	2980	2981
956	825	1	applied	\N	\N	\N	\N	2982	2982	2983
956	826	2	applied	\N	\N	\N	\N	2984	2984	2985
957	827	0	applied	\N	\N	\N	\N	2988	2988	2989
958	827	0	applied	\N	\N	\N	\N	2988	2988	2989
959	828	0	applied	\N	\N	\N	\N	2993	2993	2994
959	829	1	applied	\N	\N	\N	\N	2995	2995	2996
959	830	2	applied	\N	\N	\N	\N	2997	2997	2998
959	831	3	applied	\N	\N	\N	\N	2999	2999	3000
959	832	4	applied	\N	\N	\N	\N	3001	3001	3002
959	833	5	applied	\N	\N	\N	\N	3003	3003	3004
960	828	0	applied	\N	\N	\N	\N	2993	2993	2994
960	829	1	applied	\N	\N	\N	\N	2995	2995	2996
960	830	2	applied	\N	\N	\N	\N	2997	2997	2998
960	831	3	applied	\N	\N	\N	\N	2999	2999	3000
960	832	4	applied	\N	\N	\N	\N	3001	3001	3002
960	833	5	applied	\N	\N	\N	\N	3003	3003	3004
961	834	0	applied	\N	\N	\N	\N	3008	3008	3009
961	835	1	applied	\N	\N	\N	\N	3010	3010	3011
962	834	0	applied	\N	\N	\N	\N	3008	3008	3009
962	835	1	applied	\N	\N	\N	\N	3010	3010	3011
963	834	0	applied	\N	\N	\N	\N	3008	3008	3009
963	835	1	applied	\N	\N	\N	\N	3010	3010	3011
964	836	0	applied	\N	\N	\N	\N	3017	3017	3018
964	837	1	applied	\N	\N	\N	\N	3019	3019	3020
965	838	0	applied	\N	\N	\N	\N	3021	3021	3022
966	838	0	applied	\N	\N	\N	\N	3021	3021	3022
967	839	0	applied	\N	\N	\N	\N	3027	3027	3028
968	839	0	applied	\N	\N	\N	\N	3027	3027	3028
969	839	0	applied	\N	\N	\N	\N	3027	3027	3028
970	840	0	applied	\N	\N	\N	\N	3031	3031	3032
971	840	0	applied	\N	\N	\N	\N	3031	3031	3032
972	841	0	applied	\N	\N	\N	\N	3037	3037	3038
973	841	0	applied	\N	\N	\N	\N	3037	3037	3038
974	841	0	applied	\N	\N	\N	\N	3037	3037	3038
975	842	0	applied	\N	\N	\N	\N	3043	3043	3044
976	842	0	applied	\N	\N	\N	\N	3043	3043	3044
977	842	0	applied	\N	\N	\N	\N	3043	3043	3044
978	843	0	applied	\N	\N	\N	\N	3047	3047	3048
979	844	0	applied	\N	\N	\N	\N	3051	3051	3052
980	844	0	applied	\N	\N	\N	\N	3051	3051	3052
981	844	0	applied	\N	\N	\N	\N	3051	3051	3052
982	844	0	applied	\N	\N	\N	\N	3051	3051	3052
983	845	0	applied	\N	\N	\N	\N	3058	3058	3059
984	845	0	applied	\N	\N	\N	\N	3058	3058	3059
985	846	0	applied	\N	\N	\N	\N	3060	3060	3061
986	846	0	applied	\N	\N	\N	\N	3060	3060	3061
987	846	0	applied	\N	\N	\N	\N	3060	3060	3061
988	846	0	applied	\N	\N	\N	\N	3060	3060	3061
989	847	0	applied	\N	\N	\N	\N	3068	3068	3069
990	847	0	applied	\N	\N	\N	\N	3068	3068	3069
991	847	0	applied	\N	\N	\N	\N	3068	3068	3069
992	847	0	applied	\N	\N	\N	\N	3068	3068	3069
993	848	0	applied	\N	\N	\N	\N	3074	3074	3075
994	848	0	applied	\N	\N	\N	\N	3074	3074	3075
995	849	0	applied	\N	\N	\N	\N	3078	3078	3079
996	849	0	applied	\N	\N	\N	\N	3078	3078	3079
1000	853	0	applied	\N	\N	\N	\N	3094	3094	3095
1003	855	0	applied	\N	\N	\N	\N	3102	3102	3103
1009	863	0	applied	\N	\N	\N	\N	3126	3126	3127
1011	863	0	applied	\N	\N	\N	\N	3126	3126	3127
1012	863	0	applied	\N	\N	\N	\N	3126	3126	3127
1012	864	1	applied	\N	\N	\N	\N	3133	3133	3134
1018	867	0	applied	\N	\N	\N	\N	3145	3145	3146
1021	870	0	applied	\N	\N	\N	\N	3156	3156	3157
1024	871	0	applied	\N	\N	\N	\N	3160	3160	3161
1027	874	0	applied	\N	\N	\N	\N	3169	3169	3170
1031	876	0	applied	\N	\N	\N	\N	3177	3177	3178
1032	877	0	applied	\N	\N	\N	\N	3183	3183	3184
1033	878	0	applied	\N	\N	\N	\N	3186	3186	3187
1036	881	0	applied	\N	\N	\N	\N	3196	3196	3197
1039	883	0	applied	\N	\N	\N	\N	3202	3202	3203
1042	884	0	applied	\N	\N	\N	\N	3204	3204	3205
1045	885	0	applied	\N	\N	\N	\N	3212	3212	3213
1047	886	0	applied	\N	\N	\N	\N	3218	3218	3219
1050	891	0	applied	\N	\N	\N	\N	3233	3233	3234
1050	892	1	applied	\N	\N	\N	\N	3235	3235	3236
1053	902	0	applied	\N	\N	\N	\N	3261	3261	3262
1053	903	1	applied	\N	\N	\N	\N	3263	3263	3264
1053	904	2	applied	\N	\N	\N	\N	3265	3265	3266
1053	905	3	applied	\N	\N	\N	\N	3267	3267	3268
1053	906	4	applied	\N	\N	\N	\N	3269	3269	3270
1053	907	5	applied	\N	\N	\N	\N	3271	3271	3272
1053	908	6	applied	\N	\N	\N	\N	3273	3273	3274
1053	909	7	applied	\N	\N	\N	\N	3275	3275	3276
1053	910	8	applied	\N	\N	\N	\N	3277	3277	3278
1053	911	9	applied	\N	\N	\N	\N	3279	3279	3280
1053	912	10	applied	\N	\N	\N	\N	3281	3281	3282
1053	913	11	applied	\N	\N	\N	\N	3283	3283	3284
1053	914	12	applied	\N	\N	\N	\N	3285	3285	3286
1053	915	13	applied	\N	\N	\N	\N	3287	3287	3288
1053	916	14	applied	\N	\N	\N	\N	3289	3289	3290
1053	917	15	applied	\N	\N	\N	\N	3291	3291	3292
1053	918	16	applied	\N	\N	\N	\N	3293	3293	3294
1053	919	17	applied	\N	\N	\N	\N	3295	3295	3296
1053	920	18	applied	\N	\N	\N	\N	3297	3297	3298
1053	921	19	applied	\N	\N	\N	\N	3299	3299	3300
1053	922	20	applied	\N	\N	\N	\N	3301	3301	3302
1053	923	21	applied	\N	\N	\N	\N	3303	3303	3304
1053	924	22	applied	\N	\N	\N	\N	3305	3305	3306
1053	925	23	applied	\N	\N	\N	\N	3307	3307	3308
1053	926	24	applied	\N	\N	\N	\N	3309	3309	3310
1053	927	25	applied	\N	\N	\N	\N	3311	3311	3312
1053	928	26	applied	\N	\N	\N	\N	3313	3313	3314
1053	929	27	applied	\N	\N	\N	\N	3315	3315	3316
1053	930	28	applied	\N	\N	\N	\N	3317	3317	3318
1053	931	29	applied	\N	\N	\N	\N	3319	3319	3320
1053	932	30	applied	\N	\N	\N	\N	3321	3321	3322
1053	933	31	applied	\N	\N	\N	\N	3323	3323	3324
1053	934	32	applied	\N	\N	\N	\N	3325	3325	3326
1053	935	33	applied	\N	\N	\N	\N	3327	3327	3328
1053	936	34	applied	\N	\N	\N	\N	3329	3329	3330
1053	937	35	applied	\N	\N	\N	\N	3331	3331	3332
997	850	0	applied	\N	\N	\N	\N	3082	3082	3083
1001	853	0	applied	\N	\N	\N	\N	3094	3094	3095
1002	854	0	applied	\N	\N	\N	\N	3100	3100	3101
1006	856	0	applied	\N	\N	\N	\N	3106	3106	3107
1007	856	0	applied	\N	\N	\N	\N	3106	3106	3107
1007	857	1	applied	\N	\N	\N	\N	3110	3110	3111
1008	858	0	applied	\N	\N	\N	\N	3114	3114	3115
1008	859	1	applied	\N	\N	\N	\N	3116	3116	3117
1008	860	2	applied	\N	\N	\N	\N	3118	3118	3119
1008	861	3	applied	\N	\N	\N	\N	3120	3120	3121
1008	862	4	applied	\N	\N	\N	\N	3122	3122	3123
1014	865	0	applied	\N	\N	\N	\N	3135	3135	3136
1017	867	0	applied	\N	\N	\N	\N	3145	3145	3146
1020	869	0	applied	\N	\N	\N	\N	3152	3152	3153
1023	871	0	applied	\N	\N	\N	\N	3160	3160	3161
1026	872	0	applied	\N	\N	\N	\N	3162	3162	3163
1026	873	1	applied	\N	\N	\N	\N	3164	3164	3165
1029	875	0	applied	\N	\N	\N	\N	3173	3173	3174
1030	876	0	applied	\N	\N	\N	\N	3177	3177	3178
1035	880	0	applied	\N	\N	\N	\N	3192	3192	3193
1040	883	0	applied	\N	\N	\N	\N	3202	3202	3203
1043	884	0	applied	\N	\N	\N	\N	3204	3204	3205
1046	886	0	applied	\N	\N	\N	\N	3218	3218	3219
1049	887	0	applied	\N	\N	\N	\N	3222	3222	3223
1049	888	1	applied	\N	\N	\N	\N	3224	3224	3225
1049	889	2	applied	\N	\N	\N	\N	3226	3226	3227
1049	890	3	applied	\N	\N	\N	\N	3228	3228	3229
1052	893	0	applied	\N	\N	\N	\N	3240	3240	3241
1052	894	1	applied	\N	\N	\N	\N	3242	3242	3243
1052	895	2	applied	\N	\N	\N	\N	3244	3244	3245
1052	896	3	applied	\N	\N	\N	\N	3246	3246	3247
1052	897	4	applied	\N	\N	\N	\N	3248	3248	3249
1052	898	5	applied	\N	\N	\N	\N	3250	3250	3251
1052	899	6	applied	\N	\N	\N	\N	3252	3252	3253
1052	900	7	applied	\N	\N	\N	\N	3254	3254	3255
1052	901	8	applied	\N	\N	\N	\N	3256	3256	3257
1055	902	0	applied	\N	\N	\N	\N	3261	3261	3262
1055	903	1	applied	\N	\N	\N	\N	3263	3263	3264
1055	904	2	applied	\N	\N	\N	\N	3265	3265	3266
1055	905	3	applied	\N	\N	\N	\N	3267	3267	3268
1055	906	4	applied	\N	\N	\N	\N	3269	3269	3270
1055	907	5	applied	\N	\N	\N	\N	3271	3271	3272
1055	908	6	applied	\N	\N	\N	\N	3273	3273	3274
1055	909	7	applied	\N	\N	\N	\N	3275	3275	3276
1055	910	8	applied	\N	\N	\N	\N	3277	3277	3278
1055	911	9	applied	\N	\N	\N	\N	3279	3279	3280
1055	912	10	applied	\N	\N	\N	\N	3281	3281	3282
1055	913	11	applied	\N	\N	\N	\N	3283	3283	3284
1055	914	12	applied	\N	\N	\N	\N	3285	3285	3286
1055	915	13	applied	\N	\N	\N	\N	3287	3287	3288
1055	916	14	applied	\N	\N	\N	\N	3289	3289	3290
1055	917	15	applied	\N	\N	\N	\N	3291	3291	3292
1055	918	16	applied	\N	\N	\N	\N	3293	3293	3294
1055	919	17	applied	\N	\N	\N	\N	3295	3295	3296
1055	920	18	applied	\N	\N	\N	\N	3297	3297	3298
1055	921	19	applied	\N	\N	\N	\N	3299	3299	3300
1055	922	20	applied	\N	\N	\N	\N	3301	3301	3302
1055	923	21	applied	\N	\N	\N	\N	3303	3303	3304
1055	924	22	applied	\N	\N	\N	\N	3305	3305	3306
1055	925	23	applied	\N	\N	\N	\N	3307	3307	3308
1055	926	24	applied	\N	\N	\N	\N	3309	3309	3310
1055	927	25	applied	\N	\N	\N	\N	3311	3311	3312
1055	928	26	applied	\N	\N	\N	\N	3313	3313	3314
1055	929	27	applied	\N	\N	\N	\N	3315	3315	3316
1055	930	28	applied	\N	\N	\N	\N	3317	3317	3318
1055	931	29	applied	\N	\N	\N	\N	3319	3319	3320
1055	932	30	applied	\N	\N	\N	\N	3321	3321	3322
1055	933	31	applied	\N	\N	\N	\N	3323	3323	3324
1055	934	32	applied	\N	\N	\N	\N	3325	3325	3326
1055	935	33	applied	\N	\N	\N	\N	3327	3327	3328
1055	936	34	applied	\N	\N	\N	\N	3329	3329	3330
1055	937	35	applied	\N	\N	\N	\N	3331	3331	3332
998	851	0	applied	\N	\N	\N	\N	3086	3086	3087
999	852	0	applied	\N	\N	\N	\N	3090	3090	3091
1004	855	0	applied	\N	\N	\N	\N	3102	3102	3103
1010	863	0	applied	\N	\N	\N	\N	3126	3126	3127
1013	864	0	applied	\N	\N	\N	\N	3133	3133	3134
1015	865	0	applied	\N	\N	\N	\N	3135	3135	3136
1016	866	0	applied	\N	\N	\N	\N	3141	3141	3142
1019	868	0	applied	\N	\N	\N	\N	3150	3150	3151
1022	870	0	applied	\N	\N	\N	\N	3156	3156	3157
1025	872	0	applied	\N	\N	\N	\N	3162	3162	3163
1025	873	1	applied	\N	\N	\N	\N	3164	3164	3165
1028	874	0	applied	\N	\N	\N	\N	3169	3169	3170
1034	879	0	applied	\N	\N	\N	\N	3190	3190	3191
1037	881	0	applied	\N	\N	\N	\N	3196	3196	3197
1038	882	0	applied	\N	\N	\N	\N	3200	3200	3201
1041	884	0	applied	\N	\N	\N	\N	3204	3204	3205
1044	885	0	applied	\N	\N	\N	\N	3212	3212	3213
1048	887	0	applied	\N	\N	\N	\N	3222	3222	3223
1048	888	1	applied	\N	\N	\N	\N	3224	3224	3225
1048	889	2	applied	\N	\N	\N	\N	3226	3226	3227
1048	890	3	applied	\N	\N	\N	\N	3228	3228	3229
1051	893	0	applied	\N	\N	\N	\N	3240	3240	3241
1051	894	1	applied	\N	\N	\N	\N	3242	3242	3243
1051	895	2	applied	\N	\N	\N	\N	3244	3244	3245
1051	896	3	applied	\N	\N	\N	\N	3246	3246	3247
1051	897	4	applied	\N	\N	\N	\N	3248	3248	3249
1051	898	5	applied	\N	\N	\N	\N	3250	3250	3251
1051	899	6	applied	\N	\N	\N	\N	3252	3252	3253
1051	900	7	applied	\N	\N	\N	\N	3254	3254	3255
1051	901	8	applied	\N	\N	\N	\N	3256	3256	3257
1054	902	0	applied	\N	\N	\N	\N	3261	3261	3262
1054	903	1	applied	\N	\N	\N	\N	3263	3263	3264
1054	904	2	applied	\N	\N	\N	\N	3265	3265	3266
1054	905	3	applied	\N	\N	\N	\N	3267	3267	3268
1054	906	4	applied	\N	\N	\N	\N	3269	3269	3270
1054	907	5	applied	\N	\N	\N	\N	3271	3271	3272
1054	908	6	applied	\N	\N	\N	\N	3273	3273	3274
1054	909	7	applied	\N	\N	\N	\N	3275	3275	3276
1054	910	8	applied	\N	\N	\N	\N	3277	3277	3278
1054	911	9	applied	\N	\N	\N	\N	3279	3279	3280
1054	912	10	applied	\N	\N	\N	\N	3281	3281	3282
1054	913	11	applied	\N	\N	\N	\N	3283	3283	3284
1054	914	12	applied	\N	\N	\N	\N	3285	3285	3286
1054	915	13	applied	\N	\N	\N	\N	3287	3287	3288
1054	916	14	applied	\N	\N	\N	\N	3289	3289	3290
1054	917	15	applied	\N	\N	\N	\N	3291	3291	3292
1054	918	16	applied	\N	\N	\N	\N	3293	3293	3294
1054	919	17	applied	\N	\N	\N	\N	3295	3295	3296
1054	920	18	applied	\N	\N	\N	\N	3297	3297	3298
1054	921	19	applied	\N	\N	\N	\N	3299	3299	3300
1054	922	20	applied	\N	\N	\N	\N	3301	3301	3302
1054	923	21	applied	\N	\N	\N	\N	3303	3303	3304
1054	924	22	applied	\N	\N	\N	\N	3305	3305	3306
1054	925	23	applied	\N	\N	\N	\N	3307	3307	3308
1054	926	24	applied	\N	\N	\N	\N	3309	3309	3310
1054	927	25	applied	\N	\N	\N	\N	3311	3311	3312
1054	928	26	applied	\N	\N	\N	\N	3313	3313	3314
1054	929	27	applied	\N	\N	\N	\N	3315	3315	3316
1054	930	28	applied	\N	\N	\N	\N	3317	3317	3318
1054	931	29	applied	\N	\N	\N	\N	3319	3319	3320
1054	932	30	applied	\N	\N	\N	\N	3321	3321	3322
1054	933	31	applied	\N	\N	\N	\N	3323	3323	3324
1054	934	32	applied	\N	\N	\N	\N	3325	3325	3326
1054	935	33	applied	\N	\N	\N	\N	3327	3327	3328
1054	936	34	applied	\N	\N	\N	\N	3329	3329	3330
1054	937	35	applied	\N	\N	\N	\N	3331	3331	3332
1056	938	0	applied	\N	\N	\N	\N	3337	3337	3338
1056	939	1	applied	\N	\N	\N	\N	3339	3339	3340
1056	940	2	applied	\N	\N	\N	\N	3341	3341	3342
1056	941	3	applied	\N	\N	\N	\N	3343	3343	3344
1056	942	4	applied	\N	\N	\N	\N	3345	3345	3346
1056	943	5	applied	\N	\N	\N	\N	3347	3347	3348
1056	944	6	applied	\N	\N	\N	\N	3349	3349	3350
1056	945	7	applied	\N	\N	\N	\N	3351	3351	3352
1056	946	8	applied	\N	\N	\N	\N	3353	3353	3354
1056	947	9	applied	\N	\N	\N	\N	3355	3355	3356
1056	948	10	applied	\N	\N	\N	\N	3357	3357	3358
1056	949	11	applied	\N	\N	\N	\N	3359	3359	3360
1056	950	12	applied	\N	\N	\N	\N	3361	3361	3362
1056	951	13	applied	\N	\N	\N	\N	3363	3363	3364
1056	952	14	applied	\N	\N	\N	\N	3365	3365	3366
1056	953	15	applied	\N	\N	\N	\N	3367	3367	3368
1056	954	16	applied	\N	\N	\N	\N	3369	3369	3370
1057	938	0	applied	\N	\N	\N	\N	3337	3337	3338
1057	939	1	applied	\N	\N	\N	\N	3339	3339	3340
1057	940	2	applied	\N	\N	\N	\N	3341	3341	3342
1057	941	3	applied	\N	\N	\N	\N	3343	3343	3344
1057	942	4	applied	\N	\N	\N	\N	3345	3345	3346
1057	943	5	applied	\N	\N	\N	\N	3347	3347	3348
1057	944	6	applied	\N	\N	\N	\N	3349	3349	3350
1057	945	7	applied	\N	\N	\N	\N	3351	3351	3352
1057	946	8	applied	\N	\N	\N	\N	3353	3353	3354
1057	947	9	applied	\N	\N	\N	\N	3355	3355	3356
1057	948	10	applied	\N	\N	\N	\N	3357	3357	3358
1057	949	11	applied	\N	\N	\N	\N	3359	3359	3360
1057	950	12	applied	\N	\N	\N	\N	3361	3361	3362
1057	951	13	applied	\N	\N	\N	\N	3363	3363	3364
1057	952	14	applied	\N	\N	\N	\N	3365	3365	3366
1057	953	15	applied	\N	\N	\N	\N	3367	3367	3368
1057	954	16	applied	\N	\N	\N	\N	3369	3369	3370
1058	938	0	applied	\N	\N	\N	\N	3337	3337	3338
1058	939	1	applied	\N	\N	\N	\N	3339	3339	3340
1058	940	2	applied	\N	\N	\N	\N	3341	3341	3342
1058	941	3	applied	\N	\N	\N	\N	3343	3343	3344
1058	942	4	applied	\N	\N	\N	\N	3345	3345	3346
1058	943	5	applied	\N	\N	\N	\N	3347	3347	3348
1058	944	6	applied	\N	\N	\N	\N	3349	3349	3350
1058	945	7	applied	\N	\N	\N	\N	3351	3351	3352
1058	946	8	applied	\N	\N	\N	\N	3353	3353	3354
1058	947	9	applied	\N	\N	\N	\N	3355	3355	3356
1058	948	10	applied	\N	\N	\N	\N	3357	3357	3358
1058	949	11	applied	\N	\N	\N	\N	3359	3359	3360
1058	950	12	applied	\N	\N	\N	\N	3361	3361	3362
1058	951	13	applied	\N	\N	\N	\N	3363	3363	3364
1058	952	14	applied	\N	\N	\N	\N	3365	3365	3366
1058	953	15	applied	\N	\N	\N	\N	3367	3367	3368
1058	954	16	applied	\N	\N	\N	\N	3369	3369	3370
1059	902	0	applied	\N	\N	\N	\N	3261	3261	3262
1059	891	1	applied	\N	\N	\N	\N	3233	3233	3234
1059	893	2	applied	\N	\N	\N	\N	3240	3240	3241
1059	894	3	applied	\N	\N	\N	\N	3242	3242	3243
1059	895	4	applied	\N	\N	\N	\N	3244	3244	3245
1059	896	5	applied	\N	\N	\N	\N	3246	3246	3247
1059	897	6	applied	\N	\N	\N	\N	3248	3248	3249
1059	898	7	applied	\N	\N	\N	\N	3250	3250	3251
1059	899	8	applied	\N	\N	\N	\N	3252	3252	3253
1059	900	9	applied	\N	\N	\N	\N	3254	3254	3255
1059	903	10	applied	\N	\N	\N	\N	3263	3263	3264
1059	904	11	applied	\N	\N	\N	\N	3265	3265	3266
1059	905	12	applied	\N	\N	\N	\N	3267	3267	3268
1059	906	13	applied	\N	\N	\N	\N	3269	3269	3270
1059	907	14	applied	\N	\N	\N	\N	3271	3271	3272
1059	908	15	applied	\N	\N	\N	\N	3273	3273	3274
1059	909	16	applied	\N	\N	\N	\N	3275	3275	3276
1059	910	17	applied	\N	\N	\N	\N	3277	3277	3278
1059	911	18	applied	\N	\N	\N	\N	3279	3279	3280
1059	912	19	applied	\N	\N	\N	\N	3281	3281	3282
1059	913	20	applied	\N	\N	\N	\N	3283	3283	3284
1059	914	21	applied	\N	\N	\N	\N	3285	3285	3286
1059	915	22	applied	\N	\N	\N	\N	3287	3287	3288
1059	916	23	applied	\N	\N	\N	\N	3289	3289	3290
1059	917	24	applied	\N	\N	\N	\N	3291	3291	3292
1059	918	25	applied	\N	\N	\N	\N	3293	3293	3294
1059	919	26	applied	\N	\N	\N	\N	3295	3295	3296
1059	920	27	applied	\N	\N	\N	\N	3297	3297	3298
1059	921	28	applied	\N	\N	\N	\N	3299	3299	3300
1059	922	29	applied	\N	\N	\N	\N	3301	3301	3302
1059	923	30	applied	\N	\N	\N	\N	3303	3303	3304
1059	924	31	applied	\N	\N	\N	\N	3305	3305	3306
1059	925	32	applied	\N	\N	\N	\N	3307	3307	3308
1059	926	33	applied	\N	\N	\N	\N	3309	3309	3310
1059	927	34	applied	\N	\N	\N	\N	3311	3311	3312
1059	928	35	applied	\N	\N	\N	\N	3313	3313	3314
1059	929	36	applied	\N	\N	\N	\N	3315	3315	3316
1059	930	37	applied	\N	\N	\N	\N	3317	3317	3318
1059	931	39	applied	\N	\N	\N	\N	3319	3319	3320
1059	932	40	applied	\N	\N	\N	\N	3321	3321	3322
1059	933	41	applied	\N	\N	\N	\N	3323	3323	3324
1059	934	42	applied	\N	\N	\N	\N	3325	3325	3326
1061	971	0	applied	\N	\N	\N	\N	3411	3411	3412
1061	972	1	applied	\N	\N	\N	\N	3413	3413	3414
1061	973	2	applied	\N	\N	\N	\N	3415	3415	3416
1066	977	0	applied	\N	\N	\N	\N	3429	3429	3430
1069	979	0	applied	\N	\N	\N	\N	3439	3439	3440
1072	979	0	applied	\N	\N	\N	\N	3439	3439	3440
1075	982	0	applied	\N	\N	\N	\N	3455	3455	3456
1078	985	0	applied	\N	\N	\N	\N	3466	3466	3467
1078	986	1	applied	\N	\N	\N	\N	3468	3468	3469
1078	987	2	applied	\N	\N	\N	\N	3470	3470	3471
1081	989	0	applied	\N	\N	\N	\N	3478	3478	3479
1082	990	0	applied	\N	\N	\N	\N	3482	3482	3483
1085	990	0	applied	\N	\N	\N	\N	3482	3482	3483
1088	991	0	applied	\N	\N	\N	\N	3491	3491	3492
1091	1009	0	applied	\N	\N	\N	\N	3532	3532	3533
1091	1010	1	applied	\N	\N	\N	\N	3534	3534	3535
1091	1011	2	applied	\N	\N	\N	\N	3536	3536	3537
1091	1012	3	applied	\N	\N	\N	\N	3538	3538	3539
1091	1013	4	applied	\N	\N	\N	\N	3540	3540	3541
1091	1014	5	applied	\N	\N	\N	\N	3542	3542	3543
1091	1015	6	applied	\N	\N	\N	\N	3544	3544	3545
1091	1016	7	applied	\N	\N	\N	\N	3546	3546	3547
1094	1027	0	applied	\N	\N	\N	\N	3574	3574	3575
1094	1028	1	applied	\N	\N	\N	\N	3576	3576	3577
1094	1029	2	applied	\N	\N	\N	\N	3578	3578	3579
1094	1030	3	applied	\N	\N	\N	\N	3580	3580	3581
1097	1031	0	applied	\N	\N	\N	\N	3588	3588	3589
1102	1034	0	applied	\N	\N	\N	\N	3598	3598	3599
1105	1035	0	applied	\N	\N	\N	\N	3600	3600	3601
1060	955	0	applied	\N	\N	\N	\N	3377	3377	3378
1060	956	1	applied	\N	\N	\N	\N	3379	3379	3380
1060	957	2	applied	\N	\N	\N	\N	3381	3381	3382
1060	958	3	applied	\N	\N	\N	\N	3383	3383	3384
1060	959	4	applied	\N	\N	\N	\N	3385	3385	3386
1060	960	5	applied	\N	\N	\N	\N	3387	3387	3388
1060	961	6	applied	\N	\N	\N	\N	3389	3389	3390
1060	962	7	applied	\N	\N	\N	\N	3391	3391	3392
1060	963	8	applied	\N	\N	\N	\N	3393	3393	3394
1060	964	9	applied	\N	\N	\N	\N	3395	3395	3396
1060	965	10	applied	\N	\N	\N	\N	3397	3397	3398
1060	966	11	applied	\N	\N	\N	\N	3399	3399	3400
1060	967	12	applied	\N	\N	\N	\N	3401	3401	3402
1060	968	13	applied	\N	\N	\N	\N	3403	3403	3404
1060	969	14	applied	\N	\N	\N	\N	3405	3405	3406
1060	970	15	applied	\N	\N	\N	\N	3407	3407	3408
1062	971	0	applied	\N	\N	\N	\N	3411	3411	3412
1062	972	1	applied	\N	\N	\N	\N	3413	3413	3414
1062	973	2	applied	\N	\N	\N	\N	3415	3415	3416
1063	971	0	applied	\N	\N	\N	\N	3411	3411	3412
1063	972	1	applied	\N	\N	\N	\N	3413	3413	3414
1063	973	2	applied	\N	\N	\N	\N	3415	3415	3416
1064	974	0	applied	\N	\N	\N	\N	3421	3421	3422
1064	975	1	applied	\N	\N	\N	\N	3423	3423	3424
1065	976	0	applied	\N	\N	\N	\N	3427	3427	3428
1067	977	0	applied	\N	\N	\N	\N	3429	3429	3430
1068	978	0	applied	\N	\N	\N	\N	3435	3435	3436
1070	979	0	applied	\N	\N	\N	\N	3439	3439	3440
1071	979	0	applied	\N	\N	\N	\N	3439	3439	3440
1073	980	0	applied	\N	\N	\N	\N	3449	3449	3450
1073	981	1	applied	\N	\N	\N	\N	3451	3451	3452
1074	980	0	applied	\N	\N	\N	\N	3449	3449	3450
1074	981	1	applied	\N	\N	\N	\N	3451	3451	3452
1076	983	0	applied	\N	\N	\N	\N	3458	3458	3459
1077	984	0	applied	\N	\N	\N	\N	3462	3462	3463
1079	985	0	applied	\N	\N	\N	\N	3466	3466	3467
1079	986	1	applied	\N	\N	\N	\N	3468	3468	3469
1079	987	2	applied	\N	\N	\N	\N	3470	3470	3471
1080	988	0	applied	\N	\N	\N	\N	3475	3475	3476
1083	990	0	applied	\N	\N	\N	\N	3482	3482	3483
1084	990	0	applied	\N	\N	\N	\N	3482	3482	3483
1086	991	0	applied	\N	\N	\N	\N	3491	3491	3492
1089	992	0	applied	\N	\N	\N	\N	3496	3496	3497
1089	993	1	applied	\N	\N	\N	\N	3498	3498	3499
1089	994	2	applied	\N	\N	\N	\N	3500	3500	3501
1089	995	3	applied	\N	\N	\N	\N	3502	3502	3503
1089	996	4	applied	\N	\N	\N	\N	3504	3504	3505
1089	997	5	applied	\N	\N	\N	\N	3506	3506	3507
1089	998	6	applied	\N	\N	\N	\N	3508	3508	3509
1089	999	7	applied	\N	\N	\N	\N	3510	3510	3511
1089	1000	8	applied	\N	\N	\N	\N	3512	3512	3513
1089	1001	9	applied	\N	\N	\N	\N	3514	3514	3515
1089	1002	10	applied	\N	\N	\N	\N	3516	3516	3517
1089	1003	11	applied	\N	\N	\N	\N	3518	3518	3519
1089	1004	12	applied	\N	\N	\N	\N	3520	3520	3521
1089	1005	13	applied	\N	\N	\N	\N	3522	3522	3523
1089	1006	14	applied	\N	\N	\N	\N	3524	3524	3525
1089	1007	15	applied	\N	\N	\N	\N	3526	3526	3527
1090	1008	0	applied	\N	\N	\N	\N	3530	3530	3531
1090	1009	1	applied	\N	\N	\N	\N	3532	3532	3533
1090	1010	2	applied	\N	\N	\N	\N	3534	3534	3535
1090	1011	3	applied	\N	\N	\N	\N	3536	3536	3537
1090	1012	4	applied	\N	\N	\N	\N	3538	3538	3539
1090	1013	5	applied	\N	\N	\N	\N	3540	3540	3541
1090	1014	6	applied	\N	\N	\N	\N	3542	3542	3543
1090	1015	7	applied	\N	\N	\N	\N	3544	3544	3545
1090	1016	8	applied	\N	\N	\N	\N	3546	3546	3547
1092	1008	0	applied	\N	\N	\N	\N	3530	3530	3531
1092	1009	1	applied	\N	\N	\N	\N	3532	3532	3533
1092	1010	2	applied	\N	\N	\N	\N	3534	3534	3535
1092	1011	3	applied	\N	\N	\N	\N	3536	3536	3537
1092	1012	4	applied	\N	\N	\N	\N	3538	3538	3539
1092	1013	5	applied	\N	\N	\N	\N	3540	3540	3541
1092	1014	6	applied	\N	\N	\N	\N	3542	3542	3543
1092	1015	7	applied	\N	\N	\N	\N	3544	3544	3545
1092	1016	8	applied	\N	\N	\N	\N	3546	3546	3547
1093	1017	0	applied	\N	\N	\N	\N	3552	3552	3553
1093	1018	1	applied	\N	\N	\N	\N	3554	3554	3555
1093	1019	2	applied	\N	\N	\N	\N	3556	3556	3557
1093	1020	3	applied	\N	\N	\N	\N	3558	3558	3559
1093	1021	4	applied	\N	\N	\N	\N	3560	3560	3561
1093	1022	5	applied	\N	\N	\N	\N	3562	3562	3563
1093	1023	6	applied	\N	\N	\N	\N	3564	3564	3565
1093	1024	7	applied	\N	\N	\N	\N	3566	3566	3567
1093	1025	8	applied	\N	\N	\N	\N	3568	3568	3569
1093	1026	9	applied	\N	\N	\N	\N	3570	3570	3571
1095	1027	0	applied	\N	\N	\N	\N	3574	3574	3575
1095	1028	1	applied	\N	\N	\N	\N	3576	3576	3577
1095	1029	2	applied	\N	\N	\N	\N	3578	3578	3579
1095	1030	3	applied	\N	\N	\N	\N	3580	3580	3581
1096	1027	0	applied	\N	\N	\N	\N	3574	3574	3575
1096	1028	1	applied	\N	\N	\N	\N	3576	3576	3577
1096	1029	2	applied	\N	\N	\N	\N	3578	3578	3579
1096	1030	3	applied	\N	\N	\N	\N	3580	3580	3581
1098	1031	0	applied	\N	\N	\N	\N	3588	3588	3589
1099	1031	0	applied	\N	\N	\N	\N	3588	3588	3589
1100	1032	0	applied	\N	\N	\N	\N	3592	3592	3593
1101	1033	0	applied	\N	\N	\N	\N	3596	3596	3597
1103	1034	0	applied	\N	\N	\N	\N	3598	3598	3599
1104	1035	0	applied	\N	\N	\N	\N	3600	3600	3601
1106	1036	0	applied	\N	\N	\N	\N	3605	3605	3606
1107	1036	0	applied	\N	\N	\N	\N	3605	3605	3606
1108	1037	0	applied	\N	\N	\N	\N	3611	3611	3612
1109	1037	0	applied	\N	\N	\N	\N	3611	3611	3612
1110	1037	0	applied	\N	\N	\N	\N	3611	3611	3612
1111	1037	0	applied	\N	\N	\N	\N	3611	3611	3612
1112	1038	0	applied	\N	\N	\N	\N	3621	3621	3622
1112	1039	1	applied	\N	\N	\N	\N	3623	3623	3624
1113	1038	0	applied	\N	\N	\N	\N	3621	3621	3622
1113	1039	1	applied	\N	\N	\N	\N	3623	3623	3624
1114	1038	0	applied	\N	\N	\N	\N	3621	3621	3622
1114	1039	1	applied	\N	\N	\N	\N	3623	3623	3624
1115	1040	0	applied	\N	\N	\N	\N	3628	3628	3629
1116	1040	0	applied	\N	\N	\N	\N	3628	3628	3629
1117	1041	0	applied	\N	\N	\N	\N	3634	3634	3635
1118	1041	0	applied	\N	\N	\N	\N	3634	3634	3635
1119	1042	0	applied	\N	\N	\N	\N	3637	3637	3638
1119	1043	1	applied	\N	\N	\N	\N	3639	3639	3640
1120	1042	0	applied	\N	\N	\N	\N	3637	3637	3638
1120	1043	1	applied	\N	\N	\N	\N	3639	3639	3640
1121	1042	0	applied	\N	\N	\N	\N	3637	3637	3638
1121	1043	1	applied	\N	\N	\N	\N	3639	3639	3640
1122	1044	0	applied	\N	\N	\N	\N	3644	3644	3645
1122	1045	1	applied	\N	\N	\N	\N	3646	3646	3647
1124	1046	0	applied	\N	\N	\N	\N	3650	3650	3651
1125	992	0	applied	\N	\N	\N	\N	3496	3496	3497
1125	977	1	applied	\N	\N	\N	\N	3429	3429	3430
1125	978	2	applied	\N	\N	\N	\N	3435	3435	3436
1125	979	3	applied	\N	\N	\N	\N	3439	3439	3440
1125	980	4	applied	\N	\N	\N	\N	3449	3449	3450
1125	981	5	applied	\N	\N	\N	\N	3451	3451	3452
1125	982	6	applied	\N	\N	\N	\N	3455	3455	3456
1125	983	7	applied	\N	\N	\N	\N	3458	3458	3459
1125	984	8	applied	\N	\N	\N	\N	3462	3462	3463
1125	985	9	applied	\N	\N	\N	\N	3466	3466	3467
1125	986	10	applied	\N	\N	\N	\N	3468	3468	3469
1125	987	11	applied	\N	\N	\N	\N	3470	3470	3471
1125	988	12	applied	\N	\N	\N	\N	3475	3475	3476
1125	993	13	applied	\N	\N	\N	\N	3498	3498	3499
1125	994	14	applied	\N	\N	\N	\N	3500	3500	3501
1125	995	15	applied	\N	\N	\N	\N	3502	3502	3503
1125	996	16	applied	\N	\N	\N	\N	3504	3504	3505
1125	997	17	applied	\N	\N	\N	\N	3506	3506	3507
1125	1000	18	applied	\N	\N	\N	\N	3512	3512	3513
1125	1001	19	applied	\N	\N	\N	\N	3514	3514	3515
1125	1002	20	applied	\N	\N	\N	\N	3516	3516	3517
1125	1003	21	applied	\N	\N	\N	\N	3518	3518	3519
1125	1004	22	applied	\N	\N	\N	\N	3520	3520	3521
1125	1005	23	applied	\N	\N	\N	\N	3522	3522	3523
1125	1006	24	applied	\N	\N	\N	\N	3524	3524	3525
1125	1007	25	applied	\N	\N	\N	\N	3526	3526	3527
1125	1009	26	applied	\N	\N	\N	\N	3532	3532	3533
1125	1010	27	applied	\N	\N	\N	\N	3534	3534	3535
1125	1011	29	applied	\N	\N	\N	\N	3536	3536	3537
1125	1012	30	applied	\N	\N	\N	\N	3538	3538	3539
1125	1013	31	applied	\N	\N	\N	\N	3540	3540	3541
1125	1014	32	applied	\N	\N	\N	\N	3542	3542	3543
1125	1015	33	applied	\N	\N	\N	\N	3544	3544	3545
1125	1016	34	applied	\N	\N	\N	\N	3546	3546	3547
1125	1018	35	applied	\N	\N	\N	\N	3554	3554	3555
1125	1019	36	applied	\N	\N	\N	\N	3556	3556	3557
1125	1020	37	applied	\N	\N	\N	\N	3558	3558	3559
1125	1021	38	applied	\N	\N	\N	\N	3560	3560	3561
1125	1022	39	applied	\N	\N	\N	\N	3562	3562	3563
1125	1023	40	applied	\N	\N	\N	\N	3564	3564	3565
1125	1024	41	applied	\N	\N	\N	\N	3566	3566	3567
1125	1025	42	applied	\N	\N	\N	\N	3568	3568	3569
1125	1026	43	applied	\N	\N	\N	\N	3570	3570	3571
1125	1028	44	applied	\N	\N	\N	\N	3576	3576	3577
1125	1029	45	applied	\N	\N	\N	\N	3578	3578	3579
1125	1030	46	applied	\N	\N	\N	\N	3580	3580	3581
1125	989	47	applied	\N	\N	\N	\N	3478	3478	3479
1125	990	48	applied	\N	\N	\N	\N	3482	3482	3483
1125	991	49	applied	\N	\N	\N	\N	3491	3491	3492
1125	998	50	applied	\N	\N	\N	\N	3508	3508	3509
1125	999	51	applied	\N	\N	\N	\N	3510	3510	3511
1125	1008	52	applied	\N	\N	\N	\N	3530	3530	3531
1125	1017	53	applied	\N	\N	\N	\N	3552	3552	3553
1125	1027	54	applied	\N	\N	\N	\N	3574	3574	3575
1125	1031	55	applied	\N	\N	\N	\N	3588	3588	3589
1125	1032	56	applied	\N	\N	\N	\N	3592	3592	3593
1125	1033	57	applied	\N	\N	\N	\N	3596	3596	3597
1125	1034	58	applied	\N	\N	\N	\N	3598	3598	3599
1125	1035	59	applied	\N	\N	\N	\N	3600	3600	3601
1125	1036	60	applied	\N	\N	\N	\N	3605	3605	3606
1125	1037	61	applied	\N	\N	\N	\N	3611	3611	3612
1125	1038	62	applied	\N	\N	\N	\N	3621	3621	3622
1125	1039	63	applied	\N	\N	\N	\N	3623	3623	3624
1125	1040	64	applied	\N	\N	\N	\N	3628	3628	3629
1125	1041	65	applied	\N	\N	\N	\N	3634	3634	3635
1125	1042	66	applied	\N	\N	\N	\N	3637	3637	3638
1125	1043	67	applied	\N	\N	\N	\N	3639	3639	3640
1125	1044	68	applied	\N	\N	\N	\N	3644	3644	3645
1125	1045	69	applied	\N	\N	\N	\N	3646	3646	3647
1125	1046	70	applied	\N	\N	\N	\N	3650	3650	3651
1128	1050	0	applied	\N	\N	\N	\N	3668	3668	3669
1131	1052	0	applied	\N	\N	\N	\N	3676	3676	3677
1134	1056	0	applied	\N	\N	\N	\N	3687	3687	3688
1134	1057	1	applied	\N	\N	\N	\N	3689	3689	3690
1137	1058	0	applied	\N	\N	\N	\N	3694	3694	3695
1138	1059	0	applied	\N	\N	\N	\N	3699	3699	3700
1141	1060	0	applied	\N	\N	\N	\N	3705	3705	3706
1144	1061	0	applied	\N	\N	\N	\N	3711	3711	3712
1147	1062	0	applied	\N	\N	\N	\N	3717	3717	3718
1150	1063	0	applied	\N	\N	\N	\N	3727	3727	3728
1153	1066	0	applied	\N	\N	\N	\N	3737	3737	3738
1153	1067	1	applied	\N	\N	\N	\N	3739	3739	3740
1153	1068	2	applied	\N	\N	\N	\N	3741	3741	3742
1156	1069	0	applied	\N	\N	\N	\N	3749	3749	3750
1159	1072	0	applied	\N	\N	\N	\N	3755	3755	3756
1162	1073	0	applied	\N	\N	\N	\N	3760	3760	3761
1162	1074	1	applied	\N	\N	\N	\N	3762	3762	3763
1165	1076	0	applied	\N	\N	\N	\N	3771	3771	3772
1165	1077	1	applied	\N	\N	\N	\N	3773	3773	3774
1170	1078	0	applied	\N	\N	\N	\N	3777	3777	3778
1171	1079	0	applied	\N	\N	\N	\N	3783	3783	3784
1176	1084	0	applied	\N	\N	\N	\N	3800	3800	3801
1179	1086	0	applied	\N	\N	\N	\N	3808	3808	3809
1179	1087	1	applied	\N	\N	\N	\N	3810	3810	3811
1182	1090	0	applied	\N	\N	\N	\N	3820	3820	3821
1186	1093	0	applied	\N	\N	\N	\N	3832	3832	3833
1186	1094	1	applied	\N	\N	\N	\N	3834	3834	3835
1186	1095	2	applied	\N	\N	\N	\N	1644	1644	3836
1187	1096	0	applied	\N	\N	\N	\N	3840	3840	3841
1187	1097	1	applied	\N	\N	\N	\N	3842	3842	3843
1187	1098	2	applied	\N	\N	\N	\N	3844	3844	3845
1190	1099	0	applied	\N	\N	\N	\N	3847	3847	3848
1193	1100	0	applied	\N	\N	\N	\N	3851	3851	3852
1193	1101	1	applied	\N	\N	\N	\N	3853	3853	3854
1196	1102	0	applied	\N	\N	\N	\N	3862	3862	3863
1199	1104	0	applied	\N	\N	\N	\N	3869	3869	3870
1204	1107	0	applied	\N	\N	\N	\N	3880	3880	3881
1207	1108	0	applied	\N	\N	\N	\N	3889	3889	3890
1207	1109	1	applied	\N	\N	\N	\N	3891	3891	3892
1208	1110	0	applied	\N	\N	\N	\N	3893	3893	3894
1211	1111	0	applied	\N	\N	\N	\N	3901	3901	3902
1214	1112	0	applied	\N	\N	\N	\N	3907	3907	3908
1215	1113	0	applied	\N	\N	\N	\N	3911	3911	3912
1215	1114	1	applied	\N	\N	\N	\N	3913	3913	3914
1215	1115	2	applied	\N	\N	\N	\N	3915	3915	3916
1123	1046	0	applied	\N	\N	\N	\N	3650	3650	3651
1126	1047	0	applied	\N	\N	\N	\N	3659	3659	3063
1126	1048	1	applied	\N	\N	\N	\N	3660	3660	3661
1127	1049	0	applied	\N	\N	\N	\N	3664	3664	3665
1130	1051	0	applied	\N	\N	\N	\N	3672	3672	3673
1135	1056	0	applied	\N	\N	\N	\N	3687	3687	3688
1135	1057	1	applied	\N	\N	\N	\N	3689	3689	3690
1140	1059	0	applied	\N	\N	\N	\N	3699	3699	3700
1143	1061	0	applied	\N	\N	\N	\N	3711	3711	3712
1146	1062	0	applied	\N	\N	\N	\N	3717	3717	3718
1149	1062	0	applied	\N	\N	\N	\N	3717	3717	3718
1152	1066	0	applied	\N	\N	\N	\N	3737	3737	3738
1152	1067	1	applied	\N	\N	\N	\N	3739	3739	3740
1152	1068	2	applied	\N	\N	\N	\N	3741	3741	3742
1157	1070	0	applied	\N	\N	\N	\N	3751	3751	3752
1160	1072	0	applied	\N	\N	\N	\N	3755	3755	3756
1163	1075	0	applied	\N	\N	\N	\N	3767	3767	3768
1168	1078	0	applied	\N	\N	\N	\N	3777	3777	3778
1172	1080	0	applied	\N	\N	\N	\N	3787	3787	3788
1175	1082	0	applied	\N	\N	\N	\N	3793	3793	3794
1175	1083	1	applied	\N	\N	\N	\N	3795	3795	3796
1180	1088	0	applied	\N	\N	\N	\N	3815	3815	3816
1183	1090	0	applied	\N	\N	\N	\N	3820	3820	3821
1192	1100	0	applied	\N	\N	\N	\N	3851	3851	3852
1192	1101	1	applied	\N	\N	\N	\N	3853	3853	3854
1195	1102	0	applied	\N	\N	\N	\N	3862	3862	3863
1198	1103	0	applied	\N	\N	\N	\N	3864	3864	3865
1201	1105	0	applied	\N	\N	\N	\N	3872	3872	3873
1202	1106	0	applied	\N	\N	\N	\N	3876	3876	3877
1205	1107	0	applied	\N	\N	\N	\N	3880	3880	3881
1217	1116	0	applied	\N	\N	\N	\N	3918	3918	3919
1220	1118	0	applied	\N	\N	\N	\N	3924	3924	3925
1223	1121	0	applied	\N	\N	\N	\N	3934	3934	3935
1223	1122	1	applied	\N	\N	\N	\N	3936	3936	3937
1223	1123	2	applied	\N	\N	\N	\N	3938	3938	3939
1226	1125	0	applied	\N	\N	\N	\N	3948	3948	3949
1229	1127	0	applied	\N	\N	\N	\N	3954	3954	3955
1232	1130	0	applied	\N	\N	\N	\N	3965	3965	3966
1235	1134	0	applied	\N	\N	\N	\N	3977	3977	3978
1129	1050	0	applied	\N	\N	\N	\N	3668	3668	3669
1132	1053	0	applied	\N	\N	\N	\N	3680	3680	3681
1132	1054	1	applied	\N	\N	\N	\N	3682	3682	3683
1133	1055	0	applied	\N	\N	\N	\N	3684	3684	3685
1136	1058	0	applied	\N	\N	\N	\N	3694	3694	3695
1139	1059	0	applied	\N	\N	\N	\N	3699	3699	3700
1142	1060	0	applied	\N	\N	\N	\N	3705	3705	3706
1145	1061	0	applied	\N	\N	\N	\N	3711	3711	3712
1148	1062	0	applied	\N	\N	\N	\N	3717	3717	3718
1151	1064	0	applied	\N	\N	\N	\N	3731	3731	3732
1151	1065	1	applied	\N	\N	\N	\N	3733	3733	3734
1154	1066	0	applied	\N	\N	\N	\N	3737	3737	3738
1154	1067	1	applied	\N	\N	\N	\N	3739	3739	3740
1154	1068	2	applied	\N	\N	\N	\N	3741	3741	3742
1155	1069	0	applied	\N	\N	\N	\N	3749	3749	3750
1158	1071	0	applied	\N	\N	\N	\N	3753	3753	3754
1161	1073	0	applied	\N	\N	\N	\N	3760	3760	3761
1161	1074	1	applied	\N	\N	\N	\N	3762	3762	3763
1164	1075	0	applied	\N	\N	\N	\N	3767	3767	3768
1166	1076	0	applied	\N	\N	\N	\N	3771	3771	3772
1166	1077	1	applied	\N	\N	\N	\N	3773	3773	3774
1167	1078	0	applied	\N	\N	\N	\N	3777	3777	3778
1169	1078	0	applied	\N	\N	\N	\N	3777	3777	3778
1173	1081	0	applied	\N	\N	\N	\N	3789	3789	3790
1174	1082	0	applied	\N	\N	\N	\N	3793	3793	3794
1174	1083	1	applied	\N	\N	\N	\N	3795	3795	3796
1177	1085	0	applied	\N	\N	\N	\N	3804	3804	3805
1178	1086	0	applied	\N	\N	\N	\N	3808	3808	3809
1178	1087	1	applied	\N	\N	\N	\N	3810	3810	3811
1181	1089	0	applied	\N	\N	\N	\N	3817	3817	3818
1184	1091	0	applied	\N	\N	\N	\N	3826	3826	3827
1184	1092	1	applied	\N	\N	\N	\N	3828	3828	3829
1185	1093	0	applied	\N	\N	\N	\N	3832	3832	3833
1185	1094	1	applied	\N	\N	\N	\N	3834	3834	3835
1185	1095	2	applied	\N	\N	\N	\N	1644	1644	3836
1191	1100	0	applied	\N	\N	\N	\N	3851	3851	3852
1191	1101	1	applied	\N	\N	\N	\N	3853	3853	3854
1194	1100	0	applied	\N	\N	\N	\N	3851	3851	3852
1194	1101	1	applied	\N	\N	\N	\N	3853	3853	3854
1197	1103	0	applied	\N	\N	\N	\N	3864	3864	3865
1200	1104	0	applied	\N	\N	\N	\N	3869	3869	3870
1203	1107	0	applied	\N	\N	\N	\N	3880	3880	3881
1206	1107	0	applied	\N	\N	\N	\N	3880	3880	3881
1209	1110	0	applied	\N	\N	\N	\N	3893	3893	3894
1210	1110	0	applied	\N	\N	\N	\N	3893	3893	3894
1212	1111	0	applied	\N	\N	\N	\N	3901	3901	3902
1213	1111	0	applied	\N	\N	\N	\N	3901	3901	3902
1216	1116	0	applied	\N	\N	\N	\N	3918	3918	3919
1218	1116	0	applied	\N	\N	\N	\N	3918	3918	3919
1219	1117	0	applied	\N	\N	\N	\N	3922	3922	3923
1222	1121	0	applied	\N	\N	\N	\N	3934	3934	3935
1222	1122	1	applied	\N	\N	\N	\N	3936	3936	3937
1222	1123	2	applied	\N	\N	\N	\N	3938	3938	3939
1227	1125	0	applied	\N	\N	\N	\N	3948	3948	3949
1228	1126	0	applied	\N	\N	\N	\N	3952	3952	3953
1231	1128	0	applied	\N	\N	\N	\N	3958	3958	3959
1231	1129	1	applied	\N	\N	\N	\N	3960	3960	3961
1221	1119	0	applied	\N	\N	\N	\N	3928	3928	3929
1221	1120	1	applied	\N	\N	\N	\N	3930	3930	3931
1224	1121	0	applied	\N	\N	\N	\N	3934	3934	3935
1224	1122	1	applied	\N	\N	\N	\N	3936	3936	3937
1224	1123	2	applied	\N	\N	\N	\N	3938	3938	3939
1225	1124	0	applied	\N	\N	\N	\N	3944	3944	3945
1230	1128	0	applied	\N	\N	\N	\N	3958	3958	3959
1230	1129	1	applied	\N	\N	\N	\N	3960	3960	3961
1233	1131	0	applied	\N	\N	\N	\N	3969	3969	3970
1234	1132	0	applied	\N	\N	\N	\N	3972	3972	3973
1234	1133	1	applied	\N	\N	\N	\N	3974	3974	3975
1236	1135	0	applied	\N	\N	\N	\N	3979	3979	3980
1237	1135	0	applied	\N	\N	\N	\N	3979	3979	3980
1238	1136	0	applied	\N	\N	\N	\N	3981	3981	3982
1239	1136	0	applied	\N	\N	\N	\N	3981	3981	3982
1240	1136	0	applied	\N	\N	\N	\N	3981	3981	3982
1241	1137	0	applied	\N	\N	\N	\N	3988	3988	3989
1242	1138	0	applied	\N	\N	\N	\N	3992	3992	3993
1243	1139	0	applied	\N	\N	\N	\N	3996	3996	3997
1244	1140	0	applied	\N	\N	\N	\N	3998	3998	3999
1245	1141	0	applied	\N	\N	\N	\N	4001	4001	4002
1246	1141	0	applied	\N	\N	\N	\N	4001	4001	4002
1247	1141	0	applied	\N	\N	\N	\N	4001	4001	4002
1248	1142	0	applied	\N	\N	\N	\N	4009	4009	4010
1249	1142	0	applied	\N	\N	\N	\N	4009	4009	4010
1250	1143	0	applied	\N	\N	\N	\N	4014	4014	4015
1251	1143	0	applied	\N	\N	\N	\N	4014	4014	4015
1252	1144	0	applied	\N	\N	\N	\N	4020	4020	4021
1252	1145	1	applied	\N	\N	\N	\N	4022	4022	4023
1253	1144	0	applied	\N	\N	\N	\N	4020	4020	4021
1253	1145	1	applied	\N	\N	\N	\N	4022	4022	4023
1255	1146	0	applied	\N	\N	\N	\N	4027	4027	4028
1256	1146	0	applied	\N	\N	\N	\N	4027	4027	4028
1257	1147	0	applied	\N	\N	\N	\N	4031	4031	4032
1258	1148	0	applied	\N	\N	\N	\N	4035	4035	4036
1258	1149	1	applied	\N	\N	\N	\N	4037	4037	4038
1258	1150	2	applied	\N	\N	\N	\N	4039	4039	4040
1258	1151	3	applied	\N	\N	\N	\N	4041	4041	4042
1259	1152	0	applied	\N	\N	\N	\N	4045	4045	4046
1260	1152	0	applied	\N	\N	\N	\N	4045	4045	4046
1261	1152	0	applied	\N	\N	\N	\N	4045	4045	4046
1262	1153	0	applied	\N	\N	\N	\N	4051	4051	4052
1262	1154	1	applied	\N	\N	\N	\N	4053	4053	4054
1262	1155	2	applied	\N	\N	\N	\N	4055	4055	4056
1262	1156	3	applied	\N	\N	\N	\N	4057	4057	4058
1263	1153	0	applied	\N	\N	\N	\N	4051	4051	4052
1263	1154	1	applied	\N	\N	\N	\N	4053	4053	4054
1263	1155	2	applied	\N	\N	\N	\N	4055	4055	4056
1263	1156	3	applied	\N	\N	\N	\N	4057	4057	4058
1264	1153	0	applied	\N	\N	\N	\N	4051	4051	4052
1264	1154	1	applied	\N	\N	\N	\N	4053	4053	4054
1264	1155	2	applied	\N	\N	\N	\N	4055	4055	4056
1264	1156	3	applied	\N	\N	\N	\N	4057	4057	4058
1265	1139	0	applied	\N	\N	\N	\N	3996	3996	3997
1265	1140	1	applied	\N	\N	\N	\N	3998	3998	3999
1265	1141	2	applied	\N	\N	\N	\N	4001	4001	4002
1265	1142	3	applied	\N	\N	\N	\N	4009	4009	4010
1265	1143	4	applied	\N	\N	\N	\N	4014	4014	4015
1265	1144	5	applied	\N	\N	\N	\N	4020	4020	4021
1265	1145	6	applied	\N	\N	\N	\N	4022	4022	4023
1265	1146	7	applied	\N	\N	\N	\N	4027	4027	4028
1265	1147	8	applied	\N	\N	\N	\N	4031	4031	4032
1265	1148	9	applied	\N	\N	\N	\N	4035	4035	4036
1265	1149	10	applied	\N	\N	\N	\N	4037	4037	4038
1265	1150	11	applied	\N	\N	\N	\N	4039	4039	4040
1265	1151	12	applied	\N	\N	\N	\N	4041	4041	4042
1265	1152	13	applied	\N	\N	\N	\N	4045	4045	4046
1265	1153	14	applied	\N	\N	\N	\N	4051	4051	4052
1265	1154	15	applied	\N	\N	\N	\N	4053	4053	4054
1265	1155	16	applied	\N	\N	\N	\N	4055	4055	4056
1265	1156	17	applied	\N	\N	\N	\N	4057	4057	4058
1265	1157	18	applied	\N	\N	\N	\N	4063	4063	4064
1266	1157	0	applied	\N	\N	\N	\N	4063	4063	4064
1266	1158	1	applied	\N	\N	\N	\N	4067	4067	4068
1266	1159	2	applied	\N	\N	\N	\N	4069	4069	4070
1267	1157	0	applied	\N	\N	\N	\N	4063	4063	4064
1267	1158	1	applied	\N	\N	\N	\N	4067	4067	4068
1267	1159	2	applied	\N	\N	\N	\N	4069	4069	4070
1268	1160	0	applied	\N	\N	\N	\N	4075	4075	4076
1269	1161	0	applied	\N	\N	\N	\N	4077	4077	4078
1270	1161	0	applied	\N	\N	\N	\N	4077	4077	4078
1271	1161	0	applied	\N	\N	\N	\N	4077	4077	4078
1272	1162	0	applied	\N	\N	\N	\N	4084	4084	4085
1273	1162	0	applied	\N	\N	\N	\N	4084	4084	4085
1274	1162	0	applied	\N	\N	\N	\N	4084	4084	4085
1275	1163	0	applied	\N	\N	\N	\N	4091	4091	4092
1276	1164	0	applied	\N	\N	\N	\N	4093	4093	4094
1277	1165	0	applied	\N	\N	\N	\N	4097	4097	4098
1278	1165	0	applied	\N	\N	\N	\N	4097	4097	4098
1279	1166	0	applied	\N	\N	\N	\N	4101	4101	4102
1280	1167	0	applied	\N	\N	\N	\N	4104	4104	4105
1281	1168	0	applied	\N	\N	\N	\N	4108	4108	4109
1282	1169	0	applied	\N	\N	\N	\N	4111	4111	4112
1283	1169	0	applied	\N	\N	\N	\N	4111	4111	4112
1284	1169	0	applied	\N	\N	\N	\N	4111	4111	4112
1285	1169	0	applied	\N	\N	\N	\N	4111	4111	4112
1286	1169	0	applied	\N	\N	\N	\N	4111	4111	4112
1287	1170	0	applied	\N	\N	\N	\N	4119	4119	4120
1288	1171	0	applied	\N	\N	\N	\N	4121	4121	4122
1288	1172	1	applied	\N	\N	\N	\N	4123	4123	4124
1289	1173	0	applied	\N	\N	\N	\N	4125	4125	4126
1290	1173	0	applied	\N	\N	\N	\N	4125	4125	4126
1291	1174	0	applied	\N	\N	\N	\N	4127	4127	4128
1292	1174	0	applied	\N	\N	\N	\N	4127	4127	4128
1293	1175	0	applied	\N	\N	\N	\N	4131	4131	4132
1293	1176	1	applied	\N	\N	\N	\N	4133	4133	4134
1294	1175	0	applied	\N	\N	\N	\N	4131	4131	4132
1294	1176	1	applied	\N	\N	\N	\N	4133	4133	4134
1295	1177	0	applied	\N	\N	\N	\N	4136	4136	4137
1296	1178	0	applied	\N	\N	\N	\N	4140	4140	4141
1296	1179	1	applied	\N	\N	\N	\N	4142	4142	4143
1296	1180	2	applied	\N	\N	\N	\N	4144	4144	4145
1296	1181	3	applied	\N	\N	\N	\N	4146	4146	4147
1297	1178	0	applied	\N	\N	\N	\N	4140	4140	4141
1297	1179	1	applied	\N	\N	\N	\N	4142	4142	4143
1297	1180	2	applied	\N	\N	\N	\N	4144	4144	4145
1297	1181	3	applied	\N	\N	\N	\N	4146	4146	4147
1298	1178	0	applied	\N	\N	\N	\N	4140	4140	4141
1298	1179	1	applied	\N	\N	\N	\N	4142	4142	4143
1298	1180	2	applied	\N	\N	\N	\N	4144	4144	4145
1298	1181	3	applied	\N	\N	\N	\N	4146	4146	4147
1300	1178	0	applied	\N	\N	\N	\N	4140	4140	4141
1300	1179	1	applied	\N	\N	\N	\N	4142	4142	4143
1300	1180	2	applied	\N	\N	\N	\N	4144	4144	4145
1300	1181	3	applied	\N	\N	\N	\N	4146	4146	4147
1302	1182	0	applied	\N	\N	\N	\N	4155	4155	4156
1303	1183	0	applied	\N	\N	\N	\N	4161	4161	4162
1303	1184	1	applied	\N	\N	\N	\N	4163	4163	4164
1303	1185	2	applied	\N	\N	\N	\N	4165	4165	4166
1311	1191	0	applied	\N	\N	\N	\N	4181	4181	4182
1317	1194	0	applied	\N	\N	\N	\N	4193	4193	4194
1319	1195	0	applied	\N	\N	\N	\N	4195	4195	4196
1320	1196	0	applied	\N	\N	\N	\N	4199	4199	4200
1320	1197	1	applied	\N	\N	\N	\N	4201	4201	4202
1320	1198	2	applied	\N	\N	\N	\N	4203	4203	4204
1320	1199	3	applied	\N	\N	\N	\N	4205	4205	4206
1320	1200	4	applied	\N	\N	\N	\N	4207	4207	4208
1326	1204	0	applied	\N	\N	\N	\N	4222	4222	4223
1326	1205	1	applied	\N	\N	\N	\N	4224	4224	4225
1326	1206	2	applied	\N	\N	\N	\N	4226	4226	4227
1329	1208	0	applied	\N	\N	\N	\N	4232	4232	4233
1331	1209	0	applied	\N	\N	\N	\N	4237	4237	4238
1332	1210	0	applied	\N	\N	\N	\N	4241	4241	4242
1343	1217	0	applied	\N	\N	\N	\N	4277	4277	4278
1346	1218	0	applied	\N	\N	\N	\N	4281	4281	4282
1348	1218	0	applied	\N	\N	\N	\N	4281	4281	4282
1352	1220	0	applied	\N	\N	\N	\N	4292	4292	4293
1358	1227	0	applied	\N	\N	\N	\N	4313	4313	4314
1361	1228	0	applied	\N	\N	\N	\N	4319	4319	4320
1363	1229	0	applied	\N	\N	\N	\N	4323	4323	4324
1363	1230	1	applied	\N	\N	\N	\N	4325	4325	4326
1364	1229	0	applied	\N	\N	\N	\N	4323	4323	4324
1364	1230	1	applied	\N	\N	\N	\N	4325	4325	4326
1370	1234	0	applied	\N	\N	\N	\N	4341	4341	4342
1299	1178	0	applied	\N	\N	\N	\N	4140	4140	4141
1299	1179	1	applied	\N	\N	\N	\N	4142	4142	4143
1299	1180	2	applied	\N	\N	\N	\N	4144	4144	4145
1299	1181	3	applied	\N	\N	\N	\N	4146	4146	4147
1305	1187	0	applied	\N	\N	\N	\N	4171	4171	4172
1306	1188	0	applied	\N	\N	\N	\N	4173	4173	4174
1306	1189	1	applied	\N	\N	\N	\N	4175	4175	4176
1306	1190	2	applied	\N	\N	\N	\N	4177	4177	4178
1312	1192	0	applied	\N	\N	\N	\N	4187	4187	4188
1314	1193	0	applied	\N	\N	\N	\N	4189	4189	4190
1318	1195	0	applied	\N	\N	\N	\N	4195	4195	4196
1324	1201	0	applied	\N	\N	\N	\N	4212	4212	4213
1324	1202	1	applied	\N	\N	\N	\N	4214	4214	4215
1324	1203	2	applied	\N	\N	1000000000	\N	4216	4216	4217
1327	1207	0	applied	\N	\N	\N	\N	4230	4230	4231
1330	1209	0	applied	\N	\N	\N	\N	4237	4237	4238
1333	1210	0	applied	\N	\N	\N	\N	4241	4241	4242
1336	1213	0	applied	\N	\N	\N	\N	4257	4257	4258
1339	1212	0	applied	\N	\N	\N	\N	4253	4253	4254
1339	1213	1	applied	\N	\N	\N	\N	4257	4257	4258
1339	1214	2	applied	\N	\N	\N	\N	4261	4261	4262
1344	1215	0	applied	\N	\N	\N	\N	4269	4269	4270
1344	1216	1	applied	\N	\N	\N	\N	4273	4273	4274
1344	1217	2	applied	\N	\N	\N	\N	4277	4277	4278
1349	1218	0	applied	\N	\N	\N	\N	4281	4281	4282
1353	1220	0	applied	\N	\N	\N	\N	4292	4292	4293
1355	1221	0	applied	\N	\N	\N	\N	4296	4296	4297
1355	1222	1	applied	\N	\N	\N	\N	4298	4298	4299
1356	1223	0	applied	\N	\N	\N	\N	4304	4304	4305
1356	1224	1	applied	\N	\N	\N	\N	4306	4306	4307
1356	1225	2	applied	\N	\N	\N	\N	4308	4308	4309
1356	1226	3	applied	\N	\N	\N	\N	4310	4310	4311
1357	1227	0	applied	\N	\N	\N	\N	4313	4313	4314
1360	1228	0	applied	\N	\N	\N	\N	4319	4319	4320
1367	1232	0	applied	\N	\N	\N	\N	4333	4333	4334
1368	1233	0	applied	\N	\N	\N	\N	4337	4337	4338
1301	1182	0	applied	\N	\N	\N	\N	4155	4155	4156
1304	1186	0	applied	\N	\N	\N	\N	4169	4169	4170
1310	1191	0	applied	\N	\N	\N	\N	4181	4181	4182
1313	1193	0	applied	\N	\N	\N	\N	4189	4189	4190
1315	1193	0	applied	\N	\N	\N	\N	4189	4189	4190
1316	1194	0	applied	\N	\N	\N	\N	4193	4193	4194
1321	1196	0	applied	\N	\N	\N	\N	4199	4199	4200
1321	1197	1	applied	\N	\N	\N	\N	4201	4201	4202
1321	1198	2	applied	\N	\N	\N	\N	4203	4203	4204
1321	1199	3	applied	\N	\N	\N	\N	4205	4205	4206
1321	1200	4	applied	\N	\N	\N	\N	4207	4207	4208
1325	1201	0	applied	\N	\N	\N	\N	4212	4212	4213
1325	1202	1	applied	\N	\N	\N	\N	4214	4214	4215
1325	1203	2	applied	\N	\N	1000000000	\N	4216	4216	4217
1328	1208	0	applied	\N	\N	\N	\N	4232	4232	4233
1334	1158	0	applied	\N	\N	\N	\N	4067	4067	4068
1334	1159	1	applied	\N	\N	\N	\N	4069	4069	4070
1334	1160	2	applied	\N	\N	\N	\N	4075	4075	4076
1334	1161	3	applied	\N	\N	\N	\N	4077	4077	4078
1334	1162	4	applied	\N	\N	\N	\N	4084	4084	4085
1334	1163	5	applied	\N	\N	\N	\N	4091	4091	4092
1334	1164	6	applied	\N	\N	\N	\N	4093	4093	4094
1334	1165	7	applied	\N	\N	\N	\N	4097	4097	4098
1334	1166	8	applied	\N	\N	\N	\N	4101	4101	4102
1334	1167	9	applied	\N	\N	\N	\N	4104	4104	4105
1334	1168	10	applied	\N	\N	\N	\N	4108	4108	4109
1334	1169	11	applied	\N	\N	\N	\N	4111	4111	4112
1334	1170	12	applied	\N	\N	\N	\N	4119	4119	4120
1334	1176	13	applied	\N	\N	\N	\N	4133	4133	4134
1334	1171	14	applied	\N	\N	\N	\N	4121	4121	4122
1334	1172	15	applied	\N	\N	\N	\N	4123	4123	4124
1334	1173	16	applied	\N	\N	\N	\N	4125	4125	4126
1334	1174	17	applied	\N	\N	\N	\N	4127	4127	4128
1334	1175	18	applied	\N	\N	\N	\N	4131	4131	4132
1334	1177	19	applied	\N	\N	\N	\N	4136	4136	4137
1334	1178	20	applied	\N	\N	\N	\N	4140	4140	4141
1334	1179	21	applied	\N	\N	\N	\N	4142	4142	4143
1334	1180	22	applied	\N	\N	\N	\N	4144	4144	4145
1334	1181	23	applied	\N	\N	\N	\N	4146	4146	4147
1334	1182	24	applied	\N	\N	\N	\N	4155	4155	4156
1334	1183	25	applied	\N	\N	\N	\N	4161	4161	4162
1334	1184	26	applied	\N	\N	\N	\N	4163	4163	4164
1334	1186	27	applied	\N	\N	\N	\N	4169	4169	4170
1334	1187	28	applied	\N	\N	\N	\N	4171	4171	4172
1334	1188	29	applied	\N	\N	\N	\N	4173	4173	4174
1334	1189	30	applied	\N	\N	\N	\N	4175	4175	4176
1334	1191	31	applied	\N	\N	\N	\N	4181	4181	4182
1334	1192	32	applied	\N	\N	\N	\N	4187	4187	4188
1334	1193	33	applied	\N	\N	\N	\N	4189	4189	4190
1334	1194	34	applied	\N	\N	\N	\N	4193	4193	4194
1334	1195	36	applied	\N	\N	\N	\N	4195	4195	4196
1334	1196	37	applied	\N	\N	\N	\N	4199	4199	4200
1334	1197	38	applied	\N	\N	\N	\N	4201	4201	4202
1334	1198	39	applied	\N	\N	\N	\N	4203	4203	4204
1334	1199	40	applied	\N	\N	\N	\N	4205	4205	4206
1334	1200	41	applied	\N	\N	\N	\N	4207	4207	4208
1334	1201	42	applied	\N	\N	\N	\N	4212	4212	4213
1334	1202	43	applied	\N	\N	\N	\N	4214	4214	4215
1334	1204	44	applied	\N	\N	\N	\N	4222	4222	4223
1334	1205	45	applied	\N	\N	\N	\N	4224	4224	4225
1334	1206	46	applied	\N	\N	\N	\N	4226	4226	4227
1334	1207	47	applied	\N	\N	\N	\N	4230	4230	4231
1334	1208	48	applied	\N	\N	\N	\N	4232	4232	4233
1334	1209	49	applied	\N	\N	\N	\N	4237	4237	4238
1334	1210	50	applied	\N	\N	\N	\N	4241	4241	4242
1334	1211	51	applied	\N	\N	\N	\N	4248	4248	4249
1334	1185	52	applied	\N	\N	\N	\N	4165	4165	4166
1334	1203	53	applied	\N	\N	1000000000	\N	4250	4250	4217
1334	1190	54	applied	\N	\N	\N	\N	4177	4177	4216
1335	1211	0	applied	\N	\N	\N	\N	4248	4248	4249
1335	1212	1	applied	\N	\N	\N	\N	4253	4253	4254
1337	1213	0	applied	\N	\N	\N	\N	4257	4257	4258
1338	1214	0	applied	\N	\N	\N	\N	4261	4261	4262
1340	1214	0	applied	\N	\N	\N	\N	4261	4261	4262
1341	1215	0	applied	\N	\N	\N	\N	4269	4269	4270
1342	1216	0	applied	\N	\N	\N	\N	4273	4273	4274
1345	1217	0	applied	\N	\N	\N	\N	4277	4277	4278
1347	1218	0	applied	\N	\N	\N	\N	4281	4281	4282
1350	1218	0	applied	\N	\N	\N	\N	4281	4281	4282
1351	1219	0	applied	\N	\N	\N	\N	4288	4288	4289
1354	1221	0	applied	\N	\N	\N	\N	4296	4296	4297
1354	1222	1	applied	\N	\N	\N	\N	4298	4298	4299
1359	1227	0	applied	\N	\N	\N	\N	4313	4313	4314
1362	1229	0	applied	\N	\N	\N	\N	4323	4323	4324
1362	1230	1	applied	\N	\N	\N	\N	4325	4325	4326
1365	1231	0	applied	\N	\N	\N	\N	4331	4331	4332
1366	1232	0	applied	\N	\N	\N	\N	4333	4333	4334
1369	1233	0	applied	\N	\N	\N	\N	4337	4337	4338
1371	1234	0	applied	\N	\N	\N	\N	4341	4341	4342
1372	1235	0	applied	\N	\N	\N	\N	4344	4344	4345
1373	1235	0	applied	\N	\N	\N	\N	4344	4344	4345
1374	1236	0	applied	\N	\N	\N	\N	4348	4348	4349
1374	1237	1	applied	\N	\N	\N	\N	4350	4350	4351
1375	1238	0	applied	\N	\N	\N	\N	4354	4354	4355
1376	1238	0	applied	\N	\N	\N	\N	4354	4354	4355
1377	1238	0	applied	\N	\N	\N	\N	4354	4354	4355
1378	1239	0	applied	\N	\N	\N	\N	4362	4362	4363
1379	1240	0	applied	\N	\N	\N	\N	4366	4366	2040
1379	1241	1	applied	\N	\N	\N	\N	4367	4367	4368
1379	1242	2	applied	\N	\N	\N	\N	4369	4369	4370
1380	1240	0	applied	\N	\N	\N	\N	4366	4366	2040
1380	1218	1	applied	\N	\N	\N	\N	4281	4281	4282
1380	1219	2	applied	\N	\N	\N	\N	4288	4288	4289
1380	1220	3	applied	\N	\N	\N	\N	4292	4292	4293
1380	1221	4	applied	\N	\N	\N	\N	4296	4296	4297
1380	1222	5	applied	\N	\N	\N	\N	4298	4298	4299
1380	1223	6	applied	\N	\N	\N	\N	4304	4304	4305
1380	1224	7	applied	\N	\N	\N	\N	4306	4306	4307
1380	1225	8	applied	\N	\N	\N	\N	4308	4308	4309
1380	1227	9	applied	\N	\N	\N	\N	4313	4313	4314
1380	1228	10	applied	\N	\N	\N	\N	4319	4319	4320
1380	1229	11	applied	\N	\N	\N	\N	4323	4323	4324
1380	1231	12	applied	\N	\N	\N	\N	4331	4331	4332
1380	1232	13	applied	\N	\N	\N	\N	4333	4333	4334
1380	1233	14	applied	\N	\N	\N	\N	4337	4337	4338
1380	1234	15	applied	\N	\N	\N	\N	4341	4341	4342
1380	1235	16	applied	\N	\N	\N	\N	4344	4344	4345
1380	1236	17	applied	\N	\N	\N	\N	4348	4348	4349
1380	1237	18	applied	\N	\N	\N	\N	4350	4350	4351
1380	1238	19	applied	\N	\N	\N	\N	4354	4354	4355
1380	1239	20	applied	\N	\N	\N	\N	4362	4362	4363
1380	1241	21	applied	\N	\N	\N	\N	4367	4367	4368
1380	1242	22	applied	\N	\N	\N	\N	4369	4369	4370
1380	1243	23	applied	\N	\N	\N	\N	4372	4372	4373
1380	1244	24	applied	\N	\N	\N	\N	4374	4374	4375
1380	1226	25	applied	\N	\N	\N	\N	4376	4376	4311
1383	1245	0	applied	\N	\N	\N	\N	4382	4382	4383
1383	1246	1	applied	\N	\N	\N	\N	4384	4384	4385
1383	1247	2	applied	\N	\N	\N	\N	4386	4386	4387
1383	1248	3	applied	\N	\N	\N	\N	4388	4388	4389
1383	1249	4	applied	\N	\N	\N	\N	4390	4390	4391
1383	1250	5	applied	\N	\N	\N	\N	4392	4392	4393
1384	1251	0	applied	\N	\N	\N	\N	4396	4396	4397
1388	1253	0	applied	\N	\N	\N	\N	4404	4404	4405
1388	1254	1	applied	\N	\N	\N	\N	4406	4406	4407
1388	1255	2	applied	\N	\N	\N	\N	4408	4408	4409
1388	1256	3	applied	\N	\N	\N	\N	4410	4410	4411
1388	1257	4	applied	\N	\N	\N	\N	3723	3723	4412
1388	1258	5	applied	\N	\N	\N	\N	4413	4413	4414
1391	1259	0	applied	\N	\N	\N	\N	4420	4420	4421
1393	1259	0	applied	\N	\N	\N	\N	4420	4420	4421
1396	1260	0	applied	\N	\N	\N	\N	4430	4430	4431
1398	1261	0	applied	\N	\N	\N	\N	4438	4438	4439
1398	1262	1	applied	\N	\N	\N	\N	4440	4440	4441
1403	1269	0	applied	\N	\N	\N	\N	4461	4461	4462
1406	1270	0	applied	\N	\N	\N	\N	4468	4468	4469
1406	1271	1	applied	\N	\N	1000000000	\N	4470	4470	4471
1407	1270	0	applied	\N	\N	\N	\N	4468	4468	4469
1407	1271	1	applied	\N	\N	1000000000	\N	4470	4470	4471
1411	1272	0	applied	\N	\N	\N	\N	4479	4479	4480
1413	1273	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	3072	3072	\N
1413	1274	1	applied	\N	\N	\N	\N	4483	4483	4484
1413	1275	2	applied	\N	\N	\N	\N	4485	4485	4486
1415	1276	0	applied	\N	\N	\N	\N	4489	4489	4490
1417	1276	0	applied	\N	\N	\N	\N	4489	4489	4490
1425	1280	0	applied	\N	\N	\N	\N	4507	4507	4508
1425	1281	1	applied	\N	\N	\N	\N	4509	4509	4510
1425	1282	2	applied	\N	\N	\N	\N	4514	4514	4515
1430	1285	0	applied	\N	\N	\N	\N	4525	4525	4526
1430	1286	1	applied	\N	\N	\N	\N	4527	4527	4528
1430	1287	2	applied	\N	\N	\N	\N	4529	4529	4530
1435	1292	0	applied	\N	\N	\N	\N	4544	4544	4545
1436	1293	0	applied	\N	\N	\N	\N	4550	4550	4551
1436	1294	1	applied	\N	\N	\N	\N	4552	4552	4553
1438	1295	0	applied	\N	\N	\N	\N	4554	4554	4555
1438	1296	1	applied	\N	\N	\N	\N	4556	4556	4557
1439	1297	0	applied	\N	\N	\N	\N	4561	4561	4562
1443	1298	0	applied	\N	\N	\N	\N	4566	4566	4567
1443	1299	1	applied	\N	\N	\N	\N	4568	4568	4569
1445	1298	0	applied	\N	\N	\N	\N	4566	4566	4567
1445	1299	1	applied	\N	\N	\N	\N	4568	4568	4569
1451	1306	0	applied	\N	\N	\N	\N	4605	4605	4606
1454	1311	0	applied	\N	\N	\N	\N	4616	4616	4617
1454	1312	1	applied	\N	\N	1000000000	\N	4618	4618	4619
1457	1311	0	applied	\N	\N	\N	\N	4616	4616	4617
1457	1312	1	applied	\N	\N	1000000000	\N	4618	4618	4619
1460	1314	0	applied	\N	\N	\N	\N	4628	4628	4629
1460	1315	1	applied	\N	\N	\N	\N	4630	4630	4631
1460	1316	2	applied	\N	\N	\N	\N	4632	4632	4633
1460	1317	3	applied	\N	\N	\N	\N	4634	4634	4635
1466	1321	0	applied	\N	\N	\N	\N	4654	4654	4655
1466	1322	1	applied	\N	\N	\N	\N	4656	4656	4657
1469	1308	0	applied	\N	\N	\N	\N	4667	4667	4177
1469	1300	1	applied	\N	\N	\N	\N	4588	4588	4668
1469	1301	2	applied	\N	\N	\N	\N	4592	4592	4669
1469	1302	3	applied	\N	\N	\N	\N	4596	4596	4670
1469	1303	4	applied	\N	\N	\N	\N	4598	4598	4671
1469	1304	5	applied	\N	\N	\N	\N	4600	4600	4672
1469	1306	6	applied	\N	\N	\N	\N	4605	4605	4673
1469	1307	7	applied	\N	\N	\N	\N	4608	4608	4674
1469	1309	8	applied	\N	\N	\N	\N	4611	4611	4675
1469	1310	9	applied	\N	\N	\N	\N	4613	4613	4676
1469	1311	10	applied	\N	\N	\N	\N	4616	4616	4677
1469	1313	12	applied	\N	\N	\N	\N	4624	4624	4679
1469	1314	13	applied	\N	\N	\N	\N	4628	4628	4680
1469	1315	14	applied	\N	\N	\N	\N	4630	4630	4681
1469	1316	15	applied	\N	\N	\N	\N	4632	4632	4682
1469	1317	16	applied	\N	\N	\N	\N	4634	4634	4683
1469	1318	17	applied	\N	\N	\N	\N	4639	4639	4684
1469	1319	18	applied	\N	\N	\N	\N	4646	4646	4685
1469	1320	19	applied	\N	\N	\N	\N	4650	4650	4686
1469	1321	20	applied	\N	\N	\N	\N	4654	4654	4687
1469	1322	21	applied	\N	\N	\N	\N	4656	4656	4688
1469	1323	22	applied	\N	\N	\N	\N	4659	4659	4689
1469	1324	23	applied	\N	\N	\N	\N	4663	4663	4690
1469	1305	24	applied	\N	\N	\N	\N	4602	4602	4603
1473	1327	0	applied	\N	\N	\N	\N	4699	4699	4700
1473	1328	1	applied	\N	\N	\N	\N	4701	4701	4702
1474	1329	0	applied	\N	\N	\N	\N	4704	4704	4705
1474	1330	1	applied	\N	\N	\N	\N	4706	4706	4707
1474	1331	2	applied	\N	\N	\N	\N	4708	4708	4709
1474	1332	3	applied	\N	\N	\N	\N	4710	4710	4711
1474	1333	4	applied	\N	\N	\N	\N	4712	4712	4713
1477	1334	0	applied	\N	\N	\N	\N	4719	4719	4720
1381	1243	0	applied	\N	\N	\N	\N	4372	4372	4373
1381	1244	1	applied	\N	\N	\N	\N	4374	4374	4375
1387	1253	0	applied	\N	\N	\N	\N	4404	4404	4405
1387	1254	1	applied	\N	\N	\N	\N	4406	4406	4407
1387	1255	2	applied	\N	\N	\N	\N	4408	4408	4409
1387	1256	3	applied	\N	\N	\N	\N	4410	4410	4411
1387	1257	4	applied	\N	\N	\N	\N	3723	3723	4412
1387	1258	5	applied	\N	\N	\N	\N	4413	4413	4414
1390	1259	0	applied	\N	\N	\N	\N	4420	4420	4421
1394	1260	0	applied	\N	\N	\N	\N	4430	4430	4431
1397	1261	0	applied	\N	\N	\N	\N	4438	4438	4439
1397	1262	1	applied	\N	\N	\N	\N	4440	4440	4441
1401	1269	0	applied	\N	\N	\N	\N	4461	4461	4462
1405	1270	0	applied	\N	\N	\N	\N	4468	4468	4469
1405	1271	1	applied	\N	\N	1000000000	\N	4470	4470	4471
1408	1270	0	applied	\N	\N	\N	\N	4468	4468	4469
1408	1271	1	applied	\N	\N	1000000000	\N	4470	4470	4471
1410	1272	0	applied	\N	\N	\N	\N	4479	4479	4480
1418	1277	0	applied	\N	\N	\N	\N	4495	4495	4496
1420	1277	0	applied	\N	\N	\N	\N	4495	4495	4496
1421	1279	0	applied	\N	\N	\N	\N	4504	4504	4505
1424	1280	0	applied	\N	\N	\N	\N	4507	4507	4508
1424	1281	1	applied	\N	\N	\N	\N	4509	4509	4510
1427	1283	0	applied	\N	\N	\N	\N	4519	4519	4520
1432	1289	0	applied	\N	\N	\N	\N	4536	4536	4537
1432	1290	1	applied	\N	\N	\N	\N	4538	4538	4539
1432	1291	2	applied	\N	\N	\N	\N	4540	4540	4541
1440	1297	0	applied	\N	\N	\N	\N	4561	4561	4562
1441	1298	0	applied	\N	\N	\N	\N	4566	4566	4567
1441	1299	1	applied	\N	\N	\N	\N	4568	4568	4569
1444	1271	0	applied	\N	\N	1000000000	\N	4470	4470	4471
1444	1273	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	3072	3072	\N
1444	1245	2	applied	\N	\N	\N	\N	4382	4382	4383
1444	1246	3	applied	\N	\N	\N	\N	4384	4384	4385
1444	1247	4	applied	\N	\N	\N	\N	4386	4386	4387
1444	1248	5	applied	\N	\N	\N	\N	4388	4388	4389
1444	1249	6	applied	\N	\N	\N	\N	4390	4390	4391
1444	1250	7	applied	\N	\N	\N	\N	4392	4392	4393
1444	1251	8	applied	\N	\N	\N	\N	4396	4396	4397
1444	1252	9	applied	\N	\N	\N	\N	4400	4400	4401
1444	1253	10	applied	\N	\N	\N	\N	4404	4404	4405
1444	1254	11	applied	\N	\N	\N	\N	4406	4406	4407
1444	1255	12	applied	\N	\N	\N	\N	4408	4408	4409
1444	1256	13	applied	\N	\N	\N	\N	4410	4410	4411
1444	1257	14	applied	\N	\N	\N	\N	3723	3723	4412
1444	1258	15	applied	\N	\N	\N	\N	4413	4413	4414
1444	1259	16	applied	\N	\N	\N	\N	4420	4420	4421
1444	1260	17	applied	\N	\N	\N	\N	4430	4430	4431
1444	1261	18	applied	\N	\N	\N	\N	4438	4438	4439
1444	1262	19	applied	\N	\N	\N	\N	4440	4440	4441
1444	1263	20	applied	\N	\N	\N	\N	4446	4446	4447
1444	1264	21	applied	\N	\N	\N	\N	4448	4448	4449
1444	1265	22	applied	\N	\N	\N	\N	4450	4450	4451
1444	1266	23	applied	\N	\N	\N	\N	4452	4452	4453
1444	1267	24	applied	\N	\N	\N	\N	4454	4454	4455
1444	1268	25	applied	\N	\N	\N	\N	4457	4457	4458
1444	1269	26	applied	\N	\N	\N	\N	4461	4461	4462
1444	1270	27	applied	\N	\N	\N	\N	4468	4468	4469
1444	1272	28	applied	\N	\N	\N	\N	4479	4479	4480
1444	1274	29	applied	\N	\N	\N	\N	4483	4483	4484
1444	1275	30	applied	\N	\N	\N	\N	4485	4485	4486
1444	1276	31	applied	\N	\N	\N	\N	4489	4489	4490
1444	1277	32	applied	\N	\N	\N	\N	4495	4495	4496
1444	1279	33	applied	\N	\N	\N	\N	4504	4504	4505
1444	1280	34	applied	\N	\N	\N	\N	4507	4507	4508
1444	1281	35	applied	\N	\N	\N	\N	4509	4509	4510
1444	1282	36	applied	\N	\N	\N	\N	4514	4514	4515
1444	1283	37	applied	\N	\N	\N	\N	4519	4519	4520
1444	1284	38	applied	\N	\N	\N	\N	4521	4521	4522
1444	1285	39	applied	\N	\N	\N	\N	4525	4525	4526
1444	1286	40	applied	\N	\N	\N	\N	4527	4527	4528
1444	1287	41	applied	\N	\N	\N	\N	4529	4529	4530
1444	1288	42	applied	\N	\N	\N	\N	4532	4532	4533
1444	1289	43	applied	\N	\N	\N	\N	4536	4536	4573
1444	1290	44	applied	\N	\N	\N	\N	4538	4538	4574
1444	1291	45	applied	\N	\N	\N	\N	4540	4540	4575
1444	1292	46	applied	\N	\N	\N	\N	4544	4544	4576
1444	1293	47	applied	\N	\N	\N	\N	4550	4550	4577
1444	1294	48	applied	\N	\N	\N	\N	4552	4552	4578
1444	1295	49	applied	\N	\N	\N	\N	4554	4554	4579
1444	1296	50	applied	\N	\N	\N	\N	4556	4556	4580
1444	1297	51	applied	\N	\N	\N	\N	4561	4561	4581
1444	1298	52	applied	\N	\N	\N	\N	4566	4566	4582
1444	1299	53	applied	\N	\N	\N	\N	4568	4568	4583
1444	1278	54	applied	\N	\N	1000000000	\N	4499	4499	4500
1447	1301	0	applied	\N	\N	\N	\N	4592	4592	4593
1450	1303	0	applied	\N	\N	\N	\N	4598	4598	4599
1450	1304	1	applied	\N	\N	\N	\N	4600	4600	4601
1450	1305	2	applied	\N	\N	\N	\N	4602	4602	4603
1456	1311	0	applied	\N	\N	\N	\N	4616	4616	4617
1456	1312	1	applied	\N	\N	1000000000	\N	4618	4618	4619
1458	1313	0	applied	\N	\N	\N	\N	4624	4624	4625
1461	1318	0	applied	\N	\N	\N	\N	4639	4639	4640
1464	1319	0	applied	\N	\N	\N	\N	4646	4646	4647
1467	1323	0	applied	\N	\N	\N	\N	4659	4659	4660
1470	1325	0	applied	\N	\N	\N	\N	4693	4693	4694
1472	1326	0	applied	\N	\N	\N	\N	4697	4697	4698
1476	1329	0	applied	\N	\N	\N	\N	4704	4704	4705
1476	1330	1	applied	\N	\N	\N	\N	4706	4706	4707
1476	1331	2	applied	\N	\N	\N	\N	4708	4708	4709
1476	1332	3	applied	\N	\N	\N	\N	4710	4710	4711
1476	1333	4	applied	\N	\N	\N	\N	4712	4712	4713
1478	1334	0	applied	\N	\N	\N	\N	4719	4719	4720
1480	1335	0	applied	\N	\N	\N	\N	4723	4723	4724
1480	1336	1	applied	\N	\N	\N	\N	4725	4725	4726
1480	1337	2	applied	\N	\N	1000000000	\N	4727	4727	4728
1382	1243	0	applied	\N	\N	\N	\N	4372	4372	4373
1382	1244	1	applied	\N	\N	\N	\N	4374	4374	4375
1385	1252	0	applied	\N	\N	\N	\N	4400	4400	4401
1386	1253	0	applied	\N	\N	\N	\N	4404	4404	4405
1386	1254	1	applied	\N	\N	\N	\N	4406	4406	4407
1386	1255	2	applied	\N	\N	\N	\N	4408	4408	4409
1386	1256	3	applied	\N	\N	\N	\N	4410	4410	4411
1386	1257	4	applied	\N	\N	\N	\N	3723	3723	4412
1386	1258	5	applied	\N	\N	\N	\N	4413	4413	4414
1389	1259	0	applied	\N	\N	\N	\N	4420	4420	4421
1392	1259	0	applied	\N	\N	\N	\N	4420	4420	4421
1395	1260	0	applied	\N	\N	\N	\N	4430	4430	4431
1399	1263	0	applied	\N	\N	\N	\N	4446	4446	4447
1399	1264	1	applied	\N	\N	\N	\N	4448	4448	4449
1399	1265	2	applied	\N	\N	\N	\N	4450	4450	4451
1399	1266	3	applied	\N	\N	\N	\N	4452	4452	4453
1399	1267	4	applied	\N	\N	\N	\N	4454	4454	4455
1400	1268	0	applied	\N	\N	\N	\N	4457	4457	4458
1402	1269	0	applied	\N	\N	\N	\N	4461	4461	4462
1404	1269	0	applied	\N	\N	\N	\N	4461	4461	4462
1409	1272	0	applied	\N	\N	\N	\N	4479	4479	4480
1412	1273	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	3072	3072	\N
1412	1274	1	applied	\N	\N	\N	\N	4483	4483	4484
1412	1275	2	applied	\N	\N	\N	\N	4485	4485	4486
1414	1276	0	applied	\N	\N	\N	\N	4489	4489	4490
1416	1276	0	applied	\N	\N	\N	\N	4489	4489	4490
1419	1277	0	applied	\N	\N	\N	\N	4495	4495	4496
1419	1278	1	applied	\N	\N	1000000000	\N	4499	4499	4500
1423	1280	0	applied	\N	\N	\N	\N	4507	4507	4508
1423	1281	1	applied	\N	\N	\N	\N	4509	4509	4510
1426	1280	0	applied	\N	\N	\N	\N	4507	4507	4508
1426	1281	1	applied	\N	\N	\N	\N	4509	4509	4510
1426	1282	2	applied	\N	\N	\N	\N	4514	4514	4515
1428	1283	0	applied	\N	\N	\N	\N	4519	4519	4520
1429	1284	0	applied	\N	\N	\N	\N	4521	4521	4522
1431	1288	0	applied	\N	\N	\N	\N	4532	4532	4533
1433	1289	0	applied	\N	\N	\N	\N	4536	4536	4537
1433	1290	1	applied	\N	\N	\N	\N	4538	4538	4539
1433	1291	2	applied	\N	\N	\N	\N	4540	4540	4541
1434	1292	0	applied	\N	\N	\N	\N	4544	4544	4545
1437	1295	0	applied	\N	\N	\N	\N	4554	4554	4555
1437	1296	1	applied	\N	\N	\N	\N	4556	4556	4557
1442	1298	0	applied	\N	\N	\N	\N	4566	4566	4567
1442	1299	1	applied	\N	\N	\N	\N	4568	4568	4569
1446	1300	0	applied	\N	\N	\N	\N	4588	4588	4589
1448	1301	0	applied	\N	\N	\N	\N	4592	4592	4593
1449	1302	0	applied	\N	\N	\N	\N	4596	4596	4597
1452	1307	0	applied	\N	\N	\N	\N	4608	4608	4609
1453	1308	0	applied	\N	\N	\N	\N	4610	4610	4177
1453	1309	1	applied	\N	\N	\N	\N	4611	4611	4612
1453	1310	2	applied	\N	\N	\N	\N	4613	4613	4614
1455	1311	0	applied	\N	\N	\N	\N	4616	4616	4617
1455	1312	1	applied	\N	\N	1000000000	\N	4618	4618	4619
1459	1314	0	applied	\N	\N	\N	\N	4628	4628	4629
1459	1315	1	applied	\N	\N	\N	\N	4630	4630	4631
1459	1316	2	applied	\N	\N	\N	\N	4632	4632	4633
1459	1317	3	applied	\N	\N	\N	\N	4634	4634	4635
1462	1318	0	applied	\N	\N	\N	\N	4639	4639	4640
1465	1320	0	applied	\N	\N	\N	\N	4650	4650	4651
1468	1324	0	applied	\N	\N	\N	\N	4663	4663	4664
1471	1326	0	applied	\N	\N	\N	\N	4697	4697	4698
1475	1329	0	applied	\N	\N	\N	\N	4704	4704	4705
1475	1330	1	applied	\N	\N	\N	\N	4706	4706	4707
1475	1331	2	applied	\N	\N	\N	\N	4708	4708	4709
1475	1332	3	applied	\N	\N	\N	\N	4710	4710	4711
1475	1333	4	applied	\N	\N	\N	\N	4712	4712	4713
1479	1335	0	applied	\N	\N	\N	\N	4723	4723	4724
1479	1336	1	applied	\N	\N	\N	\N	4725	4725	4726
1479	1337	2	applied	\N	\N	1000000000	\N	4727	4727	4728
1481	1338	0	applied	\N	\N	\N	\N	4732	4732	4733
1481	1339	1	applied	\N	\N	\N	\N	4734	4734	4735
1482	1338	0	applied	\N	\N	\N	\N	4732	4732	4733
1482	1339	1	applied	\N	\N	\N	\N	4734	4734	4735
1483	1340	0	applied	\N	\N	\N	\N	4740	4740	4741
1484	1341	0	applied	\N	\N	\N	\N	4744	4744	4745
1485	1342	0	applied	\N	\N	\N	\N	4748	4748	4749
1485	1343	1	applied	\N	\N	\N	\N	4750	4750	4602
1486	1342	0	applied	\N	\N	\N	\N	4748	4748	4749
1486	1343	1	applied	\N	\N	\N	\N	4750	4750	4602
1487	1344	0	applied	\N	\N	\N	\N	4755	4755	4756
1487	1345	1	applied	\N	\N	\N	\N	4757	4757	4758
1488	1344	0	applied	\N	\N	\N	\N	4755	4755	4756
1488	1345	1	applied	\N	\N	\N	\N	4757	4757	4758
1489	1346	0	applied	\N	\N	\N	\N	4761	4761	4762
1489	1347	1	applied	\N	\N	\N	\N	4763	4763	4764
1490	1346	0	applied	\N	\N	\N	\N	4761	4761	4762
1490	1347	1	applied	\N	\N	\N	\N	4763	4763	4764
1491	1348	0	applied	\N	\N	\N	\N	4767	4767	4768
1492	1349	0	applied	\N	\N	\N	\N	4770	4770	4771
1493	1350	0	applied	\N	\N	\N	\N	4774	4774	4775
1494	1351	0	applied	\N	\N	\N	\N	4778	4778	4779
1495	1325	0	applied	\N	\N	\N	\N	4693	4693	4782
1495	1326	1	applied	\N	\N	\N	\N	4697	4697	4783
1495	1327	2	applied	\N	\N	\N	\N	4699	4699	4784
1495	1328	3	applied	\N	\N	\N	\N	4701	4701	4785
1495	1329	4	applied	\N	\N	\N	\N	4704	4704	4786
1495	1330	5	applied	\N	\N	\N	\N	4706	4706	4787
1495	1331	6	applied	\N	\N	\N	\N	4708	4708	4788
1495	1332	7	applied	\N	\N	\N	\N	4710	4710	4789
1495	1333	8	applied	\N	\N	\N	\N	4712	4712	4790
1495	1334	9	applied	\N	\N	\N	\N	4719	4719	4791
1495	1335	10	applied	\N	\N	\N	\N	4723	4723	4792
1495	1336	11	applied	\N	\N	\N	\N	4725	4725	4793
1495	1338	12	applied	\N	\N	\N	\N	4732	4732	4794
1495	1339	13	applied	\N	\N	\N	\N	4734	4734	4795
1495	1340	14	applied	\N	\N	\N	\N	4740	4740	4796
1495	1341	15	applied	\N	\N	\N	\N	4744	4744	4797
1495	1342	16	applied	\N	\N	\N	\N	4748	4748	4798
1495	1344	17	applied	\N	\N	\N	\N	4755	4755	4799
1495	1345	18	applied	\N	\N	\N	\N	4757	4757	4800
1495	1346	19	applied	\N	\N	\N	\N	4761	4761	4801
1495	1348	20	applied	\N	\N	\N	\N	4767	4767	4802
1495	1349	21	applied	\N	\N	\N	\N	4770	4770	4803
1495	1350	22	applied	\N	\N	\N	\N	4774	4774	4804
1495	1351	23	applied	\N	\N	\N	\N	4778	4778	4805
1495	1352	24	applied	\N	\N	\N	\N	4806	4806	4807
1496	1352	0	applied	\N	\N	\N	\N	4806	4806	4810
1496	1353	1	applied	\N	\N	\N	\N	4811	4811	4812
1496	1354	2	applied	\N	\N	\N	\N	4813	4813	4814
1496	1355	3	applied	\N	\N	1000000000	\N	4815	4815	4816
1498	1352	0	applied	\N	\N	\N	\N	4806	4806	4810
1498	1353	1	applied	\N	\N	\N	\N	4811	4811	4812
1498	1354	2	applied	\N	\N	\N	\N	4813	4813	4814
1498	1355	3	applied	\N	\N	1000000000	\N	4815	4815	4816
1499	1356	0	applied	\N	\N	\N	\N	4820	4820	4821
1504	1362	0	applied	\N	\N	\N	\N	4840	4840	4841
1510	1365	0	applied	\N	\N	\N	\N	4855	4855	4856
1510	1366	1	applied	\N	\N	\N	\N	4857	4857	4858
1513	1367	0	applied	\N	\N	\N	\N	4865	4865	4866
1513	1368	1	applied	\N	\N	\N	\N	4867	4867	4868
1518	1375	0	applied	\N	\N	\N	\N	4887	4887	4888
1520	1376	0	applied	\N	\N	\N	\N	4893	4893	4894
1520	1377	1	applied	\N	\N	\N	\N	4895	4895	4896
1521	1378	0	applied	\N	\N	\N	\N	4900	4900	4901
1521	1379	1	applied	\N	\N	\N	\N	4902	4902	4903
1523	1378	0	applied	\N	\N	\N	\N	4900	4900	4901
1523	1379	1	applied	\N	\N	\N	\N	4902	4902	4903
1524	1380	0	applied	\N	\N	\N	\N	4910	4910	4911
1525	1381	0	applied	\N	\N	\N	\N	4913	4913	4914
1525	1382	1	applied	\N	\N	\N	\N	4915	4915	4916
1525	1383	2	applied	\N	\N	\N	\N	4917	4917	4918
1525	1384	3	applied	\N	\N	\N	\N	4919	4919	4920
1528	1386	0	applied	\N	\N	\N	\N	4928	4928	4929
1531	1387	0	applied	\N	\N	\N	\N	4933	4933	4934
1533	1388	0	applied	\N	\N	\N	\N	4937	4937	4938
1534	1388	0	applied	\N	\N	\N	\N	4937	4937	4938
1537	1389	0	applied	\N	\N	\N	\N	4943	4943	4944
1541	1390	0	applied	\N	\N	\N	\N	4949	4949	4950
1546	1392	0	applied	\N	\N	\N	\N	4956	4956	4957
1548	1393	0	applied	\N	\N	\N	\N	5001	5001	5002
1553	1394	0	applied	\N	\N	\N	\N	5010	5010	5011
1553	1395	1	applied	\N	\N	\N	\N	5012	5012	5013
1553	1396	2	applied	\N	\N	\N	\N	5014	5014	5015
1556	1394	0	applied	\N	\N	\N	\N	5010	5010	5011
1556	1395	1	applied	\N	\N	\N	\N	5012	5012	5013
1556	1396	2	applied	\N	\N	\N	\N	5014	5014	5015
1559	1399	0	applied	\N	\N	\N	\N	5028	5028	5029
1559	1400	1	applied	\N	\N	\N	\N	5030	5030	5031
1564	1402	0	applied	\N	\N	\N	\N	5042	5042	5043
1565	1403	0	applied	\N	\N	\N	\N	5048	5048	5049
1568	1406	0	applied	\N	\N	\N	\N	5058	5058	5059
1571	1408	0	applied	\N	\N	\N	\N	5064	5064	5065
1574	1409	0	applied	\N	\N	\N	\N	5068	5068	5069
1576	1410	0	applied	\N	\N	\N	\N	5070	5070	5071
1577	1411	0	applied	\N	\N	\N	\N	5076	5076	5077
1580	1412	0	applied	\N	\N	\N	\N	5082	5082	5083
1580	1413	1	applied	\N	\N	\N	\N	5084	5084	5085
1580	1414	2	applied	\N	\N	\N	\N	5086	5086	5087
1586	1416	0	applied	\N	\N	\N	\N	5100	5100	5101
1592	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1594	1308	0	applied	\N	\N	\N	\N	4610	4610	4177
1594	1298	1	applied	\N	\N	\N	\N	4566	4566	4567
1594	1355	2	applied	\N	\N	1000000000	\N	4815	4815	4816
1594	1358	3	applied	\N	\N	\N	\N	5125	5125	4827
1594	1371	4	applied	\N	\N	\N	\N	5126	5126	4879
1594	1299	5	applied	\N	\N	\N	\N	4568	4568	4569
1594	1300	6	applied	\N	\N	\N	\N	4588	4588	4589
1594	1301	7	applied	\N	\N	\N	\N	4592	4592	4593
1594	1302	8	applied	\N	\N	\N	\N	4596	4596	4597
1594	1303	9	applied	\N	\N	\N	\N	4598	4598	4599
1594	1304	10	applied	\N	\N	\N	\N	4600	4600	4601
1594	1306	11	applied	\N	\N	\N	\N	4605	4605	4606
1594	1307	12	applied	\N	\N	\N	\N	4608	4608	4609
1594	1309	13	applied	\N	\N	\N	\N	4611	4611	4612
1594	1310	14	applied	\N	\N	\N	\N	4613	4613	4614
1594	1311	15	applied	\N	\N	\N	\N	4616	4616	4617
1594	1313	16	applied	\N	\N	\N	\N	4624	4624	4625
1594	1314	17	applied	\N	\N	\N	\N	4628	4628	4629
1594	1315	18	applied	\N	\N	\N	\N	4630	4630	4631
1594	1316	19	applied	\N	\N	\N	\N	4632	4632	4633
1594	1317	20	applied	\N	\N	\N	\N	4634	4634	4635
1594	1318	21	applied	\N	\N	\N	\N	4639	4639	4640
1594	1319	22	applied	\N	\N	\N	\N	4646	4646	4647
1594	1320	23	applied	\N	\N	\N	\N	4650	4650	4651
1594	1321	24	applied	\N	\N	\N	\N	4654	4654	4655
1594	1322	25	applied	\N	\N	\N	\N	4656	4656	4657
1594	1323	26	applied	\N	\N	\N	\N	4659	4659	4660
1594	1324	27	applied	\N	\N	\N	\N	4663	4663	4664
1594	1325	28	applied	\N	\N	\N	\N	4693	4693	4694
1594	1326	29	applied	\N	\N	\N	\N	4697	4697	4698
1594	1327	30	applied	\N	\N	\N	\N	4699	4699	4700
1594	1328	31	applied	\N	\N	\N	\N	4701	4701	4702
1594	1329	32	applied	\N	\N	\N	\N	4704	4704	4705
1594	1330	33	applied	\N	\N	\N	\N	4706	4706	4707
1594	1331	34	applied	\N	\N	\N	\N	4708	4708	4709
1594	1332	35	applied	\N	\N	\N	\N	4710	4710	4711
1594	1333	36	applied	\N	\N	\N	\N	4712	4712	4713
1594	1334	37	applied	\N	\N	\N	\N	4719	4719	4720
1594	1335	38	applied	\N	\N	\N	\N	4723	4723	4724
1594	1336	39	applied	\N	\N	\N	\N	4725	4725	4726
1594	1338	40	applied	\N	\N	\N	\N	4732	4732	4733
1594	1339	41	applied	\N	\N	\N	\N	4734	4734	4735
1594	1340	42	applied	\N	\N	\N	\N	4740	4740	4741
1594	1341	43	applied	\N	\N	\N	\N	4744	4744	4745
1594	1342	44	applied	\N	\N	\N	\N	4748	4748	4749
1594	1344	45	applied	\N	\N	\N	\N	4755	4755	4756
1594	1345	46	applied	\N	\N	\N	\N	4757	4757	4758
1594	1346	47	applied	\N	\N	\N	\N	4761	4761	4762
1594	1348	48	applied	\N	\N	\N	\N	4767	4767	4768
1594	1349	49	applied	\N	\N	\N	\N	4770	4770	4771
1594	1350	50	applied	\N	\N	\N	\N	4774	4774	4775
1594	1351	51	applied	\N	\N	\N	\N	4778	4778	4779
1594	1352	52	applied	\N	\N	\N	\N	4806	4806	4810
1594	1353	53	applied	\N	\N	\N	\N	4811	4811	4812
1594	1354	54	applied	\N	\N	\N	\N	4813	4813	4814
1594	1356	55	applied	\N	\N	\N	\N	4820	4820	4821
1594	1357	56	applied	\N	\N	\N	\N	4824	4824	4825
1594	1359	57	applied	\N	\N	\N	\N	4830	4830	4831
1594	1360	58	applied	\N	\N	\N	\N	4832	4832	4833
1594	1361	59	applied	\N	\N	\N	\N	4836	4836	4837
1594	1362	60	applied	\N	\N	\N	\N	4840	4840	4841
1594	1363	61	applied	\N	\N	\N	\N	4844	4844	4845
1594	1364	62	applied	\N	\N	\N	\N	4846	4846	4847
1594	1365	63	applied	\N	\N	\N	\N	4855	4855	4856
1594	1366	64	applied	\N	\N	\N	\N	4857	4857	4858
1594	1367	65	applied	\N	\N	\N	\N	4865	4865	4866
1594	1368	66	applied	\N	\N	\N	\N	4867	4867	4868
1594	1369	67	applied	\N	\N	\N	\N	4872	4872	4873
1497	1352	0	applied	\N	\N	\N	\N	4806	4806	4810
1497	1353	1	applied	\N	\N	\N	\N	4811	4811	4812
1497	1354	2	applied	\N	\N	\N	\N	4813	4813	4814
1497	1355	3	applied	\N	\N	1000000000	\N	4815	4815	4816
1501	1359	0	applied	\N	\N	\N	\N	4830	4830	4831
1502	1360	0	applied	\N	\N	\N	\N	4832	4832	4833
1505	1363	0	applied	\N	\N	\N	\N	4844	4844	4845
1507	1364	0	applied	\N	\N	\N	\N	4846	4846	4847
1509	1364	0	applied	\N	\N	\N	\N	4846	4846	4847
1517	1375	0	applied	\N	\N	\N	\N	4887	4887	4888
1522	1378	0	applied	\N	\N	\N	\N	4900	4900	4901
1522	1379	1	applied	\N	\N	\N	\N	4902	4902	4903
1527	1385	0	applied	\N	\N	\N	\N	4925	4925	4926
1529	1386	0	applied	\N	\N	\N	\N	4928	4928	4929
1530	1386	0	applied	\N	\N	\N	\N	4928	4928	4929
1536	1389	0	applied	\N	\N	\N	\N	4943	4943	4944
1539	1391	0	applied	\N	\N	\N	\N	4951	4951	4952
1542	1391	0	applied	\N	\N	\N	\N	4951	4951	4952
1545	1392	0	applied	\N	\N	\N	\N	4956	4956	4957
1549	1393	0	applied	\N	\N	\N	\N	5001	5001	5002
1555	1394	0	applied	\N	\N	\N	\N	5010	5010	5011
1555	1395	1	applied	\N	\N	\N	\N	5012	5012	5013
1555	1396	2	applied	\N	\N	\N	\N	5014	5014	5015
1557	1397	0	applied	\N	\N	\N	\N	5020	5020	5021
1560	1399	0	applied	\N	\N	\N	\N	5028	5028	5029
1560	1400	1	applied	\N	\N	\N	\N	5030	5030	5031
1561	1401	0	applied	\N	\N	\N	\N	5036	5036	5037
1566	1403	0	applied	\N	\N	\N	\N	5048	5048	5049
1567	1404	0	applied	\N	\N	\N	\N	5054	5054	5055
1567	1405	1	applied	\N	\N	\N	\N	5056	5056	5057
1570	1407	0	applied	\N	\N	\N	\N	5060	5060	5061
1573	1409	0	applied	\N	\N	\N	\N	5068	5068	5069
1578	1411	0	applied	\N	\N	\N	\N	5076	5076	5077
1579	1411	0	applied	\N	\N	\N	\N	5076	5076	5077
1581	1412	0	applied	\N	\N	\N	\N	5082	5082	5083
1581	1413	1	applied	\N	\N	\N	\N	5084	5084	5085
1581	1414	2	applied	\N	\N	\N	\N	5086	5086	5087
1582	1415	0	applied	\N	\N	\N	\N	5091	5091	5092
1584	1415	0	applied	\N	\N	\N	\N	5091	5091	5092
1587	1416	0	applied	\N	\N	\N	\N	5100	5100	5101
1588	1417	0	applied	\N	\N	\N	\N	5106	5106	5107
1591	1419	0	applied	\N	\N	\N	\N	5115	5115	5116
1591	1420	1	applied	\N	\N	\N	\N	5117	5117	5118
1593	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1595	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1597	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1598	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1600	1392	0	applied	\N	\N	\N	\N	4956	4956	4957
1600	1393	1	applied	\N	\N	\N	\N	5001	5001	5002
1600	1394	2	applied	\N	\N	\N	\N	5010	5010	5011
1600	1395	3	applied	\N	\N	\N	\N	5012	5012	5013
1600	1396	4	applied	\N	\N	\N	\N	5014	5014	5015
1600	1397	5	applied	\N	\N	\N	\N	5020	5020	5021
1602	1422	0	applied	\N	\N	\N	\N	5137	5137	5138
1602	1423	1	applied	\N	\N	\N	\N	5139	5139	5140
1500	1357	0	applied	\N	\N	\N	\N	4824	4824	4825
1500	1358	1	applied	\N	\N	\N	\N	4826	4826	4827
1503	1361	0	applied	\N	\N	\N	\N	4836	4836	4837
1506	1364	0	applied	\N	\N	\N	\N	4846	4846	4847
1508	1364	0	applied	\N	\N	\N	\N	4846	4846	4847
1511	1365	0	applied	\N	\N	\N	\N	4855	4855	4856
1511	1366	1	applied	\N	\N	\N	\N	4857	4857	4858
1512	1365	0	applied	\N	\N	\N	\N	4855	4855	4856
1512	1366	1	applied	\N	\N	\N	\N	4857	4857	4858
1514	1367	0	applied	\N	\N	\N	\N	4865	4865	4866
1514	1368	1	applied	\N	\N	\N	\N	4867	4867	4868
1515	1369	0	applied	\N	\N	\N	\N	4872	4872	4873
1516	1370	0	applied	\N	\N	\N	\N	4876	4876	4877
1516	1371	1	applied	\N	\N	\N	\N	4878	4878	4879
1516	1372	2	applied	\N	\N	\N	\N	4880	4880	4881
1516	1373	3	applied	\N	\N	\N	\N	4882	4882	4883
1516	1374	4	applied	\N	\N	\N	\N	4884	4884	4885
1519	1376	0	applied	\N	\N	\N	\N	4893	4893	4894
1519	1377	1	applied	\N	\N	\N	\N	4895	4895	4896
1526	1381	0	applied	\N	\N	\N	\N	4913	4913	4914
1526	1382	1	applied	\N	\N	\N	\N	4915	4915	4916
1526	1383	2	applied	\N	\N	\N	\N	4917	4917	4918
1526	1384	3	applied	\N	\N	\N	\N	4919	4919	4920
1532	1388	0	applied	\N	\N	\N	\N	4937	4937	4938
1535	1389	0	applied	\N	\N	\N	\N	4943	4943	4944
1538	1390	0	applied	\N	\N	\N	\N	4949	4949	4950
1547	1353	0	applied	\N	\N	\N	\N	4811	4811	4960
1547	1354	1	applied	\N	\N	\N	\N	4813	4813	4961
1547	1355	2	applied	\N	\N	1000000000	\N	4815	4815	4816
1547	1356	3	applied	\N	\N	\N	\N	4820	4820	4962
1547	1357	4	applied	\N	\N	\N	\N	4824	4824	4963
1547	1359	5	applied	\N	\N	\N	\N	4830	4830	4964
1547	1360	6	applied	\N	\N	\N	\N	4832	4832	4965
1547	1361	7	applied	\N	\N	\N	\N	4836	4836	4966
1547	1358	8	applied	\N	\N	\N	\N	4967	4967	4827
1547	1371	9	applied	\N	\N	\N	\N	4968	4968	4879
1547	1362	10	applied	\N	\N	\N	\N	4840	4840	4969
1547	1363	11	applied	\N	\N	\N	\N	4844	4844	4970
1547	1364	12	applied	\N	\N	\N	\N	4846	4846	4971
1547	1365	13	applied	\N	\N	\N	\N	4855	4855	4972
1547	1366	14	applied	\N	\N	\N	\N	4857	4857	4973
1547	1367	15	applied	\N	\N	\N	\N	4865	4865	4974
1547	1368	16	applied	\N	\N	\N	\N	4867	4867	4975
1547	1369	17	applied	\N	\N	\N	\N	4872	4872	4976
1547	1370	18	applied	\N	\N	\N	\N	4876	4876	4977
1547	1372	19	applied	\N	\N	\N	\N	4880	4880	4978
1547	1373	20	applied	\N	\N	\N	\N	4882	4882	4979
1547	1374	21	applied	\N	\N	\N	\N	4884	4884	4980
1547	1375	22	applied	\N	\N	\N	\N	4887	4887	4981
1547	1376	23	applied	\N	\N	\N	\N	4893	4893	4982
1547	1377	24	applied	\N	\N	\N	\N	4895	4895	4983
1547	1378	25	applied	\N	\N	\N	\N	4900	4900	4984
1547	1379	26	applied	\N	\N	\N	\N	4902	4902	4985
1547	1380	27	applied	\N	\N	\N	\N	4910	4910	4986
1547	1381	28	applied	\N	\N	\N	\N	4913	4913	4987
1547	1382	29	applied	\N	\N	\N	\N	4915	4915	4988
1547	1383	30	applied	\N	\N	\N	\N	4917	4917	4989
1547	1384	31	applied	\N	\N	\N	\N	4919	4919	4990
1547	1385	32	applied	\N	\N	\N	\N	4925	4925	4991
1547	1386	33	applied	\N	\N	\N	\N	4928	4928	4992
1547	1387	34	applied	\N	\N	\N	\N	4933	4933	4993
1547	1388	35	applied	\N	\N	\N	\N	4937	4937	4994
1547	1389	36	applied	\N	\N	\N	\N	4943	4943	4995
1547	1390	37	applied	\N	\N	\N	\N	4949	4949	4996
1547	1391	38	applied	\N	\N	\N	\N	4951	4951	4997
1547	1392	39	applied	\N	\N	\N	\N	4956	4956	4998
1554	1394	0	applied	\N	\N	\N	\N	5010	5010	5011
1554	1395	1	applied	\N	\N	\N	\N	5012	5012	5013
1554	1396	2	applied	\N	\N	\N	\N	5014	5014	5015
1558	1398	0	applied	\N	\N	\N	\N	5024	5024	5025
1562	1401	0	applied	\N	\N	\N	\N	5036	5036	5037
1563	1402	0	applied	\N	\N	\N	\N	5042	5042	5043
1569	1407	0	applied	\N	\N	\N	\N	5060	5060	5061
1572	1408	0	applied	\N	\N	\N	\N	5064	5064	5065
1575	1410	0	applied	\N	\N	\N	\N	5070	5070	5071
1583	1415	0	applied	\N	\N	\N	\N	5091	5091	5092
1585	1415	0	applied	\N	\N	\N	\N	5091	5091	5092
1589	1417	0	applied	\N	\N	\N	\N	5106	5106	5107
1590	1418	0	applied	\N	\N	\N	\N	5112	5112	5113
1599	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1603	1411	0	applied	\N	\N	\N	\N	5076	5076	5077
1603	1412	1	applied	\N	\N	\N	\N	5082	5082	5083
1603	1413	2	applied	\N	\N	\N	\N	5084	5084	5085
1603	1414	3	applied	\N	\N	\N	\N	5086	5086	5087
1603	1415	4	applied	\N	\N	\N	\N	5091	5091	5092
1603	1416	5	applied	\N	\N	\N	\N	5100	5100	5101
1603	1417	6	applied	\N	\N	\N	\N	5106	5106	5107
1603	1418	7	applied	\N	\N	\N	\N	5112	5112	5113
1603	1419	8	applied	\N	\N	\N	\N	5115	5115	5116
1603	1420	9	applied	\N	\N	\N	\N	5117	5117	5118
1603	1421	10	applied	\N	\N	\N	\N	5121	5121	5122
1594	1370	68	applied	\N	\N	\N	\N	4876	4876	4877
1594	1372	69	applied	\N	\N	\N	\N	4880	4880	4881
1594	1373	70	applied	\N	\N	\N	\N	4882	4882	4883
1594	1374	71	applied	\N	\N	\N	\N	4884	4884	4885
1594	1375	72	applied	\N	\N	\N	\N	4887	4887	4888
1594	1376	73	applied	\N	\N	\N	\N	4893	4893	4894
1594	1377	74	applied	\N	\N	\N	\N	4895	4895	4896
1594	1378	75	applied	\N	\N	\N	\N	4900	4900	4901
1594	1379	76	applied	\N	\N	\N	\N	4902	4902	4903
1594	1380	77	applied	\N	\N	\N	\N	4910	4910	4911
1594	1381	78	applied	\N	\N	\N	\N	4913	4913	4914
1594	1382	79	applied	\N	\N	\N	\N	4915	4915	4916
1594	1383	80	applied	\N	\N	\N	\N	4917	4917	4918
1594	1384	81	applied	\N	\N	\N	\N	4919	4919	4920
1594	1385	82	applied	\N	\N	\N	\N	4925	4925	4926
1594	1386	83	applied	\N	\N	\N	\N	4928	4928	4929
1594	1387	84	applied	\N	\N	\N	\N	4933	4933	4934
1594	1388	85	applied	\N	\N	\N	\N	4937	4937	4938
1594	1389	86	applied	\N	\N	\N	\N	4943	4943	4944
1594	1390	87	applied	\N	\N	\N	\N	4949	4949	4950
1596	1421	0	applied	\N	\N	\N	\N	5121	5121	5122
1601	1422	0	applied	\N	\N	\N	\N	5137	5137	5138
1601	1423	1	applied	\N	\N	\N	\N	5139	5139	5140
1604	1422	0	applied	\N	\N	\N	\N	5137	5137	5138
1604	1423	1	applied	\N	\N	\N	\N	5139	5139	5140
1605	1424	0	applied	\N	\N	\N	\N	5145	5145	5146
1605	1425	1	applied	\N	\N	\N	\N	5147	5147	5148
1606	1424	0	applied	\N	\N	\N	\N	5145	5145	5146
1606	1425	1	applied	\N	\N	\N	\N	5147	5147	5148
1607	1426	0	applied	\N	\N	\N	\N	5152	5152	5153
1608	1308	0	applied	\N	\N	\N	\N	4610	4610	4177
1608	1355	1	applied	\N	\N	1000000000	\N	4815	4815	4816
1608	1358	2	applied	\N	\N	\N	\N	5125	5125	4827
1608	1371	3	applied	\N	\N	\N	\N	5126	5126	4879
1608	1295	4	applied	\N	\N	\N	\N	4554	4554	4555
1608	1296	5	applied	\N	\N	\N	\N	4556	4556	4557
1608	1297	6	applied	\N	\N	\N	\N	4561	4561	4562
1608	1298	7	applied	\N	\N	\N	\N	4566	4566	4567
1608	1299	8	applied	\N	\N	\N	\N	4568	4568	4569
1608	1300	9	applied	\N	\N	\N	\N	4588	4588	4589
1608	1301	10	applied	\N	\N	\N	\N	4592	4592	4593
1608	1302	11	applied	\N	\N	\N	\N	4596	4596	4597
1608	1303	12	applied	\N	\N	\N	\N	4598	4598	4599
1608	1304	13	applied	\N	\N	\N	\N	4600	4600	4601
1608	1306	14	applied	\N	\N	\N	\N	4605	4605	4606
1608	1307	15	applied	\N	\N	\N	\N	4608	4608	4609
1608	1309	16	applied	\N	\N	\N	\N	4611	4611	4612
1608	1310	17	applied	\N	\N	\N	\N	4613	4613	4614
1608	1311	18	applied	\N	\N	\N	\N	4616	4616	4617
1608	1313	19	applied	\N	\N	\N	\N	4624	4624	4625
1608	1314	20	applied	\N	\N	\N	\N	4628	4628	4629
1608	1315	21	applied	\N	\N	\N	\N	4630	4630	4631
1608	1316	22	applied	\N	\N	\N	\N	4632	4632	4633
1608	1317	23	applied	\N	\N	\N	\N	4634	4634	4635
1608	1318	24	applied	\N	\N	\N	\N	4639	4639	4640
1608	1319	25	applied	\N	\N	\N	\N	4646	4646	4647
1608	1320	26	applied	\N	\N	\N	\N	4650	4650	4651
1608	1321	27	applied	\N	\N	\N	\N	4654	4654	4655
1608	1322	28	applied	\N	\N	\N	\N	4656	4656	4657
1608	1323	29	applied	\N	\N	\N	\N	4659	4659	4660
1608	1324	30	applied	\N	\N	\N	\N	4663	4663	4664
1608	1325	31	applied	\N	\N	\N	\N	4693	4693	4694
1608	1326	32	applied	\N	\N	\N	\N	4697	4697	4698
1608	1327	33	applied	\N	\N	\N	\N	4699	4699	4700
1608	1328	34	applied	\N	\N	\N	\N	4701	4701	4702
1608	1329	35	applied	\N	\N	\N	\N	4704	4704	4705
1608	1330	36	applied	\N	\N	\N	\N	4706	4706	4707
1608	1331	37	applied	\N	\N	\N	\N	4708	4708	4709
1608	1332	38	applied	\N	\N	\N	\N	4710	4710	4711
1608	1333	39	applied	\N	\N	\N	\N	4712	4712	4713
1608	1334	40	applied	\N	\N	\N	\N	4719	4719	4720
1608	1335	41	applied	\N	\N	\N	\N	4723	4723	4724
1608	1336	42	applied	\N	\N	\N	\N	4725	4725	4726
1608	1338	43	applied	\N	\N	\N	\N	4732	4732	4733
1608	1339	44	applied	\N	\N	\N	\N	4734	4734	4735
1608	1340	45	applied	\N	\N	\N	\N	4740	4740	4741
1608	1341	46	applied	\N	\N	\N	\N	4744	4744	4745
1608	1342	47	applied	\N	\N	\N	\N	4748	4748	4749
1608	1344	48	applied	\N	\N	\N	\N	4755	4755	4756
1608	1345	49	applied	\N	\N	\N	\N	4757	4757	4758
1608	1346	50	applied	\N	\N	\N	\N	4761	4761	4762
1608	1348	51	applied	\N	\N	\N	\N	4767	4767	4768
1608	1349	52	applied	\N	\N	\N	\N	4770	4770	4771
1608	1350	53	applied	\N	\N	\N	\N	4774	4774	4775
1608	1351	54	applied	\N	\N	\N	\N	4778	4778	4779
1608	1352	55	applied	\N	\N	\N	\N	4806	4806	4810
1608	1353	56	applied	\N	\N	\N	\N	4811	4811	4812
1608	1354	57	applied	\N	\N	\N	\N	4813	4813	4814
1608	1356	58	applied	\N	\N	\N	\N	4820	4820	4821
1608	1357	59	applied	\N	\N	\N	\N	4824	4824	4825
1608	1359	60	applied	\N	\N	\N	\N	4830	4830	4831
1608	1360	61	applied	\N	\N	\N	\N	4832	4832	4833
1608	1361	62	applied	\N	\N	\N	\N	4836	4836	4837
1608	1362	63	applied	\N	\N	\N	\N	4840	4840	4841
1608	1363	64	applied	\N	\N	\N	\N	4844	4844	4845
1608	1364	65	applied	\N	\N	\N	\N	4846	4846	4847
1608	1365	66	applied	\N	\N	\N	\N	4855	4855	4856
1608	1366	67	applied	\N	\N	\N	\N	4857	4857	4858
1608	1367	68	applied	\N	\N	\N	\N	4865	4865	4866
1608	1368	69	applied	\N	\N	\N	\N	4867	4867	4868
1608	1369	70	applied	\N	\N	\N	\N	4872	4872	4873
1608	1370	71	applied	\N	\N	\N	\N	4876	4876	4877
1608	1372	72	applied	\N	\N	\N	\N	4880	4880	4881
1608	1373	73	applied	\N	\N	\N	\N	4882	4882	4883
1608	1374	74	applied	\N	\N	\N	\N	4884	4884	4885
1608	1375	75	applied	\N	\N	\N	\N	4887	4887	4888
1608	1376	76	applied	\N	\N	\N	\N	4893	4893	4894
1608	1377	77	applied	\N	\N	\N	\N	4895	4895	4896
1608	1378	78	applied	\N	\N	\N	\N	4900	4900	4901
1608	1379	79	applied	\N	\N	\N	\N	4902	4902	4903
1608	1380	80	applied	\N	\N	\N	\N	4910	4910	4911
1608	1381	81	applied	\N	\N	\N	\N	4913	4913	4914
1608	1382	82	applied	\N	\N	\N	\N	4915	4915	4916
1608	1383	83	applied	\N	\N	\N	\N	4917	4917	4918
1608	1384	84	applied	\N	\N	\N	\N	4919	4919	4920
1608	1385	85	applied	\N	\N	\N	\N	4925	4925	4926
1608	1386	86	applied	\N	\N	\N	\N	4928	4928	4929
1608	1387	87	applied	\N	\N	\N	\N	4933	4933	4934
1608	1388	88	applied	\N	\N	\N	\N	4937	4937	4938
1608	1389	89	applied	\N	\N	\N	\N	4943	4943	4944
1608	1390	90	applied	\N	\N	\N	\N	4949	4949	4950
1608	1391	91	applied	\N	\N	\N	\N	4951	4951	4952
1608	1392	92	applied	\N	\N	\N	\N	4956	4956	4957
1608	1393	93	applied	\N	\N	\N	\N	5001	5001	5002
1608	1394	94	applied	\N	\N	\N	\N	5010	5010	5011
1608	1395	96	applied	\N	\N	\N	\N	5012	5012	5155
1608	1396	97	applied	\N	\N	\N	\N	5014	5014	5156
1608	1397	98	applied	\N	\N	\N	\N	5020	5020	5157
1608	1398	99	applied	\N	\N	\N	\N	5024	5024	5158
1608	1399	100	applied	\N	\N	\N	\N	5028	5028	5159
1608	1400	101	applied	\N	\N	\N	\N	5030	5030	5160
1608	1401	102	applied	\N	\N	\N	\N	5036	5036	5161
1608	1402	103	applied	\N	\N	\N	\N	5042	5042	5162
1608	1403	104	applied	\N	\N	\N	\N	5048	5048	5163
1608	1404	105	applied	\N	\N	\N	\N	5054	5054	5164
1608	1405	106	applied	\N	\N	\N	\N	5056	5056	5165
1608	1406	107	applied	\N	\N	\N	\N	5058	5058	5166
1608	1407	108	applied	\N	\N	\N	\N	5060	5060	5167
1608	1408	109	applied	\N	\N	\N	\N	5064	5064	5168
1608	1409	110	applied	\N	\N	\N	\N	5068	5068	5169
1608	1410	111	applied	\N	\N	\N	\N	5070	5070	5170
1608	1411	112	applied	\N	\N	\N	\N	5076	5076	5171
1608	1412	113	applied	\N	\N	\N	\N	5082	5082	5172
1608	1413	114	applied	\N	\N	\N	\N	5084	5084	5173
1608	1414	115	applied	\N	\N	\N	\N	5086	5086	5174
1608	1415	116	applied	\N	\N	\N	\N	5091	5091	5175
1608	1416	117	applied	\N	\N	\N	\N	5100	5100	5176
1608	1417	118	applied	\N	\N	\N	\N	5106	5106	5177
1608	1418	119	applied	\N	\N	\N	\N	5112	5112	5178
1608	1419	120	applied	\N	\N	\N	\N	5115	5115	5179
1608	1420	121	applied	\N	\N	\N	\N	5117	5117	5180
1608	1421	122	applied	\N	\N	\N	\N	5121	5121	5181
1608	1422	123	applied	\N	\N	\N	\N	5137	5137	5182
1608	1423	124	applied	\N	\N	\N	\N	5139	5139	5183
1608	1424	125	applied	\N	\N	\N	\N	5145	5145	5184
1612	1430	0	applied	\N	\N	\N	\N	5198	5198	5199
1612	1431	1	applied	\N	\N	\N	\N	5200	5200	5201
1612	1432	2	applied	\N	\N	\N	\N	5202	5202	5203
1612	1433	3	applied	\N	\N	\N	\N	5204	5204	5205
1613	1430	0	applied	\N	\N	\N	\N	5198	5198	5199
1613	1431	1	applied	\N	\N	\N	\N	5200	5200	5201
1613	1432	2	applied	\N	\N	\N	\N	5202	5202	5203
1613	1433	3	applied	\N	\N	\N	\N	5204	5204	5205
1615	1434	0	applied	\N	\N	\N	\N	5208	5208	5209
1621	1436	0	applied	\N	\N	\N	\N	5218	5218	5219
1623	1437	0	applied	\N	\N	\N	\N	5223	5223	5224
1624	1393	0	applied	\N	\N	\N	\N	5001	5001	5229
1624	1394	1	applied	\N	\N	\N	\N	5010	5010	5230
1624	1395	2	applied	\N	\N	\N	\N	5012	5012	5231
1624	1396	3	applied	\N	\N	\N	\N	5014	5014	5232
1624	1397	4	applied	\N	\N	\N	\N	5020	5020	5233
1624	1398	5	applied	\N	\N	\N	\N	5024	5024	5234
1624	1399	6	applied	\N	\N	\N	\N	5028	5028	5235
1624	1400	7	applied	\N	\N	\N	\N	5030	5030	5236
1624	1401	8	applied	\N	\N	\N	\N	5036	5036	5237
1624	1402	9	applied	\N	\N	\N	\N	5042	5042	5238
1624	1403	10	applied	\N	\N	\N	\N	5048	5048	5239
1624	1404	11	applied	\N	\N	\N	\N	5054	5054	5240
1624	1405	12	applied	\N	\N	\N	\N	5056	5056	5241
1624	1406	13	applied	\N	\N	\N	\N	5058	5058	5242
1624	1407	14	applied	\N	\N	\N	\N	5060	5060	5243
1624	1408	15	applied	\N	\N	\N	\N	5064	5064	5244
1624	1409	16	applied	\N	\N	\N	\N	5068	5068	5245
1624	1410	17	applied	\N	\N	\N	\N	5070	5070	5246
1624	1411	18	applied	\N	\N	\N	\N	5076	5076	5247
1624	1412	19	applied	\N	\N	\N	\N	5082	5082	5248
1624	1413	20	applied	\N	\N	\N	\N	5084	5084	5249
1624	1414	21	applied	\N	\N	\N	\N	5086	5086	5250
1624	1415	22	applied	\N	\N	\N	\N	5091	5091	5251
1624	1416	23	applied	\N	\N	\N	\N	5100	5100	5252
1624	1417	24	applied	\N	\N	\N	\N	5106	5106	5253
1624	1418	25	applied	\N	\N	\N	\N	5112	5112	5254
1624	1419	26	applied	\N	\N	\N	\N	5115	5115	5255
1624	1420	27	applied	\N	\N	\N	\N	5117	5117	5256
1624	1421	28	applied	\N	\N	\N	\N	5121	5121	5257
1624	1422	29	applied	\N	\N	\N	\N	5137	5137	5258
1624	1423	30	applied	\N	\N	\N	\N	5139	5139	5259
1624	1424	31	applied	\N	\N	\N	\N	5145	5145	5260
1624	1425	32	applied	\N	\N	\N	\N	5147	5147	5261
1624	1426	33	applied	\N	\N	\N	\N	5152	5152	5262
1624	1427	34	applied	\N	\N	\N	\N	5187	5187	5263
1624	1428	35	applied	\N	\N	\N	\N	5189	5189	5264
1624	1429	36	applied	\N	\N	\N	\N	5193	5193	5265
1624	1430	37	applied	\N	\N	\N	\N	5198	5198	5266
1624	1431	38	applied	\N	\N	\N	\N	5200	5200	5267
1624	1432	39	applied	\N	\N	\N	\N	5202	5202	5268
1624	1433	40	applied	\N	\N	\N	\N	5204	5204	5269
1624	1434	41	applied	\N	\N	\N	\N	5208	5208	5270
1624	1435	42	applied	\N	\N	\N	\N	5214	5214	5271
1624	1436	44	applied	\N	\N	\N	\N	5218	5218	5273
1624	1437	45	applied	\N	\N	\N	\N	5223	5223	5274
1627	1439	0	applied	\N	\N	\N	\N	5283	5283	5284
1630	1440	0	applied	\N	\N	\N	\N	5287	5287	5288
1633	1441	0	applied	\N	\N	\N	\N	5295	5295	5296
1633	1442	1	applied	\N	\N	\N	\N	5297	5297	5298
1634	1441	0	applied	\N	\N	\N	\N	5295	5295	5296
1634	1442	1	applied	\N	\N	\N	\N	5297	5297	5298
1637	1445	0	applied	\N	\N	\N	\N	5307	5307	5308
1638	1446	0	applied	\N	\N	\N	\N	5313	5313	5314
1642	1448	0	applied	\N	\N	\N	\N	5320	5320	5321
1644	1449	0	applied	\N	\N	\N	\N	5324	5324	5325
1647	1438	0	applied	\N	\N	\N	\N	5279	5279	5332
1647	1439	1	applied	\N	\N	\N	\N	5283	5283	5333
1647	1440	2	applied	\N	\N	\N	\N	5287	5287	5334
1647	1441	3	applied	\N	\N	\N	\N	5295	5295	5335
1647	1442	4	applied	\N	\N	\N	\N	5297	5297	5336
1647	1443	5	applied	\N	\N	\N	\N	5301	5301	5337
1647	1444	6	applied	\N	\N	\N	\N	5303	5303	5338
1647	1445	7	applied	\N	\N	\N	\N	5307	5307	5339
1647	1446	8	applied	\N	\N	\N	\N	5313	5313	5340
1647	1447	9	applied	\N	\N	\N	\N	5316	5316	5341
1647	1448	10	applied	\N	\N	\N	\N	5320	5320	5342
1647	1449	11	applied	\N	\N	\N	\N	5324	5324	5343
1649	1451	0	applied	\N	\N	\N	\N	5348	5348	5349
1652	1453	0	applied	\N	\N	\N	\N	5356	5356	5357
1655	1454	0	applied	\N	\N	\N	\N	5364	5364	5368
1658	1457	0	applied	\N	\N	\N	\N	5377	5377	5378
1662	1458	0	applied	\N	\N	\N	\N	5384	5384	5385
1662	1459	1	applied	\N	\N	\N	\N	5386	5386	5387
1662	1460	2	applied	\N	\N	\N	\N	5388	5388	5389
1609	1427	0	applied	\N	\N	\N	\N	5187	5187	5188
1609	1428	1	applied	\N	\N	\N	\N	5189	5189	5190
1616	1434	0	applied	\N	\N	\N	\N	5208	5208	5209
1618	1435	0	applied	\N	\N	\N	\N	5214	5214	5215
1619	1435	0	applied	\N	\N	\N	\N	5214	5214	5215
1622	1437	0	applied	\N	\N	\N	\N	5223	5223	5224
1632	1440	0	applied	\N	\N	\N	\N	5287	5287	5288
1635	1443	0	applied	\N	\N	\N	\N	5301	5301	5302
1635	1444	1	applied	\N	\N	\N	\N	5303	5303	5304
1640	1448	0	applied	\N	\N	\N	\N	5320	5320	5321
1645	1449	0	applied	\N	\N	\N	\N	5324	5324	5325
1648	1450	0	applied	\N	\N	\N	\N	5346	5346	5347
1650	1451	0	applied	\N	\N	\N	\N	5348	5348	5349
1651	1452	0	applied	\N	\N	\N	\N	5352	5352	5353
1653	1453	0	applied	\N	\N	\N	\N	5356	5356	5357
1654	1450	0	applied	\N	\N	\N	\N	5346	5346	5360
1654	1451	1	applied	\N	\N	\N	\N	5348	5348	5361
1654	1452	2	applied	\N	\N	\N	\N	5352	5352	5362
1654	1453	3	applied	\N	\N	\N	\N	5356	5356	5363
1654	1454	4	applied	\N	\N	\N	\N	5364	5364	5365
1657	1457	0	applied	\N	\N	\N	\N	5377	5377	5378
1659	1457	0	applied	\N	\N	\N	\N	5377	5377	5378
1661	1458	0	applied	\N	\N	\N	\N	5384	5384	5385
1661	1459	1	applied	\N	\N	\N	\N	5386	5386	5387
1661	1460	2	applied	\N	\N	\N	\N	5388	5388	5389
1661	1461	3	applied	\N	\N	\N	\N	5390	5390	5391
1664	1451	0	applied	\N	\N	\N	\N	5348	5348	5349
1664	1452	1	applied	\N	\N	\N	\N	5352	5352	5353
1664	1453	2	applied	\N	\N	\N	\N	5356	5356	5357
1664	1454	3	applied	\N	\N	\N	\N	5364	5364	5368
1664	1455	4	applied	\N	\N	\N	\N	5371	5371	5372
1664	1456	5	applied	\N	\N	\N	\N	5373	5373	5374
1664	1457	6	applied	\N	\N	\N	\N	5377	5377	5378
1664	1458	7	applied	\N	\N	\N	\N	5384	5384	5385
1664	1459	8	applied	\N	\N	\N	\N	5386	5386	5387
1664	1460	9	applied	\N	\N	\N	\N	5388	5388	5389
1664	1461	10	applied	\N	\N	\N	\N	5390	5390	5391
1664	1462	11	applied	\N	\N	\N	\N	5397	5397	5398
1664	1463	12	applied	\N	\N	\N	\N	5399	5399	5400
1668	1464	0	applied	\N	\N	\N	\N	5406	5406	5407
1668	1465	1	applied	\N	\N	\N	\N	5408	5408	5409
1671	1468	0	applied	\N	\N	\N	\N	5414	5414	5415
1686	1479	0	applied	\N	\N	\N	\N	5447	5447	5448
1689	1481	0	applied	\N	\N	\N	\N	5453	5453	5454
1692	1484	0	applied	\N	\N	\N	\N	5471	5471	5472
1692	1485	1	applied	\N	\N	\N	\N	5473	5473	5474
1693	1484	0	applied	\N	\N	\N	\N	5471	5471	5472
1693	1485	1	applied	\N	\N	\N	\N	5473	5473	5474
1696	1488	0	applied	\N	\N	\N	\N	5483	5483	5484
1701	1489	0	applied	\N	\N	\N	\N	5487	5487	5488
1701	1490	1	applied	\N	\N	\N	\N	5489	5489	5488
1701	1464	2	applied	\N	\N	\N	\N	5406	5406	5407
1701	1465	3	applied	\N	\N	\N	\N	5408	5408	5409
1701	1466	4	applied	\N	\N	\N	\N	5410	5410	5411
1701	1467	5	applied	\N	\N	\N	\N	5412	5412	5413
1701	1468	6	applied	\N	\N	\N	\N	5414	5414	5415
1701	1469	7	applied	\N	\N	\N	\N	5417	5417	5418
1701	1470	8	applied	\N	\N	\N	\N	5419	5419	5420
1701	1471	9	applied	\N	\N	\N	\N	5421	5421	5422
1701	1472	10	applied	\N	\N	\N	\N	5423	5423	5424
1701	1473	11	applied	\N	\N	\N	\N	5429	5429	5430
1701	1474	12	applied	\N	\N	\N	\N	5431	5431	5432
1701	1475	13	applied	\N	\N	\N	\N	5435	5435	5436
1701	1476	14	applied	\N	\N	\N	\N	5439	5439	5440
1701	1477	15	applied	\N	\N	\N	\N	5443	5443	5444
1701	1478	16	applied	\N	\N	\N	\N	5445	5445	5446
1701	1479	17	applied	\N	\N	\N	\N	5447	5447	5448
1701	1480	18	applied	\N	\N	\N	\N	5451	5451	5452
1701	1481	19	applied	\N	\N	\N	\N	5453	5453	5454
1701	1482	20	applied	\N	\N	\N	\N	5455	5455	5456
1701	1483	21	applied	\N	\N	\N	\N	5457	5457	5458
1701	1484	22	applied	\N	\N	\N	\N	5471	5471	5472
1701	1485	23	applied	\N	\N	\N	\N	5473	5473	5474
1701	1486	24	applied	\N	\N	\N	\N	5479	5479	5480
1701	1487	25	applied	\N	\N	\N	\N	5481	5481	5482
1701	1488	26	applied	\N	\N	\N	\N	5483	5483	5484
1701	1491	27	applied	\N	\N	\N	\N	5490	5490	5491
1701	1492	28	applied	\N	\N	\N	\N	5492	5492	5493
1701	1493	29	applied	\N	\N	\N	\N	5496	5496	5497
1701	1494	30	applied	\N	\N	\N	\N	5498	5498	5499
1610	1429	0	applied	\N	\N	\N	\N	5193	5193	5194
1614	1434	0	applied	\N	\N	\N	\N	5208	5208	5209
1617	1435	0	applied	\N	\N	\N	\N	5214	5214	5215
1620	1436	0	applied	\N	\N	\N	\N	5218	5218	5219
1625	1437	0	applied	\N	\N	\N	\N	5223	5223	5224
1626	1438	0	applied	\N	\N	\N	\N	5279	5279	5280
1628	1439	0	applied	\N	\N	\N	\N	5283	5283	5284
1629	1440	0	applied	\N	\N	\N	\N	5287	5287	5288
1631	1440	0	applied	\N	\N	\N	\N	5287	5287	5288
1636	1445	0	applied	\N	\N	\N	\N	5307	5307	5308
1639	1447	0	applied	\N	\N	\N	\N	5316	5316	5317
1641	1448	0	applied	\N	\N	\N	\N	5320	5320	5321
1643	1448	0	applied	\N	\N	\N	\N	5320	5320	5321
1656	1455	0	applied	\N	\N	\N	\N	5371	5371	5372
1656	1456	1	applied	\N	\N	\N	\N	5373	5373	5374
1660	1458	0	applied	\N	\N	\N	\N	5384	5384	5385
1660	1459	1	applied	\N	\N	\N	\N	5386	5386	5387
1660	1460	2	applied	\N	\N	\N	\N	5388	5388	5389
1660	1461	3	applied	\N	\N	\N	\N	5390	5390	5391
1663	1462	0	applied	\N	\N	\N	\N	5397	5397	5398
1663	1463	1	applied	\N	\N	\N	\N	5399	5399	5400
1666	1462	0	applied	\N	\N	\N	\N	5397	5397	5398
1666	1463	1	applied	\N	\N	\N	\N	5399	5399	5400
1669	1464	0	applied	\N	\N	\N	\N	5406	5406	5407
1669	1465	1	applied	\N	\N	\N	\N	5408	5408	5409
1674	1469	0	applied	\N	\N	\N	\N	5417	5417	5418
1674	1470	1	applied	\N	\N	\N	\N	5419	5419	5420
1674	1471	2	applied	\N	\N	\N	\N	5421	5421	5422
1674	1472	3	applied	\N	\N	\N	\N	5423	5423	5424
1675	1469	0	applied	\N	\N	\N	\N	5417	5417	5418
1675	1470	1	applied	\N	\N	\N	\N	5419	5419	5420
1675	1471	2	applied	\N	\N	\N	\N	5421	5421	5422
1675	1472	3	applied	\N	\N	\N	\N	5423	5423	5424
1677	1473	0	applied	\N	\N	\N	\N	5429	5429	5430
1678	1474	0	applied	\N	\N	\N	\N	5431	5431	5432
1681	1475	0	applied	\N	\N	\N	\N	5435	5435	5436
1683	1476	0	applied	\N	\N	\N	\N	5439	5439	5440
1684	1477	0	applied	\N	\N	\N	\N	5443	5443	5444
1687	1479	0	applied	\N	\N	\N	\N	5447	5447	5448
1690	1482	0	applied	\N	\N	\N	\N	5455	5455	5456
1690	1483	1	applied	\N	\N	\N	\N	5457	5457	5458
1695	1487	0	applied	\N	\N	\N	\N	5481	5481	5482
1698	1493	0	applied	\N	\N	\N	\N	5496	5496	5497
1662	1461	3	applied	\N	\N	\N	\N	5390	5390	5391
1665	1462	0	applied	\N	\N	\N	\N	5397	5397	5398
1665	1463	1	applied	\N	\N	\N	\N	5399	5399	5400
1667	1462	0	applied	\N	\N	\N	\N	5397	5397	5398
1667	1463	1	applied	\N	\N	\N	\N	5399	5399	5400
1670	1466	0	applied	\N	\N	\N	\N	5410	5410	5411
1670	1467	1	applied	\N	\N	\N	\N	5412	5412	5413
1672	1468	0	applied	\N	\N	\N	\N	5414	5414	5415
1673	1469	0	applied	\N	\N	\N	\N	5417	5417	5418
1673	1470	1	applied	\N	\N	\N	\N	5419	5419	5420
1673	1471	2	applied	\N	\N	\N	\N	5421	5421	5422
1673	1472	3	applied	\N	\N	\N	\N	5423	5423	5424
1676	1473	0	applied	\N	\N	\N	\N	5429	5429	5430
1679	1474	0	applied	\N	\N	\N	\N	5431	5431	5432
1682	1476	0	applied	\N	\N	\N	\N	5439	5439	5440
1685	1478	0	applied	\N	\N	\N	\N	5445	5445	5446
1688	1480	0	applied	\N	\N	\N	\N	5451	5451	5452
1691	1455	0	applied	\N	\N	\N	\N	5371	5371	5461
1691	1456	1	applied	\N	\N	\N	\N	5373	5373	5462
1691	1457	2	applied	\N	\N	\N	\N	5377	5377	5463
1691	1458	3	applied	\N	\N	\N	\N	5384	5384	5464
1691	1459	4	applied	\N	\N	\N	\N	5386	5386	5465
1691	1460	5	applied	\N	\N	\N	\N	5388	5388	5466
1691	1461	6	applied	\N	\N	\N	\N	5390	5390	5467
1691	1462	7	applied	\N	\N	\N	\N	5397	5397	5468
1694	1486	0	applied	\N	\N	\N	\N	5479	5479	5480
1697	1489	0	applied	\N	\N	\N	\N	5487	5487	5488
1697	1490	1	applied	\N	\N	\N	\N	5489	5489	5488
1697	1491	2	applied	\N	\N	\N	\N	5490	5490	5491
1697	1492	3	applied	\N	\N	\N	\N	5492	5492	5493
1702	1494	0	applied	\N	\N	\N	\N	5498	5498	5499
1703	1494	0	applied	\N	\N	\N	\N	5498	5498	5499
1704	1494	0	applied	\N	\N	\N	\N	5498	5498	5499
1706	1494	0	applied	\N	\N	\N	\N	5498	5498	5499
1706	1495	1	applied	\N	\N	\N	\N	5505	5505	5506
1707	1494	0	applied	\N	\N	\N	\N	5498	5498	5499
1707	1495	1	applied	\N	\N	\N	\N	5505	5505	5506
1708	1425	0	applied	\N	\N	\N	\N	5147	5147	5511
1708	1426	1	applied	\N	\N	\N	\N	5152	5152	5512
1708	1427	2	applied	\N	\N	\N	\N	5187	5187	5513
1708	1428	3	applied	\N	\N	\N	\N	5189	5189	5514
1708	1429	4	applied	\N	\N	\N	\N	5193	5193	5515
1708	1430	5	applied	\N	\N	\N	\N	5198	5198	5516
1708	1431	6	applied	\N	\N	\N	\N	5200	5200	5517
1708	1432	7	applied	\N	\N	\N	\N	5202	5202	5518
1708	1433	8	applied	\N	\N	\N	\N	5204	5204	5519
1708	1434	9	applied	\N	\N	\N	\N	5208	5208	5520
1708	1435	10	applied	\N	\N	\N	\N	5214	5214	5521
1708	1436	11	applied	\N	\N	\N	\N	5218	5218	5522
1708	1437	12	applied	\N	\N	\N	\N	5223	5223	5523
1708	1438	13	applied	\N	\N	\N	\N	5279	5279	5524
1708	1439	14	applied	\N	\N	\N	\N	5283	5283	5525
1708	1440	15	applied	\N	\N	\N	\N	5287	5287	5526
1708	1441	16	applied	\N	\N	\N	\N	5295	5295	5527
1708	1442	17	applied	\N	\N	\N	\N	5297	5297	5528
1708	1443	18	applied	\N	\N	\N	\N	5301	5301	5529
1708	1444	19	applied	\N	\N	\N	\N	5303	5303	5530
1708	1445	20	applied	\N	\N	\N	\N	5307	5307	5531
1708	1446	21	applied	\N	\N	\N	\N	5313	5313	5532
1708	1447	22	applied	\N	\N	\N	\N	5316	5316	5533
1708	1448	23	applied	\N	\N	\N	\N	5320	5320	5534
1708	1449	24	applied	\N	\N	\N	\N	5324	5324	5535
1708	1450	25	applied	\N	\N	\N	\N	5346	5346	5536
1708	1451	26	applied	\N	\N	\N	\N	5348	5348	5537
1708	1452	27	applied	\N	\N	\N	\N	5352	5352	5538
1708	1453	28	applied	\N	\N	\N	\N	5356	5356	5539
1708	1454	29	applied	\N	\N	\N	\N	5364	5364	5540
1708	1455	30	applied	\N	\N	\N	\N	5371	5371	5541
1708	1456	31	applied	\N	\N	\N	\N	5373	5373	5542
1708	1457	32	applied	\N	\N	\N	\N	5377	5377	5543
1708	1458	33	applied	\N	\N	\N	\N	5384	5384	5544
1708	1459	34	applied	\N	\N	\N	\N	5386	5386	5545
1708	1460	35	applied	\N	\N	\N	\N	5388	5388	5546
1708	1461	36	applied	\N	\N	\N	\N	5390	5390	5547
1708	1462	37	applied	\N	\N	\N	\N	5397	5397	5548
1708	1463	38	applied	\N	\N	\N	\N	5399	5399	5549
1708	1464	39	applied	\N	\N	\N	\N	5406	5406	5550
1708	1465	40	applied	\N	\N	\N	\N	5408	5408	5551
1708	1466	41	applied	\N	\N	\N	\N	5410	5410	5552
1708	1467	42	applied	\N	\N	\N	\N	5412	5412	5553
1708	1468	43	applied	\N	\N	\N	\N	5414	5414	5554
1708	1469	44	applied	\N	\N	\N	\N	5417	5417	5555
1708	1470	45	applied	\N	\N	\N	\N	5419	5419	5556
1708	1471	46	applied	\N	\N	\N	\N	5421	5421	5557
1708	1472	47	applied	\N	\N	\N	\N	5423	5423	5558
1708	1473	48	applied	\N	\N	\N	\N	5429	5429	5559
1708	1474	49	applied	\N	\N	\N	\N	5431	5431	5560
1708	1475	50	applied	\N	\N	\N	\N	5435	5435	5561
1708	1476	51	applied	\N	\N	\N	\N	5439	5439	5562
1708	1477	52	applied	\N	\N	\N	\N	5443	5443	5563
1708	1478	53	applied	\N	\N	\N	\N	5445	5445	5564
1708	1479	54	applied	\N	\N	\N	\N	5447	5447	5565
1708	1480	55	applied	\N	\N	\N	\N	5451	5451	5566
1708	1481	56	applied	\N	\N	\N	\N	5453	5453	5567
1708	1482	57	applied	\N	\N	\N	\N	5455	5455	5568
1708	1483	58	applied	\N	\N	\N	\N	5457	5457	5569
1708	1484	59	applied	\N	\N	\N	\N	5471	5471	5570
1708	1485	60	applied	\N	\N	\N	\N	5473	5473	5571
1708	1486	61	applied	\N	\N	\N	\N	5479	5479	5572
1708	1487	62	applied	\N	\N	\N	\N	5481	5481	5573
1708	1488	63	applied	\N	\N	\N	\N	5483	5483	5574
1708	1491	64	applied	\N	\N	\N	\N	5490	5490	5575
1708	1492	65	applied	\N	\N	\N	\N	5492	5492	5576
1708	1493	66	applied	\N	\N	\N	\N	5496	5496	5577
1708	1494	67	applied	\N	\N	\N	\N	5498	5498	5578
1708	1495	68	applied	\N	\N	\N	\N	5505	5505	5579
1708	1496	69	applied	\N	\N	\N	\N	5580	5580	5581
1708	1305	70	applied	\N	\N	\N	\N	4602	4602	4603
1708	1489	71	applied	\N	\N	\N	\N	5487	5487	5488
1708	1490	72	applied	\N	\N	\N	\N	5489	5489	5488
1709	1496	0	applied	\N	\N	\N	\N	5580	5580	5584
1709	1497	1	applied	\N	\N	\N	\N	5585	5585	5488
1709	1498	2	applied	\N	\N	\N	\N	5586	5586	5587
1709	1499	3	applied	\N	\N	\N	\N	5588	5588	5589
1710	1500	0	applied	\N	\N	\N	\N	5591	5591	5592
1710	1501	1	applied	\N	\N	1000000000	\N	5593	5593	5594
1711	1500	0	applied	\N	\N	\N	\N	5591	5591	5592
1711	1501	1	applied	\N	\N	1000000000	\N	5593	5593	5594
1715	1502	0	applied	\N	\N	\N	\N	5601	5601	5602
1715	1503	1	applied	\N	\N	\N	\N	5603	5603	5604
1719	1505	0	applied	\N	\N	\N	\N	5609	5609	5610
1720	1505	0	applied	\N	\N	\N	\N	5609	5609	5610
1721	1506	0	applied	\N	\N	\N	\N	5619	5619	5620
1721	1507	1	applied	\N	\N	\N	\N	5621	5621	5622
1721	1508	2	applied	\N	\N	\N	\N	5623	5623	5624
1721	1509	3	applied	\N	\N	\N	\N	5625	5625	5626
1727	1514	0	applied	\N	\N	\N	\N	5640	5640	5641
1730	1516	0	applied	\N	\N	\N	\N	5648	5648	5649
1730	1517	1	applied	\N	\N	\N	\N	5650	5650	5651
1735	1518	0	applied	\N	\N	\N	\N	5656	5656	5657
1736	1519	0	applied	\N	\N	\N	\N	5666	5666	5667
1741	1520	0	applied	\N	\N	\N	\N	5673	5673	5674
1741	1521	1	applied	\N	\N	\N	\N	5676	5676	5677
1742	1522	0	applied	\N	\N	\N	\N	5680	5680	5681
1747	1524	0	applied	\N	\N	\N	\N	5689	5689	5690
1747	1525	1	applied	\N	\N	\N	\N	5691	5691	5692
1749	1524	0	applied	\N	\N	\N	\N	5689	5689	5690
1749	1525	1	applied	\N	\N	\N	\N	5691	5691	5692
1751	1526	0	applied	\N	\N	\N	\N	5697	5697	5698
1756	1528	0	applied	\N	\N	\N	\N	5708	5708	5709
1757	1529	0	applied	\N	\N	\N	\N	5710	5710	5711
1757	1530	1	applied	\N	\N	\N	\N	5712	5712	5713
1760	1531	0	applied	\N	\N	\N	\N	5714	5714	5715
1763	1535	0	applied	\N	\N	\N	\N	5724	5724	5725
1769	1539	0	applied	\N	\N	\N	\N	5737	5737	5738
1772	1545	0	applied	\N	\N	\N	\N	5753	5753	5754
1772	1546	1	applied	\N	\N	\N	\N	5755	5755	5756
1774	1547	0	applied	\N	\N	\N	\N	5759	5759	5760
1779	1548	0	applied	\N	\N	\N	\N	5766	5766	5767
1781	1549	0	applied	\N	\N	\N	\N	5774	5774	5775
1781	1550	1	applied	\N	\N	\N	\N	5776	5776	5777
1784	1551	0	applied	\N	\N	\N	\N	5779	5779	5780
1787	1552	0	applied	\N	\N	\N	\N	5783	5783	5784
1787	1553	1	applied	\N	\N	\N	\N	5785	5785	5786
1787	1554	2	applied	\N	\N	\N	\N	5787	5787	5788
1787	1555	3	applied	\N	\N	\N	\N	5789	5789	5790
1787	1556	4	applied	\N	\N	\N	\N	5791	5791	5792
1789	1557	0	applied	\N	\N	\N	\N	5796	5796	5797
1790	1557	0	applied	\N	\N	\N	\N	5796	5796	5797
1793	1488	0	applied	\N	\N	\N	\N	5483	5483	5484
1793	1501	1	applied	\N	\N	1000000000	\N	5593	5593	5594
1793	1491	2	applied	\N	\N	\N	\N	5490	5490	5491
1793	1492	3	applied	\N	\N	\N	\N	5492	5492	5493
1793	1493	4	applied	\N	\N	\N	\N	5496	5496	5497
1793	1494	5	applied	\N	\N	\N	\N	5498	5498	5499
1793	1495	6	applied	\N	\N	\N	\N	5505	5505	5506
1793	1496	7	applied	\N	\N	\N	\N	5580	5580	5584
1793	1498	8	applied	\N	\N	\N	\N	5586	5586	5587
1793	1499	9	applied	\N	\N	\N	\N	5588	5588	5589
1793	1500	10	applied	\N	\N	\N	\N	5591	5591	5592
1793	1502	11	applied	\N	\N	\N	\N	5601	5601	5602
1793	1503	12	applied	\N	\N	\N	\N	5603	5603	5604
1793	1504	13	applied	\N	\N	\N	\N	5607	5607	5608
1793	1505	14	applied	\N	\N	\N	\N	5609	5609	5610
1793	1506	15	applied	\N	\N	\N	\N	5619	5619	5620
1793	1507	16	applied	\N	\N	\N	\N	5621	5621	5622
1793	1508	17	applied	\N	\N	\N	\N	5623	5623	5624
1793	1509	18	applied	\N	\N	\N	\N	5625	5625	5626
1793	1510	19	applied	\N	\N	\N	\N	5628	5628	5629
1793	1511	20	applied	\N	\N	\N	\N	5630	5630	5631
1793	1512	21	applied	\N	\N	\N	\N	5635	5635	5636
1793	1513	22	applied	\N	\N	\N	\N	5637	5637	5638
1793	1514	23	applied	\N	\N	\N	\N	5640	5640	5641
1793	1515	24	applied	\N	\N	\N	\N	5644	5644	5645
1793	1516	25	applied	\N	\N	\N	\N	5648	5648	5649
1796	1560	0	applied	\N	\N	\N	\N	5808	5808	5809
1796	1561	1	applied	\N	\N	\N	\N	5813	5813	5814
1796	1562	2	applied	\N	\N	\N	\N	5815	5815	5816
1802	1568	0	applied	\N	\N	\N	\N	5832	5832	5833
1806	1572	0	applied	\N	\N	\N	\N	5846	5846	5847
1810	1574	0	applied	\N	\N	\N	\N	5854	5854	5855
1811	1574	0	applied	\N	\N	\N	\N	5854	5854	5855
1815	1578	0	applied	\N	\N	\N	\N	5871	5871	5872
1815	1579	1	applied	\N	\N	\N	\N	5873	5873	5874
1819	1583	0	applied	\N	\N	\N	\N	5884	5884	5885
1819	1584	1	applied	\N	\N	\N	\N	5886	5886	5887
1821	1585	0	applied	\N	\N	\N	\N	5889	5889	5890
1825	1585	0	applied	\N	\N	\N	\N	5889	5889	5890
1828	1588	0	applied	\N	\N	\N	\N	5902	5902	5903
1830	1588	0	applied	\N	\N	\N	\N	5902	5902	5903
1831	1589	0	applied	\N	\N	\N	\N	5908	5908	5909
1833	1589	0	applied	\N	\N	\N	\N	5908	5908	5909
1837	1591	0	applied	\N	\N	\N	\N	5919	5919	5920
1840	1593	0	applied	\N	\N	\N	\N	5927	5927	5928
1842	1594	0	applied	\N	\N	\N	\N	5931	5931	5932
1843	1595	0	applied	\N	\N	\N	\N	5937	5937	5938
1846	1596	0	applied	\N	\N	\N	\N	5943	5943	5944
1849	1596	0	applied	\N	\N	\N	\N	5943	5943	5944
1851	1597	0	applied	\N	\N	\N	\N	5951	5951	5952
1852	1597	0	applied	\N	\N	\N	\N	5951	5951	5952
1855	1599	0	applied	\N	\N	\N	\N	5958	5958	5959
1858	1601	0	applied	\N	\N	\N	\N	5964	5964	5965
1858	1602	1	applied	\N	\N	\N	\N	5966	5966	5967
1861	1603	0	applied	\N	\N	\N	\N	5973	5973	5974
1864	1604	0	applied	\N	\N	\N	\N	5979	5979	5980
1867	1606	0	applied	\N	\N	\N	\N	5989	5989	5990
1869	1607	0	applied	\N	\N	\N	\N	5994	5994	5995
1870	1607	0	applied	\N	\N	\N	\N	5994	5994	5995
1716	1504	0	applied	\N	\N	\N	\N	5607	5607	5608
1718	1497	0	applied	\N	\N	\N	\N	5585	5585	5488
1718	1495	1	applied	\N	\N	\N	\N	5505	5505	5506
1718	1496	2	applied	\N	\N	\N	\N	5580	5580	5584
1718	1498	3	applied	\N	\N	\N	\N	5586	5586	5587
1718	1501	4	applied	\N	\N	1000000000	\N	5593	5593	5594
1718	1499	5	applied	\N	\N	\N	\N	5588	5588	5589
1718	1500	6	applied	\N	\N	\N	\N	5591	5591	5592
1718	1502	7	applied	\N	\N	\N	\N	5601	5601	5602
1718	1503	8	applied	\N	\N	\N	\N	5603	5603	5604
1718	1504	9	applied	\N	\N	\N	\N	5607	5607	5608
1718	1505	10	applied	\N	\N	\N	\N	5609	5609	5610
1724	1510	0	applied	\N	\N	\N	\N	5628	5628	5629
1724	1511	1	applied	\N	\N	\N	\N	5630	5630	5631
1725	1512	0	applied	\N	\N	\N	\N	5635	5635	5636
1731	1516	0	applied	\N	\N	\N	\N	5648	5648	5649
1731	1517	1	applied	\N	\N	\N	\N	5650	5650	5651
1733	1518	0	applied	\N	\N	\N	\N	5656	5656	5657
1737	1519	0	applied	\N	\N	\N	\N	5666	5666	5667
1739	1520	0	applied	\N	\N	\N	\N	5673	5673	5674
1740	1520	0	applied	\N	\N	\N	\N	5673	5673	5674
1740	1521	1	applied	\N	\N	\N	\N	5676	5676	5677
1743	1522	0	applied	\N	\N	\N	\N	5680	5680	5681
1745	1523	0	applied	\N	\N	\N	\N	5683	5683	5684
1746	1524	0	applied	\N	\N	\N	\N	5689	5689	5690
1746	1525	1	applied	\N	\N	\N	\N	5691	5691	5692
1748	1524	0	applied	\N	\N	\N	\N	5689	5689	5690
1748	1525	1	applied	\N	\N	\N	\N	5691	5691	5692
1754	1527	0	applied	\N	\N	\N	\N	5704	5704	5705
1755	1528	0	applied	\N	\N	\N	\N	5708	5708	5709
1761	1531	0	applied	\N	\N	\N	\N	5714	5714	5715
1764	1536	0	applied	\N	\N	\N	\N	5726	5726	5727
1767	1538	0	applied	\N	\N	\N	\N	5734	5734	5735
1770	1540	0	applied	\N	\N	\N	\N	5741	5741	5742
1770	1541	1	applied	\N	\N	\N	\N	5743	5743	5744
1770	1542	2	applied	\N	\N	\N	\N	5745	5745	5746
1773	1547	0	applied	\N	\N	\N	\N	5759	5759	5760
1775	1547	0	applied	\N	\N	\N	\N	5759	5759	5760
1776	1547	0	applied	\N	\N	\N	\N	5759	5759	5760
1778	1548	0	applied	\N	\N	\N	\N	5766	5766	5767
1782	1549	0	applied	\N	\N	\N	\N	5774	5774	5775
1782	1550	1	applied	\N	\N	\N	\N	5776	5776	5777
1785	1551	0	applied	\N	\N	\N	\N	5779	5779	5780
1786	1552	0	applied	\N	\N	\N	\N	5783	5783	5784
1786	1553	1	applied	\N	\N	\N	\N	5785	5785	5786
1786	1554	2	applied	\N	\N	\N	\N	5787	5787	5788
1786	1555	3	applied	\N	\N	\N	\N	5789	5789	5790
1786	1556	4	applied	\N	\N	\N	\N	5791	5791	5792
1792	1560	0	applied	\N	\N	\N	\N	5808	5808	5809
1795	1560	0	applied	\N	\N	\N	\N	5808	5808	5809
1798	1564	0	applied	\N	\N	1000000000	\N	5821	5821	5822
1798	1565	1	applied	\N	\N	\N	\N	5823	5823	5824
1798	1566	2	applied	\N	\N	\N	\N	5825	5825	5826
1801	1568	0	applied	\N	\N	\N	\N	5832	5832	5833
1803	1568	0	applied	\N	\N	\N	\N	5832	5832	5833
1804	1569	0	applied	\N	\N	\N	\N	5837	5837	5838
1804	1570	1	applied	\N	\N	\N	\N	5839	5839	5840
1804	1571	2	applied	\N	\N	\N	\N	5841	5841	5821
1807	1573	0	applied	\N	\N	\N	\N	5850	5850	5851
1813	1577	0	applied	\N	\N	\N	\N	5865	5865	5866
1820	1585	0	applied	\N	\N	\N	\N	5889	5889	5890
1826	1586	0	applied	\N	\N	\N	\N	5898	5898	5899
1835	1589	0	applied	\N	\N	\N	\N	5908	5908	5909
1835	1590	1	applied	\N	\N	\N	\N	5915	5915	5916
1838	1592	0	applied	\N	\N	\N	\N	5923	5923	5924
1841	1594	0	applied	\N	\N	\N	\N	5931	5931	5932
1845	1594	0	applied	\N	\N	\N	\N	5931	5931	5932
1845	1595	1	applied	\N	\N	\N	\N	5937	5937	5938
1847	1596	0	applied	\N	\N	\N	\N	5943	5943	5944
1848	1596	0	applied	\N	\N	\N	\N	5943	5943	5944
1854	1598	0	applied	\N	\N	\N	\N	5956	5956	5957
1857	1600	0	applied	\N	\N	\N	\N	5960	5960	5961
1859	1601	0	applied	\N	\N	\N	\N	5964	5964	5965
1859	1602	1	applied	\N	\N	\N	\N	5966	5966	5967
1860	1601	0	applied	\N	\N	\N	\N	5964	5964	5965
1860	1602	1	applied	\N	\N	\N	\N	5966	5966	5967
1863	1604	0	applied	\N	\N	\N	\N	5979	5979	5980
1866	1605	0	applied	\N	\N	\N	\N	5983	5983	5984
1717	1505	0	applied	\N	\N	\N	\N	5609	5609	5610
1722	1506	0	applied	\N	\N	\N	\N	5619	5619	5620
1722	1507	1	applied	\N	\N	\N	\N	5621	5621	5622
1722	1508	2	applied	\N	\N	\N	\N	5623	5623	5624
1722	1509	3	applied	\N	\N	\N	\N	5625	5625	5626
1723	1510	0	applied	\N	\N	\N	\N	5628	5628	5629
1723	1511	1	applied	\N	\N	\N	\N	5630	5630	5631
1726	1513	0	applied	\N	\N	\N	\N	5637	5637	5638
1728	1506	0	applied	\N	\N	\N	\N	5619	5619	5620
1728	1507	1	applied	\N	\N	\N	\N	5621	5621	5622
1728	1508	2	applied	\N	\N	\N	\N	5623	5623	5624
1728	1509	3	applied	\N	\N	\N	\N	5625	5625	5626
1728	1510	4	applied	\N	\N	\N	\N	5628	5628	5629
1728	1511	5	applied	\N	\N	\N	\N	5630	5630	5631
1728	1512	6	applied	\N	\N	\N	\N	5635	5635	5636
1728	1513	7	applied	\N	\N	\N	\N	5637	5637	5638
1728	1514	8	applied	\N	\N	\N	\N	5640	5640	5641
1729	1515	0	applied	\N	\N	\N	\N	5644	5644	5645
1732	1518	0	applied	\N	\N	\N	\N	5656	5656	5657
1734	1518	0	applied	\N	\N	\N	\N	5656	5656	5657
1744	1523	0	applied	\N	\N	\N	\N	5683	5683	5684
1750	1526	0	applied	\N	\N	\N	\N	5697	5697	5698
1752	1526	0	applied	\N	\N	\N	\N	5697	5697	5698
1753	1527	0	applied	\N	\N	\N	\N	5704	5704	5705
1758	1529	0	applied	\N	\N	\N	\N	5710	5710	5711
1758	1530	1	applied	\N	\N	\N	\N	5712	5712	5713
1759	1531	0	applied	\N	\N	\N	\N	5714	5714	5715
1762	1532	0	applied	\N	\N	\N	\N	5716	5716	5717
1762	1533	1	applied	\N	\N	\N	\N	5718	5718	5719
1762	1534	2	applied	\N	\N	\N	\N	5720	5720	5721
1765	1537	0	applied	\N	\N	\N	\N	5730	5730	5731
1771	1543	0	applied	\N	\N	\N	\N	5748	5748	5749
1771	1544	1	applied	\N	\N	\N	\N	5750	5750	5751
1777	1548	0	applied	\N	\N	\N	\N	5766	5766	5767
1780	1548	0	applied	\N	\N	\N	\N	5766	5766	5767
1783	1549	0	applied	\N	\N	\N	\N	5774	5774	5775
1783	1550	1	applied	\N	\N	\N	\N	5776	5776	5777
1788	1557	0	applied	\N	\N	\N	\N	5796	5796	5797
1791	1558	0	applied	\N	\N	\N	\N	5803	5803	5804
1791	1559	1	applied	\N	\N	\N	\N	5805	5805	5806
1797	1563	0	applied	\N	\N	\N	\N	5819	5819	5820
1799	1564	0	applied	\N	\N	1000000000	\N	5821	5821	5822
1799	1565	1	applied	\N	\N	\N	\N	5823	5823	5824
1799	1566	2	applied	\N	\N	\N	\N	5825	5825	5826
1800	1567	0	applied	\N	\N	\N	\N	5830	5830	5831
1805	1569	0	applied	\N	\N	\N	\N	5837	5837	5838
1805	1570	1	applied	\N	\N	\N	\N	5839	5839	5840
1805	1571	2	applied	\N	\N	\N	\N	5841	5841	5821
1808	1573	0	applied	\N	\N	\N	\N	5850	5850	5851
1809	1574	0	applied	\N	\N	\N	\N	5854	5854	5855
1812	1575	0	applied	\N	\N	\N	\N	5860	5860	5861
1812	1576	1	applied	\N	\N	\N	\N	5862	5862	5863
1814	1577	0	applied	\N	\N	\N	\N	5865	5865	5866
1817	1578	0	applied	\N	\N	\N	\N	5871	5871	5872
1817	1579	1	applied	\N	\N	\N	\N	5873	5873	5874
1817	1580	2	applied	\N	\N	\N	\N	5875	5875	5876
1817	1581	3	applied	\N	\N	\N	\N	5877	5877	5878
1818	1582	0	applied	\N	\N	\N	\N	5880	5880	5881
1824	1585	0	applied	\N	\N	\N	\N	5889	5889	5890
1827	1587	0	applied	\N	\N	\N	\N	5900	5900	5901
1829	1588	0	applied	\N	\N	\N	\N	5902	5902	5903
1832	1589	0	applied	\N	\N	\N	\N	5908	5908	5909
1836	1591	0	applied	\N	\N	\N	\N	5919	5919	5920
1839	1593	0	applied	\N	\N	\N	\N	5927	5927	5928
1844	1595	0	applied	\N	\N	\N	\N	5937	5937	5938
1850	1597	0	applied	\N	\N	\N	\N	5951	5951	5952
1853	1598	0	applied	\N	\N	\N	\N	5956	5956	5957
1856	1599	0	applied	\N	\N	\N	\N	5958	5958	5959
1862	1603	0	applied	\N	\N	\N	\N	5973	5973	5974
1865	1605	0	applied	\N	\N	\N	\N	5983	5983	5984
1868	1522	0	applied	\N	\N	\N	\N	5680	5680	5681
1868	1523	1	applied	\N	\N	\N	\N	5683	5683	5684
1868	1524	2	applied	\N	\N	\N	\N	5689	5689	5690
1868	1525	3	applied	\N	\N	\N	\N	5691	5691	5692
1868	1526	4	applied	\N	\N	\N	\N	5697	5697	5698
1868	1527	5	applied	\N	\N	\N	\N	5704	5704	5705
1868	1528	6	applied	\N	\N	\N	\N	5708	5708	5709
1868	1529	7	applied	\N	\N	\N	\N	5710	5710	5711
1868	1530	8	applied	\N	\N	\N	\N	5712	5712	5713
1868	1531	9	applied	\N	\N	\N	\N	5714	5714	5715
1868	1532	10	applied	\N	\N	\N	\N	5716	5716	5717
1868	1533	11	applied	\N	\N	\N	\N	5718	5718	5719
1868	1534	12	applied	\N	\N	\N	\N	5720	5720	5721
1868	1535	13	applied	\N	\N	\N	\N	5724	5724	5725
1868	1536	14	applied	\N	\N	\N	\N	5726	5726	5727
1868	1537	15	applied	\N	\N	\N	\N	5730	5730	5731
1868	1538	16	applied	\N	\N	\N	\N	5734	5734	5735
1868	1539	17	applied	\N	\N	\N	\N	5737	5737	5738
1868	1540	18	applied	\N	\N	\N	\N	5741	5741	5742
1868	1541	19	applied	\N	\N	\N	\N	5743	5743	5744
1868	1542	20	applied	\N	\N	\N	\N	5745	5745	5746
1868	1543	21	applied	\N	\N	\N	\N	5748	5748	5749
1868	1544	22	applied	\N	\N	\N	\N	5750	5750	5751
1868	1545	23	applied	\N	\N	\N	\N	5753	5753	5754
1868	1546	24	applied	\N	\N	\N	\N	5755	5755	5756
1868	1547	25	applied	\N	\N	\N	\N	5759	5759	5760
1868	1548	26	applied	\N	\N	\N	\N	5766	5766	5767
1868	1549	27	applied	\N	\N	\N	\N	5774	5774	5775
1868	1550	28	applied	\N	\N	\N	\N	5776	5776	5777
1868	1551	29	applied	\N	\N	\N	\N	5779	5779	5780
1868	1552	30	applied	\N	\N	\N	\N	5783	5783	5784
1868	1553	31	applied	\N	\N	\N	\N	5785	5785	5786
1868	1554	32	applied	\N	\N	\N	\N	5787	5787	5788
1868	1555	33	applied	\N	\N	\N	\N	5789	5789	5790
1868	1556	34	applied	\N	\N	\N	\N	5791	5791	5792
1868	1557	35	applied	\N	\N	\N	\N	5796	5796	5797
1868	1558	36	applied	\N	\N	\N	\N	5803	5803	5804
1868	1559	37	applied	\N	\N	\N	\N	5805	5805	5806
1868	1560	38	applied	\N	\N	\N	\N	5808	5808	5809
1868	1561	39	applied	\N	\N	\N	\N	5813	5813	5814
1868	1562	40	applied	\N	\N	\N	\N	5815	5815	5816
1868	1563	41	applied	\N	\N	\N	\N	5819	5819	5820
1868	1565	42	applied	\N	\N	\N	\N	5823	5823	5824
1868	1566	43	applied	\N	\N	\N	\N	5825	5825	5826
1868	1567	44	applied	\N	\N	\N	\N	5830	5830	5831
1868	1568	45	applied	\N	\N	\N	\N	5832	5832	5833
1868	1569	46	applied	\N	\N	\N	\N	5837	5837	5838
1868	1570	47	applied	\N	\N	\N	\N	5839	5839	5840
1868	1572	48	applied	\N	\N	\N	\N	5846	5846	5847
1868	1573	49	applied	\N	\N	\N	\N	5850	5850	5851
1868	1574	50	applied	\N	\N	\N	\N	5854	5854	5855
1868	1575	51	applied	\N	\N	\N	\N	5860	5860	5861
1868	1576	52	applied	\N	\N	\N	\N	5862	5862	5863
1868	1577	53	applied	\N	\N	\N	\N	5865	5865	5866
1868	1578	54	applied	\N	\N	\N	\N	5871	5871	5872
1868	1579	55	applied	\N	\N	\N	\N	5873	5873	5874
1868	1580	56	applied	\N	\N	\N	\N	5875	5875	5876
1868	1581	57	applied	\N	\N	\N	\N	5877	5877	5878
1868	1582	58	applied	\N	\N	\N	\N	5880	5880	5881
1868	1583	59	applied	\N	\N	\N	\N	5884	5884	5885
1868	1584	60	applied	\N	\N	\N	\N	5886	5886	5887
1868	1585	61	applied	\N	\N	\N	\N	5889	5889	5890
1868	1586	62	applied	\N	\N	\N	\N	5898	5898	5899
1868	1587	63	applied	\N	\N	\N	\N	5900	5900	5901
1868	1588	64	applied	\N	\N	\N	\N	5902	5902	5903
1868	1589	65	applied	\N	\N	\N	\N	5908	5908	5909
1868	1590	66	applied	\N	\N	\N	\N	5915	5915	5916
1868	1591	67	applied	\N	\N	\N	\N	5919	5919	5920
1868	1592	68	applied	\N	\N	\N	\N	5923	5923	5924
1868	1593	69	applied	\N	\N	\N	\N	5927	5927	5928
1868	1594	70	applied	\N	\N	\N	\N	5931	5931	5932
1868	1595	71	applied	\N	\N	\N	\N	5937	5937	5938
1868	1596	72	applied	\N	\N	\N	\N	5943	5943	5944
1868	1597	73	applied	\N	\N	\N	\N	5951	5951	5952
1868	1598	74	applied	\N	\N	\N	\N	5956	5956	5957
1868	1599	75	applied	\N	\N	\N	\N	5958	5958	5959
1868	1600	76	applied	\N	\N	\N	\N	5960	5960	5961
1868	1601	77	applied	\N	\N	\N	\N	5964	5964	5965
1868	1602	78	applied	\N	\N	\N	\N	5966	5966	5967
1868	1603	79	applied	\N	\N	\N	\N	5973	5973	5974
1871	1607	0	applied	\N	\N	\N	\N	5994	5994	5995
1872	1608	0	applied	\N	\N	\N	\N	6002	6002	6003
1872	1609	2	applied	\N	\N	\N	\N	6005	6005	6006
1873	1608	0	applied	\N	\N	\N	\N	6002	6002	6003
1873	1609	2	applied	\N	\N	\N	\N	6005	6005	6006
1874	1608	0	applied	\N	\N	\N	\N	6002	6002	6003
1874	1609	2	applied	\N	\N	\N	\N	6005	6005	6006
1875	1610	0	applied	\N	\N	\N	\N	6011	6011	6012
1876	1610	0	applied	\N	\N	\N	\N	6011	6011	6012
1877	1610	0	applied	\N	\N	\N	\N	6011	6011	6012
1878	1610	0	applied	\N	\N	\N	\N	6011	6011	6012
1879	1611	0	applied	\N	\N	\N	\N	6018	6018	6019
1879	1612	1	applied	\N	\N	\N	\N	6020	6020	6021
1880	1613	0	applied	\N	\N	\N	\N	6024	6024	6025
1881	1613	0	applied	\N	\N	\N	\N	6024	6024	6025
1882	1614	0	applied	\N	\N	\N	\N	6028	6028	6029
1883	1615	0	applied	\N	\N	\N	\N	6030	6030	6031
1884	1615	0	applied	\N	\N	\N	\N	6030	6030	6031
1885	1615	0	applied	\N	\N	\N	\N	6030	6030	6031
1886	1616	0	applied	\N	\N	\N	\N	6036	6036	6037
1886	1617	1	applied	\N	\N	\N	\N	6038	6038	6039
1887	1618	0	applied	\N	\N	\N	\N	6042	6042	6043
1888	1618	0	applied	\N	\N	\N	\N	6042	6042	6043
1889	1619	0	applied	\N	\N	\N	\N	6047	6047	6048
1890	1619	0	applied	\N	\N	\N	\N	6047	6047	6048
1891	1620	0	applied	\N	\N	\N	\N	6049	6049	6050
1892	1621	0	applied	\N	\N	\N	\N	6053	6053	6054
1893	1622	0	applied	\N	\N	\N	\N	6057	6057	6058
1894	1622	0	applied	\N	\N	\N	\N	6057	6057	6058
1895	1623	0	applied	\N	\N	\N	\N	6061	6061	6062
1896	1624	0	applied	\N	\N	\N	\N	6063	6063	6064
1896	1625	1	applied	\N	\N	\N	\N	6065	6065	6066
1896	1626	2	applied	\N	\N	\N	\N	6067	6067	6068
1897	1627	0	applied	\N	\N	\N	\N	6071	6071	6072
1898	1627	0	applied	\N	\N	\N	\N	6071	6071	6072
1899	1628	0	applied	\N	\N	\N	\N	6075	6075	6076
1899	1629	1	applied	\N	\N	\N	\N	6077	6077	6078
1899	1630	2	applied	\N	\N	\N	\N	6079	6079	6080
1900	1631	0	applied	\N	\N	\N	\N	6082	6082	6083
1901	1631	0	applied	\N	\N	\N	\N	6082	6082	6083
1902	1631	0	applied	\N	\N	\N	\N	6082	6082	6083
1903	1632	0	applied	\N	\N	\N	\N	6084	6084	6085
1904	1632	0	applied	\N	\N	\N	\N	6084	6084	6085
1905	1633	0	applied	\N	\N	\N	\N	6090	6090	6091
1906	1633	0	applied	\N	\N	\N	\N	6090	6090	6091
1907	1633	0	applied	\N	\N	\N	\N	6090	6090	6091
1908	1634	0	applied	\N	\N	\N	\N	6092	6092	6093
1909	1634	0	applied	\N	\N	\N	\N	6092	6092	6093
1910	1634	0	applied	\N	\N	\N	\N	6092	6092	6093
1911	1635	0	applied	\N	\N	\N	\N	6094	6094	6095
1911	1636	1	applied	\N	\N	\N	\N	6096	6096	6097
1911	1637	2	applied	\N	\N	\N	\N	6098	6098	6099
1912	1638	0	applied	\N	\N	\N	\N	6102	6102	6103
1913	1639	0	applied	\N	\N	\N	\N	6106	6106	6107
1914	1640	0	applied	\N	\N	\N	\N	6110	6110	6111
1914	1641	1	applied	\N	\N	\N	\N	6112	6112	1435
1915	1640	0	applied	\N	\N	\N	\N	6110	6110	6111
1915	1641	1	applied	\N	\N	\N	\N	6112	6112	1435
1916	1642	0	applied	\N	\N	\N	\N	6116	6116	6117
1917	1643	0	applied	\N	\N	\N	\N	6119	6119	6120
1918	1644	0	applied	\N	\N	\N	\N	6123	6123	6124
1919	1644	0	applied	\N	\N	\N	\N	6123	6123	6124
1920	1644	0	applied	\N	\N	\N	\N	6123	6123	6124
1921	1644	0	applied	\N	\N	\N	\N	6123	6123	6124
1922	1645	0	applied	\N	\N	\N	\N	6129	6129	6130
1923	1645	0	applied	\N	\N	\N	\N	6129	6129	6130
1924	1645	0	applied	\N	\N	\N	\N	6129	6129	6130
1925	1645	0	applied	\N	\N	\N	\N	6129	6129	6130
1926	1646	0	applied	\N	\N	\N	\N	6131	6131	6132
1926	1647	1	applied	\N	\N	\N	\N	6133	6133	6134
1926	1648	2	applied	\N	\N	\N	\N	6135	6135	6136
1927	1646	0	applied	\N	\N	\N	\N	6131	6131	6132
1927	1647	1	applied	\N	\N	\N	\N	6133	6133	6134
1927	1648	2	applied	\N	\N	\N	\N	6135	6135	6136
1928	1646	0	applied	\N	\N	\N	\N	6131	6131	6132
1928	1647	1	applied	\N	\N	\N	\N	6133	6133	6134
1928	1648	2	applied	\N	\N	\N	\N	6135	6135	6136
1929	1649	0	applied	\N	\N	\N	\N	6140	6140	6141
1930	1649	0	applied	\N	\N	\N	\N	6140	6140	6141
1931	1650	0	applied	\N	\N	\N	\N	6144	6144	6145
1931	1651	1	applied	\N	\N	\N	\N	6146	6146	6147
1932	1652	0	applied	\N	\N	\N	\N	6150	6150	6151
1933	1652	0	applied	\N	\N	\N	\N	6150	6150	6151
1934	1652	0	applied	\N	\N	\N	\N	6150	6150	6151
1935	1650	0	applied	\N	\N	\N	\N	6144	6144	6145
1935	1651	1	applied	\N	\N	\N	\N	6146	6146	6147
1935	1652	2	applied	\N	\N	\N	\N	6150	6150	6151
1936	1653	0	applied	\N	\N	\N	\N	6159	6159	6160
1937	1653	0	applied	\N	\N	\N	\N	6159	6159	6160
1938	1653	0	applied	\N	\N	\N	\N	6159	6159	6160
1939	1654	0	applied	\N	\N	\N	\N	6163	6163	6164
1942	1655	0	applied	\N	\N	\N	\N	6169	6169	6170
1942	1656	1	applied	\N	\N	\N	\N	6171	6171	6172
1946	1636	0	applied	\N	\N	\N	\N	6096	6096	6097
1946	1610	1	applied	\N	\N	\N	\N	6011	6011	6012
1946	1611	2	applied	\N	\N	\N	\N	6018	6018	6019
1946	1612	3	applied	\N	\N	\N	\N	6020	6020	6021
1946	1613	4	applied	\N	\N	\N	\N	6024	6024	6025
1946	1614	5	applied	\N	\N	\N	\N	6028	6028	6029
1946	1615	6	applied	\N	\N	\N	\N	6030	6030	6031
1946	1616	7	applied	\N	\N	\N	\N	6036	6036	6037
1946	1617	8	applied	\N	\N	\N	\N	6038	6038	6039
1946	1618	9	applied	\N	\N	\N	\N	6042	6042	6043
1946	1619	10	applied	\N	\N	\N	\N	6047	6047	6048
1946	1620	11	applied	\N	\N	\N	\N	6049	6049	6050
1946	1621	12	applied	\N	\N	\N	\N	6053	6053	6054
1946	1622	13	applied	\N	\N	\N	\N	6057	6057	6058
1946	1623	14	applied	\N	\N	\N	\N	6061	6061	6062
1946	1624	15	applied	\N	\N	\N	\N	6063	6063	6064
1946	1625	16	applied	\N	\N	\N	\N	6065	6065	6066
1946	1626	17	applied	\N	\N	\N	\N	6067	6067	6068
1946	1627	18	applied	\N	\N	\N	\N	6071	6071	6072
1946	1628	19	applied	\N	\N	\N	\N	6075	6075	6076
1946	1629	20	applied	\N	\N	\N	\N	6077	6077	6078
1946	1630	21	applied	\N	\N	\N	\N	6079	6079	6080
1946	1631	22	applied	\N	\N	\N	\N	6082	6082	6083
1946	1632	23	applied	\N	\N	\N	\N	6084	6084	6085
1946	1633	24	applied	\N	\N	\N	\N	6090	6090	6091
1946	1634	25	applied	\N	\N	\N	\N	6092	6092	6093
1946	1635	26	applied	\N	\N	\N	\N	6094	6094	6095
1946	1637	27	applied	\N	\N	\N	\N	6098	6098	6099
1946	1638	28	applied	\N	\N	\N	\N	6102	6102	6103
1946	1639	29	applied	\N	\N	\N	\N	6106	6106	6107
1946	1640	30	applied	\N	\N	\N	\N	6110	6110	6111
1946	1642	31	applied	\N	\N	\N	\N	6116	6116	6117
1946	1643	32	applied	\N	\N	\N	\N	6119	6119	6120
1946	1644	33	applied	\N	\N	\N	\N	6123	6123	6124
1946	1645	34	applied	\N	\N	\N	\N	6129	6129	6130
1946	1646	35	applied	\N	\N	\N	\N	6131	6131	6132
1946	1647	36	applied	\N	\N	\N	\N	6133	6133	6134
1946	1648	37	applied	\N	\N	\N	\N	6135	6135	6136
1946	1649	38	applied	\N	\N	\N	\N	6140	6140	6141
1946	1650	39	applied	\N	\N	\N	\N	6144	6144	6145
1946	1651	40	applied	\N	\N	\N	\N	6146	6146	6147
1946	1652	41	applied	\N	\N	\N	\N	6150	6150	6151
1946	1653	42	applied	\N	\N	\N	\N	6159	6159	6160
1946	1654	43	applied	\N	\N	\N	\N	6163	6163	6164
1946	1655	44	applied	\N	\N	\N	\N	6169	6169	6170
1946	1656	45	applied	\N	\N	\N	\N	6171	6171	6172
1946	1657	46	applied	\N	\N	\N	\N	6176	6176	6177
1948	1658	0	applied	\N	\N	\N	\N	6183	6183	6184
1948	1659	1	applied	\N	\N	\N	\N	6185	6185	6186
1950	1660	0	applied	\N	\N	\N	\N	6189	6189	6190
1951	1660	0	applied	\N	\N	\N	\N	6189	6189	6190
1954	1661	0	applied	\N	\N	\N	\N	6197	6197	6198
1957	1664	0	applied	\N	\N	\N	\N	6206	6206	6207
1959	1664	0	applied	\N	\N	\N	\N	6206	6206	6207
1960	1665	0	applied	\N	\N	\N	\N	6212	6212	6213
1960	1666	1	applied	\N	\N	\N	\N	6214	6214	6215
1965	1667	0	applied	\N	\N	\N	\N	6219	6219	6220
1966	1668	0	applied	\N	\N	\N	\N	6223	6223	6224
1966	1669	1	applied	\N	\N	\N	\N	6225	6225	6226
1966	1670	2	applied	\N	\N	\N	\N	6227	6227	6228
1966	1671	3	applied	\N	\N	\N	\N	6229	6229	6230
1966	1672	4	applied	\N	\N	\N	\N	6231	6231	6232
1966	1673	5	applied	\N	\N	\N	\N	6233	6233	6234
1968	1674	0	applied	\N	\N	\N	\N	6237	6237	6238
1968	1675	1	applied	\N	\N	\N	\N	6239	6239	6240
1972	1677	0	applied	\N	\N	\N	\N	6250	6250	6251
1978	1679	0	applied	\N	\N	\N	\N	6265	6265	6266
1981	1683	0	applied	\N	\N	\N	\N	6276	6276	6277
1984	1685	0	applied	\N	\N	\N	\N	6282	6282	6283
1984	1686	1	applied	\N	\N	\N	\N	6284	6284	6285
1988	1688	0	applied	\N	\N	\N	\N	6291	6291	6292
1990	1689	0	applied	\N	\N	\N	\N	6299	6299	6300
1994	1691	0	applied	\N	\N	\N	\N	6307	6307	6308
1998	1694	0	applied	\N	\N	\N	\N	6318	6318	6319
2004	1697	0	applied	\N	\N	\N	\N	6331	6331	6332
2004	1698	1	applied	\N	\N	\N	\N	6333	6333	6334
2008	1699	0	applied	\N	\N	\N	\N	6340	6340	6341
2008	1700	1	applied	\N	\N	\N	\N	6342	6342	6343
2008	1701	2	applied	\N	\N	\N	\N	6344	6344	6345
2011	1578	0	applied	\N	\N	\N	\N	5871	5871	5872
2011	1636	1	applied	\N	\N	\N	\N	6096	6096	6097
2011	1579	2	applied	\N	\N	\N	\N	5873	5873	5874
2011	1580	3	applied	\N	\N	\N	\N	5875	5875	5876
2011	1581	4	applied	\N	\N	\N	\N	5877	5877	5878
2011	1582	5	applied	\N	\N	\N	\N	5880	5880	5881
2011	1583	6	applied	\N	\N	\N	\N	5884	5884	5885
2011	1584	7	applied	\N	\N	\N	\N	5886	5886	5887
2011	1585	8	applied	\N	\N	\N	\N	5889	5889	5890
2011	1586	9	applied	\N	\N	\N	\N	5898	5898	5899
2011	1587	10	applied	\N	\N	\N	\N	5900	5900	5901
2011	1588	11	applied	\N	\N	\N	\N	5902	5902	5903
2011	1589	12	applied	\N	\N	\N	\N	5908	5908	5909
2011	1590	13	applied	\N	\N	\N	\N	5915	5915	5916
2011	1591	14	applied	\N	\N	\N	\N	5919	5919	5920
2011	1592	15	applied	\N	\N	\N	\N	5923	5923	5924
2011	1593	16	applied	\N	\N	\N	\N	5927	5927	5928
2011	1594	17	applied	\N	\N	\N	\N	5931	5931	5932
2011	1595	18	applied	\N	\N	\N	\N	5937	5937	5938
2011	1596	19	applied	\N	\N	\N	\N	5943	5943	5944
2011	1597	20	applied	\N	\N	\N	\N	5951	5951	5952
2011	1598	21	applied	\N	\N	\N	\N	5956	5956	5957
2011	1599	22	applied	\N	\N	\N	\N	5958	5958	5959
2011	1600	23	applied	\N	\N	\N	\N	5960	5960	5961
2011	1601	24	applied	\N	\N	\N	\N	5964	5964	5965
2011	1602	25	applied	\N	\N	\N	\N	5966	5966	5967
2011	1603	26	applied	\N	\N	\N	\N	5973	5973	5974
2011	1604	27	applied	\N	\N	\N	\N	5979	5979	5980
2011	1605	28	applied	\N	\N	\N	\N	5983	5983	5984
2011	1606	29	applied	\N	\N	\N	\N	5989	5989	5990
2011	1607	30	applied	\N	\N	\N	\N	5994	5994	5995
2011	1608	31	applied	\N	\N	\N	\N	6002	6002	6003
2011	1609	32	applied	\N	\N	\N	\N	6005	6005	6006
2011	1610	33	applied	\N	\N	\N	\N	6011	6011	6012
2011	1611	34	applied	\N	\N	\N	\N	6018	6018	6019
2011	1612	35	applied	\N	\N	\N	\N	6020	6020	6021
2011	1613	36	applied	\N	\N	\N	\N	6024	6024	6025
2011	1614	37	applied	\N	\N	\N	\N	6028	6028	6029
1940	1654	0	applied	\N	\N	\N	\N	6163	6163	6164
1943	1655	0	applied	\N	\N	\N	\N	6169	6169	6170
1943	1656	1	applied	\N	\N	\N	\N	6171	6171	6172
1944	1657	0	applied	\N	\N	\N	\N	6176	6176	6177
1947	1657	0	applied	\N	\N	\N	\N	6176	6176	6177
1953	1661	0	applied	\N	\N	\N	\N	6197	6197	6198
1956	1662	0	applied	\N	\N	\N	\N	6199	6199	6200
1956	1663	1	applied	\N	\N	\N	\N	6201	6201	6202
1958	1664	0	applied	\N	\N	\N	\N	6206	6206	6207
1962	1667	0	applied	\N	\N	\N	\N	6219	6219	6220
1971	1676	0	applied	\N	\N	\N	\N	6247	6247	6248
1973	1677	0	applied	\N	\N	\N	\N	6250	6250	6251
1975	1636	0	applied	\N	\N	\N	\N	6256	6256	6097
1975	1515	1	applied	\N	\N	\N	\N	5644	5644	5645
1975	1516	2	applied	\N	\N	\N	\N	5648	5648	5649
1975	1517	3	applied	\N	\N	\N	\N	5650	5650	5651
1975	1518	4	applied	\N	\N	\N	\N	5656	5656	5657
1975	1519	5	applied	\N	\N	\N	\N	5666	5666	5667
1975	1520	6	applied	\N	\N	\N	\N	5673	5673	5674
1975	1521	7	applied	\N	\N	\N	\N	5676	5676	5677
1975	1522	8	applied	\N	\N	\N	\N	5680	5680	5681
1975	1523	9	applied	\N	\N	\N	\N	5683	5683	5684
1975	1524	10	applied	\N	\N	\N	\N	5689	5689	5690
1975	1525	11	applied	\N	\N	\N	\N	5691	5691	5692
1975	1526	12	applied	\N	\N	\N	\N	5697	5697	5698
1975	1527	13	applied	\N	\N	\N	\N	5704	5704	5705
1975	1528	14	applied	\N	\N	\N	\N	5708	5708	5709
1975	1529	15	applied	\N	\N	\N	\N	5710	5710	5711
1975	1530	16	applied	\N	\N	\N	\N	5712	5712	5713
1975	1531	17	applied	\N	\N	\N	\N	5714	5714	5715
1975	1532	18	applied	\N	\N	\N	\N	5716	5716	5717
1975	1533	19	applied	\N	\N	\N	\N	5718	5718	5719
1975	1534	20	applied	\N	\N	\N	\N	5720	5720	5721
1975	1535	21	applied	\N	\N	\N	\N	5724	5724	5725
1975	1536	22	applied	\N	\N	\N	\N	5726	5726	5727
1975	1537	23	applied	\N	\N	\N	\N	5730	5730	5731
1975	1538	24	applied	\N	\N	\N	\N	5734	5734	5735
1975	1539	25	applied	\N	\N	\N	\N	5737	5737	5738
1975	1540	26	applied	\N	\N	\N	\N	5741	5741	5742
1975	1541	27	applied	\N	\N	\N	\N	5743	5743	5744
1975	1542	28	applied	\N	\N	\N	\N	5745	5745	5746
1975	1543	29	applied	\N	\N	\N	\N	5748	5748	5749
1975	1544	30	applied	\N	\N	\N	\N	5750	5750	5751
1975	1545	31	applied	\N	\N	\N	\N	5753	5753	5754
1975	1546	32	applied	\N	\N	\N	\N	5755	5755	5756
1975	1547	33	applied	\N	\N	\N	\N	5759	5759	5760
1975	1548	34	applied	\N	\N	\N	\N	5766	5766	5767
1975	1549	35	applied	\N	\N	\N	\N	5774	5774	5775
1975	1550	36	applied	\N	\N	\N	\N	5776	5776	5777
1975	1551	37	applied	\N	\N	\N	\N	5779	5779	5780
1975	1552	38	applied	\N	\N	\N	\N	5783	5783	5784
1975	1553	39	applied	\N	\N	\N	\N	5785	5785	5786
1975	1554	40	applied	\N	\N	\N	\N	5787	5787	5788
1975	1555	41	applied	\N	\N	\N	\N	5789	5789	5790
1975	1556	43	applied	\N	\N	\N	\N	5791	5791	5792
1975	1557	44	applied	\N	\N	\N	\N	5796	5796	5797
1975	1558	45	applied	\N	\N	\N	\N	5803	5803	5804
1975	1559	46	applied	\N	\N	\N	\N	5805	5805	5806
1975	1560	47	applied	\N	\N	\N	\N	5808	5808	5809
1975	1561	48	applied	\N	\N	\N	\N	5813	5813	5814
1975	1562	49	applied	\N	\N	\N	\N	5815	5815	5816
1975	1563	50	applied	\N	\N	\N	\N	5819	5819	5820
1975	1565	51	applied	\N	\N	\N	\N	5823	5823	5824
1975	1566	52	applied	\N	\N	\N	\N	5825	5825	5826
1975	1567	53	applied	\N	\N	\N	\N	5830	5830	5831
1975	1568	54	applied	\N	\N	\N	\N	5832	5832	5833
1975	1569	55	applied	\N	\N	\N	\N	5837	5837	5838
1975	1570	56	applied	\N	\N	\N	\N	5839	5839	5840
1975	1572	57	applied	\N	\N	\N	\N	5846	5846	5847
1975	1573	58	applied	\N	\N	\N	\N	5850	5850	5851
1975	1574	59	applied	\N	\N	\N	\N	5854	5854	5855
1975	1575	60	applied	\N	\N	\N	\N	5860	5860	5861
1975	1576	61	applied	\N	\N	\N	\N	5862	5862	5863
1975	1577	62	applied	\N	\N	\N	\N	5865	5865	5866
1975	1578	63	applied	\N	\N	\N	\N	5871	5871	5872
1975	1579	64	applied	\N	\N	\N	\N	5873	5873	5874
1975	1580	65	applied	\N	\N	\N	\N	5875	5875	5876
1975	1581	66	applied	\N	\N	\N	\N	5877	5877	5878
1975	1582	67	applied	\N	\N	\N	\N	5880	5880	5881
1975	1583	68	applied	\N	\N	\N	\N	5884	5884	5885
1975	1584	69	applied	\N	\N	\N	\N	5886	5886	5887
1975	1585	70	applied	\N	\N	\N	\N	5889	5889	5890
1975	1586	71	applied	\N	\N	\N	\N	5898	5898	5899
1975	1587	72	applied	\N	\N	\N	\N	5900	5900	5901
1975	1588	73	applied	\N	\N	\N	\N	5902	5902	5903
1975	1589	74	applied	\N	\N	\N	\N	5908	5908	5909
1975	1590	75	applied	\N	\N	\N	\N	5915	5915	5916
1975	1591	76	applied	\N	\N	\N	\N	5919	5919	5920
1975	1592	77	applied	\N	\N	\N	\N	5923	5923	5924
1975	1593	78	applied	\N	\N	\N	\N	5927	5927	5928
1975	1594	79	applied	\N	\N	\N	\N	5931	5931	5932
1975	1595	80	applied	\N	\N	\N	\N	5937	5937	5938
1975	1596	81	applied	\N	\N	\N	\N	5943	5943	5944
1975	1597	82	applied	\N	\N	\N	\N	5951	5951	5952
1975	1598	83	applied	\N	\N	\N	\N	5956	5956	5957
1975	1599	84	applied	\N	\N	\N	\N	5958	5958	5959
1975	1600	85	applied	\N	\N	\N	\N	5960	5960	5961
1975	1601	86	applied	\N	\N	\N	\N	5964	5964	5965
1975	1602	87	applied	\N	\N	\N	\N	5966	5966	5967
1975	1603	88	applied	\N	\N	\N	\N	5973	5973	5974
1975	1604	89	applied	\N	\N	\N	\N	5979	5979	5980
1975	1605	90	applied	\N	\N	\N	\N	5983	5983	5984
1975	1606	91	applied	\N	\N	\N	\N	5989	5989	5990
1975	1607	92	applied	\N	\N	\N	\N	5994	5994	5995
1975	1608	93	applied	\N	\N	\N	\N	6002	6002	6003
1975	1609	94	applied	\N	\N	\N	\N	6005	6005	6006
1975	1610	95	applied	\N	\N	\N	\N	6011	6011	6012
1975	1611	96	applied	\N	\N	\N	\N	6018	6018	6019
1975	1612	97	applied	\N	\N	\N	\N	6020	6020	6021
1975	1613	98	applied	\N	\N	\N	\N	6024	6024	6025
1975	1614	99	applied	\N	\N	\N	\N	6028	6028	6029
1975	1615	100	applied	\N	\N	\N	\N	6030	6030	6031
1975	1616	101	applied	\N	\N	\N	\N	6036	6036	6037
1975	1617	102	applied	\N	\N	\N	\N	6038	6038	6039
1975	1618	103	applied	\N	\N	\N	\N	6042	6042	6043
1975	1619	104	applied	\N	\N	\N	\N	6047	6047	6048
1975	1620	105	applied	\N	\N	\N	\N	6049	6049	6050
1975	1621	106	applied	\N	\N	\N	\N	6053	6053	6054
1975	1622	107	applied	\N	\N	\N	\N	6057	6057	6058
1975	1623	108	applied	\N	\N	\N	\N	6061	6061	6062
1941	1654	0	applied	\N	\N	\N	\N	6163	6163	6164
1945	1657	0	applied	\N	\N	\N	\N	6176	6176	6177
1949	1660	0	applied	\N	\N	\N	\N	6189	6189	6190
1952	1660	0	applied	\N	\N	\N	\N	6189	6189	6190
1955	1662	0	applied	\N	\N	\N	\N	6199	6199	6200
1955	1663	1	applied	\N	\N	\N	\N	6201	6201	6202
1961	1665	0	applied	\N	\N	\N	\N	6212	6212	6213
1961	1666	1	applied	\N	\N	\N	\N	6214	6214	6215
1963	1667	0	applied	\N	\N	\N	\N	6219	6219	6220
1964	1667	0	applied	\N	\N	\N	\N	6219	6219	6220
1967	1674	0	applied	\N	\N	\N	\N	6237	6237	6238
1967	1675	1	applied	\N	\N	\N	\N	6239	6239	6240
1969	1674	0	applied	\N	\N	\N	\N	6237	6237	6238
1969	1675	1	applied	\N	\N	\N	\N	6239	6239	6240
1970	1676	0	applied	\N	\N	\N	\N	6247	6247	6248
1974	1677	0	applied	\N	\N	\N	\N	6250	6250	6251
1976	1678	0	applied	\N	\N	\N	\N	6261	6261	6262
1979	1680	0	applied	\N	\N	\N	\N	6269	6269	6270
1979	1681	1	applied	\N	\N	\N	\N	6271	6271	6272
1979	1682	2	applied	\N	\N	\N	\N	6273	6273	6274
1985	1685	0	applied	\N	\N	\N	\N	6282	6282	6283
1985	1686	1	applied	\N	\N	\N	\N	6284	6284	6285
1987	1688	0	applied	\N	\N	\N	\N	6291	6291	6292
1989	1688	0	applied	\N	\N	\N	\N	6291	6291	6292
1992	1689	0	applied	\N	\N	\N	\N	6299	6299	6300
1997	1692	0	applied	\N	\N	\N	\N	6311	6311	6312
1997	1693	1	applied	\N	\N	\N	\N	6313	6313	6314
2000	1695	0	applied	\N	\N	\N	\N	6320	6320	6321
2002	1643	0	applied	\N	\N	\N	\N	6119	6119	6120
2002	1644	1	applied	\N	\N	\N	\N	6123	6123	6124
2002	1645	2	applied	\N	\N	\N	\N	6129	6129	6130
2002	1646	3	applied	\N	\N	\N	\N	6131	6131	6132
2002	1647	4	applied	\N	\N	\N	\N	6133	6133	6134
2002	1648	5	applied	\N	\N	\N	\N	6135	6135	6136
2002	1649	6	applied	\N	\N	\N	\N	6140	6140	6141
2002	1650	7	applied	\N	\N	\N	\N	6144	6144	6145
2002	1651	8	applied	\N	\N	\N	\N	6146	6146	6147
2002	1652	9	applied	\N	\N	\N	\N	6150	6150	6151
2002	1653	10	applied	\N	\N	\N	\N	6159	6159	6160
2002	1654	11	applied	\N	\N	\N	\N	6163	6163	6164
2002	1655	12	applied	\N	\N	\N	\N	6169	6169	6170
2002	1656	13	applied	\N	\N	\N	\N	6171	6171	6172
2002	1657	14	applied	\N	\N	\N	\N	6176	6176	6177
2002	1658	15	applied	\N	\N	\N	\N	6183	6183	6184
2002	1659	16	applied	\N	\N	\N	\N	6185	6185	6186
2002	1660	17	applied	\N	\N	\N	\N	6189	6189	6190
2002	1661	18	applied	\N	\N	\N	\N	6197	6197	6198
2002	1662	19	applied	\N	\N	\N	\N	6199	6199	6200
2002	1663	20	applied	\N	\N	\N	\N	6201	6201	6202
2002	1664	21	applied	\N	\N	\N	\N	6206	6206	6207
2002	1665	22	applied	\N	\N	\N	\N	6212	6212	6213
2002	1666	23	applied	\N	\N	\N	\N	6214	6214	6215
2002	1667	24	applied	\N	\N	\N	\N	6219	6219	6220
2002	1668	25	applied	\N	\N	\N	\N	6223	6223	6224
2002	1669	26	applied	\N	\N	\N	\N	6225	6225	6226
2002	1670	27	applied	\N	\N	\N	\N	6227	6227	6228
2002	1671	28	applied	\N	\N	\N	\N	6229	6229	6230
2002	1672	29	applied	\N	\N	\N	\N	6231	6231	6232
2002	1673	30	applied	\N	\N	\N	\N	6233	6233	6234
2002	1674	31	applied	\N	\N	\N	\N	6237	6237	6238
2002	1675	32	applied	\N	\N	\N	\N	6239	6239	6240
2002	1676	33	applied	\N	\N	\N	\N	6247	6247	6248
2002	1677	34	applied	\N	\N	\N	\N	6250	6250	6251
2002	1678	35	applied	\N	\N	\N	\N	6261	6261	6262
2002	1679	36	applied	\N	\N	\N	\N	6265	6265	6266
2002	1680	37	applied	\N	\N	\N	\N	6269	6269	6270
2002	1681	38	applied	\N	\N	\N	\N	6271	6271	6272
2002	1682	39	applied	\N	\N	\N	\N	6273	6273	6274
2002	1683	40	applied	\N	\N	\N	\N	6276	6276	6277
2002	1684	41	applied	\N	\N	\N	\N	6278	6278	6279
2002	1685	43	applied	\N	\N	\N	\N	6282	6282	6283
2002	1686	44	applied	\N	\N	\N	\N	6284	6284	6285
2002	1687	45	applied	\N	\N	\N	\N	6289	6289	6290
2002	1688	46	applied	\N	\N	\N	\N	6291	6291	6292
2002	1689	47	applied	\N	\N	\N	\N	6299	6299	6300
2002	1690	48	applied	\N	\N	\N	\N	6305	6305	6306
2002	1691	49	applied	\N	\N	\N	\N	6307	6307	6308
2002	1692	50	applied	\N	\N	\N	\N	6311	6311	6312
2002	1693	51	applied	\N	\N	\N	\N	6313	6313	6314
2002	1694	52	applied	\N	\N	\N	\N	6318	6318	6319
2002	1695	53	applied	\N	\N	\N	\N	6320	6320	6321
2003	1696	0	applied	\N	\N	\N	\N	6327	6327	6328
2006	1697	0	applied	\N	\N	\N	\N	6331	6331	6332
2006	1698	1	applied	\N	\N	\N	\N	6333	6333	6334
2009	1702	0	applied	\N	\N	\N	\N	6348	6348	6349
2013	1703	0	applied	\N	\N	\N	\N	6352	6352	6353
1975	1624	109	applied	\N	\N	\N	\N	6063	6063	6064
1975	1625	110	applied	\N	\N	\N	\N	6065	6065	6066
1975	1626	111	applied	\N	\N	\N	\N	6067	6067	6068
1975	1627	112	applied	\N	\N	\N	\N	6071	6071	6072
1975	1628	113	applied	\N	\N	\N	\N	6075	6075	6076
1975	1629	114	applied	\N	\N	\N	\N	6077	6077	6078
1975	1630	115	applied	\N	\N	\N	\N	6079	6079	6080
1975	1631	116	applied	\N	\N	\N	\N	6082	6082	6083
1975	1632	117	applied	\N	\N	\N	\N	6084	6084	6085
1975	1633	118	applied	\N	\N	\N	\N	6090	6090	6091
1975	1634	119	applied	\N	\N	\N	\N	6092	6092	6093
1975	1635	120	applied	\N	\N	\N	\N	6094	6094	6095
1975	1637	121	applied	\N	\N	\N	\N	6098	6098	6099
1975	1638	122	applied	\N	\N	\N	\N	6102	6102	6103
1975	1639	123	applied	\N	\N	\N	\N	6106	6106	6107
1975	1640	124	applied	\N	\N	\N	\N	6110	6110	6111
1975	1642	125	applied	\N	\N	\N	\N	6116	6116	6117
1977	1679	0	applied	\N	\N	\N	\N	6265	6265	6266
1980	1683	0	applied	\N	\N	\N	\N	6276	6276	6277
1982	1683	0	applied	\N	\N	\N	\N	6276	6276	6277
1983	1684	0	applied	\N	\N	\N	\N	6278	6278	6279
1986	1687	0	applied	\N	\N	\N	\N	6289	6289	6290
1991	1689	0	applied	\N	\N	\N	\N	6299	6299	6300
1993	1690	0	applied	\N	\N	\N	\N	6305	6305	6306
1995	1691	0	applied	\N	\N	\N	\N	6307	6307	6308
1996	1692	0	applied	\N	\N	\N	\N	6311	6311	6312
1996	1693	1	applied	\N	\N	\N	\N	6313	6313	6314
1999	1695	0	applied	\N	\N	\N	\N	6320	6320	6321
2001	1695	0	applied	\N	\N	\N	\N	6320	6320	6321
2005	1697	0	applied	\N	\N	\N	\N	6331	6331	6332
2005	1698	1	applied	\N	\N	\N	\N	6333	6333	6334
2007	1697	0	applied	\N	\N	\N	\N	6331	6331	6332
2007	1698	1	applied	\N	\N	\N	\N	6333	6333	6334
2010	1703	0	applied	\N	\N	\N	\N	6352	6352	6353
2014	1703	0	applied	\N	\N	\N	\N	6352	6352	6353
2011	1615	38	applied	\N	\N	\N	\N	6030	6030	6031
2011	1616	39	applied	\N	\N	\N	\N	6036	6036	6037
2011	1617	40	applied	\N	\N	\N	\N	6038	6038	6039
2011	1618	41	applied	\N	\N	\N	\N	6042	6042	6043
2011	1619	42	applied	\N	\N	\N	\N	6047	6047	6048
2011	1620	43	applied	\N	\N	\N	\N	6049	6049	6050
2011	1621	44	applied	\N	\N	\N	\N	6053	6053	6054
2011	1622	45	applied	\N	\N	\N	\N	6057	6057	6058
2011	1623	46	applied	\N	\N	\N	\N	6061	6061	6062
2011	1624	47	applied	\N	\N	\N	\N	6063	6063	6064
2011	1625	48	applied	\N	\N	\N	\N	6065	6065	6066
2011	1626	49	applied	\N	\N	\N	\N	6067	6067	6068
2011	1627	50	applied	\N	\N	\N	\N	6071	6071	6072
2011	1628	51	applied	\N	\N	\N	\N	6075	6075	6076
2011	1629	52	applied	\N	\N	\N	\N	6077	6077	6078
2011	1630	53	applied	\N	\N	\N	\N	6079	6079	6080
2011	1631	54	applied	\N	\N	\N	\N	6082	6082	6083
2011	1632	55	applied	\N	\N	\N	\N	6084	6084	6085
2011	1633	56	applied	\N	\N	\N	\N	6090	6090	6091
2011	1634	57	applied	\N	\N	\N	\N	6092	6092	6093
2011	1635	58	applied	\N	\N	\N	\N	6094	6094	6095
2011	1637	59	applied	\N	\N	\N	\N	6098	6098	6099
2011	1638	60	applied	\N	\N	\N	\N	6102	6102	6103
2011	1639	61	applied	\N	\N	\N	\N	6106	6106	6107
2011	1640	62	applied	\N	\N	\N	\N	6110	6110	6111
2011	1642	63	applied	\N	\N	\N	\N	6116	6116	6117
2011	1643	64	applied	\N	\N	\N	\N	6119	6119	6120
2011	1644	65	applied	\N	\N	\N	\N	6123	6123	6124
2011	1645	66	applied	\N	\N	\N	\N	6129	6129	6130
2011	1646	67	applied	\N	\N	\N	\N	6131	6131	6132
2011	1647	68	applied	\N	\N	\N	\N	6133	6133	6134
2011	1648	69	applied	\N	\N	\N	\N	6135	6135	6136
2011	1649	70	applied	\N	\N	\N	\N	6140	6140	6141
2011	1650	71	applied	\N	\N	\N	\N	6144	6144	6145
2011	1651	72	applied	\N	\N	\N	\N	6146	6146	6147
2011	1652	73	applied	\N	\N	\N	\N	6150	6150	6151
2011	1653	74	applied	\N	\N	\N	\N	6159	6159	6160
2011	1654	75	applied	\N	\N	\N	\N	6163	6163	6164
2011	1655	76	applied	\N	\N	\N	\N	6169	6169	6170
2011	1656	77	applied	\N	\N	\N	\N	6171	6171	6172
2011	1657	78	applied	\N	\N	\N	\N	6176	6176	6177
2011	1658	79	applied	\N	\N	\N	\N	6183	6183	6184
2011	1659	80	applied	\N	\N	\N	\N	6185	6185	6186
2012	1703	0	applied	\N	\N	\N	\N	6352	6352	6353
2015	1704	0	applied	\N	\N	\N	\N	6361	6361	6362
2015	1705	1	applied	\N	\N	\N	\N	6363	6363	6364
2015	1706	2	applied	\N	\N	\N	\N	6365	6365	6366
2016	1704	0	applied	\N	\N	\N	\N	6361	6361	6362
2016	1705	1	applied	\N	\N	\N	\N	6363	6363	6364
2016	1706	2	applied	\N	\N	\N	\N	6365	6365	6366
2017	1707	0	applied	\N	\N	\N	\N	6369	6369	6370
2018	1708	0	applied	\N	\N	\N	\N	6373	6373	6374
2019	1708	0	applied	\N	\N	\N	\N	6373	6373	6374
2020	1708	0	applied	\N	\N	\N	\N	6373	6373	6374
2021	1709	0	applied	\N	\N	\N	\N	6380	6380	6381
2021	1710	1	applied	\N	\N	\N	\N	6382	6382	6383
2022	1709	0	applied	\N	\N	\N	\N	6380	6380	6381
2022	1710	1	applied	\N	\N	\N	\N	6382	6382	6383
2023	1709	0	applied	\N	\N	\N	\N	6380	6380	6381
2023	1710	1	applied	\N	\N	\N	\N	6382	6382	6383
2024	1711	0	applied	\N	\N	\N	\N	6388	6388	6389
2024	1712	1	applied	\N	\N	\N	\N	6390	6390	6391
2025	1713	0	applied	\N	\N	\N	\N	6394	6394	6395
2025	1714	1	applied	\N	\N	\N	\N	6396	6396	6397
2026	1713	0	applied	\N	\N	\N	\N	6394	6394	6395
2026	1714	1	applied	\N	\N	\N	\N	6396	6396	6397
2027	1715	0	applied	\N	\N	\N	\N	6400	6400	6401
2028	1716	0	applied	\N	\N	\N	\N	6402	6402	6403
2029	1717	0	applied	\N	\N	\N	\N	6406	6406	6407
2030	1717	0	applied	\N	\N	\N	\N	6406	6406	6407
2031	1718	0	applied	\N	\N	\N	\N	6410	6410	6411
2032	1718	0	applied	\N	\N	\N	\N	6410	6410	6411
2032	1719	1	applied	\N	\N	\N	\N	6412	6412	6413
2033	1718	0	applied	\N	\N	\N	\N	6410	6410	6411
2033	1719	1	applied	\N	\N	\N	\N	6412	6412	6413
2034	1718	0	applied	\N	\N	\N	\N	6410	6410	6411
2034	1719	1	applied	\N	\N	\N	\N	6412	6412	6413
2035	1720	0	applied	\N	\N	\N	\N	6421	6421	6422
2036	1721	0	applied	\N	\N	\N	\N	6425	6425	6426
2036	1722	1	applied	\N	\N	\N	\N	6427	6427	6428
2037	1721	0	applied	\N	\N	\N	\N	6425	6425	6426
2037	1722	1	applied	\N	\N	\N	\N	6427	6427	6428
2038	1723	0	applied	\N	\N	\N	\N	6431	6431	6432
2038	1724	1	applied	\N	\N	\N	\N	6433	6433	6434
2039	1725	0	applied	\N	\N	\N	\N	6436	6436	6437
2040	1726	0	applied	\N	\N	\N	\N	6440	6440	6441
2040	1727	1	applied	\N	\N	\N	\N	6442	6442	6443
2041	1726	0	applied	\N	\N	\N	\N	6440	6440	6441
2041	1727	1	applied	\N	\N	\N	\N	6442	6442	6443
2042	1728	0	applied	\N	\N	\N	\N	6448	6448	6449
2043	1729	0	applied	\N	\N	\N	\N	6452	6452	6453
2044	1729	0	applied	\N	\N	\N	\N	6452	6452	6453
2045	1655	0	applied	\N	\N	\N	\N	6169	6169	6170
2045	1656	1	applied	\N	\N	\N	\N	6171	6171	6172
2045	1657	2	applied	\N	\N	\N	\N	6176	6176	6177
2045	1658	3	applied	\N	\N	\N	\N	6183	6183	6184
2045	1659	4	applied	\N	\N	\N	\N	6185	6185	6186
2045	1660	5	applied	\N	\N	\N	\N	6189	6189	6190
2045	1661	6	applied	\N	\N	\N	\N	6197	6197	6198
2045	1662	7	applied	\N	\N	\N	\N	6199	6199	6200
2045	1663	8	applied	\N	\N	\N	\N	6201	6201	6202
2045	1664	9	applied	\N	\N	\N	\N	6206	6206	6207
2045	1665	10	applied	\N	\N	\N	\N	6212	6212	6213
2045	1666	11	applied	\N	\N	\N	\N	6214	6214	6215
2045	1667	12	applied	\N	\N	\N	\N	6219	6219	6220
2045	1668	14	applied	\N	\N	\N	\N	6223	6223	6224
2045	1669	15	applied	\N	\N	\N	\N	6225	6225	6226
2045	1670	16	applied	\N	\N	\N	\N	6227	6227	6228
2045	1671	17	applied	\N	\N	\N	\N	6229	6229	6230
2045	1672	18	applied	\N	\N	\N	\N	6231	6231	6232
2045	1673	19	applied	\N	\N	\N	\N	6233	6233	6234
2045	1674	20	applied	\N	\N	\N	\N	6237	6237	6238
2045	1675	21	applied	\N	\N	\N	\N	6239	6239	6240
2045	1676	22	applied	\N	\N	\N	\N	6247	6247	6248
2045	1677	23	applied	\N	\N	\N	\N	6250	6250	6251
2045	1678	24	applied	\N	\N	\N	\N	6261	6261	6262
2045	1679	25	applied	\N	\N	\N	\N	6265	6265	6266
2045	1680	26	applied	\N	\N	\N	\N	6269	6269	6270
2045	1681	27	applied	\N	\N	\N	\N	6271	6271	6272
2045	1682	28	applied	\N	\N	\N	\N	6273	6273	6274
2045	1683	29	applied	\N	\N	\N	\N	6276	6276	6277
2045	1684	30	applied	\N	\N	\N	\N	6278	6278	6279
2045	1685	31	applied	\N	\N	\N	\N	6282	6282	6283
2045	1686	32	applied	\N	\N	\N	\N	6284	6284	6285
2045	1687	33	applied	\N	\N	\N	\N	6289	6289	6290
2045	1688	34	applied	\N	\N	\N	\N	6291	6291	6292
2045	1689	35	applied	\N	\N	\N	\N	6299	6299	6300
2045	1690	36	applied	\N	\N	\N	\N	6305	6305	6306
2045	1691	37	applied	\N	\N	\N	\N	6307	6307	6308
2045	1692	38	applied	\N	\N	\N	\N	6311	6311	6312
2045	1693	39	applied	\N	\N	\N	\N	6313	6313	6314
2045	1694	40	applied	\N	\N	\N	\N	6318	6318	6319
2045	1695	41	applied	\N	\N	\N	\N	6320	6320	6321
2045	1696	42	applied	\N	\N	\N	\N	6327	6327	6328
2045	1697	43	applied	\N	\N	\N	\N	6331	6331	6332
2045	1698	44	applied	\N	\N	\N	\N	6333	6333	6334
2045	1699	45	applied	\N	\N	\N	\N	6340	6340	6341
2045	1700	46	applied	\N	\N	\N	\N	6342	6342	6343
2045	1701	47	applied	\N	\N	\N	\N	6344	6344	6345
2045	1702	48	applied	\N	\N	\N	\N	6348	6348	6349
2047	1736	0	applied	\N	\N	\N	\N	6471	6471	6472
2052	1739	0	applied	\N	\N	\N	\N	6481	6481	6482
2052	1740	1	applied	\N	\N	\N	\N	6483	6483	6484
2056	1742	0	applied	\N	\N	\N	\N	6490	6490	6491
2059	1743	0	applied	\N	\N	\N	\N	6496	6496	6497
2062	1746	0	applied	\N	\N	\N	\N	6510	6510	6511
2065	1747	0	applied	\N	\N	\N	\N	6512	6512	6513
2069	1749	0	applied	\N	\N	\N	\N	6518	6518	6519
2072	1751	0	applied	\N	\N	\N	\N	6530	6530	6531
2072	1752	1	applied	\N	\N	\N	\N	6532	6532	6533
2075	1753	0	applied	\N	\N	\N	\N	6536	6536	6537
2078	1754	0	applied	\N	\N	\N	\N	6544	6544	6545
2083	1756	0	applied	\N	\N	\N	\N	6555	6555	6556
2090	1765	0	applied	\N	\N	\N	\N	6583	6583	6584
2091	1766	0	applied	\N	\N	\N	\N	6585	6585	6586
2094	1766	0	applied	\N	\N	\N	\N	6585	6585	6586
2097	1767	0	applied	\N	\N	\N	\N	6591	6591	6592
2097	1768	1	applied	\N	\N	\N	\N	6593	6593	6594
2099	1771	0	applied	\N	\N	\N	\N	6605	6605	6606
2101	1772	0	applied	\N	\N	\N	\N	6609	6609	6610
2105	1773	0	applied	\N	\N	\N	\N	6613	6613	6614
2108	1774	0	applied	\N	\N	\N	\N	6622	6622	6623
2111	1775	0	applied	\N	\N	\N	\N	6625	6625	6626
2112	1776	0	applied	\N	\N	\N	\N	6629	6629	6630
2114	1777	0	applied	\N	\N	\N	\N	6633	6633	6634
2115	1778	0	applied	\N	\N	\N	\N	6637	6637	6638
2115	1779	1	applied	\N	\N	\N	\N	6639	6639	6640
2117	1780	0	applied	\N	\N	\N	\N	6642	6642	6643
2117	1781	1	applied	\N	\N	\N	\N	6644	6644	6645
2119	1782	0	applied	\N	\N	\N	\N	6650	6650	6651
2123	1784	0	applied	\N	\N	\N	\N	6658	6658	6659
2129	1790	0	applied	\N	\N	\N	\N	6676	6676	6677
2134	1793	0	applied	\N	\N	\N	\N	6686	6686	6687
2138	1794	0	applied	\N	\N	\N	\N	6695	6695	6696
2144	1797	0	applied	\N	\N	\N	\N	6708	6708	6709
2146	1799	0	applied	\N	\N	\N	\N	6712	6712	6713
2146	1800	1	applied	\N	\N	\N	\N	6714	6714	6715
2149	1804	0	applied	\N	\N	\N	\N	6727	6727	6728
2150	1805	0	applied	\N	\N	\N	\N	6731	6731	6732
2150	1806	1	applied	\N	\N	\N	\N	6733	6733	6734
2152	1805	0	applied	\N	\N	\N	\N	6731	6731	6732
2152	1806	1	applied	\N	\N	\N	\N	6733	6733	6734
2154	1808	0	applied	\N	\N	\N	\N	6738	6738	6739
2154	1809	1	applied	\N	\N	\N	\N	6740	6740	6741
2156	1810	0	applied	\N	\N	\N	\N	6744	6744	6745
2156	1811	1	applied	\N	\N	\N	\N	6746	6746	6747
2159	1810	0	applied	\N	\N	\N	\N	6744	6744	6745
2159	1811	1	applied	\N	\N	\N	\N	6746	6746	6747
2161	1812	0	applied	\N	\N	\N	\N	6753	6753	6754
2169	1815	0	applied	\N	\N	\N	\N	6767	6767	6768
2169	1816	1	applied	\N	\N	\N	\N	6769	6769	6770
2171	1817	0	applied	\N	\N	\N	\N	6775	6775	6776
2176	1821	0	applied	\N	\N	\N	\N	6789	6789	6790
2177	1822	0	applied	\N	\N	\N	\N	6797	6797	6798
2180	1826	0	applied	\N	\N	\N	\N	6808	6808	6809
2180	1827	1	applied	\N	\N	\N	\N	6810	6810	6811
2184	1828	0	applied	\N	\N	\N	\N	6814	6814	6815
2187	1829	0	applied	\N	\N	\N	\N	6820	6820	6821
2187	1830	1	applied	\N	\N	\N	\N	6822	6822	6823
2190	1832	0	applied	\N	\N	\N	\N	6836	6836	6837
2192	1833	0	applied	\N	\N	\N	\N	6840	6840	6841
2193	1833	0	applied	\N	\N	\N	\N	6840	6840	6841
2193	1834	1	applied	\N	\N	\N	\N	6846	6846	6847
2193	1835	2	applied	\N	\N	\N	\N	6848	6848	6849
2193	1836	3	applied	\N	\N	\N	\N	6850	6850	6851
2046	1730	0	applied	\N	\N	\N	\N	6457	6457	6458
2046	1731	1	applied	\N	\N	\N	\N	6459	6459	6460
2046	1732	2	applied	\N	\N	\N	\N	6461	6461	6462
2046	1733	3	applied	\N	\N	\N	\N	6463	6463	6464
2046	1734	4	applied	\N	\N	\N	\N	6465	6465	6466
2046	1735	5	applied	\N	\N	\N	\N	6467	6467	6468
2048	1737	0	applied	\N	\N	\N	\N	6475	6475	6476
2049	1737	0	applied	\N	\N	\N	\N	6475	6475	6476
2050	1738	0	applied	\N	\N	\N	\N	6477	6477	6478
2054	1741	0	applied	\N	\N	\N	\N	6488	6488	6489
2055	1742	0	applied	\N	\N	\N	\N	6490	6490	6491
2058	1743	0	applied	\N	\N	\N	\N	6496	6496	6497
2060	1744	0	applied	\N	\N	\N	\N	6502	6502	6503
2061	1745	0	applied	\N	\N	\N	\N	6506	6506	6507
2064	1746	0	applied	\N	\N	\N	\N	6510	6510	6511
2066	1748	0	applied	\N	\N	\N	\N	6514	6514	6515
2067	1748	0	applied	\N	\N	\N	\N	6514	6514	6515
2068	1749	0	applied	\N	\N	\N	\N	6518	6518	6519
2071	1750	0	applied	\N	\N	\N	\N	6526	6526	6527
2074	1753	0	applied	\N	\N	\N	\N	6536	6536	6537
2077	1754	0	applied	\N	\N	\N	\N	6544	6544	6545
2079	1755	0	applied	\N	\N	\N	\N	6550	6550	6551
2080	1755	0	applied	\N	\N	\N	\N	6550	6550	6551
2082	1756	0	applied	\N	\N	\N	\N	6555	6555	6556
2085	1757	0	applied	\N	\N	\N	\N	6559	6559	6560
2087	1759	0	applied	\N	\N	\N	\N	6567	6567	6568
2087	1760	1	applied	\N	\N	\N	\N	6569	6569	6570
2087	1761	2	applied	\N	\N	\N	\N	6571	6571	6572
2089	1762	0	applied	\N	\N	\N	\N	6576	6576	6577
2089	1763	1	applied	\N	\N	\N	\N	6578	6578	6579
2089	1764	2	applied	\N	\N	\N	\N	6580	6580	6581
2093	1766	0	applied	\N	\N	\N	\N	6585	6585	6586
2096	1767	0	applied	\N	\N	\N	\N	6591	6591	6592
2096	1768	1	applied	\N	\N	\N	\N	6593	6593	6594
2098	1769	0	applied	\N	\N	\N	\N	6599	6599	6600
2098	1770	1	applied	\N	\N	\N	\N	6601	6601	6602
2100	1772	0	applied	\N	\N	\N	\N	6609	6609	6610
2103	1772	0	applied	\N	\N	\N	\N	6609	6609	6610
2106	1773	0	applied	\N	\N	\N	\N	6613	6613	6614
2107	1619	0	applied	\N	\N	\N	\N	6047	6047	6048
2107	1620	1	applied	\N	\N	\N	\N	6049	6049	6050
2107	1621	2	applied	\N	\N	\N	\N	6053	6053	6054
2107	1636	3	applied	\N	\N	\N	\N	6096	6096	6097
2107	1622	4	applied	\N	\N	\N	\N	6057	6057	6058
2107	1623	5	applied	\N	\N	\N	\N	6061	6061	6062
2107	1624	6	applied	\N	\N	\N	\N	6063	6063	6064
2107	1625	7	applied	\N	\N	\N	\N	6065	6065	6066
2107	1626	8	applied	\N	\N	\N	\N	6067	6067	6068
2107	1627	9	applied	\N	\N	\N	\N	6071	6071	6072
2107	1628	10	applied	\N	\N	\N	\N	6075	6075	6076
2107	1629	11	applied	\N	\N	\N	\N	6077	6077	6078
2107	1630	12	applied	\N	\N	\N	\N	6079	6079	6080
2107	1631	13	applied	\N	\N	\N	\N	6082	6082	6083
2107	1632	14	applied	\N	\N	\N	\N	6084	6084	6085
2107	1633	15	applied	\N	\N	\N	\N	6090	6090	6091
2107	1634	16	applied	\N	\N	\N	\N	6092	6092	6093
2107	1635	17	applied	\N	\N	\N	\N	6094	6094	6095
2107	1637	18	applied	\N	\N	\N	\N	6098	6098	6099
2107	1638	19	applied	\N	\N	\N	\N	6102	6102	6103
2107	1639	20	applied	\N	\N	\N	\N	6106	6106	6107
2107	1640	21	applied	\N	\N	\N	\N	6110	6110	6111
2107	1642	22	applied	\N	\N	\N	\N	6116	6116	6117
2107	1643	23	applied	\N	\N	\N	\N	6119	6119	6120
2107	1644	24	applied	\N	\N	\N	\N	6123	6123	6124
2107	1645	25	applied	\N	\N	\N	\N	6129	6129	6130
2107	1646	26	applied	\N	\N	\N	\N	6131	6131	6132
2107	1647	27	applied	\N	\N	\N	\N	6133	6133	6134
2107	1648	28	applied	\N	\N	\N	\N	6135	6135	6136
2107	1649	29	applied	\N	\N	\N	\N	6140	6140	6141
2107	1650	30	applied	\N	\N	\N	\N	6144	6144	6145
2107	1651	31	applied	\N	\N	\N	\N	6146	6146	6147
2107	1652	32	applied	\N	\N	\N	\N	6150	6150	6151
2107	1653	33	applied	\N	\N	\N	\N	6159	6159	6160
2107	1654	34	applied	\N	\N	\N	\N	6163	6163	6164
2107	1655	35	applied	\N	\N	\N	\N	6169	6169	6170
2107	1656	36	applied	\N	\N	\N	\N	6171	6171	6172
2107	1657	37	applied	\N	\N	\N	\N	6176	6176	6177
2107	1658	38	applied	\N	\N	\N	\N	6183	6183	6184
2107	1659	39	applied	\N	\N	\N	\N	6185	6185	6186
2107	1660	40	applied	\N	\N	\N	\N	6189	6189	6190
2107	1661	41	applied	\N	\N	\N	\N	6197	6197	6198
2107	1662	42	applied	\N	\N	\N	\N	6199	6199	6200
2107	1663	43	applied	\N	\N	\N	\N	6201	6201	6202
2107	1664	44	applied	\N	\N	\N	\N	6206	6206	6207
2107	1665	45	applied	\N	\N	\N	\N	6212	6212	6213
2107	1666	46	applied	\N	\N	\N	\N	6214	6214	6215
2107	1667	47	applied	\N	\N	\N	\N	6219	6219	6220
2107	1668	48	applied	\N	\N	\N	\N	6223	6223	6224
2107	1669	49	applied	\N	\N	\N	\N	6225	6225	6226
2107	1670	50	applied	\N	\N	\N	\N	6227	6227	6228
2107	1671	51	applied	\N	\N	\N	\N	6229	6229	6230
2107	1672	52	applied	\N	\N	\N	\N	6231	6231	6232
2107	1673	53	applied	\N	\N	\N	\N	6233	6233	6234
2107	1674	54	applied	\N	\N	\N	\N	6237	6237	6238
2107	1675	55	applied	\N	\N	\N	\N	6239	6239	6240
2107	1676	56	applied	\N	\N	\N	\N	6247	6247	6248
2107	1677	57	applied	\N	\N	\N	\N	6250	6250	6251
2107	1678	58	applied	\N	\N	\N	\N	6261	6261	6262
2107	1679	59	applied	\N	\N	\N	\N	6265	6265	6266
2107	1680	60	applied	\N	\N	\N	\N	6269	6269	6270
2107	1681	61	applied	\N	\N	\N	\N	6271	6271	6272
2107	1682	62	applied	\N	\N	\N	\N	6273	6273	6274
2107	1683	63	applied	\N	\N	\N	\N	6276	6276	6277
2107	1684	64	applied	\N	\N	\N	\N	6278	6278	6279
2107	1685	65	applied	\N	\N	\N	\N	6282	6282	6283
2107	1686	66	applied	\N	\N	\N	\N	6284	6284	6285
2107	1687	67	applied	\N	\N	\N	\N	6289	6289	6290
2107	1688	68	applied	\N	\N	\N	\N	6291	6291	6292
2107	1689	69	applied	\N	\N	\N	\N	6299	6299	6300
2107	1690	70	applied	\N	\N	\N	\N	6305	6305	6306
2107	1691	71	applied	\N	\N	\N	\N	6307	6307	6308
2107	1692	72	applied	\N	\N	\N	\N	6311	6311	6312
2107	1693	73	applied	\N	\N	\N	\N	6313	6313	6314
2107	1694	74	applied	\N	\N	\N	\N	6318	6318	6319
2107	1695	75	applied	\N	\N	\N	\N	6320	6320	6321
2107	1696	76	applied	\N	\N	\N	\N	6327	6327	6328
2107	1697	77	applied	\N	\N	\N	\N	6331	6331	6332
2107	1698	78	applied	\N	\N	\N	\N	6333	6333	6334
2107	1699	79	applied	\N	\N	\N	\N	6340	6340	6341
2107	1700	80	applied	\N	\N	\N	\N	6342	6342	6343
2051	1739	0	applied	\N	\N	\N	\N	6481	6481	6482
2051	1740	1	applied	\N	\N	\N	\N	6483	6483	6484
2053	1741	0	applied	\N	\N	\N	\N	6488	6488	6489
2057	1743	0	applied	\N	\N	\N	\N	6496	6496	6497
2063	1746	0	applied	\N	\N	\N	\N	6510	6510	6511
2070	1749	0	applied	\N	\N	\N	\N	6518	6518	6519
2073	1751	0	applied	\N	\N	\N	\N	6530	6530	6531
2073	1752	1	applied	\N	\N	\N	\N	6532	6532	6533
2076	1753	0	applied	\N	\N	\N	\N	6536	6536	6537
2081	1756	0	applied	\N	\N	\N	\N	6555	6555	6556
2084	1757	0	applied	\N	\N	\N	\N	6559	6559	6560
2086	1758	0	applied	\N	\N	\N	\N	6563	6563	6564
2092	1766	0	applied	\N	\N	\N	\N	6585	6585	6586
2095	1767	0	applied	\N	\N	\N	\N	6591	6591	6592
2095	1768	1	applied	\N	\N	\N	\N	6593	6593	6594
2102	1772	0	applied	\N	\N	\N	\N	6609	6609	6610
2104	1773	0	applied	\N	\N	\N	\N	6613	6613	6614
2109	1774	0	applied	\N	\N	\N	\N	6622	6622	6623
2113	1776	0	applied	\N	\N	\N	\N	6629	6629	6630
2121	1783	0	applied	\N	\N	\N	\N	6654	6654	6655
2125	1785	0	applied	\N	\N	\N	\N	6660	6660	6661
2125	1786	1	applied	\N	\N	\N	\N	6662	6662	6663
2126	1787	0	applied	\N	\N	\N	\N	6666	6666	6667
2127	1788	0	applied	\N	\N	\N	\N	6670	6670	6671
2130	1791	0	applied	\N	\N	\N	\N	6680	6680	6681
2136	1791	0	applied	\N	\N	\N	\N	6680	6680	6681
2136	1792	1	applied	\N	\N	\N	\N	6682	6682	6683
2136	1793	2	applied	\N	\N	\N	\N	6686	6686	6687
2139	1794	0	applied	\N	\N	\N	\N	6695	6695	6696
2141	1795	0	applied	\N	\N	\N	\N	6701	6701	6702
2148	1803	0	applied	\N	\N	\N	\N	6723	6723	6724
2153	1807	0	applied	\N	\N	\N	\N	6736	6736	6737
2157	1810	0	applied	\N	\N	\N	\N	6744	6744	6745
2157	1811	1	applied	\N	\N	\N	\N	6746	6746	6747
2162	1812	0	applied	\N	\N	\N	\N	6753	6753	6754
2164	1814	0	applied	\N	\N	\N	\N	6761	6761	6762
2167	1815	0	applied	\N	\N	\N	\N	6767	6767	6768
2167	1816	1	applied	\N	\N	\N	\N	6769	6769	6770
2170	1817	0	applied	\N	\N	\N	\N	6775	6775	6776
2178	1822	0	applied	\N	\N	\N	\N	6797	6797	6798
2179	1823	0	applied	\N	\N	\N	\N	6801	6801	6802
2179	1824	1	applied	\N	\N	\N	\N	6803	6803	6804
2179	1825	2	applied	\N	\N	\N	\N	6805	6805	6806
2182	1828	0	applied	\N	\N	\N	\N	6814	6814	6815
2185	1829	0	applied	\N	\N	\N	\N	6820	6820	6821
2185	1830	1	applied	\N	\N	\N	\N	6822	6822	6823
2186	1815	0	applied	\N	\N	\N	\N	6825	6825	6768
2186	1660	1	applied	\N	\N	\N	\N	6189	6189	6190
2186	1661	2	applied	\N	\N	\N	\N	6197	6197	6198
2186	1662	3	applied	\N	\N	\N	\N	6199	6199	6200
2186	1663	4	applied	\N	\N	\N	\N	6201	6201	6202
2186	1664	5	applied	\N	\N	\N	\N	6206	6206	6207
2186	1665	6	applied	\N	\N	\N	\N	6212	6212	6213
2186	1666	7	applied	\N	\N	\N	\N	6214	6214	6215
2186	1667	8	applied	\N	\N	\N	\N	6219	6219	6220
2186	1668	9	applied	\N	\N	\N	\N	6223	6223	6224
2186	1669	10	applied	\N	\N	\N	\N	6225	6225	6226
2186	1670	11	applied	\N	\N	\N	\N	6227	6227	6228
2186	1671	12	applied	\N	\N	\N	\N	6229	6229	6230
2189	1832	0	applied	\N	\N	\N	\N	6836	6836	6837
2194	1834	0	applied	\N	\N	\N	\N	6846	6846	6847
2194	1835	1	applied	\N	\N	\N	\N	6848	6848	6849
2194	1836	2	applied	\N	\N	\N	\N	6850	6850	6851
2107	1701	81	applied	\N	\N	\N	\N	6344	6344	6345
2107	1702	82	applied	\N	\N	\N	\N	6348	6348	6349
2107	1703	83	applied	\N	\N	\N	\N	6352	6352	6353
2107	1704	84	applied	\N	\N	\N	\N	6361	6361	6362
2107	1705	85	applied	\N	\N	\N	\N	6363	6363	6364
2107	1706	86	applied	\N	\N	\N	\N	6365	6365	6366
2107	1707	87	applied	\N	\N	\N	\N	6369	6369	6370
2107	1708	88	applied	\N	\N	\N	\N	6373	6373	6374
2107	1709	89	applied	\N	\N	\N	\N	6380	6380	6381
2107	1710	90	applied	\N	\N	\N	\N	6382	6382	6383
2107	1711	91	applied	\N	\N	\N	\N	6388	6388	6389
2107	1712	92	applied	\N	\N	\N	\N	6390	6390	6391
2107	1713	93	applied	\N	\N	\N	\N	6394	6394	6395
2107	1714	94	applied	\N	\N	\N	\N	6396	6396	6397
2107	1715	95	applied	\N	\N	\N	\N	6400	6400	6401
2107	1716	96	applied	\N	\N	\N	\N	6402	6402	6403
2107	1717	97	applied	\N	\N	\N	\N	6406	6406	6407
2107	1718	98	applied	\N	\N	\N	\N	6410	6410	6411
2107	1719	99	applied	\N	\N	\N	\N	6412	6412	6413
2107	1720	100	applied	\N	\N	\N	\N	6421	6421	6422
2107	1721	102	applied	\N	\N	\N	\N	6425	6425	6426
2107	1722	103	applied	\N	\N	\N	\N	6427	6427	6428
2107	1723	104	applied	\N	\N	\N	\N	6431	6431	6432
2107	1724	105	applied	\N	\N	\N	\N	6433	6433	6434
2107	1725	106	applied	\N	\N	\N	\N	6436	6436	6437
2107	1726	107	applied	\N	\N	\N	\N	6440	6440	6441
2107	1727	108	applied	\N	\N	\N	\N	6442	6442	6443
2107	1728	109	applied	\N	\N	\N	\N	6448	6448	6449
2107	1729	110	applied	\N	\N	\N	\N	6452	6452	6453
2107	1730	111	applied	\N	\N	\N	\N	6457	6457	6458
2107	1731	112	applied	\N	\N	\N	\N	6459	6459	6460
2107	1732	113	applied	\N	\N	\N	\N	6461	6461	6462
2107	1733	114	applied	\N	\N	\N	\N	6463	6463	6464
2107	1734	115	applied	\N	\N	\N	\N	6465	6465	6466
2107	1735	116	applied	\N	\N	\N	\N	6467	6467	6468
2107	1736	117	applied	\N	\N	\N	\N	6471	6471	6472
2107	1737	118	applied	\N	\N	\N	\N	6475	6475	6476
2107	1738	119	applied	\N	\N	\N	\N	6477	6477	6478
2107	1739	120	applied	\N	\N	\N	\N	6481	6481	6482
2107	1740	121	applied	\N	\N	\N	\N	6483	6483	6484
2107	1741	122	applied	\N	\N	\N	\N	6488	6488	6489
2107	1742	123	applied	\N	\N	\N	\N	6490	6490	6491
2107	1743	124	applied	\N	\N	\N	\N	6496	6496	6497
2107	1744	125	applied	\N	\N	\N	\N	6502	6502	6503
2110	1775	0	applied	\N	\N	\N	\N	6625	6625	6626
2116	1780	0	applied	\N	\N	\N	\N	6642	6642	6643
2116	1781	1	applied	\N	\N	\N	\N	6644	6644	6645
2118	1782	0	applied	\N	\N	\N	\N	6650	6650	6651
2120	1783	0	applied	\N	\N	\N	\N	6654	6654	6655
2122	1783	0	applied	\N	\N	\N	\N	6654	6654	6655
2124	1785	0	applied	\N	\N	\N	\N	6660	6660	6661
2124	1786	1	applied	\N	\N	\N	\N	6662	6662	6663
2128	1789	0	applied	\N	\N	\N	\N	6674	6674	6675
2131	1792	0	applied	\N	\N	\N	\N	6682	6682	6683
2132	1792	0	applied	\N	\N	\N	\N	6682	6682	6683
2133	1793	0	applied	\N	\N	\N	\N	6686	6686	6687
2135	1793	0	applied	\N	\N	\N	\N	6686	6686	6687
2137	1793	0	applied	\N	\N	\N	\N	6686	6686	6687
2140	1794	0	applied	\N	\N	\N	\N	6695	6695	6696
2142	1795	0	applied	\N	\N	\N	\N	6701	6701	6702
2143	1796	0	applied	\N	\N	\N	\N	6706	6706	6707
2145	1798	0	applied	\N	\N	\N	\N	6710	6710	6711
2147	1801	0	applied	\N	\N	\N	\N	6718	6718	6719
2147	1802	1	applied	\N	\N	\N	\N	6720	6720	6721
2158	1810	0	applied	\N	\N	\N	\N	6744	6744	6745
2158	1811	1	applied	\N	\N	\N	\N	6746	6746	6747
2160	1812	0	applied	\N	\N	\N	\N	6753	6753	6754
2163	1813	0	applied	\N	\N	\N	\N	6757	6757	6758
2165	1814	0	applied	\N	\N	\N	\N	6761	6761	6762
2166	1814	0	applied	\N	\N	\N	\N	6761	6761	6762
2168	1815	0	applied	\N	\N	\N	\N	6767	6767	6768
2168	1816	1	applied	\N	\N	\N	\N	6769	6769	6770
2172	1818	0	applied	\N	\N	\N	\N	6779	6779	6780
2172	1819	1	applied	\N	\N	\N	\N	6781	6781	6782
2172	1820	2	applied	\N	\N	\N	\N	6783	6783	6784
2174	1821	0	applied	\N	\N	\N	\N	6789	6789	6790
2175	1821	0	applied	\N	\N	\N	\N	6789	6789	6790
2181	1826	0	applied	\N	\N	\N	\N	6808	6808	6809
2181	1827	1	applied	\N	\N	\N	\N	6810	6810	6811
2183	1828	0	applied	\N	\N	\N	\N	6814	6814	6815
2188	1831	0	applied	\N	\N	\N	\N	6832	6832	6833
2191	1833	0	applied	\N	\N	\N	\N	6840	6840	6841
2195	1815	0	applied	\N	\N	\N	\N	6767	6767	6768
2195	1775	1	applied	\N	\N	\N	\N	6625	6625	6626
2195	1776	2	applied	\N	\N	\N	\N	6629	6629	6630
2195	1777	3	applied	\N	\N	\N	\N	6633	6633	6634
2195	1778	4	applied	\N	\N	\N	\N	6637	6637	6638
2195	1779	5	applied	\N	\N	\N	\N	6639	6639	6640
2195	1780	6	applied	\N	\N	\N	\N	6642	6642	6643
2195	1781	7	applied	\N	\N	\N	\N	6644	6644	6645
2195	1782	8	applied	\N	\N	\N	\N	6650	6650	6651
2195	1783	9	applied	\N	\N	\N	\N	6654	6654	6655
2195	1784	10	applied	\N	\N	\N	\N	6658	6658	6659
2195	1785	11	applied	\N	\N	\N	\N	6660	6660	6661
2195	1786	12	applied	\N	\N	\N	\N	6662	6662	6663
2195	1787	13	applied	\N	\N	\N	\N	6666	6666	6667
2195	1788	14	applied	\N	\N	\N	\N	6670	6670	6671
2195	1789	15	applied	\N	\N	\N	\N	6674	6674	6675
2195	1790	16	applied	\N	\N	\N	\N	6676	6676	6677
2195	1791	17	applied	\N	\N	\N	\N	6680	6680	6681
2195	1792	18	applied	\N	\N	\N	\N	6682	6682	6683
2195	1793	19	applied	\N	\N	\N	\N	6686	6686	6687
2195	1794	20	applied	\N	\N	\N	\N	6695	6695	6696
2195	1795	21	applied	\N	\N	\N	\N	6701	6701	6702
2195	1796	22	applied	\N	\N	\N	\N	6706	6706	6707
2195	1797	23	applied	\N	\N	\N	\N	6708	6708	6709
2195	1798	24	applied	\N	\N	\N	\N	6710	6710	6711
2195	1799	25	applied	\N	\N	\N	\N	6712	6712	6713
2195	1800	26	applied	\N	\N	\N	\N	6714	6714	6715
2195	1801	27	applied	\N	\N	\N	\N	6718	6718	6719
2195	1802	28	applied	\N	\N	\N	\N	6720	6720	6721
2195	1803	29	applied	\N	\N	\N	\N	6723	6723	6724
2195	1804	30	applied	\N	\N	\N	\N	6727	6727	6728
2195	1805	31	applied	\N	\N	\N	\N	6731	6731	6732
2195	1806	32	applied	\N	\N	\N	\N	6733	6733	6734
2195	1807	33	applied	\N	\N	\N	\N	6736	6736	6737
2195	1808	34	applied	\N	\N	\N	\N	6738	6738	6739
2195	1809	35	applied	\N	\N	\N	\N	6740	6740	6741
2195	1810	36	applied	\N	\N	\N	\N	6744	6744	6745
2195	1811	37	applied	\N	\N	\N	\N	6746	6746	6747
2195	1812	38	applied	\N	\N	\N	\N	6753	6753	6754
2195	1813	39	applied	\N	\N	\N	\N	6757	6757	6758
2195	1814	40	applied	\N	\N	\N	\N	6761	6761	6762
2195	1816	41	applied	\N	\N	\N	\N	6769	6769	6770
2195	1817	42	applied	\N	\N	\N	\N	6775	6775	6776
2195	1818	43	applied	\N	\N	\N	\N	6779	6779	6780
2195	1819	44	applied	\N	\N	\N	\N	6781	6781	6782
2195	1820	45	applied	\N	\N	\N	\N	6783	6783	6784
2195	1821	46	applied	\N	\N	\N	\N	6789	6789	6790
2195	1822	47	applied	\N	\N	\N	\N	6797	6797	6798
2195	1823	48	applied	\N	\N	\N	\N	6801	6801	6802
2195	1824	49	applied	\N	\N	\N	\N	6803	6803	6804
2195	1825	50	applied	\N	\N	\N	\N	6805	6805	6806
2195	1826	51	applied	\N	\N	\N	\N	6808	6808	6809
2195	1827	52	applied	\N	\N	\N	\N	6810	6810	6811
2195	1828	53	applied	\N	\N	\N	\N	6814	6814	6815
2195	1829	54	applied	\N	\N	\N	\N	6820	6820	6821
2195	1830	55	applied	\N	\N	\N	\N	6822	6822	6823
2195	1831	56	applied	\N	\N	\N	\N	6832	6832	6833
2195	1832	57	applied	\N	\N	\N	\N	6836	6836	6837
2195	1833	58	applied	\N	\N	\N	\N	6840	6840	6841
2195	1834	59	applied	\N	\N	\N	\N	6846	6846	6847
2195	1835	60	applied	\N	\N	\N	\N	6848	6848	6849
2195	1836	61	applied	\N	\N	\N	\N	6850	6850	6851
2196	1837	0	applied	\N	\N	\N	\N	6855	6855	6856
2197	1837	0	applied	\N	\N	\N	\N	6855	6855	6856
2198	1837	0	applied	\N	\N	\N	\N	6855	6855	6856
2199	1838	0	applied	\N	\N	\N	\N	6859	6859	6860
2199	1839	1	applied	\N	\N	\N	\N	6861	6861	6862
2199	1840	2	applied	\N	\N	\N	\N	6863	6863	6864
2200	1841	0	applied	\N	\N	\N	\N	6866	6866	6867
2201	1841	0	applied	\N	\N	\N	\N	6866	6866	6867
2202	1841	0	applied	\N	\N	\N	\N	6866	6866	6867
2203	1841	0	applied	\N	\N	\N	\N	6866	6866	6867
2204	1842	0	applied	\N	\N	\N	\N	6872	6872	6873
2204	1843	1	applied	\N	\N	\N	\N	6874	6874	6875
2205	1842	0	applied	\N	\N	\N	\N	6872	6872	6873
2205	1843	1	applied	\N	\N	\N	\N	6874	6874	6875
2206	1844	0	applied	\N	\N	\N	\N	6880	6880	6881
2207	1845	0	applied	\N	\N	\N	\N	6884	6884	6885
2207	1846	1	applied	\N	\N	\N	\N	6886	6886	6887
2208	1845	0	applied	\N	\N	\N	\N	6884	6884	6885
2208	1846	1	applied	\N	\N	\N	\N	6886	6886	6887
2209	1845	0	applied	\N	\N	\N	\N	6884	6884	6885
2209	1846	1	applied	\N	\N	\N	\N	6886	6886	6887
2210	1847	0	applied	\N	\N	\N	\N	6893	6893	6894
2210	1848	1	applied	\N	\N	\N	\N	6895	6895	6896
2211	1844	0	applied	\N	\N	\N	\N	6880	6880	6881
2212	1849	0	applied	\N	\N	\N	\N	6898	6898	6899
2213	1850	0	applied	\N	\N	\N	\N	6902	6902	6903
2214	1851	0	applied	\N	\N	\N	\N	6906	6906	6907
2215	1851	0	applied	\N	\N	\N	\N	6906	6906	6907
2216	1850	0	applied	\N	\N	\N	\N	6902	6902	6903
2216	1851	1	applied	\N	\N	\N	\N	6906	6906	6907
2216	1852	2	applied	\N	\N	\N	\N	6910	6910	6911
2217	1852	0	applied	\N	\N	\N	\N	6910	6910	6911
2218	1852	0	applied	\N	\N	\N	\N	6910	6910	6911
2219	1853	0	applied	\N	\N	\N	\N	6917	6917	6918
2220	1854	0	applied	\N	\N	\N	\N	6919	6919	6920
2221	1854	0	applied	\N	\N	\N	\N	6919	6919	6920
2222	1854	0	applied	\N	\N	\N	\N	6919	6919	6920
2223	1855	0	applied	\N	\N	\N	\N	6925	6925	6926
2224	1856	0	applied	\N	\N	\N	\N	6927	6927	6928
2224	1857	1	applied	\N	\N	\N	\N	6929	6929	6930
2224	1858	2	applied	\N	\N	\N	\N	6931	6931	6932
2224	1859	3	applied	\N	\N	\N	\N	6933	6933	6934
2224	1860	4	applied	\N	\N	\N	\N	6935	6935	6936
2225	1861	0	applied	\N	\N	\N	\N	6939	6939	6940
2225	1862	1	applied	\N	\N	\N	\N	6941	6941	6942
2226	1863	0	applied	\N	\N	\N	\N	6944	6944	6945
2227	1864	0	applied	\N	\N	\N	\N	6947	6947	6948
2228	1864	0	applied	\N	\N	\N	\N	6947	6947	6948
2229	1865	0	applied	\N	\N	\N	\N	6951	6951	6952
2230	1865	0	applied	\N	\N	\N	\N	6951	6951	6952
2232	1866	0	applied	\N	\N	\N	\N	6958	6958	6959
2232	1867	1	applied	\N	\N	\N	\N	6960	6960	6961
2233	1866	0	applied	\N	\N	\N	\N	6958	6958	6959
2233	1867	1	applied	\N	\N	\N	\N	6960	6960	6961
2234	1868	0	applied	\N	\N	1000000000	\N	6964	6964	6965
2234	1869	1	applied	\N	\N	\N	\N	6966	6966	6967
2235	1868	0	applied	\N	\N	1000000000	\N	6964	6964	6965
2235	1869	1	applied	\N	\N	\N	\N	6966	6966	6967
2236	1870	0	applied	\N	\N	\N	\N	6972	6972	6973
2237	1870	0	applied	\N	\N	\N	\N	6972	6972	6973
2238	1870	0	applied	\N	\N	\N	\N	6972	6972	6973
2239	1871	0	applied	\N	\N	\N	\N	6976	6976	6977
2239	1872	1	applied	\N	\N	\N	\N	6978	6978	6979
2240	1873	0	applied	\N	\N	\N	\N	6982	6982	6983
2240	1874	1	applied	\N	\N	\N	\N	6984	6984	6985
2241	1856	0	applied	\N	\N	\N	\N	6988	6988	6928
2241	1815	1	applied	\N	\N	\N	\N	6825	6825	6768
2241	1636	2	applied	\N	\N	\N	\N	6096	6096	6097
2242	1875	0	applied	\N	\N	1000000000	\N	6991	6991	6992
2242	1876	1	applied	\N	\N	\N	\N	6993	6993	6994
2243	1875	0	applied	\N	\N	1000000000	\N	6991	6991	6992
2243	1876	1	applied	\N	\N	\N	\N	6993	6993	6994
2251	1877	0	applied	\N	\N	\N	\N	7002	7002	7003
2251	1878	1	applied	\N	\N	\N	\N	7004	7004	7005
2251	1879	2	applied	\N	\N	\N	\N	7006	7006	7007
2253	1877	0	applied	\N	\N	\N	\N	7002	7002	7003
2253	1878	1	applied	\N	\N	\N	\N	7004	7004	7005
2253	1879	2	applied	\N	\N	\N	\N	7006	7006	7007
2254	1877	0	applied	\N	\N	\N	\N	7002	7002	7003
2254	1878	1	applied	\N	\N	\N	\N	7004	7004	7005
2254	1879	2	applied	\N	\N	\N	\N	7006	7006	7007
2255	1877	0	applied	\N	\N	\N	\N	7002	7002	7003
2255	1878	1	applied	\N	\N	\N	\N	7004	7004	7005
2255	1879	2	applied	\N	\N	\N	\N	7006	7006	7007
2256	1877	0	applied	\N	\N	\N	\N	7002	7002	7003
2256	1878	1	applied	\N	\N	\N	\N	7004	7004	7005
2256	1879	2	applied	\N	\N	\N	\N	7006	7006	7007
2257	1880	0	applied	\N	\N	\N	\N	7017	7017	7018
2258	1880	0	applied	\N	\N	\N	\N	7017	7017	7018
2259	1881	0	applied	\N	\N	\N	\N	7021	7021	7022
2259	1882	1	applied	\N	\N	\N	\N	7023	7023	7024
2259	1883	2	applied	\N	\N	\N	\N	7025	7025	7026
2259	1884	3	applied	\N	\N	1000000000	\N	7027	7027	7028
2260	1885	0	applied	\N	\N	\N	\N	7031	7031	7032
2260	1886	1	applied	\N	\N	1000000000	\N	7033	7033	7034
2261	1856	0	applied	\N	\N	\N	\N	6988	6988	6928
2261	1884	1	applied	\N	\N	1000000000	\N	7027	7027	7028
2263	1887	0	applied	\N	\N	\N	\N	7042	7042	7043
2263	1888	1	applied	\N	\N	\N	\N	7044	7044	7034
2263	1889	2	applied	\N	\N	\N	\N	7045	7045	7046
2263	1890	3	applied	\N	\N	\N	\N	7047	7047	7048
2264	1891	0	applied	\N	\N	\N	\N	7052	7052	7053
2264	1892	1	applied	\N	\N	\N	\N	7054	7054	7055
2267	1893	0	applied	\N	\N	\N	\N	7058	7058	7059
2270	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2274	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2274	1896	1	applied	\N	\N	\N	\N	7070	7070	7071
2276	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2278	1897	0	applied	\N	\N	\N	\N	7079	7079	7080
2279	1898	0	applied	\N	\N	\N	\N	7081	7081	7082
2282	1899	0	applied	\N	\N	\N	\N	7086	7086	7087
2282	1900	1	applied	\N	\N	\N	\N	7088	7088	7089
2285	1901	0	applied	\N	\N	\N	\N	7092	7092	7093
2291	1905	0	applied	\N	\N	\N	\N	7105	7105	7106
2293	1906	0	applied	\N	\N	\N	\N	7107	7107	7108
2293	1907	1	applied	\N	\N	\N	\N	7109	7109	7110
2293	1908	2	applied	\N	\N	\N	\N	7111	7111	7112
2296	1909	0	applied	\N	\N	\N	\N	7119	7119	7120
2296	1910	1	applied	\N	\N	\N	\N	7121	7121	7122
2297	1911	0	applied	\N	\N	\N	\N	7125	7125	7126
2299	1912	0	applied	\N	\N	\N	\N	7129	7129	7130
2306	1915	0	applied	\N	\N	\N	\N	7145	7145	7146
2313	1906	0	applied	\N	\N	\N	\N	7107	7107	7108
2313	1907	1	applied	\N	\N	\N	\N	7109	7109	7110
2313	1908	2	applied	\N	\N	\N	\N	7111	7111	7112
2313	1909	3	applied	\N	\N	\N	\N	7119	7119	7120
2313	1910	4	applied	\N	\N	\N	\N	7121	7121	7122
2313	1911	5	applied	\N	\N	\N	\N	7125	7125	7126
2313	1912	6	applied	\N	\N	\N	\N	7129	7129	7130
2313	1913	7	applied	\N	\N	\N	\N	7137	7137	7138
2313	1914	8	applied	\N	\N	\N	\N	7140	7140	7141
2313	1915	9	applied	\N	\N	\N	\N	7145	7145	7146
2313	1916	10	applied	\N	\N	\N	\N	7150	7150	7151
2313	1917	11	applied	\N	\N	\N	\N	7152	7152	7153
2313	1918	12	applied	\N	\N	\N	\N	7154	7154	7155
2319	1924	0	applied	\N	\N	\N	\N	7177	7177	7178
2325	1928	0	applied	\N	\N	\N	\N	7192	7192	7193
2327	1929	0	applied	\N	\N	\N	\N	7196	7196	7197
2327	1930	1	applied	\N	\N	\N	\N	7198	7198	7199
2332	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2332	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2332	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2339	1935	0	applied	\N	\N	\N	\N	7228	7228	7229
2340	1935	0	applied	\N	\N	\N	\N	7228	7228	7229
2340	1936	1	applied	\N	\N	\N	\N	7234	7234	7235
2340	1937	2	applied	\N	\N	\N	\N	7236	7236	7237
2343	1938	0	applied	\N	\N	\N	\N	7240	7240	7241
2343	1939	1	applied	\N	\N	\N	\N	7242	7242	7243
2349	1946	0	applied	\N	\N	\N	\N	7267	7267	7268
2349	1947	1	applied	\N	\N	\N	\N	7269	7269	7270
2352	1946	0	applied	\N	\N	\N	\N	7267	7267	7268
2352	1947	1	applied	\N	\N	\N	\N	7269	7269	7270
2355	1949	0	applied	\N	\N	\N	\N	7281	7281	7282
2355	1950	1	applied	\N	\N	\N	\N	7283	7283	7284
2358	1952	0	applied	\N	\N	\N	\N	7291	7291	7292
2360	1953	0	applied	\N	\N	\N	\N	7295	7295	7296
2361	1953	0	applied	\N	\N	\N	\N	7295	7295	7296
2366	1957	0	applied	\N	\N	\N	\N	7315	7315	7316
2367	1958	0	applied	\N	\N	\N	\N	7318	7318	7319
2369	1958	0	applied	\N	\N	\N	\N	7318	7318	7319
2370	1959	0	applied	\N	\N	\N	\N	7322	7322	7323
2370	1960	1	applied	\N	\N	\N	\N	7324	7324	7325
2373	1962	0	applied	\N	\N	\N	\N	7334	7334	7335
2379	1967	0	applied	\N	\N	\N	\N	7351	7351	7352
2262	1887	0	applied	\N	\N	\N	\N	7042	7042	7043
2262	1888	1	applied	\N	\N	\N	\N	7044	7044	7034
2262	1889	2	applied	\N	\N	\N	\N	7045	7045	7046
2262	1890	3	applied	\N	\N	\N	\N	7047	7047	7048
2265	1891	0	applied	\N	\N	\N	\N	7052	7052	7053
2265	1892	1	applied	\N	\N	\N	\N	7054	7054	7055
2269	1893	0	applied	\N	\N	\N	\N	7058	7058	7059
2269	1894	1	applied	\N	\N	\N	\N	7062	7062	7063
2272	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2272	1896	1	applied	\N	\N	\N	\N	7070	7070	7071
2275	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2280	1898	0	applied	\N	\N	\N	\N	7081	7081	7082
2281	1856	0	applied	\N	\N	\N	\N	6988	6988	6928
2281	1815	1	applied	\N	\N	\N	\N	6825	6825	6768
2281	1636	2	applied	\N	\N	\N	\N	6096	6096	6097
2281	1634	3	applied	\N	\N	\N	\N	6092	6092	6093
2281	1635	4	applied	\N	\N	\N	\N	6094	6094	6095
2281	1884	5	applied	\N	\N	1000000000	\N	7027	7027	7028
2281	1637	6	applied	\N	\N	\N	\N	6098	6098	6099
2281	1638	7	applied	\N	\N	\N	\N	6102	6102	6103
2281	1639	8	applied	\N	\N	\N	\N	6106	6106	6107
2281	1640	9	applied	\N	\N	\N	\N	6110	6110	6111
2287	1904	0	applied	\N	\N	\N	\N	7101	7101	7102
2294	1906	0	applied	\N	\N	\N	\N	7107	7107	7108
2294	1907	1	applied	\N	\N	\N	\N	7109	7109	7110
2294	1908	2	applied	\N	\N	\N	\N	7111	7111	7112
2301	1856	0	applied	\N	\N	\N	\N	6927	6927	6928
2301	1815	1	applied	\N	\N	\N	\N	7133	7133	6768
2301	1737	2	applied	\N	\N	\N	\N	6475	6475	6476
2301	1738	3	applied	\N	\N	\N	\N	6477	6477	6478
2301	1739	4	applied	\N	\N	\N	\N	6481	6481	6482
2301	1740	5	applied	\N	\N	\N	\N	6483	6483	6484
2301	1741	6	applied	\N	\N	\N	\N	6488	6488	6489
2301	1884	7	applied	\N	\N	1000000000	\N	7027	7027	7028
2301	1742	8	applied	\N	\N	\N	\N	6490	6490	6491
2301	1743	9	applied	\N	\N	\N	\N	6496	6496	6497
2301	1744	10	applied	\N	\N	\N	\N	6502	6502	6503
2301	1745	11	applied	\N	\N	\N	\N	6506	6506	6507
2301	1746	12	applied	\N	\N	\N	\N	6510	6510	6511
2301	1747	13	applied	\N	\N	\N	\N	6512	6512	6513
2301	1748	14	applied	\N	\N	\N	\N	6514	6514	6515
2301	1749	15	applied	\N	\N	\N	\N	6518	6518	6519
2301	1750	16	applied	\N	\N	\N	\N	6526	6526	6527
2301	1751	17	applied	\N	\N	\N	\N	6530	6530	6531
2301	1752	18	applied	\N	\N	\N	\N	6532	6532	6533
2301	1753	19	applied	\N	\N	\N	\N	6536	6536	6537
2301	1754	20	applied	\N	\N	\N	\N	6544	6544	6545
2301	1755	21	applied	\N	\N	\N	\N	6550	6550	6551
2301	1756	22	applied	\N	\N	\N	\N	6555	6555	6556
2301	1757	23	applied	\N	\N	\N	\N	6559	6559	6560
2301	1758	24	applied	\N	\N	\N	\N	6563	6563	6564
2301	1759	25	applied	\N	\N	\N	\N	6567	6567	6568
2301	1760	26	applied	\N	\N	\N	\N	6569	6569	6570
2301	1761	27	applied	\N	\N	\N	\N	6571	6571	6572
2301	1762	28	applied	\N	\N	\N	\N	6576	6576	6577
2301	1763	29	applied	\N	\N	\N	\N	6578	6578	6579
2301	1764	30	applied	\N	\N	\N	\N	6580	6580	6581
2301	1765	31	applied	\N	\N	\N	\N	6583	6583	6584
2301	1766	32	applied	\N	\N	\N	\N	6585	6585	6586
2301	1767	33	applied	\N	\N	\N	\N	6591	6591	6592
2301	1768	34	applied	\N	\N	\N	\N	6593	6593	6594
2301	1769	35	applied	\N	\N	\N	\N	6599	6599	6600
2301	1770	36	applied	\N	\N	\N	\N	6601	6601	6602
2301	1771	37	applied	\N	\N	\N	\N	6605	6605	6606
2301	1772	38	applied	\N	\N	\N	\N	6609	6609	6610
2301	1773	39	applied	\N	\N	\N	\N	6613	6613	6614
2301	1774	40	applied	\N	\N	\N	\N	6622	6622	6623
2301	1775	41	applied	\N	\N	\N	\N	6625	6625	6626
2301	1776	42	applied	\N	\N	\N	\N	6629	6629	6630
2301	1777	43	applied	\N	\N	\N	\N	6633	6633	6634
2301	1778	44	applied	\N	\N	\N	\N	6637	6637	6638
2301	1779	45	applied	\N	\N	\N	\N	6639	6639	6640
2301	1780	46	applied	\N	\N	\N	\N	6642	6642	6643
2301	1781	47	applied	\N	\N	\N	\N	6644	6644	6645
2301	1782	48	applied	\N	\N	\N	\N	6650	6650	6651
2301	1783	49	applied	\N	\N	\N	\N	6654	6654	6655
2301	1784	50	applied	\N	\N	\N	\N	6658	6658	6659
2301	1785	51	applied	\N	\N	\N	\N	6660	6660	6661
2301	1786	52	applied	\N	\N	\N	\N	6662	6662	6663
2301	1787	53	applied	\N	\N	\N	\N	6666	6666	6667
2301	1788	54	applied	\N	\N	\N	\N	6670	6670	6671
2301	1789	55	applied	\N	\N	\N	\N	6674	6674	6675
2301	1790	56	applied	\N	\N	\N	\N	6676	6676	6677
2301	1791	57	applied	\N	\N	\N	\N	6680	6680	6681
2301	1792	58	applied	\N	\N	\N	\N	6682	6682	6683
2301	1793	59	applied	\N	\N	\N	\N	6686	6686	6687
2301	1794	60	applied	\N	\N	\N	\N	6695	6695	6696
2301	1795	61	applied	\N	\N	\N	\N	6701	6701	6702
2301	1796	62	applied	\N	\N	\N	\N	6706	6706	6707
2301	1797	63	applied	\N	\N	\N	\N	6708	6708	6709
2301	1798	64	applied	\N	\N	\N	\N	6710	6710	6711
2301	1799	65	applied	\N	\N	\N	\N	6712	6712	6713
2301	1800	66	applied	\N	\N	\N	\N	6714	6714	6715
2301	1801	67	applied	\N	\N	\N	\N	6718	6718	6719
2301	1802	68	applied	\N	\N	\N	\N	6720	6720	6721
2301	1803	69	applied	\N	\N	\N	\N	6723	6723	6724
2301	1804	70	applied	\N	\N	\N	\N	6727	6727	6728
2301	1805	71	applied	\N	\N	\N	\N	6731	6731	6732
2301	1806	72	applied	\N	\N	\N	\N	6733	6733	6734
2301	1807	73	applied	\N	\N	\N	\N	6736	6736	6737
2301	1808	74	applied	\N	\N	\N	\N	6738	6738	6739
2301	1809	75	applied	\N	\N	\N	\N	6740	6740	6741
2301	1810	76	applied	\N	\N	\N	\N	6744	6744	6745
2301	1811	77	applied	\N	\N	\N	\N	6746	6746	6747
2301	1812	78	applied	\N	\N	\N	\N	6753	6753	6754
2301	1813	79	applied	\N	\N	\N	\N	6757	6757	6758
2301	1814	80	applied	\N	\N	\N	\N	6761	6761	6762
2301	1816	81	applied	\N	\N	\N	\N	6769	6769	6770
2301	1817	82	applied	\N	\N	\N	\N	6775	6775	6776
2301	1818	83	applied	\N	\N	\N	\N	6779	6779	6780
2301	1819	84	applied	\N	\N	\N	\N	6781	6781	6782
2301	1820	86	applied	\N	\N	\N	\N	6783	6783	6784
2301	1821	87	applied	\N	\N	\N	\N	6789	6789	6790
2301	1822	88	applied	\N	\N	\N	\N	6797	6797	6798
2301	1823	89	applied	\N	\N	\N	\N	6801	6801	6802
2301	1824	90	applied	\N	\N	\N	\N	6803	6803	6804
2301	1825	91	applied	\N	\N	\N	\N	6805	6805	6806
2301	1826	92	applied	\N	\N	\N	\N	6808	6808	6809
2301	1827	93	applied	\N	\N	\N	\N	6810	6810	6811
2266	1891	0	applied	\N	\N	\N	\N	7052	7052	7053
2266	1892	1	applied	\N	\N	\N	\N	7054	7054	7055
2273	1895	0	applied	\N	\N	\N	\N	7066	7066	7067
2273	1896	1	applied	\N	\N	\N	\N	7070	7070	7071
2277	1897	0	applied	\N	\N	\N	\N	7079	7079	7080
2283	1901	0	applied	\N	\N	\N	\N	7092	7092	7093
2286	1902	0	applied	\N	\N	\N	\N	7095	7095	7096
2286	1903	1	applied	\N	\N	\N	\N	7097	7097	7098
2288	1904	0	applied	\N	\N	\N	\N	7101	7101	7102
2292	1906	0	applied	\N	\N	\N	\N	7107	7107	7108
2292	1907	1	applied	\N	\N	\N	\N	7109	7109	7110
2292	1908	2	applied	\N	\N	\N	\N	7111	7111	7112
2295	1909	0	applied	\N	\N	\N	\N	7119	7119	7120
2295	1910	1	applied	\N	\N	\N	\N	7121	7121	7122
2298	1912	0	applied	\N	\N	\N	\N	7129	7129	7130
2300	1912	0	applied	\N	\N	\N	\N	7129	7129	7130
2303	1913	0	applied	\N	\N	\N	\N	7137	7137	7138
2304	1914	0	applied	\N	\N	\N	\N	7140	7140	7141
2308	1915	0	applied	\N	\N	\N	\N	7145	7145	7146
2312	1916	0	applied	\N	\N	\N	\N	7150	7150	7151
2312	1917	1	applied	\N	\N	\N	\N	7152	7152	7153
2312	1918	2	applied	\N	\N	\N	\N	7154	7154	7155
2315	1919	0	applied	\N	\N	\N	\N	7161	7161	7162
2316	1920	0	applied	\N	\N	\N	\N	7165	7165	7166
2316	1921	1	applied	\N	\N	\N	\N	7167	7167	7168
2322	1925	0	applied	\N	\N	\N	\N	7181	7181	7182
2323	1926	0	applied	\N	\N	\N	\N	7184	7184	7185
2326	1929	0	applied	\N	\N	\N	\N	7196	7196	7197
2326	1930	1	applied	\N	\N	\N	\N	7198	7198	7199
2329	1929	0	applied	\N	\N	\N	\N	7196	7196	7197
2329	1930	1	applied	\N	\N	\N	\N	7198	7198	7199
2333	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2333	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2333	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2336	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2336	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2336	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2336	1934	3	applied	\N	\N	\N	\N	7222	7222	7223
2341	1935	0	applied	\N	\N	\N	\N	7228	7228	7229
2341	1936	1	applied	\N	\N	\N	\N	7234	7234	7235
2341	1937	2	applied	\N	\N	\N	\N	7236	7236	7237
2342	1938	0	applied	\N	\N	\N	\N	7240	7240	7241
2342	1939	1	applied	\N	\N	\N	\N	7242	7242	7243
2345	1943	0	applied	\N	\N	\N	\N	7255	7255	7256
2348	1945	0	applied	\N	\N	\N	\N	7263	7263	7264
2350	1946	0	applied	\N	\N	\N	\N	7267	7267	7268
2350	1947	1	applied	\N	\N	\N	\N	7269	7269	7270
2357	1951	0	applied	\N	\N	\N	\N	7288	7288	7289
2363	1954	0	applied	\N	\N	\N	\N	7306	7306	7307
2363	1955	1	applied	\N	\N	\N	\N	7308	7308	7309
2363	1956	2	applied	\N	\N	\N	\N	7310	7310	6086
2368	1958	0	applied	\N	\N	\N	\N	7318	7318	7319
2371	1959	0	applied	\N	\N	\N	\N	7322	7322	7323
2371	1960	1	applied	\N	\N	\N	\N	7324	7324	7325
2372	1961	0	applied	\N	\N	\N	\N	7330	7330	7331
2375	1964	0	applied	\N	\N	\N	\N	7342	7342	7343
2378	1966	0	applied	\N	\N	\N	\N	7347	7347	7348
2301	1828	94	applied	\N	\N	\N	\N	6814	6814	6815
2301	1829	95	applied	\N	\N	\N	\N	6820	6820	6821
2301	1830	96	applied	\N	\N	\N	\N	6822	6822	6823
2301	1831	97	applied	\N	\N	\N	\N	6832	6832	6833
2301	1832	98	applied	\N	\N	\N	\N	6836	6836	6837
2301	1833	99	applied	\N	\N	\N	\N	6840	6840	6841
2301	1834	100	applied	\N	\N	\N	\N	6846	6846	6847
2301	1835	101	applied	\N	\N	\N	\N	6848	6848	6849
2301	1836	102	applied	\N	\N	\N	\N	6850	6850	6851
2301	1837	103	applied	\N	\N	\N	\N	6855	6855	6856
2301	1838	104	applied	\N	\N	\N	\N	6859	6859	6860
2301	1839	105	applied	\N	\N	\N	\N	6861	6861	6862
2301	1840	106	applied	\N	\N	\N	\N	6863	6863	6864
2301	1841	107	applied	\N	\N	\N	\N	6866	6866	6867
2301	1842	108	applied	\N	\N	\N	\N	6872	6872	6873
2301	1843	109	applied	\N	\N	\N	\N	6874	6874	6875
2301	1844	110	applied	\N	\N	\N	\N	6880	6880	6881
2301	1845	111	applied	\N	\N	\N	\N	6884	6884	6885
2301	1846	112	applied	\N	\N	\N	\N	6886	6886	6887
2301	1847	113	applied	\N	\N	\N	\N	6893	6893	6894
2301	1848	114	applied	\N	\N	\N	\N	6895	6895	6896
2301	1849	115	applied	\N	\N	\N	\N	6898	6898	6899
2301	1850	116	applied	\N	\N	\N	\N	6902	6902	6903
2301	1851	117	applied	\N	\N	\N	\N	6906	6906	6907
2301	1852	118	applied	\N	\N	\N	\N	6910	6910	6911
2301	1853	119	applied	\N	\N	\N	\N	6917	6917	6918
2301	1854	120	applied	\N	\N	\N	\N	6919	6919	6920
2301	1855	121	applied	\N	\N	\N	\N	6925	6925	6926
2301	1857	122	applied	\N	\N	\N	\N	6929	6929	6930
2301	1858	123	applied	\N	\N	\N	\N	6931	6931	6932
2301	1859	124	applied	\N	\N	\N	\N	6933	6933	6934
2301	1860	125	applied	\N	\N	\N	\N	6935	6935	6936
2302	1913	0	applied	\N	\N	\N	\N	7137	7137	7138
2311	1916	0	applied	\N	\N	\N	\N	7150	7150	7151
2311	1917	1	applied	\N	\N	\N	\N	7152	7152	7153
2311	1918	2	applied	\N	\N	\N	\N	7154	7154	7155
2314	1919	0	applied	\N	\N	\N	\N	7161	7161	7162
2317	1922	0	applied	\N	\N	\N	\N	7170	7170	7171
2317	1923	1	applied	\N	\N	\N	\N	7172	7172	7173
2320	1924	0	applied	\N	\N	\N	\N	7177	7177	7178
2321	1925	0	applied	\N	\N	\N	\N	7181	7181	7182
2324	1927	0	applied	\N	\N	\N	\N	7188	7188	7189
2328	1929	0	applied	\N	\N	\N	\N	7196	7196	7197
2328	1930	1	applied	\N	\N	\N	\N	7198	7198	7199
2331	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2331	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2331	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2334	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2334	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2334	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2335	1931	0	applied	\N	\N	\N	\N	7209	7209	7210
2335	1932	1	applied	\N	\N	\N	\N	7211	7211	7212
2335	1933	2	applied	\N	\N	\N	\N	7213	7213	7214
2338	1935	0	applied	\N	\N	\N	\N	7228	7228	7229
2344	1940	0	applied	\N	\N	\N	\N	7247	7247	7248
2344	1941	1	applied	\N	\N	\N	\N	7249	7249	7250
2344	1942	2	applied	\N	\N	\N	\N	7251	7251	7252
2346	1943	0	applied	\N	\N	\N	\N	7255	7255	7256
2347	1944	0	applied	\N	\N	\N	\N	7259	7259	7260
2351	1946	0	applied	\N	\N	\N	\N	7267	7267	7268
2351	1947	1	applied	\N	\N	\N	\N	7269	7269	7270
2353	1948	0	applied	\N	\N	\N	\N	7279	7279	7280
2356	1949	0	applied	\N	\N	\N	\N	7281	7281	7282
2356	1950	1	applied	\N	\N	\N	\N	7283	7283	7284
2359	1953	0	applied	\N	\N	\N	\N	7295	7295	7296
2362	1856	0	applied	\N	\N	\N	\N	6927	6927	6928
2362	1815	1	applied	\N	\N	\N	\N	7133	7133	6768
2362	1703	2	applied	\N	\N	\N	\N	6352	6352	6353
2362	1704	3	applied	\N	\N	\N	\N	6361	6361	6362
2362	1705	4	applied	\N	\N	\N	\N	6363	6363	6364
2362	1884	5	applied	\N	\N	1000000000	\N	7027	7027	7028
2362	1706	6	applied	\N	\N	\N	\N	6365	6365	6366
2362	1707	7	applied	\N	\N	\N	\N	6369	6369	6370
2362	1708	8	applied	\N	\N	\N	\N	6373	6373	6374
2362	1709	9	applied	\N	\N	\N	\N	6380	6380	6381
2362	1710	10	applied	\N	\N	\N	\N	6382	6382	6383
2362	1711	11	applied	\N	\N	\N	\N	6388	6388	6389
2362	1712	12	applied	\N	\N	\N	\N	6390	6390	6391
2362	1713	13	applied	\N	\N	\N	\N	6394	6394	6395
2362	1714	14	applied	\N	\N	\N	\N	6396	6396	6397
2362	1715	15	applied	\N	\N	\N	\N	6400	6400	6401
2362	1716	16	applied	\N	\N	\N	\N	6402	6402	6403
2362	1717	17	applied	\N	\N	\N	\N	6406	6406	6407
2362	1718	18	applied	\N	\N	\N	\N	6410	6410	6411
2362	1719	19	applied	\N	\N	\N	\N	6412	6412	6413
2362	1720	20	applied	\N	\N	\N	\N	6421	6421	6422
2362	1721	21	applied	\N	\N	\N	\N	6425	6425	6426
2362	1722	22	applied	\N	\N	\N	\N	6427	6427	6428
2362	1723	23	applied	\N	\N	\N	\N	6431	6431	6432
2362	1724	24	applied	\N	\N	\N	\N	6433	6433	6434
2362	1725	25	applied	\N	\N	\N	\N	6436	6436	6437
2362	1726	26	applied	\N	\N	\N	\N	6440	6440	6441
2362	1727	27	applied	\N	\N	\N	\N	6442	6442	6443
2362	1728	28	applied	\N	\N	\N	\N	6448	6448	6449
2362	1729	29	applied	\N	\N	\N	\N	6452	6452	6453
2362	1730	30	applied	\N	\N	\N	\N	6457	6457	6458
2362	1731	32	applied	\N	\N	\N	\N	6459	6459	6460
2362	1732	33	applied	\N	\N	\N	\N	6461	6461	6462
2362	1733	34	applied	\N	\N	\N	\N	6463	6463	6464
2362	1734	35	applied	\N	\N	\N	\N	6465	6465	6466
2362	1735	36	applied	\N	\N	\N	\N	6467	6467	6468
2362	1736	37	applied	\N	\N	\N	\N	6471	6471	6472
2362	1737	38	applied	\N	\N	\N	\N	6475	6475	6476
2362	1738	39	applied	\N	\N	\N	\N	6477	6477	6478
2362	1739	40	applied	\N	\N	\N	\N	6481	6481	6482
2362	1740	41	applied	\N	\N	\N	\N	6483	6483	6484
2362	1741	42	applied	\N	\N	\N	\N	6488	6488	6489
2362	1742	43	applied	\N	\N	\N	\N	6490	6490	6491
2362	1743	44	applied	\N	\N	\N	\N	6496	6496	6497
2362	1744	45	applied	\N	\N	\N	\N	6502	6502	6503
2362	1745	46	applied	\N	\N	\N	\N	6506	6506	6507
2362	1746	47	applied	\N	\N	\N	\N	6510	6510	6511
2362	1747	48	applied	\N	\N	\N	\N	6512	6512	6513
2362	1748	49	applied	\N	\N	\N	\N	6514	6514	6515
2362	1749	50	applied	\N	\N	\N	\N	6518	6518	6519
2362	1750	51	applied	\N	\N	\N	\N	6526	6526	6527
2362	1751	52	applied	\N	\N	\N	\N	6530	6530	6531
2362	1752	53	applied	\N	\N	\N	\N	6532	6532	6533
2362	1753	54	applied	\N	\N	\N	\N	6536	6536	6537
2362	1754	55	applied	\N	\N	\N	\N	6544	6544	6545
2362	1755	56	applied	\N	\N	\N	\N	6550	6550	6551
2362	1756	57	applied	\N	\N	\N	\N	6555	6555	6556
2362	1757	58	applied	\N	\N	\N	\N	6559	6559	6560
2362	1758	59	applied	\N	\N	\N	\N	6563	6563	6564
2362	1759	60	applied	\N	\N	\N	\N	6567	6567	6568
2362	1760	61	applied	\N	\N	\N	\N	6569	6569	6570
2362	1761	62	applied	\N	\N	\N	\N	6571	6571	6572
2362	1762	63	applied	\N	\N	\N	\N	6576	6576	6577
2362	1763	64	applied	\N	\N	\N	\N	6578	6578	6579
2362	1764	65	applied	\N	\N	\N	\N	6580	6580	6581
2362	1765	66	applied	\N	\N	\N	\N	6583	6583	6584
2362	1766	67	applied	\N	\N	\N	\N	6585	6585	6586
2362	1767	68	applied	\N	\N	\N	\N	6591	6591	6592
2362	1768	69	applied	\N	\N	\N	\N	6593	6593	6594
2362	1769	70	applied	\N	\N	\N	\N	6599	6599	6600
2362	1770	71	applied	\N	\N	\N	\N	6601	6601	6602
2362	1771	72	applied	\N	\N	\N	\N	6605	6605	6606
2362	1772	73	applied	\N	\N	\N	\N	6609	6609	6610
2362	1773	74	applied	\N	\N	\N	\N	6613	6613	6614
2362	1774	75	applied	\N	\N	\N	\N	6622	6622	6623
2362	1775	76	applied	\N	\N	\N	\N	6625	6625	6626
2362	1776	77	applied	\N	\N	\N	\N	6629	6629	6630
2362	1777	78	applied	\N	\N	\N	\N	6633	6633	6634
2362	1778	79	applied	\N	\N	\N	\N	6637	6637	6638
2362	1779	80	applied	\N	\N	\N	\N	6639	6639	6640
2362	1780	81	applied	\N	\N	\N	\N	6642	6642	6643
2362	1781	82	applied	\N	\N	\N	\N	6644	6644	6645
2362	1782	83	applied	\N	\N	\N	\N	6650	6650	6651
2362	1783	84	applied	\N	\N	\N	\N	6654	6654	6655
2362	1784	85	applied	\N	\N	\N	\N	6658	6658	6659
2362	1785	86	applied	\N	\N	\N	\N	6660	6660	6661
2362	1786	87	applied	\N	\N	\N	\N	6662	6662	6663
2362	1787	88	applied	\N	\N	\N	\N	6666	6666	6667
2362	1788	89	applied	\N	\N	\N	\N	6670	6670	6671
2362	1789	90	applied	\N	\N	\N	\N	6674	6674	6675
2362	1790	91	applied	\N	\N	\N	\N	6676	6676	6677
2362	1791	92	applied	\N	\N	\N	\N	6680	6680	6681
2362	1792	93	applied	\N	\N	\N	\N	6682	6682	6683
2362	1793	94	applied	\N	\N	\N	\N	6686	6686	6687
2362	1794	95	applied	\N	\N	\N	\N	6695	6695	6696
2362	1795	96	applied	\N	\N	\N	\N	6701	6701	6702
2362	1796	97	applied	\N	\N	\N	\N	6706	6706	6707
2362	1797	98	applied	\N	\N	\N	\N	6708	6708	6709
2362	1798	99	applied	\N	\N	\N	\N	6710	6710	6711
2362	1799	100	applied	\N	\N	\N	\N	6712	6712	6713
2362	1800	101	applied	\N	\N	\N	\N	6714	6714	6715
2362	1801	102	applied	\N	\N	\N	\N	6718	6718	6719
2362	1802	103	applied	\N	\N	\N	\N	6720	6720	6721
2362	1803	104	applied	\N	\N	\N	\N	6723	6723	6724
2362	1804	105	applied	\N	\N	\N	\N	6727	6727	6728
2362	1805	106	applied	\N	\N	\N	\N	6731	6731	6732
2362	1806	107	applied	\N	\N	\N	\N	6733	6733	6734
2362	1807	108	applied	\N	\N	\N	\N	6736	6736	6737
2362	1808	109	applied	\N	\N	\N	\N	6738	6738	6739
2362	1809	110	applied	\N	\N	\N	\N	6740	6740	6741
2362	1810	111	applied	\N	\N	\N	\N	6744	6744	6745
2362	1811	112	applied	\N	\N	\N	\N	6746	6746	6747
2362	1812	113	applied	\N	\N	\N	\N	6753	6753	6754
2362	1813	114	applied	\N	\N	\N	\N	6757	6757	6758
2362	1814	115	applied	\N	\N	\N	\N	6761	6761	6762
2362	1816	116	applied	\N	\N	\N	\N	6769	6769	6770
2362	1817	117	applied	\N	\N	\N	\N	6775	6775	6776
2362	1818	118	applied	\N	\N	\N	\N	6779	6779	6780
2362	1819	119	applied	\N	\N	\N	\N	6781	6781	6782
2362	1820	120	applied	\N	\N	\N	\N	6783	6783	6784
2362	1821	121	applied	\N	\N	\N	\N	6789	6789	6790
2362	1822	122	applied	\N	\N	\N	\N	6797	6797	6798
2362	1823	123	applied	\N	\N	\N	\N	6801	6801	6802
2362	1824	124	applied	\N	\N	\N	\N	6803	6803	6804
2362	1825	125	applied	\N	\N	\N	\N	6805	6805	6806
2364	1954	0	applied	\N	\N	\N	\N	7306	7306	7307
2364	1955	1	applied	\N	\N	\N	\N	7308	7308	7309
2364	1956	2	applied	\N	\N	\N	\N	7310	7310	6086
2365	1957	0	applied	\N	\N	\N	\N	7315	7315	7316
2374	1963	0	applied	\N	\N	\N	\N	7338	7338	7339
2376	1964	0	applied	\N	\N	\N	\N	7342	7342	7343
2377	1965	0	applied	\N	\N	\N	\N	7345	7345	7346
2380	1968	0	applied	\N	\N	\N	\N	7355	7355	7356
2381	1968	0	applied	\N	\N	\N	\N	7355	7355	7356
2382	1968	0	applied	\N	\N	\N	\N	7355	7355	7356
2383	1968	0	applied	\N	\N	\N	\N	7355	7355	7356
2384	1968	0	applied	\N	\N	\N	\N	7355	7355	7356
2385	1969	0	applied	\N	\N	\N	\N	7359	7359	7360
2386	1969	0	applied	\N	\N	\N	\N	7359	7359	7360
2387	1969	0	applied	\N	\N	\N	\N	7359	7359	7360
2388	1969	0	applied	\N	\N	\N	\N	7359	7359	7360
2389	1970	0	applied	\N	\N	\N	\N	7366	7366	7367
2390	1971	0	applied	\N	\N	\N	\N	7368	7368	1435
2390	1972	1	applied	\N	\N	\N	\N	7369	7369	7370
2392	1973	0	applied	\N	\N	\N	\N	7372	7372	7373
2393	1973	0	applied	\N	\N	\N	\N	7372	7372	7373
2394	1973	0	applied	\N	\N	\N	\N	7372	7372	7373
2394	1974	1	applied	\N	\N	\N	\N	7376	7376	7377
2395	1975	0	applied	\N	\N	\N	\N	7379	7379	7380
2395	1976	1	applied	\N	\N	\N	\N	7381	7381	7382
2395	1977	2	applied	\N	\N	\N	\N	7383	7383	7384
2395	1978	3	applied	\N	\N	\N	\N	7385	7385	7386
2396	1979	0	applied	\N	\N	\N	\N	7389	7389	7390
2397	1980	0	applied	\N	\N	\N	\N	7391	7391	7392
2397	1981	1	applied	\N	\N	\N	\N	7393	7393	7394
2398	1982	0	applied	\N	\N	\N	\N	7397	7397	7398
2399	1982	0	applied	\N	\N	\N	\N	7397	7397	7398
2400	1982	0	applied	\N	\N	\N	\N	7397	7397	7398
2401	1983	0	applied	\N	\N	\N	\N	7403	7403	7404
2402	1983	0	applied	\N	\N	\N	\N	7403	7403	7404
2403	1983	0	applied	\N	\N	\N	\N	7403	7403	7404
2404	1984	0	applied	\N	\N	\N	\N	7409	7409	7410
2405	1985	0	applied	\N	\N	\N	\N	7413	7413	7414
2406	1985	0	applied	\N	\N	\N	\N	7413	7413	7414
2407	1986	0	applied	\N	\N	\N	\N	7417	7417	7418
2407	1987	1	applied	\N	\N	\N	\N	7419	7419	7420
2408	1988	0	applied	\N	\N	\N	\N	7423	7423	7424
2409	1988	0	applied	\N	\N	\N	\N	7423	7423	7424
2410	1989	0	applied	\N	\N	\N	\N	7427	7427	7428
2411	1989	0	applied	\N	\N	\N	\N	7427	7427	7428
2412	1990	0	applied	\N	\N	\N	\N	7431	7431	7432
2412	1991	1	applied	\N	\N	\N	\N	7433	7433	7434
2413	1992	0	applied	\N	\N	\N	\N	7436	7436	7437
2414	1992	0	applied	\N	\N	\N	\N	7436	7436	7437
2415	1993	0	applied	\N	\N	\N	\N	7442	7442	7443
2416	1994	0	applied	\N	\N	\N	\N	7446	7446	7447
2416	1995	1	applied	\N	\N	\N	\N	7448	7448	7449
2419	1996	0	applied	\N	\N	\N	\N	6759	6759	7454
2419	1997	1	applied	\N	\N	\N	\N	7455	7455	7456
2419	1998	2	applied	\N	\N	\N	\N	7457	7457	7458
2425	2003	0	applied	\N	\N	\N	\N	7477	7477	7478
2430	2005	0	applied	\N	\N	\N	\N	7484	7484	7485
2431	2006	0	applied	\N	\N	\N	\N	7488	7488	7489
2434	2007	0	applied	\N	\N	\N	\N	7494	7494	7495
2434	2008	1	applied	\N	\N	\N	\N	7496	7496	7497
2438	2009	0	applied	\N	\N	\N	\N	7500	7500	7501
2438	2010	1	applied	\N	\N	\N	\N	7502	7502	7503
2438	2011	2	applied	\N	\N	\N	\N	7504	7504	7505
2440	2012	0	applied	\N	\N	\N	\N	7511	7511	7512
2443	2013	0	applied	\N	\N	\N	\N	7513	7513	7514
2447	2016	0	applied	\N	\N	\N	\N	7527	7527	7528
2454	2021	0	applied	\N	\N	\N	\N	7545	7545	7546
2456	2022	0	applied	\N	\N	\N	\N	7550	7550	7551
2456	2023	1	applied	\N	\N	\N	\N	7552	7552	7553
2456	2024	2	applied	\N	\N	\N	\N	7554	7554	7555
2456	2025	3	applied	\N	\N	\N	\N	7556	7556	7557
2459	2027	0	applied	\N	\N	\N	\N	7563	7563	7564
2465	2031	0	applied	\N	\N	\N	\N	7581	7581	7582
2468	2035	0	applied	\N	\N	\N	\N	7595	7595	7596
2471	2036	0	applied	\N	\N	\N	\N	7599	7599	7600
2475	2038	0	applied	\N	\N	\N	\N	7608	7608	7609
2475	2039	1	applied	\N	\N	\N	\N	7610	7610	7611
2475	2040	2	applied	\N	\N	\N	\N	7612	7612	7613
2475	2041	3	applied	\N	\N	\N	\N	7614	7614	7615
2475	2042	4	applied	\N	\N	\N	\N	7616	7616	7617
2477	2044	0	applied	\N	\N	\N	\N	7624	7624	7625
2480	2045	0	applied	\N	\N	\N	\N	7628	7628	7629
2480	2046	1	applied	\N	\N	\N	\N	7630	7630	7631
2482	2047	0	applied	\N	\N	\N	\N	7633	7633	7634
2482	2048	1	applied	\N	\N	\N	\N	7635	7635	7636
2485	1971	0	applied	\N	\N	\N	\N	7368	7368	1435
2485	1996	1	applied	\N	\N	\N	\N	6759	6759	7454
2485	1948	2	applied	\N	\N	\N	\N	7279	7279	7280
2485	1949	3	applied	\N	\N	\N	\N	7281	7281	7282
2485	1950	4	applied	\N	\N	\N	\N	7283	7283	7284
2485	1956	5	applied	\N	\N	\N	\N	7310	7310	6086
2485	1951	6	applied	\N	\N	\N	\N	7288	7288	7289
2485	1952	7	applied	\N	\N	\N	\N	7291	7291	7292
2485	1953	8	applied	\N	\N	\N	\N	7295	7295	7296
2485	1954	9	applied	\N	\N	\N	\N	7306	7306	7307
2485	1955	10	applied	\N	\N	\N	\N	7308	7308	7309
2485	1957	11	applied	\N	\N	\N	\N	7315	7315	7316
2485	1958	12	applied	\N	\N	\N	\N	7318	7318	7319
2485	1959	13	applied	\N	\N	\N	\N	7322	7322	7323
2485	1960	14	applied	\N	\N	\N	\N	7324	7324	7325
2485	1961	15	applied	\N	\N	\N	\N	7330	7330	7331
2485	1962	16	applied	\N	\N	\N	\N	7334	7334	7335
2485	1963	17	applied	\N	\N	\N	\N	7338	7338	7339
2485	1964	18	applied	\N	\N	\N	\N	7342	7342	7343
2485	1965	19	applied	\N	\N	\N	\N	7345	7345	7346
2485	1966	20	applied	\N	\N	\N	\N	7347	7347	7348
2485	1967	21	applied	\N	\N	\N	\N	7351	7351	7352
2485	1968	22	applied	\N	\N	\N	\N	7355	7355	7356
2485	1969	23	applied	\N	\N	\N	\N	7359	7359	7360
2485	1970	24	applied	\N	\N	\N	\N	7366	7366	7367
2485	1972	25	applied	\N	\N	\N	\N	7369	7369	7370
2485	1973	26	applied	\N	\N	\N	\N	7372	7372	7373
2485	1974	27	applied	\N	\N	\N	\N	7376	7376	7377
2485	1975	28	applied	\N	\N	\N	\N	7379	7379	7380
2485	1976	29	applied	\N	\N	\N	\N	7381	7381	7382
2485	1977	30	applied	\N	\N	\N	\N	7383	7383	7384
2485	1978	31	applied	\N	\N	\N	\N	7385	7385	7386
2485	1979	32	applied	\N	\N	\N	\N	7389	7389	7390
2485	1980	33	applied	\N	\N	\N	\N	7391	7391	7392
2485	1981	34	applied	\N	\N	\N	\N	7393	7393	7394
2485	1982	35	applied	\N	\N	\N	\N	7397	7397	7398
2485	1983	36	applied	\N	\N	\N	\N	7403	7403	7404
2485	1984	37	applied	\N	\N	\N	\N	7409	7409	7410
2485	1985	38	applied	\N	\N	\N	\N	7413	7413	7414
2485	1986	39	applied	\N	\N	\N	\N	7417	7417	7418
2485	1987	40	applied	\N	\N	\N	\N	7419	7419	7420
2485	1988	41	applied	\N	\N	\N	\N	7423	7423	7424
2485	1989	42	applied	\N	\N	\N	\N	7427	7427	7428
2485	1990	43	applied	\N	\N	\N	\N	7431	7431	7432
2485	1991	44	applied	\N	\N	\N	\N	7433	7433	7434
2485	1992	45	applied	\N	\N	\N	\N	7436	7436	7437
2485	1993	46	applied	\N	\N	\N	\N	7442	7442	7443
2485	1994	47	applied	\N	\N	\N	\N	7446	7446	7447
2485	1995	48	applied	\N	\N	\N	\N	7448	7448	7449
2485	1997	49	applied	\N	\N	\N	\N	7455	7455	7456
2485	1998	50	applied	\N	\N	\N	\N	7457	7457	7458
2485	1999	51	applied	\N	\N	\N	\N	7462	7462	7463
2485	2000	52	applied	\N	\N	\N	\N	7467	7467	7468
2485	2001	53	applied	\N	\N	\N	\N	7469	7469	7470
2485	2002	54	applied	\N	\N	\N	\N	7473	7473	7474
2485	2003	55	applied	\N	\N	\N	\N	7477	7477	7478
2485	2004	56	applied	\N	\N	\N	\N	7480	7480	7481
2485	2005	57	applied	\N	\N	\N	\N	7484	7484	7485
2485	2006	58	applied	\N	\N	\N	\N	7488	7488	7489
2485	2007	59	applied	\N	\N	\N	\N	7494	7494	7495
2485	2008	60	applied	\N	\N	\N	\N	7496	7496	7497
2485	2009	61	applied	\N	\N	\N	\N	7500	7500	7501
2485	2010	62	applied	\N	\N	\N	\N	7502	7502	7503
2485	2011	63	applied	\N	\N	\N	\N	7504	7504	7505
2485	2012	64	applied	\N	\N	\N	\N	7511	7511	7512
2485	2013	65	applied	\N	\N	\N	\N	7513	7513	7514
2485	2014	66	applied	\N	\N	\N	\N	7519	7519	7520
2485	2015	67	applied	\N	\N	\N	\N	7523	7523	7524
2485	2016	68	applied	\N	\N	\N	\N	7527	7527	7528
2485	2017	69	applied	\N	\N	\N	\N	7531	7531	7532
2485	2018	70	applied	\N	\N	\N	\N	7535	7535	7536
2485	2019	71	applied	\N	\N	\N	\N	7540	7540	7541
2485	2020	72	applied	\N	\N	\N	\N	7542	7542	7543
2485	2021	73	applied	\N	\N	\N	\N	7545	7545	7546
2485	2022	74	applied	\N	\N	\N	\N	7550	7550	7551
2485	2023	75	applied	\N	\N	\N	\N	7552	7552	7553
2485	2024	76	applied	\N	\N	\N	\N	7554	7554	7555
2485	2025	77	applied	\N	\N	\N	\N	7556	7556	7557
2485	2026	78	applied	\N	\N	\N	\N	7559	7559	7560
2485	2027	79	applied	\N	\N	\N	\N	7563	7563	7564
2485	2028	80	applied	\N	\N	\N	\N	7569	7569	7570
2485	2029	81	applied	\N	\N	\N	\N	7575	7575	7576
2485	2030	82	applied	\N	\N	\N	\N	7577	7577	7578
2485	2031	83	applied	\N	\N	\N	\N	7581	7581	7582
2485	2032	84	applied	\N	\N	\N	\N	7587	7587	7588
2417	1994	0	applied	\N	\N	\N	\N	7446	7446	7447
2417	1995	1	applied	\N	\N	\N	\N	7448	7448	7449
2420	1996	0	applied	\N	\N	\N	\N	6759	6759	7454
2420	1997	1	applied	\N	\N	\N	\N	7455	7455	7456
2420	1998	2	applied	\N	\N	\N	\N	7457	7457	7458
2421	1999	0	applied	\N	\N	\N	\N	7462	7462	7463
2424	2002	0	applied	\N	\N	\N	\N	7473	7473	7474
2426	2003	0	applied	\N	\N	\N	\N	7477	7477	7478
2427	2004	0	applied	\N	\N	\N	\N	7480	7480	7481
2432	2006	0	applied	\N	\N	\N	\N	7488	7488	7489
2436	2009	0	applied	\N	\N	\N	\N	7500	7500	7501
2436	2010	1	applied	\N	\N	\N	\N	7502	7502	7503
2436	2011	2	applied	\N	\N	\N	\N	7504	7504	7505
2439	2012	0	applied	\N	\N	\N	\N	7511	7511	7512
2441	2013	0	applied	\N	\N	\N	\N	7513	7513	7514
2444	2014	0	applied	\N	\N	\N	\N	7519	7519	7520
2445	2015	0	applied	\N	\N	\N	\N	7523	7523	7524
2446	2015	0	applied	\N	\N	\N	\N	7523	7523	7524
2450	2018	0	applied	\N	\N	\N	\N	7535	7535	7536
2455	2021	0	applied	\N	\N	\N	\N	7545	7545	7546
2457	2026	0	applied	\N	\N	\N	\N	7559	7559	7560
2458	2027	0	applied	\N	\N	\N	\N	7563	7563	7564
2460	2028	0	applied	\N	\N	\N	\N	7569	7569	7570
2462	2029	0	applied	\N	\N	\N	\N	7575	7575	7576
2462	2030	1	applied	\N	\N	\N	\N	7577	7577	7578
2463	2029	0	applied	\N	\N	\N	\N	7575	7575	7576
2463	2030	1	applied	\N	\N	\N	\N	7577	7577	7578
2464	2031	0	applied	\N	\N	\N	\N	7581	7581	7582
2467	2033	0	applied	\N	\N	\N	\N	7589	7589	7590
2467	2034	1	applied	\N	\N	\N	\N	7591	7591	7592
2470	2036	0	applied	\N	\N	\N	\N	7599	7599	7600
2473	2037	0	applied	\N	\N	\N	\N	7604	7604	7605
2478	2044	0	applied	\N	\N	\N	\N	7624	7624	7625
2483	2047	0	applied	\N	\N	\N	\N	7633	7633	7634
2483	2048	1	applied	\N	\N	\N	\N	7635	7635	7636
2486	2047	0	applied	\N	\N	\N	\N	7633	7633	7634
2486	2048	1	applied	\N	\N	\N	\N	7635	7635	7636
2486	2049	2	applied	\N	\N	\N	\N	7641	7641	7642
2488	2050	0	applied	\N	\N	\N	\N	7647	7647	7648
2494	2053	0	applied	\N	\N	\N	\N	7665	7665	7666
2494	2054	1	applied	\N	\N	1000000000	\N	7667	7667	7668
2498	2059	0	applied	\N	\N	\N	\N	7680	7680	7681
2499	2060	0	applied	\N	\N	\N	\N	7685	7685	7686
2500	2061	0	applied	\N	\N	\N	\N	7688	7688	7689
2500	2062	1	applied	\N	\N	\N	\N	7690	7690	7691
2500	2063	2	applied	\N	\N	\N	\N	7692	7692	7693
2500	2064	3	applied	\N	\N	\N	\N	7694	7694	7695
2503	2065	0	applied	\N	\N	\N	\N	5821	5821	7698
2503	2066	1	applied	\N	\N	\N	\N	7699	7699	7700
2503	2067	2	applied	\N	\N	\N	\N	7701	7701	7702
2503	2068	3	applied	\N	\N	\N	\N	7703	7703	7704
2504	2069	0	applied	\N	\N	\N	\N	7709	7709	7710
2506	2071	0	applied	\N	\N	\N	\N	7715	7715	7716
2509	2074	0	applied	\N	\N	\N	\N	7722	7722	7723
2509	2075	1	applied	\N	\N	\N	\N	7724	7724	7725
2509	2076	2	applied	\N	\N	\N	\N	7726	7726	7727
2511	2078	0	applied	\N	\N	\N	\N	7735	7735	7736
2511	2079	1	applied	\N	\N	\N	\N	7737	7737	7738
2513	2080	0	applied	\N	\N	\N	\N	7741	7741	7742
2516	2082	0	applied	\N	\N	\N	\N	7749	7749	7750
2517	2083	0	applied	\N	\N	\N	\N	7751	7751	7752
2517	2084	1	applied	\N	\N	\N	\N	7753	7753	7754
2517	2085	2	applied	\N	\N	\N	\N	7755	7755	7756
2520	2086	0	applied	\N	\N	\N	\N	7763	7763	7764
2520	2087	1	applied	\N	\N	\N	\N	7765	7765	7766
2520	2088	2	applied	\N	\N	\N	\N	7767	7767	7768
2520	2089	3	applied	\N	\N	1000000000	\N	7769	7769	7770
2521	2086	0	applied	\N	\N	\N	\N	7763	7763	7764
2521	2087	1	applied	\N	\N	\N	\N	7765	7765	7766
2521	2088	2	applied	\N	\N	\N	\N	7767	7767	7768
2521	2089	3	applied	\N	\N	1000000000	\N	7769	7769	7770
2523	2091	0	applied	\N	\N	\N	\N	7778	7778	7779
2531	2100	0	applied	\N	\N	\N	\N	7807	7807	7808
2534	2101	0	applied	\N	\N	\N	\N	7811	7811	7812
2534	2102	1	applied	\N	\N	\N	\N	7814	7814	7815
2537	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2537	2105	1	applied	\N	\N	\N	\N	7826	7826	7827
2540	2106	0	applied	\N	\N	\N	\N	7831	7831	7832
2543	2108	0	applied	\N	\N	\N	\N	7839	7839	7840
2549	2111	0	applied	\N	\N	\N	\N	7851	7851	7852
2549	2112	1	applied	\N	\N	\N	\N	7853	7853	7854
2549	2113	2	applied	\N	\N	\N	\N	7855	7855	7856
2549	2114	3	applied	\N	\N	\N	\N	7857	7857	7858
2552	2118	0	applied	\N	\N	\N	\N	7870	7870	7871
2556	2121	0	applied	\N	\N	\N	\N	7884	7884	7885
2559	2125	0	applied	\N	\N	\N	\N	7896	7896	7897
2562	2126	0	applied	\N	\N	\N	\N	7900	7900	7901
2562	2127	1	applied	\N	\N	\N	\N	7902	7902	7903
2564	2126	0	applied	\N	\N	\N	\N	7900	7900	7901
2564	2127	1	applied	\N	\N	\N	\N	7902	7902	7903
2418	1994	0	applied	\N	\N	\N	\N	7446	7446	7447
2418	1995	1	applied	\N	\N	\N	\N	7448	7448	7449
2422	1999	0	applied	\N	\N	\N	\N	7462	7462	7463
2423	2000	0	applied	\N	\N	\N	\N	7467	7467	7468
2423	2001	1	applied	\N	\N	\N	\N	7469	7469	7470
2428	2004	0	applied	\N	\N	\N	\N	7480	7480	7481
2429	2005	0	applied	\N	\N	\N	\N	7484	7484	7485
2433	2006	0	applied	\N	\N	\N	\N	7488	7488	7489
2435	2007	0	applied	\N	\N	\N	\N	7494	7494	7495
2435	2008	1	applied	\N	\N	\N	\N	7496	7496	7497
2437	2009	0	applied	\N	\N	\N	\N	7500	7500	7501
2437	2010	1	applied	\N	\N	\N	\N	7502	7502	7503
2437	2011	2	applied	\N	\N	\N	\N	7504	7504	7505
2442	2013	0	applied	\N	\N	\N	\N	7513	7513	7514
2448	2017	0	applied	\N	\N	\N	\N	7531	7531	7532
2449	2017	0	applied	\N	\N	\N	\N	7531	7531	7532
2451	2018	0	applied	\N	\N	\N	\N	7535	7535	7536
2452	2019	0	applied	\N	\N	\N	\N	7540	7540	7541
2452	2020	1	applied	\N	\N	\N	\N	7542	7542	7543
2453	2021	0	applied	\N	\N	\N	\N	7545	7545	7546
2461	2028	0	applied	\N	\N	\N	\N	7569	7569	7570
2466	2032	0	applied	\N	\N	\N	\N	7587	7587	7588
2469	2036	0	applied	\N	\N	\N	\N	7599	7599	7600
2472	2037	0	applied	\N	\N	\N	\N	7604	7604	7605
2474	2037	0	applied	\N	\N	\N	\N	7604	7604	7605
2476	2043	0	applied	\N	\N	\N	\N	7620	7620	7621
2479	2044	0	applied	\N	\N	\N	\N	7624	7624	7625
2491	2052	0	applied	\N	\N	\N	\N	7657	7657	7658
2492	2052	0	applied	\N	\N	\N	\N	7657	7657	7658
2495	2053	0	applied	\N	\N	\N	\N	7665	7665	7666
2495	2054	1	applied	\N	\N	1000000000	\N	7667	7667	7668
2497	2059	0	applied	\N	\N	\N	\N	7680	7680	7681
2505	2070	0	applied	\N	\N	\N	\N	7713	7713	7714
2524	2092	0	applied	\N	\N	\N	\N	7782	7782	7783
2524	2093	1	applied	\N	\N	\N	\N	7784	7784	7785
2524	2094	2	applied	\N	\N	\N	\N	7786	7786	7787
2526	2097	0	applied	\N	\N	\N	\N	7796	7796	7797
2527	2097	0	applied	\N	\N	\N	\N	7796	7796	7797
2529	2098	0	applied	\N	\N	\N	\N	7803	7803	7804
2532	2065	0	applied	\N	\N	\N	\N	5821	5821	7698
2532	2054	1	applied	\N	\N	1000000000	\N	7667	7667	7668
2532	2089	2	applied	\N	\N	1000000000	\N	7769	7769	7770
2532	2051	3	applied	\N	\N	\N	\N	7653	7653	7654
2532	2052	4	applied	\N	\N	\N	\N	7657	7657	7658
2532	2053	5	applied	\N	\N	\N	\N	7665	7665	7666
2532	2055	6	applied	\N	\N	\N	\N	7670	7670	7671
2532	2056	7	applied	\N	\N	\N	\N	7672	7672	7673
2532	2057	8	applied	\N	\N	\N	\N	7674	7674	7675
2532	2058	9	applied	\N	\N	\N	\N	7676	7676	7677
2532	2059	10	applied	\N	\N	\N	\N	7680	7680	7681
2532	2060	11	applied	\N	\N	\N	\N	7685	7685	7686
2532	2061	12	applied	\N	\N	\N	\N	7688	7688	7689
2532	2062	13	applied	\N	\N	\N	\N	7690	7690	7691
2532	2063	14	applied	\N	\N	\N	\N	7692	7692	7693
2532	2064	15	applied	\N	\N	\N	\N	7694	7694	7695
2532	2066	16	applied	\N	\N	\N	\N	7699	7699	7700
2532	2067	17	applied	\N	\N	\N	\N	7701	7701	7702
2532	2068	18	applied	\N	\N	\N	\N	7703	7703	7704
2532	2069	19	applied	\N	\N	\N	\N	7709	7709	7710
2532	2070	20	applied	\N	\N	\N	\N	7713	7713	7714
2532	2071	21	applied	\N	\N	\N	\N	7715	7715	7716
2532	2072	22	applied	\N	\N	\N	\N	7717	7717	7718
2532	2073	23	applied	\N	\N	\N	\N	7719	7719	7720
2532	2074	24	applied	\N	\N	\N	\N	7722	7722	7723
2532	2075	25	applied	\N	\N	\N	\N	7724	7724	7725
2532	2076	26	applied	\N	\N	\N	\N	7726	7726	7727
2532	2077	27	applied	\N	\N	\N	\N	7731	7731	7732
2532	2078	28	applied	\N	\N	\N	\N	7735	7735	7736
2532	2079	29	applied	\N	\N	\N	\N	7737	7737	7738
2532	2080	30	applied	\N	\N	\N	\N	7741	7741	7742
2532	2081	31	applied	\N	\N	\N	\N	7745	7745	7746
2532	2082	32	applied	\N	\N	\N	\N	7749	7749	7750
2532	2083	33	applied	\N	\N	\N	\N	7751	7751	7752
2532	2084	34	applied	\N	\N	\N	\N	7753	7753	7754
2532	2085	35	applied	\N	\N	\N	\N	7755	7755	7756
2532	2086	36	applied	\N	\N	\N	\N	7763	7763	7764
2532	2087	37	applied	\N	\N	\N	\N	7765	7765	7766
2532	2088	38	applied	\N	\N	\N	\N	7767	7767	7768
2532	2090	39	applied	\N	\N	\N	\N	7774	7774	7775
2532	2091	40	applied	\N	\N	\N	\N	7778	7778	7779
2532	2092	41	applied	\N	\N	\N	\N	7782	7782	7783
2532	2093	42	applied	\N	\N	\N	\N	7784	7784	7785
2532	2094	43	applied	\N	\N	\N	\N	7786	7786	7787
2532	2095	44	applied	\N	\N	\N	\N	7790	7790	7791
2532	2096	45	applied	\N	\N	\N	\N	7792	7792	7793
2532	2097	46	applied	\N	\N	\N	\N	7796	7796	7797
2532	2098	47	applied	\N	\N	\N	\N	7803	7803	7804
2532	2099	48	applied	\N	\N	\N	\N	7805	7805	7806
2532	2100	49	applied	\N	\N	\N	\N	7807	7807	7808
2532	2101	50	applied	\N	\N	\N	\N	7811	7811	7812
2535	2101	0	applied	\N	\N	\N	\N	7811	7811	7812
2535	2102	1	applied	\N	\N	\N	\N	7814	7814	7815
2536	2103	0	applied	\N	\N	\N	\N	7822	7822	7823
2539	2106	0	applied	\N	\N	\N	\N	7831	7831	7832
2541	2106	0	applied	\N	\N	\N	\N	7831	7831	7832
2542	2107	0	applied	\N	\N	\N	\N	7837	7837	7838
2545	2110	0	applied	\N	\N	\N	\N	7845	7845	7846
2548	2111	0	applied	\N	\N	\N	\N	7851	7851	7852
2548	2112	1	applied	\N	\N	\N	\N	7853	7853	7854
2548	2113	2	applied	\N	\N	\N	\N	7855	7855	7856
2548	2114	3	applied	\N	\N	\N	\N	7857	7857	7858
2551	2116	0	applied	\N	\N	\N	\N	7865	7865	7866
2551	2117	1	applied	\N	\N	\N	\N	7867	7867	7868
2555	2119	0	applied	\N	\N	\N	\N	7876	7876	7877
2555	2120	1	applied	\N	\N	\N	\N	7878	7878	7879
2558	2124	0	applied	\N	\N	\N	\N	7894	7894	7895
2561	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2561	2082	1	applied	\N	\N	\N	\N	7749	7749	7750
2561	2089	2	applied	\N	\N	1000000000	\N	7769	7769	7770
2561	2083	3	applied	\N	\N	\N	\N	7751	7751	7752
2561	2084	4	applied	\N	\N	\N	\N	7753	7753	7754
2561	2085	5	applied	\N	\N	\N	\N	7755	7755	7756
2561	2086	6	applied	\N	\N	\N	\N	7763	7763	7764
2561	2087	7	applied	\N	\N	\N	\N	7765	7765	7766
2561	2088	8	applied	\N	\N	\N	\N	7767	7767	7768
2561	2090	9	applied	\N	\N	\N	\N	7774	7774	7775
2561	2091	10	applied	\N	\N	\N	\N	7778	7778	7779
2561	2092	11	applied	\N	\N	\N	\N	7782	7782	7783
2561	2093	12	applied	\N	\N	\N	\N	7784	7784	7785
2485	2033	85	applied	\N	\N	\N	\N	7589	7589	7590
2485	2034	86	applied	\N	\N	\N	\N	7591	7591	7592
2485	2035	87	applied	\N	\N	\N	\N	7595	7595	7596
2485	2036	88	applied	\N	\N	\N	\N	7599	7599	7600
2485	2037	89	applied	\N	\N	\N	\N	7604	7604	7605
2485	2038	90	applied	\N	\N	\N	\N	7608	7608	7609
2485	2039	91	applied	\N	\N	\N	\N	7610	7610	7611
2485	2040	92	applied	\N	\N	\N	\N	7612	7612	7613
2485	2041	93	applied	\N	\N	\N	\N	7614	7614	7615
2485	2042	94	applied	\N	\N	\N	\N	7616	7616	7617
2485	2043	95	applied	\N	\N	\N	\N	7620	7620	7621
2485	2044	96	applied	\N	\N	\N	\N	7624	7624	7625
2485	2045	97	applied	\N	\N	\N	\N	7628	7628	7629
2485	2046	99	applied	\N	\N	\N	\N	7630	7630	7631
2485	2047	100	applied	\N	\N	\N	\N	7633	7633	7634
2485	2048	101	applied	\N	\N	\N	\N	7635	7635	7636
2485	2049	102	applied	\N	\N	\N	\N	7641	7641	7642
2487	2050	0	applied	\N	\N	\N	\N	7647	7647	7648
2489	2051	0	applied	\N	\N	\N	\N	7653	7653	7654
2490	2051	0	applied	\N	\N	\N	\N	7653	7653	7654
2493	2052	0	applied	\N	\N	\N	\N	7657	7657	7658
2496	2055	0	applied	\N	\N	\N	\N	7670	7670	7671
2496	2056	1	applied	\N	\N	\N	\N	7672	7672	7673
2496	2057	2	applied	\N	\N	\N	\N	7674	7674	7675
2496	2058	3	applied	\N	\N	\N	\N	7676	7676	7677
2501	1996	0	applied	\N	\N	\N	\N	6759	6759	7454
2501	2054	1	applied	\N	\N	1000000000	\N	7667	7667	7668
2501	1997	2	applied	\N	\N	\N	\N	7455	7455	7456
2501	1998	3	applied	\N	\N	\N	\N	7457	7457	7458
2501	1999	4	applied	\N	\N	\N	\N	7462	7462	7463
2501	2000	5	applied	\N	\N	\N	\N	7467	7467	7468
2501	2001	6	applied	\N	\N	\N	\N	7469	7469	7470
2501	2002	7	applied	\N	\N	\N	\N	7473	7473	7474
2501	2003	8	applied	\N	\N	\N	\N	7477	7477	7478
2501	2004	9	applied	\N	\N	\N	\N	7480	7480	7481
2501	2005	10	applied	\N	\N	\N	\N	7484	7484	7485
2501	2006	11	applied	\N	\N	\N	\N	7488	7488	7489
2501	2007	12	applied	\N	\N	\N	\N	7494	7494	7495
2501	2008	13	applied	\N	\N	\N	\N	7496	7496	7497
2501	2009	14	applied	\N	\N	\N	\N	7500	7500	7501
2501	2010	15	applied	\N	\N	\N	\N	7502	7502	7503
2501	2011	16	applied	\N	\N	\N	\N	7504	7504	7505
2501	2012	17	applied	\N	\N	\N	\N	7511	7511	7512
2501	2013	18	applied	\N	\N	\N	\N	7513	7513	7514
2501	2014	19	applied	\N	\N	\N	\N	7519	7519	7520
2501	2015	20	applied	\N	\N	\N	\N	7523	7523	7524
2501	2016	21	applied	\N	\N	\N	\N	7527	7527	7528
2501	2017	22	applied	\N	\N	\N	\N	7531	7531	7532
2501	2018	23	applied	\N	\N	\N	\N	7535	7535	7536
2501	2019	24	applied	\N	\N	\N	\N	7540	7540	7541
2501	2020	25	applied	\N	\N	\N	\N	7542	7542	7543
2501	2021	26	applied	\N	\N	\N	\N	7545	7545	7546
2501	2022	27	applied	\N	\N	\N	\N	7550	7550	7551
2501	2023	28	applied	\N	\N	\N	\N	7552	7552	7553
2501	2024	29	applied	\N	\N	\N	\N	7554	7554	7555
2501	2025	30	applied	\N	\N	\N	\N	7556	7556	7557
2501	2026	31	applied	\N	\N	\N	\N	7559	7559	7560
2501	2027	32	applied	\N	\N	\N	\N	7563	7563	7564
2501	2028	33	applied	\N	\N	\N	\N	7569	7569	7570
2501	2029	34	applied	\N	\N	\N	\N	7575	7575	7576
2501	2030	35	applied	\N	\N	\N	\N	7577	7577	7578
2501	2031	36	applied	\N	\N	\N	\N	7581	7581	7582
2501	2032	37	applied	\N	\N	\N	\N	7587	7587	7588
2501	2033	38	applied	\N	\N	\N	\N	7589	7589	7590
2501	2034	39	applied	\N	\N	\N	\N	7591	7591	7592
2501	2035	40	applied	\N	\N	\N	\N	7595	7595	7596
2501	2036	41	applied	\N	\N	\N	\N	7599	7599	7600
2501	2037	42	applied	\N	\N	\N	\N	7604	7604	7605
2501	2038	43	applied	\N	\N	\N	\N	7608	7608	7609
2501	2039	44	applied	\N	\N	\N	\N	7610	7610	7611
2501	2040	45	applied	\N	\N	\N	\N	7612	7612	7613
2501	2041	46	applied	\N	\N	\N	\N	7614	7614	7615
2501	2042	47	applied	\N	\N	\N	\N	7616	7616	7617
2501	2043	48	applied	\N	\N	\N	\N	7620	7620	7621
2501	2044	49	applied	\N	\N	\N	\N	7624	7624	7625
2501	2045	50	applied	\N	\N	\N	\N	7628	7628	7629
2501	2046	51	applied	\N	\N	\N	\N	7630	7630	7631
2501	2047	52	applied	\N	\N	\N	\N	7633	7633	7634
2501	2048	53	applied	\N	\N	\N	\N	7635	7635	7636
2501	2049	54	applied	\N	\N	\N	\N	7641	7641	7642
2501	2050	55	applied	\N	\N	\N	\N	7647	7647	7648
2501	2051	56	applied	\N	\N	\N	\N	7653	7653	7654
2501	2052	57	applied	\N	\N	\N	\N	7657	7657	7658
2501	2053	58	applied	\N	\N	\N	\N	7665	7665	7666
2501	2055	59	applied	\N	\N	\N	\N	7670	7670	7671
2501	2056	60	applied	\N	\N	\N	\N	7672	7672	7673
2501	2057	61	applied	\N	\N	\N	\N	7674	7674	7675
2501	2058	62	applied	\N	\N	\N	\N	7676	7676	7677
2501	2059	63	applied	\N	\N	\N	\N	7680	7680	7681
2501	2060	64	applied	\N	\N	\N	\N	7685	7685	7686
2501	2061	65	applied	\N	\N	\N	\N	7688	7688	7689
2501	2062	66	applied	\N	\N	\N	\N	7690	7690	7691
2501	2063	67	applied	\N	\N	\N	\N	7692	7692	7693
2501	2064	68	applied	\N	\N	\N	\N	7694	7694	7695
2502	2065	0	applied	\N	\N	\N	\N	5821	5821	7698
2502	2066	1	applied	\N	\N	\N	\N	7699	7699	7700
2502	2067	2	applied	\N	\N	\N	\N	7701	7701	7702
2502	2068	3	applied	\N	\N	\N	\N	7703	7703	7704
2507	2072	0	applied	\N	\N	\N	\N	7717	7717	7718
2507	2073	1	applied	\N	\N	\N	\N	7719	7719	7720
2508	2074	0	applied	\N	\N	\N	\N	7722	7722	7723
2508	2075	1	applied	\N	\N	\N	\N	7724	7724	7725
2508	2076	2	applied	\N	\N	\N	\N	7726	7726	7727
2510	2077	0	applied	\N	\N	\N	\N	7731	7731	7732
2512	2078	0	applied	\N	\N	\N	\N	7735	7735	7736
2512	2079	1	applied	\N	\N	\N	\N	7737	7737	7738
2514	2081	0	applied	\N	\N	\N	\N	7745	7745	7746
2515	2082	0	applied	\N	\N	\N	\N	7749	7749	7750
2518	2083	0	applied	\N	\N	\N	\N	7751	7751	7752
2518	2084	1	applied	\N	\N	\N	\N	7753	7753	7754
2518	2085	2	applied	\N	\N	\N	\N	7755	7755	7756
2519	2083	0	applied	\N	\N	\N	\N	7751	7751	7752
2519	2084	1	applied	\N	\N	\N	\N	7753	7753	7754
2519	2085	2	applied	\N	\N	\N	\N	7755	7755	7756
2522	2090	0	applied	\N	\N	\N	\N	7774	7774	7775
2525	2095	0	applied	\N	\N	\N	\N	7790	7790	7791
2525	2096	1	applied	\N	\N	\N	\N	7792	7792	7793
2528	2097	0	applied	\N	\N	\N	\N	7796	7796	7797
2530	2099	0	applied	\N	\N	\N	\N	7805	7805	7806
2538	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2538	2105	1	applied	\N	\N	\N	\N	7826	7826	7827
2544	2109	0	applied	\N	\N	\N	\N	7841	7841	7842
2546	2110	0	applied	\N	\N	\N	\N	7845	7845	7846
2550	2115	0	applied	\N	\N	\N	\N	7861	7861	7862
2553	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2553	2065	1	applied	\N	\N	\N	\N	5821	5821	7698
2553	2054	2	applied	\N	\N	1000000000	\N	7667	7667	7668
2553	2013	3	applied	\N	\N	\N	\N	7513	7513	7514
2553	2014	4	applied	\N	\N	\N	\N	7519	7519	7520
2553	2015	5	applied	\N	\N	\N	\N	7523	7523	7524
2553	2016	6	applied	\N	\N	\N	\N	7527	7527	7528
2553	2017	7	applied	\N	\N	\N	\N	7531	7531	7532
2553	2018	8	applied	\N	\N	\N	\N	7535	7535	7536
2553	2019	9	applied	\N	\N	\N	\N	7540	7540	7541
2553	2020	10	applied	\N	\N	\N	\N	7542	7542	7543
2553	2089	11	applied	\N	\N	1000000000	\N	7769	7769	7770
2553	2021	12	applied	\N	\N	\N	\N	7545	7545	7546
2553	2022	13	applied	\N	\N	\N	\N	7550	7550	7551
2553	2023	14	applied	\N	\N	\N	\N	7552	7552	7553
2553	2024	15	applied	\N	\N	\N	\N	7554	7554	7555
2553	2025	16	applied	\N	\N	\N	\N	7556	7556	7557
2553	2026	17	applied	\N	\N	\N	\N	7559	7559	7560
2553	2027	18	applied	\N	\N	\N	\N	7563	7563	7564
2553	2028	19	applied	\N	\N	\N	\N	7569	7569	7570
2553	2029	20	applied	\N	\N	\N	\N	7575	7575	7576
2553	2030	21	applied	\N	\N	\N	\N	7577	7577	7578
2553	2031	22	applied	\N	\N	\N	\N	7581	7581	7582
2553	2032	23	applied	\N	\N	\N	\N	7587	7587	7588
2553	2033	24	applied	\N	\N	\N	\N	7589	7589	7590
2553	2034	25	applied	\N	\N	\N	\N	7591	7591	7592
2553	2035	26	applied	\N	\N	\N	\N	7595	7595	7596
2553	2036	27	applied	\N	\N	\N	\N	7599	7599	7600
2553	2037	28	applied	\N	\N	\N	\N	7604	7604	7605
2553	2038	29	applied	\N	\N	\N	\N	7608	7608	7609
2553	2039	30	applied	\N	\N	\N	\N	7610	7610	7611
2553	2040	31	applied	\N	\N	\N	\N	7612	7612	7613
2553	2041	32	applied	\N	\N	\N	\N	7614	7614	7615
2553	2042	33	applied	\N	\N	\N	\N	7616	7616	7617
2553	2043	34	applied	\N	\N	\N	\N	7620	7620	7621
2553	2044	35	applied	\N	\N	\N	\N	7624	7624	7625
2553	2045	36	applied	\N	\N	\N	\N	7628	7628	7629
2553	2046	37	applied	\N	\N	\N	\N	7630	7630	7631
2553	2047	38	applied	\N	\N	\N	\N	7633	7633	7634
2553	2048	39	applied	\N	\N	\N	\N	7635	7635	7636
2553	2049	40	applied	\N	\N	\N	\N	7641	7641	7642
2553	2050	41	applied	\N	\N	\N	\N	7647	7647	7648
2553	2051	42	applied	\N	\N	\N	\N	7653	7653	7654
2553	2052	43	applied	\N	\N	\N	\N	7657	7657	7658
2553	2053	44	applied	\N	\N	\N	\N	7665	7665	7666
2553	2055	45	applied	\N	\N	\N	\N	7670	7670	7671
2553	2056	46	applied	\N	\N	\N	\N	7672	7672	7673
2553	2057	47	applied	\N	\N	\N	\N	7674	7674	7675
2553	2058	48	applied	\N	\N	\N	\N	7676	7676	7677
2553	2059	49	applied	\N	\N	\N	\N	7680	7680	7681
2553	2060	50	applied	\N	\N	\N	\N	7685	7685	7686
2553	2061	51	applied	\N	\N	\N	\N	7688	7688	7689
2553	2062	52	applied	\N	\N	\N	\N	7690	7690	7691
2553	2063	53	applied	\N	\N	\N	\N	7692	7692	7693
2553	2064	54	applied	\N	\N	\N	\N	7694	7694	7695
2553	2066	55	applied	\N	\N	\N	\N	7699	7699	7700
2553	2067	56	applied	\N	\N	\N	\N	7701	7701	7702
2553	2068	57	applied	\N	\N	\N	\N	7703	7703	7704
2553	2069	58	applied	\N	\N	\N	\N	7709	7709	7710
2553	2070	59	applied	\N	\N	\N	\N	7713	7713	7714
2553	2071	60	applied	\N	\N	\N	\N	7715	7715	7716
2553	2072	61	applied	\N	\N	\N	\N	7717	7717	7718
2553	2073	62	applied	\N	\N	\N	\N	7719	7719	7720
2553	2074	63	applied	\N	\N	\N	\N	7722	7722	7723
2553	2075	64	applied	\N	\N	\N	\N	7724	7724	7725
2553	2076	65	applied	\N	\N	\N	\N	7726	7726	7727
2553	2077	66	applied	\N	\N	\N	\N	7731	7731	7732
2553	2078	67	applied	\N	\N	\N	\N	7735	7735	7736
2553	2079	69	applied	\N	\N	\N	\N	7737	7737	7738
2553	2080	70	applied	\N	\N	\N	\N	7741	7741	7742
2553	2081	71	applied	\N	\N	\N	\N	7745	7745	7746
2553	2082	72	applied	\N	\N	\N	\N	7749	7749	7750
2553	2083	73	applied	\N	\N	\N	\N	7751	7751	7752
2553	2084	74	applied	\N	\N	\N	\N	7753	7753	7754
2553	2085	75	applied	\N	\N	\N	\N	7755	7755	7756
2553	2086	76	applied	\N	\N	\N	\N	7763	7763	7764
2553	2087	77	applied	\N	\N	\N	\N	7765	7765	7766
2553	2088	78	applied	\N	\N	\N	\N	7767	7767	7768
2553	2090	79	applied	\N	\N	\N	\N	7774	7774	7775
2553	2091	80	applied	\N	\N	\N	\N	7778	7778	7779
2554	2119	0	applied	\N	\N	\N	\N	7876	7876	7877
2554	2120	1	applied	\N	\N	\N	\N	7878	7878	7879
2557	2122	0	applied	\N	\N	\N	\N	7888	7888	7889
2557	2123	1	applied	\N	\N	\N	\N	7890	7890	7891
2560	2126	0	applied	\N	\N	\N	\N	7900	7900	7901
2560	2127	1	applied	\N	\N	\N	\N	7902	7902	7903
2563	2126	0	applied	\N	\N	\N	\N	7900	7900	7901
2563	2127	1	applied	\N	\N	\N	\N	7902	7902	7903
2561	2094	13	applied	\N	\N	\N	\N	7786	7786	7787
2561	2095	14	applied	\N	\N	\N	\N	7790	7790	7791
2561	2096	15	applied	\N	\N	\N	\N	7792	7792	7793
2561	2097	16	applied	\N	\N	\N	\N	7796	7796	7797
2561	2098	17	applied	\N	\N	\N	\N	7803	7803	7804
2561	2099	18	applied	\N	\N	\N	\N	7805	7805	7806
2561	2100	19	applied	\N	\N	\N	\N	7807	7807	7808
2561	2101	20	applied	\N	\N	\N	\N	7811	7811	7812
2561	2102	21	applied	\N	\N	\N	\N	7814	7814	7815
2561	2103	22	applied	\N	\N	\N	\N	7822	7822	7823
2561	2105	23	applied	\N	\N	\N	\N	7826	7826	7827
2561	2106	24	applied	\N	\N	\N	\N	7831	7831	7832
2561	2107	25	applied	\N	\N	\N	\N	7837	7837	7838
2561	2108	26	applied	\N	\N	\N	\N	7839	7839	7840
2561	2109	27	applied	\N	\N	\N	\N	7841	7841	7842
2561	2110	28	applied	\N	\N	\N	\N	7845	7845	7846
2561	2111	29	applied	\N	\N	\N	\N	7851	7851	7852
2561	2112	30	applied	\N	\N	\N	\N	7853	7853	7854
2561	2113	31	applied	\N	\N	\N	\N	7855	7855	7856
2561	2114	32	applied	\N	\N	\N	\N	7857	7857	7858
2561	2115	33	applied	\N	\N	\N	\N	7861	7861	7862
2561	2116	34	applied	\N	\N	\N	\N	7865	7865	7866
2561	2117	35	applied	\N	\N	\N	\N	7867	7867	7868
2561	2118	36	applied	\N	\N	\N	\N	7870	7870	7871
2561	2119	37	applied	\N	\N	\N	\N	7876	7876	7877
2561	2120	38	applied	\N	\N	\N	\N	7878	7878	7879
2561	2121	39	applied	\N	\N	\N	\N	7884	7884	7885
2561	2122	40	applied	\N	\N	\N	\N	7888	7888	7889
2561	2123	42	applied	\N	\N	\N	\N	7890	7890	7891
2561	2124	43	applied	\N	\N	\N	\N	7894	7894	7895
2561	2125	44	applied	\N	\N	\N	\N	7896	7896	7897
2561	2126	45	applied	\N	\N	\N	\N	7900	7900	7901
2561	2127	46	applied	\N	\N	\N	\N	7902	7902	7903
2565	2128	0	applied	\N	\N	\N	\N	7913	7913	7914
2566	2129	0	applied	\N	\N	\N	\N	7917	7917	7918
2567	2130	0	applied	\N	\N	\N	\N	7921	7921	7922
2568	2130	0	applied	\N	\N	\N	\N	7921	7921	7922
2569	1856	0	applied	\N	\N	\N	\N	6927	6927	6928
2569	2104	1	applied	\N	\N	\N	\N	7824	7824	7825
2569	1815	2	applied	\N	\N	\N	\N	6767	6767	6768
2569	1996	3	applied	\N	\N	\N	\N	6759	6759	7454
2569	1816	4	applied	\N	\N	\N	\N	6769	6769	6770
2569	2054	5	applied	\N	\N	1000000000	\N	7667	7667	7668
2569	1817	6	applied	\N	\N	\N	\N	6775	6775	6776
2569	1818	7	applied	\N	\N	\N	\N	6779	6779	6780
2569	1819	8	applied	\N	\N	\N	\N	6781	6781	6782
2569	1820	9	applied	\N	\N	\N	\N	6783	6783	6784
2569	1821	10	applied	\N	\N	\N	\N	6789	6789	6790
2569	1822	12	applied	\N	\N	\N	\N	6797	6797	6798
2570	2130	0	applied	\N	\N	\N	\N	7921	7921	7922
2571	2131	0	applied	\N	\N	\N	\N	7932	7932	7933
2571	2132	1	applied	\N	\N	\N	\N	7934	7934	7935
2572	2133	0	applied	\N	\N	\N	\N	7937	7937	7938
2572	2134	1	applied	\N	\N	\N	\N	7939	7939	7940
2573	2135	0	applied	\N	\N	\N	\N	7943	7943	7944
2573	2136	1	applied	\N	\N	\N	\N	7945	7945	7946
2574	2137	0	applied	\N	\N	\N	\N	7949	7949	7950
2574	2138	1	applied	\N	\N	\N	\N	7951	7951	7952
2575	2139	0	applied	\N	\N	\N	\N	7955	7955	7956
2576	2140	0	applied	\N	\N	\N	\N	7959	7959	7960
2577	2140	0	applied	\N	\N	\N	\N	7959	7959	7960
2579	2141	0	applied	\N	\N	\N	\N	7965	7965	7966
2579	2142	1	applied	\N	\N	\N	\N	7967	7967	7968
2579	2143	2	applied	\N	\N	\N	\N	7969	7969	7970
2580	2141	0	applied	\N	\N	\N	\N	7965	7965	7966
2580	2142	1	applied	\N	\N	\N	\N	7967	7967	7968
2580	2143	2	applied	\N	\N	\N	\N	7969	7969	7970
2581	2144	0	applied	\N	\N	\N	\N	7975	7975	7976
2582	2144	0	applied	\N	\N	\N	\N	7975	7975	7976
2583	2145	0	applied	\N	\N	\N	\N	7979	7979	7980
2584	2145	0	applied	\N	\N	\N	\N	7979	7979	7980
2585	2145	0	applied	\N	\N	\N	\N	7979	7979	7980
2587	2146	0	applied	\N	\N	\N	\N	7989	7989	7990
2588	2146	0	applied	\N	\N	\N	\N	7989	7989	7990
2589	2147	0	applied	\N	\N	\N	\N	7995	7995	7996
2589	2148	1	applied	\N	\N	\N	\N	7997	7997	7998
2590	2147	0	applied	\N	\N	\N	\N	7995	7995	7996
2590	2148	1	applied	\N	\N	\N	\N	7997	7997	7998
2591	2149	0	applied	\N	\N	\N	\N	8002	8002	8003
2592	2150	0	applied	\N	\N	\N	\N	8004	8004	8005
2593	2150	0	applied	\N	\N	\N	\N	8004	8004	8005
2594	2150	0	applied	\N	\N	\N	\N	8004	8004	8005
2595	2151	0	applied	\N	\N	\N	\N	8011	8011	8012
2595	2152	1	applied	\N	\N	\N	\N	8013	8013	8014
2596	2151	0	applied	\N	\N	\N	\N	8011	8011	8012
2596	2152	1	applied	\N	\N	\N	\N	8013	8013	8014
2597	2151	0	applied	\N	\N	\N	\N	8011	8011	8012
2597	2152	1	applied	\N	\N	\N	\N	8013	8013	8014
2598	2153	0	applied	\N	\N	\N	\N	8019	8019	8020
2603	2154	0	applied	\N	\N	\N	\N	8022	8022	8023
2603	2155	1	applied	\N	\N	\N	\N	8024	8024	8025
2604	2154	0	applied	\N	\N	\N	\N	8022	8022	8023
2604	2155	1	applied	\N	\N	\N	\N	8024	8024	8025
2605	2156	0	applied	\N	\N	\N	\N	8032	8032	8033
2605	2157	1	applied	\N	\N	\N	\N	8034	8034	8035
2606	2156	0	applied	\N	\N	\N	\N	8032	8032	8033
2606	2157	1	applied	\N	\N	\N	\N	8034	8034	8035
2607	2158	0	applied	\N	\N	\N	\N	8038	8038	8039
2608	2158	0	applied	\N	\N	\N	\N	8038	8038	8039
2609	2128	0	applied	\N	\N	\N	\N	7913	7913	7914
2609	2129	1	applied	\N	\N	\N	\N	7917	7917	7918
2609	2130	2	applied	\N	\N	\N	\N	7921	7921	7922
2609	2131	3	applied	\N	\N	\N	\N	7932	7932	7933
2609	2132	4	applied	\N	\N	\N	\N	7934	7934	7935
2609	2133	5	applied	\N	\N	\N	\N	7937	7937	7938
2609	2134	6	applied	\N	\N	\N	\N	7939	7939	7940
2609	2135	7	applied	\N	\N	\N	\N	7943	7943	7944
2609	2136	8	applied	\N	\N	\N	\N	7945	7945	7946
2609	2137	9	applied	\N	\N	\N	\N	7949	7949	7950
2609	2138	10	applied	\N	\N	\N	\N	7951	7951	7952
2609	2139	11	applied	\N	\N	\N	\N	7955	7955	7956
2609	2140	12	applied	\N	\N	\N	\N	7959	7959	7960
2609	2141	13	applied	\N	\N	\N	\N	7965	7965	7966
2609	2142	14	applied	\N	\N	\N	\N	7967	7967	7968
2609	2143	15	applied	\N	\N	\N	\N	7969	7969	7970
2609	2144	16	applied	\N	\N	\N	\N	7975	7975	7976
2609	2145	17	applied	\N	\N	\N	\N	7979	7979	7980
2609	2146	18	applied	\N	\N	\N	\N	7989	7989	7990
2609	2147	19	applied	\N	\N	\N	\N	7995	7995	7996
2609	2148	20	applied	\N	\N	\N	\N	7997	7997	7998
2609	2149	21	applied	\N	\N	\N	\N	8002	8002	8003
2609	2150	22	applied	\N	\N	\N	\N	8004	8004	8005
2609	2151	23	applied	\N	\N	\N	\N	8011	8011	8012
2609	2152	24	applied	\N	\N	\N	\N	8013	8013	8014
2609	2153	25	applied	\N	\N	\N	\N	8019	8019	8020
2609	2154	26	applied	\N	\N	\N	\N	8022	8022	8023
2609	2155	27	applied	\N	\N	\N	\N	8024	8024	8025
2609	2156	28	applied	\N	\N	\N	\N	8032	8032	8033
2609	2157	29	applied	\N	\N	\N	\N	8034	8034	8035
2609	2158	30	applied	\N	\N	\N	\N	8038	8038	8039
2612	2161	0	applied	\N	\N	\N	\N	8052	8052	8053
2613	2162	0	applied	\N	\N	\N	\N	8055	8055	8056
2613	2163	1	applied	\N	\N	\N	\N	8057	8057	8058
2613	2164	2	applied	\N	\N	\N	\N	8059	8059	8060
2613	2165	3	applied	\N	\N	\N	\N	8061	8061	8062
2613	2166	4	applied	\N	\N	\N	\N	8063	8063	8064
2616	2168	0	applied	\N	\N	\N	\N	8072	8072	8073
2619	2169	0	applied	\N	\N	\N	\N	8074	8074	8075
2622	2169	0	applied	\N	\N	\N	\N	8074	8074	8075
2625	2174	0	applied	\N	\N	\N	\N	8091	8091	8092
2628	2175	0	applied	\N	\N	\N	\N	8093	8093	8094
2631	2177	0	applied	\N	\N	\N	\N	8099	8099	8100
2631	2178	1	applied	\N	\N	\N	\N	8101	8101	8102
2634	2180	0	applied	\N	\N	\N	\N	8108	8108	8109
2637	2181	0	applied	\N	\N	\N	\N	8112	8112	8113
2643	2184	0	applied	\N	\N	\N	\N	8130	8130	8131
2643	2185	1	applied	\N	\N	\N	\N	8132	8132	8133
2646	2187	0	applied	\N	\N	\N	\N	8140	8140	8141
2649	2189	0	applied	\N	\N	\N	\N	8150	8150	8151
2652	2190	0	applied	\N	\N	\N	\N	8152	8152	8153
2652	2191	1	applied	\N	\N	\N	\N	8154	8154	8155
2655	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2655	2065	1	applied	\N	\N	\N	\N	5821	5821	7698
2655	2089	2	applied	\N	\N	1000000000	\N	7769	7769	7770
2655	2066	3	applied	\N	\N	\N	\N	7699	7699	7700
2655	2067	4	applied	\N	\N	\N	\N	7701	7701	7702
2655	2068	5	applied	\N	\N	\N	\N	7703	7703	7704
2655	2069	6	applied	\N	\N	\N	\N	7709	7709	7710
2655	2070	7	applied	\N	\N	\N	\N	7713	7713	7714
2655	2071	8	applied	\N	\N	\N	\N	7715	7715	7716
2655	2072	9	applied	\N	\N	\N	\N	7717	7717	7718
2655	2073	10	applied	\N	\N	\N	\N	7719	7719	7720
2655	2074	11	applied	\N	\N	\N	\N	7722	7722	7723
2655	2075	12	applied	\N	\N	\N	\N	7724	7724	7725
2655	2076	13	applied	\N	\N	\N	\N	7726	7726	7727
2655	2077	14	applied	\N	\N	\N	\N	7731	7731	7732
2655	2078	15	applied	\N	\N	\N	\N	7735	7735	7736
2655	2079	16	applied	\N	\N	\N	\N	7737	7737	7738
2655	2080	17	applied	\N	\N	\N	\N	7741	7741	7742
2655	2081	18	applied	\N	\N	\N	\N	7745	7745	7746
2655	2082	19	applied	\N	\N	\N	\N	7749	7749	7750
2655	2083	20	applied	\N	\N	\N	\N	7751	7751	7752
2655	2084	21	applied	\N	\N	\N	\N	7753	7753	7754
2655	2085	22	applied	\N	\N	\N	\N	7755	7755	7756
2655	2086	23	applied	\N	\N	\N	\N	7763	7763	7764
2655	2087	24	applied	\N	\N	\N	\N	7765	7765	7766
2655	2088	25	applied	\N	\N	\N	\N	7767	7767	7768
2655	2090	26	applied	\N	\N	\N	\N	7774	7774	7775
2655	2091	27	applied	\N	\N	\N	\N	7778	7778	7779
2655	2092	28	applied	\N	\N	\N	\N	7782	7782	7783
2655	2093	29	applied	\N	\N	\N	\N	7784	7784	7785
2655	2094	30	applied	\N	\N	\N	\N	7786	7786	7787
2655	2095	31	applied	\N	\N	\N	\N	7790	7790	7791
2655	2096	32	applied	\N	\N	\N	\N	7792	7792	7793
2655	2097	33	applied	\N	\N	\N	\N	7796	7796	7797
2655	2098	34	applied	\N	\N	\N	\N	7803	7803	7804
2655	2099	35	applied	\N	\N	\N	\N	7805	7805	7806
2655	2100	37	applied	\N	\N	\N	\N	7807	7807	7808
2655	2101	38	applied	\N	\N	\N	\N	7811	7811	7812
2655	2102	39	applied	\N	\N	\N	\N	7814	7814	7815
2655	2103	40	applied	\N	\N	\N	\N	7822	7822	7823
2655	2105	41	applied	\N	\N	\N	\N	7826	7826	7827
2655	2106	42	applied	\N	\N	\N	\N	7831	7831	7832
2655	2107	43	applied	\N	\N	\N	\N	7837	7837	7838
2655	2108	44	applied	\N	\N	\N	\N	7839	7839	7840
2655	2109	45	applied	\N	\N	\N	\N	7841	7841	7842
2655	2110	46	applied	\N	\N	\N	\N	7845	7845	7846
2655	2111	47	applied	\N	\N	\N	\N	7851	7851	7852
2655	2112	48	applied	\N	\N	\N	\N	7853	7853	7854
2655	2113	49	applied	\N	\N	\N	\N	7855	7855	7856
2655	2114	50	applied	\N	\N	\N	\N	7857	7857	7858
2655	2115	51	applied	\N	\N	\N	\N	7861	7861	7862
2655	2116	52	applied	\N	\N	\N	\N	7865	7865	7866
2655	2117	53	applied	\N	\N	\N	\N	7867	7867	7868
2655	2118	54	applied	\N	\N	\N	\N	7870	7870	7871
2655	2119	55	applied	\N	\N	\N	\N	7876	7876	7877
2655	2120	56	applied	\N	\N	\N	\N	7878	7878	7879
2655	2121	57	applied	\N	\N	\N	\N	7884	7884	7885
2655	2122	58	applied	\N	\N	\N	\N	7888	7888	7889
2655	2123	59	applied	\N	\N	\N	\N	7890	7890	7891
2655	2124	60	applied	\N	\N	\N	\N	7894	7894	7895
2655	2125	61	applied	\N	\N	\N	\N	7896	7896	7897
2655	2126	62	applied	\N	\N	\N	\N	7900	7900	7901
2655	2127	63	applied	\N	\N	\N	\N	7902	7902	7903
2655	2128	64	applied	\N	\N	\N	\N	7913	7913	7914
2655	2129	65	applied	\N	\N	\N	\N	7917	7917	7918
2655	2130	66	applied	\N	\N	\N	\N	7921	7921	7922
2655	2131	67	applied	\N	\N	\N	\N	7932	7932	7933
2655	2132	68	applied	\N	\N	\N	\N	7934	7934	7935
2655	2133	69	applied	\N	\N	\N	\N	7937	7937	7938
2655	2134	70	applied	\N	\N	\N	\N	7939	7939	7940
2655	2135	71	applied	\N	\N	\N	\N	7943	7943	7944
2655	2136	72	applied	\N	\N	\N	\N	7945	7945	7946
2655	2137	73	applied	\N	\N	\N	\N	7949	7949	7950
2655	2138	74	applied	\N	\N	\N	\N	7951	7951	7952
2655	2139	75	applied	\N	\N	\N	\N	7955	7955	7956
2655	2140	76	applied	\N	\N	\N	\N	7959	7959	7960
2655	2141	77	applied	\N	\N	\N	\N	7965	7965	7966
2655	2142	78	applied	\N	\N	\N	\N	7967	7967	7968
2655	2143	79	applied	\N	\N	\N	\N	7969	7969	7970
2655	2144	80	applied	\N	\N	\N	\N	7975	7975	7976
2655	2145	81	applied	\N	\N	\N	\N	7979	7979	7980
2655	2146	82	applied	\N	\N	\N	\N	7989	7989	7990
2655	2147	83	applied	\N	\N	\N	\N	7995	7995	7996
2655	2148	84	applied	\N	\N	\N	\N	7997	7997	7998
2655	2149	85	applied	\N	\N	\N	\N	8002	8002	8003
2655	2150	86	applied	\N	\N	\N	\N	8004	8004	8005
2656	2197	0	applied	\N	\N	\N	\N	8178	8178	8179
2659	2198	0	applied	\N	\N	\N	\N	8184	8184	8185
2662	2199	0	applied	\N	\N	\N	\N	8187	8187	8188
2610	2159	0	applied	\N	\N	\N	\N	8045	8045	8046
2610	2160	1	applied	\N	\N	\N	\N	8047	8047	8048
2611	2159	0	applied	\N	\N	\N	\N	8045	8045	8046
2611	2160	1	applied	\N	\N	\N	\N	8047	8047	8048
2615	2167	0	applied	\N	\N	\N	\N	8068	8068	8069
2618	2169	0	applied	\N	\N	\N	\N	8074	8074	8075
2621	2169	0	applied	\N	\N	\N	\N	8074	8074	8075
2624	2172	0	applied	\N	\N	\N	\N	8086	8086	8087
2624	2173	1	applied	\N	\N	\N	\N	8088	8088	8089
2626	2174	0	applied	\N	\N	\N	\N	8091	8091	8092
2627	2174	0	applied	\N	\N	\N	\N	8091	8091	8092
2630	2177	0	applied	\N	\N	\N	\N	8099	8099	8100
2630	2178	1	applied	\N	\N	\N	\N	8101	8101	8102
2633	2179	0	applied	\N	\N	\N	\N	8105	8105	8106
2635	2180	0	applied	\N	\N	\N	\N	8108	8108	8109
2636	2181	0	applied	\N	\N	\N	\N	8112	8112	8113
2639	2182	0	applied	\N	\N	\N	\N	8118	8118	8119
2642	2183	0	applied	\N	\N	\N	\N	8128	8128	8129
2645	2187	0	applied	\N	\N	\N	\N	8140	8140	8141
2648	2188	0	applied	\N	\N	\N	\N	8146	8146	8147
2650	2189	0	applied	\N	\N	\N	\N	8150	8150	8151
2651	2190	0	applied	\N	\N	\N	\N	8152	8152	8153
2651	2191	1	applied	\N	\N	\N	\N	8154	8154	8155
2654	2192	0	applied	\N	\N	\N	\N	8161	8161	8162
2654	2193	1	applied	\N	\N	\N	\N	8163	8163	8164
2654	2194	2	applied	\N	\N	\N	\N	8165	8165	8166
2654	2195	3	applied	\N	\N	\N	\N	8167	8167	8168
2654	2196	4	applied	\N	\N	\N	\N	8169	8169	8170
2657	2197	0	applied	\N	\N	\N	\N	8178	8178	8179
2660	2198	0	applied	\N	\N	\N	\N	8184	8184	8185
2663	2199	0	applied	\N	\N	\N	\N	8187	8187	8188
2663	2200	1	applied	\N	\N	\N	\N	8189	8189	8190
2665	2201	0	applied	\N	\N	\N	\N	8193	8193	8194
2667	2202	0	applied	\N	\N	\N	\N	8199	8199	8200
2670	2203	0	applied	\N	\N	\N	\N	8202	8202	8203
2670	2204	1	applied	\N	\N	\N	\N	8204	8204	8205
2675	2208	0	applied	\N	\N	\N	\N	8221	8221	8222
2675	2209	1	applied	\N	\N	\N	\N	8223	8223	8224
2675	2210	2	applied	\N	\N	\N	\N	8225	8225	8226
2675	2211	3	applied	\N	\N	\N	\N	8227	8227	8228
2678	2212	0	applied	\N	\N	\N	\N	8233	8233	8234
2678	2213	1	applied	\N	\N	\N	\N	8235	8235	8236
2681	2215	0	applied	\N	\N	\N	\N	8243	8243	8244
2684	2216	0	applied	\N	\N	\N	\N	8249	8249	8250
2687	2218	0	applied	\N	\N	\N	\N	8260	8260	8261
2690	2218	0	applied	\N	\N	\N	\N	8260	8260	8261
2693	2220	0	applied	\N	\N	\N	\N	8270	8270	8271
2693	2221	1	applied	\N	\N	\N	\N	8272	8272	8273
2696	2225	0	applied	\N	\N	\N	\N	8285	8285	8286
2699	2226	0	applied	\N	\N	\N	\N	8287	8287	8288
2702	2227	0	applied	\N	\N	\N	\N	8291	8291	8292
2705	2230	0	applied	\N	\N	\N	\N	8308	8308	8309
2708	2231	0	applied	\N	\N	\N	\N	8312	8312	8313
2711	2233	0	applied	\N	\N	\N	\N	8322	8322	8323
2714	2234	0	applied	\N	\N	\N	\N	8327	8327	8328
2717	2239	0	applied	\N	\N	\N	\N	8341	8341	8342
2720	2240	0	applied	\N	\N	\N	\N	8347	8347	8348
2720	2241	1	applied	\N	\N	\N	\N	8349	8349	8350
2720	2242	2	applied	\N	\N	\N	\N	8353	8353	8354
2723	2244	0	applied	\N	\N	\N	\N	8363	8363	8364
2723	2245	1	applied	\N	\N	\N	\N	8365	8365	8366
2726	2244	0	applied	\N	\N	\N	\N	8363	8363	8364
2726	2245	1	applied	\N	\N	\N	\N	8365	8365	8366
2614	2162	0	applied	\N	\N	\N	\N	8055	8055	8056
2614	2163	1	applied	\N	\N	\N	\N	8057	8057	8058
2614	2164	2	applied	\N	\N	\N	\N	8059	8059	8060
2614	2165	3	applied	\N	\N	\N	\N	8061	8061	8062
2614	2166	4	applied	\N	\N	\N	\N	8063	8063	8064
2623	2170	0	applied	\N	\N	\N	\N	8080	8080	8081
2623	2171	1	applied	\N	\N	\N	\N	8082	8082	8083
2629	2176	0	applied	\N	\N	\N	\N	8095	8095	8096
2632	2179	0	applied	\N	\N	\N	\N	8105	8105	8106
2638	2182	0	applied	\N	\N	\N	\N	8118	8118	8119
2640	2182	0	applied	\N	\N	\N	\N	8118	8118	8119
2641	2182	0	applied	\N	\N	\N	\N	8118	8118	8119
2644	2186	0	applied	\N	\N	\N	\N	8136	8136	8137
2647	2188	0	applied	\N	\N	\N	\N	8146	8146	8147
2653	2190	0	applied	\N	\N	\N	\N	8152	8152	8153
2653	2191	1	applied	\N	\N	\N	\N	8154	8154	8155
2658	2197	0	applied	\N	\N	\N	\N	8178	8178	8179
2661	2198	0	applied	\N	\N	\N	\N	8184	8184	8185
2666	2201	0	applied	\N	\N	\N	\N	8193	8193	8194
2668	2203	0	applied	\N	\N	\N	\N	8202	8202	8203
2668	2204	1	applied	\N	\N	\N	\N	8204	8204	8205
2671	2205	0	applied	\N	\N	\N	\N	8209	8209	8210
2672	2206	0	applied	\N	\N	\N	\N	8211	8211	8212
2674	2207	0	applied	\N	\N	\N	\N	8217	8217	8218
2677	2208	0	applied	\N	\N	\N	\N	8221	8221	8222
2677	2209	1	applied	\N	\N	\N	\N	8223	8223	8224
2677	2210	2	applied	\N	\N	\N	\N	8225	8225	8226
2677	2211	3	applied	\N	\N	\N	\N	8227	8227	8228
2680	2215	0	applied	\N	\N	\N	\N	8243	8243	8244
2683	2216	0	applied	\N	\N	\N	\N	8249	8249	8250
2686	2217	0	applied	\N	\N	\N	\N	8254	8254	8255
2689	2218	0	applied	\N	\N	\N	\N	8260	8260	8261
2692	2220	0	applied	\N	\N	\N	\N	8270	8270	8271
2692	2221	1	applied	\N	\N	\N	\N	8272	8272	8273
2695	2223	0	applied	\N	\N	\N	\N	8280	8280	8281
2695	2224	1	applied	\N	\N	\N	\N	8282	8282	8283
2698	2226	0	applied	\N	\N	\N	\N	8287	8287	8288
2701	2227	0	applied	\N	\N	\N	\N	8291	8291	8292
2704	2228	0	applied	\N	\N	\N	\N	8302	8302	8303
2704	2229	1	applied	\N	\N	\N	\N	8304	8304	8305
2707	2231	0	applied	\N	\N	\N	\N	8312	8312	8313
2710	2233	0	applied	\N	\N	\N	\N	8322	8322	8323
2716	2238	0	applied	\N	\N	\N	\N	8339	8339	8340
2719	2240	0	applied	\N	\N	\N	\N	8347	8347	8348
2719	2241	1	applied	\N	\N	\N	\N	8349	8349	8350
2722	2243	0	applied	\N	\N	\N	\N	8359	8359	8360
2724	2244	0	applied	\N	\N	\N	\N	8363	8363	8364
2724	2245	1	applied	\N	\N	\N	\N	8365	8365	8366
2725	2244	0	applied	\N	\N	\N	\N	8363	8363	8364
2725	2245	1	applied	\N	\N	\N	\N	8365	8365	8366
2728	2154	0	applied	\N	\N	\N	\N	8022	8022	8023
2728	2155	1	applied	\N	\N	\N	\N	8024	8024	8025
2728	2156	2	applied	\N	\N	\N	\N	8032	8032	8033
2728	2157	3	applied	\N	\N	\N	\N	8034	8034	8035
2728	2158	4	applied	\N	\N	\N	\N	8038	8038	8039
2728	2159	5	applied	\N	\N	\N	\N	8045	8045	8046
2728	2160	6	applied	\N	\N	\N	\N	8047	8047	8048
2728	2161	7	applied	\N	\N	\N	\N	8052	8052	8053
2728	2162	8	applied	\N	\N	\N	\N	8055	8055	8056
2728	2163	9	applied	\N	\N	\N	\N	8057	8057	8058
2728	2164	10	applied	\N	\N	\N	\N	8059	8059	8060
2728	2165	11	applied	\N	\N	\N	\N	8061	8061	8062
2728	2166	12	applied	\N	\N	\N	\N	8063	8063	8064
2728	2167	13	applied	\N	\N	\N	\N	8068	8068	8069
2728	2168	14	applied	\N	\N	\N	\N	8072	8072	8073
2728	2169	15	applied	\N	\N	\N	\N	8074	8074	8075
2728	2170	16	applied	\N	\N	\N	\N	8080	8080	8081
2728	2171	17	applied	\N	\N	\N	\N	8082	8082	8083
2728	2172	18	applied	\N	\N	\N	\N	8086	8086	8087
2728	2173	19	applied	\N	\N	\N	\N	8088	8088	8089
2728	2174	20	applied	\N	\N	\N	\N	8091	8091	8092
2728	2175	21	applied	\N	\N	\N	\N	8093	8093	8094
2728	2176	22	applied	\N	\N	\N	\N	8095	8095	8096
2728	2177	23	applied	\N	\N	\N	\N	8099	8099	8100
2728	2178	24	applied	\N	\N	\N	\N	8101	8101	8102
2728	2179	25	applied	\N	\N	\N	\N	8105	8105	8106
2728	2180	26	applied	\N	\N	\N	\N	8108	8108	8109
2728	2181	27	applied	\N	\N	\N	\N	8112	8112	8113
2728	2182	29	applied	\N	\N	\N	\N	8118	8118	8119
2728	2183	30	applied	\N	\N	\N	\N	8128	8128	8129
2728	2184	31	applied	\N	\N	\N	\N	8130	8130	8131
2728	2185	32	applied	\N	\N	\N	\N	8132	8132	8133
2728	2186	33	applied	\N	\N	\N	\N	8136	8136	8137
2728	2187	34	applied	\N	\N	\N	\N	8140	8140	8141
2728	2188	35	applied	\N	\N	\N	\N	8146	8146	8147
2728	2189	36	applied	\N	\N	\N	\N	8150	8150	8151
2728	2190	37	applied	\N	\N	\N	\N	8152	8152	8153
2728	2191	38	applied	\N	\N	\N	\N	8154	8154	8155
2728	2192	39	applied	\N	\N	\N	\N	8161	8161	8162
2728	2193	40	applied	\N	\N	\N	\N	8163	8163	8164
2728	2194	41	applied	\N	\N	\N	\N	8165	8165	8166
2728	2195	42	applied	\N	\N	\N	\N	8167	8167	8168
2728	2196	43	applied	\N	\N	\N	\N	8169	8169	8170
2728	2197	44	applied	\N	\N	\N	\N	8178	8178	8179
2728	2198	45	applied	\N	\N	\N	\N	8184	8184	8185
2728	2199	46	applied	\N	\N	\N	\N	8187	8187	8188
2728	2200	47	applied	\N	\N	\N	\N	8189	8189	8190
2728	2201	48	applied	\N	\N	\N	\N	8193	8193	8194
2728	2202	49	applied	\N	\N	\N	\N	8199	8199	8200
2728	2203	50	applied	\N	\N	\N	\N	8202	8202	8203
2728	2204	51	applied	\N	\N	\N	\N	8204	8204	8205
2728	2205	52	applied	\N	\N	\N	\N	8209	8209	8210
2728	2206	53	applied	\N	\N	\N	\N	8211	8211	8212
2728	2207	54	applied	\N	\N	\N	\N	8217	8217	8218
2728	2208	55	applied	\N	\N	\N	\N	8221	8221	8222
2728	2209	56	applied	\N	\N	\N	\N	8223	8223	8224
2728	2210	57	applied	\N	\N	\N	\N	8225	8225	8226
2728	2211	58	applied	\N	\N	\N	\N	8227	8227	8228
2728	2212	59	applied	\N	\N	\N	\N	8233	8233	8234
2728	2213	60	applied	\N	\N	\N	\N	8235	8235	8236
2728	2214	61	applied	\N	\N	\N	\N	8239	8239	8240
2728	2215	62	applied	\N	\N	\N	\N	8243	8243	8244
2728	2216	63	applied	\N	\N	\N	\N	8249	8249	8250
2728	2217	64	applied	\N	\N	\N	\N	8254	8254	8255
2728	2218	65	applied	\N	\N	\N	\N	8260	8260	8261
2728	2219	66	applied	\N	\N	\N	\N	8266	8266	8267
2728	2220	67	applied	\N	\N	\N	\N	8270	8270	8271
2728	2221	68	applied	\N	\N	\N	\N	8272	8272	8273
2728	2222	69	applied	\N	\N	\N	\N	8276	8276	8277
2728	2223	70	applied	\N	\N	\N	\N	8280	8280	8281
2662	2200	1	applied	\N	\N	\N	\N	8189	8189	8190
2664	2201	0	applied	\N	\N	\N	\N	8193	8193	8194
2669	2203	0	applied	\N	\N	\N	\N	8202	8202	8203
2669	2204	1	applied	\N	\N	\N	\N	8204	8204	8205
2673	2206	0	applied	\N	\N	\N	\N	8211	8211	8212
2676	2208	0	applied	\N	\N	\N	\N	8221	8221	8222
2676	2209	1	applied	\N	\N	\N	\N	8223	8223	8224
2676	2210	2	applied	\N	\N	\N	\N	8225	8225	8226
2676	2211	3	applied	\N	\N	\N	\N	8227	8227	8228
2679	2214	0	applied	\N	\N	\N	\N	8239	8239	8240
2682	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2682	2065	1	applied	\N	\N	\N	\N	5821	5821	7698
2682	2002	2	applied	\N	\N	\N	\N	7473	7473	7474
2682	2054	3	applied	\N	\N	1000000000	\N	7667	7667	7668
2682	2003	4	applied	\N	\N	\N	\N	7477	7477	7478
2682	2089	5	applied	\N	\N	1000000000	\N	7769	7769	7770
2682	2004	6	applied	\N	\N	\N	\N	7480	7480	7481
2682	2005	7	applied	\N	\N	\N	\N	7484	7484	7485
2682	2006	8	applied	\N	\N	\N	\N	7488	7488	7489
2682	2007	9	applied	\N	\N	\N	\N	7494	7494	7495
2682	2008	10	applied	\N	\N	\N	\N	7496	7496	7497
2682	2009	11	applied	\N	\N	\N	\N	7500	7500	7501
2682	2010	12	applied	\N	\N	\N	\N	7502	7502	7503
2682	2011	13	applied	\N	\N	\N	\N	7504	7504	7505
2682	2012	14	applied	\N	\N	\N	\N	7511	7511	7512
2682	2013	15	applied	\N	\N	\N	\N	7513	7513	7514
2682	2014	16	applied	\N	\N	\N	\N	7519	7519	7520
2682	2015	17	applied	\N	\N	\N	\N	7523	7523	7524
2682	2016	18	applied	\N	\N	\N	\N	7527	7527	7528
2682	2017	19	applied	\N	\N	\N	\N	7531	7531	7532
2682	2018	20	applied	\N	\N	\N	\N	7535	7535	7536
2682	2019	21	applied	\N	\N	\N	\N	7540	7540	7541
2682	2020	22	applied	\N	\N	\N	\N	7542	7542	7543
2682	2021	23	applied	\N	\N	\N	\N	7545	7545	7546
2682	2022	24	applied	\N	\N	\N	\N	7550	7550	7551
2682	2023	25	applied	\N	\N	\N	\N	7552	7552	7553
2682	2024	26	applied	\N	\N	\N	\N	7554	7554	7555
2682	2025	27	applied	\N	\N	\N	\N	7556	7556	7557
2682	2026	28	applied	\N	\N	\N	\N	7559	7559	7560
2682	2027	29	applied	\N	\N	\N	\N	7563	7563	7564
2682	2028	30	applied	\N	\N	\N	\N	7569	7569	7570
2682	2029	31	applied	\N	\N	\N	\N	7575	7575	7576
2682	2030	32	applied	\N	\N	\N	\N	7577	7577	7578
2682	2031	33	applied	\N	\N	\N	\N	7581	7581	7582
2682	2032	34	applied	\N	\N	\N	\N	7587	7587	7588
2682	2033	35	applied	\N	\N	\N	\N	7589	7589	7590
2682	2034	36	applied	\N	\N	\N	\N	7591	7591	7592
2682	2035	37	applied	\N	\N	\N	\N	7595	7595	7596
2682	2036	38	applied	\N	\N	\N	\N	7599	7599	7600
2682	2037	39	applied	\N	\N	\N	\N	7604	7604	7605
2682	2038	40	applied	\N	\N	\N	\N	7608	7608	7609
2682	2039	41	applied	\N	\N	\N	\N	7610	7610	7611
2682	2040	42	applied	\N	\N	\N	\N	7612	7612	7613
2682	2041	43	applied	\N	\N	\N	\N	7614	7614	7615
2682	2042	44	applied	\N	\N	\N	\N	7616	7616	7617
2682	2043	45	applied	\N	\N	\N	\N	7620	7620	7621
2682	2044	46	applied	\N	\N	\N	\N	7624	7624	7625
2682	2045	47	applied	\N	\N	\N	\N	7628	7628	7629
2682	2046	48	applied	\N	\N	\N	\N	7630	7630	7631
2682	2047	49	applied	\N	\N	\N	\N	7633	7633	7634
2682	2048	50	applied	\N	\N	\N	\N	7635	7635	7636
2682	2049	51	applied	\N	\N	\N	\N	7641	7641	7642
2682	2050	52	applied	\N	\N	\N	\N	7647	7647	7648
2682	2051	53	applied	\N	\N	\N	\N	7653	7653	7654
2682	2052	54	applied	\N	\N	\N	\N	7657	7657	7658
2682	2053	55	applied	\N	\N	\N	\N	7665	7665	7666
2682	2055	56	applied	\N	\N	\N	\N	7670	7670	7671
2682	2056	57	applied	\N	\N	\N	\N	7672	7672	7673
2682	2057	58	applied	\N	\N	\N	\N	7674	7674	7675
2682	2058	59	applied	\N	\N	\N	\N	7676	7676	7677
2682	2059	60	applied	\N	\N	\N	\N	7680	7680	7681
2682	2060	61	applied	\N	\N	\N	\N	7685	7685	7686
2682	2061	62	applied	\N	\N	\N	\N	7688	7688	7689
2682	2062	63	applied	\N	\N	\N	\N	7690	7690	7691
2682	2063	64	applied	\N	\N	\N	\N	7692	7692	7693
2682	2064	65	applied	\N	\N	\N	\N	7694	7694	7695
2682	2066	66	applied	\N	\N	\N	\N	7699	7699	7700
2682	2067	67	applied	\N	\N	\N	\N	7701	7701	7702
2682	2068	68	applied	\N	\N	\N	\N	7703	7703	7704
2682	2069	69	applied	\N	\N	\N	\N	7709	7709	7710
2682	2070	70	applied	\N	\N	\N	\N	7713	7713	7714
2682	2071	71	applied	\N	\N	\N	\N	7715	7715	7716
2682	2072	72	applied	\N	\N	\N	\N	7717	7717	7718
2682	2073	73	applied	\N	\N	\N	\N	7719	7719	7720
2682	2074	74	applied	\N	\N	\N	\N	7722	7722	7723
2682	2075	75	applied	\N	\N	\N	\N	7724	7724	7725
2682	2076	76	applied	\N	\N	\N	\N	7726	7726	7727
2682	2077	77	applied	\N	\N	\N	\N	7731	7731	7732
2682	2078	78	applied	\N	\N	\N	\N	7735	7735	7736
2682	2079	79	applied	\N	\N	\N	\N	7737	7737	7738
2682	2080	80	applied	\N	\N	\N	\N	7741	7741	7742
2682	2081	81	applied	\N	\N	\N	\N	7745	7745	7746
2682	2082	82	applied	\N	\N	\N	\N	7749	7749	7750
2682	2083	83	applied	\N	\N	\N	\N	7751	7751	7752
2682	2084	84	applied	\N	\N	\N	\N	7753	7753	7754
2682	2085	85	applied	\N	\N	\N	\N	7755	7755	7756
2682	2086	86	applied	\N	\N	\N	\N	7763	7763	7764
2682	2087	87	applied	\N	\N	\N	\N	7765	7765	7766
2682	2088	88	applied	\N	\N	\N	\N	7767	7767	7768
2682	2090	89	applied	\N	\N	\N	\N	7774	7774	7775
2682	2091	90	applied	\N	\N	\N	\N	7778	7778	7779
2682	2092	91	applied	\N	\N	\N	\N	7782	7782	7783
2682	2093	92	applied	\N	\N	\N	\N	7784	7784	7785
2682	2094	93	applied	\N	\N	\N	\N	7786	7786	7787
2685	2217	0	applied	\N	\N	\N	\N	8254	8254	8255
2688	2218	0	applied	\N	\N	\N	\N	8260	8260	8261
2691	2219	0	applied	\N	\N	\N	\N	8266	8266	8267
2694	2222	0	applied	\N	\N	\N	\N	8276	8276	8277
2697	2226	0	applied	\N	\N	\N	\N	8287	8287	8288
2700	2227	0	applied	\N	\N	\N	\N	8291	8291	8292
2703	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2703	2065	1	applied	\N	\N	\N	\N	5821	5821	7698
2703	2054	2	applied	\N	\N	1000000000	\N	7667	7667	7668
2703	2089	3	applied	\N	\N	1000000000	\N	7769	7769	7770
2703	2029	4	applied	\N	\N	\N	\N	7575	7575	7576
2703	2030	5	applied	\N	\N	\N	\N	7577	7577	7578
2703	2031	6	applied	\N	\N	\N	\N	7581	7581	7582
2703	2032	7	applied	\N	\N	\N	\N	7587	7587	7588
2703	2033	8	applied	\N	\N	\N	\N	7589	7589	7590
2703	2034	9	applied	\N	\N	\N	\N	7591	7591	7592
2703	2035	10	applied	\N	\N	\N	\N	7595	7595	7596
2703	2036	11	applied	\N	\N	\N	\N	7599	7599	7600
2703	2037	12	applied	\N	\N	\N	\N	7604	7604	7605
2703	2038	13	applied	\N	\N	\N	\N	7608	7608	7609
2703	2039	14	applied	\N	\N	\N	\N	7610	7610	7611
2703	2040	15	applied	\N	\N	\N	\N	7612	7612	7613
2703	2041	16	applied	\N	\N	\N	\N	7614	7614	7615
2703	2042	17	applied	\N	\N	\N	\N	7616	7616	7617
2703	2043	18	applied	\N	\N	\N	\N	7620	7620	7621
2703	2044	19	applied	\N	\N	\N	\N	7624	7624	7625
2703	2045	20	applied	\N	\N	\N	\N	7628	7628	7629
2703	2046	21	applied	\N	\N	\N	\N	7630	7630	7631
2703	2047	22	applied	\N	\N	\N	\N	7633	7633	7634
2703	2048	23	applied	\N	\N	\N	\N	7635	7635	7636
2703	2049	24	applied	\N	\N	\N	\N	7641	7641	7642
2703	2050	25	applied	\N	\N	\N	\N	7647	7647	7648
2703	2051	26	applied	\N	\N	\N	\N	7653	7653	7654
2703	2052	27	applied	\N	\N	\N	\N	7657	7657	7658
2703	2053	29	applied	\N	\N	\N	\N	7665	7665	7666
2703	2055	30	applied	\N	\N	\N	\N	7670	7670	7671
2703	2056	31	applied	\N	\N	\N	\N	7672	7672	7673
2703	2057	32	applied	\N	\N	\N	\N	7674	7674	7675
2703	2058	33	applied	\N	\N	\N	\N	7676	7676	7677
2703	2059	34	applied	\N	\N	\N	\N	7680	7680	7681
2703	2060	35	applied	\N	\N	\N	\N	7685	7685	7686
2703	2061	36	applied	\N	\N	\N	\N	7688	7688	7689
2703	2062	37	applied	\N	\N	\N	\N	7690	7690	7691
2703	2063	38	applied	\N	\N	\N	\N	7692	7692	7693
2703	2064	39	applied	\N	\N	\N	\N	7694	7694	7695
2703	2066	40	applied	\N	\N	\N	\N	7699	7699	7700
2703	2067	41	applied	\N	\N	\N	\N	7701	7701	7702
2703	2068	42	applied	\N	\N	\N	\N	7703	7703	7704
2703	2069	43	applied	\N	\N	\N	\N	7709	7709	7710
2703	2070	44	applied	\N	\N	\N	\N	7713	7713	7714
2703	2071	45	applied	\N	\N	\N	\N	7715	7715	7716
2703	2072	46	applied	\N	\N	\N	\N	7717	7717	7718
2703	2073	47	applied	\N	\N	\N	\N	7719	7719	7720
2703	2074	48	applied	\N	\N	\N	\N	7722	7722	7723
2703	2075	49	applied	\N	\N	\N	\N	7724	7724	7725
2703	2076	50	applied	\N	\N	\N	\N	7726	7726	7727
2703	2077	51	applied	\N	\N	\N	\N	7731	7731	7732
2703	2078	52	applied	\N	\N	\N	\N	7735	7735	7736
2703	2079	53	applied	\N	\N	\N	\N	7737	7737	7738
2703	2080	54	applied	\N	\N	\N	\N	7741	7741	7742
2703	2081	55	applied	\N	\N	\N	\N	7745	7745	7746
2703	2082	56	applied	\N	\N	\N	\N	7749	7749	7750
2703	2083	57	applied	\N	\N	\N	\N	7751	7751	7752
2703	2084	58	applied	\N	\N	\N	\N	7753	7753	7754
2703	2085	59	applied	\N	\N	\N	\N	7755	7755	7756
2703	2086	60	applied	\N	\N	\N	\N	7763	7763	7764
2703	2087	61	applied	\N	\N	\N	\N	7765	7765	7766
2703	2088	62	applied	\N	\N	\N	\N	7767	7767	7768
2703	2090	63	applied	\N	\N	\N	\N	7774	7774	7775
2703	2091	64	applied	\N	\N	\N	\N	7778	7778	7779
2703	2092	65	applied	\N	\N	\N	\N	7782	7782	7783
2703	2093	66	applied	\N	\N	\N	\N	7784	7784	7785
2703	2094	67	applied	\N	\N	\N	\N	7786	7786	7787
2703	2095	68	applied	\N	\N	\N	\N	7790	7790	7791
2703	2096	69	applied	\N	\N	\N	\N	7792	7792	7793
2703	2097	70	applied	\N	\N	\N	\N	7796	7796	7797
2703	2098	71	applied	\N	\N	\N	\N	7803	7803	7804
2703	2099	72	applied	\N	\N	\N	\N	7805	7805	7806
2703	2100	73	applied	\N	\N	\N	\N	7807	7807	7808
2703	2101	74	applied	\N	\N	\N	\N	7811	7811	7812
2703	2102	75	applied	\N	\N	\N	\N	7814	7814	7815
2703	2103	76	applied	\N	\N	\N	\N	7822	7822	7823
2703	2105	77	applied	\N	\N	\N	\N	7826	7826	7827
2703	2106	78	applied	\N	\N	\N	\N	7831	7831	7832
2703	2107	79	applied	\N	\N	\N	\N	7837	7837	7838
2703	2108	80	applied	\N	\N	\N	\N	7839	7839	7840
2703	2109	81	applied	\N	\N	\N	\N	7841	7841	7842
2703	2110	82	applied	\N	\N	\N	\N	7845	7845	7846
2703	2111	83	applied	\N	\N	\N	\N	7851	7851	7852
2703	2112	84	applied	\N	\N	\N	\N	7853	7853	7854
2703	2113	85	applied	\N	\N	\N	\N	7855	7855	7856
2703	2114	86	applied	\N	\N	\N	\N	7857	7857	7858
2703	2115	87	applied	\N	\N	\N	\N	7861	7861	7862
2703	2116	88	applied	\N	\N	\N	\N	7865	7865	7866
2703	2117	89	applied	\N	\N	\N	\N	7867	7867	7868
2703	2118	90	applied	\N	\N	\N	\N	7870	7870	7871
2703	2119	91	applied	\N	\N	\N	\N	7876	7876	7877
2703	2120	92	applied	\N	\N	\N	\N	7878	7878	7879
2703	2121	93	applied	\N	\N	\N	\N	7884	7884	7885
2703	2122	94	applied	\N	\N	\N	\N	7888	7888	7889
2703	2123	95	applied	\N	\N	\N	\N	7890	7890	7891
2703	2124	96	applied	\N	\N	\N	\N	7894	7894	7895
2703	2125	97	applied	\N	\N	\N	\N	7896	7896	7897
2703	2126	98	applied	\N	\N	\N	\N	7900	7900	7901
2703	2127	99	applied	\N	\N	\N	\N	7902	7902	7903
2703	2128	100	applied	\N	\N	\N	\N	7913	7913	7914
2703	2129	101	applied	\N	\N	\N	\N	7917	7917	7918
2703	2130	102	applied	\N	\N	\N	\N	7921	7921	7922
2703	2131	103	applied	\N	\N	\N	\N	7932	7932	7933
2703	2132	104	applied	\N	\N	\N	\N	7934	7934	7935
2703	2133	105	applied	\N	\N	\N	\N	7937	7937	7938
2703	2134	106	applied	\N	\N	\N	\N	7939	7939	7940
2703	2135	107	applied	\N	\N	\N	\N	7943	7943	7944
2703	2136	108	applied	\N	\N	\N	\N	7945	7945	7946
2703	2137	109	applied	\N	\N	\N	\N	7949	7949	7950
2703	2138	110	applied	\N	\N	\N	\N	7951	7951	7952
2703	2139	111	applied	\N	\N	\N	\N	7955	7955	7956
2703	2140	112	applied	\N	\N	\N	\N	7959	7959	7960
2703	2141	113	applied	\N	\N	\N	\N	7965	7965	7966
2703	2142	114	applied	\N	\N	\N	\N	7967	7967	7968
2703	2143	115	applied	\N	\N	\N	\N	7969	7969	7970
2703	2144	116	applied	\N	\N	\N	\N	7975	7975	7976
2703	2145	117	applied	\N	\N	\N	\N	7979	7979	7980
2703	2146	118	applied	\N	\N	\N	\N	7989	7989	7990
2703	2147	119	applied	\N	\N	\N	\N	7995	7995	7996
2703	2148	120	applied	\N	\N	\N	\N	7997	7997	7998
2703	2149	121	applied	\N	\N	\N	\N	8002	8002	8003
2703	2150	122	applied	\N	\N	\N	\N	8004	8004	8005
2703	2151	123	applied	\N	\N	\N	\N	8011	8011	8012
2703	2152	124	applied	\N	\N	\N	\N	8013	8013	8014
2703	2153	125	applied	\N	\N	\N	\N	8019	8019	8020
2706	2231	0	applied	\N	\N	\N	\N	8312	8312	8313
2709	2232	0	applied	\N	\N	\N	\N	8318	8318	8319
2712	2233	0	applied	\N	\N	\N	\N	8322	8322	8323
2715	2235	0	applied	\N	\N	\N	\N	8331	8331	8332
2715	2236	1	applied	\N	\N	\N	\N	8333	8333	8334
2715	2237	2	applied	\N	\N	\N	\N	8335	8335	8336
2718	2239	0	applied	\N	\N	\N	\N	8341	8341	8342
2721	2240	0	applied	\N	\N	\N	\N	8347	8347	8348
2721	2241	1	applied	\N	\N	\N	\N	8349	8349	8350
2727	2244	0	applied	\N	\N	\N	\N	8363	8363	8364
2727	2245	1	applied	\N	\N	\N	\N	8365	8365	8366
2728	2224	71	applied	\N	\N	\N	\N	8282	8282	8283
2728	2225	72	applied	\N	\N	\N	\N	8285	8285	8286
2728	2226	73	applied	\N	\N	\N	\N	8287	8287	8288
2728	2227	74	applied	\N	\N	\N	\N	8291	8291	8292
2728	2228	75	applied	\N	\N	\N	\N	8302	8302	8303
2728	2229	76	applied	\N	\N	\N	\N	8304	8304	8305
2728	2230	77	applied	\N	\N	\N	\N	8308	8308	8309
2728	2231	78	applied	\N	\N	\N	\N	8312	8312	8313
2728	2232	79	applied	\N	\N	\N	\N	8318	8318	8319
2728	2233	80	applied	\N	\N	\N	\N	8322	8322	8323
2728	2234	81	applied	\N	\N	\N	\N	8327	8327	8328
2728	2235	82	applied	\N	\N	\N	\N	8331	8331	8332
2728	2236	83	applied	\N	\N	\N	\N	8333	8333	8334
2728	2237	84	applied	\N	\N	\N	\N	8335	8335	8336
2728	2238	85	applied	\N	\N	\N	\N	8339	8339	8340
2728	2239	86	applied	\N	\N	\N	\N	8341	8341	8342
2728	2240	87	applied	\N	\N	\N	\N	8347	8347	8348
2728	2241	88	applied	\N	\N	\N	\N	8349	8349	8350
2728	2242	89	applied	\N	\N	\N	\N	8353	8353	8354
2728	2243	90	applied	\N	\N	\N	\N	8359	8359	8360
2728	2244	91	applied	\N	\N	\N	\N	8363	8363	8364
2728	2245	92	applied	\N	\N	\N	\N	8365	8365	8366
2729	2246	0	applied	\N	\N	\N	\N	8375	8375	8376
2730	2247	0	applied	\N	\N	\N	\N	8379	8379	8380
2731	2248	0	applied	\N	\N	\N	\N	8382	8382	8383
2731	2249	1	applied	\N	\N	\N	\N	8384	8384	8385
2732	2248	0	applied	\N	\N	\N	\N	8382	8382	8383
2732	2249	1	applied	\N	\N	\N	\N	8384	8384	8385
2733	2250	0	applied	\N	\N	\N	\N	8390	8390	8391
2734	2251	0	applied	\N	\N	\N	\N	8392	8392	8393
2734	2252	1	applied	\N	\N	\N	\N	8394	8394	8395
2735	2251	0	applied	\N	\N	\N	\N	8392	8392	8393
2735	2252	1	applied	\N	\N	\N	\N	8394	8394	8395
2736	2253	0	applied	\N	\N	\N	\N	8399	8399	8400
2737	2253	0	applied	\N	\N	\N	\N	8399	8399	8400
2738	2253	0	applied	\N	\N	\N	\N	8399	8399	8400
2739	2254	0	applied	\N	\N	\N	\N	8405	8405	8406
2740	2254	0	applied	\N	\N	\N	\N	8405	8405	8406
2741	2255	0	applied	\N	\N	\N	\N	8410	8410	8411
2741	2256	1	applied	\N	\N	\N	\N	8412	8412	8413
2742	2255	0	applied	\N	\N	\N	\N	8410	8410	8411
2742	2256	1	applied	\N	\N	\N	\N	8412	8412	8413
2743	2187	0	applied	\N	\N	\N	\N	8140	8140	8141
2743	2188	1	applied	\N	\N	\N	\N	8146	8146	8147
2743	2189	2	applied	\N	\N	\N	\N	8150	8150	8151
2743	2190	3	applied	\N	\N	\N	\N	8152	8152	8153
2743	2191	4	applied	\N	\N	\N	\N	8154	8154	8155
2743	2192	5	applied	\N	\N	\N	\N	8161	8161	8162
2743	2193	6	applied	\N	\N	\N	\N	8163	8163	8164
2743	2194	7	applied	\N	\N	\N	\N	8165	8165	8166
2743	2195	8	applied	\N	\N	\N	\N	8167	8167	8168
2743	2196	9	applied	\N	\N	\N	\N	8169	8169	8170
2743	2197	10	applied	\N	\N	\N	\N	8178	8178	8179
2743	2198	11	applied	\N	\N	\N	\N	8184	8184	8185
2743	2199	12	applied	\N	\N	\N	\N	8187	8187	8188
2743	2200	13	applied	\N	\N	\N	\N	8189	8189	8190
2743	2201	14	applied	\N	\N	\N	\N	8193	8193	8194
2743	2202	15	applied	\N	\N	\N	\N	8199	8199	8200
2743	2203	16	applied	\N	\N	\N	\N	8202	8202	8203
2743	2204	17	applied	\N	\N	\N	\N	8204	8204	8205
2743	2205	18	applied	\N	\N	\N	\N	8209	8209	8210
2743	2206	19	applied	\N	\N	\N	\N	8211	8211	8212
2743	2207	20	applied	\N	\N	\N	\N	8217	8217	8218
2743	2208	21	applied	\N	\N	\N	\N	8221	8221	8222
2743	2209	22	applied	\N	\N	\N	\N	8223	8223	8224
2743	2210	23	applied	\N	\N	\N	\N	8225	8225	8226
2743	2211	24	applied	\N	\N	\N	\N	8227	8227	8228
2743	2212	25	applied	\N	\N	\N	\N	8233	8233	8234
2743	2213	26	applied	\N	\N	\N	\N	8235	8235	8236
2743	2214	27	applied	\N	\N	\N	\N	8239	8239	8240
2743	2215	28	applied	\N	\N	\N	\N	8243	8243	8244
2743	2216	29	applied	\N	\N	\N	\N	8249	8249	8250
2743	2217	30	applied	\N	\N	\N	\N	8254	8254	8255
2743	2218	31	applied	\N	\N	\N	\N	8260	8260	8261
2743	2219	32	applied	\N	\N	\N	\N	8266	8266	8267
2743	2220	33	applied	\N	\N	\N	\N	8270	8270	8271
2743	2221	34	applied	\N	\N	\N	\N	8272	8272	8273
2743	2222	35	applied	\N	\N	\N	\N	8276	8276	8277
2743	2223	36	applied	\N	\N	\N	\N	8280	8280	8281
2743	2224	37	applied	\N	\N	\N	\N	8282	8282	8283
2743	2225	38	applied	\N	\N	\N	\N	8285	8285	8286
2743	2226	39	applied	\N	\N	\N	\N	8287	8287	8288
2743	2227	40	applied	\N	\N	\N	\N	8291	8291	8292
2743	2228	41	applied	\N	\N	\N	\N	8302	8302	8303
2743	2229	42	applied	\N	\N	\N	\N	8304	8304	8305
2743	2230	43	applied	\N	\N	\N	\N	8308	8308	8309
2743	2231	44	applied	\N	\N	\N	\N	8312	8312	8313
2743	2232	45	applied	\N	\N	\N	\N	8318	8318	8319
2743	2233	46	applied	\N	\N	\N	\N	8322	8322	8323
2743	2234	47	applied	\N	\N	\N	\N	8327	8327	8328
2743	2235	49	applied	\N	\N	\N	\N	8331	8331	8332
2743	2236	50	applied	\N	\N	\N	\N	8333	8333	8334
2743	2237	51	applied	\N	\N	\N	\N	8335	8335	8336
2743	2238	52	applied	\N	\N	\N	\N	8339	8339	8340
2743	2239	53	applied	\N	\N	\N	\N	8341	8341	8342
2743	2240	54	applied	\N	\N	\N	\N	8347	8347	8348
2743	2241	55	applied	\N	\N	\N	\N	8349	8349	8350
2743	2242	56	applied	\N	\N	\N	\N	8353	8353	8354
2743	2243	57	applied	\N	\N	\N	\N	8359	8359	8360
2743	2244	58	applied	\N	\N	\N	\N	8363	8363	8364
2743	2245	59	applied	\N	\N	\N	\N	8365	8365	8366
2743	2246	60	applied	\N	\N	\N	\N	8375	8375	8376
2743	2247	61	applied	\N	\N	\N	\N	8379	8379	8380
2743	2248	62	applied	\N	\N	\N	\N	8382	8382	8383
2743	2249	63	applied	\N	\N	\N	\N	8384	8384	8385
2743	2250	64	applied	\N	\N	\N	\N	8390	8390	8391
2743	2251	65	applied	\N	\N	\N	\N	8392	8392	8393
2743	2252	66	applied	\N	\N	\N	\N	8394	8394	8395
2743	2253	67	applied	\N	\N	\N	\N	8399	8399	8400
2743	2254	68	applied	\N	\N	\N	\N	8405	8405	8406
2743	2255	69	applied	\N	\N	\N	\N	8410	8410	8411
2743	2256	70	applied	\N	\N	\N	\N	8412	8412	8413
2744	2257	0	applied	\N	\N	\N	\N	8419	8419	8420
2745	2257	0	applied	\N	\N	\N	\N	8419	8419	8420
2746	2257	0	applied	\N	\N	\N	\N	8419	8419	8420
2747	2257	0	applied	\N	\N	\N	\N	8419	8419	8420
2749	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2750	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2753	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2755	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2755	2259	1	applied	\N	\N	\N	\N	8434	8434	8435
2757	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2757	2259	1	applied	\N	\N	\N	\N	8434	8434	8435
2758	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2758	2259	1	applied	\N	\N	\N	\N	8434	8434	8435
2762	2264	0	applied	\N	\N	\N	\N	8464	8464	8465
2765	2265	0	applied	\N	\N	\N	\N	8470	8470	8471
2770	2271	0	applied	\N	\N	\N	\N	8485	8485	8486
2773	2274	0	applied	\N	\N	\N	\N	8495	8495	8496
2776	2276	0	applied	\N	\N	\N	\N	8499	8499	8500
2776	2277	1	applied	\N	\N	\N	\N	8501	8501	8502
2778	2276	0	applied	\N	\N	\N	\N	8499	8499	8500
2778	2277	1	applied	\N	\N	\N	\N	8501	8501	8502
2779	2278	0	applied	\N	\N	\N	\N	8506	8506	8507
2779	2279	1	applied	\N	\N	\N	\N	8508	8508	8509
2785	2283	0	applied	\N	\N	\N	\N	8523	8523	8524
2791	2287	0	applied	\N	\N	\N	\N	8542	8542	8543
2794	2288	0	applied	\N	\N	\N	\N	8546	8546	8547
2797	2289	0	applied	\N	\N	\N	\N	8550	8550	8551
2800	2290	0	applied	\N	\N	\N	\N	8558	8558	8559
2800	2291	1	applied	\N	\N	\N	\N	8560	8560	8561
2800	2292	2	applied	\N	\N	\N	\N	8562	8562	8563
2800	2293	3	applied	\N	\N	\N	\N	8564	8564	8565
2802	2294	0	applied	\N	\N	\N	\N	8571	8571	8572
2802	2295	1	applied	\N	\N	\N	\N	8573	8573	8574
2802	2296	2	applied	\N	\N	\N	\N	8575	8575	8576
2803	2294	0	applied	\N	\N	\N	\N	8571	8571	8572
2803	2295	1	applied	\N	\N	\N	\N	8573	8573	8574
2803	2296	2	applied	\N	\N	\N	\N	8575	8575	8576
2805	2294	0	applied	\N	\N	\N	\N	8571	8571	8572
2805	2295	1	applied	\N	\N	\N	\N	8573	8573	8574
2805	2296	2	applied	\N	\N	\N	\N	8575	8575	8576
2806	2297	0	applied	\N	\N	\N	\N	8588	8588	8589
2809	2300	0	applied	\N	\N	\N	\N	8599	8599	8600
2812	2303	0	applied	\N	\N	\N	\N	8607	8607	8608
2815	2304	0	applied	\N	\N	\N	\N	8611	8611	8612
2829	2311	0	applied	\N	\N	\N	\N	8631	8631	8632
2829	2312	1	applied	\N	\N	\N	\N	8633	8633	8634
2829	2313	2	applied	\N	\N	\N	\N	8635	8635	8636
2829	2314	3	applied	\N	\N	\N	\N	8637	8637	8638
2829	2315	4	applied	\N	\N	\N	\N	8639	8639	8640
2829	2316	5	applied	\N	\N	\N	\N	8641	8641	8642
2829	2317	6	applied	\N	\N	\N	\N	8643	8643	8644
2829	2318	7	applied	\N	\N	\N	\N	8645	8645	8646
2832	2319	0	applied	\N	\N	\N	\N	8651	8651	8652
2832	2320	1	applied	\N	\N	\N	\N	8653	8653	8654
2834	2321	0	applied	\N	\N	\N	\N	8657	8657	8658
2838	2326	0	applied	\N	\N	\N	\N	8670	8670	8671
2838	2327	1	applied	\N	\N	\N	\N	8672	8672	8673
2838	2328	2	applied	\N	\N	\N	\N	8674	8674	8675
2841	2330	0	applied	\N	\N	\N	\N	8682	8682	8683
2841	2331	1	applied	\N	\N	\N	\N	8684	8684	8685
2844	2335	0	applied	\N	\N	\N	\N	8697	8697	8698
2847	2337	0	applied	\N	\N	\N	\N	8706	8706	8707
2847	2338	1	applied	\N	\N	\N	\N	8708	8708	8709
2850	2340	0	applied	\N	\N	\N	\N	8715	8715	8716
2856	2343	0	applied	\N	\N	\N	\N	8730	8730	8731
2856	2344	1	applied	\N	\N	\N	\N	8732	8732	8733
2856	2345	2	applied	\N	\N	\N	\N	8734	8734	8735
2858	2343	0	applied	\N	\N	\N	\N	8730	8730	8731
2858	2344	1	applied	\N	\N	\N	\N	8732	8732	8733
2858	2345	2	applied	\N	\N	\N	\N	8734	8734	8735
2859	2345	0	applied	\N	\N	\N	\N	8734	8734	8735
2862	2207	0	applied	\N	\N	\N	\N	8217	8217	8218
2863	2347	0	applied	\N	\N	\N	\N	8747	8747	8748
2863	2348	1	applied	\N	\N	\N	\N	8749	8749	8750
2866	2350	0	applied	\N	\N	\N	\N	8756	8756	8757
2866	2351	1	applied	\N	\N	\N	\N	8758	8758	8759
2866	2352	2	applied	\N	\N	\N	\N	8760	8760	8761
2869	2353	0	applied	\N	\N	\N	\N	8767	8767	8768
2872	2353	0	applied	\N	\N	\N	\N	8767	8767	8768
2872	2354	1	applied	\N	\N	\N	\N	8771	8771	8772
2875	2356	0	applied	\N	\N	\N	\N	8777	8777	8778
2878	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2881	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2881	2358	1	applied	\N	\N	\N	\N	8783	8783	8784
2883	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2883	2358	1	applied	\N	\N	\N	\N	8783	8783	8784
2884	2359	0	applied	\N	\N	\N	\N	8789	8789	8790
2886	2359	0	applied	\N	\N	\N	\N	8789	8789	8790
2887	2360	0	applied	\N	\N	\N	\N	8793	8793	8794
2890	2362	0	applied	\N	\N	\N	\N	8803	8803	8804
2892	2362	0	applied	\N	\N	\N	\N	8803	8803	8804
2896	2366	0	applied	\N	\N	\N	\N	8821	8821	8822
2896	2367	1	applied	\N	\N	\N	\N	8823	8823	8824
2899	2369	0	applied	\N	\N	\N	\N	8830	8830	8831
2902	2370	0	applied	\N	\N	\N	\N	8835	8835	8836
2906	2372	0	applied	\N	\N	\N	\N	8841	8841	8842
2906	2373	1	applied	\N	\N	\N	\N	8843	8843	8844
2906	2374	2	applied	\N	\N	\N	\N	8845	8845	8846
2906	2375	3	applied	\N	\N	\N	\N	8847	8847	8848
2909	2372	0	applied	\N	\N	\N	\N	8841	8841	8842
2909	2373	1	applied	\N	\N	\N	\N	8843	8843	8844
2909	2374	2	applied	\N	\N	\N	\N	8845	8845	8846
2909	2375	3	applied	\N	\N	\N	\N	8847	8847	8848
2756	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2760	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2760	2065	1	applied	\N	\N	\N	\N	5821	5821	7698
2760	2054	2	applied	\N	\N	1000000000	\N	7667	7667	7668
2760	2089	3	applied	\N	\N	1000000000	\N	8440	8440	7770
2760	2050	4	applied	\N	\N	\N	\N	7647	7647	7648
2760	2051	5	applied	\N	\N	\N	\N	7653	7653	7654
2760	2052	6	applied	\N	\N	\N	\N	7657	7657	7658
2760	2053	7	applied	\N	\N	\N	\N	7665	7665	7666
2760	2055	8	applied	\N	\N	\N	\N	7670	7670	7671
2760	2056	9	applied	\N	\N	\N	\N	7672	7672	7673
2760	2057	10	applied	\N	\N	\N	\N	7674	7674	7675
2760	2058	11	applied	\N	\N	\N	\N	7676	7676	7677
2760	2059	12	applied	\N	\N	\N	\N	7680	7680	7681
2760	2060	13	applied	\N	\N	\N	\N	7685	7685	7686
2760	2061	14	applied	\N	\N	\N	\N	7688	7688	7689
2760	2062	15	applied	\N	\N	\N	\N	7690	7690	7691
2760	2063	16	applied	\N	\N	\N	\N	7692	7692	7693
2760	2064	17	applied	\N	\N	\N	\N	7694	7694	7695
2760	2066	18	applied	\N	\N	\N	\N	7699	7699	7700
2760	2067	19	applied	\N	\N	\N	\N	7701	7701	7702
2760	2068	20	applied	\N	\N	\N	\N	7703	7703	7704
2760	2069	21	applied	\N	\N	\N	\N	7709	7709	7710
2760	2070	22	applied	\N	\N	\N	\N	7713	7713	7714
2760	2071	23	applied	\N	\N	\N	\N	7715	7715	7716
2760	2072	24	applied	\N	\N	\N	\N	7717	7717	7718
2760	2073	25	applied	\N	\N	\N	\N	7719	7719	7720
2760	2074	26	applied	\N	\N	\N	\N	7722	7722	7723
2760	2075	27	applied	\N	\N	\N	\N	7724	7724	7725
2760	2076	28	applied	\N	\N	\N	\N	7726	7726	7727
2760	2077	29	applied	\N	\N	\N	\N	7731	7731	7732
2760	2078	30	applied	\N	\N	\N	\N	7735	7735	7736
2760	2079	31	applied	\N	\N	\N	\N	7737	7737	7738
2760	2080	32	applied	\N	\N	\N	\N	7741	7741	7742
2760	2081	33	applied	\N	\N	\N	\N	7745	7745	7746
2760	2082	34	applied	\N	\N	\N	\N	7749	7749	7750
2760	2083	35	applied	\N	\N	\N	\N	7751	7751	7752
2760	2084	36	applied	\N	\N	\N	\N	7753	7753	7754
2760	2085	37	applied	\N	\N	\N	\N	7755	7755	7756
2760	2086	38	applied	\N	\N	\N	\N	7763	7763	7764
2760	2087	39	applied	\N	\N	\N	\N	7765	7765	7766
2760	2088	40	applied	\N	\N	\N	\N	7767	7767	7768
2760	2090	41	applied	\N	\N	\N	\N	7774	7774	7775
2760	2091	42	applied	\N	\N	\N	\N	7778	7778	7779
2760	2092	43	applied	\N	\N	\N	\N	7782	7782	7783
2760	2093	44	applied	\N	\N	\N	\N	7784	7784	7785
2760	2094	45	applied	\N	\N	\N	\N	7786	7786	7787
2760	2095	46	applied	\N	\N	\N	\N	7790	7790	7791
2760	2096	47	applied	\N	\N	\N	\N	7792	7792	7793
2760	2097	48	applied	\N	\N	\N	\N	7796	7796	7797
2760	2098	49	applied	\N	\N	\N	\N	7803	7803	7804
2760	2099	50	applied	\N	\N	\N	\N	7805	7805	7806
2760	2100	51	applied	\N	\N	\N	\N	7807	7807	7808
2760	2101	52	applied	\N	\N	\N	\N	7811	7811	7812
2760	2102	53	applied	\N	\N	\N	\N	7814	7814	7815
2760	2103	54	applied	\N	\N	\N	\N	7822	7822	7823
2760	2105	55	applied	\N	\N	\N	\N	7826	7826	7827
2760	2106	56	applied	\N	\N	\N	\N	7831	7831	7832
2760	2107	57	applied	\N	\N	\N	\N	7837	7837	7838
2760	2108	58	applied	\N	\N	\N	\N	7839	7839	7840
2760	2109	59	applied	\N	\N	\N	\N	7841	7841	7842
2760	2110	60	applied	\N	\N	\N	\N	7845	7845	7846
2760	2111	61	applied	\N	\N	\N	\N	7851	7851	7852
2760	2112	62	applied	\N	\N	\N	\N	7853	7853	7854
2760	2113	63	applied	\N	\N	\N	\N	7855	7855	7856
2760	2114	64	applied	\N	\N	\N	\N	7857	7857	7858
2760	2115	65	applied	\N	\N	\N	\N	7861	7861	7862
2760	2116	66	applied	\N	\N	\N	\N	7865	7865	7866
2760	2117	67	applied	\N	\N	\N	\N	7867	7867	7868
2760	2118	68	applied	\N	\N	\N	\N	7870	7870	7871
2760	2119	69	applied	\N	\N	\N	\N	7876	7876	7877
2760	2120	70	applied	\N	\N	\N	\N	7878	7878	7879
2760	2121	71	applied	\N	\N	\N	\N	7884	7884	7885
2760	2122	72	applied	\N	\N	\N	\N	7888	7888	7889
2760	2123	73	applied	\N	\N	\N	\N	7890	7890	7891
2760	2124	74	applied	\N	\N	\N	\N	7894	7894	7895
2760	2125	75	applied	\N	\N	\N	\N	7896	7896	7897
2760	2126	76	applied	\N	\N	\N	\N	7900	7900	7901
2760	2127	77	applied	\N	\N	\N	\N	7902	7902	7903
2760	2128	78	applied	\N	\N	\N	\N	7913	7913	7914
2760	2129	79	applied	\N	\N	\N	\N	7917	7917	7918
2760	2130	80	applied	\N	\N	\N	\N	7921	7921	7922
2760	2131	81	applied	\N	\N	\N	\N	7932	7932	7933
2760	2132	82	applied	\N	\N	\N	\N	7934	7934	7935
2760	2133	83	applied	\N	\N	\N	\N	7937	7937	7938
2760	2134	84	applied	\N	\N	\N	\N	7939	7939	7940
2760	2135	85	applied	\N	\N	\N	\N	7943	7943	7944
2760	2136	86	applied	\N	\N	\N	\N	7945	7945	7946
2760	2137	87	applied	\N	\N	\N	\N	7949	7949	7950
2760	2138	88	applied	\N	\N	\N	\N	7951	7951	7952
2760	2139	89	applied	\N	\N	\N	\N	7955	7955	7956
2760	2140	90	applied	\N	\N	\N	\N	7959	7959	7960
2760	2141	91	applied	\N	\N	\N	\N	7965	7965	7966
2760	2142	92	applied	\N	\N	\N	\N	7967	7967	7968
2760	2143	93	applied	\N	\N	\N	\N	7969	7969	7970
2760	2144	94	applied	\N	\N	\N	\N	7975	7975	7976
2760	2145	95	applied	\N	\N	\N	\N	7979	7979	7980
2760	2146	96	applied	\N	\N	\N	\N	7989	7989	7990
2760	2147	97	applied	\N	\N	\N	\N	7995	7995	7996
2760	2148	98	applied	\N	\N	\N	\N	7997	7997	7998
2760	2149	99	applied	\N	\N	\N	\N	8002	8002	8003
2760	2150	100	applied	\N	\N	\N	\N	8004	8004	8005
2760	2151	101	applied	\N	\N	\N	\N	8011	8011	8012
2760	2152	102	applied	\N	\N	\N	\N	8013	8013	8014
2760	2153	103	applied	\N	\N	\N	\N	8019	8019	8020
2760	2154	104	applied	\N	\N	\N	\N	8022	8022	8023
2760	2155	105	applied	\N	\N	\N	\N	8024	8024	8025
2760	2156	106	applied	\N	\N	\N	\N	8032	8032	8033
2760	2157	107	applied	\N	\N	\N	\N	8034	8034	8035
2760	2158	108	applied	\N	\N	\N	\N	8038	8038	8039
2760	2159	109	applied	\N	\N	\N	\N	8045	8045	8046
2760	2160	110	applied	\N	\N	\N	\N	8047	8047	8048
2760	2161	111	applied	\N	\N	\N	\N	8052	8052	8053
2760	2162	112	applied	\N	\N	\N	\N	8055	8055	8056
2760	2163	113	applied	\N	\N	\N	\N	8057	8057	8058
2760	2164	114	applied	\N	\N	\N	\N	8059	8059	8060
2760	2165	115	applied	\N	\N	\N	\N	8061	8061	8062
2760	2166	116	applied	\N	\N	\N	\N	8063	8063	8064
2760	2167	122	applied	\N	\N	\N	\N	8068	8068	8069
2759	2258	0	applied	\N	\N	\N	\N	8429	8429	8430
2759	2259	1	applied	\N	\N	\N	\N	8434	8434	8435
2763	2264	0	applied	\N	\N	\N	\N	8464	8464	8465
2769	2270	0	applied	\N	\N	\N	\N	8481	8481	8482
2771	2272	0	applied	\N	\N	\N	\N	8489	8489	8490
2774	2275	0	applied	\N	\N	\N	\N	8497	8497	8498
2780	2278	0	applied	\N	\N	\N	\N	8506	8506	8507
2780	2279	1	applied	\N	\N	\N	\N	8508	8508	8509
2783	2281	0	applied	\N	\N	\N	\N	8517	8517	8518
2786	2283	0	applied	\N	\N	\N	\N	8523	8523	8524
2788	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2788	2101	1	applied	\N	\N	\N	\N	7811	7811	7812
2788	2102	2	applied	\N	\N	\N	\N	7814	7814	7815
2788	2285	3	applied	\N	\N	\N	\N	8533	8533	8532
2788	2103	4	applied	\N	\N	\N	\N	7822	7822	7823
2788	2105	5	applied	\N	\N	\N	\N	7826	7826	7827
2788	2106	6	applied	\N	\N	\N	\N	7831	7831	7832
2788	2107	7	applied	\N	\N	\N	\N	7837	7837	7838
2788	2108	8	applied	\N	\N	\N	\N	7839	7839	7840
2788	2109	9	applied	\N	\N	\N	\N	7841	7841	7842
2788	2110	10	applied	\N	\N	\N	\N	7845	7845	7846
2788	2111	11	applied	\N	\N	\N	\N	7851	7851	7852
2788	2112	12	applied	\N	\N	\N	\N	7853	7853	7854
2788	2113	13	applied	\N	\N	\N	\N	7855	7855	7856
2788	2114	14	applied	\N	\N	\N	\N	7857	7857	7858
2788	2115	15	applied	\N	\N	\N	\N	7861	7861	7862
2788	2116	16	applied	\N	\N	\N	\N	7865	7865	7866
2788	2117	17	applied	\N	\N	\N	\N	7867	7867	7868
2788	2118	18	applied	\N	\N	\N	\N	7870	7870	7871
2788	2119	19	applied	\N	\N	\N	\N	7876	7876	7877
2788	2120	20	applied	\N	\N	\N	\N	7878	7878	7879
2788	2121	21	applied	\N	\N	\N	\N	7884	7884	7885
2788	2122	22	applied	\N	\N	\N	\N	7888	7888	7889
2788	2123	23	applied	\N	\N	\N	\N	7890	7890	7891
2788	2124	24	applied	\N	\N	\N	\N	7894	7894	7895
2788	2125	25	applied	\N	\N	\N	\N	7896	7896	7897
2788	2126	26	applied	\N	\N	\N	\N	7900	7900	7901
2788	2127	27	applied	\N	\N	\N	\N	7902	7902	7903
2788	2128	28	applied	\N	\N	\N	\N	7913	7913	7914
2788	2129	29	applied	\N	\N	\N	\N	7917	7917	7918
2788	2130	30	applied	\N	\N	\N	\N	7921	7921	7922
2788	2131	31	applied	\N	\N	\N	\N	7932	7932	7933
2788	2132	32	applied	\N	\N	\N	\N	7934	7934	7935
2788	2133	33	applied	\N	\N	\N	\N	7937	7937	7938
2788	2134	34	applied	\N	\N	\N	\N	7939	7939	7940
2788	2135	35	applied	\N	\N	\N	\N	7943	7943	7944
2788	2136	36	applied	\N	\N	\N	\N	7945	7945	7946
2788	2137	37	applied	\N	\N	\N	\N	7949	7949	7950
2788	2138	38	applied	\N	\N	\N	\N	7951	7951	7952
2788	2139	39	applied	\N	\N	\N	\N	7955	7955	7956
2788	2140	40	applied	\N	\N	\N	\N	7959	7959	7960
2788	2141	41	applied	\N	\N	\N	\N	7965	7965	7966
2788	2142	42	applied	\N	\N	\N	\N	7967	7967	7968
2788	2143	43	applied	\N	\N	\N	\N	7969	7969	7970
2788	2144	44	applied	\N	\N	\N	\N	7975	7975	7976
2788	2145	45	applied	\N	\N	\N	\N	7979	7979	7980
2788	2146	46	applied	\N	\N	\N	\N	7989	7989	7990
2788	2147	47	applied	\N	\N	\N	\N	7995	7995	7996
2788	2148	48	applied	\N	\N	\N	\N	7997	7997	7998
2788	2149	49	applied	\N	\N	\N	\N	8002	8002	8003
2788	2150	50	applied	\N	\N	\N	\N	8004	8004	8005
2788	2151	51	applied	\N	\N	\N	\N	8011	8011	8012
2788	2152	52	applied	\N	\N	\N	\N	8013	8013	8014
2788	2153	53	applied	\N	\N	\N	\N	8019	8019	8020
2788	2154	54	applied	\N	\N	\N	\N	8022	8022	8023
2788	2155	55	applied	\N	\N	\N	\N	8024	8024	8025
2788	2156	56	applied	\N	\N	\N	\N	8032	8032	8033
2788	2157	57	applied	\N	\N	\N	\N	8034	8034	8035
2788	2158	58	applied	\N	\N	\N	\N	8038	8038	8039
2788	2159	59	applied	\N	\N	\N	\N	8045	8045	8046
2788	2160	60	applied	\N	\N	\N	\N	8047	8047	8048
2788	2161	61	applied	\N	\N	\N	\N	8052	8052	8053
2788	2162	62	applied	\N	\N	\N	\N	8055	8055	8056
2788	2163	63	applied	\N	\N	\N	\N	8057	8057	8058
2788	2164	64	applied	\N	\N	\N	\N	8059	8059	8060
2788	2165	65	applied	\N	\N	\N	\N	8061	8061	8062
2788	2166	66	applied	\N	\N	\N	\N	8063	8063	8064
2788	2167	67	applied	\N	\N	\N	\N	8068	8068	8069
2788	2168	68	applied	\N	\N	\N	\N	8072	8072	8073
2788	2169	69	applied	\N	\N	\N	\N	8074	8074	8075
2788	2170	70	applied	\N	\N	\N	\N	8080	8080	8081
2788	2171	71	applied	\N	\N	\N	\N	8082	8082	8083
2788	2172	72	applied	\N	\N	\N	\N	8086	8086	8087
2788	2173	73	applied	\N	\N	\N	\N	8088	8088	8089
2788	2174	74	applied	\N	\N	\N	\N	8091	8091	8092
2788	2175	75	applied	\N	\N	\N	\N	8093	8093	8094
2788	2176	76	applied	\N	\N	\N	\N	8095	8095	8096
2788	2177	77	applied	\N	\N	\N	\N	8099	8099	8100
2788	2178	78	applied	\N	\N	\N	\N	8101	8101	8102
2788	2179	79	applied	\N	\N	\N	\N	8105	8105	8106
2788	2180	80	applied	\N	\N	\N	\N	8108	8108	8109
2788	2181	81	applied	\N	\N	\N	\N	8112	8112	8113
2788	2182	82	applied	\N	\N	\N	\N	8118	8118	8119
2788	2183	83	applied	\N	\N	\N	\N	8128	8128	8129
2788	2184	84	applied	\N	\N	\N	\N	8130	8130	8131
2788	2185	85	applied	\N	\N	\N	\N	8132	8132	8133
2788	2186	86	applied	\N	\N	\N	\N	8136	8136	8137
2788	2187	87	applied	\N	\N	\N	\N	8140	8140	8141
2788	2188	88	applied	\N	\N	\N	\N	8146	8146	8147
2788	2189	89	applied	\N	\N	\N	\N	8150	8150	8151
2788	2190	90	applied	\N	\N	\N	\N	8152	8152	8153
2788	2191	91	applied	\N	\N	\N	\N	8154	8154	8155
2788	2192	92	applied	\N	\N	\N	\N	8161	8161	8162
2788	2193	93	applied	\N	\N	\N	\N	8163	8163	8164
2788	2194	94	applied	\N	\N	\N	\N	8165	8165	8166
2788	2195	95	applied	\N	\N	\N	\N	8167	8167	8168
2788	2196	96	applied	\N	\N	\N	\N	8169	8169	8170
2788	2197	97	applied	\N	\N	\N	\N	8178	8178	8179
2788	2198	98	applied	\N	\N	\N	\N	8184	8184	8185
2788	2199	99	applied	\N	\N	\N	\N	8187	8187	8188
2788	2200	100	applied	\N	\N	\N	\N	8189	8189	8190
2788	2201	101	applied	\N	\N	\N	\N	8193	8193	8194
2788	2202	102	applied	\N	\N	\N	\N	8199	8199	8200
2788	2203	103	applied	\N	\N	\N	\N	8202	8202	8203
2788	2204	104	applied	\N	\N	\N	\N	8204	8204	8205
2788	2205	105	applied	\N	\N	\N	\N	8209	8209	8210
2788	2206	106	applied	\N	\N	\N	\N	8211	8211	8212
2788	2207	107	applied	\N	\N	\N	\N	8217	8217	8218
2788	2208	108	applied	\N	\N	\N	\N	8221	8221	8222
2788	2209	109	applied	\N	\N	\N	\N	8223	8223	8224
2760	2168	123	applied	\N	\N	\N	\N	8072	8072	8073
2760	2169	124	applied	\N	\N	\N	\N	8074	8074	8075
2760	2170	125	applied	\N	\N	\N	\N	8080	8080	8081
2761	2260	0	applied	\N	\N	\N	\N	8454	8454	8455
2761	2261	1	applied	\N	\N	\N	\N	8456	8456	8457
2761	2262	3	applied	\N	\N	\N	\N	8458	8458	8459
2761	2263	4	applied	\N	\N	\N	\N	8460	8460	8461
2764	2265	0	applied	\N	\N	\N	\N	8470	8470	8471
2767	2266	0	applied	\N	\N	\N	\N	8473	8473	8474
2767	2267	1	applied	\N	\N	\N	\N	8475	8475	8476
2767	2268	2	applied	\N	\N	\N	\N	8477	8477	8478
2767	2269	3	applied	\N	\N	\N	\N	8479	8479	8480
2772	2273	0	applied	\N	\N	\N	\N	8493	8493	8494
2775	2276	0	applied	\N	\N	\N	\N	8499	8499	8500
2775	2277	1	applied	\N	\N	\N	\N	8501	8501	8502
2777	2276	0	applied	\N	\N	\N	\N	8499	8499	8500
2777	2277	1	applied	\N	\N	\N	\N	8501	8501	8502
2781	2280	0	applied	\N	\N	\N	\N	8513	8513	8514
2784	2282	0	applied	\N	\N	\N	\N	8519	8519	8520
2787	2284	0	applied	\N	\N	\N	\N	8529	8529	8530
2787	2285	1	applied	\N	\N	\N	\N	8531	8531	8532
2790	2286	0	applied	\N	\N	\N	\N	8536	8536	8537
2793	2288	0	applied	\N	\N	\N	\N	8546	8546	8547
2796	2289	0	applied	\N	\N	\N	\N	8550	8550	8551
2799	2290	0	applied	\N	\N	\N	\N	8558	8558	8559
2799	2291	1	applied	\N	\N	\N	\N	8560	8560	8561
2799	2292	2	applied	\N	\N	\N	\N	8562	8562	8563
2799	2293	3	applied	\N	\N	\N	\N	8564	8564	8565
2808	2298	0	applied	\N	\N	\N	\N	8592	8592	8593
2808	2299	1	applied	\N	\N	\N	\N	8594	8594	8595
2811	2302	0	applied	\N	\N	\N	\N	8603	8603	8604
2817	2305	0	applied	\N	\N	\N	\N	8613	8613	8614
2817	2306	1	applied	\N	\N	\N	\N	8615	8615	8616
2822	2307	0	applied	\N	\N	1000000000	\N	8617	8617	8618
2822	2308	1	applied	\N	\N	\N	\N	8619	8619	8620
2825	2309	0	applied	\N	\N	\N	\N	8623	8623	8624
2825	2310	1	applied	\N	\N	\N	\N	8625	8625	8626
2828	2311	0	applied	\N	\N	\N	\N	8631	8631	8632
2828	2312	1	applied	\N	\N	\N	\N	8633	8633	8634
2828	2313	2	applied	\N	\N	\N	\N	8635	8635	8636
2828	2314	3	applied	\N	\N	\N	\N	8637	8637	8638
2828	2315	4	applied	\N	\N	\N	\N	8639	8639	8640
2828	2316	5	applied	\N	\N	\N	\N	8641	8641	8642
2828	2317	6	applied	\N	\N	\N	\N	8643	8643	8644
2828	2318	7	applied	\N	\N	\N	\N	8645	8645	8646
2836	2322	0	applied	\N	\N	\N	\N	8660	8660	8661
2836	2323	1	applied	\N	\N	\N	\N	8662	8662	8663
2836	2324	2	applied	\N	\N	\N	\N	8664	8664	8665
2836	2325	3	applied	\N	\N	\N	\N	8666	8666	6794
2840	2329	0	applied	\N	\N	\N	\N	8678	8678	8679
2843	2334	0	applied	\N	\N	\N	\N	8693	8693	8694
2846	2336	0	applied	\N	\N	\N	\N	8701	8701	8702
2849	2339	0	applied	\N	\N	\N	\N	8711	8711	8712
2852	2340	0	applied	\N	\N	\N	\N	8715	8715	8716
2855	2341	0	applied	\N	\N	\N	\N	8722	8722	8723
2855	2342	1	applied	\N	\N	\N	\N	8724	8724	8725
2860	2343	0	applied	\N	\N	\N	\N	8730	8730	8731
2860	2344	1	applied	\N	\N	\N	\N	8732	8732	8733
2860	2345	2	applied	\N	\N	\N	\N	8734	8734	8735
2861	2346	0	applied	\N	\N	\N	\N	8743	8743	8744
2865	2349	0	applied	\N	\N	\N	\N	8753	8753	8754
2871	2353	0	applied	\N	\N	\N	\N	8767	8767	8768
2871	2354	1	applied	\N	\N	\N	\N	8771	8771	8772
2877	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2889	2361	0	applied	\N	\N	\N	\N	8797	8797	8798
2891	2362	0	applied	\N	\N	\N	\N	8803	8803	8804
2893	2362	0	applied	\N	\N	\N	\N	8803	8803	8804
2895	2363	0	applied	\N	\N	\N	\N	8813	8813	8814
2895	2364	1	applied	\N	\N	\N	\N	8815	8815	8816
2895	2365	2	applied	\N	\N	\N	\N	8817	8817	8818
2898	2368	0	applied	\N	\N	\N	\N	8827	8827	8828
2904	2371	0	applied	\N	\N	\N	\N	8837	8837	8838
2788	2210	110	applied	\N	\N	\N	\N	8225	8225	8226
2788	2211	111	applied	\N	\N	\N	\N	8227	8227	8228
2788	2212	112	applied	\N	\N	\N	\N	8233	8233	8234
2788	2213	113	applied	\N	\N	\N	\N	8235	8235	8236
2788	2214	114	applied	\N	\N	\N	\N	8239	8239	8240
2788	2215	115	applied	\N	\N	\N	\N	8243	8243	8244
2788	2216	116	applied	\N	\N	\N	\N	8249	8249	8250
2788	2217	117	applied	\N	\N	\N	\N	8254	8254	8255
2788	2218	118	applied	\N	\N	\N	\N	8260	8260	8261
2788	2219	119	applied	\N	\N	\N	\N	8266	8266	8267
2788	2220	120	applied	\N	\N	\N	\N	8270	8270	8271
2788	2221	121	applied	\N	\N	\N	\N	8272	8272	8273
2788	2222	122	applied	\N	\N	\N	\N	8276	8276	8277
2788	2223	123	applied	\N	\N	\N	\N	8280	8280	8281
2788	2224	124	applied	\N	\N	\N	\N	8282	8282	8283
2788	2225	125	applied	\N	\N	\N	\N	8285	8285	8286
2789	2286	0	applied	\N	\N	\N	\N	8536	8536	8537
2792	2288	0	applied	\N	\N	\N	\N	8546	8546	8547
2795	2289	0	applied	\N	\N	\N	\N	8550	8550	8551
2798	2290	0	applied	\N	\N	\N	\N	8558	8558	8559
2798	2291	1	applied	\N	\N	\N	\N	8560	8560	8561
2798	2292	2	applied	\N	\N	\N	\N	8562	8562	8563
2798	2293	3	applied	\N	\N	\N	\N	8564	8564	8565
2801	2294	0	applied	\N	\N	\N	\N	8571	8571	8572
2801	2295	1	applied	\N	\N	\N	\N	8573	8573	8574
2801	2296	2	applied	\N	\N	\N	\N	8575	8575	8576
2804	2104	0	applied	\N	\N	\N	\N	7824	7824	7825
2804	2285	1	applied	\N	\N	\N	\N	8533	8533	8532
2804	2103	2	applied	\N	\N	\N	\N	7822	7822	7823
2804	2105	3	applied	\N	\N	\N	\N	7826	7826	7827
2804	2106	4	applied	\N	\N	\N	\N	7831	7831	7832
2804	2107	5	applied	\N	\N	\N	\N	7837	7837	7838
2804	2108	6	applied	\N	\N	\N	\N	7839	7839	7840
2804	2109	7	applied	\N	\N	\N	\N	7841	7841	7842
2804	2110	8	applied	\N	\N	\N	\N	7845	7845	7846
2804	2111	9	applied	\N	\N	\N	\N	7851	7851	7852
2804	2112	10	applied	\N	\N	\N	\N	7853	7853	7854
2804	2113	11	applied	\N	\N	\N	\N	7855	7855	7856
2804	2114	12	applied	\N	\N	\N	\N	7857	7857	7858
2804	2115	13	applied	\N	\N	\N	\N	7861	7861	7862
2804	2116	14	applied	\N	\N	\N	\N	7865	7865	7866
2804	2117	15	applied	\N	\N	\N	\N	7867	7867	7868
2804	2118	16	applied	\N	\N	\N	\N	7870	7870	7871
2804	2119	17	applied	\N	\N	\N	\N	7876	7876	7877
2804	2120	18	applied	\N	\N	\N	\N	7878	7878	7879
2804	2121	19	applied	\N	\N	\N	\N	7884	7884	7885
2804	2122	20	applied	\N	\N	\N	\N	7888	7888	7889
2804	2123	21	applied	\N	\N	\N	\N	7890	7890	7891
2804	2124	22	applied	\N	\N	\N	\N	7894	7894	7895
2804	2125	23	applied	\N	\N	\N	\N	7896	7896	7897
2804	2126	24	applied	\N	\N	\N	\N	7900	7900	7901
2804	2127	25	applied	\N	\N	\N	\N	7902	7902	7903
2804	2128	26	applied	\N	\N	\N	\N	7913	7913	7914
2804	2129	27	applied	\N	\N	\N	\N	7917	7917	7918
2804	2130	28	applied	\N	\N	\N	\N	7921	7921	7922
2804	2131	29	applied	\N	\N	\N	\N	7932	7932	7933
2804	2132	30	applied	\N	\N	\N	\N	7934	7934	7935
2804	2133	31	applied	\N	\N	\N	\N	7937	7937	7938
2804	2134	32	applied	\N	\N	\N	\N	7939	7939	7940
2804	2135	33	applied	\N	\N	\N	\N	7943	7943	7944
2804	2136	34	applied	\N	\N	\N	\N	7945	7945	7946
2804	2137	35	applied	\N	\N	\N	\N	7949	7949	7950
2804	2138	36	applied	\N	\N	\N	\N	7951	7951	7952
2804	2139	37	applied	\N	\N	\N	\N	7955	7955	7956
2804	2140	38	applied	\N	\N	\N	\N	7959	7959	7960
2804	2141	39	applied	\N	\N	\N	\N	7965	7965	7966
2804	2142	40	applied	\N	\N	\N	\N	7967	7967	7968
2804	2143	41	applied	\N	\N	\N	\N	7969	7969	7970
2804	2144	42	applied	\N	\N	\N	\N	7975	7975	7976
2804	2145	43	applied	\N	\N	\N	\N	7979	7979	7980
2804	2146	44	applied	\N	\N	\N	\N	7989	7989	7990
2804	2147	45	applied	\N	\N	\N	\N	7995	7995	7996
2804	2148	46	applied	\N	\N	\N	\N	7997	7997	7998
2804	2149	47	applied	\N	\N	\N	\N	8002	8002	8003
2804	2150	48	applied	\N	\N	\N	\N	8004	8004	8005
2804	2151	49	applied	\N	\N	\N	\N	8011	8011	8012
2804	2152	50	applied	\N	\N	\N	\N	8013	8013	8014
2804	2153	51	applied	\N	\N	\N	\N	8019	8019	8020
2804	2154	52	applied	\N	\N	\N	\N	8022	8022	8023
2804	2155	53	applied	\N	\N	\N	\N	8024	8024	8025
2804	2156	54	applied	\N	\N	\N	\N	8032	8032	8033
2804	2157	55	applied	\N	\N	\N	\N	8034	8034	8035
2804	2158	56	applied	\N	\N	\N	\N	8038	8038	8039
2804	2159	57	applied	\N	\N	\N	\N	8045	8045	8046
2804	2160	58	applied	\N	\N	\N	\N	8047	8047	8048
2804	2161	59	applied	\N	\N	\N	\N	8052	8052	8053
2804	2162	60	applied	\N	\N	\N	\N	8055	8055	8056
2804	2163	61	applied	\N	\N	\N	\N	8057	8057	8058
2804	2164	62	applied	\N	\N	\N	\N	8059	8059	8060
2804	2165	63	applied	\N	\N	\N	\N	8061	8061	8062
2804	2166	64	applied	\N	\N	\N	\N	8063	8063	8064
2804	2167	65	applied	\N	\N	\N	\N	8068	8068	8069
2804	2168	66	applied	\N	\N	\N	\N	8072	8072	8073
2804	2169	67	applied	\N	\N	\N	\N	8074	8074	8075
2804	2170	68	applied	\N	\N	\N	\N	8080	8080	8081
2804	2171	69	applied	\N	\N	\N	\N	8082	8082	8083
2804	2172	70	applied	\N	\N	\N	\N	8086	8086	8087
2804	2173	71	applied	\N	\N	\N	\N	8088	8088	8089
2804	2174	72	applied	\N	\N	\N	\N	8091	8091	8092
2804	2175	73	applied	\N	\N	\N	\N	8093	8093	8094
2804	2176	74	applied	\N	\N	\N	\N	8095	8095	8096
2804	2177	75	applied	\N	\N	\N	\N	8099	8099	8100
2804	2178	76	applied	\N	\N	\N	\N	8101	8101	8102
2804	2179	77	applied	\N	\N	\N	\N	8105	8105	8106
2804	2180	78	applied	\N	\N	\N	\N	8108	8108	8109
2804	2181	79	applied	\N	\N	\N	\N	8112	8112	8113
2804	2182	80	applied	\N	\N	\N	\N	8118	8118	8119
2804	2183	81	applied	\N	\N	\N	\N	8128	8128	8129
2804	2184	82	applied	\N	\N	\N	\N	8130	8130	8131
2804	2185	83	applied	\N	\N	\N	\N	8132	8132	8133
2804	2186	84	applied	\N	\N	\N	\N	8136	8136	8137
2804	2187	85	applied	\N	\N	\N	\N	8140	8140	8141
2804	2188	86	applied	\N	\N	\N	\N	8146	8146	8147
2804	2189	87	applied	\N	\N	\N	\N	8150	8150	8151
2804	2190	88	applied	\N	\N	\N	\N	8152	8152	8153
2804	2191	89	applied	\N	\N	\N	\N	8154	8154	8155
2804	2192	90	applied	\N	\N	\N	\N	8161	8161	8162
2804	2193	91	applied	\N	\N	\N	\N	8163	8163	8164
2804	2194	92	applied	\N	\N	\N	\N	8165	8165	8166
2804	2195	93	applied	\N	\N	\N	\N	8167	8167	8168
2804	2196	94	applied	\N	\N	\N	\N	8169	8169	8170
2804	2197	95	applied	\N	\N	\N	\N	8178	8178	8179
2804	2198	96	applied	\N	\N	\N	\N	8184	8184	8185
2804	2199	97	applied	\N	\N	\N	\N	8187	8187	8188
2804	2200	98	applied	\N	\N	\N	\N	8189	8189	8190
2804	2201	99	applied	\N	\N	\N	\N	8193	8193	8194
2804	2202	100	applied	\N	\N	\N	\N	8199	8199	8200
2804	2203	101	applied	\N	\N	\N	\N	8202	8202	8203
2804	2204	102	applied	\N	\N	\N	\N	8204	8204	8205
2804	2205	103	applied	\N	\N	\N	\N	8209	8209	8210
2804	2206	104	applied	\N	\N	\N	\N	8211	8211	8212
2804	2207	105	applied	\N	\N	\N	\N	8217	8217	8218
2804	2208	106	applied	\N	\N	\N	\N	8221	8221	8222
2804	2209	107	applied	\N	\N	\N	\N	8223	8223	8224
2804	2210	108	applied	\N	\N	\N	\N	8225	8225	8226
2804	2211	109	applied	\N	\N	\N	\N	8227	8227	8228
2804	2212	110	applied	\N	\N	\N	\N	8233	8233	8234
2804	2213	111	applied	\N	\N	\N	\N	8235	8235	8236
2804	2214	112	applied	\N	\N	\N	\N	8239	8239	8240
2804	2215	113	applied	\N	\N	\N	\N	8243	8243	8244
2804	2216	114	applied	\N	\N	\N	\N	8249	8249	8250
2804	2217	115	applied	\N	\N	\N	\N	8254	8254	8255
2804	2218	116	applied	\N	\N	\N	\N	8260	8260	8261
2804	2219	117	applied	\N	\N	\N	\N	8266	8266	8267
2804	2220	118	applied	\N	\N	\N	\N	8270	8270	8271
2804	2221	119	applied	\N	\N	\N	\N	8272	8272	8273
2804	2222	120	applied	\N	\N	\N	\N	8276	8276	8277
2804	2223	122	applied	\N	\N	\N	\N	8280	8280	8281
2804	2224	123	applied	\N	\N	\N	\N	8282	8282	8283
2804	2225	124	applied	\N	\N	\N	\N	8285	8285	8286
2804	2226	125	applied	\N	\N	\N	\N	8287	8287	8288
2807	2298	0	applied	\N	\N	\N	\N	8592	8592	8593
2807	2299	1	applied	\N	\N	\N	\N	8594	8594	8595
2810	2301	0	applied	\N	\N	\N	\N	8601	8601	8602
2813	2303	0	applied	\N	\N	\N	\N	8607	8607	8608
2833	2319	0	applied	\N	\N	\N	\N	8651	8651	8652
2833	2320	1	applied	\N	\N	\N	\N	8653	8653	8654
2833	2321	2	applied	\N	\N	\N	\N	8657	8657	8658
2842	2332	0	applied	\N	\N	\N	\N	8687	8687	8688
2842	2333	1	applied	\N	\N	\N	\N	8689	8689	8690
2845	2336	0	applied	\N	\N	\N	\N	8701	8701	8702
2854	2341	0	applied	\N	\N	\N	\N	8722	8722	8723
2854	2342	1	applied	\N	\N	\N	\N	8724	8724	8725
2857	2343	0	applied	\N	\N	\N	\N	8730	8730	8731
2857	2344	1	applied	\N	\N	\N	\N	8732	8732	8733
2857	2345	2	applied	\N	\N	\N	\N	8734	8734	8735
2864	2349	0	applied	\N	\N	\N	\N	8753	8753	8754
2867	2350	0	applied	\N	\N	\N	\N	8756	8756	8757
2867	2351	1	applied	\N	\N	\N	\N	8758	8758	8759
2867	2352	2	applied	\N	\N	\N	\N	8760	8760	8761
2873	2355	0	applied	\N	\N	\N	\N	8775	8775	8776
2876	2356	0	applied	\N	\N	\N	\N	8777	8777	8778
2879	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2882	2357	0	applied	\N	\N	\N	\N	8779	8779	8780
2882	2358	1	applied	\N	\N	\N	\N	8783	8783	8784
2885	2359	0	applied	\N	\N	\N	\N	8789	8789	8790
2888	2361	0	applied	\N	\N	\N	\N	8797	8797	8798
2894	2362	0	applied	\N	\N	\N	\N	8803	8803	8804
2897	2368	0	applied	\N	\N	\N	\N	8827	8827	8828
2900	2369	0	applied	\N	\N	\N	\N	8830	8830	8831
2903	2370	0	applied	\N	\N	\N	\N	8835	8835	8836
2905	2372	0	applied	\N	\N	\N	\N	8841	8841	8842
2905	2373	1	applied	\N	\N	\N	\N	8843	8843	8844
2905	2374	2	applied	\N	\N	\N	\N	8845	8845	8846
2905	2375	3	applied	\N	\N	\N	\N	8847	8847	8848
2908	2372	0	applied	\N	\N	\N	\N	8841	8841	8842
2908	2373	1	applied	\N	\N	\N	\N	8843	8843	8844
2908	2374	2	applied	\N	\N	\N	\N	8845	8845	8846
2908	2375	3	applied	\N	\N	\N	\N	8847	8847	8848
2911	2376	0	applied	\N	\N	\N	\N	8860	8860	8861
2911	2377	1	applied	\N	\N	\N	\N	8862	8862	8863
2911	2378	2	applied	\N	\N	\N	\N	8864	8864	8865
2911	2379	3	applied	\N	\N	\N	\N	8866	8866	8867
2911	2380	4	applied	\N	\N	\N	\N	8868	8868	8869
2912	2307	0	applied	\N	\N	1000000000	\N	8617	8617	8618
2912	2294	1	applied	\N	\N	\N	\N	8571	8571	8572
2912	2295	2	applied	\N	\N	\N	\N	8573	8573	8574
2912	2296	3	applied	\N	\N	\N	\N	8575	8575	8576
2912	2297	4	applied	\N	\N	\N	\N	8588	8588	8589
2912	2298	5	applied	\N	\N	\N	\N	8592	8592	8593
2912	2299	6	applied	\N	\N	\N	\N	8594	8594	8595
2912	2300	7	applied	\N	\N	\N	\N	8599	8599	8600
2912	2309	8	applied	\N	\N	\N	\N	8623	8623	8624
2912	2301	9	applied	\N	\N	\N	\N	8601	8601	8602
2912	2302	10	applied	\N	\N	\N	\N	8603	8603	8604
2912	2303	11	applied	\N	\N	\N	\N	8607	8607	8608
2912	2304	12	applied	\N	\N	\N	\N	8611	8611	8612
2912	2305	13	applied	\N	\N	\N	\N	8613	8613	8614
2912	2306	14	applied	\N	\N	\N	\N	8615	8615	8616
2912	2308	15	applied	\N	\N	\N	\N	8619	8619	8620
2912	2311	16	applied	\N	\N	\N	\N	8631	8631	8632
2912	2312	17	applied	\N	\N	\N	\N	8633	8633	8634
2912	2313	18	applied	\N	\N	\N	\N	8635	8635	8636
2912	2314	19	applied	\N	\N	\N	\N	8637	8637	8638
2912	2315	20	applied	\N	\N	\N	\N	8639	8639	8640
2912	2316	21	applied	\N	\N	\N	\N	8641	8641	8642
2912	2317	22	applied	\N	\N	\N	\N	8643	8643	8644
2912	2318	23	applied	\N	\N	\N	\N	8645	8645	8646
2912	2319	24	applied	\N	\N	\N	\N	8651	8651	8652
2912	2320	25	applied	\N	\N	\N	\N	8653	8653	8654
2912	2321	26	applied	\N	\N	\N	\N	8657	8657	8658
2912	2322	27	applied	\N	\N	\N	\N	8660	8660	8661
2912	2323	28	applied	\N	\N	\N	\N	8662	8662	8663
2912	2324	29	applied	\N	\N	\N	\N	8664	8664	8665
2912	2326	30	applied	\N	\N	\N	\N	8670	8670	8671
2912	2327	31	applied	\N	\N	\N	\N	8672	8672	8673
2912	2328	32	applied	\N	\N	\N	\N	8674	8674	8675
2912	2329	33	applied	\N	\N	\N	\N	8678	8678	8679
2912	2330	34	applied	\N	\N	\N	\N	8682	8682	8683
2912	2331	35	applied	\N	\N	\N	\N	8684	8684	8685
2912	2332	36	applied	\N	\N	\N	\N	8687	8687	8688
2912	2333	37	applied	\N	\N	\N	\N	8689	8689	8690
2912	2334	38	applied	\N	\N	\N	\N	8693	8693	8694
2912	2335	39	applied	\N	\N	\N	\N	8697	8697	8698
2912	2336	40	applied	\N	\N	\N	\N	8701	8701	8702
2912	2337	41	applied	\N	\N	\N	\N	8706	8706	8707
2912	2338	42	applied	\N	\N	\N	\N	8708	8708	8709
2912	2339	43	applied	\N	\N	\N	\N	8711	8711	8712
2912	2340	44	applied	\N	\N	\N	\N	8715	8715	8716
2912	2341	45	applied	\N	\N	\N	\N	8722	8722	8723
2912	2342	46	applied	\N	\N	\N	\N	8724	8724	8725
2912	2343	47	applied	\N	\N	\N	\N	8730	8730	8731
2912	2344	48	applied	\N	\N	\N	\N	8732	8732	8733
2912	2346	49	applied	\N	\N	\N	\N	8743	8743	8744
2912	2347	50	applied	\N	\N	\N	\N	8747	8747	8748
2913	2376	0	applied	\N	\N	\N	\N	8860	8860	8861
2913	2377	1	applied	\N	\N	\N	\N	8862	8862	8863
2913	2378	2	applied	\N	\N	\N	\N	8864	8864	8865
2913	2379	3	applied	\N	\N	\N	\N	8866	8866	8867
2913	2380	4	applied	\N	\N	\N	\N	8868	8868	8869
2914	2376	0	applied	\N	\N	\N	\N	8860	8860	8861
2914	2377	1	applied	\N	\N	\N	\N	8862	8862	8863
2914	2378	2	applied	\N	\N	\N	\N	8864	8864	8865
2914	2379	3	applied	\N	\N	\N	\N	8866	8866	8867
2914	2380	4	applied	\N	\N	\N	\N	8868	8868	8869
2915	2381	0	applied	\N	\N	\N	\N	8882	8882	8883
2916	2381	0	applied	\N	\N	\N	\N	8882	8882	8883
2918	2382	0	applied	\N	\N	\N	\N	8889	8889	8890
2918	2383	1	applied	\N	\N	\N	\N	8891	8891	8892
2918	2384	2	applied	\N	\N	\N	\N	8893	8893	8894
2919	2385	0	applied	\N	\N	\N	\N	8897	8897	8898
2921	2246	0	applied	\N	\N	\N	\N	8375	8375	8376
2921	2247	1	applied	\N	\N	\N	\N	8379	8379	8380
2921	2248	2	applied	\N	\N	\N	\N	8382	8382	8383
2921	2285	3	applied	\N	\N	\N	\N	8531	8531	8532
2921	2307	4	applied	\N	\N	1000000000	\N	8617	8617	8618
2921	2309	5	applied	\N	\N	\N	\N	8623	8623	8624
2921	2249	6	applied	\N	\N	\N	\N	8384	8384	8385
2921	2250	7	applied	\N	\N	\N	\N	8390	8390	8391
2921	2251	8	applied	\N	\N	\N	\N	8392	8392	8393
2921	2252	9	applied	\N	\N	\N	\N	8394	8394	8395
2921	2253	10	applied	\N	\N	\N	\N	8399	8399	8400
2921	2254	11	applied	\N	\N	\N	\N	8405	8405	8406
2921	2255	12	applied	\N	\N	\N	\N	8410	8410	8411
2921	2256	13	applied	\N	\N	\N	\N	8412	8412	8413
2921	2257	14	applied	\N	\N	\N	\N	8419	8419	8420
2921	2258	15	applied	\N	\N	\N	\N	8429	8429	8430
2921	2259	16	applied	\N	\N	\N	\N	8434	8434	8435
2921	2260	17	applied	\N	\N	\N	\N	8454	8454	8455
2921	2261	18	applied	\N	\N	\N	\N	8456	8456	8457
2921	2262	19	applied	\N	\N	\N	\N	8458	8458	8459
2921	2263	20	applied	\N	\N	\N	\N	8460	8460	8461
2921	2264	21	applied	\N	\N	\N	\N	8464	8464	8465
2921	2265	22	applied	\N	\N	\N	\N	8470	8470	8471
2921	2266	23	applied	\N	\N	\N	\N	8473	8473	8474
2921	2267	24	applied	\N	\N	\N	\N	8475	8475	8476
2921	2268	25	applied	\N	\N	\N	\N	8477	8477	8478
2921	2269	26	applied	\N	\N	\N	\N	8479	8479	8480
2921	2270	27	applied	\N	\N	\N	\N	8481	8481	8482
2921	2271	28	applied	\N	\N	\N	\N	8485	8485	8486
2921	2272	29	applied	\N	\N	\N	\N	8489	8489	8490
2921	2273	30	applied	\N	\N	\N	\N	8493	8493	8494
2921	2274	31	applied	\N	\N	\N	\N	8495	8495	8496
2921	2275	32	applied	\N	\N	\N	\N	8497	8497	8498
2921	2276	33	applied	\N	\N	\N	\N	8499	8499	8500
2921	2277	34	applied	\N	\N	\N	\N	8501	8501	8502
2921	2278	35	applied	\N	\N	\N	\N	8506	8506	8507
2921	2279	36	applied	\N	\N	\N	\N	8508	8508	8509
2921	2280	38	applied	\N	\N	\N	\N	8513	8513	8514
2921	2281	39	applied	\N	\N	\N	\N	8517	8517	8518
2921	2282	40	applied	\N	\N	\N	\N	8519	8519	8520
2921	2283	41	applied	\N	\N	\N	\N	8523	8523	8524
2921	2284	42	applied	\N	\N	\N	\N	8529	8529	8530
2921	2286	43	applied	\N	\N	\N	\N	8536	8536	8537
2921	2287	44	applied	\N	\N	\N	\N	8542	8542	8543
2921	2288	45	applied	\N	\N	\N	\N	8546	8546	8547
2921	2289	46	applied	\N	\N	\N	\N	8550	8550	8551
2921	2290	47	applied	\N	\N	\N	\N	8558	8558	8559
2921	2291	48	applied	\N	\N	\N	\N	8560	8560	8561
2921	2292	49	applied	\N	\N	\N	\N	8562	8562	8563
2921	2293	50	applied	\N	\N	\N	\N	8564	8564	8565
2921	2294	51	applied	\N	\N	\N	\N	8571	8571	8572
2921	2295	52	applied	\N	\N	\N	\N	8573	8573	8574
2921	2296	53	applied	\N	\N	\N	\N	8575	8575	8576
2921	2297	54	applied	\N	\N	\N	\N	8588	8588	8589
2921	2298	55	applied	\N	\N	\N	\N	8592	8592	8593
2921	2299	56	applied	\N	\N	\N	\N	8594	8594	8595
2921	2300	57	applied	\N	\N	\N	\N	8599	8599	8600
2921	2301	58	applied	\N	\N	\N	\N	8601	8601	8602
2921	2302	59	applied	\N	\N	\N	\N	8603	8603	8604
2921	2303	60	applied	\N	\N	\N	\N	8607	8607	8608
2921	2304	61	applied	\N	\N	\N	\N	8611	8611	8612
2921	2305	62	applied	\N	\N	\N	\N	8613	8613	8614
2921	2306	63	applied	\N	\N	\N	\N	8615	8615	8616
2921	2308	64	applied	\N	\N	\N	\N	8619	8619	8620
2921	2311	65	applied	\N	\N	\N	\N	8631	8631	8632
2921	2312	66	applied	\N	\N	\N	\N	8633	8633	8634
2921	2313	67	applied	\N	\N	\N	\N	8635	8635	8636
2921	2314	68	applied	\N	\N	\N	\N	8637	8637	8638
2921	2315	69	applied	\N	\N	\N	\N	8639	8639	8640
2921	2316	70	applied	\N	\N	\N	\N	8641	8641	8642
2921	2317	71	applied	\N	\N	\N	\N	8643	8643	8644
2921	2318	72	applied	\N	\N	\N	\N	8645	8645	8646
2921	2319	73	applied	\N	\N	\N	\N	8651	8651	8652
2921	2320	74	applied	\N	\N	\N	\N	8653	8653	8654
2921	2321	75	applied	\N	\N	\N	\N	8657	8657	8658
2921	2322	76	applied	\N	\N	\N	\N	8660	8660	8661
2921	2323	77	applied	\N	\N	\N	\N	8662	8662	8663
2921	2324	78	applied	\N	\N	\N	\N	8664	8664	8665
2921	2326	79	applied	\N	\N	\N	\N	8670	8670	8671
2921	2327	80	applied	\N	\N	\N	\N	8672	8672	8673
2921	2328	81	applied	\N	\N	\N	\N	8674	8674	8675
2921	2329	82	applied	\N	\N	\N	\N	8678	8678	8679
2921	2330	83	applied	\N	\N	\N	\N	8682	8682	8683
2921	2331	84	applied	\N	\N	\N	\N	8684	8684	8685
2921	2332	85	applied	\N	\N	\N	\N	8687	8687	8688
2921	2333	86	applied	\N	\N	\N	\N	8689	8689	8690
2921	2334	87	applied	\N	\N	\N	\N	8693	8693	8694
2921	2335	88	applied	\N	\N	\N	\N	8697	8697	8698
2921	2336	89	applied	\N	\N	\N	\N	8701	8701	8702
2921	2337	90	applied	\N	\N	\N	\N	8706	8706	8707
2921	2338	91	applied	\N	\N	\N	\N	8708	8708	8709
2921	2339	92	applied	\N	\N	\N	\N	8711	8711	8712
2921	2340	93	applied	\N	\N	\N	\N	8715	8715	8716
2921	2341	94	applied	\N	\N	\N	\N	8722	8722	8723
2921	2342	95	applied	\N	\N	\N	\N	8724	8724	8725
2921	2343	96	applied	\N	\N	\N	\N	8730	8730	8731
2921	2344	97	applied	\N	\N	\N	\N	8732	8732	8733
2921	2346	98	applied	\N	\N	\N	\N	8743	8743	8744
2921	2347	99	applied	\N	\N	\N	\N	8747	8747	8748
2921	2348	100	applied	\N	\N	\N	\N	8749	8749	8750
2921	2349	101	applied	\N	\N	\N	\N	8753	8753	8754
2921	2350	102	applied	\N	\N	\N	\N	8756	8756	8757
2921	2351	103	applied	\N	\N	\N	\N	8758	8758	8759
2921	2352	104	applied	\N	\N	\N	\N	8760	8760	8761
2921	2353	105	applied	\N	\N	\N	\N	8767	8767	8768
2921	2354	106	applied	\N	\N	\N	\N	8771	8771	8772
2921	2355	107	applied	\N	\N	\N	\N	8775	8775	8776
2921	2356	108	applied	\N	\N	\N	\N	8777	8777	8778
2921	2357	109	applied	\N	\N	\N	\N	8779	8779	8780
2921	2358	110	applied	\N	\N	\N	\N	8783	8783	8784
2921	2359	111	applied	\N	\N	\N	\N	8789	8789	8790
2921	2360	112	applied	\N	\N	\N	\N	8793	8793	8794
2921	2361	113	applied	\N	\N	\N	\N	8797	8797	8798
2921	2362	114	applied	\N	\N	\N	\N	8803	8803	8804
2921	2363	115	applied	\N	\N	\N	\N	8813	8813	8814
2921	2364	116	applied	\N	\N	\N	\N	8815	8815	8816
2921	2365	117	applied	\N	\N	\N	\N	8817	8817	8818
2921	2366	118	applied	\N	\N	\N	\N	8821	8821	8822
2921	2367	119	applied	\N	\N	\N	\N	8823	8823	8824
2921	2368	120	applied	\N	\N	\N	\N	8827	8827	8828
2921	2369	121	applied	\N	\N	\N	\N	8830	8830	8831
2921	2370	122	applied	\N	\N	\N	\N	8835	8835	8836
2921	2371	123	applied	\N	\N	\N	\N	8837	8837	8838
2921	2372	124	applied	\N	\N	\N	\N	8841	8841	8842
2921	2373	125	applied	\N	\N	\N	\N	8843	8843	8844
2924	2386	0	applied	\N	\N	\N	\N	8904	8904	8905
2924	2387	1	applied	\N	\N	\N	\N	8906	8906	8907
2929	2388	0	applied	\N	\N	\N	\N	8914	8914	8915
2929	2389	1	applied	\N	\N	\N	\N	8918	8918	8919
2932	2390	0	applied	\N	\N	\N	\N	8922	8922	8923
2932	2391	1	applied	\N	\N	\N	\N	8924	8924	8925
2935	2392	0	applied	\N	\N	\N	\N	8927	8927	8928
2935	2393	1	applied	\N	\N	\N	\N	8931	8931	8932
2941	2395	0	applied	\N	\N	\N	\N	8937	8937	8938
2947	2398	0	applied	\N	\N	\N	\N	8948	8948	8949
2949	2399	0	applied	\N	\N	\N	\N	8952	8952	8953
2952	2404	0	applied	\N	\N	\N	\N	8967	8967	8968
2952	2405	1	applied	\N	\N	\N	\N	8969	8969	8970
2952	2406	2	applied	\N	\N	\N	\N	8971	8971	8972
2952	2407	3	applied	\N	\N	\N	\N	8973	8973	8974
2959	2410	0	applied	\N	\N	\N	\N	8987	8987	8988
2961	2410	0	applied	\N	\N	\N	\N	8987	8987	8988
2963	2411	0	applied	\N	\N	\N	\N	8994	8994	8995
2966	2412	0	applied	\N	\N	\N	\N	8999	8999	9000
2969	2415	0	applied	\N	\N	\N	\N	9013	9013	9014
2969	2416	1	applied	\N	\N	\N	\N	9015	9015	9016
2969	2417	2	applied	\N	\N	\N	\N	9017	9017	9018
2972	2419	0	applied	\N	\N	\N	\N	9023	9023	9024
2972	2420	1	applied	\N	\N	\N	\N	9025	9025	9026
2972	2421	2	applied	\N	\N	\N	\N	9027	9027	9028
2975	2423	0	applied	\N	\N	\N	\N	9035	9035	9036
2975	2424	1	applied	\N	\N	\N	\N	9037	9037	9038
2979	2426	0	applied	\N	\N	\N	\N	9043	9043	9044
2982	2428	0	applied	\N	\N	\N	\N	9055	9055	9056
2985	2429	0	applied	\N	\N	\N	\N	9059	9059	9060
2988	2430	0	applied	\N	\N	\N	\N	9067	9067	9068
2991	2431	0	applied	\N	\N	\N	\N	9072	9072	9073
2991	2432	2	applied	\N	\N	\N	\N	9075	9075	9076
2991	2433	3	applied	\N	\N	\N	\N	9077	9077	9078
2994	2435	0	applied	\N	\N	\N	\N	9089	9089	9090
2997	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3012	2441	0	applied	\N	\N	\N	\N	9125	9125	9126
3015	2442	0	applied	\N	\N	\N	\N	9130	9130	9131
3017	2443	0	applied	\N	\N	\N	\N	9136	9136	9137
3018	2444	0	applied	\N	\N	\N	\N	9142	9142	9143
3021	2445	0	applied	\N	\N	\N	\N	9146	9146	9147
3024	2448	0	applied	\N	\N	\N	\N	9158	9158	9159
3026	2449	0	applied	\N	\N	\N	\N	9162	9162	9163
3027	2449	0	applied	\N	\N	\N	\N	9162	9162	9163
3030	2451	0	applied	\N	\N	\N	\N	9173	9173	9174
3033	2452	0	applied	\N	\N	\N	\N	9175	9175	9176
3036	2454	0	applied	\N	\N	\N	\N	9184	9184	9185
3036	2455	1	applied	\N	\N	\N	\N	9186	9186	9187
3039	2457	0	applied	\N	\N	\N	\N	9196	9196	9197
3044	2460	0	applied	\N	\N	\N	\N	9208	9208	9209
3044	2461	1	applied	\N	\N	\N	\N	9210	9210	9211
3047	2463	0	applied	\N	\N	\N	\N	9222	9222	9223
3047	2464	1	applied	\N	\N	\N	\N	9224	9224	9225
3050	2466	0	applied	\N	\N	\N	\N	9233	9233	9234
3050	2467	1	applied	\N	\N	\N	\N	9235	9235	9236
3050	2468	2	applied	\N	\N	\N	\N	9237	9237	9238
3053	2472	0	applied	\N	\N	\N	\N	9250	9250	9251
3062	2473	0	applied	\N	\N	1000000000	\N	9261	9261	9254
3065	2478	0	applied	\N	\N	\N	\N	9271	9271	9272
3068	2480	0	applied	\N	\N	\N	\N	9279	9279	9280
3068	2481	1	applied	\N	\N	\N	\N	9281	9281	9282
3071	2484	0	applied	\N	\N	\N	\N	9292	9292	9293
3076	2438	0	applied	\N	\N	\N	\N	9303	9303	9101
3076	2473	1	applied	\N	\N	1000000000	\N	9261	9261	9254
3076	2307	2	applied	\N	\N	1000000000	\N	8617	8617	8618
3076	2305	3	applied	\N	\N	\N	\N	8613	8613	8614
3076	2306	4	applied	\N	\N	\N	\N	8615	8615	8616
3076	2308	5	applied	\N	\N	\N	\N	8619	8619	8620
3076	2311	6	applied	\N	\N	\N	\N	8631	8631	8632
3076	2312	7	applied	\N	\N	\N	\N	8633	8633	8634
3076	2313	8	applied	\N	\N	\N	\N	8635	8635	8636
3076	2309	9	applied	\N	\N	\N	\N	8623	8623	8624
3076	2314	10	applied	\N	\N	\N	\N	8637	8637	8638
3076	2315	11	applied	\N	\N	\N	\N	8639	8639	8640
3076	2316	12	applied	\N	\N	\N	\N	8641	8641	8642
3076	2317	13	applied	\N	\N	\N	\N	8643	8643	8644
3076	2318	14	applied	\N	\N	\N	\N	8645	8645	8646
3076	2319	15	applied	\N	\N	\N	\N	8651	8651	8652
3076	2320	16	applied	\N	\N	\N	\N	8653	8653	8654
3076	2321	17	applied	\N	\N	\N	\N	8657	8657	8658
3076	2322	18	applied	\N	\N	\N	\N	8660	8660	8661
3076	2323	19	applied	\N	\N	\N	\N	8662	8662	8663
3076	2324	20	applied	\N	\N	\N	\N	8664	8664	8665
3076	2326	21	applied	\N	\N	\N	\N	8670	8670	8671
3076	2327	22	applied	\N	\N	\N	\N	8672	8672	8673
3076	2328	23	applied	\N	\N	\N	\N	8674	8674	8675
3076	2329	25	applied	\N	\N	\N	\N	8678	8678	8679
3076	2330	26	applied	\N	\N	\N	\N	8682	8682	8683
3076	2331	27	applied	\N	\N	\N	\N	8684	8684	8685
3076	2332	28	applied	\N	\N	\N	\N	8687	8687	8688
3076	2333	29	applied	\N	\N	\N	\N	8689	8689	8690
3076	2334	30	applied	\N	\N	\N	\N	8693	8693	8694
3076	2335	31	applied	\N	\N	\N	\N	8697	8697	8698
2922	2386	0	applied	\N	\N	\N	\N	8904	8904	8905
2922	2387	1	applied	\N	\N	\N	\N	8906	8906	8907
2923	2386	0	applied	\N	\N	\N	\N	8904	8904	8905
2923	2387	1	applied	\N	\N	\N	\N	8906	8906	8907
2927	2388	0	applied	\N	\N	\N	\N	8914	8914	8915
2928	2388	0	applied	\N	\N	\N	\N	8914	8914	8915
2931	2388	0	applied	\N	\N	\N	\N	8914	8914	8915
2931	2389	1	applied	\N	\N	\N	\N	8918	8918	8919
2934	2392	0	applied	\N	\N	\N	\N	8927	8927	8928
2936	2394	0	applied	\N	\N	\N	\N	8935	8935	8936
2943	2396	0	applied	\N	\N	\N	\N	8941	8941	8942
2945	2397	0	applied	\N	\N	\N	\N	8946	8946	8947
2946	2397	0	applied	\N	\N	\N	\N	8946	8946	8947
2948	2399	0	applied	\N	\N	\N	\N	8952	8952	8953
2950	2400	0	applied	\N	\N	\N	\N	8958	8958	8959
2950	2401	1	applied	\N	\N	\N	\N	8960	8960	8961
2950	2402	2	applied	\N	\N	\N	\N	8962	8962	8963
2950	2403	3	applied	\N	\N	\N	\N	8964	8964	8965
2953	2408	0	applied	\N	\N	\N	\N	8976	8976	8977
2955	2409	0	applied	\N	\N	\N	\N	8980	8980	8981
2956	2409	0	applied	\N	\N	\N	\N	8980	8980	8981
2958	2410	0	applied	\N	\N	\N	\N	8987	8987	8988
2960	2410	0	applied	\N	\N	\N	\N	8987	8987	8988
2964	2412	0	applied	\N	\N	\N	\N	8999	8999	9000
2967	2413	0	applied	\N	\N	\N	\N	9005	9005	9006
2970	2418	0	applied	\N	\N	\N	\N	9019	9019	9020
2973	2422	0	applied	\N	\N	\N	\N	9032	9032	9033
2976	2425	0	applied	\N	\N	\N	\N	9041	9041	9042
2983	2429	0	applied	\N	\N	\N	\N	9059	9059	9060
2986	2429	0	applied	\N	\N	\N	\N	9059	9059	9060
2992	2434	0	applied	\N	\N	\N	\N	9083	9083	9084
2995	2436	0	applied	\N	\N	\N	\N	9093	9093	9094
2995	2437	1	applied	\N	\N	\N	\N	9095	9095	9096
2998	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3004	2438	0	applied	\N	\N	\N	\N	9107	9107	9108
3004	2140	1	applied	\N	\N	\N	\N	7959	7959	7960
3004	2141	2	applied	\N	\N	\N	\N	7965	7965	7966
3004	2142	3	applied	\N	\N	\N	\N	7967	7967	7968
3004	2143	4	applied	\N	\N	\N	\N	7969	7969	7970
3004	2144	5	applied	\N	\N	\N	\N	7975	7975	7976
3004	2145	6	applied	\N	\N	\N	\N	7979	7979	7980
3004	2146	7	applied	\N	\N	\N	\N	7989	7989	7990
3004	2285	8	applied	\N	\N	\N	\N	8533	8533	8532
3004	2307	9	applied	\N	\N	1000000000	\N	9109	9109	8618
3004	2309	10	applied	\N	\N	\N	\N	9110	9110	8624
3004	2147	11	applied	\N	\N	\N	\N	7995	7995	7996
3004	2148	12	applied	\N	\N	\N	\N	7997	7997	7998
3004	2149	13	applied	\N	\N	\N	\N	8002	8002	8003
3004	2150	14	applied	\N	\N	\N	\N	8004	8004	8005
3004	2151	15	applied	\N	\N	\N	\N	8011	8011	8012
3004	2152	16	applied	\N	\N	\N	\N	8013	8013	8014
3004	2153	17	applied	\N	\N	\N	\N	8019	8019	8020
3004	2154	18	applied	\N	\N	\N	\N	8022	8022	8023
3004	2155	19	applied	\N	\N	\N	\N	8024	8024	8025
3004	2156	20	applied	\N	\N	\N	\N	8032	8032	8033
3004	2157	21	applied	\N	\N	\N	\N	8034	8034	8035
3004	2158	22	applied	\N	\N	\N	\N	8038	8038	8039
3004	2159	23	applied	\N	\N	\N	\N	8045	8045	8046
3004	2160	24	applied	\N	\N	\N	\N	8047	8047	8048
3004	2161	25	applied	\N	\N	\N	\N	8052	8052	8053
3004	2162	26	applied	\N	\N	\N	\N	8055	8055	8056
3004	2163	27	applied	\N	\N	\N	\N	8057	8057	8058
3004	2164	28	applied	\N	\N	\N	\N	8059	8059	8060
3004	2165	29	applied	\N	\N	\N	\N	8061	8061	8062
3004	2166	30	applied	\N	\N	\N	\N	8063	8063	8064
3004	2167	31	applied	\N	\N	\N	\N	8068	8068	8069
3004	2168	32	applied	\N	\N	\N	\N	8072	8072	8073
3004	2169	33	applied	\N	\N	\N	\N	8074	8074	8075
3004	2170	35	applied	\N	\N	\N	\N	8080	8080	8081
3004	2171	36	applied	\N	\N	\N	\N	8082	8082	8083
3004	2172	37	applied	\N	\N	\N	\N	8086	8086	8087
3004	2173	38	applied	\N	\N	\N	\N	8088	8088	8089
3004	2174	39	applied	\N	\N	\N	\N	8091	8091	8092
3004	2175	40	applied	\N	\N	\N	\N	8093	8093	8094
3004	2176	41	applied	\N	\N	\N	\N	8095	8095	8096
3004	2177	42	applied	\N	\N	\N	\N	8099	8099	8100
3004	2178	43	applied	\N	\N	\N	\N	8101	8101	8102
3004	2179	44	applied	\N	\N	\N	\N	8105	8105	8106
3004	2180	45	applied	\N	\N	\N	\N	8108	8108	8109
3004	2181	46	applied	\N	\N	\N	\N	8112	8112	8113
3004	2182	47	applied	\N	\N	\N	\N	8118	8118	8119
3004	2183	48	applied	\N	\N	\N	\N	8128	8128	8129
3004	2184	49	applied	\N	\N	\N	\N	8130	8130	8131
3004	2185	50	applied	\N	\N	\N	\N	8132	8132	8133
3004	2186	51	applied	\N	\N	\N	\N	8136	8136	8137
3004	2187	52	applied	\N	\N	\N	\N	8140	8140	8141
3004	2188	53	applied	\N	\N	\N	\N	8146	8146	8147
3004	2189	54	applied	\N	\N	\N	\N	8150	8150	8151
3004	2190	55	applied	\N	\N	\N	\N	8152	8152	8153
3004	2191	56	applied	\N	\N	\N	\N	8154	8154	8155
3004	2192	57	applied	\N	\N	\N	\N	8161	8161	8162
3004	2193	58	applied	\N	\N	\N	\N	8163	8163	8164
3004	2194	59	applied	\N	\N	\N	\N	8165	8165	8166
3004	2195	60	applied	\N	\N	\N	\N	8167	8167	8168
3004	2196	61	applied	\N	\N	\N	\N	8169	8169	8170
3004	2197	62	applied	\N	\N	\N	\N	8178	8178	8179
3004	2198	63	applied	\N	\N	\N	\N	8184	8184	8185
3004	2199	64	applied	\N	\N	\N	\N	8187	8187	8188
3004	2200	65	applied	\N	\N	\N	\N	8189	8189	8190
3004	2201	66	applied	\N	\N	\N	\N	8193	8193	8194
3004	2202	67	applied	\N	\N	\N	\N	8199	8199	8200
3004	2203	68	applied	\N	\N	\N	\N	8202	8202	8203
3010	2439	0	applied	\N	\N	\N	\N	9119	9119	9120
3010	2440	1	applied	\N	\N	\N	\N	9121	9121	9122
3013	2442	0	applied	\N	\N	\N	\N	9130	9130	9131
3016	2443	0	applied	\N	\N	\N	\N	9136	9136	9137
3019	2444	0	applied	\N	\N	\N	\N	9142	9142	9143
3022	2446	0	applied	\N	\N	\N	\N	9150	9150	9151
3025	2449	0	applied	\N	\N	\N	\N	9162	9162	9163
3028	2449	0	applied	\N	\N	\N	\N	9162	9162	9163
3031	2452	0	applied	\N	\N	\N	\N	9175	9175	9176
3034	2453	0	applied	\N	\N	\N	\N	9178	9178	9179
3037	2456	0	applied	\N	\N	\N	\N	9190	9190	9191
3040	2457	0	applied	\N	\N	\N	\N	9196	9196	9197
3042	2458	0	applied	\N	\N	\N	\N	9203	9203	9204
3042	2459	1	applied	\N	\N	\N	\N	9205	9205	9206
3045	2462	0	applied	\N	\N	\N	\N	9215	9215	9216
3048	2463	0	applied	\N	\N	\N	\N	9222	9222	9223
3048	2464	1	applied	\N	\N	\N	\N	9224	9224	9225
3051	2469	0	applied	\N	\N	\N	\N	9240	9240	9241
2925	2386	0	applied	\N	\N	\N	\N	8904	8904	8905
2925	2387	1	applied	\N	\N	\N	\N	8906	8906	8907
2930	2388	0	applied	\N	\N	\N	\N	8914	8914	8915
2930	2389	1	applied	\N	\N	\N	\N	8918	8918	8919
2942	2395	0	applied	\N	\N	\N	\N	8937	8937	8938
2954	2409	0	applied	\N	\N	\N	\N	8980	8980	8981
2962	2411	0	applied	\N	\N	\N	\N	8994	8994	8995
2965	2412	0	applied	\N	\N	\N	\N	8999	8999	9000
2968	2414	0	applied	\N	\N	\N	\N	9009	9009	9010
2971	2419	0	applied	\N	\N	\N	\N	9023	9023	9024
2971	2420	1	applied	\N	\N	\N	\N	9025	9025	9026
2971	2421	2	applied	\N	\N	\N	\N	9027	9027	9028
2974	2422	0	applied	\N	\N	\N	\N	9032	9032	9033
2978	2426	0	applied	\N	\N	\N	\N	9043	9043	9044
2980	2426	0	applied	\N	\N	\N	\N	9043	9043	9044
2981	2427	0	applied	\N	\N	\N	\N	9051	9051	9052
2984	2429	0	applied	\N	\N	\N	\N	9059	9059	9060
2987	2430	0	applied	\N	\N	\N	\N	9067	9067	9068
2990	2431	0	applied	\N	\N	\N	\N	9072	9072	9073
2990	2432	2	applied	\N	\N	\N	\N	9075	9075	9076
2990	2433	3	applied	\N	\N	\N	\N	9077	9077	9078
2993	2434	0	applied	\N	\N	\N	\N	9083	9083	9084
2996	2436	0	applied	\N	\N	\N	\N	9093	9093	9094
2996	2437	1	applied	\N	\N	\N	\N	9095	9095	9096
2999	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3011	2441	0	applied	\N	\N	\N	\N	9125	9125	9126
3014	2442	0	applied	\N	\N	\N	\N	9130	9130	9131
3020	2445	0	applied	\N	\N	\N	\N	9146	9146	9147
3023	2447	0	applied	\N	\N	\N	\N	9154	9154	9155
3029	2450	0	applied	\N	\N	\N	\N	9171	9171	9172
3032	2452	0	applied	\N	\N	\N	\N	9175	9175	9176
3035	2453	0	applied	\N	\N	\N	\N	9178	9178	9179
3038	2456	0	applied	\N	\N	\N	\N	9190	9190	9191
3043	2460	0	applied	\N	\N	\N	\N	9208	9208	9209
3043	2461	1	applied	\N	\N	\N	\N	9210	9210	9211
3046	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3046	2429	1	applied	\N	\N	\N	\N	9059	9059	9060
3046	2430	2	applied	\N	\N	\N	\N	9067	9067	9068
3046	2431	3	applied	\N	\N	\N	\N	9072	9072	9073
3046	2432	4	applied	\N	\N	\N	\N	9075	9075	9076
3046	2433	5	applied	\N	\N	\N	\N	9077	9077	9078
3046	2434	6	applied	\N	\N	\N	\N	9083	9083	9084
3046	2435	8	applied	\N	\N	\N	\N	9089	9089	9090
3046	2436	9	applied	\N	\N	\N	\N	9093	9093	9094
3046	2437	10	applied	\N	\N	\N	\N	9095	9095	9096
3046	2439	11	applied	\N	\N	\N	\N	9119	9119	9120
3046	2440	12	applied	\N	\N	\N	\N	9121	9121	9122
3046	2441	13	applied	\N	\N	\N	\N	9125	9125	9126
3046	2442	14	applied	\N	\N	\N	\N	9130	9130	9131
3046	2443	15	applied	\N	\N	\N	\N	9136	9136	9137
3046	2444	16	applied	\N	\N	\N	\N	9142	9142	9143
3046	2445	17	applied	\N	\N	\N	\N	9146	9146	9147
3046	2446	18	applied	\N	\N	\N	\N	9150	9150	9151
3046	2447	19	applied	\N	\N	\N	\N	9154	9154	9155
3046	2448	20	applied	\N	\N	\N	\N	9158	9158	9159
3046	2449	21	applied	\N	\N	\N	\N	9162	9162	9163
3046	2450	22	applied	\N	\N	\N	\N	9171	9171	9172
3046	2451	23	applied	\N	\N	\N	\N	9173	9173	9174
3046	2452	24	applied	\N	\N	\N	\N	9175	9175	9176
3046	2453	25	applied	\N	\N	\N	\N	9178	9178	9179
3046	2454	26	applied	\N	\N	\N	\N	9184	9184	9185
3046	2455	27	applied	\N	\N	\N	\N	9186	9186	9187
3046	2456	28	applied	\N	\N	\N	\N	9190	9190	9191
3046	2457	29	applied	\N	\N	\N	\N	9196	9196	9197
3046	2458	30	applied	\N	\N	\N	\N	9203	9203	9204
3046	2459	31	applied	\N	\N	\N	\N	9205	9205	9206
3046	2460	32	applied	\N	\N	\N	\N	9208	9208	9209
3046	2461	33	applied	\N	\N	\N	\N	9210	9210	9211
3046	2462	34	applied	\N	\N	\N	\N	9215	9215	9216
3049	2465	0	applied	\N	\N	\N	\N	9229	9229	9230
3052	2470	0	applied	\N	\N	\N	\N	9244	9244	9245
3052	2471	1	applied	\N	\N	\N	\N	9246	9246	9247
3055	2472	0	applied	\N	\N	\N	\N	9250	9250	9251
3058	2473	0	applied	\N	\N	1000000000	\N	9253	9253	9254
3058	2474	1	applied	\N	\N	\N	\N	9255	9255	9256
3058	2475	2	applied	\N	\N	\N	\N	9257	9257	9258
3064	2477	0	applied	\N	\N	\N	\N	9267	9267	9268
3067	2479	0	applied	\N	\N	\N	\N	9275	9275	9276
3070	2482	0	applied	\N	\N	\N	\N	9287	9287	9288
3070	2483	1	applied	\N	\N	\N	\N	9289	9289	9290
3073	2485	0	applied	\N	\N	\N	\N	9296	9296	9297
3085	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3088	2489	0	applied	\N	\N	\N	\N	9327	9327	9328
3088	2490	1	applied	\N	\N	\N	\N	9329	9329	9330
3091	2493	0	applied	\N	\N	\N	\N	9339	9339	9340
3093	2494	0	applied	\N	\N	\N	\N	9346	9346	9347
3093	2495	1	applied	\N	\N	\N	\N	9348	9348	9349
3093	2496	2	applied	\N	\N	\N	\N	9350	9350	9351
3093	2497	3	applied	\N	\N	\N	\N	9352	9352	9353
3093	2498	4	applied	\N	\N	\N	\N	9354	9354	9355
3093	2499	5	applied	\N	\N	\N	\N	9356	9356	9357
3093	2500	6	applied	\N	\N	\N	\N	9358	9358	9359
3093	2501	7	applied	\N	\N	1000000000	\N	9360	9360	9361
3096	2502	0	applied	\N	\N	\N	\N	9368	9368	9369
3096	2503	1	applied	\N	\N	\N	\N	9370	9370	9371
3096	2504	2	applied	\N	\N	\N	\N	9372	9372	9373
3099	2505	0	applied	\N	\N	\N	\N	9378	9378	9379
3102	2507	0	applied	\N	\N	\N	\N	9385	9385	9386
3108	2512	0	applied	\N	\N	\N	\N	9399	9399	9400
3108	2513	1	applied	\N	\N	\N	\N	9401	9401	9402
3108	2514	2	applied	\N	\N	\N	\N	9403	9403	9404
3114	2518	0	applied	\N	\N	\N	\N	9422	9422	9423
3117	2522	0	applied	\N	\N	\N	\N	9434	9434	9435
3117	2523	1	applied	\N	\N	\N	\N	9436	9436	9437
3120	2526	0	applied	\N	\N	\N	\N	9446	9446	9447
3120	2527	1	applied	\N	\N	\N	\N	9448	9448	9449
3120	2528	2	applied	\N	\N	\N	\N	9450	9450	9451
3120	2529	3	applied	\N	\N	\N	\N	9452	9452	9453
3120	2530	4	applied	\N	\N	\N	\N	9454	9454	9455
3120	2531	5	applied	\N	\N	\N	\N	9456	9456	9457
3120	2532	6	applied	\N	\N	\N	\N	9458	9458	9459
3120	2533	7	applied	\N	\N	\N	\N	9460	9460	9461
3120	2534	8	applied	\N	\N	\N	\N	9462	9462	9463
3120	2535	9	applied	\N	\N	\N	\N	9464	9464	9465
3120	2536	10	applied	\N	\N	\N	\N	9466	9466	9467
3120	2537	11	applied	\N	\N	\N	\N	9468	9468	9469
3123	2538	0	applied	\N	\N	\N	\N	9473	9473	9474
3123	2539	1	applied	\N	\N	\N	\N	9475	9475	9476
3123	2540	2	applied	\N	\N	\N	\N	9477	9477	9478
3054	2472	0	applied	\N	\N	\N	\N	9250	9250	9251
3063	2476	0	applied	\N	\N	\N	\N	9264	9264	9265
3072	2485	0	applied	\N	\N	\N	\N	9296	9296	9297
3074	2485	0	applied	\N	\N	\N	\N	9296	9296	9297
3075	2485	0	applied	\N	\N	\N	\N	9296	9296	9297
3078	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3080	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3081	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3084	2473	0	applied	\N	\N	1000000000	\N	9261	9261	9254
3084	2463	1	applied	\N	\N	\N	\N	9222	9222	9223
3084	2464	2	applied	\N	\N	\N	\N	9224	9224	9225
3084	2465	3	applied	\N	\N	\N	\N	9229	9229	9230
3084	2466	4	applied	\N	\N	\N	\N	9233	9233	9234
3084	2467	5	applied	\N	\N	\N	\N	9235	9235	9236
3084	2468	6	applied	\N	\N	\N	\N	9237	9237	9238
3084	2469	7	applied	\N	\N	\N	\N	9240	9240	9241
3084	2470	8	applied	\N	\N	\N	\N	9244	9244	9245
3084	2471	9	applied	\N	\N	\N	\N	9246	9246	9247
3084	2472	10	applied	\N	\N	\N	\N	9250	9250	9251
3084	2474	11	applied	\N	\N	\N	\N	9255	9255	9256
3084	2475	12	applied	\N	\N	\N	\N	9257	9257	9258
3084	2476	13	applied	\N	\N	\N	\N	9264	9264	9265
3084	2477	14	applied	\N	\N	\N	\N	9267	9267	9268
3084	2478	15	applied	\N	\N	\N	\N	9271	9271	9272
3084	2479	16	applied	\N	\N	\N	\N	9275	9275	9276
3084	2480	17	applied	\N	\N	\N	\N	9279	9279	9280
3084	2481	18	applied	\N	\N	\N	\N	9281	9281	9282
3084	2482	19	applied	\N	\N	\N	\N	9287	9287	9288
3084	2483	20	applied	\N	\N	\N	\N	9289	9289	9290
3084	2484	21	applied	\N	\N	\N	\N	9292	9292	9293
3084	2485	22	applied	\N	\N	\N	\N	9296	9296	9297
3084	2486	23	applied	\N	\N	\N	\N	9307	9307	9308
3087	2489	0	applied	\N	\N	\N	\N	9327	9327	9328
3087	2490	1	applied	\N	\N	\N	\N	9329	9329	9330
3090	2492	0	applied	\N	\N	\N	\N	9337	9337	9338
3095	2494	0	applied	\N	\N	\N	\N	9346	9346	9347
3095	2495	1	applied	\N	\N	\N	\N	9348	9348	9349
3095	2496	2	applied	\N	\N	\N	\N	9350	9350	9351
3095	2497	3	applied	\N	\N	\N	\N	9352	9352	9353
3095	2498	4	applied	\N	\N	\N	\N	9354	9354	9355
3095	2499	5	applied	\N	\N	\N	\N	9356	9356	9357
3095	2500	6	applied	\N	\N	\N	\N	9358	9358	9359
3095	2501	7	applied	\N	\N	1000000000	\N	9360	9360	9361
3098	2505	0	applied	\N	\N	\N	\N	9378	9378	9379
3101	2506	0	applied	\N	\N	\N	\N	9382	9382	9383
3104	2510	0	applied	\N	\N	\N	\N	9393	9393	9394
3106	2510	0	applied	\N	\N	\N	\N	9393	9393	9394
3107	2511	0	applied	\N	\N	\N	\N	9397	9397	9398
3109	2512	0	applied	\N	\N	\N	\N	9399	9399	9400
3109	2513	1	applied	\N	\N	\N	\N	9401	9401	9402
3109	2514	2	applied	\N	\N	\N	\N	9403	9403	9404
3110	2515	0	applied	\N	\N	\N	\N	9408	9408	9409
3110	2516	1	applied	\N	\N	\N	\N	9410	9410	9411
3113	2517	0	applied	\N	\N	\N	\N	9418	9418	9419
3116	2519	0	applied	\N	\N	\N	\N	9426	9426	9427
3116	2520	1	applied	\N	\N	\N	\N	9428	9428	9429
3116	2521	2	applied	\N	\N	\N	\N	9430	9430	9431
3119	2525	0	applied	\N	\N	\N	\N	9442	9442	9443
3122	2538	0	applied	\N	\N	\N	\N	9473	9473	9474
3122	2539	1	applied	\N	\N	\N	\N	9475	9475	9476
3122	2540	2	applied	\N	\N	\N	\N	9477	9477	9478
3076	2336	32	applied	\N	\N	\N	\N	8701	8701	8702
3076	2337	33	applied	\N	\N	\N	\N	8706	8706	8707
3076	2338	34	applied	\N	\N	\N	\N	8708	8708	8709
3076	2339	35	applied	\N	\N	\N	\N	8711	8711	8712
3076	2340	36	applied	\N	\N	\N	\N	8715	8715	8716
3076	2341	37	applied	\N	\N	\N	\N	8722	8722	8723
3076	2342	38	applied	\N	\N	\N	\N	8724	8724	8725
3076	2343	39	applied	\N	\N	\N	\N	8730	8730	8731
3076	2344	40	applied	\N	\N	\N	\N	8732	8732	8733
3076	2346	41	applied	\N	\N	\N	\N	8743	8743	8744
3076	2347	42	applied	\N	\N	\N	\N	8747	8747	8748
3076	2348	43	applied	\N	\N	\N	\N	8749	8749	8750
3076	2349	44	applied	\N	\N	\N	\N	8753	8753	8754
3076	2350	45	applied	\N	\N	\N	\N	8756	8756	8757
3076	2351	46	applied	\N	\N	\N	\N	8758	8758	8759
3076	2352	47	applied	\N	\N	\N	\N	8760	8760	8761
3076	2353	48	applied	\N	\N	\N	\N	8767	8767	8768
3076	2354	49	applied	\N	\N	\N	\N	8771	8771	8772
3076	2355	50	applied	\N	\N	\N	\N	8775	8775	8776
3076	2356	51	applied	\N	\N	\N	\N	8777	8777	8778
3076	2357	52	applied	\N	\N	\N	\N	8779	8779	8780
3076	2358	53	applied	\N	\N	\N	\N	8783	8783	8784
3076	2359	54	applied	\N	\N	\N	\N	8789	8789	8790
3076	2360	55	applied	\N	\N	\N	\N	8793	8793	8794
3076	2361	56	applied	\N	\N	\N	\N	8797	8797	8798
3076	2362	57	applied	\N	\N	\N	\N	8803	8803	8804
3076	2363	58	applied	\N	\N	\N	\N	8813	8813	8814
3076	2364	59	applied	\N	\N	\N	\N	8815	8815	8816
3076	2365	60	applied	\N	\N	\N	\N	8817	8817	8818
3076	2366	61	applied	\N	\N	\N	\N	8821	8821	8822
3076	2367	62	applied	\N	\N	\N	\N	8823	8823	8824
3076	2368	63	applied	\N	\N	\N	\N	8827	8827	8828
3076	2369	64	applied	\N	\N	\N	\N	8830	8830	8831
3076	2370	65	applied	\N	\N	\N	\N	8835	8835	8836
3076	2371	66	applied	\N	\N	\N	\N	8837	8837	8838
3076	2372	67	applied	\N	\N	\N	\N	8841	8841	8842
3076	2373	68	applied	\N	\N	\N	\N	8843	8843	8844
3076	2374	69	applied	\N	\N	\N	\N	8845	8845	8846
3076	2375	70	applied	\N	\N	\N	\N	8847	8847	8848
3076	2376	71	applied	\N	\N	\N	\N	8860	8860	8861
3076	2377	72	applied	\N	\N	\N	\N	8862	8862	8863
3076	2378	73	applied	\N	\N	\N	\N	8864	8864	8865
3076	2379	74	applied	\N	\N	\N	\N	8866	8866	8867
3076	2380	75	applied	\N	\N	\N	\N	8868	8868	8869
3076	2381	76	applied	\N	\N	\N	\N	8882	8882	8883
3076	2382	77	applied	\N	\N	\N	\N	8889	8889	8890
3076	2383	78	applied	\N	\N	\N	\N	8891	8891	8892
3076	2384	79	applied	\N	\N	\N	\N	8893	8893	8894
3076	2385	80	applied	\N	\N	\N	\N	8897	8897	8898
3076	2386	81	applied	\N	\N	\N	\N	8904	8904	8905
3076	2387	82	applied	\N	\N	\N	\N	8906	8906	8907
3076	2388	83	applied	\N	\N	\N	\N	8914	8914	8915
3076	2389	84	applied	\N	\N	\N	\N	8918	8918	8919
3076	2390	85	applied	\N	\N	\N	\N	8922	8922	8923
3076	2391	86	applied	\N	\N	\N	\N	8924	8924	8925
3076	2392	87	applied	\N	\N	\N	\N	8927	8927	8928
3076	2393	88	applied	\N	\N	\N	\N	8931	8931	8932
3076	2394	89	applied	\N	\N	\N	\N	8935	8935	8936
3076	2395	90	applied	\N	\N	\N	\N	8937	8937	8938
3076	2396	91	applied	\N	\N	\N	\N	8941	8941	8942
3076	2397	92	applied	\N	\N	\N	\N	8946	8946	8947
3076	2398	93	applied	\N	\N	\N	\N	8948	8948	8949
3076	2399	94	applied	\N	\N	\N	\N	8952	8952	8953
3076	2400	95	applied	\N	\N	\N	\N	8958	8958	8959
3076	2401	96	applied	\N	\N	\N	\N	8960	8960	8961
3076	2402	97	applied	\N	\N	\N	\N	8962	8962	8963
3076	2403	98	applied	\N	\N	\N	\N	8964	8964	8965
3076	2404	99	applied	\N	\N	\N	\N	8967	8967	8968
3076	2405	100	applied	\N	\N	\N	\N	8969	8969	8970
3076	2406	101	applied	\N	\N	\N	\N	8971	8971	8972
3076	2407	102	applied	\N	\N	\N	\N	8973	8973	8974
3076	2408	103	applied	\N	\N	\N	\N	8976	8976	8977
3076	2409	104	applied	\N	\N	\N	\N	8980	8980	8981
3076	2410	105	applied	\N	\N	\N	\N	8987	8987	8988
3076	2411	106	applied	\N	\N	\N	\N	8994	8994	8995
3076	2412	107	applied	\N	\N	\N	\N	8999	8999	9000
3076	2413	108	applied	\N	\N	\N	\N	9005	9005	9006
3076	2414	109	applied	\N	\N	\N	\N	9009	9009	9010
3076	2415	110	applied	\N	\N	\N	\N	9013	9013	9014
3076	2416	111	applied	\N	\N	\N	\N	9015	9015	9016
3076	2417	112	applied	\N	\N	\N	\N	9017	9017	9018
3076	2418	113	applied	\N	\N	\N	\N	9019	9019	9020
3076	2419	114	applied	\N	\N	\N	\N	9023	9023	9024
3076	2420	115	applied	\N	\N	\N	\N	9025	9025	9026
3076	2421	116	applied	\N	\N	\N	\N	9027	9027	9028
3076	2422	117	applied	\N	\N	\N	\N	9032	9032	9033
3076	2423	118	applied	\N	\N	\N	\N	9035	9035	9036
3076	2424	119	applied	\N	\N	\N	\N	9037	9037	9038
3076	2425	120	applied	\N	\N	\N	\N	9041	9041	9042
3076	2426	121	applied	\N	\N	\N	\N	9043	9043	9044
3076	2427	122	applied	\N	\N	\N	\N	9051	9051	9052
3076	2428	123	applied	\N	\N	\N	\N	9055	9055	9056
3076	2429	124	applied	\N	\N	\N	\N	9059	9059	9060
3076	2430	125	applied	\N	\N	\N	\N	9067	9067	9068
3077	2486	0	applied	\N	\N	\N	\N	9307	9307	9308
3079	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3082	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3083	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3086	2488	0	applied	\N	\N	\N	\N	9325	9325	9326
3089	2491	0	applied	\N	\N	\N	\N	9335	9335	9336
3092	2438	0	applied	\N	\N	\N	\N	9107	9107	9343
3092	2473	1	applied	\N	\N	1000000000	\N	9261	9261	9254
3092	2307	2	applied	\N	\N	1000000000	\N	9109	9109	8618
3092	2226	3	applied	\N	\N	\N	\N	8287	8287	8288
3092	2227	4	applied	\N	\N	\N	\N	8291	8291	8292
3092	2228	5	applied	\N	\N	\N	\N	8302	8302	8303
3092	2229	6	applied	\N	\N	\N	\N	8304	8304	8305
3092	2230	7	applied	\N	\N	\N	\N	8308	8308	8309
3092	2231	8	applied	\N	\N	\N	\N	8312	8312	8313
3092	2232	9	applied	\N	\N	\N	\N	8318	8318	8319
3092	2233	10	applied	\N	\N	\N	\N	8322	8322	8323
3092	2234	11	applied	\N	\N	\N	\N	8327	8327	8328
3092	2235	12	applied	\N	\N	\N	\N	8331	8331	8332
3092	2236	13	applied	\N	\N	\N	\N	8333	8333	8334
3092	2237	14	applied	\N	\N	\N	\N	8335	8335	8336
3092	2309	15	applied	\N	\N	\N	\N	9110	9110	8624
3092	2238	16	applied	\N	\N	\N	\N	8339	8339	8340
3092	2239	17	applied	\N	\N	\N	\N	8341	8341	8342
3092	2240	18	applied	\N	\N	\N	\N	8347	8347	8348
3092	2241	19	applied	\N	\N	\N	\N	8349	8349	8350
3092	2242	20	applied	\N	\N	\N	\N	8353	8353	8354
3092	2243	21	applied	\N	\N	\N	\N	8359	8359	8360
3092	2244	22	applied	\N	\N	\N	\N	8363	8363	8364
3092	2245	23	applied	\N	\N	\N	\N	8365	8365	8366
3092	2246	24	applied	\N	\N	\N	\N	8375	8375	8376
3092	2247	25	applied	\N	\N	\N	\N	8379	8379	8380
3092	2248	26	applied	\N	\N	\N	\N	8382	8382	8383
3092	2249	27	applied	\N	\N	\N	\N	8384	8384	8385
3092	2250	28	applied	\N	\N	\N	\N	8390	8390	8391
3092	2251	29	applied	\N	\N	\N	\N	8392	8392	8393
3092	2252	30	applied	\N	\N	\N	\N	8394	8394	8395
3092	2253	31	applied	\N	\N	\N	\N	8399	8399	8400
3092	2254	32	applied	\N	\N	\N	\N	8405	8405	8406
3092	2255	33	applied	\N	\N	\N	\N	8410	8410	8411
3092	2256	34	applied	\N	\N	\N	\N	8412	8412	8413
3092	2257	35	applied	\N	\N	\N	\N	8419	8419	8420
3092	2258	36	applied	\N	\N	\N	\N	8429	8429	8430
3092	2259	37	applied	\N	\N	\N	\N	8434	8434	8435
3092	2260	38	applied	\N	\N	\N	\N	8454	8454	8455
3092	2261	39	applied	\N	\N	\N	\N	8456	8456	8457
3092	2262	40	applied	\N	\N	\N	\N	8458	8458	8459
3092	2263	41	applied	\N	\N	\N	\N	8460	8460	8461
3092	2264	42	applied	\N	\N	\N	\N	8464	8464	8465
3092	2265	43	applied	\N	\N	\N	\N	8470	8470	8471
3092	2266	44	applied	\N	\N	\N	\N	8473	8473	8474
3092	2267	45	applied	\N	\N	\N	\N	8475	8475	8476
3092	2268	46	applied	\N	\N	\N	\N	8477	8477	8478
3092	2269	47	applied	\N	\N	\N	\N	8479	8479	8480
3092	2270	48	applied	\N	\N	\N	\N	8481	8481	8482
3092	2271	49	applied	\N	\N	\N	\N	8485	8485	8486
3092	2272	50	applied	\N	\N	\N	\N	8489	8489	8490
3092	2273	51	applied	\N	\N	\N	\N	8493	8493	8494
3092	2274	52	applied	\N	\N	\N	\N	8495	8495	8496
3092	2275	53	applied	\N	\N	\N	\N	8497	8497	8498
3092	2276	54	applied	\N	\N	\N	\N	8499	8499	8500
3092	2277	55	applied	\N	\N	\N	\N	8501	8501	8502
3092	2278	56	applied	\N	\N	\N	\N	8506	8506	8507
3092	2279	57	applied	\N	\N	\N	\N	8508	8508	8509
3092	2280	58	applied	\N	\N	\N	\N	8513	8513	8514
3092	2281	59	applied	\N	\N	\N	\N	8517	8517	8518
3092	2282	60	applied	\N	\N	\N	\N	8519	8519	8520
3092	2283	61	applied	\N	\N	\N	\N	8523	8523	8524
3092	2284	62	applied	\N	\N	\N	\N	8529	8529	8530
3092	2286	63	applied	\N	\N	\N	\N	8536	8536	8537
3092	2287	64	applied	\N	\N	\N	\N	8542	8542	8543
3092	2288	65	applied	\N	\N	\N	\N	8546	8546	8547
3092	2289	66	applied	\N	\N	\N	\N	8550	8550	8551
3092	2290	67	applied	\N	\N	\N	\N	8558	8558	8559
3092	2291	68	applied	\N	\N	\N	\N	8560	8560	8561
3092	2292	69	applied	\N	\N	\N	\N	8562	8562	8563
3092	2293	70	applied	\N	\N	\N	\N	8564	8564	8565
3092	2294	71	applied	\N	\N	\N	\N	8571	8571	8572
3092	2295	72	applied	\N	\N	\N	\N	8573	8573	8574
3092	2296	73	applied	\N	\N	\N	\N	8575	8575	8576
3092	2297	74	applied	\N	\N	\N	\N	8588	8588	8589
3092	2298	75	applied	\N	\N	\N	\N	8592	8592	8593
3092	2299	76	applied	\N	\N	\N	\N	8594	8594	8595
3092	2300	77	applied	\N	\N	\N	\N	8599	8599	8600
3092	2301	78	applied	\N	\N	\N	\N	8601	8601	8602
3092	2302	79	applied	\N	\N	\N	\N	8603	8603	8604
3092	2303	80	applied	\N	\N	\N	\N	8607	8607	8608
3092	2304	81	applied	\N	\N	\N	\N	8611	8611	8612
3092	2305	82	applied	\N	\N	\N	\N	8613	8613	8614
3092	2306	83	applied	\N	\N	\N	\N	8615	8615	8616
3092	2308	84	applied	\N	\N	\N	\N	8619	8619	8620
3092	2311	85	applied	\N	\N	\N	\N	8631	8631	8632
3092	2312	86	applied	\N	\N	\N	\N	8633	8633	8634
3092	2313	87	applied	\N	\N	\N	\N	8635	8635	8636
3092	2314	88	applied	\N	\N	\N	\N	8637	8637	8638
3092	2315	89	applied	\N	\N	\N	\N	8639	8639	8640
3092	2316	90	applied	\N	\N	\N	\N	8641	8641	8642
3092	2317	91	applied	\N	\N	\N	\N	8643	8643	8644
3092	2318	92	applied	\N	\N	\N	\N	8645	8645	8646
3092	2319	93	applied	\N	\N	\N	\N	8651	8651	8652
3092	2320	94	applied	\N	\N	\N	\N	8653	8653	8654
3092	2321	95	applied	\N	\N	\N	\N	8657	8657	8658
3092	2322	96	applied	\N	\N	\N	\N	8660	8660	8661
3092	2323	97	applied	\N	\N	\N	\N	8662	8662	8663
3092	2324	98	applied	\N	\N	\N	\N	8664	8664	8665
3092	2326	99	applied	\N	\N	\N	\N	8670	8670	8671
3092	2327	100	applied	\N	\N	\N	\N	8672	8672	8673
3092	2328	101	applied	\N	\N	\N	\N	8674	8674	8675
3092	2329	102	applied	\N	\N	\N	\N	8678	8678	8679
3092	2330	103	applied	\N	\N	\N	\N	8682	8682	8683
3092	2331	104	applied	\N	\N	\N	\N	8684	8684	8685
3092	2332	105	applied	\N	\N	\N	\N	8687	8687	8688
3092	2333	106	applied	\N	\N	\N	\N	8689	8689	8690
3092	2334	107	applied	\N	\N	\N	\N	8693	8693	8694
3092	2335	108	applied	\N	\N	\N	\N	8697	8697	8698
3092	2336	109	applied	\N	\N	\N	\N	8701	8701	8702
3092	2337	110	applied	\N	\N	\N	\N	8706	8706	8707
3092	2338	111	applied	\N	\N	\N	\N	8708	8708	8709
3092	2339	112	applied	\N	\N	\N	\N	8711	8711	8712
3092	2340	113	applied	\N	\N	\N	\N	8715	8715	8716
3092	2341	114	applied	\N	\N	\N	\N	8722	8722	8723
3092	2342	115	applied	\N	\N	\N	\N	8724	8724	8725
3092	2343	116	applied	\N	\N	\N	\N	8730	8730	8731
3092	2344	117	applied	\N	\N	\N	\N	8732	8732	8733
3092	2346	118	applied	\N	\N	\N	\N	8743	8743	8744
3092	2347	119	applied	\N	\N	\N	\N	8747	8747	8748
3092	2348	120	applied	\N	\N	\N	\N	8749	8749	8750
3092	2349	121	applied	\N	\N	\N	\N	8753	8753	8754
3092	2350	122	applied	\N	\N	\N	\N	8756	8756	8757
3092	2351	123	applied	\N	\N	\N	\N	8758	8758	8759
3092	2352	124	applied	\N	\N	\N	\N	8760	8760	8761
3092	2353	125	applied	\N	\N	\N	\N	8767	8767	8768
3094	2494	0	applied	\N	\N	\N	\N	9346	9346	9347
3094	2495	1	applied	\N	\N	\N	\N	9348	9348	9349
3094	2496	2	applied	\N	\N	\N	\N	9350	9350	9351
3094	2497	3	applied	\N	\N	\N	\N	9352	9352	9353
3094	2498	4	applied	\N	\N	\N	\N	9354	9354	9355
3094	2499	5	applied	\N	\N	\N	\N	9356	9356	9357
3094	2500	6	applied	\N	\N	\N	\N	9358	9358	9359
3094	2501	7	applied	\N	\N	1000000000	\N	9360	9360	9361
3097	2502	0	applied	\N	\N	\N	\N	9368	9368	9369
3097	2503	1	applied	\N	\N	\N	\N	9370	9370	9371
3097	2504	2	applied	\N	\N	\N	\N	9372	9372	9373
3100	2506	0	applied	\N	\N	\N	\N	9382	9382	9383
3103	2508	0	applied	\N	\N	\N	\N	9387	9387	9388
3103	2509	1	applied	\N	\N	\N	\N	9389	9389	9390
3111	2515	0	applied	\N	\N	\N	\N	9408	9408	9409
3111	2516	1	applied	\N	\N	\N	\N	9410	9410	9411
3112	2515	0	applied	\N	\N	\N	\N	9408	9408	9409
3112	2516	1	applied	\N	\N	\N	\N	9410	9410	9411
3115	2519	0	applied	\N	\N	\N	\N	9426	9426	9427
3115	2520	1	applied	\N	\N	\N	\N	9428	9428	9429
3115	2521	2	applied	\N	\N	\N	\N	9430	9430	9431
3118	2524	0	applied	\N	\N	\N	\N	9440	9440	9441
3121	2526	0	applied	\N	\N	\N	\N	9446	9446	9447
3121	2527	1	applied	\N	\N	\N	\N	9448	9448	9449
3121	2528	2	applied	\N	\N	\N	\N	9450	9450	9451
3121	2529	3	applied	\N	\N	\N	\N	9452	9452	9453
3121	2530	4	applied	\N	\N	\N	\N	9454	9454	9455
3121	2531	5	applied	\N	\N	\N	\N	9456	9456	9457
3121	2532	6	applied	\N	\N	\N	\N	9458	9458	9459
3121	2533	7	applied	\N	\N	\N	\N	9460	9460	9461
3121	2534	8	applied	\N	\N	\N	\N	9462	9462	9463
3121	2535	9	applied	\N	\N	\N	\N	9464	9464	9465
3121	2536	10	applied	\N	\N	\N	\N	9466	9466	9467
3121	2537	11	applied	\N	\N	\N	\N	9468	9468	9469
3124	2541	0	applied	\N	\N	\N	\N	9483	9483	9484
3124	2542	1	applied	\N	\N	\N	\N	9485	9485	9486
3124	2543	2	applied	\N	\N	\N	\N	9487	9487	9488
3124	2544	3	applied	\N	\N	\N	\N	9489	9489	9490
3125	2545	0	applied	\N	\N	\N	\N	9492	9492	9493
3125	2546	1	applied	\N	\N	\N	\N	9494	9494	9495
3125	2547	2	applied	\N	\N	\N	\N	9496	9496	9497
3128	2548	0	applied	\N	\N	\N	\N	9500	9500	9501
3128	2549	1	applied	\N	\N	\N	\N	9502	9502	9503
3128	2550	2	applied	\N	\N	\N	\N	9504	9504	9505
3128	2551	3	applied	\N	\N	\N	\N	9506	9506	9507
3129	2552	0	applied	\N	\N	\N	\N	9510	9510	9511
3130	2552	0	applied	\N	\N	\N	\N	9510	9510	9511
3131	2501	0	applied	\N	\N	1000000000	\N	9360	9360	9361
3131	2504	1	applied	\N	\N	\N	\N	9372	9372	9373
3131	2526	2	applied	\N	\N	\N	\N	9446	9446	9447
3131	2527	3	applied	\N	\N	\N	\N	9448	9448	9449
3131	2530	4	applied	\N	\N	\N	\N	9454	9454	9455
3131	2531	5	applied	\N	\N	\N	\N	9456	9456	9457
3131	2532	6	applied	\N	\N	\N	\N	9458	9458	9459
3131	2533	7	applied	\N	\N	\N	\N	9460	9460	9461
3131	2534	8	applied	\N	\N	\N	\N	9462	9462	9463
3131	2535	9	applied	\N	\N	\N	\N	9464	9464	9465
3131	2536	10	applied	\N	\N	\N	\N	9466	9466	9467
3131	2537	11	applied	\N	\N	\N	\N	9468	9468	9469
3131	2544	12	applied	\N	\N	\N	\N	9489	9489	9490
3132	2553	0	applied	\N	\N	\N	\N	9514	9514	9515
3133	2553	0	applied	\N	\N	\N	\N	9514	9514	9515
3134	2554	0	applied	\N	\N	\N	\N	9520	9520	9521
3135	2555	0	applied	\N	\N	\N	\N	9524	9524	9525
3136	2555	0	applied	\N	\N	\N	\N	9524	9524	9525
3137	2555	0	applied	\N	\N	\N	\N	9524	9524	9525
3138	2556	0	applied	\N	\N	\N	\N	9529	9529	9530
3138	2557	1	applied	\N	\N	\N	\N	9531	9531	9532
3138	2558	2	applied	\N	\N	\N	\N	9533	9533	9534
3138	2559	3	applied	\N	\N	\N	\N	9535	9535	9536
3139	2556	0	applied	\N	\N	\N	\N	9529	9529	9530
3139	2557	1	applied	\N	\N	\N	\N	9531	9531	9532
3139	2558	2	applied	\N	\N	\N	\N	9533	9533	9534
3139	2559	3	applied	\N	\N	\N	\N	9535	9535	9536
3140	2560	0	applied	\N	\N	\N	\N	9541	9541	9542
3140	2561	1	applied	\N	\N	\N	\N	9543	9543	9544
3141	2562	0	applied	\N	\N	\N	\N	9545	9545	9546
3141	2563	1	applied	\N	\N	\N	\N	9547	9547	9548
3141	2564	2	applied	\N	\N	\N	\N	9549	9549	9550
3141	2565	3	applied	\N	\N	\N	\N	9551	9551	9552
3141	2566	4	applied	\N	\N	\N	\N	9553	9553	9554
3142	2567	0	applied	\N	\N	\N	\N	9556	9556	9557
3143	2567	0	applied	\N	\N	\N	\N	9556	9556	9557
3144	2567	0	applied	\N	\N	\N	\N	9556	9556	9557
3145	2567	0	applied	\N	\N	\N	\N	9556	9556	9557
3146	2568	0	applied	\N	\N	\N	\N	9564	9564	9565
3147	2568	0	applied	\N	\N	\N	\N	9564	9564	9565
3148	2569	0	applied	\N	\N	\N	\N	9570	9570	9571
3148	2570	1	applied	\N	\N	\N	\N	9572	9572	9573
3149	2569	0	applied	\N	\N	\N	\N	9570	9570	9571
3149	2570	1	applied	\N	\N	\N	\N	9572	9572	9573
3150	2571	0	applied	\N	\N	\N	\N	9578	9578	9579
3151	2569	0	applied	\N	\N	\N	\N	9570	9570	9571
3151	2570	1	applied	\N	\N	\N	\N	9572	9572	9573
3151	2571	2	applied	\N	\N	\N	\N	9578	9578	9579
3152	2571	0	applied	\N	\N	\N	\N	9578	9578	9579
3153	2572	0	applied	\N	\N	\N	\N	9584	9584	9585
3154	2573	0	applied	\N	\N	\N	\N	9586	9586	9587
3155	2574	0	applied	\N	\N	\N	\N	9590	9590	9591
3156	2574	0	applied	\N	\N	\N	\N	9590	9590	9591
3157	2574	0	applied	\N	\N	\N	\N	9590	9590	9591
3158	2574	0	applied	\N	\N	\N	\N	9590	9590	9591
3159	2575	0	applied	\N	\N	\N	\N	9595	9595	9596
3160	2575	0	applied	\N	\N	\N	\N	9595	9595	9596
3161	2575	0	applied	\N	\N	\N	\N	9595	9595	9596
3162	2575	0	applied	\N	\N	\N	\N	9595	9595	9596
3163	2576	0	applied	\N	\N	\N	\N	9603	9603	9604
3164	2577	0	applied	\N	\N	\N	\N	9607	9607	9608
3165	2578	0	applied	\N	\N	\N	\N	9610	9610	9611
3165	2579	1	applied	\N	\N	\N	\N	9612	9612	9613
3165	2580	2	applied	\N	\N	\N	\N	9614	9614	9615
3165	2581	3	applied	\N	\N	\N	\N	9616	9616	9617
3165	2582	4	applied	\N	\N	\N	\N	9618	9618	9619
3166	2583	0	applied	\N	\N	\N	\N	9622	9622	9623
3167	2583	0	applied	\N	\N	\N	\N	9622	9622	9623
3168	2584	0	applied	\N	\N	\N	\N	9627	9627	9628
3169	2584	0	applied	\N	\N	\N	\N	9627	9627	9628
3170	2585	0	applied	\N	\N	\N	\N	9633	9633	9634
3171	2585	0	applied	\N	\N	\N	\N	9633	9633	9634
3172	2585	0	applied	\N	\N	\N	\N	9633	9633	9634
3173	2585	0	applied	\N	\N	\N	\N	9633	9633	9634
3174	2586	0	applied	\N	\N	\N	\N	9638	9638	9639
3175	2586	0	applied	\N	\N	\N	\N	9638	9638	9639
3176	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3176	2473	1	applied	\N	\N	1000000000	\N	9261	9261	9254
3177	2587	0	applied	\N	\N	\N	\N	9642	9642	9643
3177	2588	1	applied	\N	\N	\N	\N	9644	9644	9645
3178	2587	0	applied	\N	\N	\N	\N	9642	9642	9643
3178	2588	1	applied	\N	\N	\N	\N	9644	9644	9645
3179	2589	0	applied	\N	\N	\N	\N	9649	9649	9650
3179	2590	1	applied	\N	\N	\N	\N	9651	9651	9652
3180	2589	0	applied	\N	\N	\N	\N	9649	9649	9650
3180	2590	1	applied	\N	\N	\N	\N	9651	9651	9652
3188	2594	0	applied	\N	\N	\N	\N	9670	9670	9671
3191	2599	0	applied	\N	\N	\N	\N	9683	9683	9684
3195	2600	0	applied	\N	\N	\N	\N	9687	9687	9688
3197	2602	0	applied	\N	\N	\N	\N	9694	9694	9695
3197	2603	1	applied	\N	\N	\N	\N	9696	9696	9697
3199	2604	0	applied	\N	\N	\N	\N	9701	9701	9702
3202	2605	0	applied	\N	\N	\N	\N	9706	9706	9707
3202	2606	1	applied	\N	\N	\N	\N	9708	9708	9709
3202	2607	2	applied	\N	\N	\N	\N	9710	9710	9711
3202	2608	3	applied	\N	\N	\N	\N	9712	9712	9713
3202	2609	4	applied	\N	\N	\N	\N	9714	9714	9715
3202	2610	5	applied	\N	\N	\N	\N	9716	9716	9717
3202	2611	6	applied	\N	\N	\N	\N	9718	9718	9719
3205	2613	0	applied	\N	\N	\N	\N	9725	9725	9726
3208	2614	0	applied	\N	\N	\N	\N	9727	9727	9728
3210	2615	0	applied	\N	\N	\N	\N	9734	9734	9735
3210	2616	1	applied	\N	\N	\N	\N	9736	9736	9737
3214	2621	0	applied	\N	\N	\N	\N	9752	9752	9753
3215	2621	0	applied	\N	\N	\N	\N	9752	9752	9753
3216	2622	0	applied	\N	\N	\N	\N	9756	9756	9757
3216	2623	1	applied	\N	\N	\N	\N	9758	9758	9759
3218	2624	0	applied	\N	\N	\N	\N	9763	9763	9764
3220	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3223	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3230	2639	0	applied	\N	\N	\N	\N	9810	9810	9811
3230	2640	1	applied	\N	\N	\N	\N	9812	9812	9813
3230	2641	2	applied	\N	\N	\N	\N	9814	9814	9815
3230	2642	3	applied	\N	\N	\N	\N	9816	9816	9817
3230	2643	4	applied	\N	\N	\N	\N	9818	9818	9819
3230	2644	5	applied	\N	\N	\N	\N	9820	9820	9821
3237	2667	0	applied	\N	\N	\N	\N	9877	9877	9878
3240	2668	0	applied	\N	\N	\N	\N	9883	9883	9884
3240	2669	1	applied	\N	\N	\N	\N	9885	9885	9886
3240	2670	2	applied	\N	\N	\N	\N	9887	9887	9888
3240	2671	3	applied	\N	\N	\N	\N	9889	9889	9890
3240	2672	4	applied	\N	\N	\N	\N	9891	9891	9892
3240	2673	5	applied	\N	\N	\N	\N	9893	9893	9894
3240	2674	6	applied	\N	\N	\N	\N	9895	9895	9896
3240	2675	7	applied	\N	\N	\N	\N	9897	9897	9898
3240	2676	8	applied	\N	\N	\N	\N	9899	9899	9900
3240	2677	9	applied	\N	\N	\N	\N	9901	9901	9902
3240	2678	10	applied	\N	\N	\N	\N	9903	9903	9904
3240	2679	11	applied	\N	\N	\N	\N	9905	9905	9906
3240	2680	12	applied	\N	\N	\N	\N	9907	9907	9908
3240	2681	13	applied	\N	\N	\N	\N	9909	9909	9910
3240	2682	14	applied	\N	\N	\N	\N	9911	9911	9912
3240	2683	15	applied	\N	\N	\N	\N	9913	9913	9914
3240	2684	16	applied	\N	\N	\N	\N	9915	9915	9916
3240	2685	17	applied	\N	\N	\N	\N	9917	9917	9918
3242	2686	0	applied	\N	\N	\N	\N	9922	9922	9923
3242	2687	1	applied	\N	\N	\N	\N	9924	9924	9925
3242	2688	2	applied	\N	\N	\N	\N	9926	9926	9927
3243	2689	0	applied	\N	\N	\N	\N	9932	9932	9933
3245	2690	0	applied	\N	\N	\N	\N	9938	9938	9939
3245	2691	1	applied	\N	\N	\N	\N	9940	9940	9941
3247	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3247	2627	1	applied	\N	\N	\N	\N	9780	9780	9781
3247	2628	2	applied	\N	\N	\N	\N	9782	9782	9783
3247	2639	3	applied	\N	\N	\N	\N	9810	9810	9811
3247	2647	4	applied	\N	\N	\N	\N	9828	9828	9829
3247	2648	5	applied	\N	\N	\N	\N	9830	9830	9831
3247	2649	6	applied	\N	\N	\N	\N	9833	9833	9834
3247	2650	7	applied	\N	\N	\N	\N	9835	9835	9836
3247	2658	8	applied	\N	\N	\N	\N	9856	9856	9857
3247	2659	9	applied	\N	\N	\N	\N	9858	9858	9859
3247	2663	10	applied	\N	\N	\N	\N	9867	9867	9868
3247	2667	11	applied	\N	\N	\N	\N	9877	9877	9878
3247	2681	12	applied	\N	\N	\N	\N	9909	9909	9910
3247	2682	13	applied	\N	\N	\N	\N	9911	9911	9912
3247	2683	14	applied	\N	\N	\N	\N	9913	9913	9914
3247	2686	15	applied	\N	\N	\N	\N	9922	9922	9923
3247	2689	16	applied	\N	\N	\N	\N	9932	9932	9933
3247	2690	17	applied	\N	\N	\N	\N	9938	9938	9939
3247	2691	18	applied	\N	\N	\N	\N	9940	9940	9941
3247	2629	19	applied	\N	\N	\N	\N	9784	9784	9785
3247	2630	20	applied	\N	\N	\N	\N	9786	9786	9787
3247	2631	21	applied	\N	\N	\N	\N	9788	9788	9789
3247	2632	22	applied	\N	\N	\N	\N	9790	9790	9791
3247	2633	23	applied	\N	\N	\N	\N	9792	9792	9793
3247	2634	24	applied	\N	\N	\N	\N	9794	9794	9795
3247	2635	25	applied	\N	\N	\N	\N	9796	9796	9797
3247	2636	26	applied	\N	\N	\N	\N	9798	9798	9799
3247	2637	27	applied	\N	\N	\N	\N	9800	9800	9801
3247	2638	28	applied	\N	\N	\N	\N	9802	9802	9803
3247	2640	29	applied	\N	\N	\N	\N	9812	9812	9813
3247	2641	30	applied	\N	\N	\N	\N	9814	9814	9815
3247	2642	31	applied	\N	\N	\N	\N	9816	9816	9817
3247	2643	32	applied	\N	\N	\N	\N	9818	9818	9819
3247	2644	33	applied	\N	\N	\N	\N	9820	9820	9821
3247	2645	34	applied	\N	\N	\N	\N	9824	9824	9825
3247	2646	35	applied	\N	\N	\N	\N	9826	9826	9827
3247	2651	36	applied	\N	\N	\N	\N	9837	9837	9838
3247	2652	37	applied	\N	\N	\N	\N	9839	9839	9840
3247	2653	38	applied	\N	\N	\N	\N	9841	9841	9842
3247	2654	39	applied	\N	\N	\N	\N	9843	9843	9844
3247	2655	40	applied	\N	\N	\N	\N	9850	9850	9851
3247	2656	41	applied	\N	\N	\N	\N	9852	9852	9853
3247	2657	42	applied	\N	\N	\N	\N	9854	9854	9855
3247	2660	43	applied	\N	\N	\N	\N	9860	9860	9861
3247	2661	44	applied	\N	\N	\N	\N	9862	9862	9863
3247	2662	45	applied	\N	\N	\N	\N	9864	9864	9865
3247	2664	46	applied	\N	\N	\N	\N	9869	9869	9870
3247	2665	47	applied	\N	\N	\N	\N	9871	9871	9872
3247	2666	48	applied	\N	\N	\N	\N	9873	9873	9874
3247	2668	49	applied	\N	\N	\N	\N	9883	9883	9884
3247	2669	50	applied	\N	\N	\N	\N	9885	9885	9886
3247	2670	51	applied	\N	\N	\N	\N	9887	9887	9888
3247	2671	52	applied	\N	\N	\N	\N	9889	9889	9890
3247	2672	53	applied	\N	\N	\N	\N	9891	9891	9892
3247	2673	54	applied	\N	\N	\N	\N	9893	9893	9894
3247	2674	55	applied	\N	\N	\N	\N	9895	9895	9896
3247	2675	56	applied	\N	\N	\N	\N	9897	9897	9898
3247	2676	57	applied	\N	\N	\N	\N	9899	9899	9900
3247	2677	58	applied	\N	\N	\N	\N	9901	9901	9902
3247	2678	59	applied	\N	\N	\N	\N	9903	9903	9904
3247	2679	60	applied	\N	\N	\N	\N	9905	9905	9906
3247	2680	61	applied	\N	\N	\N	\N	9907	9907	9908
3247	2684	62	applied	\N	\N	\N	\N	9915	9915	9916
3247	2685	63	applied	\N	\N	\N	\N	9917	9917	9918
3181	2591	0	applied	\N	\N	\N	\N	9655	9655	9656
3183	2591	0	applied	\N	\N	\N	\N	9655	9655	9656
3184	2592	0	applied	\N	\N	\N	\N	9662	9662	9663
3185	2592	0	applied	\N	\N	\N	\N	9662	9662	9663
3186	2593	0	applied	\N	\N	\N	\N	9666	9666	9667
3190	2595	0	applied	\N	\N	\N	\N	9674	9674	9675
3190	2596	1	applied	\N	\N	\N	\N	9676	9676	9677
3190	2597	2	applied	\N	\N	\N	\N	9678	9678	9679
3190	2598	3	applied	\N	\N	\N	\N	9680	9680	9681
3192	2599	0	applied	\N	\N	\N	\N	9683	9683	9684
3193	2600	0	applied	\N	\N	\N	\N	9687	9687	9688
3198	2602	0	applied	\N	\N	\N	\N	9694	9694	9695
3198	2603	1	applied	\N	\N	\N	\N	9696	9696	9697
3200	2604	0	applied	\N	\N	\N	\N	9701	9701	9702
3203	2605	0	applied	\N	\N	\N	\N	9706	9706	9707
3203	2606	1	applied	\N	\N	\N	\N	9708	9708	9709
3203	2607	2	applied	\N	\N	\N	\N	9710	9710	9711
3203	2608	3	applied	\N	\N	\N	\N	9712	9712	9713
3203	2609	4	applied	\N	\N	\N	\N	9714	9714	9715
3203	2610	5	applied	\N	\N	\N	\N	9716	9716	9717
3203	2611	6	applied	\N	\N	\N	\N	9718	9718	9719
3206	2614	0	applied	\N	\N	\N	\N	9727	9727	9728
3209	2487	0	applied	\N	\N	\N	\N	9311	9311	9312
3209	2488	1	applied	\N	\N	\N	\N	9325	9325	9326
3209	2489	2	applied	\N	\N	\N	\N	9327	9327	9328
3209	2490	3	applied	\N	\N	\N	\N	9329	9329	9330
3209	2491	4	applied	\N	\N	\N	\N	9335	9335	9336
3209	2492	5	applied	\N	\N	\N	\N	9337	9337	9338
3209	2493	6	applied	\N	\N	\N	\N	9339	9339	9340
3209	2494	7	applied	\N	\N	\N	\N	9346	9346	9347
3209	2495	8	applied	\N	\N	\N	\N	9348	9348	9349
3209	2496	9	applied	\N	\N	\N	\N	9350	9350	9351
3209	2497	10	applied	\N	\N	\N	\N	9352	9352	9353
3209	2498	11	applied	\N	\N	\N	\N	9354	9354	9355
3209	2499	12	applied	\N	\N	\N	\N	9356	9356	9357
3209	2500	13	applied	\N	\N	\N	\N	9358	9358	9359
3209	2502	14	applied	\N	\N	\N	\N	9368	9368	9369
3209	2503	15	applied	\N	\N	\N	\N	9370	9370	9371
3209	2505	16	applied	\N	\N	\N	\N	9378	9378	9379
3209	2501	17	applied	\N	\N	1000000000	\N	9360	9360	9361
3209	2506	18	applied	\N	\N	\N	\N	9382	9382	9383
3209	2507	19	applied	\N	\N	\N	\N	9385	9385	9386
3209	2508	20	applied	\N	\N	\N	\N	9387	9387	9388
3209	2504	21	applied	\N	\N	\N	\N	9372	9372	9373
3209	2526	22	applied	\N	\N	\N	\N	9446	9446	9447
3209	2527	23	applied	\N	\N	\N	\N	9448	9448	9449
3209	2530	24	applied	\N	\N	\N	\N	9454	9454	9455
3209	2531	25	applied	\N	\N	\N	\N	9456	9456	9457
3209	2532	26	applied	\N	\N	\N	\N	9458	9458	9459
3209	2533	27	applied	\N	\N	\N	\N	9460	9460	9461
3209	2534	28	applied	\N	\N	\N	\N	9462	9462	9463
3209	2535	29	applied	\N	\N	\N	\N	9464	9464	9465
3209	2536	30	applied	\N	\N	\N	\N	9466	9466	9467
3209	2537	31	applied	\N	\N	\N	\N	9468	9468	9469
3209	2544	32	applied	\N	\N	\N	\N	9489	9489	9490
3209	2509	33	applied	\N	\N	\N	\N	9389	9389	9390
3209	2510	34	applied	\N	\N	\N	\N	9393	9393	9394
3209	2511	35	applied	\N	\N	\N	\N	9397	9397	9398
3209	2512	36	applied	\N	\N	\N	\N	9399	9399	9400
3209	2513	37	applied	\N	\N	\N	\N	9401	9401	9402
3209	2514	38	applied	\N	\N	\N	\N	9403	9403	9404
3209	2515	39	applied	\N	\N	\N	\N	9408	9408	9409
3209	2516	40	applied	\N	\N	\N	\N	9410	9410	9411
3209	2517	41	applied	\N	\N	\N	\N	9418	9418	9419
3209	2518	42	applied	\N	\N	\N	\N	9422	9422	9423
3209	2519	43	applied	\N	\N	\N	\N	9426	9426	9427
3209	2520	44	applied	\N	\N	\N	\N	9428	9428	9429
3209	2521	45	applied	\N	\N	\N	\N	9430	9430	9431
3209	2522	46	applied	\N	\N	\N	\N	9434	9434	9435
3209	2523	47	applied	\N	\N	\N	\N	9436	9436	9437
3209	2524	48	applied	\N	\N	\N	\N	9440	9440	9441
3209	2525	49	applied	\N	\N	\N	\N	9442	9442	9443
3209	2528	50	applied	\N	\N	\N	\N	9450	9450	9451
3209	2529	51	applied	\N	\N	\N	\N	9452	9452	9453
3209	2538	52	applied	\N	\N	\N	\N	9473	9473	9474
3209	2539	53	applied	\N	\N	\N	\N	9475	9475	9476
3209	2540	54	applied	\N	\N	\N	\N	9477	9477	9478
3209	2541	55	applied	\N	\N	\N	\N	9483	9483	9484
3209	2542	56	applied	\N	\N	\N	\N	9485	9485	9486
3209	2543	57	applied	\N	\N	\N	\N	9487	9487	9488
3209	2545	58	applied	\N	\N	\N	\N	9492	9492	9493
3209	2546	59	applied	\N	\N	\N	\N	9494	9494	9495
3209	2547	60	applied	\N	\N	\N	\N	9496	9496	9497
3209	2548	61	applied	\N	\N	\N	\N	9500	9500	9501
3209	2549	62	applied	\N	\N	\N	\N	9502	9502	9503
3209	2550	63	applied	\N	\N	\N	\N	9504	9504	9505
3209	2551	64	applied	\N	\N	\N	\N	9506	9506	9507
3209	2552	65	applied	\N	\N	\N	\N	9510	9510	9511
3209	2553	66	applied	\N	\N	\N	\N	9514	9514	9515
3209	2554	67	applied	\N	\N	\N	\N	9520	9520	9521
3209	2555	68	applied	\N	\N	\N	\N	9524	9524	9525
3209	2556	69	applied	\N	\N	\N	\N	9529	9529	9530
3209	2557	70	applied	\N	\N	\N	\N	9531	9531	9532
3209	2558	71	applied	\N	\N	\N	\N	9533	9533	9534
3209	2559	73	applied	\N	\N	\N	\N	9535	9535	9536
3209	2560	74	applied	\N	\N	\N	\N	9541	9541	9542
3209	2561	75	applied	\N	\N	\N	\N	9543	9543	9544
3209	2562	76	applied	\N	\N	\N	\N	9545	9545	9546
3209	2563	77	applied	\N	\N	\N	\N	9547	9547	9548
3209	2564	78	applied	\N	\N	\N	\N	9549	9549	9550
3209	2565	79	applied	\N	\N	\N	\N	9551	9551	9552
3209	2566	80	applied	\N	\N	\N	\N	9553	9553	9554
3209	2567	81	applied	\N	\N	\N	\N	9556	9556	9557
3209	2568	82	applied	\N	\N	\N	\N	9564	9564	9565
3209	2569	83	applied	\N	\N	\N	\N	9570	9570	9571
3209	2570	84	applied	\N	\N	\N	\N	9572	9572	9573
3209	2571	85	applied	\N	\N	\N	\N	9578	9578	9579
3209	2572	86	applied	\N	\N	\N	\N	9584	9584	9585
3209	2573	87	applied	\N	\N	\N	\N	9586	9586	9587
3209	2574	88	applied	\N	\N	\N	\N	9590	9590	9591
3209	2575	89	applied	\N	\N	\N	\N	9595	9595	9596
3209	2576	90	applied	\N	\N	\N	\N	9603	9603	9604
3209	2577	91	applied	\N	\N	\N	\N	9607	9607	9608
3209	2578	92	applied	\N	\N	\N	\N	9610	9610	9611
3209	2579	93	applied	\N	\N	\N	\N	9612	9612	9613
3209	2580	94	applied	\N	\N	\N	\N	9614	9614	9615
3209	2581	95	applied	\N	\N	\N	\N	9616	9616	9617
3209	2582	96	applied	\N	\N	\N	\N	9618	9618	9619
3209	2583	97	applied	\N	\N	\N	\N	9622	9622	9623
3209	2584	98	applied	\N	\N	\N	\N	9627	9627	9628
3182	2591	0	applied	\N	\N	\N	\N	9655	9655	9656
3187	2594	0	applied	\N	\N	\N	\N	9670	9670	9671
3189	2594	0	applied	\N	\N	\N	\N	9670	9670	9671
3194	2600	0	applied	\N	\N	\N	\N	9687	9687	9688
3196	2601	0	applied	\N	\N	\N	\N	9692	9692	9693
3204	2612	0	applied	\N	\N	\N	\N	9723	9723	9724
3207	2614	0	applied	\N	\N	\N	\N	9727	9727	9728
3222	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3225	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3229	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3229	2627	1	applied	\N	\N	\N	\N	9780	9780	9781
3229	2628	2	applied	\N	\N	\N	\N	9782	9782	9783
3229	2629	3	applied	\N	\N	\N	\N	9784	9784	9785
3233	2438	0	applied	\N	\N	\N	\N	9100	9100	9101
3233	2626	1	applied	\N	\N	\N	\N	9847	9847	9779
3233	2473	2	applied	\N	\N	1000000000	\N	9261	9261	9254
3233	2428	3	applied	\N	\N	\N	\N	9055	9055	9056
3233	2429	4	applied	\N	\N	\N	\N	9059	9059	9060
3233	2430	5	applied	\N	\N	\N	\N	9067	9067	9068
3233	2431	6	applied	\N	\N	\N	\N	9072	9072	9073
3233	2432	7	applied	\N	\N	\N	\N	9075	9075	9076
3233	2433	8	applied	\N	\N	\N	\N	9077	9077	9078
3233	2434	9	applied	\N	\N	\N	\N	9083	9083	9084
3234	2655	0	applied	\N	\N	\N	\N	9850	9850	9851
3234	2656	1	applied	\N	\N	\N	\N	9852	9852	9853
3234	2657	2	applied	\N	\N	\N	\N	9854	9854	9855
3234	2658	3	applied	\N	\N	\N	\N	9856	9856	9857
3234	2659	4	applied	\N	\N	\N	\N	9858	9858	9859
3234	2660	5	applied	\N	\N	\N	\N	9860	9860	9861
3234	2661	6	applied	\N	\N	\N	\N	9862	9862	9863
3234	2662	7	applied	\N	\N	\N	\N	9864	9864	9865
3236	2667	0	applied	\N	\N	\N	\N	9877	9877	9878
3246	2690	0	applied	\N	\N	\N	\N	9938	9938	9939
3246	2691	1	applied	\N	\N	\N	\N	9940	9940	9941
3248	2692	0	applied	\N	\N	\N	\N	9946	9946	9947
3250	2693	0	applied	\N	\N	\N	\N	9950	9950	9951
3253	2698	0	applied	\N	\N	\N	\N	9965	9965	9966
3255	2699	0	applied	\N	\N	\N	\N	9968	9968	9969
3255	2700	1	applied	\N	\N	\N	\N	9970	9970	9971
3258	2701	0	applied	\N	\N	\N	\N	9976	9976	9977
3261	2703	0	applied	\N	\N	\N	\N	9983	9983	9984
3263	2709	0	applied	\N	\N	\N	\N	9997	9997	9998
3266	2710	0	applied	\N	\N	\N	\N	10003	10003	10004
3268	2711	0	applied	\N	\N	\N	\N	10005	10005	10006
3270	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3270	2629	1	applied	\N	\N	\N	\N	9784	9784	9785
3270	2630	2	applied	\N	\N	\N	\N	9786	9786	9787
3270	2631	3	applied	\N	\N	\N	\N	9788	9788	9789
3270	2632	4	applied	\N	\N	\N	\N	9790	9790	9791
3270	2633	5	applied	\N	\N	\N	\N	9792	9792	9793
3270	2634	6	applied	\N	\N	\N	\N	9794	9794	9795
3270	2635	7	applied	\N	\N	\N	\N	9796	9796	9797
3270	2636	8	applied	\N	\N	\N	\N	9798	9798	9799
3270	2637	9	applied	\N	\N	\N	\N	9800	9800	9801
3270	2638	10	applied	\N	\N	\N	\N	9802	9802	9803
3270	2640	11	applied	\N	\N	\N	\N	9812	9812	9813
3270	2641	12	applied	\N	\N	\N	\N	9814	9814	9815
3270	2642	13	applied	\N	\N	\N	\N	9816	9816	9817
3270	2643	14	applied	\N	\N	\N	\N	9818	9818	9819
3270	2644	15	applied	\N	\N	\N	\N	9820	9820	9821
3270	2645	16	applied	\N	\N	\N	\N	9824	9824	9825
3270	2646	17	applied	\N	\N	\N	\N	9826	9826	9827
3270	2651	18	applied	\N	\N	\N	\N	9837	9837	9838
3270	2652	19	applied	\N	\N	\N	\N	9839	9839	9840
3270	2653	20	applied	\N	\N	\N	\N	9841	9841	9842
3270	2654	21	applied	\N	\N	\N	\N	9843	9843	9844
3270	2655	22	applied	\N	\N	\N	\N	9850	9850	9851
3270	2656	23	applied	\N	\N	\N	\N	9852	9852	9853
3270	2657	24	applied	\N	\N	\N	\N	9854	9854	9855
3270	2660	25	applied	\N	\N	\N	\N	9860	9860	9861
3270	2661	26	applied	\N	\N	\N	\N	9862	9862	9863
3270	2662	27	applied	\N	\N	\N	\N	9864	9864	9865
3270	2664	28	applied	\N	\N	\N	\N	9869	9869	9870
3270	2665	29	applied	\N	\N	\N	\N	9871	9871	9872
3270	2666	30	applied	\N	\N	\N	\N	9873	9873	9874
3270	2668	31	applied	\N	\N	\N	\N	9883	9883	9884
3270	2669	32	applied	\N	\N	\N	\N	9885	9885	9886
3270	2670	33	applied	\N	\N	\N	\N	9887	9887	9888
3270	2671	34	applied	\N	\N	\N	\N	9889	9889	9890
3270	2672	35	applied	\N	\N	\N	\N	9891	9891	9892
3270	2673	36	applied	\N	\N	\N	\N	9893	9893	9894
3270	2674	37	applied	\N	\N	\N	\N	9895	9895	9896
3270	2675	38	applied	\N	\N	\N	\N	9897	9897	9898
3270	2676	39	applied	\N	\N	\N	\N	9899	9899	9900
3270	2677	40	applied	\N	\N	\N	\N	9901	9901	9902
3270	2678	41	applied	\N	\N	\N	\N	9903	9903	9904
3270	2679	42	applied	\N	\N	\N	\N	9905	9905	9906
3270	2680	43	applied	\N	\N	\N	\N	9907	9907	9908
3270	2684	44	applied	\N	\N	\N	\N	9915	9915	9916
3270	2685	45	applied	\N	\N	\N	\N	9917	9917	9918
3270	2687	46	applied	\N	\N	\N	\N	9924	9924	9925
3270	2688	47	applied	\N	\N	\N	\N	9926	9926	9927
3270	2704	48	applied	\N	\N	\N	\N	9985	9985	9986
3270	2705	49	applied	\N	\N	\N	\N	9987	9987	9988
3271	2712	0	applied	\N	\N	\N	\N	10013	10013	10014
3271	2713	1	applied	\N	\N	\N	\N	10015	10015	10016
3273	2714	0	applied	\N	\N	\N	\N	10019	10019	10020
3273	2715	1	applied	\N	\N	\N	\N	10021	10021	10022
3275	2716	0	applied	\N	\N	\N	\N	10026	10026	10027
3278	2717	0	applied	\N	\N	\N	\N	10030	10030	10031
3278	2718	1	applied	\N	\N	\N	\N	10032	10032	10033
3278	2719	2	applied	\N	\N	\N	\N	10034	10034	10035
3278	2720	3	applied	\N	\N	\N	\N	10036	10036	10037
3279	2721	0	applied	\N	\N	\N	\N	10044	10044	10045
3279	2722	1	applied	\N	\N	\N	\N	10046	10046	10047
3280	2723	0	applied	\N	\N	\N	\N	10050	10050	10051
3280	2724	1	applied	\N	\N	\N	\N	10052	10052	10053
3283	2727	0	applied	\N	\N	\N	\N	10060	10060	10061
3283	2728	1	applied	\N	\N	\N	\N	10062	10062	10063
3283	2729	2	applied	\N	\N	\N	\N	10064	10064	10065
3285	2730	0	applied	\N	\N	\N	\N	10070	10070	10071
3285	2731	1	applied	\N	\N	\N	\N	10072	10072	10073
3286	2732	0	applied	\N	\N	1000000000	\N	10075	10075	10076
3286	2733	1	applied	\N	\N	\N	\N	10077	10077	10078
3286	2734	2	applied	\N	\N	\N	\N	10079	10079	10080
3286	2735	3	applied	\N	\N	\N	\N	10081	10081	10082
3286	2736	4	applied	\N	\N	\N	\N	10083	10083	10084
3286	2737	5	applied	\N	\N	\N	\N	10085	10085	10086
3286	2738	6	applied	\N	\N	\N	\N	10087	10087	10088
3209	2585	99	applied	\N	\N	\N	\N	9633	9633	9634
3209	2586	100	applied	\N	\N	\N	\N	9638	9638	9639
3209	2587	101	applied	\N	\N	\N	\N	9642	9642	9643
3209	2588	102	applied	\N	\N	\N	\N	9644	9644	9645
3209	2589	103	applied	\N	\N	\N	\N	9649	9649	9650
3209	2590	104	applied	\N	\N	\N	\N	9651	9651	9652
3209	2591	105	applied	\N	\N	\N	\N	9655	9655	9656
3209	2592	106	applied	\N	\N	\N	\N	9662	9662	9663
3209	2593	107	applied	\N	\N	\N	\N	9666	9666	9667
3209	2594	108	applied	\N	\N	\N	\N	9670	9670	9671
3209	2595	109	applied	\N	\N	\N	\N	9674	9674	9675
3209	2596	110	applied	\N	\N	\N	\N	9676	9676	9677
3209	2597	111	applied	\N	\N	\N	\N	9678	9678	9679
3209	2598	112	applied	\N	\N	\N	\N	9680	9680	9681
3209	2599	113	applied	\N	\N	\N	\N	9683	9683	9684
3209	2600	114	applied	\N	\N	\N	\N	9687	9687	9688
3209	2601	115	applied	\N	\N	\N	\N	9692	9692	9693
3209	2602	116	applied	\N	\N	\N	\N	9694	9694	9695
3209	2603	117	applied	\N	\N	\N	\N	9696	9696	9697
3209	2604	118	applied	\N	\N	\N	\N	9701	9701	9702
3209	2605	119	applied	\N	\N	\N	\N	9706	9706	9707
3209	2606	120	applied	\N	\N	\N	\N	9708	9708	9709
3209	2607	121	applied	\N	\N	\N	\N	9710	9710	9711
3209	2608	122	applied	\N	\N	\N	\N	9712	9712	9713
3209	2609	123	applied	\N	\N	\N	\N	9714	9714	9715
3209	2610	124	applied	\N	\N	\N	\N	9716	9716	9717
3209	2611	125	applied	\N	\N	\N	\N	9718	9718	9719
3211	2617	0	applied	\N	\N	\N	\N	9740	9740	9741
3212	2618	0	applied	\N	\N	\N	\N	9744	9744	9745
3213	2619	0	applied	\N	\N	\N	\N	9746	9746	9747
3213	2620	1	applied	\N	\N	\N	\N	9748	9748	9749
3217	2622	0	applied	\N	\N	\N	\N	9756	9756	9757
3217	2623	1	applied	\N	\N	\N	\N	9758	9758	9759
3219	2624	0	applied	\N	\N	\N	\N	9763	9763	9764
3221	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3224	2625	0	applied	\N	\N	\N	\N	9769	9769	9770
3226	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3226	2627	1	applied	\N	\N	\N	\N	9780	9780	9781
3226	2628	2	applied	\N	\N	\N	\N	9782	9782	9783
3226	2629	3	applied	\N	\N	\N	\N	9784	9784	9785
3226	2630	4	applied	\N	\N	\N	\N	9786	9786	9787
3226	2631	5	applied	\N	\N	\N	\N	9788	9788	9789
3226	2632	6	applied	\N	\N	\N	\N	9790	9790	9791
3226	2633	7	applied	\N	\N	\N	\N	9792	9792	9793
3226	2634	8	applied	\N	\N	\N	\N	9794	9794	9795
3226	2635	9	applied	\N	\N	\N	\N	9796	9796	9797
3226	2636	10	applied	\N	\N	\N	\N	9798	9798	9799
3226	2637	11	applied	\N	\N	\N	\N	9800	9800	9801
3226	2638	12	applied	\N	\N	\N	\N	9802	9802	9803
3227	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3227	2627	1	applied	\N	\N	\N	\N	9780	9780	9781
3227	2628	2	applied	\N	\N	\N	\N	9782	9782	9783
3227	2629	3	applied	\N	\N	\N	\N	9784	9784	9785
3227	2630	4	applied	\N	\N	\N	\N	9786	9786	9787
3227	2631	5	applied	\N	\N	\N	\N	9788	9788	9789
3227	2632	6	applied	\N	\N	\N	\N	9790	9790	9791
3227	2633	7	applied	\N	\N	\N	\N	9792	9792	9793
3227	2634	8	applied	\N	\N	\N	\N	9794	9794	9795
3227	2635	9	applied	\N	\N	\N	\N	9796	9796	9797
3227	2636	10	applied	\N	\N	\N	\N	9798	9798	9799
3227	2637	11	applied	\N	\N	\N	\N	9800	9800	9801
3227	2638	12	applied	\N	\N	\N	\N	9802	9802	9803
3228	2626	0	applied	\N	\N	\N	\N	9778	9778	9779
3228	2627	1	applied	\N	\N	\N	\N	9780	9780	9781
3228	2628	2	applied	\N	\N	\N	\N	9782	9782	9783
3228	2629	3	applied	\N	\N	\N	\N	9784	9784	9785
3228	2630	4	applied	\N	\N	\N	\N	9786	9786	9787
3228	2631	5	applied	\N	\N	\N	\N	9788	9788	9789
3228	2632	6	applied	\N	\N	\N	\N	9790	9790	9791
3228	2633	7	applied	\N	\N	\N	\N	9792	9792	9793
3228	2634	8	applied	\N	\N	\N	\N	9794	9794	9795
3228	2635	9	applied	\N	\N	\N	\N	9796	9796	9797
3228	2636	10	applied	\N	\N	\N	\N	9798	9798	9799
3228	2637	11	applied	\N	\N	\N	\N	9800	9800	9801
3228	2638	12	applied	\N	\N	\N	\N	9802	9802	9803
3231	2645	0	applied	\N	\N	\N	\N	9824	9824	9825
3231	2646	1	applied	\N	\N	\N	\N	9826	9826	9827
3231	2647	2	applied	\N	\N	\N	\N	9828	9828	9829
3231	2648	3	applied	\N	\N	\N	\N	9830	9830	9831
3232	2649	0	applied	\N	\N	\N	\N	9833	9833	9834
3232	2650	1	applied	\N	\N	\N	\N	9835	9835	9836
3232	2651	2	applied	\N	\N	\N	\N	9837	9837	9838
3232	2652	3	applied	\N	\N	\N	\N	9839	9839	9840
3232	2653	4	applied	\N	\N	\N	\N	9841	9841	9842
3232	2654	5	applied	\N	\N	\N	\N	9843	9843	9844
3235	2663	0	applied	\N	\N	\N	\N	9867	9867	9868
3235	2664	1	applied	\N	\N	\N	\N	9869	9869	9870
3235	2665	2	applied	\N	\N	\N	\N	9871	9871	9872
3235	2666	3	applied	\N	\N	\N	\N	9873	9873	9874
3238	2667	0	applied	\N	\N	\N	\N	9877	9877	9878
3239	2668	0	applied	\N	\N	\N	\N	9883	9883	9884
3239	2669	1	applied	\N	\N	\N	\N	9885	9885	9886
3239	2670	2	applied	\N	\N	\N	\N	9887	9887	9888
3239	2671	3	applied	\N	\N	\N	\N	9889	9889	9890
3239	2672	4	applied	\N	\N	\N	\N	9891	9891	9892
3239	2673	5	applied	\N	\N	\N	\N	9893	9893	9894
3239	2674	6	applied	\N	\N	\N	\N	9895	9895	9896
3239	2675	7	applied	\N	\N	\N	\N	9897	9897	9898
3239	2676	8	applied	\N	\N	\N	\N	9899	9899	9900
3239	2677	9	applied	\N	\N	\N	\N	9901	9901	9902
3239	2678	10	applied	\N	\N	\N	\N	9903	9903	9904
3239	2679	11	applied	\N	\N	\N	\N	9905	9905	9906
3239	2680	12	applied	\N	\N	\N	\N	9907	9907	9908
3239	2681	13	applied	\N	\N	\N	\N	9909	9909	9910
3239	2682	14	applied	\N	\N	\N	\N	9911	9911	9912
3239	2683	15	applied	\N	\N	\N	\N	9913	9913	9914
3239	2684	16	applied	\N	\N	\N	\N	9915	9915	9916
3239	2685	17	applied	\N	\N	\N	\N	9917	9917	9918
3241	2686	0	applied	\N	\N	\N	\N	9922	9922	9923
3241	2687	1	applied	\N	\N	\N	\N	9924	9924	9925
3241	2688	2	applied	\N	\N	\N	\N	9926	9926	9927
3244	2689	0	applied	\N	\N	\N	\N	9932	9932	9933
3251	2694	0	applied	\N	\N	\N	\N	9956	9956	9957
3251	2695	1	applied	\N	\N	\N	\N	9958	9958	9959
3252	2696	0	applied	\N	\N	\N	\N	9960	9960	9961
3252	2697	1	applied	\N	\N	\N	\N	9962	9962	9963
3256	2699	0	applied	\N	\N	\N	\N	9968	9968	9969
3256	2700	1	applied	\N	\N	\N	\N	9970	9970	9971
3257	2701	0	applied	\N	\N	\N	\N	9976	9976	9977
3260	2703	0	applied	\N	\N	\N	\N	9983	9983	9984
3247	2687	64	applied	\N	\N	\N	\N	9924	9924	9925
3247	2688	65	applied	\N	\N	\N	\N	9926	9926	9927
3249	2693	0	applied	\N	\N	\N	\N	9950	9950	9951
3254	2699	0	applied	\N	\N	\N	\N	9968	9968	9969
3254	2700	1	applied	\N	\N	\N	\N	9970	9970	9971
3259	2702	0	applied	\N	\N	\N	\N	9980	9980	9981
3262	2704	0	applied	\N	\N	\N	\N	9985	9985	9986
3262	2705	1	applied	\N	\N	\N	\N	9987	9987	9988
3262	2706	2	applied	\N	\N	\N	\N	9989	9989	9990
3262	2707	3	applied	\N	\N	\N	\N	9991	9991	9992
3262	2708	4	applied	\N	\N	\N	\N	9993	9993	9994
3264	2709	0	applied	\N	\N	\N	\N	9997	9997	9998
3269	2711	0	applied	\N	\N	\N	\N	10005	10005	10006
3276	2717	0	applied	\N	\N	\N	\N	10030	10030	10031
3276	2718	1	applied	\N	\N	\N	\N	10032	10032	10033
3276	2719	2	applied	\N	\N	\N	\N	10034	10034	10035
3276	2720	3	applied	\N	\N	\N	\N	10036	10036	10037
3284	2730	0	applied	\N	\N	\N	\N	10070	10070	10071
3284	2731	1	applied	\N	\N	\N	\N	10072	10072	10073
3293	2740	0	applied	\N	\N	\N	\N	10095	10095	10096
3293	2741	1	applied	\N	\N	\N	\N	10097	10097	10098
3293	2742	2	applied	\N	\N	\N	\N	10099	10099	10100
3293	2743	3	applied	\N	\N	\N	\N	10101	10101	10102
3293	2744	4	applied	\N	\N	\N	\N	10103	10103	10104
3297	2745	0	applied	\N	\N	\N	\N	10108	10108	10109
3297	2746	1	applied	\N	\N	\N	\N	10112	10112	10113
3298	2746	0	applied	\N	\N	\N	\N	10112	10112	10113
3298	2747	1	applied	\N	\N	\N	\N	10116	10116	10117
3301	2750	0	applied	\N	\N	\N	\N	10123	10123	10124
3301	2751	1	applied	\N	\N	\N	\N	10125	10125	10126
3301	2752	2	applied	\N	\N	\N	\N	10127	10127	10128
3301	2753	3	applied	\N	\N	\N	\N	10129	10129	10130
3310	2762	0	applied	\N	\N	\N	\N	10162	10162	10163
3317	2765	0	applied	\N	\N	\N	\N	10175	10175	10176
3317	2766	1	applied	\N	\N	\N	\N	10177	10177	10178
3319	2767	0	applied	\N	\N	\N	\N	10187	10187	10188
3319	2768	1	applied	\N	\N	\N	\N	10189	10189	10190
3322	2778	0	applied	\N	\N	\N	\N	10214	10214	10215
3322	2779	1	applied	\N	\N	\N	\N	10216	10216	10217
3322	2780	2	applied	\N	\N	\N	\N	10218	10218	10219
3322	2781	3	applied	\N	\N	\N	\N	10220	10220	10221
3322	2782	4	applied	\N	\N	\N	\N	10222	10222	10223
3322	2783	5	applied	\N	\N	\N	\N	10224	10224	10225
3322	2784	6	applied	\N	\N	\N	\N	10226	10226	10227
3322	2785	7	applied	\N	\N	\N	\N	10228	10228	10229
3322	2786	8	applied	\N	\N	\N	\N	10230	10230	10231
3322	2787	9	applied	\N	\N	\N	\N	10232	10232	10233
3322	2788	10	applied	\N	\N	\N	\N	10234	10234	10235
3322	2789	11	applied	\N	\N	\N	\N	10236	10236	10237
3322	2790	12	applied	\N	\N	\N	\N	10238	10238	10239
3322	2791	13	applied	\N	\N	\N	\N	10240	10240	10241
3322	2792	14	applied	\N	\N	\N	\N	10242	10242	10243
3322	2793	15	applied	\N	\N	\N	\N	10244	10244	10245
3322	2794	16	applied	\N	\N	\N	\N	10246	10246	10247
3322	2795	17	applied	\N	\N	\N	\N	10248	10248	10249
3322	2796	18	applied	\N	\N	\N	\N	10250	10250	10251
3325	2797	0	applied	\N	\N	\N	\N	10256	10256	10257
3325	2798	1	applied	\N	\N	\N	\N	10258	10258	10259
3325	2799	2	applied	\N	\N	\N	\N	10260	10260	10261
3325	2800	3	applied	\N	\N	\N	\N	10262	10262	10263
3325	2801	4	applied	\N	\N	\N	\N	10264	10264	10265
3328	2805	0	applied	\N	\N	\N	\N	10275	10275	10276
3328	2806	1	applied	\N	\N	\N	\N	10277	10277	10278
3328	2807	2	applied	\N	\N	\N	\N	10279	10279	10280
3328	2808	3	applied	\N	\N	\N	\N	10281	10281	10282
3328	2809	4	applied	\N	\N	\N	\N	10283	10283	10284
3328	2810	5	applied	\N	\N	\N	\N	10285	10285	10286
3328	2811	6	applied	\N	\N	\N	\N	10287	10287	10288
3331	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3331	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3331	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3331	2758	3	applied	\N	\N	1000000000	\N	10146	10146	10147
3331	2755	4	applied	\N	\N	\N	\N	10137	10137	10138
3332	2814	0	applied	\N	\N	\N	\N	10299	10299	10300
3332	2815	1	applied	\N	\N	\N	\N	10301	10301	1435
3332	2816	2	applied	\N	\N	\N	\N	10302	10302	10303
3332	2817	3	applied	\N	\N	\N	\N	10304	10304	1435
3335	2821	0	applied	\N	\N	\N	\N	10315	10315	10316
3338	2825	0	applied	\N	\N	\N	\N	10327	10327	10328
3338	2826	1	applied	\N	\N	\N	\N	10329	10329	4764
3341	2830	0	applied	\N	\N	\N	\N	10340	10340	10341
3344	2834	0	applied	\N	\N	\N	\N	10352	10352	10353
3346	2835	0	applied	\N	\N	\N	\N	10354	10354	10355
3346	2836	1	applied	\N	\N	\N	\N	10356	10356	10357
3346	2837	2	applied	\N	\N	\N	\N	10358	10358	10359
3346	2838	3	applied	\N	\N	\N	\N	10360	10360	10361
3346	2839	5	applied	\N	\N	\N	\N	10363	10363	10364
3346	2840	6	applied	\N	\N	\N	\N	10365	10365	10366
3347	2841	0	applied	\N	\N	\N	\N	10372	10372	10373
3347	2842	1	applied	\N	\N	\N	\N	10374	10374	10375
3347	2843	2	applied	\N	\N	\N	\N	10376	10376	10377
3347	2844	3	applied	\N	\N	\N	\N	10378	10378	10379
3347	2845	4	applied	\N	\N	\N	\N	10380	10380	10381
3347	2846	5	applied	\N	\N	\N	\N	10382	10382	10383
3347	2847	6	applied	\N	\N	\N	\N	10384	10384	10385
3347	2848	7	applied	\N	\N	\N	\N	10386	10386	10387
3347	2849	8	applied	\N	\N	\N	\N	10388	10388	10389
3347	2850	9	applied	\N	\N	\N	\N	10390	10390	10391
3350	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3350	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3350	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3350	2626	3	applied	\N	\N	\N	\N	9847	9847	9779
3350	2758	4	applied	\N	\N	1000000000	\N	10146	10146	10147
3350	2755	5	applied	\N	\N	\N	\N	10407	10407	10138
3350	2629	6	applied	\N	\N	\N	\N	10408	10408	9785
3350	2630	7	applied	\N	\N	\N	\N	10409	10409	9787
3350	2631	8	applied	\N	\N	\N	\N	10410	10410	9789
3350	2632	9	applied	\N	\N	\N	\N	10411	10411	9791
3350	2633	10	applied	\N	\N	\N	\N	10412	10412	9793
3350	2634	11	applied	\N	\N	\N	\N	10413	10413	9795
3350	2635	12	applied	\N	\N	\N	\N	10414	10414	9797
3350	2636	13	applied	\N	\N	\N	\N	10415	10415	9799
3350	2637	14	applied	\N	\N	\N	\N	10416	10416	9801
3350	2638	15	applied	\N	\N	\N	\N	10417	10417	9803
3350	2640	16	applied	\N	\N	\N	\N	10418	10418	9813
3350	2641	17	applied	\N	\N	\N	\N	10419	10419	9815
3350	2642	18	applied	\N	\N	\N	\N	10420	10420	9817
3350	2643	19	applied	\N	\N	\N	\N	10421	10421	9819
3350	2644	20	applied	\N	\N	\N	\N	10422	10422	9821
3265	2709	0	applied	\N	\N	\N	\N	9997	9997	9998
3267	2711	0	applied	\N	\N	\N	\N	10005	10005	10006
3272	2712	0	applied	\N	\N	\N	\N	10013	10013	10014
3272	2713	1	applied	\N	\N	\N	\N	10015	10015	10016
3274	2714	0	applied	\N	\N	\N	\N	10019	10019	10020
3274	2715	1	applied	\N	\N	\N	\N	10021	10021	10022
3277	2717	0	applied	\N	\N	\N	\N	10030	10030	10031
3277	2718	1	applied	\N	\N	\N	\N	10032	10032	10033
3277	2719	2	applied	\N	\N	\N	\N	10034	10034	10035
3277	2720	3	applied	\N	\N	\N	\N	10036	10036	10037
3281	2725	0	applied	\N	\N	\N	\N	10055	10055	10056
3281	2726	1	applied	\N	\N	\N	\N	10057	10057	10058
3282	2727	0	applied	\N	\N	\N	\N	10060	10060	10061
3282	2728	1	applied	\N	\N	\N	\N	10062	10062	10063
3282	2729	2	applied	\N	\N	\N	\N	10064	10064	10065
3287	2732	0	applied	\N	\N	1000000000	\N	10075	10075	10076
3287	2733	1	applied	\N	\N	\N	\N	10077	10077	10078
3287	2734	2	applied	\N	\N	\N	\N	10079	10079	10080
3287	2735	3	applied	\N	\N	\N	\N	10081	10081	10082
3287	2736	4	applied	\N	\N	\N	\N	10083	10083	10084
3287	2737	5	applied	\N	\N	\N	\N	10085	10085	10086
3287	2738	6	applied	\N	\N	\N	\N	10087	10087	10088
3287	2739	7	applied	\N	\N	\N	\N	10089	10089	10090
3288	2732	0	applied	\N	\N	1000000000	\N	10075	10075	10076
3288	2733	1	applied	\N	\N	\N	\N	10077	10077	10078
3288	2734	2	applied	\N	\N	\N	\N	10079	10079	10080
3288	2735	3	applied	\N	\N	\N	\N	10081	10081	10082
3288	2736	4	applied	\N	\N	\N	\N	10083	10083	10084
3288	2737	5	applied	\N	\N	\N	\N	10085	10085	10086
3288	2738	6	applied	\N	\N	\N	\N	10087	10087	10088
3288	2739	7	applied	\N	\N	\N	\N	10089	10089	10090
3291	2732	0	applied	\N	\N	1000000000	\N	10075	10075	10076
3291	2733	1	applied	\N	\N	\N	\N	10077	10077	10078
3291	2734	2	applied	\N	\N	\N	\N	10079	10079	10080
3291	2735	3	applied	\N	\N	\N	\N	10081	10081	10082
3291	2736	4	applied	\N	\N	\N	\N	10083	10083	10084
3291	2737	5	applied	\N	\N	\N	\N	10085	10085	10086
3291	2738	6	applied	\N	\N	\N	\N	10087	10087	10088
3291	2740	7	applied	\N	\N	\N	\N	10095	10095	10096
3291	2741	8	applied	\N	\N	\N	\N	10097	10097	10098
3291	2742	9	applied	\N	\N	\N	\N	10099	10099	10100
3291	2743	10	applied	\N	\N	\N	\N	10101	10101	10102
3291	2739	11	applied	\N	\N	\N	\N	10089	10089	10090
3291	2744	12	applied	\N	\N	\N	\N	10103	10103	10104
3296	2745	0	applied	\N	\N	\N	\N	10108	10108	10109
3300	2748	0	applied	\N	\N	\N	\N	10118	10118	10119
3300	2749	1	applied	\N	\N	\N	\N	10120	10120	10121
3303	2754	0	applied	\N	\N	\N	\N	10135	10135	10136
3303	2755	1	applied	\N	\N	\N	\N	10137	10137	10138
3306	2761	0	applied	\N	\N	\N	\N	10154	10154	10155
3309	2761	0	applied	\N	\N	\N	\N	10154	10154	10155
3311	2762	0	applied	\N	\N	\N	\N	10162	10162	10163
3312	2763	0	applied	\N	\N	\N	\N	10168	10168	10169
3312	2764	1	applied	\N	\N	\N	\N	10170	10170	10171
3314	2763	0	applied	\N	\N	\N	\N	10168	10168	10169
3314	2764	1	applied	\N	\N	\N	\N	10170	10170	10171
3315	2765	0	applied	\N	\N	\N	\N	10175	10175	10176
3315	2766	1	applied	\N	\N	\N	\N	10177	10177	10178
3321	2769	0	applied	\N	\N	\N	\N	10194	10194	10195
3321	2770	1	applied	\N	\N	\N	\N	10196	10196	10197
3321	2771	2	applied	\N	\N	\N	\N	10198	10198	10199
3321	2772	3	applied	\N	\N	\N	\N	10200	10200	10201
3321	2773	4	applied	\N	\N	\N	\N	10202	10202	10203
3321	2774	5	applied	\N	\N	\N	\N	10204	10204	10205
3321	2775	6	applied	\N	\N	\N	\N	10206	10206	10207
3321	2776	7	applied	\N	\N	\N	\N	10208	10208	10209
3321	2777	8	applied	\N	\N	\N	\N	10210	10210	10211
3324	2797	0	applied	\N	\N	\N	\N	10256	10256	10257
3324	2798	1	applied	\N	\N	\N	\N	10258	10258	10259
3324	2799	2	applied	\N	\N	\N	\N	10260	10260	10261
3324	2800	3	applied	\N	\N	\N	\N	10262	10262	10263
3324	2801	4	applied	\N	\N	\N	\N	10264	10264	10265
3327	2803	0	applied	\N	\N	\N	\N	10271	10271	10272
3327	2804	1	applied	\N	\N	\N	\N	10273	10273	10274
3330	2812	0	applied	\N	\N	\N	\N	10290	10290	10291
3330	2813	1	applied	\N	\N	\N	\N	10294	10294	10295
3334	2818	0	applied	\N	\N	\N	\N	10308	10308	1435
3334	2819	1	applied	\N	\N	\N	\N	10309	10309	10310
3334	2820	2	applied	\N	\N	\N	\N	10311	10311	10312
3337	2822	0	applied	\N	\N	\N	\N	10319	10319	1435
3337	2823	1	applied	\N	\N	\N	\N	10320	10320	10321
3337	2824	2	applied	\N	\N	\N	\N	10322	10322	10323
3340	2830	0	applied	\N	\N	\N	\N	10340	10340	10341
3343	2831	0	applied	\N	\N	\N	\N	10344	10344	10345
3343	2832	1	applied	\N	\N	\N	\N	10346	10346	10347
3343	2833	2	applied	\N	\N	\N	\N	10348	10348	4764
3349	2851	0	applied	\N	\N	\N	\N	10394	10394	10395
3349	2852	1	applied	\N	\N	\N	\N	10396	10396	10397
3349	2853	2	applied	\N	\N	\N	\N	10398	10398	10399
3349	2854	3	applied	\N	\N	\N	\N	10400	10400	10401
3349	2855	4	applied	\N	\N	1000000000	\N	10402	10402	10403
3286	2739	7	applied	\N	\N	\N	\N	10089	10089	10090
3299	2748	0	applied	\N	\N	\N	\N	10118	10118	10119
3299	2749	1	applied	\N	\N	\N	\N	10120	10120	10121
3302	2750	0	applied	\N	\N	\N	\N	10123	10123	10124
3302	2751	1	applied	\N	\N	\N	\N	10125	10125	10126
3302	2752	2	applied	\N	\N	\N	\N	10127	10127	10128
3302	2753	3	applied	\N	\N	\N	\N	10129	10129	10130
3305	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3305	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3305	2758	2	applied	\N	\N	1000000000	\N	10146	10146	10147
3305	2759	3	applied	\N	\N	\N	\N	10148	10148	10149
3305	2760	4	applied	\N	\N	\N	\N	10150	10150	10151
3307	2761	0	applied	\N	\N	\N	\N	10154	10154	10155
3308	2761	0	applied	\N	\N	\N	\N	10154	10154	10155
3313	2763	0	applied	\N	\N	\N	\N	10168	10168	10169
3313	2764	1	applied	\N	\N	\N	\N	10170	10170	10171
3316	2765	0	applied	\N	\N	\N	\N	10175	10175	10176
3316	2766	1	applied	\N	\N	\N	\N	10177	10177	10178
3318	2765	0	applied	\N	\N	\N	\N	10175	10175	10176
3318	2766	1	applied	\N	\N	\N	\N	10177	10177	10178
3320	2767	0	applied	\N	\N	\N	\N	10187	10187	10188
3320	2768	1	applied	\N	\N	\N	\N	10189	10189	10190
3323	2778	0	applied	\N	\N	\N	\N	10214	10214	10215
3323	2779	1	applied	\N	\N	\N	\N	10216	10216	10217
3323	2780	2	applied	\N	\N	\N	\N	10218	10218	10219
3323	2781	3	applied	\N	\N	\N	\N	10220	10220	10221
3323	2782	4	applied	\N	\N	\N	\N	10222	10222	10223
3323	2783	5	applied	\N	\N	\N	\N	10224	10224	10225
3323	2784	6	applied	\N	\N	\N	\N	10226	10226	10227
3323	2785	7	applied	\N	\N	\N	\N	10228	10228	10229
3323	2786	8	applied	\N	\N	\N	\N	10230	10230	10231
3323	2787	9	applied	\N	\N	\N	\N	10232	10232	10233
3323	2788	10	applied	\N	\N	\N	\N	10234	10234	10235
3323	2789	11	applied	\N	\N	\N	\N	10236	10236	10237
3323	2790	12	applied	\N	\N	\N	\N	10238	10238	10239
3323	2791	13	applied	\N	\N	\N	\N	10240	10240	10241
3323	2792	14	applied	\N	\N	\N	\N	10242	10242	10243
3323	2793	15	applied	\N	\N	\N	\N	10244	10244	10245
3323	2794	16	applied	\N	\N	\N	\N	10246	10246	10247
3323	2795	17	applied	\N	\N	\N	\N	10248	10248	10249
3323	2796	18	applied	\N	\N	\N	\N	10250	10250	10251
3326	2802	0	applied	\N	\N	\N	\N	10268	10268	10269
3329	2797	0	applied	\N	\N	\N	\N	10256	10256	10257
3329	2802	1	applied	\N	\N	\N	\N	10268	10268	10269
3329	2798	2	applied	\N	\N	\N	\N	10258	10258	10259
3329	2799	3	applied	\N	\N	\N	\N	10260	10260	10261
3329	2804	4	applied	\N	\N	\N	\N	10273	10273	10274
3329	2805	5	applied	\N	\N	\N	\N	10275	10275	10276
3329	2812	6	applied	\N	\N	\N	\N	10290	10290	10291
3329	2806	7	applied	\N	\N	\N	\N	10277	10277	10278
3329	2807	8	applied	\N	\N	\N	\N	10279	10279	10280
3329	2800	9	applied	\N	\N	\N	\N	10262	10262	10263
3329	2801	10	applied	\N	\N	\N	\N	10264	10264	10265
3329	2803	11	applied	\N	\N	\N	\N	10271	10271	10272
3333	2814	0	applied	\N	\N	\N	\N	10299	10299	10300
3333	2815	1	applied	\N	\N	\N	\N	10301	10301	1435
3333	2816	2	applied	\N	\N	\N	\N	10302	10302	10303
3333	2817	3	applied	\N	\N	\N	\N	10304	10304	1435
3336	2822	0	applied	\N	\N	\N	\N	10319	10319	1435
3336	2823	1	applied	\N	\N	\N	\N	10320	10320	10321
3336	2824	2	applied	\N	\N	\N	\N	10322	10322	10323
3339	2827	0	applied	\N	\N	\N	\N	10332	10332	10333
3339	2828	1	applied	\N	\N	\N	\N	10334	10334	10335
3339	2829	2	applied	\N	\N	\N	\N	10336	10336	10337
3342	2831	0	applied	\N	\N	\N	\N	10344	10344	10345
3342	2832	1	applied	\N	\N	\N	\N	10346	10346	10347
3342	2833	2	applied	\N	\N	\N	\N	10348	10348	4764
3345	2835	0	applied	\N	\N	\N	\N	10354	10354	10355
3345	2836	1	applied	\N	\N	\N	\N	10356	10356	10357
3345	2837	2	applied	\N	\N	\N	\N	10358	10358	10359
3345	2838	3	applied	\N	\N	\N	\N	10360	10360	10361
3345	2839	5	applied	\N	\N	\N	\N	10363	10363	10364
3345	2840	6	applied	\N	\N	\N	\N	10365	10365	10366
3348	2851	0	applied	\N	\N	\N	\N	10394	10394	10395
3348	2852	1	applied	\N	\N	\N	\N	10396	10396	10397
3348	2853	2	applied	\N	\N	\N	\N	10398	10398	10399
3348	2854	3	applied	\N	\N	\N	\N	10400	10400	10401
3348	2855	4	applied	\N	\N	1000000000	\N	10402	10402	10403
3350	2645	21	applied	\N	\N	\N	\N	10423	10423	9825
3350	2646	22	applied	\N	\N	\N	\N	10424	10424	9827
3350	2651	23	applied	\N	\N	\N	\N	10425	10425	9838
3350	2652	24	applied	\N	\N	\N	\N	10426	10426	9840
3350	2653	25	applied	\N	\N	\N	\N	10427	10427	9842
3350	2654	26	applied	\N	\N	\N	\N	10428	10428	9844
3350	2655	27	applied	\N	\N	\N	\N	10429	10429	9851
3350	2656	28	applied	\N	\N	\N	\N	10430	10430	9853
3350	2657	29	applied	\N	\N	\N	\N	10431	10431	9855
3350	2660	30	applied	\N	\N	\N	\N	10432	10432	9861
3350	2661	31	applied	\N	\N	\N	\N	10433	10433	9863
3350	2662	32	applied	\N	\N	\N	\N	10434	10434	9865
3350	2664	33	applied	\N	\N	\N	\N	10435	10435	9870
3350	2665	34	applied	\N	\N	\N	\N	10436	10436	9872
3350	2666	35	applied	\N	\N	\N	\N	10437	10437	9874
3350	2668	36	applied	\N	\N	\N	\N	10438	10438	9884
3350	2669	37	applied	\N	\N	\N	\N	10439	10439	9886
3350	2670	38	applied	\N	\N	\N	\N	10440	10440	9888
3350	2671	39	applied	\N	\N	\N	\N	10441	10441	9890
3350	2672	40	applied	\N	\N	\N	\N	10442	10442	9892
3350	2673	41	applied	\N	\N	\N	\N	10443	10443	9894
3350	2674	42	applied	\N	\N	\N	\N	10444	10444	9896
3350	2675	43	applied	\N	\N	\N	\N	10445	10445	9898
3350	2676	44	applied	\N	\N	\N	\N	10446	10446	9900
3350	2677	45	applied	\N	\N	\N	\N	10447	10447	9902
3350	2678	46	applied	\N	\N	\N	\N	10448	10448	9904
3350	2679	47	applied	\N	\N	\N	\N	10449	10449	9906
3350	2680	48	applied	\N	\N	\N	\N	10450	10450	9908
3350	2684	49	applied	\N	\N	\N	\N	10451	10451	9916
3350	2685	50	applied	\N	\N	\N	\N	10452	10452	9918
3350	2687	51	applied	\N	\N	\N	\N	10453	10453	9925
3350	2688	52	applied	\N	\N	\N	\N	10454	10454	9927
3350	2704	53	applied	\N	\N	\N	\N	10455	10455	9986
3350	2705	54	applied	\N	\N	\N	\N	10456	10456	9988
3350	2717	55	applied	\N	\N	\N	\N	10457	10457	10031
3350	2719	56	applied	\N	\N	\N	\N	10458	10458	10035
3350	2720	57	applied	\N	\N	\N	\N	10459	10459	10037
3350	2731	58	applied	\N	\N	\N	\N	10460	10460	10073
3350	2733	59	applied	\N	\N	\N	\N	10461	10461	10078
3350	2734	60	applied	\N	\N	\N	\N	10462	10462	10080
3350	2735	61	applied	\N	\N	\N	\N	10463	10463	10082
3350	2736	62	applied	\N	\N	\N	\N	10464	10464	10084
3350	2737	63	applied	\N	\N	\N	\N	10465	10465	10086
3350	2738	64	applied	\N	\N	\N	\N	10466	10466	10088
3350	2740	65	applied	\N	\N	\N	\N	10467	10467	10096
3350	2741	66	applied	\N	\N	\N	\N	10468	10468	10098
3350	2742	67	applied	\N	\N	\N	\N	10469	10469	10100
3350	2743	68	applied	\N	\N	\N	\N	10470	10470	10102
3350	2750	69	applied	\N	\N	\N	\N	10471	10471	10124
3350	2751	70	applied	\N	\N	\N	\N	10472	10472	10126
3350	2752	71	applied	\N	\N	\N	\N	10473	10473	10128
3350	2768	72	applied	\N	\N	\N	\N	10474	10474	10190
3350	2770	73	applied	\N	\N	\N	\N	10475	10475	10197
3350	2771	74	applied	\N	\N	\N	\N	10476	10476	10199
3350	2772	75	applied	\N	\N	\N	\N	10477	10477	10201
3350	2773	76	applied	\N	\N	\N	\N	10478	10478	10203
3350	2774	77	applied	\N	\N	\N	\N	10479	10479	10205
3350	2775	78	applied	\N	\N	\N	\N	10480	10480	10207
3351	2856	0	applied	\N	\N	\N	\N	10483	10483	10484
3352	2857	0	applied	\N	\N	\N	\N	10485	10485	10486
3352	2856	1	applied	\N	\N	\N	\N	10483	10483	10484
3352	2858	2	applied	\N	\N	\N	\N	10487	10487	10488
3353	2859	0	applied	\N	\N	\N	\N	10491	10491	1435
3353	2860	1	applied	\N	\N	\N	\N	10492	10492	10493
3353	2861	2	applied	\N	\N	\N	\N	10494	10494	10495
3354	2862	0	applied	\N	\N	\N	\N	10498	10498	10499
3354	2863	1	applied	\N	\N	\N	\N	10500	10500	10501
3355	2862	0	applied	\N	\N	\N	\N	10498	10498	10499
3355	2863	1	applied	\N	\N	\N	\N	10500	10500	10501
3356	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3356	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3356	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3356	2626	3	applied	\N	\N	\N	\N	9778	9778	9779
3356	2758	4	applied	\N	\N	1000000000	\N	10146	10146	10147
3356	2755	5	applied	\N	\N	\N	\N	10407	10407	10138
3356	2629	6	applied	\N	\N	\N	\N	9784	9784	9785
3356	2630	7	applied	\N	\N	\N	\N	9786	9786	9787
3356	2631	8	applied	\N	\N	\N	\N	9788	9788	9789
3356	2632	9	applied	\N	\N	\N	\N	9790	9790	9791
3356	2633	10	applied	\N	\N	\N	\N	9792	9792	9793
3356	2634	11	applied	\N	\N	\N	\N	9794	9794	9795
3356	2635	12	applied	\N	\N	\N	\N	9796	9796	9797
3356	2636	13	applied	\N	\N	\N	\N	9798	9798	9799
3356	2637	14	applied	\N	\N	\N	\N	9800	9800	9801
3356	2638	15	applied	\N	\N	\N	\N	9802	9802	9803
3356	2640	16	applied	\N	\N	\N	\N	9812	9812	9813
3356	2641	17	applied	\N	\N	\N	\N	9814	9814	9815
3356	2642	18	applied	\N	\N	\N	\N	9816	9816	9817
3356	2643	19	applied	\N	\N	\N	\N	9818	9818	9819
3356	2644	20	applied	\N	\N	\N	\N	9820	9820	9821
3356	2645	21	applied	\N	\N	\N	\N	9824	9824	9825
3356	2646	22	applied	\N	\N	\N	\N	9826	9826	9827
3356	2651	23	applied	\N	\N	\N	\N	9837	9837	9838
3356	2652	24	applied	\N	\N	\N	\N	9839	9839	9840
3356	2653	25	applied	\N	\N	\N	\N	9841	9841	9842
3356	2654	26	applied	\N	\N	\N	\N	9843	9843	9844
3356	2655	27	applied	\N	\N	\N	\N	9850	9850	9851
3356	2656	28	applied	\N	\N	\N	\N	9852	9852	9853
3356	2657	29	applied	\N	\N	\N	\N	9854	9854	9855
3356	2660	30	applied	\N	\N	\N	\N	9860	9860	9861
3356	2661	31	applied	\N	\N	\N	\N	9862	9862	9863
3356	2662	32	applied	\N	\N	\N	\N	9864	9864	9865
3356	2664	33	applied	\N	\N	\N	\N	9869	9869	9870
3356	2665	34	applied	\N	\N	\N	\N	9871	9871	9872
3356	2666	35	applied	\N	\N	\N	\N	9873	9873	9874
3356	2668	36	applied	\N	\N	\N	\N	9883	9883	9884
3356	2669	37	applied	\N	\N	\N	\N	9885	9885	9886
3356	2670	38	applied	\N	\N	\N	\N	9887	9887	9888
3356	2671	39	applied	\N	\N	\N	\N	9889	9889	9890
3356	2672	40	applied	\N	\N	\N	\N	9891	9891	9892
3356	2673	41	applied	\N	\N	\N	\N	9893	9893	9894
3356	2674	42	applied	\N	\N	\N	\N	9895	9895	9896
3356	2675	43	applied	\N	\N	\N	\N	9897	9897	9898
3356	2676	44	applied	\N	\N	\N	\N	9899	9899	9900
3356	2677	45	applied	\N	\N	\N	\N	9901	9901	9902
3356	2678	46	applied	\N	\N	\N	\N	9903	9903	9904
3356	2679	47	applied	\N	\N	\N	\N	9905	9905	9906
3357	2864	0	applied	\N	\N	\N	\N	10508	10508	10509
3358	2864	0	applied	\N	\N	\N	\N	10508	10508	10509
3359	2865	0	applied	\N	\N	\N	\N	10512	10512	10513
3360	2866	0	applied	\N	\N	\N	\N	10514	10514	10515
3360	2867	1	applied	\N	\N	\N	\N	10516	10516	10517
3363	2871	0	applied	\N	\N	\N	\N	10528	10528	10529
3366	2874	0	applied	\N	\N	\N	\N	10538	10538	10539
3372	2878	0	applied	\N	\N	\N	\N	10578	10578	10579
3375	2884	0	applied	\N	\N	\N	\N	10594	10594	10595
3375	2885	1	applied	\N	\N	\N	\N	10596	10596	10597
3383	2889	0	applied	\N	\N	\N	\N	10617	10617	10618
3384	2889	0	applied	\N	\N	\N	\N	10617	10617	10618
3387	2891	0	applied	\N	\N	\N	\N	10627	10627	10628
3393	2895	0	applied	\N	\N	\N	\N	10642	10642	10643
3396	2896	0	applied	\N	\N	\N	\N	10650	10650	10651
3399	2897	0	applied	\N	\N	\N	\N	10655	10655	10656
3402	2859	0	applied	\N	\N	\N	\N	10659	10659	1435
3402	2857	1	applied	\N	\N	\N	\N	10485	10485	10491
3402	2856	2	applied	\N	\N	\N	\N	10483	10483	10484
3402	2858	3	applied	\N	\N	\N	\N	10487	10487	10488
3402	2860	4	applied	\N	\N	\N	\N	10492	10492	10493
3402	2861	5	applied	\N	\N	\N	\N	10494	10494	10495
3402	2862	6	applied	\N	\N	\N	\N	10498	10498	10499
3402	2863	7	applied	\N	\N	\N	\N	10500	10500	10501
3402	2864	8	applied	\N	\N	\N	\N	10508	10508	10509
3402	2865	9	applied	\N	\N	\N	\N	10512	10512	10513
3402	2866	10	applied	\N	\N	\N	\N	10514	10514	10515
3402	2867	11	applied	\N	\N	\N	\N	10516	10516	10517
3402	2868	12	applied	\N	\N	\N	\N	10519	10519	10520
3402	2869	13	applied	\N	\N	\N	\N	10521	10521	10522
3402	2870	14	applied	\N	\N	\N	\N	10524	10524	10525
3402	2871	15	applied	\N	\N	\N	\N	10528	10528	10529
3402	2872	16	applied	\N	\N	\N	\N	10532	10532	10533
3402	2873	17	applied	\N	\N	\N	\N	10534	10534	10535
3402	2874	18	applied	\N	\N	\N	\N	10538	10538	10539
3402	2875	19	applied	\N	\N	\N	\N	10542	10542	10543
3402	2876	20	applied	\N	\N	\N	\N	10546	10546	10547
3402	2877	21	applied	\N	\N	\N	\N	10548	10548	10549
3402	2878	22	applied	\N	\N	\N	\N	10578	10578	10579
3402	2879	23	applied	\N	\N	\N	\N	10583	10583	10584
3402	2880	24	applied	\N	\N	\N	\N	10585	10585	10586
3402	2881	25	applied	\N	\N	\N	\N	10587	10587	10588
3402	2882	26	applied	\N	\N	\N	\N	10589	10589	10590
3402	2884	27	applied	\N	\N	\N	\N	10594	10594	10595
3402	2885	28	applied	\N	\N	\N	\N	10596	10596	10597
3402	2886	29	applied	\N	\N	\N	\N	10605	10605	10606
3402	2887	30	applied	\N	\N	\N	\N	10609	10609	10610
3402	2888	31	applied	\N	\N	\N	\N	10611	10611	10612
3402	2889	32	applied	\N	\N	\N	\N	10617	10617	10618
3402	2890	33	applied	\N	\N	\N	\N	10625	10625	10626
3402	2891	34	applied	\N	\N	\N	\N	10627	10627	10628
3402	2892	35	applied	\N	\N	\N	\N	10630	10630	10631
3402	2893	36	applied	\N	\N	\N	\N	10634	10634	10635
3402	2894	37	applied	\N	\N	\N	\N	10639	10639	10640
3402	2895	38	applied	\N	\N	\N	\N	10642	10642	10643
3402	2896	39	applied	\N	\N	\N	\N	10650	10650	10651
3402	2883	40	applied	\N	\N	\N	\N	10591	10591	10168
3408	2894	0	applied	\N	\N	\N	\N	10639	10639	10640
3408	2895	1	applied	\N	\N	\N	\N	10642	10642	10643
3408	2896	2	applied	\N	\N	\N	\N	10650	10650	10651
3408	2897	3	applied	\N	\N	\N	\N	10655	10655	10656
3408	2898	4	applied	\N	\N	\N	\N	10661	10661	10662
3408	2899	5	applied	\N	\N	\N	\N	10665	10665	10666
3408	2900	6	applied	\N	\N	\N	\N	10668	10668	10669
3408	2901	7	applied	\N	\N	\N	\N	10670	10670	10671
3411	2900	0	applied	\N	\N	\N	\N	10668	10668	10669
3411	2901	1	applied	\N	\N	\N	\N	10670	10670	10671
3414	2903	0	applied	\N	\N	\N	\N	10682	10682	10683
3417	2905	0	applied	\N	\N	\N	\N	10690	10690	10691
3420	2906	0	applied	\N	\N	\N	\N	10696	10696	10697
3420	2907	1	applied	\N	\N	\N	\N	10698	10698	10699
3424	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3427	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3427	2909	1	applied	\N	\N	\N	\N	10707	10707	10708
3427	2910	2	applied	\N	\N	\N	\N	10709	10709	10710
3430	2911	0	applied	\N	\N	\N	\N	10717	10717	10718
3431	2912	0	applied	\N	\N	\N	\N	10723	10723	10724
3446	2915	0	applied	\N	\N	\N	\N	10739	10739	10740
3496	2917	0	applied	\N	\N	\N	\N	10847	10847	10848
3499	2854	0	applied	\N	\N	\N	\N	10400	10400	10795
3499	2856	1	applied	\N	\N	\N	\N	10483	10483	10796
3499	2858	2	applied	\N	\N	\N	\N	10487	10487	10797
3499	2860	3	applied	\N	\N	\N	\N	10492	10492	10798
3499	2861	4	applied	\N	\N	\N	\N	10494	10494	10799
3499	2862	5	applied	\N	\N	\N	\N	10498	10498	10800
3499	2863	6	applied	\N	\N	\N	\N	10500	10500	10801
3499	2864	7	applied	\N	\N	\N	\N	10508	10508	10802
3499	2865	8	applied	\N	\N	\N	\N	10512	10512	10803
3499	2866	9	applied	\N	\N	\N	\N	10514	10514	10804
3499	2867	10	applied	\N	\N	\N	\N	10516	10516	10805
3499	2868	11	applied	\N	\N	\N	\N	10519	10519	10806
3499	2869	12	applied	\N	\N	\N	\N	10521	10521	10807
3499	2870	13	applied	\N	\N	\N	\N	10524	10524	10808
3499	2871	15	applied	\N	\N	\N	\N	10528	10528	10809
3499	2872	16	applied	\N	\N	\N	\N	10532	10532	10810
3499	2873	17	applied	\N	\N	\N	\N	10534	10534	10811
3499	2874	18	applied	\N	\N	\N	\N	10538	10538	10812
3499	2875	19	applied	\N	\N	\N	\N	10542	10542	10813
3499	2876	20	applied	\N	\N	\N	\N	10546	10546	10814
3499	2877	21	applied	\N	\N	\N	\N	10548	10548	10815
3499	2878	22	applied	\N	\N	\N	\N	10578	10578	10816
3499	2879	23	applied	\N	\N	\N	\N	10583	10583	10817
3499	2880	24	applied	\N	\N	\N	\N	10585	10585	10819
3499	2881	25	applied	\N	\N	\N	\N	10587	10587	10820
3499	2882	26	applied	\N	\N	\N	\N	10589	10589	10821
3499	2884	27	applied	\N	\N	\N	\N	10594	10594	10822
3499	2885	28	applied	\N	\N	\N	\N	10596	10596	10823
3499	2886	29	applied	\N	\N	\N	\N	10605	10605	10824
3499	2887	30	applied	\N	\N	\N	\N	10609	10609	10825
3499	2888	31	applied	\N	\N	\N	\N	10611	10611	10826
3499	2889	32	applied	\N	\N	\N	\N	10617	10617	10827
3499	2890	33	applied	\N	\N	\N	\N	10625	10625	10828
3499	2891	34	applied	\N	\N	\N	\N	10627	10627	10829
3499	2892	35	applied	\N	\N	\N	\N	10630	10630	10830
3499	2893	36	applied	\N	\N	\N	\N	10634	10634	10831
3499	2894	37	applied	\N	\N	\N	\N	10639	10639	10832
3499	2895	38	applied	\N	\N	\N	\N	10642	10642	10833
3499	2896	39	applied	\N	\N	\N	\N	10650	10650	10834
3499	2897	40	applied	\N	\N	\N	\N	10655	10655	10835
3499	2898	41	applied	\N	\N	\N	\N	10661	10661	10836
3499	2899	42	applied	\N	\N	\N	\N	10665	10665	10837
3499	2900	43	applied	\N	\N	\N	\N	10668	10668	10838
3499	2901	44	applied	\N	\N	\N	\N	10670	10670	10839
3361	2868	0	applied	\N	\N	\N	\N	10519	10519	10520
3361	2869	1	applied	\N	\N	\N	\N	10521	10521	10522
3364	2871	0	applied	\N	\N	\N	\N	10528	10528	10529
3367	2875	0	applied	\N	\N	\N	\N	10542	10542	10543
3369	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3369	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3369	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3369	2758	3	applied	\N	\N	1000000000	\N	10146	10146	10147
3369	2732	4	applied	\N	\N	1000000000	\N	10075	10075	10076
3369	2731	5	applied	\N	\N	\N	\N	10072	10072	10073
3369	2755	6	applied	\N	\N	\N	\N	10137	10137	10138
3369	2733	7	applied	\N	\N	\N	\N	10077	10077	10078
3369	2734	8	applied	\N	\N	\N	\N	10079	10079	10080
3369	2735	9	applied	\N	\N	\N	\N	10081	10081	10082
3369	2736	10	applied	\N	\N	\N	\N	10083	10083	10084
3369	2737	11	applied	\N	\N	\N	\N	10085	10085	10086
3369	2738	12	applied	\N	\N	\N	\N	10087	10087	10088
3369	2740	13	applied	\N	\N	\N	\N	10095	10095	10096
3369	2741	14	applied	\N	\N	\N	\N	10097	10097	10098
3369	2742	15	applied	\N	\N	\N	\N	10099	10099	10100
3369	2743	16	applied	\N	\N	\N	\N	10101	10101	10102
3369	2750	17	applied	\N	\N	\N	\N	10123	10123	10124
3369	2751	18	applied	\N	\N	\N	\N	10125	10125	10126
3369	2752	19	applied	\N	\N	\N	\N	10127	10127	10128
3369	2721	20	applied	\N	\N	\N	\N	10044	10044	10045
3369	2722	21	applied	\N	\N	\N	\N	10046	10046	10047
3369	2723	22	applied	\N	\N	\N	\N	10050	10050	10051
3369	2724	23	applied	\N	\N	\N	\N	10052	10052	10053
3369	2725	24	applied	\N	\N	\N	\N	10055	10055	10056
3369	2726	25	applied	\N	\N	\N	\N	10057	10057	10058
3369	2727	26	applied	\N	\N	\N	\N	10060	10060	10061
3369	2728	27	applied	\N	\N	\N	\N	10062	10062	10063
3369	2729	28	applied	\N	\N	\N	\N	10064	10064	10065
3369	2730	29	applied	\N	\N	\N	\N	10070	10070	10071
3369	2739	30	applied	\N	\N	\N	\N	10089	10089	10090
3369	2744	31	applied	\N	\N	\N	\N	10103	10103	10104
3369	2745	32	applied	\N	\N	\N	\N	10108	10108	10109
3369	2746	33	applied	\N	\N	\N	\N	10112	10112	10113
3369	2747	34	applied	\N	\N	\N	\N	10116	10116	10117
3369	2748	35	applied	\N	\N	\N	\N	10118	10118	10119
3369	2749	36	applied	\N	\N	\N	\N	10120	10120	10121
3369	2753	37	applied	\N	\N	\N	\N	10129	10129	10130
3369	2754	38	applied	\N	\N	\N	\N	10135	10135	10552
3369	2759	39	applied	\N	\N	\N	\N	10148	10148	10553
3369	2760	40	applied	\N	\N	\N	\N	10150	10150	10554
3369	2761	41	applied	\N	\N	\N	\N	10154	10154	10555
3369	2762	42	applied	\N	\N	\N	\N	10162	10162	10556
3369	2764	43	applied	\N	\N	\N	\N	10170	10170	10557
3369	2765	44	applied	\N	\N	\N	\N	10175	10175	10558
3369	2766	45	applied	\N	\N	\N	\N	10177	10177	10559
3369	2767	46	applied	\N	\N	\N	\N	10187	10187	10560
3369	2769	47	applied	\N	\N	\N	\N	10194	10194	10561
3369	2778	48	applied	\N	\N	\N	\N	10214	10214	10562
3369	2779	49	applied	\N	\N	\N	\N	10216	10216	10563
3369	2797	50	applied	\N	\N	\N	\N	10256	10256	10564
3369	2802	51	applied	\N	\N	\N	\N	10268	10268	10565
3369	2804	52	applied	\N	\N	\N	\N	10273	10273	10566
3369	2805	53	applied	\N	\N	\N	\N	10275	10275	10567
3369	2812	54	applied	\N	\N	\N	\N	10290	10290	10568
3369	2813	55	applied	\N	\N	\N	\N	10294	10294	10569
3369	2814	56	applied	\N	\N	\N	\N	10299	10299	10570
3369	2816	57	applied	\N	\N	\N	\N	10302	10302	10571
3369	2819	58	applied	\N	\N	\N	\N	10309	10309	10572
3369	2820	60	applied	\N	\N	\N	\N	10311	10311	10574
3370	2876	0	applied	\N	\N	\N	\N	10546	10546	10547
3370	2877	1	applied	\N	\N	\N	\N	10548	10548	10549
3373	2879	0	applied	\N	\N	\N	\N	10583	10583	10584
3373	2880	1	applied	\N	\N	\N	\N	10585	10585	10586
3373	2881	2	applied	\N	\N	\N	\N	10587	10587	10588
3373	2882	3	applied	\N	\N	\N	\N	10589	10589	10590
3373	2883	4	applied	\N	\N	\N	\N	10591	10591	10168
3376	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3376	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3376	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3376	2626	3	applied	\N	\N	\N	\N	9778	9778	9779
3376	2758	4	applied	\N	\N	1000000000	\N	10146	10146	10147
3376	2508	5	applied	\N	\N	\N	\N	9387	9387	9388
3376	2526	6	applied	\N	\N	\N	\N	9446	9446	9447
3376	2527	7	applied	\N	\N	\N	\N	9448	9448	9449
3376	2755	8	applied	\N	\N	\N	\N	10407	10407	10138
3376	2530	9	applied	\N	\N	\N	\N	9454	9454	9455
3376	2531	10	applied	\N	\N	\N	\N	9456	9456	9457
3376	2532	11	applied	\N	\N	\N	\N	9458	9458	9459
3376	2533	12	applied	\N	\N	\N	\N	9460	9460	9461
3376	2534	13	applied	\N	\N	\N	\N	9462	9462	9463
3376	2535	14	applied	\N	\N	\N	\N	9464	9464	9465
3376	2536	15	applied	\N	\N	\N	\N	9466	9466	9467
3376	2537	16	applied	\N	\N	\N	\N	9468	9468	9469
3376	2544	17	applied	\N	\N	\N	\N	9489	9489	9490
3376	2509	18	applied	\N	\N	\N	\N	9389	9389	9390
3376	2510	19	applied	\N	\N	\N	\N	9393	9393	9394
3376	2511	20	applied	\N	\N	\N	\N	9397	9397	9398
3376	2512	21	applied	\N	\N	\N	\N	9399	9399	9400
3376	2513	22	applied	\N	\N	\N	\N	9401	9401	9402
3376	2514	23	applied	\N	\N	\N	\N	9403	9403	9404
3376	2515	24	applied	\N	\N	\N	\N	9408	9408	9409
3376	2516	25	applied	\N	\N	\N	\N	9410	9410	9411
3376	2517	26	applied	\N	\N	\N	\N	9418	9418	9419
3376	2518	27	applied	\N	\N	\N	\N	9422	9422	9423
3376	2519	28	applied	\N	\N	\N	\N	9426	9426	9427
3376	2520	29	applied	\N	\N	\N	\N	9428	9428	9429
3376	2521	30	applied	\N	\N	\N	\N	9430	9430	9431
3376	2522	31	applied	\N	\N	\N	\N	9434	9434	9435
3376	2523	32	applied	\N	\N	\N	\N	9436	9436	9437
3376	2524	33	applied	\N	\N	\N	\N	9440	9440	9441
3376	2525	34	applied	\N	\N	\N	\N	9442	9442	9443
3376	2528	35	applied	\N	\N	\N	\N	9450	9450	9451
3376	2529	36	applied	\N	\N	\N	\N	9452	9452	9453
3376	2538	37	applied	\N	\N	\N	\N	9473	9473	9474
3376	2539	38	applied	\N	\N	\N	\N	9475	9475	9476
3376	2540	39	applied	\N	\N	\N	\N	9477	9477	9478
3376	2541	40	applied	\N	\N	\N	\N	9483	9483	9484
3376	2542	41	applied	\N	\N	\N	\N	9485	9485	9486
3376	2543	42	applied	\N	\N	\N	\N	9487	9487	9488
3376	2545	43	applied	\N	\N	\N	\N	9492	9492	9493
3376	2546	44	applied	\N	\N	\N	\N	9494	9494	9495
3376	2547	45	applied	\N	\N	\N	\N	9496	9496	9497
3376	2548	46	applied	\N	\N	\N	\N	9500	9500	9501
3376	2549	47	applied	\N	\N	\N	\N	9502	9502	9503
3362	2870	0	applied	\N	\N	\N	\N	10524	10524	10525
3365	2872	0	applied	\N	\N	\N	\N	10532	10532	10533
3365	2873	1	applied	\N	\N	\N	\N	10534	10534	10535
3368	2876	0	applied	\N	\N	\N	\N	10546	10546	10547
3368	2877	1	applied	\N	\N	\N	\N	10548	10548	10549
3371	2878	0	applied	\N	\N	\N	\N	10578	10578	10579
3374	2884	0	applied	\N	\N	\N	\N	10594	10594	10595
3374	2885	1	applied	\N	\N	\N	\N	10596	10596	10597
3377	2886	0	applied	\N	\N	\N	\N	10605	10605	10606
3380	2888	0	applied	\N	\N	\N	\N	10611	10611	10612
3386	2890	0	applied	\N	\N	\N	\N	10625	10625	10626
3389	2864	0	applied	\N	\N	\N	\N	10508	10508	10509
3389	2865	1	applied	\N	\N	\N	\N	10512	10512	10513
3389	2866	2	applied	\N	\N	\N	\N	10514	10514	10515
3389	2867	3	applied	\N	\N	\N	\N	10516	10516	10517
3389	2868	4	applied	\N	\N	\N	\N	10519	10519	10520
3389	2869	5	applied	\N	\N	\N	\N	10521	10521	10522
3389	2870	6	applied	\N	\N	\N	\N	10524	10524	10525
3389	2871	7	applied	\N	\N	\N	\N	10528	10528	10529
3389	2872	8	applied	\N	\N	\N	\N	10532	10532	10533
3389	2873	9	applied	\N	\N	\N	\N	10534	10534	10535
3389	2874	10	applied	\N	\N	\N	\N	10538	10538	10539
3389	2875	11	applied	\N	\N	\N	\N	10542	10542	10543
3389	2876	12	applied	\N	\N	\N	\N	10546	10546	10547
3389	2877	13	applied	\N	\N	\N	\N	10548	10548	10549
3389	2878	14	applied	\N	\N	\N	\N	10578	10578	10579
3389	2879	15	applied	\N	\N	\N	\N	10583	10583	10584
3389	2880	16	applied	\N	\N	\N	\N	10585	10585	10586
3389	2881	17	applied	\N	\N	\N	\N	10587	10587	10588
3389	2882	18	applied	\N	\N	\N	\N	10589	10589	10590
3389	2884	19	applied	\N	\N	\N	\N	10594	10594	10595
3389	2885	20	applied	\N	\N	\N	\N	10596	10596	10597
3389	2886	21	applied	\N	\N	\N	\N	10605	10605	10606
3389	2887	22	applied	\N	\N	\N	\N	10609	10609	10610
3389	2888	23	applied	\N	\N	\N	\N	10611	10611	10612
3389	2889	24	applied	\N	\N	\N	\N	10617	10617	10618
3389	2890	25	applied	\N	\N	\N	\N	10625	10625	10626
3389	2891	26	applied	\N	\N	\N	\N	10627	10627	10628
3389	2892	27	applied	\N	\N	\N	\N	10630	10630	10631
3389	2893	28	applied	\N	\N	\N	\N	10634	10634	10635
3389	2883	29	applied	\N	\N	\N	\N	10591	10591	10168
3392	2894	0	applied	\N	\N	\N	\N	10639	10639	10640
3395	2551	0	applied	\N	\N	\N	\N	9506	9506	9507
3395	2552	1	applied	\N	\N	\N	\N	9510	9510	9511
3395	2553	2	applied	\N	\N	\N	\N	9514	9514	9515
3395	2554	3	applied	\N	\N	\N	\N	9520	9520	9521
3395	2555	4	applied	\N	\N	\N	\N	9524	9524	9525
3395	2556	5	applied	\N	\N	\N	\N	9529	9529	9530
3395	2557	6	applied	\N	\N	\N	\N	9531	9531	9532
3395	2558	7	applied	\N	\N	\N	\N	9533	9533	9534
3395	2559	8	applied	\N	\N	\N	\N	9535	9535	9536
3395	2560	9	applied	\N	\N	\N	\N	9541	9541	9542
3395	2561	10	applied	\N	\N	\N	\N	9543	9543	9544
3395	2562	11	applied	\N	\N	\N	\N	9545	9545	9546
3395	2563	12	applied	\N	\N	\N	\N	9547	9547	9548
3395	2564	13	applied	\N	\N	\N	\N	9549	9549	9550
3395	2565	14	applied	\N	\N	\N	\N	9551	9551	9552
3395	2566	15	applied	\N	\N	\N	\N	9553	9553	9554
3395	2567	16	applied	\N	\N	\N	\N	9556	9556	9557
3395	2568	17	applied	\N	\N	\N	\N	9564	9564	9565
3395	2569	18	applied	\N	\N	\N	\N	9570	9570	9571
3395	2570	19	applied	\N	\N	\N	\N	9572	9572	9573
3395	2571	20	applied	\N	\N	\N	\N	9578	9578	9579
3395	2572	21	applied	\N	\N	\N	\N	9584	9584	9585
3395	2573	22	applied	\N	\N	\N	\N	9586	9586	9587
3395	2574	23	applied	\N	\N	\N	\N	9590	9590	9591
3395	2575	24	applied	\N	\N	\N	\N	9595	9595	9596
3395	2576	25	applied	\N	\N	\N	\N	9603	9603	9604
3395	2577	26	applied	\N	\N	\N	\N	9607	9607	9608
3395	2578	27	applied	\N	\N	\N	\N	9610	9610	9611
3395	2579	28	applied	\N	\N	\N	\N	9612	9612	9613
3395	2580	29	applied	\N	\N	\N	\N	9614	9614	9615
3395	2581	30	applied	\N	\N	\N	\N	9616	9616	9617
3395	2582	31	applied	\N	\N	\N	\N	9618	9618	9619
3395	2583	32	applied	\N	\N	\N	\N	9622	9622	9623
3395	2584	33	applied	\N	\N	\N	\N	9627	9627	9628
3395	2585	34	applied	\N	\N	\N	\N	9633	9633	9634
3395	2586	35	applied	\N	\N	\N	\N	9638	9638	9639
3395	2587	36	applied	\N	\N	\N	\N	9642	9642	9643
3395	2588	37	applied	\N	\N	\N	\N	9644	9644	9645
3395	2589	38	applied	\N	\N	\N	\N	9649	9649	9650
3395	2590	39	applied	\N	\N	\N	\N	9651	9651	9652
3395	2591	40	applied	\N	\N	\N	\N	9655	9655	9656
3395	2592	41	applied	\N	\N	\N	\N	9662	9662	9663
3395	2593	42	applied	\N	\N	\N	\N	9666	9666	9667
3395	2594	43	applied	\N	\N	\N	\N	9670	9670	9671
3395	2595	44	applied	\N	\N	\N	\N	9674	9674	9675
3395	2596	45	applied	\N	\N	\N	\N	9676	9676	9677
3395	2597	46	applied	\N	\N	\N	\N	9678	9678	9679
3395	2598	47	applied	\N	\N	\N	\N	9680	9680	9681
3395	2599	48	applied	\N	\N	\N	\N	9683	9683	9684
3395	2600	49	applied	\N	\N	\N	\N	9687	9687	9688
3395	2601	50	applied	\N	\N	\N	\N	9692	9692	9693
3395	2602	51	applied	\N	\N	\N	\N	9694	9694	9695
3395	2603	52	applied	\N	\N	\N	\N	9696	9696	9697
3395	2604	53	applied	\N	\N	\N	\N	9701	9701	9702
3395	2605	54	applied	\N	\N	\N	\N	9706	9706	9707
3395	2606	55	applied	\N	\N	\N	\N	9708	9708	9709
3395	2607	56	applied	\N	\N	\N	\N	9710	9710	9711
3395	2608	57	applied	\N	\N	\N	\N	9712	9712	9713
3395	2609	58	applied	\N	\N	\N	\N	9714	9714	9715
3395	2610	59	applied	\N	\N	\N	\N	9716	9716	9717
3395	2611	60	applied	\N	\N	\N	\N	9718	9718	9719
3395	2612	61	applied	\N	\N	\N	\N	9723	9723	9724
3395	2613	62	applied	\N	\N	\N	\N	9725	9725	9726
3395	2614	63	applied	\N	\N	\N	\N	9727	9727	9728
3395	2615	64	applied	\N	\N	\N	\N	9734	9734	9735
3395	2616	65	applied	\N	\N	\N	\N	9736	9736	9737
3395	2617	66	applied	\N	\N	\N	\N	9740	9740	9741
3395	2618	67	applied	\N	\N	\N	\N	9744	9744	9745
3395	2619	68	applied	\N	\N	\N	\N	9746	9746	9747
3395	2620	69	applied	\N	\N	\N	\N	9748	9748	9749
3395	2621	71	applied	\N	\N	\N	\N	9752	9752	9753
3395	2622	72	applied	\N	\N	\N	\N	9756	9756	9757
3395	2623	73	applied	\N	\N	\N	\N	9758	9758	9759
3395	2624	74	applied	\N	\N	\N	\N	9763	9763	9764
3395	2625	75	applied	\N	\N	\N	\N	9769	9769	9770
3395	2627	76	applied	\N	\N	\N	\N	9780	9780	9781
3395	2628	77	applied	\N	\N	\N	\N	9782	9782	9783
3395	2639	78	applied	\N	\N	\N	\N	9810	9810	9811
3376	2550	48	applied	\N	\N	\N	\N	9504	9504	9505
3376	2629	49	applied	\N	\N	\N	\N	9784	9784	9785
3376	2630	50	applied	\N	\N	\N	\N	9786	9786	9787
3376	2631	51	applied	\N	\N	\N	\N	9788	9788	9789
3376	2632	52	applied	\N	\N	\N	\N	9790	9790	9791
3376	2633	53	applied	\N	\N	\N	\N	9792	9792	9793
3376	2634	54	applied	\N	\N	\N	\N	9794	9794	9795
3376	2635	55	applied	\N	\N	\N	\N	9796	9796	9797
3376	2636	56	applied	\N	\N	\N	\N	9798	9798	9799
3376	2637	57	applied	\N	\N	\N	\N	9800	9800	9801
3376	2638	58	applied	\N	\N	\N	\N	9802	9802	9803
3376	2640	59	applied	\N	\N	\N	\N	9812	9812	9813
3376	2641	60	applied	\N	\N	\N	\N	9814	9814	9815
3376	2642	61	applied	\N	\N	\N	\N	9816	9816	9817
3376	2643	62	applied	\N	\N	\N	\N	9818	9818	9819
3376	2644	63	applied	\N	\N	\N	\N	9820	9820	9821
3376	2645	64	applied	\N	\N	\N	\N	9824	9824	9825
3376	2646	65	applied	\N	\N	\N	\N	9826	9826	9827
3376	2651	66	applied	\N	\N	\N	\N	9837	9837	9838
3376	2652	67	applied	\N	\N	\N	\N	9839	9839	9840
3376	2653	68	applied	\N	\N	\N	\N	9841	9841	9842
3376	2654	69	applied	\N	\N	\N	\N	9843	9843	9844
3376	2655	71	applied	\N	\N	\N	\N	9850	9850	9851
3376	2656	72	applied	\N	\N	\N	\N	9852	9852	9853
3376	2657	73	applied	\N	\N	\N	\N	9854	9854	9855
3376	2660	74	applied	\N	\N	\N	\N	9860	9860	9861
3376	2661	75	applied	\N	\N	\N	\N	9862	9862	9863
3376	2662	76	applied	\N	\N	\N	\N	9864	9864	9865
3376	2664	77	applied	\N	\N	\N	\N	9869	9869	9870
3376	2665	78	applied	\N	\N	\N	\N	9871	9871	9872
3376	2666	79	applied	\N	\N	\N	\N	9873	9873	9874
3376	2668	80	applied	\N	\N	\N	\N	9883	9883	9884
3376	2669	81	applied	\N	\N	\N	\N	9885	9885	9886
3376	2670	82	applied	\N	\N	\N	\N	9887	9887	9888
3376	2671	83	applied	\N	\N	\N	\N	9889	9889	9890
3376	2672	84	applied	\N	\N	\N	\N	9891	9891	9892
3376	2673	85	applied	\N	\N	\N	\N	9893	9893	9894
3376	2674	86	applied	\N	\N	\N	\N	9895	9895	9896
3376	2675	87	applied	\N	\N	\N	\N	9897	9897	9898
3376	2676	88	applied	\N	\N	\N	\N	9899	9899	9900
3376	2677	89	applied	\N	\N	\N	\N	9901	9901	9902
3376	2678	90	applied	\N	\N	\N	\N	9903	9903	9904
3376	2679	91	applied	\N	\N	\N	\N	9905	9905	9906
3376	2680	92	applied	\N	\N	\N	\N	9907	9907	9908
3376	2684	93	applied	\N	\N	\N	\N	9915	9915	9916
3376	2685	94	applied	\N	\N	\N	\N	9917	9917	9918
3376	2687	95	applied	\N	\N	\N	\N	9924	9924	9925
3376	2688	96	applied	\N	\N	\N	\N	9926	9926	9927
3376	2704	97	applied	\N	\N	\N	\N	9985	9985	9986
3376	2705	98	applied	\N	\N	\N	\N	9987	9987	9988
3376	2717	99	applied	\N	\N	\N	\N	10030	10030	10031
3376	2719	100	applied	\N	\N	\N	\N	10034	10034	10035
3376	2720	101	applied	\N	\N	\N	\N	10036	10036	10037
3376	2731	102	applied	\N	\N	\N	\N	10072	10072	10073
3376	2733	103	applied	\N	\N	\N	\N	10077	10077	10078
3376	2734	104	applied	\N	\N	\N	\N	10079	10079	10080
3376	2735	105	applied	\N	\N	\N	\N	10081	10081	10082
3376	2736	106	applied	\N	\N	\N	\N	10083	10083	10084
3376	2737	107	applied	\N	\N	\N	\N	10085	10085	10086
3376	2738	108	applied	\N	\N	\N	\N	10087	10087	10088
3376	2740	109	applied	\N	\N	\N	\N	10095	10095	10096
3376	2741	110	applied	\N	\N	\N	\N	10097	10097	10098
3376	2742	111	applied	\N	\N	\N	\N	10099	10099	10100
3376	2743	112	applied	\N	\N	\N	\N	10101	10101	10102
3376	2750	113	applied	\N	\N	\N	\N	10123	10123	10124
3376	2751	114	applied	\N	\N	\N	\N	10125	10125	10126
3376	2752	115	applied	\N	\N	\N	\N	10127	10127	10128
3376	2768	116	applied	\N	\N	\N	\N	10189	10189	10190
3376	2770	117	applied	\N	\N	\N	\N	10196	10196	10197
3376	2771	118	applied	\N	\N	\N	\N	10198	10198	10199
3376	2772	119	applied	\N	\N	\N	\N	10200	10200	10201
3376	2773	120	applied	\N	\N	\N	\N	10202	10202	10203
3376	2774	121	applied	\N	\N	\N	\N	10204	10204	10205
3376	2775	122	applied	\N	\N	\N	\N	10206	10206	10207
3376	2776	123	applied	\N	\N	\N	\N	10208	10208	10209
3376	2777	124	applied	\N	\N	\N	\N	10210	10210	10211
3376	2780	125	applied	\N	\N	\N	\N	10218	10218	10219
3379	2886	0	applied	\N	\N	\N	\N	10605	10605	10606
3379	2887	1	applied	\N	\N	\N	\N	10609	10609	10610
3381	2888	0	applied	\N	\N	\N	\N	10611	10611	10612
3382	2889	0	applied	\N	\N	\N	\N	10617	10617	10618
3388	2892	0	applied	\N	\N	\N	\N	10630	10630	10631
3390	2893	0	applied	\N	\N	\N	\N	10634	10634	10635
3391	2893	0	applied	\N	\N	\N	\N	10634	10634	10635
3394	2895	0	applied	\N	\N	\N	\N	10642	10642	10643
3397	2896	0	applied	\N	\N	\N	\N	10650	10650	10651
3403	2898	0	applied	\N	\N	\N	\N	10661	10661	10662
3415	2904	0	applied	\N	\N	\N	\N	10686	10686	10687
3421	2906	0	applied	\N	\N	\N	\N	10696	10696	10697
3421	2907	1	applied	\N	\N	\N	\N	10698	10698	10699
3426	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3426	2909	1	applied	\N	\N	\N	\N	10707	10707	10708
3426	2910	2	applied	\N	\N	\N	\N	10709	10709	10710
3429	2911	0	applied	\N	\N	\N	\N	10717	10717	10718
3444	2913	0	applied	\N	\N	\N	\N	10733	10733	10734
3444	2914	1	applied	\N	\N	\N	\N	10735	10735	10736
3488	2916	0	applied	\N	\N	1000000000	\N	10784	10784	10785
3503	2919	0	applied	\N	\N	\N	\N	10870	10870	10871
3509	2920	0	applied	\N	\N	\N	\N	10877	10877	10878
3521	2923	0	applied	\N	\N	\N	\N	10895	10895	10896
3532	2925	0	applied	\N	\N	\N	\N	10914	10914	10915
3532	2926	1	applied	\N	\N	\N	\N	10916	10916	10917
3543	2925	0	applied	\N	\N	\N	\N	10914	10914	10915
3543	2913	1	applied	\N	\N	\N	\N	10733	10733	10734
3543	2920	2	applied	\N	\N	\N	\N	10902	10902	10878
3543	2914	3	applied	\N	\N	\N	\N	10735	10735	10736
3543	2915	4	applied	\N	\N	\N	\N	10739	10739	10740
3543	2922	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	9438	9438	\N
3543	2826	6	applied	\N	\N	\N	\N	10329	10329	4764
3543	2923	7	applied	\N	\N	\N	\N	10895	10895	10926
3543	2916	8	applied	\N	\N	1000000000	\N	10784	10784	10785
3636	2930	0	applied	\N	\N	1000000000	\N	10984	10984	10985
3636	2931	1	applied	\N	\N	\N	\N	10986	10986	1435
3636	2932	2	applied	\N	\N	\N	\N	10987	10987	1435
3640	2930	0	applied	\N	\N	1000000000	\N	10993	10993	10985
3640	2927	1	applied	\N	\N	\N	\N	10974	10974	10975
3640	2928	2	applied	\N	\N	1000000000	\N	10976	10976	10977
3640	2929	3	applied	\N	\N	\N	\N	10980	10980	10981
3640	2931	4	applied	\N	\N	\N	\N	10986	10986	1435
3395	2647	79	applied	\N	\N	\N	\N	9828	9828	9829
3395	2648	80	applied	\N	\N	\N	\N	9830	9830	9831
3395	2649	81	applied	\N	\N	\N	\N	9833	9833	9834
3395	2650	82	applied	\N	\N	\N	\N	9835	9835	9836
3395	2658	83	applied	\N	\N	\N	\N	9856	9856	9857
3395	2659	84	applied	\N	\N	\N	\N	9858	9858	9859
3395	2663	85	applied	\N	\N	\N	\N	9867	9867	9868
3395	2667	86	applied	\N	\N	\N	\N	9877	9877	9878
3395	2681	87	applied	\N	\N	\N	\N	9909	9909	9910
3395	2682	88	applied	\N	\N	\N	\N	9911	9911	9912
3395	2683	89	applied	\N	\N	\N	\N	9913	9913	9914
3395	2686	90	applied	\N	\N	\N	\N	9922	9922	9923
3395	2689	91	applied	\N	\N	\N	\N	9932	9932	9933
3395	2690	92	applied	\N	\N	\N	\N	9938	9938	9939
3395	2691	93	applied	\N	\N	\N	\N	9940	9940	9941
3395	2692	94	applied	\N	\N	\N	\N	9946	9946	9947
3395	2693	95	applied	\N	\N	\N	\N	9950	9950	9951
3395	2694	96	applied	\N	\N	\N	\N	9956	9956	9957
3395	2695	97	applied	\N	\N	\N	\N	9958	9958	9959
3395	2696	98	applied	\N	\N	\N	\N	9960	9960	9961
3395	2697	99	applied	\N	\N	\N	\N	9962	9962	9963
3395	2698	100	applied	\N	\N	\N	\N	9965	9965	9966
3395	2699	101	applied	\N	\N	\N	\N	9968	9968	9969
3395	2700	102	applied	\N	\N	\N	\N	9970	9970	9971
3395	2701	103	applied	\N	\N	\N	\N	9976	9976	9977
3395	2702	104	applied	\N	\N	\N	\N	9980	9980	9981
3395	2703	105	applied	\N	\N	\N	\N	9983	9983	9984
3395	2706	106	applied	\N	\N	\N	\N	9989	9989	9990
3395	2707	107	applied	\N	\N	\N	\N	9991	9991	9992
3395	2708	108	applied	\N	\N	\N	\N	9993	9993	9994
3395	2709	109	applied	\N	\N	\N	\N	9997	9997	9998
3395	2710	110	applied	\N	\N	\N	\N	10003	10003	10004
3395	2711	111	applied	\N	\N	\N	\N	10005	10005	10006
3395	2712	112	applied	\N	\N	\N	\N	10013	10013	10014
3395	2713	113	applied	\N	\N	\N	\N	10015	10015	10016
3395	2714	114	applied	\N	\N	\N	\N	10019	10019	10020
3395	2715	115	applied	\N	\N	\N	\N	10021	10021	10022
3395	2716	116	applied	\N	\N	\N	\N	10026	10026	10027
3395	2718	117	applied	\N	\N	\N	\N	10032	10032	10033
3395	2721	118	applied	\N	\N	\N	\N	10044	10044	10045
3395	2722	119	applied	\N	\N	\N	\N	10046	10046	10047
3395	2723	120	applied	\N	\N	\N	\N	10050	10050	10051
3395	2724	121	applied	\N	\N	\N	\N	10052	10052	10053
3395	2725	122	applied	\N	\N	\N	\N	10055	10055	10056
3395	2726	123	applied	\N	\N	\N	\N	10057	10057	10058
3395	2727	124	applied	\N	\N	\N	\N	10060	10060	10061
3395	2728	125	applied	\N	\N	\N	\N	10062	10062	10063
3398	2893	0	applied	\N	\N	\N	\N	10634	10634	10635
3398	2894	1	applied	\N	\N	\N	\N	10639	10639	10640
3398	2895	2	applied	\N	\N	\N	\N	10642	10642	10643
3398	2896	3	applied	\N	\N	\N	\N	10650	10650	10651
3400	2897	0	applied	\N	\N	\N	\N	10655	10655	10656
3401	2897	0	applied	\N	\N	\N	\N	10655	10655	10656
3404	2899	0	applied	\N	\N	\N	\N	10665	10665	10666
3409	2900	0	applied	\N	\N	\N	\N	10668	10668	10669
3409	2901	1	applied	\N	\N	\N	\N	10670	10670	10671
3410	2900	0	applied	\N	\N	\N	\N	10668	10668	10669
3410	2901	1	applied	\N	\N	\N	\N	10670	10670	10671
3413	2900	0	applied	\N	\N	\N	\N	10668	10668	10669
3413	2901	1	applied	\N	\N	\N	\N	10670	10670	10671
3413	2902	2	applied	\N	\N	\N	\N	10679	10679	10680
3416	2904	0	applied	\N	\N	\N	\N	10686	10686	10687
3418	2905	0	applied	\N	\N	\N	\N	10690	10690	10691
3419	2905	0	applied	\N	\N	\N	\N	10690	10690	10691
3422	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3425	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3425	2909	1	applied	\N	\N	\N	\N	10707	10707	10708
3425	2910	2	applied	\N	\N	\N	\N	10709	10709	10710
3428	2908	0	applied	\N	\N	\N	\N	10703	10703	10704
3428	2909	1	applied	\N	\N	\N	\N	10707	10707	10708
3428	2910	2	applied	\N	\N	\N	\N	10709	10709	10710
3445	2915	0	applied	\N	\N	\N	\N	10739	10739	10740
3447	2915	0	applied	\N	\N	\N	\N	10739	10739	10740
3448	2915	0	applied	\N	\N	\N	\N	10739	10739	10740
3456	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3456	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3456	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3456	2758	3	applied	\N	\N	1000000000	\N	10146	10146	10147
3456	2732	4	applied	\N	\N	1000000000	\N	10075	10075	10076
3456	2755	5	applied	\N	\N	\N	\N	10137	10137	10138
3456	2704	6	applied	\N	\N	\N	\N	9985	9985	9986
3456	2913	7	applied	\N	\N	\N	\N	10733	10733	10734
3456	2692	8	applied	\N	\N	\N	\N	9946	9946	9947
3456	2693	9	applied	\N	\N	\N	\N	9950	9950	9951
3456	2694	10	applied	\N	\N	\N	\N	9956	9956	9957
3456	2914	11	applied	\N	\N	\N	\N	10735	10735	10736
3456	2915	12	applied	\N	\N	\N	\N	10739	10739	10740
3456	2695	13	applied	\N	\N	\N	\N	9958	9958	9959
3456	2696	15	applied	\N	\N	\N	\N	9960	9960	9961
3456	2697	16	applied	\N	\N	\N	\N	9962	9962	9963
3456	2698	17	applied	\N	\N	\N	\N	9965	9965	9966
3456	2699	18	applied	\N	\N	\N	\N	9968	9968	9969
3456	2700	19	applied	\N	\N	\N	\N	9970	9970	9971
3456	2701	20	applied	\N	\N	\N	\N	9976	9976	9977
3456	2702	21	applied	\N	\N	\N	\N	9980	9980	9981
3456	2703	22	applied	\N	\N	\N	\N	9983	9983	9984
3456	2705	23	applied	\N	\N	\N	\N	9987	9987	9988
3456	2717	24	applied	\N	\N	\N	\N	10030	10030	10031
3456	2719	25	applied	\N	\N	\N	\N	10034	10034	10035
3456	2720	26	applied	\N	\N	\N	\N	10036	10036	10037
3456	2731	27	applied	\N	\N	\N	\N	10072	10072	10073
3456	2733	28	applied	\N	\N	\N	\N	10077	10077	10078
3456	2734	29	applied	\N	\N	\N	\N	10079	10079	10080
3456	2735	30	applied	\N	\N	\N	\N	10081	10081	10082
3456	2736	31	applied	\N	\N	\N	\N	10083	10083	10084
3456	2737	32	applied	\N	\N	\N	\N	10085	10085	10086
3456	2738	33	applied	\N	\N	\N	\N	10087	10087	10088
3456	2740	34	applied	\N	\N	\N	\N	10095	10095	10096
3456	2741	35	applied	\N	\N	\N	\N	10097	10097	10098
3456	2742	36	applied	\N	\N	\N	\N	10099	10099	10100
3456	2743	37	applied	\N	\N	\N	\N	10101	10101	10102
3456	2750	38	applied	\N	\N	\N	\N	10123	10123	10124
3456	2751	39	applied	\N	\N	\N	\N	10125	10125	10126
3456	2752	40	applied	\N	\N	\N	\N	10127	10127	10128
3456	2706	41	applied	\N	\N	\N	\N	9989	9989	9990
3456	2707	42	applied	\N	\N	\N	\N	9991	9991	9992
3456	2708	43	applied	\N	\N	\N	\N	9993	9993	9994
3456	2709	44	applied	\N	\N	\N	\N	9997	9997	9998
3456	2710	45	applied	\N	\N	\N	\N	10003	10003	10004
3456	2711	46	applied	\N	\N	\N	\N	10005	10005	10006
3456	2712	47	applied	\N	\N	\N	\N	10013	10013	10014
3456	2713	48	applied	\N	\N	\N	\N	10015	10015	10016
3456	2714	49	applied	\N	\N	\N	\N	10019	10019	10020
3456	2715	50	applied	\N	\N	\N	\N	10021	10021	10022
3456	2716	51	applied	\N	\N	\N	\N	10026	10026	10027
3456	2718	52	applied	\N	\N	\N	\N	10032	10032	10033
3456	2721	53	applied	\N	\N	\N	\N	10044	10044	10045
3456	2722	54	applied	\N	\N	\N	\N	10046	10046	10047
3456	2723	55	applied	\N	\N	\N	\N	10050	10050	10051
3456	2724	56	applied	\N	\N	\N	\N	10052	10052	10053
3456	2725	57	applied	\N	\N	\N	\N	10055	10055	10056
3456	2726	58	applied	\N	\N	\N	\N	10057	10057	10058
3456	2727	59	applied	\N	\N	\N	\N	10060	10060	10061
3456	2728	60	applied	\N	\N	\N	\N	10062	10062	10063
3456	2729	61	applied	\N	\N	\N	\N	10064	10064	10065
3456	2730	62	applied	\N	\N	\N	\N	10070	10070	10071
3456	2739	63	applied	\N	\N	\N	\N	10089	10089	10090
3456	2744	64	applied	\N	\N	\N	\N	10103	10103	10104
3456	2745	65	applied	\N	\N	\N	\N	10108	10108	10109
3456	2746	66	applied	\N	\N	\N	\N	10112	10112	10113
3456	2747	67	applied	\N	\N	\N	\N	10116	10116	10117
3456	2748	68	applied	\N	\N	\N	\N	10118	10118	10119
3456	2749	69	applied	\N	\N	\N	\N	10120	10120	10121
3456	2753	70	applied	\N	\N	\N	\N	10129	10129	10130
3456	2754	71	applied	\N	\N	\N	\N	10135	10135	10552
3456	2759	72	applied	\N	\N	\N	\N	10148	10148	10553
3456	2760	73	applied	\N	\N	\N	\N	10150	10150	10554
3456	2761	74	applied	\N	\N	\N	\N	10154	10154	10555
3456	2762	75	applied	\N	\N	\N	\N	10162	10162	10556
3456	2764	76	applied	\N	\N	\N	\N	10170	10170	10557
3456	2765	77	applied	\N	\N	\N	\N	10175	10175	10558
3456	2766	78	applied	\N	\N	\N	\N	10177	10177	10559
3456	2767	79	applied	\N	\N	\N	\N	10187	10187	10560
3456	2769	80	applied	\N	\N	\N	\N	10194	10194	10561
3456	2778	81	applied	\N	\N	\N	\N	10214	10214	10562
3456	2779	82	applied	\N	\N	\N	\N	10216	10216	10563
3456	2797	83	applied	\N	\N	\N	\N	10256	10256	10564
3456	2802	84	applied	\N	\N	\N	\N	10268	10268	10565
3456	2804	85	applied	\N	\N	\N	\N	10273	10273	10566
3456	2805	86	applied	\N	\N	\N	\N	10275	10275	10567
3456	2812	87	applied	\N	\N	\N	\N	10290	10290	10568
3456	2813	88	applied	\N	\N	\N	\N	10294	10294	10569
3456	2814	89	applied	\N	\N	\N	\N	10299	10299	10570
3456	2816	90	applied	\N	\N	\N	\N	10302	10302	10571
3456	2819	91	applied	\N	\N	\N	\N	10309	10309	10572
3456	2820	92	applied	\N	\N	\N	\N	10311	10311	10574
3456	2821	93	applied	\N	\N	\N	\N	10315	10315	10750
3456	2823	94	applied	\N	\N	\N	\N	10320	10320	10751
3456	2824	95	applied	\N	\N	\N	\N	10322	10322	10752
3456	2825	96	applied	\N	\N	\N	\N	10327	10327	10753
3456	2827	97	applied	\N	\N	\N	\N	10332	10332	10754
3456	2828	98	applied	\N	\N	\N	\N	10334	10334	10755
3456	2829	99	applied	\N	\N	\N	\N	10336	10336	10756
3456	2830	100	applied	\N	\N	\N	\N	10340	10340	10757
3456	2831	101	applied	\N	\N	\N	\N	10344	10344	10758
3456	2832	102	applied	\N	\N	\N	\N	10346	10346	10759
3456	2834	103	applied	\N	\N	\N	\N	10352	10352	10760
3456	2835	104	applied	\N	\N	\N	\N	10354	10354	10761
3456	2841	105	applied	\N	\N	\N	\N	10372	10372	10762
3456	2768	106	applied	\N	\N	\N	\N	10189	10189	10190
3456	2770	107	applied	\N	\N	\N	\N	10196	10196	10197
3456	2771	108	applied	\N	\N	\N	\N	10198	10198	10199
3456	2772	109	applied	\N	\N	\N	\N	10200	10200	10201
3456	2773	110	applied	\N	\N	\N	\N	10202	10202	10203
3456	2774	111	applied	\N	\N	\N	\N	10204	10204	10205
3456	2775	112	applied	\N	\N	\N	\N	10206	10206	10207
3456	2776	113	applied	\N	\N	\N	\N	10208	10208	10209
3456	2777	114	applied	\N	\N	\N	\N	10210	10210	10211
3456	2780	115	applied	\N	\N	\N	\N	10218	10218	10219
3456	2781	116	applied	\N	\N	\N	\N	10220	10220	10221
3456	2782	117	applied	\N	\N	\N	\N	10222	10222	10223
3456	2783	118	applied	\N	\N	\N	\N	10224	10224	10225
3456	2784	119	applied	\N	\N	\N	\N	10226	10226	10227
3456	2785	120	applied	\N	\N	\N	\N	10228	10228	10229
3456	2786	121	applied	\N	\N	\N	\N	10230	10230	10231
3456	2787	122	applied	\N	\N	\N	\N	10232	10232	10233
3456	2788	123	applied	\N	\N	\N	\N	10234	10234	10235
3456	2789	124	applied	\N	\N	\N	\N	10236	10236	10237
3456	2790	125	applied	\N	\N	\N	\N	10238	10238	10239
3489	2756	0	applied	\N	\N	\N	\N	10142	10142	10143
3489	2757	1	applied	\N	\N	\N	\N	10144	10144	10145
3489	2763	2	applied	\N	\N	\N	\N	10168	10168	10169
3489	2758	3	applied	\N	\N	1000000000	\N	10146	10146	10147
3489	2732	4	applied	\N	\N	1000000000	\N	10075	10075	10076
3489	2717	5	applied	\N	\N	\N	\N	10030	10030	10031
3489	2716	6	applied	\N	\N	\N	\N	10026	10026	10027
3489	2755	7	applied	\N	\N	\N	\N	10137	10137	10138
3489	2913	8	applied	\N	\N	\N	\N	10733	10733	10734
3489	2718	9	applied	\N	\N	\N	\N	10032	10032	10033
3489	2914	10	applied	\N	\N	\N	\N	10735	10735	10736
3489	2915	11	applied	\N	\N	\N	\N	10739	10739	10740
3489	2721	12	applied	\N	\N	\N	\N	10044	10044	10045
3489	2722	13	applied	\N	\N	\N	\N	10046	10046	10047
3489	2723	14	applied	\N	\N	\N	\N	10050	10050	10051
3489	2724	15	applied	\N	\N	\N	\N	10052	10052	10053
3489	2719	16	applied	\N	\N	\N	\N	10034	10034	10035
3489	2720	17	applied	\N	\N	\N	\N	10036	10036	10037
3489	2731	18	applied	\N	\N	\N	\N	10072	10072	10073
3489	2733	19	applied	\N	\N	\N	\N	10077	10077	10078
3489	2734	20	applied	\N	\N	\N	\N	10079	10079	10080
3489	2735	21	applied	\N	\N	\N	\N	10081	10081	10082
3489	2736	22	applied	\N	\N	\N	\N	10083	10083	10084
3489	2737	23	applied	\N	\N	\N	\N	10085	10085	10086
3489	2738	24	applied	\N	\N	\N	\N	10087	10087	10088
3489	2740	25	applied	\N	\N	\N	\N	10095	10095	10096
3489	2741	26	applied	\N	\N	\N	\N	10097	10097	10098
3489	2742	27	applied	\N	\N	\N	\N	10099	10099	10100
3489	2743	28	applied	\N	\N	\N	\N	10101	10101	10102
3489	2750	29	applied	\N	\N	\N	\N	10123	10123	10124
3489	2751	30	applied	\N	\N	\N	\N	10125	10125	10126
3489	2752	31	applied	\N	\N	\N	\N	10127	10127	10128
3489	2725	32	applied	\N	\N	\N	\N	10055	10055	10056
3489	2726	33	applied	\N	\N	\N	\N	10057	10057	10058
3489	2727	34	applied	\N	\N	\N	\N	10060	10060	10061
3489	2728	35	applied	\N	\N	\N	\N	10062	10062	10063
3489	2729	36	applied	\N	\N	\N	\N	10064	10064	10065
3489	2730	37	applied	\N	\N	\N	\N	10070	10070	10071
3489	2739	38	applied	\N	\N	\N	\N	10089	10089	10090
3489	2744	39	applied	\N	\N	\N	\N	10103	10103	10104
3489	2745	40	applied	\N	\N	\N	\N	10108	10108	10109
3489	2746	41	applied	\N	\N	\N	\N	10112	10112	10113
3489	2747	42	applied	\N	\N	\N	\N	10116	10116	10117
3489	2748	43	applied	\N	\N	\N	\N	10118	10118	10119
3489	2749	44	applied	\N	\N	\N	\N	10120	10120	10121
3489	2753	45	applied	\N	\N	\N	\N	10129	10129	10130
3489	2754	46	applied	\N	\N	\N	\N	10135	10135	10552
3489	2759	47	applied	\N	\N	\N	\N	10148	10148	10553
3489	2760	48	applied	\N	\N	\N	\N	10150	10150	10554
3489	2761	49	applied	\N	\N	\N	\N	10154	10154	10555
3489	2762	50	applied	\N	\N	\N	\N	10162	10162	10556
3489	2764	51	applied	\N	\N	\N	\N	10170	10170	10557
3489	2765	52	applied	\N	\N	\N	\N	10175	10175	10558
3489	2766	53	applied	\N	\N	\N	\N	10177	10177	10559
3489	2767	54	applied	\N	\N	\N	\N	10187	10187	10560
3489	2769	55	applied	\N	\N	\N	\N	10194	10194	10561
3489	2778	56	applied	\N	\N	\N	\N	10214	10214	10562
3489	2779	57	applied	\N	\N	\N	\N	10216	10216	10563
3489	2797	58	applied	\N	\N	\N	\N	10256	10256	10564
3489	2802	59	applied	\N	\N	\N	\N	10268	10268	10565
3489	2804	60	applied	\N	\N	\N	\N	10273	10273	10566
3489	2805	61	applied	\N	\N	\N	\N	10275	10275	10567
3489	2812	62	applied	\N	\N	\N	\N	10290	10290	10568
3489	2813	63	applied	\N	\N	\N	\N	10294	10294	10569
3489	2814	64	applied	\N	\N	\N	\N	10299	10299	10570
3489	2816	65	applied	\N	\N	\N	\N	10302	10302	10571
3489	2819	66	applied	\N	\N	\N	\N	10309	10309	10572
3489	2820	67	applied	\N	\N	\N	\N	10311	10311	10574
3489	2821	69	applied	\N	\N	\N	\N	10315	10315	10750
3489	2823	70	applied	\N	\N	\N	\N	10320	10320	10751
3489	2824	71	applied	\N	\N	\N	\N	10322	10322	10752
3489	2825	72	applied	\N	\N	\N	\N	10327	10327	10753
3489	2827	73	applied	\N	\N	\N	\N	10332	10332	10754
3489	2828	74	applied	\N	\N	\N	\N	10334	10334	10755
3489	2829	75	applied	\N	\N	\N	\N	10336	10336	10756
3489	2830	76	applied	\N	\N	\N	\N	10340	10340	10757
3489	2831	77	applied	\N	\N	\N	\N	10344	10344	10758
3489	2832	78	applied	\N	\N	\N	\N	10346	10346	10759
3489	2834	79	applied	\N	\N	\N	\N	10352	10352	10760
3489	2835	80	applied	\N	\N	\N	\N	10354	10354	10761
3489	2841	81	applied	\N	\N	\N	\N	10372	10372	10762
3489	2768	82	applied	\N	\N	\N	\N	10189	10189	10190
3489	2770	83	applied	\N	\N	\N	\N	10196	10196	10197
3489	2771	84	applied	\N	\N	\N	\N	10198	10198	10199
3493	2913	0	applied	\N	\N	\N	\N	10793	10793	10734
3493	2914	1	applied	\N	\N	\N	\N	10794	10794	10736
3493	2729	2	applied	\N	\N	\N	\N	10064	10064	10065
3493	2730	3	applied	\N	\N	\N	\N	10070	10070	10071
3493	2739	4	applied	\N	\N	\N	\N	10089	10089	10090
3493	2744	5	applied	\N	\N	\N	\N	10103	10103	10104
3493	2745	6	applied	\N	\N	\N	\N	10108	10108	10109
3493	2746	7	applied	\N	\N	\N	\N	10112	10112	10113
3493	2747	8	applied	\N	\N	\N	\N	10116	10116	10117
3493	2748	9	applied	\N	\N	\N	\N	10118	10118	10119
3493	2749	10	applied	\N	\N	\N	\N	10120	10120	10121
3493	2753	11	applied	\N	\N	\N	\N	10129	10129	10130
3493	2754	12	applied	\N	\N	\N	\N	10135	10135	10552
3493	2759	13	applied	\N	\N	\N	\N	10148	10148	10553
3493	2760	14	applied	\N	\N	\N	\N	10150	10150	10554
3493	2761	15	applied	\N	\N	\N	\N	10154	10154	10555
3493	2762	16	applied	\N	\N	\N	\N	10162	10162	10556
3493	2764	17	applied	\N	\N	\N	\N	10170	10170	10557
3493	2765	18	applied	\N	\N	\N	\N	10175	10175	10558
3493	2766	19	applied	\N	\N	\N	\N	10177	10177	10559
3493	2767	20	applied	\N	\N	\N	\N	10187	10187	10560
3493	2769	21	applied	\N	\N	\N	\N	10194	10194	10561
3493	2778	22	applied	\N	\N	\N	\N	10214	10214	10562
3493	2779	23	applied	\N	\N	\N	\N	10216	10216	10563
3493	2797	24	applied	\N	\N	\N	\N	10256	10256	10564
3493	2802	25	applied	\N	\N	\N	\N	10268	10268	10565
3493	2804	26	applied	\N	\N	\N	\N	10273	10273	10566
3493	2805	27	applied	\N	\N	\N	\N	10275	10275	10567
3493	2812	28	applied	\N	\N	\N	\N	10290	10290	10568
3493	2813	29	applied	\N	\N	\N	\N	10294	10294	10569
3493	2814	30	applied	\N	\N	\N	\N	10299	10299	10570
3493	2816	31	applied	\N	\N	\N	\N	10302	10302	10571
3493	2819	32	applied	\N	\N	\N	\N	10309	10309	10572
3493	2820	33	applied	\N	\N	\N	\N	10311	10311	10574
3493	2821	34	applied	\N	\N	\N	\N	10315	10315	10750
3493	2823	35	applied	\N	\N	\N	\N	10320	10320	10751
3493	2824	36	applied	\N	\N	\N	\N	10322	10322	10752
3493	2825	37	applied	\N	\N	\N	\N	10327	10327	10753
3493	2827	38	applied	\N	\N	\N	\N	10332	10332	10754
3493	2828	39	applied	\N	\N	\N	\N	10334	10334	10755
3493	2829	40	applied	\N	\N	\N	\N	10336	10336	10756
3493	2830	41	applied	\N	\N	\N	\N	10340	10340	10757
3493	2831	42	applied	\N	\N	\N	\N	10344	10344	10758
3493	2832	43	applied	\N	\N	\N	\N	10346	10346	10759
3493	2834	44	applied	\N	\N	\N	\N	10352	10352	10760
3493	2835	45	applied	\N	\N	\N	\N	10354	10354	10761
3493	2841	46	applied	\N	\N	\N	\N	10372	10372	10762
3493	2854	47	applied	\N	\N	\N	\N	10400	10400	10795
3493	2856	48	applied	\N	\N	\N	\N	10483	10483	10796
3493	2858	49	applied	\N	\N	\N	\N	10487	10487	10797
3493	2860	50	applied	\N	\N	\N	\N	10492	10492	10798
3493	2861	51	applied	\N	\N	\N	\N	10494	10494	10799
3493	2862	52	applied	\N	\N	\N	\N	10498	10498	10800
3493	2863	53	applied	\N	\N	\N	\N	10500	10500	10801
3493	2864	54	applied	\N	\N	\N	\N	10508	10508	10802
3493	2865	55	applied	\N	\N	\N	\N	10512	10512	10803
3493	2866	56	applied	\N	\N	\N	\N	10514	10514	10804
3493	2867	57	applied	\N	\N	\N	\N	10516	10516	10805
3493	2868	58	applied	\N	\N	\N	\N	10519	10519	10806
3493	2869	59	applied	\N	\N	\N	\N	10521	10521	10807
3493	2870	60	applied	\N	\N	\N	\N	10524	10524	10808
3493	2871	61	applied	\N	\N	\N	\N	10528	10528	10809
3493	2872	62	applied	\N	\N	\N	\N	10532	10532	10810
3493	2873	63	applied	\N	\N	\N	\N	10534	10534	10811
3493	2874	64	applied	\N	\N	\N	\N	10538	10538	10812
3493	2875	65	applied	\N	\N	\N	\N	10542	10542	10813
3493	2876	66	applied	\N	\N	\N	\N	10546	10546	10814
3493	2877	67	applied	\N	\N	\N	\N	10548	10548	10815
3493	2878	68	applied	\N	\N	\N	\N	10578	10578	10816
3493	2879	69	applied	\N	\N	\N	\N	10583	10583	10817
3493	2880	71	applied	\N	\N	\N	\N	10585	10585	10819
3493	2881	72	applied	\N	\N	\N	\N	10587	10587	10820
3493	2882	73	applied	\N	\N	\N	\N	10589	10589	10821
3493	2884	74	applied	\N	\N	\N	\N	10594	10594	10822
3493	2885	75	applied	\N	\N	\N	\N	10596	10596	10823
3493	2886	76	applied	\N	\N	\N	\N	10605	10605	10824
3493	2887	77	applied	\N	\N	\N	\N	10609	10609	10825
3493	2888	78	applied	\N	\N	\N	\N	10611	10611	10826
3493	2889	79	applied	\N	\N	\N	\N	10617	10617	10827
3493	2890	80	applied	\N	\N	\N	\N	10625	10625	10828
3493	2891	81	applied	\N	\N	\N	\N	10627	10627	10829
3493	2892	82	applied	\N	\N	\N	\N	10630	10630	10830
3493	2893	83	applied	\N	\N	\N	\N	10634	10634	10831
3493	2894	84	applied	\N	\N	\N	\N	10639	10639	10832
3493	2895	85	applied	\N	\N	\N	\N	10642	10642	10833
3493	2896	86	applied	\N	\N	\N	\N	10650	10650	10834
3493	2897	87	applied	\N	\N	\N	\N	10655	10655	10835
3493	2898	88	applied	\N	\N	\N	\N	10661	10661	10836
3493	2899	89	applied	\N	\N	\N	\N	10665	10665	10837
3493	2900	90	applied	\N	\N	\N	\N	10668	10668	10838
3493	2901	91	applied	\N	\N	\N	\N	10670	10670	10839
3493	2902	92	applied	\N	\N	\N	\N	10679	10679	10840
3493	2903	93	applied	\N	\N	\N	\N	10682	10682	10841
3493	2904	94	applied	\N	\N	\N	\N	10686	10686	10842
3493	2905	95	applied	\N	\N	\N	\N	10690	10690	10843
3495	2917	0	applied	\N	\N	\N	\N	10847	10847	10848
3498	2918	0	applied	\N	\N	\N	\N	10852	10852	10853
3504	2919	0	applied	\N	\N	\N	\N	10870	10870	10871
3510	2920	0	applied	\N	\N	\N	\N	10877	10877	10878
3519	2921	0	applied	\N	\N	\N	\N	10889	10889	10890
3529	2924	0	applied	\N	\N	\N	\N	10905	10905	10906
3533	2925	0	applied	\N	\N	\N	\N	10914	10914	10915
3533	2926	1	applied	\N	\N	\N	\N	10916	10916	10917
3628	2925	0	applied	\N	\N	\N	\N	10914	10914	10915
3633	2929	0	applied	\N	\N	\N	\N	10980	10980	10981
3637	2930	0	applied	\N	\N	1000000000	\N	10984	10984	10985
3637	2931	1	applied	\N	\N	\N	\N	10986	10986	1435
3637	2932	2	applied	\N	\N	\N	\N	10987	10987	1435
3499	2902	45	applied	\N	\N	\N	\N	10679	10679	10840
3499	2903	46	applied	\N	\N	\N	\N	10682	10682	10841
3499	2904	47	applied	\N	\N	\N	\N	10686	10686	10842
3499	2905	48	applied	\N	\N	\N	\N	10690	10690	10843
3499	2906	49	applied	\N	\N	\N	\N	10696	10696	10856
3499	2907	50	applied	\N	\N	\N	\N	10698	10698	10857
3499	2908	51	applied	\N	\N	\N	\N	10703	10703	10858
3499	2909	52	applied	\N	\N	\N	\N	10707	10707	10859
3499	2910	53	applied	\N	\N	\N	\N	10709	10709	10860
3499	2911	54	applied	\N	\N	\N	\N	10717	10717	10861
3499	2912	55	applied	\N	\N	\N	\N	10723	10723	10862
3499	2917	56	applied	\N	\N	\N	\N	10847	10847	10848
3499	2826	57	applied	\N	\N	\N	\N	10329	10329	4764
3499	2833	58	applied	\N	\N	\N	\N	10348	10348	4764
3499	2855	59	applied	\N	\N	1000000000	\N	10402	10402	10403
3499	2918	60	applied	\N	\N	\N	\N	10852	10852	10853
3499	2916	61	applied	\N	\N	1000000000	\N	10784	10784	10785
3505	2919	0	applied	\N	\N	\N	\N	10870	10870	10871
3508	2920	0	applied	\N	\N	\N	\N	10877	10877	10878
3520	2922	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	10892	10892	\N
3526	2920	0	applied	\N	\N	\N	\N	10902	10902	10878
3526	2922	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	9438	9438	\N
3526	2917	2	applied	\N	\N	\N	\N	10847	10847	10848
3526	2923	3	applied	\N	\N	\N	\N	10895	10895	10903
3526	2918	4	applied	\N	\N	\N	\N	10852	10852	10896
3526	2916	5	applied	\N	\N	1000000000	\N	10784	10784	10785
3528	2924	0	applied	\N	\N	\N	\N	10905	10905	10906
3530	2924	0	applied	\N	\N	\N	\N	10905	10905	10906
3531	2924	0	applied	\N	\N	\N	\N	10905	10905	10906
3632	2927	0	applied	\N	\N	\N	\N	10974	10974	10975
3632	2928	1	applied	\N	\N	1000000000	\N	10976	10976	10977
3635	2930	0	applied	\N	\N	1000000000	\N	10984	10984	10985
3635	2931	1	applied	\N	\N	\N	\N	10986	10986	1435
3635	2932	2	applied	\N	\N	\N	\N	10987	10987	1435
3644	2933	0	applied	\N	\N	\N	\N	10997	10997	10998
3653	2934	0	applied	\N	\N	\N	\N	11008	11008	10878
3665	2935	0	applied	\N	\N	1000000000	\N	11018	11018	11019
3666	2935	0	applied	\N	\N	1000000000	\N	11018	11018	11019
3669	2936	0	applied	\N	\N	\N	\N	11024	11024	11025
3669	2937	1	applied	\N	\N	\N	\N	11026	11026	11027
3669	2938	2	applied	\N	\N	1000000000	\N	11028	11028	11029
3670	2939	0	applied	\N	\N	\N	\N	11032	11032	11033
3671	2940	0	applied	\N	\N	\N	\N	11035	11035	11036
3673	2940	0	applied	\N	\N	\N	\N	11035	11035	11036
3674	2941	0	applied	\N	\N	\N	\N	11038	11038	11039
3675	2941	0	applied	\N	\N	\N	\N	11038	11038	11039
3676	2941	0	applied	\N	\N	\N	\N	11038	11038	11039
3677	2941	0	applied	\N	\N	\N	\N	11038	11038	11039
3678	2942	0	applied	\N	\N	\N	\N	11045	11045	11046
3679	2943	0	applied	\N	\N	\N	\N	11049	11049	11050
3680	2944	0	applied	\N	\N	\N	\N	11052	11052	11053
3681	2944	0	applied	\N	\N	\N	\N	11052	11052	11053
3682	2945	0	applied	\N	\N	\N	\N	11058	11058	11059
3683	2946	0	applied	\N	\N	\N	\N	11062	11062	11063
3684	2947	0	applied	\N	\N	\N	\N	11066	11066	1435
3684	2948	1	applied	\N	\N	\N	\N	11067	11067	11068
3684	2949	2	applied	\N	\N	\N	\N	11069	11069	11070
3685	2947	0	applied	\N	\N	\N	\N	11066	11066	1435
3685	2948	1	applied	\N	\N	\N	\N	11067	11067	11068
3685	2949	2	applied	\N	\N	\N	\N	11069	11069	11070
3686	2950	0	applied	\N	\N	\N	\N	11074	11074	11075
3686	2951	1	applied	\N	\N	\N	\N	11076	11076	11077
3687	2950	0	applied	\N	\N	\N	\N	11074	11074	11075
3687	2951	1	applied	\N	\N	\N	\N	11076	11076	11077
3688	2950	0	applied	\N	\N	\N	\N	11074	11074	11075
3688	2951	1	applied	\N	\N	\N	\N	11076	11076	11077
3689	2952	0	applied	\N	\N	\N	\N	11083	11083	11084
3690	2952	0	applied	\N	\N	\N	\N	11083	11083	11084
3691	2952	0	applied	\N	\N	\N	\N	11083	11083	11084
3692	2952	0	applied	\N	\N	\N	\N	11083	11083	11084
3693	2953	0	applied	\N	\N	\N	\N	11092	11092	11093
3694	2954	0	applied	\N	\N	\N	\N	11096	11096	11097
3695	2955	0	applied	\N	\N	\N	\N	11100	11100	11101
3695	2956	1	applied	\N	\N	\N	\N	11102	11102	11103
3695	2957	2	applied	\N	\N	\N	\N	11104	11104	11105
3696	2955	0	applied	\N	\N	\N	\N	11100	11100	11101
3696	2956	1	applied	\N	\N	\N	\N	11102	11102	11103
3696	2957	2	applied	\N	\N	\N	\N	11104	11104	11105
3697	2958	0	applied	\N	\N	\N	\N	11110	11110	11111
3698	2958	0	applied	\N	\N	\N	\N	11110	11110	11111
3699	2959	0	applied	\N	\N	\N	\N	11115	11115	11116
3700	2959	0	applied	\N	\N	\N	\N	11115	11115	11116
3701	2960	0	applied	\N	\N	\N	\N	11121	11121	11122
3701	2961	1	applied	\N	\N	\N	\N	11123	11123	11124
3701	2962	2	applied	\N	\N	\N	\N	11125	11125	11126
3702	2960	0	applied	\N	\N	\N	\N	11121	11121	11122
3702	2961	1	applied	\N	\N	\N	\N	11123	11123	11124
3702	2962	2	applied	\N	\N	\N	\N	11125	11125	11126
3703	2960	0	applied	\N	\N	\N	\N	11121	11121	11122
3703	2961	1	applied	\N	\N	\N	\N	11123	11123	11124
3703	2962	2	applied	\N	\N	\N	\N	11125	11125	11126
3704	2963	0	applied	\N	\N	\N	\N	11131	11131	11132
3705	2963	0	applied	\N	\N	\N	\N	11131	11131	11132
3706	2963	0	applied	\N	\N	\N	\N	11131	11131	11132
3707	2964	0	applied	\N	\N	\N	\N	11140	11140	11141
3708	2965	0	applied	\N	\N	\N	\N	11143	11143	11144
3709	2966	0	applied	\N	\N	\N	\N	11147	11147	11148
3709	2967	1	applied	\N	\N	\N	\N	11149	11149	11150
3709	2968	2	applied	\N	\N	\N	\N	11151	11151	11152
3709	2969	3	applied	\N	\N	\N	\N	11153	11153	11154
3710	2970	0	applied	\N	\N	\N	\N	11157	11157	11158
3710	2971	1	applied	\N	\N	\N	\N	11159	11159	11160
3711	2970	0	applied	\N	\N	\N	\N	11157	11157	11158
3711	2971	1	applied	\N	\N	\N	\N	11159	11159	11160
3712	2970	0	applied	\N	\N	\N	\N	11157	11157	11158
3712	2971	1	applied	\N	\N	\N	\N	11159	11159	11160
3713	2972	0	applied	\N	\N	\N	\N	11167	11167	11168
3714	2972	0	applied	\N	\N	\N	\N	11167	11167	11168
3715	2973	0	applied	\N	\N	\N	\N	11169	11169	11170
3716	2974	0	applied	\N	\N	\N	\N	11173	11173	11174
3717	2974	0	applied	\N	\N	\N	\N	11173	11173	11174
3718	2974	0	applied	\N	\N	\N	\N	11173	11173	11174
3719	2974	0	applied	\N	\N	\N	\N	11173	11173	11174
3720	2960	0	applied	\N	\N	\N	\N	11121	11121	11122
3720	2961	1	applied	\N	\N	\N	\N	11123	11123	11124
3720	2963	2	applied	\N	\N	\N	\N	11131	11131	11132
3720	2964	4	applied	\N	\N	\N	\N	11140	11140	11141
3720	2965	5	applied	\N	\N	\N	\N	11143	11143	11144
3720	2966	6	applied	\N	\N	\N	\N	11147	11147	11148
3720	2967	7	applied	\N	\N	\N	\N	11149	11149	11150
3720	2968	8	applied	\N	\N	\N	\N	11151	11151	11152
3720	2969	9	applied	\N	\N	\N	\N	11153	11153	11154
3720	2970	10	applied	\N	\N	\N	\N	11157	11157	11158
3720	2971	11	applied	\N	\N	\N	\N	11159	11159	11160
3722	2975	0	applied	\N	\N	\N	\N	11184	11184	11185
3725	2977	0	applied	\N	\N	\N	\N	11192	11192	11193
3729	2979	0	applied	\N	\N	\N	\N	11204	11204	11205
3731	2980	0	applied	\N	\N	\N	\N	11207	11207	11208
3733	2980	0	applied	\N	\N	\N	\N	11207	11207	11208
3736	2982	0	applied	\N	\N	\N	\N	11219	11219	11220
3736	2983	1	applied	\N	\N	\N	\N	11221	11221	11222
3738	2984	0	applied	\N	\N	\N	\N	11226	11226	11227
3741	2985	0	applied	\N	\N	\N	\N	11232	11232	11233
3747	2988	0	applied	\N	\N	\N	\N	11246	11246	11247
3747	2989	1	applied	\N	\N	\N	\N	11248	11248	11249
3760	3000	0	applied	\N	\N	\N	\N	11298	11298	11299
3768	3005	0	applied	\N	\N	\N	\N	11315	11315	11316
3768	3006	1	applied	\N	\N	\N	\N	11317	11317	11318
3775	3010	0	applied	\N	\N	\N	\N	11337	11337	11338
3780	3012	0	applied	\N	\N	\N	\N	11343	11343	11344
3782	3013	0	applied	\N	\N	\N	\N	11350	11350	11351
3782	3014	1	applied	\N	\N	\N	\N	11352	11352	11353
3785	3013	0	applied	\N	\N	\N	\N	11350	11350	11351
3785	3014	1	applied	\N	\N	\N	\N	11352	11352	11353
3786	3013	0	applied	\N	\N	\N	\N	11350	11350	11351
3786	3014	1	applied	\N	\N	\N	\N	11352	11352	11353
3790	3018	0	applied	\N	\N	\N	\N	11367	11367	11368
3790	3019	1	applied	\N	\N	\N	\N	11369	11369	11370
3790	3020	2	applied	\N	\N	\N	\N	11371	11371	11372
3790	3021	3	applied	\N	\N	\N	\N	11373	11373	11374
3792	3022	0	applied	\N	\N	\N	\N	11379	11379	11380
3794	3023	0	applied	\N	\N	\N	\N	11382	11382	11383
3797	3026	0	applied	\N	\N	\N	\N	11394	11394	11395
3799	3027	0	applied	\N	\N	\N	\N	11400	11400	11401
3805	3031	0	applied	\N	\N	\N	\N	11417	11417	11418
3805	3032	1	applied	\N	\N	\N	\N	11419	11419	11420
3805	3033	2	applied	\N	\N	\N	\N	11421	11421	11422
3807	3034	0	applied	\N	\N	\N	\N	11426	11426	11427
3812	3038	0	applied	\N	\N	\N	\N	11444	11444	11445
3812	3039	1	applied	\N	\N	\N	\N	11446	11446	11447
3817	3040	0	applied	\N	\N	\N	\N	11455	11455	11456
3821	3042	0	applied	\N	\N	\N	\N	11465	11465	11466
3824	3046	0	applied	\N	\N	\N	\N	11476	11476	1435
3824	3047	1	applied	\N	\N	\N	\N	11477	11477	11478
3826	2925	0	applied	\N	\N	\N	\N	10914	10914	10915
3826	2936	1	applied	\N	\N	\N	\N	11024	11024	11025
3826	2937	2	applied	\N	\N	\N	\N	11026	11026	11027
3826	2920	3	applied	\N	\N	\N	\N	10902	10902	10878
3826	2935	4	applied	\N	\N	1000000000	\N	11485	11485	11019
3826	2960	5	applied	\N	\N	\N	\N	11486	11486	11122
3826	2939	6	applied	\N	\N	\N	\N	11032	11032	11033
3826	2940	7	applied	\N	\N	\N	\N	11035	11035	11036
3826	2941	8	applied	\N	\N	\N	\N	11038	11038	11039
3826	2942	9	applied	\N	\N	\N	\N	11045	11045	11046
3826	2943	10	applied	\N	\N	\N	\N	11049	11049	11050
3826	2922	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	9438	9438	\N
3826	2930	12	applied	\N	\N	1000000000	\N	10993	10993	10985
3826	2933	13	applied	\N	\N	\N	\N	11293	11293	10998
3826	2944	14	applied	\N	\N	\N	\N	11052	11052	11053
3826	2945	15	applied	\N	\N	\N	\N	11058	11058	11059
3826	2946	16	applied	\N	\N	\N	\N	11062	11062	11063
3826	2948	17	applied	\N	\N	\N	\N	11067	11067	11068
3826	2949	18	applied	\N	\N	\N	\N	11069	11069	11070
3826	2950	19	applied	\N	\N	\N	\N	11074	11074	11075
3826	2951	20	applied	\N	\N	\N	\N	11076	11076	11077
3826	2952	21	applied	\N	\N	\N	\N	11083	11083	11084
3826	2953	22	applied	\N	\N	\N	\N	11092	11092	11093
3826	2954	23	applied	\N	\N	\N	\N	11096	11096	11097
3826	2955	24	applied	\N	\N	\N	\N	11100	11100	11101
3826	2956	25	applied	\N	\N	\N	\N	11102	11102	11103
3826	2958	26	applied	\N	\N	\N	\N	11110	11110	11111
3826	2959	27	applied	\N	\N	\N	\N	11115	11115	11116
3826	2961	28	applied	\N	\N	\N	\N	11123	11123	11124
3826	2963	29	applied	\N	\N	\N	\N	11131	11131	11132
3826	2964	30	applied	\N	\N	\N	\N	11140	11140	11141
3826	2965	31	applied	\N	\N	\N	\N	11143	11143	11144
3826	2966	32	applied	\N	\N	\N	\N	11147	11147	11148
3826	2967	33	applied	\N	\N	\N	\N	11149	11149	11150
3826	2968	34	applied	\N	\N	\N	\N	11151	11151	11152
3826	2969	35	applied	\N	\N	\N	\N	11153	11153	11154
3826	2970	36	applied	\N	\N	\N	\N	11157	11157	11158
3826	2971	37	applied	\N	\N	\N	\N	11159	11159	11160
3826	2972	38	applied	\N	\N	\N	\N	11167	11167	11168
3826	2973	39	applied	\N	\N	\N	\N	11169	11169	11170
3826	2974	40	applied	\N	\N	\N	\N	11173	11173	11174
3826	2975	41	applied	\N	\N	\N	\N	11184	11184	11185
3826	2976	42	applied	\N	\N	\N	\N	11188	11188	11189
3826	2977	43	applied	\N	\N	\N	\N	11192	11192	11193
3826	2978	44	applied	\N	\N	\N	\N	11200	11200	11201
3826	2979	45	applied	\N	\N	\N	\N	11204	11204	11205
3826	2980	46	applied	\N	\N	\N	\N	11207	11207	11208
3826	2981	47	applied	\N	\N	\N	\N	11217	11217	11218
3826	2982	48	applied	\N	\N	\N	\N	11219	11219	11220
3826	2983	49	applied	\N	\N	\N	\N	11221	11221	11222
3826	2984	50	applied	\N	\N	\N	\N	11226	11226	11227
3826	2985	51	applied	\N	\N	\N	\N	11232	11232	11233
3826	2986	52	applied	\N	\N	\N	\N	11238	11238	11239
3826	2988	53	applied	\N	\N	\N	\N	11246	11246	11247
3826	2989	54	applied	\N	\N	\N	\N	11248	11248	11249
3826	2990	55	applied	\N	\N	\N	\N	11254	11254	11255
3826	2991	56	applied	\N	\N	\N	\N	11258	11258	11259
3826	2992	57	applied	\N	\N	\N	\N	11260	11260	11261
3826	2993	58	applied	\N	\N	\N	\N	11265	11265	11266
3826	2994	59	applied	\N	\N	\N	\N	11271	11271	11272
3826	2995	60	applied	\N	\N	\N	\N	11277	11277	11278
3826	2996	61	applied	\N	\N	\N	\N	11281	11281	11282
3826	2997	62	applied	\N	\N	\N	\N	11283	11283	11284
3826	2998	63	applied	\N	\N	\N	\N	11286	11286	11287
3826	2999	64	applied	\N	\N	\N	\N	11288	11288	11289
3826	3000	65	applied	\N	\N	\N	\N	11298	11298	11299
3826	3001	66	applied	\N	\N	\N	\N	11302	11302	11303
3826	3002	67	applied	\N	\N	\N	\N	11305	11305	11306
3826	3003	68	applied	\N	\N	\N	\N	11310	11310	11311
3826	3004	69	applied	\N	\N	\N	\N	11312	11312	11313
3826	3005	70	applied	\N	\N	\N	\N	11315	11315	11316
3826	3006	71	applied	\N	\N	\N	\N	11317	11317	11318
3826	3007	72	applied	\N	\N	\N	\N	11325	11325	11326
3721	2975	0	applied	\N	\N	\N	\N	11184	11184	11185
3723	2976	0	applied	\N	\N	\N	\N	11188	11188	11189
3730	2980	0	applied	\N	\N	\N	\N	11207	11207	11208
3732	2980	0	applied	\N	\N	\N	\N	11207	11207	11208
3735	2982	0	applied	\N	\N	\N	\N	11219	11219	11220
3735	2983	1	applied	\N	\N	\N	\N	11221	11221	11222
3737	2984	0	applied	\N	\N	\N	\N	11226	11226	11227
3739	2984	0	applied	\N	\N	\N	\N	11226	11226	11227
3744	2986	0	applied	\N	\N	\N	\N	11238	11238	11239
3744	2987	1	applied	\N	\N	\N	\N	11240	11240	11241
3746	2988	0	applied	\N	\N	\N	\N	11246	11246	11247
3746	2989	1	applied	\N	\N	\N	\N	11248	11248	11249
3749	2991	0	applied	\N	\N	\N	\N	11258	11258	11259
3749	2992	1	applied	\N	\N	\N	\N	11260	11260	11261
3751	2993	0	applied	\N	\N	\N	\N	11265	11265	11266
3756	2996	0	applied	\N	\N	\N	\N	11281	11281	11282
3756	2997	1	applied	\N	\N	\N	\N	11283	11283	11284
3761	3001	0	applied	\N	\N	\N	\N	11302	11302	11303
3764	3003	0	applied	\N	\N	\N	\N	11310	11310	11311
3764	3004	1	applied	\N	\N	\N	\N	11312	11312	11313
3769	3007	0	applied	\N	\N	\N	\N	11325	11325	11326
3769	3008	1	applied	\N	\N	\N	\N	11327	11327	11328
3771	3009	0	applied	\N	\N	\N	\N	11331	11331	11332
3783	3013	0	applied	\N	\N	\N	\N	11350	11350	11351
3783	3014	1	applied	\N	\N	\N	\N	11352	11352	11353
3795	3024	0	applied	\N	\N	\N	\N	11386	11386	11387
3800	3028	0	applied	\N	\N	\N	\N	11404	11404	11405
3800	3029	1	applied	\N	\N	\N	\N	11406	11406	11407
3802	3028	0	applied	\N	\N	\N	\N	11404	11404	11405
3802	3029	1	applied	\N	\N	\N	\N	11406	11406	11407
3810	3037	0	applied	\N	\N	\N	\N	11438	11438	11439
3815	3038	0	applied	\N	\N	\N	\N	11444	11444	11445
3815	3039	1	applied	\N	\N	\N	\N	11446	11446	11447
3819	3041	0	applied	\N	\N	\N	\N	11459	11459	11460
3827	3050	0	applied	\N	\N	\N	\N	11491	11491	11492
3827	3051	1	applied	\N	\N	\N	\N	11493	11493	11494
3833	3060	0	applied	\N	\N	\N	\N	11518	11518	11519
3833	3061	1	applied	\N	\N	\N	\N	11520	11520	11521
3836	3065	0	applied	\N	\N	\N	\N	11531	11531	11532
3836	3066	1	applied	\N	\N	\N	\N	11533	11533	11534
3839	3068	0	applied	\N	\N	\N	\N	11541	11541	11542
3841	3069	0	applied	\N	\N	\N	\N	11553	11553	11554
3844	3070	0	applied	\N	\N	\N	\N	11557	11557	11558
3844	3071	1	applied	\N	\N	\N	\N	11559	11559	11560
3850	3073	0	applied	\N	\N	\N	\N	11569	11569	11570
3850	3074	1	applied	\N	\N	\N	\N	11571	11571	11572
3858	3081	0	applied	\N	\N	\N	\N	11596	11596	11597
3860	3082	0	applied	\N	\N	\N	\N	11600	11600	11601
3863	3084	0	applied	\N	\N	\N	\N	11608	11608	11609
3863	3085	1	applied	\N	\N	\N	\N	11610	11610	11611
3863	3086	2	applied	\N	\N	\N	\N	11612	11612	11613
3865	3084	0	applied	\N	\N	\N	\N	11608	11608	11609
3865	3085	1	applied	\N	\N	\N	\N	11610	11610	11611
3865	3086	2	applied	\N	\N	\N	\N	11612	11612	11613
3868	3088	0	applied	\N	\N	\N	\N	11623	11623	11624
3868	3089	1	applied	\N	\N	\N	\N	11625	11625	11626
3875	3094	0	applied	\N	\N	\N	\N	11644	11644	11645
3878	3095	0	applied	\N	\N	\N	\N	11647	11647	11648
3882	3098	0	applied	\N	\N	\N	\N	11663	11663	11664
3885	3101	0	applied	\N	\N	\N	\N	11675	11675	11676
3894	3105	0	applied	\N	\N	\N	\N	11694	11694	11695
3894	3106	1	applied	\N	\N	\N	\N	11696	11696	11697
3897	3107	0	applied	\N	\N	\N	\N	11700	11700	11701
3899	3108	0	applied	\N	\N	\N	\N	11704	11704	11705
3901	3110	0	applied	\N	\N	\N	\N	11712	11712	11713
3907	3114	0	applied	\N	\N	\N	\N	11726	11726	11727
3907	3115	1	applied	\N	\N	\N	\N	11728	11728	11729
3911	3117	0	applied	\N	\N	\N	\N	11735	11735	11736
3911	3118	1	applied	\N	\N	\N	\N	11737	11737	11738
3918	3120	0	applied	\N	\N	\N	\N	11747	11747	11748
3921	3121	0	applied	\N	\N	\N	\N	11749	11749	11750
3923	3123	0	applied	\N	\N	\N	\N	11759	11759	11760
3923	3124	1	applied	\N	\N	\N	\N	11761	11761	11762
3926	3123	0	applied	\N	\N	\N	\N	11759	11759	11760
3926	3124	1	applied	\N	\N	\N	\N	11761	11761	11762
3935	3131	0	applied	\N	\N	\N	\N	11791	11791	11792
3938	3134	0	applied	\N	\N	\N	\N	11805	11805	11806
3938	3135	1	applied	\N	\N	\N	\N	11807	11807	11808
3941	3138	0	applied	\N	\N	\N	\N	11817	11817	11818
3943	3139	0	applied	\N	\N	\N	\N	11820	11820	11821
3943	3140	1	applied	\N	\N	\N	\N	11822	11822	11823
3946	3144	0	applied	\N	\N	\N	\N	11835	11835	11836
3946	3145	1	applied	\N	\N	\N	\N	11837	11837	1254
3946	3146	2	applied	\N	\N	\N	\N	11838	11838	1254
3946	3147	3	applied	\N	\N	\N	\N	11839	11839	1254
3946	3148	4	applied	\N	\N	\N	\N	11840	11840	1254
3949	3151	0	applied	\N	\N	\N	\N	11851	11851	11852
3949	3152	1	applied	\N	\N	\N	\N	11853	11853	11854
3949	3153	2	applied	\N	\N	\N	\N	11855	11855	11856
3954	3157	0	applied	\N	\N	\N	\N	11869	11869	11870
3959	3160	0	applied	\N	\N	\N	\N	11881	11881	11882
3961	3160	0	applied	\N	\N	\N	\N	11881	11881	11882
3963	3161	0	applied	\N	\N	\N	\N	11888	11888	11889
3965	3161	0	applied	\N	\N	\N	\N	11888	11888	11889
3968	3164	0	applied	\N	\N	\N	\N	11903	11903	11904
3970	3165	0	applied	\N	\N	\N	\N	11907	11907	11908
3973	3166	0	applied	\N	\N	\N	\N	11913	11913	11914
3977	3167	0	applied	\N	\N	\N	\N	11923	11923	11924
3982	3171	0	applied	\N	\N	\N	\N	11938	11938	11939
3985	3172	0	applied	\N	\N	\N	\N	11944	11944	11945
3985	3173	1	applied	\N	\N	\N	\N	11946	11946	11947
3987	3175	0	applied	\N	\N	\N	\N	11955	11955	11956
3989	3176	0	applied	\N	\N	\N	\N	11959	11959	11960
3996	3178	0	applied	\N	\N	\N	\N	11971	11971	11972
4001	3181	0	applied	\N	\N	\N	\N	11982	11982	11983
4005	3183	0	applied	\N	\N	\N	\N	11990	11990	11991
4008	3187	0	applied	\N	\N	\N	\N	12004	12004	12005
4022	3196	0	applied	\N	\N	\N	\N	12039	12039	12040
4022	3197	1	applied	\N	\N	\N	\N	12041	12041	12042
4025	3200	0	applied	\N	\N	\N	\N	12049	12049	12050
4027	3201	0	applied	\N	\N	\N	\N	12053	12053	12054
4034	3205	0	applied	\N	\N	\N	\N	12068	12068	12069
4042	3211	0	applied	\N	\N	\N	\N	12092	12092	12093
4042	3212	1	applied	\N	\N	\N	\N	12094	12094	12095
4047	3215	0	applied	\N	\N	\N	\N	12106	12106	12107
4047	3216	1	applied	\N	\N	\N	\N	12108	12108	12109
4047	3217	2	applied	\N	\N	\N	\N	12110	12110	12111
4053	3222	0	applied	\N	\N	\N	\N	12128	12128	12129
4053	3223	1	applied	\N	\N	\N	\N	12130	12130	12131
4063	3230	0	applied	\N	\N	\N	\N	12159	12159	12160
3724	2977	0	applied	\N	\N	\N	\N	11192	11192	11193
3726	2977	0	applied	\N	\N	\N	\N	11192	11192	11193
3728	2978	0	applied	\N	\N	\N	\N	11200	11200	11201
3740	2985	0	applied	\N	\N	\N	\N	11232	11232	11233
3742	2985	0	applied	\N	\N	\N	\N	11232	11232	11233
3750	2991	0	applied	\N	\N	\N	\N	11258	11258	11259
3750	2992	1	applied	\N	\N	\N	\N	11260	11260	11261
3752	2987	0	applied	\N	\N	\N	\N	11240	11240	11269
3754	2994	0	applied	\N	\N	\N	\N	11271	11271	11272
3757	2998	0	applied	\N	\N	\N	\N	11286	11286	11287
3757	2999	1	applied	\N	\N	\N	\N	11288	11288	11289
3759	2933	0	applied	\N	\N	\N	\N	11293	11293	10998
3759	2987	1	applied	\N	\N	\N	\N	11240	11240	11294
3762	3002	0	applied	\N	\N	\N	\N	11305	11305	11306
3765	3005	0	applied	\N	\N	\N	\N	11315	11315	11316
3765	3006	1	applied	\N	\N	\N	\N	11317	11317	11318
3767	3005	0	applied	\N	\N	\N	\N	11315	11315	11316
3767	3006	1	applied	\N	\N	\N	\N	11317	11317	11318
3772	3010	0	applied	\N	\N	\N	\N	11337	11337	11338
3778	3011	0	applied	\N	\N	\N	\N	11341	11341	11342
3784	3013	0	applied	\N	\N	\N	\N	11350	11350	11351
3784	3014	1	applied	\N	\N	\N	\N	11352	11352	11353
3787	3015	0	applied	\N	\N	\N	\N	11360	11360	11361
3793	3022	0	applied	\N	\N	\N	\N	11379	11379	11380
3798	3026	0	applied	\N	\N	\N	\N	11394	11394	11395
3801	3028	0	applied	\N	\N	\N	\N	11404	11404	11405
3801	3029	1	applied	\N	\N	\N	\N	11406	11406	11407
3803	3030	0	applied	\N	\N	\N	\N	11413	11413	11414
3808	3035	0	applied	\N	\N	\N	\N	11430	11430	11431
3811	3037	0	applied	\N	\N	\N	\N	11438	11438	11439
3813	3038	0	applied	\N	\N	\N	\N	11444	11444	11445
3813	3039	1	applied	\N	\N	\N	\N	11446	11446	11447
3820	3041	0	applied	\N	\N	\N	\N	11459	11459	11460
3822	3043	0	applied	\N	\N	\N	\N	11469	11469	11470
3825	3048	0	applied	\N	\N	\N	\N	11480	11480	11481
3825	3049	1	applied	\N	\N	\N	\N	11482	11482	11483
3830	3054	0	applied	\N	\N	1000000000	\N	11503	11503	11504
3830	3055	1	applied	\N	\N	\N	\N	11505	11505	11506
3834	3062	0	applied	\N	\N	\N	\N	11522	11522	11523
3834	3063	1	applied	\N	\N	\N	\N	11524	11524	11525
3837	3067	0	applied	\N	\N	\N	\N	11537	11537	11538
3842	3070	0	applied	\N	\N	\N	\N	11557	11557	11558
3842	3071	1	applied	\N	\N	\N	\N	11559	11559	11560
3848	3072	0	applied	\N	\N	\N	\N	11565	11565	11566
3851	3073	0	applied	\N	\N	\N	\N	11569	11569	11570
3851	3074	1	applied	\N	\N	\N	\N	11571	11571	11572
3853	3075	0	applied	\N	\N	\N	\N	11577	11577	11578
3856	3077	0	applied	\N	\N	\N	\N	11585	11585	11586
3856	3078	1	applied	\N	\N	\N	\N	11587	11587	11588
3856	3079	2	applied	\N	\N	\N	\N	11589	11589	11590
3856	3080	3	applied	\N	\N	\N	\N	11591	11591	11592
3861	3083	0	applied	\N	\N	\N	\N	11604	11604	11605
3864	3084	0	applied	\N	\N	\N	\N	11608	11608	11609
3864	3085	1	applied	\N	\N	\N	\N	11610	11610	11611
3864	3086	2	applied	\N	\N	\N	\N	11612	11612	11613
3866	3087	0	applied	\N	\N	\N	\N	11619	11619	11620
3871	3091	0	applied	\N	\N	\N	\N	11633	11633	11634
3873	3092	0	applied	\N	\N	\N	\N	11639	11639	11640
3876	3094	0	applied	\N	\N	\N	\N	11644	11644	11645
3880	3096	0	applied	\N	\N	\N	\N	11655	11655	11656
3883	3099	0	applied	\N	\N	\N	\N	11667	11667	11668
3883	3100	1	applied	\N	\N	\N	\N	11669	11669	11670
3886	3101	0	applied	\N	\N	\N	\N	11675	11675	11676
3904	3111	0	applied	\N	\N	\N	\N	11714	11714	11715
3904	3112	1	applied	\N	\N	\N	\N	11716	11716	11717
3909	3116	0	applied	\N	\N	\N	\N	11731	11731	11732
3912	3117	0	applied	\N	\N	\N	\N	11735	11735	11736
3912	3118	1	applied	\N	\N	\N	\N	11737	11737	11738
3919	3120	0	applied	\N	\N	\N	\N	11747	11747	11748
3928	3125	0	applied	\N	\N	\N	\N	11770	11770	11771
3931	3128	0	applied	\N	\N	\N	\N	11780	11780	11781
3931	3129	1	applied	\N	\N	\N	\N	11782	11782	11783
3933	3130	0	applied	\N	\N	\N	\N	11787	11787	11788
3939	3136	0	applied	\N	\N	\N	\N	11811	11811	11812
3939	3137	1	applied	\N	\N	\N	\N	11813	11813	11814
3950	3154	0	applied	\N	\N	\N	\N	11859	11859	11860
3952	3155	0	applied	\N	\N	\N	\N	11861	11861	11862
3955	3157	0	applied	\N	\N	\N	\N	11869	11869	11870
3957	3158	0	applied	\N	\N	\N	\N	11876	11876	11877
3960	3160	0	applied	\N	\N	\N	\N	11881	11881	11882
3975	3166	0	applied	\N	\N	\N	\N	11913	11913	11914
3978	3168	0	applied	\N	\N	\N	\N	11929	11929	11930
3978	3169	1	applied	\N	\N	\N	\N	11931	11931	11932
3980	3170	0	applied	\N	\N	\N	\N	11934	11934	11935
3990	3176	0	applied	\N	\N	\N	\N	11959	11959	11960
3992	3176	0	applied	\N	\N	\N	\N	11959	11959	11960
3994	3177	0	applied	\N	\N	\N	\N	11967	11967	11968
3999	3181	0	applied	\N	\N	\N	\N	11982	11982	11983
4003	3182	0	applied	\N	\N	\N	\N	11984	11984	11985
4006	3184	0	applied	\N	\N	\N	\N	11995	11995	11996
4006	3185	1	applied	\N	\N	\N	\N	11997	11997	11998
4011	3188	0	applied	\N	\N	\N	\N	12010	12010	12011
4011	3189	1	applied	\N	\N	\N	\N	12012	12012	12013
4013	3188	0	applied	\N	\N	\N	\N	12010	12010	12011
4013	3189	1	applied	\N	\N	\N	\N	12012	12012	12013
4015	3190	0	applied	\N	\N	\N	\N	12020	12020	12021
4017	3190	0	applied	\N	\N	\N	\N	12020	12020	12021
4020	3192	0	applied	\N	\N	\N	\N	12028	12028	12029
4020	3193	1	applied	\N	\N	\N	\N	12030	12030	12031
4023	3198	0	applied	\N	\N	\N	\N	12044	12044	12045
4030	3203	0	applied	\N	\N	\N	\N	12062	12062	12063
4032	3203	0	applied	\N	\N	\N	\N	12062	12062	12063
4035	3205	0	applied	\N	\N	\N	\N	12068	12068	12069
4039	3207	0	applied	\N	\N	\N	\N	12079	12079	12080
4040	3208	0	applied	\N	\N	\N	\N	12083	12083	12084
4040	3209	1	applied	\N	\N	\N	\N	12085	12085	12086
4040	3210	2	applied	\N	\N	\N	\N	12087	12087	12088
4045	3214	0	applied	\N	\N	\N	\N	12101	12101	12102
4048	3218	0	applied	\N	\N	\N	\N	12114	12114	12115
4054	3222	0	applied	\N	\N	\N	\N	12128	12128	12129
4054	3223	1	applied	\N	\N	\N	\N	12130	12130	12131
4055	3222	0	applied	\N	\N	\N	\N	12128	12128	12129
4055	3223	1	applied	\N	\N	\N	\N	12130	12130	12131
4059	3228	0	applied	\N	\N	\N	\N	12150	12150	12151
4065	3233	0	applied	\N	\N	\N	\N	12168	12168	12169
4068	3235	0	applied	\N	\N	\N	\N	12173	12173	12174
4069	3236	0	applied	\N	\N	\N	\N	12177	12177	12178
4069	3237	1	applied	\N	\N	\N	\N	12179	12179	12180
4077	3241	0	applied	\N	\N	\N	\N	12201	12201	12202
4080	3242	0	applied	\N	\N	\N	\N	12205	12205	12206
3727	2977	0	applied	\N	\N	\N	\N	11192	11192	11193
3734	2981	0	applied	\N	\N	\N	\N	11217	11217	11218
3743	2986	0	applied	\N	\N	\N	\N	11238	11238	11239
3743	2987	1	applied	\N	\N	\N	\N	11240	11240	11241
3745	2986	0	applied	\N	\N	\N	\N	11238	11238	11239
3745	2987	1	applied	\N	\N	\N	\N	11240	11240	11241
3748	2990	0	applied	\N	\N	\N	\N	11254	11254	11255
3753	2994	0	applied	\N	\N	\N	\N	11271	11271	11272
3755	2995	0	applied	\N	\N	\N	\N	11277	11277	11278
3758	2998	0	applied	\N	\N	\N	\N	11286	11286	11287
3758	2999	1	applied	\N	\N	\N	\N	11288	11288	11289
3763	3002	0	applied	\N	\N	\N	\N	11305	11305	11306
3766	3005	0	applied	\N	\N	\N	\N	11315	11315	11316
3766	3006	1	applied	\N	\N	\N	\N	11317	11317	11318
3770	3009	0	applied	\N	\N	\N	\N	11331	11331	11332
3779	3012	0	applied	\N	\N	\N	\N	11343	11343	11344
3781	3012	0	applied	\N	\N	\N	\N	11343	11343	11344
3788	3016	0	applied	\N	\N	\N	\N	11362	11362	11363
3788	3017	1	applied	\N	\N	\N	\N	11364	11364	11365
3789	3018	0	applied	\N	\N	\N	\N	11367	11367	11368
3789	3019	1	applied	\N	\N	\N	\N	11369	11369	11370
3789	3020	2	applied	\N	\N	\N	\N	11371	11371	11372
3789	3021	3	applied	\N	\N	\N	\N	11373	11373	11374
3796	3025	0	applied	\N	\N	\N	\N	11390	11390	11391
3804	3031	0	applied	\N	\N	\N	\N	11417	11417	11418
3804	3032	1	applied	\N	\N	\N	\N	11419	11419	11420
3804	3033	2	applied	\N	\N	\N	\N	11421	11421	11422
3806	3031	0	applied	\N	\N	\N	\N	11417	11417	11418
3806	3032	1	applied	\N	\N	\N	\N	11419	11419	11420
3806	3033	2	applied	\N	\N	\N	\N	11421	11421	11422
3809	3036	0	applied	\N	\N	\N	\N	11434	11434	11435
3814	3038	0	applied	\N	\N	\N	\N	11444	11444	11445
3814	3039	1	applied	\N	\N	\N	\N	11446	11446	11447
3816	3040	0	applied	\N	\N	\N	\N	11455	11455	11456
3818	3040	0	applied	\N	\N	\N	\N	11455	11455	11456
3823	3044	0	applied	\N	\N	\N	\N	11472	11472	11473
3823	3045	1	applied	\N	\N	\N	\N	11474	11474	11475
3828	3052	0	applied	\N	\N	\N	\N	11497	11497	11498
3840	3054	0	applied	\N	\N	1000000000	\N	11503	11503	11504
3840	3050	1	applied	\N	\N	\N	\N	11491	11491	11492
3840	2933	2	applied	\N	\N	\N	\N	10997	10997	10998
3840	2936	3	applied	\N	\N	\N	\N	11024	11024	11025
3840	2937	4	applied	\N	\N	\N	\N	11026	11026	11027
3840	2935	5	applied	\N	\N	1000000000	\N	11547	11547	11019
3840	2960	6	applied	\N	\N	\N	\N	11548	11548	11122
3840	2939	7	applied	\N	\N	\N	\N	11032	11032	11033
3840	2940	8	applied	\N	\N	\N	\N	11035	11035	11036
3840	2941	9	applied	\N	\N	\N	\N	11038	11038	11039
3840	2942	10	applied	\N	\N	\N	\N	11045	11045	11046
3840	2943	11	applied	\N	\N	\N	\N	11049	11049	11050
3840	2944	12	applied	\N	\N	\N	\N	11052	11052	11053
3840	2945	13	applied	\N	\N	\N	\N	11058	11058	11059
3840	2946	14	applied	\N	\N	\N	\N	11062	11062	11063
3840	2948	15	applied	\N	\N	\N	\N	11067	11067	11068
3840	2949	16	applied	\N	\N	\N	\N	11069	11069	11070
3840	2950	17	applied	\N	\N	\N	\N	11074	11074	11075
3840	2951	18	applied	\N	\N	\N	\N	11076	11076	11077
3840	2952	19	applied	\N	\N	\N	\N	11083	11083	11084
3840	2953	20	applied	\N	\N	\N	\N	11092	11092	11093
3840	2954	21	applied	\N	\N	\N	\N	11096	11096	11097
3840	2955	22	applied	\N	\N	\N	\N	11100	11100	11101
3840	2956	23	applied	\N	\N	\N	\N	11102	11102	11103
3840	2958	24	applied	\N	\N	\N	\N	11110	11110	11111
3840	2959	25	applied	\N	\N	\N	\N	11115	11115	11116
3840	2961	26	applied	\N	\N	\N	\N	11123	11123	11124
3840	2963	27	applied	\N	\N	\N	\N	11131	11131	11132
3840	2964	28	applied	\N	\N	\N	\N	11140	11140	11141
3840	2965	29	applied	\N	\N	\N	\N	11143	11143	11144
3840	2966	30	applied	\N	\N	\N	\N	11147	11147	11148
3840	2967	31	applied	\N	\N	\N	\N	11149	11149	11150
3840	2968	32	applied	\N	\N	\N	\N	11151	11151	11152
3840	2969	33	applied	\N	\N	\N	\N	11153	11153	11154
3840	2970	34	applied	\N	\N	\N	\N	11157	11157	11158
3840	2971	35	applied	\N	\N	\N	\N	11159	11159	11160
3840	2972	36	applied	\N	\N	\N	\N	11167	11167	11168
3840	2973	37	applied	\N	\N	\N	\N	11169	11169	11170
3840	2974	38	applied	\N	\N	\N	\N	11173	11173	11174
3840	2975	39	applied	\N	\N	\N	\N	11184	11184	11185
3840	2976	40	applied	\N	\N	\N	\N	11188	11188	11189
3840	2977	41	applied	\N	\N	\N	\N	11192	11192	11193
3840	2978	42	applied	\N	\N	\N	\N	11200	11200	11201
3840	2979	43	applied	\N	\N	\N	\N	11204	11204	11205
3840	2980	44	applied	\N	\N	\N	\N	11207	11207	11208
3840	2981	45	applied	\N	\N	\N	\N	11217	11217	11218
3840	2982	46	applied	\N	\N	\N	\N	11219	11219	11220
3840	2983	47	applied	\N	\N	\N	\N	11221	11221	11222
3840	2984	48	applied	\N	\N	\N	\N	11226	11226	11227
3840	2985	49	applied	\N	\N	\N	\N	11232	11232	11233
3840	2986	50	applied	\N	\N	\N	\N	11238	11238	11239
3840	2988	51	applied	\N	\N	\N	\N	11246	11246	11247
3840	2989	52	applied	\N	\N	\N	\N	11248	11248	11249
3840	2990	53	applied	\N	\N	\N	\N	11254	11254	11255
3840	2991	54	applied	\N	\N	\N	\N	11258	11258	11259
3840	2992	55	applied	\N	\N	\N	\N	11260	11260	11261
3840	2993	56	applied	\N	\N	\N	\N	11265	11265	11266
3840	2994	57	applied	\N	\N	\N	\N	11271	11271	11272
3840	2995	58	applied	\N	\N	\N	\N	11277	11277	11278
3840	2996	59	applied	\N	\N	\N	\N	11281	11281	11282
3840	2997	60	applied	\N	\N	\N	\N	11283	11283	11284
3840	2998	61	applied	\N	\N	\N	\N	11286	11286	11287
3840	2999	62	applied	\N	\N	\N	\N	11288	11288	11289
3840	3000	63	applied	\N	\N	\N	\N	11298	11298	11299
3840	3001	64	applied	\N	\N	\N	\N	11302	11302	11303
3840	3002	65	applied	\N	\N	\N	\N	11305	11305	11306
3840	3003	66	applied	\N	\N	\N	\N	11310	11310	11311
3840	3004	67	applied	\N	\N	\N	\N	11312	11312	11313
3840	3005	68	applied	\N	\N	\N	\N	11315	11315	11316
3840	3006	69	applied	\N	\N	\N	\N	11317	11317	11318
3840	3007	70	applied	\N	\N	\N	\N	11325	11325	11326
3840	3008	71	applied	\N	\N	\N	\N	11327	11327	11328
3840	3009	72	applied	\N	\N	\N	\N	11331	11331	11332
3840	3010	73	applied	\N	\N	\N	\N	11337	11337	11338
3840	3011	74	applied	\N	\N	\N	\N	11341	11341	11342
3840	3012	75	applied	\N	\N	\N	\N	11343	11343	11344
3840	3013	76	applied	\N	\N	\N	\N	11350	11350	11351
3840	3014	77	applied	\N	\N	\N	\N	11352	11352	11353
3840	3015	78	applied	\N	\N	\N	\N	11360	11360	11361
3840	3016	79	applied	\N	\N	\N	\N	11362	11362	11363
3840	3017	80	applied	\N	\N	\N	\N	11364	11364	11365
3826	3008	73	applied	\N	\N	\N	\N	11327	11327	11328
3826	3009	74	applied	\N	\N	\N	\N	11331	11331	11332
3826	3010	75	applied	\N	\N	\N	\N	11337	11337	11338
3826	3011	76	applied	\N	\N	\N	\N	11341	11341	11342
3826	3012	77	applied	\N	\N	\N	\N	11343	11343	11344
3826	3013	78	applied	\N	\N	\N	\N	11350	11350	11351
3826	3014	79	applied	\N	\N	\N	\N	11352	11352	11353
3826	3015	80	applied	\N	\N	\N	\N	11360	11360	11361
3826	3016	82	applied	\N	\N	\N	\N	11362	11362	11363
3826	3017	83	applied	\N	\N	\N	\N	11364	11364	11365
3826	3018	84	applied	\N	\N	\N	\N	11367	11367	11368
3826	3019	85	applied	\N	\N	\N	\N	11369	11369	11370
3826	3020	86	applied	\N	\N	\N	\N	11371	11371	11372
3826	3021	87	applied	\N	\N	\N	\N	11373	11373	11374
3826	3022	88	applied	\N	\N	\N	\N	11379	11379	11380
3826	3023	89	applied	\N	\N	\N	\N	11382	11382	11383
3826	3024	90	applied	\N	\N	\N	\N	11386	11386	11387
3826	3025	91	applied	\N	\N	\N	\N	11390	11390	11391
3826	3026	92	applied	\N	\N	\N	\N	11394	11394	11395
3826	3027	93	applied	\N	\N	\N	\N	11400	11400	11401
3826	3028	94	applied	\N	\N	\N	\N	11404	11404	11405
3826	3029	95	applied	\N	\N	\N	\N	11406	11406	11407
3826	3030	96	applied	\N	\N	\N	\N	11413	11413	11414
3826	3031	97	applied	\N	\N	\N	\N	11417	11417	11418
3826	3032	98	applied	\N	\N	\N	\N	11419	11419	11420
3826	3033	99	applied	\N	\N	\N	\N	11421	11421	11422
3826	3034	100	applied	\N	\N	\N	\N	11426	11426	11427
3826	3035	101	applied	\N	\N	\N	\N	11430	11430	11431
3826	3036	102	applied	\N	\N	\N	\N	11434	11434	11435
3826	3037	103	applied	\N	\N	\N	\N	11438	11438	11439
3826	3038	104	applied	\N	\N	\N	\N	11444	11444	11445
3826	3039	105	applied	\N	\N	\N	\N	11446	11446	11447
3826	3040	106	applied	\N	\N	\N	\N	11455	11455	11456
3826	3041	107	applied	\N	\N	\N	\N	11459	11459	11460
3826	3042	108	applied	\N	\N	\N	\N	11465	11465	11466
3826	3043	109	applied	\N	\N	\N	\N	11469	11469	11470
3826	3044	110	applied	\N	\N	\N	\N	11472	11472	11473
3826	3045	111	applied	\N	\N	\N	\N	11474	11474	11475
3829	3053	0	applied	\N	\N	\N	\N	11501	11501	11502
3831	3054	0	applied	\N	\N	1000000000	\N	11503	11503	11504
3831	3055	1	applied	\N	\N	\N	\N	11505	11505	11506
3832	3056	0	applied	\N	\N	\N	\N	11510	11510	11491
3832	3057	1	applied	\N	\N	\N	\N	11511	11511	11512
3832	3058	2	applied	\N	\N	\N	\N	11513	11513	11514
3832	3059	3	applied	\N	\N	\N	\N	11515	11515	11516
3835	3064	0	applied	\N	\N	\N	\N	11527	11527	11528
3838	3068	0	applied	\N	\N	\N	\N	11541	11541	11542
3846	3070	0	applied	\N	\N	\N	\N	11557	11557	11558
3846	3071	1	applied	\N	\N	\N	\N	11559	11559	11560
3847	3072	0	applied	\N	\N	\N	\N	11565	11565	11566
3852	3075	0	applied	\N	\N	\N	\N	11577	11577	11578
3854	3076	0	applied	\N	\N	\N	\N	11581	11581	11582
3855	3077	0	applied	\N	\N	\N	\N	11585	11585	11586
3855	3078	1	applied	\N	\N	\N	\N	11587	11587	11588
3855	3079	2	applied	\N	\N	\N	\N	11589	11589	11590
3855	3080	3	applied	\N	\N	\N	\N	11591	11591	11592
3862	3083	0	applied	\N	\N	\N	\N	11604	11604	11605
3870	3091	0	applied	\N	\N	\N	\N	11633	11633	11634
3872	3091	0	applied	\N	\N	\N	\N	11633	11633	11634
3877	3095	0	applied	\N	\N	\N	\N	11647	11647	11648
3879	3095	0	applied	\N	\N	\N	\N	11647	11647	11648
3884	3099	0	applied	\N	\N	\N	\N	11667	11667	11668
3884	3100	1	applied	\N	\N	\N	\N	11669	11669	11670
3887	3102	0	applied	\N	\N	\N	\N	11680	11680	11681
3887	3103	1	applied	\N	\N	\N	\N	11682	11682	11683
3889	3102	0	applied	\N	\N	\N	\N	11680	11680	11681
3889	3103	1	applied	\N	\N	\N	\N	11682	11682	11683
3893	3104	0	applied	\N	\N	\N	\N	11690	11690	11691
3896	3107	0	applied	\N	\N	\N	\N	11700	11700	11701
3898	3108	0	applied	\N	\N	\N	\N	11704	11704	11705
3903	3111	0	applied	\N	\N	\N	\N	11714	11714	11715
3903	3112	1	applied	\N	\N	\N	\N	11716	11716	11717
3906	3114	0	applied	\N	\N	\N	\N	11726	11726	11727
3906	3115	1	applied	\N	\N	\N	\N	11728	11728	11729
3920	3121	0	applied	\N	\N	\N	\N	11749	11749	11750
3922	3122	0	applied	\N	\N	\N	\N	11755	11755	11756
3925	3123	0	applied	\N	\N	\N	\N	11759	11759	11760
3925	3124	1	applied	\N	\N	\N	\N	11761	11761	11762
3927	3067	0	applied	\N	\N	\N	\N	11537	11537	11538
3927	3068	1	applied	\N	\N	\N	\N	11541	11541	11542
3927	3069	2	applied	\N	\N	\N	\N	11553	11553	11554
3927	3070	3	applied	\N	\N	\N	\N	11557	11557	11558
3927	3071	4	applied	\N	\N	\N	\N	11559	11559	11560
3927	3072	5	applied	\N	\N	\N	\N	11565	11565	11566
3927	3073	6	applied	\N	\N	\N	\N	11569	11569	11570
3927	3074	7	applied	\N	\N	\N	\N	11571	11571	11572
3927	3075	8	applied	\N	\N	\N	\N	11577	11577	11578
3927	3076	9	applied	\N	\N	\N	\N	11581	11581	11582
3927	3077	10	applied	\N	\N	\N	\N	11585	11585	11586
3927	3078	11	applied	\N	\N	\N	\N	11587	11587	11588
3927	3079	12	applied	\N	\N	\N	\N	11589	11589	11590
3927	3080	13	applied	\N	\N	\N	\N	11591	11591	11592
3927	3081	14	applied	\N	\N	\N	\N	11596	11596	11597
3927	3082	15	applied	\N	\N	\N	\N	11600	11600	11601
3927	3083	16	applied	\N	\N	\N	\N	11604	11604	11605
3927	3084	17	applied	\N	\N	\N	\N	11608	11608	11609
3927	3085	18	applied	\N	\N	\N	\N	11610	11610	11611
3927	3086	19	applied	\N	\N	\N	\N	11612	11612	11613
3927	3087	20	applied	\N	\N	\N	\N	11619	11619	11620
3927	3088	21	applied	\N	\N	\N	\N	11623	11623	11624
3927	3089	22	applied	\N	\N	\N	\N	11625	11625	11626
3927	3090	23	applied	\N	\N	\N	\N	11629	11629	11630
3927	3091	24	applied	\N	\N	\N	\N	11633	11633	11634
3927	3092	25	applied	\N	\N	\N	\N	11639	11639	11640
3927	3093	26	applied	\N	\N	\N	\N	11642	11642	11643
3927	3094	27	applied	\N	\N	\N	\N	11644	11644	11645
3927	3095	28	applied	\N	\N	\N	\N	11647	11647	11648
3927	3096	29	applied	\N	\N	\N	\N	11655	11655	11656
3927	3097	30	applied	\N	\N	\N	\N	11659	11659	11660
3927	3098	31	applied	\N	\N	\N	\N	11663	11663	11664
3927	3099	32	applied	\N	\N	\N	\N	11667	11667	11668
3927	3100	33	applied	\N	\N	\N	\N	11669	11669	11670
3927	3101	34	applied	\N	\N	\N	\N	11675	11675	11676
3927	3102	35	applied	\N	\N	\N	\N	11680	11680	11681
3927	3103	36	applied	\N	\N	\N	\N	11682	11682	11683
3927	3104	37	applied	\N	\N	\N	\N	11690	11690	11691
3927	3105	38	applied	\N	\N	\N	\N	11694	11694	11695
3927	3106	39	applied	\N	\N	\N	\N	11696	11696	11697
3927	3107	40	applied	\N	\N	\N	\N	11700	11700	11701
3927	3108	41	applied	\N	\N	\N	\N	11704	11704	11705
3840	3018	82	applied	\N	\N	\N	\N	11367	11367	11368
3840	3019	83	applied	\N	\N	\N	\N	11369	11369	11370
3840	3020	84	applied	\N	\N	\N	\N	11371	11371	11372
3840	3021	85	applied	\N	\N	\N	\N	11373	11373	11374
3840	3022	86	applied	\N	\N	\N	\N	11379	11379	11380
3840	3023	87	applied	\N	\N	\N	\N	11382	11382	11383
3840	3024	88	applied	\N	\N	\N	\N	11386	11386	11387
3840	3025	89	applied	\N	\N	\N	\N	11390	11390	11391
3840	3026	90	applied	\N	\N	\N	\N	11394	11394	11395
3840	3027	91	applied	\N	\N	\N	\N	11400	11400	11401
3840	3028	92	applied	\N	\N	\N	\N	11404	11404	11405
3840	3029	93	applied	\N	\N	\N	\N	11406	11406	11407
3840	3030	94	applied	\N	\N	\N	\N	11413	11413	11414
3840	3031	95	applied	\N	\N	\N	\N	11417	11417	11418
3840	3032	96	applied	\N	\N	\N	\N	11419	11419	11420
3840	3033	97	applied	\N	\N	\N	\N	11421	11421	11422
3840	3034	98	applied	\N	\N	\N	\N	11426	11426	11427
3840	3035	99	applied	\N	\N	\N	\N	11430	11430	11431
3840	3036	100	applied	\N	\N	\N	\N	11434	11434	11435
3840	3037	101	applied	\N	\N	\N	\N	11438	11438	11439
3840	3038	102	applied	\N	\N	\N	\N	11444	11444	11445
3840	3039	103	applied	\N	\N	\N	\N	11446	11446	11447
3840	3040	104	applied	\N	\N	\N	\N	11455	11455	11456
3840	3041	105	applied	\N	\N	\N	\N	11459	11459	11460
3840	3042	106	applied	\N	\N	\N	\N	11465	11465	11466
3840	3043	107	applied	\N	\N	\N	\N	11469	11469	11470
3840	3044	108	applied	\N	\N	\N	\N	11472	11472	11473
3840	3045	109	applied	\N	\N	\N	\N	11474	11474	11475
3840	3047	110	applied	\N	\N	\N	\N	11477	11477	11478
3840	3049	111	applied	\N	\N	\N	\N	11482	11482	11483
3840	3051	112	applied	\N	\N	\N	\N	11493	11493	11494
3840	3052	113	applied	\N	\N	\N	\N	11497	11497	11498
3840	3053	114	applied	\N	\N	\N	\N	11501	11501	11502
3840	3055	115	applied	\N	\N	\N	\N	11505	11505	11506
3840	3057	116	applied	\N	\N	\N	\N	11511	11511	11512
3840	3058	117	applied	\N	\N	\N	\N	11513	11513	11514
3840	3059	118	applied	\N	\N	\N	\N	11515	11515	11516
3840	3060	119	applied	\N	\N	\N	\N	11518	11518	11519
3840	3061	120	applied	\N	\N	\N	\N	11520	11520	11521
3840	3062	121	applied	\N	\N	\N	\N	11522	11522	11523
3840	3063	122	applied	\N	\N	\N	\N	11524	11524	11525
3840	3064	123	applied	\N	\N	\N	\N	11527	11527	11528
3840	3065	124	applied	\N	\N	\N	\N	11531	11531	11532
3840	3066	125	applied	\N	\N	\N	\N	11533	11533	11534
3843	3070	0	applied	\N	\N	\N	\N	11557	11557	11558
3843	3071	1	applied	\N	\N	\N	\N	11559	11559	11560
3845	3070	0	applied	\N	\N	\N	\N	11557	11557	11558
3845	3071	1	applied	\N	\N	\N	\N	11559	11559	11560
3849	3073	0	applied	\N	\N	\N	\N	11569	11569	11570
3849	3074	1	applied	\N	\N	\N	\N	11571	11571	11572
3857	3081	0	applied	\N	\N	\N	\N	11596	11596	11597
3859	3081	0	applied	\N	\N	\N	\N	11596	11596	11597
3867	3088	0	applied	\N	\N	\N	\N	11623	11623	11624
3867	3089	1	applied	\N	\N	\N	\N	11625	11625	11626
3869	3090	0	applied	\N	\N	\N	\N	11629	11629	11630
3874	3093	0	applied	\N	\N	\N	\N	11642	11642	11643
3881	3097	0	applied	\N	\N	\N	\N	11659	11659	11660
3895	3105	0	applied	\N	\N	\N	\N	11694	11694	11695
3895	3106	1	applied	\N	\N	\N	\N	11696	11696	11697
3900	3109	0	applied	\N	\N	\N	\N	11709	11709	11710
3902	3110	0	applied	\N	\N	\N	\N	11712	11712	11713
3905	3113	0	applied	\N	\N	\N	\N	11722	11722	11723
3908	3114	0	applied	\N	\N	\N	\N	11726	11726	11727
3908	3115	1	applied	\N	\N	\N	\N	11728	11728	11729
3917	3119	0	applied	\N	\N	\N	\N	11743	11743	11744
3924	3123	0	applied	\N	\N	\N	\N	11759	11759	11760
3924	3124	1	applied	\N	\N	\N	\N	11761	11761	11762
3929	3126	0	applied	\N	\N	\N	\N	11774	11774	11775
3929	3127	1	applied	\N	\N	\N	\N	11776	11776	11777
3934	3131	0	applied	\N	\N	\N	\N	11791	11791	11792
3936	3132	0	applied	\N	\N	\N	\N	11797	11797	11798
3944	3139	0	applied	\N	\N	\N	\N	11820	11820	11821
3944	3140	1	applied	\N	\N	\N	\N	11822	11822	11823
3947	3149	0	applied	\N	\N	\N	\N	11843	11843	11844
3953	3156	0	applied	\N	\N	\N	\N	11865	11865	11866
3956	3157	0	applied	\N	\N	\N	\N	11869	11869	11870
3962	3161	0	applied	\N	\N	\N	\N	11888	11888	11889
3964	3161	0	applied	\N	\N	\N	\N	11888	11888	11889
3966	3054	0	applied	\N	\N	1000000000	\N	11503	11503	11504
3966	3143	1	applied	\N	\N	\N	\N	11831	11831	11832
3966	3145	2	applied	\N	\N	\N	\N	11837	11837	1254
3966	3146	3	applied	\N	\N	\N	\N	11894	11894	1254
3966	3147	4	applied	\N	\N	\N	\N	11895	11895	1254
3966	3148	5	applied	\N	\N	\N	\N	11840	11840	1254
3969	3164	0	applied	\N	\N	\N	\N	11903	11903	11904
3971	3165	0	applied	\N	\N	\N	\N	11907	11907	11908
3974	3166	0	applied	\N	\N	\N	\N	11913	11913	11914
3976	3167	0	applied	\N	\N	\N	\N	11923	11923	11924
3981	3171	0	applied	\N	\N	\N	\N	11938	11938	11939
3983	3171	0	applied	\N	\N	\N	\N	11938	11938	11939
3988	3175	0	applied	\N	\N	\N	\N	11955	11955	11956
3993	3176	0	applied	\N	\N	\N	\N	11959	11959	11960
4004	3183	0	applied	\N	\N	\N	\N	11990	11990	11991
4009	3187	0	applied	\N	\N	\N	\N	12004	12004	12005
4012	3188	0	applied	\N	\N	\N	\N	12010	12010	12011
4012	3189	1	applied	\N	\N	\N	\N	12012	12012	12013
4014	3188	0	applied	\N	\N	\N	\N	12010	12010	12011
4014	3189	1	applied	\N	\N	\N	\N	12012	12012	12013
4016	3190	0	applied	\N	\N	\N	\N	12020	12020	12021
4018	3191	0	applied	\N	\N	\N	\N	12024	12024	12025
4021	3194	0	applied	\N	\N	\N	\N	12033	12033	12034
4021	3195	1	applied	\N	\N	\N	\N	12035	12035	12036
4026	3201	0	applied	\N	\N	\N	\N	12053	12053	12054
4028	3201	0	applied	\N	\N	\N	\N	12053	12053	12054
4033	3204	0	applied	\N	\N	\N	\N	12066	12066	12067
4038	3206	0	applied	\N	\N	\N	\N	12075	12075	12076
4043	3213	0	applied	\N	\N	\N	\N	12097	12097	12098
4049	3218	0	applied	\N	\N	\N	\N	12114	12114	12115
4056	3224	0	applied	\N	\N	\N	\N	12136	12136	12137
4056	3225	1	applied	\N	\N	\N	\N	12138	12138	12139
4056	3226	2	applied	\N	\N	\N	\N	12140	12140	12141
4057	3227	0	applied	\N	\N	\N	\N	12144	12144	12145
4060	3228	0	applied	\N	\N	\N	\N	12150	12150	12151
4066	3234	0	applied	\N	\N	\N	\N	12171	12171	12172
4067	3235	0	applied	\N	\N	\N	\N	12173	12173	12174
4070	3238	0	applied	\N	\N	\N	\N	12183	12183	12184
4072	3239	0	applied	\N	\N	\N	\N	12189	12189	12190
4073	3239	0	applied	\N	\N	\N	\N	12189	12189	12190
4074	3239	0	applied	\N	\N	\N	\N	12189	12189	12190
4081	3242	0	applied	\N	\N	\N	\N	12205	12205	12206
3927	3109	42	applied	\N	\N	\N	\N	11709	11709	11710
3927	3110	43	applied	\N	\N	\N	\N	11712	11712	11713
3927	3111	44	applied	\N	\N	\N	\N	11714	11714	11715
3927	3112	45	applied	\N	\N	\N	\N	11716	11716	11717
3927	3113	46	applied	\N	\N	\N	\N	11722	11722	11723
3927	3114	47	applied	\N	\N	\N	\N	11726	11726	11727
3927	3115	48	applied	\N	\N	\N	\N	11728	11728	11729
3927	3116	49	applied	\N	\N	\N	\N	11731	11731	11732
3927	3117	50	applied	\N	\N	\N	\N	11735	11735	11736
3927	3118	51	applied	\N	\N	\N	\N	11737	11737	11738
3927	3119	52	applied	\N	\N	\N	\N	11743	11743	11744
3927	3120	53	applied	\N	\N	\N	\N	11747	11747	11748
3927	3121	54	applied	\N	\N	\N	\N	11749	11749	11750
3927	3122	55	applied	\N	\N	\N	\N	11755	11755	11756
3927	3123	56	applied	\N	\N	\N	\N	11759	11759	11760
3927	3124	57	applied	\N	\N	\N	\N	11761	11761	11762
3927	2987	58	applied	\N	\N	\N	\N	11240	11240	11294
3927	2938	59	applied	\N	\N	1000000000	\N	11269	11269	11029
3927	2957	60	applied	\N	\N	\N	\N	11767	11767	11105
3927	2962	61	applied	\N	\N	\N	\N	11241	11241	11126
3930	3128	0	applied	\N	\N	\N	\N	11780	11780	11781
3930	3129	1	applied	\N	\N	\N	\N	11782	11782	11783
3932	3128	0	applied	\N	\N	\N	\N	11780	11780	11781
3932	3129	1	applied	\N	\N	\N	\N	11782	11782	11783
3937	3133	0	applied	\N	\N	\N	\N	11801	11801	11802
3942	3138	0	applied	\N	\N	\N	\N	11817	11817	11818
3945	3141	0	applied	\N	\N	\N	\N	11827	11827	11828
3945	3142	1	applied	\N	\N	\N	\N	11829	11829	11830
3945	3143	2	applied	\N	\N	\N	\N	11831	11831	11832
3948	3150	0	applied	\N	\N	\N	\N	11847	11847	11848
3951	3155	0	applied	\N	\N	\N	\N	11861	11861	11862
3958	3159	0	applied	\N	\N	\N	\N	11878	11878	11879
3967	3162	0	applied	\N	\N	\N	\N	11897	11897	11898
3967	3163	1	applied	\N	\N	\N	\N	11899	11899	11900
3972	3166	0	applied	\N	\N	\N	\N	11913	11913	11914
3979	3170	0	applied	\N	\N	\N	\N	11934	11934	11935
3984	3172	0	applied	\N	\N	\N	\N	11944	11944	11945
3984	3173	1	applied	\N	\N	\N	\N	11946	11946	11947
3986	3174	0	applied	\N	\N	\N	\N	11951	11951	11952
3991	3176	0	applied	\N	\N	\N	\N	11959	11959	11960
3995	3178	0	applied	\N	\N	\N	\N	11971	11971	11972
3997	3178	0	applied	\N	\N	\N	\N	11971	11971	11972
3998	3179	0	applied	\N	\N	\N	\N	11977	11977	11978
3998	3180	1	applied	\N	\N	\N	\N	11979	11979	11980
4000	3181	0	applied	\N	\N	\N	\N	11982	11982	11983
4002	3182	0	applied	\N	\N	\N	\N	11984	11984	11985
4007	3186	0	applied	\N	\N	\N	\N	12000	12000	12001
4019	3191	0	applied	\N	\N	\N	\N	12024	12024	12025
4024	3199	0	applied	\N	\N	\N	\N	12047	12047	12048
4029	3202	0	applied	\N	\N	\N	\N	12059	12059	12060
4031	3203	0	applied	\N	\N	\N	\N	12062	12062	12063
4036	3205	0	applied	\N	\N	\N	\N	12068	12068	12069
4041	3208	0	applied	\N	\N	\N	\N	12083	12083	12084
4041	3209	1	applied	\N	\N	\N	\N	12085	12085	12086
4041	3210	2	applied	\N	\N	\N	\N	12087	12087	12088
4044	3213	0	applied	\N	\N	\N	\N	12097	12097	12098
4046	3214	0	applied	\N	\N	\N	\N	12101	12101	12102
4050	3218	0	applied	\N	\N	\N	\N	12114	12114	12115
4051	3219	0	applied	\N	\N	\N	\N	12119	12119	12120
4052	3220	0	applied	\N	\N	\N	\N	12123	12123	12124
4052	3221	1	applied	\N	\N	\N	\N	12125	12125	12126
4058	3227	0	applied	\N	\N	\N	\N	12144	12144	12145
4061	3229	0	applied	\N	\N	\N	\N	12155	12155	12156
4062	3230	0	applied	\N	\N	\N	\N	12159	12159	12160
4062	3231	1	applied	\N	\N	\N	\N	12161	12161	12162
4062	3232	2	applied	\N	\N	\N	\N	12163	12163	12164
4071	3238	0	applied	\N	\N	\N	\N	12183	12183	12184
4078	3242	0	applied	\N	\N	\N	\N	12205	12205	12206
4078	3243	1	applied	\N	\N	\N	\N	12207	12207	12208
4083	3244	0	applied	\N	\N	\N	\N	12215	12215	12216
4084	3245	0	applied	\N	\N	\N	\N	12220	12220	12221
4088	3247	0	applied	\N	\N	\N	\N	12228	12228	12229
4090	3248	0	applied	\N	\N	\N	\N	12233	12233	12234
4090	3249	1	applied	\N	\N	\N	\N	12235	12235	12236
4095	3257	0	applied	\N	\N	\N	\N	12262	12262	12263
4098	3260	0	applied	\N	\N	\N	\N	12272	12272	12273
4098	3261	1	applied	\N	\N	\N	\N	12274	12274	12275
4100	3262	0	applied	\N	\N	\N	\N	12279	12279	12280
4103	3263	0	applied	\N	\N	\N	\N	12283	12283	10914
4103	3264	1	applied	\N	\N	\N	\N	12284	12284	12285
4109	3268	0	applied	\N	\N	\N	\N	12303	12303	12304
4109	3269	1	applied	\N	\N	1000000000	\N	12305	12305	12306
4116	3272	0	applied	\N	\N	\N	\N	12316	12316	1435
4116	3273	1	applied	\N	\N	\N	\N	12317	12317	12318
4063	3231	1	applied	\N	\N	\N	\N	12161	12161	12162
4063	3232	2	applied	\N	\N	\N	\N	12163	12163	12164
4064	3233	0	applied	\N	\N	\N	\N	12168	12168	12169
4075	3240	0	applied	\N	\N	\N	\N	12197	12197	12198
4076	3240	0	applied	\N	\N	\N	\N	12197	12197	12198
4079	3242	0	applied	\N	\N	\N	\N	12205	12205	12206
4079	3243	1	applied	\N	\N	\N	\N	12207	12207	12208
4091	3250	0	applied	\N	\N	1000000000	\N	12241	12241	12242
4091	3251	1	applied	\N	\N	\N	\N	12243	12243	12244
4091	3252	2	applied	\N	\N	\N	\N	12245	12245	12246
4091	3253	3	applied	\N	\N	\N	\N	12247	12247	12248
4091	3254	4	applied	\N	\N	\N	\N	12249	12249	12250
4093	3255	0	applied	\N	\N	\N	\N	12255	12255	12256
4107	3265	0	applied	\N	\N	\N	\N	12294	12294	10977
4107	3266	1	applied	\N	\N	\N	\N	12295	12295	12296
4110	3270	0	applied	\N	\N	\N	\N	12308	12308	12309
4112	3270	0	applied	\N	\N	\N	\N	12308	12308	12309
4114	3271	0	applied	\N	\N	\N	\N	12310	12310	12311
4080	3243	1	applied	\N	\N	\N	\N	12207	12207	12208
4087	3247	0	applied	\N	\N	\N	\N	12228	12228	12229
4096	3257	0	applied	\N	\N	\N	\N	12262	12262	12263
4099	3260	0	applied	\N	\N	\N	\N	12272	12272	12273
4099	3261	1	applied	\N	\N	\N	\N	12274	12274	12275
4101	3262	0	applied	\N	\N	\N	\N	12279	12279	12280
4104	3263	0	applied	\N	\N	\N	\N	12283	12283	10914
4104	3264	1	applied	\N	\N	\N	\N	12284	12284	12285
4106	3263	0	applied	\N	\N	\N	\N	12283	12283	10914
4106	3264	1	applied	\N	\N	\N	\N	12284	12284	12285
4108	3267	0	applied	\N	\N	\N	\N	12299	12299	12300
4111	3270	0	applied	\N	\N	\N	\N	12308	12308	12309
4117	3265	0	applied	\N	\N	\N	\N	12294	12294	10977
4117	3263	1	applied	\N	\N	\N	\N	12283	12283	10914
4117	3196	2	applied	\N	\N	\N	\N	12039	12039	12040
4117	3272	3	applied	\N	\N	\N	\N	12316	12316	1435
4117	3128	4	applied	\N	\N	\N	\N	11780	11780	11781
4117	3129	5	applied	\N	\N	\N	\N	11782	11782	11783
4117	3130	6	applied	\N	\N	\N	\N	11787	11787	11788
4117	3131	7	applied	\N	\N	\N	\N	11791	11791	11792
4117	3132	8	applied	\N	\N	\N	\N	11797	11797	11798
4117	3133	9	applied	\N	\N	\N	\N	11801	11801	11802
4117	3134	10	applied	\N	\N	\N	\N	11805	11805	11806
4117	3135	11	applied	\N	\N	\N	\N	11807	11807	11808
4117	3136	12	applied	\N	\N	\N	\N	11811	11811	11812
4117	3137	13	applied	\N	\N	\N	\N	11813	11813	11814
4117	3138	14	applied	\N	\N	\N	\N	11817	11817	11818
4117	3139	15	applied	\N	\N	\N	\N	11820	11820	11821
4117	3140	16	applied	\N	\N	\N	\N	11822	11822	11823
4117	3141	17	applied	\N	\N	\N	\N	11827	11827	11828
4117	3142	18	applied	\N	\N	\N	\N	11829	11829	11830
4117	3144	19	applied	\N	\N	\N	\N	11835	11835	11836
4117	3149	20	applied	\N	\N	\N	\N	11843	11843	11844
4117	3150	21	applied	\N	\N	\N	\N	11847	11847	11848
4117	3151	22	applied	\N	\N	\N	\N	11851	11851	11852
4117	3152	23	applied	\N	\N	\N	\N	11853	11853	11854
4117	3153	24	applied	\N	\N	\N	\N	11855	11855	11856
4117	3154	25	applied	\N	\N	\N	\N	11859	11859	11860
4117	3155	26	applied	\N	\N	\N	\N	11861	11861	11862
4117	3156	27	applied	\N	\N	\N	\N	11865	11865	11866
4117	3157	28	applied	\N	\N	\N	\N	11869	11869	11870
4117	3158	29	applied	\N	\N	\N	\N	11876	11876	11877
4117	3159	30	applied	\N	\N	\N	\N	11878	11878	11879
4117	3160	31	applied	\N	\N	\N	\N	11881	11881	11882
4117	3161	32	applied	\N	\N	\N	\N	11888	11888	11889
4117	3162	33	applied	\N	\N	\N	\N	11897	11897	11898
4117	3163	34	applied	\N	\N	\N	\N	11899	11899	11900
4117	3164	35	applied	\N	\N	\N	\N	11903	11903	11904
4117	3165	36	applied	\N	\N	\N	\N	11907	11907	11908
4117	3166	37	applied	\N	\N	\N	\N	11913	11913	11914
4117	3167	38	applied	\N	\N	\N	\N	11923	11923	11924
4117	3168	39	applied	\N	\N	\N	\N	11929	11929	11930
4117	3169	40	applied	\N	\N	\N	\N	11931	11931	11932
4117	3170	41	applied	\N	\N	\N	\N	11934	11934	11935
4117	3171	42	applied	\N	\N	\N	\N	11938	11938	11939
4117	3172	43	applied	\N	\N	\N	\N	11944	11944	11945
4117	3173	44	applied	\N	\N	\N	\N	11946	11946	11947
4117	3174	45	applied	\N	\N	\N	\N	11951	11951	11952
4117	3175	46	applied	\N	\N	\N	\N	11955	11955	11956
4117	3176	47	applied	\N	\N	\N	\N	11959	11959	11960
4117	3177	48	applied	\N	\N	\N	\N	11967	11967	11968
4117	3178	49	applied	\N	\N	\N	\N	11971	11971	11972
4117	3179	50	applied	\N	\N	\N	\N	11977	11977	11978
4117	3180	51	applied	\N	\N	\N	\N	11979	11979	11980
4117	3181	52	applied	\N	\N	\N	\N	11982	11982	11983
4117	3182	53	applied	\N	\N	\N	\N	11984	11984	11985
4117	3183	54	applied	\N	\N	\N	\N	11990	11990	11991
4117	3184	55	applied	\N	\N	\N	\N	11995	11995	11996
4117	3185	56	applied	\N	\N	\N	\N	11997	11997	11998
4117	3186	57	applied	\N	\N	\N	\N	12000	12000	12001
4117	3187	58	applied	\N	\N	\N	\N	12004	12004	12005
4117	3188	59	applied	\N	\N	\N	\N	12010	12010	12011
4117	3189	60	applied	\N	\N	\N	\N	12012	12012	12013
4117	3190	61	applied	\N	\N	\N	\N	12020	12020	12021
4117	3191	62	applied	\N	\N	\N	\N	12024	12024	12025
4117	3192	63	applied	\N	\N	\N	\N	12028	12028	12029
4117	3193	64	applied	\N	\N	\N	\N	12030	12030	12031
4117	3194	65	applied	\N	\N	\N	\N	12033	12033	12034
4117	3195	66	applied	\N	\N	\N	\N	12035	12035	12036
4117	3197	67	applied	\N	\N	\N	\N	12041	12041	12042
4117	3198	68	applied	\N	\N	\N	\N	12044	12044	12045
4117	3199	69	applied	\N	\N	\N	\N	12047	12047	12048
4117	3200	70	applied	\N	\N	\N	\N	12049	12049	12050
4117	3201	71	applied	\N	\N	\N	\N	12053	12053	12054
4117	3202	72	applied	\N	\N	\N	\N	12059	12059	12060
4117	3203	73	applied	\N	\N	\N	\N	12062	12062	12063
4117	3204	74	applied	\N	\N	\N	\N	12066	12066	12067
4117	3205	75	applied	\N	\N	\N	\N	12068	12068	12069
4117	3206	76	applied	\N	\N	\N	\N	12075	12075	12076
4117	3207	77	applied	\N	\N	\N	\N	12079	12079	12080
4117	3208	78	applied	\N	\N	\N	\N	12083	12083	12084
4117	3209	79	applied	\N	\N	\N	\N	12085	12085	12086
4117	3210	80	applied	\N	\N	\N	\N	12087	12087	12088
4117	3211	81	applied	\N	\N	\N	\N	12092	12092	12093
4117	3212	82	applied	\N	\N	\N	\N	12094	12094	12095
4117	3213	83	applied	\N	\N	\N	\N	12097	12097	12098
4117	3214	84	applied	\N	\N	\N	\N	12101	12101	12102
4117	3215	85	applied	\N	\N	\N	\N	12106	12106	12107
4117	3216	86	applied	\N	\N	\N	\N	12108	12108	12109
4117	3217	87	applied	\N	\N	\N	\N	12110	12110	12111
4117	3218	88	applied	\N	\N	\N	\N	12114	12114	12115
4117	3219	89	applied	\N	\N	\N	\N	12119	12119	12120
4117	3220	90	applied	\N	\N	\N	\N	12123	12123	12124
4117	3221	91	applied	\N	\N	\N	\N	12125	12125	12126
4117	3222	92	applied	\N	\N	\N	\N	12128	12128	12129
4117	3223	93	applied	\N	\N	\N	\N	12130	12130	12131
4117	3224	94	applied	\N	\N	\N	\N	12136	12136	12137
4117	3225	95	applied	\N	\N	\N	\N	12138	12138	12139
4117	3227	96	applied	\N	\N	\N	\N	12144	12144	12145
4117	3228	97	applied	\N	\N	\N	\N	12150	12150	12151
4117	3229	98	applied	\N	\N	\N	\N	12155	12155	12156
4117	3230	99	applied	\N	\N	\N	\N	12159	12159	12160
4117	3231	100	applied	\N	\N	\N	\N	12161	12161	12162
4117	3232	101	applied	\N	\N	\N	\N	12163	12163	12164
4117	3233	102	applied	\N	\N	\N	\N	12168	12168	12169
4117	3234	103	applied	\N	\N	\N	\N	12171	12171	12172
4117	3235	104	applied	\N	\N	\N	\N	12173	12173	12174
4117	3236	105	applied	\N	\N	\N	\N	12177	12177	12178
4117	3237	106	applied	\N	\N	\N	\N	12179	12179	12180
4117	3238	107	applied	\N	\N	\N	\N	12183	12183	12184
4081	3243	1	applied	\N	\N	\N	\N	12207	12207	12208
4082	3244	0	applied	\N	\N	\N	\N	12215	12215	12216
4085	3246	0	applied	\N	\N	\N	\N	12224	12224	12225
4086	3246	0	applied	\N	\N	\N	\N	12224	12224	12225
4089	3248	0	applied	\N	\N	\N	\N	12233	12233	12234
4089	3249	1	applied	\N	\N	\N	\N	12235	12235	12236
4092	3250	0	applied	\N	\N	1000000000	\N	12241	12241	12242
4092	3251	1	applied	\N	\N	\N	\N	12243	12243	12244
4092	3252	2	applied	\N	\N	\N	\N	12245	12245	12246
4092	3253	3	applied	\N	\N	\N	\N	12247	12247	12248
4092	3254	4	applied	\N	\N	\N	\N	12249	12249	12250
4094	3256	0	applied	\N	\N	\N	\N	12259	12259	12260
4097	3258	0	applied	\N	\N	\N	\N	12266	12266	12267
4097	3259	1	applied	\N	\N	\N	\N	12268	12268	12269
4102	3263	0	applied	\N	\N	\N	\N	12283	12283	10914
4102	3264	1	applied	\N	\N	\N	\N	12284	12284	12285
4105	3263	0	applied	\N	\N	\N	\N	12283	12283	10914
4105	3196	1	applied	\N	\N	\N	\N	12039	12039	12040
4105	3226	2	applied	\N	\N	\N	\N	12140	12140	12141
4113	3271	0	applied	\N	\N	\N	\N	12310	12310	12311
4115	3271	0	applied	\N	\N	\N	\N	12310	12310	12311
4117	3239	108	applied	\N	\N	\N	\N	12189	12189	12190
4117	3240	109	applied	\N	\N	\N	\N	12197	12197	12198
4117	3241	110	applied	\N	\N	\N	\N	12201	12201	12202
4117	3242	111	applied	\N	\N	\N	\N	12205	12205	12206
4117	3243	112	applied	\N	\N	\N	\N	12207	12207	12208
4117	3244	114	applied	\N	\N	\N	\N	12215	12215	12216
4117	3245	115	applied	\N	\N	\N	\N	12220	12220	12221
4117	3246	116	applied	\N	\N	\N	\N	12224	12224	12225
4117	3247	117	applied	\N	\N	\N	\N	12228	12228	12229
4117	3249	118	applied	\N	\N	\N	\N	12235	12235	12236
4117	3251	119	applied	\N	\N	\N	\N	12243	12243	12244
4117	3252	120	applied	\N	\N	\N	\N	12245	12245	12246
4117	3253	121	applied	\N	\N	\N	\N	12247	12247	12248
4117	3254	122	applied	\N	\N	\N	\N	12249	12249	12250
4117	3255	123	applied	\N	\N	\N	\N	12255	12255	12256
4117	3256	124	applied	\N	\N	\N	\N	12259	12259	12260
4117	3257	125	applied	\N	\N	\N	\N	12262	12262	12263
4118	3274	0	applied	\N	\N	\N	\N	12323	12323	12324
4118	3275	1	applied	\N	\N	\N	\N	12325	12325	12326
4119	3276	0	applied	\N	\N	\N	\N	12329	12329	12330
4119	3277	1	applied	\N	\N	\N	\N	12331	12331	12332
4120	3276	0	applied	\N	\N	\N	\N	12329	12329	12330
4120	3277	1	applied	\N	\N	\N	\N	12331	12331	12332
4121	3278	0	applied	\N	\N	\N	\N	12337	12337	12338
4122	3279	0	applied	\N	\N	\N	\N	12341	12341	12342
4122	3280	1	applied	\N	\N	\N	\N	12343	12343	12344
4123	3281	0	applied	\N	\N	\N	\N	12347	12347	12348
4124	3281	0	applied	\N	\N	\N	\N	12347	12347	12348
4125	3281	0	applied	\N	\N	\N	\N	12347	12347	12348
4126	3282	0	applied	\N	\N	\N	\N	12355	12355	12356
4128	3283	0	applied	\N	\N	\N	\N	12357	12357	12358
4128	3284	1	applied	\N	\N	\N	\N	12359	12359	12360
4129	3283	0	applied	\N	\N	\N	\N	12357	12357	12358
4129	3284	1	applied	\N	\N	\N	\N	12359	12359	12360
4130	3285	0	applied	\N	\N	\N	\N	12364	12364	12365
4130	3286	1	applied	\N	\N	\N	\N	12366	12366	12367
4131	3287	0	applied	\N	\N	\N	\N	12368	12368	12369
4132	3288	0	applied	\N	\N	\N	\N	12372	12372	12373
4133	3288	0	applied	\N	\N	\N	\N	12372	12372	12373
4134	3289	0	applied	\N	\N	\N	\N	12376	12376	12377
4135	3289	0	applied	\N	\N	\N	\N	12376	12376	12377
4136	3289	0	applied	\N	\N	\N	\N	12376	12376	12377
4137	3290	0	applied	\N	\N	\N	\N	12382	12382	12383
4138	3291	0	applied	\N	\N	1000000000	\N	12385	12385	12386
4138	3292	1	applied	\N	\N	1000000000	\N	12387	12387	12388
4138	3293	2	applied	\N	\N	1000000000	\N	12389	12389	12390
4138	3294	3	applied	\N	\N	1000000000	\N	12391	12391	12392
4138	3295	4	applied	\N	\N	1000000000	\N	12393	12393	12394
4138	3296	5	applied	\N	\N	1000000000	\N	12395	12395	12396
4138	3297	6	applied	\N	\N	\N	\N	12397	12397	12398
4138	3298	7	applied	\N	\N	\N	\N	12399	12399	12400
4138	3299	8	applied	\N	\N	\N	\N	12401	12401	12402
4139	3291	0	applied	\N	\N	1000000000	\N	12385	12385	12386
4139	3292	1	applied	\N	\N	1000000000	\N	12387	12387	12388
4139	3293	2	applied	\N	\N	1000000000	\N	12389	12389	12390
4139	3294	3	applied	\N	\N	1000000000	\N	12391	12391	12392
4139	3295	4	applied	\N	\N	1000000000	\N	12393	12393	12394
4139	3296	5	applied	\N	\N	1000000000	\N	12395	12395	12396
4139	3297	6	applied	\N	\N	\N	\N	12397	12397	12398
4139	3298	7	applied	\N	\N	\N	\N	12399	12399	12400
4139	3299	8	applied	\N	\N	\N	\N	12401	12401	12402
4140	3300	0	applied	\N	\N	\N	\N	12406	12406	12407
4140	3301	1	applied	\N	\N	\N	\N	12408	12408	12409
4141	3300	0	applied	\N	\N	\N	\N	12406	12406	12407
4141	3301	1	applied	\N	\N	\N	\N	12408	12408	12409
4142	3302	0	applied	\N	\N	\N	\N	12414	12414	12415
4143	3302	0	applied	\N	\N	\N	\N	12414	12414	12415
4144	3302	0	applied	\N	\N	\N	\N	12414	12414	12415
4145	3303	0	applied	\N	\N	\N	\N	12420	12420	12421
4145	3304	1	applied	\N	\N	\N	\N	12422	12422	12423
4146	3305	0	applied	\N	\N	\N	\N	12426	12426	12427
4147	3306	0	applied	\N	\N	\N	\N	12428	12428	12429
4147	3307	1	applied	\N	\N	\N	\N	12430	12430	12431
4148	3308	0	applied	\N	\N	\N	\N	12432	12432	12433
4149	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4150	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4151	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4152	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4153	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4154	3309	0	applied	\N	\N	\N	\N	12436	12436	12437
4155	3310	0	applied	\N	\N	\N	\N	12450	12450	12451
4156	3311	0	applied	\N	\N	1000000000	\N	12454	12454	12455
4156	3312	1	applied	\N	\N	\N	\N	12456	12456	12457
4157	3311	0	applied	\N	\N	1000000000	\N	12454	12454	12455
4157	3312	1	applied	\N	\N	\N	\N	12456	12456	12457
4158	3313	0	applied	\N	\N	\N	\N	12462	12462	12463
4159	3313	0	applied	\N	\N	\N	\N	12462	12462	12463
4160	3313	0	applied	\N	\N	\N	\N	12462	12462	12463
4161	3314	0	applied	\N	\N	\N	\N	12467	12467	12468
4162	3315	0	applied	\N	\N	\N	\N	12469	12469	12470
4163	3315	0	applied	\N	\N	\N	\N	12469	12469	12470
4164	3316	0	applied	\N	\N	\N	\N	12474	12474	12475
4164	3317	1	applied	\N	\N	\N	\N	12476	12476	12477
4165	3316	0	applied	\N	\N	\N	\N	12474	12474	12475
4165	3317	1	applied	\N	\N	\N	\N	12476	12476	12477
4166	3316	0	applied	\N	\N	\N	\N	12474	12474	12475
4166	3317	1	applied	\N	\N	\N	\N	12476	12476	12477
4167	3318	0	applied	\N	\N	\N	\N	12482	12482	12483
4168	3319	0	applied	\N	\N	\N	\N	12486	12486	12487
4168	3320	1	applied	\N	\N	\N	\N	12488	12488	12489
4168	3321	2	applied	\N	\N	\N	\N	12490	12490	12491
4168	3322	3	applied	\N	\N	\N	\N	12492	12492	12493
4169	3323	0	applied	\N	\N	\N	\N	12496	12496	12497
4170	3324	0	applied	\N	\N	\N	\N	12499	12499	12500
4171	3325	0	applied	\N	\N	\N	\N	12503	12503	12504
4172	3325	0	applied	\N	\N	\N	\N	12503	12503	12504
4173	3326	0	applied	\N	\N	\N	\N	12509	12509	12510
4174	3326	0	applied	\N	\N	\N	\N	12509	12509	12510
4175	3327	0	applied	\N	\N	\N	\N	12515	12515	12516
4176	3328	0	applied	\N	\N	\N	\N	12519	12519	12520
4176	3329	1	applied	\N	\N	\N	\N	12521	12521	12522
4176	3330	2	applied	\N	\N	\N	\N	12523	12523	12524
4177	3328	0	applied	\N	\N	\N	\N	12519	12519	12520
4177	3329	1	applied	\N	\N	\N	\N	12521	12521	12522
4177	3330	2	applied	\N	\N	\N	\N	12523	12523	12524
4178	3331	0	applied	\N	\N	\N	\N	12529	12529	12530
4178	3332	1	applied	\N	\N	\N	\N	12531	12531	12532
4179	3333	0	applied	\N	\N	\N	\N	12534	12534	12535
4179	3334	1	applied	\N	\N	\N	\N	12536	12536	1435
4186	3338	0	applied	\N	\N	\N	\N	12550	12550	12551
4186	3339	1	applied	\N	\N	\N	\N	12552	12552	12553
4186	3337	2	applied	\N	\N	\N	\N	12546	12546	12547
4191	3346	0	applied	\N	\N	\N	\N	12577	12577	12578
4191	3347	1	applied	\N	\N	\N	\N	12579	12579	12580
4194	3348	0	applied	\N	\N	1000000000	\N	12585	12585	12586
4194	3349	1	applied	\N	\N	\N	\N	12587	12587	12588
4194	3350	2	applied	\N	\N	\N	\N	12589	12589	12590
4194	3351	3	applied	\N	\N	\N	\N	12591	12591	12592
4194	3352	4	applied	\N	\N	\N	\N	12593	12593	12594
4194	3353	5	applied	\N	\N	\N	\N	12595	12595	12588
4197	3355	0	applied	\N	\N	\N	\N	12604	12604	12605
4197	3356	1	applied	\N	\N	\N	\N	12606	12606	12607
4202	3361	0	applied	\N	\N	\N	\N	12622	12622	12623
4207	3367	0	applied	\N	\N	\N	\N	12641	12641	12642
4209	3368	0	applied	\N	\N	\N	\N	12643	12643	12644
4216	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4218	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4220	3371	0	applied	\N	\N	\N	\N	12658	12658	12659
4222	3372	0	applied	\N	\N	\N	\N	12662	12662	12663
4228	3384	0	applied	\N	\N	\N	\N	12694	12694	12695
4231	3385	0	applied	\N	\N	\N	\N	12698	12698	12699
4231	3386	1	applied	\N	\N	\N	\N	12700	12700	12701
4231	3387	2	applied	\N	\N	\N	\N	12702	12702	12703
4231	3388	3	applied	\N	\N	\N	\N	12704	12704	12704
4232	3389	0	applied	\N	\N	1000000000	\N	12706	12706	12707
4232	3390	1	applied	\N	\N	\N	\N	12708	12708	12709
4232	3391	2	applied	\N	\N	\N	\N	12710	12710	12711
4232	3392	3	applied	\N	\N	\N	\N	12712	12712	12713
4232	3393	4	applied	\N	\N	\N	\N	12714	12714	12715
4234	3394	0	applied	\N	\N	\N	\N	12720	12720	12721
4236	3394	0	applied	\N	\N	\N	\N	12720	12720	12721
4243	3397	0	applied	\N	\N	\N	\N	12736	12736	12737
4245	3316	0	applied	\N	\N	\N	\N	12474	12474	12475
4245	3375	1	applied	\N	\N	\N	\N	12674	12674	12675
4245	3376	2	applied	\N	\N	\N	\N	12676	12676	12677
4245	3377	3	applied	\N	\N	\N	\N	12678	12678	12679
4245	3378	4	applied	\N	\N	\N	\N	12680	12680	12681
4245	3331	5	applied	\N	\N	\N	\N	12529	12529	12530
4245	3313	6	applied	\N	\N	\N	\N	12462	12462	12463
4245	3314	7	applied	\N	\N	\N	\N	12467	12467	12468
4245	3315	8	applied	\N	\N	\N	\N	12469	12469	12470
4245	3388	9	applied	\N	\N	\N	\N	12704	12704	12704
4245	3317	10	applied	\N	\N	\N	\N	12476	12476	12477
4245	3318	11	applied	\N	\N	\N	\N	12482	12482	12483
4245	3319	12	applied	\N	\N	\N	\N	12486	12486	12487
4245	3320	13	applied	\N	\N	\N	\N	12488	12488	12489
4245	3321	14	applied	\N	\N	\N	\N	12490	12490	12491
4245	3323	15	applied	\N	\N	\N	\N	12496	12496	12497
4245	3324	16	applied	\N	\N	\N	\N	12499	12499	12500
4245	3325	17	applied	\N	\N	\N	\N	12503	12503	12504
4245	3326	18	applied	\N	\N	\N	\N	12509	12509	12510
4245	3327	19	applied	\N	\N	\N	\N	12515	12515	12516
4245	3328	20	applied	\N	\N	\N	\N	12519	12519	12520
4245	3329	21	applied	\N	\N	\N	\N	12521	12521	12522
4245	3330	22	applied	\N	\N	\N	\N	12523	12523	12524
4245	3332	23	applied	\N	\N	\N	\N	12531	12531	12532
4245	3333	24	applied	\N	\N	\N	\N	12534	12534	12535
4245	3335	25	applied	\N	\N	\N	\N	12541	12541	12542
4245	3338	26	applied	\N	\N	\N	\N	12550	12550	12551
4245	3339	27	applied	\N	\N	\N	\N	12552	12552	12553
4245	3342	28	applied	\N	\N	\N	\N	12561	12561	12562
4245	3343	29	applied	\N	\N	\N	\N	12563	12563	12564
4245	3344	30	applied	\N	\N	\N	\N	12569	12569	12570
4245	3346	31	applied	\N	\N	\N	\N	12577	12577	12578
4245	3347	32	applied	\N	\N	\N	\N	12579	12579	12580
4245	3350	33	applied	\N	\N	\N	\N	12589	12589	12590
4245	3351	34	applied	\N	\N	\N	\N	12591	12591	12592
4245	3352	35	applied	\N	\N	\N	\N	12593	12593	12594
4245	3354	36	applied	\N	\N	\N	\N	12600	12600	12601
4245	3355	37	applied	\N	\N	\N	\N	12604	12604	12605
4245	3356	38	applied	\N	\N	\N	\N	12606	12606	12607
4245	3358	39	applied	\N	\N	\N	\N	12613	12613	12614
4245	3359	40	applied	\N	\N	\N	\N	12615	12615	12616
4245	3360	41	applied	\N	\N	\N	\N	12617	12617	12618
4245	3361	42	applied	\N	\N	\N	\N	12622	12622	12623
4245	3363	43	applied	\N	\N	\N	\N	12629	12629	12630
4245	3364	44	applied	\N	\N	\N	\N	12631	12631	12632
4245	3365	45	applied	\N	\N	\N	\N	12633	12633	12634
4245	3366	46	applied	\N	\N	\N	\N	12635	12635	12636
4245	3367	47	applied	\N	\N	\N	\N	12641	12641	12642
4245	3368	48	applied	\N	\N	\N	\N	12643	12643	12644
4245	3369	49	applied	\N	\N	\N	\N	12645	12645	12646
4245	3370	50	applied	\N	\N	\N	\N	12652	12652	12653
4245	3371	51	applied	\N	\N	\N	\N	12658	12658	12659
4245	3372	52	applied	\N	\N	\N	\N	12662	12662	12663
4245	3373	53	applied	\N	\N	\N	\N	12666	12666	12667
4245	3374	54	applied	\N	\N	\N	\N	12668	12668	12669
4245	3379	55	applied	\N	\N	\N	\N	12682	12682	12683
4245	3380	56	applied	\N	\N	\N	\N	12684	12684	12685
4245	3381	57	applied	\N	\N	\N	\N	12686	12686	12687
4245	3382	58	applied	\N	\N	\N	\N	12688	12688	12689
4245	3383	59	applied	\N	\N	\N	\N	12690	12690	12691
4245	3384	60	applied	\N	\N	\N	\N	12694	12694	12695
4245	3385	61	applied	\N	\N	\N	\N	12698	12698	12699
4245	3386	62	applied	\N	\N	\N	\N	12700	12700	12701
4245	3387	63	applied	\N	\N	\N	\N	12702	12702	12703
4245	3390	64	applied	\N	\N	\N	\N	12708	12708	12709
4245	3391	66	applied	\N	\N	\N	\N	12710	12710	12711
4245	3392	67	applied	\N	\N	\N	\N	12712	12712	12713
4245	3393	68	applied	\N	\N	\N	\N	12714	12714	12715
4245	3394	69	applied	\N	\N	\N	\N	12720	12720	12721
4245	3395	70	applied	\N	\N	\N	\N	12724	12724	12725
4245	3396	71	applied	\N	\N	\N	\N	12732	12732	12733
4245	3397	72	applied	\N	\N	\N	\N	12736	12736	12737
4245	3398	73	applied	\N	\N	\N	\N	12743	12743	12744
4245	3334	74	applied	\N	\N	\N	\N	12536	12536	1435
4245	3336	75	applied	\N	\N	\N	\N	12543	12543	7276
4245	3337	76	applied	\N	\N	\N	\N	12546	12546	12547
4245	3349	77	applied	\N	\N	\N	\N	12587	12587	12588
4245	3353	78	applied	\N	\N	\N	\N	12595	12595	12588
4245	3345	79	applied	\N	\N	\N	\N	12571	12571	12572
4245	3322	80	applied	\N	\N	\N	\N	12492	12492	12493
4250	3402	0	applied	\N	\N	\N	\N	12759	12759	12760
4250	3403	1	applied	\N	\N	\N	\N	12761	12761	12762
4256	3410	0	applied	\N	\N	\N	\N	12784	12784	12785
4258	3410	0	applied	\N	\N	\N	\N	12784	12784	12785
4272	3418	0	applied	\N	\N	\N	\N	12822	12822	12823
4180	3296	0	applied	\N	\N	1000000000	\N	12395	12395	12396
4180	3316	1	applied	\N	\N	\N	\N	12474	12474	12475
4180	3331	2	applied	\N	\N	\N	\N	12529	12529	12530
4180	3258	3	applied	\N	\N	\N	\N	12266	12266	12267
4180	3259	4	applied	\N	\N	\N	\N	12268	12268	12269
4180	3260	5	applied	\N	\N	\N	\N	12272	12272	12273
4180	3261	6	applied	\N	\N	\N	\N	12274	12274	12275
4180	3262	7	applied	\N	\N	\N	\N	12279	12279	12280
4180	3264	8	applied	\N	\N	\N	\N	12284	12284	12285
4180	3266	9	applied	\N	\N	\N	\N	12295	12295	12296
4180	3267	10	applied	\N	\N	\N	\N	12299	12299	12300
4180	3268	11	applied	\N	\N	\N	\N	12303	12303	12304
4180	3270	12	applied	\N	\N	\N	\N	12308	12308	12309
4180	3271	13	applied	\N	\N	\N	\N	12310	12310	12311
4180	3273	14	applied	\N	\N	\N	\N	12317	12317	12318
4180	3274	15	applied	\N	\N	\N	\N	12323	12323	12324
4180	3275	16	applied	\N	\N	\N	\N	12325	12325	12326
4180	3276	17	applied	\N	\N	\N	\N	12329	12329	12330
4180	3277	18	applied	\N	\N	\N	\N	12331	12331	12332
4180	3278	19	applied	\N	\N	\N	\N	12337	12337	12338
4180	3279	20	applied	\N	\N	\N	\N	12341	12341	12342
4180	3280	21	applied	\N	\N	\N	\N	12343	12343	12344
4180	3281	22	applied	\N	\N	\N	\N	12347	12347	12348
4180	3282	23	applied	\N	\N	\N	\N	12355	12355	12356
4180	3283	24	applied	\N	\N	\N	\N	12357	12357	12358
4180	3284	25	applied	\N	\N	\N	\N	12359	12359	12360
4180	3285	26	applied	\N	\N	\N	\N	12364	12364	12365
4180	3286	27	applied	\N	\N	\N	\N	12366	12366	12367
4180	3287	28	applied	\N	\N	\N	\N	12368	12368	12369
4180	3288	29	applied	\N	\N	\N	\N	12372	12372	12373
4180	3289	30	applied	\N	\N	\N	\N	12376	12376	12377
4180	3290	31	applied	\N	\N	\N	\N	12382	12382	12383
4180	3297	32	applied	\N	\N	\N	\N	12397	12397	12398
4180	3298	33	applied	\N	\N	\N	\N	12399	12399	12400
4180	3299	34	applied	\N	\N	\N	\N	12401	12401	12402
4180	3300	35	applied	\N	\N	\N	\N	12406	12406	12407
4180	3301	36	applied	\N	\N	\N	\N	12408	12408	12409
4180	3302	37	applied	\N	\N	\N	\N	12414	12414	12415
4180	3303	38	applied	\N	\N	\N	\N	12420	12420	12421
4180	3304	39	applied	\N	\N	\N	\N	12422	12422	12423
4180	3305	40	applied	\N	\N	\N	\N	12426	12426	12427
4180	3306	41	applied	\N	\N	\N	\N	12428	12428	12429
4180	3307	42	applied	\N	\N	\N	\N	12430	12430	12431
4180	3308	43	applied	\N	\N	\N	\N	12432	12432	12433
4180	3309	44	applied	\N	\N	\N	\N	12436	12436	12437
4180	3310	45	applied	\N	\N	\N	\N	12450	12450	12451
4180	3312	46	applied	\N	\N	\N	\N	12456	12456	12457
4180	3313	47	applied	\N	\N	\N	\N	12462	12462	12463
4180	3314	48	applied	\N	\N	\N	\N	12467	12467	12468
4180	3315	49	applied	\N	\N	\N	\N	12469	12469	12470
4180	3317	50	applied	\N	\N	\N	\N	12476	12476	12477
4180	3318	51	applied	\N	\N	\N	\N	12482	12482	12483
4180	3319	52	applied	\N	\N	\N	\N	12486	12486	12487
4180	3320	53	applied	\N	\N	\N	\N	12488	12488	12489
4180	3321	54	applied	\N	\N	\N	\N	12490	12490	12491
4180	3323	55	applied	\N	\N	\N	\N	12496	12496	12497
4180	3324	56	applied	\N	\N	\N	\N	12499	12499	12500
4180	3325	57	applied	\N	\N	\N	\N	12503	12503	12504
4180	3326	58	applied	\N	\N	\N	\N	12509	12509	12510
4180	3327	59	applied	\N	\N	\N	\N	12515	12515	12516
4180	3328	60	applied	\N	\N	\N	\N	12519	12519	12520
4180	3329	61	applied	\N	\N	\N	\N	12521	12521	12522
4180	3330	62	applied	\N	\N	\N	\N	12523	12523	12524
4180	3332	63	applied	\N	\N	\N	\N	12531	12531	12532
4180	3333	64	applied	\N	\N	\N	\N	12534	12534	12535
4180	3143	65	applied	\N	\N	\N	\N	11831	11831	11832
4180	3226	66	applied	\N	\N	\N	\N	12140	12140	12141
4180	3145	67	applied	\N	\N	\N	\N	11837	11837	1254
4180	3334	68	applied	\N	\N	\N	\N	12536	12536	1435
4180	3146	69	applied	\N	\N	\N	\N	11838	11838	1254
4180	3269	70	applied	\N	\N	1000000000	\N	12305	12305	12306
4180	3147	71	applied	\N	\N	\N	\N	11895	11895	1254
4180	3322	72	applied	\N	\N	\N	\N	12492	12492	12493
4180	3148	73	applied	\N	\N	\N	\N	11840	11840	1254
4184	3265	0	applied	\N	\N	\N	\N	12294	12294	10977
4184	3272	1	applied	\N	\N	\N	\N	12316	12316	1435
4184	3296	2	applied	\N	\N	1000000000	\N	12395	12395	12396
4184	3316	3	applied	\N	\N	\N	\N	12474	12474	12475
4184	3331	4	applied	\N	\N	\N	\N	12529	12529	12530
4184	3334	5	applied	\N	\N	\N	\N	12536	12536	1435
4184	3269	6	applied	\N	\N	1000000000	\N	12305	12305	12306
4184	3336	7	applied	\N	\N	\N	\N	12543	12543	7276
4184	3337	8	applied	\N	\N	\N	\N	12546	12546	12547
4184	3322	9	applied	\N	\N	\N	\N	12492	12492	12493
4187	3340	0	applied	\N	\N	1000000000	\N	12557	12557	12558
4187	3341	1	applied	\N	\N	1000000000	\N	12559	12559	12560
4187	3342	2	applied	\N	\N	\N	\N	12561	12561	12562
4187	3343	3	applied	\N	\N	\N	\N	12563	12563	12564
4189	3344	0	applied	\N	\N	\N	\N	12569	12569	12570
4189	3345	1	applied	\N	\N	\N	\N	12571	12571	12572
4195	3354	0	applied	\N	\N	\N	\N	12600	12600	12601
4198	3357	0	applied	\N	\N	1000000000	\N	12611	12611	12612
4198	3358	1	applied	\N	\N	\N	\N	12613	12613	12614
4198	3359	2	applied	\N	\N	\N	\N	12615	12615	12616
4198	3360	3	applied	\N	\N	\N	\N	12617	12617	12618
4200	3361	0	applied	\N	\N	\N	\N	12622	12622	12623
4203	3361	0	applied	\N	\N	\N	\N	12622	12622	12623
4205	3362	0	applied	\N	\N	1000000000	\N	12627	12627	12628
4205	3363	1	applied	\N	\N	\N	\N	12629	12629	12630
4205	3364	2	applied	\N	\N	\N	\N	12631	12631	12632
4205	3365	3	applied	\N	\N	\N	\N	12633	12633	12634
4205	3366	4	applied	\N	\N	\N	\N	12635	12635	12636
4210	3369	0	applied	\N	\N	\N	\N	12645	12645	12646
4212	3369	0	applied	\N	\N	\N	\N	12645	12645	12646
4214	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4223	3373	0	applied	\N	\N	\N	\N	12666	12666	12667
4223	3374	1	applied	\N	\N	\N	\N	12668	12668	12669
4225	3373	0	applied	\N	\N	\N	\N	12666	12666	12667
4225	3374	1	applied	\N	\N	\N	\N	12668	12668	12669
4229	3384	0	applied	\N	\N	\N	\N	12694	12694	12695
4237	3395	0	applied	\N	\N	\N	\N	12724	12724	12725
4239	3395	0	applied	\N	\N	\N	\N	12724	12724	12725
4241	3395	0	applied	\N	\N	\N	\N	12724	12724	12725
4246	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4246	3398	1	applied	\N	\N	\N	\N	12743	12743	12744
4246	3400	2	applied	\N	\N	\N	\N	12749	12749	12750
4246	3401	3	applied	\N	\N	\N	\N	12751	12751	12752
4248	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4248	3398	1	applied	\N	\N	\N	\N	12743	12743	12744
4182	3335	0	applied	\N	\N	\N	\N	12541	12541	12542
4185	3338	0	applied	\N	\N	\N	\N	12550	12550	12551
4185	3339	1	applied	\N	\N	\N	\N	12552	12552	12553
4185	3337	2	applied	\N	\N	\N	\N	12546	12546	12547
4192	3346	0	applied	\N	\N	\N	\N	12577	12577	12578
4192	3347	1	applied	\N	\N	\N	\N	12579	12579	12580
4193	3348	0	applied	\N	\N	1000000000	\N	12585	12585	12586
4193	3349	1	applied	\N	\N	\N	\N	12587	12587	12588
4193	3350	2	applied	\N	\N	\N	\N	12589	12589	12590
4193	3351	3	applied	\N	\N	\N	\N	12591	12591	12592
4193	3352	4	applied	\N	\N	\N	\N	12593	12593	12594
4193	3353	5	applied	\N	\N	\N	\N	12595	12595	12588
4199	3357	0	applied	\N	\N	1000000000	\N	12611	12611	12612
4199	3358	1	applied	\N	\N	\N	\N	12613	12613	12614
4199	3359	2	applied	\N	\N	\N	\N	12615	12615	12616
4199	3360	3	applied	\N	\N	\N	\N	12617	12617	12618
4201	3361	0	applied	\N	\N	\N	\N	12622	12622	12623
4208	3368	0	applied	\N	\N	\N	\N	12643	12643	12644
4217	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4219	3371	0	applied	\N	\N	\N	\N	12658	12658	12659
4221	3371	0	applied	\N	\N	\N	\N	12658	12658	12659
4226	3349	0	applied	\N	\N	\N	\N	12587	12587	12588
4226	3353	1	applied	\N	\N	\N	\N	12595	12595	12588
4226	3345	2	applied	\N	\N	\N	\N	12571	12571	12572
4227	3375	0	applied	\N	\N	\N	\N	12674	12674	12675
4227	3376	1	applied	\N	\N	\N	\N	12676	12676	12677
4227	3377	2	applied	\N	\N	\N	\N	12678	12678	12679
4227	3378	3	applied	\N	\N	\N	\N	12680	12680	12681
4227	3379	4	applied	\N	\N	\N	\N	12682	12682	12683
4227	3380	5	applied	\N	\N	\N	\N	12684	12684	12685
4227	3381	6	applied	\N	\N	\N	\N	12686	12686	12687
4227	3382	7	applied	\N	\N	\N	\N	12688	12688	12689
4227	3383	8	applied	\N	\N	\N	\N	12690	12690	12691
4233	3389	0	applied	\N	\N	1000000000	\N	12706	12706	12707
4233	3390	1	applied	\N	\N	\N	\N	12708	12708	12709
4233	3391	2	applied	\N	\N	\N	\N	12710	12710	12711
4233	3392	3	applied	\N	\N	\N	\N	12712	12712	12713
4233	3393	4	applied	\N	\N	\N	\N	12714	12714	12715
4235	3394	0	applied	\N	\N	\N	\N	12720	12720	12721
4244	3397	0	applied	\N	\N	\N	\N	12736	12736	12737
4247	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4247	3398	1	applied	\N	\N	\N	\N	12743	12743	12744
4247	3400	2	applied	\N	\N	\N	\N	12749	12749	12750
4247	3401	3	applied	\N	\N	\N	\N	12751	12751	12752
4252	3405	0	applied	\N	\N	\N	\N	12767	12767	12768
4252	3406	1	applied	\N	\N	\N	\N	12769	12769	12770
4254	3405	0	applied	\N	\N	\N	\N	12767	12767	12768
4254	3406	1	applied	\N	\N	\N	\N	12769	12769	12770
4268	3414	0	applied	\N	\N	\N	\N	12807	12807	12808
4273	3419	0	applied	\N	\N	1000000000	\N	12825	12825	12826
4273	3420	1	applied	\N	\N	\N	\N	12827	12827	12828
4275	3419	0	applied	\N	\N	1000000000	\N	12825	12825	12826
4275	3420	1	applied	\N	\N	\N	\N	12827	12827	12828
4280	3423	0	applied	\N	\N	\N	\N	12845	12845	12846
4292	3432	0	applied	\N	\N	\N	\N	12880	12880	12881
4297	3436	0	applied	\N	\N	\N	\N	12896	12896	12897
4304	3439	0	applied	\N	\N	\N	\N	12906	12906	12907
4309	3445	0	applied	\N	\N	\N	\N	12928	12928	12929
4323	3453	0	applied	\N	\N	\N	\N	12962	12962	12963
4323	3454	1	applied	\N	\N	\N	\N	12964	12964	12965
4326	3457	0	applied	\N	\N	\N	\N	12974	12974	12975
4328	3458	0	applied	\N	\N	\N	\N	12978	12978	12979
4338	3464	0	applied	\N	\N	\N	\N	13003	13003	13004
4338	3465	1	applied	\N	\N	\N	\N	13005	13005	13006
4338	3466	2	applied	\N	\N	\N	\N	13007	13007	13008
4341	3467	0	applied	\N	\N	\N	\N	13011	13011	13012
4358	3482	0	applied	\N	\N	\N	\N	13068	13068	13069
4360	3483	0	applied	\N	\N	1000000000	\N	13071	13071	13072
4360	3484	1	applied	\N	\N	\N	\N	13073	13073	13074
4363	3487	0	applied	\N	\N	\N	\N	13084	13084	13085
4363	3488	1	applied	\N	\N	\N	\N	13086	13086	13087
4368	3490	0	applied	\N	\N	\N	\N	13100	13100	13101
4368	3491	1	applied	\N	\N	\N	\N	13102	13102	13103
4368	3492	2	applied	\N	\N	\N	\N	13104	13104	13105
4368	3493	3	applied	\N	\N	\N	\N	13106	13106	13107
4368	3494	4	applied	\N	\N	\N	\N	13108	13108	13109
4375	3498	0	applied	\N	\N	\N	\N	13128	13128	13129
4377	3498	0	applied	\N	\N	\N	\N	13128	13128	13129
4380	3501	0	applied	\N	\N	\N	\N	13137	13137	13138
4382	3502	0	applied	\N	\N	\N	\N	13141	13141	13142
4384	3502	0	applied	\N	\N	\N	\N	13141	13141	13142
4389	3506	0	applied	\N	\N	\N	\N	13213	13213	13214
4389	3507	1	applied	\N	\N	\N	\N	13215	13215	13216
4389	3508	2	applied	\N	\N	\N	\N	13217	13217	13218
4391	3509	0	applied	\N	\N	\N	\N	13223	13223	13224
4391	3510	1	applied	\N	\N	\N	\N	13225	13225	13226
4391	3511	2	applied	\N	\N	\N	\N	13227	13227	13228
4391	3512	3	applied	\N	\N	\N	\N	13229	13229	13230
4398	3536	0	applied	\N	\N	\N	\N	13290	13290	13291
4398	3537	1	applied	\N	\N	\N	\N	13292	13292	13293
4398	3538	2	applied	\N	\N	\N	\N	13294	13294	13295
4398	3539	3	applied	\N	\N	\N	\N	13296	13296	13297
4398	3540	4	applied	\N	\N	\N	\N	13298	13298	13299
4398	3541	5	applied	\N	\N	\N	\N	13300	13300	13301
4398	3542	6	applied	\N	\N	\N	\N	13302	13302	13303
4398	3543	7	applied	\N	\N	\N	\N	13304	13304	13305
4398	3544	8	applied	\N	\N	\N	\N	13306	13306	13307
4398	3545	9	applied	\N	\N	\N	\N	13308	13308	13309
4402	3546	0	applied	\N	\N	\N	\N	13315	13315	13316
4402	3547	1	applied	\N	\N	\N	\N	13317	13317	13318
4402	3548	2	applied	\N	\N	\N	\N	13319	13319	13320
4402	3549	3	applied	\N	\N	\N	\N	13321	13321	13322
4402	3550	4	applied	\N	\N	\N	\N	13323	13323	13324
4402	3551	5	applied	\N	\N	\N	\N	13325	13325	13326
4402	3552	6	applied	\N	\N	\N	\N	13327	13327	13328
4402	3553	7	applied	\N	\N	\N	\N	13329	13329	13330
4402	3554	8	applied	\N	\N	\N	\N	13331	13331	13332
4402	3555	9	applied	\N	\N	\N	\N	13333	13333	13334
4183	3336	0	applied	\N	\N	\N	\N	12543	12543	7276
4188	3340	0	applied	\N	\N	1000000000	\N	12557	12557	12558
4188	3341	1	applied	\N	\N	1000000000	\N	12559	12559	12560
4188	3342	2	applied	\N	\N	\N	\N	12561	12561	12562
4188	3343	3	applied	\N	\N	\N	\N	12563	12563	12564
4190	3344	0	applied	\N	\N	\N	\N	12569	12569	12570
4190	3345	1	applied	\N	\N	\N	\N	12571	12571	12572
4196	3355	0	applied	\N	\N	\N	\N	12604	12604	12605
4196	3356	1	applied	\N	\N	\N	\N	12606	12606	12607
4204	3362	0	applied	\N	\N	1000000000	\N	12627	12627	12628
4204	3363	1	applied	\N	\N	\N	\N	12629	12629	12630
4204	3364	2	applied	\N	\N	\N	\N	12631	12631	12632
4204	3365	3	applied	\N	\N	\N	\N	12633	12633	12634
4204	3366	4	applied	\N	\N	\N	\N	12635	12635	12636
4206	3363	0	applied	\N	\N	\N	\N	12629	12629	12630
4206	3364	1	applied	\N	\N	\N	\N	12631	12631	12632
4211	3369	0	applied	\N	\N	\N	\N	12645	12645	12646
4213	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4215	3370	0	applied	\N	\N	\N	\N	12652	12652	12653
4224	3373	0	applied	\N	\N	\N	\N	12666	12666	12667
4224	3374	1	applied	\N	\N	\N	\N	12668	12668	12669
4230	3384	0	applied	\N	\N	\N	\N	12694	12694	12695
4238	3375	0	applied	\N	\N	\N	\N	12674	12674	12675
4238	3376	1	applied	\N	\N	\N	\N	12676	12676	12677
4238	3377	2	applied	\N	\N	\N	\N	12678	12678	12679
4238	3378	3	applied	\N	\N	\N	\N	12680	12680	12681
4238	3388	4	applied	\N	\N	\N	\N	12704	12704	12704
4240	3395	0	applied	\N	\N	\N	\N	12724	12724	12725
4242	3396	0	applied	\N	\N	\N	\N	12732	12732	12733
4249	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4249	3398	1	applied	\N	\N	\N	\N	12743	12743	12744
4249	3400	2	applied	\N	\N	\N	\N	12749	12749	12750
4249	3401	3	applied	\N	\N	\N	\N	12751	12751	12752
4253	3405	0	applied	\N	\N	\N	\N	12767	12767	12768
4253	3406	1	applied	\N	\N	\N	\N	12769	12769	12770
4255	3407	0	applied	\N	\N	\N	\N	12777	12777	12778
4255	3408	1	applied	\N	\N	\N	\N	12779	12779	12780
4255	3409	2	applied	\N	\N	\N	\N	12781	12781	12782
4260	3411	0	applied	\N	\N	\N	\N	12790	12790	12791
4262	3411	0	applied	\N	\N	\N	\N	12790	12790	12791
4262	3412	2	applied	\N	\N	\N	\N	12793	12793	12794
4264	3412	0	applied	\N	\N	\N	\N	12793	12793	12794
4264	3413	1	applied	\N	\N	\N	\N	12802	12802	12803
4266	3413	0	applied	\N	\N	\N	\N	12802	12802	12803
4269	3414	0	applied	\N	\N	\N	\N	12807	12807	12808
4271	3417	0	applied	\N	\N	\N	\N	12819	12819	12820
4274	3419	0	applied	\N	\N	1000000000	\N	12825	12825	12826
4274	3420	1	applied	\N	\N	\N	\N	12827	12827	12828
4276	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4276	3375	1	applied	\N	\N	\N	\N	12674	12674	12675
4276	3376	2	applied	\N	\N	\N	\N	12676	12676	12677
4276	3377	3	applied	\N	\N	\N	\N	12678	12678	12679
4276	3378	4	applied	\N	\N	\N	\N	12680	12680	12681
4276	3388	5	applied	\N	\N	\N	\N	12704	12704	12704
4276	3335	6	applied	\N	\N	\N	\N	12541	12541	12542
4276	3338	7	applied	\N	\N	\N	\N	12550	12550	12551
4276	3339	8	applied	\N	\N	\N	\N	12552	12552	12553
4276	3342	9	applied	\N	\N	\N	\N	12561	12561	12562
4276	3343	10	applied	\N	\N	\N	\N	12563	12563	12564
4276	3344	11	applied	\N	\N	\N	\N	12569	12569	12570
4276	3346	12	applied	\N	\N	\N	\N	12577	12577	12578
4276	3347	13	applied	\N	\N	\N	\N	12579	12579	12580
4276	3350	14	applied	\N	\N	\N	\N	12589	12589	12590
4276	3351	15	applied	\N	\N	\N	\N	12591	12591	12592
4276	3352	16	applied	\N	\N	\N	\N	12593	12593	12594
4276	3354	17	applied	\N	\N	\N	\N	12600	12600	12601
4276	3355	18	applied	\N	\N	\N	\N	12604	12604	12605
4276	3356	19	applied	\N	\N	\N	\N	12606	12606	12607
4276	3358	20	applied	\N	\N	\N	\N	12613	12613	12614
4276	3359	21	applied	\N	\N	\N	\N	12615	12615	12616
4276	3360	22	applied	\N	\N	\N	\N	12617	12617	12618
4276	3361	23	applied	\N	\N	\N	\N	12622	12622	12623
4276	3363	24	applied	\N	\N	\N	\N	12629	12629	12630
4276	3364	25	applied	\N	\N	\N	\N	12631	12631	12632
4276	3365	26	applied	\N	\N	\N	\N	12633	12633	12634
4276	3366	27	applied	\N	\N	\N	\N	12635	12635	12636
4276	3367	28	applied	\N	\N	\N	\N	12641	12641	12642
4276	3368	29	applied	\N	\N	\N	\N	12643	12643	12644
4276	3369	30	applied	\N	\N	\N	\N	12645	12645	12646
4276	3370	31	applied	\N	\N	\N	\N	12652	12652	12653
4276	3371	32	applied	\N	\N	\N	\N	12658	12658	12659
4276	3372	33	applied	\N	\N	\N	\N	12662	12662	12663
4276	3373	34	applied	\N	\N	\N	\N	12666	12666	12667
4276	3374	35	applied	\N	\N	\N	\N	12668	12668	12669
4276	3379	36	applied	\N	\N	\N	\N	12682	12682	12683
4276	3380	38	applied	\N	\N	\N	\N	12684	12684	12685
4276	3381	39	applied	\N	\N	\N	\N	12686	12686	12687
4276	3382	40	applied	\N	\N	\N	\N	12688	12688	12689
4276	3383	41	applied	\N	\N	\N	\N	12690	12690	12691
4276	3384	42	applied	\N	\N	\N	\N	12694	12694	12695
4276	3385	43	applied	\N	\N	\N	\N	12698	12698	12699
4276	3386	44	applied	\N	\N	\N	\N	12700	12700	12701
4276	3387	45	applied	\N	\N	\N	\N	12702	12702	12703
4276	3390	46	applied	\N	\N	\N	\N	12708	12708	12709
4276	3391	47	applied	\N	\N	\N	\N	12710	12710	12711
4276	3392	48	applied	\N	\N	\N	\N	12712	12712	12713
4276	3393	49	applied	\N	\N	\N	\N	12714	12714	12715
4276	3394	50	applied	\N	\N	\N	\N	12720	12720	12721
4276	3395	51	applied	\N	\N	\N	\N	12724	12724	12725
4276	3396	52	applied	\N	\N	\N	\N	12732	12732	12733
4276	3397	53	applied	\N	\N	\N	\N	12736	12736	12737
4276	3398	54	applied	\N	\N	\N	\N	12743	12743	12744
4276	3400	55	applied	\N	\N	\N	\N	12749	12749	12750
4276	3401	56	applied	\N	\N	\N	\N	12751	12751	12752
4276	3402	57	applied	\N	\N	\N	\N	12759	12759	12760
4276	3403	58	applied	\N	\N	\N	\N	12761	12761	12762
4276	3404	59	applied	\N	\N	\N	\N	12765	12765	12766
4276	3405	60	applied	\N	\N	\N	\N	12767	12767	12768
4276	3406	61	applied	\N	\N	\N	\N	12769	12769	12770
4276	3407	62	applied	\N	\N	\N	\N	12777	12777	12778
4276	3408	63	applied	\N	\N	\N	\N	12779	12779	12780
4276	3409	64	applied	\N	\N	\N	\N	12781	12781	12782
4276	3410	65	applied	\N	\N	\N	\N	12784	12784	12785
4276	3411	66	applied	\N	\N	\N	\N	12790	12790	12791
4276	3412	67	applied	\N	\N	\N	\N	12793	12793	12794
4276	3413	68	applied	\N	\N	\N	\N	12802	12802	12803
4276	3414	69	applied	\N	\N	\N	\N	12807	12807	12808
4276	3415	70	applied	\N	\N	\N	\N	12813	12813	12814
4276	3416	71	applied	\N	\N	\N	\N	12815	12815	12816
4248	3400	2	applied	\N	\N	\N	\N	12749	12749	12750
4248	3401	3	applied	\N	\N	\N	\N	12751	12751	12752
4251	3404	0	applied	\N	\N	\N	\N	12765	12765	12766
4257	3410	0	applied	\N	\N	\N	\N	12784	12784	12785
4259	3410	0	applied	\N	\N	\N	\N	12784	12784	12785
4261	3412	0	applied	\N	\N	\N	\N	12793	12793	12794
4263	3411	0	applied	\N	\N	\N	\N	12790	12790	12791
4263	3412	2	applied	\N	\N	\N	\N	12793	12793	12794
4265	3413	0	applied	\N	\N	\N	\N	12802	12802	12803
4267	3413	0	applied	\N	\N	\N	\N	12802	12802	12803
4270	3415	0	applied	\N	\N	\N	\N	12813	12813	12814
4270	3416	1	applied	\N	\N	\N	\N	12815	12815	12816
4277	3419	0	applied	\N	\N	1000000000	\N	12825	12825	12826
4277	3420	1	applied	\N	\N	\N	\N	12827	12827	12828
4277	3421	2	applied	\N	\N	\N	\N	12836	12836	12837
4282	3425	0	applied	\N	\N	\N	\N	12852	12852	12853
4285	3426	0	applied	\N	\N	\N	\N	12856	12856	12857
4285	3427	1	applied	\N	\N	\N	\N	12858	12858	12859
4285	3428	2	applied	\N	\N	\N	\N	12860	12860	12861
4287	3426	0	applied	\N	\N	\N	\N	12856	12856	12857
4287	3427	1	applied	\N	\N	\N	\N	12858	12858	12859
4287	3428	2	applied	\N	\N	\N	\N	12860	12860	12861
4289	3429	0	applied	\N	\N	\N	\N	12869	12869	12870
4294	3435	0	applied	\N	\N	\N	\N	12890	12890	12891
4299	3437	0	applied	\N	\N	1000000000	\N	12901	12901	12902
4299	3438	1	applied	\N	\N	\N	\N	12903	12903	12904
4306	3265	0	applied	\N	\N	\N	\N	12294	12294	10977
4306	3399	1	applied	\N	\N	\N	\N	12747	12747	12748
4306	3375	3	applied	\N	\N	\N	\N	12674	12674	12675
4306	3376	4	applied	\N	\N	\N	\N	12676	12676	12677
4306	3263	5	applied	\N	\N	\N	\N	12283	12283	10914
4306	3196	6	applied	\N	\N	\N	\N	12039	12039	12040
4306	3377	7	applied	\N	\N	\N	\N	12678	12678	12679
4306	3378	8	applied	\N	\N	\N	\N	12680	12680	12681
4306	3272	9	applied	\N	\N	\N	\N	12316	12316	1435
4306	3296	10	applied	\N	\N	1000000000	\N	12395	12395	12396
4306	3316	11	applied	\N	\N	\N	\N	12474	12474	12475
4306	3331	12	applied	\N	\N	\N	\N	12529	12529	12530
4306	3069	13	applied	\N	\N	\N	\N	11553	11553	11554
4306	3388	14	applied	\N	\N	\N	\N	12704	12704	12704
4306	3070	15	applied	\N	\N	\N	\N	11557	11557	11558
4306	3071	16	applied	\N	\N	\N	\N	11559	11559	11560
4306	3072	17	applied	\N	\N	\N	\N	11565	11565	11566
4306	3073	18	applied	\N	\N	\N	\N	11569	11569	11570
4306	3074	19	applied	\N	\N	\N	\N	11571	11571	11572
4306	3075	20	applied	\N	\N	\N	\N	11577	11577	11578
4306	3076	21	applied	\N	\N	\N	\N	11581	11581	11582
4306	3077	22	applied	\N	\N	\N	\N	11585	11585	11586
4306	3078	23	applied	\N	\N	\N	\N	11587	11587	11588
4306	3079	24	applied	\N	\N	\N	\N	11589	11589	11590
4306	3080	25	applied	\N	\N	\N	\N	11591	11591	11592
4306	3081	26	applied	\N	\N	\N	\N	11596	11596	11597
4306	3082	27	applied	\N	\N	\N	\N	11600	11600	11601
4306	3083	28	applied	\N	\N	\N	\N	11604	11604	11605
4306	3084	29	applied	\N	\N	\N	\N	11608	11608	11609
4306	3085	30	applied	\N	\N	\N	\N	11610	11610	11611
4306	3086	31	applied	\N	\N	\N	\N	11612	11612	11613
4306	3087	32	applied	\N	\N	\N	\N	11619	11619	11620
4306	3088	33	applied	\N	\N	\N	\N	11623	11623	11624
4306	3089	34	applied	\N	\N	\N	\N	11625	11625	11626
4306	3090	35	applied	\N	\N	\N	\N	11629	11629	11630
4306	3091	36	applied	\N	\N	\N	\N	11633	11633	11634
4306	3092	37	applied	\N	\N	\N	\N	11639	11639	11640
4306	3093	38	applied	\N	\N	\N	\N	11642	11642	11643
4306	3094	39	applied	\N	\N	\N	\N	11644	11644	11645
4306	3095	40	applied	\N	\N	\N	\N	11647	11647	11648
4306	3096	41	applied	\N	\N	\N	\N	11655	11655	11656
4306	3097	42	applied	\N	\N	\N	\N	11659	11659	11660
4306	3098	43	applied	\N	\N	\N	\N	11663	11663	11664
4306	3099	44	applied	\N	\N	\N	\N	11667	11667	11668
4306	3100	45	applied	\N	\N	\N	\N	11669	11669	11670
4306	3101	46	applied	\N	\N	\N	\N	11675	11675	11676
4306	3102	47	applied	\N	\N	\N	\N	11680	11680	11681
4306	3103	48	applied	\N	\N	\N	\N	11682	11682	11683
4306	3104	49	applied	\N	\N	\N	\N	11690	11690	11691
4306	3105	50	applied	\N	\N	\N	\N	11694	11694	11695
4306	3106	51	applied	\N	\N	\N	\N	11696	11696	11697
4306	3107	52	applied	\N	\N	\N	\N	11700	11700	11701
4306	3108	53	applied	\N	\N	\N	\N	11704	11704	11705
4306	3109	54	applied	\N	\N	\N	\N	11709	11709	11710
4306	3110	55	applied	\N	\N	\N	\N	11712	11712	11713
4306	3111	56	applied	\N	\N	\N	\N	11714	11714	11715
4306	3112	57	applied	\N	\N	\N	\N	11716	11716	11717
4306	3113	58	applied	\N	\N	\N	\N	11722	11722	11723
4306	3114	59	applied	\N	\N	\N	\N	11726	11726	11727
4306	3115	60	applied	\N	\N	\N	\N	11728	11728	11729
4306	3116	61	applied	\N	\N	\N	\N	11731	11731	11732
4306	3117	62	applied	\N	\N	\N	\N	11735	11735	11736
4306	3118	63	applied	\N	\N	\N	\N	11737	11737	11738
4306	3119	64	applied	\N	\N	\N	\N	11743	11743	11744
4306	3120	65	applied	\N	\N	\N	\N	11747	11747	11748
4306	3121	66	applied	\N	\N	\N	\N	11749	11749	11750
4306	3122	67	applied	\N	\N	\N	\N	11755	11755	11756
4306	3123	68	applied	\N	\N	\N	\N	11759	11759	11760
4306	3124	69	applied	\N	\N	\N	\N	11761	11761	11762
4306	3125	70	applied	\N	\N	\N	\N	11770	11770	11771
4306	3126	71	applied	\N	\N	\N	\N	11774	11774	11775
4306	3127	72	applied	\N	\N	\N	\N	11776	11776	11777
4306	3128	73	applied	\N	\N	\N	\N	11780	11780	11781
4306	3129	74	applied	\N	\N	\N	\N	11782	11782	11783
4306	3130	75	applied	\N	\N	\N	\N	11787	11787	11788
4306	3131	76	applied	\N	\N	\N	\N	11791	11791	11792
4306	3132	77	applied	\N	\N	\N	\N	11797	11797	11798
4306	3133	78	applied	\N	\N	\N	\N	11801	11801	11802
4306	3134	79	applied	\N	\N	\N	\N	11805	11805	11806
4306	3135	80	applied	\N	\N	\N	\N	11807	11807	11808
4306	3136	81	applied	\N	\N	\N	\N	11811	11811	11812
4306	3137	82	applied	\N	\N	\N	\N	11813	11813	11814
4306	3138	83	applied	\N	\N	\N	\N	11817	11817	11818
4306	3139	84	applied	\N	\N	\N	\N	11820	11820	11821
4306	3140	85	applied	\N	\N	\N	\N	11822	11822	11823
4306	3141	86	applied	\N	\N	\N	\N	11827	11827	11828
4306	3142	87	applied	\N	\N	\N	\N	11829	11829	11830
4306	3144	88	applied	\N	\N	\N	\N	11835	11835	11836
4306	3149	89	applied	\N	\N	\N	\N	11843	11843	11844
4306	3150	90	applied	\N	\N	\N	\N	11847	11847	11848
4306	3151	91	applied	\N	\N	\N	\N	11851	11851	11852
4306	3152	92	applied	\N	\N	\N	\N	11853	11853	11854
4306	3153	93	applied	\N	\N	\N	\N	11855	11855	11856
4276	3417	72	applied	\N	\N	\N	\N	12819	12819	12820
4276	3418	73	applied	\N	\N	\N	\N	12822	12822	12823
4276	3420	74	applied	\N	\N	\N	\N	12827	12827	12828
4276	3336	75	applied	\N	\N	\N	\N	12543	12543	7276
4276	3337	76	applied	\N	\N	\N	\N	12546	12546	12547
4276	3349	77	applied	\N	\N	\N	\N	12587	12587	12588
4276	3353	78	applied	\N	\N	\N	\N	12595	12595	12588
4276	3345	79	applied	\N	\N	\N	\N	12571	12571	12572
4278	3421	0	applied	\N	\N	\N	\N	12836	12836	12837
4278	3422	1	applied	\N	\N	\N	\N	12839	12839	12840
4283	3425	0	applied	\N	\N	\N	\N	12852	12852	12853
4290	3430	0	applied	\N	\N	\N	\N	12873	12873	12874
4293	3433	0	applied	\N	\N	1000000000	\N	12884	12884	12885
4293	3434	1	applied	\N	\N	\N	\N	12886	12886	12887
4295	3435	0	applied	\N	\N	\N	\N	12890	12890	12891
4307	3442	0	applied	\N	\N	\N	\N	12918	12918	12919
4312	3446	0	applied	\N	\N	\N	\N	12932	12932	12933
4312	3447	1	applied	\N	\N	\N	\N	12934	12934	12935
4314	3446	0	applied	\N	\N	\N	\N	12932	12932	12933
4314	3447	1	applied	\N	\N	\N	\N	12934	12934	12935
4317	3451	0	applied	\N	\N	\N	\N	12948	12948	12949
4319	3452	0	applied	\N	\N	\N	\N	12956	12956	12957
4324	3399	0	applied	\N	\N	\N	\N	12747	12747	12748
4324	3444	1	applied	\N	\N	\N	\N	12966	12966	12925
4329	3458	0	applied	\N	\N	\N	\N	12978	12978	12979
4331	3459	0	applied	\N	\N	\N	\N	12984	12984	12985
4333	3460	0	applied	\N	\N	\N	\N	12990	12990	12991
4339	3464	0	applied	\N	\N	\N	\N	13003	13003	13004
4339	3465	1	applied	\N	\N	\N	\N	13005	13005	13006
4339	3466	2	applied	\N	\N	\N	\N	13007	13007	13008
4342	3467	0	applied	\N	\N	\N	\N	13011	13011	13012
4343	3468	0	applied	\N	\N	\N	\N	13018	13018	13019
4345	3248	0	applied	\N	\N	\N	\N	12233	12233	12234
4345	3265	1	applied	\N	\N	\N	\N	12294	12294	10977
4345	3399	2	applied	\N	\N	\N	\N	12747	12747	12748
4345	3375	3	applied	\N	\N	\N	\N	12674	12674	12675
4345	3376	4	applied	\N	\N	\N	\N	12676	12676	12677
4345	3263	5	applied	\N	\N	\N	\N	12283	12283	10914
4345	3377	6	applied	\N	\N	\N	\N	12678	12678	12679
4345	3378	7	applied	\N	\N	\N	\N	12680	12680	12681
4345	3250	8	applied	\N	\N	1000000000	\N	12241	12241	12242
4345	3291	9	applied	\N	\N	1000000000	\N	12385	12385	12386
4345	3292	10	applied	\N	\N	1000000000	\N	12387	12387	12388
4345	3293	11	applied	\N	\N	1000000000	\N	12389	12389	12390
4345	3294	12	applied	\N	\N	1000000000	\N	12391	12391	12392
4345	3295	13	applied	\N	\N	1000000000	\N	12393	12393	12394
4345	3311	14	applied	\N	\N	1000000000	\N	12454	12454	12455
4345	3340	15	applied	\N	\N	1000000000	\N	12557	12557	12558
4345	3341	16	applied	\N	\N	1000000000	\N	12559	12559	12560
4345	3272	17	applied	\N	\N	\N	\N	12316	12316	1435
4345	3296	18	applied	\N	\N	1000000000	\N	12395	12395	12396
4345	3316	19	applied	\N	\N	\N	\N	12474	12474	12475
4345	3348	20	applied	\N	\N	1000000000	\N	12585	12585	12586
4345	3357	21	applied	\N	\N	1000000000	\N	12611	12611	12612
4345	3362	22	applied	\N	\N	1000000000	\N	12627	12627	12628
4345	3389	23	applied	\N	\N	1000000000	\N	12706	12706	12707
4345	3419	24	applied	\N	\N	1000000000	\N	12825	12825	12826
4345	3433	25	applied	\N	\N	1000000000	\N	12884	12884	12885
4345	3437	26	applied	\N	\N	1000000000	\N	12901	12901	12902
4345	3440	27	applied	\N	\N	1000000000	\N	12908	12908	12909
4345	3331	28	applied	\N	\N	\N	\N	12529	12529	12530
4345	3388	29	applied	\N	\N	\N	\N	12704	12704	12704
4345	3444	30	applied	\N	\N	\N	\N	13024	13024	12925
4345	3334	31	applied	\N	\N	\N	\N	12536	12536	1435
4345	3269	32	applied	\N	\N	1000000000	\N	12305	12305	12306
4345	3336	33	applied	\N	\N	\N	\N	12543	12543	7276
4345	3337	34	applied	\N	\N	\N	\N	12546	12546	12547
4345	3349	35	applied	\N	\N	\N	\N	12587	12587	12588
4345	3353	36	applied	\N	\N	\N	\N	12595	12595	12588
4345	3345	37	applied	\N	\N	\N	\N	12571	12571	12572
4345	3322	38	applied	\N	\N	\N	\N	12492	12492	12493
4348	3469	0	applied	\N	\N	\N	\N	13029	13029	13030
4348	3470	1	applied	\N	\N	\N	\N	13031	13031	13032
4348	3471	2	applied	\N	\N	\N	\N	13033	13033	13034
4351	3473	0	applied	\N	\N	\N	\N	13042	13042	13043
4351	3474	1	applied	\N	\N	\N	\N	13044	13044	13045
4351	3475	2	applied	\N	\N	\N	\N	13046	13046	13047
4351	3476	3	applied	\N	\N	\N	\N	13048	13048	13049
4356	3481	0	applied	\N	\N	\N	\N	13062	13062	13063
4361	3485	0	applied	\N	\N	\N	\N	13076	13076	13077
4366	3489	0	applied	\N	\N	\N	\N	13092	13092	13093
4369	3495	0	applied	\N	\N	\N	\N	13112	13112	13113
4371	3496	0	applied	\N	\N	\N	\N	13116	13116	13117
4378	3499	0	applied	\N	\N	\N	\N	13132	13132	13133
4385	3503	0	applied	\N	\N	\N	\N	13148	13148	13149
4385	3504	1	applied	\N	\N	\N	\N	12231	12231	12231
4387	3505	0	applied	\N	\N	\N	\N	13152	13152	13153
4394	3525	0	applied	\N	\N	\N	\N	13260	13260	13261
4394	3526	1	applied	\N	\N	\N	\N	13262	13262	13263
4394	3527	2	applied	\N	\N	\N	\N	13264	13264	13265
4394	3528	3	applied	\N	\N	\N	\N	13266	13266	13267
4394	3529	4	applied	\N	\N	\N	\N	13268	13268	13269
4394	3530	5	applied	\N	\N	\N	\N	13270	13270	13271
4394	3531	7	applied	\N	\N	\N	\N	13273	13273	13274
4394	3532	8	applied	\N	\N	\N	\N	13275	13275	13276
4394	3533	9	applied	\N	\N	\N	\N	13277	13277	13278
4394	3534	10	applied	\N	\N	\N	\N	13279	13279	13280
4394	3535	11	applied	\N	\N	\N	\N	13281	13281	13282
4396	3525	0	applied	\N	\N	\N	\N	13260	13260	13261
4396	3526	1	applied	\N	\N	\N	\N	13262	13262	13263
4396	3527	2	applied	\N	\N	\N	\N	13264	13264	13265
4396	3528	3	applied	\N	\N	\N	\N	13266	13266	13267
4396	3529	4	applied	\N	\N	\N	\N	13268	13268	13269
4396	3530	5	applied	\N	\N	\N	\N	13270	13270	13271
4396	3531	7	applied	\N	\N	\N	\N	13273	13273	13274
4396	3532	8	applied	\N	\N	\N	\N	13275	13275	13276
4396	3533	9	applied	\N	\N	\N	\N	13277	13277	13278
4396	3534	10	applied	\N	\N	\N	\N	13279	13279	13280
4396	3535	11	applied	\N	\N	\N	\N	13281	13281	13282
4401	3546	0	applied	\N	\N	\N	\N	13315	13315	13316
4401	3547	1	applied	\N	\N	\N	\N	13317	13317	13318
4401	3548	2	applied	\N	\N	\N	\N	13319	13319	13320
4401	3549	3	applied	\N	\N	\N	\N	13321	13321	13322
4401	3550	4	applied	\N	\N	\N	\N	13323	13323	13324
4401	3551	5	applied	\N	\N	\N	\N	13325	13325	13326
4401	3552	6	applied	\N	\N	\N	\N	13327	13327	13328
4401	3553	7	applied	\N	\N	\N	\N	13329	13329	13330
4279	3421	0	applied	\N	\N	\N	\N	12836	12836	12837
4279	3422	1	applied	\N	\N	\N	\N	12839	12839	12840
4281	3424	0	applied	\N	\N	\N	\N	12849	12849	12850
4284	3426	0	applied	\N	\N	\N	\N	12856	12856	12857
4284	3427	1	applied	\N	\N	\N	\N	12858	12858	12859
4284	3428	2	applied	\N	\N	\N	\N	12860	12860	12861
4286	3426	0	applied	\N	\N	\N	\N	12856	12856	12857
4286	3427	1	applied	\N	\N	\N	\N	12858	12858	12859
4286	3428	2	applied	\N	\N	\N	\N	12860	12860	12861
4288	3426	0	applied	\N	\N	\N	\N	12856	12856	12857
4288	3427	1	applied	\N	\N	\N	\N	12858	12858	12859
4288	3428	2	applied	\N	\N	\N	\N	12860	12860	12861
4291	3431	0	applied	\N	\N	\N	\N	12877	12877	12878
4296	3436	0	applied	\N	\N	\N	\N	12896	12896	12897
4303	3439	0	applied	\N	\N	\N	\N	12906	12906	12907
4305	3440	0	applied	\N	\N	1000000000	\N	12908	12908	12909
4305	3441	1	applied	\N	\N	\N	\N	12910	12910	12911
4310	3445	0	applied	\N	\N	\N	\N	12928	12928	12929
4315	3448	0	applied	\N	\N	\N	\N	12941	12941	12942
4315	3449	1	applied	\N	\N	\N	\N	12943	12943	12944
4315	3450	2	applied	\N	\N	\N	\N	12945	12945	12946
4322	3452	0	applied	\N	\N	\N	\N	12956	12956	12957
4327	3457	0	applied	\N	\N	\N	\N	12974	12974	12975
4330	3458	0	applied	\N	\N	\N	\N	12978	12978	12979
4332	3459	0	applied	\N	\N	\N	\N	12984	12984	12985
4334	3461	0	applied	\N	\N	\N	\N	12994	12994	12995
4334	3462	1	applied	\N	\N	\N	\N	12996	12996	12997
4346	3468	0	applied	\N	\N	\N	\N	13018	13018	13019
4349	3472	0	applied	\N	\N	\N	\N	13037	13037	13038
4352	3477	0	applied	\N	\N	\N	\N	13051	13051	13052
4354	3478	0	applied	\N	\N	1000000000	\N	13055	13055	13056
4354	3479	1	applied	\N	\N	\N	\N	13057	13057	13058
4357	3481	0	applied	\N	\N	\N	\N	13062	13062	13063
4359	3482	0	applied	\N	\N	\N	\N	13068	13068	13069
4364	3487	0	applied	\N	\N	\N	\N	13084	13084	13085
4364	3488	1	applied	\N	\N	\N	\N	13086	13086	13087
4372	3497	0	applied	\N	\N	\N	\N	13122	13122	13123
4374	3497	0	applied	\N	\N	\N	\N	13122	13122	13123
4376	3498	0	applied	\N	\N	\N	\N	13128	13128	13129
4381	3502	0	applied	\N	\N	\N	\N	13141	13141	13142
4383	3502	0	applied	\N	\N	\N	\N	13141	13141	13142
4388	3433	0	applied	\N	\N	1000000000	\N	12884	12884	12885
4388	3437	1	applied	\N	\N	1000000000	\N	12901	12901	12902
4388	3440	2	applied	\N	\N	1000000000	\N	12908	12908	12909
4388	3478	3	applied	\N	\N	1000000000	\N	13055	13055	13056
4388	3483	4	applied	\N	\N	1000000000	\N	13071	13071	13072
4388	3429	5	applied	\N	\N	\N	\N	12869	12869	12870
4388	3492	6	applied	\N	\N	\N	\N	13104	13104	13156
4388	3430	7	applied	\N	\N	\N	\N	12873	12873	13157
4388	3431	8	applied	\N	\N	\N	\N	12877	12877	13158
4388	3432	9	applied	\N	\N	\N	\N	12880	12880	13159
4388	3434	10	applied	\N	\N	\N	\N	12886	12886	13160
4388	3435	11	applied	\N	\N	\N	\N	12890	12890	13161
4388	3436	12	applied	\N	\N	\N	\N	12896	12896	13162
4388	3438	13	applied	\N	\N	\N	\N	12903	12903	13163
4388	3439	14	applied	\N	\N	\N	\N	12906	12906	13164
4388	3441	15	applied	\N	\N	\N	\N	12910	12910	13165
4388	3442	16	applied	\N	\N	\N	\N	12918	12918	13166
4388	3443	17	applied	\N	\N	\N	\N	12922	12922	13167
4388	3445	18	applied	\N	\N	\N	\N	12928	12928	13168
4388	3446	19	applied	\N	\N	\N	\N	12932	12932	13169
4388	3447	20	applied	\N	\N	\N	\N	12934	12934	13170
4388	3448	21	applied	\N	\N	\N	\N	12941	12941	13171
4388	3493	22	applied	\N	\N	\N	\N	13106	13106	13107
4388	3504	23	applied	\N	\N	\N	\N	12231	12231	12231
4388	3449	24	applied	\N	\N	\N	\N	12943	12943	13172
4388	3450	25	applied	\N	\N	\N	\N	12945	12945	13173
4388	3451	26	applied	\N	\N	\N	\N	12948	12948	13174
4388	3452	27	applied	\N	\N	\N	\N	12956	12956	13175
4388	3453	28	applied	\N	\N	\N	\N	12962	12962	13176
4388	3454	29	applied	\N	\N	\N	\N	12964	12964	13177
4388	3455	30	applied	\N	\N	\N	\N	12969	12969	13178
4388	3456	31	applied	\N	\N	\N	\N	12971	12971	13179
4388	3457	32	applied	\N	\N	\N	\N	12974	12974	13180
4388	3458	33	applied	\N	\N	\N	\N	12978	12978	13181
4388	3459	34	applied	\N	\N	\N	\N	12984	12984	13182
4388	3444	35	applied	\N	\N	\N	\N	12924	12924	12925
4388	3460	36	applied	\N	\N	\N	\N	12990	12990	13183
4388	3461	37	applied	\N	\N	\N	\N	12994	12994	13184
4388	3462	38	applied	\N	\N	\N	\N	12996	12996	13185
4388	3463	39	applied	\N	\N	\N	\N	13000	13000	13186
4388	3464	40	applied	\N	\N	\N	\N	13003	13003	13187
4388	3465	41	applied	\N	\N	\N	\N	13005	13005	13188
4388	3466	42	applied	\N	\N	\N	\N	13007	13007	13189
4388	3467	43	applied	\N	\N	\N	\N	13011	13011	13190
4388	3468	44	applied	\N	\N	\N	\N	13018	13018	13191
4388	3469	45	applied	\N	\N	\N	\N	13029	13029	13192
4388	3470	46	applied	\N	\N	\N	\N	13031	13031	13193
4388	3471	47	applied	\N	\N	\N	\N	13033	13033	13194
4388	3472	48	applied	\N	\N	\N	\N	13037	13037	13195
4388	3473	49	applied	\N	\N	\N	\N	13042	13042	13196
4388	3474	50	applied	\N	\N	\N	\N	13044	13044	13197
4388	3475	51	applied	\N	\N	\N	\N	13046	13046	13198
4388	3476	52	applied	\N	\N	\N	\N	13048	13048	13199
4388	3477	53	applied	\N	\N	\N	\N	13051	13051	13200
4388	3479	54	applied	\N	\N	\N	\N	13057	13057	13201
4388	3480	55	applied	\N	\N	\N	\N	13060	13060	13202
4388	3481	56	applied	\N	\N	\N	\N	13062	13062	13203
4388	3482	57	applied	\N	\N	\N	\N	13068	13068	13204
4388	3484	58	applied	\N	\N	\N	\N	13073	13073	13205
4388	3485	59	applied	\N	\N	\N	\N	13076	13076	13206
4388	3486	60	applied	\N	\N	\N	\N	13080	13080	13207
4388	3487	61	applied	\N	\N	\N	\N	13084	13084	13208
4388	3488	62	applied	\N	\N	\N	\N	13086	13086	13209
4388	3489	63	applied	\N	\N	\N	\N	13092	13092	13210
4388	3490	64	applied	\N	\N	\N	\N	13100	13100	13211
4388	3491	65	applied	\N	\N	\N	\N	13102	13102	13105
4388	3494	66	applied	\N	\N	\N	\N	13108	13108	13109
4388	3495	67	applied	\N	\N	\N	\N	13112	13112	13113
4388	3496	68	applied	\N	\N	\N	\N	13116	13116	13117
4388	3497	69	applied	\N	\N	\N	\N	13122	13122	13123
4388	3498	70	applied	\N	\N	\N	\N	13128	13128	13129
4388	3499	71	applied	\N	\N	\N	\N	13132	13132	13133
4388	3500	72	applied	\N	\N	\N	\N	13134	13134	13135
4388	3501	73	applied	\N	\N	\N	\N	13137	13137	13138
4388	3502	74	applied	\N	\N	\N	\N	13141	13141	13142
4388	3503	75	applied	\N	\N	\N	\N	13148	13148	13149
4388	3505	76	applied	\N	\N	\N	\N	13152	13152	13153
4390	3506	0	applied	\N	\N	\N	\N	13213	13213	13214
4306	3154	94	applied	\N	\N	\N	\N	11859	11859	11860
4306	3155	95	applied	\N	\N	\N	\N	11861	11861	11862
4306	3156	96	applied	\N	\N	\N	\N	11865	11865	11866
4306	3157	97	applied	\N	\N	\N	\N	11869	11869	11870
4306	3158	98	applied	\N	\N	\N	\N	11876	11876	11877
4306	3159	99	applied	\N	\N	\N	\N	11878	11878	11879
4306	3160	100	applied	\N	\N	\N	\N	11881	11881	11882
4306	3161	101	applied	\N	\N	\N	\N	11888	11888	11889
4306	3162	102	applied	\N	\N	\N	\N	11897	11897	11898
4306	3163	103	applied	\N	\N	\N	\N	11899	11899	11900
4306	3164	104	applied	\N	\N	\N	\N	11903	11903	11904
4306	3165	105	applied	\N	\N	\N	\N	11907	11907	11908
4306	3166	106	applied	\N	\N	\N	\N	11913	11913	11914
4306	3167	107	applied	\N	\N	\N	\N	11923	11923	11924
4306	3168	108	applied	\N	\N	\N	\N	11929	11929	11930
4306	3169	109	applied	\N	\N	\N	\N	11931	11931	11932
4306	3170	110	applied	\N	\N	\N	\N	11934	11934	11935
4306	3171	111	applied	\N	\N	\N	\N	11938	11938	11939
4306	3172	112	applied	\N	\N	\N	\N	11944	11944	11945
4306	3173	113	applied	\N	\N	\N	\N	11946	11946	11947
4306	3174	114	applied	\N	\N	\N	\N	11951	11951	11952
4306	3175	115	applied	\N	\N	\N	\N	11955	11955	11956
4306	3176	116	applied	\N	\N	\N	\N	11959	11959	11960
4306	3177	117	applied	\N	\N	\N	\N	11967	11967	11968
4306	3178	118	applied	\N	\N	\N	\N	11971	11971	11972
4306	3179	119	applied	\N	\N	\N	\N	11977	11977	11978
4306	3180	120	applied	\N	\N	\N	\N	11979	11979	11980
4306	3181	121	applied	\N	\N	\N	\N	11982	11982	11983
4306	3182	122	applied	\N	\N	\N	\N	11984	11984	11985
4306	3183	123	applied	\N	\N	\N	\N	11990	11990	11991
4306	3184	124	applied	\N	\N	\N	\N	11995	11995	11996
4306	3185	125	applied	\N	\N	\N	\N	11997	11997	11998
4308	3443	0	applied	\N	\N	\N	\N	12922	12922	12923
4308	3444	1	applied	\N	\N	\N	\N	12924	12924	12925
4313	3446	0	applied	\N	\N	\N	\N	12932	12932	12933
4313	3447	1	applied	\N	\N	\N	\N	12934	12934	12935
4316	3451	0	applied	\N	\N	\N	\N	12948	12948	12949
4318	3451	0	applied	\N	\N	\N	\N	12948	12948	12949
4320	3452	0	applied	\N	\N	\N	\N	12956	12956	12957
4325	3455	0	applied	\N	\N	\N	\N	12969	12969	12970
4325	3456	1	applied	\N	\N	\N	\N	12971	12971	12972
4335	3463	0	applied	\N	\N	\N	\N	13000	13000	13001
4340	3467	0	applied	\N	\N	\N	\N	13011	13011	13012
4344	3468	0	applied	\N	\N	\N	\N	13018	13018	13019
4347	3186	0	applied	\N	\N	\N	\N	12000	12000	12001
4347	3187	1	applied	\N	\N	\N	\N	12004	12004	12005
4347	3188	3	applied	\N	\N	\N	\N	12010	12010	12011
4347	3189	4	applied	\N	\N	\N	\N	12012	12012	12013
4347	3190	5	applied	\N	\N	\N	\N	12020	12020	12021
4347	3191	6	applied	\N	\N	\N	\N	12024	12024	12025
4347	3192	7	applied	\N	\N	\N	\N	12028	12028	12029
4347	3193	8	applied	\N	\N	\N	\N	12030	12030	12031
4347	3194	9	applied	\N	\N	\N	\N	12033	12033	12034
4347	3195	10	applied	\N	\N	\N	\N	12035	12035	12036
4347	3197	11	applied	\N	\N	\N	\N	12041	12041	12042
4347	3198	12	applied	\N	\N	\N	\N	12044	12044	12045
4347	3444	13	applied	\N	\N	\N	\N	12966	12966	12925
4347	3199	14	applied	\N	\N	\N	\N	12047	12047	12048
4347	3200	15	applied	\N	\N	\N	\N	12049	12049	12050
4347	3201	16	applied	\N	\N	\N	\N	12053	12053	12054
4347	3202	17	applied	\N	\N	\N	\N	12059	12059	12060
4347	3203	18	applied	\N	\N	\N	\N	12062	12062	12063
4347	3204	19	applied	\N	\N	\N	\N	12066	12066	12067
4347	3205	20	applied	\N	\N	\N	\N	12068	12068	12069
4347	3206	21	applied	\N	\N	\N	\N	12075	12075	12076
4347	3207	22	applied	\N	\N	\N	\N	12079	12079	12080
4347	3208	23	applied	\N	\N	\N	\N	12083	12083	12084
4347	3209	24	applied	\N	\N	\N	\N	12085	12085	12086
4347	3210	25	applied	\N	\N	\N	\N	12087	12087	12088
4347	3211	26	applied	\N	\N	\N	\N	12092	12092	12093
4347	3212	27	applied	\N	\N	\N	\N	12094	12094	12095
4347	3213	28	applied	\N	\N	\N	\N	12097	12097	12098
4347	3214	29	applied	\N	\N	\N	\N	12101	12101	12102
4347	3215	30	applied	\N	\N	\N	\N	12106	12106	12107
4347	3216	31	applied	\N	\N	\N	\N	12108	12108	12109
4347	3217	32	applied	\N	\N	\N	\N	12110	12110	12111
4347	3218	33	applied	\N	\N	\N	\N	12114	12114	12115
4347	3219	34	applied	\N	\N	\N	\N	12119	12119	12120
4347	3220	35	applied	\N	\N	\N	\N	12123	12123	12124
4347	3221	36	applied	\N	\N	\N	\N	12125	12125	12126
4347	3222	37	applied	\N	\N	\N	\N	12128	12128	12129
4347	3223	38	applied	\N	\N	\N	\N	12130	12130	12131
4347	3224	39	applied	\N	\N	\N	\N	12136	12136	12137
4347	3225	40	applied	\N	\N	\N	\N	12138	12138	12139
4347	3227	41	applied	\N	\N	\N	\N	12144	12144	12145
4347	3228	42	applied	\N	\N	\N	\N	12150	12150	12151
4347	3229	43	applied	\N	\N	\N	\N	12155	12155	12156
4347	3230	44	applied	\N	\N	\N	\N	12159	12159	12160
4347	3231	45	applied	\N	\N	\N	\N	12161	12161	12162
4347	3232	46	applied	\N	\N	\N	\N	12163	12163	12164
4347	3233	47	applied	\N	\N	\N	\N	12168	12168	12169
4347	3234	48	applied	\N	\N	\N	\N	12171	12171	12172
4347	3235	49	applied	\N	\N	\N	\N	12173	12173	12174
4347	3236	50	applied	\N	\N	\N	\N	12177	12177	12178
4347	3237	51	applied	\N	\N	\N	\N	12179	12179	12180
4347	3238	52	applied	\N	\N	\N	\N	12183	12183	12184
4347	3239	53	applied	\N	\N	\N	\N	12189	12189	12190
4347	3240	54	applied	\N	\N	\N	\N	12197	12197	12198
4347	3241	55	applied	\N	\N	\N	\N	12201	12201	12202
4347	3242	56	applied	\N	\N	\N	\N	12205	12205	12206
4347	3243	57	applied	\N	\N	\N	\N	12207	12207	12208
4347	3244	58	applied	\N	\N	\N	\N	12215	12215	12216
4347	3245	59	applied	\N	\N	\N	\N	12220	12220	12221
4347	3246	60	applied	\N	\N	\N	\N	12224	12224	12225
4347	3247	61	applied	\N	\N	\N	\N	12228	12228	12229
4347	3249	62	applied	\N	\N	\N	\N	12235	12235	12236
4347	3251	63	applied	\N	\N	\N	\N	12243	12243	12244
4347	3252	64	applied	\N	\N	\N	\N	12245	12245	12246
4347	3253	65	applied	\N	\N	\N	\N	12247	12247	12248
4347	3254	66	applied	\N	\N	\N	\N	12249	12249	12250
4347	3255	67	applied	\N	\N	\N	\N	12255	12255	12256
4347	3256	68	applied	\N	\N	\N	\N	12259	12259	12260
4347	3257	69	applied	\N	\N	\N	\N	12262	12262	12263
4347	3258	70	applied	\N	\N	\N	\N	12266	12266	12267
4347	3259	71	applied	\N	\N	\N	\N	12268	12268	12269
4347	3260	72	applied	\N	\N	\N	\N	12272	12272	12273
4347	3261	73	applied	\N	\N	\N	\N	12274	12274	12275
4347	3262	74	applied	\N	\N	\N	\N	12279	12279	12280
4347	3264	75	applied	\N	\N	\N	\N	12284	12284	12285
4347	3266	76	applied	\N	\N	\N	\N	12295	12295	12296
4347	3267	77	applied	\N	\N	\N	\N	12299	12299	12300
4347	3268	78	applied	\N	\N	\N	\N	12303	12303	12304
4347	3270	79	applied	\N	\N	\N	\N	12308	12308	12309
4347	3271	80	applied	\N	\N	\N	\N	12310	12310	12311
4347	3273	81	applied	\N	\N	\N	\N	12317	12317	12318
4347	3274	82	applied	\N	\N	\N	\N	12323	12323	12324
4347	3275	83	applied	\N	\N	\N	\N	12325	12325	12326
4347	3276	84	applied	\N	\N	\N	\N	12329	12329	12330
4347	3277	85	applied	\N	\N	\N	\N	12331	12331	12332
4347	3278	86	applied	\N	\N	\N	\N	12337	12337	12338
4347	3279	87	applied	\N	\N	\N	\N	12341	12341	12342
4347	3280	88	applied	\N	\N	\N	\N	12343	12343	12344
4347	3281	89	applied	\N	\N	\N	\N	12347	12347	12348
4347	3282	90	applied	\N	\N	\N	\N	12355	12355	12356
4347	3283	91	applied	\N	\N	\N	\N	12357	12357	12358
4347	3284	92	applied	\N	\N	\N	\N	12359	12359	12360
4347	3285	93	applied	\N	\N	\N	\N	12364	12364	12365
4347	3286	94	applied	\N	\N	\N	\N	12366	12366	12367
4347	3287	95	applied	\N	\N	\N	\N	12368	12368	12369
4347	3288	96	applied	\N	\N	\N	\N	12372	12372	12373
4347	3289	97	applied	\N	\N	\N	\N	12376	12376	12377
4347	3290	98	applied	\N	\N	\N	\N	12382	12382	12383
4347	3297	99	applied	\N	\N	\N	\N	12397	12397	12398
4347	3298	100	applied	\N	\N	\N	\N	12399	12399	12400
4347	3299	101	applied	\N	\N	\N	\N	12401	12401	12402
4347	3300	102	applied	\N	\N	\N	\N	12406	12406	12407
4347	3301	103	applied	\N	\N	\N	\N	12408	12408	12409
4347	3302	104	applied	\N	\N	\N	\N	12414	12414	12415
4347	3303	105	applied	\N	\N	\N	\N	12420	12420	12421
4347	3304	106	applied	\N	\N	\N	\N	12422	12422	12423
4347	3305	107	applied	\N	\N	\N	\N	12426	12426	12427
4347	3306	108	applied	\N	\N	\N	\N	12428	12428	12429
4347	3307	109	applied	\N	\N	\N	\N	12430	12430	12431
4347	3308	110	applied	\N	\N	\N	\N	12432	12432	12433
4347	3309	111	applied	\N	\N	\N	\N	12436	12436	12437
4347	3310	112	applied	\N	\N	\N	\N	12450	12450	12451
4347	3312	113	applied	\N	\N	\N	\N	12456	12456	12457
4347	3313	114	applied	\N	\N	\N	\N	12462	12462	12463
4347	3314	115	applied	\N	\N	\N	\N	12467	12467	12468
4347	3315	116	applied	\N	\N	\N	\N	12469	12469	12470
4347	3317	117	applied	\N	\N	\N	\N	12476	12476	12477
4347	3318	118	applied	\N	\N	\N	\N	12482	12482	12483
4347	3319	119	applied	\N	\N	\N	\N	12486	12486	12487
4347	3320	120	applied	\N	\N	\N	\N	12488	12488	12489
4347	3321	121	applied	\N	\N	\N	\N	12490	12490	12491
4347	3323	122	applied	\N	\N	\N	\N	12496	12496	12497
4347	3324	123	applied	\N	\N	\N	\N	12499	12499	12500
4347	3325	124	applied	\N	\N	\N	\N	12503	12503	12504
4347	3326	125	applied	\N	\N	\N	\N	12509	12509	12510
4353	3477	0	applied	\N	\N	\N	\N	13051	13051	13052
4355	3480	0	applied	\N	\N	\N	\N	13060	13060	13061
4362	3486	0	applied	\N	\N	\N	\N	13080	13080	13081
4365	3489	0	applied	\N	\N	\N	\N	13092	13092	13093
4367	3489	0	applied	\N	\N	\N	\N	13092	13092	13093
4370	3496	0	applied	\N	\N	\N	\N	13116	13116	13117
4379	3500	0	applied	\N	\N	\N	\N	13134	13134	13135
4386	3503	0	applied	\N	\N	\N	\N	13148	13148	13149
4386	3504	1	applied	\N	\N	\N	\N	12231	12231	12231
4393	3513	0	applied	\N	\N	\N	\N	13234	13234	13235
4393	3514	1	applied	\N	\N	\N	\N	13236	13236	13237
4393	3515	2	applied	\N	\N	\N	\N	13238	13238	13239
4393	3516	3	applied	\N	\N	\N	\N	13240	13240	13241
4393	3517	4	applied	\N	\N	\N	\N	13242	13242	13243
4393	3518	5	applied	\N	\N	\N	\N	13244	13244	13245
4393	3519	6	applied	\N	\N	\N	\N	13246	13246	13247
4393	3520	7	applied	\N	\N	\N	\N	13248	13248	13249
4393	3521	8	applied	\N	\N	\N	\N	13250	13250	13251
4393	3522	9	applied	\N	\N	\N	\N	13252	13252	13253
4393	3523	10	applied	\N	\N	\N	\N	13254	13254	13255
4393	3524	11	applied	\N	\N	\N	\N	13256	13256	13257
4400	3546	0	applied	\N	\N	\N	\N	13315	13315	13316
4400	3547	1	applied	\N	\N	\N	\N	13317	13317	13318
4400	3548	2	applied	\N	\N	\N	\N	13319	13319	13320
4400	3549	3	applied	\N	\N	\N	\N	13321	13321	13322
4400	3550	4	applied	\N	\N	\N	\N	13323	13323	13324
4400	3551	5	applied	\N	\N	\N	\N	13325	13325	13326
4400	3552	6	applied	\N	\N	\N	\N	13327	13327	13328
4400	3553	7	applied	\N	\N	\N	\N	13329	13329	13330
4400	3554	8	applied	\N	\N	\N	\N	13331	13331	13332
4400	3555	9	applied	\N	\N	\N	\N	13333	13333	13334
4404	3556	0	applied	\N	\N	\N	\N	13339	13339	13340
4404	3557	1	applied	\N	\N	\N	\N	13341	13341	13342
4404	3558	2	applied	\N	\N	\N	\N	13343	13343	13344
4404	3559	3	applied	\N	\N	\N	\N	13345	13345	13346
4404	3560	4	applied	\N	\N	\N	\N	13347	13347	13348
4404	3561	5	applied	\N	\N	\N	\N	13349	13349	13350
4404	3562	6	applied	\N	\N	\N	\N	13351	13351	13352
4404	3563	7	applied	\N	\N	\N	\N	13353	13353	13354
4404	3564	8	applied	\N	\N	\N	\N	13355	13355	13356
4404	3565	9	applied	\N	\N	\N	\N	13357	13357	13358
4390	3507	1	applied	\N	\N	\N	\N	13215	13215	13216
4390	3508	2	applied	\N	\N	\N	\N	13217	13217	13218
4392	3506	0	applied	\N	\N	\N	\N	13213	13213	13214
4392	3507	1	applied	\N	\N	\N	\N	13215	13215	13216
4392	3509	2	applied	\N	\N	\N	\N	13223	13223	13224
4392	3510	3	applied	\N	\N	\N	\N	13225	13225	13226
4392	3505	4	applied	\N	\N	\N	\N	13152	13152	13153
4392	3508	5	applied	\N	\N	\N	\N	13217	13217	13218
4392	3511	6	applied	\N	\N	\N	\N	13227	13227	13228
4392	3512	7	applied	\N	\N	\N	\N	13229	13229	13230
4395	3525	0	applied	\N	\N	\N	\N	13260	13260	13261
4395	3526	1	applied	\N	\N	\N	\N	13262	13262	13263
4395	3527	2	applied	\N	\N	\N	\N	13264	13264	13265
4395	3528	3	applied	\N	\N	\N	\N	13266	13266	13267
4395	3529	4	applied	\N	\N	\N	\N	13268	13268	13269
4397	3536	0	applied	\N	\N	\N	\N	13290	13290	13291
4397	3537	1	applied	\N	\N	\N	\N	13292	13292	13293
4397	3538	2	applied	\N	\N	\N	\N	13294	13294	13295
4397	3539	3	applied	\N	\N	\N	\N	13296	13296	13297
4397	3540	4	applied	\N	\N	\N	\N	13298	13298	13299
4397	3541	5	applied	\N	\N	\N	\N	13300	13300	13301
4397	3542	6	applied	\N	\N	\N	\N	13302	13302	13303
4397	3543	7	applied	\N	\N	\N	\N	13304	13304	13305
4397	3544	8	applied	\N	\N	\N	\N	13306	13306	13307
4397	3545	9	applied	\N	\N	\N	\N	13308	13308	13309
4399	3546	0	applied	\N	\N	\N	\N	13315	13315	13316
4399	3547	1	applied	\N	\N	\N	\N	13317	13317	13318
4399	3548	2	applied	\N	\N	\N	\N	13319	13319	13320
4399	3549	3	applied	\N	\N	\N	\N	13321	13321	13322
4399	3550	4	applied	\N	\N	\N	\N	13323	13323	13324
4399	3551	5	applied	\N	\N	\N	\N	13325	13325	13326
4399	3552	6	applied	\N	\N	\N	\N	13327	13327	13328
4399	3553	7	applied	\N	\N	\N	\N	13329	13329	13330
4399	3554	8	applied	\N	\N	\N	\N	13331	13331	13332
4399	3555	9	applied	\N	\N	\N	\N	13333	13333	13334
4401	3554	8	applied	\N	\N	\N	\N	13331	13331	13332
4401	3555	9	applied	\N	\N	\N	\N	13333	13333	13334
4403	3556	0	applied	\N	\N	\N	\N	13339	13339	13340
4403	3557	1	applied	\N	\N	\N	\N	13341	13341	13342
4403	3558	2	applied	\N	\N	\N	\N	13343	13343	13344
4403	3559	3	applied	\N	\N	\N	\N	13345	13345	13346
4403	3560	4	applied	\N	\N	\N	\N	13347	13347	13348
4403	3561	5	applied	\N	\N	\N	\N	13349	13349	13350
4403	3562	6	applied	\N	\N	\N	\N	13351	13351	13352
4403	3563	7	applied	\N	\N	\N	\N	13353	13353	13354
4403	3564	8	applied	\N	\N	\N	\N	13355	13355	13356
4403	3565	9	applied	\N	\N	\N	\N	13357	13357	13358
4405	3566	0	applied	\N	\N	\N	\N	13362	13362	13363
4405	3567	1	applied	\N	\N	\N	\N	13364	13364	13365
4405	3568	2	applied	\N	\N	\N	\N	13366	13366	13367
4405	3569	3	applied	\N	\N	\N	\N	13368	13368	13369
4405	3570	4	applied	\N	\N	\N	\N	13370	13370	13371
4405	3571	5	applied	\N	\N	\N	\N	13372	13372	13373
4405	3572	6	applied	\N	\N	\N	\N	13374	13374	13375
4405	3573	7	applied	\N	\N	\N	\N	13376	13376	13377
4405	3574	8	applied	\N	\N	\N	\N	13378	13378	13379
4406	3566	0	applied	\N	\N	\N	\N	13362	13362	13363
4406	3567	1	applied	\N	\N	\N	\N	13364	13364	13365
4406	3568	2	applied	\N	\N	\N	\N	13366	13366	13367
4406	3569	3	applied	\N	\N	\N	\N	13368	13368	13369
4406	3570	4	applied	\N	\N	\N	\N	13370	13370	13371
4406	3571	5	applied	\N	\N	\N	\N	13372	13372	13373
4406	3572	6	applied	\N	\N	\N	\N	13374	13374	13375
4406	3573	7	applied	\N	\N	\N	\N	13376	13376	13377
4406	3574	8	applied	\N	\N	\N	\N	13378	13378	13379
4407	3419	0	applied	\N	\N	1000000000	\N	12825	12825	12826
4407	3433	1	applied	\N	\N	1000000000	\N	12884	12884	12885
4407	3437	2	applied	\N	\N	1000000000	\N	12901	12901	12902
4407	3440	3	applied	\N	\N	1000000000	\N	12908	12908	12909
4407	3478	4	applied	\N	\N	1000000000	\N	13055	13055	13056
4407	3483	5	applied	\N	\N	1000000000	\N	13071	13071	13072
4407	3414	6	applied	\N	\N	\N	\N	12807	12807	12808
4407	3492	7	applied	\N	\N	\N	\N	13104	13104	13383
4407	3493	8	applied	\N	\N	\N	\N	13106	13106	13107
4407	3415	9	applied	\N	\N	\N	\N	12813	12813	13384
4407	3416	10	applied	\N	\N	\N	\N	12815	12815	13385
4407	3417	11	applied	\N	\N	\N	\N	12819	12819	13386
4407	3418	12	applied	\N	\N	\N	\N	12822	12822	13387
4407	3420	13	applied	\N	\N	\N	\N	12827	12827	13388
4407	3421	14	applied	\N	\N	\N	\N	12836	12836	13389
4407	3422	15	applied	\N	\N	\N	\N	12839	12839	13390
4407	3423	16	applied	\N	\N	\N	\N	12845	12845	13391
4407	3424	17	applied	\N	\N	\N	\N	12849	12849	13392
4407	3504	18	applied	\N	\N	\N	\N	12231	12231	12231
4407	3506	19	applied	\N	\N	\N	\N	13213	13213	13214
4407	3513	20	applied	\N	\N	\N	\N	13234	13234	13235
4407	3514	21	applied	\N	\N	\N	\N	13236	13236	13237
4407	3526	22	applied	\N	\N	\N	\N	13262	13262	13263
4407	3425	23	applied	\N	\N	\N	\N	12852	12852	13393
4407	3426	24	applied	\N	\N	\N	\N	12856	12856	13394
4407	3427	25	applied	\N	\N	\N	\N	12858	12858	13395
4407	3428	26	applied	\N	\N	\N	\N	12860	12860	13396
4407	3429	27	applied	\N	\N	\N	\N	12869	12869	13156
4407	3430	28	applied	\N	\N	\N	\N	12873	12873	13157
4407	3431	29	applied	\N	\N	\N	\N	12877	12877	13158
4407	3432	30	applied	\N	\N	\N	\N	12880	12880	13159
4407	3434	31	applied	\N	\N	\N	\N	12886	12886	13160
4407	3435	32	applied	\N	\N	\N	\N	12890	12890	13161
4407	3436	33	applied	\N	\N	\N	\N	12896	12896	13162
4407	3438	34	applied	\N	\N	\N	\N	12903	12903	13163
4407	3439	35	applied	\N	\N	\N	\N	12906	12906	13164
4407	3441	36	applied	\N	\N	\N	\N	12910	12910	13165
4407	3442	37	applied	\N	\N	\N	\N	12918	12918	13166
4407	3443	38	applied	\N	\N	\N	\N	12922	12922	13167
4407	3445	39	applied	\N	\N	\N	\N	12928	12928	13168
4407	3446	40	applied	\N	\N	\N	\N	12932	12932	13169
4407	3447	41	applied	\N	\N	\N	\N	12934	12934	13170
4407	3448	42	applied	\N	\N	\N	\N	12941	12941	13171
4407	3449	43	applied	\N	\N	\N	\N	12943	12943	13172
4407	3450	44	applied	\N	\N	\N	\N	12945	12945	13173
4407	3451	45	applied	\N	\N	\N	\N	12948	12948	13174
4407	3452	46	applied	\N	\N	\N	\N	12956	12956	13175
4407	3453	47	applied	\N	\N	\N	\N	12962	12962	13176
4407	3454	48	applied	\N	\N	\N	\N	12964	12964	13177
4407	3455	49	applied	\N	\N	\N	\N	12969	12969	13178
4407	3456	50	applied	\N	\N	\N	\N	12971	12971	13179
4407	3457	51	applied	\N	\N	\N	\N	12974	12974	13180
4407	3458	52	applied	\N	\N	\N	\N	12978	12978	13181
4407	3459	53	applied	\N	\N	\N	\N	12984	12984	13182
4407	3444	54	applied	\N	\N	\N	\N	13397	13397	12925
4407	3507	55	applied	\N	\N	\N	\N	13398	13398	13216
4407	3509	56	applied	\N	\N	\N	\N	13399	13399	13224
4407	3510	57	applied	\N	\N	\N	\N	13400	13400	13226
4407	3512	58	applied	\N	\N	\N	\N	13401	13401	13230
4407	3516	59	applied	\N	\N	\N	\N	13402	13402	13241
4407	3517	60	applied	\N	\N	\N	\N	13403	13403	13243
4407	3518	61	applied	\N	\N	\N	\N	13404	13404	13245
4407	3519	62	applied	\N	\N	\N	\N	13405	13405	13247
4407	3520	63	applied	\N	\N	\N	\N	13406	13406	13249
4407	3521	64	applied	\N	\N	\N	\N	13407	13407	13251
4407	3522	65	applied	\N	\N	\N	\N	13408	13408	13253
4407	3523	66	applied	\N	\N	\N	\N	13409	13409	13255
4407	3524	67	applied	\N	\N	\N	\N	13410	13410	13257
4407	3525	68	applied	\N	\N	\N	\N	13411	13411	13261
4407	3527	69	applied	\N	\N	\N	\N	13412	13412	13265
4407	3529	70	applied	\N	\N	\N	\N	13413	13413	13269
4407	3530	71	applied	\N	\N	\N	\N	13414	13414	13271
4407	3531	72	applied	\N	\N	\N	\N	13415	13415	13274
4407	3532	73	applied	\N	\N	\N	\N	13416	13416	13276
4407	3533	74	applied	\N	\N	\N	\N	13417	13417	13278
4407	3534	75	applied	\N	\N	\N	\N	13418	13418	13280
4407	3535	76	applied	\N	\N	\N	\N	13419	13419	13282
4407	3537	77	applied	\N	\N	\N	\N	13420	13420	13293
4407	3538	78	applied	\N	\N	\N	\N	13421	13421	13295
4407	3539	79	applied	\N	\N	\N	\N	13422	13422	13297
4407	3540	80	applied	\N	\N	\N	\N	13423	13423	13299
4407	3541	81	applied	\N	\N	\N	\N	13424	13424	13301
4407	3542	82	applied	\N	\N	\N	\N	13425	13425	13303
4407	3543	83	applied	\N	\N	\N	\N	13426	13426	13305
4407	3544	84	applied	\N	\N	\N	\N	13427	13427	13307
4407	3545	85	applied	\N	\N	\N	\N	13428	13428	13309
4407	3547	86	applied	\N	\N	\N	\N	13429	13429	13318
4407	3548	87	applied	\N	\N	\N	\N	13430	13430	13320
4407	3549	88	applied	\N	\N	\N	\N	13431	13431	13322
4407	3550	89	applied	\N	\N	\N	\N	13432	13432	13324
4407	3551	90	applied	\N	\N	\N	\N	13433	13433	13326
4407	3460	91	applied	\N	\N	\N	\N	12990	12990	13183
4407	3461	92	applied	\N	\N	\N	\N	12994	12994	13184
4407	3462	93	applied	\N	\N	\N	\N	12996	12996	13185
4407	3463	94	applied	\N	\N	\N	\N	13000	13000	13186
4407	3464	95	applied	\N	\N	\N	\N	13003	13003	13187
4407	3465	96	applied	\N	\N	\N	\N	13005	13005	13188
4407	3466	97	applied	\N	\N	\N	\N	13007	13007	13189
4407	3467	98	applied	\N	\N	\N	\N	13011	13011	13190
4407	3468	99	applied	\N	\N	\N	\N	13018	13018	13191
4407	3469	100	applied	\N	\N	\N	\N	13029	13029	13192
4407	3470	101	applied	\N	\N	\N	\N	13031	13031	13193
4407	3471	102	applied	\N	\N	\N	\N	13033	13033	13194
4407	3472	103	applied	\N	\N	\N	\N	13037	13037	13195
4407	3473	104	applied	\N	\N	\N	\N	13042	13042	13196
4407	3474	105	applied	\N	\N	\N	\N	13044	13044	13197
4407	3475	106	applied	\N	\N	\N	\N	13046	13046	13198
4407	3476	107	applied	\N	\N	\N	\N	13048	13048	13199
4407	3477	108	applied	\N	\N	\N	\N	13051	13051	13200
4407	3479	109	applied	\N	\N	\N	\N	13057	13057	13201
4407	3480	110	applied	\N	\N	\N	\N	13060	13060	13202
4407	3481	111	applied	\N	\N	\N	\N	13062	13062	13203
4407	3482	112	applied	\N	\N	\N	\N	13068	13068	13204
4407	3484	113	applied	\N	\N	\N	\N	13073	13073	13205
4407	3485	114	applied	\N	\N	\N	\N	13076	13076	13206
4407	3486	115	applied	\N	\N	\N	\N	13080	13080	13207
4407	3487	116	applied	\N	\N	\N	\N	13084	13084	13208
4407	3488	117	applied	\N	\N	\N	\N	13086	13086	13209
4407	3489	118	applied	\N	\N	\N	\N	13092	13092	13210
4407	3490	119	applied	\N	\N	\N	\N	13100	13100	13211
4407	3491	120	applied	\N	\N	\N	\N	13102	13102	13105
4407	3494	121	applied	\N	\N	\N	\N	13108	13108	13109
4407	3495	123	applied	\N	\N	\N	\N	13112	13112	13113
4407	3496	124	applied	\N	\N	\N	\N	13116	13116	13117
4407	3497	125	applied	\N	\N	\N	\N	13122	13122	13123
4408	3575	0	applied	\N	\N	\N	\N	13437	13437	13438
4408	3576	1	applied	\N	\N	\N	\N	13439	13439	13440
4408	3577	2	applied	\N	\N	\N	\N	13441	13441	13442
4408	3578	3	applied	\N	\N	\N	\N	13443	13443	13444
4408	3579	4	applied	\N	\N	\N	\N	13445	13445	13446
4408	3580	5	applied	\N	\N	\N	\N	13447	13447	13448
4408	3581	6	applied	\N	\N	\N	\N	13449	13449	13450
4408	3582	7	applied	\N	\N	\N	\N	13451	13451	13452
4408	3583	8	applied	\N	\N	\N	\N	13453	13453	13454
4408	3584	9	applied	\N	\N	\N	\N	13455	13455	13456
4409	3585	0	applied	\N	\N	\N	\N	13458	13458	13459
4409	3586	1	applied	\N	\N	\N	\N	13460	13460	13461
4409	3587	2	applied	\N	\N	\N	\N	13462	13462	13463
4409	3588	3	applied	\N	\N	\N	\N	13464	13464	13465
4409	3589	4	applied	\N	\N	\N	\N	13466	13466	13467
4409	3590	5	applied	\N	\N	\N	\N	13468	13468	13469
4409	3591	6	applied	\N	\N	\N	\N	13470	13470	13471
4409	3592	7	applied	\N	\N	\N	\N	13472	13472	13473
4409	3593	8	applied	\N	\N	\N	\N	13474	13474	13475
4409	3594	9	applied	\N	\N	\N	\N	13476	13476	13477
4410	3595	0	applied	\N	\N	\N	\N	13479	13479	13480
4410	3596	1	applied	\N	\N	\N	\N	13481	13481	13482
4410	3597	2	applied	\N	\N	\N	\N	13483	13483	13484
4410	3598	3	applied	\N	\N	\N	\N	13485	13485	13486
4410	3599	4	applied	\N	\N	\N	\N	13487	13487	13488
4410	3600	5	applied	\N	\N	\N	\N	13489	13489	13490
4410	3601	6	applied	\N	\N	\N	\N	13491	13491	13492
4410	3602	7	applied	\N	\N	\N	\N	13493	13493	13494
4410	3603	8	applied	\N	\N	\N	\N	13495	13495	13496
4410	3604	9	applied	\N	\N	\N	\N	13497	13497	13498
4412	3605	0	applied	\N	\N	\N	\N	13499	13499	13500
4412	3606	1	applied	\N	\N	\N	\N	13501	13501	13502
4412	3607	2	applied	\N	\N	\N	\N	13503	13503	13504
4412	3608	3	applied	\N	\N	\N	\N	13505	13505	13506
4412	3609	4	applied	\N	\N	\N	\N	13507	13507	13508
4412	3610	5	applied	\N	\N	\N	\N	13509	13509	13510
4412	3611	6	applied	\N	\N	\N	\N	13511	13511	13512
4412	3612	7	applied	\N	\N	\N	\N	13513	13513	13514
4412	3613	8	applied	\N	\N	\N	\N	13515	13515	13516
4412	3614	9	applied	\N	\N	\N	\N	13517	13517	13518
4413	3615	0	applied	\N	\N	1000000000	\N	13522	13522	13523
4413	3616	1	applied	\N	\N	1000000000	\N	13524	13524	13525
4413	3617	2	applied	\N	\N	1000000000	\N	13526	13526	13527
4413	3618	3	applied	\N	\N	\N	\N	13528	13528	13529
4413	3619	4	applied	\N	\N	\N	\N	13530	13530	13531
4413	3620	5	applied	\N	\N	\N	\N	13532	13532	13533
4413	3621	6	applied	\N	\N	\N	\N	13534	13534	13535
4413	3622	7	applied	\N	\N	\N	\N	13536	13536	13537
4413	3623	8	applied	\N	\N	\N	\N	13538	13538	13539
4413	3624	9	applied	\N	\N	\N	\N	13540	13540	13541
4413	3625	10	applied	\N	\N	\N	\N	13542	13542	13543
4413	3626	11	applied	\N	\N	\N	\N	13544	13544	13545
4413	3627	12	applied	\N	\N	\N	\N	13546	13546	13547
4414	3628	0	applied	\N	\N	\N	\N	13549	13549	13550
4414	3629	1	applied	\N	\N	\N	\N	13551	13551	13552
4414	3630	2	applied	\N	\N	\N	\N	13553	13553	13554
4414	3631	3	applied	\N	\N	\N	\N	13555	13555	13556
4414	3632	4	applied	\N	\N	\N	\N	13557	13557	13558
4414	3633	5	applied	\N	\N	\N	\N	13559	13559	13560
4414	3634	6	applied	\N	\N	\N	\N	13561	13561	13562
4414	3635	7	applied	\N	\N	\N	\N	13563	13563	13564
4414	3636	8	applied	\N	\N	\N	\N	13565	13565	13566
4416	3628	0	applied	\N	\N	\N	\N	13549	13549	13550
4416	3629	1	applied	\N	\N	\N	\N	13551	13551	13552
4416	3630	2	applied	\N	\N	\N	\N	13553	13553	13554
4416	3631	3	applied	\N	\N	\N	\N	13555	13555	13556
4416	3632	4	applied	\N	\N	\N	\N	13557	13557	13558
4416	3633	5	applied	\N	\N	\N	\N	13559	13559	13560
4416	3634	6	applied	\N	\N	\N	\N	13561	13561	13562
4416	3635	7	applied	\N	\N	\N	\N	13563	13563	13564
4416	3636	8	applied	\N	\N	\N	\N	13565	13565	13566
4416	3637	9	applied	\N	\N	\N	\N	13568	13568	13569
4416	3638	11	applied	\N	\N	\N	\N	13571	13571	13572
4416	3639	12	applied	\N	\N	\N	\N	13573	13573	13574
4419	3640	0	applied	\N	\N	\N	\N	13577	13577	13578
4419	3637	1	applied	\N	\N	\N	\N	13568	13568	13569
4419	3638	2	applied	\N	\N	\N	\N	13571	13571	13572
4419	3641	3	applied	\N	\N	\N	\N	13579	13579	13580
4419	3639	4	applied	\N	\N	\N	\N	13573	13573	13574
4419	3642	5	applied	\N	\N	\N	\N	13581	13581	13582
4419	3643	6	applied	\N	\N	\N	\N	13583	13583	7276
4419	3644	7	applied	\N	\N	\N	\N	13584	13584	13584
4419	3645	8	applied	\N	\N	\N	\N	13585	13585	7276
4411	3605	0	applied	\N	\N	\N	\N	13499	13499	13500
4411	3606	1	applied	\N	\N	\N	\N	13501	13501	13502
4411	3607	2	applied	\N	\N	\N	\N	13503	13503	13504
4411	3608	3	applied	\N	\N	\N	\N	13505	13505	13506
4411	3609	4	applied	\N	\N	\N	\N	13507	13507	13508
4411	3610	5	applied	\N	\N	\N	\N	13509	13509	13510
4411	3611	6	applied	\N	\N	\N	\N	13511	13511	13512
4411	3612	7	applied	\N	\N	\N	\N	13513	13513	13514
4411	3613	8	applied	\N	\N	\N	\N	13515	13515	13516
4411	3614	9	applied	\N	\N	\N	\N	13517	13517	13518
4415	3628	0	applied	\N	\N	\N	\N	13549	13549	13550
4415	3629	1	applied	\N	\N	\N	\N	13551	13551	13552
4415	3630	2	applied	\N	\N	\N	\N	13553	13553	13554
4415	3631	3	applied	\N	\N	\N	\N	13555	13555	13556
4415	3632	4	applied	\N	\N	\N	\N	13557	13557	13558
4415	3633	5	applied	\N	\N	\N	\N	13559	13559	13560
4415	3634	6	applied	\N	\N	\N	\N	13561	13561	13562
4415	3635	7	applied	\N	\N	\N	\N	13563	13563	13564
4415	3636	8	applied	\N	\N	\N	\N	13565	13565	13566
4415	3637	9	applied	\N	\N	\N	\N	13568	13568	13569
4415	3638	11	applied	\N	\N	\N	\N	13571	13571	13572
4415	3639	12	applied	\N	\N	\N	\N	13573	13573	13574
4417	3640	0	applied	\N	\N	\N	\N	13577	13577	13578
4417	3637	1	applied	\N	\N	\N	\N	13568	13568	13569
4417	3638	2	applied	\N	\N	\N	\N	13571	13571	13572
4417	3641	3	applied	\N	\N	\N	\N	13579	13579	13580
4417	3639	4	applied	\N	\N	\N	\N	13573	13573	13574
4417	3642	5	applied	\N	\N	\N	\N	13581	13581	13582
4417	3643	6	applied	\N	\N	\N	\N	13583	13583	7276
4417	3644	7	applied	\N	\N	\N	\N	13584	13584	13584
4417	3645	8	applied	\N	\N	\N	\N	13585	13585	7276
4424	3478	0	applied	\N	\N	1000000000	\N	13055	13055	13056
4424	3483	1	applied	\N	\N	1000000000	\N	13071	13071	13072
4424	3615	2	applied	\N	\N	1000000000	\N	13522	13522	13523
4424	3616	3	applied	\N	\N	1000000000	\N	13524	13524	13525
4424	3617	4	applied	\N	\N	1000000000	\N	13526	13526	13527
4424	3618	5	applied	\N	\N	\N	\N	13528	13528	13529
4424	3646	6	applied	\N	\N	1000000000	\N	13590	13590	13591
4424	3652	7	applied	\N	\N	1000000000	\N	13609	13609	13610
4424	3507	8	applied	\N	\N	\N	\N	13215	13215	13216
4424	3509	9	applied	\N	\N	\N	\N	13223	13223	13224
4424	3510	10	applied	\N	\N	\N	\N	13225	13225	13226
4424	3492	11	applied	\N	\N	\N	\N	13104	13104	13177
4424	3493	12	applied	\N	\N	\N	\N	13106	13106	13107
4424	3504	13	applied	\N	\N	\N	\N	12231	12231	12231
4424	3506	14	applied	\N	\N	\N	\N	13213	13213	13214
4424	3513	15	applied	\N	\N	\N	\N	13234	13234	13235
4424	3514	16	applied	\N	\N	\N	\N	13236	13236	13237
4424	3526	17	applied	\N	\N	\N	\N	13262	13262	13263
4424	3512	18	applied	\N	\N	\N	\N	13229	13229	13230
4424	3516	19	applied	\N	\N	\N	\N	13240	13240	13241
4424	3517	20	applied	\N	\N	\N	\N	13242	13242	13243
4424	3518	21	applied	\N	\N	\N	\N	13244	13244	13245
4429	3656	0	applied	\N	\N	\N	\N	13622	13622	13623
4431	3615	0	applied	\N	\N	1000000000	\N	13522	13522	13523
4431	3616	1	applied	\N	\N	1000000000	\N	13524	13524	13525
4431	3617	2	applied	\N	\N	1000000000	\N	13526	13526	13527
4431	3618	3	applied	\N	\N	\N	\N	13528	13528	13529
4431	3646	4	applied	\N	\N	1000000000	\N	13590	13590	13591
4431	3652	5	applied	\N	\N	1000000000	\N	13609	13609	13610
4431	3566	6	applied	\N	\N	\N	\N	13362	13362	13363
4431	3575	7	applied	\N	\N	\N	\N	13437	13437	13438
4431	3586	8	applied	\N	\N	\N	\N	13460	13460	13461
4431	3598	9	applied	\N	\N	\N	\N	13485	13485	13486
4431	3605	10	applied	\N	\N	\N	\N	13499	13499	13500
4431	3621	11	applied	\N	\N	\N	\N	13534	13534	13535
4431	3630	12	applied	\N	\N	\N	\N	13553	13553	13554
4431	3631	13	applied	\N	\N	\N	\N	13555	13555	13556
4431	3632	14	applied	\N	\N	\N	\N	13557	13557	13558
4431	3633	15	applied	\N	\N	\N	\N	13559	13559	13560
4431	3640	16	applied	\N	\N	\N	\N	13577	13577	13578
4431	3641	17	applied	\N	\N	\N	\N	13579	13579	13580
4431	3648	18	applied	\N	\N	\N	\N	13594	13594	13595
4431	3649	19	applied	\N	\N	\N	\N	13598	13598	13599
4431	3650	20	applied	\N	\N	\N	\N	13600	13600	13601
4431	3651	21	applied	\N	\N	\N	\N	13605	13605	13606
4431	3653	22	applied	\N	\N	\N	\N	13612	13612	13613
4431	3654	23	applied	\N	\N	\N	\N	13615	13615	13616
4431	3655	24	applied	\N	\N	\N	\N	13617	13617	13618
4431	3656	25	applied	\N	\N	\N	\N	13622	13622	13623
4431	3643	26	applied	\N	\N	\N	\N	13583	13583	7276
4431	3644	27	applied	\N	\N	\N	\N	13584	13584	13584
4431	3645	28	applied	\N	\N	\N	\N	13585	13585	7276
4434	3661	0	applied	\N	\N	\N	\N	13638	13638	13639
4434	3662	1	applied	\N	\N	\N	\N	13640	13640	13641
4436	3661	0	applied	\N	\N	\N	\N	13638	13638	13639
4436	3662	1	applied	\N	\N	\N	\N	13640	13640	13641
4441	3666	0	applied	\N	\N	\N	\N	13656	13656	13657
4452	3675	0	applied	\N	\N	\N	\N	13692	13692	13693
4456	3679	0	applied	\N	\N	\N	\N	13704	13704	13705
4458	3680	0	applied	\N	\N	1000000000	\N	13708	13708	13709
4458	3681	1	applied	\N	\N	\N	\N	13710	13710	13711
4458	3682	2	applied	\N	\N	\N	\N	13712	13712	13713
4461	3389	0	applied	\N	\N	1000000000	\N	12706	12706	12707
4461	3399	1	applied	\N	\N	\N	\N	12747	12747	12748
4461	3419	2	applied	\N	\N	1000000000	\N	12825	12825	12826
4461	3433	3	applied	\N	\N	1000000000	\N	12884	12884	12885
4461	3437	4	applied	\N	\N	1000000000	\N	12901	12901	12902
4461	3440	5	applied	\N	\N	1000000000	\N	12908	12908	12909
4461	3478	6	applied	\N	\N	1000000000	\N	13055	13055	13056
4461	3483	7	applied	\N	\N	1000000000	\N	13071	13071	13072
4461	3615	8	applied	\N	\N	1000000000	\N	13522	13522	13523
4461	3616	9	applied	\N	\N	1000000000	\N	13524	13524	13525
4461	3617	10	applied	\N	\N	1000000000	\N	13526	13526	13527
4461	3618	11	applied	\N	\N	\N	\N	13528	13528	13529
4461	3646	12	applied	\N	\N	1000000000	\N	13590	13590	13591
4461	3652	13	applied	\N	\N	1000000000	\N	13609	13609	13610
4461	3657	14	applied	\N	\N	1000000000	\N	13627	13627	13628
4461	3667	15	applied	\N	\N	1000000000	\N	13660	13660	13661
4461	3668	16	applied	\N	\N	\N	\N	13662	13662	13663
4461	3680	17	applied	\N	\N	1000000000	\N	13708	13708	13709
4461	3684	18	applied	\N	\N	1000000000	\N	13718	13718	13719
4461	3685	19	applied	\N	\N	1000000000	\N	13720	13720	13721
4461	3492	20	applied	\N	\N	\N	\N	13104	13104	13074
4461	3493	21	applied	\N	\N	\N	\N	13106	13106	13107
4461	3504	22	applied	\N	\N	\N	\N	12231	12231	12231
4420	3646	0	applied	\N	\N	1000000000	\N	13590	13590	13591
4420	3647	1	applied	\N	\N	\N	\N	13592	13592	13593
4420	3648	2	applied	\N	\N	\N	\N	13594	13594	13595
4423	3651	0	applied	\N	\N	\N	\N	13605	13605	13606
4428	3655	0	applied	\N	\N	\N	\N	13617	13617	13618
4430	3656	0	applied	\N	\N	\N	\N	13622	13622	13623
4433	3657	0	applied	\N	\N	1000000000	\N	13627	13627	13628
4433	3658	1	applied	\N	\N	\N	\N	13629	13629	13630
4433	3659	2	applied	\N	\N	\N	\N	13631	13631	13632
4433	3660	3	applied	\N	\N	\N	\N	13633	13633	13634
4435	3661	0	applied	\N	\N	\N	\N	13638	13638	13639
4435	3662	1	applied	\N	\N	\N	\N	13640	13640	13641
4438	3663	0	applied	\N	\N	\N	\N	13647	13647	13648
4438	3664	1	applied	\N	\N	\N	\N	13649	13649	13650
4440	3666	0	applied	\N	\N	\N	\N	13656	13656	13657
4442	3667	0	applied	\N	\N	1000000000	\N	13660	13660	13661
4442	3668	1	applied	\N	\N	\N	\N	13662	13662	13663
4442	3669	2	applied	\N	\N	\N	\N	13664	13664	13665
4442	3670	3	applied	\N	\N	1000000000	\N	13666	13666	13667
4447	3671	0	applied	\N	\N	\N	\N	13674	13674	13675
4447	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13676	13676	\N
4453	3676	0	applied	\N	\N	\N	\N	13695	13695	13696
4453	3677	1	applied	\N	\N	\N	\N	13697	13697	1435
4459	3683	0	applied	\N	\N	\N	\N	13715	13715	13716
4464	3688	0	applied	\N	\N	\N	\N	13827	13827	13828
4471	3693	0	applied	\N	\N	\N	\N	13846	13846	13847
4471	3694	1	applied	\N	\N	\N	\N	13848	13848	13849
4471	3695	2	applied	\N	\N	\N	\N	13850	13850	13851
4479	3703	0	applied	\N	\N	\N	\N	13875	13875	13875
4479	3704	2	applied	\N	\N	\N	\N	13876	13876	13877
4479	3705	3	applied	\N	\N	\N	\N	13882	13882	13883
4483	3706	0	applied	\N	\N	\N	\N	13890	13890	13891
4488	3709	0	applied	\N	\N	\N	\N	13904	13904	13905
4490	3710	0	applied	\N	\N	\N	\N	13908	13908	13909
4495	3711	0	applied	\N	\N	\N	\N	13914	13914	13915
4495	3712	1	applied	\N	\N	\N	\N	13916	13916	13917
4495	3713	2	applied	\N	\N	\N	\N	13918	13918	13919
4497	3714	0	applied	\N	\N	1000000000	\N	13928	13928	13929
4497	3715	1	applied	\N	\N	\N	\N	13930	13930	13931
4497	3716	2	applied	\N	\N	\N	\N	13932	13932	13933
4497	3717	3	applied	\N	\N	\N	\N	13934	13934	13935
4497	3718	4	applied	\N	\N	\N	\N	13936	13936	13937
4499	3712	0	applied	\N	\N	\N	\N	13916	13916	13917
4499	3710	1	applied	\N	\N	\N	\N	13908	13908	13909
4503	3724	0	applied	\N	\N	\N	\N	13955	13955	13956
4503	3725	1	applied	\N	\N	\N	\N	13957	13957	13958
4507	3727	0	applied	\N	\N	\N	\N	13966	13966	13967
4509	3727	0	applied	\N	\N	\N	\N	13966	13966	13967
4511	3680	0	applied	\N	\N	1000000000	\N	13708	13708	13709
4511	3684	1	applied	\N	\N	1000000000	\N	13718	13718	13719
4511	3685	2	applied	\N	\N	1000000000	\N	13720	13720	13721
4511	3693	3	applied	\N	\N	\N	\N	13846	13846	13847
4511	3714	4	applied	\N	\N	1000000000	\N	13928	13928	13929
4511	3719	5	applied	\N	\N	\N	\N	13944	13944	13973
4511	3696	6	applied	\N	\N	1000000000	\N	13974	13974	13857
4511	3687	7	applied	\N	\N	\N	\N	13724	13724	1435
4511	3712	8	applied	\N	\N	\N	\N	13916	13916	13975
4511	3677	9	applied	\N	\N	\N	\N	13976	13976	1435
4511	3715	10	applied	\N	\N	\N	\N	13930	13930	13977
4511	3713	11	applied	\N	\N	\N	\N	13918	13918	13978
4511	3673	12	applied	\N	\N	\N	\N	13688	13688	13689
4511	3675	13	applied	\N	\N	\N	\N	13692	13692	13693
4511	3676	14	applied	\N	\N	\N	\N	13695	13695	13696
4511	3718	15	applied	\N	\N	\N	\N	13936	13936	13945
4511	3678	16	applied	\N	\N	\N	\N	13700	13700	13701
4511	3679	17	applied	\N	\N	\N	\N	13704	13704	13705
4511	3681	18	applied	\N	\N	\N	\N	13710	13710	13711
4511	3682	19	applied	\N	\N	\N	\N	13712	13712	13713
4511	3683	20	applied	\N	\N	\N	\N	13715	13715	13716
4511	3686	21	applied	\N	\N	\N	\N	13722	13722	13723
4511	3688	22	applied	\N	\N	\N	\N	13827	13827	13828
4511	3689	23	applied	\N	\N	\N	\N	13833	13833	13834
4511	3690	24	applied	\N	\N	\N	\N	13838	13838	13839
4511	3691	25	applied	\N	\N	\N	\N	13840	13840	13841
4511	3692	26	applied	\N	\N	\N	\N	13844	13844	13845
4511	3694	27	applied	\N	\N	\N	\N	13848	13848	13849
4511	3695	28	applied	\N	\N	\N	\N	13850	13850	13851
4511	3697	29	applied	\N	\N	\N	\N	13858	13858	13859
4511	3698	30	applied	\N	\N	\N	\N	13860	13860	13861
4511	3699	31	applied	\N	\N	\N	\N	13862	13862	13863
4511	3700	32	applied	\N	\N	\N	\N	13864	13864	13865
4511	3701	33	applied	\N	\N	\N	\N	13866	13866	13867
4511	3702	34	applied	\N	\N	\N	\N	13870	13870	13871
4511	3704	35	applied	\N	\N	\N	\N	13876	13876	13877
4511	3705	36	applied	\N	\N	\N	\N	13882	13882	13883
4511	3706	37	applied	\N	\N	\N	\N	13890	13890	13891
4511	3707	38	applied	\N	\N	\N	\N	13896	13896	13897
4511	3708	39	applied	\N	\N	\N	\N	13900	13900	13901
4511	3709	40	applied	\N	\N	\N	\N	13904	13904	13905
4511	3710	41	applied	\N	\N	\N	\N	13908	13908	13909
4511	3711	42	applied	\N	\N	\N	\N	13914	13914	13915
4511	3716	43	applied	\N	\N	\N	\N	13932	13932	13933
4511	3717	44	applied	\N	\N	\N	\N	13934	13934	13935
4511	3720	45	applied	\N	\N	\N	\N	13946	13946	13947
4511	3721	46	applied	\N	\N	\N	\N	13948	13948	13949
4511	3722	47	applied	\N	\N	\N	\N	13950	13950	13951
4511	3723	48	applied	\N	\N	\N	\N	13953	13953	13954
4511	3724	49	applied	\N	\N	\N	\N	13955	13955	13956
4511	3725	50	applied	\N	\N	\N	\N	13957	13957	13958
4511	3726	51	applied	\N	\N	\N	\N	13963	13963	13964
4511	3727	52	applied	\N	\N	\N	\N	13966	13966	13967
4511	3674	53	failed	Amount_insufficient_to_create_account	\N	\N	\N	13690	13690	\N
4516	3731	0	applied	\N	\N	\N	\N	13990	13990	13991
4518	3731	0	applied	\N	\N	\N	\N	13990	13990	13991
4521	3735	0	applied	\N	\N	\N	\N	14006	14006	14007
4528	3739	0	applied	\N	\N	\N	\N	14022	14022	14023
4530	3739	0	applied	\N	\N	\N	\N	14022	14022	14023
4532	3740	0	applied	\N	\N	\N	\N	14030	14030	14031
4537	3742	0	applied	\N	\N	\N	\N	14041	14041	14042
4539	3743	0	applied	\N	\N	\N	\N	14047	14047	14048
4544	3748	0	applied	\N	\N	1000000000	\N	14063	14063	14064
4544	3749	1	applied	\N	\N	\N	\N	14065	14065	14066
4545	3750	0	applied	\N	\N	\N	\N	14068	14068	14069
4545	3751	1	applied	\N	\N	\N	\N	14070	14070	14071
4547	3752	0	applied	\N	\N	\N	\N	14073	14073	14074
4555	3756	0	applied	\N	\N	1000000000	\N	14085	14085	14086
4555	3757	1	applied	\N	\N	\N	\N	14087	14087	14088
4421	3649	0	applied	\N	\N	\N	\N	13598	13598	13599
4421	3650	1	applied	\N	\N	\N	\N	13600	13600	13601
4426	3654	0	applied	\N	\N	\N	\N	13615	13615	13616
4443	3667	0	applied	\N	\N	1000000000	\N	13660	13660	13661
4443	3668	1	applied	\N	\N	\N	\N	13662	13662	13663
4443	3669	2	applied	\N	\N	\N	\N	13664	13664	13665
4443	3670	3	applied	\N	\N	1000000000	\N	13666	13666	13667
4445	3671	0	applied	\N	\N	\N	\N	13674	13674	13675
4445	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13676	13676	\N
4448	3671	0	applied	\N	\N	\N	\N	13674	13674	13675
4448	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13676	13676	\N
4450	3671	0	applied	\N	\N	\N	\N	13674	13674	13675
4450	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13676	13676	\N
4451	3673	0	applied	\N	\N	\N	\N	13688	13688	13689
4451	3674	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13690	13690	\N
4454	3678	0	applied	\N	\N	\N	\N	13700	13700	13701
4460	3684	0	applied	\N	\N	1000000000	\N	13718	13718	13719
4460	3685	1	applied	\N	\N	1000000000	\N	13720	13720	13721
4460	3686	2	applied	\N	\N	\N	\N	13722	13722	13723
4460	3687	3	applied	\N	\N	\N	\N	13724	13724	1435
4469	3689	0	applied	\N	\N	\N	\N	13833	13833	13834
4469	3690	1	applied	\N	\N	\N	\N	13838	13838	13839
4469	3691	2	applied	\N	\N	\N	\N	13840	13840	13841
4473	3696	0	applied	\N	\N	1000000000	\N	13856	13856	13857
4473	3697	1	applied	\N	\N	\N	\N	13858	13858	13859
4473	3698	2	applied	\N	\N	\N	\N	13860	13860	13861
4473	3699	3	applied	\N	\N	\N	\N	13862	13862	13863
4473	3700	4	applied	\N	\N	\N	\N	13864	13864	13865
4473	3701	5	applied	\N	\N	\N	\N	13866	13866	13867
4482	3703	0	applied	\N	\N	\N	\N	13875	13875	13875
4482	3704	2	applied	\N	\N	\N	\N	13876	13876	13877
4482	3705	3	applied	\N	\N	\N	\N	13882	13882	13883
4484	3706	0	applied	\N	\N	\N	\N	13890	13890	13891
4487	3708	0	applied	\N	\N	\N	\N	13900	13900	13901
4489	3710	0	applied	\N	\N	\N	\N	13908	13908	13909
4492	3711	0	applied	\N	\N	\N	\N	13914	13914	13915
4492	3712	1	applied	\N	\N	\N	\N	13916	13916	13917
4492	3713	2	applied	\N	\N	\N	\N	13918	13918	13919
4496	3714	0	applied	\N	\N	1000000000	\N	13928	13928	13929
4496	3715	1	applied	\N	\N	\N	\N	13930	13930	13931
4496	3716	2	applied	\N	\N	\N	\N	13932	13932	13933
4496	3717	3	applied	\N	\N	\N	\N	13934	13934	13935
4496	3718	4	applied	\N	\N	\N	\N	13936	13936	13937
4498	3714	0	applied	\N	\N	1000000000	\N	13928	13928	13929
4498	3715	1	applied	\N	\N	\N	\N	13930	13930	13931
4498	3716	2	applied	\N	\N	\N	\N	13932	13932	13933
4498	3717	3	applied	\N	\N	\N	\N	13934	13934	13935
4498	3718	4	applied	\N	\N	\N	\N	13936	13936	13937
4501	3723	0	applied	\N	\N	\N	\N	13953	13953	13954
4506	3726	0	applied	\N	\N	\N	\N	13963	13963	13964
4515	3731	0	applied	\N	\N	\N	\N	13990	13990	13991
4517	3731	0	applied	\N	\N	\N	\N	13990	13990	13991
4522	3736	0	applied	\N	\N	\N	\N	14008	14008	14009
4531	3740	0	applied	\N	\N	\N	\N	14030	14030	14031
4540	3744	0	applied	\N	\N	\N	\N	14050	14050	14051
4543	3746	0	applied	\N	\N	\N	\N	14058	14058	14059
4543	3747	1	applied	\N	\N	\N	\N	14060	14060	14061
4558	3770	0	applied	\N	\N	\N	\N	14125	14125	14126
4562	3770	0	applied	\N	\N	\N	\N	14125	14125	14126
4567	3775	0	applied	\N	\N	\N	\N	14146	14146	14147
4567	3777	1	applied	\N	\N	\N	\N	14153	14153	14154
4572	3780	0	applied	\N	\N	\N	\N	14168	14168	14169
4572	3781	1	applied	\N	\N	\N	\N	14170	14170	14171
4577	3785	0	applied	\N	\N	\N	\N	14185	14185	14186
4577	3786	1	applied	\N	\N	\N	\N	14187	14187	14188
4579	3787	0	applied	\N	\N	\N	\N	14193	14193	14194
4589	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4589	3714	1	applied	\N	\N	1000000000	\N	13928	13928	13929
4589	3756	2	applied	\N	\N	1000000000	\N	14085	14085	14086
4589	3757	3	applied	\N	\N	\N	\N	14087	14087	14088
4589	3758	4	applied	\N	\N	\N	\N	14089	14089	14090
4589	3759	5	applied	\N	\N	\N	\N	14091	14091	14092
4589	3760	6	applied	\N	\N	\N	\N	14093	14093	14094
4589	3761	7	applied	\N	\N	\N	\N	14096	14096	14097
4589	3762	8	applied	\N	\N	\N	\N	14098	14098	14099
4589	3763	9	applied	\N	\N	\N	\N	14100	14100	14101
4589	3764	10	applied	\N	\N	\N	\N	14102	14102	14103
4589	3765	11	applied	\N	\N	\N	\N	14104	14104	14105
4589	3766	12	applied	\N	\N	\N	\N	14106	14106	14107
4589	3775	13	applied	\N	\N	\N	\N	14146	14146	14147
4589	3782	14	applied	\N	\N	\N	\N	14174	14174	14175
4589	3790	15	applied	\N	\N	1000000000	\N	14204	14204	14205
4589	3748	16	applied	\N	\N	1000000000	\N	14063	14063	14064
4589	3753	17	applied	\N	\N	\N	\N	14076	14076	14077
4589	3719	18	applied	\N	\N	\N	\N	13944	13944	14219
4589	3707	19	applied	\N	\N	\N	\N	13896	13896	13897
4589	3708	20	applied	\N	\N	\N	\N	13900	13900	13901
4589	3709	21	applied	\N	\N	\N	\N	13904	13904	13905
4589	3712	22	applied	\N	\N	\N	\N	13916	13916	13976
4589	3715	23	applied	\N	\N	\N	\N	13930	13930	13977
4589	3713	24	applied	\N	\N	\N	\N	13918	13918	13978
4589	3710	25	applied	\N	\N	\N	\N	13908	13908	13909
4589	3711	26	applied	\N	\N	\N	\N	13914	13914	13915
4589	3716	27	applied	\N	\N	\N	\N	13932	13932	13933
4589	3717	28	applied	\N	\N	\N	\N	13934	13934	13935
4589	3720	29	applied	\N	\N	\N	\N	13946	13946	13947
4589	3721	30	applied	\N	\N	\N	\N	13948	13948	13949
4589	3722	31	applied	\N	\N	\N	\N	13950	13950	13951
4589	3723	32	applied	\N	\N	\N	\N	13953	13953	13954
4589	3724	33	applied	\N	\N	\N	\N	13955	13955	13956
4589	3725	34	applied	\N	\N	\N	\N	13957	13957	13958
4589	3726	35	applied	\N	\N	\N	\N	13963	13963	13964
4589	3727	36	applied	\N	\N	\N	\N	13966	13966	13967
4589	3728	37	applied	\N	\N	\N	\N	13980	13980	13981
4589	3729	38	applied	\N	\N	\N	\N	13982	13982	13983
4589	3730	39	applied	\N	\N	\N	\N	13986	13986	13987
4589	3731	40	applied	\N	\N	\N	\N	13990	13990	13991
4589	3732	41	applied	\N	\N	\N	\N	13996	13996	13997
4589	3733	42	applied	\N	\N	\N	\N	13998	13998	13999
4589	3734	43	applied	\N	\N	\N	\N	14002	14002	14003
4589	3735	44	applied	\N	\N	\N	\N	14006	14006	14007
4589	3736	45	applied	\N	\N	\N	\N	14008	14008	14009
4589	3737	46	applied	\N	\N	\N	\N	14012	14012	14013
4589	3738	47	applied	\N	\N	\N	\N	14017	14017	14018
4589	3739	48	applied	\N	\N	\N	\N	14022	14022	14023
4589	3740	49	applied	\N	\N	\N	\N	14030	14030	14031
4422	3649	0	applied	\N	\N	\N	\N	13598	13598	13599
4422	3650	1	applied	\N	\N	\N	\N	13600	13600	13601
4425	3652	0	applied	\N	\N	1000000000	\N	13609	13609	13610
4425	3653	1	applied	\N	\N	\N	\N	13612	13612	13613
4427	3655	0	applied	\N	\N	\N	\N	13617	13617	13618
4432	3657	0	applied	\N	\N	1000000000	\N	13627	13627	13628
4432	3658	1	applied	\N	\N	\N	\N	13629	13629	13630
4432	3659	2	applied	\N	\N	\N	\N	13631	13631	13632
4432	3660	3	applied	\N	\N	\N	\N	13633	13633	13634
4437	3663	0	applied	\N	\N	\N	\N	13647	13647	13648
4437	3664	1	applied	\N	\N	\N	\N	13649	13649	13650
4439	3665	0	applied	\N	\N	\N	\N	13654	13654	13655
4444	3667	0	applied	\N	\N	1000000000	\N	13660	13660	13661
4444	3668	1	applied	\N	\N	\N	\N	13662	13662	13663
4444	3669	2	applied	\N	\N	\N	\N	13664	13664	13665
4444	3670	3	applied	\N	\N	1000000000	\N	13666	13666	13667
4446	3671	0	applied	\N	\N	\N	\N	13674	13674	13675
4446	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	13676	13676	\N
4449	3615	0	applied	\N	\N	1000000000	\N	13522	13522	13523
4449	3616	1	applied	\N	\N	1000000000	\N	13524	13524	13525
4449	3617	2	applied	\N	\N	1000000000	\N	13526	13526	13527
4449	3618	3	applied	\N	\N	\N	\N	13528	13528	13529
4449	3646	4	applied	\N	\N	1000000000	\N	13590	13590	13591
4449	3652	5	applied	\N	\N	1000000000	\N	13609	13609	13610
4449	3657	6	applied	\N	\N	1000000000	\N	13627	13627	13628
4449	3667	7	applied	\N	\N	1000000000	\N	13660	13660	13661
4449	3668	8	applied	\N	\N	\N	\N	13662	13662	13663
4449	3498	9	applied	\N	\N	\N	\N	13128	13128	13129
4449	3499	10	applied	\N	\N	\N	\N	13132	13132	13133
4449	3500	11	applied	\N	\N	\N	\N	13134	13134	13135
4449	3501	12	applied	\N	\N	\N	\N	13137	13137	13138
4449	3502	13	applied	\N	\N	\N	\N	13141	13141	13142
4449	3503	14	applied	\N	\N	\N	\N	13148	13148	13149
4449	3505	15	applied	\N	\N	\N	\N	13152	13152	13153
4449	3508	16	applied	\N	\N	\N	\N	13217	13217	13218
4449	3511	17	applied	\N	\N	\N	\N	13227	13227	13228
4449	3515	18	applied	\N	\N	\N	\N	13238	13238	13239
4449	3528	19	applied	\N	\N	\N	\N	13266	13266	13267
4449	3536	20	applied	\N	\N	\N	\N	13290	13290	13291
4449	3546	21	applied	\N	\N	\N	\N	13315	13315	13316
4449	3557	22	applied	\N	\N	\N	\N	13341	13341	13342
4449	3566	23	applied	\N	\N	\N	\N	13362	13362	13363
4455	3679	0	applied	\N	\N	\N	\N	13704	13704	13705
4457	3679	0	applied	\N	\N	\N	\N	13704	13704	13705
4462	3688	0	applied	\N	\N	\N	\N	13827	13827	13828
4465	3688	0	applied	\N	\N	\N	\N	13827	13827	13828
4466	3689	0	applied	\N	\N	\N	\N	13833	13833	13834
4472	3693	0	applied	\N	\N	\N	\N	13846	13846	13847
4472	3694	1	applied	\N	\N	\N	\N	13848	13848	13849
4472	3695	2	applied	\N	\N	\N	\N	13850	13850	13851
4475	3702	0	applied	\N	\N	\N	\N	13870	13870	13871
4477	3703	0	applied	\N	\N	\N	\N	13875	13875	13875
4477	3704	1	applied	\N	\N	\N	\N	13876	13876	13877
4480	3703	0	applied	\N	\N	\N	\N	13875	13875	13875
4480	3704	2	applied	\N	\N	\N	\N	13876	13876	13877
4480	3705	3	applied	\N	\N	\N	\N	13882	13882	13883
4486	3708	0	applied	\N	\N	\N	\N	13900	13900	13901
4491	3711	0	applied	\N	\N	\N	\N	13914	13914	13915
4491	3712	1	applied	\N	\N	\N	\N	13916	13916	13917
4491	3713	2	applied	\N	\N	\N	\N	13918	13918	13919
4500	3719	0	applied	\N	\N	\N	\N	13944	13944	13945
4500	3720	1	applied	\N	\N	\N	\N	13946	13946	13947
4500	3721	2	applied	\N	\N	\N	\N	13948	13948	13949
4500	3722	3	applied	\N	\N	\N	\N	13950	13950	13951
4505	3726	0	applied	\N	\N	\N	\N	13963	13963	13964
4508	3727	0	applied	\N	\N	\N	\N	13966	13966	13967
4510	3727	0	applied	\N	\N	\N	\N	13966	13966	13967
4512	3728	0	applied	\N	\N	\N	\N	13980	13980	13981
4512	3729	1	applied	\N	\N	\N	\N	13982	13982	13983
4514	3730	0	applied	\N	\N	\N	\N	13986	13986	13987
4519	3732	0	applied	\N	\N	\N	\N	13996	13996	13997
4519	3733	1	applied	\N	\N	\N	\N	13998	13998	13999
4524	3737	0	applied	\N	\N	\N	\N	14012	14012	14013
4526	3738	0	applied	\N	\N	\N	\N	14017	14017	14018
4529	3739	0	applied	\N	\N	\N	\N	14022	14022	14023
4533	3728	0	applied	\N	\N	\N	\N	13980	13980	13981
4533	3729	1	applied	\N	\N	\N	\N	13982	13982	13983
4533	3730	2	applied	\N	\N	\N	\N	13986	13986	13987
4533	3731	3	applied	\N	\N	\N	\N	13990	13990	13991
4533	3732	4	applied	\N	\N	\N	\N	13996	13996	13997
4533	3733	6	applied	\N	\N	\N	\N	13998	13998	13999
4533	3734	7	applied	\N	\N	\N	\N	14002	14002	14003
4533	3735	8	applied	\N	\N	\N	\N	14006	14006	14007
4533	3736	9	applied	\N	\N	\N	\N	14008	14008	14009
4533	3737	10	applied	\N	\N	\N	\N	14012	14012	14013
4533	3738	11	applied	\N	\N	\N	\N	14017	14017	14018
4533	3739	12	applied	\N	\N	\N	\N	14022	14022	14023
4533	3740	13	applied	\N	\N	\N	\N	14030	14030	14031
4535	3741	0	applied	\N	\N	\N	\N	14037	14037	14038
4538	3742	0	applied	\N	\N	\N	\N	14041	14041	14042
4542	3745	0	applied	\N	\N	\N	\N	14054	14054	14055
4548	3753	0	applied	\N	\N	\N	\N	14076	14076	14077
4548	3754	1	applied	\N	\N	\N	\N	14078	14078	14079
4550	3755	0	applied	\N	\N	\N	\N	14081	14081	14082
4553	3756	0	applied	\N	\N	1000000000	\N	14085	14085	14086
4553	3757	1	applied	\N	\N	\N	\N	14087	14087	14088
4553	3758	2	applied	\N	\N	\N	\N	14089	14089	14090
4553	3759	3	applied	\N	\N	\N	\N	14091	14091	14092
4553	3760	4	applied	\N	\N	\N	\N	14093	14093	14094
4553	3761	6	applied	\N	\N	\N	\N	14096	14096	14097
4553	3762	7	applied	\N	\N	\N	\N	14098	14098	14099
4553	3763	8	applied	\N	\N	\N	\N	14100	14100	14101
4553	3764	9	applied	\N	\N	\N	\N	14102	14102	14103
4553	3765	10	applied	\N	\N	\N	\N	14104	14104	14105
4553	3766	11	applied	\N	\N	\N	\N	14106	14106	14107
4553	3767	12	applied	\N	\N	\N	\N	14108	14108	14109
4553	3768	13	applied	\N	\N	\N	\N	14110	14110	14111
4553	3769	14	applied	\N	\N	\N	\N	14112	14112	14113
4560	3756	0	applied	\N	\N	1000000000	\N	14085	14085	14086
4560	3757	1	applied	\N	\N	\N	\N	14087	14087	14088
4560	3758	2	applied	\N	\N	\N	\N	14089	14089	14090
4560	3759	3	applied	\N	\N	\N	\N	14091	14091	14092
4560	3760	4	applied	\N	\N	\N	\N	14093	14093	14094
4560	3761	6	applied	\N	\N	\N	\N	14096	14096	14097
4560	3762	7	applied	\N	\N	\N	\N	14098	14098	14099
4560	3763	8	applied	\N	\N	\N	\N	14100	14100	14101
4560	3764	9	applied	\N	\N	\N	\N	14102	14102	14103
4560	3765	10	applied	\N	\N	\N	\N	14104	14104	14105
4461	3506	23	applied	\N	\N	\N	\N	13213	13213	13214
4461	3513	24	applied	\N	\N	\N	\N	13234	13234	13235
4461	3514	25	applied	\N	\N	\N	\N	13236	13236	13237
4461	3526	26	applied	\N	\N	\N	\N	13262	13262	13263
4461	3444	27	applied	\N	\N	\N	\N	13726	13726	12925
4461	3507	28	applied	\N	\N	\N	\N	13727	13727	13216
4461	3509	29	applied	\N	\N	\N	\N	13728	13728	13224
4461	3510	30	applied	\N	\N	\N	\N	13729	13729	13226
4461	3512	31	applied	\N	\N	\N	\N	13730	13730	13230
4461	3516	32	applied	\N	\N	\N	\N	13731	13731	13241
4461	3517	33	applied	\N	\N	\N	\N	13732	13732	13243
4461	3518	34	applied	\N	\N	\N	\N	13733	13733	13245
4461	3519	35	applied	\N	\N	\N	\N	13734	13734	13247
4461	3520	36	applied	\N	\N	\N	\N	13735	13735	13249
4461	3521	37	applied	\N	\N	\N	\N	13736	13736	13251
4461	3522	38	applied	\N	\N	\N	\N	13737	13737	13253
4461	3523	39	applied	\N	\N	\N	\N	13738	13738	13255
4461	3524	40	applied	\N	\N	\N	\N	13739	13739	13257
4461	3525	41	applied	\N	\N	\N	\N	13740	13740	13261
4461	3527	42	applied	\N	\N	\N	\N	13741	13741	13265
4461	3529	43	applied	\N	\N	\N	\N	13742	13742	13269
4461	3530	44	applied	\N	\N	\N	\N	13743	13743	13271
4461	3531	45	applied	\N	\N	\N	\N	13744	13744	13274
4461	3532	46	applied	\N	\N	\N	\N	13745	13745	13276
4461	3533	47	applied	\N	\N	\N	\N	13746	13746	13278
4461	3534	48	applied	\N	\N	\N	\N	13747	13747	13280
4461	3535	49	applied	\N	\N	\N	\N	13748	13748	13282
4461	3537	50	applied	\N	\N	\N	\N	13749	13749	13293
4461	3538	51	applied	\N	\N	\N	\N	13750	13750	13295
4461	3539	52	applied	\N	\N	\N	\N	13751	13751	13297
4461	3540	53	applied	\N	\N	\N	\N	13752	13752	13299
4461	3541	54	applied	\N	\N	\N	\N	13753	13753	13301
4461	3542	55	applied	\N	\N	\N	\N	13754	13754	13303
4461	3543	56	applied	\N	\N	\N	\N	13755	13755	13305
4461	3544	57	applied	\N	\N	\N	\N	13756	13756	13307
4461	3545	58	applied	\N	\N	\N	\N	13757	13757	13309
4461	3547	59	applied	\N	\N	\N	\N	13758	13758	13318
4461	3548	60	applied	\N	\N	\N	\N	13759	13759	13320
4461	3549	61	applied	\N	\N	\N	\N	13760	13760	13322
4461	3550	62	applied	\N	\N	\N	\N	13761	13761	13324
4461	3551	63	applied	\N	\N	\N	\N	13762	13762	13326
4461	3552	64	applied	\N	\N	\N	\N	13763	13763	13328
4461	3553	65	applied	\N	\N	\N	\N	13764	13764	13330
4461	3554	66	applied	\N	\N	\N	\N	13765	13765	13332
4461	3555	67	applied	\N	\N	\N	\N	13766	13766	13334
4461	3556	68	applied	\N	\N	\N	\N	13767	13767	13340
4461	3558	69	applied	\N	\N	\N	\N	13768	13768	13344
4461	3559	70	applied	\N	\N	\N	\N	13769	13769	13346
4461	3560	71	applied	\N	\N	\N	\N	13770	13770	13348
4461	3561	72	applied	\N	\N	\N	\N	13771	13771	13350
4461	3562	73	applied	\N	\N	\N	\N	13772	13772	13352
4461	3563	74	applied	\N	\N	\N	\N	13773	13773	13354
4461	3564	76	applied	\N	\N	\N	\N	13775	13775	13356
4461	3565	77	applied	\N	\N	\N	\N	13776	13776	13358
4461	3567	78	applied	\N	\N	\N	\N	13777	13777	13365
4461	3568	79	applied	\N	\N	\N	\N	13778	13778	13367
4461	3569	80	applied	\N	\N	\N	\N	13779	13779	13369
4461	3570	81	applied	\N	\N	\N	\N	13780	13780	13371
4461	3571	82	applied	\N	\N	\N	\N	13781	13781	13373
4461	3572	83	applied	\N	\N	\N	\N	13782	13782	13375
4461	3573	84	applied	\N	\N	\N	\N	13783	13783	13377
4461	3574	85	applied	\N	\N	\N	\N	13784	13784	13379
4461	3576	86	applied	\N	\N	\N	\N	13785	13785	13440
4461	3577	87	applied	\N	\N	\N	\N	13786	13786	13442
4461	3578	88	applied	\N	\N	\N	\N	13787	13787	13444
4461	3579	89	applied	\N	\N	\N	\N	13788	13788	13446
4461	3580	90	applied	\N	\N	\N	\N	13789	13789	13448
4461	3581	91	applied	\N	\N	\N	\N	13790	13790	13450
4461	3582	92	applied	\N	\N	\N	\N	13791	13791	13452
4461	3583	93	applied	\N	\N	\N	\N	13792	13792	13454
4461	3584	94	applied	\N	\N	\N	\N	13793	13793	13456
4461	3585	95	applied	\N	\N	\N	\N	13794	13794	13459
4461	3587	96	applied	\N	\N	\N	\N	13795	13795	13463
4461	3588	97	applied	\N	\N	\N	\N	13796	13796	13465
4461	3589	98	applied	\N	\N	\N	\N	13797	13797	13467
4461	3590	99	applied	\N	\N	\N	\N	13798	13798	13469
4461	3591	100	applied	\N	\N	\N	\N	13799	13799	13471
4461	3592	101	applied	\N	\N	\N	\N	13800	13800	13473
4461	3593	102	applied	\N	\N	\N	\N	13801	13801	13475
4461	3594	103	applied	\N	\N	\N	\N	13802	13802	13477
4461	3595	104	applied	\N	\N	\N	\N	13803	13803	13480
4461	3596	105	applied	\N	\N	\N	\N	13804	13804	13482
4461	3597	106	applied	\N	\N	\N	\N	13805	13805	13484
4461	3599	107	applied	\N	\N	\N	\N	13806	13806	13488
4461	3600	108	applied	\N	\N	\N	\N	13807	13807	13490
4461	3601	109	applied	\N	\N	\N	\N	13808	13808	13492
4461	3602	110	applied	\N	\N	\N	\N	13809	13809	13494
4461	3603	111	applied	\N	\N	\N	\N	13810	13810	13496
4461	3604	112	applied	\N	\N	\N	\N	13811	13811	13498
4461	3606	113	applied	\N	\N	\N	\N	13812	13812	13502
4461	3607	114	applied	\N	\N	\N	\N	13813	13813	13504
4461	3608	115	applied	\N	\N	\N	\N	13814	13814	13506
4461	3609	116	applied	\N	\N	\N	\N	13815	13815	13508
4461	3610	117	applied	\N	\N	\N	\N	13816	13816	13510
4461	3611	118	applied	\N	\N	\N	\N	13817	13817	13512
4461	3612	119	applied	\N	\N	\N	\N	13818	13818	13514
4461	3613	120	applied	\N	\N	\N	\N	13819	13819	13516
4461	3614	121	applied	\N	\N	\N	\N	13820	13820	13518
4461	3619	122	applied	\N	\N	\N	\N	13821	13821	13531
4461	3620	123	applied	\N	\N	\N	\N	13822	13822	13533
4461	3622	124	applied	\N	\N	\N	\N	13823	13823	13537
4461	3623	125	applied	\N	\N	\N	\N	13824	13824	13539
4463	3688	0	applied	\N	\N	\N	\N	13827	13827	13828
4467	3689	0	applied	\N	\N	\N	\N	13833	13833	13834
4470	3692	0	applied	\N	\N	\N	\N	13844	13844	13845
4474	3702	0	applied	\N	\N	\N	\N	13870	13870	13871
4476	3702	0	applied	\N	\N	\N	\N	13870	13870	13871
4481	3703	0	applied	\N	\N	\N	\N	13875	13875	13875
4481	3704	2	applied	\N	\N	\N	\N	13876	13876	13877
4485	3707	0	applied	\N	\N	\N	\N	13896	13896	13897
4494	3711	0	applied	\N	\N	\N	\N	13914	13914	13915
4494	3712	1	applied	\N	\N	\N	\N	13916	13916	13917
4494	3713	2	applied	\N	\N	\N	\N	13918	13918	13919
4502	3724	0	applied	\N	\N	\N	\N	13955	13955	13956
4502	3725	1	applied	\N	\N	\N	\N	13957	13957	13958
4504	3726	0	applied	\N	\N	\N	\N	13963	13963	13964
4513	3728	0	applied	\N	\N	\N	\N	13980	13980	13981
4513	3729	1	applied	\N	\N	\N	\N	13982	13982	13983
4520	3734	0	applied	\N	\N	\N	\N	14002	14002	14003
4523	3736	0	applied	\N	\N	\N	\N	14008	14008	14009
4525	3737	0	applied	\N	\N	\N	\N	14012	14012	14013
4527	3738	0	applied	\N	\N	\N	\N	14017	14017	14018
4534	3741	0	applied	\N	\N	\N	\N	14037	14037	14038
4536	3742	0	applied	\N	\N	\N	\N	14041	14041	14042
4541	3745	0	applied	\N	\N	\N	\N	14054	14054	14055
4549	3755	0	applied	\N	\N	\N	\N	14081	14081	14082
4565	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4565	3775	1	applied	\N	\N	\N	\N	14146	14146	14147
4565	3776	2	applied	\N	\N	\N	\N	14148	14148	14149
4570	3779	0	applied	\N	\N	\N	\N	14161	14161	14162
4575	3784	0	applied	\N	\N	\N	\N	14179	14179	14180
4580	3788	0	applied	\N	\N	\N	\N	14196	14196	14197
4582	3788	0	applied	\N	\N	\N	\N	14196	14196	14197
4584	3789	0	applied	\N	\N	\N	\N	14202	14202	14203
4585	3790	0	applied	\N	\N	1000000000	\N	14204	14204	14205
4585	3791	1	applied	\N	\N	\N	\N	14206	14206	14207
4585	3792	2	applied	\N	\N	\N	\N	14208	14208	14209
4585	3793	3	applied	\N	\N	\N	\N	14210	14210	14211
4585	3794	4	applied	\N	\N	\N	\N	14212	14212	14213
4588	3790	0	applied	\N	\N	1000000000	\N	14204	14204	14205
4588	3791	1	applied	\N	\N	\N	\N	14206	14206	14207
4588	3792	2	applied	\N	\N	\N	\N	14208	14208	14209
4588	3793	3	applied	\N	\N	\N	\N	14210	14210	14211
4588	3794	4	applied	\N	\N	\N	\N	14212	14212	14213
4590	3795	0	applied	\N	\N	\N	\N	14221	14221	14222
4590	3796	1	applied	\N	\N	\N	\N	14223	14223	14224
4590	3797	2	applied	\N	\N	\N	\N	14225	14225	14226
4590	3798	3	applied	\N	\N	\N	\N	14227	14227	14228
4593	3800	0	applied	\N	\N	\N	\N	14238	14238	14239
4593	3801	1	applied	\N	\N	\N	\N	14240	14240	14241
4596	3804	0	applied	\N	\N	\N	\N	14248	14248	14249
4596	3805	1	applied	\N	\N	\N	\N	14250	14250	1435
4596	3806	2	applied	\N	\N	\N	\N	14251	14251	14252
4598	3807	0	applied	\N	\N	\N	\N	14255	14255	14256
4599	3808	0	applied	\N	\N	\N	\N	14258	14258	14259
4599	3809	1	applied	\N	\N	\N	\N	14260	14260	14261
4599	3810	2	applied	\N	\N	\N	\N	14262	14262	14263
4604	3815	0	applied	\N	\N	\N	\N	14277	14277	14278
4606	3816	0	applied	\N	\N	\N	\N	14282	14282	14283
4609	3818	0	applied	\N	\N	\N	\N	14289	14289	14290
4609	3819	1	applied	\N	\N	\N	\N	14291	14291	14292
4612	3821	0	applied	\N	\N	\N	\N	14298	14298	14299
4616	3822	0	applied	\N	\N	\N	\N	14306	14306	8545
4616	3823	1	applied	\N	\N	\N	\N	14307	14307	14308
4616	3824	2	applied	\N	\N	\N	\N	14309	14309	14310
4618	3825	0	applied	\N	\N	\N	\N	14317	14317	14318
4630	3832	0	applied	\N	\N	\N	\N	14345	14345	14346
4634	3833	0	applied	\N	\N	\N	\N	14355	14355	14356
4643	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4643	3822	1	applied	\N	\N	\N	\N	14306	14306	8545
4643	3756	2	applied	\N	\N	1000000000	\N	14085	14085	14086
4643	3757	3	applied	\N	\N	\N	\N	14087	14087	14088
4643	3758	4	applied	\N	\N	\N	\N	14089	14089	14090
4643	3759	5	applied	\N	\N	\N	\N	14091	14091	14092
4643	3760	6	applied	\N	\N	\N	\N	14093	14093	14094
4643	3761	7	applied	\N	\N	\N	\N	14096	14096	14097
4643	3762	8	applied	\N	\N	\N	\N	14098	14098	14099
4643	3763	9	applied	\N	\N	\N	\N	14100	14100	14101
4643	3764	10	applied	\N	\N	\N	\N	14102	14102	14103
4643	3765	11	applied	\N	\N	\N	\N	14104	14104	14105
4643	3766	12	applied	\N	\N	\N	\N	14106	14106	14107
4643	3775	13	applied	\N	\N	\N	\N	14146	14146	14147
4643	3782	14	applied	\N	\N	\N	\N	14174	14174	14175
4643	3790	15	applied	\N	\N	1000000000	\N	14204	14204	14205
4643	3748	16	applied	\N	\N	1000000000	\N	14063	14063	14064
4643	3753	17	applied	\N	\N	\N	\N	14076	14076	14077
4646	3838	0	applied	\N	\N	\N	\N	14375	14375	14376
4650	3839	0	applied	\N	\N	\N	\N	14385	14385	14386
4652	3843	0	applied	\N	\N	\N	\N	14397	14397	14398
4652	3844	1	applied	\N	\N	\N	\N	14399	14399	14400
4555	3758	2	applied	\N	\N	\N	\N	14089	14089	14090
4555	3759	3	applied	\N	\N	\N	\N	14091	14091	14092
4555	3760	4	applied	\N	\N	\N	\N	14093	14093	14094
4555	3761	6	applied	\N	\N	\N	\N	14096	14096	14097
4555	3762	7	applied	\N	\N	\N	\N	14098	14098	14099
4555	3763	8	applied	\N	\N	\N	\N	14100	14100	14101
4555	3764	9	applied	\N	\N	\N	\N	14102	14102	14103
4555	3765	10	applied	\N	\N	\N	\N	14104	14104	14105
4555	3766	11	applied	\N	\N	\N	\N	14106	14106	14107
4555	3767	12	applied	\N	\N	\N	\N	14108	14108	14109
4555	3768	13	applied	\N	\N	\N	\N	14110	14110	14111
4555	3769	14	applied	\N	\N	\N	\N	14112	14112	14113
4559	3770	0	applied	\N	\N	\N	\N	14125	14125	14126
4563	3771	0	applied	\N	\N	\N	\N	14135	14135	14136
4566	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4566	3776	1	applied	\N	\N	\N	\N	14148	14148	14149
4568	3778	0	applied	\N	\N	\N	\N	14157	14157	14158
4573	3782	0	applied	\N	\N	\N	\N	14174	14174	14175
4573	3783	1	applied	\N	\N	\N	\N	14176	14176	14177
4576	3785	0	applied	\N	\N	\N	\N	14185	14185	14186
4576	3786	1	applied	\N	\N	\N	\N	14187	14187	14188
4578	3787	0	applied	\N	\N	\N	\N	14193	14193	14194
4581	3788	0	applied	\N	\N	\N	\N	14196	14196	14197
4586	3790	0	applied	\N	\N	1000000000	\N	14204	14204	14205
4586	3791	1	applied	\N	\N	\N	\N	14206	14206	14207
4586	3792	2	applied	\N	\N	\N	\N	14208	14208	14209
4586	3793	3	applied	\N	\N	\N	\N	14210	14210	14211
4586	3794	4	applied	\N	\N	\N	\N	14212	14212	14213
4602	3814	0	applied	\N	\N	\N	\N	14273	14273	14274
4610	3820	0	applied	\N	\N	\N	\N	14295	14295	14296
4621	3826	0	applied	\N	\N	\N	\N	14321	14321	14322
4623	3827	0	applied	\N	\N	\N	\N	14328	14328	14329
4625	3827	0	applied	\N	\N	\N	\N	14328	14328	14329
4628	3828	0	applied	\N	\N	\N	\N	14334	14334	14335
4628	3829	1	applied	\N	\N	\N	\N	14336	14336	14337
4628	3830	2	applied	\N	\N	\N	\N	14338	14338	14339
4631	3832	0	applied	\N	\N	\N	\N	14345	14345	14346
4633	3832	0	applied	\N	\N	\N	\N	14345	14345	14346
4635	3833	0	applied	\N	\N	\N	\N	14355	14355	14356
4637	3834	0	applied	\N	\N	\N	\N	14357	14357	14358
4637	3835	1	applied	\N	\N	\N	\N	14359	14359	14360
4640	3836	0	applied	\N	\N	\N	\N	14363	14363	14364
4648	3838	0	applied	\N	\N	\N	\N	14375	14375	14376
4651	3840	0	applied	\N	\N	\N	\N	14389	14389	14390
4651	3841	1	applied	\N	\N	\N	\N	14391	14391	14392
4651	3842	2	applied	\N	\N	\N	\N	14393	14393	14394
4654	3843	0	applied	\N	\N	\N	\N	14397	14397	14398
4654	3844	1	applied	\N	\N	\N	\N	14399	14399	14400
4560	3766	11	applied	\N	\N	\N	\N	14106	14106	14107
4560	3767	12	applied	\N	\N	\N	\N	14108	14108	14109
4560	3768	13	applied	\N	\N	\N	\N	14110	14110	14111
4560	3769	14	applied	\N	\N	\N	\N	14112	14112	14113
4561	3756	0	applied	\N	\N	1000000000	\N	14085	14085	14086
4561	3757	1	applied	\N	\N	\N	\N	14087	14087	14088
4561	3758	2	applied	\N	\N	\N	\N	14089	14089	14090
4561	3759	3	applied	\N	\N	\N	\N	14091	14091	14092
4561	3760	4	applied	\N	\N	\N	\N	14093	14093	14094
4561	3761	6	applied	\N	\N	\N	\N	14096	14096	14097
4561	3762	7	applied	\N	\N	\N	\N	14098	14098	14099
4561	3763	8	applied	\N	\N	\N	\N	14100	14100	14101
4561	3764	9	applied	\N	\N	\N	\N	14102	14102	14103
4561	3765	10	applied	\N	\N	\N	\N	14104	14104	14105
4561	3766	11	applied	\N	\N	\N	\N	14106	14106	14107
4561	3767	12	applied	\N	\N	\N	\N	14108	14108	14109
4561	3768	13	applied	\N	\N	\N	\N	14110	14110	14111
4561	3769	14	applied	\N	\N	\N	\N	14112	14112	14113
4564	3772	0	applied	\N	\N	\N	\N	14139	14139	14140
4564	3773	1	applied	\N	\N	\N	\N	14141	14141	14142
4569	3778	0	applied	\N	\N	\N	\N	14157	14157	14158
4571	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4571	3483	1	applied	\N	\N	1000000000	\N	13071	13071	13072
4571	3615	2	applied	\N	\N	1000000000	\N	13522	13522	13523
4571	3616	3	applied	\N	\N	1000000000	\N	13524	13524	13525
4571	3617	4	applied	\N	\N	1000000000	\N	13526	13526	13527
4571	3618	5	applied	\N	\N	\N	\N	13528	13528	13529
4571	3646	6	applied	\N	\N	1000000000	\N	13590	13590	13591
4571	3652	7	applied	\N	\N	1000000000	\N	13609	13609	13610
4571	3657	8	applied	\N	\N	1000000000	\N	13627	13627	13628
4571	3667	9	applied	\N	\N	1000000000	\N	13660	13660	13661
4571	3668	10	applied	\N	\N	\N	\N	13662	13662	13663
4571	3680	11	applied	\N	\N	1000000000	\N	13708	13708	13709
4571	3684	12	applied	\N	\N	1000000000	\N	13718	13718	13719
4571	3685	13	applied	\N	\N	1000000000	\N	13720	13720	13721
4571	3693	14	applied	\N	\N	\N	\N	13846	13846	13847
4571	3714	15	applied	\N	\N	1000000000	\N	13928	13928	13929
4571	3756	16	applied	\N	\N	1000000000	\N	14085	14085	14086
4571	3757	17	applied	\N	\N	\N	\N	14087	14087	14088
4571	3758	18	applied	\N	\N	\N	\N	14089	14089	14090
4571	3759	19	applied	\N	\N	\N	\N	14091	14091	14092
4571	3760	20	applied	\N	\N	\N	\N	14093	14093	14094
4571	3761	21	applied	\N	\N	\N	\N	14096	14096	14097
4571	3762	22	applied	\N	\N	\N	\N	14098	14098	14099
4571	3763	23	applied	\N	\N	\N	\N	14100	14100	14101
4571	3764	24	applied	\N	\N	\N	\N	14102	14102	14103
4571	3765	25	applied	\N	\N	\N	\N	14104	14104	14105
4571	3766	26	applied	\N	\N	\N	\N	14106	14106	14107
4571	3775	27	applied	\N	\N	\N	\N	14146	14146	14147
4571	3748	28	applied	\N	\N	1000000000	\N	14063	14063	14064
4571	3753	29	applied	\N	\N	\N	\N	14076	14076	14077
4571	3507	30	applied	\N	\N	\N	\N	13215	13215	13216
4571	3509	31	applied	\N	\N	\N	\N	13223	13223	13224
4571	3510	32	applied	\N	\N	\N	\N	13225	13225	13226
4571	3660	33	applied	\N	\N	\N	\N	13633	13633	13634
4571	3484	34	applied	\N	\N	\N	\N	13073	13073	13074
4571	3485	35	applied	\N	\N	\N	\N	13076	13076	13077
4571	3492	36	applied	\N	\N	\N	\N	13104	13104	13206
4571	3493	37	applied	\N	\N	\N	\N	13106	13106	13107
4571	3504	38	applied	\N	\N	\N	\N	12231	12231	12231
4571	3506	39	applied	\N	\N	\N	\N	13213	13213	13214
4571	3513	40	applied	\N	\N	\N	\N	13234	13234	13235
4571	3514	41	applied	\N	\N	\N	\N	13236	13236	13237
4571	3526	42	applied	\N	\N	\N	\N	13262	13262	13263
4571	3512	43	applied	\N	\N	\N	\N	13229	13229	13230
4571	3516	44	applied	\N	\N	\N	\N	13240	13240	13241
4571	3517	45	applied	\N	\N	\N	\N	13242	13242	13243
4571	3518	46	applied	\N	\N	\N	\N	13244	13244	13245
4571	3519	47	applied	\N	\N	\N	\N	13246	13246	13247
4571	3520	48	applied	\N	\N	\N	\N	13248	13248	13249
4571	3521	49	applied	\N	\N	\N	\N	13250	13250	13251
4571	3522	50	applied	\N	\N	\N	\N	13252	13252	13253
4571	3523	51	applied	\N	\N	\N	\N	13254	13254	13255
4571	3524	52	applied	\N	\N	\N	\N	13256	13256	13257
4571	3525	53	applied	\N	\N	\N	\N	13260	13260	13261
4571	3527	54	applied	\N	\N	\N	\N	13264	13264	13265
4571	3529	55	applied	\N	\N	\N	\N	13268	13268	13269
4571	3530	56	applied	\N	\N	\N	\N	13270	13270	13271
4571	3531	57	applied	\N	\N	\N	\N	13273	13273	13274
4571	3532	58	applied	\N	\N	\N	\N	13275	13275	13276
4571	3533	59	applied	\N	\N	\N	\N	13277	13277	13278
4571	3534	60	applied	\N	\N	\N	\N	13279	13279	13280
4571	3535	61	applied	\N	\N	\N	\N	13281	13281	13282
4571	3537	62	applied	\N	\N	\N	\N	13292	13292	13293
4571	3538	63	applied	\N	\N	\N	\N	13294	13294	13295
4571	3539	64	applied	\N	\N	\N	\N	13296	13296	13297
4571	3540	65	applied	\N	\N	\N	\N	13298	13298	13299
4571	3541	66	applied	\N	\N	\N	\N	13300	13300	13301
4571	3542	67	applied	\N	\N	\N	\N	13302	13302	13303
4571	3543	68	applied	\N	\N	\N	\N	13304	13304	13305
4571	3544	69	applied	\N	\N	\N	\N	13306	13306	13307
4571	3545	70	applied	\N	\N	\N	\N	13308	13308	13309
4571	3547	71	applied	\N	\N	\N	\N	13317	13317	13318
4571	3548	72	applied	\N	\N	\N	\N	13319	13319	13320
4571	3549	73	applied	\N	\N	\N	\N	13321	13321	13322
4571	3550	74	applied	\N	\N	\N	\N	13323	13323	13324
4571	3551	75	applied	\N	\N	\N	\N	13325	13325	13326
4571	3552	76	applied	\N	\N	\N	\N	13327	13327	13328
4571	3553	77	applied	\N	\N	\N	\N	13329	13329	13330
4571	3554	78	applied	\N	\N	\N	\N	13331	13331	13332
4571	3555	79	applied	\N	\N	\N	\N	13333	13333	13334
4571	3556	80	applied	\N	\N	\N	\N	13339	13339	13340
4571	3558	81	applied	\N	\N	\N	\N	13343	13343	13344
4571	3559	82	applied	\N	\N	\N	\N	13345	13345	13346
4571	3560	83	applied	\N	\N	\N	\N	13347	13347	13348
4571	3561	84	applied	\N	\N	\N	\N	13349	13349	13350
4571	3562	85	applied	\N	\N	\N	\N	13351	13351	13352
4571	3563	87	applied	\N	\N	\N	\N	13353	13353	13354
4571	3564	88	applied	\N	\N	\N	\N	13355	13355	13356
4571	3565	89	applied	\N	\N	\N	\N	13357	13357	13358
4571	3567	90	applied	\N	\N	\N	\N	13364	13364	13365
4571	3568	91	applied	\N	\N	\N	\N	13366	13366	13367
4571	3569	92	applied	\N	\N	\N	\N	13368	13368	13369
4571	3570	93	applied	\N	\N	\N	\N	13370	13370	13371
4571	3571	94	applied	\N	\N	\N	\N	13372	13372	13373
4571	3572	95	applied	\N	\N	\N	\N	13374	13374	13375
4571	3573	96	applied	\N	\N	\N	\N	13376	13376	13377
4571	3574	97	applied	\N	\N	\N	\N	13378	13378	13379
4571	3576	98	applied	\N	\N	\N	\N	13439	13439	13440
4571	3577	99	applied	\N	\N	\N	\N	13441	13441	13442
4571	3578	100	applied	\N	\N	\N	\N	13443	13443	13444
4571	3579	101	applied	\N	\N	\N	\N	13445	13445	13446
4571	3580	102	applied	\N	\N	\N	\N	13447	13447	13448
4571	3581	103	applied	\N	\N	\N	\N	13449	13449	13450
4571	3582	104	applied	\N	\N	\N	\N	13451	13451	13452
4571	3583	105	applied	\N	\N	\N	\N	13453	13453	13454
4571	3584	106	applied	\N	\N	\N	\N	13455	13455	13456
4571	3585	107	applied	\N	\N	\N	\N	13458	13458	13459
4571	3587	108	applied	\N	\N	\N	\N	13462	13462	13463
4571	3588	109	applied	\N	\N	\N	\N	13464	13464	13465
4571	3589	110	applied	\N	\N	\N	\N	13466	13466	13467
4571	3590	111	applied	\N	\N	\N	\N	13468	13468	13469
4571	3591	112	applied	\N	\N	\N	\N	13470	13470	13471
4571	3592	113	applied	\N	\N	\N	\N	13472	13472	13473
4571	3593	114	applied	\N	\N	\N	\N	13474	13474	13475
4571	3594	115	applied	\N	\N	\N	\N	13476	13476	13477
4571	3595	116	applied	\N	\N	\N	\N	13479	13479	13480
4571	3596	117	applied	\N	\N	\N	\N	13481	13481	13482
4571	3597	118	applied	\N	\N	\N	\N	13483	13483	13484
4571	3599	119	applied	\N	\N	\N	\N	13487	13487	13488
4571	3600	120	applied	\N	\N	\N	\N	13489	13489	13490
4571	3601	121	applied	\N	\N	\N	\N	13491	13491	13492
4571	3602	122	applied	\N	\N	\N	\N	13493	13493	13494
4571	3603	123	applied	\N	\N	\N	\N	13495	13495	13496
4571	3604	124	applied	\N	\N	\N	\N	13497	13497	13498
4571	3606	125	applied	\N	\N	\N	\N	13501	13501	13502
4574	3784	0	applied	\N	\N	\N	\N	14179	14179	14180
4583	3788	0	applied	\N	\N	\N	\N	14196	14196	14197
4587	3790	0	applied	\N	\N	1000000000	\N	14204	14204	14205
4587	3791	1	applied	\N	\N	\N	\N	14206	14206	14207
4587	3792	2	applied	\N	\N	\N	\N	14208	14208	14209
4587	3793	3	applied	\N	\N	\N	\N	14210	14210	14211
4587	3794	4	applied	\N	\N	\N	\N	14212	14212	14213
4591	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4591	3693	1	applied	\N	\N	\N	\N	13846	13846	13847
4591	3714	2	applied	\N	\N	1000000000	\N	13928	13928	13929
4591	3756	3	applied	\N	\N	1000000000	\N	14085	14085	14086
4591	3757	4	applied	\N	\N	\N	\N	14087	14087	14088
4591	3758	5	applied	\N	\N	\N	\N	14089	14089	14090
4591	3759	6	applied	\N	\N	\N	\N	14091	14091	14092
4591	3760	7	applied	\N	\N	\N	\N	14093	14093	14094
4591	3761	8	applied	\N	\N	\N	\N	14096	14096	14097
4591	3762	9	applied	\N	\N	\N	\N	14098	14098	14099
4591	3763	10	applied	\N	\N	\N	\N	14100	14100	14101
4591	3764	11	applied	\N	\N	\N	\N	14102	14102	14103
4591	3765	12	applied	\N	\N	\N	\N	14104	14104	14105
4591	3766	13	applied	\N	\N	\N	\N	14106	14106	14107
4591	3775	14	applied	\N	\N	\N	\N	14146	14146	14147
4591	3782	15	applied	\N	\N	\N	\N	14174	14174	14175
4591	3790	16	applied	\N	\N	1000000000	\N	14204	14204	14205
4591	3748	17	applied	\N	\N	1000000000	\N	14063	14063	14064
4591	3753	18	applied	\N	\N	\N	\N	14076	14076	14077
4591	3719	19	applied	\N	\N	1000000000	\N	13944	13944	14230
4591	3715	20	applied	\N	\N	\N	\N	13930	13930	14231
4591	3713	21	applied	\N	\N	\N	\N	13918	13918	14232
4591	3718	22	applied	\N	\N	\N	\N	13936	13936	14233
4591	3643	23	applied	\N	\N	\N	\N	13583	13583	7276
4591	3644	24	applied	\N	\N	\N	\N	13584	13584	13584
4591	3645	25	applied	\N	\N	\N	\N	13585	13585	7276
4594	3802	0	applied	\N	\N	\N	\N	14243	14243	1435
4594	3803	1	applied	\N	\N	\N	\N	14244	14244	14245
4600	3811	0	applied	\N	\N	\N	\N	14265	14265	14266
4603	3814	0	applied	\N	\N	\N	\N	14273	14273	14274
4605	3815	0	applied	\N	\N	\N	\N	14277	14277	14278
4607	3816	0	applied	\N	\N	\N	\N	14282	14282	14283
4615	3822	0	applied	\N	\N	\N	\N	14306	14306	8545
4615	3823	1	applied	\N	\N	\N	\N	14307	14307	14308
4615	3824	2	applied	\N	\N	\N	\N	14309	14309	14310
4617	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4617	3822	1	applied	\N	\N	\N	\N	14306	14306	8545
4617	3657	2	applied	\N	\N	1000000000	\N	13627	13627	13628
4617	3667	3	applied	\N	\N	1000000000	\N	13660	13660	13661
4617	3668	4	applied	\N	\N	\N	\N	13662	13662	13663
4617	3680	5	applied	\N	\N	1000000000	\N	13708	13708	13709
4617	3684	6	applied	\N	\N	1000000000	\N	13718	13718	13719
4617	3685	7	applied	\N	\N	1000000000	\N	13720	13720	13721
4617	3693	8	applied	\N	\N	\N	\N	13846	13846	13847
4617	3714	9	applied	\N	\N	1000000000	\N	13928	13928	13929
4617	3756	10	applied	\N	\N	1000000000	\N	14085	14085	14086
4617	3757	11	applied	\N	\N	\N	\N	14087	14087	14088
4617	3758	12	applied	\N	\N	\N	\N	14089	14089	14090
4617	3759	13	applied	\N	\N	\N	\N	14091	14091	14092
4617	3760	14	applied	\N	\N	\N	\N	14093	14093	14094
4617	3761	15	applied	\N	\N	\N	\N	14096	14096	14097
4617	3762	16	applied	\N	\N	\N	\N	14098	14098	14099
4617	3763	17	applied	\N	\N	\N	\N	14100	14100	14101
4617	3764	18	applied	\N	\N	\N	\N	14102	14102	14103
4617	3765	19	applied	\N	\N	\N	\N	14104	14104	14105
4617	3766	20	applied	\N	\N	\N	\N	14106	14106	14107
4617	3775	21	applied	\N	\N	\N	\N	14146	14146	14147
4617	3782	22	applied	\N	\N	\N	\N	14174	14174	14175
4617	3790	23	applied	\N	\N	1000000000	\N	14204	14204	14205
4617	3748	24	applied	\N	\N	1000000000	\N	14063	14063	14064
4617	3753	25	applied	\N	\N	\N	\N	14076	14076	14077
4617	3658	26	applied	\N	\N	\N	\N	13629	13629	13630
4617	3659	27	applied	\N	\N	\N	\N	13631	13631	13632
4617	3660	28	applied	\N	\N	\N	\N	13633	13633	13634
4617	3661	29	applied	\N	\N	\N	\N	13638	13638	13639
4617	3662	30	applied	\N	\N	\N	\N	13640	13640	13641
4617	3663	31	applied	\N	\N	\N	\N	13647	13647	13648
4617	3664	32	applied	\N	\N	\N	\N	13649	13649	13650
4617	3665	33	applied	\N	\N	\N	\N	13654	13654	13655
4617	3666	34	applied	\N	\N	\N	\N	13656	13656	13657
4617	3669	35	applied	\N	\N	\N	\N	13664	13664	13665
4617	3671	36	applied	\N	\N	\N	\N	13674	13674	13675
4617	3673	37	applied	\N	\N	\N	\N	13688	13688	13689
4617	3675	38	applied	\N	\N	\N	\N	13692	13692	13693
4617	3676	39	applied	\N	\N	\N	\N	13695	13695	13696
4617	3718	40	applied	\N	\N	1000000000	\N	13936	13936	14313
4617	3678	41	applied	\N	\N	\N	\N	13700	13700	13701
4617	3679	42	applied	\N	\N	\N	\N	13704	13704	13705
4617	3681	43	applied	\N	\N	\N	\N	13710	13710	13711
4617	3682	44	applied	\N	\N	\N	\N	13712	13712	13713
4617	3683	45	applied	\N	\N	\N	\N	13715	13715	13716
4617	3686	46	applied	\N	\N	\N	\N	13722	13722	13723
4617	3688	47	applied	\N	\N	\N	\N	13827	13827	13828
4589	3741	50	applied	\N	\N	\N	\N	14037	14037	14038
4589	3742	51	applied	\N	\N	\N	\N	14041	14041	14042
4589	3743	52	applied	\N	\N	\N	\N	14047	14047	14048
4589	3744	53	applied	\N	\N	\N	\N	14050	14050	14051
4589	3745	54	applied	\N	\N	\N	\N	14054	14054	14055
4589	3746	55	applied	\N	\N	\N	\N	14058	14058	14059
4589	3747	56	applied	\N	\N	\N	\N	14060	14060	14061
4589	3749	57	applied	\N	\N	\N	\N	14065	14065	14066
4589	3750	58	applied	\N	\N	\N	\N	14068	14068	14069
4589	3751	59	applied	\N	\N	\N	\N	14070	14070	14071
4589	3752	60	applied	\N	\N	\N	\N	14073	14073	14074
4589	3754	61	applied	\N	\N	\N	\N	14078	14078	14079
4589	3755	62	applied	\N	\N	\N	\N	14081	14081	14082
4589	3767	63	applied	\N	\N	\N	\N	14108	14108	14109
4589	3768	64	applied	\N	\N	\N	\N	14110	14110	14111
4589	3769	65	applied	\N	\N	\N	\N	14112	14112	14113
4589	3770	66	applied	\N	\N	\N	\N	14125	14125	14126
4589	3771	67	applied	\N	\N	\N	\N	14135	14135	14136
4589	3772	68	applied	\N	\N	\N	\N	14139	14139	14140
4589	3773	69	applied	\N	\N	\N	\N	14141	14141	14142
4589	3776	70	applied	\N	\N	\N	\N	14148	14148	14149
4589	3777	71	applied	\N	\N	\N	\N	14153	14153	14154
4589	3778	72	applied	\N	\N	\N	\N	14157	14157	14158
4589	3779	73	applied	\N	\N	\N	\N	14161	14161	14162
4589	3780	74	applied	\N	\N	\N	\N	14168	14168	14169
4589	3781	75	applied	\N	\N	\N	\N	14170	14170	14171
4589	3783	76	applied	\N	\N	\N	\N	14176	14176	14177
4589	3784	77	applied	\N	\N	\N	\N	14179	14179	14180
4589	3785	78	applied	\N	\N	\N	\N	14185	14185	14186
4589	3786	79	applied	\N	\N	\N	\N	14187	14187	14188
4589	3787	80	applied	\N	\N	\N	\N	14193	14193	14194
4589	3788	81	applied	\N	\N	\N	\N	14196	14196	14197
4589	3789	82	applied	\N	\N	\N	\N	14202	14202	14203
4589	3791	83	applied	\N	\N	\N	\N	14206	14206	14207
4589	3792	84	applied	\N	\N	\N	\N	14208	14208	14209
4589	3793	85	applied	\N	\N	\N	\N	14210	14210	14211
4589	3794	86	applied	\N	\N	\N	\N	14212	14212	14213
4589	3718	87	applied	\N	\N	\N	\N	13936	13936	13945
4592	3799	0	applied	\N	\N	\N	\N	14236	14236	14237
4595	3804	0	applied	\N	\N	\N	\N	14248	14248	14249
4595	3805	1	applied	\N	\N	\N	\N	14250	14250	1435
4595	3806	2	applied	\N	\N	\N	\N	14251	14251	14252
4601	3812	0	applied	\N	\N	\N	\N	14267	14267	14268
4601	3813	1	applied	\N	\N	\N	\N	14269	14269	14270
4608	3817	0	applied	\N	\N	\N	\N	14287	14287	14288
4611	3821	0	applied	\N	\N	\N	\N	14298	14298	14299
4613	3821	0	applied	\N	\N	\N	\N	14298	14298	14299
4620	3826	0	applied	\N	\N	\N	\N	14321	14321	14322
4622	3826	0	applied	\N	\N	\N	\N	14321	14321	14322
4627	3828	0	applied	\N	\N	\N	\N	14334	14334	14335
4627	3829	1	applied	\N	\N	\N	\N	14336	14336	14337
4627	3830	2	applied	\N	\N	\N	\N	14338	14338	14339
4629	3831	0	applied	\N	\N	\N	\N	14343	14343	14344
4639	3836	0	applied	\N	\N	\N	\N	14363	14363	14364
4645	3838	0	applied	\N	\N	\N	\N	14375	14375	14376
4647	3838	0	applied	\N	\N	\N	\N	14375	14375	14376
4649	3838	0	applied	\N	\N	\N	\N	14375	14375	14376
4617	3689	48	applied	\N	\N	\N	\N	13833	13833	13834
4617	3690	49	applied	\N	\N	\N	\N	13838	13838	13839
4617	3691	50	applied	\N	\N	\N	\N	13840	13840	13841
4617	3692	51	applied	\N	\N	\N	\N	13844	13844	13845
4617	3694	52	applied	\N	\N	\N	\N	13848	13848	13849
4617	3695	54	applied	\N	\N	\N	\N	13850	13850	13851
4617	3697	55	applied	\N	\N	\N	\N	13858	13858	13859
4617	3698	56	applied	\N	\N	\N	\N	13860	13860	13861
4617	3699	57	applied	\N	\N	\N	\N	13862	13862	13863
4617	3700	58	applied	\N	\N	\N	\N	13864	13864	13865
4617	3701	59	applied	\N	\N	\N	\N	13866	13866	13867
4617	3702	60	applied	\N	\N	\N	\N	13870	13870	13871
4617	3704	61	applied	\N	\N	\N	\N	13876	13876	13877
4617	3705	62	applied	\N	\N	\N	\N	13882	13882	13883
4617	3706	63	applied	\N	\N	\N	\N	13890	13890	13891
4617	3707	64	applied	\N	\N	\N	\N	13896	13896	13897
4617	3708	65	applied	\N	\N	\N	\N	13900	13900	13901
4617	3709	66	applied	\N	\N	\N	\N	13904	13904	13905
4617	3710	67	applied	\N	\N	\N	\N	13908	13908	13909
4617	3711	68	applied	\N	\N	\N	\N	13914	13914	13915
4617	3716	69	applied	\N	\N	\N	\N	13932	13932	13933
4617	3717	70	applied	\N	\N	\N	\N	13934	13934	13935
4617	3720	71	applied	\N	\N	\N	\N	13946	13946	13947
4617	3721	72	applied	\N	\N	\N	\N	13948	13948	13949
4617	3722	73	applied	\N	\N	\N	\N	13950	13950	13951
4617	3723	74	applied	\N	\N	\N	\N	13953	13953	13954
4617	3724	75	applied	\N	\N	\N	\N	13955	13955	13956
4617	3725	76	applied	\N	\N	\N	\N	13957	13957	13958
4617	3726	77	applied	\N	\N	\N	\N	13963	13963	13964
4617	3727	78	applied	\N	\N	\N	\N	13966	13966	13967
4617	3728	79	applied	\N	\N	\N	\N	13980	13980	13981
4617	3729	80	applied	\N	\N	\N	\N	13982	13982	13983
4617	3730	81	applied	\N	\N	\N	\N	13986	13986	13987
4617	3731	82	applied	\N	\N	\N	\N	13990	13990	13991
4617	3732	83	applied	\N	\N	\N	\N	13996	13996	13997
4617	3733	84	applied	\N	\N	\N	\N	13998	13998	13999
4617	3734	85	applied	\N	\N	\N	\N	14002	14002	14003
4617	3735	86	applied	\N	\N	\N	\N	14006	14006	14007
4617	3736	87	applied	\N	\N	\N	\N	14008	14008	14009
4617	3737	88	applied	\N	\N	\N	\N	14012	14012	14013
4617	3738	89	applied	\N	\N	\N	\N	14017	14017	14018
4617	3739	90	applied	\N	\N	\N	\N	14022	14022	14023
4617	3740	91	applied	\N	\N	\N	\N	14030	14030	14031
4617	3741	92	applied	\N	\N	\N	\N	14037	14037	14038
4617	3742	93	applied	\N	\N	\N	\N	14041	14041	14042
4617	3743	94	applied	\N	\N	\N	\N	14047	14047	14048
4617	3744	95	applied	\N	\N	\N	\N	14050	14050	14051
4617	3745	96	applied	\N	\N	\N	\N	14054	14054	14055
4617	3746	97	applied	\N	\N	\N	\N	14058	14058	14059
4617	3747	98	applied	\N	\N	\N	\N	14060	14060	14061
4619	3825	0	applied	\N	\N	\N	\N	14317	14317	14318
4624	3827	0	applied	\N	\N	\N	\N	14328	14328	14329
4626	3827	0	applied	\N	\N	\N	\N	14328	14328	14329
4632	3832	0	applied	\N	\N	\N	\N	14345	14345	14346
4636	3833	0	applied	\N	\N	\N	\N	14355	14355	14356
4638	3836	0	applied	\N	\N	\N	\N	14363	14363	14364
4641	3836	0	applied	\N	\N	\N	\N	14363	14363	14364
4642	3837	0	applied	\N	\N	\N	\N	14368	14368	14369
4644	3837	0	applied	\N	\N	\N	\N	14368	14368	14369
4653	3843	0	applied	\N	\N	\N	\N	14397	14397	14398
4653	3844	1	applied	\N	\N	\N	\N	14399	14399	14400
4655	3845	0	applied	\N	\N	\N	\N	14406	14406	14407
4656	3846	0	applied	\N	\N	\N	\N	14410	14410	14411
4656	3847	1	applied	\N	\N	\N	\N	14412	14412	14413
4656	3848	2	applied	\N	\N	\N	\N	14414	14414	14415
4656	3849	3	applied	\N	\N	\N	\N	14416	14416	14417
4656	3850	4	applied	\N	\N	\N	\N	14418	14418	14419
4656	3851	5	applied	\N	\N	\N	\N	10287	10287	14420
4656	3852	6	applied	\N	\N	\N	\N	14421	14421	14422
4657	3853	0	applied	\N	\N	\N	\N	14425	14425	14426
4658	3854	0	applied	\N	\N	\N	\N	14429	14429	14430
4659	3855	0	applied	\N	\N	\N	\N	14431	14431	14432
4660	3855	0	applied	\N	\N	\N	\N	14431	14431	14432
4661	3856	0	applied	\N	\N	\N	\N	14433	14433	14434
4662	3856	0	applied	\N	\N	\N	\N	14433	14433	14434
4663	3856	0	applied	\N	\N	\N	\N	14433	14433	14434
4664	3857	0	applied	\N	\N	\N	\N	14437	14437	14438
4665	3858	0	applied	\N	\N	\N	\N	14439	14439	14440
4666	3859	0	applied	\N	\N	\N	\N	14441	14441	14442
4667	3859	0	applied	\N	\N	\N	\N	14441	14441	14442
4668	3860	0	applied	\N	\N	\N	\N	14446	14446	14447
4669	3860	0	applied	\N	\N	\N	\N	14446	14446	14447
4670	3861	0	applied	\N	\N	\N	\N	14450	14450	14451
4670	3862	1	applied	\N	\N	\N	\N	14452	14452	14453
4671	3861	0	applied	\N	\N	\N	\N	14450	14450	14451
4671	3862	1	applied	\N	\N	\N	\N	14452	14452	14453
4672	3861	0	applied	\N	\N	\N	\N	14450	14450	14451
4672	3862	1	applied	\N	\N	\N	\N	14452	14452	14453
4673	3863	0	applied	\N	\N	\N	\N	14458	14458	14459
4674	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4674	3822	1	applied	\N	\N	\N	\N	14306	14306	8545
4674	3714	2	applied	\N	\N	1000000000	\N	13928	13928	13929
4674	3756	3	applied	\N	\N	1000000000	\N	14085	14085	14086
4674	3757	4	applied	\N	\N	\N	\N	14087	14087	14088
4674	3758	5	applied	\N	\N	\N	\N	14089	14089	14090
4674	3759	6	applied	\N	\N	\N	\N	14091	14091	14092
4674	3760	7	applied	\N	\N	\N	\N	14093	14093	14094
4674	3761	8	applied	\N	\N	\N	\N	14096	14096	14097
4674	3762	9	applied	\N	\N	\N	\N	14098	14098	14099
4674	3763	10	applied	\N	\N	\N	\N	14100	14100	14101
4674	3764	11	applied	\N	\N	\N	\N	14102	14102	14103
4674	3765	12	applied	\N	\N	\N	\N	14104	14104	14105
4674	3766	13	applied	\N	\N	\N	\N	14106	14106	14107
4674	3775	14	applied	\N	\N	\N	\N	14146	14146	14147
4674	3782	15	applied	\N	\N	\N	\N	14174	14174	14175
4674	3790	16	applied	\N	\N	1000000000	\N	14204	14204	14205
4674	3748	17	applied	\N	\N	1000000000	\N	14063	14063	14064
4674	3753	18	applied	\N	\N	\N	\N	14076	14076	14077
4674	3709	19	applied	\N	\N	\N	\N	13904	13904	13905
4674	3719	20	applied	\N	\N	\N	\N	13944	13944	14219
4674	3844	21	applied	\N	\N	\N	\N	14399	14399	14400
4674	3712	22	applied	\N	\N	\N	\N	13916	13916	13976
4674	3715	23	applied	\N	\N	\N	\N	13930	13930	13977
4674	3713	24	applied	\N	\N	\N	\N	13918	13918	13978
4674	3710	25	applied	\N	\N	\N	\N	13908	13908	13909
4674	3711	26	applied	\N	\N	\N	\N	13914	13914	13915
4674	3716	27	applied	\N	\N	\N	\N	13932	13932	13933
4674	3717	28	applied	\N	\N	\N	\N	13934	13934	13935
4674	3720	29	applied	\N	\N	\N	\N	13946	13946	13947
4674	3721	30	applied	\N	\N	\N	\N	13948	13948	13949
4674	3722	31	applied	\N	\N	\N	\N	13950	13950	13951
4674	3723	32	applied	\N	\N	\N	\N	13953	13953	13954
4674	3724	33	applied	\N	\N	\N	\N	13955	13955	13956
4674	3725	34	applied	\N	\N	\N	\N	13957	13957	13958
4674	3726	35	applied	\N	\N	\N	\N	13963	13963	13964
4674	3727	36	applied	\N	\N	\N	\N	13966	13966	13967
4674	3728	37	applied	\N	\N	\N	\N	13980	13980	13981
4674	3729	38	applied	\N	\N	\N	\N	13982	13982	13983
4674	3730	39	applied	\N	\N	\N	\N	13986	13986	13987
4674	3731	40	applied	\N	\N	\N	\N	13990	13990	13991
4674	3732	41	applied	\N	\N	\N	\N	13996	13996	13997
4674	3733	42	applied	\N	\N	\N	\N	13998	13998	13999
4674	3734	43	applied	\N	\N	\N	\N	14002	14002	14003
4674	3735	44	applied	\N	\N	\N	\N	14006	14006	14007
4674	3736	45	applied	\N	\N	\N	\N	14008	14008	14009
4674	3737	46	applied	\N	\N	\N	\N	14012	14012	14013
4674	3738	47	applied	\N	\N	\N	\N	14017	14017	14018
4674	3739	48	applied	\N	\N	\N	\N	14022	14022	14023
4674	3740	49	applied	\N	\N	\N	\N	14030	14030	14031
4674	3741	50	applied	\N	\N	\N	\N	14037	14037	14038
4674	3742	51	applied	\N	\N	\N	\N	14041	14041	14042
4674	3743	52	applied	\N	\N	\N	\N	14047	14047	14048
4674	3744	53	applied	\N	\N	\N	\N	14050	14050	14051
4674	3745	54	applied	\N	\N	\N	\N	14054	14054	14055
4674	3746	55	applied	\N	\N	\N	\N	14058	14058	14059
4674	3747	56	applied	\N	\N	\N	\N	14060	14060	14061
4674	3749	57	applied	\N	\N	\N	\N	14065	14065	14066
4674	3750	58	applied	\N	\N	\N	\N	14068	14068	14069
4674	3751	59	applied	\N	\N	\N	\N	14070	14070	14071
4674	3752	60	applied	\N	\N	\N	\N	14073	14073	14074
4674	3754	61	applied	\N	\N	\N	\N	14078	14078	14079
4674	3755	62	applied	\N	\N	\N	\N	14081	14081	14082
4674	3767	63	applied	\N	\N	\N	\N	14108	14108	14109
4674	3768	64	applied	\N	\N	\N	\N	14110	14110	14111
4674	3769	65	applied	\N	\N	\N	\N	14112	14112	14113
4674	3770	66	applied	\N	\N	\N	\N	14125	14125	14126
4674	3771	67	applied	\N	\N	\N	\N	14135	14135	14136
4674	3772	68	applied	\N	\N	\N	\N	14139	14139	14140
4674	3773	69	applied	\N	\N	\N	\N	14141	14141	14142
4674	3776	70	applied	\N	\N	\N	\N	14148	14148	14149
4674	3777	71	applied	\N	\N	\N	\N	14153	14153	14154
4674	3778	72	applied	\N	\N	\N	\N	14157	14157	14158
4674	3779	73	applied	\N	\N	\N	\N	14161	14161	14162
4674	3780	74	applied	\N	\N	\N	\N	14168	14168	14169
4674	3781	75	applied	\N	\N	\N	\N	14170	14170	14171
4674	3783	76	applied	\N	\N	\N	\N	14176	14176	14177
4674	3784	77	applied	\N	\N	\N	\N	14179	14179	14180
4674	3785	78	applied	\N	\N	\N	\N	14185	14185	14186
4674	3786	79	applied	\N	\N	\N	\N	14187	14187	14188
4674	3787	80	applied	\N	\N	\N	\N	14193	14193	14194
4674	3788	81	applied	\N	\N	\N	\N	14196	14196	14197
4674	3789	82	applied	\N	\N	\N	\N	14202	14202	14203
4674	3791	83	applied	\N	\N	\N	\N	14206	14206	14207
4674	3792	84	applied	\N	\N	\N	\N	14208	14208	14209
4674	3793	85	applied	\N	\N	\N	\N	14210	14210	14211
4674	3794	86	applied	\N	\N	\N	\N	14212	14212	14213
4674	3795	87	applied	\N	\N	\N	\N	14221	14221	14222
4674	3796	88	applied	\N	\N	\N	\N	14223	14223	14224
4674	3797	89	applied	\N	\N	\N	\N	14225	14225	14226
4674	3798	90	applied	\N	\N	\N	\N	14227	14227	14228
4674	3799	91	applied	\N	\N	\N	\N	14236	14236	14237
4674	3800	92	applied	\N	\N	\N	\N	14238	14238	14239
4674	3801	93	applied	\N	\N	\N	\N	14240	14240	14241
4674	3803	94	applied	\N	\N	\N	\N	14244	14244	14245
4674	3804	95	applied	\N	\N	\N	\N	14248	14248	14249
4674	3806	96	applied	\N	\N	\N	\N	14251	14251	14252
4674	3807	97	applied	\N	\N	\N	\N	14255	14255	14256
4674	3808	98	applied	\N	\N	\N	\N	14258	14258	14259
4674	3809	99	applied	\N	\N	\N	\N	14260	14260	14261
4674	3810	100	applied	\N	\N	\N	\N	14262	14262	14263
4674	3811	101	applied	\N	\N	\N	\N	14265	14265	14266
4674	3812	102	applied	\N	\N	\N	\N	14267	14267	14268
4674	3813	103	applied	\N	\N	\N	\N	14269	14269	14270
4674	3814	104	applied	\N	\N	\N	\N	14273	14273	14274
4674	3815	105	applied	\N	\N	\N	\N	14277	14277	14278
4674	3816	106	applied	\N	\N	\N	\N	14282	14282	14283
4674	3817	107	applied	\N	\N	\N	\N	14287	14287	14288
4674	3718	108	applied	\N	\N	\N	\N	13936	13936	13945
4674	3818	109	applied	\N	\N	\N	\N	14289	14289	14290
4674	3819	110	applied	\N	\N	\N	\N	14291	14291	14292
4674	3820	111	applied	\N	\N	\N	\N	14295	14295	14296
4674	3821	112	applied	\N	\N	\N	\N	14298	14298	14299
4674	3823	113	applied	\N	\N	\N	\N	14307	14307	14308
4674	3824	115	applied	\N	\N	\N	\N	14309	14309	14310
4674	3825	116	applied	\N	\N	\N	\N	14317	14317	14318
4674	3826	117	applied	\N	\N	\N	\N	14321	14321	14322
4674	3827	118	applied	\N	\N	\N	\N	14328	14328	14329
4674	3828	119	applied	\N	\N	\N	\N	14334	14334	14335
4674	3829	120	applied	\N	\N	\N	\N	14336	14336	14337
4674	3830	121	applied	\N	\N	\N	\N	14338	14338	14339
4674	3831	122	applied	\N	\N	\N	\N	14343	14343	14344
4674	3832	123	applied	\N	\N	\N	\N	14345	14345	14346
4674	3833	124	applied	\N	\N	\N	\N	14355	14355	14356
4674	3834	125	applied	\N	\N	\N	\N	14357	14357	14358
4683	3868	0	applied	\N	\N	\N	\N	14481	14481	14482
4689	3872	0	applied	\N	\N	\N	\N	14497	14497	14498
4697	3878	0	applied	\N	\N	\N	\N	14518	14518	14519
4698	3878	0	applied	\N	\N	\N	\N	14518	14518	14519
4699	3879	0	applied	\N	\N	\N	\N	14524	14524	14525
4703	3880	0	applied	\N	\N	\N	\N	14527	14527	14528
4713	3887	0	applied	\N	\N	\N	\N	14557	14557	14558
4731	3900	0	applied	\N	\N	\N	\N	14605	14605	14606
4731	3901	1	applied	\N	\N	\N	\N	14607	14607	14608
4731	3902	2	applied	\N	\N	\N	\N	14609	14609	14610
4733	3903	0	applied	\N	\N	\N	\N	14614	14614	14615
4736	3904	0	applied	\N	\N	\N	\N	14618	14618	14619
4738	3907	0	applied	\N	\N	\N	\N	14627	14627	14628
4738	3908	1	applied	\N	\N	\N	\N	14629	14629	14630
4743	3912	0	applied	\N	\N	\N	\N	14646	14646	14647
4743	3913	1	applied	\N	\N	\N	\N	14648	14648	14649
4748	3914	0	applied	\N	\N	\N	\N	14653	14653	14654
4748	3915	1	applied	\N	\N	\N	\N	14655	14655	14656
4748	3916	2	applied	\N	\N	\N	\N	14657	14657	14658
4751	3917	0	applied	\N	\N	\N	\N	14664	14664	14665
4760	3924	0	applied	\N	\N	\N	\N	14689	14689	14690
4770	3929	0	applied	\N	\N	\N	\N	14716	14716	14717
4770	3930	1	applied	\N	\N	\N	\N	14718	14718	14719
4770	3931	2	applied	\N	\N	\N	\N	14720	14720	14721
4770	3932	3	applied	\N	\N	\N	\N	14722	14722	14723
4675	3864	0	applied	\N	\N	\N	\N	14463	14463	14464
4678	3865	0	applied	\N	\N	\N	\N	14467	14467	14468
4678	3866	1	applied	\N	\N	\N	\N	14469	14469	14470
4682	3868	0	applied	\N	\N	\N	\N	14481	14481	14482
4685	3870	0	applied	\N	\N	\N	\N	14489	14489	14490
4687	3871	0	applied	\N	\N	\N	\N	14493	14493	14494
4692	3874	0	applied	\N	\N	\N	\N	14505	14505	14506
4701	3879	0	applied	\N	\N	\N	\N	14524	14524	14525
4705	3861	0	applied	\N	\N	\N	\N	14450	14450	14451
4705	3857	1	applied	\N	\N	\N	\N	14437	14437	14438
4705	3858	2	applied	\N	\N	\N	\N	14439	14439	14440
4705	3859	3	applied	\N	\N	\N	\N	14441	14441	14442
4705	3860	4	applied	\N	\N	\N	\N	14446	14446	14447
4705	3877	5	applied	\N	\N	1000000000	\N	14514	14514	14515
4705	3862	6	applied	\N	\N	\N	\N	14452	14452	14453
4705	3863	7	applied	\N	\N	\N	\N	14458	14458	14459
4705	3864	8	applied	\N	\N	\N	\N	14463	14463	14464
4705	3865	9	applied	\N	\N	\N	\N	14467	14467	14468
4705	3866	10	applied	\N	\N	\N	\N	14469	14469	14470
4705	3867	11	applied	\N	\N	\N	\N	14473	14473	14474
4705	3868	12	applied	\N	\N	\N	\N	14481	14481	14482
4705	3869	13	applied	\N	\N	\N	\N	14485	14485	14486
4705	3870	14	applied	\N	\N	\N	\N	14489	14489	14490
4705	3871	15	applied	\N	\N	\N	\N	14493	14493	14494
4705	3872	16	applied	\N	\N	\N	\N	14497	14497	14498
4705	3873	17	applied	\N	\N	\N	\N	14502	14502	14503
4705	3874	18	applied	\N	\N	\N	\N	14505	14505	14506
4705	3875	19	applied	\N	\N	\N	\N	14510	14510	14511
4705	3876	20	applied	\N	\N	\N	\N	14512	14512	14513
4705	3878	21	applied	\N	\N	\N	\N	14518	14518	14519
4705	3879	22	applied	\N	\N	\N	\N	14524	14524	14529
4705	3880	23	applied	\N	\N	\N	\N	14527	14527	14530
4707	3881	0	applied	\N	\N	\N	\N	14532	14532	14533
4708	3882	0	applied	\N	\N	\N	\N	14538	14538	14539
4712	3886	0	applied	\N	\N	\N	\N	14551	14551	14552
4714	3887	0	applied	\N	\N	\N	\N	14557	14557	14558
4716	3888	0	applied	\N	\N	\N	\N	14559	14559	14560
4717	3889	0	applied	\N	\N	\N	\N	14565	14565	14566
4720	3893	0	applied	\N	\N	\N	\N	14578	14578	14579
4726	3896	0	applied	\N	\N	\N	\N	14588	14588	14589
4726	3897	1	applied	\N	\N	\N	\N	14590	14590	14591
4728	3898	0	applied	\N	\N	\N	\N	14596	14596	14597
4728	3899	1	applied	\N	\N	\N	\N	14598	14598	14599
4730	3898	0	applied	\N	\N	\N	\N	14596	14596	14597
4730	3899	1	applied	\N	\N	\N	\N	14598	14598	14599
4732	3900	0	applied	\N	\N	\N	\N	14605	14605	14606
4732	3901	1	applied	\N	\N	\N	\N	14607	14607	14608
4732	3902	2	applied	\N	\N	\N	\N	14609	14609	14610
4740	3910	0	applied	\N	\N	\N	\N	14637	14637	14638
4740	3911	1	applied	\N	\N	\N	\N	14639	14639	14640
4747	3914	0	applied	\N	\N	\N	\N	14653	14653	14654
4747	3915	1	applied	\N	\N	\N	\N	14655	14655	14656
4747	3916	2	applied	\N	\N	\N	\N	14657	14657	14658
4749	3914	0	applied	\N	\N	\N	\N	14653	14653	14654
4749	3915	1	applied	\N	\N	\N	\N	14655	14655	14656
4749	3916	2	applied	\N	\N	\N	\N	14657	14657	14658
4754	3919	0	applied	\N	\N	\N	\N	14674	14674	14675
4756	3920	0	applied	\N	\N	\N	\N	14678	14678	14679
4756	3921	1	applied	\N	\N	\N	\N	14680	14680	1435
4762	3924	0	applied	\N	\N	\N	\N	14689	14689	14690
4763	3925	0	applied	\N	\N	\N	\N	14697	14697	14698
4768	3928	0	applied	\N	\N	\N	\N	14710	14710	14711
4771	3929	0	applied	\N	\N	\N	\N	14716	14716	14717
4771	3930	1	applied	\N	\N	\N	\N	14718	14718	14719
4771	3931	2	applied	\N	\N	\N	\N	14720	14720	14721
4771	3932	3	applied	\N	\N	\N	\N	14722	14722	14723
4778	3936	0	applied	\N	\N	\N	\N	14736	14736	14737
4783	3940	0	applied	\N	\N	\N	\N	14750	14750	14751
4783	3941	1	applied	\N	\N	\N	\N	14752	14752	14753
4789	3945	0	applied	\N	\N	\N	\N	14766	14766	14767
4789	3946	1	applied	\N	\N	\N	\N	14768	14768	14769
4796	3953	0	applied	\N	\N	\N	\N	14791	14791	14792
4799	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4799	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4799	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4799	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4799	3958	4	applied	\N	\N	1000000000	\N	14805	14805	14806
4799	3959	5	applied	\N	\N	1000000000	\N	14807	14807	14808
4799	3960	6	applied	\N	\N	\N	\N	14809	14809	14810
4801	3961	0	applied	\N	\N	\N	\N	14814	14814	14815
4803	3964	0	applied	\N	\N	\N	\N	14824	14824	14825
4806	3965	0	applied	\N	\N	\N	\N	14828	14828	14829
4808	3967	0	applied	\N	\N	\N	\N	14838	14838	14839
4812	3969	0	applied	\N	\N	\N	\N	14902	14902	14903
4819	3976	0	applied	\N	\N	\N	\N	14925	14925	14926
4822	3980	0	applied	\N	\N	\N	\N	14939	14939	14940
4826	3983	0	applied	\N	\N	\N	\N	14971	14971	14972
4833	3964	0	applied	\N	\N	\N	\N	14824	14824	14990
4833	3965	1	applied	\N	\N	\N	\N	14828	14828	14991
4833	3966	2	applied	\N	\N	\N	\N	14834	14834	14992
4833	3967	3	applied	\N	\N	\N	\N	14838	14838	14993
4833	3968	4	applied	\N	\N	\N	\N	14842	14842	14994
4833	3969	5	applied	\N	\N	\N	\N	14902	14902	14995
4833	3971	6	applied	\N	\N	\N	\N	14908	14908	14996
4833	3972	7	applied	\N	\N	\N	\N	14912	14912	14997
4833	3973	8	applied	\N	\N	\N	\N	14916	14916	14998
4833	3975	9	applied	\N	\N	\N	\N	14919	14919	14999
4833	3976	10	applied	\N	\N	\N	\N	14925	14925	15000
4833	3978	11	applied	\N	\N	\N	\N	14933	14933	15001
4833	3979	12	applied	\N	\N	\N	\N	14935	14935	15002
4833	3980	13	applied	\N	\N	\N	\N	14939	14939	15003
4833	3982	14	applied	\N	\N	\N	\N	14944	14944	15004
4833	3983	15	applied	\N	\N	\N	\N	14971	14971	15005
4833	3984	16	applied	\N	\N	\N	\N	14976	14976	15006
4833	3985	17	applied	\N	\N	\N	\N	14978	14978	15007
4833	3986	18	applied	\N	\N	\N	\N	14982	14982	15008
4833	3987	19	applied	\N	\N	\N	\N	14986	14986	15009
4833	3988	20	applied	\N	\N	\N	\N	14988	14988	15010
4837	3989	0	applied	\N	\N	\N	\N	15015	15015	15016
4837	3990	1	applied	\N	\N	\N	\N	15017	15017	15018
4837	3991	2	applied	\N	\N	\N	\N	15019	15019	15020
4843	3822	0	applied	\N	\N	\N	\N	14306	14306	8545
4843	3782	1	applied	\N	\N	\N	\N	14174	14174	14175
4843	3790	2	applied	\N	\N	1000000000	\N	14204	14204	14205
4843	3954	3	applied	\N	\N	1000000000	\N	14797	14797	14798
4843	3955	4	applied	\N	\N	1000000000	\N	14799	14799	14800
4843	3956	5	applied	\N	\N	1000000000	\N	14801	14801	14802
4843	3957	6	applied	\N	\N	1000000000	\N	14803	14803	14804
4676	3864	0	applied	\N	\N	\N	\N	14463	14463	14464
4680	3867	0	applied	\N	\N	\N	\N	14473	14473	14474
4686	3870	0	applied	\N	\N	\N	\N	14489	14489	14490
4688	3872	0	applied	\N	\N	\N	\N	14497	14497	14498
4691	3873	0	applied	\N	\N	\N	\N	14502	14502	14503
4693	3822	0	applied	\N	\N	\N	\N	14306	14306	8545
4693	3861	1	applied	\N	\N	\N	\N	14450	14450	14451
4693	3844	2	applied	\N	\N	\N	\N	14507	14507	14400
4693	3802	3	applied	\N	\N	\N	\N	14243	14243	1435
4693	3805	4	applied	\N	\N	\N	\N	14250	14250	1435
4702	3880	0	applied	\N	\N	\N	\N	14527	14527	14528
4709	3883	0	applied	\N	\N	\N	\N	14542	14542	14543
4709	3884	1	applied	\N	\N	\N	\N	14544	14544	14545
4710	3885	0	applied	\N	\N	\N	\N	14547	14547	14548
4719	3891	0	applied	\N	\N	\N	\N	14573	14573	14574
4719	3892	1	applied	\N	\N	\N	\N	14575	14575	13857
4721	3894	0	applied	\N	\N	\N	\N	14582	14582	14583
4725	3896	0	applied	\N	\N	\N	\N	14588	14588	14589
4725	3897	1	applied	\N	\N	\N	\N	14590	14590	14591
4729	3898	0	applied	\N	\N	\N	\N	14596	14596	14597
4729	3899	1	applied	\N	\N	\N	\N	14598	14598	14599
4735	3904	0	applied	\N	\N	\N	\N	14618	14618	14619
4737	3905	0	applied	\N	\N	\N	\N	14622	14622	14623
4737	3906	1	applied	\N	\N	\N	\N	14624	14624	14625
4741	3910	0	applied	\N	\N	\N	\N	14637	14637	14638
4741	3911	1	applied	\N	\N	\N	\N	14639	14639	14640
4746	3912	0	applied	\N	\N	\N	\N	14646	14646	14647
4746	3913	1	applied	\N	\N	\N	\N	14648	14648	14649
4750	3917	0	applied	\N	\N	\N	\N	14664	14664	14665
4755	3919	0	applied	\N	\N	\N	\N	14674	14674	14675
4757	3921	0	applied	\N	\N	\N	\N	14680	14680	1435
4759	3922	0	applied	\N	\N	\N	\N	14684	14684	14685
4759	3923	1	applied	\N	\N	\N	\N	14686	14686	14687
4764	3774	0	applied	\N	\N	\N	\N	14145	14145	1435
4764	3822	1	applied	\N	\N	\N	\N	14306	14306	8545
4764	3615	2	applied	\N	\N	1000000000	\N	13522	13522	13523
4764	3616	3	applied	\N	\N	1000000000	\N	13524	13524	13525
4764	3617	4	applied	\N	\N	1000000000	\N	13526	13526	13527
4764	3618	5	applied	\N	\N	\N	\N	13528	13528	13529
4764	3646	6	applied	\N	\N	1000000000	\N	13590	13590	13591
4764	3652	7	applied	\N	\N	1000000000	\N	13609	13609	13610
4764	3657	8	applied	\N	\N	1000000000	\N	13627	13627	13628
4764	3667	9	applied	\N	\N	1000000000	\N	13660	13660	13661
4764	3748	10	applied	\N	\N	1000000000	\N	14063	14063	14064
4764	3753	11	applied	\N	\N	\N	\N	14076	14076	14077
4764	3844	12	applied	\N	\N	\N	\N	14507	14507	14400
4764	3513	13	applied	\N	\N	\N	\N	13234	13234	13235
4764	3514	14	applied	\N	\N	\N	\N	13236	13236	13237
4764	3515	15	applied	\N	\N	\N	\N	13238	13238	13239
4764	3660	16	applied	\N	\N	\N	\N	13633	13633	13634
4764	3526	17	applied	\N	\N	\N	\N	13262	13262	13263
4764	3516	18	applied	\N	\N	\N	\N	13240	13240	13241
4764	3528	19	applied	\N	\N	\N	\N	13266	13266	13267
4764	3536	21	applied	\N	\N	\N	\N	13290	13290	13291
4764	3546	22	applied	\N	\N	\N	\N	13315	13315	13316
4764	3557	23	applied	\N	\N	\N	\N	13341	13341	13342
4764	3566	24	applied	\N	\N	\N	\N	13362	13362	13363
4764	3575	25	applied	\N	\N	\N	\N	13437	13437	13438
4764	3586	26	applied	\N	\N	\N	\N	13460	13460	13461
4764	3598	27	applied	\N	\N	\N	\N	13485	13485	13486
4764	3605	28	applied	\N	\N	\N	\N	13499	13499	13500
4764	3621	29	applied	\N	\N	\N	\N	13534	13534	13535
4766	3926	0	applied	\N	\N	\N	\N	14704	14704	14705
4769	3928	0	applied	\N	\N	\N	\N	14710	14710	14711
4774	3934	0	applied	\N	\N	\N	\N	14730	14730	14731
4774	3935	1	applied	\N	\N	\N	\N	14732	14732	14733
4781	3938	0	applied	\N	\N	\N	\N	14746	14746	14747
4784	3942	0	applied	\N	\N	\N	\N	14756	14756	14757
4786	3943	0	applied	\N	\N	\N	\N	14758	14758	14759
4794	3951	0	applied	\N	\N	\N	\N	14783	14783	14784
4804	3964	0	applied	\N	\N	\N	\N	14824	14824	14825
4815	3973	0	applied	\N	\N	\N	\N	14916	14916	14917
4818	3974	0	applied	\N	\N	\N	\N	14918	14918	14806
4818	3975	1	applied	\N	\N	\N	\N	14919	14919	14920
4820	3976	0	applied	\N	\N	\N	\N	14925	14925	14926
4825	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4825	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4825	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4825	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4825	3861	4	applied	\N	\N	\N	\N	14450	14450	14451
4825	3958	5	applied	\N	\N	1000000000	\N	14805	14805	14806
4825	3959	6	applied	\N	\N	1000000000	\N	14807	14807	14808
4825	3962	7	applied	\N	\N	\N	\N	14818	14818	14819
4825	3977	8	applied	\N	\N	1000000000	\N	14931	14931	14932
4825	3844	9	applied	\N	\N	\N	\N	14399	14399	14400
4825	3833	10	applied	\N	\N	\N	\N	14355	14355	14356
4825	3834	11	applied	\N	\N	\N	\N	14357	14357	14358
4825	3835	12	applied	\N	\N	\N	\N	14359	14359	14360
4825	3836	13	applied	\N	\N	\N	\N	14363	14363	14364
4825	3837	14	applied	\N	\N	\N	\N	14368	14368	14369
4825	3838	15	applied	\N	\N	\N	\N	14375	14375	14376
4825	3981	16	applied	\N	\N	\N	\N	14943	14943	1435
4825	3892	17	applied	\N	\N	\N	\N	14575	14575	13857
4825	3899	18	applied	\N	\N	\N	\N	14598	14598	14599
4825	3839	19	applied	\N	\N	\N	\N	14385	14385	14386
4825	3840	20	applied	\N	\N	\N	\N	14389	14389	14390
4825	3841	21	applied	\N	\N	\N	\N	14391	14391	14392
4825	3842	22	applied	\N	\N	\N	\N	14393	14393	14394
4825	3843	23	applied	\N	\N	\N	\N	14397	14397	14398
4825	3845	24	applied	\N	\N	\N	\N	14406	14406	14407
4825	3877	25	applied	\N	\N	1000000000	\N	14514	14514	14515
4825	3906	26	applied	\N	\N	\N	\N	14624	14624	14625
4825	3852	27	applied	\N	\N	\N	\N	14421	14421	14422
4825	3853	28	applied	\N	\N	\N	\N	14425	14425	14426
4825	3854	29	applied	\N	\N	\N	\N	14429	14429	14430
4825	3855	30	applied	\N	\N	\N	\N	14431	14431	14432
4825	3856	31	applied	\N	\N	\N	\N	14433	14433	14434
4825	3857	32	applied	\N	\N	\N	\N	14437	14437	14438
4825	3858	33	applied	\N	\N	\N	\N	14439	14439	14440
4825	3859	34	applied	\N	\N	\N	\N	14441	14441	14442
4825	3860	35	applied	\N	\N	\N	\N	14446	14446	14447
4825	3862	36	applied	\N	\N	\N	\N	14452	14452	14453
4825	3863	37	applied	\N	\N	\N	\N	14458	14458	14459
4825	3864	38	applied	\N	\N	\N	\N	14463	14463	14464
4825	3865	39	applied	\N	\N	\N	\N	14467	14467	14468
4825	3866	40	applied	\N	\N	\N	\N	14469	14469	14470
4825	3867	41	applied	\N	\N	\N	\N	14473	14473	14474
4825	3868	42	applied	\N	\N	\N	\N	14481	14481	14482
4677	3865	0	applied	\N	\N	\N	\N	14467	14467	14468
4677	3866	1	applied	\N	\N	\N	\N	14469	14469	14470
4679	3867	0	applied	\N	\N	\N	\N	14473	14473	14474
4681	3867	0	applied	\N	\N	\N	\N	14473	14473	14474
4684	3869	0	applied	\N	\N	\N	\N	14485	14485	14486
4690	3869	0	applied	\N	\N	\N	\N	14485	14485	14486
4690	3870	1	applied	\N	\N	\N	\N	14489	14489	14490
4690	3871	2	applied	\N	\N	\N	\N	14493	14493	14494
4690	3872	3	applied	\N	\N	\N	\N	14497	14497	14498
4690	3873	4	applied	\N	\N	\N	\N	14502	14502	14503
4696	3875	0	applied	\N	\N	\N	\N	14510	14510	14511
4696	3876	1	applied	\N	\N	\N	\N	14512	14512	14513
4696	3877	2	applied	\N	\N	1000000000	\N	14514	14514	14515
4700	3879	0	applied	\N	\N	\N	\N	14524	14524	14525
4704	3880	0	applied	\N	\N	\N	\N	14527	14527	14528
4706	3881	0	applied	\N	\N	\N	\N	14532	14532	14533
4711	3886	0	applied	\N	\N	\N	\N	14551	14551	14552
4715	3888	0	applied	\N	\N	\N	\N	14559	14559	14560
4718	3889	0	applied	\N	\N	\N	\N	14565	14565	14566
4718	3890	1	applied	\N	\N	\N	\N	14569	14569	14570
4722	3895	0	applied	\N	\N	\N	\N	14586	14586	14587
4723	3896	0	applied	\N	\N	\N	\N	14588	14588	14589
4723	3897	1	applied	\N	\N	\N	\N	14590	14590	14591
4724	3896	0	applied	\N	\N	\N	\N	14588	14588	14589
4724	3897	1	applied	\N	\N	\N	\N	14590	14590	14591
4727	3898	0	applied	\N	\N	\N	\N	14596	14596	14597
4727	3899	1	applied	\N	\N	\N	\N	14598	14598	14599
4734	3903	0	applied	\N	\N	\N	\N	14614	14614	14615
4739	3909	0	applied	\N	\N	\N	\N	14633	14633	14634
4742	3888	0	applied	\N	\N	\N	\N	14559	14559	14560
4742	3889	1	applied	\N	\N	\N	\N	14565	14565	14566
4742	3890	2	applied	\N	\N	\N	\N	14569	14569	14570
4742	3891	3	applied	\N	\N	\N	\N	14573	14573	14574
4742	3906	4	applied	\N	\N	\N	\N	14624	14624	14625
4742	3893	5	applied	\N	\N	\N	\N	14578	14578	14579
4742	3892	6	applied	\N	\N	\N	\N	14575	14575	13857
4742	3899	7	applied	\N	\N	\N	\N	14598	14598	14599
4742	3894	8	applied	\N	\N	\N	\N	14582	14582	14583
4742	3895	9	applied	\N	\N	\N	\N	14586	14586	14587
4742	3896	10	applied	\N	\N	\N	\N	14588	14588	14589
4742	3897	11	applied	\N	\N	\N	\N	14590	14590	14591
4742	3898	12	applied	\N	\N	\N	\N	14596	14596	14597
4742	3901	13	applied	\N	\N	\N	\N	14607	14607	14608
4742	3902	14	applied	\N	\N	\N	\N	14609	14609	14610
4742	3903	15	applied	\N	\N	\N	\N	14614	14614	14615
4742	3904	16	applied	\N	\N	\N	\N	14618	14618	14619
4742	3905	17	applied	\N	\N	\N	\N	14622	14622	14623
4742	3907	18	applied	\N	\N	\N	\N	14627	14627	14628
4742	3908	19	applied	\N	\N	\N	\N	14629	14629	14630
4742	3909	20	applied	\N	\N	\N	\N	14633	14633	14634
4742	3910	21	applied	\N	\N	\N	\N	14637	14637	14638
4742	3911	22	applied	\N	\N	\N	\N	14639	14639	14640
4744	3912	0	applied	\N	\N	\N	\N	14646	14646	14647
4744	3913	1	applied	\N	\N	\N	\N	14648	14648	14649
4752	3917	0	applied	\N	\N	\N	\N	14664	14664	14665
4753	3918	0	applied	\N	\N	\N	\N	14670	14670	14671
4758	3921	0	applied	\N	\N	\N	\N	14680	14680	1435
4761	3924	0	applied	\N	\N	\N	\N	14689	14689	14690
4765	3926	0	applied	\N	\N	\N	\N	14704	14704	14705
4767	3927	0	applied	\N	\N	\N	\N	14708	14708	14709
4776	3933	0	applied	\N	\N	\N	\N	14727	14727	14728
4776	3934	1	applied	\N	\N	\N	\N	14730	14730	14731
4776	3935	2	applied	\N	\N	\N	\N	14732	14732	14733
4780	3937	0	applied	\N	\N	\N	\N	14742	14742	14743
4782	3939	0	applied	\N	\N	\N	\N	14748	14748	14749
4785	3943	0	applied	\N	\N	\N	\N	14758	14758	14759
4788	3945	0	applied	\N	\N	\N	\N	14766	14766	14767
4788	3946	1	applied	\N	\N	\N	\N	14768	14768	14769
4791	3947	0	applied	\N	\N	\N	\N	14772	14772	14773
4791	3948	1	applied	\N	\N	\N	\N	14774	14774	14775
4793	3950	0	applied	\N	\N	\N	\N	14779	14779	14780
4798	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4798	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4798	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4798	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4798	3958	4	applied	\N	\N	1000000000	\N	14805	14805	14806
4798	3959	5	applied	\N	\N	1000000000	\N	14807	14807	14808
4798	3960	6	applied	\N	\N	\N	\N	14809	14809	14810
4800	3961	0	applied	\N	\N	\N	\N	14814	14814	14815
4805	3965	0	applied	\N	\N	\N	\N	14828	14828	14829
4807	3966	0	applied	\N	\N	\N	\N	14834	14834	14835
4810	3968	0	applied	\N	\N	\N	\N	14842	14842	14843
4814	3972	0	applied	\N	\N	\N	\N	14912	14912	14913
4817	3974	0	applied	\N	\N	\N	\N	14918	14918	14806
4817	3975	1	applied	\N	\N	\N	\N	14919	14919	14920
4821	3977	0	applied	\N	\N	1000000000	\N	14931	14931	14932
4821	3978	1	applied	\N	\N	\N	\N	14933	14933	14934
4821	3979	2	applied	\N	\N	\N	\N	14935	14935	14936
4824	3981	0	applied	\N	\N	\N	\N	14943	14943	1435
4824	3982	1	applied	\N	\N	\N	\N	14944	14944	14945
4830	3984	0	applied	\N	\N	\N	\N	14976	14976	14977
4830	3985	1	applied	\N	\N	\N	\N	14978	14978	14979
4836	3989	0	applied	\N	\N	\N	\N	15015	15015	15016
4836	3990	1	applied	\N	\N	\N	\N	15017	15017	15018
4836	3991	2	applied	\N	\N	\N	\N	15019	15019	15020
4840	3992	0	applied	\N	\N	\N	\N	15024	15024	15025
4845	3996	0	applied	\N	\N	\N	\N	15042	15042	15043
4854	4002	0	applied	\N	\N	1000000000	\N	15065	15065	15066
4854	4003	1	applied	\N	\N	\N	\N	15067	15067	15068
4859	4004	0	applied	\N	\N	\N	\N	15074	15074	15075
4861	4005	0	applied	\N	\N	\N	\N	15086	15086	15087
4861	4006	1	applied	\N	\N	\N	\N	15088	15088	15089
4861	4007	2	applied	\N	\N	\N	\N	15090	15090	15091
4861	4008	3	applied	\N	\N	\N	\N	15092	15092	15093
4868	4013	0	applied	\N	\N	\N	\N	15111	15111	15112
4876	4016	0	applied	\N	\N	\N	\N	15138	15138	15139
4879	4019	0	applied	\N	\N	\N	\N	15146	15146	15147
4879	4020	1	applied	\N	\N	\N	\N	15148	15148	15149
4879	4021	2	applied	\N	\N	\N	\N	15150	15150	15151
4882	4019	0	applied	\N	\N	\N	\N	15146	15146	15147
4882	4020	1	applied	\N	\N	\N	\N	15148	15148	15149
4882	4021	2	applied	\N	\N	\N	\N	15150	15150	15151
4886	4024	0	applied	\N	\N	\N	\N	15166	15166	15167
4886	4025	1	applied	\N	\N	\N	\N	15168	15168	15169
4888	4026	0	applied	\N	\N	\N	\N	15174	15174	15175
4891	4031	0	applied	\N	\N	\N	\N	15185	15185	15186
4893	4031	0	applied	\N	\N	\N	\N	15185	15185	15186
4900	4033	0	applied	\N	\N	\N	\N	15199	15199	15200
4910	4036	0	applied	\N	\N	\N	\N	14932	14932	15216
4772	3933	0	applied	\N	\N	\N	\N	14727	14727	14728
4775	3934	0	applied	\N	\N	\N	\N	14730	14730	14731
4775	3935	1	applied	\N	\N	\N	\N	14732	14732	14733
4777	3936	0	applied	\N	\N	\N	\N	14736	14736	14737
4779	3937	0	applied	\N	\N	\N	\N	14742	14742	14743
4787	3944	0	applied	\N	\N	\N	\N	14762	14762	14763
4790	3947	0	applied	\N	\N	\N	\N	14772	14772	14773
4790	3948	1	applied	\N	\N	\N	\N	14774	14774	14775
4792	3949	0	applied	\N	\N	\N	\N	14777	14777	14778
4795	3952	0	applied	\N	\N	\N	\N	14787	14787	14788
4797	3953	0	applied	\N	\N	\N	\N	14791	14791	14792
4802	3962	0	applied	\N	\N	\N	\N	14818	14818	14819
4802	3963	1	applied	\N	\N	\N	\N	14820	14820	14821
4809	3968	0	applied	\N	\N	\N	\N	14842	14842	14843
4811	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4811	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4811	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4811	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4811	3861	4	applied	\N	\N	\N	\N	14450	14450	14451
4811	3958	5	applied	\N	\N	1000000000	\N	14805	14805	14806
4811	3959	6	applied	\N	\N	1000000000	\N	14807	14807	14808
4811	3962	7	applied	\N	\N	\N	\N	14818	14818	14819
4811	3844	8	applied	\N	\N	\N	\N	14399	14399	14400
4811	3892	9	applied	\N	\N	\N	\N	14575	14575	13857
4811	3899	10	applied	\N	\N	\N	\N	14598	14598	14599
4811	3877	11	applied	\N	\N	1000000000	\N	14514	14514	14515
4811	3906	12	applied	\N	\N	\N	\N	14624	14624	14625
4811	3831	13	applied	\N	\N	\N	\N	14343	14343	14344
4811	3832	14	applied	\N	\N	\N	\N	14345	14345	14346
4811	3833	15	applied	\N	\N	\N	\N	14355	14355	14356
4811	3834	16	applied	\N	\N	\N	\N	14357	14357	14358
4811	3835	17	applied	\N	\N	\N	\N	14359	14359	14360
4811	3836	18	applied	\N	\N	\N	\N	14363	14363	14364
4811	3837	19	applied	\N	\N	\N	\N	14368	14368	14369
4811	3838	20	applied	\N	\N	\N	\N	14375	14375	14376
4811	3839	21	applied	\N	\N	\N	\N	14385	14385	14386
4811	3840	22	applied	\N	\N	\N	\N	14389	14389	14390
4811	3841	23	applied	\N	\N	\N	\N	14391	14391	14392
4811	3842	24	applied	\N	\N	\N	\N	14393	14393	14394
4811	3843	25	applied	\N	\N	\N	\N	14397	14397	14398
4811	3845	26	applied	\N	\N	\N	\N	14406	14406	14407
4811	3852	27	applied	\N	\N	\N	\N	14421	14421	14422
4811	3853	28	applied	\N	\N	\N	\N	14425	14425	14426
4811	3854	29	applied	\N	\N	\N	\N	14429	14429	14430
4811	3855	30	applied	\N	\N	\N	\N	14431	14431	14432
4811	3856	31	applied	\N	\N	\N	\N	14433	14433	14434
4811	3857	32	applied	\N	\N	\N	\N	14437	14437	14438
4811	3858	33	applied	\N	\N	\N	\N	14439	14439	14440
4811	3859	34	applied	\N	\N	\N	\N	14441	14441	14442
4811	3860	35	applied	\N	\N	\N	\N	14446	14446	14447
4811	3862	36	applied	\N	\N	\N	\N	14452	14452	14453
4811	3863	37	applied	\N	\N	\N	\N	14458	14458	14459
4811	3864	38	applied	\N	\N	\N	\N	14463	14463	14464
4811	3865	39	applied	\N	\N	\N	\N	14467	14467	14468
4811	3866	40	applied	\N	\N	\N	\N	14469	14469	14470
4811	3867	41	applied	\N	\N	\N	\N	14473	14473	14474
4811	3868	42	applied	\N	\N	\N	\N	14481	14481	14482
4811	3869	43	applied	\N	\N	\N	\N	14485	14485	14486
4811	3870	44	applied	\N	\N	\N	\N	14489	14489	14490
4811	3871	45	applied	\N	\N	\N	\N	14493	14493	14494
4811	3872	46	applied	\N	\N	\N	\N	14497	14497	14498
4811	3873	47	applied	\N	\N	\N	\N	14502	14502	14503
4811	3874	48	applied	\N	\N	\N	\N	14505	14505	14506
4811	3875	49	applied	\N	\N	\N	\N	14510	14510	14511
4811	3876	50	applied	\N	\N	\N	\N	14512	14512	14513
4811	3878	51	applied	\N	\N	\N	\N	14518	14518	14519
4811	3879	52	applied	\N	\N	\N	\N	14524	14524	14529
4811	3880	53	applied	\N	\N	\N	\N	14527	14527	14530
4811	3881	54	applied	\N	\N	\N	\N	14532	14532	14848
4811	3882	55	applied	\N	\N	\N	\N	14538	14538	14849
4811	3883	56	applied	\N	\N	\N	\N	14542	14542	14850
4811	3884	57	applied	\N	\N	\N	\N	14544	14544	14851
4811	3885	58	applied	\N	\N	\N	\N	14547	14547	14852
4811	3886	59	applied	\N	\N	\N	\N	14551	14551	14853
4811	3887	60	applied	\N	\N	\N	\N	14557	14557	14854
4811	3888	61	applied	\N	\N	\N	\N	14559	14559	14855
4811	3889	62	applied	\N	\N	\N	\N	14565	14565	14856
4811	3890	63	applied	\N	\N	\N	\N	14569	14569	14857
4811	3891	64	applied	\N	\N	\N	\N	14573	14573	14858
4811	3893	65	applied	\N	\N	\N	\N	14578	14578	14859
4811	3894	66	applied	\N	\N	\N	\N	14582	14582	14860
4811	3895	67	applied	\N	\N	\N	\N	14586	14586	14861
4811	3896	68	applied	\N	\N	\N	\N	14588	14588	14862
4811	3897	69	applied	\N	\N	\N	\N	14590	14590	14863
4811	3898	70	applied	\N	\N	\N	\N	14596	14596	14864
4811	3901	71	applied	\N	\N	\N	\N	14607	14607	14865
4811	3902	72	applied	\N	\N	\N	\N	14609	14609	14866
4811	3903	73	applied	\N	\N	\N	\N	14614	14614	14867
4811	3904	74	applied	\N	\N	\N	\N	14618	14618	14868
4811	3905	75	applied	\N	\N	\N	\N	14622	14622	14869
4811	3907	76	applied	\N	\N	\N	\N	14627	14627	14870
4811	3908	77	applied	\N	\N	\N	\N	14629	14629	14871
4811	3909	78	applied	\N	\N	\N	\N	14633	14633	14872
4811	3910	79	applied	\N	\N	\N	\N	14637	14637	14873
4811	3911	80	applied	\N	\N	\N	\N	14639	14639	14874
4811	3912	81	applied	\N	\N	\N	\N	14646	14646	14875
4811	3913	82	applied	\N	\N	\N	\N	14648	14648	14876
4811	3914	83	applied	\N	\N	\N	\N	14653	14653	14877
4811	3915	84	applied	\N	\N	\N	\N	14655	14655	14878
4811	3916	85	applied	\N	\N	\N	\N	14657	14657	14879
4811	3917	86	applied	\N	\N	\N	\N	14664	14664	14880
4811	3918	87	applied	\N	\N	\N	\N	14670	14670	14881
4811	3919	88	applied	\N	\N	\N	\N	14674	14674	14882
4811	3920	89	applied	\N	\N	\N	\N	14678	14678	14883
4811	3922	90	applied	\N	\N	\N	\N	14684	14684	14884
4811	3923	91	applied	\N	\N	\N	\N	14686	14686	14885
4811	3924	92	applied	\N	\N	\N	\N	14689	14689	14886
4811	3925	93	applied	\N	\N	\N	\N	14697	14697	14887
4811	3926	94	applied	\N	\N	\N	\N	14704	14704	14888
4811	3927	95	applied	\N	\N	\N	\N	14708	14708	14889
4811	3928	96	applied	\N	\N	\N	\N	14710	14710	14890
4811	3929	97	applied	\N	\N	\N	\N	14716	14716	14891
4811	3930	98	applied	\N	\N	\N	\N	14718	14718	14892
4811	3931	99	applied	\N	\N	\N	\N	14720	14720	14893
4811	3932	100	applied	\N	\N	\N	\N	14722	14722	14894
4811	3933	101	applied	\N	\N	\N	\N	14727	14727	14895
4811	3934	102	applied	\N	\N	\N	\N	14730	14730	14896
4811	3935	103	applied	\N	\N	\N	\N	14732	14732	14897
4811	3936	104	applied	\N	\N	\N	\N	14736	14736	14898
4811	3937	105	applied	\N	\N	\N	\N	14742	14742	14899
4811	3938	106	applied	\N	\N	\N	\N	14746	14746	14900
4813	3970	0	applied	\N	\N	1000000000	\N	14906	14906	14907
4813	3971	1	applied	\N	\N	\N	\N	14908	14908	14909
4816	3974	0	applied	\N	\N	\N	\N	14918	14918	14806
4816	3975	1	applied	\N	\N	\N	\N	14919	14919	14920
4823	3981	0	applied	\N	\N	\N	\N	14943	14943	1435
4823	3982	1	applied	\N	\N	\N	\N	14944	14944	14945
4832	3987	0	applied	\N	\N	\N	\N	14986	14986	14987
4832	3988	1	applied	\N	\N	\N	\N	14988	14988	14989
4834	3987	0	applied	\N	\N	\N	\N	14986	14986	14987
4834	3988	1	applied	\N	\N	\N	\N	14988	14988	14989
4835	3989	0	applied	\N	\N	\N	\N	15015	15015	15016
4835	3990	1	applied	\N	\N	\N	\N	15017	15017	15018
4835	3991	2	applied	\N	\N	\N	\N	15019	15019	15020
4842	3994	0	applied	\N	\N	\N	\N	15032	15032	15033
4842	3995	1	applied	\N	\N	\N	\N	15034	15034	15035
4844	3996	0	applied	\N	\N	\N	\N	15042	15042	15043
4849	3998	0	applied	\N	\N	\N	\N	15049	15049	15050
4851	4000	0	applied	\N	\N	1000000000	\N	15059	15059	15060
4851	4001	1	applied	\N	\N	\N	\N	15061	15061	15062
4856	4004	0	applied	\N	\N	\N	\N	15074	15074	15075
4863	4005	0	applied	\N	\N	\N	\N	15086	15086	15087
4863	4006	1	applied	\N	\N	\N	\N	15088	15088	15089
4863	4007	2	applied	\N	\N	\N	\N	15090	15090	15091
4863	4008	3	applied	\N	\N	\N	\N	15092	15092	15093
4865	4010	0	applied	\N	\N	\N	\N	15101	15101	15102
4873	4014	0	applied	\N	\N	\N	\N	15116	15116	15117
4874	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4874	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4874	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4874	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4874	3977	4	applied	\N	\N	1000000000	\N	14931	14931	14932
4874	3835	5	applied	\N	\N	\N	\N	14359	14359	14360
4874	3836	6	applied	\N	\N	\N	\N	14363	14363	14364
4874	3837	7	applied	\N	\N	\N	\N	14368	14368	14369
4874	3838	8	applied	\N	\N	\N	\N	14375	14375	14376
4874	3981	9	applied	\N	\N	\N	\N	14943	14943	1435
4874	3892	10	applied	\N	\N	\N	\N	15124	15124	13857
4874	3899	11	applied	\N	\N	\N	\N	15125	15125	14599
4874	3839	12	applied	\N	\N	\N	\N	14385	14385	14386
4874	3840	13	applied	\N	\N	\N	\N	14389	14389	14390
4874	3841	14	applied	\N	\N	\N	\N	14391	14391	14392
4874	3842	15	applied	\N	\N	\N	\N	14393	14393	14394
4874	3843	16	applied	\N	\N	\N	\N	14397	14397	14398
4874	3845	17	applied	\N	\N	\N	\N	14406	14406	14407
4874	3877	18	applied	\N	\N	1000000000	\N	14514	14514	14515
4874	3906	19	applied	\N	\N	\N	\N	14624	14624	14625
4874	3852	20	applied	\N	\N	\N	\N	14421	14421	14422
4874	3853	21	applied	\N	\N	\N	\N	14425	14425	14426
4874	3854	22	applied	\N	\N	\N	\N	14429	14429	14430
4874	3855	23	applied	\N	\N	\N	\N	14431	14431	14432
4874	3856	24	applied	\N	\N	\N	\N	14433	14433	14434
4874	3857	25	applied	\N	\N	\N	\N	14437	14437	14438
4874	3858	26	applied	\N	\N	\N	\N	14439	14439	14440
4874	3859	27	applied	\N	\N	\N	\N	14441	14441	14442
4874	3860	28	applied	\N	\N	\N	\N	14446	14446	14447
4874	3862	29	applied	\N	\N	\N	\N	14452	14452	14453
4874	3863	30	applied	\N	\N	\N	\N	14458	14458	14459
4874	3864	31	applied	\N	\N	\N	\N	14463	14463	14464
4874	3865	32	applied	\N	\N	\N	\N	14467	14467	14468
4874	3866	33	applied	\N	\N	\N	\N	14469	14469	14470
4874	3867	34	applied	\N	\N	\N	\N	14473	14473	14474
4874	3868	35	applied	\N	\N	\N	\N	14481	14481	14482
4874	3869	36	applied	\N	\N	\N	\N	14485	14485	14486
4874	3870	37	applied	\N	\N	\N	\N	14489	14489	14490
4874	3871	38	applied	\N	\N	\N	\N	14493	14493	14494
4874	3872	39	applied	\N	\N	\N	\N	14497	14497	14498
4874	3873	40	applied	\N	\N	\N	\N	14502	14502	14503
4874	3874	41	applied	\N	\N	\N	\N	14505	14505	14506
4874	3875	42	applied	\N	\N	\N	\N	14510	14510	14511
4874	3876	43	applied	\N	\N	\N	\N	14512	14512	14513
4874	3878	44	applied	\N	\N	\N	\N	14518	14518	14519
4874	3879	45	applied	\N	\N	\N	\N	14524	14524	14529
4874	3880	46	applied	\N	\N	\N	\N	14527	14527	14530
4874	3881	47	applied	\N	\N	\N	\N	14532	14532	14848
4874	3882	48	applied	\N	\N	\N	\N	14538	14538	14849
4874	3883	49	applied	\N	\N	\N	\N	14542	14542	14850
4874	3884	50	applied	\N	\N	\N	\N	14544	14544	14851
4874	3885	51	applied	\N	\N	\N	\N	14547	14547	14852
4874	3886	52	applied	\N	\N	\N	\N	14551	14551	14853
4874	3887	53	applied	\N	\N	\N	\N	14557	14557	14854
4874	3888	54	applied	\N	\N	\N	\N	14559	14559	14855
4874	3889	55	applied	\N	\N	\N	\N	14565	14565	14856
4874	3890	56	applied	\N	\N	\N	\N	14569	14569	14857
4874	3891	57	applied	\N	\N	\N	\N	14573	14573	14858
4874	3893	58	applied	\N	\N	\N	\N	14578	14578	14859
4874	3894	59	applied	\N	\N	\N	\N	14582	14582	14860
4874	3895	60	applied	\N	\N	\N	\N	14586	14586	14861
4874	3896	61	applied	\N	\N	\N	\N	14588	14588	14862
4874	3897	62	applied	\N	\N	\N	\N	14590	14590	14863
4874	3898	63	applied	\N	\N	\N	\N	14596	14596	14864
4874	3901	64	applied	\N	\N	\N	\N	14607	14607	14865
4874	3902	65	applied	\N	\N	\N	\N	14609	14609	14866
4874	3903	66	applied	\N	\N	\N	\N	14614	14614	14867
4874	3904	67	applied	\N	\N	\N	\N	14618	14618	14868
4874	3905	68	applied	\N	\N	\N	\N	14622	14622	14869
4874	3907	69	applied	\N	\N	\N	\N	14627	14627	14870
4874	3908	70	applied	\N	\N	\N	\N	14629	14629	14871
4874	3909	71	applied	\N	\N	\N	\N	14633	14633	14872
4874	3910	72	applied	\N	\N	\N	\N	14637	14637	14873
4874	3911	73	applied	\N	\N	\N	\N	14639	14639	14874
4874	3912	74	applied	\N	\N	\N	\N	14646	14646	14875
4874	3913	75	applied	\N	\N	\N	\N	14648	14648	14876
4874	3914	76	applied	\N	\N	\N	\N	14653	14653	14877
4874	3915	77	applied	\N	\N	\N	\N	14655	14655	14878
4874	3916	78	applied	\N	\N	\N	\N	14657	14657	14879
4874	3917	79	applied	\N	\N	\N	\N	14664	14664	14880
4874	3918	80	applied	\N	\N	\N	\N	14670	14670	14881
4874	3919	81	applied	\N	\N	\N	\N	14674	14674	14882
4874	3920	82	applied	\N	\N	\N	\N	14678	14678	14883
4874	3922	83	applied	\N	\N	\N	\N	14684	14684	14884
4874	3923	84	applied	\N	\N	\N	\N	14686	14686	14885
4874	3924	85	applied	\N	\N	\N	\N	14689	14689	14886
4874	3925	86	applied	\N	\N	\N	\N	14697	14697	14887
4874	3926	87	applied	\N	\N	\N	\N	14704	14704	14888
4874	3927	88	applied	\N	\N	\N	\N	14708	14708	14889
4874	3928	89	applied	\N	\N	\N	\N	14710	14710	14890
4874	3929	90	applied	\N	\N	\N	\N	14716	14716	14891
4825	3869	43	applied	\N	\N	\N	\N	14485	14485	14486
4825	3870	44	applied	\N	\N	\N	\N	14489	14489	14490
4825	3871	45	applied	\N	\N	\N	\N	14493	14493	14494
4825	3872	46	applied	\N	\N	\N	\N	14497	14497	14498
4825	3873	47	applied	\N	\N	\N	\N	14502	14502	14503
4825	3874	48	applied	\N	\N	\N	\N	14505	14505	14506
4825	3875	49	applied	\N	\N	\N	\N	14510	14510	14511
4825	3876	50	applied	\N	\N	\N	\N	14512	14512	14513
4825	3878	51	applied	\N	\N	\N	\N	14518	14518	14519
4825	3879	52	applied	\N	\N	\N	\N	14524	14524	14529
4825	3880	53	applied	\N	\N	\N	\N	14527	14527	14530
4825	3881	54	applied	\N	\N	\N	\N	14532	14532	14848
4825	3882	55	applied	\N	\N	\N	\N	14538	14538	14849
4825	3883	56	applied	\N	\N	\N	\N	14542	14542	14850
4825	3884	57	applied	\N	\N	\N	\N	14544	14544	14851
4825	3885	58	applied	\N	\N	\N	\N	14547	14547	14852
4825	3886	59	applied	\N	\N	\N	\N	14551	14551	14853
4825	3887	60	applied	\N	\N	\N	\N	14557	14557	14854
4825	3888	61	applied	\N	\N	\N	\N	14559	14559	14855
4825	3889	62	applied	\N	\N	\N	\N	14565	14565	14856
4825	3890	63	applied	\N	\N	\N	\N	14569	14569	14857
4825	3891	64	applied	\N	\N	\N	\N	14573	14573	14858
4825	3893	65	applied	\N	\N	\N	\N	14578	14578	14859
4825	3894	66	applied	\N	\N	\N	\N	14582	14582	14860
4825	3895	67	applied	\N	\N	\N	\N	14586	14586	14861
4825	3896	68	applied	\N	\N	\N	\N	14588	14588	14862
4825	3897	69	applied	\N	\N	\N	\N	14590	14590	14863
4825	3898	70	applied	\N	\N	\N	\N	14596	14596	14864
4825	3901	71	applied	\N	\N	\N	\N	14607	14607	14865
4825	3902	72	applied	\N	\N	\N	\N	14609	14609	14866
4825	3903	73	applied	\N	\N	\N	\N	14614	14614	14867
4825	3904	74	applied	\N	\N	\N	\N	14618	14618	14868
4825	3905	75	applied	\N	\N	\N	\N	14622	14622	14869
4825	3907	76	applied	\N	\N	\N	\N	14627	14627	14870
4825	3908	77	applied	\N	\N	\N	\N	14629	14629	14871
4825	3909	78	applied	\N	\N	\N	\N	14633	14633	14872
4825	3910	79	applied	\N	\N	\N	\N	14637	14637	14873
4825	3911	80	applied	\N	\N	\N	\N	14639	14639	14874
4825	3912	81	applied	\N	\N	\N	\N	14646	14646	14875
4825	3913	82	applied	\N	\N	\N	\N	14648	14648	14876
4825	3914	83	applied	\N	\N	\N	\N	14653	14653	14877
4825	3915	84	applied	\N	\N	\N	\N	14655	14655	14878
4825	3916	85	applied	\N	\N	\N	\N	14657	14657	14879
4825	3917	86	applied	\N	\N	\N	\N	14664	14664	14880
4825	3918	87	applied	\N	\N	\N	\N	14670	14670	14881
4825	3919	88	applied	\N	\N	\N	\N	14674	14674	14882
4825	3920	89	applied	\N	\N	\N	\N	14678	14678	14883
4825	3922	90	applied	\N	\N	\N	\N	14684	14684	14884
4825	3923	91	applied	\N	\N	\N	\N	14686	14686	14885
4825	3924	92	applied	\N	\N	\N	\N	14689	14689	14886
4825	3925	93	applied	\N	\N	\N	\N	14697	14697	14887
4825	3926	94	applied	\N	\N	\N	\N	14704	14704	14888
4825	3927	95	applied	\N	\N	\N	\N	14708	14708	14889
4825	3928	96	applied	\N	\N	\N	\N	14710	14710	14890
4825	3929	97	applied	\N	\N	\N	\N	14716	14716	14891
4825	3930	98	applied	\N	\N	\N	\N	14718	14718	14892
4825	3931	99	applied	\N	\N	\N	\N	14720	14720	14893
4825	3932	100	applied	\N	\N	\N	\N	14722	14722	14894
4825	3933	101	applied	\N	\N	\N	\N	14727	14727	14895
4825	3934	103	applied	\N	\N	\N	\N	14730	14730	14896
4825	3935	104	applied	\N	\N	\N	\N	14732	14732	14897
4825	3936	105	applied	\N	\N	\N	\N	14736	14736	14898
4825	3937	106	applied	\N	\N	\N	\N	14742	14742	14899
4825	3938	107	applied	\N	\N	\N	\N	14746	14746	14900
4825	3939	108	applied	\N	\N	\N	\N	14748	14748	14951
4825	3940	109	applied	\N	\N	\N	\N	14750	14750	14952
4825	3941	110	applied	\N	\N	\N	\N	14752	14752	14953
4825	3942	111	applied	\N	\N	\N	\N	14756	14756	14954
4825	3943	112	applied	\N	\N	\N	\N	14758	14758	14955
4825	3944	113	applied	\N	\N	\N	\N	14762	14762	14956
4825	3945	114	applied	\N	\N	\N	\N	14766	14766	14957
4825	3946	115	applied	\N	\N	\N	\N	14768	14768	14958
4825	3947	116	applied	\N	\N	\N	\N	14772	14772	14959
4825	3948	117	applied	\N	\N	\N	\N	14774	14774	14960
4825	3949	118	applied	\N	\N	\N	\N	14777	14777	14961
4825	3950	119	applied	\N	\N	\N	\N	14779	14779	14962
4825	3951	120	applied	\N	\N	\N	\N	14783	14783	14963
4825	3952	121	applied	\N	\N	\N	\N	14787	14787	14964
4825	3953	122	applied	\N	\N	\N	\N	14791	14791	14965
4825	3960	123	applied	\N	\N	\N	\N	14809	14809	14966
4825	3961	124	applied	\N	\N	\N	\N	14814	14814	14967
4825	3963	125	applied	\N	\N	\N	\N	14820	14820	14968
4829	3984	0	applied	\N	\N	\N	\N	14976	14976	14977
4829	3985	1	applied	\N	\N	\N	\N	14978	14978	14979
4831	3986	0	applied	\N	\N	\N	\N	14982	14982	14983
4841	3993	0	applied	\N	\N	\N	\N	15028	15028	15029
4848	3998	0	applied	\N	\N	\N	\N	15049	15049	15050
4850	3999	0	applied	\N	\N	\N	\N	15055	15055	15056
4853	4002	0	applied	\N	\N	1000000000	\N	15065	15065	15066
4853	4003	1	applied	\N	\N	\N	\N	15067	15067	15068
4855	4004	0	applied	\N	\N	\N	\N	15074	15074	15075
4864	4009	0	applied	\N	\N	\N	\N	15099	15099	15100
4867	4012	0	applied	\N	\N	\N	\N	15109	15109	15110
4870	4013	0	applied	\N	\N	\N	\N	15111	15111	15112
4872	4014	0	applied	\N	\N	\N	\N	15116	15116	15117
4877	4017	0	applied	\N	\N	\N	\N	15140	15140	15141
4881	4019	0	applied	\N	\N	\N	\N	15146	15146	15147
4881	4020	1	applied	\N	\N	\N	\N	15148	15148	15149
4881	4021	2	applied	\N	\N	\N	\N	15150	15150	15151
4890	4030	0	applied	\N	\N	\N	\N	15181	15181	15182
4894	4031	0	applied	\N	\N	\N	\N	15185	15185	15186
4906	4035	0	applied	\N	\N	\N	\N	15212	15212	15213
4908	4036	0	applied	\N	\N	\N	\N	14932	14932	15216
4908	4037	1	applied	\N	\N	\N	\N	15217	15217	15218
4908	4038	2	applied	\N	\N	\N	\N	15219	15219	15220
4913	4039	0	applied	\N	\N	\N	\N	15228	15228	15229
4915	4040	0	applied	\N	\N	1000000000	\N	15234	15234	15235
4915	4041	1	applied	\N	\N	\N	\N	15236	15236	15237
4915	4042	2	applied	\N	\N	\N	\N	15238	15238	15239
4915	4043	3	applied	\N	\N	\N	\N	15240	15240	15241
4918	4046	0	applied	\N	\N	\N	\N	15251	15251	15252
4923	4048	0	applied	\N	\N	\N	\N	15261	15261	15262
4925	4049	0	applied	\N	\N	\N	\N	15266	15266	15267
4927	4051	0	applied	\N	\N	\N	\N	15270	15270	15271
4936	4064	0	applied	\N	\N	\N	\N	15307	15307	15308
4947	4069	0	applied	\N	\N	\N	\N	15326	15326	15327
4950	4071	0	applied	\N	\N	\N	\N	15335	15335	15336
4950	4072	1	applied	\N	\N	\N	\N	15337	15337	15338
4950	4073	2	applied	\N	\N	\N	\N	15339	15339	15340
4843	3861	7	applied	\N	\N	\N	\N	14450	14450	14451
4843	3958	8	applied	\N	\N	1000000000	\N	14805	14805	14806
4843	3959	9	applied	\N	\N	1000000000	\N	14807	14807	14808
4843	3962	10	applied	\N	\N	\N	\N	14818	14818	14819
4843	3977	11	applied	\N	\N	1000000000	\N	14931	14931	14932
4843	3844	12	applied	\N	\N	\N	\N	14507	14507	14400
4843	3802	13	applied	\N	\N	\N	\N	14243	14243	1435
4843	3981	14	applied	\N	\N	\N	\N	14943	14943	1435
4843	3805	15	applied	\N	\N	\N	\N	14250	14250	1435
4843	3877	16	applied	\N	\N	1000000000	\N	15038	15038	14515
4843	3486	17	applied	\N	\N	\N	\N	13080	13080	13207
4843	3487	18	applied	\N	\N	\N	\N	13084	13084	13208
4843	3488	19	applied	\N	\N	\N	\N	13086	13086	13209
4843	3489	20	applied	\N	\N	\N	\N	13092	13092	13210
4843	3490	21	applied	\N	\N	\N	\N	13100	13100	13211
4843	3491	22	applied	\N	\N	\N	\N	13102	13102	13105
4843	3494	23	applied	\N	\N	\N	\N	13108	13108	13109
4843	3495	24	applied	\N	\N	\N	\N	13112	13112	13113
4843	3496	25	applied	\N	\N	\N	\N	13116	13116	13117
4843	3497	26	applied	\N	\N	\N	\N	13122	13122	13123
4843	3498	27	applied	\N	\N	\N	\N	13128	13128	13129
4843	3499	28	applied	\N	\N	\N	\N	13132	13132	13133
4843	3500	29	applied	\N	\N	\N	\N	13134	13134	13135
4843	3501	30	applied	\N	\N	\N	\N	13137	13137	13138
4843	3502	31	applied	\N	\N	\N	\N	13141	13141	13142
4843	3503	32	applied	\N	\N	\N	\N	13148	13148	13149
4843	3505	33	applied	\N	\N	\N	\N	13152	13152	13153
4843	3508	34	applied	\N	\N	\N	\N	13217	13217	13218
4843	3511	35	applied	\N	\N	\N	\N	13227	13227	13228
4843	3515	36	applied	\N	\N	\N	\N	13238	13238	13239
4843	3528	37	applied	\N	\N	\N	\N	13266	13266	13267
4843	3536	38	applied	\N	\N	\N	\N	13290	13290	13291
4843	3546	39	applied	\N	\N	\N	\N	13315	13315	13316
4843	3557	40	applied	\N	\N	\N	\N	13341	13341	13342
4843	3566	41	applied	\N	\N	\N	\N	13362	13362	13363
4843	3575	42	applied	\N	\N	\N	\N	13437	13437	13438
4843	3586	43	applied	\N	\N	\N	\N	13460	13460	13461
4843	3598	44	applied	\N	\N	\N	\N	13485	13485	13486
4843	3605	45	applied	\N	\N	\N	\N	13499	13499	13500
4843	3621	46	applied	\N	\N	\N	\N	13534	13534	13535
4843	3630	47	applied	\N	\N	\N	\N	13553	13553	13554
4843	3631	48	applied	\N	\N	\N	\N	13555	13555	13556
4843	3632	49	applied	\N	\N	\N	\N	13557	13557	13558
4843	3633	50	applied	\N	\N	\N	\N	13559	13559	13560
4843	3640	51	applied	\N	\N	\N	\N	13577	13577	13578
4843	3641	52	applied	\N	\N	\N	\N	13579	13579	13580
4843	3648	53	applied	\N	\N	\N	\N	13594	13594	13595
4843	3649	54	applied	\N	\N	\N	\N	13598	13598	13599
4843	3650	55	applied	\N	\N	\N	\N	13600	13600	13601
4843	3651	56	applied	\N	\N	\N	\N	13605	13605	13606
4843	3653	57	applied	\N	\N	\N	\N	13612	13612	13613
4843	3654	58	applied	\N	\N	\N	\N	13615	13615	13616
4843	3655	59	applied	\N	\N	\N	\N	13617	13617	13618
4843	3656	60	applied	\N	\N	\N	\N	13622	13622	13623
4843	3658	61	applied	\N	\N	\N	\N	13629	13629	13630
4843	3659	62	applied	\N	\N	\N	\N	13631	13631	13632
4843	3661	63	applied	\N	\N	\N	\N	13638	13638	13639
4843	3662	64	applied	\N	\N	\N	\N	13640	13640	13641
4843	3663	65	applied	\N	\N	\N	\N	13647	13647	13648
4843	3664	66	applied	\N	\N	\N	\N	13649	13649	13650
4843	3665	67	applied	\N	\N	\N	\N	13654	13654	13655
4843	3666	68	applied	\N	\N	\N	\N	13656	13656	13657
4843	3669	69	applied	\N	\N	\N	\N	13664	13664	13665
4843	3671	70	applied	\N	\N	\N	\N	13674	13674	13675
4843	3673	71	applied	\N	\N	\N	\N	13688	13688	13689
4843	3675	72	applied	\N	\N	\N	\N	13692	13692	13693
4843	3676	73	applied	\N	\N	\N	\N	13695	13695	13696
4843	3678	74	applied	\N	\N	\N	\N	13700	13700	13701
4843	3679	75	applied	\N	\N	\N	\N	13704	13704	13705
4843	3681	76	applied	\N	\N	\N	\N	13710	13710	13711
4843	3682	77	applied	\N	\N	\N	\N	13712	13712	13713
4843	3683	78	applied	\N	\N	\N	\N	13715	13715	13716
4843	3686	79	applied	\N	\N	\N	\N	13722	13722	13723
4843	3688	80	applied	\N	\N	\N	\N	13827	13827	13828
4843	3689	81	applied	\N	\N	\N	\N	13833	13833	13834
4843	3690	82	applied	\N	\N	\N	\N	13838	13838	13839
4843	3691	83	applied	\N	\N	\N	\N	13840	13840	13841
4843	3692	84	applied	\N	\N	\N	\N	13844	13844	13845
4843	3694	85	applied	\N	\N	\N	\N	13848	13848	13849
4843	3695	87	applied	\N	\N	\N	\N	13850	13850	13851
4843	3697	88	applied	\N	\N	\N	\N	13858	13858	13859
4843	3698	89	applied	\N	\N	\N	\N	13860	13860	13861
4843	3699	90	applied	\N	\N	\N	\N	13862	13862	13863
4843	3700	91	applied	\N	\N	\N	\N	13864	13864	13865
4843	3701	92	applied	\N	\N	\N	\N	13866	13866	13867
4843	3702	93	applied	\N	\N	\N	\N	13870	13870	13871
4843	3704	94	applied	\N	\N	\N	\N	13876	13876	13877
4843	3705	95	applied	\N	\N	\N	\N	13882	13882	13883
4843	3706	96	applied	\N	\N	\N	\N	13890	13890	13891
4843	3707	97	applied	\N	\N	\N	\N	13896	13896	13897
4843	3708	98	applied	\N	\N	\N	\N	13900	13900	13901
4843	3709	99	applied	\N	\N	\N	\N	13904	13904	13905
4843	3710	100	applied	\N	\N	\N	\N	13908	13908	13909
4843	3711	101	applied	\N	\N	\N	\N	13914	13914	13915
4843	3716	102	applied	\N	\N	\N	\N	13932	13932	13933
4843	3717	103	applied	\N	\N	\N	\N	13934	13934	13935
4843	3720	104	applied	\N	\N	\N	\N	13946	13946	13947
4843	3721	105	applied	\N	\N	\N	\N	13948	13948	13949
4843	3722	106	applied	\N	\N	\N	\N	13950	13950	13951
4843	3723	107	applied	\N	\N	\N	\N	13953	13953	13954
4843	3724	108	applied	\N	\N	\N	\N	13955	13955	13956
4843	3725	109	applied	\N	\N	\N	\N	13957	13957	13958
4843	3726	110	applied	\N	\N	\N	\N	13963	13963	13964
4843	3727	111	applied	\N	\N	\N	\N	13966	13966	13967
4843	3728	112	applied	\N	\N	\N	\N	13980	13980	13981
4843	3729	113	applied	\N	\N	\N	\N	13982	13982	13983
4843	3730	114	applied	\N	\N	\N	\N	13986	13986	13987
4843	3731	115	applied	\N	\N	\N	\N	13990	13990	13991
4843	3732	116	applied	\N	\N	\N	\N	13996	13996	13997
4843	3733	117	applied	\N	\N	\N	\N	13998	13998	13999
4843	3734	118	applied	\N	\N	\N	\N	14002	14002	14003
4843	3735	119	applied	\N	\N	\N	\N	14006	14006	14007
4843	3736	120	applied	\N	\N	\N	\N	14008	14008	14009
4843	3737	121	applied	\N	\N	\N	\N	14012	14012	14013
4843	3738	122	applied	\N	\N	\N	\N	14017	14017	14018
4843	3739	123	applied	\N	\N	\N	\N	14022	14022	14023
4843	3740	124	applied	\N	\N	\N	\N	14030	14030	14031
4843	3741	125	applied	\N	\N	\N	\N	14037	14037	14038
4846	3996	0	applied	\N	\N	\N	\N	15042	15042	15043
4847	3997	0	applied	\N	\N	\N	\N	15045	15045	15046
4852	4002	0	applied	\N	\N	1000000000	\N	15065	15065	15066
4852	4003	1	applied	\N	\N	\N	\N	15067	15067	15068
4858	4004	0	applied	\N	\N	\N	\N	15074	15074	15075
4860	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4860	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4860	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4860	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4860	3958	4	applied	\N	\N	1000000000	\N	14805	14805	14806
4860	3959	5	applied	\N	\N	1000000000	\N	14807	14807	14808
4860	3962	6	applied	\N	\N	\N	\N	14818	14818	14819
4860	4000	7	applied	\N	\N	1000000000	\N	15059	15059	15060
4860	4002	8	applied	\N	\N	1000000000	\N	15065	15065	15066
4860	3977	9	applied	\N	\N	1000000000	\N	14931	14931	14932
4860	3880	10	applied	\N	\N	\N	\N	14527	14527	14528
4860	3881	11	applied	\N	\N	\N	\N	14532	14532	14533
4860	3882	12	applied	\N	\N	\N	\N	14538	14538	14539
4860	3883	13	applied	\N	\N	\N	\N	14542	14542	14543
4860	3884	14	applied	\N	\N	\N	\N	14544	14544	14545
4860	3885	15	applied	\N	\N	\N	\N	14547	14547	14548
4860	3906	16	applied	\N	\N	\N	\N	14624	14624	14625
4860	3886	17	applied	\N	\N	\N	\N	14551	14551	14552
4860	3887	18	applied	\N	\N	\N	\N	14557	14557	14558
4860	3888	19	applied	\N	\N	\N	\N	14559	14559	14560
4860	3889	20	applied	\N	\N	\N	\N	14565	14565	14566
4860	3890	21	applied	\N	\N	\N	\N	14569	14569	14570
4860	3891	22	applied	\N	\N	\N	\N	14573	14573	14574
4860	3981	23	applied	\N	\N	\N	\N	14943	14943	1435
4860	3893	24	applied	\N	\N	\N	\N	14578	14578	14579
4860	3892	25	applied	\N	\N	\N	\N	14575	14575	13857
4860	3899	26	applied	\N	\N	\N	\N	14598	14598	14599
4860	3894	27	applied	\N	\N	\N	\N	14582	14582	14583
4860	3895	28	applied	\N	\N	\N	\N	14586	14586	14587
4860	3896	29	applied	\N	\N	\N	\N	14588	14588	14589
4860	3897	30	applied	\N	\N	\N	\N	14590	14590	14591
4860	3898	31	applied	\N	\N	\N	\N	14596	14596	14597
4860	3901	32	applied	\N	\N	\N	\N	14607	14607	14608
4860	3902	33	applied	\N	\N	\N	\N	14609	14609	14610
4860	3903	34	applied	\N	\N	\N	\N	14614	14614	14615
4860	3904	35	applied	\N	\N	\N	\N	14618	14618	14619
4860	3905	36	applied	\N	\N	\N	\N	14622	14622	14623
4860	3907	37	applied	\N	\N	\N	\N	14627	14627	14628
4860	3908	38	applied	\N	\N	\N	\N	14629	14629	14630
4860	3909	39	applied	\N	\N	\N	\N	14633	14633	14634
4860	3910	40	applied	\N	\N	\N	\N	14637	14637	14638
4860	3911	41	applied	\N	\N	\N	\N	14639	14639	14640
4860	3912	42	applied	\N	\N	\N	\N	14646	14646	14647
4860	3913	43	applied	\N	\N	\N	\N	14648	14648	14649
4860	3914	44	applied	\N	\N	\N	\N	14653	14653	14654
4860	3915	45	applied	\N	\N	\N	\N	14655	14655	14656
4860	3916	46	applied	\N	\N	\N	\N	14657	14657	14658
4860	3917	47	applied	\N	\N	\N	\N	14664	14664	14665
4860	3918	48	applied	\N	\N	\N	\N	14670	14670	14671
4860	3919	49	applied	\N	\N	\N	\N	14674	14674	14675
4860	3920	50	applied	\N	\N	\N	\N	14678	14678	14679
4860	3922	51	applied	\N	\N	\N	\N	14684	14684	14685
4860	3923	52	applied	\N	\N	\N	\N	14686	14686	14687
4860	3924	53	applied	\N	\N	\N	\N	14689	14689	14690
4860	3925	54	applied	\N	\N	\N	\N	14697	14697	14698
4860	3926	55	applied	\N	\N	\N	\N	14704	14704	14705
4860	3927	56	applied	\N	\N	\N	\N	14708	14708	14709
4860	3928	57	applied	\N	\N	\N	\N	14710	14710	14711
4860	3929	58	applied	\N	\N	\N	\N	14716	14716	14717
4860	3930	59	applied	\N	\N	\N	\N	14718	14718	14719
4860	3931	60	applied	\N	\N	\N	\N	14720	14720	14721
4860	3932	61	applied	\N	\N	\N	\N	14722	14722	14723
4860	3933	62	applied	\N	\N	\N	\N	14727	14727	14728
4860	3934	63	applied	\N	\N	\N	\N	14730	14730	14731
4860	3935	64	applied	\N	\N	\N	\N	14732	14732	14733
4860	3936	65	applied	\N	\N	\N	\N	14736	14736	14737
4860	3937	66	applied	\N	\N	\N	\N	14742	14742	14743
4860	3938	67	applied	\N	\N	\N	\N	14746	14746	14747
4860	3939	68	applied	\N	\N	\N	\N	14748	14748	14749
4860	3940	69	applied	\N	\N	\N	\N	14750	14750	14751
4860	3941	70	applied	\N	\N	\N	\N	14752	14752	14753
4860	3942	71	applied	\N	\N	\N	\N	14756	14756	14757
4860	3943	72	applied	\N	\N	\N	\N	14758	14758	14759
4860	3944	73	applied	\N	\N	\N	\N	14762	14762	14763
4860	3945	74	applied	\N	\N	\N	\N	14766	14766	14767
4860	3946	75	applied	\N	\N	\N	\N	14768	14768	14769
4860	3947	76	applied	\N	\N	\N	\N	14772	14772	14773
4860	3948	77	applied	\N	\N	\N	\N	14774	14774	14775
4860	3949	78	applied	\N	\N	\N	\N	14777	14777	14778
4860	3950	79	applied	\N	\N	\N	\N	14779	14779	14780
4860	3951	80	applied	\N	\N	\N	\N	14783	14783	14784
4860	3952	81	applied	\N	\N	\N	\N	14787	14787	14788
4860	3953	82	applied	\N	\N	\N	\N	14791	14791	14792
4860	3960	83	applied	\N	\N	\N	\N	14809	14809	14810
4860	3961	84	applied	\N	\N	\N	\N	14814	14814	14815
4860	3963	85	applied	\N	\N	\N	\N	14820	14820	14821
4860	3964	86	applied	\N	\N	\N	\N	14824	14824	14825
4860	3965	87	applied	\N	\N	\N	\N	14828	14828	14829
4860	3966	88	applied	\N	\N	\N	\N	14834	14834	14835
4860	3967	89	applied	\N	\N	\N	\N	14838	14838	14839
4860	3968	90	applied	\N	\N	\N	\N	14842	14842	14843
4860	3969	91	applied	\N	\N	\N	\N	14902	14902	14903
4860	3971	92	applied	\N	\N	\N	\N	14908	14908	14909
4860	3972	93	applied	\N	\N	\N	\N	14912	14912	14913
4860	3973	94	applied	\N	\N	\N	\N	14916	14916	14917
4860	3975	95	applied	\N	\N	\N	\N	14919	14919	14920
4860	3976	96	applied	\N	\N	\N	\N	14925	14925	14926
4860	3978	97	applied	\N	\N	\N	\N	14933	14933	14934
4860	3979	98	applied	\N	\N	\N	\N	14935	14935	14936
4860	3980	99	applied	\N	\N	\N	\N	14939	14939	14940
4860	3982	100	applied	\N	\N	\N	\N	14944	14944	14945
4860	3983	101	applied	\N	\N	\N	\N	14971	14971	14972
4860	3984	102	applied	\N	\N	\N	\N	14976	14976	14977
4860	3985	103	applied	\N	\N	\N	\N	14978	14978	14979
4860	3986	104	applied	\N	\N	\N	\N	14982	14982	14983
4860	3987	105	applied	\N	\N	\N	\N	14986	14986	14987
4860	3988	106	applied	\N	\N	\N	\N	14988	14988	14989
4860	3989	107	applied	\N	\N	\N	\N	15015	15015	15016
4860	3990	108	applied	\N	\N	\N	\N	15017	15017	15018
4860	3991	109	applied	\N	\N	\N	\N	15019	15019	15020
4860	3992	110	applied	\N	\N	\N	\N	15024	15024	15025
4860	3993	111	applied	\N	\N	\N	\N	15028	15028	15029
4860	3994	112	applied	\N	\N	\N	\N	15032	15032	15033
4860	3995	113	applied	\N	\N	\N	\N	15034	15034	15035
4860	3996	114	applied	\N	\N	\N	\N	15042	15042	15043
4860	3997	115	applied	\N	\N	\N	\N	15045	15045	15046
4860	3998	117	applied	\N	\N	\N	\N	15049	15049	15050
4860	3999	118	applied	\N	\N	\N	\N	15055	15055	15056
4860	4001	119	applied	\N	\N	\N	\N	15061	15061	15062
4860	4003	120	applied	\N	\N	\N	\N	15067	15067	15068
4860	4004	121	applied	\N	\N	\N	\N	15074	15074	15075
4862	4005	0	applied	\N	\N	\N	\N	15086	15086	15087
4862	4006	1	applied	\N	\N	\N	\N	15088	15088	15089
4862	4007	2	applied	\N	\N	\N	\N	15090	15090	15091
4862	4008	3	applied	\N	\N	\N	\N	15092	15092	15093
4866	4011	0	applied	\N	\N	\N	\N	15105	15105	15106
4869	4013	0	applied	\N	\N	\N	\N	15111	15111	15112
4871	4014	0	applied	\N	\N	\N	\N	15116	15116	15117
4880	4019	0	applied	\N	\N	\N	\N	15146	15146	15147
4880	4020	1	applied	\N	\N	\N	\N	15148	15148	15149
4880	4021	2	applied	\N	\N	\N	\N	15150	15150	15151
4884	4022	0	applied	\N	\N	\N	\N	15160	15160	15161
4887	4024	0	applied	\N	\N	\N	\N	15166	15166	15167
4887	4025	1	applied	\N	\N	\N	\N	15168	15168	15169
4889	4027	0	applied	\N	\N	\N	\N	15176	15176	10168
4889	4028	1	applied	\N	\N	\N	\N	15177	15177	15178
4889	4029	2	applied	\N	\N	\N	\N	15179	15179	15180
4892	4031	0	applied	\N	\N	\N	\N	15185	15185	15186
4896	4032	0	applied	\N	\N	\N	\N	15195	15195	15196
4901	4033	0	applied	\N	\N	\N	\N	15199	15199	15200
4903	4034	0	applied	\N	\N	\N	\N	15207	15207	15208
4905	4035	0	applied	\N	\N	\N	\N	15212	15212	15213
4911	4036	0	applied	\N	\N	\N	\N	14932	14932	15216
4911	4037	1	applied	\N	\N	\N	\N	15217	15217	15218
4911	4038	2	applied	\N	\N	\N	\N	15219	15219	15220
4912	4039	0	applied	\N	\N	\N	\N	15228	15228	15229
4914	4039	0	applied	\N	\N	\N	\N	15228	15228	15229
4922	4048	0	applied	\N	\N	\N	\N	15261	15261	15262
4924	4049	0	applied	\N	\N	\N	\N	15266	15266	15267
4930	4055	0	applied	\N	\N	\N	\N	15281	15281	15282
4930	4056	1	applied	\N	\N	\N	\N	15283	15283	15284
4933	4060	0	applied	\N	\N	1000000000	\N	15297	15297	15298
4933	4061	1	applied	\N	\N	\N	\N	15299	15299	15300
4938	4065	0	applied	\N	\N	\N	\N	15309	15309	15310
4942	4067	0	applied	\N	\N	\N	\N	15318	15318	15319
4949	4070	0	applied	\N	\N	\N	\N	15332	15332	15333
4952	4077	0	applied	\N	\N	\N	\N	15349	15349	15350
4955	4079	0	applied	\N	\N	\N	\N	15356	15356	15357
4957	4081	0	applied	\N	\N	\N	\N	15364	15364	15365
4960	4083	0	applied	\N	\N	1000000000	\N	15372	15372	15373
4960	4084	1	applied	\N	\N	\N	\N	15374	15374	15375
4960	4085	2	applied	\N	\N	\N	\N	15376	15376	15377
4965	4089	0	applied	\N	\N	\N	\N	15392	15392	15393
4965	4090	1	applied	\N	\N	\N	\N	15394	15394	15395
4968	4092	0	applied	\N	\N	\N	\N	15403	15403	15404
4970	4093	0	applied	\N	\N	\N	\N	15407	15407	15408
4970	4094	1	applied	\N	\N	\N	\N	15409	15409	15410
4975	4098	0	applied	\N	\N	\N	\N	15426	15426	15427
4977	4099	0	applied	\N	\N	\N	\N	15430	15430	15431
4977	4100	1	applied	\N	\N	\N	\N	15432	15432	15433
4977	4101	2	applied	\N	\N	\N	\N	15434	15434	15435
4980	4102	0	applied	\N	\N	\N	\N	15441	15441	15441
4980	4103	1	applied	\N	\N	\N	\N	15442	15442	15443
4980	4104	2	applied	\N	\N	\N	\N	15444	15444	15445
4980	4105	3	applied	\N	\N	\N	\N	15446	15446	15447
4874	3930	91	applied	\N	\N	\N	\N	14718	14718	14892
4874	3931	92	applied	\N	\N	\N	\N	14720	14720	14893
4874	3932	93	applied	\N	\N	\N	\N	14722	14722	14894
4874	3933	94	applied	\N	\N	\N	\N	14727	14727	14895
4874	3934	95	applied	\N	\N	\N	\N	14730	14730	14896
4874	3935	96	applied	\N	\N	\N	\N	14732	14732	14897
4874	3936	97	applied	\N	\N	\N	\N	14736	14736	14898
4874	3937	98	applied	\N	\N	\N	\N	14742	14742	14899
4874	3938	99	applied	\N	\N	\N	\N	14746	14746	14900
4874	3939	100	applied	\N	\N	\N	\N	14748	14748	14951
4874	3940	101	applied	\N	\N	\N	\N	14750	14750	14952
4874	3941	102	applied	\N	\N	\N	\N	14752	14752	14953
4874	3942	103	applied	\N	\N	\N	\N	14756	14756	14954
4874	3943	104	applied	\N	\N	\N	\N	14758	14758	14955
4874	3944	105	applied	\N	\N	\N	\N	14762	14762	14956
4874	3945	106	applied	\N	\N	\N	\N	14766	14766	14957
4874	3946	107	applied	\N	\N	\N	\N	14768	14768	14958
4874	3947	108	applied	\N	\N	\N	\N	14772	14772	14959
4874	3948	109	applied	\N	\N	\N	\N	14774	14774	14960
4874	3949	110	applied	\N	\N	\N	\N	14777	14777	14961
4874	3950	111	applied	\N	\N	\N	\N	14779	14779	14962
4874	3951	115	applied	\N	\N	\N	\N	14783	14783	14963
4874	3952	116	applied	\N	\N	\N	\N	14787	14787	14964
4874	3953	117	applied	\N	\N	\N	\N	14791	14791	14965
4874	3960	118	applied	\N	\N	\N	\N	14809	14809	14966
4874	3961	119	applied	\N	\N	\N	\N	14814	14814	14967
4874	3963	120	applied	\N	\N	\N	\N	14820	14820	14968
4874	3964	121	applied	\N	\N	\N	\N	14824	14824	14990
4874	3965	122	applied	\N	\N	\N	\N	14828	14828	14991
4874	3966	123	applied	\N	\N	\N	\N	14834	14834	14992
4874	3967	124	applied	\N	\N	\N	\N	14838	14838	14993
4874	3968	125	applied	\N	\N	\N	\N	14842	14842	14994
4875	4015	0	applied	\N	\N	\N	\N	15134	15134	15135
4878	4018	0	applied	\N	\N	\N	\N	15144	15144	15145
4883	4019	0	applied	\N	\N	\N	\N	15146	15146	15147
4883	4020	1	applied	\N	\N	\N	\N	15148	15148	15149
4883	4021	2	applied	\N	\N	\N	\N	15150	15150	15151
4885	4023	0	applied	\N	\N	\N	\N	15162	15162	15163
4895	4000	0	applied	\N	\N	1000000000	\N	15059	15059	15060
4895	4002	1	applied	\N	\N	1000000000	\N	15065	15065	15066
4895	3742	2	applied	\N	\N	\N	\N	14041	14041	14042
4895	3743	3	applied	\N	\N	\N	\N	14047	14047	14048
4895	3744	4	applied	\N	\N	\N	\N	14050	14050	14051
4895	3745	5	applied	\N	\N	\N	\N	14054	14054	14055
4895	3746	6	applied	\N	\N	\N	\N	14058	14058	14059
4895	3747	7	applied	\N	\N	\N	\N	14060	14060	14061
4895	3749	8	applied	\N	\N	\N	\N	14065	14065	14066
4895	3750	9	applied	\N	\N	\N	\N	14068	14068	14069
4895	3751	10	applied	\N	\N	\N	\N	14070	14070	14071
4895	3752	11	applied	\N	\N	\N	\N	14073	14073	14074
4895	3754	12	applied	\N	\N	\N	\N	14078	14078	14079
4895	3755	13	applied	\N	\N	\N	\N	14081	14081	14082
4895	3767	14	applied	\N	\N	\N	\N	14108	14108	14109
4895	3768	15	applied	\N	\N	\N	\N	14110	14110	14111
4895	3769	16	applied	\N	\N	\N	\N	14112	14112	14113
4895	3770	17	applied	\N	\N	\N	\N	14125	14125	14126
4895	3771	18	applied	\N	\N	\N	\N	14135	14135	14136
4895	3772	19	applied	\N	\N	\N	\N	14139	14139	14140
4895	3773	20	applied	\N	\N	\N	\N	14141	14141	14142
4895	3776	21	applied	\N	\N	\N	\N	14148	14148	14149
4895	3777	22	applied	\N	\N	\N	\N	14153	14153	14154
4895	3778	23	applied	\N	\N	\N	\N	14157	14157	14158
4895	3779	24	applied	\N	\N	\N	\N	14161	14161	14162
4895	3780	25	applied	\N	\N	\N	\N	14168	14168	14169
4895	3781	26	applied	\N	\N	\N	\N	14170	14170	14171
4895	3783	27	applied	\N	\N	\N	\N	14176	14176	14177
4895	3784	28	applied	\N	\N	\N	\N	14179	14179	14180
4895	3785	29	applied	\N	\N	\N	\N	14185	14185	14186
4895	3786	30	applied	\N	\N	\N	\N	14187	14187	14188
4895	3787	31	applied	\N	\N	\N	\N	14193	14193	14194
4895	3788	32	applied	\N	\N	\N	\N	14196	14196	14197
4895	3789	33	applied	\N	\N	\N	\N	14202	14202	14203
4895	3791	34	applied	\N	\N	\N	\N	14206	14206	14207
4895	3792	35	applied	\N	\N	\N	\N	14208	14208	14209
4895	3793	36	applied	\N	\N	\N	\N	14210	14210	14211
4895	3794	37	applied	\N	\N	\N	\N	14212	14212	14213
4895	3795	38	applied	\N	\N	\N	\N	14221	14221	14222
4895	3796	39	applied	\N	\N	\N	\N	14223	14223	14224
4895	3797	40	applied	\N	\N	\N	\N	14225	14225	14226
4895	3798	41	applied	\N	\N	\N	\N	14227	14227	14228
4895	3799	42	applied	\N	\N	\N	\N	14236	14236	14237
4895	3800	43	applied	\N	\N	\N	\N	14238	14238	14239
4895	3801	44	applied	\N	\N	\N	\N	14240	14240	14241
4895	3803	45	applied	\N	\N	\N	\N	14244	14244	14245
4895	3804	46	applied	\N	\N	\N	\N	14248	14248	14249
4895	3806	47	applied	\N	\N	\N	\N	14251	14251	14252
4895	3807	48	applied	\N	\N	\N	\N	14255	14255	14256
4895	3808	49	applied	\N	\N	\N	\N	14258	14258	14259
4895	3809	50	applied	\N	\N	\N	\N	14260	14260	14261
4895	3810	51	applied	\N	\N	\N	\N	14262	14262	14263
4895	3811	52	applied	\N	\N	\N	\N	14265	14265	14266
4895	3812	53	applied	\N	\N	\N	\N	14267	14267	14268
4895	3813	54	applied	\N	\N	\N	\N	14269	14269	14270
4895	3814	55	applied	\N	\N	\N	\N	14273	14273	14274
4895	3815	56	applied	\N	\N	\N	\N	14277	14277	14278
4895	3816	57	applied	\N	\N	\N	\N	14282	14282	14283
4895	3817	58	applied	\N	\N	\N	\N	14287	14287	14288
4895	3818	59	applied	\N	\N	\N	\N	14289	14289	14290
4895	3819	60	applied	\N	\N	\N	\N	14291	14291	14292
4895	3820	61	applied	\N	\N	\N	\N	14295	14295	14296
4895	3821	62	applied	\N	\N	\N	\N	14298	14298	14299
4895	3823	63	applied	\N	\N	\N	\N	14307	14307	14308
4895	3824	64	applied	\N	\N	\N	\N	14309	14309	14310
4895	3825	65	applied	\N	\N	\N	\N	14317	14317	14318
4895	3826	66	applied	\N	\N	\N	\N	14321	14321	14322
4895	3827	67	applied	\N	\N	\N	\N	14328	14328	14329
4895	3828	68	applied	\N	\N	\N	\N	14334	14334	14335
4895	3829	69	applied	\N	\N	\N	\N	14336	14336	14337
4895	3830	70	applied	\N	\N	\N	\N	14338	14338	14339
4895	3831	71	applied	\N	\N	\N	\N	14343	14343	14344
4895	3832	72	applied	\N	\N	\N	\N	14345	14345	14346
4895	3833	73	applied	\N	\N	\N	\N	14355	14355	14356
4895	3834	74	applied	\N	\N	\N	\N	14357	14357	14358
4895	3835	75	applied	\N	\N	\N	\N	14359	14359	14360
4895	3836	76	applied	\N	\N	\N	\N	14363	14363	14364
4895	3837	77	applied	\N	\N	\N	\N	14368	14368	14369
4895	3838	78	applied	\N	\N	\N	\N	14375	14375	14376
4895	3839	79	applied	\N	\N	\N	\N	14385	14385	14386
4895	3840	80	applied	\N	\N	\N	\N	14389	14389	14390
4895	3841	81	applied	\N	\N	\N	\N	14391	14391	14392
4895	3842	82	applied	\N	\N	\N	\N	14393	14393	14394
4895	3843	83	applied	\N	\N	\N	\N	14397	14397	14398
4895	3845	84	applied	\N	\N	\N	\N	14406	14406	14407
4895	3852	85	applied	\N	\N	\N	\N	14421	14421	14422
4895	3853	87	applied	\N	\N	\N	\N	14425	14425	14426
4895	3854	88	applied	\N	\N	\N	\N	14429	14429	14430
4895	3855	89	applied	\N	\N	\N	\N	14431	14431	14432
4895	3856	90	applied	\N	\N	\N	\N	14433	14433	14434
4895	3857	91	applied	\N	\N	\N	\N	14437	14437	14438
4895	3858	92	applied	\N	\N	\N	\N	14439	14439	14440
4895	3859	93	applied	\N	\N	\N	\N	14441	14441	14442
4895	3860	94	applied	\N	\N	\N	\N	14446	14446	14447
4895	3862	95	applied	\N	\N	\N	\N	14452	14452	14453
4895	3863	96	applied	\N	\N	\N	\N	14458	14458	14459
4895	3864	97	applied	\N	\N	\N	\N	14463	14463	14464
4895	3865	98	applied	\N	\N	\N	\N	14467	14467	14468
4895	3866	99	applied	\N	\N	\N	\N	14469	14469	14470
4895	3867	100	applied	\N	\N	\N	\N	14473	14473	14474
4895	3868	101	applied	\N	\N	\N	\N	14481	14481	14482
4895	3869	102	applied	\N	\N	\N	\N	14485	14485	14486
4895	3870	103	applied	\N	\N	\N	\N	14489	14489	14490
4898	4032	0	applied	\N	\N	\N	\N	15195	15195	15196
4904	4034	0	applied	\N	\N	\N	\N	15207	15207	15208
4909	4036	0	applied	\N	\N	\N	\N	14932	14932	15216
4909	4037	1	applied	\N	\N	\N	\N	15217	15217	15218
4909	4038	2	applied	\N	\N	\N	\N	15219	15219	15220
4916	4044	0	applied	\N	\N	\N	\N	15243	15243	15244
4916	4045	1	applied	\N	\N	\N	\N	15245	15245	15246
4919	4046	0	applied	\N	\N	\N	\N	15251	15251	15252
4928	4051	0	applied	\N	\N	\N	\N	15270	15270	15271
4931	4055	0	applied	\N	\N	\N	\N	15281	15281	15282
4931	4056	1	applied	\N	\N	\N	\N	15283	15283	15284
4932	4057	0	applied	\N	\N	\N	\N	15289	15289	15290
4932	4058	1	applied	\N	\N	\N	\N	15291	15291	15292
4932	4059	2	applied	\N	\N	\N	\N	15293	15293	15294
4934	4062	0	applied	\N	\N	\N	\N	15303	15303	14606
4934	4063	1	applied	\N	\N	\N	\N	15304	15304	15305
4939	3954	0	applied	\N	\N	1000000000	\N	14797	14797	14798
4939	3955	1	applied	\N	\N	1000000000	\N	14799	14799	14800
4939	3956	2	applied	\N	\N	1000000000	\N	14801	14801	14802
4939	3957	3	applied	\N	\N	1000000000	\N	14803	14803	14804
4939	3958	4	applied	\N	\N	1000000000	\N	14805	14805	14806
4939	3959	5	applied	\N	\N	1000000000	\N	14807	14807	14808
4939	3962	6	applied	\N	\N	\N	\N	14818	14818	14819
4939	4000	7	applied	\N	\N	1000000000	\N	15059	15059	15060
4939	4002	8	applied	\N	\N	1000000000	\N	15065	15065	15066
4939	4040	9	applied	\N	\N	1000000000	\N	15234	15234	15235
4939	4060	10	applied	\N	\N	1000000000	\N	15297	15297	15298
4939	3977	11	applied	\N	\N	1000000000	\N	14931	14931	14932
4939	4062	12	applied	\N	\N	\N	\N	15303	15303	14606
4939	3981	13	applied	\N	\N	\N	\N	14943	14943	1435
4939	3892	14	applied	\N	\N	\N	\N	14575	14575	13857
4939	3899	15	applied	\N	\N	\N	\N	14598	14598	14599
4939	4025	16	applied	\N	\N	\N	\N	15168	15168	15169
4943	4068	0	applied	\N	\N	\N	\N	15322	15322	15323
4945	4069	0	applied	\N	\N	\N	\N	15326	15326	15327
4951	4076	0	applied	\N	\N	\N	\N	15347	15347	15348
4956	4080	0	applied	\N	\N	\N	\N	15360	15360	15361
4959	4082	0	applied	\N	\N	\N	\N	15368	15368	15369
4962	4086	0	applied	\N	\N	\N	\N	15380	15380	15381
4962	4087	1	applied	\N	\N	\N	\N	15382	15382	15383
4969	4093	0	applied	\N	\N	\N	\N	15407	15407	15408
4969	4094	1	applied	\N	\N	\N	\N	15409	15409	15410
4972	4095	0	applied	\N	\N	\N	\N	15415	15415	15416
4978	4099	0	applied	\N	\N	\N	\N	15430	15430	15431
4978	4100	1	applied	\N	\N	\N	\N	15432	15432	15433
4978	4101	2	applied	\N	\N	\N	\N	15434	15434	15435
4981	4102	0	applied	\N	\N	\N	\N	15441	15441	15441
4981	4103	1	applied	\N	\N	\N	\N	15442	15442	15443
4981	4104	2	applied	\N	\N	\N	\N	15444	15444	15445
4981	4105	3	applied	\N	\N	\N	\N	15446	15446	15447
4910	4037	1	applied	\N	\N	\N	\N	15217	15217	15218
4910	4038	2	applied	\N	\N	\N	\N	15219	15219	15220
4917	4044	0	applied	\N	\N	\N	\N	15243	15243	15244
4917	4045	1	applied	\N	\N	\N	\N	15245	15245	15246
4920	4046	0	applied	\N	\N	\N	\N	15251	15251	15252
4921	4047	0	applied	\N	\N	\N	\N	15257	15257	15258
4926	4050	0	applied	\N	\N	\N	\N	15268	15268	15269
4929	4052	0	applied	\N	\N	\N	\N	15273	15273	15274
4929	4053	1	applied	\N	\N	\N	\N	15275	15275	15276
4929	4054	2	applied	\N	\N	\N	\N	15277	15277	15278
4937	4065	0	applied	\N	\N	\N	\N	15309	15309	15310
4940	4066	0	applied	\N	\N	\N	\N	15315	15315	15316
4941	4067	0	applied	\N	\N	\N	\N	15318	15318	15319
4944	4068	0	applied	\N	\N	\N	\N	15322	15322	15323
4946	4069	0	applied	\N	\N	\N	\N	15326	15326	15327
4948	4070	0	applied	\N	\N	\N	\N	15332	15332	15333
4954	4079	0	applied	\N	\N	\N	\N	15356	15356	15357
4963	4086	0	applied	\N	\N	\N	\N	15380	15380	15381
4963	4087	1	applied	\N	\N	\N	\N	15382	15382	15383
4964	4088	0	applied	\N	\N	\N	\N	15388	15388	15389
4967	4091	0	applied	\N	\N	\N	\N	15399	15399	15400
4974	4096	0	applied	\N	\N	\N	\N	15422	15422	15422
4974	4097	1	applied	\N	\N	\N	\N	15423	15423	15424
4950	4074	3	applied	\N	\N	\N	\N	15341	15341	15342
4950	4075	4	applied	\N	\N	\N	\N	15343	15343	15344
4953	4078	0	applied	\N	\N	\N	\N	15353	15353	15354
4958	4082	0	applied	\N	\N	\N	\N	15368	15368	15369
4961	4086	0	applied	\N	\N	\N	\N	15380	15380	15381
4961	4087	1	applied	\N	\N	\N	\N	15382	15382	15383
4966	4089	0	applied	\N	\N	\N	\N	15392	15392	15393
4966	4090	1	applied	\N	\N	\N	\N	15394	15394	15395
4971	4095	0	applied	\N	\N	\N	\N	15415	15415	15416
4973	4095	0	applied	\N	\N	\N	\N	15415	15415	15416
4976	4099	0	applied	\N	\N	\N	\N	15430	15430	15431
4976	4100	1	applied	\N	\N	\N	\N	15432	15432	15433
4976	4101	2	applied	\N	\N	\N	\N	15434	15434	15435
4979	4102	0	applied	\N	\N	\N	\N	15441	15441	15441
4979	4103	1	applied	\N	\N	\N	\N	15442	15442	15443
4979	4104	2	applied	\N	\N	\N	\N	15444	15444	15445
4979	4105	3	applied	\N	\N	\N	\N	15446	15446	15447
4982	4106	0	applied	\N	\N	\N	\N	15452	15452	15453
4983	4106	0	applied	\N	\N	\N	\N	15452	15452	15453
4984	4107	0	applied	\N	\N	\N	\N	15456	15456	15457
4984	4108	1	applied	\N	\N	\N	\N	15458	15458	15459
4984	4109	2	applied	\N	\N	\N	\N	15460	15460	15461
4985	4107	0	applied	\N	\N	\N	\N	15456	15456	15457
4985	4108	1	applied	\N	\N	\N	\N	15458	15458	15459
4985	4109	2	applied	\N	\N	\N	\N	15460	15460	15461
4986	4107	0	applied	\N	\N	\N	\N	15456	15456	15457
4986	4108	1	applied	\N	\N	\N	\N	15458	15458	15459
4986	4109	2	applied	\N	\N	\N	\N	15460	15460	15461
4987	4107	0	applied	\N	\N	\N	\N	15456	15456	15457
4987	4108	1	applied	\N	\N	\N	\N	15458	15458	15459
4987	4109	2	applied	\N	\N	\N	\N	15460	15460	15461
4988	4110	0	applied	\N	\N	\N	\N	15468	15468	15469
4989	4111	0	applied	\N	\N	\N	\N	15472	15472	15473
4989	4112	1	applied	\N	\N	\N	\N	15474	15474	15475
4990	4113	0	applied	\N	\N	\N	\N	15477	15477	15478
4991	4113	0	applied	\N	\N	\N	\N	15477	15477	15478
4992	4113	0	applied	\N	\N	\N	\N	15477	15477	15478
4993	4114	0	applied	\N	\N	\N	\N	15484	15484	15485
4994	4115	0	applied	\N	\N	1000000000	\N	15486	15486	15487
4994	4116	1	applied	\N	\N	\N	\N	15488	15488	15489
4994	4117	2	applied	\N	\N	\N	\N	15490	15490	15491
4994	4118	3	applied	\N	\N	\N	\N	15492	15492	15493
4995	4115	0	applied	\N	\N	1000000000	\N	15486	15486	15487
4995	4116	1	applied	\N	\N	\N	\N	15488	15488	15489
4995	4117	2	applied	\N	\N	\N	\N	15490	15490	15491
4995	4118	3	applied	\N	\N	\N	\N	15492	15492	15493
4996	4119	0	applied	\N	\N	\N	\N	15498	15498	15499
4997	4120	0	applied	\N	\N	\N	\N	15500	15500	15500
4997	4121	1	applied	\N	\N	\N	\N	15501	15501	15502
4997	4122	2	applied	\N	\N	\N	\N	15503	15503	15504
4998	4123	0	applied	\N	\N	\N	\N	15506	15506	15507
4999	4123	0	applied	\N	\N	\N	\N	15506	15506	15507
5000	4124	0	applied	\N	\N	\N	\N	15512	15512	15513
5001	4124	0	applied	\N	\N	\N	\N	15512	15512	15513
5002	4125	0	applied	\N	\N	\N	\N	15518	15518	15519
5003	4125	0	applied	\N	\N	\N	\N	15518	15518	15519
5004	4125	0	applied	\N	\N	\N	\N	15518	15518	15519
5005	4125	0	applied	\N	\N	\N	\N	15518	15518	15519
5006	4125	0	applied	\N	\N	\N	\N	15518	15518	15519
5007	4126	0	applied	\N	\N	1000000000	\N	15530	15530	15531
5007	4127	1	applied	\N	\N	\N	\N	15532	15532	15533
5008	4126	0	applied	\N	\N	1000000000	\N	15530	15530	15531
5008	4127	1	applied	\N	\N	\N	\N	15532	15532	15533
5009	4128	0	applied	\N	\N	\N	\N	15537	15537	15538
5010	4129	0	applied	\N	\N	\N	\N	15541	15541	15542
5011	4130	0	applied	\N	\N	\N	\N	15545	15545	15546
5012	4130	0	applied	\N	\N	\N	\N	15545	15545	15546
5013	4131	0	applied	\N	\N	\N	\N	15551	15551	15552
5014	4132	0	applied	\N	\N	\N	\N	15554	15554	15555
5015	4133	0	applied	\N	\N	\N	\N	15558	15558	15559
5016	4134	0	applied	\N	\N	\N	\N	15560	15560	15561
5017	4135	0	applied	\N	\N	\N	\N	15562	15562	15563
5017	4136	1	applied	\N	\N	\N	\N	15564	15564	15565
5018	4137	0	applied	\N	\N	\N	\N	15568	15568	15569
5019	4138	0	applied	\N	\N	\N	\N	15572	15572	15573
5019	4139	1	applied	\N	\N	\N	\N	15574	15574	15575
5020	4140	0	applied	\N	\N	\N	\N	15578	15578	15579
5021	4141	0	applied	\N	\N	\N	\N	15582	15582	15583
5021	4142	1	applied	\N	\N	\N	\N	15584	15584	15585
5022	4143	0	applied	\N	\N	1000000000	\N	15588	15588	15589
5022	4144	1	applied	\N	\N	\N	\N	15590	15590	15591
5023	4143	0	applied	\N	\N	1000000000	\N	15588	15588	15589
5023	4144	1	applied	\N	\N	\N	\N	15590	15590	15591
5024	4145	0	applied	\N	\N	\N	\N	15595	15595	15596
5025	4145	0	applied	\N	\N	\N	\N	15595	15595	15596
5026	4145	0	applied	\N	\N	\N	\N	15595	15595	15596
5027	4145	0	applied	\N	\N	\N	\N	15595	15595	15596
5029	4146	0	applied	\N	\N	\N	\N	15605	15605	15606
5030	4146	0	applied	\N	\N	\N	\N	15605	15605	15606
5031	4147	0	applied	\N	\N	\N	\N	15611	15611	15612
5032	4147	0	applied	\N	\N	\N	\N	15611	15611	15612
5033	4148	0	applied	\N	\N	\N	\N	15615	15615	15616
5034	4148	0	applied	\N	\N	\N	\N	15615	15615	15616
5035	4148	0	applied	\N	\N	\N	\N	15615	15615	15616
5036	4148	0	applied	\N	\N	\N	\N	15615	15615	15616
5037	4149	0	applied	\N	\N	\N	\N	15623	15623	15624
5037	4150	1	applied	\N	\N	\N	\N	15625	15625	15626
5038	4149	0	applied	\N	\N	\N	\N	15623	15623	15624
5038	4150	1	applied	\N	\N	\N	\N	15625	15625	15626
5039	4151	0	applied	\N	\N	\N	\N	15629	15629	15630
5039	4152	1	applied	\N	\N	\N	\N	15631	15631	15632
5040	4151	0	applied	\N	\N	\N	\N	15629	15629	15630
5040	4152	1	applied	\N	\N	\N	\N	15631	15631	15632
5041	4153	0	applied	\N	\N	\N	\N	15638	15638	15639
5042	4153	0	applied	\N	\N	\N	\N	15638	15638	15639
5043	4153	0	applied	\N	\N	\N	\N	15638	15638	15639
5044	4151	0	applied	\N	\N	\N	\N	15629	15629	15630
5044	4152	1	applied	\N	\N	\N	\N	15631	15631	15632
5044	4153	2	applied	\N	\N	\N	\N	15638	15638	15639
5046	4153	0	applied	\N	\N	\N	\N	15638	15638	15639
5046	4154	1	applied	\N	\N	\N	\N	15646	15646	15647
5047	4155	0	applied	\N	\N	\N	\N	15650	15650	15651
5048	4156	0	applied	\N	\N	\N	\N	15654	15654	15655
5048	4157	1	applied	\N	\N	\N	\N	15656	15656	15657
5048	4158	2	applied	\N	\N	\N	\N	15658	15658	15659
5048	4159	3	applied	\N	\N	\N	\N	15660	15660	15661
5049	4160	0	applied	\N	\N	\N	\N	15663	15663	15664
5050	4161	0	applied	\N	\N	\N	\N	15665	15665	15666
5051	4162	0	applied	\N	\N	\N	\N	15669	15669	15670
5051	4163	1	applied	\N	\N	\N	\N	15671	15671	15672
5051	4164	2	applied	\N	\N	\N	\N	15673	15673	15674
5053	4166	0	applied	\N	\N	\N	\N	15679	15679	15680
5060	4168	0	applied	\N	\N	\N	\N	15687	15687	15688
5063	4170	0	applied	\N	\N	\N	\N	15695	15695	15696
5067	4173	0	applied	\N	\N	\N	\N	15710	15710	15711
5070	4171	0	applied	\N	\N	\N	\N	15705	15705	15706
5070	4172	1	applied	\N	\N	\N	\N	15707	15707	15708
5070	4173	2	applied	\N	\N	\N	\N	15710	15710	15711
5071	4174	0	applied	\N	\N	\N	\N	15719	15719	15720
5074	4176	0	applied	\N	\N	\N	\N	15723	15723	15724
5078	4184	0	applied	\N	\N	\N	\N	15745	15745	15746
5078	4185	1	applied	\N	\N	\N	\N	15747	15747	12588
5091	4191	0	applied	\N	\N	\N	\N	15771	15771	15772
5091	4192	1	applied	\N	\N	\N	\N	15773	15773	15774
5092	4193	0	applied	\N	\N	\N	\N	15779	15779	15780
5093	4194	0	applied	\N	\N	\N	\N	15782	15782	15783
5096	4197	0	applied	\N	\N	\N	\N	15790	15790	15791
5096	4198	1	applied	\N	\N	\N	\N	15792	15792	15793
5100	4203	0	applied	\N	\N	\N	\N	15809	15809	1435
5100	4204	1	applied	\N	\N	\N	\N	15810	15810	15811
5104	4206	0	applied	\N	\N	\N	\N	15818	15818	15819
5108	4208	0	applied	\N	\N	\N	\N	15828	15828	15829
5115	4210	0	applied	\N	\N	\N	\N	15838	15838	15839
5115	4211	1	applied	\N	\N	\N	\N	15840	15840	15841
5120	4211	0	applied	\N	\N	\N	\N	15840	15840	15841
5120	4212	1	applied	\N	\N	\N	\N	15845	15845	15846
5127	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5127	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5130	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5130	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5132	4220	0	applied	\N	\N	\N	\N	15875	15875	15876
5132	4221	1	applied	\N	\N	\N	\N	15877	15877	15878
5132	4222	2	applied	\N	\N	\N	\N	15879	15879	15880
5138	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5138	4228	1	applied	\N	\N	\N	\N	15897	15897	15898
5144	4233	0	applied	\N	\N	\N	\N	15918	15918	15919
5145	4234	0	applied	\N	\N	\N	\N	15920	15920	15921
5145	4235	1	applied	\N	\N	\N	\N	15922	15922	7310
5147	4237	0	applied	\N	\N	\N	\N	15927	15927	15928
5149	4238	0	applied	\N	\N	\N	\N	15933	15933	15934
5149	4239	1	applied	\N	\N	\N	\N	15935	15935	15936
5154	4242	0	applied	\N	\N	\N	\N	15947	15947	15948
5155	4243	0	applied	\N	\N	\N	\N	15949	15949	15950
5168	4254	0	applied	\N	\N	\N	\N	15985	15985	15986
5180	4259	0	applied	\N	\N	\N	\N	16005	16005	16006
5180	4260	1	applied	\N	\N	\N	\N	16007	16007	16008
5180	4261	2	applied	\N	\N	\N	\N	16016	16016	16017
5180	4262	3	applied	\N	\N	\N	\N	16020	16020	16021
5180	4263	4	applied	\N	\N	\N	\N	16022	16022	16023
5182	4265	0	applied	\N	\N	\N	\N	16034	16034	16035
5185	4269	0	applied	\N	\N	\N	\N	16048	16048	16049
5187	4270	0	applied	\N	\N	\N	\N	16052	16052	16053
5193	4277	0	applied	\N	\N	\N	\N	16076	16076	16077
5195	4278	0	applied	\N	\N	\N	\N	16080	16080	16081
5201	4283	0	applied	\N	\N	\N	\N	16099	16099	16100
5201	4284	1	applied	\N	\N	\N	\N	16101	16101	16102
5207	4287	0	applied	\N	\N	\N	\N	16117	16117	16118
5217	4295	0	applied	\N	\N	\N	\N	16142	16142	16143
5224	4299	0	applied	\N	\N	\N	\N	16161	16161	16162
5229	4302	0	applied	\N	\N	\N	\N	16175	16175	16176
5229	4303	1	applied	\N	\N	\N	\N	16177	16177	16178
5231	4302	0	applied	\N	\N	\N	\N	16175	16175	16176
5231	4303	1	applied	\N	\N	\N	\N	16177	16177	16178
5238	4304	0	applied	\N	\N	\N	\N	16183	16183	16184
5238	4305	1	applied	\N	\N	\N	\N	16185	16185	16186
5238	4306	2	applied	\N	\N	\N	\N	16187	16187	16188
5244	4307	0	applied	\N	\N	\N	\N	16193	16193	16194
5256	4313	0	applied	\N	\N	\N	\N	16220	16220	16221
5256	4314	1	applied	\N	\N	\N	\N	16222	16222	16223
5260	4315	0	applied	\N	\N	\N	\N	16228	16228	16229
5263	4318	0	applied	\N	\N	\N	\N	16237	16237	16238
5263	4319	1	applied	\N	\N	\N	\N	16239	16239	16240
5274	4332	0	applied	\N	\N	\N	\N	16277	16277	16278
5277	4334	0	applied	\N	\N	\N	\N	16281	16281	16282
5277	4335	1	applied	\N	\N	\N	\N	16283	16283	16284
5282	4336	0	applied	\N	\N	\N	\N	16292	16292	16293
5283	4336	0	applied	\N	\N	\N	\N	16292	16292	16293
5293	4343	0	applied	\N	\N	\N	\N	16323	16323	16324
5295	4345	0	applied	\N	\N	\N	\N	16332	16332	16333
5298	4346	0	applied	\N	\N	\N	\N	16334	16334	16335
5305	4352	0	applied	\N	\N	\N	\N	16360	16360	16361
5305	4353	1	applied	\N	\N	\N	\N	16362	16362	16363
5308	4356	0	applied	\N	\N	\N	\N	16372	16372	16373
5317	4362	0	applied	\N	\N	\N	\N	16401	16401	16402
5319	4362	0	applied	\N	\N	\N	\N	16401	16401	16402
5320	4362	0	applied	\N	\N	\N	\N	16401	16401	16402
5330	4365	0	applied	\N	\N	\N	\N	16420	16420	16421
5332	4365	0	applied	\N	\N	\N	\N	16420	16420	16421
5334	4367	0	applied	\N	\N	\N	\N	16430	16430	16431
5336	4367	0	applied	\N	\N	\N	\N	16430	16430	16431
5341	4369	0	applied	\N	\N	\N	\N	16444	16444	16445
5343	4369	0	applied	\N	\N	\N	\N	16444	16444	16445
5343	4370	1	applied	\N	\N	\N	\N	16447	16447	16448
5343	4371	2	applied	\N	\N	\N	\N	16449	16449	16450
5343	4372	3	applied	\N	\N	\N	\N	16451	16451	16452
5348	4376	0	applied	\N	\N	\N	\N	16466	16466	16467
5351	4377	0	applied	\N	\N	\N	\N	16471	16471	16472
5353	4379	0	applied	\N	\N	\N	\N	16479	16479	16480
5358	4383	0	applied	\N	\N	\N	\N	16494	16494	16495
5363	4388	0	applied	\N	\N	\N	\N	16512	16512	16513
5366	4391	0	applied	\N	\N	\N	\N	16520	16520	16521
5380	4397	0	applied	\N	\N	\N	\N	16542	16542	16543
5404	4398	0	applied	\N	\N	1000000000	\N	16564	16564	16565
5416	4400	0	applied	\N	\N	\N	\N	16577	16577	16578
5449	4403	0	applied	\N	\N	1000000000	\N	16613	16613	16614
5459	4411	0	applied	\N	\N	\N	\N	16638	16638	16482
5539	4414	0	applied	\N	\N	\N	\N	16694	16694	1435
5596	4404	0	applied	\N	\N	1000000000	\N	16620	16620	16621
5596	4414	1	applied	\N	\N	\N	\N	16694	16694	1435
5596	4405	2	applied	\N	\N	1000000000	\N	16622	16622	16623
5596	4406	3	applied	\N	\N	1000000000	\N	16624	16624	16625
5596	4407	4	applied	\N	\N	1000000000	\N	16626	16626	16627
5596	4408	5	applied	\N	\N	1000000000	\N	16628	16628	16629
5596	4409	6	applied	\N	\N	1000000000	\N	16630	16630	16631
5596	4410	7	applied	\N	\N	1000000000	\N	16632	16632	16633
5596	4412	8	applied	\N	\N	\N	\N	16666	16666	16667
5596	4413	9	applied	\N	\N	\N	\N	16675	16675	16676
5052	4165	0	applied	\N	\N	\N	\N	15677	15677	15678
5059	4168	0	applied	\N	\N	\N	\N	15687	15687	15688
5061	4169	0	applied	\N	\N	\N	\N	15691	15691	15692
5062	4170	0	applied	\N	\N	\N	\N	15695	15695	15696
5066	4171	0	applied	\N	\N	\N	\N	15705	15705	15706
5066	4172	1	applied	\N	\N	\N	\N	15707	15707	15708
5069	4173	0	applied	\N	\N	\N	\N	15710	15710	15711
5076	4181	0	applied	\N	\N	\N	\N	15736	15736	15737
5076	4182	1	applied	\N	\N	\N	\N	15738	15738	15739
5081	4185	0	applied	\N	\N	\N	\N	15747	15747	12588
5082	4185	0	applied	\N	\N	\N	\N	15747	15747	12588
5084	4186	0	applied	\N	\N	\N	\N	15756	15756	15729
5084	4187	1	applied	\N	\N	\N	\N	15757	15757	15758
5087	4188	0	applied	\N	\N	\N	\N	15760	15760	15761
5087	4189	1	applied	\N	\N	\N	\N	15762	15762	15763
5090	4191	0	applied	\N	\N	\N	\N	15771	15771	15772
5090	4192	1	applied	\N	\N	\N	\N	15773	15773	15774
5095	4197	0	applied	\N	\N	\N	\N	15790	15790	15791
5095	4198	1	applied	\N	\N	\N	\N	15792	15792	15793
5098	4199	0	applied	\N	\N	\N	\N	15798	15798	15799
5098	4200	1	applied	\N	\N	\N	\N	15800	15800	15801
5098	4201	2	applied	\N	\N	\N	\N	15802	15802	15803
5103	4205	0	applied	\N	\N	\N	\N	15812	15812	15813
5109	4209	0	applied	\N	\N	\N	\N	15832	15832	15833
5112	4210	0	applied	\N	\N	\N	\N	15838	15838	15839
5117	4211	0	applied	\N	\N	\N	\N	15840	15840	15841
5121	4211	0	applied	\N	\N	\N	\N	15840	15840	15841
5121	4212	1	applied	\N	\N	\N	\N	15845	15845	15846
5123	4213	0	applied	\N	\N	\N	\N	15850	15850	15851
5123	4214	1	applied	\N	\N	\N	\N	15852	15852	15853
5126	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5126	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5131	4220	0	applied	\N	\N	\N	\N	15875	15875	15876
5135	4225	0	applied	\N	\N	\N	\N	15890	15890	15891
5135	4226	1	applied	\N	\N	\N	\N	15892	15892	15893
5139	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5139	4228	1	applied	\N	\N	\N	\N	15897	15897	15898
5146	4236	0	applied	\N	\N	\N	\N	15925	15925	15926
5148	4237	0	applied	\N	\N	\N	\N	15927	15927	15928
5151	4240	0	applied	\N	\N	\N	\N	15940	15940	15941
5157	4245	0	applied	\N	\N	\N	\N	15954	15954	15955
5157	4246	1	applied	\N	\N	\N	\N	15956	15956	15957
5158	4247	0	applied	\N	\N	\N	\N	15958	15958	15959
5162	4248	0	applied	\N	\N	\N	\N	15962	15962	15963
5165	4250	0	applied	\N	\N	\N	\N	15973	15973	15974
5169	4254	0	applied	\N	\N	\N	\N	15985	15985	15986
5175	4259	0	applied	\N	\N	\N	\N	16005	16005	16006
5175	4260	1	applied	\N	\N	\N	\N	16007	16007	16008
5183	4266	0	applied	\N	\N	\N	\N	16038	16038	16039
5183	4267	1	applied	\N	\N	\N	\N	16040	16040	16041
5188	4271	0	applied	\N	\N	\N	\N	16056	16056	16057
5188	4272	1	applied	\N	\N	\N	\N	16058	16058	16059
5191	4276	0	applied	\N	\N	\N	\N	16070	16070	16071
5196	4279	0	applied	\N	\N	\N	\N	16084	16084	16085
5198	4280	0	applied	\N	\N	\N	\N	16090	16090	16091
5203	4285	0	applied	\N	\N	\N	\N	16109	16109	16110
5208	4288	0	applied	\N	\N	\N	\N	16121	16121	16122
5215	4291	0	applied	\N	\N	1000000000	\N	16132	16132	16133
5215	4292	1	applied	\N	\N	\N	\N	16134	16134	16135
5215	4293	2	applied	\N	\N	\N	\N	16136	16136	16137
5218	4296	0	applied	\N	\N	\N	\N	16146	16146	16147
5218	4297	1	applied	\N	\N	\N	\N	16148	16148	16149
5222	4298	0	applied	\N	\N	\N	\N	16155	16155	16156
5225	4299	0	applied	\N	\N	\N	\N	16161	16161	16162
5247	4309	0	applied	\N	\N	\N	\N	16201	16201	16202
5261	4315	0	applied	\N	\N	\N	\N	16228	16228	16229
5264	4320	0	applied	\N	\N	\N	\N	16243	16243	16244
5264	4321	1	applied	\N	\N	\N	\N	16245	16245	1435
5266	4322	0	applied	\N	\N	\N	\N	16247	16247	16248
5269	4325	0	applied	\N	\N	\N	\N	16257	16257	16258
5269	4326	1	applied	\N	\N	\N	\N	16259	16259	16260
5271	4327	0	applied	\N	\N	\N	\N	16263	16263	16264
5278	4334	0	applied	\N	\N	\N	\N	16281	16281	16282
5278	4335	1	applied	\N	\N	\N	\N	16283	16283	16284
5286	4339	0	applied	\N	\N	\N	\N	16307	16307	16308
5289	4342	0	applied	\N	\N	\N	\N	16317	16317	16318
5291	4343	0	applied	\N	\N	\N	\N	16323	16323	16324
5296	4346	0	applied	\N	\N	\N	\N	16334	16334	16335
5301	4349	0	applied	\N	\N	\N	\N	16348	16348	16349
5303	4350	0	applied	\N	\N	\N	\N	16352	16352	16353
5306	4354	0	applied	\N	\N	\N	\N	16366	16366	16367
5306	4355	1	applied	\N	\N	1000000000	\N	16368	16368	16369
5311	4360	0	applied	\N	\N	\N	\N	16388	16388	16389
5313	4360	0	applied	\N	\N	\N	\N	16388	16388	16389
5322	4363	0	applied	\N	\N	\N	\N	16407	16407	16408
5335	4367	0	applied	\N	\N	\N	\N	16430	16430	16431
5337	4367	0	applied	\N	\N	\N	\N	16430	16430	16431
5344	4371	0	applied	\N	\N	\N	\N	16449	16449	16450
5344	4372	1	applied	\N	\N	\N	\N	16451	16451	16452
5344	4373	2	applied	\N	\N	\N	\N	16454	16454	16455
5346	4374	0	applied	\N	\N	\N	\N	16458	16458	16459
5361	4364	0	applied	\N	\N	\N	\N	16413	16413	16414
5361	4365	1	applied	\N	\N	\N	\N	16420	16420	16421
5361	4366	2	applied	\N	\N	\N	\N	16428	16428	16429
5361	4367	3	applied	\N	\N	\N	\N	16430	16430	16431
5361	4368	4	applied	\N	\N	\N	\N	16440	16440	16441
5361	4369	5	applied	\N	\N	\N	\N	16444	16444	16445
5361	4370	6	applied	\N	\N	\N	\N	16447	16447	16448
5361	4371	7	applied	\N	\N	\N	\N	16449	16449	16450
5361	4372	8	applied	\N	\N	\N	\N	16451	16451	16452
5361	4373	9	applied	\N	\N	\N	\N	16454	16454	16455
5361	4374	10	applied	\N	\N	\N	\N	16458	16458	16459
5361	4375	11	applied	\N	\N	\N	\N	16462	16462	16463
5361	4376	12	applied	\N	\N	\N	\N	16466	16466	16467
5361	4377	13	applied	\N	\N	\N	\N	16471	16471	16472
5361	4378	14	applied	\N	\N	\N	\N	16477	16477	16478
5361	4379	15	applied	\N	\N	\N	\N	16479	16479	16480
5361	4380	16	applied	\N	\N	\N	\N	16483	16483	16484
5361	4381	17	applied	\N	\N	\N	\N	16489	16489	16490
5361	4382	18	applied	\N	\N	\N	\N	16491	16491	16492
5361	4383	19	applied	\N	\N	\N	\N	16494	16494	16495
5361	4384	20	applied	\N	\N	\N	\N	16500	16500	16501
5361	4385	21	applied	\N	\N	\N	\N	16502	16502	16503
5364	4389	0	applied	\N	\N	\N	\N	16514	16514	16515
5364	4390	1	applied	\N	\N	\N	\N	16516	16516	16517
5367	4392	0	applied	\N	\N	\N	\N	16524	16524	16525
5367	4393	1	applied	\N	\N	\N	\N	16526	16526	16527
5439	4402	0	applied	\N	\N	\N	\N	16600	16600	16601
5450	4403	0	applied	\N	\N	1000000000	\N	16613	16613	16614
5054	4166	0	applied	\N	\N	\N	\N	15679	15679	15680
5056	4167	0	applied	\N	\N	\N	\N	15685	15685	15686
5064	4170	0	applied	\N	\N	\N	\N	15695	15695	15696
5072	4175	0	applied	\N	\N	\N	\N	15721	15721	15722
5079	4184	0	applied	\N	\N	\N	\N	15745	15745	15746
5079	4185	1	applied	\N	\N	\N	\N	15747	15747	12588
5083	4184	0	applied	\N	\N	\N	\N	15745	15745	15746
5085	4188	0	applied	\N	\N	\N	\N	15760	15760	15761
5085	4189	1	applied	\N	\N	\N	\N	15762	15762	15763
5099	4202	0	applied	\N	\N	\N	\N	15805	15805	15806
5101	4205	0	applied	\N	\N	\N	\N	15812	15812	15813
5105	4206	0	applied	\N	\N	\N	\N	15818	15818	15819
5106	4206	0	applied	\N	\N	\N	\N	15818	15818	15819
5107	4207	0	applied	\N	\N	\N	\N	15824	15824	15825
5111	4209	0	applied	\N	\N	\N	\N	15832	15832	15833
5113	4210	0	applied	\N	\N	\N	\N	15838	15838	15839
5114	4210	0	applied	\N	\N	\N	\N	15838	15838	15839
5119	4211	0	applied	\N	\N	\N	\N	15840	15840	15841
5119	4212	1	applied	\N	\N	\N	\N	15845	15845	15846
5124	4215	0	applied	\N	\N	\N	\N	15858	15858	15859
5124	4216	1	applied	\N	\N	\N	\N	15860	15860	15861
5124	4217	2	applied	\N	\N	\N	\N	15862	15862	15863
5125	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5125	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5133	4221	0	applied	\N	\N	\N	\N	15877	15877	15878
5133	4222	1	applied	\N	\N	\N	\N	15879	15879	15880
5133	4223	2	applied	\N	\N	\N	\N	15883	15883	15884
5133	4224	3	applied	\N	\N	\N	\N	15885	15885	15886
5134	4221	0	applied	\N	\N	\N	\N	15877	15877	15878
5134	4222	1	applied	\N	\N	\N	\N	15879	15879	15880
5134	4223	2	applied	\N	\N	\N	\N	15883	15883	15884
5134	4224	3	applied	\N	\N	\N	\N	15885	15885	15886
5137	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5137	4228	1	applied	\N	\N	\N	\N	15897	15897	15898
5141	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5141	4228	1	applied	\N	\N	\N	\N	15897	15897	15898
5142	4229	0	applied	\N	\N	\N	\N	15906	15906	15907
5142	4230	1	applied	\N	\N	\N	\N	15908	15908	15909
5143	4231	0	applied	\N	\N	\N	\N	15912	15912	15913
5143	4232	1	applied	\N	\N	\N	\N	15914	15914	15915
5153	4241	0	applied	\N	\N	\N	\N	15944	15944	15945
5159	4248	0	applied	\N	\N	\N	\N	15962	15962	15963
5164	4249	0	applied	\N	\N	\N	\N	15967	15967	15968
5166	4251	0	applied	\N	\N	\N	\N	15977	15977	15978
5166	4252	1	applied	\N	\N	\N	\N	15979	15979	15980
5179	4259	0	applied	\N	\N	\N	\N	16005	16005	16006
5179	4260	1	applied	\N	\N	\N	\N	16007	16007	16008
5179	4261	2	applied	\N	\N	\N	\N	16016	16016	16017
5179	4262	3	applied	\N	\N	\N	\N	16020	16020	16021
5179	4263	4	applied	\N	\N	\N	\N	16022	16022	16023
5181	4264	0	applied	\N	\N	\N	\N	16032	16032	16033
5184	4268	0	applied	\N	\N	\N	\N	16044	16044	16045
5190	4274	0	applied	\N	\N	\N	\N	16064	16064	16065
5190	4275	1	applied	\N	\N	\N	\N	16066	16066	16067
5200	4283	0	applied	\N	\N	\N	\N	16099	16099	16100
5200	4284	1	applied	\N	\N	\N	\N	16101	16101	16102
5202	4283	0	applied	\N	\N	\N	\N	16099	16099	16100
5202	4284	1	applied	\N	\N	\N	\N	16101	16101	16102
5205	4286	0	applied	\N	\N	\N	\N	16113	16113	16114
5216	4294	0	applied	\N	\N	\N	\N	16140	16140	16141
5220	4296	0	applied	\N	\N	\N	\N	16146	16146	16147
5220	4297	1	applied	\N	\N	\N	\N	16148	16148	16149
5226	4299	0	applied	\N	\N	\N	\N	16161	16161	16162
5228	4301	0	applied	\N	\N	\N	\N	16171	16171	16172
5237	4304	0	applied	\N	\N	\N	\N	16183	16183	16184
5237	4305	1	applied	\N	\N	\N	\N	16185	16185	16186
5237	4306	2	applied	\N	\N	\N	\N	16187	16187	16188
5239	4304	0	applied	\N	\N	\N	\N	16183	16183	16184
5239	4305	1	applied	\N	\N	\N	\N	16185	16185	16186
5239	4306	2	applied	\N	\N	\N	\N	16187	16187	16188
5246	4308	0	applied	\N	\N	\N	\N	16197	16197	16198
5248	4310	0	applied	\N	\N	\N	\N	16203	16203	16204
5253	4311	0	applied	\N	\N	\N	\N	16207	16207	16208
5253	4312	1	applied	\N	\N	\N	\N	16209	16209	16210
5262	4316	0	applied	\N	\N	\N	\N	16231	16231	16232
5262	4317	1	applied	\N	\N	\N	\N	16233	16233	16234
5265	4322	0	applied	\N	\N	\N	\N	16247	16247	16248
5268	4323	0	applied	\N	\N	\N	\N	16251	16251	1435
5268	4324	1	applied	\N	\N	\N	\N	16252	16252	16253
5273	4330	0	applied	\N	\N	\N	\N	16271	16271	16272
5273	4331	1	applied	\N	\N	\N	\N	16273	16273	16274
5276	4334	0	applied	\N	\N	\N	\N	16281	16281	16282
5276	4335	1	applied	\N	\N	\N	\N	16283	16283	16284
5279	4334	0	applied	\N	\N	\N	\N	16281	16281	16282
5279	4335	1	applied	\N	\N	\N	\N	16283	16283	16284
5281	4336	0	applied	\N	\N	\N	\N	16292	16292	16293
5285	4338	0	applied	\N	\N	\N	\N	16305	16305	16306
5288	4340	0	applied	\N	\N	\N	\N	16309	16309	16310
5288	4341	1	applied	\N	\N	\N	\N	16311	16311	16312
5290	4342	0	applied	\N	\N	\N	\N	16317	16317	16318
5300	4347	0	applied	\N	\N	\N	\N	16340	16340	16341
5300	4348	1	applied	\N	\N	\N	\N	16342	16342	16343
5302	4350	0	applied	\N	\N	\N	\N	16352	16352	16353
5304	4351	0	applied	\N	\N	\N	\N	16356	16356	16357
5307	4356	0	applied	\N	\N	\N	\N	16372	16372	16373
5310	4358	0	applied	\N	\N	\N	\N	16382	16382	16383
5310	4359	1	applied	\N	\N	\N	\N	16384	16384	16385
5315	4361	0	applied	\N	\N	\N	\N	16395	16395	16396
5324	4363	0	applied	\N	\N	\N	\N	16407	16407	16408
5325	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5325	4291	1	applied	\N	\N	1000000000	\N	16132	16132	16133
5325	4212	2	applied	\N	\N	\N	\N	15845	15845	15846
5325	4323	3	applied	\N	\N	\N	\N	16251	16251	1435
5325	4282	4	applied	\N	\N	\N	\N	16096	16096	13857
5325	4321	5	applied	\N	\N	\N	\N	16245	16245	1435
5325	4213	6	applied	\N	\N	\N	\N	15850	15850	15851
5325	4214	7	applied	\N	\N	\N	\N	15852	15852	15853
5325	4215	8	applied	\N	\N	\N	\N	15858	15858	15859
5325	4216	9	applied	\N	\N	\N	\N	15860	15860	15861
5325	4235	10	applied	\N	\N	\N	\N	15922	15922	7310
5325	4217	11	applied	\N	\N	\N	\N	15862	15862	15863
5325	4218	12	applied	\N	\N	\N	\N	15866	15866	15867
5325	4219	13	applied	\N	\N	\N	\N	15868	15868	15869
5325	4220	14	applied	\N	\N	\N	\N	15875	15875	15876
5325	4221	15	applied	\N	\N	\N	\N	15877	15877	15878
5325	4222	16	applied	\N	\N	\N	\N	15879	15879	15880
5325	4223	17	applied	\N	\N	\N	\N	15883	15883	15884
5325	4224	18	applied	\N	\N	\N	\N	15885	15885	15886
5325	4225	19	applied	\N	\N	\N	\N	15890	15890	15891
5055	4165	0	applied	\N	\N	\N	\N	15677	15677	15678
5058	4168	0	applied	\N	\N	\N	\N	15687	15687	15688
5065	4170	0	applied	\N	\N	\N	\N	15695	15695	15696
5068	4173	0	applied	\N	\N	\N	\N	15710	15710	15711
5073	4175	0	applied	\N	\N	\N	\N	15721	15721	15722
5075	4177	0	applied	\N	\N	\N	\N	15727	15727	15728
5075	4178	1	applied	\N	\N	\N	\N	15729	15729	15730
5075	4179	2	applied	\N	\N	\N	\N	15731	15731	15732
5075	4180	3	applied	\N	\N	\N	\N	15733	15733	15734
5077	4183	0	applied	\N	\N	\N	\N	15742	15742	15743
5080	4184	0	applied	\N	\N	\N	\N	15745	15745	15746
5080	4185	1	applied	\N	\N	\N	\N	15747	15747	12588
5086	4188	0	applied	\N	\N	\N	\N	15760	15760	15761
5086	4189	1	applied	\N	\N	\N	\N	15762	15762	15763
5088	4190	0	applied	\N	\N	\N	\N	15768	15768	15769
5089	4191	0	applied	\N	\N	\N	\N	15771	15771	15772
5089	4192	1	applied	\N	\N	\N	\N	15773	15773	15774
5094	4195	0	applied	\N	\N	\N	\N	15786	15786	15787
5094	4196	1	applied	\N	\N	\N	\N	15788	15788	15789
5102	4205	0	applied	\N	\N	\N	\N	15812	15812	15813
5110	4209	0	applied	\N	\N	\N	\N	15832	15832	15833
5116	4211	0	applied	\N	\N	\N	\N	15840	15840	15841
5122	4213	0	applied	\N	\N	\N	\N	15850	15850	15851
5122	4214	1	applied	\N	\N	\N	\N	15852	15852	15853
5128	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5128	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5129	4218	0	applied	\N	\N	\N	\N	15866	15866	15867
5129	4219	1	applied	\N	\N	\N	\N	15868	15868	15869
5136	4225	0	applied	\N	\N	\N	\N	15890	15890	15891
5140	4227	0	applied	\N	\N	1000000000	\N	15895	15895	15896
5140	4228	1	applied	\N	\N	\N	\N	15897	15897	15898
5150	4238	0	applied	\N	\N	\N	\N	15933	15933	15934
5150	4239	1	applied	\N	\N	\N	\N	15935	15935	15936
5152	4240	0	applied	\N	\N	\N	\N	15940	15940	15941
5156	4244	0	applied	\N	\N	\N	\N	15952	15952	15953
5160	4248	0	applied	\N	\N	\N	\N	15962	15962	15963
5161	4248	0	applied	\N	\N	\N	\N	15962	15962	15963
5163	4249	0	applied	\N	\N	\N	\N	15967	15967	15968
5167	4253	0	applied	\N	\N	\N	\N	15983	15983	15984
5170	4255	0	applied	\N	\N	\N	\N	15991	15991	15992
5170	4256	1	applied	\N	\N	\N	\N	15993	15993	15994
5170	4257	2	applied	\N	\N	\N	\N	15995	15995	15996
5171	4258	0	applied	\N	\N	\N	\N	15999	15999	16000
5176	4259	0	applied	\N	\N	\N	\N	16005	16005	16006
5176	4260	1	applied	\N	\N	\N	\N	16007	16007	16008
5178	4259	0	applied	\N	\N	\N	\N	16005	16005	16006
5178	4260	1	applied	\N	\N	\N	\N	16007	16007	16008
5178	4261	2	applied	\N	\N	\N	\N	16016	16016	16017
5186	4270	0	applied	\N	\N	\N	\N	16052	16052	16053
5189	4273	0	applied	\N	\N	\N	\N	16061	16061	16062
5192	4276	0	applied	\N	\N	\N	\N	16070	16070	16071
5194	4278	0	applied	\N	\N	\N	\N	16080	16080	16081
5197	4279	0	applied	\N	\N	\N	\N	16084	16084	16085
5199	4281	0	applied	\N	\N	\N	\N	16094	16094	16095
5199	4282	1	applied	\N	\N	\N	\N	16096	16096	13857
5204	4286	0	applied	\N	\N	\N	\N	16113	16113	16114
5209	4289	0	applied	\N	\N	\N	\N	16125	16125	16126
5209	4290	1	applied	\N	\N	\N	\N	16127	16127	16128
5219	4296	0	applied	\N	\N	\N	\N	16146	16146	16147
5219	4297	1	applied	\N	\N	\N	\N	16148	16148	16149
5221	4296	0	applied	\N	\N	\N	\N	16146	16146	16147
5221	4297	1	applied	\N	\N	\N	\N	16148	16148	16149
5223	4298	0	applied	\N	\N	\N	\N	16155	16155	16156
5227	4300	0	applied	\N	\N	\N	\N	16167	16167	16168
5230	4302	0	applied	\N	\N	\N	\N	16175	16175	16176
5230	4303	1	applied	\N	\N	\N	\N	16177	16177	16178
5241	4304	0	applied	\N	\N	\N	\N	16183	16183	16184
5241	4305	1	applied	\N	\N	\N	\N	16185	16185	16186
5241	4306	2	applied	\N	\N	\N	\N	16187	16187	16188
5245	4308	0	applied	\N	\N	\N	\N	16197	16197	16198
5252	4311	0	applied	\N	\N	\N	\N	16207	16207	16208
5252	4312	1	applied	\N	\N	\N	\N	16209	16209	16210
5267	4323	0	applied	\N	\N	\N	\N	16251	16251	1435
5267	4324	1	applied	\N	\N	\N	\N	16252	16252	16253
5270	4325	0	applied	\N	\N	\N	\N	16257	16257	16258
5270	4326	1	applied	\N	\N	\N	\N	16259	16259	16260
5272	4328	0	applied	\N	\N	\N	\N	16265	16265	16266
5272	4329	1	applied	\N	\N	\N	\N	16267	16267	16268
5275	4333	0	applied	\N	\N	\N	\N	16279	16279	16280
5280	4336	0	applied	\N	\N	\N	\N	16292	16292	16293
5284	4337	0	applied	\N	\N	\N	\N	16301	16301	16302
5287	4340	0	applied	\N	\N	\N	\N	16309	16309	16310
5287	4341	1	applied	\N	\N	\N	\N	16311	16311	16312
5292	4343	0	applied	\N	\N	\N	\N	16323	16323	16324
5294	4344	0	applied	\N	\N	\N	\N	16328	16328	16329
5297	4346	0	applied	\N	\N	\N	\N	16334	16334	16335
5299	4347	0	applied	\N	\N	\N	\N	16340	16340	16341
5299	4348	1	applied	\N	\N	\N	\N	16342	16342	16343
5309	4357	0	applied	\N	\N	\N	\N	16378	16378	16379
5312	4360	0	applied	\N	\N	\N	\N	16388	16388	16389
5314	4361	0	applied	\N	\N	\N	\N	16395	16395	16396
5316	4361	0	applied	\N	\N	\N	\N	16395	16395	16396
5318	4362	0	applied	\N	\N	\N	\N	16401	16401	16402
5321	4362	0	applied	\N	\N	\N	\N	16401	16401	16402
5323	4363	0	applied	\N	\N	\N	\N	16407	16407	16408
5326	4364	0	applied	\N	\N	\N	\N	16413	16413	16414
5328	4364	0	applied	\N	\N	\N	\N	16413	16413	16414
5331	4365	0	applied	\N	\N	\N	\N	16420	16420	16421
5339	4368	0	applied	\N	\N	\N	\N	16440	16440	16441
5347	4375	0	applied	\N	\N	\N	\N	16462	16462	16463
5354	4380	0	applied	\N	\N	\N	\N	16483	16483	16484
5356	4380	0	applied	\N	\N	\N	\N	16483	16483	16484
5359	4383	0	applied	\N	\N	\N	\N	16494	16494	16495
5362	4386	0	applied	\N	\N	\N	\N	16507	16507	16508
5362	4387	1	applied	\N	\N	\N	\N	16509	16509	16510
5365	4391	0	applied	\N	\N	\N	\N	16520	16520	16521
5379	4397	0	applied	\N	\N	\N	\N	16542	16542	16543
5410	4399	0	applied	\N	\N	\N	\N	16570	16570	16571
5415	4400	0	applied	\N	\N	\N	\N	16577	16577	16578
5418	4400	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	16583	16583	\N
5418	4398	1	applied	\N	\N	1000000000	\N	16564	16564	16565
5422	4401	0	applied	\N	\N	\N	\N	16586	16586	16587
5432	4400	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	16583	16583	\N
5432	4401	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	16593	16593	\N
5432	4398	2	applied	\N	\N	1000000000	\N	16564	16564	16565
5440	4402	0	applied	\N	\N	\N	\N	16600	16600	16601
5442	4402	0	applied	\N	\N	\N	\N	16600	16600	16601
5453	4295	0	applied	\N	\N	\N	\N	16142	16142	16143
5325	4226	20	applied	\N	\N	\N	\N	15892	15892	15893
5325	4228	21	applied	\N	\N	\N	\N	15897	15897	15898
5325	4229	22	applied	\N	\N	\N	\N	15906	15906	15907
5325	4230	23	applied	\N	\N	\N	\N	15908	15908	15909
5325	4231	24	applied	\N	\N	\N	\N	15912	15912	15913
5325	4232	25	applied	\N	\N	\N	\N	15914	15914	15915
5325	4233	26	applied	\N	\N	\N	\N	15918	15918	15919
5325	4234	27	applied	\N	\N	\N	\N	15920	15920	15921
5325	4236	28	applied	\N	\N	\N	\N	15925	15925	15926
5325	4237	29	applied	\N	\N	\N	\N	15927	15927	15928
5325	4238	30	applied	\N	\N	\N	\N	15933	15933	15934
5325	4239	31	applied	\N	\N	\N	\N	15935	15935	15936
5325	4240	32	applied	\N	\N	\N	\N	15940	15940	15941
5325	4241	33	applied	\N	\N	\N	\N	15944	15944	15945
5325	4242	34	applied	\N	\N	\N	\N	15947	15947	15948
5325	4243	35	applied	\N	\N	\N	\N	15949	15949	15950
5325	4244	36	applied	\N	\N	\N	\N	15952	15952	15953
5325	4245	37	applied	\N	\N	\N	\N	15954	15954	15955
5325	4246	38	applied	\N	\N	\N	\N	15956	15956	15957
5325	4247	39	applied	\N	\N	\N	\N	15958	15958	15959
5325	4248	40	applied	\N	\N	\N	\N	15962	15962	15963
5325	4249	41	applied	\N	\N	\N	\N	15967	15967	15968
5325	4250	42	applied	\N	\N	\N	\N	15973	15973	15974
5325	4251	43	applied	\N	\N	\N	\N	15977	15977	15978
5325	4252	44	applied	\N	\N	\N	\N	15979	15979	15980
5325	4253	45	applied	\N	\N	\N	\N	15983	15983	15984
5325	4254	46	applied	\N	\N	\N	\N	15985	15985	15986
5325	4255	47	applied	\N	\N	\N	\N	15991	15991	15992
5325	4256	48	applied	\N	\N	\N	\N	15993	15993	15994
5325	4257	49	applied	\N	\N	\N	\N	15995	15995	15996
5325	4258	50	applied	\N	\N	\N	\N	15999	15999	16000
5325	4259	51	applied	\N	\N	\N	\N	16005	16005	16006
5325	4260	52	applied	\N	\N	\N	\N	16007	16007	16008
5325	4261	53	applied	\N	\N	\N	\N	16016	16016	16017
5325	4262	54	applied	\N	\N	\N	\N	16020	16020	16021
5325	4263	55	applied	\N	\N	\N	\N	16022	16022	16023
5325	4264	56	applied	\N	\N	\N	\N	16032	16032	16033
5325	4265	57	applied	\N	\N	\N	\N	16034	16034	16035
5325	4266	58	applied	\N	\N	\N	\N	16038	16038	16039
5325	4267	59	applied	\N	\N	\N	\N	16040	16040	16041
5325	4268	60	applied	\N	\N	\N	\N	16044	16044	16045
5325	4269	61	applied	\N	\N	\N	\N	16048	16048	16049
5325	4270	62	applied	\N	\N	\N	\N	16052	16052	16053
5325	4271	63	applied	\N	\N	\N	\N	16056	16056	16057
5325	4272	64	applied	\N	\N	\N	\N	16058	16058	16059
5325	4273	65	applied	\N	\N	\N	\N	16061	16061	16062
5325	4274	66	applied	\N	\N	\N	\N	16064	16064	16065
5325	4275	67	applied	\N	\N	\N	\N	16066	16066	16067
5325	4276	68	applied	\N	\N	\N	\N	16070	16070	16071
5325	4277	69	applied	\N	\N	\N	\N	16076	16076	16077
5325	4278	70	applied	\N	\N	\N	\N	16080	16080	16081
5325	4279	71	applied	\N	\N	\N	\N	16084	16084	16085
5325	4280	72	applied	\N	\N	\N	\N	16090	16090	16091
5325	4281	73	applied	\N	\N	\N	\N	16094	16094	16095
5325	4283	74	applied	\N	\N	\N	\N	16099	16099	16100
5325	4284	75	applied	\N	\N	\N	\N	16101	16101	16102
5325	4285	76	applied	\N	\N	\N	\N	16109	16109	16110
5325	4286	77	applied	\N	\N	\N	\N	16113	16113	16114
5325	4287	78	applied	\N	\N	\N	\N	16117	16117	16118
5325	4288	79	applied	\N	\N	\N	\N	16121	16121	16122
5325	4289	80	applied	\N	\N	\N	\N	16125	16125	16126
5325	4290	81	applied	\N	\N	\N	\N	16127	16127	16128
5325	4292	82	applied	\N	\N	\N	\N	16134	16134	16135
5325	4293	83	applied	\N	\N	\N	\N	16136	16136	16137
5325	4294	84	applied	\N	\N	\N	\N	16140	16140	16141
5325	4295	85	applied	\N	\N	\N	\N	16142	16142	16143
5325	4296	86	applied	\N	\N	\N	\N	16146	16146	16147
5325	4297	87	applied	\N	\N	\N	\N	16148	16148	16149
5325	4298	88	applied	\N	\N	\N	\N	16155	16155	16156
5325	4299	89	applied	\N	\N	\N	\N	16161	16161	16162
5325	4300	90	applied	\N	\N	\N	\N	16167	16167	16168
5325	4301	91	applied	\N	\N	\N	\N	16171	16171	16172
5325	4302	92	applied	\N	\N	\N	\N	16175	16175	16176
5325	4303	93	applied	\N	\N	\N	\N	16177	16177	16178
5325	4304	94	applied	\N	\N	\N	\N	16183	16183	16184
5325	4305	95	applied	\N	\N	\N	\N	16185	16185	16186
5325	4306	96	applied	\N	\N	\N	\N	16187	16187	16188
5325	4307	97	applied	\N	\N	\N	\N	16193	16193	16194
5325	4308	98	applied	\N	\N	\N	\N	16197	16197	16198
5325	4309	99	applied	\N	\N	\N	\N	16201	16201	16202
5325	4310	100	applied	\N	\N	\N	\N	16203	16203	16204
5325	4311	101	applied	\N	\N	\N	\N	16207	16207	16208
5325	4312	102	applied	\N	\N	\N	\N	16209	16209	16210
5325	4313	103	applied	\N	\N	\N	\N	16220	16220	16221
5325	4314	104	applied	\N	\N	\N	\N	16222	16222	16223
5327	4364	0	applied	\N	\N	\N	\N	16413	16413	16414
5329	4365	0	applied	\N	\N	\N	\N	16420	16420	16421
5333	4366	0	applied	\N	\N	\N	\N	16428	16428	16429
5338	4367	0	applied	\N	\N	\N	\N	16430	16430	16431
5340	4368	0	applied	\N	\N	\N	\N	16440	16440	16441
5342	4370	0	applied	\N	\N	\N	\N	16447	16447	16448
5345	4374	0	applied	\N	\N	\N	\N	16458	16458	16459
5350	4377	0	applied	\N	\N	\N	\N	16471	16471	16472
5352	4378	0	applied	\N	\N	\N	\N	16477	16477	16478
5355	4380	0	applied	\N	\N	\N	\N	16483	16483	16484
5357	4381	0	applied	\N	\N	\N	\N	16489	16489	16490
5357	4382	1	applied	\N	\N	\N	\N	16491	16491	16492
5360	4384	0	applied	\N	\N	\N	\N	16500	16500	16501
5360	4385	1	applied	\N	\N	\N	\N	16502	16502	16503
5368	4394	0	applied	\N	\N	\N	\N	16529	16529	16530
5369	4395	0	applied	\N	\N	\N	\N	16531	16531	16532
5369	4396	1	applied	\N	\N	\N	\N	16533	16533	16534
5414	4386	0	applied	\N	\N	\N	\N	16507	16507	16508
5414	4387	1	applied	\N	\N	\N	\N	16509	16509	16510
5414	4388	2	applied	\N	\N	\N	\N	16512	16512	16513
5414	4389	3	applied	\N	\N	\N	\N	16514	16514	16515
5414	4390	4	applied	\N	\N	\N	\N	16516	16516	16517
5414	4391	5	applied	\N	\N	\N	\N	16520	16520	16521
5414	4392	6	applied	\N	\N	\N	\N	16524	16524	16525
5414	4393	7	applied	\N	\N	\N	\N	16526	16526	16527
5414	4394	8	applied	\N	\N	\N	\N	16529	16529	16530
5414	4395	9	applied	\N	\N	\N	\N	16531	16531	16532
5414	4396	10	applied	\N	\N	\N	\N	16533	16533	16534
5414	4397	11	applied	\N	\N	\N	\N	16542	16542	16543
5414	4398	12	applied	\N	\N	1000000000	\N	16564	16564	16565
5441	4402	0	applied	\N	\N	\N	\N	16600	16600	16601
5512	4413	0	applied	\N	\N	\N	\N	16675	16675	16676
5570	4414	0	applied	\N	\N	\N	\N	16694	16694	1435
5631	4415	0	applied	\N	\N	\N	\N	16745	16745	16746
5766	4450	1	applied	\N	\N	\N	\N	16920	16920	16921
5453	4296	1	applied	\N	\N	\N	\N	16146	16146	16147
5453	4297	2	applied	\N	\N	\N	\N	16148	16148	16149
5453	4298	3	applied	\N	\N	\N	\N	16155	16155	16156
5453	4299	4	applied	\N	\N	\N	\N	16161	16161	16162
5453	4300	5	applied	\N	\N	\N	\N	16167	16167	16168
5453	4301	6	applied	\N	\N	\N	\N	16171	16171	16172
5453	4302	7	applied	\N	\N	\N	\N	16175	16175	16176
5453	4303	8	applied	\N	\N	\N	\N	16177	16177	16178
5453	4304	9	applied	\N	\N	\N	\N	16183	16183	16184
5453	4305	10	applied	\N	\N	\N	\N	16185	16185	16186
5453	4306	11	applied	\N	\N	\N	\N	16187	16187	16188
5453	4307	12	applied	\N	\N	\N	\N	16193	16193	16194
5453	4308	13	applied	\N	\N	\N	\N	16197	16197	16198
5453	4309	14	applied	\N	\N	\N	\N	16201	16201	16202
5453	4310	15	applied	\N	\N	\N	\N	16203	16203	16204
5453	4311	16	applied	\N	\N	\N	\N	16207	16207	16208
5453	4312	17	applied	\N	\N	\N	\N	16209	16209	16210
5453	4313	18	applied	\N	\N	\N	\N	16220	16220	16221
5453	4314	19	applied	\N	\N	\N	\N	16222	16222	16223
5453	4315	20	applied	\N	\N	\N	\N	16228	16228	16229
5453	4316	21	applied	\N	\N	\N	\N	16231	16231	16232
5453	4317	22	applied	\N	\N	\N	\N	16233	16233	16234
5453	4318	23	applied	\N	\N	\N	\N	16237	16237	16238
5453	4319	24	applied	\N	\N	\N	\N	16239	16239	16240
5453	4320	25	applied	\N	\N	\N	\N	16243	16243	16244
5453	4322	26	applied	\N	\N	\N	\N	16247	16247	16248
5453	4324	27	applied	\N	\N	\N	\N	16252	16252	16253
5453	4325	28	applied	\N	\N	\N	\N	16257	16257	16258
5453	4326	29	applied	\N	\N	\N	\N	16259	16259	16260
5453	4327	30	applied	\N	\N	\N	\N	16263	16263	16264
5453	4328	31	applied	\N	\N	\N	\N	16265	16265	16266
5453	4329	32	applied	\N	\N	\N	\N	16267	16267	16268
5453	4330	33	applied	\N	\N	\N	\N	16271	16271	16272
5453	4331	34	applied	\N	\N	\N	\N	16273	16273	16274
5453	4332	35	applied	\N	\N	\N	\N	16277	16277	16278
5453	4333	36	applied	\N	\N	\N	\N	16279	16279	16280
5453	4334	37	applied	\N	\N	\N	\N	16281	16281	16282
5453	4335	38	applied	\N	\N	\N	\N	16283	16283	16284
5458	4404	0	applied	\N	\N	1000000000	\N	16620	16620	16621
5458	4405	1	applied	\N	\N	1000000000	\N	16622	16622	16623
5458	4406	2	applied	\N	\N	1000000000	\N	16624	16624	16625
5458	4407	3	applied	\N	\N	1000000000	\N	16626	16626	16627
5458	4408	4	applied	\N	\N	1000000000	\N	16628	16628	16629
5458	4409	5	applied	\N	\N	1000000000	\N	16630	16630	16631
5458	4410	6	applied	\N	\N	1000000000	\N	16632	16632	16633
5504	4412	0	applied	\N	\N	\N	\N	16666	16666	16667
5514	4291	0	applied	\N	\N	1000000000	\N	16132	16132	16133
5514	4404	1	applied	\N	\N	1000000000	\N	16620	16620	16621
5514	4405	2	applied	\N	\N	1000000000	\N	16622	16622	16623
5514	4406	3	applied	\N	\N	1000000000	\N	16624	16624	16625
5514	4407	4	applied	\N	\N	1000000000	\N	16626	16626	16627
5514	4408	5	applied	\N	\N	1000000000	\N	16628	16628	16629
5514	4409	6	applied	\N	\N	1000000000	\N	16630	16630	16631
5514	4410	7	applied	\N	\N	1000000000	\N	16632	16632	16633
5514	4412	8	applied	\N	\N	\N	\N	16666	16666	16667
5514	4323	9	applied	\N	\N	\N	\N	16251	16251	1435
5514	4321	10	applied	\N	\N	\N	\N	16245	16245	1435
5514	4287	11	applied	\N	\N	\N	\N	16117	16117	16118
5514	4288	12	applied	\N	\N	\N	\N	16121	16121	16122
5514	4413	13	applied	\N	\N	\N	\N	16675	16675	16676
5514	4289	14	applied	\N	\N	\N	\N	16125	16125	16126
5514	4290	15	applied	\N	\N	\N	\N	16127	16127	16128
5514	4292	16	applied	\N	\N	\N	\N	16134	16134	16135
5514	4293	17	applied	\N	\N	\N	\N	16136	16136	16137
5514	4294	18	applied	\N	\N	\N	\N	16140	16140	16141
5514	4295	19	applied	\N	\N	\N	\N	16142	16142	16143
5514	4296	20	applied	\N	\N	\N	\N	16146	16146	16147
5514	4297	21	applied	\N	\N	\N	\N	16148	16148	16149
5514	4298	22	applied	\N	\N	\N	\N	16155	16155	16156
5514	4299	23	applied	\N	\N	\N	\N	16161	16161	16162
5514	4300	24	applied	\N	\N	\N	\N	16167	16167	16168
5514	4301	25	applied	\N	\N	\N	\N	16171	16171	16172
5514	4302	26	applied	\N	\N	\N	\N	16175	16175	16176
5514	4303	27	applied	\N	\N	\N	\N	16177	16177	16178
5514	4304	28	applied	\N	\N	\N	\N	16183	16183	16184
5514	4305	29	applied	\N	\N	\N	\N	16185	16185	16186
5514	4306	30	applied	\N	\N	\N	\N	16187	16187	16188
5514	4307	31	applied	\N	\N	\N	\N	16193	16193	16194
5514	4308	32	applied	\N	\N	\N	\N	16197	16197	16198
5514	4309	33	applied	\N	\N	\N	\N	16201	16201	16202
5514	4310	34	applied	\N	\N	\N	\N	16203	16203	16204
5514	4311	35	applied	\N	\N	\N	\N	16207	16207	16208
5514	4312	36	applied	\N	\N	\N	\N	16209	16209	16210
5514	4313	37	applied	\N	\N	\N	\N	16220	16220	16221
5514	4314	38	applied	\N	\N	\N	\N	16222	16222	16223
5514	4315	39	applied	\N	\N	\N	\N	16228	16228	16229
5514	4316	40	applied	\N	\N	\N	\N	16231	16231	16232
5514	4317	41	applied	\N	\N	\N	\N	16233	16233	16234
5514	4318	42	applied	\N	\N	\N	\N	16237	16237	16238
5514	4319	43	applied	\N	\N	\N	\N	16239	16239	16240
5514	4320	44	applied	\N	\N	\N	\N	16243	16243	16244
5514	4322	45	applied	\N	\N	\N	\N	16247	16247	16248
5514	4324	46	applied	\N	\N	\N	\N	16252	16252	16253
5514	4325	47	applied	\N	\N	\N	\N	16257	16257	16258
5514	4326	48	applied	\N	\N	\N	\N	16259	16259	16260
5514	4327	49	applied	\N	\N	\N	\N	16263	16263	16264
5514	4328	50	applied	\N	\N	\N	\N	16265	16265	16266
5514	4329	51	applied	\N	\N	\N	\N	16267	16267	16268
5514	4330	52	applied	\N	\N	\N	\N	16271	16271	16272
5514	4331	53	applied	\N	\N	\N	\N	16273	16273	16274
5514	4332	54	applied	\N	\N	\N	\N	16277	16277	16278
5514	4333	55	applied	\N	\N	\N	\N	16279	16279	16280
5514	4334	56	applied	\N	\N	\N	\N	16281	16281	16282
5540	4414	0	applied	\N	\N	\N	\N	16694	16694	1435
5560	4414	0	applied	\N	\N	\N	\N	16694	16694	1435
5679	4416	0	applied	\N	\N	1000000000	\N	16776	16776	16777
5683	4417	0	applied	\N	\N	\N	\N	16779	16779	16780
5700	4418	0	applied	\N	\N	\N	\N	14435	14435	745
5726	4422	0	applied	\N	\N	\N	\N	16821	16821	1435
5739	4423	0	applied	\N	\N	\N	\N	16833	16833	16834
5742	4424	0	applied	\N	\N	\N	\N	16839	16839	16840
5744	4425	0	applied	\N	\N	\N	\N	16841	16841	16842
5744	4426	1	applied	\N	\N	\N	\N	16843	16843	16844
5759	4438	0	applied	\N	\N	\N	\N	16888	16888	16889
5759	4439	1	applied	\N	\N	\N	\N	16890	16890	16891
5762	4441	0	applied	\N	\N	\N	\N	16897	16897	16898
5762	4442	1	applied	\N	\N	\N	\N	16899	16899	16900
5766	4449	0	applied	\N	\N	\N	\N	16918	16918	16919
5457	4404	0	applied	\N	\N	1000000000	\N	16620	16620	16621
5457	4405	1	applied	\N	\N	1000000000	\N	16622	16622	16623
5457	4406	2	applied	\N	\N	1000000000	\N	16624	16624	16625
5457	4407	3	applied	\N	\N	1000000000	\N	16626	16626	16627
5457	4408	4	applied	\N	\N	1000000000	\N	16628	16628	16629
5457	4409	5	applied	\N	\N	1000000000	\N	16630	16630	16631
5457	4410	6	applied	\N	\N	1000000000	\N	16632	16632	16633
5513	4413	0	applied	\N	\N	\N	\N	16675	16675	16676
5681	4417	0	applied	\N	\N	\N	\N	16779	16779	16780
5718	4420	0	applied	\N	\N	\N	\N	16809	16809	1435
5718	4421	1	applied	\N	\N	\N	\N	16810	16810	1435
5727	4422	0	applied	\N	\N	\N	\N	16821	16821	1435
5745	4427	0	applied	\N	\N	\N	\N	16846	16846	16847
5748	4430	0	applied	\N	\N	\N	\N	16858	16858	16859
5750	4431	0	applied	\N	\N	\N	\N	16861	16861	16862
5753	4433	0	applied	\N	\N	\N	\N	16871	16871	16872
5753	4434	1	applied	\N	\N	\N	\N	16873	16873	16874
5753	4435	2	applied	\N	\N	\N	\N	16875	16875	16876
5758	4437	0	applied	\N	\N	\N	\N	16883	16883	16884
5764	4443	0	applied	\N	\N	\N	\N	16901	16901	16902
5764	4444	1	applied	\N	\N	\N	\N	16903	16903	16904
5764	4445	2	applied	\N	\N	\N	\N	16905	16905	16906
5774	4453	0	applied	\N	\N	\N	\N	16935	16935	16936
5774	4454	1	applied	\N	\N	\N	\N	16937	16937	16938
5778	4461	0	applied	\N	\N	\N	\N	16958	16958	16959
5778	4462	1	applied	\N	\N	\N	\N	16960	16960	16961
5781	4466	0	applied	\N	\N	\N	\N	16972	16972	16973
5784	4469	0	applied	\N	\N	\N	\N	16982	16982	16983
5784	4470	1	applied	\N	\N	\N	\N	16984	16984	16985
5787	4471	0	applied	\N	\N	1000000000	\N	16988	16988	16989
5787	4472	1	applied	\N	\N	1000000000	\N	16990	16990	16991
5787	4473	2	applied	\N	\N	\N	\N	16992	16992	16993
5789	4471	0	applied	\N	\N	1000000000	\N	16988	16988	16989
5789	4472	1	applied	\N	\N	1000000000	\N	16990	16990	16991
5789	4473	2	applied	\N	\N	\N	\N	16992	16992	16993
5791	4474	0	applied	\N	\N	\N	\N	17001	17001	17002
5799	4479	0	applied	\N	\N	\N	\N	17021	17021	17022
5799	4480	1	applied	\N	\N	\N	\N	17023	17023	17024
5801	4483	0	applied	\N	\N	\N	\N	17032	17032	17033
5809	4488	0	applied	\N	\N	\N	\N	17049	17049	17050
5811	4489	0	applied	\N	\N	\N	\N	17055	17055	17056
5811	4490	1	applied	\N	\N	\N	\N	17057	17057	17058
5813	4491	0	applied	\N	\N	\N	\N	17062	17062	17063
5817	4495	0	applied	\N	\N	\N	\N	17074	17074	17075
5817	4496	1	applied	\N	\N	\N	\N	17076	17076	17077
5822	4498	0	applied	\N	\N	\N	\N	17085	17085	17086
5823	4499	0	applied	\N	\N	\N	\N	17091	17091	17092
5828	4500	0	applied	\N	\N	\N	\N	17097	17097	17098
5830	4503	0	applied	\N	\N	\N	\N	17104	17104	17105
5839	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
5839	4508	2	applied	\N	\N	1000000000	\N	17122	17122	17123
5839	4509	3	applied	\N	\N	\N	\N	17124	17124	17125
5839	4510	4	applied	\N	\N	\N	\N	17126	17126	17127
5840	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
5840	4508	2	applied	\N	\N	1000000000	\N	17122	17122	17123
5840	4509	3	applied	\N	\N	\N	\N	17124	17124	17125
5840	4510	4	applied	\N	\N	\N	\N	17126	17126	17127
5843	4512	0	applied	\N	\N	\N	\N	17148	17148	17149
5843	4513	1	applied	\N	\N	\N	\N	17150	17150	17151
5843	4514	2	applied	\N	\N	\N	\N	17152	17152	17153
5845	4515	0	applied	\N	\N	\N	\N	17156	17156	17157
5848	4516	0	applied	\N	\N	\N	\N	17159	17159	17160
5849	4517	0	applied	\N	\N	\N	\N	17165	17165	17166
5855	4522	0	applied	\N	\N	\N	\N	17182	17182	17183
5857	4523	0	applied	\N	\N	\N	\N	17186	17186	17187
5857	4524	1	applied	\N	\N	\N	\N	17188	17188	17189
5864	4525	0	applied	\N	\N	\N	\N	17192	17192	17193
5864	4526	1	applied	\N	\N	\N	\N	17194	17194	17195
5867	4525	0	applied	\N	\N	\N	\N	17192	17192	17193
5867	4526	1	applied	\N	\N	\N	\N	17194	17194	17195
5868	4527	0	applied	\N	\N	\N	\N	17206	17206	17207
5868	4528	1	applied	\N	\N	\N	\N	17208	17208	17209
5868	4529	2	applied	\N	\N	\N	\N	17210	17210	17211
5871	4532	0	applied	\N	\N	\N	\N	17222	17222	17223
5877	4538	0	applied	\N	\N	\N	\N	17240	17240	17241
5879	4539	0	applied	\N	\N	\N	\N	17246	17246	17247
5879	4540	1	applied	\N	\N	\N	\N	17248	17248	17249
5881	4541	0	applied	\N	\N	\N	\N	17252	17252	17253
5884	4542	0	applied	\N	\N	1000000000	\N	17255	17255	17256
5884	4543	1	applied	\N	\N	1000000000	\N	17257	17257	17258
5884	4544	2	applied	\N	\N	1000000000	\N	17259	17259	17260
5893	4545	0	applied	\N	\N	\N	\N	17263	17263	17264
5893	4546	1	applied	\N	\N	\N	\N	17265	17265	17266
5893	4547	2	applied	\N	\N	\N	\N	17267	17267	17268
5893	4548	3	applied	\N	\N	\N	\N	17269	17269	17270
5893	4549	4	applied	\N	\N	\N	\N	17271	17271	17272
5894	4550	0	applied	\N	\N	\N	\N	17278	17278	17279
5898	4557	0	applied	\N	\N	\N	\N	17300	17300	17301
5903	4559	0	applied	\N	\N	\N	\N	17310	17310	17311
5905	4560	0	applied	\N	\N	\N	\N	17314	17314	17315
5917	4567	0	applied	\N	\N	\N	\N	17342	17342	17343
5917	4568	1	applied	\N	\N	\N	\N	17344	17344	17345
5917	4569	2	applied	\N	\N	\N	\N	17346	17346	17347
5921	4570	0	applied	\N	\N	\N	\N	17355	17355	17356
5925	4572	0	applied	\N	\N	\N	\N	17365	17365	17366
5926	4572	0	applied	\N	\N	\N	\N	17365	17365	17366
5929	4573	0	applied	\N	\N	\N	\N	17372	17372	17373
5929	4574	1	applied	\N	\N	\N	\N	17374	17374	17375
5932	4577	0	applied	\N	\N	\N	\N	17386	17386	17387
5934	4578	0	applied	\N	\N	\N	\N	17413	17413	17414
5936	4578	0	applied	\N	\N	\N	\N	17413	17413	17414
5939	4581	0	applied	\N	\N	\N	\N	17427	17427	17428
5942	4582	0	applied	\N	\N	\N	\N	17430	17430	17431
5942	4583	1	applied	\N	\N	\N	\N	17432	17432	17433
5942	4584	2	applied	\N	\N	\N	\N	17434	17434	17435
5944	4586	0	applied	\N	\N	\N	\N	17444	17444	17445
5947	4589	0	applied	\N	\N	\N	\N	17453	17453	17454
5947	4590	1	applied	\N	\N	\N	\N	17455	17455	17456
5957	4597	0	applied	\N	\N	\N	\N	17483	17483	17484
5960	4605	0	applied	\N	\N	\N	\N	17504	17504	17505
5963	4607	0	applied	\N	\N	\N	\N	17512	17512	17513
5965	4607	0	applied	\N	\N	\N	\N	17512	17512	17513
5968	4609	0	applied	\N	\N	\N	\N	17521	17521	17522
5968	4610	1	applied	\N	\N	\N	\N	17523	17523	17524
5973	4616	0	applied	\N	\N	\N	\N	17547	17547	17548
5975	4617	0	applied	\N	\N	\N	\N	17553	17553	17554
5980	4619	0	applied	\N	\N	\N	\N	17557	17557	17558
5989	4626	0	applied	\N	\N	\N	\N	17583	17583	17584
5596	4411	10	applied	\N	\N	\N	\N	16638	16638	16482
5630	4415	0	applied	\N	\N	\N	\N	16745	16745	16746
5682	4417	0	applied	\N	\N	\N	\N	16779	16779	16780
5699	4418	0	applied	\N	\N	\N	\N	14435	14435	745
5716	4420	0	applied	\N	\N	\N	\N	16809	16809	1435
5716	4421	1	applied	\N	\N	\N	\N	16810	16810	1435
5741	4424	0	applied	\N	\N	\N	\N	16839	16839	16840
5746	4428	0	applied	\N	\N	\N	\N	16850	16850	16851
5749	4430	0	applied	\N	\N	\N	\N	16858	16858	16859
5751	4431	0	applied	\N	\N	\N	\N	16861	16861	16862
5754	4433	0	applied	\N	\N	\N	\N	16871	16871	16872
5754	4434	1	applied	\N	\N	\N	\N	16873	16873	16874
5754	4435	2	applied	\N	\N	\N	\N	16875	16875	16876
5756	4436	0	applied	\N	\N	\N	\N	16881	16881	16882
5761	4440	0	applied	\N	\N	\N	\N	16894	16894	16895
5765	4446	0	applied	\N	\N	\N	\N	16910	16910	16911
5765	4447	1	applied	\N	\N	\N	\N	16912	16912	16913
5765	4448	2	applied	\N	\N	\N	\N	16914	16914	16915
5770	4452	0	applied	\N	\N	\N	\N	16928	16928	16929
5775	4455	0	applied	\N	\N	\N	\N	16943	16943	16944
5775	4456	1	applied	\N	\N	\N	\N	16945	16945	16946
5782	4467	0	applied	\N	\N	\N	\N	16976	16976	16977
5782	4468	1	applied	\N	\N	\N	\N	16978	16978	16979
5788	4471	0	applied	\N	\N	1000000000	\N	16988	16988	16989
5788	4472	1	applied	\N	\N	1000000000	\N	16990	16990	16991
5788	4473	2	applied	\N	\N	\N	\N	16992	16992	16993
5794	4476	0	applied	\N	\N	\N	\N	17008	17008	17009
5794	4477	1	applied	\N	\N	\N	\N	17010	17010	17011
5802	4483	0	applied	\N	\N	\N	\N	17032	17032	17033
5810	4488	0	applied	\N	\N	\N	\N	17049	17049	17050
5812	4489	0	applied	\N	\N	\N	\N	17055	17055	17056
5812	4490	1	applied	\N	\N	\N	\N	17057	17057	17058
5814	4492	0	applied	\N	\N	\N	\N	17066	17066	17067
5824	4499	0	applied	\N	\N	\N	\N	17091	17091	17092
5826	4499	0	applied	\N	\N	\N	\N	17091	17091	17092
5831	4504	0	applied	\N	\N	\N	\N	17106	17106	17107
5833	4505	0	applied	\N	\N	\N	\N	17111	17111	17112
5836	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
5836	4508	2	applied	\N	\N	1000000000	\N	17122	17122	17123
5836	4509	3	applied	\N	\N	\N	\N	17124	17124	17125
5836	4510	4	applied	\N	\N	\N	\N	17126	17126	17127
5850	4518	0	applied	\N	\N	\N	\N	17168	17168	17169
5852	4519	0	applied	\N	\N	\N	\N	17174	17174	17175
5865	4525	0	applied	\N	\N	\N	\N	17192	17192	17193
5865	4526	1	applied	\N	\N	\N	\N	17194	17194	17195
5869	4527	0	applied	\N	\N	\N	\N	17206	17206	17207
5869	4528	1	applied	\N	\N	\N	\N	17208	17208	17209
5869	4529	2	applied	\N	\N	\N	\N	17210	17210	17211
5872	4533	0	applied	\N	\N	\N	\N	17225	17225	17226
5872	4534	1	applied	\N	\N	\N	\N	17227	17227	17228
5880	4539	0	applied	\N	\N	\N	\N	17246	17246	17247
5880	4540	1	applied	\N	\N	\N	\N	17248	17248	17249
5896	4551	0	applied	\N	\N	\N	\N	17284	17284	17285
5896	4552	1	applied	\N	\N	\N	\N	17286	17286	17287
5896	4553	2	applied	\N	\N	\N	\N	17288	17288	17289
5896	4554	3	applied	\N	\N	\N	\N	17290	17290	17291
5896	4555	4	applied	\N	\N	\N	\N	17292	17292	17293
5899	4557	0	applied	\N	\N	\N	\N	17300	17300	17301
5910	4564	0	applied	\N	\N	\N	\N	17330	17330	17331
5918	4567	0	applied	\N	\N	\N	\N	17342	17342	17343
5918	4568	1	applied	\N	\N	\N	\N	17344	17344	17345
5918	4569	2	applied	\N	\N	\N	\N	17346	17346	17347
5922	4570	0	applied	\N	\N	\N	\N	17355	17355	17356
5924	4571	0	applied	\N	\N	\N	\N	17361	17361	17362
5930	4573	0	applied	\N	\N	\N	\N	17372	17372	17373
5930	4574	1	applied	\N	\N	\N	\N	17374	17374	17375
5933	4550	0	applied	\N	\N	\N	\N	17278	17278	17279
5933	4551	1	applied	\N	\N	\N	\N	17284	17284	17285
5933	4552	2	applied	\N	\N	\N	\N	17286	17286	17287
5933	4553	3	applied	\N	\N	\N	\N	17288	17288	17289
5933	4554	4	applied	\N	\N	\N	\N	17290	17290	17291
5933	4555	5	applied	\N	\N	\N	\N	17292	17292	17293
5933	4556	6	applied	\N	\N	\N	\N	17296	17296	17390
5933	4557	7	applied	\N	\N	\N	\N	17300	17300	17391
5933	4558	8	applied	\N	\N	\N	\N	17308	17308	17392
5933	4559	9	applied	\N	\N	\N	\N	17310	17310	17393
5933	4560	10	applied	\N	\N	\N	\N	17314	17314	17394
5933	4561	11	applied	\N	\N	\N	\N	17321	17321	17395
5933	4562	12	applied	\N	\N	\N	\N	17323	17323	17396
5933	4563	13	applied	\N	\N	\N	\N	17327	17327	17397
5933	4564	14	applied	\N	\N	\N	\N	17330	17330	17398
5933	4565	15	applied	\N	\N	\N	\N	17334	17334	17399
5933	4566	16	applied	\N	\N	\N	\N	17338	17338	17400
5933	4567	17	applied	\N	\N	\N	\N	17342	17342	17401
5933	4568	18	applied	\N	\N	\N	\N	17344	17344	17402
5933	4569	19	applied	\N	\N	\N	\N	17346	17346	17403
5933	4570	20	applied	\N	\N	\N	\N	17355	17355	17404
5933	4571	21	applied	\N	\N	\N	\N	17361	17361	17405
5933	4572	22	applied	\N	\N	\N	\N	17365	17365	17406
5933	4573	23	applied	\N	\N	\N	\N	17372	17372	17407
5933	4574	24	applied	\N	\N	\N	\N	17374	17374	17408
5933	4575	25	applied	\N	\N	\N	\N	17380	17380	17409
5933	4576	26	applied	\N	\N	\N	\N	17382	17382	17410
5933	4577	27	applied	\N	\N	\N	\N	17386	17386	17411
5937	4579	0	applied	\N	\N	\N	\N	17421	17421	17422
5941	4582	0	applied	\N	\N	\N	\N	17430	17430	17431
5941	4583	1	applied	\N	\N	\N	\N	17432	17432	17433
5941	4584	2	applied	\N	\N	\N	\N	17434	17434	17435
5945	4587	0	applied	\N	\N	\N	\N	17448	17448	17449
5945	4588	1	applied	\N	\N	\N	\N	17450	17450	17451
5948	4591	0	applied	\N	\N	\N	\N	17461	17461	17462
5950	4592	0	applied	\N	\N	\N	\N	17465	17465	17466
5952	4592	0	applied	\N	\N	\N	\N	17465	17465	17466
5955	4596	0	applied	\N	\N	\N	\N	17479	17479	17480
5958	4598	0	applied	\N	\N	\N	\N	17488	17488	17489
5958	4599	1	applied	\N	\N	\N	\N	17490	17490	17491
5961	4606	0	applied	\N	\N	\N	\N	17508	17508	17509
5964	4607	0	applied	\N	\N	\N	\N	17512	17512	17513
5971	4613	0	applied	\N	\N	\N	\N	17535	17535	17536
5971	4614	1	applied	\N	\N	\N	\N	17537	17537	17538
5976	4618	0	applied	\N	\N	\N	\N	17555	17555	17556
5978	4619	0	applied	\N	\N	\N	\N	17557	17557	17558
5983	4622	0	applied	\N	\N	\N	\N	17567	17567	17568
5988	4625	0	applied	\N	\N	\N	\N	17581	17581	17582
5990	4626	0	applied	\N	\N	\N	\N	17583	17583	17584
5993	4629	0	applied	\N	\N	\N	\N	17596	17596	17597
5993	4630	1	applied	\N	\N	\N	\N	17598	17598	17599
5996	4631	0	applied	\N	\N	\N	\N	17606	17606	17607
5996	4632	1	applied	\N	\N	\N	\N	17608	17608	17609
5656	4404	0	applied	\N	\N	1000000000	\N	16620	16620	16621
5656	4414	1	applied	\N	\N	\N	\N	16694	16694	1435
5656	4405	2	applied	\N	\N	1000000000	\N	16622	16622	16623
5656	4406	3	applied	\N	\N	1000000000	\N	16624	16624	16625
5656	4407	4	applied	\N	\N	1000000000	\N	16626	16626	16627
5656	4408	5	applied	\N	\N	1000000000	\N	16628	16628	16629
5656	4409	6	applied	\N	\N	1000000000	\N	16630	16630	16631
5656	4410	7	applied	\N	\N	1000000000	\N	16632	16632	16633
5656	4412	8	applied	\N	\N	\N	\N	16666	16666	16667
5656	4413	9	applied	\N	\N	\N	\N	16675	16675	16676
5656	4403	10	applied	\N	\N	1000000000	\N	16613	16613	16614
5656	4411	12	applied	\N	\N	\N	\N	16638	16638	16482
5678	4404	0	applied	\N	\N	1000000000	\N	16620	16620	16621
5678	4414	1	applied	\N	\N	\N	\N	16694	16694	1435
5678	4405	2	applied	\N	\N	1000000000	\N	16622	16622	16623
5678	4406	3	applied	\N	\N	1000000000	\N	16624	16624	16625
5678	4407	4	applied	\N	\N	1000000000	\N	16626	16626	16627
5678	4408	5	applied	\N	\N	1000000000	\N	16628	16628	16629
5678	4409	6	applied	\N	\N	1000000000	\N	16630	16630	16631
5678	4410	7	applied	\N	\N	1000000000	\N	16632	16632	16633
5678	4412	8	applied	\N	\N	\N	\N	16666	16666	16667
5678	4413	9	applied	\N	\N	\N	\N	16675	16675	16676
5678	4403	10	applied	\N	\N	1000000000	\N	16613	16613	16614
5678	4411	11	applied	\N	\N	\N	\N	16638	16638	16482
5678	4402	12	applied	\N	\N	\N	\N	16600	16600	16601
5680	4417	0	applied	\N	\N	\N	\N	16779	16779	16780
5710	4419	0	applied	\N	\N	1000000000	\N	16802	16802	16803
5714	4419	0	applied	\N	\N	1000000000	\N	16802	16802	16803
5714	4416	1	applied	\N	\N	1000000000	\N	16776	16776	16777
5714	4417	2	applied	\N	\N	\N	\N	16779	16779	16780
5714	4418	3	applied	\N	\N	\N	\N	14435	14435	745
5717	4420	0	applied	\N	\N	\N	\N	16809	16809	1435
5717	4421	1	applied	\N	\N	\N	\N	16810	16810	1435
5740	4423	0	applied	\N	\N	\N	\N	16833	16833	16834
5747	4429	0	applied	\N	\N	\N	\N	16854	16854	16855
5752	4432	0	applied	\N	\N	\N	\N	16867	16867	16868
5757	4437	0	applied	\N	\N	\N	\N	16883	16883	16884
5760	4438	0	applied	\N	\N	\N	\N	16888	16888	16889
5760	4439	1	applied	\N	\N	\N	\N	16890	16890	16891
5763	4443	0	applied	\N	\N	\N	\N	16901	16901	16902
5763	4444	1	applied	\N	\N	\N	\N	16903	16903	16904
5763	4445	2	applied	\N	\N	\N	\N	16905	16905	16906
5769	4451	0	applied	\N	\N	\N	\N	16924	16924	16925
5777	4457	0	applied	\N	\N	\N	\N	16948	16948	16949
5777	4458	1	applied	\N	\N	\N	\N	16950	16950	16951
5777	4459	2	applied	\N	\N	\N	\N	16952	16952	16953
5777	4460	3	applied	\N	\N	\N	\N	16954	16954	16955
5780	4464	0	applied	\N	\N	\N	\N	16967	16967	16968
5780	4465	1	applied	\N	\N	\N	\N	16969	16969	16970
5793	4475	0	applied	\N	\N	\N	\N	17005	17005	17006
5796	4476	0	applied	\N	\N	\N	\N	17008	17008	17009
5796	4477	1	applied	\N	\N	\N	\N	17010	17010	17011
5798	4479	0	applied	\N	\N	\N	\N	17021	17021	17022
5798	4480	1	applied	\N	\N	\N	\N	17023	17023	17024
5803	4484	0	applied	\N	\N	\N	\N	17036	17036	17037
5808	4488	0	applied	\N	\N	\N	\N	17049	17049	17050
5816	4495	0	applied	\N	\N	\N	\N	17074	17074	17075
5816	4496	1	applied	\N	\N	\N	\N	17076	17076	17077
5818	4497	0	applied	\N	\N	\N	\N	17081	17081	17082
5821	4498	0	applied	\N	\N	\N	\N	17085	17085	17086
5827	4500	0	applied	\N	\N	\N	\N	17097	17097	17098
5835	4506	0	applied	\N	\N	\N	\N	17115	17115	17116
5838	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
5838	4508	2	applied	\N	\N	1000000000	\N	17122	17122	17123
5838	4509	3	applied	\N	\N	\N	\N	17124	17124	17125
5838	4510	4	applied	\N	\N	\N	\N	17126	17126	17127
5841	4511	0	applied	\N	\N	\N	\N	17145	17145	17146
5842	4512	0	applied	\N	\N	\N	\N	17148	17148	17149
5842	4513	1	applied	\N	\N	\N	\N	17150	17150	17151
5842	4514	2	applied	\N	\N	\N	\N	17152	17152	17153
5844	4515	0	applied	\N	\N	\N	\N	17156	17156	17157
5847	4516	0	applied	\N	\N	\N	\N	17159	17159	17160
5854	4522	0	applied	\N	\N	\N	\N	17182	17182	17183
5866	4471	0	applied	\N	\N	1000000000	\N	16988	16988	16989
5866	4472	1	applied	\N	\N	1000000000	\N	16990	16990	16991
5866	4507	2	applied	\N	\N	1000000000	\N	17119	17119	17120
5866	4508	3	applied	\N	\N	1000000000	\N	17122	17122	17123
5866	4473	4	applied	\N	\N	\N	\N	16992	16992	16993
5866	4474	5	applied	\N	\N	\N	\N	17001	17001	17002
5866	4475	6	applied	\N	\N	\N	\N	17005	17005	17006
5866	4476	7	applied	\N	\N	\N	\N	17008	17008	17009
5866	4477	8	applied	\N	\N	\N	\N	17010	17010	17011
5866	4478	9	applied	\N	\N	\N	\N	17017	17017	17018
5866	4479	10	applied	\N	\N	\N	\N	17021	17021	17022
5866	4480	11	applied	\N	\N	\N	\N	17023	17023	17024
5866	4481	12	applied	\N	\N	\N	\N	17026	17026	17027
5866	4482	13	applied	\N	\N	\N	\N	17028	17028	17029
5866	4483	14	applied	\N	\N	\N	\N	17032	17032	17033
5866	4484	15	applied	\N	\N	\N	\N	17036	17036	17037
5866	4485	16	applied	\N	\N	\N	\N	17039	17039	17040
5866	4486	17	applied	\N	\N	\N	\N	17041	17041	17042
5866	4487	18	applied	\N	\N	\N	\N	17045	17045	17046
5866	4488	19	applied	\N	\N	\N	\N	17049	17049	17050
5866	4489	20	applied	\N	\N	\N	\N	17055	17055	17056
5866	4490	21	applied	\N	\N	\N	\N	17057	17057	17058
5866	4491	22	applied	\N	\N	\N	\N	17062	17062	17063
5866	4492	23	applied	\N	\N	\N	\N	17066	17066	17067
5866	4493	24	applied	\N	\N	\N	\N	17069	17069	17070
5866	4494	25	applied	\N	\N	\N	\N	17071	17071	17072
5866	4495	26	applied	\N	\N	\N	\N	17074	17074	17075
5866	4496	27	applied	\N	\N	\N	\N	17076	17076	17077
5866	4497	28	applied	\N	\N	\N	\N	17081	17081	17082
5866	4498	29	applied	\N	\N	\N	\N	17085	17085	17086
5866	4499	30	applied	\N	\N	\N	\N	17091	17091	17092
5866	4500	31	applied	\N	\N	\N	\N	17097	17097	17098
5866	4501	32	applied	\N	\N	\N	\N	17100	17100	17101
5866	4502	33	applied	\N	\N	\N	\N	17102	17102	17103
5866	4503	34	applied	\N	\N	\N	\N	17104	17104	17105
5866	4504	35	applied	\N	\N	\N	\N	17106	17106	17107
5866	4505	36	applied	\N	\N	\N	\N	17111	17111	17112
5866	4506	37	applied	\N	\N	\N	\N	17115	17115	17116
5866	4509	38	applied	\N	\N	\N	\N	17124	17124	17125
5866	4510	39	applied	\N	\N	\N	\N	17126	17126	17127
5866	4511	40	applied	\N	\N	\N	\N	17145	17145	17146
5866	4512	41	applied	\N	\N	\N	\N	17148	17148	17149
5866	4513	42	applied	\N	\N	\N	\N	17150	17150	17151
5866	4514	43	applied	\N	\N	\N	\N	17152	17152	17153
5768	4451	0	applied	\N	\N	\N	\N	16924	16924	16925
5771	4452	0	applied	\N	\N	\N	\N	16928	16928	16929
5779	4463	0	applied	\N	\N	\N	\N	16964	16964	16965
5783	4422	0	applied	\N	\N	\N	\N	16821	16821	1435
5783	4420	1	applied	\N	\N	\N	\N	16809	16809	1435
5783	4421	2	applied	\N	\N	\N	\N	16810	16810	1435
5783	4419	3	applied	\N	\N	1000000000	\N	16802	16802	16803
5783	4423	4	applied	\N	\N	\N	\N	16833	16833	16834
5783	4424	5	applied	\N	\N	\N	\N	16839	16839	16840
5783	4425	6	applied	\N	\N	\N	\N	16841	16841	16842
5783	4426	7	applied	\N	\N	\N	\N	16843	16843	16844
5783	4427	8	applied	\N	\N	\N	\N	16846	16846	16847
5783	4428	9	applied	\N	\N	\N	\N	16850	16850	16851
5783	4429	10	applied	\N	\N	\N	\N	16854	16854	16855
5783	4430	11	applied	\N	\N	\N	\N	16858	16858	16859
5783	4431	12	applied	\N	\N	\N	\N	16861	16861	16862
5783	4432	13	applied	\N	\N	\N	\N	16867	16867	16868
5783	4433	14	applied	\N	\N	\N	\N	16871	16871	16872
5783	4434	15	applied	\N	\N	\N	\N	16873	16873	16874
5783	4435	16	applied	\N	\N	\N	\N	16875	16875	16876
5783	4436	17	applied	\N	\N	\N	\N	16881	16881	16882
5783	4437	18	applied	\N	\N	\N	\N	16883	16883	16884
5783	4438	19	applied	\N	\N	\N	\N	16888	16888	16889
5783	4439	20	applied	\N	\N	\N	\N	16890	16890	16891
5783	4417	21	applied	\N	\N	\N	\N	16779	16779	16780
5783	4418	22	applied	\N	\N	\N	\N	14435	14435	745
5783	4440	23	applied	\N	\N	\N	\N	16894	16894	16895
5783	4441	24	applied	\N	\N	\N	\N	16897	16897	16898
5783	4442	25	applied	\N	\N	\N	\N	16899	16899	16900
5783	4443	26	applied	\N	\N	\N	\N	16901	16901	16902
5783	4444	27	applied	\N	\N	\N	\N	16903	16903	16904
5783	4445	28	applied	\N	\N	\N	\N	16905	16905	16906
5783	4446	29	applied	\N	\N	\N	\N	16910	16910	16911
5783	4447	30	applied	\N	\N	\N	\N	16912	16912	16913
5783	4448	31	applied	\N	\N	\N	\N	16914	16914	16915
5783	4449	32	applied	\N	\N	\N	\N	16918	16918	16919
5783	4450	33	applied	\N	\N	\N	\N	16920	16920	16921
5783	4451	34	applied	\N	\N	\N	\N	16924	16924	16925
5783	4452	35	applied	\N	\N	\N	\N	16928	16928	16929
5783	4453	36	applied	\N	\N	\N	\N	16935	16935	16936
5783	4454	37	applied	\N	\N	\N	\N	16937	16937	16938
5783	4455	38	applied	\N	\N	\N	\N	16943	16943	16944
5783	4456	39	applied	\N	\N	\N	\N	16945	16945	16946
5783	4457	40	applied	\N	\N	\N	\N	16948	16948	16949
5783	4458	41	applied	\N	\N	\N	\N	16950	16950	16951
5783	4459	42	applied	\N	\N	\N	\N	16952	16952	16953
5783	4460	43	applied	\N	\N	\N	\N	16954	16954	16955
5783	4461	44	applied	\N	\N	\N	\N	16958	16958	16959
5783	4462	45	applied	\N	\N	\N	\N	16960	16960	16961
5783	4463	46	applied	\N	\N	\N	\N	16964	16964	16965
5783	4464	47	applied	\N	\N	\N	\N	16967	16967	16968
5783	4465	48	applied	\N	\N	\N	\N	16969	16969	16970
5783	4466	49	applied	\N	\N	\N	\N	16972	16972	16973
5783	4467	50	applied	\N	\N	\N	\N	16976	16976	16977
5783	4468	51	applied	\N	\N	\N	\N	16978	16978	16979
5783	4469	52	applied	\N	\N	\N	\N	16982	16982	16983
5783	4470	53	applied	\N	\N	\N	\N	16984	16984	16985
5785	4471	0	applied	\N	\N	1000000000	\N	16988	16988	16989
5785	4472	1	applied	\N	\N	1000000000	\N	16990	16990	16991
5785	4473	2	applied	\N	\N	\N	\N	16992	16992	16993
5790	4474	0	applied	\N	\N	\N	\N	17001	17001	17002
5795	4476	0	applied	\N	\N	\N	\N	17008	17008	17009
5795	4477	1	applied	\N	\N	\N	\N	17010	17010	17011
5797	4478	0	applied	\N	\N	\N	\N	17017	17017	17018
5800	4481	0	applied	\N	\N	\N	\N	17026	17026	17027
5800	4482	1	applied	\N	\N	\N	\N	17028	17028	17029
5805	4485	0	applied	\N	\N	\N	\N	17039	17039	17040
5805	4486	1	applied	\N	\N	\N	\N	17041	17041	17042
5807	4487	0	applied	\N	\N	\N	\N	17045	17045	17046
5815	4493	0	applied	\N	\N	\N	\N	17069	17069	17070
5815	4494	1	applied	\N	\N	\N	\N	17071	17071	17072
5820	4498	0	applied	\N	\N	\N	\N	17085	17085	17086
5825	4499	0	applied	\N	\N	\N	\N	17091	17091	17092
5829	4501	0	applied	\N	\N	\N	\N	17100	17100	17101
5829	4502	1	applied	\N	\N	\N	\N	17102	17102	17103
5832	4504	0	applied	\N	\N	\N	\N	17106	17106	17107
5834	4506	0	applied	\N	\N	\N	\N	17115	17115	17116
5837	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
5837	4508	2	applied	\N	\N	1000000000	\N	17122	17122	17123
5837	4509	3	applied	\N	\N	\N	\N	17124	17124	17125
5837	4510	4	applied	\N	\N	\N	\N	17126	17126	17127
5846	4516	0	applied	\N	\N	\N	\N	17159	17159	17160
5851	4518	0	applied	\N	\N	\N	\N	17168	17168	17169
5853	4520	0	applied	\N	\N	\N	\N	17176	17176	17177
5853	4521	1	applied	\N	\N	\N	\N	17178	17178	17179
5863	4525	0	applied	\N	\N	\N	\N	17192	17192	17193
5863	4526	1	applied	\N	\N	\N	\N	17194	17194	17195
5873	4535	0	applied	\N	\N	\N	\N	17231	17231	17232
5873	4536	1	applied	\N	\N	\N	\N	17233	17233	17234
5875	4537	0	applied	\N	\N	\N	\N	17238	17238	17239
5891	4545	0	applied	\N	\N	\N	\N	17263	17263	17264
5891	4546	1	applied	\N	\N	\N	\N	17265	17265	17266
5891	4547	2	applied	\N	\N	\N	\N	17267	17267	17268
5891	4548	3	applied	\N	\N	\N	\N	17269	17269	17270
5891	4549	4	applied	\N	\N	\N	\N	17271	17271	17272
5895	4550	0	applied	\N	\N	\N	\N	17278	17278	17279
5900	4557	0	applied	\N	\N	\N	\N	17300	17300	17301
5901	4558	0	applied	\N	\N	\N	\N	17308	17308	17309
5908	4561	0	applied	\N	\N	\N	\N	17321	17321	17322
5908	4562	1	applied	\N	\N	\N	\N	17323	17323	17324
5911	4564	0	applied	\N	\N	\N	\N	17330	17330	17331
5915	4567	0	applied	\N	\N	\N	\N	17342	17342	17343
5915	4568	1	applied	\N	\N	\N	\N	17344	17344	17345
5915	4569	2	applied	\N	\N	\N	\N	17346	17346	17347
5919	4567	0	applied	\N	\N	\N	\N	17342	17342	17343
5919	4568	1	applied	\N	\N	\N	\N	17344	17344	17345
5919	4569	2	applied	\N	\N	\N	\N	17346	17346	17347
5923	4570	0	applied	\N	\N	\N	\N	17355	17355	17356
5935	4578	0	applied	\N	\N	\N	\N	17413	17413	17414
5938	4580	0	applied	\N	\N	\N	\N	17425	17425	17426
5940	4582	0	applied	\N	\N	\N	\N	17430	17430	17431
5940	4583	1	applied	\N	\N	\N	\N	17432	17432	17433
5940	4584	2	applied	\N	\N	\N	\N	17434	17434	17435
5943	4585	0	applied	\N	\N	\N	\N	17440	17440	17441
5946	4589	0	applied	\N	\N	\N	\N	17453	17453	17454
5946	4590	1	applied	\N	\N	\N	\N	17455	17455	17456
5951	4592	0	applied	\N	\N	\N	\N	17465	17465	17466
5953	4593	0	applied	\N	\N	\N	\N	17471	17471	17472
5956	4597	0	applied	\N	\N	\N	\N	17483	17483	17484
5866	4515	44	applied	\N	\N	\N	\N	17156	17156	17157
5866	4516	45	applied	\N	\N	\N	\N	17159	17159	17160
5866	4517	46	applied	\N	\N	\N	\N	17165	17165	17166
5866	4518	47	applied	\N	\N	\N	\N	17168	17168	17169
5866	4519	48	applied	\N	\N	\N	\N	17174	17174	17175
5866	4520	49	applied	\N	\N	\N	\N	17176	17176	17177
5866	4521	50	applied	\N	\N	\N	\N	17178	17178	17179
5866	4522	51	applied	\N	\N	\N	\N	17182	17182	17183
5866	4523	53	applied	\N	\N	\N	\N	17186	17186	17187
5866	4524	54	applied	\N	\N	\N	\N	17188	17188	17189
5866	4525	55	applied	\N	\N	\N	\N	17192	17192	17193
5870	4530	0	applied	\N	\N	\N	\N	17216	17216	17217
5870	4531	1	applied	\N	\N	\N	\N	17218	17218	17219
5874	4535	0	applied	\N	\N	\N	\N	17231	17231	17232
5874	4536	1	applied	\N	\N	\N	\N	17233	17233	17234
5876	4538	0	applied	\N	\N	\N	\N	17240	17240	17241
5878	4538	0	applied	\N	\N	\N	\N	17240	17240	17241
5892	4545	0	applied	\N	\N	\N	\N	17263	17263	17264
5892	4546	1	applied	\N	\N	\N	\N	17265	17265	17266
5892	4547	2	applied	\N	\N	\N	\N	17267	17267	17268
5892	4548	3	applied	\N	\N	\N	\N	17269	17269	17270
5892	4549	4	applied	\N	\N	\N	\N	17271	17271	17272
5897	4556	0	applied	\N	\N	\N	\N	17296	17296	17297
5902	4559	0	applied	\N	\N	\N	\N	17310	17310	17311
5904	4560	0	applied	\N	\N	\N	\N	17314	17314	17315
5907	4560	0	applied	\N	\N	\N	\N	17314	17314	17315
5909	4563	0	applied	\N	\N	\N	\N	17327	17327	17328
5913	4565	0	applied	\N	\N	\N	\N	17334	17334	17335
5914	4566	0	applied	\N	\N	\N	\N	17338	17338	17339
5916	4567	0	applied	\N	\N	\N	\N	17342	17342	17343
5916	4568	1	applied	\N	\N	\N	\N	17344	17344	17345
5916	4569	2	applied	\N	\N	\N	\N	17346	17346	17347
5920	4570	0	applied	\N	\N	\N	\N	17355	17355	17356
5927	4572	0	applied	\N	\N	\N	\N	17365	17365	17366
5928	4573	0	applied	\N	\N	\N	\N	17372	17372	17373
5928	4574	1	applied	\N	\N	\N	\N	17374	17374	17375
5931	4575	0	applied	\N	\N	\N	\N	17380	17380	17381
5931	4576	1	applied	\N	\N	\N	\N	17382	17382	17383
5949	4591	0	applied	\N	\N	\N	\N	17461	17461	17462
5954	4594	0	applied	\N	\N	\N	\N	17473	17473	17474
5954	4595	1	applied	\N	\N	\N	\N	17475	17475	17476
5962	4607	0	applied	\N	\N	\N	\N	17512	17512	17513
5967	4609	0	applied	\N	\N	\N	\N	17521	17521	17522
5967	4610	1	applied	\N	\N	\N	\N	17523	17523	17524
5970	4613	0	applied	\N	\N	\N	\N	17535	17535	17536
5970	4614	1	applied	\N	\N	\N	\N	17537	17537	17538
5972	4615	0	applied	\N	\N	\N	\N	17543	17543	17544
5977	4619	0	applied	\N	\N	\N	\N	17557	17557	17558
5982	4620	0	applied	\N	\N	\N	\N	17562	17562	17563
5982	4621	1	applied	\N	\N	\N	\N	17564	17564	17565
5985	4623	0	applied	\N	\N	\N	\N	17571	17571	17572
5985	4624	1	applied	\N	\N	\N	\N	17573	17573	17574
5987	4625	0	applied	\N	\N	\N	\N	17581	17581	17582
5992	4628	0	applied	\N	\N	\N	\N	17592	17592	17593
5998	4636	0	applied	\N	\N	\N	\N	17619	17619	17620
6005	4643	0	applied	\N	\N	\N	\N	17642	17642	17643
6008	4646	0	applied	\N	\N	\N	\N	17650	17650	17651
6010	4507	0	applied	\N	\N	1000000000	\N	17119	17119	17120
6010	4508	1	applied	\N	\N	1000000000	\N	17122	17122	17123
6010	4542	2	applied	\N	\N	1000000000	\N	17255	17255	17256
6010	4543	3	applied	\N	\N	1000000000	\N	17257	17257	17258
6010	4544	4	applied	\N	\N	1000000000	\N	17259	17259	17260
6010	4638	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	14319	14319	\N
6010	4639	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	17625	17625	\N
6010	4602	7	applied	\N	\N	\N	\N	17497	17497	17498
6010	4603	8	applied	\N	\N	\N	\N	17499	17499	17500
6010	4604	9	applied	\N	\N	\N	\N	17501	17501	17502
6012	4647	0	applied	\N	\N	\N	\N	17656	17656	17657
6015	4648	0	applied	\N	\N	\N	\N	17660	17660	17661
6022	4655	0	applied	\N	\N	\N	\N	17687	17687	17688
6022	4656	1	applied	\N	\N	\N	\N	17689	17689	17690
6025	4657	0	applied	\N	\N	\N	\N	17695	17695	17696
6025	4658	1	applied	\N	\N	\N	\N	17697	17697	17698
6025	4659	2	applied	\N	\N	\N	\N	17699	17699	17700
6025	4660	3	applied	\N	\N	\N	\N	17701	17701	17702
6025	4661	4	applied	\N	\N	1000000000	\N	17703	17703	17704
6028	4663	0	applied	\N	\N	\N	\N	17712	17712	17713
6028	4664	1	applied	\N	\N	\N	\N	17714	17714	17715
6028	4665	2	applied	\N	\N	\N	\N	17716	17716	17717
6030	4663	0	applied	\N	\N	\N	\N	17712	17712	17713
6030	4664	1	applied	\N	\N	\N	\N	17714	17714	17715
6030	4665	2	applied	\N	\N	\N	\N	17716	17716	17717
6033	4670	0	applied	\N	\N	\N	\N	17732	17732	17733
6035	4671	0	applied	\N	\N	1000000000	\N	17736	17736	17737
6035	4672	1	applied	\N	\N	\N	\N	17738	17738	17739
6035	4673	2	applied	\N	\N	\N	\N	17740	17740	17741
6038	4677	0	applied	\N	\N	\N	\N	17752	17752	17753
6038	4678	1	applied	\N	\N	\N	\N	17754	17754	17755
6043	4684	0	applied	\N	\N	\N	\N	17771	17771	17772
6048	4687	0	applied	\N	\N	\N	\N	17785	17785	17786
6053	4690	0	applied	\N	\N	\N	\N	17797	17797	17798
6055	4692	0	applied	\N	\N	\N	\N	17805	17805	17806
6060	4695	0	applied	\N	\N	\N	\N	17816	17816	17817
6060	4696	1	applied	\N	\N	\N	\N	17818	17818	17819
6068	4702	0	applied	\N	\N	\N	\N	17841	17841	17842
6068	4703	1	applied	\N	\N	\N	\N	17843	17843	17844
6071	4704	0	applied	\N	\N	\N	\N	17847	17847	17848
6075	4707	0	applied	\N	\N	\N	\N	17860	17860	17861
6075	4708	1	applied	\N	\N	\N	\N	17862	17862	17863
6077	4707	0	applied	\N	\N	\N	\N	17860	17860	17861
6077	4708	1	applied	\N	\N	\N	\N	17862	17862	17863
6082	4709	0	applied	\N	\N	\N	\N	17870	17870	17871
6082	4710	1	applied	\N	\N	\N	\N	17872	17872	17873
6092	4714	0	applied	\N	\N	\N	\N	17896	17896	17897
6092	4715	1	applied	\N	\N	\N	\N	17900	17900	17901
6092	4716	2	applied	\N	\N	\N	\N	17902	17902	17903
6094	4717	0	applied	\N	\N	\N	\N	17909	17909	17910
6094	4718	1	applied	\N	\N	\N	\N	17911	17911	17912
6094	4719	2	applied	\N	\N	\N	\N	17913	17913	17914
6097	4722	0	applied	\N	\N	\N	\N	17925	17925	17926
6097	4723	1	applied	\N	\N	\N	\N	17927	17927	17928
5959	4600	0	applied	\N	\N	\N	\N	17493	17493	17494
5959	4601	1	applied	\N	\N	\N	\N	17495	17495	17496
5959	4602	2	applied	\N	\N	\N	\N	17497	17497	17498
5959	4603	3	applied	\N	\N	\N	\N	17499	17499	17500
5959	4604	4	applied	\N	\N	\N	\N	17501	17501	17502
5966	4608	0	applied	\N	\N	\N	\N	17519	17519	17520
5969	4611	0	applied	\N	\N	\N	\N	17529	17529	17530
5969	4612	1	applied	\N	\N	\N	\N	17531	17531	17532
5974	4616	0	applied	\N	\N	\N	\N	17547	17547	17548
5979	4619	0	applied	\N	\N	\N	\N	17557	17557	17558
5981	4620	0	applied	\N	\N	\N	\N	17562	17562	17563
5981	4621	1	applied	\N	\N	\N	\N	17564	17564	17565
5984	4623	0	applied	\N	\N	\N	\N	17571	17571	17572
5984	4624	1	applied	\N	\N	\N	\N	17573	17573	17574
5986	4623	0	applied	\N	\N	\N	\N	17571	17571	17572
5986	4624	1	applied	\N	\N	\N	\N	17573	17573	17574
5994	4629	0	applied	\N	\N	\N	\N	17596	17596	17597
5994	4630	1	applied	\N	\N	\N	\N	17598	17598	17599
6004	4642	0	applied	\N	\N	\N	\N	17638	17638	17639
6006	4643	0	applied	\N	\N	\N	\N	17642	17642	17643
6009	4646	0	applied	\N	\N	\N	\N	17650	17650	17651
6011	4647	0	applied	\N	\N	\N	\N	17656	17656	17657
6014	4648	0	applied	\N	\N	\N	\N	17660	17660	17661
6018	4650	0	applied	\N	\N	\N	\N	17672	17672	17673
6020	4651	0	applied	\N	\N	\N	\N	17677	17677	17678
6029	4663	0	applied	\N	\N	\N	\N	17712	17712	17713
6029	4664	1	applied	\N	\N	\N	\N	17714	17714	17715
6029	4665	2	applied	\N	\N	\N	\N	17716	17716	17717
6039	4679	0	applied	\N	\N	\N	\N	17758	17758	17759
6042	4682	0	applied	\N	\N	\N	\N	17765	17765	17766
6042	4683	1	applied	\N	\N	\N	\N	17767	17767	17768
6047	4687	0	applied	\N	\N	\N	\N	17785	17785	17786
6054	4691	0	applied	\N	\N	\N	\N	17801	17801	17802
6058	4692	0	applied	\N	\N	\N	\N	17805	17805	17806
6067	4699	0	applied	\N	\N	\N	\N	17833	17833	17834
6067	4700	1	applied	\N	\N	\N	\N	17835	17835	17836
6067	4701	2	applied	\N	\N	\N	\N	17837	17837	17838
6069	4704	0	applied	\N	\N	\N	\N	17847	17847	17848
6081	4709	0	applied	\N	\N	\N	\N	17870	17870	17871
6081	4710	1	applied	\N	\N	\N	\N	17872	17872	17873
6085	4711	0	applied	\N	\N	\N	\N	17883	17883	17884
6088	4712	0	applied	\N	\N	\N	\N	17887	17887	17888
6099	4722	0	applied	\N	\N	\N	\N	17925	17925	17926
6099	4723	1	applied	\N	\N	\N	\N	17927	17927	17928
6103	4725	0	applied	\N	\N	\N	\N	17938	17938	17939
6105	4652	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17681	17681	\N
6105	4668	1	applied	\N	\N	1000000000	\N	17726	17726	17727
6105	4661	2	applied	\N	\N	1000000000	\N	17703	17703	17704
6105	4666	3	applied	\N	\N	\N	\N	17722	17722	17723
6105	4677	4	applied	\N	\N	\N	\N	17752	17752	17794
5991	4627	0	applied	\N	\N	\N	\N	17589	17589	17590
5995	4629	0	applied	\N	\N	\N	\N	17596	17596	17597
5995	4630	1	applied	\N	\N	\N	\N	17598	17598	17599
5997	4631	0	applied	\N	\N	\N	\N	17606	17606	17607
5997	4632	1	applied	\N	\N	\N	\N	17608	17608	17609
5997	4633	2	applied	\N	\N	\N	\N	17610	17610	17611
5997	4634	3	applied	\N	\N	\N	\N	17612	17612	17613
5997	4635	4	applied	\N	\N	\N	\N	17614	17614	17615
6000	4637	0	applied	\N	\N	\N	\N	17623	17623	17624
6000	4638	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	14319	14319	\N
6000	4639	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	17625	17625	\N
6000	4640	3	applied	\N	\N	\N	\N	17626	17626	17627
6002	4641	0	applied	\N	\N	\N	\N	17631	17631	17632
6007	4644	0	applied	\N	\N	\N	\N	17646	17646	17647
6007	4645	1	applied	\N	\N	\N	\N	17648	17648	17649
6016	4649	0	applied	\N	\N	\N	\N	17668	17668	17669
6019	4650	0	applied	\N	\N	\N	\N	17672	17672	17673
6021	4652	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	17681	17681	\N
6021	4653	1	applied	\N	\N	\N	\N	17682	17682	17683
6021	4654	2	applied	\N	\N	\N	\N	17684	17684	17685
6024	4655	0	applied	\N	\N	\N	\N	17687	17687	17688
6024	4656	1	applied	\N	\N	\N	\N	17689	17689	17690
6027	4662	0	applied	\N	\N	\N	\N	17706	17706	17707
6032	4669	0	applied	\N	\N	\N	\N	17730	17730	17731
6037	4675	0	applied	\N	\N	\N	\N	17746	17746	17747
6037	4676	1	applied	\N	\N	\N	\N	17748	17748	17749
6040	4679	0	applied	\N	\N	\N	\N	17758	17758	17759
6045	4686	0	applied	\N	\N	\N	\N	17779	17779	17780
6050	4688	0	applied	\N	\N	\N	\N	17789	17789	17790
6050	4689	1	applied	\N	\N	\N	\N	17791	17791	17792
6052	4690	0	applied	\N	\N	\N	\N	17797	17797	17798
6057	4692	0	applied	\N	\N	\N	\N	17805	17805	17806
6059	4693	0	applied	\N	\N	\N	\N	17811	17811	17812
6059	4694	1	applied	\N	\N	\N	\N	17813	17813	17814
6062	4695	0	applied	\N	\N	\N	\N	17816	17816	17817
6062	4696	1	applied	\N	\N	\N	\N	17818	17818	17819
6064	4697	0	applied	\N	\N	\N	\N	17825	17825	17826
6070	4704	0	applied	\N	\N	\N	\N	17847	17847	17848
6072	4705	0	applied	\N	\N	\N	\N	17855	17855	17856
6074	4706	0	applied	\N	\N	\N	\N	17858	17858	17859
6079	4709	0	applied	\N	\N	\N	\N	17870	17870	17871
6079	4710	1	applied	\N	\N	\N	\N	17872	17872	17873
6086	4711	0	applied	\N	\N	\N	\N	17883	17883	17884
6090	4713	0	applied	\N	\N	\N	\N	17892	17892	17893
6090	4714	1	applied	\N	\N	\N	\N	17896	17896	17897
6091	4714	0	applied	\N	\N	\N	\N	17896	17896	17897
6091	4715	1	applied	\N	\N	\N	\N	17900	17900	17901
6091	4716	2	applied	\N	\N	\N	\N	17902	17902	17903
6093	4714	0	applied	\N	\N	\N	\N	17896	17896	17897
6093	4715	1	applied	\N	\N	\N	\N	17900	17900	17901
6093	4716	2	applied	\N	\N	\N	\N	17902	17902	17903
6096	4720	0	applied	\N	\N	\N	\N	17919	17919	17920
6096	4721	1	applied	\N	\N	\N	\N	17921	17921	17922
6101	4724	0	applied	\N	\N	\N	\N	17934	17934	17935
5996	4633	2	applied	\N	\N	\N	\N	17610	17610	17611
5996	4634	3	applied	\N	\N	\N	\N	17612	17612	17613
5996	4635	4	applied	\N	\N	\N	\N	17614	17614	17615
5999	4637	0	applied	\N	\N	\N	\N	17623	17623	17624
6166	4761	0	applied	\N	\N	\N	\N	18076	18076	18077
5999	4638	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	14319	14319	\N
5999	4639	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	17625	17625	\N
5999	4640	3	applied	\N	\N	\N	\N	17626	17626	17627
6001	4641	0	applied	\N	\N	\N	\N	17631	17631	17632
6003	4641	0	applied	\N	\N	\N	\N	17631	17631	17632
6013	4648	0	applied	\N	\N	\N	\N	17660	17660	17661
6017	4649	0	applied	\N	\N	\N	\N	17668	17668	17669
6023	4655	0	applied	\N	\N	\N	\N	17687	17687	17688
6023	4656	1	applied	\N	\N	\N	\N	17689	17689	17690
6026	4662	0	applied	\N	\N	\N	\N	17706	17706	17707
6031	4666	0	applied	\N	\N	\N	\N	17722	17722	17723
6031	4667	1	applied	\N	\N	\N	\N	17724	17724	17725
6031	4668	2	applied	\N	\N	1000000000	\N	17726	17726	17727
6034	4670	0	applied	\N	\N	\N	\N	17732	17732	17733
6036	4674	0	applied	\N	\N	\N	\N	17744	17744	17745
6041	4680	0	applied	\N	\N	\N	\N	17762	17762	17746
6041	4681	1	applied	\N	\N	\N	\N	17763	17763	17764
6044	4685	0	applied	\N	\N	\N	\N	17775	17775	17776
6046	4686	0	applied	\N	\N	\N	\N	17779	17779	17780
6049	4688	0	applied	\N	\N	\N	\N	17789	17789	17790
6049	4689	1	applied	\N	\N	\N	\N	17791	17791	17792
6051	4638	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	14319	14319	\N
6051	4639	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	17625	17625	\N
6051	4652	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	17681	17681	\N
6051	4668	3	applied	\N	\N	1000000000	\N	17726	17726	17727
6051	4661	4	applied	\N	\N	1000000000	\N	17703	17703	17704
6051	4666	5	applied	\N	\N	\N	\N	17722	17722	17723
6051	4677	6	applied	\N	\N	\N	\N	17752	17752	17794
6056	4692	0	applied	\N	\N	\N	\N	17805	17805	17806
6061	4695	0	applied	\N	\N	\N	\N	17816	17816	17817
6061	4696	1	applied	\N	\N	\N	\N	17818	17818	17819
6063	4697	0	applied	\N	\N	\N	\N	17825	17825	17826
6065	4698	0	applied	\N	\N	\N	\N	17829	17829	17830
6066	4699	0	applied	\N	\N	\N	\N	17833	17833	17834
6066	4700	1	applied	\N	\N	\N	\N	17835	17835	17836
6066	4701	2	applied	\N	\N	\N	\N	17837	17837	17838
6073	4705	0	applied	\N	\N	\N	\N	17855	17855	17856
6076	4707	0	applied	\N	\N	\N	\N	17860	17860	17861
6076	4708	1	applied	\N	\N	\N	\N	17862	17862	17863
6078	4707	0	applied	\N	\N	\N	\N	17860	17860	17861
6078	4708	1	applied	\N	\N	\N	\N	17862	17862	17863
6080	4709	0	applied	\N	\N	\N	\N	17870	17870	17871
6087	4712	0	applied	\N	\N	\N	\N	17887	17887	17888
6089	4713	0	applied	\N	\N	\N	\N	17892	17892	17893
6095	4717	0	applied	\N	\N	\N	\N	17909	17909	17910
6095	4718	1	applied	\N	\N	\N	\N	17911	17911	17912
6095	4719	2	applied	\N	\N	\N	\N	17913	17913	17914
6098	4722	0	applied	\N	\N	\N	\N	17925	17925	17926
6098	4723	1	applied	\N	\N	\N	\N	17927	17927	17928
6100	4724	0	applied	\N	\N	\N	\N	17934	17934	17935
6102	4725	0	applied	\N	\N	\N	\N	17938	17938	17939
6104	4725	0	applied	\N	\N	\N	\N	17938	17938	17939
6106	4725	0	applied	\N	\N	\N	\N	17938	17938	17939
6107	4726	0	applied	\N	\N	1000000000	\N	17947	17947	17948
6107	4727	1	applied	\N	\N	1000000000	\N	17949	17949	17950
6107	4728	2	applied	\N	\N	\N	\N	17951	17951	17952
6107	4729	3	applied	\N	\N	\N	\N	17953	17953	17954
6108	4726	0	applied	\N	\N	1000000000	\N	17947	17947	17948
6108	4727	1	applied	\N	\N	1000000000	\N	17949	17949	17950
6108	4728	2	applied	\N	\N	\N	\N	17951	17951	17952
6108	4729	3	applied	\N	\N	\N	\N	17953	17953	17954
6109	4726	0	applied	\N	\N	1000000000	\N	17947	17947	17948
6109	4727	1	applied	\N	\N	1000000000	\N	17949	17949	17950
6109	4728	2	applied	\N	\N	\N	\N	17951	17951	17952
6109	4729	3	applied	\N	\N	\N	\N	17953	17953	17954
6110	4730	0	applied	\N	\N	\N	\N	17960	17960	17961
6111	4730	0	applied	\N	\N	\N	\N	17960	17960	17961
6112	4730	0	applied	\N	\N	\N	\N	17960	17960	17961
6113	4731	0	applied	\N	\N	\N	\N	17964	17964	17965
6114	4731	0	applied	\N	\N	\N	\N	17964	17964	17965
6115	4732	0	applied	\N	\N	\N	\N	17968	17968	17969
6116	4732	0	applied	\N	\N	\N	\N	17968	17968	17969
6118	4733	0	applied	\N	\N	\N	\N	17971	17971	17972
6118	4734	1	applied	\N	\N	\N	\N	17973	17973	17974
6118	4735	2	applied	\N	\N	\N	\N	17975	17975	17976
6119	4736	0	applied	\N	\N	\N	\N	17978	17978	17979
6120	4736	0	applied	\N	\N	\N	\N	17978	17978	17979
6121	4736	0	applied	\N	\N	\N	\N	17978	17978	17979
6122	4737	0	applied	\N	\N	\N	\N	17981	17981	17982
6123	4738	0	applied	\N	\N	1000000000	\N	17985	17985	17986
6123	4739	1	applied	\N	\N	\N	\N	17987	17987	17988
6125	4740	0	applied	\N	\N	\N	\N	17992	17992	17993
6125	4741	1	applied	\N	\N	\N	\N	17994	17994	17995
6125	4742	2	applied	\N	\N	\N	\N	17996	17996	17997
6126	4743	0	applied	\N	\N	\N	\N	17999	17999	18000
6127	4743	0	applied	\N	\N	\N	\N	17999	17999	18000
6128	4743	0	applied	\N	\N	\N	\N	17999	17999	18000
6129	4744	0	applied	\N	\N	\N	\N	18005	18005	18006
6130	4744	0	applied	\N	\N	\N	\N	18005	18005	18006
6131	4744	0	applied	\N	\N	\N	\N	18005	18005	18006
6131	4745	1	applied	\N	\N	\N	\N	18009	18009	18010
6132	4744	0	applied	\N	\N	\N	\N	18005	18005	18006
6133	4745	0	applied	\N	\N	\N	\N	18009	18009	18010
6134	4745	0	applied	\N	\N	\N	\N	18009	18009	18010
6135	4746	0	applied	\N	\N	\N	\N	18013	18013	18014
6136	4747	0	applied	\N	\N	\N	\N	18015	18015	18016
6137	4747	0	applied	\N	\N	\N	\N	18015	18015	18016
6138	4747	0	applied	\N	\N	\N	\N	18015	18015	18016
6139	4748	0	applied	\N	\N	\N	\N	18023	18023	18024
6140	4749	0	applied	\N	\N	\N	\N	18025	18025	18026
6141	4749	0	applied	\N	\N	\N	\N	18025	18025	18026
6142	4749	0	applied	\N	\N	\N	\N	18025	18025	18026
6144	4750	0	applied	\N	\N	\N	\N	18031	18031	18032
6145	4750	0	applied	\N	\N	\N	\N	18031	18031	18032
6150	4751	0	applied	\N	\N	\N	\N	18037	18037	18038
6150	4752	1	applied	\N	\N	\N	\N	18039	18039	18040
6151	4753	0	applied	\N	\N	\N	\N	18042	18042	18043
6152	4753	0	applied	\N	\N	\N	\N	18042	18042	18043
6153	4754	0	applied	\N	\N	\N	\N	18046	18046	18047
6154	4754	0	applied	\N	\N	\N	\N	18046	18046	18047
6155	4754	0	applied	\N	\N	\N	\N	18046	18046	18047
6156	4755	0	applied	\N	\N	\N	\N	18052	18052	18053
6157	4755	0	applied	\N	\N	\N	\N	18052	18052	18053
6159	4756	0	applied	\N	\N	\N	\N	18056	18056	18057
6162	4757	0	applied	\N	\N	\N	\N	18060	18060	18061
6164	4761	0	applied	\N	\N	\N	\N	18076	18076	18077
6169	4762	0	applied	\N	\N	\N	\N	18084	18084	18085
6174	4765	0	applied	\N	\N	\N	\N	18099	18099	18100
6174	4766	1	applied	\N	\N	\N	\N	18101	18101	18102
6174	4767	2	applied	\N	\N	\N	\N	18103	18103	18104
6174	4768	3	applied	\N	\N	\N	\N	18105	18105	18106
6176	4769	0	applied	\N	\N	\N	\N	18111	18111	18112
6177	4770	0	applied	\N	\N	\N	\N	18115	18115	18116
6177	4771	1	applied	\N	\N	\N	\N	18117	18117	18118
6177	4772	2	applied	\N	\N	\N	\N	18119	18119	18120
6177	4773	3	applied	\N	\N	\N	\N	18121	18121	18122
6177	4774	4	applied	\N	\N	\N	\N	18123	18123	18124
6182	4776	0	applied	\N	\N	\N	\N	18134	18134	18135
6182	4777	1	applied	\N	\N	\N	\N	18136	18136	18137
6184	4776	0	applied	\N	\N	\N	\N	18134	18134	18135
6184	4777	1	applied	\N	\N	\N	\N	18136	18136	18137
6187	4783	0	applied	\N	\N	\N	\N	18156	18156	1435
6187	4784	1	applied	\N	\N	\N	\N	18157	18157	18158
6187	4785	2	applied	\N	\N	\N	\N	18159	18159	18160
6189	4786	0	applied	\N	\N	\N	\N	18164	18164	18165
6194	4790	0	applied	\N	\N	\N	\N	18177	18177	18178
6197	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6206	4803	0	applied	\N	\N	\N	\N	18213	18213	18214
6206	4804	1	applied	\N	\N	\N	\N	18215	18215	18216
6210	4806	0	applied	\N	\N	\N	\N	18225	18225	18226
6213	4807	0	applied	\N	\N	\N	\N	18231	18231	18145
6213	4808	1	applied	\N	\N	\N	\N	18232	18232	18233
6213	4809	2	applied	\N	\N	\N	\N	18234	18234	18235
6213	4810	3	applied	\N	\N	\N	\N	18236	18236	18237
6215	4811	0	applied	\N	\N	\N	\N	18243	18243	18244
6220	4815	0	applied	\N	\N	\N	\N	18254	18254	18255
6223	4822	0	applied	\N	\N	\N	\N	18277	18277	18278
6226	4822	0	applied	\N	\N	\N	\N	18277	18277	18278
6236	4830	0	applied	\N	\N	\N	\N	18309	18309	18310
6236	4831	1	applied	\N	\N	\N	\N	18311	18311	18312
6240	4832	0	applied	\N	\N	\N	\N	18319	18319	18320
6240	4833	1	applied	\N	\N	\N	\N	18321	18321	18322
6243	4835	0	applied	\N	\N	\N	\N	18329	18329	18330
6243	4836	1	applied	\N	\N	\N	\N	18331	18331	18332
6245	4837	0	applied	\N	\N	\N	\N	18335	18335	18336
6247	4839	0	applied	\N	\N	\N	\N	18345	18345	18346
6253	4847	0	applied	\N	\N	\N	\N	18369	18369	18370
6255	4848	0	applied	\N	\N	\N	\N	18372	18372	18373
6255	4849	1	applied	\N	\N	\N	\N	18374	18374	18375
6256	4850	0	applied	\N	\N	\N	\N	18378	18378	18379
6256	4851	1	applied	\N	\N	\N	\N	18380	18380	18381
6256	4852	2	applied	\N	\N	\N	\N	18382	18382	18383
6256	4853	3	applied	\N	\N	\N	\N	18384	18384	18385
6266	4861	0	applied	\N	\N	\N	\N	18414	18414	18415
6266	4862	1	applied	\N	\N	\N	\N	18416	18416	18417
6269	4866	0	applied	\N	\N	\N	\N	18430	18430	18431
6270	4867	0	applied	\N	\N	\N	\N	18434	18434	18435
6270	4868	1	applied	\N	\N	\N	\N	18436	18436	18437
6270	4869	2	applied	\N	\N	\N	\N	18438	18438	18439
6271	4870	0	applied	\N	\N	\N	\N	18442	18442	18443
6271	4871	1	applied	\N	\N	\N	\N	18444	18444	18445
6271	4872	2	applied	\N	\N	\N	\N	18446	18446	18447
6271	4873	3	applied	\N	\N	\N	\N	18448	18448	18449
6278	4874	0	applied	\N	\N	\N	\N	18456	18456	18457
6284	4877	0	applied	\N	\N	\N	\N	18473	18473	18474
6289	4881	0	applied	\N	\N	\N	\N	18489	18489	18490
6289	4882	1	applied	\N	\N	\N	\N	18491	18491	18492
6295	4884	0	applied	\N	\N	\N	\N	18498	18498	18499
6296	4885	0	applied	\N	\N	\N	\N	18509	18509	18510
6299	4885	0	applied	\N	\N	\N	\N	18509	18509	18510
6305	4889	0	applied	\N	\N	\N	\N	18531	18531	18532
6310	4895	0	applied	\N	\N	\N	\N	18549	18549	18550
6318	4903	0	applied	\N	\N	\N	\N	18576	18576	18577
6320	4903	0	applied	\N	\N	\N	\N	18576	18576	18577
6322	4904	0	applied	\N	\N	\N	\N	18584	18584	18585
6325	4905	0	applied	\N	\N	\N	\N	18590	18590	18591
6327	4907	0	applied	\N	\N	\N	\N	18598	18598	18599
6329	4908	0	applied	\N	\N	\N	\N	18600	18600	18601
6330	4909	0	applied	\N	\N	\N	\N	18602	18602	18603
6330	4910	1	applied	\N	\N	\N	\N	18604	18604	18605
6330	4911	2	applied	\N	\N	\N	\N	18606	18606	18607
6335	4913	0	applied	\N	\N	\N	\N	18614	18614	18615
6339	4778	0	applied	\N	\N	1000000000	\N	18142	18142	18143
6339	4542	1	applied	\N	\N	1000000000	\N	17255	17255	17256
6339	4543	2	applied	\N	\N	1000000000	\N	17257	17257	17258
6339	4726	3	applied	\N	\N	1000000000	\N	17947	17947	17948
6339	4779	4	applied	\N	\N	\N	\N	18144	18144	18145
6339	4544	5	applied	\N	\N	1000000000	\N	17259	17259	17260
6339	4738	6	applied	\N	\N	1000000000	\N	17985	17985	17986
6339	4816	7	applied	\N	\N	1000000000	\N	18262	18262	18263
6339	4890	8	applied	\N	\N	1000000000	\N	18535	18535	18536
6339	4891	9	applied	\N	\N	1000000000	\N	18537	18537	18538
6339	4783	10	applied	\N	\N	\N	\N	18156	18156	1435
6339	4784	11	applied	\N	\N	\N	\N	18157	18157	18158
6339	4787	12	applied	\N	\N	\N	\N	18169	18169	18170
6339	4807	13	applied	\N	\N	\N	\N	18231	18231	18145
6339	4813	14	applied	\N	\N	\N	\N	18248	18248	18248
6339	4539	15	applied	\N	\N	\N	\N	17246	17246	17247
6339	4727	16	applied	\N	\N	1000000000	\N	18304	18304	17950
6339	4638	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	14319	14319	\N
6339	4639	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	17625	17625	\N
6339	4602	19	applied	\N	\N	\N	\N	17497	17497	17498
6339	4652	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	17681	17681	\N
6339	4668	21	applied	\N	\N	1000000000	\N	17726	17726	17727
6339	4540	22	applied	\N	\N	\N	\N	17248	17248	17249
6339	4541	23	applied	\N	\N	\N	\N	17252	17252	17253
6339	4545	24	applied	\N	\N	\N	\N	17263	17263	17264
6339	4661	25	applied	\N	\N	1000000000	\N	17703	17703	17704
6339	4666	26	applied	\N	\N	\N	\N	17722	17722	17723
6339	4677	27	applied	\N	\N	\N	\N	17752	17752	17794
6339	4546	28	applied	\N	\N	\N	\N	17265	17265	17266
6339	4547	29	applied	\N	\N	\N	\N	17267	17267	17268
6339	4548	30	applied	\N	\N	\N	\N	17269	17269	17270
6339	4549	31	applied	\N	\N	\N	\N	17271	17271	17272
6339	4550	32	applied	\N	\N	\N	\N	17278	17278	17279
6339	4551	33	applied	\N	\N	\N	\N	17284	17284	17285
6339	4552	34	applied	\N	\N	\N	\N	17286	17286	17287
6339	4553	35	applied	\N	\N	\N	\N	17288	17288	17289
6158	4756	0	applied	\N	\N	\N	\N	18056	18056	18057
6163	4758	0	applied	\N	\N	\N	\N	18068	18068	18069
6163	4759	1	applied	\N	\N	\N	\N	18070	18070	18071
6163	4760	2	applied	\N	\N	\N	\N	18072	18072	18073
6168	4762	0	applied	\N	\N	\N	\N	18084	18084	18085
6170	4763	0	applied	\N	\N	\N	\N	18090	18090	18091
6172	4764	0	applied	\N	\N	\N	\N	18095	18095	18096
6173	4765	0	applied	\N	\N	\N	\N	18099	18099	18100
6173	4766	1	applied	\N	\N	\N	\N	18101	18101	18102
6173	4767	2	applied	\N	\N	\N	\N	18103	18103	18104
6173	4768	3	applied	\N	\N	\N	\N	18105	18105	18106
6179	4770	0	applied	\N	\N	\N	\N	18115	18115	18116
6179	4771	1	applied	\N	\N	\N	\N	18117	18117	18118
6179	4772	2	applied	\N	\N	\N	\N	18119	18119	18120
6179	4773	3	applied	\N	\N	\N	\N	18121	18121	18122
6179	4774	4	applied	\N	\N	\N	\N	18123	18123	18124
6181	4775	0	applied	\N	\N	\N	\N	18130	18130	18131
6186	4782	0	applied	\N	\N	\N	\N	18152	18152	18153
6188	4783	0	applied	\N	\N	\N	\N	18156	18156	1435
6188	4784	1	applied	\N	\N	\N	\N	18157	18157	18158
6188	4785	2	applied	\N	\N	\N	\N	18159	18159	18160
6190	4786	0	applied	\N	\N	\N	\N	18164	18164	18165
6198	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6203	4792	0	applied	\N	\N	\N	\N	18186	18186	18187
6203	4793	1	applied	\N	\N	\N	\N	18188	18188	18189
6203	4794	2	applied	\N	\N	\N	\N	18190	18190	18191
6203	4795	3	applied	\N	\N	\N	\N	18192	18192	18193
6203	4796	4	applied	\N	\N	\N	\N	18194	18194	18195
6203	4797	5	applied	\N	\N	\N	\N	18196	18196	18197
6203	4798	6	applied	\N	\N	\N	\N	18198	18198	18199
6203	4799	7	applied	\N	\N	\N	\N	18200	18200	18201
6203	4800	8	applied	\N	\N	\N	\N	18202	18202	18203
6203	4801	9	applied	\N	\N	\N	\N	18204	18204	18205
6207	4803	0	applied	\N	\N	\N	\N	18213	18213	18214
6207	4804	1	applied	\N	\N	\N	\N	18215	18215	18216
6208	4805	0	applied	\N	\N	\N	\N	18221	18221	18222
6218	4815	0	applied	\N	\N	\N	\N	18254	18254	18255
6224	4822	0	applied	\N	\N	\N	\N	18277	18277	18278
6228	4812	0	applied	\N	\N	\N	\N	18247	18247	18144
6228	4816	1	applied	\N	\N	1000000000	\N	18262	18262	18263
6228	4807	2	applied	\N	\N	\N	\N	18231	18231	18247
6228	4813	3	applied	\N	\N	\N	\N	18248	18248	18248
6228	4805	4	applied	\N	\N	\N	\N	18221	18221	18222
6228	4806	5	applied	\N	\N	\N	\N	18225	18225	18226
6228	4808	6	applied	\N	\N	\N	\N	18232	18232	18233
6228	4809	7	applied	\N	\N	\N	\N	18234	18234	18235
6228	4810	8	applied	\N	\N	\N	\N	18236	18236	18237
6228	4811	9	applied	\N	\N	\N	\N	18243	18243	18244
6228	4814	10	applied	\N	\N	\N	\N	18249	18249	18250
6228	4815	11	applied	\N	\N	\N	\N	18254	18254	18255
6228	4817	12	applied	\N	\N	\N	\N	18264	18264	18265
6228	4818	13	applied	\N	\N	\N	\N	18266	18266	18267
6228	4819	14	applied	\N	\N	\N	\N	18268	18268	18269
6228	4820	15	applied	\N	\N	\N	\N	18271	18271	18272
6228	4821	16	applied	\N	\N	\N	\N	18273	18273	18274
6228	4822	17	applied	\N	\N	\N	\N	18277	18277	18278
6228	4823	18	applied	\N	\N	\N	\N	18285	18285	18286
6228	4824	19	applied	\N	\N	\N	\N	18287	18287	18288
6231	4826	0	applied	\N	\N	\N	\N	18295	18295	18296
6231	4827	1	applied	\N	\N	\N	\N	18297	18297	18298
6231	4828	2	applied	\N	\N	\N	\N	18299	18299	18300
6233	4829	0	applied	\N	\N	\N	\N	18307	18307	18308
6248	4839	0	applied	\N	\N	\N	\N	18345	18345	18346
6250	4840	0	applied	\N	\N	\N	\N	18349	18349	18350
6250	4841	1	applied	\N	\N	\N	\N	18351	18351	18352
6259	4856	0	applied	\N	\N	\N	\N	18396	18396	18397
6260	4857	0	applied	\N	\N	\N	\N	18400	18400	18401
6260	4858	1	applied	\N	\N	\N	\N	18402	18402	18403
6262	4859	0	applied	\N	\N	\N	\N	18406	18406	18407
6264	4860	0	applied	\N	\N	\N	\N	18410	18410	18411
6267	4863	0	applied	\N	\N	\N	\N	18420	18420	18421
6272	4870	0	applied	\N	\N	\N	\N	18442	18442	18443
6272	4871	1	applied	\N	\N	\N	\N	18444	18444	18445
6272	4872	2	applied	\N	\N	\N	\N	18446	18446	18447
6272	4873	3	applied	\N	\N	\N	\N	18448	18448	18449
6280	4876	0	applied	\N	\N	\N	\N	18466	18466	18467
6282	4876	0	applied	\N	\N	\N	\N	18466	18466	18467
6287	4880	0	applied	\N	\N	\N	\N	18486	18486	18487
6290	4883	0	applied	\N	\N	\N	\N	18495	18495	18496
6292	4884	0	applied	\N	\N	\N	\N	18498	18498	18499
6300	4885	0	applied	\N	\N	\N	\N	18509	18509	18510
6306	4890	0	applied	\N	\N	1000000000	\N	18535	18535	18536
6306	4891	1	applied	\N	\N	1000000000	\N	18537	18537	18538
6306	4892	2	applied	\N	\N	\N	\N	18539	18539	18540
6306	4893	3	applied	\N	\N	\N	\N	18541	18541	18542
6306	4894	4	applied	\N	\N	\N	\N	18543	18543	18544
6308	4890	0	applied	\N	\N	1000000000	\N	18535	18535	18536
6308	4891	1	applied	\N	\N	1000000000	\N	18537	18537	18538
6308	4892	2	applied	\N	\N	\N	\N	18539	18539	18540
6308	4893	3	applied	\N	\N	\N	\N	18541	18541	18542
6308	4894	4	applied	\N	\N	\N	\N	18543	18543	18544
6311	4896	0	applied	\N	\N	\N	\N	18553	18553	18554
6311	4897	1	applied	\N	\N	\N	\N	18555	18555	18556
6313	4898	0	applied	\N	\N	\N	\N	18559	18559	18560
6314	4899	0	applied	\N	\N	\N	\N	18563	18563	18564
6314	4900	1	applied	\N	\N	\N	\N	18565	18565	18566
6314	4901	2	applied	\N	\N	\N	\N	18567	18567	18568
6316	4902	0	applied	\N	\N	\N	\N	18572	18572	18573
6319	4903	0	applied	\N	\N	\N	\N	18576	18576	18577
6323	4904	0	applied	\N	\N	\N	\N	18584	18584	18585
6333	4912	0	applied	\N	\N	\N	\N	18610	18610	18611
6337	4914	0	applied	\N	\N	\N	\N	18618	18618	18619
6344	4919	0	applied	\N	\N	\N	\N	18697	18697	18698
6347	4919	0	applied	\N	\N	\N	\N	18697	18697	18698
6348	4920	0	applied	\N	\N	\N	\N	18829	18829	18830
6351	4922	0	applied	\N	\N	\N	\N	18836	18836	18837
6351	4923	1	applied	\N	\N	\N	\N	18838	18838	18839
6353	4922	0	applied	\N	\N	\N	\N	18836	18836	18837
6353	4923	1	applied	\N	\N	\N	\N	18838	18838	18839
6356	4927	0	applied	\N	\N	\N	\N	18856	18856	18857
6356	4928	1	applied	\N	\N	\N	\N	18858	18858	18859
6359	4932	0	applied	\N	\N	\N	\N	18871	18871	18872
6362	4935	0	applied	\N	\N	\N	\N	18882	18882	18883
6369	4939	0	applied	\N	\N	\N	\N	18899	18899	18900
6376	4947	0	applied	\N	\N	\N	\N	18922	18922	18923
6377	4948	0	applied	\N	\N	\N	\N	18930	18930	18931
6380	4951	0	applied	\N	\N	1000000000	\N	18939	18939	18940
6380	4952	1	applied	\N	\N	\N	\N	18941	18941	18942
6380	4953	2	applied	\N	\N	\N	\N	18943	18943	18944
6160	4757	0	applied	\N	\N	\N	\N	18060	18060	18061
6167	4762	0	applied	\N	\N	\N	\N	18084	18084	18085
6178	4770	0	applied	\N	\N	\N	\N	18115	18115	18116
6178	4771	1	applied	\N	\N	\N	\N	18117	18117	18118
6178	4772	2	applied	\N	\N	\N	\N	18119	18119	18120
6178	4773	3	applied	\N	\N	\N	\N	18121	18121	18122
6178	4774	4	applied	\N	\N	\N	\N	18123	18123	18124
6191	4786	0	applied	\N	\N	\N	\N	18164	18164	18165
6192	4786	0	applied	\N	\N	\N	\N	18164	18164	18165
6195	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6200	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6204	4802	0	applied	\N	\N	\N	\N	18211	18211	18212
6209	4806	0	applied	\N	\N	\N	\N	18225	18225	18226
6211	4806	0	applied	\N	\N	\N	\N	18225	18225	18226
6214	4807	0	applied	\N	\N	\N	\N	18231	18231	18145
6214	4808	1	applied	\N	\N	\N	\N	18232	18232	18233
6214	4809	2	applied	\N	\N	\N	\N	18234	18234	18235
6214	4810	3	applied	\N	\N	\N	\N	18236	18236	18237
6216	4812	0	applied	\N	\N	\N	\N	18247	18247	18231
6216	4813	1	applied	\N	\N	\N	\N	18248	18248	18248
6216	4814	2	applied	\N	\N	\N	\N	18249	18249	18250
6219	4815	0	applied	\N	\N	\N	\N	18254	18254	18255
6221	4816	0	applied	\N	\N	1000000000	\N	18262	18262	18263
6221	4817	1	applied	\N	\N	\N	\N	18264	18264	18265
6221	4818	2	applied	\N	\N	\N	\N	18266	18266	18267
6221	4819	3	applied	\N	\N	\N	\N	18268	18268	18269
6225	4822	0	applied	\N	\N	\N	\N	18277	18277	18278
6232	4778	0	applied	\N	\N	1000000000	\N	18142	18142	18143
6232	4738	1	applied	\N	\N	1000000000	\N	17985	17985	17986
6232	4816	2	applied	\N	\N	1000000000	\N	18262	18262	18263
6232	4726	3	applied	\N	\N	1000000000	\N	17947	17947	17948
6232	4779	4	applied	\N	\N	\N	\N	18144	18144	18145
6232	4783	5	applied	\N	\N	\N	\N	18156	18156	1435
6232	4784	6	applied	\N	\N	\N	\N	18157	18157	18158
6232	4787	7	applied	\N	\N	\N	\N	18169	18169	18170
6232	4807	8	applied	\N	\N	\N	\N	18231	18231	18145
6232	4813	9	applied	\N	\N	\N	\N	18248	18248	18248
6232	4727	10	applied	\N	\N	1000000000	\N	18304	18304	17950
6234	4830	0	applied	\N	\N	\N	\N	18309	18309	18310
6234	4831	1	applied	\N	\N	\N	\N	18311	18311	18312
6237	4830	0	applied	\N	\N	\N	\N	18309	18309	18310
6237	4831	1	applied	\N	\N	\N	\N	18311	18311	18312
6241	4834	0	applied	\N	\N	\N	\N	18327	18327	18328
6246	4838	0	applied	\N	\N	\N	\N	18341	18341	18342
6251	4842	0	applied	\N	\N	\N	\N	18357	18357	18358
6254	4848	0	applied	\N	\N	\N	\N	18372	18372	18373
6254	4849	1	applied	\N	\N	\N	\N	18374	18374	18375
6257	4854	0	applied	\N	\N	\N	\N	18388	18388	18389
6263	4859	0	applied	\N	\N	\N	\N	18406	18406	18407
6265	4861	0	applied	\N	\N	\N	\N	18414	18414	18415
6265	4862	1	applied	\N	\N	\N	\N	18416	18416	18417
6268	4864	0	applied	\N	\N	\N	\N	18424	18424	18425
6268	4865	1	applied	\N	\N	\N	\N	18426	18426	18427
6273	4870	0	applied	\N	\N	\N	\N	18442	18442	18443
6273	4871	1	applied	\N	\N	\N	\N	18444	18444	18445
6273	4872	2	applied	\N	\N	\N	\N	18446	18446	18447
6273	4873	3	applied	\N	\N	\N	\N	18448	18448	18449
6275	4870	0	applied	\N	\N	\N	\N	18442	18442	18443
6275	4871	1	applied	\N	\N	\N	\N	18444	18444	18445
6275	4872	2	applied	\N	\N	\N	\N	18446	18446	18447
6275	4873	3	applied	\N	\N	\N	\N	18448	18448	18449
6276	4874	0	applied	\N	\N	\N	\N	18456	18456	18457
6281	4876	0	applied	\N	\N	\N	\N	18466	18466	18467
6283	4877	0	applied	\N	\N	\N	\N	18473	18473	18474
6285	4878	0	applied	\N	\N	\N	\N	18479	18479	18480
6293	4884	0	applied	\N	\N	\N	\N	18498	18498	18499
6297	4885	0	applied	\N	\N	\N	\N	18509	18509	18510
6301	4886	0	applied	\N	\N	\N	\N	18518	18518	18519
6303	4846	0	applied	\N	\N	1000000000	\N	18366	18366	18367
6309	4895	0	applied	\N	\N	\N	\N	18549	18549	18550
6317	4902	0	applied	\N	\N	\N	\N	18572	18572	18573
6321	4904	0	applied	\N	\N	\N	\N	18584	18584	18585
6328	4907	0	applied	\N	\N	\N	\N	18598	18598	18599
6331	4912	0	applied	\N	\N	\N	\N	18610	18610	18611
6336	4913	0	applied	\N	\N	\N	\N	18614	18614	18615
6338	4915	0	applied	\N	\N	\N	\N	18622	18622	18623
6338	4916	1	applied	\N	\N	\N	\N	18624	18624	18625
6340	4917	0	applied	\N	\N	\N	\N	18693	18693	18694
6342	4917	0	applied	\N	\N	\N	\N	18693	18693	18694
6349	4920	0	applied	\N	\N	\N	\N	18829	18829	18830
6354	4924	0	applied	\N	\N	\N	\N	18846	18846	18847
6354	4925	1	applied	\N	\N	\N	\N	18848	18848	18849
6354	4926	2	applied	\N	\N	\N	\N	18850	18850	18851
6357	4929	0	applied	\N	\N	\N	\N	18862	18862	18863
6360	4778	0	applied	\N	\N	1000000000	\N	18142	18142	18143
6360	4816	1	applied	\N	\N	1000000000	\N	18262	18262	18263
6360	4779	2	applied	\N	\N	\N	\N	18144	18144	18145
6360	4890	3	applied	\N	\N	1000000000	\N	18535	18535	18536
6360	4891	4	applied	\N	\N	1000000000	\N	18537	18537	18538
6360	4783	5	applied	\N	\N	\N	\N	18156	18156	1435
6360	4784	6	applied	\N	\N	\N	\N	18157	18157	18158
6360	4787	7	applied	\N	\N	\N	\N	18169	18169	18170
6360	4807	8	applied	\N	\N	\N	\N	18231	18231	18145
6360	4813	9	applied	\N	\N	\N	\N	18248	18248	18248
6360	4846	10	applied	\N	\N	1000000000	\N	18366	18366	18367
6365	4937	0	applied	\N	\N	\N	\N	18890	18890	18891
6367	4938	0	applied	\N	\N	\N	\N	18895	18895	18896
6370	4940	0	applied	\N	\N	\N	\N	18903	18903	18904
6370	4941	1	applied	\N	\N	\N	\N	18905	18905	18906
6370	4942	2	applied	\N	\N	\N	\N	18907	18907	18908
6373	4944	0	applied	\N	\N	\N	\N	18913	18913	18914
6373	4945	1	applied	\N	\N	\N	\N	18915	18915	18916
6373	4946	2	applied	\N	\N	\N	\N	18917	18917	18918
6383	4955	0	applied	\N	\N	\N	\N	18948	18948	18949
6388	4959	0	applied	\N	\N	\N	\N	18964	18964	18965
6388	4960	1	applied	\N	\N	\N	\N	18966	18966	18967
6393	4963	0	applied	\N	\N	\N	\N	18981	18981	18982
6393	4964	1	applied	\N	\N	\N	\N	18983	18983	18984
6402	4968	0	applied	\N	\N	\N	\N	19004	19004	19005
6403	4969	0	applied	\N	\N	\N	\N	19006	19006	19007
6403	4970	1	applied	\N	\N	\N	\N	19008	19008	19009
6403	4971	2	applied	\N	\N	\N	\N	19010	19010	19011
6403	4972	3	applied	\N	\N	\N	\N	19012	19012	19013
6406	4973	0	applied	\N	\N	\N	\N	19018	19018	19019
6406	4974	1	applied	\N	\N	\N	\N	19020	19020	19021
6406	4975	2	applied	\N	\N	\N	\N	19022	19022	19023
6410	4981	0	applied	\N	\N	\N	\N	19042	19042	19043
6410	4982	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19044	19044	\N
6161	4757	0	applied	\N	\N	\N	\N	18060	18060	18061
6165	4761	0	applied	\N	\N	\N	\N	18076	18076	18077
6171	4763	0	applied	\N	\N	\N	\N	18090	18090	18091
6175	4765	0	applied	\N	\N	\N	\N	18099	18099	18100
6175	4766	1	applied	\N	\N	\N	\N	18101	18101	18102
6175	4767	2	applied	\N	\N	\N	\N	18103	18103	18104
6175	4768	3	applied	\N	\N	\N	\N	18105	18105	18106
6180	4775	0	applied	\N	\N	\N	\N	18130	18130	18131
6183	4776	0	applied	\N	\N	\N	\N	18134	18134	18135
6183	4777	1	applied	\N	\N	\N	\N	18136	18136	18137
6185	4778	0	applied	\N	\N	1000000000	\N	18142	18142	18143
6185	4779	1	applied	\N	\N	\N	\N	18144	18144	18145
6185	4780	2	applied	\N	\N	\N	\N	18146	18146	18147
6185	4781	3	applied	\N	\N	\N	\N	18148	18148	18149
6193	4787	0	applied	\N	\N	\N	\N	18169	18169	18170
6193	4788	1	applied	\N	\N	\N	\N	18171	18171	18172
6193	4789	2	applied	\N	\N	\N	\N	18173	18173	18174
6196	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6199	4791	0	applied	\N	\N	\N	\N	18180	18180	18181
6202	4792	0	applied	\N	\N	\N	\N	18186	18186	18187
6202	4793	1	applied	\N	\N	\N	\N	18188	18188	18189
6202	4794	2	applied	\N	\N	\N	\N	18190	18190	18191
6202	4795	3	applied	\N	\N	\N	\N	18192	18192	18193
6202	4796	4	applied	\N	\N	\N	\N	18194	18194	18195
6202	4797	5	applied	\N	\N	\N	\N	18196	18196	18197
6202	4798	6	applied	\N	\N	\N	\N	18198	18198	18199
6202	4799	7	applied	\N	\N	\N	\N	18200	18200	18201
6202	4800	8	applied	\N	\N	\N	\N	18202	18202	18203
6202	4801	9	applied	\N	\N	\N	\N	18204	18204	18205
6205	4802	0	applied	\N	\N	\N	\N	18211	18211	18212
6205	4803	1	applied	\N	\N	\N	\N	18213	18213	18214
6205	4804	2	applied	\N	\N	\N	\N	18215	18215	18216
6212	4807	0	applied	\N	\N	\N	\N	18231	18231	18145
6212	4808	1	applied	\N	\N	\N	\N	18232	18232	18233
6212	4809	2	applied	\N	\N	\N	\N	18234	18234	18235
6212	4810	3	applied	\N	\N	\N	\N	18236	18236	18237
6217	4812	0	applied	\N	\N	\N	\N	18247	18247	18231
6217	4813	1	applied	\N	\N	\N	\N	18248	18248	18248
6217	4814	2	applied	\N	\N	\N	\N	18249	18249	18250
6222	4820	0	applied	\N	\N	\N	\N	18271	18271	18272
6222	4821	1	applied	\N	\N	\N	\N	18273	18273	18274
6227	4823	0	applied	\N	\N	\N	\N	18285	18285	18286
6227	4824	1	applied	\N	\N	\N	\N	18287	18287	18288
6229	4825	0	applied	\N	\N	\N	\N	18291	18291	18292
6230	4826	0	applied	\N	\N	\N	\N	18295	18295	18296
6230	4827	1	applied	\N	\N	\N	\N	18297	18297	18298
6230	4828	2	applied	\N	\N	\N	\N	18299	18299	18300
6235	4830	0	applied	\N	\N	\N	\N	18309	18309	18310
6235	4831	1	applied	\N	\N	\N	\N	18311	18311	18312
6238	4830	0	applied	\N	\N	\N	\N	18309	18309	18310
6238	4831	1	applied	\N	\N	\N	\N	18311	18311	18312
6239	4832	0	applied	\N	\N	\N	\N	18319	18319	18320
6239	4833	1	applied	\N	\N	\N	\N	18321	18321	18322
6242	4835	0	applied	\N	\N	\N	\N	18329	18329	18330
6242	4836	1	applied	\N	\N	\N	\N	18331	18331	18332
6244	4837	0	applied	\N	\N	\N	\N	18335	18335	18336
6249	4840	0	applied	\N	\N	\N	\N	18349	18349	18350
6249	4841	1	applied	\N	\N	\N	\N	18351	18351	18352
6252	4843	0	applied	\N	\N	\N	\N	18360	18360	18361
6252	4844	1	applied	\N	\N	\N	\N	18362	18362	18363
6252	4845	2	applied	\N	\N	\N	\N	18364	18364	18365
6252	4846	3	applied	\N	\N	1000000000	\N	18366	18366	18367
6258	4855	0	applied	\N	\N	\N	\N	18392	18392	18393
6261	4859	0	applied	\N	\N	\N	\N	18406	18406	18407
6274	4870	0	applied	\N	\N	\N	\N	18442	18442	18443
6274	4871	1	applied	\N	\N	\N	\N	18444	18444	18445
6274	4872	2	applied	\N	\N	\N	\N	18446	18446	18447
6274	4873	3	applied	\N	\N	\N	\N	18448	18448	18449
6277	4874	0	applied	\N	\N	\N	\N	18456	18456	18457
6279	4875	0	applied	\N	\N	\N	\N	18462	18462	18463
6286	4879	0	applied	\N	\N	\N	\N	18483	18483	18484
6288	4880	0	applied	\N	\N	\N	\N	18486	18486	18487
6291	4884	0	applied	\N	\N	\N	\N	18498	18498	18499
6294	4884	0	applied	\N	\N	\N	\N	18498	18498	18499
6298	4885	0	applied	\N	\N	\N	\N	18509	18509	18510
6302	4886	0	applied	\N	\N	\N	\N	18518	18518	18519
6304	4887	0	applied	\N	\N	\N	\N	18526	18526	18527
6304	4888	1	applied	\N	\N	\N	\N	18528	18528	18529
6307	4890	0	applied	\N	\N	1000000000	\N	18535	18535	18536
6307	4891	1	applied	\N	\N	1000000000	\N	18537	18537	18538
6307	4892	2	applied	\N	\N	\N	\N	18539	18539	18540
6307	4893	3	applied	\N	\N	\N	\N	18541	18541	18542
6307	4894	4	applied	\N	\N	\N	\N	18543	18543	18544
6312	4898	0	applied	\N	\N	\N	\N	18559	18559	18560
6315	4899	0	applied	\N	\N	\N	\N	18563	18563	18564
6315	4900	1	applied	\N	\N	\N	\N	18565	18565	18566
6315	4901	2	applied	\N	\N	\N	\N	18567	18567	18568
6324	4905	0	applied	\N	\N	\N	\N	18590	18590	18591
6326	4906	0	applied	\N	\N	\N	\N	18594	18594	18595
6332	4912	0	applied	\N	\N	\N	\N	18610	18610	18611
6334	4890	0	applied	\N	\N	1000000000	\N	18535	18535	18536
6334	4891	1	applied	\N	\N	1000000000	\N	18537	18537	18538
6345	4919	0	applied	\N	\N	\N	\N	18697	18697	18698
6352	4922	0	applied	\N	\N	\N	\N	18836	18836	18837
6352	4923	1	applied	\N	\N	\N	\N	18838	18838	18839
6355	4924	0	applied	\N	\N	\N	\N	18846	18846	18847
6355	4925	1	applied	\N	\N	\N	\N	18848	18848	18849
6355	4926	2	applied	\N	\N	\N	\N	18850	18850	18851
6358	4930	0	applied	\N	\N	\N	\N	18865	18865	18866
6358	4931	1	applied	\N	\N	\N	\N	18867	18867	18868
6361	4933	0	applied	\N	\N	\N	\N	18877	18877	18878
6361	4934	1	applied	\N	\N	\N	\N	18879	18879	18880
6363	4936	0	applied	\N	\N	\N	\N	18886	18886	18887
6366	4937	0	applied	\N	\N	\N	\N	18890	18890	18891
6371	4943	0	applied	\N	\N	\N	\N	18911	18911	18912
6374	4947	0	applied	\N	\N	\N	\N	18922	18922	18923
6378	4948	0	applied	\N	\N	\N	\N	18930	18930	18931
6381	4954	0	applied	\N	\N	\N	\N	18946	18946	18947
6386	4958	0	applied	\N	\N	\N	\N	18960	18960	18961
6389	4959	0	applied	\N	\N	\N	\N	18964	18964	18965
6389	4960	1	applied	\N	\N	\N	\N	18966	18966	18967
6391	4962	0	applied	\N	\N	\N	\N	18975	18975	18976
6404	4969	0	applied	\N	\N	\N	\N	19006	19006	19007
6404	4970	1	applied	\N	\N	\N	\N	19008	19008	19009
6404	4971	2	applied	\N	\N	\N	\N	19010	19010	19011
6404	4972	3	applied	\N	\N	\N	\N	19012	19012	19013
6407	4973	0	applied	\N	\N	\N	\N	19018	19018	19019
6407	4974	1	applied	\N	\N	\N	\N	19020	19020	19021
6407	4975	2	applied	\N	\N	\N	\N	19022	19022	19023
6339	4554	36	applied	\N	\N	\N	\N	17290	17290	17291
6339	4555	37	applied	\N	\N	\N	\N	17292	17292	17293
6339	4556	38	applied	\N	\N	\N	\N	17296	17296	17390
6339	4557	39	applied	\N	\N	\N	\N	17300	17300	17391
6339	4558	40	applied	\N	\N	\N	\N	17308	17308	17392
6339	4559	41	applied	\N	\N	\N	\N	17310	17310	17393
6339	4560	42	applied	\N	\N	\N	\N	17314	17314	17394
6339	4561	43	applied	\N	\N	\N	\N	17321	17321	17395
6339	4562	44	applied	\N	\N	\N	\N	17323	17323	17396
6339	4563	45	applied	\N	\N	\N	\N	17327	17327	17397
6339	4564	46	applied	\N	\N	\N	\N	17330	17330	17398
6339	4565	47	applied	\N	\N	\N	\N	17334	17334	17399
6339	4566	48	applied	\N	\N	\N	\N	17338	17338	17400
6339	4567	49	applied	\N	\N	\N	\N	17342	17342	17401
6339	4568	50	applied	\N	\N	\N	\N	17344	17344	17402
6339	4603	51	applied	\N	\N	\N	\N	17499	17499	17500
6339	4569	52	applied	\N	\N	\N	\N	17346	17346	17403
6339	4570	53	applied	\N	\N	\N	\N	17355	17355	17404
6339	4571	54	applied	\N	\N	\N	\N	17361	17361	17405
6339	4572	55	applied	\N	\N	\N	\N	17365	17365	17406
6339	4573	56	applied	\N	\N	\N	\N	17372	17372	17407
6339	4574	57	applied	\N	\N	\N	\N	17374	17374	17408
6339	4575	59	applied	\N	\N	\N	\N	17380	17380	17409
6339	4576	60	applied	\N	\N	\N	\N	17382	17382	17410
6339	4577	61	applied	\N	\N	\N	\N	17386	17386	17411
6339	4578	62	applied	\N	\N	\N	\N	17413	17413	18627
6339	4579	63	applied	\N	\N	\N	\N	17421	17421	18628
6339	4580	64	applied	\N	\N	\N	\N	17425	17425	18629
6339	4581	65	applied	\N	\N	\N	\N	17427	17427	18630
6339	4582	66	applied	\N	\N	\N	\N	17430	17430	18631
6339	4583	67	applied	\N	\N	\N	\N	17432	17432	18632
6339	4584	68	applied	\N	\N	\N	\N	17434	17434	18633
6339	4585	69	applied	\N	\N	\N	\N	17440	17440	18634
6339	4586	70	applied	\N	\N	\N	\N	17444	17444	18635
6339	4587	71	applied	\N	\N	\N	\N	17448	17448	18636
6339	4588	72	applied	\N	\N	\N	\N	17450	17450	18637
6339	4589	73	applied	\N	\N	\N	\N	17453	17453	18638
6339	4590	74	applied	\N	\N	\N	\N	17455	17455	18639
6339	4591	75	applied	\N	\N	\N	\N	17461	17461	18640
6339	4592	76	applied	\N	\N	\N	\N	17465	17465	18641
6339	4593	77	applied	\N	\N	\N	\N	17471	17471	18642
6339	4594	78	applied	\N	\N	\N	\N	17473	17473	18643
6339	4595	79	applied	\N	\N	\N	\N	17475	17475	18644
6339	4596	80	applied	\N	\N	\N	\N	17479	17479	18645
6339	4597	81	applied	\N	\N	\N	\N	17483	17483	18646
6339	4598	82	applied	\N	\N	\N	\N	17488	17488	18647
6339	4599	83	applied	\N	\N	\N	\N	17490	17490	18648
6339	4600	84	applied	\N	\N	\N	\N	17493	17493	18649
6339	4601	85	applied	\N	\N	\N	\N	17495	17495	18650
6339	4605	86	applied	\N	\N	\N	\N	17504	17504	18651
6339	4606	87	applied	\N	\N	\N	\N	17508	17508	18652
6339	4607	88	applied	\N	\N	\N	\N	17512	17512	18653
6339	4608	89	applied	\N	\N	\N	\N	17519	17519	18654
6339	4609	90	applied	\N	\N	\N	\N	17521	17521	18655
6339	4610	91	applied	\N	\N	\N	\N	17523	17523	18656
6339	4611	92	applied	\N	\N	\N	\N	17529	17529	18657
6339	4612	93	applied	\N	\N	\N	\N	17531	17531	18658
6339	4613	94	applied	\N	\N	\N	\N	17535	17535	18659
6339	4614	95	applied	\N	\N	\N	\N	17537	17537	18660
6339	4615	96	applied	\N	\N	\N	\N	17543	17543	18661
6339	4616	97	applied	\N	\N	\N	\N	17547	17547	18662
6339	4617	98	applied	\N	\N	\N	\N	17553	17553	18663
6339	4618	99	applied	\N	\N	\N	\N	17555	17555	18664
6339	4619	100	applied	\N	\N	\N	\N	17557	17557	18665
6339	4620	101	applied	\N	\N	\N	\N	17562	17562	18666
6339	4621	102	applied	\N	\N	\N	\N	17564	17564	18667
6339	4622	103	applied	\N	\N	\N	\N	17567	17567	18668
6339	4623	104	applied	\N	\N	\N	\N	17571	17571	18669
6339	4624	105	applied	\N	\N	\N	\N	17573	17573	18670
6339	4625	106	applied	\N	\N	\N	\N	17581	17581	18671
6339	4626	107	applied	\N	\N	\N	\N	17583	17583	18672
6339	4627	108	applied	\N	\N	\N	\N	17589	17589	18673
6339	4628	109	applied	\N	\N	\N	\N	17592	17592	18674
6339	4629	110	applied	\N	\N	\N	\N	17596	17596	18675
6339	4630	111	applied	\N	\N	\N	\N	17598	17598	18676
6339	4631	112	applied	\N	\N	\N	\N	17606	17606	18677
6339	4632	113	applied	\N	\N	\N	\N	17608	17608	18678
6339	4633	114	applied	\N	\N	\N	\N	17610	17610	18679
6339	4634	115	applied	\N	\N	\N	\N	17612	17612	18680
6339	4635	116	applied	\N	\N	\N	\N	17614	17614	18681
6339	4636	117	applied	\N	\N	\N	\N	17619	17619	18682
6339	4637	118	applied	\N	\N	\N	\N	17623	17623	18683
6339	4640	119	applied	\N	\N	\N	\N	17626	17626	18684
6339	4641	120	applied	\N	\N	\N	\N	17631	17631	18685
6339	4642	121	applied	\N	\N	\N	\N	17638	17638	18686
6339	4643	122	applied	\N	\N	\N	\N	17642	17642	18687
6339	4644	123	applied	\N	\N	\N	\N	17646	17646	18688
6339	4645	124	applied	\N	\N	\N	\N	17648	17648	18689
6339	4646	125	applied	\N	\N	\N	\N	17650	17650	18690
6341	4917	0	applied	\N	\N	\N	\N	18693	18693	18694
6343	4918	0	applied	\N	\N	\N	\N	18695	18695	18696
6346	4647	0	applied	\N	\N	\N	\N	17656	17656	18700
6346	4648	1	applied	\N	\N	\N	\N	17660	17660	18701
6346	4649	2	applied	\N	\N	\N	\N	17668	17668	18702
6346	4650	3	applied	\N	\N	\N	\N	17672	17672	18703
6346	4651	4	applied	\N	\N	\N	\N	17677	17677	18704
6346	4653	5	applied	\N	\N	\N	\N	17682	17682	18705
6346	4654	6	applied	\N	\N	\N	\N	17684	17684	18706
6346	4655	7	applied	\N	\N	\N	\N	17687	17687	18707
6346	4656	8	applied	\N	\N	\N	\N	17689	17689	18708
6346	4657	9	applied	\N	\N	\N	\N	17695	17695	18709
6346	4658	10	applied	\N	\N	\N	\N	17697	17697	18710
6346	4659	11	applied	\N	\N	\N	\N	17699	17699	18711
6346	4660	12	applied	\N	\N	\N	\N	17701	17701	18712
6346	4662	13	applied	\N	\N	\N	\N	17706	17706	18713
6346	4663	14	applied	\N	\N	\N	\N	17712	17712	18714
6346	4664	15	applied	\N	\N	\N	\N	17714	17714	18715
6346	4665	16	applied	\N	\N	\N	\N	17716	17716	18716
6346	4667	17	applied	\N	\N	\N	\N	17724	17724	18717
6346	4669	18	applied	\N	\N	\N	\N	17730	17730	18718
6346	4670	19	applied	\N	\N	\N	\N	17732	17732	18719
6346	4672	20	applied	\N	\N	\N	\N	17738	17738	18720
6346	4604	21	applied	\N	\N	\N	\N	17501	17501	17502
6346	4674	22	applied	\N	\N	\N	\N	17744	17744	18721
6346	4676	23	applied	\N	\N	\N	\N	17748	17748	18722
6346	4678	24	applied	\N	\N	\N	\N	17754	17754	18723
6346	4679	25	applied	\N	\N	\N	\N	17758	17758	18724
6346	4681	26	applied	\N	\N	\N	\N	17763	17763	18725
6346	4682	27	applied	\N	\N	\N	\N	17765	17765	18726
6346	4683	28	applied	\N	\N	\N	\N	17767	17767	18727
6346	4684	29	applied	\N	\N	\N	\N	17771	17771	18728
6346	4685	30	applied	\N	\N	\N	\N	17775	17775	18729
6346	4686	31	applied	\N	\N	\N	\N	17779	17779	18730
6346	4687	32	applied	\N	\N	\N	\N	17785	17785	18731
6346	4688	33	applied	\N	\N	\N	\N	17789	17789	18732
6346	4689	34	applied	\N	\N	\N	\N	17791	17791	18733
6346	4690	35	applied	\N	\N	\N	\N	17797	17797	18734
6346	4691	36	applied	\N	\N	\N	\N	17801	17801	18735
6346	4692	37	applied	\N	\N	\N	\N	17805	17805	18736
6346	4693	38	applied	\N	\N	\N	\N	17811	17811	18737
6346	4694	39	applied	\N	\N	\N	\N	17813	17813	18738
6346	4695	40	applied	\N	\N	\N	\N	17816	17816	18739
6346	4696	41	applied	\N	\N	\N	\N	17818	17818	18740
6346	4697	42	applied	\N	\N	\N	\N	17825	17825	18741
6346	4698	43	applied	\N	\N	\N	\N	17829	17829	18742
6346	4699	44	applied	\N	\N	\N	\N	17833	17833	18743
6346	4700	45	applied	\N	\N	\N	\N	17835	17835	18744
6346	4701	46	applied	\N	\N	\N	\N	17837	17837	18745
6346	4702	47	applied	\N	\N	\N	\N	17841	17841	18746
6346	4703	48	applied	\N	\N	\N	\N	17843	17843	18747
6346	4704	49	applied	\N	\N	\N	\N	17847	17847	18748
6346	4705	50	applied	\N	\N	\N	\N	17855	17855	18749
6346	4706	51	applied	\N	\N	\N	\N	17858	17858	18750
6346	4707	52	applied	\N	\N	\N	\N	17860	17860	18751
6346	4708	53	applied	\N	\N	\N	\N	17862	17862	18752
6346	4709	54	applied	\N	\N	\N	\N	17870	17870	18753
6346	4710	55	applied	\N	\N	\N	\N	17872	17872	18754
6346	4711	56	applied	\N	\N	\N	\N	17883	17883	18755
6346	4712	57	applied	\N	\N	\N	\N	17887	17887	18756
6346	4713	59	applied	\N	\N	\N	\N	17892	17892	18758
6346	4714	60	applied	\N	\N	\N	\N	17896	17896	18759
6346	4715	61	applied	\N	\N	\N	\N	17900	17900	18760
6346	4716	62	applied	\N	\N	\N	\N	17902	17902	18761
6346	4717	63	applied	\N	\N	\N	\N	17909	17909	18762
6346	4718	64	applied	\N	\N	\N	\N	17911	17911	18763
6346	4719	65	applied	\N	\N	\N	\N	17913	17913	18764
6346	4720	66	applied	\N	\N	\N	\N	17919	17919	18765
6346	4721	67	applied	\N	\N	\N	\N	17921	17921	18766
6346	4722	68	applied	\N	\N	\N	\N	17925	17925	18767
6346	4723	69	applied	\N	\N	\N	\N	17927	17927	18768
6346	4724	70	applied	\N	\N	\N	\N	17934	17934	18769
6346	4725	71	applied	\N	\N	\N	\N	17938	17938	18770
6346	4728	72	applied	\N	\N	\N	\N	17951	17951	18771
6346	4729	73	applied	\N	\N	\N	\N	17953	17953	18772
6346	4730	74	applied	\N	\N	\N	\N	17960	17960	18773
6346	4731	75	applied	\N	\N	\N	\N	17964	17964	18774
6346	4732	76	applied	\N	\N	\N	\N	17968	17968	18775
6346	4733	77	applied	\N	\N	\N	\N	17971	17971	18776
6346	4734	78	applied	\N	\N	\N	\N	17973	17973	18777
6346	4735	79	applied	\N	\N	\N	\N	17975	17975	18778
6346	4736	80	applied	\N	\N	\N	\N	17978	17978	18779
6346	4737	81	applied	\N	\N	\N	\N	17981	17981	18780
6346	4739	82	applied	\N	\N	\N	\N	17987	17987	18781
6346	4740	83	applied	\N	\N	\N	\N	17992	17992	18782
6346	4741	84	applied	\N	\N	\N	\N	17994	17994	18783
6346	4742	85	applied	\N	\N	\N	\N	17996	17996	18784
6346	4743	86	applied	\N	\N	\N	\N	17999	17999	18785
6346	4744	87	applied	\N	\N	\N	\N	18005	18005	18786
6346	4745	88	applied	\N	\N	\N	\N	18009	18009	18787
6346	4746	89	applied	\N	\N	\N	\N	18013	18013	18788
6346	4747	90	applied	\N	\N	\N	\N	18015	18015	18789
6346	4748	91	applied	\N	\N	\N	\N	18023	18023	18790
6346	4749	92	applied	\N	\N	\N	\N	18025	18025	18791
6346	4750	93	applied	\N	\N	\N	\N	18031	18031	18792
6346	4751	94	applied	\N	\N	\N	\N	18037	18037	18793
6346	4752	95	applied	\N	\N	\N	\N	18039	18039	18794
6346	4753	96	applied	\N	\N	\N	\N	18042	18042	18795
6346	4754	97	applied	\N	\N	\N	\N	18046	18046	18796
6346	4755	98	applied	\N	\N	\N	\N	18052	18052	18797
6346	4756	99	applied	\N	\N	\N	\N	18056	18056	18798
6346	4757	100	applied	\N	\N	\N	\N	18060	18060	18799
6346	4758	101	applied	\N	\N	\N	\N	18068	18068	18800
6346	4759	102	applied	\N	\N	\N	\N	18070	18070	18801
6346	4760	103	applied	\N	\N	\N	\N	18072	18072	18802
6346	4761	104	applied	\N	\N	\N	\N	18076	18076	18803
6346	4762	105	applied	\N	\N	\N	\N	18084	18084	18804
6346	4763	106	applied	\N	\N	\N	\N	18090	18090	18805
6346	4764	107	applied	\N	\N	\N	\N	18095	18095	18806
6346	4765	108	applied	\N	\N	\N	\N	18099	18099	18807
6346	4766	109	applied	\N	\N	\N	\N	18101	18101	18808
6346	4767	110	applied	\N	\N	\N	\N	18103	18103	18809
6346	4768	111	applied	\N	\N	\N	\N	18105	18105	18810
6346	4769	112	applied	\N	\N	\N	\N	18111	18111	18811
6346	4770	113	applied	\N	\N	\N	\N	18115	18115	18812
6346	4771	114	applied	\N	\N	\N	\N	18117	18117	18813
6346	4772	115	applied	\N	\N	\N	\N	18119	18119	18814
6346	4773	116	applied	\N	\N	\N	\N	18121	18121	18815
6346	4774	117	applied	\N	\N	\N	\N	18123	18123	18816
6346	4775	118	applied	\N	\N	\N	\N	18130	18130	18817
6346	4776	119	applied	\N	\N	\N	\N	18134	18134	18818
6346	4777	120	applied	\N	\N	\N	\N	18136	18136	18819
6346	4780	121	applied	\N	\N	\N	\N	18146	18146	18820
6346	4781	122	applied	\N	\N	\N	\N	18148	18148	18821
6346	4782	123	applied	\N	\N	\N	\N	18152	18152	18822
6346	4785	124	applied	\N	\N	\N	\N	18159	18159	18823
6346	4786	125	applied	\N	\N	\N	\N	18164	18164	18824
6350	4921	0	applied	\N	\N	\N	\N	18832	18832	18833
6364	4936	0	applied	\N	\N	\N	\N	18886	18886	18887
6368	4938	0	applied	\N	\N	\N	\N	18895	18895	18896
6372	4944	0	applied	\N	\N	\N	\N	18913	18913	18914
6372	4945	1	applied	\N	\N	\N	\N	18915	18915	18916
6372	4946	2	applied	\N	\N	\N	\N	18917	18917	18918
6375	4947	0	applied	\N	\N	\N	\N	18922	18922	18923
6379	4949	0	applied	\N	\N	1000000000	\N	18934	18934	18935
6379	4950	1	applied	\N	\N	\N	\N	18936	18936	18937
6382	4955	0	applied	\N	\N	\N	\N	18948	18948	18949
6384	4956	0	applied	\N	\N	\N	\N	18954	18954	18955
6387	4958	0	applied	\N	\N	\N	\N	18960	18960	18961
6392	4962	0	applied	\N	\N	\N	\N	18975	18975	18976
6394	4963	0	applied	\N	\N	\N	\N	18981	18981	18982
6394	4964	1	applied	\N	\N	\N	\N	18983	18983	18984
6399	4965	0	applied	\N	\N	\N	\N	18990	18990	18991
6399	4966	1	applied	\N	\N	\N	\N	18992	18992	18993
6399	4967	2	applied	\N	\N	\N	\N	18994	18994	18995
6401	4965	0	applied	\N	\N	\N	\N	18990	18990	18991
6401	4966	1	applied	\N	\N	\N	\N	18992	18992	18993
6401	4967	2	applied	\N	\N	\N	\N	18994	18994	18995
6408	4976	0	applied	\N	\N	\N	\N	19028	19028	19029
6408	4977	1	applied	\N	\N	\N	\N	19030	19030	19031
6408	4978	2	applied	\N	\N	\N	\N	19032	19032	19033
6385	4957	0	applied	\N	\N	\N	\N	18956	18956	18957
6390	4961	0	applied	\N	\N	\N	\N	18971	18971	18972
6400	4965	0	applied	\N	\N	\N	\N	18990	18990	18991
6400	4966	1	applied	\N	\N	\N	\N	18992	18992	18993
6400	4967	2	applied	\N	\N	\N	\N	18994	18994	18995
6405	4949	0	applied	\N	\N	1000000000	\N	18934	18934	18935
6405	4951	1	applied	\N	\N	1000000000	\N	18939	18939	18940
6409	4980	0	applied	\N	\N	\N	\N	19038	19038	19039
6412	4984	0	applied	\N	\N	\N	\N	19047	19047	19048
6412	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6415	4986	0	applied	\N	\N	\N	\N	19053	19053	19054
6415	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6415	4988	2	applied	\N	\N	\N	\N	19056	19056	19057
6415	4989	3	applied	\N	\N	\N	\N	19058	19058	19059
6415	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6415	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6419	4992	0	applied	\N	\N	\N	\N	19067	19067	19068
6419	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6421	4992	0	applied	\N	\N	\N	\N	19067	19067	19068
6421	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6423	4994	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6423	4995	1	applied	\N	\N	\N	\N	19165	19165	19166
6425	4996	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19169	19169	\N
6425	4997	1	applied	\N	\N	\N	\N	19170	19170	19171
6428	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6428	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6428	5000	2	applied	\N	\N	\N	\N	19176	19176	19177
6428	5001	3	applied	\N	\N	\N	\N	19178	19178	19179
6432	5004	0	applied	\N	\N	\N	\N	19191	19191	19192
6432	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6434	5004	0	applied	\N	\N	\N	\N	19191	19191	19192
6434	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6437	5006	0	applied	\N	\N	\N	\N	19200	19200	19201
6437	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6439	5008	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19207	19207	\N
6439	5009	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19208	19208	\N
6439	5010	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19209	19209	\N
6439	5011	3	applied	\N	\N	\N	\N	19210	19210	19211
6439	5012	4	applied	\N	\N	\N	\N	19212	19212	19213
6439	5013	5	applied	\N	\N	\N	\N	19214	19214	19215
6440	5014	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19217	19217	\N
6440	5015	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19218	19218	\N
6440	5016	2	applied	\N	\N	\N	\N	19219	19219	19220
6440	5017	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19221	19221	\N
6440	5018	4	applied	\N	\N	\N	\N	19222	19222	19223
6440	5019	5	applied	\N	\N	\N	\N	19224	19224	19225
6445	5022	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19230	19230	\N
6445	5023	1	applied	\N	\N	\N	\N	19231	19231	19232
6447	5026	0	applied	\N	\N	\N	\N	19242	19242	19243
6447	5027	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19244	19244	\N
6452	5033	0	applied	\N	\N	\N	\N	19259	19259	19260
6452	5034	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19261	19261	\N
6452	5035	2	applied	\N	\N	\N	\N	19262	19262	19263
6454	5036	0	applied	\N	\N	\N	\N	19266	19266	19267
6454	5037	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19268	19268	\N
6457	5042	0	applied	\N	\N	\N	\N	19280	19280	19281
6457	5043	1	applied	\N	\N	\N	\N	19282	19282	19283
6457	5044	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19284	19284	\N
6457	5045	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19285	19285	\N
6460	5046	0	applied	\N	\N	\N	\N	19288	19288	19289
6460	5047	1	applied	\N	\N	\N	\N	19290	19290	19291
6460	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19292	19292	\N
6460	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19293	19293	\N
6465	5059	0	applied	\N	\N	\N	\N	19318	19318	19319
6470	5063	0	applied	\N	\N	\N	\N	19334	19334	19335
6474	5069	0	applied	\N	\N	\N	\N	19353	19353	19354
6474	5070	1	applied	\N	\N	\N	\N	19355	19355	19356
6476	5071	0	applied	\N	\N	\N	\N	19358	19358	19359
6476	5072	1	applied	\N	\N	\N	\N	19360	19360	19361
6479	5077	0	applied	\N	\N	\N	\N	19375	19375	19376
6479	5078	1	applied	\N	\N	\N	\N	19377	19377	19378
6481	5077	0	applied	\N	\N	\N	\N	19375	19375	19376
6481	5078	1	applied	\N	\N	\N	\N	19377	19377	19378
6483	5079	0	applied	\N	\N	\N	\N	19385	19385	19386
6483	5080	1	applied	\N	\N	\N	\N	19387	19387	19388
6488	4890	0	applied	\N	\N	1000000000	\N	18535	18535	18536
6488	4891	1	applied	\N	\N	1000000000	\N	18537	18537	18538
6488	4949	2	applied	\N	\N	1000000000	\N	18934	18934	18935
6488	4951	3	applied	\N	\N	1000000000	\N	18939	18939	18940
6488	4982	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19044	19044	\N
6488	4985	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6488	4987	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6488	4990	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6488	4991	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6488	4993	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6488	4994	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6488	4996	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	19169	19169	\N
6488	4998	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6488	4999	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6488	5003	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	19189	19189	\N
6488	5005	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6488	5007	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6488	5008	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	19207	19207	\N
6488	5009	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	19208	19208	\N
6488	5010	19	failed	Amount_insufficient_to_create_account	\N	\N	\N	19209	19209	\N
6488	5014	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	19217	19217	\N
6488	5015	21	failed	Amount_insufficient_to_create_account	\N	\N	\N	19218	19218	\N
6592	5206	0	applied	\N	\N	\N	\N	19780	19780	19781
6408	4979	3	applied	\N	\N	\N	\N	19034	19034	19035
6411	4984	0	applied	\N	\N	\N	\N	19047	19047	19048
6411	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6414	4986	0	applied	\N	\N	\N	\N	19053	19053	19054
6414	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6414	4988	2	applied	\N	\N	\N	\N	19056	19056	19057
6414	4989	3	applied	\N	\N	\N	\N	19058	19058	19059
6414	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6414	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6418	4992	0	applied	\N	\N	\N	\N	19067	19067	19068
6418	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6427	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6427	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6427	5000	2	applied	\N	\N	\N	\N	19176	19176	19177
6427	5001	3	applied	\N	\N	\N	\N	19178	19178	19179
6430	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6430	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6430	5000	2	applied	\N	\N	\N	\N	19176	19176	19177
6430	5001	3	applied	\N	\N	\N	\N	19178	19178	19179
6436	5006	0	applied	\N	\N	\N	\N	19200	19200	19201
6436	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6442	5020	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19227	19227	\N
6442	5021	1	applied	\N	\N	\N	\N	19228	19228	19229
6444	5022	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19230	19230	\N
6444	5023	1	applied	\N	\N	\N	\N	19231	19231	19232
6446	5024	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19237	19237	\N
6446	5025	1	applied	\N	\N	\N	\N	19238	19238	19239
6449	5028	0	applied	\N	\N	\N	\N	19245	19245	19246
6449	5029	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19247	19247	\N
6451	5032	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19256	19256	\N
6456	5038	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19272	19272	\N
6456	5039	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19273	19273	\N
6456	5040	2	applied	\N	\N	\N	\N	19274	19274	19275
6456	5041	3	applied	\N	\N	\N	\N	19276	19276	19277
6462	5050	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19298	19298	\N
6462	5051	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19299	19299	\N
6462	5052	2	applied	\N	\N	\N	\N	19300	19300	19301
6462	5053	3	applied	\N	\N	\N	\N	19302	19302	19303
6467	5060	0	applied	\N	\N	\N	\N	19324	19324	19325
6467	5061	1	applied	\N	\N	1000000000	\N	19326	19326	19327
6469	5062	0	applied	\N	\N	\N	\N	19332	19332	19333
6472	5067	0	applied	\N	\N	\N	\N	19345	19345	19346
6472	5068	1	applied	\N	\N	\N	\N	19347	19347	19348
6482	5077	0	applied	\N	\N	\N	\N	19375	19375	19376
6482	5078	1	applied	\N	\N	\N	\N	19377	19377	19378
6486	5081	0	applied	\N	\N	\N	\N	19391	19391	19392
6486	5082	1	applied	\N	\N	\N	\N	19393	19393	19394
6491	5089	0	applied	\N	\N	\N	\N	19415	19415	19416
6491	5090	1	applied	\N	\N	\N	\N	19417	19417	19418
6496	5095	0	applied	\N	\N	\N	\N	19434	19434	19435
6496	5096	1	applied	\N	\N	\N	\N	19436	19436	19437
6496	5097	2	applied	\N	\N	\N	\N	19438	19438	19439
6496	5098	3	applied	\N	\N	\N	\N	19440	19440	19441
6503	5105	0	applied	\N	\N	\N	\N	19463	19463	19464
6503	5106	1	applied	\N	\N	\N	\N	19465	19465	19466
6505	5107	0	applied	\N	\N	\N	\N	19471	19471	19472
6505	5108	1	applied	\N	\N	\N	\N	19473	19473	19474
6512	5115	0	applied	\N	\N	\N	\N	19493	19493	19494
6512	5116	1	applied	\N	\N	\N	\N	19495	19495	19496
6517	5119	0	applied	\N	\N	\N	\N	19508	19508	19509
6517	5120	1	applied	\N	\N	\N	\N	19510	19510	19511
6517	5121	2	applied	\N	\N	\N	\N	19512	19512	19513
6517	5122	3	applied	\N	\N	\N	\N	19514	19514	19515
6520	5125	0	applied	\N	\N	\N	\N	19525	19525	19526
6520	5126	1	applied	\N	\N	\N	\N	19527	19527	19528
6524	5127	0	applied	\N	\N	\N	\N	19535	19535	19536
6524	5128	1	applied	\N	\N	\N	\N	19537	19537	19538
6526	5131	0	applied	\N	\N	\N	\N	19551	19551	19552
6526	5132	1	applied	\N	\N	\N	\N	19553	19553	19554
6529	5135	0	applied	\N	\N	\N	\N	19562	19562	19563
6529	5136	1	applied	\N	\N	\N	\N	19564	19564	19565
6531	5137	0	applied	\N	\N	\N	\N	19569	19569	19570
6531	5138	1	applied	\N	\N	\N	\N	19571	19571	19572
6542	5147	0	applied	\N	\N	\N	\N	19604	19604	19605
6542	5148	1	applied	\N	\N	\N	\N	19606	19606	19607
6550	5161	0	applied	\N	\N	\N	\N	19639	19639	19640
6550	5162	1	applied	\N	\N	\N	\N	19641	19641	19642
6567	5171	0	applied	\N	\N	\N	\N	19676	19676	19677
6567	5172	1	applied	\N	\N	\N	\N	19678	19678	19679
6572	5177	0	applied	\N	\N	\N	\N	19693	19693	19694
6572	5178	1	applied	\N	\N	\N	\N	19695	19695	19696
6572	5179	2	applied	\N	\N	\N	\N	19697	19697	19698
6572	5180	3	applied	\N	\N	\N	\N	19699	19699	19700
6574	5177	0	applied	\N	\N	\N	\N	19693	19693	19694
6574	5178	1	applied	\N	\N	\N	\N	19695	19695	19696
6574	5179	2	applied	\N	\N	\N	\N	19697	19697	19698
6574	5180	3	applied	\N	\N	\N	\N	19699	19699	19700
6586	5188	0	applied	\N	\N	\N	\N	19732	19732	19650
6586	5189	1	applied	\N	\N	\N	\N	19733	19733	19734
6586	5190	2	applied	\N	\N	\N	\N	19735	19735	19736
6586	5191	3	applied	\N	\N	\N	\N	19737	19737	19738
6586	5192	4	applied	\N	\N	\N	\N	19739	19739	19740
6591	5204	0	applied	\N	\N	\N	\N	19774	19774	19775
6591	5205	1	applied	\N	\N	\N	\N	19776	19776	19777
6594	5206	0	applied	\N	\N	\N	\N	19780	19780	19781
6594	5207	1	applied	\N	\N	\N	\N	19782	19782	19783
6598	5210	0	applied	\N	\N	\N	\N	19794	19794	19795
6598	5211	1	applied	\N	\N	\N	\N	19796	19796	19797
6598	5212	2	applied	\N	\N	\N	\N	19798	19798	19799
6598	5213	3	applied	\N	\N	\N	\N	19800	19800	19801
6600	5210	0	applied	\N	\N	\N	\N	19794	19794	19795
6600	5211	1	applied	\N	\N	\N	\N	19796	19796	19797
6600	5212	2	applied	\N	\N	\N	\N	19798	19798	19799
6600	5213	3	applied	\N	\N	\N	\N	19800	19800	19801
6602	5210	0	applied	\N	\N	\N	\N	19794	19794	19795
6602	5211	1	applied	\N	\N	\N	\N	19796	19796	19797
6602	5214	2	applied	\N	\N	\N	\N	19810	19810	19811
6602	5212	3	applied	\N	\N	\N	\N	19798	19798	19799
6602	5213	4	applied	\N	\N	\N	\N	19800	19800	19801
6602	5215	5	applied	\N	\N	\N	\N	19812	19812	19813
6605	5220	0	applied	\N	\N	\N	\N	19825	19825	19826
6410	4983	2	applied	\N	\N	\N	\N	19045	19045	19046
6413	4986	0	applied	\N	\N	\N	\N	19053	19053	19054
6413	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6413	4988	2	applied	\N	\N	\N	\N	19056	19056	19057
6413	4989	3	applied	\N	\N	\N	\N	19058	19058	19059
6413	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6413	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6417	4992	0	applied	\N	\N	\N	\N	19067	19067	19068
6417	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6424	4994	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6424	4995	1	applied	\N	\N	\N	\N	19165	19165	19166
6426	4982	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19044	19044	\N
6426	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6426	4987	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6426	4990	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6426	4991	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6426	4993	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6426	4994	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6426	4996	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	19169	19169	\N
6429	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6429	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6429	5000	2	applied	\N	\N	\N	\N	19176	19176	19177
6429	5001	3	applied	\N	\N	\N	\N	19178	19178	19179
6438	5006	0	applied	\N	\N	\N	\N	19200	19200	19201
6438	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6450	5030	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19252	19252	\N
6450	5031	1	applied	\N	\N	\N	\N	19253	19253	19254
6453	5033	0	applied	\N	\N	\N	\N	19259	19259	19260
6453	5034	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19261	19261	\N
6453	5035	2	applied	\N	\N	\N	\N	19262	19262	19263
6458	5046	0	applied	\N	\N	\N	\N	19288	19288	19289
6458	5047	1	applied	\N	\N	\N	\N	19290	19290	19291
6458	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19292	19292	\N
6458	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19293	19293	\N
6463	5054	0	applied	\N	\N	\N	\N	19308	19308	19309
6463	5055	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19310	19310	\N
6466	5059	0	applied	\N	\N	\N	\N	19318	19318	19319
6468	5060	0	applied	\N	\N	\N	\N	19324	19324	19325
6468	5061	1	applied	\N	\N	1000000000	\N	19326	19326	19327
6471	5064	0	applied	\N	\N	1000000000	\N	19338	19338	19339
6471	5065	1	applied	\N	\N	\N	\N	19340	19340	19341
6471	5066	2	applied	\N	\N	\N	\N	19342	19342	19343
6473	5067	0	applied	\N	\N	\N	\N	19345	19345	19346
6473	5068	1	applied	\N	\N	\N	\N	19347	19347	19348
6478	5073	0	applied	\N	\N	\N	\N	19365	19365	19366
6478	5074	1	applied	\N	\N	\N	\N	19367	19367	19368
6478	5075	2	applied	\N	\N	\N	\N	19369	19369	19370
6478	5076	3	applied	\N	\N	\N	\N	19371	19371	19372
6485	5081	0	applied	\N	\N	\N	\N	19391	19391	19392
6485	5082	1	applied	\N	\N	\N	\N	19393	19393	19394
6487	5083	0	applied	\N	\N	\N	\N	19398	19398	19399
6487	5084	1	applied	\N	\N	\N	\N	19400	19400	19401
6492	5091	0	applied	\N	\N	\N	\N	19420	19420	19421
6492	5092	1	applied	\N	\N	\N	\N	19422	19422	19423
6497	5095	0	applied	\N	\N	\N	\N	19434	19434	19435
6497	5096	1	applied	\N	\N	\N	\N	19436	19436	19437
6497	5097	2	applied	\N	\N	\N	\N	19438	19438	19439
6497	5098	3	applied	\N	\N	\N	\N	19440	19440	19441
6499	5099	0	applied	\N	\N	\N	\N	19447	19447	19448
6499	5100	1	applied	\N	\N	\N	\N	19449	19449	19450
6507	5113	0	applied	\N	\N	\N	\N	19485	19485	19486
6507	5114	1	applied	\N	\N	\N	\N	19487	19487	19488
6509	5115	0	applied	\N	\N	\N	\N	19493	19493	19494
6509	5116	1	applied	\N	\N	\N	\N	19495	19495	19496
6514	5119	0	applied	\N	\N	\N	\N	19508	19508	19509
6514	5120	1	applied	\N	\N	\N	\N	19510	19510	19511
6514	5121	2	applied	\N	\N	\N	\N	19512	19512	19513
6514	5122	3	applied	\N	\N	\N	\N	19514	19514	19515
6518	5123	0	applied	\N	\N	\N	\N	19520	19520	19521
6518	5124	1	applied	\N	\N	\N	\N	19522	19522	19523
6523	5127	0	applied	\N	\N	\N	\N	19535	19535	19536
6523	5128	1	applied	\N	\N	\N	\N	19537	19537	19538
6525	5129	0	applied	\N	\N	\N	\N	19545	19545	19546
6525	5130	1	applied	\N	\N	\N	\N	19547	19547	19548
6532	5137	0	applied	\N	\N	\N	\N	19569	19569	19570
6532	5138	1	applied	\N	\N	\N	\N	19571	19571	19572
6534	5139	0	applied	\N	\N	\N	\N	19577	19577	19578
6534	5140	1	applied	\N	\N	\N	\N	19579	19579	19580
6541	5145	0	applied	\N	\N	\N	\N	19600	19600	19601
6541	5146	1	applied	\N	\N	\N	\N	19602	19602	19603
6546	5151	0	applied	\N	\N	\N	\N	19618	19618	19619
6546	5152	1	applied	\N	\N	\N	\N	19620	19620	19621
6546	5153	2	applied	\N	\N	\N	\N	19622	19622	19623
6546	5154	3	applied	\N	\N	\N	\N	19624	19624	19625
6546	5155	4	applied	\N	\N	\N	\N	19626	19626	19627
6546	5156	5	applied	\N	\N	\N	\N	19628	19628	19629
6552	5161	0	applied	\N	\N	\N	\N	19639	19639	19640
6552	5162	1	applied	\N	\N	\N	\N	19641	19641	19642
6553	5163	0	applied	\N	\N	\N	\N	19646	19646	19647
6553	5164	1	applied	\N	\N	\N	\N	19648	19648	19649
6553	5165	2	applied	\N	\N	1000000000	\N	19650	19650	19651
6558	5166	0	applied	\N	\N	\N	\N	19654	19654	19655
6558	5167	1	applied	\N	\N	\N	\N	19656	19656	19657
6560	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6560	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6563	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6563	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6566	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6566	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6571	5175	0	applied	\N	\N	\N	\N	19688	19688	19689
6571	5176	1	applied	\N	\N	\N	\N	19690	19690	19691
6578	5183	0	applied	\N	\N	\N	\N	19714	19714	19715
6578	5184	1	applied	\N	\N	\N	\N	19716	19716	19717
6582	5165	0	applied	\N	\N	1000000000	\N	19650	19650	19651
6585	5188	0	applied	\N	\N	\N	\N	19732	19732	19650
6585	5189	1	applied	\N	\N	\N	\N	19733	19733	19734
6585	5190	2	applied	\N	\N	\N	\N	19735	19735	19736
6585	5191	3	applied	\N	\N	\N	\N	19737	19737	19738
6585	5192	4	applied	\N	\N	\N	\N	19739	19739	19740
6416	4986	0	applied	\N	\N	\N	\N	19053	19053	19054
6416	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6416	4988	2	applied	\N	\N	\N	\N	19056	19056	19057
6416	4989	3	applied	\N	\N	\N	\N	19058	19058	19059
6416	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6416	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6420	4992	0	applied	\N	\N	\N	\N	19067	19067	19068
6420	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6422	4949	0	applied	\N	\N	1000000000	\N	18934	18934	18935
6422	4951	1	applied	\N	\N	1000000000	\N	18939	18939	18940
6422	4982	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19044	19044	\N
6422	4788	3	applied	\N	\N	\N	\N	18171	18171	19079
6422	4789	4	applied	\N	\N	\N	\N	18173	18173	19080
6422	4790	5	applied	\N	\N	\N	\N	18177	18177	19081
6422	4791	6	applied	\N	\N	\N	\N	18180	18180	19082
6422	4985	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6422	4987	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6422	4990	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6422	4991	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6422	4800	11	applied	\N	\N	\N	\N	18202	18202	19083
6422	4801	12	applied	\N	\N	\N	\N	18204	18204	19084
6422	4802	13	applied	\N	\N	\N	\N	18211	18211	19085
6422	4803	14	applied	\N	\N	\N	\N	18213	18213	19086
6422	4804	15	applied	\N	\N	\N	\N	18215	18215	19087
6422	4805	16	applied	\N	\N	\N	\N	18221	18221	19088
6422	4806	17	applied	\N	\N	\N	\N	18225	18225	19089
6422	4808	18	applied	\N	\N	\N	\N	18232	18232	19090
6422	4809	19	applied	\N	\N	\N	\N	18234	18234	19091
6422	4810	20	applied	\N	\N	\N	\N	18236	18236	19092
6422	4811	21	applied	\N	\N	\N	\N	18243	18243	19093
6422	4814	22	applied	\N	\N	\N	\N	18249	18249	19094
6422	4815	23	applied	\N	\N	\N	\N	18254	18254	19095
6422	4817	24	applied	\N	\N	\N	\N	18264	18264	19096
6422	4818	25	applied	\N	\N	\N	\N	18266	18266	19097
6422	4819	26	applied	\N	\N	\N	\N	18268	18268	19098
6422	4820	27	applied	\N	\N	\N	\N	18271	18271	19099
6422	4821	28	applied	\N	\N	\N	\N	18273	18273	19100
6422	4993	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6422	4822	30	applied	\N	\N	\N	\N	18277	18277	19101
6422	4823	31	applied	\N	\N	\N	\N	18285	18285	19102
6422	4824	32	applied	\N	\N	\N	\N	18287	18287	19103
6422	4825	33	applied	\N	\N	\N	\N	18291	18291	19104
6422	4826	34	applied	\N	\N	\N	\N	18295	18295	19105
6422	4827	35	applied	\N	\N	\N	\N	18297	18297	19106
6422	4828	36	applied	\N	\N	\N	\N	18299	18299	19107
6422	4829	37	applied	\N	\N	\N	\N	18307	18307	19108
6422	4830	38	applied	\N	\N	\N	\N	18309	18309	19109
6422	4831	39	applied	\N	\N	\N	\N	18311	18311	19110
6422	4832	40	applied	\N	\N	\N	\N	18319	18319	19111
6422	4833	41	applied	\N	\N	\N	\N	18321	18321	19112
6422	4834	42	applied	\N	\N	\N	\N	18327	18327	19113
6422	4835	43	applied	\N	\N	\N	\N	18329	18329	19114
6422	4836	44	applied	\N	\N	\N	\N	18331	18331	19115
6422	4837	45	applied	\N	\N	\N	\N	18335	18335	19116
6422	4838	46	applied	\N	\N	\N	\N	18341	18341	19117
6422	4839	47	applied	\N	\N	\N	\N	18345	18345	19118
6422	4840	48	applied	\N	\N	\N	\N	18349	18349	19119
6422	4841	49	applied	\N	\N	\N	\N	18351	18351	19120
6422	4842	50	applied	\N	\N	\N	\N	18357	18357	19121
6422	4843	51	applied	\N	\N	\N	\N	18360	18360	19122
6422	4844	52	applied	\N	\N	\N	\N	18362	18362	19123
6422	4845	53	applied	\N	\N	\N	\N	18364	18364	19124
6422	4847	54	applied	\N	\N	\N	\N	18369	18369	19125
6422	4848	55	applied	\N	\N	\N	\N	18372	18372	19126
6422	4851	56	applied	\N	\N	\N	\N	18380	18380	19127
6422	4852	57	applied	\N	\N	\N	\N	18382	18382	19128
6422	4853	59	applied	\N	\N	\N	\N	18384	18384	19130
6422	4854	60	applied	\N	\N	\N	\N	18388	18388	19131
6422	4855	61	applied	\N	\N	\N	\N	18392	18392	19132
6422	4856	62	applied	\N	\N	\N	\N	18396	18396	19133
6422	4857	63	applied	\N	\N	\N	\N	18400	18400	19134
6422	4858	64	applied	\N	\N	\N	\N	18402	18402	19135
6422	4859	65	applied	\N	\N	\N	\N	18406	18406	19136
6422	4860	66	applied	\N	\N	\N	\N	18410	18410	19137
6422	4861	67	applied	\N	\N	\N	\N	18414	18414	19138
6422	4862	68	applied	\N	\N	\N	\N	18416	18416	19139
6422	4863	69	applied	\N	\N	\N	\N	18420	18420	19140
6422	4864	70	applied	\N	\N	\N	\N	18424	18424	19141
6422	4865	71	applied	\N	\N	\N	\N	18426	18426	19142
6422	4866	72	applied	\N	\N	\N	\N	18430	18430	19143
6422	4867	73	applied	\N	\N	\N	\N	18434	18434	19144
6422	4868	74	applied	\N	\N	\N	\N	18436	18436	19145
6422	4869	75	applied	\N	\N	\N	\N	18438	18438	19146
6422	4870	76	applied	\N	\N	\N	\N	18442	18442	19147
6422	4871	77	applied	\N	\N	\N	\N	18444	18444	19148
6422	4872	78	applied	\N	\N	\N	\N	18446	18446	19149
6422	4873	79	applied	\N	\N	\N	\N	18448	18448	19150
6422	4874	80	applied	\N	\N	\N	\N	18456	18456	19151
6422	4875	81	applied	\N	\N	\N	\N	18462	18462	19152
6422	4876	82	applied	\N	\N	\N	\N	18466	18466	19153
6422	4877	83	applied	\N	\N	\N	\N	18473	18473	19154
6422	4878	84	applied	\N	\N	\N	\N	18479	18479	19155
6422	4879	85	applied	\N	\N	\N	\N	18483	18483	19156
6422	4880	86	applied	\N	\N	\N	\N	18486	18486	19157
6422	4881	87	applied	\N	\N	\N	\N	18489	18489	19158
6422	4882	88	applied	\N	\N	\N	\N	18491	18491	19159
6422	4883	89	applied	\N	\N	\N	\N	18495	18495	19160
6431	5002	0	applied	\N	\N	\N	\N	19187	19187	19188
6431	5003	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19189	19189	\N
6433	5004	0	applied	\N	\N	\N	\N	19191	19191	19192
6433	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6435	5004	0	applied	\N	\N	\N	\N	19191	19191	19192
6435	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6441	5020	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19227	19227	\N
6441	5021	1	applied	\N	\N	\N	\N	19228	19228	19229
6448	5028	0	applied	\N	\N	\N	\N	19245	19245	19246
6448	5029	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19247	19247	\N
6459	5046	0	applied	\N	\N	\N	\N	19288	19288	19289
6459	5047	1	applied	\N	\N	\N	\N	19290	19290	19291
6459	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19292	19292	\N
6459	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19293	19293	\N
6461	5050	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19298	19298	\N
6461	5051	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19299	19299	\N
6461	5052	2	applied	\N	\N	\N	\N	19300	19300	19301
6461	5053	3	applied	\N	\N	\N	\N	19302	19302	19303
6464	5056	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19311	19311	\N
6464	5057	1	applied	\N	\N	\N	\N	19312	19312	19313
6464	5058	2	applied	\N	\N	\N	\N	19314	19314	19315
6475	5069	0	applied	\N	\N	\N	\N	19353	19353	19354
6475	5070	1	applied	\N	\N	\N	\N	19355	19355	19356
6477	5071	0	applied	\N	\N	\N	\N	19358	19358	19359
6477	5072	1	applied	\N	\N	\N	\N	19360	19360	19361
6480	5077	0	applied	\N	\N	\N	\N	19375	19375	19376
6480	5078	1	applied	\N	\N	\N	\N	19377	19377	19378
6484	5079	0	applied	\N	\N	\N	\N	19385	19385	19386
6484	5080	1	applied	\N	\N	\N	\N	19387	19387	19388
6489	5086	0	applied	\N	\N	\N	\N	19407	19407	19408
6489	5087	1	applied	\N	\N	\N	\N	19409	19409	19410
6489	5085	2	applied	\N	\N	\N	\N	19403	19403	19404
6489	5088	3	applied	\N	\N	\N	\N	19411	19411	19412
6494	5093	0	applied	\N	\N	\N	\N	19426	19426	19427
6494	5094	1	applied	\N	\N	\N	\N	19428	19428	19429
6501	5101	0	applied	\N	\N	\N	\N	19453	19453	19454
6501	5102	1	applied	\N	\N	\N	\N	19455	19455	19456
6504	5105	0	applied	\N	\N	\N	\N	19463	19463	19464
6504	5106	1	applied	\N	\N	\N	\N	19465	19465	19466
6506	5109	0	applied	\N	\N	\N	\N	19476	19476	19477
6506	5110	1	applied	\N	\N	\N	\N	19478	19478	19479
6506	5111	2	applied	\N	\N	\N	\N	19480	19480	19481
6506	5112	3	applied	\N	\N	\N	\N	19482	19482	19483
6511	5115	0	applied	\N	\N	\N	\N	19493	19493	19494
6511	5116	1	applied	\N	\N	\N	\N	19495	19495	19496
6513	5117	0	applied	\N	\N	\N	\N	19503	19503	19504
6513	5118	1	applied	\N	\N	\N	\N	19505	19505	19506
6522	5127	0	applied	\N	\N	\N	\N	19535	19535	19536
6522	5128	1	applied	\N	\N	\N	\N	19537	19537	19538
6527	5133	0	applied	\N	\N	\N	\N	19557	19557	19558
6527	5134	1	applied	\N	\N	\N	\N	19559	19559	19560
6530	5135	0	applied	\N	\N	\N	\N	19562	19562	19563
6530	5136	1	applied	\N	\N	\N	\N	19564	19564	19565
6538	5141	0	applied	\N	\N	\N	\N	19583	19583	19584
6538	5142	1	applied	\N	\N	\N	\N	19585	19585	19586
6540	5143	0	applied	\N	\N	\N	\N	19593	19593	19594
6540	5144	1	applied	\N	\N	\N	\N	19595	19595	19596
6543	5147	0	applied	\N	\N	\N	\N	19604	19604	19605
6543	5148	1	applied	\N	\N	\N	\N	19606	19606	19607
6548	5159	0	applied	\N	\N	\N	\N	19635	19635	19636
6548	5160	1	applied	\N	\N	\N	\N	19637	19637	19638
6551	5161	0	applied	\N	\N	\N	\N	19639	19639	19640
6551	5162	1	applied	\N	\N	\N	\N	19641	19641	19642
6555	5166	0	applied	\N	\N	\N	\N	19654	19654	19655
6555	5167	1	applied	\N	\N	\N	\N	19656	19656	19657
6557	5166	0	applied	\N	\N	\N	\N	19654	19654	19655
6557	5167	1	applied	\N	\N	\N	\N	19656	19656	19657
6559	5168	0	applied	\N	\N	\N	\N	19660	19660	19661
6562	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6562	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6565	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6565	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6568	5173	0	applied	\N	\N	\N	\N	19682	19682	19683
6568	5174	1	applied	\N	\N	\N	\N	19684	19684	19685
6570	5175	0	applied	\N	\N	\N	\N	19688	19688	19689
6570	5176	1	applied	\N	\N	\N	\N	19690	19690	19691
6573	5177	0	applied	\N	\N	\N	\N	19693	19693	19694
6573	5178	1	applied	\N	\N	\N	\N	19695	19695	19696
6573	5179	2	applied	\N	\N	\N	\N	19697	19697	19698
6573	5180	3	applied	\N	\N	\N	\N	19699	19699	19700
6575	5181	0	applied	\N	\N	\N	\N	19708	19708	19709
6575	5182	1	applied	\N	\N	\N	\N	19710	19710	19711
6577	5183	0	applied	\N	\N	\N	\N	19714	19714	19715
6577	5184	1	applied	\N	\N	\N	\N	19716	19716	19717
6580	5183	0	applied	\N	\N	\N	\N	19714	19714	19715
6580	5184	1	applied	\N	\N	\N	\N	19716	19716	19717
6584	5188	0	applied	\N	\N	\N	\N	19732	19732	19650
6584	5189	1	applied	\N	\N	\N	\N	19733	19733	19734
6584	5190	2	applied	\N	\N	\N	\N	19735	19735	19736
6584	5191	3	applied	\N	\N	\N	\N	19737	19737	19738
6584	5192	4	applied	\N	\N	\N	\N	19739	19739	19740
6589	5194	0	applied	\N	\N	\N	\N	19750	19750	19751
6589	5195	1	applied	\N	\N	\N	\N	19752	19752	19753
6589	5196	2	applied	\N	\N	\N	\N	19754	19754	19755
6589	5197	3	applied	\N	\N	1000000000	\N	19756	19756	19757
6589	5198	4	applied	\N	\N	\N	\N	19758	19758	19759
6589	5199	5	applied	\N	\N	\N	\N	19760	19760	19761
6589	5200	6	applied	\N	\N	\N	\N	19762	19762	19763
6589	5201	7	applied	\N	\N	\N	\N	19764	19764	19765
6589	5193	8	applied	\N	\N	\N	\N	19746	19746	19766
6599	5210	0	applied	\N	\N	\N	\N	19794	19794	19795
6599	5211	1	applied	\N	\N	\N	\N	19796	19796	19797
6599	5212	2	applied	\N	\N	\N	\N	19798	19798	19799
6599	5213	3	applied	\N	\N	\N	\N	19800	19800	19801
6603	5216	0	applied	\N	\N	\N	\N	19815	19815	19816
6603	5217	1	applied	\N	\N	\N	\N	19817	19817	19818
6603	5218	2	applied	\N	\N	\N	\N	19819	19819	19820
6603	5219	3	applied	\N	\N	\N	\N	19821	19821	19822
6609	5232	0	applied	\N	\N	\N	\N	19855	19855	19856
6609	5233	1	applied	\N	\N	\N	\N	19857	19857	19858
6612	5232	0	applied	\N	\N	\N	\N	19855	19855	19856
6612	5233	1	applied	\N	\N	\N	\N	19857	19857	19858
6620	5242	0	applied	\N	\N	\N	\N	19890	19890	19891
6620	5243	1	applied	\N	\N	\N	\N	19892	19892	19893
6622	5242	0	applied	\N	\N	\N	\N	19890	19890	19891
6622	5243	1	applied	\N	\N	\N	\N	19892	19892	19893
6632	5255	0	applied	\N	\N	\N	\N	19924	19924	19925
6632	5256	2	applied	\N	\N	\N	\N	19927	19927	19928
6632	5257	3	applied	\N	\N	\N	\N	19929	19929	19930
6632	5258	4	applied	\N	\N	\N	\N	19931	19931	19932
6634	5259	0	applied	\N	\N	\N	\N	19937	19937	19938
6634	5260	1	applied	\N	\N	\N	\N	19939	19939	19940
6637	5261	0	applied	\N	\N	\N	\N	19947	19947	19948
6637	5262	1	applied	\N	\N	\N	\N	19949	19949	19950
6640	5273	0	applied	\N	\N	\N	\N	19977	19977	19978
6640	5274	1	applied	\N	\N	\N	\N	19979	19979	19980
6643	5283	0	applied	\N	\N	\N	\N	20001	20001	20002
6643	5284	1	applied	\N	\N	\N	\N	20003	20003	20004
6646	5285	0	applied	\N	\N	\N	\N	20007	20007	20008
6646	5286	1	applied	\N	\N	\N	\N	20009	20009	20010
6648	5287	0	applied	\N	\N	\N	\N	20014	20014	20015
6648	5288	1	applied	\N	\N	\N	\N	20016	20016	20017
6488	5017	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	19221	19221	\N
6488	5020	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	19227	19227	\N
6488	5022	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	19230	19230	\N
6597	5213	3	applied	\N	\N	\N	\N	19800	19800	19801
6488	5024	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	19237	19237	\N
6488	5027	26	failed	Amount_insufficient_to_create_account	\N	\N	\N	19244	19244	\N
6488	5029	27	failed	Amount_insufficient_to_create_account	\N	\N	\N	19247	19247	\N
6488	5030	28	failed	Amount_insufficient_to_create_account	\N	\N	\N	19252	19252	\N
6488	5032	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	19256	19256	\N
6488	5034	30	failed	Amount_insufficient_to_create_account	\N	\N	\N	19261	19261	\N
6488	5037	31	failed	Amount_insufficient_to_create_account	\N	\N	\N	19268	19268	\N
6488	5038	32	failed	Amount_insufficient_to_create_account	\N	\N	\N	19272	19272	\N
6488	5039	33	failed	Amount_insufficient_to_create_account	\N	\N	\N	19273	19273	\N
6488	5044	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	19284	19284	\N
6488	5045	35	failed	Amount_insufficient_to_create_account	\N	\N	\N	19285	19285	\N
6488	5048	36	failed	Amount_insufficient_to_create_account	\N	\N	\N	19292	19292	\N
6488	5049	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	19293	19293	\N
6488	5050	38	failed	Amount_insufficient_to_create_account	\N	\N	\N	19298	19298	\N
6488	5051	39	failed	Amount_insufficient_to_create_account	\N	\N	\N	19299	19299	\N
6488	5055	40	failed	Amount_insufficient_to_create_account	\N	\N	\N	19310	19310	\N
6488	5056	41	failed	Amount_insufficient_to_create_account	\N	\N	\N	19311	19311	\N
6488	5061	42	applied	\N	\N	1000000000	\N	19326	19326	19327
6488	5064	43	applied	\N	\N	1000000000	\N	19338	19338	19339
6488	5068	44	applied	\N	\N	\N	\N	19347	19347	19348
6488	5069	45	applied	\N	\N	\N	\N	19353	19353	19354
6488	5072	46	applied	\N	\N	\N	\N	19360	19360	19361
6488	5075	47	applied	\N	\N	\N	\N	19369	19369	19370
6488	5076	48	applied	\N	\N	\N	\N	19371	19371	19372
6488	5077	49	applied	\N	\N	\N	\N	19375	19375	19376
6488	5080	50	applied	\N	\N	\N	\N	19387	19387	19388
6488	5081	51	applied	\N	\N	\N	\N	19391	19391	19392
6488	5084	52	applied	\N	\N	\N	\N	19400	19400	19401
6488	5085	53	applied	\N	\N	\N	\N	19403	19403	19404
6490	5086	0	applied	\N	\N	\N	\N	19407	19407	19408
6490	5087	1	applied	\N	\N	\N	\N	19409	19409	19410
6490	5085	2	applied	\N	\N	\N	\N	19403	19403	19404
6490	5088	3	applied	\N	\N	\N	\N	19411	19411	19412
6493	5091	0	applied	\N	\N	\N	\N	19420	19420	19421
6493	5092	1	applied	\N	\N	\N	\N	19422	19422	19423
6495	5093	0	applied	\N	\N	\N	\N	19426	19426	19427
6495	5094	1	applied	\N	\N	\N	\N	19428	19428	19429
6500	5099	0	applied	\N	\N	\N	\N	19447	19447	19448
6500	5100	1	applied	\N	\N	\N	\N	19449	19449	19450
6502	5103	0	applied	\N	\N	\N	\N	19458	19458	19459
6502	5104	1	applied	\N	\N	\N	\N	19460	19460	19461
6508	5113	0	applied	\N	\N	\N	\N	19485	19485	19486
6508	5114	1	applied	\N	\N	\N	\N	19487	19487	19488
6510	5115	0	applied	\N	\N	\N	\N	19493	19493	19494
6510	5116	1	applied	\N	\N	\N	\N	19495	19495	19496
6515	5119	0	applied	\N	\N	\N	\N	19508	19508	19509
6515	5120	1	applied	\N	\N	\N	\N	19510	19510	19511
6515	5121	2	applied	\N	\N	\N	\N	19512	19512	19513
6515	5122	3	applied	\N	\N	\N	\N	19514	19514	19515
6519	5125	0	applied	\N	\N	\N	\N	19525	19525	19526
6519	5126	1	applied	\N	\N	\N	\N	19527	19527	19528
6521	5125	0	applied	\N	\N	\N	\N	19525	19525	19526
6521	5126	1	applied	\N	\N	\N	\N	19527	19527	19528
6528	5135	0	applied	\N	\N	\N	\N	19562	19562	19563
6528	5136	1	applied	\N	\N	\N	\N	19564	19564	19565
6533	5137	0	applied	\N	\N	\N	\N	19569	19569	19570
6533	5138	1	applied	\N	\N	\N	\N	19571	19571	19572
6535	5141	0	applied	\N	\N	\N	\N	19583	19583	19584
6535	5142	1	applied	\N	\N	\N	\N	19585	19585	19586
6537	5141	0	applied	\N	\N	\N	\N	19583	19583	19584
6537	5142	1	applied	\N	\N	\N	\N	19585	19585	19586
6539	5143	0	applied	\N	\N	\N	\N	19593	19593	19594
6539	5144	1	applied	\N	\N	\N	\N	19595	19595	19596
6544	5149	0	applied	\N	\N	\N	\N	19612	19612	19613
6544	5150	1	applied	\N	\N	\N	\N	19614	19614	19615
6547	5157	0	applied	\N	\N	\N	\N	19631	19631	19632
6547	5158	1	applied	\N	\N	\N	\N	19633	19633	19634
6554	5163	0	applied	\N	\N	\N	\N	19646	19646	19647
6554	5164	1	applied	\N	\N	\N	\N	19648	19648	19649
6554	5165	2	applied	\N	\N	1000000000	\N	19650	19650	19651
6561	5169	0	applied	\N	\N	\N	\N	19662	19662	19663
6561	5170	1	applied	\N	\N	\N	\N	19664	19664	19665
6564	5165	0	applied	\N	\N	1000000000	\N	19650	19650	19651
6569	5175	0	applied	\N	\N	\N	\N	19688	19688	19689
6569	5176	1	applied	\N	\N	\N	\N	19690	19690	19691
6576	5181	0	applied	\N	\N	\N	\N	19708	19708	19709
6576	5182	1	applied	\N	\N	\N	\N	19710	19710	19711
6579	5183	0	applied	\N	\N	\N	\N	19714	19714	19715
6579	5184	1	applied	\N	\N	\N	\N	19716	19716	19717
6581	5183	0	applied	\N	\N	\N	\N	19714	19714	19715
6581	5184	1	applied	\N	\N	\N	\N	19716	19716	19717
6583	5185	0	applied	\N	\N	\N	\N	19725	19725	19650
6583	5186	1	applied	\N	\N	\N	\N	19726	19726	19727
6583	5187	2	applied	\N	\N	\N	\N	19728	19728	19729
6587	5193	0	applied	\N	\N	\N	\N	19746	19746	19747
6588	5194	0	applied	\N	\N	\N	\N	19750	19750	19751
6588	5195	1	applied	\N	\N	\N	\N	19752	19752	19753
6588	5196	2	applied	\N	\N	\N	\N	19754	19754	19755
6588	5197	3	applied	\N	\N	1000000000	\N	19756	19756	19757
6588	5198	4	applied	\N	\N	\N	\N	19758	19758	19759
6588	5199	5	applied	\N	\N	\N	\N	19760	19760	19761
6588	5200	6	applied	\N	\N	\N	\N	19762	19762	19763
6588	5201	7	applied	\N	\N	\N	\N	19764	19764	19765
6588	5193	8	applied	\N	\N	\N	\N	19746	19746	19766
6590	5202	0	applied	\N	\N	\N	\N	19770	19770	19771
6590	5203	1	applied	\N	\N	\N	\N	19772	19772	19773
6593	5206	0	applied	\N	\N	\N	\N	19780	19780	19781
6593	5207	1	applied	\N	\N	\N	\N	19782	19782	19783
6595	5208	0	applied	\N	\N	\N	\N	19788	19788	19789
6595	5209	1	applied	\N	\N	\N	\N	19790	19790	19791
6610	5232	0	applied	\N	\N	\N	\N	19855	19855	19856
6610	5233	1	applied	\N	\N	\N	\N	19857	19857	19858
6616	5234	0	applied	\N	\N	\N	\N	19866	19866	19867
6616	5235	1	applied	\N	\N	\N	\N	19868	19868	19869
6619	5240	0	applied	\N	\N	\N	\N	19884	19884	19885
6619	5241	1	applied	\N	\N	\N	\N	19886	19886	19887
6621	5242	0	applied	\N	\N	\N	\N	19890	19890	19891
6592	5207	1	applied	\N	\N	\N	\N	19782	19782	19783
6597	5210	0	applied	\N	\N	\N	\N	19794	19794	19795
6597	5211	1	applied	\N	\N	\N	\N	19796	19796	19797
6597	5212	2	applied	\N	\N	\N	\N	19798	19798	19799
6601	5165	0	applied	\N	\N	1000000000	\N	19650	19650	19651
6601	5193	1	applied	\N	\N	\N	\N	19746	19746	19747
6604	5216	0	applied	\N	\N	\N	\N	19815	19815	19816
6604	5217	1	applied	\N	\N	\N	\N	19817	19817	19818
6604	5218	2	applied	\N	\N	\N	\N	19819	19819	19820
6604	5219	3	applied	\N	\N	\N	\N	19821	19821	19822
6607	5222	0	applied	\N	\N	\N	\N	19829	19829	19830
6607	5223	1	applied	\N	\N	\N	\N	19831	19831	19832
6607	5224	2	applied	\N	\N	\N	\N	19833	19833	19834
6607	5225	3	applied	\N	\N	\N	\N	19835	19835	19836
6607	5226	4	applied	\N	\N	\N	\N	19837	19837	19838
6607	5227	5	applied	\N	\N	\N	\N	19839	19839	19840
6607	5228	6	applied	\N	\N	\N	\N	19841	19841	19842
6607	5229	7	applied	\N	\N	\N	\N	19843	19843	19844
6618	5238	0	applied	\N	\N	\N	\N	19878	19878	19879
6618	5239	1	applied	\N	\N	\N	\N	19880	19880	19881
6623	5244	0	applied	\N	\N	\N	\N	19896	19896	19897
6623	5245	1	applied	\N	\N	\N	\N	19898	19898	19899
6623	5246	2	applied	\N	\N	\N	\N	19900	19900	19901
6623	5247	3	applied	\N	\N	\N	\N	19902	19902	19903
6624	5248	0	applied	\N	\N	\N	\N	19906	19906	19907
6624	5249	1	applied	\N	\N	\N	\N	19908	19908	19909
6624	5250	2	applied	\N	\N	\N	\N	19910	19910	19911
6624	5251	3	applied	\N	\N	\N	\N	19912	19912	19913
6626	5252	0	applied	\N	\N	\N	\N	19916	19916	19917
6626	5253	1	applied	\N	\N	\N	\N	19918	19918	19919
6626	5254	2	applied	\N	\N	\N	\N	19920	19920	19921
6626	5248	3	applied	\N	\N	\N	\N	19906	19906	19907
6626	5249	4	applied	\N	\N	\N	\N	19908	19908	19909
6626	5250	5	applied	\N	\N	\N	\N	19910	19910	19911
6626	5251	6	applied	\N	\N	\N	\N	19912	19912	19913
6635	5259	0	applied	\N	\N	\N	\N	19937	19937	19938
6635	5260	1	applied	\N	\N	\N	\N	19939	19939	19940
6641	5275	0	applied	\N	\N	\N	\N	19982	19982	19983
6641	5276	1	applied	\N	\N	\N	\N	19984	19984	19985
6641	5277	2	applied	\N	\N	\N	\N	19986	19986	19987
6641	5278	3	applied	\N	\N	\N	\N	19988	19988	19989
6644	5285	0	applied	\N	\N	\N	\N	20007	20007	20008
6644	5286	1	applied	\N	\N	\N	\N	20009	20009	20010
6651	5293	0	applied	\N	\N	\N	\N	20030	20030	20031
6651	5294	1	applied	\N	\N	\N	\N	20032	20032	20033
6654	5297	0	applied	\N	\N	\N	\N	20043	20043	20044
6654	5298	1	applied	\N	\N	\N	\N	20045	20045	20046
6654	5299	2	applied	\N	\N	\N	\N	20047	20047	20048
6654	5300	3	applied	\N	\N	\N	\N	20049	20049	20050
6654	5301	4	applied	\N	\N	\N	\N	20051	20051	20052
6654	5302	5	applied	\N	\N	\N	\N	20053	20053	20054
6656	5303	0	applied	\N	\N	\N	\N	20057	20057	20058
6656	5304	1	applied	\N	\N	\N	\N	20059	20059	20060
6658	5303	0	applied	\N	\N	\N	\N	20057	20057	20058
6658	5304	1	applied	\N	\N	\N	\N	20059	20059	20060
6661	5305	0	applied	\N	\N	\N	\N	20064	20064	20065
6661	5306	1	applied	\N	\N	\N	\N	20066	20066	20067
6665	5309	0	applied	\N	\N	\N	\N	20081	20081	20082
6665	5310	1	applied	\N	\N	\N	\N	20083	20083	20084
6670	5313	0	applied	\N	\N	\N	\N	20093	20093	20094
6670	5314	1	applied	\N	\N	\N	\N	20095	20095	20096
6670	5315	2	applied	\N	\N	\N	\N	20097	20097	20098
6670	5316	3	applied	\N	\N	\N	\N	20099	20099	20100
6672	5317	0	applied	\N	\N	\N	\N	20105	20105	20106
6672	5318	1	applied	\N	\N	\N	\N	20107	20107	20108
6677	5325	0	applied	\N	\N	\N	\N	20130	20130	20131
6677	5326	1	applied	\N	\N	\N	\N	20132	20132	20133
6680	5329	0	applied	\N	\N	\N	\N	20139	20139	20140
6680	5330	1	applied	\N	\N	\N	\N	20141	20141	20142
6680	5331	3	applied	\N	\N	\N	\N	20144	20144	20145
6680	5332	4	applied	\N	\N	\N	\N	20146	20146	20147
6680	5333	5	applied	\N	\N	\N	\N	20148	20148	20149
6682	5334	0	applied	\N	\N	\N	\N	20160	20160	20161
6682	5335	1	applied	\N	\N	\N	\N	20162	20162	20163
6682	5336	2	applied	\N	\N	\N	\N	20164	20164	20165
6685	5337	0	applied	\N	\N	\N	\N	20167	20167	20168
6685	5338	1	applied	\N	\N	\N	\N	20169	20169	20170
6685	5339	2	applied	\N	\N	\N	\N	20171	20171	20172
6685	5340	3	applied	\N	\N	\N	\N	20173	20173	20174
6605	5221	1	applied	\N	\N	\N	\N	19827	19827	19828
6606	5222	0	applied	\N	\N	\N	\N	19829	19829	19830
6606	5223	1	applied	\N	\N	\N	\N	19831	19831	19832
6606	5224	2	applied	\N	\N	\N	\N	19833	19833	19834
6606	5225	3	applied	\N	\N	\N	\N	19835	19835	19836
6606	5226	4	applied	\N	\N	\N	\N	19837	19837	19838
6606	5227	5	applied	\N	\N	\N	\N	19839	19839	19840
6606	5228	6	applied	\N	\N	\N	\N	19841	19841	19842
6606	5229	7	applied	\N	\N	\N	\N	19843	19843	19844
6608	5230	0	applied	\N	\N	\N	\N	19849	19849	19850
6608	5231	1	applied	\N	\N	\N	\N	19851	19851	19852
6611	5232	0	applied	\N	\N	\N	\N	19855	19855	19856
6611	5233	1	applied	\N	\N	\N	\N	19857	19857	19858
6617	5236	0	applied	\N	\N	\N	\N	19872	19872	19873
6617	5237	1	applied	\N	\N	\N	\N	19874	19874	19875
6625	5252	0	applied	\N	\N	\N	\N	19916	19916	19917
6625	5253	1	applied	\N	\N	\N	\N	19918	19918	19919
6625	5254	2	applied	\N	\N	\N	\N	19920	19920	19921
6625	5248	3	applied	\N	\N	\N	\N	19906	19906	19907
6625	5249	4	applied	\N	\N	\N	\N	19908	19908	19909
6625	5250	5	applied	\N	\N	\N	\N	19910	19910	19911
6625	5251	6	applied	\N	\N	\N	\N	19912	19912	19913
6636	5261	0	applied	\N	\N	\N	\N	19947	19947	19948
6636	5262	1	applied	\N	\N	\N	\N	19949	19949	19950
6639	5269	0	applied	\N	\N	\N	\N	19967	19967	19968
6639	5270	1	applied	\N	\N	\N	\N	19969	19969	19970
6639	5271	2	applied	\N	\N	\N	\N	19971	19971	19972
6639	5272	3	applied	\N	\N	\N	\N	19973	19973	19974
6647	5287	0	applied	\N	\N	\N	\N	20014	20014	20015
6647	5288	1	applied	\N	\N	\N	\N	20016	20016	20017
6650	5293	0	applied	\N	\N	\N	\N	20030	20030	20031
6650	5294	1	applied	\N	\N	\N	\N	20032	20032	20033
6652	5295	0	applied	\N	\N	\N	\N	20035	20035	20036
6652	5296	1	applied	\N	\N	\N	\N	20037	20037	20038
6655	5303	0	applied	\N	\N	\N	\N	20057	20057	20058
6655	5304	1	applied	\N	\N	\N	\N	20059	20059	20060
6664	5305	0	applied	\N	\N	\N	\N	20064	20064	20065
6664	5307	1	applied	\N	\N	\N	\N	20074	20074	20075
6664	5306	2	applied	\N	\N	\N	\N	20066	20066	20067
6664	5308	3	applied	\N	\N	\N	\N	20076	20076	20077
6667	5309	0	applied	\N	\N	\N	\N	20081	20081	20082
6667	5310	1	applied	\N	\N	\N	\N	20083	20083	20084
6668	5311	0	applied	\N	\N	\N	\N	20089	20089	20090
6668	5312	1	applied	\N	\N	\N	\N	20091	20091	20092
6673	5319	0	applied	\N	\N	\N	\N	20111	20111	20112
6673	5320	1	applied	\N	\N	\N	\N	20113	20113	20114
6678	5327	0	applied	\N	\N	\N	\N	20134	20134	20135
6678	5328	1	applied	\N	\N	\N	\N	20136	20136	20137
6681	5329	0	applied	\N	\N	\N	\N	20139	20139	20140
6681	5330	1	applied	\N	\N	\N	\N	20141	20141	20142
6681	5331	3	applied	\N	\N	\N	\N	20144	20144	20145
6681	5332	4	applied	\N	\N	\N	\N	20146	20146	20147
6681	5333	5	applied	\N	\N	\N	\N	20148	20148	20149
6686	5329	0	applied	\N	\N	\N	\N	20139	20139	20179
6686	5335	1	applied	\N	\N	\N	\N	20162	20162	20180
6686	5341	2	applied	\N	\N	\N	\N	20181	20181	20182
6686	5342	3	applied	\N	\N	\N	\N	20183	20183	20184
6686	5343	4	applied	\N	\N	\N	\N	20185	20185	20186
6686	5344	5	applied	\N	\N	\N	\N	20187	20187	20188
6686	5345	6	applied	\N	\N	\N	\N	20189	20189	20190
6689	5329	0	applied	\N	\N	\N	\N	20139	20139	19164
6689	5335	1	applied	\N	\N	\N	\N	20162	20162	19069
6689	4998	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6689	4999	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19169	19169	\N
6689	5003	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6689	5005	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6689	5007	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	19189	19189	\N
6689	5008	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6689	5009	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6689	5010	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	19207	19207	\N
6689	5014	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	19208	19208	\N
6689	5015	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	19209	19209	\N
6689	5017	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	19217	19217	\N
6689	5020	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	19218	19218	\N
6689	5022	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	19221	19221	\N
6689	5024	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	19227	19227	\N
6689	5027	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	19230	19230	\N
6689	5251	17	applied	\N	\N	\N	\N	19912	19912	19913
6689	5029	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	19237	19237	\N
6689	5030	19	failed	Amount_insufficient_to_create_account	\N	\N	\N	19244	19244	\N
6689	5032	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	19247	19247	\N
6689	5034	21	failed	Amount_insufficient_to_create_account	\N	\N	\N	19252	19252	\N
6689	5037	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	19256	19256	\N
6689	5038	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	19261	19261	\N
6689	5039	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	19268	19268	\N
6689	5044	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	19272	19272	\N
6689	5045	26	failed	Amount_insufficient_to_create_account	\N	\N	\N	19273	19273	\N
6689	5048	27	failed	Amount_insufficient_to_create_account	\N	\N	\N	19284	19284	\N
6689	5049	28	failed	Amount_insufficient_to_create_account	\N	\N	\N	19285	19285	\N
6689	5050	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	19292	19292	\N
6689	5051	30	failed	Amount_insufficient_to_create_account	\N	\N	\N	19293	19293	\N
6689	5055	31	failed	Amount_insufficient_to_create_account	\N	\N	\N	19298	19298	\N
6689	5056	32	failed	Amount_insufficient_to_create_account	\N	\N	\N	20220	20220	\N
6689	5061	33	applied	\N	\N	1000000000	\N	20221	20221	19327
6689	5064	34	applied	\N	\N	1000000000	\N	20222	20222	19339
6689	5068	35	applied	\N	\N	\N	\N	20223	20223	19348
6689	5069	36	applied	\N	\N	\N	\N	20224	20224	19354
6689	5072	37	applied	\N	\N	\N	\N	20225	20225	19361
6689	5075	38	applied	\N	\N	\N	\N	20226	20226	19370
6689	5076	39	applied	\N	\N	\N	\N	20227	20227	19372
6689	5077	40	applied	\N	\N	\N	\N	20228	20228	19376
6689	5080	41	applied	\N	\N	\N	\N	20229	20229	19388
6689	5081	42	applied	\N	\N	\N	\N	20230	20230	19392
6689	5084	43	applied	\N	\N	\N	\N	20231	20231	19401
6689	5085	44	applied	\N	\N	\N	\N	20232	20232	19404
6621	5243	1	applied	\N	\N	\N	\N	19892	19892	19893
6631	5255	0	applied	\N	\N	\N	\N	19924	19924	19925
6631	5256	2	applied	\N	\N	\N	\N	19927	19927	19928
6631	5257	3	applied	\N	\N	\N	\N	19929	19929	19930
6631	5258	4	applied	\N	\N	\N	\N	19931	19931	19932
6633	5259	0	applied	\N	\N	\N	\N	19937	19937	19938
6633	5260	1	applied	\N	\N	\N	\N	19939	19939	19940
6638	5263	0	applied	\N	\N	\N	\N	19953	19953	19954
6638	5264	1	applied	\N	\N	\N	\N	19955	19955	19956
6638	5265	2	applied	\N	\N	\N	\N	19957	19957	19958
6638	5266	3	applied	\N	\N	\N	\N	19959	19959	19960
6638	5267	4	applied	\N	\N	\N	\N	19961	19961	19962
6638	5268	5	applied	\N	\N	\N	\N	19963	19963	19964
6642	5279	0	applied	\N	\N	\N	\N	19991	19991	19992
6642	5280	1	applied	\N	\N	\N	\N	19993	19993	19994
6642	5281	2	applied	\N	\N	\N	\N	19995	19995	19996
6642	5282	3	applied	\N	\N	\N	\N	19997	19997	19998
6645	5285	0	applied	\N	\N	\N	\N	20007	20007	20008
6645	5286	1	applied	\N	\N	\N	\N	20009	20009	20010
6649	5289	0	applied	\N	\N	\N	\N	20021	20021	20022
6649	5290	1	applied	\N	\N	\N	\N	20023	20023	20024
6649	5291	2	applied	\N	\N	\N	\N	20025	20025	20026
6649	5292	3	applied	\N	\N	\N	\N	20027	20027	20028
6657	5303	0	applied	\N	\N	\N	\N	20057	20057	20058
6657	5304	1	applied	\N	\N	\N	\N	20059	20059	20060
6659	5305	0	applied	\N	\N	\N	\N	20064	20064	20065
6659	5306	1	applied	\N	\N	\N	\N	20066	20066	20067
6663	5307	0	applied	\N	\N	\N	\N	20074	20074	20075
6663	5306	1	applied	\N	\N	\N	\N	20066	20066	20067
6663	5308	2	applied	\N	\N	\N	\N	20076	20076	20077
6666	5309	0	applied	\N	\N	\N	\N	20081	20081	20082
6666	5310	1	applied	\N	\N	\N	\N	20083	20083	20084
6671	5313	0	applied	\N	\N	\N	\N	20093	20093	20094
6671	5314	1	applied	\N	\N	\N	\N	20095	20095	20096
6671	5315	2	applied	\N	\N	\N	\N	20097	20097	20098
6671	5316	3	applied	\N	\N	\N	\N	20099	20099	20100
6675	5251	0	applied	\N	\N	\N	\N	19912	19912	19913
6683	5337	0	applied	\N	\N	\N	\N	20167	20167	20168
6683	5338	1	applied	\N	\N	\N	\N	20169	20169	20170
6683	5339	2	applied	\N	\N	\N	\N	20171	20171	20172
6683	5340	3	applied	\N	\N	\N	\N	20173	20173	20174
6688	5352	0	applied	\N	\N	\N	\N	20212	20212	20213
6688	5353	1	applied	\N	\N	\N	\N	20214	20214	20215
6688	5354	2	applied	\N	\N	\N	\N	20216	20216	20217
6688	5355	3	applied	\N	\N	\N	\N	20218	20218	20219
6653	5295	0	applied	\N	\N	\N	\N	20035	20035	20036
6653	5296	1	applied	\N	\N	\N	\N	20037	20037	20038
6660	5305	0	applied	\N	\N	\N	\N	20064	20064	20065
6662	5307	0	applied	\N	\N	\N	\N	20074	20074	20075
6662	5306	1	applied	\N	\N	\N	\N	20066	20066	20067
6662	5308	2	applied	\N	\N	\N	\N	20076	20076	20077
6669	5313	0	applied	\N	\N	\N	\N	20093	20093	20094
6669	5314	1	applied	\N	\N	\N	\N	20095	20095	20096
6669	5315	2	applied	\N	\N	\N	\N	20097	20097	20098
6669	5316	3	applied	\N	\N	\N	\N	20099	20099	20100
6674	4982	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	19044	19044	\N
6674	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	19049	19049	\N
6674	4987	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	19055	19055	\N
6674	4990	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	19060	19060	\N
6674	4991	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	19061	19061	\N
6674	5251	5	applied	\N	\N	\N	\N	19912	19912	19913
6674	4993	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	19069	19069	\N
6674	4994	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	19164	19164	\N
6674	4996	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	19169	19169	\N
6674	4998	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	19174	19174	\N
6674	4999	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	19175	19175	\N
6674	5003	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	19189	19189	\N
6674	5005	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	19193	19193	\N
6674	5007	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	19202	19202	\N
6674	5008	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	19207	19207	\N
6674	5009	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	19208	19208	\N
6676	5321	0	applied	\N	\N	\N	\N	20121	20121	20122
6676	5322	1	applied	\N	\N	\N	\N	20123	20123	20124
6676	5323	2	applied	\N	\N	\N	\N	20125	20125	20126
6676	5324	3	applied	\N	\N	\N	\N	20127	20127	20128
6679	5329	0	applied	\N	\N	\N	\N	20139	20139	20140
6679	5330	1	applied	\N	\N	\N	\N	20141	20141	20142
6679	5331	3	applied	\N	\N	\N	\N	20144	20144	20145
6679	5332	4	applied	\N	\N	\N	\N	20146	20146	20147
6679	5333	5	applied	\N	\N	\N	\N	20148	20148	20149
6684	5337	0	applied	\N	\N	\N	\N	20167	20167	20168
6684	5338	1	applied	\N	\N	\N	\N	20169	20169	20170
6684	5339	2	applied	\N	\N	\N	\N	20171	20171	20172
6684	5340	3	applied	\N	\N	\N	\N	20173	20173	20174
6687	5346	0	applied	\N	\N	\N	\N	20193	20193	20194
6687	5347	1	applied	\N	\N	\N	\N	20195	20195	20196
6687	5348	2	applied	\N	\N	\N	\N	20197	20197	20198
6687	5349	3	applied	\N	\N	\N	\N	20199	20199	20200
6687	5350	4	applied	\N	\N	\N	\N	20201	20201	20202
6687	5351	5	applied	\N	\N	\N	\N	20203	20203	20204
6687	5341	6	applied	\N	\N	\N	\N	20181	20181	20205
6687	5342	7	applied	\N	\N	\N	\N	20183	20183	20206
6687	5343	8	applied	\N	\N	\N	\N	20185	20185	20207
6687	5344	9	applied	\N	\N	\N	\N	20187	20187	20208
6687	5345	10	applied	\N	\N	\N	\N	20189	20189	20209
6689	5088	45	applied	\N	\N	\N	\N	20180	20180	19412
6689	5089	46	applied	\N	\N	\N	\N	20233	20233	19416
6689	5091	47	applied	\N	\N	\N	\N	20234	20234	19421
6689	5094	48	applied	\N	\N	\N	\N	20235	20235	19429
6689	5095	49	applied	\N	\N	\N	\N	20236	20236	19435
6689	5096	50	applied	\N	\N	\N	\N	20237	20237	19437
6689	5099	51	applied	\N	\N	\N	\N	20238	20238	19448
6689	5102	52	applied	\N	\N	\N	\N	20239	20239	19456
6689	5104	53	applied	\N	\N	\N	\N	20240	20240	19461
6689	5106	54	applied	\N	\N	\N	\N	20241	20241	19466
6689	5108	55	applied	\N	\N	\N	\N	20242	20242	19474
6689	5111	56	applied	\N	\N	\N	\N	20243	20243	19481
6689	5112	57	applied	\N	\N	\N	\N	20244	20244	19483
6689	5114	58	applied	\N	\N	\N	\N	20245	20245	19488
6689	5116	59	applied	\N	\N	\N	\N	20246	20246	19496
6689	5117	60	applied	\N	\N	\N	\N	20247	20247	19504
6689	5119	61	applied	\N	\N	\N	\N	20248	20248	19509
6689	5120	62	applied	\N	\N	\N	\N	20249	20249	19511
6689	5123	63	applied	\N	\N	\N	\N	20250	20250	19521
6689	5126	64	applied	\N	\N	\N	\N	20251	20251	19528
6689	5127	65	applied	\N	\N	\N	\N	20252	20252	19536
6689	5129	66	applied	\N	\N	\N	\N	20253	20253	19546
6689	5132	67	applied	\N	\N	\N	\N	20254	20254	19554
6689	5134	68	applied	\N	\N	\N	\N	20255	20255	19560
6689	5135	69	applied	\N	\N	\N	\N	20256	20256	19563
6689	5138	70	applied	\N	\N	\N	\N	20257	20257	19572
6689	5140	71	applied	\N	\N	\N	\N	20258	20258	19580
6689	5141	72	applied	\N	\N	\N	\N	20259	20259	19584
6689	5144	73	applied	\N	\N	\N	\N	20260	20260	19596
6689	5146	74	applied	\N	\N	\N	\N	20261	20261	19603
6689	5147	75	applied	\N	\N	\N	\N	20262	20262	19605
6689	5149	76	applied	\N	\N	\N	\N	20263	20263	19613
6689	5151	77	applied	\N	\N	\N	\N	20264	20264	19619
6689	5152	78	applied	\N	\N	\N	\N	20265	20265	19621
6689	5156	79	applied	\N	\N	\N	\N	20266	20266	19629
6689	5158	80	applied	\N	\N	\N	\N	20267	20267	19634
6689	5160	81	applied	\N	\N	\N	\N	20268	20268	19638
6689	5162	82	applied	\N	\N	\N	\N	20269	20269	19642
6689	5164	83	applied	\N	\N	\N	\N	20270	20270	19649
6689	5166	84	applied	\N	\N	\N	\N	20271	20271	19655
6689	5170	85	applied	\N	\N	\N	\N	20272	20272	19665
6689	5171	86	applied	\N	\N	\N	\N	20273	20273	19677
6689	5174	87	applied	\N	\N	\N	\N	20274	20274	19685
6689	5176	88	applied	\N	\N	\N	\N	20275	20275	19691
6689	5179	89	applied	\N	\N	\N	\N	20276	20276	19698
6689	5180	90	applied	\N	\N	\N	\N	20277	20277	19700
6689	5181	91	applied	\N	\N	\N	\N	20278	20278	19709
6689	5183	92	applied	\N	\N	\N	\N	20279	20279	19715
6689	5186	93	applied	\N	\N	\N	\N	20280	20280	19727
6689	5191	94	applied	\N	\N	\N	\N	20281	20281	19738
6689	5192	95	applied	\N	\N	\N	\N	20282	20282	19740
6689	5194	96	applied	\N	\N	\N	\N	20283	20283	19751
6689	5195	97	applied	\N	\N	\N	\N	20284	20284	19753
6689	5198	98	applied	\N	\N	\N	\N	20285	20285	19759
6689	5199	99	applied	\N	\N	\N	\N	20286	20286	19761
6689	5202	100	applied	\N	\N	\N	\N	20287	20287	19771
6689	5204	101	applied	\N	\N	\N	\N	20288	20288	19775
6689	5207	102	applied	\N	\N	\N	\N	20289	20289	19783
6689	5209	103	applied	\N	\N	\N	\N	20290	20290	19791
6689	5212	105	applied	\N	\N	\N	\N	20292	20292	19799
6689	5213	106	applied	\N	\N	\N	\N	20293	20293	19801
6689	5215	107	applied	\N	\N	\N	\N	20294	20294	19813
6689	5218	108	applied	\N	\N	\N	\N	20295	20295	19820
6689	5219	109	applied	\N	\N	\N	\N	20296	20296	19822
6689	5221	110	applied	\N	\N	\N	\N	20297	20297	19828
6689	5225	111	applied	\N	\N	\N	\N	20298	20298	19836
6689	5227	112	applied	\N	\N	\N	\N	20299	20299	19840
6689	5228	113	applied	\N	\N	\N	\N	20300	20300	19842
6689	5229	114	applied	\N	\N	\N	\N	20301	20301	19844
6689	5230	115	applied	\N	\N	\N	\N	20302	20302	19850
6689	5232	116	applied	\N	\N	\N	\N	20303	20303	19856
6689	5234	117	applied	\N	\N	\N	\N	20304	20304	19867
6689	5236	118	applied	\N	\N	\N	\N	20305	20305	19873
6689	5239	119	applied	\N	\N	\N	\N	20306	20306	19881
6689	5241	120	applied	\N	\N	\N	\N	20307	20307	19887
6689	5243	121	applied	\N	\N	\N	\N	20308	20308	19893
6689	5246	122	applied	\N	\N	\N	\N	20309	20309	19901
6689	5247	123	applied	\N	\N	\N	\N	20310	20310	19903
6689	5252	124	applied	\N	\N	\N	\N	20311	20311	19917
6690	5232	0	applied	\N	\N	\N	\N	19855	19855	19856
6690	5234	1	applied	\N	\N	\N	\N	19866	19866	19867
6690	5236	2	applied	\N	\N	\N	\N	19872	19872	19873
6690	5329	3	applied	\N	\N	\N	\N	20139	20139	20316
6690	5335	4	applied	\N	\N	\N	\N	20162	20162	20305
6690	5233	5	applied	\N	\N	\N	\N	19857	19857	19858
6690	5235	6	applied	\N	\N	\N	\N	19868	19868	19869
6690	5237	7	applied	\N	\N	\N	\N	19874	19874	19875
6690	5238	8	applied	\N	\N	\N	\N	19878	19878	19879
6690	5240	9	applied	\N	\N	\N	\N	19884	19884	19885
6690	5242	10	applied	\N	\N	\N	\N	19890	19890	19891
6690	5244	11	applied	\N	\N	\N	\N	19896	19896	19897
6690	5245	12	applied	\N	\N	\N	\N	19898	19898	19899
6690	5248	13	applied	\N	\N	\N	\N	19906	19906	19907
6690	5239	14	applied	\N	\N	\N	\N	20306	20306	19881
6690	5241	15	applied	\N	\N	\N	\N	20307	20307	19887
6690	5243	16	applied	\N	\N	\N	\N	20308	20308	19893
6690	5246	17	applied	\N	\N	\N	\N	20309	20309	19901
6690	5247	18	applied	\N	\N	\N	\N	20310	20310	19903
6690	5252	19	applied	\N	\N	\N	\N	20311	20311	19917
6690	5253	20	applied	\N	\N	\N	\N	20317	20317	19919
6690	5254	21	applied	\N	\N	\N	\N	20318	20318	19921
6690	5255	22	applied	\N	\N	\N	\N	20319	20319	19925
6690	5258	23	applied	\N	\N	\N	\N	20320	20320	19932
6690	5260	24	applied	\N	\N	\N	\N	20321	20321	19940
6690	5261	25	applied	\N	\N	\N	\N	20322	20322	19948
6690	5263	26	applied	\N	\N	\N	\N	20323	20323	19954
6690	5267	27	applied	\N	\N	\N	\N	20324	20324	19962
6690	5268	28	applied	\N	\N	\N	\N	20325	20325	19964
6690	5271	29	applied	\N	\N	\N	\N	20326	20326	19972
6690	5272	30	applied	\N	\N	\N	\N	20327	20327	19974
6690	5273	31	applied	\N	\N	\N	\N	20328	20328	19978
6690	5275	32	applied	\N	\N	\N	\N	20329	20329	19983
6690	5276	33	applied	\N	\N	\N	\N	20330	20330	19985
6690	5249	34	applied	\N	\N	\N	\N	19908	19908	19909
6690	5250	35	applied	\N	\N	\N	\N	19910	19910	19911
6690	5256	36	applied	\N	\N	\N	\N	19927	19927	19928
6690	5257	37	applied	\N	\N	\N	\N	19929	19929	19930
6690	5259	38	applied	\N	\N	\N	\N	19937	19937	19938
6690	5262	39	applied	\N	\N	\N	\N	19949	19949	19950
6690	5264	41	applied	\N	\N	\N	\N	19955	19955	19956
6690	5265	42	applied	\N	\N	\N	\N	19957	19957	19958
6690	5266	43	applied	\N	\N	\N	\N	19959	19959	19960
6690	5269	44	applied	\N	\N	\N	\N	19967	19967	19968
6690	5270	45	applied	\N	\N	\N	\N	19969	19969	19970
6690	5274	46	applied	\N	\N	\N	\N	19979	19979	19980
6690	5277	47	applied	\N	\N	\N	\N	19986	19986	19987
6690	5278	48	applied	\N	\N	\N	\N	19988	19988	19989
6690	5279	49	applied	\N	\N	\N	\N	19991	19991	19992
6690	5280	50	applied	\N	\N	\N	\N	19993	19993	19994
6690	5251	51	applied	\N	\N	\N	\N	19912	19912	19913
6690	5284	52	applied	\N	\N	\N	\N	20003	20003	20004
6690	5285	53	applied	\N	\N	\N	\N	20007	20007	20008
6690	5288	54	applied	\N	\N	\N	\N	20016	20016	20017
6690	5291	55	applied	\N	\N	\N	\N	20025	20025	20026
6690	5292	56	applied	\N	\N	\N	\N	20027	20027	20028
6690	5293	57	applied	\N	\N	\N	\N	20030	20030	20031
6690	5295	58	applied	\N	\N	\N	\N	20035	20035	20036
6690	5297	59	applied	\N	\N	\N	\N	20043	20043	20044
6690	5298	60	applied	\N	\N	\N	\N	20045	20045	20046
6690	5299	61	applied	\N	\N	\N	\N	20047	20047	20048
6690	5303	62	applied	\N	\N	\N	\N	20057	20057	20058
6690	5306	63	applied	\N	\N	\N	\N	20066	20066	20067
6690	5308	64	applied	\N	\N	\N	\N	20076	20076	20077
6690	5281	65	applied	\N	\N	\N	\N	20332	20332	19996
6690	5282	66	applied	\N	\N	\N	\N	20333	20333	19998
6690	5283	67	applied	\N	\N	\N	\N	20334	20334	20002
6690	5286	68	applied	\N	\N	\N	\N	20335	20335	20010
6690	5287	69	applied	\N	\N	\N	\N	20336	20336	20015
6690	5289	70	applied	\N	\N	\N	\N	20337	20337	20022
6690	5290	71	applied	\N	\N	\N	\N	20338	20338	20024
6690	5294	72	applied	\N	\N	\N	\N	20339	20339	20033
6690	5296	73	applied	\N	\N	\N	\N	20340	20340	20038
6690	5300	74	applied	\N	\N	\N	\N	20341	20341	20050
6690	5301	75	applied	\N	\N	\N	\N	20342	20342	20052
6690	5302	76	applied	\N	\N	\N	\N	20343	20343	20054
6690	5304	77	applied	\N	\N	\N	\N	20344	20344	20060
6690	5305	78	applied	\N	\N	\N	\N	20345	20345	20065
6690	5307	79	applied	\N	\N	\N	\N	20346	20346	20075
6690	5309	80	applied	\N	\N	\N	\N	20347	20347	20082
6690	5311	81	applied	\N	\N	\N	\N	20348	20348	20090
6690	5315	82	applied	\N	\N	\N	\N	20349	20349	20098
6690	5316	83	applied	\N	\N	\N	\N	20350	20350	20100
6690	5317	84	applied	\N	\N	\N	\N	20351	20351	20106
6690	5319	85	applied	\N	\N	\N	\N	20352	20352	20112
6690	5321	86	applied	\N	\N	\N	\N	20353	20353	20122
6690	5322	87	applied	\N	\N	\N	\N	20354	20354	20124
6690	5326	88	applied	\N	\N	\N	\N	20355	20355	20133
6690	5328	89	applied	\N	\N	\N	\N	20356	20356	20137
6690	5330	90	applied	\N	\N	\N	\N	20357	20357	20142
6690	5331	91	applied	\N	\N	\N	\N	20163	20163	20145
6690	5336	92	applied	\N	\N	\N	\N	20164	20164	20165
6690	5339	93	applied	\N	\N	\N	\N	20171	20171	20172
6690	5340	94	applied	\N	\N	\N	\N	20173	20173	20174
6690	5346	95	applied	\N	\N	\N	\N	20193	20193	20194
6690	5347	96	applied	\N	\N	\N	\N	20195	20195	20196
6690	5348	97	applied	\N	\N	\N	\N	20197	20197	20198
6690	5352	98	applied	\N	\N	\N	\N	20358	20358	20213
6690	5353	99	applied	\N	\N	\N	\N	20359	20359	20215
6690	5356	100	applied	\N	\N	\N	\N	20360	20360	20361
6690	5310	101	applied	\N	\N	\N	\N	20083	20083	20084
6690	5312	102	applied	\N	\N	\N	\N	20091	20091	20092
6690	5313	103	applied	\N	\N	\N	\N	20093	20093	20094
6690	5314	104	applied	\N	\N	\N	\N	20095	20095	20096
6690	5318	105	applied	\N	\N	\N	\N	20107	20107	20108
6690	5320	106	applied	\N	\N	\N	\N	20113	20113	20114
6690	5323	107	applied	\N	\N	\N	\N	20125	20125	20126
6690	5324	108	applied	\N	\N	\N	\N	20127	20127	20128
6690	5325	109	applied	\N	\N	\N	\N	20130	20130	20131
6690	5327	110	applied	\N	\N	\N	\N	20134	20134	20135
6690	5332	111	applied	\N	\N	\N	\N	20146	20146	20147
6690	5333	112	applied	\N	\N	\N	\N	20148	20148	20149
6690	5334	113	applied	\N	\N	\N	\N	20160	20160	20161
6690	5337	114	applied	\N	\N	\N	\N	20167	20167	20168
6690	5338	115	applied	\N	\N	\N	\N	20169	20169	20170
6690	5349	116	applied	\N	\N	\N	\N	20199	20199	20200
6690	5350	117	applied	\N	\N	\N	\N	20201	20201	20202
6690	5351	118	applied	\N	\N	\N	\N	20203	20203	20204
6690	5354	119	applied	\N	\N	\N	\N	20216	20216	20217
6690	5355	120	applied	\N	\N	\N	\N	20218	20218	20219
6690	5357	121	applied	\N	\N	\N	\N	20362	20362	20363
6690	5341	122	applied	\N	\N	\N	\N	20181	20181	20364
6690	5342	123	applied	\N	\N	\N	\N	20183	20183	20365
6690	5343	124	applied	\N	\N	\N	\N	20185	20185	20366
6690	5344	125	applied	\N	\N	\N	\N	20187	20187	20367
6691	5356	0	applied	\N	\N	\N	\N	20371	20371	20361
6691	5358	1	applied	\N	\N	\N	\N	20372	20372	20373
6691	5357	2	applied	\N	\N	\N	\N	20362	20362	20363
6691	5359	3	applied	\N	\N	\N	\N	20374	20374	20375
6692	5356	0	applied	\N	\N	\N	\N	20371	20371	20361
6692	5358	1	applied	\N	\N	\N	\N	20372	20372	20373
6692	5357	2	applied	\N	\N	\N	\N	20362	20362	20363
6692	5359	3	applied	\N	\N	\N	\N	20374	20374	20375
6693	5360	0	applied	\N	\N	\N	\N	20380	20380	20381
6693	5361	1	applied	\N	\N	\N	\N	20382	20382	20383
6694	5362	0	applied	\N	\N	\N	\N	20384	20384	20385
6694	5363	1	applied	\N	\N	\N	\N	20386	20386	20387
6694	5364	2	applied	\N	\N	\N	\N	20388	20388	20389
6694	5365	3	applied	\N	\N	\N	\N	20390	20390	20391
6694	5366	4	applied	\N	\N	\N	\N	20392	20392	20393
6694	5367	5	applied	\N	\N	\N	\N	20394	20394	20395
6695	5368	0	applied	\N	\N	\N	\N	20397	20397	20398
6695	5369	1	applied	\N	\N	\N	\N	20399	20399	20400
6695	5370	2	applied	\N	\N	\N	\N	20401	20401	20402
6695	5371	3	applied	\N	\N	\N	\N	20403	20403	20404
6696	5368	0	applied	\N	\N	\N	\N	20397	20397	20398
6696	5369	1	applied	\N	\N	\N	\N	20399	20399	20400
6696	5370	2	applied	\N	\N	\N	\N	20401	20401	20402
6696	5371	3	applied	\N	\N	\N	\N	20403	20403	20404
6697	5372	0	applied	\N	\N	\N	\N	20409	20409	20410
6697	5373	1	applied	\N	\N	\N	\N	20411	20411	20412
6697	5374	2	applied	\N	\N	\N	\N	20413	20413	20414
6697	5375	3	applied	\N	\N	\N	\N	20415	20415	20416
6698	5372	0	applied	\N	\N	\N	\N	20409	20409	20410
6698	5373	1	applied	\N	\N	\N	\N	20411	20411	20412
6698	5374	2	applied	\N	\N	\N	\N	20413	20413	20414
6698	5375	3	applied	\N	\N	\N	\N	20415	20415	20416
6699	5376	0	applied	\N	\N	\N	\N	20420	20420	20421
6699	5377	1	applied	\N	\N	\N	\N	20422	20422	20423
6700	5378	0	applied	\N	\N	\N	\N	20426	20426	20427
6700	5379	1	applied	\N	\N	\N	\N	20428	20428	20429
6701	5378	0	applied	\N	\N	\N	\N	20426	20426	20427
6701	5379	1	applied	\N	\N	\N	\N	20428	20428	20429
6710	5402	0	applied	\N	\N	\N	\N	20489	20489	20490
6710	5403	1	applied	\N	\N	\N	\N	20491	20491	20492
6712	5402	0	applied	\N	\N	\N	\N	20489	20489	20490
6712	5403	1	applied	\N	\N	\N	\N	20491	20491	20492
6715	5406	0	applied	\N	\N	\N	\N	20501	20501	20502
6715	5407	1	applied	\N	\N	\N	\N	20503	20503	20504
6718	5414	0	applied	\N	\N	\N	\N	20521	20521	20522
6718	5415	1	applied	\N	\N	\N	\N	20523	20523	20524
6718	5416	2	applied	\N	\N	\N	\N	20525	20525	20526
6718	5417	3	applied	\N	\N	\N	\N	20527	20527	20528
6721	5422	0	applied	\N	\N	\N	\N	20549	20549	20550
6721	5423	1	applied	\N	\N	\N	\N	20551	20551	20552
6721	5424	2	applied	\N	\N	\N	\N	20553	20553	20554
6721	5425	3	applied	\N	\N	\N	\N	20555	20555	20556
6723	5426	0	applied	\N	\N	\N	\N	20561	20561	20562
6723	5427	1	applied	\N	\N	\N	\N	20563	20563	20564
6730	5434	0	applied	\N	\N	\N	\N	20582	20582	20583
6730	5435	1	applied	\N	\N	\N	\N	20584	20584	20585
6733	5436	0	applied	\N	\N	\N	\N	20590	20590	20591
6733	5437	1	applied	\N	\N	\N	\N	20592	20592	20593
6733	5438	2	applied	\N	\N	\N	\N	20594	20594	20595
6733	5439	3	applied	\N	\N	\N	\N	20596	20596	20597
6742	5448	0	applied	\N	\N	\N	\N	20622	20622	20623
6742	5449	1	applied	\N	\N	\N	\N	20624	20624	20625
6752	5462	0	applied	\N	\N	\N	\N	20662	20662	20663
6752	5463	1	applied	\N	\N	\N	\N	20664	20664	20665
6764	5483	0	applied	\N	\N	1000000000	\N	20725	20725	20726
6764	5484	1	applied	\N	\N	\N	\N	20727	20727	20728
6764	5485	2	applied	\N	\N	\N	\N	20729	20729	20730
6766	5486	0	applied	\N	\N	\N	\N	20733	20733	20734
6769	5487	0	applied	\N	\N	\N	\N	20739	20739	20740
6769	5488	1	applied	\N	\N	\N	\N	20741	20741	20742
6769	5489	2	applied	\N	\N	\N	\N	20743	20743	20744
6769	5490	3	applied	\N	\N	\N	\N	20745	20745	20746
6774	5493	0	applied	\N	\N	\N	\N	20758	20758	20759
6774	5494	1	applied	\N	\N	\N	\N	20760	20760	20761
6778	5499	0	applied	\N	\N	\N	\N	20782	20782	20783
6778	5500	1	applied	\N	\N	\N	\N	20784	20784	20785
6783	5505	0	applied	\N	\N	\N	\N	20797	20797	20798
6783	5506	1	applied	\N	\N	\N	\N	20799	20799	20800
6786	5509	0	applied	\N	\N	\N	\N	20813	20813	20814
6786	5510	1	applied	\N	\N	\N	\N	20815	20815	20816
6786	5511	2	applied	\N	\N	\N	\N	20817	20817	20818
6786	5512	3	applied	\N	\N	\N	\N	20819	20819	20820
6792	5515	0	applied	\N	\N	\N	\N	20833	20833	20834
6792	5516	1	applied	\N	\N	\N	\N	20835	20835	20836
6792	5517	2	applied	\N	\N	\N	\N	20837	20837	20838
6792	5518	3	applied	\N	\N	\N	\N	20839	20839	20840
6800	5533	0	applied	\N	\N	\N	\N	20885	20885	20886
6800	5534	1	applied	\N	\N	\N	\N	20887	20887	20888
6810	5537	0	applied	\N	\N	\N	\N	20905	20905	20906
6810	5538	1	applied	\N	\N	\N	\N	20907	20907	20908
6810	5539	2	applied	\N	\N	\N	\N	20909	20909	20910
6810	5540	3	applied	\N	\N	\N	\N	20911	20911	20912
6811	5541	0	applied	\N	\N	\N	\N	20917	20917	20918
6811	5542	1	applied	\N	\N	\N	\N	20919	20919	20920
6814	5545	0	applied	\N	\N	\N	\N	20927	20927	20928
6814	5546	1	applied	\N	\N	1000000000	\N	20929	20929	20930
6814	5547	2	applied	\N	\N	1000000000	\N	20931	20931	20932
6814	5548	3	applied	\N	\N	\N	\N	20933	20933	20934
6816	5549	0	applied	\N	\N	\N	\N	20938	20938	20939
6816	5550	1	applied	\N	\N	\N	\N	20940	20940	20941
6816	5551	2	applied	\N	\N	\N	\N	20942	20942	20943
6816	5552	3	applied	\N	\N	\N	\N	20944	20944	20945
6822	5566	0	applied	\N	\N	\N	\N	20984	20984	20985
6822	5567	1	applied	\N	\N	\N	\N	20986	20986	20987
6824	5566	0	applied	\N	\N	\N	\N	20984	20984	20985
6824	5567	1	applied	\N	\N	\N	\N	20986	20986	20987
6826	5568	0	applied	\N	\N	\N	\N	20994	20994	20995
6826	5569	1	applied	\N	\N	\N	\N	20996	20996	20997
6827	5570	0	applied	\N	\N	\N	\N	20999	20999	21000
6827	5571	1	applied	\N	\N	\N	\N	21001	21001	21002
6827	5572	2	applied	\N	\N	\N	\N	21003	21003	21004
6827	5573	3	applied	\N	\N	\N	\N	21005	21005	21006
6827	5574	4	applied	\N	\N	\N	\N	21007	21007	21008
6827	5575	5	applied	\N	\N	\N	\N	21009	21009	21010
6827	5576	6	applied	\N	\N	\N	\N	21011	21011	21012
6827	5577	7	applied	\N	\N	\N	\N	21013	21013	21014
6830	5578	0	applied	\N	\N	\N	\N	21017	21017	21018
6830	5579	1	applied	\N	\N	\N	\N	21019	21019	21020
6834	5580	0	applied	\N	\N	\N	\N	21027	21027	21028
6834	5581	1	applied	\N	\N	\N	\N	21029	21029	21030
6837	5582	0	applied	\N	\N	\N	\N	21033	21033	21034
6837	5583	1	applied	\N	\N	\N	\N	21035	21035	21036
6843	5588	0	applied	\N	\N	\N	\N	21049	21049	21050
6848	5595	0	applied	\N	\N	\N	\N	21070	21070	21071
6848	5596	1	applied	\N	\N	\N	\N	21072	21072	21073
6848	5597	2	applied	\N	\N	\N	\N	21074	21074	21075
6850	5592	0	applied	\N	\N	\N	\N	21064	21064	21065
6850	5593	1	applied	\N	\N	\N	\N	21066	21066	21067
6850	5594	2	applied	\N	\N	\N	\N	21068	21068	21069
6850	5595	3	applied	\N	\N	\N	\N	21070	21070	21071
6850	5596	4	applied	\N	\N	\N	\N	21072	21072	21073
6850	5597	5	applied	\N	\N	\N	\N	21074	21074	21075
6850	5598	6	applied	\N	\N	\N	\N	21084	21084	21085
6857	5606	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	21109	21109	\N
6857	5607	1	applied	\N	\N	\N	\N	21110	21110	21111
6857	5608	2	applied	\N	\N	\N	\N	21112	21112	21113
6857	5609	3	applied	\N	\N	\N	\N	21114	21114	21115
6857	5610	4	applied	\N	\N	\N	\N	21116	21116	21117
6857	5611	5	applied	\N	\N	\N	\N	21118	21118	21119
6857	5612	6	applied	\N	\N	\N	\N	21120	21120	21121
6857	5613	7	applied	\N	\N	\N	\N	21122	21122	21123
6857	5614	8	applied	\N	\N	\N	\N	21124	21124	21125
6859	5615	0	applied	\N	\N	\N	\N	21128	21128	21129
6859	5616	1	applied	\N	\N	\N	\N	21130	21130	21131
6864	5625	0	applied	\N	\N	\N	\N	21158	21158	21159
6864	5626	1	applied	\N	\N	\N	\N	21160	21160	21161
6864	5627	2	applied	\N	\N	\N	\N	21162	21162	21163
6864	5628	3	applied	\N	\N	1000000000	\N	21164	21164	21165
6864	5629	4	applied	\N	\N	\N	\N	21166	21166	21167
6869	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6869	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6872	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6872	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6878	5358	0	applied	\N	\N	\N	\N	21215	21215	20373
6878	5359	1	applied	\N	\N	\N	\N	20374	20374	20375
6702	5185	0	applied	\N	\N	\N	\N	19725	19725	19650
6702	5329	1	applied	\N	\N	\N	\N	20139	20139	20432
6702	5335	3	applied	\N	\N	\N	\N	20162	20162	20274
6702	5188	4	applied	\N	\N	\N	\N	19732	19732	19650
6702	5197	5	applied	\N	\N	1000000000	\N	19756	19756	19757
6702	5175	6	applied	\N	\N	\N	\N	19688	19688	19689
6702	5177	7	applied	\N	\N	\N	\N	19693	19693	19694
6702	5178	8	applied	\N	\N	\N	\N	19695	19695	19696
6702	5182	9	applied	\N	\N	\N	\N	19710	19710	19711
6702	5184	10	applied	\N	\N	\N	\N	19716	19716	19717
6702	5187	11	applied	\N	\N	\N	\N	19728	19728	19729
6702	5176	12	applied	\N	\N	\N	\N	20275	20275	19691
6702	5179	13	applied	\N	\N	\N	\N	20276	20276	19698
6702	5189	14	applied	\N	\N	\N	\N	19733	19733	19734
6702	5190	15	applied	\N	\N	\N	\N	19735	19735	19736
6702	5196	16	applied	\N	\N	\N	\N	19754	19754	19755
6702	5200	17	applied	\N	\N	\N	\N	19762	19762	19763
6702	5201	18	applied	\N	\N	\N	\N	19764	19764	19765
6702	5251	19	applied	\N	\N	\N	\N	19912	19912	19913
6702	5203	20	applied	\N	\N	\N	\N	19772	19772	19773
6702	5205	21	applied	\N	\N	\N	\N	19776	19776	19777
6702	5206	22	applied	\N	\N	\N	\N	19780	19780	19781
6702	5208	23	applied	\N	\N	\N	\N	19788	19788	19789
6702	5210	24	applied	\N	\N	\N	\N	19794	19794	19795
6702	5211	25	applied	\N	\N	\N	\N	19796	19796	19797
6702	5214	26	applied	\N	\N	\N	\N	19810	19810	19811
6702	5216	27	applied	\N	\N	\N	\N	19815	19815	19816
6702	5217	28	applied	\N	\N	\N	\N	19817	19817	19818
6702	5220	29	applied	\N	\N	\N	\N	19825	19825	19826
6702	5222	30	applied	\N	\N	\N	\N	19829	19829	19830
6702	5223	31	applied	\N	\N	\N	\N	19831	19831	19832
6702	5224	32	applied	\N	\N	\N	\N	19833	19833	19834
6702	5226	33	applied	\N	\N	\N	\N	19837	19837	19838
6702	5231	34	applied	\N	\N	\N	\N	19851	19851	19852
6702	5233	35	applied	\N	\N	\N	\N	19857	19857	19858
6702	5235	36	applied	\N	\N	\N	\N	19868	19868	19869
6702	5237	37	applied	\N	\N	\N	\N	19874	19874	19875
6702	5238	38	applied	\N	\N	\N	\N	19878	19878	19879
6702	5240	39	applied	\N	\N	\N	\N	19884	19884	19885
6702	5242	40	applied	\N	\N	\N	\N	19890	19890	19891
6702	5244	41	applied	\N	\N	\N	\N	19896	19896	19897
6702	5245	42	applied	\N	\N	\N	\N	19898	19898	19899
6702	5248	43	applied	\N	\N	\N	\N	19906	19906	19907
6702	5249	44	applied	\N	\N	\N	\N	19908	19908	19909
6702	5250	45	applied	\N	\N	\N	\N	19910	19910	19911
6702	5256	46	applied	\N	\N	\N	\N	19927	19927	19928
6702	5257	47	applied	\N	\N	\N	\N	19929	19929	19930
6702	5259	48	applied	\N	\N	\N	\N	19937	19937	19938
6702	5262	49	applied	\N	\N	\N	\N	19949	19949	19950
6702	5264	50	applied	\N	\N	\N	\N	19955	19955	19956
6702	5265	51	applied	\N	\N	\N	\N	19957	19957	19958
6702	5266	52	applied	\N	\N	\N	\N	19959	19959	19960
6702	5269	53	applied	\N	\N	\N	\N	19967	19967	19968
6702	5270	54	applied	\N	\N	\N	\N	19969	19969	19970
6702	5274	55	applied	\N	\N	\N	\N	19979	19979	19980
6702	5277	56	applied	\N	\N	\N	\N	19986	19986	19987
6702	5278	57	applied	\N	\N	\N	\N	19988	19988	19989
6702	5279	58	applied	\N	\N	\N	\N	19991	19991	19992
6702	5280	59	applied	\N	\N	\N	\N	19993	19993	19994
6702	5284	60	applied	\N	\N	\N	\N	20003	20003	20004
6702	5285	61	applied	\N	\N	\N	\N	20007	20007	20008
6702	5288	62	applied	\N	\N	\N	\N	20016	20016	20017
6702	5291	63	applied	\N	\N	\N	\N	20025	20025	20026
6702	5292	64	applied	\N	\N	\N	\N	20027	20027	20028
6702	5293	65	applied	\N	\N	\N	\N	20030	20030	20031
6702	5295	66	applied	\N	\N	\N	\N	20035	20035	20036
6702	5297	67	applied	\N	\N	\N	\N	20043	20043	20044
6702	5298	68	applied	\N	\N	\N	\N	20045	20045	20046
6702	5299	69	applied	\N	\N	\N	\N	20047	20047	20048
6702	5303	70	applied	\N	\N	\N	\N	20057	20057	20058
6702	5306	71	applied	\N	\N	\N	\N	20066	20066	20067
6702	5308	72	applied	\N	\N	\N	\N	20076	20076	20077
6702	5180	73	applied	\N	\N	\N	\N	20277	20277	19700
6702	5181	74	applied	\N	\N	\N	\N	20278	20278	19709
6702	5183	75	applied	\N	\N	\N	\N	20279	20279	19715
6702	5186	76	applied	\N	\N	\N	\N	20280	20280	19727
6702	5191	77	applied	\N	\N	\N	\N	20281	20281	19738
6702	5192	78	applied	\N	\N	\N	\N	20282	20282	19740
6702	5194	79	applied	\N	\N	\N	\N	20283	20283	19751
6702	5195	80	applied	\N	\N	\N	\N	20284	20284	19753
6702	5198	81	applied	\N	\N	\N	\N	20285	20285	19759
6702	5199	82	applied	\N	\N	\N	\N	20286	20286	19761
6702	5202	83	applied	\N	\N	\N	\N	20287	20287	19771
6702	5204	84	applied	\N	\N	\N	\N	20288	20288	19775
6702	5207	85	applied	\N	\N	\N	\N	20289	20289	19783
6702	5209	86	applied	\N	\N	\N	\N	20290	20290	19791
6702	5212	87	applied	\N	\N	\N	\N	20292	20292	19799
6702	5213	88	applied	\N	\N	\N	\N	20293	20293	19801
6702	5215	89	applied	\N	\N	\N	\N	20294	20294	19813
6702	5218	90	applied	\N	\N	\N	\N	20295	20295	19820
6702	5219	91	applied	\N	\N	\N	\N	20296	20296	19822
6702	5221	92	applied	\N	\N	\N	\N	20297	20297	19828
6702	5225	93	applied	\N	\N	\N	\N	20298	20298	19836
6702	5227	94	applied	\N	\N	\N	\N	20299	20299	19840
6702	5228	95	applied	\N	\N	\N	\N	20300	20300	19842
6702	5229	96	applied	\N	\N	\N	\N	20301	20301	19844
6702	5230	97	applied	\N	\N	\N	\N	20302	20302	19850
6702	5232	98	applied	\N	\N	\N	\N	20303	20303	19856
6702	5234	99	applied	\N	\N	\N	\N	20304	20304	19867
6702	5236	100	applied	\N	\N	\N	\N	20305	20305	19873
6702	5239	101	applied	\N	\N	\N	\N	20306	20306	19881
6702	5241	102	applied	\N	\N	\N	\N	20307	20307	19887
6702	5243	103	applied	\N	\N	\N	\N	20308	20308	19893
6702	5246	104	applied	\N	\N	\N	\N	20309	20309	19901
6702	5247	105	applied	\N	\N	\N	\N	20310	20310	19903
6702	5252	106	applied	\N	\N	\N	\N	20311	20311	19917
6702	5253	107	applied	\N	\N	\N	\N	20317	20317	19919
6702	5254	108	applied	\N	\N	\N	\N	20318	20318	19921
6702	5255	109	applied	\N	\N	\N	\N	20319	20319	19925
6702	5258	110	applied	\N	\N	\N	\N	20320	20320	19932
6702	5260	111	applied	\N	\N	\N	\N	20321	20321	19940
6702	5261	112	applied	\N	\N	\N	\N	20322	20322	19948
6702	5263	113	applied	\N	\N	\N	\N	20323	20323	19954
6702	5267	114	applied	\N	\N	\N	\N	20324	20324	19962
6702	5268	115	applied	\N	\N	\N	\N	20325	20325	19964
6702	5271	116	applied	\N	\N	\N	\N	20326	20326	19972
6702	5272	117	applied	\N	\N	\N	\N	20327	20327	19974
6702	5273	118	applied	\N	\N	\N	\N	20328	20328	19978
6702	5275	119	applied	\N	\N	\N	\N	20329	20329	19983
6702	5276	120	applied	\N	\N	\N	\N	20330	20330	19985
6702	5281	121	applied	\N	\N	\N	\N	20332	20332	19996
6702	5282	122	applied	\N	\N	\N	\N	20333	20333	19998
6702	5283	123	applied	\N	\N	\N	\N	20334	20334	20002
6702	5286	124	applied	\N	\N	\N	\N	20335	20335	20010
6702	5287	125	applied	\N	\N	\N	\N	20336	20336	20015
6705	5390	0	applied	\N	\N	\N	\N	20459	20459	20460
6705	5391	1	applied	\N	\N	\N	\N	20461	20461	20462
6708	5398	0	applied	\N	\N	\N	\N	20480	20480	20481
6708	5399	1	applied	\N	\N	\N	\N	20482	20482	20483
6713	5404	0	applied	\N	\N	\N	\N	20497	20497	20498
6713	5405	1	applied	\N	\N	\N	\N	20499	20499	20500
6719	5418	0	applied	\N	\N	\N	\N	20531	20531	20532
6719	5419	1	applied	\N	\N	\N	\N	20533	20533	20534
6719	5420	2	applied	\N	\N	\N	\N	20535	20535	20536
6719	5421	3	applied	\N	\N	\N	\N	20537	20537	20538
6726	5428	0	applied	\N	\N	\N	\N	20565	20565	20566
6726	5429	1	applied	\N	\N	\N	\N	20567	20567	20568
6731	5434	0	applied	\N	\N	\N	\N	20582	20582	20583
6731	5435	1	applied	\N	\N	\N	\N	20584	20584	20585
6738	5442	0	applied	\N	\N	\N	\N	20605	20605	20606
6738	5443	1	applied	\N	\N	\N	\N	20607	20607	20608
6740	5444	0	applied	\N	\N	\N	\N	20612	20612	20613
6740	5445	1	applied	\N	\N	\N	\N	20614	20614	20615
6743	5448	0	applied	\N	\N	\N	\N	20622	20622	20623
6743	5449	1	applied	\N	\N	\N	\N	20624	20624	20625
6747	5454	0	applied	\N	\N	\N	\N	20639	20639	20640
6747	5455	1	applied	\N	\N	\N	\N	20641	20641	20642
6750	5460	0	applied	\N	\N	\N	\N	20656	20656	20657
6750	5461	1	applied	\N	\N	\N	\N	20658	20658	20659
6757	5468	0	applied	\N	\N	\N	\N	20686	20686	20687
6757	5469	1	applied	\N	\N	\N	\N	20688	20688	20689
6760	5470	0	applied	\N	\N	\N	\N	20692	20692	20693
6760	5471	1	applied	\N	\N	\N	\N	20694	20694	20695
6760	5472	2	applied	\N	\N	\N	\N	20696	20696	20697
6760	5473	3	applied	\N	\N	\N	\N	20698	20698	20699
6760	5474	4	applied	\N	\N	\N	\N	20700	20700	20701
6760	5475	5	applied	\N	\N	\N	\N	20702	20702	20703
6760	5476	6	applied	\N	\N	\N	\N	20704	20704	20705
6760	5477	7	applied	\N	\N	\N	\N	20706	20706	20707
6762	5478	0	applied	\N	\N	1000000000	\N	20712	20712	20713
6762	5479	1	applied	\N	\N	1000000000	\N	20714	20714	20715
6762	5480	2	applied	\N	\N	\N	\N	20716	20716	20717
6762	5481	3	applied	\N	\N	\N	\N	20718	20718	20719
6762	5482	4	applied	\N	\N	1000000000	\N	20720	20720	20721
6776	5495	0	applied	\N	\N	\N	\N	20770	20770	20771
6776	5496	1	applied	\N	\N	\N	\N	20772	20772	20773
6781	5503	0	applied	\N	\N	\N	\N	20791	20791	20792
6781	5504	1	applied	\N	\N	\N	\N	20793	20793	20794
6787	5509	0	applied	\N	\N	\N	\N	20813	20813	20814
6787	5510	1	applied	\N	\N	\N	\N	20815	20815	20816
6787	5511	2	applied	\N	\N	\N	\N	20817	20817	20818
6787	5512	3	applied	\N	\N	\N	\N	20819	20819	20820
6788	5513	0	applied	\N	\N	\N	\N	20825	20825	20826
6788	5514	1	applied	\N	\N	\N	\N	20827	20827	20828
6790	5513	0	applied	\N	\N	\N	\N	20825	20825	20826
6790	5514	1	applied	\N	\N	\N	\N	20827	20827	20828
6793	5519	0	applied	\N	\N	\N	\N	20845	20845	20846
6793	5520	1	applied	\N	\N	\N	\N	20847	20847	20848
6795	5521	0	applied	\N	\N	\N	\N	20851	20851	20852
6795	5522	1	applied	\N	\N	\N	\N	20853	20853	20854
6798	5525	0	applied	\N	\N	\N	\N	20865	20865	20866
6798	5526	1	applied	\N	\N	1000000000	\N	20867	20867	20868
6798	5527	2	applied	\N	\N	\N	\N	20869	20869	20870
6798	5528	3	applied	\N	\N	\N	\N	20871	20871	20872
6798	5529	4	applied	\N	\N	\N	\N	20873	20873	20874
6798	5530	5	applied	\N	\N	\N	\N	20875	20875	20876
6801	5533	0	applied	\N	\N	\N	\N	20885	20885	20886
6801	5534	1	applied	\N	\N	\N	\N	20887	20887	20888
6805	5535	0	applied	\N	\N	\N	\N	20895	20895	20896
6807	5535	0	applied	\N	\N	\N	\N	20895	20895	20896
6807	5536	1	applied	\N	\N	\N	\N	20899	20899	20900
6812	5543	0	applied	\N	\N	\N	\N	20923	20923	20924
6812	5544	1	applied	\N	\N	\N	\N	20925	20925	20926
6817	5553	0	applied	\N	\N	\N	\N	20948	20948	20949
6817	5554	1	applied	\N	\N	\N	\N	20950	20950	20951
6817	5555	2	applied	\N	\N	1000000000	\N	20952	20952	20953
6819	5556	0	applied	\N	\N	\N	\N	20955	20955	20956
6819	5557	1	applied	\N	\N	\N	\N	20957	20957	20958
6828	5570	0	applied	\N	\N	\N	\N	20999	20999	21000
6828	5571	1	applied	\N	\N	\N	\N	21001	21001	21002
6828	5572	2	applied	\N	\N	\N	\N	21003	21003	21004
6828	5573	3	applied	\N	\N	\N	\N	21005	21005	21006
6828	5574	4	applied	\N	\N	\N	\N	21007	21007	21008
6828	5575	5	applied	\N	\N	\N	\N	21009	21009	21010
6828	5576	6	applied	\N	\N	\N	\N	21011	21011	21012
6828	5577	7	applied	\N	\N	\N	\N	21013	21013	21014
6832	5578	0	applied	\N	\N	\N	\N	21017	21017	21018
6832	5579	1	applied	\N	\N	\N	\N	21019	21019	21020
6839	5584	0	applied	\N	\N	\N	\N	21041	21041	21042
6839	5585	1	applied	\N	\N	\N	\N	21043	21043	21044
6839	5586	2	applied	\N	\N	\N	\N	21045	21045	21046
6839	5587	3	applied	\N	\N	\N	\N	21047	21047	21048
6841	5588	0	applied	\N	\N	\N	\N	21049	21049	21050
6841	5589	1	applied	\N	\N	\N	\N	21051	21051	21052
6846	5592	0	applied	\N	\N	\N	\N	21064	21064	21065
6846	5593	1	applied	\N	\N	\N	\N	21066	21066	21067
6846	5594	2	applied	\N	\N	\N	\N	21068	21068	21069
6846	5595	3	applied	\N	\N	\N	\N	21070	21070	21071
6846	5596	4	applied	\N	\N	\N	\N	21072	21072	21073
6846	5597	5	applied	\N	\N	\N	\N	21074	21074	21075
6855	5602	0	applied	\N	\N	\N	\N	21097	21097	21098
6855	5603	1	applied	\N	\N	\N	\N	21099	21099	21100
6855	5604	2	applied	\N	\N	\N	\N	21101	21101	21102
6855	5605	3	applied	\N	\N	\N	\N	21103	21103	21104
6862	5619	0	applied	\N	\N	\N	\N	21144	21144	21145
6862	5620	1	applied	\N	\N	\N	\N	21146	21146	21147
6862	5621	2	applied	\N	\N	\N	\N	21148	21148	21149
6862	5622	3	applied	\N	\N	\N	\N	21150	21150	21151
6865	5625	0	applied	\N	\N	\N	\N	21158	21158	21159
6865	5626	1	applied	\N	\N	\N	\N	21160	21160	21161
6865	5627	2	applied	\N	\N	\N	\N	21162	21162	21163
6865	5628	3	applied	\N	\N	1000000000	\N	21164	21164	21165
6865	5629	4	applied	\N	\N	\N	\N	21166	21166	21167
6870	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6870	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6873	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6873	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6876	5640	0	applied	\N	\N	\N	\N	21203	21203	21204
6876	5641	1	applied	\N	\N	\N	\N	21205	21205	21206
6703	5380	0	applied	\N	\N	\N	\N	20436	20436	20437
6703	5381	1	applied	\N	\N	\N	\N	20438	20438	20439
6703	5382	2	applied	\N	\N	\N	\N	20440	20440	20441
6703	5383	3	applied	\N	\N	\N	\N	20442	20442	20443
6704	5384	0	applied	\N	\N	\N	\N	20446	20446	20447
6704	5385	1	applied	\N	\N	\N	\N	20448	20448	20449
6704	5386	2	applied	\N	\N	\N	\N	20450	20450	20451
6704	5387	3	applied	\N	\N	\N	\N	20452	20452	20453
6704	5388	4	applied	\N	\N	\N	\N	20454	20454	20455
6704	5389	5	applied	\N	\N	\N	\N	20456	20456	20457
6707	5392	0	applied	\N	\N	\N	\N	20466	20466	20467
6707	5393	1	applied	\N	\N	\N	\N	20468	20468	20469
6707	5394	2	applied	\N	\N	\N	\N	20470	20470	20471
6707	5395	3	applied	\N	\N	\N	\N	20472	20472	20473
6707	5396	4	applied	\N	\N	\N	\N	20474	20474	20475
6707	5397	5	applied	\N	\N	\N	\N	20476	20476	20477
6714	5406	0	applied	\N	\N	\N	\N	20501	20501	20502
6714	5407	1	applied	\N	\N	\N	\N	20503	20503	20504
6717	5412	0	applied	\N	\N	\N	\N	20515	20515	20516
6717	5413	1	applied	\N	\N	\N	\N	20517	20517	20518
6720	5185	0	applied	\N	\N	\N	\N	19725	19725	19650
6720	5329	1	applied	\N	\N	\N	\N	20139	20139	20541
6720	5335	2	applied	\N	\N	\N	\N	20162	20162	20259
6720	5188	3	applied	\N	\N	\N	\N	19732	19732	19650
6720	5197	4	applied	\N	\N	1000000000	\N	19756	19756	19757
6720	5251	5	applied	\N	\N	\N	\N	19912	19912	19913
6720	5341	6	applied	\N	\N	\N	\N	20181	20181	20542
6720	5342	7	applied	\N	\N	\N	\N	20183	20183	20543
6720	5193	8	applied	\N	\N	\N	\N	19746	19746	19766
6720	5343	9	applied	\N	\N	\N	\N	20185	20185	20544
6720	5344	10	applied	\N	\N	\N	\N	20187	20187	20545
6720	5345	11	applied	\N	\N	\N	\N	20189	20189	20546
6725	5426	0	applied	\N	\N	\N	\N	20561	20561	20562
6725	5427	1	applied	\N	\N	\N	\N	20563	20563	20564
6727	5430	0	applied	\N	\N	\N	\N	20571	20571	20572
6727	5431	1	applied	\N	\N	\N	\N	20573	20573	20574
6732	5436	0	applied	\N	\N	\N	\N	20590	20590	20591
6732	5437	1	applied	\N	\N	\N	\N	20592	20592	20593
6732	5438	2	applied	\N	\N	\N	\N	20594	20594	20595
6732	5439	3	applied	\N	\N	\N	\N	20596	20596	20597
6735	5440	0	applied	\N	\N	\N	\N	20601	20601	20602
6735	5441	1	applied	\N	\N	\N	\N	20603	20603	20604
6737	5442	0	applied	\N	\N	\N	\N	20605	20605	20606
6737	5443	1	applied	\N	\N	\N	\N	20607	20607	20608
6739	5444	0	applied	\N	\N	\N	\N	20612	20612	20613
6739	5445	1	applied	\N	\N	\N	\N	20614	20614	20615
6741	5446	0	applied	\N	\N	\N	\N	20616	20616	20617
6741	5447	1	applied	\N	\N	\N	\N	20618	20618	20619
6744	5448	0	applied	\N	\N	\N	\N	20622	20622	20623
6744	5449	1	applied	\N	\N	\N	\N	20624	20624	20625
6746	5452	0	applied	\N	\N	\N	\N	20635	20635	20636
6746	5453	1	applied	\N	\N	\N	\N	20637	20637	20638
6749	5456	0	applied	\N	\N	\N	\N	20645	20645	20646
6749	5457	1	applied	\N	\N	\N	\N	20647	20647	20648
6749	5458	2	applied	\N	\N	\N	\N	20649	20649	20650
6749	5459	3	applied	\N	\N	\N	\N	20651	20651	20652
6751	5462	0	applied	\N	\N	\N	\N	20662	20662	20663
6751	5463	1	applied	\N	\N	\N	\N	20664	20664	20665
6754	5464	0	applied	\N	\N	\N	\N	20670	20670	20671
6754	5465	1	applied	\N	\N	\N	\N	20672	20672	20673
6756	5466	0	applied	\N	\N	\N	\N	20678	20678	20679
6756	5467	1	applied	\N	\N	\N	\N	20680	20680	20681
6758	5468	0	applied	\N	\N	\N	\N	20686	20686	20687
6758	5469	1	applied	\N	\N	\N	\N	20688	20688	20689
6759	5470	0	applied	\N	\N	\N	\N	20692	20692	20693
6759	5471	1	applied	\N	\N	\N	\N	20694	20694	20695
6759	5472	2	applied	\N	\N	\N	\N	20696	20696	20697
6759	5473	3	applied	\N	\N	\N	\N	20698	20698	20699
6759	5474	4	applied	\N	\N	\N	\N	20700	20700	20701
6759	5475	5	applied	\N	\N	\N	\N	20702	20702	20703
6759	5476	6	applied	\N	\N	\N	\N	20704	20704	20705
6759	5477	7	applied	\N	\N	\N	\N	20706	20706	20707
6761	5470	0	applied	\N	\N	\N	\N	20692	20692	20693
6761	5471	1	applied	\N	\N	\N	\N	20694	20694	20695
6761	5472	2	applied	\N	\N	\N	\N	20696	20696	20697
6761	5473	3	applied	\N	\N	\N	\N	20698	20698	20699
6761	5474	4	applied	\N	\N	\N	\N	20700	20700	20701
6761	5475	5	applied	\N	\N	\N	\N	20702	20702	20703
6761	5476	6	applied	\N	\N	\N	\N	20704	20704	20705
6761	5477	7	applied	\N	\N	\N	\N	20706	20706	20707
6763	5478	0	applied	\N	\N	1000000000	\N	20712	20712	20713
6763	5479	1	applied	\N	\N	1000000000	\N	20714	20714	20715
6763	5480	2	applied	\N	\N	\N	\N	20716	20716	20717
6763	5481	3	applied	\N	\N	\N	\N	20718	20718	20719
6763	5482	4	applied	\N	\N	1000000000	\N	20720	20720	20721
6768	5487	0	applied	\N	\N	\N	\N	20739	20739	20740
6768	5488	1	applied	\N	\N	\N	\N	20741	20741	20742
6768	5489	2	applied	\N	\N	\N	\N	20743	20743	20744
6768	5490	3	applied	\N	\N	\N	\N	20745	20745	20746
6773	5493	0	applied	\N	\N	\N	\N	20758	20758	20759
6773	5494	1	applied	\N	\N	\N	\N	20760	20760	20761
6775	5493	0	applied	\N	\N	\N	\N	20758	20758	20759
6775	5494	1	applied	\N	\N	\N	\N	20760	20760	20761
6777	5497	0	applied	\N	\N	\N	\N	20776	20776	20777
6777	5498	1	applied	\N	\N	\N	\N	20778	20778	20779
6782	5505	0	applied	\N	\N	\N	\N	20797	20797	20798
6782	5506	1	applied	\N	\N	\N	\N	20799	20799	20800
6794	5521	0	applied	\N	\N	\N	\N	20851	20851	20852
6794	5522	1	applied	\N	\N	\N	\N	20853	20853	20854
6797	5523	0	applied	\N	\N	\N	\N	20859	20859	20860
6797	5524	1	applied	\N	\N	\N	\N	20861	20861	20862
6804	5534	0	applied	\N	\N	\N	\N	20887	20887	20888
6809	5537	0	applied	\N	\N	\N	\N	20905	20905	20906
6809	5538	1	applied	\N	\N	\N	\N	20907	20907	20908
6809	5539	2	applied	\N	\N	\N	\N	20909	20909	20910
6809	5540	3	applied	\N	\N	\N	\N	20911	20911	20912
6813	5545	0	applied	\N	\N	\N	\N	20927	20927	20928
6813	5546	1	applied	\N	\N	1000000000	\N	20929	20929	20930
6813	5547	2	applied	\N	\N	1000000000	\N	20931	20931	20932
6813	5548	3	applied	\N	\N	\N	\N	20933	20933	20934
6818	5556	0	applied	\N	\N	\N	\N	20955	20955	20956
6818	5557	1	applied	\N	\N	\N	\N	20957	20957	20958
6821	5560	0	applied	\N	\N	\N	\N	20970	20970	20971
6821	5561	1	applied	\N	\N	\N	\N	20972	20972	20973
6821	5562	2	applied	\N	\N	\N	\N	20974	20974	20975
6821	5563	3	applied	\N	\N	\N	\N	20976	20976	20977
6821	5564	4	applied	\N	\N	\N	\N	20978	20978	20979
6821	5565	5	applied	\N	\N	\N	\N	20980	20980	20981
6829	5578	0	applied	\N	\N	\N	\N	21017	21017	21018
6709	5400	0	applied	\N	\N	\N	\N	20484	20484	20485
6709	5401	1	applied	\N	\N	\N	\N	20486	20486	20487
6711	5402	0	applied	\N	\N	\N	\N	20489	20489	20490
6711	5403	1	applied	\N	\N	\N	\N	20491	20491	20492
6716	5408	0	applied	\N	\N	\N	\N	20507	20507	20508
6716	5409	1	applied	\N	\N	\N	\N	20509	20509	20510
6716	5410	2	applied	\N	\N	\N	\N	20511	20511	20512
6716	5411	3	applied	\N	\N	\N	\N	20513	20513	20514
6722	5422	0	applied	\N	\N	\N	\N	20549	20549	20550
6722	5423	1	applied	\N	\N	\N	\N	20551	20551	20552
6722	5424	2	applied	\N	\N	\N	\N	20553	20553	20554
6722	5425	3	applied	\N	\N	\N	\N	20555	20555	20556
6724	5426	0	applied	\N	\N	\N	\N	20561	20561	20562
6724	5427	1	applied	\N	\N	\N	\N	20563	20563	20564
6729	5432	0	applied	\N	\N	\N	\N	20578	20578	20579
6729	5433	1	applied	\N	\N	\N	\N	20580	20580	20581
6734	5440	0	applied	\N	\N	\N	\N	20601	20601	20602
6734	5441	1	applied	\N	\N	\N	\N	20603	20603	20604
6736	5442	0	applied	\N	\N	\N	\N	20605	20605	20606
6736	5443	1	applied	\N	\N	\N	\N	20607	20607	20608
6745	5450	0	applied	\N	\N	\N	\N	20630	20630	20631
6745	5451	1	applied	\N	\N	\N	\N	20632	20632	20633
6748	5456	0	applied	\N	\N	\N	\N	20645	20645	20646
6748	5457	1	applied	\N	\N	\N	\N	20647	20647	20648
6748	5458	2	applied	\N	\N	\N	\N	20649	20649	20650
6748	5459	3	applied	\N	\N	\N	\N	20651	20651	20652
6753	5464	0	applied	\N	\N	\N	\N	20670	20670	20671
6753	5465	1	applied	\N	\N	\N	\N	20672	20672	20673
6755	5466	0	applied	\N	\N	\N	\N	20678	20678	20679
6755	5467	1	applied	\N	\N	\N	\N	20680	20680	20681
6765	5483	0	applied	\N	\N	1000000000	\N	20725	20725	20726
6765	5484	1	applied	\N	\N	\N	\N	20727	20727	20728
6765	5485	2	applied	\N	\N	\N	\N	20729	20729	20730
6770	5491	0	applied	\N	\N	\N	\N	20752	20752	20753
6770	5492	1	applied	\N	\N	\N	\N	20754	20754	20755
6772	5493	0	applied	\N	\N	\N	\N	20758	20758	20759
6772	5494	1	applied	\N	\N	\N	\N	20760	20760	20761
6779	5501	0	applied	\N	\N	\N	\N	20786	20786	20787
6779	5502	1	applied	\N	\N	\N	\N	20788	20788	20789
6784	5507	0	applied	\N	\N	\N	\N	20805	20805	20806
6784	5508	1	applied	\N	\N	\N	\N	20807	20807	20808
6789	5513	0	applied	\N	\N	\N	\N	20825	20825	20826
6789	5514	1	applied	\N	\N	\N	\N	20827	20827	20828
6791	5515	0	applied	\N	\N	\N	\N	20833	20833	20834
6791	5516	1	applied	\N	\N	\N	\N	20835	20835	20836
6791	5517	2	applied	\N	\N	\N	\N	20837	20837	20838
6791	5518	3	applied	\N	\N	\N	\N	20839	20839	20840
6796	5521	0	applied	\N	\N	\N	\N	20851	20851	20852
6796	5522	1	applied	\N	\N	\N	\N	20853	20853	20854
6799	5531	0	applied	\N	\N	\N	\N	20879	20879	20880
6799	5532	1	applied	\N	\N	\N	\N	20881	20881	20882
6802	5534	0	applied	\N	\N	\N	\N	20887	20887	20888
6806	5535	0	applied	\N	\N	\N	\N	20895	20895	20896
6806	5536	1	applied	\N	\N	\N	\N	20899	20899	20900
6808	5537	0	applied	\N	\N	\N	\N	20905	20905	20906
6808	5538	1	applied	\N	\N	\N	\N	20907	20907	20908
6808	5539	2	applied	\N	\N	\N	\N	20909	20909	20910
6808	5540	3	applied	\N	\N	\N	\N	20911	20911	20912
6815	5549	0	applied	\N	\N	\N	\N	20938	20938	20939
6815	5550	1	applied	\N	\N	\N	\N	20940	20940	20941
6815	5551	2	applied	\N	\N	\N	\N	20942	20942	20943
6815	5552	3	applied	\N	\N	\N	\N	20944	20944	20945
6820	5558	0	applied	\N	\N	\N	\N	20963	20963	20964
6820	5559	2	applied	\N	\N	\N	\N	20966	20966	20967
6823	5566	0	applied	\N	\N	\N	\N	20984	20984	20985
6823	5567	1	applied	\N	\N	\N	\N	20986	20986	20987
6825	5568	0	applied	\N	\N	\N	\N	20994	20994	20995
6825	5569	1	applied	\N	\N	\N	\N	20996	20996	20997
6833	5579	0	applied	\N	\N	\N	\N	21019	21019	21020
6835	5582	0	applied	\N	\N	\N	\N	21033	21033	21034
6835	5583	1	applied	\N	\N	\N	\N	21035	21035	21036
6842	5588	0	applied	\N	\N	\N	\N	21049	21049	21050
6842	5589	1	applied	\N	\N	\N	\N	21051	21051	21052
6844	5590	0	applied	\N	\N	\N	\N	21058	21058	21059
6844	5589	1	applied	\N	\N	\N	\N	21051	21051	21052
6844	5591	2	applied	\N	\N	\N	\N	21060	21060	21061
6851	5598	0	applied	\N	\N	\N	\N	21084	21084	21085
6851	5599	1	applied	\N	\N	\N	\N	21087	21087	21088
6853	5601	0	applied	\N	\N	\N	\N	21093	21093	21094
6853	5600	1	applied	\N	\N	\N	\N	21090	21090	21091
6858	5615	0	applied	\N	\N	\N	\N	21128	21128	21129
6858	5616	1	applied	\N	\N	\N	\N	21130	21130	21131
6860	5617	0	applied	\N	\N	\N	\N	21136	21136	21137
6860	5618	1	applied	\N	\N	\N	\N	21138	21138	21139
6863	5623	0	applied	\N	\N	\N	\N	21154	21154	21155
6863	5624	1	applied	\N	\N	\N	\N	21156	21156	21157
6875	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6875	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6877	5642	0	applied	\N	\N	\N	\N	21209	21209	21210
6877	5643	1	applied	\N	\N	\N	\N	21211	21211	21212
6880	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6880	5647	1	applied	\N	\N	\N	\N	21344	21344	21345
6880	5648	2	applied	\N	\N	\N	\N	21346	21346	21347
6880	5645	3	applied	\N	\N	\N	\N	21339	21339	21340
6880	5646	4	applied	\N	\N	\N	\N	21341	21341	12588
6882	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6882	5647	1	applied	\N	\N	\N	\N	21344	21344	21345
6882	5648	2	applied	\N	\N	\N	\N	21346	21346	21347
6882	5645	3	applied	\N	\N	\N	\N	21339	21339	21340
6882	5646	4	applied	\N	\N	\N	\N	21341	21341	12588
6886	5649	0	applied	\N	\N	\N	\N	21356	21356	21357
6886	5650	1	applied	\N	\N	\N	\N	21358	21358	21359
6890	5652	0	applied	\N	\N	\N	\N	21367	21367	21368
6890	5651	1	applied	\N	\N	\N	\N	21364	21364	13107
6890	5653	2	applied	\N	\N	\N	\N	21369	21369	21370
6898	5666	0	applied	\N	\N	\N	\N	21409	21409	21410
6898	5667	1	applied	\N	\N	\N	\N	21411	21411	21412
6905	5676	0	applied	\N	\N	\N	\N	21437	21437	21438
6905	5677	1	applied	\N	\N	\N	\N	21439	21439	21440
6910	5680	0	applied	\N	\N	\N	\N	21446	21446	21447
6910	5681	1	applied	\N	\N	\N	\N	21450	21450	21451
6913	5680	0	applied	\N	\N	\N	\N	21446	21446	21447
6914	5682	0	applied	\N	\N	\N	\N	21456	21456	21457
6914	5683	1	applied	\N	\N	\N	\N	21458	21458	21459
6916	5684	0	applied	\N	\N	\N	\N	21464	21464	21465
6916	5685	1	applied	\N	\N	\N	\N	21466	21466	21467
6923	5686	0	applied	\N	\N	\N	\N	21473	21473	21474
6923	5687	1	applied	\N	\N	\N	\N	21475	21475	21476
6925	5692	0	applied	\N	\N	\N	\N	21491	21491	21492
6925	5693	1	applied	\N	\N	\N	\N	21493	21493	21494
6829	5579	1	applied	\N	\N	\N	\N	21019	21019	21020
6831	5578	0	applied	\N	\N	\N	\N	21017	21017	21018
6831	5579	1	applied	\N	\N	\N	\N	21019	21019	21020
6836	5582	0	applied	\N	\N	\N	\N	21033	21033	21034
6836	5583	1	applied	\N	\N	\N	\N	21035	21035	21036
6838	5582	0	applied	\N	\N	\N	\N	21033	21033	21034
6838	5583	1	applied	\N	\N	\N	\N	21035	21035	21036
6840	5584	0	applied	\N	\N	\N	\N	21041	21041	21042
6840	5585	1	applied	\N	\N	\N	\N	21043	21043	21044
6840	5586	2	applied	\N	\N	\N	\N	21045	21045	21046
6840	5587	3	applied	\N	\N	\N	\N	21047	21047	21048
6845	5592	0	applied	\N	\N	\N	\N	21064	21064	21065
6845	5593	1	applied	\N	\N	\N	\N	21066	21066	21067
6845	5594	2	applied	\N	\N	\N	\N	21068	21068	21069
6845	5595	3	applied	\N	\N	\N	\N	21070	21070	21071
6845	5596	4	applied	\N	\N	\N	\N	21072	21072	21073
6845	5597	5	applied	\N	\N	\N	\N	21074	21074	21075
6847	5592	0	applied	\N	\N	\N	\N	21064	21064	21065
6847	5593	1	applied	\N	\N	\N	\N	21066	21066	21067
6847	5594	2	applied	\N	\N	\N	\N	21068	21068	21069
6847	5595	3	applied	\N	\N	\N	\N	21070	21070	21071
6847	5596	4	applied	\N	\N	\N	\N	21072	21072	21073
6847	5597	5	applied	\N	\N	\N	\N	21074	21074	21075
6849	5592	0	applied	\N	\N	\N	\N	21064	21064	21065
6849	5593	1	applied	\N	\N	\N	\N	21066	21066	21067
6849	5594	2	applied	\N	\N	\N	\N	21068	21068	21069
6849	5595	3	applied	\N	\N	\N	\N	21070	21070	21071
6849	5596	4	applied	\N	\N	\N	\N	21072	21072	21073
6849	5597	5	applied	\N	\N	\N	\N	21074	21074	21075
6852	5598	0	applied	\N	\N	\N	\N	21084	21084	21085
6852	5600	1	applied	\N	\N	\N	\N	21090	21090	21091
6852	5599	2	applied	\N	\N	\N	\N	21087	21087	21088
6854	5602	0	applied	\N	\N	\N	\N	21097	21097	21098
6854	5603	1	applied	\N	\N	\N	\N	21099	21099	21100
6854	5604	2	applied	\N	\N	\N	\N	21101	21101	21102
6854	5605	3	applied	\N	\N	\N	\N	21103	21103	21104
6856	5606	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	21109	21109	\N
6856	5607	1	applied	\N	\N	\N	\N	21110	21110	21111
6856	5608	2	applied	\N	\N	\N	\N	21112	21112	21113
6856	5609	3	applied	\N	\N	\N	\N	21114	21114	21115
6856	5610	4	applied	\N	\N	\N	\N	21116	21116	21117
6856	5611	5	applied	\N	\N	\N	\N	21118	21118	21119
6856	5612	6	applied	\N	\N	\N	\N	21120	21120	21121
6856	5613	7	applied	\N	\N	\N	\N	21122	21122	21123
6856	5614	8	applied	\N	\N	\N	\N	21124	21124	21125
6861	5617	0	applied	\N	\N	\N	\N	21136	21136	21137
6861	5618	1	applied	\N	\N	\N	\N	21138	21138	21139
6867	5630	0	applied	\N	\N	\N	\N	21172	21172	21173
6867	5631	1	applied	\N	\N	\N	\N	21174	21174	21175
6868	5632	0	applied	\N	\N	\N	\N	21177	21177	21178
6868	5633	1	applied	\N	\N	\N	\N	21179	21179	21180
6868	5634	2	applied	\N	\N	\N	\N	21181	21181	21182
6868	5635	3	applied	\N	\N	\N	\N	21183	21183	21184
6868	5636	4	applied	\N	\N	\N	\N	21185	21185	21186
6868	5637	5	applied	\N	\N	\N	\N	21187	21187	21188
6871	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6871	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6874	5638	0	applied	\N	\N	\N	\N	21190	21190	21191
6874	5639	1	applied	\N	\N	\N	\N	21192	21192	21193
6879	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6879	5645	1	applied	\N	\N	\N	\N	21339	21339	21340
6879	5646	2	applied	\N	\N	\N	\N	21341	21341	12588
6881	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6881	5647	1	applied	\N	\N	\N	\N	21344	21344	21345
6881	5648	2	applied	\N	\N	\N	\N	21346	21346	21347
6881	5645	3	applied	\N	\N	\N	\N	21339	21339	21340
6881	5646	4	applied	\N	\N	\N	\N	21341	21341	12588
6885	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6885	5647	1	applied	\N	\N	\N	\N	21344	21344	21345
6885	5648	2	applied	\N	\N	\N	\N	21346	21346	21347
6885	5645	3	applied	\N	\N	\N	\N	21339	21339	21340
6885	5646	4	applied	\N	\N	\N	\N	21341	21341	12588
6888	5649	0	applied	\N	\N	\N	\N	21356	21356	21357
6888	5650	1	applied	\N	\N	\N	\N	21358	21358	21359
6893	5656	0	applied	\N	\N	\N	\N	21379	21379	21380
6893	5657	1	applied	\N	\N	\N	\N	21381	21381	21382
6893	5658	2	applied	\N	\N	\N	\N	21383	21383	21384
6893	5659	3	applied	\N	\N	\N	\N	21385	21385	21386
6895	5660	0	applied	\N	\N	\N	\N	21392	21392	21393
6895	5661	1	applied	\N	\N	\N	\N	21394	21394	21395
6895	5662	2	applied	\N	\N	\N	\N	21396	21396	21397
6895	5663	3	applied	\N	\N	\N	\N	21398	21398	21399
6900	5668	0	applied	\N	\N	\N	\N	21415	21415	21416
6900	5669	1	applied	\N	\N	\N	\N	21417	21417	21418
6902	5670	0	applied	\N	\N	\N	\N	21422	21422	21423
6902	5671	1	applied	\N	\N	\N	\N	21424	21424	21425
6907	5678	0	applied	\N	\N	\N	\N	21442	21442	21443
6907	5679	1	applied	\N	\N	\N	\N	21444	21444	21445
6909	5680	0	applied	\N	\N	\N	\N	21446	21446	21447
6912	5680	0	applied	\N	\N	\N	\N	21446	21446	21447
6912	5681	1	applied	\N	\N	\N	\N	21450	21450	21451
6918	5684	0	applied	\N	\N	\N	\N	21464	21464	21465
6918	5685	1	applied	\N	\N	\N	\N	21466	21466	21467
6920	5684	0	applied	\N	\N	\N	\N	21464	21464	21465
6920	5685	1	applied	\N	\N	\N	\N	21466	21466	21467
6922	5686	0	applied	\N	\N	\N	\N	21473	21473	21474
6922	5687	1	applied	\N	\N	\N	\N	21475	21475	21476
6922	5688	2	applied	\N	\N	\N	\N	21477	21477	21478
6922	5689	3	applied	\N	\N	\N	\N	21479	21479	21480
6941	5712	0	applied	\N	\N	\N	\N	21550	21550	21551
6941	5713	1	applied	\N	\N	\N	\N	21552	21552	21553
6946	5718	0	applied	\N	\N	\N	\N	21567	21567	21568
6946	5719	1	applied	\N	\N	1000000000	\N	21569	21569	21570
6946	5720	2	applied	\N	\N	\N	\N	21571	21571	21572
6951	5722	0	applied	\N	\N	\N	\N	21580	21580	21581
6951	5723	1	applied	\N	\N	\N	\N	21582	21582	21583
6951	5724	2	applied	\N	\N	\N	\N	21584	21584	21585
6955	5730	0	applied	\N	\N	\N	\N	21604	21604	21605
6955	5725	1	applied	\N	\N	\N	\N	21589	21589	21590
6955	5726	2	applied	\N	\N	\N	\N	21591	21591	21592
6955	5727	3	applied	\N	\N	\N	\N	21593	21593	21594
6955	5728	4	applied	\N	\N	\N	\N	21595	21595	21596
6955	5729	5	applied	\N	\N	\N	\N	21600	21600	21601
6962	5735	0	applied	\N	\N	\N	\N	21622	21622	21623
6962	5736	1	applied	\N	\N	\N	\N	21626	21626	21627
6967	5741	0	applied	\N	\N	\N	\N	21642	21642	21643
6967	5742	1	applied	\N	\N	\N	\N	21644	21644	21645
6969	5745	0	applied	\N	\N	\N	\N	21654	21654	21655
6970	5746	0	applied	\N	\N	\N	\N	21657	21657	21658
6878	5360	2	applied	\N	\N	\N	\N	20380	20380	20381
6878	5362	3	applied	\N	\N	\N	\N	20384	20384	20385
6878	5363	4	applied	\N	\N	\N	\N	20386	20386	20387
6878	5364	5	applied	\N	\N	\N	\N	20388	20388	20389
6878	5370	6	applied	\N	\N	\N	\N	20401	20401	20402
6878	5361	7	applied	\N	\N	\N	\N	21216	21216	20383
6878	5365	8	applied	\N	\N	\N	\N	21217	21217	20391
6878	5366	9	applied	\N	\N	\N	\N	21218	21218	20393
6878	5367	10	applied	\N	\N	\N	\N	21219	21219	20395
6878	5368	11	applied	\N	\N	\N	\N	21220	21220	20398
6878	5369	12	applied	\N	\N	\N	\N	21221	21221	20400
6878	5372	13	applied	\N	\N	\N	\N	21222	21222	20410
6878	5373	14	applied	\N	\N	\N	\N	21223	21223	20412
6878	5377	15	applied	\N	\N	\N	\N	21224	21224	20423
6878	5378	16	applied	\N	\N	\N	\N	21225	21225	20427
6878	5380	17	applied	\N	\N	\N	\N	21226	21226	20437
6878	5381	18	applied	\N	\N	\N	\N	21227	21227	20439
6878	5384	19	applied	\N	\N	\N	\N	21228	21228	20447
6878	5385	20	applied	\N	\N	\N	\N	21229	21229	20449
6878	5386	21	applied	\N	\N	\N	\N	21230	21230	20451
6878	5390	22	applied	\N	\N	\N	\N	21231	21231	20460
6878	5395	23	applied	\N	\N	\N	\N	21232	21232	20473
6878	5396	24	applied	\N	\N	\N	\N	21233	21233	20475
6878	5397	25	applied	\N	\N	\N	\N	21234	21234	20477
6878	5398	26	applied	\N	\N	\N	\N	21235	21235	20481
6878	5401	27	applied	\N	\N	\N	\N	21236	21236	20487
6878	5402	28	applied	\N	\N	\N	\N	21237	21237	20490
6878	5404	29	applied	\N	\N	\N	\N	21238	21238	20498
6878	5406	30	applied	\N	\N	\N	\N	21239	21239	20502
6878	5408	31	applied	\N	\N	\N	\N	21240	21240	20508
6878	5411	32	applied	\N	\N	\N	\N	21241	21241	20514
6878	5413	33	applied	\N	\N	\N	\N	21242	21242	20518
6878	5414	34	applied	\N	\N	\N	\N	21243	21243	20522
6878	5417	35	applied	\N	\N	\N	\N	21244	21244	20528
6878	5420	36	applied	\N	\N	\N	\N	21245	21245	20536
6878	5421	37	applied	\N	\N	\N	\N	21246	21246	20538
6878	5423	38	applied	\N	\N	\N	\N	21247	21247	20552
6878	5424	39	applied	\N	\N	\N	\N	21248	21248	20554
6878	5426	41	applied	\N	\N	\N	\N	21250	21250	20562
6878	5428	42	applied	\N	\N	\N	\N	21251	21251	20566
6878	5431	43	applied	\N	\N	\N	\N	21252	21252	20574
6878	5432	44	applied	\N	\N	\N	\N	21253	21253	20579
6878	5434	45	applied	\N	\N	\N	\N	21254	21254	20583
6878	5436	46	applied	\N	\N	\N	\N	21255	21255	20591
6878	5437	47	applied	\N	\N	\N	\N	21256	21256	20593
6878	5441	48	applied	\N	\N	\N	\N	21257	21257	20604
6878	5443	49	applied	\N	\N	\N	\N	21258	21258	20608
6878	5444	50	applied	\N	\N	\N	\N	21259	21259	20613
6878	5446	51	applied	\N	\N	\N	\N	21260	21260	20617
6878	5449	52	applied	\N	\N	\N	\N	21261	21261	20625
6878	5450	53	applied	\N	\N	\N	\N	21262	21262	20631
6878	5453	54	applied	\N	\N	\N	\N	21263	21263	20638
6878	5454	55	applied	\N	\N	\N	\N	21264	21264	20640
6878	5457	56	applied	\N	\N	\N	\N	21265	21265	20648
6878	5458	57	applied	\N	\N	\N	\N	21266	21266	20650
6878	5461	58	applied	\N	\N	\N	\N	21267	21267	20659
6878	5462	59	applied	\N	\N	\N	\N	21268	21268	20663
6878	5464	60	applied	\N	\N	\N	\N	21269	21269	20671
6878	5467	61	applied	\N	\N	\N	\N	21270	21270	20681
6878	5468	62	applied	\N	\N	\N	\N	21271	21271	20687
6878	5470	63	applied	\N	\N	\N	\N	21272	21272	20693
6878	5472	64	applied	\N	\N	\N	\N	21273	21273	20697
6878	5473	65	applied	\N	\N	\N	\N	21274	21274	20699
6878	5474	66	applied	\N	\N	\N	\N	21275	21275	20701
6878	5478	67	applied	\N	\N	1000000000	\N	21276	21276	20713
6878	5479	68	applied	\N	\N	1000000000	\N	21277	21277	20715
6878	5481	69	applied	\N	\N	\N	\N	21278	21278	20719
6878	5482	70	applied	\N	\N	1000000000	\N	21279	21279	20721
6878	5483	71	applied	\N	\N	1000000000	\N	21280	21280	20726
6878	5485	72	applied	\N	\N	\N	\N	21281	21281	20730
6878	5489	73	applied	\N	\N	\N	\N	21282	21282	20744
6878	5490	74	applied	\N	\N	\N	\N	21283	21283	20746
6878	5491	75	applied	\N	\N	\N	\N	21284	21284	20753
6878	5493	76	applied	\N	\N	\N	\N	21285	21285	20759
6878	5496	77	applied	\N	\N	\N	\N	21286	21286	20773
6878	5497	78	applied	\N	\N	\N	\N	21287	21287	20777
6878	5499	79	applied	\N	\N	\N	\N	21288	21288	20783
6878	5501	80	applied	\N	\N	\N	\N	21289	21289	20787
6878	5504	81	applied	\N	\N	\N	\N	21290	21290	20794
6878	5505	82	applied	\N	\N	\N	\N	21291	21291	20798
6878	5508	83	applied	\N	\N	\N	\N	21292	21292	20808
6878	5511	84	applied	\N	\N	\N	\N	21293	21293	20818
6878	5512	85	applied	\N	\N	\N	\N	21294	21294	20820
6878	5514	86	applied	\N	\N	\N	\N	21295	21295	20828
6878	5517	87	applied	\N	\N	\N	\N	21296	21296	20838
6878	5518	88	applied	\N	\N	\N	\N	21297	21297	20840
6878	5520	89	applied	\N	\N	\N	\N	21298	21298	20848
6878	5521	90	applied	\N	\N	\N	\N	21299	21299	20852
6878	5525	91	applied	\N	\N	\N	\N	21300	21300	20866
6878	5526	92	applied	\N	\N	1000000000	\N	21301	21301	20868
6878	5528	93	applied	\N	\N	\N	\N	21302	21302	20872
6878	5529	94	applied	\N	\N	\N	\N	21303	21303	20874
6878	5530	95	applied	\N	\N	\N	\N	21304	21304	20876
6878	5531	96	applied	\N	\N	\N	\N	21305	21305	20880
6878	5533	97	applied	\N	\N	\N	\N	21306	21306	20886
6878	5536	98	applied	\N	\N	\N	\N	21307	21307	20900
6878	5537	99	applied	\N	\N	\N	\N	21308	21308	20906
6878	5540	100	applied	\N	\N	\N	\N	21309	21309	20912
6878	5542	101	applied	\N	\N	\N	\N	21310	21310	20920
6878	5543	102	applied	\N	\N	\N	\N	21311	21311	20924
6878	5545	103	applied	\N	\N	\N	\N	21312	21312	20928
6878	5546	104	applied	\N	\N	1000000000	\N	21313	21313	20930
6878	5547	105	applied	\N	\N	1000000000	\N	21314	21314	20932
6878	5549	106	applied	\N	\N	\N	\N	21315	21315	20939
6878	5550	107	applied	\N	\N	\N	\N	21316	21316	20941
6878	5554	108	applied	\N	\N	\N	\N	21317	21317	20951
6878	5555	109	applied	\N	\N	1000000000	\N	21318	21318	20953
6878	5557	110	applied	\N	\N	\N	\N	21319	21319	20958
6878	5559	111	applied	\N	\N	\N	\N	21320	21320	20967
6878	5563	112	applied	\N	\N	\N	\N	21321	21321	20977
6878	5564	113	applied	\N	\N	\N	\N	21322	21322	20979
6878	5565	114	applied	\N	\N	\N	\N	21323	21323	20981
6878	5566	115	applied	\N	\N	\N	\N	21324	21324	20985
6878	5568	116	applied	\N	\N	\N	\N	21325	21325	20995
6878	5571	117	applied	\N	\N	\N	\N	21326	21326	21002
6878	5572	118	applied	\N	\N	\N	\N	21327	21327	21004
6878	5573	119	applied	\N	\N	\N	\N	21328	21328	21006
6878	5574	120	applied	\N	\N	\N	\N	21329	21329	21008
6878	5578	121	applied	\N	\N	\N	\N	21330	21330	21018
6878	5581	122	applied	\N	\N	\N	\N	21331	21331	21030
6878	5582	123	applied	\N	\N	\N	\N	21332	21332	21034
6878	5586	124	applied	\N	\N	\N	\N	21333	21333	21046
6878	5587	125	applied	\N	\N	\N	\N	21334	21334	21048
6887	5649	0	applied	\N	\N	\N	\N	21356	21356	21357
6887	5650	1	applied	\N	\N	\N	\N	21358	21358	21359
6891	5654	0	applied	\N	\N	\N	\N	21373	21373	21374
6891	5655	1	applied	\N	\N	\N	\N	21375	21375	21376
6896	5664	0	applied	\N	\N	\N	\N	21402	21402	21403
6896	5665	1	applied	\N	\N	\N	\N	21404	21404	21405
6901	5668	0	applied	\N	\N	\N	\N	21415	21415	21416
6901	5669	1	applied	\N	\N	\N	\N	21417	21417	21418
6903	5670	0	applied	\N	\N	\N	\N	21422	21422	21423
6903	5671	1	applied	\N	\N	\N	\N	21424	21424	21425
6906	5676	0	applied	\N	\N	\N	\N	21437	21437	21438
6906	5677	1	applied	\N	\N	\N	\N	21439	21439	21440
6908	5678	0	applied	\N	\N	\N	\N	21442	21442	21443
6908	5679	1	applied	\N	\N	\N	\N	21444	21444	21445
6911	5680	0	applied	\N	\N	\N	\N	21446	21446	21447
6911	5681	1	applied	\N	\N	\N	\N	21450	21450	21451
6917	5684	0	applied	\N	\N	\N	\N	21464	21464	21465
6917	5685	1	applied	\N	\N	\N	\N	21466	21466	21467
6921	5686	0	applied	\N	\N	\N	\N	21473	21473	21474
6921	5687	1	applied	\N	\N	\N	\N	21475	21475	21476
6921	5688	2	applied	\N	\N	\N	\N	21477	21477	21478
6921	5689	3	applied	\N	\N	\N	\N	21479	21479	21480
6926	5692	0	applied	\N	\N	\N	\N	21491	21491	21492
6928	5694	0	applied	\N	\N	\N	\N	21500	21500	21501
6928	5695	1	applied	\N	\N	\N	\N	21502	21502	21503
6937	5702	0	applied	\N	\N	\N	\N	21524	21524	21525
6937	5703	1	applied	\N	\N	\N	\N	21526	21526	21527
6937	5704	2	applied	\N	\N	\N	\N	21528	21528	21529
6937	5705	3	applied	\N	\N	\N	\N	21530	21530	21531
6940	5710	0	applied	\N	\N	\N	\N	21545	21545	21546
6940	5711	1	applied	\N	\N	\N	\N	21547	21547	21548
6950	5722	0	applied	\N	\N	\N	\N	21580	21580	21581
6950	5723	1	applied	\N	\N	\N	\N	21582	21582	21583
6950	5724	2	applied	\N	\N	\N	\N	21584	21584	21585
6953	5725	0	applied	\N	\N	\N	\N	21589	21589	21590
6953	5726	1	applied	\N	\N	\N	\N	21591	21591	21592
6953	5722	2	applied	\N	\N	\N	\N	21580	21580	21581
6953	5723	3	applied	\N	\N	\N	\N	21582	21582	21583
6953	5727	4	applied	\N	\N	\N	\N	21593	21593	21594
6953	5728	5	applied	\N	\N	\N	\N	21595	21595	21596
6953	5724	6	applied	\N	\N	\N	\N	21584	21584	21585
6954	5654	0	applied	\N	\N	\N	\N	21373	21373	21374
6954	5656	1	applied	\N	\N	\N	\N	21379	21379	21380
6954	5655	2	applied	\N	\N	\N	\N	21375	21375	21376
6954	5657	3	applied	\N	\N	\N	\N	21381	21381	21382
6954	5658	4	applied	\N	\N	\N	\N	21383	21383	21384
6954	5660	5	applied	\N	\N	\N	\N	21392	21392	21393
6954	5661	6	applied	\N	\N	\N	\N	21394	21394	21395
6954	5665	7	applied	\N	\N	\N	\N	21404	21404	21405
6954	5667	8	applied	\N	\N	\N	\N	21411	21411	21412
6954	5669	9	applied	\N	\N	\N	\N	21417	21417	21418
6954	5670	10	applied	\N	\N	\N	\N	21422	21422	21423
6954	5672	11	applied	\N	\N	\N	\N	21428	21428	21429
6954	5659	12	applied	\N	\N	\N	\N	21385	21385	21386
6954	5662	13	applied	\N	\N	\N	\N	21396	21396	21397
6954	5663	14	applied	\N	\N	\N	\N	21398	21398	21399
6954	5664	15	applied	\N	\N	\N	\N	21402	21402	21403
6954	5666	16	applied	\N	\N	\N	\N	21409	21409	21410
6954	5668	17	applied	\N	\N	\N	\N	21415	21415	21416
6954	5674	18	applied	\N	\N	\N	\N	21432	21432	21433
6954	5677	19	applied	\N	\N	\N	\N	21439	21439	21440
6954	5671	20	applied	\N	\N	\N	\N	21424	21424	21425
6954	5673	21	applied	\N	\N	\N	\N	21430	21430	21431
6954	5678	22	applied	\N	\N	\N	\N	21442	21442	21443
6954	5675	23	applied	\N	\N	\N	\N	21434	21434	21435
6954	5676	24	applied	\N	\N	\N	\N	21437	21437	21438
6954	5679	25	applied	\N	\N	\N	\N	21444	21444	21445
6954	5680	26	applied	\N	\N	\N	\N	21446	21446	21447
6954	5681	27	applied	\N	\N	\N	\N	21450	21450	21451
6954	5682	28	applied	\N	\N	\N	\N	21456	21456	21457
6954	5684	29	applied	\N	\N	\N	\N	21464	21464	21465
6954	5683	30	applied	\N	\N	\N	\N	21458	21458	21459
6954	5685	31	applied	\N	\N	\N	\N	21466	21466	21467
6954	5686	32	applied	\N	\N	\N	\N	21473	21473	21474
6954	5687	33	applied	\N	\N	\N	\N	21475	21475	21476
6954	5691	34	applied	\N	\N	\N	\N	21487	21487	21488
6954	5692	35	applied	\N	\N	\N	\N	21491	21491	21492
6954	5695	36	applied	\N	\N	\N	\N	21502	21502	21503
6954	5698	37	applied	\N	\N	\N	\N	21510	21510	21511
6954	5699	38	applied	\N	\N	\N	\N	21512	21512	21513
6954	5701	39	applied	\N	\N	\N	\N	21520	21520	21521
6954	5704	40	applied	\N	\N	\N	\N	21528	21528	21529
6954	5705	41	applied	\N	\N	\N	\N	21530	21530	21531
6954	5706	42	applied	\N	\N	\N	\N	21533	21533	21534
6954	5708	43	applied	\N	\N	\N	\N	21539	21539	21540
6954	5711	44	applied	\N	\N	\N	\N	21547	21547	21548
6954	5713	45	applied	\N	\N	\N	\N	21552	21552	21553
6954	5716	46	applied	\N	\N	\N	\N	21561	21561	21562
6954	5717	47	applied	\N	\N	\N	\N	21563	21563	21564
6954	5720	48	applied	\N	\N	\N	\N	21571	21571	21572
6954	5721	49	applied	\N	\N	\N	\N	21578	21578	21579
6954	5722	50	applied	\N	\N	\N	\N	21580	21580	21581
6954	5723	51	applied	\N	\N	\N	\N	21582	21582	21583
6954	5724	52	applied	\N	\N	\N	\N	21584	21584	21585
6954	5688	53	applied	\N	\N	\N	\N	21477	21477	21478
6954	5689	54	applied	\N	\N	\N	\N	21479	21479	21480
6954	5690	55	applied	\N	\N	\N	\N	21485	21485	21486
6954	5693	56	applied	\N	\N	\N	\N	21493	21493	21494
6954	5694	57	applied	\N	\N	\N	\N	21500	21500	21501
6954	5696	58	applied	\N	\N	\N	\N	21506	21506	21507
6954	5697	59	applied	\N	\N	\N	\N	21508	21508	21509
6954	5700	60	applied	\N	\N	\N	\N	21518	21518	21519
6954	5702	61	applied	\N	\N	\N	\N	21524	21524	21525
6954	5703	62	applied	\N	\N	\N	\N	21526	21526	21527
6954	5707	63	applied	\N	\N	\N	\N	21535	21535	21536
6954	5709	64	applied	\N	\N	\N	\N	21541	21541	21542
6954	5710	65	applied	\N	\N	\N	\N	21545	21545	21546
6954	5712	66	applied	\N	\N	\N	\N	21550	21550	21551
6954	5714	67	applied	\N	\N	\N	\N	21557	21557	21558
6954	5715	68	applied	\N	\N	\N	\N	21559	21559	21560
6954	5718	69	applied	\N	\N	\N	\N	21567	21567	21568
6954	5719	70	applied	\N	\N	1000000000	\N	21569	21569	21570
6954	5725	71	applied	\N	\N	\N	\N	21589	21589	21590
6954	5726	72	applied	\N	\N	\N	\N	21591	21591	21592
6954	5727	73	applied	\N	\N	\N	\N	21593	21593	21594
6954	5728	74	applied	\N	\N	\N	\N	21595	21595	21596
6883	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6883	5647	1	applied	\N	\N	\N	\N	21344	21344	21345
6883	5648	2	applied	\N	\N	\N	\N	21346	21346	21347
6883	5645	3	applied	\N	\N	\N	\N	21339	21339	21340
6883	5646	4	applied	\N	\N	\N	\N	21341	21341	12588
6884	5644	0	applied	\N	\N	\N	\N	21337	21337	21338
6884	5645	1	applied	\N	\N	\N	\N	21339	21339	21340
6884	5646	2	applied	\N	\N	\N	\N	21341	21341	12588
6889	5646	0	applied	\N	\N	\N	\N	21341	21341	12588
6889	5651	1	applied	\N	\N	\N	\N	21364	21364	13107
6892	5656	0	applied	\N	\N	\N	\N	21379	21379	21380
6892	5657	1	applied	\N	\N	\N	\N	21381	21381	21382
6892	5658	2	applied	\N	\N	\N	\N	21383	21383	21384
6892	5659	3	applied	\N	\N	\N	\N	21385	21385	21386
6899	5668	0	applied	\N	\N	\N	\N	21415	21415	21416
6899	5669	1	applied	\N	\N	\N	\N	21417	21417	21418
6904	5672	0	applied	\N	\N	\N	\N	21428	21428	21429
6904	5673	1	applied	\N	\N	\N	\N	21430	21430	21431
6904	5674	2	applied	\N	\N	\N	\N	21432	21432	21433
6904	5675	3	applied	\N	\N	\N	\N	21434	21434	21435
6915	5682	0	applied	\N	\N	\N	\N	21456	21456	21457
6915	5683	1	applied	\N	\N	\N	\N	21458	21458	21459
6919	5684	0	applied	\N	\N	\N	\N	21464	21464	21465
6919	5685	1	applied	\N	\N	\N	\N	21466	21466	21467
6924	5690	0	applied	\N	\N	\N	\N	21485	21485	21486
6924	5691	1	applied	\N	\N	\N	\N	21487	21487	21488
6929	5694	0	applied	\N	\N	\N	\N	21500	21500	21501
6929	5695	1	applied	\N	\N	\N	\N	21502	21502	21503
6931	5696	0	applied	\N	\N	\N	\N	21506	21506	21507
6931	5697	1	applied	\N	\N	\N	\N	21508	21508	21509
6931	5698	2	applied	\N	\N	\N	\N	21510	21510	21511
6931	5699	3	applied	\N	\N	\N	\N	21512	21512	21513
6938	5706	0	applied	\N	\N	\N	\N	21533	21533	21534
6938	5707	1	applied	\N	\N	\N	\N	21535	21535	21536
6943	5713	0	applied	\N	\N	\N	\N	21552	21552	21553
6945	5714	0	applied	\N	\N	\N	\N	21557	21557	21558
6945	5715	1	applied	\N	\N	\N	\N	21559	21559	21560
6945	5716	2	applied	\N	\N	\N	\N	21561	21561	21562
6945	5717	3	applied	\N	\N	\N	\N	21563	21563	21564
6957	5731	0	applied	\N	\N	\N	\N	21607	21607	21608
6957	5732	1	applied	\N	\N	\N	\N	21609	21609	21610
6960	5733	0	applied	\N	\N	\N	\N	21615	21615	21616
6960	5734	1	applied	\N	\N	\N	\N	21617	21617	21618
6964	5737	0	applied	\N	\N	\N	\N	21629	21629	21630
6964	5738	1	applied	\N	\N	\N	\N	21631	21631	21632
6966	5741	0	applied	\N	\N	\N	\N	21642	21642	21643
6966	5742	1	applied	\N	\N	\N	\N	21644	21644	21645
6973	5756	0	applied	\N	\N	\N	\N	21680	21680	21681
6973	5755	1	applied	\N	\N	\N	\N	21676	21676	21677
6976	5757	0	applied	\N	\N	\N	\N	21690	21690	21691
6976	5756	1	applied	\N	\N	\N	\N	21680	21680	21681
6976	5758	2	applied	\N	\N	\N	\N	21692	21692	21693
6981	5763	0	applied	\N	\N	\N	\N	21706	21706	21707
6981	5764	1	applied	\N	\N	\N	\N	21708	21708	21709
6981	5765	2	applied	\N	\N	\N	\N	21710	21710	21711
6981	5766	3	applied	\N	\N	\N	\N	21712	21712	21713
6984	5769	0	applied	\N	\N	\N	\N	21722	21722	21723
6984	5770	1	applied	\N	\N	\N	\N	21724	21724	21725
6984	5771	2	applied	\N	\N	\N	\N	21726	21726	21727
6984	5772	3	applied	\N	\N	\N	\N	21728	21728	21729
6989	5779	0	applied	\N	\N	\N	\N	21751	21751	21752
6989	5780	1	applied	\N	\N	\N	\N	21753	21753	21754
6993	5785	0	applied	\N	\N	\N	\N	21767	21767	21768
6993	5786	1	applied	\N	\N	1000000000	\N	21769	21769	21770
6993	5787	2	applied	\N	\N	\N	\N	21771	21771	21772
6993	5788	3	applied	\N	\N	\N	\N	21773	21773	21774
6993	5789	4	applied	\N	\N	\N	\N	21775	21775	21776
6993	5790	5	applied	\N	\N	\N	\N	21777	21777	21778
6993	5791	6	applied	\N	\N	\N	\N	21779	21779	21780
6993	5792	7	applied	\N	\N	\N	\N	21781	21781	21782
6993	5793	8	applied	\N	\N	\N	\N	21783	21783	21784
6997	5796	0	applied	\N	\N	\N	\N	21799	21799	21800
6997	5797	1	applied	\N	\N	\N	\N	21801	21801	21802
6999	5798	0	applied	\N	\N	\N	\N	21805	21805	21806
6999	5799	1	applied	\N	\N	\N	\N	21807	21807	21808
7008	5802	0	applied	\N	\N	\N	\N	21819	21819	21820
7008	5803	1	applied	\N	\N	\N	\N	21821	21821	21822
7008	5804	2	applied	\N	\N	\N	\N	21823	21823	21824
7008	5805	3	applied	\N	\N	\N	\N	21825	21825	21826
7008	5806	4	applied	\N	\N	\N	\N	21827	21827	21828
7010	5802	0	applied	\N	\N	\N	\N	21819	21819	21820
7010	5803	1	applied	\N	\N	\N	\N	21821	21821	21822
7010	5804	2	applied	\N	\N	\N	\N	21823	21823	21824
7010	5805	3	applied	\N	\N	\N	\N	21825	21825	21826
7010	5806	4	applied	\N	\N	\N	\N	21827	21827	21828
7012	5807	0	applied	\N	\N	\N	\N	21835	21835	21836
7012	5808	1	applied	\N	\N	\N	\N	21837	21837	21838
7020	5815	0	applied	\N	\N	\N	\N	21859	21859	21860
7020	5816	1	applied	\N	\N	\N	\N	21861	21861	21862
7020	5817	2	applied	\N	\N	\N	\N	21863	21863	21864
7020	5818	3	applied	\N	\N	\N	\N	21865	21865	21866
7025	5829	0	applied	\N	\N	\N	\N	21894	21894	21895
7025	5830	1	applied	\N	\N	\N	\N	21896	21896	21897
7025	5831	2	applied	\N	\N	\N	\N	21898	21898	21899
7025	5832	3	applied	\N	\N	\N	\N	21900	21900	21901
7030	5835	0	applied	\N	\N	\N	\N	21915	21915	21916
7030	5836	1	applied	\N	\N	\N	\N	21917	21917	21918
7030	5837	2	applied	\N	\N	\N	\N	21919	21919	21920
7030	5838	3	applied	\N	\N	\N	\N	21921	21921	21922
7033	5845	0	applied	\N	\N	\N	\N	21938	21938	21939
7033	5846	1	applied	\N	\N	\N	\N	21940	21940	21941
7036	5853	0	applied	\N	\N	\N	\N	21957	21957	21958
7036	5854	1	applied	\N	\N	\N	\N	21959	21959	21960
7039	5857	0	applied	\N	\N	\N	\N	21969	21969	21970
7039	5858	1	applied	\N	\N	\N	\N	21971	21971	21972
7041	5859	0	applied	\N	\N	\N	\N	21977	21977	21978
7041	5860	1	applied	\N	\N	\N	\N	21979	21979	21980
7044	5866	0	applied	\N	\N	\N	\N	21995	21995	21996
7044	5867	1	applied	\N	\N	\N	\N	21997	21997	21998
7044	5868	2	applied	\N	\N	\N	\N	21999	21999	22000
7044	5869	3	applied	\N	\N	\N	\N	22001	22001	22002
7047	5872	0	applied	\N	\N	\N	\N	22011	22011	22012
7047	5873	1	applied	\N	\N	\N	\N	22013	22013	22014
7047	5874	2	applied	\N	\N	\N	\N	22015	22015	22016
7047	5875	3	applied	\N	\N	\N	\N	22017	22017	22018
7051	5880	0	applied	\N	\N	\N	\N	22034	22034	22035
7051	5881	1	applied	\N	\N	\N	\N	22036	22036	22037
7053	5880	0	applied	\N	\N	\N	\N	22034	22034	22035
7053	5881	1	applied	\N	\N	\N	\N	22036	22036	22037
7056	5886	0	applied	\N	\N	\N	\N	22055	22055	22056
6927	5692	0	applied	\N	\N	\N	\N	21491	21491	21492
6927	5693	1	applied	\N	\N	\N	\N	21493	21493	21494
6930	5696	0	applied	\N	\N	\N	\N	21506	21506	21507
6930	5697	1	applied	\N	\N	\N	\N	21508	21508	21509
6930	5698	2	applied	\N	\N	\N	\N	21510	21510	21511
6930	5699	3	applied	\N	\N	\N	\N	21512	21512	21513
6934	5700	0	applied	\N	\N	\N	\N	21518	21518	21519
6934	5701	1	applied	\N	\N	\N	\N	21520	21520	21521
6939	5708	0	applied	\N	\N	\N	\N	21539	21539	21540
6939	5709	1	applied	\N	\N	\N	\N	21541	21541	21542
6942	5712	0	applied	\N	\N	\N	\N	21550	21550	21551
6942	5713	1	applied	\N	\N	\N	\N	21552	21552	21553
6947	5718	0	applied	\N	\N	\N	\N	21567	21567	21568
6947	5719	1	applied	\N	\N	1000000000	\N	21569	21569	21570
6947	5720	2	applied	\N	\N	\N	\N	21571	21571	21572
6949	5721	0	applied	\N	\N	\N	\N	21578	21578	21579
6952	5725	0	applied	\N	\N	\N	\N	21589	21589	21590
6952	5726	1	applied	\N	\N	\N	\N	21591	21591	21592
6952	5722	2	applied	\N	\N	\N	\N	21580	21580	21581
6952	5723	3	applied	\N	\N	\N	\N	21582	21582	21583
6952	5727	4	applied	\N	\N	\N	\N	21593	21593	21594
6952	5728	5	applied	\N	\N	\N	\N	21595	21595	21596
6952	5724	6	applied	\N	\N	\N	\N	21584	21584	21585
6956	5731	0	applied	\N	\N	\N	\N	21607	21607	21608
6956	5732	1	applied	\N	\N	\N	\N	21609	21609	21610
6958	5733	0	applied	\N	\N	\N	\N	21615	21615	21616
6958	5734	1	applied	\N	\N	\N	\N	21617	21617	21618
6963	5737	0	applied	\N	\N	\N	\N	21629	21629	21630
6963	5738	1	applied	\N	\N	\N	\N	21631	21631	21632
6965	5739	0	applied	\N	\N	\N	\N	21637	21637	21638
6965	5740	1	applied	\N	\N	\N	\N	21639	21639	21640
6971	5755	0	applied	\N	\N	\N	\N	21676	21676	21677
6975	5756	0	applied	\N	\N	\N	\N	21680	21680	21681
6975	5755	1	applied	\N	\N	\N	\N	21676	21676	21677
6982	5763	0	applied	\N	\N	\N	\N	21706	21706	21707
6982	5764	1	applied	\N	\N	\N	\N	21708	21708	21709
6982	5765	2	applied	\N	\N	\N	\N	21710	21710	21711
6982	5766	3	applied	\N	\N	\N	\N	21712	21712	21713
6985	5773	0	applied	\N	\N	\N	\N	21732	21732	21733
6985	5774	1	applied	\N	\N	\N	\N	21734	21734	21735
6988	5777	0	applied	\N	\N	\N	\N	21743	21743	21744
6988	5778	1	applied	\N	\N	\N	\N	21745	21745	21746
6991	5781	0	applied	\N	\N	\N	\N	21755	21755	21756
6991	5782	1	applied	\N	\N	\N	\N	21757	21757	21758
6991	5783	2	applied	\N	\N	\N	\N	21759	21759	21760
6991	5784	3	applied	\N	\N	\N	\N	21761	21761	21762
6996	5794	0	applied	\N	\N	\N	\N	21791	21791	21792
6996	5795	1	applied	\N	\N	\N	\N	21793	21793	21794
7009	5802	0	applied	\N	\N	\N	\N	21819	21819	21820
7009	5803	1	applied	\N	\N	\N	\N	21821	21821	21822
7009	5804	2	applied	\N	\N	\N	\N	21823	21823	21824
7009	5805	3	applied	\N	\N	\N	\N	21825	21825	21826
7009	5806	4	applied	\N	\N	\N	\N	21827	21827	21828
7013	5807	0	applied	\N	\N	\N	\N	21835	21835	21836
7013	5808	1	applied	\N	\N	\N	\N	21837	21837	21838
7016	5811	0	applied	\N	\N	\N	\N	21848	21848	21849
7016	5812	1	applied	\N	\N	\N	\N	21850	21850	21851
7016	5813	2	applied	\N	\N	\N	\N	21852	21852	21853
7016	5814	3	applied	\N	\N	\N	\N	21854	21854	21855
7021	5819	0	applied	\N	\N	\N	\N	21872	21872	21873
7021	5820	1	applied	\N	\N	\N	\N	21874	21874	21875
7021	5821	2	applied	\N	\N	\N	\N	21876	21876	21877
7021	5822	3	applied	\N	\N	\N	\N	21878	21878	21879
7024	5829	0	applied	\N	\N	\N	\N	21894	21894	21895
7024	5830	1	applied	\N	\N	\N	\N	21896	21896	21897
7024	5831	2	applied	\N	\N	\N	\N	21898	21898	21899
7024	5832	3	applied	\N	\N	\N	\N	21900	21900	21901
7029	5835	0	applied	\N	\N	\N	\N	21915	21915	21916
7029	5836	1	applied	\N	\N	\N	\N	21917	21917	21918
7029	5837	2	applied	\N	\N	\N	\N	21919	21919	21920
7029	5838	3	applied	\N	\N	\N	\N	21921	21921	21922
7031	5839	0	applied	\N	\N	\N	\N	21926	21926	21927
7031	5840	1	applied	\N	\N	\N	\N	21928	21928	21929
7034	5847	0	applied	\N	\N	\N	\N	21942	21942	21943
7034	5848	1	applied	\N	\N	\N	\N	21944	21944	21945
7037	5855	0	applied	\N	\N	\N	\N	21963	21963	21964
7037	5856	1	applied	\N	\N	\N	\N	21965	21965	21966
7042	5861	0	applied	\N	\N	1000000000	\N	21982	21982	21983
7042	5862	1	applied	\N	\N	\N	\N	21984	21984	21985
7042	5863	2	applied	\N	\N	\N	\N	21986	21986	21987
7042	5864	4	applied	\N	\N	\N	\N	21989	21989	21990
7042	5865	5	applied	\N	\N	\N	\N	21991	21991	21992
7045	5870	0	applied	\N	\N	\N	\N	22007	22007	22008
7045	5871	1	applied	\N	\N	\N	\N	22009	22009	22010
7048	5872	0	applied	\N	\N	\N	\N	22011	22011	22012
7048	5873	1	applied	\N	\N	\N	\N	22013	22013	22014
7048	5874	2	applied	\N	\N	\N	\N	22015	22015	22016
7048	5875	3	applied	\N	\N	\N	\N	22017	22017	22018
7050	5878	0	applied	\N	\N	\N	\N	22029	22029	22030
7050	5879	1	applied	\N	\N	\N	\N	22031	22031	22032
7055	5882	0	applied	\N	\N	\N	\N	22044	22044	22045
7055	5883	1	applied	\N	\N	\N	\N	22046	22046	22047
7055	5884	2	applied	\N	\N	\N	\N	22048	22048	22049
7055	5885	3	applied	\N	\N	\N	\N	22050	22050	22051
7057	5888	0	applied	\N	\N	\N	\N	22059	22059	22060
7057	5889	1	applied	\N	\N	\N	\N	22061	22061	22062
7060	5892	0	applied	\N	\N	\N	\N	22072	22072	22073
7060	5893	1	applied	\N	\N	\N	\N	22074	22074	22075
7060	5894	2	applied	\N	\N	\N	\N	22076	22076	22077
7060	5895	3	applied	\N	\N	\N	\N	22078	22078	22079
7065	5898	0	applied	\N	\N	\N	\N	22089	22089	22090
7065	5899	1	applied	\N	\N	\N	\N	22091	22091	22092
7065	5900	2	applied	\N	\N	\N	\N	22093	22093	22094
7065	5901	3	applied	\N	\N	\N	\N	22095	22095	22096
7071	5902	0	applied	\N	\N	\N	\N	22099	22099	22100
7071	5903	1	applied	\N	\N	1000000000	\N	22101	22101	22102
7071	5905	2	applied	\N	\N	1000000000	\N	22114	22114	22115
7071	5906	3	applied	\N	\N	\N	\N	22116	22116	22117
7071	5904	4	applied	\N	\N	\N	\N	22103	22103	22104
7071	5907	5	applied	\N	\N	\N	\N	22118	22118	22119
7077	5911	0	applied	\N	\N	\N	\N	22133	22133	22134
7077	5909	1	applied	\N	\N	\N	\N	22126	22126	22127
7077	5912	2	applied	\N	\N	\N	\N	22135	22135	22136
7077	5913	3	applied	\N	\N	\N	\N	22137	22137	22138
7077	5914	4	applied	\N	\N	\N	\N	22139	22139	22140
7077	5915	5	applied	\N	\N	\N	\N	22141	22141	22142
7077	5916	6	applied	\N	\N	\N	\N	22143	22143	22144
7077	5910	7	applied	\N	\N	\N	\N	22128	22128	22129
7077	5917	8	applied	\N	\N	\N	\N	22145	22145	22146
6954	5729	75	applied	\N	\N	\N	\N	21600	21600	21601
6959	5733	0	applied	\N	\N	\N	\N	21615	21615	21616
6959	5734	1	applied	\N	\N	\N	\N	21617	21617	21618
6961	5735	0	applied	\N	\N	\N	\N	21622	21622	21623
6968	5743	0	applied	\N	\N	\N	\N	21649	21649	21650
6968	5744	1	applied	\N	\N	\N	\N	21651	21651	21652
6972	5756	0	applied	\N	\N	\N	\N	21680	21680	21681
6972	5755	1	applied	\N	\N	\N	\N	21676	21676	21677
6978	5759	0	applied	\N	\N	\N	\N	21696	21696	21697
6978	5760	1	applied	\N	\N	\N	\N	21698	21698	21699
6980	5761	0	applied	\N	\N	\N	\N	21700	21700	21701
6980	5762	1	applied	\N	\N	\N	\N	21702	21702	21703
6983	5767	0	applied	\N	\N	\N	\N	21717	21717	21718
6983	5768	1	applied	\N	\N	\N	\N	21719	21719	21720
6986	5775	0	applied	\N	\N	\N	\N	21738	21738	21739
6986	5776	1	applied	\N	\N	\N	\N	21740	21740	21741
6992	5785	0	applied	\N	\N	\N	\N	21767	21767	21768
6992	5786	1	applied	\N	\N	1000000000	\N	21769	21769	21770
6992	5787	2	applied	\N	\N	\N	\N	21771	21771	21772
6992	5788	3	applied	\N	\N	\N	\N	21773	21773	21774
6992	5789	4	applied	\N	\N	\N	\N	21775	21775	21776
6992	5790	5	applied	\N	\N	\N	\N	21777	21777	21778
6992	5791	6	applied	\N	\N	\N	\N	21779	21779	21780
6992	5792	7	applied	\N	\N	\N	\N	21781	21781	21782
6992	5793	8	applied	\N	\N	\N	\N	21783	21783	21784
7005	5800	0	applied	\N	\N	\N	\N	21811	21811	21812
7005	5801	1	applied	\N	\N	\N	\N	21813	21813	21814
7007	5800	0	applied	\N	\N	\N	\N	21811	21811	21812
7007	5801	1	applied	\N	\N	\N	\N	21813	21813	21814
7014	5807	0	applied	\N	\N	\N	\N	21835	21835	21836
7014	5808	1	applied	\N	\N	\N	\N	21837	21837	21838
7017	5811	0	applied	\N	\N	\N	\N	21848	21848	21849
7017	5812	1	applied	\N	\N	\N	\N	21850	21850	21851
7017	5813	2	applied	\N	\N	\N	\N	21852	21852	21853
7017	5814	3	applied	\N	\N	\N	\N	21854	21854	21855
7019	5815	0	applied	\N	\N	\N	\N	21859	21859	21860
7019	5816	1	applied	\N	\N	\N	\N	21861	21861	21862
7019	5817	2	applied	\N	\N	\N	\N	21863	21863	21864
7019	5818	3	applied	\N	\N	\N	\N	21865	21865	21866
7022	5823	0	applied	\N	\N	\N	\N	21880	21880	21881
7022	5824	1	applied	\N	\N	\N	\N	21882	21882	21883
7022	5825	2	applied	\N	\N	\N	\N	21884	21884	21885
7022	5826	3	applied	\N	\N	\N	\N	21886	21886	21887
7022	5827	4	applied	\N	\N	\N	\N	21888	21888	21889
7022	5828	5	applied	\N	\N	\N	\N	21890	21890	21891
7027	5833	0	applied	\N	\N	\N	\N	21907	21907	21908
7027	5834	1	applied	\N	\N	\N	\N	21909	21909	21910
7032	5841	0	applied	\N	\N	\N	\N	21930	21930	21931
7032	5842	1	applied	\N	\N	\N	\N	21932	21932	21933
7032	5843	2	applied	\N	\N	\N	\N	21934	21934	21935
7032	5844	3	applied	\N	\N	\N	\N	21936	21936	21937
7035	5849	0	applied	\N	\N	\N	\N	21947	21947	21948
7035	5850	1	applied	\N	\N	\N	\N	21949	21949	21950
7035	5851	2	applied	\N	\N	\N	\N	21951	21951	21952
7035	5852	3	applied	\N	\N	\N	\N	21953	21953	21954
7038	5857	0	applied	\N	\N	\N	\N	21969	21969	21970
7038	5858	1	applied	\N	\N	\N	\N	21971	21971	21972
7040	5859	0	applied	\N	\N	\N	\N	21977	21977	21978
7040	5860	1	applied	\N	\N	\N	\N	21979	21979	21980
7043	5866	0	applied	\N	\N	\N	\N	21995	21995	21996
7043	5867	1	applied	\N	\N	\N	\N	21997	21997	21998
7043	5868	2	applied	\N	\N	\N	\N	21999	21999	22000
7043	5869	3	applied	\N	\N	\N	\N	22001	22001	22002
7046	5872	0	applied	\N	\N	\N	\N	22011	22011	22012
7046	5873	1	applied	\N	\N	\N	\N	22013	22013	22014
7046	5874	2	applied	\N	\N	\N	\N	22015	22015	22016
7046	5875	3	applied	\N	\N	\N	\N	22017	22017	22018
7058	5890	0	applied	\N	\N	\N	\N	22065	22065	22066
7058	5891	1	applied	\N	\N	\N	\N	22067	22067	22068
7072	5908	0	applied	\N	\N	\N	\N	22122	22122	22123
7074	5909	0	applied	\N	\N	\N	\N	22126	22126	22127
7074	5910	1	applied	\N	\N	\N	\N	22128	22128	22129
7080	5922	0	applied	\N	\N	\N	\N	22161	22161	22162
7080	5923	1	applied	\N	\N	\N	\N	22163	22163	22164
7080	5924	2	applied	\N	\N	\N	\N	22165	22165	22166
7080	5925	3	applied	\N	\N	\N	\N	22167	22167	22168
7083	5930	0	applied	\N	\N	\N	\N	22183	22183	22184
7083	5931	1	applied	\N	\N	\N	\N	22185	22185	22186
7083	5932	2	applied	\N	\N	\N	\N	22187	22187	22188
7083	5933	3	applied	\N	\N	\N	\N	22189	22189	22190
7085	5934	0	applied	\N	\N	\N	\N	22195	22195	22196
7085	5935	1	applied	\N	\N	\N	\N	22197	22197	22198
7095	5948	0	applied	\N	\N	\N	\N	22235	22235	22236
7095	5949	1	applied	\N	\N	\N	\N	22239	22239	22240
7097	5950	0	applied	\N	\N	\N	\N	22242	22242	22243
7097	5951	1	applied	\N	\N	\N	\N	22244	22244	22245
7100	5952	0	applied	\N	\N	\N	\N	22249	22249	22250
7100	5953	1	applied	\N	\N	\N	\N	22251	22251	22252
7106	5959	0	applied	\N	\N	\N	\N	22268	22268	22269
7106	5960	1	applied	\N	\N	\N	\N	22270	22270	22271
7111	5971	0	applied	\N	\N	\N	\N	22303	22303	22304
7111	5972	1	applied	\N	\N	\N	\N	22305	22305	22306
7111	5973	2	applied	\N	\N	\N	\N	22307	22307	22308
7111	5974	3	applied	\N	\N	\N	\N	22309	22309	22310
7114	5981	0	applied	\N	\N	\N	\N	22327	22327	22328
7114	5982	1	applied	\N	\N	1000000000	\N	22329	22329	22330
7114	5983	2	applied	\N	\N	\N	\N	22331	22331	22332
7121	6005	0	applied	\N	\N	\N	\N	22384	22384	22385
7121	6006	1	applied	\N	\N	\N	\N	22386	22386	22387
7121	6007	2	applied	\N	\N	\N	\N	22388	22388	22389
7121	6008	3	applied	\N	\N	1000000000	\N	22390	22390	22391
7121	6009	4	applied	\N	\N	\N	\N	22392	22392	22393
7122	6010	0	applied	\N	\N	\N	\N	22395	22395	22396
7122	6011	1	applied	\N	\N	\N	\N	22397	22397	22398
7122	6012	2	applied	\N	\N	\N	\N	22399	22399	22400
7122	6013	3	applied	\N	\N	\N	\N	22401	22401	22402
7122	6014	4	applied	\N	\N	\N	\N	22403	22403	22404
7122	6015	5	applied	\N	\N	\N	\N	22405	22405	22406
7124	6016	0	applied	\N	\N	\N	\N	22410	22410	22411
7124	6017	1	applied	\N	\N	\N	\N	22412	22412	22413
7129	6022	0	applied	\N	\N	\N	\N	22427	22427	22428
7129	6023	1	applied	\N	\N	\N	\N	22429	22429	22430
6970	5747	1	applied	\N	\N	\N	\N	21659	21659	21660
6970	5748	2	applied	\N	\N	\N	\N	21661	21661	21662
6970	5749	3	applied	\N	\N	\N	\N	21663	21663	21664
6970	5750	4	applied	\N	\N	\N	\N	21665	21665	21666
6970	5751	5	applied	\N	\N	\N	\N	21667	21667	21668
6970	5752	6	applied	\N	\N	\N	\N	21669	21669	21670
6970	5753	7	applied	\N	\N	\N	\N	21671	21671	21672
6970	5754	8	applied	\N	\N	\N	\N	21673	21673	21674
6974	5756	0	applied	\N	\N	\N	\N	21680	21680	21681
6974	5755	1	applied	\N	\N	\N	\N	21676	21676	21677
6977	5757	0	applied	\N	\N	\N	\N	21690	21690	21691
6977	5756	1	applied	\N	\N	\N	\N	21680	21680	21681
6977	5758	2	applied	\N	\N	\N	\N	21692	21692	21693
6979	5761	0	applied	\N	\N	\N	\N	21700	21700	21701
6979	5762	1	applied	\N	\N	\N	\N	21702	21702	21703
6987	5777	0	applied	\N	\N	\N	\N	21743	21743	21744
6987	5778	1	applied	\N	\N	\N	\N	21745	21745	21746
6990	5781	0	applied	\N	\N	\N	\N	21755	21755	21756
6990	5782	1	applied	\N	\N	\N	\N	21757	21757	21758
6990	5783	2	applied	\N	\N	\N	\N	21759	21759	21760
6990	5784	3	applied	\N	\N	\N	\N	21761	21761	21762
6994	5785	0	applied	\N	\N	\N	\N	21767	21767	21768
6994	5786	1	applied	\N	\N	1000000000	\N	21769	21769	21770
6994	5787	2	applied	\N	\N	\N	\N	21771	21771	21772
6994	5788	3	applied	\N	\N	\N	\N	21773	21773	21774
6994	5789	4	applied	\N	\N	\N	\N	21775	21775	21776
6994	5790	5	applied	\N	\N	\N	\N	21777	21777	21778
6994	5791	6	applied	\N	\N	\N	\N	21779	21779	21780
6994	5792	7	applied	\N	\N	\N	\N	21781	21781	21782
6994	5793	8	applied	\N	\N	\N	\N	21783	21783	21784
6995	5794	0	applied	\N	\N	\N	\N	21791	21791	21792
6995	5795	1	applied	\N	\N	\N	\N	21793	21793	21794
7000	5798	0	applied	\N	\N	\N	\N	21805	21805	21806
7000	5799	1	applied	\N	\N	\N	\N	21807	21807	21808
7006	5800	0	applied	\N	\N	\N	\N	21811	21811	21812
7006	5801	1	applied	\N	\N	\N	\N	21813	21813	21814
7011	5802	0	applied	\N	\N	\N	\N	21819	21819	21820
7011	5803	1	applied	\N	\N	\N	\N	21821	21821	21822
7011	5804	2	applied	\N	\N	\N	\N	21823	21823	21824
7011	5805	3	applied	\N	\N	\N	\N	21825	21825	21826
7011	5806	4	applied	\N	\N	\N	\N	21827	21827	21828
7015	5809	0	applied	\N	\N	\N	\N	21842	21842	21843
7015	5810	1	applied	\N	\N	\N	\N	21844	21844	21845
7018	5815	0	applied	\N	\N	\N	\N	21859	21859	21860
7018	5816	1	applied	\N	\N	\N	\N	21861	21861	21862
7018	5817	2	applied	\N	\N	\N	\N	21863	21863	21864
7018	5818	3	applied	\N	\N	\N	\N	21865	21865	21866
7023	5823	0	applied	\N	\N	\N	\N	21880	21880	21881
7023	5824	1	applied	\N	\N	\N	\N	21882	21882	21883
7023	5825	2	applied	\N	\N	\N	\N	21884	21884	21885
7023	5826	3	applied	\N	\N	\N	\N	21886	21886	21887
7023	5827	4	applied	\N	\N	\N	\N	21888	21888	21889
7023	5828	5	applied	\N	\N	\N	\N	21890	21890	21891
7026	5829	0	applied	\N	\N	\N	\N	21894	21894	21895
7026	5830	1	applied	\N	\N	\N	\N	21896	21896	21897
7026	5831	2	applied	\N	\N	\N	\N	21898	21898	21899
7026	5832	3	applied	\N	\N	\N	\N	21900	21900	21901
7028	5833	0	applied	\N	\N	\N	\N	21907	21907	21908
7028	5834	1	applied	\N	\N	\N	\N	21909	21909	21910
7049	5876	0	applied	\N	\N	\N	\N	22024	22024	22025
7049	5877	1	applied	\N	\N	\N	\N	22026	22026	22027
7052	5880	0	applied	\N	\N	\N	\N	22034	22034	22035
7052	5881	1	applied	\N	\N	\N	\N	22036	22036	22037
7054	5882	0	applied	\N	\N	\N	\N	22044	22044	22045
7054	5883	1	applied	\N	\N	\N	\N	22046	22046	22047
7054	5884	2	applied	\N	\N	\N	\N	22048	22048	22049
7054	5885	3	applied	\N	\N	\N	\N	22050	22050	22051
7059	5890	0	applied	\N	\N	\N	\N	22065	22065	22066
7059	5891	1	applied	\N	\N	\N	\N	22067	22067	22068
7062	5896	0	applied	\N	\N	\N	\N	22083	22083	22084
7062	5897	1	applied	\N	\N	\N	\N	22085	22085	22086
7064	5898	0	applied	\N	\N	\N	\N	22089	22089	22090
7064	5899	1	applied	\N	\N	\N	\N	22091	22091	22092
7064	5900	2	applied	\N	\N	\N	\N	22093	22093	22094
7064	5901	3	applied	\N	\N	\N	\N	22095	22095	22096
7067	5902	0	applied	\N	\N	\N	\N	22099	22099	22100
7067	5903	1	applied	\N	\N	1000000000	\N	22101	22101	22102
7067	5904	2	applied	\N	\N	\N	\N	22103	22103	22104
7073	5909	0	applied	\N	\N	\N	\N	22126	22126	22127
7073	5910	1	applied	\N	\N	\N	\N	22128	22128	22129
7079	5922	0	applied	\N	\N	\N	\N	22161	22161	22162
7079	5923	1	applied	\N	\N	\N	\N	22163	22163	22164
7079	5924	2	applied	\N	\N	\N	\N	22165	22165	22166
7079	5925	3	applied	\N	\N	\N	\N	22167	22167	22168
7082	5930	0	applied	\N	\N	\N	\N	22183	22183	22184
7082	5931	1	applied	\N	\N	\N	\N	22185	22185	22186
7082	5932	2	applied	\N	\N	\N	\N	22187	22187	22188
7082	5933	3	applied	\N	\N	\N	\N	22189	22189	22190
7084	5930	0	applied	\N	\N	\N	\N	22183	22183	22184
7084	5931	1	applied	\N	\N	\N	\N	22185	22185	22186
7084	5932	2	applied	\N	\N	\N	\N	22187	22187	22188
7084	5933	3	applied	\N	\N	\N	\N	22189	22189	22190
7089	5940	0	applied	\N	\N	\N	\N	22212	22212	22213
7089	5941	1	applied	\N	\N	\N	\N	22214	22214	22215
7094	5948	0	applied	\N	\N	\N	\N	22235	22235	22236
7096	5950	0	applied	\N	\N	\N	\N	22242	22242	22243
7096	5951	1	applied	\N	\N	\N	\N	22244	22244	22245
7102	5952	0	applied	\N	\N	\N	\N	22249	22249	22250
7113	5975	0	applied	\N	\N	\N	\N	22314	22314	22315
7113	5976	1	applied	\N	\N	\N	\N	22316	22316	22317
7113	5977	2	applied	\N	\N	\N	\N	22318	22318	22319
7113	5978	3	applied	\N	\N	\N	\N	22320	22320	22321
7113	5979	4	applied	\N	\N	\N	\N	22322	22322	22323
7113	5980	5	applied	\N	\N	\N	\N	22324	22324	22325
7116	5988	0	applied	\N	\N	\N	\N	22342	22342	22343
7116	5989	1	applied	\N	\N	\N	\N	22344	22344	22345
7116	5990	2	applied	\N	\N	\N	\N	22346	22346	22347
7116	5991	3	applied	\N	\N	\N	\N	22348	22348	22349
7118	5992	0	applied	\N	\N	\N	\N	22352	22352	22353
7118	5993	1	applied	\N	\N	\N	\N	22354	22354	22355
7118	5994	2	applied	\N	\N	\N	\N	22356	22356	22357
7118	5995	3	applied	\N	\N	\N	\N	22358	22358	22359
7118	5996	4	applied	\N	\N	\N	\N	22360	22360	22361
7118	5997	5	applied	\N	\N	\N	\N	22362	22362	22363
7118	5998	6	applied	\N	\N	\N	\N	22364	22364	22365
7118	5999	7	applied	\N	\N	\N	\N	22366	22366	22367
7118	6000	8	applied	\N	\N	\N	\N	22368	22368	22369
7118	6001	9	applied	\N	\N	\N	\N	22370	22370	22371
7118	6002	10	applied	\N	\N	\N	\N	22372	22372	22373
7056	5887	1	applied	\N	\N	\N	\N	22057	22057	22058
7066	5902	0	applied	\N	\N	\N	\N	22099	22099	22100
7066	5903	1	applied	\N	\N	1000000000	\N	22101	22101	22102
7066	5904	2	applied	\N	\N	\N	\N	22103	22103	22104
7068	5902	0	applied	\N	\N	\N	\N	22099	22099	22100
7068	5903	1	applied	\N	\N	1000000000	\N	22101	22101	22102
7068	5904	2	applied	\N	\N	\N	\N	22103	22103	22104
7070	5833	0	applied	\N	\N	\N	\N	21907	21907	21908
7070	5837	1	applied	\N	\N	\N	\N	21919	21919	21920
7070	5838	2	applied	\N	\N	\N	\N	21921	21921	21922
7070	5840	3	applied	\N	\N	\N	\N	21928	21928	21929
7070	5841	4	applied	\N	\N	\N	\N	21930	21930	21931
7070	5842	5	applied	\N	\N	\N	\N	21932	21932	21933
7070	5845	6	applied	\N	\N	\N	\N	21938	21938	21939
7070	5834	7	applied	\N	\N	\N	\N	21909	21909	21910
7070	5835	8	applied	\N	\N	\N	\N	21915	21915	21916
7070	5836	9	applied	\N	\N	\N	\N	21917	21917	21918
7070	5839	10	applied	\N	\N	\N	\N	21926	21926	21927
7070	5843	11	applied	\N	\N	\N	\N	21934	21934	21935
7070	5844	12	applied	\N	\N	\N	\N	21936	21936	21937
7070	5846	13	applied	\N	\N	\N	\N	21940	21940	21941
7070	5847	14	applied	\N	\N	\N	\N	21942	21942	21943
7070	5849	15	applied	\N	\N	\N	\N	21947	21947	21948
7070	5852	16	applied	\N	\N	\N	\N	21953	21953	21954
7070	5853	17	applied	\N	\N	\N	\N	21957	21957	21958
7070	5856	18	applied	\N	\N	\N	\N	21965	21965	21966
7070	5857	19	applied	\N	\N	\N	\N	21969	21969	21970
7070	5859	20	applied	\N	\N	\N	\N	21977	21977	21978
7070	5862	21	applied	\N	\N	\N	\N	21984	21984	21985
7070	5863	22	applied	\N	\N	\N	\N	21986	21986	21987
7070	5868	23	applied	\N	\N	\N	\N	21999	21999	22000
7070	5869	24	applied	\N	\N	\N	\N	22001	22001	22002
7070	5871	25	applied	\N	\N	\N	\N	22009	22009	22010
7070	5872	26	applied	\N	\N	\N	\N	22011	22011	22012
7070	5873	27	applied	\N	\N	\N	\N	22013	22013	22014
7070	5876	28	applied	\N	\N	\N	\N	22024	22024	22025
7070	5878	29	applied	\N	\N	\N	\N	22029	22029	22030
7070	5880	30	applied	\N	\N	\N	\N	22034	22034	22035
7070	5882	31	applied	\N	\N	\N	\N	22044	22044	22045
7070	5883	32	applied	\N	\N	\N	\N	22046	22046	22047
7070	5886	33	applied	\N	\N	\N	\N	22055	22055	22056
7070	5888	34	applied	\N	\N	\N	\N	22059	22059	22060
7070	5891	35	applied	\N	\N	\N	\N	22067	22067	22068
7070	5892	36	applied	\N	\N	\N	\N	22072	22072	22073
7070	5893	37	applied	\N	\N	\N	\N	22074	22074	22075
7070	5897	38	applied	\N	\N	\N	\N	22085	22085	22086
7070	5900	39	applied	\N	\N	\N	\N	22093	22093	22094
7070	5901	40	applied	\N	\N	\N	\N	22095	22095	22096
7070	5848	41	applied	\N	\N	\N	\N	21944	21944	21945
7070	5850	42	applied	\N	\N	\N	\N	21949	21949	21950
7070	5851	43	applied	\N	\N	\N	\N	21951	21951	21952
7070	5854	44	applied	\N	\N	\N	\N	21959	21959	21960
7070	5855	45	applied	\N	\N	\N	\N	21963	21963	21964
7070	5858	46	applied	\N	\N	\N	\N	21971	21971	21972
7070	5860	47	applied	\N	\N	\N	\N	21979	21979	21980
7070	5861	48	applied	\N	\N	1000000000	\N	21982	21982	21983
7070	5864	49	applied	\N	\N	\N	\N	21989	21989	21990
7070	5865	50	applied	\N	\N	\N	\N	21991	21991	21992
7070	5866	51	applied	\N	\N	\N	\N	21995	21995	21996
7070	5867	52	applied	\N	\N	\N	\N	21997	21997	21998
7070	5870	54	applied	\N	\N	\N	\N	22007	22007	22008
7070	5874	55	applied	\N	\N	\N	\N	22015	22015	22016
7070	5875	56	applied	\N	\N	\N	\N	22017	22017	22018
7070	5877	57	applied	\N	\N	\N	\N	22026	22026	22027
7070	5879	58	applied	\N	\N	\N	\N	22031	22031	22032
7070	5881	59	applied	\N	\N	\N	\N	22036	22036	22037
7070	5884	60	applied	\N	\N	\N	\N	22048	22048	22049
7070	5885	61	applied	\N	\N	\N	\N	22050	22050	22051
7070	5887	62	applied	\N	\N	\N	\N	22057	22057	22058
7070	5889	63	applied	\N	\N	\N	\N	22061	22061	22062
7070	5890	64	applied	\N	\N	\N	\N	22065	22065	22066
7070	5894	65	applied	\N	\N	\N	\N	22076	22076	22077
7070	5895	66	applied	\N	\N	\N	\N	22078	22078	22079
7070	5896	67	applied	\N	\N	\N	\N	22083	22083	22084
7070	5898	68	applied	\N	\N	\N	\N	22089	22089	22090
7070	5899	69	applied	\N	\N	\N	\N	22091	22091	22092
7070	5902	70	applied	\N	\N	\N	\N	22099	22099	22100
7070	5903	71	applied	\N	\N	1000000000	\N	22101	22101	22102
7070	5904	72	applied	\N	\N	\N	\N	22103	22103	22104
7076	5911	0	applied	\N	\N	\N	\N	22133	22133	22134
7076	5909	1	applied	\N	\N	\N	\N	22126	22126	22127
7076	5912	2	applied	\N	\N	\N	\N	22135	22135	22136
7076	5913	3	applied	\N	\N	\N	\N	22137	22137	22138
7076	5914	4	applied	\N	\N	\N	\N	22139	22139	22140
7076	5915	5	applied	\N	\N	\N	\N	22141	22141	22142
7076	5916	6	applied	\N	\N	\N	\N	22143	22143	22144
7076	5910	7	applied	\N	\N	\N	\N	22128	22128	22129
7076	5917	8	applied	\N	\N	\N	\N	22145	22145	22146
7076	5918	9	applied	\N	\N	\N	\N	22147	22147	22148
7076	5919	10	applied	\N	\N	\N	\N	22149	22149	22150
7076	5920	11	applied	\N	\N	\N	\N	22151	22151	22152
7076	5921	12	applied	\N	\N	\N	\N	22153	22153	22154
7078	5800	0	applied	\N	\N	\N	\N	21811	21811	21812
7078	5801	1	applied	\N	\N	\N	\N	21813	21813	21814
7078	5911	2	applied	\N	\N	\N	\N	22157	22157	22134
7078	5802	3	applied	\N	\N	\N	\N	21819	21819	21820
7078	5803	4	applied	\N	\N	\N	\N	21821	21821	21822
7078	5804	5	applied	\N	\N	\N	\N	21823	21823	21824
7078	5805	6	applied	\N	\N	\N	\N	21825	21825	21826
7078	5807	7	applied	\N	\N	\N	\N	21835	21835	21836
7078	5809	8	applied	\N	\N	\N	\N	21842	21842	21843
7078	5811	9	applied	\N	\N	\N	\N	21848	21848	21849
7078	5812	10	applied	\N	\N	\N	\N	21850	21850	21851
7078	5816	11	applied	\N	\N	\N	\N	21861	21861	21862
7078	5817	12	applied	\N	\N	\N	\N	21863	21863	21864
7078	5821	13	applied	\N	\N	\N	\N	21876	21876	21877
7078	5822	14	applied	\N	\N	\N	\N	21878	21878	21879
7078	5808	15	applied	\N	\N	\N	\N	21837	21837	21838
7078	5810	16	applied	\N	\N	\N	\N	21844	21844	21845
7078	5813	17	applied	\N	\N	\N	\N	21852	21852	21853
7078	5814	18	applied	\N	\N	\N	\N	21854	21854	21855
7078	5815	19	applied	\N	\N	\N	\N	21859	21859	21860
7078	5825	20	applied	\N	\N	\N	\N	21884	21884	21885
7078	5826	21	applied	\N	\N	\N	\N	21886	21886	21887
7078	5827	22	applied	\N	\N	\N	\N	21888	21888	21889
7078	5829	23	applied	\N	\N	\N	\N	21894	21894	21895
7078	5832	24	applied	\N	\N	\N	\N	21900	21900	21901
7078	5818	25	applied	\N	\N	\N	\N	21865	21865	21866
7078	5819	26	applied	\N	\N	\N	\N	21872	21872	21873
7077	5918	9	applied	\N	\N	\N	\N	22147	22147	22148
7077	5919	10	applied	\N	\N	\N	\N	22149	22149	22150
7077	5920	11	applied	\N	\N	\N	\N	22151	22151	22152
7077	5921	12	applied	\N	\N	\N	\N	22153	22153	22154
7087	5936	0	applied	\N	\N	\N	\N	22200	22200	22201
7087	5937	1	applied	\N	\N	\N	\N	22202	22202	22203
7090	5942	0	applied	\N	\N	\N	\N	22218	22218	22219
7090	5943	1	applied	\N	\N	\N	\N	22220	22220	22221
7092	5945	0	applied	\N	\N	\N	\N	22226	22226	22227
7092	5946	1	applied	\N	\N	\N	\N	22228	22228	22229
7092	5947	2	applied	\N	\N	\N	\N	22230	22230	22231
7099	5952	0	applied	\N	\N	\N	\N	22249	22249	22250
7099	5953	1	applied	\N	\N	\N	\N	22251	22251	22252
7103	5954	0	applied	\N	\N	\N	\N	22254	22254	22255
7103	5955	1	applied	\N	\N	\N	\N	22256	22256	22257
7104	5956	0	applied	\N	\N	\N	\N	22260	22260	22261
7104	5957	1	applied	\N	\N	\N	\N	22262	22262	22263
7104	5958	2	applied	\N	\N	\N	\N	22264	22264	22265
7105	5959	0	applied	\N	\N	\N	\N	22268	22268	22269
7105	5960	1	applied	\N	\N	\N	\N	22270	22270	22271
7110	5967	0	applied	\N	\N	\N	\N	22293	22293	22294
7110	5968	1	applied	\N	\N	\N	\N	22295	22295	22296
7110	5969	2	applied	\N	\N	\N	\N	22297	22297	22298
7110	5970	3	applied	\N	\N	\N	\N	22299	22299	22300
7126	6018	0	applied	\N	\N	\N	\N	22417	22417	22418
7126	6019	1	applied	\N	\N	\N	\N	22419	22419	22420
7131	6024	0	applied	\N	\N	\N	\N	22433	22433	22434
7131	6025	1	applied	\N	\N	\N	\N	22435	22435	22436
7078	5820	27	applied	\N	\N	\N	\N	21874	21874	21875
7078	5823	28	applied	\N	\N	\N	\N	21880	21880	21881
7078	5824	29	applied	\N	\N	\N	\N	21882	21882	21883
7078	5828	30	applied	\N	\N	\N	\N	21890	21890	21891
7078	5830	31	applied	\N	\N	\N	\N	21896	21896	21897
7078	5831	32	applied	\N	\N	\N	\N	21898	21898	21899
7078	5833	33	applied	\N	\N	\N	\N	21907	21907	21908
7078	5837	34	applied	\N	\N	\N	\N	21919	21919	21920
7078	5838	35	applied	\N	\N	\N	\N	21921	21921	21922
7078	5840	36	applied	\N	\N	\N	\N	21928	21928	21929
7078	5841	37	applied	\N	\N	\N	\N	21930	21930	21931
7078	5842	38	applied	\N	\N	\N	\N	21932	21932	21933
7078	5845	39	applied	\N	\N	\N	\N	21938	21938	21939
7078	5834	40	applied	\N	\N	\N	\N	21909	21909	21910
7078	5835	41	applied	\N	\N	\N	\N	21915	21915	21916
7078	5836	42	applied	\N	\N	\N	\N	21917	21917	21918
7078	5839	43	applied	\N	\N	\N	\N	21926	21926	21927
7078	5843	44	applied	\N	\N	\N	\N	21934	21934	21935
7078	5844	45	applied	\N	\N	\N	\N	21936	21936	21937
7078	5846	46	applied	\N	\N	\N	\N	21940	21940	21941
7078	5847	47	applied	\N	\N	\N	\N	21942	21942	21943
7078	5849	48	applied	\N	\N	\N	\N	21947	21947	21948
7078	5852	49	applied	\N	\N	\N	\N	21953	21953	21954
7078	5853	50	applied	\N	\N	\N	\N	21957	21957	21958
7078	5856	51	applied	\N	\N	\N	\N	21965	21965	21966
7078	5857	52	applied	\N	\N	\N	\N	21969	21969	21970
7078	5859	53	applied	\N	\N	\N	\N	21977	21977	21978
7078	5862	54	applied	\N	\N	\N	\N	21984	21984	21985
7078	5863	55	applied	\N	\N	\N	\N	21986	21986	21987
7078	5868	56	applied	\N	\N	\N	\N	21999	21999	22000
7078	5869	57	applied	\N	\N	\N	\N	22001	22001	22002
7078	5871	58	applied	\N	\N	\N	\N	22009	22009	22010
7078	5872	59	applied	\N	\N	\N	\N	22011	22011	22012
7078	5873	60	applied	\N	\N	\N	\N	22013	22013	22014
7078	5876	61	applied	\N	\N	\N	\N	22024	22024	22025
7078	5878	62	applied	\N	\N	\N	\N	22029	22029	22030
7078	5880	63	applied	\N	\N	\N	\N	22034	22034	22035
7078	5882	64	applied	\N	\N	\N	\N	22044	22044	22045
7078	5883	65	applied	\N	\N	\N	\N	22046	22046	22047
7078	5886	66	applied	\N	\N	\N	\N	22055	22055	22056
7078	5888	67	applied	\N	\N	\N	\N	22059	22059	22060
7078	5891	68	applied	\N	\N	\N	\N	22067	22067	22068
7078	5892	69	applied	\N	\N	\N	\N	22072	22072	22073
7078	5893	70	applied	\N	\N	\N	\N	22074	22074	22075
7078	5897	71	applied	\N	\N	\N	\N	22085	22085	22086
7078	5900	72	applied	\N	\N	\N	\N	22093	22093	22094
7078	5901	73	applied	\N	\N	\N	\N	22095	22095	22096
7078	5848	74	applied	\N	\N	\N	\N	21944	21944	21945
7078	5850	75	applied	\N	\N	\N	\N	21949	21949	21950
7078	5851	76	applied	\N	\N	\N	\N	21951	21951	21952
7078	5854	77	applied	\N	\N	\N	\N	21959	21959	21960
7078	5855	78	applied	\N	\N	\N	\N	21963	21963	21964
7078	5858	79	applied	\N	\N	\N	\N	21971	21971	21972
7078	5860	80	applied	\N	\N	\N	\N	21979	21979	21980
7078	5861	81	applied	\N	\N	1000000000	\N	21982	21982	21983
7078	5864	82	applied	\N	\N	\N	\N	21989	21989	21990
7078	5865	83	applied	\N	\N	\N	\N	21991	21991	21992
7078	5866	84	applied	\N	\N	\N	\N	21995	21995	21996
7078	5867	85	applied	\N	\N	\N	\N	21997	21997	21998
7078	5870	86	applied	\N	\N	\N	\N	22007	22007	22008
7078	5874	87	applied	\N	\N	\N	\N	22015	22015	22016
7078	5875	88	applied	\N	\N	\N	\N	22017	22017	22018
7078	5877	89	applied	\N	\N	\N	\N	22026	22026	22027
7078	5879	90	applied	\N	\N	\N	\N	22031	22031	22032
7078	5881	91	applied	\N	\N	\N	\N	22036	22036	22037
7078	5884	92	applied	\N	\N	\N	\N	22048	22048	22049
7078	5885	93	applied	\N	\N	\N	\N	22050	22050	22051
7078	5887	94	applied	\N	\N	\N	\N	22057	22057	22058
7078	5889	95	applied	\N	\N	\N	\N	22061	22061	22062
7078	5890	96	applied	\N	\N	\N	\N	22065	22065	22066
7078	5894	97	applied	\N	\N	\N	\N	22076	22076	22077
7078	5895	98	applied	\N	\N	\N	\N	22078	22078	22079
7078	5896	99	applied	\N	\N	\N	\N	22083	22083	22084
7078	5898	100	applied	\N	\N	\N	\N	22089	22089	22090
7078	5899	101	applied	\N	\N	\N	\N	22091	22091	22092
7078	5902	102	applied	\N	\N	\N	\N	22099	22099	22100
7078	5903	103	applied	\N	\N	1000000000	\N	22101	22101	22102
7078	5905	105	applied	\N	\N	1000000000	\N	22114	22114	22115
7078	5906	106	applied	\N	\N	\N	\N	22116	22116	22117
7078	5909	107	applied	\N	\N	\N	\N	22126	22126	22127
7078	5912	108	applied	\N	\N	\N	\N	22135	22135	22136
7078	5913	109	applied	\N	\N	\N	\N	22137	22137	22138
7078	5914	110	applied	\N	\N	\N	\N	22139	22139	22140
7078	5915	111	applied	\N	\N	\N	\N	22141	22141	22142
7078	5916	112	applied	\N	\N	\N	\N	22143	22143	22144
7078	5904	113	applied	\N	\N	\N	\N	22103	22103	22104
7078	5907	114	applied	\N	\N	\N	\N	22118	22118	22119
7078	5908	115	applied	\N	\N	\N	\N	22122	22122	22123
7078	5910	116	applied	\N	\N	\N	\N	22128	22128	22129
7078	5917	117	applied	\N	\N	\N	\N	22145	22145	22146
7078	5918	118	applied	\N	\N	\N	\N	22147	22147	22148
7078	5919	119	applied	\N	\N	\N	\N	22149	22149	22150
7078	5920	120	applied	\N	\N	\N	\N	22151	22151	22152
7078	5921	121	applied	\N	\N	\N	\N	22153	22153	22154
7078	5806	122	applied	\N	\N	\N	\N	21827	21827	21828
7081	5926	0	applied	\N	\N	\N	\N	22173	22173	22174
7081	5927	1	applied	\N	\N	\N	\N	22175	22175	22176
7081	5928	2	applied	\N	\N	\N	\N	22177	22177	22178
7081	5929	3	applied	\N	\N	\N	\N	22179	22179	22180
7086	5934	0	applied	\N	\N	\N	\N	22195	22195	22196
7086	5935	1	applied	\N	\N	\N	\N	22197	22197	22198
7088	5938	0	applied	\N	\N	\N	\N	22206	22206	22207
7088	5939	1	applied	\N	\N	\N	\N	22208	22208	22209
7091	5944	0	applied	\N	\N	\N	\N	22223	22223	22224
7093	5945	0	applied	\N	\N	\N	\N	22226	22226	22227
7093	5946	1	applied	\N	\N	\N	\N	22228	22228	22229
7093	5947	2	applied	\N	\N	\N	\N	22230	22230	22231
7098	5950	0	applied	\N	\N	\N	\N	22242	22242	22243
7098	5951	1	applied	\N	\N	\N	\N	22244	22244	22245
7101	5952	0	applied	\N	\N	\N	\N	22249	22249	22250
7101	5953	1	applied	\N	\N	\N	\N	22251	22251	22252
7107	5961	0	applied	\N	\N	\N	\N	22276	22276	22277
7107	5962	1	applied	\N	\N	\N	\N	22278	22278	22279
7108	5963	0	applied	\N	\N	\N	\N	22282	22282	22283
7108	5964	1	applied	\N	\N	\N	\N	22284	22284	22285
7108	5965	2	applied	\N	\N	\N	\N	22286	22286	22287
7108	5966	3	applied	\N	\N	\N	\N	22288	22288	22289
7109	5963	0	applied	\N	\N	\N	\N	22282	22282	22283
7109	5964	1	applied	\N	\N	\N	\N	22284	22284	22285
7109	5965	2	applied	\N	\N	\N	\N	22286	22286	22287
7109	5966	3	applied	\N	\N	\N	\N	22288	22288	22289
7112	5971	0	applied	\N	\N	\N	\N	22303	22303	22304
7112	5972	1	applied	\N	\N	\N	\N	22305	22305	22306
7112	5973	2	applied	\N	\N	\N	\N	22307	22307	22308
7112	5974	3	applied	\N	\N	\N	\N	22309	22309	22310
7115	5984	0	applied	\N	\N	\N	\N	22334	22334	22335
7115	5985	1	applied	\N	\N	\N	\N	22336	22336	22337
7115	5986	2	applied	\N	\N	\N	\N	22338	22338	22339
7115	5987	3	applied	\N	\N	\N	\N	22340	22340	22341
7117	5992	0	applied	\N	\N	\N	\N	22352	22352	22353
7117	5993	1	applied	\N	\N	\N	\N	22354	22354	22355
7117	5994	2	applied	\N	\N	\N	\N	22356	22356	22357
7117	5995	3	applied	\N	\N	\N	\N	22358	22358	22359
7117	5996	4	applied	\N	\N	\N	\N	22360	22360	22361
7117	5997	5	applied	\N	\N	\N	\N	22362	22362	22363
7117	5998	6	applied	\N	\N	\N	\N	22364	22364	22365
7117	5999	7	applied	\N	\N	\N	\N	22366	22366	22367
7117	6000	8	applied	\N	\N	\N	\N	22368	22368	22369
7117	6001	9	applied	\N	\N	\N	\N	22370	22370	22371
7117	6002	10	applied	\N	\N	\N	\N	22372	22372	22373
7119	6003	0	applied	\N	\N	\N	\N	22378	22378	22379
7119	6004	1	applied	\N	\N	\N	\N	22380	22380	22381
7125	6016	0	applied	\N	\N	\N	\N	22410	22410	22411
7125	6017	1	applied	\N	\N	\N	\N	22412	22412	22413
7127	6020	0	applied	\N	\N	\N	\N	22421	22421	22422
7127	6021	1	applied	\N	\N	\N	\N	22423	22423	22424
7120	6003	0	applied	\N	\N	\N	\N	22378	22378	22379
7120	6004	1	applied	\N	\N	\N	\N	22380	22380	22381
7123	6010	0	applied	\N	\N	\N	\N	22395	22395	22396
7123	6011	1	applied	\N	\N	\N	\N	22397	22397	22398
7123	6012	2	applied	\N	\N	\N	\N	22399	22399	22400
7123	6013	3	applied	\N	\N	\N	\N	22401	22401	22402
7123	6014	4	applied	\N	\N	\N	\N	22403	22403	22404
7123	6015	5	applied	\N	\N	\N	\N	22405	22405	22406
7128	6022	0	applied	\N	\N	\N	\N	22427	22427	22428
7128	6023	1	applied	\N	\N	\N	\N	22429	22429	22430
7130	6024	0	applied	\N	\N	\N	\N	22433	22433	22434
7130	6025	1	applied	\N	\N	\N	\N	22435	22435	22436
7132	6026	0	applied	\N	\N	\N	\N	22440	22440	22441
7132	6027	1	applied	\N	\N	\N	\N	22442	22442	22443
7133	6028	0	applied	\N	\N	\N	\N	22446	22446	22447
7133	6029	1	applied	\N	\N	\N	\N	22448	22448	22449
7133	6030	2	applied	\N	\N	\N	\N	22450	22450	22451
7134	6028	0	applied	\N	\N	\N	\N	22446	22446	22447
7134	6029	1	applied	\N	\N	\N	\N	22448	22448	22449
7134	6030	2	applied	\N	\N	\N	\N	22450	22450	22451
7135	6028	0	applied	\N	\N	\N	\N	22446	22446	22447
7135	6029	1	applied	\N	\N	\N	\N	22448	22448	22449
7135	6030	2	applied	\N	\N	\N	\N	22450	22450	22451
7136	6031	0	applied	\N	\N	\N	\N	22457	22457	22458
7136	6032	1	applied	\N	\N	\N	\N	22459	22459	22460
7137	6031	0	applied	\N	\N	\N	\N	22457	22457	22458
7137	6032	1	applied	\N	\N	\N	\N	22459	22459	22460
7138	6031	0	applied	\N	\N	\N	\N	22457	22457	22458
7138	6032	1	applied	\N	\N	\N	\N	22459	22459	22460
7139	6033	0	applied	\N	\N	\N	\N	22464	22464	22465
7141	6034	0	applied	\N	\N	\N	\N	22468	22468	22469
7142	6035	0	applied	\N	\N	\N	\N	22472	22472	22473
7142	6036	1	applied	\N	\N	\N	\N	22474	22474	22475
7142	6037	2	applied	\N	\N	\N	\N	22476	22476	22477
7143	6035	0	applied	\N	\N	\N	\N	22472	22472	22473
7143	6036	1	applied	\N	\N	\N	\N	22474	22474	22475
7143	6037	2	applied	\N	\N	\N	\N	22476	22476	22477
7144	6038	0	applied	\N	\N	\N	\N	22479	22479	22480
7145	6039	0	applied	\N	\N	\N	\N	22481	22481	22482
7146	6039	0	applied	\N	\N	\N	\N	22481	22481	22482
7147	6039	0	applied	\N	\N	\N	\N	22481	22481	22482
7148	6040	0	applied	\N	\N	1000000000	\N	22486	22486	22487
7148	6041	1	applied	\N	\N	\N	\N	22488	22488	22489
7149	6040	0	applied	\N	\N	1000000000	\N	22486	22486	22487
7149	6041	1	applied	\N	\N	\N	\N	22488	22488	22489
7150	5905	0	applied	\N	\N	1000000000	\N	22114	22114	22115
7150	5911	1	applied	\N	\N	\N	\N	22157	22157	22134
7150	5906	2	applied	\N	\N	\N	\N	22116	22116	22117
7150	5909	3	applied	\N	\N	\N	\N	22126	22126	22127
7150	5912	4	applied	\N	\N	\N	\N	22135	22135	22136
7150	5913	5	applied	\N	\N	\N	\N	22137	22137	22138
7150	5914	6	applied	\N	\N	\N	\N	22139	22139	22140
7150	5915	7	applied	\N	\N	\N	\N	22141	22141	22142
7150	5916	8	applied	\N	\N	\N	\N	22143	22143	22144
7150	5922	9	applied	\N	\N	\N	\N	22161	22161	22162
7150	5907	10	applied	\N	\N	\N	\N	22118	22118	22119
7150	5908	11	applied	\N	\N	\N	\N	22122	22122	22123
7150	5910	12	applied	\N	\N	\N	\N	22128	22128	22129
7150	5917	13	applied	\N	\N	\N	\N	22145	22145	22146
7150	5918	14	applied	\N	\N	\N	\N	22147	22147	22148
7150	5919	15	applied	\N	\N	\N	\N	22149	22149	22150
7150	5920	16	applied	\N	\N	\N	\N	22151	22151	22152
7150	5921	17	applied	\N	\N	\N	\N	22153	22153	22154
7150	5923	18	applied	\N	\N	\N	\N	22163	22163	22164
7150	5924	19	applied	\N	\N	\N	\N	22165	22165	22166
7150	5928	20	applied	\N	\N	\N	\N	22177	22177	22178
7150	5929	21	applied	\N	\N	\N	\N	22179	22179	22180
7150	5930	22	applied	\N	\N	\N	\N	22183	22183	22184
7150	5931	23	applied	\N	\N	\N	\N	22185	22185	22186
7150	5935	24	applied	\N	\N	\N	\N	22197	22197	22198
7150	5937	25	applied	\N	\N	\N	\N	22202	22202	22203
7150	5938	26	applied	\N	\N	\N	\N	22206	22206	22207
7150	5940	27	applied	\N	\N	\N	\N	22212	22212	22213
7150	5943	28	applied	\N	\N	\N	\N	22220	22220	22221
7150	5945	29	applied	\N	\N	\N	\N	22226	22226	22227
7150	5947	30	applied	\N	\N	\N	\N	22230	22230	22231
7150	5948	31	applied	\N	\N	\N	\N	22235	22235	22236
7150	5950	32	applied	\N	\N	\N	\N	22242	22242	22243
7150	5925	33	applied	\N	\N	\N	\N	22167	22167	22168
7150	5926	34	applied	\N	\N	\N	\N	22173	22173	22174
7150	5927	35	applied	\N	\N	\N	\N	22175	22175	22176
7150	5932	36	applied	\N	\N	\N	\N	22187	22187	22188
7150	5933	37	applied	\N	\N	\N	\N	22189	22189	22190
7150	5934	38	applied	\N	\N	\N	\N	22195	22195	22196
7150	5936	39	applied	\N	\N	\N	\N	22200	22200	22201
7150	5939	40	applied	\N	\N	\N	\N	22208	22208	22209
7150	5941	41	applied	\N	\N	\N	\N	22214	22214	22215
7150	5942	42	applied	\N	\N	\N	\N	22218	22218	22219
7150	5944	43	applied	\N	\N	\N	\N	22223	22223	22224
7150	5946	44	applied	\N	\N	\N	\N	22228	22228	22229
7150	5949	45	applied	\N	\N	\N	\N	22239	22239	22240
7150	5951	46	applied	\N	\N	\N	\N	22244	22244	22245
7150	5952	47	applied	\N	\N	\N	\N	22249	22249	22250
7150	5955	48	applied	\N	\N	\N	\N	22256	22256	22257
7150	5956	49	applied	\N	\N	\N	\N	22260	22260	22261
7150	5957	50	applied	\N	\N	\N	\N	22262	22262	22263
7150	5953	51	applied	\N	\N	\N	\N	22251	22251	22252
7150	5954	52	applied	\N	\N	\N	\N	22254	22254	22255
7150	5958	53	applied	\N	\N	\N	\N	22264	22264	22265
7150	5959	54	applied	\N	\N	\N	\N	22268	22268	22269
7150	5961	55	applied	\N	\N	\N	\N	22276	22276	22277
7150	5965	56	applied	\N	\N	\N	\N	22286	22286	22287
7150	5966	57	applied	\N	\N	\N	\N	22288	22288	22289
7150	5969	58	applied	\N	\N	\N	\N	22297	22297	22298
7150	5970	59	applied	\N	\N	\N	\N	22299	22299	22300
7150	5971	60	applied	\N	\N	\N	\N	22303	22303	22304
7150	5972	61	applied	\N	\N	\N	\N	22305	22305	22306
7150	5978	62	applied	\N	\N	\N	\N	22320	22320	22321
7150	5979	63	applied	\N	\N	\N	\N	22322	22322	22323
7150	5980	64	applied	\N	\N	\N	\N	22324	22324	22325
7150	5983	65	applied	\N	\N	\N	\N	22331	22331	22332
7150	5986	66	applied	\N	\N	\N	\N	22338	22338	22339
7150	5987	67	applied	\N	\N	\N	\N	22340	22340	22341
7150	5988	68	applied	\N	\N	\N	\N	22342	22342	22343
7150	5989	69	applied	\N	\N	\N	\N	22344	22344	22345
7150	5996	70	applied	\N	\N	\N	\N	22360	22360	22361
7150	5997	71	applied	\N	\N	\N	\N	22362	22362	22363
7150	5998	72	applied	\N	\N	\N	\N	22364	22364	22365
7150	5999	73	applied	\N	\N	\N	\N	22366	22366	22367
7150	6001	74	applied	\N	\N	\N	\N	22370	22370	22371
7150	6003	75	applied	\N	\N	\N	\N	22378	22378	22379
7150	6005	76	applied	\N	\N	\N	\N	22384	22384	22385
7150	6006	77	applied	\N	\N	\N	\N	22386	22386	22387
7150	6012	78	applied	\N	\N	\N	\N	22399	22399	22400
7150	6013	79	applied	\N	\N	\N	\N	22401	22401	22402
7150	6014	80	applied	\N	\N	\N	\N	22403	22403	22404
7150	6016	81	applied	\N	\N	\N	\N	22410	22410	22411
7150	6018	82	applied	\N	\N	\N	\N	22417	22417	22418
7150	6021	83	applied	\N	\N	\N	\N	22423	22423	22424
7150	6022	84	applied	\N	\N	\N	\N	22427	22427	22428
7150	6024	85	applied	\N	\N	\N	\N	22433	22433	22434
7150	6026	86	applied	\N	\N	\N	\N	22440	22440	22441
7150	6028	87	applied	\N	\N	\N	\N	22446	22446	22447
7150	6002	88	applied	\N	\N	\N	\N	22493	22493	22373
7150	5960	89	applied	\N	\N	\N	\N	22270	22270	22271
7150	5962	90	applied	\N	\N	\N	\N	22278	22278	22279
7150	5963	91	applied	\N	\N	\N	\N	22282	22282	22283
7150	5964	92	applied	\N	\N	\N	\N	22284	22284	22285
7150	5967	93	applied	\N	\N	\N	\N	22293	22293	22294
7150	5968	94	applied	\N	\N	\N	\N	22295	22295	22296
7150	5973	95	applied	\N	\N	\N	\N	22307	22307	22308
7150	5974	96	applied	\N	\N	\N	\N	22309	22309	22310
7150	5975	97	applied	\N	\N	\N	\N	22314	22314	22315
7150	5976	98	applied	\N	\N	\N	\N	22316	22316	22317
7150	5977	99	applied	\N	\N	\N	\N	22318	22318	22319
7150	5981	100	applied	\N	\N	\N	\N	22327	22327	22328
7150	5982	101	applied	\N	\N	1000000000	\N	22329	22329	22330
7150	5984	102	applied	\N	\N	\N	\N	22334	22334	22335
7150	5985	103	applied	\N	\N	\N	\N	22336	22336	22337
7150	5990	104	applied	\N	\N	\N	\N	22346	22346	22347
7150	5991	105	applied	\N	\N	\N	\N	22348	22348	22349
7150	5992	107	applied	\N	\N	\N	\N	22352	22352	22353
7150	5993	108	applied	\N	\N	\N	\N	22354	22354	22355
7150	5994	109	applied	\N	\N	\N	\N	22356	22356	22357
7150	5995	110	applied	\N	\N	\N	\N	22358	22358	22359
7150	6000	111	applied	\N	\N	\N	\N	22368	22368	22369
7150	6004	112	applied	\N	\N	\N	\N	22380	22380	22381
7150	6007	113	applied	\N	\N	\N	\N	22388	22388	22389
7150	6008	114	applied	\N	\N	1000000000	\N	22390	22390	22391
7150	6009	115	applied	\N	\N	\N	\N	22392	22392	22393
7150	6010	116	applied	\N	\N	\N	\N	22395	22395	22396
7150	6011	117	applied	\N	\N	\N	\N	22397	22397	22398
7150	6015	118	applied	\N	\N	\N	\N	22405	22405	22406
7150	6017	119	applied	\N	\N	\N	\N	22412	22412	22413
7150	6019	120	applied	\N	\N	\N	\N	22419	22419	22420
7150	6020	121	applied	\N	\N	\N	\N	22421	22421	22422
7150	6023	122	applied	\N	\N	\N	\N	22429	22429	22430
7150	6025	123	applied	\N	\N	\N	\N	22435	22435	22436
7150	6027	124	applied	\N	\N	\N	\N	22442	22442	22443
7150	6029	125	applied	\N	\N	\N	\N	22448	22448	22449
7152	6044	0	applied	\N	\N	\N	\N	22501	22501	22502
7152	6045	1	applied	\N	\N	\N	\N	22503	22503	22504
7155	6046	0	applied	\N	\N	\N	\N	22509	22509	22510
7157	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7157	6048	1	applied	\N	\N	\N	\N	22519	22519	22520
7157	6049	2	applied	\N	\N	\N	\N	22521	22521	22522
7166	6052	0	applied	\N	\N	\N	\N	22538	22538	22539
7168	6053	0	applied	\N	\N	\N	\N	22543	22543	22544
7170	6054	0	applied	\N	\N	\N	\N	22549	22549	22550
7174	6060	0	applied	\N	\N	\N	\N	22564	22564	22565
7174	6061	1	applied	\N	\N	\N	\N	22566	22566	22567
7177	6065	0	applied	\N	\N	\N	\N	22579	22579	22580
7181	6067	0	applied	\N	\N	\N	\N	22587	22587	22588
7184	6070	0	applied	\N	\N	\N	\N	22599	22599	22600
7189	6074	0	applied	\N	\N	\N	\N	22617	22617	22618
7192	6078	0	applied	\N	\N	\N	\N	22629	22629	22630
7192	6079	2	applied	\N	\N	\N	\N	22632	22632	22633
7195	6080	0	applied	\N	\N	\N	\N	22639	22639	22640
7195	6081	1	applied	\N	\N	\N	\N	22641	22641	22642
7200	6084	0	applied	\N	\N	\N	\N	22652	22652	22653
7202	6085	0	applied	\N	\N	\N	\N	22658	22658	22659
7202	6086	1	applied	\N	\N	\N	\N	22660	22660	22661
7205	6085	0	applied	\N	\N	\N	\N	22658	22658	22659
7205	6086	1	applied	\N	\N	\N	\N	22660	22660	22661
7206	6087	0	applied	\N	\N	\N	\N	22667	22667	22668
7207	6088	0	applied	\N	\N	\N	\N	22669	22669	22670
7207	6089	1	applied	\N	\N	\N	\N	22671	22671	22672
7207	6090	2	applied	\N	\N	\N	\N	22673	22673	22674
7212	6093	0	applied	\N	\N	\N	\N	22686	22686	22687
7214	6095	0	applied	\N	\N	\N	\N	22696	22696	22697
7215	6096	0	applied	\N	\N	\N	\N	22700	22700	22701
7215	6097	1	applied	\N	\N	\N	\N	22702	22702	22703
7215	6098	2	applied	\N	\N	\N	\N	22704	22704	22705
7217	6099	0	applied	\N	\N	\N	\N	22709	22709	22710
7220	6100	0	applied	\N	\N	\N	\N	22715	22715	22716
7224	6101	0	applied	\N	\N	\N	\N	22722	22722	1435
7224	6102	1	applied	\N	\N	\N	\N	22723	22723	22724
7226	6103	0	applied	\N	\N	\N	\N	22730	22730	22731
7231	6106	0	applied	\N	\N	\N	\N	22742	22742	22743
7231	6107	1	applied	\N	\N	\N	\N	22744	22744	22745
7233	6108	0	applied	\N	\N	\N	\N	22750	22750	22751
7236	6109	0	applied	\N	\N	\N	\N	22755	22755	22756
7236	6110	1	applied	\N	\N	\N	\N	22757	22757	22758
7240	6112	0	applied	\N	\N	\N	\N	22771	22771	22772
7243	6113	0	applied	\N	\N	\N	\N	22774	22774	22775
7243	6114	1	applied	\N	\N	\N	\N	22776	22776	22777
7243	6115	2	applied	\N	\N	\N	\N	22778	22778	22779
7246	6118	0	applied	\N	\N	\N	\N	22787	22787	22788
7249	6120	0	applied	\N	\N	\N	\N	22794	22794	22795
7249	6121	1	applied	\N	\N	\N	\N	22796	22796	22797
7254	6124	0	applied	\N	\N	\N	\N	22811	22811	22812
7256	6126	0	applied	\N	\N	\N	\N	22818	22818	22819
7258	6127	0	applied	\N	\N	\N	\N	22823	22823	22824
7261	6129	0	applied	\N	\N	\N	\N	22832	22832	22833
7261	6130	1	applied	\N	\N	\N	\N	22834	22834	22835
7261	6131	2	applied	\N	\N	\N	\N	22836	22836	22837
7270	6133	0	applied	\N	\N	\N	\N	22848	22848	22849
7273	6136	0	applied	\N	\N	\N	\N	22857	22857	22858
7275	6139	0	applied	\N	\N	\N	\N	22868	22868	22869
7284	6142	0	applied	\N	\N	\N	\N	22884	22884	22885
7284	6143	1	applied	\N	\N	\N	\N	22886	22886	22887
7287	6145	0	applied	\N	\N	\N	\N	22895	22895	22896
7287	6146	1	applied	\N	\N	\N	\N	22897	22897	22898
7289	6147	0	applied	\N	\N	\N	\N	22902	22902	22903
7292	6148	0	applied	\N	\N	\N	\N	22908	22908	22909
7295	6149	0	applied	\N	\N	\N	\N	22912	22912	22913
7295	6150	1	applied	\N	\N	\N	\N	22914	22914	22915
7301	6154	0	applied	\N	\N	\N	\N	22930	22930	22931
7151	6042	0	applied	\N	\N	\N	\N	22497	22497	22498
7151	6043	1	applied	\N	\N	\N	\N	22499	22499	22500
7154	6046	0	applied	\N	\N	\N	\N	22509	22509	22510
7160	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7160	6048	1	applied	\N	\N	\N	\N	22519	22519	22520
7160	6049	2	applied	\N	\N	\N	\N	22521	22521	22522
7163	6051	0	applied	\N	\N	\N	\N	22533	22533	22534
7165	6052	0	applied	\N	\N	\N	\N	22538	22538	22539
7173	6060	0	applied	\N	\N	\N	\N	22564	22564	22565
7173	6061	1	applied	\N	\N	\N	\N	22566	22566	22567
7176	6065	0	applied	\N	\N	\N	\N	22579	22579	22580
7183	6069	0	applied	\N	\N	\N	\N	22595	22595	22596
7186	6072	0	applied	\N	\N	\N	\N	22607	22607	22608
7191	6076	0	applied	\N	\N	\N	\N	22624	22624	22625
7191	6077	1	applied	\N	\N	\N	\N	22626	22626	22627
7194	6078	0	applied	\N	\N	\N	\N	22629	22629	22630
7194	6079	2	applied	\N	\N	\N	\N	22632	22632	22633
7197	6082	0	applied	\N	\N	\N	\N	22645	22645	22646
7197	6083	1	applied	\N	\N	\N	\N	22647	22647	22648
7199	6084	0	applied	\N	\N	\N	\N	22652	22652	22653
7204	6085	0	applied	\N	\N	\N	\N	22658	22658	22659
7204	6086	1	applied	\N	\N	\N	\N	22660	22660	22661
7209	6091	0	applied	\N	\N	\N	\N	22676	22676	22677
7211	6093	0	applied	\N	\N	\N	\N	22686	22686	22687
7219	6100	0	applied	\N	\N	\N	\N	22715	22715	22716
7223	6101	0	applied	\N	\N	\N	\N	22722	22722	1435
7223	6102	1	applied	\N	\N	\N	\N	22723	22723	22724
7225	6101	0	applied	\N	\N	\N	\N	22722	22722	1435
7225	6102	1	applied	\N	\N	\N	\N	22723	22723	22724
7228	6105	0	applied	\N	\N	\N	\N	22736	22736	22737
7235	6109	0	applied	\N	\N	\N	\N	22755	22755	22756
7235	6110	1	applied	\N	\N	\N	\N	22757	22757	22758
7238	6111	0	applied	\N	\N	\N	\N	22763	22763	22764
7245	6116	0	applied	\N	\N	\N	\N	22783	22783	22784
7245	6117	1	applied	\N	\N	\N	\N	22785	22785	22786
7248	6120	0	applied	\N	\N	\N	\N	22794	22794	22795
7248	6121	1	applied	\N	\N	\N	\N	22796	22796	22797
7251	6122	0	applied	\N	\N	\N	\N	22802	22802	22803
7253	6124	0	applied	\N	\N	\N	\N	22811	22811	22812
7255	6125	0	applied	\N	\N	\N	\N	22814	22814	22815
7264	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7266	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7272	6136	0	applied	\N	\N	\N	\N	22857	22857	22858
7291	6148	0	applied	\N	\N	\N	\N	22908	22908	22909
7294	6149	0	applied	\N	\N	\N	\N	22912	22912	22913
7294	6150	1	applied	\N	\N	\N	\N	22914	22914	22915
7298	6151	0	applied	\N	\N	\N	\N	22922	22922	22923
7298	6152	1	applied	\N	\N	\N	\N	22924	22924	22925
7298	6153	2	applied	\N	\N	\N	\N	22926	22926	22927
7304	6160	0	applied	\N	\N	\N	\N	22947	22947	22948
7306	6160	0	applied	\N	\N	\N	\N	22947	22947	22948
7306	6161	1	applied	\N	\N	\N	\N	22952	22952	22953
7309	6163	0	applied	\N	\N	\N	\N	22958	22958	22959
7309	6164	1	applied	\N	\N	\N	\N	22960	22960	22961
7309	6165	2	applied	\N	\N	\N	\N	22962	22962	22963
7310	6166	0	failed	Receiver_not_present	\N	\N	\N	22966	22966	\N
7310	6167	1	applied	\N	\N	\N	\N	22967	22967	22968
7310	6168	2	applied	\N	\N	\N	\N	22969	22969	22970
7310	6169	3	applied	\N	\N	\N	\N	22971	22971	22972
7312	6170	0	applied	\N	\N	\N	\N	22976	22976	22977
7315	6172	0	applied	\N	\N	\N	\N	22984	22984	22985
7315	6173	1	applied	\N	\N	\N	\N	22986	22986	22987
7318	6174	0	applied	\N	\N	\N	\N	22989	22989	22990
7318	6175	1	applied	\N	\N	\N	\N	22991	22991	22992
7318	6176	2	applied	\N	\N	\N	\N	22993	22993	22994
7323	6179	0	applied	\N	\N	\N	\N	23006	23006	23007
7330	6182	0	applied	\N	\N	\N	\N	23015	23015	23016
7337	6185	0	applied	\N	\N	\N	\N	23027	23027	23028
7337	6186	1	applied	\N	\N	\N	\N	23029	23029	23030
7337	6187	2	applied	\N	\N	\N	\N	23031	23031	23032
7337	6188	3	applied	\N	\N	\N	\N	23033	23033	23034
7337	6189	4	applied	\N	\N	\N	\N	23035	23035	23036
7339	6193	0	applied	\N	\N	\N	\N	23051	23051	23052
7341	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7341	6101	1	applied	\N	\N	\N	\N	22722	22722	1435
7341	6185	2	applied	\N	\N	\N	\N	23027	23027	23028
7341	6186	3	applied	\N	\N	\N	\N	23029	23029	23030
7341	6187	4	applied	\N	\N	\N	\N	23031	23031	23032
7341	6188	5	applied	\N	\N	\N	\N	23033	23033	23034
7341	6042	6	applied	\N	\N	\N	\N	22497	22497	22498
7341	6043	7	applied	\N	\N	\N	\N	22499	22499	22500
7341	6044	8	applied	\N	\N	\N	\N	22501	22501	22502
7341	6045	9	applied	\N	\N	\N	\N	22503	22503	22504
7341	6046	10	applied	\N	\N	\N	\N	22509	22509	22510
7341	6166	11	failed	Receiver_not_present	\N	\N	\N	22966	22966	\N
7341	6059	12	applied	\N	\N	\N	\N	22562	22562	1435
7341	6048	13	applied	\N	\N	\N	\N	22519	22519	22520
7341	6049	14	applied	\N	\N	\N	\N	22521	22521	22522
7341	6050	15	applied	\N	\N	\N	\N	22530	22530	22531
7341	6051	16	applied	\N	\N	\N	\N	22533	22533	22534
7341	6052	17	applied	\N	\N	\N	\N	22538	22538	22539
7341	6053	18	applied	\N	\N	\N	\N	22543	22543	22544
7341	6054	19	applied	\N	\N	\N	\N	22549	22549	22550
7341	6055	20	applied	\N	\N	\N	\N	22554	22554	22555
7341	6056	21	applied	\N	\N	\N	\N	22556	22556	22557
7341	6057	22	applied	\N	\N	\N	\N	22558	22558	22559
7341	6058	23	applied	\N	\N	\N	\N	22560	22560	22561
7341	6060	24	applied	\N	\N	\N	\N	22564	22564	22565
7341	6061	25	applied	\N	\N	\N	\N	22566	22566	22567
7341	6062	26	applied	\N	\N	\N	\N	22571	22571	22572
7341	6063	27	applied	\N	\N	\N	\N	22573	22573	22574
7341	6064	28	applied	\N	\N	\N	\N	22575	22575	22576
7341	6065	29	applied	\N	\N	\N	\N	22579	22579	22580
7341	6066	30	applied	\N	\N	\N	\N	22583	22583	22584
7341	6067	31	applied	\N	\N	\N	\N	22587	22587	22588
7341	6068	32	applied	\N	\N	\N	\N	22591	22591	22592
7341	6069	33	applied	\N	\N	\N	\N	22595	22595	22596
7341	6070	34	applied	\N	\N	\N	\N	22599	22599	22600
7341	6071	35	applied	\N	\N	\N	\N	22603	22603	22604
7341	6072	36	applied	\N	\N	\N	\N	22607	22607	22608
7341	6073	37	applied	\N	\N	\N	\N	22611	22611	22612
7341	6074	38	applied	\N	\N	\N	\N	22617	22617	22618
7341	6075	39	applied	\N	\N	\N	\N	22620	22620	22621
7341	6076	40	applied	\N	\N	\N	\N	22624	22624	22625
7341	6077	41	applied	\N	\N	\N	\N	22626	22626	22627
7341	6078	42	applied	\N	\N	\N	\N	22629	22629	22630
7341	6079	43	applied	\N	\N	\N	\N	22632	22632	22633
7341	6080	44	applied	\N	\N	\N	\N	22639	22639	22640
7341	6081	45	applied	\N	\N	\N	\N	22641	22641	22642
7153	6044	0	applied	\N	\N	\N	\N	22501	22501	22502
7153	6045	1	applied	\N	\N	\N	\N	22503	22503	22504
7156	6046	0	applied	\N	\N	\N	\N	22509	22509	22510
7158	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7158	6048	1	applied	\N	\N	\N	\N	22519	22519	22520
7158	6049	2	applied	\N	\N	\N	\N	22521	22521	22522
7164	6051	0	applied	\N	\N	\N	\N	22533	22533	22534
7167	6052	0	applied	\N	\N	\N	\N	22538	22538	22539
7169	6053	0	applied	\N	\N	\N	\N	22543	22543	22544
7171	6054	0	applied	\N	\N	\N	\N	22549	22549	22550
7175	6062	0	applied	\N	\N	\N	\N	22571	22571	22572
7175	6063	1	applied	\N	\N	\N	\N	22573	22573	22574
7175	6064	2	applied	\N	\N	\N	\N	22575	22575	22576
7178	6065	0	applied	\N	\N	\N	\N	22579	22579	22580
7182	6068	0	applied	\N	\N	\N	\N	22591	22591	22592
7187	6073	0	applied	\N	\N	\N	\N	22611	22611	22612
7201	6084	0	applied	\N	\N	\N	\N	22652	22652	22653
7203	6085	0	applied	\N	\N	\N	\N	22658	22658	22659
7203	6086	1	applied	\N	\N	\N	\N	22660	22660	22661
7210	6092	0	applied	\N	\N	\N	\N	22682	22682	22683
7216	6096	0	applied	\N	\N	\N	\N	22700	22700	22701
7216	6097	1	applied	\N	\N	\N	\N	22702	22702	22703
7216	6098	2	applied	\N	\N	\N	\N	22704	22704	22705
7218	6099	0	applied	\N	\N	\N	\N	22709	22709	22710
7221	6100	0	applied	\N	\N	\N	\N	22715	22715	22716
7229	6105	0	applied	\N	\N	\N	\N	22736	22736	22737
7232	6106	0	applied	\N	\N	\N	\N	22742	22742	22743
7232	6107	1	applied	\N	\N	\N	\N	22744	22744	22745
7241	6112	0	applied	\N	\N	\N	\N	22771	22771	22772
7257	6126	0	applied	\N	\N	\N	\N	22818	22818	22819
7259	6128	0	applied	\N	\N	\N	\N	22825	22825	22826
7262	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7265	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7267	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7268	6133	0	applied	\N	\N	\N	\N	22848	22848	22849
7276	6139	0	applied	\N	\N	\N	\N	22868	22868	22869
7280	6139	0	applied	\N	\N	\N	\N	22868	22868	22869
7280	6140	1	applied	\N	\N	\N	\N	22875	22875	22876
7282	6141	0	applied	\N	\N	\N	\N	22880	22880	22881
7285	6144	0	applied	\N	\N	\N	\N	22889	22889	22890
7288	6145	0	applied	\N	\N	\N	\N	22895	22895	22896
7288	6146	1	applied	\N	\N	\N	\N	22897	22897	22898
7290	6147	0	applied	\N	\N	\N	\N	22902	22902	22903
7300	6151	0	applied	\N	\N	\N	\N	22922	22922	22923
7300	6152	1	applied	\N	\N	\N	\N	22924	22924	22925
7300	6153	2	applied	\N	\N	\N	\N	22926	22926	22927
7303	6155	0	applied	\N	\N	\N	\N	22933	22933	22934
7303	6156	1	applied	\N	\N	\N	\N	22935	22935	22936
7303	6157	2	applied	\N	\N	\N	\N	22937	22937	22938
7303	6158	3	applied	\N	\N	\N	\N	22939	22939	22940
7303	6159	4	applied	\N	\N	\N	\N	22941	22941	22942
7319	6177	0	applied	\N	\N	\N	\N	22998	22998	22999
7321	6178	0	applied	\N	\N	\N	\N	23002	23002	23003
7326	6181	0	applied	\N	\N	\N	\N	23013	23013	23014
7328	6182	0	applied	\N	\N	\N	\N	23015	23015	23016
7333	6183	0	applied	\N	\N	\N	\N	23021	23021	23022
7335	6185	0	applied	\N	\N	\N	\N	23027	23027	23028
7335	6186	1	applied	\N	\N	\N	\N	23029	23029	23030
7335	6187	2	applied	\N	\N	\N	\N	23031	23031	23032
7335	6188	3	applied	\N	\N	\N	\N	23033	23033	23034
7335	6189	4	applied	\N	\N	\N	\N	23035	23035	23036
7343	6197	0	applied	\N	\N	\N	\N	23068	23068	23069
7352	6224	0	applied	\N	\N	\N	\N	23138	23138	23139
7352	6225	1	applied	\N	\N	\N	\N	23140	23140	23141
7352	6226	2	applied	\N	\N	\N	\N	23142	23142	23143
7352	6227	3	applied	\N	\N	\N	\N	23144	23144	23145
7352	6228	4	applied	\N	\N	\N	\N	23146	23146	23147
7352	6229	5	applied	\N	\N	\N	\N	23148	23148	23149
7352	6230	6	applied	\N	\N	\N	\N	23150	23150	23151
7352	6231	7	applied	\N	\N	\N	\N	23152	23152	23153
7357	6241	0	applied	\N	\N	\N	\N	23208	23208	23209
7357	6242	1	applied	\N	\N	\N	\N	23210	23210	23211
7357	6243	2	applied	\N	\N	\N	\N	23212	23212	23213
7357	6244	3	applied	\N	\N	\N	\N	23214	23214	23215
7357	6245	4	applied	\N	\N	\N	\N	23216	23216	23217
7357	6246	5	applied	\N	\N	\N	\N	23218	23218	23219
7357	6247	6	applied	\N	\N	\N	\N	23220	23220	23221
7357	6248	7	applied	\N	\N	\N	\N	23222	23222	23223
7357	6249	8	applied	\N	\N	\N	\N	23224	23224	23225
7357	6250	9	applied	\N	\N	\N	\N	23226	23226	23227
7357	6251	10	applied	\N	\N	\N	\N	23228	23228	23229
7357	6252	11	applied	\N	\N	\N	\N	23230	23230	23231
7357	6253	12	applied	\N	\N	\N	\N	23232	23232	23233
7357	6254	13	applied	\N	\N	\N	\N	23234	23234	23235
7357	6255	14	applied	\N	\N	\N	\N	23236	23236	23237
7357	6256	15	applied	\N	\N	\N	\N	23238	23238	23239
7357	6257	16	applied	\N	\N	\N	\N	23240	23240	23241
7357	6258	17	applied	\N	\N	\N	\N	23242	23242	23243
7359	6259	0	applied	\N	\N	\N	\N	23248	23248	23249
7359	6260	1	applied	\N	\N	\N	\N	23250	23250	23251
7359	6261	2	applied	\N	\N	\N	\N	23252	23252	23253
7359	6262	3	applied	\N	\N	\N	\N	23254	23254	23255
7359	6263	4	applied	\N	\N	\N	\N	23256	23256	23257
7359	6264	5	applied	\N	\N	\N	\N	23258	23258	23259
7359	6265	6	applied	\N	\N	\N	\N	23260	23260	23261
7359	6266	7	applied	\N	\N	\N	\N	23262	23262	23263
7359	6267	8	applied	\N	\N	\N	\N	23264	23264	23265
7368	6276	0	applied	\N	\N	\N	\N	23293	23293	23294
7368	6277	1	applied	\N	\N	\N	\N	23295	23295	23296
7368	6278	2	applied	\N	\N	\N	\N	23297	23297	23298
7368	6279	3	applied	\N	\N	\N	\N	23299	23299	23300
7368	6280	4	applied	\N	\N	\N	\N	23301	23301	23302
7368	6281	5	applied	\N	\N	\N	\N	23303	23303	23304
7368	6282	6	applied	\N	\N	\N	\N	23305	23305	23306
7370	6283	0	applied	\N	\N	\N	\N	23312	23312	23313
7370	6284	1	applied	\N	\N	\N	\N	23314	23314	23315
7370	6285	2	applied	\N	\N	\N	\N	23316	23316	23317
7370	6286	3	applied	\N	\N	\N	\N	23318	23318	23319
7370	6287	4	applied	\N	\N	\N	\N	23320	23320	23321
7370	6288	5	applied	\N	\N	\N	\N	23322	23322	23323
7370	6289	6	applied	\N	\N	\N	\N	23324	23324	23325
7373	6290	0	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7373	6291	1	applied	\N	\N	\N	\N	23332	23332	23333
7373	6292	2	applied	\N	\N	1000000000	\N	23334	23334	23335
7373	6293	3	applied	\N	\N	\N	\N	23336	23336	23337
7373	6294	4	applied	\N	\N	\N	\N	23338	23338	23339
7373	6295	5	applied	\N	\N	\N	\N	23340	23340	23341
7373	6296	6	applied	\N	\N	\N	\N	23342	23342	23343
7373	6297	7	applied	\N	\N	\N	\N	23344	23344	23345
7159	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7159	6048	1	applied	\N	\N	\N	\N	22519	22519	22520
7159	6049	2	applied	\N	\N	\N	\N	22521	22521	22522
7161	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7161	6048	1	applied	\N	\N	\N	\N	22519	22519	22520
7161	6049	2	applied	\N	\N	\N	\N	22521	22521	22522
7162	6050	0	applied	\N	\N	\N	\N	22530	22530	22531
7172	6055	0	applied	\N	\N	\N	\N	22554	22554	22555
7172	6056	1	applied	\N	\N	\N	\N	22556	22556	22557
7172	6057	2	applied	\N	\N	\N	\N	22558	22558	22559
7172	6058	3	applied	\N	\N	\N	\N	22560	22560	22561
7172	6059	4	applied	\N	\N	\N	\N	22562	22562	1435
7179	6065	0	applied	\N	\N	\N	\N	22579	22579	22580
7180	6066	0	applied	\N	\N	\N	\N	22583	22583	22584
7185	6071	0	applied	\N	\N	\N	\N	22603	22603	22604
7188	6073	0	applied	\N	\N	\N	\N	22611	22611	22612
7190	6075	0	applied	\N	\N	\N	\N	22620	22620	22621
7193	6078	0	applied	\N	\N	\N	\N	22629	22629	22630
7193	6079	2	applied	\N	\N	\N	\N	22632	22632	22633
7196	6082	0	applied	\N	\N	\N	\N	22645	22645	22646
7196	6083	1	applied	\N	\N	\N	\N	22647	22647	22648
7198	6080	0	applied	\N	\N	\N	\N	22639	22639	22640
7198	6081	1	applied	\N	\N	\N	\N	22641	22641	22642
7198	6082	2	applied	\N	\N	\N	\N	22645	22645	22646
7198	6083	3	applied	\N	\N	\N	\N	22647	22647	22648
7208	6091	0	applied	\N	\N	\N	\N	22676	22676	22677
7213	6094	0	applied	\N	\N	\N	\N	22692	22692	22693
7222	6100	0	applied	\N	\N	\N	\N	22715	22715	22716
7227	6104	0	applied	\N	\N	\N	\N	22732	22732	22733
7230	5807	0	applied	\N	\N	\N	\N	21835	21835	21836
7230	5911	1	applied	\N	\N	\N	\N	22157	22157	22134
7230	5809	2	applied	\N	\N	\N	\N	21842	21842	21843
7230	5811	3	applied	\N	\N	\N	\N	21848	21848	21849
7230	5812	4	applied	\N	\N	\N	\N	21850	21850	21851
7230	5816	5	applied	\N	\N	\N	\N	21861	21861	21862
7230	5817	6	applied	\N	\N	\N	\N	21863	21863	21864
7230	5821	7	applied	\N	\N	\N	\N	21876	21876	21877
7230	5822	8	applied	\N	\N	\N	\N	21878	21878	21879
7230	5808	9	applied	\N	\N	\N	\N	21837	21837	21838
7230	5810	10	applied	\N	\N	\N	\N	21844	21844	21845
7230	5813	11	applied	\N	\N	\N	\N	21852	21852	21853
7230	5814	12	applied	\N	\N	\N	\N	21854	21854	21855
7230	5815	13	applied	\N	\N	\N	\N	21859	21859	21860
7230	5825	14	applied	\N	\N	\N	\N	21884	21884	21885
7230	5826	15	applied	\N	\N	\N	\N	21886	21886	21887
7230	5827	16	applied	\N	\N	\N	\N	21888	21888	21889
7230	5829	17	applied	\N	\N	\N	\N	21894	21894	21895
7230	5832	18	applied	\N	\N	\N	\N	21900	21900	21901
7230	5818	19	applied	\N	\N	\N	\N	21865	21865	21866
7230	5819	20	applied	\N	\N	\N	\N	21872	21872	21873
7230	5820	21	applied	\N	\N	\N	\N	21874	21874	21875
7230	5823	22	applied	\N	\N	\N	\N	21880	21880	21881
7230	5824	23	applied	\N	\N	\N	\N	21882	21882	21883
7230	5828	24	applied	\N	\N	\N	\N	21890	21890	21891
7230	5830	25	applied	\N	\N	\N	\N	21896	21896	21897
7230	5831	26	applied	\N	\N	\N	\N	21898	21898	21899
7230	5833	27	applied	\N	\N	\N	\N	21907	21907	21908
7230	5837	28	applied	\N	\N	\N	\N	21919	21919	21920
7230	5838	29	applied	\N	\N	\N	\N	21921	21921	21922
7230	5840	30	applied	\N	\N	\N	\N	21928	21928	21929
7230	5841	31	applied	\N	\N	\N	\N	21930	21930	21931
7230	5842	32	applied	\N	\N	\N	\N	21932	21932	21933
7230	5845	33	applied	\N	\N	\N	\N	21938	21938	21939
7230	5834	34	applied	\N	\N	\N	\N	21909	21909	21910
7230	5835	35	applied	\N	\N	\N	\N	21915	21915	21916
7230	5836	36	applied	\N	\N	\N	\N	21917	21917	21918
7230	5839	37	applied	\N	\N	\N	\N	21926	21926	21927
7230	5843	38	applied	\N	\N	\N	\N	21934	21934	21935
7230	5844	39	applied	\N	\N	\N	\N	21936	21936	21937
7230	5846	40	applied	\N	\N	\N	\N	21940	21940	21941
7230	5847	41	applied	\N	\N	\N	\N	21942	21942	21943
7230	5849	42	applied	\N	\N	\N	\N	21947	21947	21948
7230	5852	43	applied	\N	\N	\N	\N	21953	21953	21954
7230	5853	44	applied	\N	\N	\N	\N	21957	21957	21958
7230	5856	45	applied	\N	\N	\N	\N	21965	21965	21966
7230	5857	46	applied	\N	\N	\N	\N	21969	21969	21970
7230	5859	47	applied	\N	\N	\N	\N	21977	21977	21978
7230	5862	48	applied	\N	\N	\N	\N	21984	21984	21985
7230	5863	49	applied	\N	\N	\N	\N	21986	21986	21987
7230	5868	50	applied	\N	\N	\N	\N	21999	21999	22000
7230	5869	51	applied	\N	\N	\N	\N	22001	22001	22002
7230	5871	52	applied	\N	\N	\N	\N	22009	22009	22010
7230	5872	53	applied	\N	\N	\N	\N	22011	22011	22012
7230	5873	54	applied	\N	\N	\N	\N	22013	22013	22014
7230	5876	55	applied	\N	\N	\N	\N	22024	22024	22025
7230	5878	56	applied	\N	\N	\N	\N	22029	22029	22030
7230	5880	57	applied	\N	\N	\N	\N	22034	22034	22035
7230	5882	58	applied	\N	\N	\N	\N	22044	22044	22045
7230	5883	59	applied	\N	\N	\N	\N	22046	22046	22047
7230	5886	60	applied	\N	\N	\N	\N	22055	22055	22056
7230	5888	61	applied	\N	\N	\N	\N	22059	22059	22060
7230	5891	62	applied	\N	\N	\N	\N	22067	22067	22068
7230	5892	63	applied	\N	\N	\N	\N	22072	22072	22073
7230	5893	64	applied	\N	\N	\N	\N	22074	22074	22075
7230	5897	65	applied	\N	\N	\N	\N	22085	22085	22086
7230	5900	66	applied	\N	\N	\N	\N	22093	22093	22094
7230	5901	67	applied	\N	\N	\N	\N	22095	22095	22096
7230	5848	68	applied	\N	\N	\N	\N	21944	21944	21945
7230	5850	69	applied	\N	\N	\N	\N	21949	21949	21950
7230	5851	70	applied	\N	\N	\N	\N	21951	21951	21952
7230	5854	71	applied	\N	\N	\N	\N	21959	21959	21960
7230	5855	72	applied	\N	\N	\N	\N	21963	21963	21964
7230	5858	73	applied	\N	\N	\N	\N	21971	21971	21972
7230	5860	74	applied	\N	\N	\N	\N	21979	21979	21980
7230	5861	75	applied	\N	\N	1000000000	\N	21982	21982	21983
7230	5864	76	applied	\N	\N	\N	\N	21989	21989	21990
7230	5865	77	applied	\N	\N	\N	\N	21991	21991	21992
7230	5866	78	applied	\N	\N	\N	\N	21995	21995	21996
7230	5867	79	applied	\N	\N	\N	\N	21997	21997	21998
7230	5870	80	applied	\N	\N	\N	\N	22007	22007	22008
7230	5874	81	applied	\N	\N	\N	\N	22015	22015	22016
7230	5875	82	applied	\N	\N	\N	\N	22017	22017	22018
7230	5877	83	applied	\N	\N	\N	\N	22026	22026	22027
7230	5879	84	applied	\N	\N	\N	\N	22031	22031	22032
7230	5881	85	applied	\N	\N	\N	\N	22036	22036	22037
7230	5884	86	applied	\N	\N	\N	\N	22048	22048	22049
7230	5885	87	applied	\N	\N	\N	\N	22050	22050	22051
7230	5887	88	applied	\N	\N	\N	\N	22057	22057	22058
7230	5889	89	applied	\N	\N	\N	\N	22061	22061	22062
7230	5890	90	applied	\N	\N	\N	\N	22065	22065	22066
7230	5894	91	applied	\N	\N	\N	\N	22076	22076	22077
7230	5895	92	applied	\N	\N	\N	\N	22078	22078	22079
7230	5896	94	applied	\N	\N	\N	\N	22083	22083	22084
7230	5898	95	applied	\N	\N	\N	\N	22089	22089	22090
7230	5899	96	applied	\N	\N	\N	\N	22091	22091	22092
7230	5902	97	applied	\N	\N	\N	\N	22099	22099	22100
7230	5903	98	applied	\N	\N	1000000000	\N	22101	22101	22102
7230	5905	99	applied	\N	\N	1000000000	\N	22114	22114	22115
7230	5906	100	applied	\N	\N	\N	\N	22116	22116	22117
7230	5909	101	applied	\N	\N	\N	\N	22126	22126	22127
7230	5912	102	applied	\N	\N	\N	\N	22135	22135	22136
7230	5913	103	applied	\N	\N	\N	\N	22137	22137	22138
7230	5914	104	applied	\N	\N	\N	\N	22139	22139	22140
7230	5915	105	applied	\N	\N	\N	\N	22141	22141	22142
7230	5916	106	applied	\N	\N	\N	\N	22143	22143	22144
7230	5904	107	applied	\N	\N	\N	\N	22103	22103	22104
7230	5907	108	applied	\N	\N	\N	\N	22118	22118	22119
7230	5908	109	applied	\N	\N	\N	\N	22122	22122	22123
7230	5910	110	applied	\N	\N	\N	\N	22128	22128	22129
7230	5917	111	applied	\N	\N	\N	\N	22145	22145	22146
7230	5918	112	applied	\N	\N	\N	\N	22147	22147	22148
7230	5919	113	applied	\N	\N	\N	\N	22149	22149	22150
7230	5920	114	applied	\N	\N	\N	\N	22151	22151	22152
7230	5921	115	applied	\N	\N	\N	\N	22153	22153	22154
7234	6108	0	applied	\N	\N	\N	\N	22750	22750	22751
7237	6111	0	applied	\N	\N	\N	\N	22763	22763	22764
7239	6111	0	applied	\N	\N	\N	\N	22763	22763	22764
7244	6113	0	applied	\N	\N	\N	\N	22774	22774	22775
7244	6114	1	applied	\N	\N	\N	\N	22776	22776	22777
7244	6115	2	applied	\N	\N	\N	\N	22778	22778	22779
7247	6119	0	applied	\N	\N	\N	\N	22790	22790	22791
7250	6122	0	applied	\N	\N	\N	\N	22802	22802	22803
7252	6123	0	applied	\N	\N	\N	\N	22808	22808	22809
7260	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7260	6101	1	applied	\N	\N	\N	\N	22722	22722	1435
7260	5992	2	applied	\N	\N	\N	\N	22352	22352	22353
7260	5993	3	applied	\N	\N	\N	\N	22354	22354	22355
7260	5994	4	applied	\N	\N	\N	\N	22356	22356	22357
7260	5995	5	applied	\N	\N	\N	\N	22358	22358	22359
7260	5996	6	applied	\N	\N	\N	\N	22360	22360	22361
7260	5997	7	applied	\N	\N	\N	\N	22362	22362	22363
7260	5998	8	applied	\N	\N	\N	\N	22364	22364	22365
7260	5999	9	applied	\N	\N	\N	\N	22366	22366	22367
7260	6000	10	applied	\N	\N	\N	\N	22368	22368	22369
7260	6004	11	applied	\N	\N	\N	\N	22380	22380	22381
7260	6001	12	applied	\N	\N	\N	\N	22370	22370	22371
7260	6003	13	applied	\N	\N	\N	\N	22378	22378	22379
7260	6005	14	applied	\N	\N	\N	\N	22384	22384	22385
7260	6006	15	applied	\N	\N	\N	\N	22386	22386	22387
7260	6012	16	applied	\N	\N	\N	\N	22399	22399	22400
7260	6013	17	applied	\N	\N	\N	\N	22401	22401	22402
7260	6014	18	applied	\N	\N	\N	\N	22403	22403	22404
7260	6016	19	applied	\N	\N	\N	\N	22410	22410	22411
7260	6018	20	applied	\N	\N	\N	\N	22417	22417	22418
7260	6021	21	applied	\N	\N	\N	\N	22423	22423	22424
7260	6022	22	applied	\N	\N	\N	\N	22427	22427	22428
7260	6024	23	applied	\N	\N	\N	\N	22433	22433	22434
7260	6026	24	applied	\N	\N	\N	\N	22440	22440	22441
7260	6028	25	applied	\N	\N	\N	\N	22446	22446	22447
7260	6007	26	applied	\N	\N	\N	\N	22388	22388	22389
7260	6008	27	applied	\N	\N	1000000000	\N	22390	22390	22391
7260	6009	28	applied	\N	\N	\N	\N	22392	22392	22393
7260	6010	29	applied	\N	\N	\N	\N	22395	22395	22396
7260	6011	30	applied	\N	\N	\N	\N	22397	22397	22398
7260	6015	31	applied	\N	\N	\N	\N	22405	22405	22406
7260	6017	32	applied	\N	\N	\N	\N	22412	22412	22413
7260	6019	33	applied	\N	\N	\N	\N	22419	22419	22420
7260	6020	34	applied	\N	\N	\N	\N	22421	22421	22422
7260	6023	35	applied	\N	\N	\N	\N	22429	22429	22430
7260	6025	36	applied	\N	\N	\N	\N	22435	22435	22436
7260	6027	37	applied	\N	\N	\N	\N	22442	22442	22443
7260	6029	38	applied	\N	\N	\N	\N	22448	22448	22449
7260	6030	39	applied	\N	\N	\N	\N	22450	22450	22451
7260	6031	40	applied	\N	\N	\N	\N	22457	22457	22458
7260	6032	41	applied	\N	\N	\N	\N	22459	22459	22460
7260	6033	42	applied	\N	\N	\N	\N	22464	22464	22465
7260	6034	44	applied	\N	\N	\N	\N	22468	22468	22469
7260	6036	45	applied	\N	\N	\N	\N	22474	22474	22475
7260	6002	46	applied	\N	\N	\N	\N	22372	22372	22373
7260	6037	47	applied	\N	\N	\N	\N	22476	22476	22477
7260	6038	48	applied	\N	\N	\N	\N	22479	22479	22480
7260	6039	49	applied	\N	\N	\N	\N	22481	22481	22482
7260	6040	50	applied	\N	\N	1000000000	\N	22486	22486	22487
7260	6041	51	applied	\N	\N	\N	\N	22488	22488	22489
7260	6042	52	applied	\N	\N	\N	\N	22497	22497	22498
7260	6043	53	applied	\N	\N	\N	\N	22499	22499	22500
7260	6044	54	applied	\N	\N	\N	\N	22501	22501	22502
7260	6045	55	applied	\N	\N	\N	\N	22503	22503	22504
7260	6046	56	applied	\N	\N	\N	\N	22509	22509	22510
7260	6048	57	applied	\N	\N	\N	\N	22519	22519	22520
7260	6049	58	applied	\N	\N	\N	\N	22521	22521	22522
7260	6050	59	applied	\N	\N	\N	\N	22530	22530	22531
7260	6051	60	applied	\N	\N	\N	\N	22533	22533	22534
7260	6052	61	applied	\N	\N	\N	\N	22538	22538	22539
7260	6053	62	applied	\N	\N	\N	\N	22543	22543	22544
7260	6054	63	applied	\N	\N	\N	\N	22549	22549	22550
7260	6055	64	applied	\N	\N	\N	\N	22554	22554	22555
7260	6056	65	applied	\N	\N	\N	\N	22556	22556	22557
7260	6057	66	applied	\N	\N	\N	\N	22558	22558	22559
7260	6058	67	applied	\N	\N	\N	\N	22560	22560	22561
7260	6060	68	applied	\N	\N	\N	\N	22564	22564	22565
7260	6061	69	applied	\N	\N	\N	\N	22566	22566	22567
7260	6062	70	applied	\N	\N	\N	\N	22571	22571	22572
7260	6063	71	applied	\N	\N	\N	\N	22573	22573	22574
7260	6064	72	applied	\N	\N	\N	\N	22575	22575	22576
7260	6065	73	applied	\N	\N	\N	\N	22579	22579	22580
7260	6066	74	applied	\N	\N	\N	\N	22583	22583	22584
7260	6067	75	applied	\N	\N	\N	\N	22587	22587	22588
7260	6068	76	applied	\N	\N	\N	\N	22591	22591	22592
7260	6069	77	applied	\N	\N	\N	\N	22595	22595	22596
7260	6070	78	applied	\N	\N	\N	\N	22599	22599	22600
7260	6071	79	applied	\N	\N	\N	\N	22603	22603	22604
7260	6072	80	applied	\N	\N	\N	\N	22607	22607	22608
7260	6073	81	applied	\N	\N	\N	\N	22611	22611	22612
7260	6074	82	applied	\N	\N	\N	\N	22617	22617	22618
7260	6075	83	applied	\N	\N	\N	\N	22620	22620	22621
7260	6076	84	applied	\N	\N	\N	\N	22624	22624	22625
7260	6077	85	applied	\N	\N	\N	\N	22626	22626	22627
7260	6078	86	applied	\N	\N	\N	\N	22629	22629	22630
7260	6079	87	applied	\N	\N	\N	\N	22632	22632	22633
7260	6080	88	applied	\N	\N	\N	\N	22639	22639	22640
7260	6081	89	applied	\N	\N	\N	\N	22641	22641	22642
7260	6082	90	applied	\N	\N	\N	\N	22645	22645	22646
7260	6083	91	applied	\N	\N	\N	\N	22647	22647	22648
7260	6084	92	applied	\N	\N	\N	\N	22652	22652	22653
7260	6085	93	applied	\N	\N	\N	\N	22658	22658	22659
7260	6086	94	applied	\N	\N	\N	\N	22660	22660	22661
7260	6087	95	applied	\N	\N	\N	\N	22667	22667	22668
7260	6088	96	applied	\N	\N	\N	\N	22669	22669	22670
7260	6089	97	applied	\N	\N	\N	\N	22671	22671	22672
7260	6090	98	applied	\N	\N	\N	\N	22673	22673	22674
7260	6091	99	applied	\N	\N	\N	\N	22676	22676	22677
7260	6092	100	applied	\N	\N	\N	\N	22682	22682	22683
7260	6093	101	applied	\N	\N	\N	\N	22686	22686	22687
7260	6094	102	applied	\N	\N	\N	\N	22692	22692	22693
7260	6095	103	applied	\N	\N	\N	\N	22696	22696	22697
7260	6096	104	applied	\N	\N	\N	\N	22700	22700	22701
7260	6097	105	applied	\N	\N	\N	\N	22702	22702	22703
7260	6098	106	applied	\N	\N	\N	\N	22704	22704	22705
7260	6099	107	applied	\N	\N	\N	\N	22709	22709	22710
7260	6100	108	applied	\N	\N	\N	\N	22715	22715	22716
7260	6102	109	applied	\N	\N	\N	\N	22723	22723	22724
7260	6103	110	applied	\N	\N	\N	\N	22730	22730	22731
7260	6104	111	applied	\N	\N	\N	\N	22732	22732	22733
7260	6105	112	applied	\N	\N	\N	\N	22736	22736	22737
7260	6106	113	applied	\N	\N	\N	\N	22742	22742	22743
7260	6107	114	applied	\N	\N	\N	\N	22744	22744	22745
7260	6108	115	applied	\N	\N	\N	\N	22750	22750	22751
7260	6109	116	applied	\N	\N	\N	\N	22755	22755	22756
7260	6110	117	applied	\N	\N	\N	\N	22757	22757	22758
7260	6111	118	applied	\N	\N	\N	\N	22763	22763	22764
7260	6112	119	applied	\N	\N	\N	\N	22771	22771	22772
7260	6113	120	applied	\N	\N	\N	\N	22774	22774	22775
7260	6114	121	applied	\N	\N	\N	\N	22776	22776	22777
7260	6115	122	applied	\N	\N	\N	\N	22778	22778	22779
7260	6116	123	applied	\N	\N	\N	\N	22783	22783	22784
7260	6117	124	applied	\N	\N	\N	\N	22785	22785	22786
7260	6118	125	applied	\N	\N	\N	\N	22787	22787	22788
7263	6132	0	applied	\N	\N	\N	\N	22840	22840	22841
7269	6133	0	applied	\N	\N	\N	\N	22848	22848	22849
7271	6134	0	applied	\N	\N	\N	\N	22852	22852	22853
7271	6135	1	applied	\N	\N	\N	\N	22854	22854	22855
7274	6137	0	applied	\N	\N	\N	\N	22863	22863	22864
7274	6138	1	applied	\N	\N	\N	\N	22865	22865	22866
7277	6139	0	applied	\N	\N	\N	\N	22868	22868	22869
7281	6139	0	applied	\N	\N	\N	\N	22868	22868	22869
7281	6140	1	applied	\N	\N	\N	\N	22875	22875	22876
7283	6141	0	applied	\N	\N	\N	\N	22880	22880	22881
7286	6144	0	applied	\N	\N	\N	\N	22889	22889	22890
7293	6149	0	applied	\N	\N	\N	\N	22912	22912	22913
7293	6150	1	applied	\N	\N	\N	\N	22914	22914	22915
7308	6162	0	applied	\N	\N	\N	\N	22955	22955	22956
7314	6171	0	applied	\N	\N	\N	\N	22980	22980	22981
7317	6174	0	applied	\N	\N	\N	\N	22989	22989	22990
7317	6175	1	applied	\N	\N	\N	\N	22991	22991	22992
7317	6176	2	applied	\N	\N	\N	\N	22993	22993	22994
7320	6177	0	applied	\N	\N	\N	\N	22998	22998	22999
7322	6179	0	applied	\N	\N	\N	\N	23006	23006	23007
7327	6181	0	applied	\N	\N	\N	\N	23013	23013	23014
7329	6182	0	applied	\N	\N	\N	\N	23015	23015	23016
7336	6185	0	applied	\N	\N	\N	\N	23027	23027	23028
7336	6186	1	applied	\N	\N	\N	\N	23029	23029	23030
7336	6187	2	applied	\N	\N	\N	\N	23031	23031	23032
7336	6188	3	applied	\N	\N	\N	\N	23033	23033	23034
7336	6189	4	applied	\N	\N	\N	\N	23035	23035	23036
7338	6190	0	applied	\N	\N	\N	\N	23042	23042	23043
7338	6191	2	applied	\N	\N	\N	\N	23045	23045	23046
7338	6192	3	applied	\N	\N	\N	\N	23047	23047	23048
7346	6199	0	applied	\N	\N	\N	\N	23078	23078	23079
7346	6200	1	applied	\N	\N	\N	\N	23080	23080	23081
7346	6201	2	applied	\N	\N	\N	\N	23082	23082	23083
7346	6202	3	applied	\N	\N	\N	\N	23084	23084	23085
7346	6203	4	applied	\N	\N	\N	\N	23086	23086	23087
7346	6204	5	applied	\N	\N	\N	\N	23088	23088	23089
7346	6205	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	23090	23090	\N
7348	6206	0	applied	\N	\N	\N	\N	23095	23095	23096
7348	6207	1	applied	\N	\N	\N	\N	23097	23097	23098
7348	6208	2	applied	\N	\N	\N	\N	23099	23099	23100
7348	6209	3	applied	\N	\N	\N	\N	23101	23101	23102
7348	6210	4	applied	\N	\N	\N	\N	23103	23103	23104
7348	6211	5	applied	\N	\N	\N	\N	23105	23105	23106
7348	6212	6	applied	\N	\N	\N	\N	23107	23107	23108
7348	6213	7	applied	\N	\N	\N	\N	23109	23109	23110
7348	6214	8	applied	\N	\N	\N	\N	23111	23111	23112
7348	6215	9	applied	\N	\N	\N	\N	23113	23113	23114
7351	6216	0	applied	\N	\N	\N	\N	23117	23117	23118
7351	6217	1	applied	\N	\N	\N	\N	23119	23119	23120
7351	6218	2	applied	\N	\N	\N	\N	23121	23121	23122
7351	6219	3	applied	\N	\N	\N	\N	23123	23123	23124
7351	6220	4	applied	\N	\N	\N	\N	23125	23125	23126
7351	6221	5	applied	\N	\N	\N	\N	23127	23127	23128
7351	6222	6	applied	\N	\N	\N	\N	23129	23129	23130
7351	6223	7	applied	\N	\N	\N	\N	23131	23131	23132
7353	6224	0	applied	\N	\N	\N	\N	23138	23138	23139
7353	6225	1	applied	\N	\N	\N	\N	23140	23140	23141
7353	6226	2	applied	\N	\N	\N	\N	23142	23142	23143
7353	6227	3	applied	\N	\N	\N	\N	23144	23144	23145
7353	6228	4	applied	\N	\N	\N	\N	23146	23146	23147
7353	6229	5	applied	\N	\N	\N	\N	23148	23148	23149
7353	6230	6	applied	\N	\N	\N	\N	23150	23150	23151
7353	6231	7	applied	\N	\N	\N	\N	23152	23152	23153
7355	6232	0	applied	\N	\N	\N	\N	23186	23186	23187
7355	6233	1	applied	\N	\N	\N	\N	23188	23188	23189
7355	6234	2	applied	\N	\N	\N	\N	23190	23190	23191
7355	6235	3	applied	\N	\N	\N	\N	23192	23192	23193
7355	6236	4	applied	\N	\N	\N	\N	23194	23194	23195
7355	6237	5	applied	\N	\N	\N	\N	23196	23196	23197
7355	6238	6	applied	\N	\N	\N	\N	23198	23198	23199
7355	6239	7	applied	\N	\N	\N	\N	23200	23200	23201
7355	6240	8	applied	\N	\N	\N	\N	23202	23202	23203
7361	6259	0	applied	\N	\N	\N	\N	23248	23248	23249
7361	6260	1	applied	\N	\N	\N	\N	23250	23250	23251
7361	6261	2	applied	\N	\N	\N	\N	23252	23252	23253
7361	6262	3	applied	\N	\N	\N	\N	23254	23254	23255
7361	6263	4	applied	\N	\N	\N	\N	23256	23256	23257
7361	6264	5	applied	\N	\N	\N	\N	23258	23258	23259
7361	6265	6	applied	\N	\N	\N	\N	23260	23260	23261
7302	6155	0	applied	\N	\N	\N	\N	22933	22933	22934
7302	6156	1	applied	\N	\N	\N	\N	22935	22935	22936
7302	6157	2	applied	\N	\N	\N	\N	22937	22937	22938
7302	6158	3	applied	\N	\N	\N	\N	22939	22939	22940
7302	6159	4	applied	\N	\N	\N	\N	22941	22941	22942
7307	6160	0	applied	\N	\N	\N	\N	22947	22947	22948
7307	6161	1	applied	\N	\N	\N	\N	22952	22952	22953
7311	6166	0	failed	Receiver_not_present	\N	\N	\N	22966	22966	\N
7311	6167	1	applied	\N	\N	\N	\N	22967	22967	22968
7311	6168	2	applied	\N	\N	\N	\N	22969	22969	22970
7311	6169	3	applied	\N	\N	\N	\N	22971	22971	22972
7313	6170	0	applied	\N	\N	\N	\N	22976	22976	22977
7316	6172	0	applied	\N	\N	\N	\N	22984	22984	22985
7316	6173	1	applied	\N	\N	\N	\N	22986	22986	22987
7324	6179	0	applied	\N	\N	\N	\N	23006	23006	23007
7325	6180	0	applied	\N	\N	\N	\N	23009	23009	23010
7332	6183	0	applied	\N	\N	\N	\N	23021	23021	23022
7334	6184	0	applied	\N	\N	\N	\N	23024	23024	23025
7340	6101	0	applied	\N	\N	\N	\N	22722	22722	1435
7340	6185	1	applied	\N	\N	\N	\N	23027	23027	23028
7340	6186	2	applied	\N	\N	\N	\N	23029	23029	23030
7340	6187	3	applied	\N	\N	\N	\N	23031	23031	23032
7340	6188	4	applied	\N	\N	\N	\N	23033	23033	23034
7340	6166	5	failed	Receiver_not_present	\N	\N	\N	22966	22966	\N
7342	6194	0	applied	\N	\N	\N	\N	23060	23060	23061
7342	6195	1	applied	\N	\N	\N	\N	23062	23062	23063
7342	6196	2	applied	\N	\N	\N	\N	23064	23064	23065
7345	6198	0	applied	\N	\N	\N	\N	23072	23072	23073
7350	6216	0	applied	\N	\N	\N	\N	23117	23117	23118
7350	6217	1	applied	\N	\N	\N	\N	23119	23119	23120
7350	6218	2	applied	\N	\N	\N	\N	23121	23121	23122
7350	6219	3	applied	\N	\N	\N	\N	23123	23123	23124
7350	6220	4	applied	\N	\N	\N	\N	23125	23125	23126
7350	6221	5	applied	\N	\N	\N	\N	23127	23127	23128
7350	6222	6	applied	\N	\N	\N	\N	23129	23129	23130
7350	6223	7	applied	\N	\N	\N	\N	23131	23131	23132
7358	6241	0	applied	\N	\N	\N	\N	23208	23208	23209
7358	6242	1	applied	\N	\N	\N	\N	23210	23210	23211
7358	6243	2	applied	\N	\N	\N	\N	23212	23212	23213
7358	6244	3	applied	\N	\N	\N	\N	23214	23214	23215
7358	6245	4	applied	\N	\N	\N	\N	23216	23216	23217
7358	6246	5	applied	\N	\N	\N	\N	23218	23218	23219
7358	6247	6	applied	\N	\N	\N	\N	23220	23220	23221
7358	6248	7	applied	\N	\N	\N	\N	23222	23222	23223
7358	6249	8	applied	\N	\N	\N	\N	23224	23224	23225
7358	6250	9	applied	\N	\N	\N	\N	23226	23226	23227
7358	6251	10	applied	\N	\N	\N	\N	23228	23228	23229
7358	6252	11	applied	\N	\N	\N	\N	23230	23230	23231
7358	6253	12	applied	\N	\N	\N	\N	23232	23232	23233
7358	6254	13	applied	\N	\N	\N	\N	23234	23234	23235
7358	6255	14	applied	\N	\N	\N	\N	23236	23236	23237
7358	6256	15	applied	\N	\N	\N	\N	23238	23238	23239
7358	6257	16	applied	\N	\N	\N	\N	23240	23240	23241
7358	6258	17	applied	\N	\N	\N	\N	23242	23242	23243
7360	6259	0	applied	\N	\N	\N	\N	23248	23248	23249
7360	6260	1	applied	\N	\N	\N	\N	23250	23250	23251
7360	6261	2	applied	\N	\N	\N	\N	23252	23252	23253
7360	6262	3	applied	\N	\N	\N	\N	23254	23254	23255
7360	6263	4	applied	\N	\N	\N	\N	23256	23256	23257
7360	6264	5	applied	\N	\N	\N	\N	23258	23258	23259
7360	6265	6	applied	\N	\N	\N	\N	23260	23260	23261
7360	6266	7	applied	\N	\N	\N	\N	23262	23262	23263
7360	6267	8	applied	\N	\N	\N	\N	23264	23264	23265
7362	6268	0	applied	\N	\N	\N	\N	23270	23270	23271
7362	6269	1	applied	\N	\N	\N	\N	23272	23272	23273
7362	6270	2	applied	\N	\N	\N	\N	23274	23274	23275
7362	6271	3	applied	\N	\N	\N	\N	23276	23276	23277
7362	6272	4	applied	\N	\N	\N	\N	23278	23278	23279
7362	6273	5	applied	\N	\N	\N	\N	23280	23280	23281
7362	6274	6	applied	\N	\N	\N	\N	23282	23282	23283
7362	6275	7	applied	\N	\N	\N	\N	23284	23284	23285
7365	6268	0	applied	\N	\N	\N	\N	23270	23270	23271
7365	6269	1	applied	\N	\N	\N	\N	23272	23272	23273
7365	6270	2	applied	\N	\N	\N	\N	23274	23274	23275
7365	6271	3	applied	\N	\N	\N	\N	23276	23276	23277
7365	6272	4	applied	\N	\N	\N	\N	23278	23278	23279
7365	6273	5	applied	\N	\N	\N	\N	23280	23280	23281
7365	6274	6	applied	\N	\N	\N	\N	23282	23282	23283
7365	6275	7	applied	\N	\N	\N	\N	23284	23284	23285
7366	6276	0	applied	\N	\N	\N	\N	23293	23293	23294
7366	6277	1	applied	\N	\N	\N	\N	23295	23295	23296
7366	6278	2	applied	\N	\N	\N	\N	23297	23297	23298
7366	6279	3	applied	\N	\N	\N	\N	23299	23299	23300
7366	6280	4	applied	\N	\N	\N	\N	23301	23301	23302
7366	6281	5	applied	\N	\N	\N	\N	23303	23303	23304
7366	6282	6	applied	\N	\N	\N	\N	23305	23305	23306
7371	6283	0	applied	\N	\N	\N	\N	23312	23312	23313
7371	6284	1	applied	\N	\N	\N	\N	23314	23314	23315
7371	6285	2	applied	\N	\N	\N	\N	23316	23316	23317
7371	6286	3	applied	\N	\N	\N	\N	23318	23318	23319
7371	6287	4	applied	\N	\N	\N	\N	23320	23320	23321
7371	6288	5	applied	\N	\N	\N	\N	23322	23322	23323
7378	6320	0	applied	\N	\N	\N	\N	23396	23396	23397
7380	6321	0	applied	\N	\N	\N	\N	23401	23401	23402
7383	6323	0	applied	\N	\N	\N	\N	23409	23409	23410
7385	6324	0	applied	\N	\N	\N	\N	23414	23414	23415
7385	6325	1	applied	\N	\N	\N	\N	23416	23416	23417
7388	6328	0	applied	\N	\N	\N	\N	23425	23425	23426
7391	6332	0	applied	\N	\N	\N	\N	23436	23436	23437
7391	6333	1	applied	\N	\N	\N	\N	23438	23438	23439
7391	6334	2	applied	\N	\N	\N	\N	23440	23440	23441
7391	6335	3	applied	\N	\N	\N	\N	23442	23442	23443
7391	6336	4	applied	\N	\N	\N	\N	23444	23444	23445
7393	6337	0	applied	\N	\N	\N	\N	23449	23449	23450
7396	6340	0	applied	\N	\N	\N	\N	23460	23460	23461
7396	6341	1	applied	\N	\N	\N	\N	23462	23462	23463
7398	6342	0	applied	\N	\N	\N	\N	23467	23467	23468
7402	6353	0	applied	\N	\N	\N	\N	23471	23471	13857
7402	6354	1	applied	\N	\N	\N	\N	23498	23498	23499
7402	6355	2	applied	\N	\N	\N	\N	23500	23500	23501
7405	6356	0	applied	\N	\N	\N	\N	23506	23506	23507
7407	6358	0	applied	\N	\N	\N	\N	23516	23516	23517
7413	6364	0	applied	\N	\N	\N	\N	23533	23533	23534
7413	6365	1	applied	\N	\N	\N	\N	23537	23537	23538
7415	6365	0	applied	\N	\N	\N	\N	23537	23537	23538
7415	6366	2	applied	\N	\N	\N	\N	23541	23541	23542
7421	6369	0	applied	\N	\N	\N	\N	23556	23556	23557
7421	6370	1	applied	\N	\N	\N	\N	23558	23558	23559
7424	6047	0	applied	\N	\N	1000000000	\N	22517	22517	22518
7341	6082	46	applied	\N	\N	\N	\N	22645	22645	22646
7341	6083	47	applied	\N	\N	\N	\N	22647	22647	22648
7341	6084	48	applied	\N	\N	\N	\N	22652	22652	22653
7341	6085	49	applied	\N	\N	\N	\N	22658	22658	22659
7341	6086	50	applied	\N	\N	\N	\N	22660	22660	22661
7341	6087	51	applied	\N	\N	\N	\N	22667	22667	22668
7341	6088	52	applied	\N	\N	\N	\N	22669	22669	22670
7341	6089	53	applied	\N	\N	\N	\N	22671	22671	22672
7341	6090	54	applied	\N	\N	\N	\N	22673	22673	22674
7341	6091	55	applied	\N	\N	\N	\N	22676	22676	22677
7341	6092	56	applied	\N	\N	\N	\N	22682	22682	22683
7341	6093	57	applied	\N	\N	\N	\N	22686	22686	22687
7341	6094	58	applied	\N	\N	\N	\N	22692	22692	22693
7341	6095	59	applied	\N	\N	\N	\N	22696	22696	22697
7341	6096	60	applied	\N	\N	\N	\N	22700	22700	22701
7341	6097	61	applied	\N	\N	\N	\N	22702	22702	22703
7341	6098	62	applied	\N	\N	\N	\N	22704	22704	22705
7341	6099	63	applied	\N	\N	\N	\N	22709	22709	22710
7341	6100	64	applied	\N	\N	\N	\N	22715	22715	22716
7341	6102	65	applied	\N	\N	\N	\N	22723	22723	22724
7341	6103	66	applied	\N	\N	\N	\N	22730	22730	22731
7341	6104	67	applied	\N	\N	\N	\N	22732	22732	22733
7341	6105	68	applied	\N	\N	\N	\N	22736	22736	22737
7341	6106	69	applied	\N	\N	\N	\N	22742	22742	22743
7341	6107	70	applied	\N	\N	\N	\N	22744	22744	22745
7341	6108	71	applied	\N	\N	\N	\N	22750	22750	22751
7341	6109	72	applied	\N	\N	\N	\N	22755	22755	22756
7341	6110	73	applied	\N	\N	\N	\N	22757	22757	22758
7341	6111	74	applied	\N	\N	\N	\N	22763	22763	22764
7341	6112	75	applied	\N	\N	\N	\N	22771	22771	22772
7341	6113	76	applied	\N	\N	\N	\N	22774	22774	22775
7341	6114	77	applied	\N	\N	\N	\N	22776	22776	22777
7341	6115	78	applied	\N	\N	\N	\N	22778	22778	22779
7341	6116	79	applied	\N	\N	\N	\N	22783	22783	22784
7341	6117	80	applied	\N	\N	\N	\N	22785	22785	22786
7341	6118	81	applied	\N	\N	\N	\N	22787	22787	22788
7341	6119	82	applied	\N	\N	\N	\N	22790	22790	22791
7341	6120	83	applied	\N	\N	\N	\N	22794	22794	22795
7341	6121	84	applied	\N	\N	\N	\N	22796	22796	22797
7341	6122	86	applied	\N	\N	\N	\N	22802	22802	22803
7341	6123	87	applied	\N	\N	\N	\N	22808	22808	22809
7341	6124	88	applied	\N	\N	\N	\N	22811	22811	22812
7341	6125	89	applied	\N	\N	\N	\N	22814	22814	22815
7341	6126	90	applied	\N	\N	\N	\N	22818	22818	22819
7341	6127	91	applied	\N	\N	\N	\N	22823	22823	22824
7341	6128	92	applied	\N	\N	\N	\N	22825	22825	22826
7341	6129	93	applied	\N	\N	\N	\N	22832	22832	22833
7341	6130	94	applied	\N	\N	\N	\N	22834	22834	22835
7341	6131	95	applied	\N	\N	\N	\N	22836	22836	22837
7341	6132	96	applied	\N	\N	\N	\N	22840	22840	22841
7341	6133	97	applied	\N	\N	\N	\N	22848	22848	22849
7341	6134	98	applied	\N	\N	\N	\N	22852	22852	22853
7341	6135	99	applied	\N	\N	\N	\N	22854	22854	22855
7341	6136	100	applied	\N	\N	\N	\N	22857	22857	22858
7341	6137	101	applied	\N	\N	\N	\N	22863	22863	22864
7341	6138	102	applied	\N	\N	\N	\N	22865	22865	22866
7341	6139	103	applied	\N	\N	\N	\N	22868	22868	22869
7341	6140	104	applied	\N	\N	\N	\N	22875	22875	22876
7341	6141	105	applied	\N	\N	\N	\N	22880	22880	22881
7341	6142	106	applied	\N	\N	\N	\N	22884	22884	22885
7341	6143	107	applied	\N	\N	\N	\N	22886	22886	22887
7341	6144	108	applied	\N	\N	\N	\N	22889	22889	22890
7341	6145	109	applied	\N	\N	\N	\N	22895	22895	22896
7341	6146	110	applied	\N	\N	\N	\N	22897	22897	22898
7341	6147	111	applied	\N	\N	\N	\N	22902	22902	22903
7341	6148	112	applied	\N	\N	\N	\N	22908	22908	22909
7341	6149	113	applied	\N	\N	\N	\N	22912	22912	22913
7341	6150	114	applied	\N	\N	\N	\N	22914	22914	22915
7341	6151	115	applied	\N	\N	\N	\N	22922	22922	22923
7341	6152	116	applied	\N	\N	\N	\N	22924	22924	22925
7341	6153	117	applied	\N	\N	\N	\N	22926	22926	22927
7341	6154	118	applied	\N	\N	\N	\N	22930	22930	22931
7341	6155	119	applied	\N	\N	\N	\N	22933	22933	22934
7341	6156	120	applied	\N	\N	\N	\N	22935	22935	22936
7341	6157	121	applied	\N	\N	\N	\N	22937	22937	22938
7341	6158	122	applied	\N	\N	\N	\N	22939	22939	22940
7341	6159	123	applied	\N	\N	\N	\N	22941	22941	22942
7341	6160	124	applied	\N	\N	\N	\N	22947	22947	22948
7341	6161	125	applied	\N	\N	\N	\N	22952	22952	22953
7344	6198	0	applied	\N	\N	\N	\N	23072	23072	23073
7347	6199	0	applied	\N	\N	\N	\N	23078	23078	23079
7347	6200	1	applied	\N	\N	\N	\N	23080	23080	23081
7347	6201	2	applied	\N	\N	\N	\N	23082	23082	23083
7347	6202	3	applied	\N	\N	\N	\N	23084	23084	23085
7347	6203	4	applied	\N	\N	\N	\N	23086	23086	23087
7347	6204	5	applied	\N	\N	\N	\N	23088	23088	23089
7347	6205	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	23090	23090	\N
7349	6216	0	applied	\N	\N	\N	\N	23117	23117	23118
7349	6217	1	applied	\N	\N	\N	\N	23119	23119	23120
7349	6218	2	applied	\N	\N	\N	\N	23121	23121	23122
7349	6219	3	applied	\N	\N	\N	\N	23123	23123	23124
7349	6220	4	applied	\N	\N	\N	\N	23125	23125	23126
7349	6221	5	applied	\N	\N	\N	\N	23127	23127	23128
7349	6222	6	applied	\N	\N	\N	\N	23129	23129	23130
7349	6223	7	applied	\N	\N	\N	\N	23131	23131	23132
7354	6199	0	applied	\N	\N	\N	\N	23157	23157	23079
7354	6201	1	applied	\N	\N	\N	\N	23158	23158	23083
7354	6202	2	applied	\N	\N	\N	\N	23159	23159	23085
7354	6203	3	applied	\N	\N	\N	\N	23160	23160	23087
7354	6171	4	applied	\N	\N	\N	\N	22980	22980	22981
7354	6172	5	applied	\N	\N	\N	\N	22984	22984	22985
7354	6173	6	applied	\N	\N	\N	\N	22986	22986	22987
7354	6174	7	applied	\N	\N	\N	\N	22989	22989	22990
7354	6175	8	applied	\N	\N	\N	\N	22991	22991	22992
7354	6176	9	applied	\N	\N	\N	\N	22993	22993	22994
7354	6177	10	applied	\N	\N	\N	\N	22998	22998	22999
7354	6185	11	applied	\N	\N	\N	\N	23027	23027	23028
7354	6186	12	applied	\N	\N	\N	\N	23029	23029	23030
7354	6187	13	applied	\N	\N	\N	\N	23031	23031	23032
7354	6188	14	applied	\N	\N	\N	\N	23033	23033	23034
7354	6178	15	applied	\N	\N	\N	\N	23002	23002	23003
7354	6179	16	applied	\N	\N	\N	\N	23006	23006	23007
7354	6180	17	applied	\N	\N	\N	\N	23009	23009	23010
7354	6181	18	applied	\N	\N	\N	\N	23013	23013	23014
7354	6204	19	applied	\N	\N	\N	\N	23161	23161	23089
7354	6207	20	applied	\N	\N	\N	\N	23162	23162	23098
7354	6208	21	applied	\N	\N	\N	\N	23163	23163	23100
7354	6209	22	applied	\N	\N	\N	\N	23164	23164	23102
7354	6210	23	applied	\N	\N	\N	\N	23165	23165	23104
7354	6211	24	applied	\N	\N	\N	\N	23166	23166	23106
7354	6212	25	applied	\N	\N	\N	\N	23167	23167	23108
7354	6213	26	applied	\N	\N	\N	\N	23168	23168	23110
7354	6214	27	applied	\N	\N	\N	\N	23169	23169	23112
7354	6215	28	applied	\N	\N	\N	\N	23170	23170	23114
7354	6216	29	applied	\N	\N	\N	\N	23171	23171	23118
7354	6217	30	applied	\N	\N	\N	\N	23172	23172	23120
7354	6218	31	applied	\N	\N	\N	\N	23173	23173	23122
7354	6220	32	applied	\N	\N	\N	\N	23174	23174	23126
7354	6221	33	applied	\N	\N	\N	\N	23175	23175	23128
7354	6222	34	applied	\N	\N	\N	\N	23176	23176	23130
7354	6223	35	applied	\N	\N	\N	\N	23177	23177	23132
7354	6224	36	applied	\N	\N	\N	\N	23178	23178	23139
7354	6225	37	applied	\N	\N	\N	\N	23179	23179	23141
7354	6226	38	applied	\N	\N	\N	\N	23180	23180	23143
7354	6227	39	applied	\N	\N	\N	\N	23181	23181	23145
7354	6228	40	applied	\N	\N	\N	\N	23182	23182	23147
7354	6182	41	applied	\N	\N	\N	\N	23015	23015	23016
7354	6183	42	applied	\N	\N	\N	\N	23021	23021	23022
7354	6184	43	applied	\N	\N	\N	\N	23024	23024	23025
7354	6189	45	applied	\N	\N	\N	\N	23035	23035	23036
7354	6190	46	applied	\N	\N	\N	\N	23042	23042	23043
7354	6191	47	applied	\N	\N	\N	\N	23045	23045	23046
7354	6192	48	applied	\N	\N	\N	\N	23047	23047	23048
7354	6193	49	applied	\N	\N	\N	\N	23051	23051	23052
7354	6194	50	applied	\N	\N	\N	\N	23060	23060	23061
7354	6195	51	applied	\N	\N	\N	\N	23062	23062	23063
7354	6196	52	applied	\N	\N	\N	\N	23064	23064	23065
7354	6197	53	applied	\N	\N	\N	\N	23068	23068	23069
7354	6198	54	applied	\N	\N	\N	\N	23072	23072	23073
7354	6200	55	applied	\N	\N	\N	\N	23080	23080	23081
7354	6206	56	applied	\N	\N	\N	\N	23095	23095	23096
7354	6219	57	applied	\N	\N	\N	\N	23123	23123	23124
7354	6205	58	failed	Amount_insufficient_to_create_account	\N	\N	\N	23090	23090	\N
7356	6232	0	applied	\N	\N	\N	\N	23186	23186	23187
7356	6233	1	applied	\N	\N	\N	\N	23188	23188	23189
7356	6234	2	applied	\N	\N	\N	\N	23190	23190	23191
7356	6235	3	applied	\N	\N	\N	\N	23192	23192	23193
7356	6236	4	applied	\N	\N	\N	\N	23194	23194	23195
7356	6237	5	applied	\N	\N	\N	\N	23196	23196	23197
7356	6238	6	applied	\N	\N	\N	\N	23198	23198	23199
7356	6239	7	applied	\N	\N	\N	\N	23200	23200	23201
7356	6240	8	applied	\N	\N	\N	\N	23202	23202	23203
7364	6268	0	applied	\N	\N	\N	\N	23270	23270	23271
7364	6269	1	applied	\N	\N	\N	\N	23272	23272	23273
7364	6270	2	applied	\N	\N	\N	\N	23274	23274	23275
7364	6271	3	applied	\N	\N	\N	\N	23276	23276	23277
7364	6272	4	applied	\N	\N	\N	\N	23278	23278	23279
7364	6273	5	applied	\N	\N	\N	\N	23280	23280	23281
7364	6274	6	applied	\N	\N	\N	\N	23282	23282	23283
7364	6275	7	applied	\N	\N	\N	\N	23284	23284	23285
7372	6290	0	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7372	6291	1	applied	\N	\N	\N	\N	23332	23332	23333
7372	6292	2	applied	\N	\N	1000000000	\N	23334	23334	23335
7372	6289	3	applied	\N	\N	\N	\N	23324	23324	23325
7372	6293	4	applied	\N	\N	\N	\N	23336	23336	23337
7372	6294	5	applied	\N	\N	\N	\N	23338	23338	23339
7372	6295	6	applied	\N	\N	\N	\N	23340	23340	23341
7372	6296	7	applied	\N	\N	\N	\N	23342	23342	23343
7372	6297	8	applied	\N	\N	\N	\N	23344	23344	23345
7372	6298	9	applied	\N	\N	\N	\N	23346	23346	23347
7372	6299	10	applied	\N	\N	\N	\N	23348	23348	23349
7372	6300	11	applied	\N	\N	\N	\N	23350	23350	23351
7372	6301	12	applied	\N	\N	\N	\N	23352	23352	23353
7372	6302	13	applied	\N	\N	\N	\N	23354	23354	23355
7372	6303	14	applied	\N	\N	\N	\N	23356	23356	23357
7372	6304	15	applied	\N	\N	\N	\N	23358	23358	23359
7372	6305	16	applied	\N	\N	\N	\N	23360	23360	23361
7372	6306	17	applied	\N	\N	\N	\N	23362	23362	23363
7372	6307	18	applied	\N	\N	\N	\N	23364	23364	23365
7372	6308	19	applied	\N	\N	\N	\N	23366	23366	23367
7372	6309	20	applied	\N	\N	\N	\N	23368	23368	23369
7372	6310	21	applied	\N	\N	\N	\N	23370	23370	23371
7372	6311	22	applied	\N	\N	\N	\N	23372	23372	23373
7372	6312	23	applied	\N	\N	\N	\N	23374	23374	23375
7372	6313	24	applied	\N	\N	\N	\N	23376	23376	23377
7372	6314	25	applied	\N	\N	\N	\N	23378	23378	23379
7372	6315	26	applied	\N	\N	\N	\N	23380	23380	23381
7372	6316	27	applied	\N	\N	\N	\N	23382	23382	23383
7372	6317	28	applied	\N	\N	\N	\N	23384	23384	23385
7372	6318	29	applied	\N	\N	\N	\N	23386	23386	23387
7375	6319	0	applied	\N	\N	\N	\N	23390	23390	23391
7381	6322	0	applied	\N	\N	\N	\N	23405	23405	23406
7389	6329	0	applied	\N	\N	\N	\N	23429	23429	23430
7389	6330	1	applied	\N	\N	\N	\N	23431	23431	23432
7389	6331	2	applied	\N	\N	\N	\N	23433	23433	23434
7394	6338	0	applied	\N	\N	\N	\N	23455	23455	23456
7394	6339	1	applied	\N	\N	\N	\N	23457	23457	23458
7399	6343	0	applied	\N	\N	\N	\N	23473	23473	23474
7409	6362	0	applied	\N	\N	\N	\N	23527	23527	23528
7409	6363	1	applied	\N	\N	\N	\N	23529	23529	23530
7411	6364	0	applied	\N	\N	\N	\N	23533	23533	23534
7417	6366	0	applied	\N	\N	\N	\N	23541	23541	23542
7425	6373	0	applied	\N	\N	\N	\N	23608	23608	23609
7425	6374	1	applied	\N	\N	\N	\N	23610	23610	23611
7425	6375	2	applied	\N	\N	\N	\N	23612	23612	23613
7428	6376	0	applied	\N	\N	\N	\N	23617	23617	23618
7428	6377	1	applied	\N	\N	\N	\N	23619	23619	23620
7430	6378	0	applied	\N	\N	\N	\N	23623	23623	23624
7432	6379	0	applied	\N	\N	\N	\N	23629	23629	23630
7434	6380	0	applied	\N	\N	\N	\N	23636	23636	23637
7437	6384	0	applied	\N	\N	\N	\N	23648	23648	23649
7442	6388	0	applied	\N	\N	\N	\N	23665	23665	23666
7450	6395	0	applied	\N	\N	\N	\N	23689	23689	23690
7450	6396	1	applied	\N	\N	\N	\N	23691	23691	23692
7453	6399	0	applied	\N	\N	\N	\N	23703	23703	23704
7453	6400	1	applied	\N	\N	\N	\N	23705	23705	23706
7453	6401	2	applied	\N	\N	\N	\N	23707	23707	23708
7461	6405	0	applied	\N	\N	\N	\N	23726	23726	23727
7461	6406	1	applied	\N	\N	\N	\N	23728	23728	23729
7461	6407	2	applied	\N	\N	\N	\N	23730	23730	23731
7465	6410	0	applied	\N	\N	\N	\N	23741	23741	23742
7469	6411	0	applied	\N	\N	\N	\N	23745	23745	23746
7470	6412	0	applied	\N	\N	\N	\N	23755	23755	23756
7470	6413	1	applied	\N	\N	\N	\N	23757	23757	23758
7472	6414	0	applied	\N	\N	\N	\N	23759	23759	23760
7475	6417	0	applied	\N	\N	\N	\N	23772	23772	23773
7475	6418	1	applied	\N	\N	\N	\N	23774	23774	19746
7479	6419	0	applied	\N	\N	\N	\N	23782	23782	23783
7361	6266	7	applied	\N	\N	\N	\N	23262	23262	23263
7361	6267	8	applied	\N	\N	\N	\N	23264	23264	23265
7363	6268	0	applied	\N	\N	\N	\N	23270	23270	23271
7363	6269	1	applied	\N	\N	\N	\N	23272	23272	23273
7363	6270	2	applied	\N	\N	\N	\N	23274	23274	23275
7363	6271	3	applied	\N	\N	\N	\N	23276	23276	23277
7363	6272	4	applied	\N	\N	\N	\N	23278	23278	23279
7363	6273	5	applied	\N	\N	\N	\N	23280	23280	23281
7363	6274	6	applied	\N	\N	\N	\N	23282	23282	23283
7363	6275	7	applied	\N	\N	\N	\N	23284	23284	23285
7367	6276	0	applied	\N	\N	\N	\N	23293	23293	23294
7367	6277	1	applied	\N	\N	\N	\N	23295	23295	23296
7367	6278	2	applied	\N	\N	\N	\N	23297	23297	23298
7367	6279	3	applied	\N	\N	\N	\N	23299	23299	23300
7367	6280	4	applied	\N	\N	\N	\N	23301	23301	23302
7367	6281	5	applied	\N	\N	\N	\N	23303	23303	23304
7367	6282	6	applied	\N	\N	\N	\N	23305	23305	23306
7369	6283	0	applied	\N	\N	\N	\N	23312	23312	23313
7369	6284	1	applied	\N	\N	\N	\N	23314	23314	23315
7369	6285	2	applied	\N	\N	\N	\N	23316	23316	23317
7369	6286	3	applied	\N	\N	\N	\N	23318	23318	23319
7369	6287	4	applied	\N	\N	\N	\N	23320	23320	23321
7369	6288	5	applied	\N	\N	\N	\N	23322	23322	23323
7369	6289	6	applied	\N	\N	\N	\N	23324	23324	23325
7374	6319	0	applied	\N	\N	\N	\N	23390	23390	23391
7379	6320	0	applied	\N	\N	\N	\N	23396	23396	23397
7384	6323	0	applied	\N	\N	\N	\N	23409	23409	23410
7386	6326	0	applied	\N	\N	\N	\N	23419	23419	23420
7386	6327	1	applied	\N	\N	\N	\N	23421	23421	23422
7400	6344	0	applied	\N	\N	\N	\N	23477	23477	23478
7400	6345	1	applied	\N	\N	\N	\N	23479	23479	23480
7400	6346	2	applied	\N	\N	1000000000	\N	23481	23481	23482
7400	6347	3	applied	\N	\N	1000000000	\N	23483	23483	23484
7400	6348	4	applied	\N	\N	\N	\N	23485	23485	23486
7400	6349	5	applied	\N	\N	\N	\N	23487	23487	23488
7400	6350	6	applied	\N	\N	\N	\N	23489	23489	23490
7400	6351	7	applied	\N	\N	\N	\N	23491	23491	23492
7403	6353	0	applied	\N	\N	\N	\N	23471	23471	13857
7403	6354	1	applied	\N	\N	\N	\N	23498	23498	23499
7403	6355	2	applied	\N	\N	\N	\N	23500	23500	23501
7408	6359	0	applied	\N	\N	\N	\N	23520	23520	23521
7408	6360	1	applied	\N	\N	\N	\N	23522	23522	23523
7408	6361	2	applied	\N	\N	1000000000	\N	23524	23524	23525
7416	6365	0	applied	\N	\N	\N	\N	23537	23537	23538
7416	6366	2	applied	\N	\N	\N	\N	23541	23541	23542
7422	6371	0	applied	\N	\N	\N	\N	23562	23562	23563
7427	6376	0	applied	\N	\N	\N	\N	23617	23617	23618
7427	6377	1	applied	\N	\N	\N	\N	23619	23619	23620
7429	6378	0	applied	\N	\N	\N	\N	23623	23623	23624
7440	6385	0	applied	\N	\N	\N	\N	23652	23652	23653
7441	6386	0	applied	\N	\N	\N	\N	23659	23659	23660
7441	6387	1	applied	\N	\N	\N	\N	23661	23661	23662
7444	6389	0	applied	\N	\N	\N	\N	23669	23669	23670
7446	6390	0	applied	\N	\N	\N	\N	23673	23673	23674
7449	6393	0	applied	\N	\N	\N	\N	23683	23683	23684
7449	6394	1	applied	\N	\N	\N	\N	23685	23685	23686
7452	6397	0	applied	\N	\N	\N	\N	23697	23697	23698
7452	6398	1	applied	\N	\N	\N	\N	23699	23699	23700
7455	6402	0	applied	\N	\N	\N	\N	23710	23710	23711
7458	6403	0	applied	\N	\N	\N	\N	23715	23715	23716
7459	6404	0	applied	\N	\N	\N	\N	23723	23723	23724
7460	6405	0	applied	\N	\N	\N	\N	23726	23726	23727
7460	6406	1	applied	\N	\N	\N	\N	23728	23728	23729
7460	6407	2	applied	\N	\N	\N	\N	23730	23730	23731
7468	6411	0	applied	\N	\N	\N	\N	23745	23745	23746
7474	6415	0	applied	\N	\N	\N	\N	23767	23767	23768
7474	6416	1	applied	\N	\N	\N	\N	23769	23769	23770
7481	6420	0	applied	\N	\N	\N	\N	23787	23787	23788
7481	6421	1	applied	\N	\N	\N	\N	23789	23789	23790
7481	6422	2	applied	\N	\N	\N	\N	23791	23791	19746
7489	6425	0	applied	\N	\N	\N	\N	23804	23804	23805
7489	6426	1	applied	\N	\N	\N	\N	23806	23806	23807
7499	6439	0	applied	\N	\N	\N	\N	23844	23844	23845
7504	6441	0	applied	\N	\N	\N	\N	23852	23852	23853
7504	6442	1	applied	\N	\N	\N	\N	23854	23854	23855
7509	6449	0	applied	\N	\N	\N	\N	23880	23880	23881
7509	6450	1	applied	\N	\N	\N	\N	23882	23882	23883
7509	6451	2	applied	\N	\N	\N	\N	23884	23884	23885
7509	6452	3	applied	\N	\N	\N	\N	23886	23886	23887
7512	6449	0	applied	\N	\N	\N	\N	23880	23880	23881
7512	6450	1	applied	\N	\N	\N	\N	23882	23882	23883
7512	6451	2	applied	\N	\N	\N	\N	23884	23884	23885
7512	6452	3	applied	\N	\N	\N	\N	23886	23886	23887
7516	6455	0	applied	\N	\N	\N	\N	23905	23905	23906
7519	6457	0	applied	\N	\N	\N	\N	23913	23913	23914
7519	6458	1	applied	\N	\N	\N	\N	23915	23915	23916
7519	6459	2	applied	\N	\N	\N	\N	23917	23917	23918
7533	6465	0	applied	\N	\N	\N	\N	24041	24041	24042
7533	6467	1	applied	\N	\N	\N	\N	24047	24047	24048
7533	6466	2	applied	\N	\N	\N	\N	24043	24043	24043
7535	6468	0	applied	\N	\N	\N	\N	24052	24052	24053
7535	6469	1	applied	\N	\N	\N	\N	24055	24055	24055
7538	6471	0	applied	\N	\N	\N	\N	24062	24062	24063
7550	6481	0	applied	\N	\N	\N	\N	24101	24101	24102
7555	6484	0	applied	\N	\N	\N	\N	24112	24112	24113
7557	6485	0	applied	\N	\N	\N	\N	24120	24120	24121
7568	6490	0	applied	\N	\N	\N	\N	24145	24145	24146
7571	6491	0	applied	\N	\N	\N	\N	24149	24149	24150
7580	6493	0	applied	\N	\N	\N	\N	24162	24162	24163
7582	6493	0	applied	\N	\N	\N	\N	24162	24162	24163
7583	6494	0	applied	\N	\N	\N	\N	24171	24171	24172
7591	6501	0	applied	\N	\N	\N	\N	24194	24194	24195
7591	6502	1	applied	\N	\N	1000000000	\N	24197	24197	24198
7597	6510	0	applied	\N	\N	\N	\N	24221	24221	24222
7373	6298	8	applied	\N	\N	\N	\N	23346	23346	23347
7373	6299	9	applied	\N	\N	\N	\N	23348	23348	23349
7373	6300	10	applied	\N	\N	\N	\N	23350	23350	23351
7373	6301	11	applied	\N	\N	\N	\N	23352	23352	23353
7373	6302	12	applied	\N	\N	\N	\N	23354	23354	23355
7373	6303	13	applied	\N	\N	\N	\N	23356	23356	23357
7373	6304	14	applied	\N	\N	\N	\N	23358	23358	23359
7373	6305	15	applied	\N	\N	\N	\N	23360	23360	23361
7373	6306	16	applied	\N	\N	\N	\N	23362	23362	23363
7373	6307	17	applied	\N	\N	\N	\N	23364	23364	23365
7373	6308	18	applied	\N	\N	\N	\N	23366	23366	23367
7373	6309	19	applied	\N	\N	\N	\N	23368	23368	23369
7373	6310	20	applied	\N	\N	\N	\N	23370	23370	23371
7373	6311	21	applied	\N	\N	\N	\N	23372	23372	23373
7373	6312	22	applied	\N	\N	\N	\N	23374	23374	23375
7373	6313	23	applied	\N	\N	\N	\N	23376	23376	23377
7373	6314	24	applied	\N	\N	\N	\N	23378	23378	23379
7373	6315	25	applied	\N	\N	\N	\N	23380	23380	23381
7373	6316	26	applied	\N	\N	\N	\N	23382	23382	23383
7373	6317	27	applied	\N	\N	\N	\N	23384	23384	23385
7373	6318	28	applied	\N	\N	\N	\N	23386	23386	23387
7376	6319	0	applied	\N	\N	\N	\N	23390	23390	23391
7377	6320	0	applied	\N	\N	\N	\N	23396	23396	23397
7382	6323	0	applied	\N	\N	\N	\N	23409	23409	23410
7387	6328	0	applied	\N	\N	\N	\N	23425	23425	23426
7390	6332	0	applied	\N	\N	\N	\N	23436	23436	23437
7390	6333	1	applied	\N	\N	\N	\N	23438	23438	23439
7390	6334	2	applied	\N	\N	\N	\N	23440	23440	23441
7390	6335	3	applied	\N	\N	\N	\N	23442	23442	23443
7390	6336	4	applied	\N	\N	\N	\N	23444	23444	23445
7392	6337	0	applied	\N	\N	\N	\N	23449	23449	23450
7395	6340	0	applied	\N	\N	\N	\N	23460	23460	23461
7395	6341	1	applied	\N	\N	\N	\N	23462	23462	23463
7397	6342	0	applied	\N	\N	\N	\N	23467	23467	23468
7401	6352	0	applied	\N	\N	\N	\N	23495	23495	23496
7404	6356	0	applied	\N	\N	\N	\N	23506	23506	23507
7406	6357	0	applied	\N	\N	\N	\N	23512	23512	23513
7410	6362	0	applied	\N	\N	\N	\N	23527	23527	23528
7410	6363	1	applied	\N	\N	\N	\N	23529	23529	23530
7412	6364	0	applied	\N	\N	\N	\N	23533	23533	23534
7414	6365	0	applied	\N	\N	\N	\N	23537	23537	23538
7414	6366	2	applied	\N	\N	\N	\N	23541	23541	23542
7418	6367	0	applied	\N	\N	\N	\N	23550	23550	23551
7418	6368	1	applied	\N	\N	\N	\N	23552	23552	22685
7419	6365	0	applied	\N	\N	\N	\N	23537	23537	23538
7419	6367	1	applied	\N	\N	\N	\N	23550	23550	23551
7419	6368	2	applied	\N	\N	\N	\N	23552	23552	22685
7423	6372	0	applied	\N	\N	\N	\N	23565	23565	23566
7431	6378	0	applied	\N	\N	\N	\N	23623	23623	23624
7431	6379	1	applied	\N	\N	\N	\N	23629	23629	23630
7433	6379	0	applied	\N	\N	\N	\N	23629	23629	23630
7435	6381	0	applied	\N	\N	\N	\N	23640	23640	23641
7435	6382	1	applied	\N	\N	\N	\N	23642	23642	23643
7438	6385	0	applied	\N	\N	\N	\N	23652	23652	23653
7445	6389	0	applied	\N	\N	\N	\N	23669	23669	23670
7447	6391	0	applied	\N	\N	\N	\N	23675	23675	23676
7451	6395	0	applied	\N	\N	\N	\N	23689	23689	23690
7451	6396	1	applied	\N	\N	\N	\N	23691	23691	23692
7456	6403	0	applied	\N	\N	\N	\N	23715	23715	23716
7463	6408	0	applied	\N	\N	\N	\N	23737	23737	23738
7466	6411	0	applied	\N	\N	\N	\N	23745	23745	23746
7473	6290	0	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7473	6386	1	applied	\N	\N	\N	\N	23659	23659	23660
7473	6399	2	applied	\N	\N	\N	\N	23703	23703	23704
7473	6199	3	applied	\N	\N	\N	\N	23157	23157	23079
7473	6201	4	applied	\N	\N	\N	\N	23158	23158	23083
7473	6202	5	applied	\N	\N	\N	\N	23159	23159	23085
7473	6203	6	applied	\N	\N	\N	\N	23160	23160	23087
7473	6353	7	applied	\N	\N	\N	\N	23763	23763	13857
7473	6185	8	applied	\N	\N	\N	\N	23027	23027	23028
7473	6186	9	applied	\N	\N	\N	\N	23029	23029	23030
7473	6187	10	applied	\N	\N	\N	\N	23031	23031	23032
7473	6188	11	applied	\N	\N	\N	\N	23033	23033	23034
7473	6361	12	applied	\N	\N	1000000000	\N	23524	23524	23525
7473	6204	13	applied	\N	\N	\N	\N	23161	23161	23089
7473	6207	14	applied	\N	\N	\N	\N	23162	23162	23098
7473	6208	15	applied	\N	\N	\N	\N	23163	23163	23100
7473	6209	16	applied	\N	\N	\N	\N	23164	23164	23102
7473	6210	17	applied	\N	\N	\N	\N	23165	23165	23104
7473	6211	18	applied	\N	\N	\N	\N	23166	23166	23106
7473	6212	19	applied	\N	\N	\N	\N	23167	23167	23108
7473	6213	21	applied	\N	\N	\N	\N	23168	23168	23110
7476	6417	0	applied	\N	\N	\N	\N	23772	23772	23773
7476	6418	1	applied	\N	\N	\N	\N	23774	23774	19746
7482	6420	0	applied	\N	\N	\N	\N	23787	23787	23788
7482	6421	1	applied	\N	\N	\N	\N	23789	23789	23790
7482	6422	2	applied	\N	\N	\N	\N	23791	23791	19746
7485	6423	0	applied	\N	\N	\N	\N	23795	23795	23796
7487	6425	0	applied	\N	\N	\N	\N	23804	23804	23805
7487	6426	1	applied	\N	\N	\N	\N	23806	23806	23807
7492	6427	0	applied	\N	\N	\N	\N	23814	23814	23815
7494	6429	0	applied	\N	\N	\N	\N	23818	23818	12588
7494	6430	1	applied	\N	\N	\N	\N	23819	23819	23820
7497	6435	0	applied	\N	\N	\N	\N	23834	23834	23835
7500	6439	0	applied	\N	\N	\N	\N	23844	23844	23845
7502	6440	0	applied	\N	\N	\N	\N	23849	23849	23850
7505	6443	0	applied	\N	\N	\N	\N	23860	23860	23861
7505	6444	1	applied	\N	\N	\N	\N	23862	23862	23863
7510	6449	0	applied	\N	\N	\N	\N	23880	23880	23881
7510	6450	1	applied	\N	\N	\N	\N	23882	23882	23883
7510	6451	2	applied	\N	\N	\N	\N	23884	23884	23885
7510	6452	3	applied	\N	\N	\N	\N	23886	23886	23887
7513	6449	0	applied	\N	\N	\N	\N	23880	23880	23881
7513	6450	1	applied	\N	\N	\N	\N	23882	23882	23883
7513	6451	2	applied	\N	\N	\N	\N	23884	23884	23885
7513	6452	3	applied	\N	\N	\N	\N	23886	23886	23887
7514	6453	0	applied	\N	\N	\N	\N	23898	23898	19746
7520	6457	0	applied	\N	\N	\N	\N	23913	23913	23914
7520	6458	1	applied	\N	\N	\N	\N	23915	23915	23916
7520	6459	2	applied	\N	\N	\N	\N	23917	23917	23918
7524	6462	0	applied	\N	\N	\N	\N	23930	23930	23931
7529	6290	0	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7529	6386	1	applied	\N	\N	\N	\N	23939	23939	23660
7529	6399	2	applied	\N	\N	\N	\N	23940	23940	23704
7529	6199	3	applied	\N	\N	\N	\N	23976	23976	23079
7529	6201	4	applied	\N	\N	\N	\N	23977	23977	23083
7529	6202	5	applied	\N	\N	\N	\N	23978	23978	23085
7529	6203	6	applied	\N	\N	\N	\N	23979	23979	23087
7529	6453	7	applied	\N	\N	\N	\N	23898	23898	19746
7424	5730	1	applied	\N	\N	\N	\N	21604	21604	21605
7424	5911	2	applied	\N	\N	\N	\N	22157	22157	22134
7424	5731	3	applied	\N	\N	\N	\N	21607	21607	21608
7424	6353	4	applied	\N	\N	\N	\N	23569	23569	13857
7424	6185	5	applied	\N	\N	\N	\N	23027	23027	23028
7424	6186	6	applied	\N	\N	\N	\N	23029	23029	23030
7424	6187	7	applied	\N	\N	\N	\N	23031	23031	23032
7424	6188	8	applied	\N	\N	\N	\N	23033	23033	23034
7424	5733	9	applied	\N	\N	\N	\N	21615	21615	21616
7424	6361	10	applied	\N	\N	1000000000	\N	23570	23570	23525
7424	6166	11	failed	Receiver_not_present	\N	\N	\N	23571	23571	\N
7424	6290	12	failed	Receiver_not_present	\N	\N	\N	23572	23572	\N
7424	5732	13	applied	\N	\N	\N	\N	21609	21609	21610
7424	5734	14	applied	\N	\N	\N	\N	21617	21617	21618
7424	5735	15	applied	\N	\N	\N	\N	21622	21622	21623
7424	5736	16	applied	\N	\N	\N	\N	21626	21626	21627
7424	5737	17	applied	\N	\N	\N	\N	21629	21629	21630
7424	5740	18	applied	\N	\N	\N	\N	21639	21639	21640
7424	5741	19	applied	\N	\N	\N	\N	21642	21642	21643
7424	5744	20	applied	\N	\N	\N	\N	21651	21651	21652
7424	5746	21	applied	\N	\N	\N	\N	21657	21657	21658
7424	5747	22	applied	\N	\N	\N	\N	21659	21659	21660
7424	5752	23	applied	\N	\N	\N	\N	21669	21669	21670
7424	5753	25	applied	\N	\N	\N	\N	21671	21671	21672
7424	5754	26	applied	\N	\N	\N	\N	21673	21673	21674
7424	5756	27	applied	\N	\N	\N	\N	21680	21680	21681
7424	5758	28	applied	\N	\N	\N	\N	21692	21692	21693
7424	5760	29	applied	\N	\N	\N	\N	21698	21698	21699
7424	5761	30	applied	\N	\N	\N	\N	21700	21700	21701
7424	5765	31	applied	\N	\N	\N	\N	21710	21710	21711
7424	5766	32	applied	\N	\N	\N	\N	21712	21712	21713
7424	5767	33	applied	\N	\N	\N	\N	21717	21717	21718
7424	5771	34	applied	\N	\N	\N	\N	21726	21726	21727
7424	5738	35	applied	\N	\N	\N	\N	21631	21631	21632
7424	5739	36	applied	\N	\N	\N	\N	21637	21637	21638
7424	5772	37	applied	\N	\N	\N	\N	21728	21728	21729
7424	5773	38	applied	\N	\N	\N	\N	21732	21732	21733
7424	5776	39	applied	\N	\N	\N	\N	21740	21740	21741
7424	5777	40	applied	\N	\N	\N	\N	21743	21743	21744
7424	5780	41	applied	\N	\N	\N	\N	21753	21753	21754
7424	5781	42	applied	\N	\N	\N	\N	21755	21755	21756
7424	5783	43	applied	\N	\N	\N	\N	21759	21759	21760
7424	5785	44	applied	\N	\N	\N	\N	21767	21767	21768
7424	5786	45	applied	\N	\N	1000000000	\N	21769	21769	21770
7424	5788	46	applied	\N	\N	\N	\N	21773	21773	21774
7424	5792	47	applied	\N	\N	\N	\N	21781	21781	21782
7424	5793	48	applied	\N	\N	\N	\N	21783	21783	21784
7424	5795	49	applied	\N	\N	\N	\N	21793	21793	21794
7424	5742	50	applied	\N	\N	\N	\N	21644	21644	21645
7424	5743	51	applied	\N	\N	\N	\N	21649	21649	21650
7424	5745	52	applied	\N	\N	\N	\N	21654	21654	21655
7424	5748	53	applied	\N	\N	\N	\N	21661	21661	21662
7424	5749	54	applied	\N	\N	\N	\N	21663	21663	21664
7424	5750	55	applied	\N	\N	\N	\N	21665	21665	21666
7424	5751	56	applied	\N	\N	\N	\N	21667	21667	21668
7424	5755	57	applied	\N	\N	\N	\N	21676	21676	21677
7424	5757	58	applied	\N	\N	\N	\N	21690	21690	21691
7424	5759	59	applied	\N	\N	\N	\N	21696	21696	21697
7424	5762	60	applied	\N	\N	\N	\N	21702	21702	21703
7424	5763	61	applied	\N	\N	\N	\N	21706	21706	21707
7424	5764	62	applied	\N	\N	\N	\N	21708	21708	21709
7424	5768	63	applied	\N	\N	\N	\N	21719	21719	21720
7424	5769	64	applied	\N	\N	\N	\N	21722	21722	21723
7424	5770	65	applied	\N	\N	\N	\N	21724	21724	21725
7424	5774	66	applied	\N	\N	\N	\N	21734	21734	21735
7424	5775	67	applied	\N	\N	\N	\N	21738	21738	21739
7424	5797	68	applied	\N	\N	\N	\N	21801	21801	21802
7424	5799	69	applied	\N	\N	\N	\N	21807	21807	21808
7424	5800	70	applied	\N	\N	\N	\N	21811	21811	21812
7424	5804	71	applied	\N	\N	\N	\N	21823	21823	21824
7424	5805	72	applied	\N	\N	\N	\N	21825	21825	21826
7424	5807	73	applied	\N	\N	\N	\N	21835	21835	21836
7424	5809	74	applied	\N	\N	\N	\N	21842	21842	21843
7424	5811	75	applied	\N	\N	\N	\N	21848	21848	21849
7424	5812	76	applied	\N	\N	\N	\N	21850	21850	21851
7424	5816	77	applied	\N	\N	\N	\N	21861	21861	21862
7424	5817	78	applied	\N	\N	\N	\N	21863	21863	21864
7424	5821	79	applied	\N	\N	\N	\N	21876	21876	21877
7424	5822	80	applied	\N	\N	\N	\N	21878	21878	21879
7424	5825	81	applied	\N	\N	\N	\N	21884	21884	21885
7424	5826	82	applied	\N	\N	\N	\N	21886	21886	21887
7424	5827	83	applied	\N	\N	\N	\N	21888	21888	21889
7424	5829	84	applied	\N	\N	\N	\N	21894	21894	21895
7424	5832	85	applied	\N	\N	\N	\N	21900	21900	21901
7424	5833	86	applied	\N	\N	\N	\N	21907	21907	21908
7424	5837	87	applied	\N	\N	\N	\N	21919	21919	21920
7424	5838	88	applied	\N	\N	\N	\N	21921	21921	21922
7424	5840	89	applied	\N	\N	\N	\N	21928	21928	21929
7424	5841	90	applied	\N	\N	\N	\N	21930	21930	21931
7424	5842	91	applied	\N	\N	\N	\N	21932	21932	21933
7424	5845	92	applied	\N	\N	\N	\N	21938	21938	21939
7424	6339	93	applied	\N	\N	\N	\N	23574	23574	23458
7424	6002	94	applied	\N	\N	\N	\N	22493	22493	22373
7424	6199	95	applied	\N	\N	\N	\N	23575	23575	23079
7424	6201	96	applied	\N	\N	\N	\N	23576	23576	23083
7424	6202	97	applied	\N	\N	\N	\N	23577	23577	23085
7424	6203	98	applied	\N	\N	\N	\N	23578	23578	23087
7424	6204	99	applied	\N	\N	\N	\N	23579	23579	23089
7424	6207	100	applied	\N	\N	\N	\N	23580	23580	23098
7424	6208	101	applied	\N	\N	\N	\N	23581	23581	23100
7424	6209	102	applied	\N	\N	\N	\N	23582	23582	23102
7424	6210	103	applied	\N	\N	\N	\N	23583	23583	23104
7424	6211	104	applied	\N	\N	\N	\N	23584	23584	23106
7424	6212	105	applied	\N	\N	\N	\N	23585	23585	23108
7424	6213	106	applied	\N	\N	\N	\N	23586	23586	23110
7424	6214	107	applied	\N	\N	\N	\N	23587	23587	23112
7424	6215	108	applied	\N	\N	\N	\N	23588	23588	23114
7424	6216	109	applied	\N	\N	\N	\N	23589	23589	23118
7424	6217	110	applied	\N	\N	\N	\N	23590	23590	23120
7424	6218	111	applied	\N	\N	\N	\N	23591	23591	23122
7424	6220	112	applied	\N	\N	\N	\N	23592	23592	23126
7424	6221	113	applied	\N	\N	\N	\N	23593	23593	23128
7424	6222	114	applied	\N	\N	\N	\N	23594	23594	23130
7424	6223	115	applied	\N	\N	\N	\N	23595	23595	23132
7424	6224	116	applied	\N	\N	\N	\N	23596	23596	23139
7424	6225	117	applied	\N	\N	\N	\N	23597	23597	23141
7424	6226	118	applied	\N	\N	\N	\N	23598	23598	23143
7424	6227	119	applied	\N	\N	\N	\N	23599	23599	23145
7424	6228	120	applied	\N	\N	\N	\N	23600	23600	23147
7424	6229	121	applied	\N	\N	\N	\N	23601	23601	23149
7424	6230	122	applied	\N	\N	\N	\N	23602	23602	23151
7424	6232	123	applied	\N	\N	\N	\N	23603	23603	23187
7424	6234	124	applied	\N	\N	\N	\N	23604	23604	23191
7424	6235	125	applied	\N	\N	\N	\N	23605	23605	23193
7426	6373	0	applied	\N	\N	\N	\N	23608	23608	23609
7426	6374	1	applied	\N	\N	\N	\N	23610	23610	23611
7426	6375	2	applied	\N	\N	\N	\N	23612	23612	23613
7436	6383	0	applied	\N	\N	\N	\N	23646	23646	23647
7439	6385	0	applied	\N	\N	\N	\N	23652	23652	23653
7443	6389	0	applied	\N	\N	\N	\N	23669	23669	23670
7448	6392	0	applied	\N	\N	\N	\N	23679	23679	23680
7454	6402	0	applied	\N	\N	\N	\N	23710	23710	23711
7457	6403	0	applied	\N	\N	\N	\N	23715	23715	23716
7462	6405	0	applied	\N	\N	\N	\N	23726	23726	23727
7462	6406	1	applied	\N	\N	\N	\N	23728	23728	23729
7462	6407	2	applied	\N	\N	\N	\N	23730	23730	23731
7464	6409	0	applied	\N	\N	\N	\N	23739	23739	23740
7467	6411	0	applied	\N	\N	\N	\N	23745	23745	23746
7471	6414	0	applied	\N	\N	\N	\N	23759	23759	23760
7477	6417	0	applied	\N	\N	\N	\N	23772	23772	23773
7477	6418	1	applied	\N	\N	\N	\N	23774	23774	19746
7478	6417	0	applied	\N	\N	\N	\N	23772	23772	23773
7478	6418	1	applied	\N	\N	\N	\N	23774	23774	19746
7483	6420	0	applied	\N	\N	\N	\N	23787	23787	23788
7483	6421	1	applied	\N	\N	\N	\N	23789	23789	23790
7483	6422	2	applied	\N	\N	\N	\N	23791	23791	19746
7488	6425	0	applied	\N	\N	\N	\N	23804	23804	23805
7488	6426	1	applied	\N	\N	\N	\N	23806	23806	23807
7495	6431	0	applied	\N	\N	\N	\N	23823	23823	23824
7495	6432	1	applied	\N	\N	\N	\N	23825	23825	23826
7498	6436	0	applied	\N	\N	\N	\N	23836	23836	23837
7498	6437	1	applied	\N	\N	\N	\N	23838	23838	23839
7498	6438	2	applied	\N	\N	\N	\N	23840	23840	23841
7501	6439	0	applied	\N	\N	\N	\N	23844	23844	23845
7503	6441	0	applied	\N	\N	\N	\N	23852	23852	23853
7503	6442	1	applied	\N	\N	\N	\N	23854	23854	23855
7506	6445	0	applied	\N	\N	\N	\N	23866	23866	23867
7506	6446	1	applied	\N	\N	\N	\N	23868	23868	23869
7508	6448	0	applied	\N	\N	\N	\N	23876	23876	23877
7511	6386	0	applied	\N	\N	\N	\N	23659	23659	23660
7511	6399	1	applied	\N	\N	\N	\N	23703	23703	23704
7511	6337	2	applied	\N	\N	\N	\N	23449	23449	23450
7511	6353	3	applied	\N	\N	\N	\N	23763	23763	13857
7511	6338	4	applied	\N	\N	\N	\N	23455	23455	23456
7511	6340	5	applied	\N	\N	\N	\N	23460	23460	23461
7511	6341	6	applied	\N	\N	\N	\N	23462	23462	23463
7511	6361	7	applied	\N	\N	1000000000	\N	23524	23524	23525
7511	6418	8	applied	\N	\N	\N	\N	23774	23774	19746
7511	6342	9	applied	\N	\N	\N	\N	23467	23467	23468
7511	6343	10	applied	\N	\N	\N	\N	23473	23473	23474
7511	6344	11	applied	\N	\N	\N	\N	23477	23477	23478
7511	6345	12	applied	\N	\N	\N	\N	23479	23479	23480
7511	6346	13	applied	\N	\N	1000000000	\N	23481	23481	23482
7511	6347	14	applied	\N	\N	1000000000	\N	23483	23483	23484
7511	6348	15	applied	\N	\N	\N	\N	23485	23485	23486
7511	6349	16	applied	\N	\N	\N	\N	23487	23487	23488
7511	6350	17	applied	\N	\N	\N	\N	23489	23489	23490
7511	6351	18	applied	\N	\N	\N	\N	23491	23491	23492
7511	6352	19	applied	\N	\N	\N	\N	23495	23495	23496
7511	6354	20	applied	\N	\N	\N	\N	23498	23498	23499
7511	6355	21	applied	\N	\N	\N	\N	23500	23500	23501
7511	6356	22	applied	\N	\N	\N	\N	23506	23506	23507
7511	6357	23	applied	\N	\N	\N	\N	23512	23512	23513
7511	6358	24	applied	\N	\N	\N	\N	23516	23516	23517
7511	6359	25	applied	\N	\N	\N	\N	23520	23520	23521
7511	6360	26	applied	\N	\N	\N	\N	23522	23522	23523
7511	6362	27	applied	\N	\N	\N	\N	23527	23527	23528
7511	6363	28	applied	\N	\N	\N	\N	23529	23529	23530
7511	6364	29	applied	\N	\N	\N	\N	23533	23533	23534
7511	6365	30	applied	\N	\N	\N	\N	23537	23537	23538
7511	6367	31	applied	\N	\N	\N	\N	23550	23550	23551
7511	6369	32	applied	\N	\N	\N	\N	23556	23556	23557
7511	6370	33	applied	\N	\N	\N	\N	23558	23558	23559
7511	6371	34	applied	\N	\N	\N	\N	23562	23562	23563
7511	6372	35	applied	\N	\N	\N	\N	23565	23565	23566
7511	6373	36	applied	\N	\N	\N	\N	23608	23608	23609
7511	6374	37	applied	\N	\N	\N	\N	23610	23610	23611
7511	6375	38	applied	\N	\N	\N	\N	23612	23612	23613
7511	6376	39	applied	\N	\N	\N	\N	23617	23617	23618
7511	6377	40	applied	\N	\N	\N	\N	23619	23619	23620
7511	6378	41	applied	\N	\N	\N	\N	23623	23623	23624
7511	6379	42	applied	\N	\N	\N	\N	23629	23629	23630
7511	6380	43	applied	\N	\N	\N	\N	23636	23636	23637
7511	6381	44	applied	\N	\N	\N	\N	23640	23640	23641
7511	6382	45	applied	\N	\N	\N	\N	23642	23642	23643
7511	6383	46	applied	\N	\N	\N	\N	23646	23646	23647
7511	6384	47	applied	\N	\N	\N	\N	23648	23648	23649
7511	6385	48	applied	\N	\N	\N	\N	23652	23652	23653
7511	6387	49	applied	\N	\N	\N	\N	23661	23661	23662
7511	6388	50	applied	\N	\N	\N	\N	23665	23665	23666
7511	6389	51	applied	\N	\N	\N	\N	23669	23669	23670
7511	6390	52	applied	\N	\N	\N	\N	23673	23673	23674
7511	6391	53	applied	\N	\N	\N	\N	23675	23675	23676
7511	6392	54	applied	\N	\N	\N	\N	23679	23679	23680
7511	6393	55	applied	\N	\N	\N	\N	23683	23683	23684
7511	6394	56	applied	\N	\N	\N	\N	23685	23685	23686
7511	6395	58	applied	\N	\N	\N	\N	23689	23689	23690
7511	6396	59	applied	\N	\N	\N	\N	23691	23691	23692
7511	6397	60	applied	\N	\N	\N	\N	23697	23697	23698
7511	6398	61	applied	\N	\N	\N	\N	23699	23699	23700
7511	6400	62	applied	\N	\N	\N	\N	23705	23705	23706
7511	6401	63	applied	\N	\N	\N	\N	23707	23707	23708
7511	6402	64	applied	\N	\N	\N	\N	23710	23710	23711
7511	6403	65	applied	\N	\N	\N	\N	23715	23715	23716
7511	6404	66	applied	\N	\N	\N	\N	23723	23723	23724
7511	6405	67	applied	\N	\N	\N	\N	23726	23726	23727
7511	6406	68	applied	\N	\N	\N	\N	23728	23728	23729
7511	6407	69	applied	\N	\N	\N	\N	23730	23730	23731
7511	6408	70	applied	\N	\N	\N	\N	23737	23737	23738
7511	6409	71	applied	\N	\N	\N	\N	23739	23739	23740
7511	6410	72	applied	\N	\N	\N	\N	23741	23741	23742
7511	6411	73	applied	\N	\N	\N	\N	23745	23745	23746
7511	6412	74	applied	\N	\N	\N	\N	23755	23755	23756
7511	6413	75	applied	\N	\N	\N	\N	23757	23757	23758
7511	6414	76	applied	\N	\N	\N	\N	23759	23759	23760
7511	6415	77	applied	\N	\N	\N	\N	23767	23767	23768
7511	6416	78	applied	\N	\N	\N	\N	23769	23769	23770
7511	6417	79	applied	\N	\N	\N	\N	23772	23772	23773
7484	6423	0	applied	\N	\N	\N	\N	23795	23795	23796
7486	6424	0	applied	\N	\N	\N	\N	23800	23800	23801
7490	6425	0	applied	\N	\N	\N	\N	23804	23804	23805
7490	6426	1	applied	\N	\N	\N	\N	23806	23806	23807
7491	6427	0	applied	\N	\N	\N	\N	23814	23814	23815
7493	6428	0	applied	\N	\N	\N	\N	23816	23816	23817
7496	6433	0	applied	\N	\N	\N	\N	23828	23828	23829
7496	6434	1	applied	\N	\N	\N	\N	23830	23830	23831
7507	6447	0	applied	\N	\N	\N	\N	23872	23872	23873
7517	6456	0	applied	\N	\N	\N	\N	23908	23908	23909
7522	6460	0	applied	\N	\N	\N	\N	23923	23923	23924
7525	6462	0	applied	\N	\N	\N	\N	23930	23930	23931
7527	6463	0	applied	\N	\N	\N	\N	23934	23934	23935
7527	6464	1	applied	\N	\N	\N	\N	23936	23936	23937
7534	6465	0	applied	\N	\N	\N	\N	24041	24041	24042
7534	6467	1	applied	\N	\N	\N	\N	24047	24047	24048
7534	6468	2	applied	\N	\N	\N	\N	24052	24052	24053
7534	6466	3	applied	\N	\N	\N	\N	24043	24043	24043
7536	6470	0	applied	\N	\N	\N	\N	24058	24058	24059
7541	6473	0	applied	\N	\N	\N	\N	24071	24071	24072
7544	6474	0	applied	\N	\N	\N	\N	24076	24076	24077
7544	6475	1	applied	\N	\N	\N	\N	24078	24078	24079
7546	6476	0	applied	\N	\N	\N	\N	24084	24084	24085
7556	6485	0	applied	\N	\N	\N	\N	24120	24120	24121
7558	6486	0	applied	\N	\N	\N	\N	24124	24124	24125
7563	6488	0	applied	\N	\N	\N	\N	24132	24132	24133
7565	6489	0	applied	\N	\N	\N	\N	24139	24139	24140
7572	6453	0	applied	\N	\N	\N	\N	23898	23898	19746
7572	6466	1	applied	\N	\N	\N	\N	24043	24043	24043
7572	6469	2	applied	\N	\N	\N	\N	24055	24055	24055
7574	6491	0	applied	\N	\N	\N	\N	24149	24149	24150
7576	6492	0	applied	\N	\N	\N	\N	24158	24158	24159
7578	6493	0	applied	\N	\N	\N	\N	24162	24162	24163
7581	6493	0	applied	\N	\N	\N	\N	24162	24162	24163
7586	6496	0	applied	\N	\N	\N	\N	24177	24177	24178
7586	6497	1	applied	\N	\N	\N	\N	24179	24179	24180
7586	6498	2	applied	\N	\N	\N	\N	24181	24181	24182
7586	6499	3	applied	\N	\N	\N	\N	24183	24183	24184
7588	6500	0	applied	\N	\N	\N	\N	24188	24188	24189
7590	6500	0	applied	\N	\N	\N	\N	24188	24188	24189
7590	6501	1	applied	\N	\N	\N	\N	24194	24194	24195
7593	6501	0	applied	\N	\N	\N	\N	24194	24194	24195
7593	6503	1	applied	\N	\N	\N	\N	24202	24202	24203
7593	6504	2	applied	\N	\N	\N	\N	24204	24204	24205
7593	6505	3	applied	\N	\N	\N	\N	24206	24206	24207
7593	6506	4	applied	\N	\N	\N	\N	24208	24208	24209
7593	6507	5	applied	\N	\N	1000000000	\N	24210	24210	24211
7593	6508	6	applied	\N	\N	1000000000	\N	24212	24212	24213
7595	6509	0	applied	\N	\N	\N	\N	24217	24217	24218
7511	6419	80	applied	\N	\N	\N	\N	23782	23782	23783
7511	6420	81	applied	\N	\N	\N	\N	23787	23787	23788
7511	6421	82	applied	\N	\N	\N	\N	23789	23789	23790
7511	6423	83	applied	\N	\N	\N	\N	23795	23795	23796
7511	6424	84	applied	\N	\N	\N	\N	23800	23800	23801
7511	6425	85	applied	\N	\N	\N	\N	23804	23804	23805
7511	6426	86	applied	\N	\N	\N	\N	23806	23806	23807
7511	6427	87	applied	\N	\N	\N	\N	23814	23814	23815
7511	6428	88	applied	\N	\N	\N	\N	23816	23816	23817
7511	6430	89	applied	\N	\N	\N	\N	23819	23819	23820
7511	6431	90	applied	\N	\N	\N	\N	23823	23823	23824
7511	6432	91	applied	\N	\N	\N	\N	23825	23825	23826
7511	6434	92	applied	\N	\N	\N	\N	23830	23830	23831
7511	6435	93	applied	\N	\N	\N	\N	23834	23834	23835
7511	6436	94	applied	\N	\N	\N	\N	23836	23836	23837
7511	6437	95	applied	\N	\N	\N	\N	23838	23838	23839
7511	6339	96	applied	\N	\N	\N	\N	23457	23457	23458
7511	6438	97	applied	\N	\N	\N	\N	23840	23840	23841
7511	6439	98	applied	\N	\N	\N	\N	23844	23844	23845
7511	6440	99	applied	\N	\N	\N	\N	23849	23849	23850
7511	6441	100	applied	\N	\N	\N	\N	23852	23852	23853
7511	6442	101	applied	\N	\N	\N	\N	23854	23854	23855
7511	6443	102	applied	\N	\N	\N	\N	23860	23860	23861
7511	6444	103	applied	\N	\N	\N	\N	23862	23862	23863
7511	6446	104	applied	\N	\N	\N	\N	23868	23868	23869
7511	6447	105	applied	\N	\N	\N	\N	23872	23872	23873
7511	6448	106	applied	\N	\N	\N	\N	23876	23876	23877
7511	6449	107	applied	\N	\N	\N	\N	23880	23880	23881
7511	6450	108	applied	\N	\N	\N	\N	23882	23882	23883
7511	6451	109	applied	\N	\N	\N	\N	23884	23884	23885
7511	6366	110	applied	\N	\N	\N	\N	23541	23541	23542
7511	6445	111	applied	\N	\N	\N	\N	23866	23866	23867
7511	6452	112	applied	\N	\N	\N	\N	23886	23886	23887
7511	6422	113	applied	\N	\N	\N	\N	23791	23791	19746
7511	6429	114	applied	\N	\N	\N	\N	23818	23818	12588
7511	6433	115	applied	\N	\N	\N	\N	23828	23828	23829
7511	6368	116	applied	\N	\N	\N	\N	23552	23552	22685
7515	6454	0	applied	\N	\N	\N	\N	23901	23901	23902
7518	6456	0	applied	\N	\N	\N	\N	23908	23908	23909
7521	6457	0	applied	\N	\N	\N	\N	23913	23913	23914
7521	6458	1	applied	\N	\N	\N	\N	23915	23915	23916
7521	6459	2	applied	\N	\N	\N	\N	23917	23917	23918
7523	6461	0	applied	\N	\N	\N	\N	23927	23927	23928
7528	6386	0	applied	\N	\N	\N	\N	23939	23939	23660
7528	6399	1	applied	\N	\N	\N	\N	23940	23940	23704
7528	6199	2	applied	\N	\N	\N	\N	23941	23941	23079
7528	6119	3	applied	\N	\N	\N	\N	22790	22790	22791
7528	6201	4	applied	\N	\N	\N	\N	23942	23942	23083
7528	6202	5	applied	\N	\N	\N	\N	23943	23943	23085
7528	6203	6	applied	\N	\N	\N	\N	23944	23944	23087
7528	6453	7	applied	\N	\N	\N	\N	23898	23898	19746
7528	6353	8	applied	\N	\N	\N	\N	23945	23945	13857
7528	6185	9	applied	\N	\N	\N	\N	23027	23027	23028
7528	6186	10	applied	\N	\N	\N	\N	23029	23029	23030
7528	6187	11	applied	\N	\N	\N	\N	23031	23031	23032
7528	6188	12	applied	\N	\N	\N	\N	23033	23033	23034
7528	6361	13	applied	\N	\N	1000000000	\N	23570	23570	23525
7528	6166	14	failed	Receiver_not_present	\N	\N	\N	22966	22966	\N
7528	6290	15	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7528	6120	16	applied	\N	\N	\N	\N	22794	22794	22795
7528	6121	17	applied	\N	\N	\N	\N	22796	22796	22797
7528	6122	18	applied	\N	\N	\N	\N	22802	22802	22803
7528	6123	19	applied	\N	\N	\N	\N	22808	22808	22809
7528	6124	20	applied	\N	\N	\N	\N	22811	22811	22812
7528	6125	21	applied	\N	\N	\N	\N	22814	22814	22815
7528	6126	22	applied	\N	\N	\N	\N	22818	22818	22819
7528	6127	23	applied	\N	\N	\N	\N	22823	22823	22824
7528	6128	24	applied	\N	\N	\N	\N	22825	22825	22826
7528	6129	25	applied	\N	\N	\N	\N	22832	22832	22833
7528	6130	26	applied	\N	\N	\N	\N	22834	22834	22835
7528	6131	27	applied	\N	\N	\N	\N	22836	22836	22837
7528	6132	28	applied	\N	\N	\N	\N	22840	22840	22841
7528	6133	29	applied	\N	\N	\N	\N	22848	22848	22849
7528	6134	30	applied	\N	\N	\N	\N	22852	22852	22853
7528	6135	31	applied	\N	\N	\N	\N	22854	22854	22855
7528	6136	32	applied	\N	\N	\N	\N	22857	22857	22858
7528	6137	33	applied	\N	\N	\N	\N	22863	22863	22864
7528	6138	34	applied	\N	\N	\N	\N	22865	22865	22866
7528	6139	35	applied	\N	\N	\N	\N	22868	22868	22869
7528	6140	36	applied	\N	\N	\N	\N	22875	22875	22876
7528	6141	37	applied	\N	\N	\N	\N	22880	22880	22881
7528	6142	38	applied	\N	\N	\N	\N	22884	22884	22885
7528	6143	39	applied	\N	\N	\N	\N	22886	22886	22887
7528	6144	40	applied	\N	\N	\N	\N	22889	22889	22890
7528	6145	41	applied	\N	\N	\N	\N	22895	22895	22896
7528	6146	42	applied	\N	\N	\N	\N	22897	22897	22898
7528	6147	44	applied	\N	\N	\N	\N	22902	22902	22903
7528	6148	45	applied	\N	\N	\N	\N	22908	22908	22909
7528	6149	46	applied	\N	\N	\N	\N	22912	22912	22913
7528	6150	47	applied	\N	\N	\N	\N	22914	22914	22915
7528	6151	48	applied	\N	\N	\N	\N	22922	22922	22923
7528	6152	49	applied	\N	\N	\N	\N	22924	22924	22925
7528	6153	50	applied	\N	\N	\N	\N	22926	22926	22927
7528	6154	51	applied	\N	\N	\N	\N	22930	22930	22931
7528	6155	52	applied	\N	\N	\N	\N	22933	22933	22934
7528	6156	53	applied	\N	\N	\N	\N	22935	22935	22936
7528	6157	54	applied	\N	\N	\N	\N	22937	22937	22938
7528	6158	55	applied	\N	\N	\N	\N	22939	22939	22940
7528	6159	56	applied	\N	\N	\N	\N	22941	22941	22942
7528	6160	57	applied	\N	\N	\N	\N	22947	22947	22948
7528	6161	58	applied	\N	\N	\N	\N	22952	22952	22953
7528	6162	59	applied	\N	\N	\N	\N	22955	22955	22956
7528	6163	60	applied	\N	\N	\N	\N	22958	22958	22959
7528	6164	61	applied	\N	\N	\N	\N	22960	22960	22961
7528	6165	62	applied	\N	\N	\N	\N	22962	22962	22963
7528	6167	63	applied	\N	\N	\N	\N	22967	22967	22968
7528	6168	64	applied	\N	\N	\N	\N	22969	22969	22970
7528	6169	65	applied	\N	\N	\N	\N	22971	22971	22972
7528	6170	66	applied	\N	\N	\N	\N	22976	22976	22977
7528	6171	67	applied	\N	\N	\N	\N	22980	22980	22981
7528	6172	68	applied	\N	\N	\N	\N	22984	22984	22985
7528	6173	69	applied	\N	\N	\N	\N	22986	22986	22987
7528	6174	70	applied	\N	\N	\N	\N	22989	22989	22990
7528	6175	71	applied	\N	\N	\N	\N	22991	22991	22992
7528	6176	72	applied	\N	\N	\N	\N	22993	22993	22994
7528	6177	73	applied	\N	\N	\N	\N	22998	22998	22999
7528	6178	74	applied	\N	\N	\N	\N	23002	23002	23003
7528	6179	75	applied	\N	\N	\N	\N	23006	23006	23007
7528	6180	76	applied	\N	\N	\N	\N	23009	23009	23010
7528	6181	77	applied	\N	\N	\N	\N	23013	23013	23014
7528	6204	78	applied	\N	\N	\N	\N	23947	23947	23089
7528	6207	79	applied	\N	\N	\N	\N	23948	23948	23098
7528	6208	80	applied	\N	\N	\N	\N	23949	23949	23100
7528	6209	81	applied	\N	\N	\N	\N	23950	23950	23102
7528	6210	82	applied	\N	\N	\N	\N	23951	23951	23104
7528	6211	83	applied	\N	\N	\N	\N	23952	23952	23106
7528	6212	84	applied	\N	\N	\N	\N	23953	23953	23108
7528	6213	85	applied	\N	\N	\N	\N	23954	23954	23110
7528	6214	86	applied	\N	\N	\N	\N	23955	23955	23112
7528	6215	87	applied	\N	\N	\N	\N	23956	23956	23114
7528	6216	88	applied	\N	\N	\N	\N	23957	23957	23118
7528	6217	89	applied	\N	\N	\N	\N	23958	23958	23120
7528	6218	90	applied	\N	\N	\N	\N	23959	23959	23122
7528	6220	91	applied	\N	\N	\N	\N	23960	23960	23126
7528	6221	92	applied	\N	\N	\N	\N	23961	23961	23128
7528	6222	93	applied	\N	\N	\N	\N	23962	23962	23130
7528	6223	94	applied	\N	\N	\N	\N	23963	23963	23132
7528	6224	95	applied	\N	\N	\N	\N	23964	23964	23139
7528	6225	96	applied	\N	\N	\N	\N	23965	23965	23141
7528	6226	97	applied	\N	\N	\N	\N	23966	23966	23143
7528	6227	98	applied	\N	\N	\N	\N	23967	23967	23145
7528	6228	99	applied	\N	\N	\N	\N	23968	23968	23147
7528	6229	100	applied	\N	\N	\N	\N	23969	23969	23149
7528	6230	101	applied	\N	\N	\N	\N	23970	23970	23151
7528	6232	102	applied	\N	\N	\N	\N	23971	23971	23187
7528	6234	103	applied	\N	\N	\N	\N	23972	23972	23191
7528	6235	104	applied	\N	\N	\N	\N	23973	23973	23193
7528	6339	105	applied	\N	\N	\N	\N	23574	23574	23458
7528	6182	106	applied	\N	\N	\N	\N	23015	23015	23016
7528	6183	107	applied	\N	\N	\N	\N	23021	23021	23022
7528	6184	108	applied	\N	\N	\N	\N	23024	23024	23025
7528	6189	109	applied	\N	\N	\N	\N	23035	23035	23036
7528	6190	110	applied	\N	\N	\N	\N	23042	23042	23043
7528	6191	111	applied	\N	\N	\N	\N	23045	23045	23046
7528	6192	112	applied	\N	\N	\N	\N	23047	23047	23048
7528	6193	113	applied	\N	\N	\N	\N	23051	23051	23052
7528	6194	114	applied	\N	\N	\N	\N	23060	23060	23061
7528	6195	115	applied	\N	\N	\N	\N	23062	23062	23063
7528	6196	116	applied	\N	\N	\N	\N	23064	23064	23065
7528	6197	117	applied	\N	\N	\N	\N	23068	23068	23069
7528	6198	118	applied	\N	\N	\N	\N	23072	23072	23073
7528	6200	119	applied	\N	\N	\N	\N	23080	23080	23081
7528	6206	120	applied	\N	\N	\N	\N	23095	23095	23096
7528	6219	121	applied	\N	\N	\N	\N	23123	23123	23124
7528	6231	122	applied	\N	\N	\N	\N	23152	23152	23153
7528	6233	123	applied	\N	\N	\N	\N	23188	23188	23189
7528	6242	124	applied	\N	\N	\N	\N	23210	23210	23211
7528	6243	125	applied	\N	\N	\N	\N	23212	23212	23213
7530	6465	0	applied	\N	\N	\N	\N	24041	24041	24042
7530	6466	1	applied	\N	\N	\N	\N	24043	24043	24043
7532	6467	0	applied	\N	\N	\N	\N	24047	24047	24048
7537	6471	0	applied	\N	\N	\N	\N	24062	24062	24063
7542	6473	0	applied	\N	\N	\N	\N	24071	24071	24072
7545	6474	0	applied	\N	\N	\N	\N	24076	24076	24077
7545	6475	1	applied	\N	\N	\N	\N	24078	24078	24079
7547	6477	0	applied	\N	\N	\N	\N	24088	24088	24089
7547	6478	1	applied	\N	\N	\N	\N	24090	24090	24091
7549	6480	0	applied	\N	\N	\N	\N	24097	24097	24098
7552	6482	0	applied	\N	\N	\N	\N	24106	24106	24107
7552	6483	1	applied	\N	\N	\N	\N	24108	24108	24109
7554	6484	0	applied	\N	\N	\N	\N	24112	24112	24113
7559	6486	0	applied	\N	\N	\N	\N	24124	24124	24125
7561	6487	0	applied	\N	\N	\N	\N	24128	24128	24129
7566	6489	0	applied	\N	\N	\N	\N	24139	24139	24140
7570	6491	0	applied	\N	\N	\N	\N	24149	24149	24150
7573	6491	0	applied	\N	\N	\N	\N	24149	24149	24150
7579	6445	0	applied	\N	\N	\N	\N	23866	23866	23867
7579	6453	1	applied	\N	\N	\N	\N	23898	23898	19746
7579	6439	2	applied	\N	\N	\N	\N	23844	23844	23845
7579	6440	3	applied	\N	\N	\N	\N	23849	23849	23850
7579	6441	4	applied	\N	\N	\N	\N	23852	23852	23853
7579	6442	5	applied	\N	\N	\N	\N	23854	23854	23855
7579	6443	6	applied	\N	\N	\N	\N	23860	23860	23861
7579	6444	7	applied	\N	\N	\N	\N	23862	23862	23863
7579	6446	8	applied	\N	\N	\N	\N	23868	23868	23869
7579	6447	9	applied	\N	\N	\N	\N	23872	23872	23873
7579	6448	10	applied	\N	\N	\N	\N	23876	23876	23877
7579	6449	11	applied	\N	\N	\N	\N	23880	23880	23881
7579	6450	12	applied	\N	\N	\N	\N	23882	23882	23883
7579	6451	13	applied	\N	\N	\N	\N	23884	23884	23885
7579	6454	14	applied	\N	\N	\N	\N	23901	23901	23902
7579	6455	15	applied	\N	\N	\N	\N	23905	23905	23906
7579	6456	16	applied	\N	\N	\N	\N	23908	23908	23909
7579	6457	17	applied	\N	\N	\N	\N	23913	23913	23914
7579	6458	18	applied	\N	\N	\N	\N	23915	23915	23916
7579	6459	19	applied	\N	\N	\N	\N	23917	23917	23918
7579	6460	20	applied	\N	\N	\N	\N	23923	23923	23924
7579	6461	21	applied	\N	\N	\N	\N	23927	23927	23928
7579	6462	22	applied	\N	\N	\N	\N	23930	23930	23931
7579	6463	23	applied	\N	\N	\N	\N	23934	23934	23935
7579	6464	24	applied	\N	\N	\N	\N	23936	23936	23937
7579	6465	25	applied	\N	\N	\N	\N	24041	24041	24042
7579	6467	26	applied	\N	\N	\N	\N	24047	24047	24048
7579	6468	27	applied	\N	\N	\N	\N	24052	24052	24053
7579	6470	28	applied	\N	\N	\N	\N	24058	24058	24059
7579	6471	29	applied	\N	\N	\N	\N	24062	24062	24063
7579	6472	30	applied	\N	\N	\N	\N	24068	24068	24069
7579	6473	31	applied	\N	\N	\N	\N	24071	24071	24072
7579	6474	32	applied	\N	\N	\N	\N	24076	24076	24077
7579	6475	33	applied	\N	\N	\N	\N	24078	24078	24079
7579	6476	34	applied	\N	\N	\N	\N	24084	24084	24085
7579	6477	35	applied	\N	\N	\N	\N	24088	24088	24089
7579	6478	36	applied	\N	\N	\N	\N	24090	24090	24091
7579	6479	37	applied	\N	\N	\N	\N	24094	24094	24095
7579	6480	38	applied	\N	\N	\N	\N	24097	24097	24098
7579	6481	39	applied	\N	\N	\N	\N	24101	24101	24102
7579	6482	40	applied	\N	\N	\N	\N	24106	24106	24107
7579	6483	41	applied	\N	\N	\N	\N	24108	24108	24109
7579	6484	42	applied	\N	\N	\N	\N	24112	24112	24113
7579	6485	43	applied	\N	\N	\N	\N	24120	24120	24121
7579	6486	44	applied	\N	\N	\N	\N	24124	24124	24125
7579	6487	45	applied	\N	\N	\N	\N	24128	24128	24129
7579	6488	46	applied	\N	\N	\N	\N	24132	24132	24133
7579	6489	47	applied	\N	\N	\N	\N	24139	24139	24140
7579	6490	48	applied	\N	\N	\N	\N	24145	24145	24146
7579	6491	49	applied	\N	\N	\N	\N	24149	24149	24150
7579	6492	50	applied	\N	\N	\N	\N	24158	24158	24159
7579	6452	51	applied	\N	\N	\N	\N	23886	23886	23887
7579	6466	52	applied	\N	\N	\N	\N	24043	24043	24043
7529	6353	8	applied	\N	\N	\N	\N	23945	23945	13857
7529	6361	9	applied	\N	\N	1000000000	\N	23524	23524	23525
7529	6162	10	applied	\N	\N	\N	\N	22955	22955	22956
7529	6163	11	applied	\N	\N	\N	\N	22958	22958	22959
7529	6164	12	applied	\N	\N	\N	\N	22960	22960	22961
7529	6165	13	applied	\N	\N	\N	\N	22962	22962	22963
7529	6167	14	applied	\N	\N	\N	\N	22967	22967	22968
7529	6168	15	applied	\N	\N	\N	\N	22969	22969	22970
7529	6169	16	applied	\N	\N	\N	\N	22971	22971	22972
7529	6170	17	applied	\N	\N	\N	\N	22976	22976	22977
7529	6171	18	applied	\N	\N	\N	\N	22980	22980	22981
7529	6172	19	applied	\N	\N	\N	\N	22984	22984	22985
7529	6173	20	applied	\N	\N	\N	\N	22986	22986	22987
7529	6174	21	applied	\N	\N	\N	\N	22989	22989	22990
7529	6175	22	applied	\N	\N	\N	\N	22991	22991	22992
7529	6176	23	applied	\N	\N	\N	\N	22993	22993	22994
7529	6177	24	applied	\N	\N	\N	\N	22998	22998	22999
7529	6178	25	applied	\N	\N	\N	\N	23002	23002	23003
7529	6179	26	applied	\N	\N	\N	\N	23006	23006	23007
7529	6180	27	applied	\N	\N	\N	\N	23009	23009	23010
7529	6181	28	applied	\N	\N	\N	\N	23013	23013	23014
7529	6204	29	applied	\N	\N	\N	\N	23980	23980	23089
7529	6207	30	applied	\N	\N	\N	\N	23981	23981	23098
7529	6208	31	applied	\N	\N	\N	\N	23982	23982	23100
7529	6209	32	applied	\N	\N	\N	\N	23983	23983	23102
7529	6210	33	applied	\N	\N	\N	\N	23984	23984	23104
7529	6211	34	applied	\N	\N	\N	\N	23985	23985	23106
7529	6212	35	applied	\N	\N	\N	\N	23986	23986	23108
7529	6213	36	applied	\N	\N	\N	\N	23987	23987	23110
7529	6214	37	applied	\N	\N	\N	\N	23988	23988	23112
7529	6215	38	applied	\N	\N	\N	\N	23989	23989	23114
7529	6216	39	applied	\N	\N	\N	\N	23990	23990	23118
7529	6217	40	applied	\N	\N	\N	\N	23991	23991	23120
7529	6218	41	applied	\N	\N	\N	\N	23992	23992	23122
7529	6220	42	applied	\N	\N	\N	\N	23993	23993	23126
7529	6221	43	applied	\N	\N	\N	\N	23994	23994	23128
7529	6222	44	applied	\N	\N	\N	\N	23995	23995	23130
7529	6223	45	applied	\N	\N	\N	\N	23996	23996	23132
7529	6224	46	applied	\N	\N	\N	\N	23997	23997	23139
7529	6225	47	applied	\N	\N	\N	\N	23998	23998	23141
7529	6226	48	applied	\N	\N	\N	\N	23999	23999	23143
7529	6227	49	applied	\N	\N	\N	\N	24000	24000	23145
7529	6228	50	applied	\N	\N	\N	\N	24001	24001	23147
7529	6229	51	applied	\N	\N	\N	\N	24002	24002	23149
7529	6230	52	applied	\N	\N	\N	\N	24003	24003	23151
7529	6232	53	applied	\N	\N	\N	\N	24004	24004	23187
7529	6234	54	applied	\N	\N	\N	\N	24005	24005	23191
7529	6235	55	applied	\N	\N	\N	\N	24006	24006	23193
7529	6339	56	applied	\N	\N	\N	\N	23574	23574	23458
7529	6182	57	applied	\N	\N	\N	\N	23015	23015	23016
7529	6183	58	applied	\N	\N	\N	\N	23021	23021	23022
7529	6184	59	applied	\N	\N	\N	\N	23024	23024	23025
7529	6189	60	applied	\N	\N	\N	\N	23035	23035	23036
7529	6190	61	applied	\N	\N	\N	\N	23042	23042	23043
7529	6191	62	applied	\N	\N	\N	\N	23045	23045	23046
7529	6192	63	applied	\N	\N	\N	\N	23047	23047	23048
7529	6193	64	applied	\N	\N	\N	\N	23051	23051	23052
7529	6194	65	applied	\N	\N	\N	\N	23060	23060	23061
7529	6195	66	applied	\N	\N	\N	\N	23062	23062	23063
7529	6196	67	applied	\N	\N	\N	\N	23064	23064	23065
7529	6197	68	applied	\N	\N	\N	\N	23068	23068	23069
7529	6198	69	applied	\N	\N	\N	\N	23072	23072	23073
7529	6200	70	applied	\N	\N	\N	\N	23080	23080	23081
7529	6206	71	applied	\N	\N	\N	\N	23095	23095	23096
7529	6219	72	applied	\N	\N	\N	\N	23123	23123	23124
7529	6231	73	applied	\N	\N	\N	\N	23152	23152	23153
7529	6233	74	applied	\N	\N	\N	\N	23188	23188	23189
7529	6242	75	applied	\N	\N	\N	\N	23210	23210	23211
7529	6243	76	applied	\N	\N	\N	\N	23212	23212	23213
7529	6259	77	applied	\N	\N	\N	\N	23248	23248	23249
7529	6272	78	applied	\N	\N	\N	\N	23278	23278	23279
7529	6276	79	applied	\N	\N	\N	\N	23293	23293	23294
7529	6284	80	applied	\N	\N	\N	\N	23314	23314	23315
7529	6291	81	applied	\N	\N	\N	\N	23332	23332	23333
7529	6317	82	applied	\N	\N	\N	\N	23384	23384	23385
7529	6319	83	applied	\N	\N	\N	\N	23390	23390	23391
7529	6320	84	applied	\N	\N	\N	\N	23396	23396	23397
7529	6321	86	applied	\N	\N	\N	\N	23401	23401	23402
7529	6322	87	applied	\N	\N	\N	\N	23405	23405	23406
7529	6323	88	applied	\N	\N	\N	\N	23409	23409	23410
7529	6324	89	applied	\N	\N	\N	\N	23414	23414	23415
7529	6325	90	applied	\N	\N	\N	\N	23416	23416	23417
7529	6326	91	applied	\N	\N	\N	\N	23419	23419	23420
7529	6327	92	applied	\N	\N	\N	\N	23421	23421	23422
7529	6328	93	applied	\N	\N	\N	\N	23425	23425	23426
7529	6329	94	applied	\N	\N	\N	\N	23429	23429	23430
7529	6236	95	applied	\N	\N	\N	\N	24008	24008	23195
7529	6237	96	applied	\N	\N	\N	\N	24009	24009	23197
7529	6238	97	applied	\N	\N	\N	\N	24010	24010	23199
7529	6239	98	applied	\N	\N	\N	\N	24011	24011	23201
7529	6240	99	applied	\N	\N	\N	\N	24012	24012	23203
7529	6241	100	applied	\N	\N	\N	\N	24013	24013	23209
7529	6244	101	applied	\N	\N	\N	\N	24014	24014	23215
7529	6245	102	applied	\N	\N	\N	\N	24015	24015	23217
7529	6246	103	applied	\N	\N	\N	\N	24016	24016	23219
7529	6247	104	applied	\N	\N	\N	\N	24017	24017	23221
7529	6248	105	applied	\N	\N	\N	\N	24018	24018	23223
7529	6249	106	applied	\N	\N	\N	\N	24019	24019	23225
7529	6250	107	applied	\N	\N	\N	\N	24020	24020	23227
7529	6251	108	applied	\N	\N	\N	\N	24021	24021	23229
7529	6252	109	applied	\N	\N	\N	\N	24022	24022	23231
7529	6253	110	applied	\N	\N	\N	\N	24023	24023	23233
7529	6254	111	applied	\N	\N	\N	\N	24024	24024	23235
7529	6255	112	applied	\N	\N	\N	\N	24025	24025	23237
7529	6256	113	applied	\N	\N	\N	\N	24026	24026	23239
7529	6257	114	applied	\N	\N	\N	\N	24027	24027	23241
7529	6258	115	applied	\N	\N	\N	\N	24028	24028	23243
7529	6260	116	applied	\N	\N	\N	\N	24029	24029	23251
7529	6261	117	applied	\N	\N	\N	\N	24030	24030	23253
7529	6262	118	applied	\N	\N	\N	\N	24031	24031	23255
7529	6263	119	applied	\N	\N	\N	\N	24032	24032	23257
7529	6264	120	applied	\N	\N	\N	\N	24033	24033	23259
7529	6265	121	applied	\N	\N	\N	\N	24034	24034	23261
7529	6266	122	applied	\N	\N	\N	\N	24035	24035	23263
7529	6267	123	applied	\N	\N	\N	\N	24036	24036	23265
7529	6268	124	applied	\N	\N	\N	\N	24037	24037	23271
7529	6269	125	applied	\N	\N	\N	\N	24038	24038	23273
7531	6465	0	applied	\N	\N	\N	\N	24041	24041	24042
7531	6466	1	applied	\N	\N	\N	\N	24043	24043	24043
7539	6471	0	applied	\N	\N	\N	\N	24062	24062	24063
7540	6472	0	applied	\N	\N	\N	\N	24068	24068	24069
7543	6474	0	applied	\N	\N	\N	\N	24076	24076	24077
7543	6475	1	applied	\N	\N	\N	\N	24078	24078	24079
7548	6479	0	applied	\N	\N	\N	\N	24094	24094	24095
7551	6481	0	applied	\N	\N	\N	\N	24101	24101	24102
7553	6484	0	applied	\N	\N	\N	\N	24112	24112	24113
7560	6487	0	applied	\N	\N	\N	\N	24128	24128	24129
7562	6488	0	applied	\N	\N	\N	\N	24132	24132	24133
7564	6488	0	applied	\N	\N	\N	\N	24132	24132	24133
7567	6489	0	applied	\N	\N	\N	\N	24139	24139	24140
7569	6490	0	applied	\N	\N	\N	\N	24145	24145	24146
7575	6492	0	applied	\N	\N	\N	\N	24158	24158	24159
7577	6492	0	applied	\N	\N	\N	\N	24158	24158	24159
7584	6495	0	applied	\N	\N	\N	\N	24173	24173	24174
7585	6496	0	applied	\N	\N	\N	\N	24177	24177	24178
7585	6497	1	applied	\N	\N	\N	\N	24179	24179	24180
7585	6498	2	applied	\N	\N	\N	\N	24181	24181	24182
7585	6499	3	applied	\N	\N	\N	\N	24183	24183	24184
7587	6500	0	applied	\N	\N	\N	\N	24188	24188	24189
7589	6500	0	applied	\N	\N	\N	\N	24188	24188	24189
7592	6502	0	applied	\N	\N	1000000000	\N	24197	24197	24198
7579	6469	53	applied	\N	\N	\N	\N	24055	24055	24055
7594	6501	0	applied	\N	\N	\N	\N	24194	24194	24195
7594	6503	1	applied	\N	\N	\N	\N	24202	24202	24203
7594	6504	2	applied	\N	\N	\N	\N	24204	24204	24205
7594	6505	3	applied	\N	\N	\N	\N	24206	24206	24207
7594	6506	4	applied	\N	\N	\N	\N	24208	24208	24209
7594	6507	5	applied	\N	\N	1000000000	\N	24210	24210	24211
7594	6508	6	applied	\N	\N	1000000000	\N	24212	24212	24213
7596	6510	0	applied	\N	\N	\N	\N	24221	24221	24222
7598	6454	0	applied	\N	\N	\N	\N	23901	23901	23902
7598	6453	1	applied	\N	\N	\N	\N	23898	23898	19746
7598	6455	2	applied	\N	\N	\N	\N	23905	23905	23906
7598	6456	3	applied	\N	\N	\N	\N	23908	23908	23909
7598	6457	4	applied	\N	\N	\N	\N	23913	23913	23914
7598	6458	5	applied	\N	\N	\N	\N	23915	23915	23916
7598	6459	6	applied	\N	\N	\N	\N	23917	23917	23918
7598	6460	7	applied	\N	\N	\N	\N	23923	23923	23924
7598	6461	8	applied	\N	\N	\N	\N	23927	23927	23928
7598	6462	9	applied	\N	\N	\N	\N	23930	23930	23931
7598	6463	10	applied	\N	\N	\N	\N	23934	23934	23935
7598	6464	11	applied	\N	\N	\N	\N	23936	23936	23937
7598	6465	12	applied	\N	\N	\N	\N	24041	24041	24042
7598	6467	13	applied	\N	\N	\N	\N	24047	24047	24048
7598	6468	14	applied	\N	\N	\N	\N	24052	24052	24053
7598	6470	15	applied	\N	\N	\N	\N	24058	24058	24059
7598	6471	16	applied	\N	\N	\N	\N	24062	24062	24063
7598	6472	17	applied	\N	\N	\N	\N	24068	24068	24069
7598	6473	18	applied	\N	\N	\N	\N	24071	24071	24072
7598	6474	19	applied	\N	\N	\N	\N	24076	24076	24077
7598	6475	20	applied	\N	\N	\N	\N	24078	24078	24079
7598	6476	21	applied	\N	\N	\N	\N	24084	24084	24085
7598	6477	22	applied	\N	\N	\N	\N	24088	24088	24089
7598	6478	23	applied	\N	\N	\N	\N	24090	24090	24091
7598	6479	24	applied	\N	\N	\N	\N	24094	24094	24095
7598	6480	25	applied	\N	\N	\N	\N	24097	24097	24098
7598	6481	26	applied	\N	\N	\N	\N	24101	24101	24102
7598	6482	27	applied	\N	\N	\N	\N	24106	24106	24107
7598	6483	28	applied	\N	\N	\N	\N	24108	24108	24109
7598	6484	29	applied	\N	\N	\N	\N	24112	24112	24113
7598	6485	30	applied	\N	\N	\N	\N	24120	24120	24121
7598	6486	31	applied	\N	\N	\N	\N	24124	24124	24125
7598	6487	32	applied	\N	\N	\N	\N	24128	24128	24129
7598	6488	33	applied	\N	\N	\N	\N	24132	24132	24133
7598	6489	34	applied	\N	\N	\N	\N	24139	24139	24140
7598	6490	35	applied	\N	\N	\N	\N	24145	24145	24146
7598	6491	36	applied	\N	\N	\N	\N	24149	24149	24150
7598	6492	37	applied	\N	\N	\N	\N	24158	24158	24159
7598	6493	38	applied	\N	\N	\N	\N	24162	24162	24163
7598	6494	39	applied	\N	\N	\N	\N	24171	24171	24172
7598	6495	40	applied	\N	\N	\N	\N	24173	24173	24174
7598	6496	41	applied	\N	\N	\N	\N	24177	24177	24178
7598	6497	42	applied	\N	\N	\N	\N	24179	24179	24180
7598	6498	43	applied	\N	\N	\N	\N	24181	24181	24182
7598	6499	44	applied	\N	\N	\N	\N	24183	24183	24184
7598	6500	45	applied	\N	\N	\N	\N	24188	24188	24189
7598	6501	46	applied	\N	\N	\N	\N	24194	24194	24195
7598	6503	47	applied	\N	\N	\N	\N	24202	24202	24203
7598	6504	48	applied	\N	\N	\N	\N	24204	24204	24205
7598	6505	49	applied	\N	\N	\N	\N	24206	24206	24207
7598	6506	50	applied	\N	\N	\N	\N	24208	24208	24209
7598	6507	51	applied	\N	\N	1000000000	\N	24210	24210	24211
7598	6508	52	applied	\N	\N	1000000000	\N	24212	24212	24213
7598	6509	53	applied	\N	\N	\N	\N	24217	24217	24218
7598	6510	54	applied	\N	\N	\N	\N	24221	24221	24222
7598	6466	55	applied	\N	\N	\N	\N	24043	24043	24043
7598	6469	56	applied	\N	\N	\N	\N	24055	24055	24055
7599	6511	0	applied	\N	\N	\N	\N	24228	24228	24229
7600	6512	0	applied	\N	\N	\N	\N	24232	24232	24233
7600	6513	1	applied	\N	\N	\N	\N	24234	24234	24235
7601	6514	0	applied	\N	\N	\N	\N	24237	24237	19746
7601	6515	1	applied	\N	\N	\N	\N	24238	24238	24239
7601	6516	2	applied	\N	\N	\N	\N	24240	24240	24241
7601	6517	3	applied	\N	\N	1000000000	\N	24242	24242	24243
7601	6518	4	applied	\N	\N	\N	\N	24244	24244	24245
7602	6519	0	applied	\N	\N	\N	\N	24247	24247	24248
7603	6520	0	applied	\N	\N	\N	\N	24251	24251	24252
7604	6521	0	applied	\N	\N	\N	\N	24255	24255	24256
7605	6522	0	applied	\N	\N	\N	\N	24259	24259	24260
7606	6523	0	applied	\N	\N	\N	\N	24263	24263	24264
7608	6523	0	applied	\N	\N	\N	\N	24263	24263	24264
7610	6524	0	applied	\N	\N	1000000000	\N	24269	24269	24270
7611	6525	0	applied	\N	\N	\N	\N	24271	24271	24272
7611	6524	1	applied	\N	\N	1000000000	\N	24269	24269	24270
7611	6526	2	applied	\N	\N	\N	\N	24273	24273	24274
7612	6525	0	applied	\N	\N	\N	\N	24271	24271	24272
7612	6526	1	applied	\N	\N	\N	\N	24273	24273	24274
7612	6527	2	applied	\N	\N	\N	\N	24276	24276	24277
7613	6525	0	applied	\N	\N	\N	\N	24271	24271	24272
7613	6526	1	applied	\N	\N	\N	\N	24273	24273	24274
7613	6527	2	applied	\N	\N	\N	\N	24276	24276	24277
7614	6525	0	applied	\N	\N	\N	\N	24271	24271	24272
7614	6526	1	applied	\N	\N	\N	\N	24273	24273	24274
7614	6527	2	applied	\N	\N	\N	\N	24276	24276	24277
7615	6528	0	applied	\N	\N	\N	\N	24282	24282	24283
7615	6529	1	applied	\N	\N	\N	\N	24284	24284	24285
7616	6528	0	applied	\N	\N	\N	\N	24282	24282	24283
7616	6529	1	applied	\N	\N	\N	\N	24284	24284	24285
7618	6530	0	applied	\N	\N	\N	\N	24291	24291	24292
7619	6530	0	applied	\N	\N	\N	\N	24291	24291	24292
7621	6531	0	applied	\N	\N	\N	\N	24297	24297	24298
7621	6532	1	applied	\N	\N	\N	\N	24299	24299	24300
7621	6533	2	applied	\N	\N	\N	\N	24301	24301	24302
7622	6531	0	applied	\N	\N	\N	\N	24297	24297	24298
7622	6532	1	applied	\N	\N	\N	\N	24299	24299	24300
7622	6533	2	applied	\N	\N	\N	\N	24301	24301	24302
7623	6534	0	applied	\N	\N	\N	\N	24304	24304	24305
7623	6535	1	applied	\N	\N	\N	\N	24306	24306	24307
7623	6536	2	applied	\N	\N	\N	\N	24308	24308	24309
7623	6537	3	applied	\N	\N	\N	\N	24310	24310	24311
7624	6445	0	applied	\N	\N	\N	\N	23866	23866	23867
7624	6453	1	applied	\N	\N	\N	\N	23898	23898	19746
7624	6502	2	applied	\N	\N	1000000000	\N	24197	24197	24198
7624	6524	3	applied	\N	\N	1000000000	\N	24269	24269	24270
7624	6452	4	applied	\N	\N	\N	\N	23886	23886	23887
7624	6533	5	applied	\N	\N	\N	\N	24301	24301	24302
7625	6538	0	applied	\N	\N	\N	\N	24316	24316	24317
7625	6539	1	applied	\N	\N	\N	\N	24318	24318	24319
7626	6538	0	applied	\N	\N	\N	\N	24316	24316	24317
7626	6539	1	applied	\N	\N	\N	\N	24318	24318	24319
7627	6538	0	applied	\N	\N	\N	\N	24316	24316	24317
7627	6539	1	applied	\N	\N	\N	\N	24318	24318	24319
7635	6552	0	applied	\N	\N	\N	\N	24357	24357	24358
7638	6553	0	applied	\N	\N	\N	\N	24363	24363	24364
7640	6554	0	applied	\N	\N	\N	\N	24370	24370	24371
7640	6555	1	applied	\N	\N	\N	\N	24372	24372	24373
7640	6556	2	applied	\N	\N	1000000000	\N	24374	24374	24375
7640	6557	3	applied	\N	\N	\N	\N	24376	24376	24377
7640	6558	4	applied	\N	\N	\N	\N	24378	24378	24379
7640	6559	5	applied	\N	\N	\N	\N	24380	24380	24381
7640	6560	6	applied	\N	\N	\N	\N	24382	24382	24383
7640	6561	7	applied	\N	\N	\N	\N	24384	24384	24385
7640	6562	8	applied	\N	\N	\N	\N	10287	10287	24386
7644	6514	0	applied	\N	\N	\N	\N	24237	24237	19746
7644	6511	1	applied	\N	\N	\N	\N	24228	24228	24229
7644	6512	2	applied	\N	\N	\N	\N	24232	24232	24233
7644	6513	3	applied	\N	\N	\N	\N	24234	24234	24235
7644	6515	4	applied	\N	\N	\N	\N	24238	24238	24239
7644	6516	5	applied	\N	\N	\N	\N	24240	24240	24241
7644	6517	6	applied	\N	\N	1000000000	\N	24242	24242	24243
7644	6518	8	applied	\N	\N	\N	\N	24244	24244	24245
7644	6519	9	applied	\N	\N	\N	\N	24247	24247	24248
7644	6520	10	applied	\N	\N	\N	\N	24251	24251	24252
7644	6521	11	applied	\N	\N	\N	\N	24255	24255	24256
7644	6522	12	applied	\N	\N	\N	\N	24259	24259	24260
7644	6523	13	applied	\N	\N	\N	\N	24263	24263	24264
7644	6525	14	applied	\N	\N	\N	\N	24271	24271	24272
7644	6526	15	applied	\N	\N	\N	\N	24273	24273	24274
7644	6527	16	applied	\N	\N	\N	\N	24276	24276	24277
7644	6528	17	applied	\N	\N	\N	\N	24282	24282	24283
7644	6529	18	applied	\N	\N	\N	\N	24284	24284	24285
7644	6530	19	applied	\N	\N	\N	\N	24291	24291	24292
7644	6531	20	applied	\N	\N	\N	\N	24297	24297	24298
7644	6532	21	applied	\N	\N	\N	\N	24299	24299	24300
7644	6534	22	applied	\N	\N	\N	\N	24304	24304	24305
7644	6535	23	applied	\N	\N	\N	\N	24306	24306	24307
7644	6536	24	applied	\N	\N	\N	\N	24308	24308	24309
7644	6537	25	applied	\N	\N	\N	\N	24310	24310	24311
7644	6538	26	applied	\N	\N	\N	\N	24316	24316	24317
7644	6539	27	applied	\N	\N	\N	\N	24318	24318	24319
7644	6540	28	applied	\N	\N	\N	\N	24324	24324	24325
7644	6541	29	applied	\N	\N	\N	\N	24326	24326	24327
7644	6542	30	applied	\N	\N	\N	\N	24328	24328	24329
7644	6544	31	applied	\N	\N	\N	\N	24332	24332	24333
7644	6545	32	applied	\N	\N	\N	\N	24334	24334	24335
7644	6546	33	applied	\N	\N	\N	\N	24337	24337	24338
7644	6547	34	applied	\N	\N	\N	\N	24341	24341	24342
7644	6548	35	applied	\N	\N	\N	\N	24344	24344	24345
7644	6549	36	applied	\N	\N	\N	\N	24346	24346	24347
7644	6550	37	applied	\N	\N	\N	\N	24350	24350	24351
7644	6551	38	applied	\N	\N	\N	\N	24353	24353	24354
7644	6552	39	applied	\N	\N	\N	\N	24357	24357	24358
7644	6553	40	applied	\N	\N	\N	\N	24363	24363	24364
7644	6555	41	applied	\N	\N	\N	\N	24372	24372	24373
7644	6557	42	applied	\N	\N	\N	\N	24376	24376	24377
7644	6533	43	applied	\N	\N	\N	\N	24396	24396	24302
7647	6566	0	applied	\N	\N	\N	\N	24408	24408	24409
7655	6574	0	applied	\N	\N	\N	\N	24436	24436	24437
7655	6575	1	applied	\N	\N	\N	\N	24438	24438	24439
7660	6578	0	applied	\N	\N	\N	\N	24450	24450	24451
7665	6583	0	applied	\N	\N	\N	\N	24467	24467	1435
7665	6584	1	applied	\N	\N	\N	\N	24468	24468	1435
7665	6585	2	applied	\N	\N	\N	\N	24469	24469	1435
7668	6586	0	applied	\N	\N	\N	\N	24471	24471	24472
7668	6587	1	applied	\N	\N	\N	\N	24473	24473	24474
7674	6591	0	applied	\N	\N	\N	\N	24488	24488	24489
7674	6592	1	applied	\N	\N	\N	\N	24490	24490	24491
7674	6593	2	applied	\N	\N	1000000000	\N	24492	24492	24493
7674	6594	3	applied	\N	\N	\N	\N	24494	24494	24495
7674	6595	4	applied	\N	\N	\N	\N	24496	24496	24497
7677	6596	0	applied	\N	\N	\N	\N	24503	24503	24504
7677	6597	2	applied	\N	\N	\N	\N	24505	24505	24506
7677	6598	3	applied	\N	\N	\N	\N	24507	24507	24508
7677	6599	4	applied	\N	\N	\N	\N	24509	24509	24510
7685	6605	0	applied	\N	\N	\N	\N	24533	24533	24534
7685	6606	1	applied	\N	\N	\N	\N	24535	24535	24536
7688	6608	0	applied	\N	\N	\N	\N	24543	24543	24544
7693	6614	0	applied	\N	\N	\N	\N	24562	24562	24563
7693	6613	1	applied	\N	\N	\N	\N	24559	24559	24560
7693	6615	2	applied	\N	\N	\N	\N	24564	24564	24565
7702	6620	0	applied	\N	\N	\N	\N	24582	24582	24583
7716	6627	0	applied	\N	\N	\N	\N	24609	24609	24610
7719	6628	0	applied	\N	\N	\N	\N	24613	24613	24614
7723	6629	0	applied	\N	\N	\N	\N	24621	24621	24622
7725	6632	0	applied	\N	\N	\N	\N	24632	24632	24633
7729	6636	0	applied	\N	\N	1000000000	\N	24645	24645	24646
7729	6637	1	applied	\N	\N	\N	\N	24647	24647	24648
7729	6638	2	applied	\N	\N	\N	\N	24649	24649	24650
7731	6639	0	applied	\N	\N	\N	\N	24653	24653	24654
7734	6644	0	applied	\N	\N	\N	\N	24666	24666	24667
7741	6649	0	applied	\N	\N	\N	\N	24686	24686	24687
7751	6657	0	applied	\N	\N	\N	\N	24717	24717	24718
7758	6660	0	applied	\N	\N	\N	\N	24732	24732	24733
7760	6659	0	applied	\N	\N	\N	\N	24730	24730	24731
7760	6660	1	applied	\N	\N	\N	\N	24732	24732	24733
7763	6664	0	applied	\N	\N	\N	\N	24747	24747	24748
7769	6671	0	applied	\N	\N	\N	\N	24770	24770	24771
7772	6672	0	applied	\N	\N	\N	\N	24774	24774	24775
7773	6673	0	applied	\N	\N	\N	\N	24780	24780	24781
7776	6674	0	applied	\N	\N	\N	\N	24784	24784	24785
7778	6675	0	applied	\N	\N	\N	\N	24789	24789	24790
7782	6677	0	applied	\N	\N	\N	\N	24798	24798	24799
7785	6678	0	applied	\N	\N	\N	\N	24802	24802	24803
7785	6679	1	applied	\N	\N	\N	\N	24804	24804	24805
7788	6683	0	applied	\N	\N	\N	\N	24818	24818	24819
7790	6687	0	applied	\N	\N	\N	\N	24830	24830	24831
7792	6688	0	applied	\N	\N	\N	\N	24834	24834	24835
7795	6688	0	applied	\N	\N	\N	\N	24834	24834	24835
7799	6691	0	applied	\N	\N	\N	\N	24849	24849	24850
7799	6692	1	applied	\N	\N	\N	\N	24851	24851	24852
7804	6695	0	applied	\N	\N	\N	\N	24866	24866	24867
7806	6696	0	applied	\N	\N	\N	\N	24872	24872	24873
7809	6696	0	applied	\N	\N	\N	\N	24872	24872	24873
7811	6697	0	applied	\N	\N	\N	\N	24881	24881	24882
7811	6698	1	applied	\N	\N	\N	\N	24883	24883	24884
7816	6700	0	applied	\N	\N	\N	\N	24894	24894	24895
7821	6706	0	applied	\N	\N	\N	\N	24918	24918	24919
7821	6707	1	applied	\N	\N	\N	\N	24920	24920	24921
7823	6708	0	applied	\N	\N	\N	\N	24923	24923	24924
7629	6540	0	applied	\N	\N	\N	\N	24324	24324	24325
7629	6541	1	applied	\N	\N	\N	\N	24326	24326	24327
7629	6542	2	applied	\N	\N	\N	\N	24328	24328	24329
7629	6543	3	applied	\N	\N	1000000000	\N	24330	24330	24331
7629	6544	4	applied	\N	\N	\N	\N	24332	24332	24333
7629	6545	5	applied	\N	\N	\N	\N	24334	24334	24335
7632	6548	0	applied	\N	\N	\N	\N	24344	24344	24345
7632	6549	1	applied	\N	\N	\N	\N	24346	24346	24347
7637	6553	0	applied	\N	\N	\N	\N	24363	24363	24364
7643	6554	0	applied	\N	\N	\N	\N	24370	24370	24371
7643	6555	1	applied	\N	\N	\N	\N	24372	24372	24373
7643	6556	2	applied	\N	\N	1000000000	\N	24374	24374	24375
7643	6557	3	applied	\N	\N	\N	\N	24376	24376	24377
7643	6558	4	applied	\N	\N	\N	\N	24378	24378	24379
7643	6559	5	applied	\N	\N	\N	\N	24380	24380	24381
7643	6560	6	applied	\N	\N	\N	\N	24382	24382	24383
7643	6561	7	applied	\N	\N	\N	\N	24384	24384	24385
7643	6562	8	applied	\N	\N	\N	\N	10287	10287	24386
7646	6564	0	applied	\N	\N	\N	\N	24403	24403	24404
7646	6565	1	applied	\N	\N	\N	\N	24405	24405	24406
7649	6567	0	applied	\N	\N	\N	\N	24412	24412	24413
7649	6568	1	applied	\N	\N	\N	\N	24414	24414	24415
7652	6569	0	applied	\N	\N	\N	\N	24420	24420	24421
7652	6570	1	applied	\N	\N	\N	\N	24422	24422	24423
7652	6571	2	applied	\N	\N	1000000000	\N	24426	24426	24427
7659	6577	0	applied	\N	\N	\N	\N	24448	24448	24449
7664	6581	0	applied	\N	\N	1000000000	\N	24462	24462	24463
7664	6579	1	applied	\N	\N	\N	\N	24453	24453	24454
7664	6580	2	applied	\N	\N	\N	\N	24455	24455	24456
7664	6582	3	applied	\N	\N	\N	\N	24464	24464	24465
7667	6586	0	applied	\N	\N	\N	\N	24471	24471	24472
7667	6587	1	applied	\N	\N	\N	\N	24473	24473	24474
7671	6588	0	applied	\N	\N	\N	\N	24478	24478	24479
7680	6601	0	applied	\N	\N	\N	\N	24517	24517	24518
7682	6602	0	applied	\N	\N	\N	\N	24522	24522	24523
7687	6608	0	applied	\N	\N	\N	\N	24543	24543	24544
7690	6612	0	applied	\N	\N	\N	\N	24556	24556	24557
7695	6616	0	applied	\N	\N	\N	\N	24568	24568	24569
7697	6617	0	applied	\N	\N	\N	\N	24571	24571	24572
7700	6618	0	applied	\N	\N	\N	\N	24575	24575	24576
7705	6620	0	applied	\N	\N	\N	\N	24582	24582	24583
7706	6621	0	applied	\N	\N	\N	\N	24586	24586	24587
7709	6622	0	applied	\N	\N	\N	\N	24589	24589	24590
7709	6623	1	applied	\N	\N	\N	\N	24591	24591	24592
7711	6624	0	applied	\N	\N	\N	\N	24596	24596	24597
7713	6625	0	applied	\N	\N	\N	\N	24601	24601	24602
7718	6628	0	applied	\N	\N	\N	\N	24613	24613	24614
7722	6629	0	applied	\N	\N	\N	\N	24621	24621	24622
7730	6639	0	applied	\N	\N	\N	\N	24653	24653	24654
7733	6641	0	applied	\N	\N	\N	\N	24659	24659	24660
7733	6642	1	applied	\N	\N	\N	\N	24661	24661	24662
7733	6643	2	applied	\N	\N	\N	\N	24663	24663	24664
7738	6646	0	applied	\N	\N	\N	\N	24675	24675	24676
7738	6647	1	applied	\N	\N	\N	\N	24677	24677	24678
7746	6650	0	applied	\N	\N	\N	\N	24693	24693	24694
7746	6651	1	applied	\N	\N	\N	\N	24695	24695	24696
7746	6652	2	applied	\N	\N	\N	\N	24697	24697	24698
7748	6653	0	applied	\N	\N	\N	\N	24701	24701	24702
7762	6661	0	applied	\N	\N	\N	\N	24739	24739	24740
7762	6662	1	applied	\N	\N	\N	\N	24741	24741	24742
7762	6663	2	applied	\N	\N	\N	\N	24743	24743	24744
7765	6664	0	applied	\N	\N	\N	\N	24747	24747	24748
7768	6668	0	applied	\N	\N	\N	\N	24763	24763	24764
7768	6669	1	applied	\N	\N	\N	\N	24765	24765	24766
7768	6670	2	applied	\N	\N	\N	\N	24767	24767	24768
7771	6672	0	applied	\N	\N	\N	\N	24774	24774	24775
7775	6674	0	applied	\N	\N	\N	\N	24784	24784	24785
7777	6675	0	applied	\N	\N	\N	\N	24789	24789	24790
7784	6678	0	applied	\N	\N	\N	\N	24802	24802	24803
7784	6679	1	applied	\N	\N	\N	\N	24804	24804	24805
7787	6683	0	applied	\N	\N	\N	\N	24818	24818	24819
7789	6684	0	applied	\N	\N	\N	\N	24822	24822	24823
7789	6685	1	applied	\N	\N	1000000000	\N	24824	24824	24825
7789	6686	2	applied	\N	\N	1000000000	\N	24826	24826	24827
7796	6689	0	applied	\N	\N	\N	\N	24841	24841	24842
7803	6694	0	applied	\N	\N	\N	\N	24862	24862	24863
7810	6697	0	applied	\N	\N	\N	\N	24881	24881	24882
7810	6698	1	applied	\N	\N	\N	\N	24883	24883	24884
7813	6699	0	applied	\N	\N	\N	\N	24888	24888	24889
7815	6700	0	applied	\N	\N	\N	\N	24894	24894	24895
7817	6701	0	applied	\N	\N	\N	\N	24902	24902	24903
7820	6702	0	applied	\N	\N	\N	\N	24905	24905	24906
7820	6703	1	applied	\N	\N	\N	\N	24907	24907	24908
7820	6704	2	applied	\N	\N	\N	\N	24909	24909	24910
7820	6705	3	applied	\N	\N	\N	\N	24911	24911	24912
7824	6708	0	applied	\N	\N	\N	\N	24923	24923	24924
7826	6710	0	applied	\N	\N	\N	\N	24931	24931	24932
7829	6712	0	applied	\N	\N	\N	\N	24941	24941	24942
7833	6713	0	applied	\N	\N	\N	\N	24946	24946	24947
7837	6714	0	applied	\N	\N	\N	\N	24950	24950	24951
7841	6716	0	applied	\N	\N	1000000000	\N	24963	24963	24964
7841	6717	1	applied	\N	\N	\N	\N	24965	24965	24966
7841	6718	2	applied	\N	\N	\N	\N	24967	24967	24968
7841	6719	3	applied	\N	\N	\N	\N	24969	24969	24970
7841	6720	4	applied	\N	\N	\N	\N	24971	24971	24972
7841	6721	5	applied	\N	\N	\N	\N	24973	24973	24974
7843	6722	0	applied	\N	\N	\N	\N	24978	24978	24979
7846	6725	0	applied	\N	\N	\N	\N	24986	24986	24987
7848	6725	0	applied	\N	\N	\N	\N	24986	24986	24987
7851	6728	0	applied	\N	\N	\N	\N	24994	24994	24995
7854	6733	0	applied	\N	\N	\N	\N	25010	25010	25011
7856	6734	0	applied	\N	\N	\N	\N	25016	25016	25017
7861	6737	0	applied	\N	\N	\N	\N	25026	25026	25027
7867	6738	0	applied	\N	\N	\N	\N	25035	25035	25036
7871	6740	0	applied	\N	\N	\N	\N	25043	25043	25044
7871	6741	1	applied	\N	\N	\N	\N	25045	25045	25046
7874	6742	0	applied	\N	\N	\N	\N	25052	25052	25053
7880	6748	0	applied	\N	\N	\N	\N	25070	25070	25071
7882	6749	0	applied	\N	\N	\N	\N	25072	25072	25073
7882	6750	1	applied	\N	\N	\N	\N	25074	25074	25075
7884	6751	0	applied	\N	\N	\N	\N	25076	25076	25077
7889	6755	0	applied	\N	\N	\N	\N	25091	25091	25092
7896	6758	0	applied	\N	\N	\N	\N	25105	25105	25106
7907	6764	0	applied	\N	\N	\N	\N	25132	25132	25133
7912	6768	0	applied	\N	\N	\N	\N	25146	25146	25147
7915	6771	0	applied	\N	\N	\N	\N	25156	25156	25157
7918	6773	0	applied	\N	\N	\N	\N	25166	25166	25167
7918	6774	1	applied	\N	\N	\N	\N	25168	25168	25169
7918	6775	2	applied	\N	\N	\N	\N	25170	25170	25171
7630	6546	0	applied	\N	\N	\N	\N	24337	24337	24338
7633	6550	0	applied	\N	\N	\N	\N	24350	24350	24351
7636	6552	0	applied	\N	\N	\N	\N	24357	24357	24358
7639	6553	0	applied	\N	\N	\N	\N	24363	24363	24364
7641	6556	0	applied	\N	\N	1000000000	\N	24374	24374	24375
7648	6567	0	applied	\N	\N	\N	\N	24412	24412	24413
7648	6568	1	applied	\N	\N	\N	\N	24414	24414	24415
7653	6572	0	applied	\N	\N	\N	\N	24429	24429	24430
7653	6573	1	applied	\N	\N	\N	\N	24431	24431	24432
7656	6576	0	applied	\N	\N	\N	\N	24442	24442	24443
7661	6579	0	applied	\N	\N	\N	\N	24453	24453	24454
7661	6580	1	applied	\N	\N	\N	\N	24455	24455	24456
7663	6579	0	applied	\N	\N	\N	\N	24453	24453	24454
7663	6580	1	applied	\N	\N	\N	\N	24455	24455	24456
7670	6588	0	applied	\N	\N	\N	\N	24478	24478	24479
7672	6589	0	applied	\N	\N	\N	\N	24484	24484	24485
7675	6591	0	applied	\N	\N	\N	\N	24488	24488	24489
7675	6592	1	applied	\N	\N	\N	\N	24490	24490	24491
7675	6593	2	applied	\N	\N	1000000000	\N	24492	24492	24493
7675	6594	3	applied	\N	\N	\N	\N	24494	24494	24495
7675	6595	4	applied	\N	\N	\N	\N	24496	24496	24497
7678	6600	0	applied	\N	\N	\N	\N	24513	24513	24514
7683	6602	0	applied	\N	\N	\N	\N	24522	24522	24523
7683	6603	1	applied	\N	\N	\N	\N	24526	24526	24527
7683	6604	2	applied	\N	\N	\N	\N	24528	24528	24529
7696	6617	0	applied	\N	\N	\N	\N	24571	24571	24572
7698	6618	0	applied	\N	\N	\N	\N	24575	24575	24576
7703	6620	0	applied	\N	\N	\N	\N	24582	24582	24583
7707	6619	0	applied	\N	\N	\N	\N	24580	24580	24581
7707	6620	1	applied	\N	\N	\N	\N	24582	24582	24583
7707	6621	2	applied	\N	\N	\N	\N	24586	24586	24587
7712	6624	0	applied	\N	\N	\N	\N	24596	24596	24597
7714	6626	0	applied	\N	\N	\N	\N	24605	24605	24606
7720	6628	0	applied	\N	\N	\N	\N	24613	24613	24614
7726	6633	0	applied	\N	\N	\N	\N	24634	24634	24635
7735	6644	0	applied	\N	\N	\N	\N	24666	24666	24667
7742	6649	0	applied	\N	\N	\N	\N	24686	24686	24687
7749	6654	0	applied	\N	\N	\N	\N	24707	24707	24708
7752	6657	0	applied	\N	\N	\N	\N	24717	24717	24718
7754	6657	0	applied	\N	\N	\N	\N	24717	24717	24718
7756	6658	0	applied	\N	\N	\N	\N	24728	24728	24729
7759	6660	0	applied	\N	\N	\N	\N	24732	24732	24733
7764	6664	0	applied	\N	\N	\N	\N	24747	24747	24748
7779	6675	0	applied	\N	\N	\N	\N	24789	24789	24790
7791	6687	0	applied	\N	\N	\N	\N	24830	24830	24831
7793	6688	0	applied	\N	\N	\N	\N	24834	24834	24835
7797	6690	0	applied	\N	\N	\N	\N	24845	24845	24846
7800	6693	0	applied	\N	\N	\N	\N	24854	24854	24855
7802	6693	0	applied	\N	\N	\N	\N	24854	24854	24855
7805	6695	0	applied	\N	\N	\N	\N	24866	24866	24867
7807	6696	0	applied	\N	\N	\N	\N	24872	24872	24873
7819	6702	0	applied	\N	\N	\N	\N	24905	24905	24906
7819	6703	1	applied	\N	\N	\N	\N	24907	24907	24908
7819	6704	2	applied	\N	\N	\N	\N	24909	24909	24910
7819	6705	3	applied	\N	\N	\N	\N	24911	24911	24912
7825	6709	0	applied	\N	\N	\N	\N	24927	24927	24928
7831	6712	0	applied	\N	\N	\N	\N	24941	24941	24942
7835	6714	0	applied	\N	\N	\N	\N	24950	24950	24951
7855	6733	0	applied	\N	\N	\N	\N	25010	25010	25011
7858	6735	0	applied	\N	\N	\N	\N	25018	25018	25019
7860	6736	0	applied	\N	\N	\N	\N	25022	25022	25023
7862	6737	0	applied	\N	\N	\N	\N	25026	25026	25027
7865	6737	0	applied	\N	\N	\N	\N	25026	25026	25027
7869	6740	0	applied	\N	\N	\N	\N	25043	25043	25044
7869	6741	1	applied	\N	\N	\N	\N	25045	25045	25046
7872	6740	0	applied	\N	\N	\N	\N	25043	25043	25044
7872	6741	1	applied	\N	\N	\N	\N	25045	25045	25046
7873	6742	0	applied	\N	\N	\N	\N	25052	25052	25053
7876	6743	0	applied	\N	\N	\N	\N	25056	25056	25057
7876	6744	1	applied	\N	\N	\N	\N	25058	25058	25059
7878	6745	0	applied	\N	\N	\N	\N	25062	25062	25063
7878	6746	1	applied	\N	\N	\N	\N	25064	25064	25065
7878	6747	2	applied	\N	\N	1000000000	\N	25066	25066	25067
7883	6751	0	applied	\N	\N	\N	\N	25076	25076	25077
7888	6754	0	applied	\N	\N	\N	\N	25089	25089	25090
7891	6756	0	applied	\N	\N	\N	\N	25095	25095	25096
7893	6756	0	applied	\N	\N	\N	\N	25095	25095	25096
7895	6757	0	applied	\N	\N	\N	\N	25103	25103	25104
7898	6758	0	applied	\N	\N	\N	\N	25105	25105	25106
7900	6759	0	applied	\N	\N	\N	\N	25109	25109	25110
7900	6760	1	applied	\N	\N	\N	\N	25111	25111	25112
7904	6761	0	applied	\N	\N	\N	\N	25118	25118	25119
7904	6762	1	applied	\N	\N	\N	\N	25120	25120	25066
7906	6763	0	applied	\N	\N	\N	\N	25128	25128	25129
7909	6765	0	applied	\N	\N	\N	\N	25136	25136	25137
7911	6767	0	applied	\N	\N	\N	\N	25144	25144	25145
7914	6769	0	applied	\N	\N	\N	\N	25150	25150	25151
7914	6770	1	applied	\N	\N	\N	\N	25152	25152	25153
7916	6772	0	applied	\N	\N	\N	\N	25160	25160	25161
7922	6778	0	applied	\N	\N	\N	\N	25182	25182	25183
7922	6779	1	applied	\N	\N	\N	\N	25184	25184	25185
7925	6783	0	applied	\N	\N	\N	\N	25195	25195	25196
7930	6787	0	applied	\N	\N	\N	\N	25208	25208	25209
7933	6784	0	applied	\N	\N	\N	\N	25199	25199	25200
7933	6785	1	applied	\N	\N	\N	\N	25201	25201	25202
7933	6786	2	applied	\N	\N	\N	\N	25204	25204	25205
7933	6787	3	applied	\N	\N	\N	\N	25208	25208	25209
7934	6788	0	applied	\N	\N	\N	\N	25217	25217	25218
7942	6791	0	applied	\N	\N	\N	\N	25227	25227	25228
7943	6792	0	applied	\N	\N	\N	\N	25234	25234	25235
7947	6793	0	applied	\N	\N	\N	\N	25240	25240	25241
7952	6796	0	applied	\N	\N	\N	\N	25255	25255	25256
7954	6797	0	applied	\N	\N	\N	\N	25259	25259	25260
7957	6801	0	applied	\N	\N	\N	\N	25271	25271	25272
7963	6808	0	applied	\N	\N	\N	\N	25293	25293	25294
7972	6814	0	applied	\N	\N	\N	\N	25315	25315	25316
7976	6821	0	applied	\N	\N	\N	\N	25335	25335	25336
7978	6822	0	applied	\N	\N	\N	\N	25341	25341	25342
7981	6823	0	applied	\N	\N	\N	\N	25347	25347	25348
7981	6824	1	applied	\N	\N	\N	\N	25349	25349	25350
7981	6825	2	applied	\N	\N	\N	\N	25351	25351	25352
7983	6826	0	applied	\N	\N	\N	\N	25359	25359	25360
7987	6836	0	applied	\N	\N	\N	\N	25384	25384	25385
7987	6837	1	applied	\N	\N	\N	\N	25386	25386	25387
7987	6838	2	applied	\N	\N	\N	\N	25388	25388	25389
7990	6839	0	applied	\N	\N	\N	\N	25392	25392	25393
7990	6840	1	applied	\N	\N	\N	\N	25394	25394	25395
7992	6842	0	applied	\N	\N	\N	\N	25401	25401	25402
7995	6845	0	applied	\N	\N	\N	\N	25411	25411	25412
7631	6547	0	applied	\N	\N	\N	\N	24341	24341	24342
7634	6551	0	applied	\N	\N	\N	\N	24353	24353	24354
7642	6554	0	applied	\N	\N	\N	\N	24370	24370	24371
7642	6555	1	applied	\N	\N	\N	\N	24372	24372	24373
7642	6556	2	applied	\N	\N	1000000000	\N	24374	24374	24375
7642	6557	3	applied	\N	\N	\N	\N	24376	24376	24377
7642	6558	4	applied	\N	\N	\N	\N	24378	24378	24379
7642	6559	5	applied	\N	\N	\N	\N	24380	24380	24381
7642	6560	6	applied	\N	\N	\N	\N	24382	24382	24383
7642	6561	7	applied	\N	\N	\N	\N	24384	24384	24385
7642	6562	8	applied	\N	\N	\N	\N	10287	10287	24386
7645	6563	0	applied	\N	\N	\N	\N	24399	24399	24400
7651	6563	0	applied	\N	\N	\N	\N	24399	24399	24400
7651	6564	1	applied	\N	\N	\N	\N	24403	24403	24404
7651	6565	2	applied	\N	\N	\N	\N	24405	24405	24406
7651	6566	3	applied	\N	\N	\N	\N	24408	24408	24409
7651	6567	4	applied	\N	\N	\N	\N	24412	24412	24413
7651	6568	5	applied	\N	\N	\N	\N	24414	24414	24415
7651	6569	6	applied	\N	\N	\N	\N	24420	24420	24421
7651	6570	7	applied	\N	\N	\N	\N	24422	24422	24423
7654	6572	0	applied	\N	\N	\N	\N	24429	24429	24430
7654	6573	1	applied	\N	\N	\N	\N	24431	24431	24432
7657	6576	0	applied	\N	\N	\N	\N	24442	24442	24443
7666	6586	0	applied	\N	\N	\N	\N	24471	24471	24472
7666	6587	1	applied	\N	\N	\N	\N	24473	24473	24474
7669	6586	0	applied	\N	\N	\N	\N	24471	24471	24472
7669	6587	1	applied	\N	\N	\N	\N	24473	24473	24474
7673	6590	0	applied	\N	\N	\N	\N	24486	24486	24487
7679	6601	0	applied	\N	\N	\N	\N	24517	24517	24518
7684	6602	0	applied	\N	\N	\N	\N	24522	24522	24523
7684	6603	1	applied	\N	\N	\N	\N	24526	24526	24527
7684	6604	2	applied	\N	\N	\N	\N	24528	24528	24529
7686	6607	0	applied	\N	\N	\N	\N	24539	24539	24540
7689	6609	0	applied	\N	\N	\N	\N	24548	24548	24549
7689	6610	1	applied	\N	\N	\N	\N	24550	24550	24551
7689	6611	2	applied	\N	\N	\N	\N	24552	24552	24553
7692	6613	0	applied	\N	\N	\N	\N	24559	24559	24560
7694	6616	0	applied	\N	\N	\N	\N	24568	24568	24569
7699	6618	0	applied	\N	\N	\N	\N	24575	24575	24576
7701	6619	0	applied	\N	\N	\N	\N	24580	24580	24581
7704	6620	0	applied	\N	\N	\N	\N	24582	24582	24583
7708	6622	0	applied	\N	\N	\N	\N	24589	24589	24590
7708	6623	1	applied	\N	\N	\N	\N	24591	24591	24592
7710	6624	0	applied	\N	\N	\N	\N	24596	24596	24597
7715	6626	0	applied	\N	\N	\N	\N	24605	24605	24606
7717	6628	0	applied	\N	\N	\N	\N	24613	24613	24614
7721	6628	0	applied	\N	\N	\N	\N	24613	24613	24614
7724	6630	0	applied	\N	\N	\N	\N	24627	24627	24628
7724	6631	1	applied	\N	\N	\N	\N	24629	24629	24630
7727	6634	0	applied	\N	\N	\N	\N	24638	24638	24639
7727	6635	1	applied	\N	\N	\N	\N	24640	24640	24641
7732	6640	0	applied	\N	\N	\N	\N	24657	24657	24658
7736	6626	0	applied	\N	\N	\N	\N	24605	24605	24606
7736	6627	1	applied	\N	\N	\N	\N	24609	24609	24610
7736	6628	2	applied	\N	\N	\N	\N	24613	24613	24614
7736	6629	3	applied	\N	\N	\N	\N	24621	24621	24622
7736	6630	4	applied	\N	\N	\N	\N	24627	24627	24628
7736	6631	5	applied	\N	\N	\N	\N	24629	24629	24630
7736	6632	6	applied	\N	\N	\N	\N	24632	24632	24633
7736	6633	7	applied	\N	\N	\N	\N	24634	24634	24635
7736	6634	8	applied	\N	\N	\N	\N	24638	24638	24639
7736	6635	9	applied	\N	\N	\N	\N	24640	24640	24641
7736	6636	10	applied	\N	\N	1000000000	\N	24645	24645	24646
7736	6637	11	applied	\N	\N	\N	\N	24647	24647	24648
7736	6638	12	applied	\N	\N	\N	\N	24649	24649	24650
7736	6639	13	applied	\N	\N	\N	\N	24653	24653	24654
7736	6640	14	applied	\N	\N	\N	\N	24657	24657	24658
7736	6641	15	applied	\N	\N	\N	\N	24659	24659	24660
7736	6642	16	applied	\N	\N	\N	\N	24661	24661	24662
7736	6643	17	applied	\N	\N	\N	\N	24663	24663	24664
7736	6644	18	applied	\N	\N	\N	\N	24666	24666	24667
7737	6645	0	applied	\N	\N	\N	\N	24671	24671	24672
7740	6648	0	applied	\N	\N	\N	\N	24682	24682	24683
7745	6650	0	applied	\N	\N	\N	\N	24693	24693	24694
7745	6651	1	applied	\N	\N	\N	\N	24695	24695	24696
7745	6652	2	applied	\N	\N	\N	\N	24697	24697	24698
7747	6653	0	applied	\N	\N	\N	\N	24701	24701	24702
7750	6655	0	applied	\N	\N	\N	\N	24711	24711	24712
7750	6656	1	applied	\N	\N	\N	\N	24713	24713	24714
7753	6657	0	applied	\N	\N	\N	\N	24717	24717	24718
7755	6657	0	applied	\N	\N	\N	\N	24717	24717	24718
7757	6659	0	applied	\N	\N	\N	\N	24730	24730	24731
7767	6665	0	applied	\N	\N	\N	\N	24755	24755	24756
7767	6666	1	applied	\N	\N	\N	\N	24757	24757	24758
7767	6667	2	applied	\N	\N	\N	\N	24759	24759	24760
7770	6672	0	applied	\N	\N	\N	\N	24774	24774	24775
7774	6673	0	applied	\N	\N	\N	\N	24780	24780	24781
7781	6676	0	applied	\N	\N	\N	\N	24794	24794	24795
7783	6677	0	applied	\N	\N	\N	\N	24798	24798	24799
7786	6680	0	applied	\N	\N	\N	\N	24810	24810	24811
7786	6681	1	applied	\N	\N	\N	\N	24812	24812	24813
7786	6682	2	applied	\N	\N	\N	\N	24814	24814	24815
7794	6688	0	applied	\N	\N	\N	\N	24834	24834	24835
7798	6690	0	applied	\N	\N	\N	\N	24845	24845	24846
7801	6693	0	applied	\N	\N	\N	\N	24854	24854	24855
7808	6696	0	applied	\N	\N	\N	\N	24872	24872	24873
7812	6699	0	applied	\N	\N	\N	\N	24888	24888	24889
7814	6700	0	applied	\N	\N	\N	\N	24894	24894	24895
7822	6706	0	applied	\N	\N	\N	\N	24918	24918	24919
7822	6707	1	applied	\N	\N	\N	\N	24920	24920	24921
7827	6710	0	applied	\N	\N	\N	\N	24931	24931	24932
7830	6712	0	applied	\N	\N	\N	\N	24941	24941	24942
7834	6714	0	applied	\N	\N	\N	\N	24950	24950	24951
7838	6715	0	applied	\N	\N	\N	\N	24956	24956	24957
7842	6716	0	applied	\N	\N	1000000000	\N	24963	24963	24964
7842	6717	1	applied	\N	\N	\N	\N	24965	24965	24966
7842	6718	2	applied	\N	\N	\N	\N	24967	24967	24968
7842	6719	3	applied	\N	\N	\N	\N	24969	24969	24970
7842	6720	4	applied	\N	\N	\N	\N	24971	24971	24972
7842	6721	5	applied	\N	\N	\N	\N	24973	24973	24974
7844	6723	0	applied	\N	\N	\N	\N	24980	24980	24981
7844	6724	1	applied	\N	\N	\N	\N	24982	24982	24983
7847	6725	0	applied	\N	\N	\N	\N	24986	24986	24987
7849	6726	0	applied	\N	\N	\N	\N	24990	24990	24991
7849	6727	1	applied	\N	\N	\N	\N	24992	24992	24993
7852	6729	0	applied	\N	\N	\N	\N	24998	24998	24999
7852	6730	1	applied	\N	\N	\N	\N	25000	25000	25001
7852	6731	2	applied	\N	\N	\N	\N	25002	25002	25003
7857	6735	0	applied	\N	\N	\N	\N	25018	25018	25019
7828	6711	0	applied	\N	\N	\N	\N	24937	24937	24938
7832	6712	0	applied	\N	\N	\N	\N	24941	24941	24942
7836	6714	0	applied	\N	\N	\N	\N	24950	24950	24951
7839	6715	0	applied	\N	\N	\N	\N	24956	24956	24957
7845	6723	0	applied	\N	\N	\N	\N	24980	24980	24981
7845	6724	1	applied	\N	\N	\N	\N	24982	24982	24983
7850	6728	0	applied	\N	\N	\N	\N	24994	24994	24995
7853	6732	0	applied	\N	\N	\N	\N	25006	25006	25007
7863	6737	0	applied	\N	\N	\N	\N	25026	25026	25027
7866	6583	0	applied	\N	\N	\N	\N	25030	25030	1435
7866	6584	1	applied	\N	\N	\N	\N	25031	25031	1435
7866	6614	2	applied	\N	\N	\N	\N	24562	24562	24563
7866	6585	3	applied	\N	\N	\N	\N	25032	25032	1435
7866	6290	4	failed	Receiver_not_present	\N	\N	\N	23331	23331	\N
7866	6386	5	applied	\N	\N	\N	\N	23659	23659	23660
7866	6399	6	applied	\N	\N	\N	\N	23703	23703	23704
7866	6453	7	applied	\N	\N	\N	\N	23898	23898	19746
7866	6353	8	applied	\N	\N	\N	\N	23763	23763	13857
7866	6361	9	applied	\N	\N	1000000000	\N	23524	23524	23525
7866	6682	10	applied	\N	\N	\N	\N	25033	25033	24815
7866	6339	11	applied	\N	\N	\N	\N	23457	23457	23458
7866	6366	12	applied	\N	\N	\N	\N	23541	23541	23542
7866	6445	13	applied	\N	\N	\N	\N	23866	23866	23867
7866	6452	14	applied	\N	\N	\N	\N	23886	23886	23887
7866	6533	15	applied	\N	\N	\N	\N	24396	24396	24302
7870	6740	0	applied	\N	\N	\N	\N	25043	25043	25044
7870	6741	1	applied	\N	\N	\N	\N	25045	25045	25046
7877	6743	0	applied	\N	\N	\N	\N	25056	25056	25057
7877	6744	1	applied	\N	\N	\N	\N	25058	25058	25059
7879	6748	0	applied	\N	\N	\N	\N	25070	25070	25071
7886	6752	0	applied	\N	\N	\N	\N	25084	25084	25085
7892	6756	0	applied	\N	\N	\N	\N	25095	25095	25096
7902	6761	0	applied	\N	\N	\N	\N	25118	25118	25119
7902	6762	1	applied	\N	\N	\N	\N	25120	25120	25066
7905	6761	0	applied	\N	\N	\N	\N	25118	25118	25119
7905	6762	1	applied	\N	\N	\N	\N	25120	25120	25066
7917	6772	0	applied	\N	\N	\N	\N	25160	25160	25161
7920	6776	0	applied	\N	\N	\N	\N	25176	25176	25177
7920	6777	1	applied	\N	\N	\N	\N	25178	25178	25179
7923	6780	0	applied	\N	\N	\N	\N	25188	25188	25189
7923	6781	1	applied	\N	\N	\N	\N	25190	25190	25191
7923	6782	2	applied	\N	\N	\N	\N	25192	25192	25193
7928	6786	0	applied	\N	\N	\N	\N	25204	25204	25205
7931	6787	0	applied	\N	\N	\N	\N	25208	25208	25209
7937	6790	0	applied	\N	\N	\N	\N	25225	25225	25226
7939	6791	0	applied	\N	\N	\N	\N	25227	25227	25228
7944	6792	0	applied	\N	\N	\N	\N	25234	25234	25235
7948	6794	0	applied	\N	\N	\N	\N	25244	25244	25245
7950	6794	0	applied	\N	\N	\N	\N	25244	25244	25245
7953	6796	0	applied	\N	\N	\N	\N	25255	25255	25256
7955	6798	0	applied	\N	\N	\N	\N	25263	25263	25264
7958	6801	0	applied	\N	\N	\N	\N	25271	25271	25272
7960	6801	0	applied	\N	\N	\N	\N	25271	25271	25272
7973	6815	0	applied	\N	\N	\N	\N	25318	25318	25319
7977	6821	0	applied	\N	\N	\N	\N	25335	25335	25336
7982	6823	0	applied	\N	\N	\N	\N	25347	25347	25348
7982	6824	1	applied	\N	\N	\N	\N	25349	25349	25350
7982	6825	2	applied	\N	\N	\N	\N	25351	25351	25352
7984	6827	0	applied	\N	\N	\N	\N	25363	25363	25364
7984	6828	1	applied	\N	\N	\N	\N	25365	25365	25366
7984	6829	2	applied	\N	\N	\N	\N	25367	25367	25368
7993	6843	0	applied	\N	\N	\N	\N	25403	25403	25404
7993	6844	1	applied	\N	\N	\N	\N	25405	25405	25406
7996	6847	0	applied	\N	\N	\N	\N	25417	25417	25418
8007	6850	0	applied	\N	\N	\N	\N	25433	25433	25434
8007	6851	1	applied	\N	\N	\N	\N	25435	25435	25436
8012	6854	0	applied	\N	\N	\N	\N	25447	25447	25448
8012	6855	1	applied	\N	\N	\N	\N	25449	25449	4764
8015	6854	0	applied	\N	\N	\N	\N	25447	25447	25448
8015	6855	1	applied	\N	\N	\N	\N	25449	25449	4764
8017	6859	0	applied	\N	\N	\N	\N	25465	25465	25466
8020	6862	0	applied	\N	\N	\N	\N	25475	25475	25476
8020	6863	1	applied	\N	\N	\N	\N	25477	25477	25478
8026	6867	0	applied	\N	\N	\N	\N	25491	25491	25492
8026	6868	1	applied	\N	\N	\N	\N	25493	25493	25494
8028	6869	0	applied	\N	\N	\N	\N	25501	25501	25502
8030	6870	0	applied	\N	\N	\N	\N	25503	25503	25504
8030	6871	1	applied	\N	\N	\N	\N	25505	25505	25506
8030	6872	2	applied	\N	\N	\N	\N	25507	25507	25508
8037	6883	0	applied	\N	\N	\N	\N	25537	25537	25538
8046	6886	0	applied	\N	\N	\N	\N	25552	25552	25553
8049	6887	0	applied	\N	\N	\N	\N	25556	25556	25557
8051	6888	0	applied	\N	\N	\N	\N	25562	25562	25563
8051	6889	1	applied	\N	\N	\N	\N	25564	25564	25565
8051	6890	2	applied	\N	\N	\N	\N	25566	25566	25567
8054	6891	0	applied	\N	\N	\N	\N	25571	25571	25572
8056	6893	0	applied	\N	\N	\N	\N	25575	25575	25576
8059	6895	0	applied	\N	\N	\N	\N	25581	25581	25582
8059	6896	1	applied	\N	\N	\N	\N	25583	25583	25584
8061	6897	0	applied	\N	\N	\N	\N	25590	25590	25591
8066	6901	0	applied	\N	\N	\N	\N	25602	25602	25603
8066	6902	1	applied	\N	\N	\N	\N	25604	25604	4764
8071	6906	0	applied	\N	\N	\N	\N	25621	25621	25622
8071	6907	1	applied	\N	\N	\N	\N	25623	25623	25624
8074	6910	0	applied	\N	\N	\N	\N	25633	25633	25634
8074	6911	1	applied	\N	\N	\N	\N	25635	25635	25636
8074	6912	2	applied	\N	\N	\N	\N	25637	25637	4764
8074	6913	3	applied	\N	\N	1000000000	\N	25638	25638	25639
8079	6916	0	applied	\N	\N	\N	\N	25649	25649	25650
8081	6919	0	applied	\N	\N	\N	\N	25658	25658	25659
8081	6920	1	applied	\N	\N	\N	\N	25660	25660	25655
8081	6921	2	applied	\N	\N	1000000000	\N	25661	25661	25662
8084	6926	0	applied	\N	\N	\N	\N	25671	25671	25672
8086	6927	0	applied	\N	\N	\N	\N	25675	25675	25676
8086	6928	1	applied	\N	\N	\N	\N	25677	25677	10714
8089	6930	0	applied	\N	\N	\N	\N	25683	25683	25684
8093	6931	0	applied	\N	\N	\N	\N	25686	25686	25687
8095	6932	0	applied	\N	\N	\N	\N	25696	25696	25697
8095	6933	1	applied	\N	\N	\N	\N	25698	25698	25661
8099	6934	0	applied	\N	\N	\N	\N	25704	25704	25705
8099	6935	1	applied	\N	\N	\N	\N	25706	25706	25661
8104	6937	0	applied	\N	\N	1000000000	\N	25711	25711	25712
8104	6938	1	applied	\N	\N	\N	\N	25713	25713	25714
8104	6939	2	applied	\N	\N	\N	\N	25715	25715	25716
8104	6940	3	applied	\N	\N	\N	\N	25717	25717	25661
8107	6942	0	applied	\N	\N	\N	\N	25723	25723	25724
8109	6944	0	applied	\N	\N	\N	\N	25730	25730	25731
8112	6947	0	applied	\N	\N	\N	\N	25740	25740	25741
8116	6955	0	applied	\N	\N	\N	\N	25759	25759	25760
7859	6736	0	applied	\N	\N	\N	\N	25022	25022	25023
7868	6739	0	applied	\N	\N	\N	\N	25039	25039	25040
7875	6743	0	applied	\N	\N	\N	\N	25056	25056	25057
7875	6744	1	applied	\N	\N	\N	\N	25058	25058	25059
7881	6748	0	applied	\N	\N	\N	\N	25070	25070	25071
7885	6751	0	applied	\N	\N	\N	\N	25076	25076	25077
7887	6753	0	applied	\N	\N	\N	\N	25086	25086	25087
7890	6756	0	applied	\N	\N	\N	\N	25095	25095	25096
7894	6757	0	applied	\N	\N	\N	\N	25103	25103	25104
7897	6758	0	applied	\N	\N	\N	\N	25105	25105	25106
7899	6759	0	applied	\N	\N	\N	\N	25109	25109	25110
7899	6760	1	applied	\N	\N	\N	\N	25111	25111	25112
7901	6759	0	applied	\N	\N	\N	\N	25109	25109	25110
7901	6760	1	applied	\N	\N	\N	\N	25111	25111	25112
7903	6761	0	applied	\N	\N	\N	\N	25118	25118	25119
7903	6762	1	applied	\N	\N	\N	\N	25120	25120	25066
7908	6765	0	applied	\N	\N	\N	\N	25136	25136	25137
7910	6766	0	applied	\N	\N	\N	\N	25140	25140	25141
7913	6769	0	applied	\N	\N	\N	\N	25150	25150	25151
7913	6770	1	applied	\N	\N	\N	\N	25152	25152	25153
7919	6773	0	applied	\N	\N	\N	\N	25166	25166	25167
7919	6774	1	applied	\N	\N	\N	\N	25168	25168	25169
7919	6775	2	applied	\N	\N	\N	\N	25170	25170	25171
7924	6783	0	applied	\N	\N	\N	\N	25195	25195	25196
7927	6784	0	applied	\N	\N	\N	\N	25199	25199	25200
7927	6785	1	applied	\N	\N	\N	\N	25201	25201	25202
7929	6787	0	applied	\N	\N	\N	\N	25208	25208	25209
7932	6645	0	applied	\N	\N	\N	\N	24671	24671	24672
7932	6646	1	applied	\N	\N	\N	\N	24675	24675	24676
7932	6716	2	applied	\N	\N	1000000000	\N	24963	24963	24964
7932	6647	3	applied	\N	\N	\N	\N	24677	24677	24678
7932	6682	4	applied	\N	\N	\N	\N	24814	24814	24815
7932	6648	5	applied	\N	\N	\N	\N	24682	24682	24683
7932	6649	6	applied	\N	\N	\N	\N	24686	24686	24687
7932	6650	7	applied	\N	\N	\N	\N	24693	24693	24694
7932	6651	8	applied	\N	\N	\N	\N	24695	24695	24696
7932	6652	9	applied	\N	\N	\N	\N	24697	24697	24698
7932	6653	10	applied	\N	\N	\N	\N	24701	24701	24702
7932	6654	11	applied	\N	\N	\N	\N	24707	24707	24708
7932	6655	12	applied	\N	\N	\N	\N	24711	24711	24712
7932	6656	13	applied	\N	\N	\N	\N	24713	24713	24714
7932	6657	14	applied	\N	\N	\N	\N	24717	24717	24718
7932	6658	15	applied	\N	\N	\N	\N	24728	24728	24729
7932	6659	16	applied	\N	\N	\N	\N	24730	24730	24731
7932	6660	17	applied	\N	\N	\N	\N	24732	24732	24733
7932	6661	18	applied	\N	\N	\N	\N	24739	24739	24740
7932	6662	19	applied	\N	\N	\N	\N	24741	24741	24742
7932	6663	20	applied	\N	\N	\N	\N	24743	24743	24744
7932	6664	21	applied	\N	\N	\N	\N	24747	24747	24748
7932	6665	22	applied	\N	\N	\N	\N	24755	24755	24756
7932	6666	23	applied	\N	\N	\N	\N	24757	24757	24758
7932	6667	24	applied	\N	\N	\N	\N	24759	24759	24760
7932	6668	25	applied	\N	\N	\N	\N	24763	24763	24764
7932	6669	26	applied	\N	\N	\N	\N	24765	24765	24766
7932	6670	27	applied	\N	\N	\N	\N	24767	24767	24768
7932	6671	28	applied	\N	\N	\N	\N	24770	24770	24771
7932	6672	29	applied	\N	\N	\N	\N	24774	24774	24775
7932	6673	30	applied	\N	\N	\N	\N	24780	24780	24781
7932	6674	31	applied	\N	\N	\N	\N	24784	24784	24785
7932	6675	32	applied	\N	\N	\N	\N	24789	24789	24790
7932	6676	33	applied	\N	\N	\N	\N	24794	24794	24795
7932	6677	34	applied	\N	\N	\N	\N	24798	24798	24799
7932	6678	35	applied	\N	\N	\N	\N	24802	24802	24803
7932	6679	36	applied	\N	\N	\N	\N	24804	24804	24805
7932	6680	38	applied	\N	\N	\N	\N	24810	24810	24811
7932	6681	39	applied	\N	\N	\N	\N	24812	24812	24813
7932	6683	40	applied	\N	\N	\N	\N	24818	24818	24819
7932	6684	41	applied	\N	\N	\N	\N	24822	24822	24823
7932	6685	42	applied	\N	\N	1000000000	\N	24824	24824	24825
7932	6686	43	applied	\N	\N	1000000000	\N	24826	24826	24827
7932	6687	44	applied	\N	\N	\N	\N	24830	24830	24831
7932	6688	45	applied	\N	\N	\N	\N	24834	24834	24835
7932	6689	46	applied	\N	\N	\N	\N	24841	24841	24842
7932	6690	47	applied	\N	\N	\N	\N	24845	24845	24846
7932	6691	48	applied	\N	\N	\N	\N	24849	24849	24850
7932	6692	49	applied	\N	\N	\N	\N	24851	24851	24852
7932	6693	50	applied	\N	\N	\N	\N	24854	24854	24855
7932	6694	51	applied	\N	\N	\N	\N	24862	24862	24863
7932	6695	52	applied	\N	\N	\N	\N	24866	24866	24867
7932	6696	53	applied	\N	\N	\N	\N	24872	24872	24873
7932	6697	54	applied	\N	\N	\N	\N	24881	24881	24882
7932	6698	55	applied	\N	\N	\N	\N	24883	24883	24884
7932	6699	56	applied	\N	\N	\N	\N	24888	24888	24889
7932	6700	57	applied	\N	\N	\N	\N	24894	24894	24895
7932	6701	58	applied	\N	\N	\N	\N	24902	24902	24903
7932	6702	59	applied	\N	\N	\N	\N	24905	24905	24906
7932	6703	60	applied	\N	\N	\N	\N	24907	24907	24908
7932	6704	61	applied	\N	\N	\N	\N	24909	24909	24910
7932	6705	62	applied	\N	\N	\N	\N	24911	24911	24912
7932	6706	63	applied	\N	\N	\N	\N	24918	24918	24919
7932	6707	64	applied	\N	\N	\N	\N	24920	24920	24921
7932	6708	65	applied	\N	\N	\N	\N	24923	24923	24924
7932	6709	66	applied	\N	\N	\N	\N	24927	24927	24928
7932	6710	67	applied	\N	\N	\N	\N	24931	24931	24932
7932	6711	68	applied	\N	\N	\N	\N	24937	24937	24938
7932	6712	69	applied	\N	\N	\N	\N	24941	24941	24942
7932	6713	70	applied	\N	\N	\N	\N	24946	24946	24947
7932	6714	71	applied	\N	\N	\N	\N	24950	24950	24951
7932	6715	72	applied	\N	\N	\N	\N	24956	24956	24957
7932	6717	73	applied	\N	\N	\N	\N	24965	24965	24966
7932	6718	74	applied	\N	\N	\N	\N	24967	24967	24968
7932	6719	75	applied	\N	\N	\N	\N	24969	24969	24970
7932	6720	76	applied	\N	\N	\N	\N	24971	24971	24972
7932	6721	77	applied	\N	\N	\N	\N	24973	24973	24974
7932	6722	78	applied	\N	\N	\N	\N	24978	24978	24979
7932	6723	79	applied	\N	\N	\N	\N	24980	24980	24981
7932	6724	80	applied	\N	\N	\N	\N	24982	24982	24983
7932	6725	81	applied	\N	\N	\N	\N	24986	24986	24987
7932	6726	82	applied	\N	\N	\N	\N	24990	24990	24991
7932	6727	83	applied	\N	\N	\N	\N	24992	24992	24993
7932	6728	84	applied	\N	\N	\N	\N	24994	24994	24995
7932	6729	85	applied	\N	\N	\N	\N	24998	24998	24999
7932	6730	86	applied	\N	\N	\N	\N	25000	25000	25001
7932	6731	87	applied	\N	\N	\N	\N	25002	25002	25003
7932	6732	88	applied	\N	\N	\N	\N	25006	25006	25007
7932	6733	89	applied	\N	\N	\N	\N	25010	25010	25011
7932	6734	90	applied	\N	\N	\N	\N	25016	25016	25017
7932	6735	91	applied	\N	\N	\N	\N	25018	25018	25019
7932	6736	92	applied	\N	\N	\N	\N	25022	25022	25023
7921	6778	0	applied	\N	\N	\N	\N	25182	25182	25183
7921	6779	1	applied	\N	\N	\N	\N	25184	25184	25185
7926	6784	0	applied	\N	\N	\N	\N	25199	25199	25200
7926	6785	1	applied	\N	\N	\N	\N	25201	25201	25202
7935	6789	0	applied	\N	\N	\N	\N	25219	25219	25220
7938	6790	0	applied	\N	\N	\N	\N	25225	25225	25226
7940	6791	0	applied	\N	\N	\N	\N	25227	25227	25228
7945	6792	0	applied	\N	\N	\N	\N	25234	25234	25235
7956	6799	0	applied	\N	\N	\N	\N	25265	25265	25266
7956	6800	1	applied	\N	\N	\N	\N	25267	25267	25268
7959	6772	0	applied	\N	\N	\N	\N	25160	25160	25161
7959	6773	1	applied	\N	\N	\N	\N	25166	25166	25167
7959	6774	2	applied	\N	\N	\N	\N	25168	25168	25169
7959	6775	3	applied	\N	\N	\N	\N	25170	25170	25171
7959	6776	4	applied	\N	\N	\N	\N	25176	25176	25177
7959	6777	5	applied	\N	\N	\N	\N	25178	25178	25179
7959	6778	6	applied	\N	\N	\N	\N	25182	25182	25183
7959	6779	7	applied	\N	\N	\N	\N	25184	25184	25185
7959	6780	8	applied	\N	\N	\N	\N	25188	25188	25189
7959	6781	9	applied	\N	\N	\N	\N	25190	25190	25191
7959	6783	10	applied	\N	\N	\N	\N	25195	25195	25196
7959	6784	11	applied	\N	\N	\N	\N	25199	25199	25200
7959	6785	12	applied	\N	\N	\N	\N	25201	25201	25202
7959	6786	13	applied	\N	\N	\N	\N	25204	25204	25205
7959	6787	14	applied	\N	\N	\N	\N	25208	25208	25209
7959	6788	15	applied	\N	\N	\N	\N	25217	25217	25218
7959	6789	16	applied	\N	\N	\N	\N	25219	25219	25220
7959	6790	17	applied	\N	\N	\N	\N	25225	25225	25226
7959	6791	18	applied	\N	\N	\N	\N	25227	25227	25228
7959	6792	19	applied	\N	\N	\N	\N	25234	25234	25235
7959	6793	20	applied	\N	\N	\N	\N	25240	25240	25241
7959	6794	21	applied	\N	\N	\N	\N	25244	25244	25245
7959	6795	22	applied	\N	\N	\N	\N	25251	25251	25252
7959	6796	23	applied	\N	\N	\N	\N	25255	25255	25256
7959	6797	24	applied	\N	\N	\N	\N	25259	25259	25260
7959	6798	25	applied	\N	\N	\N	\N	25263	25263	25264
7959	6799	26	applied	\N	\N	\N	\N	25265	25265	25266
7959	6800	27	applied	\N	\N	\N	\N	25267	25267	25268
7959	6801	28	applied	\N	\N	\N	\N	25271	25271	25272
7959	6747	29	applied	\N	\N	1000000000	\N	25066	25066	25067
7959	6782	30	applied	\N	\N	\N	\N	25192	25192	25273
7961	6802	0	applied	\N	\N	\N	\N	25278	25278	25279
7961	6803	1	applied	\N	\N	\N	\N	25280	25280	25281
7961	6804	2	applied	\N	\N	\N	\N	25282	25282	25283
7964	6808	0	applied	\N	\N	\N	\N	25293	25293	25294
7969	6809	0	applied	\N	\N	\N	\N	25302	25302	25303
7969	6810	1	applied	\N	\N	\N	\N	25304	25304	25305
7969	6811	2	applied	\N	\N	\N	\N	25306	25306	25307
7969	6812	3	applied	\N	\N	\N	\N	25308	25308	25309
7969	6813	4	applied	\N	\N	\N	\N	25310	25310	25311
7971	6809	0	applied	\N	\N	\N	\N	25302	25302	25303
7971	6810	1	applied	\N	\N	\N	\N	25304	25304	25305
7971	6811	2	applied	\N	\N	\N	\N	25306	25306	25307
7971	6812	3	applied	\N	\N	\N	\N	25308	25308	25309
7971	6813	4	applied	\N	\N	\N	\N	25310	25310	25311
7974	6816	0	applied	\N	\N	\N	\N	25322	25322	25323
7974	6817	1	applied	\N	\N	\N	\N	25324	25324	25325
7979	6822	0	applied	\N	\N	\N	\N	25341	25341	25342
7985	6830	0	applied	\N	\N	\N	\N	25371	25371	25372
7985	6831	1	applied	\N	\N	\N	\N	25373	25373	25374
7985	6832	2	applied	\N	\N	\N	\N	25375	25375	25376
7988	6836	0	applied	\N	\N	\N	\N	25384	25384	25385
7988	6837	1	applied	\N	\N	\N	\N	25386	25386	25387
7988	6838	2	applied	\N	\N	\N	\N	25388	25388	25389
7991	6841	0	applied	\N	\N	\N	\N	25397	25397	25398
7994	6843	0	applied	\N	\N	\N	\N	25403	25403	25404
7994	6844	1	applied	\N	\N	\N	\N	25405	25405	25406
7997	6847	0	applied	\N	\N	\N	\N	25417	25417	25418
8000	6847	0	applied	\N	\N	\N	\N	25417	25417	25418
8005	6848	0	applied	\N	\N	\N	\N	25423	25423	25424
8005	6849	1	applied	\N	\N	\N	\N	25425	25425	25426
8010	6852	0	applied	\N	\N	\N	\N	25440	25440	25441
8013	6854	0	applied	\N	\N	\N	\N	25447	25447	25448
8013	6855	1	applied	\N	\N	\N	\N	25449	25449	4764
8023	6866	0	applied	\N	\N	\N	\N	25488	25488	25489
8033	6870	0	applied	\N	\N	\N	\N	25503	25503	25504
8033	6871	1	applied	\N	\N	\N	\N	25505	25505	25506
8033	6872	2	applied	\N	\N	\N	\N	25507	25507	25508
8033	6873	3	applied	\N	\N	\N	\N	25513	25513	25514
8033	6874	4	applied	\N	\N	\N	\N	25515	25515	25516
8033	6875	5	applied	\N	\N	1000000000	\N	25517	25517	25518
8033	6876	6	applied	\N	\N	1000000000	\N	25519	25519	25520
8033	6877	7	applied	\N	\N	1000000000	\N	25521	25521	25522
8033	6878	8	applied	\N	\N	1000000000	\N	25523	25523	25524
8033	6879	9	applied	\N	\N	\N	\N	25525	25525	25526
8033	6880	10	applied	\N	\N	1000000000	\N	25527	25527	25528
8033	6881	11	applied	\N	\N	\N	\N	25529	25529	25530
8038	6883	0	applied	\N	\N	\N	\N	25537	25537	25538
8040	6884	0	applied	\N	\N	\N	\N	25541	25541	25542
8042	6885	0	applied	\N	\N	\N	\N	25547	25547	25548
8045	6885	0	applied	\N	\N	\N	\N	25547	25547	25548
8047	6886	0	applied	\N	\N	\N	\N	25552	25552	25553
8050	6887	0	applied	\N	\N	\N	\N	25556	25556	25557
8052	6888	0	applied	\N	\N	\N	\N	25562	25562	25563
8052	6889	1	applied	\N	\N	\N	\N	25564	25564	25565
8052	6890	2	applied	\N	\N	\N	\N	25566	25566	25567
8060	6895	0	applied	\N	\N	\N	\N	25581	25581	25582
8060	6896	1	applied	\N	\N	\N	\N	25583	25583	25584
8064	6900	0	applied	\N	\N	\N	\N	25598	25598	25599
8067	6901	0	applied	\N	\N	\N	\N	25602	25602	25603
8067	6902	1	applied	\N	\N	\N	\N	25604	25604	4764
8072	6906	0	applied	\N	\N	\N	\N	25621	25621	25622
8072	6907	1	applied	\N	\N	\N	\N	25623	25623	25624
8075	6910	0	applied	\N	\N	\N	\N	25633	25633	25634
8075	6911	1	applied	\N	\N	\N	\N	25635	25635	25636
8075	6912	2	applied	\N	\N	\N	\N	25637	25637	4764
8075	6913	3	applied	\N	\N	1000000000	\N	25638	25638	25639
8077	6916	0	applied	\N	\N	\N	\N	25649	25649	25650
8082	6922	0	applied	\N	\N	\N	\N	25665	25665	1435
8082	6923	1	applied	\N	\N	\N	\N	25666	25666	25667
8082	6924	2	applied	\N	\N	\N	\N	25668	25668	25661
8082	6925	3	applied	\N	\N	\N	\N	25669	25669	10714
8085	6926	0	applied	\N	\N	\N	\N	25671	25671	25672
8090	6930	0	applied	\N	\N	\N	\N	25683	25683	25684
8091	6931	0	applied	\N	\N	\N	\N	25686	25686	25687
8094	6931	0	applied	\N	\N	\N	\N	25686	25686	25687
8096	6932	0	applied	\N	\N	\N	\N	25696	25696	25697
8096	6933	1	applied	\N	\N	\N	\N	25698	25698	25661
8100	6934	0	applied	\N	\N	\N	\N	25704	25704	25705
7932	6737	93	applied	\N	\N	\N	\N	25026	25026	25027
7932	6738	94	applied	\N	\N	\N	\N	25035	25035	25036
7932	6739	95	applied	\N	\N	\N	\N	25039	25039	25040
7932	6740	96	applied	\N	\N	\N	\N	25043	25043	25044
7932	6741	97	applied	\N	\N	\N	\N	25045	25045	25046
7932	6742	98	applied	\N	\N	\N	\N	25052	25052	25053
7932	6743	99	applied	\N	\N	\N	\N	25056	25056	25057
7932	6744	100	applied	\N	\N	\N	\N	25058	25058	25059
7932	6745	101	applied	\N	\N	\N	\N	25062	25062	25063
7932	6746	102	applied	\N	\N	\N	\N	25064	25064	25065
7932	6748	103	applied	\N	\N	\N	\N	25070	25070	25071
7932	6749	104	applied	\N	\N	\N	\N	25072	25072	25073
7932	6750	105	applied	\N	\N	\N	\N	25074	25074	25075
7932	6751	106	applied	\N	\N	\N	\N	25076	25076	25077
7932	6752	107	applied	\N	\N	\N	\N	25084	25084	25085
7932	6753	108	applied	\N	\N	\N	\N	25086	25086	25087
7932	6754	109	applied	\N	\N	\N	\N	25089	25089	25090
7932	6755	110	applied	\N	\N	\N	\N	25091	25091	25092
7932	6756	111	applied	\N	\N	\N	\N	25095	25095	25096
7932	6757	112	applied	\N	\N	\N	\N	25103	25103	25104
7932	6758	113	applied	\N	\N	\N	\N	25105	25105	25106
7932	6759	114	applied	\N	\N	\N	\N	25109	25109	25110
7932	6760	115	applied	\N	\N	\N	\N	25111	25111	25112
7932	6761	116	applied	\N	\N	\N	\N	25118	25118	25119
7932	6763	117	applied	\N	\N	\N	\N	25128	25128	25129
7932	6764	118	applied	\N	\N	\N	\N	25132	25132	25133
7932	6765	119	applied	\N	\N	\N	\N	25136	25136	25137
7932	6766	120	applied	\N	\N	\N	\N	25140	25140	25141
7932	6767	121	applied	\N	\N	\N	\N	25144	25144	25145
7932	6768	122	applied	\N	\N	\N	\N	25146	25146	25147
7932	6769	123	applied	\N	\N	\N	\N	25150	25150	25151
7932	6770	124	applied	\N	\N	\N	\N	25152	25152	25153
7932	6771	125	applied	\N	\N	\N	\N	25156	25156	25157
7936	6789	0	applied	\N	\N	\N	\N	25219	25219	25220
7941	6791	0	applied	\N	\N	\N	\N	25227	25227	25228
7946	6792	0	applied	\N	\N	\N	\N	25234	25234	25235
7949	6794	0	applied	\N	\N	\N	\N	25244	25244	25245
7951	6795	0	applied	\N	\N	\N	\N	25251	25251	25252
7962	6805	0	applied	\N	\N	\N	\N	25285	25285	25286
7962	6806	1	applied	\N	\N	\N	\N	25287	25287	25288
7962	6807	2	applied	\N	\N	\N	\N	25289	25289	25290
7970	6812	0	applied	\N	\N	\N	\N	25308	25308	25309
7975	6818	0	applied	\N	\N	\N	\N	25327	25327	25328
7975	6819	1	applied	\N	\N	\N	\N	25329	25329	25330
7975	6820	2	applied	\N	\N	\N	\N	25331	25331	25332
7980	6823	0	applied	\N	\N	\N	\N	25347	25347	25348
7980	6824	1	applied	\N	\N	\N	\N	25349	25349	25350
7980	6825	2	applied	\N	\N	\N	\N	25351	25351	25352
7986	6833	0	applied	\N	\N	\N	\N	25378	25378	1435
7986	6834	1	applied	\N	\N	\N	\N	25379	25379	25380
7986	6835	2	applied	\N	\N	\N	\N	25381	25381	25382
7989	6839	0	applied	\N	\N	\N	\N	25392	25392	25393
7989	6840	1	applied	\N	\N	\N	\N	25394	25394	25395
7998	6847	0	applied	\N	\N	\N	\N	25417	25417	25418
8001	6847	0	applied	\N	\N	\N	\N	25417	25417	25418
8006	6848	0	applied	\N	\N	\N	\N	25423	25423	25424
8006	6849	1	applied	\N	\N	\N	\N	25425	25425	25426
8014	6854	0	applied	\N	\N	\N	\N	25447	25447	25448
8014	6855	1	applied	\N	\N	\N	\N	25449	25449	4764
8018	6860	0	applied	\N	\N	\N	\N	25469	25469	25470
8021	6862	0	applied	\N	\N	\N	\N	25475	25475	25476
8021	6863	1	applied	\N	\N	\N	\N	25477	25477	25478
8024	6867	0	applied	\N	\N	\N	\N	25491	25491	25492
8024	6868	1	applied	\N	\N	\N	\N	25493	25493	25494
8032	6870	0	applied	\N	\N	\N	\N	25503	25503	25504
8032	6871	1	applied	\N	\N	\N	\N	25505	25505	25506
8032	6872	2	applied	\N	\N	\N	\N	25507	25507	25508
8036	6882	0	applied	\N	\N	\N	\N	25535	25535	25536
8043	6885	0	applied	\N	\N	\N	\N	25547	25547	25548
8057	6894	0	applied	\N	\N	\N	\N	25578	25578	25579
8062	6898	0	applied	\N	\N	\N	\N	25592	25592	24562
8062	6899	1	applied	\N	\N	\N	\N	25593	25593	25594
8069	6903	0	applied	\N	\N	\N	\N	25611	25611	25612
8078	6916	0	applied	\N	\N	\N	\N	25649	25649	25650
8080	6917	0	applied	\N	\N	\N	\N	25653	25653	25654
8080	6918	1	applied	\N	\N	1000000000	\N	25655	25655	25656
8087	6929	0	applied	\N	\N	\N	\N	25679	25679	25680
8092	6931	0	applied	\N	\N	\N	\N	25686	25686	25687
8098	6932	0	applied	\N	\N	\N	\N	25696	25696	25697
8098	6933	1	applied	\N	\N	\N	\N	25698	25698	25661
8101	6934	0	applied	\N	\N	\N	\N	25704	25704	25705
8103	6937	0	applied	\N	\N	1000000000	\N	25711	25711	25712
8103	6938	1	applied	\N	\N	\N	\N	25713	25713	25714
8103	6939	2	applied	\N	\N	\N	\N	25715	25715	25716
8103	6940	3	applied	\N	\N	\N	\N	25717	25717	25661
8105	6941	0	applied	\N	\N	\N	\N	25721	25721	25722
8114	6948	0	applied	\N	\N	\N	\N	25744	25744	25745
8114	6949	1	applied	\N	\N	\N	\N	25746	25746	25747
8114	6950	2	applied	\N	\N	\N	\N	25748	25748	25749
8114	6951	3	applied	\N	\N	\N	\N	25750	25750	25751
8114	6952	4	applied	\N	\N	\N	\N	25752	25752	25753
8114	6953	5	applied	\N	\N	\N	\N	25754	25754	25755
8114	6954	6	applied	\N	\N	\N	\N	25756	25756	25661
8119	6957	0	applied	\N	\N	\N	\N	25769	25769	25770
8122	6958	0	applied	\N	\N	\N	\N	25776	25776	25777
8122	6959	1	applied	\N	\N	\N	\N	25778	25778	25779
8124	6960	0	applied	\N	\N	\N	\N	25783	25783	1435
8124	6958	1	applied	\N	\N	\N	\N	25776	25776	25777
8124	6959	2	applied	\N	\N	\N	\N	25778	25778	25779
8124	6961	3	applied	\N	\N	\N	\N	25784	25784	25785
8124	6962	4	applied	\N	\N	\N	\N	25786	25786	25787
8130	6964	0	applied	\N	\N	\N	\N	25794	25794	25795
8134	6968	0	applied	\N	\N	\N	\N	25809	25809	25810
8134	6969	1	applied	\N	\N	\N	\N	25811	25811	25812
8136	6971	0	applied	\N	\N	\N	\N	25818	25818	25819
8139	6974	0	applied	\N	\N	\N	\N	25826	25826	25827
8139	6975	1	applied	\N	\N	\N	\N	25828	25828	25829
8144	6977	0	applied	\N	\N	\N	\N	25840	25840	25841
8144	6978	1	applied	\N	\N	\N	\N	25842	25842	25843
8146	6977	0	applied	\N	\N	\N	\N	25840	25840	25841
8146	6978	1	applied	\N	\N	\N	\N	25842	25842	25843
8148	6979	0	applied	\N	\N	\N	\N	25848	25848	25849
8149	6960	0	applied	\N	\N	\N	\N	25783	25783	1435
8149	6954	1	applied	\N	\N	\N	\N	25756	25756	25661
8155	6986	0	applied	\N	\N	\N	\N	25870	25870	25871
8160	6988	0	applied	\N	\N	\N	\N	25881	25881	25882
8165	6991	0	applied	\N	\N	\N	\N	25894	25894	25895
8168	6992	0	applied	\N	\N	\N	\N	25899	25899	25900
8168	6993	1	applied	\N	\N	\N	\N	25901	25901	25902
7995	6846	1	applied	\N	\N	\N	\N	25413	25413	25414
8004	6848	0	applied	\N	\N	\N	\N	25423	25423	25424
8004	6849	1	applied	\N	\N	\N	\N	25425	25425	25426
8009	6852	0	applied	\N	\N	\N	\N	25440	25440	25441
8011	6853	0	applied	\N	\N	\N	\N	25444	25444	25445
8016	6856	0	applied	\N	\N	\N	\N	25458	25458	25459
8016	6857	1	applied	\N	\N	\N	\N	25460	25460	25461
8016	6858	2	applied	\N	\N	\N	\N	25462	25462	25463
8019	6861	0	applied	\N	\N	\N	\N	25473	25473	25474
8022	6864	0	applied	\N	\N	\N	\N	25482	25482	25483
8022	6865	1	applied	\N	\N	\N	\N	25484	25484	25485
8025	6867	0	applied	\N	\N	\N	\N	25491	25491	25492
8025	6868	1	applied	\N	\N	\N	\N	25493	25493	25494
8027	6869	0	applied	\N	\N	\N	\N	25501	25501	25502
8029	6869	0	applied	\N	\N	\N	\N	25501	25501	25502
8034	6870	0	applied	\N	\N	\N	\N	25503	25503	25504
8034	6871	1	applied	\N	\N	\N	\N	25505	25505	25506
8034	6872	2	applied	\N	\N	\N	\N	25507	25507	25508
8034	6873	3	applied	\N	\N	\N	\N	25513	25513	25514
8034	6874	4	applied	\N	\N	\N	\N	25515	25515	25516
8034	6875	5	applied	\N	\N	1000000000	\N	25517	25517	25518
8034	6876	6	applied	\N	\N	1000000000	\N	25519	25519	25520
8034	6877	7	applied	\N	\N	1000000000	\N	25521	25521	25522
8034	6878	8	applied	\N	\N	1000000000	\N	25523	25523	25524
8034	6879	9	applied	\N	\N	\N	\N	25525	25525	25526
8034	6880	10	applied	\N	\N	1000000000	\N	25527	25527	25528
8034	6881	11	applied	\N	\N	\N	\N	25529	25529	25530
8035	6870	0	applied	\N	\N	\N	\N	25503	25503	25504
8035	6871	1	applied	\N	\N	\N	\N	25505	25505	25506
8035	6872	2	applied	\N	\N	\N	\N	25507	25507	25508
8035	6873	3	applied	\N	\N	\N	\N	25513	25513	25514
8035	6874	4	applied	\N	\N	\N	\N	25515	25515	25516
8035	6875	5	applied	\N	\N	1000000000	\N	25517	25517	25518
8035	6876	6	applied	\N	\N	1000000000	\N	25519	25519	25520
8035	6877	7	applied	\N	\N	1000000000	\N	25521	25521	25522
8035	6878	8	applied	\N	\N	1000000000	\N	25523	25523	25524
8035	6879	9	applied	\N	\N	\N	\N	25525	25525	25526
8035	6880	10	applied	\N	\N	1000000000	\N	25527	25527	25528
8035	6881	11	applied	\N	\N	\N	\N	25529	25529	25530
8039	6884	0	applied	\N	\N	\N	\N	25541	25541	25542
8041	6885	0	applied	\N	\N	\N	\N	25547	25547	25548
8044	6885	0	applied	\N	\N	\N	\N	25547	25547	25548
8048	6887	0	applied	\N	\N	\N	\N	25556	25556	25557
8053	6891	0	applied	\N	\N	\N	\N	25571	25571	25572
8055	6892	0	applied	\N	\N	\N	\N	25573	25573	25574
8058	6895	0	applied	\N	\N	\N	\N	25581	25581	25582
8058	6896	1	applied	\N	\N	\N	\N	25583	25583	25584
8063	6898	0	applied	\N	\N	\N	\N	25592	25592	24562
8063	6899	1	applied	\N	\N	\N	\N	25593	25593	25594
8065	6901	0	applied	\N	\N	\N	\N	25602	25602	25603
8065	6902	1	applied	\N	\N	\N	\N	25604	25604	4764
8070	6904	0	applied	\N	\N	\N	\N	25615	25615	25616
8070	6905	1	applied	\N	\N	\N	\N	25617	25617	25618
8073	6908	0	applied	\N	\N	\N	\N	25628	25628	25629
8073	6909	1	applied	\N	\N	\N	\N	25630	25630	4764
8076	6914	0	applied	\N	\N	\N	\N	25643	25643	25644
8076	6915	1	applied	\N	\N	\N	\N	25645	25645	25646
8083	6926	0	applied	\N	\N	\N	\N	25671	25671	25672
8088	6930	0	applied	\N	\N	\N	\N	25683	25683	25684
8097	6932	0	applied	\N	\N	\N	\N	25696	25696	25697
8097	6933	1	applied	\N	\N	\N	\N	25698	25698	25661
8106	6942	0	applied	\N	\N	\N	\N	25723	25723	25724
8108	6943	0	applied	\N	\N	\N	\N	25727	25727	25728
8111	6947	0	applied	\N	\N	\N	\N	25740	25740	25741
8115	6955	0	applied	\N	\N	\N	\N	25759	25759	25760
8120	6957	0	applied	\N	\N	\N	\N	25769	25769	25770
8127	6964	0	applied	\N	\N	\N	\N	25794	25794	25795
8131	6965	0	applied	\N	\N	\N	\N	25801	25801	25802
8137	6972	0	applied	\N	\N	\N	\N	25820	25820	25821
8137	6973	1	applied	\N	\N	\N	\N	25822	25822	25823
8140	6974	0	applied	\N	\N	\N	\N	25826	25826	25827
8140	6975	1	applied	\N	\N	\N	\N	25828	25828	25829
8142	6976	0	applied	\N	\N	\N	\N	25832	25832	25833
8145	6977	0	applied	\N	\N	\N	\N	25840	25840	25841
8145	6978	1	applied	\N	\N	\N	\N	25842	25842	25843
8147	6977	0	applied	\N	\N	\N	\N	25840	25840	25841
8147	6978	1	applied	\N	\N	\N	\N	25842	25842	25843
8158	6987	0	applied	\N	\N	\N	\N	25877	25877	25878
8163	6989	0	applied	\N	\N	\N	\N	25890	25890	25891
8163	6990	1	applied	\N	\N	\N	\N	25892	25892	25893
8166	6991	0	applied	\N	\N	\N	\N	25894	25894	25895
8170	6994	0	applied	\N	\N	\N	\N	25907	25907	25908
8173	6994	0	applied	\N	\N	\N	\N	25907	25907	25908
8175	6996	0	applied	\N	\N	\N	\N	25919	25919	25920
8175	6997	1	applied	\N	\N	\N	\N	25921	25921	25922
8178	6996	0	applied	\N	\N	\N	\N	25919	25919	25920
8178	6997	1	applied	\N	\N	\N	\N	25921	25921	25922
8179	6998	0	applied	\N	\N	\N	\N	25930	25930	25931
8186	7008	0	applied	\N	\N	\N	\N	25960	25960	25961
8188	7009	0	applied	\N	\N	\N	\N	25964	25964	25965
8191	7011	0	applied	\N	\N	\N	\N	25971	25971	25972
8198	7015	0	applied	\N	\N	\N	\N	25987	25987	25988
8200	7016	0	applied	\N	\N	\N	\N	25993	25993	25994
8207	7023	0	applied	\N	\N	\N	\N	26019	26019	26020
8212	7025	0	applied	\N	\N	\N	\N	26032	26032	26033
8212	7026	1	applied	\N	\N	\N	\N	26034	26034	26035
8220	7029	0	applied	\N	\N	\N	\N	26046	26046	26047
8220	7030	1	applied	\N	\N	1000000000	\N	26048	26048	26049
8221	7031	0	applied	\N	\N	\N	\N	26055	26055	26056
8228	7034	0	applied	\N	\N	\N	\N	26070	26070	26071
8231	7036	0	applied	\N	\N	\N	\N	26078	26078	26079
8231	7037	1	applied	\N	\N	\N	\N	26080	26080	26081
8231	7038	2	applied	\N	\N	\N	\N	26082	26082	26083
8235	7039	0	applied	\N	\N	\N	\N	26089	26089	26090
8235	7040	1	applied	\N	\N	\N	\N	26091	26091	26092
8242	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8256	7048	0	applied	\N	\N	\N	\N	26140	26140	26141
8256	7049	1	applied	\N	\N	\N	\N	26142	26142	26143
8260	7051	0	applied	\N	\N	\N	\N	26150	26150	26151
8260	7052	1	applied	\N	\N	\N	\N	26152	26152	26153
8267	7063	0	applied	\N	\N	\N	\N	26182	26182	26183
8267	7064	1	applied	\N	\N	\N	\N	26184	26184	26185
8267	7065	2	applied	\N	\N	\N	\N	26186	26186	26187
8269	7066	0	applied	\N	\N	\N	\N	26192	26192	26186
8277	7076	0	applied	\N	\N	\N	\N	26224	26224	26225
8277	7077	1	applied	\N	\N	\N	\N	26226	26226	26216
8284	7079	0	applied	\N	\N	\N	\N	26237	26237	26238
8285	7079	0	applied	\N	\N	\N	\N	26237	26237	26238
8100	6935	1	applied	\N	\N	\N	\N	25706	25706	25661
8102	6935	0	applied	\N	\N	\N	\N	25706	25706	25661
8102	6936	1	applied	\N	\N	\N	\N	25709	25709	25661
8110	6945	0	applied	\N	\N	\N	\N	25734	25734	25735
8110	6946	1	applied	\N	\N	\N	\N	25736	25736	25737
8113	6947	0	applied	\N	\N	\N	\N	25740	25740	25741
8117	6955	0	applied	\N	\N	\N	\N	25759	25759	25760
8118	6956	0	applied	\N	\N	\N	\N	25767	25767	25768
8123	6958	0	applied	\N	\N	\N	\N	25776	25776	25777
8123	6959	1	applied	\N	\N	\N	\N	25778	25778	25779
8126	6963	0	applied	\N	\N	\N	\N	25790	25790	25791
8129	6964	0	applied	\N	\N	\N	\N	25794	25794	25795
8133	6968	0	applied	\N	\N	\N	\N	25809	25809	25810
8133	6969	1	applied	\N	\N	\N	\N	25811	25811	25812
8141	6976	0	applied	\N	\N	\N	\N	25832	25832	25833
8151	6980	0	applied	\N	\N	\N	\N	25852	25852	25853
8151	6981	1	applied	\N	\N	\N	\N	25854	25854	25855
8151	6982	2	applied	\N	\N	1000000000	\N	25856	25856	25857
8151	6983	3	applied	\N	\N	\N	\N	25858	25858	25859
8153	6960	0	applied	\N	\N	\N	\N	25783	25783	1435
8153	6941	1	applied	\N	\N	\N	\N	25721	25721	25722
8153	6942	2	applied	\N	\N	\N	\N	25723	25723	25724
8153	6943	3	applied	\N	\N	\N	\N	25727	25727	25728
8153	6944	4	applied	\N	\N	\N	\N	25730	25730	25731
8153	6945	5	applied	\N	\N	\N	\N	25734	25734	25735
8153	6946	6	applied	\N	\N	\N	\N	25736	25736	25737
8153	6947	7	applied	\N	\N	\N	\N	25740	25740	25741
8153	6948	8	applied	\N	\N	\N	\N	25744	25744	25745
8153	6949	9	applied	\N	\N	\N	\N	25746	25746	25747
8153	6950	10	applied	\N	\N	\N	\N	25748	25748	25749
8153	6951	11	applied	\N	\N	\N	\N	25750	25750	25751
8153	6952	12	applied	\N	\N	\N	\N	25752	25752	25753
8153	6953	13	applied	\N	\N	\N	\N	25754	25754	25755
8153	6955	14	applied	\N	\N	\N	\N	25759	25759	25760
8153	6956	15	applied	\N	\N	\N	\N	25767	25767	25768
8153	6957	16	applied	\N	\N	\N	\N	25769	25769	25770
8153	6958	17	applied	\N	\N	\N	\N	25776	25776	25777
8153	6959	18	applied	\N	\N	\N	\N	25778	25778	25779
8153	6961	19	applied	\N	\N	\N	\N	25784	25784	25785
8153	6962	20	applied	\N	\N	\N	\N	25786	25786	25787
8153	6963	21	applied	\N	\N	\N	\N	25790	25790	25791
8153	6964	22	applied	\N	\N	\N	\N	25794	25794	25795
8153	6965	23	applied	\N	\N	\N	\N	25801	25801	25802
8153	6966	24	applied	\N	\N	\N	\N	25805	25805	25806
8153	6967	25	applied	\N	\N	\N	\N	25807	25807	25808
8153	6968	26	applied	\N	\N	\N	\N	25809	25809	25810
8153	6969	27	applied	\N	\N	\N	\N	25811	25811	25812
8153	6970	28	applied	\N	\N	\N	\N	25816	25816	25817
8153	6971	29	applied	\N	\N	\N	\N	25818	25818	25819
8153	6972	30	applied	\N	\N	\N	\N	25820	25820	25821
8153	6973	31	applied	\N	\N	\N	\N	25822	25822	25823
8153	6974	32	applied	\N	\N	\N	\N	25826	25826	25827
8153	6975	33	applied	\N	\N	\N	\N	25828	25828	25829
8153	6976	34	applied	\N	\N	\N	\N	25832	25832	25833
8153	6977	35	applied	\N	\N	\N	\N	25840	25840	25841
8153	6978	36	applied	\N	\N	\N	\N	25842	25842	25843
8153	6979	37	applied	\N	\N	\N	\N	25848	25848	25849
8153	6980	38	applied	\N	\N	\N	\N	25852	25852	25853
8153	6981	39	applied	\N	\N	\N	\N	25854	25854	25855
8153	6982	40	applied	\N	\N	1000000000	\N	25856	25856	25857
8153	6983	41	applied	\N	\N	\N	\N	25858	25858	25859
8153	6984	42	applied	\N	\N	\N	\N	25862	25862	25863
8153	6954	43	applied	\N	\N	\N	\N	25756	25756	25661
8157	6986	0	applied	\N	\N	\N	\N	25870	25870	25871
8159	6988	0	applied	\N	\N	\N	\N	25881	25881	25882
8162	6985	0	applied	\N	\N	\N	\N	25866	25866	25867
8162	6986	1	applied	\N	\N	\N	\N	25870	25870	25871
8162	6987	2	applied	\N	\N	\N	\N	25877	25877	25878
8162	6988	3	applied	\N	\N	\N	\N	25881	25881	25882
8167	6992	0	applied	\N	\N	\N	\N	25899	25899	25900
8167	6993	1	applied	\N	\N	\N	\N	25901	25901	25902
8169	6992	0	applied	\N	\N	\N	\N	25899	25899	25900
8169	6993	1	applied	\N	\N	\N	\N	25901	25901	25902
8172	6994	0	applied	\N	\N	\N	\N	25907	25907	25908
8181	7000	0	applied	\N	\N	\N	\N	25937	25937	25938
8181	7001	1	applied	\N	\N	\N	\N	25939	25939	25940
8182	7002	0	applied	\N	\N	\N	\N	25942	25942	25943
8182	7003	1	applied	\N	\N	\N	\N	25944	25944	25945
8182	7004	2	applied	\N	\N	\N	\N	25946	25946	25947
8182	7005	3	applied	\N	\N	\N	\N	25948	25948	25949
8192	7012	0	applied	\N	\N	\N	\N	25975	25975	25976
8192	7013	1	applied	\N	\N	\N	\N	25977	25977	25978
8195	7012	0	applied	\N	\N	\N	\N	25975	25975	25976
8195	7013	1	applied	\N	\N	\N	\N	25977	25977	25978
8195	7014	2	applied	\N	\N	\N	\N	25981	25981	25982
8199	7016	0	applied	\N	\N	\N	\N	25993	25993	25994
8201	7017	0	applied	\N	\N	\N	\N	25999	25999	26000
8204	7018	0	applied	\N	\N	1000000000	\N	26001	26001	26002
8204	7019	1	applied	\N	\N	\N	\N	26003	26003	26004
8204	7020	2	applied	\N	\N	\N	\N	26005	26005	26006
8206	7022	0	applied	\N	\N	\N	\N	26017	26017	26018
8208	7023	0	applied	\N	\N	\N	\N	26019	26019	26020
8213	7027	0	applied	\N	\N	\N	\N	26038	26038	26039
8216	7028	0	applied	\N	\N	\N	\N	26044	26044	26045
8218	7029	0	applied	\N	\N	\N	\N	26046	26046	26047
8218	7030	1	applied	\N	\N	1000000000	\N	26048	26048	26049
8222	7032	0	applied	\N	\N	\N	\N	26058	26058	26059
8227	7034	0	applied	\N	\N	\N	\N	26070	26070	26071
8229	7035	0	applied	\N	\N	\N	\N	26074	26074	26075
8233	7036	0	applied	\N	\N	\N	\N	26078	26078	26079
8233	7037	1	applied	\N	\N	\N	\N	26080	26080	26081
8233	7038	2	applied	\N	\N	\N	\N	26082	26082	26083
8239	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8243	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8243	7043	1	applied	\N	\N	\N	\N	26108	26108	26109
8243	7044	3	applied	\N	\N	\N	\N	26111	26111	26112
8250	7047	0	applied	\N	\N	\N	\N	26131	26131	26132
8253	7047	0	applied	\N	\N	\N	\N	26131	26131	26132
8254	7048	0	applied	\N	\N	\N	\N	26140	26140	26141
8254	7049	1	applied	\N	\N	\N	\N	26142	26142	26143
8259	7051	0	applied	\N	\N	\N	\N	26150	26150	26151
8259	7052	1	applied	\N	\N	\N	\N	26152	26152	26153
8263	7053	0	applied	\N	\N	\N	\N	26157	26157	26157
8263	7054	1	applied	\N	\N	\N	\N	26158	26158	26159
8263	7055	2	applied	\N	\N	\N	\N	26160	26160	26161
8263	7056	3	applied	\N	\N	\N	\N	26162	26162	26163
8263	7057	4	applied	\N	\N	\N	\N	26164	26164	26165
8263	7058	5	applied	\N	\N	\N	\N	26166	26166	26167
8265	7061	0	applied	\N	\N	\N	\N	26176	26176	26177
8125	6963	0	applied	\N	\N	\N	\N	25790	25790	25791
8132	6966	0	applied	\N	\N	\N	\N	25805	25805	25806
8132	6967	1	applied	\N	\N	\N	\N	25807	25807	25808
8135	6970	0	applied	\N	\N	\N	\N	25816	25816	25817
8143	6976	0	applied	\N	\N	\N	\N	25832	25832	25833
8150	6980	0	applied	\N	\N	\N	\N	25852	25852	25853
8150	6981	1	applied	\N	\N	\N	\N	25854	25854	25855
8150	6982	2	applied	\N	\N	1000000000	\N	25856	25856	25857
8150	6983	3	applied	\N	\N	\N	\N	25858	25858	25859
8152	6984	0	applied	\N	\N	\N	\N	25862	25862	25863
8154	6985	0	applied	\N	\N	\N	\N	25866	25866	25867
8156	6986	0	applied	\N	\N	\N	\N	25870	25870	25871
8161	6988	0	applied	\N	\N	\N	\N	25881	25881	25882
8171	6994	0	applied	\N	\N	\N	\N	25907	25907	25908
8176	6996	0	applied	\N	\N	\N	\N	25919	25919	25920
8176	6997	1	applied	\N	\N	\N	\N	25921	25921	25922
8180	6999	0	applied	\N	\N	\N	\N	25934	25934	25935
8184	7006	0	applied	\N	\N	\N	\N	25952	25952	25953
8187	7008	0	applied	\N	\N	\N	\N	25960	25960	25961
8189	7010	0	applied	\N	\N	\N	\N	25968	25968	25969
8194	7012	0	applied	\N	\N	\N	\N	25975	25975	25976
8194	7013	1	applied	\N	\N	\N	\N	25977	25977	25978
8194	7014	2	applied	\N	\N	\N	\N	25981	25981	25982
8203	7018	0	applied	\N	\N	1000000000	\N	26001	26001	26002
8203	7019	1	applied	\N	\N	\N	\N	26003	26003	26004
8203	7020	2	applied	\N	\N	\N	\N	26005	26005	26006
8205	7021	0	applied	\N	\N	\N	\N	26013	26013	26014
8215	7028	0	applied	\N	\N	\N	\N	26044	26044	26045
8217	7029	0	applied	\N	\N	\N	\N	26046	26046	26047
8217	7030	1	applied	\N	\N	1000000000	\N	26048	26048	26049
8224	7033	0	applied	\N	\N	\N	\N	26064	26064	26065
8226	7034	0	applied	\N	\N	\N	\N	26070	26070	26071
8232	7036	0	applied	\N	\N	\N	\N	26078	26078	26079
8232	7037	1	applied	\N	\N	\N	\N	26080	26080	26081
8232	7038	2	applied	\N	\N	\N	\N	26082	26082	26083
8238	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8245	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8245	7043	1	applied	\N	\N	\N	\N	26108	26108	26109
8245	7044	3	applied	\N	\N	\N	\N	26111	26111	26112
8247	7045	0	applied	\N	\N	\N	\N	26123	26123	26124
8249	7046	0	applied	\N	\N	\N	\N	26127	26127	26128
8252	7047	0	applied	\N	\N	\N	\N	26131	26131	26132
8258	7050	0	applied	\N	\N	\N	\N	26148	26148	26149
8261	7051	0	applied	\N	\N	\N	\N	26150	26150	26151
8261	7052	1	applied	\N	\N	\N	\N	26152	26152	26153
8262	7053	0	applied	\N	\N	\N	\N	26157	26157	26157
8262	7054	1	applied	\N	\N	\N	\N	26158	26158	26159
8262	7055	2	applied	\N	\N	\N	\N	26160	26160	26161
8262	7056	3	applied	\N	\N	\N	\N	26162	26162	26163
8262	7057	4	applied	\N	\N	\N	\N	26164	26164	26165
8262	7058	5	applied	\N	\N	\N	\N	26166	26166	26167
8264	7059	0	applied	\N	\N	\N	\N	26171	26171	26172
8264	7060	1	applied	\N	\N	\N	\N	26173	26173	26142
8272	7068	0	applied	\N	\N	\N	\N	26201	26201	26202
8275	7072	0	applied	\N	\N	\N	\N	26212	26212	26213
8275	7073	1	applied	\N	\N	\N	\N	26214	26214	26215
8275	7074	2	applied	\N	\N	1000000000	\N	26216	26216	26217
8278	7076	0	applied	\N	\N	\N	\N	26224	26224	26225
8278	7077	1	applied	\N	\N	\N	\N	26226	26226	26216
8282	7079	0	applied	\N	\N	\N	\N	26237	26237	26238
8287	7082	0	applied	\N	\N	\N	\N	26253	26253	26254
8296	7088	0	applied	\N	\N	\N	\N	26276	26276	26277
8296	7089	1	applied	\N	\N	\N	\N	26278	26278	26279
8301	7092	0	applied	\N	\N	\N	\N	26290	26290	26291
8310	6987	0	applied	\N	\N	\N	\N	25877	25877	25878
8310	6988	1	applied	\N	\N	\N	\N	25881	25881	25882
8310	6989	2	applied	\N	\N	\N	\N	25890	25890	25891
8310	6990	3	applied	\N	\N	\N	\N	25892	25892	25893
8310	6991	4	applied	\N	\N	\N	\N	25894	25894	25895
8310	6992	5	applied	\N	\N	\N	\N	25899	25899	25900
8310	6993	6	applied	\N	\N	\N	\N	25901	25901	25902
8310	6994	7	applied	\N	\N	\N	\N	25907	25907	25908
8310	6995	8	applied	\N	\N	\N	\N	25915	25915	25916
8310	6996	10	applied	\N	\N	\N	\N	25919	25919	25920
8310	6997	11	applied	\N	\N	\N	\N	25921	25921	25922
8310	6998	12	applied	\N	\N	\N	\N	25930	25930	25931
8310	6999	13	applied	\N	\N	\N	\N	25934	25934	25935
8310	7000	14	applied	\N	\N	\N	\N	25937	25937	25938
8310	7001	15	applied	\N	\N	\N	\N	25939	25939	25940
8310	7002	16	applied	\N	\N	\N	\N	25942	25942	25943
8310	7003	17	applied	\N	\N	\N	\N	25944	25944	25945
8310	7004	18	applied	\N	\N	\N	\N	25946	25946	25947
8310	7005	19	applied	\N	\N	\N	\N	25948	25948	25949
8310	7006	20	applied	\N	\N	\N	\N	25952	25952	25953
8310	7007	21	applied	\N	\N	\N	\N	25956	25956	25957
8310	7008	22	applied	\N	\N	\N	\N	25960	25960	25961
8310	7009	23	applied	\N	\N	\N	\N	25964	25964	25965
8310	7010	24	applied	\N	\N	\N	\N	25968	25968	25969
8310	7011	25	applied	\N	\N	\N	\N	25971	25971	25972
8310	7012	26	applied	\N	\N	\N	\N	25975	25975	25976
8310	7013	27	applied	\N	\N	\N	\N	25977	25977	25978
8310	7014	28	applied	\N	\N	\N	\N	25981	25981	25982
8310	7015	29	applied	\N	\N	\N	\N	25987	25987	25988
8310	7016	30	applied	\N	\N	\N	\N	25993	25993	25994
8310	7017	31	applied	\N	\N	\N	\N	25999	25999	26000
8310	7018	32	applied	\N	\N	1000000000	\N	26001	26001	26002
8310	7019	33	applied	\N	\N	\N	\N	26003	26003	26004
8310	7020	34	applied	\N	\N	\N	\N	26005	26005	26006
8310	7021	35	applied	\N	\N	\N	\N	26013	26013	26014
8310	7022	36	applied	\N	\N	\N	\N	26017	26017	26018
8310	7023	37	applied	\N	\N	\N	\N	26019	26019	26020
8310	7024	38	applied	\N	\N	\N	\N	26028	26028	26029
8310	7025	39	applied	\N	\N	\N	\N	26032	26032	26033
8310	7026	40	applied	\N	\N	\N	\N	26034	26034	26035
8310	7027	41	applied	\N	\N	\N	\N	26038	26038	26039
8310	7028	42	applied	\N	\N	\N	\N	26044	26044	26045
8310	7029	43	applied	\N	\N	\N	\N	26046	26046	26047
8310	7030	44	applied	\N	\N	1000000000	\N	26048	26048	26049
8310	7031	45	applied	\N	\N	\N	\N	26055	26055	26056
8310	7032	46	applied	\N	\N	\N	\N	26058	26058	26059
8310	7033	47	applied	\N	\N	\N	\N	26064	26064	26065
8310	7034	48	applied	\N	\N	\N	\N	26070	26070	26071
8310	7035	49	applied	\N	\N	\N	\N	26074	26074	26075
8310	7036	50	applied	\N	\N	\N	\N	26078	26078	26079
8310	7037	51	applied	\N	\N	\N	\N	26080	26080	26081
8310	7038	52	applied	\N	\N	\N	\N	26082	26082	26083
8310	7039	53	applied	\N	\N	\N	\N	26089	26089	26090
8310	7040	54	applied	\N	\N	\N	\N	26091	26091	26092
8310	7041	55	applied	\N	\N	\N	\N	26095	26095	26096
8174	6995	0	applied	\N	\N	\N	\N	25915	25915	25916
8177	6996	0	applied	\N	\N	\N	\N	25919	25919	25920
8177	6997	1	applied	\N	\N	\N	\N	25921	25921	25922
8183	7002	0	applied	\N	\N	\N	\N	25942	25942	25943
8183	7003	1	applied	\N	\N	\N	\N	25944	25944	25945
8183	7004	2	applied	\N	\N	\N	\N	25946	25946	25947
8183	7005	3	applied	\N	\N	\N	\N	25948	25948	25949
8185	7007	0	applied	\N	\N	\N	\N	25956	25956	25957
8190	7011	0	applied	\N	\N	\N	\N	25971	25971	25972
8196	7012	0	applied	\N	\N	\N	\N	25975	25975	25976
8196	7013	1	applied	\N	\N	\N	\N	25977	25977	25978
8196	7014	2	applied	\N	\N	\N	\N	25981	25981	25982
8197	7015	0	applied	\N	\N	\N	\N	25987	25987	25988
8202	7018	0	applied	\N	\N	1000000000	\N	26001	26001	26002
8202	7019	1	applied	\N	\N	\N	\N	26003	26003	26004
8202	7020	2	applied	\N	\N	\N	\N	26005	26005	26006
8209	7023	0	applied	\N	\N	\N	\N	26019	26019	26020
8210	6966	0	applied	\N	\N	\N	\N	25805	25805	25806
8210	6967	1	applied	\N	\N	\N	\N	25807	25807	25808
8210	6968	2	applied	\N	\N	\N	\N	25809	25809	25810
8210	6969	3	applied	\N	\N	\N	\N	25811	25811	25812
8210	6970	4	applied	\N	\N	\N	\N	25816	25816	25817
8210	6971	5	applied	\N	\N	\N	\N	25818	25818	25819
8210	6972	6	applied	\N	\N	\N	\N	25820	25820	25821
8210	6973	7	applied	\N	\N	\N	\N	25822	25822	25823
8210	6974	8	applied	\N	\N	\N	\N	25826	25826	25827
8210	6975	9	applied	\N	\N	\N	\N	25828	25828	25829
8210	6976	10	applied	\N	\N	\N	\N	25832	25832	25833
8210	6977	11	applied	\N	\N	\N	\N	25840	25840	25841
8210	6978	12	applied	\N	\N	\N	\N	25842	25842	25843
8210	6979	13	applied	\N	\N	\N	\N	25848	25848	25849
8210	6980	14	applied	\N	\N	\N	\N	25852	25852	25853
8210	6981	15	applied	\N	\N	\N	\N	25854	25854	25855
8210	6982	16	applied	\N	\N	1000000000	\N	25856	25856	25857
8210	6983	17	applied	\N	\N	\N	\N	25858	25858	25859
8210	6984	18	applied	\N	\N	\N	\N	25862	25862	25863
8210	6985	19	applied	\N	\N	\N	\N	25866	25866	25867
8210	6986	20	applied	\N	\N	\N	\N	25870	25870	25871
8210	6987	21	applied	\N	\N	\N	\N	25877	25877	25878
8210	6988	22	applied	\N	\N	\N	\N	25881	25881	25882
8210	6989	23	applied	\N	\N	\N	\N	25890	25890	25891
8210	6990	24	applied	\N	\N	\N	\N	25892	25892	25893
8210	6991	25	applied	\N	\N	\N	\N	25894	25894	25895
8210	6992	26	applied	\N	\N	\N	\N	25899	25899	25900
8210	6993	27	applied	\N	\N	\N	\N	25901	25901	25902
8210	6994	28	applied	\N	\N	\N	\N	25907	25907	25908
8210	6995	29	applied	\N	\N	\N	\N	25915	25915	25916
8210	6996	30	applied	\N	\N	\N	\N	25919	25919	25920
8210	6997	31	applied	\N	\N	\N	\N	25921	25921	25922
8210	6998	32	applied	\N	\N	\N	\N	25930	25930	25931
8210	6999	33	applied	\N	\N	\N	\N	25934	25934	25935
8210	7000	34	applied	\N	\N	\N	\N	25937	25937	25938
8210	7001	35	applied	\N	\N	\N	\N	25939	25939	25940
8210	7002	36	applied	\N	\N	\N	\N	25942	25942	25943
8210	7003	37	applied	\N	\N	\N	\N	25944	25944	25945
8210	7004	38	applied	\N	\N	\N	\N	25946	25946	25947
8210	7005	39	applied	\N	\N	\N	\N	25948	25948	25949
8210	7006	40	applied	\N	\N	\N	\N	25952	25952	25953
8210	7007	41	applied	\N	\N	\N	\N	25956	25956	25957
8210	7008	42	applied	\N	\N	\N	\N	25960	25960	25961
8210	7009	43	applied	\N	\N	\N	\N	25964	25964	25965
8210	7010	44	applied	\N	\N	\N	\N	25968	25968	25969
8210	7011	45	applied	\N	\N	\N	\N	25971	25971	25972
8210	7012	46	applied	\N	\N	\N	\N	25975	25975	25976
8210	7013	47	applied	\N	\N	\N	\N	25977	25977	25978
8210	7014	48	applied	\N	\N	\N	\N	25981	25981	25982
8210	7015	49	applied	\N	\N	\N	\N	25987	25987	25988
8210	7016	50	applied	\N	\N	\N	\N	25993	25993	25994
8210	7017	51	applied	\N	\N	\N	\N	25999	25999	26000
8210	7018	52	applied	\N	\N	1000000000	\N	26001	26001	26002
8210	7019	53	applied	\N	\N	\N	\N	26003	26003	26004
8210	7020	54	applied	\N	\N	\N	\N	26005	26005	26006
8210	7021	55	applied	\N	\N	\N	\N	26013	26013	26014
8210	7022	57	applied	\N	\N	\N	\N	26017	26017	26018
8210	7023	58	applied	\N	\N	\N	\N	26019	26019	26020
8211	7024	0	applied	\N	\N	\N	\N	26028	26028	26029
8214	7027	0	applied	\N	\N	\N	\N	26038	26038	26039
8219	7029	0	applied	\N	\N	\N	\N	26046	26046	26047
8219	7030	1	applied	\N	\N	1000000000	\N	26048	26048	26049
8223	7032	0	applied	\N	\N	\N	\N	26058	26058	26059
8225	7033	0	applied	\N	\N	\N	\N	26064	26064	26065
8230	7036	0	applied	\N	\N	\N	\N	26078	26078	26079
8230	7037	1	applied	\N	\N	\N	\N	26080	26080	26081
8230	7038	2	applied	\N	\N	\N	\N	26082	26082	26083
8234	7036	0	applied	\N	\N	\N	\N	26078	26078	26079
8234	7037	1	applied	\N	\N	\N	\N	26080	26080	26081
8234	7038	2	applied	\N	\N	\N	\N	26082	26082	26083
8237	7041	0	applied	\N	\N	\N	\N	26095	26095	26096
8240	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8244	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8244	7043	1	applied	\N	\N	\N	\N	26108	26108	26109
8246	7042	0	applied	\N	\N	\N	\N	26098	26098	26099
8246	7043	1	applied	\N	\N	\N	\N	26108	26108	26109
8246	7044	3	applied	\N	\N	\N	\N	26111	26111	26112
8248	7045	0	applied	\N	\N	\N	\N	26123	26123	26124
8251	7047	0	applied	\N	\N	\N	\N	26131	26131	26132
8255	7048	0	applied	\N	\N	\N	\N	26140	26140	26141
8255	7049	1	applied	\N	\N	\N	\N	26142	26142	26143
8266	7063	0	applied	\N	\N	\N	\N	26182	26182	26183
8266	7064	1	applied	\N	\N	\N	\N	26184	26184	26185
8266	7065	2	applied	\N	\N	\N	\N	26186	26186	26187
8271	7067	0	applied	\N	\N	\N	\N	26196	26196	26197
8274	7069	0	applied	\N	\N	\N	\N	26205	26205	26206
8274	7070	1	applied	\N	\N	\N	\N	26207	26207	26208
8274	7071	2	applied	\N	\N	\N	\N	26209	26209	26210
8281	7078	0	applied	\N	\N	\N	\N	26233	26233	26234
8283	7079	0	applied	\N	\N	\N	\N	26237	26237	26238
8288	7083	0	applied	\N	\N	\N	\N	26257	26257	26258
8288	7084	1	applied	\N	\N	1000000000	\N	26259	26259	26260
8293	7088	0	applied	\N	\N	\N	\N	26276	26276	26277
8293	7089	1	applied	\N	\N	\N	\N	26278	26278	26279
8302	7093	0	applied	\N	\N	\N	\N	26296	26296	26297
8302	7094	1	applied	\N	\N	\N	\N	26298	26298	26299
8304	7095	0	applied	\N	\N	\N	\N	26302	26302	26303
8307	7095	0	applied	\N	\N	\N	\N	26302	26302	26303
8309	7096	0	applied	\N	\N	\N	\N	26307	26307	26308
8309	7097	1	applied	\N	\N	\N	\N	26309	26309	26310
8309	7098	2	applied	\N	\N	\N	\N	26311	26311	26312
8311	7099	0	applied	\N	\N	\N	\N	26322	26322	26323
8265	7062	1	applied	\N	\N	\N	\N	26178	26178	26179
8268	7066	0	applied	\N	\N	\N	\N	26192	26192	26186
8270	7067	0	applied	\N	\N	\N	\N	26196	26196	26197
8273	7069	0	applied	\N	\N	\N	\N	26205	26205	26206
8273	7070	1	applied	\N	\N	\N	\N	26207	26207	26208
8273	7071	2	applied	\N	\N	\N	\N	26209	26209	26210
8276	7075	0	applied	\N	\N	\N	\N	26220	26220	26221
8279	7076	0	applied	\N	\N	\N	\N	26224	26224	26225
8279	7077	1	applied	\N	\N	\N	\N	26226	26226	26216
8280	7076	0	applied	\N	\N	\N	\N	26224	26224	26225
8280	7077	1	applied	\N	\N	\N	\N	26226	26226	26216
8290	7085	0	applied	\N	\N	\N	\N	26265	26265	26266
8290	7086	1	applied	\N	\N	\N	\N	26267	26267	26268
8290	7087	2	applied	\N	\N	\N	\N	26269	26269	26270
8297	7090	0	applied	\N	\N	\N	\N	26284	26284	1435
8299	7092	0	applied	\N	\N	\N	\N	26290	26290	26291
8306	7095	0	applied	\N	\N	\N	\N	26302	26302	26303
8308	7096	0	applied	\N	\N	\N	\N	26307	26307	26308
8308	7097	1	applied	\N	\N	\N	\N	26309	26309	26310
8308	7098	2	applied	\N	\N	\N	\N	26311	26311	26312
8313	7100	0	applied	\N	\N	\N	\N	26327	26327	26328
8313	7101	1	applied	\N	\N	\N	\N	26329	26329	26330
8313	7102	2	applied	\N	\N	\N	\N	26331	26331	26332
8316	7104	0	applied	\N	\N	\N	\N	26339	26339	1435
8316	7105	1	applied	\N	\N	\N	\N	26340	26340	26341
8316	7106	2	applied	\N	\N	\N	\N	26342	26342	26343
8316	7107	3	applied	\N	\N	\N	\N	26344	26344	26345
8316	7108	4	applied	\N	\N	\N	\N	26346	26346	26331
8323	7111	0	applied	\N	\N	\N	\N	26359	26359	26360
8323	7112	1	applied	\N	\N	\N	\N	26361	26361	26362
8326	7115	0	applied	\N	\N	\N	\N	26371	26371	26372
8333	7120	0	applied	\N	\N	\N	\N	26388	26388	26389
8336	7124	0	applied	\N	\N	\N	\N	26398	26398	26399
8339	7125	0	applied	\N	\N	\N	\N	26402	26402	26403
8343	7125	0	applied	\N	\N	\N	\N	26402	26402	26403
8343	7126	1	applied	\N	\N	\N	\N	26408	26408	26409
8343	7127	2	applied	\N	\N	\N	\N	26410	26410	26411
8345	7134	0	applied	\N	\N	\N	\N	26429	26429	26430
8367	7161	0	applied	\N	\N	\N	\N	26513	26513	26514
8372	7164	0	applied	\N	\N	\N	\N	26523	26523	26524
8374	7167	0	applied	\N	\N	\N	\N	26532	26532	26533
8378	7170	0	applied	\N	\N	\N	\N	26539	26539	1435
8378	7171	1	applied	\N	\N	\N	\N	26540	26540	26541
8378	7172	2	applied	\N	\N	\N	\N	26542	26542	26543
8378	7173	3	applied	\N	\N	\N	\N	26544	26544	26545
8382	7174	0	applied	\N	\N	\N	\N	26554	26554	26555
8382	7175	1	applied	\N	\N	\N	\N	26556	26556	26557
8387	7182	0	applied	\N	\N	\N	\N	26579	26579	26580
8389	7183	0	applied	\N	\N	\N	\N	26586	26586	26587
8389	7184	1	applied	\N	\N	\N	\N	26588	26588	26589
8391	7185	0	applied	\N	\N	\N	\N	26593	26593	26594
8398	7190	0	applied	\N	\N	\N	\N	26611	26611	26612
8409	7196	0	applied	\N	\N	\N	\N	26631	26631	26632
8455	7207	0	applied	\N	\N	\N	\N	26687	26687	26688
8457	7208	0	applied	\N	\N	\N	\N	26690	26690	26691
8461	7209	0	applied	\N	\N	\N	\N	26696	26696	26697
8463	7210	0	applied	\N	\N	\N	\N	26701	26701	26702
8466	7212	0	applied	\N	\N	\N	\N	26706	26706	26707
8469	7213	0	applied	\N	\N	\N	\N	26713	26713	26714
8469	7214	1	applied	\N	\N	\N	\N	26715	26715	26716
8469	7215	2	applied	\N	\N	\N	\N	26717	26717	26718
8469	7216	3	applied	\N	\N	\N	\N	26719	26719	26720
8469	7217	4	applied	\N	\N	\N	\N	26721	26721	26722
8475	7220	0	applied	\N	\N	\N	\N	26734	26734	26735
8478	7222	0	applied	\N	\N	\N	\N	26740	26740	26741
8478	7223	1	applied	\N	\N	1000000000	\N	26742	26742	26743
8480	7224	0	applied	\N	\N	\N	\N	26748	26748	26749
8485	7227	0	applied	\N	\N	\N	\N	26760	26760	26761
8485	7228	1	applied	\N	\N	\N	\N	26762	26762	26763
8489	7230	0	applied	\N	\N	\N	\N	26775	26775	26776
8494	7235	0	applied	\N	\N	\N	\N	26792	26792	26793
8496	7236	0	applied	\N	\N	\N	\N	26796	26796	26797
8498	7236	0	applied	\N	\N	\N	\N	26796	26796	26797
8503	7239	0	applied	\N	\N	\N	\N	26809	26809	26810
8506	7241	0	applied	\N	\N	\N	\N	26816	26816	26817
8510	7243	0	applied	\N	\N	\N	\N	26826	26826	26827
8515	7247	0	applied	\N	\N	\N	\N	26841	26841	26842
8518	7248	0	applied	\N	\N	\N	\N	26847	26847	26848
8518	7249	1	applied	\N	\N	\N	\N	26849	26849	26850
8522	7251	0	applied	\N	\N	\N	\N	26856	26856	26857
8522	7252	1	applied	\N	\N	\N	\N	26858	26858	26859
8522	7253	2	applied	\N	\N	\N	\N	26860	26860	26861
8523	7254	0	applied	\N	\N	\N	\N	26864	26864	26865
8523	7255	1	applied	\N	\N	\N	\N	26866	26866	26867
8532	7260	0	applied	\N	\N	\N	\N	26888	26888	26889
8534	7261	0	applied	\N	\N	\N	\N	26892	26892	26893
8540	7267	0	applied	\N	\N	\N	\N	26905	26905	26906
8554	7277	0	applied	\N	\N	\N	\N	26940	26940	26941
8557	7280	0	applied	\N	\N	\N	\N	26951	26951	26952
8559	7281	0	applied	\N	\N	\N	\N	26955	26955	26956
8562	7283	0	applied	\N	\N	\N	\N	26959	26959	26960
8562	7284	1	applied	\N	\N	\N	\N	26961	26961	26962
8567	7287	0	applied	\N	\N	\N	\N	26973	26973	26974
8569	7288	0	applied	\N	\N	\N	\N	26979	26979	26980
8572	7291	0	applied	\N	\N	\N	\N	26989	26989	26990
8572	7292	1	applied	\N	\N	\N	\N	26991	26991	26992
8574	7293	0	applied	\N	\N	\N	\N	26996	26996	26997
8577	7296	0	applied	\N	\N	\N	\N	27006	27006	27007
8584	7225	0	applied	\N	\N	\N	\N	27025	27025	1435
8584	7200	1	applied	\N	\N	\N	\N	26662	26662	26663
8584	7232	2	applied	\N	\N	\N	\N	26781	26781	26782
8584	7202	3	applied	\N	\N	\N	\N	26670	26670	26671
8584	7203	4	applied	\N	\N	1000000000	\N	26672	26672	26673
8584	7204	5	applied	\N	\N	\N	\N	26674	26674	26675
8584	7205	6	applied	\N	\N	\N	\N	26679	26679	26680
8584	7206	7	applied	\N	\N	\N	\N	26682	26682	26683
8584	7207	8	applied	\N	\N	\N	\N	26687	26687	26688
8584	7208	9	applied	\N	\N	\N	\N	26690	26690	26691
8584	7209	10	applied	\N	\N	\N	\N	26696	26696	26697
8584	7210	11	applied	\N	\N	\N	\N	26701	26701	26702
8584	7211	12	applied	\N	\N	\N	\N	26703	26703	26704
8584	7212	13	applied	\N	\N	\N	\N	26706	26706	26707
8584	7213	14	applied	\N	\N	\N	\N	26713	26713	26714
8584	7214	15	applied	\N	\N	\N	\N	26715	26715	26716
8584	7215	16	applied	\N	\N	\N	\N	26717	26717	26718
8584	7216	17	applied	\N	\N	\N	\N	26719	26719	26720
8584	7217	18	applied	\N	\N	\N	\N	26721	26721	26722
8584	7218	19	applied	\N	\N	\N	\N	26724	26724	26725
8584	7219	20	applied	\N	\N	\N	\N	26730	26730	26731
8286	7080	0	applied	\N	\N	\N	\N	26247	26247	26248
8286	7081	1	applied	\N	\N	\N	\N	26249	26249	26250
8289	7083	0	applied	\N	\N	\N	\N	26257	26257	26258
8289	7084	1	applied	\N	\N	1000000000	\N	26259	26259	26260
8291	7085	0	applied	\N	\N	\N	\N	26265	26265	26266
8291	7086	1	applied	\N	\N	\N	\N	26267	26267	26268
8291	7087	2	applied	\N	\N	\N	\N	26269	26269	26270
8294	7088	0	applied	\N	\N	\N	\N	26276	26276	26277
8294	7089	1	applied	\N	\N	\N	\N	26278	26278	26279
8295	7088	0	applied	\N	\N	\N	\N	26276	26276	26277
8295	7089	1	applied	\N	\N	\N	\N	26278	26278	26279
8298	7091	0	applied	\N	\N	\N	\N	26287	26287	26288
8298	7090	1	applied	\N	\N	\N	\N	26284	26284	1435
8300	7092	0	applied	\N	\N	\N	\N	26290	26290	26291
8303	7093	0	applied	\N	\N	\N	\N	26296	26296	26297
8303	7094	1	applied	\N	\N	\N	\N	26298	26298	26299
8305	7095	0	applied	\N	\N	\N	\N	26302	26302	26303
8312	7099	0	applied	\N	\N	\N	\N	26322	26322	26323
8327	7115	0	applied	\N	\N	\N	\N	26371	26371	26372
8329	7116	0	applied	\N	\N	\N	\N	26375	26375	26376
8332	7119	0	applied	\N	\N	\N	\N	26385	26385	26386
8335	7122	0	applied	\N	\N	\N	\N	26394	26394	26395
8335	7123	1	applied	\N	\N	\N	\N	26396	26396	26397
8341	7125	0	applied	\N	\N	\N	\N	26402	26402	26403
8344	7128	0	applied	\N	\N	1000000000	\N	26415	26415	26416
8344	7129	1	applied	\N	\N	\N	\N	26417	26417	26418
8344	7130	2	applied	\N	\N	1000000000	\N	26419	26419	26420
8344	7131	3	applied	\N	\N	1000000000	\N	26421	26421	26422
8344	7132	4	applied	\N	\N	1000000000	\N	26423	26423	26424
8344	7133	5	applied	\N	\N	1000000000	\N	26425	26425	26426
8347	7136	0	applied	\N	\N	\N	\N	26435	26435	26436
8347	7137	1	applied	\N	\N	\N	\N	26437	26437	26438
8347	7138	2	applied	\N	\N	1000000000	\N	26439	26439	26440
8349	7136	0	applied	\N	\N	\N	\N	26435	26435	26436
8349	7137	1	applied	\N	\N	\N	\N	26437	26437	26438
8349	7138	2	applied	\N	\N	1000000000	\N	26439	26439	26440
8352	7139	0	applied	\N	\N	\N	\N	26445	26445	26446
8352	7140	1	applied	\N	\N	\N	\N	26447	26447	26448
8352	7141	2	applied	\N	\N	\N	\N	26449	26449	2824
8354	7142	0	applied	\N	\N	\N	\N	26456	26456	26457
8354	7143	1	applied	\N	\N	\N	\N	26458	26458	26459
8354	7144	2	applied	\N	\N	\N	\N	26460	26460	26461
8354	7145	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	26462	26462	\N
8357	7148	0	applied	\N	\N	\N	\N	26471	26471	26472
8357	7149	1	applied	\N	\N	\N	\N	26473	26473	26474
8360	7152	0	applied	\N	\N	\N	\N	26483	26483	26484
8360	7153	1	applied	\N	\N	\N	\N	26485	26485	26486
8363	7157	0	applied	\N	\N	\N	\N	26497	26497	26498
8363	7158	1	applied	\N	\N	\N	\N	26499	26499	26500
8369	7161	0	applied	\N	\N	\N	\N	26513	26513	26514
8373	7165	0	applied	\N	\N	\N	\N	26527	26527	26528
8373	7166	1	applied	\N	\N	1000000000	\N	26529	26529	26530
8376	7170	0	applied	\N	\N	\N	\N	26539	26539	1435
8376	7171	1	applied	\N	\N	\N	\N	26540	26540	26541
8376	7172	2	applied	\N	\N	\N	\N	26542	26542	26543
8376	7173	3	applied	\N	\N	\N	\N	26544	26544	26545
8380	7170	0	applied	\N	\N	\N	\N	26539	26539	1435
8380	7171	1	applied	\N	\N	\N	\N	26540	26540	26541
8380	7172	2	applied	\N	\N	\N	\N	26542	26542	26543
8380	7173	3	applied	\N	\N	\N	\N	26544	26544	26545
8383	7176	0	applied	\N	\N	\N	\N	26561	26561	26562
8383	7177	1	applied	\N	\N	\N	\N	26563	26563	26564
8383	7178	2	applied	\N	\N	\N	\N	26565	26565	26566
8383	7179	3	applied	\N	\N	\N	\N	26567	26567	26568
8383	7180	4	applied	\N	\N	\N	\N	26569	26569	26570
8388	6991	0	applied	\N	\N	\N	\N	25894	25894	25895
8388	6992	1	applied	\N	\N	\N	\N	25899	25899	25900
8388	6993	2	applied	\N	\N	\N	\N	25901	25901	25902
8388	6994	3	applied	\N	\N	\N	\N	25907	25907	25908
8388	6995	4	applied	\N	\N	\N	\N	25915	25915	25916
8388	6996	5	applied	\N	\N	\N	\N	25919	25919	25920
8388	6997	6	applied	\N	\N	\N	\N	25921	25921	25922
8388	6998	7	applied	\N	\N	\N	\N	25930	25930	25931
8388	6999	8	applied	\N	\N	\N	\N	25934	25934	25935
8388	7000	9	applied	\N	\N	\N	\N	25937	25937	25938
8388	7001	10	applied	\N	\N	\N	\N	25939	25939	25940
8388	7002	11	applied	\N	\N	\N	\N	25942	25942	25943
8388	7003	12	applied	\N	\N	\N	\N	25944	25944	25945
8388	7004	13	applied	\N	\N	\N	\N	25946	25946	25947
8388	7138	14	applied	\N	\N	1000000000	\N	26439	26439	26440
8388	7005	15	applied	\N	\N	\N	\N	25948	25948	25949
8388	7006	16	applied	\N	\N	\N	\N	25952	25952	25953
8388	7007	17	applied	\N	\N	\N	\N	25956	25956	25957
8388	7008	18	applied	\N	\N	\N	\N	25960	25960	25961
8388	7009	19	applied	\N	\N	\N	\N	25964	25964	25965
8388	7010	20	applied	\N	\N	\N	\N	25968	25968	25969
8388	7011	21	applied	\N	\N	\N	\N	25971	25971	25972
8388	7012	22	applied	\N	\N	\N	\N	25975	25975	25976
8388	7013	23	applied	\N	\N	\N	\N	25977	25977	25978
8388	7014	24	applied	\N	\N	\N	\N	25981	25981	25982
8388	7015	25	applied	\N	\N	\N	\N	25987	25987	25988
8388	7016	26	applied	\N	\N	\N	\N	25993	25993	25994
8388	7017	27	applied	\N	\N	\N	\N	25999	25999	26000
8388	7018	28	applied	\N	\N	1000000000	\N	26001	26001	26002
8388	7019	29	applied	\N	\N	\N	\N	26003	26003	26004
8388	7020	30	applied	\N	\N	\N	\N	26005	26005	26006
8388	7021	31	applied	\N	\N	\N	\N	26013	26013	26014
8388	7022	32	applied	\N	\N	\N	\N	26017	26017	26018
8388	7023	33	applied	\N	\N	\N	\N	26019	26019	26020
8388	7024	34	applied	\N	\N	\N	\N	26028	26028	26029
8388	7025	35	applied	\N	\N	\N	\N	26032	26032	26033
8388	7026	36	applied	\N	\N	\N	\N	26034	26034	26035
8388	7027	37	applied	\N	\N	\N	\N	26038	26038	26039
8388	7028	38	applied	\N	\N	\N	\N	26044	26044	26045
8388	7029	39	applied	\N	\N	\N	\N	26046	26046	26047
8388	7030	40	applied	\N	\N	1000000000	\N	26048	26048	26049
8388	7031	41	applied	\N	\N	\N	\N	26055	26055	26056
8388	7032	42	applied	\N	\N	\N	\N	26058	26058	26059
8388	7033	43	applied	\N	\N	\N	\N	26064	26064	26065
8388	7034	44	applied	\N	\N	\N	\N	26070	26070	26071
8388	7035	45	applied	\N	\N	\N	\N	26074	26074	26075
8388	7036	46	applied	\N	\N	\N	\N	26078	26078	26079
8388	7037	47	applied	\N	\N	\N	\N	26080	26080	26081
8388	7038	48	applied	\N	\N	\N	\N	26082	26082	26083
8388	7039	49	applied	\N	\N	\N	\N	26089	26089	26090
8388	7040	50	applied	\N	\N	\N	\N	26091	26091	26092
8388	7041	51	applied	\N	\N	\N	\N	26095	26095	26096
8388	7042	52	applied	\N	\N	\N	\N	26098	26098	26099
8310	7042	56	applied	\N	\N	\N	\N	26098	26098	26099
8310	7043	57	applied	\N	\N	\N	\N	26108	26108	26109
8310	7044	58	applied	\N	\N	\N	\N	26111	26111	26112
8310	7045	59	applied	\N	\N	\N	\N	26123	26123	26124
8310	7046	60	applied	\N	\N	\N	\N	26127	26127	26128
8310	7047	61	applied	\N	\N	\N	\N	26131	26131	26132
8310	7048	62	applied	\N	\N	\N	\N	26140	26140	26141
8310	7050	63	applied	\N	\N	\N	\N	26148	26148	26149
8310	7051	64	applied	\N	\N	\N	\N	26150	26150	26151
8310	7052	65	applied	\N	\N	\N	\N	26152	26152	26153
8310	7054	66	applied	\N	\N	\N	\N	26158	26158	26159
8310	7055	67	applied	\N	\N	\N	\N	26160	26160	26161
8310	7056	68	applied	\N	\N	\N	\N	26162	26162	26163
8310	7057	69	applied	\N	\N	\N	\N	26164	26164	26165
8310	7058	70	applied	\N	\N	\N	\N	26166	26166	26167
8310	7059	71	applied	\N	\N	\N	\N	26171	26171	26172
8310	7061	72	applied	\N	\N	\N	\N	26176	26176	26177
8310	7062	73	applied	\N	\N	\N	\N	26178	26178	26179
8310	7063	74	applied	\N	\N	\N	\N	26182	26182	26183
8310	7064	75	applied	\N	\N	\N	\N	26184	26184	26185
8310	7067	76	applied	\N	\N	\N	\N	26196	26196	26197
8310	7068	77	applied	\N	\N	\N	\N	26201	26201	26202
8310	7069	78	applied	\N	\N	\N	\N	26205	26205	26206
8310	7070	79	applied	\N	\N	\N	\N	26207	26207	26208
8310	7071	80	applied	\N	\N	\N	\N	26209	26209	26210
8310	7072	81	applied	\N	\N	\N	\N	26212	26212	26213
8310	7073	82	applied	\N	\N	\N	\N	26214	26214	26215
8310	7075	83	applied	\N	\N	\N	\N	26220	26220	26221
8310	7076	84	applied	\N	\N	\N	\N	26224	26224	26225
8310	7078	85	applied	\N	\N	\N	\N	26233	26233	26234
8310	7079	86	applied	\N	\N	\N	\N	26237	26237	26238
8310	7080	87	applied	\N	\N	\N	\N	26247	26247	26248
8310	7081	88	applied	\N	\N	\N	\N	26249	26249	26250
8310	7082	89	applied	\N	\N	\N	\N	26253	26253	26254
8310	7083	90	applied	\N	\N	\N	\N	26257	26257	26258
8310	7085	91	applied	\N	\N	\N	\N	26265	26265	26266
8310	7086	92	applied	\N	\N	\N	\N	26267	26267	26268
8310	7088	93	applied	\N	\N	\N	\N	26276	26276	26277
8310	7089	94	applied	\N	\N	\N	\N	26278	26278	26279
8310	7091	95	applied	\N	\N	\N	\N	26287	26287	26288
8310	7092	96	applied	\N	\N	\N	\N	26290	26290	26291
8310	7093	97	applied	\N	\N	\N	\N	26296	26296	26297
8310	7095	98	applied	\N	\N	\N	\N	26302	26302	26303
8310	7084	99	applied	\N	\N	1000000000	\N	26259	26259	26260
8310	7090	100	applied	\N	\N	\N	\N	26284	26284	1435
8310	7049	101	applied	\N	\N	\N	\N	26316	26316	26143
8310	7065	102	applied	\N	\N	\N	\N	26317	26317	26187
8310	7094	103	applied	\N	\N	\N	\N	26298	26298	26318
8310	7074	104	applied	\N	\N	1000000000	\N	26319	26319	26217
8318	7104	0	applied	\N	\N	\N	\N	26339	26339	1435
8318	7105	1	applied	\N	\N	\N	\N	26340	26340	26341
8318	7106	2	applied	\N	\N	\N	\N	26342	26342	26343
8318	7107	3	applied	\N	\N	\N	\N	26344	26344	26345
8318	7108	4	applied	\N	\N	\N	\N	26346	26346	26331
8320	7110	0	applied	\N	\N	\N	\N	26353	26353	26311
8325	7113	0	applied	\N	\N	\N	\N	26364	26364	26365
8325	7114	1	applied	\N	\N	\N	\N	26366	26366	26367
8328	7115	0	applied	\N	\N	\N	\N	26371	26371	26372
8330	7117	0	applied	\N	\N	\N	\N	26379	26379	26380
8342	7125	0	applied	\N	\N	\N	\N	26402	26402	26403
8342	7126	1	applied	\N	\N	\N	\N	26408	26408	26409
8342	7127	2	applied	\N	\N	\N	\N	26410	26410	26411
8348	7136	0	applied	\N	\N	\N	\N	26435	26435	26436
8348	7137	1	applied	\N	\N	\N	\N	26437	26437	26438
8348	7138	2	applied	\N	\N	1000000000	\N	26439	26439	26440
8350	7139	0	applied	\N	\N	\N	\N	26445	26445	26446
8350	7140	1	applied	\N	\N	\N	\N	26447	26447	26448
8350	7141	2	applied	\N	\N	\N	\N	26449	26449	2824
8353	7139	0	applied	\N	\N	\N	\N	26445	26445	26446
8353	7140	1	applied	\N	\N	\N	\N	26447	26447	26448
8353	7141	2	applied	\N	\N	\N	\N	26449	26449	2824
8355	7146	0	applied	\N	\N	\N	\N	26465	26465	26466
8355	7147	1	applied	\N	\N	\N	\N	26467	26467	26468
8358	7148	0	applied	\N	\N	\N	\N	26471	26471	26472
8358	7149	1	applied	\N	\N	\N	\N	26473	26473	26474
8361	7154	0	applied	\N	\N	\N	\N	26489	26489	26490
8361	7155	1	applied	\N	\N	\N	\N	26491	26491	26492
8364	7159	0	applied	\N	\N	\N	\N	26503	26503	26504
8366	7160	0	applied	\N	\N	\N	\N	26509	26509	26510
8371	7164	0	applied	\N	\N	\N	\N	26523	26523	26524
8377	7170	0	applied	\N	\N	\N	\N	26539	26539	1435
8377	7171	1	applied	\N	\N	\N	\N	26540	26540	26541
8377	7172	2	applied	\N	\N	\N	\N	26542	26542	26543
8377	7173	3	applied	\N	\N	\N	\N	26544	26544	26545
8381	7174	0	applied	\N	\N	\N	\N	26554	26554	26555
8381	7175	1	applied	\N	\N	\N	\N	26556	26556	26557
8384	7181	0	applied	\N	\N	\N	\N	26573	26573	26574
8386	7182	0	applied	\N	\N	\N	\N	26579	26579	26580
8400	7191	0	applied	\N	\N	\N	\N	26614	26614	26615
8403	7192	0	applied	\N	\N	\N	\N	26617	26617	26618
8405	7194	0	applied	\N	\N	\N	\N	26623	26623	26624
8406	7194	0	applied	\N	\N	\N	\N	26623	26623	26624
8408	7195	0	applied	\N	\N	\N	\N	26627	26627	26628
8412	7197	0	applied	\N	\N	\N	\N	26637	26637	26638
8412	7198	1	applied	\N	\N	1000000000	\N	26639	26639	26640
8412	7199	2	applied	\N	\N	\N	\N	26641	26641	26642
8449	7202	0	applied	\N	\N	\N	\N	26670	26670	26671
8449	7203	1	applied	\N	\N	1000000000	\N	26672	26672	26673
8449	7204	2	applied	\N	\N	\N	\N	26674	26674	26675
8452	7205	0	applied	\N	\N	\N	\N	26679	26679	26680
8456	7208	0	applied	\N	\N	\N	\N	26690	26690	26691
8459	7208	0	applied	\N	\N	\N	\N	26690	26690	26691
8462	7209	0	applied	\N	\N	\N	\N	26696	26696	26697
8470	7218	0	applied	\N	\N	\N	\N	26724	26724	26725
8472	7219	0	applied	\N	\N	\N	\N	26730	26730	26731
8474	7219	0	applied	\N	\N	\N	\N	26730	26730	26731
8481	7225	0	applied	\N	\N	\N	\N	26753	26753	1435
8481	7226	1	applied	\N	\N	\N	\N	26754	26754	26755
8483	7225	0	applied	\N	\N	\N	\N	26753	26753	1435
8483	7226	1	applied	\N	\N	\N	\N	26754	26754	26755
8488	7229	0	applied	\N	\N	\N	\N	26769	26769	26770
8491	7231	0	applied	\N	\N	\N	\N	26779	26779	26780
8491	7232	1	applied	\N	\N	\N	\N	26781	26781	26782
8491	7233	2	applied	\N	\N	\N	\N	26783	26783	26784
8493	7234	0	applied	\N	\N	\N	\N	26788	26788	26789
8502	7238	0	applied	\N	\N	\N	\N	26803	26803	26804
8504	7240	0	applied	\N	\N	\N	\N	26812	26812	26813
8511	7244	0	applied	\N	\N	\N	\N	26830	26830	26831
8516	7247	0	applied	\N	\N	\N	\N	26841	26841	26842
8314	7103	0	applied	\N	\N	\N	\N	26335	26335	26336
8317	7104	0	applied	\N	\N	\N	\N	26339	26339	1435
8317	7105	1	applied	\N	\N	\N	\N	26340	26340	26341
8317	7106	2	applied	\N	\N	\N	\N	26342	26342	26343
8317	7107	3	applied	\N	\N	\N	\N	26344	26344	26345
8317	7108	4	applied	\N	\N	\N	\N	26346	26346	26331
8319	7109	0	applied	\N	\N	\N	\N	26351	26351	26352
8321	7110	0	applied	\N	\N	\N	\N	26353	26353	26311
8322	7110	0	applied	\N	\N	\N	\N	26353	26353	26311
8324	7113	0	applied	\N	\N	\N	\N	26364	26364	26365
8324	7114	1	applied	\N	\N	\N	\N	26366	26366	26367
8331	7118	0	applied	\N	\N	\N	\N	26383	26383	26384
8334	7121	0	applied	\N	\N	\N	\N	26392	26392	26393
8337	7124	0	applied	\N	\N	\N	\N	26398	26398	26399
8340	7125	0	applied	\N	\N	\N	\N	26402	26402	26403
8346	7135	0	applied	\N	\N	\N	\N	26433	26433	26434
8351	7139	0	applied	\N	\N	\N	\N	26445	26445	26446
8351	7140	1	applied	\N	\N	\N	\N	26447	26447	26448
8351	7141	2	applied	\N	\N	\N	\N	26449	26449	2824
8356	7146	0	applied	\N	\N	\N	\N	26465	26465	26466
8356	7147	1	applied	\N	\N	\N	\N	26467	26467	26468
8359	7150	0	applied	\N	\N	\N	\N	26477	26477	26478
8359	7151	1	applied	\N	\N	\N	\N	26479	26479	26480
8362	7156	0	applied	\N	\N	\N	\N	26495	26495	26496
8365	7159	0	applied	\N	\N	\N	\N	26503	26503	26504
8368	7161	0	applied	\N	\N	\N	\N	26513	26513	26514
8370	7162	0	applied	\N	\N	\N	\N	26519	26519	26520
8370	7163	1	applied	\N	\N	\N	\N	26521	26521	26522
8375	7168	0	applied	\N	\N	\N	\N	26534	26534	26535
8375	7169	1	applied	\N	\N	\N	\N	26536	26536	1435
8379	7170	0	applied	\N	\N	\N	\N	26539	26539	1435
8379	7171	1	applied	\N	\N	\N	\N	26540	26540	26541
8379	7172	2	applied	\N	\N	\N	\N	26542	26542	26543
8379	7173	3	applied	\N	\N	\N	\N	26544	26544	26545
8385	7181	0	applied	\N	\N	\N	\N	26573	26573	26574
8390	7183	0	applied	\N	\N	\N	\N	26586	26586	26587
8390	7184	1	applied	\N	\N	\N	\N	26588	26588	26589
8392	7186	0	applied	\N	\N	\N	\N	26597	26597	26598
8394	7187	0	applied	\N	\N	\N	\N	26601	26601	26602
8394	7188	1	applied	\N	\N	\N	\N	26603	26603	26567
8396	7187	0	applied	\N	\N	\N	\N	26601	26601	26602
8396	7188	1	applied	\N	\N	\N	\N	26603	26603	26567
8399	7191	0	applied	\N	\N	\N	\N	26614	26614	26615
8401	7192	0	applied	\N	\N	\N	\N	26617	26617	26618
8410	7196	0	applied	\N	\N	\N	\N	26631	26631	26632
8448	7201	0	applied	\N	\N	\N	\N	26666	26666	26667
8451	7205	0	applied	\N	\N	\N	\N	26679	26679	26680
8453	7206	0	applied	\N	\N	\N	\N	26682	26682	26683
8458	7208	0	applied	\N	\N	\N	\N	26690	26690	26691
8460	7166	0	applied	\N	\N	1000000000	\N	26529	26529	26530
8460	7179	1	applied	\N	\N	\N	\N	26567	26567	26693
8460	7162	2	applied	\N	\N	\N	\N	26519	26519	26520
8460	7163	3	applied	\N	\N	\N	\N	26521	26521	26522
8460	7164	4	applied	\N	\N	\N	\N	26523	26523	26524
8460	7165	5	applied	\N	\N	\N	\N	26527	26527	26528
8464	7211	0	applied	\N	\N	\N	\N	26703	26703	26704
8467	7212	0	applied	\N	\N	\N	\N	26706	26706	26707
8476	7221	0	applied	\N	\N	\N	\N	26738	26738	26739
8487	7229	0	applied	\N	\N	\N	\N	26769	26769	26770
8490	7231	0	applied	\N	\N	\N	\N	26779	26779	26780
8490	7232	1	applied	\N	\N	\N	\N	26781	26781	26782
8490	7233	2	applied	\N	\N	\N	\N	26783	26783	26784
8492	7234	0	applied	\N	\N	\N	\N	26788	26788	26789
8495	7235	0	applied	\N	\N	\N	\N	26792	26792	26793
8497	7236	0	applied	\N	\N	\N	\N	26796	26796	26797
8499	7237	0	applied	\N	\N	\N	\N	26801	26801	26802
8501	7238	0	applied	\N	\N	\N	\N	26803	26803	26804
8508	7242	0	applied	\N	\N	\N	\N	26820	26820	26821
8513	7245	0	applied	\N	\N	\N	\N	26833	26833	26834
8519	7248	0	applied	\N	\N	\N	\N	26847	26847	26848
8519	7249	1	applied	\N	\N	\N	\N	26849	26849	26850
8528	7257	0	applied	\N	\N	\N	\N	26875	26875	26876
8530	7258	0	applied	\N	\N	\N	\N	26881	26881	26882
8530	7259	1	applied	\N	\N	\N	\N	26883	26883	26884
8535	7262	0	applied	\N	\N	\N	\N	26894	26894	26895
8538	7267	0	applied	\N	\N	\N	\N	26905	26905	26906
8543	7269	0	applied	\N	\N	\N	\N	26910	26910	26911
8543	7270	1	applied	\N	\N	\N	\N	26912	26912	26913
8545	7271	0	applied	\N	\N	\N	\N	26920	26920	26921
8548	7274	0	applied	\N	\N	\N	\N	26927	26927	26928
8550	7275	0	applied	\N	\N	\N	\N	26931	26931	26932
8555	7278	0	applied	\N	\N	\N	\N	26944	26944	26945
8560	7281	0	applied	\N	\N	\N	\N	26955	26955	26956
8563	7285	0	applied	\N	\N	\N	\N	26965	26965	26966
8563	7286	1	applied	\N	\N	\N	\N	26967	26967	26968
8565	7287	0	applied	\N	\N	\N	\N	26973	26973	26974
8570	7289	0	applied	\N	\N	\N	\N	26983	26983	26984
8570	7290	1	applied	\N	\N	\N	\N	26985	26985	26986
8573	7291	0	applied	\N	\N	\N	\N	26989	26989	26990
8573	7292	1	applied	\N	\N	\N	\N	26991	26991	26992
8575	7293	0	applied	\N	\N	\N	\N	26996	26996	26997
8580	7299	0	applied	\N	\N	\N	\N	27018	27018	27019
8587	7303	0	applied	\N	\N	\N	\N	27037	27037	27038
8589	7303	0	applied	\N	\N	\N	\N	27037	27037	27038
8592	7306	0	applied	\N	\N	\N	\N	27045	27045	27046
8599	7311	0	applied	\N	\N	\N	\N	27069	27069	27070
8601	7312	0	applied	\N	\N	\N	\N	27073	27073	27074
8603	7313	0	applied	\N	\N	\N	\N	27075	27075	27076
8603	7314	1	applied	\N	\N	\N	\N	27077	27077	27078
8603	7315	2	applied	\N	\N	\N	\N	27079	27079	27080
8603	7316	3	applied	\N	\N	\N	\N	27081	27081	27082
8603	7317	4	applied	\N	\N	\N	\N	27083	27083	27084
8603	7318	5	applied	\N	\N	\N	\N	27085	27085	27086
8603	7319	6	applied	\N	\N	\N	\N	27087	27087	27088
8603	7320	8	applied	\N	\N	\N	\N	27090	27090	27091
8603	7321	9	applied	\N	\N	\N	\N	27092	27092	27093
8603	7322	10	applied	\N	\N	\N	\N	27094	27094	27095
8603	7323	11	applied	\N	\N	\N	\N	27096	27096	27097
8603	7324	12	applied	\N	\N	\N	\N	27098	27098	27099
8603	7325	13	applied	\N	\N	\N	\N	27100	27100	27101
8603	7326	14	applied	\N	\N	\N	\N	27102	27102	27103
8603	7327	15	applied	\N	\N	\N	\N	27104	27104	27105
8603	7328	16	applied	\N	\N	\N	\N	27106	27106	27107
8603	7329	17	applied	\N	\N	\N	\N	27108	27108	27109
8603	7330	18	applied	\N	\N	\N	\N	27110	27110	27111
8606	7301	0	applied	\N	\N	\N	\N	27029	27029	27030
8606	7302	1	applied	\N	\N	\N	\N	27033	27033	27034
8606	7303	2	applied	\N	\N	\N	\N	27037	27037	27038
8606	7304	3	applied	\N	\N	\N	\N	27041	27041	27042
8606	7305	4	applied	\N	\N	\N	\N	27043	27043	27044
8388	7043	53	applied	\N	\N	\N	\N	26108	26108	26109
8388	7044	54	applied	\N	\N	\N	\N	26111	26111	26112
8388	7045	55	applied	\N	\N	\N	\N	26123	26123	26124
8388	7046	56	applied	\N	\N	\N	\N	26127	26127	26128
8388	7047	57	applied	\N	\N	\N	\N	26131	26131	26132
8388	7048	58	applied	\N	\N	\N	\N	26140	26140	26141
8388	7050	59	applied	\N	\N	\N	\N	26148	26148	26149
8388	7051	60	applied	\N	\N	\N	\N	26150	26150	26151
8388	7052	61	applied	\N	\N	\N	\N	26152	26152	26153
8388	7054	62	applied	\N	\N	\N	\N	26158	26158	26159
8388	7055	63	applied	\N	\N	\N	\N	26160	26160	26161
8388	7056	64	applied	\N	\N	\N	\N	26162	26162	26163
8388	7057	65	applied	\N	\N	\N	\N	26164	26164	26165
8388	7058	66	applied	\N	\N	\N	\N	26166	26166	26167
8388	7059	67	applied	\N	\N	\N	\N	26171	26171	26172
8388	7061	68	applied	\N	\N	\N	\N	26176	26176	26177
8388	7062	69	applied	\N	\N	\N	\N	26178	26178	26179
8388	7063	70	applied	\N	\N	\N	\N	26182	26182	26183
8388	7064	71	applied	\N	\N	\N	\N	26184	26184	26185
8388	7067	72	applied	\N	\N	\N	\N	26196	26196	26197
8388	7068	73	applied	\N	\N	\N	\N	26201	26201	26202
8388	7069	74	applied	\N	\N	\N	\N	26205	26205	26206
8388	7070	75	applied	\N	\N	\N	\N	26207	26207	26208
8388	7071	76	applied	\N	\N	\N	\N	26209	26209	26210
8388	7072	77	applied	\N	\N	\N	\N	26212	26212	26213
8388	7073	78	applied	\N	\N	\N	\N	26214	26214	26215
8388	7075	79	applied	\N	\N	\N	\N	26220	26220	26221
8388	7076	80	applied	\N	\N	\N	\N	26224	26224	26225
8388	7078	81	applied	\N	\N	\N	\N	26233	26233	26234
8388	7079	82	applied	\N	\N	\N	\N	26237	26237	26238
8388	7080	83	applied	\N	\N	\N	\N	26247	26247	26248
8388	7081	84	applied	\N	\N	\N	\N	26249	26249	26250
8388	7082	85	applied	\N	\N	\N	\N	26253	26253	26254
8388	7083	86	applied	\N	\N	\N	\N	26257	26257	26258
8388	7085	87	applied	\N	\N	\N	\N	26265	26265	26266
8388	7086	88	applied	\N	\N	\N	\N	26267	26267	26268
8388	7088	89	applied	\N	\N	\N	\N	26276	26276	26277
8388	7089	90	applied	\N	\N	\N	\N	26278	26278	26279
8388	7091	91	applied	\N	\N	\N	\N	26287	26287	26288
8388	7092	92	applied	\N	\N	\N	\N	26290	26290	26291
8388	7093	93	applied	\N	\N	\N	\N	26296	26296	26297
8388	7095	94	applied	\N	\N	\N	\N	26302	26302	26303
8388	7096	95	applied	\N	\N	\N	\N	26307	26307	26308
8388	7097	96	applied	\N	\N	\N	\N	26309	26309	26310
8388	7099	97	applied	\N	\N	\N	\N	26322	26322	26323
8388	7100	98	applied	\N	\N	\N	\N	26327	26327	26328
8388	7101	99	applied	\N	\N	\N	\N	26329	26329	26330
8388	7103	100	applied	\N	\N	\N	\N	26335	26335	26336
8388	7105	101	applied	\N	\N	\N	\N	26340	26340	26341
8388	7106	102	applied	\N	\N	\N	\N	26342	26342	26343
8388	7107	103	applied	\N	\N	\N	\N	26344	26344	26345
8388	7109	104	applied	\N	\N	\N	\N	26351	26351	26352
8388	7111	105	applied	\N	\N	\N	\N	26359	26359	26360
8388	7112	106	applied	\N	\N	\N	\N	26361	26361	26362
8388	7113	107	applied	\N	\N	\N	\N	26364	26364	26365
8388	7114	108	applied	\N	\N	\N	\N	26366	26366	26367
8388	7115	109	applied	\N	\N	\N	\N	26371	26371	26372
8388	7116	110	applied	\N	\N	\N	\N	26375	26375	26376
8388	7117	111	applied	\N	\N	\N	\N	26379	26379	26380
8388	7118	112	applied	\N	\N	\N	\N	26383	26383	26384
8388	7119	113	applied	\N	\N	\N	\N	26385	26385	26386
8388	7120	114	applied	\N	\N	\N	\N	26388	26388	26389
8388	7121	115	applied	\N	\N	\N	\N	26392	26392	26393
8388	7122	116	applied	\N	\N	\N	\N	26394	26394	26395
8388	7123	117	applied	\N	\N	\N	\N	26396	26396	26397
8388	7124	118	applied	\N	\N	\N	\N	26398	26398	26399
8388	7125	119	applied	\N	\N	\N	\N	26402	26402	26403
8388	7126	120	applied	\N	\N	\N	\N	26408	26408	26409
8388	7127	121	applied	\N	\N	\N	\N	26410	26410	26411
8388	7128	122	applied	\N	\N	1000000000	\N	26415	26415	26416
8388	7129	123	applied	\N	\N	\N	\N	26417	26417	26418
8388	7130	124	applied	\N	\N	1000000000	\N	26419	26419	26420
8388	7131	125	applied	\N	\N	1000000000	\N	26421	26421	26422
8393	7186	0	applied	\N	\N	\N	\N	26597	26597	26598
8395	7187	0	applied	\N	\N	\N	\N	26601	26601	26602
8395	7188	1	applied	\N	\N	\N	\N	26603	26603	26567
8397	7189	0	applied	\N	\N	\N	\N	26609	26609	26610
8402	7192	0	applied	\N	\N	\N	\N	26617	26617	26618
8404	7193	0	applied	\N	\N	\N	\N	26621	26621	26622
8407	7194	0	applied	\N	\N	\N	\N	26623	26623	26624
8411	7197	0	applied	\N	\N	\N	\N	26637	26637	26638
8411	7198	1	applied	\N	\N	1000000000	\N	26639	26639	26640
8411	7199	2	applied	\N	\N	\N	\N	26641	26641	26642
8413	7197	0	applied	\N	\N	\N	\N	26637	26637	26638
8413	7198	1	applied	\N	\N	1000000000	\N	26639	26639	26640
8413	7199	2	applied	\N	\N	\N	\N	26641	26641	26642
8447	7200	0	applied	\N	\N	\N	\N	26662	26662	26663
8450	7202	0	applied	\N	\N	\N	\N	26670	26670	26671
8450	7203	1	applied	\N	\N	1000000000	\N	26672	26672	26673
8450	7204	2	applied	\N	\N	\N	\N	26674	26674	26675
8454	7206	0	applied	\N	\N	\N	\N	26682	26682	26683
8465	7212	0	applied	\N	\N	\N	\N	26706	26706	26707
8468	7213	0	applied	\N	\N	\N	\N	26713	26713	26714
8468	7214	1	applied	\N	\N	\N	\N	26715	26715	26716
8468	7215	2	applied	\N	\N	\N	\N	26717	26717	26718
8468	7216	3	applied	\N	\N	\N	\N	26719	26719	26720
8468	7217	4	applied	\N	\N	\N	\N	26721	26721	26722
8471	7218	0	applied	\N	\N	\N	\N	26724	26724	26725
8473	7219	0	applied	\N	\N	\N	\N	26730	26730	26731
8477	7222	0	applied	\N	\N	\N	\N	26740	26740	26741
8477	7223	1	applied	\N	\N	1000000000	\N	26742	26742	26743
8479	7224	0	applied	\N	\N	\N	\N	26748	26748	26749
8482	7225	0	applied	\N	\N	\N	\N	26753	26753	1435
8482	7226	1	applied	\N	\N	\N	\N	26754	26754	26755
8484	7227	0	applied	\N	\N	\N	\N	26760	26760	26761
8484	7228	1	applied	\N	\N	\N	\N	26762	26762	26763
8486	7227	0	applied	\N	\N	\N	\N	26760	26760	26761
8486	7228	1	applied	\N	\N	\N	\N	26762	26762	26763
8500	7237	0	applied	\N	\N	\N	\N	26801	26801	26802
8505	7241	0	applied	\N	\N	\N	\N	26816	26816	26817
8507	7242	0	applied	\N	\N	\N	\N	26820	26820	26821
8509	7242	0	applied	\N	\N	\N	\N	26820	26820	26821
8512	7244	0	applied	\N	\N	\N	\N	26830	26830	26831
8514	7246	0	applied	\N	\N	\N	\N	26837	26837	26838
8517	7248	0	applied	\N	\N	\N	\N	26847	26847	26848
8517	7249	1	applied	\N	\N	\N	\N	26849	26849	26850
8520	7248	0	applied	\N	\N	\N	\N	26847	26847	26848
8520	7249	1	applied	\N	\N	\N	\N	26849	26849	26850
8521	7250	0	applied	\N	\N	\N	\N	26853	26853	26854
8524	7256	0	applied	\N	\N	\N	\N	26870	26870	26871
8526	7257	0	applied	\N	\N	\N	\N	26875	26875	26876
8531	7258	0	applied	\N	\N	\N	\N	26881	26881	26882
8531	7259	1	applied	\N	\N	\N	\N	26883	26883	26884
8533	7260	0	applied	\N	\N	\N	\N	26888	26888	26889
8536	7262	0	applied	\N	\N	\N	\N	26894	26894	26895
8539	7267	0	applied	\N	\N	\N	\N	26905	26905	26906
8541	7268	0	applied	\N	\N	\N	\N	26908	26908	26909
8544	7269	0	applied	\N	\N	\N	\N	26910	26910	26911
8544	7270	1	applied	\N	\N	\N	\N	26912	26912	26913
8546	7272	0	applied	\N	\N	\N	\N	26922	26922	26923
8546	7273	1	applied	\N	\N	\N	\N	26924	26924	26925
8549	7274	0	applied	\N	\N	\N	\N	26927	26927	26928
8553	7276	0	applied	\N	\N	\N	\N	26936	26936	26937
8558	7280	0	applied	\N	\N	\N	\N	26951	26951	26952
8564	7285	0	applied	\N	\N	\N	\N	26965	26965	26966
8564	7286	1	applied	\N	\N	\N	\N	26967	26967	26968
8566	7287	0	applied	\N	\N	\N	\N	26973	26973	26974
8568	7288	0	applied	\N	\N	\N	\N	26979	26979	26980
8571	7289	0	applied	\N	\N	\N	\N	26983	26983	26984
8571	7290	1	applied	\N	\N	\N	\N	26985	26985	26986
8578	7297	0	applied	\N	\N	\N	\N	27010	27010	27011
8581	7299	0	applied	\N	\N	\N	\N	27018	27018	27019
8583	7300	0	applied	\N	\N	\N	\N	27021	27021	27022
8585	7301	0	applied	\N	\N	\N	\N	27029	27029	27030
8588	7303	0	applied	\N	\N	\N	\N	27037	27037	27038
8590	7304	0	applied	\N	\N	\N	\N	27041	27041	27042
8590	7305	1	applied	\N	\N	\N	\N	27043	27043	27044
8597	7309	0	applied	\N	\N	\N	\N	27061	27061	27062
8600	7311	0	applied	\N	\N	\N	\N	27069	27069	27070
8604	7313	0	applied	\N	\N	\N	\N	27075	27075	27076
8604	7314	1	applied	\N	\N	\N	\N	27077	27077	27078
8604	7315	2	applied	\N	\N	\N	\N	27079	27079	27080
8604	7316	3	applied	\N	\N	\N	\N	27081	27081	27082
8604	7317	4	applied	\N	\N	\N	\N	27083	27083	27084
8604	7318	5	applied	\N	\N	\N	\N	27085	27085	27086
8604	7319	6	applied	\N	\N	\N	\N	27087	27087	27088
8604	7320	8	applied	\N	\N	\N	\N	27090	27090	27091
8604	7321	9	applied	\N	\N	\N	\N	27092	27092	27093
8604	7322	10	applied	\N	\N	\N	\N	27094	27094	27095
8604	7323	11	applied	\N	\N	\N	\N	27096	27096	27097
8604	7324	12	applied	\N	\N	\N	\N	27098	27098	27099
8604	7325	13	applied	\N	\N	\N	\N	27100	27100	27101
8604	7326	14	applied	\N	\N	\N	\N	27102	27102	27103
8604	7327	15	applied	\N	\N	\N	\N	27104	27104	27105
8604	7328	16	applied	\N	\N	\N	\N	27106	27106	27107
8604	7329	17	applied	\N	\N	\N	\N	27108	27108	27109
8604	7330	18	applied	\N	\N	\N	\N	27110	27110	27111
8609	7335	0	applied	\N	\N	\N	\N	27127	27127	27128
8525	7256	0	applied	\N	\N	\N	\N	26870	26870	26871
8527	7257	0	applied	\N	\N	\N	\N	26875	26875	26876
8537	7263	0	applied	\N	\N	\N	\N	26896	26896	26897
8537	7264	1	applied	\N	\N	\N	\N	26898	26898	26899
8537	7265	2	applied	\N	\N	\N	\N	26900	26900	26901
8537	7266	3	applied	\N	\N	\N	\N	26902	26902	26903
8542	7269	0	applied	\N	\N	\N	\N	26910	26910	26911
8542	7270	1	applied	\N	\N	\N	\N	26912	26912	26913
8547	7272	0	applied	\N	\N	\N	\N	26922	26922	26923
8547	7273	1	applied	\N	\N	\N	\N	26924	26924	26925
8556	7279	0	applied	\N	\N	\N	\N	26947	26947	26948
8561	7282	0	applied	\N	\N	\N	\N	26957	26957	26958
8576	7294	0	applied	\N	\N	\N	\N	27002	27002	27003
8576	7295	1	applied	\N	\N	\N	\N	27004	27004	27005
8579	7298	0	applied	\N	\N	\N	\N	27014	27014	27015
8582	7299	0	applied	\N	\N	\N	\N	27018	27018	27019
8586	7302	0	applied	\N	\N	\N	\N	27033	27033	27034
8591	7306	0	applied	\N	\N	\N	\N	27045	27045	27046
8593	7306	0	applied	\N	\N	\N	\N	27045	27045	27046
8595	7307	0	applied	\N	\N	\N	\N	27055	27055	27056
8595	7308	1	applied	\N	\N	1000000000	\N	27057	27057	27058
8602	7312	0	applied	\N	\N	\N	\N	27073	27073	27074
8605	7313	0	applied	\N	\N	\N	\N	27075	27075	27076
8605	7314	1	applied	\N	\N	\N	\N	27077	27077	27078
8605	7315	2	applied	\N	\N	\N	\N	27079	27079	27080
8605	7316	3	applied	\N	\N	\N	\N	27081	27081	27082
8605	7317	4	applied	\N	\N	\N	\N	27083	27083	27084
8605	7318	5	applied	\N	\N	\N	\N	27085	27085	27086
8605	7319	6	applied	\N	\N	\N	\N	27087	27087	27088
8605	7320	8	applied	\N	\N	\N	\N	27090	27090	27091
8605	7321	9	applied	\N	\N	\N	\N	27092	27092	27093
8605	7322	10	applied	\N	\N	\N	\N	27094	27094	27095
8605	7323	11	applied	\N	\N	\N	\N	27096	27096	27097
8605	7324	12	applied	\N	\N	\N	\N	27098	27098	27099
8605	7325	13	applied	\N	\N	\N	\N	27100	27100	27101
8605	7326	14	applied	\N	\N	\N	\N	27102	27102	27103
8605	7327	15	applied	\N	\N	\N	\N	27104	27104	27105
8605	7328	16	applied	\N	\N	\N	\N	27106	27106	27107
8605	7329	17	applied	\N	\N	\N	\N	27108	27108	27109
8605	7330	18	applied	\N	\N	\N	\N	27110	27110	27111
8607	7331	0	applied	\N	\N	\N	\N	27116	27116	27117
8607	7332	1	applied	\N	\N	\N	\N	27118	27118	27119
8607	7333	2	applied	\N	\N	\N	\N	27120	27120	27121
8607	7334	3	applied	\N	\N	\N	\N	27124	27124	27125
8584	7220	21	applied	\N	\N	\N	\N	26734	26734	26735
8584	7221	22	applied	\N	\N	\N	\N	26738	26738	26739
8584	7222	23	applied	\N	\N	\N	\N	26740	26740	26741
8584	7223	24	applied	\N	\N	1000000000	\N	26742	26742	26743
8584	7224	25	applied	\N	\N	\N	\N	26748	26748	26749
8584	7226	26	applied	\N	\N	\N	\N	26754	26754	26755
8584	7227	27	applied	\N	\N	\N	\N	26760	26760	26761
8584	7228	28	applied	\N	\N	\N	\N	26762	26762	26763
8584	7229	29	applied	\N	\N	\N	\N	26769	26769	26770
8584	7230	30	applied	\N	\N	\N	\N	26775	26775	26776
8584	7231	31	applied	\N	\N	\N	\N	26779	26779	26780
8584	7233	32	applied	\N	\N	\N	\N	26783	26783	26784
8584	7234	33	applied	\N	\N	\N	\N	26788	26788	26789
8584	7235	34	applied	\N	\N	\N	\N	26792	26792	26793
8584	7236	35	applied	\N	\N	\N	\N	26796	26796	26797
8584	7237	36	applied	\N	\N	\N	\N	26801	26801	26802
8584	7238	37	applied	\N	\N	\N	\N	26803	26803	26804
8584	7239	38	applied	\N	\N	\N	\N	26809	26809	26810
8584	7240	39	applied	\N	\N	\N	\N	26812	26812	26813
8584	7241	40	applied	\N	\N	\N	\N	26816	26816	26817
8584	7242	41	applied	\N	\N	\N	\N	26820	26820	26821
8584	7243	42	applied	\N	\N	\N	\N	26826	26826	26827
8584	7244	44	applied	\N	\N	\N	\N	26830	26830	26831
8584	7245	45	applied	\N	\N	\N	\N	26833	26833	26834
8584	7246	46	applied	\N	\N	\N	\N	26837	26837	26838
8584	7247	47	applied	\N	\N	\N	\N	26841	26841	26842
8584	7248	48	applied	\N	\N	\N	\N	26847	26847	26848
8584	7249	49	applied	\N	\N	\N	\N	26849	26849	26850
8584	7250	50	applied	\N	\N	\N	\N	26853	26853	26854
8584	7251	51	applied	\N	\N	\N	\N	26856	26856	26857
8584	7252	52	applied	\N	\N	\N	\N	26858	26858	26859
8584	7254	53	applied	\N	\N	\N	\N	26864	26864	26865
8584	7255	54	applied	\N	\N	\N	\N	26866	26866	26867
8584	7256	55	applied	\N	\N	\N	\N	26870	26870	26871
8584	7257	56	applied	\N	\N	\N	\N	26875	26875	26876
8584	7258	57	applied	\N	\N	\N	\N	26881	26881	26882
8584	7259	58	applied	\N	\N	\N	\N	26883	26883	26884
8584	7260	59	applied	\N	\N	\N	\N	26888	26888	26889
8584	7261	60	applied	\N	\N	\N	\N	26892	26892	26893
8584	7262	61	applied	\N	\N	\N	\N	26894	26894	26895
8584	7263	62	applied	\N	\N	\N	\N	26896	26896	26897
8584	7264	63	applied	\N	\N	\N	\N	26898	26898	26899
8584	7265	64	applied	\N	\N	\N	\N	26900	26900	26901
8584	7266	65	applied	\N	\N	\N	\N	26902	26902	26903
8584	7267	66	applied	\N	\N	\N	\N	26905	26905	26906
8584	7268	67	applied	\N	\N	\N	\N	26908	26908	26909
8584	7269	68	applied	\N	\N	\N	\N	26910	26910	26911
8584	7270	69	applied	\N	\N	\N	\N	26912	26912	26913
8584	7271	70	applied	\N	\N	\N	\N	26920	26920	26921
8584	7272	71	applied	\N	\N	\N	\N	26922	26922	26923
8584	7273	72	applied	\N	\N	\N	\N	26924	26924	26925
8584	7274	73	applied	\N	\N	\N	\N	26927	26927	26928
8584	7275	74	applied	\N	\N	\N	\N	26931	26931	26932
8584	7276	75	applied	\N	\N	\N	\N	26936	26936	26937
8584	7277	76	applied	\N	\N	\N	\N	26940	26940	26941
8584	7278	77	applied	\N	\N	\N	\N	26944	26944	26945
8584	7279	78	applied	\N	\N	\N	\N	26947	26947	26948
8584	7280	79	applied	\N	\N	\N	\N	26951	26951	26952
8584	7281	80	applied	\N	\N	\N	\N	26955	26955	26956
8584	7282	81	applied	\N	\N	\N	\N	26957	26957	26958
8584	7283	82	applied	\N	\N	\N	\N	26959	26959	26960
8584	7284	83	applied	\N	\N	\N	\N	26961	26961	26962
8584	7285	84	applied	\N	\N	\N	\N	26965	26965	26966
8584	7286	85	applied	\N	\N	\N	\N	26967	26967	26968
8584	7287	86	applied	\N	\N	\N	\N	26973	26973	26974
8584	7288	87	applied	\N	\N	\N	\N	26979	26979	26980
8584	7289	88	applied	\N	\N	\N	\N	26983	26983	26984
8584	7290	89	applied	\N	\N	\N	\N	26985	26985	26986
8584	7291	90	applied	\N	\N	\N	\N	26989	26989	26990
8584	7292	91	applied	\N	\N	\N	\N	26991	26991	26992
8584	7293	92	applied	\N	\N	\N	\N	26996	26996	26997
8584	7294	93	applied	\N	\N	\N	\N	27002	27002	27003
8584	7295	94	applied	\N	\N	\N	\N	27004	27004	27005
8584	7296	95	applied	\N	\N	\N	\N	27006	27006	27007
8584	7297	96	applied	\N	\N	\N	\N	27010	27010	27011
8584	7298	97	applied	\N	\N	\N	\N	27014	27014	27015
8584	7299	98	applied	\N	\N	\N	\N	27018	27018	27019
8584	7300	99	applied	\N	\N	\N	\N	27021	27021	27022
8584	7253	100	applied	\N	\N	\N	\N	26860	26860	26861
8584	7201	101	applied	\N	\N	\N	\N	26666	26666	26667
8594	7306	0	applied	\N	\N	\N	\N	27045	27045	27046
8596	7309	0	applied	\N	\N	\N	\N	27061	27061	27062
8598	7310	0	applied	\N	\N	\N	\N	27067	27067	27068
8608	7335	0	applied	\N	\N	\N	\N	27127	27127	27128
8610	7225	0	applied	\N	\N	\N	\N	27025	27025	1435
8610	7156	1	applied	\N	\N	\N	\N	26495	26495	26496
8610	7232	2	applied	\N	\N	\N	\N	26781	26781	26782
8610	7157	3	applied	\N	\N	\N	\N	26497	26497	26498
8610	7158	4	applied	\N	\N	\N	\N	26499	26499	26500
8610	7159	5	applied	\N	\N	\N	\N	26503	26503	26504
8610	7160	6	applied	\N	\N	\N	\N	26509	26509	26510
8610	7161	7	applied	\N	\N	\N	\N	26513	26513	26514
8610	7166	8	applied	\N	\N	1000000000	\N	26529	26529	26530
8610	7179	9	applied	\N	\N	\N	\N	26567	26567	26693
8610	7162	10	applied	\N	\N	\N	\N	26519	26519	26520
8610	7163	11	applied	\N	\N	\N	\N	26521	26521	26522
8610	7164	12	applied	\N	\N	\N	\N	26523	26523	26524
8610	7165	13	applied	\N	\N	\N	\N	26527	26527	26528
8610	7167	14	applied	\N	\N	\N	\N	26532	26532	26533
8610	7168	15	applied	\N	\N	\N	\N	26534	26534	26535
8610	7172	16	applied	\N	\N	\N	\N	26542	26542	26543
8610	7173	17	applied	\N	\N	\N	\N	26544	26544	26545
8610	7174	18	applied	\N	\N	\N	\N	26554	26554	26555
8610	7175	19	applied	\N	\N	\N	\N	26556	26556	26557
8610	7176	20	applied	\N	\N	\N	\N	26561	26561	26562
8610	7177	21	applied	\N	\N	\N	\N	26563	26563	26564
8606	7306	5	applied	\N	\N	\N	\N	27045	27045	27046
8606	7307	6	applied	\N	\N	\N	\N	27055	27055	27056
8606	7309	7	applied	\N	\N	\N	\N	27061	27061	27062
8606	7310	8	applied	\N	\N	\N	\N	27067	27067	27068
8606	7311	9	applied	\N	\N	\N	\N	27069	27069	27070
8606	7312	10	applied	\N	\N	\N	\N	27073	27073	27074
8606	7313	11	applied	\N	\N	\N	\N	27075	27075	27076
8606	7314	12	applied	\N	\N	\N	\N	27077	27077	27078
8606	7315	13	applied	\N	\N	\N	\N	27079	27079	27080
8606	7316	14	applied	\N	\N	\N	\N	27081	27081	27082
8606	7317	15	applied	\N	\N	\N	\N	27083	27083	27084
8606	7318	16	applied	\N	\N	\N	\N	27085	27085	27086
8606	7319	17	applied	\N	\N	\N	\N	27087	27087	27088
8606	7320	18	applied	\N	\N	\N	\N	27090	27090	27091
8606	7331	19	applied	\N	\N	\N	\N	27116	27116	27117
8606	7332	20	applied	\N	\N	\N	\N	27118	27118	27119
8606	7333	21	applied	\N	\N	\N	\N	27120	27120	27121
8606	7308	22	applied	\N	\N	1000000000	\N	27057	27057	27058
8606	7321	23	applied	\N	\N	\N	\N	27092	27092	27093
8606	7322	24	applied	\N	\N	\N	\N	27094	27094	27095
8606	7323	25	applied	\N	\N	\N	\N	27096	27096	27097
8606	7324	26	applied	\N	\N	\N	\N	27098	27098	27099
8606	7325	27	applied	\N	\N	\N	\N	27100	27100	27101
8606	7326	28	applied	\N	\N	\N	\N	27102	27102	27103
8606	7327	29	applied	\N	\N	\N	\N	27104	27104	27105
8606	7328	30	applied	\N	\N	\N	\N	27106	27106	27107
8606	7329	31	applied	\N	\N	\N	\N	27108	27108	27109
8606	7330	32	applied	\N	\N	\N	\N	27110	27110	27111
8611	7336	0	applied	\N	\N	\N	\N	27131	27131	27132
8612	7337	0	applied	\N	\N	\N	\N	27133	27133	27134
8612	7338	1	applied	\N	\N	\N	\N	27135	27135	27136
8613	7337	0	applied	\N	\N	\N	\N	27133	27133	27134
8613	7338	1	applied	\N	\N	\N	\N	27135	27135	27136
8614	7337	0	applied	\N	\N	\N	\N	27133	27133	27134
8614	7338	1	applied	\N	\N	\N	\N	27135	27135	27136
8615	7339	0	applied	\N	\N	\N	\N	27142	27142	27143
8616	7339	0	applied	\N	\N	\N	\N	27142	27142	27143
8617	7340	0	applied	\N	\N	\N	\N	27148	27148	27149
8618	7340	0	applied	\N	\N	\N	\N	27148	27148	27149
8619	7341	0	applied	\N	\N	\N	\N	27154	27154	27155
8620	7342	0	applied	\N	\N	\N	\N	27156	27156	27157
8621	7342	0	applied	\N	\N	\N	\N	27156	27156	27157
8622	7343	0	applied	\N	\N	\N	\N	27160	27160	27161
8624	7344	0	applied	\N	\N	\N	\N	27164	27164	27165
8625	7343	0	applied	\N	\N	\N	\N	27160	27160	27161
8625	7344	1	applied	\N	\N	\N	\N	27164	27164	27165
8626	7225	0	applied	\N	\N	\N	\N	27025	27025	1435
8626	7232	1	applied	\N	\N	\N	\N	26781	26781	26782
8626	7161	2	applied	\N	\N	\N	\N	26513	26513	26514
8626	7166	3	applied	\N	\N	1000000000	\N	26529	26529	26530
8626	7179	4	applied	\N	\N	\N	\N	26567	26567	26693
8626	7162	5	applied	\N	\N	\N	\N	26519	26519	26520
8626	7163	6	applied	\N	\N	\N	\N	26521	26521	26522
8626	7164	7	applied	\N	\N	\N	\N	26523	26523	26524
8626	7165	8	applied	\N	\N	\N	\N	26527	26527	26528
8626	7167	10	applied	\N	\N	\N	\N	26532	26532	26533
8626	7168	11	applied	\N	\N	\N	\N	26534	26534	26535
8626	7172	12	applied	\N	\N	\N	\N	26542	26542	26543
8626	7173	13	applied	\N	\N	\N	\N	26544	26544	26545
8626	7174	14	applied	\N	\N	\N	\N	26554	26554	26555
8626	7175	15	applied	\N	\N	\N	\N	26556	26556	26557
8626	7176	16	applied	\N	\N	\N	\N	26561	26561	26562
8626	7177	17	applied	\N	\N	\N	\N	26563	26563	26564
8626	7178	18	applied	\N	\N	\N	\N	26565	26565	26566
8626	7181	19	applied	\N	\N	\N	\N	26573	26573	26574
8626	7182	20	applied	\N	\N	\N	\N	26579	26579	26580
8626	7183	21	applied	\N	\N	\N	\N	26586	26586	26587
8626	7185	22	applied	\N	\N	\N	\N	26593	26593	26594
8626	7186	23	applied	\N	\N	\N	\N	26597	26597	26598
8626	7187	24	applied	\N	\N	\N	\N	26601	26601	26602
8626	7189	25	applied	\N	\N	\N	\N	26609	26609	26610
8626	7190	26	applied	\N	\N	\N	\N	26611	26611	26612
8626	7191	27	applied	\N	\N	\N	\N	26614	26614	26615
8626	7192	28	applied	\N	\N	\N	\N	26617	26617	26618
8626	7193	29	applied	\N	\N	\N	\N	26621	26621	26622
8626	7194	30	applied	\N	\N	\N	\N	26623	26623	26624
8626	7195	31	applied	\N	\N	\N	\N	26627	26627	26628
8626	7196	32	applied	\N	\N	\N	\N	26631	26631	26632
8626	7197	33	applied	\N	\N	\N	\N	26637	26637	26638
8626	7198	34	applied	\N	\N	1000000000	\N	26639	26639	26640
8626	7199	35	applied	\N	\N	\N	\N	26641	26641	26642
8626	7202	36	applied	\N	\N	\N	\N	26670	26670	26671
8626	7203	37	applied	\N	\N	1000000000	\N	26672	26672	26673
8626	7204	38	applied	\N	\N	\N	\N	26674	26674	26675
8626	7205	39	applied	\N	\N	\N	\N	26679	26679	26680
8626	7206	40	applied	\N	\N	\N	\N	26682	26682	26683
8626	7207	41	applied	\N	\N	\N	\N	26687	26687	26688
8626	7208	42	applied	\N	\N	\N	\N	26690	26690	26691
8626	7209	43	applied	\N	\N	\N	\N	26696	26696	26697
8626	7210	44	applied	\N	\N	\N	\N	26701	26701	26702
8626	7211	45	applied	\N	\N	\N	\N	26703	26703	26704
8626	7212	46	applied	\N	\N	\N	\N	26706	26706	26707
8626	7213	47	applied	\N	\N	\N	\N	26713	26713	26714
8626	7214	48	applied	\N	\N	\N	\N	26715	26715	26716
8626	7215	49	applied	\N	\N	\N	\N	26717	26717	26718
8626	7216	50	applied	\N	\N	\N	\N	26719	26719	26720
8626	7217	51	applied	\N	\N	\N	\N	26721	26721	26722
8626	7218	52	applied	\N	\N	\N	\N	26724	26724	26725
8626	7219	53	applied	\N	\N	\N	\N	26730	26730	26731
8626	7220	54	applied	\N	\N	\N	\N	26734	26734	26735
8626	7221	55	applied	\N	\N	\N	\N	26738	26738	26739
8626	7222	56	applied	\N	\N	\N	\N	26740	26740	26741
8626	7223	57	applied	\N	\N	1000000000	\N	26742	26742	26743
8626	7224	58	applied	\N	\N	\N	\N	26748	26748	26749
8626	7226	59	applied	\N	\N	\N	\N	26754	26754	26755
8626	7227	60	applied	\N	\N	\N	\N	26760	26760	26761
8626	7228	61	applied	\N	\N	\N	\N	26762	26762	26763
8626	7229	62	applied	\N	\N	\N	\N	26769	26769	26770
8626	7230	63	applied	\N	\N	\N	\N	26775	26775	26776
8626	7231	64	applied	\N	\N	\N	\N	26779	26779	26780
8626	7233	65	applied	\N	\N	\N	\N	26783	26783	26784
8626	7234	66	applied	\N	\N	\N	\N	26788	26788	26789
8626	7235	67	applied	\N	\N	\N	\N	26792	26792	26793
8626	7236	68	applied	\N	\N	\N	\N	26796	26796	26797
8626	7237	69	applied	\N	\N	\N	\N	26801	26801	26802
8626	7238	70	applied	\N	\N	\N	\N	26803	26803	26804
8626	7239	71	applied	\N	\N	\N	\N	26809	26809	26810
8626	7240	72	applied	\N	\N	\N	\N	26812	26812	26813
8626	7241	73	applied	\N	\N	\N	\N	26816	26816	26817
8626	7242	74	applied	\N	\N	\N	\N	26820	26820	26821
8626	7243	75	applied	\N	\N	\N	\N	26826	26826	26827
8626	7244	76	applied	\N	\N	\N	\N	26830	26830	26831
8626	7245	77	applied	\N	\N	\N	\N	26833	26833	26834
8626	7246	78	applied	\N	\N	\N	\N	26837	26837	26838
8626	7247	79	applied	\N	\N	\N	\N	26841	26841	26842
8626	7248	80	applied	\N	\N	\N	\N	26847	26847	26848
8626	7249	81	applied	\N	\N	\N	\N	26849	26849	26850
8626	7250	82	applied	\N	\N	\N	\N	26853	26853	26854
8626	7251	83	applied	\N	\N	\N	\N	26856	26856	26857
8626	7252	84	applied	\N	\N	\N	\N	26858	26858	26859
8626	7254	85	applied	\N	\N	\N	\N	26864	26864	26865
8626	7255	86	applied	\N	\N	\N	\N	26866	26866	26867
8626	7256	87	applied	\N	\N	\N	\N	26870	26870	26871
8626	7257	88	applied	\N	\N	\N	\N	26875	26875	26876
8626	7258	89	applied	\N	\N	\N	\N	26881	26881	26882
8626	7259	90	applied	\N	\N	\N	\N	26883	26883	26884
8626	7260	91	applied	\N	\N	\N	\N	26888	26888	26889
8626	7261	92	applied	\N	\N	\N	\N	26892	26892	26893
8626	7262	93	applied	\N	\N	\N	\N	26894	26894	26895
8626	7263	94	applied	\N	\N	\N	\N	26896	26896	26897
8626	7264	95	applied	\N	\N	\N	\N	26898	26898	26899
8626	7265	96	applied	\N	\N	\N	\N	26900	26900	26901
8626	7266	97	applied	\N	\N	\N	\N	26902	26902	26903
8626	7267	98	applied	\N	\N	\N	\N	26905	26905	26906
8626	7268	99	applied	\N	\N	\N	\N	26908	26908	26909
8626	7269	100	applied	\N	\N	\N	\N	26910	26910	26911
8626	7270	101	applied	\N	\N	\N	\N	26912	26912	26913
8626	7271	102	applied	\N	\N	\N	\N	26920	26920	26921
8626	7272	103	applied	\N	\N	\N	\N	26922	26922	26923
8626	7273	104	applied	\N	\N	\N	\N	26924	26924	26925
8626	7274	105	applied	\N	\N	\N	\N	26927	26927	26928
8626	7275	106	applied	\N	\N	\N	\N	26931	26931	26932
8626	7276	107	applied	\N	\N	\N	\N	26936	26936	26937
8626	7277	108	applied	\N	\N	\N	\N	26940	26940	26941
8626	7278	109	applied	\N	\N	\N	\N	26944	26944	26945
8626	7279	110	applied	\N	\N	\N	\N	26947	26947	26948
8626	7280	111	applied	\N	\N	\N	\N	26951	26951	26952
8626	7281	112	applied	\N	\N	\N	\N	26955	26955	26956
8626	7282	113	applied	\N	\N	\N	\N	26957	26957	26958
8626	7283	114	applied	\N	\N	\N	\N	26959	26959	26960
8626	7284	115	applied	\N	\N	\N	\N	26961	26961	26962
8626	7285	116	applied	\N	\N	\N	\N	26965	26965	26966
8626	7286	117	applied	\N	\N	\N	\N	26967	26967	26968
8626	7287	118	applied	\N	\N	\N	\N	26973	26973	26974
8626	7288	119	applied	\N	\N	\N	\N	26979	26979	26980
8626	7289	120	applied	\N	\N	\N	\N	26983	26983	26984
8626	7290	121	applied	\N	\N	\N	\N	26985	26985	26986
8626	7291	122	applied	\N	\N	\N	\N	26989	26989	26990
8626	7292	123	applied	\N	\N	\N	\N	26991	26991	26992
8628	7345	0	applied	\N	\N	\N	\N	27177	27177	27178
8628	7346	1	applied	\N	\N	\N	\N	27179	27179	27180
8637	7351	0	applied	\N	\N	\N	\N	27204	27204	27205
8642	7352	0	applied	\N	\N	\N	\N	27208	27208	27209
8648	7361	0	applied	\N	\N	\N	\N	27233	27233	27234
8648	7362	1	applied	\N	\N	\N	\N	27235	27235	27236
8653	7368	0	applied	\N	\N	\N	\N	27257	27257	27258
8653	7369	1	applied	\N	\N	\N	\N	27259	27259	27260
8659	7370	0	applied	\N	\N	\N	\N	27264	27264	27265
8660	7370	0	applied	\N	\N	\N	\N	27264	27264	27265
8662	7371	0	applied	\N	\N	\N	\N	27274	27274	27275
8667	7375	0	applied	\N	\N	\N	\N	27290	27290	27291
8667	7376	1	applied	\N	\N	\N	\N	27292	27292	27293
8667	7377	2	applied	\N	\N	\N	\N	27294	27294	27295
8667	7378	3	applied	\N	\N	\N	\N	27296	27296	27297
8682	7349	0	applied	\N	\N	\N	\N	27200	27200	1435
8682	7383	1	applied	\N	\N	\N	\N	27318	27318	27332
8682	7378	2	applied	\N	\N	\N	\N	27296	27296	27297
8682	7300	3	applied	\N	\N	\N	\N	27021	27021	27022
8682	7368	4	applied	\N	\N	\N	\N	27257	27257	27258
8682	7301	5	applied	\N	\N	\N	\N	27029	27029	27030
8682	7302	6	applied	\N	\N	\N	\N	27033	27033	27034
8682	7303	7	applied	\N	\N	\N	\N	27037	27037	27038
8682	7304	8	applied	\N	\N	\N	\N	27041	27041	27042
8682	7305	9	applied	\N	\N	\N	\N	27043	27043	27044
8682	7306	10	applied	\N	\N	\N	\N	27045	27045	27046
8682	7307	11	applied	\N	\N	\N	\N	27055	27055	27056
8682	7309	12	applied	\N	\N	\N	\N	27061	27061	27062
8682	7384	13	applied	\N	\N	\N	\N	27320	27320	27333
8682	7385	14	applied	\N	\N	\N	\N	27324	27324	27334
8682	7386	15	applied	\N	\N	\N	\N	27330	27330	27335
8682	7310	16	applied	\N	\N	\N	\N	27067	27067	27068
8682	7311	17	applied	\N	\N	\N	\N	27069	27069	27070
8682	7312	18	applied	\N	\N	\N	\N	27073	27073	27074
8682	7313	19	applied	\N	\N	\N	\N	27075	27075	27076
8682	7314	20	applied	\N	\N	\N	\N	27077	27077	27078
8682	7315	21	applied	\N	\N	\N	\N	27079	27079	27080
8682	7316	22	applied	\N	\N	\N	\N	27081	27081	27082
8682	7317	23	applied	\N	\N	\N	\N	27083	27083	27084
8682	7318	24	applied	\N	\N	\N	\N	27085	27085	27086
8682	7319	25	applied	\N	\N	\N	\N	27087	27087	27088
8682	7320	26	applied	\N	\N	\N	\N	27090	27090	27091
8682	7331	27	applied	\N	\N	\N	\N	27116	27116	27117
8682	7332	28	applied	\N	\N	\N	\N	27118	27118	27119
8682	7333	29	applied	\N	\N	\N	\N	27120	27120	27121
8682	7334	30	applied	\N	\N	\N	\N	27124	27124	27125
8682	7335	31	applied	\N	\N	\N	\N	27127	27127	27128
8682	7336	32	applied	\N	\N	\N	\N	27131	27131	27132
8682	7337	33	applied	\N	\N	\N	\N	27133	27133	27134
8682	7338	34	applied	\N	\N	\N	\N	27135	27135	27136
8682	7339	35	applied	\N	\N	\N	\N	27142	27142	27143
8682	7340	36	applied	\N	\N	\N	\N	27148	27148	27149
8682	7341	37	applied	\N	\N	\N	\N	27154	27154	27155
8682	7342	38	applied	\N	\N	\N	\N	27156	27156	27157
8682	7343	39	applied	\N	\N	\N	\N	27160	27160	27161
8682	7344	40	applied	\N	\N	\N	\N	27164	27164	27165
8682	7345	41	applied	\N	\N	\N	\N	27177	27177	27178
8682	7346	43	applied	\N	\N	\N	\N	27179	27179	27180
8682	7347	44	applied	\N	\N	\N	\N	27186	27186	27187
8682	7348	45	applied	\N	\N	\N	\N	27188	27188	27189
8682	7350	46	applied	\N	\N	\N	\N	27201	27201	27202
8682	7351	47	applied	\N	\N	\N	\N	27204	27204	27205
8682	7352	48	applied	\N	\N	\N	\N	27208	27208	27209
8682	7353	49	applied	\N	\N	\N	\N	27216	27216	27217
8682	7354	50	applied	\N	\N	\N	\N	27218	27218	27219
8682	7355	51	applied	\N	\N	\N	\N	27220	27220	27221
8682	7356	52	applied	\N	\N	\N	\N	27222	27222	27223
8682	7357	53	applied	\N	\N	\N	\N	27224	27224	27225
8682	7358	54	applied	\N	\N	\N	\N	27226	27226	27227
8682	7359	55	applied	\N	\N	\N	\N	27228	27228	27229
8627	7345	0	applied	\N	\N	\N	\N	27177	27177	27178
8627	7346	1	applied	\N	\N	\N	\N	27179	27179	27180
8632	7225	0	applied	\N	\N	\N	\N	27025	27025	1435
8632	7193	1	applied	\N	\N	\N	\N	26621	26621	26622
8632	7194	2	applied	\N	\N	\N	\N	26623	26623	26624
8632	7232	3	applied	\N	\N	\N	\N	26781	26781	26782
8632	7195	4	applied	\N	\N	\N	\N	26627	26627	26628
8632	7196	5	applied	\N	\N	\N	\N	26631	26631	26632
8632	7197	6	applied	\N	\N	\N	\N	26637	26637	26638
8632	7198	7	applied	\N	\N	1000000000	\N	26639	26639	26640
8632	7199	8	applied	\N	\N	\N	\N	26641	26641	26642
8632	7202	9	applied	\N	\N	\N	\N	26670	26670	26671
8632	7203	10	applied	\N	\N	1000000000	\N	26672	26672	26673
8632	7204	11	applied	\N	\N	\N	\N	26674	26674	26675
8632	7205	12	applied	\N	\N	\N	\N	26679	26679	26680
8632	7206	13	applied	\N	\N	\N	\N	26682	26682	26683
8632	7207	14	applied	\N	\N	\N	\N	26687	26687	26688
8632	7208	15	applied	\N	\N	\N	\N	26690	26690	26691
8632	7209	16	applied	\N	\N	\N	\N	26696	26696	26697
8632	7210	17	applied	\N	\N	\N	\N	26701	26701	26702
8632	7211	18	applied	\N	\N	\N	\N	26703	26703	26704
8632	7212	19	applied	\N	\N	\N	\N	26706	26706	26707
8632	7213	20	applied	\N	\N	\N	\N	26713	26713	26714
8632	7214	21	applied	\N	\N	\N	\N	26715	26715	26716
8632	7215	22	applied	\N	\N	\N	\N	26717	26717	26718
8632	7216	23	applied	\N	\N	\N	\N	26719	26719	26720
8632	7217	24	applied	\N	\N	\N	\N	26721	26721	26722
8632	7218	25	applied	\N	\N	\N	\N	26724	26724	26725
8632	7219	26	applied	\N	\N	\N	\N	26730	26730	26731
8632	7220	27	applied	\N	\N	\N	\N	26734	26734	26735
8632	7221	28	applied	\N	\N	\N	\N	26738	26738	26739
8632	7222	29	applied	\N	\N	\N	\N	26740	26740	26741
8632	7223	30	applied	\N	\N	1000000000	\N	26742	26742	26743
8632	7224	31	applied	\N	\N	\N	\N	26748	26748	26749
8632	7226	32	applied	\N	\N	\N	\N	26754	26754	26755
8632	7227	33	applied	\N	\N	\N	\N	26760	26760	26761
8632	7228	34	applied	\N	\N	\N	\N	26762	26762	26763
8632	7229	35	applied	\N	\N	\N	\N	26769	26769	26770
8632	7230	36	applied	\N	\N	\N	\N	26775	26775	26776
8632	7231	37	applied	\N	\N	\N	\N	26779	26779	26780
8632	7233	38	applied	\N	\N	\N	\N	26783	26783	26784
8632	7234	39	applied	\N	\N	\N	\N	26788	26788	26789
8632	7235	40	applied	\N	\N	\N	\N	26792	26792	26793
8632	7236	41	applied	\N	\N	\N	\N	26796	26796	26797
8632	7237	42	applied	\N	\N	\N	\N	26801	26801	26802
8632	7238	43	applied	\N	\N	\N	\N	26803	26803	26804
8632	7239	44	applied	\N	\N	\N	\N	26809	26809	26810
8632	7240	45	applied	\N	\N	\N	\N	26812	26812	26813
8632	7241	46	applied	\N	\N	\N	\N	26816	26816	26817
8632	7242	47	applied	\N	\N	\N	\N	26820	26820	26821
8632	7243	48	applied	\N	\N	\N	\N	26826	26826	26827
8632	7244	49	applied	\N	\N	\N	\N	26830	26830	26831
8632	7245	50	applied	\N	\N	\N	\N	26833	26833	26834
8632	7246	51	applied	\N	\N	\N	\N	26837	26837	26838
8632	7247	52	applied	\N	\N	\N	\N	26841	26841	26842
8632	7248	53	applied	\N	\N	\N	\N	26847	26847	26848
8632	7249	54	applied	\N	\N	\N	\N	26849	26849	26850
8632	7250	55	applied	\N	\N	\N	\N	26853	26853	26854
8632	7251	56	applied	\N	\N	\N	\N	26856	26856	26857
8632	7252	57	applied	\N	\N	\N	\N	26858	26858	26859
8632	7254	58	applied	\N	\N	\N	\N	26864	26864	26865
8632	7255	59	applied	\N	\N	\N	\N	26866	26866	26867
8632	7256	60	applied	\N	\N	\N	\N	26870	26870	26871
8632	7257	61	applied	\N	\N	\N	\N	26875	26875	26876
8632	7258	62	applied	\N	\N	\N	\N	26881	26881	26882
8632	7259	63	applied	\N	\N	\N	\N	26883	26883	26884
8632	7260	64	applied	\N	\N	\N	\N	26888	26888	26889
8632	7261	65	applied	\N	\N	\N	\N	26892	26892	26893
8632	7262	66	applied	\N	\N	\N	\N	26894	26894	26895
8632	7263	68	applied	\N	\N	\N	\N	26896	26896	26897
8632	7264	69	applied	\N	\N	\N	\N	26898	26898	26899
8632	7265	70	applied	\N	\N	\N	\N	26900	26900	26901
8632	7266	71	applied	\N	\N	\N	\N	26902	26902	26903
8632	7267	72	applied	\N	\N	\N	\N	26905	26905	26906
8632	7268	73	applied	\N	\N	\N	\N	26908	26908	26909
8632	7269	74	applied	\N	\N	\N	\N	26910	26910	26911
8632	7270	75	applied	\N	\N	\N	\N	26912	26912	26913
8632	7271	76	applied	\N	\N	\N	\N	26920	26920	26921
8632	7272	77	applied	\N	\N	\N	\N	26922	26922	26923
8632	7273	78	applied	\N	\N	\N	\N	26924	26924	26925
8632	7274	79	applied	\N	\N	\N	\N	26927	26927	26928
8632	7275	80	applied	\N	\N	\N	\N	26931	26931	26932
8632	7276	81	applied	\N	\N	\N	\N	26936	26936	26937
8632	7277	82	applied	\N	\N	\N	\N	26940	26940	26941
8632	7278	83	applied	\N	\N	\N	\N	26944	26944	26945
8632	7279	84	applied	\N	\N	\N	\N	26947	26947	26948
8632	7280	85	applied	\N	\N	\N	\N	26951	26951	26952
8632	7281	86	applied	\N	\N	\N	\N	26955	26955	26956
8632	7282	87	applied	\N	\N	\N	\N	26957	26957	26958
8632	7283	88	applied	\N	\N	\N	\N	26959	26959	26960
8632	7284	89	applied	\N	\N	\N	\N	26961	26961	26962
8632	7285	90	applied	\N	\N	\N	\N	26965	26965	26966
8632	7286	91	applied	\N	\N	\N	\N	26967	26967	26968
8632	7287	92	applied	\N	\N	\N	\N	26973	26973	26974
8632	7288	93	applied	\N	\N	\N	\N	26979	26979	26980
8632	7289	94	applied	\N	\N	\N	\N	26983	26983	26984
8638	7351	0	applied	\N	\N	\N	\N	27204	27204	27205
8640	7352	0	applied	\N	\N	\N	\N	27208	27208	27209
8646	7355	0	applied	\N	\N	\N	\N	27220	27220	27221
8646	7356	1	applied	\N	\N	\N	\N	27222	27222	27223
8646	7357	2	applied	\N	\N	\N	\N	27224	27224	27225
8646	7358	3	applied	\N	\N	\N	\N	27226	27226	27227
8646	7359	4	applied	\N	\N	\N	\N	27228	27228	27229
8646	7360	5	applied	\N	\N	\N	\N	27230	27230	27231
8650	7367	0	applied	\N	\N	\N	\N	27251	27251	27252
8654	7368	0	applied	\N	\N	\N	\N	27257	27257	27258
8654	7369	1	applied	\N	\N	\N	\N	27259	27259	27260
8657	7370	0	applied	\N	\N	\N	\N	27264	27264	27265
8663	7371	0	applied	\N	\N	\N	\N	27274	27274	27275
8665	7372	0	applied	\N	\N	\N	\N	27281	27281	27282
8665	7373	1	applied	\N	\N	\N	\N	27283	27283	27284
8669	7381	0	applied	\N	\N	\N	\N	27306	27306	27307
8671	7382	0	applied	\N	\N	\N	\N	27310	27310	27311
8679	7385	0	applied	\N	\N	\N	\N	27324	27324	27325
8681	7386	0	applied	\N	\N	\N	\N	27330	27330	27331
8686	7389	0	applied	\N	\N	\N	\N	27345	27345	27346
8686	7390	1	applied	\N	\N	\N	\N	27347	27347	1435
8688	7349	0	applied	\N	\N	\N	\N	27200	27200	1435
8688	7383	1	applied	\N	\N	\N	\N	27318	27318	27332
8629	7345	0	applied	\N	\N	\N	\N	27177	27177	27178
8629	7346	1	applied	\N	\N	\N	\N	27179	27179	27180
8631	7347	0	applied	\N	\N	\N	\N	27186	27186	27187
8631	7348	1	applied	\N	\N	\N	\N	27188	27188	27189
8643	7352	0	applied	\N	\N	\N	\N	27208	27208	27209
8644	7353	0	applied	\N	\N	\N	\N	27216	27216	27217
8644	7354	1	applied	\N	\N	\N	\N	27218	27218	27219
8649	7363	0	applied	\N	\N	\N	\N	27241	27241	27242
8649	7364	1	applied	\N	\N	\N	\N	27243	27243	27244
8649	7365	2	applied	\N	\N	\N	\N	27245	27245	27246
8649	7366	3	applied	\N	\N	\N	\N	27247	27247	27248
8652	7367	0	applied	\N	\N	\N	\N	27251	27251	27252
8656	7370	0	applied	\N	\N	\N	\N	27264	27264	27265
8668	7379	0	applied	\N	\N	\N	\N	27300	27300	27301
8668	7380	1	applied	\N	\N	\N	\N	27302	27302	27303
8678	7383	0	applied	\N	\N	\N	\N	27318	27318	27319
8678	7384	1	applied	\N	\N	\N	\N	27320	27320	27321
8683	7387	0	applied	\N	\N	\N	\N	27339	27339	27340
8690	7392	0	applied	\N	\N	\N	\N	27363	27363	27364
8695	7397	0	applied	\N	\N	\N	\N	27378	27378	27379
8697	7397	0	applied	\N	\N	\N	\N	27378	27378	27379
8700	7399	0	applied	\N	\N	\N	\N	27388	27388	27389
8703	7400	0	applied	\N	\N	\N	\N	27392	27392	27393
8703	7401	1	applied	\N	\N	\N	\N	27394	27394	27395
8703	7402	2	applied	\N	\N	\N	\N	27396	27396	27397
8703	7403	3	applied	\N	\N	\N	\N	27398	27398	27399
8703	7404	4	applied	\N	\N	\N	\N	27400	27400	27400
8707	7412	0	applied	\N	\N	\N	\N	27423	27423	27424
8707	7413	1	applied	\N	\N	\N	\N	27425	27425	27426
8711	7416	0	applied	\N	\N	\N	\N	27434	27434	27435
8711	7417	1	applied	\N	\N	\N	\N	27436	27436	27437
8711	7418	2	applied	\N	\N	\N	\N	27438	27438	27439
8711	7419	3	applied	\N	\N	\N	\N	27440	27440	27441
8711	7420	4	applied	\N	\N	\N	\N	27442	27442	27443
8711	7421	5	applied	\N	\N	\N	\N	27444	27444	27445
8711	7422	6	applied	\N	\N	1000000000	\N	27446	27446	27447
8711	7423	7	applied	\N	\N	\N	\N	27448	27448	27449
8713	7225	0	applied	\N	\N	\N	\N	27025	27025	1435
8713	7200	1	applied	\N	\N	\N	\N	26662	26662	26663
8713	7349	2	applied	\N	\N	\N	\N	27200	27200	1435
8713	7383	3	applied	\N	\N	\N	\N	27318	27318	27460
8713	7232	4	applied	\N	\N	\N	\N	26781	26781	26782
8713	7378	5	applied	\N	\N	\N	\N	27296	27296	27297
8713	7368	6	applied	\N	\N	\N	\N	27461	27461	27258
8713	7384	7	applied	\N	\N	\N	\N	27320	27320	27462
8713	7385	8	applied	\N	\N	\N	\N	27324	27324	27463
8713	7386	9	applied	\N	\N	\N	\N	27330	27330	27464
8713	7387	10	applied	\N	\N	\N	\N	27339	27339	27465
8713	7388	11	applied	\N	\N	\N	\N	27341	27341	27466
8713	7389	12	applied	\N	\N	\N	\N	27345	27345	27467
8713	7391	13	applied	\N	\N	\N	\N	27355	27355	27468
8713	7392	14	applied	\N	\N	\N	\N	27363	27363	27469
8713	7202	15	applied	\N	\N	\N	\N	26670	26670	26671
8713	7203	16	applied	\N	\N	1000000000	\N	26672	26672	26673
8713	7204	17	applied	\N	\N	\N	\N	26674	26674	26675
8713	7205	18	applied	\N	\N	\N	\N	26679	26679	26680
8713	7206	19	applied	\N	\N	\N	\N	26682	26682	26683
8713	7207	20	applied	\N	\N	\N	\N	26687	26687	26688
8713	7208	21	applied	\N	\N	\N	\N	26690	26690	26691
8713	7209	22	applied	\N	\N	\N	\N	26696	26696	26697
8713	7210	23	applied	\N	\N	\N	\N	26701	26701	26702
8713	7211	24	applied	\N	\N	\N	\N	26703	26703	26704
8713	7212	25	applied	\N	\N	\N	\N	26706	26706	26707
8713	7213	26	applied	\N	\N	\N	\N	26713	26713	26714
8713	7214	27	applied	\N	\N	\N	\N	26715	26715	26716
8713	7215	28	applied	\N	\N	\N	\N	26717	26717	26718
8713	7216	29	applied	\N	\N	\N	\N	26719	26719	26720
8713	7217	30	applied	\N	\N	\N	\N	26721	26721	26722
8713	7218	31	applied	\N	\N	\N	\N	26724	26724	26725
8713	7219	32	applied	\N	\N	\N	\N	26730	26730	26731
8713	7220	33	applied	\N	\N	\N	\N	26734	26734	26735
8713	7221	34	applied	\N	\N	\N	\N	26738	26738	26739
8713	7222	35	applied	\N	\N	\N	\N	26740	26740	26741
8713	7223	37	applied	\N	\N	1000000000	\N	26742	26742	26743
8713	7224	38	applied	\N	\N	\N	\N	26748	26748	26749
8713	7226	39	applied	\N	\N	\N	\N	26754	26754	26755
8713	7227	40	applied	\N	\N	\N	\N	26760	26760	26761
8713	7228	41	applied	\N	\N	\N	\N	26762	26762	26763
8713	7229	42	applied	\N	\N	\N	\N	26769	26769	26770
8713	7230	43	applied	\N	\N	\N	\N	26775	26775	26776
8713	7231	44	applied	\N	\N	\N	\N	26779	26779	26780
8713	7233	45	applied	\N	\N	\N	\N	26783	26783	26784
8713	7234	46	applied	\N	\N	\N	\N	26788	26788	26789
8713	7235	47	applied	\N	\N	\N	\N	26792	26792	26793
8713	7236	48	applied	\N	\N	\N	\N	26796	26796	26797
8713	7237	49	applied	\N	\N	\N	\N	26801	26801	26802
8713	7238	50	applied	\N	\N	\N	\N	26803	26803	26804
8713	7239	51	applied	\N	\N	\N	\N	26809	26809	26810
8713	7240	52	applied	\N	\N	\N	\N	26812	26812	26813
8713	7241	53	applied	\N	\N	\N	\N	26816	26816	26817
8713	7242	54	applied	\N	\N	\N	\N	26820	26820	26821
8713	7243	55	applied	\N	\N	\N	\N	26826	26826	26827
8713	7244	56	applied	\N	\N	\N	\N	26830	26830	26831
8713	7245	57	applied	\N	\N	\N	\N	26833	26833	26834
8713	7246	58	applied	\N	\N	\N	\N	26837	26837	26838
8713	7247	59	applied	\N	\N	\N	\N	26841	26841	26842
8713	7248	60	applied	\N	\N	\N	\N	26847	26847	26848
8713	7249	61	applied	\N	\N	\N	\N	26849	26849	26850
8713	7250	62	applied	\N	\N	\N	\N	26853	26853	26854
8713	7251	63	applied	\N	\N	\N	\N	26856	26856	26857
8713	7252	64	applied	\N	\N	\N	\N	26858	26858	26859
8713	7254	65	applied	\N	\N	\N	\N	26864	26864	26865
8713	7255	66	applied	\N	\N	\N	\N	26866	26866	26867
8713	7256	67	applied	\N	\N	\N	\N	26870	26870	26871
8713	7257	68	applied	\N	\N	\N	\N	26875	26875	26876
8713	7258	69	applied	\N	\N	\N	\N	26881	26881	26882
8713	7259	70	applied	\N	\N	\N	\N	26883	26883	26884
8713	7260	71	applied	\N	\N	\N	\N	26888	26888	26889
8713	7261	72	applied	\N	\N	\N	\N	26892	26892	26893
8713	7262	73	applied	\N	\N	\N	\N	26894	26894	26895
8713	7263	74	applied	\N	\N	\N	\N	26896	26896	26897
8713	7264	75	applied	\N	\N	\N	\N	26898	26898	26899
8713	7265	76	applied	\N	\N	\N	\N	26900	26900	26901
8713	7266	77	applied	\N	\N	\N	\N	26902	26902	26903
8713	7267	78	applied	\N	\N	\N	\N	26905	26905	26906
8713	7268	79	applied	\N	\N	\N	\N	26908	26908	26909
8713	7269	80	applied	\N	\N	\N	\N	26910	26910	26911
8713	7270	81	applied	\N	\N	\N	\N	26912	26912	26913
8713	7271	82	applied	\N	\N	\N	\N	26920	26920	26921
8630	7347	0	applied	\N	\N	\N	\N	27186	27186	27187
8630	7348	1	applied	\N	\N	\N	\N	27188	27188	27189
8636	7349	0	applied	\N	\N	\N	\N	27200	27200	1435
8636	7350	1	applied	\N	\N	\N	\N	27201	27201	27202
8639	7351	0	applied	\N	\N	\N	\N	27204	27204	27205
8641	7352	0	applied	\N	\N	\N	\N	27208	27208	27209
8647	7361	0	applied	\N	\N	\N	\N	27233	27233	27234
8647	7362	1	applied	\N	\N	\N	\N	27235	27235	27236
8651	7367	0	applied	\N	\N	\N	\N	27251	27251	27252
8655	7370	0	applied	\N	\N	\N	\N	27264	27264	27265
8661	7371	0	applied	\N	\N	\N	\N	27274	27274	27275
8664	7371	0	applied	\N	\N	\N	\N	27274	27274	27275
8666	7374	0	applied	\N	\N	\N	\N	27286	27286	27287
8680	7385	0	applied	\N	\N	\N	\N	27324	27324	27325
8684	7388	0	applied	\N	\N	\N	\N	27341	27341	27342
8687	7389	0	applied	\N	\N	\N	\N	27345	27345	27346
8687	7390	1	applied	\N	\N	\N	\N	27347	27347	1435
8689	7391	0	applied	\N	\N	\N	\N	27355	27355	27360
8691	7393	0	applied	\N	\N	\N	\N	27365	27365	27366
8694	7396	0	applied	\N	\N	\N	\N	27374	27374	27375
8701	7399	0	applied	\N	\N	\N	\N	27388	27388	27389
8704	7405	0	applied	\N	\N	\N	\N	27404	27404	27405
8704	7406	1	applied	\N	\N	\N	\N	27406	27406	27407
8708	7414	0	applied	\N	\N	\N	\N	27428	27428	27429
8712	7424	0	applied	\N	\N	\N	\N	27454	27454	27455
8712	7425	1	applied	\N	\N	\N	\N	27456	27456	27457
8719	7428	0	applied	\N	\N	\N	\N	27483	27483	27484
8719	7429	1	applied	\N	\N	\N	\N	27485	27485	27486
8719	7430	2	applied	\N	\N	\N	\N	27487	27487	27488
8719	7431	3	applied	\N	\N	\N	\N	27489	27489	27490
8724	7438	0	applied	\N	\N	\N	\N	27512	27512	27513
8724	7439	1	applied	\N	\N	\N	\N	27514	27514	27515
8724	7440	2	applied	\N	\N	\N	\N	27516	27516	27517
8724	7441	3	applied	\N	\N	\N	\N	27518	27518	27519
8724	7442	4	applied	\N	\N	\N	\N	27520	27520	27521
8724	7443	5	applied	\N	\N	\N	\N	27522	27522	27523
8724	7444	6	applied	\N	\N	\N	\N	27524	27524	27525
8729	7449	0	applied	\N	\N	\N	\N	27541	27541	27542
8731	7451	0	applied	\N	\N	\N	\N	27552	27552	27553
8731	7452	1	applied	\N	\N	\N	\N	27554	27554	27555
8734	7453	0	applied	\N	\N	\N	\N	27561	27561	27562
8734	7454	1	applied	\N	\N	\N	\N	27563	27563	27564
8740	7473	0	applied	\N	\N	\N	\N	27614	27614	27615
8740	7474	1	applied	\N	\N	\N	\N	27616	27616	27617
8747	7481	0	applied	\N	\N	\N	\N	27642	27642	27643
8747	7482	1	applied	\N	\N	\N	\N	27644	27644	27645
8752	7487	0	applied	\N	\N	\N	\N	27658	27658	27659
8752	7488	1	applied	\N	\N	\N	\N	27662	27662	27663
8756	7491	0	applied	\N	\N	\N	\N	27675	27675	27676
8756	7492	1	applied	\N	\N	\N	\N	27677	27677	27678
8769	7499	0	applied	\N	\N	\N	\N	27703	27703	27704
8769	7500	1	applied	\N	\N	\N	\N	27705	27705	27706
8772	7503	0	applied	\N	\N	\N	\N	27715	27715	27716
8772	7504	1	applied	\N	\N	\N	\N	27717	27717	27718
8772	7505	2	applied	\N	\N	\N	\N	27719	27719	27720
8772	7506	3	applied	\N	\N	\N	\N	27721	27721	27722
8772	7507	4	applied	\N	\N	\N	\N	27723	27723	27724
8772	7508	5	applied	\N	\N	\N	\N	27725	27725	27726
8777	7513	0	applied	\N	\N	\N	\N	27741	27741	27742
8777	7514	1	applied	\N	\N	\N	\N	27743	27743	27744
8779	7515	0	applied	\N	\N	\N	\N	27749	27749	27750
8779	7516	1	applied	\N	\N	\N	\N	27751	27751	27752
8782	7517	0	applied	\N	\N	\N	\N	27755	27755	27756
8782	7518	1	applied	\N	\N	1000000000	\N	27757	27757	27758
8782	7519	2	applied	\N	\N	\N	\N	27759	27759	27760
8782	7520	3	applied	\N	\N	1000000000	\N	27761	27761	27762
8787	7521	0	applied	\N	\N	\N	\N	27770	27770	27771
8787	7522	1	applied	\N	\N	\N	\N	27772	27772	27773
8788	7523	0	applied	\N	\N	\N	\N	27787	27787	27788
8788	7524	1	applied	\N	\N	\N	\N	27789	27789	27790
8791	7525	0	applied	\N	\N	\N	\N	27795	27795	27796
8791	7526	1	applied	\N	\N	\N	\N	27797	27797	27798
8791	7527	2	applied	\N	\N	\N	\N	27799	27799	27800
8791	7528	3	applied	\N	\N	\N	\N	27801	27801	27802
8794	7525	0	applied	\N	\N	\N	\N	27795	27795	27796
8794	7526	1	applied	\N	\N	\N	\N	27797	27797	27798
8794	7527	2	applied	\N	\N	\N	\N	27799	27799	27800
8794	7528	3	applied	\N	\N	\N	\N	27801	27801	27802
8795	7529	0	applied	\N	\N	\N	\N	27811	27811	27812
8795	7530	1	applied	\N	\N	\N	\N	27813	27813	27814
8795	7531	2	applied	\N	\N	\N	\N	27815	27815	27816
8795	7532	3	applied	\N	\N	\N	\N	27817	27817	27818
8798	7535	0	applied	\N	\N	\N	\N	27827	27827	27828
8798	7536	1	applied	\N	\N	\N	\N	27829	27829	27830
8802	7541	0	applied	\N	\N	\N	\N	27845	27845	27846
8802	7542	1	applied	\N	\N	\N	\N	27847	27847	27848
8805	7543	0	applied	\N	\N	\N	\N	27851	27851	27852
8805	7544	1	applied	\N	\N	\N	\N	27853	27853	27854
8805	7545	2	applied	\N	\N	\N	\N	27855	27855	27856
8805	7546	3	applied	\N	\N	\N	\N	27857	27857	27858
8807	7549	0	applied	\N	\N	\N	\N	27866	27866	27867
8807	7550	1	applied	\N	\N	\N	\N	27868	27868	27869
8814	7555	0	applied	\N	\N	1000000000	\N	27886	27886	27887
8814	7499	1	applied	\N	\N	\N	\N	27703	27703	27704
8814	7500	2	applied	\N	\N	\N	\N	27705	27705	27706
8814	7502	3	applied	\N	\N	\N	\N	27711	27711	27712
8819	7561	0	applied	\N	\N	\N	\N	27905	27905	27906
8819	7562	1	applied	\N	\N	\N	\N	27907	27907	27908
8819	7563	2	applied	\N	\N	\N	\N	27909	27909	27910
8824	7570	0	applied	\N	\N	\N	\N	27930	27930	27931
8824	7571	1	applied	\N	\N	\N	\N	27932	27932	27933
8827	7575	0	applied	\N	\N	\N	\N	27942	27942	27943
8827	7576	1	applied	\N	\N	\N	\N	27944	27944	27945
8827	7577	2	applied	\N	\N	\N	\N	27946	27946	27947
8827	7578	3	applied	\N	\N	\N	\N	27948	27948	27949
8827	7579	4	applied	\N	\N	\N	\N	27950	27950	27951
8827	7580	5	applied	\N	\N	\N	\N	27952	27952	27953
8831	7581	0	applied	\N	\N	\N	\N	27963	27963	27964
8831	7582	1	applied	\N	\N	\N	\N	27965	27965	27966
8831	7583	2	applied	\N	\N	\N	\N	27967	27967	27968
8832	7584	0	applied	\N	\N	1000000000	\N	27971	27971	27972
8832	7585	1	applied	\N	\N	\N	\N	27973	27973	27974
8832	7586	2	applied	\N	\N	\N	\N	27975	27975	27976
8832	7587	3	applied	\N	\N	\N	\N	27977	27977	27978
8832	7588	4	applied	\N	\N	\N	\N	27979	27979	27980
8832	7589	5	applied	\N	\N	\N	\N	27981	27981	27982
8840	7595	0	applied	\N	\N	\N	\N	28001	28001	28002
8840	7596	1	applied	\N	\N	\N	\N	28003	28003	28004
8840	7597	2	applied	\N	\N	\N	\N	28005	28005	28006
8682	7360	56	applied	\N	\N	\N	\N	27230	27230	27231
8682	7361	57	applied	\N	\N	\N	\N	27233	27233	27234
8682	7362	58	applied	\N	\N	\N	\N	27235	27235	27236
8682	7363	59	applied	\N	\N	\N	\N	27241	27241	27242
8682	7364	60	applied	\N	\N	\N	\N	27243	27243	27244
8682	7365	61	applied	\N	\N	\N	\N	27245	27245	27246
8682	7366	62	applied	\N	\N	\N	\N	27247	27247	27248
8682	7367	63	applied	\N	\N	\N	\N	27251	27251	27252
8682	7369	64	applied	\N	\N	\N	\N	27259	27259	27260
8682	7370	65	applied	\N	\N	\N	\N	27264	27264	27265
8682	7371	66	applied	\N	\N	\N	\N	27274	27274	27275
8682	7372	67	applied	\N	\N	\N	\N	27281	27281	27282
8682	7373	68	applied	\N	\N	\N	\N	27283	27283	27284
8682	7374	69	applied	\N	\N	\N	\N	27286	27286	27287
8682	7375	70	applied	\N	\N	\N	\N	27290	27290	27291
8682	7376	71	applied	\N	\N	\N	\N	27292	27292	27293
8682	7377	72	applied	\N	\N	\N	\N	27294	27294	27295
8682	7379	73	applied	\N	\N	\N	\N	27300	27300	27301
8682	7380	74	applied	\N	\N	\N	\N	27302	27302	27303
8682	7381	75	applied	\N	\N	\N	\N	27306	27306	27307
8682	7382	76	applied	\N	\N	\N	\N	27310	27310	27311
8682	7308	77	applied	\N	\N	1000000000	\N	27057	27057	27058
8682	7321	78	applied	\N	\N	\N	\N	27092	27092	27093
8682	7322	79	applied	\N	\N	\N	\N	27094	27094	27095
8682	7323	80	applied	\N	\N	\N	\N	27096	27096	27097
8682	7324	81	applied	\N	\N	\N	\N	27098	27098	27099
8682	7325	82	applied	\N	\N	\N	\N	27100	27100	27101
8682	7326	83	applied	\N	\N	\N	\N	27102	27102	27103
8682	7327	84	applied	\N	\N	\N	\N	27104	27104	27105
8682	7328	85	applied	\N	\N	\N	\N	27106	27106	27107
8682	7329	86	applied	\N	\N	\N	\N	27108	27108	27109
8682	7330	87	applied	\N	\N	\N	\N	27110	27110	27111
8692	7394	0	applied	\N	\N	\N	\N	27367	27367	27368
8692	7395	1	applied	\N	\N	\N	\N	27369	27369	27370
8699	7399	0	applied	\N	\N	\N	\N	27388	27388	27389
8702	7400	0	applied	\N	\N	\N	\N	27392	27392	27393
8702	7401	1	applied	\N	\N	\N	\N	27394	27394	27395
8702	7402	2	applied	\N	\N	\N	\N	27396	27396	27397
8702	7403	3	applied	\N	\N	\N	\N	27398	27398	27399
8702	7404	4	applied	\N	\N	\N	\N	27400	27400	27400
8705	7407	0	applied	\N	\N	\N	\N	27409	27409	27410
8706	7408	0	applied	\N	\N	\N	\N	27413	27413	27414
8706	7409	1	applied	\N	\N	\N	\N	27415	27415	27416
8706	7410	2	applied	\N	\N	\N	\N	27417	27417	27418
8706	7411	3	applied	\N	\N	\N	\N	27419	27419	27420
8709	7415	0	applied	\N	\N	\N	\N	27430	27430	27431
8710	7416	0	applied	\N	\N	\N	\N	27434	27434	27435
8710	7417	1	applied	\N	\N	\N	\N	27436	27436	27437
8710	7418	2	applied	\N	\N	\N	\N	27438	27438	27439
8710	7419	3	applied	\N	\N	\N	\N	27440	27440	27441
8710	7420	4	applied	\N	\N	\N	\N	27442	27442	27443
8710	7421	5	applied	\N	\N	\N	\N	27444	27444	27445
8710	7422	6	applied	\N	\N	1000000000	\N	27446	27446	27447
8710	7423	7	applied	\N	\N	\N	\N	27448	27448	27449
8722	7434	0	applied	\N	\N	\N	\N	27498	27498	27499
8722	7435	1	applied	\N	\N	\N	\N	27500	27500	27501
8722	7436	2	applied	\N	\N	\N	\N	27502	27502	27503
8722	7437	3	applied	\N	\N	\N	\N	27504	27504	27505
8727	7447	0	applied	\N	\N	\N	\N	27535	27535	27536
8727	7448	1	applied	\N	\N	\N	\N	27537	27537	27538
8730	7449	0	applied	\N	\N	\N	\N	27541	27541	27542
8730	7450	2	applied	\N	\N	\N	\N	27548	27548	27549
8737	7463	0	applied	\N	\N	\N	\N	27588	27588	27589
8737	7464	1	applied	\N	\N	\N	\N	27590	27590	27591
8743	7477	0	applied	\N	\N	\N	\N	27626	27626	27627
8743	7478	1	applied	\N	\N	\N	\N	27628	27628	27629
8750	7485	0	applied	\N	\N	\N	\N	27652	27652	27653
8750	7486	1	applied	\N	\N	\N	\N	27654	27654	27655
8753	7487	0	applied	\N	\N	\N	\N	27658	27658	27659
8753	7488	1	applied	\N	\N	\N	\N	27662	27662	27663
8757	7493	0	applied	\N	\N	\N	\N	27681	27681	27682
8757	7494	1	applied	\N	\N	\N	\N	27683	27683	27684
8759	7493	0	applied	\N	\N	\N	\N	27681	27681	27682
8759	7494	1	applied	\N	\N	\N	\N	27683	27683	27684
8761	7495	0	applied	\N	\N	\N	\N	27687	27687	27688
8761	7496	1	applied	\N	\N	\N	\N	27689	27689	27690
8764	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8764	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8773	7503	0	applied	\N	\N	\N	\N	27715	27715	27716
8773	7504	1	applied	\N	\N	\N	\N	27717	27717	27718
8773	7505	2	applied	\N	\N	\N	\N	27719	27719	27720
8773	7506	3	applied	\N	\N	\N	\N	27721	27721	27722
8773	7507	4	applied	\N	\N	\N	\N	27723	27723	27724
8773	7508	5	applied	\N	\N	\N	\N	27725	27725	27726
8775	7509	0	applied	\N	\N	\N	\N	27729	27729	27730
8775	7510	1	applied	\N	\N	\N	\N	27731	27731	27732
8778	7513	0	applied	\N	\N	\N	\N	27741	27741	27742
8778	7514	1	applied	\N	\N	\N	\N	27743	27743	27744
8780	7517	0	applied	\N	\N	\N	\N	27755	27755	27756
8780	7518	1	applied	\N	\N	1000000000	\N	27757	27757	27758
8780	7519	2	applied	\N	\N	\N	\N	27759	27759	27760
8780	7520	3	applied	\N	\N	1000000000	\N	27761	27761	27762
8784	7521	0	applied	\N	\N	\N	\N	27770	27770	27771
8784	7522	1	applied	\N	\N	\N	\N	27772	27772	27773
8800	7538	0	applied	\N	\N	\N	\N	27836	27836	27837
8803	7541	0	applied	\N	\N	\N	\N	27845	27845	27846
8803	7542	1	applied	\N	\N	\N	\N	27847	27847	27848
8810	7552	0	applied	\N	\N	\N	\N	27877	27877	27878
8810	7549	1	applied	\N	\N	\N	\N	27866	27866	27867
8810	7551	2	applied	\N	\N	\N	\N	27872	27872	27873
8812	7553	0	applied	\N	\N	\N	\N	27880	27880	27881
8812	7554	1	applied	\N	\N	\N	\N	27882	27882	27883
8820	7561	0	applied	\N	\N	\N	\N	27905	27905	27906
8820	7562	1	applied	\N	\N	\N	\N	27907	27907	27908
8820	7563	2	applied	\N	\N	\N	\N	27909	27909	27910
8821	7564	0	applied	\N	\N	\N	\N	27915	27915	27916
8821	7565	1	applied	\N	\N	\N	\N	27917	27917	27918
8837	7595	0	applied	\N	\N	\N	\N	28001	28001	28002
8837	7596	1	applied	\N	\N	\N	\N	28003	28003	28004
8837	7597	2	applied	\N	\N	\N	\N	28005	28005	28006
8837	7598	3	applied	\N	\N	\N	\N	28007	28007	28008
8838	7595	0	applied	\N	\N	\N	\N	28001	28001	28002
8838	7596	1	applied	\N	\N	\N	\N	28003	28003	28004
8838	7597	2	applied	\N	\N	\N	\N	28005	28005	28006
8838	7598	3	applied	\N	\N	\N	\N	28007	28007	28008
8844	7605	0	applied	\N	\N	\N	\N	28035	28035	28036
8844	7606	1	applied	\N	\N	\N	\N	28037	28037	28038
8846	7605	0	applied	\N	\N	\N	\N	28035	28035	28036
8851	7611	0	applied	\N	\N	\N	\N	28055	28055	28056
8688	7378	2	applied	\N	\N	\N	\N	27296	27296	27297
8688	7368	3	applied	\N	\N	\N	\N	27351	27351	27258
8688	7384	4	applied	\N	\N	\N	\N	27320	27320	27333
8688	7385	5	applied	\N	\N	\N	\N	27324	27324	27334
8688	7386	6	applied	\N	\N	\N	\N	27330	27330	27335
8688	7387	7	applied	\N	\N	\N	\N	27339	27339	27352
8688	7388	8	applied	\N	\N	\N	\N	27341	27341	27353
8688	7389	9	applied	\N	\N	\N	\N	27345	27345	27354
8688	7391	10	applied	\N	\N	\N	\N	27355	27355	27356
8688	7308	11	applied	\N	\N	1000000000	\N	27057	27057	27058
8688	7321	12	applied	\N	\N	\N	\N	27092	27092	27093
8693	7394	0	applied	\N	\N	\N	\N	27367	27367	27368
8693	7395	1	applied	\N	\N	\N	\N	27369	27369	27370
8696	7397	0	applied	\N	\N	\N	\N	27378	27378	27379
8698	7398	0	applied	\N	\N	\N	\N	27384	27384	27385
8714	7424	0	applied	\N	\N	\N	\N	27454	27454	27455
8714	7425	1	applied	\N	\N	\N	\N	27456	27456	27457
8718	7428	0	applied	\N	\N	\N	\N	27483	27483	27484
8718	7429	1	applied	\N	\N	\N	\N	27485	27485	27486
8718	7430	2	applied	\N	\N	\N	\N	27487	27487	27488
8718	7431	3	applied	\N	\N	\N	\N	27489	27489	27490
8721	7434	0	applied	\N	\N	\N	\N	27498	27498	27499
8721	7435	1	applied	\N	\N	\N	\N	27500	27500	27501
8721	7436	2	applied	\N	\N	\N	\N	27502	27502	27503
8721	7437	3	applied	\N	\N	\N	\N	27504	27504	27505
8733	7453	0	applied	\N	\N	\N	\N	27561	27561	27562
8733	7454	1	applied	\N	\N	\N	\N	27563	27563	27564
8736	7461	0	applied	\N	\N	\N	\N	27582	27582	27583
8736	7462	1	applied	\N	\N	\N	\N	27584	27584	27585
8739	7469	0	applied	\N	\N	\N	\N	27604	27604	27605
8739	7470	1	applied	\N	\N	\N	\N	27606	27606	27607
8739	7471	2	applied	\N	\N	\N	\N	27608	27608	27609
8739	7472	3	applied	\N	\N	\N	\N	27610	27610	27611
8742	7475	0	applied	\N	\N	\N	\N	27618	27618	27619
8742	7476	1	applied	\N	\N	\N	\N	27620	27620	27621
8745	7477	0	applied	\N	\N	\N	\N	27626	27626	27627
8745	7478	1	applied	\N	\N	\N	\N	27628	27628	27629
8746	7479	0	applied	\N	\N	\N	\N	27636	27636	27637
8746	7480	1	applied	\N	\N	\N	\N	27638	27638	27639
8749	7485	0	applied	\N	\N	\N	\N	27652	27652	27653
8749	7486	1	applied	\N	\N	\N	\N	27654	27654	27655
8751	7487	0	applied	\N	\N	\N	\N	27658	27658	27659
8754	7487	0	applied	\N	\N	\N	\N	27658	27658	27659
8754	7488	1	applied	\N	\N	\N	\N	27662	27662	27663
8760	7493	0	applied	\N	\N	\N	\N	27681	27681	27682
8760	7494	1	applied	\N	\N	\N	\N	27683	27683	27684
8763	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8763	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8766	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8766	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8768	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8768	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8771	7501	0	applied	\N	\N	\N	\N	27709	27709	27710
8771	7502	1	applied	\N	\N	\N	\N	27711	27711	27712
8774	7509	0	applied	\N	\N	\N	\N	27729	27729	27730
8774	7510	1	applied	\N	\N	\N	\N	27731	27731	27732
8776	7511	0	applied	\N	\N	\N	\N	27735	27735	27736
8776	7512	1	applied	\N	\N	\N	\N	27737	27737	27738
8783	7517	0	applied	\N	\N	\N	\N	27755	27755	27756
8783	7518	1	applied	\N	\N	1000000000	\N	27757	27757	27758
8783	7519	2	applied	\N	\N	\N	\N	27759	27759	27760
8783	7520	3	applied	\N	\N	1000000000	\N	27761	27761	27762
8786	7521	0	applied	\N	\N	\N	\N	27770	27770	27771
8786	7522	1	applied	\N	\N	\N	\N	27772	27772	27773
8793	7525	0	applied	\N	\N	\N	\N	27795	27795	27796
8793	7526	1	applied	\N	\N	\N	\N	27797	27797	27798
8793	7527	2	applied	\N	\N	\N	\N	27799	27799	27800
8793	7528	3	applied	\N	\N	\N	\N	27801	27801	27802
8797	7535	0	applied	\N	\N	\N	\N	27827	27827	27828
8797	7536	1	applied	\N	\N	\N	\N	27829	27829	27830
8799	7537	0	applied	\N	\N	\N	\N	27834	27834	27835
8799	7538	1	applied	\N	\N	\N	\N	27836	27836	27837
8809	7550	0	applied	\N	\N	\N	\N	27868	27868	27869
8811	7552	0	applied	\N	\N	\N	\N	27877	27877	27878
8813	7553	0	applied	\N	\N	\N	\N	27880	27880	27881
8813	7554	1	applied	\N	\N	\N	\N	27882	27882	27883
8818	7561	0	applied	\N	\N	\N	\N	27905	27905	27906
8818	7562	1	applied	\N	\N	\N	\N	27907	27907	27908
8818	7563	2	applied	\N	\N	\N	\N	27909	27909	27910
8823	7570	0	applied	\N	\N	\N	\N	27930	27930	27931
8823	7571	1	applied	\N	\N	\N	\N	27932	27932	27933
8825	7572	0	applied	\N	\N	\N	\N	27935	27935	27936
8825	7573	1	applied	\N	\N	\N	\N	27937	27937	27938
8825	7574	2	applied	\N	\N	\N	\N	27939	27939	27940
8826	7575	0	applied	\N	\N	\N	\N	27942	27942	27943
8826	7576	1	applied	\N	\N	\N	\N	27944	27944	27945
8826	7577	2	applied	\N	\N	\N	\N	27946	27946	27947
8826	7578	3	applied	\N	\N	\N	\N	27948	27948	27949
8826	7579	4	applied	\N	\N	\N	\N	27950	27950	27951
8826	7580	5	applied	\N	\N	\N	\N	27952	27952	27953
8829	7575	0	applied	\N	\N	\N	\N	27942	27942	27943
8829	7576	1	applied	\N	\N	\N	\N	27944	27944	27945
8829	7577	2	applied	\N	\N	\N	\N	27946	27946	27947
8829	7578	3	applied	\N	\N	\N	\N	27948	27948	27949
8829	7579	4	applied	\N	\N	\N	\N	27950	27950	27951
8829	7580	5	applied	\N	\N	\N	\N	27952	27952	27953
8830	7575	0	applied	\N	\N	\N	\N	27942	27942	27943
8830	7576	1	applied	\N	\N	\N	\N	27944	27944	27945
8830	7577	2	applied	\N	\N	\N	\N	27946	27946	27947
8830	7578	3	applied	\N	\N	\N	\N	27948	27948	27949
8830	7579	4	applied	\N	\N	\N	\N	27950	27950	27951
8830	7580	5	applied	\N	\N	\N	\N	27952	27952	27953
8834	7590	0	applied	\N	\N	\N	\N	27985	27985	27986
8834	7591	1	applied	\N	\N	\N	\N	27987	27987	27988
8836	7592	0	applied	\N	\N	\N	\N	27993	27993	10168
8836	7593	1	applied	\N	\N	\N	\N	27994	27994	27995
8836	7594	2	applied	\N	\N	\N	\N	27996	27996	27997
8839	7595	0	applied	\N	\N	\N	\N	28001	28001	28002
8839	7596	1	applied	\N	\N	\N	\N	28003	28003	28004
8839	7597	2	applied	\N	\N	\N	\N	28005	28005	28006
8839	7598	3	applied	\N	\N	\N	\N	28007	28007	28008
8842	7599	0	applied	\N	\N	\N	\N	28018	28018	28019
8842	7600	1	applied	\N	\N	\N	\N	28020	28020	28021
8842	7601	2	applied	\N	\N	\N	\N	28022	28022	28023
8842	7602	3	applied	\N	\N	\N	\N	28024	28024	28025
8842	7603	4	applied	\N	\N	\N	\N	28026	28026	28027
8842	7604	5	applied	\N	\N	\N	\N	28028	28028	28029
8853	7611	0	applied	\N	\N	\N	\N	28055	28055	28056
8853	7612	1	applied	\N	\N	\N	\N	28057	28057	28058
8713	7272	83	applied	\N	\N	\N	\N	26922	26922	26923
8713	7273	84	applied	\N	\N	\N	\N	26924	26924	26925
8713	7274	85	applied	\N	\N	\N	\N	26927	26927	26928
8713	7275	86	applied	\N	\N	\N	\N	26931	26931	26932
8713	7276	87	applied	\N	\N	\N	\N	26936	26936	26937
8713	7277	88	applied	\N	\N	\N	\N	26940	26940	26941
8713	7278	89	applied	\N	\N	\N	\N	26944	26944	26945
8713	7279	90	applied	\N	\N	\N	\N	26947	26947	26948
8713	7280	91	applied	\N	\N	\N	\N	26951	26951	26952
8713	7281	92	applied	\N	\N	\N	\N	26955	26955	26956
8713	7282	93	applied	\N	\N	\N	\N	26957	26957	26958
8713	7283	94	applied	\N	\N	\N	\N	26959	26959	26960
8713	7284	95	applied	\N	\N	\N	\N	26961	26961	26962
8713	7285	96	applied	\N	\N	\N	\N	26965	26965	26966
8713	7286	97	applied	\N	\N	\N	\N	26967	26967	26968
8713	7287	98	applied	\N	\N	\N	\N	26973	26973	26974
8713	7288	99	applied	\N	\N	\N	\N	26979	26979	26980
8713	7289	100	applied	\N	\N	\N	\N	26983	26983	26984
8713	7290	101	applied	\N	\N	\N	\N	26985	26985	26986
8713	7291	102	applied	\N	\N	\N	\N	26989	26989	26990
8713	7292	103	applied	\N	\N	\N	\N	26991	26991	26992
8713	7293	104	applied	\N	\N	\N	\N	26996	26996	26997
8713	7294	105	applied	\N	\N	\N	\N	27002	27002	27003
8713	7295	106	applied	\N	\N	\N	\N	27004	27004	27005
8713	7296	107	applied	\N	\N	\N	\N	27006	27006	27007
8713	7297	108	applied	\N	\N	\N	\N	27010	27010	27011
8713	7298	109	applied	\N	\N	\N	\N	27014	27014	27015
8713	7299	110	applied	\N	\N	\N	\N	27018	27018	27019
8713	7300	111	applied	\N	\N	\N	\N	27021	27021	27022
8713	7301	112	applied	\N	\N	\N	\N	27029	27029	27030
8713	7302	113	applied	\N	\N	\N	\N	27033	27033	27034
8713	7303	114	applied	\N	\N	\N	\N	27037	27037	27038
8713	7304	115	applied	\N	\N	\N	\N	27041	27041	27042
8713	7305	116	applied	\N	\N	\N	\N	27043	27043	27044
8713	7306	117	applied	\N	\N	\N	\N	27045	27045	27046
8713	7307	118	applied	\N	\N	\N	\N	27055	27055	27056
8715	7426	0	applied	\N	\N	\N	\N	27475	27475	27476
8715	7427	1	applied	\N	\N	\N	\N	27477	27477	27478
8717	7426	0	applied	\N	\N	\N	\N	27475	27475	27476
8717	7427	1	applied	\N	\N	\N	\N	27477	27477	27478
8720	7432	0	applied	\N	\N	\N	\N	27493	27493	27494
8720	7433	1	applied	\N	\N	\N	\N	27495	27495	27496
8723	7434	0	applied	\N	\N	\N	\N	27498	27498	27499
8723	7435	1	applied	\N	\N	\N	\N	27500	27500	27501
8723	7436	2	applied	\N	\N	\N	\N	27502	27502	27503
8723	7437	3	applied	\N	\N	\N	\N	27504	27504	27505
8726	7445	0	applied	\N	\N	\N	\N	27530	27530	27531
8726	7446	1	applied	\N	\N	\N	\N	27532	27532	27533
8728	7449	0	applied	\N	\N	\N	\N	27541	27541	27542
8732	7451	0	applied	\N	\N	\N	\N	27552	27552	27553
8732	7452	1	applied	\N	\N	\N	\N	27554	27554	27555
8735	7455	0	applied	\N	\N	\N	\N	27568	27568	27569
8735	7456	1	applied	\N	\N	\N	\N	27570	27570	27571
8735	7457	2	applied	\N	\N	\N	\N	27572	27572	27573
8735	7458	3	applied	\N	\N	\N	\N	27574	27574	27575
8735	7459	4	applied	\N	\N	\N	\N	27576	27576	27577
8735	7460	5	applied	\N	\N	\N	\N	27578	27578	27579
8738	7465	0	applied	\N	\N	\N	\N	27594	27594	27595
8738	7466	1	applied	\N	\N	\N	\N	27596	27596	27597
8738	7467	2	applied	\N	\N	\N	\N	27598	27598	27599
8738	7468	3	applied	\N	\N	\N	\N	27600	27600	27601
8741	7475	0	applied	\N	\N	\N	\N	27618	27618	27619
8741	7476	1	applied	\N	\N	\N	\N	27620	27620	27621
8744	7477	0	applied	\N	\N	\N	\N	27626	27626	27627
8744	7478	1	applied	\N	\N	\N	\N	27628	27628	27629
8748	7483	0	applied	\N	\N	\N	\N	27646	27646	27647
8748	7484	1	applied	\N	\N	\N	\N	27648	27648	27649
8755	7489	0	applied	\N	\N	\N	\N	27669	27669	27670
8755	7490	1	applied	\N	\N	\N	\N	27671	27671	27672
8758	7493	0	applied	\N	\N	\N	\N	27681	27681	27682
8758	7494	1	applied	\N	\N	\N	\N	27683	27683	27684
8762	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8762	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8765	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8765	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8767	7497	0	applied	\N	\N	\N	\N	27692	27692	27693
8767	7498	1	applied	\N	\N	\N	\N	27694	27694	27695
8770	7499	0	applied	\N	\N	\N	\N	27703	27703	27704
8770	7500	1	applied	\N	\N	\N	\N	27705	27705	27706
8781	7517	0	applied	\N	\N	\N	\N	27755	27755	27756
8781	7518	1	applied	\N	\N	1000000000	\N	27757	27757	27758
8781	7519	2	applied	\N	\N	\N	\N	27759	27759	27760
8781	7520	3	applied	\N	\N	1000000000	\N	27761	27761	27762
8785	7521	0	applied	\N	\N	\N	\N	27770	27770	27771
8785	7522	1	applied	\N	\N	\N	\N	27772	27772	27773
8792	7525	0	applied	\N	\N	\N	\N	27795	27795	27796
8792	7526	1	applied	\N	\N	\N	\N	27797	27797	27798
8792	7527	2	applied	\N	\N	\N	\N	27799	27799	27800
8792	7528	3	applied	\N	\N	\N	\N	27801	27801	27802
8796	7533	0	applied	\N	\N	\N	\N	27821	27821	27822
8796	7534	1	applied	\N	\N	\N	\N	27823	27823	27824
8801	7537	0	applied	\N	\N	\N	\N	27834	27834	27835
8801	7539	1	applied	\N	\N	\N	\N	27840	27840	27841
8801	7540	2	applied	\N	\N	\N	\N	27842	27842	27843
8806	7547	0	applied	\N	\N	\N	\N	27860	27860	27861
8806	7548	1	applied	\N	\N	\N	\N	27862	27862	27863
8808	7549	0	applied	\N	\N	\N	\N	27866	27866	27867
8808	7550	1	applied	\N	\N	\N	\N	27868	27868	27869
8808	7551	2	applied	\N	\N	\N	\N	27872	27872	27873
8815	7556	0	applied	\N	\N	\N	\N	27890	27890	27891
8815	7555	1	applied	\N	\N	1000000000	\N	27886	27886	27887
8815	7557	2	applied	\N	\N	\N	\N	27892	27892	27893
8817	7558	0	applied	\N	\N	\N	\N	27897	27897	27898
8817	7559	1	applied	\N	\N	\N	\N	27899	27899	27900
8817	7560	2	applied	\N	\N	\N	\N	27901	27901	27902
8822	7566	0	applied	\N	\N	\N	\N	27920	27920	27921
8822	7567	1	applied	\N	\N	\N	\N	27922	27922	27923
8822	7568	2	applied	\N	\N	\N	\N	27924	27924	27925
8822	7569	3	applied	\N	\N	\N	\N	27926	27926	27927
8828	7575	0	applied	\N	\N	\N	\N	27942	27942	27943
8828	7576	1	applied	\N	\N	\N	\N	27944	27944	27945
8828	7577	2	applied	\N	\N	\N	\N	27946	27946	27947
8828	7578	3	applied	\N	\N	\N	\N	27948	27948	27949
8828	7579	4	applied	\N	\N	\N	\N	27950	27950	27951
8828	7580	5	applied	\N	\N	\N	\N	27952	27952	27953
8833	7590	0	applied	\N	\N	\N	\N	27985	27985	27986
8833	7591	1	applied	\N	\N	\N	\N	27987	27987	27988
8835	7592	0	applied	\N	\N	\N	\N	27993	27993	10168
8835	7593	1	applied	\N	\N	\N	\N	27994	27994	27995
8835	7594	2	applied	\N	\N	\N	\N	27996	27996	27997
8841	7599	0	applied	\N	\N	\N	\N	28018	28018	28019
8841	7600	1	applied	\N	\N	\N	\N	28020	28020	28021
8841	7601	2	applied	\N	\N	\N	\N	28022	28022	28023
8841	7602	3	applied	\N	\N	\N	\N	28024	28024	28025
8841	7603	4	applied	\N	\N	\N	\N	28026	28026	28027
8841	7604	5	applied	\N	\N	\N	\N	28028	28028	28029
8845	7605	0	applied	\N	\N	\N	\N	28035	28035	28036
8847	7605	0	applied	\N	\N	\N	\N	28035	28035	28036
8847	7606	1	applied	\N	\N	\N	\N	28037	28037	28038
8849	7609	0	applied	\N	\N	\N	\N	28048	28048	28049
8849	7610	1	applied	\N	\N	\N	\N	28050	28050	28051
8852	7611	0	applied	\N	\N	\N	\N	28055	28055	28056
8852	7612	1	applied	\N	\N	\N	\N	28057	28057	28058
8858	7617	0	applied	\N	\N	\N	\N	28075	28075	28076
8858	7618	1	applied	\N	\N	\N	\N	28077	28077	28078
8861	7621	0	applied	\N	\N	\N	\N	28087	28087	28088
8861	7622	1	applied	\N	\N	\N	\N	28089	28089	28090
8864	7623	0	applied	\N	\N	\N	\N	28092	28092	28093
8864	7624	1	applied	\N	\N	\N	\N	28094	28094	28095
8865	7625	0	applied	\N	\N	\N	\N	28101	28101	28102
8865	7626	1	applied	\N	\N	\N	\N	28103	28103	28104
8868	7627	0	applied	\N	\N	\N	\N	28109	28109	28110
8868	7628	1	applied	\N	\N	\N	\N	28111	28111	28112
8870	7633	0	applied	\N	\N	\N	\N	28125	28125	28126
8870	7634	1	applied	\N	\N	\N	\N	28127	28127	28128
8877	7637	0	applied	\N	\N	\N	\N	28138	28138	28139
8877	7638	1	applied	\N	\N	\N	\N	28140	28140	28141
8877	7639	2	applied	\N	\N	\N	\N	28142	28142	28143
8877	7640	3	applied	\N	\N	\N	\N	28144	28144	28145
8877	7641	4	applied	\N	\N	\N	\N	28146	28146	28147
8879	7572	0	applied	\N	\N	\N	\N	27935	27935	27936
8879	7589	1	applied	\N	\N	\N	\N	27981	27981	27982
8882	7646	0	applied	\N	\N	\N	\N	28165	28165	28166
8882	7647	1	applied	\N	\N	\N	\N	28167	28167	28168
8882	7648	2	applied	\N	\N	\N	\N	28169	28169	28170
8882	7649	3	applied	\N	\N	\N	\N	28171	28171	28172
8885	7656	0	applied	\N	\N	\N	\N	28189	28189	28190
8885	7657	1	applied	\N	\N	\N	\N	28191	28191	28192
8886	7658	0	applied	\N	\N	\N	\N	28195	28195	28196
8886	7659	1	applied	\N	\N	\N	\N	28197	28197	28198
8886	7660	2	applied	\N	\N	\N	\N	28199	28199	28200
8886	7661	3	applied	\N	\N	\N	\N	28201	28201	28202
8886	7662	4	applied	\N	\N	\N	\N	28203	28203	28204
8886	7663	5	applied	\N	\N	\N	\N	28205	28205	28206
8886	7664	6	applied	\N	\N	\N	\N	28207	28207	28208
8886	7665	7	applied	\N	\N	\N	\N	28209	28209	28210
8900	7678	0	applied	\N	\N	\N	\N	28253	28253	28254
8900	7679	1	applied	\N	\N	\N	\N	28255	28255	28256
8900	7680	2	applied	\N	\N	1000000000	\N	28257	28257	28258
8907	7685	0	applied	\N	\N	\N	\N	28270	28270	28271
8907	7686	1	applied	\N	\N	\N	\N	28272	28272	28273
8907	7687	2	applied	\N	\N	\N	\N	28274	28274	28275
8907	7688	3	applied	\N	\N	\N	\N	28276	28276	28277
8910	7691	0	applied	\N	\N	\N	\N	28288	28288	28289
8910	7692	1	applied	\N	\N	\N	\N	28290	28290	28291
8910	7693	2	applied	\N	\N	\N	\N	28292	28292	28293
8910	7694	3	applied	\N	\N	\N	\N	28294	28294	28295
8910	7695	4	applied	\N	\N	\N	\N	28296	28296	28297
8910	7696	5	applied	\N	\N	\N	\N	28298	28298	28299
8915	7702	0	applied	\N	\N	\N	\N	28317	28317	28318
8923	7716	0	applied	\N	\N	\N	\N	28358	28358	28359
8923	7707	1	applied	\N	\N	\N	\N	28330	28330	28331
8925	7721	0	applied	\N	\N	\N	\N	28374	28374	28375
8925	7722	1	applied	\N	\N	\N	\N	28376	28376	28377
8928	7723	0	applied	\N	\N	\N	\N	28380	28380	28381
8928	7724	1	applied	\N	\N	\N	\N	28382	28382	28383
8933	7736	0	applied	\N	\N	\N	\N	28416	28416	28417
8933	7737	1	applied	\N	\N	\N	\N	28418	28418	28419
8933	7738	2	applied	\N	\N	\N	\N	28420	28420	28421
8933	7739	3	applied	\N	\N	\N	\N	28422	28422	28423
8935	7740	0	applied	\N	\N	\N	\N	28425	28425	28426
8935	7741	1	applied	\N	\N	\N	\N	28427	28427	28428
8943	7754	0	applied	\N	\N	\N	\N	28462	28462	28463
8943	7755	1	applied	\N	\N	\N	\N	28464	28464	28465
8950	7764	0	applied	\N	\N	\N	\N	28496	28496	28497
8950	7765	1	applied	\N	\N	\N	\N	28498	28498	28499
8953	7771	0	applied	\N	\N	\N	\N	28513	28513	28514
8953	7772	1	applied	\N	\N	\N	\N	28515	28515	28516
8953	7773	2	applied	\N	\N	\N	\N	28517	28517	28518
8953	7774	3	applied	\N	\N	\N	\N	28519	28519	28520
8958	7727	0	failed	Receiver_not_present	\N	\N	\N	28394	28394	\N
8958	7756	1	applied	\N	\N	\N	\N	28470	28470	28471
8958	7761	2	applied	\N	\N	\N	\N	28486	28486	28487
8958	7581	3	applied	\N	\N	\N	\N	27963	27963	27964
8958	7646	4	applied	\N	\N	\N	\N	28165	28165	28166
8958	7572	5	applied	\N	\N	\N	\N	27935	27935	27936
8958	7555	6	applied	\N	\N	1000000000	\N	27886	27886	27887
8958	7553	7	applied	\N	\N	\N	\N	27880	27880	27881
8958	7554	8	applied	\N	\N	\N	\N	27882	27882	27883
8958	7556	9	applied	\N	\N	\N	\N	27890	27890	27891
8958	7559	10	applied	\N	\N	\N	\N	27899	27899	27900
8958	7560	11	applied	\N	\N	\N	\N	27901	27901	27902
8958	7562	12	applied	\N	\N	\N	\N	27907	27907	27908
8958	7563	13	applied	\N	\N	\N	\N	27909	27909	27910
8958	7564	14	applied	\N	\N	\N	\N	27915	27915	27916
8958	7557	15	applied	\N	\N	\N	\N	27892	27892	27893
8958	7558	16	applied	\N	\N	\N	\N	27897	27897	27898
8958	7561	17	applied	\N	\N	\N	\N	27905	27905	27906
8958	7565	18	applied	\N	\N	\N	\N	27917	27917	27918
8958	7566	19	applied	\N	\N	\N	\N	27920	27920	27921
8958	7567	20	applied	\N	\N	\N	\N	27922	27922	27923
8958	7568	21	applied	\N	\N	\N	\N	27924	27924	27925
8958	7571	22	applied	\N	\N	\N	\N	27932	27932	27933
8958	7574	23	applied	\N	\N	\N	\N	27939	27939	27940
8958	7576	24	applied	\N	\N	\N	\N	27944	27944	27945
8958	7577	25	applied	\N	\N	\N	\N	27946	27946	27947
8958	7579	26	applied	\N	\N	\N	\N	27950	27950	27951
8958	7582	27	applied	\N	\N	\N	\N	27965	27965	27966
8958	7584	28	applied	\N	\N	1000000000	\N	27971	27971	27972
8958	7586	29	applied	\N	\N	\N	\N	27975	27975	27976
8958	7587	30	applied	\N	\N	\N	\N	27977	27977	27978
8958	7591	31	applied	\N	\N	\N	\N	27987	27987	27988
8958	7593	32	applied	\N	\N	\N	\N	27994	27994	27995
8958	7595	33	applied	\N	\N	\N	\N	28001	28001	28002
8958	7596	34	applied	\N	\N	\N	\N	28003	28003	28004
8958	7599	35	applied	\N	\N	\N	\N	28018	28018	28019
8958	7600	36	applied	\N	\N	\N	\N	28020	28020	28021
8958	7601	37	applied	\N	\N	\N	\N	28022	28022	28023
8840	7598	3	applied	\N	\N	\N	\N	28007	28007	28008
8843	7599	0	applied	\N	\N	\N	\N	28018	28018	28019
8843	7600	1	applied	\N	\N	\N	\N	28020	28020	28021
8843	7601	2	applied	\N	\N	\N	\N	28022	28022	28023
8843	7602	3	applied	\N	\N	\N	\N	28024	28024	28025
8843	7603	4	applied	\N	\N	\N	\N	28026	28026	28027
8843	7604	5	applied	\N	\N	\N	\N	28028	28028	28029
8848	7607	0	applied	\N	\N	\N	\N	28042	28042	28043
8848	7606	1	applied	\N	\N	\N	\N	28037	28037	28038
8848	7608	2	applied	\N	\N	\N	\N	28044	28044	28045
8850	7609	0	applied	\N	\N	\N	\N	28048	28048	28049
8850	7610	1	applied	\N	\N	\N	\N	28050	28050	28051
8854	7611	0	applied	\N	\N	\N	\N	28055	28055	28056
8854	7612	1	applied	\N	\N	\N	\N	28057	28057	28058
8857	7615	0	applied	\N	\N	\N	\N	28071	28071	28072
8857	7616	1	applied	\N	\N	\N	\N	28073	28073	28074
8862	7623	0	applied	\N	\N	\N	\N	28092	28092	28093
8862	7624	1	applied	\N	\N	\N	\N	28094	28094	28095
8869	7629	0	applied	\N	\N	\N	\N	28116	28116	28117
8869	7630	1	applied	\N	\N	\N	\N	28118	28118	28119
8869	7631	2	applied	\N	\N	\N	\N	28120	28120	28121
8869	7632	3	applied	\N	\N	\N	\N	28122	28122	28123
8878	7637	0	applied	\N	\N	\N	\N	28138	28138	28139
8878	7638	1	applied	\N	\N	\N	\N	28140	28140	28141
8878	7639	2	applied	\N	\N	\N	\N	28142	28142	28143
8878	7640	3	applied	\N	\N	\N	\N	28144	28144	28145
8878	7641	4	applied	\N	\N	\N	\N	28146	28146	28147
8881	7642	0	applied	\N	\N	\N	\N	28153	28153	28154
8881	7643	1	applied	\N	\N	\N	\N	28155	28155	28156
8881	7644	2	applied	\N	\N	\N	\N	28157	28157	28158
8881	7645	3	applied	\N	\N	\N	\N	28159	28159	28160
8884	7654	0	applied	\N	\N	\N	\N	28184	28184	28185
8884	7655	1	applied	\N	\N	\N	\N	28186	28186	28187
8888	7666	0	applied	\N	\N	\N	\N	28213	28213	28214
8888	7667	1	applied	\N	\N	\N	\N	28215	28215	28216
8893	7668	0	applied	\N	\N	\N	\N	28219	28219	28220
8893	7669	1	applied	\N	\N	\N	\N	28221	28221	28222
8897	7670	0	applied	\N	\N	\N	\N	28229	28229	28230
8897	7671	1	applied	\N	\N	\N	\N	28231	28231	28232
8897	7672	2	applied	\N	\N	\N	\N	28233	28233	28234
8897	7674	3	applied	\N	\N	\N	\N	28240	28240	28241
8897	7675	4	applied	\N	\N	\N	\N	28242	28242	28243
8897	7673	5	applied	\N	\N	\N	\N	28235	28235	28236
8897	7676	6	applied	\N	\N	\N	\N	28246	28246	28247
8897	7677	7	applied	\N	\N	\N	\N	28248	28248	28249
8899	7674	0	applied	\N	\N	\N	\N	28240	28240	28241
8899	7675	1	applied	\N	\N	\N	\N	28242	28242	28243
8899	7676	2	applied	\N	\N	\N	\N	28246	28246	28247
8899	7677	3	applied	\N	\N	\N	\N	28248	28248	28249
8902	7678	0	applied	\N	\N	\N	\N	28253	28253	28254
8902	7679	1	applied	\N	\N	\N	\N	28255	28255	28256
8902	7680	2	applied	\N	\N	1000000000	\N	28257	28257	28258
8905	7681	0	applied	\N	\N	\N	\N	28261	28261	28262
8905	7682	1	applied	\N	\N	\N	\N	28263	28263	28264
8908	7689	0	applied	\N	\N	\N	\N	28280	28280	28281
8908	7690	1	applied	\N	\N	\N	\N	28282	28282	28283
8911	7697	0	applied	\N	\N	\N	\N	28302	28302	28303
8911	7698	1	applied	\N	\N	\N	\N	28304	28304	28305
8916	7703	0	applied	\N	\N	\N	\N	28322	28322	28323
8916	7704	1	applied	\N	\N	\N	\N	28324	28324	28325
8916	7705	2	applied	\N	\N	\N	\N	28326	28326	28327
8916	7706	3	applied	\N	\N	\N	\N	28328	28328	28329
8916	7707	4	applied	\N	\N	\N	\N	28330	28330	28331
8921	7712	0	applied	\N	\N	\N	\N	28350	28350	28351
8921	7713	1	applied	\N	\N	\N	\N	28352	28352	28353
8921	7714	2	applied	\N	\N	\N	\N	28354	28354	28355
8921	7715	3	applied	\N	\N	\N	\N	28356	28356	28357
8921	7716	4	applied	\N	\N	\N	\N	28358	28358	28359
8926	7723	0	applied	\N	\N	\N	\N	28380	28380	28381
8926	7724	1	applied	\N	\N	\N	\N	28382	28382	28383
8931	7730	0	applied	\N	\N	\N	\N	28401	28401	28402
8931	7731	1	applied	\N	\N	\N	\N	28403	28403	28404
8931	7732	2	applied	\N	\N	\N	\N	28405	28405	28406
8931	7733	3	applied	\N	\N	\N	\N	28407	28407	28408
8936	7740	0	applied	\N	\N	\N	\N	28425	28425	28426
8936	7741	1	applied	\N	\N	\N	\N	28427	28427	28428
8939	7744	0	applied	\N	\N	\N	\N	28437	28437	28438
8939	7745	2	applied	\N	\N	\N	\N	28440	28440	28441
8939	7746	3	applied	\N	\N	\N	\N	28442	28442	28443
8939	7747	4	applied	\N	\N	\N	\N	28444	28444	28445
8944	7756	0	applied	\N	\N	\N	\N	28470	28470	28471
8944	7757	1	applied	\N	\N	\N	\N	28472	28472	28473
8944	7758	2	applied	\N	\N	\N	\N	28474	28474	28475
8959	7779	0	applied	\N	\N	\N	\N	28539	28539	28540
8959	7780	1	applied	\N	\N	\N	\N	28541	28541	28542
8959	7781	2	applied	\N	\N	\N	\N	28543	28543	28544
8959	7782	3	applied	\N	\N	\N	\N	28545	28545	28546
8959	7783	4	applied	\N	\N	\N	\N	28547	28547	28548
8964	7788	0	applied	\N	\N	\N	\N	28561	28561	28562
8964	7789	1	applied	\N	\N	\N	\N	28563	28563	28564
8964	7790	2	applied	\N	\N	\N	\N	28565	28565	28566
8964	7791	3	applied	\N	\N	\N	\N	28567	28567	28568
8967	7794	0	applied	\N	\N	\N	\N	28581	28581	28582
8967	7795	1	applied	\N	\N	\N	\N	28583	28583	28584
8967	7796	2	applied	\N	\N	\N	\N	28585	28585	28586
8967	7797	3	applied	\N	\N	\N	\N	28587	28587	28588
8984	7821	0	applied	\N	\N	\N	\N	28665	28665	28666
8984	7822	1	applied	\N	\N	\N	\N	28667	28667	28668
8993	7830	0	applied	\N	\N	\N	\N	28706	28706	28707
8993	7831	1	applied	\N	\N	\N	\N	28708	28708	28709
8996	7832	0	applied	\N	\N	\N	\N	28710	28710	28711
8996	7833	1	applied	\N	\N	\N	\N	28712	28712	28713
8996	7834	2	applied	\N	\N	\N	\N	28714	28714	28715
8996	7835	3	applied	\N	\N	\N	\N	28716	28716	28717
8996	7836	4	applied	\N	\N	\N	\N	28718	28718	28719
9001	7847	0	applied	\N	\N	\N	\N	28749	28749	28750
9001	7848	1	applied	\N	\N	\N	\N	28751	28751	28752
9012	7857	0	applied	\N	\N	\N	\N	28785	28785	28786
9012	7858	1	applied	\N	\N	\N	\N	28787	28787	28788
9015	7865	0	applied	\N	\N	\N	\N	28806	28806	28807
9015	7866	1	applied	\N	\N	\N	\N	28808	28808	28809
9018	7871	0	applied	\N	\N	\N	\N	28822	28822	28823
9018	7872	1	applied	\N	\N	\N	\N	28824	28824	28825
9018	7873	2	applied	\N	\N	\N	\N	28826	28826	28827
9018	7874	3	applied	\N	\N	\N	\N	28828	28828	28829
9018	7875	4	applied	\N	\N	\N	\N	28830	28830	27453
9021	7876	0	applied	\N	\N	\N	\N	28833	28833	28834
9023	7880	0	applied	\N	\N	\N	\N	28846	28846	28847
9023	7881	1	applied	\N	\N	\N	\N	28848	28848	28849
9023	7882	2	applied	\N	\N	\N	\N	28850	28850	28851
8851	7612	1	applied	\N	\N	\N	\N	28057	28057	28058
8855	7611	0	applied	\N	\N	\N	\N	28055	28055	28056
8855	7612	1	applied	\N	\N	\N	\N	28057	28057	28058
8860	7621	0	applied	\N	\N	\N	\N	28087	28087	28088
8860	7622	1	applied	\N	\N	\N	\N	28089	28089	28090
8863	7623	0	applied	\N	\N	\N	\N	28092	28092	28093
8863	7624	1	applied	\N	\N	\N	\N	28094	28094	28095
8867	7627	0	applied	\N	\N	\N	\N	28109	28109	28110
8867	7628	1	applied	\N	\N	\N	\N	28111	28111	28112
8872	7633	0	applied	\N	\N	\N	\N	28125	28125	28126
8872	7634	1	applied	\N	\N	\N	\N	28127	28127	28128
8873	7633	0	applied	\N	\N	\N	\N	28125	28125	28126
8873	7634	1	applied	\N	\N	\N	\N	28127	28127	28128
8874	7635	0	applied	\N	\N	\N	\N	28131	28131	28132
8874	7636	1	applied	\N	\N	\N	\N	28133	28133	28134
8876	7627	0	applied	\N	\N	\N	\N	28109	28109	28110
8876	7631	1	applied	\N	\N	\N	\N	28120	28120	28121
8876	7628	2	applied	\N	\N	\N	\N	28111	28111	28112
8876	7629	3	applied	\N	\N	\N	\N	28116	28116	28117
8876	7630	4	applied	\N	\N	\N	\N	28118	28118	28119
8876	7634	5	applied	\N	\N	\N	\N	28127	28127	28128
8876	7636	6	applied	\N	\N	\N	\N	28133	28133	28134
8876	7632	7	applied	\N	\N	\N	\N	28122	28122	28123
8876	7633	8	applied	\N	\N	\N	\N	28125	28125	28126
8891	7668	0	applied	\N	\N	\N	\N	28219	28219	28220
8891	7669	1	applied	\N	\N	\N	\N	28221	28221	28222
8895	7670	0	applied	\N	\N	\N	\N	28229	28229	28230
8895	7671	1	applied	\N	\N	\N	\N	28231	28231	28232
8895	7672	2	applied	\N	\N	\N	\N	28233	28233	28234
8895	7673	3	applied	\N	\N	\N	\N	28235	28235	28236
8898	7674	0	applied	\N	\N	\N	\N	28240	28240	28241
8898	7675	1	applied	\N	\N	\N	\N	28242	28242	28243
8898	7676	2	applied	\N	\N	\N	\N	28246	28246	28247
8898	7677	3	applied	\N	\N	\N	\N	28248	28248	28249
8903	7678	0	applied	\N	\N	\N	\N	28253	28253	28254
8903	7679	1	applied	\N	\N	\N	\N	28255	28255	28256
8903	7680	2	applied	\N	\N	1000000000	\N	28257	28257	28258
8906	7683	0	applied	\N	\N	\N	\N	28265	28265	28266
8906	7684	1	applied	\N	\N	\N	\N	28267	28267	28268
8909	7689	0	applied	\N	\N	\N	\N	28280	28280	28281
8909	7690	1	applied	\N	\N	\N	\N	28282	28282	28283
8912	7697	0	applied	\N	\N	\N	\N	28302	28302	28303
8912	7698	1	applied	\N	\N	\N	\N	28304	28304	28305
8914	7701	0	applied	\N	\N	\N	\N	28315	28315	28316
8914	7702	1	applied	\N	\N	\N	\N	28317	28317	28318
8917	7703	0	applied	\N	\N	\N	\N	28322	28322	28323
8917	7704	1	applied	\N	\N	\N	\N	28324	28324	28325
8917	7705	2	applied	\N	\N	\N	\N	28326	28326	28327
8917	7706	3	applied	\N	\N	\N	\N	28328	28328	28329
8917	7707	4	applied	\N	\N	\N	\N	28330	28330	28331
8919	7708	0	applied	\N	\N	\N	\N	28336	28336	28337
8919	7709	1	applied	\N	\N	\N	\N	28338	28338	28339
8922	7717	0	applied	\N	\N	\N	\N	28362	28362	28363
8922	7718	1	applied	\N	\N	\N	\N	28364	28364	28365
8924	7719	0	applied	\N	\N	\N	\N	28368	28368	28369
8924	7720	1	applied	\N	\N	\N	\N	28370	28370	28371
8927	7723	0	applied	\N	\N	\N	\N	28380	28380	28381
8927	7724	1	applied	\N	\N	\N	\N	28382	28382	28383
8929	7725	0	applied	\N	\N	\N	\N	28389	28389	28390
8929	7726	1	applied	\N	\N	\N	\N	28391	28391	28392
8932	7734	0	applied	\N	\N	\N	\N	28410	28410	28411
8932	7735	1	applied	\N	\N	\N	\N	28412	28412	28413
8937	7742	0	applied	\N	\N	\N	\N	28431	28431	28432
8937	7743	1	applied	\N	\N	\N	\N	28433	28433	28434
8942	7754	0	applied	\N	\N	\N	\N	28462	28462	28463
8942	7755	1	applied	\N	\N	\N	\N	28464	28464	28465
8945	7727	0	failed	Receiver_not_present	\N	\N	\N	28394	28394	\N
8945	7756	1	applied	\N	\N	\N	\N	28470	28470	28471
8947	7761	0	applied	\N	\N	\N	\N	28486	28486	28487
8947	7759	1	applied	\N	\N	\N	\N	28480	28480	28481
8947	7762	2	applied	\N	\N	\N	\N	28488	28488	28489
8947	7760	3	applied	\N	\N	\N	\N	28482	28482	28483
8947	7763	4	applied	\N	\N	\N	\N	28490	28490	28491
8952	7769	0	applied	\N	\N	\N	\N	28507	28507	28508
8952	7770	1	applied	\N	\N	\N	\N	28509	28509	28510
8955	7766	0	failed	Receiver_not_present	\N	\N	\N	28500	28500	\N
8955	7761	1	applied	\N	\N	\N	\N	28486	28486	28487
8957	7775	0	applied	\N	\N	\N	\N	28525	28525	28526
8957	7776	1	applied	\N	\N	\N	\N	28527	28527	28528
8957	7777	2	applied	\N	\N	\N	\N	28529	28529	28530
8957	7778	3	applied	\N	\N	\N	\N	28531	28531	28532
8962	7784	0	applied	\N	\N	\N	\N	28552	28552	28553
8962	7785	1	applied	\N	\N	\N	\N	28554	28554	28555
8965	7792	0	applied	\N	\N	\N	\N	28571	28571	28572
8965	7793	1	applied	\N	\N	\N	\N	28573	28573	28574
8968	7794	0	applied	\N	\N	\N	\N	28581	28581	28582
8968	7795	1	applied	\N	\N	\N	\N	28583	28583	28584
8968	7796	2	applied	\N	\N	\N	\N	28585	28585	28586
8968	7797	3	applied	\N	\N	\N	\N	28587	28587	28588
8970	7798	0	applied	\N	\N	\N	\N	28593	28593	28594
8970	7799	1	applied	\N	\N	\N	\N	28595	28595	28596
8970	7800	2	applied	\N	\N	\N	\N	28597	28597	28598
8970	7801	3	applied	\N	\N	\N	\N	28599	28599	28600
8970	7802	4	applied	\N	\N	1000000000	\N	28601	28601	28602
8973	7811	0	applied	\N	\N	\N	\N	28625	28625	28626
8973	7812	1	applied	\N	\N	\N	\N	28627	28627	28628
8975	7727	0	failed	Receiver_not_present	\N	\N	\N	28394	28394	\N
8975	7756	1	applied	\N	\N	\N	\N	28470	28470	28471
8975	7761	2	applied	\N	\N	\N	\N	28486	28486	28487
8975	7438	3	applied	\N	\N	\N	\N	28633	28633	27513
8975	7375	4	applied	\N	\N	\N	\N	27290	27290	27291
8975	7572	5	applied	\N	\N	\N	\N	27935	27935	27936
8975	7383	6	applied	\N	\N	\N	\N	27318	27318	27319
8975	7376	7	applied	\N	\N	\N	\N	27292	27292	27293
8975	7377	8	applied	\N	\N	\N	\N	27294	27294	27295
8975	7555	9	applied	\N	\N	1000000000	\N	27886	27886	27887
8975	7378	10	applied	\N	\N	\N	\N	27296	27296	27297
8975	7379	11	applied	\N	\N	\N	\N	27300	27300	27301
8975	7380	12	applied	\N	\N	\N	\N	27302	27302	27303
8975	7384	13	applied	\N	\N	\N	\N	27320	27320	27321
8975	7385	14	applied	\N	\N	\N	\N	27324	27324	27325
8975	7386	15	applied	\N	\N	\N	\N	27330	27330	27331
8975	7387	16	applied	\N	\N	\N	\N	27339	27339	27340
8975	7388	17	applied	\N	\N	\N	\N	27341	27341	27342
8975	7389	18	applied	\N	\N	\N	\N	27345	27345	27346
8975	7391	19	applied	\N	\N	\N	\N	27355	27355	27360
8975	7392	21	applied	\N	\N	\N	\N	27363	27363	27364
8975	7381	22	applied	\N	\N	\N	\N	27306	27306	27307
8975	7382	23	applied	\N	\N	\N	\N	27310	27310	27311
8856	7613	0	applied	\N	\N	\N	\N	28065	28065	28066
8856	7614	1	applied	\N	\N	\N	\N	28067	28067	28068
8859	7619	0	applied	\N	\N	\N	\N	28081	28081	28082
8859	7620	1	applied	\N	\N	\N	\N	28083	28083	28084
8866	7625	0	applied	\N	\N	\N	\N	28101	28101	28102
8866	7626	1	applied	\N	\N	\N	\N	28103	28103	28104
8871	7633	0	applied	\N	\N	\N	\N	28125	28125	28126
8871	7634	1	applied	\N	\N	\N	\N	28127	28127	28128
8880	7642	0	applied	\N	\N	\N	\N	28153	28153	28154
8880	7643	1	applied	\N	\N	\N	\N	28155	28155	28156
8880	7644	2	applied	\N	\N	\N	\N	28157	28157	28158
8880	7645	3	applied	\N	\N	\N	\N	28159	28159	28160
8883	7650	0	applied	\N	\N	\N	\N	28174	28174	28175
8883	7651	1	applied	\N	\N	\N	\N	28176	28176	28177
8883	7652	2	applied	\N	\N	\N	\N	28178	28178	28179
8883	7653	3	applied	\N	\N	\N	\N	28180	28180	28181
8887	7666	0	applied	\N	\N	\N	\N	28213	28213	28214
8887	7667	1	applied	\N	\N	\N	\N	28215	28215	28216
8889	7668	0	applied	\N	\N	\N	\N	28219	28219	28220
8889	7669	1	applied	\N	\N	\N	\N	28221	28221	28222
8892	7668	0	applied	\N	\N	\N	\N	28219	28219	28220
8892	7669	1	applied	\N	\N	\N	\N	28221	28221	28222
8896	7674	0	applied	\N	\N	\N	\N	28240	28240	28241
8896	7675	1	applied	\N	\N	\N	\N	28242	28242	28243
8901	7678	0	applied	\N	\N	\N	\N	28253	28253	28254
8901	7679	1	applied	\N	\N	\N	\N	28255	28255	28256
8901	7680	2	applied	\N	\N	1000000000	\N	28257	28257	28258
8904	7678	0	applied	\N	\N	\N	\N	28253	28253	28254
8904	7679	1	applied	\N	\N	\N	\N	28255	28255	28256
8913	7699	0	applied	\N	\N	\N	\N	28310	28310	28311
8913	7700	1	applied	\N	\N	\N	\N	28312	28312	28313
8918	7708	0	applied	\N	\N	\N	\N	28336	28336	28337
8918	7709	1	applied	\N	\N	\N	\N	28338	28338	28339
8920	7710	0	applied	\N	\N	\N	\N	28344	28344	28345
8920	7711	1	applied	\N	\N	\N	\N	28346	28346	28347
8930	7727	0	failed	Receiver_not_present	\N	\N	\N	28394	28394	\N
8930	7728	1	applied	\N	\N	\N	\N	28395	28395	28396
8930	7729	2	applied	\N	\N	\N	\N	28397	28397	28398
8934	7736	0	applied	\N	\N	\N	\N	28416	28416	28417
8934	7737	1	applied	\N	\N	\N	\N	28418	28418	28419
8934	7738	2	applied	\N	\N	\N	\N	28420	28420	28421
8934	7739	3	applied	\N	\N	\N	\N	28422	28422	28423
8941	7744	0	applied	\N	\N	\N	\N	28437	28437	28438
8941	7745	1	applied	\N	\N	\N	\N	28440	28440	28441
8941	7746	2	applied	\N	\N	\N	\N	28442	28442	28443
8941	7748	3	applied	\N	\N	\N	\N	28449	28449	28450
8941	7749	4	applied	\N	\N	\N	\N	28451	28451	28452
8941	7747	5	applied	\N	\N	\N	\N	28444	28444	28445
8941	7750	6	applied	\N	\N	\N	\N	28453	28453	28454
8941	7751	7	applied	\N	\N	\N	\N	28455	28455	28456
8941	7752	8	applied	\N	\N	1000000000	\N	28457	28457	28458
8941	7753	9	applied	\N	\N	1000000000	\N	28459	28459	28460
8946	7759	0	applied	\N	\N	\N	\N	28480	28480	28481
8946	7760	1	applied	\N	\N	\N	\N	28482	28482	28483
8948	7761	0	applied	\N	\N	\N	\N	28486	28486	28487
8948	7759	1	applied	\N	\N	\N	\N	28480	28480	28481
8948	7762	2	applied	\N	\N	\N	\N	28488	28488	28489
8948	7760	3	applied	\N	\N	\N	\N	28482	28482	28483
8948	7763	4	applied	\N	\N	\N	\N	28490	28490	28491
8951	7766	0	failed	Receiver_not_present	\N	\N	\N	28500	28500	\N
8951	7767	1	applied	\N	\N	\N	\N	28501	28501	28502
8951	7768	2	applied	\N	\N	\N	\N	28503	28503	28504
8954	7771	0	applied	\N	\N	\N	\N	28513	28513	28514
8954	7772	1	applied	\N	\N	\N	\N	28515	28515	28516
8954	7773	2	applied	\N	\N	\N	\N	28517	28517	28518
8954	7774	3	applied	\N	\N	\N	\N	28519	28519	28520
8956	7775	0	applied	\N	\N	\N	\N	28525	28525	28526
8956	7776	1	applied	\N	\N	\N	\N	28527	28527	28528
8956	7777	2	applied	\N	\N	\N	\N	28529	28529	28530
8956	7778	3	applied	\N	\N	\N	\N	28531	28531	28532
8961	7784	0	applied	\N	\N	\N	\N	28552	28552	28553
8961	7785	1	applied	\N	\N	\N	\N	28554	28554	28555
8963	7786	0	applied	\N	\N	\N	\N	28557	28557	28558
8963	7787	1	applied	\N	\N	\N	\N	28559	28559	28560
8966	7783	0	applied	\N	\N	\N	\N	28577	28577	28578
8969	7798	0	applied	\N	\N	\N	\N	28593	28593	28594
8969	7799	1	applied	\N	\N	\N	\N	28595	28595	28596
8969	7800	2	applied	\N	\N	\N	\N	28597	28597	28598
8969	7801	3	applied	\N	\N	\N	\N	28599	28599	28600
8969	7802	4	applied	\N	\N	1000000000	\N	28601	28601	28602
8971	7803	0	applied	\N	\N	\N	\N	28606	28606	28607
8971	7804	1	applied	\N	\N	\N	\N	28608	28608	28609
8972	7805	0	applied	\N	\N	\N	\N	28611	28611	28612
8972	7806	1	applied	\N	\N	\N	\N	28613	28613	28614
8972	7807	2	applied	\N	\N	\N	\N	28615	28615	28616
8972	7808	3	applied	\N	\N	\N	\N	28617	28617	28618
8972	7809	4	applied	\N	\N	\N	\N	28619	28619	28620
8972	7810	5	applied	\N	\N	\N	\N	28621	28621	28622
8977	7813	0	applied	\N	\N	\N	\N	28637	28637	28638
8977	7814	1	applied	\N	\N	\N	\N	28639	28639	28640
8979	7817	0	applied	\N	\N	\N	\N	28651	28651	28652
8979	7818	1	applied	\N	\N	\N	\N	28653	28653	28654
8986	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8986	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8986	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8986	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8986	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8986	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8989	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8989	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8989	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8989	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8989	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8989	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8991	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8991	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8991	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8991	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8991	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8991	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8992	7828	0	applied	\N	\N	\N	\N	28698	28698	28699
8992	7829	1	applied	\N	\N	\N	\N	28700	28700	28701
8994	7830	0	applied	\N	\N	\N	\N	28706	28706	28707
8994	7831	1	applied	\N	\N	\N	\N	28708	28708	28709
8999	7843	0	applied	\N	\N	\N	\N	28739	28739	28740
8999	7844	1	applied	\N	\N	\N	\N	28741	28741	28742
8999	7845	2	applied	\N	\N	\N	\N	28743	28743	28744
8999	7846	3	applied	\N	\N	\N	\N	28745	28745	28746
9002	7847	0	applied	\N	\N	\N	\N	28749	28749	28750
8958	7606	38	applied	\N	\N	\N	\N	28037	28037	28038
8958	7608	39	applied	\N	\N	\N	\N	28044	28044	28045
8958	7610	40	applied	\N	\N	\N	\N	28050	28050	28051
8958	7611	41	applied	\N	\N	\N	\N	28055	28055	28056
8958	7569	42	applied	\N	\N	\N	\N	27926	27926	27927
8958	7570	43	applied	\N	\N	\N	\N	27930	27930	27931
8958	7573	44	applied	\N	\N	\N	\N	27937	27937	27938
8958	7575	45	applied	\N	\N	\N	\N	27942	27942	27943
8958	7578	46	applied	\N	\N	\N	\N	27948	27948	27949
8958	7580	47	applied	\N	\N	\N	\N	27952	27952	27953
8958	7583	48	applied	\N	\N	\N	\N	27967	27967	27968
8958	7585	49	applied	\N	\N	\N	\N	27973	27973	27974
8958	7588	50	applied	\N	\N	\N	\N	27979	27979	27980
8958	7590	51	applied	\N	\N	\N	\N	27985	27985	27986
8958	7594	52	applied	\N	\N	\N	\N	27996	27996	27997
8958	7597	53	applied	\N	\N	\N	\N	28005	28005	28006
8958	7598	54	applied	\N	\N	\N	\N	28007	28007	28008
8958	7602	55	applied	\N	\N	\N	\N	28024	28024	28025
8958	7603	56	applied	\N	\N	\N	\N	28026	28026	28027
8958	7604	57	applied	\N	\N	\N	\N	28028	28028	28029
8958	7605	58	applied	\N	\N	\N	\N	28035	28035	28036
8958	7607	59	applied	\N	\N	\N	\N	28042	28042	28043
8958	7609	60	applied	\N	\N	\N	\N	28048	28048	28049
8958	7612	61	applied	\N	\N	\N	\N	28057	28057	28058
8958	7613	62	applied	\N	\N	\N	\N	28065	28065	28066
8958	7616	63	applied	\N	\N	\N	\N	28073	28073	28074
8958	7617	64	applied	\N	\N	\N	\N	28075	28075	28076
8958	7620	65	applied	\N	\N	\N	\N	28083	28083	28084
8958	7621	66	applied	\N	\N	\N	\N	28087	28087	28088
8958	7623	68	applied	\N	\N	\N	\N	28092	28092	28093
8958	7625	69	applied	\N	\N	\N	\N	28101	28101	28102
8958	7627	70	applied	\N	\N	\N	\N	28109	28109	28110
8958	7631	71	applied	\N	\N	\N	\N	28120	28120	28121
8958	7589	72	applied	\N	\N	\N	\N	27981	27981	27982
8958	7632	73	applied	\N	\N	\N	\N	28122	28122	28123
8958	7633	74	applied	\N	\N	\N	\N	28125	28125	28126
8958	7635	75	applied	\N	\N	\N	\N	28131	28131	28132
8958	7637	76	applied	\N	\N	\N	\N	28138	28138	28139
8958	7638	77	applied	\N	\N	\N	\N	28140	28140	28141
8958	7639	78	applied	\N	\N	\N	\N	28142	28142	28143
8958	7643	79	applied	\N	\N	\N	\N	28155	28155	28156
8958	7644	80	applied	\N	\N	\N	\N	28157	28157	28158
8958	7649	81	applied	\N	\N	\N	\N	28171	28171	28172
8958	7651	82	applied	\N	\N	\N	\N	28176	28176	28177
8958	7652	83	applied	\N	\N	\N	\N	28178	28178	28179
8958	7654	84	applied	\N	\N	\N	\N	28184	28184	28185
8958	7657	85	applied	\N	\N	\N	\N	28191	28191	28192
8958	7658	86	applied	\N	\N	\N	\N	28195	28195	28196
8958	7659	87	applied	\N	\N	\N	\N	28197	28197	28198
8958	7661	88	applied	\N	\N	\N	\N	28201	28201	28202
8958	7662	89	applied	\N	\N	\N	\N	28203	28203	28204
8958	7666	90	applied	\N	\N	\N	\N	28213	28213	28214
8958	7669	91	applied	\N	\N	\N	\N	28221	28221	28222
8958	7671	92	applied	\N	\N	\N	\N	28231	28231	28232
8958	7672	93	applied	\N	\N	\N	\N	28233	28233	28234
8958	7674	94	applied	\N	\N	\N	\N	28240	28240	28241
8958	7675	95	applied	\N	\N	\N	\N	28242	28242	28243
8958	7678	96	applied	\N	\N	\N	\N	28253	28253	28254
8958	7682	97	applied	\N	\N	\N	\N	28263	28263	28264
8958	7683	98	applied	\N	\N	\N	\N	28265	28265	28266
8958	7687	99	applied	\N	\N	\N	\N	28274	28274	28275
8958	7688	100	applied	\N	\N	\N	\N	28276	28276	28277
8958	7689	101	applied	\N	\N	\N	\N	28280	28280	28281
8958	7691	102	applied	\N	\N	\N	\N	28288	28288	28289
8958	7693	103	applied	\N	\N	\N	\N	28292	28292	28293
8958	7694	104	applied	\N	\N	\N	\N	28294	28294	28295
8958	7697	105	applied	\N	\N	\N	\N	28302	28302	28303
8958	7700	106	applied	\N	\N	\N	\N	28312	28312	28313
8958	7702	107	applied	\N	\N	\N	\N	28317	28317	28318
8958	7703	108	applied	\N	\N	\N	\N	28322	28322	28323
8958	7704	109	applied	\N	\N	\N	\N	28324	28324	28325
8958	7709	110	applied	\N	\N	\N	\N	28338	28338	28339
8958	7710	111	applied	\N	\N	\N	\N	28344	28344	28345
8958	7712	112	applied	\N	\N	\N	\N	28350	28350	28351
8958	7715	113	applied	\N	\N	\N	\N	28356	28356	28357
8958	7717	114	applied	\N	\N	\N	\N	28362	28362	28363
8958	7719	115	applied	\N	\N	\N	\N	28368	28368	28369
8958	7722	116	applied	\N	\N	\N	\N	28376	28376	28377
8958	7724	117	applied	\N	\N	\N	\N	28382	28382	28383
8958	7725	118	applied	\N	\N	\N	\N	28389	28389	28390
8958	7728	119	applied	\N	\N	\N	\N	28395	28395	28396
8958	7732	120	applied	\N	\N	\N	\N	28405	28405	28406
8958	7733	121	applied	\N	\N	\N	\N	28407	28407	28408
8958	7735	122	applied	\N	\N	\N	\N	28412	28412	28413
8958	7738	123	applied	\N	\N	\N	\N	28420	28420	28421
8958	7739	124	applied	\N	\N	\N	\N	28422	28422	28423
8958	7740	125	applied	\N	\N	\N	\N	28425	28425	28426
8960	7779	0	applied	\N	\N	\N	\N	28539	28539	28540
8960	7780	1	applied	\N	\N	\N	\N	28541	28541	28542
8960	7781	2	applied	\N	\N	\N	\N	28543	28543	28544
8960	7782	3	applied	\N	\N	\N	\N	28545	28545	28546
8960	7783	4	applied	\N	\N	\N	\N	28547	28547	28548
8974	7811	0	applied	\N	\N	\N	\N	28625	28625	28626
8974	7812	1	applied	\N	\N	\N	\N	28627	28627	28628
8976	7813	0	applied	\N	\N	\N	\N	28637	28637	28638
8976	7814	1	applied	\N	\N	\N	\N	28639	28639	28640
8978	7815	0	applied	\N	\N	\N	\N	28645	28645	28646
8978	7816	1	applied	\N	\N	\N	\N	28647	28647	28648
8981	7817	0	applied	\N	\N	\N	\N	28651	28651	28652
8981	7818	1	applied	\N	\N	\N	\N	28653	28653	28654
8983	7820	0	applied	\N	\N	\N	\N	28660	28660	28661
8985	7821	0	applied	\N	\N	\N	\N	28665	28665	28666
8988	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8988	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8988	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8988	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8988	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8988	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8990	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8990	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8990	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8990	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8990	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8990	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8995	7832	0	applied	\N	\N	\N	\N	28710	28710	28711
8995	7833	1	applied	\N	\N	\N	\N	28712	28712	28713
8995	7834	2	applied	\N	\N	\N	\N	28714	28714	28715
8995	7835	3	applied	\N	\N	\N	\N	28716	28716	28717
8995	7836	4	applied	\N	\N	\N	\N	28718	28718	28719
8998	7837	0	applied	\N	\N	\N	\N	28724	28724	28725
8975	7421	24	applied	\N	\N	\N	\N	27444	27444	27445
8975	7422	25	applied	\N	\N	1000000000	\N	27446	27446	27447
8975	7423	26	applied	\N	\N	\N	\N	27448	27448	27449
8975	7425	27	applied	\N	\N	\N	\N	27456	27456	27457
8975	7426	28	applied	\N	\N	\N	\N	27475	27475	27476
8975	7428	29	applied	\N	\N	\N	\N	27483	27483	27484
8975	7429	30	applied	\N	\N	\N	\N	27485	27485	27486
8975	7432	31	applied	\N	\N	\N	\N	27493	27493	27494
8975	7434	32	applied	\N	\N	\N	\N	27498	27498	27499
8975	7435	33	applied	\N	\N	\N	\N	27500	27500	27501
8975	7439	34	applied	\N	\N	\N	\N	27514	27514	27515
8975	7440	35	applied	\N	\N	\N	\N	27516	27516	27517
8975	7441	36	applied	\N	\N	\N	\N	27518	27518	27519
8975	7446	37	applied	\N	\N	\N	\N	27532	27532	27533
8975	7447	38	applied	\N	\N	\N	\N	27535	27535	27536
8975	7450	39	applied	\N	\N	\N	\N	27548	27548	27549
8975	7452	40	applied	\N	\N	\N	\N	27554	27554	27555
8975	7453	41	applied	\N	\N	\N	\N	27561	27561	27562
8975	7455	42	applied	\N	\N	\N	\N	27568	27568	27569
8975	7457	43	applied	\N	\N	\N	\N	27572	27572	27573
8975	7458	44	applied	\N	\N	\N	\N	27574	27574	27575
8975	7461	45	applied	\N	\N	\N	\N	27582	27582	27583
8975	7463	46	applied	\N	\N	\N	\N	27588	27588	27589
8975	7467	47	applied	\N	\N	\N	\N	27598	27598	27599
8975	7468	48	applied	\N	\N	\N	\N	27600	27600	27601
8975	7469	49	applied	\N	\N	\N	\N	27604	27604	27605
8975	7470	50	applied	\N	\N	\N	\N	27606	27606	27607
8975	7474	51	applied	\N	\N	\N	\N	27616	27616	27617
8975	7476	52	applied	\N	\N	\N	\N	27620	27620	27621
8975	7478	53	applied	\N	\N	\N	\N	27628	27628	27629
8975	7480	54	applied	\N	\N	\N	\N	27638	27638	27639
8975	7481	55	applied	\N	\N	\N	\N	27642	27642	27643
8975	7483	56	applied	\N	\N	\N	\N	27646	27646	27647
8975	7485	57	applied	\N	\N	\N	\N	27652	27652	27653
8975	7488	58	applied	\N	\N	\N	\N	27662	27662	27663
8975	7489	59	applied	\N	\N	\N	\N	27669	27669	27670
8975	7492	60	applied	\N	\N	\N	\N	27677	27677	27678
8975	7493	61	applied	\N	\N	\N	\N	27681	27681	27682
8975	7495	62	applied	\N	\N	\N	\N	27687	27687	27688
8980	7817	0	applied	\N	\N	\N	\N	28651	28651	28652
8980	7818	1	applied	\N	\N	\N	\N	28653	28653	28654
8982	7819	0	applied	\N	\N	\N	\N	28658	28658	28659
8982	7820	1	applied	\N	\N	\N	\N	28660	28660	28661
8987	7822	0	applied	\N	\N	\N	\N	28667	28667	28668
8987	7823	2	applied	\N	\N	\N	\N	28671	28671	28672
8987	7824	3	applied	\N	\N	\N	\N	28673	28673	28674
8987	7825	4	applied	\N	\N	\N	\N	28675	28675	28676
8987	7826	5	applied	\N	\N	\N	\N	28677	28677	28678
8987	7827	6	applied	\N	\N	\N	\N	28679	28679	28679
8997	7837	0	applied	\N	\N	\N	\N	28724	28724	28725
8997	7838	1	applied	\N	\N	\N	\N	28726	28726	28727
8997	7839	2	applied	\N	\N	\N	\N	28728	28728	28729
8997	7840	3	applied	\N	\N	\N	\N	28730	28730	28731
8997	7841	4	applied	\N	\N	\N	\N	28732	28732	28733
8997	7842	5	applied	\N	\N	\N	\N	28734	28734	28735
9000	7847	0	applied	\N	\N	\N	\N	28749	28749	28750
9000	7848	1	applied	\N	\N	\N	\N	28751	28751	28752
9003	7847	0	applied	\N	\N	\N	\N	28749	28749	28750
9004	7849	0	applied	\N	\N	\N	\N	28759	28759	28760
9004	7850	1	applied	\N	\N	\N	\N	28761	28761	28762
9009	7853	0	applied	\N	\N	\N	\N	28771	28771	28772
9009	7854	1	applied	\N	\N	\N	\N	28773	28773	28774
9009	7855	2	applied	\N	\N	\N	\N	28775	28775	28776
9009	7856	3	applied	\N	\N	\N	\N	28777	28777	28778
9014	7863	0	applied	\N	\N	\N	\N	28800	28800	28801
9014	7864	1	applied	\N	\N	\N	\N	28802	28802	28803
9016	7865	0	applied	\N	\N	\N	\N	28806	28806	28807
9016	7866	1	applied	\N	\N	\N	\N	28808	28808	28809
9020	7876	0	applied	\N	\N	\N	\N	28833	28833	28834
9020	7877	1	applied	\N	\N	\N	\N	28835	28835	28836
9029	7888	0	applied	\N	\N	\N	\N	28868	28868	28869
9029	7889	1	applied	\N	\N	\N	\N	28870	28870	28871
9031	7890	0	applied	\N	\N	\N	\N	28874	28874	28875
9031	7891	1	applied	\N	\N	\N	\N	28876	28876	28877
9031	7892	2	applied	\N	\N	\N	\N	28878	28878	28879
9041	7903	0	applied	\N	\N	\N	\N	28912	28912	28913
9041	7904	1	applied	\N	\N	\N	\N	28914	28914	28915
9051	7927	0	applied	\N	\N	\N	\N	28979	28979	28980
9051	7928	1	applied	\N	\N	\N	\N	28981	28981	28982
9055	7931	0	applied	\N	\N	\N	\N	28995	28995	28996
9055	7932	1	applied	\N	\N	\N	\N	28997	28997	28998
9055	7933	2	applied	\N	\N	\N	\N	28999	28999	29000
9055	7934	3	applied	\N	\N	\N	\N	29001	29001	29002
9055	7935	4	applied	\N	\N	\N	\N	29003	29003	28358
9057	7931	0	applied	\N	\N	\N	\N	28995	28995	28996
9057	7932	1	applied	\N	\N	\N	\N	28997	28997	28998
9057	7933	2	applied	\N	\N	\N	\N	28999	28999	29000
9057	7934	3	applied	\N	\N	\N	\N	29001	29001	29002
9057	7935	4	applied	\N	\N	\N	\N	29003	29003	28358
9062	7940	0	applied	\N	\N	\N	\N	29021	29021	29022
9062	7941	1	applied	\N	\N	\N	\N	29023	29023	29024
9062	7942	2	applied	\N	\N	\N	\N	29025	29025	29026
9062	7943	3	applied	\N	\N	\N	\N	29027	29027	29028
9064	7944	0	applied	\N	\N	1000000000	\N	29031	29031	29032
9064	7945	1	applied	\N	\N	\N	\N	29033	29033	29034
9064	7946	2	applied	\N	\N	\N	\N	29035	29035	29036
9067	7949	0	applied	\N	\N	1000000000	\N	29045	29045	29046
9067	7950	1	applied	\N	\N	\N	\N	29047	29047	29048
9067	7951	2	applied	\N	\N	\N	\N	29049	29049	29050
9067	7952	3	applied	\N	\N	\N	\N	29051	29051	29052
9067	7953	4	applied	\N	\N	\N	\N	29053	29053	29054
9077	7980	0	applied	\N	\N	\N	\N	29118	29118	29119
9077	7981	1	applied	\N	\N	\N	\N	29120	29120	29121
9077	7982	2	applied	\N	\N	\N	\N	29122	29122	29123
9077	7983	4	applied	\N	\N	\N	\N	29125	29125	29126
9077	7984	5	applied	\N	\N	\N	\N	29127	29127	29128
9077	7985	6	applied	\N	\N	\N	\N	29129	29129	29130
9077	7986	7	applied	\N	\N	\N	\N	29131	29131	29132
9079	7987	0	applied	\N	\N	\N	\N	29137	29137	29138
9082	7989	0	applied	\N	\N	\N	\N	29143	29143	29144
9082	7990	1	applied	\N	\N	1000000000	\N	29145	29145	29146
9082	7988	2	applied	\N	\N	\N	\N	29139	29139	29140
9083	7989	0	applied	\N	\N	\N	\N	29143	29143	29144
9083	7990	1	applied	\N	\N	1000000000	\N	29145	29145	29146
9085	7992	0	applied	\N	\N	\N	\N	29154	29154	29155
9085	7993	1	applied	\N	\N	1000000000	\N	29156	29156	29157
9091	7999	0	applied	\N	\N	\N	\N	29176	29176	29175
9091	8000	1	applied	\N	\N	\N	\N	5821	5821	29177
9091	8001	2	applied	\N	\N	\N	\N	29178	29178	29179
8998	7838	1	applied	\N	\N	\N	\N	28726	28726	28727
8998	7839	2	applied	\N	\N	\N	\N	28728	28728	28729
8998	7840	3	applied	\N	\N	\N	\N	28730	28730	28731
8998	7841	4	applied	\N	\N	\N	\N	28732	28732	28733
8998	7842	5	applied	\N	\N	\N	\N	28734	28734	28735
9005	7849	0	applied	\N	\N	\N	\N	28759	28759	28760
9005	7850	1	applied	\N	\N	\N	\N	28761	28761	28762
9010	7853	0	applied	\N	\N	\N	\N	28771	28771	28772
9010	7854	1	applied	\N	\N	\N	\N	28773	28773	28774
9010	7855	2	applied	\N	\N	\N	\N	28775	28775	28776
9010	7856	3	applied	\N	\N	\N	\N	28777	28777	28778
9017	7867	0	applied	\N	\N	\N	\N	28812	28812	28813
9017	7868	1	applied	\N	\N	\N	\N	28814	28814	28815
9017	7869	2	applied	\N	\N	\N	\N	28816	28816	28817
9017	7870	3	applied	\N	\N	\N	\N	28818	28818	28819
9022	7878	0	applied	\N	\N	\N	\N	28842	28842	28843
9022	7879	1	applied	\N	\N	\N	\N	28844	28844	28845
9025	7884	0	applied	\N	\N	\N	\N	28857	28857	28858
9025	7885	1	applied	\N	\N	\N	\N	28859	28859	28860
9027	7886	0	applied	\N	\N	\N	\N	28864	28864	28865
9027	7887	1	applied	\N	\N	\N	\N	28866	28866	28867
9030	7888	0	applied	\N	\N	\N	\N	28868	28868	28869
9030	7889	1	applied	\N	\N	\N	\N	28870	28870	28871
9032	7890	0	applied	\N	\N	\N	\N	28874	28874	28875
9032	7891	1	applied	\N	\N	\N	\N	28876	28876	28877
9032	7892	2	applied	\N	\N	\N	\N	28878	28878	28879
9034	7893	0	applied	\N	\N	\N	\N	28885	28885	28886
9034	7894	1	applied	\N	\N	\N	\N	28887	28887	28888
9034	7895	2	applied	\N	\N	\N	\N	28889	28889	28890
9034	7896	3	applied	\N	\N	\N	\N	28891	28891	28892
9039	7901	0	applied	\N	\N	\N	\N	28908	28908	28909
9039	7902	1	applied	\N	\N	\N	\N	28910	28910	28911
9044	7905	0	applied	\N	\N	\N	\N	28918	28918	28919
9044	7906	1	applied	\N	\N	\N	\N	28920	28920	28921
9044	7907	2	applied	\N	\N	\N	\N	28922	28922	28923
9044	7908	3	applied	\N	\N	\N	\N	28924	28924	28925
9044	7909	4	applied	\N	\N	1000000000	\N	28926	28926	28927
9046	7910	0	applied	\N	\N	\N	\N	28936	28936	28937
9046	7911	1	applied	\N	\N	\N	\N	28938	28938	28939
9046	7912	2	applied	\N	\N	\N	\N	28940	28940	28941
9046	7913	3	applied	\N	\N	\N	\N	28942	28942	28943
9059	7938	0	applied	\N	\N	\N	\N	29013	29013	29014
9059	7939	1	applied	\N	\N	\N	\N	29015	29015	29016
9069	7954	0	applied	\N	\N	\N	\N	29056	29056	29057
9069	7955	1	applied	\N	\N	\N	\N	29058	29058	29059
9070	7956	0	applied	\N	\N	\N	\N	29060	29060	29061
9070	7957	1	applied	\N	\N	\N	\N	29062	29062	29063
9070	7958	2	applied	\N	\N	\N	\N	29064	29064	29065
9070	7959	3	applied	\N	\N	\N	\N	29066	29066	29067
9070	7960	4	applied	\N	\N	\N	\N	29068	29068	29069
9070	7961	5	applied	\N	\N	\N	\N	29070	29070	29071
9070	7962	6	applied	\N	\N	\N	\N	29072	29072	29073
9070	7963	7	applied	\N	\N	\N	\N	29074	29074	29075
9070	7964	8	applied	\N	\N	\N	\N	29076	29076	29077
9070	7965	9	applied	\N	\N	\N	\N	29078	29078	29079
9070	7966	10	applied	\N	\N	\N	\N	29080	29080	29081
9073	7974	0	applied	\N	\N	\N	\N	29100	29100	29101
9073	7975	1	applied	\N	\N	\N	\N	29102	29102	29103
9076	7980	0	applied	\N	\N	\N	\N	29118	29118	29119
9076	7981	1	applied	\N	\N	\N	\N	29120	29120	29121
9076	7982	2	applied	\N	\N	\N	\N	29122	29122	29123
9076	7983	4	applied	\N	\N	\N	\N	29125	29125	29126
9076	7984	5	applied	\N	\N	\N	\N	29127	29127	29128
9076	7985	6	applied	\N	\N	\N	\N	29129	29129	29130
9076	7986	7	applied	\N	\N	\N	\N	29131	29131	29132
9078	7987	0	applied	\N	\N	\N	\N	29137	29137	29138
9078	7988	1	applied	\N	\N	\N	\N	29139	29139	29140
9081	7989	0	applied	\N	\N	\N	\N	29143	29143	29144
9081	7990	1	applied	\N	\N	1000000000	\N	29145	29145	29146
9081	7988	2	applied	\N	\N	\N	\N	29139	29139	29140
9081	7991	3	applied	\N	\N	\N	\N	29147	29147	29148
9087	7994	0	applied	\N	\N	\N	\N	29163	29163	29164
9087	7995	1	applied	\N	\N	\N	\N	29165	29165	29166
9087	7996	2	applied	\N	\N	\N	\N	29167	29167	29168
9087	7997	3	applied	\N	\N	\N	\N	29169	29169	29170
9087	7998	4	applied	\N	\N	\N	\N	29171	29171	29172
9088	7999	0	applied	\N	\N	\N	\N	29174	29174	29175
9090	7999	0	applied	\N	\N	\N	\N	29176	29176	29175
9090	8000	1	applied	\N	\N	\N	\N	5821	5821	29177
9090	8001	2	applied	\N	\N	\N	\N	29178	29178	29179
9090	8002	3	applied	\N	\N	\N	\N	29180	29180	29181
9090	8003	4	applied	\N	\N	\N	\N	29182	29182	29183
9090	8004	5	applied	\N	\N	\N	\N	29184	29184	29185
9090	8005	6	applied	\N	\N	\N	\N	29186	29186	29187
9090	8006	7	applied	\N	\N	\N	\N	29188	29188	29189
9090	8007	8	applied	\N	\N	1000000000	\N	29190	29190	29191
9090	8008	9	applied	\N	\N	\N	\N	29192	29192	29156
9090	8009	10	applied	\N	\N	\N	\N	29193	29193	29194
9093	7999	0	applied	\N	\N	\N	\N	29174	29174	29175
9096	8010	0	applied	\N	\N	\N	\N	29202	29202	29203
9096	8011	1	applied	\N	\N	\N	\N	29204	29204	29205
9101	8017	0	applied	\N	\N	\N	\N	29220	29220	29221
9101	8018	1	applied	\N	\N	\N	\N	29222	29222	29223
9104	8017	0	applied	\N	\N	\N	\N	29220	29220	29221
9104	8018	1	applied	\N	\N	\N	\N	29222	29222	29223
9105	8019	0	applied	\N	\N	\N	\N	29229	29229	29230
9105	8020	1	applied	\N	\N	\N	\N	29231	29231	29232
9110	8023	0	applied	\N	\N	\N	\N	29241	29241	29242
9110	8024	1	applied	\N	\N	\N	\N	29243	29243	29244
9113	8027	0	applied	\N	\N	\N	\N	29254	29254	29255
9113	8028	1	applied	\N	\N	\N	\N	29256	29256	29257
9113	8029	2	applied	\N	\N	\N	\N	29258	29258	29259
9113	8030	3	applied	\N	\N	\N	\N	29260	29260	29261
9116	8035	0	applied	\N	\N	\N	\N	29275	29275	29276
9116	8036	1	applied	\N	\N	\N	\N	29277	29277	29278
9116	8037	2	applied	\N	\N	\N	\N	29279	29279	29280
9116	8038	3	applied	\N	\N	\N	\N	29281	29281	29282
9119	8035	0	applied	\N	\N	\N	\N	29275	29275	29276
9119	8036	1	applied	\N	\N	\N	\N	29277	29277	29278
9119	8037	2	applied	\N	\N	\N	\N	29279	29279	29280
9119	8038	3	applied	\N	\N	\N	\N	29281	29281	29282
9122	8039	0	applied	\N	\N	\N	\N	29290	29290	29291
9122	8040	1	applied	\N	\N	\N	\N	29292	29292	29293
9124	8041	0	applied	\N	\N	\N	\N	29298	29298	29299
9124	8042	1	applied	\N	\N	\N	\N	29300	29300	29301
9124	8043	2	applied	\N	\N	\N	\N	29302	29302	29303
9124	8044	3	applied	\N	\N	\N	\N	29304	29304	29305
9127	8045	0	applied	\N	\N	\N	\N	29309	29309	29310
9127	8046	1	applied	\N	\N	\N	\N	29311	29311	29312
9002	7848	1	applied	\N	\N	\N	\N	28751	28751	28752
9006	7851	0	applied	\N	\N	\N	\N	28765	28765	28766
9006	7852	1	applied	\N	\N	\N	\N	28767	28767	28768
9011	7853	0	applied	\N	\N	\N	\N	28771	28771	28772
9011	7854	1	applied	\N	\N	\N	\N	28773	28773	28774
9011	7855	2	applied	\N	\N	\N	\N	28775	28775	28776
9011	7856	3	applied	\N	\N	\N	\N	28777	28777	28778
9013	7859	0	applied	\N	\N	\N	\N	28790	28790	28791
9013	7860	1	applied	\N	\N	\N	\N	28792	28792	28793
9013	7861	2	applied	\N	\N	\N	\N	28794	28794	28795
9013	7862	3	applied	\N	\N	\N	\N	28796	28796	28797
9019	7876	0	applied	\N	\N	\N	\N	28833	28833	28834
9019	7877	1	applied	\N	\N	\N	\N	28835	28835	28836
9024	7880	0	applied	\N	\N	\N	\N	28846	28846	28847
9024	7881	1	applied	\N	\N	\N	\N	28848	28848	28849
9024	7882	2	applied	\N	\N	\N	\N	28850	28850	28851
9024	7883	3	applied	\N	\N	\N	\N	28852	28852	28853
9036	7897	0	applied	\N	\N	\N	\N	28893	28893	28894
9036	7898	1	applied	\N	\N	\N	\N	28895	28895	28896
9038	7899	0	applied	\N	\N	\N	\N	28901	28901	28902
9038	7900	2	applied	\N	\N	\N	\N	28904	28904	28905
9040	7903	0	applied	\N	\N	\N	\N	28912	28912	28913
9040	7904	1	applied	\N	\N	\N	\N	28914	28914	28915
9045	7727	0	failed	Receiver_not_present	\N	\N	\N	28394	28394	\N
9045	7756	1	applied	\N	\N	\N	\N	28470	28470	28471
9045	7761	2	applied	\N	\N	\N	\N	28486	28486	28487
9049	7914	0	applied	\N	\N	\N	\N	28948	28948	28949
9049	7915	1	applied	\N	\N	\N	\N	28950	28950	28951
9049	7916	2	applied	\N	\N	\N	\N	28952	28952	28953
9049	7917	3	applied	\N	\N	\N	\N	28954	28954	28955
9049	7918	4	applied	\N	\N	\N	\N	28956	28956	28957
9049	7919	5	applied	\N	\N	\N	\N	28958	28958	28959
9049	7920	6	applied	\N	\N	\N	\N	28960	28960	28961
9049	7921	7	applied	\N	\N	\N	\N	28962	28962	28963
9049	7922	8	applied	\N	\N	\N	\N	28964	28964	28965
9049	7923	9	applied	\N	\N	1000000000	\N	28966	28966	28967
9049	7924	10	applied	\N	\N	\N	\N	28968	28968	28969
9049	7925	11	applied	\N	\N	\N	\N	28970	28970	28971
9049	7926	12	applied	\N	\N	\N	\N	28972	28972	28973
9053	7929	0	applied	\N	\N	\N	\N	28987	28987	28988
9053	7930	1	applied	\N	\N	\N	\N	28989	28989	28990
9056	7931	0	applied	\N	\N	\N	\N	28995	28995	28996
9056	7932	1	applied	\N	\N	\N	\N	28997	28997	28998
9056	7933	2	applied	\N	\N	\N	\N	28999	28999	29000
9056	7934	3	applied	\N	\N	\N	\N	29001	29001	29002
9056	7935	4	applied	\N	\N	\N	\N	29003	29003	28358
9060	7938	0	applied	\N	\N	\N	\N	29013	29013	29014
9060	7939	1	applied	\N	\N	\N	\N	29015	29015	29016
9065	7947	0	applied	\N	\N	\N	\N	29039	29039	29040
9065	7948	1	applied	\N	\N	\N	\N	29041	29041	29042
9071	7967	0	applied	\N	\N	\N	\N	29084	29084	29085
9071	7968	1	applied	\N	\N	\N	\N	29086	29086	29087
9074	7976	0	applied	\N	\N	\N	\N	29106	29106	29107
9074	7977	1	applied	\N	\N	\N	\N	29108	29108	29109
9086	7969	0	applied	\N	\N	\N	\N	29090	29090	1435
9086	7956	1	applied	\N	\N	\N	\N	29060	29060	29061
9086	7980	2	applied	\N	\N	\N	\N	29118	29118	29119
9086	7901	3	applied	\N	\N	\N	\N	28908	28908	28909
9086	7903	4	applied	\N	\N	\N	\N	28912	28912	28913
9086	7949	5	applied	\N	\N	1000000000	\N	29045	29045	29046
9086	7915	6	applied	\N	\N	\N	\N	28950	28950	28951
9086	7990	7	applied	\N	\N	1000000000	\N	29145	29145	29146
9086	7983	8	applied	\N	\N	\N	\N	29125	29125	29126
9086	7984	9	applied	\N	\N	\N	\N	29127	29127	29128
9086	7902	10	applied	\N	\N	\N	\N	28910	28910	28911
9086	7904	11	applied	\N	\N	\N	\N	28914	28914	28915
9086	7905	12	applied	\N	\N	\N	\N	28918	28918	28919
9086	7906	13	applied	\N	\N	\N	\N	28920	28920	28921
9086	7910	14	applied	\N	\N	\N	\N	28936	28936	28937
9086	7911	15	applied	\N	\N	\N	\N	28938	28938	28939
9086	7907	16	applied	\N	\N	\N	\N	28922	28922	28923
9086	7908	17	applied	\N	\N	\N	\N	28924	28924	28925
9086	7912	18	applied	\N	\N	\N	\N	28940	28940	28941
9086	7913	19	applied	\N	\N	\N	\N	28942	28942	28943
9086	7914	20	applied	\N	\N	\N	\N	28948	28948	28949
9086	7916	21	applied	\N	\N	\N	\N	28952	28952	28953
9086	7917	22	applied	\N	\N	\N	\N	28954	28954	28955
9086	7918	23	applied	\N	\N	\N	\N	28956	28956	28957
9086	7919	24	applied	\N	\N	\N	\N	28958	28958	28959
9086	7928	25	applied	\N	\N	\N	\N	28981	28981	28982
9086	7930	26	applied	\N	\N	\N	\N	28989	28989	28990
9086	7931	27	applied	\N	\N	\N	\N	28995	28995	28996
9086	7934	28	applied	\N	\N	\N	\N	29001	29001	29002
9086	7936	29	applied	\N	\N	\N	\N	29009	29009	29010
9086	7939	30	applied	\N	\N	\N	\N	29015	29015	29016
9086	7940	31	applied	\N	\N	\N	\N	29021	29021	29022
9086	7941	32	applied	\N	\N	\N	\N	29023	29023	29024
9086	7946	33	applied	\N	\N	\N	\N	29035	29035	29036
9086	7947	34	applied	\N	\N	\N	\N	29039	29039	29040
9089	7999	0	applied	\N	\N	\N	\N	29176	29176	29175
9089	8000	1	applied	\N	\N	\N	\N	5821	5821	29177
9089	8001	2	applied	\N	\N	\N	\N	29178	29178	29179
9089	8002	3	applied	\N	\N	\N	\N	29180	29180	29181
9089	8003	4	applied	\N	\N	\N	\N	29182	29182	29183
9089	8004	5	applied	\N	\N	\N	\N	29184	29184	29185
9089	8005	6	applied	\N	\N	\N	\N	29186	29186	29187
9089	8006	7	applied	\N	\N	\N	\N	29188	29188	29189
9089	8007	8	applied	\N	\N	1000000000	\N	29190	29190	29191
9089	8008	9	applied	\N	\N	\N	\N	29192	29192	29156
9089	8009	10	applied	\N	\N	\N	\N	29193	29193	29194
9092	7999	0	applied	\N	\N	\N	\N	29176	29176	29175
9092	8000	1	applied	\N	\N	\N	\N	5821	5821	29177
9092	8001	2	applied	\N	\N	\N	\N	29178	29178	29179
9092	8002	3	applied	\N	\N	\N	\N	29180	29180	29181
9092	8003	4	applied	\N	\N	\N	\N	29182	29182	29183
9092	8004	5	applied	\N	\N	\N	\N	29184	29184	29185
9092	8005	6	applied	\N	\N	\N	\N	29186	29186	29187
9092	8006	7	applied	\N	\N	\N	\N	29188	29188	29189
9092	8007	8	applied	\N	\N	1000000000	\N	29190	29190	29191
9092	8008	9	applied	\N	\N	\N	\N	29192	29192	29156
9092	8009	10	applied	\N	\N	\N	\N	29193	29193	29194
9095	7999	0	applied	\N	\N	\N	\N	29174	29174	29175
9098	8010	0	applied	\N	\N	\N	\N	29202	29202	29203
9098	8011	1	applied	\N	\N	\N	\N	29204	29204	29205
9102	8017	0	applied	\N	\N	\N	\N	29220	29220	29221
9102	8018	1	applied	\N	\N	\N	\N	29222	29222	29223
9107	8021	0	applied	\N	\N	\N	\N	29235	29235	29236
9107	8022	1	applied	\N	\N	\N	\N	29237	29237	29238
9109	8023	0	applied	\N	\N	\N	\N	29241	29241	29242
9023	7883	3	applied	\N	\N	\N	\N	28852	28852	28853
9026	7884	0	applied	\N	\N	\N	\N	28857	28857	28858
9026	7885	1	applied	\N	\N	\N	\N	28859	28859	28860
9028	7886	0	applied	\N	\N	\N	\N	28864	28864	28865
9028	7887	1	applied	\N	\N	\N	\N	28866	28866	28867
9033	7890	0	applied	\N	\N	\N	\N	28874	28874	28875
9033	7891	1	applied	\N	\N	\N	\N	28876	28876	28877
9033	7892	2	applied	\N	\N	\N	\N	28878	28878	28879
9035	7897	0	applied	\N	\N	\N	\N	28893	28893	28894
9035	7898	1	applied	\N	\N	\N	\N	28895	28895	28896
9037	7899	0	applied	\N	\N	\N	\N	28901	28901	28902
9037	7900	2	applied	\N	\N	\N	\N	28904	28904	28905
9042	7905	0	applied	\N	\N	\N	\N	28918	28918	28919
9042	7906	1	applied	\N	\N	\N	\N	28920	28920	28921
9042	7907	2	applied	\N	\N	\N	\N	28922	28922	28923
9042	7908	3	applied	\N	\N	\N	\N	28924	28924	28925
9042	7909	4	applied	\N	\N	1000000000	\N	28926	28926	28927
9047	7910	0	applied	\N	\N	\N	\N	28936	28936	28937
9047	7911	1	applied	\N	\N	\N	\N	28938	28938	28939
9047	7912	2	applied	\N	\N	\N	\N	28940	28940	28941
9047	7913	3	applied	\N	\N	\N	\N	28942	28942	28943
9048	7914	0	applied	\N	\N	\N	\N	28948	28948	28949
9048	7915	1	applied	\N	\N	\N	\N	28950	28950	28951
9048	7916	2	applied	\N	\N	\N	\N	28952	28952	28953
9048	7917	3	applied	\N	\N	\N	\N	28954	28954	28955
9048	7918	4	applied	\N	\N	\N	\N	28956	28956	28957
9048	7919	5	applied	\N	\N	\N	\N	28958	28958	28959
9048	7920	6	applied	\N	\N	\N	\N	28960	28960	28961
9048	7921	7	applied	\N	\N	\N	\N	28962	28962	28963
9048	7922	8	applied	\N	\N	\N	\N	28964	28964	28965
9048	7923	9	applied	\N	\N	1000000000	\N	28966	28966	28967
9048	7924	10	applied	\N	\N	\N	\N	28968	28968	28969
9048	7925	11	applied	\N	\N	\N	\N	28970	28970	28971
9048	7926	12	applied	\N	\N	\N	\N	28972	28972	28973
9050	7914	0	applied	\N	\N	\N	\N	28948	28948	28949
9050	7915	1	applied	\N	\N	\N	\N	28950	28950	28951
9050	7916	2	applied	\N	\N	\N	\N	28952	28952	28953
9050	7917	3	applied	\N	\N	\N	\N	28954	28954	28955
9050	7918	4	applied	\N	\N	\N	\N	28956	28956	28957
9050	7919	5	applied	\N	\N	\N	\N	28958	28958	28959
9050	7920	6	applied	\N	\N	\N	\N	28960	28960	28961
9050	7921	7	applied	\N	\N	\N	\N	28962	28962	28963
9050	7922	8	applied	\N	\N	\N	\N	28964	28964	28965
9050	7923	9	applied	\N	\N	1000000000	\N	28966	28966	28967
9050	7924	10	applied	\N	\N	\N	\N	28968	28968	28969
9050	7925	11	applied	\N	\N	\N	\N	28970	28970	28971
9050	7926	12	applied	\N	\N	\N	\N	28972	28972	28973
9052	7927	0	applied	\N	\N	\N	\N	28979	28979	28980
9052	7928	1	applied	\N	\N	\N	\N	28981	28981	28982
9054	7929	0	applied	\N	\N	\N	\N	28987	28987	28988
9054	7930	1	applied	\N	\N	\N	\N	28989	28989	28990
9058	7936	0	applied	\N	\N	\N	\N	29009	29009	29010
9058	7937	1	applied	\N	\N	\N	\N	29011	29011	29012
9061	7940	0	applied	\N	\N	\N	\N	29021	29021	29022
9061	7941	1	applied	\N	\N	\N	\N	29023	29023	29024
9061	7942	2	applied	\N	\N	\N	\N	29025	29025	29026
9061	7943	3	applied	\N	\N	\N	\N	29027	29027	29028
9063	7944	0	applied	\N	\N	1000000000	\N	29031	29031	29032
9063	7945	1	applied	\N	\N	\N	\N	29033	29033	29034
9063	7946	2	applied	\N	\N	\N	\N	29035	29035	29036
9068	7954	0	applied	\N	\N	\N	\N	29056	29056	29057
9068	7955	1	applied	\N	\N	\N	\N	29058	29058	29059
9072	7969	0	applied	\N	\N	\N	\N	29090	29090	1435
9072	7970	1	applied	\N	\N	\N	\N	29091	29091	29092
9072	7971	2	applied	\N	\N	\N	\N	29093	29093	29094
9072	7972	3	applied	\N	\N	\N	\N	29095	29095	29096
9072	7973	4	applied	\N	\N	\N	\N	29097	29097	29098
9075	7978	0	applied	\N	\N	\N	\N	29112	29112	29113
9075	7979	1	applied	\N	\N	\N	\N	29114	29114	29115
9080	7989	0	applied	\N	\N	\N	\N	29143	29143	29144
9080	7990	1	applied	\N	\N	1000000000	\N	29145	29145	29146
9080	7988	2	applied	\N	\N	\N	\N	29139	29139	29140
9080	7991	3	applied	\N	\N	\N	\N	29147	29147	29148
9084	7992	0	applied	\N	\N	\N	\N	29154	29154	29155
9084	7993	1	applied	\N	\N	1000000000	\N	29156	29156	29157
9100	8015	0	applied	\N	\N	\N	\N	29216	29216	29217
9100	8016	1	applied	\N	\N	\N	\N	29218	29218	29219
9103	8017	0	applied	\N	\N	\N	\N	29220	29220	29221
9103	8018	1	applied	\N	\N	\N	\N	29222	29222	29223
9112	8027	0	applied	\N	\N	\N	\N	29254	29254	29255
9112	8028	1	applied	\N	\N	\N	\N	29256	29256	29257
9112	8029	2	applied	\N	\N	\N	\N	29258	29258	29259
9112	8030	3	applied	\N	\N	\N	\N	29260	29260	29261
9118	8035	0	applied	\N	\N	\N	\N	29275	29275	29276
9118	8036	1	applied	\N	\N	\N	\N	29277	29277	29278
9118	8037	2	applied	\N	\N	\N	\N	29279	29279	29280
9118	8038	3	applied	\N	\N	\N	\N	29281	29281	29282
9121	8039	0	applied	\N	\N	\N	\N	29290	29290	29291
9121	8040	1	applied	\N	\N	\N	\N	29292	29292	29293
9126	8045	0	applied	\N	\N	\N	\N	29309	29309	29310
9126	8046	1	applied	\N	\N	\N	\N	29311	29311	29312
9136	8057	0	applied	\N	\N	\N	\N	29347	29347	29348
9136	8058	1	applied	\N	\N	\N	\N	29349	29349	29350
9138	8061	0	applied	\N	\N	\N	\N	29362	29362	29363
9138	8062	1	applied	\N	\N	\N	\N	29364	29364	29365
9140	8063	0	applied	\N	\N	\N	\N	29369	29369	29370
9140	8064	1	applied	\N	\N	\N	\N	29371	29371	29372
9147	8079	0	applied	\N	\N	\N	\N	29408	29408	29409
9147	8080	1	applied	\N	\N	\N	\N	29410	29410	29411
9147	8081	2	applied	\N	\N	\N	\N	29412	29412	29413
9147	8082	3	applied	\N	\N	\N	\N	29414	29414	29415
9151	8087	0	applied	\N	\N	\N	\N	29432	29432	29433
9151	8088	1	applied	\N	\N	\N	\N	29434	29434	29435
9153	8089	0	applied	\N	\N	\N	\N	29437	29437	29438
9153	8090	1	applied	\N	\N	\N	\N	29439	29439	29440
9158	8095	0	applied	\N	\N	\N	\N	29455	29455	29456
9158	8096	1	applied	\N	\N	\N	\N	29457	29457	29458
9161	8099	0	applied	\N	\N	\N	\N	29470	29470	29471
9161	8100	1	applied	\N	\N	\N	\N	29472	29472	29473
9161	8101	2	applied	\N	\N	\N	\N	29474	29474	29475
9161	8102	3	applied	\N	\N	\N	\N	29476	29476	29477
9161	8103	4	applied	\N	\N	\N	\N	29478	29478	29479
9161	8104	5	applied	\N	\N	\N	\N	29480	29480	29481
9161	8105	6	applied	\N	\N	\N	\N	29482	29482	29483
9161	8106	7	applied	\N	\N	\N	\N	29484	29484	29485
9164	8111	0	applied	\N	\N	\N	\N	29500	29500	29501
9164	8112	1	applied	\N	\N	\N	\N	29502	29502	29503
9169	8117	0	applied	\N	\N	\N	\N	29516	29516	29517
9169	8118	1	applied	\N	\N	\N	\N	29518	29518	29519
9091	8002	3	applied	\N	\N	\N	\N	29180	29180	29181
9091	8003	4	applied	\N	\N	\N	\N	29182	29182	29183
9091	8004	5	applied	\N	\N	\N	\N	29184	29184	29185
9091	8005	6	applied	\N	\N	\N	\N	29186	29186	29187
9091	8006	7	applied	\N	\N	\N	\N	29188	29188	29189
9091	8007	8	applied	\N	\N	1000000000	\N	29190	29190	29191
9091	8008	9	applied	\N	\N	\N	\N	29192	29192	29156
9091	8009	10	applied	\N	\N	\N	\N	29193	29193	29194
9094	7999	0	applied	\N	\N	\N	\N	29174	29174	29175
9097	8010	0	applied	\N	\N	\N	\N	29202	29202	29203
9097	8011	1	applied	\N	\N	\N	\N	29204	29204	29205
9099	8012	0	applied	\N	\N	\N	\N	29210	29210	29176
9099	8013	1	applied	\N	\N	\N	\N	29211	29211	29212
9099	8014	2	applied	\N	\N	\N	\N	29213	29213	29214
9106	8021	0	applied	\N	\N	\N	\N	29235	29235	29236
9106	8022	1	applied	\N	\N	\N	\N	29237	29237	29238
9108	8023	0	applied	\N	\N	\N	\N	29241	29241	29242
9108	8024	1	applied	\N	\N	\N	\N	29243	29243	29244
9125	8041	0	applied	\N	\N	\N	\N	29298	29298	29299
9125	8042	1	applied	\N	\N	\N	\N	29300	29300	29301
9125	8043	2	applied	\N	\N	\N	\N	29302	29302	29303
9125	8044	3	applied	\N	\N	\N	\N	29304	29304	29305
9132	8053	0	applied	\N	\N	\N	\N	29335	29335	29336
9132	8054	1	applied	\N	\N	\N	\N	29337	29337	29338
9139	8061	0	applied	\N	\N	\N	\N	29362	29362	29363
9139	8062	1	applied	\N	\N	\N	\N	29364	29364	29365
9142	8067	0	applied	\N	\N	1000000000	\N	29379	29379	29380
9142	8068	1	applied	\N	\N	\N	\N	29381	29381	29382
9142	8069	2	applied	\N	\N	\N	\N	29383	29383	29384
9142	8070	3	applied	\N	\N	\N	\N	29385	29385	29386
9142	8071	4	applied	\N	\N	\N	\N	29387	29387	29388
9145	8079	0	applied	\N	\N	\N	\N	29408	29408	29409
9145	8080	1	applied	\N	\N	\N	\N	29410	29410	29411
9145	8081	2	applied	\N	\N	\N	\N	29412	29412	29413
9145	8082	3	applied	\N	\N	\N	\N	29414	29414	29415
9148	8079	0	applied	\N	\N	\N	\N	29408	29408	29409
9148	8080	1	applied	\N	\N	\N	\N	29410	29410	29411
9148	8081	2	applied	\N	\N	\N	\N	29412	29412	29413
9148	8082	3	applied	\N	\N	\N	\N	29414	29414	29415
9150	8083	0	applied	\N	\N	\N	\N	29423	29423	29424
9150	8084	1	applied	\N	\N	\N	\N	29425	29425	29426
9150	8085	2	applied	\N	\N	\N	\N	29427	29427	29428
9150	8086	3	applied	\N	\N	\N	\N	29429	29429	29430
9157	8095	0	applied	\N	\N	\N	\N	29455	29455	29456
9157	8096	1	applied	\N	\N	\N	\N	29457	29457	29458
9159	8097	0	applied	\N	\N	\N	\N	29463	29463	29464
9159	8098	1	applied	\N	\N	\N	\N	29465	29465	29466
9165	8113	0	applied	\N	\N	\N	\N	29504	29504	29505
9165	8114	1	applied	\N	\N	\N	\N	29506	29506	29507
9175	8132	0	applied	\N	\N	\N	\N	29551	29551	29552
9175	8133	1	applied	\N	\N	\N	\N	29553	29553	29554
9178	8132	0	applied	\N	\N	\N	\N	29551	29551	29552
9178	8133	1	applied	\N	\N	\N	\N	29553	29553	29554
9182	8140	0	applied	\N	\N	\N	\N	29584	29584	29585
9182	8141	1	applied	\N	\N	\N	\N	29586	29586	29587
9185	8149	0	applied	\N	\N	\N	\N	29604	29604	29605
9185	8150	1	applied	\N	\N	\N	\N	29606	29606	29607
9190	8155	0	applied	\N	\N	\N	\N	29624	29624	29625
9190	8156	1	applied	\N	\N	\N	\N	29626	29626	29627
9190	8157	2	applied	\N	\N	\N	\N	29628	29628	29629
9190	8158	3	applied	\N	\N	\N	\N	29630	29630	29631
9195	8168	0	applied	\N	\N	\N	\N	29660	29660	29661
9195	8169	1	applied	\N	\N	\N	\N	29662	29662	29663
9195	8170	2	applied	\N	\N	\N	\N	29664	29664	29665
9195	8171	3	applied	\N	\N	\N	\N	29666	29666	29667
9195	8172	4	applied	\N	\N	\N	\N	29668	29668	29668
9197	7969	0	applied	\N	\N	\N	\N	29090	29090	1435
9197	7956	1	applied	\N	\N	\N	\N	29316	29316	29061
9197	7999	2	applied	\N	\N	\N	\N	29174	29174	29175
9197	7980	3	applied	\N	\N	\N	\N	29118	29118	29119
9197	7949	4	applied	\N	\N	1000000000	\N	29045	29045	29046
9197	7742	5	applied	\N	\N	\N	\N	28431	28431	28432
9197	8159	6	applied	\N	\N	\N	\N	29673	29673	29639
9197	7745	7	applied	\N	\N	\N	\N	28440	28440	28441
9197	7891	8	applied	\N	\N	\N	\N	28876	28876	28877
9197	7746	9	applied	\N	\N	\N	\N	28442	28442	28443
9197	7915	10	applied	\N	\N	\N	\N	28950	28950	28951
9197	7748	11	applied	\N	\N	\N	\N	28449	28449	28450
9197	7749	12	applied	\N	\N	\N	\N	28451	28451	28452
9197	7754	13	applied	\N	\N	\N	\N	28462	28462	28463
9197	8163	14	applied	\N	\N	\N	\N	29674	29674	29649
9197	7990	15	applied	\N	\N	1000000000	\N	29145	29145	29146
9197	8164	16	applied	\N	\N	\N	\N	29675	29675	29651
9197	8165	17	applied	\N	\N	\N	\N	29676	29676	29653
9197	8166	18	applied	\N	\N	\N	\N	29677	29677	29655
9197	8168	19	applied	\N	\N	\N	\N	29678	29678	29661
9197	8170	20	applied	\N	\N	\N	\N	29679	29679	29665
9197	7983	21	applied	\N	\N	\N	\N	29125	29125	29126
9197	7984	22	applied	\N	\N	\N	\N	29127	29127	29128
9197	7758	23	applied	\N	\N	\N	\N	28474	28474	28475
9197	7759	24	applied	\N	\N	\N	\N	28480	28480	28481
9197	7762	25	applied	\N	\N	\N	\N	28488	28488	28489
9197	7764	26	applied	\N	\N	\N	\N	28496	28496	28497
9197	7768	27	applied	\N	\N	\N	\N	28503	28503	28504
9197	7770	28	applied	\N	\N	\N	\N	28509	28509	28510
9197	7771	29	applied	\N	\N	\N	\N	28513	28513	28514
9197	7772	30	applied	\N	\N	\N	\N	28515	28515	28516
9197	7777	31	applied	\N	\N	\N	\N	28529	28529	28530
9197	7778	32	applied	\N	\N	\N	\N	28531	28531	28532
9197	7780	33	applied	\N	\N	\N	\N	28541	28541	28542
9197	7781	34	applied	\N	\N	\N	\N	28543	28543	28544
9197	7784	35	applied	\N	\N	\N	\N	28552	28552	28553
9197	7787	36	applied	\N	\N	\N	\N	28559	28559	28560
9197	7789	37	applied	\N	\N	\N	\N	28563	28563	28564
9197	7790	38	applied	\N	\N	\N	\N	28565	28565	28566
9197	7792	39	applied	\N	\N	\N	\N	28571	28571	28572
9197	7794	40	applied	\N	\N	\N	\N	28581	28581	28582
9197	7797	41	applied	\N	\N	\N	\N	28587	28587	28588
9197	7798	42	applied	\N	\N	\N	\N	28593	28593	28594
9197	7799	43	applied	\N	\N	\N	\N	28595	28595	28596
9197	7803	44	applied	\N	\N	\N	\N	28606	28606	28607
9197	7805	45	applied	\N	\N	\N	\N	28611	28611	28612
9197	7806	46	applied	\N	\N	\N	\N	28613	28613	28614
9197	7807	47	applied	\N	\N	\N	\N	28615	28615	28616
9197	7811	48	applied	\N	\N	\N	\N	28625	28625	28626
9197	7814	49	applied	\N	\N	\N	\N	28639	28639	28640
9197	7816	50	applied	\N	\N	\N	\N	28647	28647	28648
9197	7818	51	applied	\N	\N	\N	\N	28653	28653	28654
9197	7820	52	applied	\N	\N	\N	\N	28660	28660	28661
9109	8024	1	applied	\N	\N	\N	\N	29243	29243	29244
9111	8025	0	applied	\N	\N	\N	\N	29249	29249	29250
9111	8026	1	applied	\N	\N	\N	\N	29251	29251	29252
9114	8031	0	applied	\N	\N	\N	\N	29266	29266	29267
9114	8032	1	applied	\N	\N	\N	\N	29268	29268	29269
9114	8033	2	applied	\N	\N	\N	\N	29270	29270	29271
9114	8034	3	applied	\N	\N	\N	\N	29272	29272	29273
9117	8035	0	applied	\N	\N	\N	\N	29275	29275	29276
9117	8036	1	applied	\N	\N	\N	\N	29277	29277	29278
9117	8037	2	applied	\N	\N	\N	\N	29279	29279	29280
9117	8038	3	applied	\N	\N	\N	\N	29281	29281	29282
9123	8039	0	applied	\N	\N	\N	\N	29290	29290	29291
9123	8040	1	applied	\N	\N	\N	\N	29292	29292	29293
9128	7969	0	applied	\N	\N	\N	\N	29090	29090	1435
9128	7956	1	applied	\N	\N	\N	\N	29316	29316	29061
9128	7999	2	applied	\N	\N	\N	\N	29174	29174	29175
9128	7980	3	applied	\N	\N	\N	\N	29118	29118	29119
9128	7949	4	applied	\N	\N	1000000000	\N	29045	29045	29046
9128	7891	5	applied	\N	\N	\N	\N	28876	28876	28877
9128	7915	6	applied	\N	\N	\N	\N	28950	28950	28951
9128	7990	7	applied	\N	\N	1000000000	\N	29145	29145	29146
9128	7983	8	applied	\N	\N	\N	\N	29125	29125	29126
9128	7984	9	applied	\N	\N	\N	\N	29127	29127	29128
9128	7802	10	applied	\N	\N	1000000000	\N	28601	28601	28602
9128	7875	11	applied	\N	\N	\N	\N	28830	28830	27453
9128	7827	12	applied	\N	\N	\N	\N	28679	28679	28679
9128	7935	13	applied	\N	\N	\N	\N	29003	29003	28358
9128	7993	14	applied	\N	\N	1000000000	\N	29156	29156	29157
9128	8009	15	applied	\N	\N	\N	\N	29193	29193	29317
9128	7909	16	applied	\N	\N	1000000000	\N	28926	28926	28927
9128	7926	17	applied	\N	\N	\N	\N	28972	28972	28973
9130	8051	0	applied	\N	\N	\N	\N	29328	29328	29329
9133	8053	0	applied	\N	\N	\N	\N	29335	29335	29336
9133	8054	1	applied	\N	\N	\N	\N	29337	29337	29338
9135	8057	0	applied	\N	\N	\N	\N	29347	29347	29348
9135	8058	1	applied	\N	\N	\N	\N	29349	29349	29350
9137	8059	0	applied	\N	\N	\N	\N	29355	29355	29356
9137	8060	2	applied	\N	\N	\N	\N	29357	29357	29358
9143	8067	0	applied	\N	\N	1000000000	\N	29379	29379	29380
9143	8068	1	applied	\N	\N	\N	\N	29381	29381	29382
9143	8069	2	applied	\N	\N	\N	\N	29383	29383	29384
9143	8070	3	applied	\N	\N	\N	\N	29385	29385	29386
9143	8071	4	applied	\N	\N	\N	\N	29387	29387	29388
9146	8079	0	applied	\N	\N	\N	\N	29408	29408	29409
9146	8080	1	applied	\N	\N	\N	\N	29410	29410	29411
9146	8081	2	applied	\N	\N	\N	\N	29412	29412	29413
9146	8082	3	applied	\N	\N	\N	\N	29414	29414	29415
9155	8091	0	applied	\N	\N	\N	\N	29443	29443	29444
9155	8092	1	applied	\N	\N	\N	\N	29445	29445	29446
9160	8097	0	applied	\N	\N	\N	\N	29463	29463	29464
9160	8098	1	applied	\N	\N	\N	\N	29465	29465	29466
9163	8107	0	applied	\N	\N	\N	\N	29488	29488	29489
9163	8108	1	applied	\N	\N	\N	\N	29490	29490	29491
9163	8109	2	applied	\N	\N	\N	\N	29492	29492	29493
9163	8110	3	applied	\N	\N	\N	\N	29494	29494	29495
9166	8115	0	applied	\N	\N	\N	\N	29510	29510	29511
9166	8116	1	applied	\N	\N	\N	\N	29512	29512	29513
9170	8117	0	applied	\N	\N	\N	\N	29516	29516	29517
9170	8118	1	applied	\N	\N	\N	\N	29518	29518	29519
9176	8132	0	applied	\N	\N	\N	\N	29551	29551	29552
9176	8133	1	applied	\N	\N	\N	\N	29553	29553	29554
9180	8134	0	applied	\N	\N	\N	\N	29561	29561	29562
9180	8135	1	applied	\N	\N	\N	\N	29563	29563	29564
9180	8136	2	applied	\N	\N	\N	\N	29565	29565	29566
9180	8137	3	applied	\N	\N	\N	\N	29567	29567	29568
9180	8138	5	applied	\N	\N	\N	\N	29570	29570	29571
9180	8139	6	applied	\N	\N	\N	\N	29572	29572	29573
9186	8151	0	applied	\N	\N	\N	\N	29610	29610	29611
9186	8152	1	applied	\N	\N	\N	\N	29612	29612	29613
9186	8153	2	applied	\N	\N	\N	\N	29614	29614	29615
9186	8154	3	applied	\N	\N	\N	\N	29616	29616	29617
9188	8151	0	applied	\N	\N	\N	\N	29610	29610	29611
9188	8152	1	applied	\N	\N	\N	\N	29612	29612	29613
9188	8153	2	applied	\N	\N	\N	\N	29614	29614	29615
9188	8154	3	applied	\N	\N	\N	\N	29616	29616	29617
9191	8155	0	applied	\N	\N	\N	\N	29624	29624	29625
9191	8156	1	applied	\N	\N	\N	\N	29626	29626	29627
9191	8157	2	applied	\N	\N	\N	\N	29628	29628	29629
9191	8158	3	applied	\N	\N	\N	\N	29630	29630	29631
9193	8159	0	applied	\N	\N	\N	\N	29638	29638	29639
9193	8160	1	applied	\N	\N	\N	\N	29640	29640	29641
9193	8161	2	applied	\N	\N	\N	\N	29642	29642	29643
9200	8177	0	applied	\N	\N	\N	\N	29694	29694	29695
9200	8178	1	applied	\N	\N	\N	\N	29696	29696	29697
9206	8185	0	applied	\N	\N	\N	\N	29717	29717	29718
9206	8186	1	applied	\N	\N	\N	\N	29719	29719	29720
9206	8187	2	applied	\N	\N	\N	\N	29721	29721	29722
9206	8188	3	applied	\N	\N	\N	\N	29723	29723	29724
9206	8189	4	applied	\N	\N	\N	\N	29725	29725	29726
9206	8190	5	applied	\N	\N	\N	\N	29727	29727	29728
9206	8191	6	applied	\N	\N	\N	\N	29729	29729	29730
9206	8192	7	applied	\N	\N	\N	\N	29731	29731	29732
9212	8204	0	applied	\N	\N	\N	\N	29762	29762	29763
9212	8205	1	applied	\N	\N	\N	\N	29764	29764	29765
9212	8206	2	applied	\N	\N	\N	\N	29766	29766	29767
9212	8207	3	applied	\N	\N	\N	\N	29768	29768	29769
9214	8204	0	applied	\N	\N	\N	\N	29762	29762	29763
9214	8205	1	applied	\N	\N	\N	\N	29764	29764	29765
9214	8206	2	applied	\N	\N	\N	\N	29766	29766	29767
9214	8207	3	applied	\N	\N	\N	\N	29768	29768	29769
9217	8208	0	applied	\N	\N	\N	\N	29778	29778	29779
9217	8209	1	applied	\N	\N	\N	\N	29780	29780	29781
9217	8210	2	applied	\N	\N	\N	\N	29782	29782	29783
9217	8211	3	applied	\N	\N	\N	\N	29784	29784	29785
9217	8212	4	applied	\N	\N	\N	\N	29786	29786	29787
9217	8213	5	applied	\N	\N	\N	\N	29788	29788	29789
9223	8220	0	applied	\N	\N	\N	\N	29814	29814	29815
9223	8221	1	applied	\N	\N	\N	\N	29816	29816	29817
9230	8222	0	applied	\N	\N	1000000000	\N	29822	29822	29823
9230	8223	1	applied	\N	\N	\N	\N	29824	29824	29825
9230	8224	2	applied	\N	\N	\N	\N	29826	29826	29827
9232	8226	0	applied	\N	\N	\N	\N	29838	29838	29839
9232	8227	1	applied	\N	\N	\N	\N	29840	29840	29841
9237	8234	0	applied	\N	\N	\N	\N	29859	29859	29860
9237	8235	1	applied	\N	\N	\N	\N	29861	29861	29862
9237	8236	2	applied	\N	\N	\N	\N	29863	29863	29864
9237	8237	3	applied	\N	\N	\N	\N	29865	29865	29866
9240	8242	0	applied	\N	\N	\N	\N	29880	29880	29881
9240	8243	1	applied	\N	\N	\N	\N	29882	29882	29883
9129	8047	0	applied	\N	\N	\N	\N	29320	29320	29321
9129	8048	1	applied	\N	\N	\N	\N	29322	29322	29323
9129	8049	2	applied	\N	\N	\N	\N	29324	29324	29325
9129	8050	3	applied	\N	\N	\N	\N	29326	29326	29327
9131	8051	0	applied	\N	\N	\N	\N	29328	29328	29329
9131	8052	1	applied	\N	\N	\N	\N	29332	29332	29333
9134	8055	0	applied	\N	\N	\N	\N	29343	29343	29344
9134	8056	1	applied	\N	\N	\N	\N	29345	29345	29346
9141	8065	0	applied	\N	\N	\N	\N	29374	29374	29375
9141	8066	1	applied	\N	\N	\N	\N	29376	29376	29377
9144	8072	0	applied	\N	\N	\N	\N	29392	29392	29393
9144	8073	1	applied	\N	\N	\N	\N	29394	29394	29395
9144	8074	2	applied	\N	\N	\N	\N	29396	29396	29397
9144	8075	3	applied	\N	\N	\N	\N	29398	29398	29399
9144	8076	4	applied	\N	\N	\N	\N	29400	29400	29401
9144	8077	5	applied	\N	\N	1000000000	\N	29402	29402	29403
9144	8078	6	applied	\N	\N	\N	\N	29404	29404	29405
9149	8083	0	applied	\N	\N	\N	\N	29423	29423	29424
9149	8084	1	applied	\N	\N	\N	\N	29425	29425	29426
9149	8085	2	applied	\N	\N	\N	\N	29427	29427	29428
9149	8086	3	applied	\N	\N	\N	\N	29429	29429	29430
9152	8087	0	applied	\N	\N	\N	\N	29432	29432	29433
9152	8088	1	applied	\N	\N	\N	\N	29434	29434	29435
9154	8091	0	applied	\N	\N	\N	\N	29443	29443	29444
9154	8092	1	applied	\N	\N	\N	\N	29445	29445	29446
9156	8093	0	applied	\N	\N	\N	\N	29449	29449	29450
9156	8094	1	applied	\N	\N	\N	\N	29451	29451	29452
9162	8107	0	applied	\N	\N	\N	\N	29488	29488	29489
9162	8108	1	applied	\N	\N	\N	\N	29490	29490	29491
9162	8109	2	applied	\N	\N	\N	\N	29492	29492	29493
9162	8110	3	applied	\N	\N	\N	\N	29494	29494	29495
9167	8115	0	applied	\N	\N	\N	\N	29510	29510	29511
9167	8116	1	applied	\N	\N	\N	\N	29512	29512	29513
9172	8119	0	applied	\N	\N	\N	\N	29523	29523	29524
9172	8120	1	applied	\N	\N	\N	\N	29525	29525	29526
9172	8121	2	applied	\N	\N	\N	\N	29527	29527	29528
9174	8126	0	applied	\N	\N	\N	\N	29540	29540	29541
9174	8127	1	applied	\N	\N	\N	\N	29542	29542	29543
9174	8128	2	applied	\N	\N	\N	\N	29544	29544	1435
9174	8129	3	applied	\N	\N	\N	\N	29545	29545	1435
9174	8130	4	applied	\N	\N	\N	\N	29546	29546	29547
9174	8131	5	applied	\N	\N	\N	\N	29548	29548	29549
9179	8134	0	applied	\N	\N	\N	\N	29561	29561	29562
9179	8135	1	applied	\N	\N	\N	\N	29563	29563	29564
9179	8136	2	applied	\N	\N	\N	\N	29565	29565	29566
9179	8137	3	applied	\N	\N	\N	\N	29567	29567	29568
9179	8138	5	applied	\N	\N	\N	\N	29570	29570	29571
9179	8139	6	applied	\N	\N	\N	\N	29572	29572	29573
9194	8162	0	applied	\N	\N	\N	\N	29646	29646	29647
9194	8163	1	applied	\N	\N	\N	\N	29648	29648	29649
9194	8164	2	applied	\N	\N	\N	\N	29650	29650	29651
9194	8165	3	applied	\N	\N	\N	\N	29652	29652	29653
9194	8166	4	applied	\N	\N	\N	\N	29654	29654	29655
9194	8167	5	applied	\N	\N	\N	\N	29656	29656	29657
9199	8175	0	applied	\N	\N	\N	\N	29690	29690	29691
9199	8176	1	applied	\N	\N	\N	\N	29692	29692	29693
9204	8183	0	applied	\N	\N	\N	\N	29711	29711	29712
9204	8184	1	applied	\N	\N	\N	\N	29713	29713	29714
9205	8185	0	applied	\N	\N	\N	\N	29717	29717	29718
9205	8186	1	applied	\N	\N	\N	\N	29719	29719	29720
9205	8187	2	applied	\N	\N	\N	\N	29721	29721	29722
9205	8188	3	applied	\N	\N	\N	\N	29723	29723	29724
9205	8189	4	applied	\N	\N	\N	\N	29725	29725	29726
9205	8190	5	applied	\N	\N	\N	\N	29727	29727	29728
9205	8191	6	applied	\N	\N	\N	\N	29729	29729	29730
9205	8192	7	applied	\N	\N	\N	\N	29731	29731	29732
9207	8193	0	applied	\N	\N	\N	\N	29735	29735	29736
9207	8194	1	applied	\N	\N	\N	\N	29737	29737	29738
9207	8195	2	applied	\N	\N	\N	\N	29739	29739	29740
9207	8196	3	applied	\N	\N	\N	\N	29741	29741	29742
9210	8201	0	applied	\N	\N	\N	\N	29755	29755	29756
9210	8202	1	applied	\N	\N	\N	\N	29757	29757	29758
9210	8203	2	applied	\N	\N	1000000000	\N	29759	29759	29760
9213	8204	0	applied	\N	\N	\N	\N	29762	29762	29763
9213	8205	1	applied	\N	\N	\N	\N	29764	29764	29765
9213	8206	2	applied	\N	\N	\N	\N	29766	29766	29767
9213	8207	3	applied	\N	\N	\N	\N	29768	29768	29769
9215	8208	0	applied	\N	\N	\N	\N	29778	29778	29779
9215	8209	1	applied	\N	\N	\N	\N	29780	29780	29781
9215	8210	2	applied	\N	\N	\N	\N	29782	29782	29783
9215	8211	3	applied	\N	\N	\N	\N	29784	29784	29785
9215	8212	4	applied	\N	\N	\N	\N	29786	29786	29787
9215	8213	5	applied	\N	\N	\N	\N	29788	29788	29789
9220	8218	0	applied	\N	\N	\N	\N	29807	29807	29808
9220	8219	1	applied	\N	\N	\N	\N	29809	29809	29810
9224	8220	0	applied	\N	\N	\N	\N	29814	29814	29815
9224	8221	1	applied	\N	\N	\N	\N	29816	29816	29817
9227	8203	0	applied	\N	\N	1000000000	\N	29759	29759	29760
9231	8225	0	applied	\N	\N	\N	\N	29834	29834	29835
9233	8228	0	applied	\N	\N	\N	\N	29844	29844	29845
9233	8229	1	applied	\N	\N	\N	\N	29846	29846	29847
9236	8232	0	applied	\N	\N	\N	\N	29854	29854	29855
9236	8233	1	applied	\N	\N	\N	\N	29856	29856	29857
9241	8244	0	applied	\N	\N	\N	\N	29884	29884	29885
9241	8245	1	applied	\N	\N	\N	\N	29886	29886	29887
9246	8249	0	applied	\N	\N	\N	\N	29904	29904	29905
9246	8250	1	applied	\N	\N	\N	\N	29906	29906	29907
9246	8251	2	applied	\N	\N	\N	\N	29908	29908	29909
9246	8252	3	applied	\N	\N	\N	\N	29910	29910	29911
9246	8253	4	applied	\N	\N	\N	\N	29912	29912	29913
9246	8254	5	applied	\N	\N	\N	\N	29914	29914	29915
9246	8255	6	applied	\N	\N	\N	\N	29916	29916	29917
9246	8256	7	applied	\N	\N	\N	\N	29918	29918	29919
9246	8257	8	applied	\N	\N	\N	\N	29920	29920	29921
9246	8258	9	applied	\N	\N	\N	\N	29922	29922	29923
9171	8119	0	applied	\N	\N	\N	\N	29523	29523	29524
9171	8120	1	applied	\N	\N	\N	\N	29525	29525	29526
9171	8121	2	applied	\N	\N	\N	\N	29527	29527	29528
9173	8122	0	applied	\N	\N	\N	\N	29531	29531	29532
9173	8123	1	applied	\N	\N	\N	\N	29533	29533	29534
9173	8124	2	applied	\N	\N	\N	\N	29535	29535	29536
9173	8125	3	applied	\N	\N	\N	\N	29537	29537	29538
9177	8132	0	applied	\N	\N	\N	\N	29551	29551	29552
9177	8133	1	applied	\N	\N	\N	\N	29553	29553	29554
9181	8134	0	applied	\N	\N	\N	\N	29561	29561	29562
9181	8135	1	applied	\N	\N	\N	\N	29563	29563	29564
9181	8136	2	applied	\N	\N	\N	\N	29565	29565	29566
9181	8137	3	applied	\N	\N	\N	\N	29567	29567	29568
9181	8138	5	applied	\N	\N	\N	\N	29570	29570	29571
9181	8139	6	applied	\N	\N	\N	\N	29572	29572	29573
9183	8142	0	applied	\N	\N	\N	\N	29588	29588	29589
9183	8143	1	applied	\N	\N	\N	\N	29590	29590	29591
9184	8144	0	applied	\N	\N	\N	\N	29592	29592	29593
9184	8145	1	applied	\N	\N	\N	\N	29594	29594	29595
9184	8146	2	applied	\N	\N	\N	\N	29596	29596	29597
9184	8147	3	applied	\N	\N	\N	\N	29598	29598	29599
9184	8148	4	applied	\N	\N	\N	\N	29600	29600	29601
9187	8151	0	applied	\N	\N	\N	\N	29610	29610	29611
9187	8152	1	applied	\N	\N	\N	\N	29612	29612	29613
9187	8153	2	applied	\N	\N	\N	\N	29614	29614	29615
9187	8154	3	applied	\N	\N	\N	\N	29616	29616	29617
9189	8155	0	applied	\N	\N	\N	\N	29624	29624	29625
9189	8156	1	applied	\N	\N	\N	\N	29626	29626	29627
9189	8157	2	applied	\N	\N	\N	\N	29628	29628	29629
9189	8158	3	applied	\N	\N	\N	\N	29630	29630	29631
9192	8121	0	applied	\N	\N	\N	\N	29527	29527	29528
9192	8124	1	applied	\N	\N	\N	\N	29535	29535	29536
9192	8125	2	applied	\N	\N	\N	\N	29537	29537	29538
9196	8168	0	applied	\N	\N	\N	\N	29660	29660	29661
9196	8169	1	applied	\N	\N	\N	\N	29662	29662	29663
9196	8170	2	applied	\N	\N	\N	\N	29664	29664	29665
9196	8171	3	applied	\N	\N	\N	\N	29666	29666	29667
9196	8172	4	applied	\N	\N	\N	\N	29668	29668	29668
9198	8173	0	applied	\N	\N	\N	\N	29685	29685	29686
9198	8174	1	applied	\N	\N	\N	\N	29687	29687	29688
9201	8177	0	applied	\N	\N	\N	\N	29694	29694	29695
9201	8178	1	applied	\N	\N	\N	\N	29696	29696	29697
9203	8181	0	applied	\N	\N	\N	\N	29706	29706	29707
9203	8182	1	applied	\N	\N	\N	\N	29708	29708	29709
9209	8199	0	applied	\N	\N	\N	\N	29751	29751	29752
9209	8200	1	applied	\N	\N	\N	\N	29753	29753	29754
9219	8214	0	applied	\N	\N	\N	\N	29795	29795	29796
9219	8215	1	applied	\N	\N	\N	\N	29797	29797	29798
9219	8216	2	applied	\N	\N	\N	\N	29799	29799	29800
9219	8217	3	applied	\N	\N	\N	\N	29801	29801	29802
9222	8218	0	applied	\N	\N	\N	\N	29807	29807	29808
9222	8219	1	applied	\N	\N	\N	\N	29809	29809	29810
9226	8222	0	applied	\N	\N	1000000000	\N	29822	29822	29823
9226	8223	1	applied	\N	\N	\N	\N	29824	29824	29825
9226	8224	2	applied	\N	\N	\N	\N	29826	29826	29827
9235	8232	0	applied	\N	\N	\N	\N	29854	29854	29855
9235	8233	1	applied	\N	\N	\N	\N	29856	29856	29857
9238	8238	0	applied	\N	\N	\N	\N	29868	29868	29869
9238	8239	1	applied	\N	\N	\N	\N	29870	29870	29871
9197	7821	53	applied	\N	\N	\N	\N	28665	28665	28666
9197	7823	54	applied	\N	\N	\N	\N	28671	28671	28672
9197	7826	55	applied	\N	\N	\N	\N	28677	28677	28678
9197	7829	56	applied	\N	\N	\N	\N	28700	28700	28701
9197	7831	57	applied	\N	\N	\N	\N	28708	28708	28709
9197	7832	58	applied	\N	\N	\N	\N	28710	28710	28711
9197	7835	59	applied	\N	\N	\N	\N	28716	28716	28717
9197	7837	60	applied	\N	\N	\N	\N	28724	28724	28725
9197	7841	61	applied	\N	\N	\N	\N	28732	28732	28733
9197	7842	62	applied	\N	\N	\N	\N	28734	28734	28735
9197	7845	63	applied	\N	\N	\N	\N	28743	28743	28744
9197	7846	64	applied	\N	\N	\N	\N	28745	28745	28746
9197	7847	65	applied	\N	\N	\N	\N	28749	28749	28750
9197	7850	66	applied	\N	\N	\N	\N	28761	28761	28762
9197	7851	68	applied	\N	\N	\N	\N	28765	28765	28766
9197	7855	69	applied	\N	\N	\N	\N	28775	28775	28776
9197	7856	70	applied	\N	\N	\N	\N	28777	28777	28778
9197	7857	71	applied	\N	\N	\N	\N	28785	28785	28786
9197	7861	72	applied	\N	\N	\N	\N	28794	28794	28795
9197	7862	73	applied	\N	\N	\N	\N	28796	28796	28797
9197	7863	74	applied	\N	\N	\N	\N	28800	28800	28801
9197	7865	75	applied	\N	\N	\N	\N	28806	28806	28807
9197	7869	76	applied	\N	\N	\N	\N	28816	28816	28817
9197	7870	77	applied	\N	\N	\N	\N	28818	28818	28819
9197	7871	78	applied	\N	\N	\N	\N	28822	28822	28823
9197	7873	79	applied	\N	\N	\N	\N	28826	28826	28827
9197	7877	80	applied	\N	\N	\N	\N	28835	28835	28836
9197	7878	81	applied	\N	\N	\N	\N	28842	28842	28843
9197	7880	82	applied	\N	\N	\N	\N	28846	28846	28847
9197	7881	83	applied	\N	\N	\N	\N	28848	28848	28849
9197	7884	84	applied	\N	\N	\N	\N	28857	28857	28858
9197	7887	85	applied	\N	\N	\N	\N	28866	28866	28867
9197	7889	86	applied	\N	\N	\N	\N	28870	28870	28871
9197	7890	87	applied	\N	\N	\N	\N	28874	28874	28875
9197	7893	88	applied	\N	\N	\N	\N	28885	28885	28886
9197	7894	89	applied	\N	\N	\N	\N	28887	28887	28888
9197	7897	90	applied	\N	\N	\N	\N	28893	28893	28894
9197	7900	91	applied	\N	\N	\N	\N	28904	28904	28905
9197	7901	92	applied	\N	\N	\N	\N	28908	28908	28909
9197	7903	93	applied	\N	\N	\N	\N	28912	28912	28913
9197	7907	94	applied	\N	\N	\N	\N	28922	28922	28923
9197	7908	95	applied	\N	\N	\N	\N	28924	28924	28925
9197	7912	96	applied	\N	\N	\N	\N	28940	28940	28941
9197	7913	97	applied	\N	\N	\N	\N	28942	28942	28943
9197	7914	98	applied	\N	\N	\N	\N	28948	28948	28949
9197	7916	99	applied	\N	\N	\N	\N	28952	28952	28953
9197	7917	100	applied	\N	\N	\N	\N	28954	28954	28955
9197	7918	101	applied	\N	\N	\N	\N	28956	28956	28957
9197	7919	102	applied	\N	\N	\N	\N	28958	28958	28959
9197	7928	103	applied	\N	\N	\N	\N	28981	28981	28982
9197	7930	104	applied	\N	\N	\N	\N	28989	28989	28990
9197	7931	105	applied	\N	\N	\N	\N	28995	28995	28996
9197	7934	106	applied	\N	\N	\N	\N	29001	29001	29002
9197	7936	107	applied	\N	\N	\N	\N	29009	29009	29010
9197	7939	108	applied	\N	\N	\N	\N	29015	29015	29016
9197	7940	109	applied	\N	\N	\N	\N	29021	29021	29022
9197	7941	110	applied	\N	\N	\N	\N	29023	29023	29024
9197	7946	111	applied	\N	\N	\N	\N	29035	29035	29036
9197	7947	112	applied	\N	\N	\N	\N	29039	29039	29040
9197	7950	113	applied	\N	\N	\N	\N	29047	29047	29048
9197	7951	114	applied	\N	\N	\N	\N	29049	29049	29050
9197	7954	115	applied	\N	\N	\N	\N	29056	29056	29057
9197	7959	116	applied	\N	\N	\N	\N	29066	29066	29067
9197	7963	117	applied	\N	\N	\N	\N	29074	29074	29075
9197	7964	118	applied	\N	\N	\N	\N	29076	29076	29077
9197	7965	119	applied	\N	\N	\N	\N	29078	29078	29079
9197	7966	120	applied	\N	\N	\N	\N	29080	29080	29081
9197	7968	121	applied	\N	\N	\N	\N	29086	29086	29087
9197	7972	122	applied	\N	\N	\N	\N	29095	29095	29096
9197	7973	123	applied	\N	\N	\N	\N	29097	29097	29098
9197	7974	124	applied	\N	\N	\N	\N	29100	29100	29101
9202	8179	0	applied	\N	\N	\N	\N	29700	29700	29701
9202	8180	1	applied	\N	\N	\N	\N	29702	29702	29703
9208	8197	0	applied	\N	\N	\N	\N	29745	29745	29746
9208	8198	1	applied	\N	\N	\N	\N	29747	29747	29748
9211	8204	0	applied	\N	\N	\N	\N	29762	29762	29763
9211	8205	1	applied	\N	\N	\N	\N	29764	29764	29765
9211	8206	2	applied	\N	\N	\N	\N	29766	29766	29767
9211	8207	3	applied	\N	\N	\N	\N	29768	29768	29769
9216	8208	0	applied	\N	\N	\N	\N	29778	29778	29779
9216	8209	1	applied	\N	\N	\N	\N	29780	29780	29781
9216	8210	2	applied	\N	\N	\N	\N	29782	29782	29783
9216	8211	3	applied	\N	\N	\N	\N	29784	29784	29785
9216	8212	4	applied	\N	\N	\N	\N	29786	29786	29787
9216	8213	5	applied	\N	\N	\N	\N	29788	29788	29789
9218	8214	0	applied	\N	\N	\N	\N	29795	29795	29796
9218	8215	1	applied	\N	\N	\N	\N	29797	29797	29798
9218	8216	2	applied	\N	\N	\N	\N	29799	29799	29800
9218	8217	3	applied	\N	\N	\N	\N	29801	29801	29802
9221	8218	0	applied	\N	\N	\N	\N	29807	29807	29808
9221	8219	1	applied	\N	\N	\N	\N	29809	29809	29810
9225	8220	0	applied	\N	\N	\N	\N	29814	29814	29815
9225	8221	1	applied	\N	\N	\N	\N	29816	29816	29817
9228	8222	0	applied	\N	\N	1000000000	\N	29822	29822	29823
9228	8223	1	applied	\N	\N	\N	\N	29824	29824	29825
9228	8224	2	applied	\N	\N	\N	\N	29826	29826	29827
9229	8222	0	applied	\N	\N	1000000000	\N	29822	29822	29823
9229	8223	1	applied	\N	\N	\N	\N	29824	29824	29825
9229	8224	2	applied	\N	\N	\N	\N	29826	29826	29827
9234	8230	0	applied	\N	\N	\N	\N	29848	29848	29849
9234	8231	1	applied	\N	\N	\N	\N	29850	29850	29851
9239	8240	0	applied	\N	\N	\N	\N	29874	29874	29875
9239	8241	1	applied	\N	\N	\N	\N	29876	29876	29877
9242	8246	0	applied	\N	\N	\N	\N	29890	29890	29891
9242	8247	1	applied	\N	\N	\N	\N	29892	29892	29893
9242	8248	2	applied	\N	\N	\N	\N	29894	29894	29895
9244	8246	0	applied	\N	\N	\N	\N	29890	29890	29891
9244	8247	1	applied	\N	\N	\N	\N	29892	29892	29893
9244	8248	2	applied	\N	\N	\N	\N	29894	29894	29895
9247	8259	0	applied	\N	\N	\N	\N	29926	29926	29927
9247	8260	1	applied	\N	\N	\N	\N	29928	29928	29929
9247	8261	2	applied	\N	\N	\N	\N	29930	29930	29931
9247	8262	3	applied	\N	\N	\N	\N	29932	29932	29933
9247	8263	4	applied	\N	\N	\N	\N	29934	29934	29935
9247	8264	5	applied	\N	\N	\N	\N	29936	29936	29937
9247	8265	6	applied	\N	\N	\N	\N	29938	29938	29939
9247	8266	7	applied	\N	\N	\N	\N	29940	29940	29941
9247	8267	8	applied	\N	\N	\N	\N	29942	29942	29943
9247	8268	9	applied	\N	\N	\N	\N	29944	29944	29945
9243	8246	0	applied	\N	\N	\N	\N	29890	29890	29891
9243	8247	1	applied	\N	\N	\N	\N	29892	29892	29893
9243	8248	2	applied	\N	\N	\N	\N	29894	29894	29895
9245	8246	0	applied	\N	\N	\N	\N	29890	29890	29891
9245	8247	1	applied	\N	\N	\N	\N	29892	29892	29893
9245	8248	2	applied	\N	\N	\N	\N	29894	29894	29895
9247	8269	10	applied	\N	\N	\N	\N	29946	29946	29947
9247	8270	11	applied	\N	\N	\N	\N	29948	29948	29949
9247	8271	12	applied	\N	\N	\N	\N	29950	29950	29951
9247	8272	13	applied	\N	\N	\N	\N	29952	29952	29953
9247	8273	14	applied	\N	\N	\N	\N	29954	29954	29955
9247	8274	15	applied	\N	\N	\N	\N	29956	29956	29957
9247	8275	16	applied	\N	\N	\N	\N	29958	29958	29959
9247	8276	17	applied	\N	\N	\N	\N	29960	29960	29961
9247	8277	18	applied	\N	\N	\N	\N	29962	29962	29963
9247	8278	19	applied	\N	\N	\N	\N	29964	29964	29965
9248	8279	0	applied	\N	\N	\N	\N	29968	29968	29969
9248	8280	1	applied	\N	\N	\N	\N	29970	29970	29971
9248	8281	2	applied	\N	\N	\N	\N	29972	29972	29973
9248	8282	3	applied	\N	\N	\N	\N	29974	29974	29975
9248	8283	4	applied	\N	\N	\N	\N	29976	29976	29977
9248	8284	5	applied	\N	\N	\N	\N	29978	29978	29979
9248	8285	6	applied	\N	\N	\N	\N	29980	29980	29981
9248	8286	7	applied	\N	\N	\N	\N	29982	29982	29983
9249	8287	0	applied	\N	\N	\N	\N	29985	29985	29986
9249	8288	1	applied	\N	\N	\N	\N	29987	29987	29988
9249	8289	2	applied	\N	\N	\N	\N	29989	29989	29990
9249	8290	3	applied	\N	\N	\N	\N	29991	29991	29992
9249	8291	4	applied	\N	\N	\N	\N	29993	29993	29994
9249	8292	5	applied	\N	\N	\N	\N	29995	29995	29996
9249	8293	6	applied	\N	\N	\N	\N	29997	29997	29998
9249	8294	7	applied	\N	\N	\N	\N	29999	29999	30000
9249	8295	8	applied	\N	\N	\N	\N	30001	30001	30002
9249	8296	9	applied	\N	\N	\N	\N	30003	30003	30004
9249	8297	10	applied	\N	\N	\N	\N	30005	30005	30006
9249	8298	11	applied	\N	\N	\N	\N	30007	30007	30008
9249	8299	12	applied	\N	\N	\N	\N	30009	30009	30010
9249	8300	13	applied	\N	\N	\N	\N	30011	30011	30012
9249	8301	14	applied	\N	\N	\N	\N	30013	30013	30014
9249	8302	15	applied	\N	\N	\N	\N	30015	30015	30016
9250	8303	0	applied	\N	\N	\N	\N	30019	30019	30020
9250	8304	1	applied	\N	\N	\N	\N	30021	30021	30022
9250	8305	2	applied	\N	\N	\N	\N	30023	30023	30024
9250	8306	3	applied	\N	\N	\N	\N	30025	30025	30026
9250	8307	4	applied	\N	\N	\N	\N	30027	30027	30028
9250	8308	5	applied	\N	\N	\N	\N	30029	30029	30030
9250	8309	7	applied	\N	\N	\N	\N	30032	30032	30033
9250	8310	8	applied	\N	\N	\N	\N	30034	30034	30035
9250	8311	9	applied	\N	\N	\N	\N	30036	30036	30037
9250	8312	10	applied	\N	\N	\N	\N	30038	30038	30039
9250	8313	11	applied	\N	\N	\N	\N	30040	30040	30041
9250	8314	12	applied	\N	\N	\N	\N	30042	30042	30043
9250	8315	13	applied	\N	\N	\N	\N	30044	30044	30045
9250	8316	14	applied	\N	\N	\N	\N	30046	30046	30047
9250	8317	15	applied	\N	\N	\N	\N	30048	30048	30049
9250	8318	16	applied	\N	\N	\N	\N	30050	30050	30051
9250	8319	17	applied	\N	\N	\N	\N	30052	30052	30053
9250	8320	18	applied	\N	\N	\N	\N	30054	30054	30055
9250	8321	19	applied	\N	\N	\N	\N	30056	30056	30057
9250	8322	20	applied	\N	\N	\N	\N	30058	30058	30059
9250	8323	21	applied	\N	\N	\N	\N	30060	30060	30061
9250	8324	22	applied	\N	\N	\N	\N	30062	30062	30063
9250	8325	23	applied	\N	\N	\N	\N	30064	30064	30065
9250	8326	24	applied	\N	\N	\N	\N	30066	30066	30067
9251	8303	0	applied	\N	\N	\N	\N	30019	30019	30020
9251	8304	1	applied	\N	\N	\N	\N	30021	30021	30022
9251	8305	2	applied	\N	\N	\N	\N	30023	30023	30024
9251	8306	3	applied	\N	\N	\N	\N	30025	30025	30026
9251	8307	4	applied	\N	\N	\N	\N	30027	30027	30028
9251	8308	5	applied	\N	\N	\N	\N	30029	30029	30030
9251	8309	7	applied	\N	\N	\N	\N	30032	30032	30033
9251	8310	8	applied	\N	\N	\N	\N	30034	30034	30035
9251	8311	9	applied	\N	\N	\N	\N	30036	30036	30037
9251	8312	10	applied	\N	\N	\N	\N	30038	30038	30039
9251	8313	11	applied	\N	\N	\N	\N	30040	30040	30041
9251	8314	12	applied	\N	\N	\N	\N	30042	30042	30043
9251	8315	13	applied	\N	\N	\N	\N	30044	30044	30045
9251	8316	14	applied	\N	\N	\N	\N	30046	30046	30047
9251	8317	15	applied	\N	\N	\N	\N	30048	30048	30049
9251	8318	16	applied	\N	\N	\N	\N	30050	30050	30051
9251	8319	17	applied	\N	\N	\N	\N	30052	30052	30053
9251	8320	18	applied	\N	\N	\N	\N	30054	30054	30055
9251	8321	19	applied	\N	\N	\N	\N	30056	30056	30057
9251	8322	20	applied	\N	\N	\N	\N	30058	30058	30059
9251	8323	21	applied	\N	\N	\N	\N	30060	30060	30061
9251	8324	22	applied	\N	\N	\N	\N	30062	30062	30063
9251	8325	23	applied	\N	\N	\N	\N	30064	30064	30065
9251	8326	24	applied	\N	\N	\N	\N	30066	30066	30067
9252	8111	0	applied	\N	\N	\N	\N	29500	29500	29501
9252	8112	1	applied	\N	\N	\N	\N	29502	29502	29503
9252	8159	2	applied	\N	\N	\N	\N	29638	29638	29639
9252	8113	3	applied	\N	\N	\N	\N	29504	29504	29505
9252	8116	4	applied	\N	\N	\N	\N	29512	29512	29513
9252	8117	5	applied	\N	\N	\N	\N	29516	29516	29517
9252	8120	6	applied	\N	\N	\N	\N	29525	29525	29526
9252	8163	7	applied	\N	\N	\N	\N	29648	29648	29649
9252	8248	8	applied	\N	\N	\N	\N	29894	29894	29895
9252	8250	9	applied	\N	\N	\N	\N	29906	29906	29907
9252	8123	10	applied	\N	\N	\N	\N	29533	29533	29534
9252	8164	11	applied	\N	\N	\N	\N	29650	29650	29651
9252	8165	12	applied	\N	\N	\N	\N	29652	29652	29653
9252	8166	13	applied	\N	\N	\N	\N	29654	29654	29655
9252	8168	14	applied	\N	\N	\N	\N	29660	29660	29661
9252	8170	15	applied	\N	\N	\N	\N	29664	29664	29665
9252	8327	16	applied	\N	\N	\N	\N	30073	30073	29736
9252	8114	17	applied	\N	\N	\N	\N	29506	29506	29507
9252	8115	18	applied	\N	\N	\N	\N	29510	29510	29511
9252	8118	19	applied	\N	\N	\N	\N	29518	29518	29519
9252	8119	20	applied	\N	\N	\N	\N	29523	29523	29524
9252	8122	21	applied	\N	\N	\N	\N	29531	29531	29532
9252	8126	22	applied	\N	\N	\N	\N	29540	29540	29541
9252	8127	23	applied	\N	\N	\N	\N	29542	29542	29543
9252	8132	24	applied	\N	\N	\N	\N	29551	29551	29552
9252	8134	25	applied	\N	\N	\N	\N	29561	29561	29562
9252	8138	26	applied	\N	\N	\N	\N	29570	29570	29571
9252	8139	27	applied	\N	\N	\N	\N	29572	29572	29573
9252	8141	28	applied	\N	\N	\N	\N	29586	29586	29587
9252	8142	29	applied	\N	\N	\N	\N	29588	29588	29589
9252	8144	30	applied	\N	\N	\N	\N	29592	29592	29593
9252	8145	31	applied	\N	\N	\N	\N	29594	29594	29595
9252	8146	32	applied	\N	\N	\N	\N	29596	29596	29597
9252	8150	33	applied	\N	\N	\N	\N	29606	29606	29607
9252	8151	34	applied	\N	\N	\N	\N	29610	29610	29611
9252	8152	35	applied	\N	\N	\N	\N	29612	29612	29613
9252	8157	36	applied	\N	\N	\N	\N	29628	29628	29629
9252	8158	37	applied	\N	\N	\N	\N	29630	29630	29631
9252	8160	38	applied	\N	\N	\N	\N	29640	29640	29641
9252	8167	39	applied	\N	\N	\N	\N	29656	29656	29657
9252	8171	40	applied	\N	\N	\N	\N	29666	29666	29667
9252	8174	41	applied	\N	\N	\N	\N	29687	29687	29688
9252	8176	42	applied	\N	\N	\N	\N	29692	29692	29693
9252	8177	44	applied	\N	\N	\N	\N	29694	29694	29695
9252	8180	45	applied	\N	\N	\N	\N	29702	29702	29703
9252	8182	46	applied	\N	\N	\N	\N	29708	29708	29709
9252	8183	47	applied	\N	\N	\N	\N	29711	29711	29712
9252	8328	48	applied	\N	\N	\N	\N	30075	30075	29738
9252	8189	49	applied	\N	\N	\N	\N	29725	29725	29726
9252	8190	50	applied	\N	\N	\N	\N	29727	29727	29728
9252	8191	51	applied	\N	\N	\N	\N	29729	29729	29730
9252	8192	52	applied	\N	\N	\N	\N	29731	29731	29732
9252	8195	53	applied	\N	\N	\N	\N	29739	29739	29740
9252	8197	54	applied	\N	\N	\N	\N	29745	29745	29746
9252	8199	55	applied	\N	\N	\N	\N	29751	29751	29752
9252	8201	56	applied	\N	\N	\N	\N	29755	29755	29756
9252	8204	57	applied	\N	\N	\N	\N	29762	29762	29763
9252	8206	58	applied	\N	\N	\N	\N	29766	29766	29767
9252	8208	59	applied	\N	\N	\N	\N	29778	29778	29779
9252	8209	60	applied	\N	\N	\N	\N	29780	29780	29781
9252	8210	61	applied	\N	\N	\N	\N	29782	29782	29783
9252	8214	62	applied	\N	\N	\N	\N	29795	29795	29796
9252	8215	63	applied	\N	\N	\N	\N	29797	29797	29798
9252	8219	64	applied	\N	\N	\N	\N	29809	29809	29810
9252	8221	65	applied	\N	\N	\N	\N	29816	29816	29817
9252	8130	66	applied	\N	\N	\N	\N	29546	29546	29547
9252	8131	67	applied	\N	\N	\N	\N	29548	29548	29549
9252	8133	68	applied	\N	\N	\N	\N	29553	29553	29554
9252	8135	69	applied	\N	\N	\N	\N	29563	29563	29564
9252	8136	70	applied	\N	\N	\N	\N	29565	29565	29566
9252	8137	71	applied	\N	\N	\N	\N	29567	29567	29568
9252	8140	72	applied	\N	\N	\N	\N	29584	29584	29585
9252	8143	73	applied	\N	\N	\N	\N	29590	29590	29591
9252	8147	74	applied	\N	\N	\N	\N	29598	29598	29599
9252	8148	75	applied	\N	\N	\N	\N	29600	29600	29601
9252	8149	76	applied	\N	\N	\N	\N	29604	29604	29605
9252	8153	77	applied	\N	\N	\N	\N	29614	29614	29615
9252	8154	78	applied	\N	\N	\N	\N	29616	29616	29617
9252	8155	79	applied	\N	\N	\N	\N	29624	29624	29625
9252	8156	80	applied	\N	\N	\N	\N	29626	29626	29627
9252	8161	81	applied	\N	\N	\N	\N	29642	29642	29643
9252	8162	82	applied	\N	\N	\N	\N	29646	29646	29647
9252	8169	83	applied	\N	\N	\N	\N	29662	29662	29663
9252	8173	84	applied	\N	\N	\N	\N	29685	29685	29686
9252	8175	85	applied	\N	\N	\N	\N	29690	29690	29691
9252	8178	86	applied	\N	\N	\N	\N	29696	29696	29697
9252	8179	87	applied	\N	\N	\N	\N	29700	29700	29701
9252	8181	88	applied	\N	\N	\N	\N	29706	29706	29707
9252	8184	89	applied	\N	\N	\N	\N	29713	29713	29714
9252	8185	90	applied	\N	\N	\N	\N	29717	29717	29718
9252	8186	91	applied	\N	\N	\N	\N	29719	29719	29720
9252	8187	92	applied	\N	\N	\N	\N	29721	29721	29722
9252	8188	93	applied	\N	\N	\N	\N	29723	29723	29724
9252	8196	94	applied	\N	\N	\N	\N	29741	29741	29742
9252	8198	95	applied	\N	\N	\N	\N	29747	29747	29748
9252	8200	96	applied	\N	\N	\N	\N	29753	29753	29754
9252	8202	97	applied	\N	\N	\N	\N	29757	29757	29758
9252	8205	98	applied	\N	\N	\N	\N	29764	29764	29765
9252	8207	99	applied	\N	\N	\N	\N	29768	29768	29769
9252	8252	100	applied	\N	\N	\N	\N	29910	29910	29911
9252	8253	101	applied	\N	\N	\N	\N	29912	29912	29913
9252	8254	102	applied	\N	\N	\N	\N	29914	29914	29915
9252	8255	103	applied	\N	\N	\N	\N	29916	29916	29917
9252	8256	104	applied	\N	\N	\N	\N	29918	29918	29919
9252	8264	105	applied	\N	\N	\N	\N	29936	29936	29937
9252	8265	106	applied	\N	\N	\N	\N	29938	29938	29939
9252	8267	107	applied	\N	\N	\N	\N	29942	29942	29943
9252	8268	108	applied	\N	\N	\N	\N	29944	29944	29945
9252	8269	109	applied	\N	\N	\N	\N	29946	29946	29947
9252	8270	110	applied	\N	\N	\N	\N	29948	29948	29949
9252	8271	111	applied	\N	\N	\N	\N	29950	29950	29951
9252	8272	112	applied	\N	\N	\N	\N	29952	29952	29953
9252	8273	113	applied	\N	\N	\N	\N	29954	29954	29955
9252	8274	114	applied	\N	\N	\N	\N	29956	29956	29957
9252	8275	115	applied	\N	\N	\N	\N	29958	29958	29959
9252	8276	116	applied	\N	\N	\N	\N	29960	29960	29961
9252	8277	117	applied	\N	\N	\N	\N	29962	29962	29963
9252	8278	118	applied	\N	\N	\N	\N	29964	29964	29965
9252	8281	119	applied	\N	\N	\N	\N	29972	29972	29973
9252	8282	120	applied	\N	\N	\N	\N	29974	29974	29975
9252	8283	121	applied	\N	\N	\N	\N	29976	29976	29977
9252	8284	122	applied	\N	\N	\N	\N	29978	29978	29979
9252	8285	123	applied	\N	\N	\N	\N	29980	29980	29981
9252	8286	124	applied	\N	\N	\N	\N	29982	29982	29983
9252	8291	125	applied	\N	\N	\N	\N	29993	29993	29994
9258	8336	0	applied	\N	\N	\N	\N	30096	30096	30097
9258	8337	1	applied	\N	\N	\N	\N	30098	30098	30099
9258	8338	2	applied	\N	\N	\N	\N	30100	30100	30101
9258	8339	3	applied	\N	\N	\N	\N	30102	30102	30103
9258	8340	4	applied	\N	\N	\N	\N	30104	30104	30105
9258	8341	5	applied	\N	\N	\N	\N	30106	30106	30107
9258	8342	6	applied	\N	\N	\N	\N	30108	30108	30109
9258	8343	7	applied	\N	\N	\N	\N	30110	30110	30111
9260	8344	0	applied	\N	\N	\N	\N	30117	30117	30118
9260	8345	1	applied	\N	\N	\N	\N	30119	30119	30120
9260	8346	2	applied	\N	\N	\N	\N	30121	30121	30122
9260	8347	3	applied	\N	\N	\N	\N	30123	30123	30124
9260	8348	4	applied	\N	\N	\N	\N	30125	30125	30126
9260	8349	5	applied	\N	\N	\N	\N	30127	30127	30128
9260	8350	6	applied	\N	\N	\N	\N	30129	30129	30130
9260	8351	7	applied	\N	\N	\N	\N	30131	30131	30132
9262	8352	0	applied	\N	\N	\N	\N	30137	30137	30138
9262	8353	1	applied	\N	\N	\N	\N	30139	30139	30140
9262	8354	2	applied	\N	\N	\N	\N	30141	30141	30142
9262	8355	3	applied	\N	\N	\N	\N	30143	30143	30144
9262	8356	4	applied	\N	\N	\N	\N	30145	30145	30146
9262	8357	5	applied	\N	\N	\N	\N	30147	30147	30148
9262	8358	6	applied	\N	\N	\N	\N	30149	30149	30150
9262	8359	7	applied	\N	\N	\N	\N	30151	30151	30152
9270	8395	0	applied	\N	\N	\N	\N	30232	30232	30233
9270	8396	1	applied	\N	\N	\N	\N	30234	30234	30235
9270	8397	2	applied	\N	\N	\N	\N	30236	30236	30237
9273	8395	0	applied	\N	\N	\N	\N	30232	30232	30233
9273	8396	1	applied	\N	\N	\N	\N	30234	30234	30235
9273	8397	2	applied	\N	\N	\N	\N	30236	30236	30237
9274	8398	0	applied	\N	\N	\N	\N	30242	30242	30243
9274	8399	1	applied	\N	\N	\N	\N	30244	30244	30245
9279	8406	0	applied	\N	\N	\N	\N	30267	30267	30268
9253	8303	0	applied	\N	\N	\N	\N	30019	30019	30020
9253	8304	1	applied	\N	\N	\N	\N	30021	30021	30022
9253	8305	2	applied	\N	\N	\N	\N	30023	30023	30024
9253	8306	3	applied	\N	\N	\N	\N	30025	30025	30026
9253	8307	4	applied	\N	\N	\N	\N	30027	30027	30028
9253	8308	5	applied	\N	\N	\N	\N	30029	30029	30030
9253	8309	7	applied	\N	\N	\N	\N	30032	30032	30033
9253	8310	8	applied	\N	\N	\N	\N	30034	30034	30035
9253	8311	9	applied	\N	\N	\N	\N	30036	30036	30037
9253	8312	10	applied	\N	\N	\N	\N	30038	30038	30039
9253	8313	11	applied	\N	\N	\N	\N	30040	30040	30041
9253	8314	12	applied	\N	\N	\N	\N	30042	30042	30043
9253	8315	13	applied	\N	\N	\N	\N	30044	30044	30045
9253	8316	14	applied	\N	\N	\N	\N	30046	30046	30047
9253	8317	15	applied	\N	\N	\N	\N	30048	30048	30049
9253	8318	16	applied	\N	\N	\N	\N	30050	30050	30051
9253	8319	17	applied	\N	\N	\N	\N	30052	30052	30053
9253	8320	18	applied	\N	\N	\N	\N	30054	30054	30055
9253	8321	19	applied	\N	\N	\N	\N	30056	30056	30057
9253	8322	20	applied	\N	\N	\N	\N	30058	30058	30059
9253	8323	21	applied	\N	\N	\N	\N	30060	30060	30061
9253	8324	22	applied	\N	\N	\N	\N	30062	30062	30063
9253	8325	23	applied	\N	\N	\N	\N	30064	30064	30065
9253	8326	24	applied	\N	\N	\N	\N	30066	30066	30067
9254	8329	0	applied	\N	\N	\N	\N	30081	30081	30082
9254	8330	1	applied	\N	\N	\N	\N	30083	30083	30084
9254	8331	2	applied	\N	\N	\N	\N	30085	30085	30086
9254	8332	3	applied	\N	\N	\N	\N	30087	30087	30088
9254	8333	4	applied	\N	\N	\N	\N	30089	30089	30090
9254	8334	5	applied	\N	\N	\N	\N	30091	30091	30092
9254	8335	6	applied	\N	\N	\N	\N	30093	30093	30094
9256	8336	0	applied	\N	\N	\N	\N	30096	30096	30097
9256	8337	1	applied	\N	\N	\N	\N	30098	30098	30099
9256	8338	2	applied	\N	\N	\N	\N	30100	30100	30101
9256	8339	3	applied	\N	\N	\N	\N	30102	30102	30103
9256	8340	4	applied	\N	\N	\N	\N	30104	30104	30105
9256	8341	5	applied	\N	\N	\N	\N	30106	30106	30107
9256	8342	6	applied	\N	\N	\N	\N	30108	30108	30109
9256	8343	7	applied	\N	\N	\N	\N	30110	30110	30111
9261	8344	0	applied	\N	\N	\N	\N	30117	30117	30118
9261	8345	1	applied	\N	\N	\N	\N	30119	30119	30120
9261	8346	2	applied	\N	\N	\N	\N	30121	30121	30122
9261	8347	3	applied	\N	\N	\N	\N	30123	30123	30124
9261	8348	4	applied	\N	\N	\N	\N	30125	30125	30126
9261	8349	5	applied	\N	\N	\N	\N	30127	30127	30128
9261	8350	6	applied	\N	\N	\N	\N	30129	30129	30130
9261	8351	7	applied	\N	\N	\N	\N	30131	30131	30132
9263	8360	0	applied	\N	\N	\N	\N	30155	30155	30156
9263	8361	1	applied	\N	\N	\N	\N	30157	30157	30158
9263	8362	2	applied	\N	\N	\N	\N	30159	30159	30160
9263	8363	3	applied	\N	\N	\N	\N	30161	30161	30162
9263	8364	4	applied	\N	\N	\N	\N	30163	30163	30164
9263	8365	5	applied	\N	\N	\N	\N	30165	30165	30166
9263	8366	6	applied	\N	\N	\N	\N	30167	30167	30168
9263	8367	7	applied	\N	\N	\N	\N	30169	30169	30170
9263	8368	8	applied	\N	\N	\N	\N	30171	30171	30172
9263	8369	9	applied	\N	\N	\N	\N	30173	30173	30174
9263	8370	10	applied	\N	\N	\N	\N	30175	30175	30176
9263	8371	11	applied	\N	\N	\N	\N	30177	30177	30178
9263	8372	12	applied	\N	\N	\N	\N	30179	30179	30180
9263	8373	13	applied	\N	\N	\N	\N	30181	30181	30182
9263	8374	14	applied	\N	\N	\N	\N	30183	30183	30184
9271	8395	0	applied	\N	\N	\N	\N	30232	30232	30233
9271	8396	1	applied	\N	\N	\N	\N	30234	30234	30235
9271	8397	2	applied	\N	\N	\N	\N	30236	30236	30237
9275	8400	0	applied	\N	\N	\N	\N	30247	30247	30248
9275	8401	1	applied	\N	\N	\N	\N	30249	30249	30250
9277	8402	0	applied	\N	\N	\N	\N	30255	30255	30256
9277	8403	1	applied	\N	\N	\N	\N	30257	30257	30258
9280	8406	0	applied	\N	\N	\N	\N	30267	30267	30268
9280	8407	1	applied	\N	\N	\N	\N	30269	30269	30270
9284	8410	0	applied	\N	\N	\N	\N	30281	30281	30282
9284	8411	1	applied	\N	\N	\N	\N	30283	30283	30284
9287	8415	0	applied	\N	\N	\N	\N	30294	30294	30295
9287	8416	1	applied	\N	\N	\N	\N	30296	30296	30297
9289	8419	0	applied	\N	\N	\N	\N	30304	30304	30305
9289	8420	1	applied	\N	\N	\N	\N	30306	30306	30307
9292	8421	0	applied	\N	\N	\N	\N	30314	30314	30315
9292	8422	1	applied	\N	\N	\N	\N	30316	30316	30317
9292	8423	2	applied	\N	\N	\N	\N	30318	30318	30319
9292	8424	3	applied	\N	\N	\N	\N	30320	30320	30321
9294	8428	0	applied	\N	\N	\N	\N	30331	30331	30332
9294	8429	1	applied	\N	\N	\N	\N	30333	30333	30334
9297	8432	0	applied	\N	\N	\N	\N	30344	30344	30345
9297	8433	1	applied	\N	\N	\N	\N	30346	30346	30347
9303	8444	0	applied	\N	\N	\N	\N	30377	30377	30378
9303	8445	1	applied	\N	\N	\N	\N	30379	30379	30380
9306	8454	0	applied	\N	\N	\N	\N	30405	30405	30406
9306	8455	1	applied	\N	\N	\N	\N	30407	30407	30408
9306	8456	2	applied	\N	\N	\N	\N	30409	30409	30410
9306	8457	3	applied	\N	\N	1000000000	\N	30411	30411	30412
9315	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9315	8465	1	applied	\N	\N	\N	\N	30440	30440	30441
9315	8466	2	applied	\N	\N	\N	\N	30442	30442	30443
9315	8464	3	applied	\N	\N	\N	\N	30431	30431	30431
9323	8475	0	applied	\N	\N	\N	\N	30472	30472	30473
9323	8476	1	applied	\N	\N	\N	\N	30474	30474	30475
9323	8477	2	applied	\N	\N	\N	\N	30476	30476	30477
9323	8478	3	applied	\N	\N	\N	\N	30478	30478	30479
9326	8481	0	applied	\N	\N	\N	\N	30490	30490	30491
9326	8482	1	applied	\N	\N	\N	\N	30492	30492	1435
9326	8483	2	applied	\N	\N	\N	\N	30493	30493	30494
9326	8484	3	applied	\N	\N	\N	\N	30495	30495	30496
9326	8485	4	applied	\N	\N	\N	\N	30497	30497	30498
9329	8491	0	applied	\N	\N	\N	\N	30512	30512	30513
9329	8492	1	applied	\N	\N	\N	\N	30514	30514	30515
9331	8493	0	applied	\N	\N	\N	\N	30518	30518	30519
9331	8494	1	applied	\N	\N	\N	\N	30520	30520	30521
9334	8499	0	applied	\N	\N	\N	\N	30534	30534	30535
9334	8500	1	applied	\N	\N	\N	\N	30536	30536	30537
9334	8501	2	applied	\N	\N	\N	\N	30538	30538	30539
9334	8502	3	applied	\N	\N	\N	\N	30540	30540	30431
9339	8510	0	applied	\N	\N	\N	\N	30565	30565	30566
9339	8511	1	applied	\N	\N	\N	\N	30567	30567	30568
9344	8514	0	applied	\N	\N	\N	\N	30576	30576	30577
9344	8515	1	applied	\N	\N	\N	\N	30578	30578	30579
9346	8518	0	applied	\N	\N	\N	\N	30588	30588	30589
9346	8519	1	applied	\N	\N	\N	\N	30590	30590	30591
9351	8528	0	applied	\N	\N	\N	\N	30615	30615	30616
9351	8529	1	applied	\N	\N	\N	\N	30617	30617	30618
9255	8329	0	applied	\N	\N	\N	\N	30081	30081	30082
9255	8330	1	applied	\N	\N	\N	\N	30083	30083	30084
9255	8331	2	applied	\N	\N	\N	\N	30085	30085	30086
9255	8332	3	applied	\N	\N	\N	\N	30087	30087	30088
9255	8333	4	applied	\N	\N	\N	\N	30089	30089	30090
9255	8334	5	applied	\N	\N	\N	\N	30091	30091	30092
9255	8335	6	applied	\N	\N	\N	\N	30093	30093	30094
9257	8336	0	applied	\N	\N	\N	\N	30096	30096	30097
9257	8337	1	applied	\N	\N	\N	\N	30098	30098	30099
9257	8338	2	applied	\N	\N	\N	\N	30100	30100	30101
9257	8339	3	applied	\N	\N	\N	\N	30102	30102	30103
9257	8340	4	applied	\N	\N	\N	\N	30104	30104	30105
9257	8341	5	applied	\N	\N	\N	\N	30106	30106	30107
9257	8342	6	applied	\N	\N	\N	\N	30108	30108	30109
9257	8343	7	applied	\N	\N	\N	\N	30110	30110	30111
9259	8336	0	applied	\N	\N	\N	\N	30096	30096	30097
9259	8337	1	applied	\N	\N	\N	\N	30098	30098	30099
9259	8338	2	applied	\N	\N	\N	\N	30100	30100	30101
9259	8339	3	applied	\N	\N	\N	\N	30102	30102	30103
9259	8340	4	applied	\N	\N	\N	\N	30104	30104	30105
9259	8341	5	applied	\N	\N	\N	\N	30106	30106	30107
9259	8342	6	applied	\N	\N	\N	\N	30108	30108	30109
9259	8343	7	applied	\N	\N	\N	\N	30110	30110	30111
9264	8360	0	applied	\N	\N	\N	\N	30155	30155	30156
9264	8361	1	applied	\N	\N	\N	\N	30157	30157	30158
9264	8362	2	applied	\N	\N	\N	\N	30159	30159	30160
9264	8363	3	applied	\N	\N	\N	\N	30161	30161	30162
9264	8364	4	applied	\N	\N	\N	\N	30163	30163	30164
9264	8365	5	applied	\N	\N	\N	\N	30165	30165	30166
9264	8366	6	applied	\N	\N	\N	\N	30167	30167	30168
9264	8367	7	applied	\N	\N	\N	\N	30169	30169	30170
9264	8368	8	applied	\N	\N	\N	\N	30171	30171	30172
9264	8369	9	applied	\N	\N	\N	\N	30173	30173	30174
9264	8370	10	applied	\N	\N	\N	\N	30175	30175	30176
9264	8371	11	applied	\N	\N	\N	\N	30177	30177	30178
9264	8372	12	applied	\N	\N	\N	\N	30179	30179	30180
9264	8373	13	applied	\N	\N	\N	\N	30181	30181	30182
9264	8374	14	applied	\N	\N	\N	\N	30183	30183	30184
9267	8375	0	applied	\N	\N	\N	\N	30190	30190	1435
9268	8376	0	applied	\N	\N	\N	\N	30192	30192	30193
9268	8375	1	applied	\N	\N	\N	\N	30190	30190	1435
9268	8377	2	applied	\N	\N	\N	\N	30194	30194	30195
9268	8378	3	applied	\N	\N	\N	\N	30196	30196	30197
9268	8379	4	applied	\N	\N	\N	\N	30198	30198	30199
9268	8380	5	applied	\N	\N	\N	\N	30200	30200	30201
9268	8381	6	applied	\N	\N	\N	\N	30202	30202	30203
9268	8382	7	applied	\N	\N	\N	\N	30204	30204	30205
9268	8383	8	applied	\N	\N	\N	\N	30206	30206	30207
9269	8384	0	applied	\N	\N	\N	\N	30210	30210	30211
9269	8385	1	applied	\N	\N	\N	\N	30212	30212	30213
9269	8386	2	applied	\N	\N	\N	\N	30214	30214	30215
9269	8387	3	applied	\N	\N	\N	\N	30216	30216	30217
9269	8388	4	applied	\N	\N	\N	\N	30218	30218	30219
9269	8389	5	applied	\N	\N	\N	\N	30220	30220	30221
9269	8390	6	applied	\N	\N	\N	\N	30222	30222	30223
9269	8391	7	applied	\N	\N	\N	\N	30224	30224	30225
9269	8392	8	applied	\N	\N	\N	\N	30226	30226	30227
9269	8393	9	applied	\N	\N	\N	\N	30228	30228	30229
9269	8394	10	applied	\N	\N	\N	\N	30230	30230	27110
9272	8395	0	applied	\N	\N	\N	\N	30232	30232	30233
9272	8396	1	applied	\N	\N	\N	\N	30234	30234	30235
9272	8397	2	applied	\N	\N	\N	\N	30236	30236	30237
9276	8400	0	applied	\N	\N	\N	\N	30247	30247	30248
9276	8401	1	applied	\N	\N	\N	\N	30249	30249	30250
9278	8404	0	applied	\N	\N	\N	\N	30261	30261	30262
9278	8405	1	applied	\N	\N	\N	\N	30263	30263	30264
9281	8408	0	applied	\N	\N	\N	\N	30274	30274	30275
9281	8409	1	applied	\N	\N	\N	\N	30276	30276	30277
9283	8408	0	applied	\N	\N	\N	\N	30274	30274	30275
9283	8409	1	applied	\N	\N	\N	\N	30276	30276	30277
9285	8411	0	applied	\N	\N	\N	\N	30283	30283	30284
9288	8417	0	applied	\N	\N	\N	\N	30298	30298	30299
9288	8418	1	applied	\N	\N	\N	\N	30300	30300	30301
9290	8419	0	applied	\N	\N	\N	\N	30304	30304	30305
9290	8420	1	applied	\N	\N	\N	\N	30306	30306	30307
9291	7969	0	applied	\N	\N	\N	\N	29090	29090	1435
9291	7956	1	applied	\N	\N	\N	\N	29060	29060	29061
9291	7999	2	applied	\N	\N	\N	\N	29174	29174	29175
9291	7980	3	applied	\N	\N	\N	\N	29118	29118	29119
9291	7949	4	applied	\N	\N	1000000000	\N	29045	29045	29046
9291	8159	5	applied	\N	\N	\N	\N	29673	29673	29639
9291	7890	6	applied	\N	\N	\N	\N	28874	28874	28875
9291	7893	7	applied	\N	\N	\N	\N	28885	28885	28886
9291	7894	8	applied	\N	\N	\N	\N	28887	28887	28888
9291	7897	9	applied	\N	\N	\N	\N	28893	28893	28894
9291	7900	10	applied	\N	\N	\N	\N	28904	28904	28905
9291	7901	11	applied	\N	\N	\N	\N	28908	28908	28909
9291	7903	12	applied	\N	\N	\N	\N	28912	28912	28913
9291	7891	13	applied	\N	\N	\N	\N	28876	28876	28877
9291	7915	14	applied	\N	\N	\N	\N	28950	28950	28951
9291	8163	15	applied	\N	\N	\N	\N	29674	29674	29649
9291	8248	17	applied	\N	\N	\N	\N	29894	29894	29895
9291	8250	18	applied	\N	\N	\N	\N	29906	29906	29907
9291	7990	19	applied	\N	\N	1000000000	\N	29145	29145	29146
9291	8164	20	applied	\N	\N	\N	\N	29675	29675	29651
9291	8165	21	applied	\N	\N	\N	\N	29676	29676	29653
9291	8166	22	applied	\N	\N	\N	\N	29677	29677	29655
9291	8168	23	applied	\N	\N	\N	\N	29678	29678	29661
9291	8170	24	applied	\N	\N	\N	\N	29679	29679	29665
9291	7983	25	applied	\N	\N	\N	\N	29125	29125	29126
9291	7984	26	applied	\N	\N	\N	\N	29127	29127	29128
9291	8252	27	applied	\N	\N	\N	\N	29910	29910	29911
9291	8253	28	applied	\N	\N	\N	\N	29912	29912	29913
9291	8254	29	applied	\N	\N	\N	\N	29914	29914	29915
9291	8255	30	applied	\N	\N	\N	\N	29916	29916	29917
9291	8256	31	applied	\N	\N	\N	\N	29918	29918	29919
9291	8264	32	applied	\N	\N	\N	\N	29936	29936	29937
9291	8265	33	applied	\N	\N	\N	\N	29938	29938	29939
9291	8267	34	applied	\N	\N	\N	\N	29942	29942	29943
9291	8268	35	applied	\N	\N	\N	\N	29944	29944	29945
9291	8269	36	applied	\N	\N	\N	\N	29946	29946	29947
9291	8270	37	applied	\N	\N	\N	\N	29948	29948	29949
9291	8271	38	applied	\N	\N	\N	\N	29950	29950	29951
9291	8272	39	applied	\N	\N	\N	\N	29952	29952	29953
9291	8273	40	applied	\N	\N	\N	\N	29954	29954	29955
9291	8274	41	applied	\N	\N	\N	\N	29956	29956	29957
9291	8275	42	applied	\N	\N	\N	\N	29958	29958	29959
9291	8276	43	applied	\N	\N	\N	\N	29960	29960	29961
9291	8277	44	applied	\N	\N	\N	\N	29962	29962	29963
9279	8407	1	applied	\N	\N	\N	\N	30269	30269	30270
9282	8408	0	applied	\N	\N	\N	\N	30274	30274	30275
9282	8409	1	applied	\N	\N	\N	\N	30276	30276	30277
9286	8412	0	applied	\N	\N	\N	\N	30287	30287	30288
9286	8413	1	applied	\N	\N	\N	\N	30289	30289	30290
9286	8414	2	applied	\N	\N	\N	\N	30291	30291	30292
9302	8444	0	applied	\N	\N	\N	\N	30377	30377	30378
9302	8445	1	applied	\N	\N	\N	\N	30379	30379	30380
9308	8458	0	applied	\N	\N	\N	\N	30416	30416	30417
9308	8459	1	applied	\N	\N	\N	\N	30418	30418	30419
9308	8460	2	applied	\N	\N	\N	\N	30420	30420	30421
9308	8461	3	applied	\N	\N	\N	\N	30422	30422	30423
9311	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9311	8463	1	applied	\N	\N	\N	\N	30429	30429	30430
9311	8464	2	applied	\N	\N	\N	\N	30431	30431	30431
9313	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9313	8463	1	applied	\N	\N	\N	\N	30429	30429	30430
9313	8464	2	applied	\N	\N	\N	\N	30431	30431	30431
9317	8467	0	applied	\N	\N	\N	\N	30448	30448	30449
9317	8468	1	applied	\N	\N	\N	\N	30450	30450	30451
9320	8467	0	applied	\N	\N	\N	\N	30448	30448	30449
9320	8468	1	applied	\N	\N	\N	\N	30450	30450	30451
9322	8469	0	applied	\N	\N	\N	\N	30458	30458	30459
9322	8470	1	applied	\N	\N	\N	\N	30460	30460	30461
9322	8471	2	applied	\N	\N	\N	\N	30462	30462	30463
9322	8472	3	applied	\N	\N	\N	\N	30464	30464	30465
9322	8473	4	applied	\N	\N	\N	\N	30466	30466	30467
9322	8474	5	applied	\N	\N	\N	\N	30468	30468	30469
9324	8479	0	applied	\N	\N	\N	\N	30482	30482	30483
9324	8480	1	applied	\N	\N	\N	\N	30484	30484	30485
9327	8486	0	applied	\N	\N	\N	\N	30500	30500	30501
9327	8487	1	applied	\N	\N	\N	\N	30502	30502	30503
9327	8488	3	applied	\N	\N	\N	\N	30505	30505	1435
9327	8489	4	applied	\N	\N	\N	\N	30506	30506	30507
9327	8490	5	applied	\N	\N	\N	\N	30508	30508	30509
9335	8499	0	applied	\N	\N	\N	\N	30534	30534	30535
9335	8500	1	applied	\N	\N	\N	\N	30536	30536	30537
9335	8501	2	applied	\N	\N	\N	\N	30538	30538	30539
9335	8503	3	applied	\N	\N	\N	\N	30543	30543	30544
9335	8504	4	applied	\N	\N	\N	\N	30545	30545	30546
9335	8505	5	applied	\N	\N	\N	\N	30547	30547	30548
9335	8502	6	applied	\N	\N	\N	\N	30540	30540	30431
9337	8508	0	applied	\N	\N	\N	\N	30557	30557	30558
9337	8509	1	applied	\N	\N	\N	\N	30559	30559	30560
9340	8510	0	applied	\N	\N	\N	\N	30565	30565	30566
9340	8511	1	applied	\N	\N	\N	\N	30567	30567	30568
9342	8514	0	applied	\N	\N	\N	\N	30576	30576	30577
9342	8515	1	applied	\N	\N	\N	\N	30578	30578	30579
9349	8520	0	applied	\N	\N	\N	\N	30597	30597	30597
9349	8521	1	applied	\N	\N	\N	\N	30598	30598	30599
9349	8522	2	applied	\N	\N	\N	\N	30600	30600	30601
9349	8523	3	applied	\N	\N	\N	\N	30602	30602	30603
9349	8524	4	applied	\N	\N	\N	\N	30604	30604	30605
9349	8525	5	applied	\N	\N	\N	\N	30606	30606	30607
9354	8530	0	applied	\N	\N	\N	\N	30625	30625	30626
9354	8531	1	applied	\N	\N	\N	\N	30627	30627	30628
9366	8537	0	applied	\N	\N	\N	\N	30646	30646	30647
9366	8538	1	applied	\N	\N	\N	\N	30648	30648	30649
9367	8539	0	applied	\N	\N	\N	\N	30656	30656	30657
9367	8540	1	applied	\N	\N	\N	\N	30658	30658	30659
9372	8547	0	applied	\N	\N	1000000000	\N	30677	30677	30678
9372	8548	1	applied	\N	\N	\N	\N	30679	30679	23829
9375	8551	0	applied	\N	\N	\N	\N	30687	30687	30688
9375	8552	1	applied	\N	\N	\N	\N	30689	30689	30690
9375	8553	2	applied	\N	\N	\N	\N	30691	30691	30692
9379	8556	0	applied	\N	\N	\N	\N	30701	30701	30702
9379	8557	1	applied	\N	\N	\N	\N	30703	30703	30704
9379	8558	2	applied	\N	\N	\N	\N	30705	30705	30706
9379	8559	4	applied	\N	\N	\N	\N	30708	30708	30709
9384	8520	0	applied	\N	\N	\N	\N	30724	30724	30724
9384	8547	1	applied	\N	\N	1000000000	\N	30677	30677	30678
9384	8482	2	applied	\N	\N	\N	\N	30492	30492	1435
9384	8292	3	applied	\N	\N	\N	\N	29995	29995	29996
9384	8293	4	applied	\N	\N	\N	\N	29997	29997	29998
9384	8294	5	applied	\N	\N	\N	\N	29999	29999	30000
9384	8488	6	applied	\N	\N	\N	\N	30725	30725	1435
9384	8295	7	applied	\N	\N	\N	\N	30001	30001	30002
9384	8296	8	applied	\N	\N	\N	\N	30003	30003	30004
9384	8297	9	applied	\N	\N	\N	\N	30005	30005	30006
9384	8298	10	applied	\N	\N	\N	\N	30007	30007	30008
9384	8299	11	applied	\N	\N	\N	\N	30009	30009	30010
9384	8300	12	applied	\N	\N	\N	\N	30011	30011	30012
9384	8301	13	applied	\N	\N	\N	\N	30013	30013	30014
9384	8302	14	applied	\N	\N	\N	\N	30015	30015	30016
9384	8307	15	applied	\N	\N	\N	\N	30027	30027	30028
9384	8308	16	applied	\N	\N	\N	\N	30029	30029	30030
9384	8309	17	applied	\N	\N	\N	\N	30032	30032	30033
9384	8311	18	applied	\N	\N	\N	\N	30036	30036	30037
9384	8312	19	applied	\N	\N	\N	\N	30038	30038	30039
9384	8313	20	applied	\N	\N	\N	\N	30040	30040	30041
9384	8314	21	applied	\N	\N	\N	\N	30042	30042	30043
9384	8315	22	applied	\N	\N	\N	\N	30044	30044	30045
9384	8317	23	applied	\N	\N	\N	\N	30048	30048	30049
9384	8318	24	applied	\N	\N	\N	\N	30050	30050	30051
9384	8319	25	applied	\N	\N	\N	\N	30052	30052	30053
9384	8320	26	applied	\N	\N	\N	\N	30054	30054	30055
9384	8321	27	applied	\N	\N	\N	\N	30056	30056	30057
9384	8322	28	applied	\N	\N	\N	\N	30058	30058	30059
9384	8323	29	applied	\N	\N	\N	\N	30060	30060	30061
9384	8324	30	applied	\N	\N	\N	\N	30062	30062	30063
9384	8325	31	applied	\N	\N	\N	\N	30064	30064	30065
9384	8326	32	applied	\N	\N	\N	\N	30066	30066	30067
9384	8331	33	applied	\N	\N	\N	\N	30085	30085	30086
9384	8332	34	applied	\N	\N	\N	\N	30087	30087	30505
9384	8333	35	applied	\N	\N	\N	\N	30089	30089	30090
9384	8334	36	applied	\N	\N	\N	\N	30091	30091	30092
9384	8335	37	applied	\N	\N	\N	\N	30093	30093	30094
9384	8224	38	applied	\N	\N	\N	\N	29826	29826	29827
9384	8225	39	applied	\N	\N	\N	\N	29834	29834	29835
9384	8226	40	applied	\N	\N	\N	\N	29838	29838	29839
9384	8228	41	applied	\N	\N	\N	\N	29844	29844	29845
9384	8230	42	applied	\N	\N	\N	\N	29848	29848	29849
9384	8232	44	applied	\N	\N	\N	\N	29854	29854	29855
9384	8235	45	applied	\N	\N	\N	\N	29861	29861	29862
9384	8236	46	applied	\N	\N	\N	\N	29863	29863	29864
9384	8238	47	applied	\N	\N	\N	\N	29868	29868	29869
9384	8241	48	applied	\N	\N	\N	\N	29876	29876	29877
9384	8242	49	applied	\N	\N	\N	\N	29880	29880	29881
9384	8245	50	applied	\N	\N	\N	\N	29886	29886	29887
9291	8278	45	applied	\N	\N	\N	\N	29964	29964	29965
9291	8281	46	applied	\N	\N	\N	\N	29972	29972	29973
9291	8282	47	applied	\N	\N	\N	\N	29974	29974	29975
9291	8283	48	applied	\N	\N	\N	\N	29976	29976	29977
9291	8284	49	applied	\N	\N	\N	\N	29978	29978	29979
9291	8285	50	applied	\N	\N	\N	\N	29980	29980	29981
9291	8286	51	applied	\N	\N	\N	\N	29982	29982	29983
9291	8291	52	applied	\N	\N	\N	\N	29993	29993	29994
9291	8292	53	applied	\N	\N	\N	\N	29995	29995	29996
9291	8293	54	applied	\N	\N	\N	\N	29997	29997	29998
9291	8294	55	applied	\N	\N	\N	\N	29999	29999	30000
9291	8295	56	applied	\N	\N	\N	\N	30001	30001	30002
9291	8296	57	applied	\N	\N	\N	\N	30003	30003	30004
9291	8297	58	applied	\N	\N	\N	\N	30005	30005	30006
9291	8298	59	applied	\N	\N	\N	\N	30007	30007	30008
9291	8299	60	applied	\N	\N	\N	\N	30009	30009	30010
9291	8300	61	applied	\N	\N	\N	\N	30011	30011	30012
9291	8301	62	applied	\N	\N	\N	\N	30013	30013	30014
9291	8302	63	applied	\N	\N	\N	\N	30015	30015	30016
9291	8307	64	applied	\N	\N	\N	\N	30027	30027	30028
9291	8308	65	applied	\N	\N	\N	\N	30029	30029	30030
9291	8309	66	applied	\N	\N	\N	\N	30032	30032	30033
9291	8311	67	applied	\N	\N	\N	\N	30036	30036	30037
9291	8312	68	applied	\N	\N	\N	\N	30038	30038	30039
9291	8313	69	applied	\N	\N	\N	\N	30040	30040	30041
9291	8314	70	applied	\N	\N	\N	\N	30042	30042	30043
9291	8315	71	applied	\N	\N	\N	\N	30044	30044	30045
9291	8317	72	applied	\N	\N	\N	\N	30048	30048	30049
9291	8318	73	applied	\N	\N	\N	\N	30050	30050	30051
9291	8319	74	applied	\N	\N	\N	\N	30052	30052	30053
9291	8320	75	applied	\N	\N	\N	\N	30054	30054	30055
9291	8321	76	applied	\N	\N	\N	\N	30056	30056	30057
9291	8322	77	applied	\N	\N	\N	\N	30058	30058	30059
9291	8323	78	applied	\N	\N	\N	\N	30060	30060	30061
9291	8324	79	applied	\N	\N	\N	\N	30062	30062	30063
9291	8325	80	applied	\N	\N	\N	\N	30064	30064	30065
9291	8326	81	applied	\N	\N	\N	\N	30066	30066	30067
9291	8331	82	applied	\N	\N	\N	\N	30085	30085	30086
9291	8332	83	applied	\N	\N	\N	\N	30087	30087	30088
9291	8333	84	applied	\N	\N	\N	\N	30089	30089	30090
9291	8334	85	applied	\N	\N	\N	\N	30091	30091	30092
9291	8335	86	applied	\N	\N	\N	\N	30093	30093	30094
9291	7907	87	applied	\N	\N	\N	\N	28922	28922	28923
9291	7908	88	applied	\N	\N	\N	\N	28924	28924	28925
9291	7912	89	applied	\N	\N	\N	\N	28940	28940	28941
9291	7913	90	applied	\N	\N	\N	\N	28942	28942	28943
9291	7914	91	applied	\N	\N	\N	\N	28948	28948	28949
9291	7916	92	applied	\N	\N	\N	\N	28952	28952	28953
9291	7917	93	applied	\N	\N	\N	\N	28954	28954	28955
9291	7918	94	applied	\N	\N	\N	\N	28956	28956	28957
9291	7919	95	applied	\N	\N	\N	\N	28958	28958	28959
9291	7928	96	applied	\N	\N	\N	\N	28981	28981	28982
9291	7930	97	applied	\N	\N	\N	\N	28989	28989	28990
9291	7931	98	applied	\N	\N	\N	\N	28995	28995	28996
9291	7934	99	applied	\N	\N	\N	\N	29001	29001	29002
9291	7936	100	applied	\N	\N	\N	\N	29009	29009	29010
9291	7939	101	applied	\N	\N	\N	\N	29015	29015	29016
9291	7940	102	applied	\N	\N	\N	\N	29021	29021	29022
9291	7941	103	applied	\N	\N	\N	\N	29023	29023	29024
9291	7946	104	applied	\N	\N	\N	\N	29035	29035	29036
9291	7947	105	applied	\N	\N	\N	\N	29039	29039	29040
9291	7950	106	applied	\N	\N	\N	\N	29047	29047	29048
9291	7951	107	applied	\N	\N	\N	\N	29049	29049	29050
9291	7954	108	applied	\N	\N	\N	\N	29056	29056	29057
9291	7959	109	applied	\N	\N	\N	\N	29066	29066	29067
9291	7963	110	applied	\N	\N	\N	\N	29074	29074	29075
9291	7964	111	applied	\N	\N	\N	\N	29076	29076	29077
9291	7965	112	applied	\N	\N	\N	\N	29078	29078	29079
9291	7966	113	applied	\N	\N	\N	\N	29080	29080	29081
9291	7968	114	applied	\N	\N	\N	\N	29086	29086	29087
9291	7972	115	applied	\N	\N	\N	\N	29095	29095	29096
9291	7973	116	applied	\N	\N	\N	\N	29097	29097	29098
9291	7974	117	applied	\N	\N	\N	\N	29100	29100	29101
9291	7977	118	applied	\N	\N	\N	\N	29108	29108	29109
9291	7979	119	applied	\N	\N	\N	\N	29114	29114	29115
9291	7981	120	applied	\N	\N	\N	\N	29120	29120	29121
9291	7982	121	applied	\N	\N	\N	\N	29122	29122	29123
9291	7987	122	applied	\N	\N	\N	\N	29137	29137	29138
9291	7989	123	applied	\N	\N	\N	\N	29143	29143	29144
9291	7992	124	applied	\N	\N	\N	\N	29154	29154	29155
9291	7997	125	applied	\N	\N	\N	\N	29169	29169	29170
9293	8425	0	applied	\N	\N	\N	\N	30324	30324	30325
9293	8426	1	applied	\N	\N	\N	\N	30326	30326	30327
9293	8427	2	applied	\N	\N	\N	\N	30328	30328	1254
9298	8434	0	applied	\N	\N	\N	\N	30350	30350	30351
9298	8435	1	applied	\N	\N	\N	\N	30352	30352	30353
9300	8436	0	applied	\N	\N	\N	\N	30358	30358	30359
9300	8437	1	applied	\N	\N	\N	\N	30360	30360	30361
9301	8438	0	applied	\N	\N	\N	\N	30364	30364	30365
9301	8439	1	applied	\N	\N	\N	\N	30366	30366	30367
9301	8440	2	applied	\N	\N	\N	\N	30368	30368	30369
9301	8441	3	applied	\N	\N	\N	\N	30370	30370	30371
9301	8442	4	applied	\N	\N	\N	\N	30372	30372	30373
9301	8443	5	applied	\N	\N	\N	\N	30374	30374	30375
9304	8446	0	applied	\N	\N	\N	\N	30385	30385	30386
9304	8447	1	applied	\N	\N	\N	\N	30387	30387	30388
9304	8448	2	applied	\N	\N	\N	\N	30389	30389	30390
9304	8449	3	applied	\N	\N	\N	\N	30391	30391	30392
9304	8450	4	applied	\N	\N	\N	\N	30393	30393	30394
9304	8451	5	applied	\N	\N	\N	\N	30395	30395	30396
9304	8452	6	applied	\N	\N	\N	\N	30397	30397	30398
9304	8453	7	applied	\N	\N	\N	\N	30399	30399	30400
9307	8454	0	applied	\N	\N	\N	\N	30405	30405	30406
9307	8455	1	applied	\N	\N	\N	\N	30407	30407	30408
9307	8456	2	applied	\N	\N	\N	\N	30409	30409	30410
9307	8457	3	applied	\N	\N	1000000000	\N	30411	30411	30412
9309	8458	0	applied	\N	\N	\N	\N	30416	30416	30417
9309	8459	1	applied	\N	\N	\N	\N	30418	30418	30419
9309	8460	2	applied	\N	\N	\N	\N	30420	30420	30421
9309	8461	3	applied	\N	\N	\N	\N	30422	30422	30423
9314	8463	0	applied	\N	\N	\N	\N	30429	30429	30430
9318	8467	0	applied	\N	\N	\N	\N	30448	30448	30449
9318	8468	1	applied	\N	\N	\N	\N	30450	30450	30451
9321	8468	0	applied	\N	\N	\N	\N	30450	30450	30451
9325	8480	0	applied	\N	\N	\N	\N	30484	30484	30485
9328	8491	0	applied	\N	\N	\N	\N	30512	30512	30513
9328	8492	1	applied	\N	\N	\N	\N	30514	30514	30515
9333	8497	0	applied	\N	\N	\N	\N	30528	30528	30529
9333	8498	1	applied	\N	\N	\N	\N	30530	30530	30531
9336	8506	0	applied	\N	\N	\N	\N	30551	30551	30552
9295	8428	0	applied	\N	\N	\N	\N	30331	30331	30332
9295	8429	1	applied	\N	\N	\N	\N	30333	30333	30334
9296	8430	0	applied	\N	\N	\N	\N	30338	30338	30339
9296	8431	1	applied	\N	\N	\N	\N	30340	30340	30341
9299	8434	0	applied	\N	\N	\N	\N	30350	30350	30351
9299	8435	1	applied	\N	\N	\N	\N	30352	30352	30353
9305	8446	0	applied	\N	\N	\N	\N	30385	30385	30386
9305	8447	1	applied	\N	\N	\N	\N	30387	30387	30388
9305	8448	2	applied	\N	\N	\N	\N	30389	30389	30390
9305	8449	3	applied	\N	\N	\N	\N	30391	30391	30392
9305	8450	4	applied	\N	\N	\N	\N	30393	30393	30394
9305	8451	5	applied	\N	\N	\N	\N	30395	30395	30396
9305	8452	6	applied	\N	\N	\N	\N	30397	30397	30398
9305	8453	7	applied	\N	\N	\N	\N	30399	30399	30400
9310	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9310	8463	1	applied	\N	\N	\N	\N	30429	30429	30430
9310	8464	2	applied	\N	\N	\N	\N	30431	30431	30431
9312	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9312	8463	1	applied	\N	\N	\N	\N	30429	30429	30430
9312	8464	2	applied	\N	\N	\N	\N	30431	30431	30431
9316	8462	0	applied	\N	\N	\N	\N	30427	30427	30428
9316	8465	1	applied	\N	\N	\N	\N	30440	30440	30441
9316	8466	2	applied	\N	\N	\N	\N	30442	30442	30443
9316	8464	3	applied	\N	\N	\N	\N	30431	30431	30431
9319	8467	0	applied	\N	\N	\N	\N	30448	30448	30449
9319	8468	1	applied	\N	\N	\N	\N	30450	30450	30451
9330	8491	0	applied	\N	\N	\N	\N	30512	30512	30513
9330	8492	1	applied	\N	\N	\N	\N	30514	30514	30515
9332	8495	0	applied	\N	\N	\N	\N	30522	30522	30523
9332	8496	1	applied	\N	\N	\N	\N	30524	30524	30525
9338	8508	0	applied	\N	\N	\N	\N	30557	30557	30558
9338	8509	1	applied	\N	\N	\N	\N	30559	30559	30560
9343	8514	0	applied	\N	\N	\N	\N	30576	30576	30577
9343	8515	1	applied	\N	\N	\N	\N	30578	30578	30579
9347	8518	0	applied	\N	\N	\N	\N	30588	30588	30589
9347	8519	1	applied	\N	\N	\N	\N	30590	30590	30591
9350	8526	0	applied	\N	\N	\N	\N	30609	30609	30610
9350	8527	1	applied	\N	\N	\N	\N	30611	30611	30612
9352	8528	0	applied	\N	\N	\N	\N	30615	30615	30616
9352	8529	1	applied	\N	\N	\N	\N	30617	30617	30618
9363	8535	0	applied	\N	\N	\N	\N	30640	30640	30641
9363	8536	1	applied	\N	\N	\N	\N	30642	30642	30643
9368	8539	0	applied	\N	\N	\N	\N	30656	30656	30657
9368	8540	1	applied	\N	\N	\N	\N	30658	30658	30659
9370	8543	0	applied	\N	\N	\N	\N	30666	30666	30667
9370	8544	1	applied	\N	\N	\N	\N	30668	30668	30669
9377	8554	0	applied	\N	\N	\N	\N	30697	30697	30698
9377	8555	1	applied	\N	\N	\N	\N	30699	30699	30700
9380	8556	0	applied	\N	\N	\N	\N	30701	30701	30702
9380	8557	1	applied	\N	\N	\N	\N	30703	30703	30704
9380	8558	2	applied	\N	\N	\N	\N	30705	30705	30706
9380	8559	4	applied	\N	\N	\N	\N	30708	30708	30709
9382	8560	0	applied	\N	\N	\N	\N	30717	30717	30718
9386	8562	0	applied	\N	\N	\N	\N	30730	30730	30731
9386	8563	1	applied	\N	\N	\N	\N	30732	30732	30733
9389	8566	0	applied	\N	\N	\N	\N	30743	30743	30744
9389	8567	1	applied	\N	\N	\N	\N	30745	30745	30746
9389	8568	2	applied	\N	\N	\N	\N	30747	30747	30748
9389	8569	3	applied	\N	\N	\N	\N	30749	30749	30750
9392	8577	0	applied	\N	\N	\N	\N	30766	30766	30767
9392	8578	1	applied	\N	\N	\N	\N	30768	30768	30769
9392	8579	2	applied	\N	\N	\N	\N	30770	30770	30771
9392	8580	3	applied	\N	\N	\N	\N	30772	30772	30773
9394	8577	0	applied	\N	\N	\N	\N	30766	30766	30767
9394	8578	1	applied	\N	\N	\N	\N	30768	30768	30769
9394	8579	2	applied	\N	\N	\N	\N	30770	30770	30771
9394	8580	3	applied	\N	\N	\N	\N	30772	30772	30773
9398	8592	0	applied	\N	\N	\N	\N	30803	30803	30804
9398	8593	1	applied	\N	\N	\N	\N	30805	30805	30806
9400	8594	0	applied	\N	\N	\N	\N	30813	30813	30814
9400	8595	1	applied	\N	\N	\N	\N	30815	30815	30816
9400	8596	2	applied	\N	\N	\N	\N	30817	30817	30818
9400	8597	3	applied	\N	\N	\N	\N	30819	30819	30820
9406	8610	0	applied	\N	\N	\N	\N	30853	30853	30854
9406	8611	1	applied	\N	\N	\N	\N	30855	30855	30856
9408	8614	0	applied	\N	\N	\N	\N	30864	30864	30865
9408	8615	1	applied	\N	\N	\N	\N	30866	30866	30867
9409	8616	0	applied	\N	\N	\N	\N	30870	30870	30871
9409	8617	1	applied	\N	\N	\N	\N	30872	30872	30873
9409	8618	2	applied	\N	\N	\N	\N	30874	30874	30875
9409	8619	3	applied	\N	\N	\N	\N	30876	30876	30877
9409	8620	4	applied	\N	\N	\N	\N	30878	30878	30879
9409	8621	5	applied	\N	\N	\N	\N	30880	30880	30881
9409	8622	6	applied	\N	\N	\N	\N	30882	30882	30883
9409	8623	7	applied	\N	\N	\N	\N	30884	30884	30885
9412	8624	0	applied	\N	\N	\N	\N	30888	30888	30889
9412	8625	1	applied	\N	\N	\N	\N	30890	30890	30891
9427	8648	0	applied	\N	\N	\N	\N	30959	30959	30960
9429	8648	0	applied	\N	\N	\N	\N	30959	30959	30960
9432	8652	0	applied	\N	\N	\N	\N	30972	30972	30973
9432	8653	1	applied	\N	\N	1000000000	\N	30974	30974	30975
9435	8652	0	applied	\N	\N	\N	\N	30972	30972	30973
9435	8653	1	applied	\N	\N	1000000000	\N	30974	30974	30975
9442	8663	0	applied	\N	\N	\N	\N	31013	31013	31014
9442	8664	1	applied	\N	\N	\N	\N	31015	31015	31016
9447	8669	0	applied	\N	\N	\N	\N	31032	31032	31033
9447	8670	1	applied	\N	\N	\N	\N	31034	31034	31035
9453	8675	0	applied	\N	\N	\N	\N	31053	31053	31054
9453	8676	1	applied	\N	\N	\N	\N	31055	31055	31056
9453	8677	2	applied	\N	\N	\N	\N	31057	31057	31058
9453	8678	3	applied	\N	\N	\N	\N	31059	31059	31060
9453	8679	4	applied	\N	\N	\N	\N	31061	31061	30431
9454	8680	0	applied	\N	\N	\N	\N	31066	31066	31067
9454	8681	1	applied	\N	\N	\N	\N	31068	31068	31069
9461	8684	0	applied	\N	\N	\N	\N	31081	31081	31082
9461	8685	1	applied	\N	\N	\N	\N	31083	31083	31084
9465	8687	0	applied	\N	\N	\N	\N	31092	31092	31093
9465	8688	1	applied	\N	\N	\N	\N	31097	31097	31098
9465	8689	2	applied	\N	\N	\N	\N	31099	31099	31100
9472	8703	0	applied	\N	\N	1000000000	\N	31136	31136	31137
9472	8704	1	applied	\N	\N	\N	\N	31138	31138	31139
9472	8705	2	applied	\N	\N	\N	\N	31140	31140	31141
9476	8712	0	applied	\N	\N	\N	\N	31167	31167	31168
9476	8713	1	applied	\N	\N	\N	\N	31169	31169	31170
9478	8714	0	applied	\N	\N	1000000000	\N	31175	31175	31176
9478	8715	1	applied	\N	\N	1000000000	\N	31177	31177	31178
9478	8716	3	applied	\N	\N	\N	\N	31179	31179	31180
9478	8717	4	applied	\N	\N	\N	\N	31181	31181	31182
9483	8720	0	applied	\N	\N	\N	\N	31188	31188	31189
9336	8503	1	applied	\N	\N	\N	\N	30543	30543	30544
9336	8504	2	applied	\N	\N	\N	\N	30545	30545	30546
9336	8505	3	applied	\N	\N	\N	\N	30547	30547	30548
9336	8507	4	applied	\N	\N	\N	\N	30553	30553	30554
9341	8512	0	applied	\N	\N	\N	\N	30572	30572	30573
9341	8513	1	applied	\N	\N	\N	\N	30574	30574	30575
9345	8516	0	applied	\N	\N	\N	\N	30584	30584	30585
9345	8517	1	applied	\N	\N	\N	\N	30586	30586	30587
9348	8518	0	applied	\N	\N	\N	\N	30588	30588	30589
9348	8519	1	applied	\N	\N	\N	\N	30590	30590	30591
9353	8528	0	applied	\N	\N	\N	\N	30615	30615	30616
9353	8529	1	applied	\N	\N	\N	\N	30617	30617	30618
9355	8532	0	applied	\N	\N	\N	\N	30631	30631	30632
9355	8533	1	applied	\N	\N	\N	\N	30633	30633	30634
9356	8532	0	applied	\N	\N	\N	\N	30631	30631	30632
9356	8533	1	applied	\N	\N	\N	\N	30633	30633	30634
9364	8537	0	applied	\N	\N	\N	\N	30646	30646	30647
9364	8538	1	applied	\N	\N	\N	\N	30648	30648	30649
9371	8545	0	applied	\N	\N	\N	\N	30671	30671	30672
9371	8546	1	applied	\N	\N	\N	\N	30673	30673	30674
9373	8547	0	applied	\N	\N	1000000000	\N	30677	30677	30678
9373	8549	1	applied	\N	\N	\N	\N	30682	30682	30683
9373	8550	2	applied	\N	\N	\N	\N	30684	30684	30685
9373	8548	3	applied	\N	\N	\N	\N	30679	30679	23829
9376	8551	0	applied	\N	\N	\N	\N	30687	30687	30688
9376	8552	1	applied	\N	\N	\N	\N	30689	30689	30690
9376	8553	2	applied	\N	\N	\N	\N	30691	30691	30692
9378	8554	0	applied	\N	\N	\N	\N	30697	30697	30698
9378	8555	1	applied	\N	\N	\N	\N	30699	30699	30700
9387	8564	0	applied	\N	\N	\N	\N	30737	30737	30738
9387	8565	1	applied	\N	\N	\N	\N	30739	30739	30740
9393	8577	0	applied	\N	\N	\N	\N	30766	30766	30767
9393	8578	1	applied	\N	\N	\N	\N	30768	30768	30769
9393	8579	2	applied	\N	\N	\N	\N	30770	30770	30771
9393	8580	3	applied	\N	\N	\N	\N	30772	30772	30773
9395	8581	0	applied	\N	\N	\N	\N	30778	30778	30779
9395	8582	1	applied	\N	\N	\N	\N	30780	30780	30781
9395	8583	2	applied	\N	\N	\N	\N	30782	30782	30783
9395	8584	3	applied	\N	\N	\N	\N	30784	30784	30785
9413	8624	0	applied	\N	\N	\N	\N	30888	30888	30889
9413	8625	1	applied	\N	\N	\N	\N	30890	30890	30891
9414	8626	0	applied	\N	\N	\N	\N	30900	30900	30901
9414	8627	1	applied	\N	\N	\N	\N	30902	30902	30903
9424	8638	0	applied	\N	\N	\N	\N	30933	30933	30934
9424	8639	1	applied	\N	\N	\N	\N	30935	30935	30936
9425	8640	0	applied	\N	\N	\N	\N	30939	30939	30940
9425	8641	1	applied	\N	\N	\N	\N	30941	30941	30942
9425	8642	2	applied	\N	\N	\N	\N	30943	30943	30944
9425	8643	3	applied	\N	\N	\N	\N	30945	30945	30946
9436	8649	0	applied	\N	\N	\N	\N	30963	30963	30481
9436	8648	1	applied	\N	\N	\N	\N	30959	30959	30964
9440	8657	0	applied	\N	\N	\N	\N	30995	30995	30996
9440	8658	1	applied	\N	\N	\N	\N	30997	30997	30998
9443	8663	0	applied	\N	\N	\N	\N	31013	31013	31014
9443	8664	1	applied	\N	\N	\N	\N	31015	31015	31016
9445	8665	0	applied	\N	\N	\N	\N	31021	31021	31022
9445	8666	1	applied	\N	\N	\N	\N	31023	31023	31024
9445	8667	2	applied	\N	\N	\N	\N	31025	31025	31026
9445	8668	3	applied	\N	\N	\N	\N	31027	31027	31028
9450	8673	0	applied	\N	\N	\N	\N	31047	31047	31048
9450	8674	1	applied	\N	\N	\N	\N	31049	31049	31050
9457	8680	0	applied	\N	\N	\N	\N	31066	31066	31067
9457	8681	1	applied	\N	\N	\N	\N	31068	31068	31069
9459	8682	0	applied	\N	\N	\N	\N	31073	31073	31074
9459	8683	1	applied	\N	\N	\N	\N	31075	31075	31076
9466	8690	0	applied	\N	\N	\N	\N	31103	31103	31104
9466	8691	1	applied	\N	\N	\N	\N	31105	31105	31106
9466	8692	2	applied	\N	\N	\N	\N	31107	31107	31108
9466	8693	3	applied	\N	\N	\N	\N	31109	31109	31110
9469	8696	0	applied	\N	\N	\N	\N	31120	31120	31121
9469	8697	1	applied	\N	\N	\N	\N	31122	31122	31123
9469	8698	2	applied	\N	\N	\N	\N	31124	31124	31125
9469	8699	3	applied	\N	\N	\N	\N	31126	31126	31127
9469	8700	4	applied	\N	\N	\N	\N	31128	31128	31129
9469	8701	5	applied	\N	\N	\N	\N	31130	31130	31131
9469	8702	6	applied	\N	\N	\N	\N	31132	31132	31133
9477	8712	0	applied	\N	\N	\N	\N	31167	31167	31168
9477	8713	1	applied	\N	\N	\N	\N	31169	31169	31170
9479	8718	0	applied	\N	\N	\N	\N	31184	31184	31185
9479	8719	1	applied	\N	\N	\N	\N	31186	31186	31187
9484	8722	0	applied	\N	\N	\N	\N	31196	31196	30788
9484	8723	1	applied	\N	\N	\N	\N	31197	31197	31198
9484	8724	2	applied	\N	\N	\N	\N	31199	31199	31200
9484	8725	3	applied	\N	\N	\N	\N	31201	31201	31202
9484	8726	4	applied	\N	\N	\N	\N	31203	31203	31204
9484	8727	5	applied	\N	\N	\N	\N	31205	31205	31206
9484	8728	6	applied	\N	\N	\N	\N	31207	31207	31208
9486	8729	0	applied	\N	\N	\N	\N	31213	31213	31214
9486	8730	1	applied	\N	\N	\N	\N	31215	31215	31216
9489	8735	0	applied	\N	\N	\N	\N	31230	31230	31231
9489	8736	1	applied	\N	\N	\N	\N	31232	31232	31233
9491	8737	0	applied	\N	\N	\N	\N	31237	31237	31238
9491	8738	1	applied	\N	\N	\N	\N	31239	31239	31240
9497	8747	0	applied	\N	\N	\N	\N	31260	31260	31261
9497	8748	1	applied	\N	\N	\N	\N	31262	31262	31263
9504	8755	0	applied	\N	\N	\N	\N	31282	31282	31242
9504	8756	1	applied	\N	\N	\N	\N	31283	31283	31284
9504	8757	2	applied	\N	\N	\N	\N	31285	31285	31286
9510	8762	0	applied	\N	\N	\N	\N	31308	31308	31309
9510	8763	1	applied	\N	\N	\N	\N	31310	31310	31311
9510	8764	2	applied	\N	\N	\N	\N	31312	31312	31313
9517	8769	0	applied	\N	\N	\N	\N	31332	31332	31333
9517	8770	1	applied	\N	\N	\N	\N	31334	31334	31335
9519	8771	0	applied	\N	\N	\N	\N	31337	31337	31338
9519	8772	1	applied	\N	\N	\N	\N	31339	31339	31340
9524	8779	0	applied	\N	\N	\N	\N	31361	31361	31362
9524	8780	1	applied	\N	\N	\N	\N	31363	31363	31364
9524	8781	2	applied	\N	\N	\N	\N	31365	31365	31366
9524	8782	3	applied	\N	\N	\N	\N	31367	31367	31368
9524	8783	4	applied	\N	\N	\N	\N	31369	31369	31132
9529	8791	0	applied	\N	\N	\N	\N	31393	31393	31394
9529	8792	1	applied	\N	\N	\N	\N	31395	31395	31396
9529	8793	2	applied	\N	\N	\N	\N	31397	31397	31398
9529	8794	3	applied	\N	\N	\N	\N	31399	31399	31400
9529	8795	4	applied	\N	\N	\N	\N	31401	31401	31402
9534	8801	0	applied	\N	\N	\N	\N	31420	31420	31421
9534	8802	1	applied	\N	\N	\N	\N	31422	31422	31423
9536	8803	0	applied	\N	\N	\N	\N	31430	31430	31431
9536	8804	1	applied	\N	\N	\N	\N	31432	31432	31433
9536	8805	2	applied	\N	\N	\N	\N	31434	31434	31435
9358	8534	0	applied	\N	\N	\N	\N	30637	30637	30638
9365	8537	0	applied	\N	\N	\N	\N	30646	30646	30647
9365	8538	1	applied	\N	\N	\N	\N	30648	30648	30649
9369	8541	0	applied	\N	\N	\N	\N	30662	30662	30663
9369	8542	1	applied	\N	\N	\N	\N	30664	30664	30665
9374	8551	0	applied	\N	\N	\N	\N	30687	30687	30688
9374	8552	1	applied	\N	\N	\N	\N	30689	30689	30690
9374	8553	2	applied	\N	\N	\N	\N	30691	30691	30692
9381	8556	0	applied	\N	\N	\N	\N	30701	30701	30702
9381	8557	1	applied	\N	\N	\N	\N	30703	30703	30704
9381	8558	2	applied	\N	\N	\N	\N	30705	30705	30706
9381	8559	4	applied	\N	\N	\N	\N	30708	30708	30709
9383	8561	0	applied	\N	\N	\N	\N	30720	30720	30721
9383	8560	1	applied	\N	\N	\N	\N	30717	30717	30718
9385	8562	0	applied	\N	\N	\N	\N	30730	30730	30731
9385	8563	1	applied	\N	\N	\N	\N	30732	30732	30733
9388	8564	0	applied	\N	\N	\N	\N	30737	30737	30738
9388	8565	1	applied	\N	\N	\N	\N	30739	30739	30740
9390	8570	0	applied	\N	\N	\N	\N	30751	30751	30752
9390	8571	1	applied	\N	\N	\N	\N	30753	30753	30754
9390	8572	2	applied	\N	\N	\N	\N	30755	30755	30756
9396	8585	0	applied	\N	\N	\N	\N	30788	30788	30789
9396	8586	1	applied	\N	\N	\N	\N	30790	30790	30791
9396	8587	2	applied	\N	\N	1000000000	\N	30792	30792	30793
9396	8588	3	applied	\N	\N	\N	\N	30794	30794	30795
9396	8589	4	applied	\N	\N	\N	\N	30796	30796	30797
9396	8590	5	applied	\N	\N	\N	\N	30798	30798	30799
9396	8591	6	applied	\N	\N	\N	\N	30800	30800	30801
9401	8594	0	applied	\N	\N	\N	\N	30813	30813	30814
9401	8595	1	applied	\N	\N	\N	\N	30815	30815	30816
9401	8596	2	applied	\N	\N	\N	\N	30817	30817	30818
9401	8597	3	applied	\N	\N	\N	\N	30819	30819	30820
9403	8598	0	applied	\N	\N	\N	\N	30825	30825	30826
9403	8599	1	applied	\N	\N	\N	\N	30827	30827	30828
9404	8600	0	applied	\N	\N	1000000000	\N	30831	30831	30832
9404	8601	1	applied	\N	\N	\N	\N	30833	30833	30834
9404	8602	2	applied	\N	\N	\N	\N	30835	30835	30836
9404	8603	3	applied	\N	\N	\N	\N	30837	30837	30838
9404	8604	4	applied	\N	\N	\N	\N	30839	30839	30840
9404	8605	5	applied	\N	\N	\N	\N	30841	30841	30842
9404	8606	6	applied	\N	\N	\N	\N	30843	30843	30844
9404	8607	7	applied	\N	\N	\N	\N	30845	30845	30846
9404	8608	8	applied	\N	\N	\N	\N	30847	30847	30848
9404	8609	9	applied	\N	\N	\N	\N	30849	30849	30850
9410	8624	0	applied	\N	\N	\N	\N	30888	30888	30889
9410	8625	1	applied	\N	\N	\N	\N	30890	30890	30891
9415	8628	0	applied	\N	\N	\N	\N	30904	30904	30905
9415	8629	1	applied	\N	\N	\N	\N	30906	30906	30907
9415	8630	2	applied	\N	\N	\N	\N	30908	30908	30909
9415	8631	3	applied	\N	\N	\N	\N	30910	30910	30911
9416	8632	0	applied	\N	\N	\N	\N	30914	30914	30915
9416	8633	1	applied	\N	\N	\N	\N	30916	30916	30917
9416	8634	2	applied	\N	\N	\N	\N	30918	30918	30919
9416	8635	3	applied	\N	\N	\N	\N	30920	30920	30921
9417	8632	0	applied	\N	\N	\N	\N	30914	30914	30915
9417	8633	1	applied	\N	\N	\N	\N	30916	30916	30917
9417	8634	2	applied	\N	\N	\N	\N	30918	30918	30919
9417	8635	3	applied	\N	\N	\N	\N	30920	30920	30921
9420	8636	0	applied	\N	\N	\N	\N	30928	30928	30929
9420	8637	1	applied	\N	\N	\N	\N	30930	30930	30931
9426	8644	0	applied	\N	\N	\N	\N	30949	30949	30950
9426	8645	1	applied	\N	\N	\N	\N	30951	30951	30952
9426	8646	2	applied	\N	\N	\N	\N	30953	30953	30954
9426	8647	3	applied	\N	\N	\N	\N	30955	30955	30956
9428	8649	0	applied	\N	\N	\N	\N	30963	30963	30481
9428	8648	1	applied	\N	\N	\N	\N	30959	30959	30964
9430	8649	0	applied	\N	\N	\N	\N	30963	30963	30481
9430	8650	1	applied	\N	\N	\N	\N	30967	30967	30968
9430	8651	2	applied	\N	\N	\N	\N	30969	30969	30970
9430	8648	3	applied	\N	\N	\N	\N	30959	30959	30964
9433	8652	0	applied	\N	\N	\N	\N	30972	30972	30973
9433	8653	1	applied	\N	\N	1000000000	\N	30974	30974	30975
9438	8520	0	applied	\N	\N	\N	\N	30987	30987	30987
9438	7969	1	applied	\N	\N	\N	\N	29090	29090	1435
9438	7956	2	applied	\N	\N	\N	\N	29060	29060	29061
9438	8547	3	applied	\N	\N	1000000000	\N	30677	30677	30678
9438	7813	4	applied	\N	\N	\N	\N	28637	28637	28638
9438	7815	5	applied	\N	\N	\N	\N	28645	28645	28646
9438	7999	6	applied	\N	\N	\N	\N	29174	29174	29175
9438	7980	7	applied	\N	\N	\N	\N	29118	29118	29119
9438	8585	8	applied	\N	\N	\N	\N	30988	30988	30789
9438	7949	9	applied	\N	\N	1000000000	\N	29045	29045	29046
9438	7814	10	applied	\N	\N	\N	\N	28639	28639	28640
9438	7816	11	applied	\N	\N	\N	\N	28647	28647	28648
9438	8159	12	applied	\N	\N	\N	\N	29673	29673	29639
9438	7817	13	applied	\N	\N	\N	\N	28651	28651	28652
9438	7819	14	applied	\N	\N	\N	\N	28658	28658	28659
9438	7822	15	applied	\N	\N	\N	\N	28667	28667	28668
9438	8649	16	applied	\N	\N	\N	\N	30963	30963	26860
9438	8603	17	applied	\N	\N	\N	\N	30837	30837	30838
9438	8572	18	applied	\N	\N	\N	\N	30755	30755	30989
9438	7891	19	applied	\N	\N	\N	\N	28876	28876	30756
9438	7915	21	applied	\N	\N	\N	\N	28950	28950	28951
9438	8163	22	applied	\N	\N	\N	\N	29674	29674	29649
9438	8248	23	applied	\N	\N	\N	\N	30991	30991	29895
9438	8250	24	applied	\N	\N	\N	\N	30992	30992	29907
9438	7990	25	applied	\N	\N	1000000000	\N	29145	29145	29146
9441	8659	0	applied	\N	\N	\N	\N	31003	31003	31004
9441	8660	1	applied	\N	\N	\N	\N	31005	31005	31006
9441	8661	2	applied	\N	\N	\N	\N	31007	31007	31008
9441	8662	3	applied	\N	\N	\N	\N	31009	31009	31010
9446	8669	0	applied	\N	\N	\N	\N	31032	31032	31033
9446	8670	1	applied	\N	\N	\N	\N	31034	31034	31035
9448	8671	0	applied	\N	\N	\N	\N	31039	31039	31040
9448	8672	1	applied	\N	\N	\N	\N	31041	31041	31042
9451	8675	0	applied	\N	\N	\N	\N	31053	31053	31054
9451	8676	1	applied	\N	\N	\N	\N	31055	31055	31056
9451	8677	2	applied	\N	\N	\N	\N	31057	31057	31058
9451	8678	3	applied	\N	\N	\N	\N	31059	31059	31060
9451	8679	4	applied	\N	\N	\N	\N	31061	31061	30431
9455	8680	0	applied	\N	\N	\N	\N	31066	31066	31067
9455	8681	1	applied	\N	\N	\N	\N	31068	31068	31069
9462	8686	0	applied	\N	\N	\N	\N	31088	31088	31089
9464	8674	0	applied	\N	\N	\N	\N	31049	31049	31050
9464	8679	1	applied	\N	\N	\N	\N	31061	31061	30431
9467	8694	0	applied	\N	\N	\N	\N	31113	31113	31114
9467	8695	1	applied	\N	\N	\N	\N	31115	31115	31116
9470	8703	0	applied	\N	\N	1000000000	\N	31136	31136	31137
9470	8704	1	applied	\N	\N	\N	\N	31138	31138	31139
9384	8247	51	applied	\N	\N	\N	\N	29892	29892	29893
9384	8338	52	applied	\N	\N	\N	\N	30100	30100	30101
9384	8339	53	applied	\N	\N	\N	\N	30102	30102	30103
9384	8340	54	applied	\N	\N	\N	\N	30104	30104	30105
9384	8341	55	applied	\N	\N	\N	\N	30106	30106	30107
9384	8342	56	applied	\N	\N	\N	\N	30108	30108	30109
9384	8343	57	applied	\N	\N	\N	\N	30110	30110	30111
9384	8344	58	applied	\N	\N	\N	\N	30117	30117	30118
9384	8345	59	applied	\N	\N	\N	\N	30119	30119	30120
9384	8346	60	applied	\N	\N	\N	\N	30121	30121	30122
9384	8348	61	applied	\N	\N	\N	\N	30125	30125	30126
9384	8349	62	applied	\N	\N	\N	\N	30127	30127	30128
9384	8350	63	applied	\N	\N	\N	\N	30129	30129	30130
9384	8353	64	applied	\N	\N	\N	\N	30139	30139	30140
9384	8355	65	applied	\N	\N	\N	\N	30143	30143	30144
9384	8356	66	applied	\N	\N	\N	\N	30145	30145	30146
9384	8357	67	applied	\N	\N	\N	\N	30147	30147	30148
9384	8358	68	applied	\N	\N	\N	\N	30149	30149	30150
9384	8359	69	applied	\N	\N	\N	\N	30151	30151	30152
9384	8362	70	applied	\N	\N	\N	\N	30159	30159	30160
9384	8365	71	applied	\N	\N	\N	\N	30165	30165	30166
9384	8366	72	applied	\N	\N	\N	\N	30167	30167	30168
9384	8367	73	applied	\N	\N	\N	\N	30169	30169	30170
9384	8368	74	applied	\N	\N	\N	\N	30171	30171	30172
9384	8369	75	applied	\N	\N	\N	\N	30173	30173	30174
9384	8370	76	applied	\N	\N	\N	\N	30175	30175	30176
9384	8371	77	applied	\N	\N	\N	\N	30177	30177	30178
9384	8372	78	applied	\N	\N	\N	\N	30179	30179	30180
9384	8373	79	applied	\N	\N	\N	\N	30181	30181	30182
9384	8374	80	applied	\N	\N	\N	\N	30183	30183	30184
9384	8376	81	applied	\N	\N	\N	\N	30192	30192	30193
9384	8378	82	applied	\N	\N	\N	\N	30196	30196	30197
9384	8379	83	applied	\N	\N	\N	\N	30198	30198	30199
9384	8380	84	applied	\N	\N	\N	\N	30200	30200	30201
9384	8381	85	applied	\N	\N	\N	\N	30202	30202	30203
9384	8382	86	applied	\N	\N	\N	\N	30204	30204	30205
9384	8384	87	applied	\N	\N	\N	\N	30210	30210	30211
9384	8385	88	applied	\N	\N	\N	\N	30212	30212	30213
9384	8388	89	applied	\N	\N	\N	\N	30218	30218	30219
9384	8390	90	applied	\N	\N	\N	\N	30222	30222	30223
9384	8392	91	applied	\N	\N	\N	\N	30226	30226	30227
9384	8393	92	applied	\N	\N	\N	\N	30228	30228	30229
9384	8414	93	applied	\N	\N	\N	\N	30291	30291	30292
9384	8211	94	applied	\N	\N	\N	\N	29784	29784	29785
9384	8212	95	applied	\N	\N	\N	\N	29786	29786	29787
9384	8213	96	applied	\N	\N	\N	\N	29788	29788	29789
9384	8216	97	applied	\N	\N	\N	\N	29799	29799	29800
9384	8217	98	applied	\N	\N	\N	\N	29801	29801	29802
9384	8218	99	applied	\N	\N	\N	\N	29807	29807	29808
9384	8220	100	applied	\N	\N	\N	\N	29814	29814	29815
9384	8222	101	applied	\N	\N	1000000000	\N	29822	29822	29823
9384	8223	102	applied	\N	\N	\N	\N	29824	29824	29825
9384	8227	103	applied	\N	\N	\N	\N	29840	29840	29841
9384	8229	104	applied	\N	\N	\N	\N	29846	29846	29847
9384	8231	105	applied	\N	\N	\N	\N	29850	29850	29851
9384	8233	106	applied	\N	\N	\N	\N	29856	29856	29857
9384	8234	107	applied	\N	\N	\N	\N	29859	29859	29860
9384	8237	108	applied	\N	\N	\N	\N	29865	29865	29866
9384	8239	109	applied	\N	\N	\N	\N	29870	29870	29871
9384	8240	110	applied	\N	\N	\N	\N	29874	29874	29875
9384	8243	111	applied	\N	\N	\N	\N	29882	29882	29883
9384	8244	112	applied	\N	\N	\N	\N	29884	29884	29885
9384	8246	113	applied	\N	\N	\N	\N	29890	29890	29891
9384	8249	114	applied	\N	\N	\N	\N	29904	29904	29905
9384	8251	115	applied	\N	\N	\N	\N	29908	29908	29909
9384	8260	116	applied	\N	\N	\N	\N	29928	29928	29929
9384	8261	117	applied	\N	\N	\N	\N	29930	29930	29931
9384	8262	118	applied	\N	\N	\N	\N	29932	29932	29933
9384	8279	119	applied	\N	\N	\N	\N	29968	29968	29969
9384	8287	120	applied	\N	\N	\N	\N	29985	29985	29986
9384	8288	121	applied	\N	\N	\N	\N	29987	29987	29988
9384	8304	122	applied	\N	\N	\N	\N	30021	30021	30022
9384	8310	123	applied	\N	\N	\N	\N	30034	30034	30035
9384	8316	124	applied	\N	\N	\N	\N	30046	30046	30047
9384	8330	125	applied	\N	\N	\N	\N	30083	30083	30084
9391	8573	0	applied	\N	\N	\N	\N	30757	30757	30758
9391	8574	1	applied	\N	\N	\N	\N	30759	30759	30760
9391	8575	2	applied	\N	\N	\N	\N	30761	30761	30762
9391	8576	3	applied	\N	\N	\N	\N	30763	30763	30764
9397	8592	0	applied	\N	\N	\N	\N	30803	30803	30804
9397	8593	1	applied	\N	\N	\N	\N	30805	30805	30806
9399	8592	0	applied	\N	\N	\N	\N	30803	30803	30804
9399	8593	1	applied	\N	\N	\N	\N	30805	30805	30806
9402	8594	0	applied	\N	\N	\N	\N	30813	30813	30814
9402	8595	1	applied	\N	\N	\N	\N	30815	30815	30816
9402	8596	2	applied	\N	\N	\N	\N	30817	30817	30818
9402	8597	3	applied	\N	\N	\N	\N	30819	30819	30820
9405	8610	0	applied	\N	\N	\N	\N	30853	30853	30854
9405	8611	1	applied	\N	\N	\N	\N	30855	30855	30856
9407	8612	0	applied	\N	\N	\N	\N	30858	30858	30859
9407	8613	1	applied	\N	\N	\N	\N	30860	30860	30861
9411	8624	0	applied	\N	\N	\N	\N	30888	30888	30889
9411	8625	1	applied	\N	\N	\N	\N	30890	30890	30891
9418	8632	0	applied	\N	\N	\N	\N	30914	30914	30915
9418	8633	1	applied	\N	\N	\N	\N	30916	30916	30917
9418	8634	2	applied	\N	\N	\N	\N	30918	30918	30919
9418	8635	3	applied	\N	\N	\N	\N	30920	30920	30921
9431	8652	0	applied	\N	\N	\N	\N	30972	30972	30973
9431	8653	1	applied	\N	\N	1000000000	\N	30974	30974	30975
9434	8652	0	applied	\N	\N	\N	\N	30972	30972	30973
9434	8653	1	applied	\N	\N	1000000000	\N	30974	30974	30975
9437	8654	0	applied	\N	\N	\N	\N	30981	30981	30982
9437	8655	1	applied	\N	\N	1000000000	\N	30983	30983	30984
9437	8656	2	applied	\N	\N	\N	\N	30985	30985	30986
9439	8657	0	applied	\N	\N	\N	\N	30995	30995	30996
9439	8658	1	applied	\N	\N	\N	\N	30997	30997	30998
9444	8665	0	applied	\N	\N	\N	\N	31021	31021	31022
9444	8666	1	applied	\N	\N	\N	\N	31023	31023	31024
9444	8667	2	applied	\N	\N	\N	\N	31025	31025	31026
9444	8668	3	applied	\N	\N	\N	\N	31027	31027	31028
9449	8671	0	applied	\N	\N	\N	\N	31039	31039	31040
9449	8672	1	applied	\N	\N	\N	\N	31041	31041	31042
9452	8675	0	applied	\N	\N	\N	\N	31053	31053	31054
9452	8676	1	applied	\N	\N	\N	\N	31055	31055	31056
9452	8677	2	applied	\N	\N	\N	\N	31057	31057	31058
9452	8678	3	applied	\N	\N	\N	\N	31059	31059	31060
9452	8679	4	applied	\N	\N	\N	\N	31061	31061	30431
9458	8682	0	applied	\N	\N	\N	\N	31073	31073	31074
9458	8683	1	applied	\N	\N	\N	\N	31075	31075	31076
9460	8684	0	applied	\N	\N	\N	\N	31081	31081	31082
9460	8685	1	applied	\N	\N	\N	\N	31083	31083	31084
9463	8687	0	applied	\N	\N	\N	\N	31092	31092	31093
9463	8686	1	applied	\N	\N	\N	\N	31088	31088	31089
9468	8669	0	applied	\N	\N	\N	\N	31032	31032	31033
9468	8671	1	applied	\N	\N	\N	\N	31039	31039	31040
9468	8673	2	applied	\N	\N	\N	\N	31047	31047	31048
9468	8675	3	applied	\N	\N	\N	\N	31053	31053	31054
9468	8678	4	applied	\N	\N	\N	\N	31059	31059	31060
9468	8680	5	applied	\N	\N	\N	\N	31066	31066	31067
9468	8683	6	applied	\N	\N	\N	\N	31075	31075	31076
9468	8685	7	applied	\N	\N	\N	\N	31083	31083	31084
9468	8686	8	applied	\N	\N	\N	\N	31088	31088	31089
9468	8688	9	applied	\N	\N	\N	\N	31097	31097	31098
9468	8692	10	applied	\N	\N	\N	\N	31107	31107	31108
9468	8693	11	applied	\N	\N	\N	\N	31109	31109	31110
9468	8695	12	applied	\N	\N	\N	\N	31115	31115	31116
9468	8670	13	applied	\N	\N	\N	\N	31034	31034	31035
9468	8672	14	applied	\N	\N	\N	\N	31041	31041	31042
9468	8676	15	applied	\N	\N	\N	\N	31055	31055	31056
9468	8677	16	applied	\N	\N	\N	\N	31057	31057	31058
9468	8681	17	applied	\N	\N	\N	\N	31068	31068	31069
9468	8682	18	applied	\N	\N	\N	\N	31073	31073	31074
9468	8684	19	applied	\N	\N	\N	\N	31081	31081	31082
9468	8687	20	applied	\N	\N	\N	\N	31092	31092	31093
9468	8689	21	applied	\N	\N	\N	\N	31099	31099	31100
9468	8690	22	applied	\N	\N	\N	\N	31103	31103	31104
9468	8691	23	applied	\N	\N	\N	\N	31105	31105	31106
9468	8694	24	applied	\N	\N	\N	\N	31113	31113	31114
9468	8674	25	applied	\N	\N	\N	\N	31049	31049	31050
9468	8679	26	applied	\N	\N	\N	\N	31061	31061	30431
9471	8703	0	applied	\N	\N	1000000000	\N	31136	31136	31137
9471	8705	1	applied	\N	\N	\N	\N	31140	31140	31141
9475	8708	0	applied	\N	\N	\N	\N	31157	31157	31158
9475	8709	1	applied	\N	\N	\N	\N	31159	31159	31160
9475	8710	2	applied	\N	\N	\N	\N	31161	31161	31162
9475	8711	3	applied	\N	\N	\N	\N	31163	31163	31164
9481	8718	0	applied	\N	\N	\N	\N	31184	31184	31185
9481	8719	1	applied	\N	\N	\N	\N	31186	31186	31187
9482	8720	0	applied	\N	\N	\N	\N	31188	31188	31189
9482	8721	1	applied	\N	\N	\N	\N	31190	31190	31191
9485	8722	0	applied	\N	\N	\N	\N	31196	31196	30788
9485	8723	1	applied	\N	\N	\N	\N	31197	31197	31198
9485	8724	2	applied	\N	\N	\N	\N	31199	31199	31200
9485	8725	3	applied	\N	\N	\N	\N	31201	31201	31202
9485	8726	4	applied	\N	\N	\N	\N	31203	31203	31204
9485	8727	5	applied	\N	\N	\N	\N	31205	31205	31206
9485	8728	6	applied	\N	\N	\N	\N	31207	31207	31208
9493	8742	0	applied	\N	\N	\N	\N	31249	31249	31242
9493	8743	1	applied	\N	\N	\N	\N	31250	31250	31251
9493	8744	2	applied	\N	\N	\N	\N	31252	31252	31253
9493	8745	3	applied	\N	\N	\N	\N	31254	31254	31255
9493	8746	4	applied	\N	\N	\N	\N	31256	31256	31257
9495	8747	0	applied	\N	\N	\N	\N	31260	31260	31261
9495	8748	1	applied	\N	\N	\N	\N	31262	31262	31263
9498	8747	0	applied	\N	\N	\N	\N	31260	31260	31261
9498	8748	1	applied	\N	\N	\N	\N	31262	31262	31263
9500	8753	0	applied	\N	\N	\N	\N	31278	31278	31279
9500	8754	1	applied	\N	\N	\N	\N	31280	31280	31281
9502	8755	0	applied	\N	\N	\N	\N	31282	31282	31242
9502	8756	1	applied	\N	\N	\N	\N	31283	31283	31284
9502	8757	2	applied	\N	\N	\N	\N	31285	31285	31286
9514	8765	0	applied	\N	\N	\N	\N	31319	31319	31320
9514	8766	1	applied	\N	\N	\N	\N	31321	31321	31322
9516	8767	0	applied	\N	\N	\N	\N	31326	31326	31327
9516	8768	1	applied	\N	\N	\N	\N	31328	31328	31329
9521	8773	0	applied	\N	\N	1000000000	\N	31343	31343	31344
9521	8774	1	applied	\N	\N	\N	\N	31345	31345	31346
9521	8775	2	applied	\N	\N	\N	\N	31347	31347	31348
9521	8776	3	applied	\N	\N	\N	\N	31349	31349	31350
9521	8777	4	applied	\N	\N	\N	\N	31351	31351	31352
9521	8778	5	applied	\N	\N	\N	\N	31353	31353	31354
9533	8801	0	applied	\N	\N	\N	\N	31420	31420	31421
9533	8802	1	applied	\N	\N	\N	\N	31422	31422	31423
9540	8811	0	applied	\N	\N	\N	\N	31452	31452	31453
9540	8812	1	applied	\N	\N	\N	\N	31454	31454	31455
9540	8813	2	applied	\N	\N	\N	\N	31456	31456	31457
9540	8814	3	applied	\N	\N	\N	\N	31458	31458	31459
9545	8819	0	applied	\N	\N	\N	\N	31472	31472	31473
9545	8820	1	applied	\N	\N	\N	\N	31474	31474	31475
9550	8827	0	applied	\N	\N	\N	\N	31495	31495	31496
9550	8828	1	applied	\N	\N	\N	\N	31497	31497	31498
9559	8834	0	applied	\N	\N	\N	\N	31519	31519	31520
9559	8835	1	applied	\N	\N	\N	\N	31521	31521	31522
9559	8836	2	applied	\N	\N	\N	\N	31523	31523	31524
9559	8837	3	applied	\N	\N	\N	\N	31525	31525	31526
9562	8842	0	applied	\N	\N	\N	\N	31537	31537	31538
9562	8843	1	applied	\N	\N	\N	\N	31539	31539	31540
9562	8844	2	applied	\N	\N	\N	\N	31541	31541	31542
9562	8845	3	applied	\N	\N	\N	\N	31543	31543	31544
9565	8846	0	applied	\N	\N	\N	\N	31547	31547	31548
9565	8847	1	applied	\N	\N	\N	\N	31549	31549	31550
9565	8848	2	applied	\N	\N	\N	\N	31551	31551	31552
9567	8849	0	applied	\N	\N	\N	\N	31557	31557	31558
9567	8850	1	applied	\N	\N	\N	\N	31559	31559	31560
9572	8863	0	applied	\N	\N	\N	\N	31590	31590	31591
9572	8864	1	applied	\N	\N	\N	\N	31592	31592	31593
9575	8867	0	applied	\N	\N	\N	\N	31604	31604	31605
9575	8868	1	applied	\N	\N	\N	\N	31606	31606	31607
9577	8871	0	applied	\N	\N	\N	\N	31612	31612	31613
9577	8872	1	applied	\N	\N	\N	\N	31614	31614	31615
9580	8873	0	applied	\N	\N	1000000000	\N	31618	31618	31619
9580	8874	1	applied	\N	\N	\N	\N	31620	31620	31621
9580	8875	2	applied	\N	\N	\N	\N	31622	31622	31623
9582	8878	0	applied	\N	\N	\N	\N	31634	31634	31635
9582	8879	1	applied	\N	\N	\N	\N	31636	31636	31637
9587	8886	0	applied	\N	\N	\N	\N	31658	31658	31659
9587	8887	1	applied	\N	\N	\N	\N	31660	31660	31661
9596	8896	0	applied	\N	\N	\N	\N	31689	31689	31690
9596	8897	1	applied	\N	\N	\N	\N	31691	31691	31692
9599	8902	0	applied	\N	\N	\N	\N	31706	31706	31707
9599	8903	1	applied	\N	\N	\N	\N	31708	31708	31709
9599	8904	2	applied	\N	\N	\N	\N	31710	31710	31711
9601	8902	0	applied	\N	\N	\N	\N	31706	31706	31707
9601	8903	1	applied	\N	\N	\N	\N	31708	31708	31709
9601	8904	2	applied	\N	\N	\N	\N	31710	31710	31711
9604	8909	0	applied	\N	\N	\N	\N	31726	31726	31727
9604	8910	1	applied	\N	\N	\N	\N	31728	31728	31729
9604	8911	2	applied	\N	\N	\N	\N	31730	31730	31731
9470	8705	2	applied	\N	\N	\N	\N	31140	31140	31141
9473	8703	0	applied	\N	\N	1000000000	\N	31136	31136	31137
9473	8520	1	applied	\N	\N	\N	\N	30724	30724	30724
9473	8547	2	applied	\N	\N	1000000000	\N	30677	30677	30678
9473	8482	3	applied	\N	\N	\N	\N	31147	31147	1435
9473	8585	4	applied	\N	\N	\N	\N	31148	31148	30789
9473	8021	5	applied	\N	\N	\N	\N	29235	29235	29236
9473	8023	6	applied	\N	\N	\N	\N	29241	29241	29242
9473	8159	7	applied	\N	\N	\N	\N	29638	29638	29639
9473	8022	8	applied	\N	\N	\N	\N	29237	29237	29238
9473	8024	9	applied	\N	\N	\N	\N	29243	29243	29244
9473	8649	10	applied	\N	\N	\N	\N	30963	30963	26860
9473	8488	11	applied	\N	\N	\N	\N	30725	30725	1435
9473	8603	12	applied	\N	\N	\N	\N	30837	30837	30838
9473	8572	13	applied	\N	\N	\N	\N	30755	30755	30756
9473	8163	14	applied	\N	\N	\N	\N	29648	29648	29649
9473	8248	15	applied	\N	\N	\N	\N	29894	29894	29895
9473	8250	16	applied	\N	\N	\N	\N	29906	29906	29907
9473	8025	17	applied	\N	\N	\N	\N	29249	29249	29250
9473	8027	18	applied	\N	\N	\N	\N	29254	29254	29255
9473	8028	19	applied	\N	\N	\N	\N	29256	29256	29257
9473	8031	20	applied	\N	\N	\N	\N	29266	29266	29267
9473	8033	21	applied	\N	\N	\N	\N	29270	29270	29271
9473	8037	22	applied	\N	\N	\N	\N	29279	29279	29280
9473	8038	23	applied	\N	\N	\N	\N	29281	29281	29282
9473	8039	24	applied	\N	\N	\N	\N	29290	29290	29291
9473	8041	25	applied	\N	\N	\N	\N	29298	29298	29299
9473	8042	26	applied	\N	\N	\N	\N	29300	29300	29301
9473	8045	27	applied	\N	\N	\N	\N	29309	29309	29310
9473	8049	28	applied	\N	\N	\N	\N	29324	29324	29325
9473	8050	29	applied	\N	\N	\N	\N	29326	29326	29327
9473	8051	30	applied	\N	\N	\N	\N	29328	29328	29329
9473	8053	31	applied	\N	\N	\N	\N	29335	29335	29336
9473	8055	32	applied	\N	\N	\N	\N	29343	29343	29344
9473	8057	33	applied	\N	\N	\N	\N	29347	29347	29348
9473	8059	34	applied	\N	\N	\N	\N	29355	29355	29356
9473	8062	35	applied	\N	\N	\N	\N	29364	29364	29365
9473	8063	36	applied	\N	\N	\N	\N	29369	29369	29370
9473	8065	37	applied	\N	\N	\N	\N	29374	29374	29375
9473	8068	38	applied	\N	\N	\N	\N	29381	29381	29382
9473	8069	39	applied	\N	\N	\N	\N	29383	29383	29384
9473	8072	40	applied	\N	\N	\N	\N	29392	29392	29393
9473	8026	41	applied	\N	\N	\N	\N	29251	29251	29252
9473	8029	42	applied	\N	\N	\N	\N	29258	29258	29259
9473	8030	43	applied	\N	\N	\N	\N	29260	29260	29261
9473	8032	44	applied	\N	\N	\N	\N	29268	29268	29269
9473	8034	45	applied	\N	\N	\N	\N	29272	29272	29273
9473	8035	46	applied	\N	\N	\N	\N	29275	29275	29276
9473	8036	47	applied	\N	\N	\N	\N	29277	29277	29278
9473	8040	48	applied	\N	\N	\N	\N	29292	29292	29293
9473	8164	49	applied	\N	\N	\N	\N	29650	29650	29651
9473	8165	50	applied	\N	\N	\N	\N	29652	29652	29653
9473	8166	51	applied	\N	\N	\N	\N	29654	29654	29655
9473	8168	52	applied	\N	\N	\N	\N	29660	29660	29661
9473	8170	53	applied	\N	\N	\N	\N	29664	29664	29665
9473	8327	54	applied	\N	\N	\N	\N	30073	30073	29736
9473	8043	55	applied	\N	\N	\N	\N	29302	29302	29303
9473	8044	56	applied	\N	\N	\N	\N	29304	29304	29305
9473	8328	57	applied	\N	\N	\N	\N	30075	30075	29738
9473	8075	58	applied	\N	\N	\N	\N	29398	29398	29399
9473	8076	59	applied	\N	\N	\N	\N	29400	29400	29401
9473	8080	60	applied	\N	\N	\N	\N	29410	29410	29411
9473	8081	61	applied	\N	\N	\N	\N	29412	29412	29413
9473	8084	62	applied	\N	\N	\N	\N	29425	29425	29426
9473	8085	63	applied	\N	\N	\N	\N	29427	29427	29428
9473	8088	64	applied	\N	\N	\N	\N	29434	29434	29435
9473	8090	65	applied	\N	\N	\N	\N	29439	29439	29440
9473	8092	66	applied	\N	\N	\N	\N	29445	29445	29446
9473	8094	68	applied	\N	\N	\N	\N	29451	29451	29452
9473	8096	69	applied	\N	\N	\N	\N	29457	29457	29458
9473	8098	70	applied	\N	\N	\N	\N	29465	29465	29466
9473	8099	71	applied	\N	\N	\N	\N	29470	29470	29471
9473	8100	72	applied	\N	\N	\N	\N	29472	29472	29473
9473	8101	73	applied	\N	\N	\N	\N	29474	29474	29475
9473	8102	74	applied	\N	\N	\N	\N	29476	29476	29477
9473	8046	75	applied	\N	\N	\N	\N	29311	29311	29312
9473	8047	76	applied	\N	\N	\N	\N	29320	29320	29321
9473	8048	77	applied	\N	\N	\N	\N	29322	29322	29323
9473	8109	78	applied	\N	\N	\N	\N	29492	29492	29493
9473	8110	79	applied	\N	\N	\N	\N	29494	29494	29495
9473	8111	80	applied	\N	\N	\N	\N	29500	29500	29501
9473	8114	81	applied	\N	\N	\N	\N	29506	29506	29507
9473	8115	82	applied	\N	\N	\N	\N	29510	29510	29511
9473	8118	83	applied	\N	\N	\N	\N	29518	29518	29519
9473	8119	84	applied	\N	\N	\N	\N	29523	29523	29524
9473	8122	85	applied	\N	\N	\N	\N	29531	29531	29532
9473	8126	86	applied	\N	\N	\N	\N	29540	29540	29541
9473	8127	87	applied	\N	\N	\N	\N	29542	29542	29543
9473	8132	88	applied	\N	\N	\N	\N	29551	29551	29552
9473	8134	89	applied	\N	\N	\N	\N	29561	29561	29562
9473	8138	90	applied	\N	\N	\N	\N	29570	29570	29571
9473	8139	91	applied	\N	\N	\N	\N	29572	29572	29573
9473	8141	92	applied	\N	\N	\N	\N	29586	29586	29587
9473	8142	93	applied	\N	\N	\N	\N	29588	29588	29589
9473	8144	94	applied	\N	\N	\N	\N	29592	29592	29593
9473	8145	95	applied	\N	\N	\N	\N	29594	29594	29595
9473	8146	96	applied	\N	\N	\N	\N	29596	29596	29597
9473	8150	97	applied	\N	\N	\N	\N	29606	29606	29607
9473	8151	98	applied	\N	\N	\N	\N	29610	29610	29611
9473	8152	99	applied	\N	\N	\N	\N	29612	29612	29613
9473	8157	100	applied	\N	\N	\N	\N	29628	29628	29629
9473	8158	101	applied	\N	\N	\N	\N	29630	29630	29631
9473	8160	102	applied	\N	\N	\N	\N	29640	29640	29641
9473	8167	103	applied	\N	\N	\N	\N	29656	29656	29657
9473	8171	104	applied	\N	\N	\N	\N	29666	29666	29667
9473	8174	105	applied	\N	\N	\N	\N	29687	29687	29688
9473	8176	106	applied	\N	\N	\N	\N	29692	29692	29693
9473	8177	107	applied	\N	\N	\N	\N	29694	29694	29695
9473	8180	108	applied	\N	\N	\N	\N	29702	29702	29703
9473	8182	109	applied	\N	\N	\N	\N	29708	29708	29709
9473	8183	110	applied	\N	\N	\N	\N	29711	29711	29712
9473	8189	111	applied	\N	\N	\N	\N	29725	29725	29726
9473	8190	112	applied	\N	\N	\N	\N	29727	29727	29728
9473	8191	113	applied	\N	\N	\N	\N	29729	29729	29730
9473	8192	114	applied	\N	\N	\N	\N	29731	29731	29732
9473	8195	115	applied	\N	\N	\N	\N	29739	29739	29740
9473	8197	116	applied	\N	\N	\N	\N	29745	29745	29746
9473	8199	117	applied	\N	\N	\N	\N	29751	29751	29752
9473	8201	118	applied	\N	\N	\N	\N	29755	29755	29756
9473	8204	119	applied	\N	\N	\N	\N	29762	29762	29763
9473	8206	120	applied	\N	\N	\N	\N	29766	29766	29767
9473	8208	121	applied	\N	\N	\N	\N	29778	29778	29779
9473	8209	122	applied	\N	\N	\N	\N	29780	29780	29781
9473	8210	123	applied	\N	\N	\N	\N	29782	29782	29783
9473	8214	124	applied	\N	\N	\N	\N	29795	29795	29796
9473	8215	125	applied	\N	\N	\N	\N	29797	29797	29798
9474	8706	0	applied	\N	\N	\N	\N	31152	31152	31153
9474	8704	1	applied	\N	\N	\N	\N	31138	31138	31139
9474	8707	2	applied	\N	\N	\N	\N	31154	31154	31155
9480	8718	0	applied	\N	\N	\N	\N	31184	31184	31185
9480	8719	1	applied	\N	\N	\N	\N	31186	31186	31187
9487	8731	0	applied	\N	\N	\N	\N	31219	31219	31220
9487	8732	1	applied	\N	\N	\N	\N	31221	31221	31222
9490	8735	0	applied	\N	\N	\N	\N	31230	31230	31231
9490	8736	1	applied	\N	\N	\N	\N	31232	31232	31233
9492	8739	0	applied	\N	\N	\N	\N	31241	31241	31242
9492	8740	1	applied	\N	\N	\N	\N	31243	31243	31244
9492	8741	2	applied	\N	\N	\N	\N	31245	31245	31246
9499	8749	0	applied	\N	\N	\N	\N	31268	31268	31269
9499	8750	1	applied	\N	\N	\N	\N	31270	31270	31271
9499	8751	2	applied	\N	\N	\N	\N	31272	31272	31273
9499	8752	3	applied	\N	\N	\N	\N	31274	31274	31275
9505	8755	0	applied	\N	\N	\N	\N	31282	31282	31242
9505	8756	1	applied	\N	\N	\N	\N	31283	31283	31284
9505	8757	2	applied	\N	\N	\N	\N	31285	31285	31286
9508	8758	0	applied	\N	\N	\N	\N	31295	31295	31296
9508	8759	1	applied	\N	\N	\N	\N	31297	31297	31298
9511	8762	0	applied	\N	\N	\N	\N	31308	31308	31309
9511	8763	1	applied	\N	\N	\N	\N	31310	31310	31311
9511	8764	2	applied	\N	\N	\N	\N	31312	31312	31313
9513	8765	0	applied	\N	\N	\N	\N	31319	31319	31320
9513	8766	1	applied	\N	\N	\N	\N	31321	31321	31322
9515	8767	0	applied	\N	\N	\N	\N	31326	31326	31327
9515	8768	1	applied	\N	\N	\N	\N	31328	31328	31329
9518	8769	0	applied	\N	\N	\N	\N	31332	31332	31333
9518	8770	1	applied	\N	\N	\N	\N	31334	31334	31335
9520	8773	0	applied	\N	\N	1000000000	\N	31343	31343	31344
9520	8774	1	applied	\N	\N	\N	\N	31345	31345	31346
9520	8775	2	applied	\N	\N	\N	\N	31347	31347	31348
9520	8776	3	applied	\N	\N	\N	\N	31349	31349	31350
9520	8777	4	applied	\N	\N	\N	\N	31351	31351	31352
9520	8778	5	applied	\N	\N	\N	\N	31353	31353	31354
9525	8779	0	applied	\N	\N	\N	\N	31361	31361	31362
9525	8780	1	applied	\N	\N	\N	\N	31363	31363	31364
9525	8781	2	applied	\N	\N	\N	\N	31365	31365	31366
9525	8782	3	applied	\N	\N	\N	\N	31367	31367	31368
9525	8783	4	applied	\N	\N	\N	\N	31369	31369	31132
9527	8789	0	applied	\N	\N	\N	\N	31386	31386	31387
9527	8790	1	applied	\N	\N	\N	\N	31388	31388	31389
9530	8791	0	applied	\N	\N	\N	\N	31393	31393	31394
9530	8792	1	applied	\N	\N	\N	\N	31395	31395	31396
9530	8793	2	applied	\N	\N	\N	\N	31397	31397	31398
9530	8794	3	applied	\N	\N	\N	\N	31399	31399	31400
9530	8795	4	applied	\N	\N	\N	\N	31401	31401	31402
9532	8796	0	applied	\N	\N	\N	\N	31407	31407	31408
9532	8797	1	applied	\N	\N	\N	\N	31409	31409	31410
9532	8798	2	applied	\N	\N	\N	\N	31411	31411	31412
9532	8799	3	applied	\N	\N	\N	\N	31413	31413	31414
9532	8800	4	applied	\N	\N	\N	\N	31415	31415	31416
9535	8801	0	applied	\N	\N	\N	\N	31420	31420	31421
9535	8802	1	applied	\N	\N	\N	\N	31422	31422	31423
9537	8803	0	applied	\N	\N	\N	\N	31430	31430	31431
9537	8804	1	applied	\N	\N	\N	\N	31432	31432	31433
9537	8805	2	applied	\N	\N	\N	\N	31434	31434	31435
9539	8806	0	applied	\N	\N	\N	\N	31441	31441	31442
9539	8807	1	applied	\N	\N	\N	\N	31443	31443	31444
9539	8808	2	applied	\N	\N	\N	\N	31445	31445	31446
9539	8809	3	applied	\N	\N	\N	\N	31447	31447	31448
9539	8810	4	applied	\N	\N	\N	\N	31449	31449	31450
9544	8817	0	applied	\N	\N	\N	\N	31468	31468	31469
9544	8818	1	applied	\N	\N	\N	\N	31470	31470	31471
9547	8821	0	applied	\N	\N	\N	\N	31480	31480	31481
9547	8822	1	applied	\N	\N	\N	\N	31482	31482	31483
9547	8823	2	applied	\N	\N	\N	\N	31484	31484	31485
9547	8824	3	applied	\N	\N	\N	\N	31486	31486	31487
9558	8830	0	applied	\N	\N	\N	\N	31510	31510	31511
9558	8831	1	applied	\N	\N	\N	\N	31512	31512	31513
9558	8832	2	applied	\N	\N	\N	\N	31514	31514	31515
9558	8833	3	applied	\N	\N	\N	\N	31516	31516	31517
9561	8840	0	applied	\N	\N	\N	\N	31533	31533	31534
9561	8841	1	applied	\N	\N	\N	\N	31535	31535	31536
9564	8846	0	applied	\N	\N	\N	\N	31547	31547	31548
9564	8847	1	applied	\N	\N	\N	\N	31549	31549	31550
9564	8848	2	applied	\N	\N	\N	\N	31551	31551	31552
9566	8849	0	applied	\N	\N	\N	\N	31557	31557	31558
9566	8850	1	applied	\N	\N	\N	\N	31559	31559	31560
9569	8851	0	applied	\N	\N	\N	\N	31561	31561	31562
9569	8852	1	applied	\N	\N	\N	\N	31563	31563	31564
9569	8853	2	applied	\N	\N	\N	\N	31565	31565	31566
9569	8854	3	applied	\N	\N	\N	\N	31567	31567	31568
9569	8855	4	applied	\N	\N	\N	\N	31569	31569	31570
9569	8856	5	applied	\N	\N	\N	\N	31571	31571	31572
9569	8857	6	applied	\N	\N	\N	\N	31573	31573	31574
9569	8858	7	applied	\N	\N	\N	\N	31575	31575	31576
9569	8859	8	applied	\N	\N	\N	\N	31577	31577	31578
9574	8865	0	applied	\N	\N	\N	\N	31598	31598	31599
9574	8866	1	applied	\N	\N	\N	\N	31600	31600	31601
9579	8873	0	applied	\N	\N	1000000000	\N	31618	31618	31619
9579	8874	1	applied	\N	\N	\N	\N	31620	31620	31621
9579	8875	2	applied	\N	\N	\N	\N	31622	31622	31623
9581	8876	0	applied	\N	\N	\N	\N	31628	31628	31629
9581	8877	1	applied	\N	\N	\N	\N	31630	31630	31631
9589	8886	0	applied	\N	\N	\N	\N	31658	31658	31659
9589	8887	1	applied	\N	\N	\N	\N	31660	31660	31661
9591	8888	0	applied	\N	\N	\N	\N	31665	31665	31666
9591	8889	1	applied	\N	\N	\N	\N	31667	31667	31668
9594	8890	0	applied	\N	\N	\N	\N	31673	31673	31674
9594	8891	1	applied	\N	\N	\N	\N	31675	31675	31676
9598	8898	0	applied	\N	\N	\N	\N	31695	31695	31696
9598	8899	1	applied	\N	\N	\N	\N	31697	31697	31698
9598	8900	2	applied	\N	\N	\N	\N	31699	31699	31700
9598	8901	3	applied	\N	\N	\N	\N	31701	31701	31702
9603	8907	0	applied	\N	\N	\N	\N	31720	31720	31721
9603	8908	1	applied	\N	\N	\N	\N	31722	31722	31723
9606	8915	0	applied	\N	\N	\N	\N	31739	31739	31740
9606	8916	1	applied	\N	\N	\N	\N	31741	31741	31742
9606	8917	2	applied	\N	\N	\N	\N	31743	31743	31744
9606	8918	3	applied	\N	\N	\N	\N	31745	31745	31746
9483	8721	1	applied	\N	\N	\N	\N	31190	31190	31191
9488	8733	0	applied	\N	\N	1000000000	\N	31225	31225	31226
9488	8734	1	applied	\N	\N	\N	\N	31227	31227	31228
9494	8742	0	applied	\N	\N	\N	\N	31249	31249	31242
9494	8743	1	applied	\N	\N	\N	\N	31250	31250	31251
9494	8744	2	applied	\N	\N	\N	\N	31252	31252	31253
9494	8745	3	applied	\N	\N	\N	\N	31254	31254	31255
9494	8746	4	applied	\N	\N	\N	\N	31256	31256	31257
9496	8747	0	applied	\N	\N	\N	\N	31260	31260	31261
9496	8748	1	applied	\N	\N	\N	\N	31262	31262	31263
9501	8753	0	applied	\N	\N	\N	\N	31278	31278	31279
9501	8754	1	applied	\N	\N	\N	\N	31280	31280	31281
9503	8755	0	applied	\N	\N	\N	\N	31282	31282	31242
9503	8756	1	applied	\N	\N	\N	\N	31283	31283	31284
9503	8757	2	applied	\N	\N	\N	\N	31285	31285	31286
9506	8755	0	applied	\N	\N	\N	\N	31282	31282	31242
9506	8756	1	applied	\N	\N	\N	\N	31283	31283	31284
9506	8757	2	applied	\N	\N	\N	\N	31285	31285	31286
9507	8758	0	applied	\N	\N	\N	\N	31295	31295	31296
9507	8759	1	applied	\N	\N	\N	\N	31297	31297	31298
9509	8760	0	applied	\N	\N	\N	\N	31302	31302	31303
9509	8761	1	applied	\N	\N	\N	\N	31304	31304	31305
9512	8762	0	applied	\N	\N	\N	\N	31308	31308	31309
9512	8763	1	applied	\N	\N	\N	\N	31310	31310	31311
9512	8764	2	applied	\N	\N	\N	\N	31312	31312	31313
9522	8773	0	applied	\N	\N	1000000000	\N	31343	31343	31344
9522	8774	1	applied	\N	\N	\N	\N	31345	31345	31346
9522	8775	2	applied	\N	\N	\N	\N	31347	31347	31348
9522	8776	3	applied	\N	\N	\N	\N	31349	31349	31350
9522	8777	4	applied	\N	\N	\N	\N	31351	31351	31352
9522	8778	5	applied	\N	\N	\N	\N	31353	31353	31354
9523	8773	0	applied	\N	\N	1000000000	\N	31343	31343	31344
9523	8774	1	applied	\N	\N	\N	\N	31345	31345	31346
9523	8775	2	applied	\N	\N	\N	\N	31347	31347	31348
9523	8776	3	applied	\N	\N	\N	\N	31349	31349	31350
9523	8777	4	applied	\N	\N	\N	\N	31351	31351	31352
9523	8778	5	applied	\N	\N	\N	\N	31353	31353	31354
9526	8784	0	applied	\N	\N	\N	\N	31374	31374	31375
9526	8785	1	applied	\N	\N	\N	\N	31376	31376	31377
9526	8786	2	applied	\N	\N	\N	\N	31378	31378	31379
9526	8787	3	applied	\N	\N	\N	\N	31380	31380	31381
9526	8788	4	applied	\N	\N	\N	\N	31382	31382	31383
9531	8796	0	applied	\N	\N	\N	\N	31407	31407	31408
9531	8797	1	applied	\N	\N	\N	\N	31409	31409	31410
9531	8798	2	applied	\N	\N	\N	\N	31411	31411	31412
9531	8799	3	applied	\N	\N	\N	\N	31413	31413	31414
9531	8800	4	applied	\N	\N	\N	\N	31415	31415	31416
9538	8803	0	applied	\N	\N	\N	\N	31430	31430	31431
9538	8804	1	applied	\N	\N	\N	\N	31432	31432	31433
9541	8811	0	applied	\N	\N	\N	\N	31452	31452	31453
9541	8812	1	applied	\N	\N	\N	\N	31454	31454	31455
9541	8813	2	applied	\N	\N	\N	\N	31456	31456	31457
9541	8814	3	applied	\N	\N	\N	\N	31458	31458	31459
9543	8815	0	applied	\N	\N	\N	\N	31464	31464	31465
9543	8816	1	applied	\N	\N	\N	\N	31466	31466	31467
9546	8819	0	applied	\N	\N	\N	\N	31472	31472	31473
9546	8820	1	applied	\N	\N	\N	\N	31474	31474	31475
9548	8825	0	applied	\N	\N	\N	\N	31489	31489	31490
9548	8826	1	applied	\N	\N	\N	\N	31491	31491	31492
9560	8838	0	applied	\N	\N	\N	\N	31529	31529	31530
9560	8839	1	applied	\N	\N	\N	\N	31531	31531	31532
9570	8851	0	applied	\N	\N	\N	\N	31561	31561	31562
9570	8852	1	applied	\N	\N	\N	\N	31563	31563	31564
9570	8853	2	applied	\N	\N	\N	\N	31565	31565	31566
9570	8854	3	applied	\N	\N	\N	\N	31567	31567	31568
9570	8855	4	applied	\N	\N	\N	\N	31569	31569	31570
9570	8856	5	applied	\N	\N	\N	\N	31571	31571	31572
9570	8857	6	applied	\N	\N	\N	\N	31573	31573	31574
9570	8858	7	applied	\N	\N	\N	\N	31575	31575	31576
9570	8859	8	applied	\N	\N	\N	\N	31577	31577	31578
9578	8872	0	applied	\N	\N	\N	\N	31614	31614	31615
9583	8880	0	applied	\N	\N	\N	\N	31640	31640	31640
9583	8881	1	applied	\N	\N	\N	\N	31641	31641	31642
9583	8882	2	applied	\N	\N	\N	\N	31643	31643	31644
9583	8883	3	applied	\N	\N	\N	\N	31645	31645	31646
9585	8884	0	applied	\N	\N	\N	\N	31651	31651	31652
9585	8885	1	applied	\N	\N	\N	\N	31653	31653	31654
9592	8890	0	applied	\N	\N	\N	\N	31673	31673	31674
9592	8891	1	applied	\N	\N	\N	\N	31675	31675	31676
9597	8898	0	applied	\N	\N	\N	\N	31695	31695	31696
9597	8899	1	applied	\N	\N	\N	\N	31697	31697	31698
9597	8900	2	applied	\N	\N	\N	\N	31699	31699	31700
9597	8901	3	applied	\N	\N	\N	\N	31701	31701	31702
9605	8909	0	applied	\N	\N	\N	\N	31726	31726	31727
9605	8910	1	applied	\N	\N	\N	\N	31728	31728	31729
9605	8911	2	applied	\N	\N	\N	\N	31730	31730	31731
9605	8912	3	applied	\N	\N	\N	\N	31732	31732	31733
9605	8913	4	applied	\N	\N	\N	\N	31734	31734	31734
9605	8914	5	applied	\N	\N	\N	\N	31735	31735	31735
9607	8915	0	applied	\N	\N	\N	\N	31739	31739	31740
9607	8916	1	applied	\N	\N	\N	\N	31741	31741	31742
9607	8917	2	applied	\N	\N	\N	\N	31743	31743	31744
9607	8918	3	applied	\N	\N	\N	\N	31745	31745	31746
9610	8923	0	applied	\N	\N	\N	\N	31760	31760	31761
9610	8924	1	applied	\N	\N	\N	\N	31762	31762	31763
9610	8925	2	applied	\N	\N	\N	\N	31764	31764	31764
9610	8926	3	applied	\N	\N	\N	\N	31765	31765	31765
9610	8927	4	applied	\N	\N	\N	\N	31766	31766	31766
9612	8928	0	applied	\N	\N	\N	\N	31770	31770	31771
9612	8929	1	applied	\N	\N	\N	\N	31772	31772	31773
9614	8930	0	applied	\N	\N	\N	\N	31776	31776	31777
9614	8931	1	applied	\N	\N	\N	\N	31778	31778	31779
9617	8932	0	applied	\N	\N	\N	\N	31782	31782	31783
9617	8933	1	applied	\N	\N	\N	\N	31784	31784	31785
9620	8933	0	applied	\N	\N	\N	\N	31784	31784	31785
9620	8934	1	applied	\N	\N	\N	\N	31790	31790	31791
9620	8935	2	applied	\N	\N	\N	\N	31792	31792	31793
9620	8936	3	applied	\N	\N	\N	\N	31794	31794	31795
9620	8937	4	applied	\N	\N	\N	\N	31796	31796	31797
9620	8938	5	applied	\N	\N	\N	\N	31798	31798	31799
9620	8939	6	applied	\N	\N	\N	\N	31800	31800	31801
9620	8940	7	applied	\N	\N	\N	\N	31802	31802	31803
9620	8941	8	applied	\N	\N	\N	\N	31804	31804	31805
9622	8942	0	applied	\N	\N	\N	\N	31811	31811	31812
9622	8943	1	applied	\N	\N	\N	\N	31813	31813	31814
9622	8944	2	applied	\N	\N	\N	\N	31815	31815	31816
9622	8945	3	applied	\N	\N	\N	\N	31817	31817	31818
9622	8946	4	applied	\N	\N	\N	\N	31819	31819	31820
9622	8947	5	applied	\N	\N	\N	\N	31821	31821	31822
9542	8811	0	applied	\N	\N	\N	\N	31452	31452	31453
9542	8812	1	applied	\N	\N	\N	\N	31454	31454	31455
9542	8813	2	applied	\N	\N	\N	\N	31456	31456	31457
9542	8814	3	applied	\N	\N	\N	\N	31458	31458	31459
9549	8827	0	applied	\N	\N	\N	\N	31495	31495	31496
9549	8828	1	applied	\N	\N	\N	\N	31497	31497	31498
9551	8827	0	applied	\N	\N	\N	\N	31495	31495	31496
9553	8829	0	applied	\N	\N	\N	\N	31505	31505	31506
9555	8829	0	applied	\N	\N	\N	\N	31505	31505	31506
9563	8842	0	applied	\N	\N	\N	\N	31537	31537	31538
9563	8843	1	applied	\N	\N	\N	\N	31539	31539	31540
9563	8844	2	applied	\N	\N	\N	\N	31541	31541	31542
9563	8845	3	applied	\N	\N	\N	\N	31543	31543	31544
9568	8849	0	applied	\N	\N	\N	\N	31557	31557	31558
9568	8850	1	applied	\N	\N	\N	\N	31559	31559	31560
9571	8860	0	applied	\N	\N	\N	\N	31583	31583	31584
9571	8861	1	applied	\N	\N	\N	\N	31585	31585	31586
9571	8862	2	applied	\N	\N	\N	\N	31587	31587	31588
9573	8863	0	applied	\N	\N	\N	\N	31590	31590	31591
9573	8864	1	applied	\N	\N	\N	\N	31592	31592	31593
9576	8869	0	applied	\N	\N	\N	\N	31608	31608	31609
9576	8870	1	applied	\N	\N	\N	\N	31610	31610	31611
9584	8880	0	applied	\N	\N	\N	\N	31640	31640	31640
9584	8881	1	applied	\N	\N	\N	\N	31641	31641	31642
9584	8882	2	applied	\N	\N	\N	\N	31643	31643	31644
9584	8883	3	applied	\N	\N	\N	\N	31645	31645	31646
9586	8884	0	applied	\N	\N	\N	\N	31651	31651	31652
9586	8885	1	applied	\N	\N	\N	\N	31653	31653	31654
9588	8886	0	applied	\N	\N	\N	\N	31658	31658	31659
9588	8887	1	applied	\N	\N	\N	\N	31660	31660	31661
9590	8888	0	applied	\N	\N	\N	\N	31665	31665	31666
9590	8889	1	applied	\N	\N	\N	\N	31667	31667	31668
9593	8890	0	applied	\N	\N	\N	\N	31673	31673	31674
9593	8891	1	applied	\N	\N	\N	\N	31675	31675	31676
9595	8892	0	applied	\N	\N	\N	\N	31680	31680	31681
9595	8893	1	applied	\N	\N	\N	\N	31682	31682	31683
9595	8894	2	applied	\N	\N	\N	\N	31684	31684	31685
9595	8895	3	applied	\N	\N	\N	\N	31686	31686	31687
9600	8902	0	applied	\N	\N	\N	\N	31706	31706	31707
9600	8903	1	applied	\N	\N	\N	\N	31708	31708	31709
9600	8904	2	applied	\N	\N	\N	\N	31710	31710	31711
9602	8905	0	applied	\N	\N	\N	\N	31716	31716	31717
9602	8906	1	applied	\N	\N	\N	\N	31718	31718	31719
9608	8919	0	applied	\N	\N	\N	\N	31751	31751	31752
9608	8920	1	applied	\N	\N	\N	\N	31753	31753	31754
9608	8921	2	applied	\N	\N	\N	\N	31755	31755	31756
9608	8922	3	applied	\N	\N	\N	\N	31757	31757	31758
9615	8930	0	applied	\N	\N	\N	\N	31776	31776	31777
9615	8931	1	applied	\N	\N	\N	\N	31778	31778	31779
9621	8933	0	applied	\N	\N	\N	\N	31784	31784	31785
9621	8934	1	applied	\N	\N	\N	\N	31790	31790	31791
9621	8935	2	applied	\N	\N	\N	\N	31792	31792	31793
9621	8936	3	applied	\N	\N	\N	\N	31794	31794	31795
9621	8937	4	applied	\N	\N	\N	\N	31796	31796	31797
9621	8938	5	applied	\N	\N	\N	\N	31798	31798	31799
9621	8939	6	applied	\N	\N	\N	\N	31800	31800	31801
9621	8940	7	applied	\N	\N	\N	\N	31802	31802	31803
9621	8941	8	applied	\N	\N	\N	\N	31804	31804	31805
9626	8960	0	applied	\N	\N	\N	\N	31853	31853	31854
9626	8961	1	applied	\N	\N	\N	\N	31855	31855	31856
9626	8962	2	applied	\N	\N	\N	\N	31857	31857	31858
9626	8963	3	applied	\N	\N	\N	\N	31859	31859	10878
9626	8964	4	applied	\N	\N	\N	\N	31860	31860	31861
9626	8965	5	applied	\N	\N	\N	\N	31862	31862	31863
9626	8966	6	applied	\N	\N	\N	\N	31864	31864	31865
9626	8967	7	applied	\N	\N	\N	\N	31866	31866	31867
9626	8968	8	applied	\N	\N	\N	\N	31868	31868	31869
9626	8969	9	applied	\N	\N	\N	\N	31870	31870	31871
9626	8970	10	applied	\N	\N	\N	\N	31872	31872	31873
9626	8971	11	applied	\N	\N	\N	\N	31874	31874	31875
9626	8972	12	applied	\N	\N	\N	\N	31876	31876	31877
9626	8973	13	applied	\N	\N	\N	\N	31878	31878	31879
9626	8974	14	applied	\N	\N	\N	\N	31880	31880	31881
9626	8975	15	applied	\N	\N	\N	\N	31882	31882	31883
9626	8976	16	applied	\N	\N	\N	\N	31884	31884	31885
9626	8977	17	applied	\N	\N	\N	\N	31886	31886	31887
9626	8978	18	applied	\N	\N	\N	\N	31888	31888	31889
9626	8979	19	applied	\N	\N	\N	\N	31890	31890	31891
9626	8980	20	applied	\N	\N	\N	\N	31892	31892	31893
9626	8981	21	applied	\N	\N	\N	\N	31894	31894	31895
9626	8982	22	applied	\N	\N	\N	\N	31896	31896	31897
9626	8983	23	applied	\N	\N	\N	\N	31898	31898	31899
9626	8984	24	applied	\N	\N	\N	\N	31900	31900	31901
9626	8985	25	applied	\N	\N	\N	\N	31902	31902	31903
9626	8986	26	applied	\N	\N	\N	\N	31904	31904	31905
9626	8987	27	applied	\N	\N	\N	\N	31906	31906	31907
9626	8988	28	applied	\N	\N	\N	\N	31908	31908	31909
9626	8989	29	applied	\N	\N	\N	\N	31910	31910	31911
9626	8990	30	applied	\N	\N	\N	\N	31912	31912	31913
9629	8993	0	applied	\N	\N	\N	\N	31923	31923	31924
9629	8994	1	applied	\N	\N	\N	\N	31925	31925	31926
9629	8995	2	applied	\N	\N	\N	\N	31927	31927	31928
9629	8996	3	applied	\N	\N	\N	\N	31929	31929	31930
9629	8997	4	applied	\N	\N	\N	\N	31931	31931	31932
9629	8998	5	applied	\N	\N	\N	\N	31933	31933	31934
9629	8999	6	applied	\N	\N	\N	\N	31935	31935	31936
9634	9004	0	applied	\N	\N	\N	\N	31953	31953	31954
9634	9005	1	applied	\N	\N	\N	\N	31955	31955	31956
9634	9006	2	applied	\N	\N	\N	\N	31957	31957	31958
9634	9007	3	applied	\N	\N	\N	\N	31959	31959	31960
9634	9008	4	applied	\N	\N	\N	\N	31961	31961	31962
9634	9009	5	applied	\N	\N	\N	\N	31963	31963	31964
9634	9010	6	applied	\N	\N	\N	\N	31965	31965	31966
9634	9011	7	applied	\N	\N	\N	\N	31967	31967	31968
9634	9012	8	applied	\N	\N	\N	\N	31969	31969	31970
9634	9013	9	applied	\N	\N	\N	\N	31971	31971	31972
9637	9010	0	applied	\N	\N	\N	\N	31965	31965	31966
9637	9011	1	applied	\N	\N	\N	\N	31967	31967	31968
9637	9012	2	applied	\N	\N	\N	\N	31969	31969	31970
9637	9013	3	applied	\N	\N	\N	\N	31971	31971	31972
9640	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9640	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9643	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9643	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9645	9020	0	applied	\N	\N	\N	\N	31999	31999	32000
9645	9021	1	applied	\N	\N	\N	\N	32001	32001	32002
9648	9026	0	applied	\N	\N	\N	\N	32017	32017	32018
9648	9027	1	applied	\N	\N	\N	\N	32019	32019	32020
9648	9028	2	applied	\N	\N	\N	\N	32021	32021	32022
9650	9029	0	applied	\N	\N	\N	\N	32026	32026	32027
9604	8912	3	applied	\N	\N	\N	\N	31732	31732	31733
9604	8913	4	applied	\N	\N	\N	\N	31734	31734	31734
9604	8914	5	applied	\N	\N	\N	\N	31735	31735	31735
9609	8923	0	applied	\N	\N	\N	\N	31760	31760	31761
9609	8924	1	applied	\N	\N	\N	\N	31762	31762	31763
9609	8925	2	applied	\N	\N	\N	\N	31764	31764	31764
9609	8926	3	applied	\N	\N	\N	\N	31765	31765	31765
9609	8927	4	applied	\N	\N	\N	\N	31766	31766	31766
9616	8932	0	applied	\N	\N	\N	\N	31782	31782	31783
9616	8933	1	applied	\N	\N	\N	\N	31784	31784	31785
9618	8932	0	applied	\N	\N	\N	\N	31782	31782	31783
9619	8933	0	applied	\N	\N	\N	\N	31784	31784	31785
9619	8934	1	applied	\N	\N	\N	\N	31790	31790	31791
9619	8935	2	applied	\N	\N	\N	\N	31792	31792	31793
9619	8936	3	applied	\N	\N	\N	\N	31794	31794	31795
9619	8937	4	applied	\N	\N	\N	\N	31796	31796	31797
9619	8938	5	applied	\N	\N	\N	\N	31798	31798	31799
9619	8939	6	applied	\N	\N	\N	\N	31800	31800	31801
9619	8940	7	applied	\N	\N	\N	\N	31802	31802	31803
9619	8941	8	applied	\N	\N	\N	\N	31804	31804	31805
9625	8958	0	applied	\N	\N	\N	\N	31848	31848	31849
9625	8959	1	applied	\N	\N	\N	\N	31850	31850	31851
9631	9000	0	applied	\N	\N	\N	\N	31940	31940	31941
9631	9001	1	applied	\N	\N	\N	\N	31942	31942	31943
9631	9002	2	applied	\N	\N	\N	\N	31944	31944	31945
9639	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9639	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9642	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9642	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9647	9024	0	applied	\N	\N	\N	\N	32011	32011	32012
9647	9025	1	applied	\N	\N	\N	\N	32013	32013	32014
9652	9031	0	applied	\N	\N	\N	\N	32034	32034	32035
9652	9032	1	applied	\N	\N	\N	\N	32036	32036	32037
9654	9033	0	applied	\N	\N	\N	\N	32041	32041	32042
9654	9034	1	applied	\N	\N	\N	\N	32043	32043	32044
9654	9035	2	applied	\N	\N	\N	\N	32045	32045	32046
9657	9042	0	applied	\N	\N	\N	\N	32066	32066	32067
9657	9043	1	applied	\N	\N	\N	\N	32068	32068	32069
9657	9044	2	applied	\N	\N	\N	\N	32070	32070	32071
9657	9045	3	applied	\N	\N	\N	\N	32072	32072	32073
9657	9046	4	applied	\N	\N	\N	\N	32074	32074	32075
9657	9047	5	applied	\N	\N	\N	\N	32076	32076	32077
9660	9048	0	applied	\N	\N	\N	\N	32080	32080	32081
9660	9049	1	applied	\N	\N	\N	\N	32082	32082	32083
9662	9052	0	applied	\N	\N	\N	\N	32096	32096	32097
9662	9053	1	applied	\N	\N	\N	\N	32098	32098	32099
9662	9054	2	applied	\N	\N	\N	\N	32100	32100	32101
9669	9063	0	applied	\N	\N	\N	\N	32127	32127	32128
9669	9064	1	applied	\N	\N	\N	\N	32129	32129	32130
9676	9071	0	applied	\N	\N	\N	\N	32149	32149	32150
9676	9072	1	applied	\N	\N	\N	\N	32151	32151	32152
9676	9073	2	applied	\N	\N	\N	\N	32153	32153	32154
9679	9075	0	applied	\N	\N	\N	\N	32160	32160	32161
9679	9076	1	applied	\N	\N	\N	\N	32162	32162	32163
9679	9077	2	applied	\N	\N	\N	\N	32164	32164	32165
9679	9078	3	applied	\N	\N	\N	\N	32166	32166	32167
9687	9084	0	applied	\N	\N	\N	\N	32188	32188	32189
9687	9085	1	applied	\N	\N	\N	\N	32190	32190	32191
9691	9096	0	applied	\N	\N	\N	\N	32216	32216	32217
9691	9097	1	applied	\N	\N	\N	\N	32218	32218	32219
9691	9098	2	applied	\N	\N	\N	\N	32220	32220	32221
9691	9099	3	applied	\N	\N	\N	\N	32222	32222	32223
9691	9100	4	applied	\N	\N	\N	\N	32224	32224	32225
9691	9101	5	applied	\N	\N	\N	\N	32226	32226	32227
9691	9102	6	applied	\N	\N	\N	\N	32228	32228	32229
9691	9103	7	applied	\N	\N	\N	\N	32230	32230	32231
9691	9104	8	applied	\N	\N	\N	\N	32232	32232	32233
9691	9105	9	applied	\N	\N	\N	\N	32234	32234	32207
9693	9106	0	applied	\N	\N	\N	\N	32237	32237	32238
9695	9107	0	applied	\N	\N	\N	\N	32242	32242	32243
9695	9108	1	applied	\N	\N	\N	\N	32244	32244	32245
9695	9109	2	applied	\N	\N	\N	\N	32246	32246	32247
9697	9110	0	applied	\N	\N	\N	\N	32253	32253	32205
9697	9111	1	applied	\N	\N	\N	\N	32254	32254	32255
9697	9112	2	applied	\N	\N	\N	\N	32256	32256	32257
9699	9110	0	applied	\N	\N	\N	\N	32253	32253	32205
9699	9111	1	applied	\N	\N	\N	\N	32254	32254	32255
9699	9112	2	applied	\N	\N	\N	\N	32256	32256	32257
9699	9115	3	applied	\N	\N	\N	\N	32265	32265	32266
9699	9113	4	applied	\N	\N	\N	\N	32259	32259	32260
9699	9114	5	applied	\N	\N	\N	\N	32261	32261	32262
9699	9116	6	applied	\N	\N	\N	\N	32267	32267	32268
9699	9117	7	applied	\N	\N	\N	\N	32269	32269	32270
9702	9121	0	applied	\N	\N	\N	\N	32283	32283	32284
9702	9122	1	applied	\N	\N	\N	\N	32285	32285	32286
9702	9123	2	applied	\N	\N	\N	\N	32287	32287	32288
9702	9124	3	applied	\N	\N	\N	\N	32289	32289	32290
9704	9126	0	applied	\N	\N	\N	\N	32295	32295	32296
9704	9127	1	applied	\N	\N	\N	\N	32298	32298	32299
9704	9125	2	applied	\N	\N	\N	\N	32293	32293	32294
9704	9128	3	applied	\N	\N	\N	\N	32300	32300	32301
9707	9128	0	applied	\N	\N	\N	\N	32300	32300	32301
9707	9127	1	applied	\N	\N	\N	\N	32298	32298	32299
9711	9132	0	applied	\N	\N	\N	\N	32316	32316	32317
9713	9133	0	applied	\N	\N	\N	\N	32321	32321	32322
9713	9134	1	applied	\N	\N	\N	\N	32323	32323	32324
9713	9135	2	applied	\N	\N	\N	\N	32325	32325	32326
9713	9136	3	applied	\N	\N	\N	\N	32327	32327	32328
9715	8871	0	applied	\N	\N	\N	\N	31612	31612	31613
9715	8880	1	applied	\N	\N	\N	\N	31640	31640	31640
9715	9108	2	applied	\N	\N	\N	\N	32244	32244	32245
9715	8873	3	applied	\N	\N	1000000000	\N	31618	31618	31619
9715	8874	4	applied	\N	\N	\N	\N	31620	31620	31621
9715	8876	5	applied	\N	\N	\N	\N	31628	31628	31629
9715	8879	6	applied	\N	\N	\N	\N	31636	31636	31637
9715	8881	7	applied	\N	\N	\N	\N	31641	31641	31642
9715	9131	8	applied	\N	\N	\N	\N	32311	32311	32312
9715	9133	9	applied	\N	\N	\N	\N	32321	32321	32322
9715	9135	10	applied	\N	\N	\N	\N	32325	32325	32326
9715	8884	11	applied	\N	\N	\N	\N	31651	31651	31652
9715	8886	12	applied	\N	\N	\N	\N	31658	31658	31659
9715	8888	13	applied	\N	\N	\N	\N	31665	31665	31666
9715	8890	14	applied	\N	\N	\N	\N	31673	31673	31674
9715	8904	15	applied	\N	\N	\N	\N	31710	31710	31711
9715	8892	16	applied	\N	\N	\N	\N	31680	31680	31681
9715	8893	17	applied	\N	\N	\N	\N	31682	31682	31683
9715	8896	18	applied	\N	\N	\N	\N	31689	31689	31690
9715	8898	19	applied	\N	\N	\N	\N	31695	31695	31696
9715	8900	20	applied	\N	\N	\N	\N	31699	31699	31700
9715	8902	21	applied	\N	\N	\N	\N	31706	31706	31707
9611	8928	0	applied	\N	\N	\N	\N	31770	31770	31771
9611	8929	1	applied	\N	\N	\N	\N	31772	31772	31773
9613	8928	0	applied	\N	\N	\N	\N	31770	31770	31771
9613	8929	1	applied	\N	\N	\N	\N	31772	31772	31773
9624	8955	0	applied	\N	\N	\N	\N	31840	31840	31841
9624	8956	1	applied	\N	\N	\N	\N	31842	31842	31843
9624	8957	2	applied	\N	\N	1000000000	\N	31844	31844	31845
9627	8991	0	applied	\N	\N	\N	\N	31915	31915	31916
9627	8992	1	applied	\N	\N	\N	\N	31917	31917	31918
9630	8993	0	applied	\N	\N	\N	\N	31923	31923	31924
9630	8994	1	applied	\N	\N	\N	\N	31925	31925	31926
9630	8995	2	applied	\N	\N	\N	\N	31927	31927	31928
9630	8996	3	applied	\N	\N	\N	\N	31929	31929	31930
9630	8997	4	applied	\N	\N	\N	\N	31931	31931	31932
9630	8998	5	applied	\N	\N	\N	\N	31933	31933	31934
9630	8999	6	applied	\N	\N	\N	\N	31935	31935	31936
9633	9003	0	applied	\N	\N	\N	\N	31947	31947	31948
9636	9014	0	applied	\N	\N	\N	\N	31975	31975	31976
9636	9015	1	applied	\N	\N	\N	\N	31977	31977	31978
9636	9016	2	applied	\N	\N	\N	\N	31979	31979	31980
9636	9017	3	applied	\N	\N	\N	\N	31981	31981	31982
9638	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9638	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9641	9018	0	applied	\N	\N	\N	\N	31989	31989	31990
9641	9019	1	applied	\N	\N	\N	\N	31991	31991	31992
9656	9039	0	applied	\N	\N	\N	\N	32058	32058	32059
9656	9040	1	applied	\N	\N	\N	\N	32060	32060	32061
9656	9041	2	applied	\N	\N	\N	\N	32062	32062	32063
9664	9052	0	applied	\N	\N	\N	\N	32096	32096	32097
9664	9053	1	applied	\N	\N	\N	\N	32098	32098	32099
9664	9054	2	applied	\N	\N	\N	\N	32100	32100	32101
9666	9059	0	applied	\N	\N	\N	\N	32117	32117	32118
9666	9060	1	applied	\N	\N	\N	\N	32119	32119	32120
9671	9063	0	applied	\N	\N	\N	\N	32127	32127	32128
9671	9064	1	applied	\N	\N	\N	\N	32129	32129	32130
9682	9079	0	applied	\N	\N	\N	\N	32173	32173	32174
9682	9080	1	applied	\N	\N	\N	\N	32175	32175	32176
9682	9081	2	applied	\N	\N	\N	\N	32177	32177	32178
9686	9082	0	applied	\N	\N	\N	\N	32180	32180	32181
9686	9083	1	applied	\N	\N	\N	\N	32182	32182	32183
9689	9091	0	applied	\N	\N	1000000000	\N	32205	32205	32206
9689	9092	1	applied	\N	\N	\N	\N	32207	32207	32208
9689	9093	2	applied	\N	\N	\N	\N	32209	32209	32210
9689	9094	3	applied	\N	\N	\N	\N	32211	32211	32212
9689	9095	4	applied	\N	\N	\N	\N	32213	32213	32214
9690	9096	0	applied	\N	\N	\N	\N	32216	32216	32217
9690	9097	1	applied	\N	\N	\N	\N	32218	32218	32219
9690	9098	2	applied	\N	\N	\N	\N	32220	32220	32221
9690	9099	3	applied	\N	\N	\N	\N	32222	32222	32223
9690	9100	4	applied	\N	\N	\N	\N	32224	32224	32225
9690	9101	5	applied	\N	\N	\N	\N	32226	32226	32227
9690	9102	6	applied	\N	\N	\N	\N	32228	32228	32229
9690	9103	7	applied	\N	\N	\N	\N	32230	32230	32231
9690	9104	8	applied	\N	\N	\N	\N	32232	32232	32233
9690	9105	9	applied	\N	\N	\N	\N	32234	32234	32207
9692	9106	0	applied	\N	\N	\N	\N	32237	32237	32238
9701	9118	0	applied	\N	\N	\N	\N	32274	32274	32275
9701	9115	1	applied	\N	\N	\N	\N	32265	32265	32266
9701	9119	2	applied	\N	\N	\N	\N	32276	32276	32277
9701	9120	3	applied	\N	\N	\N	\N	32278	32278	32279
9701	9113	4	applied	\N	\N	\N	\N	32259	32259	32260
9701	9114	5	applied	\N	\N	\N	\N	32261	32261	32262
9701	9116	6	applied	\N	\N	\N	\N	32267	32267	32268
9701	9117	7	applied	\N	\N	\N	\N	32269	32269	32270
9706	9126	0	applied	\N	\N	\N	\N	32295	32295	32296
9706	9127	1	applied	\N	\N	\N	\N	32298	32298	32299
9706	9125	2	applied	\N	\N	\N	\N	32293	32293	32294
9706	9128	3	applied	\N	\N	\N	\N	32300	32300	32301
9708	9129	0	applied	\N	\N	\N	\N	32307	32307	32308
9708	9130	1	applied	\N	\N	\N	\N	32309	32309	32310
9708	9131	2	applied	\N	\N	\N	\N	32311	32311	32312
9710	9132	0	applied	\N	\N	\N	\N	32316	32316	32317
9717	9137	0	applied	\N	\N	\N	\N	32336	32336	32337
9717	9138	1	applied	\N	\N	\N	\N	32338	32338	32339
9717	9139	2	applied	\N	\N	\N	\N	32340	32340	32341
9717	9140	3	applied	\N	\N	\N	\N	32342	32342	32343
9717	9141	4	applied	\N	\N	\N	\N	32344	32344	32345
9717	9142	5	applied	\N	\N	\N	\N	32346	32346	32347
9719	9137	0	applied	\N	\N	\N	\N	32336	32336	32337
9719	9139	1	applied	\N	\N	\N	\N	32340	32340	32341
9719	9140	2	applied	\N	\N	\N	\N	32342	32342	32343
9719	9141	3	applied	\N	\N	\N	\N	32344	32344	32345
9719	9142	4	applied	\N	\N	\N	\N	32346	32346	32347
9721	9144	0	applied	\N	\N	\N	\N	32356	32356	32357
9721	9145	1	applied	\N	\N	\N	\N	32358	32358	32359
9721	9146	2	applied	\N	\N	\N	\N	32360	32360	32361
9721	9147	3	applied	\N	\N	\N	\N	32362	32362	32363
9734	9172	0	applied	\N	\N	\N	\N	32444	32444	32445
9734	9173	1	applied	\N	\N	\N	\N	32446	32446	32350
9734	9174	2	applied	\N	\N	\N	\N	32447	32447	32448
9734	9175	3	applied	\N	\N	\N	\N	32449	32449	32450
9734	9176	4	applied	\N	\N	\N	\N	32451	32451	32452
9734	9177	5	applied	\N	\N	\N	\N	32453	32453	32454
9734	9178	6	applied	\N	\N	\N	\N	32455	32455	32456
9734	9179	7	applied	\N	\N	\N	\N	32457	32457	32458
9734	9180	8	applied	\N	\N	\N	\N	32459	32459	32460
9734	9181	9	applied	\N	\N	\N	\N	32461	32461	32462
9734	9182	10	applied	\N	\N	\N	\N	32463	32463	32464
9734	9183	11	applied	\N	\N	\N	\N	32465	32465	32466
9734	9184	12	applied	\N	\N	1000000000	\N	32467	32467	32468
9741	9195	0	applied	\N	\N	\N	\N	32499	32499	32500
9741	9196	1	applied	\N	\N	\N	\N	32501	32501	32502
9741	9197	2	applied	\N	\N	\N	\N	32503	32503	32504
9741	9198	3	applied	\N	\N	\N	\N	32505	32505	32506
9741	9199	4	applied	\N	\N	\N	\N	32507	32507	32508
9741	9200	5	applied	\N	\N	\N	\N	32509	32509	32510
9741	9201	6	applied	\N	\N	\N	\N	32511	32511	32512
9745	9204	0	applied	\N	\N	\N	\N	32521	32521	32522
9745	9205	1	applied	\N	\N	\N	\N	32523	32523	32524
9745	9206	2	applied	\N	\N	\N	\N	32525	32525	32526
9745	9207	3	applied	\N	\N	\N	\N	32527	32527	32528
9745	9208	4	applied	\N	\N	\N	\N	32529	32529	32530
9750	9215	0	applied	\N	\N	\N	\N	32553	32553	32554
9750	9216	1	applied	\N	\N	\N	\N	32555	32555	32556
9750	9217	2	applied	\N	\N	\N	\N	32557	32557	32558
9750	9218	3	applied	\N	\N	\N	\N	32559	32559	32560
9755	9224	0	applied	\N	\N	\N	\N	32580	32580	32581
9755	9225	1	applied	\N	\N	\N	\N	32582	32582	32583
9757	9230	0	applied	\N	\N	\N	\N	32595	32595	32596
9623	8948	0	applied	\N	\N	\N	\N	31825	31825	31826
9623	8949	1	applied	\N	\N	\N	\N	31827	31827	31828
9623	8950	2	applied	\N	\N	\N	\N	31829	31829	31830
9623	8951	3	applied	\N	\N	\N	\N	31831	31831	31832
9623	8952	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	31833	31833	\N
9623	8953	5	applied	\N	\N	\N	\N	31834	31834	31835
9623	8954	6	applied	\N	\N	\N	\N	31836	31836	31837
9628	8991	0	applied	\N	\N	\N	\N	31915	31915	31916
9628	8992	1	applied	\N	\N	\N	\N	31917	31917	31918
9632	9003	0	applied	\N	\N	\N	\N	31947	31947	31948
9635	9014	0	applied	\N	\N	\N	\N	31975	31975	31976
9635	9015	1	applied	\N	\N	\N	\N	31977	31977	31978
9635	9016	2	applied	\N	\N	\N	\N	31979	31979	31980
9635	9017	3	applied	\N	\N	\N	\N	31981	31981	31982
9646	9022	0	applied	\N	\N	\N	\N	32005	32005	32006
9646	9023	1	applied	\N	\N	\N	\N	32007	32007	32008
9649	9026	0	applied	\N	\N	\N	\N	32017	32017	32018
9649	9027	1	applied	\N	\N	\N	\N	32019	32019	32020
9649	9028	2	applied	\N	\N	\N	\N	32021	32021	32022
9651	9029	0	applied	\N	\N	\N	\N	32026	32026	32027
9651	9030	1	applied	\N	\N	\N	\N	32028	32028	32029
9659	9048	0	applied	\N	\N	\N	\N	32080	32080	32081
9659	9049	1	applied	\N	\N	\N	\N	32082	32082	32083
9661	9050	0	applied	\N	\N	\N	\N	32090	32090	32091
9661	9051	1	applied	\N	\N	\N	\N	32092	32092	32093
9668	9061	0	applied	\N	\N	\N	\N	32123	32123	32124
9668	9062	1	applied	\N	\N	\N	\N	32125	32125	32126
9673	9065	0	applied	\N	\N	\N	\N	32133	32133	32134
9673	9066	1	applied	\N	\N	\N	\N	32135	32135	32136
9673	9067	2	applied	\N	\N	\N	\N	32137	32137	32138
9673	9068	3	applied	\N	\N	\N	\N	32139	32139	32140
9673	9069	4	applied	\N	\N	\N	\N	32141	32141	31132
9675	9070	0	applied	\N	\N	\N	\N	32147	32147	32148
9675	9071	1	applied	\N	\N	\N	\N	32149	32149	32150
9675	9072	2	applied	\N	\N	\N	\N	32151	32151	32152
9675	9073	3	applied	\N	\N	\N	\N	32153	32153	32154
9675	9074	4	applied	\N	\N	\N	\N	32155	32155	32156
9678	9075	0	applied	\N	\N	\N	\N	32160	32160	32161
9678	9070	1	applied	\N	\N	\N	\N	32147	32147	32148
9678	9076	2	applied	\N	\N	\N	\N	32162	32162	32163
9678	9077	3	applied	\N	\N	\N	\N	32164	32164	32165
9678	9074	4	applied	\N	\N	\N	\N	32155	32155	32156
9678	9078	5	applied	\N	\N	\N	\N	32166	32166	32167
9680	9075	0	applied	\N	\N	\N	\N	32160	32160	32161
9680	9070	1	applied	\N	\N	\N	\N	32147	32147	32148
9680	9076	2	applied	\N	\N	\N	\N	32162	32162	32163
9680	9077	3	applied	\N	\N	\N	\N	32164	32164	32165
9680	9074	4	applied	\N	\N	\N	\N	32155	32155	32156
9680	9078	5	applied	\N	\N	\N	\N	32166	32166	32167
9684	9082	0	applied	\N	\N	\N	\N	32180	32180	32181
9684	9083	1	applied	\N	\N	\N	\N	32182	32182	32183
9694	9107	0	applied	\N	\N	\N	\N	32242	32242	32243
9694	9108	1	applied	\N	\N	\N	\N	32244	32244	32245
9694	9109	2	applied	\N	\N	\N	\N	32246	32246	32247
9700	9110	0	applied	\N	\N	\N	\N	32253	32253	32205
9700	9111	1	applied	\N	\N	\N	\N	32254	32254	32255
9700	9112	2	applied	\N	\N	\N	\N	32256	32256	32257
9703	9121	0	applied	\N	\N	\N	\N	32283	32283	32284
9703	9122	1	applied	\N	\N	\N	\N	32285	32285	32286
9703	9125	2	applied	\N	\N	\N	\N	32293	32293	32294
9703	9123	3	applied	\N	\N	\N	\N	32287	32287	32288
9703	9126	4	applied	\N	\N	\N	\N	32295	32295	32296
9703	9124	5	applied	\N	\N	\N	\N	32289	32289	32290
9712	9132	0	applied	\N	\N	\N	\N	32316	32316	32317
9723	8703	0	applied	\N	\N	1000000000	\N	31136	31136	31137
9723	8755	1	applied	\N	\N	\N	\N	31282	31282	31137
9723	8739	2	applied	\N	\N	\N	\N	31241	31241	31242
9723	8742	3	applied	\N	\N	\N	\N	31249	31249	31242
9723	8722	4	applied	\N	\N	\N	\N	31196	31196	30788
9723	8807	5	applied	\N	\N	\N	\N	32367	32367	31444
9723	8773	6	applied	\N	\N	1000000000	\N	31343	31343	31344
9723	8784	7	applied	\N	\N	\N	\N	31374	31374	31375
9723	8791	8	applied	\N	\N	\N	\N	31393	31393	31394
9723	8796	9	applied	\N	\N	\N	\N	31407	31407	31408
9723	8803	10	applied	\N	\N	\N	\N	31430	31430	31431
9723	8806	11	applied	\N	\N	\N	\N	31441	31441	31442
9723	9091	12	applied	\N	\N	1000000000	\N	32205	32205	32206
9723	9148	13	applied	\N	\N	\N	\N	32368	32368	32369
9723	9075	14	applied	\N	\N	\N	\N	32160	32160	32161
9723	9108	15	applied	\N	\N	\N	\N	32370	32370	32245
9723	8873	16	applied	\N	\N	1000000000	\N	31618	31618	31619
9723	9076	17	applied	\N	\N	\N	\N	32162	32162	32163
9723	9079	18	applied	\N	\N	\N	\N	32173	32173	32174
9723	8775	19	applied	\N	\N	\N	\N	31347	31347	32371
9723	8785	20	applied	\N	\N	\N	\N	31376	31376	31443
9723	9131	21	applied	\N	\N	\N	\N	32311	32311	32312
9723	9133	22	applied	\N	\N	\N	\N	32321	32321	32322
9723	9145	23	applied	\N	\N	\N	\N	32372	32372	32359
9723	9089	24	applied	\N	\N	1000000000	\N	32373	32373	32201
9723	9135	25	applied	\N	\N	\N	\N	32325	32325	32326
9723	9138	26	applied	\N	\N	\N	\N	32338	32338	32339
9723	8904	27	applied	\N	\N	\N	\N	31710	31710	32374
9723	9119	28	applied	\N	\N	\N	\N	32276	32276	32277
9723	9120	29	applied	\N	\N	\N	\N	32278	32278	32279
9723	9122	30	applied	\N	\N	\N	\N	32285	32285	32286
9723	9149	31	applied	\N	\N	\N	\N	32375	32375	32376
9723	9010	32	applied	\N	\N	\N	\N	31965	31965	31966
9723	9011	33	applied	\N	\N	\N	\N	31967	31967	31968
9723	9012	34	applied	\N	\N	\N	\N	31969	31969	31970
9723	9013	35	applied	\N	\N	\N	\N	31971	31971	31972
9723	9124	36	applied	\N	\N	\N	\N	32289	32289	32290
9723	8952	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	31833	31833	\N
9723	9113	38	applied	\N	\N	\N	\N	32377	32377	32260
9723	9114	39	applied	\N	\N	\N	\N	32378	32378	32262
9723	9116	41	applied	\N	\N	\N	\N	32380	32380	32268
9723	9117	42	applied	\N	\N	\N	\N	32381	32381	32270
9729	9157	0	applied	\N	\N	\N	\N	32408	32408	32409
9729	9158	1	applied	\N	\N	\N	\N	32410	32410	32411
9729	9159	2	applied	\N	\N	\N	\N	32412	32412	32413
9729	9160	3	applied	\N	\N	\N	\N	32414	32414	32415
9729	9161	4	applied	\N	\N	\N	\N	32416	32416	32417
9729	9162	5	applied	\N	\N	\N	\N	32418	32418	32419
9729	9163	6	applied	\N	\N	\N	\N	32420	32420	32421
9729	9164	7	applied	\N	\N	\N	\N	32422	32422	32423
9729	9165	8	applied	\N	\N	\N	\N	32424	32424	32425
9729	9166	9	applied	\N	\N	\N	\N	32426	32426	32427
9729	9167	10	applied	\N	\N	\N	\N	32428	32428	32429
9729	9168	11	applied	\N	\N	\N	\N	32430	32430	32431
9650	9030	1	applied	\N	\N	\N	\N	32028	32028	32029
9653	9031	0	applied	\N	\N	\N	\N	32034	32034	32035
9653	9032	1	applied	\N	\N	\N	\N	32036	32036	32037
9655	9036	0	applied	\N	\N	\N	\N	32049	32049	32050
9655	9037	1	applied	\N	\N	\N	\N	32051	32051	32052
9655	9038	3	applied	\N	\N	\N	\N	32054	32054	32055
9658	9048	0	applied	\N	\N	\N	\N	32080	32080	32081
9658	9049	1	applied	\N	\N	\N	\N	32082	32082	32083
9663	9052	0	applied	\N	\N	\N	\N	32096	32096	32097
9663	9053	1	applied	\N	\N	\N	\N	32098	32098	32099
9663	9054	2	applied	\N	\N	\N	\N	32100	32100	32101
9665	9055	0	applied	\N	\N	\N	\N	32107	32107	32108
9665	9056	1	applied	\N	\N	\N	\N	32109	32109	32110
9665	9057	2	applied	\N	\N	\N	\N	32111	32111	32112
9665	9058	3	applied	\N	\N	\N	\N	32113	32113	32114
9667	9059	0	applied	\N	\N	\N	\N	32117	32117	32118
9667	9060	1	applied	\N	\N	\N	\N	32119	32119	32120
9670	9063	0	applied	\N	\N	\N	\N	32127	32127	32128
9670	9064	1	applied	\N	\N	\N	\N	32129	32129	32130
9672	9065	0	applied	\N	\N	\N	\N	32133	32133	32134
9672	9066	1	applied	\N	\N	\N	\N	32135	32135	32136
9672	9067	2	applied	\N	\N	\N	\N	32137	32137	32138
9672	9068	3	applied	\N	\N	\N	\N	32139	32139	32140
9672	9069	4	applied	\N	\N	\N	\N	32141	32141	31132
9674	9065	0	applied	\N	\N	\N	\N	32133	32133	32134
9674	9066	1	applied	\N	\N	\N	\N	32135	32135	32136
9674	9067	2	applied	\N	\N	\N	\N	32137	32137	32138
9674	9068	3	applied	\N	\N	\N	\N	32139	32139	32140
9674	9069	4	applied	\N	\N	\N	\N	32141	32141	31132
9677	9075	0	applied	\N	\N	\N	\N	32160	32160	32161
9677	9076	1	applied	\N	\N	\N	\N	32162	32162	32163
9677	9077	2	applied	\N	\N	\N	\N	32164	32164	32165
9677	9078	3	applied	\N	\N	\N	\N	32166	32166	32167
9681	9075	0	applied	\N	\N	\N	\N	32160	32160	32161
9681	9076	1	applied	\N	\N	\N	\N	32162	32162	32163
9681	9077	2	applied	\N	\N	\N	\N	32164	32164	32165
9681	9078	3	applied	\N	\N	\N	\N	32166	32166	32167
9683	9082	0	applied	\N	\N	\N	\N	32180	32180	32181
9683	9083	1	applied	\N	\N	\N	\N	32182	32182	32183
9685	9082	0	applied	\N	\N	\N	\N	32180	32180	32181
9685	9083	1	applied	\N	\N	\N	\N	32182	32182	32183
9688	9086	0	applied	\N	\N	\N	\N	32194	32194	32195
9688	9087	1	applied	\N	\N	\N	\N	32196	32196	32197
9688	9088	2	applied	\N	\N	\N	\N	32198	32198	32199
9688	9089	3	applied	\N	\N	1000000000	\N	32200	32200	32201
9688	9090	4	applied	\N	\N	\N	\N	32202	32202	32203
9696	9091	0	applied	\N	\N	1000000000	\N	32205	32205	32206
9696	9086	1	applied	\N	\N	\N	\N	32194	32194	32195
9696	9087	2	applied	\N	\N	\N	\N	32196	32196	32197
9696	9108	3	applied	\N	\N	\N	\N	32244	32244	32245
9696	9094	4	applied	\N	\N	\N	\N	32211	32211	32212
9696	9096	5	applied	\N	\N	\N	\N	32216	32216	32217
9696	9088	6	applied	\N	\N	\N	\N	32198	32198	32199
9696	9089	7	applied	\N	\N	1000000000	\N	32200	32200	32201
9696	9092	8	applied	\N	\N	\N	\N	32207	32207	32208
9696	9095	9	applied	\N	\N	\N	\N	32213	32213	32214
9696	9097	10	applied	\N	\N	\N	\N	32218	32218	32219
9696	9098	11	applied	\N	\N	\N	\N	32220	32220	32221
9696	9099	12	applied	\N	\N	\N	\N	32222	32222	32223
9696	9103	13	applied	\N	\N	\N	\N	32230	32230	32231
9696	9104	14	applied	\N	\N	\N	\N	32232	32232	32233
9696	9106	15	applied	\N	\N	\N	\N	32237	32237	32238
9696	9109	16	applied	\N	\N	\N	\N	32246	32246	32247
9696	9090	17	applied	\N	\N	\N	\N	32202	32202	32203
9696	9093	18	applied	\N	\N	\N	\N	32209	32209	32210
9696	9100	19	applied	\N	\N	\N	\N	32224	32224	32225
9696	9101	20	applied	\N	\N	\N	\N	32226	32226	32227
9696	9102	21	applied	\N	\N	\N	\N	32228	32228	32229
9696	9107	22	applied	\N	\N	\N	\N	32242	32242	32243
9698	9110	0	applied	\N	\N	\N	\N	32253	32253	32205
9698	9111	1	applied	\N	\N	\N	\N	32254	32254	32255
9698	9112	2	applied	\N	\N	\N	\N	32256	32256	32257
9698	9113	3	applied	\N	\N	\N	\N	32259	32259	32260
9698	9114	4	applied	\N	\N	\N	\N	32261	32261	32262
9705	9126	0	applied	\N	\N	\N	\N	32295	32295	32296
9705	9127	1	applied	\N	\N	\N	\N	32298	32298	32299
9705	9125	2	applied	\N	\N	\N	\N	32293	32293	32294
9705	9128	3	applied	\N	\N	\N	\N	32300	32300	32301
9709	9129	0	applied	\N	\N	\N	\N	32307	32307	32308
9709	9130	1	applied	\N	\N	\N	\N	32309	32309	32310
9709	9131	2	applied	\N	\N	\N	\N	32311	32311	32312
9714	9133	0	applied	\N	\N	\N	\N	32321	32321	32322
9714	9134	1	applied	\N	\N	\N	\N	32323	32323	32324
9714	9135	2	applied	\N	\N	\N	\N	32325	32325	32326
9714	9136	3	applied	\N	\N	\N	\N	32327	32327	32328
9716	9133	0	applied	\N	\N	\N	\N	32321	32321	32322
9716	9134	1	applied	\N	\N	\N	\N	32323	32323	32324
9716	9135	2	applied	\N	\N	\N	\N	32325	32325	32326
9716	9136	3	applied	\N	\N	\N	\N	32327	32327	32328
9718	9143	0	applied	\N	\N	\N	\N	32349	32349	32350
9718	9137	1	applied	\N	\N	\N	\N	32336	32336	32337
9718	9139	2	applied	\N	\N	\N	\N	32340	32340	32341
9718	9140	3	applied	\N	\N	\N	\N	32342	32342	32343
9718	9141	4	applied	\N	\N	\N	\N	32344	32344	32345
9718	9142	5	applied	\N	\N	\N	\N	32346	32346	32347
9720	9137	0	applied	\N	\N	\N	\N	32336	32336	32337
9720	9138	1	applied	\N	\N	\N	\N	32338	32338	32339
9720	9139	2	applied	\N	\N	\N	\N	32340	32340	32341
9720	9140	3	applied	\N	\N	\N	\N	32342	32342	32343
9720	9141	4	applied	\N	\N	\N	\N	32344	32344	32345
9720	9142	5	applied	\N	\N	\N	\N	32346	32346	32347
9722	9144	0	applied	\N	\N	\N	\N	32356	32356	32357
9722	9145	1	applied	\N	\N	\N	\N	32358	32358	32359
9722	9146	2	applied	\N	\N	\N	\N	32360	32360	32361
9722	9147	3	applied	\N	\N	\N	\N	32362	32362	32363
9725	9148	0	applied	\N	\N	\N	\N	32368	32368	32369
9725	9150	1	applied	\N	\N	\N	\N	32389	32389	32390
9725	9149	2	applied	\N	\N	\N	\N	32391	32391	32376
9725	9151	3	applied	\N	\N	\N	\N	32392	32392	32393
9725	9152	4	applied	\N	\N	\N	\N	32394	32394	32395
9725	9153	5	applied	\N	\N	\N	\N	32396	32396	32397
9725	9154	6	applied	\N	\N	1000000000	\N	32398	32398	32399
9725	9155	7	applied	\N	\N	\N	\N	32400	32400	32401
9725	9156	8	applied	\N	\N	\N	\N	32402	32402	32403
9728	9157	0	applied	\N	\N	\N	\N	32408	32408	32409
9728	9158	1	applied	\N	\N	\N	\N	32410	32410	32411
9728	9159	2	applied	\N	\N	\N	\N	32412	32412	32413
9728	9160	3	applied	\N	\N	\N	\N	32414	32414	32415
9728	9161	4	applied	\N	\N	\N	\N	32416	32416	32417
9715	8907	22	applied	\N	\N	\N	\N	31720	31720	31721
9715	8910	23	applied	\N	\N	\N	\N	31728	31728	31729
9715	8911	24	applied	\N	\N	\N	\N	31730	31730	31731
9715	8916	25	applied	\N	\N	\N	\N	31741	31741	31742
9715	9119	26	applied	\N	\N	\N	\N	32276	32276	32277
9715	9120	27	applied	\N	\N	\N	\N	32278	32278	32279
9715	9122	28	applied	\N	\N	\N	\N	32285	32285	32286
9715	9010	29	applied	\N	\N	\N	\N	31965	31965	31966
9715	9011	30	applied	\N	\N	\N	\N	31967	31967	31968
9715	9012	31	applied	\N	\N	\N	\N	31969	31969	31970
9715	9013	32	applied	\N	\N	\N	\N	31971	31971	31972
9715	9124	33	applied	\N	\N	\N	\N	32289	32289	32290
9715	8952	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	31833	31833	\N
9715	9113	35	applied	\N	\N	\N	\N	32259	32259	32260
9715	9114	36	applied	\N	\N	\N	\N	32261	32261	32262
9715	9116	37	applied	\N	\N	\N	\N	32267	32267	32268
9715	9117	38	applied	\N	\N	\N	\N	32269	32269	32270
9715	8906	39	applied	\N	\N	\N	\N	31718	31718	31719
9715	8918	40	applied	\N	\N	\N	\N	31745	31745	31746
9715	8920	41	applied	\N	\N	\N	\N	31753	31753	31754
9715	8922	42	applied	\N	\N	\N	\N	31757	31757	31758
9715	8924	43	applied	\N	\N	\N	\N	31762	31762	31763
9715	8928	44	applied	\N	\N	\N	\N	31770	31770	31771
9715	8931	45	applied	\N	\N	\N	\N	31778	31778	31779
9715	8932	46	applied	\N	\N	\N	\N	31782	31782	31783
9715	8875	47	applied	\N	\N	\N	\N	31622	31622	31623
9715	8877	48	applied	\N	\N	\N	\N	31630	31630	31631
9715	8878	49	applied	\N	\N	\N	\N	31634	31634	31635
9715	8882	50	applied	\N	\N	\N	\N	31643	31643	31644
9715	8883	51	applied	\N	\N	\N	\N	31645	31645	31646
9715	8885	52	applied	\N	\N	\N	\N	31653	31653	31654
9715	8887	53	applied	\N	\N	\N	\N	31660	31660	31661
9715	8889	54	applied	\N	\N	\N	\N	31667	31667	31668
9715	8891	55	applied	\N	\N	\N	\N	31675	31675	31676
9715	8894	56	applied	\N	\N	\N	\N	31684	31684	31685
9715	8895	57	applied	\N	\N	\N	\N	31686	31686	31687
9715	8897	58	applied	\N	\N	\N	\N	31691	31691	31692
9715	8899	59	applied	\N	\N	\N	\N	31697	31697	31698
9715	8901	60	applied	\N	\N	\N	\N	31701	31701	31702
9715	8903	61	applied	\N	\N	\N	\N	31708	31708	31709
9715	8905	62	applied	\N	\N	\N	\N	31716	31716	31717
9715	8908	63	applied	\N	\N	\N	\N	31722	31722	31723
9715	8909	64	applied	\N	\N	\N	\N	31726	31726	31727
9715	8912	65	applied	\N	\N	\N	\N	31732	31732	31733
9715	8915	66	applied	\N	\N	\N	\N	31739	31739	31740
9715	8917	67	applied	\N	\N	\N	\N	31743	31743	31744
9715	8919	68	applied	\N	\N	\N	\N	31751	31751	31752
9715	8921	69	applied	\N	\N	\N	\N	31755	31755	31756
9715	8923	70	applied	\N	\N	\N	\N	31760	31760	31761
9715	8929	71	applied	\N	\N	\N	\N	31772	31772	31773
9715	8938	72	applied	\N	\N	\N	\N	31798	31798	31799
9715	8939	73	applied	\N	\N	\N	\N	31800	31800	31801
9715	8940	74	applied	\N	\N	\N	\N	31802	31802	31803
9715	8941	75	applied	\N	\N	\N	\N	31804	31804	31805
9715	8945	76	applied	\N	\N	\N	\N	31817	31817	31818
9715	8946	77	applied	\N	\N	\N	\N	31819	31819	31820
9715	8947	78	applied	\N	\N	\N	\N	31821	31821	31822
9715	8948	79	applied	\N	\N	\N	\N	31825	31825	31826
9715	8953	80	applied	\N	\N	\N	\N	31834	31834	31835
9715	8954	81	applied	\N	\N	\N	\N	31836	31836	31837
9715	8955	82	applied	\N	\N	\N	\N	31840	31840	31841
9715	8958	83	applied	\N	\N	\N	\N	31848	31848	31849
9715	8960	84	applied	\N	\N	\N	\N	31853	31853	31854
9715	8992	85	applied	\N	\N	\N	\N	31917	31917	31918
9715	8997	86	applied	\N	\N	\N	\N	31931	31931	31932
9715	8998	87	applied	\N	\N	\N	\N	31933	31933	31934
9715	8999	88	applied	\N	\N	\N	\N	31935	31935	31936
9715	9001	89	applied	\N	\N	\N	\N	31942	31942	31943
9715	9002	90	applied	\N	\N	\N	\N	31944	31944	31945
9715	9007	91	applied	\N	\N	\N	\N	31959	31959	31960
9715	9008	92	applied	\N	\N	\N	\N	31961	31961	31962
9715	9009	93	applied	\N	\N	\N	\N	31963	31963	31964
9715	9015	94	applied	\N	\N	\N	\N	31977	31977	31978
9715	9016	95	applied	\N	\N	\N	\N	31979	31979	31980
9715	9019	96	applied	\N	\N	\N	\N	31991	31991	31992
9715	9021	97	applied	\N	\N	\N	\N	32001	32001	32002
9715	9022	98	applied	\N	\N	\N	\N	32005	32005	32006
9715	9024	99	applied	\N	\N	\N	\N	32011	32011	32012
9715	9028	100	applied	\N	\N	\N	\N	32021	32021	32022
9715	9029	101	applied	\N	\N	\N	\N	32026	32026	32027
9715	9032	102	applied	\N	\N	\N	\N	32036	32036	32037
9715	9034	103	applied	\N	\N	\N	\N	32043	32043	32044
9715	9038	104	applied	\N	\N	\N	\N	32054	32054	32055
9715	9039	105	applied	\N	\N	\N	\N	32058	32058	32059
9715	9042	106	applied	\N	\N	\N	\N	32066	32066	32067
9715	9048	107	applied	\N	\N	\N	\N	32080	32080	32081
9715	9051	108	applied	\N	\N	\N	\N	32092	32092	32093
9715	9053	109	applied	\N	\N	\N	\N	32098	32098	32099
9715	9055	110	applied	\N	\N	\N	\N	32107	32107	32108
9715	9056	111	applied	\N	\N	\N	\N	32109	32109	32110
9715	9060	112	applied	\N	\N	\N	\N	32119	32119	32120
9715	9061	113	applied	\N	\N	\N	\N	32123	32123	32124
9715	9064	114	applied	\N	\N	\N	\N	32129	32129	32130
9715	8957	115	applied	\N	\N	1000000000	\N	31844	31844	31845
9715	8913	116	applied	\N	\N	\N	\N	31734	31734	31734
9715	8914	117	applied	\N	\N	\N	\N	31735	31735	31735
9715	8925	118	applied	\N	\N	\N	\N	31764	31764	31764
9715	8926	119	applied	\N	\N	\N	\N	31765	31765	31765
9715	8927	121	applied	\N	\N	\N	\N	31766	31766	31766
9715	8962	122	applied	\N	\N	\N	\N	31857	31857	31858
9715	8964	123	applied	\N	\N	\N	\N	31860	31860	31861
9715	8965	124	applied	\N	\N	\N	\N	31862	31862	31863
9715	8966	125	applied	\N	\N	\N	\N	31864	31864	31865
9724	9148	0	applied	\N	\N	\N	\N	32368	32368	32369
9724	9150	1	applied	\N	\N	\N	\N	32389	32389	32390
9724	9149	2	applied	\N	\N	\N	\N	32391	32391	32376
9724	9151	3	applied	\N	\N	\N	\N	32392	32392	32393
9724	9152	4	applied	\N	\N	\N	\N	32394	32394	32395
9724	9153	5	applied	\N	\N	\N	\N	32396	32396	32397
9724	9154	6	applied	\N	\N	1000000000	\N	32398	32398	32399
9724	9155	7	applied	\N	\N	\N	\N	32400	32400	32401
9724	9156	8	applied	\N	\N	\N	\N	32402	32402	32403
9726	9148	0	applied	\N	\N	\N	\N	32368	32368	32369
9726	9150	1	applied	\N	\N	\N	\N	32389	32389	32390
9726	9149	2	applied	\N	\N	\N	\N	32391	32391	32376
9726	9151	3	applied	\N	\N	\N	\N	32392	32392	32393
9726	9152	4	applied	\N	\N	\N	\N	32394	32394	32395
9726	9153	5	applied	\N	\N	\N	\N	32396	32396	32397
9726	9154	6	applied	\N	\N	1000000000	\N	32398	32398	32399
9726	9155	7	applied	\N	\N	\N	\N	32400	32400	32401
9726	9156	8	applied	\N	\N	\N	\N	32402	32402	32403
9727	9157	0	applied	\N	\N	\N	\N	32408	32408	32409
9727	9158	1	applied	\N	\N	\N	\N	32410	32410	32411
9727	9159	2	applied	\N	\N	\N	\N	32412	32412	32413
9727	9160	3	applied	\N	\N	\N	\N	32414	32414	32415
9727	9161	4	applied	\N	\N	\N	\N	32416	32416	32417
9727	9162	5	applied	\N	\N	\N	\N	32418	32418	32419
9727	9163	6	applied	\N	\N	\N	\N	32420	32420	32421
9727	9164	7	applied	\N	\N	\N	\N	32422	32422	32423
9727	9165	8	applied	\N	\N	\N	\N	32424	32424	32425
9727	9166	9	applied	\N	\N	\N	\N	32426	32426	32427
9727	9167	10	applied	\N	\N	\N	\N	32428	32428	32429
9727	9168	11	applied	\N	\N	\N	\N	32430	32430	32431
9727	9169	12	applied	\N	\N	\N	\N	32432	32432	32433
9731	9170	0	applied	\N	\N	\N	\N	32439	32439	32440
9731	9171	1	applied	\N	\N	\N	\N	32441	32441	32442
9735	9172	0	applied	\N	\N	\N	\N	32444	32444	32445
9735	9173	1	applied	\N	\N	\N	\N	32446	32446	32350
9735	9174	2	applied	\N	\N	\N	\N	32447	32447	32448
9735	9175	3	applied	\N	\N	\N	\N	32449	32449	32450
9735	9176	4	applied	\N	\N	\N	\N	32451	32451	32452
9735	9177	5	applied	\N	\N	\N	\N	32453	32453	32454
9735	9178	6	applied	\N	\N	\N	\N	32455	32455	32456
9735	9179	7	applied	\N	\N	\N	\N	32457	32457	32458
9735	9180	8	applied	\N	\N	\N	\N	32459	32459	32460
9735	9181	9	applied	\N	\N	\N	\N	32461	32461	32462
9735	9182	10	applied	\N	\N	\N	\N	32463	32463	32464
9735	9183	11	applied	\N	\N	\N	\N	32465	32465	32466
9735	9184	12	applied	\N	\N	1000000000	\N	32467	32467	32468
9736	9185	0	applied	\N	\N	\N	\N	32474	32474	32475
9736	9186	1	applied	\N	\N	\N	\N	32476	32476	32477
9736	9187	2	applied	\N	\N	\N	\N	32478	32478	32479
9739	9189	0	applied	\N	\N	\N	\N	32483	32483	32484
9739	9191	1	applied	\N	\N	\N	\N	32487	32487	32488
9739	9184	2	applied	\N	\N	1000000000	\N	32467	32467	32468
9739	9194	3	applied	\N	\N	\N	\N	32493	32493	32494
9743	9202	0	applied	\N	\N	\N	\N	32515	32515	32516
9743	9203	1	applied	\N	\N	\N	\N	32517	32517	32518
9746	9209	0	applied	\N	\N	\N	\N	32534	32534	32535
9746	9210	1	applied	\N	\N	\N	\N	32536	32536	32537
9746	9211	2	applied	\N	\N	\N	\N	32538	32538	32539
9748	9212	0	applied	\N	\N	\N	\N	32542	32542	32543
9748	9213	1	applied	\N	\N	\N	\N	32544	32544	32545
9748	9214	3	applied	\N	\N	\N	\N	32547	32547	32548
9753	9222	0	applied	\N	\N	\N	\N	32572	32572	32573
9753	9223	1	applied	\N	\N	\N	\N	32574	32574	32575
9758	9230	0	applied	\N	\N	\N	\N	32595	32595	32596
9758	9231	1	applied	\N	\N	\N	\N	32597	32597	32598
9760	9232	0	applied	\N	\N	1000000000	\N	32603	32603	32604
9760	9233	1	applied	\N	\N	\N	\N	32605	32605	32606
9763	9244	0	applied	\N	\N	\N	\N	32633	32633	32634
9763	9245	1	applied	\N	\N	\N	\N	32635	32635	32636
9763	9246	2	applied	\N	\N	\N	\N	32637	32637	32414
9766	9247	0	applied	\N	\N	\N	\N	32642	32642	32643
9766	9248	1	applied	\N	\N	\N	\N	32644	32644	32645
9766	9249	2	applied	\N	\N	\N	\N	32646	32646	32647
9766	9250	3	applied	\N	\N	\N	\N	32648	32648	32649
9766	9251	4	applied	\N	\N	\N	\N	32650	32650	32651
9766	9252	5	applied	\N	\N	\N	\N	32652	32652	32653
9766	9253	6	applied	\N	\N	\N	\N	32654	32654	32654
9766	9254	7	applied	\N	\N	\N	\N	32655	32655	32655
9766	9255	8	applied	\N	\N	\N	\N	32656	32656	32656
9766	9256	9	applied	\N	\N	\N	\N	32657	32657	32657
9766	9257	10	applied	\N	\N	\N	\N	32658	32658	32658
9770	9258	0	applied	\N	\N	\N	\N	32667	32667	32668
9770	9259	1	applied	\N	\N	\N	\N	32669	32669	32670
9773	9262	0	applied	\N	\N	\N	\N	32678	32678	32679
9773	9263	1	applied	\N	\N	\N	\N	32680	32680	32681
9777	9266	0	applied	\N	\N	\N	\N	32692	32692	32693
9777	9267	1	applied	\N	\N	\N	\N	32694	32694	32695
9777	9268	2	applied	\N	\N	\N	\N	32696	32696	32697
9777	9269	3	applied	\N	\N	\N	\N	32698	32698	32699
9777	9270	4	applied	\N	\N	\N	\N	32700	32700	32701
9777	9271	5	applied	\N	\N	\N	\N	32702	32702	32703
9779	9272	0	applied	\N	\N	\N	\N	32706	32706	32707
9779	9273	1	applied	\N	\N	\N	\N	32708	32708	32709
9779	9274	2	applied	\N	\N	\N	\N	32710	32710	32711
9779	9275	3	applied	\N	\N	\N	\N	32712	32712	32713
9782	9279	0	applied	\N	\N	\N	\N	32724	32724	32725
9782	9280	1	applied	\N	\N	\N	\N	32726	32726	32727
9782	9281	2	applied	\N	\N	\N	\N	32728	32728	32729
9782	9282	3	applied	\N	\N	\N	\N	32730	32730	32731
9784	9283	0	applied	\N	\N	\N	\N	32736	32736	32737
9784	9284	1	applied	\N	\N	\N	\N	32738	32738	32739
9787	9292	0	applied	\N	\N	\N	\N	32759	32759	32760
9787	9293	1	applied	\N	\N	\N	\N	32761	32761	32762
9787	9294	2	applied	\N	\N	\N	\N	32763	32763	32764
9787	9295	4	applied	\N	\N	\N	\N	32766	32766	32767
9787	9296	5	applied	\N	\N	\N	\N	32768	32768	32769
9787	9297	6	applied	\N	\N	\N	\N	32770	32770	32771
9787	9298	7	applied	\N	\N	\N	\N	32772	32772	32773
9788	9292	0	applied	\N	\N	\N	\N	32759	32759	32760
9788	9293	1	applied	\N	\N	\N	\N	32761	32761	32762
9788	9294	2	applied	\N	\N	\N	\N	32763	32763	32764
9788	9295	4	applied	\N	\N	\N	\N	32766	32766	32767
9788	9296	5	applied	\N	\N	\N	\N	32768	32768	32769
9788	9297	6	applied	\N	\N	\N	\N	32770	32770	32771
9788	9298	7	applied	\N	\N	\N	\N	32772	32772	32773
9790	9307	0	applied	\N	\N	\N	\N	32794	32794	32795
9790	9308	1	applied	\N	\N	\N	\N	32796	32796	32797
9790	9309	2	applied	\N	\N	\N	\N	32798	32798	32799
9790	9310	3	applied	\N	\N	\N	\N	32800	32800	32801
9790	9311	4	applied	\N	\N	\N	\N	32802	32802	32803
9790	9312	5	applied	\N	\N	\N	\N	32804	32804	32805
9790	9313	6	applied	\N	\N	\N	\N	32806	32806	32807
9790	9314	7	applied	\N	\N	\N	\N	32808	32808	32809
9793	9318	0	applied	\N	\N	\N	\N	32820	32820	32821
9793	9319	1	applied	\N	\N	\N	\N	32822	32822	32823
9795	9324	0	applied	\N	\N	\N	\N	32835	32835	32836
9795	9325	1	applied	\N	\N	\N	\N	32837	32837	32838
9800	9340	0	applied	\N	\N	\N	\N	32872	32872	32873
9800	9341	1	applied	\N	\N	\N	\N	32874	32874	32875
9803	9340	0	applied	\N	\N	\N	\N	32872	32872	32873
9807	9346	0	applied	\N	\N	\N	\N	32894	32894	32895
9807	9347	1	applied	\N	\N	\N	\N	32896	32896	32897
9807	9348	2	applied	\N	\N	\N	\N	32898	32898	31583
9807	9349	3	applied	\N	\N	\N	\N	32899	32899	31583
9728	9162	5	applied	\N	\N	\N	\N	32418	32418	32419
9728	9163	6	applied	\N	\N	\N	\N	32420	32420	32421
9728	9164	7	applied	\N	\N	\N	\N	32422	32422	32423
9728	9165	8	applied	\N	\N	\N	\N	32424	32424	32425
9728	9166	9	applied	\N	\N	\N	\N	32426	32426	32427
9728	9167	10	applied	\N	\N	\N	\N	32428	32428	32429
9728	9168	11	applied	\N	\N	\N	\N	32430	32430	32431
9728	9169	12	applied	\N	\N	\N	\N	32432	32432	32433
9732	9170	0	applied	\N	\N	\N	\N	32439	32439	32440
9732	9171	1	applied	\N	\N	\N	\N	32441	32441	32442
9737	9188	0	applied	\N	\N	\N	\N	32481	32481	32482
9737	9189	1	applied	\N	\N	\N	\N	32483	32483	32484
9737	9190	2	applied	\N	\N	\N	\N	32485	32485	32486
9737	9191	3	applied	\N	\N	\N	\N	32487	32487	32488
9737	9192	4	applied	\N	\N	\N	\N	32489	32489	32490
9737	9193	5	applied	\N	\N	\N	\N	32491	32491	32492
9737	9194	6	applied	\N	\N	\N	\N	32493	32493	32494
9742	9189	0	applied	\N	\N	\N	\N	32483	32483	32484
9742	9191	1	applied	\N	\N	\N	\N	32487	32487	32488
9742	9194	2	applied	\N	\N	\N	\N	32493	32493	32494
9742	9201	3	applied	\N	\N	\N	\N	32511	32511	32512
9744	9204	0	applied	\N	\N	\N	\N	32521	32521	32522
9744	9205	1	applied	\N	\N	\N	\N	32523	32523	32524
9744	9206	2	applied	\N	\N	\N	\N	32525	32525	32526
9744	9207	3	applied	\N	\N	\N	\N	32527	32527	32528
9744	9208	4	applied	\N	\N	\N	\N	32529	32529	32530
9749	9213	0	applied	\N	\N	\N	\N	32544	32544	32545
9751	9219	0	applied	\N	\N	\N	\N	32563	32563	32564
9751	9220	1	applied	\N	\N	\N	\N	32565	32565	32566
9751	9221	2	applied	\N	\N	\N	\N	32567	32567	32568
9756	9226	0	applied	\N	\N	\N	\N	32585	32585	32586
9756	9227	1	applied	\N	\N	\N	\N	32587	32587	32588
9756	9228	2	applied	\N	\N	\N	\N	32589	32589	32590
9756	9229	3	applied	\N	\N	\N	\N	32591	32591	32592
9764	9244	0	applied	\N	\N	\N	\N	32633	32633	32634
9764	9245	1	applied	\N	\N	\N	\N	32635	32635	32636
9764	9246	2	applied	\N	\N	\N	\N	32637	32637	32414
9768	9247	0	applied	\N	\N	\N	\N	32642	32642	32643
9768	9248	1	applied	\N	\N	\N	\N	32644	32644	32645
9768	9249	2	applied	\N	\N	\N	\N	32646	32646	32647
9768	9250	3	applied	\N	\N	\N	\N	32648	32648	32649
9768	9251	4	applied	\N	\N	\N	\N	32650	32650	32651
9768	9252	5	applied	\N	\N	\N	\N	32652	32652	32653
9768	9253	6	applied	\N	\N	\N	\N	32654	32654	32654
9768	9254	7	applied	\N	\N	\N	\N	32655	32655	32655
9768	9255	8	applied	\N	\N	\N	\N	32656	32656	32656
9768	9256	9	applied	\N	\N	\N	\N	32657	32657	32657
9768	9257	10	applied	\N	\N	\N	\N	32658	32658	32658
9775	9264	0	applied	\N	\N	\N	\N	32686	32686	32687
9775	9265	1	applied	\N	\N	\N	\N	32688	32688	32689
9780	9276	0	applied	\N	\N	1000000000	\N	32715	32715	32716
9780	9277	1	applied	\N	\N	\N	\N	32717	32717	32718
9780	9278	2	applied	\N	\N	\N	\N	32719	32719	32720
9785	9285	0	applied	\N	\N	\N	\N	32742	32742	32743
9785	9286	1	applied	\N	\N	\N	\N	32744	32744	32745
9785	9287	2	applied	\N	\N	\N	\N	32746	32746	32747
9796	9326	0	applied	\N	\N	\N	\N	32841	32841	32842
9796	9327	1	applied	\N	\N	\N	\N	32843	32843	32844
9796	9328	2	applied	\N	\N	1000000000	\N	32845	32845	32846
9798	9326	0	applied	\N	\N	\N	\N	32841	32841	32842
9798	9327	1	applied	\N	\N	\N	\N	32843	32843	32844
9798	9328	2	applied	\N	\N	1000000000	\N	32845	32845	32846
9805	9341	0	applied	\N	\N	\N	\N	32874	32874	32875
9805	9342	1	applied	\N	\N	\N	\N	32883	32883	32884
9808	9346	0	applied	\N	\N	\N	\N	32894	32894	32895
9808	9347	1	applied	\N	\N	\N	\N	32896	32896	32897
9808	9348	2	applied	\N	\N	\N	\N	32898	32898	31583
9808	9349	3	applied	\N	\N	\N	\N	32899	32899	31583
9812	9359	0	applied	\N	\N	\N	\N	32920	32920	32921
9812	9360	1	applied	\N	\N	\N	\N	32922	32922	32923
9812	9361	2	applied	\N	\N	\N	\N	32924	32924	32925
9812	9362	3	applied	\N	\N	\N	\N	32926	32926	32927
9812	9363	4	applied	\N	\N	\N	\N	32928	32928	32929
9812	9364	5	applied	\N	\N	\N	\N	32930	32930	32931
9814	9359	0	applied	\N	\N	\N	\N	32920	32920	32921
9814	9360	1	applied	\N	\N	\N	\N	32922	32922	32923
9814	9361	2	applied	\N	\N	\N	\N	32924	32924	32925
9814	9362	3	applied	\N	\N	\N	\N	32926	32926	32927
9814	9363	4	applied	\N	\N	\N	\N	32928	32928	32929
9814	9364	5	applied	\N	\N	\N	\N	32930	32930	32931
9816	9365	0	applied	\N	\N	\N	\N	32938	32938	32939
9816	9366	1	applied	\N	\N	\N	\N	32940	32940	32941
9729	9169	12	applied	\N	\N	\N	\N	32432	32432	32433
9730	9170	0	applied	\N	\N	\N	\N	32439	32439	32440
9730	9171	1	applied	\N	\N	\N	\N	32441	32441	32442
9733	9172	0	applied	\N	\N	\N	\N	32444	32444	32445
9733	9173	1	applied	\N	\N	\N	\N	32446	32446	32350
9733	9174	2	applied	\N	\N	\N	\N	32447	32447	32448
9733	9175	3	applied	\N	\N	\N	\N	32449	32449	32450
9733	9176	4	applied	\N	\N	\N	\N	32451	32451	32452
9733	9177	5	applied	\N	\N	\N	\N	32453	32453	32454
9733	9178	6	applied	\N	\N	\N	\N	32455	32455	32456
9733	9179	7	applied	\N	\N	\N	\N	32457	32457	32458
9733	9180	8	applied	\N	\N	\N	\N	32459	32459	32460
9733	9181	9	applied	\N	\N	\N	\N	32461	32461	32462
9733	9182	10	applied	\N	\N	\N	\N	32463	32463	32464
9733	9183	11	applied	\N	\N	\N	\N	32465	32465	32466
9733	9184	12	applied	\N	\N	1000000000	\N	32467	32467	32468
9738	9188	0	applied	\N	\N	\N	\N	32481	32481	32482
9738	9189	1	applied	\N	\N	\N	\N	32483	32483	32484
9738	9190	2	applied	\N	\N	\N	\N	32485	32485	32486
9738	9191	3	applied	\N	\N	\N	\N	32487	32487	32488
9738	9192	4	applied	\N	\N	\N	\N	32489	32489	32490
9738	9193	5	applied	\N	\N	\N	\N	32491	32491	32492
9738	9194	6	applied	\N	\N	\N	\N	32493	32493	32494
9740	9195	0	applied	\N	\N	\N	\N	32499	32499	32500
9740	9196	1	applied	\N	\N	\N	\N	32501	32501	32502
9740	9197	2	applied	\N	\N	\N	\N	32503	32503	32504
9740	9198	3	applied	\N	\N	\N	\N	32505	32505	32506
9740	9199	4	applied	\N	\N	\N	\N	32507	32507	32508
9740	9200	5	applied	\N	\N	\N	\N	32509	32509	32510
9740	9201	6	applied	\N	\N	\N	\N	32511	32511	32512
9747	9209	0	applied	\N	\N	\N	\N	32534	32534	32535
9747	9210	1	applied	\N	\N	\N	\N	32536	32536	32537
9747	9211	2	applied	\N	\N	\N	\N	32538	32538	32539
9752	9219	0	applied	\N	\N	\N	\N	32563	32563	32564
9752	9220	1	applied	\N	\N	\N	\N	32565	32565	32566
9752	9221	2	applied	\N	\N	\N	\N	32567	32567	32568
9754	9222	0	applied	\N	\N	\N	\N	32572	32572	32573
9754	9223	1	applied	\N	\N	\N	\N	32574	32574	32575
9759	9230	0	applied	\N	\N	\N	\N	32595	32595	32596
9759	9231	1	applied	\N	\N	\N	\N	32597	32597	32598
9761	9234	0	applied	\N	\N	\N	\N	32609	32609	32610
9761	9235	1	applied	\N	\N	\N	\N	32611	32611	32612
9761	9236	2	applied	\N	\N	\N	\N	32613	32613	32614
9767	9247	0	applied	\N	\N	\N	\N	32642	32642	32643
9767	9248	1	applied	\N	\N	\N	\N	32644	32644	32645
9767	9249	2	applied	\N	\N	\N	\N	32646	32646	32647
9767	9250	3	applied	\N	\N	\N	\N	32648	32648	32649
9767	9251	4	applied	\N	\N	\N	\N	32650	32650	32651
9767	9252	5	applied	\N	\N	\N	\N	32652	32652	32653
9767	9253	6	applied	\N	\N	\N	\N	32654	32654	32654
9767	9254	7	applied	\N	\N	\N	\N	32655	32655	32655
9767	9255	8	applied	\N	\N	\N	\N	32656	32656	32656
9767	9256	9	applied	\N	\N	\N	\N	32657	32657	32657
9767	9257	10	applied	\N	\N	\N	\N	32658	32658	32658
9769	9247	0	applied	\N	\N	\N	\N	32642	32642	32643
9769	9248	1	applied	\N	\N	\N	\N	32644	32644	32645
9769	9249	2	applied	\N	\N	\N	\N	32646	32646	32647
9769	9250	3	applied	\N	\N	\N	\N	32648	32648	32649
9769	9251	4	applied	\N	\N	\N	\N	32650	32650	32651
9769	9252	5	applied	\N	\N	\N	\N	32652	32652	32653
9769	9253	6	applied	\N	\N	\N	\N	32654	32654	32654
9769	9254	7	applied	\N	\N	\N	\N	32655	32655	32655
9769	9255	8	applied	\N	\N	\N	\N	32656	32656	32656
9769	9256	9	applied	\N	\N	\N	\N	32657	32657	32657
9769	9257	10	applied	\N	\N	\N	\N	32658	32658	32658
9771	9260	0	applied	\N	\N	\N	\N	32672	32672	32673
9771	9261	1	applied	\N	\N	\N	\N	32674	32674	32675
9778	9268	0	applied	\N	\N	\N	\N	32696	32696	32697
9778	9269	1	applied	\N	\N	\N	\N	32698	32698	32699
9778	9270	2	applied	\N	\N	\N	\N	32700	32700	32701
9778	9271	3	applied	\N	\N	\N	\N	32702	32702	32703
9781	9276	0	applied	\N	\N	1000000000	\N	32715	32715	32716
9781	9277	1	applied	\N	\N	\N	\N	32717	32717	32718
9781	9278	2	applied	\N	\N	\N	\N	32719	32719	32720
9783	9279	0	applied	\N	\N	\N	\N	32724	32724	32725
9783	9280	1	applied	\N	\N	\N	\N	32726	32726	32727
9783	9281	2	applied	\N	\N	\N	\N	32728	32728	32729
9783	9282	3	applied	\N	\N	\N	\N	32730	32730	32731
9786	9288	0	applied	\N	\N	\N	\N	32750	32750	32751
9786	9289	1	applied	\N	\N	\N	\N	32752	32752	32753
9786	9290	2	applied	\N	\N	\N	\N	32754	32754	32755
9786	9291	3	applied	\N	\N	\N	\N	32756	32756	32757
9791	9315	0	applied	\N	\N	\N	\N	32812	32812	32813
9791	9316	1	applied	\N	\N	\N	\N	32814	32814	32815
9791	9317	2	applied	\N	\N	1000000000	\N	32816	32816	32817
9794	9320	0	applied	\N	\N	\N	\N	32826	32826	32827
9794	9321	1	applied	\N	\N	\N	\N	32828	32828	32829
9794	9322	2	applied	\N	\N	\N	\N	32830	32830	32831
9794	9323	3	applied	\N	\N	\N	\N	32832	32832	32833
9797	9326	0	applied	\N	\N	\N	\N	32841	32841	32842
9797	9327	1	applied	\N	\N	\N	\N	32843	32843	32844
9797	9328	2	applied	\N	\N	1000000000	\N	32845	32845	32846
9799	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
9799	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
9799	9331	2	applied	\N	\N	\N	\N	32854	32854	32855
9799	9332	3	applied	\N	\N	\N	\N	32856	32856	32857
9799	9333	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	32858	32858	\N
9799	9334	5	applied	\N	\N	\N	\N	32859	32859	32860
9799	9335	6	applied	\N	\N	\N	\N	32861	32861	32862
9799	9336	7	applied	\N	\N	\N	\N	32863	32863	32864
9799	9337	8	applied	\N	\N	\N	\N	32865	32865	32866
9799	9338	9	applied	\N	\N	\N	\N	32867	32867	32868
9799	9339	10	applied	\N	\N	\N	\N	32869	32869	32870
9801	9340	0	applied	\N	\N	\N	\N	32872	32872	32873
9801	9341	1	applied	\N	\N	\N	\N	32874	32874	32875
9810	9350	0	applied	\N	\N	\N	\N	32905	32905	32906
9810	9351	1	applied	\N	\N	\N	\N	32907	32907	32908
9810	9352	2	applied	\N	\N	\N	\N	32909	32909	31583
9810	9353	3	applied	\N	\N	\N	\N	32910	32910	31583
9810	9354	4	applied	\N	\N	\N	\N	32911	32911	31583
9810	9355	5	applied	\N	\N	\N	\N	32912	32912	31583
9810	9356	6	applied	\N	\N	\N	\N	32913	32913	31583
9810	9357	7	applied	\N	\N	\N	\N	32914	32914	31583
9810	9358	8	applied	\N	\N	\N	\N	32915	32915	31583
9813	9359	0	applied	\N	\N	\N	\N	32920	32920	32921
9813	9360	1	applied	\N	\N	\N	\N	32922	32922	32923
9813	9361	2	applied	\N	\N	\N	\N	32924	32924	32925
9813	9362	3	applied	\N	\N	\N	\N	32926	32926	32927
9813	9363	4	applied	\N	\N	\N	\N	32928	32928	32929
9757	9231	1	applied	\N	\N	\N	\N	32597	32597	32598
9762	9237	0	applied	\N	\N	\N	\N	32617	32617	32618
9762	9238	1	applied	\N	\N	\N	\N	32619	32619	32620
9762	9239	2	applied	\N	\N	1000000000	\N	32621	32621	32622
9762	9240	3	applied	\N	\N	\N	\N	32623	32623	32624
9762	9241	4	applied	\N	\N	\N	\N	32625	32625	32626
9762	9242	5	applied	\N	\N	\N	\N	32627	32627	32628
9762	9243	6	applied	\N	\N	\N	\N	32629	32629	32630
9765	9247	0	applied	\N	\N	\N	\N	32642	32642	32643
9765	9248	1	applied	\N	\N	\N	\N	32644	32644	32645
9765	9249	2	applied	\N	\N	\N	\N	32646	32646	32647
9765	9250	3	applied	\N	\N	\N	\N	32648	32648	32649
9765	9251	4	applied	\N	\N	\N	\N	32650	32650	32651
9765	9252	5	applied	\N	\N	\N	\N	32652	32652	32653
9765	9253	6	applied	\N	\N	\N	\N	32654	32654	32654
9765	9254	7	applied	\N	\N	\N	\N	32655	32655	32655
9765	9255	8	applied	\N	\N	\N	\N	32656	32656	32656
9765	9256	9	applied	\N	\N	\N	\N	32657	32657	32657
9765	9257	10	applied	\N	\N	\N	\N	32658	32658	32658
9772	9262	0	applied	\N	\N	\N	\N	32678	32678	32679
9772	9263	1	applied	\N	\N	\N	\N	32680	32680	32681
9776	9264	0	applied	\N	\N	\N	\N	32686	32686	32687
9776	9265	1	applied	\N	\N	\N	\N	32688	32688	32689
9789	9299	0	applied	\N	\N	\N	\N	32776	32776	32777
9789	9300	1	applied	\N	\N	\N	\N	32778	32778	32779
9789	9301	2	applied	\N	\N	\N	\N	32780	32780	32781
9789	9302	3	applied	\N	\N	\N	\N	32782	32782	32783
9789	9303	4	applied	\N	\N	\N	\N	32784	32784	32785
9789	9304	5	applied	\N	\N	\N	\N	32786	32786	32787
9789	9305	6	applied	\N	\N	\N	\N	32788	32788	32789
9789	9306	7	applied	\N	\N	\N	\N	32790	32790	32791
9792	9318	0	applied	\N	\N	\N	\N	32820	32820	32821
9792	9319	1	applied	\N	\N	\N	\N	32822	32822	32823
9802	9340	0	applied	\N	\N	\N	\N	32872	32872	32873
9804	9341	0	applied	\N	\N	\N	\N	32874	32874	32875
9804	9342	1	applied	\N	\N	\N	\N	32883	32883	32884
9806	9343	0	applied	\N	\N	\N	\N	32887	32887	32888
9806	9344	1	applied	\N	\N	\N	\N	32889	32889	32890
9806	9345	2	applied	\N	\N	\N	\N	32891	32891	31583
9809	9346	0	applied	\N	\N	\N	\N	32894	32894	32895
9809	9347	1	applied	\N	\N	\N	\N	32896	32896	32897
9809	9348	2	applied	\N	\N	\N	\N	32898	32898	31583
9809	9349	3	applied	\N	\N	\N	\N	32899	32899	31583
9811	9350	0	applied	\N	\N	\N	\N	32905	32905	32906
9811	9351	1	applied	\N	\N	\N	\N	32907	32907	32908
9811	9352	2	applied	\N	\N	\N	\N	32909	32909	31583
9811	9353	3	applied	\N	\N	\N	\N	32910	32910	31583
9811	9354	4	applied	\N	\N	\N	\N	32911	32911	31583
9811	9355	5	applied	\N	\N	\N	\N	32912	32912	31583
9811	9356	6	applied	\N	\N	\N	\N	32913	32913	31583
9811	9357	7	applied	\N	\N	\N	\N	32914	32914	31583
9811	9358	8	applied	\N	\N	\N	\N	32915	32915	31583
9818	9367	0	applied	\N	\N	\N	\N	32944	32944	32945
9818	9368	1	applied	\N	\N	\N	\N	32946	32946	32947
9818	9369	2	applied	\N	\N	\N	\N	32948	32948	32930
9818	9370	3	applied	\N	\N	\N	\N	32949	32949	32930
9818	9371	4	applied	\N	\N	\N	\N	32950	32950	32930
9818	9372	5	applied	\N	\N	\N	\N	32951	32951	32930
9818	9373	6	applied	\N	\N	\N	\N	32952	32952	32930
9818	9374	7	applied	\N	\N	\N	\N	32953	32953	32930
9818	9375	8	applied	\N	\N	\N	\N	32954	32954	32930
9818	9376	9	applied	\N	\N	\N	\N	32955	32955	32930
9818	9377	10	applied	\N	\N	\N	\N	32956	32956	32930
9818	9378	11	applied	\N	\N	\N	\N	32957	32957	32930
9813	9364	5	applied	\N	\N	\N	\N	32930	32930	32931
9815	9359	0	applied	\N	\N	\N	\N	32920	32920	32921
9815	9360	1	applied	\N	\N	\N	\N	32922	32922	32923
9815	9361	2	applied	\N	\N	\N	\N	32924	32924	32925
9815	9362	3	applied	\N	\N	\N	\N	32926	32926	32927
9815	9363	4	applied	\N	\N	\N	\N	32928	32928	32929
9815	9364	5	applied	\N	\N	\N	\N	32930	32930	32931
9817	9367	0	applied	\N	\N	\N	\N	32944	32944	32945
9817	9368	1	applied	\N	\N	\N	\N	32946	32946	32947
9817	9369	2	applied	\N	\N	\N	\N	32948	32948	32930
9817	9370	3	applied	\N	\N	\N	\N	32949	32949	32930
9817	9371	4	applied	\N	\N	\N	\N	32950	32950	32930
9817	9372	5	applied	\N	\N	\N	\N	32951	32951	32930
9817	9373	6	applied	\N	\N	\N	\N	32952	32952	32930
9817	9374	7	applied	\N	\N	\N	\N	32953	32953	32930
9817	9375	8	applied	\N	\N	\N	\N	32954	32954	32930
9817	9376	9	applied	\N	\N	\N	\N	32955	32955	32930
9817	9377	10	applied	\N	\N	\N	\N	32956	32956	32930
9817	9378	11	applied	\N	\N	\N	\N	32957	32957	32930
9819	9367	0	applied	\N	\N	\N	\N	32944	32944	32945
9819	9368	1	applied	\N	\N	\N	\N	32946	32946	32947
9819	9369	2	applied	\N	\N	\N	\N	32948	32948	32930
9819	9370	3	applied	\N	\N	\N	\N	32949	32949	32930
9819	9371	4	applied	\N	\N	\N	\N	32950	32950	32930
9819	9372	5	applied	\N	\N	\N	\N	32951	32951	32930
9819	9373	6	applied	\N	\N	\N	\N	32952	32952	32930
9819	9374	7	applied	\N	\N	\N	\N	32953	32953	32930
9819	9375	8	applied	\N	\N	\N	\N	32954	32954	32930
9819	9376	9	applied	\N	\N	\N	\N	32955	32955	32930
9819	9377	10	applied	\N	\N	\N	\N	32956	32956	32930
9819	9378	11	applied	\N	\N	\N	\N	32957	32957	32930
9820	9367	0	applied	\N	\N	\N	\N	32944	32944	32945
9820	9368	1	applied	\N	\N	\N	\N	32946	32946	32947
9820	9369	2	applied	\N	\N	\N	\N	32948	32948	32930
9820	9370	3	applied	\N	\N	\N	\N	32949	32949	32930
9820	9371	4	applied	\N	\N	\N	\N	32950	32950	32930
9820	9372	5	applied	\N	\N	\N	\N	32951	32951	32930
9820	9373	6	applied	\N	\N	\N	\N	32952	32952	32930
9820	9374	7	applied	\N	\N	\N	\N	32953	32953	32930
9820	9375	8	applied	\N	\N	\N	\N	32954	32954	32930
9820	9376	9	applied	\N	\N	\N	\N	32955	32955	32930
9820	9377	10	applied	\N	\N	\N	\N	32956	32956	32930
9820	9378	11	applied	\N	\N	\N	\N	32957	32957	32930
9821	9379	0	applied	\N	\N	\N	\N	32966	32966	32967
9821	9380	1	applied	\N	\N	\N	\N	32968	32968	32969
9821	9381	2	applied	\N	\N	\N	\N	32970	32970	32957
9821	9382	3	applied	\N	\N	\N	\N	32971	32971	32957
9821	9383	4	applied	\N	\N	\N	\N	32972	32972	32957
9821	9384	5	applied	\N	\N	\N	\N	32973	32973	32957
9821	9385	6	applied	\N	\N	\N	\N	32974	32974	32957
9821	9386	7	applied	\N	\N	\N	\N	32975	32975	32974
9821	9387	8	applied	\N	\N	\N	\N	32976	32976	32975
9822	9379	0	applied	\N	\N	\N	\N	32966	32966	32967
9822	9380	1	applied	\N	\N	\N	\N	32968	32968	32969
9822	9381	2	applied	\N	\N	\N	\N	32970	32970	32957
9822	9382	3	applied	\N	\N	\N	\N	32971	32971	32957
9822	9383	4	applied	\N	\N	\N	\N	32972	32972	32957
9822	9384	5	applied	\N	\N	\N	\N	32973	32973	32957
9822	9385	6	applied	\N	\N	\N	\N	32974	32974	32957
9822	9386	7	applied	\N	\N	\N	\N	32975	32975	32974
9822	9387	8	applied	\N	\N	\N	\N	32976	32976	32975
9822	9388	10	applied	\N	\N	\N	\N	32980	32980	32975
9823	9379	0	applied	\N	\N	\N	\N	32966	32966	32967
9823	9380	1	applied	\N	\N	\N	\N	32968	32968	32969
9823	9381	2	applied	\N	\N	\N	\N	32970	32970	32957
9823	9382	3	applied	\N	\N	\N	\N	32971	32971	32957
9823	9383	4	applied	\N	\N	\N	\N	32972	32972	32957
9823	9384	5	applied	\N	\N	\N	\N	32973	32973	32957
9823	9385	6	applied	\N	\N	\N	\N	32974	32974	32957
9823	9386	7	applied	\N	\N	\N	\N	32975	32975	32974
9823	9387	8	applied	\N	\N	\N	\N	32976	32976	32975
9823	9388	10	applied	\N	\N	\N	\N	32980	32980	32975
9823	9389	11	applied	\N	\N	\N	\N	32984	32984	32975
9823	9390	12	applied	\N	\N	\N	\N	32985	32985	32975
9823	9391	13	applied	\N	\N	\N	\N	32986	32986	32985
9823	9392	14	applied	\N	\N	\N	\N	32987	32987	32985
9823	9393	15	applied	\N	\N	\N	\N	32988	32988	32985
9823	9394	16	applied	\N	\N	\N	\N	32989	32989	32985
9823	9395	17	applied	\N	\N	\N	\N	32990	32990	32985
9823	9396	18	applied	\N	\N	\N	\N	32991	32991	32985
9823	9397	19	applied	\N	\N	\N	\N	32992	32992	32985
9823	9398	20	applied	\N	\N	\N	\N	32993	32993	32985
9823	9399	21	applied	\N	\N	\N	\N	32994	32994	32985
9823	9400	22	applied	\N	\N	\N	\N	32995	32995	32994
9824	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
9824	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
9824	9226	2	applied	\N	\N	\N	\N	32585	32585	32586
9824	9091	3	applied	\N	\N	1000000000	\N	32205	32205	32206
9824	9148	4	applied	\N	\N	\N	\N	32368	32368	32369
9824	9157	5	applied	\N	\N	\N	\N	32408	32408	32409
9824	9158	6	applied	\N	\N	\N	\N	32410	32410	32411
9824	9159	7	applied	\N	\N	\N	\N	32412	32412	32413
9824	9174	8	applied	\N	\N	\N	\N	32447	32447	32448
9824	9276	9	applied	\N	\N	1000000000	\N	32715	32715	32716
9824	9293	10	applied	\N	\N	\N	\N	32998	32998	32762
9824	9294	11	applied	\N	\N	\N	\N	32999	32999	32764
9824	9189	12	applied	\N	\N	\N	\N	32483	32483	32484
9824	9108	13	applied	\N	\N	\N	\N	32244	32244	32245
9824	9331	14	applied	\N	\N	\N	\N	33000	33000	32855
9824	9332	15	applied	\N	\N	\N	\N	33001	33001	32857
9824	9234	16	applied	\N	\N	\N	\N	32609	32609	32610
9824	9237	17	applied	\N	\N	\N	\N	32617	32617	32618
9824	9191	18	applied	\N	\N	\N	\N	32487	32487	32488
9824	9192	19	applied	\N	\N	\N	\N	32489	32489	32490
9824	9193	20	applied	\N	\N	\N	\N	32491	32491	32492
9824	9131	21	applied	\N	\N	\N	\N	32311	32311	32312
9824	9133	22	applied	\N	\N	\N	\N	32321	32321	32322
9824	9145	23	applied	\N	\N	\N	\N	32358	32358	32359
9824	9089	24	applied	\N	\N	1000000000	\N	32200	32200	32201
9824	9092	25	applied	\N	\N	\N	\N	32207	32207	32208
9824	9135	26	applied	\N	\N	\N	\N	32325	32325	32326
9824	9138	27	applied	\N	\N	\N	\N	32338	32338	32339
9824	9173	28	applied	\N	\N	\N	\N	32446	32446	32350
9824	9197	29	applied	\N	\N	\N	\N	32503	32503	32504
9824	9295	30	applied	\N	\N	\N	\N	32766	32766	32767
9824	9178	31	applied	\N	\N	\N	\N	32455	32455	32456
9824	9179	32	applied	\N	\N	\N	\N	32457	32457	32458
9824	9180	33	applied	\N	\N	\N	\N	32459	32459	32460
9824	9238	34	applied	\N	\N	\N	\N	32619	32619	32620
9824	9239	35	applied	\N	\N	1000000000	\N	32621	32621	32622
9824	9200	36	applied	\N	\N	\N	\N	32509	32509	32510
9824	9119	37	applied	\N	\N	\N	\N	32276	32276	32277
9824	9120	38	applied	\N	\N	\N	\N	32278	32278	32279
9824	9122	39	applied	\N	\N	\N	\N	32285	32285	32286
9824	9149	40	applied	\N	\N	\N	\N	32391	32391	32376
9824	9164	41	applied	\N	\N	\N	\N	32422	32422	32423
9824	9165	42	applied	\N	\N	\N	\N	32424	32424	32425
9824	9166	43	applied	\N	\N	\N	\N	32426	32426	32427
9824	9172	44	applied	\N	\N	\N	\N	32444	32444	32445
9824	9124	45	applied	\N	\N	\N	\N	32289	32289	32290
9824	9297	46	applied	\N	\N	\N	\N	33002	33002	32771
9824	9298	47	applied	\N	\N	\N	\N	33003	33003	32773
9824	9113	48	applied	\N	\N	\N	\N	32259	32259	32260
9824	9114	49	applied	\N	\N	\N	\N	32261	32261	32262
9824	9116	50	applied	\N	\N	\N	\N	32267	32267	32268
9824	9117	51	applied	\N	\N	\N	\N	32269	32269	32270
9824	9211	52	applied	\N	\N	\N	\N	33004	33004	32539
9824	9215	53	applied	\N	\N	\N	\N	33005	33005	32554
9824	9216	54	applied	\N	\N	\N	\N	33006	33006	32556
9824	9217	55	applied	\N	\N	\N	\N	33007	33007	32558
9824	9301	56	applied	\N	\N	\N	\N	33008	33008	32781
9824	9302	57	applied	\N	\N	\N	\N	33009	33009	32783
9824	9303	58	applied	\N	\N	\N	\N	33010	33010	32785
9824	9304	59	applied	\N	\N	\N	\N	33011	33011	32787
9824	9305	60	applied	\N	\N	\N	\N	33012	33012	32789
9824	9306	61	applied	\N	\N	\N	\N	33013	33013	32791
9824	9310	62	applied	\N	\N	\N	\N	32800	32800	32801
9824	9311	63	applied	\N	\N	\N	\N	32802	32802	32803
9824	9312	64	applied	\N	\N	\N	\N	32804	32804	32805
9824	9328	65	applied	\N	\N	1000000000	\N	32845	32845	32846
9824	9338	66	applied	\N	\N	\N	\N	33014	33014	32868
9824	9339	67	applied	\N	\N	\N	\N	33015	33015	32870
9824	9154	68	applied	\N	\N	1000000000	\N	32398	32398	32399
9824	9160	69	applied	\N	\N	\N	\N	32414	32414	32415
9824	9142	70	applied	\N	\N	\N	\N	32346	32346	32347
9824	9273	71	applied	\N	\N	\N	\N	32708	32708	32709
9824	9253	72	applied	\N	\N	\N	\N	32654	32654	32654
9824	9147	73	applied	\N	\N	\N	\N	32362	32362	32363
9824	9345	74	applied	\N	\N	\N	\N	32891	32891	31583
9824	9348	75	applied	\N	\N	\N	\N	32898	32898	31583
9824	9184	76	applied	\N	\N	1000000000	\N	32467	32467	32468
9824	9194	77	applied	\N	\N	\N	\N	32493	32493	32494
9824	9201	78	applied	\N	\N	\N	\N	32511	32511	32512
9824	9155	79	applied	\N	\N	\N	\N	32400	32400	32401
9824	9254	80	applied	\N	\N	\N	\N	32655	32655	32655
9824	9255	81	applied	\N	\N	\N	\N	32656	32656	32656
9824	9349	82	applied	\N	\N	\N	\N	32899	32899	31583
9824	9352	83	applied	\N	\N	\N	\N	32909	32909	31583
9824	9353	84	applied	\N	\N	\N	\N	32910	32910	31583
9824	9354	85	applied	\N	\N	\N	\N	32911	32911	31583
9824	9355	86	applied	\N	\N	\N	\N	32912	32912	31583
9824	9356	87	applied	\N	\N	\N	\N	32913	32913	31583
9824	9357	88	applied	\N	\N	\N	\N	32914	32914	31583
9824	9358	89	applied	\N	\N	\N	\N	32915	32915	31583
9824	9364	90	applied	\N	\N	\N	\N	32930	32930	32931
9824	9381	91	applied	\N	\N	\N	\N	32970	32970	32931
9824	9382	92	applied	\N	\N	\N	\N	32971	32971	32931
9824	9383	93	applied	\N	\N	\N	\N	32972	32972	32931
9824	9384	94	applied	\N	\N	\N	\N	32973	32973	32931
9824	9385	95	applied	\N	\N	\N	\N	32974	32974	32931
9824	9387	96	applied	\N	\N	\N	\N	32976	32976	32931
9824	9388	97	applied	\N	\N	\N	\N	32980	32980	32931
9824	9389	98	applied	\N	\N	\N	\N	32984	32984	32931
9824	9390	99	applied	\N	\N	\N	\N	32985	32985	32931
9824	9208	100	applied	\N	\N	\N	\N	32529	32529	32530
9824	9214	101	applied	\N	\N	\N	\N	32547	32547	32548
9824	9221	102	applied	\N	\N	\N	\N	32567	32567	32568
9824	9229	103	applied	\N	\N	\N	\N	32591	32591	32592
9824	9274	104	applied	\N	\N	\N	\N	32710	32710	32711
9824	9275	105	applied	\N	\N	\N	\N	32712	32712	32713
9824	9156	106	applied	\N	\N	\N	\N	32402	32402	32403
9824	9401	108	applied	\N	\N	\N	\N	33017	33017	32477
9824	9400	109	applied	\N	\N	\N	\N	32995	32995	32931
9824	9256	110	applied	\N	\N	\N	\N	32657	32657	32657
9824	9257	111	applied	\N	\N	\N	\N	32658	32658	32658
9824	9268	112	applied	\N	\N	\N	\N	32696	32696	32697
9824	9269	113	applied	\N	\N	\N	\N	32698	32698	32699
9824	9270	114	applied	\N	\N	\N	\N	32700	32700	32701
9824	9271	115	applied	\N	\N	\N	\N	32702	32702	32703
9826	9403	0	applied	\N	\N	\N	\N	33024	33024	33025
9826	9404	1	applied	\N	\N	\N	\N	33026	33026	33027
9826	9405	2	applied	\N	\N	\N	\N	33028	33028	33029
9826	9406	3	applied	\N	\N	\N	\N	33030	33030	33031
9826	9407	4	applied	\N	\N	\N	\N	33032	33032	33033
9826	9408	5	applied	\N	\N	\N	\N	33034	33034	33035
9826	9409	6	applied	\N	\N	\N	\N	33036	33036	33037
9826	9410	7	applied	\N	\N	\N	\N	33038	33038	33039
9826	9411	8	applied	\N	\N	\N	\N	33040	33040	33041
9826	9412	9	applied	\N	\N	\N	\N	33042	33042	33043
9826	9413	10	applied	\N	\N	\N	\N	33044	33044	33045
9826	9414	11	applied	\N	\N	\N	\N	33046	33046	33047
9826	9388	12	applied	\N	\N	\N	\N	32980	32980	32975
9826	9389	13	applied	\N	\N	\N	\N	32984	32984	32975
9826	9390	14	applied	\N	\N	\N	\N	32985	32985	32975
9826	9391	15	applied	\N	\N	\N	\N	32986	32986	32985
9826	9392	16	applied	\N	\N	\N	\N	32987	32987	32985
9826	9393	17	applied	\N	\N	\N	\N	32988	32988	32985
9826	9394	18	applied	\N	\N	\N	\N	32989	32989	32985
9826	9395	19	applied	\N	\N	\N	\N	32990	32990	32985
9826	9396	20	applied	\N	\N	\N	\N	32991	32991	32985
9826	9397	21	applied	\N	\N	\N	\N	32992	32992	32985
9826	9398	22	applied	\N	\N	\N	\N	32993	32993	32985
9826	9399	23	applied	\N	\N	\N	\N	32994	32994	32985
9826	9415	24	applied	\N	\N	\N	\N	33048	33048	1435
9826	9400	25	applied	\N	\N	\N	\N	32995	32995	33048
9827	9416	0	applied	\N	\N	\N	\N	33050	33050	33051
9827	9417	1	applied	\N	\N	\N	\N	33052	33052	33053
9827	9418	2	applied	\N	\N	\N	\N	33054	33054	33055
9827	9419	3	applied	\N	\N	\N	\N	33056	33056	33057
9827	9420	4	applied	\N	\N	\N	\N	33058	33058	33059
9827	9421	5	applied	\N	\N	\N	\N	33060	33060	33061
9827	9422	6	applied	\N	\N	\N	\N	33062	33062	33063
9827	9423	7	applied	\N	\N	\N	\N	33064	33064	12588
9829	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
9829	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
9829	9226	2	applied	\N	\N	\N	\N	32585	32585	32586
9829	9402	3	applied	\N	\N	\N	\N	33020	33020	33021
9829	9403	4	applied	\N	\N	\N	\N	33024	33024	33025
9825	9402	0	applied	\N	\N	\N	\N	33020	33020	33021
9831	9426	0	applied	\N	\N	\N	\N	33082	33082	33083
9831	9427	1	applied	\N	\N	\N	\N	33084	33084	33085
9831	9428	2	applied	\N	\N	\N	\N	33086	33086	33087
9831	9429	3	applied	\N	\N	\N	\N	33088	33088	33089
9831	9430	4	applied	\N	\N	\N	\N	33090	33090	33091
9831	9431	5	applied	\N	\N	\N	\N	33092	33092	33093
9831	9432	6	applied	\N	\N	\N	\N	33094	33094	33095
9835	9448	0	applied	\N	\N	\N	\N	33132	33132	33133
9835	9449	1	applied	\N	\N	\N	\N	33134	33134	33135
9844	9456	0	applied	\N	\N	\N	\N	33160	33160	33161
9844	9457	1	applied	\N	\N	\N	\N	33162	33162	33163
9847	9460	0	applied	\N	\N	\N	\N	33174	33174	33175
9847	9461	1	applied	\N	\N	\N	\N	33176	33176	33177
9847	9462	2	applied	\N	\N	\N	\N	33178	33178	33179
9847	9463	3	applied	\N	\N	\N	\N	33180	33180	33181
9847	9464	4	applied	\N	\N	\N	\N	33182	33182	33183
9847	9465	5	applied	\N	\N	\N	\N	33186	33186	33187
9852	9473	0	applied	\N	\N	\N	\N	33209	33209	33210
9852	9474	1	applied	\N	\N	\N	\N	33211	33211	33212
9852	9475	2	applied	\N	\N	\N	\N	33213	33213	33214
9858	9486	0	applied	\N	\N	\N	\N	33244	33244	33245
9858	9487	1	applied	\N	\N	\N	\N	33246	33246	33247
9858	9488	2	applied	\N	\N	\N	\N	33248	33248	33249
9858	9489	3	applied	\N	\N	\N	\N	33250	33250	33251
9858	9490	4	applied	\N	\N	\N	\N	33252	33252	33253
9858	9491	5	applied	\N	\N	\N	\N	33254	33254	33255
9858	9492	6	applied	\N	\N	\N	\N	33256	33256	33257
9861	9499	0	applied	\N	\N	\N	\N	33275	33275	33276
9861	9500	1	applied	\N	\N	\N	\N	33277	33277	33278
9864	9499	0	applied	\N	\N	\N	\N	33275	33275	33276
9864	9500	1	applied	\N	\N	\N	\N	33277	33277	33278
9865	9501	0	applied	\N	\N	\N	\N	33284	33284	33285
9870	9506	0	applied	\N	\N	\N	\N	33303	33303	33304
9870	9507	1	applied	\N	\N	\N	\N	33305	33305	33306
9889	9523	0	applied	\N	\N	\N	\N	33357	33357	33358
9889	9524	1	applied	\N	\N	\N	\N	33359	33359	33360
9891	9525	0	applied	\N	\N	\N	\N	33365	33365	33366
9891	9526	1	applied	\N	\N	\N	\N	33367	33367	33368
9891	9527	2	applied	\N	\N	\N	\N	33369	33369	33370
9891	9528	3	applied	\N	\N	\N	\N	33371	33371	33372
9896	9534	0	applied	\N	\N	\N	\N	33393	33393	33394
9896	9535	1	applied	\N	\N	\N	\N	33395	33395	33396
9901	9540	0	applied	\N	\N	\N	\N	33415	33415	33416
9901	9541	1	applied	\N	\N	\N	\N	33417	33417	33418
9904	9546	0	applied	\N	\N	\N	\N	33432	33432	33433
9904	9547	1	applied	\N	\N	\N	\N	33434	33434	33435
9906	9548	0	applied	\N	\N	\N	\N	33439	33439	33440
9906	9549	1	applied	\N	\N	\N	\N	33441	33441	33442
9909	9550	0	applied	\N	\N	\N	\N	33447	33447	33448
9909	9551	1	applied	\N	\N	\N	\N	33449	33449	33450
9909	9552	2	applied	\N	\N	\N	\N	33451	33451	33452
9909	9553	3	applied	\N	\N	\N	\N	33453	33453	33454
9909	9554	4	applied	\N	\N	\N	\N	33455	33455	33456
9909	9555	5	applied	\N	\N	\N	\N	33457	33457	33458
9909	9556	6	applied	\N	\N	\N	\N	33459	33459	33460
9909	9557	7	applied	\N	\N	\N	\N	33461	33461	33462
9912	9560	0	applied	\N	\N	\N	\N	33471	33471	33472
9912	9561	1	applied	\N	\N	\N	\N	33473	33473	33474
9912	9562	2	applied	\N	\N	\N	\N	33475	33475	33476
9912	9563	3	applied	\N	\N	\N	\N	33477	33477	33478
9914	9565	0	applied	\N	\N	\N	\N	33485	33485	33486
9914	9566	1	applied	\N	\N	\N	\N	33487	33487	33488
9917	9573	0	applied	\N	\N	\N	\N	33505	33505	33506
9917	9574	1	applied	\N	\N	\N	\N	33507	33507	33508
9917	9575	2	applied	\N	\N	\N	\N	33509	33509	33510
9920	9583	0	applied	\N	\N	\N	\N	33529	33529	33530
9920	9584	1	applied	\N	\N	\N	\N	33531	33531	33532
9925	9589	0	applied	\N	\N	\N	\N	33546	33546	33547
9925	9590	1	applied	\N	\N	\N	\N	33548	33548	33549
9927	9591	0	applied	\N	\N	\N	\N	33554	33554	33555
9927	9592	1	applied	\N	\N	\N	\N	33556	33556	33557
9927	9593	2	applied	\N	\N	\N	\N	33558	33558	33559
9927	9594	3	applied	\N	\N	\N	\N	33560	33560	33561
9927	9595	4	applied	\N	\N	\N	\N	33562	33562	33563
9940	9614	0	applied	\N	\N	\N	\N	33620	33620	33621
9940	9615	1	applied	\N	\N	\N	\N	33622	33622	33623
9944	9619	0	applied	\N	\N	\N	\N	33638	33638	33639
9944	9620	1	applied	\N	\N	\N	\N	33640	33640	33641
9953	9641	0	applied	\N	\N	\N	\N	33696	33696	33697
9955	9642	0	applied	\N	\N	\N	\N	33704	33704	33705
9955	9643	1	applied	\N	\N	\N	\N	33706	33706	33707
9955	9644	2	applied	\N	\N	\N	\N	33708	33708	33709
9955	9645	3	applied	\N	\N	\N	\N	33710	33710	33711
9955	9646	4	applied	\N	\N	\N	\N	33712	33712	33713
9964	9639	0	applied	\N	\N	\N	\N	33690	33690	33691
9964	9640	1	applied	\N	\N	\N	\N	33692	33692	33693
9964	9641	2	applied	\N	\N	\N	\N	33696	33696	33723
9964	9642	3	applied	\N	\N	\N	\N	33704	33704	33724
9964	9643	4	applied	\N	\N	\N	\N	33706	33706	33725
9964	9644	5	applied	\N	\N	\N	\N	33708	33708	33709
9964	9645	6	applied	\N	\N	\N	\N	33710	33710	33711
9964	9648	7	applied	\N	\N	\N	\N	33726	33726	33727
9964	9649	8	applied	\N	\N	\N	\N	33728	33728	33729
9964	9647	9	applied	\N	\N	\N	\N	33718	33718	33730
9964	9650	10	applied	\N	\N	\N	\N	33731	33731	33732
9964	9651	11	applied	\N	\N	\N	\N	33733	33733	33734
9964	9646	12	applied	\N	\N	\N	\N	33712	33712	33713
9968	9650	0	applied	\N	\N	\N	\N	33731	33731	33737
9968	9648	1	applied	\N	\N	\N	\N	33726	33726	33727
9968	9649	2	applied	\N	\N	\N	\N	33728	33728	33729
9968	9652	3	applied	\N	\N	\N	\N	33738	33738	33739
9968	9651	4	applied	\N	\N	\N	\N	33733	33733	33740
9968	9653	5	applied	\N	\N	\N	\N	33741	33741	33742
9968	9654	6	applied	\N	\N	\N	\N	33743	33743	33744
9971	9655	0	applied	\N	\N	\N	\N	33754	33754	33755
9971	9656	1	applied	\N	\N	\N	\N	33756	33756	33757
9971	9657	2	applied	\N	\N	\N	\N	33765	33765	33766
9971	9658	3	applied	\N	\N	\N	\N	33767	33767	33768
9977	9661	0	applied	\N	\N	\N	\N	33779	33779	33780
9977	9662	1	applied	\N	\N	\N	\N	33781	33781	33782
9977	9663	2	applied	\N	\N	\N	\N	33783	33783	33784
9977	9664	3	applied	\N	\N	\N	\N	33785	33785	33786
9977	9665	4	applied	\N	\N	\N	\N	33787	33787	33788
9980	9668	0	applied	\N	\N	\N	\N	33797	33797	33798
9980	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9980	9670	2	applied	\N	\N	\N	\N	33801	33801	33802
9980	9671	3	applied	\N	\N	\N	\N	33803	33803	33804
9980	9672	4	applied	\N	\N	\N	\N	33805	33805	33806
9980	9673	5	applied	\N	\N	\N	\N	33807	33807	33808
9828	9416	0	applied	\N	\N	\N	\N	33050	33050	33051
9830	9417	0	applied	\N	\N	\N	\N	33052	33052	33053
9830	9418	1	applied	\N	\N	\N	\N	33054	33054	33055
9830	9419	2	applied	\N	\N	\N	\N	33056	33056	33057
9830	9424	3	applied	\N	\N	\N	\N	33076	33076	33077
9830	9420	4	applied	\N	\N	\N	\N	33058	33058	33059
9830	9421	5	applied	\N	\N	\N	\N	33060	33060	33061
9830	9422	6	applied	\N	\N	\N	\N	33062	33062	33063
9830	9425	7	applied	\N	\N	\N	\N	33078	33078	33079
9830	9423	8	applied	\N	\N	\N	\N	33064	33064	12588
9833	9433	0	applied	\N	\N	\N	\N	33098	33098	33099
9833	9434	1	applied	\N	\N	\N	\N	33100	33100	33101
9833	9435	2	applied	\N	\N	\N	\N	33104	33104	33105
9834	9436	0	applied	\N	\N	\N	\N	33107	33107	33108
9834	9437	1	applied	\N	\N	\N	\N	33109	33109	33110
9834	9438	2	applied	\N	\N	\N	\N	33111	33111	33112
9834	9439	3	applied	\N	\N	\N	\N	33113	33113	33114
9834	9435	4	applied	\N	\N	\N	\N	33104	33104	33105
9834	9440	5	applied	\N	\N	\N	\N	33115	33115	33116
9834	9441	6	applied	\N	\N	\N	\N	33117	33117	33118
9834	9442	7	applied	\N	\N	\N	\N	33119	33119	33120
9834	9443	8	applied	\N	\N	\N	\N	33121	33121	33122
9834	9444	9	applied	\N	\N	\N	\N	33123	33123	33124
9834	9445	10	applied	\N	\N	\N	\N	33125	33125	33126
9834	9446	11	applied	\N	\N	\N	\N	33127	33127	33128
9834	9447	12	applied	\N	\N	\N	\N	33129	33129	33130
9837	9450	0	applied	\N	\N	\N	\N	33137	33137	33138
9837	9451	1	applied	\N	\N	\N	\N	33139	33139	33140
9839	9452	0	applied	\N	\N	\N	\N	33144	33144	33145
9839	9453	1	applied	\N	\N	\N	\N	33146	33146	33147
9849	9466	0	applied	\N	\N	\N	\N	33189	33189	33190
9854	9476	0	applied	\N	\N	\N	\N	33217	33217	33218
9857	9484	0	applied	\N	\N	\N	\N	33238	33238	33239
9857	9485	1	applied	\N	\N	\N	\N	33240	33240	33241
9860	9497	0	applied	\N	\N	\N	\N	33269	33269	33270
9860	9498	1	applied	\N	\N	\N	\N	33271	33271	33272
9863	9499	0	applied	\N	\N	\N	\N	33275	33275	33276
9863	9500	1	applied	\N	\N	\N	\N	33277	33277	33278
9867	9502	0	applied	\N	\N	\N	\N	33289	33289	33290
9867	9503	1	applied	\N	\N	\N	\N	33291	33291	33292
9867	9504	2	applied	\N	\N	\N	\N	33293	33293	33294
9867	9505	3	applied	\N	\N	\N	\N	33295	33295	33296
9872	9508	0	applied	\N	\N	\N	\N	33307	33307	33308
9872	9509	1	applied	\N	\N	\N	\N	33309	33309	33310
9888	9523	0	applied	\N	\N	\N	\N	33357	33357	33358
9888	9524	1	applied	\N	\N	\N	\N	33359	33359	33360
9898	9536	0	applied	\N	\N	\N	\N	33401	33401	33402
9898	9537	1	applied	\N	\N	\N	\N	33403	33403	33404
9900	9538	0	applied	\N	\N	\N	\N	33407	33407	33408
9900	9539	1	applied	\N	\N	\N	\N	33409	33409	33410
9903	9544	0	applied	\N	\N	\N	\N	33427	33427	33428
9903	9545	1	applied	\N	\N	\N	\N	33429	33429	33430
9911	9560	0	applied	\N	\N	\N	\N	33471	33471	33472
9911	9561	1	applied	\N	\N	\N	\N	33473	33473	33474
9911	9562	2	applied	\N	\N	\N	\N	33475	33475	33476
9911	9563	3	applied	\N	\N	\N	\N	33477	33477	33478
9922	9585	0	applied	\N	\N	\N	\N	33535	33535	33536
9932	9599	0	applied	\N	\N	\N	\N	33578	33578	33579
9932	9600	1	applied	\N	\N	\N	\N	33580	33580	33581
9937	9607	0	applied	\N	\N	\N	\N	33602	33602	33603
9937	9608	1	applied	\N	\N	\N	\N	33604	33604	33605
9937	9609	2	applied	\N	\N	\N	\N	33606	33606	33607
9937	9610	3	applied	\N	\N	\N	\N	33608	33608	33609
9937	9611	4	applied	\N	\N	\N	\N	33610	33610	33611
9937	9612	5	applied	\N	\N	\N	\N	33612	33612	33613
9937	9613	6	applied	\N	\N	\N	\N	33614	33614	33615
9939	9614	0	applied	\N	\N	\N	\N	33620	33620	33621
9939	9615	1	applied	\N	\N	\N	\N	33622	33622	33623
9943	9616	0	applied	\N	\N	\N	\N	33630	33630	33631
9943	9617	1	applied	\N	\N	\N	\N	33632	33632	33633
9943	9618	2	applied	\N	\N	\N	\N	33634	33634	33635
9950	9637	0	applied	\N	\N	\N	\N	33684	33684	33685
9950	9638	1	applied	\N	\N	\N	\N	33686	33686	33687
9952	9641	0	applied	\N	\N	\N	\N	33696	33696	33697
9961	9647	0	applied	\N	\N	\N	\N	33718	33718	33719
9966	9650	0	applied	\N	\N	\N	\N	33731	33731	33737
9966	9648	1	applied	\N	\N	\N	\N	33726	33726	33727
9966	9649	2	applied	\N	\N	\N	\N	33728	33728	33729
9966	9652	3	applied	\N	\N	\N	\N	33738	33738	33739
9966	9651	4	applied	\N	\N	\N	\N	33733	33733	33740
9966	9653	5	applied	\N	\N	\N	\N	33741	33741	33742
9966	9654	6	applied	\N	\N	\N	\N	33743	33743	33744
9970	9655	0	applied	\N	\N	\N	\N	33754	33754	33755
9970	9656	1	applied	\N	\N	\N	\N	33756	33756	33757
9970	9657	2	applied	\N	\N	\N	\N	33765	33765	33766
9970	9658	3	applied	\N	\N	\N	\N	33767	33767	33768
9975	9655	0	applied	\N	\N	\N	\N	33754	33754	33755
9975	9656	1	applied	\N	\N	\N	\N	33756	33756	33757
9975	9660	2	applied	\N	\N	\N	\N	33775	33775	33776
9979	9666	0	applied	\N	\N	\N	\N	33789	33789	33790
9979	9667	1	applied	\N	\N	\N	\N	33791	33791	33792
9984	9674	0	applied	\N	\N	\N	\N	33815	33815	33816
9984	9675	1	applied	\N	\N	\N	\N	33817	33817	33818
9984	9676	2	applied	\N	\N	\N	\N	33819	33819	33820
9984	9677	3	applied	\N	\N	\N	\N	33821	33821	33822
9984	9678	4	applied	\N	\N	\N	\N	33823	33823	33824
9987	9680	0	applied	\N	\N	\N	\N	33842	33842	33843
9987	9681	1	applied	\N	\N	\N	\N	33844	33844	33845
9987	9682	2	applied	\N	\N	\N	\N	33846	33846	33847
9987	9683	3	applied	\N	\N	\N	\N	33848	33848	33849
9987	9684	4	applied	\N	\N	\N	\N	33850	33850	33851
9987	9685	5	applied	\N	\N	\N	\N	33852	33852	33853
9991	9688	0	applied	\N	\N	\N	\N	33868	33868	33869
9991	9689	1	applied	\N	\N	\N	\N	33870	33870	33871
9994	9698	0	applied	\N	\N	\N	\N	33890	33890	33891
9994	9699	1	applied	\N	\N	\N	\N	33892	33892	33893
9998	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
9998	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
9998	9110	2	applied	\N	\N	\N	\N	32253	32253	32205
9998	9148	3	applied	\N	\N	\N	\N	32368	32368	32369
9998	9157	4	applied	\N	\N	\N	\N	32408	32408	32409
9998	9158	5	applied	\N	\N	\N	\N	32410	32410	32411
9998	9159	6	applied	\N	\N	\N	\N	32412	32412	32413
9998	9226	7	applied	\N	\N	\N	\N	32585	32585	32586
9998	9576	8	applied	\N	\N	\N	\N	33514	33514	33515
9998	9591	9	applied	\N	\N	\N	\N	33751	33751	33555
9998	9592	10	applied	\N	\N	\N	\N	33752	33752	33557
9998	9593	11	applied	\N	\N	\N	\N	33753	33753	33559
9998	9402	12	applied	\N	\N	\N	\N	33020	33020	33021
9998	9403	13	applied	\N	\N	\N	\N	33024	33024	33025
9829	9404	5	applied	\N	\N	\N	\N	33026	33026	33027
9829	9405	6	applied	\N	\N	\N	\N	33028	33028	33029
9829	9416	7	applied	\N	\N	\N	\N	33050	33050	33051
9829	9173	8	applied	\N	\N	\N	\N	32446	32446	32350
9829	9174	9	applied	\N	\N	\N	\N	32447	32447	32448
9829	9276	10	applied	\N	\N	1000000000	\N	32715	32715	32716
9829	9293	11	applied	\N	\N	\N	\N	32998	32998	32762
9829	9294	12	applied	\N	\N	\N	\N	32999	32999	32764
9829	9189	13	applied	\N	\N	\N	\N	32483	32483	32484
9829	9331	14	applied	\N	\N	\N	\N	33000	33000	32855
9829	9332	15	applied	\N	\N	\N	\N	33001	33001	32857
9829	9234	16	applied	\N	\N	\N	\N	32609	32609	32610
9829	9360	17	applied	\N	\N	\N	\N	33068	33068	32923
9829	9361	18	applied	\N	\N	\N	\N	33069	33069	32925
9829	9237	19	applied	\N	\N	\N	\N	32617	32617	32618
9829	9191	20	applied	\N	\N	\N	\N	32487	32487	32488
9829	9192	21	applied	\N	\N	\N	\N	32489	32489	32490
9829	9193	22	applied	\N	\N	\N	\N	32491	32491	32492
9829	9197	23	applied	\N	\N	\N	\N	32503	32503	32504
9829	9295	24	applied	\N	\N	\N	\N	32766	32766	32767
9829	9178	25	applied	\N	\N	\N	\N	32455	32455	32456
9829	9179	26	applied	\N	\N	\N	\N	32457	32457	32458
9829	9180	27	applied	\N	\N	\N	\N	32459	32459	32460
9829	9238	28	applied	\N	\N	\N	\N	32619	32619	32620
9829	9239	29	applied	\N	\N	1000000000	\N	32621	32621	32622
9829	9164	30	applied	\N	\N	\N	\N	32422	32422	32423
9829	9165	31	applied	\N	\N	\N	\N	32424	32424	32425
9829	9166	32	applied	\N	\N	\N	\N	32426	32426	32427
9829	9172	33	applied	\N	\N	\N	\N	32444	32444	32445
9829	9246	34	applied	\N	\N	\N	\N	33070	33070	32398
9829	9186	35	applied	\N	\N	\N	\N	32476	32476	32477
9829	9200	36	applied	\N	\N	\N	\N	32509	32509	32510
9829	9362	37	applied	\N	\N	\N	\N	33071	33071	32927
9829	9363	38	applied	\N	\N	\N	\N	33072	33072	32929
9829	9297	39	applied	\N	\N	\N	\N	33002	33002	32771
9829	9298	40	applied	\N	\N	\N	\N	33003	33003	32773
9829	9211	41	applied	\N	\N	\N	\N	32538	32538	32539
9829	9215	42	applied	\N	\N	\N	\N	32553	32553	32554
9829	9216	43	applied	\N	\N	\N	\N	32555	32555	32556
9829	9217	44	applied	\N	\N	\N	\N	32557	32557	32558
9829	9232	45	applied	\N	\N	1000000000	\N	32603	32603	32604
9829	9301	46	applied	\N	\N	\N	\N	33008	33008	32781
9829	9302	47	applied	\N	\N	\N	\N	33009	33009	32783
9829	9303	48	applied	\N	\N	\N	\N	33010	33010	32785
9829	9304	49	applied	\N	\N	\N	\N	33011	33011	32787
9829	9305	50	applied	\N	\N	\N	\N	33012	33012	32789
9829	9306	51	applied	\N	\N	\N	\N	33013	33013	32791
9829	9310	52	applied	\N	\N	\N	\N	32800	32800	32801
9829	9311	53	applied	\N	\N	\N	\N	32802	32802	32803
9829	9312	54	applied	\N	\N	\N	\N	32804	32804	32805
9829	9328	55	applied	\N	\N	1000000000	\N	32845	32845	32846
9829	9338	56	applied	\N	\N	\N	\N	33014	33014	32868
9829	9339	57	applied	\N	\N	\N	\N	33015	33015	32870
9829	9414	58	applied	\N	\N	\N	\N	33073	33073	33047
9829	9273	59	applied	\N	\N	\N	\N	32708	32708	32709
9829	9253	60	applied	\N	\N	\N	\N	32654	32654	32654
9829	9345	61	applied	\N	\N	\N	\N	32891	32891	31583
9829	9348	62	applied	\N	\N	\N	\N	32898	32898	31583
9829	9184	63	applied	\N	\N	1000000000	\N	32467	32467	32468
9829	9194	64	applied	\N	\N	\N	\N	32493	32493	32494
9829	9201	65	applied	\N	\N	\N	\N	32511	32511	32512
9829	9254	66	applied	\N	\N	\N	\N	32655	32655	32655
9829	9255	67	applied	\N	\N	\N	\N	32656	32656	32656
9829	9349	68	applied	\N	\N	\N	\N	32899	32899	31583
9829	9352	69	applied	\N	\N	\N	\N	32909	32909	31583
9829	9353	70	applied	\N	\N	\N	\N	32910	32910	31583
9829	9354	71	applied	\N	\N	\N	\N	32911	32911	31583
9829	9355	72	applied	\N	\N	\N	\N	32912	32912	31583
9829	9356	73	applied	\N	\N	\N	\N	32913	32913	31583
9829	9357	74	applied	\N	\N	\N	\N	32914	32914	31583
9832	9433	0	applied	\N	\N	\N	\N	33098	33098	33099
9832	9434	1	applied	\N	\N	\N	\N	33100	33100	33101
9836	9450	0	applied	\N	\N	\N	\N	33137	33137	33138
9836	9451	1	applied	\N	\N	\N	\N	33139	33139	33140
9841	9454	0	applied	\N	\N	\N	\N	33152	33152	33153
9841	9455	1	applied	\N	\N	\N	\N	33154	33154	33155
9843	9456	0	applied	\N	\N	\N	\N	33160	33160	33161
9843	9457	1	applied	\N	\N	\N	\N	33162	33162	33163
9846	9460	0	applied	\N	\N	\N	\N	33174	33174	33175
9846	9461	1	applied	\N	\N	\N	\N	33176	33176	33177
9846	9462	2	applied	\N	\N	\N	\N	33178	33178	33179
9846	9463	3	applied	\N	\N	\N	\N	33180	33180	33181
9846	9464	4	applied	\N	\N	\N	\N	33182	33182	33183
9848	9466	0	applied	\N	\N	\N	\N	33189	33189	33190
9851	9469	0	applied	\N	\N	\N	\N	33200	33200	33201
9851	9470	1	applied	\N	\N	\N	\N	33202	33202	33203
9851	9471	2	applied	\N	\N	\N	\N	33204	33204	33205
9851	9472	3	applied	\N	\N	\N	\N	33206	33206	33207
9856	9477	0	applied	\N	\N	\N	\N	33222	33222	33223
9856	9478	1	applied	\N	\N	\N	\N	33224	33224	33225
9856	9479	2	applied	\N	\N	\N	\N	33226	33226	33227
9856	9480	3	applied	\N	\N	\N	\N	33228	33228	33229
9856	9481	4	applied	\N	\N	\N	\N	33230	33230	33231
9856	9482	5	applied	\N	\N	\N	\N	33232	33232	33233
9856	9483	6	applied	\N	\N	\N	\N	33234	33234	33235
9869	9502	0	applied	\N	\N	\N	\N	33289	33289	33290
9869	9503	1	applied	\N	\N	\N	\N	33291	33291	33292
9869	9504	2	applied	\N	\N	\N	\N	33293	33293	33294
9869	9505	3	applied	\N	\N	\N	\N	33295	33295	33296
9871	9508	0	applied	\N	\N	\N	\N	33307	33307	33308
9871	9509	1	applied	\N	\N	\N	\N	33309	33309	33310
9874	9510	0	applied	\N	\N	\N	\N	33315	33315	33316
9874	9511	1	applied	\N	\N	\N	\N	33317	33317	33318
9879	9519	0	applied	\N	\N	\N	\N	33338	33338	33339
9879	9520	1	applied	\N	\N	\N	\N	33340	33340	33341
9882	9519	0	applied	\N	\N	\N	\N	33338	33338	33339
9882	9520	1	applied	\N	\N	\N	\N	33340	33340	33341
9886	9521	0	applied	\N	\N	\N	\N	33351	33351	33352
9886	9522	1	applied	\N	\N	\N	\N	33353	33353	33354
9890	9523	0	applied	\N	\N	\N	\N	33357	33357	33358
9890	9524	1	applied	\N	\N	\N	\N	33359	33359	33360
9893	9529	0	applied	\N	\N	\N	\N	33375	33375	33376
9895	9530	0	applied	\N	\N	\N	\N	33383	33383	33384
9895	9531	1	applied	\N	\N	\N	\N	33385	33385	33386
9895	9532	2	applied	\N	\N	\N	\N	33387	33387	33388
9895	9533	3	applied	\N	\N	\N	\N	33389	33389	33390
9902	9542	0	applied	\N	\N	\N	\N	33421	33421	33422
9902	9543	1	applied	\N	\N	\N	\N	33423	33423	33424
9910	9558	0	applied	\N	\N	\N	\N	33465	33465	33466
9838	9452	0	applied	\N	\N	\N	\N	33144	33144	33145
9838	9453	1	applied	\N	\N	\N	\N	33146	33146	33147
9840	9454	0	applied	\N	\N	\N	\N	33152	33152	33153
9840	9455	1	applied	\N	\N	\N	\N	33154	33154	33155
9842	9454	0	applied	\N	\N	\N	\N	33152	33152	33153
9842	9455	1	applied	\N	\N	\N	\N	33154	33154	33155
9845	9458	0	applied	\N	\N	\N	\N	33168	33168	33169
9845	9459	1	applied	\N	\N	\N	\N	33170	33170	33171
9850	9467	0	applied	\N	\N	\N	\N	33194	33194	33195
9850	9468	1	applied	\N	\N	\N	\N	33196	33196	33197
9853	9473	0	applied	\N	\N	\N	\N	33209	33209	33210
9853	9474	1	applied	\N	\N	\N	\N	33211	33211	33212
9853	9475	2	applied	\N	\N	\N	\N	33213	33213	33214
9859	9493	0	applied	\N	\N	\N	\N	33260	33260	33261
9859	9494	1	applied	\N	\N	\N	\N	33262	33262	33263
9859	9495	2	applied	\N	\N	\N	\N	33264	33264	33265
9859	9496	3	applied	\N	\N	\N	\N	33266	33266	33267
9862	9499	0	applied	\N	\N	\N	\N	33275	33275	33276
9862	9500	1	applied	\N	\N	\N	\N	33277	33277	33278
9866	9501	0	applied	\N	\N	\N	\N	33284	33284	33285
9868	9502	0	applied	\N	\N	\N	\N	33289	33289	33290
9868	9503	1	applied	\N	\N	\N	\N	33291	33291	33292
9868	9504	2	applied	\N	\N	\N	\N	33293	33293	33294
9868	9505	3	applied	\N	\N	\N	\N	33295	33295	33296
9873	9510	0	applied	\N	\N	\N	\N	33315	33315	33316
9873	9511	1	applied	\N	\N	\N	\N	33317	33317	33318
9875	9512	0	applied	\N	\N	\N	\N	33320	33320	33321
9875	9513	1	applied	\N	\N	\N	\N	33322	33322	33323
9876	9514	0	applied	\N	\N	\N	\N	33326	33326	33327
9876	9515	1	applied	\N	\N	\N	\N	33328	33328	33329
9876	9516	2	applied	\N	\N	\N	\N	33330	33330	33331
9876	9517	3	applied	\N	\N	\N	\N	33332	33332	33333
9876	9518	4	applied	\N	\N	\N	\N	33334	33334	33335
9878	9519	0	applied	\N	\N	\N	\N	33338	33338	33339
9878	9520	1	applied	\N	\N	\N	\N	33340	33340	33341
9881	9519	0	applied	\N	\N	\N	\N	33338	33338	33339
9881	9520	1	applied	\N	\N	\N	\N	33340	33340	33341
9885	9521	0	applied	\N	\N	\N	\N	33351	33351	33352
9885	9522	1	applied	\N	\N	\N	\N	33353	33353	33354
9887	9521	0	applied	\N	\N	\N	\N	33351	33351	33352
9887	9522	1	applied	\N	\N	\N	\N	33353	33353	33354
9892	9529	0	applied	\N	\N	\N	\N	33375	33375	33376
9894	9525	0	applied	\N	\N	\N	\N	33365	33365	33366
9894	9526	1	applied	\N	\N	\N	\N	33367	33367	33368
9894	9527	2	applied	\N	\N	\N	\N	33369	33369	33370
9894	9529	3	applied	\N	\N	\N	\N	33375	33375	33376
9894	9528	4	applied	\N	\N	\N	\N	33371	33371	33372
9897	9534	0	applied	\N	\N	\N	\N	33393	33393	33394
9897	9535	1	applied	\N	\N	\N	\N	33395	33395	33396
9899	9538	0	applied	\N	\N	\N	\N	33407	33407	33408
9899	9539	1	applied	\N	\N	\N	\N	33409	33409	33410
9905	9544	0	applied	\N	\N	\N	\N	33427	33427	33428
9905	9545	1	applied	\N	\N	\N	\N	33429	33429	33430
9905	9546	2	applied	\N	\N	\N	\N	33432	33432	33433
9905	9547	3	applied	\N	\N	\N	\N	33434	33434	33435
9915	9567	0	applied	\N	\N	\N	\N	33491	33491	33492
9915	9568	1	applied	\N	\N	\N	\N	33493	33493	33494
9915	9569	2	applied	\N	\N	\N	\N	33495	33495	33496
9915	9570	3	applied	\N	\N	\N	\N	33497	33497	33498
9921	9585	0	applied	\N	\N	\N	\N	33535	33535	33536
9921	9586	1	applied	\N	\N	\N	\N	33537	33537	33538
9923	9587	0	applied	\N	\N	\N	\N	33540	33540	33541
9923	9586	1	applied	\N	\N	\N	\N	33537	33537	33538
9923	9588	2	applied	\N	\N	\N	\N	33542	33542	33543
9928	9596	0	applied	\N	\N	\N	\N	33568	33568	33569
9930	9597	0	applied	\N	\N	\N	\N	33572	33572	33573
9930	9598	1	applied	\N	\N	\N	\N	33574	33574	33575
9933	9601	0	applied	\N	\N	\N	\N	33585	33585	33586
9933	9602	1	applied	\N	\N	\N	\N	33587	33587	33588
9933	9603	2	applied	\N	\N	\N	\N	33589	33589	33590
9933	9604	3	applied	\N	\N	\N	\N	33591	33591	33592
9935	9605	0	applied	\N	\N	\N	\N	33596	33596	33597
9935	9606	1	applied	\N	\N	\N	\N	33598	33598	33599
9945	9621	0	applied	\N	\N	\N	\N	33644	33644	33645
9945	9622	1	applied	\N	\N	\N	\N	33646	33646	33647
9946	9623	0	applied	\N	\N	\N	\N	33648	33648	33649
9946	9624	1	applied	\N	\N	\N	\N	33650	33650	33651
9946	9625	2	applied	\N	\N	\N	\N	33652	33652	33653
9946	9626	3	applied	\N	\N	\N	\N	33654	33654	33655
9946	9627	4	applied	\N	\N	\N	\N	33656	33656	33657
9946	9628	5	applied	\N	\N	\N	\N	33658	33658	33659
9951	9639	0	applied	\N	\N	\N	\N	33690	33690	33691
9951	9640	1	applied	\N	\N	\N	\N	33692	33692	33693
9954	9641	0	applied	\N	\N	\N	\N	33696	33696	33697
9956	9642	0	applied	\N	\N	\N	\N	33704	33704	33705
9956	9643	1	applied	\N	\N	\N	\N	33706	33706	33707
9956	9644	2	applied	\N	\N	\N	\N	33708	33708	33709
9956	9645	3	applied	\N	\N	\N	\N	33710	33710	33711
9956	9646	4	applied	\N	\N	\N	\N	33712	33712	33713
9969	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
9969	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
9969	9576	2	applied	\N	\N	\N	\N	33514	33514	33515
9969	9591	3	applied	\N	\N	\N	\N	33751	33751	33555
9969	9592	4	applied	\N	\N	\N	\N	33752	33752	33557
9969	9593	5	applied	\N	\N	\N	\N	33753	33753	33559
9969	9402	6	applied	\N	\N	\N	\N	33020	33020	33021
9969	9403	7	applied	\N	\N	\N	\N	33024	33024	33025
9969	9404	8	applied	\N	\N	\N	\N	33026	33026	33027
9969	9405	9	applied	\N	\N	\N	\N	33028	33028	33029
9969	9416	10	applied	\N	\N	\N	\N	33050	33050	33051
9969	9639	11	applied	\N	\N	\N	\N	33690	33690	33691
9969	9473	12	applied	\N	\N	\N	\N	33209	33209	33210
9969	9331	13	applied	\N	\N	\N	\N	32854	32854	32855
9969	9332	14	applied	\N	\N	\N	\N	32856	32856	32857
9969	9607	15	applied	\N	\N	\N	\N	33602	33602	33603
9969	9479	16	applied	\N	\N	\N	\N	33226	33226	33227
9969	9360	17	applied	\N	\N	\N	\N	32922	32922	32923
9969	9361	18	applied	\N	\N	\N	\N	32924	32924	32925
9969	9655	19	applied	\N	\N	\N	\N	33754	33754	33755
9969	9656	20	applied	\N	\N	\N	\N	33756	33756	33757
9969	9609	21	applied	\N	\N	\N	\N	33606	33606	33607
9969	9610	22	applied	\N	\N	\N	\N	33608	33608	33609
9969	9612	23	applied	\N	\N	\N	\N	33612	33612	33613
9969	9362	24	applied	\N	\N	\N	\N	32926	32926	32927
9969	9363	25	applied	\N	\N	\N	\N	32928	32928	32929
9969	9613	26	applied	\N	\N	\N	\N	33614	33614	33615
9969	9338	27	applied	\N	\N	\N	\N	32867	32867	32868
9969	9339	28	applied	\N	\N	\N	\N	32869	32869	32870
9969	9489	29	applied	\N	\N	\N	\N	33250	33250	33251
9969	9490	30	applied	\N	\N	\N	\N	33252	33252	33253
9910	9559	1	applied	\N	\N	\N	\N	33467	33467	33468
9913	9564	0	applied	\N	\N	\N	\N	33482	33482	33483
9916	9571	0	applied	\N	\N	\N	\N	33500	33500	33501
9916	9572	1	applied	\N	\N	\N	\N	33502	33502	33503
9918	9573	0	applied	\N	\N	\N	\N	33505	33505	33506
9918	9574	1	applied	\N	\N	\N	\N	33507	33507	33508
9918	9575	2	applied	\N	\N	\N	\N	33509	33509	33510
9919	9576	0	applied	\N	\N	\N	\N	33514	33514	33515
9919	9577	1	applied	\N	\N	\N	\N	33516	33516	33517
9919	9578	2	applied	\N	\N	\N	\N	33518	33518	33519
9919	9579	3	applied	\N	\N	\N	\N	33520	33520	33521
9919	9580	4	applied	\N	\N	\N	\N	33522	33522	33523
9919	9581	5	applied	\N	\N	\N	\N	33524	33524	33525
9919	9582	6	applied	\N	\N	\N	\N	33526	33526	33527
9924	9589	0	applied	\N	\N	\N	\N	33546	33546	33547
9924	9590	1	applied	\N	\N	\N	\N	33548	33548	33549
9926	9591	0	applied	\N	\N	\N	\N	33554	33554	33555
9926	9592	1	applied	\N	\N	\N	\N	33556	33556	33557
9926	9593	2	applied	\N	\N	\N	\N	33558	33558	33559
9926	9594	3	applied	\N	\N	\N	\N	33560	33560	33561
9926	9595	4	applied	\N	\N	\N	\N	33562	33562	33563
9931	9599	0	applied	\N	\N	\N	\N	33578	33578	33579
9931	9600	1	applied	\N	\N	\N	\N	33580	33580	33581
9934	9601	0	applied	\N	\N	\N	\N	33585	33585	33586
9934	9602	1	applied	\N	\N	\N	\N	33587	33587	33588
9934	9603	2	applied	\N	\N	\N	\N	33589	33589	33590
9934	9604	3	applied	\N	\N	\N	\N	33591	33591	33592
9936	9607	0	applied	\N	\N	\N	\N	33602	33602	33603
9936	9608	1	applied	\N	\N	\N	\N	33604	33604	33605
9936	9609	2	applied	\N	\N	\N	\N	33606	33606	33607
9936	9610	3	applied	\N	\N	\N	\N	33608	33608	33609
9936	9611	4	applied	\N	\N	\N	\N	33610	33610	33611
9936	9612	5	applied	\N	\N	\N	\N	33612	33612	33613
9936	9613	6	applied	\N	\N	\N	\N	33614	33614	33615
9938	9614	0	applied	\N	\N	\N	\N	33620	33620	33621
9938	9615	1	applied	\N	\N	\N	\N	33622	33622	33623
9941	9614	0	applied	\N	\N	\N	\N	33620	33620	33621
9941	9615	1	applied	\N	\N	\N	\N	33622	33622	33623
9942	9614	0	applied	\N	\N	\N	\N	33620	33620	33621
9942	9615	1	applied	\N	\N	\N	\N	33622	33622	33623
9947	9629	0	applied	\N	\N	\N	\N	33662	33662	33663
9947	9630	1	applied	\N	\N	\N	\N	33664	33664	33665
9947	9631	2	applied	\N	\N	\N	\N	33666	33666	33667
9947	9632	3	applied	\N	\N	\N	\N	33668	33668	33669
9947	9633	4	applied	\N	\N	\N	\N	33670	33670	33671
9947	9634	5	applied	\N	\N	\N	\N	33672	33672	33673
9949	9629	0	applied	\N	\N	\N	\N	33662	33662	33663
9949	9630	1	applied	\N	\N	\N	\N	33664	33664	33665
9949	9635	2	applied	\N	\N	\N	\N	33678	33678	33679
9949	9631	3	applied	\N	\N	\N	\N	33666	33666	33667
9949	9632	4	applied	\N	\N	\N	\N	33668	33668	33669
9949	9633	5	applied	\N	\N	\N	\N	33670	33670	33671
9949	9634	6	applied	\N	\N	\N	\N	33672	33672	33673
9949	9636	7	applied	\N	\N	\N	\N	33680	33680	33681
9965	9650	0	applied	\N	\N	\N	\N	33731	33731	33737
9965	9648	1	applied	\N	\N	\N	\N	33726	33726	33727
9965	9649	2	applied	\N	\N	\N	\N	33728	33728	33729
9965	9652	3	applied	\N	\N	\N	\N	33738	33738	33739
9965	9651	4	applied	\N	\N	\N	\N	33733	33733	33740
9965	9653	5	applied	\N	\N	\N	\N	33741	33741	33742
9965	9654	6	applied	\N	\N	\N	\N	33743	33743	33744
9967	9648	0	applied	\N	\N	\N	\N	33726	33726	33727
9967	9649	1	applied	\N	\N	\N	\N	33728	33728	33729
9967	9652	2	applied	\N	\N	\N	\N	33738	33738	33739
9967	9647	3	applied	\N	\N	\N	\N	33718	33718	33719
9967	9650	4	applied	\N	\N	\N	\N	33731	33731	33737
9967	9651	5	applied	\N	\N	\N	\N	33733	33733	33740
9967	9653	6	applied	\N	\N	\N	\N	33741	33741	33742
9967	9654	7	applied	\N	\N	\N	\N	33743	33743	33744
9972	9655	0	applied	\N	\N	\N	\N	33754	33754	33755
9972	9656	1	applied	\N	\N	\N	\N	33756	33756	33757
9972	9657	2	applied	\N	\N	\N	\N	33765	33765	33766
9972	9658	3	applied	\N	\N	\N	\N	33767	33767	33768
9974	9655	0	applied	\N	\N	\N	\N	33754	33754	33755
9974	9656	1	applied	\N	\N	\N	\N	33756	33756	33757
9974	9660	2	applied	\N	\N	\N	\N	33775	33775	33776
9982	9668	0	applied	\N	\N	\N	\N	33797	33797	33798
9982	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9982	9670	2	applied	\N	\N	\N	\N	33801	33801	33802
9982	9671	3	applied	\N	\N	\N	\N	33803	33803	33804
9982	9672	4	applied	\N	\N	\N	\N	33805	33805	33806
9982	9673	5	applied	\N	\N	\N	\N	33807	33807	33808
9986	9680	0	applied	\N	\N	\N	\N	33842	33842	33843
9986	9681	1	applied	\N	\N	\N	\N	33844	33844	33845
9986	9682	2	applied	\N	\N	\N	\N	33846	33846	33847
9986	9683	3	applied	\N	\N	\N	\N	33848	33848	33849
9986	9684	4	applied	\N	\N	\N	\N	33850	33850	33851
9986	9685	5	applied	\N	\N	\N	\N	33852	33852	33853
9988	9680	0	applied	\N	\N	\N	\N	33842	33842	33843
9988	9681	1	applied	\N	\N	\N	\N	33844	33844	33845
9988	9682	2	applied	\N	\N	\N	\N	33846	33846	33847
9988	9683	3	applied	\N	\N	\N	\N	33848	33848	33849
9988	9684	4	applied	\N	\N	\N	\N	33850	33850	33851
9988	9685	5	applied	\N	\N	\N	\N	33852	33852	33853
9990	9686	0	applied	\N	\N	\N	\N	33862	33862	33863
9990	9687	1	applied	\N	\N	\N	\N	33864	33864	33865
9993	9692	0	applied	\N	\N	\N	\N	33878	33878	33879
9993	9693	1	applied	\N	\N	\N	\N	33880	33880	33881
9993	9694	2	applied	\N	\N	\N	\N	33882	33882	33883
9993	9695	3	applied	\N	\N	\N	\N	33884	33884	33885
9993	9696	4	applied	\N	\N	\N	\N	33886	33886	33887
9993	9697	5	applied	\N	\N	\N	\N	33888	33888	1254
9996	9681	0	applied	\N	\N	\N	\N	33844	33844	33845
9996	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9996	9666	2	applied	\N	\N	\N	\N	33789	33789	33790
9996	9670	3	applied	\N	\N	\N	\N	33801	33801	33802
9996	9671	4	applied	\N	\N	\N	\N	33803	33803	33804
9996	9674	5	applied	\N	\N	\N	\N	33815	33815	33816
9996	9667	6	applied	\N	\N	\N	\N	33791	33791	33792
9996	9668	7	applied	\N	\N	\N	\N	33797	33797	33798
9996	9677	8	applied	\N	\N	\N	\N	33821	33821	33822
9996	9680	9	applied	\N	\N	\N	\N	33842	33842	33843
9996	9682	10	applied	\N	\N	\N	\N	33846	33846	33847
9996	9687	11	applied	\N	\N	\N	\N	33864	33864	33865
9996	9688	12	applied	\N	\N	\N	\N	33868	33868	33869
9996	9690	13	applied	\N	\N	\N	\N	33872	33872	33873
9996	9692	14	applied	\N	\N	\N	\N	33878	33878	33879
9996	9693	15	applied	\N	\N	\N	\N	33880	33880	33881
9996	9699	16	applied	\N	\N	\N	\N	33892	33892	33893
9996	9672	17	applied	\N	\N	\N	\N	33805	33805	33806
9969	9491	31	applied	\N	\N	\N	\N	33254	33254	33255
9969	9414	32	applied	\N	\N	\N	\N	33758	33758	33047
9969	9429	33	applied	\N	\N	\N	\N	33759	33759	33089
9969	9446	34	applied	\N	\N	\N	\N	33760	33760	33128
9969	9447	35	applied	\N	\N	\N	\N	33761	33761	33130
9969	9575	36	applied	\N	\N	\N	\N	33762	33762	33510
9969	9646	37	applied	\N	\N	\N	\N	33712	33712	33713
9969	9654	38	applied	\N	\N	\N	\N	33763	33763	33744
9969	9345	39	applied	\N	\N	\N	\N	32891	32891	31583
9969	9348	40	applied	\N	\N	\N	\N	32898	32898	31583
9969	9349	41	applied	\N	\N	\N	\N	32899	32899	31583
9969	9352	42	applied	\N	\N	\N	\N	32909	32909	31583
9969	9353	43	applied	\N	\N	\N	\N	32910	32910	31583
9969	9354	44	applied	\N	\N	\N	\N	32911	32911	31583
9969	9355	45	applied	\N	\N	\N	\N	32912	32912	31583
9969	9356	46	applied	\N	\N	\N	\N	32913	32913	31583
9969	9357	47	applied	\N	\N	\N	\N	32914	32914	31583
9969	9358	48	applied	\N	\N	\N	\N	32915	32915	31583
9969	9364	49	applied	\N	\N	\N	\N	32930	32930	32931
9969	9381	50	applied	\N	\N	\N	\N	32970	32970	32931
9969	9382	51	applied	\N	\N	\N	\N	32971	32971	32931
9969	9383	52	applied	\N	\N	\N	\N	32972	32972	32931
9969	9384	53	applied	\N	\N	\N	\N	32973	32973	32931
9969	9385	54	applied	\N	\N	\N	\N	32974	32974	32931
9969	9387	55	applied	\N	\N	\N	\N	32976	32976	32931
9969	9388	56	applied	\N	\N	\N	\N	32980	32980	32931
9969	9389	57	applied	\N	\N	\N	\N	32984	32984	32931
9969	9390	58	applied	\N	\N	\N	\N	32985	32985	32931
9969	9400	59	applied	\N	\N	\N	\N	32995	32995	32931
9969	9423	60	applied	\N	\N	\N	\N	33064	33064	12588
9973	9659	0	applied	\N	\N	\N	\N	33772	33772	33773
9976	9650	0	applied	\N	\N	\N	\N	33731	33731	33737
9976	9648	1	applied	\N	\N	\N	\N	33726	33726	33727
9976	9649	2	applied	\N	\N	\N	\N	33728	33728	33729
9976	9655	3	applied	\N	\N	\N	\N	33754	33754	33755
9976	9651	4	applied	\N	\N	\N	\N	33733	33733	33740
9976	9656	5	applied	\N	\N	\N	\N	33756	33756	33757
9976	9660	6	applied	\N	\N	\N	\N	33775	33775	33776
9978	9666	0	applied	\N	\N	\N	\N	33789	33789	33790
9978	9667	1	applied	\N	\N	\N	\N	33791	33791	33792
9981	9668	0	applied	\N	\N	\N	\N	33797	33797	33798
9981	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9981	9670	2	applied	\N	\N	\N	\N	33801	33801	33802
9981	9671	3	applied	\N	\N	\N	\N	33803	33803	33804
9981	9672	4	applied	\N	\N	\N	\N	33805	33805	33806
9981	9673	5	applied	\N	\N	\N	\N	33807	33807	33808
9992	9690	0	applied	\N	\N	\N	\N	33872	33872	33873
9992	9691	1	applied	\N	\N	\N	\N	33874	33874	33875
9995	9698	0	applied	\N	\N	\N	\N	33890	33890	33891
9995	9699	1	applied	\N	\N	\N	\N	33892	33892	33893
10000	9700	0	applied	\N	\N	\N	\N	33906	33906	33907
10000	9701	1	applied	\N	\N	1000000000	\N	33908	33908	33909
10002	9702	0	applied	\N	\N	\N	\N	33915	33915	33916
10002	9703	1	applied	\N	\N	\N	\N	33917	33917	33918
10005	9706	0	applied	\N	\N	\N	\N	33925	33925	33926
10005	9707	1	applied	\N	\N	\N	\N	33927	33927	33928
10005	9708	2	applied	\N	\N	\N	\N	33929	33929	33930
10005	9709	3	applied	\N	\N	\N	\N	33931	33931	33932
10005	9710	4	applied	\N	\N	\N	\N	33933	33933	33934
10007	9706	0	applied	\N	\N	\N	\N	33925	33925	33926
10007	9707	1	applied	\N	\N	\N	\N	33927	33927	33928
10007	9708	2	applied	\N	\N	\N	\N	33929	33929	33930
10007	9709	3	applied	\N	\N	\N	\N	33931	33931	33932
10007	9710	4	applied	\N	\N	\N	\N	33933	33933	33934
10007	9711	5	applied	\N	\N	\N	\N	33936	33936	33937
10007	9712	7	applied	\N	\N	\N	\N	33939	33939	33940
10007	9713	8	applied	\N	\N	\N	\N	33941	33941	33942
10007	9714	9	applied	\N	\N	\N	\N	33943	33943	33944
10007	9715	10	applied	\N	\N	\N	\N	33945	33945	33946
10007	9716	11	applied	\N	\N	\N	\N	33947	33947	33948
10007	9717	12	applied	\N	\N	\N	\N	33949	33949	33950
10007	9718	13	applied	\N	\N	\N	\N	33951	33951	33952
10007	9719	14	applied	\N	\N	\N	\N	33953	33953	33954
10007	9720	15	applied	\N	\N	\N	\N	33955	33955	33956
10007	9721	16	applied	\N	\N	\N	\N	33957	33957	33958
10010	9726	0	applied	\N	\N	\N	\N	33974	33974	33975
10010	9727	1	applied	\N	\N	\N	\N	33976	33976	33977
10010	9728	2	applied	\N	\N	\N	\N	33978	33978	33979
10012	9729	0	applied	\N	\N	\N	\N	33984	33984	33985
10012	9730	1	applied	\N	\N	\N	\N	33986	33986	33987
10012	9731	2	applied	\N	\N	\N	\N	33988	33988	33989
10012	9732	3	applied	\N	\N	\N	\N	33990	33990	33991
10015	9738	0	applied	\N	\N	\N	\N	34003	34003	34004
10015	9739	1	applied	\N	\N	\N	\N	34005	34005	34006
10015	9740	2	applied	\N	\N	\N	\N	34007	34007	34008
10015	9741	3	applied	\N	\N	\N	\N	34009	34009	34010
10015	9742	4	applied	\N	\N	\N	\N	34011	34011	34012
10018	9748	0	applied	\N	\N	\N	\N	34027	34027	34028
10018	9749	1	applied	\N	\N	\N	\N	34029	34029	34030
10020	9750	0	applied	\N	\N	\N	\N	34064	34064	34065
10020	9751	1	applied	\N	\N	\N	\N	34066	34066	34067
10020	9752	2	applied	\N	\N	\N	\N	34068	34068	34069
10020	9753	3	applied	\N	\N	1000000000	\N	34070	34070	34071
10025	9769	0	applied	\N	\N	\N	\N	34111	34111	34112
10025	9770	1	applied	\N	\N	\N	\N	34113	34113	34114
10025	9771	2	applied	\N	\N	\N	\N	34115	34115	34116
10025	9772	3	applied	\N	\N	\N	\N	34117	34117	34118
10025	9773	4	applied	\N	\N	\N	\N	34119	34119	34120
10028	9781	0	applied	\N	\N	\N	\N	34139	34139	34140
10028	9782	1	applied	\N	\N	\N	\N	34141	34141	34142
10028	9783	2	applied	\N	\N	\N	\N	34143	34143	34144
10028	9784	3	applied	\N	\N	\N	\N	34145	34145	34146
10034	9796	0	applied	\N	\N	\N	\N	34180	34180	34181
10034	9797	1	applied	\N	\N	\N	\N	34182	34182	34183
10034	9798	2	applied	\N	\N	\N	\N	34184	34184	34185
10034	9799	3	applied	\N	\N	\N	\N	34186	34186	34187
10034	9800	4	applied	\N	\N	\N	\N	34188	34188	34189
10035	9796	0	applied	\N	\N	\N	\N	34180	34180	34181
10035	9797	1	applied	\N	\N	\N	\N	34182	34182	34183
10035	9798	2	applied	\N	\N	\N	\N	34184	34184	34185
10035	9799	3	applied	\N	\N	\N	\N	34186	34186	34187
10035	9800	4	applied	\N	\N	\N	\N	34188	34188	34189
10036	9801	0	applied	\N	\N	\N	\N	34194	34194	34195
10036	9802	1	applied	\N	\N	\N	\N	34196	34196	34197
10041	9810	0	applied	\N	\N	\N	\N	34220	34220	34221
10041	9811	1	applied	\N	\N	\N	\N	34222	34222	34223
10048	9812	0	applied	\N	\N	\N	\N	34254	34254	34255
10048	9813	1	applied	\N	\N	\N	\N	34256	34256	34257
10052	9816	0	applied	\N	\N	\N	\N	34270	34270	34271
9983	9668	0	applied	\N	\N	\N	\N	33797	33797	33798
9983	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9983	9670	2	applied	\N	\N	\N	\N	33801	33801	33802
9983	9671	3	applied	\N	\N	\N	\N	33803	33803	33804
9983	9672	4	applied	\N	\N	\N	\N	33805	33805	33806
9983	9673	5	applied	\N	\N	\N	\N	33807	33807	33808
9985	9652	0	applied	\N	\N	\N	\N	33738	33738	33739
9985	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
9985	9655	2	applied	\N	\N	\N	\N	33754	33754	33755
9985	9656	3	applied	\N	\N	\N	\N	33756	33756	33757
9985	9660	4	applied	\N	\N	\N	\N	33775	33775	33776
9985	9653	5	applied	\N	\N	\N	\N	33741	33741	33827
9985	9657	6	applied	\N	\N	\N	\N	33765	33765	33766
9985	9662	7	applied	\N	\N	\N	\N	33781	33781	33782
9985	9663	8	applied	\N	\N	\N	\N	33783	33783	33784
9985	9667	9	applied	\N	\N	\N	\N	33791	33791	33792
9985	9668	10	applied	\N	\N	\N	\N	33797	33797	33798
9985	9658	11	applied	\N	\N	\N	\N	33767	33767	33828
9985	9672	12	applied	\N	\N	\N	\N	33805	33805	33806
9985	9676	13	applied	\N	\N	\N	\N	33819	33819	33820
9985	9678	14	applied	\N	\N	\N	\N	33823	33823	33824
9985	9659	15	applied	\N	\N	\N	\N	33772	33772	33829
9985	9661	16	applied	\N	\N	\N	\N	33779	33779	33830
9985	9664	17	applied	\N	\N	\N	\N	33785	33785	33831
9985	9666	18	applied	\N	\N	\N	\N	33789	33789	33832
9985	9670	19	applied	\N	\N	\N	\N	33801	33801	33833
9985	9671	20	applied	\N	\N	\N	\N	33803	33803	33834
9985	9674	21	applied	\N	\N	\N	\N	33815	33815	33835
9985	9677	22	applied	\N	\N	\N	\N	33821	33821	33836
9985	9673	23	applied	\N	\N	\N	\N	33807	33807	33808
9985	9675	24	applied	\N	\N	\N	\N	33817	33817	33818
9985	9679	25	applied	\N	\N	\N	\N	33837	33837	33838
9985	9654	26	applied	\N	\N	\N	\N	33763	33763	33744
9985	9665	27	applied	\N	\N	\N	\N	33839	33839	33788
9989	9680	0	applied	\N	\N	\N	\N	33842	33842	33843
9989	9681	1	applied	\N	\N	\N	\N	33844	33844	33845
9989	9682	2	applied	\N	\N	\N	\N	33846	33846	33847
9989	9683	3	applied	\N	\N	\N	\N	33848	33848	33849
9989	9684	4	applied	\N	\N	\N	\N	33850	33850	33851
9989	9685	5	applied	\N	\N	\N	\N	33852	33852	33853
9997	9698	0	applied	\N	\N	\N	\N	33890	33890	33891
9997	9699	1	applied	\N	\N	\N	\N	33892	33892	33893
9999	9700	0	applied	\N	\N	\N	\N	33906	33906	33907
9999	9701	1	applied	\N	\N	1000000000	\N	33908	33908	33909
10004	9704	0	applied	\N	\N	\N	\N	33919	33919	33920
10004	9705	1	applied	\N	\N	\N	\N	33921	33921	33922
10009	9724	0	applied	\N	\N	\N	\N	33970	33970	33971
10009	9725	1	applied	\N	\N	\N	\N	33972	33972	33973
10014	9733	0	applied	\N	\N	\N	\N	33995	33995	33996
10014	9734	1	applied	\N	\N	\N	\N	33997	33997	33998
10014	9735	2	applied	\N	\N	\N	\N	33999	33999	12588
10014	9736	3	applied	\N	\N	\N	\N	34000	34000	12588
10014	9737	4	applied	\N	\N	\N	\N	34001	34001	33908
10017	9748	0	applied	\N	\N	\N	\N	34027	34027	34028
10017	9749	1	applied	\N	\N	\N	\N	34029	34029	34030
10019	9680	0	applied	\N	\N	\N	\N	33842	33842	34035
10019	9682	1	applied	\N	\N	\N	\N	33846	33846	34036
10019	9683	2	applied	\N	\N	\N	\N	33848	33848	33849
10019	9684	3	applied	\N	\N	\N	\N	33850	33850	33851
10019	9687	4	applied	\N	\N	\N	\N	33864	33864	34037
10019	9688	5	applied	\N	\N	\N	\N	33868	33868	34038
10019	9690	6	applied	\N	\N	\N	\N	33872	33872	34039
10019	9692	7	applied	\N	\N	\N	\N	33878	33878	34040
10019	9693	8	applied	\N	\N	\N	\N	33880	33880	34041
10019	9699	9	applied	\N	\N	\N	\N	33892	33892	34042
10019	9685	10	applied	\N	\N	\N	\N	33852	33852	33853
10019	9686	11	applied	\N	\N	\N	\N	33862	33862	33863
10019	9700	12	applied	\N	\N	\N	\N	33906	33906	34043
10019	9702	13	applied	\N	\N	\N	\N	33915	33915	34044
10019	9705	14	applied	\N	\N	\N	\N	33921	33921	34045
10019	9707	15	applied	\N	\N	\N	\N	33927	33927	34046
10019	9708	16	applied	\N	\N	\N	\N	33929	33929	34047
10019	9709	17	applied	\N	\N	\N	\N	33931	33931	34048
10019	9722	18	applied	\N	\N	\N	\N	33964	33964	34049
10019	9724	19	applied	\N	\N	\N	\N	33970	33970	34050
10019	9727	20	applied	\N	\N	\N	\N	33976	33976	34051
10019	9728	21	applied	\N	\N	\N	\N	33978	33978	34052
10019	9732	22	applied	\N	\N	\N	\N	33990	33990	34053
10019	9733	23	applied	\N	\N	\N	\N	33995	33995	34054
10019	9738	24	applied	\N	\N	\N	\N	34003	34003	34055
10019	9740	25	applied	\N	\N	\N	\N	34007	34007	34056
10019	9744	26	applied	\N	\N	\N	\N	34017	34017	34057
10019	9746	27	applied	\N	\N	\N	\N	34021	34021	34058
10019	9748	28	applied	\N	\N	\N	\N	34027	34027	34059
10019	9689	29	applied	\N	\N	\N	\N	33870	33870	33871
10019	9691	30	applied	\N	\N	\N	\N	33874	33874	33875
10019	9695	31	applied	\N	\N	\N	\N	33884	33884	33885
10019	9696	32	applied	\N	\N	\N	\N	33886	33886	33887
10019	9698	33	applied	\N	\N	\N	\N	33890	33890	33891
10019	9703	34	applied	\N	\N	\N	\N	33917	33917	33918
10019	9704	35	applied	\N	\N	\N	\N	33919	33919	33920
10019	9706	36	applied	\N	\N	\N	\N	33925	33925	33926
10019	9710	37	applied	\N	\N	\N	\N	33933	33933	33934
10019	9711	38	applied	\N	\N	\N	\N	33936	33936	33937
10019	9723	39	applied	\N	\N	\N	\N	33966	33966	33967
10019	9725	40	applied	\N	\N	\N	\N	33972	33972	33973
10019	9726	41	applied	\N	\N	\N	\N	33974	33974	33975
10019	9729	42	applied	\N	\N	\N	\N	33984	33984	33985
10019	9734	43	applied	\N	\N	\N	\N	33997	33997	33998
10019	9741	44	applied	\N	\N	\N	\N	34009	34009	34010
10019	9742	45	applied	\N	\N	\N	\N	34011	34011	34012
10019	9743	46	applied	\N	\N	\N	\N	34015	34015	34016
10019	9745	47	applied	\N	\N	\N	\N	34019	34019	34020
10019	9749	48	applied	\N	\N	\N	\N	34029	34029	34030
10019	9697	49	applied	\N	\N	\N	\N	33888	33888	1254
10019	9712	50	applied	\N	\N	\N	\N	34060	34060	33940
10019	9747	51	applied	\N	\N	\N	\N	34061	34061	34024
10019	9701	52	applied	\N	\N	1000000000	\N	33908	33908	33909
10022	9754	0	applied	\N	\N	\N	\N	34076	34076	34077
10022	9755	1	applied	\N	\N	\N	\N	34078	34078	34079
10022	9756	2	applied	\N	\N	\N	\N	34080	34080	34081
10022	9757	3	applied	\N	\N	\N	\N	34082	34082	34083
10022	9758	4	applied	\N	\N	\N	\N	34084	34084	34085
10022	9759	5	applied	\N	\N	\N	\N	34086	34086	34087
10022	9760	6	applied	\N	\N	\N	\N	34088	34088	34089
10022	9761	7	applied	\N	\N	\N	\N	34090	34090	34091
10022	9762	8	applied	\N	\N	\N	\N	34092	34092	34093
10022	9763	9	applied	\N	\N	\N	\N	34094	34094	34095
10022	9764	10	applied	\N	\N	\N	\N	34096	34096	34097
9996	9676	18	applied	\N	\N	\N	\N	33819	33819	33820
9996	9694	19	applied	\N	\N	\N	\N	33882	33882	33883
9996	9678	20	applied	\N	\N	\N	\N	33823	33823	33824
9996	9685	21	applied	\N	\N	\N	\N	33852	33852	33853
9996	9686	22	applied	\N	\N	\N	\N	33862	33862	33863
9996	9673	23	applied	\N	\N	\N	\N	33807	33807	33808
9996	9675	24	applied	\N	\N	\N	\N	33817	33817	33818
9996	9683	25	applied	\N	\N	\N	\N	33848	33848	33849
9996	9684	26	applied	\N	\N	\N	\N	33850	33850	33851
9996	9689	27	applied	\N	\N	\N	\N	33870	33870	33871
9996	9691	28	applied	\N	\N	\N	\N	33874	33874	33875
9996	9695	29	applied	\N	\N	\N	\N	33884	33884	33885
9996	9696	30	applied	\N	\N	\N	\N	33886	33886	33887
9996	9698	31	applied	\N	\N	\N	\N	33890	33890	33891
9996	9697	32	applied	\N	\N	\N	\N	33888	33888	1254
10001	9700	0	applied	\N	\N	\N	\N	33906	33906	33907
10001	9701	1	applied	\N	\N	1000000000	\N	33908	33908	33909
10013	9729	0	applied	\N	\N	\N	\N	33984	33984	33985
10013	9730	1	applied	\N	\N	\N	\N	33986	33986	33987
10013	9731	2	applied	\N	\N	\N	\N	33988	33988	33989
10013	9732	3	applied	\N	\N	\N	\N	33990	33990	33991
10016	9743	0	applied	\N	\N	\N	\N	34015	34015	34016
10016	9744	1	applied	\N	\N	\N	\N	34017	34017	34018
10016	9745	2	applied	\N	\N	\N	\N	34019	34019	34020
10016	9746	3	applied	\N	\N	\N	\N	34021	34021	34022
10016	9747	4	applied	\N	\N	\N	\N	34023	34023	34024
10023	9754	0	applied	\N	\N	\N	\N	34076	34076	34077
10023	9755	1	applied	\N	\N	\N	\N	34078	34078	34079
10023	9756	2	applied	\N	\N	\N	\N	34080	34080	34081
10023	9757	3	applied	\N	\N	\N	\N	34082	34082	34083
10023	9758	4	applied	\N	\N	\N	\N	34084	34084	34085
10023	9759	5	applied	\N	\N	\N	\N	34086	34086	34087
10023	9760	6	applied	\N	\N	\N	\N	34088	34088	34089
10023	9761	7	applied	\N	\N	\N	\N	34090	34090	34091
10023	9762	8	applied	\N	\N	\N	\N	34092	34092	34093
10023	9763	9	applied	\N	\N	\N	\N	34094	34094	34095
10023	9764	10	applied	\N	\N	\N	\N	34096	34096	34097
10023	9765	11	applied	\N	\N	\N	\N	34098	34098	34099
10026	9774	0	applied	\N	\N	\N	\N	34122	34122	34123
10026	9775	1	applied	\N	\N	\N	\N	34124	34124	34125
10026	9776	2	applied	\N	\N	\N	\N	34126	34126	34127
10026	9777	3	applied	\N	\N	\N	\N	34128	34128	34129
10029	9785	0	applied	\N	\N	\N	\N	34149	34149	34150
10029	9786	1	applied	\N	\N	\N	\N	34151	34151	34152
10029	9787	2	applied	\N	\N	\N	\N	34153	34153	34154
10029	9788	3	applied	\N	\N	\N	\N	34155	34155	34156
10032	9792	0	applied	\N	\N	\N	\N	34170	34170	34171
10032	9793	1	applied	\N	\N	\N	\N	34172	34172	34173
10032	9794	2	applied	\N	\N	\N	\N	34174	34174	34175
10032	9795	3	applied	\N	\N	\N	\N	34176	34176	34177
10032	9791	4	applied	\N	\N	\N	\N	34178	34178	34163
10037	9801	0	applied	\N	\N	\N	\N	34194	34194	34195
10037	9802	1	applied	\N	\N	\N	\N	34196	34196	34197
10039	9803	0	applied	\N	\N	\N	\N	34202	34202	34203
10039	9804	1	applied	\N	\N	\N	\N	34204	34204	34205
10039	9805	2	applied	\N	\N	\N	\N	34206	34206	34207
10042	9810	0	applied	\N	\N	\N	\N	34220	34220	34221
10042	9811	1	applied	\N	\N	\N	\N	34222	34222	34223
10044	9810	0	applied	\N	\N	\N	\N	34220	34220	34221
10044	9811	1	applied	\N	\N	\N	\N	34222	34222	34223
10046	9812	0	applied	\N	\N	\N	\N	34254	34254	34255
10046	9813	1	applied	\N	\N	\N	\N	34256	34256	34257
10050	9814	0	applied	\N	\N	\N	\N	34262	34262	34263
10050	9815	1	applied	\N	\N	\N	\N	34264	34264	34265
10055	9819	0	applied	\N	\N	\N	\N	34282	34282	34283
10055	9820	1	applied	\N	\N	\N	\N	34284	34284	34285
10055	9821	2	applied	\N	\N	\N	\N	34286	34286	34287
10055	9822	3	applied	\N	\N	\N	\N	34288	34288	34289
10061	9826	0	applied	\N	\N	\N	\N	34300	34300	34301
10061	9828	1	applied	\N	\N	\N	\N	34307	34307	34308
10061	9829	2	applied	\N	\N	\N	\N	34309	34309	34310
10061	9830	3	applied	\N	\N	\N	\N	34311	34311	34312
10061	9831	4	applied	\N	\N	\N	\N	34313	34313	34314
10061	9832	5	applied	\N	\N	\N	\N	34315	34315	34316
10061	9833	6	applied	\N	\N	1000000000	\N	34317	34317	34318
10061	9834	7	applied	\N	\N	1000000000	\N	34319	34319	34320
10061	9835	8	applied	\N	\N	\N	\N	34321	34321	34322
10061	9836	9	applied	\N	\N	1000000000	\N	34323	34323	34324
10061	9837	10	applied	\N	\N	1000000000	\N	34325	34325	34326
10061	9838	11	applied	\N	\N	\N	\N	34327	34327	34328
10061	9839	12	applied	\N	\N	\N	\N	34329	34329	34330
10061	9840	13	applied	\N	\N	\N	\N	34331	34331	34332
10063	9841	0	applied	\N	\N	\N	\N	34339	34339	34340
10063	9842	1	applied	\N	\N	\N	\N	34341	34341	34342
10063	9843	2	applied	\N	\N	\N	\N	34343	34343	34344
10063	9844	3	applied	\N	\N	\N	\N	34345	34345	34346
10065	9845	0	applied	\N	\N	\N	\N	34350	34350	34351
10065	9846	1	applied	\N	\N	\N	\N	34352	34352	34353
10065	9847	2	applied	\N	\N	\N	\N	34354	34354	34355
10065	9848	3	applied	\N	\N	\N	\N	34356	34356	34357
10065	9849	4	applied	\N	\N	\N	\N	34358	34358	34359
10065	9850	5	applied	\N	\N	\N	\N	34360	34360	34361
10065	9851	6	applied	\N	\N	\N	\N	34362	34362	34363
10065	9852	7	applied	\N	\N	\N	\N	34364	34364	34365
10065	9853	8	applied	\N	\N	\N	\N	34366	34366	34367
10065	9854	9	applied	\N	\N	\N	\N	34368	34368	34369
10067	9841	0	applied	\N	\N	\N	\N	34339	34339	34340
10067	9855	1	applied	\N	\N	\N	\N	34374	34374	34375
10067	9842	2	applied	\N	\N	\N	\N	34341	34341	34342
10067	9843	3	applied	\N	\N	\N	\N	34343	34343	34344
10067	9846	4	applied	\N	\N	\N	\N	34352	34352	34353
10067	9847	5	applied	\N	\N	\N	\N	34354	34354	34355
10067	9844	6	applied	\N	\N	\N	\N	34345	34345	34346
10067	9845	7	applied	\N	\N	\N	\N	34350	34350	34351
10067	9856	8	applied	\N	\N	\N	\N	34376	34376	34377
10067	9848	9	applied	\N	\N	\N	\N	34356	34356	34357
10067	9849	10	applied	\N	\N	\N	\N	34358	34358	34359
10067	9850	11	applied	\N	\N	\N	\N	34360	34360	34361
10067	9851	12	applied	\N	\N	\N	\N	34362	34362	34363
10067	9852	13	applied	\N	\N	\N	\N	34364	34364	34365
10067	9853	14	applied	\N	\N	\N	\N	34366	34366	34367
10067	9854	15	applied	\N	\N	\N	\N	34368	34368	34369
10067	9857	16	applied	\N	\N	\N	\N	34378	34378	34379
10069	9855	0	applied	\N	\N	\N	\N	34374	34374	34375
10069	9856	1	applied	\N	\N	\N	\N	34376	34376	34377
10069	9858	2	applied	\N	\N	\N	\N	34382	34382	25661
10076	9896	0	applied	\N	\N	\N	\N	34479	34479	34379
10076	9893	1	applied	\N	\N	\N	\N	34471	34471	34472
10076	9897	2	applied	\N	\N	\N	\N	34480	34480	34481
9998	9404	14	applied	\N	\N	\N	\N	33026	33026	33027
9998	9405	15	applied	\N	\N	\N	\N	33028	33028	33029
9998	9416	16	applied	\N	\N	\N	\N	33050	33050	33051
9998	9639	17	applied	\N	\N	\N	\N	33690	33690	33691
9998	9473	18	applied	\N	\N	\N	\N	33209	33209	33210
9998	9174	19	applied	\N	\N	\N	\N	32447	32447	32448
9998	9276	20	applied	\N	\N	1000000000	\N	32715	32715	32716
9998	9293	21	applied	\N	\N	\N	\N	32998	32998	32762
9998	9294	23	applied	\N	\N	\N	\N	32999	32999	32764
9998	9189	24	applied	\N	\N	\N	\N	32483	32483	32484
9998	9111	25	applied	\N	\N	\N	\N	32254	32254	32255
9998	9112	26	applied	\N	\N	\N	\N	32256	32256	32257
9998	9331	27	applied	\N	\N	\N	\N	33000	33000	32855
9998	9332	28	applied	\N	\N	\N	\N	33001	33001	32857
9998	9234	29	applied	\N	\N	\N	\N	32609	32609	32610
9998	9607	30	applied	\N	\N	\N	\N	33602	33602	33603
9998	9479	31	applied	\N	\N	\N	\N	33226	33226	33227
9998	9360	32	applied	\N	\N	\N	\N	33068	33068	32923
9998	9361	33	applied	\N	\N	\N	\N	33069	33069	32925
9998	9237	34	applied	\N	\N	\N	\N	32617	32617	32618
9998	9191	35	applied	\N	\N	\N	\N	32487	32487	32488
9998	9192	36	applied	\N	\N	\N	\N	32489	32489	32490
9998	9193	37	applied	\N	\N	\N	\N	32491	32491	32492
9998	9669	38	applied	\N	\N	\N	\N	33799	33799	33800
9998	9131	39	applied	\N	\N	\N	\N	32311	32311	32312
9998	9133	40	applied	\N	\N	\N	\N	32321	32321	32322
9998	9145	41	applied	\N	\N	\N	\N	32358	32358	32359
9998	9655	42	applied	\N	\N	\N	\N	33901	33901	33755
9998	9135	43	applied	\N	\N	\N	\N	32325	32325	32326
9998	9118	44	applied	\N	\N	\N	\N	32274	32274	32275
9998	9121	45	applied	\N	\N	\N	\N	32283	32283	32284
9998	9138	46	applied	\N	\N	\N	\N	32338	32338	32339
9998	9173	47	applied	\N	\N	\N	\N	32446	32446	32350
9998	9197	48	applied	\N	\N	\N	\N	32503	32503	32504
9998	9656	49	applied	\N	\N	\N	\N	33902	33902	33757
9998	9660	50	applied	\N	\N	\N	\N	33903	33903	33776
9998	9295	51	applied	\N	\N	\N	\N	32766	32766	32767
9998	9115	52	applied	\N	\N	\N	\N	32265	32265	32266
9998	9178	53	applied	\N	\N	\N	\N	32455	32455	32456
9998	9179	54	applied	\N	\N	\N	\N	32457	32457	32458
9998	9180	55	applied	\N	\N	\N	\N	32459	32459	32460
9998	9609	56	applied	\N	\N	\N	\N	33606	33606	33607
9998	9610	57	applied	\N	\N	\N	\N	33608	33608	33609
9998	9238	58	applied	\N	\N	\N	\N	32619	32619	32620
9998	9239	59	applied	\N	\N	1000000000	\N	32621	32621	32622
9998	9612	60	applied	\N	\N	\N	\N	33612	33612	33613
9998	9125	61	applied	\N	\N	\N	\N	32293	32293	32294
9998	9128	62	applied	\N	\N	\N	\N	32300	32300	32301
9998	9130	63	applied	\N	\N	\N	\N	32309	32309	32310
9998	9134	64	applied	\N	\N	\N	\N	32323	32323	32324
9998	9137	65	applied	\N	\N	\N	\N	32336	32336	32337
9998	9139	66	applied	\N	\N	\N	\N	32340	32340	32341
9998	9144	67	applied	\N	\N	\N	\N	32356	32356	32357
9998	9150	68	applied	\N	\N	\N	\N	32389	32389	32390
9998	9123	69	applied	\N	\N	\N	\N	32287	32287	32288
9998	9126	70	applied	\N	\N	\N	\N	32295	32295	32296
9998	9127	71	applied	\N	\N	\N	\N	32298	32298	32299
9998	9129	72	applied	\N	\N	\N	\N	32307	32307	32308
9998	9132	73	applied	\N	\N	\N	\N	32316	32316	32317
9998	9136	74	applied	\N	\N	\N	\N	32327	32327	32328
9998	9200	75	applied	\N	\N	\N	\N	32509	32509	32510
9998	9140	76	applied	\N	\N	\N	\N	32342	32342	32343
9998	9141	77	applied	\N	\N	\N	\N	32344	32344	32345
9998	9146	78	applied	\N	\N	\N	\N	32360	32360	32361
9998	9362	79	applied	\N	\N	\N	\N	33071	33071	32927
9998	9363	80	applied	\N	\N	\N	\N	33072	33072	32929
9998	9119	81	applied	\N	\N	\N	\N	32276	32276	32277
9998	9120	82	applied	\N	\N	\N	\N	32278	32278	32279
9998	9122	83	applied	\N	\N	\N	\N	32285	32285	32286
9998	9149	84	applied	\N	\N	\N	\N	32391	32391	32376
9998	9164	85	applied	\N	\N	\N	\N	32422	32422	32423
9998	9165	86	applied	\N	\N	\N	\N	32424	32424	32425
9998	9166	87	applied	\N	\N	\N	\N	32426	32426	32427
9998	9172	88	applied	\N	\N	\N	\N	32444	32444	32445
9998	9151	89	applied	\N	\N	\N	\N	32392	32392	32393
9998	9124	90	applied	\N	\N	\N	\N	32289	32289	32290
9998	9613	91	applied	\N	\N	\N	\N	33614	33614	33615
9998	9297	92	applied	\N	\N	\N	\N	33002	33002	32771
9998	9298	93	applied	\N	\N	\N	\N	33003	33003	32773
9998	9152	94	applied	\N	\N	\N	\N	32394	32394	32395
9998	9153	95	applied	\N	\N	\N	\N	32396	32396	32397
9998	9161	96	applied	\N	\N	\N	\N	32416	32416	32417
9998	9162	97	applied	\N	\N	\N	\N	32418	32418	32419
9998	9163	98	applied	\N	\N	\N	\N	32420	32420	32421
9998	9170	99	applied	\N	\N	\N	\N	32439	32439	32440
9998	9175	100	applied	\N	\N	\N	\N	32449	32449	32450
9998	9176	101	applied	\N	\N	\N	\N	32451	32451	32452
9998	9177	102	applied	\N	\N	\N	\N	32453	32453	32454
9998	9187	103	applied	\N	\N	\N	\N	32478	32478	32479
9998	9188	104	applied	\N	\N	\N	\N	32481	32481	32482
9998	9198	105	applied	\N	\N	\N	\N	32505	32505	32506
9998	9199	106	applied	\N	\N	\N	\N	32507	32507	32508
9998	9202	107	applied	\N	\N	\N	\N	32515	32515	32516
9998	9113	108	applied	\N	\N	\N	\N	32259	32259	32260
9998	9114	109	applied	\N	\N	\N	\N	32261	32261	32262
9998	9116	110	applied	\N	\N	\N	\N	32267	32267	32268
9998	9117	111	applied	\N	\N	\N	\N	32269	32269	32270
9998	9211	112	applied	\N	\N	\N	\N	32538	32538	32539
9998	9215	113	applied	\N	\N	\N	\N	32553	32553	32554
9998	9216	114	applied	\N	\N	\N	\N	32555	32555	32556
9998	9217	115	applied	\N	\N	\N	\N	32557	32557	32558
9998	9232	116	applied	\N	\N	1000000000	\N	32603	32603	32604
9998	9301	117	applied	\N	\N	\N	\N	33008	33008	32781
9998	9673	118	applied	\N	\N	\N	\N	33807	33807	33808
9998	9675	119	applied	\N	\N	\N	\N	33817	33817	33818
9998	9683	120	applied	\N	\N	\N	\N	33848	33848	33849
9998	9684	121	applied	\N	\N	\N	\N	33850	33850	33851
9998	9302	122	applied	\N	\N	\N	\N	33009	33009	32783
9998	9303	123	applied	\N	\N	\N	\N	33010	33010	32785
9998	9304	124	applied	\N	\N	\N	\N	33011	33011	32787
9998	9305	125	applied	\N	\N	\N	\N	33012	33012	32789
10003	9704	0	applied	\N	\N	\N	\N	33919	33919	33920
10003	9705	1	applied	\N	\N	\N	\N	33921	33921	33922
10006	9706	0	applied	\N	\N	\N	\N	33925	33925	33926
10006	9707	1	applied	\N	\N	\N	\N	33927	33927	33928
10006	9708	2	applied	\N	\N	\N	\N	33929	33929	33930
10006	9709	3	applied	\N	\N	\N	\N	33931	33931	33932
10006	9710	4	applied	\N	\N	\N	\N	33933	33933	33934
10006	9711	5	applied	\N	\N	\N	\N	33936	33936	33937
10006	9712	7	applied	\N	\N	\N	\N	33939	33939	33940
10006	9713	8	applied	\N	\N	\N	\N	33941	33941	33942
10006	9714	9	applied	\N	\N	\N	\N	33943	33943	33944
10006	9715	10	applied	\N	\N	\N	\N	33945	33945	33946
10006	9716	11	applied	\N	\N	\N	\N	33947	33947	33948
10006	9717	12	applied	\N	\N	\N	\N	33949	33949	33950
10006	9718	13	applied	\N	\N	\N	\N	33951	33951	33952
10006	9719	14	applied	\N	\N	\N	\N	33953	33953	33954
10006	9720	15	applied	\N	\N	\N	\N	33955	33955	33956
10006	9721	16	applied	\N	\N	\N	\N	33957	33957	33958
10008	9722	0	applied	\N	\N	\N	\N	33964	33964	33965
10008	9723	1	applied	\N	\N	\N	\N	33966	33966	33967
10011	9726	0	applied	\N	\N	\N	\N	33974	33974	33975
10011	9727	1	applied	\N	\N	\N	\N	33976	33976	33977
10011	9728	2	applied	\N	\N	\N	\N	33978	33978	33979
10021	9750	0	applied	\N	\N	\N	\N	34064	34064	34065
10021	9751	1	applied	\N	\N	\N	\N	34066	34066	34067
10021	9752	2	applied	\N	\N	\N	\N	34068	34068	34069
10021	9753	3	applied	\N	\N	1000000000	\N	34070	34070	34071
10024	9766	0	applied	\N	\N	\N	\N	34104	34104	34105
10024	9767	1	applied	\N	\N	\N	\N	34106	34106	34107
10024	9768	2	applied	\N	\N	\N	\N	34108	34108	34109
10030	9789	0	applied	\N	\N	\N	\N	34158	34158	34159
10030	9790	1	applied	\N	\N	\N	\N	34160	34160	34161
10040	9806	0	applied	\N	\N	\N	\N	34208	34208	34209
10040	9807	1	applied	\N	\N	\N	\N	34210	34210	34211
10040	9808	2	applied	\N	\N	\N	\N	34212	34212	34213
10040	9809	3	applied	\N	\N	\N	\N	34216	34216	34217
10043	9810	0	applied	\N	\N	\N	\N	34220	34220	34221
10043	9811	1	applied	\N	\N	\N	\N	34222	34222	34223
10047	9812	0	applied	\N	\N	\N	\N	34254	34254	34255
10047	9813	1	applied	\N	\N	\N	\N	34256	34256	34257
10049	9812	0	applied	\N	\N	\N	\N	34254	34254	34255
10049	9813	1	applied	\N	\N	\N	\N	34256	34256	34257
10053	9818	0	applied	\N	\N	\N	\N	34276	34276	34277
10056	9823	0	applied	\N	\N	\N	\N	34291	34291	34292
10056	9824	1	applied	\N	\N	\N	\N	34293	34293	34294
10056	9825	2	applied	\N	\N	\N	\N	34295	34295	34296
10058	9826	0	applied	\N	\N	\N	\N	34300	34300	34301
10058	9827	1	applied	\N	\N	\N	\N	34302	34302	34303
10070	9767	0	applied	\N	\N	\N	\N	34106	34106	34107
10070	9842	1	applied	\N	\N	\N	\N	34341	34341	34342
10070	9843	2	applied	\N	\N	\N	\N	34343	34343	34344
10070	9831	3	applied	\N	\N	\N	\N	34313	34313	34386
10070	9750	4	applied	\N	\N	\N	\N	34064	34064	34387
10070	9754	5	applied	\N	\N	\N	\N	34076	34076	34388
10070	9755	6	applied	\N	\N	\N	\N	34078	34078	34389
10070	9756	7	applied	\N	\N	\N	\N	34080	34080	34390
10070	9766	8	applied	\N	\N	\N	\N	34104	34104	34391
10070	9832	9	applied	\N	\N	\N	\N	34315	34315	34392
10077	9900	0	applied	\N	\N	\N	\N	34487	34487	34488
10077	9901	1	applied	\N	\N	\N	\N	34489	34489	34490
10077	9902	2	applied	\N	\N	\N	\N	34491	34491	34492
10077	9903	3	applied	\N	\N	\N	\N	34493	34493	34494
10077	9904	4	applied	\N	\N	\N	\N	34495	34495	34496
10079	9905	0	applied	\N	\N	\N	\N	34499	34499	34500
10079	9906	1	applied	\N	\N	\N	\N	34501	34501	34502
10079	9907	2	applied	\N	\N	\N	\N	34505	34505	34506
10079	9908	3	applied	\N	\N	\N	\N	34507	34507	34508
10079	9909	4	applied	\N	\N	\N	\N	34509	34509	34510
10079	9910	5	applied	\N	\N	\N	\N	34511	34511	34512
10085	9920	0	applied	\N	\N	\N	\N	34539	34539	34540
10085	9921	1	applied	\N	\N	\N	\N	34541	34541	34542
10085	9922	2	applied	\N	\N	\N	\N	34543	34543	34544
10085	9923	3	applied	\N	\N	\N	\N	34545	34545	34546
10085	9924	4	applied	\N	\N	\N	\N	34547	34547	34548
10085	9925	5	applied	\N	\N	\N	\N	34549	34549	34550
10085	9926	6	applied	\N	\N	\N	\N	34551	34551	34552
10085	9927	7	applied	\N	\N	\N	\N	34553	34553	34554
10085	9928	8	applied	\N	\N	\N	\N	34555	34555	34556
10085	9929	9	applied	\N	\N	\N	\N	34557	34557	34558
10085	9930	10	applied	\N	\N	\N	\N	34559	34559	34560
10085	9931	11	applied	\N	\N	\N	\N	34561	34561	34562
10085	9932	12	applied	\N	\N	\N	\N	34563	34563	34564
10085	9933	13	applied	\N	\N	\N	\N	34565	34565	34566
10085	9934	14	applied	\N	\N	\N	\N	34567	34567	34568
10085	9935	15	applied	\N	\N	\N	\N	34569	34569	34570
10085	9936	16	applied	\N	\N	\N	\N	34571	34571	34572
10085	9937	17	applied	\N	\N	\N	\N	34573	34573	34574
10085	9938	18	applied	\N	\N	\N	\N	34575	34575	34576
10085	9939	19	applied	\N	\N	\N	\N	34577	34577	34578
10085	9940	20	applied	\N	\N	\N	\N	34579	34579	34580
10085	9941	21	applied	\N	\N	\N	\N	34581	34581	34582
10085	9942	22	applied	\N	\N	\N	\N	34583	34583	34584
10085	9943	23	applied	\N	\N	\N	\N	34585	34585	34586
10085	9944	24	applied	\N	\N	1000000000	\N	34587	34587	34588
10085	9945	25	applied	\N	\N	\N	\N	34589	34589	34590
10092	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10092	9993	1	applied	\N	\N	\N	\N	34700	34700	34701
10092	9994	2	applied	\N	\N	\N	\N	34702	34702	34703
10092	9995	3	applied	\N	\N	\N	\N	34704	34704	34705
10092	9996	4	applied	\N	\N	\N	\N	34706	34706	34707
10092	9997	5	applied	\N	\N	\N	\N	34708	34708	34709
10092	9998	6	applied	\N	\N	\N	\N	34710	34710	34711
10092	9999	8	applied	\N	\N	\N	\N	34713	34713	34714
10092	10000	9	applied	\N	\N	\N	\N	34715	34715	34716
10092	10001	10	applied	\N	\N	\N	\N	34717	34717	34718
10092	10002	11	applied	\N	\N	\N	\N	34719	34719	34720
10092	10003	12	applied	\N	\N	\N	\N	34721	34721	34722
10092	10004	13	applied	\N	\N	\N	\N	34723	34723	34724
10092	10005	14	applied	\N	\N	\N	\N	34725	34725	34726
10092	10006	15	applied	\N	\N	\N	\N	34727	34727	34728
10092	10007	16	applied	\N	\N	\N	\N	34729	34729	34730
10092	10008	17	applied	\N	\N	\N	\N	34731	34731	34732
10092	10009	18	applied	\N	\N	\N	\N	34733	34733	34734
10092	10010	19	applied	\N	\N	\N	\N	34735	34735	34736
10092	10011	20	applied	\N	\N	\N	\N	34737	34737	34738
10092	10012	21	applied	\N	\N	\N	\N	34739	34739	34740
10097	10013	0	applied	\N	\N	\N	\N	34745	34745	34746
10097	10014	1	applied	\N	\N	\N	\N	34747	34747	34748
10097	10015	2	applied	\N	\N	\N	\N	34749	34749	34750
10097	10016	3	applied	\N	\N	\N	\N	34751	34751	34752
10102	10031	0	applied	\N	\N	\N	\N	34790	34790	34791
10105	10038	0	applied	\N	\N	\N	\N	34807	34807	34808
10105	10039	1	applied	\N	\N	\N	\N	34809	34809	34810
10107	10040	0	applied	\N	\N	\N	\N	34814	34814	34815
10107	10041	1	applied	\N	\N	\N	\N	34816	34816	34817
10107	10042	2	applied	\N	\N	\N	\N	34818	34818	34819
10117	10076	0	applied	\N	\N	\N	\N	34903	34903	34803
10022	9765	11	applied	\N	\N	\N	\N	34098	34098	34099
10027	9778	0	applied	\N	\N	\N	\N	34131	34131	34132
10027	9779	1	applied	\N	\N	\N	\N	34133	34133	34134
10027	9780	2	applied	\N	\N	\N	\N	34135	34135	34136
10031	9681	0	applied	\N	\N	\N	\N	33844	33844	33845
10031	9767	1	applied	\N	\N	\N	\N	34106	34106	34107
10031	9669	2	applied	\N	\N	\N	\N	33799	33799	33800
10031	9768	3	applied	\N	\N	\N	\N	34108	34108	34109
10031	9769	4	applied	\N	\N	\N	\N	34111	34111	34112
10031	9772	5	applied	\N	\N	\N	\N	34117	34117	34118
10031	9694	6	applied	\N	\N	\N	\N	33882	33882	33883
10031	9730	7	applied	\N	\N	\N	\N	33986	33986	33987
10031	9731	8	applied	\N	\N	\N	\N	33988	33988	33989
10031	9739	9	applied	\N	\N	\N	\N	34005	34005	34006
10031	9673	10	applied	\N	\N	\N	\N	33807	33807	33808
10031	9675	11	applied	\N	\N	\N	\N	33817	33817	33818
10031	9683	12	applied	\N	\N	\N	\N	33848	33848	33849
10031	9684	13	applied	\N	\N	\N	\N	33850	33850	33851
10031	9791	14	applied	\N	\N	\N	\N	34162	34162	34163
10031	9752	15	applied	\N	\N	\N	\N	34164	34164	34069
10031	9759	16	applied	\N	\N	\N	\N	34165	34165	34087
10031	9697	17	applied	\N	\N	\N	\N	33888	33888	1254
10031	9760	18	applied	\N	\N	\N	\N	34166	34166	34089
10031	9701	19	applied	\N	\N	1000000000	\N	33908	33908	33909
10031	9665	20	applied	\N	\N	\N	\N	33839	33839	33788
10031	9712	21	applied	\N	\N	\N	\N	34060	34060	33940
10031	9747	22	applied	\N	\N	\N	\N	34061	34061	34024
10033	9796	0	applied	\N	\N	\N	\N	34180	34180	34181
10033	9797	1	applied	\N	\N	\N	\N	34182	34182	34183
10033	9798	2	applied	\N	\N	\N	\N	34184	34184	34185
10033	9799	3	applied	\N	\N	\N	\N	34186	34186	34187
10033	9800	4	applied	\N	\N	\N	\N	34188	34188	34189
10038	9803	0	applied	\N	\N	\N	\N	34202	34202	34203
10038	9804	1	applied	\N	\N	\N	\N	34204	34204	34205
10038	9805	2	applied	\N	\N	\N	\N	34206	34206	34207
10038	9806	3	applied	\N	\N	\N	\N	34208	34208	34209
10038	9807	4	applied	\N	\N	\N	\N	34210	34210	34211
10038	9808	5	applied	\N	\N	\N	\N	34212	34212	34213
10045	9576	0	applied	\N	\N	\N	\N	33514	33514	33515
10045	9591	1	applied	\N	\N	\N	\N	33751	33751	33555
10045	9592	2	applied	\N	\N	\N	\N	33752	33752	33557
10045	9593	3	applied	\N	\N	\N	\N	33753	33753	33559
10045	9402	4	applied	\N	\N	\N	\N	33020	33020	33021
10045	9403	5	applied	\N	\N	\N	\N	33024	33024	33025
10045	9404	6	applied	\N	\N	\N	\N	33026	33026	33027
10045	9405	7	applied	\N	\N	\N	\N	33028	33028	33029
10045	9416	8	applied	\N	\N	\N	\N	33050	33050	33051
10045	9639	9	applied	\N	\N	\N	\N	33690	33690	33691
10045	9473	10	applied	\N	\N	\N	\N	33209	33209	33210
10045	9607	11	applied	\N	\N	\N	\N	33602	33602	33603
10045	9479	12	applied	\N	\N	\N	\N	33226	33226	33227
10045	9767	13	applied	\N	\N	\N	\N	34106	34106	34107
10045	9669	14	applied	\N	\N	\N	\N	33799	33799	33800
10045	9655	15	applied	\N	\N	\N	\N	33901	33901	33755
10045	9656	16	applied	\N	\N	\N	\N	33902	33902	33757
10045	9660	17	applied	\N	\N	\N	\N	33903	33903	33776
10045	9609	18	applied	\N	\N	\N	\N	33606	33606	33607
10045	9610	19	applied	\N	\N	\N	\N	33608	33608	33609
10045	9768	20	applied	\N	\N	\N	\N	34108	34108	34109
10045	9769	21	applied	\N	\N	\N	\N	34111	34111	34112
10045	9612	22	applied	\N	\N	\N	\N	33612	33612	33613
10045	9772	23	applied	\N	\N	\N	\N	34117	34117	34118
10045	9613	24	applied	\N	\N	\N	\N	33614	33614	33615
10045	9673	25	applied	\N	\N	\N	\N	33807	33807	33808
10045	9675	26	applied	\N	\N	\N	\N	33817	33817	33818
10045	9683	27	applied	\N	\N	\N	\N	33848	33848	33849
10045	9684	28	applied	\N	\N	\N	\N	33850	33850	33851
10045	9489	29	applied	\N	\N	\N	\N	33250	33250	33251
10045	9490	30	applied	\N	\N	\N	\N	33252	33252	33253
10045	9491	31	applied	\N	\N	\N	\N	33254	33254	33255
10045	9679	32	applied	\N	\N	\N	\N	34232	34232	33838
10045	9414	33	applied	\N	\N	\N	\N	33073	33073	33047
10045	9429	34	applied	\N	\N	\N	\N	34233	34233	33089
10045	9446	35	applied	\N	\N	\N	\N	34234	34234	33128
10045	9447	36	applied	\N	\N	\N	\N	34235	34235	33130
10045	9575	37	applied	\N	\N	\N	\N	34236	34236	33510
10045	9646	38	applied	\N	\N	\N	\N	33712	33712	33713
10045	9791	39	applied	\N	\N	\N	\N	34162	34162	34163
10045	9752	40	applied	\N	\N	\N	\N	34237	34237	34069
10045	9759	41	applied	\N	\N	\N	\N	34238	34238	34087
10045	9654	42	applied	\N	\N	\N	\N	33763	33763	33744
10045	9798	43	applied	\N	\N	\N	\N	34239	34239	34185
10045	9760	44	applied	\N	\N	\N	\N	34240	34240	34089
10045	9423	45	applied	\N	\N	\N	\N	33064	33064	12588
10045	9799	46	applied	\N	\N	\N	\N	34241	34241	34187
10045	9701	47	applied	\N	\N	1000000000	\N	33908	33908	33909
10045	9800	48	applied	\N	\N	\N	\N	34242	34242	34189
10045	9665	49	applied	\N	\N	\N	\N	33839	33839	33788
10045	9712	50	applied	\N	\N	\N	\N	34060	34060	33940
10045	9747	51	applied	\N	\N	\N	\N	34061	34061	34024
10045	9753	52	applied	\N	\N	1000000000	\N	34243	34243	34071
10045	9762	53	applied	\N	\N	\N	\N	34244	34244	34093
10045	9763	54	applied	\N	\N	\N	\N	34245	34245	34095
10045	9764	55	applied	\N	\N	\N	\N	34246	34246	34097
10045	9765	56	applied	\N	\N	\N	\N	34247	34247	34099
10045	9773	57	applied	\N	\N	\N	\N	34248	34248	34120
10045	9777	58	applied	\N	\N	\N	\N	34128	34128	34249
10045	9780	59	applied	\N	\N	\N	\N	34250	34250	34136
10051	9814	0	applied	\N	\N	\N	\N	34262	34262	34263
10051	9815	1	applied	\N	\N	\N	\N	34264	34264	34265
10054	9818	0	applied	\N	\N	\N	\N	34276	34276	34277
10064	9841	0	applied	\N	\N	\N	\N	34339	34339	34340
10064	9842	1	applied	\N	\N	\N	\N	34341	34341	34342
10064	9843	2	applied	\N	\N	\N	\N	34343	34343	34344
10064	9844	3	applied	\N	\N	\N	\N	34345	34345	34346
10066	9845	0	applied	\N	\N	\N	\N	34350	34350	34351
10066	9846	1	applied	\N	\N	\N	\N	34352	34352	34353
10066	9847	2	applied	\N	\N	\N	\N	34354	34354	34355
10066	9848	3	applied	\N	\N	\N	\N	34356	34356	34357
10066	9849	4	applied	\N	\N	\N	\N	34358	34358	34359
10066	9850	5	applied	\N	\N	\N	\N	34360	34360	34361
10066	9851	6	applied	\N	\N	\N	\N	34362	34362	34363
10066	9852	7	applied	\N	\N	\N	\N	34364	34364	34365
10066	9853	8	applied	\N	\N	\N	\N	34366	34366	34367
10066	9854	9	applied	\N	\N	\N	\N	34368	34368	34369
10068	9855	0	applied	\N	\N	\N	\N	34374	34374	34375
10068	9856	1	applied	\N	\N	\N	\N	34376	34376	34377
10068	9858	2	applied	\N	\N	\N	\N	34382	34382	25661
10071	9859	0	applied	\N	\N	\N	\N	34395	34395	34396
10052	9817	1	applied	\N	\N	\N	\N	34272	34272	34273
10057	9823	0	applied	\N	\N	\N	\N	34291	34291	34292
10057	9824	1	applied	\N	\N	\N	\N	34293	34293	34294
10057	9825	2	applied	\N	\N	\N	\N	34295	34295	34296
10059	9827	0	applied	\N	\N	\N	\N	34302	34302	34303
10060	9826	0	applied	\N	\N	\N	\N	34300	34300	34301
10060	9828	1	applied	\N	\N	\N	\N	34307	34307	34308
10060	9829	2	applied	\N	\N	\N	\N	34309	34309	34310
10060	9830	3	applied	\N	\N	\N	\N	34311	34311	34312
10060	9831	4	applied	\N	\N	\N	\N	34313	34313	34314
10060	9832	5	applied	\N	\N	\N	\N	34315	34315	34316
10060	9833	6	applied	\N	\N	1000000000	\N	34317	34317	34318
10060	9834	7	applied	\N	\N	1000000000	\N	34319	34319	34320
10060	9835	8	applied	\N	\N	\N	\N	34321	34321	34322
10060	9836	9	applied	\N	\N	1000000000	\N	34323	34323	34324
10060	9837	10	applied	\N	\N	1000000000	\N	34325	34325	34326
10060	9838	11	applied	\N	\N	\N	\N	34327	34327	34328
10060	9839	12	applied	\N	\N	\N	\N	34329	34329	34330
10060	9840	13	applied	\N	\N	\N	\N	34331	34331	34332
10062	9831	0	applied	\N	\N	\N	\N	34313	34313	34336
10072	9873	0	applied	\N	\N	\N	\N	34425	34425	34426
10072	9874	1	applied	\N	\N	\N	\N	34427	34427	34428
10072	9875	2	applied	\N	\N	\N	\N	34429	34429	34430
10072	9876	3	applied	\N	\N	\N	\N	34431	34431	34432
10072	9877	4	applied	\N	\N	\N	\N	34433	34433	34434
10072	9878	5	applied	\N	\N	\N	\N	34435	34435	34436
10072	9879	6	applied	\N	\N	\N	\N	34437	34437	34438
10073	9880	0	applied	\N	\N	\N	\N	34441	34441	34442
10073	9881	1	applied	\N	\N	\N	\N	34443	34443	34444
10073	9882	2	applied	\N	\N	\N	\N	34445	34445	34446
10073	9883	3	applied	\N	\N	\N	\N	34447	34447	34448
10073	9884	4	applied	\N	\N	\N	\N	34449	34449	34450
10073	9885	5	applied	\N	\N	\N	\N	34451	34451	34452
10073	9886	6	applied	\N	\N	\N	\N	34453	34453	34454
10073	9887	7	applied	\N	\N	\N	\N	34455	34455	34456
10073	9888	8	applied	\N	\N	\N	\N	34457	34457	34458
10073	9889	9	applied	\N	\N	\N	\N	34459	34459	34460
10073	9890	10	applied	\N	\N	\N	\N	34461	34461	34462
10073	9891	11	applied	\N	\N	\N	\N	34463	34463	34464
10073	9892	12	applied	\N	\N	\N	\N	34465	34465	34466
10075	9893	0	applied	\N	\N	\N	\N	34471	34471	34472
10075	9894	1	applied	\N	\N	\N	\N	34473	34473	34474
10075	9895	2	applied	\N	\N	\N	\N	34475	34475	34476
10078	9900	0	applied	\N	\N	\N	\N	34487	34487	34488
10078	9901	1	applied	\N	\N	\N	\N	34489	34489	34490
10078	9905	2	applied	\N	\N	\N	\N	34499	34499	34500
10078	9906	3	applied	\N	\N	\N	\N	34501	34501	34502
10078	9902	4	applied	\N	\N	\N	\N	34491	34491	34492
10078	9903	5	applied	\N	\N	\N	\N	34493	34493	34494
10078	9904	6	applied	\N	\N	\N	\N	34495	34495	34496
10083	9918	0	applied	\N	\N	\N	\N	34533	34533	34534
10083	9919	1	applied	\N	\N	\N	\N	34535	34535	34536
10086	9946	0	applied	\N	\N	\N	\N	34595	34595	34596
10086	9947	1	applied	\N	\N	\N	\N	34597	34597	34598
10086	9948	2	applied	\N	\N	\N	\N	34599	34599	34600
10086	9949	3	applied	\N	\N	\N	\N	34601	34601	34602
10086	9950	4	applied	\N	\N	\N	\N	34603	34603	34604
10086	9951	5	applied	\N	\N	\N	\N	34605	34605	34606
10086	9952	6	applied	\N	\N	\N	\N	34607	34607	34608
10086	9953	7	applied	\N	\N	\N	\N	34609	34609	34610
10086	9954	8	applied	\N	\N	\N	\N	34611	34611	34612
10086	9955	9	applied	\N	\N	\N	\N	34613	34613	34614
10086	9956	10	applied	\N	\N	\N	\N	34615	34615	34616
10086	9957	11	applied	\N	\N	\N	\N	34617	34617	34618
10086	9958	12	applied	\N	\N	\N	\N	34619	34619	34620
10086	9959	13	applied	\N	\N	\N	\N	34621	34621	34622
10086	9960	14	applied	\N	\N	\N	\N	34623	34623	34624
10086	9961	15	applied	\N	\N	\N	\N	34625	34625	34626
10086	9962	16	applied	\N	\N	\N	\N	34627	34627	34628
10086	9963	17	applied	\N	\N	\N	\N	34629	34629	34630
10086	9964	18	applied	\N	\N	\N	\N	34631	34631	34632
10086	9965	19	applied	\N	\N	\N	\N	34633	34633	34634
10086	9966	20	applied	\N	\N	\N	\N	34635	34635	34636
10086	9967	21	applied	\N	\N	\N	\N	34637	34637	25661
10101	10030	0	applied	\N	\N	\N	\N	34786	34786	34787
10104	10038	0	applied	\N	\N	\N	\N	34807	34807	34808
10104	10039	1	applied	\N	\N	\N	\N	34809	34809	34810
10111	10043	0	applied	\N	\N	\N	\N	34823	34823	34824
10111	10044	1	applied	\N	\N	\N	\N	34825	34825	34826
10111	10045	2	applied	\N	\N	\N	\N	34827	34827	34828
10111	10046	3	applied	\N	\N	\N	\N	34829	34829	34830
10111	10047	4	applied	\N	\N	\N	\N	34831	34831	34832
10111	10048	5	applied	\N	\N	\N	\N	34833	34833	34834
10111	10049	6	applied	\N	\N	\N	\N	34835	34835	34836
10113	10050	0	applied	\N	\N	\N	\N	34845	34845	34846
10113	10051	1	applied	\N	\N	\N	\N	34847	34847	34848
10113	10052	2	applied	\N	\N	\N	\N	34849	34849	34850
10113	10053	3	applied	\N	\N	\N	\N	34851	34851	34852
10113	10054	4	applied	\N	\N	\N	\N	34853	34853	34854
10113	10055	5	applied	\N	\N	\N	\N	34855	34855	34856
10113	10056	6	applied	\N	\N	\N	\N	34857	34857	34858
10113	10057	7	applied	\N	\N	\N	\N	34859	34859	34860
10113	10058	8	applied	\N	\N	\N	\N	34861	34861	34862
10113	10059	9	applied	\N	\N	\N	\N	34863	34863	34864
10113	10060	10	applied	\N	\N	\N	\N	34865	34865	34866
10118	10079	0	applied	\N	\N	\N	\N	34910	34910	34911
10118	10080	1	applied	\N	\N	\N	\N	34912	34912	34913
10118	10081	2	applied	\N	\N	\N	\N	34914	34914	34915
10121	10082	0	applied	\N	\N	\N	\N	34921	34921	34922
10121	10083	1	applied	\N	\N	\N	\N	34923	34923	34924
10121	10084	2	applied	\N	\N	\N	\N	34925	34925	34926
10121	10085	3	applied	\N	\N	\N	\N	34927	34927	34928
10121	10086	4	applied	\N	\N	\N	\N	34929	34929	34930
10121	10087	5	applied	\N	\N	\N	\N	34931	34931	34932
10121	10088	6	applied	\N	\N	\N	\N	34933	34933	34934
10121	10089	7	applied	\N	\N	\N	\N	34935	34935	34936
10121	10090	8	applied	\N	\N	\N	\N	34937	34937	34938
10121	10091	9	applied	\N	\N	\N	\N	34939	34939	34940
10121	10092	10	applied	\N	\N	\N	\N	34941	34941	34942
10121	10093	11	applied	\N	\N	\N	\N	34943	34943	34944
10121	10094	12	applied	\N	\N	\N	\N	34945	34945	34946
10124	10098	0	applied	\N	\N	\N	\N	34956	34956	34957
10124	10097	1	applied	\N	\N	\N	\N	34953	34953	34954
10128	10103	0	applied	\N	\N	\N	\N	34978	34978	34979
10130	10104	0	applied	\N	\N	\N	\N	34981	34981	34982
10130	10103	1	applied	\N	\N	\N	\N	34978	34978	34979
10137	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10137	10109	1	applied	\N	\N	\N	\N	35018	35018	34997
10137	9993	2	applied	\N	\N	\N	\N	34700	34700	34701
10071	9860	1	applied	\N	\N	\N	\N	34397	34397	34398
10071	9861	2	applied	\N	\N	\N	\N	34399	34399	34400
10071	9862	3	applied	\N	\N	\N	\N	34401	34401	34402
10071	9863	4	applied	\N	\N	1000000000	\N	34403	34403	34404
10071	9864	5	applied	\N	\N	\N	\N	34405	34405	34406
10071	9865	6	applied	\N	\N	\N	\N	34407	34407	34408
10071	9866	7	applied	\N	\N	1000000000	\N	34409	34409	34410
10071	9867	8	applied	\N	\N	\N	\N	34411	34411	34412
10071	9868	9	applied	\N	\N	\N	\N	34413	34413	34414
10071	9869	10	applied	\N	\N	\N	\N	34415	34415	34416
10071	9870	11	applied	\N	\N	\N	\N	34417	34417	34418
10071	9871	12	applied	\N	\N	\N	\N	34419	34419	34420
10071	9872	13	applied	\N	\N	\N	\N	34421	34421	34422
10080	9905	0	applied	\N	\N	\N	\N	34499	34499	34500
10080	9906	1	applied	\N	\N	\N	\N	34501	34501	34502
10080	9907	2	applied	\N	\N	\N	\N	34505	34505	34506
10080	9908	3	applied	\N	\N	\N	\N	34507	34507	34508
10080	9909	4	applied	\N	\N	\N	\N	34509	34509	34510
10080	9910	5	applied	\N	\N	\N	\N	34511	34511	34512
10082	9913	0	applied	\N	\N	\N	\N	34521	34521	34522
10082	9914	1	applied	\N	\N	\N	\N	34523	34523	34524
10082	9915	2	applied	\N	\N	\N	\N	34525	34525	34526
10082	9916	3	applied	\N	\N	\N	\N	34527	34527	34528
10082	9917	4	applied	\N	\N	\N	\N	34529	34529	34530
10088	9946	0	applied	\N	\N	\N	\N	34595	34595	34596
10088	9947	1	applied	\N	\N	\N	\N	34597	34597	34598
10088	9948	2	applied	\N	\N	\N	\N	34599	34599	34600
10088	9949	3	applied	\N	\N	\N	\N	34601	34601	34602
10088	9950	4	applied	\N	\N	\N	\N	34603	34603	34604
10088	9951	5	applied	\N	\N	\N	\N	34605	34605	34606
10088	9952	6	applied	\N	\N	\N	\N	34607	34607	34608
10088	9953	7	applied	\N	\N	\N	\N	34609	34609	34610
10088	9954	8	applied	\N	\N	\N	\N	34611	34611	34612
10088	9955	9	applied	\N	\N	\N	\N	34613	34613	34614
10088	9956	10	applied	\N	\N	\N	\N	34615	34615	34616
10088	9957	11	applied	\N	\N	\N	\N	34617	34617	34618
10088	9958	12	applied	\N	\N	\N	\N	34619	34619	34620
10088	9959	13	applied	\N	\N	\N	\N	34621	34621	34622
10088	9960	14	applied	\N	\N	\N	\N	34623	34623	34624
10088	9961	15	applied	\N	\N	\N	\N	34625	34625	34626
10088	9962	16	applied	\N	\N	\N	\N	34627	34627	34628
10088	9963	17	applied	\N	\N	\N	\N	34629	34629	34630
10088	9964	18	applied	\N	\N	\N	\N	34631	34631	34632
10088	9965	19	applied	\N	\N	\N	\N	34633	34633	34634
10088	9966	20	applied	\N	\N	\N	\N	34635	34635	34636
10088	9967	21	applied	\N	\N	\N	\N	34637	34637	25661
10090	9767	0	applied	\N	\N	\N	\N	34106	34106	34107
10090	9669	1	applied	\N	\N	\N	\N	33799	33799	33800
10090	9880	2	applied	\N	\N	\N	\N	34667	34667	34442
10090	9655	3	applied	\N	\N	\N	\N	33754	33754	33755
10090	9656	4	applied	\N	\N	\N	\N	33756	33756	33757
10090	9660	5	applied	\N	\N	\N	\N	33775	33775	33776
10090	9657	6	applied	\N	\N	\N	\N	33765	33765	33766
10090	9842	7	applied	\N	\N	\N	\N	34341	34341	34342
10090	9843	8	applied	\N	\N	\N	\N	34343	34343	34344
10090	9662	9	applied	\N	\N	\N	\N	33781	33781	33782
10090	9663	10	applied	\N	\N	\N	\N	33783	33783	33784
10090	9923	11	applied	\N	\N	\N	\N	34545	34545	34546
10090	9924	12	applied	\N	\N	\N	\N	34547	34547	34548
10090	9925	13	applied	\N	\N	\N	\N	34549	34549	34550
10090	9926	14	applied	\N	\N	\N	\N	34551	34551	34552
10090	9831	15	applied	\N	\N	\N	\N	34313	34313	34386
10090	9832	16	applied	\N	\N	\N	\N	34315	34315	34392
10090	9667	17	applied	\N	\N	\N	\N	33791	33791	33792
10090	9668	18	applied	\N	\N	\N	\N	33797	33797	33798
10090	9768	19	applied	\N	\N	\N	\N	34108	34108	34109
10090	9769	20	applied	\N	\N	\N	\N	34111	34111	34112
10090	9864	21	applied	\N	\N	\N	\N	34405	34405	34668
10090	9846	22	applied	\N	\N	\N	\N	34352	34352	34353
10090	9847	23	applied	\N	\N	\N	\N	34354	34354	34355
10090	9658	24	applied	\N	\N	\N	\N	33767	33767	33768
10090	9772	25	applied	\N	\N	\N	\N	34117	34117	34118
10090	9848	26	applied	\N	\N	\N	\N	34356	34356	34357
10090	9849	27	applied	\N	\N	\N	\N	34358	34358	34359
10090	9850	28	applied	\N	\N	\N	\N	34360	34360	34361
10090	9851	29	applied	\N	\N	\N	\N	34362	34362	34363
10090	9852	30	applied	\N	\N	\N	\N	34364	34364	34365
10090	9853	31	applied	\N	\N	\N	\N	34366	34366	34367
10090	9927	32	applied	\N	\N	\N	\N	34553	34553	34554
10090	9928	33	applied	\N	\N	\N	\N	34555	34555	34556
10090	9929	34	applied	\N	\N	\N	\N	34557	34557	34558
10090	9930	35	applied	\N	\N	\N	\N	34559	34559	34560
10090	9931	36	applied	\N	\N	\N	\N	34561	34561	34562
10090	9932	37	applied	\N	\N	\N	\N	34563	34563	34564
10090	9933	38	applied	\N	\N	\N	\N	34565	34565	34566
10090	9934	39	applied	\N	\N	\N	\N	34567	34567	34568
10090	9935	40	applied	\N	\N	\N	\N	34569	34569	34570
10090	9936	41	applied	\N	\N	\N	\N	34571	34571	34572
10090	9937	42	applied	\N	\N	\N	\N	34573	34573	34574
10090	9938	43	applied	\N	\N	\N	\N	34575	34575	34576
10090	9939	44	applied	\N	\N	\N	\N	34577	34577	34578
10090	9940	45	applied	\N	\N	\N	\N	34579	34579	34580
10090	9941	46	applied	\N	\N	\N	\N	34581	34581	34582
10090	9947	47	applied	\N	\N	\N	\N	34597	34597	34598
10090	9948	48	applied	\N	\N	\N	\N	34599	34599	34600
10090	9949	49	applied	\N	\N	\N	\N	34601	34601	34602
10090	9950	50	applied	\N	\N	\N	\N	34603	34603	34604
10090	9951	51	applied	\N	\N	\N	\N	34605	34605	34606
10090	9952	52	applied	\N	\N	\N	\N	34607	34607	34608
10090	9953	53	applied	\N	\N	\N	\N	34609	34609	34610
10090	9954	54	applied	\N	\N	\N	\N	34611	34611	34612
10090	9955	55	applied	\N	\N	\N	\N	34613	34613	34614
10090	9956	56	applied	\N	\N	\N	\N	34615	34615	34616
10090	9957	57	applied	\N	\N	\N	\N	34617	34617	34618
10090	9958	58	applied	\N	\N	\N	\N	34619	34619	34620
10090	9959	59	applied	\N	\N	\N	\N	34621	34621	34622
10090	9672	60	applied	\N	\N	\N	\N	33805	33805	33806
10090	9676	61	applied	\N	\N	\N	\N	33819	33819	33820
10090	9854	62	applied	\N	\N	\N	\N	34368	34368	34369
10090	9678	63	applied	\N	\N	\N	\N	33823	33823	33824
10090	9685	64	applied	\N	\N	\N	\N	33852	33852	33853
10090	9686	65	applied	\N	\N	\N	\N	33862	33862	33863
10090	9659	66	applied	\N	\N	\N	\N	33772	33772	33773
10090	9661	67	applied	\N	\N	\N	\N	33779	33779	33780
10090	9664	68	applied	\N	\N	\N	\N	33785	33785	33786
10090	9666	69	applied	\N	\N	\N	\N	33789	33789	33790
10090	9670	70	applied	\N	\N	\N	\N	33801	33801	33802
10090	9671	71	applied	\N	\N	\N	\N	33803	33803	33804
10090	9674	72	applied	\N	\N	\N	\N	33815	33815	33816
10076	9894	3	applied	\N	\N	\N	\N	34473	34473	34474
10076	9898	4	applied	\N	\N	\N	\N	34482	34482	34483
10076	9899	5	applied	\N	\N	1000000000	\N	34484	34484	34485
10076	9895	6	applied	\N	\N	\N	\N	34475	34475	34476
10081	9911	0	applied	\N	\N	\N	\N	34515	34515	34516
10081	9912	1	applied	\N	\N	\N	\N	34517	34517	34518
10084	9920	0	applied	\N	\N	\N	\N	34539	34539	34540
10084	9921	1	applied	\N	\N	\N	\N	34541	34541	34542
10084	9922	2	applied	\N	\N	\N	\N	34543	34543	34544
10084	9923	3	applied	\N	\N	\N	\N	34545	34545	34546
10084	9924	4	applied	\N	\N	\N	\N	34547	34547	34548
10084	9925	5	applied	\N	\N	\N	\N	34549	34549	34550
10084	9926	6	applied	\N	\N	\N	\N	34551	34551	34552
10084	9927	7	applied	\N	\N	\N	\N	34553	34553	34554
10084	9928	8	applied	\N	\N	\N	\N	34555	34555	34556
10084	9929	9	applied	\N	\N	\N	\N	34557	34557	34558
10084	9930	10	applied	\N	\N	\N	\N	34559	34559	34560
10084	9931	11	applied	\N	\N	\N	\N	34561	34561	34562
10084	9932	12	applied	\N	\N	\N	\N	34563	34563	34564
10084	9933	13	applied	\N	\N	\N	\N	34565	34565	34566
10084	9934	14	applied	\N	\N	\N	\N	34567	34567	34568
10084	9935	15	applied	\N	\N	\N	\N	34569	34569	34570
10084	9936	16	applied	\N	\N	\N	\N	34571	34571	34572
10084	9937	17	applied	\N	\N	\N	\N	34573	34573	34574
10084	9938	18	applied	\N	\N	\N	\N	34575	34575	34576
10084	9939	19	applied	\N	\N	\N	\N	34577	34577	34578
10084	9940	20	applied	\N	\N	\N	\N	34579	34579	34580
10084	9941	21	applied	\N	\N	\N	\N	34581	34581	34582
10084	9942	22	applied	\N	\N	\N	\N	34583	34583	34584
10084	9943	23	applied	\N	\N	\N	\N	34585	34585	34586
10084	9944	24	applied	\N	\N	1000000000	\N	34587	34587	34588
10084	9945	25	applied	\N	\N	\N	\N	34589	34589	34590
10087	9946	0	applied	\N	\N	\N	\N	34595	34595	34596
10087	9947	1	applied	\N	\N	\N	\N	34597	34597	34598
10087	9948	2	applied	\N	\N	\N	\N	34599	34599	34600
10087	9949	3	applied	\N	\N	\N	\N	34601	34601	34602
10087	9950	4	applied	\N	\N	\N	\N	34603	34603	34604
10087	9951	5	applied	\N	\N	\N	\N	34605	34605	34606
10087	9952	6	applied	\N	\N	\N	\N	34607	34607	34608
10087	9953	7	applied	\N	\N	\N	\N	34609	34609	34610
10087	9954	8	applied	\N	\N	\N	\N	34611	34611	34612
10087	9955	9	applied	\N	\N	\N	\N	34613	34613	34614
10087	9956	10	applied	\N	\N	\N	\N	34615	34615	34616
10087	9957	11	applied	\N	\N	\N	\N	34617	34617	34618
10087	9958	12	applied	\N	\N	\N	\N	34619	34619	34620
10087	9959	13	applied	\N	\N	\N	\N	34621	34621	34622
10087	9960	14	applied	\N	\N	\N	\N	34623	34623	34624
10087	9961	15	applied	\N	\N	\N	\N	34625	34625	34626
10087	9962	16	applied	\N	\N	\N	\N	34627	34627	34628
10087	9963	17	applied	\N	\N	\N	\N	34629	34629	34630
10087	9964	18	applied	\N	\N	\N	\N	34631	34631	34632
10087	9965	19	applied	\N	\N	\N	\N	34633	34633	34634
10087	9966	20	applied	\N	\N	\N	\N	34635	34635	34636
10087	9967	21	applied	\N	\N	\N	\N	34637	34637	25661
10089	9968	0	applied	\N	\N	1000000000	\N	34642	34642	34643
10089	9969	1	applied	\N	\N	\N	\N	34644	34644	34645
10089	9970	2	applied	\N	\N	\N	\N	34646	34646	34647
10089	9971	3	applied	\N	\N	\N	\N	34648	34648	34649
10089	9972	4	applied	\N	\N	\N	\N	34650	34650	34651
10089	9973	5	applied	\N	\N	\N	\N	34652	34652	34653
10089	9974	6	applied	\N	\N	\N	\N	34654	34654	34655
10089	9975	7	applied	\N	\N	\N	\N	34656	34656	34657
10089	9976	8	applied	\N	\N	\N	\N	34658	34658	34659
10089	9977	9	applied	\N	\N	\N	\N	34660	34660	34661
10089	9978	10	applied	\N	\N	\N	\N	34662	34662	34663
10089	9979	11	applied	\N	\N	\N	\N	34664	34664	34665
10091	9980	0	applied	\N	\N	\N	\N	34672	34672	34673
10091	9981	1	applied	\N	\N	\N	\N	34674	34674	34675
10091	9982	2	applied	\N	\N	\N	\N	34676	34676	34677
10091	9983	3	applied	\N	\N	\N	\N	34678	34678	34679
10091	9984	4	applied	\N	\N	\N	\N	34680	34680	34681
10091	9985	5	applied	\N	\N	\N	\N	34682	34682	34683
10091	9986	6	applied	\N	\N	\N	\N	34684	34684	34685
10091	9987	7	applied	\N	\N	\N	\N	34686	34686	34687
10091	9988	8	applied	\N	\N	\N	\N	34688	34688	34689
10091	9989	9	applied	\N	\N	\N	\N	34690	34690	34691
10091	9990	10	applied	\N	\N	\N	\N	34692	34692	34693
10091	9991	11	applied	\N	\N	\N	\N	34694	34694	34695
10094	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10094	9993	1	applied	\N	\N	\N	\N	34700	34700	34701
10094	9994	2	applied	\N	\N	\N	\N	34702	34702	34703
10094	9995	3	applied	\N	\N	\N	\N	34704	34704	34705
10094	9996	4	applied	\N	\N	\N	\N	34706	34706	34707
10094	9997	5	applied	\N	\N	\N	\N	34708	34708	34709
10094	9998	6	applied	\N	\N	\N	\N	34710	34710	34711
10094	9999	8	applied	\N	\N	\N	\N	34713	34713	34714
10094	10000	9	applied	\N	\N	\N	\N	34715	34715	34716
10094	10001	10	applied	\N	\N	\N	\N	34717	34717	34718
10094	10002	11	applied	\N	\N	\N	\N	34719	34719	34720
10094	10003	12	applied	\N	\N	\N	\N	34721	34721	34722
10094	10004	13	applied	\N	\N	\N	\N	34723	34723	34724
10094	10005	14	applied	\N	\N	\N	\N	34725	34725	34726
10094	10006	15	applied	\N	\N	\N	\N	34727	34727	34728
10094	10007	16	applied	\N	\N	\N	\N	34729	34729	34730
10094	10008	17	applied	\N	\N	\N	\N	34731	34731	34732
10094	10009	18	applied	\N	\N	\N	\N	34733	34733	34734
10094	10010	19	applied	\N	\N	\N	\N	34735	34735	34736
10094	10011	20	applied	\N	\N	\N	\N	34737	34737	34738
10094	10012	21	applied	\N	\N	\N	\N	34739	34739	34740
10095	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10095	9993	1	applied	\N	\N	\N	\N	34700	34700	34701
10095	9994	2	applied	\N	\N	\N	\N	34702	34702	34703
10095	9995	3	applied	\N	\N	\N	\N	34704	34704	34705
10095	9996	4	applied	\N	\N	\N	\N	34706	34706	34707
10095	9997	5	applied	\N	\N	\N	\N	34708	34708	34709
10095	9998	6	applied	\N	\N	\N	\N	34710	34710	34711
10095	9999	8	applied	\N	\N	\N	\N	34713	34713	34714
10095	10000	9	applied	\N	\N	\N	\N	34715	34715	34716
10095	10001	10	applied	\N	\N	\N	\N	34717	34717	34718
10095	10002	11	applied	\N	\N	\N	\N	34719	34719	34720
10095	10003	12	applied	\N	\N	\N	\N	34721	34721	34722
10095	10004	13	applied	\N	\N	\N	\N	34723	34723	34724
10095	10005	14	applied	\N	\N	\N	\N	34725	34725	34726
10095	10006	15	applied	\N	\N	\N	\N	34727	34727	34728
10095	10007	16	applied	\N	\N	\N	\N	34729	34729	34730
10095	10008	17	applied	\N	\N	\N	\N	34731	34731	34732
10095	10009	18	applied	\N	\N	\N	\N	34733	34733	34734
10095	10010	19	applied	\N	\N	\N	\N	34735	34735	34736
10095	10011	20	applied	\N	\N	\N	\N	34737	34737	34738
10090	9677	73	applied	\N	\N	\N	\N	33821	33821	33822
10090	9680	74	applied	\N	\N	\N	\N	33842	33842	33843
10090	9682	75	applied	\N	\N	\N	\N	33846	33846	33847
10090	9687	76	applied	\N	\N	\N	\N	33864	33864	33865
10090	9688	77	applied	\N	\N	\N	\N	33868	33868	33869
10090	9690	78	applied	\N	\N	\N	\N	33872	33872	33873
10090	9692	79	applied	\N	\N	\N	\N	33878	33878	33879
10090	9693	80	applied	\N	\N	\N	\N	33880	33880	33881
10090	9699	81	applied	\N	\N	\N	\N	33892	33892	33893
10090	9700	82	applied	\N	\N	\N	\N	33906	33906	33907
10090	9702	83	applied	\N	\N	\N	\N	33915	33915	33916
10090	9705	84	applied	\N	\N	\N	\N	33921	33921	33922
10090	9707	86	applied	\N	\N	\N	\N	33927	33927	33928
10090	9708	87	applied	\N	\N	\N	\N	33929	33929	33930
10090	9709	88	applied	\N	\N	\N	\N	33931	33931	33932
10090	9722	89	applied	\N	\N	\N	\N	33964	33964	33965
10090	9724	90	applied	\N	\N	\N	\N	33970	33970	33971
10090	9727	91	applied	\N	\N	\N	\N	33976	33976	33977
10090	9728	92	applied	\N	\N	\N	\N	33978	33978	33979
10090	9732	93	applied	\N	\N	\N	\N	33990	33990	33991
10090	9733	94	applied	\N	\N	\N	\N	33995	33995	33996
10090	9738	95	applied	\N	\N	\N	\N	34003	34003	34004
10090	9740	96	applied	\N	\N	\N	\N	34007	34007	34008
10090	9744	97	applied	\N	\N	\N	\N	34017	34017	34018
10090	9746	98	applied	\N	\N	\N	\N	34021	34021	34022
10090	9748	99	applied	\N	\N	\N	\N	34027	34027	34028
10090	9750	100	applied	\N	\N	\N	\N	34064	34064	34065
10090	9754	101	applied	\N	\N	\N	\N	34076	34076	34077
10090	9755	102	applied	\N	\N	\N	\N	34078	34078	34079
10090	9756	103	applied	\N	\N	\N	\N	34080	34080	34081
10090	9766	104	applied	\N	\N	\N	\N	34104	34104	34105
10090	9771	105	applied	\N	\N	\N	\N	34115	34115	34116
10090	9774	106	applied	\N	\N	\N	\N	34122	34122	34123
10090	9778	107	applied	\N	\N	\N	\N	34131	34131	34132
10090	9783	108	applied	\N	\N	\N	\N	34143	34143	34144
10090	9784	109	applied	\N	\N	\N	\N	34145	34145	34146
10090	9785	110	applied	\N	\N	\N	\N	34149	34149	34150
10090	9673	111	applied	\N	\N	\N	\N	33807	33807	33808
10090	9675	112	applied	\N	\N	\N	\N	33817	33817	33818
10090	9683	113	applied	\N	\N	\N	\N	33848	33848	33849
10093	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10093	9993	1	applied	\N	\N	\N	\N	34700	34700	34701
10093	9994	2	applied	\N	\N	\N	\N	34702	34702	34703
10093	9995	3	applied	\N	\N	\N	\N	34704	34704	34705
10093	9996	4	applied	\N	\N	\N	\N	34706	34706	34707
10093	9997	5	applied	\N	\N	\N	\N	34708	34708	34709
10093	9998	6	applied	\N	\N	\N	\N	34710	34710	34711
10093	9999	8	applied	\N	\N	\N	\N	34713	34713	34714
10093	10000	9	applied	\N	\N	\N	\N	34715	34715	34716
10093	10001	10	applied	\N	\N	\N	\N	34717	34717	34718
10093	10002	11	applied	\N	\N	\N	\N	34719	34719	34720
10093	10003	12	applied	\N	\N	\N	\N	34721	34721	34722
10093	10004	13	applied	\N	\N	\N	\N	34723	34723	34724
10093	10005	14	applied	\N	\N	\N	\N	34725	34725	34726
10093	10006	15	applied	\N	\N	\N	\N	34727	34727	34728
10093	10007	16	applied	\N	\N	\N	\N	34729	34729	34730
10093	10008	17	applied	\N	\N	\N	\N	34731	34731	34732
10093	10009	18	applied	\N	\N	\N	\N	34733	34733	34734
10093	10010	19	applied	\N	\N	\N	\N	34735	34735	34736
10093	10011	20	applied	\N	\N	\N	\N	34737	34737	34738
10093	10012	21	applied	\N	\N	\N	\N	34739	34739	34740
10103	10032	0	applied	\N	\N	\N	\N	34793	34793	34794
10103	10033	1	applied	\N	\N	\N	\N	34795	34795	34796
10103	10034	2	applied	\N	\N	\N	\N	34797	34797	34798
10103	10035	3	applied	\N	\N	\N	\N	34799	34799	34800
10103	10036	4	applied	\N	\N	\N	\N	34801	34801	34802
10103	10037	5	applied	\N	\N	\N	\N	34803	34803	34804
10106	10038	0	applied	\N	\N	\N	\N	34807	34807	34808
10106	10039	1	applied	\N	\N	\N	\N	34809	34809	34810
10110	10043	0	applied	\N	\N	\N	\N	34823	34823	34824
10110	10044	1	applied	\N	\N	\N	\N	34825	34825	34826
10110	10045	2	applied	\N	\N	\N	\N	34827	34827	34828
10110	10046	3	applied	\N	\N	\N	\N	34829	34829	34830
10110	10047	4	applied	\N	\N	\N	\N	34831	34831	34832
10110	10048	5	applied	\N	\N	\N	\N	34833	34833	34834
10110	10049	6	applied	\N	\N	\N	\N	34835	34835	34836
10115	10061	0	applied	\N	\N	\N	\N	34870	34870	34871
10115	10062	1	applied	\N	\N	\N	\N	34872	34872	34873
10115	10063	2	applied	\N	\N	\N	\N	34874	34874	34875
10115	10064	3	applied	\N	\N	1000000000	\N	34876	34876	34877
10115	10065	4	applied	\N	\N	1000000000	\N	34878	34878	34879
10120	10079	0	applied	\N	\N	\N	\N	34910	34910	34911
10120	10080	1	applied	\N	\N	\N	\N	34912	34912	34913
10120	10081	2	applied	\N	\N	\N	\N	34914	34914	34915
10123	10066	0	applied	\N	\N	\N	\N	34882	34882	34883
10123	10067	1	applied	\N	\N	\N	\N	34884	34884	34885
10123	10082	2	applied	\N	\N	\N	\N	34921	34921	34922
10123	10083	3	applied	\N	\N	\N	\N	34923	34923	34924
10123	10084	4	applied	\N	\N	\N	\N	34925	34925	34926
10123	10085	5	applied	\N	\N	\N	\N	34927	34927	34928
10123	9870	6	applied	\N	\N	\N	\N	34417	34417	34418
10123	10050	7	applied	\N	\N	\N	\N	34845	34845	34846
10123	9873	8	applied	\N	\N	\N	\N	34425	34425	34426
10123	10068	9	applied	\N	\N	\N	\N	34886	34886	34887
10123	10071	10	applied	\N	\N	\N	\N	34892	34892	34893
10123	10072	11	applied	\N	\N	\N	\N	34894	34894	34895
10123	10073	12	applied	\N	\N	\N	\N	34896	34896	34897
10123	10052	13	applied	\N	\N	\N	\N	34849	34849	34850
10123	10094	14	applied	\N	\N	\N	\N	34945	34945	34946
10123	10054	15	applied	\N	\N	\N	\N	34853	34853	34854
10123	10055	16	applied	\N	\N	\N	\N	34855	34855	34856
10123	10056	17	applied	\N	\N	\N	\N	34857	34857	34858
10123	9882	18	applied	\N	\N	\N	\N	34445	34445	34446
10123	9883	19	applied	\N	\N	\N	\N	34447	34447	34448
10123	9884	20	applied	\N	\N	\N	\N	34449	34449	34450
10123	9885	21	applied	\N	\N	\N	\N	34451	34451	34452
10123	9893	22	applied	\N	\N	\N	\N	34471	34471	34472
10123	9897	23	applied	\N	\N	\N	\N	34480	34480	34481
10123	9901	24	applied	\N	\N	\N	\N	34489	34489	34490
10123	9905	25	applied	\N	\N	\N	\N	34499	34499	34500
10123	9909	26	applied	\N	\N	\N	\N	34509	34509	34510
10123	9912	27	applied	\N	\N	\N	\N	34517	34517	34518
10123	9914	28	applied	\N	\N	\N	\N	34523	34523	34524
10123	9919	29	applied	\N	\N	\N	\N	34535	34535	34536
10123	9920	30	applied	\N	\N	\N	\N	34539	34539	34540
10123	9921	31	applied	\N	\N	\N	\N	34541	34541	34542
10123	9922	32	applied	\N	\N	\N	\N	34543	34543	34544
10123	9960	33	applied	\N	\N	\N	\N	34623	34623	34624
10123	9961	34	applied	\N	\N	\N	\N	34625	34625	34626
10095	10012	21	applied	\N	\N	\N	\N	34739	34739	34740
10096	10013	0	applied	\N	\N	\N	\N	34745	34745	34746
10096	10014	1	applied	\N	\N	\N	\N	34747	34747	34748
10096	10015	2	applied	\N	\N	\N	\N	34749	34749	34750
10096	10016	3	applied	\N	\N	\N	\N	34751	34751	34752
10098	10017	0	applied	\N	\N	\N	\N	34758	34758	34759
10098	10018	1	applied	\N	\N	\N	\N	34760	34760	34761
10098	10019	2	applied	\N	\N	1000000000	\N	34762	34762	34763
10099	10020	0	applied	\N	\N	\N	\N	34765	34765	34766
10099	10021	1	applied	\N	\N	\N	\N	34767	34767	34768
10099	10022	2	applied	\N	\N	\N	\N	34769	34769	34770
10099	10023	3	applied	\N	\N	\N	\N	34771	34771	34772
10099	10024	4	applied	\N	\N	\N	\N	34773	34773	34774
10099	10025	5	applied	\N	\N	\N	\N	34775	34775	34776
10099	10026	6	applied	\N	\N	\N	\N	34777	34777	34778
10099	10027	7	applied	\N	\N	\N	\N	34779	34779	34780
10099	10028	8	applied	\N	\N	\N	\N	34781	34781	34782
10099	10029	9	applied	\N	\N	\N	\N	34783	34783	34784
10109	10040	0	applied	\N	\N	\N	\N	34814	34814	34815
10109	10041	1	applied	\N	\N	\N	\N	34816	34816	34817
10109	10042	2	applied	\N	\N	\N	\N	34818	34818	34819
10112	9992	0	applied	\N	\N	\N	\N	34698	34698	34699
10112	9993	1	applied	\N	\N	\N	\N	34700	34700	34701
10112	10020	2	applied	\N	\N	\N	\N	34765	34765	34766
10112	9980	3	applied	\N	\N	\N	\N	34672	34672	34841
10112	10013	4	applied	\N	\N	\N	\N	34745	34745	34746
10112	10014	5	applied	\N	\N	\N	\N	34747	34747	34748
10112	10015	6	applied	\N	\N	\N	\N	34749	34749	34750
10112	9880	7	applied	\N	\N	\N	\N	34441	34441	34442
10112	10039	8	applied	\N	\N	\N	\N	34809	34809	34810
10112	10025	9	applied	\N	\N	\N	\N	34775	34775	34776
10112	10032	10	applied	\N	\N	\N	\N	34793	34793	34794
10112	10041	11	applied	\N	\N	\N	\N	34816	34816	34817
10112	9842	12	applied	\N	\N	\N	\N	34341	34341	34342
10112	9843	13	applied	\N	\N	\N	\N	34343	34343	34344
10112	9923	14	applied	\N	\N	\N	\N	34545	34545	34546
10112	9924	15	applied	\N	\N	\N	\N	34547	34547	34548
10112	9925	16	applied	\N	\N	\N	\N	34549	34549	34550
10112	9926	17	applied	\N	\N	\N	\N	34551	34551	34552
10112	9831	18	applied	\N	\N	\N	\N	34313	34313	34314
10112	10042	19	applied	\N	\N	\N	\N	34818	34818	34819
10112	9832	20	applied	\N	\N	\N	\N	34315	34315	34392
10112	9864	21	applied	\N	\N	\N	\N	34405	34405	34406
10112	9846	22	applied	\N	\N	\N	\N	34352	34352	34353
10112	9847	23	applied	\N	\N	\N	\N	34354	34354	34355
10112	9811	24	applied	\N	\N	\N	\N	34222	34222	34223
10112	9813	25	applied	\N	\N	\N	\N	34256	34256	34257
10112	9848	26	applied	\N	\N	\N	\N	34356	34356	34357
10112	9849	27	applied	\N	\N	\N	\N	34358	34358	34359
10112	9850	28	applied	\N	\N	\N	\N	34360	34360	34361
10112	9851	29	applied	\N	\N	\N	\N	34362	34362	34363
10112	9852	30	applied	\N	\N	\N	\N	34364	34364	34365
10112	9853	31	applied	\N	\N	\N	\N	34366	34366	34367
10112	9927	32	applied	\N	\N	\N	\N	34553	34553	34554
10112	9928	33	applied	\N	\N	\N	\N	34555	34555	34556
10112	9929	34	applied	\N	\N	\N	\N	34557	34557	34558
10112	9930	35	applied	\N	\N	\N	\N	34559	34559	34560
10112	9931	36	applied	\N	\N	\N	\N	34561	34561	34562
10112	9932	37	applied	\N	\N	\N	\N	34563	34563	34564
10112	9933	38	applied	\N	\N	\N	\N	34565	34565	34566
10112	9934	39	applied	\N	\N	\N	\N	34567	34567	34568
10112	9935	40	applied	\N	\N	\N	\N	34569	34569	34570
10112	9936	41	applied	\N	\N	\N	\N	34571	34571	34572
10112	9937	42	applied	\N	\N	\N	\N	34573	34573	34574
10112	9938	43	applied	\N	\N	\N	\N	34575	34575	34576
10112	9939	44	applied	\N	\N	\N	\N	34577	34577	34578
10112	9940	45	applied	\N	\N	\N	\N	34579	34579	34580
10112	9941	46	applied	\N	\N	\N	\N	34581	34581	34582
10112	9947	47	applied	\N	\N	\N	\N	34597	34597	34598
10112	9948	48	applied	\N	\N	\N	\N	34599	34599	34600
10112	9949	49	applied	\N	\N	\N	\N	34601	34601	34602
10112	9950	50	applied	\N	\N	\N	\N	34603	34603	34604
10112	9951	51	applied	\N	\N	\N	\N	34605	34605	34606
10112	9952	52	applied	\N	\N	\N	\N	34607	34607	34608
10112	9953	53	applied	\N	\N	\N	\N	34609	34609	34610
10112	9954	54	applied	\N	\N	\N	\N	34611	34611	34612
10112	9955	55	applied	\N	\N	\N	\N	34613	34613	34614
10112	9956	56	applied	\N	\N	\N	\N	34615	34615	34616
10112	9957	57	applied	\N	\N	\N	\N	34617	34617	34618
10112	9958	58	applied	\N	\N	\N	\N	34619	34619	34620
10112	9959	59	applied	\N	\N	\N	\N	34621	34621	34622
10112	9854	60	applied	\N	\N	\N	\N	34368	34368	34369
10112	9809	61	applied	\N	\N	\N	\N	34216	34216	34217
10112	9810	62	applied	\N	\N	\N	\N	34220	34220	34221
10112	9812	63	applied	\N	\N	\N	\N	34254	34254	34255
10112	9814	64	applied	\N	\N	\N	\N	34262	34262	34263
10112	9816	65	applied	\N	\N	\N	\N	34270	34270	34271
10112	9818	66	applied	\N	\N	\N	\N	34276	34276	34277
10112	9821	67	applied	\N	\N	\N	\N	34286	34286	34287
10112	9822	68	applied	\N	\N	\N	\N	34288	34288	34289
10112	9823	69	applied	\N	\N	\N	\N	34291	34291	34292
10112	9827	70	applied	\N	\N	\N	\N	34302	34302	34303
10112	9829	71	applied	\N	\N	\N	\N	34309	34309	34310
10112	9830	72	applied	\N	\N	\N	\N	34311	34311	34312
10112	9840	73	applied	\N	\N	\N	\N	34331	34331	34332
10112	9844	74	applied	\N	\N	\N	\N	34345	34345	34346
10112	9845	75	applied	\N	\N	\N	\N	34350	34350	34351
10112	9856	76	applied	\N	\N	\N	\N	34376	34376	34377
10112	9860	77	applied	\N	\N	\N	\N	34397	34397	34398
10112	9861	78	applied	\N	\N	\N	\N	34399	34399	34400
10112	9815	79	applied	\N	\N	\N	\N	34264	34264	34265
10112	9817	80	applied	\N	\N	\N	\N	34272	34272	34273
10112	9819	81	applied	\N	\N	\N	\N	34282	34282	34283
10112	9820	82	applied	\N	\N	\N	\N	34284	34284	34285
10112	9824	83	applied	\N	\N	\N	\N	34293	34293	34294
10112	9826	84	applied	\N	\N	\N	\N	34300	34300	34301
10112	9828	85	applied	\N	\N	\N	\N	34307	34307	34308
10112	9833	86	applied	\N	\N	1000000000	\N	34317	34317	34318
10112	9834	87	applied	\N	\N	1000000000	\N	34319	34319	34320
10112	9835	88	applied	\N	\N	\N	\N	34321	34321	34322
10112	9836	89	applied	\N	\N	1000000000	\N	34323	34323	34324
10112	9837	90	applied	\N	\N	1000000000	\N	34325	34325	34326
10112	9838	91	applied	\N	\N	\N	\N	34327	34327	34328
10112	9839	92	applied	\N	\N	\N	\N	34329	34329	34330
10112	9841	93	applied	\N	\N	\N	\N	34339	34339	34340
10112	9855	94	applied	\N	\N	\N	\N	34374	34374	34375
10112	9862	95	applied	\N	\N	\N	\N	34401	34401	34402
10112	9863	96	applied	\N	\N	1000000000	\N	34403	34403	34404
10112	9865	97	applied	\N	\N	\N	\N	34407	34407	34408
10112	9866	98	applied	\N	\N	1000000000	\N	34409	34409	34410
10112	9867	99	applied	\N	\N	\N	\N	34411	34411	34412
10112	9868	100	applied	\N	\N	\N	\N	34413	34413	34414
10112	9874	101	applied	\N	\N	\N	\N	34427	34427	34428
10112	9886	102	applied	\N	\N	\N	\N	34453	34453	34454
10112	9887	103	applied	\N	\N	\N	\N	34455	34455	34456
10112	9888	104	applied	\N	\N	\N	\N	34457	34457	34458
10112	9894	105	applied	\N	\N	\N	\N	34473	34473	34474
10112	9898	106	applied	\N	\N	\N	\N	34482	34482	34483
10112	9899	107	applied	\N	\N	1000000000	\N	34484	34484	34485
10112	9900	108	applied	\N	\N	\N	\N	34487	34487	34488
10112	9906	109	applied	\N	\N	\N	\N	34501	34501	34502
10112	9907	110	applied	\N	\N	\N	\N	34505	34505	34506
10112	9911	111	applied	\N	\N	\N	\N	34515	34515	34516
10112	9913	112	applied	\N	\N	\N	\N	34521	34521	34522
10112	9918	113	applied	\N	\N	\N	\N	34533	34533	34534
10112	9942	115	applied	\N	\N	\N	\N	34583	34583	34584
10112	9943	116	applied	\N	\N	\N	\N	34585	34585	34586
10112	9944	117	applied	\N	\N	1000000000	\N	34587	34587	34588
10112	9945	118	applied	\N	\N	\N	\N	34589	34589	34590
10112	9946	119	applied	\N	\N	\N	\N	34595	34595	34596
10112	9962	120	applied	\N	\N	\N	\N	34627	34627	34628
10112	9972	121	applied	\N	\N	\N	\N	34650	34650	34651
10112	9982	122	applied	\N	\N	\N	\N	34676	34676	34677
10112	9995	123	applied	\N	\N	\N	\N	34704	34704	34705
10112	10045	124	applied	\N	\N	\N	\N	34827	34827	34828
10112	9869	125	applied	\N	\N	\N	\N	34415	34415	34416
10114	10050	0	applied	\N	\N	\N	\N	34845	34845	34846
10114	10051	1	applied	\N	\N	\N	\N	34847	34847	34848
10114	10052	2	applied	\N	\N	\N	\N	34849	34849	34850
10114	10053	3	applied	\N	\N	\N	\N	34851	34851	34852
10114	10054	4	applied	\N	\N	\N	\N	34853	34853	34854
10114	10055	5	applied	\N	\N	\N	\N	34855	34855	34856
10114	10056	6	applied	\N	\N	\N	\N	34857	34857	34858
10114	10057	7	applied	\N	\N	\N	\N	34859	34859	34860
10114	10058	8	applied	\N	\N	\N	\N	34861	34861	34862
10114	10059	9	applied	\N	\N	\N	\N	34863	34863	34864
10114	10060	10	applied	\N	\N	\N	\N	34865	34865	34866
10116	10066	0	applied	\N	\N	\N	\N	34882	34882	34883
10116	10067	1	applied	\N	\N	\N	\N	34884	34884	34885
10116	10068	2	applied	\N	\N	\N	\N	34886	34886	34887
10116	10069	3	applied	\N	\N	1000000000	\N	34888	34888	34889
10116	10070	4	applied	\N	\N	\N	\N	34890	34890	34891
10116	10071	5	applied	\N	\N	\N	\N	34892	34892	34893
10116	10072	6	applied	\N	\N	\N	\N	34894	34894	34895
10116	10073	7	applied	\N	\N	\N	\N	34896	34896	34897
10116	10074	8	applied	\N	\N	\N	\N	34898	34898	34899
10116	10075	9	applied	\N	\N	1000000000	\N	34900	34900	34901
10122	10082	0	applied	\N	\N	\N	\N	34921	34921	34922
10122	10083	1	applied	\N	\N	\N	\N	34923	34923	34924
10122	10084	2	applied	\N	\N	\N	\N	34925	34925	34926
10122	10085	3	applied	\N	\N	\N	\N	34927	34927	34928
10122	10086	4	applied	\N	\N	\N	\N	34929	34929	34930
10122	10087	5	applied	\N	\N	\N	\N	34931	34931	34932
10122	10088	6	applied	\N	\N	\N	\N	34933	34933	34934
10122	10089	7	applied	\N	\N	\N	\N	34935	34935	34936
10122	10090	8	applied	\N	\N	\N	\N	34937	34937	34938
10122	10091	9	applied	\N	\N	\N	\N	34939	34939	34940
10122	10092	10	applied	\N	\N	\N	\N	34941	34941	34942
10122	10093	11	applied	\N	\N	\N	\N	34943	34943	34944
10122	10094	12	applied	\N	\N	\N	\N	34945	34945	34946
10125	10098	0	applied	\N	\N	\N	\N	34956	34956	34957
10125	10097	1	applied	\N	\N	\N	\N	34953	34953	34954
10133	10105	0	applied	\N	\N	\N	\N	34986	34986	34987
10133	10108	1	applied	\N	\N	\N	\N	34993	34993	34994
10133	10106	2	applied	\N	\N	\N	\N	34988	34988	34989
10138	10109	0	applied	\N	\N	\N	\N	34996	34996	34997
10138	10110	1	applied	\N	\N	\N	\N	34998	34998	34999
10138	10111	2	applied	\N	\N	\N	\N	35000	35000	35001
10138	10107	3	applied	\N	\N	\N	\N	34990	34990	34991
10138	10112	4	applied	\N	\N	\N	\N	35002	35002	35003
10138	10113	5	applied	\N	\N	\N	\N	35004	35004	35005
10142	10118	0	applied	\N	\N	\N	\N	35115	35115	35116
10142	10119	1	applied	\N	\N	\N	\N	35117	35117	35118
10142	10120	2	applied	\N	\N	\N	\N	35119	35119	35120
10143	10121	0	applied	\N	\N	\N	\N	35123	35123	35124
10143	10122	1	applied	\N	\N	\N	\N	35125	35125	35126
10143	10123	2	applied	\N	\N	\N	\N	35127	35127	35128
10143	10124	3	applied	\N	\N	\N	\N	35129	35129	35130
10143	10125	4	applied	\N	\N	\N	\N	35131	35131	35132
10143	10126	5	applied	\N	\N	\N	\N	35133	35133	35134
10148	10129	0	applied	\N	\N	\N	\N	35146	35146	35147
10148	10130	1	applied	\N	\N	\N	\N	35148	35148	35149
10153	10133	0	applied	\N	\N	\N	\N	35160	35160	35161
10153	10134	1	applied	\N	\N	\N	\N	35162	35162	35163
10158	10139	0	applied	\N	\N	\N	\N	35178	35178	35179
10158	10140	1	applied	\N	\N	\N	\N	35180	35180	35181
10163	10143	0	applied	\N	\N	\N	\N	35197	35197	35198
10163	10144	1	applied	\N	\N	\N	\N	35199	35199	35200
10163	10145	2	applied	\N	\N	\N	\N	35201	35201	35202
10163	10146	3	applied	\N	\N	\N	\N	35203	35203	35204
10163	10147	4	applied	\N	\N	\N	\N	35205	35205	35206
10163	10148	5	applied	\N	\N	\N	\N	35207	35207	35208
10163	10149	6	applied	\N	\N	\N	\N	35209	35209	35210
10163	10150	7	applied	\N	\N	\N	\N	35211	35211	35212
10163	10151	8	applied	\N	\N	\N	\N	35213	35213	35214
10163	10152	9	applied	\N	\N	\N	\N	35215	35215	35216
10163	10153	10	applied	\N	\N	\N	\N	35217	35217	35218
10163	10154	11	applied	\N	\N	\N	\N	35219	35219	35220
10168	10157	0	applied	\N	\N	\N	\N	35230	35230	35231
10168	10158	1	applied	\N	\N	\N	\N	35232	35232	35233
10173	10160	0	applied	\N	\N	\N	\N	35241	35241	35242
10173	10161	1	applied	\N	\N	\N	\N	35244	35244	35245
10173	10162	2	applied	\N	\N	\N	\N	35246	35246	35247
10173	10163	3	applied	\N	\N	\N	\N	35248	35248	35249
10173	10164	4	applied	\N	\N	\N	\N	35250	35250	35251
10173	10165	5	applied	\N	\N	\N	\N	35252	35252	35253
10173	10166	6	applied	\N	\N	\N	\N	35254	35254	35255
10173	10167	7	applied	\N	\N	\N	\N	35256	35256	35257
10173	10168	8	applied	\N	\N	\N	\N	35258	35258	35259
10173	10169	9	applied	\N	\N	\N	\N	35260	35260	35261
10173	10170	10	applied	\N	\N	\N	\N	35262	35262	35263
10173	10171	11	applied	\N	\N	\N	\N	35264	35264	35265
10173	10172	12	applied	\N	\N	\N	\N	35266	35266	35267
10173	10173	13	applied	\N	\N	\N	\N	35268	35268	35269
10173	10174	14	applied	\N	\N	\N	\N	35270	35270	35271
10173	10175	15	applied	\N	\N	\N	\N	35272	35272	35273
10173	10176	16	applied	\N	\N	\N	\N	35274	35274	35275
10174	10177	0	applied	\N	\N	\N	\N	35277	35277	35278
10117	10077	1	applied	\N	\N	\N	\N	34904	34904	34905
10117	10078	2	applied	\N	\N	\N	\N	34906	34906	34907
10119	10079	0	applied	\N	\N	\N	\N	34910	34910	34911
10119	10080	1	applied	\N	\N	\N	\N	34912	34912	34913
10119	10081	2	applied	\N	\N	\N	\N	34914	34914	34915
10129	10104	0	applied	\N	\N	\N	\N	34981	34981	34982
10129	10103	1	applied	\N	\N	\N	\N	34978	34978	34979
10131	10105	0	applied	\N	\N	\N	\N	34986	34986	34987
10131	10106	1	applied	\N	\N	\N	\N	34988	34988	34989
10131	10107	2	applied	\N	\N	\N	\N	34990	34990	34991
10136	10114	0	applied	\N	\N	\N	\N	35008	35008	35009
10136	10115	1	applied	\N	\N	\N	\N	35010	35010	35011
10136	10116	2	applied	\N	\N	\N	\N	35012	35012	35013
10136	10117	3	applied	\N	\N	\N	\N	35014	35014	35015
10139	10114	0	applied	\N	\N	\N	\N	35008	35008	35009
10139	10115	1	applied	\N	\N	\N	\N	35010	35010	35011
10139	10116	2	applied	\N	\N	\N	\N	35012	35012	35013
10139	10117	3	applied	\N	\N	\N	\N	35014	35014	35015
10144	10127	0	applied	\N	\N	\N	\N	35137	35137	35138
10144	10128	1	applied	\N	\N	\N	\N	35139	35139	35140
10149	10129	0	applied	\N	\N	\N	\N	35146	35146	35147
10149	10130	1	applied	\N	\N	\N	\N	35148	35148	35149
10154	10133	0	applied	\N	\N	\N	\N	35160	35160	35161
10154	10134	1	applied	\N	\N	\N	\N	35162	35162	35163
10155	10135	0	applied	\N	\N	\N	\N	35168	35168	35169
10155	10136	1	applied	\N	\N	\N	\N	35170	35170	35171
10155	10137	2	applied	\N	\N	\N	\N	35172	35172	35173
10155	10138	3	applied	\N	\N	\N	\N	35174	35174	35175
10159	10139	0	applied	\N	\N	\N	\N	35178	35178	35179
10159	10140	1	applied	\N	\N	\N	\N	35180	35180	35181
10162	10141	0	applied	\N	\N	\N	\N	35189	35189	35190
10162	10142	1	applied	\N	\N	\N	\N	35191	35191	35192
10167	10157	0	applied	\N	\N	\N	\N	35230	35230	35231
10167	10158	1	applied	\N	\N	\N	\N	35232	35232	35233
10172	10159	0	applied	\N	\N	\N	\N	35239	35239	35240
10178	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10178	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10178	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10178	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10183	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10183	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10183	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10183	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10187	10185	0	applied	\N	\N	\N	\N	35311	35311	35312
10187	10186	1	applied	\N	\N	\N	\N	35313	35313	35314
10188	10187	0	applied	\N	\N	\N	\N	35318	35318	35319
10188	10188	1	applied	\N	\N	\N	\N	35320	35320	35321
10188	10189	2	applied	\N	\N	1000000000	\N	35322	35322	35323
10188	10190	3	applied	\N	\N	\N	\N	35324	35324	35325
10188	10191	4	applied	\N	\N	\N	\N	35326	35326	35327
10194	10199	0	applied	\N	\N	\N	\N	35351	35351	35352
10194	10200	1	applied	\N	\N	\N	\N	35353	35353	35354
10194	10201	2	applied	\N	\N	\N	\N	35355	35355	35356
10194	10202	3	applied	\N	\N	\N	\N	35357	35357	35358
10199	10205	0	applied	\N	\N	\N	\N	35371	35371	35372
10199	10206	1	applied	\N	\N	\N	\N	35373	35373	35374
10200	10207	0	applied	\N	\N	\N	\N	35375	35375	35376
10200	10208	1	applied	\N	\N	\N	\N	35377	35377	35378
10205	10213	0	applied	\N	\N	\N	\N	35396	35396	35397
10205	10214	1	applied	\N	\N	\N	\N	35398	35398	35399
10210	10217	0	applied	\N	\N	\N	\N	35412	35412	35413
10210	10218	1	applied	\N	\N	\N	\N	35414	35414	35415
10210	10219	2	applied	\N	\N	\N	\N	35416	35416	35417
10212	10220	0	applied	\N	\N	\N	\N	35420	35420	35421
10212	10221	1	applied	\N	\N	\N	\N	35422	35422	35423
10212	10222	2	applied	\N	\N	\N	\N	35424	35424	35425
10212	10223	3	applied	\N	\N	\N	\N	35426	35426	35427
10212	10224	4	applied	\N	\N	\N	\N	35428	35428	35429
10212	10225	5	applied	\N	\N	\N	\N	35430	35430	35431
10216	10226	0	applied	\N	\N	\N	\N	35436	35436	35437
10216	10227	1	applied	\N	\N	\N	\N	35438	35438	35439
10228	10242	0	applied	\N	\N	\N	\N	35495	35495	35496
10229	10243	0	applied	\N	\N	\N	\N	35503	35503	35504
10229	10244	1	applied	\N	\N	\N	\N	35505	35505	35506
10229	10245	2	applied	\N	\N	\N	\N	35507	35507	35508
10229	10246	3	applied	\N	\N	\N	\N	35509	35509	35510
10230	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
10230	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
10230	9992	2	applied	\N	\N	\N	\N	34698	34698	34699
10230	10109	3	applied	\N	\N	\N	\N	35018	35018	34997
10230	9993	4	applied	\N	\N	\N	\N	34700	34700	34701
10230	10020	5	applied	\N	\N	\N	\N	34765	34765	34766
10230	9226	6	applied	\N	\N	\N	\N	32585	32585	32586
10230	10066	7	applied	\N	\N	\N	\N	34882	34882	34883
10230	10067	8	applied	\N	\N	\N	\N	34884	34884	34885
10230	10082	9	applied	\N	\N	\N	\N	34921	34921	34922
10230	10192	10	applied	\N	\N	\N	\N	35334	35334	35335
10230	10114	11	applied	\N	\N	\N	\N	35019	35019	35009
10230	9980	12	applied	\N	\N	\N	\N	34672	34672	35020
10230	10115	13	applied	\N	\N	\N	\N	35021	35021	35011
10230	9576	14	applied	\N	\N	\N	\N	33514	33514	33515
10230	9591	16	applied	\N	\N	\N	\N	33751	33751	33555
10230	9592	17	applied	\N	\N	\N	\N	33752	33752	33557
10230	9593	18	applied	\N	\N	\N	\N	33753	33753	33559
10230	10083	19	applied	\N	\N	\N	\N	34923	34923	34924
10230	10013	20	applied	\N	\N	\N	\N	34745	34745	34746
10230	10014	21	applied	\N	\N	\N	\N	34747	34747	34748
10230	9091	22	applied	\N	\N	1000000000	\N	32205	32205	32206
10230	9148	23	applied	\N	\N	\N	\N	32368	32368	32369
10230	9157	24	applied	\N	\N	\N	\N	32408	32408	32409
10230	9158	25	applied	\N	\N	\N	\N	32410	32410	32411
10230	9159	26	applied	\N	\N	\N	\N	32412	32412	32413
10230	10015	27	applied	\N	\N	\N	\N	34749	34749	34750
10230	9402	28	applied	\N	\N	\N	\N	33020	33020	33021
10230	9403	29	applied	\N	\N	\N	\N	33024	33024	33025
10230	9404	30	applied	\N	\N	\N	\N	33026	33026	33027
10230	9405	31	applied	\N	\N	\N	\N	33028	33028	33029
10230	9416	32	applied	\N	\N	\N	\N	33050	33050	33051
10230	9639	33	applied	\N	\N	\N	\N	33690	33690	33691
10230	9473	34	applied	\N	\N	\N	\N	33209	33209	33210
10230	9174	35	applied	\N	\N	\N	\N	32447	32447	32448
10230	9276	36	applied	\N	\N	1000000000	\N	32715	32715	32716
10230	9293	37	applied	\N	\N	\N	\N	32998	32998	32762
10230	9294	38	applied	\N	\N	\N	\N	32999	32999	32764
10230	9029	39	applied	\N	\N	\N	\N	32026	32026	32027
10230	9189	40	applied	\N	\N	\N	\N	32483	32483	32484
10230	9075	41	applied	\N	\N	\N	\N	32160	32160	32161
10230	9108	42	applied	\N	\N	\N	\N	32244	32244	32245
10230	9331	43	applied	\N	\N	\N	\N	35514	35514	32855
10123	9969	35	applied	\N	\N	\N	\N	34644	34644	34645
10123	9983	36	applied	\N	\N	\N	\N	34678	34678	34679
10123	9996	37	applied	\N	\N	\N	\N	34706	34706	34707
10123	9997	38	applied	\N	\N	\N	\N	34708	34708	34709
10123	10062	39	applied	\N	\N	1000000000	\N	34872	34872	34950
10123	9889	40	applied	\N	\N	\N	\N	34459	34459	34460
10123	9890	41	applied	\N	\N	\N	\N	34461	34461	34462
10123	9891	42	applied	\N	\N	\N	\N	34463	34463	34464
10123	10095	43	applied	\N	\N	\N	\N	34491	34491	34772
10123	10096	44	applied	\N	\N	\N	\N	34493	34493	34780
10123	9904	45	applied	\N	\N	\N	\N	34495	34495	34496
10123	10023	46	applied	\N	\N	\N	\N	34771	34771	34951
10123	10027	47	applied	\N	\N	\N	\N	34779	34779	34952
10123	9875	48	applied	\N	\N	\N	\N	34429	34429	34430
10123	9876	49	applied	\N	\N	\N	\N	34431	34431	34432
10123	9877	50	applied	\N	\N	\N	\N	34433	34433	34434
10123	10016	51	applied	\N	\N	\N	\N	34751	34751	34752
10123	10018	52	applied	\N	\N	\N	\N	34760	34760	34761
10123	10021	53	applied	\N	\N	\N	\N	34767	34767	34768
10123	10022	54	applied	\N	\N	\N	\N	34769	34769	34770
10123	10028	55	applied	\N	\N	\N	\N	34781	34781	34782
10123	10029	56	applied	\N	\N	\N	\N	34783	34783	34784
10123	10030	57	applied	\N	\N	\N	\N	34786	34786	34787
10123	10031	58	applied	\N	\N	\N	\N	34790	34790	34791
10123	10033	59	applied	\N	\N	\N	\N	34795	34795	34796
10123	10034	60	applied	\N	\N	\N	\N	34797	34797	34798
10123	10038	61	applied	\N	\N	\N	\N	34807	34807	34808
10123	10040	62	applied	\N	\N	\N	\N	34814	34814	34815
10123	10043	63	applied	\N	\N	\N	\N	34823	34823	34824
10123	10044	64	applied	\N	\N	\N	\N	34825	34825	34826
10123	10051	65	applied	\N	\N	\N	\N	34847	34847	34848
10123	10053	66	applied	\N	\N	\N	\N	34851	34851	34852
10123	10061	67	applied	\N	\N	\N	\N	34870	34870	34871
10123	10074	68	applied	\N	\N	\N	\N	34898	34898	34899
10123	10077	69	applied	\N	\N	\N	\N	34904	34904	34905
10123	10079	70	applied	\N	\N	\N	\N	34910	34910	34911
10123	10086	71	applied	\N	\N	\N	\N	34929	34929	34930
10123	10087	72	applied	\N	\N	\N	\N	34931	34931	34932
10123	10088	73	applied	\N	\N	\N	\N	34933	34933	34934
10123	10092	74	applied	\N	\N	\N	\N	34941	34941	34942
10123	10097	75	applied	\N	\N	\N	\N	34953	34953	34954
10123	9825	76	applied	\N	\N	\N	\N	34295	34295	34316
10123	9963	77	applied	\N	\N	\N	\N	34629	34629	34630
10123	9964	78	applied	\N	\N	\N	\N	34631	34631	34632
10123	9965	79	applied	\N	\N	\N	\N	34633	34633	34634
10123	9966	80	applied	\N	\N	\N	\N	34635	34635	34636
10123	9970	81	applied	\N	\N	\N	\N	34646	34646	34647
10123	9971	82	applied	\N	\N	\N	\N	34648	34648	34649
10123	9973	83	applied	\N	\N	\N	\N	34652	34652	34653
10123	9974	84	applied	\N	\N	\N	\N	34654	34654	34655
10123	9975	85	applied	\N	\N	\N	\N	34656	34656	34657
10123	9976	86	applied	\N	\N	\N	\N	34658	34658	34659
10123	9977	87	applied	\N	\N	\N	\N	34660	34660	34661
10123	9978	88	applied	\N	\N	\N	\N	34662	34662	34663
10123	9979	89	applied	\N	\N	\N	\N	34664	34664	34665
10123	9981	90	applied	\N	\N	\N	\N	34674	34674	34675
10123	9984	91	applied	\N	\N	\N	\N	34680	34680	34681
10123	9985	92	applied	\N	\N	\N	\N	34682	34682	34683
10123	9986	93	applied	\N	\N	\N	\N	34684	34684	34685
10123	9987	94	applied	\N	\N	\N	\N	34686	34686	34687
10123	9988	95	applied	\N	\N	\N	\N	34688	34688	34689
10123	9989	96	applied	\N	\N	\N	\N	34690	34690	34691
10123	9990	97	applied	\N	\N	\N	\N	34692	34692	34693
10123	9991	98	applied	\N	\N	\N	\N	34694	34694	34695
10123	9998	99	applied	\N	\N	\N	\N	34710	34710	34711
10123	9999	100	applied	\N	\N	\N	\N	34713	34713	34714
10123	10000	101	applied	\N	\N	\N	\N	34715	34715	34716
10123	10001	102	applied	\N	\N	\N	\N	34717	34717	34718
10123	10002	103	applied	\N	\N	\N	\N	34719	34719	34720
10123	10003	104	applied	\N	\N	\N	\N	34721	34721	34722
10123	10004	105	applied	\N	\N	\N	\N	34723	34723	34724
10123	10005	106	applied	\N	\N	\N	\N	34725	34725	34726
10123	10006	107	applied	\N	\N	\N	\N	34727	34727	34728
10123	10007	108	applied	\N	\N	\N	\N	34729	34729	34730
10123	9878	109	applied	\N	\N	\N	\N	34435	34435	34436
10123	10063	110	applied	\N	\N	\N	\N	34874	34874	34875
10123	10064	111	applied	\N	\N	1000000000	\N	34876	34876	34877
10123	10065	112	applied	\N	\N	1000000000	\N	34878	34878	34879
10123	10069	113	applied	\N	\N	1000000000	\N	34888	34888	34889
10123	10070	115	applied	\N	\N	\N	\N	34890	34890	34891
10123	10078	116	applied	\N	\N	\N	\N	34906	34906	34907
10123	10080	117	applied	\N	\N	\N	\N	34912	34912	34913
10123	10081	118	applied	\N	\N	\N	\N	34914	34914	34915
10123	10089	119	applied	\N	\N	\N	\N	34935	34935	34936
10123	10090	120	applied	\N	\N	\N	\N	34937	34937	34938
10123	10091	121	applied	\N	\N	\N	\N	34939	34939	34940
10123	10093	122	applied	\N	\N	\N	\N	34943	34943	34944
10123	10098	123	applied	\N	\N	\N	\N	34956	34956	34957
10123	10046	124	applied	\N	\N	\N	\N	34829	34829	34830
10123	10047	125	applied	\N	\N	\N	\N	34831	34831	34832
10126	10098	0	applied	\N	\N	\N	\N	34956	34956	34957
10126	10097	1	applied	\N	\N	\N	\N	34953	34953	34954
10127	10099	0	applied	\N	\N	\N	\N	34968	34968	34969
10127	10100	1	applied	\N	\N	\N	\N	34970	34970	34971
10127	10101	2	applied	\N	\N	\N	\N	34972	34972	34973
10127	10102	3	applied	\N	\N	1000000000	\N	34974	34974	34975
10132	10105	0	applied	\N	\N	\N	\N	34986	34986	34987
10132	10108	1	applied	\N	\N	\N	\N	34993	34993	34994
10132	10106	2	applied	\N	\N	\N	\N	34988	34988	34989
10132	10107	3	applied	\N	\N	\N	\N	34990	34990	34991
10134	10109	0	applied	\N	\N	\N	\N	34996	34996	34997
10134	10110	1	applied	\N	\N	\N	\N	34998	34998	34999
10134	10111	2	applied	\N	\N	\N	\N	35000	35000	35001
10134	10107	3	applied	\N	\N	\N	\N	34990	34990	34991
10134	10112	4	applied	\N	\N	\N	\N	35002	35002	35003
10134	10113	5	applied	\N	\N	\N	\N	35004	35004	35005
10140	9329	0	applied	\N	\N	\N	\N	32852	32852	31282
10140	9330	1	applied	\N	\N	\N	\N	32853	32853	32853
10140	9110	2	applied	\N	\N	\N	\N	32253	32253	32205
10140	9148	3	applied	\N	\N	\N	\N	32368	32368	32369
10140	9157	4	applied	\N	\N	\N	\N	32408	32408	32409
10140	9158	5	applied	\N	\N	\N	\N	32410	32410	32411
10140	9159	6	applied	\N	\N	\N	\N	32412	32412	32413
10140	9226	7	applied	\N	\N	\N	\N	32585	32585	32586
10140	9576	8	applied	\N	\N	\N	\N	33514	33514	33515
10140	9591	9	applied	\N	\N	\N	\N	33751	33751	33555
10140	9592	10	applied	\N	\N	\N	\N	33752	33752	33557
10140	9593	11	applied	\N	\N	\N	\N	33753	33753	33559
10140	9402	12	applied	\N	\N	\N	\N	33020	33020	33021
10137	10020	3	applied	\N	\N	\N	\N	34765	34765	34766
10137	10066	4	applied	\N	\N	\N	\N	34882	34882	34883
10137	10067	5	applied	\N	\N	\N	\N	34884	34884	34885
10137	10082	6	applied	\N	\N	\N	\N	34921	34921	34922
10137	10114	7	applied	\N	\N	\N	\N	35019	35019	35009
10137	9980	8	applied	\N	\N	\N	\N	34672	34672	35020
10137	10115	9	applied	\N	\N	\N	\N	35021	35021	35011
10137	10083	10	applied	\N	\N	\N	\N	34923	34923	34924
10137	10013	11	applied	\N	\N	\N	\N	34745	34745	34746
10137	10014	12	applied	\N	\N	\N	\N	34747	34747	34748
10137	10015	13	applied	\N	\N	\N	\N	34749	34749	34750
10137	10068	14	applied	\N	\N	\N	\N	35022	35022	34887
10137	9767	15	applied	\N	\N	\N	\N	34106	34106	34107
10137	9880	16	applied	\N	\N	\N	\N	34667	34667	34442
10137	10039	17	applied	\N	\N	\N	\N	35023	35023	35024
10137	10025	18	applied	\N	\N	\N	\N	35025	35025	34776
10137	10032	19	applied	\N	\N	\N	\N	35026	35026	34794
10137	10041	20	applied	\N	\N	\N	\N	35027	35027	34817
10137	9842	21	applied	\N	\N	\N	\N	34341	34341	34342
10137	9843	23	applied	\N	\N	\N	\N	34343	34343	34344
10137	10071	24	applied	\N	\N	\N	\N	35029	35029	34893
10137	10072	25	applied	\N	\N	\N	\N	35030	35030	34895
10137	9923	26	applied	\N	\N	\N	\N	35031	35031	34546
10137	9924	27	applied	\N	\N	\N	\N	35032	35032	34548
10137	9925	28	applied	\N	\N	\N	\N	35033	35033	34550
10137	9926	29	applied	\N	\N	\N	\N	35034	35034	34552
10137	9831	30	applied	\N	\N	\N	\N	34313	34313	35035
10137	10042	31	applied	\N	\N	\N	\N	35036	35036	34819
10137	9832	32	applied	\N	\N	\N	\N	35037	35037	34392
10137	9768	33	applied	\N	\N	\N	\N	34108	34108	34109
10137	9769	34	applied	\N	\N	\N	\N	34111	34111	34112
10137	9864	35	applied	\N	\N	\N	\N	34405	34405	35038
10137	9846	36	applied	\N	\N	\N	\N	34352	34352	34353
10137	9847	37	applied	\N	\N	\N	\N	34354	34354	34355
10137	9772	38	applied	\N	\N	\N	\N	34117	34117	34118
10137	9848	39	applied	\N	\N	\N	\N	34356	34356	34357
10137	9849	40	applied	\N	\N	\N	\N	34358	34358	34359
10137	9850	41	applied	\N	\N	\N	\N	34360	34360	34361
10137	9851	42	applied	\N	\N	\N	\N	34362	34362	34363
10137	9852	43	applied	\N	\N	\N	\N	34364	34364	34365
10137	9853	44	applied	\N	\N	\N	\N	34366	34366	34367
10137	10094	45	applied	\N	\N	\N	\N	35039	35039	34946
10137	10099	46	applied	\N	\N	\N	\N	35040	35040	34969
10137	10106	47	applied	\N	\N	\N	\N	35041	35041	34989
10137	9927	48	applied	\N	\N	\N	\N	35042	35042	34554
10137	9928	49	applied	\N	\N	\N	\N	35043	35043	34556
10137	9929	50	applied	\N	\N	\N	\N	35044	35044	34558
10137	9930	51	applied	\N	\N	\N	\N	35045	35045	34560
10137	9931	52	applied	\N	\N	\N	\N	35046	35046	34562
10137	9932	53	applied	\N	\N	\N	\N	35047	35047	34564
10137	9933	54	applied	\N	\N	\N	\N	35048	35048	34566
10137	9934	55	applied	\N	\N	\N	\N	35049	35049	34568
10137	9935	56	applied	\N	\N	\N	\N	35050	35050	34570
10137	9936	57	applied	\N	\N	\N	\N	35051	35051	34572
10137	9937	58	applied	\N	\N	\N	\N	35052	35052	34574
10137	9938	59	applied	\N	\N	\N	\N	35053	35053	34576
10137	9939	60	applied	\N	\N	\N	\N	35054	35054	34578
10137	9940	61	applied	\N	\N	\N	\N	35055	35055	34580
10137	9941	62	applied	\N	\N	\N	\N	35056	35056	34582
10137	9947	63	applied	\N	\N	\N	\N	35057	35057	34598
10137	9948	64	applied	\N	\N	\N	\N	35058	35058	34600
10137	9949	65	applied	\N	\N	\N	\N	35059	35059	34602
10137	9950	66	applied	\N	\N	\N	\N	35060	35060	34604
10137	9951	67	applied	\N	\N	\N	\N	35061	35061	34606
10137	9952	68	applied	\N	\N	\N	\N	35062	35062	34608
10137	9953	69	applied	\N	\N	\N	\N	35063	35063	34610
10137	9954	70	applied	\N	\N	\N	\N	35064	35064	34612
10137	9955	71	applied	\N	\N	\N	\N	35065	35065	34614
10137	9956	72	applied	\N	\N	\N	\N	35066	35066	34616
10137	9957	73	applied	\N	\N	\N	\N	35067	35067	34618
10137	9958	74	applied	\N	\N	\N	\N	35068	35068	34620
10137	9959	75	applied	\N	\N	\N	\N	35069	35069	34622
10137	10054	76	applied	\N	\N	\N	\N	35070	35070	34854
10137	10055	77	applied	\N	\N	\N	\N	35071	35071	34856
10137	10056	78	applied	\N	\N	\N	\N	35072	35072	34858
10137	9854	79	applied	\N	\N	\N	\N	34368	34368	34369
10137	10062	80	applied	\N	\N	1000000000	\N	35073	35073	34950
10137	9889	81	applied	\N	\N	\N	\N	35074	35074	34460
10137	9890	82	applied	\N	\N	\N	\N	35075	35075	34462
10137	9891	83	applied	\N	\N	\N	\N	35076	35076	34464
10137	10095	84	applied	\N	\N	\N	\N	35077	35077	34772
10137	10096	85	applied	\N	\N	\N	\N	35078	35078	34780
10137	9904	86	applied	\N	\N	\N	\N	35079	35079	34496
10137	10023	87	applied	\N	\N	\N	\N	35080	35080	34951
10137	10027	88	applied	\N	\N	\N	\N	35081	35081	34952
10137	9875	89	applied	\N	\N	\N	\N	34429	34429	34430
10137	9876	90	applied	\N	\N	\N	\N	34431	34431	34432
10137	9877	91	applied	\N	\N	\N	\N	34433	34433	34434
10137	9310	92	applied	\N	\N	\N	\N	32800	32800	32801
10137	9311	93	applied	\N	\N	\N	\N	32802	32802	32803
10137	9312	94	applied	\N	\N	\N	\N	32804	32804	32805
10137	9328	95	applied	\N	\N	1000000000	\N	32845	32845	32846
10137	9857	96	applied	\N	\N	\N	\N	34378	34378	34379
10137	9881	97	applied	\N	\N	\N	\N	35082	35082	34444
10137	9338	98	applied	\N	\N	\N	\N	33014	33014	32868
10137	9206	99	applied	\N	\N	\N	\N	32525	32525	32526
10137	9207	100	applied	\N	\N	\N	\N	32527	32527	32528
10137	9209	101	applied	\N	\N	\N	\N	32534	32534	32535
10137	9825	102	applied	\N	\N	\N	\N	34295	34295	34316
10137	9963	103	applied	\N	\N	\N	\N	35083	35083	34630
10137	9964	104	applied	\N	\N	\N	\N	35084	35084	34632
10137	9965	105	applied	\N	\N	\N	\N	35085	35085	34634
10137	9966	106	applied	\N	\N	\N	\N	35086	35086	34636
10137	9970	107	applied	\N	\N	\N	\N	35087	35087	34647
10137	9971	108	applied	\N	\N	\N	\N	35088	35088	34649
10137	9973	109	applied	\N	\N	\N	\N	35089	35089	34653
10137	9974	110	applied	\N	\N	\N	\N	35090	35090	34655
10137	9975	111	applied	\N	\N	\N	\N	35091	35091	34657
10137	9976	112	applied	\N	\N	\N	\N	35092	35092	34659
10137	9977	113	applied	\N	\N	\N	\N	35093	35093	34661
10137	9978	114	applied	\N	\N	\N	\N	35094	35094	34663
10137	9979	115	applied	\N	\N	\N	\N	35095	35095	34665
10137	9981	116	applied	\N	\N	\N	\N	35096	35096	34675
10137	9984	117	applied	\N	\N	\N	\N	35097	35097	34681
10137	9985	118	applied	\N	\N	\N	\N	35098	35098	34683
10137	9986	119	applied	\N	\N	\N	\N	35099	35099	34685
10137	9987	120	applied	\N	\N	\N	\N	35100	35100	34687
10137	9988	121	applied	\N	\N	\N	\N	35101	35101	34689
10137	9989	122	applied	\N	\N	\N	\N	35102	35102	34691
10137	9990	123	applied	\N	\N	\N	\N	35103	35103	34693
10137	9991	124	applied	\N	\N	\N	\N	35104	35104	34695
10137	9998	125	applied	\N	\N	\N	\N	35105	35105	34711
10146	10127	0	applied	\N	\N	\N	\N	35137	35137	35138
10146	10128	1	applied	\N	\N	\N	\N	35139	35139	35140
10147	10129	0	applied	\N	\N	\N	\N	35146	35146	35147
10147	10130	1	applied	\N	\N	\N	\N	35148	35148	35149
10151	10131	0	applied	\N	\N	\N	\N	35154	35154	35155
10151	10132	1	applied	\N	\N	\N	\N	35156	35156	35157
10152	10131	0	applied	\N	\N	\N	\N	35154	35154	35155
10152	10132	1	applied	\N	\N	\N	\N	35156	35156	35157
10157	10139	0	applied	\N	\N	\N	\N	35178	35178	35179
10157	10140	1	applied	\N	\N	\N	\N	35180	35180	35181
10164	10143	0	applied	\N	\N	\N	\N	35197	35197	35198
10164	10144	1	applied	\N	\N	\N	\N	35199	35199	35200
10164	10145	2	applied	\N	\N	\N	\N	35201	35201	35202
10164	10146	3	applied	\N	\N	\N	\N	35203	35203	35204
10164	10147	4	applied	\N	\N	\N	\N	35205	35205	35206
10164	10148	5	applied	\N	\N	\N	\N	35207	35207	35208
10164	10149	6	applied	\N	\N	\N	\N	35209	35209	35210
10164	10150	7	applied	\N	\N	\N	\N	35211	35211	35212
10164	10151	8	applied	\N	\N	\N	\N	35213	35213	35214
10164	10152	9	applied	\N	\N	\N	\N	35215	35215	35216
10164	10153	10	applied	\N	\N	\N	\N	35217	35217	35218
10164	10154	11	applied	\N	\N	\N	\N	35219	35219	35220
10165	10155	0	applied	\N	\N	\N	\N	35224	35224	35225
10165	10156	1	applied	\N	\N	\N	\N	35226	35226	35227
10169	10157	0	applied	\N	\N	\N	\N	35230	35230	35231
10169	10158	1	applied	\N	\N	\N	\N	35232	35232	35233
10175	10179	0	applied	\N	\N	\N	\N	35283	35283	35284
10175	10180	1	applied	\N	\N	\N	\N	35285	35285	35286
10181	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10181	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10181	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10181	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10185	10185	0	applied	\N	\N	\N	\N	35311	35311	35312
10185	10186	1	applied	\N	\N	\N	\N	35313	35313	35314
10190	10187	0	applied	\N	\N	\N	\N	35318	35318	35319
10190	10188	1	applied	\N	\N	\N	\N	35320	35320	35321
10190	10189	2	applied	\N	\N	1000000000	\N	35322	35322	35323
10190	10190	3	applied	\N	\N	\N	\N	35324	35324	35325
10190	10191	4	applied	\N	\N	\N	\N	35326	35326	35327
10191	10192	0	applied	\N	\N	\N	\N	35334	35334	35335
10191	10193	1	applied	\N	\N	\N	\N	35336	35336	35337
10191	10194	2	applied	\N	\N	\N	\N	35338	35338	35339
10191	10195	3	applied	\N	\N	\N	\N	35340	35340	35341
10191	10196	4	applied	\N	\N	\N	\N	35342	35342	35343
10191	10197	5	applied	\N	\N	\N	\N	35344	35344	35345
10191	10198	6	applied	\N	\N	\N	\N	35346	35346	35347
10197	10203	0	applied	\N	\N	\N	\N	35364	35364	35365
10197	10204	1	applied	\N	\N	\N	\N	35366	35366	35367
10202	10209	0	applied	\N	\N	\N	\N	35380	35380	35381
10202	10210	1	applied	\N	\N	\N	\N	35382	35382	35383
10203	10211	0	applied	\N	\N	\N	\N	35388	35388	35389
10203	10212	1	applied	\N	\N	\N	\N	35390	35390	35391
10208	10215	0	applied	\N	\N	\N	\N	35404	35404	35405
10208	10216	1	applied	\N	\N	\N	\N	35406	35406	35407
10214	10220	0	applied	\N	\N	\N	\N	35420	35420	35421
10214	10221	1	applied	\N	\N	\N	\N	35422	35422	35423
10214	10222	2	applied	\N	\N	\N	\N	35424	35424	35425
10214	10223	3	applied	\N	\N	\N	\N	35426	35426	35427
10214	10224	4	applied	\N	\N	\N	\N	35428	35428	35429
10214	10225	5	applied	\N	\N	\N	\N	35430	35430	35431
10220	10232	0	applied	\N	\N	\N	\N	35453	35453	35454
10220	10233	1	applied	\N	\N	\N	\N	35455	35455	35456
10226	10242	0	applied	\N	\N	\N	\N	35495	35495	35496
10233	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10233	10254	1	applied	\N	\N	\N	\N	35534	35534	35535
10233	10255	2	applied	\N	\N	\N	\N	35536	35536	35537
10238	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10238	10243	1	applied	\N	\N	\N	\N	35503	35503	35504
10238	10244	2	applied	\N	\N	\N	\N	35505	35505	35506
10238	10247	3	applied	\N	\N	\N	\N	35519	35519	35520
10238	10248	4	applied	\N	\N	\N	\N	35521	35521	35522
10238	10249	5	applied	\N	\N	\N	\N	35523	35523	35524
10238	10254	6	applied	\N	\N	\N	\N	35534	35534	35535
10238	10256	7	applied	\N	\N	\N	\N	35545	35545	35546
10238	10245	8	applied	\N	\N	\N	\N	35507	35507	35508
10238	10246	9	applied	\N	\N	\N	\N	35509	35509	35510
10238	10250	10	applied	\N	\N	\N	\N	35525	35525	35526
10238	10251	11	applied	\N	\N	\N	\N	35527	35527	35528
10238	10252	12	applied	\N	\N	\N	\N	35529	35529	35530
10238	10255	13	applied	\N	\N	\N	\N	35536	35536	35537
10258	10303	0	applied	\N	\N	1000000000	\N	35670	35670	35671
10258	10304	1	applied	\N	\N	\N	\N	35672	35672	35673
10258	10305	2	applied	\N	\N	\N	\N	35674	35674	35675
10258	10306	3	applied	\N	\N	\N	\N	35676	35676	35677
10258	10307	4	applied	\N	\N	\N	\N	35678	35678	35679
10263	10308	0	applied	\N	\N	\N	\N	35685	35685	35686
10263	10309	1	applied	\N	\N	\N	\N	35687	35687	35688
10263	10310	2	applied	\N	\N	\N	\N	35689	35689	35690
10263	10311	3	applied	\N	\N	\N	\N	35691	35691	35692
10269	10324	0	applied	\N	\N	\N	\N	35729	35729	35730
10269	10325	1	applied	\N	\N	\N	\N	35731	35731	35732
10270	10326	0	applied	\N	\N	\N	\N	35734	35734	35735
10270	10327	1	applied	\N	\N	\N	\N	35736	35736	35737
10140	9403	13	applied	\N	\N	\N	\N	33024	33024	33025
10140	9404	14	applied	\N	\N	\N	\N	33026	33026	33027
10140	9405	15	applied	\N	\N	\N	\N	33028	33028	33029
10140	9416	16	applied	\N	\N	\N	\N	33050	33050	33051
10140	9106	17	applied	\N	\N	\N	\N	32237	32237	32238
10140	9639	18	applied	\N	\N	\N	\N	33690	33690	33691
10140	9473	19	applied	\N	\N	\N	\N	33209	33209	33210
10140	9174	20	applied	\N	\N	\N	\N	32447	32447	32448
10145	10127	0	applied	\N	\N	\N	\N	35137	35137	35138
10145	10128	1	applied	\N	\N	\N	\N	35139	35139	35140
10150	10129	0	applied	\N	\N	\N	\N	35146	35146	35147
10150	10130	1	applied	\N	\N	\N	\N	35148	35148	35149
10156	10135	0	applied	\N	\N	\N	\N	35168	35168	35169
10156	10136	1	applied	\N	\N	\N	\N	35170	35170	35171
10156	10137	2	applied	\N	\N	\N	\N	35172	35172	35173
10156	10138	3	applied	\N	\N	\N	\N	35174	35174	35175
10160	10139	0	applied	\N	\N	\N	\N	35178	35178	35179
10160	10140	1	applied	\N	\N	\N	\N	35180	35180	35181
10161	10141	0	applied	\N	\N	\N	\N	35189	35189	35190
10161	10142	1	applied	\N	\N	\N	\N	35191	35191	35192
10166	10157	0	applied	\N	\N	\N	\N	35230	35230	35231
10166	10158	1	applied	\N	\N	\N	\N	35232	35232	35233
10170	10157	0	applied	\N	\N	\N	\N	35230	35230	35231
10170	10158	1	applied	\N	\N	\N	\N	35232	35232	35233
10171	10159	0	applied	\N	\N	\N	\N	35239	35239	35240
10171	10160	1	applied	\N	\N	\N	\N	35241	35241	35242
10176	10179	0	applied	\N	\N	\N	\N	35283	35283	35284
10176	10180	1	applied	\N	\N	\N	\N	35285	35285	35286
10182	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10182	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10182	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10182	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10186	10185	0	applied	\N	\N	\N	\N	35311	35311	35312
10186	10186	1	applied	\N	\N	\N	\N	35313	35313	35314
10192	10192	0	applied	\N	\N	\N	\N	35334	35334	35335
10192	10193	1	applied	\N	\N	\N	\N	35336	35336	35337
10192	10194	2	applied	\N	\N	\N	\N	35338	35338	35339
10192	10195	3	applied	\N	\N	\N	\N	35340	35340	35341
10192	10196	4	applied	\N	\N	\N	\N	35342	35342	35343
10192	10197	5	applied	\N	\N	\N	\N	35344	35344	35345
10192	10198	6	applied	\N	\N	\N	\N	35346	35346	35347
10193	10199	0	applied	\N	\N	\N	\N	35351	35351	35352
10193	10200	1	applied	\N	\N	\N	\N	35353	35353	35354
10193	10201	2	applied	\N	\N	\N	\N	35355	35355	35356
10193	10202	3	applied	\N	\N	\N	\N	35357	35357	35358
10198	10203	0	applied	\N	\N	\N	\N	35364	35364	35365
10198	10204	1	applied	\N	\N	\N	\N	35366	35366	35367
10204	10211	0	applied	\N	\N	\N	\N	35388	35388	35389
10204	10212	1	applied	\N	\N	\N	\N	35390	35390	35391
10209	10217	0	applied	\N	\N	\N	\N	35412	35412	35413
10209	10218	1	applied	\N	\N	\N	\N	35414	35414	35415
10209	10219	2	applied	\N	\N	\N	\N	35416	35416	35417
10215	10226	0	applied	\N	\N	\N	\N	35436	35436	35437
10215	10227	1	applied	\N	\N	\N	\N	35438	35438	35439
10221	10232	0	applied	\N	\N	\N	\N	35453	35453	35454
10221	10233	1	applied	\N	\N	\N	\N	35455	35455	35456
10227	10242	0	applied	\N	\N	\N	\N	35495	35495	35496
10234	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10234	10254	1	applied	\N	\N	\N	\N	35534	35534	35535
10234	10255	2	applied	\N	\N	\N	\N	35536	35536	35537
10239	10258	0	applied	\N	\N	\N	\N	35552	35552	35553
10239	10259	1	applied	\N	\N	\N	\N	35554	35554	35555
10245	10260	0	applied	\N	\N	\N	\N	35559	35559	35560
10245	10261	1	applied	\N	\N	\N	\N	35561	35561	35562
10245	10262	2	applied	\N	\N	\N	\N	35563	35563	35564
10245	10263	3	applied	\N	\N	\N	\N	35565	35565	35566
10253	10281	0	applied	\N	\N	\N	\N	35620	35620	35621
10253	10282	1	applied	\N	\N	\N	\N	35622	35622	35623
10253	10283	2	applied	\N	\N	\N	\N	35624	35624	35625
10253	10284	3	applied	\N	\N	\N	\N	35626	35626	35627
10253	10285	4	applied	\N	\N	\N	\N	35628	35628	35629
10253	10286	5	applied	\N	\N	\N	\N	35630	35630	35631
10253	10287	6	applied	\N	\N	\N	\N	35632	35632	35633
10253	10288	7	applied	\N	\N	\N	\N	35634	35634	35635
10253	10289	8	applied	\N	\N	\N	\N	35636	35636	35637
10253	10290	9	applied	\N	\N	\N	\N	35638	35638	35639
10253	10291	10	applied	\N	\N	\N	\N	35640	35640	35641
10253	10292	11	applied	\N	\N	\N	\N	35642	35642	35643
10253	10293	12	applied	\N	\N	\N	\N	35644	35644	35645
10253	10294	13	applied	\N	\N	\N	\N	35646	35646	35647
10253	10295	14	applied	\N	\N	\N	\N	35648	35648	35649
10253	10296	15	applied	\N	\N	\N	\N	35650	35650	35651
10253	10297	16	applied	\N	\N	\N	\N	35652	35652	35653
10253	10298	17	applied	\N	\N	\N	\N	35654	35654	35655
10259	10303	0	applied	\N	\N	1000000000	\N	35670	35670	35671
10259	10304	1	applied	\N	\N	\N	\N	35672	35672	35673
10259	10305	2	applied	\N	\N	\N	\N	35674	35674	35675
10259	10306	3	applied	\N	\N	\N	\N	35676	35676	35677
10259	10307	4	applied	\N	\N	\N	\N	35678	35678	35679
10264	10312	0	applied	\N	\N	\N	\N	35698	35698	35699
10264	10313	1	applied	\N	\N	\N	\N	35700	35700	35701
10265	10314	0	applied	\N	\N	\N	\N	35704	35704	35705
10265	10315	1	applied	\N	\N	\N	\N	35706	35706	35707
10265	10316	2	applied	\N	\N	\N	\N	35708	35708	35709
10265	10317	3	applied	\N	\N	\N	\N	35710	35710	35711
10265	10318	4	applied	\N	\N	\N	\N	35712	35712	35713
10265	10319	5	applied	\N	\N	\N	\N	35714	35714	35715
10265	10320	6	applied	\N	\N	\N	\N	35716	35716	35717
10265	10321	7	applied	\N	\N	\N	\N	35718	35718	35719
10271	10328	0	applied	\N	\N	\N	\N	35738	35738	35739
10271	10329	1	applied	\N	\N	\N	\N	35740	35740	35741
10272	10330	0	applied	\N	\N	\N	\N	35744	35744	35745
10272	10331	1	applied	\N	\N	\N	\N	35746	35746	35747
10174	10178	1	applied	\N	\N	\N	\N	35279	35279	35280
10179	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10179	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10179	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10179	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10180	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10180	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10180	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10180	10184	3	applied	\N	\N	\N	\N	35296	35296	35297
10184	10181	0	applied	\N	\N	\N	\N	35290	35290	35291
10184	10182	1	applied	\N	\N	\N	\N	35292	35292	35293
10184	10183	2	applied	\N	\N	\N	\N	35294	35294	35295
10189	10187	0	applied	\N	\N	\N	\N	35318	35318	35319
10189	10188	1	applied	\N	\N	\N	\N	35320	35320	35321
10189	10189	2	applied	\N	\N	1000000000	\N	35322	35322	35323
10189	10190	3	applied	\N	\N	\N	\N	35324	35324	35325
10189	10191	4	applied	\N	\N	\N	\N	35326	35326	35327
10195	10199	0	applied	\N	\N	\N	\N	35351	35351	35352
10195	10200	1	applied	\N	\N	\N	\N	35353	35353	35354
10195	10201	2	applied	\N	\N	\N	\N	35355	35355	35356
10195	10202	3	applied	\N	\N	\N	\N	35357	35357	35358
10196	10203	0	applied	\N	\N	\N	\N	35364	35364	35365
10196	10204	1	applied	\N	\N	\N	\N	35366	35366	35367
10201	10209	0	applied	\N	\N	\N	\N	35380	35380	35381
10201	10210	1	applied	\N	\N	\N	\N	35382	35382	35383
10206	10213	0	applied	\N	\N	\N	\N	35396	35396	35397
10206	10214	1	applied	\N	\N	\N	\N	35398	35398	35399
10207	10215	0	applied	\N	\N	\N	\N	35404	35404	35405
10207	10216	1	applied	\N	\N	\N	\N	35406	35406	35407
10213	10220	0	applied	\N	\N	\N	\N	35420	35420	35421
10213	10221	1	applied	\N	\N	\N	\N	35422	35422	35423
10213	10222	2	applied	\N	\N	\N	\N	35424	35424	35425
10213	10223	3	applied	\N	\N	\N	\N	35426	35426	35427
10213	10224	4	applied	\N	\N	\N	\N	35428	35428	35429
10213	10225	5	applied	\N	\N	\N	\N	35430	35430	35431
10218	10228	0	applied	\N	\N	\N	\N	35444	35444	35445
10218	10229	1	applied	\N	\N	\N	\N	35446	35446	35447
10218	10230	2	applied	\N	\N	\N	\N	35448	35448	35449
10218	10231	3	applied	\N	\N	\N	\N	35450	35450	35451
10219	10232	0	applied	\N	\N	\N	\N	35453	35453	35454
10219	10233	1	applied	\N	\N	\N	\N	35455	35455	35456
10223	10192	0	applied	\N	\N	\N	\N	35334	35334	35335
10223	10143	1	applied	\N	\N	\N	\N	35197	35197	35198
10223	10146	2	applied	\N	\N	\N	\N	35203	35203	35204
10223	10147	3	applied	\N	\N	\N	\N	35458	35458	35206
10223	10148	4	applied	\N	\N	\N	\N	35207	35207	35208
10223	10149	5	applied	\N	\N	\N	\N	35459	35459	35210
10223	10150	6	applied	\N	\N	\N	\N	35460	35460	35212
10223	10151	7	applied	\N	\N	\N	\N	35461	35461	35214
10223	9999	8	applied	\N	\N	\N	\N	35462	35462	34714
10223	10000	9	applied	\N	\N	\N	\N	35463	35463	34716
10223	10152	10	applied	\N	\N	\N	\N	35464	35464	35216
10223	10153	11	applied	\N	\N	\N	\N	35465	35465	35218
10223	10154	12	applied	\N	\N	\N	\N	35219	35219	35220
10223	10001	13	applied	\N	\N	\N	\N	35466	35466	34718
10223	10002	14	applied	\N	\N	\N	\N	35467	35467	34720
10223	10003	15	applied	\N	\N	\N	\N	35468	35468	34722
10223	10004	16	applied	\N	\N	\N	\N	35469	35469	34724
10223	10005	17	applied	\N	\N	\N	\N	35470	35470	34726
10223	9213	18	applied	\N	\N	\N	\N	32544	32544	32545
10223	9218	19	applied	\N	\N	\N	\N	32559	32559	32560
10223	9220	20	applied	\N	\N	\N	\N	32565	32565	32566
10223	9222	21	applied	\N	\N	\N	\N	32572	32572	32573
10223	9224	23	applied	\N	\N	\N	\N	32580	32580	32581
10223	9228	24	applied	\N	\N	\N	\N	32589	32589	32590
10223	9230	25	applied	\N	\N	\N	\N	32595	32595	32596
10223	9233	26	applied	\N	\N	\N	\N	32605	32605	32606
10223	9235	27	applied	\N	\N	\N	\N	32611	32611	32612
10223	9241	28	applied	\N	\N	\N	\N	32625	32625	32626
10223	9242	29	applied	\N	\N	\N	\N	32627	32627	32628
10223	9245	30	applied	\N	\N	\N	\N	32635	32635	32636
10223	9249	31	applied	\N	\N	\N	\N	32646	32646	32647
10223	9250	32	applied	\N	\N	\N	\N	32648	32648	32649
10223	9251	33	applied	\N	\N	\N	\N	32650	32650	32651
10223	9258	34	applied	\N	\N	\N	\N	32667	32667	32668
10223	9261	35	applied	\N	\N	\N	\N	32674	32674	32675
10223	9263	36	applied	\N	\N	\N	\N	32680	32680	32681
10223	9265	37	applied	\N	\N	\N	\N	32688	32688	32689
10223	9267	38	applied	\N	\N	\N	\N	32694	32694	32695
10223	9272	39	applied	\N	\N	\N	\N	32706	32706	32707
10223	9277	40	applied	\N	\N	\N	\N	32717	32717	32718
10223	9279	41	applied	\N	\N	\N	\N	32724	32724	32725
10223	9282	42	applied	\N	\N	\N	\N	32730	32730	32731
10223	9284	43	applied	\N	\N	\N	\N	32738	32738	32739
10223	9286	44	applied	\N	\N	\N	\N	32744	32744	32745
10223	9288	45	applied	\N	\N	\N	\N	32750	32750	32751
10223	9289	46	applied	\N	\N	\N	\N	32752	32752	32753
10223	9296	47	applied	\N	\N	\N	\N	32768	32768	32769
10223	9300	48	applied	\N	\N	\N	\N	32778	32778	32779
10223	9313	49	applied	\N	\N	\N	\N	32806	32806	32807
10223	9314	50	applied	\N	\N	\N	\N	32808	32808	32809
10223	9315	51	applied	\N	\N	\N	\N	32812	32812	32813
10223	9318	52	applied	\N	\N	\N	\N	32820	32820	32821
10223	9320	53	applied	\N	\N	\N	\N	32826	32826	32827
10223	9323	54	applied	\N	\N	\N	\N	32832	32832	32833
10223	9324	55	applied	\N	\N	\N	\N	32835	32835	32836
10223	9326	56	applied	\N	\N	\N	\N	32841	32841	32842
10223	9334	57	applied	\N	\N	\N	\N	32859	32859	32860
10223	9335	58	applied	\N	\N	\N	\N	32861	32861	32862
10223	9341	59	applied	\N	\N	\N	\N	32874	32874	32875
10223	9342	60	applied	\N	\N	\N	\N	32883	32883	32884
10224	10234	0	applied	\N	\N	\N	\N	35475	35475	35476
10224	10235	1	applied	\N	\N	\N	\N	35477	35477	35478
10224	10236	2	applied	\N	\N	\N	\N	35479	35479	35480
10224	10237	3	applied	\N	\N	\N	\N	35481	35481	35482
10224	10238	4	applied	\N	\N	\N	\N	35483	35483	35484
10224	10239	5	applied	\N	\N	\N	\N	35485	35485	35486
10225	10234	0	applied	\N	\N	\N	\N	35475	35475	35476
10225	10235	1	applied	\N	\N	\N	\N	35477	35477	35478
10225	10236	2	applied	\N	\N	\N	\N	35479	35479	35480
10225	10240	3	applied	\N	\N	\N	\N	35489	35489	35490
10225	10237	4	applied	\N	\N	\N	\N	35481	35481	35482
10225	10238	5	applied	\N	\N	\N	\N	35483	35483	35484
10225	10239	6	applied	\N	\N	\N	\N	35485	35485	35486
10225	10241	7	applied	\N	\N	\N	\N	35491	35491	35492
10232	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10232	10254	1	applied	\N	\N	\N	\N	35534	35534	35535
10232	10255	2	applied	\N	\N	\N	\N	35536	35536	35537
10237	10256	0	applied	\N	\N	\N	\N	35545	35545	35546
10230	9332	44	applied	\N	\N	\N	\N	35515	35515	32857
10230	9234	45	applied	\N	\N	\N	\N	32609	32609	32610
10230	9607	46	applied	\N	\N	\N	\N	33602	33602	33603
10230	9479	47	applied	\N	\N	\N	\N	33226	33226	33227
10230	9237	48	applied	\N	\N	\N	\N	32617	32617	32618
10230	9191	49	applied	\N	\N	\N	\N	32487	32487	32488
10230	9192	50	applied	\N	\N	\N	\N	32489	32489	32490
10230	9193	51	applied	\N	\N	\N	\N	32491	32491	32492
10230	9030	52	applied	\N	\N	\N	\N	32028	32028	32029
10230	9031	53	applied	\N	\N	\N	\N	32034	32034	32035
10230	10068	54	applied	\N	\N	\N	\N	35516	35516	34887
10230	9076	55	applied	\N	\N	\N	\N	32162	32162	32163
10230	9079	56	applied	\N	\N	\N	\N	32173	32173	32174
10230	9360	57	applied	\N	\N	\N	\N	33068	33068	32923
10230	9361	58	applied	\N	\N	\N	\N	33069	33069	32925
10230	9767	59	applied	\N	\N	\N	\N	34106	34106	34107
10230	9669	60	applied	\N	\N	\N	\N	33799	33799	33800
10230	9131	61	applied	\N	\N	\N	\N	32311	32311	32312
10230	9133	62	applied	\N	\N	\N	\N	32321	32321	32322
10230	9880	63	applied	\N	\N	\N	\N	34667	34667	34442
10230	9145	64	applied	\N	\N	\N	\N	32358	32358	32359
10230	9089	65	applied	\N	\N	1000000000	\N	32200	32200	32201
10230	9092	66	applied	\N	\N	\N	\N	32207	32207	32208
10230	9655	67	applied	\N	\N	\N	\N	33901	33901	33755
10230	9135	68	applied	\N	\N	\N	\N	32325	32325	32326
10230	9033	69	applied	\N	\N	\N	\N	32041	32041	32042
10230	9036	70	applied	\N	\N	\N	\N	32049	32049	32050
10230	9040	71	applied	\N	\N	\N	\N	32060	32060	32061
10230	10025	72	applied	\N	\N	\N	\N	35025	35025	34776
10230	10032	73	applied	\N	\N	\N	\N	35026	35026	34794
10230	10041	74	applied	\N	\N	\N	\N	35027	35027	34817
10230	9138	75	applied	\N	\N	\N	\N	32338	32338	32339
10231	10247	0	applied	\N	\N	\N	\N	35519	35519	35520
10231	10248	1	applied	\N	\N	\N	\N	35521	35521	35522
10231	10249	2	applied	\N	\N	\N	\N	35523	35523	35524
10231	10250	3	applied	\N	\N	\N	\N	35525	35525	35526
10231	10251	4	applied	\N	\N	\N	\N	35527	35527	35528
10231	10252	5	applied	\N	\N	\N	\N	35529	35529	35530
10235	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10235	10254	1	applied	\N	\N	\N	\N	35534	35534	35535
10235	10255	2	applied	\N	\N	\N	\N	35536	35536	35537
10240	10258	0	applied	\N	\N	\N	\N	35552	35552	35553
10240	10259	1	applied	\N	\N	\N	\N	35554	35554	35555
10254	10299	0	applied	\N	\N	\N	\N	35658	35658	35659
10254	10300	1	applied	\N	\N	\N	\N	35660	35660	35661
10260	10303	0	applied	\N	\N	1000000000	\N	35670	35670	35671
10260	10304	1	applied	\N	\N	\N	\N	35672	35672	35673
10260	10305	2	applied	\N	\N	\N	\N	35674	35674	35675
10260	10306	3	applied	\N	\N	\N	\N	35676	35676	35677
10260	10307	4	applied	\N	\N	\N	\N	35678	35678	35679
10261	10308	0	applied	\N	\N	\N	\N	35685	35685	35686
10261	10309	1	applied	\N	\N	\N	\N	35687	35687	35688
10261	10310	2	applied	\N	\N	\N	\N	35689	35689	35690
10261	10311	3	applied	\N	\N	\N	\N	35691	35691	35692
10266	10314	0	applied	\N	\N	\N	\N	35704	35704	35705
10266	10315	1	applied	\N	\N	\N	\N	35706	35706	35707
10266	10316	2	applied	\N	\N	\N	\N	35708	35708	35709
10266	10317	3	applied	\N	\N	\N	\N	35710	35710	35711
10266	10318	4	applied	\N	\N	\N	\N	35712	35712	35713
10266	10319	5	applied	\N	\N	\N	\N	35714	35714	35715
10266	10320	6	applied	\N	\N	\N	\N	35716	35716	35717
10266	10321	7	applied	\N	\N	\N	\N	35718	35718	35719
10267	10322	0	applied	\N	\N	\N	\N	35723	35723	35724
10267	10323	1	applied	\N	\N	\N	\N	35725	35725	35726
10273	10332	0	applied	\N	\N	\N	\N	35750	35750	35751
10273	10333	1	applied	\N	\N	\N	\N	35752	35752	35753
10274	10334	0	applied	\N	\N	\N	\N	35756	35756	35757
10274	10335	1	applied	\N	\N	\N	\N	35758	35758	35759
10274	10336	2	applied	\N	\N	\N	\N	35760	35760	35761
10275	10337	0	applied	\N	\N	\N	\N	35764	35764	35765
10275	10338	1	applied	\N	\N	\N	\N	35766	35766	35767
10275	10339	2	applied	\N	\N	\N	\N	35768	35768	35769
10275	10340	3	applied	\N	\N	\N	\N	35770	35770	35771
10275	10341	4	applied	\N	\N	\N	\N	1406	1406	35772
10275	10342	5	applied	\N	\N	\N	\N	35773	35773	35774
10275	10343	6	applied	\N	\N	\N	\N	35775	35775	35776
10275	10344	7	applied	\N	\N	\N	\N	35777	35777	35778
10237	10257	1	applied	\N	\N	\N	\N	35547	35547	35548
10242	10260	0	applied	\N	\N	\N	\N	35559	35559	35560
10242	10261	1	applied	\N	\N	\N	\N	35561	35561	35562
10242	10262	2	applied	\N	\N	\N	\N	35563	35563	35564
10242	10263	3	applied	\N	\N	\N	\N	35565	35565	35566
10247	10264	0	applied	\N	\N	\N	\N	35570	35570	35571
10247	10265	1	applied	\N	\N	\N	\N	35572	35572	35573
10248	10266	0	applied	\N	\N	\N	\N	35574	35574	35575
10248	10267	1	applied	\N	\N	\N	\N	35576	35576	35577
10248	10268	2	applied	\N	\N	\N	\N	35578	35578	35579
10248	10269	3	applied	\N	\N	\N	\N	35580	35580	35581
10248	10270	4	applied	\N	\N	\N	\N	35582	35582	35583
10248	10271	5	applied	\N	\N	\N	\N	35584	35584	35585
10249	10272	0	applied	\N	\N	\N	\N	35587	35587	35588
10249	10273	1	applied	\N	\N	\N	\N	35589	35589	35590
10250	10253	0	applied	\N	\N	1000000000	\N	35532	35532	35533
10250	9992	1	applied	\N	\N	\N	\N	34698	34698	34699
10250	10109	2	applied	\N	\N	\N	\N	35593	35593	34997
10250	9993	3	applied	\N	\N	\N	\N	34700	34700	34701
10250	10020	4	applied	\N	\N	\N	\N	34765	34765	34766
10250	10066	5	applied	\N	\N	\N	\N	34882	34882	34883
10250	10067	6	applied	\N	\N	\N	\N	34884	34884	34885
10250	10082	7	applied	\N	\N	\N	\N	34921	34921	34922
10250	10192	8	applied	\N	\N	\N	\N	35334	35334	35335
10250	10114	9	applied	\N	\N	\N	\N	35594	35594	35009
10250	9980	10	applied	\N	\N	\N	\N	34672	34672	35595
10250	10115	11	applied	\N	\N	\N	\N	35596	35596	35011
10250	10083	12	applied	\N	\N	\N	\N	34923	34923	34924
10250	10013	13	applied	\N	\N	\N	\N	34745	34745	34746
10250	10014	14	applied	\N	\N	\N	\N	34747	34747	34748
10250	10015	15	applied	\N	\N	\N	\N	34749	34749	34750
10250	10143	16	applied	\N	\N	\N	\N	35197	35197	35198
10250	10019	17	applied	\N	\N	1000000000	\N	35597	35597	34763
10250	10068	18	applied	\N	\N	\N	\N	35598	35598	34887
10250	10024	19	applied	\N	\N	\N	\N	35599	35599	34774
10250	9880	20	applied	\N	\N	\N	\N	34667	34667	34442
10250	10039	21	applied	\N	\N	\N	\N	35023	35023	35024
10250	10025	22	applied	\N	\N	\N	\N	34775	34775	34776
10250	10032	23	applied	\N	\N	\N	\N	34793	34793	34794
10250	10041	24	applied	\N	\N	\N	\N	34816	34816	34817
10250	10026	25	applied	\N	\N	\N	\N	35600	35600	34778
10250	10071	26	applied	\N	\N	\N	\N	35601	35601	34893
10250	10072	27	applied	\N	\N	\N	\N	35602	35602	34895
10252	10274	0	applied	\N	\N	1000000000	\N	35605	35605	35606
10252	10275	1	applied	\N	\N	\N	\N	35607	35607	35608
10252	10276	2	applied	\N	\N	\N	\N	35609	35609	35610
10252	10277	3	applied	\N	\N	\N	\N	35611	35611	35612
10252	10278	4	applied	\N	\N	\N	\N	35613	35613	35614
10252	10279	5	applied	\N	\N	\N	\N	35615	35615	35616
10252	10280	6	applied	\N	\N	\N	\N	35617	35617	35618
10255	10299	0	applied	\N	\N	\N	\N	35658	35658	35659
10255	10300	1	applied	\N	\N	\N	\N	35660	35660	35661
10256	10301	0	applied	\N	\N	\N	\N	35664	35664	35665
10256	10302	1	applied	\N	\N	\N	\N	35666	35666	35667
10262	10308	0	applied	\N	\N	\N	\N	35685	35685	35686
10262	10309	1	applied	\N	\N	\N	\N	35687	35687	35688
10262	10310	2	applied	\N	\N	\N	\N	35689	35689	35690
10262	10311	3	applied	\N	\N	\N	\N	35691	35691	35692
10268	10322	0	applied	\N	\N	\N	\N	35723	35723	35724
10268	10323	1	applied	\N	\N	\N	\N	35725	35725	35726
10276	10345	0	applied	\N	\N	\N	\N	35781	35781	35782
10276	10346	1	applied	\N	\N	\N	\N	35783	35783	35784
10276	10347	3	applied	\N	\N	\N	\N	35786	35786	35787
10276	10348	4	applied	\N	\N	\N	\N	35788	35788	35789
10276	10349	5	applied	\N	\N	\N	\N	35790	35790	35791
10276	10350	6	applied	\N	\N	\N	\N	35792	35792	35793
10276	10351	7	applied	\N	\N	\N	\N	35794	35794	35795
10277	10345	0	applied	\N	\N	\N	\N	35781	35781	35782
10277	10346	1	applied	\N	\N	\N	\N	35783	35783	35784
10277	10347	3	applied	\N	\N	\N	\N	35786	35786	35787
10277	10348	4	applied	\N	\N	\N	\N	35788	35788	35789
10277	10349	5	applied	\N	\N	\N	\N	35790	35790	35791
10277	10350	6	applied	\N	\N	\N	\N	35792	35792	35793
10277	10351	7	applied	\N	\N	\N	\N	35794	35794	35795
10278	10345	0	applied	\N	\N	\N	\N	35781	35781	35782
10278	10346	1	applied	\N	\N	\N	\N	35783	35783	35784
10278	10347	3	applied	\N	\N	\N	\N	35786	35786	35787
10278	10348	4	applied	\N	\N	\N	\N	35788	35788	35789
10278	10349	5	applied	\N	\N	\N	\N	35790	35790	35791
10278	10350	6	applied	\N	\N	\N	\N	35792	35792	35793
10278	10351	7	applied	\N	\N	\N	\N	35794	35794	35795
10279	10345	0	applied	\N	\N	\N	\N	35781	35781	35782
10279	10346	1	applied	\N	\N	\N	\N	35783	35783	35784
10279	10347	3	applied	\N	\N	\N	\N	35786	35786	35787
10279	10348	4	applied	\N	\N	\N	\N	35788	35788	35789
10279	10349	5	applied	\N	\N	\N	\N	35790	35790	35791
10279	10350	6	applied	\N	\N	\N	\N	35792	35792	35793
10279	10351	7	applied	\N	\N	\N	\N	35794	35794	35795
10280	10345	0	applied	\N	\N	\N	\N	35781	35781	35782
10280	10346	1	applied	\N	\N	\N	\N	35783	35783	35784
10280	10347	3	applied	\N	\N	\N	\N	35786	35786	35787
10280	10348	4	applied	\N	\N	\N	\N	35788	35788	35789
10280	10349	5	applied	\N	\N	\N	\N	35790	35790	35791
10280	10350	6	applied	\N	\N	\N	\N	35792	35792	35793
10280	10351	7	applied	\N	\N	\N	\N	35794	35794	35795
10281	10352	0	applied	\N	\N	\N	\N	35813	35813	35814
10281	10353	1	applied	\N	\N	\N	\N	35815	35815	35816
10282	10354	0	applied	\N	\N	\N	\N	35819	35819	35820
10282	10355	1	applied	\N	\N	\N	\N	35821	35821	35822
10282	10356	2	applied	\N	\N	\N	\N	35823	35823	35824
10282	10357	3	applied	\N	\N	\N	\N	35825	35825	35826
10282	10358	4	applied	\N	\N	\N	\N	35827	35827	35828
10282	10359	5	applied	\N	\N	\N	\N	35829	35829	35830
10282	10360	6	applied	\N	\N	\N	\N	35831	35831	35832
10282	10361	7	applied	\N	\N	\N	\N	35833	35833	35834
10282	10362	8	applied	\N	\N	\N	\N	35835	35835	35836
10282	10363	9	applied	\N	\N	\N	\N	35837	35837	35838
10282	10364	10	applied	\N	\N	\N	\N	35839	35839	35840
10283	10365	0	applied	\N	\N	\N	\N	35842	35842	35843
10283	10366	1	applied	\N	\N	\N	\N	35844	35844	35845
10284	10365	0	applied	\N	\N	\N	\N	35842	35842	35843
10284	10366	1	applied	\N	\N	\N	\N	35844	35844	35845
10284	10367	2	applied	\N	\N	\N	\N	35847	35847	35848
10285	10365	0	applied	\N	\N	\N	\N	35842	35842	35843
10285	10366	1	applied	\N	\N	\N	\N	35844	35844	35845
10285	10367	2	applied	\N	\N	\N	\N	35847	35847	35848
10286	10368	0	applied	\N	\N	\N	\N	35852	35852	35853
10286	10369	1	applied	\N	\N	\N	\N	35854	35854	35855
10286	10370	2	applied	\N	\N	\N	\N	35856	35856	35857
10286	10371	3	applied	\N	\N	\N	\N	35858	35858	35859
10291	10372	0	applied	\N	\N	\N	\N	35866	35866	35867
10291	10373	1	applied	\N	\N	\N	\N	35868	35868	35869
10291	10374	2	applied	\N	\N	\N	\N	35870	35870	35871
10297	10383	0	applied	\N	\N	\N	\N	35895	35895	35896
10297	10384	1	applied	\N	\N	\N	\N	35897	35897	35898
10304	10397	0	applied	\N	\N	\N	\N	35932	35932	35933
10304	10398	1	applied	\N	\N	\N	\N	35934	35934	35935
10304	10399	2	applied	\N	\N	\N	\N	35936	35936	35937
10304	10400	3	applied	\N	\N	\N	\N	35938	35938	35939
10305	10401	0	applied	\N	\N	\N	\N	35941	35941	35942
10305	10402	1	applied	\N	\N	\N	\N	35943	35943	35944
10305	10403	2	applied	\N	\N	\N	\N	35945	35945	35946
10305	10404	3	applied	\N	\N	\N	\N	35947	35947	35948
10305	10405	4	applied	\N	\N	\N	\N	35949	35949	35950
10309	10401	0	applied	\N	\N	\N	\N	35941	35941	35942
10309	10402	1	applied	\N	\N	\N	\N	35943	35943	35944
10309	10403	2	applied	\N	\N	\N	\N	35945	35945	35946
10309	10404	3	applied	\N	\N	\N	\N	35947	35947	35948
10309	10405	4	applied	\N	\N	\N	\N	35949	35949	35950
10310	10407	0	applied	\N	\N	\N	\N	35960	35960	35961
10310	10408	1	applied	\N	\N	\N	\N	35962	35962	35963
10310	10406	2	applied	\N	\N	\N	\N	35953	35953	35954
10318	10427	0	applied	\N	\N	\N	\N	36009	36009	36010
10318	10428	1	applied	\N	\N	\N	\N	36011	36011	36012
10318	10429	2	applied	\N	\N	\N	\N	36013	36013	36014
10318	10430	3	applied	\N	\N	\N	\N	36015	36015	36016
10318	10431	4	applied	\N	\N	\N	\N	36017	36017	36018
10318	10432	5	applied	\N	\N	\N	\N	36019	36019	36020
10318	10433	6	applied	\N	\N	\N	\N	36021	36021	36022
10318	10434	7	applied	\N	\N	\N	\N	36023	36023	36024
10318	10435	8	applied	\N	\N	\N	\N	36025	36025	36026
10318	10436	10	applied	\N	\N	\N	\N	10287	10287	36029
10319	10437	0	applied	\N	\N	\N	\N	36031	36031	36032
10319	10438	1	applied	\N	\N	\N	\N	36033	36033	36034
10320	10439	0	applied	\N	\N	\N	\N	36035	36035	36036
10320	10440	1	applied	\N	\N	\N	\N	36037	36037	36038
10320	10441	2	applied	\N	\N	\N	\N	36039	36039	36040
10320	10442	3	applied	\N	\N	\N	\N	36041	36041	36042
10325	10445	0	applied	\N	\N	\N	\N	36056	36056	36057
10325	10446	1	applied	\N	\N	\N	\N	36058	36058	36059
10325	10447	2	applied	\N	\N	\N	\N	36060	36060	36061
10325	10448	3	applied	\N	\N	\N	\N	36062	36062	36063
10335	10478	0	applied	\N	\N	\N	\N	36135	36135	36136
10335	10479	1	applied	\N	\N	\N	\N	36137	36137	36138
10335	10480	2	applied	\N	\N	\N	\N	36139	36139	36140
10336	10481	0	applied	\N	\N	\N	\N	36145	36145	36146
10336	10482	1	applied	\N	\N	\N	\N	36147	36147	36148
10342	10489	0	applied	\N	\N	\N	\N	36167	36167	36168
10342	10490	1	applied	\N	\N	\N	\N	36170	36170	36171
10348	10499	0	applied	\N	\N	\N	\N	36200	36200	36201
10348	10500	1	applied	\N	\N	\N	\N	36202	36202	36203
10354	10505	0	applied	\N	\N	\N	\N	36217	36217	36218
10354	10506	1	applied	\N	\N	\N	\N	36219	36219	36220
10369	10515	0	applied	\N	\N	1000000000	\N	36250	36250	36251
10369	10516	1	applied	\N	\N	\N	\N	36252	36252	36253
10369	10517	3	applied	\N	\N	\N	\N	36255	36255	36256
10369	10518	4	applied	\N	\N	\N	\N	36257	36257	36258
10369	10519	5	applied	\N	\N	\N	\N	36259	36259	36260
10373	10521	0	applied	\N	\N	\N	\N	36268	36268	36269
10382	10546	0	applied	\N	\N	\N	\N	36339	36339	36340
10382	10547	1	applied	\N	\N	\N	\N	36341	36341	36342
10382	10548	2	applied	\N	\N	\N	\N	36343	36343	36344
10388	10553	0	applied	\N	\N	\N	\N	36378	36378	36379
10388	10554	1	applied	\N	\N	\N	\N	36380	36380	36381
10388	10555	2	applied	\N	\N	\N	\N	36382	36382	36383
10392	10560	0	applied	\N	\N	\N	\N	36398	36398	36399
10392	10561	1	applied	\N	\N	\N	\N	36400	36400	36401
10397	10564	0	applied	\N	\N	\N	\N	36412	36412	36413
10397	10565	1	applied	\N	\N	\N	\N	36414	36414	36415
10404	10574	0	applied	\N	\N	\N	\N	36439	36439	36440
10404	10575	1	applied	\N	\N	\N	\N	36441	36441	36442
10405	10576	0	applied	\N	\N	\N	\N	36444	36444	36445
10405	10577	1	applied	\N	\N	\N	\N	36446	36446	36447
10405	10578	2	applied	\N	\N	\N	\N	36448	36448	36449
10405	10579	3	applied	\N	\N	\N	\N	36450	36450	36451
10405	10580	4	applied	\N	\N	\N	\N	36452	36452	36453
10405	10581	5	applied	\N	\N	\N	\N	36454	36454	36455
10406	10582	0	applied	\N	\N	\N	\N	36458	36458	36459
10406	10583	1	applied	\N	\N	\N	\N	36460	36460	36461
10413	10595	0	applied	\N	\N	\N	\N	36493	36493	36494
10413	10596	2	applied	\N	\N	\N	\N	36496	36496	36497
10415	10604	0	applied	\N	\N	\N	\N	36520	36520	36521
10415	10605	1	applied	\N	\N	\N	\N	36522	36522	36523
10415	10606	2	applied	\N	\N	\N	\N	36524	36524	36525
10415	10607	3	applied	\N	\N	\N	\N	36526	36526	36527
10415	10608	4	applied	\N	\N	\N	\N	36528	36528	36529
10426	10629	0	applied	\N	\N	\N	\N	36591	36591	36592
10426	10630	1	applied	\N	\N	\N	\N	36593	36593	36594
10427	10631	0	applied	\N	\N	\N	\N	36595	36595	36596
10427	10632	1	applied	\N	\N	\N	\N	36597	36597	36598
10427	10633	2	applied	\N	\N	\N	\N	36599	36599	36600
10427	10634	3	applied	\N	\N	\N	\N	36601	36601	36602
10427	10635	4	applied	\N	\N	\N	\N	36603	36603	36604
10427	10636	5	applied	\N	\N	\N	\N	36605	36605	36606
10427	10637	6	applied	\N	\N	\N	\N	36607	36607	36608
10427	10638	7	applied	\N	\N	\N	\N	36609	36609	36610
10427	10639	8	applied	\N	\N	\N	\N	36611	36611	36612
10427	10640	9	applied	\N	\N	\N	\N	36613	36613	36614
10427	10641	10	applied	\N	\N	\N	\N	36615	36615	36616
10427	10642	11	applied	\N	\N	\N	\N	36617	36617	36618
10427	10643	12	applied	\N	\N	\N	\N	36619	36619	36620
10427	10644	13	applied	\N	\N	\N	\N	36621	36621	36622
10427	10645	14	applied	\N	\N	\N	\N	36623	36623	36624
10429	10646	0	applied	\N	\N	\N	\N	36628	36628	36629
10429	10647	1	applied	\N	\N	\N	\N	36630	36630	36631
10449	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10449	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10449	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10449	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10449	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10449	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10449	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10449	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10449	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10449	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10449	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10449	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10449	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10287	10368	0	applied	\N	\N	\N	\N	35852	35852	35853
10287	10369	1	applied	\N	\N	\N	\N	35854	35854	35855
10287	10370	2	applied	\N	\N	\N	\N	35856	35856	35857
10287	10371	3	applied	\N	\N	\N	\N	35858	35858	35859
10292	10375	0	applied	\N	\N	\N	\N	35874	35874	1435
10292	10376	1	applied	\N	\N	\N	\N	35875	35875	35876
10292	10377	2	applied	\N	\N	\N	\N	35877	35877	35878
10293	10378	0	applied	\N	\N	\N	\N	35880	35880	35881
10293	10379	1	applied	\N	\N	\N	\N	35882	35882	35883
10293	10380	2	applied	\N	\N	\N	\N	35884	35884	35885
10293	10381	3	applied	\N	\N	\N	\N	35886	35886	35887
10293	10382	4	applied	\N	\N	\N	\N	35888	35888	35889
10298	10383	0	applied	\N	\N	\N	\N	35895	35895	35896
10298	10384	1	applied	\N	\N	\N	\N	35897	35897	35898
10299	10385	0	applied	\N	\N	\N	\N	35904	35904	35905
10299	10386	1	applied	\N	\N	\N	\N	35906	35906	35907
10299	10387	2	applied	\N	\N	\N	\N	35908	35908	35909
10299	10388	3	applied	\N	\N	\N	\N	35910	35910	35911
10299	10389	4	applied	\N	\N	\N	\N	35912	35912	35913
10299	10390	5	applied	\N	\N	\N	\N	35914	35914	35915
10299	10391	6	applied	\N	\N	\N	\N	35916	35916	35917
10300	10392	0	applied	\N	\N	\N	\N	35919	35919	35920
10300	10393	1	applied	\N	\N	1000000000	\N	35921	35921	35922
10300	10394	2	applied	\N	\N	\N	\N	35923	35923	35924
10306	10401	0	applied	\N	\N	\N	\N	35941	35941	35942
10306	10402	1	applied	\N	\N	\N	\N	35943	35943	35944
10306	10403	2	applied	\N	\N	\N	\N	35945	35945	35946
10306	10404	3	applied	\N	\N	\N	\N	35947	35947	35948
10306	10406	4	applied	\N	\N	\N	\N	35953	35953	35954
10306	10405	5	applied	\N	\N	\N	\N	35949	35949	35950
10311	10409	0	applied	\N	\N	\N	\N	35965	35965	35966
10311	10410	1	applied	\N	\N	\N	\N	35967	35967	35968
10311	10411	2	applied	\N	\N	\N	\N	35969	35969	35970
10311	10412	3	applied	\N	\N	\N	\N	35971	35971	35971
10312	10413	0	applied	\N	\N	\N	\N	35973	35973	35974
10312	10414	1	applied	\N	\N	\N	\N	35975	35975	35976
10312	10415	2	applied	\N	\N	\N	\N	35977	35977	35977
10321	10439	0	applied	\N	\N	\N	\N	36035	36035	36036
10321	10440	1	applied	\N	\N	\N	\N	36037	36037	36038
10321	10441	2	applied	\N	\N	\N	\N	36039	36039	36040
10321	10442	3	applied	\N	\N	\N	\N	36041	36041	36042
10326	10445	0	applied	\N	\N	\N	\N	36056	36056	36057
10326	10446	1	applied	\N	\N	\N	\N	36058	36058	36059
10326	10447	2	applied	\N	\N	\N	\N	36060	36060	36061
10326	10448	3	applied	\N	\N	\N	\N	36062	36062	36063
10327	10449	0	applied	\N	\N	\N	\N	36066	36066	36067
10327	10450	1	applied	\N	\N	\N	\N	36068	36068	36069
10327	10451	2	applied	\N	\N	\N	\N	36070	36070	36071
10327	10452	3	applied	\N	\N	\N	\N	36072	36072	36073
10337	10481	0	applied	\N	\N	\N	\N	36145	36145	36146
10337	10482	1	applied	\N	\N	\N	\N	36147	36147	36148
10338	10483	0	applied	\N	\N	\N	\N	36152	36152	36153
10338	10484	1	applied	\N	\N	\N	\N	36154	36154	36155
10338	10485	2	applied	\N	\N	\N	\N	36156	36156	36157
10338	10486	3	applied	\N	\N	\N	\N	36158	36158	36159
10343	10489	0	applied	\N	\N	\N	\N	36167	36167	36168
10343	10490	1	applied	\N	\N	\N	\N	36170	36170	36171
10344	10491	0	applied	\N	\N	\N	\N	36178	36178	36179
10344	10492	1	applied	\N	\N	\N	\N	36180	36180	36181
10344	10493	2	applied	\N	\N	\N	\N	36182	36182	36183
10344	10494	3	applied	\N	\N	\N	\N	36184	36184	36185
10344	10495	4	applied	\N	\N	\N	\N	36186	36186	36187
10344	10496	5	applied	\N	\N	\N	\N	36188	36188	36189
10345	10491	0	applied	\N	\N	\N	\N	36178	36178	36179
10345	10492	1	applied	\N	\N	\N	\N	36180	36180	36181
10345	10493	2	applied	\N	\N	\N	\N	36182	36182	36183
10345	10494	3	applied	\N	\N	\N	\N	36184	36184	36185
10345	10495	4	applied	\N	\N	\N	\N	36186	36186	36187
10345	10496	5	applied	\N	\N	\N	\N	36188	36188	36189
10349	10499	0	applied	\N	\N	\N	\N	36200	36200	36201
10349	10500	1	applied	\N	\N	\N	\N	36202	36202	36203
10350	10499	0	applied	\N	\N	\N	\N	36200	36200	36201
10350	10500	1	applied	\N	\N	\N	\N	36202	36202	36203
10350	10501	2	applied	\N	\N	\N	\N	36206	36206	36207
10350	10502	3	applied	\N	\N	\N	\N	36208	36208	36209
10355	10505	0	applied	\N	\N	\N	\N	36217	36217	36218
10355	10506	1	applied	\N	\N	\N	\N	36219	36219	36220
10359	10507	0	applied	\N	\N	\N	\N	36225	36225	36226
10359	10508	1	applied	\N	\N	\N	\N	36227	36227	36228
10364	10509	0	applied	\N	\N	\N	\N	36232	36232	36233
10364	10510	1	applied	\N	\N	\N	\N	36234	36234	36235
10365	10511	0	applied	\N	\N	\N	\N	36238	36238	36239
10365	10512	1	applied	\N	\N	\N	\N	36240	36240	36241
10365	10513	2	applied	\N	\N	\N	\N	36242	36242	36243
10365	10514	3	applied	\N	\N	\N	\N	36244	36244	36245
10370	10520	0	applied	\N	\N	\N	\N	36266	36266	36267
10370	10521	1	applied	\N	\N	\N	\N	36268	36268	36269
10374	10520	0	applied	\N	\N	\N	\N	36266	36266	36267
10374	10521	1	applied	\N	\N	\N	\N	36268	36268	36269
10375	10521	0	applied	\N	\N	\N	\N	36268	36268	36269
10377	10527	0	applied	\N	\N	\N	\N	36291	36291	36292
10377	10528	1	applied	\N	\N	\N	\N	36293	36293	36294
10377	10529	2	applied	\N	\N	\N	\N	36295	36295	36296
10377	10530	3	applied	\N	\N	\N	\N	36297	36297	36298
10377	10531	4	applied	\N	\N	\N	\N	36299	36299	36300
10377	10532	5	applied	\N	\N	\N	\N	36301	36301	36302
10377	10533	6	applied	\N	\N	\N	\N	36303	36303	36304
10377	10534	7	applied	\N	\N	\N	\N	36305	36305	36306
10377	10535	8	applied	\N	\N	\N	\N	36307	36307	36308
10378	10536	0	applied	\N	\N	\N	\N	36311	36311	36312
10378	10537	1	applied	\N	\N	\N	\N	36313	36313	36314
10378	10538	2	applied	\N	\N	\N	\N	36315	36315	36316
10378	10539	3	applied	\N	\N	\N	\N	36317	36317	36318
10378	10540	4	applied	\N	\N	\N	\N	36319	36319	36320
10378	10541	5	applied	\N	\N	\N	\N	36321	36321	36322
10383	10546	0	applied	\N	\N	\N	\N	36339	36339	36340
10383	10547	1	applied	\N	\N	\N	\N	36341	36341	36342
10384	10549	0	applied	\N	\N	\N	\N	36348	36348	36349
10384	10550	1	applied	\N	\N	\N	\N	36350	36350	36351
10389	10554	0	applied	\N	\N	\N	\N	36380	36380	36381
10389	10555	1	applied	\N	\N	\N	\N	36382	36382	36383
10393	10560	0	applied	\N	\N	\N	\N	36398	36398	36399
10393	10561	1	applied	\N	\N	\N	\N	36400	36400	36401
10398	10564	0	applied	\N	\N	\N	\N	36412	36412	36413
10398	10565	1	applied	\N	\N	\N	\N	36414	36414	36415
10399	10566	0	applied	\N	\N	\N	\N	36418	36418	36419
10399	10567	1	applied	\N	\N	\N	\N	36420	36420	36421
10407	10582	0	applied	\N	\N	\N	\N	36458	36458	36459
10407	10583	1	applied	\N	\N	\N	\N	36460	36460	36461
10408	10584	0	applied	\N	\N	\N	\N	36465	36465	36466
10288	10368	0	applied	\N	\N	\N	\N	35852	35852	35853
10288	10369	1	applied	\N	\N	\N	\N	35854	35854	35855
10288	10370	2	applied	\N	\N	\N	\N	35856	35856	35857
10288	10371	3	applied	\N	\N	\N	\N	35858	35858	35859
10294	10378	0	applied	\N	\N	\N	\N	35880	35880	35881
10294	10379	1	applied	\N	\N	\N	\N	35882	35882	35883
10294	10380	2	applied	\N	\N	\N	\N	35884	35884	35885
10294	10381	3	applied	\N	\N	\N	\N	35886	35886	35887
10294	10382	4	applied	\N	\N	\N	\N	35888	35888	35889
10295	10378	0	applied	\N	\N	\N	\N	35880	35880	35881
10295	10379	1	applied	\N	\N	\N	\N	35882	35882	35883
10295	10380	2	applied	\N	\N	\N	\N	35884	35884	35885
10295	10381	3	applied	\N	\N	\N	\N	35886	35886	35887
10295	10382	4	applied	\N	\N	\N	\N	35888	35888	35889
10301	10392	0	applied	\N	\N	\N	\N	35919	35919	35920
10301	10393	1	applied	\N	\N	1000000000	\N	35921	35921	35922
10301	10394	2	applied	\N	\N	\N	\N	35923	35923	35924
10307	10401	0	applied	\N	\N	\N	\N	35941	35941	35942
10307	10402	1	applied	\N	\N	\N	\N	35943	35943	35944
10307	10403	2	applied	\N	\N	\N	\N	35945	35945	35946
10307	10404	3	applied	\N	\N	\N	\N	35947	35947	35948
10307	10406	4	applied	\N	\N	\N	\N	35953	35953	35954
10307	10405	5	applied	\N	\N	\N	\N	35949	35949	35950
10313	10413	0	applied	\N	\N	\N	\N	35973	35973	35974
10313	10414	1	applied	\N	\N	\N	\N	35975	35975	35976
10313	10415	2	applied	\N	\N	\N	\N	35977	35977	35977
10322	10439	0	applied	\N	\N	\N	\N	36035	36035	36036
10322	10440	1	applied	\N	\N	\N	\N	36037	36037	36038
10322	10441	2	applied	\N	\N	\N	\N	36039	36039	36040
10322	10442	3	applied	\N	\N	\N	\N	36041	36041	36042
10328	10453	0	applied	\N	\N	\N	\N	36076	36076	36077
10328	10454	1	applied	\N	\N	\N	\N	36078	36078	36079
10328	10455	2	applied	\N	\N	\N	\N	36080	36080	36081
10328	10456	3	applied	\N	\N	\N	\N	36082	36082	36083
10328	10457	4	applied	\N	\N	\N	\N	36084	36084	36085
10333	10471	0	applied	\N	\N	\N	\N	10287	10287	36029
10333	10472	1	applied	\N	\N	\N	\N	36121	36121	36122
10333	10473	2	applied	\N	\N	\N	\N	36123	36123	36124
10333	10474	3	applied	\N	\N	\N	\N	36125	36125	36126
10333	10475	4	applied	\N	\N	\N	\N	36127	36127	36128
10333	10476	5	applied	\N	\N	\N	\N	36129	36129	36130
10333	10477	6	applied	\N	\N	\N	\N	36131	36131	36132
10339	10487	0	applied	\N	\N	\N	\N	36161	36161	36162
10339	10488	1	applied	\N	\N	\N	\N	36163	36163	36164
10346	10497	0	applied	\N	\N	\N	\N	36192	36192	36193
10346	10498	1	applied	\N	\N	\N	\N	36194	36194	36195
10351	10501	0	applied	\N	\N	\N	\N	36206	36206	36207
10351	10503	1	applied	\N	\N	\N	\N	36210	36210	36211
10351	10502	2	applied	\N	\N	\N	\N	36208	36208	36209
10351	10504	3	applied	\N	\N	\N	\N	36212	36212	36213
10352	10501	0	applied	\N	\N	\N	\N	36206	36206	36207
10352	10503	1	applied	\N	\N	\N	\N	36210	36210	36211
10352	10502	2	applied	\N	\N	\N	\N	36208	36208	36209
10352	10504	3	applied	\N	\N	\N	\N	36212	36212	36213
10360	10507	0	applied	\N	\N	\N	\N	36225	36225	36226
10360	10508	1	applied	\N	\N	\N	\N	36227	36227	36228
10366	10511	0	applied	\N	\N	\N	\N	36238	36238	36239
10366	10512	1	applied	\N	\N	\N	\N	36240	36240	36241
10366	10513	2	applied	\N	\N	\N	\N	36242	36242	36243
10366	10514	3	applied	\N	\N	\N	\N	36244	36244	36245
10367	10515	0	applied	\N	\N	1000000000	\N	36250	36250	36251
10367	10516	1	applied	\N	\N	\N	\N	36252	36252	36253
10367	10517	3	applied	\N	\N	\N	\N	36255	36255	36256
10367	10518	4	applied	\N	\N	\N	\N	36257	36257	36258
10367	10519	5	applied	\N	\N	\N	\N	36259	36259	36260
10371	10520	0	applied	\N	\N	\N	\N	36266	36266	36267
10371	10521	1	applied	\N	\N	\N	\N	36268	36268	36269
10376	10522	0	applied	\N	\N	\N	\N	36280	36280	36281
10376	10523	1	applied	\N	\N	\N	\N	36282	36282	36283
10376	10524	2	applied	\N	\N	\N	\N	36284	36284	36285
10376	10525	3	applied	\N	\N	\N	\N	36286	36286	36287
10376	10526	4	applied	\N	\N	\N	\N	36288	36288	36289
10379	10536	0	applied	\N	\N	\N	\N	36311	36311	36312
10379	10537	1	applied	\N	\N	\N	\N	36313	36313	36314
10379	10538	2	applied	\N	\N	\N	\N	36315	36315	36316
10379	10539	3	applied	\N	\N	\N	\N	36317	36317	36318
10379	10540	4	applied	\N	\N	\N	\N	36319	36319	36320
10379	10541	5	applied	\N	\N	\N	\N	36321	36321	36322
10380	10542	0	applied	\N	\N	\N	\N	36327	36327	36328
10380	10543	1	applied	\N	\N	\N	\N	36329	36329	36330
10380	10544	2	applied	\N	\N	\N	\N	36331	36331	36332
10380	10545	3	applied	\N	\N	\N	\N	36333	36333	36334
10385	10551	0	applied	\N	\N	\N	\N	36354	36354	36355
10385	10552	1	applied	\N	\N	\N	\N	36356	36356	36357
10390	10553	0	applied	\N	\N	\N	\N	36378	36378	36379
10390	10554	1	applied	\N	\N	\N	\N	36380	36380	36381
10390	10555	2	applied	\N	\N	\N	\N	36382	36382	36383
10391	10556	0	applied	\N	\N	\N	\N	36389	36389	36390
10391	10557	1	applied	\N	\N	\N	\N	36391	36391	36392
10391	10558	2	applied	\N	\N	\N	\N	36393	36393	36394
10391	10559	3	applied	\N	\N	\N	\N	36395	36395	36396
10396	10560	0	applied	\N	\N	\N	\N	36398	36398	36399
10396	10562	1	applied	\N	\N	\N	\N	36406	36406	36407
10396	10561	2	applied	\N	\N	\N	\N	36400	36400	36401
10401	10568	0	applied	\N	\N	1000000000	\N	36423	36423	36424
10401	10569	1	applied	\N	\N	\N	\N	36425	36425	36426
10401	10570	2	applied	\N	\N	\N	\N	36427	36427	36428
10402	10571	0	applied	\N	\N	\N	\N	36430	36430	36431
10403	10572	0	applied	\N	\N	\N	\N	36433	36433	36434
10403	10573	1	applied	\N	\N	\N	\N	36435	36435	36436
10412	10595	0	applied	\N	\N	\N	\N	36493	36493	36494
10412	10596	2	applied	\N	\N	\N	\N	36496	36496	36497
10414	10597	0	applied	\N	\N	\N	\N	36505	36505	36506
10414	10598	1	applied	\N	\N	\N	\N	36507	36507	36508
10414	10599	2	applied	\N	\N	\N	\N	36509	36509	36510
10414	10600	3	applied	\N	\N	\N	\N	36511	36511	36512
10414	10601	4	applied	\N	\N	\N	\N	36513	36513	36514
10414	10602	5	applied	\N	\N	\N	\N	36515	36515	36516
10414	10603	6	applied	\N	\N	\N	\N	36517	36517	36518
10419	10609	0	applied	\N	\N	\N	\N	36533	36533	36534
10419	10610	1	applied	\N	\N	\N	\N	36535	36535	36536
10420	10611	0	applied	\N	\N	\N	\N	36537	36537	36538
10420	10612	1	applied	\N	\N	\N	\N	36545	36545	36546
10420	10613	2	applied	\N	\N	\N	\N	36547	36547	36548
10420	10614	3	applied	\N	\N	\N	\N	36549	36549	36550
10420	10615	4	applied	\N	\N	\N	\N	36551	36551	36552
10420	10616	5	applied	\N	\N	\N	\N	36553	36553	36554
10420	10617	6	applied	\N	\N	\N	\N	36555	36555	36556
10420	10618	7	applied	\N	\N	\N	\N	36557	36557	36558
10289	10368	0	applied	\N	\N	\N	\N	35852	35852	35853
10289	10369	1	applied	\N	\N	\N	\N	35854	35854	35855
10289	10371	2	applied	\N	\N	\N	\N	35858	35858	35859
10290	10372	0	applied	\N	\N	\N	\N	35866	35866	35867
10290	10373	1	applied	\N	\N	\N	\N	35868	35868	35869
10290	10374	2	applied	\N	\N	\N	\N	35870	35870	35871
10296	10383	0	applied	\N	\N	\N	\N	35895	35895	35896
10296	10384	1	applied	\N	\N	\N	\N	35897	35897	35898
10303	10395	0	applied	\N	\N	\N	\N	35926	35926	35927
10303	10396	1	applied	\N	\N	\N	\N	35928	35928	35929
10308	10401	0	applied	\N	\N	\N	\N	35941	35941	35942
10308	10402	1	applied	\N	\N	\N	\N	35943	35943	35944
10308	10403	2	applied	\N	\N	\N	\N	35945	35945	35946
10308	10404	3	applied	\N	\N	\N	\N	35947	35947	35948
10308	10405	4	applied	\N	\N	\N	\N	35949	35949	35950
10314	10413	0	applied	\N	\N	\N	\N	35973	35973	35974
10314	10414	1	applied	\N	\N	\N	\N	35975	35975	35976
10314	10415	2	applied	\N	\N	\N	\N	35977	35977	35977
10315	10416	0	applied	\N	\N	\N	\N	35984	35984	35985
10315	10417	1	applied	\N	\N	\N	\N	35986	35986	35987
10315	10418	2	applied	\N	\N	\N	\N	35988	35988	35989
10315	10419	3	applied	\N	\N	\N	\N	35990	35990	35991
10315	10420	4	applied	\N	\N	\N	\N	35992	35992	35993
10315	10421	5	applied	\N	\N	\N	\N	35994	35994	35995
10316	10422	0	applied	\N	\N	\N	\N	35997	35997	35998
10316	10423	1	applied	\N	\N	\N	\N	35999	35999	36000
10316	10424	2	applied	\N	\N	\N	\N	36001	36001	36002
10316	10425	3	applied	\N	\N	\N	\N	36003	36003	36004
10316	10426	4	applied	\N	\N	\N	\N	36005	36005	36006
10317	10427	0	applied	\N	\N	\N	\N	36009	36009	36010
10317	10428	1	applied	\N	\N	\N	\N	36011	36011	36012
10317	10429	2	applied	\N	\N	\N	\N	36013	36013	36014
10317	10430	3	applied	\N	\N	\N	\N	36015	36015	36016
10317	10431	4	applied	\N	\N	\N	\N	36017	36017	36018
10317	10432	5	applied	\N	\N	\N	\N	36019	36019	36020
10317	10433	6	applied	\N	\N	\N	\N	36021	36021	36022
10317	10434	7	applied	\N	\N	\N	\N	36023	36023	36024
10317	10435	8	applied	\N	\N	\N	\N	36025	36025	36026
10323	10439	0	applied	\N	\N	\N	\N	36035	36035	36036
10323	10440	1	applied	\N	\N	\N	\N	36037	36037	36038
10323	10441	2	applied	\N	\N	\N	\N	36039	36039	36040
10323	10442	3	applied	\N	\N	\N	\N	36041	36041	36042
10324	10443	0	applied	\N	\N	\N	\N	36051	36051	36052
10324	10444	1	applied	\N	\N	\N	\N	36053	36053	36054
10329	10453	0	applied	\N	\N	\N	\N	36076	36076	36077
10329	10454	1	applied	\N	\N	\N	\N	36078	36078	36079
10329	10455	2	applied	\N	\N	\N	\N	36080	36080	36081
10329	10456	3	applied	\N	\N	\N	\N	36082	36082	36083
10329	10457	4	applied	\N	\N	\N	\N	36084	36084	36085
10330	10458	0	applied	\N	\N	\N	\N	36090	36090	36091
10330	10459	1	applied	\N	\N	\N	\N	36092	36092	36093
10330	10460	2	applied	\N	\N	\N	\N	36094	36094	36095
10330	10461	3	applied	\N	\N	\N	\N	36096	36096	36097
10330	10462	4	applied	\N	\N	\N	\N	36098	36098	36099
10331	10463	0	applied	\N	\N	\N	\N	36102	36102	36103
10331	10464	1	applied	\N	\N	\N	\N	36104	36104	36105
10332	10465	0	applied	\N	\N	\N	\N	36107	36107	36108
10332	10466	1	applied	\N	\N	\N	\N	36109	36109	36110
10332	10467	2	applied	\N	\N	\N	\N	36111	36111	36112
10332	10468	3	applied	\N	\N	\N	\N	36113	36113	36114
10332	10469	4	applied	\N	\N	\N	\N	36115	36115	36116
10332	10470	5	applied	\N	\N	\N	\N	36117	36117	36118
10334	10478	0	applied	\N	\N	\N	\N	36135	36135	36136
10334	10479	1	applied	\N	\N	\N	\N	36137	36137	36138
10334	10480	2	applied	\N	\N	\N	\N	36139	36139	36140
10340	10487	0	applied	\N	\N	\N	\N	36161	36161	36162
10340	10488	1	applied	\N	\N	\N	\N	36163	36163	36164
10340	10489	2	applied	\N	\N	\N	\N	36167	36167	36168
10341	10489	0	applied	\N	\N	\N	\N	36167	36167	36168
10341	10490	1	applied	\N	\N	\N	\N	36170	36170	36171
10347	10497	0	applied	\N	\N	\N	\N	36192	36192	36193
10347	10498	1	applied	\N	\N	\N	\N	36194	36194	36195
10353	10505	0	applied	\N	\N	\N	\N	36217	36217	36218
10353	10506	1	applied	\N	\N	\N	\N	36219	36219	36220
10357	10507	0	applied	\N	\N	\N	\N	36225	36225	36226
10357	10508	1	applied	\N	\N	\N	\N	36227	36227	36228
10368	10515	0	applied	\N	\N	1000000000	\N	36250	36250	36251
10368	10516	1	applied	\N	\N	\N	\N	36252	36252	36253
10368	10517	3	applied	\N	\N	\N	\N	36255	36255	36256
10368	10518	4	applied	\N	\N	\N	\N	36257	36257	36258
10368	10519	5	applied	\N	\N	\N	\N	36259	36259	36260
10372	10520	0	applied	\N	\N	\N	\N	36266	36266	36267
10372	10521	1	applied	\N	\N	\N	\N	36268	36268	36269
10381	10542	0	applied	\N	\N	\N	\N	36327	36327	36328
10381	10543	1	applied	\N	\N	\N	\N	36329	36329	36330
10381	10544	2	applied	\N	\N	\N	\N	36331	36331	36332
10381	10545	3	applied	\N	\N	\N	\N	36333	36333	36334
10386	10551	0	applied	\N	\N	\N	\N	36354	36354	36355
10386	10552	1	applied	\N	\N	\N	\N	36356	36356	36357
10387	10522	0	applied	\N	\N	\N	\N	36280	36280	36281
10387	10536	1	applied	\N	\N	\N	\N	36311	36311	36312
10387	10537	2	applied	\N	\N	\N	\N	36313	36313	36314
10387	10538	3	applied	\N	\N	\N	\N	36315	36315	36316
10387	10539	4	applied	\N	\N	\N	\N	36317	36317	36318
10387	10515	5	applied	\N	\N	1000000000	\N	36250	36250	36251
10387	10546	6	applied	\N	\N	\N	\N	36339	36339	36340
10387	10314	7	applied	\N	\N	\N	\N	35704	35704	35705
10387	10449	8	applied	\N	\N	\N	\N	36361	36361	36067
10387	10315	9	applied	\N	\N	\N	\N	35706	35706	35707
10387	10316	11	applied	\N	\N	\N	\N	35708	35708	35709
10387	10317	12	applied	\N	\N	\N	\N	35710	35710	35711
10387	10337	13	applied	\N	\N	\N	\N	35764	35764	35765
10387	10453	14	applied	\N	\N	\N	\N	36363	36363	36077
10387	10454	15	applied	\N	\N	\N	\N	36364	36364	36079
10387	10455	16	applied	\N	\N	\N	\N	36365	36365	36081
10387	10345	17	applied	\N	\N	\N	\N	35781	35781	35782
10387	10354	18	applied	\N	\N	\N	\N	35819	35819	35820
10387	10372	19	applied	\N	\N	\N	\N	35866	35866	35867
10387	10378	20	applied	\N	\N	\N	\N	35880	35880	35881
10387	10385	21	applied	\N	\N	\N	\N	35904	35904	35905
10387	10527	22	applied	\N	\N	\N	\N	36291	36291	36292
10387	10281	23	applied	\N	\N	\N	\N	35620	35620	35621
10387	10282	24	applied	\N	\N	\N	\N	35622	35622	35623
10387	10283	25	applied	\N	\N	\N	\N	35624	35624	35625
10387	10284	26	applied	\N	\N	\N	\N	35626	35626	35627
10387	10285	27	applied	\N	\N	\N	\N	35628	35628	35629
10387	10286	28	applied	\N	\N	\N	\N	35630	35630	35631
10387	10287	29	applied	\N	\N	\N	\N	35632	35632	35633
10387	10479	30	applied	\N	\N	\N	\N	36366	36366	36138
10387	10366	31	applied	\N	\N	\N	\N	35844	35844	35845
10387	10402	32	applied	\N	\N	\N	\N	36367	36367	35944
10387	10410	33	applied	\N	\N	\N	\N	36368	36368	35968
10387	10259	34	applied	\N	\N	\N	\N	35554	35554	35555
10387	10260	35	applied	\N	\N	\N	\N	35559	35559	35560
10387	10261	36	applied	\N	\N	\N	\N	35561	35561	35562
10387	10264	37	applied	\N	\N	\N	\N	35570	35570	35571
10387	10292	38	applied	\N	\N	\N	\N	35642	35642	35643
10387	10257	39	applied	\N	\N	\N	\N	35547	35547	35548
10387	10258	40	applied	\N	\N	\N	\N	35552	35552	35553
10387	10262	41	applied	\N	\N	\N	\N	35563	35563	35564
10387	10263	42	applied	\N	\N	\N	\N	35565	35565	35566
10387	10265	43	applied	\N	\N	\N	\N	35572	35572	35573
10387	10266	44	applied	\N	\N	\N	\N	35574	35574	35575
10387	10267	45	applied	\N	\N	\N	\N	35576	35576	35577
10387	10268	46	applied	\N	\N	\N	\N	35578	35578	35579
10387	10273	47	applied	\N	\N	\N	\N	35589	35589	35590
10387	10274	48	applied	\N	\N	1000000000	\N	35605	35605	35606
10387	10275	49	applied	\N	\N	\N	\N	35607	35607	35608
10387	10276	50	applied	\N	\N	\N	\N	35609	35609	35610
10387	10277	51	applied	\N	\N	\N	\N	35611	35611	35612
10387	10291	52	applied	\N	\N	\N	\N	35640	35640	35641
10387	10357	53	applied	\N	\N	\N	\N	36369	36369	35826
10387	10358	54	applied	\N	\N	\N	\N	36370	36370	35828
10387	10359	55	applied	\N	\N	\N	\N	36371	36371	35830
10387	10360	56	applied	\N	\N	\N	\N	36372	36372	35832
10387	10361	57	applied	\N	\N	\N	\N	36373	36373	35834
10387	10362	58	applied	\N	\N	\N	\N	36374	36374	35836
10387	10341	59	applied	\N	\N	\N	\N	1406	1406	35772
10387	10336	60	applied	\N	\N	\N	\N	35760	35760	35761
10387	10369	61	applied	\N	\N	\N	\N	35854	35854	35855
10387	10370	62	applied	\N	\N	\N	\N	35856	35856	35857
10387	10406	63	applied	\N	\N	\N	\N	35953	35953	35954
10387	10269	64	applied	\N	\N	\N	\N	35580	35580	35581
10387	10270	65	applied	\N	\N	\N	\N	35582	35582	35583
10387	10271	66	applied	\N	\N	\N	\N	35584	35584	35585
10387	10272	67	applied	\N	\N	\N	\N	35587	35587	35588
10387	10295	68	applied	\N	\N	\N	\N	35648	35648	35649
10387	10296	69	applied	\N	\N	\N	\N	35650	35650	35651
10387	10297	70	applied	\N	\N	\N	\N	35652	35652	35653
10387	10278	71	applied	\N	\N	\N	\N	35613	35613	35614
10387	10279	72	applied	\N	\N	\N	\N	35615	35615	35616
10387	10280	73	applied	\N	\N	\N	\N	35617	35617	35618
10387	10288	74	applied	\N	\N	\N	\N	35634	35634	35635
10387	10289	75	applied	\N	\N	\N	\N	35636	35636	35637
10387	10290	76	applied	\N	\N	\N	\N	35638	35638	35639
10387	10293	77	applied	\N	\N	\N	\N	35644	35644	35645
10387	10294	78	applied	\N	\N	\N	\N	35646	35646	35647
10387	10299	79	applied	\N	\N	\N	\N	35658	35658	35659
10387	10301	80	applied	\N	\N	\N	\N	35664	35664	35665
10387	10304	81	applied	\N	\N	\N	\N	35672	35672	35673
10387	10305	82	applied	\N	\N	\N	\N	35674	35674	35675
10387	10308	83	applied	\N	\N	\N	\N	35685	35685	35686
10387	10309	84	applied	\N	\N	\N	\N	35687	35687	35688
10387	10313	85	applied	\N	\N	\N	\N	35700	35700	35701
10387	10320	86	applied	\N	\N	\N	\N	35716	35716	35717
10387	10321	87	applied	\N	\N	\N	\N	35718	35718	35719
10387	10322	88	applied	\N	\N	\N	\N	35723	35723	35724
10387	10324	89	applied	\N	\N	\N	\N	35729	35729	35730
10387	10327	90	applied	\N	\N	\N	\N	35736	35736	35737
10387	10329	91	applied	\N	\N	\N	\N	35740	35740	35741
10387	10331	92	applied	\N	\N	\N	\N	35746	35746	35747
10387	10333	93	applied	\N	\N	\N	\N	35752	35752	35753
10387	10334	94	applied	\N	\N	\N	\N	35756	35756	35757
10387	10338	95	applied	\N	\N	\N	\N	35766	35766	35767
10387	10339	96	applied	\N	\N	\N	\N	35768	35768	35769
10387	10340	97	applied	\N	\N	\N	\N	35770	35770	35771
10387	10348	98	applied	\N	\N	\N	\N	35788	35788	35789
10387	10349	99	applied	\N	\N	\N	\N	35790	35790	35791
10387	10350	100	applied	\N	\N	\N	\N	35792	35792	35793
10387	10352	101	applied	\N	\N	\N	\N	35813	35813	35814
10387	10355	102	applied	\N	\N	\N	\N	35821	35821	35822
10387	10356	103	applied	\N	\N	\N	\N	35823	35823	35824
10387	10367	104	applied	\N	\N	\N	\N	35847	35847	35848
10387	10368	105	applied	\N	\N	\N	\N	35852	35852	35853
10387	10373	106	applied	\N	\N	\N	\N	35868	35868	35869
10387	10376	107	applied	\N	\N	\N	\N	35875	35875	35876
10387	10381	108	applied	\N	\N	\N	\N	35886	35886	35887
10387	10382	109	applied	\N	\N	\N	\N	35888	35888	35889
10387	10384	110	applied	\N	\N	\N	\N	35897	35897	35898
10387	10388	111	applied	\N	\N	\N	\N	35910	35910	35911
10387	10390	112	applied	\N	\N	\N	\N	35914	35914	35915
10387	10391	113	applied	\N	\N	\N	\N	35916	35916	35917
10387	10394	114	applied	\N	\N	\N	\N	35923	35923	35924
10387	10396	115	applied	\N	\N	\N	\N	35928	35928	35929
10387	10398	116	applied	\N	\N	\N	\N	35934	35934	35935
10387	10399	117	applied	\N	\N	\N	\N	35936	35936	35937
10387	10401	118	applied	\N	\N	\N	\N	35941	35941	35942
10387	10405	119	applied	\N	\N	\N	\N	35949	35949	35950
10387	10408	120	applied	\N	\N	\N	\N	35962	35962	35963
10387	10411	121	applied	\N	\N	\N	\N	35969	35969	35970
10387	10414	122	applied	\N	\N	\N	\N	35975	35975	35976
10387	10417	123	applied	\N	\N	\N	\N	35986	35986	35987
10387	10418	124	applied	\N	\N	\N	\N	35988	35988	35989
10387	10421	125	applied	\N	\N	\N	\N	35994	35994	35995
10394	10560	0	applied	\N	\N	\N	\N	36398	36398	36399
10394	10561	1	applied	\N	\N	\N	\N	36400	36400	36401
10395	10562	0	applied	\N	\N	\N	\N	36406	36406	36407
10395	10563	1	applied	\N	\N	\N	\N	36408	36408	36409
10400	10566	0	applied	\N	\N	\N	\N	36418	36418	36419
10400	10567	1	applied	\N	\N	\N	\N	36420	36420	36421
10410	10588	0	applied	\N	\N	\N	\N	36475	36475	36476
10410	10589	1	applied	\N	\N	\N	\N	36477	36477	36478
10410	10590	2	applied	\N	\N	\N	\N	36479	36479	36480
10410	10591	3	applied	\N	\N	\N	\N	36481	36481	36482
10410	10592	4	applied	\N	\N	\N	\N	36483	36483	36484
10411	10593	0	applied	\N	\N	\N	\N	36487	36487	36488
10411	10594	1	applied	\N	\N	\N	\N	36489	36489	36490
10418	10609	0	applied	\N	\N	\N	\N	36533	36533	36534
10418	10610	1	applied	\N	\N	\N	\N	36535	36535	36536
10418	10611	2	applied	\N	\N	\N	\N	36537	36537	36538
10422	10611	0	applied	\N	\N	\N	\N	36537	36537	36538
10422	10612	1	applied	\N	\N	\N	\N	36545	36545	36546
10422	10613	2	applied	\N	\N	\N	\N	36547	36547	36548
10422	10614	3	applied	\N	\N	\N	\N	36549	36549	36550
10422	10615	4	applied	\N	\N	\N	\N	36551	36551	36552
10422	10616	5	applied	\N	\N	\N	\N	36553	36553	36554
10422	10617	6	applied	\N	\N	\N	\N	36555	36555	36556
10422	10618	7	applied	\N	\N	\N	\N	36557	36557	36558
10422	10619	8	applied	\N	\N	\N	\N	36559	36559	36560
10408	10585	1	applied	\N	\N	\N	\N	36467	36467	36468
10408	10586	2	applied	\N	\N	\N	\N	36469	36469	36470
10408	10587	3	applied	\N	\N	\N	\N	36471	36471	36472
10409	10588	0	applied	\N	\N	\N	\N	36475	36475	36476
10409	10589	1	applied	\N	\N	\N	\N	36477	36477	36478
10409	10590	2	applied	\N	\N	\N	\N	36479	36479	36480
10409	10591	3	applied	\N	\N	\N	\N	36481	36481	36482
10409	10592	4	applied	\N	\N	\N	\N	36483	36483	36484
10416	10604	0	applied	\N	\N	\N	\N	36520	36520	36521
10416	10605	1	applied	\N	\N	\N	\N	36522	36522	36523
10416	10606	2	applied	\N	\N	\N	\N	36524	36524	36525
10416	10607	3	applied	\N	\N	\N	\N	36526	36526	36527
10416	10608	4	applied	\N	\N	\N	\N	36528	36528	36529
10417	10609	0	applied	\N	\N	\N	\N	36533	36533	36534
10417	10610	1	applied	\N	\N	\N	\N	36535	36535	36536
10417	10611	2	applied	\N	\N	\N	\N	36537	36537	36538
10430	10648	0	applied	\N	\N	\N	\N	36632	36632	36633
10430	10649	1	applied	\N	\N	\N	\N	36634	36634	36635
10430	10650	2	applied	\N	\N	\N	\N	36636	36636	36637
10434	10651	0	applied	\N	\N	\N	\N	36642	36642	36643
10434	10652	1	applied	\N	\N	\N	\N	36646	36646	36647
10436	10651	0	applied	\N	\N	\N	\N	36642	36642	36643
10436	10652	1	applied	\N	\N	\N	\N	36646	36646	36647
10439	10661	0	applied	\N	\N	\N	\N	36671	36671	36672
10439	10662	1	applied	\N	\N	\N	\N	36673	36673	36674
10439	10663	2	applied	\N	\N	\N	\N	36675	36675	36676
10442	10671	0	applied	\N	\N	\N	\N	36695	36695	36696
10442	10669	1	applied	\N	\N	\N	\N	36691	36691	36692
10442	10670	2	applied	\N	\N	\N	\N	36693	36693	36694
10444	10672	0	applied	\N	\N	\N	\N	36698	36698	36699
10444	10673	1	applied	\N	\N	\N	\N	36700	36700	36701
10444	10674	2	applied	\N	\N	\N	\N	36702	36702	36703
10451	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10451	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10451	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10451	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10451	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10451	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10451	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10451	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10451	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10451	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10451	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10451	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10451	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10452	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10452	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10452	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10452	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10452	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10452	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10452	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10452	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10452	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10452	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10452	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10452	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10452	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10455	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10455	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10455	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10455	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10455	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10455	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10455	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10455	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10455	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10455	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10455	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10455	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10455	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10457	10698	0	applied	\N	\N	\N	\N	36790	36790	1435
10457	10699	1	applied	\N	\N	\N	\N	36791	36791	36792
10457	10700	2	applied	\N	\N	\N	\N	36793	36793	36794
10457	10701	3	applied	\N	\N	\N	\N	36795	36795	36796
10457	10702	4	applied	\N	\N	\N	\N	36797	36797	36798
10457	10703	5	applied	\N	\N	\N	\N	36799	36799	36800
10463	10704	0	applied	\N	\N	\N	\N	36808	36808	36809
10463	10703	1	applied	\N	\N	\N	\N	36799	36799	36800
10463	10705	2	applied	\N	\N	\N	\N	36810	36810	36811
10463	10706	3	applied	\N	\N	\N	\N	36812	36812	36813
10463	10707	4	applied	\N	\N	\N	\N	36814	36814	36815
10468	10715	0	applied	\N	\N	\N	\N	36837	36837	36838
10468	10716	1	applied	\N	\N	\N	\N	36839	36839	36840
10468	10717	2	applied	\N	\N	\N	\N	36841	36841	36842
10468	10718	3	applied	\N	\N	\N	\N	36843	36843	36844
10468	10719	4	applied	\N	\N	\N	\N	36845	36845	36846
10468	10720	5	applied	\N	\N	\N	\N	36847	36847	36848
10468	10721	6	applied	\N	\N	1000000000	\N	36849	36849	36850
10468	10722	7	applied	\N	\N	\N	\N	36851	36851	36852
10468	10723	8	applied	\N	\N	\N	\N	36853	36853	36854
10470	10728	0	applied	\N	\N	\N	\N	36868	36868	36869
10470	10729	1	applied	\N	\N	\N	\N	36870	36870	36871
10470	10730	2	applied	\N	\N	\N	\N	36872	36872	36873
10470	10731	3	applied	\N	\N	\N	\N	36874	36874	36875
10470	10732	4	applied	\N	\N	\N	\N	36876	36876	36877
10470	10733	5	applied	\N	\N	\N	\N	36878	36878	36879
10470	10734	6	applied	\N	\N	\N	\N	36880	36880	36881
10470	10735	7	applied	\N	\N	\N	\N	36882	36882	36883
10470	10736	8	applied	\N	\N	\N	\N	36884	36884	36885
10470	10737	9	applied	\N	\N	\N	\N	36886	36886	12588
10470	10738	10	applied	\N	\N	\N	\N	36887	36887	12588
10470	10739	11	applied	\N	\N	\N	\N	36888	36888	12588
10470	10740	12	applied	\N	\N	\N	\N	36889	36889	12588
10470	10741	13	applied	\N	\N	\N	\N	36890	36890	12588
10470	10742	14	applied	\N	\N	\N	\N	36891	36891	12588
10470	10743	15	applied	\N	\N	\N	\N	36892	36892	12588
10470	10744	16	applied	\N	\N	\N	\N	36893	36893	12588
10470	10745	17	applied	\N	\N	\N	\N	36894	36894	12588
10470	10746	18	applied	\N	\N	\N	\N	36895	36895	12588
10475	10754	0	applied	\N	\N	\N	\N	36915	36915	36916
10475	10755	1	applied	\N	\N	\N	\N	36917	36917	36918
10475	10756	2	applied	\N	\N	\N	\N	36919	36919	36920
10481	10764	0	applied	\N	\N	\N	\N	36943	36943	36944
10481	10765	1	applied	\N	\N	\N	\N	36945	36945	36946
10481	10766	2	applied	\N	\N	\N	\N	36947	36947	36948
10481	10767	3	applied	\N	\N	\N	\N	36949	36949	36950
10481	10768	4	applied	\N	\N	\N	\N	36951	36951	36952
10420	10619	8	applied	\N	\N	\N	\N	36559	36559	36560
10420	10620	9	applied	\N	\N	\N	\N	36561	36561	36562
10420	10621	10	applied	\N	\N	\N	\N	36563	36563	36564
10420	10622	11	applied	\N	\N	\N	\N	36565	36565	36566
10421	10611	0	applied	\N	\N	\N	\N	36537	36537	36538
10421	10612	1	applied	\N	\N	\N	\N	36545	36545	36546
10421	10613	2	applied	\N	\N	\N	\N	36547	36547	36548
10421	10614	3	applied	\N	\N	\N	\N	36549	36549	36550
10421	10615	4	applied	\N	\N	\N	\N	36551	36551	36552
10421	10616	5	applied	\N	\N	\N	\N	36553	36553	36554
10421	10617	6	applied	\N	\N	\N	\N	36555	36555	36556
10421	10618	7	applied	\N	\N	\N	\N	36557	36557	36558
10421	10619	8	applied	\N	\N	\N	\N	36559	36559	36560
10421	10620	9	applied	\N	\N	\N	\N	36561	36561	36562
10421	10621	10	applied	\N	\N	\N	\N	36563	36563	36564
10421	10622	11	applied	\N	\N	\N	\N	36565	36565	36566
10423	10623	0	applied	\N	\N	\N	\N	36573	36573	36574
10423	10624	1	applied	\N	\N	\N	\N	36575	36575	36576
10424	10623	0	applied	\N	\N	\N	\N	36573	36573	36574
10424	10624	1	applied	\N	\N	\N	\N	36575	36575	36576
10432	10648	0	applied	\N	\N	\N	\N	36632	36632	36633
10432	10649	1	applied	\N	\N	\N	\N	36634	36634	36635
10432	10650	2	applied	\N	\N	\N	\N	36636	36636	36637
10433	10648	0	applied	\N	\N	\N	\N	36632	36632	36633
10433	10651	1	applied	\N	\N	\N	\N	36642	36642	36643
10433	10649	2	applied	\N	\N	\N	\N	36634	36634	36635
10433	10650	3	applied	\N	\N	\N	\N	36636	36636	36637
10438	10657	0	applied	\N	\N	\N	\N	36661	36661	36662
10438	10658	1	applied	\N	\N	\N	\N	36663	36663	36664
10438	10659	2	applied	\N	\N	\N	\N	36665	36665	36666
10438	10660	3	applied	\N	\N	\N	\N	36667	36667	36668
10441	10669	0	applied	\N	\N	\N	\N	36691	36691	36692
10441	10670	1	applied	\N	\N	\N	\N	36693	36693	36694
10443	10672	0	applied	\N	\N	\N	\N	36698	36698	36699
10443	10673	1	applied	\N	\N	\N	\N	36700	36700	36701
10443	10674	2	applied	\N	\N	\N	\N	36702	36702	36703
10446	10675	0	applied	\N	\N	1000000000	\N	36708	36708	36709
10446	10676	1	applied	\N	\N	\N	\N	36710	36710	36711
10446	10677	2	applied	\N	\N	\N	\N	36712	36712	36713
10446	10678	3	applied	\N	\N	\N	\N	36714	36714	36715
10446	10679	4	applied	\N	\N	\N	\N	36716	36716	36717
10446	10680	5	applied	\N	\N	\N	\N	36718	36718	36719
10446	10681	6	applied	\N	\N	\N	\N	36720	36720	36721
10446	10682	7	applied	\N	\N	\N	\N	36722	36722	36723
10446	10683	8	applied	\N	\N	\N	\N	36724	36724	36725
10446	10684	9	applied	\N	\N	\N	\N	36726	36726	36727
10448	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10448	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10448	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10448	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10448	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10448	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10448	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10448	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10448	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10448	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10448	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10448	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10448	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10450	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10450	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10450	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10450	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10450	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10450	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10450	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10450	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10450	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10450	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10450	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10450	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10450	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10459	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10459	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10459	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10459	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10459	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10459	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10459	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10459	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10459	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10459	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10459	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10459	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10459	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10461	10704	0	applied	\N	\N	\N	\N	36808	36808	36809
10461	10703	1	applied	\N	\N	\N	\N	36799	36799	36800
10461	10705	2	applied	\N	\N	\N	\N	36810	36810	36811
10461	10706	3	applied	\N	\N	\N	\N	36812	36812	36813
10461	10707	4	applied	\N	\N	\N	\N	36814	36814	36815
10465	10708	0	applied	\N	\N	\N	\N	36822	36822	36823
10465	10709	1	applied	\N	\N	\N	\N	36824	36824	36825
10465	10710	2	applied	\N	\N	\N	\N	36826	36826	36827
10465	10711	3	applied	\N	\N	\N	\N	36828	36828	36829
10465	10712	4	applied	\N	\N	\N	\N	36830	36830	36831
10465	10713	5	applied	\N	\N	\N	\N	36832	36832	36833
10465	10714	6	applied	\N	\N	\N	\N	36834	36834	36835
10466	10715	0	applied	\N	\N	\N	\N	36837	36837	36838
10466	10716	1	applied	\N	\N	\N	\N	36839	36839	36840
10466	10717	2	applied	\N	\N	\N	\N	36841	36841	36842
10466	10718	3	applied	\N	\N	\N	\N	36843	36843	36844
10466	10719	4	applied	\N	\N	\N	\N	36845	36845	36846
10466	10720	5	applied	\N	\N	\N	\N	36847	36847	36848
10466	10721	6	applied	\N	\N	1000000000	\N	36849	36849	36850
10466	10722	7	applied	\N	\N	\N	\N	36851	36851	36852
10466	10723	8	applied	\N	\N	\N	\N	36853	36853	36854
10471	10747	0	applied	\N	\N	\N	\N	36898	36898	36899
10471	10748	1	applied	\N	\N	\N	\N	36900	36900	36901
10476	10754	0	applied	\N	\N	\N	\N	36915	36915	36916
10476	10757	1	applied	\N	\N	\N	\N	36923	36923	36924
10476	10755	2	applied	\N	\N	\N	\N	36917	36917	36918
10476	10758	3	applied	\N	\N	\N	\N	36925	36925	36926
10476	10756	4	applied	\N	\N	\N	\N	36919	36919	36920
10485	10779	0	applied	\N	\N	\N	\N	36981	36981	36982
10485	10780	1	applied	\N	\N	\N	\N	36983	36983	36984
10492	10781	0	applied	\N	\N	\N	\N	36992	36992	36993
10492	10782	1	applied	\N	\N	\N	\N	36994	36994	36995
10492	10783	2	applied	\N	\N	\N	\N	36996	36996	36997
10422	10620	9	applied	\N	\N	\N	\N	36561	36561	36562
10422	10621	10	applied	\N	\N	\N	\N	36563	36563	36564
10422	10622	11	applied	\N	\N	\N	\N	36565	36565	36566
10425	10625	0	applied	\N	\N	\N	\N	36581	36581	36582
10425	10626	1	applied	\N	\N	\N	\N	36583	36583	36584
10425	10627	2	applied	\N	\N	\N	\N	36585	36585	36586
10425	10628	3	applied	\N	\N	\N	\N	36587	36587	36588
10428	10631	0	applied	\N	\N	\N	\N	36595	36595	36596
10428	10632	1	applied	\N	\N	\N	\N	36597	36597	36598
10428	10633	2	applied	\N	\N	\N	\N	36599	36599	36600
10428	10634	3	applied	\N	\N	\N	\N	36601	36601	36602
10428	10635	4	applied	\N	\N	\N	\N	36603	36603	36604
10428	10636	5	applied	\N	\N	\N	\N	36605	36605	36606
10428	10637	6	applied	\N	\N	\N	\N	36607	36607	36608
10428	10638	7	applied	\N	\N	\N	\N	36609	36609	36610
10428	10639	8	applied	\N	\N	\N	\N	36611	36611	36612
10428	10640	9	applied	\N	\N	\N	\N	36613	36613	36614
10428	10641	10	applied	\N	\N	\N	\N	36615	36615	36616
10428	10642	11	applied	\N	\N	\N	\N	36617	36617	36618
10428	10643	12	applied	\N	\N	\N	\N	36619	36619	36620
10428	10644	13	applied	\N	\N	\N	\N	36621	36621	36622
10428	10645	14	applied	\N	\N	\N	\N	36623	36623	36624
10431	10648	0	applied	\N	\N	\N	\N	36632	36632	36633
10431	10649	1	applied	\N	\N	\N	\N	36634	36634	36635
10431	10650	2	applied	\N	\N	\N	\N	36636	36636	36637
10435	10651	0	applied	\N	\N	\N	\N	36642	36642	36643
10435	10652	1	applied	\N	\N	\N	\N	36646	36646	36647
10437	10653	0	applied	\N	\N	\N	\N	36652	36652	36653
10437	10654	1	applied	\N	\N	\N	\N	36654	36654	36655
10437	10655	2	applied	\N	\N	\N	\N	36656	36656	36657
10437	10656	3	applied	\N	\N	\N	\N	36658	36658	36659
10440	10664	0	applied	\N	\N	\N	\N	36679	36679	36680
10440	10665	1	applied	\N	\N	\N	\N	36681	36681	36682
10440	10666	2	applied	\N	\N	\N	\N	36683	36683	36684
10440	10667	3	applied	\N	\N	\N	\N	36685	36685	36686
10440	10668	4	applied	\N	\N	\N	\N	36687	36687	36688
10445	10675	0	applied	\N	\N	1000000000	\N	36708	36708	36709
10445	10676	1	applied	\N	\N	\N	\N	36710	36710	36711
10445	10677	2	applied	\N	\N	\N	\N	36712	36712	36713
10445	10678	3	applied	\N	\N	\N	\N	36714	36714	36715
10445	10679	4	applied	\N	\N	\N	\N	36716	36716	36717
10445	10680	5	applied	\N	\N	\N	\N	36718	36718	36719
10445	10681	6	applied	\N	\N	\N	\N	36720	36720	36721
10445	10682	7	applied	\N	\N	\N	\N	36722	36722	36723
10445	10683	8	applied	\N	\N	\N	\N	36724	36724	36725
10445	10684	9	applied	\N	\N	\N	\N	36726	36726	36727
10447	10522	0	applied	\N	\N	\N	\N	36280	36280	36281
10447	10536	1	applied	\N	\N	\N	\N	36311	36311	36312
10447	10537	2	applied	\N	\N	\N	\N	36313	36313	36314
10447	10538	3	applied	\N	\N	\N	\N	36315	36315	36316
10447	10539	4	applied	\N	\N	\N	\N	36317	36317	36318
10447	10253	5	applied	\N	\N	1000000000	\N	35532	35532	35533
10447	10109	6	applied	\N	\N	\N	\N	34996	34996	34997
10447	10515	7	applied	\N	\N	1000000000	\N	36250	36250	36251
10447	10546	8	applied	\N	\N	\N	\N	36339	36339	36340
10447	10066	9	applied	\N	\N	\N	\N	34882	34882	34883
10447	10067	10	applied	\N	\N	\N	\N	34884	34884	34885
10447	10082	11	applied	\N	\N	\N	\N	34921	34921	34922
10447	10192	12	applied	\N	\N	\N	\N	35334	35334	35335
10447	10114	13	applied	\N	\N	\N	\N	35008	35008	35009
10447	10314	14	applied	\N	\N	\N	\N	35704	35704	35705
10447	10449	15	applied	\N	\N	\N	\N	36361	36361	36067
10447	10315	16	applied	\N	\N	\N	\N	35706	35706	35707
10447	10316	17	applied	\N	\N	\N	\N	35708	35708	35709
10447	10317	18	applied	\N	\N	\N	\N	35710	35710	35711
10447	10115	19	applied	\N	\N	\N	\N	35010	35010	35011
10447	10116	20	applied	\N	\N	\N	\N	35012	35012	35013
10447	10675	21	applied	\N	\N	1000000000	\N	36708	36708	36709
10447	10083	22	applied	\N	\N	\N	\N	34923	34923	34924
10447	10337	23	applied	\N	\N	\N	\N	35764	35764	35765
10447	10453	24	applied	\N	\N	\N	\N	36363	36363	36077
10447	10084	25	applied	\N	\N	\N	\N	34925	34925	34926
10447	10085	26	applied	\N	\N	\N	\N	34927	34927	34928
10447	10454	27	applied	\N	\N	\N	\N	36364	36364	36079
10447	10455	28	applied	\N	\N	\N	\N	36365	36365	36081
10447	10345	29	applied	\N	\N	\N	\N	35781	35781	35782
10447	10354	30	applied	\N	\N	\N	\N	35819	35819	35820
10447	10372	31	applied	\N	\N	\N	\N	35866	35866	35867
10447	10378	32	applied	\N	\N	\N	\N	35880	35880	35881
10447	10385	33	applied	\N	\N	\N	\N	35904	35904	35905
10447	10143	34	applied	\N	\N	\N	\N	35197	35197	35198
10447	10527	35	applied	\N	\N	\N	\N	36291	36291	36292
10447	10672	36	applied	\N	\N	\N	\N	36731	36731	36699
10447	10038	37	applied	\N	\N	\N	\N	34807	34807	34808
10447	10040	38	applied	\N	\N	\N	\N	34814	34814	34815
10447	10043	39	applied	\N	\N	\N	\N	34823	34823	34824
10447	10661	40	applied	\N	\N	\N	\N	36732	36732	36672
10447	10076	41	applied	\N	\N	\N	\N	36733	36733	34803
10447	10044	42	applied	\N	\N	\N	\N	34825	34825	34826
10447	10568	43	applied	\N	\N	1000000000	\N	36734	36734	36424
10447	10051	44	applied	\N	\N	\N	\N	34847	34847	34848
10447	10589	45	applied	\N	\N	\N	\N	36735	36735	36478
10447	10068	46	applied	\N	\N	\N	\N	34886	34886	34887
10447	10281	47	applied	\N	\N	\N	\N	35620	35620	35621
10447	10282	48	applied	\N	\N	\N	\N	35622	35622	35623
10447	10283	49	applied	\N	\N	\N	\N	35624	35624	35625
10447	10284	50	applied	\N	\N	\N	\N	35626	35626	35627
10447	10285	51	applied	\N	\N	\N	\N	35628	35628	35629
10447	10286	52	applied	\N	\N	\N	\N	35630	35630	35631
10447	10287	53	applied	\N	\N	\N	\N	35632	35632	35633
10447	10479	54	applied	\N	\N	\N	\N	36366	36366	36138
10447	10366	55	applied	\N	\N	\N	\N	36736	36736	35845
10447	10402	56	applied	\N	\N	\N	\N	36367	36367	35944
10447	10410	57	applied	\N	\N	\N	\N	36368	36368	35968
10447	10666	58	applied	\N	\N	\N	\N	36737	36737	36684
10447	10598	59	applied	\N	\N	\N	\N	36738	36738	36508
10447	10605	60	applied	\N	\N	\N	\N	36739	36739	36523
10447	10039	61	applied	\N	\N	\N	\N	34809	34809	34810
10447	10041	62	applied	\N	\N	\N	\N	34816	34816	34817
10447	10071	63	applied	\N	\N	\N	\N	34892	34892	34893
10447	10072	64	applied	\N	\N	\N	\N	34894	34894	34895
10447	10073	65	applied	\N	\N	\N	\N	34896	34896	34897
10447	10649	66	applied	\N	\N	\N	\N	36634	36634	36635
10447	10653	67	applied	\N	\N	\N	\N	36652	36652	36653
10447	10042	68	applied	\N	\N	\N	\N	34818	34818	34819
10447	10292	69	applied	\N	\N	\N	\N	35642	35642	35643
10447	10146	70	applied	\N	\N	\N	\N	35203	35203	35204
10447	10147	71	applied	\N	\N	\N	\N	35205	35205	35206
10447	10053	72	applied	\N	\N	\N	\N	34851	34851	34852
10447	10061	73	applied	\N	\N	\N	\N	34870	34870	34871
10447	10045	75	applied	\N	\N	\N	\N	34827	34827	34828
10447	10050	76	applied	\N	\N	\N	\N	34845	34845	34846
10447	10052	77	applied	\N	\N	\N	\N	34849	34849	34850
10447	10094	78	applied	\N	\N	\N	\N	34945	34945	34946
10447	10099	79	applied	\N	\N	\N	\N	34968	34968	34969
10447	10106	80	applied	\N	\N	\N	\N	34988	34988	34989
10447	10611	81	applied	\N	\N	\N	\N	36741	36741	36538
10447	10612	82	applied	\N	\N	\N	\N	36742	36742	36546
10447	10148	83	applied	\N	\N	\N	\N	35207	35207	35208
10447	10149	84	applied	\N	\N	\N	\N	35209	35209	35210
10447	10150	85	applied	\N	\N	\N	\N	35211	35211	35212
10447	10151	86	applied	\N	\N	\N	\N	35213	35213	35214
10447	10054	87	applied	\N	\N	\N	\N	34853	34853	34854
10447	10055	88	applied	\N	\N	\N	\N	34855	34855	34856
10447	10056	89	applied	\N	\N	\N	\N	34857	34857	34858
10447	10074	90	applied	\N	\N	\N	\N	34898	34898	34899
10447	10077	91	applied	\N	\N	\N	\N	34904	34904	34905
10447	10079	92	applied	\N	\N	\N	\N	34910	34910	34911
10447	10086	93	applied	\N	\N	\N	\N	34929	34929	34930
10447	10087	94	applied	\N	\N	\N	\N	34931	34931	34932
10447	10088	95	applied	\N	\N	\N	\N	34933	34933	34934
10447	10092	96	applied	\N	\N	\N	\N	34941	34941	34942
10447	10097	97	applied	\N	\N	\N	\N	34953	34953	34954
10447	10101	98	applied	\N	\N	\N	\N	34972	34972	34973
10447	10103	99	applied	\N	\N	\N	\N	34978	34978	34979
10447	10062	100	applied	\N	\N	\N	\N	34872	34872	34903
10447	10336	101	applied	\N	\N	\N	\N	35760	35760	35761
10447	10369	102	applied	\N	\N	\N	\N	35854	35854	35855
10447	10370	103	applied	\N	\N	\N	\N	35856	35856	35857
10447	10406	104	applied	\N	\N	\N	\N	35953	35953	35954
10447	10107	105	applied	\N	\N	\N	\N	34990	34990	34991
10447	10112	106	applied	\N	\N	\N	\N	35002	35002	35003
10447	10113	107	applied	\N	\N	\N	\N	35004	35004	35005
10447	10152	108	applied	\N	\N	\N	\N	35215	35215	35216
10447	10153	109	applied	\N	\N	\N	\N	35217	35217	35218
10447	10357	110	applied	\N	\N	\N	\N	36369	36369	35826
10447	10358	111	applied	\N	\N	\N	\N	36370	36370	35828
10447	10359	112	applied	\N	\N	\N	\N	36371	36371	35830
10447	10360	113	applied	\N	\N	\N	\N	36372	36372	35832
10447	10361	114	applied	\N	\N	\N	\N	36373	36373	35834
10447	10362	115	applied	\N	\N	\N	\N	36374	36374	35836
10447	10154	116	applied	\N	\N	\N	\N	35219	35219	35220
10447	10119	117	applied	\N	\N	\N	\N	35117	35117	35118
10447	10121	118	applied	\N	\N	\N	\N	35123	35123	35124
10447	10122	119	applied	\N	\N	\N	\N	35125	35125	35126
10447	10123	120	applied	\N	\N	\N	\N	35127	35127	35128
10447	10127	121	applied	\N	\N	\N	\N	35137	35137	35138
10447	10130	122	applied	\N	\N	\N	\N	35148	35148	35149
10447	10131	123	applied	\N	\N	\N	\N	35154	35154	35155
10447	10133	124	applied	\N	\N	\N	\N	35160	35160	35161
10447	10136	125	applied	\N	\N	\N	\N	35170	35170	35171
10453	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10453	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10453	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10453	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10453	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10453	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10453	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10453	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10453	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10453	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10453	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10453	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10453	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10456	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10456	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10456	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10456	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10456	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10456	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10456	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10456	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10456	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10456	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10456	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10456	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10456	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10458	10698	0	applied	\N	\N	\N	\N	36790	36790	1435
10458	10699	1	applied	\N	\N	\N	\N	36791	36791	36792
10458	10700	2	applied	\N	\N	\N	\N	36793	36793	36794
10458	10701	3	applied	\N	\N	\N	\N	36795	36795	36796
10458	10702	4	applied	\N	\N	\N	\N	36797	36797	36798
10473	10749	0	applied	\N	\N	\N	\N	36708	36708	1435
10473	10750	1	applied	\N	\N	\N	\N	36905	36905	36906
10473	10751	2	applied	\N	\N	\N	\N	36907	36907	36908
10478	10759	0	applied	\N	\N	1000000000	\N	36929	36929	36930
10478	10756	1	applied	\N	\N	\N	\N	36919	36919	36920
10482	10764	0	applied	\N	\N	\N	\N	36943	36943	36944
10482	10765	1	applied	\N	\N	\N	\N	36945	36945	36946
10482	10766	2	applied	\N	\N	\N	\N	36947	36947	36948
10482	10767	3	applied	\N	\N	\N	\N	36949	36949	36950
10482	10768	4	applied	\N	\N	\N	\N	36951	36951	36952
10482	10769	5	applied	\N	\N	\N	\N	36953	36953	36954
10488	10779	0	applied	\N	\N	\N	\N	36981	36981	36982
10488	10780	1	applied	\N	\N	\N	\N	36983	36983	36984
10494	10781	0	applied	\N	\N	\N	\N	36992	36992	36993
10494	10782	1	applied	\N	\N	\N	\N	36994	36994	36995
10494	10783	2	applied	\N	\N	\N	\N	36996	36996	36997
10494	10784	3	applied	\N	\N	\N	\N	36998	36998	36999
10494	10785	4	applied	\N	\N	\N	\N	37000	37000	37001
10494	10786	5	applied	\N	\N	\N	\N	37002	37002	37003
10494	10787	6	applied	\N	\N	\N	\N	37004	37004	37005
10494	10788	7	applied	\N	\N	\N	\N	37006	37006	37007
10494	10789	8	applied	\N	\N	\N	\N	37008	37008	37009
10494	10790	9	applied	\N	\N	\N	\N	37010	37010	37011
10494	10791	10	applied	\N	\N	\N	\N	37012	37012	37013
10494	10792	11	applied	\N	\N	\N	\N	37014	37014	37015
10494	10793	12	applied	\N	\N	\N	\N	37016	37016	37017
10494	10794	13	applied	\N	\N	\N	\N	37018	37018	37019
10494	10795	14	applied	\N	\N	\N	\N	37020	37020	37021
10494	10796	15	applied	\N	\N	\N	\N	37022	37022	37023
10494	10797	16	applied	\N	\N	\N	\N	37024	37024	37025
10494	10798	17	applied	\N	\N	\N	\N	37026	37026	37027
10494	10799	18	applied	\N	\N	\N	\N	37028	37028	37029
10494	10800	19	applied	\N	\N	\N	\N	37030	37030	37031
10494	10801	20	applied	\N	\N	\N	\N	37032	37032	37033
10494	10802	21	applied	\N	\N	\N	\N	37034	37034	37035
10496	10804	0	applied	\N	\N	\N	\N	37043	37043	37044
10454	10685	0	applied	\N	\N	\N	\N	36745	36745	36746
10454	10686	2	applied	\N	\N	\N	\N	36748	36748	36749
10454	10687	3	applied	\N	\N	\N	\N	36750	36750	36751
10454	10688	4	applied	\N	\N	\N	\N	36752	36752	36753
10454	10689	5	applied	\N	\N	\N	\N	36754	36754	36755
10454	10690	6	applied	\N	\N	\N	\N	36756	36756	36757
10454	10691	7	applied	\N	\N	\N	\N	36758	36758	36759
10454	10692	8	applied	\N	\N	\N	\N	36760	36760	36761
10454	10693	9	applied	\N	\N	1000000000	\N	36762	36762	36763
10454	10694	10	applied	\N	\N	1000000000	\N	36764	36764	36765
10454	10695	11	applied	\N	\N	1000000000	\N	36766	36766	36767
10454	10696	12	applied	\N	\N	\N	\N	36768	36768	36769
10454	10697	13	applied	\N	\N	\N	\N	36770	36770	36771
10460	10698	0	applied	\N	\N	\N	\N	36790	36790	1435
10460	10699	1	applied	\N	\N	\N	\N	36791	36791	36792
10460	10700	2	applied	\N	\N	\N	\N	36793	36793	36794
10460	10701	3	applied	\N	\N	\N	\N	36795	36795	36796
10460	10702	4	applied	\N	\N	\N	\N	36797	36797	36798
10462	10698	0	applied	\N	\N	\N	\N	36790	36790	1435
10462	10699	1	applied	\N	\N	\N	\N	36791	36791	36792
10462	10700	2	applied	\N	\N	\N	\N	36793	36793	36794
10462	10701	3	applied	\N	\N	\N	\N	36795	36795	36796
10462	10702	4	applied	\N	\N	\N	\N	36797	36797	36798
10467	10715	0	applied	\N	\N	\N	\N	36837	36837	36838
10467	10716	1	applied	\N	\N	\N	\N	36839	36839	36840
10467	10717	2	applied	\N	\N	\N	\N	36841	36841	36842
10467	10718	3	applied	\N	\N	\N	\N	36843	36843	36844
10467	10719	4	applied	\N	\N	\N	\N	36845	36845	36846
10467	10720	5	applied	\N	\N	\N	\N	36847	36847	36848
10467	10721	6	applied	\N	\N	1000000000	\N	36849	36849	36850
10467	10722	7	applied	\N	\N	\N	\N	36851	36851	36852
10467	10723	8	applied	\N	\N	\N	\N	36853	36853	36854
10469	10724	0	applied	\N	\N	\N	\N	36858	36858	36859
10469	10725	1	applied	\N	\N	\N	\N	36860	36860	36861
10469	10726	2	applied	\N	\N	\N	\N	36862	36862	36863
10469	10727	3	applied	\N	\N	\N	\N	36864	36864	36865
10472	10747	0	applied	\N	\N	\N	\N	36898	36898	36899
10472	10748	1	applied	\N	\N	\N	\N	36900	36900	36901
10474	10752	0	applied	\N	\N	\N	\N	36910	36910	36911
10474	10753	1	applied	\N	\N	\N	\N	36912	36912	36913
10477	10759	0	applied	\N	\N	1000000000	\N	36929	36929	36930
10477	10757	1	applied	\N	\N	\N	\N	36923	36923	36924
10477	10760	2	applied	\N	\N	\N	\N	36931	36931	36932
10477	10758	3	applied	\N	\N	\N	\N	36925	36925	36926
10477	10761	4	applied	\N	\N	\N	\N	36933	36933	36934
10479	10762	0	applied	\N	\N	\N	\N	36938	36938	36939
10479	10763	1	applied	\N	\N	\N	\N	36940	36940	36941
10480	10764	0	applied	\N	\N	\N	\N	36943	36943	36944
10480	10765	1	applied	\N	\N	\N	\N	36945	36945	36946
10480	10766	2	applied	\N	\N	\N	\N	36947	36947	36948
10480	10767	3	applied	\N	\N	\N	\N	36949	36949	36950
10480	10768	4	applied	\N	\N	\N	\N	36951	36951	36952
10480	10769	5	applied	\N	\N	\N	\N	36953	36953	36954
10483	10770	0	applied	\N	\N	\N	\N	36960	36960	36961
10483	10771	1	applied	\N	\N	\N	\N	36962	36962	36963
10483	10772	2	applied	\N	\N	\N	\N	36964	36964	36965
10483	10773	3	applied	\N	\N	\N	\N	36966	36966	36967
10483	10774	4	applied	\N	\N	\N	\N	36968	36968	36969
10483	10775	5	applied	\N	\N	\N	\N	36970	36970	36971
10483	10776	6	applied	\N	\N	\N	\N	36972	36972	36973
10483	10777	7	applied	\N	\N	\N	\N	36974	36974	36975
10483	10778	8	applied	\N	\N	\N	\N	36976	36976	36977
10486	10779	0	applied	\N	\N	\N	\N	36981	36981	36982
10486	10780	1	applied	\N	\N	\N	\N	36983	36983	36984
10489	10779	0	applied	\N	\N	\N	\N	36981	36981	36982
10489	10780	1	applied	\N	\N	\N	\N	36983	36983	36984
10493	10781	0	applied	\N	\N	\N	\N	36992	36992	36993
10493	10782	1	applied	\N	\N	\N	\N	36994	36994	36995
10493	10783	2	applied	\N	\N	\N	\N	36996	36996	36997
10493	10784	3	applied	\N	\N	\N	\N	36998	36998	36999
10493	10785	4	applied	\N	\N	\N	\N	37000	37000	37001
10493	10786	5	applied	\N	\N	\N	\N	37002	37002	37003
10493	10787	6	applied	\N	\N	\N	\N	37004	37004	37005
10493	10788	7	applied	\N	\N	\N	\N	37006	37006	37007
10493	10789	8	applied	\N	\N	\N	\N	37008	37008	37009
10493	10790	9	applied	\N	\N	\N	\N	37010	37010	37011
10493	10791	10	applied	\N	\N	\N	\N	37012	37012	37013
10493	10792	11	applied	\N	\N	\N	\N	37014	37014	37015
10493	10793	12	applied	\N	\N	\N	\N	37016	37016	37017
10493	10794	13	applied	\N	\N	\N	\N	37018	37018	37019
10493	10795	14	applied	\N	\N	\N	\N	37020	37020	37021
10493	10796	15	applied	\N	\N	\N	\N	37022	37022	37023
10493	10797	16	applied	\N	\N	\N	\N	37024	37024	37025
10493	10798	17	applied	\N	\N	\N	\N	37026	37026	37027
10493	10799	18	applied	\N	\N	\N	\N	37028	37028	37029
10493	10800	19	applied	\N	\N	\N	\N	37030	37030	37031
10493	10801	20	applied	\N	\N	\N	\N	37032	37032	37033
10493	10802	21	applied	\N	\N	\N	\N	37034	37034	37035
10495	10803	0	applied	\N	\N	\N	\N	37039	37039	37040
10502	10817	0	applied	\N	\N	\N	\N	37077	37077	37078
10502	10818	1	applied	\N	\N	\N	\N	37079	37079	37080
10502	10819	2	applied	\N	\N	\N	\N	37081	37081	37082
10502	10820	3	applied	\N	\N	\N	\N	37083	37083	37084
10506	10823	0	applied	\N	\N	\N	\N	37094	37094	37095
10506	10824	1	applied	\N	\N	\N	\N	37096	37096	37097
10506	10825	2	applied	\N	\N	\N	\N	37098	37098	37099
10506	10826	3	applied	\N	\N	\N	\N	37100	37100	37101
10506	10827	4	applied	\N	\N	\N	\N	37102	37102	37103
10506	10828	5	applied	\N	\N	\N	\N	37104	37104	37105
10506	10829	6	applied	\N	\N	\N	\N	37106	37106	37107
10506	10830	7	applied	\N	\N	\N	\N	37108	37108	37109
10506	10831	8	applied	\N	\N	\N	\N	37110	37110	37111
10511	10833	0	applied	\N	\N	\N	\N	37119	37119	37120
10511	10832	1	applied	\N	\N	\N	\N	37116	37116	37117
10515	10834	0	applied	\N	\N	\N	\N	37125	37125	37126
10515	10835	1	applied	\N	\N	\N	\N	37127	37127	37128
10515	10836	2	applied	\N	\N	\N	\N	37130	37130	37131
10515	10837	3	applied	\N	\N	\N	\N	37132	37132	37133
10515	10838	4	applied	\N	\N	\N	\N	37134	37134	37135
10515	10839	5	applied	\N	\N	\N	\N	37136	37136	37137
10517	10842	0	applied	\N	\N	\N	\N	37144	37144	37145
10517	10843	1	applied	\N	\N	\N	\N	37146	37146	37147
10519	10842	0	applied	\N	\N	\N	\N	37144	37144	37145
10519	10843	1	applied	\N	\N	\N	\N	37146	37146	37147
10522	10846	0	applied	\N	\N	\N	\N	37157	37157	37158
10522	10847	1	applied	\N	\N	\N	\N	37159	37159	37160
10522	10848	2	applied	\N	\N	\N	\N	37161	37161	37162
10522	10849	3	applied	\N	\N	\N	\N	37163	37163	37164
10527	10823	0	applied	\N	\N	\N	\N	37094	37094	37095
10481	10769	5	applied	\N	\N	\N	\N	36953	36953	36954
10484	10770	0	applied	\N	\N	\N	\N	36960	36960	36961
10484	10771	1	applied	\N	\N	\N	\N	36962	36962	36963
10484	10772	2	applied	\N	\N	\N	\N	36964	36964	36965
10484	10773	3	applied	\N	\N	\N	\N	36966	36966	36967
10484	10774	4	applied	\N	\N	\N	\N	36968	36968	36969
10484	10775	5	applied	\N	\N	\N	\N	36970	36970	36971
10484	10776	6	applied	\N	\N	\N	\N	36972	36972	36973
10484	10777	7	applied	\N	\N	\N	\N	36974	36974	36975
10484	10778	8	applied	\N	\N	\N	\N	36976	36976	36977
10487	10779	0	applied	\N	\N	\N	\N	36981	36981	36982
10487	10780	1	applied	\N	\N	\N	\N	36983	36983	36984
10490	10770	0	applied	\N	\N	\N	\N	36960	36960	36961
10490	10771	1	applied	\N	\N	\N	\N	36962	36962	36963
10490	10772	2	applied	\N	\N	\N	\N	36964	36964	36965
10490	10773	3	applied	\N	\N	\N	\N	36966	36966	36967
10490	10774	4	applied	\N	\N	\N	\N	36968	36968	36969
10490	10775	5	applied	\N	\N	\N	\N	36970	36970	36971
10490	10779	6	applied	\N	\N	\N	\N	36981	36981	36982
10490	10776	7	applied	\N	\N	\N	\N	36972	36972	36973
10490	10777	8	applied	\N	\N	\N	\N	36974	36974	36975
10490	10778	9	applied	\N	\N	\N	\N	36976	36976	36977
10490	10780	10	applied	\N	\N	\N	\N	36983	36983	36984
10498	10804	0	applied	\N	\N	\N	\N	37043	37043	37044
10498	10805	1	applied	\N	\N	\N	\N	37045	37045	37046
10498	10806	2	applied	\N	\N	\N	\N	37047	37047	37048
10498	10807	3	applied	\N	\N	\N	\N	37049	37049	37050
10498	10808	4	applied	\N	\N	\N	\N	37051	37051	37052
10498	10809	5	applied	\N	\N	\N	\N	37053	37053	37054
10498	10810	6	applied	\N	\N	\N	\N	37055	37055	37056
10498	10811	7	applied	\N	\N	\N	\N	37057	37057	37058
10498	10812	8	applied	\N	\N	\N	\N	37059	37059	37060
10498	10813	9	applied	\N	\N	\N	\N	37061	37061	37062
10498	10814	10	applied	\N	\N	\N	\N	37063	37063	37064
10500	10804	0	applied	\N	\N	\N	\N	37043	37043	37044
10500	10805	1	applied	\N	\N	\N	\N	37045	37045	37046
10500	10806	2	applied	\N	\N	\N	\N	37047	37047	37048
10500	10807	3	applied	\N	\N	\N	\N	37049	37049	37050
10500	10808	4	applied	\N	\N	\N	\N	37051	37051	37052
10500	10809	5	applied	\N	\N	\N	\N	37053	37053	37054
10500	10810	6	applied	\N	\N	\N	\N	37055	37055	37056
10500	10811	7	applied	\N	\N	\N	\N	37057	37057	37058
10500	10812	8	applied	\N	\N	\N	\N	37059	37059	37060
10500	10813	9	applied	\N	\N	\N	\N	37061	37061	37062
10500	10814	10	applied	\N	\N	\N	\N	37063	37063	37064
10508	10832	0	applied	\N	\N	\N	\N	37116	37116	37117
10523	10846	0	applied	\N	\N	\N	\N	37157	37157	37158
10523	10847	1	applied	\N	\N	\N	\N	37159	37159	37160
10523	10848	2	applied	\N	\N	\N	\N	37161	37161	37162
10523	10849	3	applied	\N	\N	\N	\N	37163	37163	37164
10525	10850	0	applied	\N	\N	\N	\N	37172	37172	37173
10525	10851	1	applied	\N	\N	\N	\N	37174	37174	37175
10525	10852	2	applied	\N	\N	\N	\N	37176	37176	37177
10525	10853	3	applied	\N	\N	\N	\N	37178	37178	37179
10525	10854	4	applied	\N	\N	\N	\N	37180	37180	37181
10525	10855	5	applied	\N	\N	\N	\N	37182	37182	37183
10525	10856	6	applied	\N	\N	\N	\N	37184	37184	37185
10525	10857	7	applied	\N	\N	\N	\N	37186	37186	37187
10530	10862	0	applied	\N	\N	\N	\N	37209	37209	37210
10530	10863	1	applied	\N	\N	\N	\N	37211	37211	37212
10530	10864	2	applied	\N	\N	1000000000	\N	37213	37213	37214
10530	10865	3	applied	\N	\N	\N	\N	37215	37215	37216
10533	10870	0	applied	\N	\N	\N	\N	37229	37229	37230
10533	10871	1	applied	\N	\N	\N	\N	37231	37231	37232
10533	10872	2	applied	\N	\N	\N	\N	37233	37233	37234
10533	10873	3	applied	\N	\N	\N	\N	37235	37235	37236
10533	10874	5	applied	\N	\N	\N	\N	37238	37238	1435
10538	10881	0	applied	\N	\N	\N	\N	37258	37258	37259
10538	10882	1	applied	\N	\N	\N	\N	37260	37260	37261
10544	10888	0	applied	\N	\N	\N	\N	37277	37277	37278
10544	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10547	10890	0	applied	\N	\N	\N	\N	37287	37287	37288
10547	10891	1	applied	\N	\N	\N	\N	37289	37289	37290
10547	10892	2	applied	\N	\N	\N	\N	37291	37291	37292
10547	10893	3	applied	\N	\N	\N	\N	37293	37293	37294
10547	10894	4	applied	\N	\N	\N	\N	37295	37295	37296
10553	10900	0	applied	\N	\N	\N	\N	37329	37329	37330
10553	10901	1	applied	\N	\N	\N	\N	37331	37331	37332
10553	10902	2	applied	\N	\N	\N	\N	37333	37333	37334
10553	10903	3	applied	\N	\N	\N	\N	37335	37335	37336
10553	10897	4	applied	\N	\N	\N	\N	37322	37322	37339
10553	10898	5	applied	\N	\N	\N	\N	37324	37324	37340
10553	10899	6	applied	\N	\N	\N	\N	37326	37326	37341
10555	10900	0	applied	\N	\N	\N	\N	37329	37329	37330
10555	10901	1	applied	\N	\N	\N	\N	37331	37331	37332
10555	10902	2	applied	\N	\N	\N	\N	37333	37333	37334
10555	10903	3	applied	\N	\N	\N	\N	37335	37335	37336
10555	10905	4	applied	\N	\N	\N	\N	37348	37348	37349
10555	10897	5	applied	\N	\N	\N	\N	37322	37322	37339
10555	10898	6	applied	\N	\N	\N	\N	37324	37324	37340
10555	10899	7	applied	\N	\N	\N	\N	37326	37326	37341
10555	10904	8	applied	\N	\N	\N	\N	37346	37346	37347
10557	10906	0	applied	\N	\N	\N	\N	37354	37354	37355
10557	10907	1	applied	\N	\N	\N	\N	37357	37357	37358
10557	10908	2	applied	\N	\N	\N	\N	37359	37359	37360
10557	10909	3	applied	\N	\N	\N	\N	37361	37361	37362
10563	10916	0	applied	\N	\N	\N	\N	37438	37438	37439
10563	10917	1	applied	\N	\N	\N	\N	37440	37440	37441
10563	10918	2	applied	\N	\N	\N	\N	37444	37444	37445
10563	10919	3	applied	\N	\N	\N	\N	37446	37446	37447
10565	10922	0	applied	\N	\N	\N	\N	37456	37456	37457
10565	10923	1	applied	\N	\N	\N	\N	37458	37458	37459
10567	10922	0	applied	\N	\N	\N	\N	37456	37456	37457
10567	10923	1	applied	\N	\N	\N	\N	37458	37458	37459
10569	10922	0	applied	\N	\N	\N	\N	37456	37456	37457
10569	10923	1	applied	\N	\N	\N	\N	37458	37458	37459
10574	10929	0	applied	\N	\N	\N	\N	37485	37485	37486
10574	10930	1	applied	\N	\N	\N	\N	37487	37487	37488
10574	10931	2	applied	\N	\N	\N	\N	37489	37489	37490
10577	10935	0	applied	\N	\N	\N	\N	37499	37499	37500
10577	10936	1	applied	\N	\N	\N	\N	37501	37501	37502
10580	10945	0	applied	\N	\N	\N	\N	37525	37525	37526
10580	10946	1	applied	\N	\N	\N	\N	37527	37527	37528
10583	10947	0	applied	\N	\N	\N	\N	37532	37532	37533
10583	10948	1	applied	\N	\N	\N	\N	37534	37534	37535
10585	10947	0	applied	\N	\N	\N	\N	37532	37532	37533
10585	10948	1	applied	\N	\N	\N	\N	37534	37534	37535
10587	10951	0	applied	\N	\N	\N	\N	37548	37548	37549
10587	10952	1	applied	\N	\N	\N	\N	37550	37550	37551
10590	10955	0	applied	\N	\N	\N	\N	37558	37558	37559
10492	10784	3	applied	\N	\N	\N	\N	36998	36998	36999
10492	10785	4	applied	\N	\N	\N	\N	37000	37000	37001
10492	10786	5	applied	\N	\N	\N	\N	37002	37002	37003
10492	10787	6	applied	\N	\N	\N	\N	37004	37004	37005
10492	10788	7	applied	\N	\N	\N	\N	37006	37006	37007
10492	10789	8	applied	\N	\N	\N	\N	37008	37008	37009
10492	10790	9	applied	\N	\N	\N	\N	37010	37010	37011
10492	10791	10	applied	\N	\N	\N	\N	37012	37012	37013
10492	10792	11	applied	\N	\N	\N	\N	37014	37014	37015
10492	10793	12	applied	\N	\N	\N	\N	37016	37016	37017
10492	10794	13	applied	\N	\N	\N	\N	37018	37018	37019
10492	10795	14	applied	\N	\N	\N	\N	37020	37020	37021
10492	10796	15	applied	\N	\N	\N	\N	37022	37022	37023
10492	10797	16	applied	\N	\N	\N	\N	37024	37024	37025
10492	10798	17	applied	\N	\N	\N	\N	37026	37026	37027
10492	10799	18	applied	\N	\N	\N	\N	37028	37028	37029
10492	10800	19	applied	\N	\N	\N	\N	37030	37030	37031
10492	10801	20	applied	\N	\N	\N	\N	37032	37032	37033
10492	10802	21	applied	\N	\N	\N	\N	37034	37034	37035
10497	10804	0	applied	\N	\N	\N	\N	37043	37043	37044
10497	10805	1	applied	\N	\N	\N	\N	37045	37045	37046
10497	10806	2	applied	\N	\N	\N	\N	37047	37047	37048
10497	10807	3	applied	\N	\N	\N	\N	37049	37049	37050
10497	10808	4	applied	\N	\N	\N	\N	37051	37051	37052
10497	10809	5	applied	\N	\N	\N	\N	37053	37053	37054
10497	10810	6	applied	\N	\N	\N	\N	37055	37055	37056
10497	10811	7	applied	\N	\N	\N	\N	37057	37057	37058
10497	10812	8	applied	\N	\N	\N	\N	37059	37059	37060
10497	10813	9	applied	\N	\N	\N	\N	37061	37061	37062
10497	10814	10	applied	\N	\N	\N	\N	37063	37063	37064
10499	10804	0	applied	\N	\N	\N	\N	37043	37043	37044
10499	10805	1	applied	\N	\N	\N	\N	37045	37045	37046
10499	10806	2	applied	\N	\N	\N	\N	37047	37047	37048
10499	10807	3	applied	\N	\N	\N	\N	37049	37049	37050
10499	10808	4	applied	\N	\N	\N	\N	37051	37051	37052
10499	10809	5	applied	\N	\N	\N	\N	37053	37053	37054
10499	10810	6	applied	\N	\N	\N	\N	37055	37055	37056
10499	10811	7	applied	\N	\N	\N	\N	37057	37057	37058
10499	10812	8	applied	\N	\N	\N	\N	37059	37059	37060
10499	10813	9	applied	\N	\N	\N	\N	37061	37061	37062
10499	10814	10	applied	\N	\N	\N	\N	37063	37063	37064
10501	10815	0	applied	\N	\N	\N	\N	37072	37072	37073
10501	10816	1	applied	\N	\N	\N	\N	37074	37074	37075
10504	10821	0	applied	\N	\N	\N	\N	37087	37087	37088
10504	10822	1	applied	\N	\N	\N	\N	37089	37089	37090
10505	10823	0	applied	\N	\N	\N	\N	37094	37094	37095
10505	10824	1	applied	\N	\N	\N	\N	37096	37096	37097
10505	10825	2	applied	\N	\N	\N	\N	37098	37098	37099
10505	10826	3	applied	\N	\N	\N	\N	37100	37100	37101
10505	10827	4	applied	\N	\N	\N	\N	37102	37102	37103
10505	10828	5	applied	\N	\N	\N	\N	37104	37104	37105
10505	10829	6	applied	\N	\N	\N	\N	37106	37106	37107
10505	10830	7	applied	\N	\N	\N	\N	37108	37108	37109
10505	10831	8	applied	\N	\N	\N	\N	37110	37110	37111
10510	10833	0	applied	\N	\N	\N	\N	37119	37119	37120
10510	10832	1	applied	\N	\N	\N	\N	37116	37116	37117
10514	10834	0	applied	\N	\N	\N	\N	37125	37125	37126
10514	10835	1	applied	\N	\N	\N	\N	37127	37127	37128
10514	10836	2	applied	\N	\N	\N	\N	37130	37130	37131
10514	10837	3	applied	\N	\N	\N	\N	37132	37132	37133
10514	10838	4	applied	\N	\N	\N	\N	37134	37134	37135
10514	10839	5	applied	\N	\N	\N	\N	37136	37136	37137
10516	10840	0	applied	\N	\N	\N	\N	37139	37139	37140
10516	10841	1	applied	\N	\N	\N	\N	37141	37141	37142
10521	10846	0	applied	\N	\N	\N	\N	37157	37157	37158
10521	10847	1	applied	\N	\N	\N	\N	37159	37159	37160
10521	10848	2	applied	\N	\N	\N	\N	37161	37161	37162
10521	10849	3	applied	\N	\N	\N	\N	37163	37163	37164
10526	10850	0	applied	\N	\N	\N	\N	37172	37172	37173
10526	10851	1	applied	\N	\N	\N	\N	37174	37174	37175
10526	10852	2	applied	\N	\N	\N	\N	37176	37176	37177
10526	10853	3	applied	\N	\N	\N	\N	37178	37178	37179
10526	10854	4	applied	\N	\N	\N	\N	37180	37180	37181
10526	10855	5	applied	\N	\N	\N	\N	37182	37182	37183
10526	10856	6	applied	\N	\N	\N	\N	37184	37184	37185
10526	10857	7	applied	\N	\N	\N	\N	37186	37186	37187
10529	10858	0	applied	\N	\N	\N	\N	37192	37192	37193
10529	10859	1	applied	\N	\N	\N	\N	37194	37194	37195
10529	10860	2	applied	\N	\N	\N	\N	37200	37200	37205
10529	10861	3	applied	\N	\N	\N	\N	37202	37202	37206
10532	10866	0	applied	\N	\N	\N	\N	37219	37219	37220
10532	10867	1	applied	\N	\N	\N	\N	37221	37221	37222
10532	10868	2	applied	\N	\N	\N	\N	37223	37223	37224
10532	10869	3	applied	\N	\N	\N	\N	37225	37225	31061
10534	10875	0	applied	\N	\N	\N	\N	37240	37240	37241
10534	10876	1	applied	\N	\N	\N	\N	37242	37242	37243
10539	10883	0	applied	\N	\N	\N	\N	37263	37263	37264
10539	10884	1	applied	\N	\N	\N	\N	37265	37265	37266
10539	10885	2	applied	\N	\N	1000000000	\N	37267	37267	37268
10542	10888	0	applied	\N	\N	\N	\N	37277	37277	37278
10542	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10545	10886	0	applied	\N	\N	\N	\N	37271	37271	37272
10545	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10545	10887	2	applied	\N	\N	\N	\N	37273	37273	37274
10545	10888	3	applied	\N	\N	\N	\N	37277	37277	37278
10556	10904	0	applied	\N	\N	\N	\N	37346	37346	37347
10556	10905	1	applied	\N	\N	\N	\N	37348	37348	37349
10556	10906	2	applied	\N	\N	\N	\N	37354	37354	37355
10559	10912	0	applied	\N	\N	\N	\N	37426	37426	37427
10559	10913	1	applied	\N	\N	\N	\N	37428	37428	37429
10564	10920	0	applied	\N	\N	\N	\N	37450	37450	37451
10564	10921	1	applied	\N	\N	\N	\N	37452	37452	37453
10571	10924	0	applied	\N	\N	\N	\N	37470	37470	37471
10571	10925	1	applied	\N	\N	\N	\N	37472	37472	37473
10573	10926	0	applied	\N	\N	\N	\N	37477	37477	37478
10573	10927	1	applied	\N	\N	\N	\N	37479	37479	37480
10573	10928	2	applied	\N	\N	\N	\N	37482	37482	37483
10576	10935	0	applied	\N	\N	\N	\N	37499	37499	37500
10576	10936	1	applied	\N	\N	\N	\N	37501	37501	37502
10579	10943	0	applied	\N	\N	\N	\N	37521	37521	37522
10579	10944	1	applied	\N	\N	\N	\N	37523	37523	37524
10584	10947	0	applied	\N	\N	\N	\N	37532	37532	37533
10584	10948	1	applied	\N	\N	\N	\N	37534	37534	37535
10588	10953	0	applied	\N	\N	\N	\N	37552	37552	37553
10588	10954	1	applied	\N	\N	\N	\N	37554	37554	37555
10591	10955	0	applied	\N	\N	\N	\N	37558	37558	37559
10591	10956	1	applied	\N	\N	\N	\N	37560	37560	37561
10591	10957	2	applied	\N	\N	\N	\N	37562	37562	37563
10591	10958	3	applied	\N	\N	\N	\N	37564	37564	37565
10593	10959	0	applied	\N	\N	\N	\N	37570	37570	37571
10496	10805	1	applied	\N	\N	\N	\N	37045	37045	37046
10496	10806	2	applied	\N	\N	\N	\N	37047	37047	37048
10496	10807	3	applied	\N	\N	\N	\N	37049	37049	37050
10496	10808	4	applied	\N	\N	\N	\N	37051	37051	37052
10496	10809	5	applied	\N	\N	\N	\N	37053	37053	37054
10496	10810	6	applied	\N	\N	\N	\N	37055	37055	37056
10496	10811	7	applied	\N	\N	\N	\N	37057	37057	37058
10496	10812	8	applied	\N	\N	\N	\N	37059	37059	37060
10496	10813	9	applied	\N	\N	\N	\N	37061	37061	37062
10496	10814	10	applied	\N	\N	\N	\N	37063	37063	37064
10503	10821	0	applied	\N	\N	\N	\N	37087	37087	37088
10503	10822	1	applied	\N	\N	\N	\N	37089	37089	37090
10507	10823	0	applied	\N	\N	\N	\N	37094	37094	37095
10507	10824	1	applied	\N	\N	\N	\N	37096	37096	37097
10507	10825	2	applied	\N	\N	\N	\N	37098	37098	37099
10507	10826	3	applied	\N	\N	\N	\N	37100	37100	37101
10507	10827	4	applied	\N	\N	\N	\N	37102	37102	37103
10507	10828	5	applied	\N	\N	\N	\N	37104	37104	37105
10507	10829	6	applied	\N	\N	\N	\N	37106	37106	37107
10507	10830	7	applied	\N	\N	\N	\N	37108	37108	37109
10507	10831	8	applied	\N	\N	\N	\N	37110	37110	37111
10509	10833	0	applied	\N	\N	\N	\N	37119	37119	37120
10509	10832	1	applied	\N	\N	\N	\N	37116	37116	37117
10512	10833	0	applied	\N	\N	\N	\N	37119	37119	37120
10512	10832	1	applied	\N	\N	\N	\N	37116	37116	37117
10513	10833	0	applied	\N	\N	\N	\N	37119	37119	37120
10513	10832	1	applied	\N	\N	\N	\N	37116	37116	37117
10513	10834	2	applied	\N	\N	\N	\N	37125	37125	37126
10513	10835	3	applied	\N	\N	\N	\N	37127	37127	37128
10518	10842	0	applied	\N	\N	\N	\N	37144	37144	37145
10518	10843	1	applied	\N	\N	\N	\N	37146	37146	37147
10520	10844	0	applied	\N	\N	\N	\N	37151	37151	37152
10520	10845	1	applied	\N	\N	\N	\N	37153	37153	37154
10524	10846	0	applied	\N	\N	\N	\N	37157	37157	37158
10524	10847	1	applied	\N	\N	\N	\N	37159	37159	37160
10524	10848	2	applied	\N	\N	\N	\N	37161	37161	37162
10524	10849	3	applied	\N	\N	\N	\N	37163	37163	37164
10528	10858	0	applied	\N	\N	\N	\N	37192	37192	37193
10528	10859	1	applied	\N	\N	\N	\N	37194	37194	37195
10528	10860	2	applied	\N	\N	\N	\N	37200	37200	37205
10528	10861	3	applied	\N	\N	\N	\N	37202	37202	37206
10531	10866	0	applied	\N	\N	\N	\N	37219	37219	37220
10531	10867	1	applied	\N	\N	\N	\N	37221	37221	37222
10531	10868	2	applied	\N	\N	\N	\N	37223	37223	37224
10531	10869	3	applied	\N	\N	\N	\N	37225	37225	31061
10536	10877	0	applied	\N	\N	\N	\N	37246	37246	37247
10536	10878	1	applied	\N	\N	\N	\N	37248	37248	37249
10541	10888	0	applied	\N	\N	\N	\N	37277	37277	37278
10541	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10548	10890	0	applied	\N	\N	\N	\N	37287	37287	37288
10548	10891	1	applied	\N	\N	\N	\N	37289	37289	37290
10548	10892	2	applied	\N	\N	\N	\N	37291	37291	37292
10548	10893	3	applied	\N	\N	\N	\N	37293	37293	37294
10548	10894	4	applied	\N	\N	\N	\N	37295	37295	37296
10550	10895	0	applied	\N	\N	\N	\N	37301	37301	37302
10550	10896	1	applied	\N	\N	\N	\N	37303	37303	37304
10551	10862	0	applied	\N	\N	\N	\N	37209	37209	37210
10551	10866	1	applied	\N	\N	\N	\N	37219	37219	37220
10551	10870	2	applied	\N	\N	\N	\N	37229	37229	37230
10551	10873	3	applied	\N	\N	\N	\N	37235	37235	37236
10551	10875	4	applied	\N	\N	\N	\N	37240	37240	37241
10551	10877	5	applied	\N	\N	\N	\N	37246	37246	37247
10551	10879	6	applied	\N	\N	\N	\N	37252	37252	37253
10551	10863	7	applied	\N	\N	\N	\N	37211	37211	37307
10551	10867	8	applied	\N	\N	\N	\N	37221	37221	37308
10551	10868	9	applied	\N	\N	\N	\N	37223	37223	37309
10551	10871	10	applied	\N	\N	\N	\N	37231	37231	37310
10551	10872	11	applied	\N	\N	\N	\N	37233	37233	37311
10551	10876	12	applied	\N	\N	\N	\N	37242	37242	37312
10551	10878	13	applied	\N	\N	\N	\N	37248	37248	37313
10551	10880	14	applied	\N	\N	\N	\N	37254	37254	37314
10551	10881	15	applied	\N	\N	\N	\N	37258	37258	37315
10551	10883	16	applied	\N	\N	\N	\N	37263	37263	37316
10551	10887	17	applied	\N	\N	\N	\N	37273	37273	37317
10551	10888	18	applied	\N	\N	\N	\N	37277	37277	37318
10551	10892	19	applied	\N	\N	\N	\N	37291	37291	37319
10551	10893	20	applied	\N	\N	\N	\N	37293	37293	37320
10551	10895	21	applied	\N	\N	\N	\N	37301	37301	37321
10551	10897	22	applied	\N	\N	\N	\N	37322	37322	37323
10551	10898	23	applied	\N	\N	\N	\N	37324	37324	37325
10551	10899	24	applied	\N	\N	\N	\N	37326	37326	37327
10551	10882	25	applied	\N	\N	\N	\N	37260	37260	37261
10551	10884	26	applied	\N	\N	\N	\N	37265	37265	37266
10551	10886	27	applied	\N	\N	\N	\N	37271	37271	37272
10551	10889	28	applied	\N	\N	\N	\N	37279	37279	37280
10551	10890	29	applied	\N	\N	\N	\N	37287	37287	37288
10551	10891	30	applied	\N	\N	\N	\N	37289	37289	37290
10551	10896	31	applied	\N	\N	\N	\N	37303	37303	37304
10551	10900	33	applied	\N	\N	\N	\N	37329	37329	37330
10551	10901	34	applied	\N	\N	\N	\N	37331	37331	37332
10551	10902	35	applied	\N	\N	\N	\N	37333	37333	37334
10551	10903	36	applied	\N	\N	\N	\N	37335	37335	37336
10551	10869	37	applied	\N	\N	\N	\N	37225	37225	31061
10551	10874	38	applied	\N	\N	\N	\N	37238	37238	1435
10551	10864	39	applied	\N	\N	1000000000	\N	37213	37213	37214
10551	10865	40	applied	\N	\N	\N	\N	37215	37215	37216
10551	10885	41	applied	\N	\N	1000000000	\N	37267	37267	37268
10551	10894	42	applied	\N	\N	\N	\N	37295	37295	37296
10561	10916	0	applied	\N	\N	\N	\N	37438	37438	37439
10561	10917	1	applied	\N	\N	\N	\N	37440	37440	37441
10566	10922	0	applied	\N	\N	\N	\N	37456	37456	37457
10566	10923	1	applied	\N	\N	\N	\N	37458	37458	37459
10568	10922	0	applied	\N	\N	\N	\N	37456	37456	37457
10568	10923	1	applied	\N	\N	\N	\N	37458	37458	37459
10570	10924	0	applied	\N	\N	\N	\N	37470	37470	37471
10570	10925	1	applied	\N	\N	\N	\N	37472	37472	37473
10572	10926	0	applied	\N	\N	\N	\N	37477	37477	37478
10572	10927	1	applied	\N	\N	\N	\N	37479	37479	37480
10575	10932	0	applied	\N	\N	\N	\N	37492	37492	37493
10575	10933	1	applied	\N	\N	\N	\N	37494	37494	37495
10575	10934	2	applied	\N	\N	\N	\N	37496	37496	37497
10578	10937	0	applied	\N	\N	\N	\N	37507	37507	37508
10578	10938	1	applied	\N	\N	\N	\N	37509	37509	37510
10578	10939	2	applied	\N	\N	\N	\N	37511	37511	37512
10578	10940	3	applied	\N	\N	\N	\N	37513	37513	37514
10578	10941	4	applied	\N	\N	\N	\N	37515	37515	37516
10578	10942	5	applied	\N	\N	\N	\N	37517	37517	37518
10581	10945	0	applied	\N	\N	\N	\N	37525	37525	37526
10581	10946	1	applied	\N	\N	\N	\N	37527	37527	37528
10527	10824	1	applied	\N	\N	\N	\N	37096	37096	37097
10527	10825	2	applied	\N	\N	\N	\N	37098	37098	37099
10527	10826	3	applied	\N	\N	\N	\N	37100	37100	37101
10527	10827	4	applied	\N	\N	\N	\N	37102	37102	37103
10527	10832	5	applied	\N	\N	\N	\N	37116	37116	37117
10527	10834	6	applied	\N	\N	\N	\N	37125	37125	37126
10527	10838	7	applied	\N	\N	\N	\N	37134	37134	37135
10527	10839	8	applied	\N	\N	\N	\N	37136	37136	37137
10527	10840	9	applied	\N	\N	\N	\N	37139	37139	37140
10527	10843	10	applied	\N	\N	\N	\N	37146	37146	37147
10527	10845	11	applied	\N	\N	\N	\N	37153	37153	37154
10527	10846	12	applied	\N	\N	\N	\N	37157	37157	37158
10527	10847	13	applied	\N	\N	\N	\N	37159	37159	37160
10527	10851	14	applied	\N	\N	\N	\N	37174	37174	37175
10527	10852	15	applied	\N	\N	\N	\N	37176	37176	37177
10527	10828	16	applied	\N	\N	\N	\N	37104	37104	37105
10527	10829	17	applied	\N	\N	\N	\N	37106	37106	37107
10527	10856	18	applied	\N	\N	\N	\N	37184	37184	37185
10527	10857	19	applied	\N	\N	\N	\N	37186	37186	37187
10527	10858	20	applied	\N	\N	\N	\N	37192	37192	37193
10527	10859	21	applied	\N	\N	\N	\N	37194	37194	37195
10527	10830	22	applied	\N	\N	\N	\N	37108	37108	37109
10527	10831	23	applied	\N	\N	\N	\N	37110	37110	37111
10527	10833	24	applied	\N	\N	\N	\N	37119	37119	37120
10527	10835	25	applied	\N	\N	\N	\N	37127	37127	37128
10527	10836	26	applied	\N	\N	\N	\N	37130	37130	37131
10527	10837	27	applied	\N	\N	\N	\N	37132	37132	37133
10527	10841	28	applied	\N	\N	\N	\N	37141	37141	37142
10527	10842	29	applied	\N	\N	\N	\N	37144	37144	37145
10527	10844	30	applied	\N	\N	\N	\N	37151	37151	37152
10527	10848	31	applied	\N	\N	\N	\N	37161	37161	37162
10527	10849	32	applied	\N	\N	\N	\N	37163	37163	37164
10527	10850	33	applied	\N	\N	\N	\N	37172	37172	37196
10527	10853	34	applied	\N	\N	\N	\N	37178	37178	37197
10527	10854	35	applied	\N	\N	\N	\N	37180	37180	37198
10527	10855	36	applied	\N	\N	\N	\N	37182	37182	37199
10527	10860	37	applied	\N	\N	\N	\N	37200	37200	37201
10527	10861	38	applied	\N	\N	\N	\N	37202	37202	37203
10535	10875	0	applied	\N	\N	\N	\N	37240	37240	37241
10535	10876	1	applied	\N	\N	\N	\N	37242	37242	37243
10537	10879	0	applied	\N	\N	\N	\N	37252	37252	37253
10537	10880	1	applied	\N	\N	\N	\N	37254	37254	37255
10540	10886	0	applied	\N	\N	\N	\N	37271	37271	37272
10540	10887	1	applied	\N	\N	\N	\N	37273	37273	37274
10543	10888	0	applied	\N	\N	\N	\N	37277	37277	37278
10543	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10546	10888	0	applied	\N	\N	\N	\N	37277	37277	37278
10546	10889	1	applied	\N	\N	\N	\N	37279	37279	37280
10549	10890	0	applied	\N	\N	\N	\N	37287	37287	37288
10549	10891	1	applied	\N	\N	\N	\N	37289	37289	37290
10549	10892	2	applied	\N	\N	\N	\N	37291	37291	37292
10549	10893	3	applied	\N	\N	\N	\N	37293	37293	37294
10549	10894	4	applied	\N	\N	\N	\N	37295	37295	37296
10552	10900	0	applied	\N	\N	\N	\N	37329	37329	37330
10552	10901	1	applied	\N	\N	\N	\N	37331	37331	37332
10552	10902	2	applied	\N	\N	\N	\N	37333	37333	37334
10552	10903	3	applied	\N	\N	\N	\N	37335	37335	37336
10552	10897	4	applied	\N	\N	\N	\N	37322	37322	37339
10552	10898	5	applied	\N	\N	\N	\N	37324	37324	37340
10552	10899	6	applied	\N	\N	\N	\N	37326	37326	37341
10554	10904	0	applied	\N	\N	\N	\N	37346	37346	37347
10554	10905	1	applied	\N	\N	\N	\N	37348	37348	37349
10558	10759	0	applied	\N	\N	1000000000	\N	36929	36929	36930
10558	10675	1	applied	\N	\N	1000000000	\N	36708	36708	36709
10558	10781	2	applied	\N	\N	\N	\N	36992	36992	36993
10558	10672	3	applied	\N	\N	\N	\N	37365	37365	36699
10558	10661	4	applied	\N	\N	\N	\N	37366	37366	36672
10558	10424	5	applied	\N	\N	\N	\N	36001	36001	36002
10558	10425	6	applied	\N	\N	\N	\N	36003	36003	36004
10558	10428	7	applied	\N	\N	\N	\N	36011	36011	36012
10558	10429	8	applied	\N	\N	\N	\N	36013	36013	36014
10558	10568	9	applied	\N	\N	1000000000	\N	36734	36734	36424
10558	10589	11	applied	\N	\N	\N	\N	37368	37368	36478
10558	10666	12	applied	\N	\N	\N	\N	37369	37369	36684
10558	10598	13	applied	\N	\N	\N	\N	37370	37370	36508
10558	10605	14	applied	\N	\N	\N	\N	37371	37371	36523
10558	10791	15	applied	\N	\N	\N	\N	37012	37012	37013
10558	10649	16	applied	\N	\N	\N	\N	36634	36634	36635
10558	10653	17	applied	\N	\N	\N	\N	36652	36652	36653
10558	10792	18	applied	\N	\N	\N	\N	37014	37014	37015
10558	10793	19	applied	\N	\N	\N	\N	37016	37016	37017
10558	10794	20	applied	\N	\N	\N	\N	37018	37018	37019
10558	10611	21	applied	\N	\N	\N	\N	37372	37372	36538
10558	10612	22	applied	\N	\N	\N	\N	37373	37373	36546
10558	10721	23	applied	\N	\N	1000000000	\N	36849	36849	36850
10558	10729	24	applied	\N	\N	\N	\N	36870	36870	36871
10558	10730	25	applied	\N	\N	\N	\N	36872	36872	36873
10558	10733	26	applied	\N	\N	\N	\N	36878	36878	36879
10558	10734	27	applied	\N	\N	\N	\N	36880	36880	36881
10558	10678	28	applied	\N	\N	\N	\N	37374	37374	36715
10558	10679	29	applied	\N	\N	\N	\N	37375	37375	36717
10558	10680	30	applied	\N	\N	\N	\N	37376	37376	36719
10558	10681	31	applied	\N	\N	\N	\N	37377	37377	36721
10558	10682	32	applied	\N	\N	\N	\N	37378	37378	36723
10558	10686	33	applied	\N	\N	\N	\N	37379	37379	36749
10558	10688	34	applied	\N	\N	\N	\N	37380	37380	36753
10558	10689	35	applied	\N	\N	\N	\N	37381	37381	36755
10558	10690	36	applied	\N	\N	\N	\N	37382	37382	36757
10558	10691	37	applied	\N	\N	\N	\N	37383	37383	36759
10558	10692	38	applied	\N	\N	\N	\N	37384	37384	36761
10558	10700	39	applied	\N	\N	\N	\N	37385	37385	36794
10558	10702	40	applied	\N	\N	\N	\N	37386	37386	36798
10558	10703	41	applied	\N	\N	\N	\N	37387	37387	36800
10558	10705	42	applied	\N	\N	\N	\N	37388	37388	36811
10558	10706	43	applied	\N	\N	\N	\N	37389	37389	36813
10558	10910	44	applied	\N	\N	\N	\N	37390	37390	37391
10558	10911	45	applied	\N	\N	\N	\N	37392	37392	37393
10558	10711	46	applied	\N	\N	\N	\N	37394	37394	36829
10558	10715	47	applied	\N	\N	\N	\N	37395	37395	36838
10558	10720	48	applied	\N	\N	\N	\N	37396	37396	36848
10558	10617	49	applied	\N	\N	\N	\N	37397	37397	36556
10558	10618	50	applied	\N	\N	\N	\N	37398	37398	36558
10558	10625	51	applied	\N	\N	\N	\N	37399	37399	36582
10558	10627	52	applied	\N	\N	\N	\N	37400	37400	36586
10558	10633	53	applied	\N	\N	\N	\N	37401	37401	36600
10558	10634	54	applied	\N	\N	\N	\N	37402	37402	36602
10558	10635	55	applied	\N	\N	\N	\N	37403	37403	36604
10558	10636	56	applied	\N	\N	\N	\N	37404	37404	36606
10558	10641	57	applied	\N	\N	\N	\N	37405	37405	36616
10558	10642	58	applied	\N	\N	\N	\N	37406	37406	36618
10558	10643	59	applied	\N	\N	\N	\N	37407	37407	36620
10558	10644	60	applied	\N	\N	\N	\N	37408	37408	36622
10558	10645	61	applied	\N	\N	\N	\N	37409	37409	36624
10558	10795	62	applied	\N	\N	\N	\N	37410	37410	37021
10558	10796	63	applied	\N	\N	\N	\N	37411	37411	37023
10558	10797	64	applied	\N	\N	\N	\N	37412	37412	37025
10558	10798	65	applied	\N	\N	\N	\N	37413	37413	37027
10558	10799	66	applied	\N	\N	\N	\N	37414	37414	37029
10558	10800	67	applied	\N	\N	\N	\N	37415	37415	37031
10558	10801	68	applied	\N	\N	\N	\N	37416	37416	37033
10558	10804	69	applied	\N	\N	\N	\N	37417	37417	37044
10558	10807	70	applied	\N	\N	\N	\N	37418	37418	37050
10558	10808	71	applied	\N	\N	\N	\N	37419	37419	37052
10558	10809	72	applied	\N	\N	\N	\N	37420	37420	37054
10558	10810	73	applied	\N	\N	\N	\N	37421	37421	37056
10558	10811	74	applied	\N	\N	\N	\N	37422	37422	37058
10558	10812	75	applied	\N	\N	\N	\N	37423	37423	37060
10558	10438	76	applied	\N	\N	\N	\N	36033	36033	36034
10558	10441	77	applied	\N	\N	\N	\N	36039	36039	36040
10558	10442	78	applied	\N	\N	\N	\N	36041	36041	36042
10558	10443	79	applied	\N	\N	\N	\N	36051	36051	36052
10558	10445	80	applied	\N	\N	\N	\N	36056	36056	36057
10558	10446	81	applied	\N	\N	\N	\N	36058	36058	36059
10558	10450	82	applied	\N	\N	\N	\N	36068	36068	36069
10558	10456	83	applied	\N	\N	\N	\N	36082	36082	36083
10558	10458	84	applied	\N	\N	\N	\N	36090	36090	36091
10558	10459	85	applied	\N	\N	\N	\N	36092	36092	36093
10558	10467	86	applied	\N	\N	\N	\N	36111	36111	36112
10558	10468	87	applied	\N	\N	\N	\N	36113	36113	36114
10558	10469	88	applied	\N	\N	\N	\N	36115	36115	36116
10558	10470	89	applied	\N	\N	\N	\N	36117	36117	36118
10558	10473	90	applied	\N	\N	\N	\N	36123	36123	36124
10558	10474	91	applied	\N	\N	\N	\N	36125	36125	36126
10558	10477	92	applied	\N	\N	\N	\N	36131	36131	36132
10558	10478	93	applied	\N	\N	\N	\N	36135	36135	36136
10558	10481	94	applied	\N	\N	\N	\N	36145	36145	36146
10558	10483	95	applied	\N	\N	\N	\N	36152	36152	36153
10558	10484	96	applied	\N	\N	\N	\N	36154	36154	36155
10558	10487	97	applied	\N	\N	\N	\N	36161	36161	36162
10558	10489	98	applied	\N	\N	\N	\N	36167	36167	36168
10558	10494	99	applied	\N	\N	\N	\N	36184	36184	36185
10558	10495	100	applied	\N	\N	\N	\N	36186	36186	36187
10558	10496	101	applied	\N	\N	\N	\N	36188	36188	36189
10558	10497	102	applied	\N	\N	\N	\N	36192	36192	36193
10558	10499	103	applied	\N	\N	\N	\N	36200	36200	36201
10558	10502	104	applied	\N	\N	\N	\N	36208	36208	36209
10558	10504	105	applied	\N	\N	\N	\N	36212	36212	36213
10558	10506	106	applied	\N	\N	\N	\N	36219	36219	36220
10558	10508	107	applied	\N	\N	\N	\N	36227	36227	36228
10558	10510	108	applied	\N	\N	\N	\N	36234	36234	36235
10558	10513	109	applied	\N	\N	\N	\N	36242	36242	36243
10558	10514	110	applied	\N	\N	\N	\N	36244	36244	36245
10558	10516	111	applied	\N	\N	\N	\N	36252	36252	36253
10558	10519	112	applied	\N	\N	\N	\N	36259	36259	36260
10558	10521	113	applied	\N	\N	\N	\N	36268	36268	36269
10558	10525	114	applied	\N	\N	\N	\N	36286	36286	36287
10558	10526	115	applied	\N	\N	\N	\N	36288	36288	36289
10558	10529	116	applied	\N	\N	\N	\N	36295	36295	36296
10558	10530	117	applied	\N	\N	\N	\N	36297	36297	36298
10558	10531	118	applied	\N	\N	\N	\N	36299	36299	36300
10558	10532	119	applied	\N	\N	\N	\N	36301	36301	36302
10558	10541	120	applied	\N	\N	\N	\N	36321	36321	36322
10558	10656	121	applied	\N	\N	\N	\N	36658	36658	36659
10558	10659	122	applied	\N	\N	\N	\N	36665	36665	36666
10558	10671	123	applied	\N	\N	\N	\N	36695	36695	36696
10558	10544	124	applied	\N	\N	\N	\N	36331	36331	36332
10558	10545	125	applied	\N	\N	\N	\N	36333	36333	36334
10560	10914	0	applied	\N	\N	\N	\N	37432	37432	37433
10560	10915	1	applied	\N	\N	\N	\N	37434	37434	37435
10562	10918	0	applied	\N	\N	\N	\N	37444	37444	37445
10562	10919	1	applied	\N	\N	\N	\N	37446	37446	37447
10582	10947	0	applied	\N	\N	\N	\N	37532	37532	37533
10582	10948	1	applied	\N	\N	\N	\N	37534	37534	37535
10586	10949	0	applied	\N	\N	\N	\N	37543	37543	37544
10586	10950	1	applied	\N	\N	\N	\N	37545	37545	37546
10592	10955	0	applied	\N	\N	\N	\N	37558	37558	37559
10592	10956	1	applied	\N	\N	\N	\N	37560	37560	37561
10592	10957	2	applied	\N	\N	\N	\N	37562	37562	37563
10592	10958	3	applied	\N	\N	\N	\N	37564	37564	37565
10596	10961	0	applied	\N	\N	\N	\N	37578	37578	37579
10596	10962	1	applied	\N	\N	\N	\N	37580	37580	37581
10596	10963	2	applied	\N	\N	\N	\N	37582	37582	37583
10596	10964	3	applied	\N	\N	\N	\N	37584	37584	37585
10601	10971	0	applied	\N	\N	\N	\N	37610	37610	37611
10601	10972	1	applied	\N	\N	\N	\N	37612	37612	37613
10608	10977	0	applied	\N	\N	\N	\N	37626	37626	37627
10608	10978	1	applied	\N	\N	\N	\N	37628	37628	37629
10610	10979	0	applied	\N	\N	\N	\N	37634	37634	37635
10610	10980	1	applied	\N	\N	\N	\N	37636	37636	37637
10610	10981	2	applied	\N	\N	\N	\N	37638	37638	37639
10610	10982	3	applied	\N	\N	\N	\N	37640	37640	37641
10615	10988	0	applied	\N	\N	\N	\N	37659	37659	37660
10615	10989	1	applied	\N	\N	\N	\N	37661	37661	37662
10617	10990	0	applied	\N	\N	\N	\N	37665	37665	37666
10617	10991	1	applied	\N	\N	\N	\N	37667	37667	37668
10619	10990	0	applied	\N	\N	\N	\N	37665	37665	37666
10619	10991	1	applied	\N	\N	\N	\N	37667	37667	37668
10623	10996	0	applied	\N	\N	\N	\N	37686	37686	37687
10623	10997	1	applied	\N	\N	\N	\N	37688	37688	37689
10623	10998	2	applied	\N	\N	\N	\N	37690	37690	37691
10623	10999	3	applied	\N	\N	\N	\N	37692	37692	37693
10623	11000	4	applied	\N	\N	\N	\N	37694	37694	37695
10623	11001	5	applied	\N	\N	\N	\N	37696	37696	37697
10625	11002	0	applied	\N	\N	\N	\N	37701	37701	37702
10625	11003	1	applied	\N	\N	\N	\N	37703	37703	37704
10627	11004	0	applied	\N	\N	\N	\N	37709	37709	37710
10627	11005	1	applied	\N	\N	\N	\N	37711	37711	37712
10627	11006	2	applied	\N	\N	\N	\N	37713	37713	37714
10630	11009	0	applied	\N	\N	\N	\N	37721	37721	37722
10630	11010	1	applied	\N	\N	\N	\N	37725	37725	37726
10634	11013	0	applied	\N	\N	\N	\N	37736	37736	37737
10634	11014	1	applied	\N	\N	\N	\N	37738	37738	37739
10636	11016	0	applied	\N	\N	\N	\N	37747	37747	37748
10636	11015	1	applied	\N	\N	\N	\N	37740	37740	37741
10636	11017	2	applied	\N	\N	\N	\N	37749	37749	37750
10637	11018	0	applied	\N	\N	\N	\N	37753	37753	37754
10637	11019	1	applied	\N	\N	\N	\N	37755	37755	37756
10637	11020	2	applied	\N	\N	\N	\N	37757	37757	37758
10637	11021	4	applied	\N	\N	\N	\N	37760	37760	37761
10590	10956	1	applied	\N	\N	\N	\N	37560	37560	37561
10590	10957	2	applied	\N	\N	\N	\N	37562	37562	37563
10590	10958	3	applied	\N	\N	\N	\N	37564	37564	37565
10594	10959	0	applied	\N	\N	\N	\N	37570	37570	37571
10594	10960	1	applied	\N	\N	\N	\N	37572	37572	37573
10599	10969	0	applied	\N	\N	\N	\N	37602	37602	37603
10599	10970	1	applied	\N	\N	\N	\N	37604	37604	37605
10602	10971	0	applied	\N	\N	\N	\N	37610	37610	37611
10602	10972	1	applied	\N	\N	\N	\N	37612	37612	37613
10606	10975	0	applied	\N	\N	\N	\N	37620	37620	37621
10606	10976	1	applied	\N	\N	\N	\N	37622	37622	37623
10609	10977	0	applied	\N	\N	\N	\N	37626	37626	37627
10609	10978	1	applied	\N	\N	\N	\N	37628	37628	37629
10613	10983	0	applied	\N	\N	\N	\N	37646	37646	37647
10613	10984	1	applied	\N	\N	\N	\N	37648	37648	37649
10616	10988	0	applied	\N	\N	\N	\N	37659	37659	37660
10616	10989	1	applied	\N	\N	\N	\N	37661	37661	37662
10620	10992	0	applied	\N	\N	\N	\N	37676	37676	37677
10620	10993	1	applied	\N	\N	\N	\N	37678	37678	37679
10620	10994	2	applied	\N	\N	\N	\N	37680	37680	37681
10620	10995	3	applied	\N	\N	\N	\N	37682	37682	37683
10632	11010	0	applied	\N	\N	\N	\N	37725	37725	37726
10632	11011	1	applied	\N	\N	\N	\N	37730	37730	37731
10632	11012	2	applied	\N	\N	1000000000	\N	37732	37732	37733
10635	11013	0	applied	\N	\N	\N	\N	37736	37736	37737
10635	11014	1	applied	\N	\N	\N	\N	37738	37738	37739
10640	11027	0	applied	\N	\N	\N	\N	37778	37778	37779
10640	11028	1	applied	\N	\N	\N	\N	37780	37780	37781
10640	11029	2	applied	\N	\N	\N	\N	37782	37782	37783
10645	11036	0	applied	\N	\N	\N	\N	37823	37823	37824
10645	11037	1	applied	\N	\N	\N	\N	37825	37825	37826
10645	11038	2	applied	\N	\N	\N	\N	37827	37827	37828
10645	11039	3	applied	\N	\N	\N	\N	37829	37829	37830
10647	11040	0	applied	\N	\N	\N	\N	37835	37835	37836
10647	11041	1	applied	\N	\N	\N	\N	37837	37837	37838
10652	11042	0	applied	\N	\N	\N	\N	37845	37845	37846
10652	11043	1	applied	\N	\N	\N	\N	37847	37847	37848
10652	11044	2	applied	\N	\N	\N	\N	37849	37849	37850
10652	11045	3	applied	\N	\N	\N	\N	37851	37851	37852
10657	11050	0	applied	\N	\N	\N	\N	37869	37869	37870
10657	11051	1	applied	\N	\N	\N	\N	37871	37871	37872
10657	11052	2	applied	\N	\N	\N	\N	37873	37873	37874
10657	11053	3	applied	\N	\N	\N	\N	37875	37875	37876
10661	11055	0	applied	\N	\N	\N	\N	37887	37887	37888
10661	11056	1	applied	\N	\N	\N	\N	37889	37889	37890
10664	11057	0	applied	\N	\N	\N	\N	37893	37893	37894
10664	11058	1	applied	\N	\N	\N	\N	37895	37895	37896
10668	11059	0	applied	\N	\N	\N	\N	37903	37903	37904
10668	11060	1	applied	\N	\N	\N	\N	37905	37905	37906
10668	11061	2	applied	\N	\N	\N	\N	37907	37907	37908
10668	11062	3	applied	\N	\N	\N	\N	37909	37909	37910
10668	11063	4	applied	\N	\N	\N	\N	37911	37911	37912
10672	11064	0	applied	\N	\N	\N	\N	37918	37918	37919
10672	11065	1	applied	\N	\N	\N	\N	37920	37920	37921
10672	11066	2	applied	\N	\N	\N	\N	37922	37922	37923
10672	11067	3	applied	\N	\N	\N	\N	37924	37924	37925
10672	11068	4	applied	\N	\N	\N	\N	37926	37926	37927
10672	11069	5	applied	\N	\N	\N	\N	37928	37928	37929
10676	11074	0	applied	\N	\N	\N	\N	37946	37946	37947
10676	11075	1	applied	\N	\N	\N	\N	37948	37948	37949
10678	11076	0	applied	\N	\N	\N	\N	37956	37956	37957
10678	11077	1	applied	\N	\N	\N	\N	37958	37958	37959
10680	11078	0	applied	\N	\N	\N	\N	37960	37960	37961
10680	11079	1	applied	\N	\N	\N	\N	37962	37962	37963
10685	11086	0	applied	\N	\N	\N	\N	37981	37981	37982
10685	11087	1	applied	\N	\N	\N	\N	37983	37983	37984
10685	11088	2	applied	\N	\N	\N	\N	37985	37985	37986
10688	11089	0	applied	\N	\N	\N	\N	37990	37990	37991
10688	11090	1	applied	\N	\N	\N	\N	37992	37992	37993
10690	11094	0	applied	\N	\N	\N	\N	38003	38003	38004
10690	11095	1	applied	\N	\N	\N	\N	38005	38005	38006
10698	11104	0	applied	\N	\N	\N	\N	38033	38033	38034
10698	11105	1	applied	\N	\N	\N	\N	38035	38035	38036
10698	11106	2	applied	\N	\N	\N	\N	38037	38037	38038
10698	11107	3	applied	\N	\N	\N	\N	38039	38039	38040
10698	11108	4	applied	\N	\N	\N	\N	38041	38041	38042
10698	11109	5	applied	\N	\N	\N	\N	38043	38043	38044
10698	11110	6	applied	\N	\N	\N	\N	38045	38045	38046
10698	11111	7	applied	\N	\N	\N	\N	38047	38047	38048
10702	11112	0	applied	\N	\N	\N	\N	38057	38057	38058
10702	11113	1	applied	\N	\N	\N	\N	38059	38059	38060
10706	11118	0	applied	\N	\N	\N	\N	38072	38072	38073
10706	11119	1	applied	\N	\N	\N	\N	38074	38074	38075
10706	11120	2	applied	\N	\N	\N	\N	38076	38076	38077
10706	11121	3	applied	\N	\N	\N	\N	38078	38078	38079
10706	11122	4	applied	\N	\N	\N	\N	38080	38080	38081
10706	11123	5	applied	\N	\N	\N	\N	38082	38082	38083
10706	11124	6	applied	\N	\N	\N	\N	38084	38084	38085
10706	11125	7	applied	\N	\N	\N	\N	38086	38086	38087
10706	11126	8	applied	\N	\N	1000000000	\N	38088	38088	38089
10710	11130	0	applied	\N	\N	\N	\N	38103	38103	38104
10710	11131	1	applied	\N	\N	\N	\N	38105	38105	38106
10713	11132	0	applied	\N	\N	\N	\N	38109	38109	38110
10713	11133	1	applied	\N	\N	\N	\N	38111	38111	38112
10740	11169	0	applied	\N	\N	\N	\N	38223	38223	38224
10740	11170	1	applied	\N	\N	\N	\N	38225	38225	38226
10743	11175	0	applied	\N	\N	\N	\N	38239	38239	38240
10743	11176	1	applied	\N	\N	\N	\N	38241	38241	38242
10743	11177	3	applied	\N	\N	\N	\N	38244	38244	38245
10747	11180	0	applied	\N	\N	\N	\N	38259	38259	38260
10747	11181	1	applied	\N	\N	\N	\N	38261	38261	38262
10750	11182	0	applied	\N	\N	\N	\N	38265	38265	38266
10750	11183	1	applied	\N	\N	\N	\N	38267	38267	38268
10750	11184	2	applied	\N	\N	1000000000	\N	38269	38269	38270
10752	11185	0	applied	\N	\N	\N	\N	38276	38276	38277
10752	11186	1	applied	\N	\N	1000000000	\N	38278	38278	38279
10752	11187	2	applied	\N	\N	\N	\N	38280	38280	38281
10752	11188	3	applied	\N	\N	\N	\N	38282	38282	38283
10752	11189	4	applied	\N	\N	\N	\N	38284	38284	38285
10752	11190	5	applied	\N	\N	\N	\N	38286	38286	38287
10752	11191	6	applied	\N	\N	\N	\N	38288	38288	38289
10757	11200	0	applied	\N	\N	\N	\N	38310	38310	38311
10757	11201	1	applied	\N	\N	\N	\N	38312	38312	38313
10761	11204	0	applied	\N	\N	\N	\N	38322	38322	38323
10761	11205	1	applied	\N	\N	\N	\N	38324	38324	38325
10761	11206	2	applied	\N	\N	\N	\N	38326	38326	38327
10761	11207	3	applied	\N	\N	\N	\N	38328	38328	38329
10765	11212	0	applied	\N	\N	\N	\N	38347	38347	38348
10765	11213	1	applied	\N	\N	\N	\N	38349	38349	38350
10593	10960	1	applied	\N	\N	\N	\N	37572	37572	37573
10598	10967	0	applied	\N	\N	\N	\N	37596	37596	37597
10598	10968	1	applied	\N	\N	\N	\N	37598	37598	37599
10603	10971	0	applied	\N	\N	\N	\N	37610	37610	37611
10603	10972	1	applied	\N	\N	\N	\N	37612	37612	37613
10605	10973	0	applied	\N	\N	\N	\N	37614	37614	37615
10605	10974	1	applied	\N	\N	\N	\N	37616	37616	37617
10607	10977	0	applied	\N	\N	\N	\N	37626	37626	37627
10607	10978	1	applied	\N	\N	\N	\N	37628	37628	37629
10612	10983	0	applied	\N	\N	\N	\N	37646	37646	37647
10612	10984	1	applied	\N	\N	\N	\N	37648	37648	37649
10614	10985	0	applied	\N	\N	\N	\N	37652	37652	37653
10614	10986	1	applied	\N	\N	\N	\N	37654	37654	37655
10614	10987	2	applied	\N	\N	1000000000	\N	37656	37656	37657
10622	10996	0	applied	\N	\N	\N	\N	37686	37686	37687
10622	10997	1	applied	\N	\N	\N	\N	37688	37688	37689
10622	10998	2	applied	\N	\N	\N	\N	37690	37690	37691
10622	10999	3	applied	\N	\N	\N	\N	37692	37692	37693
10622	11000	4	applied	\N	\N	\N	\N	37694	37694	37695
10622	11001	5	applied	\N	\N	\N	\N	37696	37696	37697
10624	11002	0	applied	\N	\N	\N	\N	37701	37701	37702
10624	11003	1	applied	\N	\N	\N	\N	37703	37703	37704
10629	11009	0	applied	\N	\N	\N	\N	37721	37721	37722
10631	11009	0	applied	\N	\N	\N	\N	37721	37721	37722
10631	11010	1	applied	\N	\N	\N	\N	37725	37725	37726
10639	11025	0	applied	\N	\N	\N	\N	37770	37770	37771
10639	11026	1	applied	\N	\N	\N	\N	37772	37772	37773
10641	11030	0	applied	\N	\N	\N	\N	37786	37786	37787
10641	11031	1	applied	\N	\N	\N	\N	37788	37788	37789
10646	11036	0	applied	\N	\N	\N	\N	37823	37823	37824
10646	11039	1	applied	\N	\N	\N	\N	37829	37829	37830
10649	11040	0	applied	\N	\N	\N	\N	37835	37835	37836
10649	11041	1	applied	\N	\N	\N	\N	37837	37837	37838
10655	11046	0	applied	\N	\N	\N	\N	37859	37859	37860
10655	11047	1	applied	\N	\N	\N	\N	37861	37861	37862
10655	11048	2	applied	\N	\N	\N	\N	37863	37863	37864
10655	11049	3	applied	\N	\N	\N	\N	37865	37865	37866
10660	11054	0	applied	\N	\N	\N	\N	37884	37884	37885
10667	11059	0	applied	\N	\N	\N	\N	37903	37903	37904
10667	11060	1	applied	\N	\N	\N	\N	37905	37905	37906
10667	11061	2	applied	\N	\N	\N	\N	37907	37907	37908
10667	11062	3	applied	\N	\N	\N	\N	37909	37909	37910
10667	11063	4	applied	\N	\N	\N	\N	37911	37911	37912
10670	11064	0	applied	\N	\N	\N	\N	37918	37918	37919
10670	11065	1	applied	\N	\N	\N	\N	37920	37920	37921
10670	11066	2	applied	\N	\N	\N	\N	37922	37922	37923
10670	11067	3	applied	\N	\N	\N	\N	37924	37924	37925
10670	11068	4	applied	\N	\N	\N	\N	37926	37926	37927
10670	11069	5	applied	\N	\N	\N	\N	37928	37928	37929
10673	11064	0	applied	\N	\N	\N	\N	37918	37918	37919
10673	11065	1	applied	\N	\N	\N	\N	37920	37920	37921
10673	11066	2	applied	\N	\N	\N	\N	37922	37922	37923
10673	11070	3	applied	\N	\N	\N	\N	37935	37935	37936
10673	11067	4	applied	\N	\N	\N	\N	37924	37924	37925
10673	11068	5	applied	\N	\N	\N	\N	37926	37926	37927
10673	11069	6	applied	\N	\N	\N	\N	37928	37928	37929
10673	11071	7	applied	\N	\N	\N	\N	37937	37937	37938
10679	11078	0	applied	\N	\N	\N	\N	37960	37960	37961
10679	11079	1	applied	\N	\N	\N	\N	37962	37962	37963
10682	11080	0	applied	\N	\N	\N	\N	37966	37966	37967
10682	11081	1	applied	\N	\N	\N	\N	37968	37968	37969
10684	11084	0	applied	\N	\N	\N	\N	37976	37976	37977
10684	11085	1	applied	\N	\N	\N	\N	37978	37978	37979
10692	11094	0	applied	\N	\N	\N	\N	38003	38003	38004
10692	11095	1	applied	\N	\N	\N	\N	38005	38005	38006
10709	11129	0	applied	\N	\N	\N	\N	38099	38099	38100
10711	11130	0	applied	\N	\N	\N	\N	38103	38103	38104
10711	11131	1	applied	\N	\N	\N	\N	38105	38105	38106
10718	11134	0	applied	\N	\N	\N	\N	38119	38119	38120
10718	11135	1	applied	\N	\N	\N	\N	38121	38121	38122
10720	11136	0	applied	\N	\N	\N	\N	38125	38125	38126
10720	11137	1	applied	\N	\N	\N	\N	38127	38127	38128
10729	11155	0	applied	\N	\N	\N	\N	38181	38181	38182
10729	11156	1	applied	\N	\N	\N	\N	38183	38183	38184
10732	11155	0	applied	\N	\N	\N	\N	38181	38181	38182
10732	11156	1	applied	\N	\N	\N	\N	38183	38183	38184
10733	11156	0	applied	\N	\N	\N	\N	38183	38183	38184
10733	11157	1	applied	\N	\N	\N	\N	38191	38191	38192
10733	11158	2	applied	\N	\N	\N	\N	38193	38193	38194
10736	11161	0	applied	\N	\N	\N	\N	38204	38204	38205
10736	11162	1	applied	\N	\N	\N	\N	38206	38206	38207
10736	11163	2	applied	\N	\N	\N	\N	38208	38208	38209
10736	11164	3	applied	\N	\N	\N	\N	38210	38210	38211
10739	11169	0	applied	\N	\N	\N	\N	38223	38223	38224
10739	11170	1	applied	\N	\N	\N	\N	38225	38225	38226
10741	11171	0	applied	\N	\N	\N	\N	38231	38231	38232
10741	11172	1	applied	\N	\N	\N	\N	38233	38233	38234
10741	11173	2	applied	\N	\N	\N	\N	38235	38235	38236
10741	11174	3	applied	\N	\N	\N	\N	38237	38237	38238
10746	11180	0	applied	\N	\N	\N	\N	38259	38259	38260
10746	11181	1	applied	\N	\N	\N	\N	38261	38261	38262
10748	11182	0	applied	\N	\N	\N	\N	38265	38265	38266
10748	11183	1	applied	\N	\N	\N	\N	38267	38267	38268
10748	11184	2	applied	\N	\N	1000000000	\N	38269	38269	38270
10754	11198	0	applied	\N	\N	\N	\N	38304	38304	38305
10754	11199	1	applied	\N	\N	\N	\N	38306	38306	38307
10756	11200	0	applied	\N	\N	\N	\N	38310	38310	38311
10756	11201	1	applied	\N	\N	\N	\N	38312	38312	38313
10759	11204	0	applied	\N	\N	\N	\N	38322	38322	38323
10759	11205	1	applied	\N	\N	\N	\N	38324	38324	38325
10759	11206	2	applied	\N	\N	\N	\N	38326	38326	38327
10759	11207	3	applied	\N	\N	\N	\N	38328	38328	38329
10762	11204	0	applied	\N	\N	\N	\N	38322	38322	38323
10762	11205	1	applied	\N	\N	\N	\N	38324	38324	38325
10762	11206	2	applied	\N	\N	\N	\N	38326	38326	38327
10762	11207	3	applied	\N	\N	\N	\N	38328	38328	38329
10763	11208	0	applied	\N	\N	\N	\N	38337	38337	38338
10763	11209	1	applied	\N	\N	\N	\N	38339	38339	38340
10767	11212	0	applied	\N	\N	\N	\N	38347	38347	38348
10767	11213	1	applied	\N	\N	\N	\N	38349	38349	38350
10767	11214	2	applied	\N	\N	\N	\N	38351	38351	38352
10767	11215	3	applied	\N	\N	\N	\N	38353	38353	38354
10768	11216	0	applied	\N	\N	\N	\N	38360	38360	38361
10768	11217	1	applied	\N	\N	\N	\N	38362	38362	38363
10773	11222	0	applied	\N	\N	\N	\N	38378	38378	38379
10773	11223	1	applied	\N	\N	\N	\N	38380	38380	38381
10773	11224	2	applied	\N	\N	\N	\N	38382	38382	38383
10773	11225	3	applied	\N	\N	\N	\N	38384	38384	38385
10776	11230	0	applied	\N	\N	\N	\N	38398	38398	38399
10595	10961	0	applied	\N	\N	\N	\N	37578	37578	37579
10595	10962	1	applied	\N	\N	\N	\N	37580	37580	37581
10595	10963	2	applied	\N	\N	\N	\N	37582	37582	37583
10595	10964	3	applied	\N	\N	\N	\N	37584	37584	37585
10597	10965	0	applied	\N	\N	\N	\N	37590	37590	37591
10597	10966	1	applied	\N	\N	\N	\N	37592	37592	37593
10600	10969	0	applied	\N	\N	\N	\N	37602	37602	37603
10600	10970	1	applied	\N	\N	\N	\N	37604	37604	37605
10604	10973	0	applied	\N	\N	\N	\N	37614	37614	37615
10604	10974	1	applied	\N	\N	\N	\N	37616	37616	37617
10611	10979	0	applied	\N	\N	\N	\N	37634	37634	37635
10611	10980	1	applied	\N	\N	\N	\N	37636	37636	37637
10611	10981	2	applied	\N	\N	\N	\N	37638	37638	37639
10611	10982	3	applied	\N	\N	\N	\N	37640	37640	37641
10618	10548	0	applied	\N	\N	\N	\N	36343	36343	36344
10618	10549	1	applied	\N	\N	\N	\N	36348	36348	36349
10618	10551	2	applied	\N	\N	\N	\N	36354	36354	36355
10618	10554	3	applied	\N	\N	\N	\N	36380	36380	36381
10618	10558	4	applied	\N	\N	\N	\N	36393	36393	36394
10618	10559	5	applied	\N	\N	\N	\N	36395	36395	36396
10618	10561	6	applied	\N	\N	\N	\N	36400	36400	36401
10618	10563	7	applied	\N	\N	\N	\N	36408	36408	36409
10618	10565	8	applied	\N	\N	\N	\N	36414	36414	36415
10618	10566	9	applied	\N	\N	\N	\N	36418	36418	36419
10618	10570	11	applied	\N	\N	\N	\N	36427	36427	36428
10618	10573	12	applied	\N	\N	\N	\N	36435	36435	36436
10618	10575	13	applied	\N	\N	\N	\N	36441	36441	36442
10618	10577	14	applied	\N	\N	\N	\N	36446	36446	36447
10618	10578	15	applied	\N	\N	\N	\N	36448	36448	36449
10618	10579	16	applied	\N	\N	\N	\N	36450	36450	36451
10618	10582	17	applied	\N	\N	\N	\N	36458	36458	36459
10618	10584	18	applied	\N	\N	\N	\N	36465	36465	36466
10618	10586	19	applied	\N	\N	\N	\N	36469	36469	36470
10618	10591	20	applied	\N	\N	\N	\N	36481	36481	36482
10618	10592	21	applied	\N	\N	\N	\N	36483	36483	36484
10618	10593	22	applied	\N	\N	\N	\N	36487	36487	36488
10618	10595	23	applied	\N	\N	\N	\N	36493	36493	36494
10618	10597	24	applied	\N	\N	\N	\N	36505	36505	36506
10618	10599	25	applied	\N	\N	\N	\N	36509	36509	36510
10618	10600	26	applied	\N	\N	\N	\N	36511	36511	36512
10618	10604	27	applied	\N	\N	\N	\N	36520	36520	36521
10618	10607	28	applied	\N	\N	\N	\N	36526	36526	36527
10618	10610	29	applied	\N	\N	\N	\N	36535	36535	36536
10618	10619	30	applied	\N	\N	\N	\N	36559	36559	36560
10618	10620	31	applied	\N	\N	\N	\N	36561	36561	36562
10618	10621	32	applied	\N	\N	\N	\N	36563	36563	36564
10618	10622	33	applied	\N	\N	\N	\N	36565	36565	36566
10618	10623	34	applied	\N	\N	\N	\N	36573	36573	36574
10618	10628	35	applied	\N	\N	\N	\N	36587	36587	36588
10621	10992	0	applied	\N	\N	\N	\N	37676	37676	37677
10621	10993	1	applied	\N	\N	\N	\N	37678	37678	37679
10621	10994	2	applied	\N	\N	\N	\N	37680	37680	37681
10621	10995	3	applied	\N	\N	\N	\N	37682	37682	37683
10626	11002	0	applied	\N	\N	\N	\N	37701	37701	37702
10626	11003	1	applied	\N	\N	\N	\N	37703	37703	37704
10628	11007	0	applied	\N	\N	\N	\N	37717	37717	37718
10628	11008	1	applied	\N	\N	\N	\N	37719	37719	37720
10633	11013	0	applied	\N	\N	\N	\N	37736	37736	37737
10633	11014	1	applied	\N	\N	\N	\N	37738	37738	37739
10633	11015	2	applied	\N	\N	\N	\N	37740	37740	37741
10638	11025	0	applied	\N	\N	\N	\N	37770	37770	37771
10638	11026	1	applied	\N	\N	\N	\N	37772	37772	37773
10643	10781	0	applied	\N	\N	\N	\N	36992	36992	36993
10643	10791	1	applied	\N	\N	\N	\N	37012	37012	37013
10643	10792	2	applied	\N	\N	\N	\N	37014	37014	37015
10643	10793	3	applied	\N	\N	\N	\N	37016	37016	37017
10643	10794	4	applied	\N	\N	\N	\N	37018	37018	37019
10643	10795	5	applied	\N	\N	\N	\N	37793	37793	37021
10643	10796	6	applied	\N	\N	\N	\N	37794	37794	37023
10643	10797	7	applied	\N	\N	\N	\N	37795	37795	37025
10643	10798	8	applied	\N	\N	\N	\N	37796	37796	37027
10643	10799	9	applied	\N	\N	\N	\N	37797	37797	37029
10643	10800	10	applied	\N	\N	\N	\N	37798	37798	37031
10643	10801	11	applied	\N	\N	\N	\N	37799	37799	37033
10643	10804	12	applied	\N	\N	\N	\N	37800	37800	37044
10643	10807	13	applied	\N	\N	\N	\N	37801	37801	37050
10643	10808	14	applied	\N	\N	\N	\N	37802	37802	37052
10643	10809	15	applied	\N	\N	\N	\N	37803	37803	37054
10643	10810	16	applied	\N	\N	\N	\N	37804	37804	37056
10643	10811	17	applied	\N	\N	\N	\N	37805	37805	37058
10643	10812	18	applied	\N	\N	\N	\N	37806	37806	37060
10643	10869	19	applied	\N	\N	\N	\N	37225	37225	31061
10643	11024	20	applied	\N	\N	\N	\N	37807	37807	37808
10643	11029	21	applied	\N	\N	\N	\N	37809	37809	37810
10643	10874	22	applied	\N	\N	\N	\N	37783	37783	1435
10643	10864	23	applied	\N	\N	1000000000	\N	37213	37213	37214
10643	10865	24	applied	\N	\N	\N	\N	37215	37215	37216
10643	10885	25	applied	\N	\N	1000000000	\N	37267	37267	37268
10643	10894	26	applied	\N	\N	\N	\N	37295	37295	37296
10643	10987	27	applied	\N	\N	1000000000	\N	37656	37656	37657
10643	11006	28	applied	\N	\N	\N	\N	37713	37713	37714
10643	11012	29	applied	\N	\N	1000000000	\N	37732	37732	37733
10648	11040	0	applied	\N	\N	\N	\N	37835	37835	37836
10648	11041	1	applied	\N	\N	\N	\N	37837	37837	37838
10653	11042	0	applied	\N	\N	\N	\N	37845	37845	37846
10653	11043	1	applied	\N	\N	\N	\N	37847	37847	37848
10653	11044	2	applied	\N	\N	\N	\N	37849	37849	37850
10653	11045	3	applied	\N	\N	\N	\N	37851	37851	37852
10658	11050	0	applied	\N	\N	\N	\N	37869	37869	37870
10658	11051	1	applied	\N	\N	\N	\N	37871	37871	37872
10658	11052	2	applied	\N	\N	\N	\N	37873	37873	37874
10658	11053	3	applied	\N	\N	\N	\N	37875	37875	37876
10666	11057	0	applied	\N	\N	\N	\N	37893	37893	37894
10666	11058	1	applied	\N	\N	\N	\N	37895	37895	37896
10669	11059	0	applied	\N	\N	\N	\N	37903	37903	37904
10669	11060	1	applied	\N	\N	\N	\N	37905	37905	37906
10669	11061	2	applied	\N	\N	\N	\N	37907	37907	37908
10669	11062	3	applied	\N	\N	\N	\N	37909	37909	37910
10669	11063	4	applied	\N	\N	\N	\N	37911	37911	37912
10674	11071	0	applied	\N	\N	\N	\N	37937	37937	37938
10674	11072	1	applied	\N	\N	\N	\N	37940	37940	37941
10674	11070	2	applied	\N	\N	\N	\N	37935	37935	37936
10674	11073	3	applied	\N	\N	\N	\N	37942	37942	37943
10677	11074	0	applied	\N	\N	\N	\N	37946	37946	37947
10677	11075	1	applied	\N	\N	\N	\N	37948	37948	37949
10681	11080	0	applied	\N	\N	\N	\N	37966	37966	37967
10681	11081	1	applied	\N	\N	\N	\N	37968	37968	37969
10683	11082	0	applied	\N	\N	\N	\N	37972	37972	37973
10683	11083	1	applied	\N	\N	\N	\N	37974	37974	37975
10637	11022	5	applied	\N	\N	\N	\N	37762	37762	37763
10637	11023	6	applied	\N	\N	\N	\N	37764	37764	37765
10637	11024	7	applied	\N	\N	\N	\N	37766	37766	37767
10642	11030	0	applied	\N	\N	\N	\N	37786	37786	37787
10642	11031	1	applied	\N	\N	\N	\N	37788	37788	37789
10644	11032	0	applied	\N	\N	\N	\N	37813	37813	37814
10644	11033	1	applied	\N	\N	\N	\N	37815	37815	37816
10644	11034	2	applied	\N	\N	\N	\N	37817	37817	37818
10644	11035	3	applied	\N	\N	\N	\N	37819	37819	37820
10650	11040	0	applied	\N	\N	\N	\N	37835	37835	37836
10650	11041	1	applied	\N	\N	\N	\N	37837	37837	37838
10651	11042	0	applied	\N	\N	\N	\N	37845	37845	37846
10651	11043	1	applied	\N	\N	\N	\N	37847	37847	37848
10651	11044	2	applied	\N	\N	\N	\N	37849	37849	37850
10651	11045	3	applied	\N	\N	\N	\N	37851	37851	37852
10656	11050	0	applied	\N	\N	\N	\N	37869	37869	37870
10656	11051	1	applied	\N	\N	\N	\N	37871	37871	37872
10656	11052	2	applied	\N	\N	\N	\N	37873	37873	37874
10656	11053	3	applied	\N	\N	\N	\N	37875	37875	37876
10659	11050	0	applied	\N	\N	\N	\N	37869	37869	37870
10659	11051	1	applied	\N	\N	\N	\N	37871	37871	37872
10659	11052	2	applied	\N	\N	\N	\N	37873	37873	37874
10659	11053	3	applied	\N	\N	\N	\N	37875	37875	37876
10663	11057	0	applied	\N	\N	\N	\N	37893	37893	37894
10663	11058	1	applied	\N	\N	\N	\N	37895	37895	37896
10665	11057	0	applied	\N	\N	\N	\N	37893	37893	37894
10665	11058	1	applied	\N	\N	\N	\N	37895	37895	37896
10671	11064	0	applied	\N	\N	\N	\N	37918	37918	37919
10671	11065	1	applied	\N	\N	\N	\N	37920	37920	37921
10671	11066	2	applied	\N	\N	\N	\N	37922	37922	37923
10671	11067	3	applied	\N	\N	\N	\N	37924	37924	37925
10671	11068	4	applied	\N	\N	\N	\N	37926	37926	37927
10671	11069	5	applied	\N	\N	\N	\N	37928	37928	37929
10675	11074	0	applied	\N	\N	\N	\N	37946	37946	37947
10675	11075	1	applied	\N	\N	\N	\N	37948	37948	37949
10689	11089	0	applied	\N	\N	\N	\N	37990	37990	37991
10689	11090	1	applied	\N	\N	\N	\N	37992	37992	37993
10689	11091	2	applied	\N	\N	\N	\N	37995	37995	37996
10689	11092	3	applied	\N	\N	\N	\N	37997	37997	37998
10689	11093	4	applied	\N	\N	\N	\N	37999	37999	38000
10697	11104	0	applied	\N	\N	\N	\N	38033	38033	38034
10697	11105	1	applied	\N	\N	\N	\N	38035	38035	38036
10697	11106	2	applied	\N	\N	\N	\N	38037	38037	38038
10697	11107	3	applied	\N	\N	\N	\N	38039	38039	38040
10697	11108	4	applied	\N	\N	\N	\N	38041	38041	38042
10697	11109	5	applied	\N	\N	\N	\N	38043	38043	38044
10697	11110	6	applied	\N	\N	\N	\N	38045	38045	38046
10697	11111	7	applied	\N	\N	\N	\N	38047	38047	38048
10700	11104	0	applied	\N	\N	\N	\N	38033	38033	38034
10700	11105	1	applied	\N	\N	\N	\N	38035	38035	38036
10700	11106	2	applied	\N	\N	\N	\N	38037	38037	38038
10700	11107	3	applied	\N	\N	\N	\N	38039	38039	38040
10700	11108	4	applied	\N	\N	\N	\N	38041	38041	38042
10700	11109	5	applied	\N	\N	\N	\N	38043	38043	38044
10700	11110	6	applied	\N	\N	\N	\N	38045	38045	38046
10700	11111	7	applied	\N	\N	\N	\N	38047	38047	38048
10701	11104	0	applied	\N	\N	\N	\N	38033	38033	38034
10701	11105	1	applied	\N	\N	\N	\N	38035	38035	38036
10701	11106	2	applied	\N	\N	\N	\N	38037	38037	38038
10701	11107	3	applied	\N	\N	\N	\N	38039	38039	38040
10701	11108	4	applied	\N	\N	\N	\N	38041	38041	38042
10701	11109	5	applied	\N	\N	\N	\N	38043	38043	38044
10701	11110	6	applied	\N	\N	\N	\N	38045	38045	38046
10701	11111	7	applied	\N	\N	\N	\N	38047	38047	38048
10704	11114	0	applied	\N	\N	\N	\N	38062	38062	38063
10704	11115	1	applied	\N	\N	\N	\N	38064	38064	38065
10704	11116	2	applied	\N	\N	\N	\N	38066	38066	38067
10704	11117	3	applied	\N	\N	\N	\N	38068	38068	38069
10705	11118	0	applied	\N	\N	\N	\N	38072	38072	38073
10705	11119	1	applied	\N	\N	\N	\N	38074	38074	38075
10705	11120	2	applied	\N	\N	\N	\N	38076	38076	38077
10705	11121	3	applied	\N	\N	\N	\N	38078	38078	38079
10705	11122	4	applied	\N	\N	\N	\N	38080	38080	38081
10705	11123	5	applied	\N	\N	\N	\N	38082	38082	38083
10705	11124	6	applied	\N	\N	\N	\N	38084	38084	38085
10705	11125	7	applied	\N	\N	\N	\N	38086	38086	38087
10705	11126	8	applied	\N	\N	1000000000	\N	38088	38088	38089
10707	11127	0	applied	\N	\N	\N	\N	38093	38093	38094
10707	11128	1	applied	\N	\N	\N	\N	38095	38095	38096
10708	11127	0	applied	\N	\N	\N	\N	38093	38093	38094
10708	11128	1	applied	\N	\N	\N	\N	38095	38095	38096
10712	11132	0	applied	\N	\N	\N	\N	38109	38109	38110
10712	11133	1	applied	\N	\N	\N	\N	38111	38111	38112
10716	11132	0	applied	\N	\N	\N	\N	38109	38109	38110
10716	11133	1	applied	\N	\N	\N	\N	38111	38111	38112
10719	11134	0	applied	\N	\N	\N	\N	38119	38119	38120
10719	11135	1	applied	\N	\N	\N	\N	38121	38121	38122
10721	11138	0	applied	\N	\N	\N	\N	38131	38131	38132
10721	11139	1	applied	\N	\N	\N	\N	38133	38133	38134
10721	11140	2	applied	\N	\N	\N	\N	38135	38135	38136
10721	11141	3	applied	\N	\N	\N	\N	38137	38137	38138
10721	11142	4	applied	\N	\N	\N	\N	38139	38139	38140
10721	11143	5	applied	\N	\N	\N	\N	38141	38141	38142
10723	11144	0	applied	\N	\N	\N	\N	38146	38146	38147
10723	11145	1	applied	\N	\N	\N	\N	38148	38148	38149
10725	11138	0	applied	\N	\N	\N	\N	38131	38131	38132
10725	10781	1	applied	\N	\N	\N	\N	36992	36992	36993
10725	10791	2	applied	\N	\N	\N	\N	37012	37012	37013
10725	10792	3	applied	\N	\N	\N	\N	37014	37014	37015
10725	10793	4	applied	\N	\N	\N	\N	37016	37016	37017
10725	10794	5	applied	\N	\N	\N	\N	37018	37018	37019
10725	10764	6	applied	\N	\N	\N	\N	36943	36943	36944
10725	10765	7	applied	\N	\N	\N	\N	36945	36945	36946
10725	10766	8	applied	\N	\N	\N	\N	36947	36947	36948
10725	10771	9	applied	\N	\N	\N	\N	36962	36962	36963
10725	10772	10	applied	\N	\N	\N	\N	36964	36964	36965
10725	10773	11	applied	\N	\N	\N	\N	36966	36966	36967
10725	10774	12	applied	\N	\N	\N	\N	36968	36968	36969
10725	10775	13	applied	\N	\N	\N	\N	36970	36970	36971
10725	10779	14	applied	\N	\N	\N	\N	36981	36981	36982
10725	10786	15	applied	\N	\N	\N	\N	37002	37002	37003
10725	10787	16	applied	\N	\N	\N	\N	37004	37004	37005
10725	10788	17	applied	\N	\N	\N	\N	37006	37006	37007
10725	10789	18	applied	\N	\N	\N	\N	37008	37008	37009
10725	10790	19	applied	\N	\N	\N	\N	37010	37010	37011
10725	10767	20	applied	\N	\N	\N	\N	36949	36949	36950
10725	10768	21	applied	\N	\N	\N	\N	36951	36951	36952
10725	10769	22	applied	\N	\N	\N	\N	36953	36953	36954
10725	10770	24	applied	\N	\N	\N	\N	36960	36960	36961
10725	10776	25	applied	\N	\N	\N	\N	36972	36972	36973
10686	11086	0	applied	\N	\N	\N	\N	37981	37981	37982
10686	11087	1	applied	\N	\N	\N	\N	37983	37983	37984
10686	11088	2	applied	\N	\N	\N	\N	37985	37985	37986
10691	11094	0	applied	\N	\N	\N	\N	38003	38003	38004
10691	11095	1	applied	\N	\N	\N	\N	38005	38005	38006
10695	11096	0	applied	\N	\N	\N	\N	38013	38013	38014
10695	11097	1	applied	\N	\N	\N	\N	38015	38015	38016
10695	11098	2	applied	\N	\N	\N	\N	38017	38017	38018
10695	11099	3	applied	\N	\N	\N	\N	38019	38019	38020
10695	11100	4	applied	\N	\N	\N	\N	38021	38021	38022
10696	11101	0	applied	\N	\N	\N	\N	38025	38025	38026
10696	11102	1	applied	\N	\N	\N	\N	38027	38027	38028
10696	11103	2	applied	\N	\N	\N	\N	38029	38029	38030
10699	11104	0	applied	\N	\N	\N	\N	38033	38033	38034
10699	11105	1	applied	\N	\N	\N	\N	38035	38035	38036
10699	11106	2	applied	\N	\N	\N	\N	38037	38037	38038
10699	11107	3	applied	\N	\N	\N	\N	38039	38039	38040
10699	11108	4	applied	\N	\N	\N	\N	38041	38041	38042
10699	11109	5	applied	\N	\N	\N	\N	38043	38043	38044
10699	11110	6	applied	\N	\N	\N	\N	38045	38045	38046
10699	11111	7	applied	\N	\N	\N	\N	38047	38047	38048
10703	11112	0	applied	\N	\N	\N	\N	38057	38057	38058
10703	11113	1	applied	\N	\N	\N	\N	38059	38059	38060
10714	11132	0	applied	\N	\N	\N	\N	38109	38109	38110
10714	11133	1	applied	\N	\N	\N	\N	38111	38111	38112
10715	11132	0	applied	\N	\N	\N	\N	38109	38109	38110
10715	11133	1	applied	\N	\N	\N	\N	38111	38111	38112
10717	11134	0	applied	\N	\N	\N	\N	38119	38119	38120
10717	11135	1	applied	\N	\N	\N	\N	38121	38121	38122
10722	11138	0	applied	\N	\N	\N	\N	38131	38131	38132
10722	11139	1	applied	\N	\N	\N	\N	38133	38133	38134
10722	11140	2	applied	\N	\N	\N	\N	38135	38135	38136
10722	11141	3	applied	\N	\N	\N	\N	38137	38137	38138
10722	11142	4	applied	\N	\N	\N	\N	38139	38139	38140
10722	11143	5	applied	\N	\N	\N	\N	38141	38141	38142
10724	11144	0	applied	\N	\N	\N	\N	38146	38146	38147
10724	11145	1	applied	\N	\N	\N	\N	38148	38148	38149
10726	11146	0	applied	\N	\N	\N	\N	38158	38158	38159
10726	11147	1	applied	\N	\N	\N	\N	38160	38160	38161
10726	11148	2	applied	\N	\N	\N	\N	38162	38162	38163
10726	11149	3	applied	\N	\N	\N	\N	38164	38164	38165
10726	11150	4	applied	\N	\N	\N	\N	38166	38166	38167
10726	11151	5	applied	\N	\N	\N	\N	38168	38168	38169
10726	11152	6	applied	\N	\N	\N	\N	38170	38170	38171
10728	11153	0	applied	\N	\N	\N	\N	38175	38175	38176
10728	11154	1	applied	\N	\N	\N	\N	38177	38177	38178
10731	11155	0	applied	\N	\N	\N	\N	38181	38181	38182
10731	11156	1	applied	\N	\N	\N	\N	38183	38183	38184
10735	11159	0	applied	\N	\N	\N	\N	38197	38197	38198
10735	11160	1	applied	\N	\N	\N	\N	38199	38199	38200
10738	11169	0	applied	\N	\N	\N	\N	38223	38223	38224
10738	11170	1	applied	\N	\N	\N	\N	38225	38225	38226
10751	11182	0	applied	\N	\N	\N	\N	38265	38265	38266
10751	11183	1	applied	\N	\N	\N	\N	38267	38267	38268
10751	11184	2	applied	\N	\N	1000000000	\N	38269	38269	38270
10753	11192	0	applied	\N	\N	\N	\N	38292	38292	38293
10753	11193	1	applied	\N	\N	\N	\N	38294	38294	38295
10753	11194	2	applied	\N	\N	\N	\N	38296	38296	38297
10753	11195	3	applied	\N	\N	\N	\N	38298	38298	38299
10753	11196	4	applied	\N	\N	\N	\N	38300	38300	38301
10753	11197	5	applied	\N	\N	\N	\N	38302	38302	38303
10758	11202	0	applied	\N	\N	\N	\N	38316	38316	38317
10758	11203	1	applied	\N	\N	\N	\N	38318	38318	38319
10766	11212	0	applied	\N	\N	\N	\N	38347	38347	38348
10766	11213	1	applied	\N	\N	\N	\N	38349	38349	38350
10766	11214	2	applied	\N	\N	\N	\N	38351	38351	38352
10766	11215	3	applied	\N	\N	\N	\N	38353	38353	38354
10771	11218	0	applied	\N	\N	\N	\N	38366	38366	38367
10771	11219	1	applied	\N	\N	\N	\N	38368	38368	38369
10771	11220	2	applied	\N	\N	\N	\N	38370	38370	38371
10771	11221	3	applied	\N	\N	\N	\N	38372	38372	38373
10775	11230	0	applied	\N	\N	\N	\N	38398	38398	38399
10775	11231	1	applied	\N	\N	\N	\N	38400	38400	38401
10775	11232	2	applied	\N	\N	\N	\N	38402	38402	38403
10775	11233	3	applied	\N	\N	\N	\N	38404	38404	38405
10775	11234	4	applied	\N	\N	\N	\N	38406	38406	38407
10783	11239	0	applied	\N	\N	\N	\N	38425	38425	38426
10783	11240	1	applied	\N	\N	\N	\N	38427	38427	38428
10783	11241	2	applied	\N	\N	\N	\N	38429	38429	38430
10783	11242	3	applied	\N	\N	\N	\N	38431	38431	38432
10787	11248	0	applied	\N	\N	\N	\N	38452	38452	38453
10787	11249	1	applied	\N	\N	\N	\N	38454	38454	38455
10787	11250	2	applied	\N	\N	\N	\N	38456	38456	38457
10790	11257	0	applied	\N	\N	\N	\N	38474	38474	38475
10790	11258	1	applied	\N	\N	\N	\N	38476	38476	38477
10790	11259	2	applied	\N	\N	\N	\N	38478	38478	38479
10790	11260	3	applied	\N	\N	\N	\N	38480	38480	38481
10790	11261	4	applied	\N	\N	\N	\N	38482	38482	38483
10793	11268	0	applied	\N	\N	\N	\N	38502	38502	29193
10793	11269	1	applied	\N	\N	\N	\N	38503	38503	38504
10793	11270	2	applied	\N	\N	\N	\N	38505	38505	38506
10793	11271	3	applied	\N	\N	\N	\N	38507	38507	38508
10793	11272	4	applied	\N	\N	\N	\N	38509	38509	38510
10800	11275	0	applied	\N	\N	\N	\N	38521	38521	38522
10800	11276	1	applied	\N	\N	\N	\N	38523	38523	38524
10800	11277	2	applied	\N	\N	\N	\N	38525	38525	38526
10800	11278	3	applied	\N	\N	\N	\N	38527	38527	38528
10800	11279	4	applied	\N	\N	\N	\N	38529	38529	38530
10803	11284	0	applied	\N	\N	\N	\N	38573	38573	38574
10803	11285	1	applied	\N	\N	\N	\N	38575	38575	38576
10803	11286	2	applied	\N	\N	\N	\N	38577	38577	38578
10803	11287	3	applied	\N	\N	\N	\N	38579	38579	38580
10817	11308	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	38755	38755	\N
10817	11309	1	applied	\N	\N	\N	\N	38756	38756	38757
10817	11310	2	applied	\N	\N	\N	\N	38758	38758	38759
10819	11311	0	applied	\N	\N	\N	\N	38763	38763	38764
10819	11312	1	applied	\N	\N	\N	\N	38765	38765	38766
10824	11316	0	applied	\N	\N	1000000000	\N	38779	38779	38780
10824	11317	1	applied	\N	\N	1000000000	\N	38781	38781	38782
10824	11318	2	applied	\N	\N	\N	\N	38783	38783	38784
10834	11335	0	applied	\N	\N	\N	\N	38829	38829	38830
10834	11336	1	applied	\N	\N	\N	\N	38831	38831	38832
10834	11337	2	applied	\N	\N	\N	\N	38833	38833	38834
10834	11338	3	applied	\N	\N	\N	\N	38835	38835	38836
10837	11339	0	applied	\N	\N	\N	\N	38840	38840	38841
10837	11340	1	applied	\N	\N	\N	\N	38842	38842	38843
10837	11341	2	applied	\N	\N	\N	\N	38844	38844	38845
10837	11342	3	applied	\N	\N	\N	\N	38846	38846	38847
10837	11343	4	applied	\N	\N	\N	\N	38848	38848	38849
10725	10777	26	applied	\N	\N	\N	\N	36974	36974	36975
10725	10778	27	applied	\N	\N	\N	\N	36976	36976	36977
10725	10780	28	applied	\N	\N	\N	\N	36983	36983	36984
10725	10782	29	applied	\N	\N	\N	\N	36994	36994	36995
10725	10783	30	applied	\N	\N	\N	\N	36996	36996	36997
10725	10784	31	applied	\N	\N	\N	\N	36998	36998	36999
10725	10785	32	applied	\N	\N	\N	\N	37000	37000	37001
10725	10795	33	applied	\N	\N	\N	\N	37020	37020	37021
10725	10796	34	applied	\N	\N	\N	\N	37022	37022	37023
10725	10797	35	applied	\N	\N	\N	\N	37024	37024	37025
10725	10798	36	applied	\N	\N	\N	\N	37026	37026	37027
10725	10799	37	applied	\N	\N	\N	\N	37028	37028	37029
10725	10800	38	applied	\N	\N	\N	\N	37030	37030	37031
10725	10801	39	applied	\N	\N	\N	\N	37032	37032	37033
10725	10804	40	applied	\N	\N	\N	\N	37043	37043	37044
10725	10807	41	applied	\N	\N	\N	\N	37049	37049	37050
10725	10808	42	applied	\N	\N	\N	\N	37051	37051	37052
10725	10809	43	applied	\N	\N	\N	\N	37053	37053	37054
10725	10810	44	applied	\N	\N	\N	\N	37055	37055	37056
10725	10811	45	applied	\N	\N	\N	\N	37057	37057	37058
10725	10812	46	applied	\N	\N	\N	\N	37059	37059	37060
10725	10813	47	applied	\N	\N	\N	\N	37061	37061	37062
10725	10814	48	applied	\N	\N	\N	\N	37063	37063	37064
10725	10816	49	applied	\N	\N	\N	\N	37074	37074	37075
10725	10819	50	applied	\N	\N	\N	\N	37081	37081	37082
10725	10820	51	applied	\N	\N	\N	\N	37083	37083	37084
10725	10821	52	applied	\N	\N	\N	\N	37087	37087	37088
10725	10828	53	applied	\N	\N	\N	\N	37104	37104	37105
10725	10829	54	applied	\N	\N	\N	\N	37106	37106	37107
10725	10830	55	applied	\N	\N	\N	\N	37108	37108	37109
10725	10831	56	applied	\N	\N	\N	\N	37110	37110	37111
10725	10833	57	applied	\N	\N	\N	\N	37119	37119	37120
10725	10835	58	applied	\N	\N	\N	\N	37127	37127	37128
10725	10836	59	applied	\N	\N	\N	\N	37130	37130	37131
10725	10837	60	applied	\N	\N	\N	\N	37132	37132	37133
10725	10841	61	applied	\N	\N	\N	\N	37141	37141	37142
10725	10842	62	applied	\N	\N	\N	\N	37144	37144	37145
10725	10844	63	applied	\N	\N	\N	\N	37151	37151	37152
10725	10802	64	applied	\N	\N	\N	\N	37034	37034	37035
10725	10803	65	applied	\N	\N	\N	\N	37039	37039	37040
10725	10805	66	applied	\N	\N	\N	\N	37045	37045	37046
10725	10806	67	applied	\N	\N	\N	\N	37047	37047	37048
10725	10815	68	applied	\N	\N	\N	\N	37072	37072	37073
10725	10817	69	applied	\N	\N	\N	\N	37077	37077	37078
10725	10818	70	applied	\N	\N	\N	\N	37079	37079	37080
10725	10822	71	applied	\N	\N	\N	\N	37089	37089	37090
10725	10823	72	applied	\N	\N	\N	\N	37094	37094	37095
10725	10824	73	applied	\N	\N	\N	\N	37096	37096	37097
10725	10825	74	applied	\N	\N	\N	\N	37098	37098	37099
10725	10826	75	applied	\N	\N	\N	\N	37100	37100	37101
10725	10827	76	applied	\N	\N	\N	\N	37102	37102	37103
10725	10832	77	applied	\N	\N	\N	\N	37116	37116	37117
10725	10834	78	applied	\N	\N	\N	\N	37125	37125	37126
10725	10838	79	applied	\N	\N	\N	\N	37134	37134	37135
10725	10839	80	applied	\N	\N	\N	\N	37136	37136	37137
10725	10840	81	applied	\N	\N	\N	\N	37139	37139	37140
10725	10843	82	applied	\N	\N	\N	\N	37146	37146	37147
10725	10845	83	applied	\N	\N	\N	\N	37153	37153	37154
10725	10846	84	applied	\N	\N	\N	\N	37157	37157	37158
10725	10847	85	applied	\N	\N	\N	\N	37159	37159	37160
10725	10851	86	applied	\N	\N	\N	\N	37174	37174	37175
10725	10852	87	applied	\N	\N	\N	\N	37176	37176	37177
10725	10856	88	applied	\N	\N	\N	\N	37184	37184	37185
10725	10857	89	applied	\N	\N	\N	\N	37186	37186	37187
10725	10858	90	applied	\N	\N	\N	\N	37192	37192	37193
10725	10859	91	applied	\N	\N	\N	\N	37194	37194	37195
10725	10862	92	applied	\N	\N	\N	\N	37209	37209	37210
10725	10866	93	applied	\N	\N	\N	\N	37219	37219	37220
10725	10870	94	applied	\N	\N	\N	\N	37229	37229	37230
10725	10873	95	applied	\N	\N	\N	\N	37235	37235	37236
10725	10875	96	applied	\N	\N	\N	\N	37240	37240	37241
10725	10877	97	applied	\N	\N	\N	\N	37246	37246	37247
10725	10879	98	applied	\N	\N	\N	\N	37252	37252	37253
10725	10848	99	applied	\N	\N	\N	\N	37161	37161	37162
10725	10849	100	applied	\N	\N	\N	\N	37163	37163	37164
10725	10850	101	applied	\N	\N	\N	\N	37172	37172	37196
10725	10853	102	applied	\N	\N	\N	\N	37178	37178	37197
10725	10854	103	applied	\N	\N	\N	\N	37180	37180	37198
10725	10855	104	applied	\N	\N	\N	\N	37182	37182	37199
10725	10860	105	applied	\N	\N	\N	\N	37200	37200	37201
10725	10861	106	applied	\N	\N	\N	\N	37202	37202	37203
10725	10863	107	applied	\N	\N	\N	\N	37211	37211	37307
10725	10867	108	applied	\N	\N	\N	\N	37221	37221	37308
10725	10868	109	applied	\N	\N	\N	\N	37223	37223	37309
10725	10871	110	applied	\N	\N	\N	\N	37231	37231	37310
10725	10872	111	applied	\N	\N	\N	\N	37233	37233	37311
10725	10876	112	applied	\N	\N	\N	\N	37242	37242	37312
10725	10878	113	applied	\N	\N	\N	\N	37248	37248	37313
10725	10880	114	applied	\N	\N	\N	\N	37254	37254	37314
10725	10881	115	applied	\N	\N	\N	\N	37258	37258	37315
10725	10883	116	applied	\N	\N	\N	\N	37263	37263	37316
10725	10887	117	applied	\N	\N	\N	\N	37273	37273	37317
10725	10888	118	applied	\N	\N	\N	\N	37277	37277	37318
10725	10892	119	applied	\N	\N	\N	\N	37291	37291	37319
10725	10893	120	applied	\N	\N	\N	\N	37293	37293	37320
10725	10895	121	applied	\N	\N	\N	\N	37301	37301	37321
10725	10897	122	applied	\N	\N	\N	\N	37322	37322	37323
10725	10898	123	applied	\N	\N	\N	\N	37324	37324	37325
10725	10899	124	applied	\N	\N	\N	\N	37326	37326	37327
10725	10904	125	applied	\N	\N	\N	\N	37346	37346	38154
10727	11146	0	applied	\N	\N	\N	\N	38158	38158	38159
10727	11147	1	applied	\N	\N	\N	\N	38160	38160	38161
10727	11144	2	applied	\N	\N	\N	\N	38146	38146	38147
10727	11145	3	applied	\N	\N	\N	\N	38148	38148	38149
10727	11148	4	applied	\N	\N	\N	\N	38162	38162	38163
10727	11149	5	applied	\N	\N	\N	\N	38164	38164	38165
10727	11150	6	applied	\N	\N	\N	\N	38166	38166	38167
10727	11151	7	applied	\N	\N	\N	\N	38168	38168	38169
10727	11152	8	applied	\N	\N	\N	\N	38170	38170	38171
10730	11155	0	applied	\N	\N	\N	\N	38181	38181	38182
10734	11159	0	applied	\N	\N	\N	\N	38197	38197	38198
10734	11160	1	applied	\N	\N	\N	\N	38199	38199	38200
10737	11165	0	applied	\N	\N	\N	\N	38213	38213	38214
10737	11166	1	applied	\N	\N	\N	\N	38215	38215	38216
10737	11167	2	applied	\N	\N	\N	\N	38217	38217	38218
10737	11168	3	applied	\N	\N	\N	\N	38219	38219	38220
10742	11175	0	applied	\N	\N	\N	\N	38239	38239	38240
10742	11176	1	applied	\N	\N	\N	\N	38241	38241	38242
10742	11177	3	applied	\N	\N	\N	\N	38244	38244	38245
10744	11178	0	applied	\N	\N	\N	\N	38251	38251	38252
10744	11179	1	applied	\N	\N	\N	\N	38253	38253	38254
10745	11178	0	applied	\N	\N	\N	\N	38251	38251	38252
10745	11179	1	applied	\N	\N	\N	\N	38253	38253	38254
10749	11182	0	applied	\N	\N	\N	\N	38265	38265	38266
10749	11183	1	applied	\N	\N	\N	\N	38267	38267	38268
10749	11184	2	applied	\N	\N	1000000000	\N	38269	38269	38270
10760	11204	0	applied	\N	\N	\N	\N	38322	38322	38323
10760	11205	1	applied	\N	\N	\N	\N	38324	38324	38325
10760	11206	2	applied	\N	\N	\N	\N	38326	38326	38327
10760	11207	3	applied	\N	\N	\N	\N	38328	38328	38329
10764	11210	0	applied	\N	\N	\N	\N	38341	38341	38342
10764	11211	1	applied	\N	\N	\N	\N	38343	38343	38344
10769	11218	0	applied	\N	\N	\N	\N	38366	38366	38367
10769	11219	1	applied	\N	\N	\N	\N	38368	38368	38369
10769	11220	2	applied	\N	\N	\N	\N	38370	38370	38371
10769	11221	3	applied	\N	\N	\N	\N	38372	38372	38373
10779	11236	0	applied	\N	\N	\N	\N	38414	38414	38415
10779	11237	1	applied	\N	\N	\N	\N	38416	38416	38417
10779	11238	2	applied	\N	\N	\N	\N	38418	38418	38419
10781	11239	0	applied	\N	\N	\N	\N	38425	38425	38426
10781	11240	1	applied	\N	\N	\N	\N	38427	38427	38428
10781	11241	2	applied	\N	\N	\N	\N	38429	38429	38430
10781	11242	3	applied	\N	\N	\N	\N	38431	38431	38432
10788	11251	0	applied	\N	\N	\N	\N	38460	38460	38461
10788	11252	1	applied	\N	\N	\N	\N	38462	38462	38463
10788	11253	2	applied	\N	\N	\N	\N	38464	38464	38465
10788	11254	3	applied	\N	\N	\N	\N	38466	38466	38467
10792	11262	0	applied	\N	\N	\N	\N	38486	38486	38487
10792	11263	1	applied	\N	\N	\N	\N	38488	38488	38489
10792	11264	2	applied	\N	\N	\N	\N	38490	38490	38491
10792	11265	3	applied	\N	\N	\N	\N	38492	38492	38493
10792	11266	4	applied	\N	\N	\N	\N	38494	38494	38495
10792	11267	5	applied	\N	\N	\N	\N	38496	38496	38497
10795	11268	0	applied	\N	\N	\N	\N	38502	38502	29193
10795	11269	1	applied	\N	\N	\N	\N	38503	38503	38504
10795	11270	2	applied	\N	\N	\N	\N	38505	38505	38506
10795	11271	3	applied	\N	\N	\N	\N	38507	38507	38508
10795	11272	4	applied	\N	\N	\N	\N	38509	38509	38510
10797	11273	0	applied	\N	\N	\N	\N	38515	38515	38516
10797	11274	1	applied	\N	\N	\N	\N	38517	38517	38518
10807	11290	0	applied	\N	\N	\N	\N	38588	38588	38589
10807	11291	1	applied	\N	\N	\N	\N	38590	38590	38591
10807	11292	2	applied	\N	\N	\N	\N	38592	38592	38593
10811	11293	0	applied	\N	\N	\N	\N	38713	38713	38714
10811	11294	1	applied	\N	\N	\N	\N	38715	38715	38716
10811	11295	2	applied	\N	\N	\N	\N	38717	38717	38718
10813	11296	0	applied	\N	\N	\N	\N	38723	38723	38724
10813	11297	1	applied	\N	\N	\N	\N	38725	38725	38726
10815	11297	0	applied	\N	\N	\N	\N	38725	38725	38726
10821	11311	0	applied	\N	\N	\N	\N	38763	38763	38764
10821	11312	1	applied	\N	\N	\N	\N	38765	38765	38766
10825	11319	0	applied	\N	\N	\N	\N	38787	38787	38788
10825	11320	1	applied	\N	\N	1000000000	\N	38789	38789	38790
10825	11321	2	applied	\N	\N	\N	\N	38791	38791	38792
10830	11327	0	applied	\N	\N	\N	\N	38809	38809	38810
10830	11328	1	applied	\N	\N	\N	\N	38811	38811	38812
10832	11322	0	applied	\N	\N	\N	\N	38795	38795	38796
10832	11325	1	applied	\N	\N	\N	\N	38801	38801	38802
10832	11326	2	applied	\N	\N	\N	\N	38805	38805	38806
10832	11328	3	applied	\N	\N	\N	\N	38811	38811	38812
10840	11349	0	applied	\N	\N	\N	\N	38864	38864	38865
10840	11350	1	applied	\N	\N	\N	\N	38866	38866	38867
10843	11362	0	applied	\N	\N	\N	\N	38895	38895	38896
10843	11363	1	applied	\N	\N	\N	\N	38897	38897	38898
10843	11358	2	applied	\N	\N	\N	\N	38885	38885	38886
10843	11359	3	applied	\N	\N	\N	\N	38887	38887	38888
10843	11360	4	applied	\N	\N	\N	\N	38889	38889	38890
10843	11361	5	applied	\N	\N	\N	\N	38891	38891	38892
10845	11364	0	applied	\N	\N	\N	\N	38902	38902	38903
10845	11365	1	applied	\N	\N	\N	\N	38904	38904	38905
10845	11362	2	applied	\N	\N	\N	\N	38895	38895	38896
10845	11366	3	applied	\N	\N	\N	\N	38906	38906	38907
10845	11363	4	applied	\N	\N	\N	\N	38897	38897	38898
10845	11367	5	applied	\N	\N	\N	\N	38908	38908	38909
10845	11368	6	applied	\N	\N	\N	\N	38910	38910	38911
10848	11371	0	applied	\N	\N	\N	\N	38919	38919	38920
10848	11372	1	applied	\N	\N	\N	\N	38921	38921	38922
10848	11373	2	applied	\N	\N	\N	\N	38923	38923	38924
10848	11374	3	applied	\N	\N	\N	\N	38925	38925	38926
10848	11375	4	applied	\N	\N	\N	\N	38927	38927	38928
10850	11382	0	applied	\N	\N	\N	\N	38944	38944	38945
10850	11383	1	applied	\N	\N	\N	\N	38946	38946	38947
10859	11396	0	applied	\N	\N	\N	\N	39041	39041	39042
10859	11397	1	applied	\N	\N	\N	\N	39043	39043	39044
10860	11398	0	applied	\N	\N	\N	\N	39051	39051	39052
10860	11399	1	applied	\N	\N	\N	\N	39053	39053	39054
10860	11400	2	applied	\N	\N	\N	\N	39055	39055	39056
10860	11401	3	applied	\N	\N	\N	\N	39057	39057	39058
10863	11398	0	applied	\N	\N	\N	\N	39051	39051	39052
10863	11399	1	applied	\N	\N	\N	\N	39053	39053	39054
10863	11400	2	applied	\N	\N	\N	\N	39055	39055	39056
10863	11401	3	applied	\N	\N	\N	\N	39057	39057	39058
10864	11402	0	applied	\N	\N	\N	\N	39064	39064	39065
10864	11403	1	applied	\N	\N	\N	\N	39066	39066	39067
10867	11404	0	applied	\N	\N	\N	\N	39072	39072	39073
10867	11405	1	applied	\N	\N	\N	\N	39074	39074	39075
10867	11406	2	applied	\N	\N	\N	\N	39076	39076	39077
10870	11404	0	applied	\N	\N	\N	\N	39072	39072	39073
10870	11407	1	applied	\N	\N	\N	\N	39082	39082	39083
10870	11371	2	applied	\N	\N	\N	\N	38919	38919	38920
10870	11372	3	applied	\N	\N	\N	\N	38921	38921	38922
10870	11373	4	applied	\N	\N	\N	\N	38923	38923	38924
10870	11376	5	applied	\N	\N	\N	\N	38932	38932	38933
10870	11377	6	applied	\N	\N	\N	\N	38934	38934	38935
10870	11374	7	applied	\N	\N	\N	\N	38925	38925	38926
10870	11375	8	applied	\N	\N	\N	\N	38927	38927	38928
10870	11378	9	applied	\N	\N	\N	\N	38936	38936	38937
10870	11379	10	applied	\N	\N	\N	\N	38938	38938	38939
10870	11382	11	applied	\N	\N	\N	\N	38944	38944	38945
10870	11386	12	applied	\N	\N	\N	\N	38956	38956	38957
10870	11387	13	applied	\N	\N	\N	\N	38958	38958	38959
10870	11390	14	applied	\N	\N	\N	\N	38966	38966	38967
10870	11383	15	applied	\N	\N	\N	\N	38946	38946	38947
10870	11384	16	applied	\N	\N	\N	\N	38952	38952	38953
10870	11385	17	applied	\N	\N	\N	\N	38954	38954	38955
10870	11388	18	applied	\N	\N	\N	\N	38962	38962	38963
10870	11389	19	applied	\N	\N	\N	\N	38964	38964	38965
10870	11391	20	applied	\N	\N	\N	\N	38968	38968	38969
10870	11395	21	applied	\N	\N	\N	\N	39037	39037	39038
10765	11214	2	applied	\N	\N	\N	\N	38351	38351	38352
10765	11215	3	applied	\N	\N	\N	\N	38353	38353	38354
10770	11218	0	applied	\N	\N	\N	\N	38366	38366	38367
10770	11219	1	applied	\N	\N	\N	\N	38368	38368	38369
10770	11220	2	applied	\N	\N	\N	\N	38370	38370	38371
10770	11221	3	applied	\N	\N	\N	\N	38372	38372	38373
10772	11222	0	applied	\N	\N	\N	\N	38378	38378	38379
10772	11223	1	applied	\N	\N	\N	\N	38380	38380	38381
10772	11224	2	applied	\N	\N	\N	\N	38382	38382	38383
10772	11225	3	applied	\N	\N	\N	\N	38384	38384	38385
10774	11226	0	applied	\N	\N	\N	\N	38388	38388	38389
10774	11227	1	applied	\N	\N	\N	\N	38390	38390	38391
10774	11228	2	applied	\N	\N	\N	\N	38392	38392	38393
10774	11229	3	applied	\N	\N	\N	\N	38394	38394	38395
10777	11235	0	applied	\N	\N	\N	\N	38410	38410	38411
10782	11239	0	applied	\N	\N	\N	\N	38425	38425	38426
10782	11240	1	applied	\N	\N	\N	\N	38427	38427	38428
10782	11241	2	applied	\N	\N	\N	\N	38429	38429	38430
10782	11242	3	applied	\N	\N	\N	\N	38431	38431	38432
10784	11138	0	applied	\N	\N	\N	\N	38131	38131	38132
10784	11146	1	applied	\N	\N	\N	\N	38158	38158	38159
10784	11147	2	applied	\N	\N	\N	\N	38160	38160	38161
10784	11243	3	applied	\N	\N	\N	\N	38438	38438	38439
10784	10881	4	applied	\N	\N	\N	\N	37258	37258	37259
10784	10883	5	applied	\N	\N	\N	\N	37263	37263	37264
10784	11227	6	applied	\N	\N	\N	\N	38390	38390	38391
10784	11218	7	applied	\N	\N	\N	\N	38366	38366	38367
10784	11220	8	applied	\N	\N	\N	\N	38370	38370	38371
10784	11229	9	applied	\N	\N	\N	\N	38394	38394	38395
10784	11230	10	applied	\N	\N	\N	\N	38398	38398	38399
10784	11236	11	applied	\N	\N	\N	\N	38414	38414	38415
10784	10887	12	applied	\N	\N	\N	\N	37273	37273	37274
10784	10888	13	applied	\N	\N	\N	\N	37277	37277	37278
10784	10892	14	applied	\N	\N	\N	\N	37291	37291	37292
10784	10893	15	applied	\N	\N	\N	\N	37293	37293	37294
10784	10895	16	applied	\N	\N	\N	\N	37301	37301	37302
10784	10897	17	applied	\N	\N	\N	\N	37322	37322	37339
10784	10898	18	applied	\N	\N	\N	\N	37324	37324	37340
10784	10899	19	applied	\N	\N	\N	\N	37326	37326	37341
10784	10904	20	applied	\N	\N	\N	\N	37346	37346	37347
10784	10906	21	applied	\N	\N	\N	\N	37354	37354	37355
10784	10907	22	applied	\N	\N	\N	\N	37357	37357	37358
10784	10912	23	applied	\N	\N	\N	\N	37426	37426	37427
10784	10915	24	applied	\N	\N	\N	\N	37434	37434	37435
10784	10917	25	applied	\N	\N	\N	\N	37440	37440	37441
10784	10919	26	applied	\N	\N	\N	\N	37446	37446	37447
10784	10920	27	applied	\N	\N	\N	\N	37450	37450	37451
10784	10923	28	applied	\N	\N	\N	\N	37458	37458	37459
10784	10925	29	applied	\N	\N	\N	\N	37472	37472	37473
10784	10927	30	applied	\N	\N	\N	\N	37479	37479	37480
10784	10928	31	applied	\N	\N	\N	\N	37482	37482	37483
10784	10931	32	applied	\N	\N	\N	\N	37489	37489	37490
10784	10932	33	applied	\N	\N	\N	\N	37492	37492	37493
10784	10933	34	applied	\N	\N	\N	\N	37494	37494	37495
10784	10935	35	applied	\N	\N	\N	\N	37499	37499	37500
10784	10940	36	applied	\N	\N	\N	\N	37513	37513	37514
10784	10941	37	applied	\N	\N	\N	\N	37515	37515	37516
10784	10942	38	applied	\N	\N	\N	\N	37517	37517	37518
10784	10943	39	applied	\N	\N	\N	\N	37521	37521	37522
10784	10946	40	applied	\N	\N	\N	\N	37527	37527	37528
10784	10947	41	applied	\N	\N	\N	\N	37532	37532	37533
10784	10950	42	applied	\N	\N	\N	\N	37545	37545	37546
10784	10952	43	applied	\N	\N	\N	\N	37550	37550	37551
10784	10953	44	applied	\N	\N	\N	\N	37552	37552	37553
10784	10957	45	applied	\N	\N	\N	\N	37562	37562	37563
10784	10958	46	applied	\N	\N	\N	\N	37564	37564	37565
10784	10959	47	applied	\N	\N	\N	\N	37570	37570	37571
10784	10963	48	applied	\N	\N	\N	\N	37582	37582	37583
10784	10964	49	applied	\N	\N	\N	\N	37584	37584	37585
10784	10966	50	applied	\N	\N	\N	\N	37592	37592	37593
10784	10968	51	applied	\N	\N	\N	\N	37598	37598	37599
10784	10970	52	applied	\N	\N	\N	\N	37604	37604	37605
10784	10972	53	applied	\N	\N	\N	\N	37612	37612	37613
10784	10974	54	applied	\N	\N	\N	\N	37616	37616	37617
10784	10975	55	applied	\N	\N	\N	\N	37620	37620	37621
10784	10978	56	applied	\N	\N	\N	\N	37628	37628	37629
10784	10979	57	applied	\N	\N	\N	\N	37634	37634	37635
10784	10980	58	applied	\N	\N	\N	\N	37636	37636	37637
10784	10984	59	applied	\N	\N	\N	\N	37648	37648	37649
10784	10985	60	applied	\N	\N	\N	\N	37652	37652	37653
10784	10989	61	applied	\N	\N	\N	\N	37661	37661	37662
10784	10990	62	applied	\N	\N	\N	\N	37665	37665	37666
10784	10994	63	applied	\N	\N	\N	\N	37680	37680	37681
10784	10995	64	applied	\N	\N	\N	\N	37682	37682	37683
10784	10999	65	applied	\N	\N	\N	\N	37692	37692	37693
10784	11000	66	applied	\N	\N	\N	\N	37694	37694	37695
10784	11001	67	applied	\N	\N	\N	\N	37696	37696	37697
10784	11002	68	applied	\N	\N	\N	\N	37701	37701	37702
10784	11005	69	applied	\N	\N	\N	\N	37711	37711	37712
10784	11007	70	applied	\N	\N	\N	\N	37717	37717	37718
10784	11009	71	applied	\N	\N	\N	\N	37721	37721	37722
10784	11014	72	applied	\N	\N	\N	\N	37738	37738	37739
10784	11015	73	applied	\N	\N	\N	\N	37740	37740	37741
10784	11017	74	applied	\N	\N	\N	\N	37749	37749	37750
10784	11021	75	applied	\N	\N	\N	\N	37760	37760	37761
10784	11022	76	applied	\N	\N	\N	\N	37762	37762	37763
10784	11023	77	applied	\N	\N	\N	\N	37764	37764	37765
10784	11026	78	applied	\N	\N	\N	\N	37772	37772	37773
10784	11027	79	applied	\N	\N	\N	\N	37778	37778	37779
10784	11031	80	applied	\N	\N	\N	\N	37788	37788	37789
10784	11032	81	applied	\N	\N	\N	\N	37813	37813	37814
10784	11036	82	applied	\N	\N	\N	\N	37823	37823	37824
10784	11039	83	applied	\N	\N	\N	\N	37829	37829	37830
10784	11041	84	applied	\N	\N	\N	\N	37837	37837	37838
10784	11044	85	applied	\N	\N	\N	\N	37849	37849	37850
10784	11045	86	applied	\N	\N	\N	\N	37851	37851	37852
10784	11046	87	applied	\N	\N	\N	\N	37859	37859	37860
10784	11047	88	applied	\N	\N	\N	\N	37861	37861	37862
10784	11052	89	applied	\N	\N	\N	\N	37873	37873	37874
10784	11053	90	applied	\N	\N	\N	\N	37875	37875	37876
10784	11054	91	applied	\N	\N	\N	\N	37884	37884	37885
10784	11055	92	applied	\N	\N	\N	\N	37887	37887	37888
10784	11057	93	applied	\N	\N	\N	\N	37893	37893	37894
10784	11060	94	applied	\N	\N	\N	\N	37905	37905	37906
10784	11061	95	applied	\N	\N	\N	\N	37907	37907	37908
10784	11064	96	applied	\N	\N	\N	\N	37918	37918	37919
10784	11065	97	applied	\N	\N	\N	\N	37920	37920	37921
10784	11066	98	applied	\N	\N	\N	\N	37922	37922	37923
10784	11070	99	applied	\N	\N	\N	\N	37935	37935	37936
10784	11073	100	applied	\N	\N	\N	\N	37942	37942	37943
10776	11231	1	applied	\N	\N	\N	\N	38400	38400	38401
10776	11232	2	applied	\N	\N	\N	\N	38402	38402	38403
10776	11233	3	applied	\N	\N	\N	\N	38404	38404	38405
10776	11234	4	applied	\N	\N	\N	\N	38406	38406	38407
10778	11236	0	applied	\N	\N	\N	\N	38414	38414	38415
10778	11237	1	applied	\N	\N	\N	\N	38416	38416	38417
10778	11238	2	applied	\N	\N	\N	\N	38418	38418	38419
10780	11236	0	applied	\N	\N	\N	\N	38414	38414	38415
10780	11237	1	applied	\N	\N	\N	\N	38416	38416	38417
10780	11238	2	applied	\N	\N	\N	\N	38418	38418	38419
10785	11244	0	applied	\N	\N	\N	\N	38443	38443	38444
10785	11245	1	applied	\N	\N	1000000000	\N	38445	38445	38446
10785	11246	2	applied	\N	\N	\N	\N	38447	38447	38448
10785	11247	3	applied	\N	\N	\N	\N	38449	38449	38450
10791	11262	0	applied	\N	\N	\N	\N	38486	38486	38487
10791	11263	1	applied	\N	\N	\N	\N	38488	38488	38489
10791	11264	2	applied	\N	\N	\N	\N	38490	38490	38491
10791	11265	3	applied	\N	\N	\N	\N	38492	38492	38493
10791	11266	4	applied	\N	\N	\N	\N	38494	38494	38495
10791	11267	5	applied	\N	\N	\N	\N	38496	38496	38497
10794	11268	0	applied	\N	\N	\N	\N	38502	38502	29193
10794	11269	1	applied	\N	\N	\N	\N	38503	38503	38504
10794	11270	2	applied	\N	\N	\N	\N	38505	38505	38506
10794	11271	3	applied	\N	\N	\N	\N	38507	38507	38508
10794	11272	4	applied	\N	\N	\N	\N	38509	38509	38510
10796	11273	0	applied	\N	\N	\N	\N	38515	38515	38516
10796	11274	1	applied	\N	\N	\N	\N	38517	38517	38518
10799	11273	0	applied	\N	\N	\N	\N	38515	38515	38516
10799	11274	1	applied	\N	\N	\N	\N	38517	38517	38518
10801	11280	0	applied	\N	\N	\N	\N	38532	38532	38533
10801	11281	1	applied	\N	\N	\N	\N	38534	38534	38535
10801	11282	2	applied	\N	\N	\N	\N	38536	38536	38537
10801	11283	3	applied	\N	\N	\N	\N	38538	38538	38539
10804	11284	0	applied	\N	\N	\N	\N	38573	38573	38574
10804	11285	1	applied	\N	\N	\N	\N	38575	38575	38576
10804	11286	2	applied	\N	\N	\N	\N	38577	38577	38578
10804	11287	3	applied	\N	\N	\N	\N	38579	38579	38580
10806	11290	0	applied	\N	\N	\N	\N	38588	38588	38589
10806	11291	1	applied	\N	\N	\N	\N	38590	38590	38591
10806	11292	2	applied	\N	\N	\N	\N	38592	38592	38593
10810	11293	0	applied	\N	\N	\N	\N	38713	38713	38714
10810	11294	1	applied	\N	\N	\N	\N	38715	38715	38716
10810	11295	2	applied	\N	\N	\N	\N	38717	38717	38718
10812	11293	0	applied	\N	\N	\N	\N	38713	38713	38714
10812	11294	1	applied	\N	\N	\N	\N	38715	38715	38716
10818	11308	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	38755	38755	\N
10818	11309	1	applied	\N	\N	\N	\N	38756	38756	38757
10818	11310	2	applied	\N	\N	\N	\N	38758	38758	38759
10820	11311	0	applied	\N	\N	\N	\N	38763	38763	38764
10820	11312	1	applied	\N	\N	\N	\N	38765	38765	38766
10822	11313	0	applied	\N	\N	\N	\N	38772	38772	38773
10822	11314	1	applied	\N	\N	\N	\N	38774	38774	38775
10822	11315	2	applied	\N	\N	\N	\N	38776	38776	38777
10827	11319	0	applied	\N	\N	\N	\N	38787	38787	38788
10827	11320	1	applied	\N	\N	1000000000	\N	38789	38789	38790
10827	11321	2	applied	\N	\N	\N	\N	38791	38791	38792
10829	11326	0	applied	\N	\N	\N	\N	38805	38805	38806
10838	11339	0	applied	\N	\N	\N	\N	38840	38840	38841
10838	11340	1	applied	\N	\N	\N	\N	38842	38842	38843
10838	11341	2	applied	\N	\N	\N	\N	38844	38844	38845
10838	11342	3	applied	\N	\N	\N	\N	38846	38846	38847
10838	11343	4	applied	\N	\N	\N	\N	38848	38848	38849
10838	11344	5	applied	\N	\N	\N	\N	38850	38850	38851
10838	11345	6	applied	\N	\N	\N	\N	38852	38852	38853
10838	11347	7	applied	\N	\N	\N	\N	38856	38856	38857
10838	11348	8	applied	\N	\N	\N	\N	38858	38858	38859
10839	11349	0	applied	\N	\N	\N	\N	38864	38864	38865
10839	11350	1	applied	\N	\N	\N	\N	38866	38866	38867
10842	11358	0	applied	\N	\N	\N	\N	38885	38885	38886
10842	11359	1	applied	\N	\N	\N	\N	38887	38887	38888
10842	11360	2	applied	\N	\N	\N	\N	38889	38889	38890
10842	11361	3	applied	\N	\N	\N	\N	38891	38891	38892
10847	11371	0	applied	\N	\N	\N	\N	38919	38919	38920
10847	11372	1	applied	\N	\N	\N	\N	38921	38921	38922
10847	11373	2	applied	\N	\N	\N	\N	38923	38923	38924
10847	11374	3	applied	\N	\N	\N	\N	38925	38925	38926
10847	11375	4	applied	\N	\N	\N	\N	38927	38927	38928
10852	11384	0	applied	\N	\N	\N	\N	38952	38952	38953
10852	11385	1	applied	\N	\N	\N	\N	38954	38954	38955
10852	11386	2	applied	\N	\N	\N	\N	38956	38956	38957
10852	11387	3	applied	\N	\N	\N	\N	38958	38958	38959
10853	11388	0	applied	\N	\N	\N	\N	38962	38962	38963
10853	11389	1	applied	\N	\N	\N	\N	38964	38964	38965
10853	11390	2	applied	\N	\N	\N	\N	38966	38966	38967
10853	11391	3	applied	\N	\N	\N	\N	38968	38968	38969
10853	11392	4	applied	\N	\N	\N	\N	38970	38970	38971
10853	11393	5	applied	\N	\N	\N	\N	38972	38972	38973
10856	11396	0	applied	\N	\N	\N	\N	39041	39041	39042
10856	11397	1	applied	\N	\N	\N	\N	39043	39043	39044
10861	11398	0	applied	\N	\N	\N	\N	39051	39051	39052
10861	11399	1	applied	\N	\N	\N	\N	39053	39053	39054
10861	11400	2	applied	\N	\N	\N	\N	39055	39055	39056
10861	11401	3	applied	\N	\N	\N	\N	39057	39057	39058
10784	11075	101	applied	\N	\N	\N	\N	37948	37948	37949
10784	11076	102	applied	\N	\N	\N	\N	37956	37956	37957
10784	11078	103	applied	\N	\N	\N	\N	37960	37960	37961
10784	11081	104	applied	\N	\N	\N	\N	37968	37968	37969
10784	11083	105	applied	\N	\N	\N	\N	37974	37974	37975
10784	11085	106	applied	\N	\N	\N	\N	37978	37978	37979
10784	11087	107	applied	\N	\N	\N	\N	37983	37983	37984
10784	11089	108	applied	\N	\N	\N	\N	37990	37990	37991
10784	11092	109	applied	\N	\N	\N	\N	37997	37997	37998
10784	11094	110	applied	\N	\N	\N	\N	38003	38003	38004
10784	11096	111	applied	\N	\N	\N	\N	38013	38013	38014
10784	11097	113	applied	\N	\N	\N	\N	38015	38015	38016
10784	11101	114	applied	\N	\N	\N	\N	38025	38025	38026
10784	11102	115	applied	\N	\N	\N	\N	38027	38027	38028
10784	11103	116	applied	\N	\N	\N	\N	38029	38029	38030
10784	11104	117	applied	\N	\N	\N	\N	38033	38033	38034
10784	11105	118	applied	\N	\N	\N	\N	38035	38035	38036
10784	11112	119	applied	\N	\N	\N	\N	38057	38057	38058
10784	11114	120	applied	\N	\N	\N	\N	38062	38062	38063
10784	11117	121	applied	\N	\N	\N	\N	38068	38068	38069
10784	11122	122	applied	\N	\N	\N	\N	38080	38080	38081
10784	11123	123	applied	\N	\N	\N	\N	38082	38082	38083
10784	11124	124	applied	\N	\N	\N	\N	38084	38084	38085
10784	11125	125	applied	\N	\N	\N	\N	38086	38086	38087
10786	11248	0	applied	\N	\N	\N	\N	38452	38452	38453
10786	11249	1	applied	\N	\N	\N	\N	38454	38454	38455
10786	11250	2	applied	\N	\N	\N	\N	38456	38456	38457
10789	11255	0	applied	\N	\N	\N	\N	38468	38468	38469
10789	11256	1	applied	\N	\N	\N	\N	38470	38470	38471
10798	11273	0	applied	\N	\N	\N	\N	38515	38515	38516
10798	11274	1	applied	\N	\N	\N	\N	38517	38517	38518
10802	11268	0	applied	\N	\N	\N	\N	38502	38502	29193
10802	11248	1	applied	\N	\N	\N	\N	38541	38541	38453
10802	11127	2	applied	\N	\N	\N	\N	38093	38093	38094
10802	11129	3	applied	\N	\N	\N	\N	38099	38099	38100
10802	11131	4	applied	\N	\N	\N	\N	38105	38105	38106
10802	11132	5	applied	\N	\N	\N	\N	38109	38109	38110
10802	11135	6	applied	\N	\N	\N	\N	38121	38121	38122
10802	11278	7	applied	\N	\N	\N	\N	38542	38542	38528
10802	11137	8	applied	\N	\N	\N	\N	38127	38127	38128
10802	11139	9	applied	\N	\N	\N	\N	38133	38133	38134
10802	11142	10	applied	\N	\N	\N	\N	38139	38139	38140
10802	11145	11	applied	\N	\N	\N	\N	38148	38148	38149
10802	11148	12	applied	\N	\N	\N	\N	38162	38162	38163
10802	11154	13	applied	\N	\N	\N	\N	38177	38177	38178
10802	11156	14	applied	\N	\N	\N	\N	38183	38183	38184
10802	11157	15	applied	\N	\N	\N	\N	38191	38191	38192
10802	11160	16	applied	\N	\N	\N	\N	38199	38199	38200
10802	11161	17	applied	\N	\N	\N	\N	38204	38204	38205
10802	11162	18	applied	\N	\N	\N	\N	38206	38206	38207
10802	11165	19	applied	\N	\N	\N	\N	38213	38213	38214
10802	11166	20	applied	\N	\N	\N	\N	38215	38215	38216
10802	11170	21	applied	\N	\N	\N	\N	38225	38225	38226
10802	11173	22	applied	\N	\N	\N	\N	38235	38235	38236
10802	11174	23	applied	\N	\N	\N	\N	38237	38237	38238
10802	11175	24	applied	\N	\N	\N	\N	38239	38239	38240
10802	11179	25	applied	\N	\N	\N	\N	38253	38253	38254
10802	11181	26	applied	\N	\N	\N	\N	38261	38261	38262
10802	11182	27	applied	\N	\N	\N	\N	38265	38265	38266
10802	11185	28	applied	\N	\N	\N	\N	38276	38276	38277
10802	11190	29	applied	\N	\N	\N	\N	38286	38286	38287
10802	11191	30	applied	\N	\N	\N	\N	38288	38288	38289
10802	11195	31	applied	\N	\N	\N	\N	38298	38298	38299
10802	11196	32	applied	\N	\N	\N	\N	38300	38300	38301
10802	11197	33	applied	\N	\N	\N	\N	38302	38302	38303
10802	11198	34	applied	\N	\N	\N	\N	38304	38304	38305
10802	11200	35	applied	\N	\N	\N	\N	38310	38310	38311
10802	11203	36	applied	\N	\N	\N	\N	38318	38318	38319
10802	11204	37	applied	\N	\N	\N	\N	38322	38322	38323
10802	11205	38	applied	\N	\N	\N	\N	38324	38324	38325
10802	11209	39	applied	\N	\N	\N	\N	38339	38339	38340
10802	11211	40	applied	\N	\N	\N	\N	38343	38343	38344
10802	11214	41	applied	\N	\N	\N	\N	38351	38351	38352
10802	11215	42	applied	\N	\N	\N	\N	38353	38353	38354
10802	11219	43	applied	\N	\N	\N	\N	38368	38368	38543
10802	11222	44	applied	\N	\N	\N	\N	38378	38378	38544
10802	11225	45	applied	\N	\N	\N	\N	38384	38384	38545
10802	11228	46	applied	\N	\N	\N	\N	38392	38392	38546
10802	11233	47	applied	\N	\N	\N	\N	38404	38404	38547
10802	11234	48	applied	\N	\N	\N	\N	38406	38406	38548
10802	11235	49	applied	\N	\N	\N	\N	38410	38410	38549
10802	11237	50	applied	\N	\N	\N	\N	38416	38416	38550
10802	11239	51	applied	\N	\N	\N	\N	38425	38425	38551
10802	11240	52	applied	\N	\N	\N	\N	38427	38427	38552
10802	11246	53	applied	\N	\N	\N	\N	38447	38447	38553
10802	11249	54	applied	\N	\N	\N	\N	38454	38454	38554
10802	11252	55	applied	\N	\N	\N	\N	38462	38462	38555
10802	11253	56	applied	\N	\N	\N	\N	38464	38464	38556
10802	11256	57	applied	\N	\N	\N	\N	38470	38470	38557
10802	11258	58	applied	\N	\N	\N	\N	38476	38476	38558
10802	11259	59	applied	\N	\N	\N	\N	38478	38478	38559
10802	11265	60	applied	\N	\N	\N	\N	38492	38492	38560
10802	11266	61	applied	\N	\N	\N	\N	38494	38494	38561
10802	11267	62	applied	\N	\N	\N	\N	38496	38496	38562
10802	11271	63	applied	\N	\N	\N	\N	38507	38507	38563
10802	11272	64	applied	\N	\N	\N	\N	38509	38509	38564
10802	11273	65	applied	\N	\N	\N	\N	38515	38515	38565
10802	11275	66	applied	\N	\N	\N	\N	38521	38521	38566
10802	11277	67	applied	\N	\N	\N	\N	38525	38525	38567
10802	11280	68	applied	\N	\N	\N	\N	38532	38532	38568
10802	11281	69	applied	\N	\N	\N	\N	38534	38534	38569
10802	10882	70	applied	\N	\N	\N	\N	37260	37260	37261
10802	10884	71	applied	\N	\N	\N	\N	37265	37265	37266
10802	10886	72	applied	\N	\N	\N	\N	37271	37271	37272
10802	10889	73	applied	\N	\N	\N	\N	37279	37279	37280
10802	10890	74	applied	\N	\N	\N	\N	37287	37287	37288
10802	10891	75	applied	\N	\N	\N	\N	37289	37289	37290
10802	10896	76	applied	\N	\N	\N	\N	37303	37303	37304
10802	10900	77	applied	\N	\N	\N	\N	37329	37329	37330
10802	10901	78	applied	\N	\N	\N	\N	37331	37331	37332
10802	10902	79	applied	\N	\N	\N	\N	37333	37333	37334
10802	10903	80	applied	\N	\N	\N	\N	37335	37335	37336
10802	10905	81	applied	\N	\N	\N	\N	37348	37348	37349
10802	10908	82	applied	\N	\N	\N	\N	37359	37359	37360
10802	10909	83	applied	\N	\N	\N	\N	37361	37361	37362
10802	10913	84	applied	\N	\N	\N	\N	37428	37428	37429
10802	10914	85	applied	\N	\N	\N	\N	37432	37432	37433
10802	10916	86	applied	\N	\N	\N	\N	37438	37438	37439
10802	10918	87	applied	\N	\N	\N	\N	37444	37444	37445
10802	10921	88	applied	\N	\N	\N	\N	37452	37452	37453
10802	10922	89	applied	\N	\N	\N	\N	37456	37456	37457
10802	10924	90	applied	\N	\N	\N	\N	37470	37470	37471
10802	10926	91	applied	\N	\N	\N	\N	37477	37477	37478
10802	10929	92	applied	\N	\N	\N	\N	37485	37485	37486
10802	10930	93	applied	\N	\N	\N	\N	37487	37487	37488
10802	10934	94	applied	\N	\N	\N	\N	37496	37496	37497
10802	10936	95	applied	\N	\N	\N	\N	37501	37501	37502
10802	10937	96	applied	\N	\N	\N	\N	37507	37507	37508
10802	10938	97	applied	\N	\N	\N	\N	37509	37509	37510
10802	10939	98	applied	\N	\N	\N	\N	37511	37511	37512
10802	10944	99	applied	\N	\N	\N	\N	37523	37523	37524
10802	10945	100	applied	\N	\N	\N	\N	37525	37525	37526
10802	10948	101	applied	\N	\N	\N	\N	37534	37534	37535
10802	10949	102	applied	\N	\N	\N	\N	37543	37543	37544
10802	10951	103	applied	\N	\N	\N	\N	37548	37548	37549
10802	10954	104	applied	\N	\N	\N	\N	37554	37554	37555
10802	10955	105	applied	\N	\N	\N	\N	37558	37558	37559
10802	10956	106	applied	\N	\N	\N	\N	37560	37560	37561
10802	10960	107	applied	\N	\N	\N	\N	37572	37572	37573
10802	10961	108	applied	\N	\N	\N	\N	37578	37578	37579
10802	10962	109	applied	\N	\N	\N	\N	37580	37580	37581
10802	10965	110	applied	\N	\N	\N	\N	37590	37590	37591
10802	10967	111	applied	\N	\N	\N	\N	37596	37596	37597
10802	10969	113	applied	\N	\N	\N	\N	37602	37602	37603
10802	10971	114	applied	\N	\N	\N	\N	37610	37610	37611
10802	10973	115	applied	\N	\N	\N	\N	37614	37614	37615
10802	10976	116	applied	\N	\N	\N	\N	37622	37622	37623
10802	10977	117	applied	\N	\N	\N	\N	37626	37626	37627
10802	10981	118	applied	\N	\N	\N	\N	37638	37638	37639
10802	10982	119	applied	\N	\N	\N	\N	37640	37640	37641
10802	10983	120	applied	\N	\N	\N	\N	37646	37646	37647
10802	10986	121	applied	\N	\N	\N	\N	37654	37654	37655
10802	10988	122	applied	\N	\N	\N	\N	37659	37659	37660
10802	10991	123	applied	\N	\N	\N	\N	37667	37667	37668
10802	10992	124	applied	\N	\N	\N	\N	37676	37676	37677
10802	10993	125	applied	\N	\N	\N	\N	37678	37678	37679
10805	11288	0	applied	\N	\N	\N	\N	38582	38582	38583
10805	11289	1	applied	\N	\N	\N	\N	38584	38584	38585
10808	11290	0	applied	\N	\N	\N	\N	38588	38588	38589
10808	11291	1	applied	\N	\N	\N	\N	38590	38590	38591
10808	11292	2	applied	\N	\N	\N	\N	38592	38592	38593
10809	11268	0	applied	\N	\N	\N	\N	38502	38502	29193
10809	11146	1	applied	\N	\N	\N	\N	38158	38158	38159
10809	11147	2	applied	\N	\N	\N	\N	38160	38160	38161
10809	11243	3	applied	\N	\N	\N	\N	38438	38438	38439
10809	11227	4	applied	\N	\N	\N	\N	38390	38390	38391
10809	11218	5	applied	\N	\N	\N	\N	38366	38366	38367
10809	10906	6	applied	\N	\N	\N	\N	37354	37354	38597
10809	10907	7	applied	\N	\N	\N	\N	37357	37357	38598
10809	10912	8	applied	\N	\N	\N	\N	37426	37426	38599
10809	10915	9	applied	\N	\N	\N	\N	37434	37434	38600
10809	10917	10	applied	\N	\N	\N	\N	37440	37440	38601
10809	11220	11	applied	\N	\N	\N	\N	38370	38370	38371
10809	11229	12	applied	\N	\N	\N	\N	38394	38394	38395
10809	11230	13	applied	\N	\N	\N	\N	38398	38398	38399
10809	11236	14	applied	\N	\N	\N	\N	38414	38414	38415
10809	11248	15	applied	\N	\N	\N	\N	38541	38541	38453
10809	10919	16	applied	\N	\N	\N	\N	37446	37446	38602
10809	10920	17	applied	\N	\N	\N	\N	37450	37450	38603
10809	10923	18	applied	\N	\N	\N	\N	37458	37458	38604
10809	11278	19	applied	\N	\N	\N	\N	38542	38542	38528
10809	10925	20	applied	\N	\N	\N	\N	37472	37472	38605
10809	10927	21	applied	\N	\N	\N	\N	37479	37479	38606
10809	10928	22	applied	\N	\N	\N	\N	37482	37482	38607
10809	10931	24	applied	\N	\N	\N	\N	37489	37489	38609
10809	10932	25	applied	\N	\N	\N	\N	37492	37492	38610
10809	10933	26	applied	\N	\N	\N	\N	37494	37494	38611
10809	10935	27	applied	\N	\N	\N	\N	37499	37499	38612
10809	10940	28	applied	\N	\N	\N	\N	37513	37513	38613
10809	10941	29	applied	\N	\N	\N	\N	37515	37515	38614
10809	10942	30	applied	\N	\N	\N	\N	37517	37517	38615
10809	10943	31	applied	\N	\N	\N	\N	37521	37521	38616
10809	10946	32	applied	\N	\N	\N	\N	37527	37527	38617
10809	10947	33	applied	\N	\N	\N	\N	37532	37532	38618
10809	10950	34	applied	\N	\N	\N	\N	37545	37545	38619
10809	10952	35	applied	\N	\N	\N	\N	37550	37550	38620
10809	10953	36	applied	\N	\N	\N	\N	37552	37552	38621
10809	10957	37	applied	\N	\N	\N	\N	37562	37562	38622
10809	10958	38	applied	\N	\N	\N	\N	37564	37564	38623
10809	10959	39	applied	\N	\N	\N	\N	37570	37570	38624
10809	10963	40	applied	\N	\N	\N	\N	37582	37582	38625
10809	10964	41	applied	\N	\N	\N	\N	37584	37584	38626
10809	10966	42	applied	\N	\N	\N	\N	37592	37592	38627
10809	11292	43	applied	\N	\N	\N	\N	38628	38628	38593
10809	10968	44	applied	\N	\N	\N	\N	37598	37598	38629
10809	10970	45	applied	\N	\N	\N	\N	37604	37604	38630
10809	10972	46	applied	\N	\N	\N	\N	37612	37612	38631
10809	10974	47	applied	\N	\N	\N	\N	37616	37616	38632
10809	10975	48	applied	\N	\N	\N	\N	37620	37620	38633
10809	10978	49	applied	\N	\N	\N	\N	37628	37628	38634
10809	10979	50	applied	\N	\N	\N	\N	37634	37634	38635
10809	10980	51	applied	\N	\N	\N	\N	37636	37636	38636
10809	10984	52	applied	\N	\N	\N	\N	37648	37648	38637
10809	10985	53	applied	\N	\N	\N	\N	37652	37652	38638
10809	10989	54	applied	\N	\N	\N	\N	37661	37661	38639
10809	10990	55	applied	\N	\N	\N	\N	37665	37665	38640
10809	10994	56	applied	\N	\N	\N	\N	37680	37680	38641
10809	10995	57	applied	\N	\N	\N	\N	37682	37682	38642
10809	10999	58	applied	\N	\N	\N	\N	37692	37692	38643
10809	11000	59	applied	\N	\N	\N	\N	37694	37694	38644
10809	11001	60	applied	\N	\N	\N	\N	37696	37696	38645
10809	11002	61	applied	\N	\N	\N	\N	37701	37701	38646
10809	11005	62	applied	\N	\N	\N	\N	37711	37711	38647
10809	11007	63	applied	\N	\N	\N	\N	37717	37717	38648
10809	11009	64	applied	\N	\N	\N	\N	37721	37721	38649
10809	11014	65	applied	\N	\N	\N	\N	37738	37738	38650
10809	11015	66	applied	\N	\N	\N	\N	37740	37740	38651
10809	11017	67	applied	\N	\N	\N	\N	37749	37749	38652
10809	11021	68	applied	\N	\N	\N	\N	37760	37760	38653
10809	11022	69	applied	\N	\N	\N	\N	37762	37762	38654
10809	11023	70	applied	\N	\N	\N	\N	37764	37764	38655
10809	11026	71	applied	\N	\N	\N	\N	37772	37772	38656
10809	11027	72	applied	\N	\N	\N	\N	37778	37778	38657
10809	11031	73	applied	\N	\N	\N	\N	37788	37788	38658
10809	11032	74	applied	\N	\N	\N	\N	37813	37813	38659
10809	11036	75	applied	\N	\N	\N	\N	37823	37823	38660
10809	11039	76	applied	\N	\N	\N	\N	37829	37829	38661
10809	11041	77	applied	\N	\N	\N	\N	37837	37837	38662
10809	11044	78	applied	\N	\N	\N	\N	37849	37849	38663
10809	11045	79	applied	\N	\N	\N	\N	37851	37851	38664
10809	11046	80	applied	\N	\N	\N	\N	37859	37859	38665
10809	11047	81	applied	\N	\N	\N	\N	37861	37861	38666
10809	11052	82	applied	\N	\N	\N	\N	37873	37873	38667
10809	11053	83	applied	\N	\N	\N	\N	37875	37875	38668
10809	11054	84	applied	\N	\N	\N	\N	37884	37884	38669
10809	11055	85	applied	\N	\N	\N	\N	37887	37887	38670
10809	11057	86	applied	\N	\N	\N	\N	37893	37893	38671
10809	11060	87	applied	\N	\N	\N	\N	37905	37905	38672
10809	11061	88	applied	\N	\N	\N	\N	37907	37907	38673
10809	11064	89	applied	\N	\N	\N	\N	37918	37918	38674
10809	11065	90	applied	\N	\N	\N	\N	37920	37920	38675
10809	11066	91	applied	\N	\N	\N	\N	37922	37922	38676
10809	11070	92	applied	\N	\N	\N	\N	37935	37935	38677
10809	11073	93	applied	\N	\N	\N	\N	37942	37942	38678
10809	11075	94	applied	\N	\N	\N	\N	37948	37948	38679
10809	11076	95	applied	\N	\N	\N	\N	37956	37956	38680
10809	11078	96	applied	\N	\N	\N	\N	37960	37960	38681
10809	11081	97	applied	\N	\N	\N	\N	37968	37968	38682
10809	11083	98	applied	\N	\N	\N	\N	37974	37974	38683
10809	11085	99	applied	\N	\N	\N	\N	37978	37978	38684
10809	11087	100	applied	\N	\N	\N	\N	37983	37983	38685
10809	11089	101	applied	\N	\N	\N	\N	37990	37990	38686
10809	11092	102	applied	\N	\N	\N	\N	37997	37997	38687
10809	11094	103	applied	\N	\N	\N	\N	38003	38003	38688
10809	11096	104	applied	\N	\N	\N	\N	38013	38013	38689
10809	11097	105	applied	\N	\N	\N	\N	38015	38015	38690
10809	11101	106	applied	\N	\N	\N	\N	38025	38025	38691
10809	11102	107	applied	\N	\N	\N	\N	38027	38027	38692
10809	11103	108	applied	\N	\N	\N	\N	38029	38029	38693
10809	11104	109	applied	\N	\N	\N	\N	38033	38033	38694
10809	11105	110	applied	\N	\N	\N	\N	38035	38035	38695
10809	11112	111	applied	\N	\N	\N	\N	38057	38057	38696
10809	11114	112	applied	\N	\N	\N	\N	38062	38062	38697
10809	11117	113	applied	\N	\N	\N	\N	38068	38068	38698
10809	11122	114	applied	\N	\N	\N	\N	38080	38080	38699
10809	11123	115	applied	\N	\N	\N	\N	38082	38082	38700
10809	11124	116	applied	\N	\N	\N	\N	38084	38084	38701
10809	11125	117	applied	\N	\N	\N	\N	38086	38086	38702
10809	11127	118	applied	\N	\N	\N	\N	38093	38093	38703
10809	11129	119	applied	\N	\N	\N	\N	38099	38099	38704
10809	11131	120	applied	\N	\N	\N	\N	38105	38105	38705
10809	11132	121	applied	\N	\N	\N	\N	38109	38109	38706
10809	11135	122	applied	\N	\N	\N	\N	38121	38121	38707
10809	11137	123	applied	\N	\N	\N	\N	38127	38127	38708
10809	11139	124	applied	\N	\N	\N	\N	38133	38133	38709
10809	11142	125	applied	\N	\N	\N	\N	38139	38139	38710
10814	11296	0	applied	\N	\N	\N	\N	38723	38723	38724
10814	11297	1	applied	\N	\N	\N	\N	38725	38725	38726
10816	11298	0	applied	\N	\N	\N	\N	38733	38733	38734
10816	11299	1	applied	\N	\N	\N	\N	38735	38735	38736
10816	11300	2	applied	\N	\N	\N	\N	38737	38737	38738
10816	11301	3	applied	\N	\N	\N	\N	38739	38739	38740
10816	11302	4	applied	\N	\N	\N	\N	38741	38741	38742
10816	11303	5	applied	\N	\N	\N	\N	38743	38743	38744
10816	11304	6	applied	\N	\N	\N	\N	38745	38745	38746
10816	11305	7	applied	\N	\N	\N	\N	38747	38747	38748
10816	11306	8	applied	\N	\N	\N	\N	38749	38749	38750
10816	11307	9	applied	\N	\N	\N	\N	38751	38751	38752
10823	11316	0	applied	\N	\N	1000000000	\N	38779	38779	38780
10823	11317	1	applied	\N	\N	1000000000	\N	38781	38781	38782
10823	11318	2	applied	\N	\N	\N	\N	38783	38783	38784
10826	11319	0	applied	\N	\N	\N	\N	38787	38787	38788
10826	11320	1	applied	\N	\N	1000000000	\N	38789	38789	38790
10826	11321	2	applied	\N	\N	\N	\N	38791	38791	38792
10828	11322	0	applied	\N	\N	\N	\N	38795	38795	38796
10828	11323	1	applied	\N	\N	\N	\N	38797	38797	38798
10828	11324	2	applied	\N	\N	\N	\N	38799	38799	38800
10828	11325	3	applied	\N	\N	\N	\N	38801	38801	38802
10831	11327	0	applied	\N	\N	\N	\N	38809	38809	38810
10831	11328	1	applied	\N	\N	\N	\N	38811	38811	38812
10833	11329	0	applied	\N	\N	\N	\N	38815	38815	38816
10833	11330	1	applied	\N	\N	\N	\N	38817	38817	38818
10833	11331	2	applied	\N	\N	\N	\N	38819	38819	38820
10833	11332	3	applied	\N	\N	1000000000	\N	38821	38821	38822
10833	11333	4	applied	\N	\N	\N	\N	38823	38823	38824
10833	11334	5	applied	\N	\N	1000000000	\N	38825	38825	38826
10836	11339	0	applied	\N	\N	\N	\N	38840	38840	38841
10836	11340	1	applied	\N	\N	\N	\N	38842	38842	38843
10836	11341	2	applied	\N	\N	\N	\N	38844	38844	38845
10836	11342	3	applied	\N	\N	\N	\N	38846	38846	38847
10836	11343	4	applied	\N	\N	\N	\N	38848	38848	38849
10836	11344	5	applied	\N	\N	\N	\N	38850	38850	38851
10836	11345	6	applied	\N	\N	\N	\N	38852	38852	38853
10836	11346	7	applied	\N	\N	\N	\N	38854	38854	38855
10836	11347	8	applied	\N	\N	\N	\N	38856	38856	38857
10836	11348	9	applied	\N	\N	\N	\N	38858	38858	38859
10841	11351	0	applied	\N	\N	1000000000	\N	38870	38870	38871
10841	11352	1	applied	\N	\N	\N	\N	38872	38872	38873
10841	11353	2	applied	\N	\N	\N	\N	38874	38874	38875
10841	11354	3	applied	\N	\N	\N	\N	38876	38876	38877
10841	11355	4	applied	\N	\N	\N	\N	38878	38878	38879
10841	11356	5	applied	\N	\N	\N	\N	38880	38880	38881
10841	11357	6	applied	\N	\N	\N	\N	38882	38882	38883
10844	11362	0	applied	\N	\N	\N	\N	38895	38895	38896
10844	11363	1	applied	\N	\N	\N	\N	38897	38897	38898
10844	11358	2	applied	\N	\N	\N	\N	38885	38885	38886
10844	11359	3	applied	\N	\N	\N	\N	38887	38887	38888
10844	11360	4	applied	\N	\N	\N	\N	38889	38889	38890
10844	11361	5	applied	\N	\N	\N	\N	38891	38891	38892
10851	11382	0	applied	\N	\N	\N	\N	38944	38944	38945
10851	11383	1	applied	\N	\N	\N	\N	38946	38946	38947
10855	11394	0	applied	\N	\N	\N	\N	39035	39035	39036
10855	11395	1	applied	\N	\N	\N	\N	39037	39037	39038
10858	11396	0	applied	\N	\N	\N	\N	39041	39041	39042
10858	11397	1	applied	\N	\N	\N	\N	39043	39043	39044
10862	11398	0	applied	\N	\N	\N	\N	39051	39051	39052
10862	11399	1	applied	\N	\N	\N	\N	39053	39053	39054
10862	11400	2	applied	\N	\N	\N	\N	39055	39055	39056
10862	11401	3	applied	\N	\N	\N	\N	39057	39057	39058
10866	11404	0	applied	\N	\N	\N	\N	39072	39072	39073
10866	11405	1	applied	\N	\N	\N	\N	39074	39074	39075
10866	11406	2	applied	\N	\N	\N	\N	39076	39076	39077
10869	11407	0	applied	\N	\N	\N	\N	39082	39082	39083
10869	11408	1	applied	\N	\N	\N	\N	39084	39084	39085
10869	11409	2	applied	\N	\N	\N	\N	39086	39086	39087
10869	11410	3	applied	\N	\N	\N	\N	39088	39088	39089
10869	11411	4	applied	\N	\N	\N	\N	39090	39090	39091
10837	11344	5	applied	\N	\N	\N	\N	38850	38850	38851
10837	11345	6	applied	\N	\N	\N	\N	38852	38852	38853
10837	11347	7	applied	\N	\N	\N	\N	38856	38856	38857
10837	11348	8	applied	\N	\N	\N	\N	38858	38858	38859
10846	11369	0	applied	\N	\N	\N	\N	38913	38913	38914
10846	11370	1	applied	\N	\N	\N	\N	38915	38915	38916
10849	11376	0	applied	\N	\N	\N	\N	38932	38932	38933
10849	11377	1	applied	\N	\N	\N	\N	38934	38934	38935
10849	11378	2	applied	\N	\N	\N	\N	38936	38936	38937
10849	11379	3	applied	\N	\N	\N	\N	38938	38938	38939
10849	11380	4	applied	\N	\N	\N	\N	38940	38940	38363
10849	11381	5	applied	\N	\N	\N	\N	38941	38941	38363
10854	11351	0	applied	\N	\N	1000000000	\N	38870	38870	38871
10854	11308	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	38755	38755	\N
10854	10996	2	applied	\N	\N	\N	\N	37686	37686	37687
10854	10997	3	applied	\N	\N	\N	\N	37688	37688	37689
10854	10998	4	applied	\N	\N	\N	\N	37690	37690	37691
10854	11003	5	applied	\N	\N	\N	\N	37703	37703	37704
10854	11332	6	applied	\N	\N	1000000000	\N	38975	38975	38822
10854	11339	7	applied	\N	\N	\N	\N	38976	38976	38841
10854	11340	8	applied	\N	\N	\N	\N	38977	38977	38843
10854	11341	9	applied	\N	\N	\N	\N	38978	38978	38845
10854	11342	10	applied	\N	\N	\N	\N	38979	38979	38847
10854	11343	11	applied	\N	\N	\N	\N	38980	38980	38849
10854	11350	12	applied	\N	\N	\N	\N	38981	38981	38867
10854	11354	13	applied	\N	\N	\N	\N	38982	38982	38877
10854	11358	14	applied	\N	\N	\N	\N	38983	38983	38886
10854	11004	15	applied	\N	\N	\N	\N	37709	37709	37710
10854	11008	16	applied	\N	\N	\N	\N	37719	37719	37720
10854	11359	17	applied	\N	\N	\N	\N	38984	38984	38888
10854	11360	18	applied	\N	\N	\N	\N	38985	38985	38890
10854	11361	19	applied	\N	\N	\N	\N	38986	38986	38892
10854	11364	20	applied	\N	\N	\N	\N	38987	38987	38903
10854	11365	21	applied	\N	\N	\N	\N	38988	38988	38905
10854	11371	22	applied	\N	\N	\N	\N	38989	38989	38920
10854	11372	23	applied	\N	\N	\N	\N	38990	38990	38922
10854	11375	24	applied	\N	\N	\N	\N	38991	38991	38928
10854	11286	25	applied	\N	\N	\N	\N	38577	38577	38992
10854	11287	26	applied	\N	\N	\N	\N	38579	38579	38993
10854	11288	27	applied	\N	\N	\N	\N	38582	38582	38994
10854	11290	28	applied	\N	\N	\N	\N	38588	38588	38995
10854	11294	29	applied	\N	\N	\N	\N	38715	38715	38996
10854	11297	30	applied	\N	\N	\N	\N	38725	38725	38997
10854	11298	31	applied	\N	\N	\N	\N	38733	38733	38998
10854	11299	32	applied	\N	\N	\N	\N	38735	38735	38999
10854	11303	33	applied	\N	\N	\N	\N	38743	38743	39000
10854	11310	34	applied	\N	\N	\N	\N	38758	38758	39001
10854	11311	35	applied	\N	\N	\N	\N	38763	38763	39002
10854	11314	36	applied	\N	\N	\N	\N	38774	38774	39003
10854	11315	37	applied	\N	\N	\N	\N	38776	38776	39004
10854	11319	38	applied	\N	\N	\N	\N	38787	38787	39005
10854	11322	39	applied	\N	\N	\N	\N	38795	38795	39006
10854	11325	40	applied	\N	\N	\N	\N	38801	38801	39007
10854	11326	41	applied	\N	\N	\N	\N	38805	38805	39008
10854	11328	42	applied	\N	\N	\N	\N	38811	38811	39009
10854	11329	43	applied	\N	\N	\N	\N	38815	38815	39010
10854	11330	44	applied	\N	\N	\N	\N	38817	38817	39011
10854	11337	45	applied	\N	\N	\N	\N	38833	38833	39012
10854	11338	46	applied	\N	\N	\N	\N	38835	38835	39013
10854	11010	47	applied	\N	\N	\N	\N	37725	37725	37726
10854	11011	48	applied	\N	\N	\N	\N	37730	37730	37731
10854	11013	49	applied	\N	\N	\N	\N	37736	37736	37737
10854	11016	50	applied	\N	\N	\N	\N	37747	37747	37748
10854	11018	51	applied	\N	\N	\N	\N	37753	37753	37754
10854	11019	52	applied	\N	\N	\N	\N	37755	37755	37756
10854	11020	53	applied	\N	\N	\N	\N	37757	37757	37758
10854	11025	54	applied	\N	\N	\N	\N	37770	37770	37771
10854	11028	55	applied	\N	\N	\N	\N	37780	37780	37781
10854	11030	56	applied	\N	\N	\N	\N	37786	37786	37787
10854	11033	57	applied	\N	\N	\N	\N	37815	37815	37816
10854	11037	58	applied	\N	\N	\N	\N	37825	37825	37826
10854	11038	59	applied	\N	\N	\N	\N	37827	37827	37828
10854	11040	60	applied	\N	\N	\N	\N	37835	37835	37836
10854	11042	61	applied	\N	\N	\N	\N	37845	37845	37846
10854	11043	62	applied	\N	\N	\N	\N	37847	37847	37848
10854	11347	63	applied	\N	\N	\N	\N	38856	38856	39014
10854	11348	64	applied	\N	\N	\N	\N	38858	38858	39015
10854	11349	65	applied	\N	\N	\N	\N	38864	38864	39016
10854	11353	66	applied	\N	\N	\N	\N	38874	38874	39017
10854	11355	67	applied	\N	\N	\N	\N	38878	38878	39018
10854	11363	68	applied	\N	\N	\N	\N	38897	38897	39019
10854	11367	69	applied	\N	\N	\N	\N	38908	38908	39020
10854	11369	70	applied	\N	\N	\N	\N	38913	38913	39021
10854	11373	71	applied	\N	\N	\N	\N	38923	38923	39022
10854	11376	72	applied	\N	\N	\N	\N	38932	38932	39023
10854	11377	73	applied	\N	\N	\N	\N	38934	38934	39024
10854	11383	74	applied	\N	\N	\N	\N	38946	38946	39025
10854	11384	75	applied	\N	\N	\N	\N	38952	38952	39026
10854	11385	76	applied	\N	\N	\N	\N	38954	38954	39027
10854	11388	77	applied	\N	\N	\N	\N	38962	38962	39028
10854	11389	78	applied	\N	\N	\N	\N	38964	38964	39029
10854	11391	79	applied	\N	\N	\N	\N	38968	38968	39030
10854	11292	80	applied	\N	\N	\N	\N	38628	38628	38593
10854	11304	81	applied	\N	\N	\N	\N	39031	39031	38746
10854	11048	82	applied	\N	\N	\N	\N	37863	37863	37864
10854	11049	83	applied	\N	\N	\N	\N	37865	37865	37866
10854	11050	84	applied	\N	\N	\N	\N	37869	37869	37870
10854	11051	85	applied	\N	\N	\N	\N	37871	37871	37872
10854	11056	86	applied	\N	\N	\N	\N	37889	37889	37890
10854	11058	87	applied	\N	\N	\N	\N	37895	37895	37896
10854	11059	88	applied	\N	\N	\N	\N	37903	37903	37904
10854	11062	89	applied	\N	\N	\N	\N	37909	37909	37910
10854	11063	90	applied	\N	\N	\N	\N	37911	37911	37912
10854	11067	91	applied	\N	\N	\N	\N	37924	37924	37925
10854	11068	92	applied	\N	\N	\N	\N	37926	37926	37927
10854	11069	93	applied	\N	\N	\N	\N	37928	37928	37929
10854	11071	94	applied	\N	\N	\N	\N	37937	37937	37938
10854	11072	95	applied	\N	\N	\N	\N	37940	37940	37941
10854	11074	96	applied	\N	\N	\N	\N	37946	37946	37947
10854	11077	97	applied	\N	\N	\N	\N	37958	37958	37959
10854	11079	98	applied	\N	\N	\N	\N	37962	37962	37963
10854	11080	99	applied	\N	\N	\N	\N	37966	37966	37967
10854	11082	100	applied	\N	\N	\N	\N	37972	37972	37973
10854	11084	101	applied	\N	\N	\N	\N	37976	37976	37977
10854	11086	102	applied	\N	\N	\N	\N	37981	37981	37982
10854	11090	103	applied	\N	\N	\N	\N	37992	37992	37993
10854	11091	104	applied	\N	\N	\N	\N	37995	37995	37996
10854	11095	105	applied	\N	\N	\N	\N	38005	38005	38006
10854	11098	106	applied	\N	\N	\N	\N	38017	38017	38018
10854	11099	107	applied	\N	\N	\N	\N	38019	38019	38020
10854	11106	108	applied	\N	\N	\N	\N	38037	38037	38038
10854	11107	109	applied	\N	\N	\N	\N	38039	38039	38040
10854	11108	110	applied	\N	\N	\N	\N	38041	38041	38042
10854	11109	111	applied	\N	\N	\N	\N	38043	38043	38044
10854	11110	113	applied	\N	\N	\N	\N	38045	38045	38046
10854	11113	114	applied	\N	\N	\N	\N	38059	38059	38060
10854	11115	115	applied	\N	\N	\N	\N	38064	38064	38065
10857	11396	0	applied	\N	\N	\N	\N	39041	39041	39042
10857	11397	1	applied	\N	\N	\N	\N	39043	39043	39044
10865	11402	0	applied	\N	\N	\N	\N	39064	39064	39065
10865	11403	1	applied	\N	\N	\N	\N	39066	39066	39067
10868	11407	0	applied	\N	\N	\N	\N	39082	39082	39083
10868	11408	1	applied	\N	\N	\N	\N	39084	39084	39085
10868	11409	2	applied	\N	\N	\N	\N	39086	39086	39087
10868	11410	3	applied	\N	\N	\N	\N	39088	39088	39089
10868	11411	4	applied	\N	\N	\N	\N	39090	39090	39091
10870	11396	22	applied	\N	\N	\N	\N	39041	39041	39042
10870	11399	23	applied	\N	\N	\N	\N	39053	39053	39054
10870	11400	24	applied	\N	\N	\N	\N	39055	39055	39056
10870	11402	25	applied	\N	\N	\N	\N	39064	39064	39065
10870	11405	26	applied	\N	\N	\N	\N	39074	39074	39075
10870	11408	27	applied	\N	\N	\N	\N	39084	39084	39085
10870	11409	28	applied	\N	\N	\N	\N	39086	39086	39087
10870	11392	29	applied	\N	\N	\N	\N	38970	38970	38971
10870	11393	30	applied	\N	\N	\N	\N	38972	38972	38973
10870	11394	31	applied	\N	\N	\N	\N	39035	39035	39036
10870	11397	32	applied	\N	\N	\N	\N	39043	39043	39044
10870	11398	33	applied	\N	\N	\N	\N	39051	39051	39052
10870	11401	34	applied	\N	\N	\N	\N	39057	39057	39058
10870	11403	35	applied	\N	\N	\N	\N	39066	39066	39067
10870	11406	36	applied	\N	\N	\N	\N	39076	39076	39077
10870	11410	37	applied	\N	\N	\N	\N	39088	39088	39089
10870	11411	38	applied	\N	\N	\N	\N	39090	39090	39091
10870	11380	39	applied	\N	\N	\N	\N	38940	38940	38363
10870	11381	40	applied	\N	\N	\N	\N	38941	38941	38363
10872	11412	0	applied	\N	\N	\N	\N	39096	39096	39097
10872	11413	1	applied	\N	\N	\N	\N	39098	39098	39099
10873	11412	0	applied	\N	\N	\N	\N	39096	39096	39097
10873	11413	1	applied	\N	\N	\N	\N	39098	39098	39099
10874	11412	0	applied	\N	\N	\N	\N	39096	39096	39097
10874	11413	1	applied	\N	\N	\N	\N	39098	39098	39099
10875	11414	0	applied	\N	\N	\N	\N	39104	39104	39105
10875	11415	1	applied	\N	\N	1000000000	\N	39106	39106	39107
10875	11416	2	applied	\N	\N	\N	\N	39108	39108	39109
10875	11417	3	applied	\N	\N	\N	\N	39110	39110	39111
10875	11418	4	applied	\N	\N	\N	\N	39112	39112	39113
10876	11414	0	applied	\N	\N	\N	\N	39104	39104	39105
10876	11415	1	applied	\N	\N	1000000000	\N	39106	39106	39107
10876	11416	2	applied	\N	\N	\N	\N	39108	39108	39109
10876	11417	3	applied	\N	\N	\N	\N	39110	39110	39111
10876	11418	4	applied	\N	\N	\N	\N	39112	39112	39113
10877	11414	0	applied	\N	\N	\N	\N	39104	39104	39105
10877	11415	1	applied	\N	\N	1000000000	\N	39106	39106	39107
10877	11416	2	applied	\N	\N	\N	\N	39108	39108	39109
10877	11417	3	applied	\N	\N	\N	\N	39110	39110	39111
10877	11418	4	applied	\N	\N	\N	\N	39112	39112	39113
10878	11419	0	applied	\N	\N	\N	\N	39118	39118	39119
10878	11420	1	applied	\N	\N	\N	\N	39120	39120	39121
10879	11415	0	applied	\N	\N	1000000000	\N	39106	39106	39107
10879	11421	1	applied	\N	\N	\N	\N	39124	39124	39125
10879	11404	2	applied	\N	\N	\N	\N	39072	39072	39073
10879	11407	3	applied	\N	\N	\N	\N	39082	39082	39083
10879	11422	4	applied	\N	\N	\N	\N	39126	39126	39127
10879	11423	5	applied	\N	\N	\N	\N	39128	39128	39129
10880	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10880	11424	1	applied	\N	\N	\N	\N	39132	39132	39133
10880	11422	2	applied	\N	\N	\N	\N	39126	39126	39127
10880	11423	3	applied	\N	\N	\N	\N	39128	39128	39129
10880	11425	4	applied	\N	\N	\N	\N	39134	39134	39135
10881	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10881	11422	1	applied	\N	\N	\N	\N	39126	39126	39127
10881	11423	2	applied	\N	\N	\N	\N	39128	39128	39129
10881	11425	3	applied	\N	\N	\N	\N	39134	39134	39135
10882	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10882	11424	1	applied	\N	\N	\N	\N	39132	39132	39133
10882	11422	2	applied	\N	\N	\N	\N	39126	39126	39127
10882	11423	3	applied	\N	\N	\N	\N	39128	39128	39129
10882	11425	4	applied	\N	\N	\N	\N	39134	39134	39135
10883	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10883	11424	1	applied	\N	\N	\N	\N	39132	39132	39133
10883	11422	2	applied	\N	\N	\N	\N	39126	39126	39127
10883	11423	3	applied	\N	\N	\N	\N	39128	39128	39129
10883	11425	4	applied	\N	\N	\N	\N	39134	39134	39135
10884	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10884	11424	1	applied	\N	\N	\N	\N	39132	39132	39133
10884	11422	2	applied	\N	\N	\N	\N	39126	39126	39127
10884	11423	3	applied	\N	\N	\N	\N	39128	39128	39129
10884	11425	4	applied	\N	\N	\N	\N	39134	39134	39135
10885	11421	0	applied	\N	\N	\N	\N	39124	39124	39125
10885	11424	1	applied	\N	\N	\N	\N	39132	39132	39133
10885	11422	2	applied	\N	\N	\N	\N	39126	39126	39127
10885	11423	3	applied	\N	\N	\N	\N	39128	39128	39129
10885	11425	4	applied	\N	\N	\N	\N	39134	39134	39135
10886	11426	0	applied	\N	\N	\N	\N	39139	39139	39140
10886	11427	1	applied	\N	\N	\N	\N	39141	39141	39142
10886	11428	2	applied	\N	\N	\N	\N	39143	39143	39144
10886	11429	3	applied	\N	\N	\N	\N	39145	39145	39146
10887	11426	0	applied	\N	\N	\N	\N	39139	39139	39140
10887	11427	1	applied	\N	\N	\N	\N	39141	39141	39142
10887	11428	2	applied	\N	\N	\N	\N	39143	39143	39144
10887	11429	3	applied	\N	\N	\N	\N	39145	39145	39146
10888	11426	0	applied	\N	\N	\N	\N	39139	39139	39140
10888	11427	1	applied	\N	\N	\N	\N	39141	39141	39142
10888	11428	2	applied	\N	\N	\N	\N	39143	39143	39144
10888	11429	3	applied	\N	\N	\N	\N	39145	39145	39146
10889	11430	0	applied	\N	\N	\N	\N	39148	39148	39149
10889	11431	1	applied	\N	\N	\N	\N	39150	39150	39151
10890	11432	0	applied	\N	\N	\N	\N	39153	39153	39154
10890	11430	1	applied	\N	\N	\N	\N	39148	39148	39149
10890	11431	2	applied	\N	\N	\N	\N	39150	39150	39151
10891	11433	0	applied	\N	\N	\N	\N	39156	39156	39157
10891	11434	1	applied	\N	\N	\N	\N	39158	39158	36696
10891	11435	2	applied	\N	\N	\N	\N	39159	39159	39160
10891	11436	3	applied	\N	\N	\N	\N	39161	39161	39162
10891	11437	4	applied	\N	\N	\N	\N	39163	39163	39164
10892	11433	0	applied	\N	\N	\N	\N	39156	39156	39157
10892	11434	1	applied	\N	\N	\N	\N	39158	39158	36696
10892	11435	2	applied	\N	\N	\N	\N	39159	39159	39160
10892	11436	3	applied	\N	\N	\N	\N	39161	39161	39162
10892	11437	4	applied	\N	\N	\N	\N	39163	39163	39164
10893	11438	0	applied	\N	\N	\N	\N	39167	39167	39168
10893	11439	1	applied	\N	\N	\N	\N	39169	39169	39170
10894	11438	0	applied	\N	\N	\N	\N	39167	39167	39168
10894	11439	1	applied	\N	\N	\N	\N	39169	39169	39170
10895	11415	0	applied	\N	\N	1000000000	\N	39106	39106	39107
10895	11421	1	applied	\N	\N	\N	\N	39124	39124	39125
10895	11404	2	applied	\N	\N	\N	\N	39072	39072	39073
10895	11407	3	applied	\N	\N	\N	\N	39082	39082	39083
10895	11422	4	applied	\N	\N	\N	\N	39126	39126	39127
10895	11423	5	applied	\N	\N	\N	\N	39128	39128	39129
10895	11426	6	applied	\N	\N	\N	\N	39139	39139	39140
10895	11432	7	applied	\N	\N	\N	\N	39153	39153	39154
10895	11394	8	applied	\N	\N	\N	\N	39035	39035	39036
10895	11397	9	applied	\N	\N	\N	\N	39043	39043	39044
10895	11398	10	applied	\N	\N	\N	\N	39051	39051	39052
10895	11401	11	applied	\N	\N	\N	\N	39057	39057	39058
10895	11403	12	applied	\N	\N	\N	\N	39066	39066	39067
10895	11395	13	applied	\N	\N	\N	\N	39037	39037	39038
10895	11396	14	applied	\N	\N	\N	\N	39041	39041	39042
10895	11399	15	applied	\N	\N	\N	\N	39053	39053	39054
10895	11400	16	applied	\N	\N	\N	\N	39055	39055	39056
10895	11402	17	applied	\N	\N	\N	\N	39064	39064	39065
10895	11405	18	applied	\N	\N	\N	\N	39074	39074	39075
10895	11408	19	applied	\N	\N	\N	\N	39084	39084	39085
10895	11409	20	applied	\N	\N	\N	\N	39086	39086	39087
10895	11413	21	applied	\N	\N	\N	\N	39098	39098	39099
10895	11414	22	applied	\N	\N	\N	\N	39104	39104	39105
10895	11418	23	applied	\N	\N	\N	\N	39112	39112	39113
10895	11419	24	applied	\N	\N	\N	\N	39118	39118	39119
10895	11424	25	applied	\N	\N	\N	\N	39132	39132	39133
10895	11427	26	applied	\N	\N	\N	\N	39141	39141	39142
10895	11431	27	applied	\N	\N	\N	\N	39150	39150	39151
10895	11436	28	applied	\N	\N	\N	\N	39161	39161	39162
10895	11437	29	applied	\N	\N	\N	\N	39163	39163	39164
10895	11438	30	applied	\N	\N	\N	\N	39167	39167	39168
10895	11429	31	applied	\N	\N	\N	\N	39145	39145	39146
10895	11434	32	applied	\N	\N	\N	\N	39158	39158	36696
10895	11406	33	applied	\N	\N	\N	\N	39076	39076	39077
10895	11410	34	applied	\N	\N	\N	\N	39088	39088	39089
10895	11411	35	applied	\N	\N	\N	\N	39090	39090	39091
10895	11412	36	applied	\N	\N	\N	\N	39096	39096	39097
10895	11416	37	applied	\N	\N	\N	\N	39108	39108	39109
10895	11417	38	applied	\N	\N	\N	\N	39110	39110	39111
10895	11420	39	applied	\N	\N	\N	\N	39120	39120	39121
10895	11425	40	applied	\N	\N	\N	\N	39134	39134	39135
10895	11428	41	applied	\N	\N	\N	\N	39143	39143	39144
10895	11430	42	applied	\N	\N	\N	\N	39148	39148	39149
10895	11433	43	applied	\N	\N	\N	\N	39156	39156	39157
10895	11435	44	applied	\N	\N	\N	\N	39159	39159	39160
10895	11439	45	applied	\N	\N	\N	\N	39169	39169	39170
10898	11440	0	applied	\N	\N	\N	\N	39174	39174	39175
10898	11441	1	applied	\N	\N	\N	\N	39176	39176	39177
10898	11442	2	applied	\N	\N	\N	\N	39178	39178	39179
10898	11443	3	applied	\N	\N	\N	\N	39180	39180	39181
10898	11444	4	applied	\N	\N	\N	\N	39182	39182	39183
10898	11445	5	applied	\N	\N	\N	\N	39184	39184	39185
10898	11446	6	applied	\N	\N	\N	\N	39186	39186	39187
10900	11448	0	applied	\N	\N	\N	\N	39196	39196	39197
10900	11449	1	applied	\N	\N	\N	\N	39198	39198	39199
10901	11450	0	applied	\N	\N	\N	\N	39201	39201	39202
10901	11451	1	applied	\N	\N	\N	\N	39203	39203	39204
10901	11452	2	applied	\N	\N	\N	\N	39205	39205	39206
10901	11453	3	applied	\N	\N	\N	\N	39207	39207	39208
10901	11454	4	applied	\N	\N	\N	\N	39209	39209	39210
10908	11484	0	applied	\N	\N	\N	\N	39280	39280	39244
10913	11468	0	applied	\N	\N	\N	\N	39242	39242	39243
10913	11479	1	applied	\N	\N	\N	\N	39268	39268	39269
10913	11480	3	applied	\N	\N	\N	\N	39270	39270	39271
10913	11481	4	applied	\N	\N	\N	\N	39272	39272	39273
10913	11469	5	applied	\N	\N	\N	\N	39244	39244	39245
10913	11457	6	applied	\N	\N	\N	\N	39219	39219	39220
10913	11458	7	applied	\N	\N	\N	\N	39221	39221	39222
10913	11459	8	applied	\N	\N	\N	\N	39223	39223	39224
10913	11460	9	applied	\N	\N	\N	\N	39225	39225	39226
10913	11440	10	applied	\N	\N	\N	\N	39174	39174	39175
10913	11441	11	applied	\N	\N	\N	\N	39176	39176	39177
10913	11442	12	applied	\N	\N	\N	\N	39178	39178	39179
10913	11447	13	applied	\N	\N	\N	\N	39193	39193	39194
10913	11449	14	applied	\N	\N	\N	\N	39198	39198	39199
10913	11443	15	applied	\N	\N	\N	\N	39180	39180	39181
10913	11450	16	applied	\N	\N	\N	\N	39201	39201	39202
10913	11453	17	applied	\N	\N	\N	\N	39207	39207	39208
10913	11466	18	applied	\N	\N	\N	\N	39237	39237	39238
10913	11470	19	applied	\N	\N	\N	\N	39246	39246	39247
10913	11444	20	applied	\N	\N	\N	\N	39182	39182	39183
10913	11445	21	applied	\N	\N	\N	\N	39184	39184	39185
10913	11446	22	applied	\N	\N	\N	\N	39186	39186	39187
10913	11448	23	applied	\N	\N	\N	\N	39196	39196	39197
10913	11451	24	applied	\N	\N	\N	\N	39203	39203	39204
10913	11452	25	applied	\N	\N	\N	\N	39205	39205	39206
10913	11454	26	applied	\N	\N	\N	\N	39209	39209	39210
10913	11455	27	applied	\N	\N	\N	\N	39213	39213	39214
10913	11461	28	applied	\N	\N	\N	\N	39227	39227	39228
10913	11463	29	applied	\N	\N	\N	\N	39231	39231	39232
10913	11465	30	applied	\N	\N	\N	\N	39235	39235	39236
10913	11471	31	applied	\N	\N	\N	\N	39248	39248	39249
10913	11474	32	applied	\N	\N	\N	\N	39254	39254	39255
10913	11475	33	applied	\N	\N	\N	\N	39258	39258	39259
10913	11476	34	applied	\N	\N	\N	\N	39260	39260	39261
10913	11483	35	applied	\N	\N	\N	\N	39276	39276	39277
10913	11486	36	applied	\N	\N	\N	\N	39285	39285	39286
10913	11488	37	applied	\N	\N	\N	\N	39290	39290	39291
10913	11489	38	applied	\N	\N	\N	\N	39294	39294	39295
10913	11491	39	applied	\N	\N	\N	\N	39303	39303	39304
10913	11456	40	applied	\N	\N	\N	\N	39215	39215	39216
10913	11462	41	applied	\N	\N	\N	\N	39229	39229	39230
10913	11464	42	applied	\N	\N	\N	\N	39233	39233	39234
10913	11467	43	applied	\N	\N	\N	\N	39239	39239	39240
10913	11472	44	applied	\N	\N	\N	\N	39250	39250	39251
10913	11473	45	applied	\N	\N	\N	\N	39252	39252	39253
10913	11477	46	applied	\N	\N	\N	\N	39262	39262	39263
10913	11478	47	applied	\N	\N	\N	\N	39264	39264	39265
10913	11482	48	applied	\N	\N	\N	\N	39274	39274	39275
10913	11485	49	applied	\N	\N	\N	\N	39283	39283	39284
10913	11487	50	applied	\N	\N	\N	\N	39288	39288	39289
10913	11490	51	applied	\N	\N	\N	\N	39296	39296	39297
10913	11492	52	applied	\N	\N	\N	\N	39305	39305	39306
10918	11499	0	applied	\N	\N	\N	\N	39325	39325	39326
10918	11500	1	applied	\N	\N	\N	\N	39329	39329	39330
10921	11508	0	applied	\N	\N	\N	\N	39349	39349	39350
10921	11509	1	applied	\N	\N	\N	\N	39351	39351	39352
10926	11513	0	applied	\N	\N	\N	\N	39363	39363	39364
10927	11514	0	applied	\N	\N	\N	\N	39373	39373	39374
10927	11510	1	applied	\N	\N	\N	\N	39356	39356	39357
10927	11512	2	applied	\N	\N	\N	\N	39361	39361	39362
10927	11515	3	applied	\N	\N	\N	\N	39375	39375	39376
10927	11516	4	applied	\N	\N	\N	\N	39377	39377	39378
10929	11514	0	applied	\N	\N	\N	\N	39373	39373	39374
10929	11510	1	applied	\N	\N	\N	\N	39356	39356	39357
10929	11511	2	applied	\N	\N	\N	\N	39358	39358	39359
10929	11512	3	applied	\N	\N	\N	\N	39361	39361	39362
10929	11517	4	applied	\N	\N	\N	\N	39380	39380	39381
10929	11518	5	applied	\N	\N	\N	\N	39382	39382	39383
10929	11515	6	applied	\N	\N	\N	\N	39375	39375	39376
10929	11516	7	applied	\N	\N	\N	\N	39377	39377	39378
10896	11440	0	applied	\N	\N	\N	\N	39174	39174	39175
10896	11441	1	applied	\N	\N	\N	\N	39176	39176	39177
10896	11442	2	applied	\N	\N	\N	\N	39178	39178	39179
10896	11443	3	applied	\N	\N	\N	\N	39180	39180	39181
10896	11444	4	applied	\N	\N	\N	\N	39182	39182	39183
10896	11445	5	applied	\N	\N	\N	\N	39184	39184	39185
10896	11446	6	applied	\N	\N	\N	\N	39186	39186	39187
10904	11468	0	applied	\N	\N	\N	\N	39242	39242	39243
10904	11469	1	applied	\N	\N	\N	\N	39244	39244	39245
10904	11470	2	applied	\N	\N	\N	\N	39246	39246	39247
10904	11471	3	applied	\N	\N	\N	\N	39248	39248	39249
10904	11472	4	applied	\N	\N	\N	\N	39250	39250	39251
10904	11473	5	applied	\N	\N	\N	\N	39252	39252	39253
10904	11474	6	applied	\N	\N	\N	\N	39254	39254	39255
10905	11475	0	applied	\N	\N	\N	\N	39258	39258	39259
10905	11476	1	applied	\N	\N	\N	\N	39260	39260	39261
10905	11477	2	applied	\N	\N	\N	\N	39262	39262	39263
10905	11478	3	applied	\N	\N	\N	\N	39264	39264	39265
10907	11479	0	applied	\N	\N	\N	\N	39268	39268	39269
10907	11480	1	applied	\N	\N	\N	\N	39270	39270	39271
10907	11481	2	applied	\N	\N	\N	\N	39272	39272	39273
10907	11482	3	applied	\N	\N	\N	\N	39274	39274	39275
10907	11483	4	applied	\N	\N	\N	\N	39276	39276	39277
10912	11489	0	applied	\N	\N	\N	\N	39294	39294	39295
10912	11490	1	applied	\N	\N	\N	\N	39296	39296	39297
10914	11493	0	applied	\N	\N	\N	\N	39309	39309	39310
10914	11494	1	applied	\N	\N	\N	\N	39311	39311	39312
10914	11495	2	applied	\N	\N	\N	\N	39313	39313	39314
10914	11492	3	applied	\N	\N	\N	\N	39305	39305	39306
10914	11496	4	applied	\N	\N	\N	\N	39315	39315	39316
10914	11497	5	applied	\N	\N	\N	\N	39317	39317	39318
10914	11491	6	applied	\N	\N	\N	\N	39303	39303	39304
10914	11498	7	applied	\N	\N	\N	\N	39319	39319	39320
10919	11501	0	applied	\N	\N	\N	\N	39333	39333	39334
10919	11502	1	applied	\N	\N	\N	\N	39335	39335	39336
10919	11503	2	applied	\N	\N	\N	\N	39337	39337	39338
10919	11504	3	applied	\N	\N	\N	\N	39339	39339	39340
10919	11500	4	applied	\N	\N	\N	\N	39329	39329	39330
10919	11505	5	applied	\N	\N	\N	\N	39341	39341	39342
10919	11506	6	applied	\N	\N	\N	\N	39343	39343	39344
10919	11507	7	applied	\N	\N	\N	\N	39345	39345	39346
10922	11508	0	applied	\N	\N	\N	\N	39349	39349	39350
10922	11509	1	applied	\N	\N	\N	\N	39351	39351	39352
10925	11511	0	applied	\N	\N	\N	\N	39358	39358	39359
10925	11513	1	applied	\N	\N	\N	\N	39363	39363	39364
10928	11514	0	applied	\N	\N	\N	\N	39373	39373	39374
10928	11510	1	applied	\N	\N	\N	\N	39356	39356	39357
10928	11511	2	applied	\N	\N	\N	\N	39358	39358	39359
10928	11512	3	applied	\N	\N	\N	\N	39361	39361	39362
10928	11517	4	applied	\N	\N	\N	\N	39380	39380	39381
10928	11518	5	applied	\N	\N	\N	\N	39382	39382	39383
10928	11515	6	applied	\N	\N	\N	\N	39375	39375	39376
10928	11516	7	applied	\N	\N	\N	\N	39377	39377	39378
10931	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10931	11518	1	applied	\N	\N	\N	\N	39382	39382	39383
10934	11519	0	applied	\N	\N	\N	\N	39396	39396	39397
10934	11520	1	applied	\N	\N	\N	\N	39398	39398	39399
10938	11523	0	applied	\N	\N	\N	\N	39409	39409	39410
10938	11524	1	applied	\N	\N	\N	\N	39411	39411	39412
10945	11527	0	applied	\N	\N	\N	\N	39428	39428	39429
10945	11528	1	applied	\N	\N	\N	\N	39430	39430	39431
10950	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10950	11520	1	applied	\N	\N	\N	\N	39398	39398	39399
10950	11522	2	applied	\N	\N	\N	\N	39405	39405	39406
10950	11523	3	applied	\N	\N	\N	\N	39409	39409	39410
10950	11525	4	applied	\N	\N	\N	\N	39418	39418	39419
10950	11527	5	applied	\N	\N	\N	\N	39428	39428	39429
10950	11518	6	applied	\N	\N	\N	\N	39382	39382	39383
10950	11519	7	applied	\N	\N	\N	\N	39396	39396	39397
10950	11521	8	applied	\N	\N	\N	\N	39403	39403	39404
10950	11530	9	applied	\N	\N	\N	\N	39438	39438	39439
10950	11531	10	applied	\N	\N	\N	\N	39440	39440	39441
10950	11532	11	applied	\N	\N	\N	\N	39442	39442	39443
10950	11524	12	applied	\N	\N	\N	\N	39411	39411	39412
10950	11526	13	applied	\N	\N	\N	\N	39420	39420	39421
10950	11528	14	applied	\N	\N	\N	\N	39430	39430	39431
10950	11529	15	applied	\N	\N	\N	\N	39434	39434	39435
10950	11533	16	applied	\N	\N	\N	\N	39444	39444	39445
10950	11534	17	applied	\N	\N	\N	\N	39446	39446	39447
10950	11535	18	applied	\N	\N	\N	\N	39448	39448	39449
10954	11537	0	applied	\N	\N	\N	\N	39460	39460	39461
10954	11538	1	applied	\N	\N	\N	\N	39462	39462	39463
10954	11539	2	applied	\N	\N	\N	\N	39464	39464	39465
10954	11540	3	applied	\N	\N	\N	\N	39466	39466	39467
10954	11541	4	applied	\N	\N	\N	\N	39468	39468	39469
10959	11547	0	applied	\N	\N	\N	\N	39489	39489	39490
10959	11548	1	applied	\N	\N	\N	\N	39491	39491	39492
10959	11549	2	applied	\N	\N	\N	\N	39493	39493	39494
10964	11557	0	applied	\N	\N	\N	\N	39515	39515	39516
10964	11558	1	applied	\N	\N	\N	\N	39517	39517	39518
10966	11559	0	applied	\N	\N	\N	\N	39525	39525	39526
10966	11560	1	applied	\N	\N	\N	\N	39527	39527	39528
10970	11559	0	applied	\N	\N	\N	\N	39525	39525	39526
10970	11560	1	applied	\N	\N	\N	\N	39527	39527	39528
10975	11566	0	applied	\N	\N	\N	\N	39547	39547	39548
10975	11567	1	applied	\N	\N	\N	\N	39549	39549	39550
10980	11573	0	applied	\N	\N	\N	\N	39566	39566	39567
10980	11574	1	applied	\N	\N	\N	\N	39568	39568	39569
10980	11575	2	applied	\N	\N	\N	\N	39570	39570	39571
10983	11576	0	applied	\N	\N	\N	\N	39578	39578	39579
10983	11577	1	applied	\N	\N	\N	\N	39580	39580	39581
10985	11580	0	applied	\N	\N	\N	\N	39594	39594	39595
10985	11581	1	applied	\N	\N	\N	\N	39596	39596	39597
10985	11582	2	applied	\N	\N	\N	\N	39598	39598	39599
10985	11583	3	applied	\N	\N	\N	\N	39600	39600	39601
10985	11584	4	applied	\N	\N	\N	\N	39602	39602	39603
10985	11585	5	applied	\N	\N	\N	\N	39604	39604	39605
10992	11590	0	applied	\N	\N	\N	\N	39620	39620	39621
10992	11591	1	applied	\N	\N	\N	\N	39622	39622	39623
10992	11592	2	applied	\N	\N	\N	\N	39624	39624	39625
10992	11593	3	applied	\N	\N	\N	\N	39626	39626	39627
10999	11602	0	applied	\N	\N	\N	\N	39659	39659	39660
11004	11602	0	applied	\N	\N	\N	\N	39659	39659	39660
11008	11603	0	applied	\N	\N	\N	\N	39668	39668	39669
11008	11605	1	applied	\N	\N	\N	\N	39673	39673	39674
11008	11604	2	applied	\N	\N	\N	\N	39670	39670	39671
11008	11606	3	applied	\N	\N	\N	\N	39675	39675	39676
11010	11607	0	applied	\N	\N	\N	\N	39679	39679	39679
11010	11608	1	applied	\N	\N	\N	\N	39680	39680	39681
11010	11609	2	applied	\N	\N	\N	\N	39682	39682	39683
10897	11440	0	applied	\N	\N	\N	\N	39174	39174	39175
10897	11441	1	applied	\N	\N	\N	\N	39176	39176	39177
10897	11442	2	applied	\N	\N	\N	\N	39178	39178	39179
10897	11443	3	applied	\N	\N	\N	\N	39180	39180	39181
10897	11444	4	applied	\N	\N	\N	\N	39182	39182	39183
10897	11445	5	applied	\N	\N	\N	\N	39184	39184	39185
10897	11446	6	applied	\N	\N	\N	\N	39186	39186	39187
10903	11457	0	applied	\N	\N	\N	\N	39219	39219	39220
10903	11458	1	applied	\N	\N	\N	\N	39221	39221	39222
10903	11459	2	applied	\N	\N	\N	\N	39223	39223	39224
10903	11460	3	applied	\N	\N	\N	\N	39225	39225	39226
10903	11461	4	applied	\N	\N	\N	\N	39227	39227	39228
10903	11462	5	applied	\N	\N	\N	\N	39229	39229	39230
10903	11463	6	applied	\N	\N	\N	\N	39231	39231	39232
10903	11464	7	applied	\N	\N	\N	\N	39233	39233	39234
10903	11465	8	applied	\N	\N	\N	\N	39235	39235	39236
10903	11466	9	applied	\N	\N	\N	\N	39237	39237	39238
10903	11467	10	applied	\N	\N	\N	\N	39239	39239	39240
10909	11484	0	applied	\N	\N	\N	\N	39280	39280	39244
10909	11485	1	applied	\N	\N	\N	\N	39283	39283	39284
10909	11486	2	applied	\N	\N	\N	\N	39285	39285	39286
10911	11489	0	applied	\N	\N	\N	\N	39294	39294	39295
10911	11490	1	applied	\N	\N	\N	\N	39296	39296	39297
10916	11499	0	applied	\N	\N	\N	\N	39325	39325	39326
10923	11510	0	applied	\N	\N	\N	\N	39356	39356	39357
10923	11511	1	applied	\N	\N	\N	\N	39358	39358	39359
10923	11512	3	applied	\N	\N	\N	\N	39361	39361	39362
10923	11513	4	applied	\N	\N	\N	\N	39363	39363	39364
10924	11510	0	applied	\N	\N	\N	\N	39356	39356	39357
10924	11511	1	applied	\N	\N	\N	\N	39358	39358	39359
10924	11512	3	applied	\N	\N	\N	\N	39361	39361	39362
10924	11513	4	applied	\N	\N	\N	\N	39363	39363	39364
10930	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10930	11518	1	applied	\N	\N	\N	\N	39382	39382	39383
10933	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10933	11518	1	applied	\N	\N	\N	\N	39382	39382	39383
10936	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10936	11520	1	applied	\N	\N	\N	\N	39398	39398	39399
10936	11518	2	applied	\N	\N	\N	\N	39382	39382	39383
10936	11519	3	applied	\N	\N	\N	\N	39396	39396	39397
10937	11521	0	applied	\N	\N	\N	\N	39403	39403	39404
10937	11522	1	applied	\N	\N	\N	\N	39405	39405	39406
10940	11523	0	applied	\N	\N	\N	\N	39409	39409	39410
10940	11524	1	applied	\N	\N	\N	\N	39411	39411	39412
10942	11525	0	applied	\N	\N	\N	\N	39418	39418	39419
10942	11526	1	applied	\N	\N	\N	\N	39420	39420	39421
10944	11527	0	applied	\N	\N	\N	\N	39428	39428	39429
10944	11528	1	applied	\N	\N	\N	\N	39430	39430	39431
10956	11542	0	applied	\N	\N	\N	\N	39474	39474	39475
10958	11537	0	applied	\N	\N	\N	\N	39460	39460	39461
10958	11496	1	applied	\N	\N	\N	\N	39315	39315	39316
10958	11502	2	applied	\N	\N	\N	\N	39335	39335	39336
10958	11511	3	applied	\N	\N	\N	\N	39358	39358	39359
10958	11512	4	applied	\N	\N	\N	\N	39361	39361	39362
10958	11499	5	applied	\N	\N	\N	\N	39325	39325	39326
10958	11501	6	applied	\N	\N	\N	\N	39333	39333	39334
10958	11503	7	applied	\N	\N	\N	\N	39337	39337	39338
10958	11504	8	applied	\N	\N	\N	\N	39339	39339	39340
10958	11509	9	applied	\N	\N	\N	\N	39351	39351	39352
10958	11513	10	applied	\N	\N	\N	\N	39363	39363	39364
10958	11514	11	applied	\N	\N	\N	\N	39373	39373	39374
10958	11517	12	applied	\N	\N	\N	\N	39380	39380	39381
10958	11520	13	applied	\N	\N	\N	\N	39398	39398	39399
10958	11522	14	applied	\N	\N	\N	\N	39405	39405	39406
10958	11523	15	applied	\N	\N	\N	\N	39409	39409	39410
10958	11525	16	applied	\N	\N	\N	\N	39418	39418	39419
10958	11527	17	applied	\N	\N	\N	\N	39428	39428	39429
10958	11493	18	applied	\N	\N	\N	\N	39309	39309	39310
10958	11498	19	applied	\N	\N	\N	\N	39319	39319	39320
10958	11530	20	applied	\N	\N	\N	\N	39438	39438	39439
10958	11531	21	applied	\N	\N	\N	\N	39440	39440	39441
10958	11532	22	applied	\N	\N	\N	\N	39442	39442	39443
10958	11536	23	applied	\N	\N	\N	\N	39455	39455	39456
10958	11538	24	applied	\N	\N	\N	\N	39462	39462	39463
10958	11539	25	applied	\N	\N	\N	\N	39464	39464	39465
10958	11543	26	applied	\N	\N	\N	\N	39477	39477	39478
10958	11544	27	applied	\N	\N	\N	\N	39479	39479	39480
10958	11515	28	applied	\N	\N	\N	\N	39375	39375	39376
10958	11500	29	applied	\N	\N	\N	\N	39329	39329	39330
10958	11505	30	applied	\N	\N	\N	\N	39341	39341	39342
10958	11506	31	applied	\N	\N	\N	\N	39343	39343	39344
10958	11507	32	applied	\N	\N	\N	\N	39345	39345	39346
10958	11508	33	applied	\N	\N	\N	\N	39349	39349	39350
10958	11510	34	applied	\N	\N	\N	\N	39356	39356	39357
10958	11518	35	applied	\N	\N	\N	\N	39382	39382	39383
10958	11519	36	applied	\N	\N	\N	\N	39396	39396	39397
10958	11521	37	applied	\N	\N	\N	\N	39403	39403	39404
10958	11524	38	applied	\N	\N	\N	\N	39411	39411	39412
10958	11526	39	applied	\N	\N	\N	\N	39420	39420	39421
10958	11528	40	applied	\N	\N	\N	\N	39430	39430	39431
10958	11529	41	applied	\N	\N	\N	\N	39434	39434	39435
10958	11533	42	applied	\N	\N	\N	\N	39444	39444	39445
10958	11534	43	applied	\N	\N	\N	\N	39446	39446	39447
10958	11535	44	applied	\N	\N	\N	\N	39448	39448	39449
10958	11540	45	applied	\N	\N	\N	\N	39466	39466	39467
10958	11541	46	applied	\N	\N	\N	\N	39468	39468	39469
10958	11542	47	applied	\N	\N	\N	\N	39474	39474	39475
10958	11545	48	applied	\N	\N	\N	\N	39481	39481	39482
10958	11516	49	applied	\N	\N	\N	\N	39377	39377	39378
10958	11546	50	applied	\N	\N	\N	\N	39483	39483	39484
10963	11557	0	applied	\N	\N	\N	\N	39515	39515	39516
10963	11558	1	applied	\N	\N	\N	\N	39517	39517	39518
10969	11559	0	applied	\N	\N	\N	\N	39525	39525	39526
10969	11560	1	applied	\N	\N	\N	\N	39527	39527	39528
10972	11562	0	applied	\N	\N	\N	\N	39537	39537	39538
10972	11563	1	applied	\N	\N	\N	\N	39539	39539	39540
10972	11564	2	applied	\N	\N	\N	\N	39541	39541	39542
10977	11571	0	applied	\N	\N	\N	\N	39560	39560	39561
10977	11572	1	applied	\N	\N	\N	\N	39562	39562	39563
10982	11576	0	applied	\N	\N	\N	\N	39578	39578	39579
10982	11577	1	applied	\N	\N	\N	\N	39580	39580	39581
10984	11578	0	applied	\N	\N	\N	\N	39588	39588	39589
10984	11579	1	applied	\N	\N	\N	\N	39590	39590	39591
10989	11586	0	applied	\N	\N	\N	\N	39608	39608	39609
10989	11587	1	applied	\N	\N	\N	\N	39610	39610	39611
10989	11588	2	applied	\N	\N	\N	\N	39612	39612	39613
10989	11589	3	applied	\N	\N	\N	\N	39614	39614	39615
10994	11594	0	applied	\N	\N	\N	\N	39636	39636	39637
10994	11595	1	applied	\N	\N	\N	\N	39638	39638	39639
10994	11596	2	applied	\N	\N	\N	\N	39640	39640	39641
10899	11447	0	applied	\N	\N	\N	\N	39193	39193	39194
10902	11455	0	applied	\N	\N	\N	\N	39213	39213	39214
10902	11456	1	applied	\N	\N	\N	\N	39215	39215	39216
10906	11475	0	applied	\N	\N	\N	\N	39258	39258	39259
10906	11476	1	applied	\N	\N	\N	\N	39260	39260	39261
10906	11477	2	applied	\N	\N	\N	\N	39262	39262	39263
10906	11478	3	applied	\N	\N	\N	\N	39264	39264	39265
10910	11485	0	applied	\N	\N	\N	\N	39283	39283	39284
10910	11487	1	applied	\N	\N	\N	\N	39288	39288	39289
10910	11486	2	applied	\N	\N	\N	\N	39285	39285	39286
10910	11488	3	applied	\N	\N	\N	\N	39290	39290	39291
10915	11493	0	applied	\N	\N	\N	\N	39309	39309	39310
10915	11494	1	applied	\N	\N	\N	\N	39311	39311	39312
10915	11495	2	applied	\N	\N	\N	\N	39313	39313	39314
10915	11492	3	applied	\N	\N	\N	\N	39305	39305	39306
10915	11496	4	applied	\N	\N	\N	\N	39315	39315	39316
10915	11497	5	applied	\N	\N	\N	\N	39317	39317	39318
10915	11491	6	applied	\N	\N	\N	\N	39303	39303	39304
10915	11498	7	applied	\N	\N	\N	\N	39319	39319	39320
10917	11499	0	applied	\N	\N	\N	\N	39325	39325	39326
10917	11500	1	applied	\N	\N	\N	\N	39329	39329	39330
10920	11508	0	applied	\N	\N	\N	\N	39349	39349	39350
10935	11517	0	applied	\N	\N	\N	\N	39380	39380	39381
10935	11520	1	applied	\N	\N	\N	\N	39398	39398	39399
10935	11518	2	applied	\N	\N	\N	\N	39382	39382	39383
10935	11519	3	applied	\N	\N	\N	\N	39396	39396	39397
10939	11523	0	applied	\N	\N	\N	\N	39409	39409	39410
10939	11524	1	applied	\N	\N	\N	\N	39411	39411	39412
10943	11525	0	applied	\N	\N	\N	\N	39418	39418	39419
10943	11526	1	applied	\N	\N	\N	\N	39420	39420	39421
10947	11529	0	applied	\N	\N	\N	\N	39434	39434	39435
10948	11530	0	applied	\N	\N	\N	\N	39438	39438	39439
10948	11531	1	applied	\N	\N	\N	\N	39440	39440	39441
10948	11532	2	applied	\N	\N	\N	\N	39442	39442	39443
10948	11533	3	applied	\N	\N	\N	\N	39444	39444	39445
10948	11534	4	applied	\N	\N	\N	\N	39446	39446	39447
10948	11535	5	applied	\N	\N	\N	\N	39448	39448	39449
10951	11530	0	applied	\N	\N	\N	\N	39438	39438	39439
10951	11531	1	applied	\N	\N	\N	\N	39440	39440	39441
10951	11532	2	applied	\N	\N	\N	\N	39442	39442	39443
10951	11533	3	applied	\N	\N	\N	\N	39444	39444	39445
10951	11534	4	applied	\N	\N	\N	\N	39446	39446	39447
10951	11535	5	applied	\N	\N	\N	\N	39448	39448	39449
10952	11536	0	applied	\N	\N	\N	\N	39455	39455	39456
10955	11537	0	applied	\N	\N	\N	\N	39460	39460	39461
10955	11538	1	applied	\N	\N	\N	\N	39462	39462	39463
10955	11539	2	applied	\N	\N	\N	\N	39464	39464	39465
10955	11540	3	applied	\N	\N	\N	\N	39466	39466	39467
10955	11541	4	applied	\N	\N	\N	\N	39468	39468	39469
10957	11543	0	applied	\N	\N	\N	\N	39477	39477	39478
10957	11544	1	applied	\N	\N	\N	\N	39479	39479	39480
10957	11545	2	applied	\N	\N	\N	\N	39481	39481	39482
10957	11546	3	applied	\N	\N	\N	\N	39483	39483	39484
10960	11550	0	applied	\N	\N	\N	\N	39497	39497	39498
10960	11551	1	applied	\N	\N	\N	\N	39499	39499	39500
10960	11552	2	applied	\N	\N	\N	\N	39501	39501	39502
10960	11553	3	applied	\N	\N	\N	\N	39503	39503	39504
10960	11554	4	applied	\N	\N	\N	\N	39505	39505	39506
10960	11555	5	applied	\N	\N	\N	\N	39507	39507	39508
10960	11556	6	applied	\N	\N	\N	\N	39509	39509	39510
10962	11550	0	applied	\N	\N	\N	\N	39497	39497	39498
10962	11551	1	applied	\N	\N	\N	\N	39499	39499	39500
10962	11552	2	applied	\N	\N	\N	\N	39501	39501	39502
10962	11553	3	applied	\N	\N	\N	\N	39503	39503	39504
10962	11554	4	applied	\N	\N	\N	\N	39505	39505	39506
10962	11555	5	applied	\N	\N	\N	\N	39507	39507	39508
10962	11556	6	applied	\N	\N	\N	\N	39509	39509	39510
10967	11559	0	applied	\N	\N	\N	\N	39525	39525	39526
10967	11560	1	applied	\N	\N	\N	\N	39527	39527	39528
10971	11561	0	applied	\N	\N	\N	\N	39534	39534	39535
10973	11562	0	applied	\N	\N	\N	\N	39537	39537	39538
10973	11565	1	applied	\N	\N	\N	\N	39544	39544	39545
10973	11563	2	applied	\N	\N	\N	\N	39539	39539	39540
10973	11564	3	applied	\N	\N	\N	\N	39541	39541	39542
10978	11573	0	applied	\N	\N	\N	\N	39566	39566	39567
10978	11574	1	applied	\N	\N	\N	\N	39568	39568	39569
10978	11575	2	applied	\N	\N	\N	\N	39570	39570	39571
10988	11586	0	applied	\N	\N	\N	\N	39608	39608	39609
10988	11587	1	applied	\N	\N	\N	\N	39610	39610	39611
10988	11588	2	applied	\N	\N	\N	\N	39612	39612	39613
10988	11589	3	applied	\N	\N	\N	\N	39614	39614	39615
10990	11586	0	applied	\N	\N	\N	\N	39608	39608	39609
10990	11587	1	applied	\N	\N	\N	\N	39610	39610	39611
10990	11588	2	applied	\N	\N	\N	\N	39612	39612	39613
10990	11589	3	applied	\N	\N	\N	\N	39614	39614	39615
10993	11590	0	applied	\N	\N	\N	\N	39620	39620	39621
10993	11591	1	applied	\N	\N	\N	\N	39622	39622	39623
10993	11592	2	applied	\N	\N	\N	\N	39624	39624	39625
10993	11593	3	applied	\N	\N	\N	\N	39626	39626	39627
10995	11598	0	applied	\N	\N	\N	\N	39646	39646	39647
10995	11599	1	applied	\N	\N	\N	\N	39648	39648	39649
10998	11600	0	applied	\N	\N	\N	\N	39652	39652	39653
10998	11601	1	applied	\N	\N	\N	\N	39654	39654	39655
11006	11603	0	applied	\N	\N	\N	\N	39668	39668	39669
11006	11602	1	applied	\N	\N	\N	\N	39659	39659	39660
11006	11604	2	applied	\N	\N	\N	\N	39670	39670	39671
11011	11607	0	applied	\N	\N	\N	\N	39679	39679	39679
11011	11608	1	applied	\N	\N	\N	\N	39680	39680	39681
11011	11609	2	applied	\N	\N	\N	\N	39682	39682	39683
11011	11610	3	applied	\N	\N	\N	\N	39684	39684	39685
11011	11611	4	applied	\N	\N	\N	\N	39686	39686	39687
11011	11612	5	applied	\N	\N	1000000000	\N	39688	39688	39689
11013	11613	0	applied	\N	\N	\N	\N	39696	39696	39697
11020	11624	0	applied	\N	\N	\N	\N	39724	39724	39725
11020	11625	1	applied	\N	\N	\N	\N	39726	39726	39727
11022	11626	0	applied	\N	\N	\N	\N	39733	39733	39734
11022	11627	1	applied	\N	\N	\N	\N	39735	39735	39736
11022	11628	2	applied	\N	\N	\N	\N	39737	39737	39738
11025	11629	0	applied	\N	\N	\N	\N	39741	39741	39742
11028	11630	0	applied	\N	\N	\N	\N	39745	39745	39746
11028	11631	1	applied	\N	\N	\N	\N	39747	39747	39748
11028	11632	2	applied	\N	\N	\N	\N	39749	39749	39750
11028	11633	3	applied	\N	\N	\N	\N	39751	39751	39752
11028	11634	4	applied	\N	\N	\N	\N	39753	39753	39754
11028	11635	5	applied	\N	\N	\N	\N	39755	39755	39756
11028	11636	6	applied	\N	\N	\N	\N	39757	39757	39758
11028	11637	7	applied	\N	\N	\N	\N	39759	39759	39760
11028	11638	8	applied	\N	\N	\N	\N	39761	39761	39762
11028	11639	9	applied	\N	\N	\N	\N	39763	39763	39764
11030	11642	0	applied	\N	\N	\N	\N	39775	39775	39776
10932	11518	0	applied	\N	\N	\N	\N	39382	39382	39383
10941	11525	0	applied	\N	\N	\N	\N	39418	39418	39419
10941	11526	1	applied	\N	\N	\N	\N	39420	39420	39421
10946	11527	0	applied	\N	\N	\N	\N	39428	39428	39429
10946	11528	1	applied	\N	\N	\N	\N	39430	39430	39431
10949	11530	0	applied	\N	\N	\N	\N	39438	39438	39439
10949	11531	1	applied	\N	\N	\N	\N	39440	39440	39441
10949	11532	2	applied	\N	\N	\N	\N	39442	39442	39443
10949	11533	3	applied	\N	\N	\N	\N	39444	39444	39445
10949	11534	4	applied	\N	\N	\N	\N	39446	39446	39447
10949	11535	5	applied	\N	\N	\N	\N	39448	39448	39449
10953	11536	0	applied	\N	\N	\N	\N	39455	39455	39456
10961	11550	0	applied	\N	\N	\N	\N	39497	39497	39498
10961	11551	1	applied	\N	\N	\N	\N	39499	39499	39500
10961	11552	2	applied	\N	\N	\N	\N	39501	39501	39502
10961	11553	3	applied	\N	\N	\N	\N	39503	39503	39504
10961	11554	4	applied	\N	\N	\N	\N	39505	39505	39506
10961	11555	5	applied	\N	\N	\N	\N	39507	39507	39508
10961	11556	6	applied	\N	\N	\N	\N	39509	39509	39510
10965	11557	0	applied	\N	\N	\N	\N	39515	39515	39516
10965	11558	1	applied	\N	\N	\N	\N	39517	39517	39518
10968	11559	0	applied	\N	\N	\N	\N	39525	39525	39526
10968	11560	1	applied	\N	\N	\N	\N	39527	39527	39528
10974	11566	0	applied	\N	\N	\N	\N	39547	39547	39548
10974	11567	1	applied	\N	\N	\N	\N	39549	39549	39550
10976	11568	0	applied	\N	\N	\N	\N	39553	39553	39554
10976	11569	1	applied	\N	\N	\N	\N	39555	39555	39556
10976	11570	2	applied	\N	\N	\N	\N	39557	39557	39558
10979	11573	0	applied	\N	\N	\N	\N	39566	39566	39567
10979	11574	1	applied	\N	\N	\N	\N	39568	39568	39569
10979	11575	2	applied	\N	\N	\N	\N	39570	39570	39571
10981	11576	0	applied	\N	\N	\N	\N	39578	39578	39579
10981	11577	1	applied	\N	\N	\N	\N	39580	39580	39581
10991	11590	0	applied	\N	\N	\N	\N	39620	39620	39621
10991	11591	1	applied	\N	\N	\N	\N	39622	39622	39623
10991	11592	2	applied	\N	\N	\N	\N	39624	39624	39625
10991	11593	3	applied	\N	\N	\N	\N	39626	39626	39627
10996	11600	0	applied	\N	\N	\N	\N	39652	39652	39653
10996	11601	1	applied	\N	\N	\N	\N	39654	39654	39655
11001	11602	0	applied	\N	\N	\N	\N	39659	39659	39660
11002	11602	0	applied	\N	\N	\N	\N	39659	39659	39660
11009	11603	0	applied	\N	\N	\N	\N	39668	39668	39669
11009	11605	1	applied	\N	\N	\N	\N	39673	39673	39674
11009	11604	2	applied	\N	\N	\N	\N	39670	39670	39671
11009	11606	3	applied	\N	\N	\N	\N	39675	39675	39676
11018	11620	0	applied	\N	\N	\N	\N	39714	39714	39715
11018	11622	1	applied	\N	\N	\N	\N	39720	39720	39721
11018	11621	2	applied	\N	\N	\N	\N	39716	39716	39717
11018	11623	3	applied	\N	\N	\N	\N	39722	39722	39723
11021	11622	0	applied	\N	\N	\N	\N	39720	39720	39721
11021	11624	1	applied	\N	\N	\N	\N	39724	39724	39725
11021	11623	2	applied	\N	\N	\N	\N	39722	39722	39723
11021	11625	3	applied	\N	\N	\N	\N	39726	39726	39727
11023	11629	0	applied	\N	\N	\N	\N	39741	39741	39742
11026	11630	0	applied	\N	\N	\N	\N	39745	39745	39746
11026	11631	1	applied	\N	\N	\N	\N	39747	39747	39748
11026	11632	2	applied	\N	\N	\N	\N	39749	39749	39750
11026	11633	3	applied	\N	\N	\N	\N	39751	39751	39752
11026	11634	4	applied	\N	\N	\N	\N	39753	39753	39754
11026	11635	5	applied	\N	\N	\N	\N	39755	39755	39756
11026	11636	6	applied	\N	\N	\N	\N	39757	39757	39758
11026	11637	7	applied	\N	\N	\N	\N	39759	39759	39760
11026	11638	8	applied	\N	\N	\N	\N	39761	39761	39762
11026	11639	9	applied	\N	\N	\N	\N	39763	39763	39764
11033	11550	0	applied	\N	\N	\N	\N	39497	39497	39498
11033	11551	1	applied	\N	\N	\N	\N	39499	39499	39500
11033	11568	2	applied	\N	\N	\N	\N	39553	39553	39554
11033	11547	3	applied	\N	\N	\N	\N	39489	39489	39490
11033	11607	4	applied	\N	\N	\N	\N	39791	39791	39791
11033	11614	5	applied	\N	\N	\N	\N	39792	39792	39701
11033	11615	6	applied	\N	\N	\N	\N	39793	39793	39703
11033	11616	7	applied	\N	\N	\N	\N	39794	39794	39705
11033	11617	8	applied	\N	\N	\N	\N	39795	39795	39707
11033	11548	9	applied	\N	\N	\N	\N	39491	39491	39492
11033	11554	10	applied	\N	\N	\N	\N	39505	39505	39506
11033	11612	11	applied	\N	\N	1000000000	\N	39688	39688	39689
11033	11631	12	applied	\N	\N	\N	\N	39796	39796	39797
11033	11549	13	applied	\N	\N	\N	\N	39493	39493	39494
11033	11552	14	applied	\N	\N	\N	\N	39501	39501	39502
11033	11553	15	applied	\N	\N	\N	\N	39503	39503	39504
11033	11558	16	applied	\N	\N	\N	\N	39517	39517	39518
11033	11559	17	applied	\N	\N	\N	\N	39525	39525	39526
11033	11561	18	applied	\N	\N	\N	\N	39534	39534	39535
11033	11562	19	applied	\N	\N	\N	\N	39537	39537	39538
11033	11565	20	applied	\N	\N	\N	\N	39544	39544	39545
11033	11567	21	applied	\N	\N	\N	\N	39549	39549	39550
11033	11569	23	applied	\N	\N	\N	\N	39555	39555	39556
11033	11572	24	applied	\N	\N	\N	\N	39562	39562	39563
11033	11573	25	applied	\N	\N	\N	\N	39566	39566	39567
11033	11576	26	applied	\N	\N	\N	\N	39578	39578	39579
11033	11578	27	applied	\N	\N	\N	\N	39588	39588	39589
11033	11582	28	applied	\N	\N	\N	\N	39598	39598	39599
11033	11583	29	applied	\N	\N	\N	\N	39600	39600	39601
11033	11584	30	applied	\N	\N	\N	\N	39602	39602	39603
11033	11588	31	applied	\N	\N	\N	\N	39612	39612	39613
11033	11589	32	applied	\N	\N	\N	\N	39614	39614	39615
11033	11592	33	applied	\N	\N	\N	\N	39624	39624	39625
11033	11593	34	applied	\N	\N	\N	\N	39626	39626	39627
11033	11596	35	applied	\N	\N	\N	\N	39640	39640	39641
11033	11597	36	applied	\N	\N	\N	\N	39642	39642	39643
11033	11598	37	applied	\N	\N	\N	\N	39646	39646	39647
11033	11601	38	applied	\N	\N	\N	\N	39654	39654	39655
11033	11603	39	applied	\N	\N	\N	\N	39668	39668	39669
11033	11605	40	applied	\N	\N	\N	\N	39673	39673	39674
11033	11608	41	applied	\N	\N	\N	\N	39680	39680	39681
11033	11611	42	applied	\N	\N	\N	\N	39686	39686	39687
11033	11613	43	applied	\N	\N	\N	\N	39696	39696	39697
11033	11619	44	applied	\N	\N	\N	\N	39710	39710	39711
11033	11621	45	applied	\N	\N	\N	\N	39716	39716	39717
11033	11623	46	applied	\N	\N	\N	\N	39722	39722	39723
11033	11625	47	applied	\N	\N	\N	\N	39726	39726	39727
11033	11626	48	applied	\N	\N	\N	\N	39733	39733	39734
11033	11633	49	applied	\N	\N	\N	\N	39751	39751	39752
11033	11634	50	applied	\N	\N	\N	\N	39753	39753	39754
11033	11635	51	applied	\N	\N	\N	\N	39755	39755	39756
11033	11636	52	applied	\N	\N	\N	\N	39757	39757	39758
11033	11640	53	applied	\N	\N	\N	\N	39770	39770	39771
11033	11643	54	applied	\N	\N	\N	\N	39777	39777	39778
11033	11644	55	applied	\N	\N	\N	\N	39779	39779	39780
11033	11646	56	applied	\N	\N	\N	\N	39785	39785	39786
10994	11597	3	applied	\N	\N	\N	\N	39642	39642	39643
10997	11600	0	applied	\N	\N	\N	\N	39652	39652	39653
10997	11601	1	applied	\N	\N	\N	\N	39654	39654	39655
11007	11603	0	applied	\N	\N	\N	\N	39668	39668	39669
11007	11605	1	applied	\N	\N	\N	\N	39673	39673	39674
11007	11604	2	applied	\N	\N	\N	\N	39670	39670	39671
11007	11606	3	applied	\N	\N	\N	\N	39675	39675	39676
11012	11607	0	applied	\N	\N	\N	\N	39679	39679	39679
11012	11608	1	applied	\N	\N	\N	\N	39680	39680	39681
11012	11609	2	applied	\N	\N	\N	\N	39682	39682	39683
11012	11610	3	applied	\N	\N	\N	\N	39684	39684	39685
11012	11611	4	applied	\N	\N	\N	\N	39686	39686	39687
11012	11612	5	applied	\N	\N	1000000000	\N	39688	39688	39689
11014	11614	0	applied	\N	\N	\N	\N	39700	39700	39701
11014	11615	1	applied	\N	\N	\N	\N	39702	39702	39703
11014	11616	2	applied	\N	\N	\N	\N	39704	39704	39705
11014	11617	3	applied	\N	\N	\N	\N	39706	39706	39707
11014	11618	4	applied	\N	\N	\N	\N	39708	39708	39709
11014	11619	5	applied	\N	\N	\N	\N	39710	39710	39711
11016	11607	0	applied	\N	\N	\N	\N	39679	39679	39679
11016	11614	1	applied	\N	\N	\N	\N	39700	39700	39701
11016	11615	2	applied	\N	\N	\N	\N	39702	39702	39703
11016	11616	3	applied	\N	\N	\N	\N	39704	39704	39705
11016	11617	4	applied	\N	\N	\N	\N	39706	39706	39707
11016	11608	5	applied	\N	\N	\N	\N	39680	39680	39681
11016	11609	6	applied	\N	\N	\N	\N	39682	39682	39683
11016	11610	7	applied	\N	\N	\N	\N	39684	39684	39685
11016	11618	8	applied	\N	\N	\N	\N	39708	39708	39709
11016	11611	9	applied	\N	\N	\N	\N	39686	39686	39687
11016	11612	10	applied	\N	\N	1000000000	\N	39688	39688	39689
11016	11613	11	applied	\N	\N	\N	\N	39696	39696	39697
11016	11619	12	applied	\N	\N	\N	\N	39710	39710	39711
11019	11624	0	applied	\N	\N	\N	\N	39724	39724	39725
11019	11625	1	applied	\N	\N	\N	\N	39726	39726	39727
11024	11629	0	applied	\N	\N	\N	\N	39741	39741	39742
11027	11630	0	applied	\N	\N	\N	\N	39745	39745	39746
11027	11631	1	applied	\N	\N	\N	\N	39747	39747	39748
11027	11632	2	applied	\N	\N	\N	\N	39749	39749	39750
11027	11633	3	applied	\N	\N	\N	\N	39751	39751	39752
11027	11634	4	applied	\N	\N	\N	\N	39753	39753	39754
11027	11635	5	applied	\N	\N	\N	\N	39755	39755	39756
11027	11636	6	applied	\N	\N	\N	\N	39757	39757	39758
11027	11637	7	applied	\N	\N	\N	\N	39759	39759	39760
11027	11638	8	applied	\N	\N	\N	\N	39761	39761	39762
11027	11639	9	applied	\N	\N	\N	\N	39763	39763	39764
11031	11644	0	applied	\N	\N	\N	\N	39779	39779	39780
11031	11645	1	applied	\N	\N	\N	\N	39781	39781	39782
11036	11648	0	applied	\N	\N	\N	\N	39803	39803	39804
11036	11649	1	applied	\N	\N	\N	\N	39805	39805	39806
11038	11650	0	applied	\N	\N	\N	\N	39813	39813	39814
11038	11651	1	applied	\N	\N	\N	\N	39815	39815	39816
11040	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11040	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11045	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11045	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11047	11654	0	applied	\N	\N	\N	\N	39833	39833	39834
11047	11655	1	applied	\N	\N	\N	\N	39835	39835	39836
11054	11662	0	applied	\N	\N	\N	\N	39855	39855	39856
11054	11663	1	applied	\N	\N	\N	\N	39857	39857	39858
11054	11664	2	applied	\N	\N	\N	\N	39859	39859	39860
11054	11665	3	applied	\N	\N	\N	\N	39861	39861	39862
11056	11662	0	applied	\N	\N	\N	\N	39855	39855	39856
11056	11663	1	applied	\N	\N	\N	\N	39857	39857	39858
11056	11664	2	applied	\N	\N	\N	\N	39859	39859	39860
11056	11665	3	applied	\N	\N	\N	\N	39861	39861	39862
11057	11662	0	applied	\N	\N	\N	\N	39855	39855	39856
11057	11663	1	applied	\N	\N	\N	\N	39857	39857	39858
11057	11664	2	applied	\N	\N	\N	\N	39859	39859	39860
11057	11665	3	applied	\N	\N	\N	\N	39861	39861	39862
11066	11680	0	applied	\N	\N	\N	\N	39913	39913	39914
11066	11681	1	applied	\N	\N	\N	\N	39915	39915	39916
11071	11685	0	applied	\N	\N	\N	\N	39929	39929	39930
11071	11686	1	applied	\N	\N	\N	\N	39931	39931	39932
11073	11689	0	applied	\N	\N	\N	\N	39940	39940	39941
11073	11690	1	applied	\N	\N	\N	\N	39942	39942	39943
11075	11691	0	applied	\N	\N	\N	\N	39966	39966	39967
11075	11692	1	applied	\N	\N	\N	\N	39968	39968	39969
11080	11696	0	applied	\N	\N	\N	\N	39984	39984	39985
11080	11697	1	applied	\N	\N	\N	\N	39986	39986	39987
11082	11698	0	applied	\N	\N	\N	\N	39988	39988	39989
11082	11699	1	applied	\N	\N	\N	\N	39990	39990	39991
11082	11700	2	applied	\N	\N	\N	\N	39992	39992	39993
11082	11701	3	applied	\N	\N	\N	\N	39994	39994	39995
11084	11702	0	applied	\N	\N	\N	\N	39998	39998	39999
11084	11703	1	applied	\N	\N	\N	\N	40000	40000	40001
11087	11707	0	applied	\N	\N	\N	\N	40012	40012	40013
11087	11708	1	applied	\N	\N	\N	\N	40014	40014	40015
11087	11709	2	applied	\N	\N	\N	\N	40016	40016	40017
11087	11710	3	applied	\N	\N	\N	\N	40018	40018	40019
11095	11719	0	applied	\N	\N	\N	\N	40048	40048	40049
11095	11720	1	applied	\N	\N	\N	\N	40050	40050	40051
11099	11721	0	applied	\N	\N	\N	\N	40060	40060	40061
11099	11722	1	applied	\N	\N	\N	\N	40062	40062	40063
11104	11648	0	applied	\N	\N	\N	\N	39803	39803	39804
11104	11682	1	applied	\N	\N	\N	\N	40089	40089	39922
11104	11649	2	applied	\N	\N	\N	\N	39805	39805	39806
11104	11723	3	applied	\N	\N	\N	\N	40064	40064	40065
11104	11693	4	applied	\N	\N	\N	\N	40090	40090	39975
11104	11650	5	applied	\N	\N	\N	\N	39813	39813	39865
11104	11651	6	applied	\N	\N	\N	\N	39815	39815	39816
11104	11724	7	applied	\N	\N	\N	\N	40066	40066	40067
11104	11725	8	applied	\N	\N	\N	\N	40068	40068	40069
11104	11726	9	applied	\N	\N	\N	\N	40070	40070	40071
11104	11727	10	applied	\N	\N	\N	\N	40072	40072	40073
11104	11699	11	applied	\N	\N	\N	\N	40091	40091	39991
11104	11652	12	applied	\N	\N	\N	\N	39819	39819	39866
11104	11653	13	applied	\N	\N	\N	\N	39821	39821	39822
11104	11654	14	applied	\N	\N	\N	\N	39833	39833	39834
11104	11657	15	applied	\N	\N	\N	\N	39841	39841	39842
11104	11655	16	applied	\N	\N	\N	\N	39835	39835	39867
11104	11656	17	applied	\N	\N	\N	\N	39839	39839	39868
11104	11658	18	applied	\N	\N	\N	\N	39845	39845	39846
11104	11659	19	applied	\N	\N	\N	\N	39847	39847	39848
11104	11662	20	applied	\N	\N	\N	\N	39855	39855	39856
11104	11663	21	applied	\N	\N	\N	\N	39857	39857	39858
11104	11666	22	applied	\N	\N	\N	\N	39877	39877	39878
11104	11668	23	applied	\N	\N	\N	\N	39881	39881	39882
11104	11669	24	applied	\N	\N	\N	\N	39883	39883	39884
11104	11670	25	applied	\N	\N	\N	\N	39885	39885	39886
11010	11610	3	applied	\N	\N	\N	\N	39684	39684	39685
11010	11611	4	applied	\N	\N	\N	\N	39686	39686	39687
11010	11612	5	applied	\N	\N	1000000000	\N	39688	39688	39689
11015	11614	0	applied	\N	\N	\N	\N	39700	39700	39701
11015	11615	1	applied	\N	\N	\N	\N	39702	39702	39703
11015	11616	2	applied	\N	\N	\N	\N	39704	39704	39705
11015	11617	3	applied	\N	\N	\N	\N	39706	39706	39707
11015	11618	4	applied	\N	\N	\N	\N	39708	39708	39709
11015	11619	5	applied	\N	\N	\N	\N	39710	39710	39711
11017	11620	0	applied	\N	\N	\N	\N	39714	39714	39715
11017	11621	1	applied	\N	\N	\N	\N	39716	39716	39717
11029	11640	0	applied	\N	\N	\N	\N	39770	39770	39771
11029	11641	1	applied	\N	\N	\N	\N	39772	39772	39773
11032	11646	0	applied	\N	\N	\N	\N	39785	39785	39786
11032	11647	1	applied	\N	\N	\N	\N	39787	39787	39788
11034	11648	0	applied	\N	\N	\N	\N	39803	39803	39804
11034	11649	1	applied	\N	\N	\N	\N	39805	39805	39806
11037	11648	0	applied	\N	\N	\N	\N	39803	39803	39804
11037	11649	1	applied	\N	\N	\N	\N	39805	39805	39806
11041	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11041	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11049	11656	0	applied	\N	\N	\N	\N	39839	39839	39840
11049	11657	1	applied	\N	\N	\N	\N	39841	39841	39842
11062	11674	0	applied	\N	\N	\N	\N	39896	39896	39897
11062	11675	1	applied	\N	\N	\N	\N	39898	39898	39899
11062	11676	2	applied	\N	\N	\N	\N	39900	39900	39901
11062	11677	3	applied	\N	\N	\N	\N	39902	39902	39903
11064	11678	0	applied	\N	\N	\N	\N	39905	39905	39906
11064	11679	1	applied	\N	\N	\N	\N	39907	39907	39908
11067	11680	0	applied	\N	\N	\N	\N	39913	39913	39914
11067	11681	1	applied	\N	\N	\N	\N	39915	39915	39916
11078	11693	0	applied	\N	\N	\N	\N	39974	39974	39975
11078	11694	1	applied	\N	\N	\N	\N	39976	39976	39977
11078	11695	2	applied	\N	\N	\N	\N	39978	39978	39979
11085	11704	0	applied	\N	\N	\N	\N	40003	40003	40004
11085	11705	1	applied	\N	\N	\N	\N	40005	40005	40006
11085	11706	2	applied	\N	\N	\N	\N	40007	40007	40008
11090	11714	0	applied	\N	\N	\N	\N	40032	40032	40033
11090	11715	1	applied	\N	\N	\N	\N	40034	40034	40035
11096	11719	0	applied	\N	\N	\N	\N	40048	40048	40049
11096	11720	1	applied	\N	\N	\N	\N	40050	40050	40051
11102	11728	0	applied	\N	\N	\N	\N	40076	40076	40077
11102	11723	1	applied	\N	\N	\N	\N	40064	40064	40065
11102	11724	2	applied	\N	\N	\N	\N	40066	40066	40067
11102	11725	3	applied	\N	\N	\N	\N	40068	40068	40069
11102	11726	4	applied	\N	\N	\N	\N	40070	40070	40071
11102	11727	5	applied	\N	\N	\N	\N	40072	40072	40073
11102	11729	6	applied	\N	\N	\N	\N	40078	40078	40079
11102	11730	7	applied	\N	\N	\N	\N	40080	40080	40081
11102	11731	8	applied	\N	\N	\N	\N	40082	40082	40083
11106	11732	0	applied	\N	\N	\N	\N	40108	40108	40109
11106	11733	1	applied	\N	\N	\N	\N	40110	40110	40111
11106	11734	2	applied	\N	\N	\N	\N	40112	40112	40113
11106	11735	3	applied	\N	\N	\N	\N	40114	40114	40115
11106	11736	4	applied	\N	\N	1000000000	\N	40116	40116	40117
11109	11737	0	applied	\N	\N	\N	\N	40120	40120	40121
11109	11738	2	applied	\N	\N	\N	\N	40123	40123	40124
11113	11744	0	applied	\N	\N	\N	\N	40148	40148	40149
11113	11745	1	applied	\N	\N	\N	\N	40150	40150	40151
11113	11746	2	applied	\N	\N	\N	\N	40152	40152	40153
11113	11747	3	applied	\N	\N	\N	\N	40154	40154	40155
11120	11752	0	applied	\N	\N	\N	\N	40172	40172	40173
11120	11753	1	applied	\N	\N	\N	\N	40174	40174	40175
11127	11758	0	applied	\N	\N	\N	\N	40190	40190	40191
11127	11759	1	applied	\N	\N	\N	\N	40192	40192	40193
11129	11760	0	applied	\N	\N	\N	\N	40199	40199	40200
11129	11761	1	applied	\N	\N	\N	\N	40201	40201	40202
11129	11762	2	applied	\N	\N	\N	\N	40203	40203	40204
11129	11763	3	applied	\N	\N	\N	\N	40205	40205	40206
11134	11766	0	applied	\N	\N	\N	\N	40222	40222	40223
11134	11767	1	applied	\N	\N	\N	\N	40224	40224	40225
11144	11781	0	applied	\N	\N	\N	\N	40263	40263	40264
11144	11782	1	applied	\N	\N	\N	\N	40265	40265	40266
11144	11783	2	applied	\N	\N	\N	\N	40267	40267	40268
11144	11784	3	applied	\N	\N	\N	\N	40269	40269	40270
11147	11781	0	applied	\N	\N	\N	\N	40263	40263	40264
11147	11782	1	applied	\N	\N	\N	\N	40265	40265	40266
11147	11783	2	applied	\N	\N	\N	\N	40267	40267	40268
11147	11784	3	applied	\N	\N	\N	\N	40269	40269	40270
11148	11785	0	applied	\N	\N	\N	\N	40278	40278	40279
11148	11786	1	applied	\N	\N	\N	\N	40280	40280	40281
11153	11793	0	applied	\N	\N	\N	\N	40302	40302	40303
11153	11794	1	applied	\N	\N	\N	\N	40304	40304	40305
11156	11797	0	applied	\N	\N	\N	\N	40312	40312	40313
11156	11798	1	applied	\N	\N	\N	\N	40314	40314	40315
11156	11799	2	applied	\N	\N	\N	\N	40316	40316	40317
11158	11800	0	applied	\N	\N	\N	\N	40319	40319	40320
11158	11801	1	applied	\N	\N	\N	\N	40321	40321	40322
11163	11802	0	applied	\N	\N	\N	\N	40324	40324	40325
11163	11803	1	applied	\N	\N	\N	\N	40326	40326	40327
11163	11804	2	applied	\N	\N	\N	\N	40328	40328	40329
11163	11805	3	applied	\N	\N	\N	\N	40330	40330	40331
11163	11806	4	applied	\N	\N	\N	\N	40332	40332	40333
11163	11807	5	applied	\N	\N	\N	\N	40334	40334	40335
11166	11810	0	applied	\N	\N	\N	\N	40343	40343	40344
11166	11811	1	applied	\N	\N	\N	\N	40345	40345	40346
11170	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11170	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11170	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11170	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11176	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11176	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11176	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11176	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11189	11826	0	applied	\N	\N	\N	\N	40396	40396	40397
11189	11827	1	applied	\N	\N	\N	\N	40398	40398	40399
11189	11828	2	applied	\N	\N	\N	\N	40400	40400	40401
11192	11829	0	applied	\N	\N	\N	\N	40404	40404	40405
11192	11830	1	applied	\N	\N	\N	\N	40406	40406	40407
11194	11831	0	applied	\N	\N	\N	\N	40410	40410	40411
11194	11832	1	applied	\N	\N	\N	\N	40412	40412	40413
11196	11833	0	applied	\N	\N	\N	\N	40417	40417	40418
11196	11834	1	applied	\N	\N	\N	\N	40419	40419	40420
11199	11841	0	applied	\N	\N	\N	\N	40436	40436	40437
11199	11842	1	applied	\N	\N	\N	\N	40438	40438	40439
11201	11843	0	applied	\N	\N	\N	\N	40444	40444	40445
11201	11844	1	applied	\N	\N	\N	\N	40446	40446	40447
11204	11848	0	applied	\N	\N	1000000000	\N	40458	40458	40459
11204	11849	1	applied	\N	\N	\N	\N	40460	40460	40461
11030	11643	1	applied	\N	\N	\N	\N	39777	39777	39778
11035	11648	0	applied	\N	\N	\N	\N	39803	39803	39804
11039	11650	0	applied	\N	\N	\N	\N	39813	39813	39814
11039	11651	1	applied	\N	\N	\N	\N	39815	39815	39816
11042	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11042	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11048	11654	0	applied	\N	\N	\N	\N	39833	39833	39834
11048	11655	1	applied	\N	\N	\N	\N	39835	39835	39836
11050	11656	0	applied	\N	\N	\N	\N	39839	39839	39840
11050	11657	1	applied	\N	\N	\N	\N	39841	39841	39842
11052	11658	0	applied	\N	\N	\N	\N	39845	39845	39846
11052	11659	1	applied	\N	\N	\N	\N	39847	39847	39848
11052	11660	2	applied	\N	\N	\N	\N	39849	39849	39850
11052	11661	3	applied	\N	\N	\N	\N	39851	39851	39852
11055	11627	0	applied	\N	\N	\N	\N	39735	39735	39736
11055	11631	1	applied	\N	\N	\N	\N	39747	39747	39748
11055	11632	2	applied	\N	\N	\N	\N	39749	39749	39750
11055	11624	3	applied	\N	\N	\N	\N	39724	39724	39725
11055	11628	4	applied	\N	\N	\N	\N	39737	39737	39738
11055	11629	5	applied	\N	\N	\N	\N	39741	39741	39742
11055	11630	6	applied	\N	\N	\N	\N	39745	39745	39746
11055	11625	7	applied	\N	\N	\N	\N	39726	39726	39727
11055	11626	8	applied	\N	\N	\N	\N	39733	39733	39734
11055	11633	9	applied	\N	\N	\N	\N	39751	39751	39752
11055	11634	10	applied	\N	\N	\N	\N	39753	39753	39754
11055	11635	11	applied	\N	\N	\N	\N	39755	39755	39756
11055	11636	12	applied	\N	\N	\N	\N	39757	39757	39758
11055	11640	13	applied	\N	\N	\N	\N	39770	39770	39771
11055	11643	14	applied	\N	\N	\N	\N	39777	39777	39778
11055	11644	15	applied	\N	\N	\N	\N	39779	39779	39780
11055	11646	16	applied	\N	\N	\N	\N	39785	39785	39786
11055	11648	17	applied	\N	\N	\N	\N	39803	39803	39804
11055	11650	18	applied	\N	\N	\N	\N	39813	39813	39865
11055	11652	19	applied	\N	\N	\N	\N	39819	39819	39866
11055	11655	20	applied	\N	\N	\N	\N	39835	39835	39867
11055	11656	21	applied	\N	\N	\N	\N	39839	39839	39868
11055	11660	22	applied	\N	\N	\N	\N	39849	39849	39869
11055	11661	23	applied	\N	\N	\N	\N	39851	39851	39870
11055	11664	24	applied	\N	\N	\N	\N	39859	39859	39871
11055	11665	25	applied	\N	\N	\N	\N	39861	39861	39872
11055	11637	26	applied	\N	\N	\N	\N	39759	39759	39760
11055	11638	27	applied	\N	\N	\N	\N	39761	39761	39762
11055	11639	28	applied	\N	\N	\N	\N	39763	39763	39764
11055	11641	29	applied	\N	\N	\N	\N	39772	39772	39773
11055	11642	30	applied	\N	\N	\N	\N	39775	39775	39776
11055	11645	31	applied	\N	\N	\N	\N	39781	39781	39782
11055	11647	32	applied	\N	\N	\N	\N	39787	39787	39788
11055	11649	33	applied	\N	\N	\N	\N	39805	39805	39806
11055	11651	34	applied	\N	\N	\N	\N	39815	39815	39816
11055	11653	35	applied	\N	\N	\N	\N	39821	39821	39822
11055	11654	36	applied	\N	\N	\N	\N	39833	39833	39834
11055	11657	37	applied	\N	\N	\N	\N	39841	39841	39842
11055	11658	38	applied	\N	\N	\N	\N	39845	39845	39846
11055	11659	39	applied	\N	\N	\N	\N	39847	39847	39848
11055	11662	40	applied	\N	\N	\N	\N	39855	39855	39856
11055	11663	41	applied	\N	\N	\N	\N	39857	39857	39858
11059	11666	0	applied	\N	\N	\N	\N	39877	39877	39878
11059	11667	1	applied	\N	\N	\N	\N	39879	39879	39880
11060	11668	0	applied	\N	\N	\N	\N	39881	39881	39882
11060	11669	1	applied	\N	\N	\N	\N	39883	39883	39884
11060	11670	2	applied	\N	\N	\N	\N	39885	39885	39886
11060	11671	3	applied	\N	\N	\N	\N	39887	39887	39888
11060	11672	4	applied	\N	\N	\N	\N	39889	39889	39890
11060	11673	5	applied	\N	\N	\N	\N	39891	39891	39892
11063	11674	0	applied	\N	\N	\N	\N	39896	39896	39897
11063	11675	1	applied	\N	\N	\N	\N	39898	39898	39899
11063	11676	2	applied	\N	\N	\N	\N	39900	39900	39901
11063	11677	3	applied	\N	\N	\N	\N	39902	39902	39903
11068	11680	0	applied	\N	\N	\N	\N	39913	39913	39914
11068	11681	1	applied	\N	\N	\N	\N	39915	39915	39916
11069	11682	0	applied	\N	\N	\N	\N	39921	39921	39922
11069	11683	1	applied	\N	\N	\N	\N	39923	39923	39924
11069	11684	2	applied	\N	\N	\N	\N	39925	39925	39926
11074	11568	0	applied	\N	\N	\N	\N	39553	39553	39554
11074	11607	1	applied	\N	\N	\N	\N	39944	39944	39944
11074	11614	2	applied	\N	\N	\N	\N	39945	39945	39701
11074	11615	3	applied	\N	\N	\N	\N	39946	39946	39703
11074	11616	4	applied	\N	\N	\N	\N	39947	39947	39705
11074	11617	5	applied	\N	\N	\N	\N	39948	39948	39707
11074	11682	6	applied	\N	\N	\N	\N	39921	39921	39922
11074	11559	7	applied	\N	\N	\N	\N	39525	39525	39526
11074	11561	8	applied	\N	\N	\N	\N	39534	39534	39535
11074	11562	9	applied	\N	\N	\N	\N	39537	39537	39538
11074	11565	10	applied	\N	\N	\N	\N	39544	39544	39545
11074	11567	11	applied	\N	\N	\N	\N	39549	39549	39550
11074	11569	12	applied	\N	\N	\N	\N	39555	39555	39556
11074	11572	13	applied	\N	\N	\N	\N	39562	39562	39563
11074	11573	14	applied	\N	\N	\N	\N	39566	39566	39567
11074	11576	15	applied	\N	\N	\N	\N	39578	39578	39579
11074	11578	16	applied	\N	\N	\N	\N	39588	39588	39589
11074	11632	17	applied	\N	\N	1000000000	\N	39749	39749	39949
11074	11612	18	applied	\N	\N	\N	\N	39688	39688	39950
11074	11631	19	applied	\N	\N	\N	\N	39796	39796	39951
11074	11560	20	applied	\N	\N	\N	\N	39527	39527	39528
11074	11563	21	applied	\N	\N	\N	\N	39539	39539	39540
11074	11564	22	applied	\N	\N	\N	\N	39541	39541	39542
11074	11566	23	applied	\N	\N	\N	\N	39547	39547	39548
11074	11570	24	applied	\N	\N	\N	\N	39557	39557	39558
11074	11571	25	applied	\N	\N	\N	\N	39560	39560	39561
11074	11574	26	applied	\N	\N	\N	\N	39568	39568	39569
11074	11577	27	applied	\N	\N	\N	\N	39580	39580	39581
11074	11579	28	applied	\N	\N	\N	\N	39590	39590	39591
11074	11580	29	applied	\N	\N	\N	\N	39594	39594	39595
11074	11581	30	applied	\N	\N	\N	\N	39596	39596	39597
11074	11582	31	applied	\N	\N	\N	\N	39598	39598	39599
11074	11583	32	applied	\N	\N	\N	\N	39600	39600	39601
11074	11584	33	applied	\N	\N	\N	\N	39602	39602	39603
11074	11588	34	applied	\N	\N	\N	\N	39612	39612	39613
11074	11589	35	applied	\N	\N	\N	\N	39614	39614	39615
11074	11592	36	applied	\N	\N	\N	\N	39624	39624	39625
11074	11593	37	applied	\N	\N	\N	\N	39626	39626	39627
11074	11596	38	applied	\N	\N	\N	\N	39640	39640	39641
11074	11597	39	applied	\N	\N	\N	\N	39642	39642	39643
11074	11598	40	applied	\N	\N	\N	\N	39646	39646	39647
11074	11601	41	applied	\N	\N	\N	\N	39654	39654	39655
11074	11603	42	applied	\N	\N	\N	\N	39668	39668	39669
11074	11605	43	applied	\N	\N	\N	\N	39673	39673	39674
11074	11608	44	applied	\N	\N	\N	\N	39680	39680	39681
11074	11611	45	applied	\N	\N	\N	\N	39686	39686	39687
11074	11613	46	applied	\N	\N	\N	\N	39696	39696	39697
11033	11555	57	applied	\N	\N	\N	\N	39507	39507	39508
11033	11557	58	applied	\N	\N	\N	\N	39515	39515	39516
11033	11560	59	applied	\N	\N	\N	\N	39527	39527	39528
11033	11563	60	applied	\N	\N	\N	\N	39539	39539	39540
11033	11564	61	applied	\N	\N	\N	\N	39541	39541	39542
11033	11566	62	applied	\N	\N	\N	\N	39547	39547	39548
11033	11570	63	applied	\N	\N	\N	\N	39557	39557	39558
11033	11571	64	applied	\N	\N	\N	\N	39560	39560	39561
11033	11574	65	applied	\N	\N	\N	\N	39568	39568	39569
11033	11577	66	applied	\N	\N	\N	\N	39580	39580	39581
11033	11579	67	applied	\N	\N	\N	\N	39590	39590	39591
11033	11580	68	applied	\N	\N	\N	\N	39594	39594	39595
11033	11581	69	applied	\N	\N	\N	\N	39596	39596	39597
11033	11585	70	applied	\N	\N	\N	\N	39604	39604	39605
11033	11586	71	applied	\N	\N	\N	\N	39608	39608	39609
11033	11587	72	applied	\N	\N	\N	\N	39610	39610	39611
11033	11590	73	applied	\N	\N	\N	\N	39620	39620	39621
11033	11591	74	applied	\N	\N	\N	\N	39622	39622	39623
11033	11594	75	applied	\N	\N	\N	\N	39636	39636	39637
11033	11595	76	applied	\N	\N	\N	\N	39638	39638	39639
11033	11599	77	applied	\N	\N	\N	\N	39648	39648	39649
11033	11600	78	applied	\N	\N	\N	\N	39652	39652	39653
11033	11602	79	applied	\N	\N	\N	\N	39659	39659	39660
11033	11604	80	applied	\N	\N	\N	\N	39670	39670	39671
11033	11606	81	applied	\N	\N	\N	\N	39675	39675	39676
11033	11609	82	applied	\N	\N	\N	\N	39682	39682	39683
11033	11610	83	applied	\N	\N	\N	\N	39684	39684	39685
11033	11618	84	applied	\N	\N	\N	\N	39708	39708	39709
11033	11620	85	applied	\N	\N	\N	\N	39714	39714	39715
11033	11622	86	applied	\N	\N	\N	\N	39720	39720	39721
11033	11624	87	applied	\N	\N	\N	\N	39724	39724	39725
11033	11628	88	applied	\N	\N	\N	\N	39737	39737	39738
11033	11629	89	applied	\N	\N	\N	\N	39741	39741	39742
11033	11630	90	applied	\N	\N	\N	\N	39745	39745	39746
11033	11637	91	applied	\N	\N	\N	\N	39759	39759	39760
11033	11638	92	applied	\N	\N	\N	\N	39761	39761	39762
11033	11639	93	applied	\N	\N	\N	\N	39763	39763	39764
11033	11641	94	applied	\N	\N	\N	\N	39772	39772	39773
11033	11642	95	applied	\N	\N	\N	\N	39775	39775	39776
11033	11645	96	applied	\N	\N	\N	\N	39781	39781	39782
11033	11647	97	applied	\N	\N	\N	\N	39787	39787	39788
11033	11556	98	applied	\N	\N	\N	\N	39509	39509	39799
11043	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11043	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11044	11652	0	applied	\N	\N	\N	\N	39819	39819	39820
11044	11653	1	applied	\N	\N	\N	\N	39821	39821	39822
11046	11654	0	applied	\N	\N	\N	\N	39833	39833	39834
11046	11655	1	applied	\N	\N	\N	\N	39835	39835	39836
11051	11654	0	applied	\N	\N	\N	\N	39833	39833	39834
11051	11655	1	applied	\N	\N	\N	\N	39835	39835	39836
11053	11662	0	applied	\N	\N	\N	\N	39855	39855	39856
11053	11663	1	applied	\N	\N	\N	\N	39857	39857	39858
11053	11664	2	applied	\N	\N	\N	\N	39859	39859	39860
11053	11665	3	applied	\N	\N	\N	\N	39861	39861	39862
11061	11668	0	applied	\N	\N	\N	\N	39881	39881	39882
11061	11669	1	applied	\N	\N	\N	\N	39883	39883	39884
11061	11670	2	applied	\N	\N	\N	\N	39885	39885	39886
11061	11671	3	applied	\N	\N	\N	\N	39887	39887	39888
11061	11672	4	applied	\N	\N	\N	\N	39889	39889	39890
11061	11673	5	applied	\N	\N	\N	\N	39891	39891	39892
11065	11678	0	applied	\N	\N	\N	\N	39905	39905	39906
11065	11679	1	applied	\N	\N	\N	\N	39907	39907	39908
11070	11685	0	applied	\N	\N	\N	\N	39929	39929	39930
11070	11686	1	applied	\N	\N	\N	\N	39931	39931	39932
11072	11687	0	applied	\N	\N	\N	\N	39935	39935	39936
11072	11688	1	applied	\N	\N	\N	\N	39937	39937	39938
11077	11693	0	applied	\N	\N	\N	\N	39974	39974	39975
11077	11694	1	applied	\N	\N	\N	\N	39976	39976	39977
11077	11695	2	applied	\N	\N	\N	\N	39978	39978	39979
11079	11696	0	applied	\N	\N	\N	\N	39984	39984	39985
11079	11697	1	applied	\N	\N	\N	\N	39986	39986	39987
11089	11713	0	applied	\N	\N	\N	\N	40028	40028	40029
11092	11716	0	applied	\N	\N	\N	\N	40038	40038	40039
11092	11717	1	applied	\N	\N	\N	\N	40040	40040	40041
11092	11718	2	applied	\N	\N	\N	\N	40042	40042	40043
11094	11719	0	applied	\N	\N	\N	\N	40048	40048	40049
11094	11720	1	applied	\N	\N	\N	\N	40050	40050	40051
11098	11721	0	applied	\N	\N	\N	\N	40060	40060	40061
11098	11722	1	applied	\N	\N	\N	\N	40062	40062	40063
11101	11728	0	applied	\N	\N	\N	\N	40076	40076	40077
11101	11723	1	applied	\N	\N	\N	\N	40064	40064	40065
11101	11724	2	applied	\N	\N	\N	\N	40066	40066	40067
11101	11725	3	applied	\N	\N	\N	\N	40068	40068	40069
11101	11726	4	applied	\N	\N	\N	\N	40070	40070	40071
11101	11727	5	applied	\N	\N	\N	\N	40072	40072	40073
11101	11729	6	applied	\N	\N	\N	\N	40078	40078	40079
11101	11730	7	applied	\N	\N	\N	\N	40080	40080	40081
11101	11731	8	applied	\N	\N	\N	\N	40082	40082	40083
11105	11732	0	applied	\N	\N	\N	\N	40108	40108	40109
11105	11733	1	applied	\N	\N	\N	\N	40110	40110	40111
11105	11734	2	applied	\N	\N	\N	\N	40112	40112	40113
11105	11735	3	applied	\N	\N	\N	\N	40114	40114	40115
11105	11736	4	applied	\N	\N	1000000000	\N	40116	40116	40117
11107	11737	0	applied	\N	\N	\N	\N	40120	40120	40121
11107	11738	2	applied	\N	\N	\N	\N	40123	40123	40124
11112	11739	0	applied	\N	\N	\N	\N	40134	40134	40135
11112	11740	1	applied	\N	\N	1000000000	\N	40136	40136	40137
11112	11741	2	applied	\N	\N	\N	\N	40138	40138	40139
11112	11742	3	applied	\N	\N	\N	\N	40140	40140	40141
11112	11743	4	applied	\N	\N	\N	\N	40142	40142	40143
11115	11744	0	applied	\N	\N	\N	\N	40148	40148	40149
11115	11745	1	applied	\N	\N	\N	\N	40150	40150	40151
11115	11746	2	applied	\N	\N	\N	\N	40152	40152	40153
11115	11747	3	applied	\N	\N	\N	\N	40154	40154	40155
11121	11754	0	applied	\N	\N	\N	\N	40177	40177	40178
11121	11755	1	applied	\N	\N	\N	\N	40179	40179	40180
11130	11760	0	applied	\N	\N	\N	\N	40199	40199	40200
11130	11761	1	applied	\N	\N	\N	\N	40201	40201	40202
11130	11762	2	applied	\N	\N	\N	\N	40203	40203	40204
11130	11763	3	applied	\N	\N	\N	\N	40205	40205	40206
11135	11766	0	applied	\N	\N	\N	\N	40222	40222	40223
11135	11767	1	applied	\N	\N	\N	\N	40224	40224	40225
11138	11768	0	applied	\N	\N	\N	\N	40228	40228	40229
11138	11769	1	applied	\N	\N	\N	\N	40230	40230	40231
11138	11770	2	applied	\N	\N	\N	\N	40232	40232	40233
11138	11771	3	applied	\N	\N	\N	\N	40234	40234	40235
11138	11772	4	applied	\N	\N	\N	\N	40236	40236	40237
11138	11773	5	applied	\N	\N	\N	\N	40238	40238	40239
11140	11776	0	applied	\N	\N	\N	\N	40248	40248	40249
11074	11619	48	applied	\N	\N	\N	\N	39710	39710	39711
11074	11621	49	applied	\N	\N	\N	\N	39716	39716	39717
11074	11623	50	applied	\N	\N	\N	\N	39722	39722	39723
11074	11625	51	applied	\N	\N	\N	\N	39726	39726	39727
11074	11626	52	applied	\N	\N	\N	\N	39733	39733	39734
11074	11633	53	applied	\N	\N	\N	\N	39751	39751	39752
11074	11634	54	applied	\N	\N	\N	\N	39753	39753	39754
11074	11635	55	applied	\N	\N	\N	\N	39755	39755	39756
11074	11636	56	applied	\N	\N	\N	\N	39757	39757	39758
11074	11640	57	applied	\N	\N	\N	\N	39770	39770	39771
11074	11643	58	applied	\N	\N	\N	\N	39777	39777	39778
11074	11644	59	applied	\N	\N	\N	\N	39779	39779	39780
11074	11646	60	applied	\N	\N	\N	\N	39785	39785	39786
11074	11648	61	applied	\N	\N	\N	\N	39803	39803	39804
11074	11650	62	applied	\N	\N	\N	\N	39813	39813	39865
11074	11652	63	applied	\N	\N	\N	\N	39819	39819	39866
11074	11655	64	applied	\N	\N	\N	\N	39835	39835	39867
11074	11656	65	applied	\N	\N	\N	\N	39839	39839	39868
11074	11585	66	applied	\N	\N	\N	\N	39604	39604	39605
11074	11586	67	applied	\N	\N	\N	\N	39608	39608	39609
11074	11587	68	applied	\N	\N	\N	\N	39610	39610	39611
11074	11590	69	applied	\N	\N	\N	\N	39620	39620	39621
11074	11591	70	applied	\N	\N	\N	\N	39622	39622	39623
11074	11594	71	applied	\N	\N	\N	\N	39636	39636	39637
11074	11595	72	applied	\N	\N	\N	\N	39638	39638	39639
11074	11599	73	applied	\N	\N	\N	\N	39648	39648	39649
11074	11600	74	applied	\N	\N	\N	\N	39652	39652	39653
11074	11602	75	applied	\N	\N	\N	\N	39659	39659	39660
11074	11604	76	applied	\N	\N	\N	\N	39670	39670	39671
11074	11606	77	applied	\N	\N	\N	\N	39675	39675	39676
11074	11609	78	applied	\N	\N	\N	\N	39682	39682	39683
11074	11610	79	applied	\N	\N	\N	\N	39684	39684	39685
11074	11618	80	applied	\N	\N	\N	\N	39708	39708	39709
11074	11620	81	applied	\N	\N	\N	\N	39714	39714	39715
11074	11622	82	applied	\N	\N	\N	\N	39720	39720	39721
11074	11624	83	applied	\N	\N	\N	\N	39724	39724	39725
11074	11628	84	applied	\N	\N	\N	\N	39737	39737	39738
11074	11629	85	applied	\N	\N	\N	\N	39741	39741	39742
11074	11630	86	applied	\N	\N	\N	\N	39745	39745	39746
11074	11660	87	applied	\N	\N	\N	\N	39849	39849	39869
11074	11661	88	applied	\N	\N	\N	\N	39851	39851	39870
11074	11664	89	applied	\N	\N	\N	\N	39859	39859	39871
11074	11665	90	applied	\N	\N	\N	\N	39861	39861	39872
11074	11667	91	applied	\N	\N	\N	\N	39879	39879	39953
11074	11671	92	applied	\N	\N	\N	\N	39887	39887	39954
11074	11672	93	applied	\N	\N	\N	\N	39889	39889	39955
11074	11673	94	applied	\N	\N	\N	\N	39891	39891	39956
11074	11674	95	applied	\N	\N	\N	\N	39896	39896	39957
11074	11677	96	applied	\N	\N	\N	\N	39902	39902	39958
11074	11678	97	applied	\N	\N	\N	\N	39905	39905	39959
11074	11681	98	applied	\N	\N	\N	\N	39915	39915	39960
11074	11684	99	applied	\N	\N	\N	\N	39925	39925	39961
11074	11686	100	applied	\N	\N	\N	\N	39931	39931	39962
11074	11687	101	applied	\N	\N	\N	\N	39935	39935	39963
11074	11637	102	applied	\N	\N	\N	\N	39759	39759	39760
11074	11638	103	applied	\N	\N	\N	\N	39761	39761	39762
11074	11639	104	applied	\N	\N	\N	\N	39763	39763	39764
11074	11641	105	applied	\N	\N	\N	\N	39772	39772	39773
11074	11642	106	applied	\N	\N	\N	\N	39775	39775	39776
11074	11645	107	applied	\N	\N	\N	\N	39781	39781	39782
11074	11647	108	applied	\N	\N	\N	\N	39787	39787	39788
11074	11649	109	applied	\N	\N	\N	\N	39805	39805	39806
11074	11651	110	applied	\N	\N	\N	\N	39815	39815	39816
11074	11653	111	applied	\N	\N	\N	\N	39821	39821	39822
11074	11654	112	applied	\N	\N	\N	\N	39833	39833	39834
11074	11657	113	applied	\N	\N	\N	\N	39841	39841	39842
11074	11658	114	applied	\N	\N	\N	\N	39845	39845	39846
11074	11659	115	applied	\N	\N	\N	\N	39847	39847	39848
11074	11662	116	applied	\N	\N	\N	\N	39855	39855	39856
11074	11663	117	applied	\N	\N	\N	\N	39857	39857	39858
11074	11666	118	applied	\N	\N	\N	\N	39877	39877	39878
11074	11668	119	applied	\N	\N	\N	\N	39881	39881	39882
11074	11669	120	applied	\N	\N	\N	\N	39883	39883	39884
11074	11670	121	applied	\N	\N	\N	\N	39885	39885	39886
11074	11675	122	applied	\N	\N	\N	\N	39898	39898	39899
11074	11676	123	applied	\N	\N	\N	\N	39900	39900	39901
11074	11679	124	applied	\N	\N	\N	\N	39907	39907	39908
11074	11680	125	applied	\N	\N	\N	\N	39913	39913	39914
11076	11691	0	applied	\N	\N	\N	\N	39966	39966	39967
11076	11692	1	applied	\N	\N	\N	\N	39968	39968	39969
11081	11696	0	applied	\N	\N	\N	\N	39984	39984	39985
11081	11697	1	applied	\N	\N	\N	\N	39986	39986	39987
11083	11702	0	applied	\N	\N	\N	\N	39998	39998	39999
11083	11703	1	applied	\N	\N	\N	\N	40000	40000	40001
11086	11704	0	applied	\N	\N	\N	\N	40003	40003	40004
11086	11705	1	applied	\N	\N	\N	\N	40005	40005	40006
11086	11706	2	applied	\N	\N	\N	\N	40007	40007	40008
11088	11711	0	applied	\N	\N	\N	\N	40022	40022	40023
11088	11712	1	applied	\N	\N	\N	\N	40024	40024	40025
11091	11716	0	applied	\N	\N	\N	\N	40038	40038	40039
11091	11717	1	applied	\N	\N	\N	\N	40040	40040	40041
11091	11718	2	applied	\N	\N	\N	\N	40042	40042	40043
11093	11719	0	applied	\N	\N	\N	\N	40048	40048	40049
11093	11720	1	applied	\N	\N	\N	\N	40050	40050	40051
11097	11719	0	applied	\N	\N	\N	\N	40048	40048	40049
11097	11720	1	applied	\N	\N	\N	\N	40050	40050	40051
11100	11723	0	applied	\N	\N	\N	\N	40064	40064	40065
11100	11693	1	applied	\N	\N	\N	\N	39974	39974	39975
11100	11724	2	applied	\N	\N	\N	\N	40066	40066	40067
11100	11725	3	applied	\N	\N	\N	\N	40068	40068	40069
11100	11726	4	applied	\N	\N	\N	\N	40070	40070	40071
11100	11727	5	applied	\N	\N	\N	\N	40072	40072	40073
11100	11699	6	applied	\N	\N	\N	\N	39990	39990	39991
11100	11700	7	applied	\N	\N	\N	\N	39992	39992	39993
11100	11705	8	applied	\N	\N	\N	\N	40005	40005	40006
11100	11718	9	applied	\N	\N	\N	\N	40042	40042	40043
11103	11728	0	applied	\N	\N	\N	\N	40076	40076	40077
11103	11723	1	applied	\N	\N	\N	\N	40064	40064	40065
11103	11724	2	applied	\N	\N	\N	\N	40066	40066	40067
11103	11725	3	applied	\N	\N	\N	\N	40068	40068	40069
11103	11726	4	applied	\N	\N	\N	\N	40070	40070	40071
11103	11727	5	applied	\N	\N	\N	\N	40072	40072	40073
11103	11729	6	applied	\N	\N	\N	\N	40078	40078	40079
11103	11730	7	applied	\N	\N	\N	\N	40080	40080	40081
11103	11731	8	applied	\N	\N	\N	\N	40082	40082	40083
11110	11737	0	applied	\N	\N	\N	\N	40120	40120	40121
11110	11738	2	applied	\N	\N	\N	\N	40123	40123	40124
11111	11739	0	applied	\N	\N	\N	\N	40134	40134	40135
11111	11740	1	applied	\N	\N	1000000000	\N	40136	40136	40137
11111	11741	2	applied	\N	\N	\N	\N	40138	40138	40139
11104	11675	26	applied	\N	\N	\N	\N	39898	39898	39899
11104	11676	27	applied	\N	\N	\N	\N	39900	39900	39901
11104	11679	28	applied	\N	\N	\N	\N	39907	39907	39908
11104	11680	29	applied	\N	\N	\N	\N	39913	39913	39914
11104	11683	30	applied	\N	\N	\N	\N	39923	39923	39924
11104	11685	31	applied	\N	\N	\N	\N	39929	39929	39930
11104	11688	32	applied	\N	\N	\N	\N	39937	39937	39938
11104	11689	33	applied	\N	\N	\N	\N	39940	39940	39941
11104	11692	34	applied	\N	\N	\N	\N	39968	39968	39969
11104	11694	35	applied	\N	\N	\N	\N	39976	39976	39977
11104	11697	36	applied	\N	\N	\N	\N	39986	39986	39987
11104	11698	37	applied	\N	\N	\N	\N	39988	39988	39989
11104	11700	38	applied	\N	\N	\N	\N	40092	40092	39993
11104	11705	39	applied	\N	\N	\N	\N	40093	40093	40006
11104	11718	40	applied	\N	\N	\N	\N	40094	40094	40043
11104	11703	41	applied	\N	\N	\N	\N	40000	40000	40001
11104	11706	42	applied	\N	\N	\N	\N	40007	40007	40008
11104	11707	43	applied	\N	\N	\N	\N	40012	40012	40013
11104	11708	44	applied	\N	\N	\N	\N	40014	40014	40015
11104	11711	45	applied	\N	\N	\N	\N	40022	40022	40023
11104	11713	46	applied	\N	\N	\N	\N	40028	40028	40029
11104	11715	47	applied	\N	\N	\N	\N	40034	40034	40035
11104	11716	48	applied	\N	\N	\N	\N	40038	40038	40039
11104	11719	50	applied	\N	\N	\N	\N	40048	40048	40049
11104	11721	51	applied	\N	\N	\N	\N	40060	40060	40061
11104	11728	52	applied	\N	\N	\N	\N	40076	40076	40077
11104	11731	53	applied	\N	\N	\N	\N	40082	40082	40083
11104	11660	54	applied	\N	\N	\N	\N	39849	39849	39869
11104	11661	55	applied	\N	\N	\N	\N	39851	39851	39870
11104	11664	56	applied	\N	\N	\N	\N	39859	39859	39871
11104	11665	57	applied	\N	\N	\N	\N	39861	39861	39872
11104	11667	58	applied	\N	\N	\N	\N	39879	39879	39953
11104	11671	59	applied	\N	\N	\N	\N	39887	39887	39954
11104	11672	60	applied	\N	\N	\N	\N	39889	39889	39955
11104	11673	61	applied	\N	\N	\N	\N	39891	39891	39956
11104	11674	62	applied	\N	\N	\N	\N	39896	39896	39957
11104	11677	63	applied	\N	\N	\N	\N	39902	39902	39958
11104	11678	64	applied	\N	\N	\N	\N	39905	39905	39959
11104	11681	65	applied	\N	\N	\N	\N	39915	39915	39960
11104	11684	66	applied	\N	\N	\N	\N	39925	39925	39961
11104	11686	67	applied	\N	\N	\N	\N	39931	39931	39962
11104	11687	68	applied	\N	\N	\N	\N	39935	39935	39963
11104	11690	69	applied	\N	\N	\N	\N	39942	39942	40096
11104	11691	70	applied	\N	\N	\N	\N	39966	39966	40097
11104	11695	71	applied	\N	\N	\N	\N	39978	39978	40098
11104	11696	72	applied	\N	\N	\N	\N	39984	39984	40099
11104	11701	73	applied	\N	\N	\N	\N	39994	39994	40100
11104	11702	74	applied	\N	\N	\N	\N	39998	39998	40101
11104	11704	75	applied	\N	\N	\N	\N	40003	40003	40102
11104	11709	76	applied	\N	\N	\N	\N	40016	40016	40103
11104	11710	77	applied	\N	\N	\N	\N	40018	40018	40104
11104	11712	78	applied	\N	\N	\N	\N	40024	40024	40105
11108	11737	0	applied	\N	\N	\N	\N	40120	40120	40121
11108	11738	2	applied	\N	\N	\N	\N	40123	40123	40124
11116	11744	0	applied	\N	\N	\N	\N	40148	40148	40149
11116	11745	1	applied	\N	\N	\N	\N	40150	40150	40151
11116	11746	2	applied	\N	\N	\N	\N	40152	40152	40153
11116	11747	3	applied	\N	\N	\N	\N	40154	40154	40155
11119	11748	0	applied	\N	\N	\N	\N	40161	40161	40162
11119	11749	1	applied	\N	\N	\N	\N	40163	40163	40164
11119	11750	2	applied	\N	\N	\N	\N	40165	40165	40166
11119	11751	3	applied	\N	\N	\N	\N	40167	40167	40168
11122	11754	0	applied	\N	\N	\N	\N	40177	40177	40178
11122	11755	1	applied	\N	\N	\N	\N	40179	40179	40180
11124	11756	0	applied	\N	\N	\N	\N	40185	40185	40186
11124	11757	1	applied	\N	\N	\N	\N	40187	40187	40188
11126	11758	0	applied	\N	\N	\N	\N	40190	40190	40191
11126	11759	1	applied	\N	\N	\N	\N	40192	40192	40193
11131	11682	0	applied	\N	\N	\N	\N	39921	39921	39922
11131	11627	1	applied	\N	\N	\N	\N	39735	39735	39736
11131	11723	2	applied	\N	\N	\N	\N	40064	40064	40065
11131	11693	3	applied	\N	\N	\N	\N	39974	39974	39975
11131	11631	4	applied	\N	\N	\N	\N	39747	39747	39748
11131	11724	5	applied	\N	\N	\N	\N	40066	40066	40067
11131	11725	6	applied	\N	\N	\N	\N	40068	40068	40069
11131	11726	7	applied	\N	\N	\N	\N	40070	40070	40071
11131	11727	8	applied	\N	\N	\N	\N	40072	40072	40073
11131	11699	9	applied	\N	\N	\N	\N	39990	39990	39991
11131	11632	10	applied	\N	\N	\N	\N	39749	39749	39750
11131	11624	11	applied	\N	\N	\N	\N	39724	39724	39725
11131	11628	12	applied	\N	\N	\N	\N	39737	39737	39738
11131	11629	13	applied	\N	\N	\N	\N	39741	39741	39742
11131	11630	14	applied	\N	\N	\N	\N	39745	39745	39746
11131	11625	15	applied	\N	\N	\N	\N	39726	39726	39727
11131	11626	16	applied	\N	\N	\N	\N	39733	39733	39734
11131	11633	17	applied	\N	\N	\N	\N	39751	39751	39752
11131	11634	18	applied	\N	\N	\N	\N	39753	39753	39754
11131	11635	19	applied	\N	\N	\N	\N	39755	39755	39756
11131	11636	20	applied	\N	\N	\N	\N	39757	39757	39758
11131	11640	21	applied	\N	\N	\N	\N	39770	39770	39771
11131	11643	22	applied	\N	\N	\N	\N	39777	39777	39778
11131	11644	23	applied	\N	\N	\N	\N	39779	39779	39780
11131	11646	24	applied	\N	\N	\N	\N	39785	39785	39786
11131	11648	25	applied	\N	\N	\N	\N	39803	39803	39804
11131	11650	26	applied	\N	\N	\N	\N	39813	39813	39865
11131	11652	27	applied	\N	\N	\N	\N	39819	39819	39866
11131	11655	28	applied	\N	\N	\N	\N	39835	39835	39867
11131	11656	29	applied	\N	\N	\N	\N	39839	39839	39868
11131	11700	30	applied	\N	\N	\N	\N	39992	39992	39993
11131	11705	31	applied	\N	\N	\N	\N	40005	40005	40006
11131	11718	32	applied	\N	\N	\N	\N	40042	40042	40043
11131	11660	33	applied	\N	\N	\N	\N	39849	39849	39869
11131	11661	34	applied	\N	\N	\N	\N	39851	39851	39870
11131	11664	35	applied	\N	\N	\N	\N	39859	39859	39871
11131	11665	36	applied	\N	\N	\N	\N	39861	39861	39872
11131	11667	37	applied	\N	\N	\N	\N	39879	39879	39953
11131	11671	38	applied	\N	\N	\N	\N	39887	39887	39954
11131	11672	39	applied	\N	\N	\N	\N	39889	39889	39955
11131	11673	40	applied	\N	\N	\N	\N	39891	39891	39956
11131	11674	41	applied	\N	\N	\N	\N	39896	39896	39957
11131	11677	42	applied	\N	\N	\N	\N	39902	39902	39958
11131	11678	43	applied	\N	\N	\N	\N	39905	39905	39959
11131	11681	44	applied	\N	\N	\N	\N	39915	39915	39960
11131	11684	45	applied	\N	\N	\N	\N	39925	39925	39961
11131	11686	46	applied	\N	\N	\N	\N	39931	39931	39962
11131	11687	47	applied	\N	\N	\N	\N	39935	39935	39963
11131	11690	48	applied	\N	\N	\N	\N	39942	39942	40096
11131	11691	49	applied	\N	\N	\N	\N	39966	39966	40097
11131	11695	50	applied	\N	\N	\N	\N	39978	39978	40098
11131	11696	51	applied	\N	\N	\N	\N	39984	39984	40099
11111	11742	3	applied	\N	\N	\N	\N	40140	40140	40141
11111	11743	4	applied	\N	\N	\N	\N	40142	40142	40143
11114	11744	0	applied	\N	\N	\N	\N	40148	40148	40149
11114	11745	1	applied	\N	\N	\N	\N	40150	40150	40151
11114	11746	2	applied	\N	\N	\N	\N	40152	40152	40153
11114	11747	3	applied	\N	\N	\N	\N	40154	40154	40155
11118	11748	0	applied	\N	\N	\N	\N	40161	40161	40162
11118	11749	1	applied	\N	\N	\N	\N	40163	40163	40164
11118	11750	2	applied	\N	\N	\N	\N	40165	40165	40166
11118	11751	3	applied	\N	\N	\N	\N	40167	40167	40168
11123	11754	0	applied	\N	\N	\N	\N	40177	40177	40178
11123	11755	1	applied	\N	\N	\N	\N	40179	40179	40180
11125	11682	0	applied	\N	\N	\N	\N	39921	39921	39922
11125	11680	1	applied	\N	\N	\N	\N	39913	39913	39914
11125	11681	2	applied	\N	\N	\N	\N	39915	39915	39916
11125	11723	3	applied	\N	\N	\N	\N	40064	40064	40065
11125	11693	4	applied	\N	\N	\N	\N	39974	39974	39975
11125	11683	5	applied	\N	\N	\N	\N	39923	39923	39924
11125	11685	6	applied	\N	\N	\N	\N	39929	39929	39930
11125	11724	7	applied	\N	\N	\N	\N	40066	40066	40067
11125	11725	8	applied	\N	\N	\N	\N	40068	40068	40069
11125	11726	9	applied	\N	\N	\N	\N	40070	40070	40071
11125	11727	10	applied	\N	\N	\N	\N	40072	40072	40073
11125	11699	11	applied	\N	\N	\N	\N	39990	39990	39991
11125	11688	12	applied	\N	\N	\N	\N	39937	39937	39938
11125	11689	13	applied	\N	\N	\N	\N	39940	39940	39941
11125	11692	14	applied	\N	\N	\N	\N	39968	39968	39969
11125	11694	15	applied	\N	\N	\N	\N	39976	39976	39977
11125	11697	16	applied	\N	\N	\N	\N	39986	39986	39987
11125	11698	17	applied	\N	\N	\N	\N	39988	39988	39989
11125	11684	18	applied	\N	\N	\N	\N	39925	39925	39926
11125	11686	19	applied	\N	\N	\N	\N	39931	39931	39932
11125	11687	20	applied	\N	\N	\N	\N	39935	39935	39936
11125	11690	21	applied	\N	\N	\N	\N	39942	39942	39943
11125	11691	22	applied	\N	\N	\N	\N	39966	39966	39967
11125	11695	23	applied	\N	\N	\N	\N	39978	39978	39979
11125	11696	24	applied	\N	\N	\N	\N	39984	39984	39985
11125	11700	25	applied	\N	\N	\N	\N	39992	39992	39993
11125	11705	26	applied	\N	\N	\N	\N	40005	40005	40006
11125	11718	27	applied	\N	\N	\N	\N	40042	40042	40043
11125	11703	28	applied	\N	\N	\N	\N	40000	40000	40001
11125	11706	29	applied	\N	\N	\N	\N	40007	40007	40008
11125	11707	30	applied	\N	\N	\N	\N	40012	40012	40013
11125	11708	31	applied	\N	\N	\N	\N	40014	40014	40015
11125	11711	32	applied	\N	\N	\N	\N	40022	40022	40023
11125	11713	33	applied	\N	\N	\N	\N	40028	40028	40029
11125	11715	34	applied	\N	\N	\N	\N	40034	40034	40035
11125	11716	35	applied	\N	\N	\N	\N	40038	40038	40039
11125	11719	36	applied	\N	\N	\N	\N	40048	40048	40049
11125	11721	37	applied	\N	\N	\N	\N	40060	40060	40061
11125	11728	38	applied	\N	\N	\N	\N	40076	40076	40077
11125	11731	39	applied	\N	\N	\N	\N	40082	40082	40083
11125	11734	40	applied	\N	\N	\N	\N	40112	40112	40113
11125	11735	41	applied	\N	\N	\N	\N	40114	40114	40115
11125	11736	42	applied	\N	\N	1000000000	\N	40116	40116	40117
11125	11737	43	applied	\N	\N	\N	\N	40120	40120	40121
11125	11740	44	applied	\N	\N	1000000000	\N	40136	40136	40137
11125	11741	45	applied	\N	\N	\N	\N	40138	40138	40139
11125	11701	46	applied	\N	\N	\N	\N	39994	39994	39995
11125	11702	47	applied	\N	\N	\N	\N	39998	39998	39999
11125	11704	48	applied	\N	\N	\N	\N	40003	40003	40004
11125	11743	49	applied	\N	\N	\N	\N	40142	40142	40143
11125	11745	50	applied	\N	\N	\N	\N	40150	40150	40151
11125	11746	51	applied	\N	\N	\N	\N	40152	40152	40153
11125	11750	52	applied	\N	\N	\N	\N	40165	40165	40166
11125	11751	53	applied	\N	\N	\N	\N	40167	40167	40168
11125	11753	54	applied	\N	\N	\N	\N	40174	40174	40175
11125	11754	55	applied	\N	\N	\N	\N	40177	40177	40178
11125	11757	56	applied	\N	\N	\N	\N	40187	40187	40188
11125	11709	57	applied	\N	\N	\N	\N	40016	40016	40017
11125	11710	58	applied	\N	\N	\N	\N	40018	40018	40019
11125	11712	59	applied	\N	\N	\N	\N	40024	40024	40025
11125	11714	60	applied	\N	\N	\N	\N	40032	40032	40033
11125	11717	61	applied	\N	\N	\N	\N	40040	40040	40041
11125	11720	62	applied	\N	\N	\N	\N	40050	40050	40051
11125	11722	63	applied	\N	\N	\N	\N	40062	40062	40063
11125	11729	64	applied	\N	\N	\N	\N	40078	40078	40079
11125	11730	65	applied	\N	\N	\N	\N	40080	40080	40081
11125	11732	66	applied	\N	\N	\N	\N	40108	40108	40109
11125	11733	67	applied	\N	\N	\N	\N	40110	40110	40111
11125	11738	68	applied	\N	\N	\N	\N	40123	40123	40124
11125	11739	69	applied	\N	\N	\N	\N	40134	40134	40135
11125	11742	70	applied	\N	\N	\N	\N	40140	40140	40141
11125	11744	71	applied	\N	\N	\N	\N	40148	40148	40149
11125	11747	72	applied	\N	\N	\N	\N	40154	40154	40155
11125	11748	73	applied	\N	\N	\N	\N	40161	40161	40162
11125	11749	74	applied	\N	\N	\N	\N	40163	40163	40164
11125	11752	75	applied	\N	\N	\N	\N	40172	40172	40173
11125	11755	76	applied	\N	\N	\N	\N	40179	40179	40180
11125	11756	77	applied	\N	\N	\N	\N	40185	40185	40186
11128	11758	0	applied	\N	\N	\N	\N	40190	40190	40191
11128	11759	1	applied	\N	\N	\N	\N	40192	40192	40193
11132	11764	0	applied	\N	\N	\N	\N	40218	40218	40219
11132	11765	1	applied	\N	\N	\N	\N	40220	40220	40221
11137	11768	0	applied	\N	\N	\N	\N	40228	40228	40229
11137	11769	1	applied	\N	\N	\N	\N	40230	40230	40231
11137	11770	2	applied	\N	\N	\N	\N	40232	40232	40233
11137	11771	3	applied	\N	\N	\N	\N	40234	40234	40235
11137	11772	4	applied	\N	\N	\N	\N	40236	40236	40237
11137	11773	5	applied	\N	\N	\N	\N	40238	40238	40239
11139	11774	0	applied	\N	\N	\N	\N	40244	40244	40245
11139	11775	1	applied	\N	\N	\N	\N	40246	40246	40247
11142	11776	0	applied	\N	\N	\N	\N	40248	40248	40249
11142	11777	1	applied	\N	\N	\N	\N	40250	40250	40251
11145	11781	0	applied	\N	\N	\N	\N	40263	40263	40264
11145	11782	1	applied	\N	\N	\N	\N	40265	40265	40266
11145	11783	2	applied	\N	\N	\N	\N	40267	40267	40268
11145	11784	3	applied	\N	\N	\N	\N	40269	40269	40270
11151	11787	0	applied	\N	\N	\N	\N	40286	40286	40287
11151	11788	1	applied	\N	\N	\N	\N	40288	40288	40289
11151	11789	2	applied	\N	\N	\N	\N	40290	40290	40291
11151	11790	3	applied	\N	\N	\N	\N	40292	40292	40293
11154	11795	0	applied	\N	\N	\N	\N	40308	40308	40309
11154	11796	1	applied	\N	\N	\N	\N	40310	40310	40311
11173	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11173	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11173	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11173	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11178	11816	0	applied	\N	\N	\N	\N	40366	40366	40367
11131	11701	52	applied	\N	\N	\N	\N	39994	39994	40100
11131	11702	53	applied	\N	\N	\N	\N	39998	39998	40101
11131	11704	54	applied	\N	\N	\N	\N	40003	40003	40102
11131	11637	55	applied	\N	\N	\N	\N	39759	39759	39760
11131	11638	56	applied	\N	\N	\N	\N	39761	39761	39762
11131	11639	57	applied	\N	\N	\N	\N	39763	39763	39764
11131	11641	58	applied	\N	\N	\N	\N	39772	39772	39773
11131	11642	59	applied	\N	\N	\N	\N	39775	39775	39776
11131	11645	60	applied	\N	\N	\N	\N	39781	39781	39782
11131	11647	61	applied	\N	\N	\N	\N	39787	39787	39788
11131	11649	62	applied	\N	\N	\N	\N	39805	39805	39806
11131	11651	63	applied	\N	\N	\N	\N	39815	39815	39816
11131	11653	64	applied	\N	\N	\N	\N	39821	39821	39822
11131	11654	66	applied	\N	\N	\N	\N	39833	39833	39834
11131	11657	67	applied	\N	\N	\N	\N	39841	39841	39842
11131	11658	68	applied	\N	\N	\N	\N	39845	39845	39846
11131	11659	69	applied	\N	\N	\N	\N	39847	39847	39848
11131	11662	70	applied	\N	\N	\N	\N	39855	39855	39856
11131	11663	71	applied	\N	\N	\N	\N	39857	39857	39858
11131	11666	72	applied	\N	\N	\N	\N	39877	39877	39878
11131	11668	73	applied	\N	\N	\N	\N	39881	39881	39882
11131	11669	74	applied	\N	\N	\N	\N	39883	39883	39884
11131	11670	75	applied	\N	\N	\N	\N	39885	39885	39886
11131	11675	76	applied	\N	\N	\N	\N	39898	39898	39899
11131	11676	77	applied	\N	\N	\N	\N	39900	39900	39901
11131	11679	78	applied	\N	\N	\N	\N	39907	39907	39908
11131	11680	79	applied	\N	\N	\N	\N	39913	39913	39914
11131	11683	80	applied	\N	\N	\N	\N	39923	39923	39924
11131	11685	81	applied	\N	\N	\N	\N	39929	39929	39930
11131	11688	82	applied	\N	\N	\N	\N	39937	39937	39938
11131	11689	83	applied	\N	\N	\N	\N	39940	39940	39941
11131	11692	84	applied	\N	\N	\N	\N	39968	39968	39969
11131	11694	85	applied	\N	\N	\N	\N	39976	39976	39977
11131	11697	86	applied	\N	\N	\N	\N	39986	39986	39987
11131	11698	87	applied	\N	\N	\N	\N	39988	39988	39989
11131	11703	88	applied	\N	\N	\N	\N	40000	40000	40001
11131	11706	89	applied	\N	\N	\N	\N	40007	40007	40008
11131	11707	90	applied	\N	\N	\N	\N	40012	40012	40013
11131	11708	91	applied	\N	\N	\N	\N	40014	40014	40015
11131	11711	92	applied	\N	\N	\N	\N	40022	40022	40023
11131	11713	93	applied	\N	\N	\N	\N	40028	40028	40029
11131	11715	94	applied	\N	\N	\N	\N	40034	40034	40035
11131	11716	95	applied	\N	\N	\N	\N	40038	40038	40039
11131	11719	96	applied	\N	\N	\N	\N	40048	40048	40049
11131	11721	97	applied	\N	\N	\N	\N	40060	40060	40061
11131	11728	98	applied	\N	\N	\N	\N	40076	40076	40077
11131	11731	99	applied	\N	\N	\N	\N	40082	40082	40083
11131	11734	100	applied	\N	\N	\N	\N	40112	40112	40113
11131	11735	101	applied	\N	\N	\N	\N	40114	40114	40115
11131	11736	102	applied	\N	\N	1000000000	\N	40116	40116	40117
11131	11737	103	applied	\N	\N	\N	\N	40120	40120	40121
11131	11740	104	applied	\N	\N	1000000000	\N	40136	40136	40137
11131	11741	105	applied	\N	\N	\N	\N	40138	40138	40139
11131	11743	106	applied	\N	\N	\N	\N	40142	40142	40143
11131	11745	107	applied	\N	\N	\N	\N	40150	40150	40151
11131	11746	108	applied	\N	\N	\N	\N	40152	40152	40153
11131	11750	109	applied	\N	\N	\N	\N	40165	40165	40166
11131	11751	110	applied	\N	\N	\N	\N	40167	40167	40168
11131	11753	111	applied	\N	\N	\N	\N	40174	40174	40175
11131	11754	112	applied	\N	\N	\N	\N	40177	40177	40178
11131	11757	113	applied	\N	\N	\N	\N	40187	40187	40188
11131	11758	114	applied	\N	\N	\N	\N	40190	40190	40191
11131	11761	115	applied	\N	\N	\N	\N	40201	40201	40202
11131	11762	116	applied	\N	\N	\N	\N	40203	40203	40204
11131	11709	117	applied	\N	\N	\N	\N	40016	40016	40103
11131	11710	118	applied	\N	\N	\N	\N	40018	40018	40104
11131	11712	119	applied	\N	\N	\N	\N	40024	40024	40105
11131	11714	120	applied	\N	\N	\N	\N	40032	40032	40210
11131	11717	121	applied	\N	\N	\N	\N	40040	40040	40211
11131	11720	122	applied	\N	\N	\N	\N	40050	40050	40212
11131	11722	123	applied	\N	\N	\N	\N	40062	40062	40213
11131	11729	124	applied	\N	\N	\N	\N	40078	40078	40214
11131	11730	125	applied	\N	\N	\N	\N	40080	40080	40215
11133	11766	0	applied	\N	\N	\N	\N	40222	40222	40223
11133	11767	1	applied	\N	\N	\N	\N	40224	40224	40225
11136	11766	0	applied	\N	\N	\N	\N	40222	40222	40223
11136	11767	1	applied	\N	\N	\N	\N	40224	40224	40225
11141	11776	0	applied	\N	\N	\N	\N	40248	40248	40249
11141	11777	1	applied	\N	\N	\N	\N	40250	40250	40251
11143	11778	0	applied	\N	\N	\N	\N	40256	40256	40257
11143	11779	1	applied	\N	\N	\N	\N	40258	40258	40259
11143	11780	2	applied	\N	\N	\N	\N	40260	40260	40261
11146	11781	0	applied	\N	\N	\N	\N	40263	40263	40264
11146	11782	1	applied	\N	\N	\N	\N	40265	40265	40266
11146	11783	2	applied	\N	\N	\N	\N	40267	40267	40268
11146	11784	3	applied	\N	\N	\N	\N	40269	40269	40270
11155	11795	0	applied	\N	\N	\N	\N	40308	40308	40309
11155	11796	1	applied	\N	\N	\N	\N	40310	40310	40311
11165	11810	0	applied	\N	\N	\N	\N	40343	40343	40344
11165	11811	1	applied	\N	\N	\N	\N	40345	40345	40346
11172	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11172	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11172	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11172	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11175	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11175	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11175	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11175	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11177	11537	0	applied	\N	\N	\N	\N	39460	39460	39461
11177	11550	1	applied	\N	\N	\N	\N	39497	39497	39498
11177	11551	2	applied	\N	\N	\N	\N	39499	39499	39500
11177	11568	3	applied	\N	\N	\N	\N	39553	39553	39554
11177	11468	4	applied	\N	\N	\N	\N	39242	39242	39243
11177	11479	5	applied	\N	\N	\N	\N	39268	39268	39269
11177	11480	6	applied	\N	\N	\N	\N	39270	39270	39271
11177	11481	7	applied	\N	\N	\N	\N	39272	39272	39273
11177	11547	8	applied	\N	\N	\N	\N	39489	39489	39490
11177	11607	9	applied	\N	\N	\N	\N	39791	39791	39791
11177	11614	10	applied	\N	\N	\N	\N	39792	39792	39701
11177	11615	11	applied	\N	\N	\N	\N	39793	39793	39703
11177	11616	12	applied	\N	\N	\N	\N	39794	39794	39705
11177	11617	13	applied	\N	\N	\N	\N	39795	39795	39707
11177	11469	14	applied	\N	\N	\N	\N	39244	39244	39245
11177	11457	15	applied	\N	\N	\N	\N	39219	39219	39220
11177	11458	16	applied	\N	\N	\N	\N	39221	39221	39222
11177	11459	17	applied	\N	\N	\N	\N	39223	39223	39224
11177	11460	18	applied	\N	\N	\N	\N	39225	39225	39226
11177	11682	19	applied	\N	\N	\N	\N	40089	40089	39922
11177	11723	20	applied	\N	\N	\N	\N	40064	40064	40065
11140	11777	1	applied	\N	\N	\N	\N	40250	40250	40251
11149	11785	0	applied	\N	\N	\N	\N	40278	40278	40279
11149	11786	1	applied	\N	\N	\N	\N	40280	40280	40281
11152	11791	0	applied	\N	\N	\N	\N	40296	40296	40297
11152	11792	1	applied	\N	\N	\N	\N	40298	40298	40299
11164	11808	0	applied	\N	\N	\N	\N	40337	40337	40338
11164	11809	1	applied	\N	\N	\N	\N	40339	40339	40340
11171	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11171	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11171	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11171	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11174	11812	0	applied	\N	\N	\N	\N	40349	40349	40350
11174	11813	1	applied	\N	\N	\N	\N	40351	40351	40352
11174	11814	2	applied	\N	\N	\N	\N	40353	40353	40354
11174	11815	3	applied	\N	\N	\N	\N	40355	40355	40356
11181	11820	0	applied	\N	\N	\N	\N	40376	40376	40377
11181	11821	1	applied	\N	\N	\N	\N	40378	40378	40379
11181	11822	2	applied	\N	\N	\N	\N	40380	40380	40381
11181	11823	3	applied	\N	\N	\N	\N	40382	40382	40383
11185	11824	0	applied	\N	\N	\N	\N	40390	40390	40391
11185	11825	1	applied	\N	\N	\N	\N	40392	40392	40393
11188	11824	0	applied	\N	\N	\N	\N	40390	40390	40391
11188	11825	1	applied	\N	\N	\N	\N	40392	40392	40393
11190	11826	0	applied	\N	\N	\N	\N	40396	40396	40397
11190	11827	1	applied	\N	\N	\N	\N	40398	40398	40399
11190	11828	2	applied	\N	\N	\N	\N	40400	40400	40401
11200	11841	0	applied	\N	\N	\N	\N	40436	40436	40437
11200	11842	1	applied	\N	\N	\N	\N	40438	40438	40439
11202	11845	0	applied	\N	\N	\N	\N	40448	40448	40449
11202	11846	1	applied	\N	\N	1000000000	\N	40450	40450	40451
11202	11847	2	applied	\N	\N	\N	\N	40452	40452	40453
11205	11848	0	applied	\N	\N	1000000000	\N	40458	40458	40459
11205	11849	1	applied	\N	\N	\N	\N	40460	40460	40461
11205	11850	2	applied	\N	\N	\N	\N	40462	40462	40463
11205	11851	3	applied	\N	\N	\N	\N	40464	40464	40465
11205	11852	4	applied	\N	\N	\N	\N	40466	40466	40467
11205	11853	5	applied	\N	\N	\N	\N	40468	40468	40137
11209	11858	0	applied	\N	\N	\N	\N	40482	40482	40483
11209	11859	1	applied	\N	\N	\N	\N	40484	40484	40485
11213	11866	0	applied	\N	\N	\N	\N	40502	40502	40503
11213	11867	1	applied	\N	\N	\N	\N	40504	40504	40505
11213	11868	2	applied	\N	\N	\N	\N	40506	40506	40507
11213	11869	3	applied	\N	\N	\N	\N	40508	40508	40509
11213	11870	4	applied	\N	\N	\N	\N	40510	40510	40511
11213	11871	5	applied	\N	\N	\N	\N	40512	40512	40513
11213	11872	6	applied	\N	\N	\N	\N	40514	40514	40515
11213	11873	7	applied	\N	\N	\N	\N	40516	40516	40517
11213	11874	8	applied	\N	\N	\N	\N	40518	40518	40519
11213	11875	9	applied	\N	\N	\N	\N	40520	40520	40521
11221	11889	0	applied	\N	\N	\N	\N	40561	40561	40562
11221	11890	1	applied	\N	\N	\N	\N	40563	40563	40564
11224	11893	0	applied	\N	\N	\N	\N	40571	40571	40572
11224	11894	1	applied	\N	\N	\N	\N	40573	40573	40574
11224	11895	2	applied	\N	\N	\N	\N	40575	40575	40576
11224	11896	3	applied	\N	\N	\N	\N	40577	40577	40578
11226	11899	0	applied	\N	\N	\N	\N	40588	40588	40589
11226	11900	1	applied	\N	\N	\N	\N	40590	40590	40591
11230	11906	0	applied	\N	\N	\N	\N	40606	40606	40607
11230	11907	1	applied	\N	\N	\N	\N	40608	40608	40609
11230	11908	2	applied	\N	\N	\N	\N	40610	40610	40611
11230	11909	3	applied	\N	\N	\N	\N	40612	40612	40613
11230	11910	4	applied	\N	\N	\N	\N	40614	40614	40615
11235	11911	0	applied	\N	\N	\N	\N	40622	40622	40623
11235	11912	1	applied	\N	\N	\N	\N	40624	40624	40625
11235	11913	2	applied	\N	\N	\N	\N	40626	40626	40627
11235	11914	3	applied	\N	\N	\N	\N	40628	40628	40629
11235	11915	4	applied	\N	\N	\N	\N	40630	40630	40631
11235	11916	5	applied	\N	\N	\N	\N	40632	40632	40633
11237	11917	0	applied	\N	\N	\N	\N	40639	40639	40640
11237	11918	1	applied	\N	\N	\N	\N	40641	40641	40642
11239	11917	0	applied	\N	\N	\N	\N	40639	40639	40640
11239	11918	1	applied	\N	\N	\N	\N	40641	40641	40642
11245	11934	0	applied	\N	\N	\N	\N	40685	40685	40686
11245	11935	1	applied	\N	\N	\N	\N	40687	40687	40688
11245	11936	2	applied	\N	\N	\N	\N	40689	40689	40690
11245	11937	3	applied	\N	\N	\N	\N	40691	40691	40692
11247	11934	0	applied	\N	\N	\N	\N	40685	40685	40686
11247	11935	1	applied	\N	\N	\N	\N	40687	40687	40688
11247	11936	2	applied	\N	\N	\N	\N	40689	40689	40690
11247	11937	3	applied	\N	\N	\N	\N	40691	40691	40692
11249	11938	0	applied	\N	\N	\N	\N	40698	40698	40699
11249	11939	1	applied	\N	\N	\N	\N	40700	40700	40701
11249	11940	2	applied	\N	\N	\N	\N	40702	40702	40703
11249	11941	3	applied	\N	\N	\N	\N	40704	40704	40705
11249	11942	4	applied	\N	\N	\N	\N	40706	40706	40707
11252	11958	0	applied	\N	\N	\N	\N	40744	40744	40745
11252	11959	1	applied	\N	\N	\N	\N	40746	40746	40747
11252	11960	2	applied	\N	\N	\N	\N	40748	40748	40749
11252	11961	3	applied	\N	\N	\N	\N	40750	40750	40751
11252	11962	4	applied	\N	\N	\N	\N	40752	40752	40753
11252	11963	5	applied	\N	\N	\N	\N	40754	40754	40755
11252	11964	6	applied	\N	\N	\N	\N	40756	40756	40757
11259	11981	0	applied	\N	\N	\N	\N	40798	40798	40799
11259	11982	1	applied	\N	\N	\N	\N	40800	40800	40801
11259	11983	2	applied	\N	\N	\N	\N	40802	40802	40803
11259	11984	3	applied	\N	\N	\N	\N	40804	40804	40805
11259	11985	4	applied	\N	\N	\N	\N	40806	40806	40807
11259	11986	5	applied	\N	\N	\N	\N	40808	40808	40809
11259	11987	6	applied	\N	\N	\N	\N	40810	40810	40811
11259	11988	7	applied	\N	\N	\N	\N	40812	40812	40813
11259	11989	8	applied	\N	\N	\N	\N	40814	40814	40815
11259	11990	9	applied	\N	\N	\N	\N	40816	40816	40817
11259	11991	10	applied	\N	\N	\N	\N	40818	40818	40819
11259	11992	11	applied	\N	\N	\N	\N	40820	40820	40821
11259	11993	12	applied	\N	\N	\N	\N	40822	40822	40823
11259	11994	13	applied	\N	\N	\N	\N	40824	40824	40825
11259	11995	14	applied	\N	\N	\N	\N	40826	40826	40827
11259	11996	15	applied	\N	\N	\N	\N	40828	40828	40829
11259	11997	16	applied	\N	\N	\N	\N	40830	40830	40831
11259	11998	17	applied	\N	\N	\N	\N	40832	40832	40833
11259	11999	18	applied	\N	\N	\N	\N	40834	40834	40835
11259	12000	19	applied	\N	\N	\N	\N	40836	40836	40837
11259	12001	20	applied	\N	\N	\N	\N	40838	40838	40839
11259	12002	21	applied	\N	\N	\N	\N	40840	40840	40841
11259	12003	22	applied	\N	\N	\N	\N	40842	40842	40843
11259	12004	23	applied	\N	\N	\N	\N	40844	40844	40845
11265	12012	0	applied	\N	\N	\N	\N	40867	40867	40868
11265	12013	1	applied	\N	\N	\N	\N	40869	40869	40870
11265	12014	2	applied	\N	\N	\N	\N	40871	40871	40872
11177	11693	21	applied	\N	\N	\N	\N	40090	40090	39975
11177	11438	22	applied	\N	\N	\N	\N	39167	39167	39168
11177	11440	23	applied	\N	\N	\N	\N	39174	39174	39175
11177	11441	24	applied	\N	\N	\N	\N	39176	39176	39177
11177	11724	25	applied	\N	\N	\N	\N	40066	40066	40067
11177	11725	26	applied	\N	\N	\N	\N	40068	40068	40069
11177	11502	27	applied	\N	\N	\N	\N	39335	39335	39336
11177	11511	28	applied	\N	\N	\N	\N	39358	39358	39359
11177	11512	29	applied	\N	\N	\N	\N	39361	39361	39362
11177	11726	30	applied	\N	\N	\N	\N	40070	40070	40071
11177	11727	31	applied	\N	\N	\N	\N	40072	40072	40073
11177	11442	32	applied	\N	\N	\N	\N	39178	39178	39179
11177	11447	33	applied	\N	\N	\N	\N	39193	39193	39194
11177	11699	34	applied	\N	\N	\N	\N	40091	40091	39991
11177	11449	35	applied	\N	\N	\N	\N	39198	39198	39199
11177	11632	36	applied	\N	\N	1000000000	\N	39749	39749	39949
11177	11493	37	applied	\N	\N	\N	\N	39309	39309	39310
11177	11494	38	applied	\N	\N	\N	\N	39311	39311	39312
11177	11495	39	applied	\N	\N	\N	\N	39313	39313	39314
11177	11443	40	applied	\N	\N	\N	\N	39180	39180	39181
11177	11450	41	applied	\N	\N	\N	\N	39201	39201	39202
11177	11612	42	applied	\N	\N	\N	\N	39688	39688	39950
11177	11631	43	applied	\N	\N	\N	\N	39796	39796	39951
11177	11453	44	applied	\N	\N	\N	\N	39207	39207	39208
11177	11466	45	applied	\N	\N	\N	\N	39237	39237	39238
11177	11470	46	applied	\N	\N	\N	\N	39246	39246	39247
11177	11497	47	applied	\N	\N	\N	\N	39317	39317	39318
11177	11439	48	applied	\N	\N	\N	\N	39169	39169	39170
11177	11700	49	applied	\N	\N	\N	\N	40092	40092	39993
11177	11705	50	applied	\N	\N	\N	\N	40093	40093	40006
11177	11718	51	applied	\N	\N	\N	\N	40094	40094	40043
11177	11515	52	applied	\N	\N	\N	\N	39375	39375	39376
11177	11444	53	applied	\N	\N	\N	\N	39182	39182	39183
11177	11445	54	applied	\N	\N	\N	\N	39184	39184	39185
11177	11446	55	applied	\N	\N	\N	\N	39186	39186	39187
11177	11448	56	applied	\N	\N	\N	\N	39196	39196	39197
11177	11451	57	applied	\N	\N	\N	\N	39203	39203	39204
11177	11452	58	applied	\N	\N	\N	\N	39205	39205	39206
11177	11454	59	applied	\N	\N	\N	\N	39209	39209	39210
11177	11455	60	applied	\N	\N	\N	\N	39213	39213	39214
11177	11461	61	applied	\N	\N	\N	\N	39227	39227	39228
11177	11463	62	applied	\N	\N	\N	\N	39231	39231	39232
11177	11465	63	applied	\N	\N	\N	\N	39235	39235	39236
11177	11471	64	applied	\N	\N	\N	\N	39248	39248	39249
11177	11474	65	applied	\N	\N	\N	\N	39254	39254	39255
11177	11475	66	applied	\N	\N	\N	\N	39258	39258	39259
11177	11476	67	applied	\N	\N	\N	\N	39260	39260	39261
11177	11483	68	applied	\N	\N	\N	\N	39276	39276	39277
11177	11486	69	applied	\N	\N	\N	\N	39285	39285	39286
11177	11488	70	applied	\N	\N	\N	\N	39290	39290	39291
11177	11489	71	applied	\N	\N	\N	\N	39294	39294	39295
11177	11491	72	applied	\N	\N	\N	\N	39303	39303	39304
11177	11498	73	applied	\N	\N	\N	\N	39319	39319	39320
11177	11500	74	applied	\N	\N	\N	\N	39329	39329	39330
11177	11505	75	applied	\N	\N	\N	\N	39341	39341	39342
11177	11506	76	applied	\N	\N	\N	\N	39343	39343	39344
11177	11507	77	applied	\N	\N	\N	\N	39345	39345	39346
11177	11508	78	applied	\N	\N	\N	\N	39349	39349	39350
11177	11510	79	applied	\N	\N	\N	\N	39356	39356	39357
11177	11518	80	applied	\N	\N	\N	\N	39382	39382	39383
11177	11519	81	applied	\N	\N	\N	\N	39396	39396	39397
11177	11521	82	applied	\N	\N	\N	\N	39403	39403	39404
11177	11524	83	applied	\N	\N	\N	\N	39411	39411	39412
11177	11526	84	applied	\N	\N	\N	\N	39420	39420	39421
11177	11528	85	applied	\N	\N	\N	\N	39430	39430	39431
11177	11529	86	applied	\N	\N	\N	\N	39434	39434	39435
11177	11533	87	applied	\N	\N	\N	\N	39444	39444	39445
11177	11534	88	applied	\N	\N	\N	\N	39446	39446	39447
11177	11535	89	applied	\N	\N	\N	\N	39448	39448	39449
11177	11540	90	applied	\N	\N	\N	\N	39466	39466	39467
11177	11541	91	applied	\N	\N	\N	\N	39468	39468	39469
11177	11542	92	applied	\N	\N	\N	\N	39474	39474	39475
11177	11545	93	applied	\N	\N	\N	\N	39481	39481	39482
11177	11549	94	applied	\N	\N	\N	\N	39493	39493	39494
11177	11552	95	applied	\N	\N	\N	\N	39501	39501	39502
11177	11553	96	applied	\N	\N	\N	\N	39503	39503	39504
11177	11558	97	applied	\N	\N	\N	\N	39517	39517	39518
11177	11559	98	applied	\N	\N	\N	\N	39525	39525	39526
11177	11561	99	applied	\N	\N	\N	\N	39534	39534	39535
11177	11562	100	applied	\N	\N	\N	\N	39537	39537	39538
11177	11565	101	applied	\N	\N	\N	\N	39544	39544	39545
11177	11567	102	applied	\N	\N	\N	\N	39549	39549	39550
11177	11569	103	applied	\N	\N	\N	\N	39555	39555	39556
11177	11572	104	applied	\N	\N	\N	\N	39562	39562	39563
11177	11573	105	applied	\N	\N	\N	\N	39566	39566	39567
11177	11576	106	applied	\N	\N	\N	\N	39578	39578	39579
11177	11578	107	applied	\N	\N	\N	\N	39588	39588	39589
11177	11582	109	applied	\N	\N	\N	\N	39598	39598	39599
11177	11583	110	applied	\N	\N	\N	\N	39600	39600	39601
11177	11584	111	applied	\N	\N	\N	\N	39602	39602	39603
11177	11588	112	applied	\N	\N	\N	\N	39612	39612	39613
11177	11589	113	applied	\N	\N	\N	\N	39614	39614	39615
11177	11592	114	applied	\N	\N	\N	\N	39624	39624	39625
11177	11593	115	applied	\N	\N	\N	\N	39626	39626	39627
11177	11596	116	applied	\N	\N	\N	\N	39640	39640	39641
11177	11597	117	applied	\N	\N	\N	\N	39642	39642	39643
11177	11598	118	applied	\N	\N	\N	\N	39646	39646	39647
11177	11601	119	applied	\N	\N	\N	\N	39654	39654	39655
11177	11603	120	applied	\N	\N	\N	\N	39668	39668	39669
11177	11605	121	applied	\N	\N	\N	\N	39673	39673	39674
11177	11608	122	applied	\N	\N	\N	\N	39680	39680	39681
11177	11611	123	applied	\N	\N	\N	\N	39686	39686	39687
11177	11613	124	applied	\N	\N	\N	\N	39696	39696	39697
11177	11619	125	applied	\N	\N	\N	\N	39710	39710	39711
11179	11816	0	applied	\N	\N	\N	\N	40366	40366	40367
11179	11817	1	applied	\N	\N	\N	\N	40368	40368	40369
11179	11818	2	applied	\N	\N	\N	\N	40370	40370	40371
11179	11819	3	applied	\N	\N	\N	\N	40372	40372	40373
11182	11820	0	applied	\N	\N	\N	\N	40376	40376	40377
11182	11821	1	applied	\N	\N	\N	\N	40378	40378	40379
11182	11822	2	applied	\N	\N	\N	\N	40380	40380	40381
11182	11823	3	applied	\N	\N	\N	\N	40382	40382	40383
11186	11824	0	applied	\N	\N	\N	\N	40390	40390	40391
11186	11825	1	applied	\N	\N	\N	\N	40392	40392	40393
11197	11835	0	applied	\N	\N	\N	\N	40423	40423	40424
11197	11836	1	applied	\N	\N	\N	\N	40425	40425	40426
11203	11845	0	applied	\N	\N	\N	\N	40448	40448	40449
11203	11846	1	applied	\N	\N	1000000000	\N	40450	40450	40451
11203	11847	2	applied	\N	\N	\N	\N	40452	40452	40453
11178	11817	1	applied	\N	\N	\N	\N	40368	40368	40369
11178	11818	2	applied	\N	\N	\N	\N	40370	40370	40371
11178	11819	3	applied	\N	\N	\N	\N	40372	40372	40373
11180	11816	0	applied	\N	\N	\N	\N	40366	40366	40367
11180	11817	1	applied	\N	\N	\N	\N	40368	40368	40369
11180	11818	2	applied	\N	\N	\N	\N	40370	40370	40371
11180	11819	3	applied	\N	\N	\N	\N	40372	40372	40373
11184	11820	0	applied	\N	\N	\N	\N	40376	40376	40377
11184	11821	1	applied	\N	\N	\N	\N	40378	40378	40379
11184	11822	2	applied	\N	\N	\N	\N	40380	40380	40381
11184	11823	3	applied	\N	\N	\N	\N	40382	40382	40383
11187	11824	0	applied	\N	\N	\N	\N	40390	40390	40391
11187	11825	1	applied	\N	\N	\N	\N	40392	40392	40393
11191	11829	0	applied	\N	\N	\N	\N	40404	40404	40405
11191	11830	1	applied	\N	\N	\N	\N	40406	40406	40407
11193	11831	0	applied	\N	\N	\N	\N	40410	40410	40411
11193	11832	1	applied	\N	\N	\N	\N	40412	40412	40413
11195	11831	0	applied	\N	\N	\N	\N	40410	40410	40411
11195	11832	1	applied	\N	\N	\N	\N	40412	40412	40413
11198	11837	0	applied	\N	\N	\N	\N	40427	40427	40428
11198	11838	1	applied	\N	\N	\N	\N	40429	40429	40430
11198	11839	2	applied	\N	\N	\N	\N	40431	40431	40432
11198	11840	3	applied	\N	\N	\N	\N	40433	40433	40434
11207	11848	0	applied	\N	\N	1000000000	\N	40458	40458	40459
11207	11849	1	applied	\N	\N	\N	\N	40460	40460	40461
11207	11850	2	applied	\N	\N	\N	\N	40462	40462	40463
11207	11851	3	applied	\N	\N	\N	\N	40464	40464	40465
11207	11852	4	applied	\N	\N	\N	\N	40466	40466	40467
11207	11853	5	applied	\N	\N	\N	\N	40468	40468	40137
11208	11854	0	applied	\N	\N	\N	\N	40473	40473	40474
11208	11855	1	applied	\N	\N	\N	\N	40475	40475	40476
11208	11856	2	applied	\N	\N	\N	\N	40477	40477	40478
11208	11857	3	applied	\N	\N	\N	\N	40479	40479	40480
11217	11881	0	applied	\N	\N	\N	\N	40539	40539	40540
11217	11882	1	applied	\N	\N	\N	\N	40541	40541	40542
11217	11883	2	applied	\N	\N	\N	\N	40543	40543	40544
11217	11884	3	applied	\N	\N	\N	\N	40545	40545	40546
11220	11887	0	applied	\N	\N	\N	\N	40554	40554	40555
11220	11888	1	applied	\N	\N	\N	\N	40556	40556	40557
11222	11891	0	applied	\N	\N	\N	\N	40567	40567	40568
11222	11892	1	applied	\N	\N	\N	\N	40569	40569	40570
11225	11897	0	applied	\N	\N	\N	\N	40582	40582	40583
11225	11898	1	applied	\N	\N	\N	\N	40584	40584	40585
11228	11901	0	applied	\N	\N	\N	\N	40592	40592	40593
11228	11902	1	applied	\N	\N	\N	\N	40594	40594	40595
11228	11903	2	applied	\N	\N	\N	\N	40596	40596	40597
11228	11904	3	applied	\N	\N	\N	\N	40598	40598	40599
11228	11905	4	applied	\N	\N	\N	\N	40600	40600	40601
11233	11911	0	applied	\N	\N	\N	\N	40622	40622	40623
11233	11912	1	applied	\N	\N	\N	\N	40624	40624	40625
11233	11913	2	applied	\N	\N	\N	\N	40626	40626	40627
11233	11914	3	applied	\N	\N	\N	\N	40628	40628	40629
11233	11915	4	applied	\N	\N	\N	\N	40630	40630	40631
11233	11916	5	applied	\N	\N	\N	\N	40632	40632	40633
11238	11917	0	applied	\N	\N	\N	\N	40639	40639	40640
11238	11918	1	applied	\N	\N	\N	\N	40641	40641	40642
11240	11919	0	applied	\N	\N	\N	\N	40649	40649	40650
11240	11920	1	applied	\N	\N	\N	\N	40651	40651	40652
11240	11921	2	applied	\N	\N	\N	\N	40653	40653	40654
11243	11928	0	applied	\N	\N	\N	\N	40670	40670	40671
11243	11929	1	applied	\N	\N	\N	\N	40672	40672	40673
11248	11938	0	applied	\N	\N	\N	\N	40698	40698	40699
11248	11939	1	applied	\N	\N	\N	\N	40700	40700	40701
11248	11940	2	applied	\N	\N	\N	\N	40702	40702	40703
11248	11941	3	applied	\N	\N	\N	\N	40704	40704	40705
11248	11942	4	applied	\N	\N	\N	\N	40706	40706	40707
11251	11943	0	applied	\N	\N	\N	\N	40712	40712	40713
11251	11944	1	applied	\N	\N	\N	\N	40714	40714	40715
11251	11945	2	applied	\N	\N	\N	\N	40716	40716	40717
11251	11946	3	applied	\N	\N	\N	\N	40718	40718	40719
11251	11947	4	applied	\N	\N	\N	\N	40720	40720	40721
11251	11948	5	applied	\N	\N	\N	\N	40722	40722	40723
11251	11949	6	applied	\N	\N	\N	\N	40724	40724	40725
11251	11950	7	applied	\N	\N	\N	\N	40726	40726	40727
11251	11951	8	applied	\N	\N	\N	\N	40728	40728	40729
11251	11952	9	applied	\N	\N	\N	\N	40730	40730	40731
11251	11953	10	applied	\N	\N	\N	\N	40732	40732	40733
11251	11954	11	applied	\N	\N	\N	\N	40734	40734	40735
11251	11955	12	applied	\N	\N	\N	\N	40736	40736	40737
11251	11956	13	applied	\N	\N	\N	\N	40738	40738	40739
11251	11957	14	applied	\N	\N	\N	\N	40740	40740	40741
11253	11965	0	applied	\N	\N	\N	\N	40760	40760	40761
11253	11966	1	applied	\N	\N	\N	\N	40762	40762	40763
11253	11967	2	applied	\N	\N	\N	\N	40764	40764	40765
11253	11968	3	applied	\N	\N	\N	\N	40766	40766	40767
11253	11969	4	applied	\N	\N	\N	\N	40768	40768	40769
11253	11970	5	applied	\N	\N	\N	\N	40770	40770	40771
11253	11971	6	applied	\N	\N	\N	\N	40772	40772	40773
11253	11972	7	applied	\N	\N	\N	\N	40774	40774	40775
11260	11981	0	applied	\N	\N	\N	\N	40798	40798	40799
11260	11982	1	applied	\N	\N	\N	\N	40800	40800	40801
11260	11983	2	applied	\N	\N	\N	\N	40802	40802	40803
11260	11984	3	applied	\N	\N	\N	\N	40804	40804	40805
11260	11985	4	applied	\N	\N	\N	\N	40806	40806	40807
11260	11986	5	applied	\N	\N	\N	\N	40808	40808	40809
11260	11987	6	applied	\N	\N	\N	\N	40810	40810	40811
11260	11988	7	applied	\N	\N	\N	\N	40812	40812	40813
11260	11989	8	applied	\N	\N	\N	\N	40814	40814	40815
11260	11990	9	applied	\N	\N	\N	\N	40816	40816	40817
11260	11991	10	applied	\N	\N	\N	\N	40818	40818	40819
11260	11992	11	applied	\N	\N	\N	\N	40820	40820	40821
11260	11993	12	applied	\N	\N	\N	\N	40822	40822	40823
11260	11994	13	applied	\N	\N	\N	\N	40824	40824	40825
11260	11995	14	applied	\N	\N	\N	\N	40826	40826	40827
11260	11996	15	applied	\N	\N	\N	\N	40828	40828	40829
11260	11997	16	applied	\N	\N	\N	\N	40830	40830	40831
11260	11998	17	applied	\N	\N	\N	\N	40832	40832	40833
11260	11999	18	applied	\N	\N	\N	\N	40834	40834	40835
11260	12000	19	applied	\N	\N	\N	\N	40836	40836	40837
11260	12001	20	applied	\N	\N	\N	\N	40838	40838	40839
11260	12002	21	applied	\N	\N	\N	\N	40840	40840	40841
11260	12003	22	applied	\N	\N	\N	\N	40842	40842	40843
11260	12004	23	applied	\N	\N	\N	\N	40844	40844	40845
11269	12066	0	applied	\N	\N	\N	\N	40981	40981	40982
11269	12067	1	applied	\N	\N	\N	\N	40983	40983	40984
11269	12068	2	applied	\N	\N	\N	\N	40985	40985	40986
11269	12069	3	applied	\N	\N	\N	\N	40987	40987	40988
11269	12070	4	applied	\N	\N	\N	\N	40989	40989	40990
11269	12071	5	applied	\N	\N	\N	\N	40991	40991	40992
11269	12072	6	applied	\N	\N	\N	\N	40993	40993	40994
11204	11850	2	applied	\N	\N	\N	\N	40462	40462	40463
11204	11851	3	applied	\N	\N	\N	\N	40464	40464	40465
11204	11852	4	applied	\N	\N	\N	\N	40466	40466	40467
11204	11853	5	applied	\N	\N	\N	\N	40468	40468	40137
11211	11863	0	applied	\N	\N	\N	\N	40495	40495	34093
11211	11864	1	applied	\N	\N	\N	\N	40496	40496	40497
11211	11865	2	applied	\N	\N	\N	\N	40498	40498	40499
11215	11876	0	applied	\N	\N	\N	\N	40524	40524	40525
11215	11877	1	applied	\N	\N	\N	\N	40526	40526	40527
11215	11878	2	applied	\N	\N	\N	\N	40528	40528	40529
11218	11885	0	applied	\N	\N	\N	\N	40549	40549	40550
11218	11886	1	applied	\N	\N	\N	\N	40551	40551	40552
11223	11893	0	applied	\N	\N	\N	\N	40571	40571	40572
11223	11894	1	applied	\N	\N	\N	\N	40573	40573	40574
11223	11895	2	applied	\N	\N	\N	\N	40575	40575	40576
11223	11896	3	applied	\N	\N	\N	\N	40577	40577	40578
11229	11906	0	applied	\N	\N	\N	\N	40606	40606	40607
11229	11907	1	applied	\N	\N	\N	\N	40608	40608	40609
11229	11908	2	applied	\N	\N	\N	\N	40610	40610	40611
11229	11909	3	applied	\N	\N	\N	\N	40612	40612	40613
11229	11910	4	applied	\N	\N	\N	\N	40614	40614	40615
11231	11906	0	applied	\N	\N	\N	\N	40606	40606	40607
11231	11907	1	applied	\N	\N	\N	\N	40608	40608	40609
11231	11908	2	applied	\N	\N	\N	\N	40610	40610	40611
11231	11909	3	applied	\N	\N	\N	\N	40612	40612	40613
11231	11910	4	applied	\N	\N	\N	\N	40614	40614	40615
11234	11911	0	applied	\N	\N	\N	\N	40622	40622	40623
11234	11912	1	applied	\N	\N	\N	\N	40624	40624	40625
11234	11913	2	applied	\N	\N	\N	\N	40626	40626	40627
11234	11914	3	applied	\N	\N	\N	\N	40628	40628	40629
11234	11915	4	applied	\N	\N	\N	\N	40630	40630	40631
11234	11916	5	applied	\N	\N	\N	\N	40632	40632	40633
11236	11917	0	applied	\N	\N	\N	\N	40639	40639	40640
11236	11918	1	applied	\N	\N	\N	\N	40641	40641	40642
11241	11922	0	applied	\N	\N	\N	\N	40657	40657	40658
11241	11923	1	applied	\N	\N	\N	\N	40659	40659	40660
11241	11924	2	applied	\N	\N	\N	\N	40661	40661	40662
11241	11925	3	applied	\N	\N	\N	\N	40663	40663	40664
11241	11926	4	applied	\N	\N	\N	\N	40665	40665	40666
11241	11927	5	applied	\N	\N	\N	\N	40667	40667	40668
11244	11930	0	applied	\N	\N	\N	\N	40676	40676	40677
11244	11931	1	applied	\N	\N	\N	\N	40678	40678	40679
11244	11932	2	applied	\N	\N	\N	\N	40680	40680	40681
11244	11933	3	applied	\N	\N	\N	\N	40682	40682	40683
11254	11973	0	applied	\N	\N	\N	\N	40778	40778	40779
11254	11974	1	applied	\N	\N	\N	\N	40780	40780	40781
11254	11975	2	applied	\N	\N	\N	\N	40782	40782	40783
11254	11976	3	applied	\N	\N	\N	\N	40784	40784	40785
11254	11977	4	applied	\N	\N	\N	\N	40786	40786	40787
11254	11978	5	applied	\N	\N	\N	\N	40788	40788	40789
11254	11979	6	applied	\N	\N	\N	\N	40790	40790	40791
11254	11980	7	applied	\N	\N	\N	\N	40792	40792	40793
11261	12005	0	applied	\N	\N	\N	\N	40850	40850	40851
11261	12006	1	applied	\N	\N	\N	\N	40852	40852	40853
11261	12007	2	applied	\N	\N	\N	\N	40854	40854	40855
11261	12008	3	applied	\N	\N	\N	\N	40856	40856	40857
11261	12009	4	applied	\N	\N	\N	\N	40858	40858	40859
11261	12010	5	applied	\N	\N	\N	\N	40860	40860	40861
11261	12011	6	applied	\N	\N	\N	\N	40862	40862	40863
11263	12012	0	applied	\N	\N	\N	\N	40867	40867	40868
11263	12013	1	applied	\N	\N	\N	\N	40869	40869	40870
11263	12014	2	applied	\N	\N	\N	\N	40871	40871	40872
11263	12015	3	applied	\N	\N	\N	\N	40873	40873	40874
11263	12016	4	applied	\N	\N	\N	\N	40875	40875	40876
11263	12017	5	applied	\N	\N	\N	\N	40877	40877	40878
11263	12018	6	applied	\N	\N	\N	\N	40879	40879	40880
11263	12019	7	applied	\N	\N	\N	\N	40881	40881	40882
11263	12020	8	applied	\N	\N	\N	\N	40883	40883	40884
11263	12021	9	applied	\N	\N	\N	\N	40885	40885	40886
11274	12074	0	applied	\N	\N	\N	\N	41002	41002	41003
11274	12075	1	applied	\N	\N	\N	\N	41004	41004	41005
11281	12087	0	applied	\N	\N	\N	\N	41047	41047	41048
11281	12088	2	applied	\N	\N	\N	\N	41050	41050	41051
11281	12089	3	applied	\N	\N	\N	\N	41052	41052	41053
11281	12090	4	applied	\N	\N	\N	\N	41054	41054	41055
11285	12091	0	applied	\N	\N	\N	\N	41065	41065	41066
11285	12092	1	applied	\N	\N	\N	\N	41067	41067	41068
11287	12095	0	applied	\N	\N	\N	\N	41080	41080	41081
11287	12096	1	applied	\N	\N	\N	\N	41082	41082	41083
11292	12099	0	applied	\N	\N	\N	\N	41094	41094	41095
11292	12100	1	applied	\N	\N	\N	\N	41096	41096	41097
11295	12109	0	applied	\N	\N	\N	\N	41119	41119	41120
11295	12110	1	applied	\N	\N	\N	\N	41121	41121	41122
11298	12109	0	applied	\N	\N	\N	\N	41119	41119	41120
11298	12110	1	applied	\N	\N	\N	\N	41121	41121	41122
11300	12111	0	applied	\N	\N	\N	\N	41130	41130	41131
11307	12117	0	applied	\N	\N	\N	\N	41153	41153	41154
11307	12116	1	applied	\N	\N	\N	\N	41149	41149	41150
11309	12119	0	applied	\N	\N	\N	\N	41159	41159	41160
11309	12120	1	applied	\N	\N	\N	\N	41161	41161	41162
11309	12121	2	applied	\N	\N	\N	\N	41163	41163	41164
11311	12122	0	applied	\N	\N	\N	\N	41168	41168	41169
11311	12123	1	applied	\N	\N	\N	\N	41170	41170	41171
11324	12131	0	applied	\N	\N	\N	\N	41205	41205	41206
11324	12132	1	applied	\N	\N	\N	\N	41207	41207	41208
11326	12133	0	applied	\N	\N	\N	\N	41211	41211	41212
11326	12134	1	applied	\N	\N	\N	\N	41213	41213	41214
11334	12150	0	applied	\N	\N	\N	\N	41256	41256	41257
11334	12151	1	applied	\N	\N	\N	\N	41258	41258	41259
11344	12162	0	applied	\N	\N	\N	\N	41295	41295	41296
11344	12163	1	applied	\N	\N	\N	\N	41297	41297	41298
11344	12164	2	applied	\N	\N	\N	\N	41299	41299	41300
11344	12165	3	applied	\N	\N	\N	\N	41301	41301	41302
11344	12166	4	applied	\N	\N	\N	\N	41303	41303	41304
11344	12167	5	applied	\N	\N	\N	\N	41305	41305	41306
11347	12170	0	applied	\N	\N	\N	\N	41316	41316	41317
11347	12171	1	applied	\N	\N	\N	\N	41318	41318	41319
11347	12172	2	applied	\N	\N	\N	\N	41320	41320	41321
11347	12173	3	applied	\N	\N	\N	\N	41322	41322	41323
11349	12174	0	applied	\N	\N	\N	\N	41328	41328	41329
11349	12175	1	applied	\N	\N	\N	\N	41330	41330	41331
11356	12179	0	applied	\N	\N	\N	\N	41350	41350	41351
11356	12180	1	applied	\N	\N	\N	\N	41352	41352	41353
11358	12181	0	applied	\N	\N	\N	\N	41357	41357	41358
11367	12200	0	applied	\N	\N	\N	\N	41410	41410	41411
11367	12201	1	applied	\N	\N	\N	\N	41412	41412	41413
11372	12210	0	applied	\N	\N	\N	\N	41439	41439	41440
11372	12211	1	applied	\N	\N	\N	\N	41441	41441	41442
11375	12218	0	applied	\N	\N	\N	\N	41457	41457	41458
11375	12219	1	applied	\N	\N	\N	\N	41459	41459	41460
11206	11848	0	applied	\N	\N	1000000000	\N	40458	40458	40459
11206	11849	1	applied	\N	\N	\N	\N	40460	40460	40461
11206	11850	2	applied	\N	\N	\N	\N	40462	40462	40463
11206	11851	3	applied	\N	\N	\N	\N	40464	40464	40465
11206	11852	4	applied	\N	\N	\N	\N	40466	40466	40467
11206	11853	5	applied	\N	\N	\N	\N	40468	40468	40137
11210	11860	0	applied	\N	\N	\N	\N	40488	40488	26424
11210	11861	1	applied	\N	\N	\N	\N	40489	40489	40490
11210	11862	2	applied	\N	\N	\N	\N	40491	40491	40492
11212	11863	0	applied	\N	\N	\N	\N	40495	40495	34093
11212	11864	1	applied	\N	\N	\N	\N	40496	40496	40497
11212	11865	2	applied	\N	\N	\N	\N	40498	40498	40499
11214	11876	0	applied	\N	\N	\N	\N	40524	40524	40525
11214	11877	1	applied	\N	\N	\N	\N	40526	40526	40527
11214	11878	2	applied	\N	\N	\N	\N	40528	40528	40529
11216	11879	0	applied	\N	\N	\N	\N	40533	40533	40534
11216	11880	1	applied	\N	\N	\N	\N	40535	40535	40536
11219	11887	0	applied	\N	\N	\N	\N	40554	40554	40555
11219	11888	1	applied	\N	\N	\N	\N	40556	40556	40557
11227	11901	0	applied	\N	\N	\N	\N	40592	40592	40593
11227	11902	1	applied	\N	\N	\N	\N	40594	40594	40595
11227	11903	2	applied	\N	\N	\N	\N	40596	40596	40597
11227	11904	3	applied	\N	\N	\N	\N	40598	40598	40599
11227	11905	4	applied	\N	\N	\N	\N	40600	40600	40601
11232	11906	0	applied	\N	\N	\N	\N	40606	40606	40607
11232	11907	1	applied	\N	\N	\N	\N	40608	40608	40609
11232	11908	2	applied	\N	\N	\N	\N	40610	40610	40611
11232	11909	3	applied	\N	\N	\N	\N	40612	40612	40613
11232	11910	4	applied	\N	\N	\N	\N	40614	40614	40615
11246	11934	0	applied	\N	\N	\N	\N	40685	40685	40686
11246	11935	1	applied	\N	\N	\N	\N	40687	40687	40688
11246	11936	2	applied	\N	\N	\N	\N	40689	40689	40690
11246	11937	3	applied	\N	\N	\N	\N	40691	40691	40692
11250	11943	0	applied	\N	\N	\N	\N	40712	40712	40713
11250	11944	1	applied	\N	\N	\N	\N	40714	40714	40715
11250	11945	2	applied	\N	\N	\N	\N	40716	40716	40717
11250	11946	3	applied	\N	\N	\N	\N	40718	40718	40719
11250	11947	4	applied	\N	\N	\N	\N	40720	40720	40721
11250	11948	5	applied	\N	\N	\N	\N	40722	40722	40723
11250	11949	6	applied	\N	\N	\N	\N	40724	40724	40725
11250	11950	7	applied	\N	\N	\N	\N	40726	40726	40727
11250	11951	8	applied	\N	\N	\N	\N	40728	40728	40729
11250	11952	9	applied	\N	\N	\N	\N	40730	40730	40731
11250	11953	10	applied	\N	\N	\N	\N	40732	40732	40733
11250	11954	11	applied	\N	\N	\N	\N	40734	40734	40735
11250	11955	12	applied	\N	\N	\N	\N	40736	40736	40737
11250	11956	13	applied	\N	\N	\N	\N	40738	40738	40739
11250	11957	14	applied	\N	\N	\N	\N	40740	40740	40741
11262	12005	0	applied	\N	\N	\N	\N	40850	40850	40851
11262	12006	1	applied	\N	\N	\N	\N	40852	40852	40853
11262	12007	2	applied	\N	\N	\N	\N	40854	40854	40855
11262	12008	3	applied	\N	\N	\N	\N	40856	40856	40857
11262	12009	4	applied	\N	\N	\N	\N	40858	40858	40859
11262	12010	5	applied	\N	\N	\N	\N	40860	40860	40861
11262	12011	6	applied	\N	\N	\N	\N	40862	40862	40863
11266	12023	0	applied	\N	\N	\N	\N	40892	40892	40893
11266	12024	1	applied	\N	\N	\N	\N	40894	40894	40895
11266	12025	2	applied	\N	\N	\N	\N	40896	40896	40897
11266	12026	3	applied	\N	\N	\N	\N	40898	40898	40899
11266	12027	4	applied	\N	\N	\N	\N	40900	40900	40901
11266	12028	5	applied	\N	\N	\N	\N	40902	40902	40903
11266	12029	6	applied	\N	\N	\N	\N	40904	40904	40905
11266	12030	7	applied	\N	\N	\N	\N	40906	40906	40907
11266	12031	8	applied	\N	\N	\N	\N	40908	40908	40909
11266	12032	9	applied	\N	\N	\N	\N	40910	40910	40911
11266	12033	10	applied	\N	\N	\N	\N	40912	40912	40913
11266	12034	11	applied	\N	\N	\N	\N	40914	40914	40915
11266	12035	12	applied	\N	\N	\N	\N	40916	40916	40917
11266	12036	13	applied	\N	\N	\N	\N	40918	40918	40919
11266	12037	14	applied	\N	\N	\N	\N	40920	40920	40921
11266	12038	15	applied	\N	\N	\N	\N	40922	40922	40923
11266	12039	16	applied	\N	\N	\N	\N	40924	40924	40925
11266	12040	17	applied	\N	\N	\N	\N	40926	40926	40927
11266	12041	18	applied	\N	\N	\N	\N	40928	40928	40929
11266	12042	19	applied	\N	\N	\N	\N	40930	40930	40931
11266	12043	20	applied	\N	\N	\N	\N	40932	40932	40933
11266	12044	21	applied	\N	\N	\N	\N	40934	40934	40935
11266	12045	22	applied	\N	\N	\N	\N	40936	40936	40937
11266	12046	23	applied	\N	\N	\N	\N	40938	40938	40939
11266	12047	24	applied	\N	\N	\N	\N	40940	40940	40941
11266	12048	25	applied	\N	\N	\N	\N	40942	40942	40943
11266	12049	26	applied	\N	\N	\N	\N	40944	40944	40945
11266	12050	27	applied	\N	\N	\N	\N	40946	40946	40947
11266	12051	28	applied	\N	\N	\N	\N	40948	40948	40949
11266	12052	29	applied	\N	\N	\N	\N	40950	40950	40951
11266	12053	30	applied	\N	\N	\N	\N	40952	40952	40953
11266	12054	31	applied	\N	\N	\N	\N	40954	40954	40955
11266	12055	32	applied	\N	\N	\N	\N	40956	40956	40957
11266	12056	33	applied	\N	\N	\N	\N	40958	40958	40959
11266	12057	34	applied	\N	\N	\N	\N	40960	40960	40961
11266	12058	35	applied	\N	\N	\N	\N	40962	40962	40963
11271	12066	0	applied	\N	\N	\N	\N	40981	40981	40982
11271	12072	1	applied	\N	\N	\N	\N	40993	40993	40994
11271	12073	2	applied	\N	\N	\N	\N	40995	40995	40996
11275	12076	0	applied	\N	\N	\N	\N	41011	41011	41012
11284	12091	0	applied	\N	\N	\N	\N	41065	41065	41066
11284	12092	1	applied	\N	\N	\N	\N	41067	41067	41068
11286	12093	0	applied	\N	\N	\N	\N	41074	41074	41075
11286	12094	1	applied	\N	\N	\N	\N	41076	41076	41077
11293	12101	0	applied	\N	\N	\N	\N	41100	41100	41101
11293	12102	1	applied	\N	\N	\N	\N	41102	41102	41103
11293	12103	2	applied	\N	\N	\N	\N	41104	41104	41105
11293	12104	3	applied	\N	\N	\N	\N	41106	41106	41107
11297	12109	0	applied	\N	\N	\N	\N	41119	41119	41120
11297	12110	1	applied	\N	\N	\N	\N	41121	41121	41122
11303	12112	0	applied	\N	\N	\N	\N	41137	41137	41138
11303	12113	1	applied	\N	\N	\N	\N	41139	41139	41140
11305	12114	0	applied	\N	\N	\N	\N	41144	41144	41145
11305	12115	1	applied	\N	\N	\N	\N	41146	41146	41147
11313	12122	0	applied	\N	\N	\N	\N	41168	41168	41169
11313	12123	1	applied	\N	\N	\N	\N	41170	41170	41171
11315	12124	0	applied	\N	\N	\N	\N	41178	41178	41179
11315	12125	1	applied	\N	\N	\N	\N	41180	41180	41181
11318	12126	0	applied	\N	\N	\N	\N	41186	41186	41187
11318	12127	1	applied	\N	\N	\N	\N	41188	41188	41189
11321	12128	0	applied	\N	\N	\N	\N	41193	41193	41194
11321	12129	1	applied	\N	\N	\N	\N	41195	41195	41196
11327	12134	0	applied	\N	\N	\N	\N	41213	41213	41214
11330	12139	0	applied	\N	\N	\N	\N	41228	41228	41229
11330	12140	1	applied	\N	\N	\N	\N	41230	41230	41231
11265	12015	3	applied	\N	\N	\N	\N	40873	40873	40874
11265	12016	4	applied	\N	\N	\N	\N	40875	40875	40876
11265	12017	5	applied	\N	\N	\N	\N	40877	40877	40878
11265	12018	6	applied	\N	\N	\N	\N	40879	40879	40880
11265	12019	7	applied	\N	\N	\N	\N	40881	40881	40882
11265	12022	8	applied	\N	\N	\N	\N	40889	40889	40890
11265	12020	9	applied	\N	\N	\N	\N	40883	40883	40884
11265	12021	10	applied	\N	\N	\N	\N	40885	40885	40886
11267	12059	0	applied	\N	\N	\N	\N	40966	40966	40967
11267	12060	1	applied	\N	\N	\N	\N	40968	40968	40969
11267	12061	2	applied	\N	\N	\N	\N	40970	40970	40971
11267	12062	3	applied	\N	\N	\N	\N	40972	40972	40973
11267	12063	4	applied	\N	\N	\N	\N	40974	40974	40975
11267	12064	5	applied	\N	\N	\N	\N	40976	40976	40977
11267	12065	6	applied	\N	\N	\N	\N	40978	40978	40979
11270	12066	0	applied	\N	\N	\N	\N	40981	40981	40982
11270	12067	1	applied	\N	\N	\N	\N	40983	40983	40984
11270	12068	2	applied	\N	\N	\N	\N	40985	40985	40986
11270	12069	3	applied	\N	\N	\N	\N	40987	40987	40988
11270	12070	4	applied	\N	\N	\N	\N	40989	40989	40990
11270	12071	5	applied	\N	\N	\N	\N	40991	40991	40992
11270	12072	6	applied	\N	\N	\N	\N	40993	40993	40994
11270	12073	7	applied	\N	\N	\N	\N	40995	40995	40996
11272	12074	0	applied	\N	\N	\N	\N	41002	41002	41003
11272	12075	1	applied	\N	\N	\N	\N	41004	41004	41005
11277	12085	0	applied	\N	\N	\N	\N	41031	41031	41032
11277	12086	1	applied	\N	\N	\N	\N	41033	41033	41034
11279	11848	0	applied	\N	\N	1000000000	\N	40458	40458	40459
11279	11723	1	applied	\N	\N	\N	\N	40064	40064	40065
11279	11693	2	applied	\N	\N	\N	\N	39974	39974	39975
11279	11938	3	applied	\N	\N	\N	\N	41038	41038	40699
11279	11683	4	applied	\N	\N	\N	\N	39923	39923	39924
11279	11685	5	applied	\N	\N	\N	\N	39929	39929	39930
11279	11939	6	applied	\N	\N	\N	\N	41039	41039	40701
11279	11690	7	applied	\N	\N	\N	\N	39942	39942	40096
11279	11691	8	applied	\N	\N	\N	\N	39966	39966	40097
11279	11695	9	applied	\N	\N	\N	\N	39978	39978	40098
11279	11696	10	applied	\N	\N	\N	\N	39984	39984	40099
11279	11724	11	applied	\N	\N	\N	\N	40066	40066	40067
11279	11725	12	applied	\N	\N	\N	\N	40068	40068	40069
11279	12078	13	applied	\N	\N	\N	\N	41016	41016	41017
11279	11726	14	applied	\N	\N	\N	\N	40070	40070	40071
11279	11727	15	applied	\N	\N	\N	\N	40072	40072	40073
11279	11699	16	applied	\N	\N	\N	\N	39990	39990	39991
11279	12080	17	applied	\N	\N	\N	\N	41020	41020	41021
11279	11688	18	applied	\N	\N	\N	\N	39937	39937	39938
11279	11689	19	applied	\N	\N	\N	\N	39940	39940	39941
11279	11692	20	applied	\N	\N	\N	\N	39968	39968	39969
11279	11694	21	applied	\N	\N	\N	\N	39976	39976	39977
11279	11697	22	applied	\N	\N	\N	\N	39986	39986	39987
11279	11698	23	applied	\N	\N	\N	\N	39988	39988	39989
11279	11941	24	applied	\N	\N	\N	\N	41040	41040	40705
11279	11943	25	applied	\N	\N	\N	\N	41041	41041	40713
11279	11945	26	applied	\N	\N	\N	\N	41042	41042	40717
11279	12081	27	applied	\N	\N	\N	\N	41022	41022	41023
11279	12082	28	applied	\N	\N	\N	\N	41024	41024	41025
11279	11700	29	applied	\N	\N	\N	\N	39992	39992	39993
11279	11705	30	applied	\N	\N	\N	\N	40005	40005	40006
11279	11718	31	applied	\N	\N	\N	\N	40042	40042	40043
11279	11703	32	applied	\N	\N	\N	\N	40000	40000	40001
11279	11706	33	applied	\N	\N	\N	\N	40007	40007	40008
11279	11707	34	applied	\N	\N	\N	\N	40012	40012	40013
11279	11708	35	applied	\N	\N	\N	\N	40014	40014	40015
11279	11711	36	applied	\N	\N	\N	\N	40022	40022	40023
11279	11713	37	applied	\N	\N	\N	\N	40028	40028	40029
11279	11715	38	applied	\N	\N	\N	\N	40034	40034	40035
11279	11716	39	applied	\N	\N	\N	\N	40038	40038	40039
11279	11719	40	applied	\N	\N	\N	\N	40048	40048	40049
11279	11721	41	applied	\N	\N	\N	\N	40060	40060	40061
11279	11728	42	applied	\N	\N	\N	\N	40076	40076	40077
11279	11731	43	applied	\N	\N	\N	\N	40082	40082	40083
11279	11734	44	applied	\N	\N	\N	\N	40112	40112	40113
11279	11735	45	applied	\N	\N	\N	\N	40114	40114	40115
11279	11736	46	applied	\N	\N	1000000000	\N	40116	40116	40117
11279	11737	48	applied	\N	\N	\N	\N	40120	40120	40121
11279	11740	49	applied	\N	\N	1000000000	\N	40136	40136	40137
11279	11741	50	applied	\N	\N	\N	\N	40138	40138	40139
11279	11701	51	applied	\N	\N	\N	\N	39994	39994	40100
11279	11702	52	applied	\N	\N	\N	\N	39998	39998	40101
11279	11704	53	applied	\N	\N	\N	\N	40003	40003	40102
11279	11743	54	applied	\N	\N	\N	\N	40142	40142	40143
11279	11745	55	applied	\N	\N	\N	\N	40150	40150	40151
11279	11746	56	applied	\N	\N	\N	\N	40152	40152	40153
11279	11750	57	applied	\N	\N	\N	\N	40165	40165	40166
11279	11751	58	applied	\N	\N	\N	\N	40167	40167	40168
11279	11753	59	applied	\N	\N	\N	\N	40174	40174	40175
11279	11754	60	applied	\N	\N	\N	\N	40177	40177	40178
11279	11757	61	applied	\N	\N	\N	\N	40187	40187	40188
11279	11758	62	applied	\N	\N	\N	\N	40190	40190	40191
11279	11761	63	applied	\N	\N	\N	\N	40201	40201	40202
11279	11762	64	applied	\N	\N	\N	\N	40203	40203	40204
11279	11765	65	applied	\N	\N	\N	\N	40220	40220	40221
11279	11767	66	applied	\N	\N	\N	\N	40224	40224	40225
11279	11768	67	applied	\N	\N	\N	\N	40228	40228	40229
11279	11769	68	applied	\N	\N	\N	\N	40230	40230	40231
11279	11773	69	applied	\N	\N	\N	\N	40238	40238	40239
11279	11775	70	applied	\N	\N	\N	\N	40246	40246	40247
11279	11776	71	applied	\N	\N	\N	\N	40248	40248	40249
11279	11780	72	applied	\N	\N	\N	\N	40260	40260	40261
11279	11781	73	applied	\N	\N	\N	\N	40263	40263	40264
11279	11782	74	applied	\N	\N	\N	\N	40265	40265	40266
11279	11785	75	applied	\N	\N	\N	\N	40278	40278	40279
11279	11788	76	applied	\N	\N	\N	\N	40288	40288	40289
11279	11789	77	applied	\N	\N	\N	\N	40290	40290	40291
11279	11791	78	applied	\N	\N	\N	\N	40296	40296	40297
11279	11794	79	applied	\N	\N	\N	\N	40304	40304	40305
11279	11796	80	applied	\N	\N	\N	\N	40310	40310	40311
11279	11798	81	applied	\N	\N	\N	\N	40314	40314	40315
11279	11799	82	applied	\N	\N	\N	\N	40316	40316	40317
11279	11800	83	applied	\N	\N	\N	\N	40319	40319	40320
11283	12091	0	applied	\N	\N	\N	\N	41065	41065	41066
11283	12092	1	applied	\N	\N	\N	\N	41067	41067	41068
11288	12095	0	applied	\N	\N	\N	\N	41080	41080	41081
11288	12096	1	applied	\N	\N	\N	\N	41082	41082	41083
11290	12097	0	applied	\N	\N	\N	\N	41088	41088	41089
11290	12098	1	applied	\N	\N	\N	\N	41090	41090	41091
11296	12109	0	applied	\N	\N	\N	\N	41119	41119	41120
11296	12110	1	applied	\N	\N	\N	\N	41121	41121	41122
11301	12111	0	applied	\N	\N	\N	\N	41130	41130	41131
11269	12073	7	applied	\N	\N	\N	\N	40995	40995	40996
11273	12074	0	applied	\N	\N	\N	\N	41002	41002	41003
11273	12075	1	applied	\N	\N	\N	\N	41004	41004	41005
11276	12077	0	applied	\N	\N	\N	\N	41014	41014	41015
11276	12078	1	applied	\N	\N	\N	\N	41016	41016	41017
11276	12079	2	applied	\N	\N	\N	\N	41018	41018	41019
11276	12080	3	applied	\N	\N	\N	\N	41020	41020	41021
11276	12081	4	applied	\N	\N	\N	\N	41022	41022	41023
11276	12082	5	applied	\N	\N	\N	\N	41024	41024	41025
11276	12083	6	applied	\N	\N	\N	\N	41026	41026	41027
11276	12084	7	applied	\N	\N	\N	\N	41028	41028	41029
11278	12085	0	applied	\N	\N	\N	\N	41031	41031	41032
11278	12086	1	applied	\N	\N	\N	\N	41033	41033	41034
11280	12087	0	applied	\N	\N	\N	\N	41047	41047	41048
11280	12088	2	applied	\N	\N	\N	\N	41050	41050	41051
11280	12089	3	applied	\N	\N	\N	\N	41052	41052	41053
11280	12090	4	applied	\N	\N	\N	\N	41054	41054	41055
11282	12087	0	applied	\N	\N	\N	\N	41047	41047	41048
11282	12088	2	applied	\N	\N	\N	\N	41050	41050	41051
11282	12089	3	applied	\N	\N	\N	\N	41052	41052	41053
11282	12090	4	applied	\N	\N	\N	\N	41054	41054	41055
11289	12097	0	applied	\N	\N	\N	\N	41088	41088	41089
11289	12098	1	applied	\N	\N	\N	\N	41090	41090	41091
11291	12099	0	applied	\N	\N	\N	\N	41094	41094	41095
11291	12100	1	applied	\N	\N	\N	\N	41096	41096	41097
11294	12105	0	applied	\N	\N	\N	\N	41110	41110	41111
11294	12106	1	applied	\N	\N	\N	\N	41112	41112	41113
11294	12107	2	applied	\N	\N	\N	\N	41114	41114	41115
11294	12108	3	applied	\N	\N	\N	\N	41116	41116	41117
11302	12111	0	applied	\N	\N	\N	\N	41130	41130	41131
11304	12112	0	applied	\N	\N	\N	\N	41137	41137	41138
11304	12113	1	applied	\N	\N	\N	\N	41139	41139	41140
11306	12116	0	applied	\N	\N	\N	\N	41149	41149	41150
11308	12118	0	applied	\N	\N	\N	\N	41157	41157	41158
11316	12125	0	applied	\N	\N	\N	\N	41180	41180	41181
11319	12126	0	applied	\N	\N	\N	\N	41186	41186	41187
11319	12127	1	applied	\N	\N	\N	\N	41188	41188	41189
11323	12130	0	applied	\N	\N	\N	\N	41201	41201	41202
11328	12133	0	applied	\N	\N	\N	\N	41211	41211	41212
11328	12135	1	applied	\N	\N	\N	\N	41219	41219	41220
11328	12136	2	applied	\N	\N	\N	\N	41221	41221	41222
11331	12139	0	applied	\N	\N	\N	\N	41228	41228	41229
11331	12140	1	applied	\N	\N	\N	\N	41230	41230	41231
11336	12150	0	applied	\N	\N	\N	\N	41256	41256	41257
11336	12151	1	applied	\N	\N	\N	\N	41258	41258	41259
11339	12152	0	applied	\N	\N	\N	\N	41265	41265	41266
11339	12153	1	applied	\N	\N	\N	\N	41267	41267	41268
11339	12154	2	applied	\N	\N	\N	\N	41269	41269	41270
11339	12155	3	applied	\N	\N	\N	\N	41271	41271	41272
11346	12168	0	applied	\N	\N	\N	\N	41311	41311	41312
11346	12169	1	applied	\N	\N	\N	\N	41313	41313	41314
11359	12181	0	applied	\N	\N	\N	\N	41357	41357	41358
11360	12182	0	applied	\N	\N	\N	\N	41364	41364	41365
11360	12183	1	applied	\N	\N	\N	\N	41366	41366	41367
11360	12184	2	applied	\N	\N	\N	\N	41368	41368	41369
11360	12185	3	applied	\N	\N	\N	\N	41370	41370	41371
11360	12186	4	applied	\N	\N	\N	\N	41372	41372	41373
11360	12187	5	applied	\N	\N	\N	\N	41374	41374	41375
11360	12188	6	applied	\N	\N	\N	\N	41376	41376	41377
11360	12189	7	applied	\N	\N	\N	\N	41378	41378	41379
11360	12190	8	applied	\N	\N	\N	\N	41380	41380	41381
11360	12191	9	applied	\N	\N	\N	\N	41382	41382	41383
11362	12192	0	applied	\N	\N	\N	\N	41388	41388	41389
11362	12193	1	applied	\N	\N	\N	\N	41390	41390	41391
11365	12196	0	applied	\N	\N	\N	\N	41399	41399	41400
11365	12197	1	applied	\N	\N	\N	\N	41401	41401	41402
11365	12198	2	applied	\N	\N	\N	\N	41403	41403	41404
11365	12199	3	applied	\N	\N	\N	\N	41405	41405	41406
11368	12202	0	applied	\N	\N	\N	\N	41417	41417	41418
11368	12203	1	applied	\N	\N	\N	\N	41419	41419	41420
11368	12204	2	applied	\N	\N	\N	\N	41421	41421	41422
11368	12205	3	applied	\N	\N	\N	\N	41423	41423	41424
11368	12206	4	applied	\N	\N	\N	\N	41425	41425	41426
11368	12207	5	applied	\N	\N	\N	\N	41427	41427	41428
11370	12208	0	applied	\N	\N	\N	\N	41432	41432	41433
11370	12209	1	applied	\N	\N	\N	\N	41434	41434	41435
11373	12212	0	applied	\N	\N	\N	\N	41444	41444	41445
11373	12213	1	applied	\N	\N	\N	\N	41446	41446	41447
11373	12214	2	applied	\N	\N	\N	\N	41448	41448	41449
11373	12215	3	applied	\N	\N	\N	\N	41450	41450	41451
11376	12218	0	applied	\N	\N	\N	\N	41457	41457	41458
11376	12219	1	applied	\N	\N	\N	\N	41459	41459	41460
11379	12220	0	applied	\N	\N	\N	\N	41465	41465	41466
11379	12221	1	applied	\N	\N	\N	\N	41467	41467	41468
11379	12222	2	applied	\N	\N	\N	\N	41469	41469	41470
11379	12223	3	applied	\N	\N	\N	\N	41471	41471	41472
11380	12224	0	applied	\N	\N	\N	\N	41477	41477	41478
11380	12225	1	applied	\N	\N	\N	\N	41479	41479	41480
11383	12226	0	applied	\N	\N	\N	\N	41483	41483	41484
11383	12227	1	applied	\N	\N	\N	\N	41485	41485	41486
11385	12228	0	applied	\N	\N	\N	\N	41492	41492	41493
11385	12229	1	applied	\N	\N	\N	\N	41494	41494	41495
11387	12230	0	applied	\N	\N	\N	\N	41499	41499	41500
11390	12231	0	applied	\N	\N	\N	\N	41503	41503	41504
11390	12232	2	applied	\N	\N	\N	\N	41506	41506	41507
11390	12233	3	applied	\N	\N	\N	\N	41508	41508	41509
11390	12234	4	applied	\N	\N	\N	\N	41510	41510	41511
11397	12237	0	applied	\N	\N	\N	\N	41525	41525	41526
11397	12238	1	applied	\N	\N	\N	\N	41527	41527	41528
11398	12239	0	applied	\N	\N	\N	\N	41532	41532	41533
11404	12248	0	applied	\N	\N	\N	\N	41559	41559	41560
11404	12249	1	applied	\N	\N	\N	\N	41561	41561	41562
11409	12262	0	applied	\N	\N	\N	\N	41595	41595	41596
11409	12263	1	applied	\N	\N	\N	\N	41597	41597	41598
11409	12264	2	applied	\N	\N	1000000000	\N	41599	41599	41600
11414	12267	0	applied	\N	\N	\N	\N	41609	41609	41610
11416	12268	0	applied	\N	\N	\N	\N	41616	41616	41617
11416	12269	1	applied	\N	\N	\N	\N	41618	41618	41619
11418	12270	0	applied	\N	\N	\N	\N	41622	41622	41623
11418	12271	1	applied	\N	\N	\N	\N	41624	41624	41625
11421	12274	0	applied	\N	\N	\N	\N	41635	41635	41636
11421	12275	1	applied	\N	\N	\N	\N	41637	41637	41638
11421	12276	2	applied	\N	\N	\N	\N	41639	41639	41640
11421	12277	3	applied	\N	\N	\N	\N	41641	41641	41642
11423	12278	0	applied	\N	\N	\N	\N	41647	41647	41648
11423	12279	1	applied	\N	\N	\N	\N	41649	41649	41650
11426	12087	0	applied	\N	\N	\N	\N	41658	41658	41048
11426	12088	1	applied	\N	\N	\N	\N	41659	41659	41051
11426	12077	2	applied	\N	\N	\N	\N	41014	41014	41015
11426	12078	3	applied	\N	\N	\N	\N	41016	41016	41017
11310	12119	0	applied	\N	\N	\N	\N	41159	41159	41160
11310	12120	1	applied	\N	\N	\N	\N	41161	41161	41162
11310	12121	2	applied	\N	\N	\N	\N	41163	41163	41164
11312	12122	0	applied	\N	\N	\N	\N	41168	41168	41169
11312	12123	1	applied	\N	\N	\N	\N	41170	41170	41171
11314	12124	0	applied	\N	\N	\N	\N	41178	41178	41179
11314	12125	1	applied	\N	\N	\N	\N	41180	41180	41181
11320	12128	0	applied	\N	\N	\N	\N	41193	41193	41194
11320	12129	1	applied	\N	\N	\N	\N	41195	41195	41196
11322	12130	0	applied	\N	\N	\N	\N	41201	41201	41202
11325	12131	0	applied	\N	\N	\N	\N	41205	41205	41206
11325	12132	1	applied	\N	\N	\N	\N	41207	41207	41208
11329	12137	0	applied	\N	\N	\N	\N	41224	41224	41225
11329	12138	1	applied	\N	\N	\N	\N	41226	41226	41227
11332	12141	0	applied	\N	\N	\N	\N	41235	41235	41236
11332	12142	1	applied	\N	\N	\N	\N	41237	41237	41238
11332	12143	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41239	41239	\N
11332	12144	3	applied	\N	\N	\N	\N	41240	41240	41241
11332	12145	4	applied	\N	\N	\N	\N	41242	41242	41243
11335	12150	0	applied	\N	\N	\N	\N	41256	41256	41257
11335	12151	1	applied	\N	\N	\N	\N	41258	41258	41259
11337	12152	0	applied	\N	\N	\N	\N	41265	41265	41266
11337	12153	1	applied	\N	\N	\N	\N	41267	41267	41268
11337	12154	2	applied	\N	\N	\N	\N	41269	41269	41270
11337	12155	3	applied	\N	\N	\N	\N	41271	41271	41272
11342	12158	0	applied	\N	\N	\N	\N	41285	41285	41286
11342	12159	1	applied	\N	\N	\N	\N	41287	41287	41288
11342	12160	2	applied	\N	\N	\N	\N	41289	41289	41290
11342	12161	3	applied	\N	\N	\N	\N	41291	41291	41292
11345	12162	0	applied	\N	\N	\N	\N	41295	41295	41296
11345	12163	1	applied	\N	\N	\N	\N	41297	41297	41298
11345	12164	2	applied	\N	\N	\N	\N	41299	41299	41300
11345	12165	3	applied	\N	\N	\N	\N	41301	41301	41302
11345	12166	4	applied	\N	\N	\N	\N	41303	41303	41304
11345	12167	5	applied	\N	\N	\N	\N	41305	41305	41306
11348	12170	0	applied	\N	\N	\N	\N	41316	41316	41317
11348	12171	1	applied	\N	\N	\N	\N	41318	41318	41319
11348	12172	2	applied	\N	\N	\N	\N	41320	41320	41321
11348	12173	3	applied	\N	\N	\N	\N	41322	41322	41323
11350	12174	0	applied	\N	\N	\N	\N	41328	41328	41329
11350	12175	1	applied	\N	\N	\N	\N	41330	41330	41331
11352	12176	0	applied	\N	\N	\N	\N	41338	41338	41339
11354	12177	0	applied	\N	\N	\N	\N	41344	41344	41345
11354	12178	1	applied	\N	\N	\N	\N	41346	41346	41347
11364	12196	0	applied	\N	\N	\N	\N	41399	41399	41400
11364	12197	1	applied	\N	\N	\N	\N	41401	41401	41402
11364	12198	2	applied	\N	\N	\N	\N	41403	41403	41404
11364	12199	3	applied	\N	\N	\N	\N	41405	41405	41406
11366	12200	0	applied	\N	\N	\N	\N	41410	41410	41411
11366	12201	1	applied	\N	\N	\N	\N	41412	41412	41413
11374	12216	0	applied	\N	\N	\N	\N	41453	41453	41454
11374	12217	1	applied	\N	\N	\N	\N	41455	41455	41456
11377	12220	0	applied	\N	\N	\N	\N	41465	41465	41466
11377	12221	1	applied	\N	\N	\N	\N	41467	41467	41468
11377	12222	2	applied	\N	\N	\N	\N	41469	41469	41470
11377	12223	3	applied	\N	\N	\N	\N	41471	41471	41472
11382	12226	0	applied	\N	\N	\N	\N	41483	41483	41484
11382	12227	1	applied	\N	\N	\N	\N	41485	41485	41486
11386	12228	0	applied	\N	\N	\N	\N	41492	41492	41493
11386	12229	1	applied	\N	\N	\N	\N	41494	41494	41495
11388	12230	0	applied	\N	\N	\N	\N	41499	41499	41500
11393	12235	0	applied	\N	\N	\N	\N	41517	41517	41518
11393	12236	1	applied	\N	\N	\N	\N	41519	41519	41520
11395	12237	0	applied	\N	\N	\N	\N	41525	41525	41526
11395	12238	1	applied	\N	\N	\N	\N	41527	41527	41528
11400	12242	0	applied	\N	\N	\N	\N	41541	41541	41542
11400	12243	1	applied	\N	\N	\N	\N	41543	41543	41544
11400	12244	2	applied	\N	\N	\N	\N	41545	41545	41546
11400	12245	3	applied	\N	\N	\N	\N	41547	41547	41548
11402	12246	0	applied	\N	\N	\N	\N	41553	41553	41554
11402	12247	1	applied	\N	\N	\N	\N	41555	41555	41556
11405	12250	0	applied	\N	\N	\N	\N	41566	41566	41567
11405	12251	1	applied	\N	\N	\N	\N	41568	41568	41569
11405	12252	2	applied	\N	\N	\N	\N	41570	41570	41571
11405	12253	3	applied	\N	\N	\N	\N	41572	41572	41573
11408	12258	0	applied	\N	\N	\N	\N	41585	41585	41586
11408	12259	1	applied	\N	\N	\N	\N	41587	41587	41588
11408	12260	2	applied	\N	\N	\N	\N	41589	41589	41590
11408	12261	3	applied	\N	\N	\N	\N	41591	41591	41592
11410	12262	0	applied	\N	\N	\N	\N	41595	41595	41596
11410	12263	1	applied	\N	\N	\N	\N	41597	41597	41598
11410	12264	2	applied	\N	\N	1000000000	\N	41599	41599	41600
11415	12267	0	applied	\N	\N	\N	\N	41609	41609	41610
11417	12270	0	applied	\N	\N	\N	\N	41622	41622	41623
11417	12271	1	applied	\N	\N	\N	\N	41624	41624	41625
11422	12274	0	applied	\N	\N	\N	\N	41635	41635	41636
11422	12275	1	applied	\N	\N	\N	\N	41637	41637	41638
11422	12276	2	applied	\N	\N	\N	\N	41639	41639	41640
11422	12277	3	applied	\N	\N	\N	\N	41641	41641	41642
11425	12280	0	applied	\N	\N	\N	\N	41651	41651	41652
11425	12281	1	applied	\N	\N	\N	\N	41653	41653	41654
11429	12282	0	applied	\N	\N	\N	\N	41664	41664	41665
11429	12283	1	applied	\N	\N	\N	\N	41666	41666	41667
11429	12284	2	applied	\N	\N	\N	\N	41668	41668	41669
11429	12285	3	applied	\N	\N	\N	\N	41670	41670	41671
11429	12286	4	applied	\N	\N	\N	\N	41672	41672	41673
11432	12293	0	applied	\N	\N	\N	\N	41691	41691	41692
11432	12294	1	applied	\N	\N	\N	\N	41693	41693	41694
11435	12293	0	applied	\N	\N	\N	\N	41691	41691	41692
11435	12294	1	applied	\N	\N	\N	\N	41693	41693	41694
11442	12304	0	applied	\N	\N	\N	\N	41726	41726	41727
11442	12305	1	applied	\N	\N	\N	\N	41728	41728	41729
11442	12306	2	applied	\N	\N	\N	\N	41733	41733	41734
11442	12307	3	applied	\N	\N	\N	\N	41735	41735	41736
11445	12314	0	applied	\N	\N	\N	\N	41753	41753	41754
11453	12324	0	applied	\N	\N	\N	\N	41783	41783	41784
11453	12325	1	applied	\N	\N	\N	\N	41785	41785	41786
11456	11938	0	applied	\N	\N	\N	\N	40698	40698	40699
11456	11939	1	applied	\N	\N	\N	\N	40700	40700	40701
11456	12078	2	applied	\N	\N	\N	\N	41016	41016	41017
11456	12080	3	applied	\N	\N	\N	\N	41020	41020	41021
11456	11941	4	applied	\N	\N	\N	\N	40704	40704	40705
11456	11943	5	applied	\N	\N	\N	\N	40712	40712	40713
11456	11945	6	applied	\N	\N	\N	\N	40716	40716	40717
11456	12081	7	applied	\N	\N	\N	\N	41022	41022	41023
11456	12082	8	applied	\N	\N	\N	\N	41024	41024	41025
11456	11947	9	applied	\N	\N	\N	\N	40720	40720	40721
11456	11948	10	applied	\N	\N	\N	\N	40722	40722	40723
11456	11949	11	applied	\N	\N	\N	\N	40724	40724	40725
11333	12146	0	applied	\N	\N	\N	\N	41246	41246	41247
11333	12147	1	applied	\N	\N	\N	\N	41248	41248	41249
11333	12148	2	applied	\N	\N	\N	\N	41250	41250	41251
11333	12149	3	applied	\N	\N	\N	\N	41252	41252	41253
11338	12152	0	applied	\N	\N	\N	\N	41265	41265	41266
11338	12153	1	applied	\N	\N	\N	\N	41267	41267	41268
11338	12154	2	applied	\N	\N	\N	\N	41269	41269	41270
11338	12155	3	applied	\N	\N	\N	\N	41271	41271	41272
11340	12156	0	applied	\N	\N	\N	\N	41279	41279	41280
11340	12157	2	applied	\N	\N	\N	\N	41282	41282	41283
11343	12162	0	applied	\N	\N	\N	\N	41295	41295	41296
11343	12163	1	applied	\N	\N	\N	\N	41297	41297	41298
11343	12164	2	applied	\N	\N	\N	\N	41299	41299	41300
11343	12165	3	applied	\N	\N	\N	\N	41301	41301	41302
11343	12166	4	applied	\N	\N	\N	\N	41303	41303	41304
11343	12167	5	applied	\N	\N	\N	\N	41305	41305	41306
11351	12174	0	applied	\N	\N	\N	\N	41328	41328	41329
11351	12175	1	applied	\N	\N	\N	\N	41330	41330	41331
11353	12176	0	applied	\N	\N	\N	\N	41338	41338	41339
11355	12179	0	applied	\N	\N	\N	\N	41350	41350	41351
11355	12180	1	applied	\N	\N	\N	\N	41352	41352	41353
11357	12181	0	applied	\N	\N	\N	\N	41357	41357	41358
11361	12182	0	applied	\N	\N	\N	\N	41364	41364	41365
11361	12183	1	applied	\N	\N	\N	\N	41366	41366	41367
11361	12184	2	applied	\N	\N	\N	\N	41368	41368	41369
11361	12185	3	applied	\N	\N	\N	\N	41370	41370	41371
11361	12186	4	applied	\N	\N	\N	\N	41372	41372	41373
11361	12187	5	applied	\N	\N	\N	\N	41374	41374	41375
11361	12188	6	applied	\N	\N	\N	\N	41376	41376	41377
11361	12189	7	applied	\N	\N	\N	\N	41378	41378	41379
11361	12190	8	applied	\N	\N	\N	\N	41380	41380	41381
11361	12191	9	applied	\N	\N	\N	\N	41382	41382	41383
11363	12194	0	applied	\N	\N	\N	\N	41394	41394	41395
11363	12195	1	applied	\N	\N	\N	\N	41396	41396	41397
11369	12202	0	applied	\N	\N	\N	\N	41417	41417	41418
11369	12203	1	applied	\N	\N	\N	\N	41419	41419	41420
11369	12204	2	applied	\N	\N	\N	\N	41421	41421	41422
11369	12205	3	applied	\N	\N	\N	\N	41423	41423	41424
11369	12206	4	applied	\N	\N	\N	\N	41425	41425	41426
11369	12207	5	applied	\N	\N	\N	\N	41427	41427	41428
11371	12208	0	applied	\N	\N	\N	\N	41432	41432	41433
11371	12209	1	applied	\N	\N	\N	\N	41434	41434	41435
11381	12226	0	applied	\N	\N	\N	\N	41483	41483	41484
11381	12227	1	applied	\N	\N	\N	\N	41485	41485	41486
11391	12231	0	applied	\N	\N	\N	\N	41503	41503	41504
11391	12232	2	applied	\N	\N	\N	\N	41506	41506	41507
11391	12233	3	applied	\N	\N	\N	\N	41508	41508	41509
11391	12234	4	applied	\N	\N	\N	\N	41510	41510	41511
11392	12235	0	applied	\N	\N	\N	\N	41517	41517	41518
11392	12236	1	applied	\N	\N	\N	\N	41519	41519	41520
11399	12240	0	applied	\N	\N	\N	\N	41535	41535	41536
11399	12241	1	applied	\N	\N	\N	\N	41537	41537	41538
11407	12254	0	applied	\N	\N	\N	\N	41576	41576	41577
11407	12255	1	applied	\N	\N	\N	\N	41578	41578	41579
11407	12256	2	applied	\N	\N	\N	\N	41580	41580	41581
11407	12257	3	applied	\N	\N	\N	\N	41582	41582	41583
11412	12265	0	applied	\N	\N	\N	\N	41605	41605	41606
11412	12266	1	applied	\N	\N	\N	\N	41607	41607	41608
11419	12270	0	applied	\N	\N	\N	\N	41622	41622	41623
11419	12271	1	applied	\N	\N	\N	\N	41624	41624	41625
11424	12280	0	applied	\N	\N	\N	\N	41651	41651	41652
11424	12281	1	applied	\N	\N	\N	\N	41653	41653	41654
11434	12293	0	applied	\N	\N	\N	\N	41691	41691	41692
11434	12294	1	applied	\N	\N	\N	\N	41693	41693	41694
11436	12295	0	applied	\N	\N	\N	\N	41703	41703	41704
11439	12298	0	applied	\N	\N	\N	\N	41711	41711	41712
11439	12299	1	applied	\N	\N	\N	\N	41713	41713	41714
11444	12308	0	applied	\N	\N	\N	\N	41740	41740	41741
11444	12309	1	applied	\N	\N	\N	\N	41742	41742	41743
11444	12310	2	applied	\N	\N	\N	\N	41744	41744	41745
11444	12311	3	applied	\N	\N	\N	\N	41746	41746	41747
11444	12312	4	applied	\N	\N	\N	\N	41748	41748	41749
11444	12313	5	applied	\N	\N	\N	\N	41750	41750	41751
11448	12314	0	applied	\N	\N	\N	\N	41753	41753	41754
11452	12320	0	applied	\N	\N	\N	\N	41773	41773	41774
11452	12321	1	applied	\N	\N	\N	\N	41775	41775	41776
11452	12322	2	applied	\N	\N	\N	\N	41777	41777	41778
11452	12323	3	applied	\N	\N	\N	\N	41779	41779	41780
11455	12329	0	applied	\N	\N	\N	\N	41796	41796	41797
11455	12330	1	applied	\N	\N	\N	\N	41798	41798	41799
11457	12331	0	applied	\N	\N	\N	\N	41805	41805	41806
11457	12332	1	applied	\N	\N	\N	\N	41807	41807	41808
11462	12337	0	applied	\N	\N	\N	\N	41827	41827	41828
11462	12338	1	applied	\N	\N	\N	\N	41829	41829	41830
11475	12363	0	applied	\N	\N	\N	\N	41894	41894	41895
11475	12364	1	applied	\N	\N	\N	\N	41896	41896	41897
11477	12365	0	applied	\N	\N	\N	\N	41900	41900	41901
11477	12366	1	applied	\N	\N	\N	\N	41902	41902	41903
11498	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41865	41865	\N
11498	12351	1	applied	\N	\N	\N	\N	39698	39698	41092
11498	12360	2	applied	\N	\N	\N	\N	41887	41887	41887
11498	12308	3	applied	\N	\N	\N	\N	41740	41740	41741
11498	12309	4	applied	\N	\N	\N	\N	41742	41742	41743
11498	12310	5	applied	\N	\N	\N	\N	41744	41744	41745
11498	12314	6	applied	\N	\N	\N	\N	41753	41753	41754
11498	12316	7	applied	\N	\N	\N	\N	41764	41764	41765
11498	12317	8	applied	\N	\N	\N	\N	41766	41766	41767
11498	12320	9	applied	\N	\N	\N	\N	41773	41773	41774
11498	12321	10	applied	\N	\N	\N	\N	41775	41775	41776
11498	12324	11	applied	\N	\N	\N	\N	41783	41783	41784
11498	12327	12	applied	\N	\N	\N	\N	41791	41791	41792
11498	12329	13	applied	\N	\N	\N	\N	41796	41796	41797
11498	12331	14	applied	\N	\N	\N	\N	41805	41805	41806
11498	12333	15	applied	\N	\N	\N	\N	41811	41811	41812
11498	12335	16	applied	\N	\N	\N	\N	41821	41821	41822
11498	12337	17	applied	\N	\N	\N	\N	41827	41827	41828
11498	12339	18	applied	\N	\N	\N	\N	41833	41833	41834
11498	12341	19	applied	\N	\N	\N	\N	41838	41838	41839
11498	12343	20	applied	\N	\N	\N	\N	41844	41844	41845
11498	12345	21	applied	\N	\N	\N	\N	41848	41848	41849
11498	12347	22	applied	\N	\N	\N	\N	41854	41854	41855
11498	12352	23	applied	\N	\N	\N	\N	41867	41867	41868
11498	12353	24	applied	\N	\N	\N	\N	41869	41869	41870
11498	12354	25	applied	\N	\N	\N	\N	41871	41871	41872
11498	12355	26	applied	\N	\N	\N	\N	41873	41873	41874
11498	12361	27	applied	\N	\N	\N	\N	41888	41888	41889
11498	12363	28	applied	\N	\N	\N	\N	41894	41894	41895
11498	12365	29	applied	\N	\N	\N	\N	41900	41900	41901
11498	12367	30	applied	\N	\N	\N	\N	41905	41905	41906
11378	12220	0	applied	\N	\N	\N	\N	41465	41465	41466
11378	12221	1	applied	\N	\N	\N	\N	41467	41467	41468
11378	12222	2	applied	\N	\N	\N	\N	41469	41469	41470
11378	12223	3	applied	\N	\N	\N	\N	41471	41471	41472
11384	12228	0	applied	\N	\N	\N	\N	41492	41492	41493
11384	12229	1	applied	\N	\N	\N	\N	41494	41494	41495
11389	12231	0	applied	\N	\N	\N	\N	41503	41503	41504
11389	12232	2	applied	\N	\N	\N	\N	41506	41506	41507
11389	12233	3	applied	\N	\N	\N	\N	41508	41508	41509
11389	12234	4	applied	\N	\N	\N	\N	41510	41510	41511
11394	12235	0	applied	\N	\N	\N	\N	41517	41517	41518
11394	12236	1	applied	\N	\N	\N	\N	41519	41519	41520
11396	12237	0	applied	\N	\N	\N	\N	41525	41525	41526
11396	12238	1	applied	\N	\N	\N	\N	41527	41527	41528
11401	12242	0	applied	\N	\N	\N	\N	41541	41541	41542
11401	12243	1	applied	\N	\N	\N	\N	41543	41543	41544
11401	12244	2	applied	\N	\N	\N	\N	41545	41545	41546
11401	12245	3	applied	\N	\N	\N	\N	41547	41547	41548
11403	12248	0	applied	\N	\N	\N	\N	41559	41559	41560
11403	12249	1	applied	\N	\N	\N	\N	41561	41561	41562
11406	12250	0	applied	\N	\N	\N	\N	41566	41566	41567
11406	12251	1	applied	\N	\N	\N	\N	41568	41568	41569
11406	12252	2	applied	\N	\N	\N	\N	41570	41570	41571
11406	12253	3	applied	\N	\N	\N	\N	41572	41572	41573
11411	12262	0	applied	\N	\N	\N	\N	41595	41595	41596
11411	12263	1	applied	\N	\N	\N	\N	41597	41597	41598
11411	12264	2	applied	\N	\N	1000000000	\N	41599	41599	41600
11413	12267	0	applied	\N	\N	\N	\N	41609	41609	41610
11420	12272	0	applied	\N	\N	\N	\N	41630	41630	41631
11420	12273	1	applied	\N	\N	\N	\N	41632	41632	41633
11430	12287	0	applied	\N	\N	\N	\N	41677	41677	41678
11430	12288	1	applied	\N	\N	\N	\N	41679	41679	41680
11437	12296	0	applied	\N	\N	\N	\N	41707	41707	41708
11437	12297	1	applied	\N	\N	\N	\N	41709	41709	41710
11440	12300	0	applied	\N	\N	\N	\N	41716	41716	41717
11440	12301	1	applied	\N	\N	\N	\N	41718	41718	41719
11440	12302	2	applied	\N	\N	\N	\N	41720	41720	41721
11440	12303	3	applied	\N	\N	\N	\N	41722	41722	41723
11443	12304	0	applied	\N	\N	\N	\N	41726	41726	41727
11443	12305	1	applied	\N	\N	\N	\N	41728	41728	41729
11443	12306	2	applied	\N	\N	\N	\N	41733	41733	41734
11443	12307	3	applied	\N	\N	\N	\N	41735	41735	41736
11446	12314	0	applied	\N	\N	\N	\N	41753	41753	41754
11449	12314	0	applied	\N	\N	\N	\N	41753	41753	41754
11450	12315	0	applied	\N	\N	\N	\N	41761	41761	41762
11459	12333	0	applied	\N	\N	\N	\N	41811	41811	41812
11459	12334	1	applied	\N	\N	\N	\N	41813	41813	41814
11463	12339	0	applied	\N	\N	\N	\N	41833	41833	41834
11463	12340	1	applied	\N	\N	\N	\N	41835	41835	41836
11466	12345	0	applied	\N	\N	\N	\N	41848	41848	41849
11466	12346	1	applied	\N	\N	\N	\N	41850	41850	41851
11468	12347	0	applied	\N	\N	\N	\N	41854	41854	41855
11468	12348	1	applied	\N	\N	\N	\N	41856	41856	41857
11468	12349	2	applied	\N	\N	\N	\N	41858	41858	41859
11470	12347	0	applied	\N	\N	\N	\N	41854	41854	41855
11470	12348	1	applied	\N	\N	\N	\N	41856	41856	41857
11470	12349	2	applied	\N	\N	\N	\N	41858	41858	41859
11471	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41865	41865	\N
11471	12351	1	applied	\N	\N	\N	\N	41866	41866	41092
11471	12352	2	applied	\N	\N	\N	\N	41867	41867	41868
11471	12353	3	applied	\N	\N	\N	\N	41869	41869	41870
11471	12354	4	applied	\N	\N	\N	\N	41871	41871	41872
11471	12355	5	applied	\N	\N	\N	\N	41873	41873	41874
11471	12356	6	applied	\N	\N	\N	\N	41875	41875	41876
11471	12357	7	applied	\N	\N	\N	\N	41877	41877	41878
11471	12358	8	applied	\N	\N	\N	\N	41879	41879	41880
11471	12359	9	applied	\N	\N	\N	\N	41881	41881	41882
11476	12363	0	applied	\N	\N	\N	\N	41894	41894	41895
11476	12364	1	applied	\N	\N	\N	\N	41896	41896	41897
11479	12367	0	applied	\N	\N	\N	\N	41905	41905	41906
11479	12368	1	applied	\N	\N	\N	\N	41907	41907	41908
11479	12369	2	applied	\N	\N	\N	\N	41909	41909	41910
11479	12370	3	applied	\N	\N	\N	\N	41911	41911	41912
11481	12371	0	applied	\N	\N	\N	\N	41917	41917	41918
11481	12372	1	applied	\N	\N	\N	\N	41919	41919	41920
11483	12373	0	applied	\N	\N	\N	\N	41921	41921	41922
11483	12374	1	applied	\N	\N	\N	\N	41923	41923	41924
11483	12375	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41925	41925	\N
11485	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11490	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11491	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11492	12377	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41940	41940	\N
11492	12378	1	applied	\N	\N	\N	\N	41941	41941	41942
11492	12379	3	applied	\N	\N	\N	\N	41944	41944	41945
11492	12380	4	applied	\N	\N	\N	\N	41946	41946	41947
11492	12381	5	applied	\N	\N	\N	\N	41948	41948	41949
11492	12382	6	applied	\N	\N	\N	\N	41950	41950	41951
11492	12383	7	applied	\N	\N	\N	\N	41952	41952	41953
11497	12389	0	applied	\N	\N	\N	\N	41974	41974	41975
11497	12390	1	applied	\N	\N	\N	\N	41976	41976	41977
11499	12391	0	applied	\N	\N	\N	\N	41983	41983	41984
11499	12392	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	41985	41985	\N
11499	12393	2	applied	\N	\N	\N	\N	41986	41986	41987
11502	12394	0	applied	\N	\N	\N	\N	41990	41990	41991
11502	12395	1	applied	\N	\N	\N	\N	41992	41992	41993
11502	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41994	41994	\N
11502	12397	3	applied	\N	\N	\N	\N	41995	41995	41996
11502	12398	4	applied	\N	\N	\N	\N	41997	41997	41997
11502	12399	5	applied	\N	\N	\N	\N	41998	41998	41999
11504	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41865	41865	\N
11504	12351	1	applied	\N	\N	\N	\N	39698	39698	39533
11504	12360	2	applied	\N	\N	\N	\N	42014	42014	42014
11504	12282	3	applied	\N	\N	\N	\N	41664	41664	41665
11504	12283	4	applied	\N	\N	\N	\N	41666	41666	41667
11504	12284	5	applied	\N	\N	\N	\N	41668	41668	41669
11504	12287	6	applied	\N	\N	\N	\N	41677	41677	41678
11504	12289	7	applied	\N	\N	\N	\N	41681	41681	41682
11504	12290	8	applied	\N	\N	\N	\N	41683	41683	41684
11504	12293	9	applied	\N	\N	\N	\N	41691	41691	41692
11504	12296	10	applied	\N	\N	\N	\N	41707	41707	41708
11504	12298	11	applied	\N	\N	\N	\N	41711	41711	41712
11504	12300	12	applied	\N	\N	\N	\N	41716	41716	41717
11504	12301	13	applied	\N	\N	\N	\N	41718	41718	41719
11504	12304	14	applied	\N	\N	\N	\N	41726	41726	41727
11504	12305	15	applied	\N	\N	\N	\N	41728	41728	41729
11504	12308	16	applied	\N	\N	\N	\N	41740	41740	41741
11504	12309	17	applied	\N	\N	\N	\N	41742	41742	41743
11426	12079	4	applied	\N	\N	\N	\N	41018	41018	41019
11426	12085	5	applied	\N	\N	\N	\N	41031	41031	41032
11426	12080	6	applied	\N	\N	\N	\N	41020	41020	41021
11426	12089	7	applied	\N	\N	\N	\N	41052	41052	41053
11426	12091	8	applied	\N	\N	\N	\N	41065	41065	41066
11426	12093	9	applied	\N	\N	\N	\N	41074	41074	41075
11426	12095	10	applied	\N	\N	\N	\N	41080	41080	41081
11426	12097	11	applied	\N	\N	\N	\N	41088	41088	41089
11426	12099	12	applied	\N	\N	\N	\N	41094	41094	41095
11426	12101	13	applied	\N	\N	\N	\N	41100	41100	41101
11426	12102	14	applied	\N	\N	\N	\N	41102	41102	41103
11426	12105	15	applied	\N	\N	\N	\N	41110	41110	41111
11426	12106	16	applied	\N	\N	\N	\N	41112	41112	41113
11426	12081	17	applied	\N	\N	\N	\N	41022	41022	41023
11426	12082	19	applied	\N	\N	\N	\N	41024	41024	41025
11426	12109	20	applied	\N	\N	\N	\N	41119	41119	41120
11426	12111	21	applied	\N	\N	\N	\N	41130	41130	41131
11426	12112	22	applied	\N	\N	\N	\N	41137	41137	41138
11426	12114	23	applied	\N	\N	\N	\N	41144	41144	41145
11426	12117	24	applied	\N	\N	\N	\N	41153	41153	41154
11426	12119	25	applied	\N	\N	\N	\N	41159	41159	41160
11426	12120	26	applied	\N	\N	\N	\N	41161	41161	41162
11426	12122	27	applied	\N	\N	\N	\N	41168	41168	41169
11426	12124	28	applied	\N	\N	\N	\N	41178	41178	41179
11426	12126	29	applied	\N	\N	\N	\N	41186	41186	41187
11426	12128	30	applied	\N	\N	\N	\N	41193	41193	41194
11426	12130	31	applied	\N	\N	\N	\N	41201	41201	41202
11426	12131	32	applied	\N	\N	\N	\N	41205	41205	41206
11426	12133	33	applied	\N	\N	\N	\N	41211	41211	41212
11426	12135	34	applied	\N	\N	\N	\N	41219	41219	41220
11426	12137	35	applied	\N	\N	\N	\N	41224	41224	41225
11426	12139	36	applied	\N	\N	\N	\N	41228	41228	41229
11426	12141	37	applied	\N	\N	\N	\N	41235	41235	41236
11426	12142	38	applied	\N	\N	\N	\N	41237	41237	41238
11426	12146	39	applied	\N	\N	\N	\N	41246	41246	41247
11426	12147	40	applied	\N	\N	\N	\N	41248	41248	41249
11426	12150	41	applied	\N	\N	\N	\N	41256	41256	41257
11426	12152	42	applied	\N	\N	\N	\N	41265	41265	41266
11426	12153	43	applied	\N	\N	\N	\N	41267	41267	41268
11426	12156	44	applied	\N	\N	\N	\N	41279	41279	41280
11426	12158	45	applied	\N	\N	\N	\N	41285	41285	41286
11426	12159	46	applied	\N	\N	\N	\N	41287	41287	41288
11426	12162	47	applied	\N	\N	\N	\N	41295	41295	41296
11426	12163	48	applied	\N	\N	\N	\N	41297	41297	41298
11426	12164	49	applied	\N	\N	\N	\N	41299	41299	41300
11426	12168	50	applied	\N	\N	\N	\N	41311	41311	41312
11426	12170	51	applied	\N	\N	\N	\N	41316	41316	41317
11426	12171	52	applied	\N	\N	\N	\N	41318	41318	41319
11426	12174	53	applied	\N	\N	\N	\N	41328	41328	41329
11426	12177	54	applied	\N	\N	\N	\N	41344	41344	41345
11426	12179	55	applied	\N	\N	\N	\N	41350	41350	41351
11426	12181	56	applied	\N	\N	\N	\N	41357	41357	41358
11426	12182	57	applied	\N	\N	\N	\N	41364	41364	41365
11426	12183	58	applied	\N	\N	\N	\N	41366	41366	41367
11426	12184	59	applied	\N	\N	\N	\N	41368	41368	41369
11426	12185	60	applied	\N	\N	\N	\N	41370	41370	41371
11426	12186	61	applied	\N	\N	\N	\N	41372	41372	41373
11426	12192	62	applied	\N	\N	\N	\N	41388	41388	41389
11426	12194	63	applied	\N	\N	\N	\N	41394	41394	41395
11426	12196	64	applied	\N	\N	\N	\N	41399	41399	41400
11426	12197	65	applied	\N	\N	\N	\N	41401	41401	41402
11426	12200	66	applied	\N	\N	\N	\N	41410	41410	41411
11426	12202	67	applied	\N	\N	\N	\N	41417	41417	41418
11426	12203	68	applied	\N	\N	\N	\N	41419	41419	41420
11426	12204	69	applied	\N	\N	\N	\N	41421	41421	41422
11426	12208	70	applied	\N	\N	\N	\N	41432	41432	41433
11426	12210	71	applied	\N	\N	\N	\N	41439	41439	41440
11426	12212	72	applied	\N	\N	\N	\N	41444	41444	41445
11426	12213	73	applied	\N	\N	\N	\N	41446	41446	41447
11426	12216	74	applied	\N	\N	\N	\N	41453	41453	41454
11426	12218	75	applied	\N	\N	\N	\N	41457	41457	41458
11426	12220	76	applied	\N	\N	\N	\N	41465	41465	41466
11426	12221	77	applied	\N	\N	\N	\N	41467	41467	41468
11426	12224	78	applied	\N	\N	\N	\N	41477	41477	41478
11426	12226	79	applied	\N	\N	\N	\N	41483	41483	41484
11426	12228	80	applied	\N	\N	\N	\N	41492	41492	41493
11426	12231	81	applied	\N	\N	\N	\N	41503	41503	41504
11426	12232	82	applied	\N	\N	\N	\N	41506	41506	41507
11426	12235	83	applied	\N	\N	\N	\N	41517	41517	41518
11426	12237	84	applied	\N	\N	\N	\N	41525	41525	41526
11426	12239	85	applied	\N	\N	\N	\N	41532	41532	41533
11426	12240	86	applied	\N	\N	\N	\N	41535	41535	41536
11426	12242	87	applied	\N	\N	\N	\N	41541	41541	41542
11426	12243	88	applied	\N	\N	\N	\N	41543	41543	41544
11426	12246	89	applied	\N	\N	\N	\N	41553	41553	41554
11426	12248	90	applied	\N	\N	\N	\N	41559	41559	41560
11426	12250	91	applied	\N	\N	\N	\N	41566	41566	41567
11426	12251	92	applied	\N	\N	\N	\N	41568	41568	41569
11426	12254	93	applied	\N	\N	\N	\N	41576	41576	41577
11426	12255	94	applied	\N	\N	\N	\N	41578	41578	41579
11426	12258	95	applied	\N	\N	\N	\N	41585	41585	41586
11426	12259	96	applied	\N	\N	\N	\N	41587	41587	41588
11426	12262	97	applied	\N	\N	\N	\N	41595	41595	41596
11426	12265	98	applied	\N	\N	\N	\N	41605	41605	41606
11426	12268	99	applied	\N	\N	\N	\N	41616	41616	41617
11426	12270	100	applied	\N	\N	\N	\N	41622	41622	41623
11426	12272	101	applied	\N	\N	\N	\N	41630	41630	41631
11426	12274	102	applied	\N	\N	\N	\N	41635	41635	41636
11426	12275	103	applied	\N	\N	\N	\N	41637	41637	41638
11426	12278	104	applied	\N	\N	\N	\N	41647	41647	41648
11426	12280	105	applied	\N	\N	\N	\N	41651	41651	41652
11426	12076	106	applied	\N	\N	\N	\N	41011	41011	41012
11426	12143	107	failed	Amount_insufficient_to_create_account	\N	\N	\N	41239	41239	\N
11426	12083	108	applied	\N	\N	\N	\N	41026	41026	41027
11426	12084	109	applied	\N	\N	\N	\N	41028	41028	41029
11426	12086	110	applied	\N	\N	\N	\N	41033	41033	41034
11426	12090	111	applied	\N	\N	\N	\N	41054	41054	41055
11426	12092	112	applied	\N	\N	\N	\N	41067	41067	41068
11426	12094	113	applied	\N	\N	\N	\N	41076	41076	41077
11426	12096	114	applied	\N	\N	\N	\N	41082	41082	41083
11426	12098	115	applied	\N	\N	\N	\N	41090	41090	41091
11426	12100	116	applied	\N	\N	\N	\N	41096	41096	41097
11426	12103	117	applied	\N	\N	\N	\N	41104	41104	41105
11426	12104	118	applied	\N	\N	\N	\N	41106	41106	41107
11426	12107	119	applied	\N	\N	\N	\N	41114	41114	41115
11426	12108	120	applied	\N	\N	\N	\N	41116	41116	41117
11426	12110	121	applied	\N	\N	\N	\N	41121	41121	41122
11426	12113	122	applied	\N	\N	\N	\N	41139	41139	41140
11426	12115	123	applied	\N	\N	\N	\N	41146	41146	41147
11426	12116	124	applied	\N	\N	\N	\N	41149	41149	41150
11426	12118	125	applied	\N	\N	\N	\N	41157	41157	41158
11428	12282	0	applied	\N	\N	\N	\N	41664	41664	41665
11428	12283	1	applied	\N	\N	\N	\N	41666	41666	41667
11428	12284	2	applied	\N	\N	\N	\N	41668	41668	41669
11428	12285	3	applied	\N	\N	\N	\N	41670	41670	41671
11428	12286	4	applied	\N	\N	\N	\N	41672	41672	41673
11431	12289	0	applied	\N	\N	\N	\N	41681	41681	41682
11431	12290	1	applied	\N	\N	\N	\N	41683	41683	41684
11431	12291	2	applied	\N	\N	\N	\N	41685	41685	41686
11431	12292	3	applied	\N	\N	\N	\N	41687	41687	41688
11433	12293	0	applied	\N	\N	\N	\N	41691	41691	41692
11433	12294	1	applied	\N	\N	\N	\N	41693	41693	41694
11438	12298	0	applied	\N	\N	\N	\N	41711	41711	41712
11438	12299	1	applied	\N	\N	\N	\N	41713	41713	41714
11441	12177	0	applied	\N	\N	\N	\N	41344	41344	41345
11441	12179	1	applied	\N	\N	\N	\N	41350	41350	41351
11441	12181	2	applied	\N	\N	\N	\N	41357	41357	41358
11441	12182	3	applied	\N	\N	\N	\N	41364	41364	41365
11441	12183	4	applied	\N	\N	\N	\N	41366	41366	41367
11441	12184	5	applied	\N	\N	\N	\N	41368	41368	41369
11441	12185	6	applied	\N	\N	\N	\N	41370	41370	41371
11441	12186	7	applied	\N	\N	\N	\N	41372	41372	41373
11441	12192	8	applied	\N	\N	\N	\N	41388	41388	41389
11441	12194	9	applied	\N	\N	\N	\N	41394	41394	41395
11441	12196	10	applied	\N	\N	\N	\N	41399	41399	41400
11441	12197	11	applied	\N	\N	\N	\N	41401	41401	41402
11441	12200	12	applied	\N	\N	\N	\N	41410	41410	41411
11441	12202	13	applied	\N	\N	\N	\N	41417	41417	41418
11441	12203	14	applied	\N	\N	\N	\N	41419	41419	41420
11441	12204	15	applied	\N	\N	\N	\N	41421	41421	41422
11441	12208	16	applied	\N	\N	\N	\N	41432	41432	41433
11441	12210	17	applied	\N	\N	\N	\N	41439	41439	41440
11441	12212	18	applied	\N	\N	\N	\N	41444	41444	41445
11441	12213	19	applied	\N	\N	\N	\N	41446	41446	41447
11441	12216	20	applied	\N	\N	\N	\N	41453	41453	41454
11441	12218	21	applied	\N	\N	\N	\N	41457	41457	41458
11441	12220	22	applied	\N	\N	\N	\N	41465	41465	41466
11441	12221	23	applied	\N	\N	\N	\N	41467	41467	41468
11441	12224	24	applied	\N	\N	\N	\N	41477	41477	41478
11441	12226	25	applied	\N	\N	\N	\N	41483	41483	41484
11441	12228	26	applied	\N	\N	\N	\N	41492	41492	41493
11441	12231	27	applied	\N	\N	\N	\N	41503	41503	41504
11441	12232	28	applied	\N	\N	\N	\N	41506	41506	41507
11441	12235	29	applied	\N	\N	\N	\N	41517	41517	41518
11441	12237	30	applied	\N	\N	\N	\N	41525	41525	41526
11441	12239	31	applied	\N	\N	\N	\N	41532	41532	41533
11441	12240	32	applied	\N	\N	\N	\N	41535	41535	41536
11441	12242	33	applied	\N	\N	\N	\N	41541	41541	41542
11441	12243	34	applied	\N	\N	\N	\N	41543	41543	41544
11441	12246	35	applied	\N	\N	\N	\N	41553	41553	41554
11441	12248	36	applied	\N	\N	\N	\N	41559	41559	41560
11441	12250	37	applied	\N	\N	\N	\N	41566	41566	41567
11441	12251	38	applied	\N	\N	\N	\N	41568	41568	41569
11441	12254	39	applied	\N	\N	\N	\N	41576	41576	41577
11441	12255	40	applied	\N	\N	\N	\N	41578	41578	41579
11441	12258	41	applied	\N	\N	\N	\N	41585	41585	41586
11441	12259	42	applied	\N	\N	\N	\N	41587	41587	41588
11441	12262	43	applied	\N	\N	\N	\N	41595	41595	41596
11441	12265	44	applied	\N	\N	\N	\N	41605	41605	41606
11441	12268	45	applied	\N	\N	\N	\N	41616	41616	41617
11441	12270	46	applied	\N	\N	\N	\N	41622	41622	41623
11441	12272	47	applied	\N	\N	\N	\N	41630	41630	41631
11441	12274	48	applied	\N	\N	\N	\N	41635	41635	41636
11441	12275	49	applied	\N	\N	\N	\N	41637	41637	41638
11441	12278	50	applied	\N	\N	\N	\N	41647	41647	41648
11441	12280	51	applied	\N	\N	\N	\N	41651	41651	41652
11441	12282	52	applied	\N	\N	\N	\N	41664	41664	41665
11441	12283	53	applied	\N	\N	\N	\N	41666	41666	41667
11441	12284	54	applied	\N	\N	\N	\N	41668	41668	41669
11441	12287	55	applied	\N	\N	\N	\N	41677	41677	41678
11441	12289	56	applied	\N	\N	\N	\N	41681	41681	41682
11441	12290	57	applied	\N	\N	\N	\N	41683	41683	41684
11441	12293	58	applied	\N	\N	\N	\N	41691	41691	41692
11441	12296	59	applied	\N	\N	\N	\N	41707	41707	41708
11441	12298	60	applied	\N	\N	\N	\N	41711	41711	41712
11441	12300	61	applied	\N	\N	\N	\N	41716	41716	41717
11441	12301	62	applied	\N	\N	\N	\N	41718	41718	41719
11441	12304	63	applied	\N	\N	\N	\N	41726	41726	41727
11441	12305	64	applied	\N	\N	\N	\N	41728	41728	41729
11441	12178	65	applied	\N	\N	\N	\N	41346	41346	41347
11441	12180	66	applied	\N	\N	\N	\N	41352	41352	41353
11441	12187	67	applied	\N	\N	\N	\N	41374	41374	41375
11441	12188	68	applied	\N	\N	\N	\N	41376	41376	41377
11441	12189	69	applied	\N	\N	\N	\N	41378	41378	41379
11441	12190	70	applied	\N	\N	\N	\N	41380	41380	41381
11441	12191	71	applied	\N	\N	\N	\N	41382	41382	41383
11441	12193	72	applied	\N	\N	\N	\N	41390	41390	41391
11441	12195	73	applied	\N	\N	\N	\N	41396	41396	41397
11441	12198	74	applied	\N	\N	\N	\N	41403	41403	41404
11441	12199	75	applied	\N	\N	\N	\N	41405	41405	41406
11441	12201	76	applied	\N	\N	\N	\N	41412	41412	41413
11441	12205	77	applied	\N	\N	\N	\N	41423	41423	41424
11441	12206	78	applied	\N	\N	\N	\N	41425	41425	41426
11441	12207	79	applied	\N	\N	\N	\N	41427	41427	41428
11441	12209	80	applied	\N	\N	\N	\N	41434	41434	41435
11441	12211	81	applied	\N	\N	\N	\N	41441	41441	41442
11441	12214	82	applied	\N	\N	\N	\N	41448	41448	41449
11441	12215	83	applied	\N	\N	\N	\N	41450	41450	41451
11441	12217	84	applied	\N	\N	\N	\N	41455	41455	41456
11441	12219	85	applied	\N	\N	\N	\N	41459	41459	41460
11441	12222	86	applied	\N	\N	\N	\N	41469	41469	41470
11441	12223	87	applied	\N	\N	\N	\N	41471	41471	41472
11441	12225	88	applied	\N	\N	\N	\N	41479	41479	41480
11441	12227	89	applied	\N	\N	\N	\N	41485	41485	41486
11441	12229	90	applied	\N	\N	\N	\N	41494	41494	41495
11441	12230	91	applied	\N	\N	\N	\N	41499	41499	41500
11441	12233	92	applied	\N	\N	\N	\N	41508	41508	41509
11441	12234	94	applied	\N	\N	\N	\N	41510	41510	41511
11441	12236	95	applied	\N	\N	\N	\N	41519	41519	41520
11441	12238	96	applied	\N	\N	\N	\N	41527	41527	41528
11441	12241	97	applied	\N	\N	\N	\N	41537	41537	41538
11441	12244	98	applied	\N	\N	\N	\N	41545	41545	41546
11441	12245	99	applied	\N	\N	\N	\N	41547	41547	41548
11441	12247	100	applied	\N	\N	\N	\N	41555	41555	41556
11441	12249	101	applied	\N	\N	\N	\N	41561	41561	41562
11441	12252	102	applied	\N	\N	\N	\N	41570	41570	41571
11441	12253	103	applied	\N	\N	\N	\N	41572	41572	41573
11441	12256	104	applied	\N	\N	\N	\N	41580	41580	41581
11441	12257	105	applied	\N	\N	\N	\N	41582	41582	41583
11441	12260	106	applied	\N	\N	\N	\N	41589	41589	41590
11441	12261	107	applied	\N	\N	\N	\N	41591	41591	41592
11441	12263	108	applied	\N	\N	\N	\N	41597	41597	41598
11441	12264	109	applied	\N	\N	1000000000	\N	41599	41599	41600
11441	12266	110	applied	\N	\N	\N	\N	41607	41607	41608
11441	12267	111	applied	\N	\N	\N	\N	41609	41609	41610
11441	12269	112	applied	\N	\N	\N	\N	41618	41618	41619
11441	12271	113	applied	\N	\N	\N	\N	41624	41624	41625
11441	12273	114	applied	\N	\N	\N	\N	41632	41632	41633
11441	12276	115	applied	\N	\N	\N	\N	41639	41639	41640
11441	12277	116	applied	\N	\N	\N	\N	41641	41641	41642
11441	12279	117	applied	\N	\N	\N	\N	41649	41649	41650
11441	12281	118	applied	\N	\N	\N	\N	41653	41653	41654
11441	12285	119	applied	\N	\N	\N	\N	41670	41670	41671
11441	12286	120	applied	\N	\N	\N	\N	41672	41672	41673
11441	12288	121	applied	\N	\N	\N	\N	41679	41679	41680
11441	12291	122	applied	\N	\N	\N	\N	41685	41685	41686
11441	12292	123	applied	\N	\N	\N	\N	41687	41687	41688
11441	12294	124	applied	\N	\N	\N	\N	41693	41693	41694
11441	12295	125	applied	\N	\N	\N	\N	41703	41703	41704
11447	12314	0	applied	\N	\N	\N	\N	41753	41753	41754
11451	12316	0	applied	\N	\N	\N	\N	41764	41764	41765
11451	12317	1	applied	\N	\N	\N	\N	41766	41766	41767
11451	12318	2	applied	\N	\N	\N	\N	41768	41768	41769
11451	12319	3	applied	\N	\N	\N	\N	41770	41770	41771
11454	12326	0	applied	\N	\N	1000000000	\N	41789	41789	41790
11454	12327	1	applied	\N	\N	\N	\N	41791	41791	41792
11454	12328	2	applied	\N	\N	\N	\N	41793	41793	41794
11460	12333	0	applied	\N	\N	\N	\N	41811	41811	41812
11460	12334	1	applied	\N	\N	\N	\N	41813	41813	41814
11461	12335	0	applied	\N	\N	\N	\N	41821	41821	41822
11461	12336	1	applied	\N	\N	\N	\N	41823	41823	41824
11464	12341	0	applied	\N	\N	\N	\N	41838	41838	41839
11464	12342	1	applied	\N	\N	\N	\N	41840	41840	41841
11467	12345	0	applied	\N	\N	\N	\N	41848	41848	41849
11467	12346	1	applied	\N	\N	\N	\N	41850	41850	41851
11469	12347	0	applied	\N	\N	\N	\N	41854	41854	41855
11469	12348	1	applied	\N	\N	\N	\N	41856	41856	41857
11469	12349	2	applied	\N	\N	\N	\N	41858	41858	41859
11472	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41865	41865	\N
11472	12351	1	applied	\N	\N	\N	\N	41866	41866	41092
11472	12352	2	applied	\N	\N	\N	\N	41867	41867	41868
11472	12353	3	applied	\N	\N	\N	\N	41869	41869	41870
11472	12354	4	applied	\N	\N	\N	\N	41871	41871	41872
11472	12355	5	applied	\N	\N	\N	\N	41873	41873	41874
11472	12356	6	applied	\N	\N	\N	\N	41875	41875	41876
11472	12357	7	applied	\N	\N	\N	\N	41877	41877	41878
11472	12358	8	applied	\N	\N	\N	\N	41879	41879	41880
11472	12359	9	applied	\N	\N	\N	\N	41881	41881	41882
11474	12363	0	applied	\N	\N	\N	\N	41894	41894	41895
11474	12364	1	applied	\N	\N	\N	\N	41896	41896	41897
11484	12373	0	applied	\N	\N	\N	\N	41921	41921	41922
11484	12374	1	applied	\N	\N	\N	\N	41923	41923	41924
11484	12375	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41925	41925	\N
11488	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11493	12377	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	41940	41940	\N
11493	12378	1	applied	\N	\N	\N	\N	41941	41941	41942
11493	12379	3	applied	\N	\N	\N	\N	41944	41944	41945
11493	12380	4	applied	\N	\N	\N	\N	41946	41946	41947
11493	12381	5	applied	\N	\N	\N	\N	41948	41948	41949
11493	12382	6	applied	\N	\N	\N	\N	41950	41950	41951
11493	12383	7	applied	\N	\N	\N	\N	41952	41952	41953
11495	12384	0	applied	\N	\N	\N	\N	41960	41960	41961
11495	12385	1	applied	\N	\N	\N	\N	41962	41962	41963
11495	12386	2	applied	\N	\N	\N	\N	41964	41964	41965
11495	12387	3	applied	\N	\N	\N	\N	41966	41966	41967
11495	12388	4	applied	\N	\N	\N	\N	41968	41968	41969
11507	12411	0	applied	\N	\N	\N	\N	42037	42037	42038
11507	12412	1	applied	\N	\N	\N	\N	42039	42039	42040
11512	12413	0	applied	\N	\N	\N	\N	42042	42042	42043
11512	12414	1	applied	\N	\N	\N	\N	42044	42044	42045
11514	12415	0	applied	\N	\N	\N	\N	42048	42048	42049
11514	12416	1	applied	\N	\N	\N	\N	42050	42050	42051
11516	12417	0	applied	\N	\N	\N	\N	42057	42057	42058
11516	12418	1	applied	\N	\N	\N	\N	42059	42059	42060
11527	12439	0	applied	\N	\N	\N	\N	42114	42114	42115
11527	12440	1	applied	\N	\N	\N	\N	42116	42116	42117
11527	12441	2	applied	\N	\N	\N	\N	42118	42118	42119
11527	12442	3	applied	\N	\N	\N	\N	42120	42120	42121
11527	12443	4	applied	\N	\N	\N	\N	42122	42122	42123
11532	12450	0	applied	\N	\N	\N	\N	42143	42143	42144
11532	12451	1	applied	\N	\N	\N	\N	42145	42145	42146
11535	12457	0	applied	\N	\N	\N	\N	42161	42161	42162
11535	12458	1	applied	\N	\N	\N	\N	42163	42163	42164
11535	12459	2	applied	\N	\N	1000000000	\N	42165	42165	42166
11535	12460	3	applied	\N	\N	1000000000	\N	42167	42167	42168
11539	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11539	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11539	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11539	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11539	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11539	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11539	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11544	12470	0	applied	\N	\N	\N	\N	42201	42201	42202
11544	12471	1	applied	\N	\N	\N	\N	42203	42203	42204
11546	12472	0	applied	\N	\N	\N	\N	42208	42208	42209
11546	12473	1	applied	\N	\N	\N	\N	42210	42210	42211
11551	12476	0	applied	\N	\N	\N	\N	42222	42222	42223
11554	12478	0	applied	\N	\N	\N	\N	42232	42232	42233
11554	12479	1	applied	\N	\N	\N	\N	42234	42234	42235
11556	12480	0	applied	\N	\N	\N	\N	42238	42238	42239
11560	12486	0	applied	\N	\N	\N	\N	42257	42257	42258
11560	12487	1	applied	\N	\N	\N	\N	42259	42259	42260
11565	12491	0	applied	\N	\N	\N	\N	42274	42274	42275
11567	12492	0	applied	\N	\N	\N	\N	42281	42281	42282
11572	12495	0	applied	\N	\N	\N	\N	42293	42293	42294
11577	12500	0	applied	\N	\N	\N	\N	42310	42310	42311
11577	12501	1	applied	\N	\N	\N	\N	42312	42312	42313
11580	12505	0	applied	\N	\N	\N	\N	42323	42323	42324
11587	12508	0	applied	\N	\N	\N	\N	42337	42337	42338
11592	12511	0	applied	\N	\N	\N	\N	42351	42351	42352
11598	12513	0	applied	\N	\N	\N	\N	42359	42359	42360
11598	12514	1	applied	\N	\N	\N	\N	42361	42361	42362
11599	12515	0	applied	\N	\N	\N	\N	42367	42367	42368
11599	12516	1	applied	\N	\N	\N	\N	42369	42369	42370
11456	11950	12	applied	\N	\N	\N	\N	40726	40726	40727
11456	11951	13	applied	\N	\N	\N	\N	40728	40728	40729
11456	11952	14	applied	\N	\N	\N	\N	40730	40730	40731
11456	11953	15	applied	\N	\N	\N	\N	40732	40732	40733
11456	11954	16	applied	\N	\N	\N	\N	40734	40734	40735
11456	11955	17	applied	\N	\N	\N	\N	40736	40736	40737
11456	11959	18	applied	\N	\N	\N	\N	40746	40746	40747
11456	11960	19	applied	\N	\N	\N	\N	40748	40748	40749
11456	11961	20	applied	\N	\N	\N	\N	40750	40750	40751
11456	11962	21	applied	\N	\N	\N	\N	40752	40752	40753
11456	11963	22	applied	\N	\N	\N	\N	40754	40754	40755
11456	11966	23	applied	\N	\N	\N	\N	40762	40762	40763
11456	11967	24	applied	\N	\N	\N	\N	40764	40764	40765
11456	11968	25	applied	\N	\N	\N	\N	40766	40766	40767
11456	11969	26	applied	\N	\N	\N	\N	40768	40768	40769
11456	11970	27	applied	\N	\N	\N	\N	40770	40770	40771
11456	11971	28	applied	\N	\N	\N	\N	40772	40772	40773
11456	11974	29	applied	\N	\N	\N	\N	40780	40780	40781
11456	11975	30	applied	\N	\N	\N	\N	40782	40782	40783
11456	11976	31	applied	\N	\N	\N	\N	40784	40784	40785
11456	11977	32	applied	\N	\N	\N	\N	40786	40786	40787
11456	11978	33	applied	\N	\N	\N	\N	40788	40788	40789
11456	11979	34	applied	\N	\N	\N	\N	40790	40790	40791
11456	11981	35	applied	\N	\N	\N	\N	40798	40798	40799
11456	11982	36	applied	\N	\N	\N	\N	40800	40800	40801
11456	11983	37	applied	\N	\N	\N	\N	40802	40802	40803
11456	11984	38	applied	\N	\N	\N	\N	40804	40804	40805
11456	11985	39	applied	\N	\N	\N	\N	40806	40806	40807
11456	11986	40	applied	\N	\N	\N	\N	40808	40808	40809
11456	11987	41	applied	\N	\N	\N	\N	40810	40810	40811
11456	11988	42	applied	\N	\N	\N	\N	40812	40812	40813
11456	11989	43	applied	\N	\N	\N	\N	40814	40814	40815
11456	11990	44	applied	\N	\N	\N	\N	40816	40816	40817
11456	11991	45	applied	\N	\N	\N	\N	40818	40818	40819
11456	11992	46	applied	\N	\N	\N	\N	40820	40820	40821
11456	11993	47	applied	\N	\N	\N	\N	40822	40822	40823
11456	11994	48	applied	\N	\N	\N	\N	40824	40824	40825
11456	11995	49	applied	\N	\N	\N	\N	40826	40826	40827
11456	11996	50	applied	\N	\N	\N	\N	40828	40828	40829
11456	11997	51	applied	\N	\N	\N	\N	40830	40830	40831
11456	11998	52	applied	\N	\N	\N	\N	40832	40832	40833
11456	12005	53	applied	\N	\N	\N	\N	40850	40850	40851
11456	12006	54	applied	\N	\N	\N	\N	40852	40852	40853
11456	12007	55	applied	\N	\N	\N	\N	40854	40854	40855
11456	12008	56	applied	\N	\N	\N	\N	40856	40856	40857
11456	12009	57	applied	\N	\N	\N	\N	40858	40858	40859
11456	12010	58	applied	\N	\N	\N	\N	40860	40860	40861
11456	12014	59	applied	\N	\N	\N	\N	40871	40871	40872
11456	12015	60	applied	\N	\N	\N	\N	40873	40873	40874
11456	12016	61	applied	\N	\N	\N	\N	40875	40875	40876
11456	12017	62	applied	\N	\N	\N	\N	40877	40877	40878
11456	12018	63	applied	\N	\N	\N	\N	40879	40879	40880
11456	12019	64	applied	\N	\N	\N	\N	40881	40881	40882
11458	12333	0	applied	\N	\N	\N	\N	41811	41811	41812
11458	12334	1	applied	\N	\N	\N	\N	41813	41813	41814
11465	12343	0	applied	\N	\N	\N	\N	41844	41844	41845
11465	12344	1	applied	\N	\N	\N	\N	41846	41846	41847
11473	12360	0	applied	\N	\N	\N	\N	41887	41887	41887
11473	12361	1	applied	\N	\N	\N	\N	41888	41888	41889
11473	12362	2	applied	\N	\N	\N	\N	41890	41890	41891
11478	12367	0	applied	\N	\N	\N	\N	41905	41905	41906
11478	12368	1	applied	\N	\N	\N	\N	41907	41907	41908
11478	12369	2	applied	\N	\N	\N	\N	41909	41909	41910
11478	12370	3	applied	\N	\N	\N	\N	41911	41911	41912
11480	12371	0	applied	\N	\N	\N	\N	41917	41917	41918
11480	12372	1	applied	\N	\N	\N	\N	41919	41919	41920
11482	12371	0	applied	\N	\N	\N	\N	41917	41917	41918
11482	12372	1	applied	\N	\N	\N	\N	41919	41919	41920
11487	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11489	12376	0	applied	\N	\N	\N	\N	41929	41929	41930
11494	12384	0	applied	\N	\N	\N	\N	41960	41960	41961
11494	12385	1	applied	\N	\N	\N	\N	41962	41962	41963
11494	12386	2	applied	\N	\N	\N	\N	41964	41964	41965
11494	12387	3	applied	\N	\N	\N	\N	41966	41966	41967
11494	12388	4	applied	\N	\N	\N	\N	41968	41968	41969
11496	12389	0	applied	\N	\N	\N	\N	41974	41974	41975
11496	12390	1	applied	\N	\N	\N	\N	41976	41976	41977
11501	12394	0	applied	\N	\N	\N	\N	41990	41990	41991
11501	12395	1	applied	\N	\N	\N	\N	41992	41992	41993
11501	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41994	41994	\N
11501	12397	3	applied	\N	\N	\N	\N	41995	41995	41996
11501	12398	4	applied	\N	\N	\N	\N	41997	41997	41997
11501	12399	5	applied	\N	\N	\N	\N	41998	41998	41999
11503	12400	0	applied	\N	\N	\N	\N	42006	42006	42007
11503	12401	1	applied	\N	\N	\N	\N	42008	42008	42009
11503	12402	2	applied	\N	\N	\N	\N	42010	42010	42011
11506	12406	0	applied	\N	\N	\N	\N	42026	42026	42027
11506	12407	1	applied	\N	\N	\N	\N	42028	42028	42029
11506	12408	2	applied	\N	\N	\N	\N	42030	42030	42031
11506	12409	3	applied	\N	\N	\N	\N	42032	42032	42033
11506	12410	4	applied	\N	\N	\N	\N	42034	42034	42035
11522	12423	0	applied	\N	\N	\N	\N	42071	42071	42072
11522	12424	1	applied	\N	\N	\N	\N	42073	42073	42074
11523	12425	0	applied	\N	\N	\N	\N	42077	42077	42078
11523	12426	1	applied	\N	\N	\N	\N	42079	42079	42080
11523	12427	2	applied	\N	\N	\N	\N	42081	42081	42082
11523	12428	3	applied	\N	\N	\N	\N	42083	42083	42084
11523	12429	4	applied	\N	\N	\N	\N	42085	42085	42086
11523	12430	5	applied	\N	\N	\N	\N	42087	42087	42088
11523	12431	6	applied	\N	\N	\N	\N	42089	42089	42090
11523	12432	7	applied	\N	\N	\N	\N	42091	42091	42092
11531	12448	0	applied	\N	\N	\N	\N	42138	42138	42139
11531	12449	1	applied	\N	\N	\N	\N	42140	42140	42141
11537	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11537	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11537	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11537	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11537	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11537	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11537	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11541	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11541	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11541	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11541	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11541	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11541	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11541	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11550	12475	0	applied	\N	\N	\N	\N	42218	42218	42219
11558	12482	0	applied	\N	\N	\N	\N	42246	42246	42247
11498	12368	31	applied	\N	\N	\N	\N	41907	41907	41908
11498	12371	32	applied	\N	\N	\N	\N	41917	41917	41918
11498	12373	33	applied	\N	\N	\N	\N	41921	41921	41922
11498	12376	34	applied	\N	\N	\N	\N	41929	41929	41930
11498	12378	35	applied	\N	\N	\N	\N	41941	41941	41942
11498	12379	36	applied	\N	\N	\N	\N	41944	41944	41945
11498	12380	37	applied	\N	\N	\N	\N	41946	41946	41947
11498	12384	38	applied	\N	\N	\N	\N	41960	41960	41961
11498	12385	39	applied	\N	\N	\N	\N	41962	41962	41963
11498	12389	40	applied	\N	\N	\N	\N	41974	41974	41975
11498	12386	41	applied	\N	\N	\N	\N	41964	41964	41965
11498	12349	42	applied	\N	\N	\N	\N	41858	41858	41859
11498	12297	43	applied	\N	\N	\N	\N	41709	41709	41710
11498	12299	44	applied	\N	\N	\N	\N	41713	41713	41714
11498	12375	45	failed	Amount_insufficient_to_create_account	\N	\N	\N	41925	41925	\N
11498	12377	46	failed	Amount_insufficient_to_create_account	\N	\N	\N	41940	41940	\N
11498	12302	47	applied	\N	\N	\N	\N	41720	41720	41721
11498	12303	48	applied	\N	\N	\N	\N	41722	41722	41723
11498	12306	49	applied	\N	\N	\N	\N	41733	41733	41734
11498	12307	50	applied	\N	\N	\N	\N	41735	41735	41736
11498	12311	51	applied	\N	\N	\N	\N	41746	41746	41747
11498	12312	52	applied	\N	\N	\N	\N	41748	41748	41749
11498	12313	53	applied	\N	\N	\N	\N	41750	41750	41751
11498	12315	54	applied	\N	\N	\N	\N	41761	41761	41762
11498	12318	55	applied	\N	\N	\N	\N	41768	41768	41769
11498	12319	56	applied	\N	\N	\N	\N	41770	41770	41771
11498	12322	57	applied	\N	\N	\N	\N	41777	41777	41778
11498	12323	58	applied	\N	\N	\N	\N	41779	41779	41780
11498	12325	59	applied	\N	\N	\N	\N	41785	41785	41786
11498	12326	60	applied	\N	\N	1000000000	\N	41789	41789	41790
11498	12328	61	applied	\N	\N	\N	\N	41793	41793	41794
11498	12330	62	applied	\N	\N	\N	\N	41798	41798	41799
11498	12332	63	applied	\N	\N	\N	\N	41807	41807	41808
11498	12334	64	applied	\N	\N	\N	\N	41813	41813	41814
11498	12336	65	applied	\N	\N	\N	\N	41823	41823	41824
11498	12338	66	applied	\N	\N	\N	\N	41829	41829	41830
11498	12340	67	applied	\N	\N	\N	\N	41835	41835	41836
11498	12342	68	applied	\N	\N	\N	\N	41840	41840	41841
11498	12344	69	applied	\N	\N	\N	\N	41846	41846	41847
11498	12346	70	applied	\N	\N	\N	\N	41850	41850	41851
11498	12348	71	applied	\N	\N	\N	\N	41856	41856	41857
11498	12356	72	applied	\N	\N	\N	\N	41875	41875	41876
11498	12357	73	applied	\N	\N	\N	\N	41877	41877	41878
11498	12358	74	applied	\N	\N	\N	\N	41879	41879	41880
11498	12359	75	applied	\N	\N	\N	\N	41881	41881	41882
11498	12362	76	applied	\N	\N	\N	\N	41890	41890	41891
11498	12364	77	applied	\N	\N	\N	\N	41896	41896	41897
11498	12366	78	applied	\N	\N	\N	\N	41902	41902	41903
11498	12369	79	applied	\N	\N	\N	\N	41909	41909	41910
11498	12370	80	applied	\N	\N	\N	\N	41911	41911	41912
11498	12372	81	applied	\N	\N	\N	\N	41919	41919	41920
11498	12374	82	applied	\N	\N	\N	\N	41923	41923	41924
11498	12381	83	applied	\N	\N	\N	\N	41948	41948	41949
11498	12382	84	applied	\N	\N	\N	\N	41950	41950	41951
11498	12383	85	applied	\N	\N	\N	\N	41952	41952	41953
11498	12387	86	applied	\N	\N	\N	\N	41966	41966	41967
11498	12388	87	applied	\N	\N	\N	\N	41968	41968	41969
11498	12390	88	applied	\N	\N	\N	\N	41976	41976	41977
11500	12394	0	applied	\N	\N	\N	\N	41990	41990	41991
11500	12395	1	applied	\N	\N	\N	\N	41992	41992	41993
11500	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	41994	41994	\N
11500	12397	3	applied	\N	\N	\N	\N	41995	41995	41996
11500	12398	4	applied	\N	\N	\N	\N	41997	41997	41997
11500	12399	5	applied	\N	\N	\N	\N	41998	41998	41999
11505	12403	0	applied	\N	\N	\N	\N	42019	42019	42020
11505	12404	1	applied	\N	\N	\N	\N	42021	42021	42022
11505	12405	2	applied	\N	\N	\N	\N	42023	42023	42024
11508	12411	0	applied	\N	\N	\N	\N	42037	42037	42038
11508	12412	1	applied	\N	\N	\N	\N	42039	42039	42040
11515	12415	0	applied	\N	\N	\N	\N	42048	42048	42049
11515	12416	1	applied	\N	\N	\N	\N	42050	42050	42051
11517	12417	0	applied	\N	\N	\N	\N	42057	42057	42058
11517	12418	1	applied	\N	\N	\N	\N	42059	42059	42060
11521	12419	0	applied	\N	\N	\N	\N	42062	42062	42063
11521	12420	1	applied	\N	\N	\N	\N	42064	42064	42065
11521	12421	2	applied	\N	\N	\N	\N	42066	42066	42067
11521	12422	3	applied	\N	\N	\N	\N	42068	42068	42069
11525	11537	0	applied	\N	\N	\N	\N	39460	39460	39461
11525	11550	1	applied	\N	\N	\N	\N	39497	39497	39498
11525	11551	2	applied	\N	\N	\N	\N	39499	39499	39500
11525	11568	3	applied	\N	\N	\N	\N	39553	39553	39554
11525	11848	4	applied	\N	\N	1000000000	\N	40458	40458	40459
11525	11547	5	applied	\N	\N	\N	\N	39489	39489	39490
11525	11607	6	applied	\N	\N	\N	\N	39791	39791	39791
11525	11614	7	applied	\N	\N	\N	\N	39792	39792	39701
11525	11615	8	applied	\N	\N	\N	\N	39793	39793	39703
11525	11616	9	applied	\N	\N	\N	\N	39794	39794	39705
11525	11617	10	applied	\N	\N	\N	\N	39795	39795	39707
11525	11682	11	applied	\N	\N	\N	\N	39921	39921	39922
11525	12351	12	applied	\N	\N	\N	\N	42096	42096	36580
11525	11723	13	applied	\N	\N	\N	\N	40064	40064	40065
11525	11693	14	applied	\N	\N	\N	\N	39974	39974	39975
11525	12360	15	applied	\N	\N	\N	\N	42097	42097	42097
11525	11938	16	applied	\N	\N	\N	\N	41038	41038	40699
11525	11939	17	applied	\N	\N	\N	\N	41039	41039	40701
11525	11724	18	applied	\N	\N	\N	\N	40066	40066	40067
11525	11725	19	applied	\N	\N	\N	\N	40068	40068	40069
11525	12078	20	applied	\N	\N	\N	\N	41016	41016	41017
11525	11726	21	applied	\N	\N	\N	\N	40070	40070	40071
11525	11727	22	applied	\N	\N	\N	\N	40072	40072	40073
11525	11699	23	applied	\N	\N	\N	\N	39990	39990	39991
11525	12080	24	applied	\N	\N	\N	\N	41020	41020	41021
11525	11632	25	applied	\N	\N	1000000000	\N	39749	39749	39949
11525	11612	26	applied	\N	\N	\N	\N	39688	39688	39950
11525	11631	27	applied	\N	\N	\N	\N	39796	39796	39951
11525	11941	28	applied	\N	\N	\N	\N	41040	41040	40705
11525	11943	29	applied	\N	\N	\N	\N	41041	41041	40713
11525	11945	30	applied	\N	\N	\N	\N	41042	41042	40717
11525	12081	31	applied	\N	\N	\N	\N	41022	41022	41023
11525	12082	32	applied	\N	\N	\N	\N	41024	41024	41025
11525	11536	33	applied	\N	\N	\N	\N	39455	39455	39456
11525	11538	34	applied	\N	\N	\N	\N	39462	39462	39463
11525	11539	35	applied	\N	\N	\N	\N	39464	39464	39465
11525	11543	36	applied	\N	\N	\N	\N	39477	39477	39478
11525	11544	37	applied	\N	\N	\N	\N	39479	39479	39480
11525	11548	38	applied	\N	\N	\N	\N	39491	39491	39492
11525	11554	39	applied	\N	\N	\N	\N	39505	39505	39506
11525	11700	40	applied	\N	\N	\N	\N	39992	39992	39993
11504	12310	19	applied	\N	\N	\N	\N	41744	41744	41745
11504	12314	20	applied	\N	\N	\N	\N	41753	41753	41754
11504	12316	21	applied	\N	\N	\N	\N	41764	41764	41765
11504	12317	22	applied	\N	\N	\N	\N	41766	41766	41767
11504	12320	23	applied	\N	\N	\N	\N	41773	41773	41774
11504	12321	24	applied	\N	\N	\N	\N	41775	41775	41776
11504	12324	25	applied	\N	\N	\N	\N	41783	41783	41784
11504	12327	26	applied	\N	\N	\N	\N	41791	41791	41792
11504	12329	27	applied	\N	\N	\N	\N	41796	41796	41797
11504	12331	28	applied	\N	\N	\N	\N	41805	41805	41806
11504	12333	29	applied	\N	\N	\N	\N	41811	41811	41812
11504	12335	30	applied	\N	\N	\N	\N	41821	41821	41822
11504	12337	31	applied	\N	\N	\N	\N	41827	41827	41828
11504	12339	32	applied	\N	\N	\N	\N	41833	41833	41834
11504	12341	33	applied	\N	\N	\N	\N	41838	41838	41839
11504	12343	34	applied	\N	\N	\N	\N	41844	41844	41845
11504	12345	35	applied	\N	\N	\N	\N	41848	41848	41849
11504	12347	36	applied	\N	\N	\N	\N	41854	41854	41855
11504	12352	37	applied	\N	\N	\N	\N	41867	41867	41868
11504	12353	38	applied	\N	\N	\N	\N	41869	41869	41870
11509	12411	0	applied	\N	\N	\N	\N	42037	42037	42038
11509	12412	1	applied	\N	\N	\N	\N	42039	42039	42040
11511	12413	0	applied	\N	\N	\N	\N	42042	42042	42043
11511	12414	1	applied	\N	\N	\N	\N	42044	42044	42045
11513	12415	0	applied	\N	\N	\N	\N	42048	42048	42049
11513	12416	1	applied	\N	\N	\N	\N	42050	42050	42051
11518	12417	0	applied	\N	\N	\N	\N	42057	42057	42058
11518	12418	1	applied	\N	\N	\N	\N	42059	42059	42060
11520	12389	0	applied	\N	\N	\N	\N	41974	41974	41975
11520	12391	1	applied	\N	\N	\N	\N	41983	41983	41984
11520	12395	2	applied	\N	\N	\N	\N	41992	41992	41993
11520	12400	3	applied	\N	\N	\N	\N	42006	42006	42007
11520	12403	4	applied	\N	\N	\N	\N	42019	42019	42020
11520	12406	5	applied	\N	\N	\N	\N	42026	42026	42027
11520	12407	6	applied	\N	\N	\N	\N	42028	42028	42029
11520	12411	7	applied	\N	\N	\N	\N	42037	42037	42038
11520	12413	8	applied	\N	\N	\N	\N	42042	42042	42043
11520	12415	9	applied	\N	\N	\N	\N	42048	42048	42049
11520	12401	10	applied	\N	\N	\N	\N	42008	42008	42009
11520	12397	11	applied	\N	\N	\N	\N	41995	41995	41996
11520	12398	12	applied	\N	\N	\N	\N	41997	41997	41997
11520	12390	13	applied	\N	\N	\N	\N	41976	41976	41977
11520	12392	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	41985	41985	\N
11520	12396	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	41994	41994	\N
11520	12393	16	applied	\N	\N	\N	\N	41986	41986	41987
11520	12394	17	applied	\N	\N	\N	\N	41990	41990	41991
11520	12399	18	applied	\N	\N	\N	\N	41998	41998	41999
11520	12402	19	applied	\N	\N	\N	\N	42010	42010	42011
11520	12404	20	applied	\N	\N	\N	\N	42021	42021	42022
11520	12408	21	applied	\N	\N	\N	\N	42030	42030	42031
11520	12410	22	applied	\N	\N	\N	\N	42034	42034	42035
11520	12412	23	applied	\N	\N	\N	\N	42039	42039	42040
11520	12414	24	applied	\N	\N	\N	\N	42044	42044	42045
11520	12416	25	applied	\N	\N	\N	\N	42050	42050	42051
11520	12405	26	applied	\N	\N	\N	\N	42023	42023	42024
11520	12409	27	applied	\N	\N	\N	\N	42032	42032	42033
11524	12419	0	applied	\N	\N	\N	\N	42062	42062	42063
11524	12420	1	applied	\N	\N	\N	\N	42064	42064	42065
11524	12423	2	applied	\N	\N	\N	\N	42071	42071	42072
11524	12425	3	applied	\N	\N	\N	\N	42077	42077	42078
11524	12426	4	applied	\N	\N	\N	\N	42079	42079	42080
11524	12427	5	applied	\N	\N	\N	\N	42081	42081	42082
11524	12428	6	applied	\N	\N	\N	\N	42083	42083	42084
11524	12421	7	applied	\N	\N	\N	\N	42066	42066	42067
11524	12422	8	applied	\N	\N	\N	\N	42068	42068	42069
11524	12424	9	applied	\N	\N	\N	\N	42073	42073	42074
11524	12429	10	applied	\N	\N	\N	\N	42085	42085	42086
11524	12430	11	applied	\N	\N	\N	\N	42087	42087	42088
11524	12431	12	applied	\N	\N	\N	\N	42089	42089	42090
11524	12432	13	applied	\N	\N	\N	\N	42091	42091	42092
11526	12433	0	applied	\N	\N	\N	\N	42101	42101	42102
11526	12434	1	applied	\N	\N	\N	\N	42103	42103	42104
11526	12435	2	applied	\N	\N	\N	\N	42105	42105	42106
11526	12436	3	applied	\N	\N	\N	\N	42107	42107	42108
11526	12437	4	applied	\N	\N	\N	\N	42109	42109	42110
11526	12438	5	applied	\N	\N	\N	\N	42111	42111	42112
11529	12444	0	applied	\N	\N	\N	\N	42127	42127	42128
11529	12445	1	applied	\N	\N	\N	\N	42129	42129	42130
11534	12457	0	applied	\N	\N	\N	\N	42161	42161	42162
11534	12458	1	applied	\N	\N	\N	\N	42163	42163	42164
11534	12459	2	applied	\N	\N	1000000000	\N	42165	42165	42166
11534	12460	3	applied	\N	\N	1000000000	\N	42167	42167	42168
11538	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11538	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11538	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11538	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11538	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11538	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11538	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11543	12468	0	applied	\N	\N	\N	\N	42196	42196	42197
11543	12469	1	applied	\N	\N	\N	\N	42198	42198	42199
11548	12474	0	applied	\N	\N	\N	\N	42214	42214	42215
11553	12477	0	applied	\N	\N	\N	\N	42228	42228	42229
11559	12484	0	applied	\N	\N	\N	\N	42252	42252	42253
11559	12485	1	applied	\N	\N	\N	\N	42254	42254	42255
11562	12488	0	applied	\N	\N	\N	\N	42263	42263	42264
11569	12493	0	applied	\N	\N	\N	\N	42286	42286	42287
11574	12496	0	applied	\N	\N	\N	\N	42297	42297	42298
11584	12506	0	applied	\N	\N	\N	\N	42329	42329	42330
11591	12510	0	applied	\N	\N	\N	\N	42346	42346	42347
11594	12512	0	applied	\N	\N	\N	\N	42354	42354	42355
11597	12513	0	applied	\N	\N	\N	\N	42359	42359	42360
11597	12514	1	applied	\N	\N	\N	\N	42361	42361	42362
11604	12351	0	applied	\N	\N	\N	\N	39698	39698	41092
11604	12137	1	applied	\N	\N	\N	\N	41224	41224	41225
11604	12360	2	applied	\N	\N	\N	\N	41887	41887	41887
11604	12139	3	applied	\N	\N	\N	\N	41228	41228	41229
11604	12141	4	applied	\N	\N	\N	\N	41235	41235	41236
11604	12142	5	applied	\N	\N	\N	\N	41237	41237	41238
11604	12146	6	applied	\N	\N	\N	\N	41246	41246	41247
11604	12147	7	applied	\N	\N	\N	\N	41248	41248	41249
11604	12150	8	applied	\N	\N	\N	\N	41256	41256	41257
11604	12152	9	applied	\N	\N	\N	\N	41265	41265	41266
11604	12153	10	applied	\N	\N	\N	\N	41267	41267	41268
11604	12156	11	applied	\N	\N	\N	\N	41279	41279	41280
11604	12158	12	applied	\N	\N	\N	\N	41285	41285	41286
11604	12159	13	applied	\N	\N	\N	\N	41287	41287	41288
11604	12162	14	applied	\N	\N	\N	\N	41295	41295	41296
11525	11705	41	applied	\N	\N	\N	\N	40005	40005	40006
11525	11718	42	applied	\N	\N	\N	\N	40042	40042	40043
11525	11540	43	applied	\N	\N	\N	\N	39466	39466	39467
11525	11541	44	applied	\N	\N	\N	\N	39468	39468	39469
11525	11542	45	applied	\N	\N	\N	\N	39474	39474	39475
11525	11545	46	applied	\N	\N	\N	\N	39481	39481	39482
11525	11549	47	applied	\N	\N	\N	\N	39493	39493	39494
11525	11552	48	applied	\N	\N	\N	\N	39501	39501	39502
11525	11553	49	applied	\N	\N	\N	\N	39503	39503	39504
11525	11558	50	applied	\N	\N	\N	\N	39517	39517	39518
11525	11559	51	applied	\N	\N	\N	\N	39525	39525	39526
11525	11561	52	applied	\N	\N	\N	\N	39534	39534	39535
11525	11562	53	applied	\N	\N	\N	\N	39537	39537	39538
11525	11565	54	applied	\N	\N	\N	\N	39544	39544	39545
11525	11567	55	applied	\N	\N	\N	\N	39549	39549	39550
11525	11569	56	applied	\N	\N	\N	\N	39555	39555	39556
11525	11572	57	applied	\N	\N	\N	\N	39562	39562	39563
11525	11573	58	applied	\N	\N	\N	\N	39566	39566	39567
11525	11576	59	applied	\N	\N	\N	\N	39578	39578	39579
11525	11578	60	applied	\N	\N	\N	\N	39588	39588	39589
11525	11582	61	applied	\N	\N	\N	\N	39598	39598	39599
11525	11583	62	applied	\N	\N	\N	\N	39600	39600	39601
11525	11584	63	applied	\N	\N	\N	\N	39602	39602	39603
11525	11588	64	applied	\N	\N	\N	\N	39612	39612	39613
11525	11589	65	applied	\N	\N	\N	\N	39614	39614	39615
11525	11592	66	applied	\N	\N	\N	\N	39624	39624	39625
11525	11593	67	applied	\N	\N	\N	\N	39626	39626	39627
11525	11596	68	applied	\N	\N	\N	\N	39640	39640	39641
11525	11597	69	applied	\N	\N	\N	\N	39642	39642	39643
11525	11598	70	applied	\N	\N	\N	\N	39646	39646	39647
11525	11601	71	applied	\N	\N	\N	\N	39654	39654	39655
11525	11603	72	applied	\N	\N	\N	\N	39668	39668	39669
11525	11605	73	applied	\N	\N	\N	\N	39673	39673	39674
11525	11608	74	applied	\N	\N	\N	\N	39680	39680	39681
11525	11611	75	applied	\N	\N	\N	\N	39686	39686	39687
11525	11613	76	applied	\N	\N	\N	\N	39696	39696	39697
11525	11619	77	applied	\N	\N	\N	\N	39710	39710	39711
11525	11621	78	applied	\N	\N	\N	\N	39716	39716	39717
11525	11623	79	applied	\N	\N	\N	\N	39722	39722	39723
11525	11625	80	applied	\N	\N	\N	\N	39726	39726	39727
11525	11626	81	applied	\N	\N	\N	\N	39733	39733	39734
11525	11633	82	applied	\N	\N	\N	\N	39751	39751	39752
11525	11634	83	applied	\N	\N	\N	\N	39753	39753	39754
11525	11635	84	applied	\N	\N	\N	\N	39755	39755	39756
11525	11636	85	applied	\N	\N	\N	\N	39757	39757	39758
11525	11640	86	applied	\N	\N	\N	\N	39770	39770	39771
11525	11643	87	applied	\N	\N	\N	\N	39777	39777	39778
11525	11644	88	applied	\N	\N	\N	\N	39779	39779	39780
11525	11646	89	applied	\N	\N	\N	\N	39785	39785	39786
11525	11648	90	applied	\N	\N	\N	\N	39803	39803	39804
11525	11650	91	applied	\N	\N	\N	\N	39813	39813	39865
11525	11652	92	applied	\N	\N	\N	\N	39819	39819	39866
11525	11655	93	applied	\N	\N	\N	\N	39835	39835	39867
11525	11656	94	applied	\N	\N	\N	\N	39839	39839	39868
11525	11555	95	applied	\N	\N	\N	\N	39507	39507	39508
11525	11557	96	applied	\N	\N	\N	\N	39515	39515	39516
11525	11560	97	applied	\N	\N	\N	\N	39527	39527	39528
11525	11563	99	applied	\N	\N	\N	\N	39539	39539	39540
11525	11564	100	applied	\N	\N	\N	\N	39541	39541	39542
11525	11566	101	applied	\N	\N	\N	\N	39547	39547	39548
11525	11570	102	applied	\N	\N	\N	\N	39557	39557	39558
11525	11571	103	applied	\N	\N	\N	\N	39560	39560	39561
11525	11574	104	applied	\N	\N	\N	\N	39568	39568	39569
11525	11577	105	applied	\N	\N	\N	\N	39580	39580	39581
11525	11579	106	applied	\N	\N	\N	\N	39590	39590	39591
11525	11580	107	applied	\N	\N	\N	\N	39594	39594	39595
11525	11581	108	applied	\N	\N	\N	\N	39596	39596	39597
11525	11585	109	applied	\N	\N	\N	\N	39604	39604	39605
11525	11586	110	applied	\N	\N	\N	\N	39608	39608	39609
11525	11587	111	applied	\N	\N	\N	\N	39610	39610	39611
11525	11590	112	applied	\N	\N	\N	\N	39620	39620	39621
11525	11591	113	applied	\N	\N	\N	\N	39622	39622	39623
11525	11594	114	applied	\N	\N	\N	\N	39636	39636	39637
11525	11595	115	applied	\N	\N	\N	\N	39638	39638	39639
11525	11599	116	applied	\N	\N	\N	\N	39648	39648	39649
11525	11600	117	applied	\N	\N	\N	\N	39652	39652	39653
11525	11602	118	applied	\N	\N	\N	\N	39659	39659	39660
11525	11604	119	applied	\N	\N	\N	\N	39670	39670	39671
11525	11606	120	applied	\N	\N	\N	\N	39675	39675	39676
11525	11609	121	applied	\N	\N	\N	\N	39682	39682	39683
11525	11610	122	applied	\N	\N	\N	\N	39684	39684	39685
11525	11618	123	applied	\N	\N	\N	\N	39708	39708	39709
11525	11620	124	applied	\N	\N	\N	\N	39714	39714	39715
11525	11622	125	applied	\N	\N	\N	\N	39720	39720	39721
11528	12439	0	applied	\N	\N	\N	\N	42114	42114	42115
11528	12440	1	applied	\N	\N	\N	\N	42116	42116	42117
11528	12441	2	applied	\N	\N	\N	\N	42118	42118	42119
11528	12442	3	applied	\N	\N	\N	\N	42120	42120	42121
11528	12443	4	applied	\N	\N	\N	\N	42122	42122	42123
11530	12446	0	applied	\N	\N	\N	\N	42132	42132	42133
11530	12447	1	applied	\N	\N	\N	\N	42134	42134	42135
11533	12452	0	applied	\N	\N	\N	\N	42149	42149	42150
11533	12453	1	applied	\N	\N	\N	\N	42151	42151	42152
11533	12454	2	applied	\N	\N	\N	\N	42153	42153	42154
11533	12455	3	applied	\N	\N	\N	\N	42155	42155	42156
11533	12456	4	applied	\N	\N	\N	\N	42157	42157	42158
11536	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11536	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11536	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11536	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11536	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11536	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11536	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11540	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11540	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11540	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11540	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11540	12465	4	applied	\N	\N	\N	\N	42180	42180	42181
11540	12466	5	applied	\N	\N	\N	\N	42182	42182	42183
11540	12467	6	applied	\N	\N	\N	\N	42184	42184	42185
11542	12468	0	applied	\N	\N	\N	\N	42196	42196	42197
11542	12469	1	applied	\N	\N	\N	\N	42198	42198	42199
11545	12470	0	applied	\N	\N	\N	\N	42201	42201	42202
11545	12471	1	applied	\N	\N	\N	\N	42203	42203	42204
11547	12472	0	applied	\N	\N	\N	\N	42208	42208	42209
11547	12473	1	applied	\N	\N	\N	\N	42210	42210	42211
11552	12476	0	applied	\N	\N	\N	\N	42222	42222	42223
11555	12478	0	applied	\N	\N	\N	\N	42232	42232	42233
11555	12479	1	applied	\N	\N	\N	\N	42234	42234	42235
11557	12481	0	applied	\N	\N	\N	\N	42242	42242	42243
11558	12483	1	applied	\N	\N	\N	\N	42248	42248	42249
11561	12488	0	applied	\N	\N	\N	\N	42263	42263	42264
11564	12491	0	applied	\N	\N	\N	\N	42274	42274	42275
11568	12492	0	applied	\N	\N	\N	\N	42281	42281	42282
11571	12494	0	applied	\N	\N	\N	\N	42289	42289	42290
11573	12496	0	applied	\N	\N	\N	\N	42297	42297	42298
11576	12498	0	applied	\N	\N	\N	\N	42305	42305	42306
11576	12499	1	applied	\N	\N	\N	\N	42307	42307	42308
11579	12504	0	applied	\N	\N	\N	\N	42321	42321	42322
11586	12507	0	applied	\N	\N	\N	\N	42335	42335	42336
11589	12509	0	applied	\N	\N	\N	\N	42341	42341	42342
11593	12512	0	applied	\N	\N	\N	\N	42354	42354	42355
11596	12513	0	applied	\N	\N	\N	\N	42359	42359	42360
11596	12514	1	applied	\N	\N	\N	\N	42361	42361	42362
11601	12517	0	applied	\N	\N	\N	\N	42376	42376	42377
11601	12518	1	applied	\N	\N	\N	\N	42378	42378	42379
11563	12489	0	applied	\N	\N	\N	\N	42268	42268	42269
11563	12490	1	applied	\N	\N	\N	\N	42270	42270	42271
11566	12491	0	applied	\N	\N	\N	\N	42274	42274	42275
11570	12494	0	applied	\N	\N	\N	\N	42289	42289	42290
11575	12497	0	applied	\N	\N	\N	\N	42302	42302	42303
11578	12502	0	applied	\N	\N	\N	\N	42316	42316	42317
11578	12503	1	applied	\N	\N	\N	\N	42318	42318	42319
11581	12505	0	applied	\N	\N	\N	\N	42323	42323	42324
11585	12506	0	applied	\N	\N	\N	\N	42329	42329	42330
11588	12509	0	applied	\N	\N	\N	\N	42341	42341	42342
11590	12510	0	applied	\N	\N	\N	\N	42346	42346	42347
11595	12513	0	applied	\N	\N	\N	\N	42359	42359	42360
11595	12514	1	applied	\N	\N	\N	\N	42361	42361	42362
11600	12515	0	applied	\N	\N	\N	\N	42367	42367	42368
11600	12516	1	applied	\N	\N	\N	\N	42369	42369	42370
11604	12163	15	applied	\N	\N	\N	\N	41297	41297	41298
11604	12164	16	applied	\N	\N	\N	\N	41299	41299	41300
11604	12168	17	applied	\N	\N	\N	\N	41311	41311	41312
11604	12170	18	applied	\N	\N	\N	\N	41316	41316	41317
11604	12171	19	applied	\N	\N	\N	\N	41318	41318	41319
11604	12174	20	applied	\N	\N	\N	\N	41328	41328	41329
11604	12177	21	applied	\N	\N	\N	\N	41344	41344	41345
11604	12179	22	applied	\N	\N	\N	\N	41350	41350	41351
11604	12181	23	applied	\N	\N	\N	\N	41357	41357	41358
11604	12182	24	applied	\N	\N	\N	\N	41364	41364	41365
11604	12183	25	applied	\N	\N	\N	\N	41366	41366	41367
11604	12184	26	applied	\N	\N	\N	\N	41368	41368	41369
11604	12185	27	applied	\N	\N	\N	\N	41370	41370	41371
11604	12186	28	applied	\N	\N	\N	\N	41372	41372	41373
11604	12192	29	applied	\N	\N	\N	\N	41388	41388	41389
11604	12194	30	applied	\N	\N	\N	\N	41394	41394	41395
11604	12196	31	applied	\N	\N	\N	\N	41399	41399	41400
11604	12197	33	applied	\N	\N	\N	\N	41401	41401	41402
11604	12200	34	applied	\N	\N	\N	\N	41410	41410	41411
11604	12202	35	applied	\N	\N	\N	\N	41417	41417	41418
11604	12203	36	applied	\N	\N	\N	\N	41419	41419	41420
11604	12204	37	applied	\N	\N	\N	\N	41421	41421	41422
11604	12208	38	applied	\N	\N	\N	\N	41432	41432	41433
11604	12210	39	applied	\N	\N	\N	\N	41439	41439	41440
11604	12212	40	applied	\N	\N	\N	\N	41444	41444	41445
11604	12213	41	applied	\N	\N	\N	\N	41446	41446	41447
11604	12216	42	applied	\N	\N	\N	\N	41453	41453	41454
11604	12218	43	applied	\N	\N	\N	\N	41457	41457	41458
11604	12220	44	applied	\N	\N	\N	\N	41465	41465	41466
11604	12221	45	applied	\N	\N	\N	\N	41467	41467	41468
11604	12224	46	applied	\N	\N	\N	\N	41477	41477	41478
11604	12226	47	applied	\N	\N	\N	\N	41483	41483	41484
11604	12228	48	applied	\N	\N	\N	\N	41492	41492	41493
11604	12231	49	applied	\N	\N	\N	\N	41503	41503	41504
11604	12232	50	applied	\N	\N	\N	\N	41506	41506	41507
11604	12235	51	applied	\N	\N	\N	\N	41517	41517	41518
11604	12237	52	applied	\N	\N	\N	\N	41525	41525	41526
11604	12239	53	applied	\N	\N	\N	\N	41532	41532	41533
11604	12240	54	applied	\N	\N	\N	\N	41535	41535	41536
11604	12242	55	applied	\N	\N	\N	\N	41541	41541	41542
11604	12243	56	applied	\N	\N	\N	\N	41543	41543	41544
11604	12246	57	applied	\N	\N	\N	\N	41553	41553	41554
11604	12248	58	applied	\N	\N	\N	\N	41559	41559	41560
11604	12250	59	applied	\N	\N	\N	\N	41566	41566	41567
11604	12251	60	applied	\N	\N	\N	\N	41568	41568	41569
11604	12254	61	applied	\N	\N	\N	\N	41576	41576	41577
11604	12255	62	applied	\N	\N	\N	\N	41578	41578	41579
11604	12258	63	applied	\N	\N	\N	\N	41585	41585	41586
11604	12259	64	applied	\N	\N	\N	\N	41587	41587	41588
11604	12262	65	applied	\N	\N	\N	\N	41595	41595	41596
11604	12265	66	applied	\N	\N	\N	\N	41605	41605	41606
11604	12268	67	applied	\N	\N	\N	\N	41616	41616	41617
11604	12270	68	applied	\N	\N	\N	\N	41622	41622	41623
11604	12272	69	applied	\N	\N	\N	\N	41630	41630	41631
11604	12274	70	applied	\N	\N	\N	\N	41635	41635	41636
11604	12275	71	applied	\N	\N	\N	\N	41637	41637	41638
11604	12278	72	applied	\N	\N	\N	\N	41647	41647	41648
11604	12280	73	applied	\N	\N	\N	\N	41651	41651	41652
11604	12282	74	applied	\N	\N	\N	\N	41664	41664	41665
11604	12283	75	applied	\N	\N	\N	\N	41666	41666	41667
11604	12284	76	applied	\N	\N	\N	\N	41668	41668	41669
11604	12287	77	applied	\N	\N	\N	\N	41677	41677	41678
11604	12289	78	applied	\N	\N	\N	\N	41681	41681	41682
11604	12290	79	applied	\N	\N	\N	\N	41683	41683	41684
11604	12293	80	applied	\N	\N	\N	\N	41691	41691	41692
11604	12296	81	applied	\N	\N	\N	\N	41707	41707	41708
11604	12298	82	applied	\N	\N	\N	\N	41711	41711	41712
11604	12300	83	applied	\N	\N	\N	\N	41716	41716	41717
11604	12301	84	applied	\N	\N	\N	\N	41718	41718	41719
11604	12304	85	applied	\N	\N	\N	\N	41726	41726	41727
11604	12305	86	applied	\N	\N	\N	\N	41728	41728	41729
11604	12308	87	applied	\N	\N	\N	\N	41740	41740	41741
11604	12309	88	applied	\N	\N	\N	\N	41742	41742	41743
11604	12310	89	applied	\N	\N	\N	\N	41744	41744	41745
11604	12314	90	applied	\N	\N	\N	\N	41753	41753	41754
11604	12316	91	applied	\N	\N	\N	\N	41764	41764	41765
11604	12317	92	applied	\N	\N	\N	\N	41766	41766	41767
11604	12320	93	applied	\N	\N	\N	\N	41773	41773	41774
11604	12321	94	applied	\N	\N	\N	\N	41775	41775	41776
11604	12324	95	applied	\N	\N	\N	\N	41783	41783	41784
11604	12327	96	applied	\N	\N	\N	\N	41791	41791	41792
11604	12329	97	applied	\N	\N	\N	\N	41796	41796	41797
11604	12331	98	applied	\N	\N	\N	\N	41805	41805	41806
11604	12333	99	applied	\N	\N	\N	\N	41811	41811	41812
11604	12335	100	applied	\N	\N	\N	\N	41821	41821	41822
11604	12337	101	applied	\N	\N	\N	\N	41827	41827	41828
11604	12339	102	applied	\N	\N	\N	\N	41833	41833	41834
11604	12341	103	applied	\N	\N	\N	\N	41838	41838	41839
11604	12343	104	applied	\N	\N	\N	\N	41844	41844	41845
11604	12345	105	applied	\N	\N	\N	\N	41848	41848	41849
11604	12347	106	applied	\N	\N	\N	\N	41854	41854	41855
11604	12352	107	applied	\N	\N	\N	\N	41867	41867	41868
11604	12353	108	applied	\N	\N	\N	\N	41869	41869	41870
11604	12354	109	applied	\N	\N	\N	\N	41871	41871	41872
11604	12355	110	applied	\N	\N	\N	\N	41873	41873	41874
11604	12361	111	applied	\N	\N	\N	\N	41888	41888	41889
11604	12363	112	applied	\N	\N	\N	\N	41894	41894	41895
11604	12365	113	applied	\N	\N	\N	\N	41900	41900	41901
11604	12367	114	applied	\N	\N	\N	\N	41905	41905	41906
11604	12368	115	applied	\N	\N	\N	\N	41907	41907	41908
11604	12371	116	applied	\N	\N	\N	\N	41917	41917	41918
11604	12373	117	applied	\N	\N	\N	\N	41921	41921	41922
11604	12376	118	applied	\N	\N	\N	\N	41929	41929	41930
11604	12378	119	applied	\N	\N	\N	\N	41941	41941	41942
11604	12379	120	applied	\N	\N	\N	\N	41944	41944	41945
11604	12380	121	applied	\N	\N	\N	\N	41946	41946	41947
11604	12384	122	applied	\N	\N	\N	\N	41960	41960	41961
11604	12385	123	applied	\N	\N	\N	\N	41962	41962	41963
11604	12389	124	applied	\N	\N	\N	\N	41974	41974	41975
11605	12519	0	applied	\N	\N	\N	\N	42388	42388	42389
11605	12520	1	applied	\N	\N	\N	\N	42390	42390	42391
11605	12521	2	applied	\N	\N	\N	\N	42392	42392	42393
11606	12522	0	applied	\N	\N	\N	\N	42396	42396	42397
11606	12523	1	applied	\N	\N	\N	\N	42398	42398	42399
11607	12524	0	applied	\N	\N	\N	\N	42401	42401	42402
11607	12525	1	applied	\N	\N	\N	\N	42403	42403	42404
11608	12524	0	applied	\N	\N	\N	\N	42401	42401	42402
11608	12525	1	applied	\N	\N	\N	\N	42403	42403	42404
11609	12526	0	applied	\N	\N	\N	\N	42409	42409	42410
11609	12527	1	applied	\N	\N	\N	\N	42411	42411	42412
11609	12528	2	applied	\N	\N	\N	\N	42413	42413	42414
11613	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11613	12462	1	applied	\N	\N	\N	\N	42174	42174	42175
11613	12463	2	applied	\N	\N	\N	\N	42176	42176	42177
11613	12464	3	applied	\N	\N	\N	\N	42178	42178	42179
11613	12468	4	applied	\N	\N	\N	\N	42196	42196	42197
11613	12470	5	applied	\N	\N	\N	\N	42201	42201	42202
11613	12472	6	applied	\N	\N	\N	\N	42208	42208	42209
11613	12465	7	applied	\N	\N	\N	\N	42180	42180	42181
11613	12466	8	applied	\N	\N	\N	\N	42182	42182	42183
11613	12467	9	applied	\N	\N	\N	\N	42184	42184	42185
11613	12469	10	applied	\N	\N	\N	\N	42198	42198	42199
11613	12471	11	applied	\N	\N	\N	\N	42203	42203	42204
11613	12473	12	applied	\N	\N	\N	\N	42210	42210	42211
11613	12474	13	applied	\N	\N	\N	\N	42214	42214	42215
11613	12475	14	applied	\N	\N	\N	\N	42218	42218	42219
11613	12476	15	applied	\N	\N	\N	\N	42222	42222	42223
11613	12477	16	applied	\N	\N	\N	\N	42228	42228	42229
11613	12478	17	applied	\N	\N	\N	\N	42232	42232	42233
11613	12479	18	applied	\N	\N	\N	\N	42234	42234	42235
11613	12480	19	applied	\N	\N	\N	\N	42238	42238	42239
11613	12481	20	applied	\N	\N	\N	\N	42242	42242	42243
11613	12482	21	applied	\N	\N	\N	\N	42246	42246	42247
11613	12483	22	applied	\N	\N	\N	\N	42248	42248	42249
11613	12484	23	applied	\N	\N	\N	\N	42252	42252	42253
11613	12485	24	applied	\N	\N	\N	\N	42254	42254	42255
11613	12486	25	applied	\N	\N	\N	\N	42257	42257	42258
11613	12487	26	applied	\N	\N	\N	\N	42259	42259	42260
11613	12488	27	applied	\N	\N	\N	\N	42263	42263	42264
11613	12489	28	applied	\N	\N	\N	\N	42268	42268	42269
11613	12490	29	applied	\N	\N	\N	\N	42270	42270	42271
11613	12491	30	applied	\N	\N	\N	\N	42274	42274	42275
11613	12492	31	applied	\N	\N	\N	\N	42281	42281	42282
11613	12493	32	applied	\N	\N	\N	\N	42286	42286	42287
11613	12494	33	applied	\N	\N	\N	\N	42289	42289	42290
11613	12495	34	applied	\N	\N	\N	\N	42293	42293	42294
11613	12496	35	applied	\N	\N	\N	\N	42297	42297	42298
11613	12497	36	applied	\N	\N	\N	\N	42302	42302	42303
11613	12498	37	applied	\N	\N	\N	\N	42305	42305	42306
11613	12499	38	applied	\N	\N	\N	\N	42307	42307	42308
11613	12500	39	applied	\N	\N	\N	\N	42310	42310	42311
11613	12502	40	applied	\N	\N	\N	\N	42316	42316	42317
11613	12503	41	applied	\N	\N	\N	\N	42318	42318	42319
11613	12504	42	applied	\N	\N	\N	\N	42321	42321	42322
11613	12505	43	applied	\N	\N	\N	\N	42323	42323	42324
11613	12506	44	applied	\N	\N	\N	\N	42329	42329	42330
11613	12507	45	applied	\N	\N	\N	\N	42335	42335	42336
11613	12508	46	applied	\N	\N	\N	\N	42337	42337	42338
11613	12509	47	applied	\N	\N	\N	\N	42341	42341	42342
11613	12510	48	applied	\N	\N	\N	\N	42346	42346	42347
11613	12511	49	applied	\N	\N	\N	\N	42351	42351	42352
11613	12512	50	applied	\N	\N	\N	\N	42354	42354	42355
11613	12513	51	applied	\N	\N	\N	\N	42359	42359	42360
11613	12514	52	applied	\N	\N	\N	\N	42361	42361	42362
11613	12515	53	applied	\N	\N	\N	\N	42367	42367	42368
11613	12516	54	applied	\N	\N	\N	\N	42369	42369	42370
11613	12517	55	applied	\N	\N	\N	\N	42376	42376	42377
11613	12518	56	applied	\N	\N	\N	\N	42378	42378	42379
11613	12519	57	applied	\N	\N	\N	\N	42388	42388	42389
11613	12520	58	applied	\N	\N	\N	\N	42390	42390	42391
11613	12521	59	applied	\N	\N	\N	\N	42392	42392	42393
11613	12522	60	applied	\N	\N	\N	\N	42396	42396	42397
11613	12523	61	applied	\N	\N	\N	\N	42398	42398	42399
11613	12524	62	applied	\N	\N	\N	\N	42401	42401	42402
11613	12525	63	applied	\N	\N	\N	\N	42403	42403	42404
11613	12526	64	applied	\N	\N	\N	\N	42409	42409	42410
11613	12527	65	applied	\N	\N	\N	\N	42411	42411	42412
11613	12528	66	applied	\N	\N	\N	\N	42413	42413	42414
11613	12529	67	applied	\N	\N	\N	\N	42416	42416	42417
11613	12530	68	applied	\N	\N	\N	\N	42420	42420	42421
11613	12531	69	applied	\N	\N	\N	\N	42422	42422	42423
11613	12532	70	applied	\N	\N	\N	\N	42424	42424	42425
11613	12533	71	applied	\N	\N	\N	\N	42428	42428	42429
11613	12534	72	applied	\N	\N	\N	\N	42430	42430	42431
11617	12537	0	applied	\N	\N	\N	\N	42443	42443	42444
11620	12541	0	applied	\N	\N	\N	\N	42455	42455	42456
11623	12542	0	applied	\N	\N	\N	\N	42459	42459	42460
11623	12543	1	applied	\N	\N	\N	\N	42463	42463	42464
11623	12544	2	applied	\N	\N	\N	\N	42465	42465	42466
11627	12551	0	applied	\N	\N	\N	\N	42488	42488	42489
11639	12558	0	applied	\N	\N	\N	\N	42523	42523	42524
11645	12561	0	applied	\N	\N	\N	\N	42535	42535	42536
11650	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11650	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11655	12564	0	applied	\N	\N	\N	\N	42557	42557	42558
11662	12567	0	applied	\N	\N	\N	\N	42572	42572	42573
11666	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11669	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11672	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11678	12578	0	applied	\N	\N	\N	\N	42615	42615	42616
11680	12579	0	applied	\N	\N	\N	\N	42621	42621	42622
11680	12580	1	applied	\N	\N	\N	\N	42623	42623	42624
11680	12581	2	applied	\N	\N	\N	\N	42625	42625	42626
11685	12584	0	applied	\N	\N	\N	\N	42634	42634	42580
11685	12585	1	applied	\N	\N	\N	\N	42635	42635	42636
11685	12586	2	applied	\N	\N	\N	\N	42637	42637	42638
11685	12587	3	applied	\N	\N	\N	\N	42639	42639	42640
11685	12588	4	applied	\N	\N	\N	\N	42641	42641	42642
11685	12589	5	applied	\N	\N	\N	\N	42643	42643	42644
11685	12590	6	applied	\N	\N	\N	\N	42645	42645	42646
11685	12591	7	applied	\N	\N	\N	\N	42647	42647	42648
11685	12592	8	applied	\N	\N	\N	\N	42649	42649	42650
11686	12593	0	applied	\N	\N	\N	\N	42658	42658	42659
11686	12594	1	applied	\N	\N	\N	\N	42660	42660	42661
11693	12597	0	applied	\N	\N	\N	\N	42676	42676	42677
11696	12599	0	applied	\N	\N	\N	\N	42686	42686	42687
11696	12600	1	applied	\N	\N	\N	\N	42688	42688	42689
11698	12602	0	applied	\N	\N	\N	\N	42697	42697	42698
11701	12603	0	applied	\N	\N	\N	\N	42702	42702	42703
11703	12605	0	applied	\N	\N	\N	\N	42712	42712	42713
11706	12607	0	applied	\N	\N	\N	\N	42718	42718	42719
11726	12614	0	applied	\N	\N	\N	\N	42751	42751	42752
11728	12614	0	applied	\N	\N	\N	\N	42751	42751	42752
11728	12615	1	applied	\N	\N	\N	\N	42753	42753	42754
11732	12617	0	applied	\N	\N	\N	\N	42765	42765	42766
11736	12618	0	applied	\N	\N	\N	\N	42767	42767	42768
11736	12619	1	applied	\N	\N	\N	\N	42769	42769	42770
11736	12620	2	applied	\N	\N	\N	\N	42771	42771	42772
11736	12621	3	applied	\N	\N	\N	\N	42773	42773	42774
11736	12622	4	applied	\N	\N	\N	\N	42777	42777	42778
11610	12529	0	applied	\N	\N	\N	\N	42416	42416	42417
11611	12530	0	applied	\N	\N	\N	\N	42420	42420	42421
11611	12531	1	applied	\N	\N	\N	\N	42422	42422	42423
11611	12532	2	applied	\N	\N	\N	\N	42424	42424	42425
11612	12533	0	applied	\N	\N	\N	\N	42428	42428	42429
11612	12534	1	applied	\N	\N	\N	\N	42430	42430	42431
11614	12535	0	applied	\N	\N	\N	\N	42435	42435	42436
11616	12536	0	applied	\N	\N	\N	\N	42440	42440	42441
11619	12538	0	applied	\N	\N	\N	\N	42447	42447	42448
11619	12539	1	applied	\N	\N	\N	\N	42449	42449	42450
11619	12540	2	applied	\N	\N	\N	\N	42451	42451	42452
11624	12542	0	applied	\N	\N	\N	\N	42459	42459	42460
11624	12543	1	applied	\N	\N	\N	\N	42463	42463	42464
11624	12544	2	applied	\N	\N	\N	\N	42465	42465	42466
11625	11243	0	applied	\N	\N	\N	\N	42471	42471	38439
11625	12545	1	applied	\N	\N	\N	\N	42472	42472	42473
11625	12546	2	applied	\N	\N	\N	\N	42474	42474	42475
11625	12547	3	applied	\N	\N	\N	\N	42476	42476	42477
11625	12548	4	applied	\N	\N	\N	\N	42478	42478	42479
11626	12549	0	applied	\N	\N	\N	\N	42482	42482	42483
11626	12550	1	applied	\N	\N	\N	\N	42484	42484	42485
11628	12551	0	applied	\N	\N	\N	\N	42488	42488	42489
11629	12551	0	applied	\N	\N	\N	\N	42488	42488	42489
11630	12552	0	applied	\N	\N	\N	\N	42494	42494	42495
11631	12552	0	applied	\N	\N	\N	\N	42494	42494	42495
11634	12461	0	applied	\N	\N	\N	\N	42173	42173	33908
11634	12417	1	applied	\N	\N	\N	\N	42057	42057	42058
11634	12419	2	applied	\N	\N	\N	\N	42062	42062	42063
11634	12420	3	applied	\N	\N	\N	\N	42064	42064	42065
11634	12423	4	applied	\N	\N	\N	\N	42071	42071	42072
11634	12425	5	applied	\N	\N	\N	\N	42077	42077	42078
11634	12426	6	applied	\N	\N	\N	\N	42079	42079	42080
11634	12427	7	applied	\N	\N	\N	\N	42081	42081	42082
11634	12428	8	applied	\N	\N	\N	\N	42083	42083	42084
11634	12433	9	applied	\N	\N	\N	\N	42101	42101	42102
11634	12434	10	applied	\N	\N	\N	\N	42103	42103	42104
11634	12435	11	applied	\N	\N	\N	\N	42105	42105	42106
11634	12439	12	applied	\N	\N	\N	\N	42114	42114	42115
11634	12440	13	applied	\N	\N	\N	\N	42116	42116	42117
11634	12444	14	applied	\N	\N	\N	\N	42127	42127	42128
11634	12446	15	applied	\N	\N	\N	\N	42132	42132	42133
11634	12448	16	applied	\N	\N	\N	\N	42138	42138	42139
11634	12450	17	applied	\N	\N	\N	\N	42143	42143	42144
11634	12452	18	applied	\N	\N	\N	\N	42149	42149	42150
11634	12457	19	applied	\N	\N	\N	\N	42161	42161	42162
11634	12462	20	applied	\N	\N	\N	\N	42174	42174	42175
11634	12463	21	applied	\N	\N	\N	\N	42176	42176	42177
11634	12464	22	applied	\N	\N	\N	\N	42178	42178	42179
11634	12468	23	applied	\N	\N	\N	\N	42196	42196	42197
11634	12470	24	applied	\N	\N	\N	\N	42201	42201	42202
11634	12472	25	applied	\N	\N	\N	\N	42208	42208	42209
11634	12418	26	applied	\N	\N	\N	\N	42059	42059	42060
11634	12421	27	applied	\N	\N	\N	\N	42066	42066	42067
11634	12422	28	applied	\N	\N	\N	\N	42068	42068	42069
11634	12424	29	applied	\N	\N	\N	\N	42073	42073	42074
11634	12429	30	applied	\N	\N	\N	\N	42085	42085	42086
11634	12443	31	applied	\N	\N	\N	\N	42122	42122	42123
11634	12454	32	applied	\N	\N	\N	\N	42153	42153	42154
11634	12455	33	applied	\N	\N	\N	\N	42155	42155	42156
11634	12456	34	applied	\N	\N	\N	\N	42157	42157	42158
11634	12430	35	applied	\N	\N	\N	\N	42087	42087	42088
11634	12431	36	applied	\N	\N	\N	\N	42089	42089	42090
11634	12432	37	applied	\N	\N	\N	\N	42091	42091	42092
11634	12436	38	applied	\N	\N	\N	\N	42107	42107	42108
11634	12437	39	applied	\N	\N	\N	\N	42109	42109	42110
11634	12438	40	applied	\N	\N	\N	\N	42111	42111	42112
11634	12441	41	applied	\N	\N	\N	\N	42118	42118	42119
11634	12442	42	applied	\N	\N	\N	\N	42120	42120	42121
11634	12445	43	applied	\N	\N	\N	\N	42129	42129	42130
11634	12447	44	applied	\N	\N	\N	\N	42134	42134	42135
11634	12449	45	applied	\N	\N	\N	\N	42140	42140	42141
11634	12451	46	applied	\N	\N	\N	\N	42145	42145	42146
11634	12453	47	applied	\N	\N	\N	\N	42151	42151	42152
11634	12458	48	applied	\N	\N	\N	\N	42163	42163	42164
11634	12459	49	applied	\N	\N	1000000000	\N	42165	42165	42166
11634	12460	50	applied	\N	\N	1000000000	\N	42167	42167	42168
11634	12465	51	applied	\N	\N	\N	\N	42180	42180	42181
11634	12466	52	applied	\N	\N	\N	\N	42182	42182	42183
11634	12467	53	applied	\N	\N	\N	\N	42184	42184	42185
11634	12469	54	applied	\N	\N	\N	\N	42198	42198	42199
11634	12471	55	applied	\N	\N	\N	\N	42203	42203	42204
11634	12473	56	applied	\N	\N	\N	\N	42210	42210	42211
11634	12474	57	applied	\N	\N	\N	\N	42214	42214	42215
11634	12475	58	applied	\N	\N	\N	\N	42218	42218	42219
11634	12476	59	applied	\N	\N	\N	\N	42222	42222	42223
11634	12477	60	applied	\N	\N	\N	\N	42228	42228	42229
11634	12478	61	applied	\N	\N	\N	\N	42232	42232	42233
11634	12479	62	applied	\N	\N	\N	\N	42234	42234	42235
11634	12480	63	applied	\N	\N	\N	\N	42238	42238	42239
11634	12481	64	applied	\N	\N	\N	\N	42242	42242	42243
11634	12482	65	applied	\N	\N	\N	\N	42246	42246	42247
11634	12483	66	applied	\N	\N	\N	\N	42248	42248	42249
11634	12484	67	applied	\N	\N	\N	\N	42252	42252	42253
11634	12485	68	applied	\N	\N	\N	\N	42254	42254	42255
11634	12486	69	applied	\N	\N	\N	\N	42257	42257	42258
11634	12487	70	applied	\N	\N	\N	\N	42259	42259	42260
11634	12488	71	applied	\N	\N	\N	\N	42263	42263	42264
11634	12489	72	applied	\N	\N	\N	\N	42268	42268	42269
11634	12490	73	applied	\N	\N	\N	\N	42270	42270	42271
11634	12491	74	applied	\N	\N	\N	\N	42274	42274	42275
11634	12492	75	applied	\N	\N	\N	\N	42281	42281	42282
11634	12493	76	applied	\N	\N	\N	\N	42286	42286	42287
11634	12494	77	applied	\N	\N	\N	\N	42289	42289	42290
11634	12495	78	applied	\N	\N	\N	\N	42293	42293	42294
11634	12496	79	applied	\N	\N	\N	\N	42297	42297	42298
11634	12497	80	applied	\N	\N	\N	\N	42302	42302	42303
11634	12498	81	applied	\N	\N	\N	\N	42305	42305	42306
11634	12499	82	applied	\N	\N	\N	\N	42307	42307	42308
11634	12500	84	applied	\N	\N	\N	\N	42310	42310	42311
11634	12502	85	applied	\N	\N	\N	\N	42316	42316	42317
11634	12503	86	applied	\N	\N	\N	\N	42318	42318	42319
11634	12504	87	applied	\N	\N	\N	\N	42321	42321	42322
11634	12505	88	applied	\N	\N	\N	\N	42323	42323	42324
11634	12506	89	applied	\N	\N	\N	\N	42329	42329	42330
11634	12507	90	applied	\N	\N	\N	\N	42335	42335	42336
11634	12508	91	applied	\N	\N	\N	\N	42337	42337	42338
11634	12509	92	applied	\N	\N	\N	\N	42341	42341	42342
11634	12510	93	applied	\N	\N	\N	\N	42346	42346	42347
11634	12511	94	applied	\N	\N	\N	\N	42351	42351	42352
11615	12535	0	applied	\N	\N	\N	\N	42435	42435	42436
11618	12536	0	applied	\N	\N	\N	\N	42440	42440	42441
11618	12537	1	applied	\N	\N	\N	\N	42443	42443	42444
11621	12542	0	applied	\N	\N	\N	\N	42459	42459	42460
11632	12552	0	applied	\N	\N	\N	\N	42494	42494	42495
11633	12553	0	applied	\N	\N	\N	\N	42502	42502	42503
11636	12554	0	applied	\N	\N	\N	\N	42510	42510	42511
11636	12555	1	applied	\N	\N	\N	\N	42512	42512	42513
11636	12556	2	applied	\N	\N	\N	\N	42514	42514	42515
11636	12557	3	applied	\N	\N	\N	\N	42516	42516	42517
11644	12561	0	applied	\N	\N	\N	\N	42535	42535	42536
11646	12561	0	applied	\N	\N	\N	\N	42535	42535	42536
11649	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11649	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11652	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11652	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11654	12564	0	applied	\N	\N	\N	\N	42557	42557	42558
11657	12565	0	applied	\N	\N	\N	\N	42563	42563	42564
11659	12566	0	applied	\N	\N	\N	\N	42566	42566	42567
11665	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11668	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11674	12575	0	applied	\N	\N	\N	\N	42607	42607	42608
11677	12578	0	applied	\N	\N	\N	\N	42615	42615	42616
11679	12578	0	applied	\N	\N	\N	\N	42615	42615	42616
11684	12584	0	applied	\N	\N	\N	\N	42634	42634	42580
11684	12585	1	applied	\N	\N	\N	\N	42635	42635	42636
11684	12586	2	applied	\N	\N	\N	\N	42637	42637	42638
11684	12587	3	applied	\N	\N	\N	\N	42639	42639	42640
11684	12588	4	applied	\N	\N	\N	\N	42641	42641	42642
11684	12589	5	applied	\N	\N	\N	\N	42643	42643	42644
11684	12590	6	applied	\N	\N	\N	\N	42645	42645	42646
11684	12591	7	applied	\N	\N	\N	\N	42647	42647	42648
11684	12592	8	applied	\N	\N	\N	\N	42649	42649	42650
11688	12595	0	applied	\N	\N	\N	\N	42666	42666	42667
11691	12596	0	applied	\N	\N	\N	\N	42668	42668	42669
11695	12599	0	applied	\N	\N	\N	\N	42686	42686	42687
11695	12600	1	applied	\N	\N	\N	\N	42688	42688	42689
11700	12603	0	applied	\N	\N	\N	\N	42702	42702	42703
11702	12604	0	applied	\N	\N	\N	\N	42708	42708	42709
11705	12607	0	applied	\N	\N	\N	\N	42718	42718	42719
11712	12610	0	applied	\N	\N	\N	\N	42733	42733	42734
11719	12612	0	applied	\N	\N	\N	\N	42743	42743	42744
11721	12584	0	applied	\N	\N	\N	\N	42634	42634	42580
11721	12585	1	applied	\N	\N	\N	\N	42635	42635	42636
11721	12586	2	applied	\N	\N	\N	\N	42637	42637	42638
11721	12587	3	applied	\N	\N	\N	\N	42639	42639	42640
11721	12588	4	applied	\N	\N	\N	\N	42641	42641	42642
11727	12614	0	applied	\N	\N	\N	\N	42751	42751	42752
11727	12615	1	applied	\N	\N	\N	\N	42753	42753	42754
11730	12616	0	applied	\N	\N	\N	\N	42759	42759	42760
11735	12618	0	applied	\N	\N	\N	\N	42767	42767	42768
11735	12619	1	applied	\N	\N	\N	\N	42769	42769	42770
11735	12620	2	applied	\N	\N	\N	\N	42771	42771	42772
11735	12621	3	applied	\N	\N	\N	\N	42773	42773	42774
11735	12622	4	applied	\N	\N	\N	\N	42777	42777	42778
11735	12623	5	applied	\N	\N	\N	\N	42779	42779	42780
11735	12624	6	applied	\N	\N	\N	\N	42781	42781	42782
11739	12622	0	applied	\N	\N	\N	\N	42777	42777	42778
11739	12623	1	applied	\N	\N	\N	\N	42779	42779	42780
11739	12624	2	applied	\N	\N	\N	\N	42781	42781	42782
11739	12625	3	applied	\N	\N	\N	\N	42790	42790	42791
11739	12626	4	applied	\N	\N	1000000000	\N	42792	42792	42793
11741	12628	0	applied	\N	\N	\N	\N	42798	42798	42799
11744	12630	0	applied	\N	\N	\N	\N	42805	42805	42806
11744	12631	1	applied	\N	\N	\N	\N	42807	42807	42808
11746	12632	0	applied	\N	\N	\N	\N	42811	42811	42812
11749	12634	0	applied	\N	\N	\N	\N	42821	42821	42822
11749	12635	1	applied	\N	\N	\N	\N	42823	42823	42824
11751	12636	0	applied	\N	\N	\N	\N	42827	42827	42828
11756	12639	0	applied	\N	\N	\N	\N	42839	42839	42840
11761	12642	0	applied	\N	\N	\N	\N	42852	42852	42853
11761	12643	1	applied	\N	\N	\N	\N	42854	42854	42855
11764	12646	0	applied	\N	\N	\N	\N	42866	42866	42867
11764	12647	1	applied	\N	\N	\N	\N	42868	42868	42869
11764	12648	2	applied	\N	\N	\N	\N	42870	42870	42871
11764	12649	3	applied	\N	\N	\N	\N	42872	42872	42873
11767	12652	0	applied	\N	\N	\N	\N	42881	42881	42882
11767	12653	1	applied	\N	\N	\N	\N	42883	42883	42884
11769	12654	0	applied	\N	\N	\N	\N	42889	42889	42890
11769	12655	1	applied	\N	\N	\N	\N	42891	42891	42892
11769	12656	2	applied	\N	\N	\N	\N	42893	42893	42894
11772	12657	0	applied	\N	\N	\N	\N	42898	42898	42899
11772	12658	1	applied	\N	\N	\N	\N	42900	42900	42901
11774	12657	0	applied	\N	\N	\N	\N	42898	42898	42899
11774	12658	1	applied	\N	\N	\N	\N	42900	42900	42901
11774	12659	2	applied	\N	\N	\N	\N	42909	42909	42910
11779	12664	0	applied	\N	\N	\N	\N	42924	42924	42925
11781	12665	0	applied	\N	\N	\N	\N	42932	42932	42933
11799	12674	0	applied	\N	\N	\N	\N	42980	42980	42981
11802	12677	0	applied	\N	\N	\N	\N	42989	42989	42990
11805	12678	0	applied	\N	\N	\N	\N	42992	42992	42993
11806	12678	0	applied	\N	\N	\N	\N	42992	42992	42993
11814	12681	0	applied	\N	\N	\N	\N	43003	43003	43004
11819	12685	0	applied	\N	\N	\N	\N	43019	43019	43020
11819	12686	1	applied	\N	\N	\N	\N	43021	43021	43022
11819	12687	2	applied	\N	\N	\N	\N	43023	43023	43024
11821	12689	0	applied	\N	\N	\N	\N	43033	43033	43034
11821	12690	1	applied	\N	\N	\N	\N	43035	43035	43036
11826	12693	0	applied	\N	\N	\N	\N	43049	43049	43050
11826	12694	1	applied	\N	\N	\N	\N	43051	43051	43052
11826	12695	2	applied	\N	\N	\N	\N	43053	43053	43054
11826	12696	3	applied	\N	\N	\N	\N	43055	43055	43056
11826	12697	4	applied	\N	\N	\N	\N	43057	43057	43058
11826	12698	5	applied	\N	\N	\N	\N	43059	43059	43060
11826	12699	6	applied	\N	\N	\N	\N	43061	43061	43062
11826	12700	7	applied	\N	\N	\N	\N	43063	43063	43064
11826	12701	8	applied	\N	\N	\N	\N	43065	43065	43066
11826	12702	9	applied	\N	\N	\N	\N	43067	43067	43068
11826	12703	10	applied	\N	\N	\N	\N	43069	43069	43070
11829	12705	0	applied	\N	\N	\N	\N	43074	43074	43075
11829	12706	1	applied	\N	\N	\N	\N	43076	43076	43077
11833	12709	0	applied	\N	\N	\N	\N	43088	43088	43089
11833	12710	1	applied	\N	\N	\N	\N	43090	43090	43091
11833	12711	2	applied	\N	\N	\N	\N	43092	43092	43093
11833	12712	3	applied	\N	\N	\N	\N	43094	43094	43095
11833	12713	4	applied	\N	\N	\N	\N	43096	43096	43097
11836	12718	0	applied	\N	\N	\N	\N	43113	43113	43114
11841	12723	0	applied	\N	\N	\N	\N	43133	43133	43134
11841	12724	1	applied	\N	\N	\N	\N	43135	43135	43136
11846	12727	0	applied	\N	\N	\N	\N	43149	43149	43150
11634	12512	95	applied	\N	\N	\N	\N	42354	42354	42355
11634	12513	96	applied	\N	\N	\N	\N	42359	42359	42360
11634	12514	97	applied	\N	\N	\N	\N	42361	42361	42362
11634	12515	98	applied	\N	\N	\N	\N	42367	42367	42368
11634	12516	99	applied	\N	\N	\N	\N	42369	42369	42370
11634	12517	100	applied	\N	\N	\N	\N	42376	42376	42377
11634	12518	101	applied	\N	\N	\N	\N	42378	42378	42379
11634	12519	102	applied	\N	\N	\N	\N	42388	42388	42389
11634	12520	103	applied	\N	\N	\N	\N	42390	42390	42391
11634	12521	104	applied	\N	\N	\N	\N	42392	42392	42393
11634	12522	105	applied	\N	\N	\N	\N	42396	42396	42397
11634	12523	106	applied	\N	\N	\N	\N	42398	42398	42399
11634	12524	107	applied	\N	\N	\N	\N	42401	42401	42402
11634	12525	108	applied	\N	\N	\N	\N	42403	42403	42404
11634	12526	109	applied	\N	\N	\N	\N	42409	42409	42410
11634	12527	110	applied	\N	\N	\N	\N	42411	42411	42412
11634	12528	111	applied	\N	\N	\N	\N	42413	42413	42414
11634	12529	112	applied	\N	\N	\N	\N	42416	42416	42417
11635	12554	0	applied	\N	\N	\N	\N	42510	42510	42511
11635	12555	1	applied	\N	\N	\N	\N	42512	42512	42513
11635	12556	2	applied	\N	\N	\N	\N	42514	42514	42515
11635	12557	3	applied	\N	\N	\N	\N	42516	42516	42517
11640	12559	0	applied	\N	\N	\N	\N	42527	42527	42528
11640	12560	1	applied	\N	\N	\N	\N	42529	42529	42530
11647	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11647	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11653	12564	0	applied	\N	\N	\N	\N	42557	42557	42558
11660	12567	0	applied	\N	\N	\N	\N	42572	42572	42573
11663	12568	0	applied	\N	\N	1000000000	\N	42580	42580	42581
11663	12569	1	applied	\N	\N	\N	\N	42582	42582	42583
11663	12570	2	applied	\N	\N	\N	\N	42584	42584	42585
11663	12571	3	applied	\N	\N	\N	\N	42586	42586	42587
11663	12572	4	applied	\N	\N	\N	\N	42588	42588	42589
11670	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11673	12574	0	applied	\N	\N	\N	\N	42604	42604	42605
11675	12576	0	applied	\N	\N	\N	\N	42609	42609	42610
11681	12582	0	applied	\N	\N	\N	\N	42628	42628	42629
11681	12583	1	applied	\N	\N	\N	\N	42630	42630	42631
11682	12584	0	applied	\N	\N	\N	\N	42634	42634	42580
11682	12585	1	applied	\N	\N	\N	\N	42635	42635	42636
11682	12586	2	applied	\N	\N	\N	\N	42637	42637	42638
11682	12587	3	applied	\N	\N	\N	\N	42639	42639	42640
11682	12588	4	applied	\N	\N	\N	\N	42641	42641	42642
11682	12589	5	applied	\N	\N	\N	\N	42643	42643	42644
11682	12590	6	applied	\N	\N	\N	\N	42645	42645	42646
11682	12591	7	applied	\N	\N	\N	\N	42647	42647	42648
11682	12592	8	applied	\N	\N	\N	\N	42649	42649	42650
11687	12593	0	applied	\N	\N	\N	\N	42658	42658	42659
11687	12594	1	applied	\N	\N	\N	\N	42660	42660	42661
11689	12596	0	applied	\N	\N	\N	\N	42668	42668	42669
11707	12607	0	applied	\N	\N	\N	\N	42718	42718	42719
11708	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11708	11243	1	applied	\N	\N	\N	\N	42471	42471	38439
11708	12568	2	applied	\N	\N	1000000000	\N	42580	42580	42581
11708	12585	3	applied	\N	\N	\N	\N	42635	42635	42636
11708	12586	4	applied	\N	\N	\N	\N	42637	42637	42638
11708	12587	5	applied	\N	\N	\N	\N	42639	42639	42640
11708	12588	6	applied	\N	\N	\N	\N	42641	42641	42642
11715	12611	0	applied	\N	\N	\N	\N	42738	42738	42739
11731	12616	0	applied	\N	\N	\N	\N	42759	42759	42760
11733	12617	0	applied	\N	\N	\N	\N	42765	42765	42766
11737	12618	0	applied	\N	\N	\N	\N	42767	42767	42768
11737	12619	1	applied	\N	\N	\N	\N	42769	42769	42770
11737	12620	2	applied	\N	\N	\N	\N	42771	42771	42772
11737	12621	3	applied	\N	\N	\N	\N	42773	42773	42774
11737	12622	4	applied	\N	\N	\N	\N	42777	42777	42778
11737	12623	5	applied	\N	\N	\N	\N	42779	42779	42780
11737	12624	6	applied	\N	\N	\N	\N	42781	42781	42782
11740	12627	0	applied	\N	\N	\N	\N	42795	42795	42796
11750	12634	0	applied	\N	\N	\N	\N	42821	42821	42822
11750	12635	1	applied	\N	\N	\N	\N	42823	42823	42824
11755	12638	0	applied	\N	\N	\N	\N	42835	42835	42836
11760	12642	0	applied	\N	\N	\N	\N	42852	42852	42853
11760	12643	1	applied	\N	\N	\N	\N	42854	42854	42855
11763	12644	0	applied	\N	\N	\N	\N	42860	42860	42861
11763	12645	1	applied	\N	\N	\N	\N	42862	42862	42863
11768	12652	0	applied	\N	\N	\N	\N	42881	42881	42882
11768	12653	1	applied	\N	\N	\N	\N	42883	42883	42884
11770	12654	0	applied	\N	\N	\N	\N	42889	42889	42890
11770	12655	1	applied	\N	\N	\N	\N	42891	42891	42892
11770	12656	2	applied	\N	\N	\N	\N	42893	42893	42894
11780	12664	0	applied	\N	\N	\N	\N	42924	42924	42925
11783	12665	0	applied	\N	\N	\N	\N	42932	42932	42933
11784	12665	0	applied	\N	\N	\N	\N	42932	42932	42933
11788	12666	0	applied	\N	\N	\N	\N	42940	42940	42941
11788	12667	1	applied	\N	\N	\N	\N	42942	42942	42943
11791	12669	0	applied	\N	\N	\N	\N	42954	42954	42955
11791	12670	1	applied	\N	\N	\N	\N	42956	42956	42957
11794	12671	0	applied	\N	\N	\N	\N	42962	42962	42963
11798	12673	0	applied	\N	\N	\N	\N	42976	42976	42977
11803	12678	0	applied	\N	\N	\N	\N	42992	42992	42993
11810	12680	0	applied	\N	\N	\N	\N	42998	42998	42999
11812	12681	0	applied	\N	\N	\N	\N	43003	43003	43004
11816	12682	0	applied	\N	\N	\N	\N	43009	43009	43010
11820	12688	0	applied	\N	\N	\N	\N	43029	43029	43030
11825	12692	0	applied	\N	\N	\N	\N	43043	43043	43044
11828	12705	0	applied	\N	\N	\N	\N	43074	43074	43075
11828	12706	1	applied	\N	\N	\N	\N	43076	43076	43077
11837	12719	0	applied	\N	\N	1000000000	\N	43117	43117	43118
11837	12720	1	applied	\N	\N	\N	\N	43119	43119	43120
11843	12725	0	applied	\N	\N	\N	\N	43139	43139	43140
11845	12727	0	applied	\N	\N	\N	\N	43149	43149	43150
11855	12730	0	applied	\N	\N	\N	\N	43164	43164	43165
11857	12731	0	applied	\N	\N	\N	\N	43169	43169	43170
11857	12732	1	applied	\N	\N	\N	\N	43171	43171	43172
11859	12733	0	applied	\N	\N	\N	\N	43176	43176	43177
11864	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11864	12693	1	applied	\N	\N	\N	\N	43049	43049	43050
11864	12433	2	applied	\N	\N	\N	\N	42101	42101	42102
11864	12461	3	applied	\N	\N	\N	\N	42173	42173	33908
11864	12735	4	applied	\N	\N	\N	\N	43192	43192	43184
11864	12646	5	applied	\N	\N	\N	\N	42866	42866	42867
11864	12647	6	applied	\N	\N	\N	\N	42868	42868	42869
11864	12568	7	applied	\N	\N	1000000000	\N	42580	42580	42581
11864	12694	8	applied	\N	\N	\N	\N	43051	43051	43052
11864	12618	9	applied	\N	\N	\N	\N	42767	42767	42768
11864	12695	10	applied	\N	\N	\N	\N	43053	43053	43054
11864	12650	11	applied	\N	\N	\N	\N	42876	42876	42877
11864	12652	12	applied	\N	\N	\N	\N	42881	42881	42882
11641	12559	0	applied	\N	\N	\N	\N	42527	42527	42528
11641	12560	1	applied	\N	\N	\N	\N	42529	42529	42530
11643	12561	0	applied	\N	\N	\N	\N	42535	42535	42536
11648	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11648	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11651	12562	0	applied	\N	\N	\N	\N	42543	42543	42544
11651	12563	1	applied	\N	\N	\N	\N	42545	42545	42546
11656	12565	0	applied	\N	\N	\N	\N	42563	42563	42564
11658	12566	0	applied	\N	\N	\N	\N	42566	42566	42567
11664	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11667	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11671	12573	0	applied	\N	\N	\N	\N	42591	42591	42592
11676	12577	0	applied	\N	\N	\N	\N	42611	42611	42612
11683	12584	0	applied	\N	\N	\N	\N	42634	42634	42580
11683	12585	1	applied	\N	\N	\N	\N	42635	42635	42636
11683	12586	2	applied	\N	\N	\N	\N	42637	42637	42638
11683	12587	3	applied	\N	\N	\N	\N	42639	42639	42640
11683	12588	4	applied	\N	\N	\N	\N	42641	42641	42642
11683	12589	5	applied	\N	\N	\N	\N	42643	42643	42644
11683	12590	6	applied	\N	\N	\N	\N	42645	42645	42646
11683	12591	7	applied	\N	\N	\N	\N	42647	42647	42648
11683	12592	8	applied	\N	\N	\N	\N	42649	42649	42650
11690	12596	0	applied	\N	\N	\N	\N	42668	42668	42669
11692	12597	0	applied	\N	\N	\N	\N	42676	42676	42677
11694	12598	0	applied	\N	\N	\N	\N	42682	42682	42683
11697	12601	0	applied	\N	\N	\N	\N	42693	42693	42694
11699	12602	0	applied	\N	\N	\N	\N	42697	42697	42698
11704	12606	0	applied	\N	\N	\N	\N	42714	42714	42715
11711	12608	0	applied	\N	\N	\N	\N	42727	42727	42728
11711	12609	1	applied	\N	\N	\N	\N	42729	42729	42730
11714	12611	0	applied	\N	\N	\N	\N	42738	42738	42739
11718	12612	0	applied	\N	\N	\N	\N	42743	42743	42744
11720	12613	0	applied	\N	\N	\N	\N	42748	42748	42749
11729	12616	0	applied	\N	\N	\N	\N	42759	42759	42760
11734	12618	0	applied	\N	\N	\N	\N	42767	42767	42768
11734	12619	1	applied	\N	\N	\N	\N	42769	42769	42770
11734	12620	2	applied	\N	\N	\N	\N	42771	42771	42772
11734	12621	3	applied	\N	\N	\N	\N	42773	42773	42774
11743	12629	0	applied	\N	\N	\N	\N	42801	42801	42802
11748	12633	0	applied	\N	\N	\N	\N	42815	42815	42816
11758	12640	0	applied	\N	\N	\N	\N	42845	42845	42846
11758	12641	1	applied	\N	\N	\N	\N	42847	42847	42848
11766	12652	0	applied	\N	\N	\N	\N	42881	42881	42882
11766	12653	1	applied	\N	\N	\N	\N	42883	42883	42884
11771	12657	0	applied	\N	\N	\N	\N	42898	42898	42899
11771	12658	1	applied	\N	\N	\N	\N	42900	42900	42901
11773	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11773	12646	1	applied	\N	\N	\N	\N	42866	42866	42867
11773	12647	2	applied	\N	\N	\N	\N	42868	42868	42869
11773	12568	3	applied	\N	\N	1000000000	\N	42580	42580	42581
11773	12618	4	applied	\N	\N	\N	\N	42767	42767	42768
11773	12650	5	applied	\N	\N	\N	\N	42876	42876	42877
11773	12652	6	applied	\N	\N	\N	\N	42881	42881	42882
11773	12654	7	applied	\N	\N	\N	\N	42889	42889	42890
11773	12655	8	applied	\N	\N	\N	\N	42891	42891	42892
11773	12657	9	applied	\N	\N	\N	\N	42898	42898	42899
11773	12585	10	applied	\N	\N	\N	\N	42635	42635	42636
11773	12586	11	applied	\N	\N	\N	\N	42637	42637	42638
11773	12587	12	applied	\N	\N	\N	\N	42639	42639	42640
11773	12588	13	applied	\N	\N	\N	\N	42641	42641	42642
11773	12619	14	applied	\N	\N	\N	\N	42769	42769	42770
11773	12620	15	applied	\N	\N	\N	\N	42771	42771	42772
11773	12621	16	applied	\N	\N	\N	\N	42773	42773	42774
11773	12535	17	applied	\N	\N	\N	\N	42435	42435	42436
11773	12536	18	applied	\N	\N	\N	\N	42440	42440	42441
11773	12537	19	applied	\N	\N	\N	\N	42443	42443	42444
11773	12538	20	applied	\N	\N	\N	\N	42447	42447	42448
11773	12539	21	applied	\N	\N	\N	\N	42449	42449	42450
11773	12540	22	applied	\N	\N	\N	\N	42451	42451	42452
11773	12541	23	applied	\N	\N	\N	\N	42455	42455	42456
11773	12542	24	applied	\N	\N	\N	\N	42459	42459	42460
11773	12543	25	applied	\N	\N	\N	\N	42463	42463	42464
11773	12544	26	applied	\N	\N	\N	\N	42465	42465	42466
11773	12545	27	applied	\N	\N	\N	\N	42472	42472	42473
11773	12546	28	applied	\N	\N	\N	\N	42474	42474	42475
11773	12547	29	applied	\N	\N	\N	\N	42476	42476	42477
11773	12548	30	applied	\N	\N	\N	\N	42478	42478	42479
11773	12549	31	applied	\N	\N	\N	\N	42482	42482	42483
11773	12550	32	applied	\N	\N	\N	\N	42484	42484	42485
11773	12551	33	applied	\N	\N	\N	\N	42488	42488	42489
11773	12552	34	applied	\N	\N	\N	\N	42494	42494	42495
11773	12553	35	applied	\N	\N	\N	\N	42502	42502	42503
11773	12554	36	applied	\N	\N	\N	\N	42510	42510	42511
11773	12555	37	applied	\N	\N	\N	\N	42512	42512	42513
11773	12556	38	applied	\N	\N	\N	\N	42514	42514	42515
11773	12557	39	applied	\N	\N	\N	\N	42516	42516	42517
11773	12558	40	applied	\N	\N	\N	\N	42523	42523	42524
11773	12559	41	applied	\N	\N	\N	\N	42527	42527	42528
11773	12560	42	applied	\N	\N	\N	\N	42529	42529	42530
11773	12561	43	applied	\N	\N	\N	\N	42535	42535	42536
11773	12562	44	applied	\N	\N	\N	\N	42543	42543	42544
11773	12563	45	applied	\N	\N	\N	\N	42545	42545	42546
11773	12564	46	applied	\N	\N	\N	\N	42557	42557	42558
11773	12565	47	applied	\N	\N	\N	\N	42563	42563	42564
11773	12566	48	applied	\N	\N	\N	\N	42566	42566	42567
11773	12567	49	applied	\N	\N	\N	\N	42572	42572	42573
11773	12569	50	applied	\N	\N	\N	\N	42582	42582	42583
11773	12570	52	applied	\N	\N	\N	\N	42584	42584	42585
11773	12571	53	applied	\N	\N	\N	\N	42586	42586	42587
11773	12572	54	applied	\N	\N	\N	\N	42588	42588	42589
11773	12573	55	applied	\N	\N	\N	\N	42591	42591	42592
11773	12574	56	applied	\N	\N	\N	\N	42604	42604	42605
11773	12575	57	applied	\N	\N	\N	\N	42607	42607	42608
11773	12576	58	applied	\N	\N	\N	\N	42609	42609	42610
11773	12577	59	applied	\N	\N	\N	\N	42611	42611	42612
11773	12578	60	applied	\N	\N	\N	\N	42615	42615	42616
11773	12579	61	applied	\N	\N	\N	\N	42621	42621	42622
11773	12580	62	applied	\N	\N	\N	\N	42623	42623	42624
11773	12581	63	applied	\N	\N	\N	\N	42625	42625	42626
11773	12582	64	applied	\N	\N	\N	\N	42628	42628	42629
11773	12583	65	applied	\N	\N	\N	\N	42630	42630	42631
11773	12589	66	applied	\N	\N	\N	\N	42643	42643	42644
11773	12590	67	applied	\N	\N	\N	\N	42645	42645	42646
11773	12591	68	applied	\N	\N	\N	\N	42647	42647	42648
11773	12592	69	applied	\N	\N	\N	\N	42649	42649	42650
11773	12593	70	applied	\N	\N	\N	\N	42658	42658	42659
11773	12594	71	applied	\N	\N	\N	\N	42660	42660	42661
11773	12595	72	applied	\N	\N	\N	\N	42666	42666	42667
11773	12596	73	applied	\N	\N	\N	\N	42668	42668	42669
11773	12597	74	applied	\N	\N	\N	\N	42676	42676	42677
11736	12623	5	applied	\N	\N	\N	\N	42779	42779	42780
11736	12624	6	applied	\N	\N	\N	\N	42781	42781	42782
11742	12628	0	applied	\N	\N	\N	\N	42798	42798	42799
11745	12630	0	applied	\N	\N	\N	\N	42805	42805	42806
11745	12631	1	applied	\N	\N	\N	\N	42807	42807	42808
11747	12633	0	applied	\N	\N	\N	\N	42815	42815	42816
11752	12637	0	applied	\N	\N	\N	\N	42831	42831	42832
11757	12639	0	applied	\N	\N	\N	\N	42839	42839	42840
11759	12640	0	applied	\N	\N	\N	\N	42845	42845	42846
11759	12641	1	applied	\N	\N	\N	\N	42847	42847	42848
11762	12644	0	applied	\N	\N	\N	\N	42860	42860	42861
11762	12645	1	applied	\N	\N	\N	\N	42862	42862	42863
11765	12650	0	applied	\N	\N	\N	\N	42876	42876	42877
11765	12651	1	applied	\N	\N	\N	\N	42878	42878	42879
11777	12663	0	applied	\N	\N	\N	\N	42921	42921	42922
11782	12665	0	applied	\N	\N	\N	\N	42932	42932	42933
11787	12666	0	applied	\N	\N	\N	\N	42940	42940	42941
11787	12667	1	applied	\N	\N	\N	\N	42942	42942	42943
11790	12668	0	applied	\N	\N	\N	\N	42950	42950	42951
11793	12671	0	applied	\N	\N	\N	\N	42962	42962	42963
11795	12671	0	applied	\N	\N	\N	\N	42962	42962	42963
11797	12672	0	applied	\N	\N	\N	\N	42974	42974	42975
11800	12675	0	applied	\N	\N	\N	\N	42982	42982	42983
11800	12676	1	applied	\N	\N	\N	\N	42984	42984	42985
11807	12678	0	applied	\N	\N	\N	\N	42992	42992	42993
11809	12680	0	applied	\N	\N	\N	\N	42998	42998	42999
11815	12681	0	applied	\N	\N	\N	\N	43003	43003	43004
11822	12691	0	applied	\N	\N	\N	\N	43039	43039	43040
11824	12692	0	applied	\N	\N	\N	\N	43043	43043	43044
11827	12704	0	applied	\N	\N	\N	\N	43072	43072	43073
11830	12705	0	applied	\N	\N	\N	\N	43074	43074	43075
11830	12706	1	applied	\N	\N	\N	\N	43076	43076	43077
11834	12709	0	applied	\N	\N	\N	\N	43088	43088	43089
11834	12710	1	applied	\N	\N	\N	\N	43090	43090	43091
11834	12711	2	applied	\N	\N	\N	\N	43092	43092	43093
11834	12712	3	applied	\N	\N	\N	\N	43094	43094	43095
11834	12713	4	applied	\N	\N	\N	\N	43096	43096	43097
11839	12721	0	applied	\N	\N	\N	\N	43123	43123	43124
11842	12725	0	applied	\N	\N	\N	\N	43139	43139	43140
11844	12726	0	applied	\N	\N	\N	\N	43145	43145	43146
11847	12727	0	applied	\N	\N	\N	\N	43149	43149	43150
11851	12728	0	applied	\N	\N	1000000000	\N	43157	43157	43158
11851	12729	1	applied	\N	\N	\N	\N	43159	43159	43160
11854	12693	0	applied	\N	\N	\N	\N	43049	43049	43050
11854	12694	1	applied	\N	\N	\N	\N	43051	43051	43052
11854	12695	2	applied	\N	\N	\N	\N	43053	43053	43054
11854	12696	3	applied	\N	\N	\N	\N	43055	43055	43056
11854	12697	4	applied	\N	\N	\N	\N	43057	43057	43058
11854	12698	5	applied	\N	\N	\N	\N	43059	43059	43060
11854	12699	6	applied	\N	\N	\N	\N	43061	43061	43062
11854	12700	7	applied	\N	\N	\N	\N	43063	43063	43064
11854	12701	8	applied	\N	\N	\N	\N	43065	43065	43066
11856	12731	0	applied	\N	\N	\N	\N	43169	43169	43170
11856	12732	1	applied	\N	\N	\N	\N	43171	43171	43172
11861	12734	0	applied	\N	\N	\N	\N	43178	43178	43179
11863	12735	0	applied	\N	\N	\N	\N	43183	43183	43184
11863	12736	1	applied	\N	\N	\N	\N	43185	43185	43186
11863	12737	2	applied	\N	\N	\N	\N	43187	43187	43188
11866	12738	0	applied	\N	\N	\N	\N	43196	43196	43197
11868	12739	0	applied	\N	\N	\N	\N	43201	43201	43202
11870	12740	0	applied	\N	\N	\N	\N	43209	43209	43210
11870	12741	1	applied	\N	\N	\N	\N	43211	43211	43212
11873	12745	0	applied	\N	\N	\N	\N	43225	43225	43226
11873	12746	1	applied	\N	\N	\N	\N	43227	43227	43228
11873	12747	2	applied	\N	\N	\N	\N	43229	43229	43230
11876	12748	0	applied	\N	\N	\N	\N	43232	43232	43233
11878	12693	0	applied	\N	\N	\N	\N	43049	43049	43050
11878	12735	1	applied	\N	\N	\N	\N	43183	43183	43184
11878	12740	2	applied	\N	\N	\N	\N	43209	43209	43210
11878	12745	3	applied	\N	\N	\N	\N	43225	43225	43226
11878	12750	4	applied	\N	\N	\N	\N	43243	43243	43244
11878	12646	5	applied	\N	\N	\N	\N	42866	42866	42867
11883	12752	0	applied	\N	\N	\N	\N	43257	43257	43258
11883	12753	1	applied	\N	\N	\N	\N	43259	43259	43260
11883	12754	2	applied	\N	\N	\N	\N	43261	43261	43262
11883	12755	3	applied	\N	\N	\N	\N	43263	43263	43264
11885	12756	0	applied	\N	\N	\N	\N	43270	43270	43271
11890	12759	0	applied	\N	\N	\N	\N	43280	43280	43281
11893	12762	0	applied	\N	\N	\N	\N	43289	43289	43290
11893	12763	1	applied	\N	\N	\N	\N	43291	43291	43292
11899	12770	0	applied	\N	\N	\N	\N	43321	43321	43322
11899	12771	1	applied	\N	\N	\N	\N	43323	43323	43324
11901	12772	0	applied	\N	\N	\N	\N	43327	43327	43328
11904	12775	0	applied	\N	\N	\N	\N	43337	43337	43338
11912	12782	0	applied	\N	\N	\N	\N	43361	43361	43362
11914	12783	0	applied	\N	\N	\N	\N	43366	43366	43367
11921	12787	0	applied	\N	\N	\N	\N	43384	43384	43385
11921	12788	1	applied	\N	\N	\N	\N	43386	43386	43387
11924	12791	0	applied	\N	\N	\N	\N	43396	43396	43397
11927	12795	0	applied	\N	\N	\N	\N	43410	43410	43411
11930	12797	0	applied	\N	\N	\N	\N	43420	43420	43421
11930	12798	1	applied	\N	\N	\N	\N	43422	43422	43423
11930	12799	2	applied	\N	\N	\N	\N	43424	43424	43425
11932	12800	0	applied	\N	\N	\N	\N	43429	43429	43430
11943	12815	0	applied	\N	\N	\N	\N	43475	43475	43476
11945	12816	0	applied	\N	\N	\N	\N	43481	43481	43482
11948	12822	0	applied	\N	\N	\N	\N	43500	43500	43501
11948	12823	1	applied	\N	\N	\N	\N	43502	43502	43503
11952	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
11952	12819	1	applied	\N	\N	\N	\N	43491	43491	43492
11952	12820	2	applied	\N	\N	\N	\N	43493	43493	43494
11952	12821	3	applied	\N	\N	\N	\N	43495	43495	43496
11952	12802	4	applied	\N	\N	\N	\N	43442	43442	43443
11952	12803	5	applied	\N	\N	\N	\N	43444	43444	43445
11952	12804	6	applied	\N	\N	\N	\N	43446	43446	43447
11952	12805	7	applied	\N	\N	\N	\N	43451	43451	43452
11952	12818	8	applied	\N	\N	\N	\N	43497	43497	43488
11952	12806	9	applied	\N	\N	\N	\N	43453	43453	43454
11952	12808	10	applied	\N	\N	\N	\N	43458	43458	43459
11952	12809	11	applied	\N	\N	\N	\N	43460	43460	43461
11952	12813	12	applied	\N	\N	\N	\N	43468	43468	43469
11952	12814	13	applied	\N	\N	\N	\N	43470	43470	43471
11952	12815	14	applied	\N	\N	\N	\N	43475	43475	43476
11952	12816	15	applied	\N	\N	\N	\N	43481	43481	43482
11952	12817	16	applied	\N	\N	\N	\N	43485	43485	43486
11952	12822	17	applied	\N	\N	\N	\N	43500	43500	43501
11952	12823	18	applied	\N	\N	\N	\N	43502	43502	43503
11952	12824	19	applied	\N	\N	\N	\N	43512	43512	43513
11955	12826	0	applied	\N	\N	\N	\N	43521	43521	43522
11955	12827	1	applied	\N	\N	\N	\N	43523	43523	43524
11773	12598	75	applied	\N	\N	\N	\N	42682	42682	42683
11773	12599	76	applied	\N	\N	\N	\N	42686	42686	42687
11773	12600	77	applied	\N	\N	\N	\N	42688	42688	42689
11773	12601	78	applied	\N	\N	\N	\N	42693	42693	42694
11773	12602	79	applied	\N	\N	\N	\N	42697	42697	42698
11773	12603	80	applied	\N	\N	\N	\N	42702	42702	42703
11773	12604	81	applied	\N	\N	\N	\N	42708	42708	42709
11773	12605	82	applied	\N	\N	\N	\N	42712	42712	42713
11773	12606	83	applied	\N	\N	\N	\N	42714	42714	42715
11773	12607	84	applied	\N	\N	\N	\N	42718	42718	42719
11773	12608	85	applied	\N	\N	\N	\N	42727	42727	42728
11773	12609	86	applied	\N	\N	\N	\N	42729	42729	42730
11773	12610	87	applied	\N	\N	\N	\N	42733	42733	42734
11773	12611	88	applied	\N	\N	\N	\N	42738	42738	42739
11773	12612	89	applied	\N	\N	\N	\N	42743	42743	42744
11773	12613	90	applied	\N	\N	\N	\N	42748	42748	42749
11773	12614	91	applied	\N	\N	\N	\N	42751	42751	42752
11773	12615	92	applied	\N	\N	\N	\N	42753	42753	42754
11773	12616	93	applied	\N	\N	\N	\N	42759	42759	42760
11773	12617	94	applied	\N	\N	\N	\N	42765	42765	42766
11773	12622	95	applied	\N	\N	\N	\N	42777	42777	42778
11773	12623	96	applied	\N	\N	\N	\N	42779	42779	42780
11773	12624	97	applied	\N	\N	\N	\N	42781	42781	42782
11773	12625	98	applied	\N	\N	\N	\N	42790	42790	42791
11773	12626	99	applied	\N	\N	1000000000	\N	42792	42792	42793
11773	12627	100	applied	\N	\N	\N	\N	42795	42795	42796
11773	12628	101	applied	\N	\N	\N	\N	42798	42798	42799
11773	12629	102	applied	\N	\N	\N	\N	42801	42801	42802
11773	12630	103	applied	\N	\N	\N	\N	42805	42805	42806
11773	12631	104	applied	\N	\N	\N	\N	42807	42807	42808
11773	12632	105	applied	\N	\N	\N	\N	42811	42811	42812
11773	12633	106	applied	\N	\N	\N	\N	42815	42815	42816
11773	12634	107	applied	\N	\N	\N	\N	42821	42821	42822
11773	12635	108	applied	\N	\N	\N	\N	42823	42823	42824
11773	12636	109	applied	\N	\N	\N	\N	42827	42827	42828
11773	12637	110	applied	\N	\N	\N	\N	42831	42831	42832
11773	12638	111	applied	\N	\N	\N	\N	42835	42835	42836
11773	12639	112	applied	\N	\N	\N	\N	42839	42839	42840
11773	12640	113	applied	\N	\N	\N	\N	42845	42845	42846
11773	12641	114	applied	\N	\N	\N	\N	42847	42847	42848
11773	12642	115	applied	\N	\N	\N	\N	42852	42852	42853
11773	12643	116	applied	\N	\N	\N	\N	42854	42854	42855
11773	12644	117	applied	\N	\N	\N	\N	42860	42860	42861
11773	12645	118	applied	\N	\N	\N	\N	42862	42862	42863
11773	12648	119	applied	\N	\N	\N	\N	42870	42870	42871
11773	12649	120	applied	\N	\N	\N	\N	42872	42872	42873
11773	12651	121	applied	\N	\N	\N	\N	42878	42878	42879
11773	12653	122	applied	\N	\N	\N	\N	42883	42883	42884
11773	12656	123	applied	\N	\N	\N	\N	42893	42893	42894
11773	12658	124	applied	\N	\N	\N	\N	42900	42900	42901
11775	12659	0	applied	\N	\N	\N	\N	42909	42909	42910
11775	12660	1	applied	\N	\N	\N	\N	42912	42912	7825
11776	12661	0	applied	\N	\N	\N	\N	42915	42915	42916
11776	12662	1	applied	\N	\N	\N	\N	42917	42917	42918
11778	12664	0	applied	\N	\N	\N	\N	42924	42924	42925
11785	12666	0	applied	\N	\N	\N	\N	42940	42940	42941
11785	12667	1	applied	\N	\N	\N	\N	42942	42942	42943
11789	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11789	12646	1	applied	\N	\N	\N	\N	42866	42866	42867
11789	12647	2	applied	\N	\N	\N	\N	42868	42868	42869
11789	12568	3	applied	\N	\N	1000000000	\N	42580	42580	42581
11789	12618	4	applied	\N	\N	\N	\N	42767	42767	42768
11789	12650	5	applied	\N	\N	\N	\N	42876	42876	42877
11789	12652	6	applied	\N	\N	\N	\N	42881	42881	42882
11789	12654	7	applied	\N	\N	\N	\N	42889	42889	42890
11789	12655	8	applied	\N	\N	\N	\N	42891	42891	42892
11789	12657	9	applied	\N	\N	\N	\N	42898	42898	42899
11789	12585	10	applied	\N	\N	\N	\N	42635	42635	42636
11789	12586	11	applied	\N	\N	\N	\N	42637	42637	42638
11789	12587	12	applied	\N	\N	\N	\N	42639	42639	42640
11789	12588	13	applied	\N	\N	\N	\N	42641	42641	42642
11789	12619	14	applied	\N	\N	\N	\N	42769	42769	42770
11789	12620	15	applied	\N	\N	\N	\N	42771	42771	42772
11789	12621	16	applied	\N	\N	\N	\N	42773	42773	42774
11789	12491	17	applied	\N	\N	\N	\N	42274	42274	42275
11789	12492	18	applied	\N	\N	\N	\N	42281	42281	42282
11789	12493	19	applied	\N	\N	\N	\N	42286	42286	42287
11789	12494	20	applied	\N	\N	\N	\N	42289	42289	42290
11789	12495	21	applied	\N	\N	\N	\N	42293	42293	42294
11789	12496	22	applied	\N	\N	\N	\N	42297	42297	42298
11789	12497	23	applied	\N	\N	\N	\N	42302	42302	42303
11789	12501	24	applied	\N	\N	\N	\N	42312	42312	42313
11789	12498	25	applied	\N	\N	\N	\N	42305	42305	42306
11789	12499	26	applied	\N	\N	\N	\N	42307	42307	42308
11789	12500	27	applied	\N	\N	\N	\N	42310	42310	42311
11789	12502	28	applied	\N	\N	\N	\N	42316	42316	42317
11789	12503	29	applied	\N	\N	\N	\N	42318	42318	42319
11789	12504	30	applied	\N	\N	\N	\N	42321	42321	42322
11789	12505	31	applied	\N	\N	\N	\N	42323	42323	42324
11789	12506	32	applied	\N	\N	\N	\N	42329	42329	42330
11789	12507	33	applied	\N	\N	\N	\N	42335	42335	42336
11789	12508	34	applied	\N	\N	\N	\N	42337	42337	42338
11789	12509	35	applied	\N	\N	\N	\N	42341	42341	42342
11789	12510	36	applied	\N	\N	\N	\N	42346	42346	42347
11789	12511	37	applied	\N	\N	\N	\N	42351	42351	42352
11789	12512	38	applied	\N	\N	\N	\N	42354	42354	42355
11789	12513	39	applied	\N	\N	\N	\N	42359	42359	42360
11789	12514	40	applied	\N	\N	\N	\N	42361	42361	42362
11789	12515	41	applied	\N	\N	\N	\N	42367	42367	42368
11789	12516	42	applied	\N	\N	\N	\N	42369	42369	42370
11789	12517	43	applied	\N	\N	\N	\N	42376	42376	42377
11789	12518	44	applied	\N	\N	\N	\N	42378	42378	42379
11789	12519	45	applied	\N	\N	\N	\N	42388	42388	42389
11789	12520	46	applied	\N	\N	\N	\N	42390	42390	42391
11789	12660	47	applied	\N	\N	\N	\N	42912	42912	7825
11789	12521	48	applied	\N	\N	\N	\N	42392	42392	42393
11789	12522	49	applied	\N	\N	\N	\N	42396	42396	42397
11789	12523	50	applied	\N	\N	\N	\N	42398	42398	42399
11789	12524	51	applied	\N	\N	\N	\N	42401	42401	42402
11789	12525	52	applied	\N	\N	\N	\N	42403	42403	42404
11789	12526	53	applied	\N	\N	\N	\N	42409	42409	42410
11789	12527	54	applied	\N	\N	\N	\N	42411	42411	42412
11789	12528	55	applied	\N	\N	\N	\N	42413	42413	42414
11789	12529	56	applied	\N	\N	\N	\N	42416	42416	42417
11789	12530	57	applied	\N	\N	\N	\N	42420	42420	42421
11789	12531	58	applied	\N	\N	\N	\N	42422	42422	42423
11789	12532	59	applied	\N	\N	\N	\N	42424	42424	42425
11789	12533	60	applied	\N	\N	\N	\N	42428	42428	42429
11789	12534	61	applied	\N	\N	\N	\N	42430	42430	42431
11789	12535	62	applied	\N	\N	\N	\N	42435	42435	42436
11789	12536	64	applied	\N	\N	\N	\N	42440	42440	42441
11789	12537	65	applied	\N	\N	\N	\N	42443	42443	42444
11789	12538	66	applied	\N	\N	\N	\N	42447	42447	42448
11789	12539	67	applied	\N	\N	\N	\N	42449	42449	42450
11789	12540	68	applied	\N	\N	\N	\N	42451	42451	42452
11789	12541	69	applied	\N	\N	\N	\N	42455	42455	42456
11789	12542	70	applied	\N	\N	\N	\N	42459	42459	42460
11789	12543	71	applied	\N	\N	\N	\N	42463	42463	42464
11789	12544	72	applied	\N	\N	\N	\N	42465	42465	42466
11789	12545	73	applied	\N	\N	\N	\N	42472	42472	42473
11789	12546	74	applied	\N	\N	\N	\N	42474	42474	42475
11789	12547	75	applied	\N	\N	\N	\N	42476	42476	42477
11789	12548	76	applied	\N	\N	\N	\N	42478	42478	42479
11789	12549	77	applied	\N	\N	\N	\N	42482	42482	42483
11789	12550	78	applied	\N	\N	\N	\N	42484	42484	42485
11789	12551	79	applied	\N	\N	\N	\N	42488	42488	42489
11789	12552	80	applied	\N	\N	\N	\N	42494	42494	42495
11789	12553	81	applied	\N	\N	\N	\N	42502	42502	42503
11789	12554	82	applied	\N	\N	\N	\N	42510	42510	42511
11789	12555	83	applied	\N	\N	\N	\N	42512	42512	42513
11789	12556	84	applied	\N	\N	\N	\N	42514	42514	42515
11789	12557	85	applied	\N	\N	\N	\N	42516	42516	42517
11789	12558	86	applied	\N	\N	\N	\N	42523	42523	42524
11789	12559	87	applied	\N	\N	\N	\N	42527	42527	42528
11789	12560	88	applied	\N	\N	\N	\N	42529	42529	42530
11789	12561	89	applied	\N	\N	\N	\N	42535	42535	42536
11789	12562	90	applied	\N	\N	\N	\N	42543	42543	42544
11789	12563	91	applied	\N	\N	\N	\N	42545	42545	42546
11789	12564	92	applied	\N	\N	\N	\N	42557	42557	42558
11789	12565	93	applied	\N	\N	\N	\N	42563	42563	42564
11789	12566	94	applied	\N	\N	\N	\N	42566	42566	42567
11789	12567	95	applied	\N	\N	\N	\N	42572	42572	42573
11789	12569	96	applied	\N	\N	\N	\N	42582	42582	42583
11789	12570	97	applied	\N	\N	\N	\N	42584	42584	42585
11789	12571	98	applied	\N	\N	\N	\N	42586	42586	42587
11789	12572	99	applied	\N	\N	\N	\N	42588	42588	42589
11789	12573	100	applied	\N	\N	\N	\N	42591	42591	42592
11789	12574	101	applied	\N	\N	\N	\N	42604	42604	42605
11789	12575	102	applied	\N	\N	\N	\N	42607	42607	42608
11789	12576	103	applied	\N	\N	\N	\N	42609	42609	42610
11789	12577	104	applied	\N	\N	\N	\N	42611	42611	42612
11789	12578	105	applied	\N	\N	\N	\N	42615	42615	42616
11789	12579	106	applied	\N	\N	\N	\N	42621	42621	42622
11789	12580	107	applied	\N	\N	\N	\N	42623	42623	42624
11789	12581	108	applied	\N	\N	\N	\N	42625	42625	42626
11789	12582	109	applied	\N	\N	\N	\N	42628	42628	42629
11789	12583	110	applied	\N	\N	\N	\N	42630	42630	42631
11789	12589	111	applied	\N	\N	\N	\N	42643	42643	42644
11789	12590	112	applied	\N	\N	\N	\N	42645	42645	42646
11789	12591	113	applied	\N	\N	\N	\N	42647	42647	42648
11789	12592	114	applied	\N	\N	\N	\N	42649	42649	42650
11789	12593	115	applied	\N	\N	\N	\N	42658	42658	42659
11789	12594	116	applied	\N	\N	\N	\N	42660	42660	42661
11789	12595	117	applied	\N	\N	\N	\N	42666	42666	42667
11789	12596	118	applied	\N	\N	\N	\N	42668	42668	42669
11789	12597	119	applied	\N	\N	\N	\N	42676	42676	42677
11789	12598	120	applied	\N	\N	\N	\N	42682	42682	42683
11789	12599	121	applied	\N	\N	\N	\N	42686	42686	42687
11789	12600	122	applied	\N	\N	\N	\N	42688	42688	42689
11789	12601	123	applied	\N	\N	\N	\N	42693	42693	42694
11789	12602	124	applied	\N	\N	\N	\N	42697	42697	42698
11789	12603	125	applied	\N	\N	\N	\N	42702	42702	42703
11792	12669	0	applied	\N	\N	\N	\N	42954	42954	42955
11792	12670	1	applied	\N	\N	\N	\N	42956	42956	42957
11796	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11796	12646	1	applied	\N	\N	\N	\N	42866	42866	42867
11796	12647	2	applied	\N	\N	\N	\N	42868	42868	42869
11796	12568	3	applied	\N	\N	1000000000	\N	42580	42580	42581
11796	12391	4	applied	\N	\N	\N	\N	41983	41983	41984
11796	12395	5	applied	\N	\N	\N	\N	41992	41992	41993
11796	12400	6	applied	\N	\N	\N	\N	42006	42006	42007
11796	12403	7	applied	\N	\N	\N	\N	42019	42019	42020
11796	12406	8	applied	\N	\N	\N	\N	42026	42026	42027
11796	12407	9	applied	\N	\N	\N	\N	42028	42028	42029
11796	12411	10	applied	\N	\N	\N	\N	42037	42037	42038
11796	12413	11	applied	\N	\N	\N	\N	42042	42042	42043
11796	12415	12	applied	\N	\N	\N	\N	42048	42048	42049
11796	12417	13	applied	\N	\N	\N	\N	42057	42057	42058
11796	12419	14	applied	\N	\N	\N	\N	42062	42062	42063
11796	12420	15	applied	\N	\N	\N	\N	42064	42064	42065
11796	12423	16	applied	\N	\N	\N	\N	42071	42071	42072
11796	12425	17	applied	\N	\N	\N	\N	42077	42077	42078
11796	12426	18	applied	\N	\N	\N	\N	42079	42079	42080
11796	12427	19	applied	\N	\N	\N	\N	42081	42081	42082
11796	12428	20	applied	\N	\N	\N	\N	42083	42083	42084
11796	12433	21	applied	\N	\N	\N	\N	42101	42101	42102
11796	12618	22	applied	\N	\N	\N	\N	42767	42767	42768
11796	12650	23	applied	\N	\N	\N	\N	42876	42876	42877
11796	12652	24	applied	\N	\N	\N	\N	42881	42881	42882
11796	12654	25	applied	\N	\N	\N	\N	42889	42889	42890
11796	12655	26	applied	\N	\N	\N	\N	42891	42891	42892
11796	12657	27	applied	\N	\N	\N	\N	42898	42898	42899
11796	12585	28	applied	\N	\N	\N	\N	42635	42635	42636
11796	12586	29	applied	\N	\N	\N	\N	42637	42637	42638
11796	12587	30	applied	\N	\N	\N	\N	42639	42639	42640
11796	12588	31	applied	\N	\N	\N	\N	42641	42641	42642
11796	12434	33	applied	\N	\N	\N	\N	42103	42103	42104
11796	12435	34	applied	\N	\N	\N	\N	42105	42105	42106
11796	12439	35	applied	\N	\N	\N	\N	42114	42114	42115
11796	12440	36	applied	\N	\N	\N	\N	42116	42116	42117
11796	12444	37	applied	\N	\N	\N	\N	42127	42127	42128
11796	12446	38	applied	\N	\N	\N	\N	42132	42132	42133
11796	12448	39	applied	\N	\N	\N	\N	42138	42138	42139
11796	12450	40	applied	\N	\N	\N	\N	42143	42143	42144
11796	12452	41	applied	\N	\N	\N	\N	42149	42149	42150
11796	12457	42	applied	\N	\N	\N	\N	42161	42161	42162
11796	12462	43	applied	\N	\N	\N	\N	42174	42174	42175
11796	12463	44	applied	\N	\N	\N	\N	42176	42176	42177
11796	12464	45	applied	\N	\N	\N	\N	42178	42178	42179
11796	12468	46	applied	\N	\N	\N	\N	42196	42196	42197
11796	12470	47	applied	\N	\N	\N	\N	42201	42201	42202
11796	12472	48	applied	\N	\N	\N	\N	42208	42208	42209
11796	12619	49	applied	\N	\N	\N	\N	42769	42769	42770
11796	12620	50	applied	\N	\N	\N	\N	42771	42771	42772
11796	12621	51	applied	\N	\N	\N	\N	42773	42773	42774
11796	12401	52	applied	\N	\N	\N	\N	42969	42969	42009
11796	12386	53	applied	\N	\N	\N	\N	41964	41964	42008
11796	12397	54	applied	\N	\N	\N	\N	41995	41995	41996
11796	12138	55	applied	\N	\N	\N	\N	41226	41226	41227
11796	12140	56	applied	\N	\N	\N	\N	41230	41230	41231
11796	12398	57	applied	\N	\N	\N	\N	41997	41997	41997
11796	12461	58	applied	\N	\N	\N	\N	42173	42173	33908
11796	12349	59	applied	\N	\N	\N	\N	41858	41858	41859
11796	12143	60	failed	Amount_insufficient_to_create_account	\N	\N	\N	41239	41239	\N
11796	12350	61	failed	Amount_insufficient_to_create_account	\N	\N	\N	41865	41865	\N
11796	12375	62	failed	Amount_insufficient_to_create_account	\N	\N	\N	41925	41925	\N
11796	12377	63	failed	Amount_insufficient_to_create_account	\N	\N	\N	41940	41940	\N
11796	12392	64	failed	Amount_insufficient_to_create_account	\N	\N	\N	41985	41985	\N
11796	12396	65	failed	Amount_insufficient_to_create_account	\N	\N	\N	41994	41994	\N
11796	12443	66	applied	\N	\N	\N	\N	42122	42122	42123
11796	12454	67	applied	\N	\N	\N	\N	42153	42153	42154
11796	12455	68	applied	\N	\N	\N	\N	42155	42155	42156
11796	12456	69	applied	\N	\N	\N	\N	42157	42157	42158
11796	12144	70	applied	\N	\N	\N	\N	41240	41240	41241
11796	12660	71	applied	\N	\N	\N	\N	42912	42912	7825
11796	12405	72	applied	\N	\N	\N	\N	42023	42023	42024
11796	12409	73	applied	\N	\N	\N	\N	42032	42032	42033
11796	12145	74	applied	\N	\N	\N	\N	41242	41242	41243
11796	12148	75	applied	\N	\N	\N	\N	41250	41250	41251
11796	12149	76	applied	\N	\N	\N	\N	41252	41252	41253
11796	12151	77	applied	\N	\N	\N	\N	41258	41258	41259
11796	12154	78	applied	\N	\N	\N	\N	41269	41269	41270
11796	12155	79	applied	\N	\N	\N	\N	41271	41271	41272
11796	12157	80	applied	\N	\N	\N	\N	41282	41282	41283
11796	12160	81	applied	\N	\N	\N	\N	41289	41289	41290
11796	12161	82	applied	\N	\N	\N	\N	41291	41291	41292
11796	12165	83	applied	\N	\N	\N	\N	41301	41301	41302
11796	12166	84	applied	\N	\N	\N	\N	41303	41303	41304
11796	12167	85	applied	\N	\N	\N	\N	41305	41305	41306
11796	12169	86	applied	\N	\N	\N	\N	41313	41313	41314
11796	12172	87	applied	\N	\N	\N	\N	41320	41320	41321
11796	12173	88	applied	\N	\N	\N	\N	41322	41322	41323
11796	12175	89	applied	\N	\N	\N	\N	41330	41330	41331
11796	12176	90	applied	\N	\N	\N	\N	41338	41338	41339
11796	12178	91	applied	\N	\N	\N	\N	41346	41346	41347
11796	12180	92	applied	\N	\N	\N	\N	41352	41352	41353
11796	12187	93	applied	\N	\N	\N	\N	41374	41374	41375
11796	12188	94	applied	\N	\N	\N	\N	41376	41376	41377
11796	12189	95	applied	\N	\N	\N	\N	41378	41378	41379
11796	12190	96	applied	\N	\N	\N	\N	41380	41380	41381
11796	12191	97	applied	\N	\N	\N	\N	41382	41382	41383
11796	12193	98	applied	\N	\N	\N	\N	41390	41390	41391
11796	12195	99	applied	\N	\N	\N	\N	41396	41396	41397
11796	12198	100	applied	\N	\N	\N	\N	41403	41403	41404
11796	12199	101	applied	\N	\N	\N	\N	41405	41405	41406
11796	12201	102	applied	\N	\N	\N	\N	41412	41412	41413
11796	12205	103	applied	\N	\N	\N	\N	41423	41423	41424
11796	12206	104	applied	\N	\N	\N	\N	41425	41425	41426
11796	12207	105	applied	\N	\N	\N	\N	41427	41427	41428
11796	12209	106	applied	\N	\N	\N	\N	41434	41434	41435
11796	12211	107	applied	\N	\N	\N	\N	41441	41441	41442
11796	12214	108	applied	\N	\N	\N	\N	41448	41448	41449
11796	12215	109	applied	\N	\N	\N	\N	41450	41450	41451
11796	12217	110	applied	\N	\N	\N	\N	41455	41455	41456
11796	12219	111	applied	\N	\N	\N	\N	41459	41459	41460
11796	12222	112	applied	\N	\N	\N	\N	41469	41469	41470
11796	12223	113	applied	\N	\N	\N	\N	41471	41471	41472
11796	12225	114	applied	\N	\N	\N	\N	41479	41479	41480
11796	12227	115	applied	\N	\N	\N	\N	41485	41485	41486
11796	12229	116	applied	\N	\N	\N	\N	41494	41494	41495
11796	12230	117	applied	\N	\N	\N	\N	41499	41499	41500
11796	12233	118	applied	\N	\N	\N	\N	41508	41508	41509
11796	12234	119	applied	\N	\N	\N	\N	41510	41510	41511
11796	12236	120	applied	\N	\N	\N	\N	41519	41519	41520
11796	12238	121	applied	\N	\N	\N	\N	41527	41527	41528
11796	12241	122	applied	\N	\N	\N	\N	41537	41537	41538
11796	12244	123	applied	\N	\N	\N	\N	41545	41545	41546
11796	12245	124	applied	\N	\N	\N	\N	41547	41547	41548
11801	12675	0	applied	\N	\N	\N	\N	42982	42982	42983
11801	12676	1	applied	\N	\N	\N	\N	42984	42984	42985
11804	12678	0	applied	\N	\N	\N	\N	42992	42992	42993
11808	12679	0	applied	\N	\N	\N	\N	42996	42996	42997
11811	12680	0	applied	\N	\N	\N	\N	42998	42998	42999
11813	12681	0	applied	\N	\N	\N	\N	43003	43003	43004
11817	12683	0	applied	\N	\N	\N	\N	43013	43013	43014
11817	12684	1	applied	\N	\N	\N	\N	43015	43015	43016
11818	12685	0	applied	\N	\N	\N	\N	43019	43019	43020
11818	12686	1	applied	\N	\N	\N	\N	43021	43021	43022
11818	12687	2	applied	\N	\N	\N	\N	43023	43023	43024
11831	12707	0	applied	\N	\N	\N	\N	43082	43082	43083
11831	12708	1	applied	\N	\N	\N	\N	43084	43084	43085
11832	12709	0	applied	\N	\N	\N	\N	43088	43088	43089
11832	12710	1	applied	\N	\N	\N	\N	43090	43090	43091
11832	12711	2	applied	\N	\N	\N	\N	43092	43092	43093
11832	12712	3	applied	\N	\N	\N	\N	43094	43094	43095
11832	12713	4	applied	\N	\N	\N	\N	43096	43096	43097
11835	12714	0	applied	\N	\N	\N	\N	43103	43103	43104
11835	12715	1	applied	\N	\N	\N	\N	43105	43105	43106
11835	12716	2	applied	\N	\N	\N	\N	43107	43107	43108
11835	12717	3	applied	\N	\N	\N	\N	43109	43109	43110
11838	12721	0	applied	\N	\N	\N	\N	43123	43123	43124
11840	12722	0	applied	\N	\N	\N	\N	43129	43129	43130
11848	12727	0	applied	\N	\N	\N	\N	43149	43149	43150
11850	12728	0	applied	\N	\N	1000000000	\N	43157	43157	43158
11850	12729	1	applied	\N	\N	\N	\N	43159	43159	43160
11862	12735	0	applied	\N	\N	\N	\N	43183	43183	43184
11862	12736	1	applied	\N	\N	\N	\N	43185	43185	43186
11862	12737	2	applied	\N	\N	\N	\N	43187	43187	43188
11869	12739	0	applied	\N	\N	\N	\N	43201	43201	43202
11872	12742	0	applied	\N	\N	\N	\N	43215	43215	43216
11872	12743	1	applied	\N	\N	\N	\N	43217	43217	43218
11872	12744	2	applied	\N	\N	\N	\N	43219	43219	43220
11875	12693	0	applied	\N	\N	\N	\N	43049	43049	43050
11875	12735	1	applied	\N	\N	\N	\N	43183	43183	43184
11875	12740	2	applied	\N	\N	\N	\N	43209	43209	43210
11875	12745	3	applied	\N	\N	\N	\N	43225	43225	43226
11875	12694	4	applied	\N	\N	\N	\N	43051	43051	43052
11875	12695	5	applied	\N	\N	\N	\N	43053	43053	43054
11875	12696	6	applied	\N	\N	\N	\N	43055	43055	43056
11875	12697	7	applied	\N	\N	\N	\N	43057	43057	43058
11875	12698	8	applied	\N	\N	\N	\N	43059	43059	43060
11875	12699	9	applied	\N	\N	\N	\N	43061	43061	43062
11875	12700	11	applied	\N	\N	\N	\N	43063	43063	43064
11875	12701	12	applied	\N	\N	\N	\N	43065	43065	43066
11875	12682	13	applied	\N	\N	\N	\N	43009	43009	43010
11875	12683	14	applied	\N	\N	\N	\N	43013	43013	43014
11853	12730	0	applied	\N	\N	\N	\N	43164	43164	43165
11860	12734	0	applied	\N	\N	\N	\N	43178	43178	43179
11865	12738	0	applied	\N	\N	\N	\N	43196	43196	43197
11867	12739	0	applied	\N	\N	\N	\N	43201	43201	43202
11877	12749	0	applied	\N	\N	\N	\N	43240	43240	43241
11880	12750	0	applied	\N	\N	\N	\N	43243	43243	43244
11880	12751	1	applied	\N	\N	\N	\N	43248	43248	43249
11892	12761	0	applied	\N	\N	\N	\N	43286	43286	43287
11895	12764	0	applied	\N	\N	\N	\N	43302	43302	43303
11895	12765	1	applied	\N	\N	\N	\N	43304	43304	43305
11898	12769	0	applied	\N	\N	\N	\N	43318	43318	43319
11906	12777	0	applied	\N	\N	\N	\N	43343	43343	43344
11909	12780	0	applied	\N	\N	\N	\N	43355	43355	43356
11911	12782	0	applied	\N	\N	\N	\N	43361	43361	43362
11916	12784	0	applied	\N	\N	\N	\N	43372	43372	43373
11918	12785	0	applied	\N	\N	\N	\N	43378	43378	43379
11923	12790	0	applied	\N	\N	\N	\N	43394	43394	43395
11926	12794	0	applied	\N	\N	\N	\N	43406	43406	43407
11928	12796	0	applied	\N	\N	\N	\N	43414	43414	43415
11931	12797	0	applied	\N	\N	\N	\N	43420	43420	43421
11931	12798	1	applied	\N	\N	\N	\N	43422	43422	43423
11931	12799	2	applied	\N	\N	\N	\N	43424	43424	43425
11933	12800	0	applied	\N	\N	\N	\N	43429	43429	43430
11936	12801	0	applied	\N	\N	\N	\N	43433	43433	43434
11938	12802	0	applied	\N	\N	\N	\N	43442	43442	43443
11938	12803	1	applied	\N	\N	\N	\N	43444	43444	43445
11938	12804	2	applied	\N	\N	\N	\N	43446	43446	43447
11944	12815	0	applied	\N	\N	\N	\N	43475	43475	43476
11947	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
11947	12819	1	applied	\N	\N	\N	\N	43491	43491	43492
11947	12820	2	applied	\N	\N	\N	\N	43493	43493	43494
11947	12821	3	applied	\N	\N	\N	\N	43495	43495	43496
11947	12818	4	applied	\N	\N	\N	\N	43497	43497	43488
11954	12822	0	applied	\N	\N	\N	\N	43500	43500	43501
11954	12823	1	applied	\N	\N	\N	\N	43502	43502	43503
11954	12824	2	applied	\N	\N	\N	\N	43512	43512	43513
11954	12825	3	applied	\N	\N	\N	\N	43516	43516	43517
11956	12826	0	applied	\N	\N	\N	\N	43521	43521	43522
11956	12827	1	applied	\N	\N	\N	\N	43523	43523	43524
11971	12835	0	applied	\N	\N	\N	\N	43561	43561	43562
11971	12836	1	applied	\N	\N	\N	\N	43563	43563	43564
11973	12838	0	applied	\N	\N	\N	\N	43572	43572	43573
11975	12839	0	applied	\N	\N	\N	\N	43577	43577	43578
11980	12843	0	applied	\N	\N	\N	\N	43591	43591	43592
11985	12846	0	applied	\N	\N	\N	\N	43602	43602	43603
11987	12847	0	applied	\N	\N	\N	\N	43606	43606	43607
11992	12850	0	applied	\N	\N	\N	\N	43623	43623	43624
11995	12851	0	applied	\N	\N	\N	\N	43627	43627	43628
11997	12852	0	applied	\N	\N	\N	\N	43630	43630	43631
12004	12858	0	applied	\N	\N	\N	\N	43654	43654	43655
12004	12859	1	applied	\N	\N	\N	\N	43656	43656	43657
12004	12860	2	applied	\N	\N	\N	\N	43658	43658	43659
12012	12870	0	applied	\N	\N	\N	\N	43685	43685	43686
12017	12873	0	applied	\N	\N	\N	\N	43701	43701	43702
12021	12874	0	applied	\N	\N	\N	\N	43705	43705	43706
12022	12874	0	applied	\N	\N	\N	\N	43705	43705	43706
12025	12878	0	applied	\N	\N	\N	\N	43727	43727	43728
12034	12884	0	applied	\N	\N	\N	\N	43753	43753	43754
12034	12885	1	applied	\N	\N	\N	\N	43755	43755	43756
12037	12889	0	applied	\N	\N	\N	\N	43768	43768	43769
12039	12889	0	applied	\N	\N	\N	\N	43768	43768	43769
12045	12892	0	applied	\N	\N	\N	\N	43782	43782	43783
12046	12893	0	applied	\N	\N	\N	\N	43789	43789	43790
12049	12894	0	applied	\N	\N	\N	\N	43795	43795	43796
12053	12896	0	applied	\N	\N	\N	\N	43807	43807	43808
12053	12897	1	applied	\N	\N	\N	\N	43809	43809	43810
12053	12898	2	applied	\N	\N	1000000000	\N	43811	43811	43812
12053	12899	3	applied	\N	\N	\N	\N	43813	43813	43813
12057	12900	0	applied	\N	\N	\N	\N	43816	43816	43817
12060	12902	0	applied	\N	\N	\N	\N	43828	43828	43829
12062	12903	0	applied	\N	\N	\N	\N	43835	43835	43836
12062	12904	1	applied	\N	\N	\N	\N	43837	43837	43837
12065	12909	0	applied	\N	\N	\N	\N	43848	43848	43849
12069	12914	0	applied	\N	\N	\N	\N	43864	43864	43865
12077	12925	0	applied	\N	\N	\N	\N	43898	43898	43899
12080	12926	0	applied	\N	\N	\N	\N	43904	43904	43905
12086	12930	0	applied	\N	\N	\N	\N	43917	43917	43918
12086	12931	1	applied	\N	\N	\N	\N	43919	43919	43920
12087	12932	0	applied	\N	\N	\N	\N	43930	43930	43931
12092	12935	0	applied	\N	\N	\N	\N	43946	43946	43947
12092	12936	1	applied	\N	\N	\N	\N	43948	43948	43949
12095	12940	0	applied	\N	\N	\N	\N	43959	43959	43960
12095	12941	1	applied	\N	\N	\N	\N	43961	43961	43962
12095	12942	2	applied	\N	\N	\N	\N	43963	43963	43964
12098	12945	0	applied	\N	\N	\N	\N	43972	43972	43973
12098	12946	1	applied	\N	\N	\N	\N	43974	43974	43975
12101	12947	0	applied	\N	\N	\N	\N	43976	43976	43977
12101	12948	1	applied	\N	\N	\N	\N	43978	43978	43979
12103	12949	0	applied	\N	\N	\N	\N	43984	43984	43985
12103	12950	1	applied	\N	\N	\N	\N	43986	43986	43987
12113	12958	0	applied	\N	\N	\N	\N	44013	44013	44014
12115	12959	0	applied	\N	\N	\N	\N	44018	44018	44019
12122	12963	0	applied	\N	\N	\N	\N	44036	44036	44037
12127	12965	0	applied	\N	\N	\N	\N	44045	44045	44046
12127	12966	1	applied	\N	\N	\N	\N	44047	44047	44048
12130	12968	0	applied	\N	\N	\N	\N	44057	44057	44058
12130	12969	1	applied	\N	\N	\N	\N	44059	44059	44060
12130	12970	2	applied	\N	\N	\N	\N	44061	44061	44062
12133	12968	0	applied	\N	\N	\N	\N	44057	44057	44058
12133	12969	1	applied	\N	\N	\N	\N	44059	44059	44060
12133	12970	2	applied	\N	\N	\N	\N	44061	44061	44062
12146	12982	0	applied	\N	\N	\N	\N	44108	44108	44109
12153	12986	0	applied	\N	\N	\N	\N	44125	44125	44126
12158	12987	0	applied	\N	\N	1000000000	\N	44130	44130	44131
12158	12988	1	applied	\N	\N	\N	\N	44132	44132	44133
12159	12987	0	applied	\N	\N	1000000000	\N	44130	44130	44131
12161	12989	0	applied	\N	\N	\N	\N	44139	44139	44140
12161	12990	1	applied	\N	\N	\N	\N	44141	44141	44142
12161	12991	2	applied	\N	\N	\N	\N	44143	44143	44144
12161	12992	3	applied	\N	\N	\N	\N	44145	44145	44146
12161	12993	4	applied	\N	\N	\N	\N	44147	44147	44148
12163	12989	0	applied	\N	\N	\N	\N	44139	44139	44140
12163	12990	1	applied	\N	\N	\N	\N	44141	44141	44142
12163	12991	2	applied	\N	\N	\N	\N	44143	44143	44144
12163	12992	3	applied	\N	\N	\N	\N	44145	44145	44146
12163	12993	4	applied	\N	\N	\N	\N	44147	44147	44148
12169	12998	0	applied	\N	\N	\N	\N	44167	44167	44168
12170	12999	0	applied	\N	\N	\N	\N	44172	44172	44173
12174	13002	0	applied	\N	\N	\N	\N	44181	44181	44182
11864	12654	13	applied	\N	\N	\N	\N	42889	42889	42890
11864	12655	14	applied	\N	\N	\N	\N	42891	42891	42892
11864	12657	15	applied	\N	\N	\N	\N	42898	42898	42899
11864	12585	16	applied	\N	\N	\N	\N	42635	42635	42636
11864	12586	17	applied	\N	\N	\N	\N	42637	42637	42638
11864	12587	18	applied	\N	\N	\N	\N	42639	42639	42640
11864	12588	19	applied	\N	\N	\N	\N	42641	42641	42642
11864	12696	20	applied	\N	\N	\N	\N	43055	43055	43056
11864	12697	21	applied	\N	\N	\N	\N	43057	43057	43058
11864	12698	22	applied	\N	\N	\N	\N	43059	43059	43060
11864	12699	23	applied	\N	\N	\N	\N	43061	43061	43062
11864	12700	24	applied	\N	\N	\N	\N	43063	43063	43064
11864	12701	25	applied	\N	\N	\N	\N	43065	43065	43066
11864	12434	26	applied	\N	\N	\N	\N	42103	42103	42104
11864	12435	27	applied	\N	\N	\N	\N	42105	42105	42106
11864	12439	28	applied	\N	\N	\N	\N	42114	42114	42115
11864	12440	29	applied	\N	\N	\N	\N	42116	42116	42117
11864	12444	30	applied	\N	\N	\N	\N	42127	42127	42128
11864	12446	31	applied	\N	\N	\N	\N	42132	42132	42133
11864	12448	32	applied	\N	\N	\N	\N	42138	42138	42139
11864	12450	33	applied	\N	\N	\N	\N	42143	42143	42144
11864	12452	34	applied	\N	\N	\N	\N	42149	42149	42150
11864	12457	35	applied	\N	\N	\N	\N	42161	42161	42162
11864	12462	36	applied	\N	\N	\N	\N	42174	42174	42175
11864	12463	37	applied	\N	\N	\N	\N	42176	42176	42177
11864	12464	38	applied	\N	\N	\N	\N	42178	42178	42179
11864	12468	39	applied	\N	\N	\N	\N	42196	42196	42197
11864	12470	40	applied	\N	\N	\N	\N	42201	42201	42202
11864	12472	41	applied	\N	\N	\N	\N	42208	42208	42209
11864	12619	42	applied	\N	\N	\N	\N	42769	42769	42770
11864	12620	43	applied	\N	\N	\N	\N	42771	42771	42772
11864	12621	44	applied	\N	\N	\N	\N	42773	42773	42774
11864	12436	45	applied	\N	\N	\N	\N	42107	42107	42108
11864	12437	47	applied	\N	\N	\N	\N	42109	42109	42110
11864	12443	48	applied	\N	\N	\N	\N	42122	42122	42123
11864	12454	49	applied	\N	\N	\N	\N	42153	42153	42154
11864	12455	50	applied	\N	\N	\N	\N	42155	42155	42156
11864	12456	51	applied	\N	\N	\N	\N	42157	42157	42158
11864	12660	52	applied	\N	\N	\N	\N	42912	42912	7825
11864	12438	53	applied	\N	\N	\N	\N	42111	42111	42112
11864	12441	54	applied	\N	\N	\N	\N	42118	42118	42119
11864	12442	55	applied	\N	\N	\N	\N	42120	42120	42121
11864	12445	56	applied	\N	\N	\N	\N	42129	42129	42130
11864	12447	57	applied	\N	\N	\N	\N	42134	42134	42135
11864	12449	58	applied	\N	\N	\N	\N	42140	42140	42141
11864	12451	59	applied	\N	\N	\N	\N	42145	42145	42146
11864	12453	60	applied	\N	\N	\N	\N	42151	42151	42152
11864	12458	61	applied	\N	\N	\N	\N	42163	42163	42164
11864	12459	62	applied	\N	\N	1000000000	\N	42165	42165	42166
11864	12460	63	applied	\N	\N	1000000000	\N	42167	42167	42168
11864	12465	64	applied	\N	\N	\N	\N	42180	42180	42181
11864	12466	65	applied	\N	\N	\N	\N	42182	42182	42183
11864	12467	66	applied	\N	\N	\N	\N	42184	42184	42185
11864	12469	67	applied	\N	\N	\N	\N	42198	42198	42199
11864	12471	68	applied	\N	\N	\N	\N	42203	42203	42204
11864	12473	69	applied	\N	\N	\N	\N	42210	42210	42211
11864	12474	70	applied	\N	\N	\N	\N	42214	42214	42215
11864	12475	71	applied	\N	\N	\N	\N	42218	42218	42219
11864	12476	72	applied	\N	\N	\N	\N	42222	42222	42223
11864	12477	73	applied	\N	\N	\N	\N	42228	42228	42229
11864	12478	74	applied	\N	\N	\N	\N	42232	42232	42233
11864	12479	75	applied	\N	\N	\N	\N	42234	42234	42235
11864	12480	76	applied	\N	\N	\N	\N	42238	42238	42239
11864	12481	77	applied	\N	\N	\N	\N	42242	42242	42243
11864	12482	78	applied	\N	\N	\N	\N	42246	42246	42247
11864	12483	79	applied	\N	\N	\N	\N	42248	42248	42249
11864	12484	80	applied	\N	\N	\N	\N	42252	42252	42253
11864	12485	81	applied	\N	\N	\N	\N	42254	42254	42255
11864	12486	82	applied	\N	\N	\N	\N	42257	42257	42258
11864	12487	83	applied	\N	\N	\N	\N	42259	42259	42260
11864	12488	84	applied	\N	\N	\N	\N	42263	42263	42264
11864	12489	85	applied	\N	\N	\N	\N	42268	42268	42269
11864	12490	86	applied	\N	\N	\N	\N	42270	42270	42271
11864	12491	87	applied	\N	\N	\N	\N	42274	42274	42275
11864	12492	88	applied	\N	\N	\N	\N	42281	42281	42282
11864	12493	89	applied	\N	\N	\N	\N	42286	42286	42287
11864	12494	90	applied	\N	\N	\N	\N	42289	42289	42290
11864	12495	91	applied	\N	\N	\N	\N	42293	42293	42294
11864	12496	92	applied	\N	\N	\N	\N	42297	42297	42298
11864	12497	93	applied	\N	\N	\N	\N	42302	42302	42303
11864	12498	94	applied	\N	\N	\N	\N	42305	42305	42306
11864	12499	95	applied	\N	\N	\N	\N	42307	42307	42308
11864	12500	96	applied	\N	\N	\N	\N	42310	42310	42311
11864	12502	97	applied	\N	\N	\N	\N	42316	42316	42317
11864	12503	98	applied	\N	\N	\N	\N	42318	42318	42319
11864	12504	99	applied	\N	\N	\N	\N	42321	42321	42322
11864	12505	100	applied	\N	\N	\N	\N	42323	42323	42324
11864	12506	101	applied	\N	\N	\N	\N	42329	42329	42330
11864	12507	102	applied	\N	\N	\N	\N	42335	42335	42336
11864	12508	103	applied	\N	\N	\N	\N	42337	42337	42338
11864	12509	104	applied	\N	\N	\N	\N	42341	42341	42342
11864	12510	105	applied	\N	\N	\N	\N	42346	42346	42347
11864	12511	106	applied	\N	\N	\N	\N	42351	42351	42352
11864	12512	107	applied	\N	\N	\N	\N	42354	42354	42355
11864	12513	108	applied	\N	\N	\N	\N	42359	42359	42360
11864	12514	109	applied	\N	\N	\N	\N	42361	42361	42362
11864	12515	110	applied	\N	\N	\N	\N	42367	42367	42368
11864	12516	111	applied	\N	\N	\N	\N	42369	42369	42370
11864	12517	112	applied	\N	\N	\N	\N	42376	42376	42377
11864	12518	113	applied	\N	\N	\N	\N	42378	42378	42379
11864	12519	114	applied	\N	\N	\N	\N	42388	42388	42389
11864	12520	115	applied	\N	\N	\N	\N	42390	42390	42391
11864	12521	116	applied	\N	\N	\N	\N	42392	42392	42393
11864	12522	117	applied	\N	\N	\N	\N	42396	42396	42397
11864	12523	118	applied	\N	\N	\N	\N	42398	42398	42399
11864	12524	119	applied	\N	\N	\N	\N	42401	42401	42402
11864	12525	120	applied	\N	\N	\N	\N	42403	42403	42404
11864	12526	121	applied	\N	\N	\N	\N	42409	42409	42410
11864	12527	122	applied	\N	\N	\N	\N	42411	42411	42412
11864	12528	123	applied	\N	\N	\N	\N	42413	42413	42414
11864	12529	124	applied	\N	\N	\N	\N	42416	42416	42417
11864	12530	125	applied	\N	\N	\N	\N	42420	42420	42421
11871	12742	0	applied	\N	\N	\N	\N	43215	43215	43216
11871	12743	1	applied	\N	\N	\N	\N	43217	43217	43218
11871	12744	2	applied	\N	\N	\N	\N	43219	43219	43220
11874	12748	0	applied	\N	\N	\N	\N	43232	43232	43233
11884	12752	0	applied	\N	\N	\N	\N	43257	43257	43258
11884	12753	1	applied	\N	\N	\N	\N	43259	43259	43260
11884	12754	2	applied	\N	\N	\N	\N	43261	43261	43262
11875	12684	15	applied	\N	\N	\N	\N	43015	43015	43016
11875	12685	16	applied	\N	\N	\N	\N	43019	43019	43020
11875	12686	17	applied	\N	\N	\N	\N	43021	43021	43022
11875	12687	18	applied	\N	\N	\N	\N	43023	43023	43024
11875	12688	19	applied	\N	\N	\N	\N	43029	43029	43030
11875	12689	20	applied	\N	\N	\N	\N	43033	43033	43034
11875	12690	21	applied	\N	\N	\N	\N	43035	43035	43036
11875	12691	22	applied	\N	\N	\N	\N	43039	43039	43040
11875	12692	23	applied	\N	\N	\N	\N	43043	43043	43044
11875	12702	24	applied	\N	\N	\N	\N	43067	43067	43068
11875	12703	25	applied	\N	\N	\N	\N	43069	43069	43070
11875	12704	26	applied	\N	\N	\N	\N	43072	43072	43073
11875	12705	27	applied	\N	\N	\N	\N	43074	43074	43075
11875	12706	28	applied	\N	\N	\N	\N	43076	43076	43077
11875	12707	29	applied	\N	\N	\N	\N	43082	43082	43083
11875	12708	30	applied	\N	\N	\N	\N	43084	43084	43085
11875	12709	31	applied	\N	\N	\N	\N	43088	43088	43089
11875	12710	32	applied	\N	\N	\N	\N	43090	43090	43091
11875	12711	33	applied	\N	\N	\N	\N	43092	43092	43093
11875	12712	34	applied	\N	\N	\N	\N	43094	43094	43095
11875	12713	35	applied	\N	\N	\N	\N	43096	43096	43097
11875	12714	36	applied	\N	\N	\N	\N	43103	43103	43104
11875	12715	37	applied	\N	\N	\N	\N	43105	43105	43106
11875	12716	38	applied	\N	\N	\N	\N	43107	43107	43108
11875	12717	39	applied	\N	\N	\N	\N	43109	43109	43110
11875	12718	40	applied	\N	\N	\N	\N	43113	43113	43114
11875	12719	41	applied	\N	\N	1000000000	\N	43117	43117	43118
11875	12720	42	applied	\N	\N	\N	\N	43119	43119	43120
11875	12721	43	applied	\N	\N	\N	\N	43123	43123	43124
11875	12722	44	applied	\N	\N	\N	\N	43129	43129	43130
11875	12723	45	applied	\N	\N	\N	\N	43133	43133	43134
11875	12724	46	applied	\N	\N	\N	\N	43135	43135	43136
11875	12725	47	applied	\N	\N	\N	\N	43139	43139	43140
11875	12726	48	applied	\N	\N	\N	\N	43145	43145	43146
11875	12727	49	applied	\N	\N	\N	\N	43149	43149	43150
11875	12728	50	applied	\N	\N	1000000000	\N	43157	43157	43158
11875	12729	51	applied	\N	\N	\N	\N	43159	43159	43160
11875	12730	52	applied	\N	\N	\N	\N	43164	43164	43165
11875	12731	53	applied	\N	\N	\N	\N	43169	43169	43170
11875	12732	54	applied	\N	\N	\N	\N	43171	43171	43172
11875	12733	55	applied	\N	\N	\N	\N	43176	43176	43177
11875	12734	56	applied	\N	\N	\N	\N	43178	43178	43179
11875	12736	57	applied	\N	\N	\N	\N	43185	43185	43186
11875	12737	58	applied	\N	\N	\N	\N	43187	43187	43188
11875	12738	59	applied	\N	\N	\N	\N	43196	43196	43197
11875	12739	60	applied	\N	\N	\N	\N	43201	43201	43202
11875	12741	61	applied	\N	\N	\N	\N	43211	43211	43212
11875	12742	62	applied	\N	\N	\N	\N	43215	43215	43216
11875	12743	63	applied	\N	\N	\N	\N	43217	43217	43218
11875	12744	64	applied	\N	\N	\N	\N	43219	43219	43220
11875	12746	65	applied	\N	\N	\N	\N	43227	43227	43228
11875	12747	66	applied	\N	\N	\N	\N	43229	43229	43230
11875	12748	67	applied	\N	\N	\N	\N	43232	43232	43233
11879	12750	0	applied	\N	\N	\N	\N	43243	43243	43244
11879	12751	1	applied	\N	\N	\N	\N	43248	43248	43249
11881	12750	0	applied	\N	\N	\N	\N	43243	43243	43244
11881	12751	1	applied	\N	\N	\N	\N	43248	43248	43249
11882	12752	0	applied	\N	\N	\N	\N	43257	43257	43258
11882	12753	1	applied	\N	\N	\N	\N	43259	43259	43260
11882	12754	2	applied	\N	\N	\N	\N	43261	43261	43262
11882	12755	3	applied	\N	\N	\N	\N	43263	43263	43264
11887	12757	0	applied	\N	\N	\N	\N	43273	43273	43274
11889	12758	0	applied	\N	\N	\N	\N	43275	43275	43276
11891	12760	0	applied	\N	\N	\N	\N	43282	43282	43283
11894	12584	0	applied	\N	\N	\N	\N	42634	42634	39747
11894	12693	1	applied	\N	\N	\N	\N	43049	43049	43050
11894	12735	2	applied	\N	\N	\N	\N	43192	43192	43184
11894	12740	3	applied	\N	\N	\N	\N	43294	43294	43210
11894	12745	4	applied	\N	\N	\N	\N	43295	43295	43226
11894	12750	5	applied	\N	\N	\N	\N	43296	43296	43244
11894	12646	6	applied	\N	\N	\N	\N	42866	42866	42867
11894	12647	7	applied	\N	\N	\N	\N	42868	42868	42869
11894	12568	8	applied	\N	\N	1000000000	\N	42580	42580	42581
11894	12694	9	applied	\N	\N	\N	\N	43051	43051	43052
11894	12618	10	applied	\N	\N	\N	\N	42767	42767	42768
11894	12695	11	applied	\N	\N	\N	\N	43053	43053	43054
11894	12650	12	applied	\N	\N	\N	\N	42876	42876	42877
11894	12652	13	applied	\N	\N	\N	\N	42881	42881	42882
11894	12654	14	applied	\N	\N	\N	\N	42889	42889	42890
11894	12655	15	applied	\N	\N	\N	\N	42891	42891	42892
11894	12657	16	applied	\N	\N	\N	\N	42898	42898	42899
11894	12585	17	applied	\N	\N	\N	\N	42635	42635	42636
11894	12586	18	applied	\N	\N	\N	\N	42637	42637	42638
11894	12587	19	applied	\N	\N	\N	\N	42639	42639	42640
11894	12588	20	applied	\N	\N	\N	\N	42641	42641	42642
11894	12696	21	applied	\N	\N	\N	\N	43055	43055	43056
11894	12697	22	applied	\N	\N	\N	\N	43057	43057	43058
11894	12698	23	applied	\N	\N	\N	\N	43059	43059	43060
11894	12699	24	applied	\N	\N	\N	\N	43061	43061	43062
11894	12700	25	applied	\N	\N	\N	\N	43063	43063	43064
11894	12701	26	applied	\N	\N	\N	\N	43065	43065	43066
11894	12619	27	applied	\N	\N	\N	\N	42769	42769	42770
11894	12620	28	applied	\N	\N	\N	\N	42771	42771	42772
11894	12621	29	applied	\N	\N	\N	\N	42773	42773	42774
11894	12530	30	applied	\N	\N	\N	\N	42420	42420	42421
11894	12531	31	applied	\N	\N	\N	\N	42422	42422	42423
11894	12532	32	applied	\N	\N	\N	\N	42424	42424	42425
11894	12533	33	applied	\N	\N	\N	\N	42428	42428	42429
11894	12534	34	applied	\N	\N	\N	\N	42430	42430	42431
11894	12535	35	applied	\N	\N	\N	\N	42435	42435	42436
11894	12536	36	applied	\N	\N	\N	\N	42440	42440	42441
11894	12660	37	applied	\N	\N	\N	\N	42912	42912	7825
11894	12537	38	applied	\N	\N	\N	\N	42443	42443	42444
11894	12538	39	applied	\N	\N	\N	\N	42447	42447	42448
11894	12539	40	applied	\N	\N	\N	\N	42449	42449	42450
11894	12540	41	applied	\N	\N	\N	\N	42451	42451	42452
11894	12541	42	applied	\N	\N	\N	\N	42455	42455	42456
11894	12542	43	applied	\N	\N	\N	\N	42459	42459	42460
11894	12543	44	applied	\N	\N	\N	\N	42463	42463	42464
11894	12544	45	applied	\N	\N	\N	\N	42465	42465	42466
11894	12545	46	applied	\N	\N	\N	\N	42472	42472	42473
11894	12546	47	applied	\N	\N	\N	\N	42474	42474	42475
11894	12547	48	applied	\N	\N	\N	\N	42476	42476	42477
11894	12548	49	applied	\N	\N	\N	\N	42478	42478	42479
11894	12549	50	applied	\N	\N	\N	\N	42482	42482	42483
11894	12550	51	applied	\N	\N	\N	\N	42484	42484	42485
11894	12551	52	applied	\N	\N	\N	\N	42488	42488	42489
11894	12552	53	applied	\N	\N	\N	\N	42494	42494	42495
11894	12553	54	applied	\N	\N	\N	\N	42502	42502	42503
11884	12755	3	applied	\N	\N	\N	\N	43263	43263	43264
11886	12757	0	applied	\N	\N	\N	\N	43273	43273	43274
11888	12758	0	applied	\N	\N	\N	\N	43275	43275	43276
11896	12766	0	applied	\N	\N	\N	\N	43308	43308	43309
11900	12770	0	applied	\N	\N	\N	\N	43321	43321	43322
11900	12771	1	applied	\N	\N	\N	\N	43323	43323	43324
11902	12773	0	applied	\N	\N	\N	\N	43331	43331	43332
11902	12774	1	applied	\N	\N	\N	\N	43333	43333	43334
11905	12776	0	applied	\N	\N	\N	\N	43341	43341	43342
11907	12778	0	applied	\N	\N	\N	\N	43347	43347	43348
11910	12781	0	applied	\N	\N	\N	\N	43359	43359	43360
11919	12786	0	applied	\N	\N	\N	\N	43380	43380	43381
11922	12789	0	applied	\N	\N	\N	\N	43390	43390	43391
11925	12792	0	applied	\N	\N	\N	\N	43400	43400	43401
11925	12793	1	applied	\N	\N	\N	\N	43402	43402	43403
11929	12796	0	applied	\N	\N	\N	\N	43414	43414	43415
11934	12770	0	applied	\N	\N	\N	\N	43321	43321	43322
11934	12771	1	applied	\N	\N	\N	\N	43323	43323	43324
11934	12772	2	applied	\N	\N	\N	\N	43327	43327	43328
11934	12773	3	applied	\N	\N	\N	\N	43331	43331	43332
11934	12774	4	applied	\N	\N	\N	\N	43333	43333	43334
11934	12775	5	applied	\N	\N	\N	\N	43337	43337	43338
11934	12776	6	applied	\N	\N	\N	\N	43341	43341	43342
11934	12777	7	applied	\N	\N	\N	\N	43343	43343	43344
11934	12778	8	applied	\N	\N	\N	\N	43347	43347	43348
11934	12779	9	applied	\N	\N	\N	\N	43351	43351	43352
11934	12780	10	applied	\N	\N	\N	\N	43355	43355	43356
11934	12781	11	applied	\N	\N	\N	\N	43359	43359	43360
11934	12782	12	applied	\N	\N	\N	\N	43361	43361	43362
11934	12783	13	applied	\N	\N	\N	\N	43366	43366	43367
11934	12784	14	applied	\N	\N	\N	\N	43372	43372	43373
11934	12785	15	applied	\N	\N	\N	\N	43378	43378	43379
11934	12786	16	applied	\N	\N	\N	\N	43380	43380	43381
11934	12787	17	applied	\N	\N	\N	\N	43384	43384	43385
11934	12788	18	applied	\N	\N	\N	\N	43386	43386	43387
11934	12789	19	applied	\N	\N	\N	\N	43390	43390	43391
11934	12790	20	applied	\N	\N	\N	\N	43394	43394	43395
11934	12791	21	applied	\N	\N	\N	\N	43396	43396	43397
11934	12792	22	applied	\N	\N	\N	\N	43400	43400	43401
11934	12793	23	applied	\N	\N	\N	\N	43402	43402	43403
11934	12794	24	applied	\N	\N	\N	\N	43406	43406	43407
11934	12795	25	applied	\N	\N	\N	\N	43410	43410	43411
11934	12796	26	applied	\N	\N	\N	\N	43414	43414	43415
11934	12797	27	applied	\N	\N	\N	\N	43420	43420	43421
11934	12798	28	applied	\N	\N	\N	\N	43422	43422	43423
11934	12799	29	applied	\N	\N	\N	\N	43424	43424	43425
11934	12800	30	applied	\N	\N	\N	\N	43429	43429	43430
11934	12801	31	applied	\N	\N	\N	\N	43433	43433	43434
11942	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
11942	12808	1	applied	\N	\N	\N	\N	43458	43458	43459
11942	12809	2	applied	\N	\N	\N	\N	43460	43460	43461
11942	12810	3	applied	\N	\N	\N	\N	43462	43462	43463
11942	12811	4	applied	\N	\N	\N	\N	43464	43464	43465
11942	12812	5	applied	\N	\N	\N	\N	43466	43466	43467
11942	12813	6	applied	\N	\N	\N	\N	43468	43468	43469
11942	12814	7	applied	\N	\N	\N	\N	43470	43470	43471
11959	12829	0	applied	\N	\N	\N	\N	43533	43533	43534
11959	12830	1	applied	\N	\N	\N	\N	43535	43535	43536
11962	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
11962	12819	1	applied	\N	\N	\N	\N	43491	43491	43492
11962	12820	2	applied	\N	\N	\N	\N	43493	43493	43494
11962	12821	3	applied	\N	\N	\N	\N	43495	43495	43496
11962	12818	4	applied	\N	\N	\N	\N	43497	43497	43488
11964	12833	0	applied	\N	\N	\N	\N	43549	43549	43550
11968	12834	0	applied	\N	\N	\N	\N	43557	43557	43558
11974	12838	0	applied	\N	\N	\N	\N	43572	43572	43573
11976	12840	0	applied	\N	\N	\N	\N	43581	43581	43582
11976	12841	1	applied	\N	\N	\N	\N	43583	43583	43584
11977	12840	0	applied	\N	\N	\N	\N	43581	43581	43582
11977	12841	1	applied	\N	\N	\N	\N	43583	43583	43584
11981	12843	0	applied	\N	\N	\N	\N	43591	43591	43592
11983	12845	0	applied	\N	\N	\N	\N	43598	43598	43599
11988	12847	0	applied	\N	\N	\N	\N	43606	43606	43607
11990	12848	0	applied	\N	\N	\N	\N	43615	43615	43616
11990	12849	1	applied	\N	\N	\N	\N	43617	43617	43618
11999	12853	0	applied	\N	\N	\N	\N	43638	43638	43639
12005	12861	0	applied	\N	\N	\N	\N	43661	43661	43662
12007	12862	0	applied	\N	\N	\N	\N	43665	43665	43666
12008	12862	0	applied	\N	\N	\N	\N	43665	43665	43666
12013	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
12013	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
12013	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
12013	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
12013	12750	4	applied	\N	\N	\N	\N	43243	43243	43244
12013	12854	5	applied	\N	\N	1000000000	\N	43641	43641	43642
12013	12865	6	applied	\N	\N	\N	\N	43673	43673	43674
12013	12818	7	applied	\N	\N	\N	\N	43508	43508	43488
12013	12866	8	applied	\N	\N	\N	\N	43675	43675	43676
12013	12749	9	applied	\N	\N	\N	\N	43240	43240	43241
12013	12751	10	applied	\N	\N	\N	\N	43248	43248	43249
12013	12752	11	applied	\N	\N	\N	\N	43257	43257	43258
12013	12753	12	applied	\N	\N	\N	\N	43259	43259	43260
12013	12754	13	applied	\N	\N	\N	\N	43261	43261	43262
12013	12755	14	applied	\N	\N	\N	\N	43263	43263	43264
12013	12756	15	applied	\N	\N	\N	\N	43270	43270	43271
12013	12757	16	applied	\N	\N	\N	\N	43273	43273	43274
12013	12758	17	applied	\N	\N	\N	\N	43275	43275	43276
12013	12759	18	applied	\N	\N	\N	\N	43280	43280	43281
12013	12760	19	applied	\N	\N	\N	\N	43282	43282	43283
12013	12761	20	applied	\N	\N	\N	\N	43286	43286	43287
12013	12762	21	applied	\N	\N	\N	\N	43289	43289	43290
12013	12763	22	applied	\N	\N	\N	\N	43291	43291	43292
12013	12764	23	applied	\N	\N	\N	\N	43302	43302	43303
12013	12765	24	applied	\N	\N	\N	\N	43304	43304	43305
12013	12766	25	applied	\N	\N	\N	\N	43308	43308	43309
12013	12767	26	applied	\N	\N	\N	\N	43312	43312	43313
12013	12768	27	applied	\N	\N	\N	\N	43314	43314	43315
12013	12769	28	applied	\N	\N	\N	\N	43318	43318	43319
12013	12770	29	applied	\N	\N	\N	\N	43321	43321	43322
12013	12771	30	applied	\N	\N	\N	\N	43323	43323	43324
12013	12772	31	applied	\N	\N	\N	\N	43327	43327	43328
12013	12773	32	applied	\N	\N	\N	\N	43331	43331	43332
12013	12774	33	applied	\N	\N	\N	\N	43333	43333	43334
12013	12775	34	applied	\N	\N	\N	\N	43337	43337	43338
12013	12776	35	applied	\N	\N	\N	\N	43341	43341	43342
12013	12777	36	applied	\N	\N	\N	\N	43343	43343	43344
12013	12778	37	applied	\N	\N	\N	\N	43347	43347	43348
12013	12779	38	applied	\N	\N	\N	\N	43351	43351	43352
12013	12780	39	applied	\N	\N	\N	\N	43355	43355	43356
12013	12781	40	applied	\N	\N	\N	\N	43359	43359	43360
11894	12554	55	applied	\N	\N	\N	\N	42510	42510	42511
11894	12555	56	applied	\N	\N	\N	\N	42512	42512	42513
11894	12556	57	applied	\N	\N	\N	\N	42514	42514	42515
11894	12557	58	applied	\N	\N	\N	\N	42516	42516	42517
11894	12558	59	applied	\N	\N	\N	\N	42523	42523	42524
11894	12559	60	applied	\N	\N	\N	\N	42527	42527	42528
11894	12560	61	applied	\N	\N	\N	\N	42529	42529	42530
11894	12561	62	applied	\N	\N	\N	\N	42535	42535	42536
11894	12562	63	applied	\N	\N	\N	\N	42543	42543	42544
11894	12563	64	applied	\N	\N	\N	\N	42545	42545	42546
11894	12564	65	applied	\N	\N	\N	\N	42557	42557	42558
11894	12565	66	applied	\N	\N	\N	\N	42563	42563	42564
11894	12566	67	applied	\N	\N	\N	\N	42566	42566	42567
11894	12567	68	applied	\N	\N	\N	\N	42572	42572	42573
11894	12569	69	applied	\N	\N	\N	\N	42582	42582	42583
11894	12570	70	applied	\N	\N	\N	\N	42584	42584	42585
11894	12571	71	applied	\N	\N	\N	\N	42586	42586	42587
11894	12572	72	applied	\N	\N	\N	\N	42588	42588	42589
11894	12573	73	applied	\N	\N	\N	\N	42591	42591	42592
11894	12574	74	applied	\N	\N	\N	\N	42604	42604	42605
11894	12575	75	applied	\N	\N	\N	\N	42607	42607	42608
11894	12576	76	applied	\N	\N	\N	\N	42609	42609	42610
11894	12577	77	applied	\N	\N	\N	\N	42611	42611	42612
11894	12578	78	applied	\N	\N	\N	\N	42615	42615	42616
11894	12579	79	applied	\N	\N	\N	\N	42621	42621	42622
11894	12580	80	applied	\N	\N	\N	\N	42623	42623	42624
11894	12581	81	applied	\N	\N	\N	\N	42625	42625	42626
11894	12582	82	applied	\N	\N	\N	\N	42628	42628	42629
11894	12583	83	applied	\N	\N	\N	\N	42630	42630	42631
11894	12589	84	applied	\N	\N	\N	\N	42643	42643	42644
11894	12590	85	applied	\N	\N	\N	\N	42645	42645	42646
11894	12591	86	applied	\N	\N	\N	\N	42647	42647	42648
11894	12592	87	applied	\N	\N	\N	\N	42649	42649	42650
11894	12593	88	applied	\N	\N	\N	\N	42658	42658	42659
11894	12594	89	applied	\N	\N	\N	\N	42660	42660	42661
11894	12595	90	applied	\N	\N	\N	\N	42666	42666	42667
11894	12596	91	applied	\N	\N	\N	\N	42668	42668	42669
11894	12597	92	applied	\N	\N	\N	\N	42676	42676	42677
11894	12598	93	applied	\N	\N	\N	\N	42682	42682	42683
11894	12599	96	applied	\N	\N	\N	\N	42686	42686	42687
11894	12600	97	applied	\N	\N	\N	\N	42688	42688	42689
11894	12601	98	applied	\N	\N	\N	\N	42693	42693	42694
11894	12602	99	applied	\N	\N	\N	\N	42697	42697	42698
11894	12603	100	applied	\N	\N	\N	\N	42702	42702	42703
11894	12604	101	applied	\N	\N	\N	\N	42708	42708	42709
11894	12605	102	applied	\N	\N	\N	\N	42712	42712	42713
11894	12606	103	applied	\N	\N	\N	\N	42714	42714	42715
11894	12607	104	applied	\N	\N	\N	\N	42718	42718	42719
11894	12608	105	applied	\N	\N	\N	\N	42727	42727	42728
11894	12609	106	applied	\N	\N	\N	\N	42729	42729	42730
11894	12610	107	applied	\N	\N	\N	\N	42733	42733	42734
11894	12611	108	applied	\N	\N	\N	\N	42738	42738	42739
11894	12612	109	applied	\N	\N	\N	\N	42743	42743	42744
11894	12613	110	applied	\N	\N	\N	\N	42748	42748	42749
11894	12614	111	applied	\N	\N	\N	\N	42751	42751	42752
11894	12615	112	applied	\N	\N	\N	\N	42753	42753	42754
11894	12616	113	applied	\N	\N	\N	\N	42759	42759	42760
11894	12617	114	applied	\N	\N	\N	\N	42765	42765	42766
11894	12622	115	applied	\N	\N	\N	\N	42777	42777	42778
11894	12623	116	applied	\N	\N	\N	\N	42779	42779	42780
11894	12624	117	applied	\N	\N	\N	\N	42781	42781	42782
11894	12625	118	applied	\N	\N	\N	\N	42790	42790	42791
11894	12626	119	applied	\N	\N	1000000000	\N	42792	42792	42793
11894	12627	120	applied	\N	\N	\N	\N	42795	42795	42796
11894	12628	121	applied	\N	\N	\N	\N	42798	42798	42799
11894	12629	122	applied	\N	\N	\N	\N	42801	42801	42802
11894	12630	123	applied	\N	\N	\N	\N	42805	42805	42806
11894	12631	124	applied	\N	\N	\N	\N	42807	42807	42808
11894	12632	125	applied	\N	\N	\N	\N	42811	42811	42812
11897	12767	0	applied	\N	\N	\N	\N	43312	43312	43313
11897	12768	1	applied	\N	\N	\N	\N	43314	43314	43315
11903	12773	0	applied	\N	\N	\N	\N	43331	43331	43332
11903	12774	1	applied	\N	\N	\N	\N	43333	43333	43334
11908	12779	0	applied	\N	\N	\N	\N	43351	43351	43352
11913	12782	0	applied	\N	\N	\N	\N	43361	43361	43362
11915	12693	0	applied	\N	\N	\N	\N	43049	43049	43050
11915	12735	1	applied	\N	\N	\N	\N	43183	43183	43184
11915	12740	2	applied	\N	\N	\N	\N	43209	43209	43210
11915	12745	3	applied	\N	\N	\N	\N	43225	43225	43226
11915	12750	4	applied	\N	\N	\N	\N	43243	43243	43244
11915	12646	5	applied	\N	\N	\N	\N	42866	42866	42867
11915	12647	6	applied	\N	\N	\N	\N	42868	42868	42869
11915	12694	7	applied	\N	\N	\N	\N	43051	43051	43052
11915	12618	8	applied	\N	\N	\N	\N	42767	42767	42768
11915	12695	9	applied	\N	\N	\N	\N	43053	43053	43054
11915	12650	10	applied	\N	\N	\N	\N	42876	42876	42877
11915	12652	11	applied	\N	\N	\N	\N	42881	42881	42882
11915	12654	12	applied	\N	\N	\N	\N	42889	42889	42890
11915	12655	13	applied	\N	\N	\N	\N	42891	42891	42892
11915	12657	14	applied	\N	\N	\N	\N	42898	42898	42899
11915	12696	15	applied	\N	\N	\N	\N	43055	43055	43056
11915	12697	16	applied	\N	\N	\N	\N	43057	43057	43058
11915	12698	17	applied	\N	\N	\N	\N	43059	43059	43060
11915	12699	18	applied	\N	\N	\N	\N	43061	43061	43062
11915	12700	19	applied	\N	\N	\N	\N	43063	43063	43064
11915	12701	20	applied	\N	\N	\N	\N	43065	43065	43066
11915	12619	21	applied	\N	\N	\N	\N	42769	42769	42770
11915	12620	22	applied	\N	\N	\N	\N	42771	42771	42772
11915	12621	23	applied	\N	\N	\N	\N	42773	42773	42774
11915	12660	24	applied	\N	\N	\N	\N	42912	42912	7825
11917	12784	0	applied	\N	\N	\N	\N	43372	43372	43373
11920	12786	0	applied	\N	\N	\N	\N	43380	43380	43381
11935	12801	0	applied	\N	\N	\N	\N	43433	43433	43434
11940	12805	0	applied	\N	\N	\N	\N	43451	43451	43452
11940	12806	1	applied	\N	\N	\N	\N	43453	43453	43454
11941	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
11941	12808	1	applied	\N	\N	\N	\N	43458	43458	43459
11941	12809	2	applied	\N	\N	\N	\N	43460	43460	43461
11941	12810	3	applied	\N	\N	\N	\N	43462	43462	43463
11941	12811	4	applied	\N	\N	\N	\N	43464	43464	43465
11941	12812	5	applied	\N	\N	\N	\N	43466	43466	43467
11941	12813	6	applied	\N	\N	\N	\N	43468	43468	43469
11941	12814	7	applied	\N	\N	\N	\N	43470	43470	43471
11946	12817	0	applied	\N	\N	\N	\N	43485	43485	43486
11946	12818	1	applied	\N	\N	\N	\N	43487	43487	43488
11949	12822	0	applied	\N	\N	\N	\N	43500	43500	43501
11949	12823	1	applied	\N	\N	\N	\N	43502	43502	43503
11951	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
11951	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
11951	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
11951	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
11951	12633	4	applied	\N	\N	\N	\N	42815	42815	42816
11951	12818	5	applied	\N	\N	\N	\N	43508	43508	43488
11951	12634	6	applied	\N	\N	\N	\N	42821	42821	42822
11951	12635	7	applied	\N	\N	\N	\N	42823	42823	42824
11951	12636	8	applied	\N	\N	\N	\N	42827	42827	42828
11951	12637	9	applied	\N	\N	\N	\N	42831	42831	42832
11951	12638	10	applied	\N	\N	\N	\N	42835	42835	42836
11951	12639	11	applied	\N	\N	\N	\N	42839	42839	42840
11951	12640	12	applied	\N	\N	\N	\N	42845	42845	42846
11951	12641	13	applied	\N	\N	\N	\N	42847	42847	42848
11951	12642	14	applied	\N	\N	\N	\N	42852	42852	42853
11951	12643	15	applied	\N	\N	\N	\N	42854	42854	42855
11953	12822	0	applied	\N	\N	\N	\N	43500	43500	43501
11953	12823	1	applied	\N	\N	\N	\N	43502	43502	43503
11953	12824	2	applied	\N	\N	\N	\N	43512	43512	43513
11953	12825	3	applied	\N	\N	\N	\N	43516	43516	43517
11958	12828	0	applied	\N	\N	\N	\N	43528	43528	43529
11961	12831	0	applied	\N	\N	\N	\N	43539	43539	43540
11961	12832	1	applied	\N	\N	\N	\N	43541	43541	43542
11963	12833	0	applied	\N	\N	\N	\N	43549	43549	43550
11966	12833	0	applied	\N	\N	\N	\N	43549	43549	43550
11970	12835	0	applied	\N	\N	\N	\N	43561	43561	43562
11970	12836	1	applied	\N	\N	\N	\N	43563	43563	43564
11972	12837	0	applied	\N	\N	\N	\N	43570	43570	43571
11982	12844	0	applied	\N	\N	\N	\N	43594	43594	43595
11984	12845	0	applied	\N	\N	\N	\N	43598	43598	43599
11989	12847	0	applied	\N	\N	\N	\N	43606	43606	43607
11991	12848	0	applied	\N	\N	\N	\N	43615	43615	43616
11991	12849	1	applied	\N	\N	\N	\N	43617	43617	43618
11994	12851	0	applied	\N	\N	\N	\N	43627	43627	43628
11996	12852	0	applied	\N	\N	\N	\N	43630	43630	43631
11998	12852	0	applied	\N	\N	\N	\N	43630	43630	43631
12001	12854	0	applied	\N	\N	1000000000	\N	43641	43641	43642
12001	12855	1	applied	\N	\N	\N	\N	43643	43643	43644
12003	12856	0	applied	\N	\N	\N	\N	43649	43649	43650
12006	12862	0	applied	\N	\N	\N	\N	43665	43665	43666
12009	12862	0	applied	\N	\N	\N	\N	43665	43665	43666
12014	12870	0	applied	\N	\N	\N	\N	43685	43685	43686
12016	12871	0	applied	\N	\N	\N	\N	43695	43695	43696
12016	12872	1	applied	\N	\N	\N	\N	43697	43697	43698
12020	12874	0	applied	\N	\N	\N	\N	43705	43705	43706
12030	12881	0	applied	\N	\N	\N	\N	43739	43739	43740
12041	12890	0	applied	\N	\N	\N	\N	43775	43775	43776
12044	12892	0	applied	\N	\N	\N	\N	43782	43782	43783
12048	12894	0	applied	\N	\N	\N	\N	43795	43795	43796
12051	12894	0	applied	\N	\N	\N	\N	43795	43795	43796
12052	12895	0	applied	\N	\N	\N	\N	43803	43803	43804
12054	12900	0	applied	\N	\N	\N	\N	43816	43816	43817
12058	12901	0	applied	\N	\N	\N	\N	43823	43823	43824
12063	12905	0	applied	\N	\N	\N	\N	43838	43838	43839
12063	12906	1	applied	\N	\N	\N	\N	43840	43840	43841
12063	12907	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	43842	43842	\N
12063	12908	3	applied	\N	\N	\N	\N	43843	43843	43843
12066	12909	0	applied	\N	\N	\N	\N	43848	43848	43849
12072	12918	0	applied	\N	\N	\N	\N	43874	43874	43875
12075	12921	0	applied	\N	\N	\N	\N	43885	43885	43886
12075	12922	1	applied	\N	\N	\N	\N	43887	43887	43888
12075	12923	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	43889	43889	\N
12078	12925	0	applied	\N	\N	\N	\N	43898	43898	43899
12083	12930	0	applied	\N	\N	\N	\N	43917	43917	43918
12083	12931	1	applied	\N	\N	\N	\N	43919	43919	43920
12096	12943	0	applied	\N	\N	\N	\N	43966	43966	43967
12099	12945	0	applied	\N	\N	\N	\N	43972	43972	43973
12099	12946	1	applied	\N	\N	\N	\N	43974	43974	43975
12106	12952	0	applied	\N	\N	\N	\N	43996	43996	43997
12108	12952	0	applied	\N	\N	\N	\N	43996	43996	43997
12114	12958	0	applied	\N	\N	\N	\N	44013	44013	44014
12116	12959	0	applied	\N	\N	\N	\N	44018	44018	44019
12125	12964	0	applied	\N	\N	\N	\N	44041	44041	44042
12137	12973	0	applied	\N	\N	\N	\N	44077	44077	44078
12142	12975	0	applied	\N	\N	\N	\N	44085	44085	44086
12142	12976	1	applied	\N	\N	\N	\N	44087	44087	44088
12144	12975	0	applied	\N	\N	\N	\N	44085	44085	44086
12144	12976	1	applied	\N	\N	\N	\N	44087	44087	44088
12149	12984	0	applied	\N	\N	\N	\N	44115	44115	44116
12151	12985	0	applied	\N	\N	\N	\N	44119	44119	44120
12154	12986	0	applied	\N	\N	\N	\N	44125	44125	44126
12166	12994	0	applied	\N	\N	\N	\N	44156	44156	44157
12166	12995	1	applied	\N	\N	\N	\N	44158	44158	44159
12166	12996	2	applied	\N	\N	\N	\N	44160	44160	44161
12166	12997	3	applied	\N	\N	\N	\N	44162	44162	44163
12171	12999	0	applied	\N	\N	\N	\N	44172	44172	44173
12177	13008	0	applied	\N	\N	\N	\N	44198	44198	44199
12181	13009	0	applied	\N	\N	\N	\N	44204	44204	44205
12181	13010	1	applied	\N	\N	\N	\N	44206	44206	44207
12181	13011	2	applied	\N	\N	\N	\N	44208	44208	44209
12181	13012	3	applied	\N	\N	\N	\N	44210	44210	44211
12182	13013	0	applied	\N	\N	\N	\N	44217	44217	44218
12182	13014	1	applied	\N	\N	\N	\N	44219	44219	44220
12187	13018	0	applied	\N	\N	\N	\N	44242	44242	44243
12192	13013	0	applied	\N	\N	\N	\N	44217	44217	44218
12192	12994	1	applied	\N	\N	\N	\N	44156	44156	44157
12192	12995	2	applied	\N	\N	\N	\N	44158	44158	44159
12192	12996	3	applied	\N	\N	\N	\N	44160	44160	44161
12192	12997	4	applied	\N	\N	\N	\N	44162	44162	44163
12192	12998	5	applied	\N	\N	\N	\N	44167	44167	44168
12192	12999	6	applied	\N	\N	\N	\N	44172	44172	44173
12192	13000	7	applied	\N	\N	\N	\N	44175	44175	44176
12192	13001	8	applied	\N	\N	\N	\N	44177	44177	44178
12192	13002	9	applied	\N	\N	\N	\N	44181	44181	44182
12192	13003	10	applied	\N	\N	\N	\N	44183	44183	44184
12192	13004	11	applied	\N	\N	\N	\N	44185	44185	44186
12192	13005	12	applied	\N	\N	\N	\N	44188	44188	44189
12192	13006	13	applied	\N	\N	\N	\N	44190	44190	44191
12192	13007	14	applied	\N	\N	\N	\N	44192	44192	44193
12192	13008	15	applied	\N	\N	\N	\N	44198	44198	44199
12192	13009	16	applied	\N	\N	\N	\N	44204	44204	44205
12192	13010	17	applied	\N	\N	\N	\N	44206	44206	44207
12192	13011	18	applied	\N	\N	\N	\N	44208	44208	44209
12192	13012	19	applied	\N	\N	\N	\N	44210	44210	44211
12192	13014	20	applied	\N	\N	\N	\N	44219	44219	44220
12192	13015	21	applied	\N	\N	\N	\N	44222	44222	44223
12192	13016	22	applied	\N	\N	\N	\N	44235	44235	44236
12192	13017	23	applied	\N	\N	\N	\N	44239	44239	44240
12192	13018	24	applied	\N	\N	\N	\N	44242	44242	44243
12192	13019	25	applied	\N	\N	\N	\N	44246	44246	44247
12192	13020	26	applied	\N	\N	\N	\N	44248	44248	44249
12192	13021	27	applied	\N	\N	\N	\N	44250	44250	44251
11957	12828	0	applied	\N	\N	\N	\N	43528	43528	43529
11960	12831	0	applied	\N	\N	\N	\N	43539	43539	43540
11960	12832	1	applied	\N	\N	\N	\N	43541	43541	43542
11965	12833	0	applied	\N	\N	\N	\N	43549	43549	43550
11967	12833	0	applied	\N	\N	\N	\N	43549	43549	43550
11969	12835	0	applied	\N	\N	\N	\N	43561	43561	43562
11969	12836	1	applied	\N	\N	\N	\N	43563	43563	43564
11978	12840	0	applied	\N	\N	\N	\N	43581	43581	43582
11978	12841	1	applied	\N	\N	\N	\N	43583	43583	43584
11979	12842	0	applied	\N	\N	\N	\N	43587	43587	43588
11986	12847	0	applied	\N	\N	\N	\N	43606	43606	43607
11993	12851	0	applied	\N	\N	\N	\N	43627	43627	43628
12000	12854	0	applied	\N	\N	1000000000	\N	43641	43641	43642
12000	12855	1	applied	\N	\N	\N	\N	43643	43643	43644
12002	12856	0	applied	\N	\N	\N	\N	43649	43649	43650
12002	12857	1	applied	\N	\N	\N	\N	43651	43651	43652
12010	12863	0	applied	\N	\N	\N	\N	43669	43669	43670
12011	12864	0	applied	\N	\N	\N	\N	43671	43671	43672
12011	12865	1	applied	\N	\N	\N	\N	43673	43673	43674
12011	12866	2	applied	\N	\N	\N	\N	43675	43675	43676
12011	12867	3	applied	\N	\N	\N	\N	43677	43677	43678
12011	12868	4	applied	\N	\N	\N	\N	43679	43679	43680
12011	12869	5	applied	\N	\N	\N	\N	43681	43681	43682
12019	12874	0	applied	\N	\N	\N	\N	43705	43705	43706
12027	12854	0	applied	\N	\N	1000000000	\N	43641	43641	43642
12027	12865	1	applied	\N	\N	\N	\N	43673	43673	43674
12027	12866	2	applied	\N	\N	\N	\N	43675	43675	43676
12029	12881	0	applied	\N	\N	\N	\N	43739	43739	43740
12031	12881	0	applied	\N	\N	\N	\N	43739	43739	43740
12033	12883	0	applied	\N	\N	\N	\N	43749	43749	43750
12036	12887	0	applied	\N	\N	\N	\N	43762	43762	43763
12036	12888	1	applied	\N	\N	\N	\N	43764	43764	43765
12043	12892	0	applied	\N	\N	\N	\N	43782	43782	43783
12055	12900	0	applied	\N	\N	\N	\N	43816	43816	43817
12059	12884	0	applied	\N	\N	\N	\N	43753	43753	43754
12059	12854	1	applied	\N	\N	1000000000	\N	43641	43641	43642
12059	12898	2	applied	\N	\N	1000000000	\N	43811	43811	43812
12059	12840	3	applied	\N	\N	\N	\N	43581	43581	43582
12059	12865	4	applied	\N	\N	\N	\N	43673	43673	43674
12059	12899	5	applied	\N	\N	\N	\N	43813	43813	43813
12059	12866	6	applied	\N	\N	\N	\N	43675	43675	43676
12059	12841	7	applied	\N	\N	\N	\N	43583	43583	43584
12059	12842	8	applied	\N	\N	\N	\N	43587	43587	43588
12059	12843	9	applied	\N	\N	\N	\N	43591	43591	43592
12059	12844	10	applied	\N	\N	\N	\N	43594	43594	43595
12059	12845	11	applied	\N	\N	\N	\N	43598	43598	43599
12059	12846	12	applied	\N	\N	\N	\N	43602	43602	43603
12059	12847	13	applied	\N	\N	\N	\N	43606	43606	43607
12059	12848	14	applied	\N	\N	\N	\N	43615	43615	43616
12059	12849	15	applied	\N	\N	\N	\N	43617	43617	43618
12059	12850	16	applied	\N	\N	\N	\N	43623	43623	43624
12059	12851	17	applied	\N	\N	\N	\N	43627	43627	43628
12059	12852	18	applied	\N	\N	\N	\N	43630	43630	43631
12059	12853	19	applied	\N	\N	\N	\N	43638	43638	43639
12059	12855	20	applied	\N	\N	\N	\N	43643	43643	43644
12059	12856	21	applied	\N	\N	\N	\N	43649	43649	43650
12059	12857	22	applied	\N	\N	\N	\N	43651	43651	43652
12059	12858	23	applied	\N	\N	\N	\N	43654	43654	43655
12059	12859	24	applied	\N	\N	\N	\N	43656	43656	43657
12059	12860	25	applied	\N	\N	\N	\N	43658	43658	43659
12059	12861	26	applied	\N	\N	\N	\N	43661	43661	43662
12059	12862	27	applied	\N	\N	\N	\N	43665	43665	43666
12059	12863	28	applied	\N	\N	\N	\N	43669	43669	43670
12059	12864	29	applied	\N	\N	\N	\N	43671	43671	43672
12059	12867	30	applied	\N	\N	\N	\N	43677	43677	43678
12059	12868	31	applied	\N	\N	\N	\N	43679	43679	43680
12059	12869	32	applied	\N	\N	\N	\N	43681	43681	43682
12059	12870	33	applied	\N	\N	\N	\N	43685	43685	43686
12059	12871	34	applied	\N	\N	\N	\N	43695	43695	43696
12059	12872	35	applied	\N	\N	\N	\N	43697	43697	43698
12059	12873	36	applied	\N	\N	\N	\N	43701	43701	43702
12059	12874	37	applied	\N	\N	\N	\N	43705	43705	43706
12059	12875	38	applied	\N	\N	\N	\N	43717	43717	43718
12059	12876	39	applied	\N	\N	\N	\N	43719	43719	43720
12059	12877	40	applied	\N	\N	\N	\N	43723	43723	43724
12059	12878	41	applied	\N	\N	\N	\N	43727	43727	43728
12059	12879	42	applied	\N	\N	\N	\N	43731	43731	43732
12059	12880	43	applied	\N	\N	\N	\N	43733	43733	43734
12059	12881	44	applied	\N	\N	\N	\N	43739	43739	43740
12059	12882	45	applied	\N	\N	\N	\N	43745	43745	43746
12059	12883	46	applied	\N	\N	\N	\N	43749	43749	43750
12059	12885	47	applied	\N	\N	\N	\N	43755	43755	43756
12059	12886	48	applied	\N	\N	\N	\N	43758	43758	43759
12059	12887	49	applied	\N	\N	\N	\N	43762	43762	43763
12059	12888	50	applied	\N	\N	\N	\N	43764	43764	43765
12059	12889	51	applied	\N	\N	\N	\N	43768	43768	43769
12059	12890	52	applied	\N	\N	\N	\N	43775	43775	43776
12059	12891	53	applied	\N	\N	\N	\N	43778	43778	43779
12059	12892	54	applied	\N	\N	\N	\N	43782	43782	43783
12059	12893	55	applied	\N	\N	\N	\N	43789	43789	43790
12059	12894	57	applied	\N	\N	\N	\N	43795	43795	43796
12059	12895	58	applied	\N	\N	\N	\N	43803	43803	43804
12059	12896	59	applied	\N	\N	\N	\N	43807	43807	43808
12059	12897	60	applied	\N	\N	\N	\N	43809	43809	43810
12059	12900	61	applied	\N	\N	\N	\N	43816	43816	43817
12059	12901	62	applied	\N	\N	\N	\N	43823	43823	43824
12061	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
12061	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
12061	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
12061	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
12061	12884	4	applied	\N	\N	\N	\N	43753	43753	43754
12061	12758	5	applied	\N	\N	\N	\N	43275	43275	43276
12061	12759	6	applied	\N	\N	\N	\N	43280	43280	43281
12061	12854	7	applied	\N	\N	1000000000	\N	43641	43641	43642
12061	12760	8	applied	\N	\N	\N	\N	43282	43282	43283
12061	12898	9	applied	\N	\N	1000000000	\N	43811	43811	43812
12061	12865	10	applied	\N	\N	\N	\N	43673	43673	43674
12061	12761	11	applied	\N	\N	\N	\N	43286	43286	43287
12061	12762	12	applied	\N	\N	\N	\N	43289	43289	43290
12061	12763	13	applied	\N	\N	\N	\N	43291	43291	43292
12061	12764	14	applied	\N	\N	\N	\N	43302	43302	43303
12061	12899	15	applied	\N	\N	\N	\N	43813	43813	43813
12061	12818	16	applied	\N	\N	\N	\N	43508	43508	43488
12061	12866	17	applied	\N	\N	\N	\N	43675	43675	43676
12061	12765	18	applied	\N	\N	\N	\N	43304	43304	43305
12061	12766	19	applied	\N	\N	\N	\N	43308	43308	43309
12061	12767	20	applied	\N	\N	\N	\N	43312	43312	43313
12061	12768	21	applied	\N	\N	\N	\N	43314	43314	43315
12061	12769	22	applied	\N	\N	\N	\N	43318	43318	43319
12013	12782	41	applied	\N	\N	\N	\N	43361	43361	43362
12013	12783	42	applied	\N	\N	\N	\N	43366	43366	43367
12013	12784	43	applied	\N	\N	\N	\N	43372	43372	43373
12013	12785	44	applied	\N	\N	\N	\N	43378	43378	43379
12013	12786	45	applied	\N	\N	\N	\N	43380	43380	43381
12013	12787	46	applied	\N	\N	\N	\N	43384	43384	43385
12013	12788	47	applied	\N	\N	\N	\N	43386	43386	43387
12013	12789	48	applied	\N	\N	\N	\N	43390	43390	43391
12013	12790	49	applied	\N	\N	\N	\N	43394	43394	43395
12013	12791	50	applied	\N	\N	\N	\N	43396	43396	43397
12013	12792	51	applied	\N	\N	\N	\N	43400	43400	43401
12013	12793	52	applied	\N	\N	\N	\N	43402	43402	43403
12013	12794	53	applied	\N	\N	\N	\N	43406	43406	43407
12013	12795	54	applied	\N	\N	\N	\N	43410	43410	43411
12013	12796	55	applied	\N	\N	\N	\N	43414	43414	43415
12013	12797	56	applied	\N	\N	\N	\N	43420	43420	43421
12013	12798	57	applied	\N	\N	\N	\N	43422	43422	43423
12013	12799	58	applied	\N	\N	\N	\N	43424	43424	43425
12013	12800	59	applied	\N	\N	\N	\N	43429	43429	43430
12013	12801	60	applied	\N	\N	\N	\N	43433	43433	43434
12013	12802	61	applied	\N	\N	\N	\N	43442	43442	43443
12013	12803	62	applied	\N	\N	\N	\N	43444	43444	43445
12013	12804	63	applied	\N	\N	\N	\N	43446	43446	43447
12013	12805	64	applied	\N	\N	\N	\N	43451	43451	43452
12013	12806	65	applied	\N	\N	\N	\N	43453	43453	43454
12013	12808	66	applied	\N	\N	\N	\N	43458	43458	43459
12013	12809	67	applied	\N	\N	\N	\N	43460	43460	43461
12013	12813	69	applied	\N	\N	\N	\N	43468	43468	43469
12013	12814	70	applied	\N	\N	\N	\N	43470	43470	43471
12013	12815	71	applied	\N	\N	\N	\N	43475	43475	43476
12013	12816	72	applied	\N	\N	\N	\N	43481	43481	43482
12013	12817	73	applied	\N	\N	\N	\N	43485	43485	43486
12013	12822	74	applied	\N	\N	\N	\N	43500	43500	43501
12013	12823	75	applied	\N	\N	\N	\N	43502	43502	43503
12013	12824	76	applied	\N	\N	\N	\N	43512	43512	43513
12013	12825	77	applied	\N	\N	\N	\N	43516	43516	43517
12013	12826	78	applied	\N	\N	\N	\N	43521	43521	43522
12013	12827	79	applied	\N	\N	\N	\N	43523	43523	43524
12013	12828	80	applied	\N	\N	\N	\N	43528	43528	43529
12013	12829	81	applied	\N	\N	\N	\N	43533	43533	43534
12013	12830	82	applied	\N	\N	\N	\N	43535	43535	43536
12013	12831	83	applied	\N	\N	\N	\N	43539	43539	43540
12013	12832	84	applied	\N	\N	\N	\N	43541	43541	43542
12013	12833	85	applied	\N	\N	\N	\N	43549	43549	43550
12013	12834	86	applied	\N	\N	\N	\N	43557	43557	43558
12013	12835	87	applied	\N	\N	\N	\N	43561	43561	43562
12013	12836	88	applied	\N	\N	\N	\N	43563	43563	43564
12013	12837	89	applied	\N	\N	\N	\N	43570	43570	43571
12013	12838	90	applied	\N	\N	\N	\N	43572	43572	43573
12013	12839	91	applied	\N	\N	\N	\N	43577	43577	43578
12013	12840	92	applied	\N	\N	\N	\N	43581	43581	43582
12013	12841	93	applied	\N	\N	\N	\N	43583	43583	43584
12013	12842	94	applied	\N	\N	\N	\N	43587	43587	43588
12013	12843	95	applied	\N	\N	\N	\N	43591	43591	43592
12013	12844	96	applied	\N	\N	\N	\N	43594	43594	43595
12013	12845	97	applied	\N	\N	\N	\N	43598	43598	43599
12013	12846	98	applied	\N	\N	\N	\N	43602	43602	43603
12013	12847	99	applied	\N	\N	\N	\N	43606	43606	43607
12013	12848	100	applied	\N	\N	\N	\N	43615	43615	43616
12013	12849	101	applied	\N	\N	\N	\N	43617	43617	43618
12013	12850	102	applied	\N	\N	\N	\N	43623	43623	43624
12013	12851	103	applied	\N	\N	\N	\N	43627	43627	43628
12013	12852	104	applied	\N	\N	\N	\N	43630	43630	43631
12013	12853	105	applied	\N	\N	\N	\N	43638	43638	43639
12013	12855	106	applied	\N	\N	\N	\N	43643	43643	43644
12013	12856	107	applied	\N	\N	\N	\N	43649	43649	43650
12013	12857	108	applied	\N	\N	\N	\N	43651	43651	43652
12013	12858	109	applied	\N	\N	\N	\N	43654	43654	43655
12013	12859	110	applied	\N	\N	\N	\N	43656	43656	43657
12013	12860	111	applied	\N	\N	\N	\N	43658	43658	43659
12013	12861	112	applied	\N	\N	\N	\N	43661	43661	43662
12013	12862	113	applied	\N	\N	\N	\N	43665	43665	43666
12013	12863	114	applied	\N	\N	\N	\N	43669	43669	43670
12013	12864	115	applied	\N	\N	\N	\N	43671	43671	43672
12013	12867	116	applied	\N	\N	\N	\N	43677	43677	43678
12013	12868	117	applied	\N	\N	\N	\N	43679	43679	43680
12013	12869	118	applied	\N	\N	\N	\N	43681	43681	43682
12013	12870	119	applied	\N	\N	\N	\N	43685	43685	43686
12015	12807	0	applied	\N	\N	\N	\N	43456	43456	43457
12015	12819	1	applied	\N	\N	\N	\N	43491	43491	43492
12015	12820	2	applied	\N	\N	\N	\N	43493	43493	43494
12015	12821	3	applied	\N	\N	\N	\N	43495	43495	43496
12015	12854	4	applied	\N	\N	1000000000	\N	43641	43641	43642
12015	12789	5	applied	\N	\N	\N	\N	43390	43390	43391
12015	12790	6	applied	\N	\N	\N	\N	43394	43394	43395
12015	12791	7	applied	\N	\N	\N	\N	43396	43396	43397
12015	12792	8	applied	\N	\N	\N	\N	43400	43400	43401
12015	12865	9	applied	\N	\N	\N	\N	43673	43673	43674
12015	12793	10	applied	\N	\N	\N	\N	43402	43402	43403
12015	12794	11	applied	\N	\N	\N	\N	43406	43406	43407
12015	12795	12	applied	\N	\N	\N	\N	43410	43410	43411
12015	12818	13	applied	\N	\N	\N	\N	43497	43497	43488
12015	12866	14	applied	\N	\N	\N	\N	43675	43675	43676
12015	12796	15	applied	\N	\N	\N	\N	43414	43414	43415
12015	12797	16	applied	\N	\N	\N	\N	43420	43420	43421
12015	12798	17	applied	\N	\N	\N	\N	43422	43422	43423
12015	12799	18	applied	\N	\N	\N	\N	43424	43424	43425
12015	12800	19	applied	\N	\N	\N	\N	43429	43429	43430
12015	12801	20	applied	\N	\N	\N	\N	43433	43433	43434
12015	12802	21	applied	\N	\N	\N	\N	43442	43442	43443
12015	12803	22	applied	\N	\N	\N	\N	43444	43444	43445
12015	12804	23	applied	\N	\N	\N	\N	43446	43446	43447
12015	12805	24	applied	\N	\N	\N	\N	43451	43451	43452
12015	12806	25	applied	\N	\N	\N	\N	43453	43453	43454
12015	12808	26	applied	\N	\N	\N	\N	43458	43458	43459
12015	12809	27	applied	\N	\N	\N	\N	43460	43460	43461
12015	12813	28	applied	\N	\N	\N	\N	43468	43468	43469
12015	12814	29	applied	\N	\N	\N	\N	43470	43470	43471
12015	12815	30	applied	\N	\N	\N	\N	43475	43475	43476
12015	12816	31	applied	\N	\N	\N	\N	43481	43481	43482
12015	12817	32	applied	\N	\N	\N	\N	43485	43485	43486
12015	12822	34	applied	\N	\N	\N	\N	43500	43500	43501
12015	12823	35	applied	\N	\N	\N	\N	43502	43502	43503
12015	12824	36	applied	\N	\N	\N	\N	43512	43512	43513
12015	12825	37	applied	\N	\N	\N	\N	43516	43516	43517
12015	12826	38	applied	\N	\N	\N	\N	43521	43521	43522
12015	12827	39	applied	\N	\N	\N	\N	43523	43523	43524
12015	12828	40	applied	\N	\N	\N	\N	43528	43528	43529
12015	12829	41	applied	\N	\N	\N	\N	43533	43533	43534
12015	12830	42	applied	\N	\N	\N	\N	43535	43535	43536
12015	12831	43	applied	\N	\N	\N	\N	43539	43539	43540
12015	12832	44	applied	\N	\N	\N	\N	43541	43541	43542
12015	12833	45	applied	\N	\N	\N	\N	43549	43549	43550
12015	12834	46	applied	\N	\N	\N	\N	43557	43557	43558
12015	12835	47	applied	\N	\N	\N	\N	43561	43561	43562
12015	12836	48	applied	\N	\N	\N	\N	43563	43563	43564
12015	12837	49	applied	\N	\N	\N	\N	43570	43570	43571
12015	12838	50	applied	\N	\N	\N	\N	43572	43572	43573
12015	12839	51	applied	\N	\N	\N	\N	43577	43577	43578
12015	12840	52	applied	\N	\N	\N	\N	43581	43581	43582
12015	12841	53	applied	\N	\N	\N	\N	43583	43583	43584
12015	12842	54	applied	\N	\N	\N	\N	43587	43587	43588
12015	12843	55	applied	\N	\N	\N	\N	43591	43591	43592
12015	12844	56	applied	\N	\N	\N	\N	43594	43594	43595
12015	12845	57	applied	\N	\N	\N	\N	43598	43598	43599
12015	12846	58	applied	\N	\N	\N	\N	43602	43602	43603
12015	12847	59	applied	\N	\N	\N	\N	43606	43606	43607
12015	12848	60	applied	\N	\N	\N	\N	43615	43615	43616
12015	12849	61	applied	\N	\N	\N	\N	43617	43617	43618
12015	12850	62	applied	\N	\N	\N	\N	43623	43623	43624
12015	12851	63	applied	\N	\N	\N	\N	43627	43627	43628
12015	12852	64	applied	\N	\N	\N	\N	43630	43630	43631
12015	12853	65	applied	\N	\N	\N	\N	43638	43638	43639
12015	12855	66	applied	\N	\N	\N	\N	43643	43643	43644
12015	12856	67	applied	\N	\N	\N	\N	43649	43649	43650
12015	12857	68	applied	\N	\N	\N	\N	43651	43651	43652
12015	12858	69	applied	\N	\N	\N	\N	43654	43654	43655
12015	12859	70	applied	\N	\N	\N	\N	43656	43656	43657
12015	12860	71	applied	\N	\N	\N	\N	43658	43658	43659
12015	12861	72	applied	\N	\N	\N	\N	43661	43661	43662
12015	12862	73	applied	\N	\N	\N	\N	43665	43665	43666
12015	12863	74	applied	\N	\N	\N	\N	43669	43669	43670
12015	12864	75	applied	\N	\N	\N	\N	43671	43671	43672
12015	12867	76	applied	\N	\N	\N	\N	43677	43677	43678
12015	12868	77	applied	\N	\N	\N	\N	43679	43679	43680
12015	12869	78	applied	\N	\N	\N	\N	43681	43681	43682
12015	12870	79	applied	\N	\N	\N	\N	43685	43685	43686
12018	12874	0	applied	\N	\N	\N	\N	43705	43705	43706
12023	12875	0	applied	\N	\N	\N	\N	43717	43717	43718
12023	12876	1	applied	\N	\N	\N	\N	43719	43719	43720
12024	12877	0	applied	\N	\N	\N	\N	43723	43723	43724
12026	12879	0	applied	\N	\N	\N	\N	43731	43731	43732
12026	12880	1	applied	\N	\N	\N	\N	43733	43733	43734
12028	12881	0	applied	\N	\N	\N	\N	43739	43739	43740
12032	12882	0	applied	\N	\N	\N	\N	43745	43745	43746
12035	12886	0	applied	\N	\N	\N	\N	43758	43758	43759
12038	12889	0	applied	\N	\N	\N	\N	43768	43768	43769
12040	12890	0	applied	\N	\N	\N	\N	43775	43775	43776
12042	12891	0	applied	\N	\N	\N	\N	43778	43778	43779
12047	12893	0	applied	\N	\N	\N	\N	43789	43789	43790
12050	12894	0	applied	\N	\N	\N	\N	43795	43795	43796
12056	12900	0	applied	\N	\N	\N	\N	43816	43816	43817
12067	12884	0	applied	\N	\N	\N	\N	43753	43753	43754
12067	12854	1	applied	\N	\N	1000000000	\N	43641	43641	43642
12067	12898	2	applied	\N	\N	1000000000	\N	43811	43811	43812
12067	12825	3	applied	\N	\N	\N	\N	43516	43516	43517
12067	12865	4	applied	\N	\N	\N	\N	43673	43673	43674
12067	12899	5	applied	\N	\N	\N	\N	43813	43813	43813
12067	12866	6	applied	\N	\N	\N	\N	43675	43675	43676
12067	12826	7	applied	\N	\N	\N	\N	43521	43521	43522
12067	12827	8	applied	\N	\N	\N	\N	43523	43523	43524
12067	12828	9	applied	\N	\N	\N	\N	43528	43528	43529
12067	12904	10	applied	\N	\N	\N	\N	43837	43837	43837
12067	12908	11	applied	\N	\N	\N	\N	43843	43843	43843
12067	12829	12	applied	\N	\N	\N	\N	43533	43533	43534
12067	12830	13	applied	\N	\N	\N	\N	43535	43535	43536
12067	12831	14	applied	\N	\N	\N	\N	43539	43539	43540
12067	12832	15	applied	\N	\N	\N	\N	43541	43541	43542
12067	12833	16	applied	\N	\N	\N	\N	43549	43549	43550
12067	12834	17	applied	\N	\N	\N	\N	43557	43557	43558
12067	12835	18	applied	\N	\N	\N	\N	43561	43561	43562
12067	12836	19	applied	\N	\N	\N	\N	43563	43563	43564
12067	12837	20	applied	\N	\N	\N	\N	43570	43570	43571
12067	12838	21	applied	\N	\N	\N	\N	43572	43572	43573
12067	12839	22	applied	\N	\N	\N	\N	43577	43577	43578
12067	12840	23	applied	\N	\N	\N	\N	43581	43581	43582
12067	12841	24	applied	\N	\N	\N	\N	43583	43583	43584
12067	12842	25	applied	\N	\N	\N	\N	43587	43587	43588
12067	12843	26	applied	\N	\N	\N	\N	43591	43591	43592
12067	12844	27	applied	\N	\N	\N	\N	43594	43594	43595
12067	12845	29	applied	\N	\N	\N	\N	43598	43598	43599
12067	12846	30	applied	\N	\N	\N	\N	43602	43602	43603
12067	12847	31	applied	\N	\N	\N	\N	43606	43606	43607
12067	12848	32	applied	\N	\N	\N	\N	43615	43615	43616
12067	12849	33	applied	\N	\N	\N	\N	43617	43617	43618
12067	12850	34	applied	\N	\N	\N	\N	43623	43623	43624
12067	12851	35	applied	\N	\N	\N	\N	43627	43627	43628
12067	12852	36	applied	\N	\N	\N	\N	43630	43630	43631
12067	12853	37	applied	\N	\N	\N	\N	43638	43638	43639
12067	12855	38	applied	\N	\N	\N	\N	43643	43643	43644
12067	12856	39	applied	\N	\N	\N	\N	43649	43649	43650
12067	12857	40	applied	\N	\N	\N	\N	43651	43651	43652
12067	12858	41	applied	\N	\N	\N	\N	43654	43654	43655
12067	12859	42	applied	\N	\N	\N	\N	43656	43656	43657
12067	12860	43	applied	\N	\N	\N	\N	43658	43658	43659
12067	12861	44	applied	\N	\N	\N	\N	43661	43661	43662
12067	12862	45	applied	\N	\N	\N	\N	43665	43665	43666
12067	12863	46	applied	\N	\N	\N	\N	43669	43669	43670
12067	12864	47	applied	\N	\N	\N	\N	43671	43671	43672
12067	12867	48	applied	\N	\N	\N	\N	43677	43677	43678
12067	12868	49	applied	\N	\N	\N	\N	43679	43679	43680
12067	12869	50	applied	\N	\N	\N	\N	43681	43681	43682
12067	12870	51	applied	\N	\N	\N	\N	43685	43685	43686
12067	12871	52	applied	\N	\N	\N	\N	43695	43695	43696
12067	12872	53	applied	\N	\N	\N	\N	43697	43697	43698
12067	12873	54	applied	\N	\N	\N	\N	43701	43701	43702
12067	12874	55	applied	\N	\N	\N	\N	43705	43705	43706
12067	12875	56	applied	\N	\N	\N	\N	43717	43717	43718
12067	12876	57	applied	\N	\N	\N	\N	43719	43719	43720
12067	12877	58	applied	\N	\N	\N	\N	43723	43723	43724
12067	12878	59	applied	\N	\N	\N	\N	43727	43727	43728
12067	12879	60	applied	\N	\N	\N	\N	43731	43731	43732
12067	12880	61	applied	\N	\N	\N	\N	43733	43733	43734
12067	12881	62	applied	\N	\N	\N	\N	43739	43739	43740
12067	12882	63	applied	\N	\N	\N	\N	43745	43745	43746
12067	12883	64	applied	\N	\N	\N	\N	43749	43749	43750
12067	12885	65	applied	\N	\N	\N	\N	43755	43755	43756
12067	12886	66	applied	\N	\N	\N	\N	43758	43758	43759
12067	12887	67	applied	\N	\N	\N	\N	43762	43762	43763
12061	12770	23	applied	\N	\N	\N	\N	43321	43321	43322
12061	12771	24	applied	\N	\N	\N	\N	43323	43323	43324
12061	12772	25	applied	\N	\N	\N	\N	43327	43327	43328
12061	12773	26	applied	\N	\N	\N	\N	43331	43331	43332
12061	12774	27	applied	\N	\N	\N	\N	43333	43333	43334
12061	12775	28	applied	\N	\N	\N	\N	43337	43337	43338
12061	12776	29	applied	\N	\N	\N	\N	43341	43341	43342
12061	12777	30	applied	\N	\N	\N	\N	43343	43343	43344
12061	12778	31	applied	\N	\N	\N	\N	43347	43347	43348
12061	12779	32	applied	\N	\N	\N	\N	43351	43351	43352
12061	12780	33	applied	\N	\N	\N	\N	43355	43355	43356
12061	12781	34	applied	\N	\N	\N	\N	43359	43359	43360
12061	12782	35	applied	\N	\N	\N	\N	43361	43361	43362
12061	12783	36	applied	\N	\N	\N	\N	43366	43366	43367
12061	12784	37	applied	\N	\N	\N	\N	43372	43372	43373
12061	12785	38	applied	\N	\N	\N	\N	43378	43378	43379
12061	12786	39	applied	\N	\N	\N	\N	43380	43380	43381
12061	12787	40	applied	\N	\N	\N	\N	43384	43384	43385
12061	12788	41	applied	\N	\N	\N	\N	43386	43386	43387
12061	12789	42	applied	\N	\N	\N	\N	43390	43390	43391
12061	12790	43	applied	\N	\N	\N	\N	43394	43394	43395
12061	12791	44	applied	\N	\N	\N	\N	43396	43396	43397
12061	12792	45	applied	\N	\N	\N	\N	43400	43400	43401
12061	12793	46	applied	\N	\N	\N	\N	43402	43402	43403
12061	12794	47	applied	\N	\N	\N	\N	43406	43406	43407
12061	12795	48	applied	\N	\N	\N	\N	43410	43410	43411
12061	12796	49	applied	\N	\N	\N	\N	43414	43414	43415
12061	12797	50	applied	\N	\N	\N	\N	43420	43420	43421
12061	12798	51	applied	\N	\N	\N	\N	43422	43422	43423
12061	12799	52	applied	\N	\N	\N	\N	43424	43424	43425
12061	12800	53	applied	\N	\N	\N	\N	43429	43429	43430
12061	12801	54	applied	\N	\N	\N	\N	43433	43433	43434
12061	12802	55	applied	\N	\N	\N	\N	43442	43442	43443
12061	12803	56	applied	\N	\N	\N	\N	43444	43444	43445
12061	12804	57	applied	\N	\N	\N	\N	43446	43446	43447
12061	12805	58	applied	\N	\N	\N	\N	43451	43451	43452
12061	12806	59	applied	\N	\N	\N	\N	43453	43453	43454
12061	12808	60	applied	\N	\N	\N	\N	43458	43458	43459
12061	12809	61	applied	\N	\N	\N	\N	43460	43460	43461
12061	12813	62	applied	\N	\N	\N	\N	43468	43468	43469
12061	12814	63	applied	\N	\N	\N	\N	43470	43470	43471
12061	12815	64	applied	\N	\N	\N	\N	43475	43475	43476
12061	12816	65	applied	\N	\N	\N	\N	43481	43481	43482
12061	12817	66	applied	\N	\N	\N	\N	43485	43485	43486
12061	12822	67	applied	\N	\N	\N	\N	43500	43500	43501
12061	12823	68	applied	\N	\N	\N	\N	43502	43502	43503
12061	12824	69	applied	\N	\N	\N	\N	43512	43512	43513
12061	12825	70	applied	\N	\N	\N	\N	43516	43516	43517
12061	12826	71	applied	\N	\N	\N	\N	43521	43521	43522
12061	12827	72	applied	\N	\N	\N	\N	43523	43523	43524
12061	12828	73	applied	\N	\N	\N	\N	43528	43528	43529
12061	12829	74	applied	\N	\N	\N	\N	43533	43533	43534
12061	12830	75	applied	\N	\N	\N	\N	43535	43535	43536
12061	12831	76	applied	\N	\N	\N	\N	43539	43539	43540
12061	12832	77	applied	\N	\N	\N	\N	43541	43541	43542
12061	12833	78	applied	\N	\N	\N	\N	43549	43549	43550
12061	12834	79	applied	\N	\N	\N	\N	43557	43557	43558
12061	12835	80	applied	\N	\N	\N	\N	43561	43561	43562
12061	12836	81	applied	\N	\N	\N	\N	43563	43563	43564
12061	12837	82	applied	\N	\N	\N	\N	43570	43570	43571
12061	12838	83	applied	\N	\N	\N	\N	43572	43572	43573
12061	12839	84	applied	\N	\N	\N	\N	43577	43577	43578
12061	12840	85	applied	\N	\N	\N	\N	43581	43581	43582
12061	12841	86	applied	\N	\N	\N	\N	43583	43583	43584
12061	12842	87	applied	\N	\N	\N	\N	43587	43587	43588
12061	12843	88	applied	\N	\N	\N	\N	43591	43591	43592
12061	12844	89	applied	\N	\N	\N	\N	43594	43594	43595
12061	12845	90	applied	\N	\N	\N	\N	43598	43598	43599
12061	12846	91	applied	\N	\N	\N	\N	43602	43602	43603
12061	12847	92	applied	\N	\N	\N	\N	43606	43606	43607
12061	12848	93	applied	\N	\N	\N	\N	43615	43615	43616
12061	12849	94	applied	\N	\N	\N	\N	43617	43617	43618
12061	12850	95	applied	\N	\N	\N	\N	43623	43623	43624
12061	12851	96	applied	\N	\N	\N	\N	43627	43627	43628
12061	12852	97	applied	\N	\N	\N	\N	43630	43630	43631
12061	12853	98	applied	\N	\N	\N	\N	43638	43638	43639
12061	12855	99	applied	\N	\N	\N	\N	43643	43643	43644
12061	12856	100	applied	\N	\N	\N	\N	43649	43649	43650
12061	12857	101	applied	\N	\N	\N	\N	43651	43651	43652
12061	12858	102	applied	\N	\N	\N	\N	43654	43654	43655
12061	12859	103	applied	\N	\N	\N	\N	43656	43656	43657
12061	12860	104	applied	\N	\N	\N	\N	43658	43658	43659
12061	12861	105	applied	\N	\N	\N	\N	43661	43661	43662
12061	12862	106	applied	\N	\N	\N	\N	43665	43665	43666
12061	12863	107	applied	\N	\N	\N	\N	43669	43669	43670
12061	12864	108	applied	\N	\N	\N	\N	43671	43671	43672
12061	12867	109	applied	\N	\N	\N	\N	43677	43677	43678
12061	12868	110	applied	\N	\N	\N	\N	43679	43679	43680
12061	12869	111	applied	\N	\N	\N	\N	43681	43681	43682
12061	12870	112	applied	\N	\N	\N	\N	43685	43685	43686
12061	12871	113	applied	\N	\N	\N	\N	43695	43695	43696
12061	12872	115	applied	\N	\N	\N	\N	43697	43697	43698
12061	12873	116	applied	\N	\N	\N	\N	43701	43701	43702
12061	12874	117	applied	\N	\N	\N	\N	43705	43705	43706
12061	12875	118	applied	\N	\N	\N	\N	43717	43717	43718
12061	12876	119	applied	\N	\N	\N	\N	43719	43719	43720
12061	12877	120	applied	\N	\N	\N	\N	43723	43723	43724
12061	12878	121	applied	\N	\N	\N	\N	43727	43727	43728
12061	12879	122	applied	\N	\N	\N	\N	43731	43731	43732
12061	12880	123	applied	\N	\N	\N	\N	43733	43733	43734
12061	12881	124	applied	\N	\N	\N	\N	43739	43739	43740
12061	12882	125	applied	\N	\N	\N	\N	43745	43745	43746
12064	12905	0	applied	\N	\N	\N	\N	43838	43838	43839
12064	12906	1	applied	\N	\N	\N	\N	43840	43840	43841
12064	12907	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	43842	43842	\N
12064	12908	3	applied	\N	\N	\N	\N	43843	43843	43843
12070	12915	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	43866	43866	\N
12070	12916	1	applied	\N	\N	\N	\N	43867	43867	43868
12073	12919	0	applied	\N	\N	\N	\N	43878	43878	43879
12073	12920	2	applied	\N	\N	\N	\N	43881	43881	43882
12076	12924	0	applied	\N	\N	\N	\N	43894	43894	43895
12081	12927	0	applied	\N	\N	\N	\N	43910	43910	43911
12081	12928	1	applied	\N	\N	\N	\N	43912	43912	43913
12081	12929	2	applied	\N	\N	\N	\N	43914	43914	43915
12084	12930	0	applied	\N	\N	\N	\N	43917	43917	43918
12084	12931	1	applied	\N	\N	\N	\N	43919	43919	43920
12088	12933	0	applied	\N	\N	\N	\N	43934	43934	43935
12088	12934	1	applied	\N	\N	\N	\N	43936	43936	43937
12090	12933	0	applied	\N	\N	\N	\N	43934	43934	43935
12067	12888	68	applied	\N	\N	\N	\N	43764	43764	43765
12067	12889	69	applied	\N	\N	\N	\N	43768	43768	43769
12067	12890	70	applied	\N	\N	\N	\N	43775	43775	43776
12067	12891	71	applied	\N	\N	\N	\N	43778	43778	43779
12067	12892	72	applied	\N	\N	\N	\N	43782	43782	43783
12067	12893	73	applied	\N	\N	\N	\N	43789	43789	43790
12067	12894	74	applied	\N	\N	\N	\N	43795	43795	43796
12067	12895	75	applied	\N	\N	\N	\N	43803	43803	43804
12067	12896	76	applied	\N	\N	\N	\N	43807	43807	43808
12067	12897	77	applied	\N	\N	\N	\N	43809	43809	43810
12067	12900	78	applied	\N	\N	\N	\N	43816	43816	43817
12067	12901	79	applied	\N	\N	\N	\N	43823	43823	43824
12067	12902	80	applied	\N	\N	\N	\N	43828	43828	43829
12067	12903	81	applied	\N	\N	\N	\N	43835	43835	43836
12067	12905	82	applied	\N	\N	\N	\N	43838	43838	43839
12067	12906	83	applied	\N	\N	\N	\N	43840	43840	43841
12067	12909	84	applied	\N	\N	\N	\N	43848	43848	43849
12067	12910	85	applied	\N	\N	\N	\N	43853	43853	43854
12067	12911	86	applied	\N	\N	1000000000	\N	43855	43855	43856
12067	12912	87	applied	\N	\N	\N	\N	43857	43857	43858
12068	12910	0	applied	\N	\N	\N	\N	43853	43853	43854
12068	12911	1	applied	\N	\N	1000000000	\N	43855	43855	43856
12068	12912	2	applied	\N	\N	\N	\N	43857	43857	43858
12068	12913	3	applied	\N	\N	\N	\N	43861	43861	43862
12071	12917	0	applied	\N	\N	\N	\N	43870	43870	43871
12074	12921	0	applied	\N	\N	\N	\N	43885	43885	43886
12074	12922	1	applied	\N	\N	\N	\N	43887	43887	43888
12074	12923	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	43889	43889	\N
12079	12926	0	applied	\N	\N	\N	\N	43904	43904	43905
12082	12930	0	applied	\N	\N	\N	\N	43917	43917	43918
12082	12931	1	applied	\N	\N	\N	\N	43919	43919	43920
12085	12930	0	applied	\N	\N	\N	\N	43917	43917	43918
12085	12931	1	applied	\N	\N	\N	\N	43919	43919	43920
12089	12933	0	applied	\N	\N	\N	\N	43934	43934	43935
12089	12934	1	applied	\N	\N	\N	\N	43936	43936	43937
12091	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
12091	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
12091	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
12091	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
12091	12693	4	applied	\N	\N	\N	\N	43049	43049	43050
12091	12735	5	applied	\N	\N	\N	\N	43183	43183	43184
12091	12740	6	applied	\N	\N	\N	\N	43209	43209	43210
12091	12745	7	applied	\N	\N	\N	\N	43225	43225	43226
12091	12750	8	applied	\N	\N	\N	\N	43243	43243	43244
12091	12646	9	applied	\N	\N	\N	\N	42866	42866	42867
12091	12647	10	applied	\N	\N	\N	\N	42868	42868	42869
12091	12694	11	applied	\N	\N	\N	\N	43051	43051	43052
12091	12884	12	applied	\N	\N	\N	\N	43753	43753	43754
12091	12618	13	applied	\N	\N	\N	\N	42767	42767	42768
12091	12695	14	applied	\N	\N	\N	\N	43053	43053	43054
12091	12650	15	applied	\N	\N	\N	\N	42876	42876	42877
12091	12652	16	applied	\N	\N	\N	\N	42881	42881	42882
12091	12654	17	applied	\N	\N	\N	\N	42889	42889	42890
12091	12655	18	applied	\N	\N	\N	\N	42891	42891	42892
12091	12657	19	applied	\N	\N	\N	\N	42898	42898	42899
12091	12696	20	applied	\N	\N	\N	\N	43055	43055	43056
12091	12697	21	applied	\N	\N	\N	\N	43057	43057	43058
12091	12698	22	applied	\N	\N	\N	\N	43059	43059	43060
12091	12699	23	applied	\N	\N	\N	\N	43061	43061	43062
12091	12700	24	applied	\N	\N	\N	\N	43063	43063	43064
12091	12701	25	applied	\N	\N	\N	\N	43065	43065	43066
12091	12619	26	applied	\N	\N	\N	\N	42769	42769	42770
12091	12620	27	applied	\N	\N	\N	\N	42771	42771	42772
12091	12621	28	applied	\N	\N	\N	\N	42773	42773	42774
12091	12854	29	applied	\N	\N	1000000000	\N	43641	43641	43642
12091	12898	30	applied	\N	\N	1000000000	\N	43811	43811	43812
12094	12937	0	applied	\N	\N	\N	\N	43952	43952	43953
12094	12938	1	applied	\N	\N	\N	\N	43954	43954	43955
12094	12939	2	applied	\N	\N	\N	\N	43956	43956	43957
12097	12944	0	applied	\N	\N	\N	\N	43970	43970	43971
12100	12947	0	applied	\N	\N	\N	\N	43976	43976	43977
12100	12948	1	applied	\N	\N	\N	\N	43978	43978	43979
12105	12951	0	applied	\N	\N	\N	\N	43992	43992	43993
12110	12953	0	applied	\N	\N	\N	\N	44002	44002	44003
12112	12955	0	applied	\N	\N	\N	\N	44007	44007	44008
12112	12956	1	applied	\N	\N	\N	\N	44009	44009	44010
12112	12957	2	applied	\N	\N	1000000000	\N	44011	44011	44012
12117	12960	0	applied	\N	\N	\N	\N	44024	44024	44025
12124	12964	0	applied	\N	\N	\N	\N	44041	44041	44042
12129	12967	0	applied	\N	\N	\N	\N	44051	44051	44052
12134	12968	0	applied	\N	\N	\N	\N	44057	44057	44058
12134	12969	1	applied	\N	\N	\N	\N	44059	44059	44060
12134	12970	2	applied	\N	\N	\N	\N	44061	44061	44062
12136	12972	0	applied	\N	\N	\N	\N	44073	44073	44074
12141	12975	0	applied	\N	\N	\N	\N	44085	44085	44086
12141	12976	1	applied	\N	\N	\N	\N	44087	44087	44088
12145	12977	0	applied	\N	\N	\N	\N	44096	44096	44097
12145	12978	1	applied	\N	\N	\N	\N	44098	44098	44099
12145	12979	2	applied	\N	\N	\N	\N	44100	44100	44101
12145	12980	3	applied	\N	\N	\N	\N	44102	44102	44103
12145	12981	4	applied	\N	\N	\N	\N	44104	44104	44105
12152	12985	0	applied	\N	\N	\N	\N	44119	44119	44120
12157	12987	0	applied	\N	\N	1000000000	\N	44130	44130	44131
12160	12989	0	applied	\N	\N	\N	\N	44139	44139	44140
12160	12990	1	applied	\N	\N	\N	\N	44141	44141	44142
12160	12991	2	applied	\N	\N	\N	\N	44143	44143	44144
12160	12992	3	applied	\N	\N	\N	\N	44145	44145	44146
12160	12993	4	applied	\N	\N	\N	\N	44147	44147	44148
12168	12998	0	applied	\N	\N	\N	\N	44167	44167	44168
12172	13000	0	applied	\N	\N	\N	\N	44175	44175	44176
12172	13001	1	applied	\N	\N	\N	\N	44177	44177	44178
12173	13002	0	applied	\N	\N	\N	\N	44181	44181	44182
12173	13003	1	applied	\N	\N	\N	\N	44183	44183	44184
12173	13004	2	applied	\N	\N	\N	\N	44185	44185	44186
12176	13005	0	applied	\N	\N	\N	\N	44188	44188	44189
12176	13006	1	applied	\N	\N	\N	\N	44190	44190	44191
12176	13007	2	applied	\N	\N	\N	\N	44192	44192	44193
12178	13008	0	applied	\N	\N	\N	\N	44198	44198	44199
12179	13009	0	applied	\N	\N	\N	\N	44204	44204	44205
12179	13010	1	applied	\N	\N	\N	\N	44206	44206	44207
12179	13011	2	applied	\N	\N	\N	\N	44208	44208	44209
12179	13012	3	applied	\N	\N	\N	\N	44210	44210	44211
12186	13016	0	applied	\N	\N	\N	\N	44235	44235	44236
12186	13017	1	applied	\N	\N	\N	\N	44239	44239	44240
12189	13019	0	applied	\N	\N	\N	\N	44246	44246	44247
12189	13020	1	applied	\N	\N	\N	\N	44248	44248	44249
12189	13021	2	applied	\N	\N	\N	\N	44250	44250	44251
12193	13022	0	applied	\N	\N	\N	\N	44258	44258	44259
12090	12934	1	applied	\N	\N	\N	\N	43936	43936	43937
12093	12898	0	applied	\N	\N	1000000000	\N	43811	43811	43812
12093	12891	1	applied	\N	\N	\N	\N	43778	43778	43779
12093	12934	2	applied	\N	\N	\N	\N	43936	43936	43937
12093	12899	3	applied	\N	\N	\N	\N	43813	43813	43813
12093	12892	4	applied	\N	\N	\N	\N	43782	43782	43783
12093	12893	5	applied	\N	\N	\N	\N	43789	43789	43790
12093	12894	6	applied	\N	\N	\N	\N	43795	43795	43796
12093	12895	7	applied	\N	\N	\N	\N	43803	43803	43804
12093	12896	8	applied	\N	\N	\N	\N	43807	43807	43808
12093	12897	9	applied	\N	\N	\N	\N	43809	43809	43810
12093	12900	10	applied	\N	\N	\N	\N	43816	43816	43817
12093	12901	11	applied	\N	\N	\N	\N	43823	43823	43824
12093	12902	12	applied	\N	\N	\N	\N	43828	43828	43829
12093	12903	13	applied	\N	\N	\N	\N	43835	43835	43836
12093	12905	14	applied	\N	\N	\N	\N	43838	43838	43839
12093	12906	15	applied	\N	\N	\N	\N	43840	43840	43841
12093	12909	16	applied	\N	\N	\N	\N	43848	43848	43849
12093	12910	17	applied	\N	\N	\N	\N	43853	43853	43854
12093	12911	18	applied	\N	\N	1000000000	\N	43855	43855	43856
12093	12912	19	applied	\N	\N	\N	\N	43857	43857	43858
12093	12913	20	applied	\N	\N	\N	\N	43861	43861	43862
12093	12914	21	applied	\N	\N	\N	\N	43864	43864	43865
12093	12916	22	applied	\N	\N	\N	\N	43867	43867	43868
12093	12917	23	applied	\N	\N	\N	\N	43870	43870	43871
12093	12918	24	applied	\N	\N	\N	\N	43874	43874	43875
12093	12919	25	applied	\N	\N	\N	\N	43878	43878	43879
12093	12920	26	applied	\N	\N	\N	\N	43881	43881	43882
12093	12921	27	applied	\N	\N	\N	\N	43885	43885	43886
12093	12922	28	applied	\N	\N	\N	\N	43887	43887	43888
12093	12924	29	applied	\N	\N	\N	\N	43894	43894	43895
12093	12925	30	applied	\N	\N	\N	\N	43898	43898	43899
12093	12926	31	applied	\N	\N	\N	\N	43904	43904	43905
12093	12927	32	applied	\N	\N	\N	\N	43910	43910	43911
12093	12928	33	applied	\N	\N	\N	\N	43912	43912	43913
12093	12929	34	applied	\N	\N	\N	\N	43914	43914	43915
12093	12930	35	applied	\N	\N	\N	\N	43917	43917	43918
12093	12931	36	applied	\N	\N	\N	\N	43919	43919	43920
12093	12932	37	applied	\N	\N	\N	\N	43930	43930	43931
12093	12933	38	applied	\N	\N	\N	\N	43934	43934	43935
12093	12935	39	applied	\N	\N	\N	\N	43946	43946	43947
12093	12936	40	applied	\N	\N	\N	\N	43948	43948	43949
12093	12904	41	applied	\N	\N	\N	\N	43837	43837	43837
12093	12908	42	applied	\N	\N	\N	\N	43843	43843	43843
12102	12949	0	applied	\N	\N	\N	\N	43984	43984	43985
12102	12950	1	applied	\N	\N	\N	\N	43986	43986	43987
12104	12951	0	applied	\N	\N	\N	\N	43992	43992	43993
12109	12953	0	applied	\N	\N	\N	\N	44002	44002	44003
12111	12954	0	applied	\N	\N	\N	\N	44005	44005	44006
12119	12961	0	applied	\N	\N	\N	\N	44029	44029	44030
12119	12962	1	applied	\N	\N	\N	\N	44031	44031	44032
12121	12961	0	applied	\N	\N	\N	\N	44029	44029	44030
12121	12962	1	applied	\N	\N	\N	\N	44031	44031	44032
12123	12963	0	applied	\N	\N	\N	\N	44036	44036	44037
12126	12964	0	applied	\N	\N	\N	\N	44041	44041	44042
12128	12967	0	applied	\N	\N	\N	\N	44051	44051	44052
12132	12968	0	applied	\N	\N	\N	\N	44057	44057	44058
12132	12969	1	applied	\N	\N	\N	\N	44059	44059	44060
12132	12970	2	applied	\N	\N	\N	\N	44061	44061	44062
12135	12971	0	applied	\N	\N	\N	\N	44071	44071	44072
12138	12974	0	applied	\N	\N	\N	\N	44079	44079	44080
12143	12975	0	applied	\N	\N	\N	\N	44085	44085	44086
12143	12976	1	applied	\N	\N	\N	\N	44087	44087	44088
12147	12983	0	applied	\N	\N	\N	\N	44111	44111	44112
12150	12984	0	applied	\N	\N	\N	\N	44115	44115	44116
12155	12986	0	applied	\N	\N	\N	\N	44125	44125	44126
12156	12987	0	applied	\N	\N	1000000000	\N	44130	44130	44131
12156	12988	1	applied	\N	\N	\N	\N	44132	44132	44133
12162	12989	0	applied	\N	\N	\N	\N	44139	44139	44140
12162	12990	1	applied	\N	\N	\N	\N	44141	44141	44142
12162	12991	2	applied	\N	\N	\N	\N	44143	44143	44144
12162	12992	3	applied	\N	\N	\N	\N	44145	44145	44146
12162	12993	4	applied	\N	\N	\N	\N	44147	44147	44148
12175	13005	0	applied	\N	\N	\N	\N	44188	44188	44189
12175	13006	1	applied	\N	\N	\N	\N	44190	44190	44191
12175	13007	2	applied	\N	\N	\N	\N	44192	44192	44193
12183	13015	0	applied	\N	\N	\N	\N	44222	44222	44223
12185	13013	0	applied	\N	\N	\N	\N	44228	44228	44229
12185	12913	1	applied	\N	\N	\N	\N	43861	43861	43862
12185	12949	2	applied	\N	\N	\N	\N	44218	44218	43985
12185	12934	3	applied	\N	\N	\N	\N	43936	43936	43937
12185	12914	4	applied	\N	\N	\N	\N	43864	43864	43865
12185	12916	5	applied	\N	\N	\N	\N	43867	43867	43868
12185	12917	6	applied	\N	\N	\N	\N	43870	43870	43871
12185	12918	7	applied	\N	\N	\N	\N	43874	43874	43875
12185	12919	8	applied	\N	\N	\N	\N	43878	43878	43879
12185	12920	9	applied	\N	\N	\N	\N	43881	43881	43882
12185	12921	10	applied	\N	\N	\N	\N	43885	43885	43886
12185	12922	11	applied	\N	\N	\N	\N	43887	43887	43888
12185	12924	12	applied	\N	\N	\N	\N	43894	43894	43895
12185	12978	13	applied	\N	\N	\N	\N	44230	44230	44099
12185	12979	14	applied	\N	\N	\N	\N	44231	44231	44101
12185	12925	15	applied	\N	\N	\N	\N	43898	43898	43899
12185	12926	16	applied	\N	\N	\N	\N	43904	43904	43905
12185	12927	17	applied	\N	\N	\N	\N	43910	43910	43911
12185	12928	18	applied	\N	\N	\N	\N	43912	43912	43913
12185	12929	19	applied	\N	\N	\N	\N	43914	43914	43915
12185	12930	20	applied	\N	\N	\N	\N	43917	43917	43918
12185	12931	21	applied	\N	\N	\N	\N	43919	43919	43920
12185	12932	22	applied	\N	\N	\N	\N	43930	43930	43931
12185	12933	23	applied	\N	\N	\N	\N	43934	43934	43935
12185	12935	24	applied	\N	\N	\N	\N	43946	43946	43947
12185	12936	25	applied	\N	\N	\N	\N	43948	43948	43949
12185	12937	26	applied	\N	\N	\N	\N	43952	43952	43953
12185	12938	27	applied	\N	\N	\N	\N	43954	43954	43955
12185	12939	28	applied	\N	\N	\N	\N	43956	43956	43957
12185	12940	29	applied	\N	\N	\N	\N	43959	43959	43960
12185	12941	30	applied	\N	\N	\N	\N	43961	43961	43962
12185	12942	31	applied	\N	\N	\N	\N	43963	43963	43964
12185	12943	32	applied	\N	\N	\N	\N	43966	43966	43967
12185	12944	33	applied	\N	\N	\N	\N	43970	43970	43971
12185	12945	34	applied	\N	\N	\N	\N	43972	43972	43973
12185	12946	35	applied	\N	\N	\N	\N	43974	43974	43975
12185	12980	36	applied	\N	\N	\N	\N	44232	44232	44103
12185	12981	37	applied	\N	\N	\N	\N	44233	44233	44105
12185	12947	38	applied	\N	\N	\N	\N	43976	43976	43977
12185	12948	39	applied	\N	\N	\N	\N	43978	43978	43979
12185	12950	40	applied	\N	\N	\N	\N	43986	43986	43987
12185	12951	41	applied	\N	\N	\N	\N	43992	43992	43993
12174	13003	1	applied	\N	\N	\N	\N	44183	44183	44184
12174	13004	2	applied	\N	\N	\N	\N	44185	44185	44186
12180	13009	0	applied	\N	\N	\N	\N	44204	44204	44205
12180	13010	1	applied	\N	\N	\N	\N	44206	44206	44207
12180	13011	2	applied	\N	\N	\N	\N	44208	44208	44209
12180	13012	3	applied	\N	\N	\N	\N	44210	44210	44211
12184	13015	0	applied	\N	\N	\N	\N	44222	44222	44223
12190	13019	0	applied	\N	\N	\N	\N	44246	44246	44247
12190	13020	1	applied	\N	\N	\N	\N	44248	44248	44249
12190	13021	2	applied	\N	\N	\N	\N	44250	44250	44251
12194	13022	0	applied	\N	\N	\N	\N	44258	44258	44259
12205	13041	0	applied	\N	\N	\N	\N	44313	44313	44314
12210	13043	0	applied	\N	\N	\N	\N	44322	44322	44323
12210	13044	1	applied	\N	\N	\N	\N	44324	44324	44325
12210	13045	2	applied	\N	\N	1000000000	\N	44326	44326	44327
12215	13048	0	applied	\N	\N	\N	\N	44339	44339	44340
12215	13049	1	applied	\N	\N	\N	\N	44341	44341	44342
12227	13057	0	applied	\N	\N	\N	\N	44377	44377	44378
12230	13058	0	applied	\N	\N	\N	\N	44381	44381	44382
12230	13059	1	applied	\N	\N	\N	\N	44385	44385	44386
12235	13065	0	applied	\N	\N	\N	\N	44401	44401	44402
12238	13066	0	applied	\N	\N	\N	\N	44409	44409	44410
12248	13078	0	applied	\N	\N	\N	\N	44449	44449	44450
12248	13079	1	applied	\N	\N	\N	\N	44451	44451	44452
12248	13080	2	applied	\N	\N	\N	\N	44453	44453	44454
12248	13081	3	applied	\N	\N	\N	\N	44455	44455	44456
12250	13069	0	applied	\N	\N	\N	\N	44425	44425	44426
12250	13072	1	applied	\N	\N	\N	\N	44433	44433	44434
12250	13073	2	applied	\N	\N	\N	\N	44435	44435	44436
12250	13074	3	applied	\N	\N	\N	\N	44437	44437	44438
12250	13076	4	applied	\N	\N	\N	\N	44442	44442	44443
12250	13078	5	applied	\N	\N	\N	\N	44449	44449	44450
12250	13079	6	applied	\N	\N	\N	\N	44451	44451	44452
12250	13065	7	applied	\N	\N	\N	\N	44401	44401	44402
12250	13066	8	applied	\N	\N	\N	\N	44409	44409	44410
12250	13067	9	applied	\N	\N	\N	\N	44415	44415	44416
12250	13068	10	applied	\N	\N	\N	\N	44421	44421	44422
12250	13070	11	applied	\N	\N	\N	\N	44427	44427	44428
12250	13071	12	applied	\N	\N	\N	\N	44429	44429	44430
12250	13075	13	applied	\N	\N	\N	\N	44439	44439	44440
12250	13077	14	applied	\N	\N	\N	\N	44444	44444	44445
12250	13080	15	applied	\N	\N	\N	\N	44453	44453	44454
12250	13081	16	applied	\N	\N	\N	\N	44455	44455	44456
12253	13082	0	applied	\N	\N	\N	\N	44462	44462	44463
12257	13084	0	applied	\N	\N	\N	\N	44473	44473	44474
12262	13089	0	applied	\N	\N	\N	\N	44500	44500	44501
12282	13102	0	applied	\N	\N	\N	\N	44558	44558	44559
12282	13103	1	applied	\N	\N	\N	\N	44560	44560	44561
12285	13107	0	applied	\N	\N	\N	\N	44571	44571	44572
12285	13108	1	applied	\N	\N	\N	\N	44573	44573	44574
12285	13109	2	applied	\N	\N	\N	\N	44575	44575	44576
12285	13110	3	applied	\N	\N	\N	\N	44577	44577	44578
12288	13112	0	applied	\N	\N	\N	\N	44584	44584	44585
12292	13115	0	applied	\N	\N	\N	\N	44610	44610	44611
12292	13116	1	applied	\N	\N	\N	\N	44612	44612	44613
12292	13117	2	applied	\N	\N	\N	\N	44614	44614	44615
12295	13120	0	applied	\N	\N	\N	\N	44624	44624	44625
12295	13121	1	applied	\N	\N	\N	\N	44626	44626	44627
12295	13122	2	applied	\N	\N	\N	\N	44628	44628	44629
12295	13123	3	applied	\N	\N	\N	\N	44630	44630	44631
12295	13124	4	applied	\N	\N	\N	\N	44632	44632	44633
12295	13125	5	applied	\N	\N	\N	\N	44634	44634	44635
12295	13126	6	applied	\N	\N	\N	\N	44636	44636	44637
12295	13127	7	applied	\N	\N	\N	\N	18200	18200	44638
12295	13128	8	applied	\N	\N	\N	\N	44639	44639	44640
12295	13129	9	applied	\N	\N	\N	\N	44641	44641	44642
12297	13130	0	applied	\N	\N	\N	\N	44647	44647	44648
12300	13133	0	applied	\N	\N	\N	\N	44654	44654	44655
12302	13134	0	applied	\N	\N	\N	\N	44660	44660	44661
12302	13135	1	applied	\N	\N	\N	\N	44662	44662	44663
12304	13136	0	applied	\N	\N	\N	\N	44668	44668	44669
12304	13137	1	applied	\N	\N	\N	\N	44670	44670	44671
12307	13142	0	applied	\N	\N	\N	\N	44683	44683	44684
12312	13148	0	applied	\N	\N	\N	\N	44703	44703	44704
12312	13149	1	applied	\N	\N	\N	\N	44705	44705	44706
12318	13153	0	applied	\N	\N	\N	\N	44721	44721	44722
12320	13156	0	applied	\N	\N	\N	\N	44735	44735	44736
12323	13159	0	applied	\N	\N	\N	\N	44748	44748	44749
12323	13160	1	applied	\N	\N	\N	\N	44750	44750	44751
12331	13167	0	applied	\N	\N	\N	\N	44772	44772	44773
12338	13170	0	applied	\N	\N	\N	\N	44785	44785	44786
12347	13180	0	applied	\N	\N	\N	\N	44818	44818	44819
12347	13181	1	applied	\N	\N	\N	\N	44820	44820	44821
12347	13182	2	applied	\N	\N	\N	\N	44822	44822	44823
12347	13183	3	applied	\N	\N	\N	\N	44824	44824	44825
12350	13185	0	applied	\N	\N	\N	\N	44831	44831	44832
12350	13186	1	applied	\N	\N	\N	\N	44833	44833	44834
12352	13187	0	applied	\N	\N	\N	\N	44839	44839	44840
12357	13192	0	applied	\N	\N	\N	\N	44851	44851	44852
12364	13195	0	applied	\N	\N	\N	\N	44868	44868	44869
12364	13196	1	applied	\N	\N	\N	\N	44870	44870	44871
12368	13203	0	applied	\N	\N	\N	\N	44889	44889	44890
12375	13207	0	applied	\N	\N	\N	\N	44921	44921	44922
12381	13210	0	applied	\N	\N	\N	\N	44936	44936	44937
12384	13213	0	applied	\N	\N	\N	\N	44945	44945	44946
12386	13214	0	applied	\N	\N	\N	\N	44949	44949	44950
12391	13216	0	applied	\N	\N	\N	\N	44955	44955	44956
12391	13217	2	applied	\N	\N	\N	\N	44958	44958	44959
12393	13218	0	applied	\N	\N	\N	\N	44961	44961	44962
12399	13224	0	applied	\N	\N	\N	\N	44981	44981	44982
12399	13225	1	applied	\N	\N	\N	\N	44983	44983	44984
12403	13226	0	applied	\N	\N	\N	\N	44992	44992	44993
12403	13227	1	applied	\N	\N	\N	\N	44994	44994	44995
12406	13229	0	applied	\N	\N	\N	\N	45006	45006	45007
12406	13230	1	applied	\N	\N	\N	\N	45008	45008	45009
12409	13231	0	applied	\N	\N	\N	\N	45012	45012	45013
12419	13234	0	applied	\N	\N	\N	\N	45035	45035	45036
12419	13235	1	applied	\N	\N	\N	\N	45037	45037	45038
12419	13236	2	applied	\N	\N	\N	\N	45039	45039	45040
12459	13174	0	applied	\N	\N	\N	\N	44900	44900	44802
12459	13180	1	applied	\N	\N	\N	\N	44901	44901	44819
12459	13181	2	applied	\N	\N	\N	\N	44902	44902	44821
12459	13182	3	applied	\N	\N	\N	\N	44903	44903	44823
12459	13115	4	applied	\N	\N	\N	\N	44904	44904	44611
12459	13118	5	applied	\N	\N	\N	\N	44905	44905	44619
12459	13131	6	applied	\N	\N	\N	\N	44906	44906	44650
12459	13134	7	applied	\N	\N	\N	\N	44907	44907	44661
12459	13136	8	applied	\N	\N	\N	\N	44908	44908	44669
12459	13138	9	applied	\N	\N	\N	\N	44909	44909	44673
12472	13239	0	applied	\N	\N	\N	\N	45080	45080	45081
12185	12952	42	applied	\N	\N	\N	\N	43996	43996	43997
12185	12953	43	applied	\N	\N	\N	\N	44002	44002	44003
12185	12954	44	applied	\N	\N	\N	\N	44005	44005	44006
12185	12955	45	applied	\N	\N	\N	\N	44007	44007	44008
12185	12956	46	applied	\N	\N	\N	\N	44009	44009	44010
12185	12957	47	applied	\N	\N	1000000000	\N	44011	44011	44012
12185	12958	48	applied	\N	\N	\N	\N	44013	44013	44014
12185	12959	49	applied	\N	\N	\N	\N	44018	44018	44019
12185	12960	50	applied	\N	\N	\N	\N	44024	44024	44025
12185	12961	51	applied	\N	\N	\N	\N	44029	44029	44030
12185	12962	52	applied	\N	\N	\N	\N	44031	44031	44032
12185	12963	53	applied	\N	\N	\N	\N	44036	44036	44037
12185	12964	54	applied	\N	\N	\N	\N	44041	44041	44042
12185	12965	55	applied	\N	\N	\N	\N	44045	44045	44046
12185	12966	56	applied	\N	\N	\N	\N	44047	44047	44048
12185	12967	57	applied	\N	\N	\N	\N	44051	44051	44052
12185	12968	58	applied	\N	\N	\N	\N	44057	44057	44058
12185	12969	59	applied	\N	\N	\N	\N	44059	44059	44060
12185	12970	60	applied	\N	\N	\N	\N	44061	44061	44062
12185	12971	61	applied	\N	\N	\N	\N	44071	44071	44072
12185	12972	62	applied	\N	\N	\N	\N	44073	44073	44074
12185	12973	63	applied	\N	\N	\N	\N	44077	44077	44078
12185	12974	64	applied	\N	\N	\N	\N	44079	44079	44080
12185	12975	65	applied	\N	\N	\N	\N	44085	44085	44086
12185	12976	67	applied	\N	\N	\N	\N	44087	44087	44088
12185	12977	68	applied	\N	\N	\N	\N	44096	44096	44097
12185	12982	69	applied	\N	\N	\N	\N	44108	44108	44109
12185	12983	70	applied	\N	\N	\N	\N	44111	44111	44112
12185	12984	71	applied	\N	\N	\N	\N	44115	44115	44116
12185	12985	72	applied	\N	\N	\N	\N	44119	44119	44120
12185	12986	73	applied	\N	\N	\N	\N	44125	44125	44126
12185	12987	74	applied	\N	\N	1000000000	\N	44130	44130	44131
12185	12988	75	applied	\N	\N	\N	\N	44132	44132	44133
12185	12989	76	applied	\N	\N	\N	\N	44139	44139	44140
12185	12990	77	applied	\N	\N	\N	\N	44141	44141	44142
12185	12991	78	applied	\N	\N	\N	\N	44143	44143	44144
12185	12992	79	applied	\N	\N	\N	\N	44145	44145	44146
12185	12993	80	applied	\N	\N	\N	\N	44147	44147	44148
12185	12994	81	applied	\N	\N	\N	\N	44156	44156	44157
12185	12995	82	applied	\N	\N	\N	\N	44158	44158	44159
12185	12996	83	applied	\N	\N	\N	\N	44160	44160	44161
12185	12997	84	applied	\N	\N	\N	\N	44162	44162	44163
12185	12998	85	applied	\N	\N	\N	\N	44167	44167	44168
12185	12999	86	applied	\N	\N	\N	\N	44172	44172	44173
12185	13000	87	applied	\N	\N	\N	\N	44175	44175	44176
12185	13001	88	applied	\N	\N	\N	\N	44177	44177	44178
12185	13002	89	applied	\N	\N	\N	\N	44181	44181	44182
12185	13003	90	applied	\N	\N	\N	\N	44183	44183	44184
12185	13004	91	applied	\N	\N	\N	\N	44185	44185	44186
12185	13005	92	applied	\N	\N	\N	\N	44188	44188	44189
12185	13006	93	applied	\N	\N	\N	\N	44190	44190	44191
12185	13007	94	applied	\N	\N	\N	\N	44192	44192	44193
12185	13008	95	applied	\N	\N	\N	\N	44198	44198	44199
12185	13009	96	applied	\N	\N	\N	\N	44204	44204	44205
12185	13010	97	applied	\N	\N	\N	\N	44206	44206	44207
12185	13011	98	applied	\N	\N	\N	\N	44208	44208	44209
12185	13012	99	applied	\N	\N	\N	\N	44210	44210	44211
12185	13014	100	applied	\N	\N	\N	\N	44219	44219	44220
12185	13015	101	applied	\N	\N	\N	\N	44222	44222	44223
12185	13016	102	applied	\N	\N	\N	\N	44235	44235	44236
12188	13018	0	applied	\N	\N	\N	\N	44242	44242	44243
12191	13019	0	applied	\N	\N	\N	\N	44246	44246	44247
12191	13020	1	applied	\N	\N	\N	\N	44248	44248	44249
12191	13021	2	applied	\N	\N	\N	\N	44250	44250	44251
12195	13023	0	applied	\N	\N	\N	\N	44261	44261	44262
12198	13027	0	applied	\N	\N	\N	\N	44274	44274	44275
12198	13028	1	applied	\N	\N	\N	\N	44276	44276	44277
12201	13033	0	applied	\N	\N	\N	\N	44289	44289	44290
12204	13040	0	applied	\N	\N	\N	\N	44309	44309	44310
12209	13027	0	applied	\N	\N	\N	\N	44274	44274	44275
12209	13029	1	applied	\N	\N	\N	\N	44280	44280	44281
12209	13034	2	applied	\N	\N	\N	\N	44293	44293	44294
12209	13035	3	applied	\N	\N	\N	\N	44295	44295	44296
12209	13038	4	applied	\N	\N	\N	\N	44302	44302	44303
12209	13013	5	applied	\N	\N	\N	\N	44217	44217	44218
12211	13046	0	applied	\N	\N	\N	\N	44330	44330	44331
12217	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
12217	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
12217	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
12217	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
12217	13029	4	applied	\N	\N	\N	\N	44280	44280	44281
12217	13034	5	applied	\N	\N	\N	\N	44293	44293	44294
12217	13035	6	applied	\N	\N	\N	\N	44295	44295	44296
12217	13038	7	applied	\N	\N	\N	\N	44302	44302	44303
12217	12693	8	applied	\N	\N	\N	\N	43049	43049	43050
12217	12735	9	applied	\N	\N	\N	\N	43183	43183	43184
12217	12740	10	applied	\N	\N	\N	\N	43209	43209	43210
12217	12745	11	applied	\N	\N	\N	\N	43225	43225	43226
12217	12750	12	applied	\N	\N	\N	\N	43243	43243	43244
12217	12694	13	applied	\N	\N	\N	\N	43051	43051	43052
12217	12884	14	applied	\N	\N	\N	\N	43753	43753	43754
12217	12695	15	applied	\N	\N	\N	\N	43053	43053	43054
12217	13013	16	applied	\N	\N	\N	\N	44228	44228	44229
12217	12696	17	applied	\N	\N	\N	\N	43055	43055	43056
12217	12697	18	applied	\N	\N	\N	\N	43057	43057	43058
12217	12698	19	applied	\N	\N	\N	\N	43059	43059	43060
12217	12699	20	applied	\N	\N	\N	\N	43061	43061	43062
12217	12700	21	applied	\N	\N	\N	\N	43063	43063	43064
12217	12701	22	applied	\N	\N	\N	\N	43065	43065	43066
12217	12854	23	applied	\N	\N	1000000000	\N	43641	43641	43642
12217	12949	24	applied	\N	\N	\N	\N	44218	44218	43985
12217	12898	25	applied	\N	\N	1000000000	\N	43811	43811	43812
12217	12702	26	applied	\N	\N	\N	\N	43067	43067	43068
12217	12865	27	applied	\N	\N	\N	\N	43673	43673	43674
12217	12899	28	applied	\N	\N	\N	\N	43813	43813	43813
12217	12818	29	applied	\N	\N	\N	\N	43508	43508	43488
12217	12703	30	applied	\N	\N	\N	\N	43069	43069	43070
12217	12704	31	applied	\N	\N	\N	\N	43072	43072	43073
12217	12866	32	applied	\N	\N	\N	\N	43675	43675	43676
12217	12934	33	applied	\N	\N	\N	\N	43936	43936	43937
12217	12978	34	applied	\N	\N	\N	\N	44230	44230	44099
12217	12979	35	applied	\N	\N	\N	\N	44231	44231	44101
12217	12980	36	applied	\N	\N	\N	\N	44232	44232	44103
12217	12981	37	applied	\N	\N	\N	\N	44233	44233	44105
12217	12705	38	applied	\N	\N	\N	\N	43074	43074	43075
12217	12706	39	applied	\N	\N	\N	\N	43076	43076	43077
12217	12707	40	applied	\N	\N	\N	\N	43082	43082	43083
12217	12708	41	applied	\N	\N	\N	\N	43084	43084	43085
12217	12709	42	applied	\N	\N	\N	\N	43088	43088	43089
12196	13024	0	applied	\N	\N	\N	\N	44264	44264	44265
12196	13025	1	applied	\N	\N	\N	\N	44266	44266	44267
12199	13029	0	applied	\N	\N	\N	\N	44280	44280	44281
12199	13030	1	applied	\N	\N	\N	\N	44282	44282	44283
12199	13031	2	applied	\N	\N	\N	\N	44284	44284	44285
12202	13034	0	applied	\N	\N	\N	\N	44293	44293	44294
12202	13035	1	applied	\N	\N	\N	\N	44295	44295	44296
12202	13036	2	applied	\N	\N	\N	\N	44297	44297	44298
12202	13037	3	applied	\N	\N	\N	\N	44299	44299	44300
12208	13042	0	applied	\N	\N	\N	\N	44317	44317	44318
12212	13046	0	applied	\N	\N	\N	\N	44330	44330	44331
12214	13047	0	applied	\N	\N	\N	\N	44335	44335	44336
12220	13050	0	applied	\N	\N	\N	\N	44350	44350	44351
12220	13051	1	applied	\N	\N	\N	\N	44352	44352	44353
12224	13053	0	applied	\N	\N	\N	\N	44364	44364	44365
12229	13058	0	applied	\N	\N	\N	\N	44381	44381	44382
12229	13059	1	applied	\N	\N	\N	\N	44385	44385	44386
12234	13065	0	applied	\N	\N	\N	\N	44401	44401	44402
12245	13072	0	applied	\N	\N	\N	\N	44433	44433	44434
12245	13073	1	applied	\N	\N	\N	\N	44435	44435	44436
12245	13074	2	applied	\N	\N	\N	\N	44437	44437	44438
12245	13075	3	applied	\N	\N	\N	\N	44439	44439	44440
12247	13076	0	applied	\N	\N	\N	\N	44442	44442	44443
12247	13077	1	applied	\N	\N	\N	\N	44444	44444	44445
12254	13083	0	applied	\N	\N	\N	\N	44468	44468	44469
12256	13083	0	applied	\N	\N	\N	\N	44468	44468	44469
12260	13086	0	applied	\N	\N	\N	\N	44481	44481	44482
12260	13087	1	applied	\N	\N	\N	\N	44483	44483	44484
12260	13088	2	applied	\N	\N	\N	\N	44485	44485	44486
12266	13090	0	applied	\N	\N	\N	\N	44519	44519	44520
12268	13091	0	applied	\N	\N	\N	\N	44525	44525	44526
12273	13099	0	applied	\N	\N	\N	\N	44547	44547	44548
12284	13105	0	applied	\N	\N	\N	\N	44565	44565	44566
12284	13106	1	applied	\N	\N	\N	\N	44567	44567	44568
12287	13112	0	applied	\N	\N	\N	\N	44584	44584	44585
12289	13113	0	applied	\N	\N	\N	\N	44588	44588	44589
12291	13114	0	applied	\N	\N	\N	\N	44606	44606	44607
12294	13120	0	applied	\N	\N	\N	\N	44624	44624	44625
12294	13121	1	applied	\N	\N	\N	\N	44626	44626	44627
12294	13122	2	applied	\N	\N	\N	\N	44628	44628	44629
12294	13123	3	applied	\N	\N	\N	\N	44630	44630	44631
12294	13124	4	applied	\N	\N	\N	\N	44632	44632	44633
12294	13125	5	applied	\N	\N	\N	\N	44634	44634	44635
12294	13126	6	applied	\N	\N	\N	\N	44636	44636	44637
12294	13127	7	applied	\N	\N	\N	\N	18200	18200	44638
12294	13128	8	applied	\N	\N	\N	\N	44639	44639	44640
12294	13129	9	applied	\N	\N	\N	\N	44641	44641	44642
12299	13133	0	applied	\N	\N	\N	\N	44654	44654	44655
12301	13134	0	applied	\N	\N	\N	\N	44660	44660	44661
12301	13135	1	applied	\N	\N	\N	\N	44662	44662	44663
12306	13138	0	applied	\N	\N	\N	\N	44672	44672	44673
12306	13139	1	applied	\N	\N	\N	\N	44674	44674	44675
12306	13140	2	applied	\N	\N	\N	\N	44676	44676	44677
12306	13141	3	applied	\N	\N	\N	\N	44678	44678	44679
12309	13145	0	applied	\N	\N	\N	\N	44693	44693	44694
12315	13152	0	applied	\N	\N	\N	\N	44715	44715	44716
12317	13153	0	applied	\N	\N	\N	\N	44721	44721	44722
12319	13154	0	applied	\N	\N	\N	\N	44729	44729	44730
12319	13155	1	applied	\N	\N	\N	\N	44731	44731	44732
12322	13157	0	applied	\N	\N	\N	\N	44742	44742	44743
12322	13158	1	applied	\N	\N	\N	\N	44744	44744	44745
12327	13163	0	applied	\N	\N	\N	\N	44758	44758	44759
12327	13164	1	applied	\N	\N	\N	\N	44760	44760	44761
12327	13165	2	applied	\N	\N	\N	\N	44762	44762	44763
12327	13166	3	applied	\N	\N	\N	\N	44764	44764	44765
12333	13168	0	applied	\N	\N	\N	\N	44775	44775	44776
12341	13172	0	applied	\N	\N	\N	\N	44793	44793	44794
12341	13173	1	applied	\N	\N	\N	\N	44795	44795	44796
12344	13174	0	applied	\N	\N	\N	\N	44801	44801	44802
12344	13175	1	applied	\N	\N	\N	\N	44803	44803	44804
12344	13176	2	applied	\N	\N	\N	\N	44805	44805	44806
12344	13177	3	applied	\N	\N	\N	\N	44807	44807	44808
12346	13179	0	applied	\N	\N	\N	\N	44816	44816	44817
12349	13185	0	applied	\N	\N	\N	\N	44831	44831	44832
12349	13186	1	applied	\N	\N	\N	\N	44833	44833	44834
12359	13193	0	applied	\N	\N	\N	\N	44857	44857	44858
12362	13194	0	applied	\N	\N	\N	\N	44859	44859	44860
12367	13200	0	applied	\N	\N	\N	\N	44881	44881	44882
12367	13201	1	applied	\N	\N	\N	\N	44883	44883	44884
12367	13202	2	applied	\N	\N	\N	\N	44885	44885	44886
12374	13207	0	applied	\N	\N	\N	\N	44921	44921	44922
12379	13208	0	applied	\N	\N	\N	\N	44927	44927	44928
12383	13212	0	applied	\N	\N	\N	\N	44941	44941	44942
12389	13215	0	applied	\N	\N	\N	\N	44953	44953	44954
12396	13221	0	applied	\N	\N	\N	\N	44971	44971	44972
12396	13222	1	applied	\N	\N	\N	\N	44973	44973	44974
12398	13224	0	applied	\N	\N	\N	\N	44981	44981	44982
12398	13225	1	applied	\N	\N	\N	\N	44983	44983	44984
12408	13231	0	applied	\N	\N	\N	\N	45012	45012	45013
12413	13232	0	applied	\N	\N	\N	\N	45019	45019	45020
12414	13232	0	applied	\N	\N	\N	\N	45019	45019	45020
12417	13233	0	applied	\N	\N	\N	\N	45029	45029	45030
12424	13237	0	applied	\N	\N	\N	\N	45048	45048	45049
12424	13238	1	applied	\N	\N	\N	\N	45050	45050	45051
12461	13239	0	applied	\N	\N	\N	\N	45080	45080	45081
12478	13248	0	applied	\N	\N	\N	\N	45116	45116	45117
12478	13249	1	applied	\N	\N	1000000000	\N	45118	45118	45119
12478	13250	2	applied	\N	\N	1000000000	\N	45120	45120	45121
12480	13251	0	applied	\N	\N	1000000000	\N	45127	45127	45128
12480	13252	1	applied	\N	\N	1000000000	\N	45129	45129	45130
12480	13253	2	applied	\N	\N	\N	\N	45131	45131	45132
12486	13258	0	applied	\N	\N	\N	\N	45148	45148	45149
12486	13259	1	applied	\N	\N	\N	\N	45150	45150	45151
12486	13260	2	applied	\N	\N	\N	\N	45152	45152	45153
12486	13261	3	applied	\N	\N	\N	\N	45154	45154	45155
12488	13262	0	applied	\N	\N	\N	\N	45162	45162	45163
12501	13268	0	applied	\N	\N	\N	\N	45195	45195	45196
12501	13269	1	applied	\N	\N	\N	\N	45197	45197	45198
12504	13270	0	applied	\N	\N	\N	\N	45202	45202	45203
12504	13271	1	applied	\N	\N	\N	\N	45204	45204	45205
12509	13285	0	applied	\N	\N	\N	\N	45245	45245	45246
12509	13286	1	applied	\N	\N	\N	\N	45247	45247	45248
12509	13287	2	applied	\N	\N	\N	\N	45249	45249	45250
12509	13288	3	applied	\N	\N	\N	\N	45251	45251	45252
12514	13298	0	applied	\N	\N	\N	\N	45276	45276	45277
12514	13299	1	applied	\N	\N	\N	\N	45278	45278	45279
12518	13304	0	applied	\N	\N	\N	\N	45295	45295	45296
12518	13305	1	applied	\N	\N	\N	\N	45297	45297	45298
12523	13310	0	applied	\N	\N	\N	\N	45314	45314	45315
12197	13026	0	applied	\N	\N	\N	\N	44270	44270	44271
12200	13032	0	applied	\N	\N	\N	\N	44287	44287	44288
12203	13038	0	applied	\N	\N	\N	\N	44302	44302	44303
12203	13039	2	applied	\N	\N	\N	\N	44305	44305	44306
12206	13042	0	applied	\N	\N	\N	\N	44317	44317	44318
12213	13046	0	applied	\N	\N	\N	\N	44330	44330	44331
12216	13048	0	applied	\N	\N	\N	\N	44339	44339	44340
12216	13049	1	applied	\N	\N	\N	\N	44341	44341	44342
12218	13050	0	applied	\N	\N	\N	\N	44350	44350	44351
12218	13051	1	applied	\N	\N	\N	\N	44352	44352	44353
12221	13050	0	applied	\N	\N	\N	\N	44350	44350	44351
12221	13051	1	applied	\N	\N	\N	\N	44352	44352	44353
12222	13052	0	applied	\N	\N	\N	\N	44361	44361	44362
12225	13054	0	applied	\N	\N	\N	\N	44368	44368	44369
12225	13055	1	applied	\N	\N	\N	\N	44370	44370	44371
12225	13056	2	applied	\N	\N	\N	\N	44372	44372	44373
12232	13060	0	applied	\N	\N	\N	\N	44389	44389	44390
12232	13061	1	applied	\N	\N	\N	\N	44391	44391	44392
12232	13062	2	applied	\N	\N	\N	\N	44393	44393	44394
12232	13063	3	applied	\N	\N	\N	\N	44395	44395	44396
12232	13064	4	applied	\N	\N	\N	\N	44397	44397	44398
12239	13066	0	applied	\N	\N	\N	\N	44409	44409	44410
12241	13067	0	applied	\N	\N	\N	\N	44415	44415	44416
12243	13068	0	applied	\N	\N	\N	\N	44421	44421	44422
12246	13076	0	applied	\N	\N	\N	\N	44442	44442	44443
12246	13077	1	applied	\N	\N	\N	\N	44444	44444	44445
12249	13078	0	applied	\N	\N	\N	\N	44449	44449	44450
12249	13079	1	applied	\N	\N	\N	\N	44451	44451	44452
12249	13080	2	applied	\N	\N	\N	\N	44453	44453	44454
12249	13081	3	applied	\N	\N	\N	\N	44455	44455	44456
12251	13082	0	applied	\N	\N	\N	\N	44462	44462	44463
12264	13089	0	applied	\N	\N	\N	\N	44500	44500	44501
12275	13099	0	applied	\N	\N	\N	\N	44547	44547	44548
12278	13100	0	applied	\N	\N	\N	\N	44551	44551	44552
12280	13101	0	applied	\N	\N	\N	\N	44554	44554	44555
12290	13092	0	applied	\N	\N	\N	\N	44590	44590	44532
12290	13029	1	applied	\N	\N	\N	\N	44280	44280	44281
12290	13034	2	applied	\N	\N	\N	\N	44293	44293	44294
12290	13035	3	applied	\N	\N	\N	\N	44295	44295	44296
12290	13038	4	applied	\N	\N	\N	\N	44302	44302	44303
12290	13058	5	applied	\N	\N	\N	\N	44381	44381	44382
12290	13060	6	applied	\N	\N	\N	\N	44389	44389	44390
12290	13107	7	applied	\N	\N	\N	\N	44591	44591	44572
12290	13108	8	applied	\N	\N	\N	\N	44592	44592	44574
12290	13061	9	applied	\N	\N	\N	\N	44391	44391	44392
12290	13109	10	applied	\N	\N	\N	\N	44593	44593	44576
12290	13110	11	applied	\N	\N	\N	\N	44594	44594	44578
12290	13062	12	applied	\N	\N	\N	\N	44393	44393	44394
12290	13069	14	applied	\N	\N	\N	\N	44596	44596	44426
12290	13072	15	applied	\N	\N	\N	\N	44597	44597	44434
12290	13073	16	applied	\N	\N	\N	\N	44598	44598	44436
12290	13074	17	applied	\N	\N	\N	\N	44599	44599	44438
12290	13093	18	applied	\N	\N	\N	\N	44600	44600	44534
12290	13094	19	applied	\N	\N	\N	\N	44601	44601	44536
12290	13095	20	applied	\N	\N	\N	\N	44602	44602	44538
12290	13076	21	applied	\N	\N	\N	\N	44603	44603	44443
12303	13134	0	applied	\N	\N	\N	\N	44660	44660	44661
12303	13135	1	applied	\N	\N	\N	\N	44662	44662	44663
12305	13138	0	applied	\N	\N	\N	\N	44672	44672	44673
12305	13139	1	applied	\N	\N	\N	\N	44674	44674	44675
12305	13140	2	applied	\N	\N	\N	\N	44676	44676	44677
12305	13141	3	applied	\N	\N	\N	\N	44678	44678	44679
12310	13146	0	applied	\N	\N	\N	\N	44697	44697	44698
12310	13147	1	applied	\N	\N	\N	\N	44699	44699	44700
12313	13150	0	applied	\N	\N	\N	\N	44709	44709	44710
12313	13151	1	applied	\N	\N	\N	\N	44711	44711	44712
12324	13161	0	applied	\N	\N	\N	\N	44753	44753	44754
12324	13162	1	applied	\N	\N	\N	\N	44755	44755	44756
12325	13163	0	applied	\N	\N	\N	\N	44758	44758	44759
12325	13164	1	applied	\N	\N	\N	\N	44760	44760	44761
12325	13165	2	applied	\N	\N	\N	\N	44762	44762	44763
12325	13166	3	applied	\N	\N	\N	\N	44764	44764	44765
12328	13163	0	applied	\N	\N	\N	\N	44758	44758	44759
12328	13164	1	applied	\N	\N	\N	\N	44760	44760	44761
12328	13165	2	applied	\N	\N	\N	\N	44762	44762	44763
12328	13166	3	applied	\N	\N	\N	\N	44764	44764	44765
12334	13169	0	applied	\N	\N	\N	\N	44781	44781	44782
12339	13171	0	applied	\N	\N	\N	\N	44789	44789	44790
12353	13187	0	applied	\N	\N	\N	\N	44839	44839	44840
12355	13188	0	applied	\N	\N	\N	\N	44841	44841	44842
12355	13189	1	applied	\N	\N	\N	\N	44843	44843	44844
12358	13192	0	applied	\N	\N	\N	\N	44851	44851	44852
12360	13194	0	applied	\N	\N	\N	\N	44859	44859	44860
12363	13194	0	applied	\N	\N	\N	\N	44859	44859	44860
12365	13197	0	applied	\N	\N	\N	\N	44872	44872	44873
12365	13198	1	applied	\N	\N	\N	\N	44874	44874	44875
12369	13203	0	applied	\N	\N	\N	\N	44889	44889	44890
12371	13204	0	applied	\N	\N	\N	\N	44895	44895	44896
12371	13205	1	applied	\N	\N	\N	\N	44897	44897	44898
12377	13208	0	applied	\N	\N	\N	\N	44927	44927	44928
12382	13211	0	applied	\N	\N	\N	\N	44939	44939	44940
12385	13213	0	applied	\N	\N	\N	\N	44945	44945	44946
12387	13215	0	applied	\N	\N	\N	\N	44953	44953	44954
12394	13219	0	applied	\N	\N	\N	\N	44965	44965	44966
12394	13220	1	applied	\N	\N	\N	\N	44967	44967	44968
12404	13228	0	applied	\N	\N	\N	\N	45000	45000	45001
12410	13231	0	applied	\N	\N	\N	\N	45012	45012	45013
12411	13232	0	applied	\N	\N	\N	\N	45019	45019	45020
12415	13233	0	applied	\N	\N	\N	\N	45029	45029	45030
12420	13234	0	applied	\N	\N	\N	\N	45035	45035	45036
12420	13235	1	applied	\N	\N	\N	\N	45037	45037	45038
12420	13236	2	applied	\N	\N	\N	\N	45039	45039	45040
12445	13174	0	applied	\N	\N	\N	\N	44900	44900	44802
12445	13180	1	applied	\N	\N	\N	\N	44901	44901	44819
12445	13181	2	applied	\N	\N	\N	\N	44902	44902	44821
12445	13182	3	applied	\N	\N	\N	\N	44903	44903	44823
12445	13115	4	applied	\N	\N	\N	\N	44904	44904	44611
12445	13092	5	applied	\N	\N	\N	\N	44531	44531	44532
12445	13118	6	applied	\N	\N	\N	\N	44618	44618	44619
12445	13131	7	applied	\N	\N	\N	\N	44649	44649	44650
12445	13134	8	applied	\N	\N	\N	\N	44660	44660	44661
12445	13136	9	applied	\N	\N	\N	\N	44668	44668	44669
12445	13138	10	applied	\N	\N	\N	\N	44672	44672	44673
12445	13143	11	applied	\N	\N	\N	\N	44687	44687	44688
12445	13146	12	applied	\N	\N	\N	\N	44697	44697	44698
12445	13148	13	applied	\N	\N	\N	\N	44703	44703	44704
12445	13027	14	applied	\N	\N	\N	\N	44274	44274	44275
12445	13029	15	applied	\N	\N	\N	\N	44280	44280	44281
12445	13034	16	applied	\N	\N	\N	\N	44293	44293	44294
12445	13035	17	applied	\N	\N	\N	\N	44295	44295	44296
12217	12710	43	applied	\N	\N	\N	\N	43090	43090	43091
12217	12711	44	applied	\N	\N	\N	\N	43092	43092	43093
12217	12712	45	applied	\N	\N	\N	\N	43094	43094	43095
12217	12713	46	applied	\N	\N	\N	\N	43096	43096	43097
12217	12714	47	applied	\N	\N	\N	\N	43103	43103	43104
12217	12715	48	applied	\N	\N	\N	\N	43105	43105	43106
12217	12716	49	applied	\N	\N	\N	\N	43107	43107	43108
12217	12717	50	applied	\N	\N	\N	\N	43109	43109	43110
12217	12718	51	applied	\N	\N	\N	\N	43113	43113	43114
12217	12719	52	applied	\N	\N	1000000000	\N	43117	43117	43118
12217	12720	53	applied	\N	\N	\N	\N	43119	43119	43120
12217	12721	54	applied	\N	\N	\N	\N	43123	43123	43124
12217	12722	55	applied	\N	\N	\N	\N	43129	43129	43130
12217	12723	56	applied	\N	\N	\N	\N	43133	43133	43134
12217	12724	57	applied	\N	\N	\N	\N	43135	43135	43136
12217	12725	58	applied	\N	\N	\N	\N	43139	43139	43140
12217	12726	59	applied	\N	\N	\N	\N	43145	43145	43146
12217	12727	60	applied	\N	\N	\N	\N	43149	43149	43150
12217	12728	61	applied	\N	\N	1000000000	\N	43157	43157	43158
12217	12729	62	applied	\N	\N	\N	\N	43159	43159	43160
12217	12730	63	applied	\N	\N	\N	\N	43164	43164	43165
12217	12731	64	applied	\N	\N	\N	\N	43169	43169	43170
12217	12732	65	applied	\N	\N	\N	\N	43171	43171	43172
12217	12733	66	applied	\N	\N	\N	\N	43176	43176	43177
12217	12734	67	applied	\N	\N	\N	\N	43178	43178	43179
12217	12736	68	applied	\N	\N	\N	\N	43185	43185	43186
12217	12737	69	applied	\N	\N	\N	\N	43187	43187	43188
12217	12738	70	applied	\N	\N	\N	\N	43196	43196	43197
12217	12739	71	applied	\N	\N	\N	\N	43201	43201	43202
12217	12741	72	applied	\N	\N	\N	\N	43211	43211	43212
12217	12742	73	applied	\N	\N	\N	\N	43215	43215	43216
12217	12743	74	applied	\N	\N	\N	\N	43217	43217	43218
12217	12744	75	applied	\N	\N	\N	\N	43219	43219	43220
12217	12746	76	applied	\N	\N	\N	\N	43227	43227	43228
12217	12747	77	applied	\N	\N	\N	\N	43229	43229	43230
12217	12748	78	applied	\N	\N	\N	\N	43232	43232	43233
12217	12749	79	applied	\N	\N	\N	\N	43240	43240	43241
12217	12751	80	applied	\N	\N	\N	\N	43248	43248	43249
12217	12752	81	applied	\N	\N	\N	\N	43257	43257	43258
12217	12753	82	applied	\N	\N	\N	\N	43259	43259	43260
12217	12754	83	applied	\N	\N	\N	\N	43261	43261	43262
12217	12755	84	applied	\N	\N	\N	\N	43263	43263	43264
12217	12756	85	applied	\N	\N	\N	\N	43270	43270	43271
12217	12757	86	applied	\N	\N	\N	\N	43273	43273	43274
12217	12758	87	applied	\N	\N	\N	\N	43275	43275	43276
12217	12759	88	applied	\N	\N	\N	\N	43280	43280	43281
12217	12760	89	applied	\N	\N	\N	\N	43282	43282	43283
12217	12761	90	applied	\N	\N	\N	\N	43286	43286	43287
12217	12762	91	applied	\N	\N	\N	\N	43289	43289	43290
12217	12763	92	applied	\N	\N	\N	\N	43291	43291	43292
12217	12764	93	applied	\N	\N	\N	\N	43302	43302	43303
12217	12765	94	applied	\N	\N	\N	\N	43304	43304	43305
12217	12766	95	applied	\N	\N	\N	\N	43308	43308	43309
12217	12767	96	applied	\N	\N	\N	\N	43312	43312	43313
12217	12768	97	applied	\N	\N	\N	\N	43314	43314	43315
12217	12769	98	applied	\N	\N	\N	\N	43318	43318	43319
12217	12770	99	applied	\N	\N	\N	\N	43321	43321	43322
12217	12771	100	applied	\N	\N	\N	\N	43323	43323	43324
12217	12772	101	applied	\N	\N	\N	\N	43327	43327	43328
12217	12773	102	applied	\N	\N	\N	\N	43331	43331	43332
12217	12774	103	applied	\N	\N	\N	\N	43333	43333	43334
12217	12775	104	applied	\N	\N	\N	\N	43337	43337	43338
12217	12776	105	applied	\N	\N	\N	\N	43341	43341	43342
12217	12777	106	applied	\N	\N	\N	\N	43343	43343	43344
12217	12778	107	applied	\N	\N	\N	\N	43347	43347	43348
12217	12779	108	applied	\N	\N	\N	\N	43351	43351	43352
12217	12780	109	applied	\N	\N	\N	\N	43355	43355	43356
12217	12781	110	applied	\N	\N	\N	\N	43359	43359	43360
12217	12782	111	applied	\N	\N	\N	\N	43361	43361	43362
12217	12783	112	applied	\N	\N	\N	\N	43366	43366	43367
12217	12784	114	applied	\N	\N	\N	\N	43372	43372	43373
12217	12785	115	applied	\N	\N	\N	\N	43378	43378	43379
12217	12786	116	applied	\N	\N	\N	\N	43380	43380	43381
12217	12787	117	applied	\N	\N	\N	\N	43384	43384	43385
12217	12788	118	applied	\N	\N	\N	\N	43386	43386	43387
12217	12789	119	applied	\N	\N	\N	\N	43390	43390	43391
12217	12790	120	applied	\N	\N	\N	\N	43394	43394	43395
12217	12791	121	applied	\N	\N	\N	\N	43396	43396	43397
12217	12792	122	applied	\N	\N	\N	\N	43400	43400	43401
12217	12793	123	applied	\N	\N	\N	\N	43402	43402	43403
12217	12794	124	applied	\N	\N	\N	\N	43406	43406	43407
12217	12795	125	applied	\N	\N	\N	\N	43410	43410	43411
12219	13050	0	applied	\N	\N	\N	\N	44350	44350	44351
12219	13051	1	applied	\N	\N	\N	\N	44352	44352	44353
12223	13053	0	applied	\N	\N	\N	\N	44364	44364	44365
12226	13054	0	applied	\N	\N	\N	\N	44368	44368	44369
12226	13055	1	applied	\N	\N	\N	\N	44370	44370	44371
12226	13056	2	applied	\N	\N	\N	\N	44372	44372	44373
12228	13058	0	applied	\N	\N	\N	\N	44381	44381	44382
12231	13059	0	applied	\N	\N	\N	\N	44385	44385	44386
12233	13065	0	applied	\N	\N	\N	\N	44401	44401	44402
12237	13065	0	applied	\N	\N	\N	\N	44401	44401	44402
12240	13066	0	applied	\N	\N	\N	\N	44409	44409	44410
12242	13067	0	applied	\N	\N	\N	\N	44415	44415	44416
12244	13069	0	applied	\N	\N	\N	\N	44425	44425	44426
12244	13070	1	applied	\N	\N	\N	\N	44427	44427	44428
12244	13071	2	applied	\N	\N	\N	\N	44429	44429	44430
12258	13085	0	applied	\N	\N	\N	\N	44477	44477	44478
12259	13086	0	applied	\N	\N	\N	\N	44481	44481	44482
12259	13087	1	applied	\N	\N	\N	\N	44483	44483	44484
12259	13088	2	applied	\N	\N	\N	\N	44485	44485	44486
12261	13027	0	applied	\N	\N	\N	\N	44274	44274	44275
12261	13029	1	applied	\N	\N	\N	\N	44280	44280	44281
12261	13034	2	applied	\N	\N	\N	\N	44293	44293	44294
12261	13035	3	applied	\N	\N	\N	\N	44295	44295	44296
12261	13038	4	applied	\N	\N	\N	\N	44302	44302	44303
12261	13058	5	applied	\N	\N	\N	\N	44381	44381	44382
12261	13060	6	applied	\N	\N	\N	\N	44389	44389	44390
12261	13061	7	applied	\N	\N	\N	\N	44391	44391	44392
12261	13062	8	applied	\N	\N	\N	\N	44393	44393	44394
12261	13069	9	applied	\N	\N	\N	\N	44425	44425	44426
12261	13072	10	applied	\N	\N	\N	\N	44433	44433	44434
12261	13073	11	applied	\N	\N	\N	\N	44435	44435	44436
12261	13074	12	applied	\N	\N	\N	\N	44437	44437	44438
12261	13076	13	applied	\N	\N	\N	\N	44442	44442	44443
12261	13078	14	applied	\N	\N	\N	\N	44449	44449	44450
12261	13013	15	applied	\N	\N	\N	\N	44217	44217	44218
12261	13079	16	applied	\N	\N	\N	\N	44451	44451	44452
12261	12960	17	applied	\N	\N	\N	\N	44024	44024	44025
12261	12978	18	applied	\N	\N	\N	\N	44490	44490	44099
12261	12979	19	applied	\N	\N	\N	\N	44491	44491	44101
12261	12961	20	applied	\N	\N	\N	\N	44029	44029	44030
12261	12980	21	applied	\N	\N	\N	\N	44492	44492	44103
12261	12981	22	applied	\N	\N	\N	\N	44493	44493	44105
12261	12962	23	applied	\N	\N	\N	\N	44031	44031	44032
12261	12963	24	applied	\N	\N	\N	\N	44036	44036	44037
12261	12964	25	applied	\N	\N	\N	\N	44041	44041	44042
12261	12965	26	applied	\N	\N	\N	\N	44045	44045	44046
12261	12966	27	applied	\N	\N	\N	\N	44047	44047	44048
12261	12967	28	applied	\N	\N	\N	\N	44051	44051	44052
12261	12968	29	applied	\N	\N	\N	\N	44057	44057	44058
12261	12969	30	applied	\N	\N	\N	\N	44059	44059	44060
12261	12970	31	applied	\N	\N	\N	\N	44061	44061	44062
12261	12971	32	applied	\N	\N	\N	\N	44071	44071	44072
12261	12972	33	applied	\N	\N	\N	\N	44073	44073	44074
12261	12973	34	applied	\N	\N	\N	\N	44077	44077	44078
12261	12974	35	applied	\N	\N	\N	\N	44079	44079	44080
12261	12975	36	applied	\N	\N	\N	\N	44085	44085	44086
12261	12976	37	applied	\N	\N	\N	\N	44087	44087	44088
12261	12977	39	applied	\N	\N	\N	\N	44096	44096	44097
12261	12982	40	applied	\N	\N	\N	\N	44108	44108	44109
12261	12983	41	applied	\N	\N	\N	\N	44111	44111	44112
12261	12984	42	applied	\N	\N	\N	\N	44115	44115	44116
12261	12985	43	applied	\N	\N	\N	\N	44119	44119	44120
12261	12986	44	applied	\N	\N	\N	\N	44125	44125	44126
12261	12987	45	applied	\N	\N	1000000000	\N	44130	44130	44131
12261	12988	46	applied	\N	\N	\N	\N	44132	44132	44133
12261	12989	47	applied	\N	\N	\N	\N	44139	44139	44140
12261	12990	48	applied	\N	\N	\N	\N	44141	44141	44142
12261	12991	49	applied	\N	\N	\N	\N	44143	44143	44144
12261	12992	50	applied	\N	\N	\N	\N	44145	44145	44146
12261	12993	51	applied	\N	\N	\N	\N	44147	44147	44148
12261	12994	52	applied	\N	\N	\N	\N	44156	44156	44157
12261	12995	53	applied	\N	\N	\N	\N	44158	44158	44159
12261	12996	54	applied	\N	\N	\N	\N	44160	44160	44161
12261	12997	55	applied	\N	\N	\N	\N	44162	44162	44163
12261	12998	56	applied	\N	\N	\N	\N	44167	44167	44168
12261	12999	57	applied	\N	\N	\N	\N	44172	44172	44173
12261	13000	58	applied	\N	\N	\N	\N	44175	44175	44176
12261	13001	59	applied	\N	\N	\N	\N	44177	44177	44178
12261	13002	60	applied	\N	\N	\N	\N	44181	44181	44182
12261	13003	61	applied	\N	\N	\N	\N	44183	44183	44184
12261	13004	62	applied	\N	\N	\N	\N	44185	44185	44186
12261	13005	63	applied	\N	\N	\N	\N	44188	44188	44189
12261	13006	64	applied	\N	\N	\N	\N	44190	44190	44191
12261	13007	65	applied	\N	\N	\N	\N	44192	44192	44193
12261	13008	66	applied	\N	\N	\N	\N	44198	44198	44199
12261	13009	67	applied	\N	\N	\N	\N	44204	44204	44205
12261	13010	68	applied	\N	\N	\N	\N	44206	44206	44207
12261	13011	69	applied	\N	\N	\N	\N	44208	44208	44209
12261	13012	70	applied	\N	\N	\N	\N	44210	44210	44211
12261	13014	71	applied	\N	\N	\N	\N	44219	44219	44220
12261	13015	72	applied	\N	\N	\N	\N	44222	44222	44223
12261	13016	73	applied	\N	\N	\N	\N	44235	44235	44236
12261	13017	74	applied	\N	\N	\N	\N	44239	44239	44240
12261	13018	75	applied	\N	\N	\N	\N	44242	44242	44243
12261	13019	76	applied	\N	\N	\N	\N	44246	44246	44247
12261	13020	77	applied	\N	\N	\N	\N	44248	44248	44249
12261	13021	78	applied	\N	\N	\N	\N	44250	44250	44251
12261	13022	79	applied	\N	\N	\N	\N	44258	44258	44259
12261	13023	80	applied	\N	\N	\N	\N	44261	44261	44262
12261	13024	81	applied	\N	\N	\N	\N	44264	44264	44265
12261	13025	82	applied	\N	\N	\N	\N	44266	44266	44267
12261	13026	83	applied	\N	\N	\N	\N	44270	44270	44271
12261	13028	84	applied	\N	\N	\N	\N	44276	44276	44277
12261	13030	85	applied	\N	\N	\N	\N	44282	44282	44283
12261	13031	86	applied	\N	\N	\N	\N	44284	44284	44285
12261	13032	87	applied	\N	\N	\N	\N	44287	44287	44288
12261	13033	88	applied	\N	\N	\N	\N	44289	44289	44290
12261	13036	89	applied	\N	\N	\N	\N	44297	44297	44298
12261	13037	90	applied	\N	\N	\N	\N	44299	44299	44300
12261	13039	91	applied	\N	\N	\N	\N	44305	44305	44306
12261	13040	92	applied	\N	\N	\N	\N	44309	44309	44310
12261	13041	93	applied	\N	\N	\N	\N	44313	44313	44314
12261	13042	94	applied	\N	\N	\N	\N	44317	44317	44318
12261	13043	95	applied	\N	\N	\N	\N	44322	44322	44323
12261	13044	96	applied	\N	\N	\N	\N	44324	44324	44325
12261	13045	97	applied	\N	\N	1000000000	\N	44326	44326	44327
12261	13046	98	applied	\N	\N	\N	\N	44330	44330	44331
12261	13047	99	applied	\N	\N	\N	\N	44335	44335	44336
12261	13048	100	applied	\N	\N	\N	\N	44339	44339	44340
12261	13049	101	applied	\N	\N	\N	\N	44341	44341	44342
12261	13050	102	applied	\N	\N	\N	\N	44350	44350	44351
12261	13051	103	applied	\N	\N	\N	\N	44352	44352	44353
12261	13052	104	applied	\N	\N	\N	\N	44361	44361	44362
12261	13053	105	applied	\N	\N	\N	\N	44364	44364	44365
12261	13054	106	applied	\N	\N	\N	\N	44368	44368	44369
12261	13055	107	applied	\N	\N	\N	\N	44370	44370	44371
12261	13056	108	applied	\N	\N	\N	\N	44372	44372	44373
12261	13057	109	applied	\N	\N	\N	\N	44377	44377	44378
12261	13059	110	applied	\N	\N	\N	\N	44385	44385	44386
12261	13063	111	applied	\N	\N	\N	\N	44395	44395	44396
12261	13064	112	applied	\N	\N	\N	\N	44397	44397	44398
12261	13065	113	applied	\N	\N	\N	\N	44401	44401	44402
12261	13066	114	applied	\N	\N	\N	\N	44409	44409	44410
12261	13067	115	applied	\N	\N	\N	\N	44415	44415	44416
12261	13068	116	applied	\N	\N	\N	\N	44421	44421	44422
12261	13070	117	applied	\N	\N	\N	\N	44427	44427	44428
12261	13071	118	applied	\N	\N	\N	\N	44429	44429	44430
12261	13075	119	applied	\N	\N	\N	\N	44439	44439	44440
12261	13077	120	applied	\N	\N	\N	\N	44444	44444	44445
12261	13080	121	applied	\N	\N	\N	\N	44453	44453	44454
12261	13081	122	applied	\N	\N	\N	\N	44455	44455	44456
12261	13082	123	applied	\N	\N	\N	\N	44462	44462	44463
12261	13083	124	applied	\N	\N	\N	\N	44468	44468	44469
12263	12807	0	applied	\N	\N	\N	\N	43504	43504	43457
12263	12819	1	applied	\N	\N	\N	\N	43505	43505	43492
12263	12820	2	applied	\N	\N	\N	\N	43506	43506	43494
12263	12821	3	applied	\N	\N	\N	\N	43507	43507	43496
12263	13029	4	applied	\N	\N	\N	\N	44504	44504	44281
12263	13034	5	applied	\N	\N	\N	\N	44505	44505	44294
12263	13035	6	applied	\N	\N	\N	\N	44506	44506	44296
12263	13038	7	applied	\N	\N	\N	\N	44507	44507	44303
12263	13058	8	applied	\N	\N	\N	\N	44381	44381	44382
12263	13060	9	applied	\N	\N	\N	\N	44389	44389	44390
12263	12647	10	applied	\N	\N	\N	\N	42868	42868	42869
12263	13061	11	applied	\N	\N	\N	\N	44391	44391	44392
12263	13062	12	applied	\N	\N	\N	\N	44393	44393	44394
12265	13090	0	applied	\N	\N	\N	\N	44519	44519	44520
12267	13091	0	applied	\N	\N	\N	\N	44525	44525	44526
12270	13092	0	applied	\N	\N	\N	\N	44531	44531	44532
12270	13093	1	applied	\N	\N	\N	\N	44533	44533	44534
12270	13094	2	applied	\N	\N	\N	\N	44535	44535	44536
12270	13095	3	applied	\N	\N	\N	\N	44537	44537	44538
12270	13096	4	applied	\N	\N	\N	\N	44539	44539	44540
12270	13097	5	applied	\N	\N	\N	\N	44541	44541	44542
12270	13098	6	applied	\N	\N	\N	\N	44543	44543	44544
12272	13099	0	applied	\N	\N	\N	\N	44547	44547	44548
12279	13100	0	applied	\N	\N	\N	\N	44551	44551	44552
12281	13101	0	applied	\N	\N	\N	\N	44554	44554	44555
12283	13104	0	applied	\N	\N	\N	\N	44563	44563	44564
12286	13111	0	applied	\N	\N	\N	\N	44580	44580	44581
12293	13118	0	applied	\N	\N	\N	\N	44618	44618	44619
12293	13119	1	applied	\N	\N	\N	\N	44620	44620	44621
12296	13120	0	applied	\N	\N	\N	\N	44624	44624	44625
12296	13121	1	applied	\N	\N	\N	\N	44626	44626	44627
12296	13128	2	applied	\N	\N	\N	\N	44639	44639	44640
12296	13129	3	applied	\N	\N	\N	\N	44641	44641	44642
12298	13131	0	applied	\N	\N	\N	\N	44649	44649	44650
12298	13132	1	applied	\N	\N	\N	\N	44651	44651	44652
12308	13143	0	applied	\N	\N	\N	\N	44687	44687	44688
12308	13144	1	applied	\N	\N	\N	\N	44689	44689	44690
12314	13152	0	applied	\N	\N	\N	\N	44715	44715	44716
12316	13153	0	applied	\N	\N	\N	\N	44721	44721	44722
12321	13115	0	applied	\N	\N	\N	\N	44738	44738	44611
12321	13092	1	applied	\N	\N	\N	\N	44531	44531	44532
12321	13118	2	applied	\N	\N	\N	\N	44618	44618	44619
12321	13131	3	applied	\N	\N	\N	\N	44649	44649	44650
12321	13134	4	applied	\N	\N	\N	\N	44660	44660	44661
12321	13136	5	applied	\N	\N	\N	\N	44668	44668	44669
12321	13138	6	applied	\N	\N	\N	\N	44672	44672	44673
12321	13143	7	applied	\N	\N	\N	\N	44687	44687	44688
12321	13146	8	applied	\N	\N	\N	\N	44697	44697	44698
12321	13148	9	applied	\N	\N	\N	\N	44703	44703	44704
12321	13107	10	applied	\N	\N	\N	\N	44571	44571	44572
12321	13108	11	applied	\N	\N	\N	\N	44573	44573	44574
12321	13102	12	applied	\N	\N	\N	\N	44558	44558	44559
12321	13109	13	applied	\N	\N	\N	\N	44575	44575	44576
12321	13110	14	applied	\N	\N	\N	\N	44577	44577	44578
12321	13139	15	applied	\N	\N	\N	\N	44674	44674	44675
12321	13093	16	applied	\N	\N	\N	\N	44533	44533	44534
12321	13094	17	applied	\N	\N	\N	\N	44535	44535	44536
12321	13095	18	applied	\N	\N	\N	\N	44537	44537	44538
12321	13096	19	applied	\N	\N	\N	\N	44539	44539	44540
12321	13082	20	applied	\N	\N	\N	\N	44462	44462	44463
12321	13083	21	applied	\N	\N	\N	\N	44468	44468	44469
12321	13084	22	applied	\N	\N	\N	\N	44473	44473	44474
12321	13085	23	applied	\N	\N	\N	\N	44477	44477	44478
12321	13086	24	applied	\N	\N	\N	\N	44481	44481	44482
12321	13087	25	applied	\N	\N	\N	\N	44483	44483	44484
12321	13088	26	applied	\N	\N	\N	\N	44485	44485	44486
12321	13089	27	applied	\N	\N	\N	\N	44500	44500	44501
12321	13090	28	applied	\N	\N	\N	\N	44519	44519	44520
12321	13091	29	applied	\N	\N	\N	\N	44525	44525	44526
12321	13097	30	applied	\N	\N	\N	\N	44541	44541	44542
12321	13098	31	applied	\N	\N	\N	\N	44543	44543	44544
12321	13099	32	applied	\N	\N	\N	\N	44547	44547	44548
12321	13100	33	applied	\N	\N	\N	\N	44551	44551	44552
12321	13101	34	applied	\N	\N	\N	\N	44554	44554	44555
12321	13103	35	applied	\N	\N	\N	\N	44560	44560	44561
12321	13104	36	applied	\N	\N	\N	\N	44563	44563	44564
12321	13105	37	applied	\N	\N	\N	\N	44565	44565	44566
12321	13106	38	applied	\N	\N	\N	\N	44567	44567	44568
12321	13111	39	applied	\N	\N	\N	\N	44580	44580	44581
12321	13112	40	applied	\N	\N	\N	\N	44584	44584	44585
12321	13113	41	applied	\N	\N	\N	\N	44588	44588	44589
12321	13114	42	applied	\N	\N	\N	\N	44606	44606	44607
12321	13116	43	applied	\N	\N	\N	\N	44612	44612	44613
12321	13117	44	applied	\N	\N	\N	\N	44614	44614	44615
12321	13119	45	applied	\N	\N	\N	\N	44620	44620	44621
12321	13128	46	applied	\N	\N	\N	\N	44639	44639	44640
12321	13129	47	applied	\N	\N	\N	\N	44641	44641	44642
12321	13130	48	applied	\N	\N	\N	\N	44647	44647	44648
12321	13132	49	applied	\N	\N	\N	\N	44651	44651	44652
12321	13133	50	applied	\N	\N	\N	\N	44654	44654	44655
12321	13135	51	applied	\N	\N	\N	\N	44662	44662	44663
12321	13137	53	applied	\N	\N	\N	\N	44670	44670	44671
12321	13140	54	applied	\N	\N	\N	\N	44676	44676	44677
12321	13141	55	applied	\N	\N	\N	\N	44678	44678	44679
12321	13142	56	applied	\N	\N	\N	\N	44683	44683	44684
12321	13144	57	applied	\N	\N	\N	\N	44689	44689	44690
12326	13163	0	applied	\N	\N	\N	\N	44758	44758	44759
12326	13164	1	applied	\N	\N	\N	\N	44760	44760	44761
12326	13165	2	applied	\N	\N	\N	\N	44762	44762	44763
12326	13166	3	applied	\N	\N	\N	\N	44764	44764	44765
12332	13168	0	applied	\N	\N	\N	\N	44775	44775	44776
12337	13170	0	applied	\N	\N	\N	\N	44785	44785	44786
12340	13172	0	applied	\N	\N	\N	\N	44793	44793	44794
12340	13173	1	applied	\N	\N	\N	\N	44795	44795	44796
12342	13172	0	applied	\N	\N	\N	\N	44793	44793	44794
12342	13173	1	applied	\N	\N	\N	\N	44795	44795	44796
12343	13174	0	applied	\N	\N	\N	\N	44801	44801	44802
12343	13175	1	applied	\N	\N	\N	\N	44803	44803	44804
12343	13176	2	applied	\N	\N	\N	\N	44805	44805	44806
12343	13177	3	applied	\N	\N	\N	\N	44807	44807	44808
12345	13178	0	applied	\N	\N	\N	\N	44812	44812	44813
12348	13184	0	applied	\N	\N	\N	\N	44828	44828	44829
12354	13187	0	applied	\N	\N	\N	\N	44839	44839	44840
12356	13190	0	applied	\N	\N	\N	\N	44846	44846	44847
12356	13191	1	applied	\N	\N	\N	\N	44848	44848	44849
12361	13194	0	applied	\N	\N	\N	\N	44859	44859	44860
12366	13199	0	applied	\N	\N	\N	\N	44877	44877	44878
12370	13203	0	applied	\N	\N	\N	\N	44889	44889	44890
12372	13174	0	applied	\N	\N	\N	\N	44900	44900	44802
12372	13180	1	applied	\N	\N	\N	\N	44901	44901	44819
12372	13181	2	applied	\N	\N	\N	\N	44902	44902	44821
12372	13182	3	applied	\N	\N	\N	\N	44903	44903	44823
12372	13115	4	applied	\N	\N	\N	\N	44904	44904	44611
12372	13092	5	applied	\N	\N	\N	\N	44590	44590	44532
12372	13118	6	applied	\N	\N	\N	\N	44905	44905	44619
12372	13131	7	applied	\N	\N	\N	\N	44906	44906	44650
12372	13134	8	applied	\N	\N	\N	\N	44907	44907	44661
12372	13136	9	applied	\N	\N	\N	\N	44908	44908	44669
12372	13138	10	applied	\N	\N	\N	\N	44909	44909	44673
12372	13143	11	applied	\N	\N	\N	\N	44910	44910	44688
12372	13146	12	applied	\N	\N	\N	\N	44911	44911	44698
12372	13029	13	applied	\N	\N	\N	\N	44280	44280	44281
12372	13034	14	applied	\N	\N	\N	\N	44293	44293	44294
12372	13035	15	applied	\N	\N	\N	\N	44295	44295	44296
12372	13038	16	applied	\N	\N	\N	\N	44302	44302	44303
12372	13058	17	applied	\N	\N	\N	\N	44381	44381	44382
12372	13060	18	applied	\N	\N	\N	\N	44389	44389	44390
12372	13107	19	applied	\N	\N	\N	\N	44591	44591	44572
12372	13108	20	applied	\N	\N	\N	\N	44592	44592	44574
12372	13061	21	applied	\N	\N	\N	\N	44391	44391	44392
12372	13109	22	applied	\N	\N	\N	\N	44593	44593	44576
12372	13110	23	applied	\N	\N	\N	\N	44594	44594	44578
12372	13062	24	applied	\N	\N	\N	\N	44393	44393	44394
12372	13069	25	applied	\N	\N	\N	\N	44596	44596	44426
12372	13072	26	applied	\N	\N	\N	\N	44597	44597	44434
12372	13073	27	applied	\N	\N	\N	\N	44598	44598	44436
12372	13074	28	applied	\N	\N	\N	\N	44599	44599	44438
12372	13093	29	applied	\N	\N	\N	\N	44600	44600	44534
12372	13094	30	applied	\N	\N	\N	\N	44601	44601	44536
12372	13095	31	applied	\N	\N	\N	\N	44602	44602	44538
12372	13076	32	applied	\N	\N	\N	\N	44603	44603	44443
12372	13078	33	applied	\N	\N	\N	\N	44912	44912	44450
12372	13096	34	applied	\N	\N	\N	\N	44913	44913	44540
12372	12884	35	applied	\N	\N	\N	\N	43753	43753	43754
12372	13013	36	applied	\N	\N	\N	\N	44228	44228	44229
12372	13079	37	applied	\N	\N	\N	\N	44451	44451	44452
12372	12871	38	applied	\N	\N	\N	\N	43695	43695	43696
12372	12949	39	applied	\N	\N	\N	\N	44218	44218	43985
12372	12872	40	applied	\N	\N	\N	\N	43697	43697	43698
12372	12898	41	applied	\N	\N	1000000000	\N	43811	43811	43812
12372	12873	42	applied	\N	\N	\N	\N	43701	43701	43702
12372	12874	43	applied	\N	\N	\N	\N	43705	43705	43706
12372	12875	44	applied	\N	\N	\N	\N	43717	43717	43718
12372	12876	45	applied	\N	\N	\N	\N	43719	43719	43720
12372	12934	46	applied	\N	\N	\N	\N	43936	43936	43937
12372	12899	47	applied	\N	\N	\N	\N	43813	43813	43813
12372	12877	48	applied	\N	\N	\N	\N	43723	43723	43724
12372	12878	49	applied	\N	\N	\N	\N	43727	43727	43728
12372	12879	50	applied	\N	\N	\N	\N	43731	43731	43732
12372	12880	51	applied	\N	\N	\N	\N	43733	43733	43734
12372	12881	52	applied	\N	\N	\N	\N	43739	43739	43740
12372	12882	53	applied	\N	\N	\N	\N	43745	43745	43746
12372	12883	54	applied	\N	\N	\N	\N	43749	43749	43750
12372	12885	55	applied	\N	\N	\N	\N	43755	43755	43756
12372	12886	56	applied	\N	\N	\N	\N	43758	43758	43759
12372	12887	57	applied	\N	\N	\N	\N	43762	43762	43763
12372	12978	58	applied	\N	\N	\N	\N	44230	44230	44099
12372	12979	59	applied	\N	\N	\N	\N	44231	44231	44101
12372	12980	60	applied	\N	\N	\N	\N	44232	44232	44103
12372	12981	61	applied	\N	\N	\N	\N	44233	44233	44105
12372	12888	62	applied	\N	\N	\N	\N	43764	43764	43765
12372	12889	63	applied	\N	\N	\N	\N	43768	43768	43769
12372	12890	64	applied	\N	\N	\N	\N	43775	43775	43776
12372	12891	65	applied	\N	\N	\N	\N	43778	43778	43779
12372	12892	66	applied	\N	\N	\N	\N	43782	43782	43783
12372	12893	67	applied	\N	\N	\N	\N	43789	43789	43790
12372	12894	68	applied	\N	\N	\N	\N	43795	43795	43796
12372	12895	69	applied	\N	\N	\N	\N	43803	43803	43804
12372	12896	70	applied	\N	\N	\N	\N	43807	43807	43808
12372	12897	71	applied	\N	\N	\N	\N	43809	43809	43810
12372	12900	72	applied	\N	\N	\N	\N	43816	43816	43817
12372	12901	73	applied	\N	\N	\N	\N	43823	43823	43824
12372	12902	74	applied	\N	\N	\N	\N	43828	43828	43829
12372	12903	75	applied	\N	\N	\N	\N	43835	43835	43836
12372	12905	76	applied	\N	\N	\N	\N	43838	43838	43839
12372	12906	77	applied	\N	\N	\N	\N	43840	43840	43841
12372	12909	78	applied	\N	\N	\N	\N	43848	43848	43849
12372	12910	80	applied	\N	\N	\N	\N	43853	43853	43854
12372	12911	81	applied	\N	\N	1000000000	\N	43855	43855	43856
12372	12912	82	applied	\N	\N	\N	\N	43857	43857	43858
12372	12913	83	applied	\N	\N	\N	\N	43861	43861	43862
12372	12914	84	applied	\N	\N	\N	\N	43864	43864	43865
12372	12916	85	applied	\N	\N	\N	\N	43867	43867	43868
12372	12917	86	applied	\N	\N	\N	\N	43870	43870	43871
12372	12918	87	applied	\N	\N	\N	\N	43874	43874	43875
12372	12919	88	applied	\N	\N	\N	\N	43878	43878	43879
12372	12920	89	applied	\N	\N	\N	\N	43881	43881	43882
12372	12921	90	applied	\N	\N	\N	\N	43885	43885	43886
12372	12922	91	applied	\N	\N	\N	\N	43887	43887	43888
12372	12924	92	applied	\N	\N	\N	\N	43894	43894	43895
12372	12925	93	applied	\N	\N	\N	\N	43898	43898	43899
12372	12926	94	applied	\N	\N	\N	\N	43904	43904	43905
12372	12927	95	applied	\N	\N	\N	\N	43910	43910	43911
12372	12928	96	applied	\N	\N	\N	\N	43912	43912	43913
12372	12929	97	applied	\N	\N	\N	\N	43914	43914	43915
12372	12930	98	applied	\N	\N	\N	\N	43917	43917	43918
12372	12931	99	applied	\N	\N	\N	\N	43919	43919	43920
12372	12932	100	applied	\N	\N	\N	\N	43930	43930	43931
12372	12933	101	applied	\N	\N	\N	\N	43934	43934	43935
12372	12935	102	applied	\N	\N	\N	\N	43946	43946	43947
12372	12936	103	applied	\N	\N	\N	\N	43948	43948	43949
12372	12937	104	applied	\N	\N	\N	\N	43952	43952	43953
12372	12938	105	applied	\N	\N	\N	\N	43954	43954	43955
12372	12939	106	applied	\N	\N	\N	\N	43956	43956	43957
12372	12940	107	applied	\N	\N	\N	\N	43959	43959	43960
12372	12941	108	applied	\N	\N	\N	\N	43961	43961	43962
12372	12942	109	applied	\N	\N	\N	\N	43963	43963	43964
12372	12943	110	applied	\N	\N	\N	\N	43966	43966	43967
12372	12944	111	applied	\N	\N	\N	\N	43970	43970	43971
12372	12945	112	applied	\N	\N	\N	\N	43972	43972	43973
12372	12946	113	applied	\N	\N	\N	\N	43974	43974	43975
12372	12904	114	applied	\N	\N	\N	\N	43837	43837	43837
12372	12908	115	applied	\N	\N	\N	\N	43843	43843	43843
12372	12947	116	applied	\N	\N	\N	\N	43976	43976	43977
12372	12948	117	applied	\N	\N	\N	\N	43978	43978	43979
12372	12950	118	applied	\N	\N	\N	\N	43986	43986	43987
12372	12951	119	applied	\N	\N	\N	\N	43992	43992	43993
12372	12952	120	applied	\N	\N	\N	\N	43996	43996	43997
12372	12953	121	applied	\N	\N	\N	\N	44002	44002	44003
12372	12954	122	applied	\N	\N	\N	\N	44005	44005	44006
12372	12955	123	applied	\N	\N	\N	\N	44007	44007	44008
12372	12956	124	applied	\N	\N	\N	\N	44009	44009	44010
12372	12957	125	applied	\N	\N	1000000000	\N	44011	44011	44012
12373	13206	0	applied	\N	\N	\N	\N	44917	44917	44918
12376	13207	0	applied	\N	\N	\N	\N	44921	44921	44922
12378	13208	0	applied	\N	\N	\N	\N	44927	44927	44928
12380	13209	0	applied	\N	\N	\N	\N	44933	44933	44934
12388	13215	0	applied	\N	\N	\N	\N	44953	44953	44954
12392	13218	0	applied	\N	\N	\N	\N	44961	44961	44962
12395	13221	0	applied	\N	\N	\N	\N	44971	44971	44972
12395	13222	1	applied	\N	\N	\N	\N	44973	44973	44974
12397	13223	0	applied	\N	\N	\N	\N	44979	44979	44980
12400	13224	0	applied	\N	\N	\N	\N	44981	44981	44982
12400	13225	1	applied	\N	\N	\N	\N	44983	44983	44984
12402	13226	0	applied	\N	\N	\N	\N	44992	44992	44993
12402	13227	1	applied	\N	\N	\N	\N	44994	44994	44995
12405	13228	0	applied	\N	\N	\N	\N	45000	45000	45001
12407	13231	0	applied	\N	\N	\N	\N	45012	45012	45013
12412	13232	0	applied	\N	\N	\N	\N	45019	45019	45020
12416	13233	0	applied	\N	\N	\N	\N	45029	45029	45030
12421	13228	0	applied	\N	\N	\N	\N	45000	45000	45001
12460	13239	0	applied	\N	\N	\N	\N	45080	45080	45081
12465	13240	0	applied	\N	\N	\N	\N	45086	45086	45087
12465	13241	1	applied	\N	\N	\N	\N	45088	45088	45089
12465	13242	2	applied	\N	\N	\N	\N	45090	45090	45091
12465	13243	3	applied	\N	\N	\N	\N	45092	45092	45093
12465	13244	4	applied	\N	\N	\N	\N	45094	45094	45095
12465	13245	5	applied	\N	\N	\N	\N	10287	10287	45096
12465	13246	6	applied	\N	\N	\N	\N	45097	45097	45098
12475	13247	0	applied	\N	\N	\N	\N	45109	45109	45110
12477	13248	0	applied	\N	\N	\N	\N	45116	45116	45117
12477	13249	1	applied	\N	\N	1000000000	\N	45118	45118	45119
12477	13250	2	applied	\N	\N	1000000000	\N	45120	45120	45121
12479	13248	0	applied	\N	\N	\N	\N	45116	45116	45117
12479	13249	1	applied	\N	\N	1000000000	\N	45118	45118	45119
12479	13250	2	applied	\N	\N	1000000000	\N	45120	45120	45121
12482	13255	0	applied	\N	\N	\N	\N	45137	45137	45138
12490	13262	0	applied	\N	\N	\N	\N	45162	45162	45163
12493	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12494	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12496	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12499	13266	0	applied	\N	\N	\N	\N	45185	45185	45186
12499	13267	1	applied	\N	\N	\N	\N	45187	45187	45188
12503	13270	0	applied	\N	\N	\N	\N	45202	45202	45203
12503	13271	1	applied	\N	\N	\N	\N	45204	45204	45205
12505	13264	0	applied	\N	\N	\N	\N	45179	45179	45180
12505	13266	1	applied	\N	\N	\N	\N	45185	45185	45186
12505	13268	2	applied	\N	\N	\N	\N	45195	45195	45196
12505	13270	3	applied	\N	\N	\N	\N	45202	45202	45203
12505	13263	4	applied	\N	\N	\N	\N	45168	45168	45169
12505	13265	5	applied	\N	\N	\N	\N	45181	45181	45182
12505	13267	6	applied	\N	\N	\N	\N	45187	45187	45188
12505	13269	7	applied	\N	\N	\N	\N	45197	45197	45198
12505	13271	8	applied	\N	\N	\N	\N	45204	45204	45205
12507	13272	0	applied	\N	\N	\N	\N	45216	45216	45217
12510	13289	0	applied	\N	\N	\N	\N	45255	45255	45256
12510	13290	1	applied	\N	\N	\N	\N	45257	45257	45258
12513	13298	0	applied	\N	\N	\N	\N	45276	45276	45277
12513	13299	1	applied	\N	\N	\N	\N	45278	45278	45279
12515	13300	0	applied	\N	\N	\N	\N	45283	45283	45284
12515	13301	1	applied	\N	\N	\N	\N	45285	45285	45286
12525	13310	0	applied	\N	\N	\N	\N	45314	45314	45315
12525	13311	1	applied	\N	\N	\N	\N	45316	45316	45317
12525	13312	2	applied	\N	\N	\N	\N	45318	45318	45319
12525	13313	3	applied	\N	\N	\N	\N	45320	45320	45321
12525	13314	4	applied	\N	\N	\N	\N	45322	45322	45323
12525	13315	5	applied	\N	\N	\N	\N	45324	45324	45325
12527	13318	0	applied	\N	\N	\N	\N	45336	45336	45337
12527	13319	1	applied	\N	\N	\N	\N	45338	45338	45339
12533	13324	0	applied	\N	\N	\N	\N	45355	45355	45356
12537	13331	0	applied	\N	\N	\N	\N	45375	45375	45376
12537	13332	1	applied	\N	\N	\N	\N	45377	45377	45378
12542	13333	0	applied	\N	\N	\N	\N	45383	45383	45384
12542	13334	1	applied	\N	\N	\N	\N	45385	45385	45386
12542	13335	2	applied	\N	\N	\N	\N	45387	45387	45388
12542	13336	3	applied	\N	\N	\N	\N	45389	45389	45390
12544	13337	0	applied	\N	\N	\N	\N	45395	45395	45396
12544	13338	1	applied	\N	\N	\N	\N	45397	45397	45398
12544	13339	2	applied	\N	\N	1000000000	\N	45399	45399	45400
12544	13340	3	applied	\N	\N	\N	\N	45401	45401	45402
12544	13341	4	applied	\N	\N	\N	\N	45403	45403	45404
12546	13342	0	applied	\N	\N	\N	\N	45408	45408	45409
12546	13343	1	applied	\N	\N	\N	\N	45410	45410	45411
12553	13344	0	applied	\N	\N	\N	\N	45419	45419	45420
12553	13345	1	applied	\N	\N	\N	\N	45421	45421	45422
12553	13348	2	applied	\N	\N	\N	\N	45429	45429	45430
12553	13346	3	applied	\N	\N	\N	\N	45423	45423	45424
12553	13347	4	applied	\N	\N	\N	\N	45425	45425	45426
12553	13349	5	applied	\N	\N	\N	\N	45433	45433	45434
12561	13360	0	applied	\N	\N	\N	\N	45466	45466	45467
12561	13361	1	applied	\N	\N	\N	\N	45468	45468	45469
12561	13362	2	applied	\N	\N	\N	\N	45470	45470	45471
12561	13363	3	applied	\N	\N	\N	\N	45472	45472	45473
12565	13368	0	applied	\N	\N	\N	\N	45490	45490	45491
12565	13369	1	applied	\N	\N	\N	\N	45492	45492	45493
12568	13372	0	applied	\N	\N	\N	\N	45504	45504	45505
12568	13373	1	applied	\N	\N	\N	\N	45506	45506	45507
12568	13374	2	applied	\N	\N	\N	\N	45508	45508	45509
12568	13375	3	applied	\N	\N	\N	\N	45510	45510	45511
12568	13376	4	applied	\N	\N	\N	\N	45512	45512	45513
12568	13377	5	applied	\N	\N	\N	\N	45514	45514	45515
12568	13378	6	applied	\N	\N	\N	\N	45516	45516	45517
12568	13379	7	applied	\N	\N	\N	\N	45518	45518	45519
12568	13380	8	applied	\N	\N	\N	\N	45520	45520	45521
12573	13385	0	applied	\N	\N	\N	\N	45538	45538	45539
12573	13386	1	applied	\N	\N	\N	\N	45540	45540	45541
12575	13387	0	applied	\N	\N	\N	\N	45543	45543	45544
12575	13388	1	applied	\N	\N	\N	\N	45545	45545	45546
12579	13399	0	applied	\N	\N	\N	\N	45577	45577	45578
12579	13400	1	applied	\N	\N	\N	\N	45579	45579	45580
12579	13401	2	applied	\N	\N	\N	\N	45581	45581	45582
12579	13402	3	applied	\N	\N	\N	\N	45583	45583	45584
12579	13403	4	applied	\N	\N	\N	\N	45585	45585	45586
12579	13404	5	applied	\N	\N	\N	\N	45587	45587	45588
12582	13405	0	applied	\N	\N	\N	\N	45592	45592	45593
12589	13420	0	applied	\N	\N	\N	\N	45631	45631	45632
12589	13421	1	applied	\N	\N	\N	\N	45633	45633	45634
12590	13422	0	applied	\N	\N	\N	\N	45638	45638	45639
12590	13423	1	applied	\N	\N	\N	\N	45640	45640	45641
12594	13428	0	applied	\N	\N	\N	\N	45657	45657	45658
12594	13429	1	applied	\N	\N	\N	\N	45659	45659	45660
12597	13438	0	applied	\N	\N	\N	\N	45681	45681	45682
12597	13439	1	applied	\N	\N	\N	\N	45683	45683	45684
12600	13444	0	applied	\N	\N	\N	\N	45698	45698	45699
12600	13445	1	applied	\N	\N	\N	\N	45700	45700	45701
12603	13448	0	applied	\N	\N	\N	\N	45712	45712	45713
12603	13449	1	applied	\N	\N	\N	\N	45714	45714	45715
12603	13450	2	applied	\N	\N	\N	\N	45716	45716	45717
12603	13451	3	applied	\N	\N	\N	\N	45718	45718	45719
12603	13452	4	applied	\N	\N	\N	\N	45720	45720	45721
12603	13453	5	applied	\N	\N	\N	\N	45722	45722	45723
12445	13038	18	applied	\N	\N	\N	\N	44302	44302	44303
12445	13058	19	applied	\N	\N	\N	\N	44381	44381	44382
12445	13060	20	applied	\N	\N	\N	\N	44389	44389	44390
12445	13107	21	applied	\N	\N	\N	\N	45066	45066	44572
12445	13108	22	applied	\N	\N	\N	\N	45067	45067	44574
12445	13061	23	applied	\N	\N	\N	\N	44391	44391	44392
12445	13109	24	applied	\N	\N	\N	\N	45068	45068	44576
12445	13110	25	applied	\N	\N	\N	\N	45069	45069	44578
12445	13139	26	applied	\N	\N	\N	\N	44674	44674	44675
12445	13062	27	applied	\N	\N	\N	\N	44393	44393	44394
12445	13069	28	applied	\N	\N	\N	\N	44425	44425	44426
12445	13072	29	applied	\N	\N	\N	\N	44433	44433	44434
12445	13073	30	applied	\N	\N	\N	\N	44435	44435	44436
12445	13074	31	applied	\N	\N	\N	\N	44437	44437	44438
12445	13093	32	applied	\N	\N	\N	\N	44600	44600	44534
12445	13094	33	applied	\N	\N	\N	\N	44601	44601	44536
12445	13095	34	applied	\N	\N	\N	\N	44602	44602	44538
12445	13076	35	applied	\N	\N	\N	\N	44442	44442	44443
12445	13078	36	applied	\N	\N	\N	\N	44449	44449	44450
12445	13096	37	applied	\N	\N	\N	\N	44913	44913	44540
12445	13079	38	applied	\N	\N	\N	\N	44451	44451	44452
12445	13022	39	applied	\N	\N	\N	\N	44258	44258	44259
12445	13023	40	applied	\N	\N	\N	\N	44261	44261	44262
12445	13024	41	applied	\N	\N	\N	\N	44264	44264	44265
12445	13025	42	applied	\N	\N	\N	\N	44266	44266	44267
12445	13026	43	applied	\N	\N	\N	\N	44270	44270	44271
12445	13028	44	applied	\N	\N	\N	\N	44276	44276	44277
12445	13030	45	applied	\N	\N	\N	\N	44282	44282	44283
12445	13031	46	applied	\N	\N	\N	\N	44284	44284	44285
12445	13032	47	applied	\N	\N	\N	\N	44287	44287	44288
12445	13033	48	applied	\N	\N	\N	\N	44289	44289	44290
12445	13036	49	applied	\N	\N	\N	\N	44297	44297	44298
12445	13037	50	applied	\N	\N	\N	\N	44299	44299	44300
12445	13039	51	applied	\N	\N	\N	\N	44305	44305	44306
12445	13040	52	applied	\N	\N	\N	\N	44309	44309	44310
12445	13041	53	applied	\N	\N	\N	\N	44313	44313	44314
12445	13042	54	applied	\N	\N	\N	\N	44317	44317	44318
12445	13043	55	applied	\N	\N	\N	\N	44322	44322	44323
12445	13044	56	applied	\N	\N	\N	\N	44324	44324	44325
12445	13045	57	applied	\N	\N	1000000000	\N	44326	44326	44327
12474	13247	0	applied	\N	\N	\N	\N	45109	45109	45110
12481	13254	0	applied	\N	\N	\N	\N	45135	45135	45136
12484	13257	0	applied	\N	\N	\N	\N	45144	45144	45145
12485	13258	0	applied	\N	\N	\N	\N	45148	45148	45149
12485	13259	1	applied	\N	\N	\N	\N	45150	45150	45151
12485	13260	2	applied	\N	\N	\N	\N	45152	45152	45153
12485	13261	3	applied	\N	\N	\N	\N	45154	45154	45155
12492	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12498	13266	0	applied	\N	\N	\N	\N	45185	45185	45186
12498	13267	1	applied	\N	\N	\N	\N	45187	45187	45188
12500	13266	0	applied	\N	\N	\N	\N	45185	45185	45186
12500	13267	1	applied	\N	\N	\N	\N	45187	45187	45188
12508	13273	0	applied	\N	\N	\N	\N	45220	45220	45221
12508	13274	1	applied	\N	\N	\N	\N	45222	45222	45223
12508	13275	2	applied	\N	\N	\N	\N	45224	45224	45225
12508	13276	3	applied	\N	\N	\N	\N	45226	45226	45227
12508	13277	4	applied	\N	\N	\N	\N	45228	45228	45229
12508	13278	5	applied	\N	\N	\N	\N	45230	45230	45231
12508	13279	6	applied	\N	\N	\N	\N	45232	45232	45233
12508	13280	7	applied	\N	\N	\N	\N	45234	45234	45235
12508	13281	8	applied	\N	\N	\N	\N	45236	45236	45237
12508	13282	9	applied	\N	\N	\N	\N	45238	45238	45239
12508	13283	10	applied	\N	\N	\N	\N	45240	45240	45241
12508	13284	11	applied	\N	\N	\N	\N	45242	45242	45243
12511	13291	0	applied	\N	\N	\N	\N	45260	45260	45261
12511	13292	1	applied	\N	\N	\N	\N	45262	45262	45263
12511	13293	2	applied	\N	\N	\N	\N	45264	45264	45265
12516	13302	0	applied	\N	\N	\N	\N	45289	45289	45290
12516	13303	1	applied	\N	\N	\N	\N	45291	45291	45292
12519	13304	0	applied	\N	\N	\N	\N	45295	45295	45296
12519	13305	1	applied	\N	\N	\N	\N	45297	45297	45298
12521	13306	0	applied	\N	\N	\N	\N	45304	45304	45305
12521	13307	1	applied	\N	\N	\N	\N	45306	45306	45307
12521	13308	2	applied	\N	\N	\N	\N	45308	45308	45309
12521	13309	3	applied	\N	\N	\N	\N	45310	45310	45311
12524	13310	0	applied	\N	\N	\N	\N	45314	45314	45315
12524	13311	1	applied	\N	\N	\N	\N	45316	45316	45317
12524	13312	2	applied	\N	\N	\N	\N	45318	45318	45319
12524	13313	3	applied	\N	\N	\N	\N	45320	45320	45321
12524	13314	4	applied	\N	\N	\N	\N	45322	45322	45323
12524	13315	5	applied	\N	\N	\N	\N	45324	45324	45325
12526	13316	0	applied	\N	\N	\N	\N	45331	45331	45332
12526	13317	1	applied	\N	\N	\N	\N	45333	45333	45334
12531	13324	0	applied	\N	\N	\N	\N	45355	45355	45356
12534	13324	0	applied	\N	\N	\N	\N	45355	45355	45356
12535	13325	0	applied	\N	\N	\N	\N	45360	45360	45361
12535	13326	1	applied	\N	\N	\N	\N	45362	45362	45363
12547	13342	0	applied	\N	\N	\N	\N	45408	45408	45409
12547	13343	1	applied	\N	\N	\N	\N	45410	45410	45411
12556	13358	0	applied	\N	\N	\N	\N	45457	45457	45458
12556	13359	1	applied	\N	\N	\N	\N	45459	45459	45460
12563	13342	0	applied	\N	\N	\N	\N	45408	45408	45409
12563	13344	1	applied	\N	\N	\N	\N	45419	45419	45420
12563	13345	2	applied	\N	\N	\N	\N	45421	45421	45422
12563	13348	3	applied	\N	\N	\N	\N	45429	45429	45430
12563	13350	5	applied	\N	\N	\N	\N	45437	45437	45438
12563	13352	6	applied	\N	\N	\N	\N	45443	45443	45444
12563	13353	7	applied	\N	\N	\N	\N	45445	45445	45446
12563	13354	8	applied	\N	\N	\N	\N	45447	45447	45448
12569	13381	0	applied	\N	\N	\N	\N	45524	45524	45525
12569	13382	1	applied	\N	\N	\N	\N	45526	45526	45527
12576	13389	0	applied	\N	\N	\N	\N	45551	45551	45552
12576	13390	1	applied	\N	\N	\N	\N	45553	45553	45554
12576	13391	2	applied	\N	\N	\N	\N	45555	45555	45556
12576	13392	3	applied	\N	\N	\N	\N	45557	45557	45558
12580	13399	0	applied	\N	\N	\N	\N	45577	45577	45578
12580	13400	1	applied	\N	\N	\N	\N	45579	45579	45580
12580	13401	2	applied	\N	\N	\N	\N	45581	45581	45582
12580	13402	3	applied	\N	\N	\N	\N	45583	45583	45584
12580	13403	4	applied	\N	\N	\N	\N	45585	45585	45586
12580	13404	5	applied	\N	\N	\N	\N	45587	45587	45588
12584	13406	0	applied	\N	\N	\N	\N	45598	45598	45599
12584	13407	1	applied	\N	\N	\N	\N	45600	45600	45601
12585	13408	0	applied	\N	\N	\N	\N	45603	45603	45604
12585	13409	1	applied	\N	\N	\N	\N	45605	45605	45606
12585	13410	2	applied	\N	\N	\N	\N	45607	45607	45608
12585	13411	3	applied	\N	\N	\N	\N	45609	45609	45610
12585	13412	4	applied	\N	\N	\N	\N	45611	45611	45612
12585	13413	5	applied	\N	\N	\N	\N	45613	45613	45614
12585	13414	6	applied	\N	\N	\N	\N	45615	45615	45616
12472	13214	1	applied	\N	\N	\N	\N	44949	44949	44950
12472	13215	2	applied	\N	\N	\N	\N	44953	44953	44954
12472	13216	3	applied	\N	\N	\N	\N	44955	44955	44956
12472	13217	4	applied	\N	\N	\N	\N	44958	44958	44959
12472	13218	5	applied	\N	\N	\N	\N	44961	44961	44962
12472	13219	6	applied	\N	\N	\N	\N	44965	44965	44966
12472	13220	8	applied	\N	\N	\N	\N	44967	44967	44968
12472	13221	9	applied	\N	\N	\N	\N	44971	44971	44972
12472	13246	10	applied	\N	\N	\N	\N	45097	45097	45098
12472	13222	11	applied	\N	\N	\N	\N	44973	44973	44974
12472	13223	12	applied	\N	\N	\N	\N	44979	44979	44980
12472	13224	13	applied	\N	\N	\N	\N	44981	44981	44982
12472	13225	14	applied	\N	\N	\N	\N	44983	44983	44984
12472	13226	15	applied	\N	\N	\N	\N	44992	44992	44993
12472	13227	16	applied	\N	\N	\N	\N	44994	44994	44995
12472	13228	17	applied	\N	\N	\N	\N	45000	45000	45001
12472	13229	18	applied	\N	\N	\N	\N	45006	45006	45007
12472	13230	19	applied	\N	\N	\N	\N	45008	45008	45009
12472	13231	20	applied	\N	\N	\N	\N	45012	45012	45013
12472	13232	21	applied	\N	\N	\N	\N	45019	45019	45020
12472	13233	22	applied	\N	\N	\N	\N	45029	45029	45030
12472	13235	23	applied	\N	\N	\N	\N	45037	45037	45038
12472	13236	24	applied	\N	\N	\N	\N	45039	45039	45040
12472	13237	25	applied	\N	\N	\N	\N	45048	45048	45049
12472	13238	26	applied	\N	\N	\N	\N	45050	45050	45051
12483	13256	0	applied	\N	\N	\N	\N	45140	45140	45141
12487	13258	0	applied	\N	\N	\N	\N	45148	45148	45149
12487	13259	1	applied	\N	\N	\N	\N	45150	45150	45151
12487	13260	2	applied	\N	\N	\N	\N	45152	45152	45153
12487	13261	3	applied	\N	\N	\N	\N	45154	45154	45155
12489	13262	0	applied	\N	\N	\N	\N	45162	45162	45163
12491	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12495	13263	0	applied	\N	\N	\N	\N	45168	45168	45169
12497	13264	0	applied	\N	\N	\N	\N	45179	45179	45180
12497	13265	1	applied	\N	\N	\N	\N	45181	45181	45182
12502	13268	0	applied	\N	\N	\N	\N	45195	45195	45196
12502	13269	1	applied	\N	\N	\N	\N	45197	45197	45198
12506	13270	0	applied	\N	\N	\N	\N	45202	45202	45203
12506	13271	1	applied	\N	\N	\N	\N	45204	45204	45205
12512	13294	0	applied	\N	\N	\N	\N	45266	45266	45267
12512	13295	1	applied	\N	\N	\N	\N	45268	45268	45269
12512	13296	2	applied	\N	\N	\N	\N	45270	45270	45271
12512	13297	3	applied	\N	\N	\N	\N	45272	45272	45273
12517	13302	0	applied	\N	\N	\N	\N	45289	45289	45290
12517	13303	1	applied	\N	\N	\N	\N	45291	45291	45292
12520	13304	0	applied	\N	\N	\N	\N	45295	45295	45296
12520	13305	1	applied	\N	\N	\N	\N	45297	45297	45298
12522	13306	0	applied	\N	\N	\N	\N	45304	45304	45305
12522	13307	1	applied	\N	\N	\N	\N	45306	45306	45307
12522	13308	2	applied	\N	\N	\N	\N	45308	45308	45309
12522	13309	3	applied	\N	\N	\N	\N	45310	45310	45311
12529	13320	0	applied	\N	\N	\N	\N	45343	45343	45344
12532	13321	0	applied	\N	\N	\N	\N	45347	45347	45348
12532	13322	1	applied	\N	\N	\N	\N	45349	45349	45350
12532	13320	2	applied	\N	\N	\N	\N	45343	45343	45344
12532	13323	3	applied	\N	\N	\N	\N	45351	45351	45352
12532	13324	4	applied	\N	\N	\N	\N	45355	45355	45356
12536	13327	0	applied	\N	\N	\N	\N	45366	45366	45367
12536	13328	1	applied	\N	\N	\N	\N	45368	45368	45369
12536	13329	2	applied	\N	\N	\N	\N	45370	45370	45371
12536	13330	3	applied	\N	\N	\N	\N	45372	45372	45373
12539	13331	0	applied	\N	\N	\N	\N	45375	45375	45376
12539	13332	1	applied	\N	\N	\N	\N	45377	45377	45378
12541	13333	0	applied	\N	\N	\N	\N	45383	45383	45384
12541	13334	1	applied	\N	\N	\N	\N	45385	45385	45386
12541	13335	2	applied	\N	\N	\N	\N	45387	45387	45388
12541	13336	3	applied	\N	\N	\N	\N	45389	45389	45390
12543	13337	0	applied	\N	\N	\N	\N	45395	45395	45396
12543	13338	1	applied	\N	\N	\N	\N	45397	45397	45398
12543	13339	2	applied	\N	\N	1000000000	\N	45399	45399	45400
12543	13340	3	applied	\N	\N	\N	\N	45401	45401	45402
12543	13341	4	applied	\N	\N	\N	\N	45403	45403	45404
12545	13342	0	applied	\N	\N	\N	\N	45408	45408	45409
12545	13343	1	applied	\N	\N	\N	\N	45410	45410	45411
12552	13174	0	applied	\N	\N	\N	\N	44801	44801	44802
12552	13180	1	applied	\N	\N	\N	\N	44818	44818	44819
12552	13181	2	applied	\N	\N	\N	\N	44820	44820	44821
12552	13182	4	applied	\N	\N	\N	\N	44822	44822	44823
12552	13264	5	applied	\N	\N	\N	\N	45179	45179	45180
12552	13266	6	applied	\N	\N	\N	\N	45185	45185	45186
12552	13268	7	applied	\N	\N	\N	\N	45195	45195	45196
12552	13270	8	applied	\N	\N	\N	\N	45202	45202	45203
12552	13273	9	applied	\N	\N	\N	\N	45220	45220	45221
12552	13275	10	applied	\N	\N	\N	\N	45224	45224	45225
12552	13276	11	applied	\N	\N	\N	\N	45226	45226	45227
12552	13277	12	applied	\N	\N	\N	\N	45228	45228	45229
12552	13278	13	applied	\N	\N	\N	\N	45230	45230	45231
12552	13279	14	applied	\N	\N	\N	\N	45232	45232	45233
12552	13285	15	applied	\N	\N	\N	\N	45245	45245	45246
12552	13286	16	applied	\N	\N	\N	\N	45247	45247	45248
12552	13289	17	applied	\N	\N	\N	\N	45255	45255	45256
12552	13291	18	applied	\N	\N	\N	\N	45260	45260	45261
12552	13294	19	applied	\N	\N	\N	\N	45266	45266	45267
12552	13295	20	applied	\N	\N	\N	\N	45268	45268	45269
12552	13298	21	applied	\N	\N	\N	\N	45276	45276	45277
12552	13300	22	applied	\N	\N	\N	\N	45283	45283	45284
12552	13302	23	applied	\N	\N	\N	\N	45289	45289	45290
12552	13304	24	applied	\N	\N	\N	\N	45295	45295	45296
12552	13306	25	applied	\N	\N	\N	\N	45304	45304	45305
12552	13307	26	applied	\N	\N	\N	\N	45306	45306	45307
12552	13310	27	applied	\N	\N	\N	\N	45314	45314	45315
12552	13311	28	applied	\N	\N	\N	\N	45316	45316	45317
12552	13312	29	applied	\N	\N	\N	\N	45318	45318	45319
12552	13316	30	applied	\N	\N	\N	\N	45331	45331	45332
12552	13318	31	applied	\N	\N	\N	\N	45336	45336	45337
12552	13321	32	applied	\N	\N	\N	\N	45347	45347	45348
12552	13322	33	applied	\N	\N	\N	\N	45349	45349	45350
12552	13325	34	applied	\N	\N	\N	\N	45360	45360	45361
12552	13327	35	applied	\N	\N	\N	\N	45366	45366	45367
12552	13328	36	applied	\N	\N	\N	\N	45368	45368	45369
12552	13331	37	applied	\N	\N	\N	\N	45375	45375	45376
12552	13333	38	applied	\N	\N	\N	\N	45383	45383	45384
12552	13334	39	applied	\N	\N	\N	\N	45385	45385	45386
12552	13337	40	applied	\N	\N	\N	\N	45395	45395	45396
12552	13338	41	applied	\N	\N	\N	\N	45397	45397	45398
12552	13342	42	applied	\N	\N	\N	\N	45408	45408	45409
12552	13344	43	applied	\N	\N	\N	\N	45419	45419	45420
12552	13345	44	applied	\N	\N	\N	\N	45421	45421	45422
12552	13348	45	applied	\N	\N	\N	\N	45429	45429	45430
12552	13239	46	applied	\N	\N	\N	\N	45080	45080	45081
12523	13311	1	applied	\N	\N	\N	\N	45316	45316	45317
12523	13312	2	applied	\N	\N	\N	\N	45318	45318	45319
12523	13313	3	applied	\N	\N	\N	\N	45320	45320	45321
12523	13314	4	applied	\N	\N	\N	\N	45322	45322	45323
12523	13315	5	applied	\N	\N	\N	\N	45324	45324	45325
12528	13318	0	applied	\N	\N	\N	\N	45336	45336	45337
12528	13319	1	applied	\N	\N	\N	\N	45338	45338	45339
12530	13321	0	applied	\N	\N	\N	\N	45347	45347	45348
12530	13322	1	applied	\N	\N	\N	\N	45349	45349	45350
12530	13323	2	applied	\N	\N	\N	\N	45351	45351	45352
12538	13331	0	applied	\N	\N	\N	\N	45375	45375	45376
12538	13332	1	applied	\N	\N	\N	\N	45377	45377	45378
12540	13333	0	applied	\N	\N	\N	\N	45383	45383	45384
12540	13334	1	applied	\N	\N	\N	\N	45385	45385	45386
12540	13335	2	applied	\N	\N	\N	\N	45387	45387	45388
12540	13336	3	applied	\N	\N	\N	\N	45389	45389	45390
12551	13344	0	applied	\N	\N	\N	\N	45419	45419	45420
12551	13345	1	applied	\N	\N	\N	\N	45421	45421	45422
12551	13346	2	applied	\N	\N	\N	\N	45423	45423	45424
12551	13347	3	applied	\N	\N	\N	\N	45425	45425	45426
12557	13358	0	applied	\N	\N	\N	\N	45457	45457	45458
12557	13359	1	applied	\N	\N	\N	\N	45459	45459	45460
12559	13360	0	applied	\N	\N	\N	\N	45466	45466	45467
12559	13361	1	applied	\N	\N	\N	\N	45468	45468	45469
12559	13362	2	applied	\N	\N	\N	\N	45470	45470	45471
12559	13363	3	applied	\N	\N	\N	\N	45472	45472	45473
12566	13370	0	applied	\N	\N	\N	\N	45496	45496	45497
12566	13371	1	applied	\N	\N	\N	\N	45498	45498	45499
12570	13381	0	applied	\N	\N	\N	\N	45524	45524	45525
12570	13382	1	applied	\N	\N	\N	\N	45526	45526	45527
12574	13387	0	applied	\N	\N	\N	\N	45543	45543	45544
12574	13388	1	applied	\N	\N	\N	\N	45545	45545	45546
12577	13393	0	applied	\N	\N	\N	\N	45561	45561	45562
12577	13394	1	applied	\N	\N	\N	\N	45563	45563	45564
12577	13395	2	applied	\N	\N	\N	\N	45565	45565	45566
12577	13396	3	applied	\N	\N	\N	\N	45567	45567	45568
12577	13397	4	applied	\N	\N	\N	\N	45569	45569	45570
12577	13398	5	applied	\N	\N	\N	\N	45571	45571	45572
12586	13416	0	applied	\N	\N	\N	\N	45620	45620	45621
12586	13417	1	applied	\N	\N	\N	\N	45622	45622	45623
12586	13418	2	applied	\N	\N	\N	\N	45624	45624	45625
12586	13419	3	applied	\N	\N	\N	\N	45626	45626	45627
12596	13430	0	applied	\N	\N	\N	\N	45664	45664	45665
12596	13431	1	applied	\N	\N	\N	\N	45666	45666	45667
12596	13432	2	applied	\N	\N	\N	\N	45668	45668	45669
12596	13433	3	applied	\N	\N	\N	\N	45670	45670	45671
12596	13434	4	applied	\N	\N	\N	\N	45672	45672	45673
12596	13435	5	applied	\N	\N	\N	\N	45674	45674	45675
12596	13436	6	applied	\N	\N	\N	\N	45676	45676	45677
12596	13437	7	applied	\N	\N	\N	\N	45678	45678	45679
12601	13446	0	applied	\N	\N	\N	\N	45704	45704	45705
12601	13447	1	applied	\N	\N	\N	\N	45706	45706	45707
12607	13456	0	applied	\N	\N	\N	\N	45733	45733	45734
12607	13457	1	applied	\N	\N	\N	\N	45735	45735	45736
12609	13460	0	applied	\N	\N	\N	\N	45746	45746	45747
12609	13461	1	applied	\N	\N	\N	\N	45748	45748	45749
12611	13462	0	applied	\N	\N	\N	\N	45753	45753	45754
12611	13463	1	applied	\N	\N	\N	\N	45755	45755	45756
12617	13476	0	applied	\N	\N	\N	\N	45788	45788	45789
12617	13477	1	applied	\N	\N	\N	\N	45790	45790	45791
12620	13486	0	applied	\N	\N	\N	\N	45814	45814	45815
12620	13487	1	applied	\N	\N	\N	\N	45816	45816	45817
12552	13339	47	applied	\N	\N	1000000000	\N	45399	45399	45400
12552	13161	48	applied	\N	\N	\N	\N	44753	44753	44754
12552	13162	49	applied	\N	\N	\N	\N	44755	44755	44756
12552	13163	50	applied	\N	\N	\N	\N	44758	44758	44759
12552	13164	51	applied	\N	\N	\N	\N	44760	44760	44761
12552	13165	52	applied	\N	\N	\N	\N	44762	44762	44763
12552	13166	53	applied	\N	\N	\N	\N	44764	44764	44765
12552	13167	54	applied	\N	\N	\N	\N	44772	44772	44773
12552	13168	55	applied	\N	\N	\N	\N	44775	44775	44776
12552	13246	56	applied	\N	\N	\N	\N	45097	45097	45098
12552	13247	57	applied	\N	\N	\N	\N	45109	45109	45110
12552	13169	58	applied	\N	\N	\N	\N	44781	44781	44782
12552	13170	59	applied	\N	\N	\N	\N	44785	44785	44786
12552	13171	60	applied	\N	\N	\N	\N	44789	44789	44790
12552	13172	61	applied	\N	\N	\N	\N	44793	44793	44794
12552	13173	62	applied	\N	\N	\N	\N	44795	44795	44796
12552	13175	63	applied	\N	\N	\N	\N	44803	44803	44804
12552	13176	64	applied	\N	\N	\N	\N	44805	44805	44806
12552	13177	65	applied	\N	\N	\N	\N	44807	44807	44808
12552	13178	66	applied	\N	\N	\N	\N	44812	44812	44813
12552	13179	67	applied	\N	\N	\N	\N	44816	44816	44817
12552	13183	68	applied	\N	\N	\N	\N	44824	44824	44825
12552	13184	69	applied	\N	\N	\N	\N	44828	44828	44829
12552	13185	70	applied	\N	\N	\N	\N	44831	44831	44832
12552	13186	71	applied	\N	\N	\N	\N	44833	44833	44834
12552	13187	72	applied	\N	\N	\N	\N	44839	44839	44840
12552	13188	73	applied	\N	\N	\N	\N	44841	44841	44842
12552	13189	74	applied	\N	\N	\N	\N	44843	44843	44844
12552	13190	75	applied	\N	\N	\N	\N	44846	44846	44847
12552	13191	76	applied	\N	\N	\N	\N	44848	44848	44849
12552	13192	77	applied	\N	\N	\N	\N	44851	44851	44852
12552	13193	78	applied	\N	\N	\N	\N	44857	44857	44858
12552	13194	79	applied	\N	\N	\N	\N	44859	44859	44860
12552	13195	80	applied	\N	\N	\N	\N	44868	44868	44869
12552	13196	81	applied	\N	\N	\N	\N	44870	44870	44871
12552	13197	82	applied	\N	\N	\N	\N	44872	44872	44873
12552	13198	83	applied	\N	\N	\N	\N	44874	44874	44875
12552	13199	84	applied	\N	\N	\N	\N	44877	44877	44878
12552	13200	85	applied	\N	\N	\N	\N	44881	44881	44882
12552	13201	86	applied	\N	\N	\N	\N	44883	44883	44884
12552	13202	87	applied	\N	\N	\N	\N	44885	44885	44886
12552	13203	88	applied	\N	\N	\N	\N	44889	44889	44890
12552	13204	89	applied	\N	\N	\N	\N	44895	44895	44896
12552	13205	90	applied	\N	\N	\N	\N	44897	44897	44898
12552	13206	91	applied	\N	\N	\N	\N	44917	44917	44918
12552	13207	92	applied	\N	\N	\N	\N	44921	44921	44922
12552	13208	93	applied	\N	\N	\N	\N	44927	44927	44928
12552	13209	94	applied	\N	\N	\N	\N	44933	44933	44934
12552	13210	95	applied	\N	\N	\N	\N	44936	44936	44937
12552	13211	96	applied	\N	\N	\N	\N	44939	44939	44940
12552	13212	97	applied	\N	\N	\N	\N	44941	44941	44942
12552	13213	98	applied	\N	\N	\N	\N	44945	44945	44946
12552	13214	99	applied	\N	\N	\N	\N	44949	44949	44950
12552	13215	100	applied	\N	\N	\N	\N	44953	44953	44954
12552	13216	101	applied	\N	\N	\N	\N	44955	44955	44956
12552	13217	102	applied	\N	\N	\N	\N	44958	44958	44959
12552	13218	103	applied	\N	\N	\N	\N	44961	44961	44962
12552	13219	104	applied	\N	\N	\N	\N	44965	44965	44966
12552	13220	105	applied	\N	\N	\N	\N	44967	44967	44968
12552	13221	106	applied	\N	\N	\N	\N	44971	44971	44972
12552	13222	107	applied	\N	\N	\N	\N	44973	44973	44974
12552	13223	108	applied	\N	\N	\N	\N	44979	44979	44980
12552	13224	109	applied	\N	\N	\N	\N	44981	44981	44982
12552	13225	110	applied	\N	\N	\N	\N	44983	44983	44984
12552	13226	111	applied	\N	\N	\N	\N	44992	44992	44993
12552	13227	112	applied	\N	\N	\N	\N	44994	44994	44995
12552	13228	113	applied	\N	\N	\N	\N	45000	45000	45001
12552	13229	114	applied	\N	\N	\N	\N	45006	45006	45007
12552	13230	115	applied	\N	\N	\N	\N	45008	45008	45009
12552	13231	116	applied	\N	\N	\N	\N	45012	45012	45013
12552	13232	117	applied	\N	\N	\N	\N	45019	45019	45020
12552	13233	118	applied	\N	\N	\N	\N	45029	45029	45030
12552	13235	119	applied	\N	\N	\N	\N	45037	45037	45038
12552	13236	120	applied	\N	\N	\N	\N	45039	45039	45040
12552	13237	121	applied	\N	\N	\N	\N	45048	45048	45049
12552	13238	122	applied	\N	\N	\N	\N	45050	45050	45051
12552	13248	123	applied	\N	\N	\N	\N	45116	45116	45117
12552	13249	124	applied	\N	\N	1000000000	\N	45118	45118	45119
12552	13250	125	applied	\N	\N	1000000000	\N	45120	45120	45121
12554	13350	0	applied	\N	\N	\N	\N	45437	45437	45438
12554	13351	1	applied	\N	\N	\N	\N	45439	45439	45440
12555	13352	0	applied	\N	\N	\N	\N	45443	45443	45444
12555	13353	1	applied	\N	\N	\N	\N	45445	45445	45446
12555	13354	2	applied	\N	\N	\N	\N	45447	45447	45448
12555	13355	3	applied	\N	\N	\N	\N	45449	45449	45450
12555	13356	4	applied	\N	\N	\N	\N	45451	45451	45452
12555	13357	5	applied	\N	\N	\N	\N	45453	45453	45454
12558	13358	0	applied	\N	\N	\N	\N	45457	45457	45458
12558	13359	1	applied	\N	\N	\N	\N	45459	45459	45460
12560	13360	0	applied	\N	\N	\N	\N	45466	45466	45467
12560	13361	1	applied	\N	\N	\N	\N	45468	45468	45469
12560	13362	2	applied	\N	\N	\N	\N	45470	45470	45471
12560	13363	3	applied	\N	\N	\N	\N	45472	45472	45473
12562	13364	0	applied	\N	\N	\N	\N	45478	45478	45479
12562	13365	1	applied	\N	\N	\N	\N	45480	45480	45481
12564	13366	0	applied	\N	\N	\N	\N	45486	45486	45487
12564	13367	1	applied	\N	\N	\N	\N	45488	45488	45489
12567	13370	0	applied	\N	\N	\N	\N	45496	45496	45497
12567	13371	1	applied	\N	\N	\N	\N	45498	45498	45499
12571	13381	0	applied	\N	\N	\N	\N	45524	45524	45525
12571	13382	1	applied	\N	\N	\N	\N	45526	45526	45527
12572	13383	0	applied	\N	\N	\N	\N	45533	45533	45534
12572	13384	1	applied	\N	\N	\N	\N	45535	45535	45536
12581	13405	0	applied	\N	\N	\N	\N	45592	45592	45593
12583	13405	0	applied	\N	\N	\N	\N	45592	45592	45593
12587	13416	0	applied	\N	\N	\N	\N	45620	45620	45621
12587	13417	1	applied	\N	\N	\N	\N	45622	45622	45623
12587	13418	2	applied	\N	\N	\N	\N	45624	45624	45625
12587	13419	3	applied	\N	\N	\N	\N	45626	45626	45627
12588	13406	0	applied	\N	\N	\N	\N	45598	45598	45599
12588	13408	1	applied	\N	\N	\N	\N	45603	45603	45604
12588	13409	2	applied	\N	\N	\N	\N	45605	45605	45606
12588	13410	3	applied	\N	\N	\N	\N	45607	45607	45608
12588	13411	4	applied	\N	\N	\N	\N	45609	45609	45610
12588	13416	5	applied	\N	\N	\N	\N	45620	45620	45621
12588	13417	6	applied	\N	\N	\N	\N	45622	45622	45623
12588	13420	7	applied	\N	\N	\N	\N	45631	45631	45632
12588	13407	8	applied	\N	\N	\N	\N	45600	45600	45601
12588	13412	9	applied	\N	\N	\N	\N	45611	45611	45612
12585	13415	7	applied	\N	\N	\N	\N	45617	45617	45618
12592	13424	0	applied	\N	\N	\N	\N	45645	45645	45646
12592	13425	1	applied	\N	\N	\N	\N	45647	45647	45648
12592	13426	2	applied	\N	\N	\N	\N	45649	45649	45650
12592	13427	3	applied	\N	\N	\N	\N	45651	45651	45652
12598	13440	0	applied	\N	\N	\N	\N	45687	45687	45688
12598	13441	1	applied	\N	\N	\N	\N	45689	45689	45690
12604	13448	0	applied	\N	\N	\N	\N	45712	45712	45713
12604	13449	1	applied	\N	\N	\N	\N	45714	45714	45715
12604	13450	2	applied	\N	\N	\N	\N	45716	45716	45717
12604	13451	3	applied	\N	\N	\N	\N	45718	45718	45719
12604	13452	4	applied	\N	\N	\N	\N	45720	45720	45721
12604	13453	5	applied	\N	\N	\N	\N	45722	45722	45723
12606	13456	0	applied	\N	\N	\N	\N	45733	45733	45734
12606	13457	1	applied	\N	\N	\N	\N	45735	45735	45736
12608	13458	0	applied	\N	\N	\N	\N	45741	45741	45742
12608	13459	1	applied	\N	\N	\N	\N	45743	45743	45744
12614	13466	0	applied	\N	\N	\N	\N	45764	45764	45765
12614	13467	1	applied	\N	\N	\N	\N	45766	45766	45767
12614	13468	2	applied	\N	\N	\N	\N	45768	45768	45769
12614	13469	3	applied	\N	\N	\N	\N	45770	45770	45771
12614	13470	4	applied	\N	\N	\N	\N	45772	45772	25661
12614	13471	5	applied	\N	\N	\N	\N	45773	45773	45774
12614	13472	6	applied	\N	\N	\N	\N	45775	45775	45776
12614	13473	7	applied	\N	\N	\N	\N	45777	45777	45778
12616	13476	0	applied	\N	\N	\N	\N	45788	45788	45789
12616	13477	1	applied	\N	\N	\N	\N	45790	45790	45791
12619	13482	0	applied	\N	\N	\N	\N	45805	45805	45806
12619	13483	1	applied	\N	\N	\N	\N	45807	45807	45808
12619	13484	2	applied	\N	\N	\N	\N	45809	45809	45810
12619	13485	3	applied	\N	\N	\N	\N	45811	45811	45812
12588	13413	10	applied	\N	\N	\N	\N	45613	45613	45614
12588	13414	11	applied	\N	\N	\N	\N	45615	45615	45616
12588	13415	12	applied	\N	\N	\N	\N	45617	45617	45618
12588	13418	13	applied	\N	\N	\N	\N	45624	45624	45625
12588	13419	14	applied	\N	\N	\N	\N	45626	45626	45627
12588	13421	15	applied	\N	\N	\N	\N	45633	45633	45634
12593	13424	0	applied	\N	\N	\N	\N	45645	45645	45646
12593	13425	1	applied	\N	\N	\N	\N	45647	45647	45648
12593	13426	2	applied	\N	\N	\N	\N	45649	45649	45650
12593	13427	3	applied	\N	\N	\N	\N	45651	45651	45652
12595	13428	0	applied	\N	\N	\N	\N	45657	45657	45658
12595	13429	1	applied	\N	\N	\N	\N	45659	45659	45660
12599	13442	0	applied	\N	\N	\N	\N	45692	45692	45693
12599	13443	1	applied	\N	\N	\N	\N	45694	45694	45695
12602	13446	0	applied	\N	\N	\N	\N	45704	45704	45705
12602	13447	1	applied	\N	\N	\N	\N	45706	45706	45707
12610	13460	0	applied	\N	\N	\N	\N	45746	45746	45747
12610	13461	1	applied	\N	\N	\N	\N	45748	45748	45749
12612	13464	0	applied	\N	\N	\N	\N	45759	45759	45760
12612	13465	1	applied	\N	\N	\N	\N	45761	45761	45762
12615	13474	0	applied	\N	\N	\N	\N	45783	45783	45784
12615	13475	1	applied	\N	\N	\N	\N	45785	45785	45786
12621	13488	0	applied	\N	\N	\N	\N	45819	45819	45820
12621	13489	1	applied	\N	\N	\N	\N	45821	45821	45822
12621	13490	2	applied	\N	\N	\N	\N	45823	45823	45824
12621	13491	3	applied	\N	\N	\N	\N	45825	45825	45826
12621	13492	4	applied	\N	\N	\N	\N	45827	45827	45828
12621	13493	5	applied	\N	\N	\N	\N	45829	45829	45830
12605	13454	0	applied	\N	\N	\N	\N	45727	45727	45728
12605	13455	1	applied	\N	\N	\N	\N	45729	45729	45730
12613	13466	0	applied	\N	\N	\N	\N	45764	45764	45765
12613	13467	1	applied	\N	\N	\N	\N	45766	45766	45767
12613	13468	2	applied	\N	\N	\N	\N	45768	45768	45769
12613	13469	3	applied	\N	\N	\N	\N	45770	45770	45771
12613	13470	4	applied	\N	\N	\N	\N	45772	45772	25661
12613	13471	5	applied	\N	\N	\N	\N	45773	45773	45774
12613	13472	6	applied	\N	\N	\N	\N	45775	45775	45776
12613	13473	7	applied	\N	\N	\N	\N	45777	45777	45778
12618	13478	0	applied	\N	\N	\N	\N	45796	45796	45797
12618	13479	1	applied	\N	\N	\N	\N	45798	45798	45799
12618	13480	2	applied	\N	\N	\N	\N	45800	45800	45801
12618	13481	3	applied	\N	\N	\N	\N	45802	45802	45803
12622	13494	0	applied	\N	\N	\N	\N	45832	45832	45833
12622	13495	1	applied	\N	\N	\N	\N	45834	45834	45835
12622	13496	2	applied	\N	\N	\N	\N	45836	45836	45837
12622	13497	3	applied	\N	\N	\N	\N	45838	45838	45839
12623	13498	0	applied	\N	\N	\N	\N	45842	45842	45843
12623	13499	1	applied	\N	\N	\N	\N	45844	45844	45845
12625	13500	0	applied	\N	\N	\N	\N	45848	45848	45849
12625	13501	1	applied	\N	\N	\N	\N	45850	45850	45851
12626	13500	0	applied	\N	\N	\N	\N	45848	45848	45849
12626	13501	1	applied	\N	\N	\N	\N	45850	45850	45851
12631	13502	0	applied	\N	\N	\N	\N	45855	45855	45856
12631	13503	1	applied	\N	\N	\N	\N	45857	45857	45858
12632	13502	0	applied	\N	\N	\N	\N	45855	45855	45856
12632	13503	1	applied	\N	\N	\N	\N	45857	45857	45858
12633	13502	0	applied	\N	\N	\N	\N	45855	45855	45856
12633	13503	1	applied	\N	\N	\N	\N	45857	45857	45858
12634	13504	0	applied	\N	\N	\N	\N	45862	45862	45863
12634	13505	1	applied	\N	\N	\N	\N	45864	45864	45865
12635	13504	0	applied	\N	\N	\N	\N	45862	45862	45863
12635	13505	1	applied	\N	\N	\N	\N	45864	45864	45865
12636	13504	0	applied	\N	\N	\N	\N	45862	45862	45863
12636	13505	1	applied	\N	\N	\N	\N	45864	45864	45865
12637	13506	0	applied	\N	\N	\N	\N	45869	45869	45870
12637	13507	1	applied	\N	\N	\N	\N	45871	45871	45872
12637	13508	2	applied	\N	\N	\N	\N	45873	45873	45874
12637	13509	3	applied	\N	\N	\N	\N	45875	45875	45876
12637	13510	4	applied	\N	\N	\N	\N	45877	45877	45878
12637	13511	5	applied	\N	\N	\N	\N	45879	45879	45880
12638	13512	0	applied	\N	\N	\N	\N	45883	45883	45884
12638	13513	1	applied	\N	\N	\N	\N	45885	45885	45886
12638	13514	2	applied	\N	\N	\N	\N	45887	45887	45888
12638	13515	3	applied	\N	\N	\N	\N	45889	45889	45890
12638	13516	4	applied	\N	\N	\N	\N	45891	45891	45892
12638	13517	5	applied	\N	\N	\N	\N	45893	45893	45894
12639	13512	0	applied	\N	\N	\N	\N	45883	45883	45884
12639	13513	1	applied	\N	\N	\N	\N	45885	45885	45886
12639	13514	2	applied	\N	\N	\N	\N	45887	45887	45888
12639	13515	3	applied	\N	\N	\N	\N	45889	45889	45890
12639	13516	4	applied	\N	\N	\N	\N	45891	45891	45892
12639	13517	5	applied	\N	\N	\N	\N	45893	45893	45894
12640	13174	0	applied	\N	\N	\N	\N	44900	44900	44802
12640	13180	1	applied	\N	\N	\N	\N	44901	44901	44819
12640	13181	2	applied	\N	\N	\N	\N	44902	44902	44821
12640	13182	3	applied	\N	\N	\N	\N	44903	44903	44823
12640	13115	4	applied	\N	\N	\N	\N	44904	44904	44611
12640	13092	5	applied	\N	\N	\N	\N	45897	45897	44532
12640	13118	6	applied	\N	\N	\N	\N	45898	45898	44619
12640	13131	7	applied	\N	\N	\N	\N	45899	45899	44650
12640	13134	8	applied	\N	\N	\N	\N	45900	45900	44661
12640	13136	9	applied	\N	\N	\N	\N	45901	45901	44669
12640	13138	10	applied	\N	\N	\N	\N	45902	45902	44673
12640	13143	11	applied	\N	\N	\N	\N	45903	45903	44688
12640	13146	12	applied	\N	\N	\N	\N	45904	45904	44698
12640	13148	13	applied	\N	\N	\N	\N	45905	45905	44704
12640	13393	14	applied	\N	\N	\N	\N	45906	45906	45562
12640	13264	15	applied	\N	\N	\N	\N	45179	45179	45180
12640	13107	16	applied	\N	\N	\N	\N	45066	45066	44572
12640	13108	17	applied	\N	\N	\N	\N	45067	45067	44574
12640	13394	18	applied	\N	\N	\N	\N	45907	45907	45564
12640	13109	19	applied	\N	\N	\N	\N	45068	45068	44576
12640	13110	20	applied	\N	\N	\N	\N	45069	45069	44578
12640	13266	21	applied	\N	\N	\N	\N	45185	45185	45186
12640	13268	22	applied	\N	\N	\N	\N	45195	45195	45196
12640	13139	23	applied	\N	\N	\N	\N	44674	44674	44675
12640	13396	24	applied	\N	\N	\N	\N	45908	45908	45568
12640	13397	25	applied	\N	\N	\N	\N	45909	45909	45570
12640	13093	26	applied	\N	\N	\N	\N	44600	44600	44534
12640	13094	27	applied	\N	\N	\N	\N	44601	44601	44536
12640	13095	28	applied	\N	\N	\N	\N	44602	44602	44538
12640	13096	29	applied	\N	\N	\N	\N	44913	44913	44540
12640	13270	30	applied	\N	\N	\N	\N	45202	45202	45203
12640	13273	31	applied	\N	\N	\N	\N	45220	45220	45221
12640	13275	32	applied	\N	\N	\N	\N	45224	45224	45225
12640	13276	33	applied	\N	\N	\N	\N	45226	45226	45227
12640	13277	34	applied	\N	\N	\N	\N	45228	45228	45229
12640	13278	35	applied	\N	\N	\N	\N	45230	45230	45231
12640	13279	36	applied	\N	\N	\N	\N	45232	45232	45233
12640	13285	37	applied	\N	\N	\N	\N	45245	45245	45246
12640	13286	39	applied	\N	\N	\N	\N	45247	45247	45248
12640	13289	40	applied	\N	\N	\N	\N	45255	45255	45256
12640	13291	41	applied	\N	\N	\N	\N	45260	45260	45261
12640	13294	42	applied	\N	\N	\N	\N	45266	45266	45267
12640	13295	43	applied	\N	\N	\N	\N	45268	45268	45269
12640	13298	44	applied	\N	\N	\N	\N	45276	45276	45277
12640	13300	45	applied	\N	\N	\N	\N	45283	45283	45284
12640	13302	46	applied	\N	\N	\N	\N	45289	45289	45290
12640	13304	47	applied	\N	\N	\N	\N	45295	45295	45296
12640	13306	48	applied	\N	\N	\N	\N	45304	45304	45305
12640	13307	49	applied	\N	\N	\N	\N	45306	45306	45307
12640	13310	50	applied	\N	\N	\N	\N	45314	45314	45315
12640	13311	51	applied	\N	\N	\N	\N	45316	45316	45317
12640	13312	52	applied	\N	\N	\N	\N	45318	45318	45319
12640	13316	53	applied	\N	\N	\N	\N	45331	45331	45332
12640	13318	54	applied	\N	\N	\N	\N	45336	45336	45337
12640	13321	55	applied	\N	\N	\N	\N	45347	45347	45348
12640	13322	56	applied	\N	\N	\N	\N	45349	45349	45350
12640	13325	57	applied	\N	\N	\N	\N	45360	45360	45361
12640	13327	58	applied	\N	\N	\N	\N	45366	45366	45367
12640	13328	59	applied	\N	\N	\N	\N	45368	45368	45369
12640	13331	60	applied	\N	\N	\N	\N	45375	45375	45376
12640	13333	61	applied	\N	\N	\N	\N	45383	45383	45384
12640	13334	62	applied	\N	\N	\N	\N	45385	45385	45386
12640	13337	63	applied	\N	\N	\N	\N	45395	45395	45396
12640	13338	64	applied	\N	\N	\N	\N	45397	45397	45398
12640	13342	65	applied	\N	\N	\N	\N	45408	45408	45409
12640	13344	66	applied	\N	\N	\N	\N	45419	45419	45420
12640	13345	67	applied	\N	\N	\N	\N	45421	45421	45422
12640	13348	68	applied	\N	\N	\N	\N	45429	45429	45430
12640	13350	69	applied	\N	\N	\N	\N	45437	45437	45438
12640	13352	70	applied	\N	\N	\N	\N	45443	45443	45444
12640	13353	71	applied	\N	\N	\N	\N	45445	45445	45446
12640	13354	72	applied	\N	\N	\N	\N	45447	45447	45448
12640	13358	73	applied	\N	\N	\N	\N	45457	45457	45458
12640	13360	74	applied	\N	\N	\N	\N	45466	45466	45467
12640	13361	75	applied	\N	\N	\N	\N	45468	45468	45469
12640	13364	76	applied	\N	\N	\N	\N	45478	45478	45479
12640	13366	77	applied	\N	\N	\N	\N	45486	45486	45487
12640	13368	78	applied	\N	\N	\N	\N	45490	45490	45491
12640	13370	79	applied	\N	\N	\N	\N	45496	45496	45497
12640	13372	80	applied	\N	\N	\N	\N	45504	45504	45505
12640	13373	81	applied	\N	\N	\N	\N	45506	45506	45507
12640	13374	82	applied	\N	\N	\N	\N	45508	45508	45509
12640	13375	83	applied	\N	\N	\N	\N	45510	45510	45511
12640	13381	84	applied	\N	\N	\N	\N	45524	45524	45525
12640	13383	85	applied	\N	\N	\N	\N	45533	45533	45534
12640	13385	86	applied	\N	\N	\N	\N	45538	45538	45539
12640	13387	87	applied	\N	\N	\N	\N	45543	45543	45544
12640	13389	88	applied	\N	\N	\N	\N	45551	45551	45552
12640	13390	89	applied	\N	\N	\N	\N	45553	45553	45554
12640	13395	90	applied	\N	\N	\N	\N	45565	45565	45566
12640	13399	91	applied	\N	\N	\N	\N	45577	45577	45578
12640	13405	92	applied	\N	\N	\N	\N	45592	45592	45593
12640	13406	93	applied	\N	\N	\N	\N	45598	45598	45599
12640	13408	94	applied	\N	\N	\N	\N	45603	45603	45604
12640	13409	95	applied	\N	\N	\N	\N	45605	45605	45606
12640	13410	96	applied	\N	\N	\N	\N	45607	45607	45608
12640	13411	97	applied	\N	\N	\N	\N	45609	45609	45610
12640	13416	98	applied	\N	\N	\N	\N	45620	45620	45621
12640	13417	99	applied	\N	\N	\N	\N	45622	45622	45623
12640	13420	100	applied	\N	\N	\N	\N	45631	45631	45632
12640	13422	101	applied	\N	\N	\N	\N	45638	45638	45639
12640	13424	102	applied	\N	\N	\N	\N	45645	45645	45646
12640	13425	103	applied	\N	\N	\N	\N	45647	45647	45648
12640	13428	104	applied	\N	\N	\N	\N	45657	45657	45658
12640	13430	105	applied	\N	\N	\N	\N	45664	45664	45665
12640	13431	106	applied	\N	\N	\N	\N	45666	45666	45667
12640	13432	107	applied	\N	\N	\N	\N	45668	45668	45669
12640	13433	108	applied	\N	\N	\N	\N	45670	45670	45671
12640	13438	109	applied	\N	\N	\N	\N	45681	45681	45682
12640	13440	110	applied	\N	\N	\N	\N	45687	45687	45688
12640	13442	111	applied	\N	\N	\N	\N	45692	45692	45693
12640	13444	112	applied	\N	\N	\N	\N	45698	45698	45911
12640	13446	113	applied	\N	\N	\N	\N	45704	45704	45912
12640	13448	114	applied	\N	\N	\N	\N	45712	45712	45913
12640	13449	115	applied	\N	\N	\N	\N	45714	45714	45914
12640	13450	116	applied	\N	\N	\N	\N	45716	45716	45915
12640	13454	117	applied	\N	\N	\N	\N	45727	45727	45916
12640	13456	118	applied	\N	\N	\N	\N	45733	45733	45917
12640	13458	119	applied	\N	\N	\N	\N	45741	45741	45918
12640	13460	120	applied	\N	\N	\N	\N	45746	45746	45919
12640	13462	121	applied	\N	\N	\N	\N	45753	45753	45920
12640	13464	122	applied	\N	\N	\N	\N	45759	45759	45921
12640	13466	123	applied	\N	\N	\N	\N	45764	45764	45922
12640	13467	124	applied	\N	\N	\N	\N	45766	45766	45923
12640	13468	125	applied	\N	\N	\N	\N	45768	45768	45924
12642	13518	0	applied	\N	\N	\N	\N	45927	45927	45928
12642	13519	1	applied	\N	\N	\N	\N	45929	45929	45930
12646	13522	0	applied	\N	\N	\N	\N	45941	45941	45942
12646	13523	1	applied	\N	\N	\N	\N	45943	45943	45944
12648	13522	0	applied	\N	\N	\N	\N	45941	45941	45942
12648	13523	1	applied	\N	\N	\N	\N	45943	45943	45944
12651	13526	0	applied	\N	\N	\N	\N	45955	45955	45956
12651	13527	1	applied	\N	\N	\N	\N	45957	45957	45958
12651	13528	2	applied	\N	\N	\N	\N	45959	45959	45960
12651	13529	3	applied	\N	\N	\N	\N	45961	45961	25661
12651	13530	4	applied	\N	\N	\N	\N	45962	45962	45963
12651	13531	5	applied	\N	\N	\N	\N	45964	45964	45965
12651	13532	6	applied	\N	\N	\N	\N	45966	45966	45967
12654	13537	0	applied	\N	\N	\N	\N	45982	45982	45983
12654	13538	1	applied	\N	\N	\N	\N	45984	45984	45985
12654	13539	2	applied	\N	\N	\N	\N	45986	45986	45987
12654	13540	3	applied	\N	\N	\N	\N	45988	45988	45989
12654	13541	4	applied	\N	\N	\N	\N	45990	45990	45991
12654	13542	5	applied	\N	\N	\N	\N	45992	45992	45993
12654	13543	6	applied	\N	\N	\N	\N	45994	45994	25661
12661	13550	0	applied	\N	\N	\N	\N	46015	46015	46016
12661	13551	1	applied	\N	\N	\N	\N	46017	46017	25661
12661	13552	2	applied	\N	\N	\N	\N	46018	46018	46019
12661	13553	3	applied	\N	\N	1000000000	\N	46020	46020	46021
12661	13554	4	applied	\N	\N	1000000000	\N	46022	46022	46023
12661	13555	5	applied	\N	\N	1000000000	\N	46024	46024	46025
12664	13556	0	applied	\N	\N	\N	\N	46027	46027	46028
12664	13557	1	applied	\N	\N	\N	\N	46029	46029	46030
12666	13563	0	applied	\N	\N	\N	\N	46045	46045	46046
12666	13564	1	applied	\N	\N	\N	\N	46047	46047	46048
12666	13565	2	applied	\N	\N	\N	\N	46049	46049	25661
12675	13573	0	applied	\N	\N	\N	\N	46074	46074	46075
12675	13574	1	applied	\N	\N	\N	\N	46076	46076	46077
12677	13575	0	applied	\N	\N	\N	\N	46082	46082	46083
12677	13576	1	applied	\N	\N	\N	\N	46084	46084	46085
12677	13577	2	applied	\N	\N	\N	\N	46086	46086	46087
12677	13578	3	applied	\N	\N	\N	\N	46088	46088	46089
12680	13579	0	applied	\N	\N	\N	\N	46094	46094	46095
12680	13580	1	applied	\N	\N	\N	\N	46096	46096	46097
12682	13585	0	applied	\N	\N	\N	\N	46114	46114	46115
12682	13586	1	applied	\N	\N	\N	\N	46116	46116	46117
12684	13587	0	applied	\N	\N	\N	\N	46122	46122	46123
12684	13588	1	applied	\N	\N	\N	\N	46124	46124	46125
12691	13593	0	applied	\N	\N	\N	\N	46144	46144	46145
12691	13594	1	applied	\N	\N	\N	\N	46146	46146	46147
12701	13606	0	applied	\N	\N	\N	\N	46184	46184	46185
12701	13607	1	applied	\N	\N	\N	\N	46186	46186	46187
12701	13608	2	applied	\N	\N	\N	\N	46188	46188	46189
12701	13609	3	applied	\N	\N	\N	\N	46190	46190	46191
12703	13610	0	applied	\N	\N	\N	\N	46195	46195	46196
12703	13611	1	applied	\N	\N	\N	\N	46197	46197	46198
12706	13612	0	applied	\N	\N	\N	\N	46203	46203	46204
12706	13613	1	applied	\N	\N	\N	\N	46205	46205	46206
12708	13612	0	applied	\N	\N	\N	\N	46203	46203	46204
12708	13613	1	applied	\N	\N	\N	\N	46205	46205	46206
12711	13614	0	applied	\N	\N	\N	\N	46214	46214	46215
12711	13615	1	applied	\N	\N	\N	\N	46216	46216	46217
12711	13616	2	applied	\N	\N	\N	\N	46218	46218	46219
12711	13617	3	applied	\N	\N	\N	\N	46220	46220	46221
12712	13618	0	applied	\N	\N	\N	\N	46227	46227	46228
12641	13518	0	applied	\N	\N	\N	\N	45927	45927	45928
12641	13519	1	applied	\N	\N	\N	\N	45929	45929	45930
12644	13518	0	applied	\N	\N	\N	\N	45927	45927	45928
12644	13520	1	applied	\N	\N	\N	\N	45935	45935	45936
12644	13519	2	applied	\N	\N	\N	\N	45929	45929	45930
12645	13520	0	applied	\N	\N	\N	\N	45935	45935	45936
12645	13521	1	applied	\N	\N	\N	\N	45938	45938	45939
12653	13535	0	applied	\N	\N	\N	\N	45976	45976	45977
12653	13536	1	applied	\N	\N	\N	\N	45978	45978	45979
12663	13557	0	applied	\N	\N	\N	\N	46029	46029	46030
12665	13558	0	applied	\N	\N	\N	\N	46035	46035	46036
12665	13559	1	applied	\N	\N	\N	\N	46037	46037	46038
12665	13560	2	applied	\N	\N	\N	\N	46039	46039	25661
12665	13561	3	applied	\N	\N	\N	\N	46040	46040	46041
12665	13562	4	applied	\N	\N	\N	\N	46042	46042	46043
12672	13568	0	applied	\N	\N	\N	\N	46061	46061	46062
12672	13569	1	applied	\N	\N	\N	\N	46063	46063	46064
12672	13570	2	applied	\N	\N	\N	\N	46065	46065	46066
12672	13571	3	applied	\N	\N	\N	\N	46067	46067	46068
12672	13572	4	applied	\N	\N	\N	\N	46069	46069	25661
12674	13573	0	applied	\N	\N	\N	\N	46074	46074	46075
12674	13574	1	applied	\N	\N	\N	\N	46076	46076	46077
12679	13579	0	applied	\N	\N	\N	\N	46094	46094	46095
12679	13580	1	applied	\N	\N	\N	\N	46096	46096	46097
12681	13581	0	applied	\N	\N	\N	\N	46102	46102	46103
12681	13582	1	applied	\N	\N	\N	\N	46104	46104	46105
12681	13583	3	applied	\N	\N	\N	\N	46107	46107	46108
12681	13584	4	applied	\N	\N	\N	\N	46109	46109	46110
12693	13593	0	applied	\N	\N	\N	\N	46144	46144	46145
12695	13595	0	applied	\N	\N	\N	\N	46153	46153	46154
12695	13594	1	applied	\N	\N	\N	\N	46146	46146	46147
12698	13600	0	applied	\N	\N	\N	\N	46168	46168	46169
12698	13601	1	applied	\N	\N	\N	\N	46170	46170	46171
12700	13604	0	applied	\N	\N	\N	\N	46180	46180	46181
12700	13605	1	applied	\N	\N	\N	\N	46182	46182	46183
12705	13612	0	applied	\N	\N	\N	\N	46203	46203	46204
12705	13613	1	applied	\N	\N	\N	\N	46205	46205	46206
12710	13614	0	applied	\N	\N	\N	\N	46214	46214	46215
12710	13615	1	applied	\N	\N	\N	\N	46216	46216	46217
12710	13616	2	applied	\N	\N	\N	\N	46218	46218	46219
12710	13617	3	applied	\N	\N	\N	\N	46220	46220	46221
12715	13620	0	applied	\N	\N	\N	\N	46235	46235	46236
12715	13621	1	applied	\N	\N	\N	\N	46237	46237	46238
12715	13622	2	applied	\N	\N	\N	\N	46239	46239	46240
12715	13623	3	applied	\N	\N	\N	\N	46241	46241	46242
12715	13624	4	applied	\N	\N	\N	\N	46243	46243	46244
12715	13625	5	applied	\N	\N	\N	\N	46245	46245	46246
12717	13620	0	applied	\N	\N	\N	\N	46235	46235	46236
12717	13621	1	applied	\N	\N	\N	\N	46237	46237	46238
12717	13622	2	applied	\N	\N	\N	\N	46239	46239	46240
12717	13623	3	applied	\N	\N	\N	\N	46241	46241	46242
12717	13624	4	applied	\N	\N	\N	\N	46243	46243	46244
12717	13625	5	applied	\N	\N	\N	\N	46245	46245	46246
12721	13641	0	applied	\N	\N	\N	\N	46287	46287	46288
12721	13642	1	applied	\N	\N	\N	\N	46289	46289	46290
12724	13643	0	applied	\N	\N	\N	\N	46293	46293	46294
12724	13644	1	applied	\N	\N	\N	\N	46295	46295	46296
12724	13645	2	applied	\N	\N	\N	\N	46297	46297	46298
12724	13646	3	applied	\N	\N	\N	\N	46299	46299	46300
12729	13628	0	applied	\N	\N	\N	\N	46258	46258	25661
12729	13536	1	applied	\N	\N	\N	\N	45978	45978	45979
12729	13540	2	applied	\N	\N	\N	\N	45988	45988	45989
12729	13541	3	applied	\N	\N	\N	\N	45990	45990	45991
12729	13542	4	applied	\N	\N	\N	\N	45992	45992	45993
12729	13545	5	applied	\N	\N	\N	\N	46001	46001	46002
12729	13548	6	applied	\N	\N	\N	\N	46009	46009	46010
12729	13552	7	applied	\N	\N	\N	\N	46018	46018	46019
12729	13553	8	applied	\N	\N	1000000000	\N	46020	46020	46021
12729	13554	9	applied	\N	\N	1000000000	\N	46022	46022	46023
12729	13555	10	applied	\N	\N	1000000000	\N	46024	46024	46025
12729	13557	11	applied	\N	\N	\N	\N	46029	46029	46030
12729	13561	12	applied	\N	\N	\N	\N	46040	46040	46041
12729	13562	13	applied	\N	\N	\N	\N	46042	46042	46043
12729	13564	14	applied	\N	\N	\N	\N	46047	46047	46048
12729	13567	15	applied	\N	\N	\N	\N	46057	46057	46058
12729	13570	16	applied	\N	\N	\N	\N	46065	46065	46066
12729	13571	17	applied	\N	\N	\N	\N	46067	46067	46068
12729	13574	18	applied	\N	\N	\N	\N	46076	46076	46077
12729	13577	19	applied	\N	\N	\N	\N	46086	46086	46087
12729	13578	20	applied	\N	\N	\N	\N	46088	46088	46089
12729	13580	21	applied	\N	\N	\N	\N	46096	46096	46097
12729	13583	22	applied	\N	\N	\N	\N	46107	46107	46108
12729	13584	23	applied	\N	\N	\N	\N	46109	46109	46110
12729	13586	24	applied	\N	\N	\N	\N	46116	46116	46117
12729	13588	25	applied	\N	\N	\N	\N	46124	46124	46125
12729	13590	26	applied	\N	\N	\N	\N	46133	46133	46134
12729	13592	27	applied	\N	\N	\N	\N	46138	46138	46139
12729	13594	28	applied	\N	\N	\N	\N	46146	46146	46147
12729	13598	29	applied	\N	\N	\N	\N	46162	46162	46163
12729	13599	30	applied	\N	\N	\N	\N	46164	46164	46165
12729	13601	31	applied	\N	\N	\N	\N	46170	46170	46171
12729	13603	32	applied	\N	\N	\N	\N	46176	46176	46177
12729	13605	33	applied	\N	\N	\N	\N	46182	46182	46183
12729	13608	34	applied	\N	\N	\N	\N	46188	46188	46189
12729	13609	35	applied	\N	\N	\N	\N	46190	46190	46191
12729	13611	36	applied	\N	\N	\N	\N	46197	46197	46198
12729	13613	37	applied	\N	\N	\N	\N	46205	46205	46206
12729	13616	38	applied	\N	\N	\N	\N	46218	46218	46219
12729	13617	39	applied	\N	\N	\N	\N	46220	46220	46221
12729	13619	40	applied	\N	\N	\N	\N	46229	46229	46230
12729	13623	41	applied	\N	\N	\N	\N	46241	46241	46242
12729	13624	42	applied	\N	\N	\N	\N	46243	46243	46244
12729	13625	43	applied	\N	\N	\N	\N	46245	46245	46246
12729	13629	44	applied	\N	\N	\N	\N	46259	46259	46260
12729	13630	45	applied	\N	\N	\N	\N	46261	46261	46262
12729	13633	46	applied	\N	\N	\N	\N	46269	46269	46270
12729	13634	47	applied	\N	\N	\N	\N	46271	46271	46272
12729	13638	48	applied	\N	\N	\N	\N	46281	46281	46282
12729	13639	49	applied	\N	\N	\N	\N	46283	46283	46284
12729	13640	50	applied	\N	\N	\N	\N	46285	46285	46286
12729	13642	51	applied	\N	\N	\N	\N	46289	46289	46290
12729	13645	52	applied	\N	\N	\N	\N	46297	46297	46298
12729	13646	53	applied	\N	\N	\N	\N	46299	46299	46300
12729	13648	54	applied	\N	\N	\N	\N	46312	46312	46313
12729	13652	55	applied	\N	\N	\N	\N	46322	46322	46323
12729	13653	56	applied	\N	\N	\N	\N	46324	46324	46325
12729	13654	57	applied	\N	\N	\N	\N	46326	46326	46327
12729	13656	58	applied	\N	\N	\N	\N	46331	46331	46332
12731	13657	0	applied	\N	\N	\N	\N	46339	46339	46340
12643	13518	0	applied	\N	\N	\N	\N	45927	45927	45928
12643	13519	1	applied	\N	\N	\N	\N	45929	45929	45930
12647	13522	0	applied	\N	\N	\N	\N	45941	45941	45942
12647	13523	1	applied	\N	\N	\N	\N	45943	45943	45944
12655	13537	0	applied	\N	\N	\N	\N	45982	45982	45983
12655	13538	1	applied	\N	\N	\N	\N	45984	45984	45985
12655	13539	2	applied	\N	\N	\N	\N	45986	45986	45987
12655	13540	3	applied	\N	\N	\N	\N	45988	45988	45989
12655	13541	4	applied	\N	\N	\N	\N	45990	45990	45991
12655	13542	5	applied	\N	\N	\N	\N	45992	45992	45993
12655	13543	6	applied	\N	\N	\N	\N	45994	45994	25661
12657	13544	0	applied	\N	\N	\N	\N	45999	45999	46000
12657	13545	1	applied	\N	\N	\N	\N	46001	46001	46002
12657	13546	2	applied	\N	\N	\N	\N	46003	46003	25661
12659	13547	0	applied	\N	\N	\N	\N	46007	46007	46008
12659	13548	1	applied	\N	\N	\N	\N	46009	46009	46010
12659	13549	2	applied	\N	\N	\N	\N	46011	46011	25661
12667	13563	0	applied	\N	\N	\N	\N	46045	46045	46046
12667	13564	1	applied	\N	\N	\N	\N	46047	46047	46048
12667	13565	2	applied	\N	\N	\N	\N	46049	46049	25661
12670	13566	0	applied	\N	\N	\N	\N	46055	46055	46056
12670	13567	1	applied	\N	\N	\N	\N	46057	46057	46058
12683	13585	0	applied	\N	\N	\N	\N	46114	46114	46115
12683	13586	1	applied	\N	\N	\N	\N	46116	46116	46117
12685	13587	0	applied	\N	\N	\N	\N	46122	46122	46123
12685	13588	1	applied	\N	\N	\N	\N	46124	46124	46125
12687	13589	0	applied	\N	\N	\N	\N	46131	46131	46132
12687	13590	1	applied	\N	\N	\N	\N	46133	46133	46134
12689	13591	0	applied	\N	\N	\N	\N	46136	46136	46137
12689	13592	1	applied	\N	\N	\N	\N	46138	46138	46139
12692	13593	0	applied	\N	\N	\N	\N	46144	46144	46145
12692	13594	1	applied	\N	\N	\N	\N	46146	46146	46147
12696	13596	0	applied	\N	\N	\N	\N	46158	46158	46159
12696	13597	1	applied	\N	\N	\N	\N	46160	46160	46161
12696	13598	2	applied	\N	\N	\N	\N	46162	46162	46163
12696	13599	3	applied	\N	\N	\N	\N	46164	46164	46165
12702	13606	0	applied	\N	\N	\N	\N	46184	46184	46185
12702	13607	1	applied	\N	\N	\N	\N	46186	46186	46187
12702	13608	2	applied	\N	\N	\N	\N	46188	46188	46189
12702	13609	3	applied	\N	\N	\N	\N	46190	46190	46191
12704	13610	0	applied	\N	\N	\N	\N	46195	46195	46196
12704	13611	1	applied	\N	\N	\N	\N	46197	46197	46198
12707	13612	0	applied	\N	\N	\N	\N	46203	46203	46204
12707	13613	1	applied	\N	\N	\N	\N	46205	46205	46206
12713	13618	0	applied	\N	\N	\N	\N	46227	46227	46228
12713	13619	1	applied	\N	\N	\N	\N	46229	46229	46230
12719	13631	0	applied	\N	\N	\N	\N	46265	46265	46266
12719	13632	1	applied	\N	\N	\N	\N	46267	46267	46268
12719	13633	2	applied	\N	\N	\N	\N	46269	46269	46270
12719	13634	3	applied	\N	\N	\N	\N	46271	46271	46272
12720	13635	0	applied	\N	\N	\N	\N	46275	46275	46276
12720	13636	1	applied	\N	\N	\N	\N	46277	46277	46278
12720	13637	2	applied	\N	\N	\N	\N	46279	46279	46280
12720	13638	3	applied	\N	\N	\N	\N	46281	46281	46282
12720	13639	4	applied	\N	\N	\N	\N	46283	46283	46284
12720	13640	5	applied	\N	\N	\N	\N	46285	46285	46286
12723	13643	0	applied	\N	\N	\N	\N	46293	46293	46294
12723	13644	1	applied	\N	\N	\N	\N	46295	46295	46296
12723	13645	2	applied	\N	\N	\N	\N	46297	46297	46298
12723	13646	3	applied	\N	\N	\N	\N	46299	46299	46300
12730	13655	0	applied	\N	\N	\N	\N	46329	46329	46330
12730	13656	1	applied	\N	\N	\N	\N	46331	46331	46332
12740	13664	0	applied	\N	\N	\N	\N	46360	46360	46361
12740	13665	1	applied	\N	\N	\N	\N	46362	46362	46363
12741	13666	0	applied	\N	\N	\N	\N	46369	46369	46370
12741	13667	1	applied	\N	\N	\N	\N	46371	46371	46372
12752	13680	0	applied	\N	\N	\N	\N	46413	46413	46414
12752	13681	1	applied	\N	\N	\N	\N	46415	46415	46416
12752	13682	2	applied	\N	\N	\N	\N	46417	46417	46418
12752	13684	3	applied	\N	\N	\N	\N	46423	46423	46424
12752	13685	4	applied	\N	\N	\N	\N	46425	46425	46426
12752	13686	5	applied	\N	\N	\N	\N	46427	46427	46428
12752	13687	6	applied	\N	\N	\N	\N	46429	46429	46430
12752	13688	7	applied	\N	\N	\N	\N	46431	46431	46432
12752	13689	8	applied	\N	\N	\N	\N	46433	46433	46434
12752	13683	9	applied	\N	\N	\N	\N	46419	46419	46420
12754	13690	0	applied	\N	\N	\N	\N	46438	46438	46439
12754	13691	1	applied	\N	\N	\N	\N	46440	46440	46441
12754	13692	2	applied	\N	\N	\N	\N	46442	46442	46443
12754	13693	3	applied	\N	\N	\N	\N	46444	46444	46445
12754	13694	4	applied	\N	\N	\N	\N	46446	46446	46447
12754	13695	5	applied	\N	\N	\N	\N	46448	46448	46449
12754	13696	6	applied	\N	\N	\N	\N	46450	46450	46451
12754	13697	7	applied	\N	\N	\N	\N	46452	46452	46453
12754	13698	8	applied	\N	\N	\N	\N	46454	46454	46455
12754	13699	9	applied	\N	\N	\N	\N	46456	46456	46457
12754	13700	10	applied	\N	\N	\N	\N	46458	46458	46459
12757	13705	0	applied	\N	\N	\N	\N	46473	46473	46474
12757	13706	1	applied	\N	\N	\N	\N	46475	46475	46476
12757	13707	2	applied	\N	\N	\N	\N	46477	46477	46478
12757	13708	3	applied	\N	\N	\N	\N	46479	46479	46480
12762	13716	0	applied	\N	\N	\N	\N	46500	46500	46501
12762	13717	1	applied	\N	\N	\N	\N	46502	46502	46503
12762	13718	2	applied	\N	\N	\N	\N	46504	46504	46505
12762	13719	3	applied	\N	\N	\N	\N	46506	46506	46507
12770	13732	0	applied	\N	\N	\N	\N	46539	46539	46540
12770	13733	1	applied	\N	\N	\N	\N	46541	46541	46542
12773	13732	0	applied	\N	\N	\N	\N	46539	46539	46540
12773	13733	1	applied	\N	\N	\N	\N	46541	46541	46542
12773	13735	2	applied	\N	\N	\N	\N	46546	46546	46547
12782	13739	0	applied	\N	\N	\N	\N	46568	46568	46569
12782	13740	1	applied	\N	\N	\N	\N	46570	46570	46571
12782	13741	3	applied	\N	\N	\N	\N	46573	46573	46574
12782	13742	4	applied	\N	\N	\N	\N	46575	46575	46576
12782	13743	5	applied	\N	\N	1000000000	\N	46577	46577	46578
12782	13744	6	applied	\N	\N	\N	\N	46579	46579	46580
12782	13745	7	applied	\N	\N	\N	\N	46581	46581	46582
12799	13778	0	applied	\N	\N	\N	\N	46673	46673	46674
12799	13779	1	applied	\N	\N	\N	\N	46675	46675	46676
12805	13785	0	applied	\N	\N	\N	\N	46694	46694	46695
12805	13786	1	applied	\N	\N	\N	\N	46697	46697	46698
12806	13787	0	applied	\N	\N	\N	\N	46700	46700	46701
12806	13788	1	applied	\N	\N	\N	\N	46702	46702	46703
12811	13791	0	applied	\N	\N	\N	\N	46714	46714	46715
12816	13797	0	applied	\N	\N	\N	\N	46733	46733	46734
12824	13804	0	applied	\N	\N	\N	\N	46757	46757	46758
12827	13806	0	applied	\N	\N	\N	\N	46764	46764	46765
12829	13788	0	applied	\N	\N	\N	\N	46702	46702	46703
12829	13790	1	applied	\N	\N	\N	\N	46711	46711	46712
12831	13808	0	applied	\N	\N	\N	\N	46775	46775	46776
12649	13524	0	applied	\N	\N	\N	\N	45949	45949	45950
12649	13525	1	applied	\N	\N	\N	\N	45951	45951	45952
12650	13526	0	applied	\N	\N	\N	\N	45955	45955	45956
12650	13527	1	applied	\N	\N	\N	\N	45957	45957	45958
12650	13528	2	applied	\N	\N	\N	\N	45959	45959	45960
12650	13529	3	applied	\N	\N	\N	\N	45961	45961	25661
12650	13530	4	applied	\N	\N	\N	\N	45962	45962	45963
12650	13531	5	applied	\N	\N	\N	\N	45964	45964	45965
12650	13532	6	applied	\N	\N	\N	\N	45966	45966	45967
12652	13533	0	applied	\N	\N	\N	\N	45970	45970	45971
12652	13534	1	applied	\N	\N	\N	\N	45972	45972	45973
12656	13537	0	applied	\N	\N	\N	\N	45982	45982	45983
12656	13538	1	applied	\N	\N	\N	\N	45984	45984	45985
12656	13539	2	applied	\N	\N	\N	\N	45986	45986	45987
12656	13540	3	applied	\N	\N	\N	\N	45988	45988	45989
12656	13541	4	applied	\N	\N	\N	\N	45990	45990	45991
12656	13542	5	applied	\N	\N	\N	\N	45992	45992	45993
12656	13543	6	applied	\N	\N	\N	\N	45994	45994	25661
12658	13544	0	applied	\N	\N	\N	\N	45999	45999	46000
12658	13545	1	applied	\N	\N	\N	\N	46001	46001	46002
12658	13546	2	applied	\N	\N	\N	\N	46003	46003	25661
12660	13547	0	applied	\N	\N	\N	\N	46007	46007	46008
12660	13548	1	applied	\N	\N	\N	\N	46009	46009	46010
12660	13549	2	applied	\N	\N	\N	\N	46011	46011	25661
12662	13556	0	applied	\N	\N	\N	\N	46027	46027	46028
12662	13557	1	applied	\N	\N	\N	\N	46029	46029	46030
12668	13563	0	applied	\N	\N	\N	\N	46045	46045	46046
12668	13564	1	applied	\N	\N	\N	\N	46047	46047	46048
12668	13565	2	applied	\N	\N	\N	\N	46049	46049	25661
12671	13568	0	applied	\N	\N	\N	\N	46061	46061	46062
12671	13569	1	applied	\N	\N	\N	\N	46063	46063	46064
12671	13570	2	applied	\N	\N	\N	\N	46065	46065	46066
12671	13571	3	applied	\N	\N	\N	\N	46067	46067	46068
12671	13572	4	applied	\N	\N	\N	\N	46069	46069	25661
12673	13568	0	applied	\N	\N	\N	\N	46061	46061	46062
12673	13569	1	applied	\N	\N	\N	\N	46063	46063	46064
12673	13570	2	applied	\N	\N	\N	\N	46065	46065	46066
12673	13571	3	applied	\N	\N	\N	\N	46067	46067	46068
12673	13572	4	applied	\N	\N	\N	\N	46069	46069	25661
12676	13575	0	applied	\N	\N	\N	\N	46082	46082	46083
12676	13576	1	applied	\N	\N	\N	\N	46084	46084	46085
12676	13577	2	applied	\N	\N	\N	\N	46086	46086	46087
12676	13578	3	applied	\N	\N	\N	\N	46088	46088	46089
12678	13579	0	applied	\N	\N	\N	\N	46094	46094	46095
12678	13580	1	applied	\N	\N	\N	\N	46096	46096	46097
12686	13587	0	applied	\N	\N	\N	\N	46122	46122	46123
12688	13589	0	applied	\N	\N	\N	\N	46131	46131	46132
12688	13590	1	applied	\N	\N	\N	\N	46133	46133	46134
12690	13591	0	applied	\N	\N	\N	\N	46136	46136	46137
12690	13592	1	applied	\N	\N	\N	\N	46138	46138	46139
12694	13595	0	applied	\N	\N	\N	\N	46153	46153	46154
12694	13594	1	applied	\N	\N	\N	\N	46146	46146	46147
12697	13600	0	applied	\N	\N	\N	\N	46168	46168	46169
12697	13601	1	applied	\N	\N	\N	\N	46170	46170	46171
12699	13602	0	applied	\N	\N	\N	\N	46174	46174	46175
12699	13603	1	applied	\N	\N	\N	\N	46176	46176	46177
12709	13614	0	applied	\N	\N	\N	\N	46214	46214	46215
12709	13615	1	applied	\N	\N	\N	\N	46216	46216	46217
12709	13616	2	applied	\N	\N	\N	\N	46218	46218	46219
12709	13617	3	applied	\N	\N	\N	\N	46220	46220	46221
12714	13620	0	applied	\N	\N	\N	\N	46235	46235	46236
12714	13621	1	applied	\N	\N	\N	\N	46237	46237	46238
12714	13622	2	applied	\N	\N	\N	\N	46239	46239	46240
12714	13623	3	applied	\N	\N	\N	\N	46241	46241	46242
12714	13624	4	applied	\N	\N	\N	\N	46243	46243	46244
12714	13625	5	applied	\N	\N	\N	\N	46245	46245	46246
12725	13393	0	applied	\N	\N	\N	\N	45561	45561	45562
12725	13264	1	applied	\N	\N	\N	\N	45179	45179	45180
12725	13394	2	applied	\N	\N	\N	\N	45563	45563	45564
12725	13266	3	applied	\N	\N	\N	\N	45185	45185	45186
12725	13268	4	applied	\N	\N	\N	\N	45195	45195	45196
12725	13396	5	applied	\N	\N	\N	\N	45567	45567	45568
12725	13397	6	applied	\N	\N	\N	\N	45569	45569	45570
12725	13270	7	applied	\N	\N	\N	\N	45202	45202	45203
12725	13273	8	applied	\N	\N	\N	\N	45220	45220	45221
12725	13275	9	applied	\N	\N	\N	\N	45224	45224	45225
12725	13276	10	applied	\N	\N	\N	\N	45226	45226	45227
12725	13277	11	applied	\N	\N	\N	\N	45228	45228	45229
12725	13278	12	applied	\N	\N	\N	\N	45230	45230	45231
12725	13279	13	applied	\N	\N	\N	\N	45232	45232	45233
12725	13285	14	applied	\N	\N	\N	\N	45245	45245	45246
12725	13286	15	applied	\N	\N	\N	\N	45247	45247	45248
12725	13289	16	applied	\N	\N	\N	\N	45255	45255	45256
12725	13291	17	applied	\N	\N	\N	\N	45260	45260	45261
12725	13294	18	applied	\N	\N	\N	\N	45266	45266	45267
12725	13295	19	applied	\N	\N	\N	\N	45268	45268	45269
12725	13298	20	applied	\N	\N	\N	\N	45276	45276	45277
12725	13300	21	applied	\N	\N	\N	\N	45283	45283	45284
12725	13302	22	applied	\N	\N	\N	\N	45289	45289	45290
12725	13304	23	applied	\N	\N	\N	\N	45295	45295	45296
12725	13306	24	applied	\N	\N	\N	\N	45304	45304	45305
12725	13307	25	applied	\N	\N	\N	\N	45306	45306	45307
12725	13310	26	applied	\N	\N	\N	\N	45314	45314	45315
12725	13311	27	applied	\N	\N	\N	\N	45316	45316	45317
12725	13312	28	applied	\N	\N	\N	\N	45318	45318	45319
12725	13316	29	applied	\N	\N	\N	\N	45331	45331	45332
12725	13318	30	applied	\N	\N	\N	\N	45336	45336	45337
12725	13321	31	applied	\N	\N	\N	\N	45347	45347	45348
12725	13322	32	applied	\N	\N	\N	\N	45349	45349	45350
12725	13325	33	applied	\N	\N	\N	\N	45360	45360	45361
12725	13327	34	applied	\N	\N	\N	\N	45366	45366	45367
12728	13655	0	applied	\N	\N	\N	\N	46329	46329	46330
12728	13656	1	applied	\N	\N	\N	\N	46331	46331	46332
12737	13664	0	applied	\N	\N	\N	\N	46360	46360	46361
12737	13665	1	applied	\N	\N	\N	\N	46362	46362	46363
12744	13670	0	applied	\N	\N	\N	\N	46382	46382	46383
12744	13671	1	applied	\N	\N	\N	\N	46384	46384	46385
12746	13670	0	applied	\N	\N	\N	\N	46382	46382	46383
12746	13671	1	applied	\N	\N	\N	\N	46384	46384	46385
12753	13680	0	applied	\N	\N	\N	\N	46413	46413	46414
12753	13681	1	applied	\N	\N	\N	\N	46415	46415	46416
12753	13682	2	applied	\N	\N	\N	\N	46417	46417	46418
12753	13684	3	applied	\N	\N	\N	\N	46423	46423	46424
12753	13685	4	applied	\N	\N	\N	\N	46425	46425	46426
12753	13686	5	applied	\N	\N	\N	\N	46427	46427	46428
12753	13687	6	applied	\N	\N	\N	\N	46429	46429	46430
12753	13688	7	applied	\N	\N	\N	\N	46431	46431	46432
12753	13689	8	applied	\N	\N	\N	\N	46433	46433	46434
12753	13683	9	applied	\N	\N	\N	\N	46419	46419	46420
12755	13690	0	applied	\N	\N	\N	\N	46438	46438	46439
12712	13619	1	applied	\N	\N	\N	\N	46229	46229	46230
12716	13393	0	applied	\N	\N	\N	\N	45561	45561	45562
12716	13385	1	applied	\N	\N	\N	\N	45538	45538	45539
12716	13387	2	applied	\N	\N	\N	\N	45543	45543	45544
12716	13389	3	applied	\N	\N	\N	\N	45551	45551	45552
12716	13394	4	applied	\N	\N	\N	\N	45563	45563	45564
12716	13396	5	applied	\N	\N	\N	\N	45567	45567	45568
12716	13397	6	applied	\N	\N	\N	\N	45569	45569	45570
12716	13390	7	applied	\N	\N	\N	\N	45553	45553	45554
12716	13395	8	applied	\N	\N	\N	\N	45565	45565	45566
12716	13399	9	applied	\N	\N	\N	\N	45577	45577	45578
12716	13405	10	applied	\N	\N	\N	\N	45592	45592	45593
12716	13406	11	applied	\N	\N	\N	\N	45598	45598	45599
12716	13408	12	applied	\N	\N	\N	\N	45603	45603	45604
12716	13409	13	applied	\N	\N	\N	\N	45605	45605	45606
12716	13410	14	applied	\N	\N	\N	\N	45607	45607	45608
12716	13411	15	applied	\N	\N	\N	\N	45609	45609	45610
12716	13416	16	applied	\N	\N	\N	\N	45620	45620	45621
12716	13417	17	applied	\N	\N	\N	\N	45622	45622	45623
12716	13420	18	applied	\N	\N	\N	\N	45631	45631	45632
12716	13422	19	applied	\N	\N	\N	\N	45638	45638	45639
12716	13424	20	applied	\N	\N	\N	\N	45645	45645	45646
12716	13425	21	applied	\N	\N	\N	\N	45647	45647	45648
12716	13428	22	applied	\N	\N	\N	\N	45657	45657	45658
12716	13430	23	applied	\N	\N	\N	\N	45664	45664	45665
12716	13431	24	applied	\N	\N	\N	\N	45666	45666	45667
12716	13432	25	applied	\N	\N	\N	\N	45668	45668	45669
12716	13433	26	applied	\N	\N	\N	\N	45670	45670	45671
12716	13438	27	applied	\N	\N	\N	\N	45681	45681	45682
12716	13440	28	applied	\N	\N	\N	\N	45687	45687	45688
12716	13442	29	applied	\N	\N	\N	\N	45692	45692	45693
12716	13444	30	applied	\N	\N	\N	\N	45698	45698	45911
12716	13446	31	applied	\N	\N	\N	\N	45704	45704	45912
12716	13448	32	applied	\N	\N	\N	\N	45712	45712	45913
12716	13449	33	applied	\N	\N	\N	\N	45714	45714	45914
12716	13450	34	applied	\N	\N	\N	\N	45716	45716	45915
12716	13454	35	applied	\N	\N	\N	\N	45727	45727	45916
12716	13456	36	applied	\N	\N	\N	\N	45733	45733	45917
12716	13458	37	applied	\N	\N	\N	\N	45741	45741	45918
12716	13460	38	applied	\N	\N	\N	\N	45746	45746	45919
12716	13462	39	applied	\N	\N	\N	\N	45753	45753	45920
12716	13464	40	applied	\N	\N	\N	\N	45759	45759	45921
12716	13466	41	applied	\N	\N	\N	\N	45764	45764	45922
12716	13386	42	applied	\N	\N	\N	\N	45540	45540	45541
12716	13470	43	applied	\N	\N	\N	\N	45772	45772	25661
12716	13388	44	applied	\N	\N	\N	\N	45545	45545	45546
12716	13391	45	applied	\N	\N	\N	\N	45555	45555	45556
12716	13392	46	applied	\N	\N	\N	\N	45557	45557	45558
12716	13398	47	applied	\N	\N	\N	\N	45571	45571	45572
12716	13529	48	applied	\N	\N	\N	\N	45961	45961	25661
12716	13400	49	applied	\N	\N	\N	\N	45579	45579	45580
12716	13401	50	applied	\N	\N	\N	\N	45581	45581	45582
12716	13402	51	applied	\N	\N	\N	\N	45583	45583	45584
12716	13403	52	applied	\N	\N	\N	\N	45585	45585	45586
12716	13471	53	applied	\N	\N	\N	\N	45773	45773	45774
12716	13404	54	applied	\N	\N	\N	\N	45587	45587	45588
12716	13407	55	applied	\N	\N	\N	\N	45600	45600	45601
12716	13412	56	applied	\N	\N	\N	\N	45611	45611	45612
12716	13413	57	applied	\N	\N	\N	\N	45613	45613	45614
12716	13543	58	applied	\N	\N	\N	\N	45994	45994	25661
12716	13546	59	applied	\N	\N	\N	\N	46003	46003	25661
12716	13549	60	applied	\N	\N	\N	\N	46011	46011	25661
12716	13551	62	applied	\N	\N	\N	\N	46017	46017	25661
12716	13560	63	applied	\N	\N	\N	\N	46039	46039	25661
12716	13565	64	applied	\N	\N	\N	\N	46049	46049	25661
12716	13572	65	applied	\N	\N	\N	\N	46069	46069	25661
12716	13414	66	applied	\N	\N	\N	\N	45615	45615	45616
12716	13415	67	applied	\N	\N	\N	\N	45617	45617	45618
12716	13418	68	applied	\N	\N	\N	\N	45624	45624	45625
12716	13419	69	applied	\N	\N	\N	\N	45626	45626	45627
12716	13421	70	applied	\N	\N	\N	\N	45633	45633	45634
12716	13423	71	applied	\N	\N	\N	\N	45640	45640	45641
12716	13426	72	applied	\N	\N	\N	\N	45649	45649	45650
12716	13427	73	applied	\N	\N	\N	\N	45651	45651	45652
12716	13429	74	applied	\N	\N	\N	\N	45659	45659	45660
12716	13434	75	applied	\N	\N	\N	\N	45672	45672	45673
12716	13435	76	applied	\N	\N	\N	\N	45674	45674	45675
12716	13436	77	applied	\N	\N	\N	\N	45676	45676	45677
12716	13437	78	applied	\N	\N	\N	\N	45678	45678	45679
12716	13439	79	applied	\N	\N	\N	\N	45683	45683	45684
12716	13441	80	applied	\N	\N	\N	\N	45689	45689	45690
12716	13443	81	applied	\N	\N	\N	\N	45694	45694	45695
12716	13445	82	applied	\N	\N	\N	\N	45700	45700	45701
12716	13447	83	applied	\N	\N	\N	\N	45706	45706	45707
12716	13451	84	applied	\N	\N	\N	\N	45718	45718	45719
12716	13452	85	applied	\N	\N	\N	\N	45720	45720	45721
12716	13453	86	applied	\N	\N	\N	\N	45722	45722	45723
12716	13455	87	applied	\N	\N	\N	\N	45729	45729	45730
12716	13457	88	applied	\N	\N	\N	\N	45735	45735	45736
12716	13459	89	applied	\N	\N	\N	\N	45743	45743	45744
12716	13461	90	applied	\N	\N	\N	\N	45748	45748	45749
12716	13463	91	applied	\N	\N	\N	\N	45755	45755	45756
12716	13465	92	applied	\N	\N	\N	\N	45761	45761	45762
12716	13469	93	applied	\N	\N	\N	\N	45770	45770	45771
12716	13472	94	applied	\N	\N	\N	\N	45775	45775	45776
12716	13473	95	applied	\N	\N	\N	\N	45777	45777	45778
12716	13475	96	applied	\N	\N	\N	\N	45785	45785	45786
12716	13477	97	applied	\N	\N	\N	\N	45790	45790	45791
12716	13480	98	applied	\N	\N	\N	\N	45800	45800	45801
12716	13481	99	applied	\N	\N	\N	\N	45802	45802	45803
12716	13484	100	applied	\N	\N	\N	\N	45809	45809	45810
12716	13485	101	applied	\N	\N	\N	\N	45811	45811	45812
12716	13487	102	applied	\N	\N	\N	\N	45816	45816	45817
12716	13491	103	applied	\N	\N	\N	\N	45825	45825	45826
12716	13492	104	applied	\N	\N	\N	\N	45827	45827	45828
12716	13493	105	applied	\N	\N	\N	\N	45829	45829	45830
12716	13496	106	applied	\N	\N	\N	\N	45836	45836	45837
12716	13497	107	applied	\N	\N	\N	\N	45838	45838	45839
12716	13499	108	applied	\N	\N	\N	\N	45844	45844	45845
12716	13501	109	applied	\N	\N	\N	\N	45850	45850	45851
12716	13503	110	applied	\N	\N	\N	\N	45857	45857	45858
12716	13505	111	applied	\N	\N	\N	\N	45864	45864	45865
12716	13509	112	applied	\N	\N	\N	\N	45875	45875	45876
12716	13510	113	applied	\N	\N	\N	\N	45877	45877	45878
12716	13511	114	applied	\N	\N	\N	\N	45879	45879	45880
12716	13515	115	applied	\N	\N	\N	\N	45889	45889	45890
12716	13516	116	applied	\N	\N	\N	\N	45891	45891	45892
12716	13517	117	applied	\N	\N	\N	\N	45893	45893	45894
12716	13519	118	applied	\N	\N	\N	\N	45929	45929	45930
12716	13521	119	applied	\N	\N	\N	\N	45938	45938	45939
12716	13523	120	applied	\N	\N	\N	\N	45943	45943	45944
12716	13525	121	applied	\N	\N	\N	\N	45951	45951	45952
12716	13530	122	applied	\N	\N	\N	\N	45962	45962	45963
12716	13531	123	applied	\N	\N	\N	\N	45964	45964	45965
12716	13532	124	applied	\N	\N	\N	\N	45966	45966	45967
12716	13534	125	applied	\N	\N	\N	\N	45972	45972	45973
12718	13626	0	applied	\N	\N	\N	\N	46254	46254	46255
12718	13627	1	applied	\N	\N	\N	\N	46256	46256	46257
12718	13628	2	applied	\N	\N	\N	\N	46258	46258	25661
12718	13629	3	applied	\N	\N	\N	\N	46259	46259	46260
12718	13630	4	applied	\N	\N	\N	\N	46261	46261	46262
12722	13643	0	applied	\N	\N	\N	\N	46293	46293	46294
12722	13644	1	applied	\N	\N	\N	\N	46295	46295	46296
12722	13645	2	applied	\N	\N	\N	\N	46297	46297	46298
12722	13646	3	applied	\N	\N	\N	\N	46299	46299	46300
12726	13647	0	applied	\N	\N	\N	\N	46310	46310	46311
12726	13648	1	applied	\N	\N	\N	\N	46312	46312	46313
12727	13649	0	applied	\N	\N	\N	\N	46316	46316	46317
12727	13650	1	applied	\N	\N	\N	\N	46318	46318	46319
12727	13651	2	applied	\N	\N	\N	\N	46320	46320	46321
12727	13652	3	applied	\N	\N	\N	\N	46322	46322	46323
12727	13653	4	applied	\N	\N	\N	\N	46324	46324	46325
12727	13654	5	applied	\N	\N	\N	\N	46326	46326	46327
12732	13657	0	applied	\N	\N	\N	\N	46339	46339	46340
12732	13658	1	applied	\N	\N	\N	\N	46343	46343	46344
12734	13657	0	applied	\N	\N	\N	\N	46339	46339	46340
12734	13658	1	applied	\N	\N	\N	\N	46343	46343	46344
12736	13659	0	applied	\N	\N	\N	\N	46349	46349	46350
12736	13660	1	applied	\N	\N	\N	\N	46351	46351	46352
12736	13661	2	applied	\N	\N	1000000000	\N	46353	46353	46354
12736	13658	3	applied	\N	\N	\N	\N	46343	46343	46344
12736	13662	4	applied	\N	\N	\N	\N	46355	46355	46356
12736	13663	5	applied	\N	\N	\N	\N	46357	46357	46358
12739	13664	0	applied	\N	\N	\N	\N	46360	46360	46361
12739	13665	1	applied	\N	\N	\N	\N	46362	46362	46363
12743	13668	0	applied	\N	\N	\N	\N	46374	46374	46375
12743	13669	1	applied	\N	\N	\N	\N	46376	46376	46377
12748	13672	0	applied	\N	\N	\N	\N	46392	46392	46393
12748	13673	1	applied	\N	\N	\N	\N	46394	46394	46395
12748	13674	2	applied	\N	\N	\N	\N	46396	46396	46396
12748	13675	3	applied	\N	\N	\N	\N	46397	46397	46398
12748	13676	4	applied	\N	\N	\N	\N	46399	46399	46400
12751	13680	0	applied	\N	\N	\N	\N	46413	46413	46414
12751	13681	1	applied	\N	\N	\N	\N	46415	46415	46416
12751	13682	2	applied	\N	\N	\N	\N	46417	46417	46418
12751	13683	3	applied	\N	\N	\N	\N	46419	46419	46420
12756	13701	0	applied	\N	\N	\N	\N	46463	46463	46464
12756	13702	1	applied	\N	\N	\N	\N	46465	46465	46466
12756	13703	2	applied	\N	\N	\N	\N	46467	46467	46468
12756	13704	3	applied	\N	\N	\N	\N	46469	46469	46470
12767	13728	0	applied	\N	\N	\N	\N	46528	46528	46529
12767	13729	1	applied	\N	\N	\N	\N	46530	46530	46531
12772	13734	0	applied	\N	\N	\N	\N	46544	46544	46545
12772	13735	1	applied	\N	\N	\N	\N	46546	46546	46547
12775	13734	0	applied	\N	\N	\N	\N	46544	46544	46545
12775	13735	1	applied	\N	\N	\N	\N	46546	46546	46547
12780	13738	0	applied	\N	\N	\N	\N	46564	46564	46565
12781	13739	0	applied	\N	\N	\N	\N	46568	46568	46569
12781	13740	1	applied	\N	\N	\N	\N	46570	46570	46571
12781	13741	3	applied	\N	\N	\N	\N	46573	46573	46574
12781	13742	4	applied	\N	\N	\N	\N	46575	46575	46576
12781	13743	5	applied	\N	\N	1000000000	\N	46577	46577	46578
12781	13744	6	applied	\N	\N	\N	\N	46579	46579	46580
12781	13745	7	applied	\N	\N	\N	\N	46581	46581	46582
12784	13746	0	applied	\N	\N	\N	\N	46589	46589	46590
12784	13747	1	applied	\N	\N	\N	\N	46591	46591	46592
12784	13748	2	applied	\N	\N	\N	\N	46593	46593	46594
12784	13749	3	applied	\N	\N	\N	\N	46595	46595	46596
12792	13759	0	applied	\N	\N	\N	\N	46624	46624	46625
12792	13761	1	applied	\N	\N	\N	\N	46628	46628	46629
12792	13762	2	applied	\N	\N	\N	\N	46630	46630	46631
12792	13763	3	applied	\N	\N	\N	\N	46632	46632	46633
12792	13764	4	applied	\N	\N	\N	\N	46634	46634	46635
12792	13760	5	applied	\N	\N	\N	\N	46626	46626	46627
12792	13765	6	applied	\N	\N	\N	\N	46637	46637	46638
12792	13766	7	applied	\N	\N	\N	\N	46639	46639	46640
12792	13767	8	applied	\N	\N	\N	\N	46641	46641	46642
12794	13768	0	applied	\N	\N	\N	\N	46644	46644	46645
12794	13770	1	applied	\N	\N	\N	\N	46648	46648	46649
12796	13771	0	applied	\N	\N	\N	\N	46651	46651	46652
12796	13760	1	applied	\N	\N	\N	\N	46626	46626	46627
12796	13765	2	applied	\N	\N	\N	\N	46637	46637	46638
12796	13766	3	applied	\N	\N	\N	\N	46639	46639	46640
12796	13767	4	applied	\N	\N	\N	\N	46641	46641	46642
12796	13769	5	applied	\N	\N	\N	\N	46646	46646	46647
12801	13780	0	applied	\N	\N	\N	\N	46680	46680	46681
12801	13781	1	applied	\N	\N	\N	\N	46682	46682	46683
12801	13782	2	applied	\N	\N	\N	\N	46684	46684	46685
12804	13785	0	applied	\N	\N	\N	\N	46694	46694	46695
12804	13786	1	applied	\N	\N	\N	\N	46697	46697	46698
12808	13787	0	applied	\N	\N	\N	\N	46700	46700	46701
12808	13788	1	applied	\N	\N	\N	\N	46702	46702	46703
12814	13792	0	applied	\N	\N	\N	\N	46717	46717	46718
12814	13793	1	applied	\N	\N	\N	\N	46719	46719	46720
12814	13794	2	applied	\N	\N	\N	\N	46721	46721	46722
12821	13801	0	applied	\N	\N	\N	\N	46747	46747	46748
12821	13802	1	applied	\N	\N	\N	\N	46749	46749	46750
12826	13806	0	applied	\N	\N	\N	\N	46764	46764	46765
12828	13807	0	applied	\N	\N	\N	\N	46768	46768	46769
12830	13807	0	applied	\N	\N	\N	\N	46768	46768	46769
12837	13809	0	applied	\N	\N	\N	\N	46784	46784	46785
12839	13810	0	applied	\N	\N	\N	\N	46796	46796	46797
12846	13817	0	applied	\N	\N	\N	\N	46819	46819	46820
12846	13818	1	applied	\N	\N	\N	\N	46821	46821	46822
12848	13788	0	applied	\N	\N	\N	\N	46702	46702	46703
12848	13732	1	applied	\N	\N	\N	\N	46539	46539	46540
12848	13734	2	applied	\N	\N	\N	\N	46544	46544	46545
12848	13737	3	applied	\N	\N	\N	\N	46558	46558	46559
12848	13739	4	applied	\N	\N	\N	\N	46568	46568	46569
12848	13740	5	applied	\N	\N	\N	\N	46570	46570	46571
12848	13741	6	applied	\N	\N	\N	\N	46573	46573	46574
12848	13746	7	applied	\N	\N	\N	\N	46589	46589	46590
12848	13747	8	applied	\N	\N	\N	\N	46591	46591	46592
12848	13750	9	applied	\N	\N	\N	\N	46601	46601	46602
12848	13751	10	applied	\N	\N	\N	\N	46603	46603	46604
12848	13754	11	applied	\N	\N	\N	\N	46610	46610	46611
12848	13756	12	applied	\N	\N	\N	\N	46616	46616	46617
12848	13759	13	applied	\N	\N	\N	\N	46624	46624	46625
12848	13790	14	applied	\N	\N	\N	\N	46711	46711	46712
12733	13657	0	applied	\N	\N	\N	\N	46339	46339	46340
12733	13658	1	applied	\N	\N	\N	\N	46343	46343	46344
12738	13664	0	applied	\N	\N	\N	\N	46360	46360	46361
12742	13668	0	applied	\N	\N	\N	\N	46374	46374	46375
12742	13669	1	applied	\N	\N	\N	\N	46376	46376	46377
12745	13670	0	applied	\N	\N	\N	\N	46382	46382	46383
12745	13671	1	applied	\N	\N	\N	\N	46384	46384	46385
12747	13672	0	applied	\N	\N	\N	\N	46392	46392	46393
12747	13673	1	applied	\N	\N	\N	\N	46394	46394	46395
12747	13674	2	applied	\N	\N	\N	\N	46396	46396	46396
12747	13675	3	applied	\N	\N	\N	\N	46397	46397	46398
12747	13676	4	applied	\N	\N	\N	\N	46399	46399	46400
12749	13672	0	applied	\N	\N	\N	\N	46392	46392	46393
12749	13673	1	applied	\N	\N	\N	\N	46394	46394	46395
12749	13674	2	applied	\N	\N	\N	\N	46396	46396	46396
12750	13677	0	applied	\N	\N	\N	\N	46405	46405	46406
12750	13678	1	applied	\N	\N	\N	\N	46407	46407	46408
12750	13679	2	applied	\N	\N	\N	\N	46409	46409	46410
12750	13675	3	applied	\N	\N	\N	\N	46397	46397	46398
12750	13676	4	applied	\N	\N	\N	\N	46399	46399	46400
12759	13705	0	applied	\N	\N	\N	\N	46473	46473	46474
12759	13706	1	applied	\N	\N	\N	\N	46475	46475	46476
12759	13707	2	applied	\N	\N	\N	\N	46477	46477	46478
12759	13708	3	applied	\N	\N	\N	\N	46479	46479	46480
12761	13714	0	applied	\N	\N	\N	\N	46495	46495	46496
12761	13715	1	applied	\N	\N	\N	\N	46497	46497	46498
12764	13722	0	applied	\N	\N	\N	\N	46515	46515	46516
12764	13723	1	applied	\N	\N	\N	\N	46517	46517	46518
12764	13724	2	applied	\N	\N	\N	\N	46519	46519	46520
12764	13725	3	applied	\N	\N	\N	\N	46521	46521	46522
12764	13726	4	applied	\N	\N	\N	\N	46523	46523	46524
12764	13727	5	applied	\N	\N	\N	\N	46525	46525	46526
12769	13730	0	applied	\N	\N	\N	\N	46532	46532	46533
12769	13731	1	applied	\N	\N	\N	\N	46534	46534	46535
12771	13734	0	applied	\N	\N	\N	\N	46544	46544	46545
12771	13735	1	applied	\N	\N	\N	\N	46546	46546	46547
12778	13737	0	applied	\N	\N	\N	\N	46558	46558	46559
12778	13736	1	applied	\N	\N	\N	\N	46554	46554	46555
12783	13746	0	applied	\N	\N	\N	\N	46589	46589	46590
12783	13747	1	applied	\N	\N	\N	\N	46591	46591	46592
12783	13748	2	applied	\N	\N	\N	\N	46593	46593	46594
12783	13749	3	applied	\N	\N	\N	\N	46595	46595	46596
12788	13756	0	applied	\N	\N	\N	\N	46616	46616	46617
12788	13757	1	applied	\N	\N	\N	\N	46618	46618	46619
12788	13758	2	applied	\N	\N	\N	\N	46620	46620	46621
12791	13759	0	applied	\N	\N	\N	\N	46624	46624	46625
12791	13761	1	applied	\N	\N	\N	\N	46628	46628	46629
12791	13762	2	applied	\N	\N	\N	\N	46630	46630	46631
12791	13763	3	applied	\N	\N	\N	\N	46632	46632	46633
12791	13764	4	applied	\N	\N	\N	\N	46634	46634	46635
12793	13768	0	applied	\N	\N	\N	\N	46644	46644	46645
12793	13760	1	applied	\N	\N	\N	\N	46626	46626	46627
12793	13765	2	applied	\N	\N	\N	\N	46637	46637	46638
12793	13766	3	applied	\N	\N	\N	\N	46639	46639	46640
12793	13767	4	applied	\N	\N	\N	\N	46641	46641	46642
12793	13769	5	applied	\N	\N	\N	\N	46646	46646	46647
12793	13770	6	applied	\N	\N	\N	\N	46648	46648	46649
12798	13776	0	applied	\N	\N	\N	\N	46667	46667	46668
12798	13777	1	applied	\N	\N	\N	\N	46669	46669	46670
12803	13785	0	applied	\N	\N	\N	\N	46694	46694	46695
12813	13792	0	applied	\N	\N	\N	\N	46717	46717	46718
12813	13793	1	applied	\N	\N	\N	\N	46719	46719	46720
12813	13794	2	applied	\N	\N	\N	\N	46721	46721	46722
12815	13795	0	applied	\N	\N	\N	\N	46727	46727	46728
12815	13796	1	applied	\N	\N	\N	\N	46729	46729	46730
12818	13798	0	applied	\N	\N	\N	\N	46737	46737	46738
12820	13800	0	applied	\N	\N	\N	\N	46743	46743	46744
12823	13803	0	applied	\N	\N	\N	\N	46752	46752	46753
12825	13805	0	applied	\N	\N	\N	\N	46761	46761	46762
12833	13808	0	applied	\N	\N	\N	\N	46775	46775	46776
12835	13808	0	applied	\N	\N	\N	\N	46775	46775	46776
12836	13809	0	applied	\N	\N	\N	\N	46784	46784	46785
12838	13809	0	applied	\N	\N	\N	\N	46784	46784	46785
12841	13811	0	applied	\N	\N	1000000000	\N	46799	46799	46800
12841	13812	1	applied	\N	\N	\N	\N	46801	46801	46802
12841	13813	2	applied	\N	\N	1000000000	\N	46803	46803	46804
12841	13814	3	applied	\N	\N	\N	\N	46805	46805	46806
12844	13815	0	applied	\N	\N	\N	\N	46810	46810	46811
12844	13816	1	applied	\N	\N	\N	\N	46812	46812	46813
12845	13817	0	applied	\N	\N	\N	\N	46819	46819	46820
12845	13818	1	applied	\N	\N	\N	\N	46821	46821	46822
12862	13833	0	applied	\N	\N	\N	\N	46872	46872	46873
12868	13856	0	applied	\N	\N	\N	\N	46931	46931	46932
12868	13857	1	applied	\N	\N	\N	\N	46933	46933	46934
12868	13858	2	applied	\N	\N	\N	\N	46935	46935	46936
12868	13859	3	applied	\N	\N	\N	\N	46937	46937	46938
12868	13860	4	applied	\N	\N	\N	\N	46939	46939	46940
12868	13861	5	applied	\N	\N	\N	\N	46941	46941	46942
12868	13862	6	applied	\N	\N	\N	\N	46943	46943	46944
12868	13863	7	applied	\N	\N	\N	\N	46945	46945	46946
12871	13875	0	applied	\N	\N	\N	\N	46971	46971	46972
12871	13876	1	applied	\N	\N	\N	\N	46973	46973	46974
12878	13881	0	applied	\N	\N	\N	\N	46990	46990	46991
12878	13882	1	applied	\N	\N	\N	\N	46992	46992	46993
12889	13889	0	applied	\N	\N	\N	\N	47019	47019	47020
12889	13890	1	applied	\N	\N	\N	\N	47021	47021	47022
12893	13891	0	applied	\N	\N	\N	\N	47025	47025	47026
12893	13892	1	applied	\N	\N	\N	\N	47027	47027	47028
12900	13899	0	applied	\N	\N	\N	\N	47051	47051	47052
12900	13900	1	applied	\N	\N	\N	\N	47053	47053	47054
12903	13901	0	applied	\N	\N	\N	\N	47056	47056	47057
12903	13902	1	applied	\N	\N	\N	\N	47058	47058	47059
12903	13903	2	applied	\N	\N	\N	\N	47060	47060	47061
12903	13904	3	applied	\N	\N	\N	\N	47062	47062	47063
12913	13914	0	applied	\N	\N	\N	\N	47097	47097	47098
12913	13915	1	applied	\N	\N	\N	\N	47099	47099	47100
12913	13916	2	applied	\N	\N	\N	\N	47101	47101	47102
12913	13917	3	applied	\N	\N	\N	\N	47103	47103	47104
12913	13918	4	applied	\N	\N	\N	\N	47105	47105	47106
12913	13919	5	applied	\N	\N	\N	\N	47107	47107	47108
12913	13920	6	applied	\N	\N	\N	\N	47109	47109	47110
12913	13921	7	applied	\N	\N	\N	\N	47111	47111	47112
12915	13922	0	applied	\N	\N	\N	\N	47118	47118	47119
12915	13923	1	applied	\N	\N	\N	\N	47120	47120	47121
12921	13930	0	applied	\N	\N	\N	\N	47143	47143	47144
12921	13931	1	applied	\N	\N	\N	\N	47145	47145	47146
12923	13934	0	applied	\N	\N	\N	\N	47155	47155	47156
12923	13935	1	applied	\N	\N	\N	\N	47157	47157	47158
12926	13936	0	applied	\N	\N	\N	\N	47163	47163	47164
12755	13691	1	applied	\N	\N	\N	\N	46440	46440	46441
12755	13692	2	applied	\N	\N	\N	\N	46442	46442	46443
12755	13693	3	applied	\N	\N	\N	\N	46444	46444	46445
12755	13694	4	applied	\N	\N	\N	\N	46446	46446	46447
12755	13695	5	applied	\N	\N	\N	\N	46448	46448	46449
12755	13696	6	applied	\N	\N	\N	\N	46450	46450	46451
12755	13697	7	applied	\N	\N	\N	\N	46452	46452	46453
12755	13698	8	applied	\N	\N	\N	\N	46454	46454	46455
12755	13699	9	applied	\N	\N	\N	\N	46456	46456	46457
12755	13700	10	applied	\N	\N	\N	\N	46458	46458	46459
12758	13705	0	applied	\N	\N	\N	\N	46473	46473	46474
12758	13706	1	applied	\N	\N	\N	\N	46475	46475	46476
12758	13707	2	applied	\N	\N	\N	\N	46477	46477	46478
12758	13708	3	applied	\N	\N	\N	\N	46479	46479	46480
12760	13709	0	applied	\N	\N	\N	\N	46484	46484	46485
12760	13710	1	applied	\N	\N	\N	\N	46486	46486	46487
12760	13711	2	applied	\N	\N	\N	\N	46488	46488	46489
12760	13712	3	applied	\N	\N	1000000000	\N	46490	46490	46491
12760	13713	4	applied	\N	\N	\N	\N	46492	46492	46493
12763	13720	0	applied	\N	\N	\N	\N	46509	46509	46510
12763	13721	1	applied	\N	\N	\N	\N	46511	46511	46512
12768	13730	0	applied	\N	\N	\N	\N	46532	46532	46533
12768	13731	1	applied	\N	\N	\N	\N	46534	46534	46535
12774	13734	0	applied	\N	\N	\N	\N	46544	46544	46545
12774	13735	1	applied	\N	\N	\N	\N	46546	46546	46547
12776	13734	0	applied	\N	\N	\N	\N	46544	46544	46545
12776	13735	1	applied	\N	\N	\N	\N	46546	46546	46547
12777	13736	0	applied	\N	\N	\N	\N	46554	46554	46555
12779	13737	0	applied	\N	\N	\N	\N	46558	46558	46559
12779	13736	1	applied	\N	\N	\N	\N	46554	46554	46555
12785	13750	0	applied	\N	\N	\N	\N	46601	46601	46602
12785	13751	1	applied	\N	\N	\N	\N	46603	46603	46604
12785	13752	2	applied	\N	\N	\N	\N	46605	46605	46606
12785	13753	3	applied	\N	\N	\N	\N	46607	46607	46608
12787	13750	0	applied	\N	\N	\N	\N	46601	46601	46602
12787	13751	1	applied	\N	\N	\N	\N	46603	46603	46604
12787	13754	2	applied	\N	\N	\N	\N	46610	46610	46611
12787	13752	3	applied	\N	\N	\N	\N	46605	46605	46606
12787	13753	4	applied	\N	\N	\N	\N	46607	46607	46608
12787	13755	5	applied	\N	\N	\N	\N	46612	46612	46613
12790	13759	0	applied	\N	\N	\N	\N	46624	46624	46625
12790	13760	1	applied	\N	\N	\N	\N	46626	46626	46627
12795	13771	0	applied	\N	\N	\N	\N	46651	46651	46652
12795	13760	1	applied	\N	\N	\N	\N	46626	46626	46627
12795	13765	2	applied	\N	\N	\N	\N	46637	46637	46638
12795	13766	3	applied	\N	\N	\N	\N	46639	46639	46640
12795	13767	4	applied	\N	\N	\N	\N	46641	46641	46642
12795	13769	5	applied	\N	\N	\N	\N	46646	46646	46647
12795	13772	6	applied	\N	\N	\N	\N	46653	46653	46654
12797	13773	0	applied	\N	\N	\N	\N	46659	46659	46660
12797	13774	1	applied	\N	\N	\N	\N	46661	46661	46662
12797	13775	2	applied	\N	\N	\N	\N	46663	46663	46664
12800	13778	0	applied	\N	\N	\N	\N	46673	46673	46674
12800	13779	1	applied	\N	\N	\N	\N	46675	46675	46676
12802	13783	0	applied	\N	\N	\N	\N	46688	46688	46689
12802	13784	1	applied	\N	\N	\N	\N	46690	46690	46691
12807	13787	0	applied	\N	\N	\N	\N	46700	46700	46701
12807	13788	1	applied	\N	\N	\N	\N	46702	46702	46703
12807	13786	2	applied	\N	\N	\N	\N	46697	46697	46698
12809	13789	0	applied	\N	\N	\N	\N	46709	46709	46710
12809	13790	1	applied	\N	\N	\N	\N	46711	46711	46712
12809	13786	2	applied	\N	\N	\N	\N	46697	46697	46698
12812	13792	0	applied	\N	\N	\N	\N	46717	46717	46718
12812	13793	1	applied	\N	\N	\N	\N	46719	46719	46720
12812	13794	2	applied	\N	\N	\N	\N	46721	46721	46722
12819	13799	0	applied	\N	\N	\N	\N	46740	46740	46741
12822	13803	0	applied	\N	\N	\N	\N	46752	46752	46753
12832	13808	0	applied	\N	\N	\N	\N	46775	46775	46776
12840	13811	0	applied	\N	\N	1000000000	\N	46799	46799	46800
12840	13812	1	applied	\N	\N	\N	\N	46801	46801	46802
12840	13813	2	applied	\N	\N	1000000000	\N	46803	46803	46804
12840	13814	3	applied	\N	\N	\N	\N	46805	46805	46806
12843	13815	0	applied	\N	\N	\N	\N	46810	46810	46811
12843	13816	1	applied	\N	\N	\N	\N	46812	46812	46813
12847	13819	0	applied	\N	\N	\N	\N	46824	46824	46825
12847	13820	1	applied	\N	\N	\N	\N	46826	46826	46827
12849	13821	0	applied	\N	\N	\N	\N	46833	46833	46834
12849	13822	1	applied	\N	\N	\N	\N	46835	46835	46836
12852	13823	0	applied	\N	\N	\N	\N	46840	46840	46841
12852	13824	1	applied	\N	\N	\N	\N	46842	46842	46843
12854	13825	0	applied	\N	\N	\N	\N	46848	46848	46849
12854	13826	1	applied	\N	\N	\N	\N	46850	46850	46851
12857	13829	0	applied	\N	\N	\N	\N	46860	46860	46861
12857	13830	1	applied	\N	\N	\N	\N	46862	46862	46863
12857	13831	2	applied	\N	\N	\N	\N	46864	46864	46865
12857	13832	3	applied	\N	\N	\N	\N	46866	46866	46867
12859	13833	0	applied	\N	\N	\N	\N	46872	46872	46873
12859	13834	1	applied	\N	\N	\N	\N	46874	46874	46875
12866	13850	0	applied	\N	\N	\N	\N	46918	46918	46919
12866	13851	1	applied	\N	\N	\N	\N	46920	46920	46921
12866	13852	2	applied	\N	\N	\N	\N	46922	46922	46923
12866	13853	3	applied	\N	\N	\N	\N	46924	46924	46925
12866	13854	4	applied	\N	\N	\N	\N	46926	46926	46927
12866	13855	5	applied	\N	\N	\N	\N	46928	46928	46929
12867	13856	0	applied	\N	\N	\N	\N	46931	46931	46932
12867	13857	1	applied	\N	\N	\N	\N	46933	46933	46934
12867	13858	2	applied	\N	\N	\N	\N	46935	46935	46936
12867	13859	3	applied	\N	\N	\N	\N	46937	46937	46938
12867	13860	4	applied	\N	\N	\N	\N	46939	46939	46940
12867	13861	5	applied	\N	\N	\N	\N	46941	46941	46942
12867	13862	6	applied	\N	\N	\N	\N	46943	46943	46944
12867	13863	7	applied	\N	\N	\N	\N	46945	46945	46946
12870	13873	0	applied	\N	\N	\N	\N	46967	46967	46968
12870	13874	1	applied	\N	\N	\N	\N	46969	46969	46970
12873	13875	0	applied	\N	\N	\N	\N	46971	46971	46972
12873	13876	1	applied	\N	\N	\N	\N	46973	46973	46974
12876	13877	0	applied	\N	\N	\N	\N	46978	46978	46979
12876	13878	1	applied	\N	\N	\N	\N	46980	46980	46981
12876	13879	2	applied	\N	\N	\N	\N	46982	46982	46983
12876	13880	3	applied	\N	\N	\N	\N	46984	46984	46985
12877	13881	0	applied	\N	\N	\N	\N	46990	46990	46991
12877	13882	1	applied	\N	\N	\N	\N	46992	46992	46993
12880	13821	0	applied	\N	\N	\N	\N	46833	46833	46834
12880	13823	1	applied	\N	\N	\N	\N	46840	46840	46841
12880	13825	2	applied	\N	\N	\N	\N	46848	46848	46849
12880	13827	3	applied	\N	\N	\N	\N	46856	46856	46857
12880	13829	4	applied	\N	\N	\N	\N	46860	46860	46861
12880	13830	5	applied	\N	\N	\N	\N	46862	46862	46863
12880	13833	6	applied	\N	\N	\N	\N	46872	46872	46873
12834	13808	0	applied	\N	\N	\N	\N	46775	46775	46776
12842	13815	0	applied	\N	\N	\N	\N	46810	46810	46811
12842	13816	1	applied	\N	\N	\N	\N	46812	46812	46813
12851	13823	0	applied	\N	\N	\N	\N	46840	46840	46841
12851	13824	1	applied	\N	\N	\N	\N	46842	46842	46843
12853	13825	0	applied	\N	\N	\N	\N	46848	46848	46849
12853	13826	1	applied	\N	\N	\N	\N	46850	46850	46851
12856	13829	0	applied	\N	\N	\N	\N	46860	46860	46861
12856	13830	1	applied	\N	\N	\N	\N	46862	46862	46863
12856	13831	2	applied	\N	\N	\N	\N	46864	46864	46865
12856	13832	3	applied	\N	\N	\N	\N	46866	46866	46867
12858	13833	0	applied	\N	\N	\N	\N	46872	46872	46873
12858	13834	1	applied	\N	\N	\N	\N	46874	46874	46875
12861	13835	0	applied	\N	\N	\N	\N	46879	46879	46880
12861	13836	1	applied	\N	\N	\N	\N	46881	46881	46882
12861	13837	2	applied	\N	\N	\N	\N	46883	46883	46884
12861	13838	3	applied	\N	\N	1000000000	\N	46885	46885	46886
12861	13839	4	applied	\N	\N	\N	\N	46887	46887	46888
12861	13840	5	applied	\N	\N	\N	\N	46889	46889	46890
12861	13841	6	applied	\N	\N	\N	\N	46891	46891	46892
12861	13842	7	applied	\N	\N	\N	\N	46893	46893	46894
12865	13843	0	applied	\N	\N	\N	\N	46901	46901	46902
12865	13844	1	applied	\N	\N	\N	\N	46903	46903	46904
12865	13845	2	applied	\N	\N	\N	\N	46905	46905	46906
12865	13846	3	applied	\N	\N	\N	\N	46907	46907	46908
12865	13847	4	applied	\N	\N	1000000000	\N	46909	46909	46910
12865	13848	5	applied	\N	\N	\N	\N	46911	46911	46912
12865	13849	6	applied	\N	\N	\N	\N	46913	46913	46914
12872	13875	0	applied	\N	\N	\N	\N	46971	46971	46972
12872	13876	1	applied	\N	\N	\N	\N	46973	46973	46974
12875	13877	0	applied	\N	\N	\N	\N	46978	46978	46979
12875	13878	1	applied	\N	\N	\N	\N	46980	46980	46981
12875	13879	2	applied	\N	\N	\N	\N	46982	46982	46983
12875	13880	3	applied	\N	\N	\N	\N	46984	46984	46985
12879	13883	0	applied	\N	\N	\N	\N	46997	46997	46998
12879	13884	1	applied	\N	\N	\N	\N	46999	46999	47000
12881	13885	0	applied	\N	\N	\N	\N	47006	47006	47007
12881	13886	1	applied	\N	\N	\N	\N	47008	47008	47009
12897	13895	0	applied	\N	\N	\N	\N	47038	47038	47039
12897	13896	1	applied	\N	\N	\N	\N	47040	47040	47041
12902	13901	0	applied	\N	\N	\N	\N	47056	47056	47057
12902	13902	1	applied	\N	\N	\N	\N	47058	47058	47059
12902	13903	2	applied	\N	\N	\N	\N	47060	47060	47061
12902	13904	3	applied	\N	\N	\N	\N	47062	47062	47063
12907	13907	0	applied	\N	\N	\N	\N	47075	47075	47076
12907	13908	1	applied	\N	\N	\N	\N	47077	47077	47078
12907	13909	2	applied	\N	\N	\N	\N	47079	47079	47080
12907	13910	3	applied	\N	\N	\N	\N	47081	47081	47082
12909	13912	0	applied	\N	\N	\N	\N	47089	47089	47090
12912	13914	0	applied	\N	\N	\N	\N	47097	47097	47098
12912	13915	1	applied	\N	\N	\N	\N	47099	47099	47100
12912	13916	2	applied	\N	\N	\N	\N	47101	47101	47102
12912	13917	3	applied	\N	\N	\N	\N	47103	47103	47104
12912	13918	4	applied	\N	\N	\N	\N	47105	47105	47106
12912	13919	5	applied	\N	\N	\N	\N	47107	47107	47108
12912	13920	6	applied	\N	\N	\N	\N	47109	47109	47110
12912	13921	7	applied	\N	\N	\N	\N	47111	47111	47112
12918	13924	0	applied	\N	\N	\N	\N	47127	47127	47128
12918	13925	1	applied	\N	\N	\N	\N	47129	47129	47130
12918	13926	2	applied	\N	\N	\N	\N	47131	47131	47132
12918	13927	3	applied	\N	\N	\N	\N	47133	47133	47134
12920	13930	0	applied	\N	\N	\N	\N	47143	47143	47144
12920	13931	1	applied	\N	\N	\N	\N	47145	47145	47146
12922	13932	0	applied	\N	\N	\N	\N	47149	47149	47150
12922	13933	1	applied	\N	\N	\N	\N	47151	47151	47152
12925	13936	0	applied	\N	\N	\N	\N	47163	47163	47164
12925	13937	1	applied	\N	\N	\N	\N	47165	47165	47166
12925	13938	2	applied	\N	\N	\N	\N	47167	47167	47168
12925	13939	3	applied	\N	\N	\N	\N	47169	47169	47170
12927	13940	0	applied	\N	\N	\N	\N	47175	47175	47176
12927	13941	1	applied	\N	\N	\N	\N	47177	47177	47178
12934	13946	0	applied	\N	\N	\N	\N	47196	47196	47197
12934	13947	1	applied	\N	\N	\N	\N	47198	47198	47199
12935	13948	0	applied	\N	\N	\N	\N	47202	47202	47203
12935	13949	1	applied	\N	\N	\N	\N	47204	47204	47205
12935	13950	2	applied	\N	\N	\N	\N	47206	47206	47207
12935	13951	3	applied	\N	\N	\N	\N	47208	47208	47209
12935	13952	4	applied	\N	\N	\N	\N	47210	47210	47211
12935	13953	5	applied	\N	\N	\N	\N	47212	47212	47213
12935	13954	6	applied	\N	\N	\N	\N	47214	47214	47215
12935	13955	7	applied	\N	\N	\N	\N	47216	47216	47217
12937	13948	0	applied	\N	\N	\N	\N	47202	47202	47203
12937	13949	1	applied	\N	\N	\N	\N	47204	47204	47205
12937	13950	2	applied	\N	\N	\N	\N	47206	47206	47207
12937	13951	3	applied	\N	\N	\N	\N	47208	47208	47209
12937	13952	4	applied	\N	\N	\N	\N	47210	47210	47211
12937	13953	5	applied	\N	\N	\N	\N	47212	47212	47213
12937	13954	6	applied	\N	\N	\N	\N	47214	47214	47215
12937	13955	7	applied	\N	\N	\N	\N	47216	47216	47217
12944	13962	0	applied	\N	\N	\N	\N	47239	47239	47240
12944	13961	2	applied	\N	\N	\N	\N	47236	47236	47237
12944	13963	3	applied	\N	\N	\N	\N	47242	47242	47243
12950	13972	0	applied	\N	\N	\N	\N	47267	47267	47268
12950	13973	1	applied	\N	\N	\N	\N	47269	47269	47270
12950	13974	2	applied	\N	\N	\N	\N	47271	47271	47272
12950	13975	3	applied	\N	\N	\N	\N	47273	47273	47274
12952	13976	0	applied	\N	\N	\N	\N	47279	47279	47280
12952	13977	1	applied	\N	\N	\N	\N	47281	47281	47282
12955	13982	0	applied	\N	\N	\N	\N	47296	47296	47297
12955	13983	1	applied	\N	\N	\N	\N	47298	47298	47299
12963	13996	0	applied	\N	\N	\N	\N	47336	47336	47337
12963	13997	1	applied	\N	\N	\N	\N	47338	47338	47339
12963	13998	2	applied	\N	\N	\N	\N	47340	47340	47341
12963	13999	3	applied	\N	\N	\N	\N	47342	47342	47343
12963	14000	4	applied	\N	\N	\N	\N	47344	47344	47345
12963	14001	5	applied	\N	\N	\N	\N	47346	47346	47347
12970	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12970	14009	1	applied	\N	\N	\N	\N	47373	47373	47374
12974	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12974	14009	1	applied	\N	\N	\N	\N	47373	47373	47374
12977	14012	0	applied	\N	\N	\N	\N	47382	47382	47383
12977	14013	1	applied	\N	\N	\N	\N	47384	47384	47385
12977	14014	2	applied	\N	\N	\N	\N	47386	47386	47387
12979	14015	0	applied	\N	\N	\N	\N	47391	47391	47392
12979	14016	1	applied	\N	\N	\N	\N	47393	47393	47394
12987	14021	0	applied	\N	\N	\N	\N	47414	47414	47415
12987	14022	1	applied	\N	\N	\N	\N	47416	47416	47417
12989	14023	0	applied	\N	\N	\N	\N	47422	47422	47423
12989	14024	1	applied	\N	\N	\N	\N	47424	47424	47425
12848	13761	15	applied	\N	\N	\N	\N	46628	46628	46629
12848	13762	16	applied	\N	\N	\N	\N	46630	46630	46631
12848	13763	18	applied	\N	\N	\N	\N	46632	46632	46633
12848	13768	19	applied	\N	\N	\N	\N	46644	46644	46645
12848	13771	20	applied	\N	\N	\N	\N	46651	46651	46652
12848	13773	21	applied	\N	\N	\N	\N	46659	46659	46660
12848	13776	22	applied	\N	\N	\N	\N	46667	46667	46668
12848	13778	23	applied	\N	\N	\N	\N	46673	46673	46674
12848	13780	24	applied	\N	\N	\N	\N	46680	46680	46681
12848	13783	25	applied	\N	\N	\N	\N	46688	46688	46689
12848	13785	26	applied	\N	\N	\N	\N	46694	46694	46695
12848	13787	27	applied	\N	\N	\N	\N	46700	46700	46701
12848	13789	28	applied	\N	\N	\N	\N	46709	46709	46710
12848	13791	29	applied	\N	\N	\N	\N	46714	46714	46715
12848	13792	30	applied	\N	\N	\N	\N	46717	46717	46718
12848	13793	31	applied	\N	\N	\N	\N	46719	46719	46720
12848	13794	32	applied	\N	\N	\N	\N	46721	46721	46722
12848	13795	33	applied	\N	\N	\N	\N	46727	46727	46728
12848	13796	34	applied	\N	\N	\N	\N	46729	46729	46730
12848	13797	35	applied	\N	\N	\N	\N	46733	46733	46734
12848	13798	36	applied	\N	\N	\N	\N	46737	46737	46738
12848	13799	37	applied	\N	\N	\N	\N	46740	46740	46741
12848	13800	38	applied	\N	\N	\N	\N	46743	46743	46744
12848	13801	39	applied	\N	\N	\N	\N	46747	46747	46748
12848	13802	40	applied	\N	\N	\N	\N	46749	46749	46750
12848	13803	41	applied	\N	\N	\N	\N	46752	46752	46753
12848	13804	42	applied	\N	\N	\N	\N	46757	46757	46758
12848	13805	43	applied	\N	\N	\N	\N	46761	46761	46762
12848	13806	44	applied	\N	\N	\N	\N	46764	46764	46765
12848	13807	45	applied	\N	\N	\N	\N	46768	46768	46769
12848	13808	46	applied	\N	\N	\N	\N	46775	46775	46776
12848	13809	47	applied	\N	\N	\N	\N	46784	46784	46785
12848	13810	48	applied	\N	\N	\N	\N	46796	46796	46797
12848	13812	49	applied	\N	\N	\N	\N	46801	46801	46802
12848	13815	50	applied	\N	\N	\N	\N	46810	46810	46811
12848	13817	51	applied	\N	\N	\N	\N	46819	46819	46820
12848	13819	52	applied	\N	\N	\N	\N	46824	46824	46825
12848	13733	53	applied	\N	\N	\N	\N	46541	46541	46542
12848	13735	54	applied	\N	\N	\N	\N	46546	46546	46547
12848	13743	55	applied	\N	\N	1000000000	\N	46577	46577	46578
12848	13757	56	applied	\N	\N	\N	\N	46618	46618	46619
12848	13764	57	applied	\N	\N	\N	\N	46634	46634	46635
12848	13736	58	applied	\N	\N	\N	\N	46554	46554	46555
12848	13738	59	applied	\N	\N	\N	\N	46564	46564	46565
12848	13742	60	applied	\N	\N	\N	\N	46575	46575	46576
12848	13744	61	applied	\N	\N	\N	\N	46579	46579	46580
12848	13745	62	applied	\N	\N	\N	\N	46581	46581	46582
12848	13748	63	applied	\N	\N	\N	\N	46593	46593	46594
12848	13749	64	applied	\N	\N	\N	\N	46595	46595	46596
12848	13752	65	applied	\N	\N	\N	\N	46605	46605	46606
12848	13753	66	applied	\N	\N	\N	\N	46607	46607	46608
12848	13755	67	applied	\N	\N	\N	\N	46612	46612	46613
12848	13758	68	applied	\N	\N	\N	\N	46620	46620	46621
12848	13760	69	applied	\N	\N	\N	\N	46626	46626	46627
12848	13765	70	applied	\N	\N	\N	\N	46637	46637	46638
12848	13766	71	applied	\N	\N	\N	\N	46639	46639	46640
12848	13767	72	applied	\N	\N	\N	\N	46641	46641	46642
12848	13769	73	applied	\N	\N	\N	\N	46646	46646	46647
12848	13772	74	applied	\N	\N	\N	\N	46653	46653	46654
12848	13775	75	applied	\N	\N	\N	\N	46663	46663	46664
12848	13777	76	applied	\N	\N	\N	\N	46669	46669	46670
12848	13779	77	applied	\N	\N	\N	\N	46675	46675	46676
12848	13781	78	applied	\N	\N	\N	\N	46682	46682	46683
12848	13784	79	applied	\N	\N	\N	\N	46690	46690	46691
12848	13786	80	applied	\N	\N	\N	\N	46697	46697	46698
12848	13811	81	applied	\N	\N	1000000000	\N	46799	46799	46800
12848	13813	82	applied	\N	\N	1000000000	\N	46803	46803	46804
12848	13814	83	applied	\N	\N	\N	\N	46805	46805	46806
12848	13816	84	applied	\N	\N	\N	\N	46812	46812	46813
12848	13818	85	applied	\N	\N	\N	\N	46821	46821	46822
12848	13820	86	applied	\N	\N	\N	\N	46826	46826	46827
12848	13770	87	applied	\N	\N	\N	\N	46648	46648	46649
12848	13774	88	applied	\N	\N	\N	\N	46661	46661	46662
12848	13782	89	applied	\N	\N	\N	\N	46684	46684	46685
12850	13821	0	applied	\N	\N	\N	\N	46833	46833	46834
12850	13822	1	applied	\N	\N	\N	\N	46835	46835	46836
12855	13827	0	applied	\N	\N	\N	\N	46856	46856	46857
12855	13828	1	applied	\N	\N	\N	\N	46858	46858	46859
12860	13833	0	applied	\N	\N	\N	\N	46872	46872	46873
12860	13834	1	applied	\N	\N	\N	\N	46874	46874	46875
12863	13835	0	applied	\N	\N	\N	\N	46879	46879	46880
12863	13836	1	applied	\N	\N	\N	\N	46881	46881	46882
12863	13837	2	applied	\N	\N	\N	\N	46883	46883	46884
12863	13834	3	applied	\N	\N	\N	\N	46874	46874	46875
12863	13838	4	applied	\N	\N	1000000000	\N	46885	46885	46886
12863	13839	5	applied	\N	\N	\N	\N	46887	46887	46888
12863	13840	6	applied	\N	\N	\N	\N	46889	46889	46890
12863	13841	7	applied	\N	\N	\N	\N	46891	46891	46892
12863	13842	8	applied	\N	\N	\N	\N	46893	46893	46894
12864	13843	0	applied	\N	\N	\N	\N	46901	46901	46902
12864	13844	1	applied	\N	\N	\N	\N	46903	46903	46904
12864	13845	2	applied	\N	\N	\N	\N	46905	46905	46906
12864	13846	3	applied	\N	\N	\N	\N	46907	46907	46908
12864	13847	4	applied	\N	\N	1000000000	\N	46909	46909	46910
12864	13848	5	applied	\N	\N	\N	\N	46911	46911	46912
12864	13849	6	applied	\N	\N	\N	\N	46913	46913	46914
12869	13864	0	applied	\N	\N	\N	\N	46949	46949	46950
12869	13865	1	applied	\N	\N	\N	\N	46951	46951	46952
12869	13866	2	applied	\N	\N	\N	\N	46953	46953	46954
12869	13867	3	applied	\N	\N	\N	\N	46955	46955	46956
12869	13868	4	applied	\N	\N	\N	\N	46957	46957	46958
12869	13869	5	applied	\N	\N	\N	\N	46959	46959	13857
12869	13870	6	applied	\N	\N	\N	\N	46960	46960	46961
12869	13871	7	applied	\N	\N	\N	\N	46962	46962	46963
12869	13872	8	applied	\N	\N	\N	\N	46964	46964	46965
12874	13877	0	applied	\N	\N	\N	\N	46978	46978	46979
12874	13878	1	applied	\N	\N	\N	\N	46980	46980	46981
12874	13879	2	applied	\N	\N	\N	\N	46982	46982	46983
12874	13880	3	applied	\N	\N	\N	\N	46984	46984	46985
12883	13885	0	applied	\N	\N	\N	\N	47006	47006	47007
12883	13886	1	applied	\N	\N	\N	\N	47008	47008	47009
12885	13887	0	applied	\N	\N	\N	\N	47014	47014	47015
12885	13888	1	applied	\N	\N	\N	\N	47016	47016	47017
12887	13889	0	applied	\N	\N	\N	\N	47019	47019	47020
12887	13890	1	applied	\N	\N	\N	\N	47021	47021	47022
12898	13897	0	applied	\N	\N	\N	\N	47043	47043	47044
12898	13898	1	applied	\N	\N	\N	\N	47045	47045	47046
12901	13899	0	applied	\N	\N	\N	\N	47051	47051	47052
12901	13900	1	applied	\N	\N	\N	\N	47053	47053	47054
12880	13835	7	applied	\N	\N	\N	\N	46879	46879	46880
12880	13836	8	applied	\N	\N	\N	\N	46881	46881	46882
12880	13837	9	applied	\N	\N	\N	\N	46883	46883	46884
12880	13843	10	applied	\N	\N	\N	\N	46901	46901	46902
12880	13844	11	applied	\N	\N	\N	\N	46903	46903	46904
12880	13845	12	applied	\N	\N	\N	\N	46905	46905	46906
12880	13850	13	applied	\N	\N	\N	\N	46918	46918	46919
12880	13851	14	applied	\N	\N	\N	\N	46920	46920	46921
12880	13852	15	applied	\N	\N	\N	\N	46922	46922	46923
12880	13856	16	applied	\N	\N	\N	\N	46931	46931	46932
12880	13857	17	applied	\N	\N	\N	\N	46933	46933	46934
12880	13858	18	applied	\N	\N	\N	\N	46935	46935	46936
12880	13859	19	applied	\N	\N	\N	\N	46937	46937	46938
12880	13864	20	applied	\N	\N	\N	\N	46949	46949	46950
12880	13865	21	applied	\N	\N	\N	\N	46951	46951	46952
12880	13866	22	applied	\N	\N	\N	\N	46953	46953	46954
12880	13867	23	applied	\N	\N	\N	\N	46955	46955	46956
12880	13873	24	applied	\N	\N	\N	\N	46967	46967	46968
12880	13875	25	applied	\N	\N	\N	\N	46971	46971	46972
12880	13877	26	applied	\N	\N	\N	\N	46978	46978	46979
12880	13878	27	applied	\N	\N	\N	\N	46980	46980	46981
12880	13881	28	applied	\N	\N	\N	\N	46990	46990	46991
12880	13869	29	applied	\N	\N	\N	\N	46959	46959	13857
12880	13822	30	applied	\N	\N	\N	\N	46835	46835	46836
12880	13838	31	applied	\N	\N	1000000000	\N	46885	46885	46886
12880	13839	32	applied	\N	\N	\N	\N	46887	46887	46888
12880	13824	33	applied	\N	\N	\N	\N	46842	46842	46843
12880	13826	34	applied	\N	\N	\N	\N	46850	46850	46851
12880	13828	35	applied	\N	\N	\N	\N	46858	46858	46859
12880	13831	36	applied	\N	\N	\N	\N	46864	46864	46865
12880	13832	37	applied	\N	\N	\N	\N	46866	46866	46867
12880	13834	38	applied	\N	\N	\N	\N	46874	46874	46875
12880	13840	39	applied	\N	\N	\N	\N	46889	46889	46890
12880	13841	40	applied	\N	\N	\N	\N	46891	46891	46892
12880	13842	41	applied	\N	\N	\N	\N	46893	46893	46894
12880	13846	42	applied	\N	\N	\N	\N	46907	46907	46908
12880	13847	43	applied	\N	\N	1000000000	\N	46909	46909	46910
12880	13848	44	applied	\N	\N	\N	\N	46911	46911	46912
12880	13849	45	applied	\N	\N	\N	\N	46913	46913	46914
12880	13853	46	applied	\N	\N	\N	\N	46924	46924	46925
12880	13854	47	applied	\N	\N	\N	\N	46926	46926	46927
12880	13855	48	applied	\N	\N	\N	\N	46928	46928	46929
12880	13860	49	applied	\N	\N	\N	\N	46939	46939	46940
12880	13861	50	applied	\N	\N	\N	\N	46941	46941	46942
12880	13862	51	applied	\N	\N	\N	\N	46943	46943	46944
12880	13863	52	applied	\N	\N	\N	\N	46945	46945	46946
12880	13868	54	applied	\N	\N	\N	\N	46957	46957	46958
12880	13870	55	applied	\N	\N	\N	\N	46960	46960	46961
12880	13871	56	applied	\N	\N	\N	\N	46962	46962	46963
12880	13872	57	applied	\N	\N	\N	\N	46964	46964	46965
12880	13874	58	applied	\N	\N	\N	\N	46969	46969	46970
12880	13876	59	applied	\N	\N	\N	\N	46973	46973	46974
12880	13879	60	applied	\N	\N	\N	\N	46982	46982	46983
12880	13880	61	applied	\N	\N	\N	\N	46984	46984	46985
12880	13882	62	applied	\N	\N	\N	\N	46992	46992	46993
12882	13885	0	applied	\N	\N	\N	\N	47006	47006	47007
12882	13886	1	applied	\N	\N	\N	\N	47008	47008	47009
12886	13887	0	applied	\N	\N	\N	\N	47014	47014	47015
12886	13888	1	applied	\N	\N	\N	\N	47016	47016	47017
12888	13889	0	applied	\N	\N	\N	\N	47019	47019	47020
12888	13890	1	applied	\N	\N	\N	\N	47021	47021	47022
12890	13889	0	applied	\N	\N	\N	\N	47019	47019	47020
12890	13890	1	applied	\N	\N	\N	\N	47021	47021	47022
12891	13889	0	applied	\N	\N	\N	\N	47019	47019	47020
12891	13890	1	applied	\N	\N	\N	\N	47021	47021	47022
12894	13893	0	applied	\N	\N	\N	\N	47031	47031	47032
12894	13894	1	applied	\N	\N	\N	\N	47033	47033	47034
12896	13893	0	applied	\N	\N	\N	\N	47031	47031	47032
12896	13894	1	applied	\N	\N	\N	\N	47033	47033	47034
12899	13897	0	applied	\N	\N	\N	\N	47043	47043	47044
12899	13898	1	applied	\N	\N	\N	\N	47045	47045	47046
12906	13907	0	applied	\N	\N	\N	\N	47075	47075	47076
12906	13908	1	applied	\N	\N	\N	\N	47077	47077	47078
12906	13909	2	applied	\N	\N	\N	\N	47079	47079	47080
12906	13910	3	applied	\N	\N	\N	\N	47081	47081	47082
12914	13922	0	applied	\N	\N	\N	\N	47118	47118	47119
12914	13923	1	applied	\N	\N	\N	\N	47120	47120	47121
12916	13881	0	applied	\N	\N	\N	\N	46990	46990	46991
12916	13883	1	applied	\N	\N	\N	\N	46997	46997	46998
12916	13885	2	applied	\N	\N	\N	\N	47006	47006	47007
12916	13887	3	applied	\N	\N	\N	\N	47014	47014	47015
12916	13889	4	applied	\N	\N	\N	\N	47019	47019	47020
12916	13891	5	applied	\N	\N	\N	\N	47025	47025	47026
12916	13893	6	applied	\N	\N	\N	\N	47031	47031	47032
12916	13895	7	applied	\N	\N	\N	\N	47038	47038	47039
12916	13897	8	applied	\N	\N	\N	\N	47043	47043	47044
12916	13899	9	applied	\N	\N	\N	\N	47051	47051	47052
12916	13901	10	applied	\N	\N	\N	\N	47056	47056	47057
12916	13902	11	applied	\N	\N	\N	\N	47058	47058	47059
12916	13905	12	applied	\N	\N	\N	\N	47069	47069	47070
12916	13907	13	applied	\N	\N	\N	\N	47075	47075	47076
12916	13908	14	applied	\N	\N	\N	\N	47077	47077	47078
12916	13911	16	applied	\N	\N	\N	\N	47087	47087	47088
12916	13914	17	applied	\N	\N	\N	\N	47097	47097	47098
12916	13915	18	applied	\N	\N	\N	\N	47099	47099	47100
12916	13916	19	applied	\N	\N	\N	\N	47101	47101	47102
12916	13917	20	applied	\N	\N	\N	\N	47103	47103	47104
12916	13922	21	applied	\N	\N	\N	\N	47118	47118	47119
12916	13882	22	applied	\N	\N	\N	\N	46992	46992	46993
12916	13884	23	applied	\N	\N	\N	\N	46999	46999	47000
12916	13886	24	applied	\N	\N	\N	\N	47008	47008	47009
12916	13888	25	applied	\N	\N	\N	\N	47016	47016	47017
12916	13890	26	applied	\N	\N	\N	\N	47021	47021	47022
12916	13892	27	applied	\N	\N	\N	\N	47027	47027	47028
12916	13894	28	applied	\N	\N	\N	\N	47033	47033	47034
12916	13896	29	applied	\N	\N	\N	\N	47040	47040	47041
12916	13898	30	applied	\N	\N	\N	\N	47045	47045	47046
12916	13900	31	applied	\N	\N	\N	\N	47053	47053	47054
12916	13903	32	applied	\N	\N	\N	\N	47060	47060	47061
12916	13904	33	applied	\N	\N	\N	\N	47062	47062	47063
12916	13906	34	applied	\N	\N	\N	\N	47071	47071	47072
12916	13909	35	applied	\N	\N	\N	\N	47079	47079	47080
12916	13910	36	applied	\N	\N	\N	\N	47081	47081	47082
12916	13912	37	applied	\N	\N	\N	\N	47089	47089	47090
12916	13913	38	applied	\N	\N	\N	\N	47094	47094	47095
12916	13918	39	applied	\N	\N	\N	\N	47105	47105	47106
12916	13919	40	applied	\N	\N	\N	\N	47107	47107	47108
12916	13920	41	applied	\N	\N	\N	\N	47109	47109	47110
12916	13921	42	applied	\N	\N	\N	\N	47111	47111	47112
12904	13901	0	applied	\N	\N	\N	\N	47056	47056	47057
12904	13902	1	applied	\N	\N	\N	\N	47058	47058	47059
12904	13903	2	applied	\N	\N	\N	\N	47060	47060	47061
12904	13904	3	applied	\N	\N	\N	\N	47062	47062	47063
12905	13905	0	applied	\N	\N	\N	\N	47069	47069	47070
12905	13906	1	applied	\N	\N	\N	\N	47071	47071	47072
12908	13911	0	applied	\N	\N	\N	\N	47087	47087	47088
12908	13912	1	applied	\N	\N	\N	\N	47089	47089	47090
12910	13913	0	applied	\N	\N	\N	\N	47094	47094	47095
12911	13914	0	applied	\N	\N	\N	\N	47097	47097	47098
12911	13915	1	applied	\N	\N	\N	\N	47099	47099	47100
12911	13916	2	applied	\N	\N	\N	\N	47101	47101	47102
12911	13917	3	applied	\N	\N	\N	\N	47103	47103	47104
12911	13918	4	applied	\N	\N	\N	\N	47105	47105	47106
12911	13919	5	applied	\N	\N	\N	\N	47107	47107	47108
12911	13920	6	applied	\N	\N	\N	\N	47109	47109	47110
12911	13921	7	applied	\N	\N	\N	\N	47111	47111	47112
12924	13934	0	applied	\N	\N	\N	\N	47155	47155	47156
12924	13935	1	applied	\N	\N	\N	\N	47157	47157	47158
12929	13942	0	applied	\N	\N	\N	\N	47179	47179	47180
12929	13943	1	applied	\N	\N	\N	\N	47181	47181	47182
12931	13942	0	applied	\N	\N	\N	\N	47179	47179	47180
12931	13943	1	applied	\N	\N	\N	\N	47181	47181	47182
12933	13944	0	applied	\N	\N	\N	\N	47188	47188	47189
12933	13945	1	applied	\N	\N	\N	\N	47190	47190	47191
12936	13948	0	applied	\N	\N	\N	\N	47202	47202	47203
12936	13949	1	applied	\N	\N	\N	\N	47204	47204	47205
12936	13950	2	applied	\N	\N	\N	\N	47206	47206	47207
12936	13951	3	applied	\N	\N	\N	\N	47208	47208	47209
12936	13952	4	applied	\N	\N	\N	\N	47210	47210	47211
12936	13953	5	applied	\N	\N	\N	\N	47212	47212	47213
12936	13954	6	applied	\N	\N	\N	\N	47214	47214	47215
12936	13955	7	applied	\N	\N	\N	\N	47216	47216	47217
12938	13956	0	applied	\N	\N	\N	\N	47222	47222	47223
12938	13957	1	applied	\N	\N	\N	\N	47224	47224	47225
12943	13962	0	applied	\N	\N	\N	\N	47239	47239	47240
12943	13961	2	applied	\N	\N	\N	\N	47236	47236	47237
12943	13963	3	applied	\N	\N	\N	\N	47242	47242	47243
12945	13964	0	applied	\N	\N	\N	\N	47249	47249	47250
12945	13965	1	applied	\N	\N	\N	\N	47251	47251	47252
12949	13970	0	applied	\N	\N	\N	\N	47262	47262	47263
12949	13971	1	applied	\N	\N	\N	\N	47264	47264	47265
12954	13980	0	applied	\N	\N	\N	\N	47291	47291	47292
12954	13981	1	applied	\N	\N	\N	\N	47293	47293	47294
12959	13986	0	applied	\N	\N	\N	\N	47311	47311	47312
12959	13987	1	applied	\N	\N	\N	\N	47313	47313	47314
12962	13994	0	applied	\N	\N	\N	\N	47330	47330	47331
12962	13995	1	applied	\N	\N	\N	\N	47332	47332	47333
12965	14002	0	applied	\N	\N	\N	\N	47352	47352	47353
12965	14003	1	applied	\N	\N	\N	\N	47354	47354	47355
12968	14006	0	applied	\N	\N	\N	\N	47364	47364	47365
12968	14007	1	applied	\N	\N	\N	\N	47366	47366	47367
12973	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12973	14009	1	applied	\N	\N	\N	\N	47373	47373	47374
12976	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12976	14010	1	applied	\N	\N	\N	\N	47377	47377	47378
12976	14009	2	applied	\N	\N	\N	\N	47373	47373	47374
12982	14017	0	applied	\N	\N	\N	\N	47396	47396	47397
12982	14018	1	applied	\N	\N	\N	\N	47398	47398	47399
12986	14021	0	applied	\N	\N	\N	\N	47414	47414	47415
12986	14022	1	applied	\N	\N	\N	\N	47416	47416	47417
12988	14023	0	applied	\N	\N	\N	\N	47422	47422	47423
12988	14024	1	applied	\N	\N	\N	\N	47424	47424	47425
12988	14025	2	applied	\N	\N	\N	\N	47426	47426	47427
12988	14026	3	applied	\N	\N	\N	\N	47428	47428	47429
12996	14033	0	applied	\N	\N	\N	\N	47452	47452	47453
12996	14034	1	applied	\N	\N	\N	\N	47454	47454	47455
12996	14035	2	applied	\N	\N	\N	\N	47456	47456	47457
12996	14036	3	applied	\N	\N	\N	\N	47458	47458	47459
12997	14033	0	applied	\N	\N	\N	\N	47452	47452	47453
12997	14034	1	applied	\N	\N	\N	\N	47454	47454	47455
12997	14035	2	applied	\N	\N	\N	\N	47456	47456	47457
12997	14036	3	applied	\N	\N	\N	\N	47458	47458	47459
13000	14037	0	applied	\N	\N	\N	\N	47468	47468	47469
13000	14038	1	applied	\N	\N	\N	\N	47470	47470	47471
13004	14040	0	applied	\N	\N	\N	\N	47479	47479	47480
13004	14039	1	applied	\N	\N	\N	\N	47475	47475	47476
13007	14046	0	applied	\N	\N	\N	\N	47495	47495	47496
13007	14047	1	applied	\N	\N	\N	\N	47497	47497	47498
13007	14048	2	applied	\N	\N	\N	\N	47499	47499	47500
13007	14049	3	applied	\N	\N	\N	\N	47501	47501	47502
13007	14050	4	applied	\N	\N	\N	\N	47503	47503	47504
13007	14051	5	applied	\N	\N	\N	\N	47505	47505	47506
13010	14054	0	applied	\N	\N	\N	\N	47513	47513	47514
13010	14055	1	applied	\N	\N	\N	\N	47515	47515	47516
13014	14060	0	applied	\N	\N	\N	\N	47532	47532	47533
13014	14061	1	applied	\N	\N	\N	\N	47534	47534	47535
13017	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	47540	47540	\N
13017	14063	1	applied	\N	\N	\N	\N	47541	47541	47542
13017	14064	2	applied	\N	\N	\N	\N	47543	47543	47544
13017	14065	3	applied	\N	\N	\N	\N	47545	47545	47546
13017	14066	4	applied	\N	\N	\N	\N	47547	47547	47548
13020	14073	0	applied	\N	\N	\N	\N	47566	47566	1435
13020	14074	1	applied	\N	\N	\N	\N	47567	47567	47568
13020	14075	2	applied	\N	\N	\N	\N	47569	47569	47570
13024	14078	0	applied	\N	\N	\N	\N	47583	47583	47584
13024	14079	1	applied	\N	\N	\N	\N	47585	47585	47586
13026	14078	0	applied	\N	\N	\N	\N	47583	47583	47584
13026	14080	1	applied	\N	\N	\N	\N	47589	47589	47590
13026	14079	2	applied	\N	\N	\N	\N	47585	47585	47586
13026	14081	3	applied	\N	\N	\N	\N	47591	47591	47592
13029	14084	0	applied	\N	\N	\N	\N	47602	47602	47603
13029	14085	1	applied	\N	\N	\N	\N	47604	47604	47605
13029	14086	2	applied	\N	\N	\N	\N	47606	47606	47607
13029	14087	3	applied	\N	\N	\N	\N	47608	47608	1435
13029	14088	4	applied	\N	\N	\N	\N	47609	47609	47610
13032	14096	0	applied	\N	\N	\N	\N	47631	47631	47632
13032	14097	1	applied	\N	\N	\N	\N	47633	47633	47634
13035	14098	0	applied	\N	\N	\N	\N	47642	47642	47643
13035	14099	1	applied	\N	\N	\N	\N	47644	47644	47645
13035	14100	2	applied	\N	\N	\N	\N	47646	47646	47647
13035	14101	3	applied	\N	\N	\N	\N	47648	47648	47649
13035	14102	4	applied	\N	\N	\N	\N	47650	47650	47651
13035	14103	5	applied	\N	\N	\N	\N	47652	47652	47653
13035	14104	6	applied	\N	\N	\N	\N	47654	47654	47655
13035	14105	7	applied	\N	\N	\N	\N	47656	47656	47657
13035	14106	8	applied	\N	\N	\N	\N	47658	47658	47659
13035	14107	9	applied	\N	\N	\N	\N	47660	47660	47661
13035	14108	10	applied	\N	\N	\N	\N	47662	47662	47663
12916	13923	43	applied	\N	\N	\N	\N	47120	47120	47121
12917	13924	0	applied	\N	\N	\N	\N	47127	47127	47128
12917	13925	1	applied	\N	\N	\N	\N	47129	47129	47130
12917	13926	2	applied	\N	\N	\N	\N	47131	47131	47132
12917	13927	3	applied	\N	\N	\N	\N	47133	47133	47134
12919	13928	0	applied	\N	\N	\N	\N	47139	47139	47140
12919	13929	1	applied	\N	\N	\N	\N	47141	47141	47142
12930	13883	0	applied	\N	\N	\N	\N	46997	46997	46998
12930	13885	1	applied	\N	\N	\N	\N	47006	47006	47007
12930	13887	2	applied	\N	\N	\N	\N	47014	47014	47015
12930	13889	3	applied	\N	\N	\N	\N	47019	47019	47020
12930	13891	4	applied	\N	\N	\N	\N	47025	47025	47026
12930	13893	5	applied	\N	\N	\N	\N	47031	47031	47032
12930	13895	6	applied	\N	\N	\N	\N	47038	47038	47039
12930	13897	7	applied	\N	\N	\N	\N	47043	47043	47044
12930	13899	8	applied	\N	\N	\N	\N	47051	47051	47052
12930	13901	9	applied	\N	\N	\N	\N	47056	47056	47057
12930	13902	10	applied	\N	\N	\N	\N	47058	47058	47059
12930	13905	11	applied	\N	\N	\N	\N	47069	47069	47070
12930	13907	12	applied	\N	\N	\N	\N	47075	47075	47076
12930	13908	13	applied	\N	\N	\N	\N	47077	47077	47078
12930	13911	14	applied	\N	\N	\N	\N	47087	47087	47088
12930	13914	15	applied	\N	\N	\N	\N	47097	47097	47098
12930	13915	16	applied	\N	\N	\N	\N	47099	47099	47100
12930	13916	17	applied	\N	\N	\N	\N	47101	47101	47102
12930	13917	18	applied	\N	\N	\N	\N	47103	47103	47104
12930	13922	19	applied	\N	\N	\N	\N	47118	47118	47119
12930	13924	20	applied	\N	\N	\N	\N	47127	47127	47128
12930	13925	21	applied	\N	\N	\N	\N	47129	47129	47130
12930	13928	22	applied	\N	\N	\N	\N	47139	47139	47140
12930	13930	23	applied	\N	\N	\N	\N	47143	47143	47144
12930	13932	24	applied	\N	\N	\N	\N	47149	47149	47150
12930	13934	25	applied	\N	\N	\N	\N	47155	47155	47156
12930	13936	26	applied	\N	\N	\N	\N	47163	47163	47164
12930	13937	27	applied	\N	\N	\N	\N	47165	47165	47166
12930	13940	28	applied	\N	\N	\N	\N	47175	47175	47176
12930	13942	29	applied	\N	\N	\N	\N	47179	47179	47180
12930	13884	30	applied	\N	\N	\N	\N	46999	46999	47000
12930	13886	31	applied	\N	\N	\N	\N	47008	47008	47009
12930	13888	32	applied	\N	\N	\N	\N	47016	47016	47017
12930	13890	33	applied	\N	\N	\N	\N	47021	47021	47022
12930	13892	34	applied	\N	\N	\N	\N	47027	47027	47028
12930	13894	35	applied	\N	\N	\N	\N	47033	47033	47034
12930	13896	36	applied	\N	\N	\N	\N	47040	47040	47041
12930	13898	37	applied	\N	\N	\N	\N	47045	47045	47046
12930	13900	38	applied	\N	\N	\N	\N	47053	47053	47054
12930	13903	39	applied	\N	\N	\N	\N	47060	47060	47061
12930	13904	40	applied	\N	\N	\N	\N	47062	47062	47063
12930	13906	41	applied	\N	\N	\N	\N	47071	47071	47072
12930	13909	42	applied	\N	\N	\N	\N	47079	47079	47080
12930	13910	43	applied	\N	\N	\N	\N	47081	47081	47082
12930	13912	44	applied	\N	\N	\N	\N	47089	47089	47090
12930	13913	45	applied	\N	\N	\N	\N	47094	47094	47095
12930	13918	46	applied	\N	\N	\N	\N	47105	47105	47106
12930	13919	47	applied	\N	\N	\N	\N	47107	47107	47108
12930	13920	48	applied	\N	\N	\N	\N	47109	47109	47110
12930	13921	49	applied	\N	\N	\N	\N	47111	47111	47112
12930	13923	50	applied	\N	\N	\N	\N	47120	47120	47121
12930	13926	51	applied	\N	\N	\N	\N	47131	47131	47132
12930	13927	52	applied	\N	\N	\N	\N	47133	47133	47134
12930	13929	53	applied	\N	\N	\N	\N	47141	47141	47142
12930	13931	54	applied	\N	\N	\N	\N	47145	47145	47146
12930	13933	55	applied	\N	\N	\N	\N	47151	47151	47152
12930	13935	56	applied	\N	\N	\N	\N	47157	47157	47158
12930	13938	57	applied	\N	\N	\N	\N	47167	47167	47168
12930	13939	58	applied	\N	\N	\N	\N	47169	47169	47170
12930	13941	59	applied	\N	\N	\N	\N	47177	47177	47178
12930	13943	60	applied	\N	\N	\N	\N	47181	47181	47182
12939	13958	0	applied	\N	\N	\N	\N	47228	47228	47229
12939	13959	1	applied	\N	\N	\N	\N	47230	47230	47231
12941	13960	0	applied	\N	\N	\N	\N	47234	47234	47235
12941	13961	1	applied	\N	\N	\N	\N	47236	47236	47237
12946	13964	0	applied	\N	\N	\N	\N	47249	47249	47250
12946	13965	1	applied	\N	\N	\N	\N	47251	47251	47252
12948	13968	0	applied	\N	\N	\N	\N	47258	47258	47259
12948	13969	1	applied	\N	\N	\N	\N	47260	47260	47261
12957	13982	0	applied	\N	\N	\N	\N	47296	47296	47297
12957	13983	1	applied	\N	\N	\N	\N	47298	47298	47299
12958	13984	0	applied	\N	\N	\N	\N	47305	47305	47306
12958	13985	1	applied	\N	\N	\N	\N	47307	47307	47308
12961	13988	0	applied	\N	\N	\N	\N	47317	47317	47318
12961	13989	1	applied	\N	\N	\N	\N	47319	47319	47320
12961	13990	2	applied	\N	\N	\N	\N	47321	47321	47322
12961	13991	3	applied	\N	\N	\N	\N	47323	47323	47324
12961	13992	4	applied	\N	\N	\N	\N	47325	47325	47326
12961	13993	5	applied	\N	\N	\N	\N	47327	47327	47328
12967	14006	0	applied	\N	\N	\N	\N	47364	47364	47365
12967	14007	1	applied	\N	\N	\N	\N	47366	47366	47367
12969	14006	0	applied	\N	\N	\N	\N	47364	47364	47365
12969	14007	1	applied	\N	\N	\N	\N	47366	47366	47367
12972	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12972	14009	1	applied	\N	\N	\N	\N	47373	47373	47374
12981	14017	0	applied	\N	\N	\N	\N	47396	47396	47397
12981	14018	1	applied	\N	\N	\N	\N	47398	47398	47399
12985	13788	0	applied	\N	\N	\N	\N	46702	46702	46703
12992	14029	0	applied	\N	\N	\N	\N	47441	47441	47442
12992	14030	1	applied	\N	\N	\N	\N	47443	47443	47444
12992	14031	2	applied	\N	\N	\N	\N	47445	47445	47446
12992	14032	3	applied	\N	\N	\N	\N	47447	47447	47448
12995	14033	0	applied	\N	\N	\N	\N	47452	47452	47453
12995	14034	1	applied	\N	\N	\N	\N	47454	47454	47455
12995	14035	2	applied	\N	\N	\N	\N	47456	47456	47457
12995	14036	3	applied	\N	\N	\N	\N	47458	47458	47459
12999	14037	0	applied	\N	\N	\N	\N	47468	47468	47469
12999	14038	1	applied	\N	\N	\N	\N	47470	47470	47471
13003	14040	0	applied	\N	\N	\N	\N	47479	47479	47480
13003	14041	1	applied	\N	\N	\N	\N	47481	47481	47482
13003	14042	2	applied	\N	\N	\N	\N	47483	47483	47484
13003	14043	3	applied	\N	\N	\N	\N	47485	47485	47486
13003	14044	4	applied	\N	\N	\N	\N	47487	47487	47488
13003	14045	5	applied	\N	\N	\N	\N	47489	47489	47490
13005	14041	0	applied	\N	\N	\N	\N	47481	47481	47482
13005	14042	1	applied	\N	\N	\N	\N	47483	47483	47484
13005	14043	2	applied	\N	\N	\N	\N	47485	47485	47486
13005	14044	3	applied	\N	\N	\N	\N	47487	47487	47488
13005	14045	4	applied	\N	\N	\N	\N	47489	47489	47490
13006	14041	0	applied	\N	\N	\N	\N	47481	47481	47482
13006	14042	1	applied	\N	\N	\N	\N	47483	47483	47484
13006	14043	2	applied	\N	\N	\N	\N	47485	47485	47486
13006	14044	3	applied	\N	\N	\N	\N	47487	47487	47488
12926	13937	1	applied	\N	\N	\N	\N	47165	47165	47166
12926	13938	2	applied	\N	\N	\N	\N	47167	47167	47168
12926	13939	3	applied	\N	\N	\N	\N	47169	47169	47170
12928	13942	0	applied	\N	\N	\N	\N	47179	47179	47180
12928	13943	1	applied	\N	\N	\N	\N	47181	47181	47182
12932	13944	0	applied	\N	\N	\N	\N	47188	47188	47189
12932	13945	1	applied	\N	\N	\N	\N	47190	47190	47191
12940	13958	0	applied	\N	\N	\N	\N	47228	47228	47229
12940	13959	1	applied	\N	\N	\N	\N	47230	47230	47231
12942	13960	0	applied	\N	\N	\N	\N	47234	47234	47235
12947	13966	0	applied	\N	\N	\N	\N	47253	47253	47254
12947	13967	1	applied	\N	\N	\N	\N	47255	47255	47256
12951	13972	0	applied	\N	\N	\N	\N	47267	47267	47268
12951	13973	1	applied	\N	\N	\N	\N	47269	47269	47270
12951	13974	2	applied	\N	\N	\N	\N	47271	47271	47272
12951	13975	3	applied	\N	\N	\N	\N	47273	47273	47274
12953	13978	0	applied	\N	\N	\N	\N	47285	47285	47286
12953	13979	1	applied	\N	\N	\N	\N	47287	47287	47288
12956	13983	0	applied	\N	\N	\N	\N	47298	47298	47299
12964	13996	0	applied	\N	\N	\N	\N	47336	47336	47337
12964	13997	1	applied	\N	\N	\N	\N	47338	47338	47339
12964	13998	2	applied	\N	\N	\N	\N	47340	47340	47341
12964	13999	3	applied	\N	\N	\N	\N	47342	47342	47343
12964	14000	4	applied	\N	\N	\N	\N	47344	47344	47345
12964	14001	5	applied	\N	\N	\N	\N	47346	47346	47347
12966	14004	0	applied	\N	\N	\N	\N	47358	47358	47359
12966	14005	1	applied	\N	\N	\N	\N	47360	47360	47361
12971	14008	0	applied	\N	\N	\N	\N	47371	47371	47372
12971	14009	1	applied	\N	\N	\N	\N	47373	47373	47374
12975	14010	0	applied	\N	\N	\N	\N	47377	47377	47378
12975	14011	1	applied	\N	\N	\N	\N	47379	47379	47380
12978	14012	0	applied	\N	\N	\N	\N	47382	47382	47383
12978	14013	1	applied	\N	\N	\N	\N	47384	47384	47385
12978	14014	2	applied	\N	\N	\N	\N	47386	47386	47387
12980	14017	0	applied	\N	\N	\N	\N	47396	47396	47397
12980	14018	1	applied	\N	\N	\N	\N	47398	47398	47399
12983	14018	0	applied	\N	\N	\N	\N	47398	47398	47399
12984	14019	0	applied	\N	\N	\N	\N	47406	47406	47407
12984	14020	1	applied	\N	\N	\N	\N	47408	47408	47409
12990	14023	0	applied	\N	\N	\N	\N	47422	47422	47423
12990	14024	1	applied	\N	\N	\N	\N	47424	47424	47425
12990	14025	2	applied	\N	\N	\N	\N	47426	47426	47427
12990	14026	3	applied	\N	\N	\N	\N	47428	47428	47429
12991	14027	0	applied	\N	\N	\N	\N	47435	47435	47436
12991	14028	1	applied	\N	\N	\N	\N	47437	47437	47438
12994	14033	0	applied	\N	\N	\N	\N	47452	47452	47453
12994	14034	1	applied	\N	\N	\N	\N	47454	47454	47455
12994	14035	2	applied	\N	\N	\N	\N	47456	47456	47457
12994	14036	3	applied	\N	\N	\N	\N	47458	47458	47459
13011	14054	0	applied	\N	\N	\N	\N	47513	47513	47514
13011	14055	1	applied	\N	\N	\N	\N	47515	47515	47516
13012	14056	0	applied	\N	\N	\N	\N	47520	47520	47521
13015	14060	0	applied	\N	\N	\N	\N	47532	47532	47533
13015	14061	1	applied	\N	\N	\N	\N	47534	47534	47535
13022	14076	0	applied	\N	\N	\N	\N	47576	47576	47577
13022	14077	1	applied	\N	\N	\N	\N	47578	47578	47579
13027	14078	0	applied	\N	\N	\N	\N	47583	47583	47584
13027	14080	1	applied	\N	\N	\N	\N	47589	47589	47590
13027	14079	2	applied	\N	\N	\N	\N	47585	47585	47586
13027	14081	3	applied	\N	\N	\N	\N	47591	47591	47592
13030	14084	0	applied	\N	\N	\N	\N	47602	47602	47603
13030	14085	1	applied	\N	\N	\N	\N	47604	47604	47605
13030	14086	2	applied	\N	\N	\N	\N	47606	47606	47607
13030	14087	3	applied	\N	\N	\N	\N	47608	47608	1435
13030	14088	4	applied	\N	\N	\N	\N	47609	47609	47610
13033	14096	0	applied	\N	\N	\N	\N	47631	47631	47632
13033	14097	1	applied	\N	\N	\N	\N	47633	47633	47634
13036	14116	0	applied	\N	\N	\N	\N	47679	47679	47680
13036	14117	1	applied	\N	\N	\N	\N	47681	47681	47682
13039	14118	0	applied	\N	\N	\N	\N	47686	47686	47687
13039	14119	1	applied	\N	\N	\N	\N	47688	47688	47689
13039	14120	2	applied	\N	\N	\N	\N	47690	47690	47691
13043	14129	0	applied	\N	\N	\N	\N	47714	47714	47715
13043	14130	1	applied	\N	\N	\N	\N	47716	47716	47717
13043	14131	2	applied	\N	\N	\N	\N	47718	47718	47719
13043	14132	3	applied	\N	\N	\N	\N	47720	47720	47721
13043	14133	4	applied	\N	\N	\N	\N	47722	47722	47723
13043	14134	5	applied	\N	\N	\N	\N	47724	47724	47725
13046	14146	0	applied	\N	\N	\N	\N	47754	47754	47755
13046	14147	1	applied	\N	\N	\N	\N	47756	47756	47757
13046	14148	2	applied	\N	\N	\N	\N	47758	47758	47759
13048	14149	0	applied	\N	\N	\N	\N	47762	47762	47763
13048	14150	1	applied	\N	\N	1000000000	\N	47764	47764	47765
13048	14151	2	applied	\N	\N	\N	\N	47766	47766	47767
13048	14152	3	applied	\N	\N	\N	\N	47768	47768	47769
13048	14153	4	applied	\N	\N	\N	\N	47770	47770	47771
13052	14149	0	applied	\N	\N	\N	\N	47762	47762	47763
13052	14150	1	applied	\N	\N	1000000000	\N	47764	47764	47765
13052	14151	2	applied	\N	\N	\N	\N	47766	47766	47767
13052	14152	3	applied	\N	\N	\N	\N	47768	47768	47769
13052	14153	4	applied	\N	\N	\N	\N	47770	47770	47771
13055	14158	0	applied	\N	\N	\N	\N	47792	47792	47793
13055	14159	1	applied	\N	\N	\N	\N	47794	47794	47795
13055	14160	2	applied	\N	\N	\N	\N	47796	47796	47797
13055	14161	3	applied	\N	\N	\N	\N	47798	47798	47799
13055	14162	4	applied	\N	\N	\N	\N	47800	47800	47801
13058	14163	0	applied	\N	\N	\N	\N	47805	47805	47806
13058	14164	1	applied	\N	\N	\N	\N	47807	47807	47808
13058	14165	2	applied	\N	\N	\N	\N	47809	47809	47810
13058	14166	3	applied	\N	\N	\N	\N	47811	47811	47812
13058	14167	4	applied	\N	\N	\N	\N	47813	47813	47814
13058	14168	5	applied	\N	\N	\N	\N	47815	47815	47816
13058	14169	6	applied	\N	\N	\N	\N	47817	47817	47818
13058	14170	7	applied	\N	\N	\N	\N	47819	47819	47820
13058	14171	8	applied	\N	\N	\N	\N	47821	47821	47822
13058	14172	9	applied	\N	\N	\N	\N	47823	47823	47824
13058	14173	10	applied	\N	\N	\N	\N	47825	47825	47826
13058	14174	11	applied	\N	\N	\N	\N	47827	47827	47828
13058	14175	12	applied	\N	\N	\N	\N	47829	47829	47830
13058	14176	13	applied	\N	\N	\N	\N	47831	47831	47832
13058	14177	14	applied	\N	\N	\N	\N	47833	47833	47834
13058	14178	15	applied	\N	\N	\N	\N	47835	47835	47836
13062	14182	0	applied	\N	\N	\N	\N	47850	47850	47851
13062	14183	1	applied	\N	\N	\N	\N	47852	47852	47853
13062	14184	2	applied	\N	\N	\N	\N	47854	47854	47855
13062	14185	3	applied	\N	\N	\N	\N	47856	47856	47857
13062	14186	4	applied	\N	\N	\N	\N	47858	47858	47859
13062	14187	5	applied	\N	\N	\N	\N	47860	47860	47861
13062	14188	6	applied	\N	\N	\N	\N	47862	47862	47863
12989	14025	2	applied	\N	\N	\N	\N	47426	47426	47427
12989	14026	3	applied	\N	\N	\N	\N	47428	47428	47429
12998	14033	0	applied	\N	\N	\N	\N	47452	47452	47453
12998	14034	1	applied	\N	\N	\N	\N	47454	47454	47455
12998	14035	2	applied	\N	\N	\N	\N	47456	47456	47457
12998	14036	3	applied	\N	\N	\N	\N	47458	47458	47459
13001	14037	0	applied	\N	\N	\N	\N	47468	47468	47469
13001	14038	1	applied	\N	\N	\N	\N	47470	47470	47471
13002	14039	0	applied	\N	\N	\N	\N	47475	47475	47476
13008	14052	0	applied	\N	\N	\N	\N	47509	47509	47510
13008	14053	1	applied	\N	\N	\N	\N	47511	47511	47512
13013	14057	0	applied	\N	\N	\N	\N	47524	47524	47525
13013	14058	1	applied	\N	\N	\N	\N	47526	47526	47527
13013	14059	2	applied	\N	\N	\N	\N	47528	47528	47529
13018	14067	0	applied	\N	\N	\N	\N	47553	47553	47553
13018	14068	1	applied	\N	\N	\N	\N	47554	47554	47555
13018	14069	2	applied	\N	\N	\N	\N	47556	47556	47557
13018	14070	3	applied	\N	\N	\N	\N	47558	47558	47559
13018	14071	4	applied	\N	\N	\N	\N	47560	47560	47561
13018	14072	5	applied	\N	\N	\N	\N	47562	47562	47563
13021	14073	0	applied	\N	\N	\N	\N	47566	47566	1435
13021	14074	1	applied	\N	\N	\N	\N	47567	47567	47568
13021	14075	2	applied	\N	\N	\N	\N	47569	47569	47570
13023	14076	0	applied	\N	\N	\N	\N	47576	47576	47577
13023	14077	1	applied	\N	\N	\N	\N	47578	47578	47579
13034	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	47540	47540	\N
13034	14089	1	applied	\N	\N	\N	\N	47639	47639	47616
13034	14073	2	applied	\N	\N	\N	\N	47566	47566	1435
13041	14121	0	applied	\N	\N	\N	\N	47695	47695	47696
13041	14122	1	applied	\N	\N	\N	\N	47697	47697	47698
13041	14123	2	applied	\N	\N	\N	\N	47699	47699	47700
13041	14124	3	applied	\N	\N	\N	\N	47701	47701	47702
13041	14125	4	applied	\N	\N	\N	\N	47703	47703	47704
13041	14126	5	applied	\N	\N	\N	\N	47705	47705	47706
13041	14127	6	applied	\N	\N	\N	\N	47707	47707	47708
13041	14128	7	applied	\N	\N	\N	\N	47709	47709	47710
13044	14135	0	applied	\N	\N	\N	\N	47728	47728	47729
13044	14136	1	applied	\N	\N	\N	\N	47730	47730	47731
13044	14137	2	applied	\N	\N	\N	\N	47732	47732	47733
13049	14149	0	applied	\N	\N	\N	\N	47762	47762	47763
13049	14150	1	applied	\N	\N	1000000000	\N	47764	47764	47765
13049	14151	2	applied	\N	\N	\N	\N	47766	47766	47767
13049	14152	3	applied	\N	\N	\N	\N	47768	47768	47769
13049	14153	4	applied	\N	\N	\N	\N	47770	47770	47771
13053	14154	0	applied	\N	\N	\N	\N	47780	47780	47781
13053	14155	1	applied	\N	\N	\N	\N	47782	47782	47783
13056	14158	0	applied	\N	\N	\N	\N	47792	47792	47793
13056	14159	1	applied	\N	\N	\N	\N	47794	47794	47795
13056	14160	2	applied	\N	\N	\N	\N	47796	47796	47797
13056	14161	3	applied	\N	\N	\N	\N	47798	47798	47799
13056	14162	4	applied	\N	\N	\N	\N	47800	47800	47801
13059	14163	0	applied	\N	\N	\N	\N	47805	47805	47806
13059	14164	1	applied	\N	\N	\N	\N	47807	47807	47808
13059	14165	2	applied	\N	\N	\N	\N	47809	47809	47810
13059	14166	3	applied	\N	\N	\N	\N	47811	47811	47812
13059	14167	4	applied	\N	\N	\N	\N	47813	47813	47814
13059	14168	5	applied	\N	\N	\N	\N	47815	47815	47816
13059	14169	6	applied	\N	\N	\N	\N	47817	47817	47818
13059	14170	7	applied	\N	\N	\N	\N	47819	47819	47820
13059	14171	8	applied	\N	\N	\N	\N	47821	47821	47822
13059	14172	9	applied	\N	\N	\N	\N	47823	47823	47824
13059	14173	10	applied	\N	\N	\N	\N	47825	47825	47826
13059	14174	11	applied	\N	\N	\N	\N	47827	47827	47828
13059	14175	12	applied	\N	\N	\N	\N	47829	47829	47830
13059	14176	13	applied	\N	\N	\N	\N	47831	47831	47832
13059	14177	14	applied	\N	\N	\N	\N	47833	47833	47834
13059	14178	15	applied	\N	\N	\N	\N	47835	47835	47836
13063	14182	0	applied	\N	\N	\N	\N	47850	47850	47851
13063	14183	1	applied	\N	\N	\N	\N	47852	47852	47853
13063	14184	2	applied	\N	\N	\N	\N	47854	47854	47855
13063	14185	3	applied	\N	\N	\N	\N	47856	47856	47857
13063	14186	4	applied	\N	\N	\N	\N	47858	47858	47859
13063	14187	5	applied	\N	\N	\N	\N	47860	47860	47861
13063	14188	6	applied	\N	\N	\N	\N	47862	47862	47863
13063	14189	7	applied	\N	\N	\N	\N	47864	47864	47865
13063	14190	8	applied	\N	\N	\N	\N	47866	47866	47867
13063	14191	9	applied	\N	\N	\N	\N	47868	47868	47869
13063	14192	10	applied	\N	\N	\N	\N	47870	47870	47871
13063	14193	11	applied	\N	\N	\N	\N	47872	47872	47873
13063	14194	12	applied	\N	\N	\N	\N	47874	47874	47875
13063	14195	13	applied	\N	\N	1000000000	\N	47876	47876	47877
13063	14196	14	applied	\N	\N	\N	\N	47878	47878	47879
13063	14197	15	applied	\N	\N	\N	\N	47880	47880	47881
13063	14198	16	applied	\N	\N	\N	\N	47882	47882	47883
13063	14199	17	applied	\N	\N	\N	\N	47884	47884	47885
13063	14200	18	applied	\N	\N	\N	\N	47886	47886	47887
13066	14201	0	applied	\N	\N	\N	\N	47891	47891	47892
13066	14202	1	applied	\N	\N	\N	\N	47893	47893	47894
13066	14203	2	applied	\N	\N	\N	\N	47895	47895	47896
13066	14204	3	applied	\N	\N	\N	\N	47897	47897	47898
13072	14213	0	applied	\N	\N	\N	\N	47925	47925	47926
13072	14214	2	applied	\N	\N	\N	\N	47928	47928	47929
13072	14215	3	applied	\N	\N	\N	\N	47930	47930	47931
13072	14216	4	applied	\N	\N	\N	\N	47932	47932	47933
13076	14220	0	applied	\N	\N	\N	\N	47949	47949	47950
13076	14221	1	applied	\N	\N	\N	\N	47951	47951	47952
13076	14222	2	applied	\N	\N	\N	\N	47953	47953	47954
13076	14223	3	applied	\N	\N	\N	\N	47955	47955	47956
13079	14224	0	applied	\N	\N	\N	\N	47961	47961	47962
13079	14225	1	applied	\N	\N	\N	\N	47963	47963	47964
13079	14226	2	applied	\N	\N	\N	\N	47965	47965	47966
13083	14227	0	applied	\N	\N	\N	\N	47972	47972	47973
13083	14228	1	applied	\N	\N	\N	\N	47974	47974	47975
13083	14229	2	applied	\N	\N	\N	\N	47976	47976	47977
13083	14230	3	applied	\N	\N	\N	\N	47978	47978	47979
13087	14231	0	applied	\N	\N	\N	\N	47986	47986	47987
13087	14232	1	applied	\N	\N	\N	\N	47988	47988	47989
13087	14233	2	applied	\N	\N	\N	\N	47990	47990	47991
13087	14234	3	applied	\N	\N	\N	\N	47992	47992	47993
13087	14235	4	applied	\N	\N	\N	\N	47994	47994	47995
13087	14236	5	applied	\N	\N	\N	\N	47996	47996	47997
13087	14237	6	applied	\N	\N	1000000000	\N	47998	47998	47999
13087	14238	7	applied	\N	\N	\N	\N	48000	48000	48001
13090	14242	0	applied	\N	\N	\N	\N	48012	48012	48013
13090	14243	1	applied	\N	\N	\N	\N	48014	48014	48015
13090	14244	2	applied	\N	\N	\N	\N	48016	48016	48017
13092	14246	0	applied	\N	\N	\N	\N	48026	48026	48027
13092	14247	1	applied	\N	\N	\N	\N	48028	48028	48029
13092	14248	2	applied	\N	\N	\N	\N	48030	48030	48031
13006	14045	4	applied	\N	\N	\N	\N	47489	47489	47490
13009	14054	0	applied	\N	\N	\N	\N	47513	47513	47514
13009	14055	1	applied	\N	\N	\N	\N	47515	47515	47516
13016	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	47540	47540	\N
13016	14063	1	applied	\N	\N	\N	\N	47541	47541	47542
13016	14064	2	applied	\N	\N	\N	\N	47543	47543	47544
13016	14065	3	applied	\N	\N	\N	\N	47545	47545	47546
13016	14066	4	applied	\N	\N	\N	\N	47547	47547	47548
13019	14073	0	applied	\N	\N	\N	\N	47566	47566	1435
13019	14074	1	applied	\N	\N	\N	\N	47567	47567	47568
13019	14075	2	applied	\N	\N	\N	\N	47569	47569	47570
13028	14082	0	applied	\N	\N	\N	\N	47596	47596	47597
13028	14083	1	applied	\N	\N	\N	\N	47598	47598	47599
13031	14089	0	applied	\N	\N	\N	\N	47615	47615	47616
13031	14090	1	applied	\N	\N	\N	\N	47617	47617	47618
13031	14091	2	applied	\N	\N	\N	\N	47619	47619	47620
13031	14092	3	applied	\N	\N	\N	\N	47621	47621	47622
13031	14093	4	applied	\N	\N	\N	\N	47623	47623	47624
13031	14094	5	applied	\N	\N	\N	\N	47625	47625	47626
13031	14095	6	applied	\N	\N	\N	\N	47627	47627	47628
13037	14118	0	applied	\N	\N	\N	\N	47686	47686	47687
13037	14119	1	applied	\N	\N	\N	\N	47688	47688	47689
13037	14120	2	applied	\N	\N	\N	\N	47690	47690	47691
13042	14121	0	applied	\N	\N	\N	\N	47695	47695	47696
13042	14122	1	applied	\N	\N	\N	\N	47697	47697	47698
13042	14123	2	applied	\N	\N	\N	\N	47699	47699	47700
13042	14124	3	applied	\N	\N	\N	\N	47701	47701	47702
13042	14125	4	applied	\N	\N	\N	\N	47703	47703	47704
13042	14126	5	applied	\N	\N	\N	\N	47705	47705	47706
13042	14127	6	applied	\N	\N	\N	\N	47707	47707	47708
13042	14128	7	applied	\N	\N	\N	\N	47709	47709	47710
13050	14149	0	applied	\N	\N	\N	\N	47762	47762	47763
13050	14150	1	applied	\N	\N	1000000000	\N	47764	47764	47765
13050	14151	2	applied	\N	\N	\N	\N	47766	47766	47767
13050	14152	3	applied	\N	\N	\N	\N	47768	47768	47769
13050	14153	4	applied	\N	\N	\N	\N	47770	47770	47771
13067	14201	0	applied	\N	\N	\N	\N	47891	47891	47892
13067	14202	1	applied	\N	\N	\N	\N	47893	47893	47894
13067	14203	2	applied	\N	\N	\N	\N	47895	47895	47896
13067	14204	3	applied	\N	\N	\N	\N	47897	47897	47898
13068	14205	0	applied	\N	\N	1000000000	\N	47905	47905	47906
13068	14206	1	applied	\N	\N	\N	\N	47907	47907	47908
13068	14207	2	applied	\N	\N	\N	\N	47909	47909	47910
13068	14208	3	applied	\N	\N	\N	\N	47911	47911	47912
13068	14209	4	applied	\N	\N	\N	\N	47913	47913	47914
13068	14210	5	applied	\N	\N	\N	\N	47915	47915	47916
13068	14211	6	applied	\N	\N	\N	\N	47917	47917	47918
13068	14212	7	applied	\N	\N	\N	\N	47919	47919	47920
13073	14213	0	applied	\N	\N	\N	\N	47925	47925	47926
13077	14220	0	applied	\N	\N	\N	\N	47949	47949	47950
13077	14221	1	applied	\N	\N	\N	\N	47951	47951	47952
13077	14222	2	applied	\N	\N	\N	\N	47953	47953	47954
13077	14223	3	applied	\N	\N	\N	\N	47955	47955	47956
13084	14227	0	applied	\N	\N	\N	\N	47972	47972	47973
13084	14228	1	applied	\N	\N	\N	\N	47974	47974	47975
13084	14229	2	applied	\N	\N	\N	\N	47976	47976	47977
13084	14230	3	applied	\N	\N	\N	\N	47978	47978	47979
13088	14239	0	applied	\N	\N	\N	\N	48004	48004	48005
13088	14240	1	applied	\N	\N	\N	\N	48006	48006	48007
13088	14241	2	applied	\N	\N	\N	\N	48008	48008	48009
13093	14252	0	applied	\N	\N	\N	\N	48039	48039	48040
13093	14253	1	applied	\N	\N	\N	\N	48041	48041	48042
13093	14254	2	applied	\N	\N	\N	\N	48043	48043	48044
13096	14267	0	applied	\N	\N	\N	\N	48072	48072	48073
13096	14268	1	applied	\N	\N	\N	\N	48074	48074	48075
13096	14269	2	applied	\N	\N	\N	\N	48076	48076	48077
13096	14270	3	applied	\N	\N	\N	\N	48078	48078	48079
13098	14271	0	applied	\N	\N	\N	\N	48083	48083	48084
13098	14272	1	applied	\N	\N	\N	\N	48085	48085	48086
13098	14273	2	applied	\N	\N	\N	\N	48087	48087	48088
13098	14274	3	applied	\N	\N	\N	\N	48089	48089	48090
13099	14271	0	applied	\N	\N	\N	\N	48083	48083	48084
13099	14272	1	applied	\N	\N	\N	\N	48085	48085	48086
13099	14273	2	applied	\N	\N	\N	\N	48087	48087	48088
13099	14274	3	applied	\N	\N	\N	\N	48089	48089	48090
13101	14275	0	applied	\N	\N	\N	\N	48093	48093	48094
13101	14276	1	applied	\N	\N	\N	\N	48095	48095	48096
13101	14277	2	applied	\N	\N	\N	\N	48097	48097	48098
13101	14278	3	applied	\N	\N	\N	\N	48099	48099	48100
13105	14286	0	applied	\N	\N	\N	\N	48121	48121	48122
13110	14296	0	applied	\N	\N	\N	\N	48149	48149	48150
13110	14297	1	applied	\N	\N	\N	\N	48151	48151	48152
13110	14298	2	applied	\N	\N	\N	\N	48153	48153	48154
13110	14299	3	applied	\N	\N	\N	\N	48155	48155	48156
13110	14300	4	applied	\N	\N	\N	\N	48157	48157	48158
13110	14301	5	applied	\N	\N	\N	\N	48159	48159	48160
13110	14302	7	applied	\N	\N	\N	\N	48162	48162	48163
13110	14303	8	applied	\N	\N	\N	\N	48164	48164	48165
13112	14296	0	applied	\N	\N	\N	\N	48149	48149	48150
13112	14297	1	applied	\N	\N	\N	\N	48151	48151	48152
13112	14298	2	applied	\N	\N	\N	\N	48153	48153	48154
13112	14299	3	applied	\N	\N	\N	\N	48155	48155	48156
13112	14300	4	applied	\N	\N	\N	\N	48157	48157	48158
13112	14301	5	applied	\N	\N	\N	\N	48159	48159	48160
13112	14302	7	applied	\N	\N	\N	\N	48162	48162	48163
13112	14303	8	applied	\N	\N	\N	\N	48164	48164	48165
13115	14308	0	applied	\N	\N	\N	\N	48187	48187	48188
13115	14309	1	applied	\N	\N	\N	\N	48189	48189	48190
13115	14310	2	applied	\N	\N	\N	\N	48191	48191	48192
13117	14311	0	applied	\N	\N	\N	\N	48196	48196	48197
13117	14312	1	applied	\N	\N	\N	\N	48198	48198	48199
13117	14313	2	applied	\N	\N	\N	\N	48200	48200	48201
13123	14341	0	applied	\N	\N	\N	\N	48265	48265	48266
13123	14342	1	applied	\N	\N	\N	\N	48267	48267	48268
13123	14343	2	applied	\N	\N	\N	\N	48269	48269	48270
13123	14344	3	applied	\N	\N	\N	\N	48271	48271	48272
13134	14384	0	applied	\N	\N	\N	\N	48364	48364	48365
13134	14385	1	applied	\N	\N	\N	\N	48366	48366	48367
13134	14386	2	applied	\N	\N	\N	\N	48368	48368	48369
13134	14387	3	applied	\N	\N	\N	\N	48370	48370	48371
13139	14392	0	applied	\N	\N	\N	\N	48383	48383	48384
13139	14393	1	applied	\N	\N	\N	\N	48385	48385	48386
13139	14394	2	applied	\N	\N	\N	\N	48387	48387	48388
13139	14395	3	applied	\N	\N	\N	\N	48389	48389	48390
13141	14396	0	applied	\N	\N	\N	\N	48396	48396	48397
13141	14397	2	applied	\N	\N	\N	\N	48399	48399	48400
13141	14398	3	applied	\N	\N	\N	\N	48401	48401	48402
13141	14399	4	applied	\N	\N	\N	\N	48403	48403	48404
13141	14400	5	applied	\N	\N	\N	\N	48405	48405	48406
13035	14109	11	applied	\N	\N	\N	\N	47664	47664	47665
13035	14110	12	applied	\N	\N	\N	\N	47666	47666	47667
13035	14111	13	applied	\N	\N	\N	\N	47668	47668	47669
13035	14112	14	applied	\N	\N	\N	\N	47670	47670	47671
13035	14113	15	applied	\N	\N	\N	\N	47672	47672	47673
13035	14114	16	applied	\N	\N	\N	\N	47674	47674	47675
13035	14115	17	applied	\N	\N	\N	\N	47676	47676	47677
13038	14118	0	applied	\N	\N	\N	\N	47686	47686	47687
13038	14119	1	applied	\N	\N	\N	\N	47688	47688	47689
13038	14120	2	applied	\N	\N	\N	\N	47690	47690	47691
13040	14121	0	applied	\N	\N	\N	\N	47695	47695	47696
13040	14122	1	applied	\N	\N	\N	\N	47697	47697	47698
13040	14123	2	applied	\N	\N	\N	\N	47699	47699	47700
13040	14124	3	applied	\N	\N	\N	\N	47701	47701	47702
13040	14125	4	applied	\N	\N	\N	\N	47703	47703	47704
13040	14126	5	applied	\N	\N	\N	\N	47705	47705	47706
13040	14127	6	applied	\N	\N	\N	\N	47707	47707	47708
13040	14128	7	applied	\N	\N	\N	\N	47709	47709	47710
13045	14138	0	applied	\N	\N	\N	\N	47736	47736	47737
13045	14139	1	applied	\N	\N	\N	\N	47738	47738	47739
13045	14140	2	applied	\N	\N	\N	\N	47740	47740	47741
13045	14141	3	applied	\N	\N	\N	\N	47742	47742	47743
13045	14142	4	applied	\N	\N	\N	\N	47744	47744	47745
13045	14143	5	applied	\N	\N	\N	\N	47746	47746	47747
13045	14144	6	applied	\N	\N	\N	\N	47748	47748	47749
13045	14145	7	applied	\N	\N	\N	\N	47750	47750	47751
13051	14149	0	applied	\N	\N	\N	\N	47762	47762	47763
13051	14150	1	applied	\N	\N	1000000000	\N	47764	47764	47765
13051	14151	2	applied	\N	\N	\N	\N	47766	47766	47767
13051	14152	3	applied	\N	\N	\N	\N	47768	47768	47769
13051	14153	4	applied	\N	\N	\N	\N	47770	47770	47771
13054	14156	0	applied	\N	\N	\N	\N	47786	47786	47787
13054	14157	1	applied	\N	\N	\N	\N	47788	47788	47789
13057	14163	0	applied	\N	\N	\N	\N	47805	47805	47806
13057	14164	1	applied	\N	\N	\N	\N	47807	47807	47808
13057	14165	2	applied	\N	\N	\N	\N	47809	47809	47810
13057	14166	3	applied	\N	\N	\N	\N	47811	47811	47812
13057	14167	4	applied	\N	\N	\N	\N	47813	47813	47814
13057	14168	5	applied	\N	\N	\N	\N	47815	47815	47816
13057	14169	6	applied	\N	\N	\N	\N	47817	47817	47818
13057	14170	7	applied	\N	\N	\N	\N	47819	47819	47820
13057	14171	8	applied	\N	\N	\N	\N	47821	47821	47822
13057	14172	9	applied	\N	\N	\N	\N	47823	47823	47824
13057	14173	10	applied	\N	\N	\N	\N	47825	47825	47826
13057	14174	11	applied	\N	\N	\N	\N	47827	47827	47828
13057	14175	12	applied	\N	\N	\N	\N	47829	47829	47830
13057	14176	13	applied	\N	\N	\N	\N	47831	47831	47832
13057	14177	14	applied	\N	\N	\N	\N	47833	47833	47834
13057	14178	15	applied	\N	\N	\N	\N	47835	47835	47836
13060	14163	0	applied	\N	\N	\N	\N	47805	47805	47806
13060	14164	1	applied	\N	\N	\N	\N	47807	47807	47808
13060	14165	2	applied	\N	\N	\N	\N	47809	47809	47810
13060	14166	3	applied	\N	\N	\N	\N	47811	47811	47812
13060	14167	4	applied	\N	\N	\N	\N	47813	47813	47814
13060	14168	5	applied	\N	\N	\N	\N	47815	47815	47816
13060	14169	6	applied	\N	\N	\N	\N	47817	47817	47818
13060	14170	7	applied	\N	\N	\N	\N	47819	47819	47820
13060	14171	8	applied	\N	\N	\N	\N	47821	47821	47822
13060	14172	9	applied	\N	\N	\N	\N	47823	47823	47824
13060	14173	10	applied	\N	\N	\N	\N	47825	47825	47826
13060	14174	11	applied	\N	\N	\N	\N	47827	47827	47828
13060	14175	12	applied	\N	\N	\N	\N	47829	47829	47830
13060	14176	13	applied	\N	\N	\N	\N	47831	47831	47832
13060	14177	14	applied	\N	\N	\N	\N	47833	47833	47834
13060	14178	15	applied	\N	\N	\N	\N	47835	47835	47836
13061	14179	0	applied	\N	\N	\N	\N	47842	47842	47843
13061	14180	1	applied	\N	\N	\N	\N	47844	47844	47845
13061	14181	2	applied	\N	\N	\N	\N	47846	47846	47847
13064	14201	0	applied	\N	\N	\N	\N	47891	47891	47892
13064	14202	1	applied	\N	\N	\N	\N	47893	47893	47894
13064	14203	2	applied	\N	\N	\N	\N	47895	47895	47896
13064	14204	3	applied	\N	\N	\N	\N	47897	47897	47898
13069	14205	0	applied	\N	\N	1000000000	\N	47905	47905	47906
13069	14206	1	applied	\N	\N	\N	\N	47907	47907	47908
13069	14207	2	applied	\N	\N	\N	\N	47909	47909	47910
13069	14208	3	applied	\N	\N	\N	\N	47911	47911	47912
13069	14209	4	applied	\N	\N	\N	\N	47913	47913	47914
13069	14210	5	applied	\N	\N	\N	\N	47915	47915	47916
13069	14211	6	applied	\N	\N	\N	\N	47917	47917	47918
13069	14212	7	applied	\N	\N	\N	\N	47919	47919	47920
13074	14213	0	applied	\N	\N	\N	\N	47925	47925	47926
13075	14217	0	applied	\N	\N	\N	\N	47941	47941	47942
13075	14214	1	applied	\N	\N	\N	\N	47928	47928	47929
13075	14215	2	applied	\N	\N	\N	\N	47930	47930	47931
13075	14216	3	applied	\N	\N	\N	\N	47932	47932	47933
13075	14218	4	applied	\N	\N	\N	\N	47943	47943	47944
13075	14219	5	applied	\N	\N	\N	\N	47945	47945	47946
13080	14224	0	applied	\N	\N	\N	\N	47961	47961	47962
13080	14225	1	applied	\N	\N	\N	\N	47963	47963	47964
13080	14226	2	applied	\N	\N	\N	\N	47965	47965	47966
13091	14245	0	applied	\N	\N	\N	\N	48022	48022	48023
13097	14267	0	applied	\N	\N	\N	\N	48072	48072	48073
13097	14268	1	applied	\N	\N	\N	\N	48074	48074	48075
13097	14269	2	applied	\N	\N	\N	\N	48076	48076	48077
13097	14270	3	applied	\N	\N	\N	\N	48078	48078	48079
13103	14279	0	applied	\N	\N	\N	\N	48105	48105	48106
13103	14280	1	applied	\N	\N	\N	\N	48107	48107	48108
13103	14281	2	applied	\N	\N	\N	\N	48109	48109	48110
13111	14296	0	applied	\N	\N	\N	\N	48149	48149	48150
13111	14297	1	applied	\N	\N	\N	\N	48151	48151	48152
13113	14304	0	applied	\N	\N	\N	\N	48176	48176	48177
13113	14305	1	applied	\N	\N	\N	\N	48178	48178	48179
13113	14306	2	applied	\N	\N	\N	\N	48180	48180	48181
13113	14307	3	applied	\N	\N	\N	\N	48182	48182	48183
13118	14314	0	applied	\N	\N	\N	\N	48202	48202	48203
13118	14315	1	applied	\N	\N	\N	\N	48204	48204	48205
13118	14316	2	applied	\N	\N	\N	\N	48206	48206	48207
13118	14317	3	applied	\N	\N	\N	\N	48208	48208	48209
13118	14318	4	applied	\N	\N	\N	\N	48210	48210	48211
13118	14319	5	applied	\N	\N	\N	\N	48212	48212	48213
13118	14320	6	applied	\N	\N	\N	\N	48214	48214	48215
13118	14321	7	applied	\N	\N	\N	\N	48216	48216	48217
13120	14322	0	applied	\N	\N	\N	\N	48222	48222	48223
13120	14323	1	applied	\N	\N	\N	\N	48224	48224	48225
13120	14324	2	applied	\N	\N	\N	\N	48226	48226	48227
13120	14325	3	applied	\N	\N	\N	\N	48228	48228	48229
13121	14326	0	applied	\N	\N	\N	\N	48231	48231	48232
13121	14327	1	applied	\N	\N	\N	\N	48233	48233	48234
13121	14328	2	applied	\N	\N	\N	\N	48235	48235	48236
13062	14189	7	applied	\N	\N	\N	\N	47864	47864	47865
13062	14190	8	applied	\N	\N	\N	\N	47866	47866	47867
13062	14191	9	applied	\N	\N	\N	\N	47868	47868	47869
13062	14192	10	applied	\N	\N	\N	\N	47870	47870	47871
13062	14193	11	applied	\N	\N	\N	\N	47872	47872	47873
13062	14194	12	applied	\N	\N	\N	\N	47874	47874	47875
13062	14195	13	applied	\N	\N	1000000000	\N	47876	47876	47877
13062	14196	14	applied	\N	\N	\N	\N	47878	47878	47879
13062	14197	15	applied	\N	\N	\N	\N	47880	47880	47881
13062	14198	16	applied	\N	\N	\N	\N	47882	47882	47883
13062	14199	17	applied	\N	\N	\N	\N	47884	47884	47885
13062	14200	18	applied	\N	\N	\N	\N	47886	47886	47887
13065	14201	0	applied	\N	\N	\N	\N	47891	47891	47892
13065	14202	1	applied	\N	\N	\N	\N	47893	47893	47894
13065	14203	2	applied	\N	\N	\N	\N	47895	47895	47896
13065	14204	3	applied	\N	\N	\N	\N	47897	47897	47898
13070	14205	0	applied	\N	\N	1000000000	\N	47905	47905	47906
13070	14206	1	applied	\N	\N	\N	\N	47907	47907	47908
13070	14207	2	applied	\N	\N	\N	\N	47909	47909	47910
13070	14208	3	applied	\N	\N	\N	\N	47911	47911	47912
13070	14209	4	applied	\N	\N	\N	\N	47913	47913	47914
13070	14210	5	applied	\N	\N	\N	\N	47915	47915	47916
13070	14211	6	applied	\N	\N	\N	\N	47917	47917	47918
13070	14212	7	applied	\N	\N	\N	\N	47919	47919	47920
13071	14213	0	applied	\N	\N	\N	\N	47925	47925	47926
13071	14214	2	applied	\N	\N	\N	\N	47928	47928	47929
13071	14215	3	applied	\N	\N	\N	\N	47930	47930	47931
13071	14216	4	applied	\N	\N	\N	\N	47932	47932	47933
13078	14224	0	applied	\N	\N	\N	\N	47961	47961	47962
13078	14225	1	applied	\N	\N	\N	\N	47963	47963	47964
13078	14226	2	applied	\N	\N	\N	\N	47965	47965	47966
13081	14224	0	applied	\N	\N	\N	\N	47961	47961	47962
13081	14225	1	applied	\N	\N	\N	\N	47963	47963	47964
13081	14226	2	applied	\N	\N	\N	\N	47965	47965	47966
13082	14227	0	applied	\N	\N	\N	\N	47972	47972	47973
13082	14228	1	applied	\N	\N	\N	\N	47974	47974	47975
13082	14229	2	applied	\N	\N	\N	\N	47976	47976	47977
13082	14230	3	applied	\N	\N	\N	\N	47978	47978	47979
13085	14227	0	applied	\N	\N	\N	\N	47972	47972	47973
13085	14228	1	applied	\N	\N	\N	\N	47974	47974	47975
13085	14229	2	applied	\N	\N	\N	\N	47976	47976	47977
13085	14230	3	applied	\N	\N	\N	\N	47978	47978	47979
13086	14227	0	applied	\N	\N	\N	\N	47972	47972	47973
13086	14228	1	applied	\N	\N	\N	\N	47974	47974	47975
13086	14229	2	applied	\N	\N	\N	\N	47976	47976	47977
13086	14230	3	applied	\N	\N	\N	\N	47978	47978	47979
13089	14242	0	applied	\N	\N	\N	\N	48012	48012	48013
13089	14243	1	applied	\N	\N	\N	\N	48014	48014	48015
13089	14244	2	applied	\N	\N	\N	\N	48016	48016	48017
13094	14255	0	applied	\N	\N	\N	\N	48046	48046	48047
13094	14256	1	applied	\N	\N	\N	\N	48048	48048	48049
13094	14257	2	applied	\N	\N	\N	\N	48050	48050	48051
13094	14258	3	applied	\N	\N	\N	\N	48052	48052	48053
13102	14275	0	applied	\N	\N	\N	\N	48093	48093	48094
13102	14276	1	applied	\N	\N	\N	\N	48095	48095	48096
13102	14277	2	applied	\N	\N	\N	\N	48097	48097	48098
13102	14278	3	applied	\N	\N	\N	\N	48099	48099	48100
13104	14282	0	applied	\N	\N	\N	\N	48112	48112	48113
13104	14283	1	applied	\N	\N	\N	\N	48114	48114	48115
13104	14284	2	applied	\N	\N	\N	\N	48116	48116	48117
13104	14285	3	applied	\N	\N	\N	\N	48118	48118	48119
13107	14286	0	applied	\N	\N	\N	\N	48121	48121	48122
13107	14287	1	applied	\N	\N	\N	\N	48126	48126	48127
13107	14288	2	applied	\N	\N	\N	\N	48128	48128	48129
13107	14289	3	applied	\N	\N	\N	\N	48130	48130	48131
13119	14314	0	applied	\N	\N	\N	\N	48202	48202	48203
13119	14315	1	applied	\N	\N	\N	\N	48204	48204	48205
13119	14316	2	applied	\N	\N	\N	\N	48206	48206	48207
13119	14317	3	applied	\N	\N	\N	\N	48208	48208	48209
13119	14318	4	applied	\N	\N	\N	\N	48210	48210	48211
13119	14319	5	applied	\N	\N	\N	\N	48212	48212	48213
13119	14320	6	applied	\N	\N	\N	\N	48214	48214	48215
13119	14321	7	applied	\N	\N	\N	\N	48216	48216	48217
13124	14345	0	applied	\N	\N	\N	\N	48275	48275	48276
13124	14346	1	applied	\N	\N	\N	\N	48277	48277	48278
13124	14347	2	applied	\N	\N	\N	\N	48279	48279	48280
13128	14348	0	applied	\N	\N	\N	\N	48285	48285	48286
13128	14349	1	applied	\N	\N	\N	\N	48287	48287	48288
13128	14350	2	applied	\N	\N	\N	\N	48289	48289	48290
13128	14351	3	applied	\N	\N	\N	\N	48291	48291	48292
13128	14352	4	applied	\N	\N	\N	\N	48293	48293	48294
13128	14353	5	applied	\N	\N	\N	\N	48295	48295	48296
13128	14354	6	applied	\N	\N	\N	\N	48297	48297	48298
13128	14355	7	applied	\N	\N	\N	\N	48299	48299	48300
13128	14356	8	applied	\N	\N	\N	\N	48301	48301	48302
13128	14357	9	applied	\N	\N	\N	\N	48303	48303	48304
13128	14358	10	applied	\N	\N	\N	\N	48305	48305	48306
13128	14359	11	applied	\N	\N	\N	\N	48307	48307	48308
13133	14384	0	applied	\N	\N	\N	\N	48364	48364	48365
13133	14385	1	applied	\N	\N	\N	\N	48366	48366	48367
13133	14386	2	applied	\N	\N	\N	\N	48368	48368	48369
13133	14387	3	applied	\N	\N	\N	\N	48370	48370	48371
13135	14388	0	applied	\N	\N	\N	\N	48372	48372	48373
13135	14389	1	applied	\N	\N	\N	\N	48374	48374	48375
13135	14390	2	applied	\N	\N	\N	\N	48376	48376	48377
13135	14391	3	applied	\N	\N	\N	\N	48378	48378	48379
13140	14392	0	applied	\N	\N	\N	\N	48383	48383	48384
13140	14393	1	applied	\N	\N	\N	\N	48385	48385	48386
13140	14394	2	applied	\N	\N	\N	\N	48387	48387	48388
13140	14395	3	applied	\N	\N	\N	\N	48389	48389	48390
13148	14428	0	applied	\N	\N	\N	\N	48467	48467	48468
13148	14429	1	applied	\N	\N	\N	\N	48469	48469	48470
13148	14430	2	applied	\N	\N	\N	\N	48471	48471	48472
13148	14431	3	applied	\N	\N	\N	\N	48473	48473	48474
13148	14432	4	applied	\N	\N	\N	\N	48475	48475	48476
13150	14433	0	applied	\N	\N	\N	\N	48481	48481	48482
13150	14434	1	applied	\N	\N	\N	\N	48483	48483	48484
13155	14435	0	applied	\N	\N	\N	\N	48490	48490	48491
13155	14436	1	applied	\N	\N	\N	\N	48492	48492	48493
13155	14437	2	applied	\N	\N	\N	\N	48494	48494	48495
13155	14438	3	applied	\N	\N	\N	\N	48496	48496	48497
13155	14439	4	applied	\N	\N	\N	\N	48498	48498	48499
13159	14448	0	applied	\N	\N	\N	\N	48524	48524	48525
13159	14449	1	applied	\N	\N	\N	\N	48526	48526	48527
13159	14446	2	applied	\N	\N	\N	\N	48515	48515	48516
13159	14447	3	applied	\N	\N	\N	\N	48517	48517	48518
13159	14450	4	applied	\N	\N	\N	\N	48528	48528	48529
13159	14451	5	applied	\N	\N	\N	\N	48530	48530	48531
13161	14448	0	applied	\N	\N	\N	\N	48524	48524	48525
13092	14249	3	applied	\N	\N	\N	\N	48032	48032	48033
13092	14250	4	applied	\N	\N	\N	\N	48034	48034	48035
13092	14251	5	applied	\N	\N	\N	\N	48036	48036	48037
13095	14259	0	applied	\N	\N	\N	\N	48055	48055	48056
13095	14260	1	applied	\N	\N	\N	\N	48057	48057	48058
13095	14261	2	applied	\N	\N	\N	\N	48059	48059	48060
13095	14262	3	applied	\N	\N	\N	\N	48061	48061	48062
13095	14263	4	applied	\N	\N	\N	\N	48063	48063	48064
13095	14264	5	applied	\N	\N	\N	\N	48065	48065	48066
13095	14265	6	applied	\N	\N	\N	\N	48067	48067	48068
13095	14266	7	applied	\N	\N	\N	\N	48069	48069	48070
13100	14275	0	applied	\N	\N	\N	\N	48093	48093	48094
13100	14276	1	applied	\N	\N	\N	\N	48095	48095	48096
13100	14277	2	applied	\N	\N	\N	\N	48097	48097	48098
13100	14278	3	applied	\N	\N	\N	\N	48099	48099	48100
13108	14286	0	applied	\N	\N	\N	\N	48121	48121	48122
13108	14287	1	applied	\N	\N	\N	\N	48126	48126	48127
13108	14288	2	applied	\N	\N	\N	\N	48128	48128	48129
13108	14289	3	applied	\N	\N	\N	\N	48130	48130	48131
13109	14290	0	applied	\N	\N	\N	\N	48135	48135	48136
13109	14291	1	applied	\N	\N	\N	\N	48137	48137	48138
13109	14292	2	applied	\N	\N	\N	\N	48139	48139	48140
13109	14293	3	applied	\N	\N	\N	\N	48141	48141	48142
13109	14294	4	applied	\N	\N	\N	\N	48143	48143	48144
13109	14295	5	applied	\N	\N	\N	\N	48145	48145	48146
13114	14308	0	applied	\N	\N	\N	\N	48187	48187	48188
13114	14309	1	applied	\N	\N	\N	\N	48189	48189	48190
13114	14310	2	applied	\N	\N	\N	\N	48191	48191	48192
13116	14308	0	applied	\N	\N	\N	\N	48187	48187	48188
13116	14309	1	applied	\N	\N	\N	\N	48189	48189	48190
13116	14310	2	applied	\N	\N	\N	\N	48191	48191	48192
13122	14338	0	applied	\N	\N	\N	\N	48257	48257	48258
13122	14339	1	applied	\N	\N	\N	\N	48259	48259	48260
13122	14340	2	applied	\N	\N	\N	\N	48261	48261	48262
13125	14345	0	applied	\N	\N	\N	\N	48275	48275	48276
13125	14346	1	applied	\N	\N	\N	\N	48277	48277	48278
13125	14347	2	applied	\N	\N	\N	\N	48279	48279	48280
13130	14360	0	applied	\N	\N	\N	\N	48313	48313	48314
13130	14361	1	applied	\N	\N	\N	\N	48315	48315	48316
13130	14362	2	applied	\N	\N	\N	\N	48317	48317	48318
13130	14363	3	applied	\N	\N	\N	\N	48319	48319	48320
13130	14364	4	applied	\N	\N	\N	\N	48321	48321	48322
13130	14365	5	applied	\N	\N	\N	\N	48323	48323	48324
13130	14366	6	applied	\N	\N	\N	\N	48325	48325	48326
13136	14388	0	applied	\N	\N	\N	\N	48372	48372	48373
13136	14389	1	applied	\N	\N	\N	\N	48374	48374	48375
13136	14390	2	applied	\N	\N	\N	\N	48376	48376	48377
13136	14391	3	applied	\N	\N	\N	\N	48378	48378	48379
13138	14392	0	applied	\N	\N	\N	\N	48383	48383	48384
13138	14393	1	applied	\N	\N	\N	\N	48385	48385	48386
13138	14394	2	applied	\N	\N	\N	\N	48387	48387	48388
13138	14395	3	applied	\N	\N	\N	\N	48389	48389	48390
13145	14404	0	applied	\N	\N	\N	\N	48415	48415	48416
13145	14405	1	applied	\N	\N	\N	\N	48417	48417	48418
13145	14406	2	applied	\N	\N	\N	\N	48419	48419	48420
13146	14407	0	applied	\N	\N	\N	\N	48422	48422	48423
13146	14408	1	applied	\N	\N	\N	\N	48424	48424	48425
13146	14409	2	applied	\N	\N	\N	\N	48426	48426	48427
13146	14410	3	applied	\N	\N	\N	\N	48428	48428	48429
13146	14411	4	applied	\N	\N	\N	\N	48430	48430	48431
13146	14412	5	applied	\N	\N	\N	\N	48432	48432	48433
13146	14413	6	applied	\N	\N	\N	\N	48434	48434	48435
13151	14428	0	applied	\N	\N	\N	\N	48467	48467	48468
13151	14429	1	applied	\N	\N	\N	\N	48469	48469	48470
13151	14433	2	applied	\N	\N	\N	\N	48481	48481	48482
13151	14430	3	applied	\N	\N	\N	\N	48471	48471	48472
13151	14431	4	applied	\N	\N	\N	\N	48473	48473	48474
13151	14432	5	applied	\N	\N	\N	\N	48475	48475	48476
13151	14434	6	applied	\N	\N	\N	\N	48483	48483	48484
13158	14444	0	applied	\N	\N	\N	\N	48511	48511	48512
13158	14445	1	applied	\N	\N	\N	\N	48513	48513	48514
13160	14448	0	applied	\N	\N	\N	\N	48524	48524	48525
13160	14449	1	applied	\N	\N	\N	\N	48526	48526	48527
13160	14446	2	applied	\N	\N	\N	\N	48515	48515	48516
13160	14447	3	applied	\N	\N	\N	\N	48517	48517	48518
13160	14450	4	applied	\N	\N	\N	\N	48528	48528	48529
13160	14451	5	applied	\N	\N	\N	\N	48530	48530	48531
13166	14463	0	applied	\N	\N	\N	\N	48562	48562	48563
13166	14464	1	applied	\N	\N	\N	\N	48564	48564	48565
13166	14465	2	applied	\N	\N	\N	\N	48566	48566	48567
13166	14466	3	applied	\N	\N	\N	\N	48568	48568	48569
13166	14467	4	applied	\N	\N	\N	\N	48570	48570	48571
13167	14468	0	applied	\N	\N	\N	\N	48577	48577	48578
13167	14469	1	applied	\N	\N	\N	\N	48579	48579	48580
13172	14475	0	applied	\N	\N	\N	\N	48601	48601	48602
13172	14476	1	applied	\N	\N	\N	\N	48603	48603	48604
13172	14477	2	applied	\N	\N	\N	\N	48605	48605	48606
13172	14478	3	applied	\N	\N	\N	\N	48607	48607	48608
13178	14489	0	applied	\N	\N	\N	\N	48636	48636	48637
13178	14490	1	applied	\N	\N	\N	\N	48638	48638	48639
13178	14491	2	applied	\N	\N	\N	\N	48640	48640	48641
13178	14492	4	applied	\N	\N	\N	\N	48643	48643	48644
13178	14493	5	applied	\N	\N	\N	\N	48645	48645	48646
13178	14494	6	applied	\N	\N	\N	\N	48647	48647	48648
13178	14495	7	applied	\N	\N	\N	\N	48649	48649	48650
13178	14496	8	applied	\N	\N	\N	\N	48651	48651	48652
13178	14497	9	applied	\N	\N	\N	\N	48653	48653	48654
13178	14498	10	applied	\N	\N	\N	\N	48655	48655	48656
13178	14499	11	applied	\N	\N	\N	\N	48657	48657	48658
13178	14500	12	applied	\N	\N	\N	\N	48659	48659	48660
13180	14501	0	applied	\N	\N	\N	\N	48669	48669	48670
13180	14502	1	applied	\N	\N	\N	\N	48671	48671	48672
13180	14503	2	applied	\N	\N	\N	\N	48673	48673	48674
13180	14504	3	applied	\N	\N	\N	\N	48675	48675	48676
13180	14505	4	applied	\N	\N	\N	\N	48677	48677	48678
13180	14506	5	applied	\N	\N	\N	\N	48679	48679	48680
13180	14507	6	applied	\N	\N	\N	\N	48681	48681	48682
13180	14508	7	applied	\N	\N	\N	\N	48683	48683	48684
13180	14509	8	applied	\N	\N	\N	\N	48685	48685	48686
13189	14536	0	applied	\N	\N	\N	\N	48755	48755	48756
13189	14537	1	applied	\N	\N	\N	\N	48757	48757	48758
13189	14538	2	applied	\N	\N	\N	\N	48759	48759	48760
13189	14539	3	applied	\N	\N	\N	\N	48761	48761	48762
13189	14540	4	applied	\N	\N	\N	\N	48763	48763	48764
13189	14541	5	applied	\N	\N	\N	\N	48765	48765	48766
13189	14542	6	applied	\N	\N	\N	\N	48767	48767	48768
13189	14543	7	applied	\N	\N	\N	\N	48769	48769	48770
13189	14544	8	applied	\N	\N	\N	\N	48771	48771	48772
13192	14545	0	applied	\N	\N	\N	\N	48775	48775	48776
13192	14539	1	applied	\N	\N	\N	\N	48761	48761	48762
13121	14329	3	applied	\N	\N	\N	\N	48237	48237	48238
13121	14330	4	applied	\N	\N	\N	\N	48239	48239	48240
13121	14331	5	applied	\N	\N	\N	\N	48241	48241	48242
13121	14332	6	applied	\N	\N	\N	\N	48243	48243	48244
13121	14333	7	applied	\N	\N	\N	\N	48245	48245	48246
13121	14334	8	applied	\N	\N	\N	\N	48247	48247	48248
13121	14335	9	applied	\N	\N	\N	\N	48249	48249	48250
13121	14336	10	applied	\N	\N	\N	\N	48251	48251	48252
13121	14337	11	applied	\N	\N	\N	\N	48253	48253	48254
13127	14348	0	applied	\N	\N	\N	\N	48285	48285	48286
13127	14349	1	applied	\N	\N	\N	\N	48287	48287	48288
13127	14350	2	applied	\N	\N	\N	\N	48289	48289	48290
13127	14351	3	applied	\N	\N	\N	\N	48291	48291	48292
13127	14352	4	applied	\N	\N	\N	\N	48293	48293	48294
13127	14353	5	applied	\N	\N	\N	\N	48295	48295	48296
13127	14354	6	applied	\N	\N	\N	\N	48297	48297	48298
13127	14355	7	applied	\N	\N	\N	\N	48299	48299	48300
13127	14356	8	applied	\N	\N	\N	\N	48301	48301	48302
13127	14357	9	applied	\N	\N	\N	\N	48303	48303	48304
13127	14358	10	applied	\N	\N	\N	\N	48305	48305	48306
13127	14359	11	applied	\N	\N	\N	\N	48307	48307	48308
13129	14348	0	applied	\N	\N	\N	\N	48285	48285	48286
13129	14349	1	applied	\N	\N	\N	\N	48287	48287	48288
13129	14351	2	applied	\N	\N	\N	\N	48291	48291	48292
13129	14352	3	applied	\N	\N	\N	\N	48293	48293	48294
13129	14353	4	applied	\N	\N	\N	\N	48295	48295	48296
13129	14354	5	applied	\N	\N	\N	\N	48297	48297	48298
13129	14355	6	applied	\N	\N	\N	\N	48299	48299	48300
13129	14356	7	applied	\N	\N	\N	\N	48301	48301	48302
13129	14357	8	applied	\N	\N	\N	\N	48303	48303	48304
13129	14358	9	applied	\N	\N	\N	\N	48305	48305	48306
13132	14367	0	applied	\N	\N	\N	\N	48328	48328	48329
13132	14368	1	applied	\N	\N	\N	\N	48330	48330	48331
13132	14369	2	applied	\N	\N	\N	\N	48332	48332	48333
13132	14370	3	applied	\N	\N	\N	\N	48334	48334	48335
13132	14371	4	applied	\N	\N	\N	\N	48336	48336	48337
13132	14372	5	applied	\N	\N	\N	\N	48338	48338	48339
13132	14373	6	applied	\N	\N	\N	\N	48340	48340	48341
13132	14374	7	applied	\N	\N	\N	\N	48342	48342	48343
13132	14375	8	applied	\N	\N	\N	\N	48344	48344	48345
13132	14376	9	applied	\N	\N	\N	\N	48346	48346	48347
13132	14377	10	applied	\N	\N	\N	\N	48348	48348	48349
13132	14378	11	applied	\N	\N	\N	\N	48350	48350	48351
13132	14379	12	applied	\N	\N	\N	\N	48352	48352	48353
13132	14380	13	applied	\N	\N	\N	\N	48354	48354	48355
13132	14381	14	applied	\N	\N	\N	\N	48356	48356	48357
13132	14382	15	applied	\N	\N	\N	\N	48358	48358	48359
13132	14383	16	applied	\N	\N	\N	\N	48360	48360	48361
13137	14388	0	applied	\N	\N	\N	\N	48372	48372	48373
13137	14389	1	applied	\N	\N	\N	\N	48374	48374	48375
13137	14390	2	applied	\N	\N	\N	\N	48376	48376	48377
13142	14396	0	applied	\N	\N	\N	\N	48396	48396	48397
13142	14397	2	applied	\N	\N	\N	\N	48399	48399	48400
13142	14398	3	applied	\N	\N	\N	\N	48401	48401	48402
13142	14399	4	applied	\N	\N	\N	\N	48403	48403	48404
13142	14400	5	applied	\N	\N	\N	\N	48405	48405	48406
13142	14401	6	applied	\N	\N	\N	\N	48407	48407	48408
13142	14402	7	applied	\N	\N	\N	\N	48409	48409	48410
13142	14403	8	applied	\N	\N	\N	\N	48411	48411	48412
13144	14404	0	applied	\N	\N	\N	\N	48415	48415	48416
13144	14405	1	applied	\N	\N	\N	\N	48417	48417	48418
13144	14406	2	applied	\N	\N	\N	\N	48419	48419	48420
13153	14433	0	applied	\N	\N	\N	\N	48481	48481	48482
13153	14434	1	applied	\N	\N	\N	\N	48483	48483	48484
13154	14435	0	applied	\N	\N	\N	\N	48490	48490	48491
13154	14436	1	applied	\N	\N	\N	\N	48492	48492	48493
13154	14437	2	applied	\N	\N	\N	\N	48494	48494	48495
13154	14438	3	applied	\N	\N	\N	\N	48496	48496	48497
13154	14439	4	applied	\N	\N	\N	\N	48498	48498	48499
13154	14440	5	applied	\N	\N	\N	\N	48500	48500	48501
13154	14441	6	applied	\N	\N	\N	\N	48502	48502	48503
13154	14442	7	applied	\N	\N	\N	\N	48504	48504	48505
13154	14443	8	applied	\N	\N	\N	\N	48506	48506	48507
13157	14444	0	applied	\N	\N	\N	\N	48511	48511	48512
13157	14445	1	applied	\N	\N	\N	\N	48513	48513	48514
13157	14446	2	applied	\N	\N	\N	\N	48515	48515	48516
13157	14447	3	applied	\N	\N	\N	\N	48517	48517	48518
13164	14463	0	applied	\N	\N	\N	\N	48562	48562	48563
13164	14464	1	applied	\N	\N	\N	\N	48564	48564	48565
13164	14465	2	applied	\N	\N	\N	\N	48566	48566	48567
13164	14466	3	applied	\N	\N	\N	\N	48568	48568	48569
13164	14467	4	applied	\N	\N	\N	\N	48570	48570	48571
13169	14470	0	applied	\N	\N	\N	\N	48583	48583	48584
13169	14471	1	applied	\N	\N	\N	\N	48585	48585	48586
13174	14475	0	applied	\N	\N	\N	\N	48601	48601	48602
13174	14476	1	applied	\N	\N	\N	\N	48603	48603	48604
13174	14477	2	applied	\N	\N	\N	\N	48605	48605	48606
13174	14478	3	applied	\N	\N	\N	\N	48607	48607	48608
13176	14479	0	applied	\N	\N	\N	\N	48613	48613	48614
13176	14480	1	applied	\N	\N	\N	\N	48615	48615	48616
13176	14481	2	applied	\N	\N	\N	\N	48617	48617	48618
13176	14482	3	applied	\N	\N	\N	\N	48619	48619	48620
13176	14483	4	applied	\N	\N	\N	\N	48621	48621	48622
13176	14484	5	applied	\N	\N	\N	\N	48623	48623	48624
13176	14485	6	applied	\N	\N	\N	\N	48625	48625	48626
13176	14486	7	applied	\N	\N	\N	\N	48627	48627	48628
13176	14487	8	applied	\N	\N	\N	\N	48629	48629	48630
13176	14488	9	applied	\N	\N	\N	\N	48631	48631	48632
13184	14515	0	applied	\N	\N	\N	\N	48706	48706	48707
13184	14516	1	applied	\N	\N	\N	\N	48708	48708	48709
13184	14517	2	applied	\N	\N	\N	\N	48710	48710	48711
13184	14518	3	applied	\N	\N	\N	\N	48712	48712	48713
13184	14519	4	applied	\N	\N	\N	\N	48714	48714	48715
13184	14520	5	applied	\N	\N	\N	\N	48716	48716	48717
13187	14523	0	applied	\N	\N	\N	\N	48725	48725	48726
13187	14524	1	applied	\N	\N	\N	\N	48727	48727	48728
13187	14525	2	applied	\N	\N	\N	\N	48729	48729	48730
13187	14526	3	applied	\N	\N	\N	\N	48731	48731	48732
13187	14527	4	applied	\N	\N	\N	\N	48733	48733	48734
13187	14528	5	applied	\N	\N	\N	\N	48735	48735	48736
13187	14529	6	applied	\N	\N	\N	\N	48737	48737	48738
13190	14536	0	applied	\N	\N	\N	\N	48755	48755	48756
13190	14537	1	applied	\N	\N	\N	\N	48757	48757	48758
13190	14538	2	applied	\N	\N	\N	\N	48759	48759	48760
13194	14539	0	applied	\N	\N	\N	\N	48761	48761	48762
13194	14540	1	applied	\N	\N	\N	\N	48763	48763	48764
13194	14541	2	applied	\N	\N	\N	\N	48765	48765	48766
13194	14542	3	applied	\N	\N	\N	\N	48767	48767	48768
13194	14543	4	applied	\N	\N	\N	\N	48769	48769	48770
13194	14544	5	applied	\N	\N	\N	\N	48771	48771	48772
13141	14401	6	applied	\N	\N	\N	\N	48407	48407	48408
13141	14402	7	applied	\N	\N	\N	\N	48409	48409	48410
13141	14403	8	applied	\N	\N	\N	\N	48411	48411	48412
13143	14404	0	applied	\N	\N	\N	\N	48415	48415	48416
13143	14405	1	applied	\N	\N	\N	\N	48417	48417	48418
13143	14406	2	applied	\N	\N	\N	\N	48419	48419	48420
13147	14407	0	applied	\N	\N	\N	\N	48422	48422	48423
13147	14408	1	applied	\N	\N	\N	\N	48424	48424	48425
13147	14409	2	applied	\N	\N	\N	\N	48426	48426	48427
13147	14410	3	applied	\N	\N	\N	\N	48428	48428	48429
13147	14411	4	applied	\N	\N	\N	\N	48430	48430	48431
13147	14412	5	applied	\N	\N	\N	\N	48432	48432	48433
13147	14413	6	applied	\N	\N	\N	\N	48434	48434	48435
13147	14414	7	applied	\N	\N	\N	\N	48437	48437	48438
13147	14415	8	applied	\N	\N	\N	\N	48439	48439	48440
13147	14416	9	applied	\N	\N	\N	\N	48441	48441	48442
13147	14417	10	applied	\N	\N	\N	\N	48443	48443	48444
13147	14418	11	applied	\N	\N	\N	\N	48445	48445	48446
13147	14419	12	applied	\N	\N	\N	\N	48447	48447	48448
13147	14420	13	applied	\N	\N	\N	\N	48449	48449	48450
13147	14421	14	applied	\N	\N	\N	\N	48451	48451	48452
13147	14422	15	applied	\N	\N	\N	\N	48453	48453	48454
13147	14423	16	applied	\N	\N	\N	\N	48455	48455	48456
13147	14424	17	applied	\N	\N	\N	\N	48457	48457	48458
13147	14425	18	applied	\N	\N	\N	\N	48459	48459	48460
13147	14426	19	applied	\N	\N	\N	\N	48461	48461	48462
13147	14427	20	applied	\N	\N	\N	\N	48463	48463	48464
13149	14428	0	applied	\N	\N	\N	\N	48467	48467	48468
13149	14429	1	applied	\N	\N	\N	\N	48469	48469	48470
13149	14430	2	applied	\N	\N	\N	\N	48471	48471	48472
13149	14431	3	applied	\N	\N	\N	\N	48473	48473	48474
13149	14432	4	applied	\N	\N	\N	\N	48475	48475	48476
13152	14433	0	applied	\N	\N	\N	\N	48481	48481	48482
13152	14434	1	applied	\N	\N	\N	\N	48483	48483	48484
13156	14444	0	applied	\N	\N	\N	\N	48511	48511	48512
13156	14445	1	applied	\N	\N	\N	\N	48513	48513	48514
13156	14446	2	applied	\N	\N	\N	\N	48515	48515	48516
13156	14447	3	applied	\N	\N	\N	\N	48517	48517	48518
13163	14462	0	applied	\N	\N	\N	\N	48559	48559	48560
13168	14470	0	applied	\N	\N	\N	\N	48583	48583	48584
13168	14471	1	applied	\N	\N	\N	\N	48585	48585	48586
13173	14475	0	applied	\N	\N	\N	\N	48601	48601	48602
13173	14476	1	applied	\N	\N	\N	\N	48603	48603	48604
13173	14477	2	applied	\N	\N	\N	\N	48605	48605	48606
13173	14478	3	applied	\N	\N	\N	\N	48607	48607	48608
13175	14479	0	applied	\N	\N	\N	\N	48613	48613	48614
13175	14480	1	applied	\N	\N	\N	\N	48615	48615	48616
13175	14481	2	applied	\N	\N	\N	\N	48617	48617	48618
13175	14482	3	applied	\N	\N	\N	\N	48619	48619	48620
13175	14483	4	applied	\N	\N	\N	\N	48621	48621	48622
13175	14484	5	applied	\N	\N	\N	\N	48623	48623	48624
13175	14485	6	applied	\N	\N	\N	\N	48625	48625	48626
13175	14486	7	applied	\N	\N	\N	\N	48627	48627	48628
13175	14487	8	applied	\N	\N	\N	\N	48629	48629	48630
13175	14488	9	applied	\N	\N	\N	\N	48631	48631	48632
13179	14489	0	applied	\N	\N	\N	\N	48636	48636	48637
13179	14490	1	applied	\N	\N	\N	\N	48638	48638	48639
13179	14491	2	applied	\N	\N	\N	\N	48640	48640	48641
13179	14492	4	applied	\N	\N	\N	\N	48643	48643	48644
13179	14493	5	applied	\N	\N	\N	\N	48645	48645	48646
13179	14494	6	applied	\N	\N	\N	\N	48647	48647	48648
13179	14495	7	applied	\N	\N	\N	\N	48649	48649	48650
13179	14496	8	applied	\N	\N	\N	\N	48651	48651	48652
13179	14497	9	applied	\N	\N	\N	\N	48653	48653	48654
13179	14498	10	applied	\N	\N	\N	\N	48655	48655	48656
13179	14499	11	applied	\N	\N	\N	\N	48657	48657	48658
13179	14500	12	applied	\N	\N	\N	\N	48659	48659	48660
13181	14510	0	applied	\N	\N	\N	\N	48689	48689	48690
13183	14407	0	applied	\N	\N	\N	\N	48422	48422	48423
13183	14428	1	applied	\N	\N	\N	\N	48467	48467	48468
13183	14448	2	applied	\N	\N	\N	\N	48524	48524	48525
13183	14435	3	applied	\N	\N	\N	\N	48490	48490	48491
13183	14454	4	applied	\N	\N	\N	\N	48541	48541	48542
13183	14436	5	applied	\N	\N	\N	\N	48492	48492	48493
13183	14476	6	applied	\N	\N	\N	\N	48603	48603	48604
13183	14481	7	applied	\N	\N	\N	\N	48617	48617	48618
13183	14439	8	applied	\N	\N	\N	\N	48498	48498	48499
13183	14444	9	applied	\N	\N	\N	\N	48511	48511	48512
13183	14482	10	applied	\N	\N	\N	\N	48619	48619	48620
13183	14489	11	applied	\N	\N	\N	\N	48636	48636	48637
13183	14491	12	applied	\N	\N	\N	\N	48640	48640	48641
13183	14492	13	applied	\N	\N	\N	\N	48643	48643	48644
13183	14304	14	applied	\N	\N	\N	\N	48176	48176	48177
13183	14308	15	applied	\N	\N	\N	\N	48187	48187	48188
13183	14311	16	applied	\N	\N	\N	\N	48196	48196	48197
13183	14314	17	applied	\N	\N	\N	\N	48202	48202	48203
13183	14315	18	applied	\N	\N	\N	\N	48204	48204	48205
13183	14322	19	applied	\N	\N	\N	\N	48222	48222	48223
13183	14326	20	applied	\N	\N	\N	\N	48231	48231	48232
13183	14327	21	applied	\N	\N	\N	\N	48233	48233	48234
13183	14328	22	applied	\N	\N	\N	\N	48235	48235	48236
13183	14338	23	applied	\N	\N	\N	\N	48257	48257	48258
13183	14341	24	applied	\N	\N	\N	\N	48265	48265	48266
13183	14345	25	applied	\N	\N	\N	\N	48275	48275	48276
13183	14348	26	applied	\N	\N	\N	\N	48285	48285	48286
13183	14349	27	applied	\N	\N	\N	\N	48287	48287	48288
13183	14350	28	applied	\N	\N	\N	\N	48289	48289	48290
13183	14360	29	applied	\N	\N	\N	\N	48313	48313	48314
13183	14367	30	applied	\N	\N	\N	\N	48328	48328	48329
13183	14368	31	applied	\N	\N	\N	\N	48330	48330	48331
13183	14369	32	applied	\N	\N	\N	\N	48332	48332	48333
13183	14370	33	applied	\N	\N	\N	\N	48334	48334	48335
13183	14371	34	applied	\N	\N	\N	\N	48336	48336	48337
13183	14384	35	applied	\N	\N	\N	\N	48364	48364	48365
13183	14388	36	applied	\N	\N	\N	\N	48372	48372	48373
13183	14392	37	applied	\N	\N	\N	\N	48383	48383	48384
13183	14396	38	applied	\N	\N	\N	\N	48396	48396	48397
13183	14397	39	applied	\N	\N	\N	\N	48399	48399	48400
13183	14404	40	applied	\N	\N	\N	\N	48415	48415	48416
13183	14408	41	applied	\N	\N	\N	\N	48424	48424	48425
13183	14409	42	applied	\N	\N	\N	\N	48426	48426	48427
13183	14410	43	applied	\N	\N	\N	\N	48428	48428	48429
13183	14411	44	applied	\N	\N	\N	\N	48430	48430	48431
13183	14412	45	applied	\N	\N	\N	\N	48432	48432	48433
13183	14413	46	applied	\N	\N	\N	\N	48434	48434	48435
13183	14429	47	applied	\N	\N	\N	\N	48469	48469	48470
13183	14433	48	applied	\N	\N	\N	\N	48481	48481	48482
13183	14437	49	applied	\N	\N	\N	\N	48494	48494	48495
13183	14438	50	applied	\N	\N	\N	\N	48496	48496	48497
13183	14445	51	applied	\N	\N	\N	\N	48513	48513	48514
13161	14449	1	applied	\N	\N	\N	\N	48526	48526	48527
13161	14450	2	applied	\N	\N	\N	\N	48528	48528	48529
13161	14451	3	applied	\N	\N	\N	\N	48530	48530	48531
13162	14452	0	applied	\N	\N	\N	\N	48537	48537	48538
13162	14453	1	applied	\N	\N	\N	\N	48539	48539	48540
13162	14454	2	applied	\N	\N	\N	\N	48541	48541	48542
13162	14455	3	applied	\N	\N	\N	\N	48543	48543	48544
13162	14456	4	applied	\N	\N	\N	\N	48545	48545	48546
13162	14457	5	applied	\N	\N	\N	\N	48547	48547	48548
13162	14458	6	applied	\N	\N	\N	\N	48549	48549	48550
13162	14459	7	applied	\N	\N	\N	\N	48551	48551	48552
13162	14460	8	applied	\N	\N	\N	\N	48553	48553	48554
13162	14461	9	applied	\N	\N	\N	\N	48555	48555	48556
13165	14463	0	applied	\N	\N	\N	\N	48562	48562	48563
13165	14464	1	applied	\N	\N	\N	\N	48564	48564	48565
13165	14465	2	applied	\N	\N	\N	\N	48566	48566	48567
13165	14466	3	applied	\N	\N	\N	\N	48568	48568	48569
13165	14467	4	applied	\N	\N	\N	\N	48570	48570	48571
13170	14407	0	applied	\N	\N	\N	\N	48422	48422	48423
13170	14428	1	applied	\N	\N	\N	\N	48467	48467	48468
13170	14448	2	applied	\N	\N	\N	\N	48524	48524	48525
13170	14435	3	applied	\N	\N	\N	\N	48490	48490	48491
13170	14275	4	applied	\N	\N	\N	\N	48093	48093	48094
13170	14454	5	applied	\N	\N	\N	\N	48541	48541	48542
13170	14436	6	applied	\N	\N	\N	\N	48492	48492	48493
13170	14439	7	applied	\N	\N	\N	\N	48498	48498	48499
13170	14444	8	applied	\N	\N	\N	\N	48511	48511	48512
13170	14279	9	applied	\N	\N	\N	\N	48105	48105	48106
13170	14282	10	applied	\N	\N	\N	\N	48112	48112	48113
13170	14286	11	applied	\N	\N	\N	\N	48121	48121	48122
13170	14290	12	applied	\N	\N	\N	\N	48135	48135	48136
13170	14291	13	applied	\N	\N	\N	\N	48137	48137	48138
13170	14296	14	applied	\N	\N	\N	\N	48149	48149	48150
13170	14297	15	applied	\N	\N	\N	\N	48151	48151	48152
13170	14304	16	applied	\N	\N	\N	\N	48176	48176	48177
13170	14308	17	applied	\N	\N	\N	\N	48187	48187	48188
13170	14311	18	applied	\N	\N	\N	\N	48196	48196	48197
13170	14314	19	applied	\N	\N	\N	\N	48202	48202	48203
13170	14315	20	applied	\N	\N	\N	\N	48204	48204	48205
13170	14322	21	applied	\N	\N	\N	\N	48222	48222	48223
13170	14326	22	applied	\N	\N	\N	\N	48231	48231	48232
13170	14327	23	applied	\N	\N	\N	\N	48233	48233	48234
13170	14328	24	applied	\N	\N	\N	\N	48235	48235	48236
13170	14338	25	applied	\N	\N	\N	\N	48257	48257	48258
13170	14341	26	applied	\N	\N	\N	\N	48265	48265	48266
13170	14345	27	applied	\N	\N	\N	\N	48275	48275	48276
13170	14348	28	applied	\N	\N	\N	\N	48285	48285	48286
13170	14349	29	applied	\N	\N	\N	\N	48287	48287	48288
13170	14350	30	applied	\N	\N	\N	\N	48289	48289	48290
13170	14360	31	applied	\N	\N	\N	\N	48313	48313	48314
13170	14367	32	applied	\N	\N	\N	\N	48328	48328	48329
13170	14368	33	applied	\N	\N	\N	\N	48330	48330	48331
13170	14369	34	applied	\N	\N	\N	\N	48332	48332	48333
13170	14370	35	applied	\N	\N	\N	\N	48334	48334	48335
13170	14371	36	applied	\N	\N	\N	\N	48336	48336	48337
13170	14384	38	applied	\N	\N	\N	\N	48364	48364	48365
13170	14388	39	applied	\N	\N	\N	\N	48372	48372	48373
13170	14392	40	applied	\N	\N	\N	\N	48383	48383	48384
13170	14396	41	applied	\N	\N	\N	\N	48396	48396	48397
13170	14397	42	applied	\N	\N	\N	\N	48399	48399	48400
13170	14404	43	applied	\N	\N	\N	\N	48415	48415	48416
13170	14408	44	applied	\N	\N	\N	\N	48424	48424	48425
13170	14409	45	applied	\N	\N	\N	\N	48426	48426	48427
13170	14410	46	applied	\N	\N	\N	\N	48428	48428	48429
13170	14411	47	applied	\N	\N	\N	\N	48430	48430	48431
13170	14412	48	applied	\N	\N	\N	\N	48432	48432	48433
13170	14413	49	applied	\N	\N	\N	\N	48434	48434	48435
13170	14429	50	applied	\N	\N	\N	\N	48469	48469	48470
13170	14433	51	applied	\N	\N	\N	\N	48481	48481	48482
13170	14437	52	applied	\N	\N	\N	\N	48494	48494	48495
13170	14438	53	applied	\N	\N	\N	\N	48496	48496	48497
13170	14445	54	applied	\N	\N	\N	\N	48513	48513	48514
13170	14449	55	applied	\N	\N	\N	\N	48526	48526	48527
13170	14452	56	applied	\N	\N	\N	\N	48537	48537	48538
13170	14453	57	applied	\N	\N	\N	\N	48539	48539	48540
13170	14455	58	applied	\N	\N	\N	\N	48543	48543	48544
13170	14462	59	applied	\N	\N	\N	\N	48559	48559	48560
13170	14463	60	applied	\N	\N	\N	\N	48562	48562	48563
13170	14468	61	applied	\N	\N	\N	\N	48577	48577	48578
13170	14276	62	applied	\N	\N	\N	\N	48095	48095	48096
13170	14277	63	applied	\N	\N	\N	\N	48097	48097	48098
13170	14278	64	applied	\N	\N	\N	\N	48099	48099	48100
13170	14280	65	applied	\N	\N	\N	\N	48107	48107	48108
13170	14281	66	applied	\N	\N	\N	\N	48109	48109	48110
13170	14283	67	applied	\N	\N	\N	\N	48114	48114	48115
13170	14284	68	applied	\N	\N	\N	\N	48116	48116	48117
13170	14285	69	applied	\N	\N	\N	\N	48118	48118	48119
13170	14287	70	applied	\N	\N	\N	\N	48126	48126	48127
13170	14288	71	applied	\N	\N	\N	\N	48128	48128	48129
13170	14289	72	applied	\N	\N	\N	\N	48130	48130	48131
13170	14292	73	applied	\N	\N	\N	\N	48139	48139	48140
13170	14293	74	applied	\N	\N	\N	\N	48141	48141	48142
13170	14294	75	applied	\N	\N	\N	\N	48143	48143	48144
13170	14295	76	applied	\N	\N	\N	\N	48145	48145	48146
13170	14298	77	applied	\N	\N	\N	\N	48153	48153	48154
13170	14299	78	applied	\N	\N	\N	\N	48155	48155	48156
13170	14300	79	applied	\N	\N	\N	\N	48157	48157	48158
13170	14301	80	applied	\N	\N	\N	\N	48159	48159	48160
13170	14302	81	applied	\N	\N	\N	\N	48162	48162	48163
13170	14303	82	applied	\N	\N	\N	\N	48164	48164	48165
13170	14305	83	applied	\N	\N	\N	\N	48178	48178	48179
13170	14306	84	applied	\N	\N	\N	\N	48180	48180	48181
13170	14307	85	applied	\N	\N	\N	\N	48182	48182	48183
13170	14309	86	applied	\N	\N	\N	\N	48189	48189	48190
13170	14310	87	applied	\N	\N	\N	\N	48191	48191	48192
13170	14312	88	applied	\N	\N	\N	\N	48198	48198	48199
13170	14313	89	applied	\N	\N	\N	\N	48200	48200	48201
13170	14316	90	applied	\N	\N	\N	\N	48206	48206	48207
13170	14317	91	applied	\N	\N	\N	\N	48208	48208	48209
13170	14318	92	applied	\N	\N	\N	\N	48210	48210	48211
13170	14319	93	applied	\N	\N	\N	\N	48212	48212	48213
13170	14320	94	applied	\N	\N	\N	\N	48214	48214	48215
13170	14321	95	applied	\N	\N	\N	\N	48216	48216	48217
13170	14323	96	applied	\N	\N	\N	\N	48224	48224	48225
13170	14324	97	applied	\N	\N	\N	\N	48226	48226	48227
13170	14325	98	applied	\N	\N	\N	\N	48228	48228	48229
13170	14329	99	applied	\N	\N	\N	\N	48237	48237	48238
13170	14330	100	applied	\N	\N	\N	\N	48239	48239	48240
13170	14331	101	applied	\N	\N	\N	\N	48241	48241	48242
13170	14332	102	applied	\N	\N	\N	\N	48243	48243	48244
13170	14333	103	applied	\N	\N	\N	\N	48245	48245	48246
13170	14334	104	applied	\N	\N	\N	\N	48247	48247	48248
13170	14335	105	applied	\N	\N	\N	\N	48249	48249	48250
13170	14336	106	applied	\N	\N	\N	\N	48251	48251	48252
13170	14337	107	applied	\N	\N	\N	\N	48253	48253	48254
13170	14339	108	applied	\N	\N	\N	\N	48259	48259	48260
13170	14340	109	applied	\N	\N	\N	\N	48261	48261	48262
13170	14342	110	applied	\N	\N	\N	\N	48267	48267	48268
13170	14343	111	applied	\N	\N	\N	\N	48269	48269	48270
13170	14344	112	applied	\N	\N	\N	\N	48271	48271	48272
13170	14346	113	applied	\N	\N	\N	\N	48277	48277	48278
13170	14347	114	applied	\N	\N	\N	\N	48279	48279	48280
13170	14351	115	applied	\N	\N	\N	\N	48291	48291	48292
13170	14352	116	applied	\N	\N	\N	\N	48293	48293	48294
13170	14353	117	applied	\N	\N	\N	\N	48295	48295	48296
13170	14354	118	applied	\N	\N	\N	\N	48297	48297	48298
13170	14355	119	applied	\N	\N	\N	\N	48299	48299	48300
13170	14356	120	applied	\N	\N	\N	\N	48301	48301	48302
13170	14357	121	applied	\N	\N	\N	\N	48303	48303	48304
13170	14358	122	applied	\N	\N	\N	\N	48305	48305	48306
13170	14359	123	applied	\N	\N	\N	\N	48307	48307	48308
13170	14361	124	applied	\N	\N	\N	\N	48315	48315	48316
13170	14362	125	applied	\N	\N	\N	\N	48317	48317	48318
13171	14472	0	applied	\N	\N	\N	\N	48594	48594	48595
13171	14473	1	applied	\N	\N	\N	\N	48596	48596	48597
13171	14474	2	applied	\N	\N	\N	\N	48598	48598	48599
13177	14489	0	applied	\N	\N	\N	\N	48636	48636	48637
13177	14490	1	applied	\N	\N	\N	\N	48638	48638	48639
13177	14491	2	applied	\N	\N	\N	\N	48640	48640	48641
13177	14492	4	applied	\N	\N	\N	\N	48643	48643	48644
13177	14493	5	applied	\N	\N	\N	\N	48645	48645	48646
13177	14494	6	applied	\N	\N	\N	\N	48647	48647	48648
13177	14495	7	applied	\N	\N	\N	\N	48649	48649	48650
13177	14496	8	applied	\N	\N	\N	\N	48651	48651	48652
13177	14497	9	applied	\N	\N	\N	\N	48653	48653	48654
13177	14498	10	applied	\N	\N	\N	\N	48655	48655	48656
13177	14499	11	applied	\N	\N	\N	\N	48657	48657	48658
13177	14500	12	applied	\N	\N	\N	\N	48659	48659	48660
13182	14511	0	applied	\N	\N	\N	\N	48693	48693	48694
13182	14512	1	applied	\N	\N	\N	\N	48695	48695	48696
13182	14513	2	applied	\N	\N	\N	\N	48697	48697	48698
13182	14514	3	applied	\N	\N	\N	\N	48699	48699	48700
13185	14515	0	applied	\N	\N	\N	\N	48706	48706	48707
13185	14516	1	applied	\N	\N	\N	\N	48708	48708	48709
13188	14530	0	applied	\N	\N	\N	\N	48741	48741	48742
13188	14531	1	applied	\N	\N	\N	\N	48743	48743	48744
13188	14532	2	applied	\N	\N	\N	\N	48745	48745	48746
13188	14533	3	applied	\N	\N	\N	\N	48747	48747	48748
13188	14534	4	applied	\N	\N	\N	\N	48749	48749	48750
13188	14535	5	applied	\N	\N	\N	\N	48751	48751	48752
13191	14545	0	applied	\N	\N	\N	\N	48775	48775	48776
13191	14539	1	applied	\N	\N	\N	\N	48761	48761	48762
13191	14540	2	applied	\N	\N	\N	\N	48763	48763	48764
13191	14541	3	applied	\N	\N	\N	\N	48765	48765	48766
13191	14542	4	applied	\N	\N	\N	\N	48767	48767	48768
13191	14543	5	applied	\N	\N	\N	\N	48769	48769	48770
13191	14544	6	applied	\N	\N	\N	\N	48771	48771	48772
13195	14545	0	applied	\N	\N	\N	\N	48775	48775	48776
13195	14548	1	applied	\N	\N	\N	\N	48788	48788	48789
13201	14559	0	applied	\N	\N	\N	\N	48817	48817	48818
13201	14560	1	applied	\N	\N	\N	\N	48819	48819	48820
13201	14561	2	applied	\N	\N	\N	\N	48821	48821	48822
13201	14562	3	applied	\N	\N	\N	\N	48823	48823	48824
13201	14563	4	applied	\N	\N	\N	\N	48825	48825	48826
13201	14564	5	applied	\N	\N	\N	\N	48827	48827	48828
13206	14568	0	applied	\N	\N	\N	\N	48841	48841	48842
13207	14571	0	applied	\N	\N	\N	\N	48851	48851	48852
13207	14572	1	applied	\N	\N	\N	\N	48853	48853	48854
13207	14573	2	applied	\N	\N	\N	\N	48855	48855	48856
13210	14580	0	applied	\N	\N	\N	\N	48872	48872	48873
13210	14581	2	applied	\N	\N	\N	\N	48875	48875	48876
13210	14582	3	applied	\N	\N	\N	\N	48877	48877	48878
13210	14583	4	applied	\N	\N	\N	\N	48879	48879	48880
13210	14584	5	applied	\N	\N	\N	\N	48881	48881	48882
13210	14585	6	applied	\N	\N	\N	\N	48883	48883	48884
13213	14589	0	applied	\N	\N	\N	\N	48898	48898	48899
13213	14590	1	applied	\N	\N	\N	\N	48900	48900	48901
13213	14591	2	applied	\N	\N	\N	\N	48902	48902	48903
13213	14592	3	applied	\N	\N	\N	\N	48904	48904	48905
13213	14593	4	applied	\N	\N	\N	\N	48906	48906	48907
13215	14594	0	applied	\N	\N	\N	\N	48910	48910	48911
13215	14595	1	applied	\N	\N	\N	\N	48912	48912	48913
13215	14596	2	applied	\N	\N	\N	\N	48914	48914	48915
13218	14600	0	applied	\N	\N	\N	\N	48928	48928	48929
13218	14601	1	applied	\N	\N	\N	\N	48930	48930	48931
13218	14602	2	applied	\N	\N	\N	\N	48932	48932	48933
13218	14603	3	applied	\N	\N	\N	\N	48934	48934	48935
13218	14604	4	applied	\N	\N	\N	\N	48936	48936	48937
13218	14605	5	applied	\N	\N	\N	\N	48938	48938	48939
13220	14606	0	applied	\N	\N	\N	\N	48943	48943	48944
13220	14602	1	applied	\N	\N	\N	\N	48932	48932	48933
13220	14603	2	applied	\N	\N	\N	\N	48934	48934	48935
13220	14604	3	applied	\N	\N	\N	\N	48936	48936	48937
13220	14605	4	applied	\N	\N	\N	\N	48938	48938	48939
13220	14607	5	applied	\N	\N	\N	\N	48945	48945	48946
13220	14608	6	applied	\N	\N	\N	\N	48947	48947	48948
13223	14609	0	applied	\N	\N	\N	\N	48953	48953	48954
13232	14618	0	applied	\N	\N	\N	\N	48983	48983	48984
13232	14619	1	applied	\N	\N	\N	\N	48986	48986	48987
13236	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13236	14621	1	applied	\N	\N	\N	\N	49001	49001	49002
13239	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13242	14482	0	applied	\N	\N	\N	\N	48619	48619	48620
13242	14489	1	applied	\N	\N	\N	\N	48636	48636	48637
13242	14491	2	applied	\N	\N	\N	\N	48640	48640	48641
13242	14492	3	applied	\N	\N	\N	\N	48643	48643	48644
13244	14625	0	applied	\N	\N	\N	\N	49017	49017	49018
13244	14626	1	applied	\N	\N	\N	\N	49019	49019	49020
13244	14627	2	applied	\N	\N	\N	\N	49021	49021	49022
13244	14628	3	applied	\N	\N	\N	\N	49023	49023	49024
13246	14629	0	applied	\N	\N	\N	\N	49028	49028	49029
13251	14636	0	applied	\N	\N	\N	\N	49052	49052	49053
13251	14637	1	applied	\N	\N	\N	\N	49054	49054	49055
13251	14638	2	applied	\N	\N	\N	\N	49056	49056	49057
13256	14648	0	applied	\N	\N	\N	\N	49083	49083	49084
13256	14649	1	applied	\N	\N	\N	\N	49085	49085	49086
13256	14650	2	applied	\N	\N	\N	\N	49087	49087	49088
13256	14651	3	applied	\N	\N	\N	\N	49089	49089	49090
13256	14652	4	applied	\N	\N	\N	\N	49091	49091	49092
13256	14653	5	applied	\N	\N	\N	\N	49093	49093	49094
13183	14449	52	applied	\N	\N	\N	\N	48526	48526	48527
13183	14452	53	applied	\N	\N	\N	\N	48537	48537	48538
13183	14453	54	applied	\N	\N	\N	\N	48539	48539	48540
13183	14455	55	applied	\N	\N	\N	\N	48543	48543	48544
13183	14462	56	applied	\N	\N	\N	\N	48559	48559	48560
13183	14463	57	applied	\N	\N	\N	\N	48562	48562	48563
13183	14468	58	applied	\N	\N	\N	\N	48577	48577	48578
13183	14470	59	applied	\N	\N	\N	\N	48583	48583	48584
13183	14472	60	applied	\N	\N	\N	\N	48594	48594	48595
13183	14475	61	applied	\N	\N	\N	\N	48601	48601	48602
13183	14479	62	applied	\N	\N	\N	\N	48613	48613	48614
13183	14480	63	applied	\N	\N	\N	\N	48615	48615	48616
13183	14483	64	applied	\N	\N	\N	\N	48621	48621	48622
13183	14490	65	applied	\N	\N	\N	\N	48638	48638	48639
13183	14493	66	applied	\N	\N	\N	\N	48645	48645	48646
13183	14494	67	applied	\N	\N	\N	\N	48647	48647	48648
13183	14501	68	applied	\N	\N	\N	\N	48669	48669	48670
13183	14502	69	applied	\N	\N	\N	\N	48671	48671	48672
13183	14503	70	applied	\N	\N	\N	\N	48673	48673	48674
13183	14510	71	applied	\N	\N	\N	\N	48689	48689	48690
13183	14511	72	applied	\N	\N	\N	\N	48693	48693	48694
13183	14305	73	applied	\N	\N	\N	\N	48178	48178	48179
13183	14306	74	applied	\N	\N	\N	\N	48180	48180	48181
13183	14307	75	applied	\N	\N	\N	\N	48182	48182	48183
13183	14309	76	applied	\N	\N	\N	\N	48189	48189	48190
13183	14310	77	applied	\N	\N	\N	\N	48191	48191	48192
13183	14312	78	applied	\N	\N	\N	\N	48198	48198	48199
13183	14313	79	applied	\N	\N	\N	\N	48200	48200	48201
13183	14316	80	applied	\N	\N	\N	\N	48206	48206	48207
13183	14317	81	applied	\N	\N	\N	\N	48208	48208	48209
13183	14318	82	applied	\N	\N	\N	\N	48210	48210	48211
13183	14319	83	applied	\N	\N	\N	\N	48212	48212	48213
13183	14320	84	applied	\N	\N	\N	\N	48214	48214	48215
13183	14321	85	applied	\N	\N	\N	\N	48216	48216	48217
13183	14323	86	applied	\N	\N	\N	\N	48224	48224	48225
13183	14324	87	applied	\N	\N	\N	\N	48226	48226	48227
13183	14325	88	applied	\N	\N	\N	\N	48228	48228	48229
13183	14329	89	applied	\N	\N	\N	\N	48237	48237	48238
13183	14330	90	applied	\N	\N	\N	\N	48239	48239	48240
13183	14331	91	applied	\N	\N	\N	\N	48241	48241	48242
13183	14332	92	applied	\N	\N	\N	\N	48243	48243	48244
13183	14333	93	applied	\N	\N	\N	\N	48245	48245	48246
13183	14334	94	applied	\N	\N	\N	\N	48247	48247	48248
13183	14335	95	applied	\N	\N	\N	\N	48249	48249	48250
13183	14336	96	applied	\N	\N	\N	\N	48251	48251	48252
13183	14337	97	applied	\N	\N	\N	\N	48253	48253	48254
13183	14339	98	applied	\N	\N	\N	\N	48259	48259	48260
13183	14340	99	applied	\N	\N	\N	\N	48261	48261	48262
13183	14342	100	applied	\N	\N	\N	\N	48267	48267	48268
13183	14343	101	applied	\N	\N	\N	\N	48269	48269	48270
13183	14344	102	applied	\N	\N	\N	\N	48271	48271	48272
13183	14346	103	applied	\N	\N	\N	\N	48277	48277	48278
13183	14347	104	applied	\N	\N	\N	\N	48279	48279	48280
13183	14351	105	applied	\N	\N	\N	\N	48291	48291	48292
13183	14352	106	applied	\N	\N	\N	\N	48293	48293	48294
13183	14353	107	applied	\N	\N	\N	\N	48295	48295	48296
13183	14354	108	applied	\N	\N	\N	\N	48297	48297	48298
13183	14355	109	applied	\N	\N	\N	\N	48299	48299	48300
13183	14356	110	applied	\N	\N	\N	\N	48301	48301	48302
13183	14357	111	applied	\N	\N	\N	\N	48303	48303	48304
13183	14358	112	applied	\N	\N	\N	\N	48305	48305	48306
13183	14359	113	applied	\N	\N	\N	\N	48307	48307	48308
13183	14361	114	applied	\N	\N	\N	\N	48315	48315	48316
13183	14362	115	applied	\N	\N	\N	\N	48317	48317	48318
13183	14363	116	applied	\N	\N	\N	\N	48319	48319	48320
13183	14364	117	applied	\N	\N	\N	\N	48321	48321	48322
13183	14365	118	applied	\N	\N	\N	\N	48323	48323	48324
13183	14366	119	applied	\N	\N	\N	\N	48325	48325	48326
13183	14372	120	applied	\N	\N	\N	\N	48338	48338	48339
13183	14373	121	applied	\N	\N	\N	\N	48340	48340	48341
13183	14374	122	applied	\N	\N	\N	\N	48342	48342	48343
13183	14375	124	applied	\N	\N	\N	\N	48344	48344	48345
13183	14376	125	applied	\N	\N	\N	\N	48346	48346	48347
13186	14521	0	applied	\N	\N	\N	\N	48721	48721	48722
13186	14522	1	applied	\N	\N	\N	\N	48723	48723	48724
13193	14539	0	applied	\N	\N	\N	\N	48761	48761	48762
13193	14540	1	applied	\N	\N	\N	\N	48763	48763	48764
13193	14541	2	applied	\N	\N	\N	\N	48765	48765	48766
13193	14542	3	applied	\N	\N	\N	\N	48767	48767	48768
13193	14543	4	applied	\N	\N	\N	\N	48769	48769	48770
13193	14544	5	applied	\N	\N	\N	\N	48771	48771	48772
13193	14546	6	applied	\N	\N	\N	\N	48779	48779	48780
13193	14547	7	applied	\N	\N	\N	\N	48781	48781	48782
13199	14554	0	applied	\N	\N	\N	\N	48806	48806	48807
13199	14555	1	applied	\N	\N	\N	\N	48808	48808	48809
13199	14556	2	applied	\N	\N	\N	\N	48810	48810	48811
13199	14557	3	applied	\N	\N	\N	\N	48812	48812	48813
13199	14558	4	applied	\N	\N	\N	\N	48814	48814	48815
13204	14568	0	applied	\N	\N	\N	\N	48841	48841	48842
13204	14569	1	applied	\N	\N	\N	\N	48843	48843	48844
13204	14570	2	applied	\N	\N	\N	\N	48845	48845	48846
13214	14589	0	applied	\N	\N	\N	\N	48898	48898	48899
13214	14590	1	applied	\N	\N	\N	\N	48900	48900	48901
13214	14591	2	applied	\N	\N	\N	\N	48902	48902	48903
13214	14592	3	applied	\N	\N	\N	\N	48904	48904	48905
13214	14593	4	applied	\N	\N	\N	\N	48906	48906	48907
13219	14600	0	applied	\N	\N	\N	\N	48928	48928	48929
13219	14601	1	applied	\N	\N	\N	\N	48930	48930	48931
13221	14606	0	applied	\N	\N	\N	\N	48943	48943	48944
13221	14602	1	applied	\N	\N	\N	\N	48932	48932	48933
13221	14603	2	applied	\N	\N	\N	\N	48934	48934	48935
13221	14604	3	applied	\N	\N	\N	\N	48936	48936	48937
13221	14605	4	applied	\N	\N	\N	\N	48938	48938	48939
13221	14607	5	applied	\N	\N	\N	\N	48945	48945	48946
13221	14608	6	applied	\N	\N	\N	\N	48947	48947	48948
13225	14609	0	applied	\N	\N	\N	\N	48953	48953	48954
13225	14610	1	applied	\N	\N	\N	\N	48955	48955	48956
13225	14611	2	applied	\N	\N	\N	\N	48957	48957	48958
13226	14448	0	applied	\N	\N	\N	\N	48524	48524	48525
13226	14435	1	applied	\N	\N	\N	\N	48490	48490	48491
13226	14454	2	applied	\N	\N	\N	\N	48541	48541	48542
13226	14436	3	applied	\N	\N	\N	\N	48492	48492	48493
13226	14476	4	applied	\N	\N	\N	\N	48603	48603	48604
13226	14481	5	applied	\N	\N	\N	\N	48617	48617	48618
13226	14437	6	applied	\N	\N	\N	\N	48494	48494	48495
13226	14438	7	applied	\N	\N	\N	\N	48496	48496	48497
13226	14445	8	applied	\N	\N	\N	\N	48513	48513	48514
13226	14449	9	applied	\N	\N	\N	\N	48526	48526	48527
13226	14452	10	applied	\N	\N	\N	\N	48537	48537	48538
13226	14453	11	applied	\N	\N	\N	\N	48539	48539	48540
13192	14540	2	applied	\N	\N	\N	\N	48763	48763	48764
13192	14541	3	applied	\N	\N	\N	\N	48765	48765	48766
13192	14542	4	applied	\N	\N	\N	\N	48767	48767	48768
13192	14543	5	applied	\N	\N	\N	\N	48769	48769	48770
13192	14544	6	applied	\N	\N	\N	\N	48771	48771	48772
13192	14546	7	applied	\N	\N	\N	\N	48779	48779	48780
13192	14547	8	applied	\N	\N	\N	\N	48781	48781	48782
13196	14545	0	applied	\N	\N	\N	\N	48775	48775	48776
13196	14548	1	applied	\N	\N	\N	\N	48788	48788	48789
13196	14546	2	applied	\N	\N	\N	\N	48779	48779	48780
13196	14547	3	applied	\N	\N	\N	\N	48781	48781	48782
13196	14549	4	applied	\N	\N	\N	\N	48792	48792	48793
13196	14550	5	applied	\N	\N	\N	\N	48794	48794	48795
13198	14551	0	applied	\N	\N	\N	\N	48799	48799	48800
13198	14552	1	applied	\N	\N	\N	\N	48801	48801	48802
13198	14553	2	applied	\N	\N	\N	\N	48803	48803	48804
13203	14566	0	applied	\N	\N	\N	\N	48835	48835	48836
13203	14567	1	applied	\N	\N	\N	\N	48837	48837	48838
13208	14574	0	applied	\N	\N	\N	\N	48857	48857	48858
13208	14575	1	applied	\N	\N	\N	\N	48859	48859	48860
13208	14576	2	applied	\N	\N	\N	\N	48861	48861	48862
13211	14580	0	applied	\N	\N	\N	\N	48872	48872	48873
13211	14581	2	applied	\N	\N	\N	\N	48875	48875	48876
13216	14597	0	applied	\N	\N	\N	\N	48917	48917	48918
13216	14598	1	applied	\N	\N	\N	\N	48919	48919	48920
13216	14599	2	applied	\N	\N	\N	\N	48921	48921	48922
13224	14609	0	applied	\N	\N	\N	\N	48953	48953	48954
13224	14610	1	applied	\N	\N	\N	\N	48955	48955	48956
13224	14611	2	applied	\N	\N	\N	\N	48957	48957	48958
13233	14618	0	applied	\N	\N	\N	\N	48983	48983	48984
13233	14619	1	applied	\N	\N	\N	\N	48986	48986	48987
13237	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13237	14621	1	applied	\N	\N	\N	\N	49001	49001	49002
13237	14622	2	applied	\N	\N	\N	\N	49005	49005	49006
13240	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13240	14621	1	applied	\N	\N	\N	\N	49001	49001	49002
13240	14622	2	applied	\N	\N	\N	\N	49005	49005	49006
13247	14631	0	applied	\N	\N	\N	\N	49035	49035	49036
13247	14630	1	applied	\N	\N	\N	\N	49030	49030	49031
13254	14642	0	applied	\N	\N	\N	\N	49069	49069	49070
13254	14643	1	applied	\N	\N	\N	\N	49071	49071	49072
13254	14644	2	applied	\N	\N	\N	\N	49073	49073	49074
13254	14645	3	applied	\N	\N	\N	\N	49075	49075	49076
13254	14646	4	applied	\N	\N	\N	\N	49077	49077	49078
13254	14647	5	applied	\N	\N	\N	\N	49079	49079	49080
13257	14654	0	applied	\N	\N	\N	\N	49097	49097	49098
13257	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13259	14658	0	applied	\N	\N	\N	\N	49107	49107	49108
13265	14664	0	applied	\N	\N	\N	\N	49124	49124	49125
13265	14665	1	applied	\N	\N	\N	\N	49126	49126	49127
13265	14666	2	applied	\N	\N	\N	\N	49128	49128	49129
13265	14667	3	applied	\N	\N	\N	\N	49130	49130	49131
13265	14668	4	applied	\N	\N	\N	\N	49132	49132	49133
13265	14669	5	applied	\N	\N	\N	\N	49135	49135	49136
13265	14670	6	applied	\N	\N	\N	\N	49137	49137	49138
13269	14674	0	applied	\N	\N	\N	\N	49152	49152	49153
13269	14675	1	applied	\N	\N	\N	\N	49154	49154	49155
13269	14676	2	applied	\N	\N	\N	\N	49156	49156	49157
13274	14677	0	applied	\N	\N	\N	\N	49164	49164	49165
13274	14678	1	applied	\N	\N	\N	\N	49166	49166	49167
13275	14677	0	applied	\N	\N	\N	\N	49164	49164	49165
13275	14678	1	applied	\N	\N	\N	\N	49166	49166	49167
13285	14703	0	applied	\N	\N	\N	\N	49233	49233	49234
13285	14704	1	applied	\N	\N	\N	\N	49235	49235	49236
13285	14705	2	applied	\N	\N	\N	\N	49237	49237	49238
13290	14712	0	applied	\N	\N	\N	\N	49259	49259	49260
13290	14713	1	applied	\N	\N	\N	\N	49261	49261	49262
13290	14714	2	applied	\N	\N	\N	\N	49263	49263	49264
13295	14727	0	applied	\N	\N	\N	\N	49297	49297	49298
13295	14728	1	applied	\N	\N	\N	\N	49299	49299	49300
13295	14729	2	applied	\N	\N	\N	\N	49301	49301	49302
13298	14740	0	applied	\N	\N	\N	\N	49328	49328	49329
13298	14741	1	applied	\N	\N	\N	\N	49330	49330	49331
13298	14742	2	applied	\N	\N	\N	\N	49332	49332	49333
13301	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13301	14658	1	applied	\N	\N	\N	\N	49107	49107	49108
13301	14659	2	applied	\N	\N	\N	\N	49111	49111	49112
13301	14664	3	applied	\N	\N	\N	\N	49124	49124	49125
13301	14665	4	applied	\N	\N	\N	\N	49126	49126	49127
13301	14671	5	applied	\N	\N	\N	\N	49141	49141	49142
13301	14672	6	applied	\N	\N	\N	\N	49147	49147	49148
13301	14674	8	applied	\N	\N	\N	\N	49152	49152	49153
13301	14677	9	applied	\N	\N	\N	\N	49164	49164	49165
13301	14679	10	applied	\N	\N	\N	\N	49175	49175	49176
13301	14682	11	applied	\N	\N	\N	\N	49183	49183	49184
13301	14685	12	applied	\N	\N	\N	\N	49190	49190	49191
13301	14686	13	applied	\N	\N	\N	\N	49192	49192	49193
13301	14687	14	applied	\N	\N	\N	\N	49194	49194	49195
13301	14694	15	applied	\N	\N	\N	\N	49210	49210	49211
13301	14660	16	applied	\N	\N	1000000000	\N	49113	49113	49114
13301	14731	17	applied	\N	\N	\N	\N	49306	49306	49307
13301	14697	18	applied	\N	\N	\N	\N	49220	49220	49221
13301	14698	19	applied	\N	\N	\N	\N	49222	49222	49223
13301	14703	20	applied	\N	\N	\N	\N	49233	49233	49234
13301	14706	21	applied	\N	\N	\N	\N	49241	49241	49242
13301	14709	22	applied	\N	\N	\N	\N	49249	49249	49250
13301	14712	23	applied	\N	\N	\N	\N	49259	49259	49260
13301	14715	24	applied	\N	\N	\N	\N	49267	49267	49268
13301	14716	25	applied	\N	\N	\N	\N	49269	49269	49270
13301	14721	26	applied	\N	\N	\N	\N	49283	49283	49284
13301	14722	27	applied	\N	\N	\N	\N	49285	49285	49286
13301	14727	28	applied	\N	\N	\N	\N	49297	49297	49298
13301	14730	29	applied	\N	\N	\N	\N	49304	49304	49305
13301	14735	30	applied	\N	\N	\N	\N	49316	49316	49317
13301	14736	31	applied	\N	\N	\N	\N	49318	49318	49319
13301	14740	32	applied	\N	\N	\N	\N	49328	49328	49329
13301	14743	33	applied	\N	\N	\N	\N	49338	49338	49339
13301	14746	34	applied	\N	\N	\N	\N	49347	49347	49348
13301	14747	35	applied	\N	\N	\N	\N	49349	49349	49350
13301	14723	36	applied	\N	\N	\N	\N	49287	49287	49288
13301	14661	37	applied	\N	\N	\N	\N	49115	49115	49116
13301	14662	38	applied	\N	\N	\N	\N	49117	49117	49118
13301	14663	39	applied	\N	\N	\N	\N	49120	49120	49121
13301	14666	40	applied	\N	\N	\N	\N	49128	49128	49129
13301	14667	41	applied	\N	\N	\N	\N	49130	49130	49131
13301	14668	42	applied	\N	\N	\N	\N	49132	49132	49133
13301	14669	43	applied	\N	\N	\N	\N	49135	49135	49136
13301	14670	44	applied	\N	\N	\N	\N	49137	49137	49138
13301	14673	45	applied	\N	\N	\N	\N	49149	49149	49150
13197	14545	0	applied	\N	\N	\N	\N	48775	48775	48776
13197	14548	1	applied	\N	\N	\N	\N	48788	48788	48789
13197	14546	2	applied	\N	\N	\N	\N	48779	48779	48780
13197	14547	3	applied	\N	\N	\N	\N	48781	48781	48782
13197	14549	4	applied	\N	\N	\N	\N	48792	48792	48793
13197	14550	5	applied	\N	\N	\N	\N	48794	48794	48795
13200	14559	0	applied	\N	\N	\N	\N	48817	48817	48818
13200	14560	1	applied	\N	\N	\N	\N	48819	48819	48820
13200	14561	2	applied	\N	\N	\N	\N	48821	48821	48822
13200	14562	3	applied	\N	\N	\N	\N	48823	48823	48824
13200	14563	4	applied	\N	\N	\N	\N	48825	48825	48826
13200	14564	5	applied	\N	\N	\N	\N	48827	48827	48828
13202	14565	0	applied	\N	\N	\N	\N	48833	48833	48834
13202	14566	1	applied	\N	\N	\N	\N	48835	48835	48836
13202	14567	2	applied	\N	\N	\N	\N	48837	48837	48838
13205	14568	0	applied	\N	\N	\N	\N	48841	48841	48842
13205	14569	1	applied	\N	\N	\N	\N	48843	48843	48844
13205	14570	2	applied	\N	\N	\N	\N	48845	48845	48846
13209	14577	0	applied	\N	\N	\N	\N	48865	48865	48866
13209	14578	1	applied	\N	\N	\N	\N	48867	48867	48868
13209	14579	2	applied	\N	\N	\N	\N	48869	48869	48870
13212	14586	0	applied	\N	\N	\N	\N	48891	48891	48892
13212	14582	1	applied	\N	\N	\N	\N	48877	48877	48878
13212	14583	2	applied	\N	\N	\N	\N	48879	48879	48880
13212	14584	3	applied	\N	\N	\N	\N	48881	48881	48882
13212	14585	4	applied	\N	\N	\N	\N	48883	48883	48884
13212	14587	5	applied	\N	\N	\N	\N	48893	48893	48894
13212	14588	6	applied	\N	\N	\N	\N	48895	48895	48896
13217	14515	0	applied	\N	\N	\N	\N	48706	48706	48707
13217	14516	1	applied	\N	\N	\N	\N	48708	48708	48709
13217	14521	2	applied	\N	\N	\N	\N	48721	48721	48722
13217	14522	3	applied	\N	\N	\N	\N	48723	48723	48724
13217	14523	4	applied	\N	\N	\N	\N	48725	48725	48726
13217	14530	5	applied	\N	\N	\N	\N	48741	48741	48742
13217	14531	6	applied	\N	\N	\N	\N	48743	48743	48744
13217	14536	7	applied	\N	\N	\N	\N	48755	48755	48756
13217	14537	8	applied	\N	\N	\N	\N	48757	48757	48758
13217	14538	9	applied	\N	\N	\N	\N	48759	48759	48760
13217	14545	10	applied	\N	\N	\N	\N	48775	48775	48776
13217	14548	11	applied	\N	\N	\N	\N	48788	48788	48789
13217	14551	12	applied	\N	\N	\N	\N	48799	48799	48800
13217	14554	13	applied	\N	\N	\N	\N	48806	48806	48807
13217	14555	14	applied	\N	\N	\N	\N	48808	48808	48809
13217	14559	15	applied	\N	\N	\N	\N	48817	48817	48818
13217	14560	16	applied	\N	\N	\N	\N	48819	48819	48820
13217	14565	17	applied	\N	\N	\N	\N	48833	48833	48834
13217	14568	18	applied	\N	\N	\N	\N	48841	48841	48842
13217	14571	19	applied	\N	\N	\N	\N	48851	48851	48852
13217	14574	20	applied	\N	\N	\N	\N	48857	48857	48858
13217	14577	21	applied	\N	\N	\N	\N	48865	48865	48866
13217	14580	22	applied	\N	\N	\N	\N	48872	48872	48873
13217	14581	23	applied	\N	\N	\N	\N	48875	48875	48876
13217	14586	24	applied	\N	\N	\N	\N	48891	48891	48892
13217	14589	25	applied	\N	\N	\N	\N	48898	48898	48899
13217	14590	26	applied	\N	\N	\N	\N	48900	48900	48901
13217	14594	27	applied	\N	\N	\N	\N	48910	48910	48911
13217	14597	28	applied	\N	\N	\N	\N	48917	48917	48918
13217	14377	29	applied	\N	\N	\N	\N	48348	48348	48349
13217	14378	30	applied	\N	\N	\N	\N	48350	48350	48351
13217	14379	31	applied	\N	\N	\N	\N	48352	48352	48353
13217	14380	32	applied	\N	\N	\N	\N	48354	48354	48355
13217	14381	33	applied	\N	\N	\N	\N	48356	48356	48357
13217	14382	34	applied	\N	\N	\N	\N	48358	48358	48359
13217	14383	35	applied	\N	\N	\N	\N	48360	48360	48361
13217	14385	36	applied	\N	\N	\N	\N	48366	48366	48367
13217	14386	37	applied	\N	\N	\N	\N	48368	48368	48369
13217	14387	38	applied	\N	\N	\N	\N	48370	48370	48371
13217	14389	39	applied	\N	\N	\N	\N	48374	48374	48375
13217	14390	40	applied	\N	\N	\N	\N	48376	48376	48377
13217	14391	41	applied	\N	\N	\N	\N	48378	48378	48379
13217	14393	42	applied	\N	\N	\N	\N	48385	48385	48386
13217	14394	43	applied	\N	\N	\N	\N	48387	48387	48388
13217	14395	44	applied	\N	\N	\N	\N	48389	48389	48390
13217	14398	45	applied	\N	\N	\N	\N	48401	48401	48402
13217	14399	46	applied	\N	\N	\N	\N	48403	48403	48404
13217	14400	47	applied	\N	\N	\N	\N	48405	48405	48406
13217	14401	48	applied	\N	\N	\N	\N	48407	48407	48408
13217	14402	49	applied	\N	\N	\N	\N	48409	48409	48410
13217	14403	50	applied	\N	\N	\N	\N	48411	48411	48412
13217	14405	51	applied	\N	\N	\N	\N	48417	48417	48418
13217	14406	52	applied	\N	\N	\N	\N	48419	48419	48420
13217	14414	53	applied	\N	\N	\N	\N	48437	48437	48438
13217	14415	54	applied	\N	\N	\N	\N	48439	48439	48440
13217	14416	55	applied	\N	\N	\N	\N	48441	48441	48442
13217	14417	56	applied	\N	\N	\N	\N	48443	48443	48444
13217	14418	57	applied	\N	\N	\N	\N	48445	48445	48446
13217	14419	58	applied	\N	\N	\N	\N	48447	48447	48448
13217	14420	59	applied	\N	\N	\N	\N	48449	48449	48450
13217	14421	60	applied	\N	\N	\N	\N	48451	48451	48452
13217	14422	61	applied	\N	\N	\N	\N	48453	48453	48454
13217	14423	62	applied	\N	\N	\N	\N	48455	48455	48456
13217	14424	63	applied	\N	\N	\N	\N	48457	48457	48458
13217	14425	64	applied	\N	\N	\N	\N	48459	48459	48460
13217	14426	65	applied	\N	\N	\N	\N	48461	48461	48462
13217	14427	66	applied	\N	\N	\N	\N	48463	48463	48464
13217	14430	67	applied	\N	\N	\N	\N	48471	48471	48472
13217	14431	68	applied	\N	\N	\N	\N	48473	48473	48474
13217	14432	69	applied	\N	\N	\N	\N	48475	48475	48476
13217	14434	70	applied	\N	\N	\N	\N	48483	48483	48484
13217	14440	71	applied	\N	\N	\N	\N	48500	48500	48501
13217	14441	72	applied	\N	\N	\N	\N	48502	48502	48503
13217	14442	73	applied	\N	\N	\N	\N	48504	48504	48505
13217	14443	74	applied	\N	\N	\N	\N	48506	48506	48507
13217	14446	75	applied	\N	\N	\N	\N	48515	48515	48516
13217	14447	76	applied	\N	\N	\N	\N	48517	48517	48518
13217	14450	77	applied	\N	\N	\N	\N	48528	48528	48529
13217	14451	78	applied	\N	\N	\N	\N	48530	48530	48531
13217	14456	79	applied	\N	\N	\N	\N	48545	48545	48546
13217	14457	80	applied	\N	\N	\N	\N	48547	48547	48548
13217	14458	81	applied	\N	\N	\N	\N	48549	48549	48550
13217	14459	82	applied	\N	\N	\N	\N	48551	48551	48552
13217	14460	83	applied	\N	\N	\N	\N	48553	48553	48554
13217	14461	84	applied	\N	\N	\N	\N	48555	48555	48556
13217	14464	85	applied	\N	\N	\N	\N	48564	48564	48565
13217	14465	86	applied	\N	\N	\N	\N	48566	48566	48567
13217	14466	87	applied	\N	\N	\N	\N	48568	48568	48569
13217	14467	88	applied	\N	\N	\N	\N	48570	48570	48571
13217	14469	89	applied	\N	\N	\N	\N	48579	48579	48580
13217	14471	90	applied	\N	\N	\N	\N	48585	48585	48586
13217	14473	91	applied	\N	\N	\N	\N	48596	48596	48597
13217	14474	92	applied	\N	\N	\N	\N	48598	48598	48599
13217	14477	93	applied	\N	\N	\N	\N	48605	48605	48606
13217	14478	94	applied	\N	\N	\N	\N	48607	48607	48608
13217	14484	95	applied	\N	\N	\N	\N	48623	48623	48624
13217	14485	96	applied	\N	\N	\N	\N	48625	48625	48626
13217	14486	97	applied	\N	\N	\N	\N	48627	48627	48628
13217	14487	98	applied	\N	\N	\N	\N	48629	48629	48630
13217	14488	99	applied	\N	\N	\N	\N	48631	48631	48632
13217	14495	100	applied	\N	\N	\N	\N	48649	48649	48650
13217	14496	101	applied	\N	\N	\N	\N	48651	48651	48652
13217	14497	102	applied	\N	\N	\N	\N	48653	48653	48654
13217	14498	103	applied	\N	\N	\N	\N	48655	48655	48656
13217	14499	104	applied	\N	\N	\N	\N	48657	48657	48658
13217	14500	105	applied	\N	\N	\N	\N	48659	48659	48660
13217	14504	106	applied	\N	\N	\N	\N	48675	48675	48676
13217	14505	107	applied	\N	\N	\N	\N	48677	48677	48678
13217	14506	108	applied	\N	\N	\N	\N	48679	48679	48680
13217	14507	109	applied	\N	\N	\N	\N	48681	48681	48682
13217	14508	110	applied	\N	\N	\N	\N	48683	48683	48684
13217	14509	111	applied	\N	\N	\N	\N	48685	48685	48686
13217	14512	112	applied	\N	\N	\N	\N	48695	48695	48696
13217	14513	113	applied	\N	\N	\N	\N	48697	48697	48698
13217	14514	114	applied	\N	\N	\N	\N	48699	48699	48700
13217	14517	115	applied	\N	\N	\N	\N	48710	48710	48711
13217	14518	116	applied	\N	\N	\N	\N	48712	48712	48713
13217	14519	117	applied	\N	\N	\N	\N	48714	48714	48715
13217	14520	118	applied	\N	\N	\N	\N	48716	48716	48717
13217	14524	119	applied	\N	\N	\N	\N	48727	48727	48728
13217	14525	120	applied	\N	\N	\N	\N	48729	48729	48730
13217	14526	121	applied	\N	\N	\N	\N	48731	48731	48732
13217	14527	122	applied	\N	\N	\N	\N	48733	48733	48734
13217	14528	124	applied	\N	\N	\N	\N	48735	48735	48736
13217	14529	125	applied	\N	\N	\N	\N	48737	48737	48738
13222	14609	0	applied	\N	\N	\N	\N	48953	48953	48954
13222	14610	1	applied	\N	\N	\N	\N	48955	48955	48956
13222	14611	2	applied	\N	\N	\N	\N	48957	48957	48958
13229	14612	0	applied	\N	\N	\N	\N	48967	48967	48968
13229	14613	1	applied	\N	\N	\N	\N	48969	48969	48970
13229	14614	2	applied	\N	\N	\N	\N	48971	48971	48972
13229	14615	3	applied	\N	\N	\N	\N	48973	48973	48974
13229	14616	4	applied	\N	\N	\N	\N	48975	48975	48976
13229	14617	5	applied	\N	\N	\N	\N	48977	48977	48978
13231	14619	0	applied	\N	\N	\N	\N	48986	48986	48987
13234	14600	0	applied	\N	\N	\N	\N	48928	48928	48929
13234	14601	1	applied	\N	\N	\N	\N	48930	48930	48931
13234	14606	2	applied	\N	\N	\N	\N	48943	48943	48944
13234	14609	3	applied	\N	\N	\N	\N	48953	48953	48954
13234	14612	4	applied	\N	\N	\N	\N	48967	48967	48968
13234	14613	5	applied	\N	\N	\N	\N	48969	48969	48970
13234	14532	6	applied	\N	\N	\N	\N	48745	48745	48746
13234	14533	7	applied	\N	\N	\N	\N	48747	48747	48748
13234	14534	8	applied	\N	\N	\N	\N	48749	48749	48750
13234	14535	9	applied	\N	\N	\N	\N	48751	48751	48752
13234	14539	10	applied	\N	\N	\N	\N	48761	48761	48762
13234	14540	11	applied	\N	\N	\N	\N	48763	48763	48764
13234	14541	12	applied	\N	\N	\N	\N	48765	48765	48766
13234	14542	13	applied	\N	\N	\N	\N	48767	48767	48768
13234	14543	14	applied	\N	\N	\N	\N	48769	48769	48770
13234	14544	15	applied	\N	\N	\N	\N	48771	48771	48772
13234	14546	16	applied	\N	\N	\N	\N	48779	48779	48780
13234	14547	17	applied	\N	\N	\N	\N	48781	48781	48782
13234	14549	18	applied	\N	\N	\N	\N	48792	48792	48793
13234	14550	19	applied	\N	\N	\N	\N	48794	48794	48795
13234	14552	20	applied	\N	\N	\N	\N	48801	48801	48802
13234	14553	21	applied	\N	\N	\N	\N	48803	48803	48804
13234	14556	22	applied	\N	\N	\N	\N	48810	48810	48811
13234	14557	23	applied	\N	\N	\N	\N	48812	48812	48813
13234	14558	24	applied	\N	\N	\N	\N	48814	48814	48815
13234	14561	25	applied	\N	\N	\N	\N	48821	48821	48822
13234	14562	26	applied	\N	\N	\N	\N	48823	48823	48824
13234	14563	27	applied	\N	\N	\N	\N	48825	48825	48826
13234	14564	28	applied	\N	\N	\N	\N	48827	48827	48828
13234	14566	29	applied	\N	\N	\N	\N	48835	48835	48836
13234	14567	30	applied	\N	\N	\N	\N	48837	48837	48838
13234	14569	31	applied	\N	\N	\N	\N	48843	48843	48844
13234	14570	32	applied	\N	\N	\N	\N	48845	48845	48846
13234	14572	33	applied	\N	\N	\N	\N	48853	48853	48854
13234	14573	34	applied	\N	\N	\N	\N	48855	48855	48856
13234	14575	35	applied	\N	\N	\N	\N	48859	48859	48860
13234	14576	36	applied	\N	\N	\N	\N	48861	48861	48862
13234	14578	37	applied	\N	\N	\N	\N	48867	48867	48868
13234	14579	38	applied	\N	\N	\N	\N	48869	48869	48870
13234	14582	39	applied	\N	\N	\N	\N	48877	48877	48878
13234	14583	40	applied	\N	\N	\N	\N	48879	48879	48880
13234	14584	41	applied	\N	\N	\N	\N	48881	48881	48882
13234	14585	42	applied	\N	\N	\N	\N	48883	48883	48884
13234	14587	43	applied	\N	\N	\N	\N	48893	48893	48894
13234	14588	44	applied	\N	\N	\N	\N	48895	48895	48896
13234	14591	45	applied	\N	\N	\N	\N	48902	48902	48903
13234	14592	46	applied	\N	\N	\N	\N	48904	48904	48905
13234	14593	47	applied	\N	\N	\N	\N	48906	48906	48907
13234	14595	48	applied	\N	\N	\N	\N	48912	48912	48913
13234	14596	49	applied	\N	\N	\N	\N	48914	48914	48915
13234	14598	50	applied	\N	\N	\N	\N	48919	48919	48920
13234	14599	51	applied	\N	\N	\N	\N	48921	48921	48922
13234	14602	52	applied	\N	\N	\N	\N	48932	48932	48933
13234	14603	53	applied	\N	\N	\N	\N	48934	48934	48935
13234	14604	54	applied	\N	\N	\N	\N	48936	48936	48937
13234	14605	55	applied	\N	\N	\N	\N	48938	48938	48939
13235	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13238	14620	0	applied	\N	\N	\N	\N	48997	48997	48998
13238	14621	1	applied	\N	\N	\N	\N	49001	49001	49002
13238	14622	2	applied	\N	\N	\N	\N	49005	49005	49006
13249	14631	0	applied	\N	\N	\N	\N	49035	49035	49036
13249	14630	1	applied	\N	\N	\N	\N	49030	49030	49031
13249	14632	2	applied	\N	\N	\N	\N	49039	49039	49040
13249	14633	3	applied	\N	\N	\N	\N	49041	49041	49042
13250	14634	0	applied	\N	\N	\N	\N	49046	49046	49047
13250	14632	1	applied	\N	\N	\N	\N	49039	49039	49040
13250	14633	2	applied	\N	\N	\N	\N	49041	49041	49042
13250	14635	3	applied	\N	\N	\N	\N	49048	49048	49049
13261	14664	0	applied	\N	\N	\N	\N	49124	49124	49125
13261	14665	1	applied	\N	\N	\N	\N	49126	49126	49127
13261	14666	2	applied	\N	\N	\N	\N	49128	49128	49129
13261	14667	3	applied	\N	\N	\N	\N	49130	49130	49131
13261	14668	4	applied	\N	\N	\N	\N	49132	49132	49133
13263	14664	0	applied	\N	\N	\N	\N	49124	49124	49125
13263	14665	1	applied	\N	\N	\N	\N	49126	49126	49127
13263	14666	2	applied	\N	\N	\N	\N	49128	49128	49129
13263	14667	3	applied	\N	\N	\N	\N	49130	49130	49131
13226	14439	12	applied	\N	\N	\N	\N	48498	48498	48499
13226	14444	13	applied	\N	\N	\N	\N	48511	48511	48512
13226	14482	14	applied	\N	\N	\N	\N	48619	48619	48620
13226	14489	15	applied	\N	\N	\N	\N	48636	48636	48637
13226	14491	16	applied	\N	\N	\N	\N	48640	48640	48641
13226	14492	17	applied	\N	\N	\N	\N	48643	48643	48644
13226	14455	18	applied	\N	\N	\N	\N	48543	48543	48544
13226	14462	19	applied	\N	\N	\N	\N	48559	48559	48560
13226	14463	20	applied	\N	\N	\N	\N	48562	48562	48563
13226	14468	21	applied	\N	\N	\N	\N	48577	48577	48578
13226	14470	22	applied	\N	\N	\N	\N	48583	48583	48584
13226	14472	23	applied	\N	\N	\N	\N	48594	48594	48595
13226	14475	24	applied	\N	\N	\N	\N	48601	48601	48602
13226	14479	25	applied	\N	\N	\N	\N	48613	48613	48614
13226	14480	26	applied	\N	\N	\N	\N	48615	48615	48616
13226	14483	27	applied	\N	\N	\N	\N	48621	48621	48622
13226	14490	28	applied	\N	\N	\N	\N	48638	48638	48639
13226	14493	29	applied	\N	\N	\N	\N	48645	48645	48646
13226	14494	30	applied	\N	\N	\N	\N	48647	48647	48648
13226	14501	31	applied	\N	\N	\N	\N	48669	48669	48670
13226	14502	32	applied	\N	\N	\N	\N	48671	48671	48672
13226	14503	33	applied	\N	\N	\N	\N	48673	48673	48674
13226	14510	34	applied	\N	\N	\N	\N	48689	48689	48690
13226	14511	35	applied	\N	\N	\N	\N	48693	48693	48694
13226	14515	36	applied	\N	\N	\N	\N	48706	48706	48707
13226	14516	37	applied	\N	\N	\N	\N	48708	48708	48709
13226	14521	38	applied	\N	\N	\N	\N	48721	48721	48722
13226	14522	39	applied	\N	\N	\N	\N	48723	48723	48724
13226	14523	40	applied	\N	\N	\N	\N	48725	48725	48726
13226	14530	41	applied	\N	\N	\N	\N	48741	48741	48742
13226	14531	42	applied	\N	\N	\N	\N	48743	48743	48744
13226	14536	43	applied	\N	\N	\N	\N	48755	48755	48756
13226	14537	44	applied	\N	\N	\N	\N	48757	48757	48758
13226	14538	45	applied	\N	\N	\N	\N	48759	48759	48760
13226	14545	46	applied	\N	\N	\N	\N	48775	48775	48776
13226	14548	47	applied	\N	\N	\N	\N	48788	48788	48789
13226	14551	48	applied	\N	\N	\N	\N	48799	48799	48800
13226	14554	49	applied	\N	\N	\N	\N	48806	48806	48807
13226	14555	50	applied	\N	\N	\N	\N	48808	48808	48809
13226	14559	51	applied	\N	\N	\N	\N	48817	48817	48818
13226	14560	52	applied	\N	\N	\N	\N	48819	48819	48820
13226	14565	53	applied	\N	\N	\N	\N	48833	48833	48834
13226	14568	54	applied	\N	\N	\N	\N	48841	48841	48842
13226	14571	55	applied	\N	\N	\N	\N	48851	48851	48852
13226	14574	56	applied	\N	\N	\N	\N	48857	48857	48858
13226	14577	57	applied	\N	\N	\N	\N	48865	48865	48866
13226	14580	58	applied	\N	\N	\N	\N	48872	48872	48873
13226	14581	59	applied	\N	\N	\N	\N	48875	48875	48876
13226	14586	60	applied	\N	\N	\N	\N	48891	48891	48892
13226	14589	61	applied	\N	\N	\N	\N	48898	48898	48899
13226	14590	62	applied	\N	\N	\N	\N	48900	48900	48901
13226	14594	63	applied	\N	\N	\N	\N	48910	48910	48911
13226	14597	64	applied	\N	\N	\N	\N	48917	48917	48918
13226	14600	65	applied	\N	\N	\N	\N	48928	48928	48929
13226	14601	66	applied	\N	\N	\N	\N	48930	48930	48931
13226	14606	67	applied	\N	\N	\N	\N	48943	48943	48944
13226	14609	68	applied	\N	\N	\N	\N	48953	48953	48954
13228	14612	0	applied	\N	\N	\N	\N	48967	48967	48968
13228	14613	1	applied	\N	\N	\N	\N	48969	48969	48970
13228	14614	2	applied	\N	\N	\N	\N	48971	48971	48972
13228	14615	3	applied	\N	\N	\N	\N	48973	48973	48974
13228	14616	4	applied	\N	\N	\N	\N	48975	48975	48976
13228	14617	5	applied	\N	\N	\N	\N	48977	48977	48978
13230	14612	0	applied	\N	\N	\N	\N	48967	48967	48968
13230	14613	1	applied	\N	\N	\N	\N	48969	48969	48970
13230	14614	2	applied	\N	\N	\N	\N	48971	48971	48972
13230	14615	3	applied	\N	\N	\N	\N	48973	48973	48974
13230	14616	4	applied	\N	\N	\N	\N	48975	48975	48976
13230	14617	5	applied	\N	\N	\N	\N	48977	48977	48978
13230	14618	6	applied	\N	\N	\N	\N	48983	48983	48984
13241	14623	0	applied	\N	\N	\N	\N	49010	49010	49011
13241	14621	1	applied	\N	\N	\N	\N	49001	49001	49002
13241	14622	2	applied	\N	\N	\N	\N	49005	49005	49006
13241	14624	3	applied	\N	\N	\N	\N	49012	49012	49013
13243	14625	0	applied	\N	\N	\N	\N	49017	49017	49018
13243	14626	1	applied	\N	\N	\N	\N	49019	49019	49020
13243	14627	2	applied	\N	\N	\N	\N	49021	49021	49022
13243	14628	3	applied	\N	\N	\N	\N	49023	49023	49024
13245	14629	0	applied	\N	\N	\N	\N	49028	49028	49029
13245	14630	1	applied	\N	\N	\N	\N	49030	49030	49031
13248	14631	0	applied	\N	\N	\N	\N	49035	49035	49036
13248	14630	1	applied	\N	\N	\N	\N	49030	49030	49031
13248	14632	2	applied	\N	\N	\N	\N	49039	49039	49040
13248	14633	3	applied	\N	\N	\N	\N	49041	49041	49042
13252	14639	0	applied	\N	\N	\N	\N	49060	49060	49061
13252	14640	1	applied	\N	\N	\N	\N	49062	49062	49063
13252	14641	2	applied	\N	\N	\N	\N	49064	49064	49065
13258	14654	0	applied	\N	\N	\N	\N	49097	49097	49098
13258	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13258	14656	2	applied	\N	\N	\N	\N	49102	49102	49103
13258	14657	3	applied	\N	\N	\N	\N	49104	49104	49105
13260	14659	0	applied	\N	\N	\N	\N	49111	49111	49112
13260	14660	1	applied	\N	\N	1000000000	\N	49113	49113	49114
13260	14661	2	applied	\N	\N	\N	\N	49115	49115	49116
13260	14662	3	applied	\N	\N	\N	\N	49117	49117	49118
13260	14663	5	applied	\N	\N	\N	\N	49120	49120	49121
13267	14671	0	applied	\N	\N	\N	\N	49141	49141	49142
13267	14672	1	applied	\N	\N	\N	\N	49147	49147	49148
13267	14673	2	applied	\N	\N	\N	\N	49149	49149	49150
13270	14674	0	applied	\N	\N	\N	\N	49152	49152	49153
13270	14675	1	applied	\N	\N	\N	\N	49154	49154	49155
13270	14676	2	applied	\N	\N	\N	\N	49156	49156	49157
13282	14694	0	applied	\N	\N	\N	\N	49210	49210	49211
13282	14695	1	applied	\N	\N	\N	\N	49214	49214	49215
13282	14696	2	applied	\N	\N	\N	\N	49216	49216	49217
13286	14703	0	applied	\N	\N	\N	\N	49233	49233	49234
13286	14704	1	applied	\N	\N	\N	\N	49235	49235	49236
13286	14705	2	applied	\N	\N	\N	\N	49237	49237	49238
13288	14709	0	applied	\N	\N	\N	\N	49249	49249	49250
13288	14710	1	applied	\N	\N	\N	\N	49251	49251	49252
13288	14711	2	applied	\N	\N	\N	\N	49253	49253	49254
13291	14715	0	applied	\N	\N	\N	\N	49267	49267	49268
13291	14716	1	applied	\N	\N	\N	\N	49269	49269	49270
13291	14717	2	applied	\N	\N	\N	\N	49271	49271	49272
13291	14718	3	applied	\N	\N	\N	\N	49273	49273	49274
13291	14719	4	applied	\N	\N	\N	\N	49275	49275	49276
13291	14720	5	applied	\N	\N	\N	\N	49277	49277	49278
13296	14730	0	applied	\N	\N	\N	\N	49304	49304	49305
13296	14731	1	applied	\N	\N	\N	\N	49306	49306	49307
13263	14668	4	applied	\N	\N	\N	\N	49132	49132	49133
13263	14669	5	applied	\N	\N	\N	\N	49135	49135	49136
13263	14670	6	applied	\N	\N	\N	\N	49137	49137	49138
13271	14674	0	applied	\N	\N	\N	\N	49152	49152	49153
13271	14675	1	applied	\N	\N	\N	\N	49154	49154	49155
13271	14676	2	applied	\N	\N	\N	\N	49156	49156	49157
13272	14677	0	applied	\N	\N	\N	\N	49164	49164	49165
13272	14678	1	applied	\N	\N	\N	\N	49166	49166	49167
13276	14679	0	applied	\N	\N	\N	\N	49175	49175	49176
13276	14680	1	applied	\N	\N	\N	\N	49177	49177	49178
13276	14681	2	applied	\N	\N	\N	\N	49179	49179	49180
13279	14685	0	applied	\N	\N	\N	\N	49190	49190	49191
13279	14686	1	applied	\N	\N	\N	\N	49192	49192	49193
13279	14687	2	applied	\N	\N	\N	\N	49194	49194	49195
13279	14688	3	applied	\N	\N	\N	\N	49196	49196	49197
13279	14689	4	applied	\N	\N	\N	\N	49198	49198	49199
13279	14690	5	applied	\N	\N	\N	\N	49200	49200	49201
13279	14691	6	applied	\N	\N	\N	\N	49202	49202	49203
13279	14692	7	applied	\N	\N	\N	\N	49204	49204	49205
13279	14693	8	applied	\N	\N	\N	\N	49206	49206	49207
13283	14694	0	applied	\N	\N	\N	\N	49210	49210	49211
13283	14695	1	applied	\N	\N	\N	\N	49214	49214	49215
13283	14696	2	applied	\N	\N	\N	\N	49216	49216	49217
13284	14697	0	applied	\N	\N	\N	\N	49220	49220	49221
13284	14698	1	applied	\N	\N	\N	\N	49222	49222	49223
13284	14699	2	applied	\N	\N	\N	\N	49224	49224	49225
13284	14700	3	applied	\N	\N	\N	\N	49226	49226	49227
13284	14701	4	applied	\N	\N	\N	\N	49228	49228	49229
13284	14702	5	applied	\N	\N	\N	\N	49230	49230	49231
13289	14709	0	applied	\N	\N	\N	\N	49249	49249	49250
13289	14710	1	applied	\N	\N	\N	\N	49251	49251	49252
13289	14711	2	applied	\N	\N	\N	\N	49253	49253	49254
13292	14715	0	applied	\N	\N	\N	\N	49267	49267	49268
13292	14716	1	applied	\N	\N	\N	\N	49269	49269	49270
13292	14717	2	applied	\N	\N	\N	\N	49271	49271	49272
13292	14718	3	applied	\N	\N	\N	\N	49273	49273	49274
13292	14719	4	applied	\N	\N	\N	\N	49275	49275	49276
13292	14720	5	applied	\N	\N	\N	\N	49277	49277	49278
13294	14721	0	applied	\N	\N	\N	\N	49283	49283	49284
13294	14722	1	applied	\N	\N	\N	\N	49285	49285	49286
13294	14723	2	applied	\N	\N	\N	\N	49287	49287	49288
13294	14724	3	applied	\N	\N	\N	\N	49289	49289	49290
13294	14725	4	applied	\N	\N	\N	\N	49291	49291	49292
13294	14726	5	applied	\N	\N	\N	\N	49293	49293	49294
13297	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13297	14735	1	applied	\N	\N	\N	\N	49316	49316	49317
13297	14736	2	applied	\N	\N	\N	\N	49318	49318	49319
13297	14737	3	applied	\N	\N	\N	\N	49320	49320	49321
13297	14738	4	applied	\N	\N	\N	\N	49322	49322	49323
13297	14739	5	applied	\N	\N	\N	\N	49324	49324	49325
13309	14761	0	applied	\N	\N	\N	\N	49388	49388	49389
13309	14762	1	applied	\N	\N	\N	\N	49390	49390	49391
13309	14763	2	applied	\N	\N	\N	\N	49392	49392	49393
13311	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13311	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13311	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13315	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13315	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13315	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13320	14775	0	applied	\N	\N	\N	\N	49431	49431	49432
13320	14776	1	applied	\N	\N	\N	\N	49433	49433	49434
13320	14777	2	applied	\N	\N	\N	\N	49435	49435	49436
13326	14794	0	applied	\N	\N	\N	\N	49478	49478	49479
13326	14795	1	applied	\N	\N	\N	\N	49480	49480	49481
13326	14796	2	applied	\N	\N	\N	\N	49482	49482	49483
13326	14797	3	applied	\N	\N	\N	\N	49484	49484	49485
13326	14798	4	applied	\N	\N	\N	\N	49486	49486	49487
13326	14799	5	applied	\N	\N	\N	\N	49488	49488	49489
13326	14800	6	applied	\N	\N	\N	\N	49490	49490	49491
13331	14808	0	applied	\N	\N	\N	\N	49516	49516	49517
13331	14809	1	applied	\N	\N	\N	\N	49518	49518	49519
13331	14810	2	applied	\N	\N	\N	\N	49520	49520	49521
13331	14811	3	applied	\N	\N	1000000000	\N	49522	49522	49523
13331	14812	4	applied	\N	\N	1000000000	\N	49524	49524	49525
13335	14813	0	applied	\N	\N	\N	\N	49527	49527	49528
13335	14814	1	applied	\N	\N	\N	\N	49529	49529	49530
13335	14816	2	applied	\N	\N	\N	\N	49533	49533	49534
13335	14817	3	applied	\N	\N	\N	\N	49535	49535	49536
13335	14815	4	applied	\N	\N	\N	\N	49531	49531	25661
13335	14818	5	applied	\N	\N	\N	\N	49537	49537	49538
13335	14819	6	applied	\N	\N	1000000000	\N	49539	49539	49540
13335	14820	7	applied	\N	\N	\N	\N	49541	49541	49542
13335	14821	8	applied	\N	\N	\N	\N	49543	49543	49544
13335	14822	9	applied	\N	\N	\N	\N	49545	49545	49546
13338	14828	0	applied	\N	\N	\N	\N	49562	49562	49563
13338	14829	1	applied	\N	\N	\N	\N	49564	49564	49565
13338	14830	2	applied	\N	\N	\N	\N	49566	49566	49567
13338	14831	3	applied	\N	\N	\N	\N	49568	49568	49569
13341	14832	0	applied	\N	\N	\N	\N	49574	49574	49575
13341	14833	2	applied	\N	\N	\N	\N	49577	49577	49578
13341	14834	3	applied	\N	\N	\N	\N	49579	49579	49580
13341	14835	4	applied	\N	\N	\N	\N	49581	49581	49582
13341	14836	5	applied	\N	\N	\N	\N	49583	49583	49584
13341	14837	6	applied	\N	\N	\N	\N	49585	49585	49586
13341	14838	7	applied	\N	\N	\N	\N	49587	49587	49588
13341	14839	8	applied	\N	\N	\N	\N	49589	49589	49590
13343	14844	0	applied	\N	\N	\N	\N	49606	49606	49607
13343	14845	1	applied	\N	\N	\N	\N	49608	49608	49609
13343	14846	2	applied	\N	\N	\N	\N	49610	49610	49611
13343	14847	3	applied	\N	\N	\N	\N	49612	49612	49613
13345	14848	0	applied	\N	\N	\N	\N	49617	49617	49618
13345	14849	1	applied	\N	\N	\N	\N	49619	49619	49620
13345	14850	2	applied	\N	\N	\N	\N	49621	49621	49622
13352	14864	0	applied	\N	\N	\N	\N	49657	49657	49658
13352	14861	1	applied	\N	\N	\N	\N	49648	49648	49649
13352	14862	2	applied	\N	\N	\N	\N	49650	49650	49651
13352	14863	3	applied	\N	\N	\N	\N	49652	49652	49653
13352	14865	4	applied	\N	\N	\N	\N	49659	49659	49660
13352	14866	5	applied	\N	\N	\N	\N	49661	49661	49662
13352	14867	6	applied	\N	\N	\N	\N	49663	49663	49664
13355	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13355	14869	1	applied	\N	\N	\N	\N	49670	49670	49671
13355	14870	2	applied	\N	\N	\N	\N	49672	49672	49673
13357	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13357	14867	1	applied	\N	\N	\N	\N	49663	49663	49664
13357	14869	2	applied	\N	\N	\N	\N	49670	49670	49671
13357	14870	3	applied	\N	\N	\N	\N	49672	49672	49673
13362	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13362	14407	1	applied	\N	\N	\N	\N	48422	48422	48423
13264	14664	0	applied	\N	\N	\N	\N	49124	49124	49125
13264	14665	1	applied	\N	\N	\N	\N	49126	49126	49127
13264	14671	2	applied	\N	\N	\N	\N	49141	49141	49142
13264	14666	3	applied	\N	\N	\N	\N	49128	49128	49129
13264	14667	4	applied	\N	\N	\N	\N	49130	49130	49131
13264	14668	5	applied	\N	\N	\N	\N	49132	49132	49133
13264	14669	6	applied	\N	\N	\N	\N	49135	49135	49136
13264	14670	7	applied	\N	\N	\N	\N	49137	49137	49138
13268	14674	0	applied	\N	\N	\N	\N	49152	49152	49153
13268	14675	1	applied	\N	\N	\N	\N	49154	49154	49155
13268	14676	2	applied	\N	\N	\N	\N	49156	49156	49157
13273	14677	0	applied	\N	\N	\N	\N	49164	49164	49165
13273	14678	1	applied	\N	\N	\N	\N	49166	49166	49167
13277	14682	0	applied	\N	\N	\N	\N	49183	49183	49184
13277	14683	1	applied	\N	\N	\N	\N	49185	49185	49186
13277	14684	2	applied	\N	\N	\N	\N	49187	49187	49188
13280	14694	0	applied	\N	\N	\N	\N	49210	49210	49211
13287	14706	0	applied	\N	\N	\N	\N	49241	49241	49242
13287	14707	1	applied	\N	\N	\N	\N	49243	49243	49244
13287	14708	2	applied	\N	\N	\N	\N	49245	49245	49246
13293	14715	0	applied	\N	\N	\N	\N	49267	49267	49268
13293	14716	1	applied	\N	\N	\N	\N	49269	49269	49270
13293	14717	2	applied	\N	\N	\N	\N	49271	49271	49272
13293	14718	3	applied	\N	\N	\N	\N	49273	49273	49274
13293	14719	4	applied	\N	\N	\N	\N	49275	49275	49276
13293	14720	5	applied	\N	\N	\N	\N	49277	49277	49278
13300	14743	0	applied	\N	\N	\N	\N	49338	49338	49339
13300	14744	1	applied	\N	\N	\N	\N	49340	49340	49341
13300	14745	2	applied	\N	\N	\N	\N	49342	49342	49343
13305	14752	0	applied	\N	\N	\N	\N	49362	49362	49363
13305	14755	1	applied	\N	\N	\N	\N	49371	49371	49372
13305	14753	2	applied	\N	\N	\N	\N	49364	49364	49365
13305	14754	3	applied	\N	\N	\N	\N	49366	49366	49367
13305	14756	4	applied	\N	\N	\N	\N	49373	49373	49374
13305	14757	5	applied	\N	\N	\N	\N	49375	49375	49376
13307	14758	0	applied	\N	\N	\N	\N	49379	49379	49380
13307	14759	1	applied	\N	\N	\N	\N	49381	49381	49382
13307	14760	2	applied	\N	\N	\N	\N	49383	49383	49384
13312	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13312	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13312	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13318	14770	0	applied	\N	\N	\N	\N	49417	49417	49418
13318	14771	1	applied	\N	\N	\N	\N	49419	49419	49420
13321	14778	0	applied	\N	\N	\N	\N	49438	49438	49439
13321	14779	1	applied	\N	\N	\N	\N	49440	49440	49441
13321	14780	2	applied	\N	\N	\N	\N	49442	49442	49443
13324	14790	0	applied	\N	\N	\N	\N	49466	49466	49467
13324	14791	1	applied	\N	\N	\N	\N	49468	49468	49469
13324	14792	2	applied	\N	\N	\N	\N	49470	49470	49471
13329	14801	0	applied	\N	\N	\N	\N	49497	49497	49498
13329	14802	1	applied	\N	\N	\N	\N	49499	49499	49500
13329	14803	2	applied	\N	\N	\N	\N	49501	49501	49502
13332	14813	0	applied	\N	\N	\N	\N	49527	49527	49528
13332	14814	1	applied	\N	\N	\N	\N	49529	49529	49530
13332	14815	2	applied	\N	\N	\N	\N	49531	49531	25661
13336	14813	0	applied	\N	\N	\N	\N	49527	49527	49528
13336	14814	1	applied	\N	\N	\N	\N	49529	49529	49530
13336	14816	2	applied	\N	\N	\N	\N	49533	49533	49534
13336	14817	3	applied	\N	\N	\N	\N	49535	49535	49536
13336	14815	4	applied	\N	\N	\N	\N	49531	49531	25661
13336	14818	5	applied	\N	\N	\N	\N	49537	49537	49538
13336	14819	6	applied	\N	\N	1000000000	\N	49539	49539	49540
13336	14820	7	applied	\N	\N	\N	\N	49541	49541	49542
13336	14821	8	applied	\N	\N	\N	\N	49543	49543	49544
13336	14822	9	applied	\N	\N	\N	\N	49545	49545	49546
13339	14828	0	applied	\N	\N	\N	\N	49562	49562	49563
13339	14829	1	applied	\N	\N	\N	\N	49564	49564	49565
13339	14830	2	applied	\N	\N	\N	\N	49566	49566	49567
13339	14831	3	applied	\N	\N	\N	\N	49568	49568	49569
13344	14844	0	applied	\N	\N	\N	\N	49606	49606	49607
13344	14845	1	applied	\N	\N	\N	\N	49608	49608	49609
13344	14846	2	applied	\N	\N	\N	\N	49610	49610	49611
13344	14847	3	applied	\N	\N	\N	\N	49612	49612	49613
13346	14851	0	applied	\N	\N	\N	\N	49624	49624	49625
13346	14852	1	applied	\N	\N	\N	\N	49626	49626	49627
13346	14853	2	applied	\N	\N	\N	\N	49628	49628	49629
13346	14854	3	applied	\N	\N	\N	\N	49630	49630	49631
13353	14864	0	applied	\N	\N	\N	\N	49657	49657	49658
13353	14865	1	applied	\N	\N	\N	\N	49659	49659	49660
13353	14866	2	applied	\N	\N	\N	\N	49661	49661	49662
13356	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13356	14869	1	applied	\N	\N	\N	\N	49670	49670	49671
13356	14870	2	applied	\N	\N	\N	\N	49672	49672	49673
13358	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13358	14869	1	applied	\N	\N	\N	\N	49670	49670	49671
13367	14885	0	applied	\N	\N	\N	\N	49723	49723	49724
13367	14886	1	applied	\N	\N	\N	\N	49725	49725	49726
13367	14887	2	applied	\N	\N	\N	\N	49727	49727	49728
13367	14888	3	applied	\N	\N	\N	\N	49729	49729	49730
13367	14889	4	applied	\N	\N	\N	\N	49731	49731	49732
13367	14890	5	applied	\N	\N	\N	\N	49733	49733	49734
13367	14891	6	applied	\N	\N	\N	\N	49735	49735	49736
13369	14892	0	applied	\N	\N	\N	\N	49740	49740	49741
13369	14893	1	applied	\N	\N	\N	\N	49742	49742	49743
13369	14894	2	applied	\N	\N	\N	\N	49744	49744	49745
13369	14895	3	applied	\N	\N	\N	\N	49746	49746	49747
13369	14896	4	applied	\N	\N	\N	\N	49748	49748	49749
13369	14897	5	applied	\N	\N	\N	\N	49750	49750	49751
13369	14898	6	applied	\N	\N	\N	\N	49752	49752	49753
13369	14899	7	applied	\N	\N	\N	\N	49754	49754	49755
13372	14900	0	applied	\N	\N	\N	\N	49763	49763	49764
13372	14901	1	applied	\N	\N	\N	\N	49765	49765	49766
13372	14902	2	applied	\N	\N	\N	\N	49767	49767	49768
13375	14911	0	applied	\N	\N	\N	\N	49789	49789	49790
13375	14912	1	applied	\N	\N	\N	\N	49791	49791	49792
13375	14913	2	applied	\N	\N	\N	\N	49793	49793	49794
13375	14914	3	applied	\N	\N	\N	\N	49795	49795	49796
13376	14915	0	applied	\N	\N	\N	\N	49801	49801	49802
13376	14916	1	applied	\N	\N	\N	\N	49803	49803	49804
13376	14917	2	applied	\N	\N	\N	\N	49805	49805	49806
13376	14918	3	applied	\N	\N	\N	\N	49807	49807	49808
13379	14928	0	applied	\N	\N	\N	\N	49832	49832	49833
13379	14929	1	applied	\N	\N	\N	\N	49834	49834	49835
13379	14930	2	applied	\N	\N	\N	\N	49836	49836	49837
13379	14931	3	applied	\N	\N	\N	\N	49838	49838	49839
13382	14944	0	applied	\N	\N	\N	\N	49869	49869	49870
13382	14945	1	applied	\N	\N	\N	\N	49871	49871	49872
13382	14946	2	applied	\N	\N	\N	\N	49873	49873	49874
13382	14947	3	applied	\N	\N	\N	\N	49875	49875	49876
13382	14948	4	applied	\N	\N	\N	\N	49877	49877	49878
13296	14732	2	applied	\N	\N	\N	\N	49308	49308	49309
13296	14733	3	applied	\N	\N	\N	\N	49310	49310	49311
13299	14740	0	applied	\N	\N	\N	\N	49328	49328	49329
13299	14741	1	applied	\N	\N	\N	\N	49330	49330	49331
13299	14742	2	applied	\N	\N	\N	\N	49332	49332	49333
13304	14746	0	applied	\N	\N	\N	\N	49347	49347	49348
13304	14747	1	applied	\N	\N	\N	\N	49349	49349	49350
13304	14752	2	applied	\N	\N	\N	\N	49362	49362	49363
13304	14748	3	applied	\N	\N	\N	\N	49351	49351	49352
13304	14749	4	applied	\N	\N	\N	\N	49353	49353	49354
13304	14750	5	applied	\N	\N	\N	\N	49355	49355	49356
13304	14751	6	applied	\N	\N	\N	\N	49357	49357	49358
13304	14753	7	applied	\N	\N	\N	\N	49364	49364	49365
13304	14754	8	applied	\N	\N	\N	\N	49366	49366	49367
13306	14755	0	applied	\N	\N	\N	\N	49371	49371	49372
13306	14756	1	applied	\N	\N	\N	\N	49373	49373	49374
13306	14757	2	applied	\N	\N	\N	\N	49375	49375	49376
13308	14758	0	applied	\N	\N	\N	\N	49379	49379	49380
13308	14759	1	applied	\N	\N	\N	\N	49381	49381	49382
13308	14760	2	applied	\N	\N	\N	\N	49383	49383	49384
13314	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13314	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13314	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13316	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13316	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13316	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13317	14767	0	applied	\N	\N	\N	\N	49410	49410	49411
13317	14768	1	applied	\N	\N	\N	\N	49412	49412	49413
13317	14769	2	applied	\N	\N	\N	\N	49414	49414	49415
13323	14781	0	applied	\N	\N	\N	\N	49446	49446	49447
13323	14782	1	applied	\N	\N	\N	\N	49448	49448	49449
13323	14783	2	applied	\N	\N	\N	\N	49450	49450	49451
13323	14784	3	applied	\N	\N	\N	\N	49452	49452	49453
13323	14785	4	applied	\N	\N	\N	\N	49454	49454	49455
13323	14786	5	applied	\N	\N	\N	\N	49456	49456	49457
13323	14787	6	applied	\N	\N	\N	\N	49458	49458	49459
13323	14788	7	applied	\N	\N	\N	\N	49460	49460	49461
13323	14789	8	applied	\N	\N	\N	\N	49462	49462	49463
13325	14793	0	applied	\N	\N	\N	\N	49474	49474	49475
13328	14801	0	applied	\N	\N	\N	\N	49497	49497	49498
13328	14802	1	applied	\N	\N	\N	\N	49499	49499	49500
13328	14803	2	applied	\N	\N	\N	\N	49501	49501	49502
13330	14804	0	applied	\N	\N	\N	\N	49507	49507	49508
13330	14805	1	applied	\N	\N	\N	\N	49509	49509	25661
13330	14806	2	applied	\N	\N	\N	\N	49510	49510	49511
13330	14807	3	applied	\N	\N	\N	\N	49512	49512	49513
13334	14813	0	applied	\N	\N	\N	\N	49527	49527	49528
13334	14814	1	applied	\N	\N	\N	\N	49529	49529	49530
13334	14816	2	applied	\N	\N	\N	\N	49533	49533	49534
13334	14817	3	applied	\N	\N	\N	\N	49535	49535	49536
13334	14815	4	applied	\N	\N	\N	\N	49531	49531	25661
13334	14818	5	applied	\N	\N	\N	\N	49537	49537	49538
13334	14819	6	applied	\N	\N	1000000000	\N	49539	49539	49540
13334	14820	7	applied	\N	\N	\N	\N	49541	49541	49542
13334	14821	8	applied	\N	\N	\N	\N	49543	49543	49544
13334	14822	9	applied	\N	\N	\N	\N	49545	49545	49546
13337	14823	0	applied	\N	\N	\N	\N	49552	49552	49553
13337	14824	1	applied	\N	\N	\N	\N	49554	49554	25661
13337	14816	2	applied	\N	\N	\N	\N	49533	49533	49534
13337	14817	3	applied	\N	\N	\N	\N	49535	49535	49536
13337	14818	4	applied	\N	\N	\N	\N	49537	49537	49538
13337	14819	5	applied	\N	\N	1000000000	\N	49539	49539	49540
13337	14820	6	applied	\N	\N	\N	\N	49541	49541	49542
13337	14821	7	applied	\N	\N	\N	\N	49543	49543	49544
13337	14822	8	applied	\N	\N	\N	\N	49545	49545	49546
13337	14825	9	applied	\N	\N	\N	\N	49555	49555	49556
13337	14826	10	applied	\N	\N	\N	\N	49557	49557	49558
13337	14827	11	applied	\N	\N	\N	\N	49559	49559	49560
13340	14832	0	applied	\N	\N	\N	\N	49574	49574	49575
13340	14833	2	applied	\N	\N	\N	\N	49577	49577	49578
13340	14834	3	applied	\N	\N	\N	\N	49579	49579	49580
13340	14835	4	applied	\N	\N	\N	\N	49581	49581	49582
13340	14836	5	applied	\N	\N	\N	\N	49583	49583	49584
13340	14837	6	applied	\N	\N	\N	\N	49585	49585	49586
13340	14838	7	applied	\N	\N	\N	\N	49587	49587	49588
13340	14839	8	applied	\N	\N	\N	\N	49589	49589	49590
13342	14840	0	applied	\N	\N	\N	\N	49596	49596	49597
13342	14841	1	applied	\N	\N	\N	\N	49598	49598	49599
13342	14842	2	applied	\N	\N	\N	\N	49600	49600	49601
13342	14843	3	applied	\N	\N	\N	\N	49602	49602	49603
13347	14855	0	applied	\N	\N	\N	\N	49634	49634	49635
13347	14856	1	applied	\N	\N	\N	\N	49636	49636	49637
13347	14857	2	applied	\N	\N	\N	\N	49638	49638	49639
13347	14858	3	applied	\N	\N	\N	\N	49640	49640	49641
13347	14859	4	applied	\N	\N	\N	\N	49642	49642	49643
13348	14855	0	applied	\N	\N	\N	\N	49634	49634	49635
13348	14856	1	applied	\N	\N	\N	\N	49636	49636	49637
13348	14857	2	applied	\N	\N	\N	\N	49638	49638	49639
13348	14858	3	applied	\N	\N	\N	\N	49640	49640	49641
13348	14859	4	applied	\N	\N	\N	\N	49642	49642	49643
13350	14860	0	applied	\N	\N	\N	\N	49646	49646	49647
13350	14861	1	applied	\N	\N	\N	\N	49648	49648	49649
13350	14862	2	applied	\N	\N	\N	\N	49650	49650	49651
13350	14863	3	applied	\N	\N	\N	\N	49652	49652	49653
13354	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13354	14869	1	applied	\N	\N	\N	\N	49670	49670	49671
13354	14870	2	applied	\N	\N	\N	\N	49672	49672	49673
13361	14871	0	applied	\N	\N	\N	\N	49682	49682	49683
13361	14872	1	applied	\N	\N	\N	\N	49684	49684	49685
13361	14873	2	applied	\N	\N	\N	\N	49686	49686	49687
13361	14874	3	applied	\N	\N	\N	\N	49688	49688	25661
13365	14882	0	applied	\N	\N	\N	\N	49714	49714	49715
13365	14883	1	applied	\N	\N	\N	\N	49716	49716	49717
13365	14884	2	applied	\N	\N	\N	\N	49718	49718	49719
13368	14885	0	applied	\N	\N	\N	\N	49723	49723	49724
13368	14886	1	applied	\N	\N	\N	\N	49725	49725	49726
13368	14887	2	applied	\N	\N	\N	\N	49727	49727	49728
13368	14888	3	applied	\N	\N	\N	\N	49729	49729	49730
13368	14889	4	applied	\N	\N	\N	\N	49731	49731	49732
13368	14890	5	applied	\N	\N	\N	\N	49733	49733	49734
13368	14891	6	applied	\N	\N	\N	\N	49735	49735	49736
13370	14801	0	applied	\N	\N	\N	\N	49497	49497	49498
13370	14804	1	applied	\N	\N	\N	\N	49507	49507	49508
13370	14808	2	applied	\N	\N	\N	\N	49516	49516	49517
13370	14813	4	applied	\N	\N	\N	\N	49527	49527	49528
13370	14814	5	applied	\N	\N	\N	\N	49529	49529	49530
13370	14823	6	applied	\N	\N	\N	\N	49552	49552	49553
13370	14828	7	applied	\N	\N	\N	\N	49562	49562	49563
13373	14911	0	applied	\N	\N	\N	\N	49789	49789	49790
13301	14675	46	applied	\N	\N	\N	\N	49154	49154	49155
13301	14676	47	applied	\N	\N	\N	\N	49156	49156	49157
13301	14678	48	applied	\N	\N	\N	\N	49166	49166	49167
13301	14680	49	applied	\N	\N	\N	\N	49177	49177	49178
13301	14681	50	applied	\N	\N	\N	\N	49179	49179	49180
13301	14683	51	applied	\N	\N	\N	\N	49185	49185	49186
13301	14684	52	applied	\N	\N	\N	\N	49187	49187	49188
13301	14688	53	applied	\N	\N	\N	\N	49196	49196	49197
13301	14689	54	applied	\N	\N	\N	\N	49198	49198	49199
13301	14690	55	applied	\N	\N	\N	\N	49200	49200	49201
13301	14691	56	applied	\N	\N	\N	\N	49202	49202	49203
13301	14692	57	applied	\N	\N	\N	\N	49204	49204	49205
13301	14693	58	applied	\N	\N	\N	\N	49206	49206	49207
13301	14695	59	applied	\N	\N	\N	\N	49214	49214	49215
13301	14696	60	applied	\N	\N	\N	\N	49216	49216	49217
13301	14699	61	applied	\N	\N	\N	\N	49224	49224	49225
13301	14700	62	applied	\N	\N	\N	\N	49226	49226	49227
13301	14701	63	applied	\N	\N	\N	\N	49228	49228	49229
13301	14702	64	applied	\N	\N	\N	\N	49230	49230	49231
13301	14704	65	applied	\N	\N	\N	\N	49235	49235	49236
13301	14705	66	applied	\N	\N	\N	\N	49237	49237	49238
13301	14707	67	applied	\N	\N	\N	\N	49243	49243	49244
13301	14708	68	applied	\N	\N	\N	\N	49245	49245	49246
13301	14710	69	applied	\N	\N	\N	\N	49251	49251	49252
13301	14711	70	applied	\N	\N	\N	\N	49253	49253	49254
13301	14713	71	applied	\N	\N	\N	\N	49261	49261	49262
13301	14714	72	applied	\N	\N	\N	\N	49263	49263	49264
13301	14717	73	applied	\N	\N	\N	\N	49271	49271	49272
13301	14718	74	applied	\N	\N	\N	\N	49273	49273	49274
13301	14719	75	applied	\N	\N	\N	\N	49275	49275	49276
13301	14720	76	applied	\N	\N	\N	\N	49277	49277	49278
13301	14724	77	applied	\N	\N	\N	\N	49289	49289	49290
13301	14725	78	applied	\N	\N	\N	\N	49291	49291	49292
13301	14726	79	applied	\N	\N	\N	\N	49293	49293	49294
13301	14728	80	applied	\N	\N	\N	\N	49299	49299	49300
13301	14729	81	applied	\N	\N	\N	\N	49301	49301	49302
13301	14732	82	applied	\N	\N	\N	\N	49308	49308	49309
13301	14733	83	applied	\N	\N	\N	\N	49310	49310	49311
13301	14737	84	applied	\N	\N	\N	\N	49320	49320	49321
13301	14738	85	applied	\N	\N	\N	\N	49322	49322	49323
13301	14739	86	applied	\N	\N	\N	\N	49324	49324	49325
13301	14741	87	applied	\N	\N	\N	\N	49330	49330	49331
13301	14742	88	applied	\N	\N	\N	\N	49332	49332	49333
13301	14744	89	applied	\N	\N	\N	\N	49340	49340	49341
13301	14745	90	applied	\N	\N	\N	\N	49342	49342	49343
13301	14748	91	applied	\N	\N	\N	\N	49351	49351	49352
13301	14749	92	applied	\N	\N	\N	\N	49353	49353	49354
13301	14750	93	applied	\N	\N	\N	\N	49355	49355	49356
13301	14751	94	applied	\N	\N	\N	\N	49357	49357	49358
13303	14746	0	applied	\N	\N	\N	\N	49347	49347	49348
13303	14747	1	applied	\N	\N	\N	\N	49349	49349	49350
13303	14752	2	applied	\N	\N	\N	\N	49362	49362	49363
13303	14748	3	applied	\N	\N	\N	\N	49351	49351	49352
13303	14749	4	applied	\N	\N	\N	\N	49353	49353	49354
13303	14750	5	applied	\N	\N	\N	\N	49355	49355	49356
13303	14751	6	applied	\N	\N	\N	\N	49357	49357	49358
13303	14753	7	applied	\N	\N	\N	\N	49364	49364	49365
13303	14754	8	applied	\N	\N	\N	\N	49366	49366	49367
13310	14761	0	applied	\N	\N	\N	\N	49388	49388	49389
13310	14762	1	applied	\N	\N	\N	\N	49390	49390	49391
13313	14764	0	applied	\N	\N	\N	\N	49398	49398	49399
13313	14765	1	applied	\N	\N	\N	\N	49400	49400	49401
13313	14766	2	applied	\N	\N	\N	\N	49402	49402	49403
13319	14772	0	applied	\N	\N	\N	\N	49423	49423	49424
13319	14773	1	applied	\N	\N	\N	\N	49425	49425	49426
13319	14774	2	applied	\N	\N	\N	\N	49427	49427	49428
13322	14746	0	applied	\N	\N	\N	\N	49347	49347	49348
13322	14747	1	applied	\N	\N	\N	\N	49349	49349	49350
13322	14752	2	applied	\N	\N	\N	\N	49362	49362	49363
13322	14755	3	applied	\N	\N	\N	\N	49371	49371	49372
13322	14758	4	applied	\N	\N	\N	\N	49379	49379	49380
13322	14761	5	applied	\N	\N	\N	\N	49388	49388	49389
13322	14764	6	applied	\N	\N	\N	\N	49398	49398	49399
13322	14767	7	applied	\N	\N	\N	\N	49410	49410	49411
13322	14770	8	applied	\N	\N	\N	\N	49417	49417	49418
13322	14772	9	applied	\N	\N	\N	\N	49423	49423	49424
13322	14775	10	applied	\N	\N	\N	\N	49431	49431	49432
13322	14778	11	applied	\N	\N	\N	\N	49438	49438	49439
13322	14781	12	applied	\N	\N	\N	\N	49446	49446	49447
13322	14782	13	applied	\N	\N	\N	\N	49448	49448	49449
13322	14783	14	applied	\N	\N	\N	\N	49450	49450	49451
13322	14748	15	applied	\N	\N	\N	\N	49351	49351	49352
13322	14749	16	applied	\N	\N	\N	\N	49353	49353	49354
13322	14750	17	applied	\N	\N	\N	\N	49355	49355	49356
13322	14751	18	applied	\N	\N	\N	\N	49357	49357	49358
13322	14753	19	applied	\N	\N	\N	\N	49364	49364	49365
13322	14754	20	applied	\N	\N	\N	\N	49366	49366	49367
13322	14756	21	applied	\N	\N	\N	\N	49373	49373	49374
13322	14757	22	applied	\N	\N	\N	\N	49375	49375	49376
13322	14759	23	applied	\N	\N	\N	\N	49381	49381	49382
13322	14760	24	applied	\N	\N	\N	\N	49383	49383	49384
13322	14762	25	applied	\N	\N	\N	\N	49390	49390	49391
13322	14763	26	applied	\N	\N	\N	\N	49392	49392	49393
13322	14765	27	applied	\N	\N	\N	\N	49400	49400	49401
13322	14766	28	applied	\N	\N	\N	\N	49402	49402	49403
13322	14768	29	applied	\N	\N	\N	\N	49412	49412	49413
13322	14769	30	applied	\N	\N	\N	\N	49414	49414	49415
13322	14771	31	applied	\N	\N	\N	\N	49419	49419	49420
13322	14773	32	applied	\N	\N	\N	\N	49425	49425	49426
13322	14774	33	applied	\N	\N	\N	\N	49427	49427	49428
13322	14776	34	applied	\N	\N	\N	\N	49433	49433	49434
13322	14777	35	applied	\N	\N	\N	\N	49435	49435	49436
13322	14779	36	applied	\N	\N	\N	\N	49440	49440	49441
13322	14780	37	applied	\N	\N	\N	\N	49442	49442	49443
13322	14784	38	applied	\N	\N	\N	\N	49452	49452	49453
13322	14785	39	applied	\N	\N	\N	\N	49454	49454	49455
13322	14786	40	applied	\N	\N	\N	\N	49456	49456	49457
13322	14787	41	applied	\N	\N	\N	\N	49458	49458	49459
13322	14788	42	applied	\N	\N	\N	\N	49460	49460	49461
13322	14789	43	applied	\N	\N	\N	\N	49462	49462	49463
13327	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13327	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13327	14660	2	applied	\N	\N	1000000000	\N	49113	49113	49114
13327	14731	3	applied	\N	\N	\N	\N	49306	49306	49307
13327	14501	4	applied	\N	\N	\N	\N	48669	48669	48670
13327	14502	5	applied	\N	\N	\N	\N	48671	48671	48672
13327	14503	6	applied	\N	\N	\N	\N	48673	48673	48674
13327	14510	7	applied	\N	\N	\N	\N	48689	48689	48690
13327	14511	8	applied	\N	\N	\N	\N	48693	48693	48694
13327	14515	9	applied	\N	\N	\N	\N	48706	48706	48707
13327	14516	10	applied	\N	\N	\N	\N	48708	48708	48709
13327	14521	11	applied	\N	\N	\N	\N	48721	48721	48722
13327	14522	12	applied	\N	\N	\N	\N	48723	48723	48724
13327	14523	13	applied	\N	\N	\N	\N	48725	48725	48726
13327	14530	14	applied	\N	\N	\N	\N	48741	48741	48742
13327	14531	15	applied	\N	\N	\N	\N	48743	48743	48744
13327	14536	16	applied	\N	\N	\N	\N	48755	48755	48756
13327	14537	17	applied	\N	\N	\N	\N	48757	48757	48758
13327	14538	18	applied	\N	\N	\N	\N	48759	48759	48760
13327	14545	19	applied	\N	\N	\N	\N	48775	48775	48776
13327	14548	20	applied	\N	\N	\N	\N	48788	48788	48789
13327	14551	21	applied	\N	\N	\N	\N	48799	48799	48800
13327	14554	22	applied	\N	\N	\N	\N	48806	48806	48807
13327	14555	23	applied	\N	\N	\N	\N	48808	48808	48809
13327	14559	24	applied	\N	\N	\N	\N	48817	48817	48818
13327	14560	25	applied	\N	\N	\N	\N	48819	48819	48820
13327	14565	26	applied	\N	\N	\N	\N	48833	48833	48834
13327	14568	27	applied	\N	\N	\N	\N	48841	48841	48842
13327	14571	28	applied	\N	\N	\N	\N	48851	48851	48852
13327	14574	29	applied	\N	\N	\N	\N	48857	48857	48858
13327	14577	30	applied	\N	\N	\N	\N	48865	48865	48866
13327	14580	31	applied	\N	\N	\N	\N	48872	48872	48873
13327	14581	32	applied	\N	\N	\N	\N	48875	48875	48876
13327	14586	33	applied	\N	\N	\N	\N	48891	48891	48892
13327	14589	34	applied	\N	\N	\N	\N	48898	48898	48899
13327	14590	35	applied	\N	\N	\N	\N	48900	48900	48901
13327	14594	36	applied	\N	\N	\N	\N	48910	48910	48911
13327	14597	37	applied	\N	\N	\N	\N	48917	48917	48918
13327	14600	38	applied	\N	\N	\N	\N	48928	48928	48929
13327	14601	39	applied	\N	\N	\N	\N	48930	48930	48931
13327	14606	40	applied	\N	\N	\N	\N	48943	48943	48944
13327	14609	41	applied	\N	\N	\N	\N	48953	48953	48954
13327	14612	42	applied	\N	\N	\N	\N	48967	48967	48968
13327	14613	43	applied	\N	\N	\N	\N	48969	48969	48970
13327	14620	44	applied	\N	\N	\N	\N	48997	48997	48998
13327	14623	45	applied	\N	\N	\N	\N	49010	49010	49011
13327	14625	46	applied	\N	\N	\N	\N	49017	49017	49018
13327	14629	47	applied	\N	\N	\N	\N	49028	49028	49029
13327	14631	48	applied	\N	\N	\N	\N	49035	49035	49036
13327	14634	49	applied	\N	\N	\N	\N	49046	49046	49047
13327	14636	50	applied	\N	\N	\N	\N	49052	49052	49053
13327	14639	51	applied	\N	\N	\N	\N	49060	49060	49061
13327	14642	52	applied	\N	\N	\N	\N	49069	49069	49070
13327	14643	53	applied	\N	\N	\N	\N	49071	49071	49072
13327	14648	54	applied	\N	\N	\N	\N	49083	49083	49084
13327	14649	55	applied	\N	\N	\N	\N	49085	49085	49086
13327	14654	56	applied	\N	\N	\N	\N	49097	49097	49098
13327	14658	57	applied	\N	\N	\N	\N	49107	49107	49108
13327	14659	58	applied	\N	\N	\N	\N	49111	49111	49112
13327	14664	59	applied	\N	\N	\N	\N	49124	49124	49125
13327	14665	60	applied	\N	\N	\N	\N	49126	49126	49127
13327	14671	61	applied	\N	\N	\N	\N	49141	49141	49142
13327	14672	62	applied	\N	\N	\N	\N	49147	49147	49148
13327	14674	63	applied	\N	\N	\N	\N	49152	49152	49153
13327	14677	64	applied	\N	\N	\N	\N	49164	49164	49165
13327	14679	65	applied	\N	\N	\N	\N	49175	49175	49176
13327	14682	66	applied	\N	\N	\N	\N	49183	49183	49184
13327	14685	67	applied	\N	\N	\N	\N	49190	49190	49191
13327	14686	68	applied	\N	\N	\N	\N	49192	49192	49193
13327	14687	69	applied	\N	\N	\N	\N	49194	49194	49195
13327	14694	70	applied	\N	\N	\N	\N	49210	49210	49211
13327	14697	71	applied	\N	\N	\N	\N	49220	49220	49221
13327	14698	72	applied	\N	\N	\N	\N	49222	49222	49223
13327	14703	73	applied	\N	\N	\N	\N	49233	49233	49234
13327	14706	74	applied	\N	\N	\N	\N	49241	49241	49242
13327	14709	75	applied	\N	\N	\N	\N	49249	49249	49250
13327	14712	76	applied	\N	\N	\N	\N	49259	49259	49260
13327	14715	77	applied	\N	\N	\N	\N	49267	49267	49268
13327	14716	78	applied	\N	\N	\N	\N	49269	49269	49270
13327	14721	79	applied	\N	\N	\N	\N	49283	49283	49284
13327	14722	80	applied	\N	\N	\N	\N	49285	49285	49286
13327	14727	81	applied	\N	\N	\N	\N	49297	49297	49298
13327	14730	82	applied	\N	\N	\N	\N	49304	49304	49305
13327	14735	83	applied	\N	\N	\N	\N	49316	49316	49317
13327	14736	84	applied	\N	\N	\N	\N	49318	49318	49319
13327	14740	85	applied	\N	\N	\N	\N	49328	49328	49329
13327	14743	86	applied	\N	\N	\N	\N	49338	49338	49339
13327	14746	87	applied	\N	\N	\N	\N	49347	49347	49348
13327	14747	88	applied	\N	\N	\N	\N	49349	49349	49350
13327	14752	89	applied	\N	\N	\N	\N	49362	49362	49363
13327	14755	90	applied	\N	\N	\N	\N	49371	49371	49372
13327	14758	91	applied	\N	\N	\N	\N	49379	49379	49380
13327	14761	92	applied	\N	\N	\N	\N	49388	49388	49389
13327	14764	93	applied	\N	\N	\N	\N	49398	49398	49399
13327	14767	94	applied	\N	\N	\N	\N	49410	49410	49411
13327	14770	95	applied	\N	\N	\N	\N	49417	49417	49418
13327	14772	96	applied	\N	\N	\N	\N	49423	49423	49424
13327	14775	97	applied	\N	\N	\N	\N	49431	49431	49432
13327	14778	98	applied	\N	\N	\N	\N	49438	49438	49439
13327	14781	99	applied	\N	\N	\N	\N	49446	49446	49447
13327	14782	100	applied	\N	\N	\N	\N	49448	49448	49449
13327	14783	101	applied	\N	\N	\N	\N	49450	49450	49451
13327	14790	102	applied	\N	\N	\N	\N	49466	49466	49467
13327	14793	103	applied	\N	\N	\N	\N	49474	49474	49475
13327	14794	104	applied	\N	\N	\N	\N	49478	49478	49479
13327	14795	105	applied	\N	\N	\N	\N	49480	49480	49481
13327	14723	106	applied	\N	\N	\N	\N	49287	49287	49288
13327	14504	107	applied	\N	\N	\N	\N	48675	48675	48676
13327	14505	108	applied	\N	\N	\N	\N	48677	48677	48678
13327	14506	109	applied	\N	\N	\N	\N	48679	48679	48680
13333	14813	0	applied	\N	\N	\N	\N	49527	49527	49528
13333	14814	1	applied	\N	\N	\N	\N	49529	49529	49530
13333	14816	2	applied	\N	\N	\N	\N	49533	49533	49534
13333	14817	3	applied	\N	\N	\N	\N	49535	49535	49536
13333	14815	4	applied	\N	\N	\N	\N	49531	49531	25661
13333	14818	5	applied	\N	\N	\N	\N	49537	49537	49538
13333	14819	6	applied	\N	\N	1000000000	\N	49539	49539	49540
13333	14820	7	applied	\N	\N	\N	\N	49541	49541	49542
13333	14821	8	applied	\N	\N	\N	\N	49543	49543	49544
13333	14822	9	applied	\N	\N	\N	\N	49545	49545	49546
13349	14860	0	applied	\N	\N	\N	\N	49646	49646	49647
13349	14861	1	applied	\N	\N	\N	\N	49648	49648	49649
13349	14862	2	applied	\N	\N	\N	\N	49650	49650	49651
13349	14863	3	applied	\N	\N	\N	\N	49652	49652	49653
13351	14860	0	applied	\N	\N	\N	\N	49646	49646	49647
13359	14868	0	applied	\N	\N	\N	\N	49668	49668	49669
13359	14867	1	applied	\N	\N	\N	\N	49663	49663	49664
13359	14869	2	applied	\N	\N	\N	\N	49670	49670	49671
13360	14871	0	applied	\N	\N	\N	\N	49682	49682	49683
13360	14872	1	applied	\N	\N	\N	\N	49684	49684	49685
13360	14873	2	applied	\N	\N	\N	\N	49686	49686	49687
13360	14874	3	applied	\N	\N	\N	\N	49688	49688	25661
13364	14876	0	applied	\N	\N	\N	\N	49700	49700	49701
13364	14877	1	applied	\N	\N	\N	\N	49702	49702	49703
13364	14878	2	applied	\N	\N	\N	\N	49704	49704	49705
13364	14879	3	applied	\N	\N	\N	\N	49706	49706	49707
13364	14880	4	applied	\N	\N	\N	\N	49708	49708	49709
13364	14881	5	applied	\N	\N	\N	\N	49710	49710	49711
13377	14919	0	applied	\N	\N	\N	\N	49811	49811	49812
13377	14920	1	applied	\N	\N	\N	\N	49813	49813	49814
13377	14921	2	applied	\N	\N	\N	\N	49815	49815	49816
13377	14922	3	applied	\N	\N	\N	\N	49817	49817	49818
13380	14928	0	applied	\N	\N	\N	\N	49832	49832	49833
13385	14952	0	applied	\N	\N	\N	\N	49891	49891	49892
13385	14953	1	applied	\N	\N	\N	\N	49893	49893	49894
13385	14954	2	applied	\N	\N	\N	\N	49895	49895	49896
13397	14971	0	applied	\N	\N	\N	\N	49945	49945	49946
13397	14972	1	applied	\N	\N	\N	\N	49947	49947	49948
13397	14973	2	applied	\N	\N	\N	\N	49949	49949	49950
13397	14974	3	applied	\N	\N	\N	\N	49951	49951	49952
13397	14975	4	applied	\N	\N	\N	\N	49953	49953	49954
13397	14976	5	applied	\N	\N	\N	\N	49955	49955	49956
13397	14977	6	applied	\N	\N	\N	\N	49957	49957	49958
13399	14979	0	applied	\N	\N	\N	\N	49966	49966	49967
13399	14980	1	applied	\N	\N	\N	\N	49968	49968	49969
13399	14978	2	applied	\N	\N	\N	\N	49963	49963	49964
13399	14981	3	applied	\N	\N	\N	\N	49970	49970	49971
13399	14982	4	applied	\N	\N	\N	\N	49972	49972	49973
13399	14983	5	applied	\N	\N	\N	\N	49974	49974	49975
13399	14984	6	applied	\N	\N	\N	\N	49976	49976	49977
13402	14985	0	applied	\N	\N	\N	\N	49980	49980	49981
13402	14986	1	applied	\N	\N	\N	\N	49982	49982	49983
13402	14987	2	applied	\N	\N	\N	\N	49984	49984	49985
13402	14988	3	applied	\N	\N	\N	\N	49986	49986	49987
13402	14989	4	applied	\N	\N	\N	\N	49988	49988	49989
13402	14990	5	applied	\N	\N	\N	\N	49990	49990	49991
13406	14991	0	applied	\N	\N	\N	\N	49999	49999	50000
13419	15033	0	applied	\N	\N	\N	\N	50099	50099	50100
13419	15034	1	applied	\N	\N	\N	\N	50101	50101	50102
13419	15035	2	applied	\N	\N	\N	\N	50103	50103	50104
13423	15042	0	applied	\N	\N	\N	\N	50120	50120	50121
13423	15043	1	applied	\N	\N	\N	\N	50122	50122	50123
13423	15045	2	applied	\N	\N	\N	\N	50127	50127	50128
13423	15046	3	applied	\N	\N	\N	\N	50129	50129	50130
13423	15047	4	applied	\N	\N	\N	\N	50131	50131	50132
13423	15048	5	applied	\N	\N	\N	\N	50133	50133	50134
13423	15049	6	applied	\N	\N	\N	\N	50135	50135	50136
13423	15050	7	applied	\N	\N	\N	\N	50137	50137	50138
13423	15044	8	applied	\N	\N	\N	\N	50124	50124	25661
13429	15059	0	applied	\N	\N	\N	\N	50165	50165	50166
13429	15060	1	applied	\N	\N	\N	\N	50167	50167	50168
13429	15061	2	applied	\N	\N	\N	\N	50169	50169	50170
13429	15062	3	applied	\N	\N	\N	\N	50171	50171	50172
13431	15063	0	applied	\N	\N	\N	\N	50176	50176	50177
13431	15064	1	applied	\N	\N	\N	\N	50178	50178	50179
13431	15065	2	applied	\N	\N	\N	\N	50180	50180	50181
13432	15066	0	applied	\N	\N	\N	\N	50184	50184	50185
13432	15067	1	applied	\N	\N	\N	\N	50186	50186	50187
13432	15068	2	applied	\N	\N	\N	\N	50188	50188	50189
13432	15069	3	applied	\N	\N	\N	\N	50190	50190	50191
13432	15070	4	applied	\N	\N	\N	\N	50192	50192	50193
13432	15071	5	applied	\N	\N	\N	\N	50194	50194	50195
13432	15072	6	applied	\N	\N	\N	\N	50196	50196	50197
13432	15073	7	applied	\N	\N	\N	\N	50198	50198	50199
13432	15074	8	applied	\N	\N	\N	\N	50200	50200	50201
13432	15075	9	applied	\N	\N	\N	\N	50202	50202	50203
13432	15076	10	applied	\N	\N	\N	\N	50204	50204	50205
13432	15077	11	applied	\N	\N	\N	\N	50206	50206	50207
13435	15082	0	applied	\N	\N	\N	\N	50220	50220	50221
13435	15083	1	applied	\N	\N	\N	\N	50222	50222	50223
13435	15084	2	applied	\N	\N	\N	\N	50224	50224	50225
13435	15085	3	applied	\N	\N	\N	\N	50226	50226	50227
13437	15086	0	applied	\N	\N	\N	\N	50232	50232	50233
13437	15087	1	applied	\N	\N	\N	\N	50236	50236	50237
13437	15088	2	applied	\N	\N	\N	\N	50238	50238	50239
13437	15089	3	applied	\N	\N	\N	\N	50240	50240	50241
13362	14428	2	applied	\N	\N	\N	\N	48467	48467	48468
13362	14448	3	applied	\N	\N	\N	\N	48524	48524	48525
13362	14435	4	applied	\N	\N	\N	\N	48490	48490	48491
13362	14454	5	applied	\N	\N	\N	\N	48541	48541	48542
13362	14436	6	applied	\N	\N	\N	\N	48492	48492	48493
13362	14476	7	applied	\N	\N	\N	\N	48603	48603	48604
13362	14481	8	applied	\N	\N	\N	\N	48617	48617	48618
13362	14439	9	applied	\N	\N	\N	\N	48498	48498	48499
13362	14444	10	applied	\N	\N	\N	\N	48511	48511	48512
13362	14482	11	applied	\N	\N	\N	\N	48619	48619	48620
13362	14489	12	applied	\N	\N	\N	\N	48636	48636	48637
13362	14491	13	applied	\N	\N	\N	\N	48640	48640	48641
13362	14492	14	applied	\N	\N	\N	\N	48643	48643	48644
13362	14655	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13362	14660	16	applied	\N	\N	1000000000	\N	49113	49113	49114
13362	14731	17	applied	\N	\N	\N	\N	49306	49306	49307
13362	14239	18	applied	\N	\N	\N	\N	48004	48004	48005
13362	14242	19	applied	\N	\N	\N	\N	48012	48012	48013
13362	14245	20	applied	\N	\N	\N	\N	48022	48022	48023
13362	14246	21	applied	\N	\N	\N	\N	48026	48026	48027
13362	14252	22	applied	\N	\N	\N	\N	48039	48039	48040
13362	14255	23	applied	\N	\N	\N	\N	48046	48046	48047
13362	14259	24	applied	\N	\N	\N	\N	48055	48055	48056
13362	14260	25	applied	\N	\N	\N	\N	48057	48057	48058
13362	14267	26	applied	\N	\N	\N	\N	48072	48072	48073
13362	14271	27	applied	\N	\N	\N	\N	48083	48083	48084
13362	14275	28	applied	\N	\N	\N	\N	48093	48093	48094
13362	14279	29	applied	\N	\N	\N	\N	48105	48105	48106
13362	14282	30	applied	\N	\N	\N	\N	48112	48112	48113
13362	14286	31	applied	\N	\N	\N	\N	48121	48121	48122
13362	14290	32	applied	\N	\N	\N	\N	48135	48135	48136
13362	14291	33	applied	\N	\N	\N	\N	48137	48137	48138
13362	14296	34	applied	\N	\N	\N	\N	48149	48149	48150
13362	14297	35	applied	\N	\N	\N	\N	48151	48151	48152
13362	14304	36	applied	\N	\N	\N	\N	48176	48176	48177
13362	14308	37	applied	\N	\N	\N	\N	48187	48187	48188
13362	14311	38	applied	\N	\N	\N	\N	48196	48196	48197
13362	14314	39	applied	\N	\N	\N	\N	48202	48202	48203
13362	14315	40	applied	\N	\N	\N	\N	48204	48204	48205
13362	14322	41	applied	\N	\N	\N	\N	48222	48222	48223
13362	14326	42	applied	\N	\N	\N	\N	48231	48231	48232
13362	14327	43	applied	\N	\N	\N	\N	48233	48233	48234
13362	14328	44	applied	\N	\N	\N	\N	48235	48235	48236
13362	14338	45	applied	\N	\N	\N	\N	48257	48257	48258
13362	14341	46	applied	\N	\N	\N	\N	48265	48265	48266
13362	14345	47	applied	\N	\N	\N	\N	48275	48275	48276
13362	14348	48	applied	\N	\N	\N	\N	48285	48285	48286
13362	14349	49	applied	\N	\N	\N	\N	48287	48287	48288
13362	14350	50	applied	\N	\N	\N	\N	48289	48289	48290
13362	14360	51	applied	\N	\N	\N	\N	48313	48313	48314
13362	14367	52	applied	\N	\N	\N	\N	48328	48328	48329
13362	14368	53	applied	\N	\N	\N	\N	48330	48330	48331
13362	14369	54	applied	\N	\N	\N	\N	48332	48332	48333
13362	14370	55	applied	\N	\N	\N	\N	48334	48334	48335
13362	14371	56	applied	\N	\N	\N	\N	48336	48336	48337
13362	14384	57	applied	\N	\N	\N	\N	48364	48364	48365
13362	14388	58	applied	\N	\N	\N	\N	48372	48372	48373
13362	14392	59	applied	\N	\N	\N	\N	48383	48383	48384
13362	14396	60	applied	\N	\N	\N	\N	48396	48396	48397
13362	14397	61	applied	\N	\N	\N	\N	48399	48399	48400
13362	14404	62	applied	\N	\N	\N	\N	48415	48415	48416
13362	14408	63	applied	\N	\N	\N	\N	48424	48424	48425
13362	14409	64	applied	\N	\N	\N	\N	48426	48426	48427
13362	14410	65	applied	\N	\N	\N	\N	48428	48428	48429
13362	14411	66	applied	\N	\N	\N	\N	48430	48430	48431
13362	14412	67	applied	\N	\N	\N	\N	48432	48432	48433
13362	14413	68	applied	\N	\N	\N	\N	48434	48434	48435
13362	14429	69	applied	\N	\N	\N	\N	48469	48469	48470
13362	14433	70	applied	\N	\N	\N	\N	48481	48481	48482
13362	14437	71	applied	\N	\N	\N	\N	48494	48494	48495
13362	14438	72	applied	\N	\N	\N	\N	48496	48496	48497
13362	14445	73	applied	\N	\N	\N	\N	48513	48513	48514
13362	14449	74	applied	\N	\N	\N	\N	48526	48526	48527
13362	14452	75	applied	\N	\N	\N	\N	48537	48537	48538
13362	14453	76	applied	\N	\N	\N	\N	48539	48539	48540
13362	14455	77	applied	\N	\N	\N	\N	48543	48543	48544
13362	14462	78	applied	\N	\N	\N	\N	48559	48559	48560
13362	14463	79	applied	\N	\N	\N	\N	48562	48562	48563
13362	14468	80	applied	\N	\N	\N	\N	48577	48577	48578
13362	14470	81	applied	\N	\N	\N	\N	48583	48583	48584
13362	14472	82	applied	\N	\N	\N	\N	48594	48594	48595
13362	14475	83	applied	\N	\N	\N	\N	48601	48601	48602
13362	14479	84	applied	\N	\N	\N	\N	48613	48613	48614
13362	14480	85	applied	\N	\N	\N	\N	48615	48615	48616
13362	14483	86	applied	\N	\N	\N	\N	48621	48621	48622
13362	14490	87	applied	\N	\N	\N	\N	48638	48638	48639
13362	14493	88	applied	\N	\N	\N	\N	48645	48645	48646
13362	14494	89	applied	\N	\N	\N	\N	48647	48647	48648
13362	14501	90	applied	\N	\N	\N	\N	48669	48669	48670
13362	14502	92	applied	\N	\N	\N	\N	48671	48671	48672
13362	14503	93	applied	\N	\N	\N	\N	48673	48673	48674
13362	14510	94	applied	\N	\N	\N	\N	48689	48689	48690
13362	14511	95	applied	\N	\N	\N	\N	48693	48693	48694
13362	14515	96	applied	\N	\N	\N	\N	48706	48706	48707
13362	14516	97	applied	\N	\N	\N	\N	48708	48708	48709
13362	14521	98	applied	\N	\N	\N	\N	48721	48721	48722
13362	14522	99	applied	\N	\N	\N	\N	48723	48723	48724
13362	14523	100	applied	\N	\N	\N	\N	48725	48725	48726
13362	14530	101	applied	\N	\N	\N	\N	48741	48741	48742
13362	14531	102	applied	\N	\N	\N	\N	48743	48743	48744
13362	14536	103	applied	\N	\N	\N	\N	48755	48755	48756
13362	14537	104	applied	\N	\N	\N	\N	48757	48757	48758
13362	14538	105	applied	\N	\N	\N	\N	48759	48759	48760
13362	14545	106	applied	\N	\N	\N	\N	48775	48775	48776
13362	14548	107	applied	\N	\N	\N	\N	48788	48788	48789
13362	14551	108	applied	\N	\N	\N	\N	48799	48799	48800
13362	14554	109	applied	\N	\N	\N	\N	48806	48806	48807
13362	14555	110	applied	\N	\N	\N	\N	48808	48808	48809
13362	14559	111	applied	\N	\N	\N	\N	48817	48817	48818
13362	14560	112	applied	\N	\N	\N	\N	48819	48819	48820
13362	14565	113	applied	\N	\N	\N	\N	48833	48833	48834
13362	14568	114	applied	\N	\N	\N	\N	48841	48841	48842
13362	14571	115	applied	\N	\N	\N	\N	48851	48851	48852
13362	14574	116	applied	\N	\N	\N	\N	48857	48857	48858
13362	14577	117	applied	\N	\N	\N	\N	48865	48865	48866
13362	14580	118	applied	\N	\N	\N	\N	48872	48872	48873
13362	14581	119	applied	\N	\N	\N	\N	48875	48875	48876
13362	14586	120	applied	\N	\N	\N	\N	48891	48891	48892
13362	14589	121	applied	\N	\N	\N	\N	48898	48898	48899
13362	14590	122	applied	\N	\N	\N	\N	48900	48900	48901
13362	14594	123	applied	\N	\N	\N	\N	48910	48910	48911
13362	14597	124	applied	\N	\N	\N	\N	48917	48917	48918
13362	14600	125	applied	\N	\N	\N	\N	48928	48928	48929
13363	14875	0	applied	\N	\N	\N	\N	49696	49696	49697
13366	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13366	14482	1	applied	\N	\N	\N	\N	48619	48619	48620
13366	14489	2	applied	\N	\N	\N	\N	48636	48636	48637
13366	14491	3	applied	\N	\N	\N	\N	48640	48640	48641
13366	14492	4	applied	\N	\N	\N	\N	48643	48643	48644
13366	14655	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13366	14660	6	applied	\N	\N	1000000000	\N	49113	49113	49114
13366	14731	7	applied	\N	\N	\N	\N	49306	49306	49307
13366	14805	8	applied	\N	\N	\N	\N	49509	49509	25661
13366	14723	9	applied	\N	\N	\N	\N	49287	49287	49288
13366	14815	10	applied	\N	\N	\N	\N	49531	49531	25661
13366	14824	11	applied	\N	\N	\N	\N	49554	49554	25661
13366	14874	12	applied	\N	\N	\N	\N	49688	49688	25661
13371	14900	0	applied	\N	\N	\N	\N	49763	49763	49764
13371	14901	1	applied	\N	\N	\N	\N	49765	49765	49766
13371	14902	2	applied	\N	\N	\N	\N	49767	49767	49768
13371	14903	3	applied	\N	\N	\N	\N	49769	49769	49770
13371	14904	4	applied	\N	\N	\N	\N	49771	49771	49772
13371	14905	5	applied	\N	\N	\N	\N	49773	49773	49774
13371	14906	6	applied	\N	\N	\N	\N	49775	49775	49776
13371	14907	7	applied	\N	\N	\N	\N	49777	49777	49778
13371	14908	8	applied	\N	\N	\N	\N	49779	49779	49780
13371	14909	9	applied	\N	\N	\N	\N	49781	49781	49782
13371	14910	10	applied	\N	\N	\N	\N	49783	49783	49784
13374	14911	0	applied	\N	\N	\N	\N	49789	49789	49790
13374	14912	1	applied	\N	\N	\N	\N	49791	49791	49792
13374	14913	2	applied	\N	\N	\N	\N	49793	49793	49794
13374	14914	3	applied	\N	\N	\N	\N	49795	49795	49796
13378	14923	0	applied	\N	\N	\N	\N	49821	49821	49822
13378	14924	1	applied	\N	\N	\N	\N	49823	49823	49493
13378	14925	2	applied	\N	\N	\N	\N	49824	49824	49825
13378	14926	3	applied	\N	\N	\N	\N	49826	49826	49827
13378	14927	4	applied	\N	\N	\N	\N	49828	49828	49829
13381	14932	0	applied	\N	\N	\N	\N	49843	49843	49844
13381	14933	1	applied	\N	\N	\N	\N	49845	49845	49846
13381	14934	2	applied	\N	\N	\N	\N	49847	49847	49848
13381	14929	3	applied	\N	\N	\N	\N	49834	49834	49835
13381	14930	4	applied	\N	\N	\N	\N	49836	49836	49837
13381	14931	5	applied	\N	\N	\N	\N	49838	49838	49839
13381	14935	6	applied	\N	\N	\N	\N	49849	49849	49850
13381	14936	7	applied	\N	\N	\N	\N	49851	49851	49852
13381	14937	8	applied	\N	\N	\N	\N	49853	49853	49854
13381	14938	9	applied	\N	\N	\N	\N	49855	49855	49856
13381	14939	10	applied	\N	\N	\N	\N	49857	49857	49858
13381	14940	11	applied	\N	\N	1000000000	\N	49859	49859	49860
13381	14941	12	applied	\N	\N	\N	\N	49861	49861	49862
13381	14942	13	applied	\N	\N	\N	\N	49863	49863	49864
13381	14943	14	applied	\N	\N	\N	\N	49865	49865	49866
13384	14944	0	applied	\N	\N	\N	\N	49869	49869	49870
13384	14945	1	applied	\N	\N	\N	\N	49871	49871	49872
13384	14946	2	applied	\N	\N	\N	\N	49873	49873	49874
13384	14947	3	applied	\N	\N	\N	\N	49875	49875	49876
13384	14948	4	applied	\N	\N	\N	\N	49877	49877	49878
13384	14949	5	applied	\N	\N	\N	\N	49879	49879	49880
13384	14950	6	applied	\N	\N	\N	\N	49881	49881	49882
13384	14951	7	applied	\N	\N	\N	\N	49883	49883	49884
13386	14955	0	applied	\N	\N	\N	\N	49899	49899	49900
13386	14956	1	applied	\N	\N	\N	\N	49901	49901	49902
13386	14957	2	applied	\N	\N	\N	\N	49903	49903	49904
13391	14961	0	applied	\N	\N	\N	\N	49916	49916	49917
13391	14962	1	applied	\N	\N	\N	\N	49918	49918	49919
13391	14963	2	applied	\N	\N	\N	\N	49920	49920	49921
13393	14964	0	applied	\N	\N	\N	\N	49926	49926	49927
13393	14965	1	applied	\N	\N	\N	\N	49928	49928	49929
13393	14966	2	applied	\N	\N	\N	\N	49930	49930	49931
13393	14967	3	applied	\N	\N	\N	\N	49932	49932	49933
13393	14968	4	applied	\N	\N	\N	\N	49934	49934	49935
13393	14969	5	applied	\N	\N	\N	\N	49936	49936	49937
13393	14970	6	applied	\N	\N	\N	\N	49938	49938	49939
13404	14985	0	applied	\N	\N	\N	\N	49980	49980	49981
13404	14986	1	applied	\N	\N	\N	\N	49982	49982	49983
13404	14987	2	applied	\N	\N	\N	\N	49984	49984	49985
13404	14988	3	applied	\N	\N	\N	\N	49986	49986	49987
13404	14989	4	applied	\N	\N	\N	\N	49988	49988	49989
13404	14990	5	applied	\N	\N	\N	\N	49990	49990	49991
13408	14991	0	applied	\N	\N	\N	\N	49999	49999	50000
13408	14992	1	applied	\N	\N	\N	\N	50002	50002	50003
13408	14993	2	applied	\N	\N	\N	\N	50004	50004	50005
13408	14994	3	applied	\N	\N	\N	\N	50006	50006	50007
13412	15007	0	applied	\N	\N	\N	\N	50038	50038	50039
13412	15008	1	applied	\N	\N	\N	\N	50040	50040	50041
13412	15009	2	applied	\N	\N	\N	\N	50042	50042	50043
13412	15010	3	applied	\N	\N	\N	\N	50044	50044	50045
13412	15011	4	applied	\N	\N	\N	\N	50046	50046	50047
13412	15012	5	applied	\N	\N	\N	\N	50048	50048	50049
13415	15018	0	applied	\N	\N	\N	\N	50064	50064	50065
13415	15019	1	applied	\N	\N	\N	\N	50066	50066	50067
13418	15030	0	applied	\N	\N	\N	\N	50091	50091	50092
13418	15031	1	applied	\N	\N	\N	\N	50093	50093	50094
13418	15032	2	applied	\N	\N	\N	\N	50095	50095	50096
13421	15042	0	applied	\N	\N	\N	\N	50120	50120	50121
13421	15043	1	applied	\N	\N	\N	\N	50122	50122	50123
13421	15044	2	applied	\N	\N	\N	\N	50124	50124	25661
13426	15055	0	applied	\N	\N	\N	\N	50151	50151	50152
13433	15078	0	applied	\N	\N	\N	\N	50210	50210	50211
13433	15079	1	applied	\N	\N	\N	\N	50212	50212	50213
13433	15080	2	applied	\N	\N	\N	\N	50214	50214	50215
13433	15081	3	applied	\N	\N	\N	\N	50216	50216	50217
13439	15086	0	applied	\N	\N	\N	\N	50232	50232	50233
13439	15087	1	applied	\N	\N	\N	\N	50236	50236	50237
13439	15088	2	applied	\N	\N	\N	\N	50238	50238	50239
13439	15089	3	applied	\N	\N	\N	\N	50240	50240	50241
13373	14912	1	applied	\N	\N	\N	\N	49791	49791	49792
13373	14913	2	applied	\N	\N	\N	\N	49793	49793	49794
13373	14914	3	applied	\N	\N	\N	\N	49795	49795	49796
13383	14944	0	applied	\N	\N	\N	\N	49869	49869	49870
13383	14945	1	applied	\N	\N	\N	\N	49871	49871	49872
13383	14946	2	applied	\N	\N	\N	\N	49873	49873	49874
13383	14947	3	applied	\N	\N	\N	\N	49875	49875	49876
13383	14948	4	applied	\N	\N	\N	\N	49877	49877	49878
13383	14949	5	applied	\N	\N	\N	\N	49879	49879	49880
13383	14950	6	applied	\N	\N	\N	\N	49881	49881	49882
13383	14951	7	applied	\N	\N	\N	\N	49883	49883	49884
13388	14958	0	applied	\N	\N	\N	\N	49908	49908	49909
13388	14959	1	applied	\N	\N	\N	\N	49910	49910	49911
13388	14960	2	applied	\N	\N	\N	\N	49912	49912	49913
13390	14961	0	applied	\N	\N	\N	\N	49916	49916	49917
13390	14962	1	applied	\N	\N	\N	\N	49918	49918	49919
13390	14963	2	applied	\N	\N	\N	\N	49920	49920	49921
13395	14964	0	applied	\N	\N	\N	\N	49926	49926	49927
13395	14965	1	applied	\N	\N	\N	\N	49928	49928	49929
13395	14966	2	applied	\N	\N	\N	\N	49930	49930	49931
13395	14967	3	applied	\N	\N	\N	\N	49932	49932	49933
13395	14968	4	applied	\N	\N	\N	\N	49934	49934	49935
13395	14969	5	applied	\N	\N	\N	\N	49936	49936	49937
13395	14970	6	applied	\N	\N	\N	\N	49938	49938	49939
13398	14971	0	applied	\N	\N	\N	\N	49945	49945	49946
13398	14972	1	applied	\N	\N	\N	\N	49947	49947	49948
13398	14973	2	applied	\N	\N	\N	\N	49949	49949	49950
13398	14974	3	applied	\N	\N	\N	\N	49951	49951	49952
13398	14975	4	applied	\N	\N	\N	\N	49953	49953	49954
13398	14976	5	applied	\N	\N	\N	\N	49955	49955	49956
13398	14977	6	applied	\N	\N	\N	\N	49957	49957	49958
13398	14978	7	applied	\N	\N	\N	\N	49963	49963	49964
13400	14979	0	applied	\N	\N	\N	\N	49966	49966	49967
13400	14980	1	applied	\N	\N	\N	\N	49968	49968	49969
13400	14978	2	applied	\N	\N	\N	\N	49963	49963	49964
13400	14981	3	applied	\N	\N	\N	\N	49970	49970	49971
13400	14982	4	applied	\N	\N	\N	\N	49972	49972	49973
13400	14983	5	applied	\N	\N	\N	\N	49974	49974	49975
13400	14984	6	applied	\N	\N	\N	\N	49976	49976	49977
13403	14985	0	applied	\N	\N	\N	\N	49980	49980	49981
13403	14986	1	applied	\N	\N	\N	\N	49982	49982	49983
13403	14987	2	applied	\N	\N	\N	\N	49984	49984	49985
13407	14991	0	applied	\N	\N	\N	\N	49999	49999	50000
13407	14992	1	applied	\N	\N	\N	\N	50002	50002	50003
13407	14993	2	applied	\N	\N	\N	\N	50004	50004	50005
13407	14994	3	applied	\N	\N	\N	\N	50006	50006	50007
13409	14995	0	applied	\N	\N	\N	\N	50010	50010	50011
13409	14996	1	applied	\N	\N	\N	\N	50012	50012	50013
13409	14997	2	applied	\N	\N	\N	\N	50014	50014	50015
13409	14998	3	applied	\N	\N	\N	\N	50016	50016	50017
13409	14999	4	applied	\N	\N	\N	\N	50018	50018	50019
13409	15000	5	applied	\N	\N	\N	\N	50020	50020	50021
13409	15001	6	applied	\N	\N	\N	\N	50022	50022	50023
13409	15002	7	applied	\N	\N	\N	\N	50024	50024	50025
13411	15003	0	applied	\N	\N	\N	\N	50028	50028	50029
13411	15004	1	applied	\N	\N	\N	\N	50030	50030	50031
13411	15005	2	applied	\N	\N	\N	\N	50032	50032	50033
13411	15006	3	applied	\N	\N	\N	\N	50034	50034	50035
13414	15013	0	applied	\N	\N	\N	\N	50051	50051	50052
13414	15014	1	applied	\N	\N	\N	\N	50053	50053	50054
13414	15015	2	applied	\N	\N	\N	\N	50056	50056	50057
13414	15016	3	applied	\N	\N	\N	\N	50058	50058	50059
13414	15017	4	applied	\N	\N	\N	\N	50060	50060	50061
13420	15036	0	applied	\N	\N	\N	\N	50107	50107	50108
13420	15037	1	applied	\N	\N	\N	\N	50109	50109	50110
13420	15038	2	applied	\N	\N	\N	\N	50111	50111	25661
13420	15039	3	applied	\N	\N	\N	\N	50112	50112	50113
13420	15040	4	applied	\N	\N	\N	\N	50114	50114	50115
13420	15041	5	applied	\N	\N	\N	\N	50116	50116	50117
13425	15055	0	applied	\N	\N	\N	\N	50151	50151	50152
13425	15056	1	applied	\N	\N	\N	\N	50153	50153	50154
13425	15057	2	applied	\N	\N	\N	\N	50155	50155	50156
13425	15058	3	applied	\N	\N	\N	\N	50157	50157	50158
13428	15055	0	applied	\N	\N	\N	\N	50151	50151	50152
13430	15059	0	applied	\N	\N	\N	\N	50165	50165	50166
13430	15060	1	applied	\N	\N	\N	\N	50167	50167	50168
13430	15061	2	applied	\N	\N	\N	\N	50169	50169	50170
13430	15062	3	applied	\N	\N	\N	\N	50171	50171	50172
13438	15086	0	applied	\N	\N	\N	\N	50232	50232	50233
13382	14949	5	applied	\N	\N	\N	\N	49879	49879	49880
13382	14950	6	applied	\N	\N	\N	\N	49881	49881	49882
13382	14951	7	applied	\N	\N	\N	\N	49883	49883	49884
13387	14955	0	applied	\N	\N	\N	\N	49899	49899	49900
13387	14956	1	applied	\N	\N	\N	\N	49901	49901	49902
13387	14957	2	applied	\N	\N	\N	\N	49903	49903	49904
13392	14961	0	applied	\N	\N	\N	\N	49916	49916	49917
13392	14962	1	applied	\N	\N	\N	\N	49918	49918	49919
13392	14963	2	applied	\N	\N	\N	\N	49920	49920	49921
13394	14964	0	applied	\N	\N	\N	\N	49926	49926	49927
13394	14965	1	applied	\N	\N	\N	\N	49928	49928	49929
13394	14966	2	applied	\N	\N	\N	\N	49930	49930	49931
13394	14967	3	applied	\N	\N	\N	\N	49932	49932	49933
13394	14968	4	applied	\N	\N	\N	\N	49934	49934	49935
13394	14969	5	applied	\N	\N	\N	\N	49936	49936	49937
13394	14970	6	applied	\N	\N	\N	\N	49938	49938	49939
13396	14971	0	applied	\N	\N	\N	\N	49945	49945	49946
13396	14972	1	applied	\N	\N	\N	\N	49947	49947	49948
13396	14973	2	applied	\N	\N	\N	\N	49949	49949	49950
13396	14974	3	applied	\N	\N	\N	\N	49951	49951	49952
13396	14975	4	applied	\N	\N	\N	\N	49953	49953	49954
13396	14976	5	applied	\N	\N	\N	\N	49955	49955	49956
13396	14977	6	applied	\N	\N	\N	\N	49957	49957	49958
13401	14985	0	applied	\N	\N	\N	\N	49980	49980	49981
13401	14986	1	applied	\N	\N	\N	\N	49982	49982	49983
13401	14987	2	applied	\N	\N	\N	\N	49984	49984	49985
13401	14988	3	applied	\N	\N	\N	\N	49986	49986	49987
13401	14989	4	applied	\N	\N	\N	\N	49988	49988	49989
13401	14990	5	applied	\N	\N	\N	\N	49990	49990	49991
13405	14985	0	applied	\N	\N	\N	\N	49980	49980	49981
13405	14986	1	applied	\N	\N	\N	\N	49982	49982	49983
13413	15013	0	applied	\N	\N	\N	\N	50051	50051	50052
13413	15014	1	applied	\N	\N	\N	\N	50053	50053	50054
13416	15020	0	applied	\N	\N	\N	\N	50069	50069	50070
13416	15021	1	applied	\N	\N	\N	\N	50071	50071	50072
13416	15022	2	applied	\N	\N	\N	\N	50073	50073	50074
13416	15023	3	applied	\N	\N	\N	\N	50075	50075	50076
13416	15024	4	applied	\N	\N	\N	\N	50077	50077	50078
13416	15025	5	applied	\N	\N	\N	\N	50079	50079	50080
13416	15026	6	applied	\N	\N	\N	\N	50081	50081	50082
13416	15027	7	applied	\N	\N	\N	\N	50083	50083	50084
13416	15028	8	applied	\N	\N	\N	\N	50085	50085	50086
13416	15029	9	applied	\N	\N	\N	\N	50087	50087	50088
13422	15042	0	applied	\N	\N	\N	\N	50120	50120	50121
13422	15043	1	applied	\N	\N	\N	\N	50122	50122	50123
13422	15045	2	applied	\N	\N	\N	\N	50127	50127	50128
13422	15046	3	applied	\N	\N	\N	\N	50129	50129	50130
13422	15047	4	applied	\N	\N	\N	\N	50131	50131	50132
13422	15048	5	applied	\N	\N	\N	\N	50133	50133	50134
13422	15049	6	applied	\N	\N	\N	\N	50135	50135	50136
13422	15050	7	applied	\N	\N	\N	\N	50137	50137	50138
13422	15044	8	applied	\N	\N	\N	\N	50124	50124	25661
13424	15051	0	applied	\N	\N	\N	\N	50141	50141	50142
13424	15045	1	applied	\N	\N	\N	\N	50127	50127	50128
13424	15046	2	applied	\N	\N	\N	\N	50129	50129	50130
13424	15047	3	applied	\N	\N	\N	\N	50131	50131	50132
13424	15048	4	applied	\N	\N	\N	\N	50133	50133	50134
13424	15049	5	applied	\N	\N	\N	\N	50135	50135	50136
13424	15050	6	applied	\N	\N	\N	\N	50137	50137	50138
13424	15052	7	applied	\N	\N	\N	\N	50143	50143	50144
13424	15053	8	applied	\N	\N	\N	\N	50145	50145	50146
13424	15054	9	applied	\N	\N	\N	\N	50147	50147	50148
13427	15055	0	applied	\N	\N	\N	\N	50151	50151	50152
13427	15056	1	applied	\N	\N	\N	\N	50153	50153	50154
13427	15057	2	applied	\N	\N	\N	\N	50155	50155	50156
13427	15058	3	applied	\N	\N	\N	\N	50157	50157	50158
13434	15082	0	applied	\N	\N	\N	\N	50220	50220	50221
13434	15083	1	applied	\N	\N	\N	\N	50222	50222	50223
13434	15084	2	applied	\N	\N	\N	\N	50224	50224	50225
13434	15085	3	applied	\N	\N	\N	\N	50226	50226	50227
13436	15086	0	applied	\N	\N	\N	\N	50232	50232	50233
13441	15090	0	applied	\N	\N	\N	\N	50246	50246	50247
13441	15091	1	applied	\N	\N	\N	\N	50248	50248	50249
13441	15092	2	applied	\N	\N	\N	\N	50250	50250	50251
13441	15093	3	applied	\N	\N	\N	\N	50252	50252	50253
13441	15094	4	applied	\N	\N	\N	\N	50254	50254	50255
13441	15095	5	applied	\N	\N	\N	\N	50256	50256	50257
13441	15096	6	applied	\N	\N	\N	\N	50258	50258	50259
13441	15097	7	applied	\N	\N	\N	\N	50260	50260	50261
13441	15098	8	applied	\N	\N	\N	\N	50262	50262	50263
13441	15099	9	applied	\N	\N	\N	\N	50264	50264	50265
13441	15100	10	applied	\N	\N	\N	\N	50266	50266	50267
13441	15101	11	applied	\N	\N	\N	\N	50268	50268	50269
13441	15102	12	applied	\N	\N	\N	\N	50270	50270	50271
13441	15103	13	applied	\N	\N	\N	\N	50272	50272	50273
13441	15104	14	applied	\N	\N	\N	\N	50274	50274	50275
13442	15105	0	applied	\N	\N	\N	\N	50278	50278	50279
13443	15106	0	applied	\N	\N	\N	\N	50282	50282	50283
13443	15107	1	applied	\N	\N	\N	\N	50284	50284	50285
13443	15108	2	applied	\N	\N	\N	\N	50286	50286	50287
13443	15109	3	applied	\N	\N	\N	\N	50288	50288	50289
13443	15110	4	applied	\N	\N	\N	\N	50290	50290	50291
13443	15111	5	applied	\N	\N	\N	\N	50292	50292	50293
13444	15106	0	applied	\N	\N	\N	\N	50282	50282	50283
13445	15112	0	applied	\N	\N	\N	\N	50298	50298	50299
13445	15107	1	applied	\N	\N	\N	\N	50284	50284	50285
13445	15108	2	applied	\N	\N	\N	\N	50286	50286	50287
13445	15109	4	applied	\N	\N	\N	\N	50288	50288	50289
13445	15110	5	applied	\N	\N	\N	\N	50290	50290	50291
13445	15111	6	applied	\N	\N	\N	\N	50292	50292	50293
13445	15113	7	applied	\N	\N	\N	\N	50301	50301	50302
13445	15114	8	applied	\N	\N	\N	\N	50303	50303	50304
13445	15115	9	applied	\N	\N	\N	\N	50305	50305	50306
13446	15112	0	applied	\N	\N	\N	\N	50298	50298	50299
13446	15107	1	applied	\N	\N	\N	\N	50284	50284	50285
13446	15108	2	applied	\N	\N	\N	\N	50286	50286	50287
13446	15109	4	applied	\N	\N	\N	\N	50288	50288	50289
13446	15110	5	applied	\N	\N	\N	\N	50290	50290	50291
13446	15111	6	applied	\N	\N	\N	\N	50292	50292	50293
13446	15113	7	applied	\N	\N	\N	\N	50301	50301	50302
13446	15114	8	applied	\N	\N	\N	\N	50303	50303	50304
13446	15115	9	applied	\N	\N	\N	\N	50305	50305	50306
13447	15112	0	applied	\N	\N	\N	\N	50298	50298	50299
13447	15107	1	applied	\N	\N	\N	\N	50284	50284	50285
13447	15108	2	applied	\N	\N	\N	\N	50286	50286	50287
13447	15109	4	applied	\N	\N	\N	\N	50288	50288	50289
13447	15110	5	applied	\N	\N	\N	\N	50290	50290	50291
13447	15111	6	applied	\N	\N	\N	\N	50292	50292	50293
13447	15113	7	applied	\N	\N	\N	\N	50301	50301	50302
13447	15114	8	applied	\N	\N	\N	\N	50303	50303	50304
13447	15115	9	applied	\N	\N	\N	\N	50305	50305	50306
13449	15116	0	applied	\N	\N	\N	\N	50315	50315	50316
13449	15117	1	applied	\N	\N	\N	\N	50317	50317	50318
13449	15118	2	applied	\N	\N	\N	\N	50319	50319	50320
13454	15119	0	applied	\N	\N	\N	\N	50323	50323	50324
13454	15121	1	applied	\N	\N	\N	\N	50328	50328	50329
13454	15122	2	applied	\N	\N	\N	\N	50330	50330	50331
13454	15123	3	applied	\N	\N	\N	\N	50332	50332	50333
13455	15124	0	applied	\N	\N	\N	\N	50339	50339	50340
13455	15125	1	applied	\N	\N	\N	\N	50341	50341	50342
13455	15126	2	applied	\N	\N	\N	\N	50343	50343	50344
13461	15135	0	applied	\N	\N	\N	\N	50364	50364	50365
13461	15136	1	applied	\N	\N	\N	\N	50366	50366	50367
13461	15137	2	applied	\N	\N	\N	\N	50368	50368	50369
13470	15147	0	applied	\N	\N	\N	\N	50405	50405	50406
13470	15148	1	applied	\N	\N	\N	\N	50407	50407	50408
13470	15149	2	applied	\N	\N	\N	\N	50409	50409	50410
13473	15157	0	applied	\N	\N	\N	\N	50431	50431	50432
13473	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13473	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13473	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13477	15161	0	applied	\N	\N	\N	\N	50444	50444	50445
13477	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13477	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13477	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13477	15162	4	applied	\N	\N	\N	\N	50446	50446	50447
13477	15163	5	applied	\N	\N	\N	\N	50448	50448	50449
13477	15164	6	applied	\N	\N	\N	\N	50450	50450	50451
13483	15180	0	applied	\N	\N	\N	\N	50490	50490	50491
13483	15181	1	applied	\N	\N	\N	\N	50492	50492	50493
13483	15182	2	applied	\N	\N	\N	\N	50494	50494	50495
13483	15183	3	applied	\N	\N	\N	\N	50496	50496	50497
13483	15184	4	applied	\N	\N	\N	\N	50498	50498	50499
13483	15185	5	applied	\N	\N	\N	\N	50500	50500	50501
13483	15186	6	applied	\N	\N	\N	\N	50502	50502	50503
13483	15187	7	applied	\N	\N	\N	\N	50504	50504	50505
13483	15188	8	applied	\N	\N	\N	\N	50506	50506	50507
13486	15198	0	applied	\N	\N	\N	\N	50532	50532	50533
13486	15199	1	applied	\N	\N	\N	\N	50534	50534	50535
13486	15200	2	applied	\N	\N	\N	\N	50536	50536	50537
13486	15201	3	applied	\N	\N	\N	\N	50538	50538	50539
13486	15202	4	applied	\N	\N	\N	\N	50540	50540	50541
13486	15203	5	applied	\N	\N	\N	\N	50542	50542	50543
13486	15204	7	applied	\N	\N	\N	\N	50545	50545	50546
13486	15205	8	applied	\N	\N	\N	\N	50547	50547	50548
13486	15206	9	applied	\N	\N	\N	\N	50549	50549	50550
13486	15207	10	applied	\N	\N	1000000000	\N	50551	50551	50552
13486	15208	11	applied	\N	\N	1000000000	\N	50553	50553	50554
13489	15215	0	applied	\N	\N	\N	\N	50573	50573	50574
13489	15216	1	applied	\N	\N	\N	\N	50575	50575	50575
13492	15219	0	applied	\N	\N	\N	\N	50585	50585	50586
13492	15220	1	applied	\N	\N	\N	\N	50587	50587	50588
13492	15221	2	applied	\N	\N	\N	\N	50589	50589	50590
13492	15222	3	applied	\N	\N	\N	\N	50591	50591	50592
13492	15223	4	applied	\N	\N	\N	\N	50593	50593	50594
13492	15224	5	applied	\N	\N	\N	\N	50597	50597	50598
13492	15225	6	applied	\N	\N	\N	\N	50599	50599	50600
13492	15226	7	applied	\N	\N	\N	\N	50601	50601	50602
13492	15227	8	applied	\N	\N	\N	\N	50603	50603	50604
13494	15228	0	applied	\N	\N	\N	\N	50607	50607	50608
13494	15229	1	applied	\N	\N	\N	\N	50609	50609	50610
13494	15230	2	applied	\N	\N	\N	\N	50611	50611	50612
13496	15231	0	applied	\N	\N	\N	\N	50615	50615	50616
13496	15229	1	applied	\N	\N	\N	\N	50609	50609	50610
13496	15230	2	applied	\N	\N	\N	\N	50611	50611	50612
13496	15232	3	applied	\N	\N	\N	\N	50617	50617	50618
13503	15241	0	applied	\N	\N	\N	\N	50643	50643	50644
13503	15242	1	applied	\N	\N	\N	\N	50645	50645	50646
13503	15243	2	applied	\N	\N	\N	\N	50647	50647	50648
13506	15241	0	applied	\N	\N	\N	\N	50643	50643	50644
13508	15254	0	applied	\N	\N	\N	\N	50676	50676	50677
13508	15255	1	applied	\N	\N	\N	\N	50678	50678	50679
13508	15256	2	applied	\N	\N	\N	\N	50680	50680	50681
13510	15120	0	applied	\N	\N	\N	\N	50326	50326	50327
13510	15124	1	applied	\N	\N	\N	\N	50339	50339	50340
13510	15127	2	applied	\N	\N	\N	\N	50345	50345	50346
13510	15128	3	applied	\N	\N	\N	\N	50347	50347	50348
13510	15135	4	applied	\N	\N	\N	\N	50364	50364	50365
13510	15138	5	applied	\N	\N	\N	\N	50371	50371	50372
13510	15141	6	applied	\N	\N	\N	\N	50381	50381	50382
13510	15144	7	applied	\N	\N	\N	\N	50397	50397	50398
13510	15147	8	applied	\N	\N	\N	\N	50405	50405	50406
13510	15150	9	applied	\N	\N	\N	\N	50415	50415	50416
13510	15151	10	applied	\N	\N	\N	\N	50417	50417	50418
13510	15157	11	applied	\N	\N	\N	\N	50431	50431	50432
13510	15161	12	applied	\N	\N	\N	\N	50444	50444	50445
13510	15165	13	applied	\N	\N	\N	\N	50458	50458	50459
13510	15166	14	applied	\N	\N	\N	\N	50460	50460	50461
13510	15167	15	applied	\N	\N	\N	\N	50462	50462	50463
13510	15168	16	applied	\N	\N	\N	\N	50464	50464	50465
13510	15169	17	applied	\N	\N	\N	\N	50466	50466	50467
13510	15180	18	applied	\N	\N	\N	\N	50490	50490	50491
13510	15181	19	applied	\N	\N	\N	\N	50492	50492	50493
13510	15182	20	applied	\N	\N	\N	\N	50494	50494	50495
13510	15189	21	applied	\N	\N	\N	\N	50512	50512	50513
13510	15190	22	applied	\N	\N	\N	\N	50514	50514	50515
13510	15191	23	applied	\N	\N	\N	\N	50516	50516	50517
13510	15198	24	applied	\N	\N	\N	\N	50532	50532	50533
13510	15199	25	applied	\N	\N	\N	\N	50534	50534	50535
13510	15200	26	applied	\N	\N	\N	\N	50536	50536	50537
13510	15209	27	applied	\N	\N	\N	\N	50557	50557	50558
13510	15210	28	applied	\N	\N	\N	\N	50559	50559	50560
13510	15215	29	applied	\N	\N	\N	\N	50573	50573	50574
13510	15219	30	applied	\N	\N	\N	\N	50585	50585	50586
13510	15220	31	applied	\N	\N	\N	\N	50587	50587	50588
13510	15221	32	applied	\N	\N	\N	\N	50589	50589	50590
13510	15228	33	applied	\N	\N	\N	\N	50607	50607	50608
13510	15231	34	applied	\N	\N	\N	\N	50615	50615	50616
13510	15235	35	applied	\N	\N	\N	\N	50627	50627	50628
13510	15238	36	applied	\N	\N	\N	\N	50637	50637	50638
13510	15241	37	applied	\N	\N	\N	\N	50643	50643	50644
13510	15244	38	applied	\N	\N	\N	\N	50655	50655	50656
13510	15245	39	applied	\N	\N	\N	\N	50657	50657	50658
13510	15246	40	applied	\N	\N	\N	\N	50659	50659	50660
13510	15254	41	applied	\N	\N	\N	\N	50676	50676	50677
13510	15257	42	applied	\N	\N	\N	\N	50684	50684	50685
13510	15170	43	applied	\N	\N	\N	\N	50468	50468	50469
13513	15263	0	applied	\N	\N	\N	\N	50702	50702	50703
13513	15264	1	applied	\N	\N	\N	\N	50704	50704	50705
13448	15107	0	applied	\N	\N	\N	\N	50284	50284	50285
13448	15108	1	applied	\N	\N	\N	\N	50286	50286	50287
13448	15109	2	applied	\N	\N	\N	\N	50288	50288	50289
13448	15110	4	applied	\N	\N	\N	\N	50290	50290	50291
13448	15111	5	applied	\N	\N	\N	\N	50292	50292	50293
13448	15113	6	applied	\N	\N	\N	\N	50301	50301	50302
13448	15114	7	applied	\N	\N	\N	\N	50303	50303	50304
13448	15115	8	applied	\N	\N	\N	\N	50305	50305	50306
13450	15119	0	applied	\N	\N	\N	\N	50323	50323	50324
13462	15138	0	applied	\N	\N	\N	\N	50371	50371	50372
13462	15139	1	applied	\N	\N	\N	\N	50373	50373	50374
13462	15140	2	applied	\N	\N	\N	\N	50375	50375	50376
13464	15141	0	applied	\N	\N	\N	\N	50381	50381	50382
13464	15142	1	applied	\N	\N	\N	\N	50383	50383	50384
13464	15143	2	applied	\N	\N	\N	\N	50385	50385	50386
13474	15157	0	applied	\N	\N	\N	\N	50431	50431	50432
13475	15157	0	applied	\N	\N	\N	\N	50431	50431	50432
13478	15161	0	applied	\N	\N	\N	\N	50444	50444	50445
13484	15180	0	applied	\N	\N	\N	\N	50490	50490	50491
13484	15181	1	applied	\N	\N	\N	\N	50492	50492	50493
13484	15182	2	applied	\N	\N	\N	\N	50494	50494	50495
13484	15183	3	applied	\N	\N	\N	\N	50496	50496	50497
13484	15184	4	applied	\N	\N	\N	\N	50498	50498	50499
13484	15185	5	applied	\N	\N	\N	\N	50500	50500	50501
13484	15186	6	applied	\N	\N	\N	\N	50502	50502	50503
13484	15187	7	applied	\N	\N	\N	\N	50504	50504	50505
13484	15188	8	applied	\N	\N	\N	\N	50506	50506	50507
13487	15209	0	applied	\N	\N	\N	\N	50557	50557	50558
13487	15210	1	applied	\N	\N	\N	\N	50559	50559	50560
13487	15211	2	applied	\N	\N	\N	\N	50561	50561	50562
13487	15212	3	applied	\N	\N	\N	\N	50563	50563	50564
13487	15213	4	applied	\N	\N	\N	\N	50565	50565	50566
13487	15214	5	applied	\N	\N	\N	\N	50567	50567	50568
13490	15215	0	applied	\N	\N	\N	\N	50573	50573	50574
13490	15213	1	applied	\N	\N	\N	\N	50565	50565	50566
13490	15214	2	applied	\N	\N	\N	\N	50567	50567	50568
13490	15217	3	applied	\N	\N	\N	\N	50580	50580	50581
13490	15218	4	applied	\N	\N	\N	\N	50582	50582	50583
13490	15216	5	applied	\N	\N	\N	\N	50575	50575	50575
13497	15231	0	applied	\N	\N	\N	\N	50615	50615	50616
13497	15229	1	applied	\N	\N	\N	\N	50609	50609	50610
13497	15230	2	applied	\N	\N	\N	\N	50611	50611	50612
13497	15232	3	applied	\N	\N	\N	\N	50617	50617	50618
13497	15233	4	applied	\N	\N	\N	\N	50621	50621	50622
13497	15234	5	applied	\N	\N	1000000000	\N	50623	50623	50624
13499	15235	0	applied	\N	\N	\N	\N	50627	50627	50628
13499	15236	1	applied	\N	\N	\N	\N	50629	50629	50630
13499	15237	2	applied	\N	\N	\N	\N	50631	50631	50632
13504	15241	0	applied	\N	\N	\N	\N	50643	50643	50644
13504	15242	1	applied	\N	\N	\N	\N	50645	50645	50646
13504	15243	2	applied	\N	\N	\N	\N	50647	50647	50648
13518	15272	0	applied	\N	\N	\N	\N	50726	50726	50727
13518	15273	1	applied	\N	\N	\N	\N	50728	50728	50729
13518	15274	2	applied	\N	\N	\N	\N	50730	50730	50731
13518	15275	3	applied	\N	\N	\N	\N	50732	50732	50468
13521	15276	0	applied	\N	\N	\N	\N	50734	50734	50735
13521	15277	1	applied	\N	\N	\N	\N	50736	50736	50737
13521	15278	2	applied	\N	\N	\N	\N	50738	50738	50739
13521	15279	3	applied	\N	\N	\N	\N	50740	50740	50468
13525	15283	0	applied	\N	\N	\N	\N	50754	50754	50755
13525	15284	1	applied	\N	\N	\N	\N	50756	50756	50757
13525	15285	2	applied	\N	\N	\N	\N	50758	50758	50759
13525	15286	3	applied	\N	\N	1000000000	\N	50760	50760	50761
13527	15287	0	applied	\N	\N	\N	\N	50766	50766	50767
13527	15288	1	applied	\N	\N	\N	\N	50768	50768	50769
13527	15289	2	applied	\N	\N	\N	\N	50770	50770	50771
13527	15290	3	applied	\N	\N	\N	\N	50772	50772	50773
13527	15291	4	applied	\N	\N	\N	\N	50774	50774	50775
13527	15292	6	applied	\N	\N	\N	\N	50777	50777	50778
13532	15297	0	applied	\N	\N	\N	\N	50795	50795	50796
13532	15298	1	applied	\N	\N	\N	\N	50797	50797	50798
13532	15299	2	applied	\N	\N	\N	\N	50799	50799	50800
13543	15306	0	applied	\N	\N	\N	\N	50820	50820	50821
13543	15307	1	applied	\N	\N	\N	\N	50822	50822	50823
13543	15308	2	applied	\N	\N	\N	\N	50824	50824	50825
13545	15309	0	applied	\N	\N	\N	\N	50831	50831	50832
13545	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13545	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13549	15312	0	applied	\N	\N	\N	\N	50841	50841	50842
13549	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13549	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13549	15313	3	applied	\N	\N	\N	\N	50843	50843	50844
13549	15314	4	applied	\N	\N	\N	\N	50845	50845	50846
13556	15315	0	applied	\N	\N	\N	\N	50852	50852	50853
13556	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13556	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13556	15313	3	applied	\N	\N	\N	\N	50843	50843	50844
13556	15314	4	applied	\N	\N	\N	\N	50845	50845	50846
13556	15316	5	applied	\N	\N	\N	\N	50854	50854	50855
13556	15317	6	applied	\N	\N	\N	\N	50856	50856	50857
13559	15318	0	applied	\N	\N	\N	\N	50860	50860	50861
13559	15319	1	applied	\N	\N	\N	\N	50862	50862	50863
13559	15320	2	applied	\N	\N	\N	\N	50864	50864	50865
13562	15321	0	applied	\N	\N	\N	\N	50871	50871	50872
13568	15235	0	applied	\N	\N	\N	\N	50627	50627	50628
13568	15238	1	applied	\N	\N	\N	\N	50637	50637	50638
13568	15241	2	applied	\N	\N	\N	\N	50643	50643	50644
13568	15244	3	applied	\N	\N	\N	\N	50655	50655	50656
13568	15245	4	applied	\N	\N	\N	\N	50657	50657	50658
13568	15246	5	applied	\N	\N	\N	\N	50659	50659	50660
13568	15254	6	applied	\N	\N	\N	\N	50676	50676	50677
13568	15257	7	applied	\N	\N	\N	\N	50684	50684	50685
13568	15260	8	applied	\N	\N	\N	\N	50694	50694	50695
13568	15263	9	applied	\N	\N	\N	\N	50702	50702	50703
13568	15264	10	applied	\N	\N	\N	\N	50704	50704	50705
13568	15269	11	applied	\N	\N	\N	\N	50718	50718	50719
13568	15272	12	applied	\N	\N	\N	\N	50726	50726	50727
13568	15276	13	applied	\N	\N	\N	\N	50734	50734	50735
13568	15280	14	applied	\N	\N	\N	\N	50746	50746	50747
13568	15283	15	applied	\N	\N	\N	\N	50754	50754	50755
13568	15287	16	applied	\N	\N	\N	\N	50766	50766	50767
13568	15288	17	applied	\N	\N	\N	\N	50768	50768	50769
13568	15294	18	applied	\N	\N	\N	\N	50787	50787	50788
13568	15297	19	applied	\N	\N	\N	\N	50795	50795	50796
13568	15300	20	applied	\N	\N	\N	\N	50803	50803	50804
13568	15303	21	applied	\N	\N	\N	\N	50814	50814	50815
13568	15306	22	applied	\N	\N	\N	\N	50820	50820	50821
13568	15309	23	applied	\N	\N	\N	\N	50831	50831	50832
13568	15312	24	applied	\N	\N	\N	\N	50841	50841	50842
13451	15116	0	applied	\N	\N	\N	\N	50315	50315	50316
13451	15117	1	applied	\N	\N	\N	\N	50317	50317	50318
13451	15118	2	applied	\N	\N	\N	\N	50319	50319	50320
13452	15119	0	applied	\N	\N	\N	\N	50323	50323	50324
13452	15120	1	applied	\N	\N	\N	\N	50326	50326	50327
13452	15121	2	applied	\N	\N	\N	\N	50328	50328	50329
13452	15122	3	applied	\N	\N	\N	\N	50330	50330	50331
13452	15123	4	applied	\N	\N	\N	\N	50332	50332	50333
13457	15127	0	applied	\N	\N	\N	\N	50345	50345	50346
13457	15128	1	applied	\N	\N	\N	\N	50347	50347	50348
13457	15129	2	applied	\N	\N	\N	\N	50349	50349	50350
13457	15130	3	applied	\N	\N	\N	\N	50351	50351	50352
13457	15131	4	applied	\N	\N	\N	\N	50353	50353	50354
13457	15132	5	applied	\N	\N	\N	\N	50355	50355	50356
13457	15133	6	applied	\N	\N	\N	\N	50357	50357	50358
13457	15134	7	applied	\N	\N	\N	\N	50359	50359	50360
13463	15138	0	applied	\N	\N	\N	\N	50371	50371	50372
13463	15139	1	applied	\N	\N	\N	\N	50373	50373	50374
13463	15140	2	applied	\N	\N	\N	\N	50375	50375	50376
13465	15141	0	applied	\N	\N	\N	\N	50381	50381	50382
13465	15142	1	applied	\N	\N	\N	\N	50383	50383	50384
13465	15143	2	applied	\N	\N	\N	\N	50385	50385	50386
13467	15144	0	applied	\N	\N	\N	\N	50397	50397	50398
13467	15145	1	applied	\N	\N	\N	\N	50399	50399	50400
13467	15146	2	applied	\N	\N	\N	\N	50401	50401	50402
13471	15150	0	applied	\N	\N	\N	\N	50415	50415	50416
13471	15151	1	applied	\N	\N	\N	\N	50417	50417	50418
13471	15152	2	applied	\N	\N	\N	\N	50419	50419	50420
13471	15153	3	applied	\N	\N	\N	\N	50421	50421	50422
13471	15154	4	applied	\N	\N	\N	\N	50423	50423	50424
13471	15155	5	applied	\N	\N	\N	\N	50425	50425	50426
13471	15156	6	applied	\N	\N	\N	\N	50427	50427	50428
13479	15161	0	applied	\N	\N	\N	\N	50444	50444	50445
13479	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13479	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13479	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13481	15165	0	applied	\N	\N	\N	\N	50458	50458	50459
13481	15166	1	applied	\N	\N	\N	\N	50460	50460	50461
13481	15167	2	applied	\N	\N	\N	\N	50462	50462	50463
13481	15168	3	applied	\N	\N	\N	\N	50464	50464	50465
13481	15169	4	applied	\N	\N	\N	\N	50466	50466	50467
13481	15170	5	applied	\N	\N	\N	\N	50468	50468	50469
13481	15162	6	applied	\N	\N	\N	\N	50446	50446	50447
13481	15163	7	applied	\N	\N	\N	\N	50448	50448	50449
13481	15164	8	applied	\N	\N	\N	\N	50450	50450	50451
13481	15171	9	applied	\N	\N	\N	\N	50470	50470	50471
13481	15172	10	applied	\N	\N	\N	\N	50472	50472	50473
13481	15173	11	applied	\N	\N	\N	\N	50474	50474	50475
13481	15174	12	applied	\N	\N	\N	\N	50476	50476	50477
13481	15175	13	applied	\N	\N	\N	\N	50478	50478	50479
13481	15176	14	applied	\N	\N	\N	\N	50480	50480	50481
13481	15177	15	applied	\N	\N	\N	\N	50482	50482	50483
13481	15178	16	applied	\N	\N	\N	\N	50484	50484	50485
13481	15179	17	applied	\N	\N	\N	\N	50486	50486	50487
13488	15209	0	applied	\N	\N	\N	\N	50557	50557	50558
13488	15210	1	applied	\N	\N	\N	\N	50559	50559	50560
13488	15211	2	applied	\N	\N	\N	\N	50561	50561	50562
13488	15212	3	applied	\N	\N	\N	\N	50563	50563	50564
13495	15228	0	applied	\N	\N	\N	\N	50607	50607	50608
13498	15231	0	applied	\N	\N	\N	\N	50615	50615	50616
13500	15235	0	applied	\N	\N	\N	\N	50627	50627	50628
13500	15236	1	applied	\N	\N	\N	\N	50629	50629	50630
13500	15237	2	applied	\N	\N	\N	\N	50631	50631	50632
13507	15244	0	applied	\N	\N	\N	\N	50655	50655	50656
13507	15245	1	applied	\N	\N	\N	\N	50657	50657	50658
13507	15246	2	applied	\N	\N	\N	\N	50659	50659	50660
13507	15247	3	applied	\N	\N	\N	\N	50661	50661	50662
13507	15248	4	applied	\N	\N	\N	\N	50663	50663	50664
13507	15249	5	applied	\N	\N	\N	\N	50665	50665	50666
13507	15250	6	applied	\N	\N	\N	\N	50667	50667	50668
13507	15251	7	applied	\N	\N	\N	\N	50669	50669	50670
13507	15252	8	applied	\N	\N	\N	\N	50671	50671	50672
13507	15253	9	applied	\N	\N	1000000000	\N	50673	50673	50674
13509	15244	0	applied	\N	\N	\N	\N	50655	50655	50656
13509	15245	1	applied	\N	\N	\N	\N	50657	50657	50658
13509	15246	2	applied	\N	\N	\N	\N	50659	50659	50660
13509	15254	3	applied	\N	\N	\N	\N	50676	50676	50677
13509	15257	4	applied	\N	\N	\N	\N	50684	50684	50685
13509	15247	5	applied	\N	\N	\N	\N	50661	50661	50662
13509	15248	6	applied	\N	\N	\N	\N	50663	50663	50664
13509	15249	7	applied	\N	\N	\N	\N	50665	50665	50666
13509	15250	8	applied	\N	\N	\N	\N	50667	50667	50668
13509	15251	9	applied	\N	\N	\N	\N	50669	50669	50670
13509	15252	10	applied	\N	\N	\N	\N	50671	50671	50672
13509	15253	11	applied	\N	\N	1000000000	\N	50673	50673	50674
13509	15255	12	applied	\N	\N	\N	\N	50678	50678	50679
13509	15256	13	applied	\N	\N	\N	\N	50680	50680	50681
13509	15258	14	applied	\N	\N	\N	\N	50686	50686	50687
13509	15259	15	applied	\N	\N	\N	\N	50688	50688	50689
13511	15257	0	applied	\N	\N	\N	\N	50684	50684	50685
13511	15258	1	applied	\N	\N	\N	\N	50686	50686	50687
13511	15259	2	applied	\N	\N	\N	\N	50688	50688	50689
13516	15269	0	applied	\N	\N	\N	\N	50718	50718	50719
13523	15283	0	applied	\N	\N	\N	\N	50754	50754	50755
13523	15284	1	applied	\N	\N	\N	\N	50756	50756	50757
13523	15285	2	applied	\N	\N	\N	\N	50758	50758	50759
13523	15286	3	applied	\N	\N	1000000000	\N	50760	50760	50761
13530	15293	0	applied	\N	\N	\N	\N	50784	50784	50785
13533	15297	0	applied	\N	\N	\N	\N	50795	50795	50796
13533	15298	1	applied	\N	\N	\N	\N	50797	50797	50798
13533	15299	2	applied	\N	\N	\N	\N	50799	50799	50800
13539	15303	0	applied	\N	\N	\N	\N	50814	50814	50815
13539	15304	1	applied	\N	\N	\N	\N	50816	50816	50817
13539	15305	2	applied	\N	\N	\N	\N	50818	50818	50819
13541	15306	0	applied	\N	\N	\N	\N	50820	50820	50821
13541	15307	1	applied	\N	\N	\N	\N	50822	50822	50823
13541	15308	2	applied	\N	\N	\N	\N	50824	50824	50825
13546	15309	0	applied	\N	\N	\N	\N	50831	50831	50832
13550	15312	0	applied	\N	\N	\N	\N	50841	50841	50842
13550	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13550	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13550	15313	3	applied	\N	\N	\N	\N	50843	50843	50844
13550	15314	4	applied	\N	\N	\N	\N	50845	50845	50846
13560	15318	0	applied	\N	\N	\N	\N	50860	50860	50861
13560	15319	1	applied	\N	\N	\N	\N	50862	50862	50863
13560	15320	2	applied	\N	\N	\N	\N	50864	50864	50865
13565	15335	0	applied	\N	\N	\N	\N	50905	50905	50906
13565	15336	1	applied	\N	\N	\N	\N	50907	50907	50908
13565	15337	2	applied	\N	\N	\N	\N	50909	50909	50910
13453	15119	0	applied	\N	\N	\N	\N	50323	50323	50324
13453	15120	1	applied	\N	\N	\N	\N	50326	50326	50327
13453	15121	2	applied	\N	\N	\N	\N	50328	50328	50329
13453	15122	3	applied	\N	\N	\N	\N	50330	50330	50331
13453	15123	4	applied	\N	\N	\N	\N	50332	50332	50333
13458	15127	0	applied	\N	\N	\N	\N	50345	50345	50346
13458	15128	1	applied	\N	\N	\N	\N	50347	50347	50348
13458	15129	2	applied	\N	\N	\N	\N	50349	50349	50350
13466	14734	0	applied	\N	\N	1000000000	\N	49314	49314	49315
13466	14470	1	applied	\N	\N	\N	\N	48583	48583	48584
13466	14472	2	applied	\N	\N	\N	\N	48594	48594	48595
13466	14475	3	applied	\N	\N	\N	\N	48601	48601	48602
13466	14479	4	applied	\N	\N	\N	\N	48613	48613	48614
13466	14480	5	applied	\N	\N	\N	\N	48615	48615	48616
13466	14476	6	applied	\N	\N	\N	\N	48603	48603	48604
13466	14481	7	applied	\N	\N	\N	\N	48617	48617	48618
13466	14482	8	applied	\N	\N	\N	\N	48619	48619	48620
13466	14489	9	applied	\N	\N	\N	\N	48636	48636	48637
13466	14491	10	applied	\N	\N	\N	\N	48640	48640	48641
13466	14492	11	applied	\N	\N	\N	\N	48643	48643	48644
13466	14655	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13466	14660	13	applied	\N	\N	1000000000	\N	49113	49113	49114
13466	14731	14	applied	\N	\N	\N	\N	49306	49306	49307
13466	14483	15	applied	\N	\N	\N	\N	48621	48621	48622
13466	14490	16	applied	\N	\N	\N	\N	48638	48638	48639
13466	14493	17	applied	\N	\N	\N	\N	48645	48645	48646
13466	14494	18	applied	\N	\N	\N	\N	48647	48647	48648
13466	14501	19	applied	\N	\N	\N	\N	48669	48669	48670
13466	14502	20	applied	\N	\N	\N	\N	48671	48671	48672
13466	14503	21	applied	\N	\N	\N	\N	48673	48673	48674
13466	14510	22	applied	\N	\N	\N	\N	48689	48689	48690
13466	14511	23	applied	\N	\N	\N	\N	48693	48693	48694
13466	14515	24	applied	\N	\N	\N	\N	48706	48706	48707
13466	14516	25	applied	\N	\N	\N	\N	48708	48708	48709
13466	14521	26	applied	\N	\N	\N	\N	48721	48721	48722
13466	14522	27	applied	\N	\N	\N	\N	48723	48723	48724
13466	14523	28	applied	\N	\N	\N	\N	48725	48725	48726
13466	14530	29	applied	\N	\N	\N	\N	48741	48741	48742
13466	14531	30	applied	\N	\N	\N	\N	48743	48743	48744
13466	14536	31	applied	\N	\N	\N	\N	48755	48755	48756
13466	14537	32	applied	\N	\N	\N	\N	48757	48757	48758
13466	14538	33	applied	\N	\N	\N	\N	48759	48759	48760
13466	14545	34	applied	\N	\N	\N	\N	48775	48775	48776
13466	14548	35	applied	\N	\N	\N	\N	48788	48788	48789
13466	14551	36	applied	\N	\N	\N	\N	48799	48799	48800
13466	14554	38	applied	\N	\N	\N	\N	48806	48806	48807
13466	14555	39	applied	\N	\N	\N	\N	48808	48808	48809
13466	14559	40	applied	\N	\N	\N	\N	48817	48817	48818
13466	14560	41	applied	\N	\N	\N	\N	48819	48819	48820
13466	14565	42	applied	\N	\N	\N	\N	48833	48833	48834
13466	14568	43	applied	\N	\N	\N	\N	48841	48841	48842
13466	14571	44	applied	\N	\N	\N	\N	48851	48851	48852
13466	14574	45	applied	\N	\N	\N	\N	48857	48857	48858
13466	14577	46	applied	\N	\N	\N	\N	48865	48865	48866
13466	14580	47	applied	\N	\N	\N	\N	48872	48872	48873
13466	14581	48	applied	\N	\N	\N	\N	48875	48875	48876
13466	14586	49	applied	\N	\N	\N	\N	48891	48891	48892
13466	14589	50	applied	\N	\N	\N	\N	48898	48898	48899
13466	14590	51	applied	\N	\N	\N	\N	48900	48900	48901
13466	14594	52	applied	\N	\N	\N	\N	48910	48910	48911
13466	14597	53	applied	\N	\N	\N	\N	48917	48917	48918
13466	14600	54	applied	\N	\N	\N	\N	48928	48928	48929
13466	14601	55	applied	\N	\N	\N	\N	48930	48930	48931
13466	14606	56	applied	\N	\N	\N	\N	48943	48943	48944
13466	14609	57	applied	\N	\N	\N	\N	48953	48953	48954
13466	14612	58	applied	\N	\N	\N	\N	48967	48967	48968
13466	14613	59	applied	\N	\N	\N	\N	48969	48969	48970
13466	14620	60	applied	\N	\N	\N	\N	48997	48997	48998
13466	14623	61	applied	\N	\N	\N	\N	49010	49010	49011
13466	14625	62	applied	\N	\N	\N	\N	49017	49017	49018
13466	14629	63	applied	\N	\N	\N	\N	49028	49028	49029
13466	14631	64	applied	\N	\N	\N	\N	49035	49035	49036
13466	14634	65	applied	\N	\N	\N	\N	49046	49046	49047
13466	14636	66	applied	\N	\N	\N	\N	49052	49052	49053
13466	14639	67	applied	\N	\N	\N	\N	49060	49060	49061
13466	14642	68	applied	\N	\N	\N	\N	49069	49069	49070
13466	14643	69	applied	\N	\N	\N	\N	49071	49071	49072
13466	14648	70	applied	\N	\N	\N	\N	49083	49083	49084
13466	14649	71	applied	\N	\N	\N	\N	49085	49085	49086
13466	14654	72	applied	\N	\N	\N	\N	49097	49097	49098
13466	14658	73	applied	\N	\N	\N	\N	49107	49107	49108
13466	14659	74	applied	\N	\N	\N	\N	49111	49111	49112
13466	14664	75	applied	\N	\N	\N	\N	49124	49124	49125
13469	15147	0	applied	\N	\N	\N	\N	50405	50405	50406
13469	15148	1	applied	\N	\N	\N	\N	50407	50407	50408
13469	15149	2	applied	\N	\N	\N	\N	50409	50409	50410
13472	15157	0	applied	\N	\N	\N	\N	50431	50431	50432
13472	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13472	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13472	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13476	15161	0	applied	\N	\N	\N	\N	50444	50444	50445
13476	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13476	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13476	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13476	15162	4	applied	\N	\N	\N	\N	50446	50446	50447
13476	15163	5	applied	\N	\N	\N	\N	50448	50448	50449
13476	15164	6	applied	\N	\N	\N	\N	50450	50450	50451
13480	15161	0	applied	\N	\N	\N	\N	50444	50444	50445
13480	15158	1	applied	\N	\N	\N	\N	50433	50433	50434
13480	15159	2	applied	\N	\N	\N	\N	50435	50435	50436
13480	15160	3	applied	\N	\N	\N	\N	50437	50437	50438
13482	15180	0	applied	\N	\N	\N	\N	50490	50490	50491
13482	15181	1	applied	\N	\N	\N	\N	50492	50492	50493
13482	15182	2	applied	\N	\N	\N	\N	50494	50494	50495
13482	15183	3	applied	\N	\N	\N	\N	50496	50496	50497
13482	15184	4	applied	\N	\N	\N	\N	50498	50498	50499
13482	15185	5	applied	\N	\N	\N	\N	50500	50500	50501
13482	15186	6	applied	\N	\N	\N	\N	50502	50502	50503
13482	15187	7	applied	\N	\N	\N	\N	50504	50504	50505
13482	15188	8	applied	\N	\N	\N	\N	50506	50506	50507
13485	15189	0	applied	\N	\N	\N	\N	50512	50512	50513
13485	15190	1	applied	\N	\N	\N	\N	50514	50514	50515
13485	15191	2	applied	\N	\N	\N	\N	50516	50516	50517
13485	15192	3	applied	\N	\N	\N	\N	50518	50518	50519
13485	15193	4	applied	\N	\N	\N	\N	50520	50520	50521
13485	15194	5	applied	\N	\N	\N	\N	50522	50522	50523
13485	15195	6	applied	\N	\N	\N	\N	50524	50524	50525
13485	15196	7	applied	\N	\N	\N	\N	50526	50526	50527
13485	15197	8	applied	\N	\N	\N	\N	50528	50528	50529
13491	15219	0	applied	\N	\N	\N	\N	50585	50585	50586
13491	15220	1	applied	\N	\N	\N	\N	50587	50587	50588
13491	15221	2	applied	\N	\N	\N	\N	50589	50589	50590
13491	15222	3	applied	\N	\N	\N	\N	50591	50591	50592
13491	15223	4	applied	\N	\N	\N	\N	50593	50593	50594
13493	15219	0	applied	\N	\N	\N	\N	50585	50585	50586
13493	15220	1	applied	\N	\N	\N	\N	50587	50587	50588
13493	15221	2	applied	\N	\N	\N	\N	50589	50589	50590
13493	15222	3	applied	\N	\N	\N	\N	50591	50591	50592
13493	15223	4	applied	\N	\N	\N	\N	50593	50593	50594
13493	15224	5	applied	\N	\N	\N	\N	50597	50597	50598
13493	15225	6	applied	\N	\N	\N	\N	50599	50599	50600
13493	15226	7	applied	\N	\N	\N	\N	50601	50601	50602
13493	15227	8	applied	\N	\N	\N	\N	50603	50603	50604
13501	15235	0	applied	\N	\N	\N	\N	50627	50627	50628
13502	15238	0	applied	\N	\N	\N	\N	50637	50637	50638
13502	15239	1	applied	\N	\N	\N	\N	50639	50639	50640
13502	15240	2	applied	\N	\N	\N	\N	50641	50641	50642
13505	15241	0	applied	\N	\N	\N	\N	50643	50643	50644
13505	15242	1	applied	\N	\N	\N	\N	50645	50645	50646
13505	15243	2	applied	\N	\N	\N	\N	50647	50647	50648
13512	15260	0	applied	\N	\N	\N	\N	50694	50694	50695
13512	15261	1	applied	\N	\N	\N	\N	50696	50696	50697
13512	15262	2	applied	\N	\N	\N	\N	50698	50698	50699
13517	15269	0	applied	\N	\N	\N	\N	50718	50718	50719
13517	15270	1	applied	\N	\N	\N	\N	50721	50721	50722
13517	15271	2	applied	\N	\N	\N	\N	50723	50723	50724
13519	15276	0	applied	\N	\N	\N	\N	50734	50734	50735
13519	15277	1	applied	\N	\N	\N	\N	50736	50736	50737
13519	15278	2	applied	\N	\N	\N	\N	50738	50738	50739
13519	15279	3	applied	\N	\N	\N	\N	50740	50740	50468
13524	15283	0	applied	\N	\N	\N	\N	50754	50754	50755
13524	15284	1	applied	\N	\N	\N	\N	50756	50756	50757
13524	15285	2	applied	\N	\N	\N	\N	50758	50758	50759
13524	15286	3	applied	\N	\N	1000000000	\N	50760	50760	50761
13528	15287	0	applied	\N	\N	\N	\N	50766	50766	50767
13528	15288	1	applied	\N	\N	\N	\N	50768	50768	50769
13528	15289	2	applied	\N	\N	\N	\N	50770	50770	50771
13528	15290	3	applied	\N	\N	\N	\N	50772	50772	50773
13528	15291	4	applied	\N	\N	\N	\N	50774	50774	50775
13528	15292	6	applied	\N	\N	\N	\N	50777	50777	50778
13529	15287	0	applied	\N	\N	\N	\N	50766	50766	50767
13529	15288	1	applied	\N	\N	\N	\N	50768	50768	50769
13529	15289	2	applied	\N	\N	\N	\N	50770	50770	50771
13529	15290	3	applied	\N	\N	\N	\N	50772	50772	50773
13529	15291	4	applied	\N	\N	\N	\N	50774	50774	50775
13529	15292	6	applied	\N	\N	\N	\N	50777	50777	50778
13535	15300	0	applied	\N	\N	\N	\N	50803	50803	50804
13535	15298	1	applied	\N	\N	\N	\N	50797	50797	50798
13535	15299	2	applied	\N	\N	\N	\N	50799	50799	50800
13535	15301	3	applied	\N	\N	\N	\N	50805	50805	50806
13535	15302	4	applied	\N	\N	\N	\N	50807	50807	50808
13538	15300	0	applied	\N	\N	\N	\N	50803	50803	50804
13538	15301	1	applied	\N	\N	\N	\N	50805	50805	50806
13538	15302	2	applied	\N	\N	\N	\N	50807	50807	50808
13540	15303	0	applied	\N	\N	\N	\N	50814	50814	50815
13540	15304	1	applied	\N	\N	\N	\N	50816	50816	50817
13540	15305	2	applied	\N	\N	\N	\N	50818	50818	50819
13542	15306	0	applied	\N	\N	\N	\N	50820	50820	50821
13542	15307	1	applied	\N	\N	\N	\N	50822	50822	50823
13542	15308	2	applied	\N	\N	\N	\N	50824	50824	50825
13544	15306	0	applied	\N	\N	\N	\N	50820	50820	50821
13544	15307	1	applied	\N	\N	\N	\N	50822	50822	50823
13544	15308	2	applied	\N	\N	\N	\N	50824	50824	50825
13547	15309	0	applied	\N	\N	\N	\N	50831	50831	50832
13551	15312	0	applied	\N	\N	\N	\N	50841	50841	50842
13558	15315	0	applied	\N	\N	\N	\N	50852	50852	50853
13558	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13558	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13558	15313	3	applied	\N	\N	\N	\N	50843	50843	50844
13558	15314	4	applied	\N	\N	\N	\N	50845	50845	50846
13558	15316	5	applied	\N	\N	\N	\N	50854	50854	50855
13558	15317	6	applied	\N	\N	\N	\N	50856	50856	50857
13561	15318	0	applied	\N	\N	\N	\N	50860	50860	50861
13561	15319	1	applied	\N	\N	\N	\N	50862	50862	50863
13563	15322	0	applied	\N	\N	\N	\N	50875	50875	50876
13563	15323	1	applied	\N	\N	\N	\N	50877	50877	50878
13563	15324	2	applied	\N	\N	\N	\N	50879	50879	50880
13563	15325	3	applied	\N	\N	\N	\N	50881	50881	50882
13563	15326	4	applied	\N	\N	\N	\N	50883	50883	50884
13563	15327	5	applied	\N	\N	\N	\N	50885	50885	50886
13563	15328	6	applied	\N	\N	\N	\N	50887	50887	50888
13563	15329	7	applied	\N	\N	\N	\N	50889	50889	50890
13563	15330	8	applied	\N	\N	\N	\N	50891	50891	50892
13563	15331	9	applied	\N	\N	\N	\N	50893	50893	50894
13566	15335	0	applied	\N	\N	\N	\N	50905	50905	50906
13566	15336	1	applied	\N	\N	\N	\N	50907	50907	50908
13566	15337	2	applied	\N	\N	\N	\N	50909	50909	50910
13566	15338	3	applied	\N	\N	\N	\N	50911	50911	50912
13566	15339	4	applied	\N	\N	\N	\N	50913	50913	50914
13566	15340	5	applied	\N	\N	\N	\N	50915	50915	50916
13566	15341	6	applied	\N	\N	\N	\N	50917	50917	50918
13566	15342	7	applied	\N	\N	\N	\N	50919	50919	50920
13571	15260	0	applied	\N	\N	\N	\N	50694	50694	50695
13571	15263	1	applied	\N	\N	\N	\N	50702	50702	50703
13571	15264	2	applied	\N	\N	\N	\N	50704	50704	50705
13571	15269	3	applied	\N	\N	\N	\N	50718	50718	50719
13571	15272	4	applied	\N	\N	\N	\N	50726	50726	50727
13571	15276	5	applied	\N	\N	\N	\N	50734	50734	50735
13571	15280	6	applied	\N	\N	\N	\N	50746	50746	50747
13571	15283	7	applied	\N	\N	\N	\N	50754	50754	50755
13571	15287	8	applied	\N	\N	\N	\N	50766	50766	50767
13571	15288	9	applied	\N	\N	\N	\N	50768	50768	50769
13571	15294	10	applied	\N	\N	\N	\N	50787	50787	50788
13571	15297	11	applied	\N	\N	\N	\N	50795	50795	50796
13571	15300	12	applied	\N	\N	\N	\N	50803	50803	50804
13571	15303	13	applied	\N	\N	\N	\N	50814	50814	50815
13571	15306	14	applied	\N	\N	\N	\N	50820	50820	50821
13571	15309	15	applied	\N	\N	\N	\N	50831	50831	50832
13571	15312	16	applied	\N	\N	\N	\N	50841	50841	50842
13571	15315	17	applied	\N	\N	\N	\N	50852	50852	50853
13571	15318	18	applied	\N	\N	\N	\N	50860	50860	50861
13571	15336	19	applied	\N	\N	\N	\N	50942	50942	50908
13571	15337	20	applied	\N	\N	\N	\N	50943	50943	50910
13571	15338	21	applied	\N	\N	\N	\N	50944	50944	50912
13571	15339	22	applied	\N	\N	\N	\N	50945	50945	50914
13571	15340	23	applied	\N	\N	\N	\N	50946	50946	50916
13571	15321	24	applied	\N	\N	\N	\N	50871	50871	50872
13571	15322	25	applied	\N	\N	\N	\N	50875	50875	50876
13571	15323	26	applied	\N	\N	\N	\N	50877	50877	50878
13513	15265	2	applied	\N	\N	\N	\N	50706	50706	50707
13513	15266	3	applied	\N	\N	\N	\N	50708	50708	50709
13513	15267	4	applied	\N	\N	\N	\N	50710	50710	50711
13513	15268	5	applied	\N	\N	\N	\N	50712	50712	50713
13515	15038	0	applied	\N	\N	\N	\N	50111	50111	25661
13515	15170	1	applied	\N	\N	\N	\N	50468	50468	50469
13515	15044	2	applied	\N	\N	\N	\N	50124	50124	25661
13520	15276	0	applied	\N	\N	\N	\N	50734	50734	50735
13520	15277	1	applied	\N	\N	\N	\N	50736	50736	50737
13520	15278	2	applied	\N	\N	\N	\N	50738	50738	50739
13520	15279	3	applied	\N	\N	\N	\N	50740	50740	50468
13522	15280	0	applied	\N	\N	\N	\N	50746	50746	50747
13522	15281	1	applied	\N	\N	\N	\N	50748	50748	50749
13522	15282	2	applied	\N	\N	\N	\N	50750	50750	50751
13531	15294	0	applied	\N	\N	\N	\N	50787	50787	50788
13531	15295	1	applied	\N	\N	\N	\N	50789	50789	50790
13531	15296	2	applied	\N	\N	\N	\N	50791	50791	50792
13534	15297	0	applied	\N	\N	\N	\N	50795	50795	50796
13536	15300	0	applied	\N	\N	\N	\N	50803	50803	50804
13536	15301	1	applied	\N	\N	\N	\N	50805	50805	50806
13536	15302	2	applied	\N	\N	\N	\N	50807	50807	50808
13548	15309	0	applied	\N	\N	\N	\N	50831	50831	50832
13548	15310	1	applied	\N	\N	\N	\N	50833	50833	50834
13548	15311	2	applied	\N	\N	\N	\N	50835	50835	50836
13552	15309	0	applied	\N	\N	\N	\N	50831	50831	50832
13557	15315	0	applied	\N	\N	\N	\N	50852	50852	50853
13564	15332	0	applied	\N	\N	\N	\N	50897	50897	50898
13564	15333	1	applied	\N	\N	\N	\N	50899	50899	50900
13564	15334	2	applied	\N	\N	\N	\N	50901	50901	50902
13567	15335	0	applied	\N	\N	\N	\N	50905	50905	50906
13567	15336	1	applied	\N	\N	\N	\N	50907	50907	50908
13567	15337	2	applied	\N	\N	\N	\N	50909	50909	50910
13567	15338	3	applied	\N	\N	\N	\N	50911	50911	50912
13567	15339	4	applied	\N	\N	\N	\N	50913	50913	50914
13567	15340	5	applied	\N	\N	\N	\N	50915	50915	50916
13567	15341	6	applied	\N	\N	\N	\N	50917	50917	50918
13567	15342	7	applied	\N	\N	\N	\N	50919	50919	50920
13572	15343	0	applied	\N	\N	\N	\N	50933	50933	50934
13572	15344	1	applied	\N	\N	\N	\N	50935	50935	50936
13572	15345	2	applied	\N	\N	\N	\N	50937	50937	50938
13575	15349	0	applied	\N	\N	\N	\N	50959	50959	50960
13575	15350	1	applied	\N	\N	\N	\N	50961	50961	50962
13575	15351	2	applied	\N	\N	\N	\N	50963	50963	50964
13578	15361	0	applied	\N	\N	\N	\N	50989	50989	50990
13578	15362	1	applied	\N	\N	\N	\N	50991	50991	50992
13578	15363	2	applied	\N	\N	\N	\N	50993	50993	50994
13578	15364	3	applied	\N	\N	\N	\N	50995	50995	50996
13586	15393	0	applied	\N	\N	\N	\N	51063	51063	51064
13586	15394	1	applied	\N	\N	\N	\N	51065	51065	51066
13586	15395	2	applied	\N	\N	\N	\N	51067	51067	51068
13586	15396	3	applied	\N	\N	\N	\N	51069	51069	51070
13588	15397	0	applied	\N	\N	1000000000	\N	51074	51074	51075
13588	15398	1	applied	\N	\N	\N	\N	51076	51076	51077
13588	15399	2	applied	\N	\N	\N	\N	51078	51078	51079
13588	15400	3	applied	\N	\N	\N	\N	51080	51080	51081
13588	15401	4	applied	\N	\N	\N	\N	51082	51082	51083
13598	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13598	15410	1	applied	\N	\N	\N	\N	51109	51109	51110
13598	15411	2	applied	\N	\N	\N	\N	51111	51111	51112
13600	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13600	15410	1	applied	\N	\N	\N	\N	51109	51109	51110
13600	15411	2	applied	\N	\N	\N	\N	51111	51111	51112
13604	15416	0	applied	\N	\N	\N	\N	51123	51123	51124
13604	15417	1	applied	\N	\N	\N	\N	51125	51125	51126
13604	15418	2	applied	\N	\N	\N	\N	51127	51127	51128
13604	15419	3	applied	\N	\N	\N	\N	51129	51129	51130
13604	15420	4	applied	\N	\N	\N	\N	51131	51131	51132
13604	15421	5	applied	\N	\N	\N	\N	51133	51133	51134
13604	15422	6	applied	\N	\N	\N	\N	51135	51135	51136
13604	15423	7	applied	\N	\N	\N	\N	51137	51137	51138
13604	15424	8	applied	\N	\N	\N	\N	51139	51139	51140
13604	15425	9	applied	\N	\N	\N	\N	51141	51141	51142
13604	15426	10	applied	\N	\N	\N	\N	51143	51143	51144
13604	15427	11	applied	\N	\N	\N	\N	51145	51145	51146
13604	15428	12	applied	\N	\N	\N	\N	51147	51147	51148
13604	15429	13	applied	\N	\N	\N	\N	51149	51149	51150
13604	15430	14	applied	\N	\N	\N	\N	51151	51151	51152
13604	15431	15	applied	\N	\N	\N	\N	51153	51153	51154
13604	15432	16	applied	\N	\N	\N	\N	51155	51155	51156
13604	15433	17	applied	\N	\N	\N	\N	51157	51157	51158
13604	15434	18	applied	\N	\N	\N	\N	51159	51159	51160
13604	15435	19	applied	\N	\N	\N	\N	51161	51161	51162
13604	15436	20	applied	\N	\N	\N	\N	51163	51163	51164
13604	15437	21	applied	\N	\N	\N	\N	51165	51165	51166
13604	15438	22	applied	\N	\N	\N	\N	51167	51167	51168
13604	15439	23	applied	\N	\N	\N	\N	51169	51169	51170
13604	15440	24	applied	\N	\N	\N	\N	51171	51171	51172
13604	15441	25	applied	\N	\N	\N	\N	51173	51173	51174
13604	15442	26	applied	\N	\N	\N	\N	51175	51175	51176
13606	15443	0	applied	\N	\N	\N	\N	51182	51182	51183
13606	15444	1	applied	\N	\N	\N	\N	51184	51184	51185
13606	15445	2	applied	\N	\N	\N	\N	51186	51186	51187
13606	15446	3	applied	\N	\N	\N	\N	51188	51188	51189
13613	15463	0	applied	\N	\N	\N	\N	51229	51229	51230
13613	15464	1	applied	\N	\N	\N	\N	51231	51231	51232
13613	15465	2	applied	\N	\N	\N	\N	51233	51233	51234
13613	15466	3	applied	\N	\N	\N	\N	51235	51235	51236
13615	15467	0	applied	\N	\N	\N	\N	51240	51240	51241
13615	15468	1	applied	\N	\N	\N	\N	51242	51242	51243
13615	15469	2	applied	\N	\N	\N	\N	51244	51244	51245
13615	15470	3	applied	\N	\N	\N	\N	51246	51246	51247
13620	15479	0	applied	\N	\N	\N	\N	51274	51274	51275
13620	15480	1	applied	\N	\N	\N	\N	51276	51276	51277
13620	15481	2	applied	\N	\N	\N	\N	51278	51278	51279
13620	15482	3	applied	\N	\N	\N	\N	51280	51280	51281
13623	15479	0	applied	\N	\N	\N	\N	51274	51274	51275
13623	15480	1	applied	\N	\N	\N	\N	51276	51276	51277
13623	15481	2	applied	\N	\N	\N	\N	51278	51278	51279
13623	15482	3	applied	\N	\N	\N	\N	51280	51280	51281
13624	15483	0	applied	\N	\N	\N	\N	51288	51288	51289
13624	15484	1	applied	\N	\N	\N	\N	51290	51290	51291
13624	15485	2	applied	\N	\N	\N	\N	51292	51292	51293
13624	15486	3	applied	\N	\N	\N	\N	51294	51294	51295
13632	15507	0	applied	\N	\N	\N	\N	51348	51348	51349
13632	15508	1	applied	\N	\N	\N	\N	51350	51350	51351
13632	15509	2	applied	\N	\N	\N	\N	51352	51352	51353
13633	15510	0	applied	\N	\N	\N	\N	51356	51356	51357
13633	15511	1	applied	\N	\N	\N	\N	51358	51358	51359
13636	15512	0	applied	\N	\N	\N	\N	51362	51362	51363
13636	15513	1	applied	\N	\N	\N	\N	51364	51364	51365
13565	15338	3	applied	\N	\N	\N	\N	50911	50911	50912
13565	15339	4	applied	\N	\N	\N	\N	50913	50913	50914
13565	15340	5	applied	\N	\N	\N	\N	50915	50915	50916
13565	15341	6	applied	\N	\N	\N	\N	50917	50917	50918
13565	15342	7	applied	\N	\N	\N	\N	50919	50919	50920
13570	15343	0	applied	\N	\N	\N	\N	50933	50933	50934
13570	15344	1	applied	\N	\N	\N	\N	50935	50935	50936
13570	15345	2	applied	\N	\N	\N	\N	50937	50937	50938
13574	15346	0	applied	\N	\N	\N	\N	50951	50951	50952
13574	15347	1	applied	\N	\N	\N	\N	50953	50953	50954
13574	15348	2	applied	\N	\N	\N	\N	50955	50955	50956
13580	15372	0	applied	\N	\N	\N	\N	51014	51014	51015
13580	15373	1	applied	\N	\N	\N	\N	51016	51016	51017
13580	15374	2	applied	\N	\N	\N	\N	51018	51018	51019
13580	15375	3	applied	\N	\N	\N	\N	51020	51020	51021
13580	15376	4	applied	\N	\N	\N	\N	51022	51022	51023
13580	15377	6	applied	\N	\N	\N	\N	51025	51025	51026
13580	15378	7	applied	\N	\N	\N	\N	51027	51027	51028
13580	15379	8	applied	\N	\N	\N	\N	51029	51029	51030
13580	15380	9	applied	\N	\N	\N	\N	51031	51031	51032
13580	15381	10	applied	\N	\N	\N	\N	51033	51033	51034
13580	15382	11	applied	\N	\N	\N	\N	51035	51035	51036
13580	15383	12	applied	\N	\N	\N	\N	51037	51037	51038
13583	15384	0	applied	\N	\N	\N	\N	51041	51041	51042
13583	15385	1	applied	\N	\N	\N	\N	51043	51043	51044
13583	15386	2	applied	\N	\N	\N	\N	51045	51045	51046
13583	15387	3	applied	\N	\N	\N	\N	51047	51047	51048
13585	15388	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	51051	51051	\N
13585	15389	1	applied	\N	\N	\N	\N	51052	51052	51053
13585	15390	2	applied	\N	\N	\N	\N	51054	51054	51055
13585	15391	3	applied	\N	\N	\N	\N	51056	51056	51057
13585	15392	4	applied	\N	\N	\N	\N	51058	51058	51059
13587	15393	0	applied	\N	\N	\N	\N	51063	51063	51064
13587	15394	1	applied	\N	\N	\N	\N	51065	51065	51066
13587	15395	2	applied	\N	\N	\N	\N	51067	51067	51068
13587	15396	3	applied	\N	\N	\N	\N	51069	51069	51070
13590	15397	0	applied	\N	\N	1000000000	\N	51074	51074	51075
13590	15398	1	applied	\N	\N	\N	\N	51076	51076	51077
13590	15399	2	applied	\N	\N	\N	\N	51078	51078	51079
13590	15400	3	applied	\N	\N	\N	\N	51080	51080	51081
13590	15401	4	applied	\N	\N	\N	\N	51082	51082	51083
13592	15402	0	applied	\N	\N	\N	\N	51086	51086	51087
13592	15403	1	applied	\N	\N	\N	\N	51088	51088	51089
13592	15404	2	applied	\N	\N	\N	\N	51090	51090	51091
13594	15405	0	applied	\N	\N	\N	\N	51095	51095	51096
13594	15406	1	applied	\N	\N	\N	\N	51097	51097	51098
13594	15407	2	applied	\N	\N	\N	\N	51099	51099	51100
13594	15408	3	applied	\N	\N	\N	\N	51101	51101	51102
13596	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13596	15410	1	applied	\N	\N	\N	\N	51109	51109	51110
13596	15411	2	applied	\N	\N	\N	\N	51111	51111	51112
13599	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13599	15410	1	applied	\N	\N	\N	\N	51109	51109	51110
13599	15411	2	applied	\N	\N	\N	\N	51111	51111	51112
13611	15460	0	applied	\N	\N	\N	\N	51221	51221	51222
13611	15461	1	applied	\N	\N	\N	\N	51223	51223	51224
13611	15462	2	applied	\N	\N	\N	\N	51225	51225	51226
13614	15463	0	applied	\N	\N	\N	\N	51229	51229	51230
13614	15464	1	applied	\N	\N	\N	\N	51231	51231	51232
13614	15465	2	applied	\N	\N	\N	\N	51233	51233	51234
13614	15466	3	applied	\N	\N	\N	\N	51235	51235	51236
13616	15471	0	applied	\N	\N	\N	\N	51250	51250	51251
13616	15472	1	applied	\N	\N	\N	\N	51252	51252	51253
13616	15473	3	applied	\N	\N	\N	\N	51255	51255	51256
13616	15474	4	applied	\N	\N	\N	\N	51257	51257	51258
13618	15471	0	applied	\N	\N	\N	\N	51250	51250	51251
13618	15472	1	applied	\N	\N	\N	\N	51252	51252	51253
13618	15473	3	applied	\N	\N	\N	\N	51255	51255	51256
13618	15474	4	applied	\N	\N	\N	\N	51257	51257	51258
13621	15479	0	applied	\N	\N	\N	\N	51274	51274	51275
13621	15480	1	applied	\N	\N	\N	\N	51276	51276	51277
13621	15481	2	applied	\N	\N	\N	\N	51278	51278	51279
13621	15482	3	applied	\N	\N	\N	\N	51280	51280	51281
13625	15483	0	applied	\N	\N	\N	\N	51288	51288	51289
13626	15487	0	applied	\N	\N	\N	\N	51299	51299	51300
13626	15488	1	applied	\N	\N	\N	\N	51301	51301	51302
13626	15489	2	applied	\N	\N	\N	\N	51303	51303	51304
13626	15490	3	applied	\N	\N	\N	\N	51305	51305	51306
13626	15491	4	applied	\N	\N	\N	\N	51307	51307	51308
13626	15492	5	applied	\N	\N	\N	\N	51309	51309	51310
13626	15493	6	applied	\N	\N	\N	\N	51311	51311	51312
13626	15494	7	applied	\N	\N	\N	\N	51313	51313	51314
13626	15495	8	applied	\N	\N	\N	\N	51315	51315	51316
13626	15496	9	applied	\N	\N	\N	\N	51317	51317	51318
13626	15497	10	applied	\N	\N	\N	\N	51319	51319	51320
13626	15498	11	applied	\N	\N	\N	\N	51321	51321	51322
13630	15487	0	applied	\N	\N	\N	\N	51299	51299	51300
13630	15488	1	applied	\N	\N	\N	\N	51301	51301	51302
13630	15489	2	applied	\N	\N	\N	\N	51303	51303	51304
13630	15499	3	applied	\N	\N	\N	\N	51328	51328	51329
13630	15490	4	applied	\N	\N	\N	\N	51305	51305	51306
13630	15491	5	applied	\N	\N	\N	\N	51307	51307	51308
13630	15492	6	applied	\N	\N	\N	\N	51309	51309	51310
13630	15493	7	applied	\N	\N	\N	\N	51311	51311	51312
13630	15494	8	applied	\N	\N	\N	\N	51313	51313	51314
13630	15495	9	applied	\N	\N	\N	\N	51315	51315	51316
13630	15496	10	applied	\N	\N	\N	\N	51317	51317	51318
13630	15497	11	applied	\N	\N	\N	\N	51319	51319	51320
13630	15498	12	applied	\N	\N	\N	\N	51321	51321	51322
13630	15500	13	applied	\N	\N	\N	\N	51330	51330	51331
13630	15501	14	applied	\N	\N	\N	\N	51332	51332	51333
13630	15502	15	applied	\N	\N	\N	\N	51334	51334	51335
13637	15512	0	applied	\N	\N	\N	\N	51362	51362	51363
13637	15513	1	applied	\N	\N	\N	\N	51364	51364	51365
13637	15514	2	applied	\N	\N	\N	\N	51366	51366	51367
13637	15515	3	applied	\N	\N	\N	\N	51368	51368	51369
13637	15516	4	applied	\N	\N	\N	\N	51370	51370	51371
13637	15517	5	applied	\N	\N	\N	\N	51372	51372	51373
13637	15518	6	applied	\N	\N	\N	\N	51374	51374	51375
13637	15519	7	applied	\N	\N	\N	\N	51376	51376	51377
13637	15520	8	applied	\N	\N	\N	\N	51378	51378	51379
13637	15521	9	applied	\N	\N	\N	\N	51380	51380	51381
13637	15522	10	applied	\N	\N	\N	\N	51382	51382	51383
13637	15523	11	applied	\N	\N	\N	\N	51384	51384	51385
13637	15524	12	applied	\N	\N	\N	\N	51386	51386	51387
13637	15525	13	applied	\N	\N	\N	\N	51388	51388	51389
13641	15542	0	applied	\N	\N	\N	\N	51432	51432	51433
13641	15543	1	applied	\N	\N	\N	\N	51434	51434	51435
13641	15544	2	applied	\N	\N	\N	\N	51436	51436	51437
13568	15315	25	applied	\N	\N	\N	\N	50852	50852	50853
13568	15318	26	applied	\N	\N	\N	\N	50860	50860	50861
13568	15336	27	applied	\N	\N	\N	\N	50926	50926	50908
13568	15337	28	applied	\N	\N	\N	\N	50927	50927	50910
13568	15338	29	applied	\N	\N	\N	\N	50928	50928	50912
13568	15339	30	applied	\N	\N	\N	\N	50929	50929	50914
13568	15340	31	applied	\N	\N	\N	\N	50930	50930	50916
13568	15321	32	applied	\N	\N	\N	\N	50871	50871	50872
13568	15322	33	applied	\N	\N	\N	\N	50875	50875	50876
13568	15323	34	applied	\N	\N	\N	\N	50877	50877	50878
13568	15324	35	applied	\N	\N	\N	\N	50879	50879	50880
13568	15332	36	applied	\N	\N	\N	\N	50897	50897	50898
13568	15335	37	applied	\N	\N	\N	\N	50905	50905	50906
13568	15275	38	applied	\N	\N	\N	\N	50732	50732	50468
13568	15279	39	applied	\N	\N	\N	\N	50740	50740	50468
13569	15343	0	applied	\N	\N	\N	\N	50933	50933	50934
13569	15344	1	applied	\N	\N	\N	\N	50935	50935	50936
13569	15345	2	applied	\N	\N	\N	\N	50937	50937	50938
13573	15346	0	applied	\N	\N	\N	\N	50951	50951	50952
13573	15347	1	applied	\N	\N	\N	\N	50953	50953	50954
13573	15348	2	applied	\N	\N	\N	\N	50955	50955	50956
13576	15349	0	applied	\N	\N	\N	\N	50959	50959	50960
13576	15350	1	applied	\N	\N	\N	\N	50961	50961	50962
13576	15351	2	applied	\N	\N	\N	\N	50963	50963	50964
13579	15365	0	applied	\N	\N	\N	\N	50998	50998	50999
13579	15366	1	applied	\N	\N	\N	\N	51000	51000	51001
13579	15367	2	applied	\N	\N	\N	\N	51002	51002	51003
13579	15368	3	applied	\N	\N	\N	\N	51004	51004	51005
13579	15369	4	applied	\N	\N	\N	\N	51006	51006	51007
13579	15370	5	applied	\N	\N	\N	\N	51008	51008	51009
13579	15371	6	applied	\N	\N	\N	\N	51010	51010	51011
13582	15384	0	applied	\N	\N	\N	\N	51041	51041	51042
13582	15385	1	applied	\N	\N	\N	\N	51043	51043	51044
13582	15386	2	applied	\N	\N	\N	\N	51045	51045	51046
13582	15387	3	applied	\N	\N	\N	\N	51047	51047	51048
13584	15388	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	51051	51051	\N
13584	15389	1	applied	\N	\N	\N	\N	51052	51052	51053
13584	15390	2	applied	\N	\N	\N	\N	51054	51054	51055
13584	15391	3	applied	\N	\N	\N	\N	51056	51056	51057
13584	15392	4	applied	\N	\N	\N	\N	51058	51058	51059
13589	15397	0	applied	\N	\N	1000000000	\N	51074	51074	51075
13589	15398	1	applied	\N	\N	\N	\N	51076	51076	51077
13589	15399	2	applied	\N	\N	\N	\N	51078	51078	51079
13589	15400	3	applied	\N	\N	\N	\N	51080	51080	51081
13589	15401	4	applied	\N	\N	\N	\N	51082	51082	51083
13591	15402	0	applied	\N	\N	\N	\N	51086	51086	51087
13591	15403	1	applied	\N	\N	\N	\N	51088	51088	51089
13591	15404	2	applied	\N	\N	\N	\N	51090	51090	51091
13593	15405	0	applied	\N	\N	\N	\N	51095	51095	51096
13593	15406	1	applied	\N	\N	\N	\N	51097	51097	51098
13593	15407	2	applied	\N	\N	\N	\N	51099	51099	51100
13593	15408	3	applied	\N	\N	\N	\N	51101	51101	51102
13601	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13602	15412	0	applied	\N	\N	\N	\N	51115	51115	51116
13602	15413	1	applied	\N	\N	\N	\N	51117	51117	51118
13602	15414	2	applied	\N	\N	\N	\N	51119	51119	51120
13602	15415	3	applied	\N	\N	\N	\N	51121	51121	51122
13603	15416	0	applied	\N	\N	\N	\N	51123	51123	51124
13603	15417	1	applied	\N	\N	\N	\N	51125	51125	51126
13603	15418	2	applied	\N	\N	\N	\N	51127	51127	51128
13603	15419	3	applied	\N	\N	\N	\N	51129	51129	51130
13603	15420	4	applied	\N	\N	\N	\N	51131	51131	51132
13603	15421	5	applied	\N	\N	\N	\N	51133	51133	51134
13603	15422	6	applied	\N	\N	\N	\N	51135	51135	51136
13603	15423	7	applied	\N	\N	\N	\N	51137	51137	51138
13603	15424	8	applied	\N	\N	\N	\N	51139	51139	51140
13603	15425	9	applied	\N	\N	\N	\N	51141	51141	51142
13603	15426	10	applied	\N	\N	\N	\N	51143	51143	51144
13603	15427	11	applied	\N	\N	\N	\N	51145	51145	51146
13603	15428	12	applied	\N	\N	\N	\N	51147	51147	51148
13603	15429	13	applied	\N	\N	\N	\N	51149	51149	51150
13603	15430	14	applied	\N	\N	\N	\N	51151	51151	51152
13603	15431	15	applied	\N	\N	\N	\N	51153	51153	51154
13603	15432	16	applied	\N	\N	\N	\N	51155	51155	51156
13603	15433	17	applied	\N	\N	\N	\N	51157	51157	51158
13603	15434	18	applied	\N	\N	\N	\N	51159	51159	51160
13603	15435	19	applied	\N	\N	\N	\N	51161	51161	51162
13603	15436	20	applied	\N	\N	\N	\N	51163	51163	51164
13603	15437	21	applied	\N	\N	\N	\N	51165	51165	51166
13603	15438	22	applied	\N	\N	\N	\N	51167	51167	51168
13603	15439	23	applied	\N	\N	\N	\N	51169	51169	51170
13603	15440	24	applied	\N	\N	\N	\N	51171	51171	51172
13603	15441	25	applied	\N	\N	\N	\N	51173	51173	51174
13603	15442	26	applied	\N	\N	\N	\N	51175	51175	51176
13608	15443	0	applied	\N	\N	\N	\N	51182	51182	51183
13608	15447	1	applied	\N	\N	\N	\N	51191	51191	51192
13608	15444	2	applied	\N	\N	\N	\N	51184	51184	51185
13608	15445	3	applied	\N	\N	\N	\N	51186	51186	51187
13608	15446	4	applied	\N	\N	\N	\N	51188	51188	51189
13608	15448	5	applied	\N	\N	\N	\N	51193	51193	51194
13608	15449	6	applied	\N	\N	\N	\N	51195	51195	51196
13608	15450	7	applied	\N	\N	\N	\N	51197	51197	51198
13610	15451	0	applied	\N	\N	\N	\N	51202	51202	51202
13610	15452	1	applied	\N	\N	\N	\N	51203	51203	51204
13610	15453	2	applied	\N	\N	\N	\N	51205	51205	51206
13610	15454	3	applied	\N	\N	\N	\N	51207	51207	51208
13610	15455	4	applied	\N	\N	\N	\N	51209	51209	51210
13610	15456	5	applied	\N	\N	\N	\N	51211	51211	51212
13610	15457	6	applied	\N	\N	\N	\N	51213	51213	51214
13610	15458	7	applied	\N	\N	\N	\N	51215	51215	51216
13610	15459	8	applied	\N	\N	\N	\N	51217	51217	51218
13619	15475	0	applied	\N	\N	\N	\N	51263	51263	51264
13619	15476	1	applied	\N	\N	\N	\N	51265	51265	51266
13619	15477	2	applied	\N	\N	\N	\N	51267	51267	51268
13619	15478	3	applied	\N	\N	\N	\N	51269	51269	51270
13622	15479	0	applied	\N	\N	\N	\N	51274	51274	51275
13628	15487	0	applied	\N	\N	\N	\N	51299	51299	51300
13628	15488	1	applied	\N	\N	\N	\N	51301	51301	51302
13628	15489	2	applied	\N	\N	\N	\N	51303	51303	51304
13628	15490	3	applied	\N	\N	\N	\N	51305	51305	51306
13628	15491	4	applied	\N	\N	\N	\N	51307	51307	51308
13628	15492	5	applied	\N	\N	\N	\N	51309	51309	51310
13628	15493	6	applied	\N	\N	\N	\N	51311	51311	51312
13628	15494	7	applied	\N	\N	\N	\N	51313	51313	51314
13628	15495	8	applied	\N	\N	\N	\N	51315	51315	51316
13628	15496	9	applied	\N	\N	\N	\N	51317	51317	51318
13628	15497	10	applied	\N	\N	\N	\N	51319	51319	51320
13628	15498	11	applied	\N	\N	\N	\N	51321	51321	51322
13635	15512	0	applied	\N	\N	\N	\N	51362	51362	51363
13571	15324	27	applied	\N	\N	\N	\N	50879	50879	50880
13571	15332	28	applied	\N	\N	\N	\N	50897	50897	50898
13571	15335	29	applied	\N	\N	\N	\N	50905	50905	50906
13571	15343	30	applied	\N	\N	\N	\N	50933	50933	50934
13571	15275	31	applied	\N	\N	\N	\N	50732	50732	50468
13571	15279	32	applied	\N	\N	\N	\N	50740	50740	50468
13577	15352	0	applied	\N	\N	\N	\N	50969	50969	50970
13577	15353	1	applied	\N	\N	\N	\N	50971	50971	50972
13577	15354	2	applied	\N	\N	\N	\N	50973	50973	50974
13577	15355	3	applied	\N	\N	\N	\N	50975	50975	50976
13577	15356	4	applied	\N	\N	\N	\N	50977	50977	50978
13577	15357	5	applied	\N	\N	\N	\N	50979	50979	50980
13577	15358	6	applied	\N	\N	\N	\N	50981	50981	50982
13577	15359	7	applied	\N	\N	\N	\N	50983	50983	50984
13577	15360	8	applied	\N	\N	\N	\N	50985	50985	50986
13581	15384	0	applied	\N	\N	\N	\N	51041	51041	51042
13581	15385	1	applied	\N	\N	\N	\N	51043	51043	51044
13581	15386	2	applied	\N	\N	\N	\N	51045	51045	51046
13581	15387	3	applied	\N	\N	\N	\N	51047	51047	51048
13595	15405	0	applied	\N	\N	\N	\N	51095	51095	51096
13595	15406	1	applied	\N	\N	\N	\N	51097	51097	51098
13595	15407	2	applied	\N	\N	\N	\N	51099	51099	51100
13595	15408	3	applied	\N	\N	\N	\N	51101	51101	51102
13597	15409	0	applied	\N	\N	\N	\N	51107	51107	51108
13597	15410	1	applied	\N	\N	\N	\N	51109	51109	51110
13597	15411	2	applied	\N	\N	\N	\N	51111	51111	51112
13607	15443	0	applied	\N	\N	\N	\N	51182	51182	51183
13607	15447	1	applied	\N	\N	\N	\N	51191	51191	51192
13607	15444	2	applied	\N	\N	\N	\N	51184	51184	51185
13607	15445	3	applied	\N	\N	\N	\N	51186	51186	51187
13607	15446	4	applied	\N	\N	\N	\N	51188	51188	51189
13607	15448	5	applied	\N	\N	\N	\N	51193	51193	51194
13607	15449	6	applied	\N	\N	\N	\N	51195	51195	51196
13607	15450	7	applied	\N	\N	\N	\N	51197	51197	51198
13612	15460	0	applied	\N	\N	\N	\N	51221	51221	51222
13612	15461	1	applied	\N	\N	\N	\N	51223	51223	51224
13612	15462	2	applied	\N	\N	\N	\N	51225	51225	51226
13617	15471	0	applied	\N	\N	\N	\N	51250	51250	51251
13617	15472	1	applied	\N	\N	\N	\N	51252	51252	51253
13617	15473	3	applied	\N	\N	\N	\N	51255	51255	51256
13617	15474	4	applied	\N	\N	\N	\N	51257	51257	51258
13627	15487	0	applied	\N	\N	\N	\N	51299	51299	51300
13627	15488	1	applied	\N	\N	\N	\N	51301	51301	51302
13627	15489	2	applied	\N	\N	\N	\N	51303	51303	51304
13627	15490	3	applied	\N	\N	\N	\N	51305	51305	51306
13627	15491	4	applied	\N	\N	\N	\N	51307	51307	51308
13627	15492	5	applied	\N	\N	\N	\N	51309	51309	51310
13627	15493	6	applied	\N	\N	\N	\N	51311	51311	51312
13627	15494	7	applied	\N	\N	\N	\N	51313	51313	51314
13627	15495	8	applied	\N	\N	\N	\N	51315	51315	51316
13627	15496	9	applied	\N	\N	\N	\N	51317	51317	51318
13627	15497	10	applied	\N	\N	\N	\N	51319	51319	51320
13627	15498	11	applied	\N	\N	\N	\N	51321	51321	51322
13631	15503	0	applied	\N	\N	\N	\N	51338	51338	51339
13631	15504	1	applied	\N	\N	\N	\N	51340	51340	51341
13631	15505	2	applied	\N	\N	\N	\N	51342	51342	51343
13631	15506	3	applied	\N	\N	\N	\N	51344	51344	51345
13634	15512	0	applied	\N	\N	\N	\N	51362	51362	51363
13634	15513	1	applied	\N	\N	\N	\N	51364	51364	51365
13634	15514	2	applied	\N	\N	\N	\N	51366	51366	51367
13634	15515	3	applied	\N	\N	\N	\N	51368	51368	51369
13634	15516	4	applied	\N	\N	\N	\N	51370	51370	51371
13634	15517	5	applied	\N	\N	\N	\N	51372	51372	51373
13634	15518	6	applied	\N	\N	\N	\N	51374	51374	51375
13634	15519	7	applied	\N	\N	\N	\N	51376	51376	51377
13634	15520	8	applied	\N	\N	\N	\N	51378	51378	51379
13634	15521	9	applied	\N	\N	\N	\N	51380	51380	51381
13634	15522	10	applied	\N	\N	\N	\N	51382	51382	51383
13634	15523	11	applied	\N	\N	\N	\N	51384	51384	51385
13634	15524	12	applied	\N	\N	\N	\N	51386	51386	51387
13634	15525	13	applied	\N	\N	\N	\N	51388	51388	51389
13638	15512	0	applied	\N	\N	\N	\N	51362	51362	51363
13638	15513	1	applied	\N	\N	\N	\N	51364	51364	51365
13639	15526	0	applied	\N	\N	\N	\N	51396	51396	51397
13639	15527	1	applied	\N	\N	\N	\N	51398	51398	51399
13639	15528	2	applied	\N	\N	\N	\N	51400	51400	51401
13639	15529	3	applied	\N	\N	\N	\N	51402	51402	51403
13639	15530	4	applied	\N	\N	\N	\N	51404	51404	51405
13639	15531	5	applied	\N	\N	\N	\N	51406	51406	51407
13639	15532	6	applied	\N	\N	\N	\N	51408	51408	51409
13639	15533	7	applied	\N	\N	\N	\N	51410	51410	51411
13639	15534	8	applied	\N	\N	\N	\N	51412	51412	51413
13639	15535	9	applied	\N	\N	\N	\N	51414	51414	51415
13639	15536	10	applied	\N	\N	\N	\N	51416	51416	51417
13639	15537	11	applied	\N	\N	\N	\N	51418	51418	51419
13639	15538	12	applied	\N	\N	\N	\N	51420	51420	51421
13639	15539	13	applied	\N	\N	\N	\N	51422	51422	51423
13639	15540	14	applied	\N	\N	\N	\N	51424	51424	51425
13639	15541	15	applied	\N	\N	\N	\N	51426	51426	51427
13647	15550	0	applied	\N	\N	\N	\N	51452	51452	51453
13647	15551	1	applied	\N	\N	\N	\N	51454	51454	51455
13647	15552	2	applied	\N	\N	\N	\N	51456	51456	51457
13649	15556	0	applied	\N	\N	\N	\N	51473	51473	51474
13649	15557	1	applied	\N	\N	\N	\N	51475	51475	51476
13651	15558	0	applied	\N	\N	\N	\N	51479	51479	51480
13651	15559	1	applied	\N	\N	\N	\N	51481	51481	51482
13651	15560	2	applied	\N	\N	\N	\N	51483	51483	51484
13657	14205	0	applied	\N	\N	1000000000	\N	47905	47905	47906
13657	15361	1	applied	\N	\N	\N	\N	50989	50989	50990
13657	15388	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	51051	51051	\N
13657	14734	3	applied	\N	\N	1000000000	\N	49314	49314	49315
13657	14407	4	applied	\N	\N	\N	\N	48422	48422	48423
13657	14158	5	applied	\N	\N	\N	\N	47792	47792	47793
13657	14428	6	applied	\N	\N	\N	\N	48467	48467	48468
13657	14448	7	applied	\N	\N	\N	\N	48524	48524	48525
13657	14435	8	applied	\N	\N	\N	\N	51511	51511	48491
13657	14454	9	applied	\N	\N	\N	\N	48541	48541	48542
13657	14436	10	applied	\N	\N	\N	\N	51512	51512	48493
13657	14476	11	applied	\N	\N	\N	\N	48603	48603	48604
13657	14481	12	applied	\N	\N	\N	\N	48617	48617	48618
13657	14159	13	applied	\N	\N	\N	\N	47794	47794	47795
13657	14163	14	applied	\N	\N	\N	\N	47805	47805	47806
13657	14439	15	applied	\N	\N	\N	\N	51513	51513	48499
13657	14444	16	applied	\N	\N	\N	\N	51514	51514	48512
13657	14164	17	applied	\N	\N	\N	\N	47807	47807	47808
13657	14179	18	applied	\N	\N	\N	\N	47842	47842	47843
13657	14182	19	applied	\N	\N	\N	\N	47850	47850	47851
13657	14183	20	applied	\N	\N	\N	\N	47852	47852	47853
13657	14201	21	applied	\N	\N	\N	\N	47891	47891	51515
13635	15513	1	applied	\N	\N	\N	\N	51364	51364	51365
13635	15514	2	applied	\N	\N	\N	\N	51366	51366	51367
13635	15515	3	applied	\N	\N	\N	\N	51368	51368	51369
13635	15516	4	applied	\N	\N	\N	\N	51370	51370	51371
13635	15517	5	applied	\N	\N	\N	\N	51372	51372	51373
13635	15518	6	applied	\N	\N	\N	\N	51374	51374	51375
13635	15519	7	applied	\N	\N	\N	\N	51376	51376	51377
13635	15520	8	applied	\N	\N	\N	\N	51378	51378	51379
13635	15521	9	applied	\N	\N	\N	\N	51380	51380	51381
13635	15522	10	applied	\N	\N	\N	\N	51382	51382	51383
13635	15523	11	applied	\N	\N	\N	\N	51384	51384	51385
13635	15524	12	applied	\N	\N	\N	\N	51386	51386	51387
13635	15525	13	applied	\N	\N	\N	\N	51388	51388	51389
13640	15526	0	applied	\N	\N	\N	\N	51396	51396	51397
13640	15527	1	applied	\N	\N	\N	\N	51398	51398	51399
13640	15528	2	applied	\N	\N	\N	\N	51400	51400	51401
13640	15529	3	applied	\N	\N	\N	\N	51402	51402	51403
13640	15530	4	applied	\N	\N	\N	\N	51404	51404	51405
13640	15531	5	applied	\N	\N	\N	\N	51406	51406	51407
13640	15532	6	applied	\N	\N	\N	\N	51408	51408	51409
13640	15533	7	applied	\N	\N	\N	\N	51410	51410	51411
13640	15534	8	applied	\N	\N	\N	\N	51412	51412	51413
13640	15535	9	applied	\N	\N	\N	\N	51414	51414	51415
13640	15536	10	applied	\N	\N	\N	\N	51416	51416	51417
13640	15537	11	applied	\N	\N	\N	\N	51418	51418	51419
13640	15538	12	applied	\N	\N	\N	\N	51420	51420	51421
13640	15539	13	applied	\N	\N	\N	\N	51422	51422	51423
13640	15540	14	applied	\N	\N	\N	\N	51424	51424	51425
13640	15541	15	applied	\N	\N	\N	\N	51426	51426	51427
13642	15546	0	applied	\N	\N	\N	\N	51442	51442	51443
13642	15547	1	applied	\N	\N	\N	\N	51444	51444	51445
13642	15548	2	applied	\N	\N	\N	\N	51446	51446	51447
13642	15549	3	applied	\N	\N	\N	\N	51448	51448	51449
13645	15550	0	applied	\N	\N	\N	\N	51452	51452	51453
13645	15551	1	applied	\N	\N	\N	\N	51454	51454	51455
13645	15552	2	applied	\N	\N	\N	\N	51456	51456	51457
13650	15556	0	applied	\N	\N	\N	\N	51473	51473	51474
13652	15561	0	applied	\N	\N	\N	\N	51487	51487	51488
13652	15562	1	applied	\N	\N	\N	\N	51489	51489	51490
13652	15563	2	applied	\N	\N	\N	\N	51491	51491	51492
13659	15564	0	applied	\N	\N	\N	\N	51494	51494	51495
13659	15567	1	applied	\N	\N	\N	\N	51592	51592	51593
13659	15568	2	applied	\N	\N	\N	\N	51594	51594	51595
13659	15569	3	applied	\N	\N	\N	\N	51596	51596	51597
13659	15570	4	applied	\N	\N	\N	\N	51598	51598	51599
13659	15565	5	applied	\N	\N	\N	\N	51497	51497	51498
13659	15566	6	applied	\N	\N	\N	\N	51499	51499	51500
13659	15571	7	applied	\N	\N	\N	\N	51600	51600	51601
13659	15572	8	applied	\N	\N	\N	\N	51602	51602	51603
13659	15573	9	applied	\N	\N	\N	\N	51604	51604	51605
13659	15574	10	applied	\N	\N	\N	\N	51606	51606	51607
13659	15575	11	applied	\N	\N	\N	\N	51608	51608	51609
13659	15576	12	applied	\N	\N	\N	\N	51610	51610	51611
13659	15577	13	applied	\N	\N	\N	\N	51612	51612	51613
13663	15578	0	applied	\N	\N	\N	\N	51619	51619	51620
13663	15579	1	applied	\N	\N	\N	\N	51621	51621	51622
13663	15580	2	applied	\N	\N	\N	\N	51623	51623	51624
13663	15581	3	applied	\N	\N	\N	\N	51625	51625	51626
13663	15582	4	applied	\N	\N	\N	\N	51627	51627	51628
13663	15583	5	applied	\N	\N	\N	\N	51629	51629	51630
13663	15584	6	applied	\N	\N	\N	\N	51631	51631	51632
13663	15585	7	applied	\N	\N	\N	\N	51633	51633	51634
13663	15577	8	applied	\N	\N	\N	\N	51612	51612	51613
13663	15586	9	applied	\N	\N	\N	\N	51635	51635	51636
13663	15587	10	applied	\N	\N	\N	\N	51637	51637	51638
13663	15588	11	applied	\N	\N	\N	\N	51639	51639	51640
13663	15589	12	applied	\N	\N	\N	\N	51641	51641	51642
13663	15590	13	applied	\N	\N	\N	\N	51643	51643	51644
13663	15591	14	applied	\N	\N	\N	\N	51645	51645	51646
13663	15592	15	applied	\N	\N	\N	\N	51647	51647	51648
13663	15593	16	applied	\N	\N	\N	\N	51649	51649	51650
13667	15594	0	applied	\N	\N	\N	\N	51665	51665	51666
13667	15595	1	applied	\N	\N	\N	\N	51667	51667	51668
13667	15596	2	applied	\N	\N	\N	\N	51669	51669	51670
13671	15594	0	applied	\N	\N	\N	\N	51665	51665	51666
13671	15596	1	applied	\N	\N	\N	\N	51669	51669	51670
13674	15602	0	applied	\N	\N	\N	\N	51690	51690	51691
13674	15603	1	applied	\N	\N	\N	\N	51692	51692	51693
13674	15604	2	applied	\N	\N	\N	\N	51694	51694	51695
13676	15605	0	applied	\N	\N	\N	\N	51698	51698	51699
13676	15606	1	applied	\N	\N	\N	\N	51700	51700	51701
13676	15607	2	applied	\N	\N	\N	\N	51702	51702	51703
13681	15614	0	applied	\N	\N	\N	\N	51724	51724	51725
13681	15615	1	applied	\N	\N	\N	\N	51726	51726	51727
13687	15623	0	applied	\N	\N	\N	\N	51745	51745	51746
13687	15624	1	applied	\N	\N	\N	\N	51747	51747	51748
13688	15625	0	applied	\N	\N	\N	\N	51754	51754	37393
13688	15626	1	applied	\N	\N	\N	\N	51755	51755	51756
13690	15627	0	applied	\N	\N	\N	\N	51759	51759	51760
13690	15628	1	applied	\N	\N	\N	\N	51761	51761	51762
13698	15641	0	applied	\N	\N	\N	\N	51805	51805	51806
13698	15642	1	applied	\N	\N	\N	\N	51807	51807	51808
13701	15645	0	applied	\N	\N	\N	\N	51815	51815	51816
13701	15646	1	applied	\N	\N	\N	\N	51817	51817	51818
13706	15653	0	applied	\N	\N	\N	\N	51843	51843	51844
13706	15654	1	applied	\N	\N	\N	\N	51845	51845	51846
13706	15655	2	applied	\N	\N	\N	\N	51847	51847	51848
13706	15656	3	applied	\N	\N	\N	\N	51849	51849	51850
13709	15663	0	applied	\N	\N	\N	\N	51869	51869	51870
13709	15664	1	applied	\N	\N	\N	\N	51871	51871	51872
13709	15665	2	applied	\N	\N	\N	\N	51873	51873	51874
13709	15666	3	applied	\N	\N	\N	\N	51875	51875	51876
13714	15667	0	applied	\N	\N	1000000000	\N	51883	51883	51884
13714	15668	1	applied	\N	\N	\N	\N	51885	51885	51886
13714	15669	2	applied	\N	\N	\N	\N	51887	51887	51888
13714	15670	3	applied	\N	\N	\N	\N	51889	51889	51890
13714	15671	4	applied	\N	\N	\N	\N	51891	51891	51892
13714	15672	5	applied	\N	\N	\N	\N	51893	51893	51894
13714	15673	6	applied	\N	\N	\N	\N	51895	51895	51896
13714	15674	7	applied	\N	\N	\N	\N	51897	51897	51898
13714	15675	8	applied	\N	\N	\N	\N	51899	51899	51900
13717	15694	0	applied	\N	\N	\N	\N	51941	51941	51942
13717	15695	1	applied	\N	\N	\N	\N	51943	51943	51944
13717	15696	2	applied	\N	\N	\N	\N	51945	51945	51946
13717	15697	3	applied	\N	\N	\N	\N	51947	51947	51948
13717	15698	4	applied	\N	\N	\N	\N	51949	51949	51950
13717	15699	5	applied	\N	\N	\N	\N	51951	51951	51952
13717	15700	6	applied	\N	\N	\N	\N	51953	51953	51954
13719	15701	0	applied	\N	\N	\N	\N	51957	51957	51958
13719	15702	1	applied	\N	\N	\N	\N	51959	51959	51960
13636	15514	2	applied	\N	\N	\N	\N	51366	51366	51367
13636	15515	3	applied	\N	\N	\N	\N	51368	51368	51369
13636	15516	4	applied	\N	\N	\N	\N	51370	51370	51371
13636	15517	5	applied	\N	\N	\N	\N	51372	51372	51373
13636	15518	6	applied	\N	\N	\N	\N	51374	51374	51375
13636	15519	7	applied	\N	\N	\N	\N	51376	51376	51377
13636	15520	8	applied	\N	\N	\N	\N	51378	51378	51379
13636	15521	9	applied	\N	\N	\N	\N	51380	51380	51381
13636	15522	10	applied	\N	\N	\N	\N	51382	51382	51383
13636	15523	11	applied	\N	\N	\N	\N	51384	51384	51385
13636	15524	12	applied	\N	\N	\N	\N	51386	51386	51387
13636	15525	13	applied	\N	\N	\N	\N	51388	51388	51389
13643	15550	0	applied	\N	\N	\N	\N	51452	51452	51453
13643	15551	1	applied	\N	\N	\N	\N	51454	51454	51455
13643	15552	2	applied	\N	\N	\N	\N	51456	51456	51457
13646	15550	0	applied	\N	\N	\N	\N	51452	51452	51453
13646	15551	1	applied	\N	\N	\N	\N	51454	51454	51455
13646	15552	2	applied	\N	\N	\N	\N	51456	51456	51457
13655	15564	0	applied	\N	\N	\N	\N	51494	51494	51495
13655	15565	2	applied	\N	\N	\N	\N	51497	51497	51498
13655	15566	3	applied	\N	\N	\N	\N	51499	51499	51500
13660	15564	0	applied	\N	\N	\N	\N	51494	51494	51495
13660	15567	1	applied	\N	\N	\N	\N	51592	51592	51593
13660	15568	2	applied	\N	\N	\N	\N	51594	51594	51595
13660	15569	3	applied	\N	\N	\N	\N	51596	51596	51597
13660	15570	4	applied	\N	\N	\N	\N	51598	51598	51599
13660	15565	5	applied	\N	\N	\N	\N	51497	51497	51498
13660	15566	6	applied	\N	\N	\N	\N	51499	51499	51500
13660	15571	7	applied	\N	\N	\N	\N	51600	51600	51601
13660	15572	8	applied	\N	\N	\N	\N	51602	51602	51603
13660	15573	9	applied	\N	\N	\N	\N	51604	51604	51605
13660	15574	10	applied	\N	\N	\N	\N	51606	51606	51607
13660	15575	11	applied	\N	\N	\N	\N	51608	51608	51609
13660	15576	12	applied	\N	\N	\N	\N	51610	51610	51611
13668	15595	0	applied	\N	\N	\N	\N	51667	51667	51668
13669	15597	0	applied	\N	\N	\N	\N	51673	51673	51674
13669	15598	1	applied	\N	\N	\N	\N	51675	51675	51676
13669	15599	2	applied	\N	\N	\N	\N	51677	51677	51678
13672	15600	0	applied	\N	\N	\N	\N	51684	51684	51685
13672	15601	1	applied	\N	\N	\N	\N	51686	51686	51687
13679	15611	0	applied	\N	\N	\N	\N	51716	51716	51717
13679	15612	1	applied	\N	\N	\N	\N	51718	51718	51719
13679	15613	2	applied	\N	\N	\N	\N	51720	51720	51721
13682	15614	0	applied	\N	\N	\N	\N	51724	51724	51725
13682	15615	1	applied	\N	\N	\N	\N	51726	51726	51727
13684	15623	0	applied	\N	\N	\N	\N	51745	51745	51746
13684	15624	1	applied	\N	\N	\N	\N	51747	51747	51748
13691	15627	0	applied	\N	\N	\N	\N	51759	51759	51760
13691	15628	1	applied	\N	\N	\N	\N	51761	51761	51762
13693	15629	0	applied	\N	\N	\N	\N	51766	51766	51767
13693	15630	1	applied	\N	\N	\N	\N	51768	51768	51769
13693	15631	2	applied	\N	\N	\N	\N	51770	51770	51771
13693	15632	3	applied	\N	\N	\N	\N	51772	51772	51773
13696	15639	0	applied	\N	\N	\N	\N	51799	51799	51800
13696	15640	1	applied	\N	\N	\N	\N	51801	51801	51802
13702	15647	0	applied	\N	\N	\N	\N	51821	51821	51822
13702	15648	1	applied	\N	\N	\N	\N	51823	51823	51824
13702	15649	2	applied	\N	\N	\N	\N	51825	51825	51826
13702	15650	3	applied	\N	\N	\N	\N	51827	51827	51828
13704	15361	0	applied	\N	\N	\N	\N	50989	50989	50990
13704	15388	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	51051	51051	\N
13704	15578	2	applied	\N	\N	\N	\N	51831	51831	51620
13704	15619	3	applied	\N	\N	\N	\N	51737	51737	37391
13704	15581	4	applied	\N	\N	\N	\N	51832	51832	51626
13704	15582	5	applied	\N	\N	\N	\N	51833	51833	51628
13704	15583	6	applied	\N	\N	\N	\N	51834	51834	51630
13704	15336	7	applied	\N	\N	\N	\N	50942	50942	50908
13704	15337	8	applied	\N	\N	\N	\N	50943	50943	50910
13704	15338	9	applied	\N	\N	\N	\N	50944	50944	50912
13704	15339	10	applied	\N	\N	\N	\N	50945	50945	50914
13704	15340	11	applied	\N	\N	\N	\N	50946	50946	50916
13704	15625	12	applied	\N	\N	\N	\N	51754	51754	37393
13704	15275	13	applied	\N	\N	\N	\N	50732	50732	50468
13704	15279	14	applied	\N	\N	\N	\N	50740	50740	50468
13707	15657	0	applied	\N	\N	\N	\N	51853	51853	51854
13707	15658	1	applied	\N	\N	\N	\N	51855	51855	51856
13710	15663	0	applied	\N	\N	\N	\N	51869	51869	51870
13710	15664	1	applied	\N	\N	\N	\N	51871	51871	51872
13710	15665	2	applied	\N	\N	\N	\N	51873	51873	51874
13710	15666	3	applied	\N	\N	\N	\N	51875	51875	51876
13720	15701	0	applied	\N	\N	\N	\N	51957	51957	51958
13720	15702	1	applied	\N	\N	\N	\N	51959	51959	51960
13720	15703	2	applied	\N	\N	\N	\N	51961	51961	51962
13720	15704	3	applied	\N	\N	\N	\N	51963	51963	51964
13734	15734	0	applied	\N	\N	\N	\N	52044	52044	52045
13734	15735	1	applied	\N	\N	\N	\N	52046	52046	52047
13734	15736	2	applied	\N	\N	\N	\N	52048	52048	52049
13734	15737	3	applied	\N	\N	\N	\N	52050	52050	52051
13739	15741	0	applied	\N	\N	\N	\N	52066	52066	52067
13739	15742	1	applied	\N	\N	\N	\N	52068	52068	52069
13739	15743	2	applied	\N	\N	\N	\N	52070	52070	52071
13739	15744	3	applied	\N	\N	\N	\N	52072	52072	52073
13741	15745	0	applied	\N	\N	\N	\N	52078	52078	52079
13741	15746	1	applied	\N	\N	\N	\N	52080	52080	52081
13741	15747	2	applied	\N	\N	\N	\N	52082	52082	52083
13741	15748	3	applied	\N	\N	\N	\N	52084	52084	52085
13741	15749	4	applied	\N	\N	\N	\N	52086	52086	52087
13741	15750	5	applied	\N	\N	\N	\N	52088	52088	52089
13741	15751	6	applied	\N	\N	\N	\N	52090	52090	52091
13741	15752	7	applied	\N	\N	\N	\N	52092	52092	52093
13741	15753	8	applied	\N	\N	\N	\N	52094	52094	52095
13741	15754	9	applied	\N	\N	\N	\N	52096	52096	52097
13741	15755	10	applied	\N	\N	\N	\N	52098	52098	52099
13741	15756	11	applied	\N	\N	\N	\N	52100	52100	52101
13741	15757	12	applied	\N	\N	\N	\N	52102	52102	52103
13741	15758	13	applied	\N	\N	\N	\N	52104	52104	52105
13741	15759	14	applied	\N	\N	\N	\N	52106	52106	52107
13741	15760	15	applied	\N	\N	\N	\N	52108	52108	52109
13741	15761	16	applied	\N	\N	\N	\N	52110	52110	52111
13741	15762	17	applied	\N	\N	\N	\N	52112	52112	52113
13741	15763	18	applied	\N	\N	\N	\N	52114	52114	52115
13741	15764	19	applied	\N	\N	\N	\N	52116	52116	52117
13747	15765	0	applied	\N	\N	\N	\N	52124	52124	52125
13748	15769	0	applied	\N	\N	\N	\N	52134	52134	52135
13748	15770	1	applied	\N	\N	\N	\N	52136	52136	52137
13748	15771	2	applied	\N	\N	\N	\N	52138	52138	52139
13748	15772	3	applied	\N	\N	\N	\N	52140	52140	52141
13748	15773	4	applied	\N	\N	\N	\N	52142	52142	52143
13748	15774	5	applied	\N	\N	\N	\N	52144	52144	52145
13641	15545	3	applied	\N	\N	\N	\N	51438	51438	51439
13644	15550	0	applied	\N	\N	\N	\N	51452	51452	51453
13644	15551	1	applied	\N	\N	\N	\N	51454	51454	51455
13644	15552	2	applied	\N	\N	\N	\N	51456	51456	51457
13648	15553	0	applied	\N	\N	\N	\N	51466	51466	51467
13648	15554	1	applied	\N	\N	\N	\N	51468	51468	51469
13648	15555	2	applied	\N	\N	\N	\N	51470	51470	51471
13653	15564	0	applied	\N	\N	\N	\N	51494	51494	51495
13653	15565	2	applied	\N	\N	\N	\N	51497	51497	51498
13653	15566	3	applied	\N	\N	\N	\N	51499	51499	51500
13664	15578	0	applied	\N	\N	\N	\N	51619	51619	51620
13664	15579	1	applied	\N	\N	\N	\N	51621	51621	51622
13664	15580	2	applied	\N	\N	\N	\N	51623	51623	51624
13664	15581	3	applied	\N	\N	\N	\N	51625	51625	51626
13664	15582	4	applied	\N	\N	\N	\N	51627	51627	51628
13664	15583	5	applied	\N	\N	\N	\N	51629	51629	51630
13664	15584	6	applied	\N	\N	\N	\N	51631	51631	51632
13664	15585	7	applied	\N	\N	\N	\N	51633	51633	51634
13664	15586	8	applied	\N	\N	\N	\N	51655	51655	51636
13664	15587	9	applied	\N	\N	\N	\N	51656	51656	51638
13664	15588	10	applied	\N	\N	\N	\N	51657	51657	51640
13664	15589	11	applied	\N	\N	\N	\N	51658	51658	51642
13664	15590	12	applied	\N	\N	\N	\N	51659	51659	51644
13664	15591	13	applied	\N	\N	\N	\N	51660	51660	51646
13664	15592	14	applied	\N	\N	\N	\N	51661	51661	51648
13664	15593	15	applied	\N	\N	\N	\N	51662	51662	51650
13670	15597	0	applied	\N	\N	\N	\N	51673	51673	51674
13670	15598	1	applied	\N	\N	\N	\N	51675	51675	51676
13670	15599	2	applied	\N	\N	\N	\N	51677	51677	51678
13675	15605	0	applied	\N	\N	\N	\N	51698	51698	51699
13675	15606	1	applied	\N	\N	\N	\N	51700	51700	51701
13675	15607	2	applied	\N	\N	\N	\N	51702	51702	51703
13677	15608	0	applied	\N	\N	\N	\N	51708	51708	51709
13677	15609	1	applied	\N	\N	\N	\N	51710	51710	51711
13677	15610	2	applied	\N	\N	\N	\N	51712	51712	51713
13685	15623	0	applied	\N	\N	\N	\N	51745	51745	51746
13685	15624	1	applied	\N	\N	\N	\N	51747	51747	51748
13686	15623	0	applied	\N	\N	\N	\N	51745	51745	51746
13686	15624	1	applied	\N	\N	\N	\N	51747	51747	51748
13689	15625	0	applied	\N	\N	\N	\N	51754	51754	37393
13689	15626	1	applied	\N	\N	\N	\N	51755	51755	51756
13694	15451	0	applied	\N	\N	\N	\N	51202	51202	51202
13694	15361	1	applied	\N	\N	\N	\N	50989	50989	50990
13694	15388	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	51051	51051	\N
13694	15578	3	applied	\N	\N	\N	\N	51778	51778	51620
13694	15343	4	applied	\N	\N	\N	\N	50933	50933	50934
13694	15619	5	applied	\N	\N	\N	\N	51737	51737	37391
13694	15581	6	applied	\N	\N	\N	\N	51779	51779	51626
13694	15582	7	applied	\N	\N	\N	\N	51780	51780	51628
13694	15583	8	applied	\N	\N	\N	\N	51781	51781	51630
13694	15346	9	applied	\N	\N	\N	\N	50951	50951	50952
13694	15349	10	applied	\N	\N	\N	\N	50959	50959	50960
13694	15352	11	applied	\N	\N	\N	\N	50969	50969	50970
13694	15353	12	applied	\N	\N	\N	\N	50971	50971	50972
13694	15354	13	applied	\N	\N	\N	\N	50973	50973	50974
13694	15362	14	applied	\N	\N	\N	\N	50991	50991	50992
13694	15365	15	applied	\N	\N	\N	\N	50998	50998	50999
13694	15366	16	applied	\N	\N	\N	\N	51000	51000	51001
13694	15372	17	applied	\N	\N	\N	\N	51014	51014	51015
13694	15373	18	applied	\N	\N	\N	\N	51016	51016	51017
13694	15374	19	applied	\N	\N	\N	\N	51018	51018	51019
13694	15384	20	applied	\N	\N	\N	\N	51041	51041	51042
13694	15389	21	applied	\N	\N	\N	\N	51052	51052	51053
13694	15393	22	applied	\N	\N	\N	\N	51063	51063	51064
13694	15398	23	applied	\N	\N	\N	\N	51076	51076	51077
13694	15402	24	applied	\N	\N	\N	\N	51086	51086	51087
13694	15405	25	applied	\N	\N	\N	\N	51095	51095	51096
13694	15409	26	applied	\N	\N	\N	\N	51107	51107	51108
13694	15412	27	applied	\N	\N	\N	\N	51115	51115	51116
13694	15416	28	applied	\N	\N	\N	\N	51123	51123	51124
13694	15417	29	applied	\N	\N	\N	\N	51125	51125	51126
13694	15418	30	applied	\N	\N	\N	\N	51127	51127	51128
13694	15419	31	applied	\N	\N	\N	\N	51129	51129	51130
13694	15420	32	applied	\N	\N	\N	\N	51131	51131	51132
13694	15421	33	applied	\N	\N	\N	\N	51133	51133	51134
13694	15422	34	applied	\N	\N	\N	\N	51135	51135	51136
13694	15443	35	applied	\N	\N	\N	\N	51182	51182	51183
13694	15447	36	applied	\N	\N	\N	\N	51191	51191	51192
13694	15452	37	applied	\N	\N	\N	\N	51203	51203	51204
13694	15453	38	applied	\N	\N	\N	\N	51205	51205	51206
13694	15460	39	applied	\N	\N	\N	\N	51221	51221	51222
13694	15625	40	applied	\N	\N	\N	\N	51754	51754	37393
13694	15463	42	applied	\N	\N	\N	\N	51229	51229	51230
13694	15467	43	applied	\N	\N	\N	\N	51240	51240	51241
13694	15471	44	applied	\N	\N	\N	\N	51250	51250	51251
13694	15475	45	applied	\N	\N	\N	\N	51263	51263	51264
13694	15479	46	applied	\N	\N	\N	\N	51274	51274	51275
13694	15483	47	applied	\N	\N	\N	\N	51288	51288	51289
13694	15487	48	applied	\N	\N	\N	\N	51299	51299	51300
13694	15488	49	applied	\N	\N	\N	\N	51301	51301	51302
13694	15489	50	applied	\N	\N	\N	\N	51303	51303	51304
13694	15499	51	applied	\N	\N	\N	\N	51328	51328	51329
13694	15503	52	applied	\N	\N	\N	\N	51338	51338	51339
13694	15507	53	applied	\N	\N	\N	\N	51348	51348	51349
13694	15510	54	applied	\N	\N	\N	\N	51356	51356	51357
13694	15511	55	applied	\N	\N	\N	\N	51358	51358	51359
13694	15512	56	applied	\N	\N	\N	\N	51362	51362	51363
13694	15513	57	applied	\N	\N	\N	\N	51364	51364	51365
13694	15526	58	applied	\N	\N	\N	\N	51396	51396	51397
13694	15527	59	applied	\N	\N	\N	\N	51398	51398	51399
13694	15528	60	applied	\N	\N	\N	\N	51400	51400	51401
13694	15529	61	applied	\N	\N	\N	\N	51402	51402	51403
13694	15542	62	applied	\N	\N	\N	\N	51432	51432	51433
13694	15546	63	applied	\N	\N	\N	\N	51442	51442	51443
13694	15550	64	applied	\N	\N	\N	\N	51452	51452	51453
13694	15553	65	applied	\N	\N	\N	\N	51466	51466	51467
13694	15556	66	applied	\N	\N	\N	\N	51473	51473	51474
13694	15558	67	applied	\N	\N	\N	\N	51479	51479	51480
13694	15561	68	applied	\N	\N	\N	\N	51487	51487	51488
13694	15564	69	applied	\N	\N	\N	\N	51494	51494	51495
13694	15567	70	applied	\N	\N	\N	\N	51592	51592	51593
13694	15568	71	applied	\N	\N	\N	\N	51594	51594	51595
13694	15569	72	applied	\N	\N	\N	\N	51596	51596	51597
13694	15570	73	applied	\N	\N	\N	\N	51598	51598	51599
13694	15579	74	applied	\N	\N	\N	\N	51621	51621	51622
13694	15580	75	applied	\N	\N	\N	\N	51623	51623	51624
13694	15584	76	applied	\N	\N	\N	\N	51631	51631	51632
13694	15585	77	applied	\N	\N	\N	\N	51633	51633	51634
13694	15594	78	applied	\N	\N	\N	\N	51665	51665	51666
13657	14206	22	applied	\N	\N	\N	\N	47907	47907	51516
13657	14482	23	applied	\N	\N	\N	\N	48619	48619	48620
13657	14489	24	applied	\N	\N	\N	\N	48636	48636	48637
13657	14491	25	applied	\N	\N	\N	\N	48640	48640	48641
13657	14492	26	applied	\N	\N	\N	\N	48643	48643	48644
13657	14207	27	applied	\N	\N	\N	\N	47909	47909	51517
13657	14213	28	applied	\N	\N	\N	\N	47925	47925	51518
13657	14217	29	applied	\N	\N	\N	\N	47941	47941	51519
13657	14220	30	applied	\N	\N	\N	\N	47949	47949	51520
13657	14224	31	applied	\N	\N	\N	\N	47961	47961	51521
13657	14227	32	applied	\N	\N	\N	\N	47972	47972	51522
13657	14231	33	applied	\N	\N	\N	\N	47986	47986	51523
13657	14655	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	49099	49099	\N
13657	14660	35	applied	\N	\N	1000000000	\N	49113	49113	49114
13657	14731	36	applied	\N	\N	\N	\N	49306	49306	49307
13657	15336	37	applied	\N	\N	\N	\N	50942	50942	50908
13657	15337	38	applied	\N	\N	\N	\N	50943	50943	50910
13657	15338	39	applied	\N	\N	\N	\N	50944	50944	50912
13657	15339	40	applied	\N	\N	\N	\N	50945	50945	50914
13657	15340	41	applied	\N	\N	\N	\N	50946	50946	50916
13657	14165	42	applied	\N	\N	\N	\N	47809	47809	47810
13657	14166	43	applied	\N	\N	\N	\N	47811	47811	47812
13657	14167	44	applied	\N	\N	\N	\N	47813	47813	47814
13657	14168	45	applied	\N	\N	\N	\N	47815	47815	47816
13657	14169	46	applied	\N	\N	\N	\N	47817	47817	47818
13657	14170	47	applied	\N	\N	\N	\N	47819	47819	47820
13657	14171	48	applied	\N	\N	\N	\N	47821	47821	47822
13657	14172	49	applied	\N	\N	\N	\N	47823	47823	47824
13657	14173	50	applied	\N	\N	\N	\N	47825	47825	47826
13657	14174	51	applied	\N	\N	\N	\N	47827	47827	47828
13657	14184	52	applied	\N	\N	\N	\N	47854	47854	47855
13657	14185	53	applied	\N	\N	\N	\N	47856	47856	47857
13657	14186	54	applied	\N	\N	\N	\N	47858	47858	47859
13657	14187	55	applied	\N	\N	\N	\N	47860	47860	47861
13657	14188	56	applied	\N	\N	\N	\N	47862	47862	47863
13657	14189	57	applied	\N	\N	\N	\N	47864	47864	47865
13657	14190	58	applied	\N	\N	\N	\N	47866	47866	47867
13657	14191	59	applied	\N	\N	\N	\N	47868	47868	47869
13657	14192	60	applied	\N	\N	\N	\N	47870	47870	47871
13657	14232	61	applied	\N	\N	\N	\N	47988	47988	51524
13657	14239	62	applied	\N	\N	\N	\N	48004	48004	51525
13657	14242	63	applied	\N	\N	\N	\N	48012	48012	51526
13657	14245	64	applied	\N	\N	\N	\N	48022	48022	51527
13657	14246	65	applied	\N	\N	\N	\N	48026	48026	51528
13657	14252	66	applied	\N	\N	\N	\N	48039	48039	51529
13657	14255	67	applied	\N	\N	\N	\N	48046	48046	51530
13657	14259	69	applied	\N	\N	\N	\N	48055	48055	51532
13657	14260	70	applied	\N	\N	\N	\N	48057	48057	51533
13657	14267	71	applied	\N	\N	\N	\N	48072	48072	51534
13657	14271	72	applied	\N	\N	\N	\N	48083	48083	51535
13657	14275	73	applied	\N	\N	\N	\N	48093	48093	51536
13657	14279	74	applied	\N	\N	\N	\N	48105	48105	51537
13657	14282	75	applied	\N	\N	\N	\N	48112	48112	51538
13657	14286	76	applied	\N	\N	\N	\N	48121	48121	51539
13657	14290	77	applied	\N	\N	\N	\N	48135	48135	51540
13657	14291	78	applied	\N	\N	\N	\N	48137	48137	51541
13657	14296	79	applied	\N	\N	\N	\N	48149	48149	51542
13657	14297	80	applied	\N	\N	\N	\N	48151	48151	51543
13657	14304	81	applied	\N	\N	\N	\N	48176	48176	51544
13657	14308	82	applied	\N	\N	\N	\N	48187	48187	51545
13657	14311	83	applied	\N	\N	\N	\N	48196	48196	51546
13657	14314	84	applied	\N	\N	\N	\N	48202	48202	51547
13657	14315	85	applied	\N	\N	\N	\N	48204	48204	51548
13657	14322	86	applied	\N	\N	\N	\N	48222	48222	51549
13657	14326	87	applied	\N	\N	\N	\N	48231	48231	51550
13657	14327	88	applied	\N	\N	\N	\N	48233	48233	51551
13657	14328	89	applied	\N	\N	\N	\N	48235	48235	51552
13657	14338	90	applied	\N	\N	\N	\N	48257	48257	51553
13657	14341	91	applied	\N	\N	\N	\N	48265	48265	51554
13657	14345	92	applied	\N	\N	\N	\N	48275	48275	51555
13657	14348	93	applied	\N	\N	\N	\N	48285	48285	51556
13657	14349	94	applied	\N	\N	\N	\N	48287	48287	51557
13657	14350	95	applied	\N	\N	\N	\N	48289	48289	51558
13657	14360	96	applied	\N	\N	\N	\N	48313	48313	51559
13657	14367	97	applied	\N	\N	\N	\N	48328	48328	51560
13657	14368	98	applied	\N	\N	\N	\N	48330	48330	51561
13657	14369	99	applied	\N	\N	\N	\N	48332	48332	51562
13657	14370	100	applied	\N	\N	\N	\N	48334	48334	51563
13657	14371	101	applied	\N	\N	\N	\N	48336	48336	51564
13657	14384	102	applied	\N	\N	\N	\N	48364	48364	51565
13657	14388	103	applied	\N	\N	\N	\N	48372	48372	51566
13657	14392	104	applied	\N	\N	\N	\N	48383	48383	51567
13657	14396	105	applied	\N	\N	\N	\N	48396	48396	51568
13657	14397	106	applied	\N	\N	\N	\N	48399	48399	51569
13657	14404	107	applied	\N	\N	\N	\N	48415	48415	51570
13657	14408	108	applied	\N	\N	\N	\N	48424	48424	51571
13657	14409	109	applied	\N	\N	\N	\N	48426	48426	51572
13657	14410	110	applied	\N	\N	\N	\N	48428	48428	51573
13657	14411	111	applied	\N	\N	\N	\N	48430	48430	51574
13657	14412	112	applied	\N	\N	\N	\N	48432	48432	51575
13657	14413	113	applied	\N	\N	\N	\N	48434	48434	51576
13657	14429	114	applied	\N	\N	\N	\N	48469	48469	51577
13657	14433	115	applied	\N	\N	\N	\N	48481	48481	51578
13657	14437	116	applied	\N	\N	\N	\N	48494	48494	51579
13657	14438	117	applied	\N	\N	\N	\N	48496	48496	51580
13657	14445	118	applied	\N	\N	\N	\N	48513	48513	51581
13657	14449	119	applied	\N	\N	\N	\N	48526	48526	51582
13657	14452	120	applied	\N	\N	\N	\N	48537	48537	51583
13657	14453	121	applied	\N	\N	\N	\N	48539	48539	51584
13657	14455	122	applied	\N	\N	\N	\N	48543	48543	51585
13657	14462	123	applied	\N	\N	\N	\N	48559	48559	51586
13657	14463	124	applied	\N	\N	\N	\N	48562	48562	51587
13657	14468	125	applied	\N	\N	\N	\N	48577	48577	51588
13661	15564	0	applied	\N	\N	\N	\N	51494	51494	51495
13661	15567	1	applied	\N	\N	\N	\N	51592	51592	51593
13661	15568	2	applied	\N	\N	\N	\N	51594	51594	51595
13661	15569	3	applied	\N	\N	\N	\N	51596	51596	51597
13661	15570	4	applied	\N	\N	\N	\N	51598	51598	51599
13661	15565	5	applied	\N	\N	\N	\N	51497	51497	51498
13661	15566	6	applied	\N	\N	\N	\N	51499	51499	51500
13661	15571	7	applied	\N	\N	\N	\N	51600	51600	51601
13661	15572	8	applied	\N	\N	\N	\N	51602	51602	51603
13661	15573	9	applied	\N	\N	\N	\N	51604	51604	51605
13661	15574	10	applied	\N	\N	\N	\N	51606	51606	51607
13661	15575	11	applied	\N	\N	\N	\N	51608	51608	51609
13661	15576	12	applied	\N	\N	\N	\N	51610	51610	51611
13661	15577	13	applied	\N	\N	\N	\N	51612	51612	51613
13662	15578	0	applied	\N	\N	\N	\N	51619	51619	51620
13662	15579	1	applied	\N	\N	\N	\N	51621	51621	51622
13662	15580	2	applied	\N	\N	\N	\N	51623	51623	51624
13662	15581	3	applied	\N	\N	\N	\N	51625	51625	51626
13662	15582	4	applied	\N	\N	\N	\N	51627	51627	51628
13662	15583	5	applied	\N	\N	\N	\N	51629	51629	51630
13662	15584	6	applied	\N	\N	\N	\N	51631	51631	51632
13662	15585	7	applied	\N	\N	\N	\N	51633	51633	51634
13662	15577	8	applied	\N	\N	\N	\N	51612	51612	51613
13662	15586	9	applied	\N	\N	\N	\N	51635	51635	51636
13662	15587	10	applied	\N	\N	\N	\N	51637	51637	51638
13662	15588	11	applied	\N	\N	\N	\N	51639	51639	51640
13662	15589	12	applied	\N	\N	\N	\N	51641	51641	51642
13662	15590	13	applied	\N	\N	\N	\N	51643	51643	51644
13662	15591	14	applied	\N	\N	\N	\N	51645	51645	51646
13662	15592	15	applied	\N	\N	\N	\N	51647	51647	51648
13662	15593	16	applied	\N	\N	\N	\N	51649	51649	51650
13666	15594	0	applied	\N	\N	\N	\N	51665	51665	51666
13666	15595	1	applied	\N	\N	\N	\N	51667	51667	51668
13666	15596	2	applied	\N	\N	\N	\N	51669	51669	51670
13673	15602	0	applied	\N	\N	\N	\N	51690	51690	51691
13673	15603	1	applied	\N	\N	\N	\N	51692	51692	51693
13673	15604	2	applied	\N	\N	\N	\N	51694	51694	51695
13678	15611	0	applied	\N	\N	\N	\N	51716	51716	51717
13678	15612	1	applied	\N	\N	\N	\N	51718	51718	51719
13678	15613	2	applied	\N	\N	\N	\N	51720	51720	51721
13680	15614	0	applied	\N	\N	\N	\N	51724	51724	51725
13680	15615	1	applied	\N	\N	\N	\N	51726	51726	51727
13683	15616	0	applied	\N	\N	\N	\N	51731	51731	51732
13683	15617	1	applied	\N	\N	\N	\N	51733	51733	51734
13683	15618	2	applied	\N	\N	\N	\N	51735	51735	51736
13683	15619	3	applied	\N	\N	\N	\N	51737	51737	37391
13683	15620	4	applied	\N	\N	\N	\N	51738	51738	51739
13683	15621	5	applied	\N	\N	\N	\N	51740	51740	51741
13683	15622	6	applied	\N	\N	\N	\N	51742	51742	51743
13692	15629	0	applied	\N	\N	\N	\N	51766	51766	51767
13692	15630	1	applied	\N	\N	\N	\N	51768	51768	51769
13692	15631	2	applied	\N	\N	\N	\N	51770	51770	51771
13692	15632	3	applied	\N	\N	\N	\N	51772	51772	51773
13695	15633	0	applied	\N	\N	\N	\N	51785	51785	51786
13695	15634	1	applied	\N	\N	\N	\N	51787	51787	51788
13695	15635	2	applied	\N	\N	\N	\N	51789	51789	51790
13695	15636	3	applied	\N	\N	\N	\N	51791	51791	51792
13695	15637	4	applied	\N	\N	\N	\N	51793	51793	51794
13695	15638	5	applied	\N	\N	\N	\N	51795	51795	51796
13700	15645	0	applied	\N	\N	\N	\N	51815	51815	51816
13700	15646	1	applied	\N	\N	\N	\N	51817	51817	51818
13705	15651	0	applied	\N	\N	\N	\N	51837	51837	51838
13705	15652	1	applied	\N	\N	\N	\N	51839	51839	51840
13708	15659	0	applied	\N	\N	\N	\N	51859	51859	51860
13708	15660	1	applied	\N	\N	\N	\N	51861	51861	51862
13708	15661	2	applied	\N	\N	\N	\N	51863	51863	51864
13708	15662	3	applied	\N	\N	\N	\N	51865	51865	51866
13712	15663	0	applied	\N	\N	\N	\N	51869	51869	51870
13712	15664	1	applied	\N	\N	\N	\N	51871	51871	51872
13712	15665	2	applied	\N	\N	\N	\N	51873	51873	51874
13712	15666	3	applied	\N	\N	\N	\N	51875	51875	51876
13713	15667	0	applied	\N	\N	1000000000	\N	51883	51883	51884
13713	15668	1	applied	\N	\N	\N	\N	51885	51885	51886
13713	15669	2	applied	\N	\N	\N	\N	51887	51887	51888
13713	15670	3	applied	\N	\N	\N	\N	51889	51889	51890
13713	15671	4	applied	\N	\N	\N	\N	51891	51891	51892
13713	15672	5	applied	\N	\N	\N	\N	51893	51893	51894
13713	15673	6	applied	\N	\N	\N	\N	51895	51895	51896
13713	15674	7	applied	\N	\N	\N	\N	51897	51897	51898
13713	15675	8	applied	\N	\N	\N	\N	51899	51899	51900
13716	15685	0	applied	\N	\N	\N	\N	51923	51923	51924
13716	15686	1	applied	\N	\N	\N	\N	51925	51925	51926
13716	15687	2	applied	\N	\N	\N	\N	51927	51927	51928
13716	15688	3	applied	\N	\N	\N	\N	51929	51929	51930
13716	15689	4	applied	\N	\N	\N	\N	51931	51931	51932
13716	15690	5	applied	\N	\N	\N	\N	51933	51933	51934
13716	15691	6	applied	\N	\N	\N	\N	51935	51935	51936
13716	15692	7	applied	\N	\N	\N	\N	51937	51937	51938
13716	15693	8	applied	\N	\N	\N	\N	51939	51939	51904
13724	15713	0	applied	\N	\N	\N	\N	51990	51990	51991
13724	15714	1	applied	\N	\N	\N	\N	51992	51992	51993
13724	15715	2	applied	\N	\N	\N	\N	51994	51994	51995
13724	15716	3	applied	\N	\N	\N	\N	51996	51996	51997
13724	15717	4	applied	\N	\N	\N	\N	51998	51998	51904
13726	15718	0	applied	\N	\N	\N	\N	52003	52003	52004
13726	15719	1	applied	\N	\N	\N	\N	52005	52005	52006
13726	15720	2	applied	\N	\N	\N	\N	52007	52007	52008
13726	15721	3	applied	\N	\N	\N	\N	52009	52009	52010
13729	15722	0	applied	\N	\N	\N	\N	52014	52014	52015
13729	15719	1	applied	\N	\N	\N	\N	52005	52005	52006
13729	15720	2	applied	\N	\N	\N	\N	52007	52007	52008
13729	15721	3	applied	\N	\N	\N	\N	52009	52009	52010
13729	15723	4	applied	\N	\N	\N	\N	52016	52016	52017
13729	15724	5	applied	\N	\N	\N	\N	52018	52018	52019
13729	15725	6	applied	\N	\N	\N	\N	52020	52020	52021
13732	15734	0	applied	\N	\N	\N	\N	52044	52044	52045
13732	15735	1	applied	\N	\N	\N	\N	52046	52046	52047
13732	15736	2	applied	\N	\N	\N	\N	52048	52048	52049
13732	15737	3	applied	\N	\N	\N	\N	52050	52050	52051
13737	15738	0	applied	\N	\N	\N	\N	52056	52056	52057
13737	15739	1	applied	\N	\N	\N	\N	52058	52058	52059
13737	15740	2	applied	\N	\N	\N	\N	52060	52060	52061
13744	15745	0	applied	\N	\N	\N	\N	52078	52078	52079
13744	15746	1	applied	\N	\N	\N	\N	52080	52080	52081
13744	15747	2	applied	\N	\N	\N	\N	52082	52082	52083
13744	15748	3	applied	\N	\N	\N	\N	52084	52084	52085
13744	15749	4	applied	\N	\N	\N	\N	52086	52086	52087
13744	15750	5	applied	\N	\N	\N	\N	52088	52088	52089
13744	15751	6	applied	\N	\N	\N	\N	52090	52090	52091
13744	15752	7	applied	\N	\N	\N	\N	52092	52092	52093
13744	15753	8	applied	\N	\N	\N	\N	52094	52094	52095
13744	15754	9	applied	\N	\N	\N	\N	52096	52096	52097
13744	15755	10	applied	\N	\N	\N	\N	52098	52098	52099
13744	15756	11	applied	\N	\N	\N	\N	52100	52100	52101
13744	15757	12	applied	\N	\N	\N	\N	52102	52102	52103
13744	15758	13	applied	\N	\N	\N	\N	52104	52104	52105
13744	15759	14	applied	\N	\N	\N	\N	52106	52106	52107
13744	15760	15	applied	\N	\N	\N	\N	52108	52108	52109
13744	15761	16	applied	\N	\N	\N	\N	52110	52110	52111
13744	15762	17	applied	\N	\N	\N	\N	52112	52112	52113
13744	15763	18	applied	\N	\N	\N	\N	52114	52114	52115
13744	15764	19	applied	\N	\N	\N	\N	52116	52116	52117
13745	15745	0	applied	\N	\N	\N	\N	52078	52078	52079
13745	15746	1	applied	\N	\N	\N	\N	52080	52080	52081
13745	15747	2	applied	\N	\N	\N	\N	52082	52082	52083
13745	15748	3	applied	\N	\N	\N	\N	52084	52084	52085
13694	15597	79	applied	\N	\N	\N	\N	51673	51673	51674
13694	15600	80	applied	\N	\N	\N	\N	51684	51684	51685
13694	15602	81	applied	\N	\N	\N	\N	51690	51690	51691
13694	15605	82	applied	\N	\N	\N	\N	51698	51698	51699
13694	15608	83	applied	\N	\N	\N	\N	51708	51708	51709
13694	15611	84	applied	\N	\N	\N	\N	51716	51716	51717
13694	15614	85	applied	\N	\N	\N	\N	51724	51724	51725
13694	15616	86	applied	\N	\N	\N	\N	51731	51731	51732
13694	15617	87	applied	\N	\N	\N	\N	51733	51733	51734
13694	15618	88	applied	\N	\N	\N	\N	51735	51735	51736
13697	15639	0	applied	\N	\N	\N	\N	51799	51799	51800
13697	15640	1	applied	\N	\N	\N	\N	51801	51801	51802
13699	15643	0	applied	\N	\N	\N	\N	51809	51809	51810
13699	15644	1	applied	\N	\N	\N	\N	51811	51811	51812
13703	15647	0	applied	\N	\N	\N	\N	51821	51821	51822
13703	15648	1	applied	\N	\N	\N	\N	51823	51823	51824
13703	15649	2	applied	\N	\N	\N	\N	51825	51825	51826
13703	15650	3	applied	\N	\N	\N	\N	51827	51827	51828
13711	15663	0	applied	\N	\N	\N	\N	51869	51869	51870
13711	15664	1	applied	\N	\N	\N	\N	51871	51871	51872
13711	15665	2	applied	\N	\N	\N	\N	51873	51873	51874
13711	15666	3	applied	\N	\N	\N	\N	51875	51875	51876
13715	15676	0	applied	\N	\N	\N	\N	51904	51904	51905
13715	15677	1	applied	\N	\N	\N	\N	51906	51906	51907
13715	15678	2	applied	\N	\N	\N	\N	51908	51908	51909
13715	15679	3	applied	\N	\N	\N	\N	51910	51910	51911
13715	15680	4	applied	\N	\N	\N	\N	51912	51912	51913
13715	15681	5	applied	\N	\N	\N	\N	51914	51914	51915
13715	15682	6	applied	\N	\N	\N	\N	51916	51916	51917
13715	15683	7	applied	\N	\N	\N	\N	51918	51918	51919
13715	15684	8	applied	\N	\N	\N	\N	51920	51920	51921
13718	15701	0	applied	\N	\N	\N	\N	51957	51957	51958
13718	15702	1	applied	\N	\N	\N	\N	51959	51959	51960
13718	15703	2	applied	\N	\N	\N	\N	51961	51961	51962
13718	15704	3	applied	\N	\N	\N	\N	51963	51963	51964
13721	15705	0	applied	\N	\N	\N	\N	51970	51970	51971
13721	15706	1	applied	\N	\N	\N	\N	51972	51972	51973
13721	15707	2	applied	\N	\N	\N	\N	51974	51974	51975
13721	15708	3	applied	\N	\N	\N	\N	51976	51976	51977
13723	15709	0	applied	\N	\N	\N	\N	51980	51980	51981
13723	15710	1	applied	\N	\N	\N	\N	51982	51982	51983
13723	15711	2	applied	\N	\N	\N	\N	51984	51984	51985
13723	15712	3	applied	\N	\N	\N	\N	51986	51986	51987
13728	15722	0	applied	\N	\N	\N	\N	52014	52014	52015
13728	15719	1	applied	\N	\N	\N	\N	52005	52005	52006
13728	15720	2	applied	\N	\N	\N	\N	52007	52007	52008
13728	15721	3	applied	\N	\N	\N	\N	52009	52009	52010
13728	15723	4	applied	\N	\N	\N	\N	52016	52016	52017
13728	15724	5	applied	\N	\N	\N	\N	52018	52018	52019
13728	15725	6	applied	\N	\N	\N	\N	52020	52020	52021
13730	15726	0	applied	\N	\N	\N	\N	52024	52024	52025
13730	15727	1	applied	\N	\N	\N	\N	52026	52026	52027
13730	15728	2	applied	\N	\N	\N	\N	52028	52028	52029
13730	15729	3	applied	\N	\N	\N	\N	52030	52030	52031
13731	15730	0	applied	\N	\N	\N	\N	52034	52034	52035
13731	15731	1	applied	\N	\N	\N	\N	52036	52036	52037
13731	15732	2	applied	\N	\N	\N	\N	52038	52038	52039
13731	15733	3	applied	\N	\N	\N	\N	52040	52040	52041
13735	15734	0	applied	\N	\N	\N	\N	52044	52044	52045
13735	15735	1	applied	\N	\N	\N	\N	52046	52046	52047
13735	15736	2	applied	\N	\N	\N	\N	52048	52048	52049
13736	15738	0	applied	\N	\N	\N	\N	52056	52056	52057
13736	15739	1	applied	\N	\N	\N	\N	52058	52058	52059
13736	15740	2	applied	\N	\N	\N	\N	52060	52060	52061
13740	15741	0	applied	\N	\N	\N	\N	52066	52066	52067
13740	15742	1	applied	\N	\N	\N	\N	52068	52068	52069
13740	15743	2	applied	\N	\N	\N	\N	52070	52070	52071
13740	15744	3	applied	\N	\N	\N	\N	52072	52072	52073
13749	15769	0	applied	\N	\N	\N	\N	52134	52134	52135
13749	15770	1	applied	\N	\N	\N	\N	52136	52136	52137
13749	15771	2	applied	\N	\N	\N	\N	52138	52138	52139
13749	15772	3	applied	\N	\N	\N	\N	52140	52140	52141
13749	15773	4	applied	\N	\N	\N	\N	52142	52142	52143
13749	15774	5	applied	\N	\N	\N	\N	52144	52144	52145
13749	15775	6	applied	\N	\N	\N	\N	52146	52146	52147
13750	15776	0	applied	\N	\N	\N	\N	52152	52152	52153
13750	15777	1	applied	\N	\N	\N	\N	52154	52154	52155
13750	15778	2	applied	\N	\N	\N	\N	52156	52156	52157
13750	15779	3	applied	\N	\N	\N	\N	52158	52158	52159
13750	15780	4	applied	\N	\N	\N	\N	52160	52160	52161
13750	15781	5	applied	\N	\N	\N	\N	52162	52162	52163
13750	15782	6	applied	\N	\N	\N	\N	52164	52164	52165
13757	15795	0	applied	\N	\N	\N	\N	52201	52201	52202
13757	15796	1	applied	\N	\N	\N	\N	52203	52203	52204
13757	15797	2	applied	\N	\N	\N	\N	52205	52205	52206
13757	15798	3	applied	\N	\N	\N	\N	52207	52207	52208
13757	15799	4	applied	\N	\N	\N	\N	52209	52209	52210
13757	15800	5	applied	\N	\N	\N	\N	52211	52211	52212
13757	15801	6	applied	\N	\N	\N	\N	52213	52213	52214
13757	15802	7	applied	\N	\N	\N	\N	52215	52215	52216
13761	15803	0	applied	\N	\N	\N	\N	52226	52226	52227
13766	15811	0	applied	\N	\N	\N	\N	52249	52249	52250
13766	15812	1	applied	\N	\N	\N	\N	52251	52251	52252
13766	15813	2	applied	\N	\N	\N	\N	52253	52253	52254
13766	15814	3	applied	\N	\N	\N	\N	52255	52255	52256
13769	15819	0	applied	\N	\N	\N	\N	52270	52270	52271
13769	15820	1	applied	\N	\N	\N	\N	52272	52272	52273
13769	15821	2	applied	\N	\N	\N	\N	52274	52274	52275
13769	15822	3	applied	\N	\N	\N	\N	52276	52276	52277
13769	15823	4	applied	\N	\N	\N	\N	52278	52278	52279
13769	15824	5	applied	\N	\N	\N	\N	52280	52280	52281
13769	15825	6	applied	\N	\N	\N	\N	52282	52282	52283
13769	15826	7	applied	\N	\N	\N	\N	52284	52284	52285
13771	15827	0	applied	\N	\N	\N	\N	52288	52288	52289
13771	15828	1	applied	\N	\N	\N	\N	52292	52292	52293
13771	15829	2	applied	\N	\N	\N	\N	52294	52294	52295
13771	15830	3	applied	\N	\N	\N	\N	52296	52296	52297
13776	15835	0	applied	\N	\N	\N	\N	52311	52311	52312
13776	15836	1	applied	\N	\N	\N	\N	52313	52313	52314
13776	15837	2	applied	\N	\N	\N	\N	52315	52315	52316
13776	15838	3	applied	\N	\N	\N	\N	52317	52317	52318
13776	15839	4	applied	\N	\N	\N	\N	52319	52319	52320
13776	15840	5	applied	\N	\N	\N	\N	52321	52321	52322
13776	15841	6	applied	\N	\N	\N	\N	52323	52323	52324
13776	15842	7	applied	\N	\N	\N	\N	52325	52325	52326
13776	15843	8	applied	\N	\N	\N	\N	52327	52327	52328
13776	15844	9	applied	\N	\N	\N	\N	52329	52329	52330
13776	15845	10	applied	\N	\N	\N	\N	52331	52331	52332
13776	15846	11	applied	\N	\N	\N	\N	52333	52333	52334
13776	15847	12	applied	\N	\N	\N	\N	52335	52335	52336
13719	15703	2	applied	\N	\N	\N	\N	51961	51961	51962
13719	15704	3	applied	\N	\N	\N	\N	51963	51963	51964
13722	15705	0	applied	\N	\N	\N	\N	51970	51970	51971
13722	15706	1	applied	\N	\N	\N	\N	51972	51972	51973
13722	15707	2	applied	\N	\N	\N	\N	51974	51974	51975
13722	15708	3	applied	\N	\N	\N	\N	51976	51976	51977
13725	15713	0	applied	\N	\N	\N	\N	51990	51990	51991
13725	15714	1	applied	\N	\N	\N	\N	51992	51992	51993
13725	15715	2	applied	\N	\N	\N	\N	51994	51994	51995
13725	15716	3	applied	\N	\N	\N	\N	51996	51996	51997
13725	15717	4	applied	\N	\N	\N	\N	51998	51998	51904
13727	15718	0	applied	\N	\N	\N	\N	52003	52003	52004
13733	15734	0	applied	\N	\N	\N	\N	52044	52044	52045
13733	15735	1	applied	\N	\N	\N	\N	52046	52046	52047
13733	15736	2	applied	\N	\N	\N	\N	52048	52048	52049
13733	15737	3	applied	\N	\N	\N	\N	52050	52050	52051
13738	15741	0	applied	\N	\N	\N	\N	52066	52066	52067
13738	15742	1	applied	\N	\N	\N	\N	52068	52068	52069
13738	15743	2	applied	\N	\N	\N	\N	52070	52070	52071
13738	15744	3	applied	\N	\N	\N	\N	52072	52072	52073
13742	15745	0	applied	\N	\N	\N	\N	52078	52078	52079
13742	15746	1	applied	\N	\N	\N	\N	52080	52080	52081
13742	15747	2	applied	\N	\N	\N	\N	52082	52082	52083
13742	15748	3	applied	\N	\N	\N	\N	52084	52084	52085
13742	15749	4	applied	\N	\N	\N	\N	52086	52086	52087
13742	15750	5	applied	\N	\N	\N	\N	52088	52088	52089
13742	15751	6	applied	\N	\N	\N	\N	52090	52090	52091
13742	15752	7	applied	\N	\N	\N	\N	52092	52092	52093
13742	15753	8	applied	\N	\N	\N	\N	52094	52094	52095
13742	15754	9	applied	\N	\N	\N	\N	52096	52096	52097
13742	15755	10	applied	\N	\N	\N	\N	52098	52098	52099
13742	15756	11	applied	\N	\N	\N	\N	52100	52100	52101
13742	15757	12	applied	\N	\N	\N	\N	52102	52102	52103
13742	15758	13	applied	\N	\N	\N	\N	52104	52104	52105
13742	15759	14	applied	\N	\N	\N	\N	52106	52106	52107
13742	15760	15	applied	\N	\N	\N	\N	52108	52108	52109
13742	15761	16	applied	\N	\N	\N	\N	52110	52110	52111
13742	15762	17	applied	\N	\N	\N	\N	52112	52112	52113
13742	15763	18	applied	\N	\N	\N	\N	52114	52114	52115
13742	15764	19	applied	\N	\N	\N	\N	52116	52116	52117
13743	15745	0	applied	\N	\N	\N	\N	52078	52078	52079
13743	15746	1	applied	\N	\N	\N	\N	52080	52080	52081
13743	15747	2	applied	\N	\N	\N	\N	52082	52082	52083
13743	15748	3	applied	\N	\N	\N	\N	52084	52084	52085
13743	15749	4	applied	\N	\N	\N	\N	52086	52086	52087
13743	15750	5	applied	\N	\N	\N	\N	52088	52088	52089
13743	15751	6	applied	\N	\N	\N	\N	52090	52090	52091
13743	15752	7	applied	\N	\N	\N	\N	52092	52092	52093
13743	15753	8	applied	\N	\N	\N	\N	52094	52094	52095
13743	15754	9	applied	\N	\N	\N	\N	52096	52096	52097
13743	15755	10	applied	\N	\N	\N	\N	52098	52098	52099
13743	15756	11	applied	\N	\N	\N	\N	52100	52100	52101
13743	15757	12	applied	\N	\N	\N	\N	52102	52102	52103
13743	15758	13	applied	\N	\N	\N	\N	52104	52104	52105
13743	15759	14	applied	\N	\N	\N	\N	52106	52106	52107
13743	15760	15	applied	\N	\N	\N	\N	52108	52108	52109
13743	15761	16	applied	\N	\N	\N	\N	52110	52110	52111
13743	15762	17	applied	\N	\N	\N	\N	52112	52112	52113
13743	15763	18	applied	\N	\N	\N	\N	52114	52114	52115
13743	15764	19	applied	\N	\N	\N	\N	52116	52116	52117
13746	15765	0	applied	\N	\N	\N	\N	52124	52124	52125
13746	15766	1	applied	\N	\N	\N	\N	52126	52126	52127
13746	15767	2	applied	\N	\N	\N	\N	52128	52128	52129
13746	15768	3	applied	\N	\N	\N	\N	52130	52130	52131
13753	15787	0	applied	\N	\N	\N	\N	52180	52180	52181
13753	15788	1	applied	\N	\N	\N	\N	52182	52182	52183
13753	15789	2	applied	\N	\N	\N	\N	52184	52184	52185
13753	15790	3	applied	\N	\N	\N	\N	52186	52186	52187
13759	15795	0	applied	\N	\N	\N	\N	52201	52201	52202
13759	15796	1	applied	\N	\N	\N	\N	52203	52203	52204
13759	15797	2	applied	\N	\N	\N	\N	52205	52205	52206
13759	15798	3	applied	\N	\N	\N	\N	52207	52207	52208
13759	15799	4	applied	\N	\N	\N	\N	52209	52209	52210
13759	15800	5	applied	\N	\N	\N	\N	52211	52211	52212
13759	15801	6	applied	\N	\N	\N	\N	52213	52213	52214
13759	15802	7	applied	\N	\N	\N	\N	52215	52215	52216
13767	15815	0	applied	\N	\N	\N	\N	52260	52260	52261
13767	15816	1	applied	\N	\N	\N	\N	52262	52262	52263
13767	15817	2	applied	\N	\N	\N	\N	52264	52264	52265
13767	15818	3	applied	\N	\N	\N	\N	52266	52266	52267
13772	15831	0	applied	\N	\N	\N	\N	52299	52299	52300
13772	15832	1	applied	\N	\N	\N	\N	52301	52301	52302
13772	15833	2	applied	\N	\N	\N	\N	52303	52303	52304
13772	15834	3	applied	\N	\N	\N	\N	52305	52305	52306
13778	15835	0	applied	\N	\N	\N	\N	52311	52311	52312
13778	15836	1	applied	\N	\N	\N	\N	52313	52313	52314
13778	15837	2	applied	\N	\N	\N	\N	52315	52315	52316
13778	15838	3	applied	\N	\N	\N	\N	52317	52317	52318
13778	15839	4	applied	\N	\N	\N	\N	52319	52319	52320
13778	15840	5	applied	\N	\N	\N	\N	52321	52321	52322
13778	15841	6	applied	\N	\N	\N	\N	52323	52323	52324
13778	15842	7	applied	\N	\N	\N	\N	52325	52325	52326
13778	15843	8	applied	\N	\N	\N	\N	52327	52327	52328
13778	15844	9	applied	\N	\N	\N	\N	52329	52329	52330
13778	15845	10	applied	\N	\N	\N	\N	52331	52331	52332
13778	15846	11	applied	\N	\N	\N	\N	52333	52333	52334
13778	15847	12	applied	\N	\N	\N	\N	52335	52335	52336
13778	15848	13	applied	\N	\N	\N	\N	52337	52337	52338
13778	15849	14	applied	\N	\N	\N	\N	52339	52339	52340
13778	15850	15	applied	\N	\N	\N	\N	52341	52341	52342
13782	15851	0	applied	\N	\N	\N	\N	52346	52346	52347
13782	15852	1	applied	\N	\N	\N	\N	52350	52350	52351
13782	15853	2	applied	\N	\N	\N	\N	52352	52352	52353
13782	15854	3	applied	\N	\N	\N	\N	52354	52354	52355
13788	15866	0	applied	\N	\N	\N	\N	52384	52384	52385
13788	15867	1	applied	\N	\N	\N	\N	52386	52386	52387
13788	15868	2	applied	\N	\N	\N	\N	52388	52388	52389
13788	15869	3	applied	\N	\N	\N	\N	52390	52390	52391
13788	15870	4	applied	\N	\N	\N	\N	52392	52392	52393
13788	15871	5	applied	\N	\N	\N	\N	52394	52394	52395
13788	15872	6	applied	\N	\N	\N	\N	52396	52396	52397
13788	15873	7	applied	\N	\N	\N	\N	52398	52398	52399
13789	15866	0	applied	\N	\N	\N	\N	52384	52384	52385
13789	15867	1	applied	\N	\N	\N	\N	52386	52386	52387
13789	15868	2	applied	\N	\N	\N	\N	52388	52388	52389
13789	15869	3	applied	\N	\N	\N	\N	52390	52390	52391
13789	15870	4	applied	\N	\N	\N	\N	52392	52392	52393
13789	15871	5	applied	\N	\N	\N	\N	52394	52394	52395
13789	15872	6	applied	\N	\N	\N	\N	52396	52396	52397
13789	15873	7	applied	\N	\N	\N	\N	52398	52398	52399
13745	15749	4	applied	\N	\N	\N	\N	52086	52086	52087
13751	15776	0	applied	\N	\N	\N	\N	52152	52152	52153
13751	15777	1	applied	\N	\N	\N	\N	52154	52154	52155
13751	15778	2	applied	\N	\N	\N	\N	52156	52156	52157
13751	15779	3	applied	\N	\N	\N	\N	52158	52158	52159
13751	15780	4	applied	\N	\N	\N	\N	52160	52160	52161
13751	15781	5	applied	\N	\N	\N	\N	52162	52162	52163
13751	15782	6	applied	\N	\N	\N	\N	52164	52164	52165
13752	15783	0	applied	\N	\N	\N	\N	52170	52170	52171
13752	15784	1	applied	\N	\N	\N	\N	52172	52172	52173
13752	15785	2	applied	\N	\N	\N	\N	52174	52174	52175
13752	15786	3	applied	\N	\N	\N	\N	52176	52176	52177
13756	15795	0	applied	\N	\N	\N	\N	52201	52201	52202
13756	15796	1	applied	\N	\N	\N	\N	52203	52203	52204
13756	15797	2	applied	\N	\N	\N	\N	52205	52205	52206
13756	15798	3	applied	\N	\N	\N	\N	52207	52207	52208
13756	15799	4	applied	\N	\N	\N	\N	52209	52209	52210
13756	15800	5	applied	\N	\N	\N	\N	52211	52211	52212
13756	15801	6	applied	\N	\N	\N	\N	52213	52213	52214
13756	15802	7	applied	\N	\N	\N	\N	52215	52215	52216
13758	15795	0	applied	\N	\N	\N	\N	52201	52201	52202
13758	15796	1	applied	\N	\N	\N	\N	52203	52203	52204
13758	15797	2	applied	\N	\N	\N	\N	52205	52205	52206
13758	15798	3	applied	\N	\N	\N	\N	52207	52207	52208
13758	15799	4	applied	\N	\N	\N	\N	52209	52209	52210
13758	15800	5	applied	\N	\N	\N	\N	52211	52211	52212
13758	15801	6	applied	\N	\N	\N	\N	52213	52213	52214
13758	15802	7	applied	\N	\N	\N	\N	52215	52215	52216
13762	15803	0	applied	\N	\N	\N	\N	52226	52226	52227
13762	15804	1	applied	\N	\N	\N	\N	52230	52230	52231
13762	15805	2	applied	\N	\N	\N	\N	52232	52232	52233
13762	15806	3	applied	\N	\N	\N	\N	52234	52234	52235
13764	15807	0	applied	\N	\N	\N	\N	52237	52237	52238
13764	15808	1	applied	\N	\N	\N	\N	52239	52239	52240
13764	15809	2	applied	\N	\N	\N	\N	52241	52241	52242
13764	15810	3	applied	\N	\N	\N	\N	52243	52243	52244
13781	15667	0	applied	\N	\N	1000000000	\N	51883	51883	51884
13781	15676	1	applied	\N	\N	\N	\N	51904	51904	51905
13781	15614	2	applied	\N	\N	\N	\N	51724	51724	51725
13781	15616	3	applied	\N	\N	\N	\N	51731	51731	51732
13781	15617	4	applied	\N	\N	\N	\N	51733	51733	51734
13781	15618	5	applied	\N	\N	\N	\N	51735	51735	51736
13781	15619	6	applied	\N	\N	\N	\N	51737	51737	37391
13781	15623	7	applied	\N	\N	\N	\N	51745	51745	51746
13781	15627	8	applied	\N	\N	\N	\N	51759	51759	51760
13781	15629	9	applied	\N	\N	\N	\N	51766	51766	51767
13781	15630	10	applied	\N	\N	\N	\N	51768	51768	51769
13781	15625	11	applied	\N	\N	\N	\N	51754	51754	37393
13781	15633	12	applied	\N	\N	\N	\N	51785	51785	51786
13781	15634	13	applied	\N	\N	\N	\N	51787	51787	51788
13781	15635	14	applied	\N	\N	\N	\N	51789	51789	51790
13781	15639	15	applied	\N	\N	\N	\N	51799	51799	51800
13781	15641	16	applied	\N	\N	\N	\N	51805	51805	51806
13781	15643	17	applied	\N	\N	\N	\N	51809	51809	51810
13781	15645	18	applied	\N	\N	\N	\N	51815	51815	51816
13781	15647	19	applied	\N	\N	\N	\N	51821	51821	51822
13781	15648	20	applied	\N	\N	\N	\N	51823	51823	51824
13781	15651	21	applied	\N	\N	\N	\N	51837	51837	51838
13781	15653	22	applied	\N	\N	\N	\N	51843	51843	51844
13781	15654	23	applied	\N	\N	\N	\N	51845	51845	51846
13781	15657	24	applied	\N	\N	\N	\N	51853	51853	51854
13781	15659	25	applied	\N	\N	\N	\N	51859	51859	51860
13781	15663	26	applied	\N	\N	\N	\N	51869	51869	51870
13781	15668	27	applied	\N	\N	\N	\N	51885	51885	51886
13781	15669	28	applied	\N	\N	\N	\N	51887	51887	51888
13781	15677	29	applied	\N	\N	\N	\N	51906	51906	51907
13781	15678	30	applied	\N	\N	\N	\N	51908	51908	51909
13781	15685	31	applied	\N	\N	\N	\N	51923	51923	51924
13781	15686	32	applied	\N	\N	\N	\N	51925	51925	51926
13781	15694	33	applied	\N	\N	\N	\N	51941	51941	51942
13781	15695	34	applied	\N	\N	\N	\N	51943	51943	51944
13781	15701	35	applied	\N	\N	\N	\N	51957	51957	51958
13781	15705	36	applied	\N	\N	\N	\N	51970	51970	51971
13781	15709	37	applied	\N	\N	\N	\N	51980	51980	51981
13781	15713	38	applied	\N	\N	\N	\N	51990	51990	51991
13781	15718	39	applied	\N	\N	\N	\N	52003	52003	52004
13781	15722	40	applied	\N	\N	\N	\N	52014	52014	52015
13781	15726	41	applied	\N	\N	\N	\N	52024	52024	52025
13781	15730	42	applied	\N	\N	\N	\N	52034	52034	52035
13781	15734	43	applied	\N	\N	\N	\N	52044	52044	52045
13781	15738	44	applied	\N	\N	\N	\N	52056	52056	52057
13781	15741	45	applied	\N	\N	\N	\N	52066	52066	52067
13781	15745	46	applied	\N	\N	\N	\N	52078	52078	52079
13781	15746	47	applied	\N	\N	\N	\N	52080	52080	52081
13781	15747	48	applied	\N	\N	\N	\N	52082	52082	52083
13781	15748	49	applied	\N	\N	\N	\N	52084	52084	52085
13781	15749	50	applied	\N	\N	\N	\N	52086	52086	52087
13781	15765	51	applied	\N	\N	\N	\N	52124	52124	52125
13781	15769	52	applied	\N	\N	\N	\N	52134	52134	52135
13781	15770	53	applied	\N	\N	\N	\N	52136	52136	52137
13781	15776	54	applied	\N	\N	\N	\N	52152	52152	52153
13781	15783	55	applied	\N	\N	\N	\N	52170	52170	52171
13781	15787	56	applied	\N	\N	\N	\N	52180	52180	52181
13781	15791	57	applied	\N	\N	\N	\N	52192	52192	52193
13781	15795	58	applied	\N	\N	\N	\N	52201	52201	52202
13781	15796	60	applied	\N	\N	\N	\N	52203	52203	52204
13781	15803	61	applied	\N	\N	\N	\N	52226	52226	52227
13781	15807	62	applied	\N	\N	\N	\N	52237	52237	52238
13781	15811	63	applied	\N	\N	\N	\N	52249	52249	52250
13781	15815	64	applied	\N	\N	\N	\N	52260	52260	52261
13781	15819	65	applied	\N	\N	\N	\N	52270	52270	52271
13781	15820	66	applied	\N	\N	\N	\N	52272	52272	52273
13781	15827	67	applied	\N	\N	\N	\N	52288	52288	52289
13781	15831	68	applied	\N	\N	\N	\N	52299	52299	52300
13781	15835	69	applied	\N	\N	\N	\N	52311	52311	52312
13781	15836	70	applied	\N	\N	\N	\N	52313	52313	52314
13781	15837	71	applied	\N	\N	\N	\N	52315	52315	52316
13781	15838	72	applied	\N	\N	\N	\N	52317	52317	52318
13781	15851	73	applied	\N	\N	\N	\N	52346	52346	52347
13781	15615	74	applied	\N	\N	\N	\N	51726	51726	51727
13781	15620	75	applied	\N	\N	\N	\N	51738	51738	51739
13781	15621	76	applied	\N	\N	\N	\N	51740	51740	51741
13781	15622	77	applied	\N	\N	\N	\N	51742	51742	51743
13781	15624	78	applied	\N	\N	\N	\N	51747	51747	51748
13781	15626	79	applied	\N	\N	\N	\N	51755	51755	51756
13781	15628	80	applied	\N	\N	\N	\N	51761	51761	51762
13781	15631	81	applied	\N	\N	\N	\N	51770	51770	51771
13781	15632	82	applied	\N	\N	\N	\N	51772	51772	51773
13781	15636	83	applied	\N	\N	\N	\N	51791	51791	51792
13781	15637	84	applied	\N	\N	\N	\N	51793	51793	51794
13748	15775	6	applied	\N	\N	\N	\N	52146	52146	52147
13754	15787	0	applied	\N	\N	\N	\N	52180	52180	52181
13754	15788	1	applied	\N	\N	\N	\N	52182	52182	52183
13754	15789	2	applied	\N	\N	\N	\N	52184	52184	52185
13754	15790	3	applied	\N	\N	\N	\N	52186	52186	52187
13755	15791	0	applied	\N	\N	\N	\N	52192	52192	52193
13755	15792	1	applied	\N	\N	\N	\N	52194	52194	52195
13755	15793	2	applied	\N	\N	\N	\N	52196	52196	52197
13755	15794	3	applied	\N	\N	\N	\N	52198	52198	52199
13760	15795	0	applied	\N	\N	\N	\N	52201	52201	52202
13760	15796	1	applied	\N	\N	\N	\N	52203	52203	52204
13760	15797	2	applied	\N	\N	\N	\N	52205	52205	52206
13763	15807	0	applied	\N	\N	\N	\N	52237	52237	52238
13763	15808	1	applied	\N	\N	\N	\N	52239	52239	52240
13763	15809	2	applied	\N	\N	\N	\N	52241	52241	52242
13763	15810	3	applied	\N	\N	\N	\N	52243	52243	52244
13765	15811	0	applied	\N	\N	\N	\N	52249	52249	52250
13765	15812	1	applied	\N	\N	\N	\N	52251	52251	52252
13765	15813	2	applied	\N	\N	\N	\N	52253	52253	52254
13765	15814	3	applied	\N	\N	\N	\N	52255	52255	52256
13768	15819	0	applied	\N	\N	\N	\N	52270	52270	52271
13768	15820	1	applied	\N	\N	\N	\N	52272	52272	52273
13768	15821	2	applied	\N	\N	\N	\N	52274	52274	52275
13768	15822	3	applied	\N	\N	\N	\N	52276	52276	52277
13768	15823	4	applied	\N	\N	\N	\N	52278	52278	52279
13768	15824	5	applied	\N	\N	\N	\N	52280	52280	52281
13768	15825	6	applied	\N	\N	\N	\N	52282	52282	52283
13768	15826	7	applied	\N	\N	\N	\N	52284	52284	52285
13770	15827	0	applied	\N	\N	\N	\N	52288	52288	52289
13773	15831	0	applied	\N	\N	\N	\N	52299	52299	52300
13773	15832	1	applied	\N	\N	\N	\N	52301	52301	52302
13773	15833	2	applied	\N	\N	\N	\N	52303	52303	52304
13773	15834	3	applied	\N	\N	\N	\N	52305	52305	52306
13785	15861	0	applied	\N	\N	\N	\N	52372	52372	52373
13785	15862	1	applied	\N	\N	1000000000	\N	52374	52374	52375
13785	15863	2	applied	\N	\N	\N	\N	52376	52376	52377
13785	15864	3	applied	\N	\N	\N	\N	52378	52378	52379
13785	15865	4	applied	\N	\N	\N	\N	52380	52380	52381
13794	15879	0	applied	\N	\N	\N	\N	52421	52421	52422
13796	15883	0	applied	\N	\N	\N	\N	52434	52434	52435
13796	15884	1	applied	\N	\N	\N	\N	52436	52436	52437
13796	15885	2	applied	\N	\N	\N	\N	52438	52438	52439
13796	15886	3	applied	\N	\N	\N	\N	52440	52440	52441
13796	15887	4	applied	\N	\N	\N	\N	52442	52442	52443
13801	15892	0	applied	\N	\N	\N	\N	52460	52460	52461
13801	15893	1	applied	\N	\N	\N	\N	52462	52462	52463
13801	15894	2	applied	\N	\N	\N	\N	52464	52464	52465
13801	15895	3	applied	\N	\N	\N	\N	52466	52466	52467
13801	15896	4	applied	\N	\N	\N	\N	52468	52468	52469
13801	15897	5	applied	\N	\N	1000000000	\N	52470	52470	52471
13801	15898	6	applied	\N	\N	1000000000	\N	52472	52472	52473
13801	15899	7	applied	\N	\N	\N	\N	52474	52474	52475
13801	15900	8	applied	\N	\N	\N	\N	52476	52476	52477
13801	15901	9	applied	\N	\N	\N	\N	52478	52478	52479
13803	15902	0	applied	\N	\N	\N	\N	52481	52481	52482
13803	15903	1	applied	\N	\N	\N	\N	52483	52483	52484
13803	15904	2	applied	\N	\N	\N	\N	52485	52485	52486
13803	15905	3	applied	\N	\N	\N	\N	52487	52487	52488
13806	15912	0	applied	\N	\N	\N	\N	52507	52507	52508
13810	15918	0	applied	\N	\N	\N	\N	52525	52525	52526
13810	15919	1	applied	\N	\N	\N	\N	52527	52527	52438
13810	15920	2	applied	\N	\N	\N	\N	52528	52528	52529
13810	15921	3	applied	\N	\N	\N	\N	52530	52530	52531
13810	15922	4	applied	\N	\N	\N	\N	52532	52532	52533
13813	15923	0	applied	\N	\N	\N	\N	52538	52538	52539
13813	15924	1	applied	\N	\N	\N	\N	52540	52540	52541
13813	15925	2	applied	\N	\N	\N	\N	52542	52542	52543
13813	15926	3	applied	\N	\N	\N	\N	52544	52544	52545
13813	15927	4	applied	\N	\N	\N	\N	52546	52546	52547
13813	15928	5	applied	\N	\N	\N	\N	52548	52548	52549
13813	15929	6	applied	\N	\N	\N	\N	52550	52550	52551
13813	15930	7	applied	\N	\N	\N	\N	52552	52552	52553
13815	15931	0	applied	\N	\N	\N	\N	52557	52557	52558
13815	15932	2	applied	\N	\N	\N	\N	52560	52560	52561
13815	15933	3	applied	\N	\N	\N	\N	52562	52562	52563
13815	15934	4	applied	\N	\N	\N	\N	52564	52564	52565
13821	15952	0	applied	\N	\N	\N	\N	52611	52611	52612
13821	15953	1	applied	\N	\N	\N	\N	52613	52613	52614
13821	15954	2	applied	\N	\N	\N	\N	52615	52615	52616
13821	15955	3	applied	\N	\N	\N	\N	52617	52617	52618
13821	15956	4	applied	\N	\N	\N	\N	52619	52619	52620
13821	15957	5	applied	\N	\N	\N	\N	52621	52621	52622
13821	15958	6	applied	\N	\N	\N	\N	52623	52623	52624
13823	15959	0	applied	\N	\N	\N	\N	52631	52631	52632
13823	15960	1	applied	\N	\N	\N	\N	52633	52633	52634
13823	15961	2	applied	\N	\N	\N	\N	52635	52635	52636
13823	15962	3	applied	\N	\N	\N	\N	52637	52637	52638
13823	15963	4	applied	\N	\N	\N	\N	52639	52639	52640
13823	15964	5	applied	\N	\N	\N	\N	52641	52641	52642
13823	15965	6	applied	\N	\N	\N	\N	52643	52643	52644
13834	16022	0	applied	\N	\N	\N	\N	52770	52770	52771
13834	16023	1	applied	\N	\N	\N	\N	52773	52773	52774
13834	16024	2	applied	\N	\N	\N	\N	52775	52775	52776
13841	16033	0	applied	\N	\N	\N	\N	52803	52803	52804
13841	16034	1	applied	\N	\N	\N	\N	52805	52805	52806
13841	16035	3	applied	\N	\N	\N	\N	52808	52808	52809
13841	16036	4	applied	\N	\N	\N	\N	52810	52810	52811
13841	16037	5	applied	\N	\N	\N	\N	52812	52812	52813
13841	16038	6	applied	\N	\N	\N	\N	52814	52814	52815
13841	16039	7	applied	\N	\N	\N	\N	52816	52816	52817
13841	16040	8	applied	\N	\N	\N	\N	52818	52818	52819
13845	16041	0	applied	\N	\N	\N	\N	52821	52821	52822
13845	16042	1	applied	\N	\N	\N	\N	52823	52823	52824
13845	16043	2	applied	\N	\N	\N	\N	52825	52825	52826
13845	16044	3	applied	\N	\N	\N	\N	52827	52827	52828
13845	16045	4	applied	\N	\N	\N	\N	52829	52829	52830
13850	16061	0	applied	\N	\N	\N	\N	52870	52870	52871
13857	16077	0	applied	\N	\N	\N	\N	52911	52911	52912
13857	16078	1	applied	\N	\N	\N	\N	52913	52913	52914
13857	16079	2	applied	\N	\N	\N	\N	52915	52915	52916
13857	16080	3	applied	\N	\N	\N	\N	52917	52917	52918
13860	16085	0	applied	\N	\N	\N	\N	52931	52931	52932
13860	16086	1	applied	\N	\N	\N	\N	52933	52933	52934
13860	16087	2	applied	\N	\N	\N	\N	52935	52935	52936
13860	16088	3	applied	\N	\N	\N	\N	52937	52937	52938
13862	16089	0	applied	\N	\N	\N	\N	52943	52943	52944
13862	16086	1	applied	\N	\N	\N	\N	52933	52933	52934
13862	16087	2	applied	\N	\N	\N	\N	52935	52935	52936
13862	16088	3	applied	\N	\N	\N	\N	52937	52937	52938
13776	15848	13	applied	\N	\N	\N	\N	52337	52337	52338
13776	15849	14	applied	\N	\N	\N	\N	52339	52339	52340
13776	15850	15	applied	\N	\N	\N	\N	52341	52341	52342
13783	15855	0	applied	\N	\N	\N	\N	52357	52357	52358
13783	15856	1	applied	\N	\N	\N	\N	52359	52359	52360
13783	15857	2	applied	\N	\N	\N	\N	52361	52361	52362
13783	15858	3	applied	\N	\N	\N	\N	52363	52363	52364
13783	15859	4	applied	\N	\N	\N	\N	52365	52365	52366
13783	15860	5	applied	\N	\N	\N	\N	52367	52367	52368
13786	15866	0	applied	\N	\N	\N	\N	52384	52384	52385
13786	15867	1	applied	\N	\N	\N	\N	52386	52386	52387
13786	15868	2	applied	\N	\N	\N	\N	52388	52388	52389
13786	15869	3	applied	\N	\N	\N	\N	52390	52390	52391
13786	15870	4	applied	\N	\N	\N	\N	52392	52392	52393
13786	15871	5	applied	\N	\N	\N	\N	52394	52394	52395
13786	15872	6	applied	\N	\N	\N	\N	52396	52396	52397
13786	15873	7	applied	\N	\N	\N	\N	52398	52398	52399
13790	15874	0	applied	\N	\N	\N	\N	52407	52407	52408
13790	15875	1	applied	\N	\N	\N	\N	52409	52409	52410
13790	15876	2	applied	\N	\N	\N	\N	52411	52411	52412
13790	15877	3	applied	\N	\N	\N	\N	52413	52413	52414
13790	15878	4	applied	\N	\N	\N	\N	52415	52415	52416
13795	15879	0	applied	\N	\N	\N	\N	52421	52421	52422
13795	15880	1	applied	\N	\N	\N	\N	52423	52423	52424
13795	15881	2	applied	\N	\N	\N	\N	52425	52425	52426
13795	15882	3	applied	\N	\N	\N	\N	52427	52427	52428
13797	15883	0	applied	\N	\N	\N	\N	52434	52434	52435
13797	15884	1	applied	\N	\N	\N	\N	52436	52436	52437
13797	15886	2	applied	\N	\N	\N	\N	52440	52440	52441
13797	15887	3	applied	\N	\N	\N	\N	52442	52442	52443
13799	15888	0	applied	\N	\N	\N	\N	52448	52448	52449
13799	15889	1	applied	\N	\N	\N	\N	52450	52450	52451
13799	15890	2	applied	\N	\N	\N	\N	52452	52452	52453
13799	15891	3	applied	\N	\N	\N	\N	52454	52454	52455
13804	15906	0	applied	\N	\N	\N	\N	52493	52493	52494
13804	15907	1	applied	\N	\N	\N	\N	52495	52495	52496
13804	15908	2	applied	\N	\N	\N	\N	52497	52497	52498
13804	15909	3	applied	\N	\N	\N	\N	52499	52499	52500
13804	15910	4	applied	\N	\N	\N	\N	52501	52501	52502
13807	15912	0	applied	\N	\N	\N	\N	52507	52507	52508
13807	15911	1	applied	\N	\N	\N	\N	52504	52504	52505
13807	15913	2	applied	\N	\N	\N	\N	52511	52511	52512
13807	15914	3	applied	\N	\N	\N	\N	52513	52513	52514
13807	15915	4	applied	\N	\N	\N	\N	52515	52515	52516
13807	15916	5	applied	\N	\N	\N	\N	52517	52517	52518
13807	15917	6	applied	\N	\N	\N	\N	52519	52519	52520
13811	15918	0	applied	\N	\N	\N	\N	52525	52525	52526
13811	15919	1	applied	\N	\N	\N	\N	52527	52527	52438
13811	15920	2	applied	\N	\N	\N	\N	52528	52528	52529
13811	15921	3	applied	\N	\N	\N	\N	52530	52530	52531
13811	15922	4	applied	\N	\N	\N	\N	52532	52532	52533
13816	15931	0	applied	\N	\N	\N	\N	52557	52557	52558
13816	15935	2	applied	\N	\N	\N	\N	52569	52569	52570
13816	15936	3	applied	\N	\N	\N	\N	52571	52571	52572
13816	15937	4	applied	\N	\N	\N	\N	52573	52573	52574
13824	15966	0	applied	\N	\N	\N	\N	52647	52647	52648
13824	15967	1	applied	\N	\N	\N	\N	52649	52649	52650
13824	15968	2	applied	\N	\N	\N	\N	52651	52651	52652
13826	15966	0	applied	\N	\N	\N	\N	52647	52647	52648
13826	15967	1	applied	\N	\N	\N	\N	52649	52649	52650
13826	15968	2	applied	\N	\N	\N	\N	52651	52651	52652
13826	15969	3	applied	\N	\N	\N	\N	52655	52655	52656
13826	15970	4	applied	\N	\N	\N	\N	52657	52657	52658
13826	15971	5	applied	\N	\N	\N	\N	52659	52659	52660
13826	15972	6	applied	\N	\N	\N	\N	52661	52661	52662
13826	15973	7	applied	\N	\N	\N	\N	52663	52663	52664
13826	15974	8	applied	\N	\N	\N	\N	52665	52665	52666
13826	15975	9	applied	\N	\N	\N	\N	52667	52667	52668
13826	15976	10	applied	\N	\N	\N	\N	52669	52669	52670
13826	15977	11	applied	\N	\N	\N	\N	52671	52671	52672
13827	15978	0	applied	\N	\N	\N	\N	52674	52674	52675
13827	15979	1	applied	\N	\N	\N	\N	52676	52676	52677
13827	15980	2	applied	\N	\N	\N	\N	52678	52678	52679
13827	15981	3	applied	\N	\N	\N	\N	52680	52680	52681
13827	15982	4	applied	\N	\N	\N	\N	52682	52682	52683
13827	15983	5	applied	\N	\N	\N	\N	52684	52684	52685
13827	15984	6	applied	\N	\N	\N	\N	52686	52686	52687
13827	15985	7	applied	\N	\N	\N	\N	52688	52688	52689
13827	15986	8	applied	\N	\N	\N	\N	52690	52690	52691
13827	15987	9	applied	\N	\N	\N	\N	52692	52692	52693
13827	15988	10	applied	\N	\N	\N	\N	52694	52694	52695
13827	15989	11	applied	\N	\N	\N	\N	52696	52696	52697
13827	15990	12	applied	\N	\N	\N	\N	52698	52698	52699
13827	15991	13	applied	\N	\N	\N	\N	52700	52700	52701
13827	15992	14	applied	\N	\N	\N	\N	52702	52702	52703
13827	15993	15	applied	\N	\N	\N	\N	52704	52704	52705
13832	16018	0	applied	\N	\N	\N	\N	52760	52760	52761
13832	16001	1	applied	\N	\N	\N	\N	52723	52723	52724
13832	16002	2	applied	\N	\N	\N	\N	52725	52725	52726
13832	16003	3	applied	\N	\N	\N	\N	52727	52727	52728
13832	16004	4	applied	\N	\N	\N	\N	52729	52729	52730
13832	16005	5	applied	\N	\N	\N	\N	52731	52731	52732
13832	16006	6	applied	\N	\N	\N	\N	52733	52733	52734
13832	16007	7	applied	\N	\N	\N	\N	52735	52735	52736
13832	16008	8	applied	\N	\N	\N	\N	52737	52737	52738
13832	16009	9	applied	\N	\N	\N	\N	52739	52739	52740
13832	16010	10	applied	\N	\N	\N	\N	52741	52741	52742
13832	16011	11	applied	\N	\N	\N	\N	52743	52743	52744
13832	16012	12	applied	\N	\N	\N	\N	52745	52745	52746
13832	16013	13	applied	\N	\N	\N	\N	52747	52747	52748
13832	16014	14	applied	\N	\N	\N	\N	52749	52749	52750
13832	16015	15	applied	\N	\N	\N	\N	52751	52751	52752
13832	16016	16	applied	\N	\N	\N	\N	52753	52753	52754
13832	16017	17	applied	\N	\N	\N	\N	52755	52755	52756
13832	16019	18	applied	\N	\N	\N	\N	52762	52762	52763
13832	16020	19	applied	\N	\N	\N	\N	52764	52764	52765
13832	16021	20	applied	\N	\N	\N	\N	52766	52766	52767
13836	16022	0	applied	\N	\N	\N	\N	52770	52770	52771
13836	16023	1	applied	\N	\N	\N	\N	52773	52773	52774
13836	16024	2	applied	\N	\N	\N	\N	52775	52775	52776
13846	16041	0	applied	\N	\N	\N	\N	52821	52821	52822
13846	16042	1	applied	\N	\N	\N	\N	52823	52823	52824
13846	16043	2	applied	\N	\N	\N	\N	52825	52825	52826
13846	16044	3	applied	\N	\N	\N	\N	52827	52827	52828
13846	16045	4	applied	\N	\N	\N	\N	52829	52829	52830
13846	16046	5	applied	\N	\N	\N	\N	52831	52831	52832
13846	16047	6	applied	\N	\N	\N	\N	52833	52833	52834
13846	16048	7	applied	\N	\N	\N	\N	52835	52835	52836
13846	16049	8	applied	\N	\N	\N	\N	52837	52837	52838
13846	16050	9	applied	\N	\N	\N	\N	52839	52839	52840
13781	15638	85	applied	\N	\N	\N	\N	51795	51795	51796
13781	15640	86	applied	\N	\N	\N	\N	51801	51801	51802
13781	15642	87	applied	\N	\N	\N	\N	51807	51807	51808
13781	15644	88	applied	\N	\N	\N	\N	51811	51811	51812
13781	15646	89	applied	\N	\N	\N	\N	51817	51817	51818
13781	15649	90	applied	\N	\N	\N	\N	51825	51825	51826
13781	15650	91	applied	\N	\N	\N	\N	51827	51827	51828
13781	15652	92	applied	\N	\N	\N	\N	51839	51839	51840
13781	15655	93	applied	\N	\N	\N	\N	51847	51847	51848
13781	15656	94	applied	\N	\N	\N	\N	51849	51849	51850
13781	15658	95	applied	\N	\N	\N	\N	51855	51855	51856
13781	15660	96	applied	\N	\N	\N	\N	51861	51861	51862
13781	15661	97	applied	\N	\N	\N	\N	51863	51863	51864
13781	15662	98	applied	\N	\N	\N	\N	51865	51865	51866
13781	15664	99	applied	\N	\N	\N	\N	51871	51871	51872
13781	15665	100	applied	\N	\N	\N	\N	51873	51873	51874
13781	15666	101	applied	\N	\N	\N	\N	51875	51875	51876
13781	15670	102	applied	\N	\N	\N	\N	51889	51889	51890
13781	15671	103	applied	\N	\N	\N	\N	51891	51891	51892
13781	15672	104	applied	\N	\N	\N	\N	51893	51893	51894
13781	15673	105	applied	\N	\N	\N	\N	51895	51895	51896
13781	15674	106	applied	\N	\N	\N	\N	51897	51897	51898
13781	15675	107	applied	\N	\N	\N	\N	51899	51899	51900
13781	15679	108	applied	\N	\N	\N	\N	51910	51910	51911
13781	15680	109	applied	\N	\N	\N	\N	51912	51912	51913
13781	15681	110	applied	\N	\N	\N	\N	51914	51914	51915
13781	15682	111	applied	\N	\N	\N	\N	51916	51916	51917
13781	15683	112	applied	\N	\N	\N	\N	51918	51918	51919
13781	15684	113	applied	\N	\N	\N	\N	51920	51920	51921
13781	15687	114	applied	\N	\N	\N	\N	51927	51927	51928
13781	15688	115	applied	\N	\N	\N	\N	51929	51929	51930
13781	15689	116	applied	\N	\N	\N	\N	51931	51931	51932
13781	15690	117	applied	\N	\N	\N	\N	51933	51933	51934
13781	15691	118	applied	\N	\N	\N	\N	51935	51935	51936
13781	15692	119	applied	\N	\N	\N	\N	51937	51937	51938
13781	15696	120	applied	\N	\N	\N	\N	51945	51945	51946
13781	15697	121	applied	\N	\N	\N	\N	51947	51947	51948
13781	15698	122	applied	\N	\N	\N	\N	51949	51949	51950
13781	15699	123	applied	\N	\N	\N	\N	51951	51951	51952
13781	15700	124	applied	\N	\N	\N	\N	51953	51953	51954
13781	15702	125	applied	\N	\N	\N	\N	51959	51959	51960
13784	15855	0	applied	\N	\N	\N	\N	52357	52357	52358
13784	15856	1	applied	\N	\N	\N	\N	52359	52359	52360
13784	15857	2	applied	\N	\N	\N	\N	52361	52361	52362
13784	15858	3	applied	\N	\N	\N	\N	52363	52363	52364
13784	15859	4	applied	\N	\N	\N	\N	52365	52365	52366
13784	15860	5	applied	\N	\N	\N	\N	52367	52367	52368
13787	15866	0	applied	\N	\N	\N	\N	52384	52384	52385
13787	15867	1	applied	\N	\N	\N	\N	52386	52386	52387
13787	15868	2	applied	\N	\N	\N	\N	52388	52388	52389
13787	15869	3	applied	\N	\N	\N	\N	52390	52390	52391
13787	15870	4	applied	\N	\N	\N	\N	52392	52392	52393
13787	15871	5	applied	\N	\N	\N	\N	52394	52394	52395
13787	15872	6	applied	\N	\N	\N	\N	52396	52396	52397
13787	15873	7	applied	\N	\N	\N	\N	52398	52398	52399
13791	15874	0	applied	\N	\N	\N	\N	52407	52407	52408
13791	15876	1	applied	\N	\N	\N	\N	52411	52411	52412
13791	15877	2	applied	\N	\N	\N	\N	52413	52413	52414
13791	15878	3	applied	\N	\N	\N	\N	52415	52415	52416
13793	15879	0	applied	\N	\N	\N	\N	52421	52421	52422
13793	15880	1	applied	\N	\N	\N	\N	52423	52423	52424
13793	15881	2	applied	\N	\N	\N	\N	52425	52425	52426
13793	15882	3	applied	\N	\N	\N	\N	52427	52427	52428
13798	15883	0	applied	\N	\N	\N	\N	52434	52434	52435
13798	15884	1	applied	\N	\N	\N	\N	52436	52436	52437
13798	15886	2	applied	\N	\N	\N	\N	52440	52440	52441
13798	15887	3	applied	\N	\N	\N	\N	52442	52442	52443
13802	15902	0	applied	\N	\N	\N	\N	52481	52481	52482
13802	15903	1	applied	\N	\N	\N	\N	52483	52483	52484
13802	15904	2	applied	\N	\N	\N	\N	52485	52485	52486
13802	15905	3	applied	\N	\N	\N	\N	52487	52487	52488
13805	15906	0	applied	\N	\N	\N	\N	52493	52493	52494
13805	15907	1	applied	\N	\N	\N	\N	52495	52495	52496
13805	15908	2	applied	\N	\N	\N	\N	52497	52497	52498
13805	15909	3	applied	\N	\N	\N	\N	52499	52499	52500
13805	15910	4	applied	\N	\N	\N	\N	52501	52501	52502
13805	15911	5	applied	\N	\N	\N	\N	52504	52504	52505
13808	15912	0	applied	\N	\N	\N	\N	52507	52507	52508
13808	15911	1	applied	\N	\N	\N	\N	52504	52504	52505
13808	15913	2	applied	\N	\N	\N	\N	52511	52511	52512
13808	15914	3	applied	\N	\N	\N	\N	52513	52513	52514
13808	15915	4	applied	\N	\N	\N	\N	52515	52515	52516
13808	15916	5	applied	\N	\N	\N	\N	52517	52517	52518
13808	15917	6	applied	\N	\N	\N	\N	52519	52519	52520
13809	15912	0	applied	\N	\N	\N	\N	52507	52507	52508
13817	15935	0	applied	\N	\N	\N	\N	52569	52569	52570
13817	15936	1	applied	\N	\N	\N	\N	52571	52571	52572
13817	15937	2	applied	\N	\N	\N	\N	52573	52573	52574
13817	15938	3	applied	\N	\N	\N	\N	52577	52577	52578
13817	15939	4	applied	\N	\N	\N	\N	52579	52579	52580
13817	15940	5	applied	\N	\N	\N	\N	52581	52581	52582
13817	15941	6	applied	\N	\N	\N	\N	52583	52583	52584
13817	15942	7	applied	\N	\N	\N	\N	52585	52585	52586
13817	15943	8	applied	\N	\N	\N	\N	52587	52587	52588
13817	15944	9	applied	\N	\N	\N	\N	52589	52589	52590
13817	15945	10	applied	\N	\N	\N	\N	52591	52591	52592
13817	15946	11	applied	\N	\N	\N	\N	52593	52593	52594
13817	15947	12	applied	\N	\N	\N	\N	52595	52595	52596
13817	15948	13	applied	\N	\N	\N	\N	52597	52597	52598
13817	15949	14	applied	\N	\N	\N	\N	52599	52599	52600
13817	15950	15	applied	\N	\N	\N	\N	52601	52601	52602
13819	15951	0	applied	\N	\N	\N	\N	52607	52607	52608
13828	15994	0	applied	\N	\N	\N	\N	52708	52708	52709
13830	15995	0	applied	\N	\N	\N	\N	52711	52711	52712
13830	15996	1	applied	\N	\N	\N	\N	52713	52713	52714
13830	15997	2	applied	\N	\N	\N	\N	52715	52715	52716
13830	15998	3	applied	\N	\N	\N	\N	52717	52717	52718
13830	15999	4	applied	\N	\N	\N	\N	52719	52719	52720
13830	16000	5	applied	\N	\N	\N	\N	52721	52721	52722
13830	16001	6	applied	\N	\N	\N	\N	52723	52723	52724
13830	16002	7	applied	\N	\N	\N	\N	52725	52725	52726
13830	16003	8	applied	\N	\N	\N	\N	52727	52727	52728
13830	16004	9	applied	\N	\N	\N	\N	52729	52729	52730
13830	16005	10	applied	\N	\N	\N	\N	52731	52731	52732
13830	16006	11	applied	\N	\N	\N	\N	52733	52733	52734
13830	16007	12	applied	\N	\N	\N	\N	52735	52735	52736
13830	16008	13	applied	\N	\N	\N	\N	52737	52737	52738
13830	16009	14	applied	\N	\N	\N	\N	52739	52739	52740
13830	16010	15	applied	\N	\N	\N	\N	52741	52741	52742
13830	16011	16	applied	\N	\N	\N	\N	52743	52743	52744
13792	15874	0	applied	\N	\N	\N	\N	52407	52407	52408
13792	15875	1	applied	\N	\N	\N	\N	52409	52409	52410
13792	15876	2	applied	\N	\N	\N	\N	52411	52411	52412
13792	15877	3	applied	\N	\N	\N	\N	52413	52413	52414
13792	15878	4	applied	\N	\N	\N	\N	52415	52415	52416
13800	15874	0	applied	\N	\N	\N	\N	52407	52407	52408
13800	15879	1	applied	\N	\N	\N	\N	52421	52421	52422
13800	15883	2	applied	\N	\N	\N	\N	52434	52434	52435
13800	15888	3	applied	\N	\N	\N	\N	52448	52448	52449
13800	15885	4	applied	\N	\N	\N	\N	52456	52456	52457
13812	15923	0	applied	\N	\N	\N	\N	52538	52538	52539
13812	15924	1	applied	\N	\N	\N	\N	52540	52540	52541
13812	15925	2	applied	\N	\N	\N	\N	52542	52542	52543
13812	15926	3	applied	\N	\N	\N	\N	52544	52544	52545
13812	15927	4	applied	\N	\N	\N	\N	52546	52546	52547
13812	15928	5	applied	\N	\N	\N	\N	52548	52548	52549
13812	15929	6	applied	\N	\N	\N	\N	52550	52550	52551
13812	15930	7	applied	\N	\N	\N	\N	52552	52552	52553
13814	15923	0	applied	\N	\N	\N	\N	52538	52538	52539
13814	15924	1	applied	\N	\N	\N	\N	52540	52540	52541
13818	15935	0	applied	\N	\N	\N	\N	52569	52569	52570
13818	15936	1	applied	\N	\N	\N	\N	52571	52571	52572
13818	15937	2	applied	\N	\N	\N	\N	52573	52573	52574
13818	15938	3	applied	\N	\N	\N	\N	52577	52577	52578
13818	15939	4	applied	\N	\N	\N	\N	52579	52579	52580
13818	15940	5	applied	\N	\N	\N	\N	52581	52581	52582
13818	15941	6	applied	\N	\N	\N	\N	52583	52583	52584
13818	15942	7	applied	\N	\N	\N	\N	52585	52585	52586
13818	15943	8	applied	\N	\N	\N	\N	52587	52587	52588
13818	15944	9	applied	\N	\N	\N	\N	52589	52589	52590
13818	15945	10	applied	\N	\N	\N	\N	52591	52591	52592
13818	15946	11	applied	\N	\N	\N	\N	52593	52593	52594
13818	15947	12	applied	\N	\N	\N	\N	52595	52595	52596
13818	15948	13	applied	\N	\N	\N	\N	52597	52597	52598
13818	15949	14	applied	\N	\N	\N	\N	52599	52599	52600
13818	15950	15	applied	\N	\N	\N	\N	52601	52601	52602
13820	15952	0	applied	\N	\N	\N	\N	52611	52611	52612
13820	15953	1	applied	\N	\N	\N	\N	52613	52613	52614
13820	15954	2	applied	\N	\N	\N	\N	52615	52615	52616
13820	15955	3	applied	\N	\N	\N	\N	52617	52617	52618
13820	15956	4	applied	\N	\N	\N	\N	52619	52619	52620
13820	15957	5	applied	\N	\N	\N	\N	52621	52621	52622
13820	15958	6	applied	\N	\N	\N	\N	52623	52623	52624
13822	15952	0	applied	\N	\N	\N	\N	52611	52611	52612
13822	15953	1	applied	\N	\N	\N	\N	52613	52613	52614
13822	15954	2	applied	\N	\N	\N	\N	52615	52615	52616
13822	15955	3	applied	\N	\N	\N	\N	52617	52617	52618
13822	15956	4	applied	\N	\N	\N	\N	52619	52619	52620
13822	15957	5	applied	\N	\N	\N	\N	52621	52621	52622
13822	15958	6	applied	\N	\N	\N	\N	52623	52623	52624
13831	15995	0	applied	\N	\N	\N	\N	52711	52711	52712
13831	15996	1	applied	\N	\N	\N	\N	52713	52713	52714
13831	15997	2	applied	\N	\N	\N	\N	52715	52715	52716
13831	15998	3	applied	\N	\N	\N	\N	52717	52717	52718
13831	15999	4	applied	\N	\N	\N	\N	52719	52719	52720
13831	16000	5	applied	\N	\N	\N	\N	52721	52721	52722
13833	16022	0	applied	\N	\N	\N	\N	52770	52770	52771
13835	16022	0	applied	\N	\N	\N	\N	52770	52770	52771
13835	16023	1	applied	\N	\N	\N	\N	52773	52773	52774
13835	16024	2	applied	\N	\N	\N	\N	52775	52775	52776
13838	16018	0	applied	\N	\N	\N	\N	52760	52760	52761
13838	16022	1	applied	\N	\N	\N	\N	52770	52770	52771
13838	16001	2	applied	\N	\N	\N	\N	52723	52723	52724
13838	16002	3	applied	\N	\N	\N	\N	52725	52725	52726
13838	16003	4	applied	\N	\N	\N	\N	52727	52727	52728
13838	16004	5	applied	\N	\N	\N	\N	52729	52729	52730
13838	16005	6	applied	\N	\N	\N	\N	52731	52731	52732
13838	16006	7	applied	\N	\N	\N	\N	52733	52733	52734
13838	16007	8	applied	\N	\N	\N	\N	52735	52735	52736
13838	16008	9	applied	\N	\N	\N	\N	52737	52737	52738
13838	16009	10	applied	\N	\N	\N	\N	52739	52739	52740
13838	16010	11	applied	\N	\N	\N	\N	52741	52741	52742
13838	16011	12	applied	\N	\N	\N	\N	52743	52743	52744
13838	16012	13	applied	\N	\N	\N	\N	52745	52745	52746
13838	16013	14	applied	\N	\N	\N	\N	52747	52747	52748
13838	16014	15	applied	\N	\N	\N	\N	52749	52749	52750
13838	16015	16	applied	\N	\N	\N	\N	52751	52751	52752
13838	16016	17	applied	\N	\N	\N	\N	52753	52753	52754
13838	16017	18	applied	\N	\N	\N	\N	52755	52755	52756
13838	16019	19	applied	\N	\N	\N	\N	52762	52762	52763
13840	16033	0	applied	\N	\N	\N	\N	52803	52803	52804
13840	16034	1	applied	\N	\N	\N	\N	52805	52805	52806
13840	16035	3	applied	\N	\N	\N	\N	52808	52808	52809
13840	16036	4	applied	\N	\N	\N	\N	52810	52810	52811
13840	16037	5	applied	\N	\N	\N	\N	52812	52812	52813
13840	16038	6	applied	\N	\N	\N	\N	52814	52814	52815
13840	16039	7	applied	\N	\N	\N	\N	52816	52816	52817
13840	16040	8	applied	\N	\N	\N	\N	52818	52818	52819
13844	16041	0	applied	\N	\N	\N	\N	52821	52821	52822
13844	16042	1	applied	\N	\N	\N	\N	52823	52823	52824
13844	16043	2	applied	\N	\N	\N	\N	52825	52825	52826
13844	16044	3	applied	\N	\N	\N	\N	52827	52827	52828
13848	16057	0	applied	\N	\N	\N	\N	52857	52857	52858
13848	16045	1	applied	\N	\N	\N	\N	52829	52829	52830
13848	16046	2	applied	\N	\N	\N	\N	52831	52831	52832
13848	16047	3	applied	\N	\N	\N	\N	52833	52833	52834
13848	16048	4	applied	\N	\N	\N	\N	52835	52835	52836
13848	16049	5	applied	\N	\N	\N	\N	52837	52837	52838
13848	16050	6	applied	\N	\N	\N	\N	52839	52839	52840
13848	16051	7	applied	\N	\N	\N	\N	52841	52841	52842
13848	16052	8	applied	\N	\N	\N	\N	52843	52843	52844
13848	16053	9	applied	\N	\N	\N	\N	52845	52845	52846
13848	16054	10	applied	\N	\N	\N	\N	52847	52847	52848
13848	16055	11	applied	\N	\N	\N	\N	52849	52849	52850
13848	16056	12	applied	\N	\N	\N	\N	52851	52851	52852
13848	16058	13	applied	\N	\N	\N	\N	52861	52861	52862
13848	16059	14	applied	\N	\N	\N	\N	52863	52863	52864
13848	16060	15	applied	\N	\N	\N	\N	52865	52865	52866
13853	16061	0	applied	\N	\N	\N	\N	52870	52870	52871
13854	16065	0	applied	\N	\N	\N	\N	52883	52883	52884
13854	16058	1	applied	\N	\N	\N	\N	52861	52861	52862
13854	16059	2	applied	\N	\N	\N	\N	52863	52863	52864
13854	16060	3	applied	\N	\N	\N	\N	52865	52865	52866
13854	16062	4	applied	\N	\N	\N	\N	52874	52874	52875
13854	16063	5	applied	\N	\N	\N	\N	52876	52876	52877
13854	16064	6	applied	\N	\N	\N	\N	52878	52878	52879
13854	16066	7	applied	\N	\N	\N	\N	52885	52885	52886
13854	16067	8	applied	\N	\N	\N	\N	52887	52887	52888
13854	16068	9	applied	\N	\N	\N	\N	52889	52889	52890
13859	16085	0	applied	\N	\N	\N	\N	52931	52931	52932
13830	16012	17	applied	\N	\N	\N	\N	52745	52745	52746
13830	16013	18	applied	\N	\N	\N	\N	52747	52747	52748
13830	16014	19	applied	\N	\N	\N	\N	52749	52749	52750
13830	16015	20	applied	\N	\N	\N	\N	52751	52751	52752
13830	16016	21	applied	\N	\N	\N	\N	52753	52753	52754
13830	16017	22	applied	\N	\N	\N	\N	52755	52755	52756
13837	15835	0	applied	\N	\N	\N	\N	52311	52311	52312
13837	15836	1	applied	\N	\N	\N	\N	52313	52313	52314
13837	15837	2	applied	\N	\N	\N	\N	52315	52315	52316
13837	15838	3	applied	\N	\N	\N	\N	52317	52317	52318
13837	15851	4	applied	\N	\N	\N	\N	52346	52346	52347
13837	15855	5	applied	\N	\N	\N	\N	52357	52357	52358
13837	15856	6	applied	\N	\N	\N	\N	52359	52359	52360
13837	15861	7	applied	\N	\N	\N	\N	52372	52372	52373
13837	15866	8	applied	\N	\N	\N	\N	52384	52384	52385
13837	15867	9	applied	\N	\N	\N	\N	52386	52386	52387
13837	15874	10	applied	\N	\N	\N	\N	52407	52407	52408
13837	15879	11	applied	\N	\N	\N	\N	52421	52421	52422
13837	15883	12	applied	\N	\N	\N	\N	52434	52434	52435
13837	15888	13	applied	\N	\N	\N	\N	52448	52448	52449
13837	15892	14	applied	\N	\N	\N	\N	52460	52460	52461
13837	15893	15	applied	\N	\N	\N	\N	52462	52462	52463
13837	15902	16	applied	\N	\N	\N	\N	52481	52481	52482
13837	15906	17	applied	\N	\N	\N	\N	52493	52493	52494
13837	15907	18	applied	\N	\N	\N	\N	52495	52495	52496
13837	15912	19	applied	\N	\N	\N	\N	52507	52507	52508
13837	15918	20	applied	\N	\N	\N	\N	52525	52525	52526
13837	15923	21	applied	\N	\N	\N	\N	52538	52538	52539
13837	15924	22	applied	\N	\N	\N	\N	52540	52540	52541
13837	15931	23	applied	\N	\N	\N	\N	52557	52557	52558
13837	15935	24	applied	\N	\N	\N	\N	52569	52569	52570
13837	15936	25	applied	\N	\N	\N	\N	52571	52571	52572
13837	15937	26	applied	\N	\N	\N	\N	52573	52573	52574
13837	15938	27	applied	\N	\N	\N	\N	52577	52577	52578
13837	15951	28	applied	\N	\N	\N	\N	52607	52607	52608
13837	15952	29	applied	\N	\N	\N	\N	52611	52611	52612
13837	15959	30	applied	\N	\N	\N	\N	52631	52631	52632
13837	15960	31	applied	\N	\N	\N	\N	52633	52633	52634
13837	15966	32	applied	\N	\N	\N	\N	52647	52647	52648
13837	15967	33	applied	\N	\N	\N	\N	52649	52649	52650
13837	15968	34	applied	\N	\N	\N	\N	52651	52651	52652
13837	15978	35	applied	\N	\N	\N	\N	52674	52674	52675
13837	15979	36	applied	\N	\N	\N	\N	52676	52676	52677
13837	15980	37	applied	\N	\N	\N	\N	52678	52678	52679
13837	15981	38	applied	\N	\N	\N	\N	52680	52680	52681
13837	15994	39	applied	\N	\N	\N	\N	52708	52708	52709
13837	15995	40	applied	\N	\N	\N	\N	52711	52711	52712
13837	15996	41	applied	\N	\N	\N	\N	52713	52713	52714
13837	15997	42	applied	\N	\N	\N	\N	52715	52715	52716
13837	15998	43	applied	\N	\N	\N	\N	52717	52717	52718
13837	15999	44	applied	\N	\N	\N	\N	52719	52719	52720
13837	16018	45	applied	\N	\N	\N	\N	52760	52760	52761
13837	16022	46	applied	\N	\N	\N	\N	52770	52770	52771
13837	15839	47	applied	\N	\N	\N	\N	52319	52319	52320
13837	15840	48	applied	\N	\N	\N	\N	52321	52321	52322
13837	15841	49	applied	\N	\N	\N	\N	52323	52323	52324
13837	15842	50	applied	\N	\N	\N	\N	52325	52325	52326
13837	15843	51	applied	\N	\N	\N	\N	52327	52327	52328
13837	15844	52	applied	\N	\N	\N	\N	52329	52329	52330
13837	15845	53	applied	\N	\N	\N	\N	52331	52331	52332
13837	15846	54	applied	\N	\N	\N	\N	52333	52333	52334
13837	15847	55	applied	\N	\N	\N	\N	52335	52335	52336
13837	15848	56	applied	\N	\N	\N	\N	52337	52337	52338
13837	15849	57	applied	\N	\N	\N	\N	52339	52339	52340
13837	15850	58	applied	\N	\N	\N	\N	52341	52341	52342
13837	15852	59	applied	\N	\N	\N	\N	52350	52350	52351
13837	15853	60	applied	\N	\N	\N	\N	52352	52352	52353
13837	15854	61	applied	\N	\N	\N	\N	52354	52354	52355
13837	15857	62	applied	\N	\N	\N	\N	52361	52361	52362
13837	15858	63	applied	\N	\N	\N	\N	52363	52363	52364
13837	15859	64	applied	\N	\N	\N	\N	52365	52365	52366
13837	15860	65	applied	\N	\N	\N	\N	52367	52367	52368
13837	15862	66	applied	\N	\N	1000000000	\N	52374	52374	52375
13837	15885	67	applied	\N	\N	\N	\N	52456	52456	52457
13837	15863	68	applied	\N	\N	\N	\N	52376	52376	52377
13837	15864	69	applied	\N	\N	\N	\N	52378	52378	52379
13837	15865	70	applied	\N	\N	\N	\N	52380	52380	52381
13837	15868	71	applied	\N	\N	\N	\N	52388	52388	52389
13837	15869	72	applied	\N	\N	\N	\N	52390	52390	52391
13837	15870	73	applied	\N	\N	\N	\N	52392	52392	52393
13837	15871	74	applied	\N	\N	\N	\N	52394	52394	52395
13837	15872	75	applied	\N	\N	\N	\N	52396	52396	52397
13837	15873	76	applied	\N	\N	\N	\N	52398	52398	52399
13837	15876	77	applied	\N	\N	\N	\N	52411	52411	52412
13837	15877	78	applied	\N	\N	\N	\N	52413	52413	52414
13837	15878	79	applied	\N	\N	\N	\N	52415	52415	52416
13837	15880	80	applied	\N	\N	\N	\N	52423	52423	52424
13837	15881	81	applied	\N	\N	\N	\N	52425	52425	52426
13837	15882	82	applied	\N	\N	\N	\N	52427	52427	52428
13837	15884	83	applied	\N	\N	\N	\N	52436	52436	52437
13837	15886	84	applied	\N	\N	\N	\N	52440	52440	52441
13837	15887	85	applied	\N	\N	\N	\N	52442	52442	52443
13837	15889	86	applied	\N	\N	\N	\N	52450	52450	52451
13837	15890	87	applied	\N	\N	\N	\N	52452	52452	52453
13837	15891	88	applied	\N	\N	\N	\N	52454	52454	52455
13837	15894	89	applied	\N	\N	\N	\N	52464	52464	52465
13837	15895	90	applied	\N	\N	\N	\N	52466	52466	52467
13837	15896	91	applied	\N	\N	\N	\N	52468	52468	52469
13837	15897	92	applied	\N	\N	1000000000	\N	52470	52470	52471
13837	15898	93	applied	\N	\N	1000000000	\N	52472	52472	52473
13837	15899	94	applied	\N	\N	\N	\N	52474	52474	52475
13837	15900	95	applied	\N	\N	\N	\N	52476	52476	52477
13837	15901	96	applied	\N	\N	\N	\N	52478	52478	52479
13837	15903	97	applied	\N	\N	\N	\N	52483	52483	52484
13837	15904	98	applied	\N	\N	\N	\N	52485	52485	52486
13837	15905	99	applied	\N	\N	\N	\N	52487	52487	52488
13837	15908	100	applied	\N	\N	\N	\N	52497	52497	52498
13837	15909	101	applied	\N	\N	\N	\N	52499	52499	52500
13837	15910	102	applied	\N	\N	\N	\N	52501	52501	52502
13837	15911	103	applied	\N	\N	\N	\N	52504	52504	52505
13837	15913	104	applied	\N	\N	\N	\N	52511	52511	52512
13837	15914	105	applied	\N	\N	\N	\N	52513	52513	52514
13837	15915	106	applied	\N	\N	\N	\N	52515	52515	52516
13837	15916	107	applied	\N	\N	\N	\N	52517	52517	52518
13837	15917	108	applied	\N	\N	\N	\N	52519	52519	52520
13837	15920	109	applied	\N	\N	\N	\N	52528	52528	52529
13837	15921	110	applied	\N	\N	\N	\N	52530	52530	52531
13837	15922	111	applied	\N	\N	\N	\N	52532	52532	52533
13837	15925	112	applied	\N	\N	\N	\N	52542	52542	52543
13837	15926	113	applied	\N	\N	\N	\N	52544	52544	52545
13837	15927	114	applied	\N	\N	\N	\N	52546	52546	52547
13837	15928	115	applied	\N	\N	\N	\N	52548	52548	52549
13837	15929	116	applied	\N	\N	\N	\N	52550	52550	52551
13837	15930	117	applied	\N	\N	\N	\N	52552	52552	52553
13837	15932	118	applied	\N	\N	\N	\N	52560	52560	52561
13837	15933	119	applied	\N	\N	\N	\N	52562	52562	52563
13837	15934	120	applied	\N	\N	\N	\N	52564	52564	52565
13837	15939	121	applied	\N	\N	\N	\N	52579	52579	52580
13837	15940	122	applied	\N	\N	\N	\N	52581	52581	52582
13837	15941	123	applied	\N	\N	\N	\N	52583	52583	52584
13837	15942	124	applied	\N	\N	\N	\N	52585	52585	52586
13837	15943	125	applied	\N	\N	\N	\N	52587	52587	52588
13839	16025	0	applied	\N	\N	\N	\N	52786	52786	52787
13839	16026	1	applied	\N	\N	\N	\N	52788	52788	52789
13839	16027	2	applied	\N	\N	\N	\N	52790	52790	52791
13839	16028	3	applied	\N	\N	\N	\N	52792	52792	52793
13839	16029	4	applied	\N	\N	\N	\N	52794	52794	52795
13839	16030	5	applied	\N	\N	\N	\N	52796	52796	52797
13839	16031	6	applied	\N	\N	\N	\N	52798	52798	52799
13839	16032	7	applied	\N	\N	\N	\N	52800	52800	52801
13842	16033	0	applied	\N	\N	\N	\N	52803	52803	52804
13842	16034	1	applied	\N	\N	\N	\N	52805	52805	52806
13842	16035	3	applied	\N	\N	\N	\N	52808	52808	52809
13842	16036	4	applied	\N	\N	\N	\N	52810	52810	52811
13842	16037	5	applied	\N	\N	\N	\N	52812	52812	52813
13842	16038	6	applied	\N	\N	\N	\N	52814	52814	52815
13842	16039	7	applied	\N	\N	\N	\N	52816	52816	52817
13842	16040	8	applied	\N	\N	\N	\N	52818	52818	52819
13843	16041	0	applied	\N	\N	\N	\N	52821	52821	52822
13843	16042	1	applied	\N	\N	\N	\N	52823	52823	52824
13843	16043	2	applied	\N	\N	\N	\N	52825	52825	52826
13843	16044	3	applied	\N	\N	\N	\N	52827	52827	52828
13843	16045	4	applied	\N	\N	\N	\N	52829	52829	52830
13843	16046	5	applied	\N	\N	\N	\N	52831	52831	52832
13843	16047	6	applied	\N	\N	\N	\N	52833	52833	52834
13843	16048	7	applied	\N	\N	\N	\N	52835	52835	52836
13843	16049	8	applied	\N	\N	\N	\N	52837	52837	52838
13843	16050	9	applied	\N	\N	\N	\N	52839	52839	52840
13843	16051	10	applied	\N	\N	\N	\N	52841	52841	52842
13843	16052	11	applied	\N	\N	\N	\N	52843	52843	52844
13843	16053	12	applied	\N	\N	\N	\N	52845	52845	52846
13843	16054	13	applied	\N	\N	\N	\N	52847	52847	52848
13843	16055	14	applied	\N	\N	\N	\N	52849	52849	52850
13843	16056	15	applied	\N	\N	\N	\N	52851	52851	52852
13851	16061	0	applied	\N	\N	\N	\N	52870	52870	52871
13851	16058	1	applied	\N	\N	\N	\N	52861	52861	52862
13851	16059	2	applied	\N	\N	\N	\N	52863	52863	52864
13851	16060	3	applied	\N	\N	\N	\N	52865	52865	52866
13851	16062	4	applied	\N	\N	\N	\N	52874	52874	52875
13851	16063	5	applied	\N	\N	\N	\N	52876	52876	52877
13851	16064	6	applied	\N	\N	\N	\N	52878	52878	52879
13855	16065	0	applied	\N	\N	\N	\N	52883	52883	52884
13855	16058	1	applied	\N	\N	\N	\N	52861	52861	52862
13855	16059	2	applied	\N	\N	\N	\N	52863	52863	52864
13855	16060	3	applied	\N	\N	\N	\N	52865	52865	52866
13855	16062	4	applied	\N	\N	\N	\N	52874	52874	52875
13855	16063	5	applied	\N	\N	\N	\N	52876	52876	52877
13855	16064	6	applied	\N	\N	\N	\N	52878	52878	52879
13855	16066	7	applied	\N	\N	\N	\N	52885	52885	52886
13855	16067	8	applied	\N	\N	\N	\N	52887	52887	52888
13855	16068	9	applied	\N	\N	\N	\N	52889	52889	52890
13858	16081	0	applied	\N	\N	\N	\N	52921	52921	52922
13858	16082	1	applied	\N	\N	\N	\N	52923	52923	52924
13858	16083	2	applied	\N	\N	\N	\N	52925	52925	52926
13858	16084	3	applied	\N	\N	\N	\N	52927	52927	52928
13863	16089	0	applied	\N	\N	\N	\N	52943	52943	52944
13865	16097	0	applied	\N	\N	\N	\N	52965	52965	52966
13865	16098	1	applied	\N	\N	\N	\N	52967	52967	52968
13865	16099	2	applied	\N	\N	\N	\N	52969	52969	52970
13865	16100	3	applied	\N	\N	\N	\N	52971	52971	52972
13869	16108	0	applied	\N	\N	\N	\N	52991	52991	52992
13869	16109	1	applied	\N	\N	\N	\N	52993	52993	52994
13869	16110	2	applied	\N	\N	\N	\N	52995	52995	52996
13869	16111	3	applied	\N	\N	\N	\N	52997	52997	52998
13869	16112	4	applied	\N	\N	\N	\N	52999	52999	53000
13869	16113	5	applied	\N	\N	\N	\N	53001	53001	53002
13869	16114	6	applied	\N	\N	\N	\N	53003	53003	53004
13869	16115	7	applied	\N	\N	\N	\N	53005	53005	53006
13871	16108	0	applied	\N	\N	\N	\N	52991	52991	52992
13871	16109	1	applied	\N	\N	\N	\N	52993	52993	52994
13873	16120	0	applied	\N	\N	\N	\N	53025	53025	53026
13873	16121	1	applied	\N	\N	\N	\N	53027	53027	53028
13873	16122	2	applied	\N	\N	\N	\N	53029	53029	53030
13873	16123	3	applied	\N	\N	\N	\N	53031	53031	53032
13873	16124	4	applied	\N	\N	\N	\N	53033	53033	53034
13873	16125	5	applied	\N	\N	\N	\N	53035	53035	53036
13873	16126	6	applied	\N	\N	\N	\N	53037	53037	53038
13874	16127	0	applied	\N	\N	\N	\N	53041	53041	53042
13874	16128	1	applied	\N	\N	\N	\N	53043	53043	53044
13874	16129	2	applied	\N	\N	\N	\N	53045	53045	53046
13874	16130	4	applied	\N	\N	\N	\N	53048	53048	53049
13879	16140	0	applied	\N	\N	\N	\N	53073	53073	53074
13879	16141	1	applied	\N	\N	\N	\N	53075	53075	53076
13879	16142	2	applied	\N	\N	\N	\N	53077	53077	53078
13879	16143	3	applied	\N	\N	\N	\N	53079	53079	53080
13879	16144	4	applied	\N	\N	\N	\N	53081	53081	53082
13879	16145	5	applied	\N	\N	\N	\N	53083	53083	53084
13879	16146	6	applied	\N	\N	\N	\N	53085	53085	53086
13879	16147	7	applied	\N	\N	\N	\N	53087	53087	53088
13886	16167	0	applied	\N	\N	\N	\N	53142	53142	53143
13886	16168	1	applied	\N	\N	\N	\N	53144	53144	53145
13886	16169	2	applied	\N	\N	\N	\N	53146	53146	53147
13886	16170	3	applied	\N	\N	\N	\N	53148	53148	53149
13888	16167	0	applied	\N	\N	\N	\N	53142	53142	53143
13888	16168	1	applied	\N	\N	\N	\N	53144	53144	53145
13888	16169	2	applied	\N	\N	\N	\N	53146	53146	53147
13888	16170	3	applied	\N	\N	\N	\N	53148	53148	53149
13890	16171	0	applied	\N	\N	\N	\N	53155	53155	53156
13890	16168	1	applied	\N	\N	\N	\N	53144	53144	53145
13890	16169	2	applied	\N	\N	\N	\N	53146	53146	53147
13890	16170	3	applied	\N	\N	\N	\N	53148	53148	53149
13890	16172	4	applied	\N	\N	\N	\N	53157	53157	53158
13890	16173	5	applied	\N	\N	\N	\N	53159	53159	53160
13890	16174	6	applied	\N	\N	\N	\N	53161	53161	53162
13893	16176	0	applied	\N	\N	\N	\N	53169	53169	53170
13893	16177	1	applied	\N	\N	\N	\N	53171	53171	53172
13893	16172	2	applied	\N	\N	\N	\N	53157	53157	53158
13893	16173	3	applied	\N	\N	\N	\N	53159	53159	53160
13893	16174	4	applied	\N	\N	\N	\N	53161	53161	53162
13846	16051	10	applied	\N	\N	\N	\N	52841	52841	52842
13846	16052	11	applied	\N	\N	\N	\N	52843	52843	52844
13846	16053	12	applied	\N	\N	\N	\N	52845	52845	52846
13846	16054	13	applied	\N	\N	\N	\N	52847	52847	52848
13846	16055	14	applied	\N	\N	\N	\N	52849	52849	52850
13846	16056	15	applied	\N	\N	\N	\N	52851	52851	52852
13847	16057	0	applied	\N	\N	\N	\N	52857	52857	52858
13847	16045	1	applied	\N	\N	\N	\N	52829	52829	52830
13847	16046	2	applied	\N	\N	\N	\N	52831	52831	52832
13847	16047	3	applied	\N	\N	\N	\N	52833	52833	52834
13847	16048	4	applied	\N	\N	\N	\N	52835	52835	52836
13847	16049	5	applied	\N	\N	\N	\N	52837	52837	52838
13847	16050	6	applied	\N	\N	\N	\N	52839	52839	52840
13847	16051	7	applied	\N	\N	\N	\N	52841	52841	52842
13847	16052	8	applied	\N	\N	\N	\N	52843	52843	52844
13847	16053	9	applied	\N	\N	\N	\N	52845	52845	52846
13847	16054	10	applied	\N	\N	\N	\N	52847	52847	52848
13847	16055	11	applied	\N	\N	\N	\N	52849	52849	52850
13847	16056	12	applied	\N	\N	\N	\N	52851	52851	52852
13849	16057	0	applied	\N	\N	\N	\N	52857	52857	52858
13852	16061	0	applied	\N	\N	\N	\N	52870	52870	52871
13852	16058	1	applied	\N	\N	\N	\N	52861	52861	52862
13852	16059	2	applied	\N	\N	\N	\N	52863	52863	52864
13852	16060	3	applied	\N	\N	\N	\N	52865	52865	52866
13852	16062	4	applied	\N	\N	\N	\N	52874	52874	52875
13852	16063	5	applied	\N	\N	\N	\N	52876	52876	52877
13852	16064	6	applied	\N	\N	\N	\N	52878	52878	52879
13856	16069	0	applied	\N	\N	\N	\N	52894	52894	52895
13856	16070	1	applied	\N	\N	\N	\N	52896	52896	52897
13856	16071	2	applied	\N	\N	\N	\N	52898	52898	52899
13856	16072	3	applied	\N	\N	\N	\N	52900	52900	52901
13856	16073	4	applied	\N	\N	\N	\N	52902	52902	52903
13856	16074	5	applied	\N	\N	\N	\N	52904	52904	52905
13856	16075	6	applied	\N	\N	\N	\N	52906	52906	52907
13856	16076	7	applied	\N	\N	\N	\N	52908	52908	52909
13861	16085	0	applied	\N	\N	\N	\N	52931	52931	52932
13866	16101	0	applied	\N	\N	\N	\N	52975	52975	52976
13866	16102	1	applied	\N	\N	\N	\N	52977	52977	52978
13866	16103	2	applied	\N	\N	\N	\N	52979	52979	52980
13866	16104	3	applied	\N	\N	\N	\N	52981	52981	52982
13866	16105	4	applied	\N	\N	\N	\N	52983	52983	52984
13866	16106	5	applied	\N	\N	\N	\N	52985	52985	52986
13866	16107	6	applied	\N	\N	\N	\N	52987	52987	52988
13875	16127	0	applied	\N	\N	\N	\N	53041	53041	53042
13875	16128	1	applied	\N	\N	\N	\N	53043	53043	53044
13875	16129	2	applied	\N	\N	\N	\N	53045	53045	53046
13875	16131	4	applied	\N	\N	\N	\N	53053	53053	53054
13875	16132	5	applied	\N	\N	\N	\N	53055	53055	53056
13875	16133	6	applied	\N	\N	\N	\N	53057	53057	53058
13875	16130	7	applied	\N	\N	\N	\N	53048	53048	53049
13875	16134	8	applied	\N	\N	\N	\N	53059	53059	53060
13875	16135	9	applied	\N	\N	\N	\N	53061	53061	53062
13875	16136	10	applied	\N	\N	\N	\N	53063	53063	53064
13875	16137	11	applied	\N	\N	\N	\N	53065	53065	53066
13875	16138	12	applied	\N	\N	\N	\N	53067	53067	53068
13875	16139	13	applied	\N	\N	\N	\N	53069	53069	53070
13878	16140	0	applied	\N	\N	\N	\N	53073	53073	53074
13878	16141	1	applied	\N	\N	\N	\N	53075	53075	53076
13878	16142	2	applied	\N	\N	\N	\N	53077	53077	53078
13878	16143	3	applied	\N	\N	\N	\N	53079	53079	53080
13878	16144	4	applied	\N	\N	\N	\N	53081	53081	53082
13878	16145	5	applied	\N	\N	\N	\N	53083	53083	53084
13878	16146	6	applied	\N	\N	\N	\N	53085	53085	53086
13878	16147	7	applied	\N	\N	\N	\N	53087	53087	53088
13880	16140	0	applied	\N	\N	\N	\N	53073	53073	53074
13880	16141	1	applied	\N	\N	\N	\N	53075	53075	53076
13884	16156	0	applied	\N	\N	\N	\N	53116	53116	53117
13884	16157	1	applied	\N	\N	\N	\N	53118	53118	53119
13884	16151	2	applied	\N	\N	\N	\N	53103	53103	53104
13884	16152	3	applied	\N	\N	\N	\N	53105	53105	53106
13884	16153	4	applied	\N	\N	\N	\N	53107	53107	53108
13884	16154	5	applied	\N	\N	\N	\N	53109	53109	53110
13884	16155	6	applied	\N	\N	\N	\N	53111	53111	53112
13884	16158	7	applied	\N	\N	\N	\N	53120	53120	53121
13884	16159	8	applied	\N	\N	\N	\N	53122	53122	53123
13884	16160	9	applied	\N	\N	\N	\N	53124	53124	53125
13884	16161	10	applied	\N	\N	\N	\N	53126	53126	53127
13884	16162	11	applied	\N	\N	\N	\N	53128	53128	53129
13884	16163	12	applied	\N	\N	\N	\N	53130	53130	53131
13887	16167	0	applied	\N	\N	\N	\N	53142	53142	53143
13887	16168	1	applied	\N	\N	\N	\N	53144	53144	53145
13887	16169	2	applied	\N	\N	\N	\N	53146	53146	53147
13887	16170	3	applied	\N	\N	\N	\N	53148	53148	53149
13891	16171	0	applied	\N	\N	\N	\N	53155	53155	53156
13894	16176	0	applied	\N	\N	\N	\N	53169	53169	53170
13894	16177	1	applied	\N	\N	\N	\N	53171	53171	53172
13894	16172	2	applied	\N	\N	\N	\N	53157	53157	53158
13894	16173	3	applied	\N	\N	\N	\N	53159	53159	53160
13894	16174	4	applied	\N	\N	\N	\N	53161	53161	53162
13894	16178	5	applied	\N	\N	\N	\N	53173	53173	53174
13894	16179	6	applied	\N	\N	\N	\N	53175	53175	53176
13894	16180	7	applied	\N	\N	\N	\N	53177	53177	53178
13894	16181	8	applied	\N	\N	\N	\N	53179	53179	53180
13894	16182	9	applied	\N	\N	\N	\N	53181	53181	53182
13894	16183	10	applied	\N	\N	\N	\N	53183	53183	53184
13894	16184	11	applied	\N	\N	\N	\N	53185	53185	53186
13894	16185	12	applied	\N	\N	\N	\N	53187	53187	53188
13894	16186	13	applied	\N	\N	\N	\N	53189	53189	53190
13897	16176	0	applied	\N	\N	\N	\N	53169	53169	53170
13897	16177	1	applied	\N	\N	\N	\N	53171	53171	53172
13899	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13899	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13899	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13899	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13899	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13899	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13899	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13899	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13899	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13899	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13899	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13899	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13899	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13899	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13899	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13899	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13899	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13899	16192	17	applied	\N	\N	\N	\N	53210	53210	53211
13899	16193	18	applied	\N	\N	\N	\N	53212	53212	53213
13899	16194	19	applied	\N	\N	\N	\N	53214	53214	53215
13859	16086	1	applied	\N	\N	\N	\N	52933	52933	52934
13859	16087	2	applied	\N	\N	\N	\N	52935	52935	52936
13859	16088	3	applied	\N	\N	\N	\N	52937	52937	52938
13867	16108	0	applied	\N	\N	\N	\N	52991	52991	52992
13867	16109	1	applied	\N	\N	\N	\N	52993	52993	52994
13867	16110	2	applied	\N	\N	\N	\N	52995	52995	52996
13867	16111	3	applied	\N	\N	\N	\N	52997	52997	52998
13867	16112	4	applied	\N	\N	\N	\N	52999	52999	53000
13867	16113	5	applied	\N	\N	\N	\N	53001	53001	53002
13867	16114	6	applied	\N	\N	\N	\N	53003	53003	53004
13867	16115	7	applied	\N	\N	\N	\N	53005	53005	53006
13870	16108	0	applied	\N	\N	\N	\N	52991	52991	52992
13870	16109	1	applied	\N	\N	\N	\N	52993	52993	52994
13870	16110	2	applied	\N	\N	\N	\N	52995	52995	52996
13870	16111	3	applied	\N	\N	\N	\N	52997	52997	52998
13870	16112	4	applied	\N	\N	\N	\N	52999	52999	53000
13870	16113	5	applied	\N	\N	\N	\N	53001	53001	53002
13870	16114	6	applied	\N	\N	\N	\N	53003	53003	53004
13870	16115	7	applied	\N	\N	\N	\N	53005	53005	53006
13882	16148	0	applied	\N	\N	\N	\N	53097	53097	53098
13882	16149	1	applied	\N	\N	\N	\N	53099	53099	53100
13882	16131	2	applied	\N	\N	\N	\N	53053	53053	53054
13882	16132	3	applied	\N	\N	\N	\N	53055	53055	53056
13882	16133	4	applied	\N	\N	\N	\N	53057	53057	53058
13882	16134	5	applied	\N	\N	\N	\N	53059	53059	53060
13882	16135	6	applied	\N	\N	\N	\N	53061	53061	53062
13882	16136	7	applied	\N	\N	\N	\N	53063	53063	53064
13882	16137	8	applied	\N	\N	\N	\N	53065	53065	53066
13882	16138	9	applied	\N	\N	\N	\N	53067	53067	53068
13882	16139	10	applied	\N	\N	\N	\N	53069	53069	53070
13882	16142	11	applied	\N	\N	\N	\N	53077	53077	53078
13882	16143	12	applied	\N	\N	\N	\N	53079	53079	53080
13882	16144	13	applied	\N	\N	\N	\N	53081	53081	53082
13882	16145	14	applied	\N	\N	\N	\N	53083	53083	53084
13882	16146	15	applied	\N	\N	\N	\N	53085	53085	53086
13882	16147	16	applied	\N	\N	\N	\N	53087	53087	53088
13882	16150	17	applied	\N	\N	\N	\N	53101	53101	53102
13882	16151	18	applied	\N	\N	\N	\N	53103	53103	53104
13882	16152	19	applied	\N	\N	\N	\N	53105	53105	53106
13882	16153	20	applied	\N	\N	\N	\N	53107	53107	53108
13882	16154	21	applied	\N	\N	\N	\N	53109	53109	53110
13882	16155	22	applied	\N	\N	\N	\N	53111	53111	53112
13889	16167	0	applied	\N	\N	\N	\N	53142	53142	53143
13895	16176	0	applied	\N	\N	\N	\N	53169	53169	53170
13895	16177	1	applied	\N	\N	\N	\N	53171	53171	53172
13895	16172	2	applied	\N	\N	\N	\N	53157	53157	53158
13895	16173	3	applied	\N	\N	\N	\N	53159	53159	53160
13895	16174	4	applied	\N	\N	\N	\N	53161	53161	53162
13895	16178	5	applied	\N	\N	\N	\N	53173	53173	53174
13895	16179	6	applied	\N	\N	\N	\N	53175	53175	53176
13895	16180	7	applied	\N	\N	\N	\N	53177	53177	53178
13895	16181	8	applied	\N	\N	\N	\N	53179	53179	53180
13895	16182	9	applied	\N	\N	\N	\N	53181	53181	53182
13895	16183	10	applied	\N	\N	\N	\N	53183	53183	53184
13895	16184	11	applied	\N	\N	\N	\N	53185	53185	53186
13895	16185	12	applied	\N	\N	\N	\N	53187	53187	53188
13895	16186	13	applied	\N	\N	\N	\N	53189	53189	53190
13900	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13900	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13900	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13900	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13900	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13900	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13900	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13900	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13900	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13900	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13900	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13900	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13900	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13900	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13900	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13900	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13900	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13903	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13903	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13903	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13903	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13903	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13903	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13903	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13903	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13903	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13903	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13903	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13903	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13903	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13903	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13903	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13903	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13903	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13911	16222	0	applied	\N	\N	\N	\N	53283	53283	53284
13911	16223	1	applied	\N	\N	\N	\N	53285	53285	53286
13911	16224	2	applied	\N	\N	\N	\N	53287	53287	53288
13911	16225	3	applied	\N	\N	\N	\N	53289	53289	53290
13917	16226	0	applied	\N	\N	\N	\N	53294	53294	53295
13917	16227	1	applied	\N	\N	\N	\N	53300	53300	53301
13917	16228	2	applied	\N	\N	\N	\N	53302	53302	53303
13917	16229	4	applied	\N	\N	\N	\N	53305	53305	53306
13922	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13922	16239	1	applied	\N	\N	\N	\N	53333	53333	53334
13922	16240	2	applied	\N	\N	\N	\N	53335	53335	53336
13922	16241	3	applied	\N	\N	\N	\N	53337	53337	53338
13928	16242	0	applied	\N	\N	\N	\N	53343	53343	53344
13928	16243	1	applied	\N	\N	\N	\N	53347	53347	53348
13928	16244	2	applied	\N	\N	\N	\N	53349	53349	53350
13930	16245	0	applied	\N	\N	\N	\N	53353	53353	53354
13930	16243	1	applied	\N	\N	\N	\N	53347	53347	53348
13930	16244	2	applied	\N	\N	\N	\N	53349	53349	53350
13930	16246	3	applied	\N	\N	\N	\N	53355	53355	53356
13930	16247	4	applied	\N	\N	\N	\N	53357	53357	53358
13930	16248	5	applied	\N	\N	\N	\N	53359	53359	53360
13935	16260	0	applied	\N	\N	\N	\N	53387	53387	53388
13935	16261	1	applied	\N	\N	\N	\N	53389	53389	53390
13935	16262	2	applied	\N	\N	\N	\N	53391	53391	53392
13935	16263	3	applied	\N	\N	\N	\N	53393	53393	53394
13948	16280	0	applied	\N	\N	\N	\N	53440	53440	53441
13948	16281	1	applied	\N	\N	\N	\N	53444	53444	53445
13948	16282	2	applied	\N	\N	\N	\N	53446	53446	53447
13948	16283	3	applied	\N	\N	\N	\N	53448	53448	53449
13862	16090	4	applied	\N	\N	\N	\N	52945	52945	52946
13862	16091	5	applied	\N	\N	\N	\N	52947	52947	52948
13862	16092	6	applied	\N	\N	\N	\N	52949	52949	52950
13864	16093	0	applied	\N	\N	\N	\N	52955	52955	52956
13864	16086	1	applied	\N	\N	\N	\N	52933	52933	52934
13864	16087	2	applied	\N	\N	\N	\N	52935	52935	52936
13864	16088	3	applied	\N	\N	\N	\N	52937	52937	52938
13864	16090	4	applied	\N	\N	\N	\N	52945	52945	52946
13864	16091	5	applied	\N	\N	\N	\N	52947	52947	52948
13864	16092	6	applied	\N	\N	\N	\N	52949	52949	52950
13864	16094	7	applied	\N	\N	\N	\N	52957	52957	52958
13864	16095	8	applied	\N	\N	\N	\N	52959	52959	52960
13864	16096	9	applied	\N	\N	\N	\N	52961	52961	52962
13868	16108	0	applied	\N	\N	\N	\N	52991	52991	52992
13868	16109	1	applied	\N	\N	\N	\N	52993	52993	52994
13872	16116	0	applied	\N	\N	\N	\N	53015	53015	53016
13872	16117	1	applied	\N	\N	\N	\N	53017	53017	53018
13872	16118	2	applied	\N	\N	\N	\N	53019	53019	53020
13872	16119	3	applied	\N	\N	\N	\N	53021	53021	53022
13876	16140	0	applied	\N	\N	\N	\N	53073	53073	53074
13876	16141	1	applied	\N	\N	\N	\N	53075	53075	53076
13876	16142	2	applied	\N	\N	\N	\N	53077	53077	53078
13876	16143	3	applied	\N	\N	\N	\N	53079	53079	53080
13876	16144	4	applied	\N	\N	\N	\N	53081	53081	53082
13876	16145	5	applied	\N	\N	\N	\N	53083	53083	53084
13876	16146	6	applied	\N	\N	\N	\N	53085	53085	53086
13876	16147	7	applied	\N	\N	\N	\N	53087	53087	53088
13883	16148	0	applied	\N	\N	\N	\N	53097	53097	53098
13883	16149	1	applied	\N	\N	\N	\N	53099	53099	53100
13883	16150	2	applied	\N	\N	\N	\N	53101	53101	53102
13885	16164	0	applied	\N	\N	\N	\N	53134	53134	53135
13885	16165	1	applied	\N	\N	\N	\N	53136	53136	53137
13885	16166	2	applied	\N	\N	\N	\N	53138	53138	53139
13892	16175	0	applied	\N	\N	\N	\N	53167	53167	53168
13902	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13902	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13902	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13902	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13902	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13902	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13902	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13902	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13902	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13902	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13902	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13902	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13902	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13902	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13902	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13902	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13902	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13902	16192	17	applied	\N	\N	\N	\N	53210	53210	53211
13902	16193	18	applied	\N	\N	\N	\N	53212	53212	53213
13902	16194	19	applied	\N	\N	\N	\N	53214	53214	53215
13902	16195	20	applied	\N	\N	\N	\N	53216	53216	53217
13902	16196	21	applied	\N	\N	\N	\N	53218	53218	53219
13902	16197	22	applied	\N	\N	\N	\N	53220	53220	53221
13902	16198	23	applied	\N	\N	\N	\N	53222	53222	53223
13902	16199	24	applied	\N	\N	\N	\N	53224	53224	53225
13902	16200	25	applied	\N	\N	\N	\N	53226	53226	53227
13902	16201	26	applied	\N	\N	\N	\N	53228	53228	53229
13902	16202	27	applied	\N	\N	\N	\N	53230	53230	53231
13902	16203	28	applied	\N	\N	\N	\N	53232	53232	53233
13902	16204	29	applied	\N	\N	\N	\N	53234	53234	53235
13902	16205	30	applied	\N	\N	\N	\N	53236	53236	53237
13904	16206	0	applied	\N	\N	\N	\N	53245	53245	53246
13904	16207	1	applied	\N	\N	\N	\N	53247	53247	53248
13904	16208	2	applied	\N	\N	\N	\N	53249	53249	53250
13904	16209	3	applied	\N	\N	\N	\N	53251	53251	53252
13906	16210	0	applied	\N	\N	\N	\N	53254	53254	53255
13906	16211	1	applied	\N	\N	\N	\N	53256	53256	53257
13906	16212	2	applied	\N	\N	\N	\N	53258	53258	53259
13906	16213	3	applied	\N	\N	\N	\N	53260	53260	53261
13913	16226	0	applied	\N	\N	\N	\N	53294	53294	53295
13916	16226	0	applied	\N	\N	\N	\N	53294	53294	53295
13916	16227	1	applied	\N	\N	\N	\N	53300	53300	53301
13916	16228	2	applied	\N	\N	\N	\N	53302	53302	53303
13916	16229	4	applied	\N	\N	\N	\N	53305	53305	53306
13923	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13923	16239	1	applied	\N	\N	\N	\N	53333	53333	53334
13923	16240	2	applied	\N	\N	\N	\N	53335	53335	53336
13923	16241	3	applied	\N	\N	\N	\N	53337	53337	53338
13926	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13929	16242	0	applied	\N	\N	\N	\N	53343	53343	53344
13929	16243	1	applied	\N	\N	\N	\N	53347	53347	53348
13929	16244	2	applied	\N	\N	\N	\N	53349	53349	53350
13934	16260	0	applied	\N	\N	\N	\N	53387	53387	53388
13934	16261	1	applied	\N	\N	\N	\N	53389	53389	53390
13934	16262	2	applied	\N	\N	\N	\N	53391	53391	53392
13934	16263	3	applied	\N	\N	\N	\N	53393	53393	53394
13936	16260	0	applied	\N	\N	\N	\N	53387	53387	53388
13940	16264	0	applied	\N	\N	\N	\N	53402	53402	53403
13940	16265	1	applied	\N	\N	\N	\N	53404	53404	53405
13940	16266	2	applied	\N	\N	\N	\N	53406	53406	53407
13940	16267	3	applied	\N	\N	\N	\N	53408	53408	53409
13942	16268	0	applied	\N	\N	\N	\N	53412	53412	53413
13942	16269	1	applied	\N	\N	\N	\N	53414	53414	53415
13942	16270	2	applied	\N	\N	\N	\N	53416	53416	53417
13942	16271	3	applied	\N	\N	\N	\N	53418	53418	53419
13944	16272	0	applied	\N	\N	\N	\N	53420	53420	53421
13944	16273	1	applied	\N	\N	\N	\N	53422	53422	53423
13944	16274	2	applied	\N	\N	\N	\N	53424	53424	53425
13944	16275	3	applied	\N	\N	\N	\N	53426	53426	53427
13949	16284	0	applied	\N	\N	\N	\N	53451	53451	53452
13949	16285	1	applied	\N	\N	\N	\N	53453	53453	53454
13949	16286	2	applied	\N	\N	\N	\N	53455	53455	53456
13949	16287	3	applied	\N	\N	\N	\N	53457	53457	53458
13952	16288	0	applied	\N	\N	\N	\N	53461	53461	53462
13959	16310	0	applied	\N	\N	\N	\N	53514	53514	53515
13959	16311	1	applied	\N	\N	\N	\N	53516	53516	53517
13959	16307	2	applied	\N	\N	\N	\N	53506	53506	53507
13959	16308	3	applied	\N	\N	\N	\N	53508	53508	53509
13959	16309	4	applied	\N	\N	\N	\N	53510	53510	53511
13959	16312	5	applied	\N	\N	\N	\N	53518	53518	53519
13959	16313	6	applied	\N	\N	\N	\N	53520	53520	53521
13959	16314	7	applied	\N	\N	\N	\N	53522	53522	53523
13959	16315	8	applied	\N	\N	\N	\N	53524	53524	53525
13959	16316	9	applied	\N	\N	\N	\N	53526	53526	53527
13959	16317	10	applied	\N	\N	\N	\N	53528	53528	53529
13965	16347	0	applied	\N	\N	\N	\N	53595	53595	53596
13893	16178	5	applied	\N	\N	\N	\N	53173	53173	53174
13893	16179	6	applied	\N	\N	\N	\N	53175	53175	53176
13893	16180	7	applied	\N	\N	\N	\N	53177	53177	53178
13893	16181	8	applied	\N	\N	\N	\N	53179	53179	53180
13893	16182	9	applied	\N	\N	\N	\N	53181	53181	53182
13893	16183	10	applied	\N	\N	\N	\N	53183	53183	53184
13893	16184	11	applied	\N	\N	\N	\N	53185	53185	53186
13893	16185	12	applied	\N	\N	\N	\N	53187	53187	53188
13893	16186	13	applied	\N	\N	\N	\N	53189	53189	53190
13896	16176	0	applied	\N	\N	\N	\N	53169	53169	53170
13896	16177	1	applied	\N	\N	\N	\N	53171	53171	53172
13896	16172	2	applied	\N	\N	\N	\N	53157	53157	53158
13896	16173	3	applied	\N	\N	\N	\N	53159	53159	53160
13896	16174	4	applied	\N	\N	\N	\N	53161	53161	53162
13896	16178	5	applied	\N	\N	\N	\N	53173	53173	53174
13896	16179	6	applied	\N	\N	\N	\N	53175	53175	53176
13896	16180	7	applied	\N	\N	\N	\N	53177	53177	53178
13896	16181	8	applied	\N	\N	\N	\N	53179	53179	53180
13896	16182	9	applied	\N	\N	\N	\N	53181	53181	53182
13896	16183	10	applied	\N	\N	\N	\N	53183	53183	53184
13896	16184	11	applied	\N	\N	\N	\N	53185	53185	53186
13896	16185	12	applied	\N	\N	\N	\N	53187	53187	53188
13896	16186	13	applied	\N	\N	\N	\N	53189	53189	53190
13898	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13898	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13898	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13898	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13898	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13898	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13898	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13898	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13898	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13898	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13898	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13898	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13898	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13898	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13898	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13898	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13898	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13898	16192	17	applied	\N	\N	\N	\N	53210	53210	53211
13898	16193	18	applied	\N	\N	\N	\N	53212	53212	53213
13898	16194	19	applied	\N	\N	\N	\N	53214	53214	53215
13898	16195	20	applied	\N	\N	\N	\N	53216	53216	53217
13898	16196	21	applied	\N	\N	\N	\N	53218	53218	53219
13898	16197	22	applied	\N	\N	\N	\N	53220	53220	53221
13898	16198	23	applied	\N	\N	\N	\N	53222	53222	53223
13898	16199	24	applied	\N	\N	\N	\N	53224	53224	53225
13898	16200	25	applied	\N	\N	\N	\N	53226	53226	53227
13898	16201	26	applied	\N	\N	\N	\N	53228	53228	53229
13898	16202	27	applied	\N	\N	\N	\N	53230	53230	53231
13898	16203	28	applied	\N	\N	\N	\N	53232	53232	53233
13898	16204	29	applied	\N	\N	\N	\N	53234	53234	53235
13898	16205	30	applied	\N	\N	\N	\N	53236	53236	53237
13901	16187	0	applied	\N	\N	\N	\N	53200	53200	53201
13901	16188	1	applied	\N	\N	\N	\N	53202	53202	53203
13901	16189	2	applied	\N	\N	\N	\N	53204	53204	53205
13901	16190	3	applied	\N	\N	\N	\N	53206	53206	53207
13901	16191	4	applied	\N	\N	\N	\N	53208	53208	53209
13901	16172	5	applied	\N	\N	\N	\N	53157	53157	53158
13901	16173	6	applied	\N	\N	\N	\N	53159	53159	53160
13901	16174	7	applied	\N	\N	\N	\N	53161	53161	53162
13901	16178	8	applied	\N	\N	\N	\N	53173	53173	53174
13901	16179	9	applied	\N	\N	\N	\N	53175	53175	53176
13901	16180	10	applied	\N	\N	\N	\N	53177	53177	53178
13901	16181	11	applied	\N	\N	\N	\N	53179	53179	53180
13901	16182	12	applied	\N	\N	\N	\N	53181	53181	53182
13901	16183	13	applied	\N	\N	\N	\N	53183	53183	53184
13901	16184	14	applied	\N	\N	\N	\N	53185	53185	53186
13901	16185	15	applied	\N	\N	\N	\N	53187	53187	53188
13901	16186	16	applied	\N	\N	\N	\N	53189	53189	53190
13901	16192	17	applied	\N	\N	\N	\N	53210	53210	53211
13901	16193	18	applied	\N	\N	\N	\N	53212	53212	53213
13901	16194	19	applied	\N	\N	\N	\N	53214	53214	53215
13901	16195	20	applied	\N	\N	\N	\N	53216	53216	53217
13901	16196	21	applied	\N	\N	\N	\N	53218	53218	53219
13901	16197	22	applied	\N	\N	\N	\N	53220	53220	53221
13901	16198	23	applied	\N	\N	\N	\N	53222	53222	53223
13901	16199	24	applied	\N	\N	\N	\N	53224	53224	53225
13901	16200	25	applied	\N	\N	\N	\N	53226	53226	53227
13901	16201	26	applied	\N	\N	\N	\N	53228	53228	53229
13901	16202	27	applied	\N	\N	\N	\N	53230	53230	53231
13901	16203	28	applied	\N	\N	\N	\N	53232	53232	53233
13901	16204	29	applied	\N	\N	\N	\N	53234	53234	53235
13901	16205	30	applied	\N	\N	\N	\N	53236	53236	53237
13907	16214	0	applied	\N	\N	\N	\N	53263	53263	53264
13907	16215	1	applied	\N	\N	\N	\N	53265	53265	53266
13907	16216	2	applied	\N	\N	\N	\N	53267	53267	53268
13907	16217	3	applied	\N	\N	\N	\N	53269	53269	53270
13907	16218	4	applied	\N	\N	\N	\N	53271	53271	53272
13907	16219	5	applied	\N	\N	\N	\N	53273	53273	53274
13907	16220	6	applied	\N	\N	\N	\N	53275	53275	53276
13907	16221	7	applied	\N	\N	\N	\N	53277	53277	53278
13909	16214	0	applied	\N	\N	\N	\N	53263	53263	53264
13909	16215	1	applied	\N	\N	\N	\N	53265	53265	53266
13912	16222	0	applied	\N	\N	\N	\N	53283	53283	53284
13912	16223	1	applied	\N	\N	\N	\N	53285	53285	53286
13912	16224	2	applied	\N	\N	\N	\N	53287	53287	53288
13914	16226	0	applied	\N	\N	\N	\N	53294	53294	53295
13920	16230	0	applied	\N	\N	\N	\N	53314	53314	53315
13920	16231	1	applied	\N	\N	\N	\N	53316	53316	53317
13920	16227	2	applied	\N	\N	\N	\N	53300	53300	53301
13920	16228	3	applied	\N	\N	\N	\N	53302	53302	53303
13920	16229	4	applied	\N	\N	\N	\N	53305	53305	53306
13920	16232	5	applied	\N	\N	\N	\N	53318	53318	53319
13920	16233	6	applied	\N	\N	\N	\N	53320	53320	53321
13920	16234	7	applied	\N	\N	\N	\N	53322	53322	53323
13920	16235	8	applied	\N	\N	\N	\N	53324	53324	53325
13920	16236	9	applied	\N	\N	\N	\N	53326	53326	53327
13920	16237	10	applied	\N	\N	\N	\N	53328	53328	53329
13924	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13924	16239	1	applied	\N	\N	\N	\N	53333	53333	53334
13924	16240	2	applied	\N	\N	\N	\N	53335	53335	53336
13924	16241	3	applied	\N	\N	\N	\N	53337	53337	53338
13937	16260	0	applied	\N	\N	\N	\N	53387	53387	53388
13937	16261	1	applied	\N	\N	\N	\N	53389	53389	53390
13937	16262	2	applied	\N	\N	\N	\N	53391	53391	53392
13937	16263	3	applied	\N	\N	\N	\N	53393	53393	53394
13943	16268	0	applied	\N	\N	\N	\N	53412	53412	53413
13943	16269	1	applied	\N	\N	\N	\N	53414	53414	53415
13899	16195	20	applied	\N	\N	\N	\N	53216	53216	53217
13899	16196	21	applied	\N	\N	\N	\N	53218	53218	53219
13899	16197	22	applied	\N	\N	\N	\N	53220	53220	53221
13899	16198	23	applied	\N	\N	\N	\N	53222	53222	53223
13899	16199	24	applied	\N	\N	\N	\N	53224	53224	53225
13899	16200	25	applied	\N	\N	\N	\N	53226	53226	53227
13899	16201	26	applied	\N	\N	\N	\N	53228	53228	53229
13899	16202	27	applied	\N	\N	\N	\N	53230	53230	53231
13899	16203	28	applied	\N	\N	\N	\N	53232	53232	53233
13899	16204	29	applied	\N	\N	\N	\N	53234	53234	53235
13899	16205	30	applied	\N	\N	\N	\N	53236	53236	53237
13905	16206	0	applied	\N	\N	\N	\N	53245	53245	53246
13905	16207	1	applied	\N	\N	\N	\N	53247	53247	53248
13905	16208	2	applied	\N	\N	\N	\N	53249	53249	53250
13905	16209	3	applied	\N	\N	\N	\N	53251	53251	53252
13908	16214	0	applied	\N	\N	\N	\N	53263	53263	53264
13908	16215	1	applied	\N	\N	\N	\N	53265	53265	53266
13908	16216	2	applied	\N	\N	\N	\N	53267	53267	53268
13908	16217	3	applied	\N	\N	\N	\N	53269	53269	53270
13908	16218	4	applied	\N	\N	\N	\N	53271	53271	53272
13908	16219	5	applied	\N	\N	\N	\N	53273	53273	53274
13908	16220	6	applied	\N	\N	\N	\N	53275	53275	53276
13908	16221	7	applied	\N	\N	\N	\N	53277	53277	53278
13910	16222	0	applied	\N	\N	\N	\N	53283	53283	53284
13910	16223	1	applied	\N	\N	\N	\N	53285	53285	53286
13910	16224	2	applied	\N	\N	\N	\N	53287	53287	53288
13910	16225	3	applied	\N	\N	\N	\N	53289	53289	53290
13915	16168	0	applied	\N	\N	\N	\N	53144	53144	53145
13915	16169	1	applied	\N	\N	\N	\N	53146	53146	53147
13915	16170	2	applied	\N	\N	\N	\N	53148	53148	53149
13921	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13921	16239	1	applied	\N	\N	\N	\N	53333	53333	53334
13921	16240	2	applied	\N	\N	\N	\N	53335	53335	53336
13921	16241	3	applied	\N	\N	\N	\N	53337	53337	53338
13925	16238	0	applied	\N	\N	\N	\N	53331	53331	53332
13925	16239	1	applied	\N	\N	\N	\N	53333	53333	53334
13925	16240	2	applied	\N	\N	\N	\N	53335	53335	53336
13925	16241	3	applied	\N	\N	\N	\N	53337	53337	53338
13927	16242	0	applied	\N	\N	\N	\N	53343	53343	53344
13932	16249	0	applied	\N	\N	\N	\N	53362	53362	53363
13932	16250	1	applied	\N	\N	\N	\N	53364	53364	53365
13932	16251	2	applied	\N	\N	\N	\N	53366	53366	53367
13932	16252	3	applied	\N	\N	\N	\N	53368	53368	53369
13932	16253	4	applied	\N	\N	\N	\N	53370	53370	53371
13932	16254	5	applied	\N	\N	\N	\N	53372	53372	53373
13932	16255	6	applied	\N	\N	\N	\N	53374	53374	53375
13932	16256	7	applied	\N	\N	\N	\N	53376	53376	53377
13932	16257	8	applied	\N	\N	\N	\N	53378	53378	53379
13932	16258	9	applied	\N	\N	\N	\N	53380	53380	53381
13932	16259	10	applied	\N	\N	\N	\N	53382	53382	53383
13938	16260	0	applied	\N	\N	\N	\N	53387	53387	53388
13941	16264	0	applied	\N	\N	\N	\N	53402	53402	53403
13941	16261	1	applied	\N	\N	\N	\N	53389	53389	53390
13941	16262	2	applied	\N	\N	\N	\N	53391	53391	53392
13941	16263	3	applied	\N	\N	\N	\N	53393	53393	53394
13941	16265	4	applied	\N	\N	\N	\N	53404	53404	53405
13941	16266	5	applied	\N	\N	\N	\N	53406	53406	53407
13941	16267	6	applied	\N	\N	\N	\N	53408	53408	53409
13946	16276	0	applied	\N	\N	\N	\N	53430	53430	53431
13946	16277	1	applied	\N	\N	\N	\N	53432	53432	53433
13946	16278	2	applied	\N	\N	\N	\N	53434	53434	53435
13946	16279	3	applied	\N	\N	\N	\N	53436	53436	53437
13950	16288	0	applied	\N	\N	\N	\N	53461	53461	53462
13950	16289	1	applied	\N	\N	\N	\N	53463	53463	53464
13950	16290	2	applied	\N	\N	\N	\N	53465	53465	53466
13950	16291	3	applied	\N	\N	\N	\N	53467	53467	53468
13955	16299	0	applied	\N	\N	\N	\N	53489	53489	53490
13955	16300	1	applied	\N	\N	\N	\N	53491	53491	53492
13955	16301	2	applied	\N	\N	\N	\N	53493	53493	53494
13955	16302	3	applied	\N	\N	\N	\N	53495	53495	53496
13955	16303	4	applied	\N	\N	\N	\N	53497	53497	53498
13955	16304	5	applied	\N	\N	\N	\N	53499	53499	53500
13955	16305	6	applied	\N	\N	\N	\N	53501	53501	53502
13964	16318	0	applied	\N	\N	\N	\N	53533	53533	53534
13964	16319	1	applied	\N	\N	\N	\N	53535	53535	53536
13964	16320	2	applied	\N	\N	\N	\N	53537	53537	53538
13964	16321	3	applied	\N	\N	\N	\N	53539	53539	53540
13964	16322	4	applied	\N	\N	\N	\N	53541	53541	53542
13964	16323	5	applied	\N	\N	\N	\N	53543	53543	53544
13964	16324	6	applied	\N	\N	\N	\N	53545	53545	53546
13964	16325	7	applied	\N	\N	\N	\N	53547	53547	53548
13964	16326	8	applied	\N	\N	\N	\N	53549	53549	53550
13964	16327	9	applied	\N	\N	\N	\N	53551	53551	53552
13964	16328	10	applied	\N	\N	\N	\N	53553	53553	53554
13964	16329	11	applied	\N	\N	\N	\N	53555	53555	53556
13964	16330	12	applied	\N	\N	\N	\N	53557	53557	53558
13966	16347	0	applied	\N	\N	\N	\N	53595	53595	53596
13971	16355	0	applied	\N	\N	\N	\N	53614	53614	53615
13971	16356	1	applied	\N	\N	\N	\N	53616	53616	53617
13971	16357	2	applied	\N	\N	\N	\N	53618	53618	53619
13973	16364	0	applied	\N	\N	\N	\N	53636	53636	53637
13973	16365	1	applied	\N	\N	\N	\N	53638	53638	53639
13976	16372	0	applied	\N	\N	\N	\N	53657	53657	53658
13976	16373	1	applied	\N	\N	\N	\N	53659	53659	53660
13976	16374	2	applied	\N	\N	\N	\N	53661	53661	53662
13976	16375	3	applied	\N	\N	\N	\N	53663	53663	53664
13978	16376	0	applied	\N	\N	\N	\N	53667	53667	53668
13978	16377	1	applied	\N	\N	\N	\N	53669	53669	53670
13978	16378	2	applied	\N	\N	\N	\N	53671	53671	53672
13978	16379	3	applied	\N	\N	\N	\N	53673	53673	53674
13978	16380	4	applied	\N	\N	\N	\N	53675	53675	53676
13978	16381	5	applied	\N	\N	\N	\N	53677	53677	53678
13978	16382	6	applied	\N	\N	\N	\N	53679	53679	53680
13978	16383	7	applied	\N	\N	\N	\N	53681	53681	53682
13978	16384	8	applied	\N	\N	\N	\N	53683	53683	53684
13978	16385	9	applied	\N	\N	\N	\N	53685	53685	53686
13978	16386	10	applied	\N	\N	\N	\N	53687	53687	53688
13978	16387	11	applied	\N	\N	\N	\N	53689	53689	53690
13981	16388	0	applied	\N	\N	\N	\N	53693	53693	53694
13981	16389	1	applied	\N	\N	\N	\N	53695	53695	53696
13981	16380	2	applied	\N	\N	\N	\N	53675	53675	53676
13981	16381	3	applied	\N	\N	\N	\N	53677	53677	53678
13981	16382	4	applied	\N	\N	\N	\N	53679	53679	53680
13981	16383	5	applied	\N	\N	\N	\N	53681	53681	53682
13981	16384	6	applied	\N	\N	\N	\N	53683	53683	53684
13981	16385	7	applied	\N	\N	\N	\N	53685	53685	53686
13981	16386	8	applied	\N	\N	\N	\N	53687	53687	53688
13981	16387	9	applied	\N	\N	\N	\N	53689	53689	53690
13981	16390	10	applied	\N	\N	\N	\N	53697	53697	53698
13981	16391	11	applied	\N	\N	\N	\N	53699	53699	53700
13943	16270	2	applied	\N	\N	\N	\N	53416	53416	53417
13943	16271	3	applied	\N	\N	\N	\N	53418	53418	53419
13945	16276	0	applied	\N	\N	\N	\N	53430	53430	53431
13945	16277	1	applied	\N	\N	\N	\N	53432	53432	53433
13945	16278	2	applied	\N	\N	\N	\N	53434	53434	53435
13945	16279	3	applied	\N	\N	\N	\N	53436	53436	53437
13947	16280	0	applied	\N	\N	\N	\N	53440	53440	53441
13954	16292	0	applied	\N	\N	\N	\N	53474	53474	53475
13954	16293	1	applied	\N	\N	\N	\N	53476	53476	53477
13954	16294	2	applied	\N	\N	\N	\N	53478	53478	53479
13954	16295	3	applied	\N	\N	\N	\N	53480	53480	53481
13954	16296	4	applied	\N	\N	\N	\N	53482	53482	53483
13954	16297	5	applied	\N	\N	\N	\N	53484	53484	53485
13954	16298	6	applied	\N	\N	\N	\N	53486	53486	53487
13957	16306	0	applied	\N	\N	\N	\N	53504	53504	53505
13960	16310	0	applied	\N	\N	\N	\N	53514	53514	53515
13960	16311	1	applied	\N	\N	\N	\N	53516	53516	53517
13960	16307	2	applied	\N	\N	\N	\N	53506	53506	53507
13960	16308	3	applied	\N	\N	\N	\N	53508	53508	53509
13960	16309	4	applied	\N	\N	\N	\N	53510	53510	53511
13960	16312	5	applied	\N	\N	\N	\N	53518	53518	53519
13960	16313	6	applied	\N	\N	\N	\N	53520	53520	53521
13960	16314	7	applied	\N	\N	\N	\N	53522	53522	53523
13960	16315	8	applied	\N	\N	\N	\N	53524	53524	53525
13960	16316	9	applied	\N	\N	\N	\N	53526	53526	53527
13960	16317	10	applied	\N	\N	\N	\N	53528	53528	53529
13963	16318	0	applied	\N	\N	\N	\N	53533	53533	53534
13963	16319	1	applied	\N	\N	\N	\N	53535	53535	53536
13963	16320	2	applied	\N	\N	\N	\N	53537	53537	53538
13963	16321	3	applied	\N	\N	\N	\N	53539	53539	53540
13963	16322	4	applied	\N	\N	\N	\N	53541	53541	53542
13963	16323	5	applied	\N	\N	\N	\N	53543	53543	53544
13963	16324	6	applied	\N	\N	\N	\N	53545	53545	53546
13963	16325	7	applied	\N	\N	\N	\N	53547	53547	53548
13963	16326	8	applied	\N	\N	\N	\N	53549	53549	53550
13963	16327	9	applied	\N	\N	\N	\N	53551	53551	53552
13963	16328	10	applied	\N	\N	\N	\N	53553	53553	53554
13963	16329	11	applied	\N	\N	\N	\N	53555	53555	53556
13963	16330	12	applied	\N	\N	\N	\N	53557	53557	53558
13968	16351	0	applied	\N	\N	\N	\N	53603	53603	53604
13975	16372	0	applied	\N	\N	\N	\N	53657	53657	53658
13975	16373	1	applied	\N	\N	\N	\N	53659	53659	53660
13975	16374	2	applied	\N	\N	\N	\N	53661	53661	53662
13975	16375	3	applied	\N	\N	\N	\N	53663	53663	53664
13980	16388	0	applied	\N	\N	\N	\N	53693	53693	53694
13980	16389	1	applied	\N	\N	\N	\N	53695	53695	53696
13980	16380	2	applied	\N	\N	\N	\N	53675	53675	53676
13980	16381	3	applied	\N	\N	\N	\N	53677	53677	53678
13980	16382	4	applied	\N	\N	\N	\N	53679	53679	53680
13980	16383	5	applied	\N	\N	\N	\N	53681	53681	53682
13980	16384	6	applied	\N	\N	\N	\N	53683	53683	53684
13980	16385	7	applied	\N	\N	\N	\N	53685	53685	53686
13980	16386	8	applied	\N	\N	\N	\N	53687	53687	53688
13980	16387	9	applied	\N	\N	\N	\N	53689	53689	53690
13980	16390	10	applied	\N	\N	\N	\N	53697	53697	53698
13980	16391	11	applied	\N	\N	\N	\N	53699	53699	53700
13980	16392	12	applied	\N	\N	\N	\N	53701	53701	53702
13980	16393	13	applied	\N	\N	\N	\N	53703	53703	53704
13980	16394	14	applied	\N	\N	\N	\N	53705	53705	53706
13980	16395	15	applied	\N	\N	\N	\N	53707	53707	53708
13985	16400	0	applied	\N	\N	\N	\N	53725	53725	53726
13985	16401	1	applied	\N	\N	\N	\N	53727	53727	53728
13985	16402	2	applied	\N	\N	\N	\N	53729	53729	53730
13985	16403	3	applied	\N	\N	\N	\N	53731	53731	53732
13985	16404	4	applied	\N	\N	\N	\N	53733	53733	53734
13985	16405	5	applied	\N	\N	\N	\N	53735	53735	53736
13988	16410	0	applied	\N	\N	\N	\N	53748	53748	53749
13988	16411	1	applied	\N	\N	\N	\N	53750	53750	53751
13988	16412	2	applied	\N	\N	\N	\N	53752	53752	53753
13988	16413	3	applied	\N	\N	\N	\N	53754	53754	53755
13990	16422	0	applied	\N	\N	\N	\N	53777	53777	53778
13990	16423	1	applied	\N	\N	\N	\N	53779	53779	53780
13990	16424	2	applied	\N	\N	\N	\N	53781	53781	53782
13990	16425	3	applied	\N	\N	\N	\N	53783	53783	53784
13992	16422	0	applied	\N	\N	\N	\N	53777	53777	53778
13992	16423	1	applied	\N	\N	\N	\N	53779	53779	53780
13992	16424	2	applied	\N	\N	\N	\N	53781	53781	53782
13992	16425	3	applied	\N	\N	\N	\N	53783	53783	53784
13997	16431	0	applied	\N	\N	\N	\N	53804	53804	53805
13997	16432	1	applied	\N	\N	\N	\N	53806	53806	53807
13997	16433	2	applied	\N	\N	\N	\N	53808	53808	12588
13997	16434	3	applied	\N	\N	\N	\N	53809	53809	51989
13997	16435	4	applied	\N	\N	\N	\N	53810	53810	53811
13997	16436	5	applied	\N	\N	\N	\N	53812	53812	53813
13997	16437	6	applied	\N	\N	\N	\N	53814	53814	53815
13997	16438	7	applied	\N	\N	\N	\N	53816	53816	53817
13997	16439	8	applied	\N	\N	\N	\N	53818	53818	53819
13999	16440	0	applied	\N	\N	\N	\N	53823	53823	53824
14000	16416	0	applied	\N	\N	\N	\N	53763	53763	47675
14000	16433	1	applied	\N	\N	\N	\N	53808	53808	12588
14000	16444	2	applied	\N	\N	\N	\N	53834	53834	52554
14000	16427	3	applied	\N	\N	\N	\N	53793	53793	25661
14000	16434	4	applied	\N	\N	\N	\N	53809	53809	51989
14002	16457	0	applied	\N	\N	\N	\N	53863	53863	53864
14002	16458	1	applied	\N	\N	\N	\N	53865	53865	53865
14008	16491	0	applied	\N	\N	\N	\N	53940	53940	53941
14008	16492	1	applied	\N	\N	\N	\N	53942	53942	25661
14008	16493	2	applied	\N	\N	\N	\N	53943	53943	53944
14008	16494	3	applied	\N	\N	\N	\N	53945	53945	53946
14008	16495	4	applied	\N	\N	\N	\N	53947	53947	53948
14013	16504	0	applied	\N	\N	\N	\N	53970	53970	53971
14013	16505	1	applied	\N	\N	\N	\N	53972	53972	25661
14016	16509	0	applied	\N	\N	\N	\N	53982	53982	53983
14016	16510	1	applied	\N	\N	\N	\N	53984	53984	53985
14016	16511	2	applied	\N	\N	\N	\N	53986	53986	53987
14016	16512	3	applied	\N	\N	\N	\N	53988	53988	53989
14016	16513	4	applied	\N	\N	\N	\N	53990	53990	53991
14018	16460	0	applied	\N	\N	\N	\N	53871	53871	53872
14018	16474	1	applied	\N	\N	\N	\N	53901	53901	53902
14018	16319	2	applied	\N	\N	\N	\N	53535	53535	53721
14018	16355	3	applied	\N	\N	\N	\N	53614	53614	53722
14018	16416	4	applied	\N	\N	\N	\N	53763	53763	47675
14018	16433	5	applied	\N	\N	\N	\N	53808	53808	12588
14018	16492	6	applied	\N	\N	\N	\N	53942	53942	25661
14018	16444	7	applied	\N	\N	\N	\N	53834	53834	52554
14018	16500	8	applied	\N	\N	\N	\N	53962	53962	25661
14018	16515	9	applied	\N	\N	\N	\N	53999	53999	25661
14018	16505	10	applied	\N	\N	\N	\N	53972	53972	25661
14018	16427	11	applied	\N	\N	\N	\N	53793	53793	25661
14018	16434	12	applied	\N	\N	\N	\N	53809	53809	51989
13951	16288	0	applied	\N	\N	\N	\N	53461	53461	53462
13953	16289	0	applied	\N	\N	\N	\N	53463	53463	53464
13953	16290	1	applied	\N	\N	\N	\N	53465	53465	53466
13953	16291	2	applied	\N	\N	\N	\N	53467	53467	53468
13956	16306	0	applied	\N	\N	\N	\N	53504	53504	53505
13956	16307	1	applied	\N	\N	\N	\N	53506	53506	53507
13956	16308	2	applied	\N	\N	\N	\N	53508	53508	53509
13956	16309	3	applied	\N	\N	\N	\N	53510	53510	53511
13958	16306	0	applied	\N	\N	\N	\N	53504	53504	53505
13962	16318	0	applied	\N	\N	\N	\N	53533	53533	53534
13962	16319	1	applied	\N	\N	\N	\N	53535	53535	53536
13962	16320	2	applied	\N	\N	\N	\N	53537	53537	53538
13962	16321	3	applied	\N	\N	\N	\N	53539	53539	53540
13962	16322	4	applied	\N	\N	\N	\N	53541	53541	53542
13962	16323	5	applied	\N	\N	\N	\N	53543	53543	53544
13962	16324	6	applied	\N	\N	\N	\N	53545	53545	53546
13962	16325	7	applied	\N	\N	\N	\N	53547	53547	53548
13962	16326	8	applied	\N	\N	\N	\N	53549	53549	53550
13962	16327	9	applied	\N	\N	\N	\N	53551	53551	53552
13962	16328	10	applied	\N	\N	\N	\N	53553	53553	53554
13962	16329	11	applied	\N	\N	\N	\N	53555	53555	53556
13962	16330	12	applied	\N	\N	\N	\N	53557	53557	53558
13962	16331	13	applied	\N	\N	\N	\N	53559	53559	53560
13962	16332	14	applied	\N	\N	\N	\N	53561	53561	53562
13962	16333	15	applied	\N	\N	\N	\N	53563	53563	53564
13962	16334	16	applied	\N	\N	\N	\N	53565	53565	53566
13962	16335	17	applied	\N	\N	\N	\N	53567	53567	53568
13962	16336	18	applied	\N	\N	\N	\N	53569	53569	53570
13962	16337	19	applied	\N	\N	\N	\N	53571	53571	53572
13962	16338	20	applied	\N	\N	\N	\N	53573	53573	53574
13962	16339	21	applied	\N	\N	\N	\N	53575	53575	53576
13962	16340	22	applied	\N	\N	\N	\N	53577	53577	53578
13962	16341	23	applied	\N	\N	\N	\N	53579	53579	53580
13962	16342	24	applied	\N	\N	\N	\N	53581	53581	53582
13962	16343	25	applied	\N	\N	\N	\N	53583	53583	53584
13962	16344	26	applied	\N	\N	\N	\N	53585	53585	53586
13962	16345	27	applied	\N	\N	\N	\N	53587	53587	53588
13962	16346	28	applied	\N	\N	\N	\N	53589	53589	53590
13969	16355	0	applied	\N	\N	\N	\N	53614	53614	53615
13969	16356	1	applied	\N	\N	\N	\N	53616	53616	53617
13969	16357	2	applied	\N	\N	\N	\N	53618	53618	53619
13969	16352	3	applied	\N	\N	\N	\N	53605	53605	53606
13969	16353	4	applied	\N	\N	\N	\N	53607	53607	53608
13969	16354	5	applied	\N	\N	\N	\N	53609	53609	53610
13969	16358	6	applied	\N	\N	\N	\N	53620	53620	53621
13969	16359	7	applied	\N	\N	\N	\N	53622	53622	53623
13969	16360	8	applied	\N	\N	\N	\N	53624	53624	53625
13969	16361	9	applied	\N	\N	\N	\N	53626	53626	53627
13969	16362	10	applied	\N	\N	\N	\N	53628	53628	53629
13969	16363	11	applied	\N	\N	\N	\N	53630	53630	53631
13974	16364	0	applied	\N	\N	\N	\N	53636	53636	53637
13974	16365	1	applied	\N	\N	\N	\N	53638	53638	53639
13974	16366	2	applied	\N	\N	\N	\N	53640	53640	53641
13974	16367	3	applied	\N	\N	\N	\N	53642	53642	53643
13974	16368	4	applied	\N	\N	\N	\N	53644	53644	53645
13974	16369	5	applied	\N	\N	\N	\N	53646	53646	53647
13974	16370	6	applied	\N	\N	\N	\N	53648	53648	53649
13974	16371	7	applied	\N	\N	\N	\N	53650	53650	53651
13977	16372	0	applied	\N	\N	\N	\N	53657	53657	53658
13977	16373	1	applied	\N	\N	\N	\N	53659	53659	53660
13977	16374	2	applied	\N	\N	\N	\N	53661	53661	53662
13977	16375	3	applied	\N	\N	\N	\N	53663	53663	53664
13984	16319	0	applied	\N	\N	\N	\N	53535	53535	53721
13984	16355	1	applied	\N	\N	\N	\N	53614	53614	53722
13984	16270	2	applied	\N	\N	\N	\N	53416	53416	53615
13986	16406	0	applied	\N	\N	\N	\N	53738	53738	53739
13986	16407	1	applied	\N	\N	\N	\N	53740	53740	53741
13986	16408	2	applied	\N	\N	\N	\N	53742	53742	53743
13986	16409	3	applied	\N	\N	\N	\N	53744	53744	53745
13989	16414	0	applied	\N	\N	\N	\N	53759	53759	53760
13989	16415	1	applied	\N	\N	\N	\N	53761	53761	53762
13989	16416	2	applied	\N	\N	\N	\N	53763	53763	47675
13989	16417	3	applied	\N	\N	\N	\N	53764	53764	53765
13989	16418	4	applied	\N	\N	\N	\N	53766	53766	53767
13989	16419	5	applied	\N	\N	\N	\N	53768	53768	53769
13989	16420	6	applied	\N	\N	\N	\N	53770	53770	53771
13989	16421	8	applied	\N	\N	\N	\N	53773	53773	53774
13991	16422	0	applied	\N	\N	\N	\N	53777	53777	53778
13991	16423	1	applied	\N	\N	\N	\N	53779	53779	53780
13991	16424	2	applied	\N	\N	\N	\N	53781	53781	53782
13991	16425	3	applied	\N	\N	\N	\N	53783	53783	53784
13996	16431	0	applied	\N	\N	\N	\N	53804	53804	53805
13996	16432	1	applied	\N	\N	\N	\N	53806	53806	53807
13996	16433	2	applied	\N	\N	\N	\N	53808	53808	12588
13996	16434	3	applied	\N	\N	\N	\N	53809	53809	51989
13996	16435	4	applied	\N	\N	\N	\N	53810	53810	53811
13996	16436	5	applied	\N	\N	\N	\N	53812	53812	53813
13996	16437	6	applied	\N	\N	\N	\N	53814	53814	53815
13996	16438	7	applied	\N	\N	\N	\N	53816	53816	53817
13996	16439	8	applied	\N	\N	\N	\N	53818	53818	53819
13998	16440	0	applied	\N	\N	\N	\N	53823	53823	53824
13998	16441	1	applied	\N	\N	\N	\N	53825	53825	53826
13998	16442	2	applied	\N	\N	\N	\N	53827	53827	53828
13998	16443	3	applied	\N	\N	\N	\N	53829	53829	53830
14001	16445	0	applied	\N	\N	\N	\N	53837	53837	53838
14001	16446	1	applied	\N	\N	\N	\N	53839	53839	53840
14001	16447	2	applied	\N	\N	\N	\N	53841	53841	53842
14001	16441	3	applied	\N	\N	\N	\N	53825	53825	53826
14001	16444	4	applied	\N	\N	\N	\N	53834	53834	52939
14001	16442	5	applied	\N	\N	\N	\N	53827	53827	53828
14001	16443	6	applied	\N	\N	\N	\N	53829	53829	53830
14001	16448	7	applied	\N	\N	\N	\N	53843	53843	53844
14001	16449	8	applied	\N	\N	\N	\N	53845	53845	53846
14001	16450	9	applied	\N	\N	\N	\N	53847	53847	53848
14001	16451	10	applied	\N	\N	\N	\N	53849	53849	53850
14001	16452	11	applied	\N	\N	\N	\N	53851	53851	53852
14001	16453	12	applied	\N	\N	\N	\N	53853	53853	53854
14001	16454	13	applied	\N	\N	\N	\N	53855	53855	53856
14001	16455	14	applied	\N	\N	\N	\N	53857	53857	53858
14001	16456	15	applied	\N	\N	\N	\N	53859	53859	53860
14004	16460	0	applied	\N	\N	\N	\N	53871	53871	53872
14004	16461	1	applied	\N	\N	\N	\N	53873	53873	53874
14004	16462	2	applied	\N	\N	\N	\N	53875	53875	53876
14004	16463	3	applied	\N	\N	\N	\N	53877	53877	53878
14004	16464	4	applied	\N	\N	\N	\N	53879	53879	53880
14004	16465	5	applied	\N	\N	\N	\N	53881	53881	53882
14004	16466	6	applied	\N	\N	\N	\N	53883	53883	53884
14004	16467	7	applied	\N	\N	\N	\N	53885	53885	53886
14004	16468	8	applied	\N	\N	\N	\N	53887	53887	53888
14004	16469	9	applied	\N	\N	\N	\N	53889	53889	53890
13965	16348	1	applied	\N	\N	\N	\N	53597	53597	53598
13965	16349	2	applied	\N	\N	\N	\N	53599	53599	53600
13965	16350	3	applied	\N	\N	\N	\N	53601	53601	53602
13967	16351	0	applied	\N	\N	\N	\N	53603	53603	53604
13967	16352	1	applied	\N	\N	\N	\N	53605	53605	53606
13967	16353	2	applied	\N	\N	\N	\N	53607	53607	53608
13967	16354	3	applied	\N	\N	\N	\N	53609	53609	53610
13970	16355	0	applied	\N	\N	\N	\N	53614	53614	53615
13970	16356	1	applied	\N	\N	\N	\N	53616	53616	53617
13970	16357	2	applied	\N	\N	\N	\N	53618	53618	53619
13970	16352	3	applied	\N	\N	\N	\N	53605	53605	53606
13970	16353	4	applied	\N	\N	\N	\N	53607	53607	53608
13970	16354	5	applied	\N	\N	\N	\N	53609	53609	53610
13970	16358	6	applied	\N	\N	\N	\N	53620	53620	53621
13970	16359	7	applied	\N	\N	\N	\N	53622	53622	53623
13970	16360	8	applied	\N	\N	\N	\N	53624	53624	53625
13970	16361	9	applied	\N	\N	\N	\N	53626	53626	53627
13970	16362	10	applied	\N	\N	\N	\N	53628	53628	53629
13970	16363	11	applied	\N	\N	\N	\N	53630	53630	53631
13972	16364	0	applied	\N	\N	\N	\N	53636	53636	53637
13972	16365	1	applied	\N	\N	\N	\N	53638	53638	53639
13972	16366	2	applied	\N	\N	\N	\N	53640	53640	53641
13972	16367	3	applied	\N	\N	\N	\N	53642	53642	53643
13972	16368	4	applied	\N	\N	\N	\N	53644	53644	53645
13972	16369	5	applied	\N	\N	\N	\N	53646	53646	53647
13972	16370	6	applied	\N	\N	\N	\N	53648	53648	53649
13972	16371	7	applied	\N	\N	\N	\N	53650	53650	53651
13979	16376	0	applied	\N	\N	\N	\N	53667	53667	53668
13979	16377	1	applied	\N	\N	\N	\N	53669	53669	53670
13979	16378	2	applied	\N	\N	\N	\N	53671	53671	53672
13979	16379	3	applied	\N	\N	\N	\N	53673	53673	53674
13982	16388	0	applied	\N	\N	\N	\N	53693	53693	53694
13982	16389	1	applied	\N	\N	\N	\N	53695	53695	53696
13982	16396	2	applied	\N	\N	\N	\N	53711	53711	53712
13982	16380	3	applied	\N	\N	\N	\N	53675	53675	53676
13982	16381	4	applied	\N	\N	\N	\N	53677	53677	53678
13982	16382	5	applied	\N	\N	\N	\N	53679	53679	53680
13982	16383	6	applied	\N	\N	\N	\N	53681	53681	53682
13982	16384	7	applied	\N	\N	\N	\N	53683	53683	53684
13982	16385	8	applied	\N	\N	\N	\N	53685	53685	53686
13982	16386	9	applied	\N	\N	\N	\N	53687	53687	53688
13982	16387	10	applied	\N	\N	\N	\N	53689	53689	53690
13987	16410	0	applied	\N	\N	\N	\N	53748	53748	53749
13987	16411	1	applied	\N	\N	\N	\N	53750	53750	53751
13987	16412	2	applied	\N	\N	\N	\N	53752	53752	53753
13987	16413	3	applied	\N	\N	\N	\N	53754	53754	53755
13994	16426	0	applied	\N	\N	\N	\N	53791	53791	53792
13994	16423	1	applied	\N	\N	\N	\N	53779	53779	53780
13994	16427	2	applied	\N	\N	\N	\N	53793	53793	25661
13994	16424	3	applied	\N	\N	\N	\N	53781	53781	53782
13994	16425	4	applied	\N	\N	\N	\N	53783	53783	53784
13994	16428	5	applied	\N	\N	\N	\N	53794	53794	53795
13994	16429	6	applied	\N	\N	\N	\N	53796	53796	53797
13994	16430	7	applied	\N	\N	\N	\N	53798	53798	53799
14005	16474	0	applied	\N	\N	\N	\N	53901	53901	53902
14005	16475	1	applied	\N	\N	\N	\N	53903	53903	53904
14005	16476	2	applied	\N	\N	\N	\N	53905	53905	53906
14005	16477	3	applied	\N	\N	\N	\N	53907	53907	53908
14005	16478	4	applied	\N	\N	\N	\N	53909	53909	53910
14005	16479	5	applied	\N	\N	\N	\N	53911	53911	53912
14005	16480	6	applied	\N	\N	\N	\N	53913	53913	53914
14005	16481	7	applied	\N	\N	\N	\N	53915	53915	53916
14005	16482	8	applied	\N	\N	\N	\N	53917	53917	53918
14005	16483	9	applied	\N	\N	\N	\N	53919	53919	53920
14005	16484	10	applied	\N	\N	\N	\N	53921	53921	53922
14005	16485	11	applied	\N	\N	\N	\N	53923	53923	53924
14005	16486	12	applied	\N	\N	\N	\N	53925	53925	53926
14010	16496	0	applied	\N	\N	\N	\N	53953	53953	53954
14010	16493	1	applied	\N	\N	\N	\N	53943	53943	53944
14010	16494	2	applied	\N	\N	\N	\N	53945	53945	53946
14010	16495	3	applied	\N	\N	\N	\N	53947	53947	53948
14010	16497	4	applied	\N	\N	\N	\N	53955	53955	53956
14010	16498	5	applied	\N	\N	\N	\N	53957	53957	53958
14021	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14021	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14021	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14021	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14021	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14021	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14021	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14021	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14021	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14021	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14025	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14025	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14025	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14025	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14025	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14025	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14025	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14025	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14025	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14025	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14031	16530	0	applied	\N	\N	\N	\N	54050	54050	54051
14031	16531	1	applied	\N	\N	\N	\N	54054	54054	54055
14033	16531	0	applied	\N	\N	\N	\N	54054	54054	54055
14037	16537	0	applied	\N	\N	\N	\N	54073	54073	54074
14039	16540	0	applied	\N	\N	\N	\N	54086	54086	54087
14039	16541	1	applied	\N	\N	\N	\N	54088	54088	54089
14039	16538	2	applied	\N	\N	\N	\N	54075	54075	54076
14039	16539	3	applied	\N	\N	\N	\N	54077	54077	54078
14039	16542	4	applied	\N	\N	\N	\N	54092	54092	54093
14039	16543	5	applied	\N	\N	\N	\N	54094	54094	54095
14039	16544	6	applied	\N	\N	\N	\N	54096	54096	54097
14039	16545	7	applied	\N	\N	\N	\N	54098	54098	54099
14050	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14050	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14050	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14050	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14050	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14050	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14050	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14050	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14050	16564	8	applied	\N	\N	\N	\N	54144	54144	54145
14050	16565	9	applied	\N	\N	\N	\N	54146	54146	54147
14050	16566	10	applied	\N	\N	\N	\N	54148	54148	54149
14052	16567	0	applied	\N	\N	\N	\N	54158	54158	54159
14052	16568	1	applied	\N	\N	\N	\N	54160	54160	25661
14052	16569	2	applied	\N	\N	\N	\N	54161	54161	54162
13981	16392	12	applied	\N	\N	\N	\N	53701	53701	53702
13981	16393	13	applied	\N	\N	\N	\N	53703	53703	53704
13981	16394	14	applied	\N	\N	\N	\N	53705	53705	53706
13981	16395	15	applied	\N	\N	\N	\N	53707	53707	53708
13983	16396	0	applied	\N	\N	\N	\N	53711	53711	53712
13983	16397	1	applied	\N	\N	\N	\N	53714	53714	53715
13983	16398	2	applied	\N	\N	\N	\N	53716	53716	53717
13983	16399	3	applied	\N	\N	\N	\N	53718	53718	53719
13993	16422	0	applied	\N	\N	\N	\N	53777	53777	53778
13995	16426	0	applied	\N	\N	\N	\N	53791	53791	53792
13995	16423	1	applied	\N	\N	\N	\N	53779	53779	53780
13995	16427	2	applied	\N	\N	\N	\N	53793	53793	25661
13995	16424	3	applied	\N	\N	\N	\N	53781	53781	53782
13995	16425	4	applied	\N	\N	\N	\N	53783	53783	53784
14003	16459	0	applied	\N	\N	\N	\N	53867	53867	53868
14006	16474	0	applied	\N	\N	\N	\N	53901	53901	53902
14006	16475	1	applied	\N	\N	\N	\N	53903	53903	53904
14006	16476	2	applied	\N	\N	\N	\N	53905	53905	53906
14006	16477	3	applied	\N	\N	\N	\N	53907	53907	53908
14011	16499	0	applied	\N	\N	\N	\N	53960	53960	53961
14011	16500	1	applied	\N	\N	\N	\N	53962	53962	25661
14011	16501	2	applied	\N	\N	\N	\N	53963	53963	53964
14011	16502	3	applied	\N	\N	\N	\N	53965	53965	53966
14011	16503	4	applied	\N	\N	\N	\N	53967	53967	25661
14014	16509	0	applied	\N	\N	\N	\N	53982	53982	53983
14014	16510	1	applied	\N	\N	\N	\N	53984	53984	53985
14014	16511	2	applied	\N	\N	\N	\N	53986	53986	53987
14014	16512	3	applied	\N	\N	\N	\N	53988	53988	53989
14014	16513	4	applied	\N	\N	\N	\N	53990	53990	53991
14023	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14023	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14023	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14027	16525	0	applied	\N	\N	\N	\N	54039	54039	54040
14027	16526	1	applied	\N	\N	\N	\N	54041	54041	54042
14027	16527	2	applied	\N	\N	\N	\N	54043	54043	54044
14027	16528	3	applied	\N	\N	\N	\N	54045	54045	54046
14027	16529	4	applied	\N	\N	\N	\N	54047	54047	25661
14028	16530	0	applied	\N	\N	\N	\N	54050	54050	54051
14038	16540	0	applied	\N	\N	\N	\N	54086	54086	54087
14038	16541	1	applied	\N	\N	\N	\N	54088	54088	54089
14040	16546	0	applied	\N	\N	\N	\N	54102	54102	54103
14040	16547	1	applied	\N	\N	\N	\N	54104	54104	54105
14040	16548	2	applied	\N	\N	\N	\N	54106	54106	54107
14040	16549	3	applied	\N	\N	\N	\N	54108	54108	54109
14040	16550	4	applied	\N	\N	\N	\N	54110	54110	54111
14040	16551	5	applied	\N	\N	\N	\N	54112	54112	54113
14040	16552	6	applied	\N	\N	\N	\N	54114	54114	54115
14040	16553	7	applied	\N	\N	\N	\N	54116	54116	54117
14043	16554	0	applied	\N	\N	\N	\N	54121	54121	54122
14043	16555	1	applied	\N	\N	\N	\N	54123	54123	54124
14045	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14045	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14045	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14045	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14045	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14045	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14045	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14045	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14045	16564	8	applied	\N	\N	\N	\N	54144	54144	54145
14045	16565	9	applied	\N	\N	\N	\N	54146	54146	54147
14045	16566	10	applied	\N	\N	\N	\N	54148	54148	54149
14048	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14048	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14048	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14048	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14048	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14048	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14048	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14048	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14048	16564	8	applied	\N	\N	\N	\N	54144	54144	54145
14048	16565	9	applied	\N	\N	\N	\N	54146	54146	54147
14048	16566	10	applied	\N	\N	\N	\N	54148	54148	54149
14051	16567	0	applied	\N	\N	\N	\N	54158	54158	54159
14051	16568	1	applied	\N	\N	\N	\N	54160	54160	25661
14051	16569	2	applied	\N	\N	\N	\N	54161	54161	54162
14051	16570	3	applied	\N	\N	\N	\N	54163	54163	54164
14051	16571	4	applied	\N	\N	\N	\N	54165	54165	54166
14056	16580	0	applied	\N	\N	\N	\N	54189	54189	54190
14056	16581	1	applied	\N	\N	\N	\N	54191	54191	54192
14056	16582	2	applied	\N	\N	\N	\N	54193	54193	54194
14056	16583	3	applied	\N	\N	\N	\N	54195	54195	54196
14068	16600	0	applied	\N	\N	\N	\N	54241	54241	54242
14068	16601	1	applied	\N	\N	\N	\N	54244	54244	54245
14068	16602	2	applied	\N	\N	\N	\N	54246	54246	54247
14068	16603	3	applied	\N	\N	\N	\N	54248	54248	54249
14071	16460	0	applied	\N	\N	\N	\N	53871	53871	53872
14071	16474	1	applied	\N	\N	\N	\N	53901	53901	53902
14071	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14071	16492	3	applied	\N	\N	\N	\N	53942	53942	25661
14071	16500	4	applied	\N	\N	\N	\N	53962	53962	25661
14071	16515	5	applied	\N	\N	\N	\N	53999	53999	25661
14071	16505	6	applied	\N	\N	\N	\N	53972	53972	25661
14071	16503	7	applied	\N	\N	\N	\N	53967	53967	25661
14071	16510	8	applied	\N	\N	\N	\N	53984	53984	53985
14071	16529	9	applied	\N	\N	\N	\N	54047	54047	25661
14071	16568	10	applied	\N	\N	\N	\N	54160	54160	25661
14071	16458	11	applied	\N	\N	\N	\N	53865	53865	53865
14071	16586	12	applied	\N	\N	\N	\N	54206	54206	1254
14072	16604	0	applied	\N	\N	\N	\N	54257	54257	54258
14072	16605	1	applied	\N	\N	\N	\N	54259	54259	54260
14072	16606	2	applied	\N	\N	\N	\N	54261	54261	54262
14072	16607	3	applied	\N	\N	\N	\N	54263	54263	54264
14083	16616	0	applied	\N	\N	\N	\N	54287	54287	54288
14083	16617	1	applied	\N	\N	\N	\N	54289	54289	54290
14083	16618	2	applied	\N	\N	1000000000	\N	54291	54291	54292
14083	16619	3	applied	\N	\N	1000000000	\N	54293	54293	54294
14083	16620	4	applied	\N	\N	\N	\N	54295	54295	54296
14083	16621	5	applied	\N	\N	\N	\N	54297	54297	54298
14086	16622	0	applied	\N	\N	\N	\N	54302	54302	54303
14086	16623	1	applied	\N	\N	\N	\N	54304	54304	54305
14086	16624	2	applied	\N	\N	\N	\N	54306	54306	54307
14086	16625	3	applied	\N	\N	\N	\N	54308	54308	54309
14086	16626	4	applied	\N	\N	\N	\N	54310	54310	54311
14086	16627	5	applied	\N	\N	\N	\N	54312	54312	54313
14086	16628	6	applied	\N	\N	\N	\N	54314	54314	54315
14086	16629	7	applied	\N	\N	\N	\N	54316	54316	54317
14086	16630	8	applied	\N	\N	\N	\N	54318	54318	54319
14088	16622	0	applied	\N	\N	\N	\N	54302	54302	54303
14004	16470	10	applied	\N	\N	\N	\N	53891	53891	53892
14004	16471	11	applied	\N	\N	\N	\N	53893	53893	53894
14004	16472	12	applied	\N	\N	\N	\N	53895	53895	53896
14004	16473	13	applied	\N	\N	\N	\N	53897	53897	53898
14007	16487	0	applied	\N	\N	\N	\N	53930	53930	53931
14007	16478	1	applied	\N	\N	\N	\N	53909	53909	53910
14007	16479	2	applied	\N	\N	\N	\N	53911	53911	53912
14007	16480	3	applied	\N	\N	\N	\N	53913	53913	53914
14007	16481	4	applied	\N	\N	\N	\N	53915	53915	53916
14007	16482	5	applied	\N	\N	\N	\N	53917	53917	53918
14007	16483	6	applied	\N	\N	\N	\N	53919	53919	53920
14007	16484	7	applied	\N	\N	\N	\N	53921	53921	53922
14007	16485	8	applied	\N	\N	\N	\N	53923	53923	53924
14007	16486	9	applied	\N	\N	\N	\N	53925	53925	53926
14007	16488	10	applied	\N	\N	\N	\N	53932	53932	53933
14007	16489	11	applied	\N	\N	\N	\N	53934	53934	53935
14007	16490	12	applied	\N	\N	\N	\N	53936	53936	53937
14009	16491	0	applied	\N	\N	\N	\N	53940	53940	53941
14009	16492	1	applied	\N	\N	\N	\N	53942	53942	25661
14012	16504	0	applied	\N	\N	\N	\N	53970	53970	53971
14012	16505	1	applied	\N	\N	\N	\N	53972	53972	25661
14012	16506	2	applied	\N	\N	\N	\N	53973	53973	53974
14012	16507	3	applied	\N	\N	\N	\N	53975	53975	53976
14012	16508	4	applied	\N	\N	\N	\N	53977	53977	53978
14015	16509	0	applied	\N	\N	\N	\N	53982	53982	53983
14015	16510	1	applied	\N	\N	\N	\N	53984	53984	53985
14015	16511	2	applied	\N	\N	\N	\N	53986	53986	53987
14015	16512	3	applied	\N	\N	\N	\N	53988	53988	53989
14015	16513	4	applied	\N	\N	\N	\N	53990	53990	53991
14017	16514	0	applied	\N	\N	\N	\N	53995	53995	53996
14020	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14020	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14020	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14020	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14020	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14020	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14020	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14020	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14020	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14020	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14024	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14024	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14024	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14024	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14024	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14024	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14024	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14024	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14024	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14024	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14030	16531	0	applied	\N	\N	\N	\N	54054	54054	54055
14030	16532	1	applied	\N	\N	\N	\N	54057	54057	54058
14030	16533	2	applied	\N	\N	\N	\N	54059	54059	54060
14030	16534	3	applied	\N	\N	\N	\N	54061	54061	54062
14030	16535	4	applied	\N	\N	\N	\N	54063	54063	54064
14030	16536	5	applied	\N	\N	\N	\N	54065	54065	54066
14032	16531	0	applied	\N	\N	\N	\N	54054	54054	54055
14032	16532	1	applied	\N	\N	\N	\N	54057	54057	54058
14032	16533	2	applied	\N	\N	\N	\N	54059	54059	54060
14032	16534	3	applied	\N	\N	\N	\N	54061	54061	54062
14032	16535	4	applied	\N	\N	\N	\N	54063	54063	54064
14032	16536	5	applied	\N	\N	\N	\N	54065	54065	54066
14036	16537	0	applied	\N	\N	\N	\N	54073	54073	54074
14036	16538	1	applied	\N	\N	\N	\N	54075	54075	54076
14036	16539	2	applied	\N	\N	\N	\N	54077	54077	54078
14041	16546	0	applied	\N	\N	\N	\N	54102	54102	54103
14041	16547	1	applied	\N	\N	\N	\N	54104	54104	54105
14041	16548	2	applied	\N	\N	\N	\N	54106	54106	54107
14041	16549	3	applied	\N	\N	\N	\N	54108	54108	54109
14041	16550	4	applied	\N	\N	\N	\N	54110	54110	54111
14041	16551	5	applied	\N	\N	\N	\N	54112	54112	54113
14041	16552	6	applied	\N	\N	\N	\N	54114	54114	54115
14041	16553	7	applied	\N	\N	\N	\N	54116	54116	54117
14046	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14046	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14046	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14046	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14046	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14046	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14046	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14046	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14046	16564	8	applied	\N	\N	\N	\N	54144	54144	54145
14046	16565	9	applied	\N	\N	\N	\N	54146	54146	54147
14046	16566	10	applied	\N	\N	\N	\N	54148	54148	54149
14049	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14049	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14054	16572	0	applied	\N	\N	\N	\N	54171	54171	54172
14054	16573	1	applied	\N	\N	\N	\N	54173	54173	54174
14054	16574	2	applied	\N	\N	\N	\N	54175	54175	54176
14054	16575	3	applied	\N	\N	\N	\N	54177	54177	54178
14054	16576	4	applied	\N	\N	\N	\N	54179	54179	54180
14054	16577	5	applied	\N	\N	\N	\N	54181	54181	54182
14054	16578	6	applied	\N	\N	\N	\N	54183	54183	54184
14054	16579	7	applied	\N	\N	\N	\N	54185	54185	54186
14057	16581	0	applied	\N	\N	\N	\N	54191	54191	54192
14057	16582	1	applied	\N	\N	\N	\N	54193	54193	54194
14057	16583	2	applied	\N	\N	\N	\N	54195	54195	54196
14058	16581	0	applied	\N	\N	\N	\N	54191	54191	54192
14058	16582	1	applied	\N	\N	\N	\N	54193	54193	54194
14058	16583	2	applied	\N	\N	\N	\N	54195	54195	54196
14061	16592	0	applied	\N	\N	\N	\N	54220	54220	54221
14061	16593	1	applied	\N	\N	\N	\N	54222	54222	54223
14061	16594	2	applied	\N	\N	\N	\N	54224	54224	54225
14061	16595	3	applied	\N	\N	\N	\N	54226	54226	54227
14069	16600	0	applied	\N	\N	\N	\N	54241	54241	54242
14069	16601	1	applied	\N	\N	\N	\N	54244	54244	54245
14069	16602	2	applied	\N	\N	\N	\N	54246	54246	54247
14069	16603	3	applied	\N	\N	\N	\N	54248	54248	54249
14073	16604	0	applied	\N	\N	\N	\N	54257	54257	54258
14073	16605	1	applied	\N	\N	\N	\N	54259	54259	54260
14073	16606	2	applied	\N	\N	\N	\N	54261	54261	54262
14073	16607	3	applied	\N	\N	\N	\N	54263	54263	54264
14077	16608	0	applied	\N	\N	\N	\N	54268	54268	54269
14077	16609	1	applied	\N	\N	\N	\N	54270	54270	54271
14077	16610	2	applied	\N	\N	\N	\N	54272	54272	54273
14077	16611	3	applied	\N	\N	\N	\N	54274	54274	54275
14077	16612	4	applied	\N	\N	\N	\N	54276	54276	54277
14077	16613	5	applied	\N	\N	\N	\N	54278	54278	54279
14077	16614	6	applied	\N	\N	\N	\N	54280	54280	54281
14018	16270	13	applied	\N	\N	\N	\N	53416	53416	53615
14018	16503	14	applied	\N	\N	\N	\N	53967	53967	25661
14018	16510	15	applied	\N	\N	\N	\N	53984	53984	53985
14018	16458	16	applied	\N	\N	\N	\N	53865	53865	53865
14022	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14022	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14022	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14022	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14022	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14022	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14022	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14022	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14022	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14022	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14026	16516	0	applied	\N	\N	\N	\N	54003	54003	54004
14026	16517	1	applied	\N	\N	\N	\N	54005	54005	54006
14026	16515	2	applied	\N	\N	\N	\N	53999	53999	25661
14026	16518	3	applied	\N	\N	\N	\N	54007	54007	54008
14026	16519	4	applied	\N	\N	\N	\N	54009	54009	54010
14026	16520	5	applied	\N	\N	\N	\N	54011	54011	54012
14026	16521	6	applied	\N	\N	\N	\N	54013	54013	54014
14026	16522	7	applied	\N	\N	\N	\N	54015	54015	54016
14026	16523	8	applied	\N	\N	\N	\N	54017	54017	54018
14026	16524	9	applied	\N	\N	\N	\N	54019	54019	54020
14029	16531	0	applied	\N	\N	\N	\N	54054	54054	54055
14034	16537	0	applied	\N	\N	\N	\N	54073	54073	54074
14034	16538	1	applied	\N	\N	\N	\N	54075	54075	54076
14034	16539	2	applied	\N	\N	\N	\N	54077	54077	54078
14035	16537	0	applied	\N	\N	\N	\N	54073	54073	54074
14042	16554	0	applied	\N	\N	\N	\N	54121	54121	54122
14042	16555	1	applied	\N	\N	\N	\N	54123	54123	54124
14042	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14042	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14042	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14042	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14042	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14042	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14044	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14044	16563	1	applied	\N	\N	\N	\N	54141	54141	54142
14044	16556	2	applied	\N	\N	\N	\N	54125	54125	54126
14044	16557	3	applied	\N	\N	\N	\N	54127	54127	54128
14044	16558	4	applied	\N	\N	\N	\N	54129	54129	54130
14044	16559	5	applied	\N	\N	\N	\N	54131	54131	54132
14044	16560	6	applied	\N	\N	\N	\N	54133	54133	54134
14044	16561	7	applied	\N	\N	\N	\N	54135	54135	54136
14047	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14047	16556	1	applied	\N	\N	\N	\N	54125	54125	54126
14047	16557	2	applied	\N	\N	\N	\N	54127	54127	54128
14047	16558	3	applied	\N	\N	\N	\N	54129	54129	54130
14047	16559	4	applied	\N	\N	\N	\N	54131	54131	54132
14047	16560	5	applied	\N	\N	\N	\N	54133	54133	54134
14047	16561	6	applied	\N	\N	\N	\N	54135	54135	54136
14047	16564	7	applied	\N	\N	\N	\N	54144	54144	54145
14047	16565	8	applied	\N	\N	\N	\N	54146	54146	54147
14047	16566	9	applied	\N	\N	\N	\N	54148	54148	54149
14053	16572	0	applied	\N	\N	\N	\N	54171	54171	54172
14053	16573	1	applied	\N	\N	\N	\N	54173	54173	54174
14055	16580	0	applied	\N	\N	\N	\N	54189	54189	54190
14055	16581	1	applied	\N	\N	\N	\N	54191	54191	54192
14055	16582	2	applied	\N	\N	\N	\N	54193	54193	54194
14055	16583	3	applied	\N	\N	\N	\N	54195	54195	54196
14060	16584	0	applied	\N	\N	\N	\N	54202	54202	54203
14060	16585	1	applied	\N	\N	\N	\N	54204	54204	54205
14060	16586	2	applied	\N	\N	\N	\N	54206	54206	1254
14060	16587	3	applied	\N	\N	\N	\N	54207	54207	54208
14060	16588	4	applied	\N	\N	\N	\N	54209	54209	54210
14060	16589	5	applied	\N	\N	\N	\N	54211	54211	54212
14060	16590	6	applied	\N	\N	\N	\N	54213	54213	54214
14060	16591	7	applied	\N	\N	\N	\N	54215	54215	54216
14067	16600	0	applied	\N	\N	\N	\N	54241	54241	54242
14070	16600	0	applied	\N	\N	\N	\N	54241	54241	54242
14070	16601	1	applied	\N	\N	\N	\N	54244	54244	54245
14070	16602	2	applied	\N	\N	\N	\N	54246	54246	54247
14070	16603	3	applied	\N	\N	\N	\N	54248	54248	54249
14085	16622	0	applied	\N	\N	\N	\N	54302	54302	54303
14085	16623	1	applied	\N	\N	\N	\N	54304	54304	54305
14085	16624	2	applied	\N	\N	\N	\N	54306	54306	54307
14085	16625	3	applied	\N	\N	\N	\N	54308	54308	54309
14085	16626	4	applied	\N	\N	\N	\N	54310	54310	54311
14085	16627	5	applied	\N	\N	\N	\N	54312	54312	54313
14085	16628	6	applied	\N	\N	\N	\N	54314	54314	54315
14085	16629	7	applied	\N	\N	\N	\N	54316	54316	54317
14085	16630	8	applied	\N	\N	\N	\N	54318	54318	54319
14089	16631	0	applied	\N	\N	\N	\N	54327	54327	54328
14098	16639	0	applied	\N	\N	\N	\N	54351	54351	54352
14098	16632	1	applied	\N	\N	\N	\N	54331	54331	54332
14098	16633	2	applied	\N	\N	\N	\N	54333	54333	54334
14098	16634	3	applied	\N	\N	\N	\N	54335	54335	54336
14098	16637	4	applied	\N	\N	\N	\N	54345	54345	54346
14098	16638	5	applied	\N	\N	\N	\N	54347	54347	54348
14098	16640	6	applied	\N	\N	\N	\N	54353	54353	54354
14098	16641	7	applied	\N	\N	\N	\N	54355	54355	54356
14098	16642	8	applied	\N	\N	\N	\N	54357	54357	54358
14105	16650	0	applied	\N	\N	\N	\N	54382	54382	54383
14111	16658	0	applied	\N	\N	\N	\N	54402	54402	54403
14111	16659	1	applied	\N	\N	\N	\N	54406	54406	54407
14111	16660	2	applied	\N	\N	\N	\N	54409	54409	54410
14111	16661	3	applied	\N	\N	\N	\N	54411	54411	54412
14113	16658	0	applied	\N	\N	\N	\N	54402	54402	54403
14116	16674	0	applied	\N	\N	\N	\N	54444	54444	54445
14116	16675	1	applied	\N	\N	\N	\N	54446	54446	54447
14116	16676	2	applied	\N	\N	\N	\N	54448	54448	54449
14116	16677	3	applied	\N	\N	\N	\N	54450	54450	54451
14125	16690	0	applied	\N	\N	\N	\N	54485	54485	54486
14125	16691	1	applied	\N	\N	\N	\N	54487	54487	54488
14125	16692	2	applied	\N	\N	\N	\N	54489	54489	54490
14125	16693	3	applied	\N	\N	\N	\N	54491	54491	54492
14129	16662	0	applied	\N	\N	\N	\N	54418	54418	54419
14129	16663	1	applied	\N	\N	\N	\N	54420	54420	54421
14129	16664	2	applied	\N	\N	\N	\N	54422	54422	54423
14129	16674	3	applied	\N	\N	\N	\N	54444	54444	54445
14129	16678	4	applied	\N	\N	\N	\N	54452	54452	54453
14129	16682	5	applied	\N	\N	\N	\N	54462	54462	54463
14129	16686	6	applied	\N	\N	\N	\N	54473	54473	54474
14129	16690	7	applied	\N	\N	\N	\N	54485	54485	54486
14129	16659	8	applied	\N	\N	\N	\N	54406	54406	54407
14129	16660	9	applied	\N	\N	\N	\N	54409	54409	54410
14129	16661	10	applied	\N	\N	\N	\N	54411	54411	54412
14129	16665	11	applied	\N	\N	\N	\N	54424	54424	54425
14052	16570	3	applied	\N	\N	\N	\N	54163	54163	54164
14052	16571	4	applied	\N	\N	\N	\N	54165	54165	54166
14059	16584	0	applied	\N	\N	\N	\N	54202	54202	54203
14059	16585	1	applied	\N	\N	\N	\N	54204	54204	54205
14059	16586	2	applied	\N	\N	\N	\N	54206	54206	1254
14059	16587	3	applied	\N	\N	\N	\N	54207	54207	54208
14059	16588	4	applied	\N	\N	\N	\N	54209	54209	54210
14059	16589	5	applied	\N	\N	\N	\N	54211	54211	54212
14059	16590	6	applied	\N	\N	\N	\N	54213	54213	54214
14059	16591	7	applied	\N	\N	\N	\N	54215	54215	54216
14062	16592	0	applied	\N	\N	\N	\N	54220	54220	54221
14064	16592	0	applied	\N	\N	\N	\N	54220	54220	54221
14064	16593	1	applied	\N	\N	\N	\N	54222	54222	54223
14064	16594	2	applied	\N	\N	\N	\N	54224	54224	54225
14064	16595	3	applied	\N	\N	\N	\N	54226	54226	54227
14066	16596	0	applied	\N	\N	\N	\N	54232	54232	54233
14066	16597	1	applied	\N	\N	\N	\N	54234	54234	54235
14066	16598	2	applied	\N	\N	\N	\N	54236	54236	54237
14066	16599	3	applied	\N	\N	\N	\N	54238	54238	54239
14087	16622	0	applied	\N	\N	\N	\N	54302	54302	54303
14087	16623	1	applied	\N	\N	\N	\N	54304	54304	54305
14087	16624	2	applied	\N	\N	\N	\N	54306	54306	54307
14087	16625	3	applied	\N	\N	\N	\N	54308	54308	54309
14087	16626	4	applied	\N	\N	\N	\N	54310	54310	54311
14087	16627	5	applied	\N	\N	\N	\N	54312	54312	54313
14087	16628	6	applied	\N	\N	\N	\N	54314	54314	54315
14087	16629	7	applied	\N	\N	\N	\N	54316	54316	54317
14087	16630	8	applied	\N	\N	\N	\N	54318	54318	54319
14092	16631	0	applied	\N	\N	\N	\N	54327	54327	54328
14092	16632	1	applied	\N	\N	\N	\N	54331	54331	54332
14092	16633	2	applied	\N	\N	\N	\N	54333	54333	54334
14092	16634	3	applied	\N	\N	\N	\N	54335	54335	54336
14097	16639	0	applied	\N	\N	\N	\N	54351	54351	54352
14097	16632	1	applied	\N	\N	\N	\N	54331	54331	54332
14097	16633	2	applied	\N	\N	\N	\N	54333	54333	54334
14097	16634	3	applied	\N	\N	\N	\N	54335	54335	54336
14097	16637	4	applied	\N	\N	\N	\N	54345	54345	54346
14097	16638	5	applied	\N	\N	\N	\N	54347	54347	54348
14097	16640	6	applied	\N	\N	\N	\N	54353	54353	54354
14097	16641	7	applied	\N	\N	\N	\N	54355	54355	54356
14097	16642	8	applied	\N	\N	\N	\N	54357	54357	54358
14100	16643	0	applied	\N	\N	\N	\N	54362	54362	54363
14100	16644	1	applied	\N	\N	\N	\N	54365	54365	54366
14100	16645	2	applied	\N	\N	\N	\N	54367	54367	54368
14100	16646	3	applied	\N	\N	\N	\N	54369	54369	54370
14103	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14103	16636	1	applied	\N	\N	\N	\N	54343	54343	25661
14103	16586	2	applied	\N	\N	\N	\N	54206	54206	1254
14103	16529	3	applied	\N	\N	\N	\N	54047	54047	25661
14103	16568	4	applied	\N	\N	\N	\N	54160	54160	25661
14104	16650	0	applied	\N	\N	\N	\N	54382	54382	54383
14104	16651	1	applied	\N	\N	\N	\N	54384	54384	54385
14104	16652	2	applied	\N	\N	\N	\N	54386	54386	54387
14104	16653	3	applied	\N	\N	\N	\N	54388	54388	54389
14109	16654	0	applied	\N	\N	\N	\N	54394	54394	54395
14109	16658	1	applied	\N	\N	\N	\N	54402	54402	54403
14109	16655	2	applied	\N	\N	\N	\N	54396	54396	54397
14109	16656	3	applied	\N	\N	\N	\N	54398	54398	54399
14109	16657	4	applied	\N	\N	\N	\N	54400	54400	54401
14115	16662	0	applied	\N	\N	\N	\N	54418	54418	54419
14115	16663	1	applied	\N	\N	\N	\N	54420	54420	54421
14115	16664	2	applied	\N	\N	\N	\N	54422	54422	54423
14115	16659	3	applied	\N	\N	\N	\N	54406	54406	54407
14115	16660	4	applied	\N	\N	\N	\N	54409	54409	54410
14115	16661	5	applied	\N	\N	\N	\N	54411	54411	54412
14115	16665	6	applied	\N	\N	\N	\N	54424	54424	54425
14115	16666	7	applied	\N	\N	\N	\N	54426	54426	54427
14115	16667	8	applied	\N	\N	\N	\N	54428	54428	54429
14115	16668	9	applied	\N	\N	\N	\N	54430	54430	54431
14115	16669	10	applied	\N	\N	\N	\N	54432	54432	54433
14115	16670	11	applied	\N	\N	\N	\N	54434	54434	54435
14115	16671	12	applied	\N	\N	\N	\N	54436	54436	54437
14115	16672	13	applied	\N	\N	\N	\N	54438	54438	54439
14115	16673	14	applied	\N	\N	\N	\N	54440	54440	54441
14118	16682	0	applied	\N	\N	\N	\N	54462	54462	54463
14118	16683	1	applied	\N	\N	\N	\N	54464	54464	54465
14118	16684	2	applied	\N	\N	\N	\N	54466	54466	54467
14118	16685	3	applied	\N	\N	\N	\N	54468	54468	54469
14123	16686	0	applied	\N	\N	\N	\N	54473	54473	54474
14123	16687	1	applied	\N	\N	\N	\N	54475	54475	54476
14123	16688	2	applied	\N	\N	\N	\N	54477	54477	54478
14123	16689	3	applied	\N	\N	\N	\N	54479	54479	54480
14141	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14141	16709	1	applied	\N	\N	\N	\N	54545	54545	54546
14141	16710	2	applied	\N	\N	\N	\N	54547	54547	54548
14141	16711	3	applied	\N	\N	\N	\N	54549	54549	54550
14141	16712	4	applied	\N	\N	\N	\N	54551	54551	54552
14141	16713	5	applied	\N	\N	\N	\N	54553	54553	54554
14145	16705	0	applied	\N	\N	\N	\N	54534	54534	54535
14145	16708	1	applied	\N	\N	\N	\N	54543	54543	54544
14145	16709	2	applied	\N	\N	\N	\N	54545	54545	54546
14145	16706	3	applied	\N	\N	\N	\N	54536	54536	54537
14145	16707	4	applied	\N	\N	\N	\N	54538	54538	54539
14145	16710	5	applied	\N	\N	\N	\N	54547	54547	54548
14145	16711	6	applied	\N	\N	\N	\N	54549	54549	54550
14145	16712	7	applied	\N	\N	\N	\N	54551	54551	54552
14145	16713	8	applied	\N	\N	\N	\N	54553	54553	54554
14146	16714	0	applied	\N	\N	\N	\N	54615	54615	54616
14146	16715	1	applied	\N	\N	\N	\N	54617	54617	54618
14146	16716	2	applied	\N	\N	\N	\N	54619	54619	54620
14149	16714	0	applied	\N	\N	\N	\N	54615	54615	54616
14149	16715	1	applied	\N	\N	\N	\N	54617	54617	54618
14149	16716	2	applied	\N	\N	\N	\N	54619	54619	54620
14153	16720	0	applied	\N	\N	\N	\N	54633	54633	54634
14153	16721	1	applied	\N	\N	\N	\N	54635	54635	54636
14153	16718	2	applied	\N	\N	\N	\N	54626	54626	54627
14153	16719	3	applied	\N	\N	\N	\N	54628	54628	54629
14153	16722	4	applied	\N	\N	\N	\N	54637	54637	54638
14153	16723	5	applied	\N	\N	\N	\N	54639	54639	54640
14153	16724	6	applied	\N	\N	\N	\N	54641	54641	54642
14153	16725	7	applied	\N	\N	\N	\N	54643	54643	54644
14162	16733	0	applied	\N	\N	\N	\N	54665	54665	54666
14165	16740	0	applied	\N	\N	\N	\N	54683	54683	54684
14165	16741	1	applied	\N	\N	\N	\N	54685	54685	54686
14165	16742	2	applied	\N	\N	\N	\N	54687	54687	54688
14170	16753	0	applied	\N	\N	\N	\N	54720	54720	54721
14170	16754	1	applied	\N	\N	\N	\N	54722	54722	54723
14170	16755	2	applied	\N	\N	\N	\N	54724	54724	54725
14170	16756	3	applied	\N	\N	\N	\N	54726	54726	54727
14077	16615	7	applied	\N	\N	\N	\N	54282	54282	54283
14084	16616	0	applied	\N	\N	\N	\N	54287	54287	54288
14084	16617	1	applied	\N	\N	\N	\N	54289	54289	54290
14084	16618	2	applied	\N	\N	1000000000	\N	54291	54291	54292
14084	16619	3	applied	\N	\N	1000000000	\N	54293	54293	54294
14084	16620	4	applied	\N	\N	\N	\N	54295	54295	54296
14084	16621	5	applied	\N	\N	\N	\N	54297	54297	54298
14091	16631	0	applied	\N	\N	\N	\N	54327	54327	54328
14091	16632	1	applied	\N	\N	\N	\N	54331	54331	54332
14091	16633	2	applied	\N	\N	\N	\N	54333	54333	54334
14091	16634	3	applied	\N	\N	\N	\N	54335	54335	54336
14095	16635	0	applied	\N	\N	\N	\N	54341	54341	54342
14095	16636	1	applied	\N	\N	\N	\N	54343	54343	25661
14095	16632	2	applied	\N	\N	\N	\N	54331	54331	54332
14095	16633	3	applied	\N	\N	\N	\N	54333	54333	54334
14095	16634	4	applied	\N	\N	\N	\N	54335	54335	54336
14095	16637	5	applied	\N	\N	\N	\N	54345	54345	54346
14095	16638	6	applied	\N	\N	\N	\N	54347	54347	54348
14099	16643	0	applied	\N	\N	\N	\N	54362	54362	54363
14108	16654	0	applied	\N	\N	\N	\N	54394	54394	54395
14108	16655	1	applied	\N	\N	\N	\N	54396	54396	54397
14108	16656	2	applied	\N	\N	\N	\N	54398	54398	54399
14108	16657	3	applied	\N	\N	\N	\N	54400	54400	54401
14117	16678	0	applied	\N	\N	\N	\N	54452	54452	54453
14117	16679	1	applied	\N	\N	\N	\N	54454	54454	54455
14117	16680	2	applied	\N	\N	\N	\N	54456	54456	54457
14117	16681	3	applied	\N	\N	\N	\N	54458	54458	54459
14120	16682	0	applied	\N	\N	\N	\N	54462	54462	54463
14122	16686	0	applied	\N	\N	\N	\N	54473	54473	54474
14122	16687	1	applied	\N	\N	\N	\N	54475	54475	54476
14122	16688	2	applied	\N	\N	\N	\N	54477	54477	54478
14122	16689	3	applied	\N	\N	\N	\N	54479	54479	54480
14127	16691	0	applied	\N	\N	\N	\N	54487	54487	54488
14127	16692	1	applied	\N	\N	\N	\N	54489	54489	54490
14127	16693	2	applied	\N	\N	\N	\N	54491	54491	54492
14131	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14131	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14131	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14131	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14131	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14131	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14131	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14131	16701	8	applied	\N	\N	\N	\N	54518	54518	54519
14131	16702	9	applied	\N	\N	\N	\N	54520	54520	54521
14131	16703	10	applied	\N	\N	\N	\N	54522	54522	54523
14131	16704	11	applied	\N	\N	\N	\N	54524	54524	54525
14134	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14134	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14134	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14134	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14134	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14134	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14134	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14134	16701	8	applied	\N	\N	\N	\N	54518	54518	54519
14134	16702	9	applied	\N	\N	\N	\N	54520	54520	54521
14134	16703	10	applied	\N	\N	\N	\N	54522	54522	54523
14134	16704	11	applied	\N	\N	\N	\N	54524	54524	54525
14137	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14137	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14137	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14137	16705	3	applied	\N	\N	\N	\N	54534	54534	54535
14137	16693	4	applied	\N	\N	\N	\N	54491	54491	54492
14137	16697	5	applied	\N	\N	\N	\N	54507	54507	54508
14137	16698	6	applied	\N	\N	\N	\N	54509	54509	54510
14137	16699	7	applied	\N	\N	\N	\N	54511	54511	54512
14137	16700	8	applied	\N	\N	\N	\N	54513	54513	54514
14137	16701	9	applied	\N	\N	\N	\N	54518	54518	54519
14137	16702	10	applied	\N	\N	\N	\N	54520	54520	54521
14137	16703	11	applied	\N	\N	\N	\N	54522	54522	54523
14137	16704	12	applied	\N	\N	\N	\N	54524	54524	54525
14137	16706	13	applied	\N	\N	\N	\N	54536	54536	54537
14137	16707	14	applied	\N	\N	\N	\N	54538	54538	54539
14140	16460	0	applied	\N	\N	\N	\N	53871	53871	53872
14140	16474	1	applied	\N	\N	\N	\N	53901	53901	53902
14140	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14140	16069	3	applied	\N	\N	\N	\N	52894	52894	52895
14140	16319	4	applied	\N	\N	\N	\N	53535	53535	54557
14140	16355	5	applied	\N	\N	\N	\N	53614	53614	54558
14140	16070	6	applied	\N	\N	\N	\N	52896	52896	52897
14140	16077	7	applied	\N	\N	\N	\N	52911	52911	52912
14140	16081	8	applied	\N	\N	\N	\N	52921	52921	52922
14140	16085	9	applied	\N	\N	\N	\N	52931	52931	52932
14140	16089	10	applied	\N	\N	\N	\N	52943	52943	52944
14140	16093	11	applied	\N	\N	\N	\N	52955	52955	52956
14140	16097	12	applied	\N	\N	\N	\N	52965	52965	52966
14140	16101	13	applied	\N	\N	\N	\N	52975	52975	52976
14140	16108	14	applied	\N	\N	\N	\N	52991	52991	52992
14140	16109	15	applied	\N	\N	\N	\N	52993	52993	52994
14140	16116	16	applied	\N	\N	\N	\N	53015	53015	53016
14140	16120	17	applied	\N	\N	\N	\N	53025	53025	53026
14140	16121	18	applied	\N	\N	\N	\N	53027	53027	53028
14140	16127	19	applied	\N	\N	\N	\N	53041	53041	53042
14140	16128	20	applied	\N	\N	\N	\N	53043	53043	53044
14140	16129	21	applied	\N	\N	\N	\N	53045	53045	53046
14140	16140	22	applied	\N	\N	\N	\N	53073	53073	53074
14140	16141	23	applied	\N	\N	\N	\N	53075	53075	53076
14140	16148	24	applied	\N	\N	\N	\N	53097	53097	53098
14140	16149	25	applied	\N	\N	\N	\N	53099	53099	53100
14140	16156	26	applied	\N	\N	\N	\N	53116	53116	53117
14140	16157	27	applied	\N	\N	\N	\N	53118	53118	53119
14140	16164	28	applied	\N	\N	\N	\N	53134	53134	53135
14140	16167	29	applied	\N	\N	\N	\N	53142	53142	53143
14140	16171	30	applied	\N	\N	\N	\N	53155	53155	53156
14140	16175	31	applied	\N	\N	\N	\N	53167	53167	53168
14140	16176	32	applied	\N	\N	\N	\N	53169	53169	53170
14140	16177	33	applied	\N	\N	\N	\N	53171	53171	53172
14140	16187	34	applied	\N	\N	\N	\N	53200	53200	53201
14140	16188	35	applied	\N	\N	\N	\N	53202	53202	53203
14140	16189	36	applied	\N	\N	\N	\N	53204	53204	53205
14140	16190	37	applied	\N	\N	\N	\N	53206	53206	53207
14140	16191	38	applied	\N	\N	\N	\N	53208	53208	53209
14140	16206	39	applied	\N	\N	\N	\N	53245	53245	53246
14140	16210	40	applied	\N	\N	\N	\N	53254	53254	53255
14140	16214	41	applied	\N	\N	\N	\N	53263	53263	53264
14140	16215	42	applied	\N	\N	\N	\N	53265	53265	53266
14140	16222	43	applied	\N	\N	\N	\N	53283	53283	53284
14140	16226	44	applied	\N	\N	\N	\N	53294	53294	53295
14140	16230	45	applied	\N	\N	\N	\N	53314	53314	53315
14140	16231	46	applied	\N	\N	\N	\N	53316	53316	53317
14088	16623	1	applied	\N	\N	\N	\N	54304	54304	54305
14088	16624	2	applied	\N	\N	\N	\N	54306	54306	54307
14088	16625	3	applied	\N	\N	\N	\N	54308	54308	54309
14088	16626	4	applied	\N	\N	\N	\N	54310	54310	54311
14088	16627	5	applied	\N	\N	\N	\N	54312	54312	54313
14088	16628	6	applied	\N	\N	\N	\N	54314	54314	54315
14088	16629	7	applied	\N	\N	\N	\N	54316	54316	54317
14088	16630	8	applied	\N	\N	\N	\N	54318	54318	54319
14090	16631	0	applied	\N	\N	\N	\N	54327	54327	54328
14090	16632	1	applied	\N	\N	\N	\N	54331	54331	54332
14090	16633	2	applied	\N	\N	\N	\N	54333	54333	54334
14090	16634	3	applied	\N	\N	\N	\N	54335	54335	54336
14093	16631	0	applied	\N	\N	\N	\N	54327	54327	54328
14094	16635	0	applied	\N	\N	\N	\N	54341	54341	54342
14094	16636	1	applied	\N	\N	\N	\N	54343	54343	25661
14096	16635	0	applied	\N	\N	\N	\N	54341	54341	54342
14096	16636	1	applied	\N	\N	\N	\N	54343	54343	25661
14096	16632	2	applied	\N	\N	\N	\N	54331	54331	54332
14096	16633	3	applied	\N	\N	\N	\N	54333	54333	54334
14096	16634	4	applied	\N	\N	\N	\N	54335	54335	54336
14096	16637	5	applied	\N	\N	\N	\N	54345	54345	54346
14096	16638	6	applied	\N	\N	\N	\N	54347	54347	54348
14102	16647	0	applied	\N	\N	\N	\N	54372	54372	54373
14102	16644	1	applied	\N	\N	\N	\N	54365	54365	54366
14102	16645	2	applied	\N	\N	\N	\N	54367	54367	54368
14102	16646	3	applied	\N	\N	\N	\N	54369	54369	54370
14102	16648	4	applied	\N	\N	\N	\N	54374	54374	54375
14102	16649	5	applied	\N	\N	\N	\N	54376	54376	54377
14106	16650	0	applied	\N	\N	\N	\N	54382	54382	54383
14106	16651	1	applied	\N	\N	\N	\N	54384	54384	54385
14106	16652	2	applied	\N	\N	\N	\N	54386	54386	54387
14106	16653	3	applied	\N	\N	\N	\N	54388	54388	54389
14107	16654	0	applied	\N	\N	\N	\N	54394	54394	54395
14107	16655	1	applied	\N	\N	\N	\N	54396	54396	54397
14107	16656	2	applied	\N	\N	\N	\N	54398	54398	54399
14107	16657	3	applied	\N	\N	\N	\N	54400	54400	54401
14110	16654	0	applied	\N	\N	\N	\N	54394	54394	54395
14110	16658	1	applied	\N	\N	\N	\N	54402	54402	54403
14110	16655	2	applied	\N	\N	\N	\N	54396	54396	54397
14110	16656	3	applied	\N	\N	\N	\N	54398	54398	54399
14110	16657	4	applied	\N	\N	\N	\N	54400	54400	54401
14110	16659	5	applied	\N	\N	\N	\N	54406	54406	54407
14112	16658	0	applied	\N	\N	\N	\N	54402	54402	54403
14112	16659	1	applied	\N	\N	\N	\N	54406	54406	54407
14112	16660	2	applied	\N	\N	\N	\N	54409	54409	54410
14112	16661	3	applied	\N	\N	\N	\N	54411	54411	54412
14119	16682	0	applied	\N	\N	\N	\N	54462	54462	54463
14119	16683	1	applied	\N	\N	\N	\N	54464	54464	54465
14119	16684	2	applied	\N	\N	\N	\N	54466	54466	54467
14119	16685	3	applied	\N	\N	\N	\N	54468	54468	54469
14121	16686	0	applied	\N	\N	\N	\N	54473	54473	54474
14121	16687	1	applied	\N	\N	\N	\N	54475	54475	54476
14121	16688	2	applied	\N	\N	\N	\N	54477	54477	54478
14121	16689	3	applied	\N	\N	\N	\N	54479	54479	54480
14126	16690	0	applied	\N	\N	\N	\N	54485	54485	54486
14126	16691	1	applied	\N	\N	\N	\N	54487	54487	54488
14126	16692	2	applied	\N	\N	\N	\N	54489	54489	54490
14126	16693	3	applied	\N	\N	\N	\N	54491	54491	54492
14128	16690	0	applied	\N	\N	\N	\N	54485	54485	54486
14128	16691	1	applied	\N	\N	\N	\N	54487	54487	54488
14128	16692	2	applied	\N	\N	\N	\N	54489	54489	54490
14130	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14130	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14130	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14130	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14130	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14130	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14130	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14133	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14133	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14133	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14133	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14133	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14133	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14133	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14133	16701	8	applied	\N	\N	\N	\N	54518	54518	54519
14133	16702	9	applied	\N	\N	\N	\N	54520	54520	54521
14133	16703	10	applied	\N	\N	\N	\N	54522	54522	54523
14133	16704	11	applied	\N	\N	\N	\N	54524	54524	54525
14136	16705	0	applied	\N	\N	\N	\N	54534	54534	54535
14136	16706	1	applied	\N	\N	\N	\N	54536	54536	54537
14136	16707	2	applied	\N	\N	\N	\N	54538	54538	54539
14139	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14139	16709	1	applied	\N	\N	\N	\N	54545	54545	54546
14139	16710	2	applied	\N	\N	\N	\N	54547	54547	54548
14139	16711	3	applied	\N	\N	\N	\N	54549	54549	54550
14139	16712	4	applied	\N	\N	\N	\N	54551	54551	54552
14139	16713	5	applied	\N	\N	\N	\N	54553	54553	54554
14143	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14143	16709	1	applied	\N	\N	\N	\N	54545	54545	54546
14143	16710	2	applied	\N	\N	\N	\N	54547	54547	54548
14143	16711	3	applied	\N	\N	\N	\N	54549	54549	54550
14143	16712	4	applied	\N	\N	\N	\N	54551	54551	54552
14143	16713	5	applied	\N	\N	\N	\N	54553	54553	54554
14144	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14144	16709	1	applied	\N	\N	\N	\N	54545	54545	54546
14144	16710	2	applied	\N	\N	\N	\N	54547	54547	54548
14144	16711	3	applied	\N	\N	\N	\N	54549	54549	54550
14144	16712	4	applied	\N	\N	\N	\N	54551	54551	54552
14144	16713	5	applied	\N	\N	\N	\N	54553	54553	54554
14147	16714	0	applied	\N	\N	\N	\N	54615	54615	54616
14147	16715	1	applied	\N	\N	\N	\N	54617	54617	54618
14147	16716	2	applied	\N	\N	\N	\N	54619	54619	54620
14154	16726	0	applied	\N	\N	\N	\N	54646	54646	54647
14154	16727	1	applied	\N	\N	\N	\N	54648	54648	54649
14154	16728	2	applied	\N	\N	\N	\N	54650	54650	54651
14163	16732	0	applied	\N	\N	\N	\N	54663	54663	54664
14163	16735	1	applied	\N	\N	\N	\N	54672	54672	54673
14163	16734	2	applied	\N	\N	\N	\N	54667	54667	54668
14163	16736	3	applied	\N	\N	\N	\N	54674	54674	54675
14163	16737	4	applied	\N	\N	\N	\N	54676	54676	54677
14163	16738	5	applied	\N	\N	\N	\N	54678	54678	54679
14163	16739	6	applied	\N	\N	\N	\N	54680	54680	54681
14168	16746	0	applied	\N	\N	\N	\N	54702	54702	54703
14168	16747	1	applied	\N	\N	\N	\N	54704	54704	54705
14168	16748	2	applied	\N	\N	\N	\N	54706	54706	54707
14168	16749	3	applied	\N	\N	\N	\N	54708	54708	54709
14168	16750	4	applied	\N	\N	\N	\N	54710	54710	54711
14168	16751	5	applied	\N	\N	\N	\N	54712	54712	54713
14171	16763	0	applied	\N	\N	\N	\N	54741	54741	54742
14129	16666	12	applied	\N	\N	\N	\N	54426	54426	54427
14129	16667	13	applied	\N	\N	\N	\N	54428	54428	54429
14129	16668	14	applied	\N	\N	\N	\N	54430	54430	54431
14129	16669	15	applied	\N	\N	\N	\N	54432	54432	54433
14129	16670	16	applied	\N	\N	\N	\N	54434	54434	54435
14129	16671	17	applied	\N	\N	\N	\N	54436	54436	54437
14129	16672	18	applied	\N	\N	\N	\N	54438	54438	54439
14129	16673	19	applied	\N	\N	\N	\N	54440	54440	54441
14129	16675	20	applied	\N	\N	\N	\N	54446	54446	54447
14129	16676	21	applied	\N	\N	\N	\N	54448	54448	54449
14129	16677	22	applied	\N	\N	\N	\N	54450	54450	54451
14129	16679	23	applied	\N	\N	\N	\N	54454	54454	54455
14129	16680	24	applied	\N	\N	\N	\N	54456	54456	54457
14129	16681	25	applied	\N	\N	\N	\N	54458	54458	54459
14129	16683	26	applied	\N	\N	\N	\N	54464	54464	54465
14129	16684	27	applied	\N	\N	\N	\N	54466	54466	54467
14129	16685	28	applied	\N	\N	\N	\N	54468	54468	54469
14129	16687	29	applied	\N	\N	\N	\N	54475	54475	54476
14129	16688	30	applied	\N	\N	\N	\N	54477	54477	54478
14129	16689	31	applied	\N	\N	\N	\N	54479	54479	54480
14129	16691	32	applied	\N	\N	\N	\N	54487	54487	54488
14129	16692	33	applied	\N	\N	\N	\N	54489	54489	54490
14132	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14132	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14132	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14132	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14132	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14132	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14132	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14132	16701	8	applied	\N	\N	\N	\N	54518	54518	54519
14132	16702	9	applied	\N	\N	\N	\N	54520	54520	54521
14132	16703	10	applied	\N	\N	\N	\N	54522	54522	54523
14132	16704	11	applied	\N	\N	\N	\N	54524	54524	54525
14135	16694	0	applied	\N	\N	\N	\N	54501	54501	54502
14135	16695	1	applied	\N	\N	\N	\N	54503	54503	54504
14135	16696	2	applied	\N	\N	\N	\N	54505	54505	54506
14135	16697	3	applied	\N	\N	\N	\N	54507	54507	54508
14135	16698	4	applied	\N	\N	\N	\N	54509	54509	54510
14135	16699	5	applied	\N	\N	\N	\N	54511	54511	54512
14135	16700	6	applied	\N	\N	\N	\N	54513	54513	54514
14135	16701	8	applied	\N	\N	\N	\N	54518	54518	54519
14135	16702	9	applied	\N	\N	\N	\N	54520	54520	54521
14135	16703	10	applied	\N	\N	\N	\N	54522	54522	54523
14135	16704	11	applied	\N	\N	\N	\N	54524	54524	54525
14138	16705	0	applied	\N	\N	\N	\N	54534	54534	54535
14138	16706	1	applied	\N	\N	\N	\N	54536	54536	54537
14138	16707	2	applied	\N	\N	\N	\N	54538	54538	54539
14142	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14142	16709	1	applied	\N	\N	\N	\N	54545	54545	54546
14142	16710	2	applied	\N	\N	\N	\N	54547	54547	54548
14142	16711	3	applied	\N	\N	\N	\N	54549	54549	54550
14142	16712	4	applied	\N	\N	\N	\N	54551	54551	54552
14142	16713	5	applied	\N	\N	\N	\N	54553	54553	54554
14150	16714	0	applied	\N	\N	\N	\N	54615	54615	54616
14150	16715	1	applied	\N	\N	\N	\N	54617	54617	54618
14150	16716	2	applied	\N	\N	\N	\N	54619	54619	54620
14151	16717	0	applied	\N	\N	\N	\N	54624	54624	54625
14151	16718	1	applied	\N	\N	\N	\N	54626	54626	54627
14151	16719	2	applied	\N	\N	\N	\N	54628	54628	54629
14157	16726	0	applied	\N	\N	\N	\N	54646	54646	54647
14157	16727	1	applied	\N	\N	\N	\N	54648	54648	54649
14157	16728	2	applied	\N	\N	\N	\N	54650	54650	54651
14160	16729	0	applied	\N	\N	\N	\N	54655	54655	54656
14160	16730	1	applied	\N	\N	\N	\N	54657	54657	54658
14160	16731	2	applied	\N	\N	\N	\N	54659	54659	54660
14166	16740	0	applied	\N	\N	\N	\N	54683	54683	54684
14166	16741	1	applied	\N	\N	\N	\N	54685	54685	54686
14166	16742	2	applied	\N	\N	\N	\N	54687	54687	54688
14167	16743	0	applied	\N	\N	\N	\N	54694	54694	54695
14167	16744	1	applied	\N	\N	\N	\N	54696	54696	54697
14167	16745	2	applied	\N	\N	\N	\N	54698	54698	54699
14173	16767	0	applied	\N	\N	\N	\N	54752	54752	54753
14173	16768	1	applied	\N	\N	\N	\N	54754	54754	54755
14173	16769	2	applied	\N	\N	1000000000	\N	54756	54756	54757
14173	16770	3	applied	\N	\N	\N	\N	54758	54758	54759
14173	16771	4	applied	\N	\N	\N	\N	54760	54760	54761
14176	16772	0	applied	\N	\N	\N	\N	54764	54764	54765
14176	16773	1	applied	\N	\N	\N	\N	54766	54766	54767
14176	16774	2	applied	\N	\N	\N	\N	54768	54768	54769
14176	16775	3	applied	\N	\N	\N	\N	54770	54770	54771
14176	16776	4	applied	\N	\N	\N	\N	54772	54772	54773
14176	16777	5	applied	\N	\N	\N	\N	54774	54774	54775
14176	16778	6	applied	\N	\N	\N	\N	54776	54776	54777
14176	16779	7	applied	\N	\N	\N	\N	54778	54778	54779
14179	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14179	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14179	16782	2	applied	\N	\N	\N	\N	54787	54787	54788
14179	16783	3	applied	\N	\N	\N	\N	54789	54789	54790
14179	16784	4	applied	\N	\N	\N	\N	54791	54791	54792
14179	16785	5	applied	\N	\N	\N	\N	54793	54793	54794
14183	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14183	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14183	16782	2	applied	\N	\N	\N	\N	54787	54787	54788
14183	16783	3	applied	\N	\N	\N	\N	54789	54789	54790
14183	16784	4	applied	\N	\N	\N	\N	54791	54791	54792
14183	16785	5	applied	\N	\N	\N	\N	54793	54793	54794
14187	16790	0	applied	\N	\N	\N	\N	54816	54816	54817
14189	16792	0	applied	\N	\N	\N	\N	54824	54824	54825
14189	16791	1	applied	\N	\N	\N	\N	54820	54820	54821
14189	16793	2	applied	\N	\N	\N	\N	54826	54826	54827
14189	16794	3	applied	\N	\N	\N	\N	54828	54828	54829
14193	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14193	16796	1	applied	\N	\N	\N	\N	54834	54834	54835
14193	16797	2	applied	\N	\N	\N	\N	54836	54836	54837
14193	16798	3	applied	\N	\N	\N	\N	54838	54838	54839
14199	16809	0	applied	\N	\N	\N	\N	54871	54871	54872
14199	16810	1	applied	\N	\N	\N	\N	54873	54873	54874
14199	16811	2	applied	\N	\N	\N	\N	54875	54875	54876
14202	16821	0	applied	\N	\N	\N	\N	54900	54900	54901
14202	16822	1	applied	\N	\N	\N	\N	54902	54902	54903
14202	16823	2	applied	\N	\N	\N	\N	54904	54904	54905
14202	16824	3	applied	\N	\N	\N	\N	54906	54906	54907
14202	16825	4	applied	\N	\N	\N	\N	54908	54908	54909
14202	16826	5	applied	\N	\N	\N	\N	54910	54910	54911
14207	16838	0	applied	\N	\N	\N	\N	54941	54941	54942
14207	16839	1	applied	\N	\N	\N	\N	54943	54943	54944
14207	16840	2	applied	\N	\N	\N	\N	54945	54945	54946
14207	16841	3	applied	\N	\N	\N	\N	54947	54947	54948
14210	16846	0	applied	\N	\N	\N	\N	54959	54959	54960
14210	16847	1	applied	\N	\N	\N	\N	54961	54961	54962
14140	16238	47	applied	\N	\N	\N	\N	53331	53331	53332
14140	16242	48	applied	\N	\N	\N	\N	53343	53343	53344
14140	16245	49	applied	\N	\N	\N	\N	53353	53353	53354
14140	16249	50	applied	\N	\N	\N	\N	53362	53362	53363
14140	16250	51	applied	\N	\N	\N	\N	53364	53364	53365
14140	16251	52	applied	\N	\N	\N	\N	53366	53366	53367
14140	16260	53	applied	\N	\N	\N	\N	53387	53387	53388
14140	16264	54	applied	\N	\N	\N	\N	53402	53402	53403
14140	16268	55	applied	\N	\N	\N	\N	53412	53412	53413
14140	16272	56	applied	\N	\N	\N	\N	53420	53420	53421
14140	16276	57	applied	\N	\N	\N	\N	53430	53430	53431
14140	16280	58	applied	\N	\N	\N	\N	53440	53440	53441
14140	16284	59	applied	\N	\N	\N	\N	53451	53451	53452
14140	16288	60	applied	\N	\N	\N	\N	53461	53461	53462
14140	16292	61	applied	\N	\N	\N	\N	53474	53474	53475
14140	16299	62	applied	\N	\N	\N	\N	53489	53489	53490
14140	16300	63	applied	\N	\N	\N	\N	53491	53491	53492
14140	16306	64	applied	\N	\N	\N	\N	53504	53504	53505
14140	16310	65	applied	\N	\N	\N	\N	53514	53514	53515
14140	16311	66	applied	\N	\N	\N	\N	53516	53516	53517
14140	16318	67	applied	\N	\N	\N	\N	53533	53533	53534
14140	16320	68	applied	\N	\N	\N	\N	53537	53537	53538
14140	16321	69	applied	\N	\N	\N	\N	53539	53539	53540
14140	16322	70	applied	\N	\N	\N	\N	53541	53541	53542
14140	16323	71	applied	\N	\N	\N	\N	53543	53543	53544
14140	16324	72	applied	\N	\N	\N	\N	53545	53545	53546
14140	16325	73	applied	\N	\N	\N	\N	53547	53547	53548
14140	16347	74	applied	\N	\N	\N	\N	53595	53595	53596
14140	16351	75	applied	\N	\N	\N	\N	53603	53603	53604
14140	16356	76	applied	\N	\N	\N	\N	53616	53616	53617
14140	16357	77	applied	\N	\N	\N	\N	53618	53618	53619
14140	16364	78	applied	\N	\N	\N	\N	53636	53636	54559
14140	16365	79	applied	\N	\N	\N	\N	53638	53638	54560
14140	16372	80	applied	\N	\N	\N	\N	53657	53657	54561
14140	16376	81	applied	\N	\N	\N	\N	53667	53667	54562
14140	16377	82	applied	\N	\N	\N	\N	53669	53669	54563
14140	16378	84	applied	\N	\N	\N	\N	53671	53671	54565
14140	16388	85	applied	\N	\N	\N	\N	53693	53693	54566
14140	16389	86	applied	\N	\N	\N	\N	53695	53695	54567
14140	16396	87	applied	\N	\N	\N	\N	53711	53711	54568
14140	16400	88	applied	\N	\N	\N	\N	53725	53725	54569
14140	16406	89	applied	\N	\N	\N	\N	53738	53738	54570
14140	16410	90	applied	\N	\N	\N	\N	53748	53748	54571
14140	16414	91	applied	\N	\N	\N	\N	53759	53759	54572
14140	16415	92	applied	\N	\N	\N	\N	53761	53761	54573
14140	16422	93	applied	\N	\N	\N	\N	53777	53777	54574
14140	16426	94	applied	\N	\N	\N	\N	53791	53791	54575
14140	16431	95	applied	\N	\N	\N	\N	53804	53804	54576
14140	16432	96	applied	\N	\N	\N	\N	53806	53806	54577
14140	16440	97	applied	\N	\N	\N	\N	53823	53823	54578
14140	16445	98	applied	\N	\N	\N	\N	53837	53837	54579
14140	16446	99	applied	\N	\N	\N	\N	53839	53839	54580
14140	16447	100	applied	\N	\N	\N	\N	53841	53841	54581
14140	16457	101	applied	\N	\N	\N	\N	53863	53863	54582
14140	16459	102	applied	\N	\N	\N	\N	53867	53867	54583
14140	16461	103	applied	\N	\N	\N	\N	53873	53873	54584
14140	16462	104	applied	\N	\N	\N	\N	53875	53875	54585
14140	16475	105	applied	\N	\N	\N	\N	53903	53903	54586
14140	16476	106	applied	\N	\N	\N	\N	53905	53905	54587
14140	16477	107	applied	\N	\N	\N	\N	53907	53907	54588
14140	16487	108	applied	\N	\N	\N	\N	53930	53930	54589
14140	16491	109	applied	\N	\N	\N	\N	53940	53940	54590
14140	16496	110	applied	\N	\N	\N	\N	53953	53953	54591
14140	16499	111	applied	\N	\N	\N	\N	53960	53960	54592
14140	16504	112	applied	\N	\N	\N	\N	53970	53970	54593
14140	16509	113	applied	\N	\N	\N	\N	53982	53982	54594
14140	16514	114	applied	\N	\N	\N	\N	53995	53995	54595
14140	16516	115	applied	\N	\N	\N	\N	54003	54003	54596
14140	16517	116	applied	\N	\N	\N	\N	54005	54005	54597
14140	16525	117	applied	\N	\N	\N	\N	54039	54039	54598
14140	16530	118	applied	\N	\N	\N	\N	54050	54050	54599
14140	16531	119	applied	\N	\N	\N	\N	54054	54054	54600
14140	16537	120	applied	\N	\N	\N	\N	54073	54073	54601
14140	16540	121	applied	\N	\N	\N	\N	54086	54086	54602
14140	16541	122	applied	\N	\N	\N	\N	54088	54088	54603
14140	16546	123	applied	\N	\N	\N	\N	54102	54102	54604
14140	16547	124	applied	\N	\N	\N	\N	54104	54104	54605
14140	16554	125	applied	\N	\N	\N	\N	54121	54121	54606
14148	16715	0	applied	\N	\N	\N	\N	54617	54617	54618
14152	16717	0	applied	\N	\N	\N	\N	54624	54624	54625
14159	16729	0	applied	\N	\N	\N	\N	54655	54655	54656
14159	16730	1	applied	\N	\N	\N	\N	54657	54657	54658
14159	16731	2	applied	\N	\N	\N	\N	54659	54659	54660
14161	16732	0	applied	\N	\N	\N	\N	54663	54663	54664
14161	16733	1	applied	\N	\N	\N	\N	54665	54665	54666
14161	16734	2	applied	\N	\N	\N	\N	54667	54667	54668
14164	16740	0	applied	\N	\N	\N	\N	54683	54683	54684
14164	16741	1	applied	\N	\N	\N	\N	54685	54685	54686
14164	16742	2	applied	\N	\N	\N	\N	54687	54687	54688
14169	16752	0	applied	\N	\N	\N	\N	54716	54716	54717
14172	16763	0	applied	\N	\N	\N	\N	54741	54741	54742
14172	16764	1	applied	\N	\N	\N	\N	54743	54743	54744
14172	16765	2	applied	\N	\N	\N	\N	54745	54745	54746
14172	16766	3	applied	\N	\N	\N	\N	54747	54747	54748
14181	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14181	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14184	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14184	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14191	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14191	16796	1	applied	\N	\N	\N	\N	54834	54834	54835
14191	16797	2	applied	\N	\N	\N	\N	54836	54836	54837
14191	16798	3	applied	\N	\N	\N	\N	54838	54838	54839
14194	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14194	16796	1	applied	\N	\N	\N	\N	54834	54834	54835
14194	16797	2	applied	\N	\N	\N	\N	54836	54836	54837
14194	16798	3	applied	\N	\N	\N	\N	54838	54838	54839
14198	16805	0	applied	\N	\N	\N	\N	54862	54862	54863
14198	16806	1	applied	\N	\N	\N	\N	54865	54865	54866
14198	16807	2	applied	\N	\N	\N	\N	54867	54867	54868
14198	16808	3	applied	\N	\N	\N	\N	54869	54869	54870
14204	16827	0	applied	\N	\N	\N	\N	54914	54914	54915
14204	16828	1	applied	\N	\N	\N	\N	54916	54916	54917
14204	16829	2	applied	\N	\N	\N	\N	54920	54920	54921
14204	16830	3	applied	\N	\N	\N	\N	54922	54922	54923
14204	16831	4	applied	\N	\N	\N	\N	54924	54924	54925
14204	16832	5	applied	\N	\N	\N	\N	54926	54926	54927
14204	16833	6	applied	\N	\N	\N	\N	54928	54928	54929
14204	16834	7	applied	\N	\N	\N	\N	54930	54930	54931
14208	16842	0	applied	\N	\N	\N	\N	54949	54949	54950
14208	16843	1	applied	\N	\N	\N	\N	54951	54951	54952
14170	16757	4	applied	\N	\N	\N	\N	54728	54728	54729
14170	16758	5	applied	\N	\N	\N	\N	54730	54730	54731
14170	16759	6	applied	\N	\N	\N	\N	54732	54732	54733
14170	16760	7	applied	\N	\N	\N	\N	54734	54734	54735
14170	16761	8	applied	\N	\N	\N	\N	54736	54736	54737
14170	16762	9	applied	\N	\N	\N	\N	54738	54738	54739
14175	16772	0	applied	\N	\N	\N	\N	54764	54764	54765
14175	16773	1	applied	\N	\N	\N	\N	54766	54766	54767
14178	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14178	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14182	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14182	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14182	16782	2	applied	\N	\N	\N	\N	54787	54787	54788
14182	16783	3	applied	\N	\N	\N	\N	54789	54789	54790
14182	16784	4	applied	\N	\N	\N	\N	54791	54791	54792
14182	16785	5	applied	\N	\N	\N	\N	54793	54793	54794
14185	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14185	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14186	16786	0	applied	\N	\N	\N	\N	54806	54806	54807
14186	16782	1	applied	\N	\N	\N	\N	54787	54787	54788
14186	16783	2	applied	\N	\N	\N	\N	54789	54789	54790
14186	16784	3	applied	\N	\N	\N	\N	54791	54791	54792
14186	16785	4	applied	\N	\N	\N	\N	54793	54793	54794
14186	16787	5	applied	\N	\N	\N	\N	54808	54808	54809
14186	16788	6	applied	\N	\N	\N	\N	54810	54810	54811
14186	16789	7	applied	\N	\N	\N	\N	54812	54812	54813
14192	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14195	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14196	16799	0	applied	\N	\N	\N	\N	54849	54849	54850
14196	16800	1	applied	\N	\N	\N	\N	54851	54851	54852
14196	16801	2	applied	\N	\N	\N	\N	54853	54853	54854
14196	16802	3	applied	\N	\N	\N	\N	54855	54855	54856
14196	16803	4	applied	\N	\N	\N	\N	54857	54857	54858
14196	16804	5	applied	\N	\N	\N	\N	54859	54859	54860
14201	16820	0	applied	\N	\N	\N	\N	54896	54896	54897
14205	16827	0	applied	\N	\N	\N	\N	54914	54914	54915
14205	16828	1	applied	\N	\N	\N	\N	54916	54916	54917
14205	16829	2	applied	\N	\N	\N	\N	54920	54920	54921
14205	16830	3	applied	\N	\N	\N	\N	54922	54922	54923
14205	16831	4	applied	\N	\N	\N	\N	54924	54924	54925
14205	16832	5	applied	\N	\N	\N	\N	54926	54926	54927
14205	16833	6	applied	\N	\N	\N	\N	54928	54928	54929
14205	16834	7	applied	\N	\N	\N	\N	54930	54930	54931
14206	16835	0	applied	\N	\N	\N	\N	54933	54933	54934
14206	16829	1	applied	\N	\N	\N	\N	54920	54920	54921
14206	16830	2	applied	\N	\N	\N	\N	54922	54922	54923
14206	16831	3	applied	\N	\N	\N	\N	54924	54924	54925
14206	16832	4	applied	\N	\N	\N	\N	54926	54926	54927
14206	16833	5	applied	\N	\N	\N	\N	54928	54928	54929
14206	16834	6	applied	\N	\N	\N	\N	54930	54930	54931
14206	16836	7	applied	\N	\N	\N	\N	54935	54935	54936
14206	16837	8	applied	\N	\N	\N	\N	54937	54937	54938
14209	16846	0	applied	\N	\N	\N	\N	54959	54959	54960
14209	16847	1	applied	\N	\N	\N	\N	54961	54961	54962
14209	16848	2	applied	\N	\N	\N	\N	54963	54963	54964
14209	16849	3	applied	\N	\N	\N	\N	54965	54965	54966
14211	16850	0	applied	\N	\N	\N	\N	54970	54970	54971
14211	16851	1	applied	\N	\N	\N	\N	54972	54972	54973
14211	16852	2	applied	\N	\N	\N	\N	54974	54974	54975
14211	16853	3	applied	\N	\N	\N	\N	54976	54976	54977
14216	16862	0	applied	\N	\N	\N	\N	55008	55008	55009
14216	16863	1	applied	\N	\N	\N	\N	55010	55010	55011
14216	16864	2	applied	\N	\N	\N	\N	55012	55012	55013
14216	16865	3	applied	\N	\N	\N	\N	55014	55014	55015
14219	16877	0	applied	\N	\N	\N	\N	55043	55043	55044
14219	16878	2	applied	\N	\N	\N	\N	55046	55046	55047
14219	16879	3	applied	\N	\N	\N	\N	55048	55048	55049
14219	16880	4	applied	\N	\N	\N	\N	55050	55050	55051
14224	16889	0	applied	\N	\N	\N	\N	55077	55077	55078
14224	16890	1	applied	\N	\N	\N	\N	55079	55079	55080
14224	16891	2	applied	\N	\N	\N	\N	55081	55081	55082
14224	16892	3	applied	\N	\N	\N	\N	55083	55083	55084
14226	16893	0	applied	\N	\N	\N	\N	55089	55089	55090
14226	16894	1	applied	\N	\N	\N	\N	55091	55091	55092
14226	16895	2	applied	\N	\N	\N	\N	55093	55093	55094
14226	16896	3	applied	\N	\N	\N	\N	55095	55095	55096
14229	16901	0	applied	\N	\N	\N	\N	55109	55109	55110
14229	16902	1	applied	\N	\N	\N	\N	55111	55111	55112
14229	16903	2	applied	\N	\N	\N	\N	55113	55113	55114
14229	16904	3	applied	\N	\N	\N	\N	55115	55115	55116
14231	16905	0	applied	\N	\N	\N	\N	55120	55120	55121
14231	16906	1	applied	\N	\N	\N	\N	55122	55122	55123
14231	16907	2	applied	\N	\N	\N	\N	55124	55124	55125
14231	16908	3	applied	\N	\N	\N	\N	55126	55126	55127
14233	16909	0	applied	\N	\N	\N	\N	55132	55132	55133
14233	16910	1	applied	\N	\N	\N	\N	55134	55134	55135
14233	16911	2	applied	\N	\N	\N	\N	55136	55136	55137
14233	16912	3	applied	\N	\N	\N	\N	55138	55138	55139
14236	16909	0	applied	\N	\N	\N	\N	55132	55132	55133
14236	16910	1	applied	\N	\N	\N	\N	55134	55134	55135
14236	16911	2	applied	\N	\N	\N	\N	55136	55136	55137
14236	16912	3	applied	\N	\N	\N	\N	55138	55138	55139
14171	16764	1	applied	\N	\N	\N	\N	54743	54743	54744
14171	16765	2	applied	\N	\N	\N	\N	54745	54745	54746
14171	16766	3	applied	\N	\N	\N	\N	54747	54747	54748
14174	16772	0	applied	\N	\N	\N	\N	54764	54764	54765
14174	16773	1	applied	\N	\N	\N	\N	54766	54766	54767
14174	16774	2	applied	\N	\N	\N	\N	54768	54768	54769
14174	16775	3	applied	\N	\N	\N	\N	54770	54770	54771
14174	16776	4	applied	\N	\N	\N	\N	54772	54772	54773
14174	16777	5	applied	\N	\N	\N	\N	54774	54774	54775
14174	16778	6	applied	\N	\N	\N	\N	54776	54776	54777
14174	16779	7	applied	\N	\N	\N	\N	54778	54778	54779
14180	16780	0	applied	\N	\N	\N	\N	54782	54782	54783
14180	16781	1	applied	\N	\N	\N	\N	54784	54784	54785
14180	16782	2	applied	\N	\N	\N	\N	54787	54787	54788
14180	16783	3	applied	\N	\N	\N	\N	54789	54789	54790
14180	16784	4	applied	\N	\N	\N	\N	54791	54791	54792
14180	16785	5	applied	\N	\N	\N	\N	54793	54793	54794
14188	16786	0	applied	\N	\N	\N	\N	54806	54806	54807
14188	16790	1	applied	\N	\N	\N	\N	54816	54816	54817
14188	16787	2	applied	\N	\N	\N	\N	54808	54808	54809
14188	16788	3	applied	\N	\N	\N	\N	54810	54810	54811
14188	16789	5	applied	\N	\N	\N	\N	54812	54812	54813
14188	16791	6	applied	\N	\N	\N	\N	54820	54820	54821
14190	16795	0	applied	\N	\N	\N	\N	54832	54832	54833
14190	16796	1	applied	\N	\N	\N	\N	54834	54834	54835
14190	16797	2	applied	\N	\N	\N	\N	54836	54836	54837
14190	16798	3	applied	\N	\N	\N	\N	54838	54838	54839
14197	16805	0	applied	\N	\N	\N	\N	54862	54862	54863
14200	16812	0	applied	\N	\N	\N	\N	54878	54878	54879
14200	16813	1	applied	\N	\N	\N	\N	54880	54880	54881
14200	16814	2	applied	\N	\N	\N	\N	54882	54882	54883
14200	16815	3	applied	\N	\N	\N	\N	54884	54884	54885
14200	16816	4	applied	\N	\N	\N	\N	54886	54886	54887
14200	16817	5	applied	\N	\N	\N	\N	54888	54888	54889
14200	16818	6	applied	\N	\N	\N	\N	54890	54890	54891
14200	16819	7	applied	\N	\N	\N	\N	54892	54892	54893
14203	16827	0	applied	\N	\N	\N	\N	54914	54914	54915
14203	16828	1	applied	\N	\N	\N	\N	54916	54916	54917
14215	16858	0	applied	\N	\N	\N	\N	54997	54997	54998
14215	16859	1	applied	\N	\N	\N	\N	54999	54999	55000
14215	16860	2	applied	\N	\N	\N	\N	55001	55001	55002
14215	16861	3	applied	\N	\N	\N	\N	55003	55003	55004
14222	16881	0	applied	\N	\N	\N	\N	55059	55059	55060
14222	16882	1	applied	\N	\N	\N	\N	55061	55061	55062
14225	16883	0	applied	\N	\N	\N	\N	55064	55064	55065
14225	16884	1	applied	\N	\N	\N	\N	55066	55066	55067
14225	16889	2	applied	\N	\N	\N	\N	55077	55077	55078
14225	16885	3	applied	\N	\N	\N	\N	55068	55068	55069
14225	16886	4	applied	\N	\N	\N	\N	55070	55070	55071
14225	16887	5	applied	\N	\N	\N	\N	55072	55072	55073
14225	16888	6	applied	\N	\N	\N	\N	55074	55074	55075
14225	16890	7	applied	\N	\N	\N	\N	55079	55079	55080
14225	16891	8	applied	\N	\N	\N	\N	55081	55081	55082
14225	16892	9	applied	\N	\N	\N	\N	55083	55083	55084
14235	16909	0	applied	\N	\N	\N	\N	55132	55132	55133
14235	16910	1	applied	\N	\N	\N	\N	55134	55134	55135
14235	16911	2	applied	\N	\N	\N	\N	55136	55136	55137
14235	16912	3	applied	\N	\N	\N	\N	55138	55138	55139
14239	16913	0	applied	\N	\N	\N	\N	55143	55143	55144
14239	16914	1	applied	\N	\N	\N	\N	55145	55145	55146
14239	16915	2	applied	\N	\N	\N	\N	55147	55147	55148
14239	16916	3	applied	\N	\N	\N	\N	55149	55149	55150
14239	16917	4	applied	\N	\N	\N	\N	55151	55151	55152
14239	16918	5	applied	\N	\N	\N	\N	55153	55153	55154
14239	16919	6	applied	\N	\N	\N	\N	55155	55155	55156
14208	16844	2	applied	\N	\N	\N	\N	54953	54953	54954
14208	16845	3	applied	\N	\N	\N	\N	54955	54955	54956
14213	16786	0	applied	\N	\N	\N	\N	54806	54806	54807
14213	16790	1	applied	\N	\N	\N	\N	54816	54816	54817
14213	16792	2	applied	\N	\N	\N	\N	54824	54824	54825
14213	16795	3	applied	\N	\N	\N	\N	54832	54832	54833
14213	16799	5	applied	\N	\N	\N	\N	54849	54849	54850
14213	16800	6	applied	\N	\N	\N	\N	54851	54851	54852
14213	16805	7	applied	\N	\N	\N	\N	54862	54862	54863
14213	16809	8	applied	\N	\N	\N	\N	54871	54871	54872
14213	16812	9	applied	\N	\N	\N	\N	54878	54878	54879
14213	16813	10	applied	\N	\N	\N	\N	54880	54880	54881
14213	16820	11	applied	\N	\N	\N	\N	54896	54896	54897
14213	16821	12	applied	\N	\N	\N	\N	54900	54900	54901
14213	16827	13	applied	\N	\N	\N	\N	54914	54914	54990
14213	16828	14	applied	\N	\N	\N	\N	54916	54916	54991
14218	16866	0	applied	\N	\N	\N	\N	55020	55020	55021
14218	16867	1	applied	\N	\N	\N	\N	55022	55022	55023
14218	16868	2	applied	\N	\N	\N	\N	55024	55024	55025
14218	16869	3	applied	\N	\N	\N	\N	55026	55026	55027
14218	16870	4	applied	\N	\N	\N	\N	55028	55028	55029
14218	16871	5	applied	\N	\N	\N	\N	55030	55030	55031
14218	16872	6	applied	\N	\N	\N	\N	55032	55032	55033
14218	16873	7	applied	\N	\N	\N	\N	55034	55034	55035
14218	16874	8	applied	\N	\N	\N	\N	55036	55036	55037
14218	16875	9	applied	\N	\N	\N	\N	55038	55038	55039
14218	16876	10	applied	\N	\N	\N	\N	55040	55040	55041
14221	16877	0	applied	\N	\N	\N	\N	55043	55043	55044
14221	16878	2	applied	\N	\N	\N	\N	55046	55046	55047
14221	16879	3	applied	\N	\N	\N	\N	55048	55048	55049
14221	16880	4	applied	\N	\N	\N	\N	55050	55050	55051
14223	16883	0	applied	\N	\N	\N	\N	55064	55064	55065
14223	16884	1	applied	\N	\N	\N	\N	55066	55066	55067
14223	16885	2	applied	\N	\N	\N	\N	55068	55068	55069
14223	16886	3	applied	\N	\N	\N	\N	55070	55070	55071
14223	16887	4	applied	\N	\N	\N	\N	55072	55072	55073
14223	16888	5	applied	\N	\N	\N	\N	55074	55074	55075
14228	16901	0	applied	\N	\N	\N	\N	55109	55109	55110
14228	16902	1	applied	\N	\N	\N	\N	55111	55111	55112
14228	16903	2	applied	\N	\N	\N	\N	55113	55113	55114
14228	16904	3	applied	\N	\N	\N	\N	55115	55115	55116
14237	16913	0	applied	\N	\N	\N	\N	55143	55143	55144
14237	16914	1	applied	\N	\N	\N	\N	55145	55145	55146
14237	16915	2	applied	\N	\N	\N	\N	55147	55147	55148
14237	16916	3	applied	\N	\N	\N	\N	55149	55149	55150
14237	16917	4	applied	\N	\N	\N	\N	55151	55151	55152
14237	16918	5	applied	\N	\N	\N	\N	55153	55153	55154
14237	16919	6	applied	\N	\N	\N	\N	55155	55155	55156
14210	16848	2	applied	\N	\N	\N	\N	54963	54963	54964
14210	16849	3	applied	\N	\N	\N	\N	54965	54965	54966
14212	16854	0	applied	\N	\N	\N	\N	54980	54980	54981
14212	16855	1	applied	\N	\N	\N	\N	54982	54982	54983
14212	16856	2	applied	\N	\N	\N	\N	54984	54984	54985
14212	16857	3	applied	\N	\N	\N	\N	54986	54986	54987
14214	16858	0	applied	\N	\N	\N	\N	54997	54997	54998
14214	16859	1	applied	\N	\N	\N	\N	54999	54999	55000
14214	16860	2	applied	\N	\N	\N	\N	55001	55001	55002
14214	16861	3	applied	\N	\N	\N	\N	55003	55003	55004
14217	16862	0	applied	\N	\N	\N	\N	55008	55008	55009
14217	16863	1	applied	\N	\N	\N	\N	55010	55010	55011
14217	16864	2	applied	\N	\N	\N	\N	55012	55012	55013
14217	16865	3	applied	\N	\N	\N	\N	55014	55014	55015
14227	16897	0	applied	\N	\N	\N	\N	55099	55099	55100
14227	16898	1	applied	\N	\N	\N	\N	55101	55101	55102
14227	16899	2	applied	\N	\N	\N	\N	55103	55103	55104
14227	16900	3	applied	\N	\N	\N	\N	55105	55105	55106
14230	16901	0	applied	\N	\N	\N	\N	55109	55109	55110
14230	16902	1	applied	\N	\N	\N	\N	55111	55111	55112
14230	16903	2	applied	\N	\N	\N	\N	55113	55113	55114
14230	16904	3	applied	\N	\N	\N	\N	55115	55115	55116
14232	16905	0	applied	\N	\N	\N	\N	55120	55120	55121
14232	16906	1	applied	\N	\N	\N	\N	55122	55122	55123
14232	16907	2	applied	\N	\N	\N	\N	55124	55124	55125
14232	16908	3	applied	\N	\N	\N	\N	55126	55126	55127
14234	16909	0	applied	\N	\N	\N	\N	55132	55132	55133
14234	16910	1	applied	\N	\N	\N	\N	55134	55134	55135
14234	16911	2	applied	\N	\N	\N	\N	55136	55136	55137
14234	16912	3	applied	\N	\N	\N	\N	55138	55138	55139
14238	16913	0	applied	\N	\N	\N	\N	55143	55143	55144
14240	16914	0	applied	\N	\N	\N	\N	55145	55145	55146
14240	16915	1	applied	\N	\N	\N	\N	55147	55147	55148
14240	16916	2	applied	\N	\N	\N	\N	55149	55149	55150
14240	16917	3	applied	\N	\N	\N	\N	55151	55151	55152
14240	16918	4	applied	\N	\N	\N	\N	55153	55153	55154
14240	16919	5	applied	\N	\N	\N	\N	55155	55155	55156
14241	16913	0	applied	\N	\N	\N	\N	55143	55143	55144
14241	16920	1	applied	\N	\N	\N	\N	55163	55163	55164
14241	16921	2	applied	\N	\N	\N	\N	55165	55165	55166
14241	16922	3	applied	\N	\N	\N	\N	55167	55167	55168
14241	16923	4	applied	\N	\N	\N	\N	55169	55169	55170
14241	16924	5	applied	\N	\N	\N	\N	55171	55171	55172
14241	16925	6	applied	\N	\N	\N	\N	55173	55173	55174
14241	16926	7	applied	\N	\N	\N	\N	55175	55175	55176
14241	16927	8	applied	\N	\N	\N	\N	55177	55177	55178
14242	16928	0	applied	\N	\N	\N	\N	55180	55180	55181
14242	16929	1	applied	\N	\N	\N	\N	55182	55182	55183
14242	16930	2	applied	\N	\N	\N	\N	55184	55184	55185
14242	16931	3	applied	\N	\N	\N	\N	55186	55186	55187
14243	16929	0	applied	\N	\N	\N	\N	55182	55182	55183
14243	16930	1	applied	\N	\N	\N	\N	55184	55184	55185
14244	16932	0	applied	\N	\N	\N	\N	55192	55192	55193
14244	16933	1	applied	\N	\N	\N	\N	55194	55194	55195
14244	16934	2	applied	\N	\N	\N	\N	55196	55196	55197
14244	16935	3	applied	\N	\N	\N	\N	55198	55198	55199
14245	16936	0	applied	\N	\N	\N	\N	55202	55202	55203
14245	16937	1	applied	\N	\N	\N	\N	55204	55204	55205
14245	16938	2	applied	\N	\N	\N	\N	55206	55206	55207
14246	16936	0	applied	\N	\N	\N	\N	55202	55202	55203
14246	16937	1	applied	\N	\N	\N	\N	55204	55204	55205
14246	16938	2	applied	\N	\N	\N	\N	55206	55206	55207
14247	16939	0	applied	\N	\N	\N	\N	55212	55212	55213
14247	16940	1	applied	\N	\N	\N	\N	55214	55214	55215
14247	16941	2	applied	\N	\N	\N	\N	55216	55216	55217
14247	16942	3	applied	\N	\N	\N	\N	55218	55218	55219
14247	16943	4	applied	\N	\N	\N	\N	55220	55220	55221
14247	16944	5	applied	\N	\N	\N	\N	55222	55222	55223
14247	16945	6	applied	\N	\N	\N	\N	55224	55224	55225
14247	16946	7	applied	\N	\N	\N	\N	55226	55226	55227
14248	16947	0	applied	\N	\N	\N	\N	55230	55230	55231
14248	16948	1	applied	\N	\N	\N	\N	55232	55232	55233
14248	16949	2	applied	\N	\N	\N	\N	55234	55234	55235
14248	16950	3	applied	\N	\N	\N	\N	55236	55236	55237
14249	16951	0	applied	\N	\N	\N	\N	55238	55238	55239
14249	16952	1	applied	\N	\N	\N	\N	55240	55240	55241
14249	16953	2	applied	\N	\N	\N	\N	55242	55242	55243
14249	16954	3	applied	\N	\N	\N	\N	55244	55244	55245
14250	16955	0	applied	\N	\N	\N	\N	55248	55248	55249
14250	16956	1	applied	\N	\N	\N	\N	55250	55250	55251
14250	16957	2	applied	\N	\N	\N	\N	55252	55252	55253
14251	16958	0	applied	\N	\N	\N	\N	55255	55255	55256
14251	16959	1	applied	\N	\N	\N	\N	55257	55257	55258
14251	16960	2	applied	\N	\N	\N	\N	55259	55259	55260
14251	16961	3	applied	\N	\N	\N	\N	55261	55261	55262
14251	16962	4	applied	\N	\N	\N	\N	55263	55263	55264
14251	16963	5	applied	\N	\N	\N	\N	55265	55265	55266
14251	16964	6	applied	\N	\N	\N	\N	55267	55267	55268
14251	16965	7	applied	\N	\N	\N	\N	55269	55269	55270
14252	16958	0	applied	\N	\N	\N	\N	55255	55255	55256
14252	16959	1	applied	\N	\N	\N	\N	55257	55257	55258
14252	16960	2	applied	\N	\N	\N	\N	55259	55259	55260
14252	16961	3	applied	\N	\N	\N	\N	55261	55261	55262
14252	16962	4	applied	\N	\N	\N	\N	55263	55263	55264
14252	16963	5	applied	\N	\N	\N	\N	55265	55265	55266
14252	16964	6	applied	\N	\N	\N	\N	55267	55267	55268
14252	16965	7	applied	\N	\N	\N	\N	55269	55269	55270
14253	16958	0	applied	\N	\N	\N	\N	55255	55255	55256
14253	16959	1	applied	\N	\N	\N	\N	55257	55257	55258
14253	16960	2	applied	\N	\N	\N	\N	55259	55259	55260
14253	16961	3	applied	\N	\N	\N	\N	55261	55261	55262
14253	16962	4	applied	\N	\N	\N	\N	55263	55263	55264
14253	16963	5	applied	\N	\N	\N	\N	55265	55265	55266
14253	16964	6	applied	\N	\N	\N	\N	55267	55267	55268
14253	16965	7	applied	\N	\N	\N	\N	55269	55269	55270
14254	16958	0	applied	\N	\N	\N	\N	55255	55255	55256
14254	16959	1	applied	\N	\N	\N	\N	55257	55257	55258
14254	16960	2	applied	\N	\N	\N	\N	55259	55259	55260
14254	16961	3	applied	\N	\N	\N	\N	55261	55261	55262
14254	16962	4	applied	\N	\N	\N	\N	55263	55263	55264
14254	16963	5	applied	\N	\N	\N	\N	55265	55265	55266
14254	16964	6	applied	\N	\N	\N	\N	55267	55267	55268
14254	16965	7	applied	\N	\N	\N	\N	55269	55269	55270
14255	16958	0	applied	\N	\N	\N	\N	55255	55255	55256
14255	16959	1	applied	\N	\N	\N	\N	55257	55257	55258
14256	16966	0	applied	\N	\N	\N	\N	55278	55278	55279
14256	16960	1	applied	\N	\N	\N	\N	55259	55259	55260
14256	16961	2	applied	\N	\N	\N	\N	55261	55261	55262
14256	16962	3	applied	\N	\N	\N	\N	55263	55263	55264
14256	16963	4	applied	\N	\N	\N	\N	55265	55265	55266
14256	16964	5	applied	\N	\N	\N	\N	55267	55267	55268
14256	16965	6	applied	\N	\N	\N	\N	55269	55269	55270
14256	16967	8	applied	\N	\N	\N	\N	55281	55281	55282
14256	16968	9	applied	\N	\N	\N	\N	55283	55283	55284
14256	16969	10	applied	\N	\N	\N	\N	55285	55285	55286
14259	16974	0	applied	\N	\N	\N	\N	55303	55303	55304
14259	16975	1	applied	\N	\N	\N	\N	55305	55305	55306
14259	16976	2	applied	\N	\N	\N	\N	55307	55307	55308
14259	16977	3	applied	\N	\N	\N	\N	55309	55309	55310
14263	16622	0	applied	\N	\N	\N	\N	54302	54302	54303
14263	16623	1	applied	\N	\N	\N	\N	54304	54304	54305
14263	16624	2	applied	\N	\N	\N	\N	54306	54306	54307
14263	16631	3	applied	\N	\N	\N	\N	54327	54327	54328
14263	16635	4	applied	\N	\N	\N	\N	54341	54341	54342
14263	16639	5	applied	\N	\N	\N	\N	54351	54351	54352
14263	16643	6	applied	\N	\N	\N	\N	54362	54362	54363
14263	16647	7	applied	\N	\N	\N	\N	54372	54372	54373
14263	16650	8	applied	\N	\N	\N	\N	54382	54382	54383
14263	16654	9	applied	\N	\N	\N	\N	54394	54394	54395
14263	16658	10	applied	\N	\N	\N	\N	54402	54402	54403
14263	16662	11	applied	\N	\N	\N	\N	54418	54418	54419
14263	16663	12	applied	\N	\N	\N	\N	54420	54420	54421
14263	16664	13	applied	\N	\N	\N	\N	54422	54422	54423
14263	16674	14	applied	\N	\N	\N	\N	54444	54444	54445
14263	16678	15	applied	\N	\N	\N	\N	54452	54452	54453
14263	16682	16	applied	\N	\N	\N	\N	54462	54462	54463
14263	16686	17	applied	\N	\N	\N	\N	54473	54473	54474
14263	16690	18	applied	\N	\N	\N	\N	54485	54485	54486
14263	16694	19	applied	\N	\N	\N	\N	54501	54501	54502
14263	16695	20	applied	\N	\N	\N	\N	54503	54503	54504
14263	16696	21	applied	\N	\N	\N	\N	54505	54505	54506
14263	16705	22	applied	\N	\N	\N	\N	54534	54534	54535
14263	16708	23	applied	\N	\N	\N	\N	54543	54543	54544
14263	16709	24	applied	\N	\N	\N	\N	54545	54545	54546
14263	16714	25	applied	\N	\N	\N	\N	54615	54615	54616
14263	16717	26	applied	\N	\N	\N	\N	54624	54624	54625
14263	16720	27	applied	\N	\N	\N	\N	54633	54633	54634
14263	16721	28	applied	\N	\N	\N	\N	54635	54635	54636
14263	16726	29	applied	\N	\N	\N	\N	54646	54646	54647
14263	16729	30	applied	\N	\N	\N	\N	54655	54655	54656
14263	16732	31	applied	\N	\N	\N	\N	54663	54663	54664
14263	16735	32	applied	\N	\N	\N	\N	54672	54672	54673
14263	16740	33	applied	\N	\N	\N	\N	54683	54683	54684
14263	16743	34	applied	\N	\N	\N	\N	54694	54694	54695
14263	16746	35	applied	\N	\N	\N	\N	54702	54702	54703
14263	16747	36	applied	\N	\N	\N	\N	54704	54704	54705
14263	16752	37	applied	\N	\N	\N	\N	54716	54716	54717
14263	16753	38	applied	\N	\N	\N	\N	54720	54720	54721
14263	16754	39	applied	\N	\N	\N	\N	54722	54722	54723
14263	16763	40	applied	\N	\N	\N	\N	54741	54741	54742
14263	16767	41	applied	\N	\N	\N	\N	54752	54752	54753
14263	16772	42	applied	\N	\N	\N	\N	54764	54764	54765
14263	16773	43	applied	\N	\N	\N	\N	54766	54766	54767
14263	16780	44	applied	\N	\N	\N	\N	54782	54782	54783
14263	16781	45	applied	\N	\N	\N	\N	54784	54784	54785
14263	16786	46	applied	\N	\N	\N	\N	54806	54806	54807
14263	16790	47	applied	\N	\N	\N	\N	54816	54816	54817
14263	16792	48	applied	\N	\N	\N	\N	54824	54824	54825
14263	16795	49	applied	\N	\N	\N	\N	54832	54832	54833
14263	16799	50	applied	\N	\N	\N	\N	54849	54849	54850
14263	16800	51	applied	\N	\N	\N	\N	54851	54851	54852
14263	16805	52	applied	\N	\N	\N	\N	54862	54862	54863
14263	16809	53	applied	\N	\N	\N	\N	54871	54871	54872
14263	16812	54	applied	\N	\N	\N	\N	54878	54878	54879
14263	16813	55	applied	\N	\N	\N	\N	54880	54880	54881
14263	16820	56	applied	\N	\N	\N	\N	54896	54896	54897
14263	16821	57	applied	\N	\N	\N	\N	54900	54900	54901
14263	16827	58	applied	\N	\N	\N	\N	54914	54914	54990
14263	16828	59	applied	\N	\N	\N	\N	54916	54916	54991
14263	16835	60	applied	\N	\N	\N	\N	54933	54933	55334
14263	16838	61	applied	\N	\N	\N	\N	54941	54941	55335
14263	16842	62	applied	\N	\N	\N	\N	54949	54949	55336
14263	16846	63	applied	\N	\N	\N	\N	54959	54959	55337
14263	16850	64	applied	\N	\N	\N	\N	54970	54970	55338
14263	16854	65	applied	\N	\N	\N	\N	54980	54980	55339
14263	16858	66	applied	\N	\N	\N	\N	54997	54997	55340
14263	16862	67	applied	\N	\N	\N	\N	55008	55008	55341
14263	16866	68	applied	\N	\N	\N	\N	55020	55020	55342
14263	16867	69	applied	\N	\N	\N	\N	55022	55022	55343
14263	16868	70	applied	\N	\N	\N	\N	55024	55024	55344
14263	16877	71	applied	\N	\N	\N	\N	55043	55043	55345
14263	16883	72	applied	\N	\N	\N	\N	55064	55064	55346
14263	16884	73	applied	\N	\N	\N	\N	55066	55066	55347
14263	16889	74	applied	\N	\N	\N	\N	55077	55077	55348
14263	16893	75	applied	\N	\N	\N	\N	55089	55089	55349
14263	16897	76	applied	\N	\N	\N	\N	55099	55099	55350
14263	16901	77	applied	\N	\N	\N	\N	55109	55109	55351
14263	16905	78	applied	\N	\N	\N	\N	55120	55120	55352
14263	16909	79	applied	\N	\N	\N	\N	55132	55132	55353
14263	16913	80	applied	\N	\N	\N	\N	55143	55143	55354
14263	16920	81	applied	\N	\N	\N	\N	55163	55163	55355
14263	16921	82	applied	\N	\N	\N	\N	55165	55165	55356
14263	16928	83	applied	\N	\N	\N	\N	55180	55180	55357
14263	16932	84	applied	\N	\N	\N	\N	55192	55192	55358
14263	16936	85	applied	\N	\N	\N	\N	55202	55202	55359
14263	16939	86	applied	\N	\N	\N	\N	55212	55212	55360
14263	16940	87	applied	\N	\N	\N	\N	55214	55214	55361
14263	16947	88	applied	\N	\N	\N	\N	55230	55230	55362
14263	16951	89	applied	\N	\N	\N	\N	55238	55238	55363
14263	16955	90	applied	\N	\N	\N	\N	55248	55248	55364
14263	16958	91	applied	\N	\N	\N	\N	55255	55255	55365
14263	16959	92	applied	\N	\N	\N	\N	55257	55257	55366
14263	16966	93	applied	\N	\N	\N	\N	55278	55278	55367
14263	16970	94	applied	\N	\N	\N	\N	55289	55289	55368
14263	16974	95	applied	\N	\N	\N	\N	55303	55303	55369
14263	16978	96	applied	\N	\N	\N	\N	55314	55314	55370
14263	16636	97	applied	\N	\N	\N	\N	54343	54343	25661
14263	16625	98	applied	\N	\N	\N	\N	54308	54308	54309
14263	16626	99	applied	\N	\N	\N	\N	54310	54310	54311
14263	16627	100	applied	\N	\N	\N	\N	54312	54312	54313
14263	16628	101	applied	\N	\N	\N	\N	54314	54314	54315
14263	16629	102	applied	\N	\N	\N	\N	54316	54316	54317
14263	16630	103	applied	\N	\N	\N	\N	54318	54318	54319
14263	16632	104	applied	\N	\N	\N	\N	54331	54331	54332
14263	16633	105	applied	\N	\N	\N	\N	54333	54333	54334
14263	16634	106	applied	\N	\N	\N	\N	54335	54335	54336
14263	16637	107	applied	\N	\N	\N	\N	54345	54345	54346
14263	16986	108	applied	\N	\N	\N	\N	55371	55371	55372
14263	16640	110	applied	\N	\N	\N	\N	55374	55374	55375
14263	16641	111	applied	\N	\N	\N	\N	55376	55376	54358
14257	16970	0	applied	\N	\N	\N	\N	55289	55289	55290
14257	16971	1	applied	\N	\N	\N	\N	55291	55291	55292
14257	16972	2	applied	\N	\N	\N	\N	55293	55293	55294
14257	16973	3	applied	\N	\N	\N	\N	55295	55295	55296
14264	16987	0	applied	\N	\N	\N	\N	55403	55403	55404
14264	16988	1	applied	\N	\N	\N	\N	55405	55405	55406
14264	16989	2	applied	\N	\N	\N	\N	55407	55407	55408
14264	16990	3	applied	\N	\N	\N	\N	55409	55409	55410
14267	16991	0	applied	\N	\N	\N	\N	55415	55415	55416
14267	16992	1	applied	\N	\N	\N	\N	55417	55417	55418
14267	16993	2	applied	\N	\N	\N	\N	55419	55419	55420
14267	16994	3	applied	\N	\N	\N	\N	55421	55421	55422
14267	16995	4	applied	\N	\N	\N	\N	55423	55423	55424
14267	16996	5	applied	\N	\N	\N	\N	55425	55425	55426
14267	16997	6	applied	\N	\N	\N	\N	55427	55427	55428
14267	16998	7	applied	\N	\N	\N	\N	55429	55429	55430
14267	16999	8	applied	\N	\N	\N	\N	55431	55431	55432
14267	17000	9	applied	\N	\N	\N	\N	55433	55433	55434
14267	17001	10	applied	\N	\N	\N	\N	55435	55435	55436
14267	17002	11	applied	\N	\N	\N	\N	55437	55437	55438
14269	17003	0	applied	\N	\N	\N	\N	55442	55442	55443
14271	17003	0	applied	\N	\N	\N	\N	55442	55442	55443
14271	17004	1	applied	\N	\N	\N	\N	55445	55445	55446
14271	17005	2	applied	\N	\N	\N	\N	55447	55447	55448
14271	17006	3	applied	\N	\N	\N	\N	55449	55449	55450
14276	17018	0	applied	\N	\N	\N	\N	55480	55480	55481
14276	17019	1	applied	\N	\N	\N	\N	55482	55482	55483
14276	17020	2	applied	\N	\N	\N	\N	55484	55484	55485
14276	17021	3	applied	\N	\N	\N	\N	55486	55486	55487
14276	17022	4	applied	\N	\N	\N	\N	55488	55488	55489
14276	17023	5	applied	\N	\N	\N	\N	55490	55490	55491
14279	17034	0	applied	\N	\N	\N	\N	55517	55517	55518
14279	17035	1	applied	\N	\N	\N	\N	55519	55519	55520
14282	17018	0	applied	\N	\N	\N	\N	55480	55480	55481
14282	17019	1	applied	\N	\N	\N	\N	55482	55482	55483
14282	17020	2	applied	\N	\N	\N	\N	55484	55484	55485
14282	17021	3	applied	\N	\N	\N	\N	55486	55486	55487
14282	16635	4	applied	\N	\N	\N	\N	54341	54341	54342
14282	16639	5	applied	\N	\N	\N	\N	54351	54351	54352
14282	16643	6	applied	\N	\N	\N	\N	54362	54362	54363
14282	16647	7	applied	\N	\N	\N	\N	54372	54372	54373
14282	16650	8	applied	\N	\N	\N	\N	54382	54382	54383
14282	16654	9	applied	\N	\N	\N	\N	54394	54394	54395
14282	16658	10	applied	\N	\N	\N	\N	54402	54402	54403
14282	16662	11	applied	\N	\N	\N	\N	54418	54418	54419
14282	16663	12	applied	\N	\N	\N	\N	54420	54420	54421
14282	16664	13	applied	\N	\N	\N	\N	54422	54422	54423
14282	16674	14	applied	\N	\N	\N	\N	54444	54444	54445
14282	16678	15	applied	\N	\N	\N	\N	54452	54452	54453
14282	16682	16	applied	\N	\N	\N	\N	54462	54462	54463
14282	16686	17	applied	\N	\N	\N	\N	54473	54473	54474
14282	16690	18	applied	\N	\N	\N	\N	54485	54485	54486
14282	16694	19	applied	\N	\N	\N	\N	54501	54501	54502
14282	16695	20	applied	\N	\N	\N	\N	54503	54503	54504
14282	16696	21	applied	\N	\N	\N	\N	54505	54505	54506
14282	16705	22	applied	\N	\N	\N	\N	54534	54534	54535
14282	16708	23	applied	\N	\N	\N	\N	54543	54543	54544
14282	16709	24	applied	\N	\N	\N	\N	54545	54545	54546
14282	16714	25	applied	\N	\N	\N	\N	54615	54615	54616
14282	16717	26	applied	\N	\N	\N	\N	54624	54624	54625
14282	16720	27	applied	\N	\N	\N	\N	54633	54633	54634
14282	16721	28	applied	\N	\N	\N	\N	54635	54635	54636
14282	16726	29	applied	\N	\N	\N	\N	54646	54646	54647
14282	16729	30	applied	\N	\N	\N	\N	54655	54655	54656
14282	16732	31	applied	\N	\N	\N	\N	54663	54663	54664
14282	16735	32	applied	\N	\N	\N	\N	54672	54672	54673
14282	16740	33	applied	\N	\N	\N	\N	54683	54683	54684
14282	16743	34	applied	\N	\N	\N	\N	54694	54694	54695
14282	16746	35	applied	\N	\N	\N	\N	54702	54702	54703
14282	16747	36	applied	\N	\N	\N	\N	54704	54704	54705
14282	16752	37	applied	\N	\N	\N	\N	54716	54716	54717
14282	16753	38	applied	\N	\N	\N	\N	54720	54720	54721
14282	16754	39	applied	\N	\N	\N	\N	54722	54722	54723
14282	16763	40	applied	\N	\N	\N	\N	54741	54741	54742
14282	16767	41	applied	\N	\N	\N	\N	54752	54752	54753
14282	16772	42	applied	\N	\N	\N	\N	54764	54764	54765
14282	16773	43	applied	\N	\N	\N	\N	54766	54766	54767
14282	16780	44	applied	\N	\N	\N	\N	54782	54782	54783
14282	16781	45	applied	\N	\N	\N	\N	54784	54784	54785
14282	16786	46	applied	\N	\N	\N	\N	54806	54806	54807
14282	16790	47	applied	\N	\N	\N	\N	54816	54816	54817
14282	16792	48	applied	\N	\N	\N	\N	54824	54824	54825
14282	16795	49	applied	\N	\N	\N	\N	54832	54832	54833
14282	16799	50	applied	\N	\N	\N	\N	54849	54849	54850
14282	16800	51	applied	\N	\N	\N	\N	54851	54851	54852
14282	16805	52	applied	\N	\N	\N	\N	54862	54862	54863
14282	16809	53	applied	\N	\N	\N	\N	54871	54871	54872
14282	16812	54	applied	\N	\N	\N	\N	54878	54878	54879
14282	16813	55	applied	\N	\N	\N	\N	54880	54880	54881
14282	16820	56	applied	\N	\N	\N	\N	54896	54896	54897
14282	16821	57	applied	\N	\N	\N	\N	54900	54900	54901
14282	16827	58	applied	\N	\N	\N	\N	54914	54914	54990
14282	16828	59	applied	\N	\N	\N	\N	54916	54916	54991
14282	16835	60	applied	\N	\N	\N	\N	54933	54933	55334
14282	16838	61	applied	\N	\N	\N	\N	54941	54941	55335
14282	16842	62	applied	\N	\N	\N	\N	54949	54949	55336
14282	16846	63	applied	\N	\N	\N	\N	54959	54959	55337
14282	16850	64	applied	\N	\N	\N	\N	54970	54970	55338
14282	16854	65	applied	\N	\N	\N	\N	54980	54980	55339
14282	16858	66	applied	\N	\N	\N	\N	54997	54997	55340
14282	16862	67	applied	\N	\N	\N	\N	55008	55008	55341
14282	16866	68	applied	\N	\N	\N	\N	55020	55020	55342
14282	16867	69	applied	\N	\N	\N	\N	55022	55022	55343
14282	16868	70	applied	\N	\N	\N	\N	55024	55024	55344
14282	16877	71	applied	\N	\N	\N	\N	55043	55043	55345
14282	16883	72	applied	\N	\N	\N	\N	55064	55064	55346
14282	16884	73	applied	\N	\N	\N	\N	55066	55066	55347
14282	16889	74	applied	\N	\N	\N	\N	55077	55077	55348
14282	16893	75	applied	\N	\N	\N	\N	55089	55089	55349
14282	16897	76	applied	\N	\N	\N	\N	55099	55099	55350
14282	16901	77	applied	\N	\N	\N	\N	55109	55109	55351
14282	16905	78	applied	\N	\N	\N	\N	55120	55120	55352
14282	16909	79	applied	\N	\N	\N	\N	55132	55132	55353
14282	16913	80	applied	\N	\N	\N	\N	55143	55143	55354
14282	16920	81	applied	\N	\N	\N	\N	55163	55163	55355
14282	16921	82	applied	\N	\N	\N	\N	55165	55165	55356
14282	16928	83	applied	\N	\N	\N	\N	55180	55180	55357
14282	16932	84	applied	\N	\N	\N	\N	55192	55192	55358
14282	16936	85	applied	\N	\N	\N	\N	55202	55202	55359
14282	16939	86	applied	\N	\N	\N	\N	55212	55212	55360
14258	16974	0	applied	\N	\N	\N	\N	55303	55303	55304
14258	16975	1	applied	\N	\N	\N	\N	55305	55305	55306
14258	16976	2	applied	\N	\N	\N	\N	55307	55307	55308
14258	16977	3	applied	\N	\N	\N	\N	55309	55309	55310
14261	16978	0	applied	\N	\N	\N	\N	55314	55314	55315
14261	16979	1	applied	\N	\N	\N	\N	55316	55316	55317
14261	16980	2	applied	\N	\N	\N	\N	55318	55318	55319
14261	16981	3	applied	\N	\N	\N	\N	55320	55320	55321
14265	16987	0	applied	\N	\N	\N	\N	55403	55403	55404
14265	16988	1	applied	\N	\N	\N	\N	55405	55405	55406
14265	16989	2	applied	\N	\N	\N	\N	55407	55407	55408
14265	16990	3	applied	\N	\N	\N	\N	55409	55409	55410
14274	17007	0	applied	\N	\N	\N	\N	55453	55453	55454
14274	17008	1	applied	\N	\N	\N	\N	55455	55455	55456
14275	17015	0	applied	\N	\N	\N	\N	55473	55473	55474
14275	17016	1	applied	\N	\N	\N	\N	55475	55475	55476
14275	17017	2	applied	\N	\N	\N	\N	55477	55477	55478
14278	17030	0	applied	\N	\N	\N	\N	55508	55508	55509
14278	17024	1	applied	\N	\N	\N	\N	55494	55494	55495
14278	17025	2	applied	\N	\N	\N	\N	55496	55496	55497
14278	17026	3	applied	\N	\N	\N	\N	55498	55498	55499
14278	17027	4	applied	\N	\N	\N	\N	55500	55500	55501
14278	17028	5	applied	\N	\N	\N	\N	55502	55502	55503
14278	17029	6	applied	\N	\N	\N	\N	55504	55504	55505
14278	17031	7	applied	\N	\N	\N	\N	55510	55510	55511
14278	17032	8	applied	\N	\N	\N	\N	55512	55512	55513
14278	17033	9	applied	\N	\N	\N	\N	55514	55514	55515
14287	17050	0	applied	\N	\N	\N	\N	55569	55569	55570
14287	17051	1	applied	\N	\N	\N	\N	55571	55571	55572
14287	17052	2	applied	\N	\N	\N	\N	55573	55573	55574
14287	17053	3	applied	\N	\N	\N	\N	55575	55575	55576
14288	17050	0	applied	\N	\N	\N	\N	55569	55569	55570
14288	17051	1	applied	\N	\N	\N	\N	55571	55571	55572
14288	17052	2	applied	\N	\N	\N	\N	55573	55573	55574
14288	17053	3	applied	\N	\N	\N	\N	55575	55575	55576
14288	17054	4	applied	\N	\N	\N	\N	55583	55583	55584
14288	17055	5	applied	\N	\N	\N	\N	55585	55585	55586
14291	17056	0	applied	\N	\N	\N	\N	55588	55588	55589
14291	17057	1	applied	\N	\N	\N	\N	55590	55590	55591
14291	17054	2	applied	\N	\N	\N	\N	55583	55583	55584
14291	17055	3	applied	\N	\N	\N	\N	55585	55585	55586
14291	17058	4	applied	\N	\N	\N	\N	55592	55592	55593
14291	17059	5	applied	\N	\N	\N	\N	55594	55594	55595
14291	17060	6	applied	\N	\N	\N	\N	55596	55596	55597
14297	17067	0	applied	\N	\N	\N	\N	55624	55624	55625
14297	17068	1	applied	\N	\N	\N	\N	55626	55626	55627
14297	17069	2	applied	\N	\N	\N	\N	55628	55628	55629
14297	17070	3	applied	\N	\N	\N	\N	55630	55630	55631
14297	17071	4	applied	\N	\N	\N	\N	55632	55632	55633
14297	17072	5	applied	\N	\N	1000000000	\N	55634	55634	55635
14297	17073	6	applied	\N	\N	\N	\N	55636	55636	55637
14297	17074	7	applied	\N	\N	\N	\N	55638	55638	55639
14297	17075	8	applied	\N	\N	\N	\N	55640	55640	55641
14300	17018	0	applied	\N	\N	\N	\N	55480	55480	55481
14300	17019	1	applied	\N	\N	\N	\N	55482	55482	55483
14300	17020	2	applied	\N	\N	\N	\N	55484	55484	55485
14300	17021	3	applied	\N	\N	\N	\N	55486	55486	55487
14300	17072	4	applied	\N	\N	1000000000	\N	55634	55634	55635
14303	17088	0	applied	\N	\N	\N	\N	55674	55674	55675
14303	17089	1	applied	\N	\N	\N	\N	55676	55676	55677
14303	17090	2	applied	\N	\N	\N	\N	55678	55678	55679
14303	17091	3	applied	\N	\N	\N	\N	55682	55682	55683
14303	17092	4	applied	\N	\N	\N	\N	55684	55684	55685
14303	17093	5	applied	\N	\N	\N	\N	55686	55686	55687
14303	17094	6	applied	\N	\N	\N	\N	55688	55688	55689
14303	17095	7	applied	\N	\N	\N	\N	55690	55690	55691
14303	17096	8	applied	\N	\N	\N	\N	55692	55692	55693
14303	17097	9	applied	\N	\N	\N	\N	55694	55694	55695
14303	17098	10	applied	\N	\N	\N	\N	55696	55696	55697
14303	17099	11	applied	\N	\N	\N	\N	55698	55698	55699
14306	17100	0	applied	\N	\N	\N	\N	55882	55882	55883
14306	17101	1	applied	\N	\N	\N	\N	55884	55884	55885
14306	17102	2	applied	\N	\N	\N	\N	55886	55886	55887
14306	17103	3	applied	\N	\N	\N	\N	55888	55888	55889
14306	17104	4	applied	\N	\N	\N	\N	55890	55890	55891
14306	17105	5	applied	\N	\N	\N	\N	55892	55892	55893
14306	17106	6	applied	\N	\N	\N	\N	55894	55894	55895
14311	17117	0	applied	\N	\N	\N	\N	55924	55924	55925
14311	17118	1	applied	\N	\N	\N	\N	55926	55926	55927
14311	17119	2	applied	\N	\N	\N	\N	55928	55928	55929
14311	17120	3	applied	\N	\N	\N	\N	55930	55930	55931
14314	17121	0	applied	\N	\N	\N	\N	55936	55936	55937
14314	17122	1	applied	\N	\N	\N	\N	55938	55938	55939
14314	17123	2	applied	\N	\N	\N	\N	55940	55940	55941
14315	17124	0	applied	\N	\N	\N	\N	55947	55947	55948
14315	17125	1	applied	\N	\N	\N	\N	55949	55949	55950
14315	17126	2	applied	\N	\N	\N	\N	55951	55951	55952
14320	17127	0	applied	\N	\N	\N	\N	55959	55959	55960
14320	17128	1	applied	\N	\N	\N	\N	55961	55961	55962
14320	17129	2	applied	\N	\N	\N	\N	55963	55963	55964
14320	17130	3	applied	\N	\N	\N	\N	55965	55965	55966
14322	17131	0	applied	\N	\N	\N	\N	55969	55969	55970
14322	17132	1	applied	\N	\N	\N	\N	55971	55971	55972
14322	17133	2	applied	\N	\N	\N	\N	55973	55973	55974
14322	17134	3	applied	\N	\N	\N	\N	55975	55975	55976
14322	17135	4	applied	\N	\N	\N	\N	55977	55977	55978
14322	17136	5	applied	\N	\N	\N	\N	55979	55979	55980
14322	17137	6	applied	\N	\N	\N	\N	55981	55981	55982
14327	17146	0	applied	\N	\N	\N	\N	56004	56004	56005
14327	17147	1	applied	\N	\N	\N	\N	56006	56006	56007
14327	17148	2	applied	\N	\N	\N	\N	56008	56008	56009
14327	17149	3	applied	\N	\N	\N	\N	56010	56010	56011
14330	17154	0	applied	\N	\N	\N	\N	56024	56024	56025
14330	17155	1	applied	\N	\N	\N	\N	56026	56026	56027
14332	17157	0	applied	\N	\N	\N	\N	56033	56033	56034
14332	17158	1	applied	\N	\N	\N	\N	56035	56035	56036
14332	17159	2	applied	\N	\N	\N	\N	56037	56037	56038
14332	17160	3	applied	\N	\N	\N	\N	56039	56039	56040
14335	17173	0	applied	\N	\N	\N	\N	56069	56069	56070
14335	17174	1	applied	\N	\N	\N	\N	56071	56071	56072
14335	17175	2	applied	\N	\N	\N	\N	56073	56073	56074
14335	17176	3	applied	\N	\N	\N	\N	56075	56075	56076
14335	17177	4	applied	\N	\N	\N	\N	56077	56077	56078
14335	17178	5	applied	\N	\N	\N	\N	56079	56079	56080
14335	17179	6	applied	\N	\N	\N	\N	56081	56081	56082
14335	17180	7	applied	\N	\N	\N	\N	56083	56083	56084
14338	17185	0	applied	\N	\N	\N	\N	56096	56096	56097
14338	17186	1	applied	\N	\N	\N	\N	56098	56098	56099
14338	17187	2	applied	\N	\N	\N	\N	56100	56100	56101
14260	16978	0	applied	\N	\N	\N	\N	55314	55314	55315
14260	16979	1	applied	\N	\N	\N	\N	55316	55316	55317
14260	16980	2	applied	\N	\N	\N	\N	55318	55318	55319
14260	16981	3	applied	\N	\N	\N	\N	55320	55320	55321
14262	16982	0	applied	\N	\N	\N	\N	55325	55325	55326
14262	16983	1	applied	\N	\N	\N	\N	55327	55327	55328
14262	16984	2	applied	\N	\N	\N	\N	55329	55329	55330
14262	16985	3	applied	\N	\N	\N	\N	55331	55331	55332
14268	16991	0	applied	\N	\N	\N	\N	55415	55415	55416
14268	16992	1	applied	\N	\N	\N	\N	55417	55417	55418
14268	16993	2	applied	\N	\N	\N	\N	55419	55419	55420
14268	16994	3	applied	\N	\N	\N	\N	55421	55421	55422
14268	16995	4	applied	\N	\N	\N	\N	55423	55423	55424
14268	16996	5	applied	\N	\N	\N	\N	55425	55425	55426
14268	16997	6	applied	\N	\N	\N	\N	55427	55427	55428
14268	16998	7	applied	\N	\N	\N	\N	55429	55429	55430
14268	16999	8	applied	\N	\N	\N	\N	55431	55431	55432
14268	17000	9	applied	\N	\N	\N	\N	55433	55433	55434
14268	17001	10	applied	\N	\N	\N	\N	55435	55435	55436
14268	17002	11	applied	\N	\N	\N	\N	55437	55437	55438
14270	17003	0	applied	\N	\N	\N	\N	55442	55442	55443
14270	17004	1	applied	\N	\N	\N	\N	55445	55445	55446
14270	17005	2	applied	\N	\N	\N	\N	55447	55447	55448
14270	17006	3	applied	\N	\N	\N	\N	55449	55449	55450
14272	17007	0	applied	\N	\N	\N	\N	55453	55453	55454
14272	17008	1	applied	\N	\N	\N	\N	55455	55455	55456
14272	17009	2	applied	\N	\N	\N	\N	55457	55457	55458
14272	17010	3	applied	\N	\N	\N	\N	55459	55459	55460
14272	17011	4	applied	\N	\N	\N	\N	55461	55461	55462
14272	17012	5	applied	\N	\N	\N	\N	55463	55463	55464
14272	17013	6	applied	\N	\N	\N	\N	55465	55465	55466
14272	17014	7	applied	\N	\N	\N	\N	55467	55467	55468
14277	17018	0	applied	\N	\N	\N	\N	55480	55480	55481
14277	17019	1	applied	\N	\N	\N	\N	55482	55482	55483
14277	17020	2	applied	\N	\N	\N	\N	55484	55484	55485
14277	17021	3	applied	\N	\N	\N	\N	55486	55486	55487
14277	17022	4	applied	\N	\N	\N	\N	55488	55488	55489
14277	17023	5	applied	\N	\N	\N	\N	55490	55490	55491
14277	17024	6	applied	\N	\N	\N	\N	55494	55494	55495
14277	17025	7	applied	\N	\N	\N	\N	55496	55496	55497
14277	17026	8	applied	\N	\N	\N	\N	55498	55498	55499
14277	17027	9	applied	\N	\N	\N	\N	55500	55500	55501
14277	17028	10	applied	\N	\N	\N	\N	55502	55502	55503
14277	17029	11	applied	\N	\N	\N	\N	55504	55504	55505
14280	17034	0	applied	\N	\N	\N	\N	55517	55517	55518
14280	17035	1	applied	\N	\N	\N	\N	55519	55519	55520
14280	17036	2	applied	\N	\N	\N	\N	55521	55521	55522
14280	17037	3	applied	\N	\N	\N	\N	55523	55523	55524
14280	17038	4	applied	\N	\N	\N	\N	55525	55525	55526
14280	17039	5	applied	\N	\N	\N	\N	55527	55527	55528
14280	17040	6	applied	\N	\N	\N	\N	55529	55529	55530
14280	17041	7	applied	\N	\N	\N	\N	55531	55531	55532
14285	17050	0	applied	\N	\N	\N	\N	55569	55569	55570
14285	17051	1	applied	\N	\N	\N	\N	55571	55571	55572
14285	17052	2	applied	\N	\N	\N	\N	55573	55573	55574
14285	17053	3	applied	\N	\N	\N	\N	55575	55575	55576
14289	17056	0	applied	\N	\N	\N	\N	55588	55588	55589
14289	17057	1	applied	\N	\N	\N	\N	55590	55590	55591
14289	17054	2	applied	\N	\N	\N	\N	55583	55583	55584
14289	17055	3	applied	\N	\N	\N	\N	55585	55585	55586
14289	17058	4	applied	\N	\N	\N	\N	55592	55592	55593
14289	17059	5	applied	\N	\N	\N	\N	55594	55594	55595
14289	17060	6	applied	\N	\N	\N	\N	55596	55596	55597
14294	17061	0	applied	\N	\N	\N	\N	55602	55602	55603
14294	17062	2	applied	\N	\N	\N	\N	55605	55605	55606
14294	17063	3	applied	\N	\N	\N	\N	55607	55607	55608
14294	17064	4	applied	\N	\N	\N	\N	55609	55609	55610
14299	17080	0	applied	\N	\N	\N	\N	55654	55654	55655
14299	17081	1	applied	\N	\N	\N	\N	55656	55656	55657
14299	17082	2	applied	\N	\N	\N	\N	55658	55658	55659
14299	17083	3	applied	\N	\N	\N	\N	55660	55660	55661
14299	17084	4	applied	\N	\N	\N	\N	55662	55662	55663
14299	17085	5	applied	\N	\N	\N	\N	55664	55664	55665
14299	17086	6	applied	\N	\N	\N	\N	55666	55666	55667
14299	17087	7	applied	\N	\N	\N	\N	55668	55668	55669
14302	17088	0	applied	\N	\N	\N	\N	55674	55674	55675
14302	17089	1	applied	\N	\N	\N	\N	55676	55676	55677
14302	17090	2	applied	\N	\N	\N	\N	55678	55678	55679
14302	17091	3	applied	\N	\N	\N	\N	55682	55682	55683
14302	17092	4	applied	\N	\N	\N	\N	55684	55684	55685
14302	17093	5	applied	\N	\N	\N	\N	55686	55686	55687
14302	17094	6	applied	\N	\N	\N	\N	55688	55688	55689
14302	17095	7	applied	\N	\N	\N	\N	55690	55690	55691
14302	17096	8	applied	\N	\N	\N	\N	55692	55692	55693
14302	17097	9	applied	\N	\N	\N	\N	55694	55694	55695
14302	17098	10	applied	\N	\N	\N	\N	55696	55696	55697
14302	17099	11	applied	\N	\N	\N	\N	55698	55698	55699
14307	17107	0	applied	\N	\N	\N	\N	55899	55899	55900
14307	17108	1	applied	\N	\N	\N	\N	55901	55901	55902
14307	17109	2	applied	\N	\N	\N	\N	55903	55903	55904
14307	17110	3	applied	\N	\N	\N	\N	55905	55905	55906
14307	17111	4	applied	\N	\N	\N	\N	55907	55907	55908
14307	17112	5	applied	\N	\N	\N	\N	55909	55909	55910
14307	17113	6	applied	\N	\N	\N	\N	55911	55911	55912
14312	17121	0	applied	\N	\N	\N	\N	55936	55936	55937
14312	17122	1	applied	\N	\N	\N	\N	55938	55938	55939
14312	17123	2	applied	\N	\N	\N	\N	55940	55940	55941
14317	17124	0	applied	\N	\N	\N	\N	55947	55947	55948
14317	17125	1	applied	\N	\N	\N	\N	55949	55949	55950
14317	17126	2	applied	\N	\N	\N	\N	55951	55951	55952
14323	17138	0	applied	\N	\N	\N	\N	55984	55984	55985
14323	17139	1	applied	\N	\N	\N	\N	55986	55986	55987
14323	17140	2	applied	\N	\N	\N	\N	55988	55988	55989
14323	17141	3	applied	\N	\N	\N	\N	55990	55990	55991
14331	17157	0	applied	\N	\N	\N	\N	56033	56033	56034
14331	17158	1	applied	\N	\N	\N	\N	56035	56035	56036
14331	17159	2	applied	\N	\N	\N	\N	56037	56037	56038
14331	17160	3	applied	\N	\N	\N	\N	56039	56039	56040
14339	17189	0	applied	\N	\N	\N	\N	56107	56107	56108
14339	17190	1	applied	\N	\N	\N	\N	56109	56109	56110
14339	17191	2	applied	\N	\N	\N	\N	56111	56111	56112
14339	17192	3	applied	\N	\N	\N	\N	56113	56113	56114
14339	17193	4	applied	\N	\N	\N	\N	56115	56115	56116
14339	17194	5	applied	\N	\N	\N	\N	56117	56117	56118
14339	17195	6	applied	\N	\N	\N	\N	56119	56119	56120
14339	17196	7	applied	\N	\N	\N	\N	56121	56121	56122
14342	17201	0	applied	\N	\N	\N	\N	56137	56137	56138
14342	17202	1	applied	\N	\N	\N	\N	56139	56139	56140
14342	17203	2	applied	\N	\N	\N	\N	56141	56141	56142
14342	17204	3	applied	\N	\N	\N	\N	56143	56143	56144
14263	16642	112	applied	\N	\N	\N	\N	55377	55377	55378
14263	16644	113	applied	\N	\N	\N	\N	55379	55379	55380
14263	16645	114	applied	\N	\N	\N	\N	55381	55381	54370
14263	16646	115	applied	\N	\N	\N	\N	55382	55382	55383
14263	16648	116	applied	\N	\N	\N	\N	55384	55384	55385
14263	16649	117	applied	\N	\N	\N	\N	55386	55386	54385
14263	16651	118	applied	\N	\N	\N	\N	55387	55387	55388
14263	16652	119	applied	\N	\N	\N	\N	55389	55389	55390
14263	16653	120	applied	\N	\N	\N	\N	55391	55391	54397
14263	16655	121	applied	\N	\N	\N	\N	55392	55392	55393
14263	16656	122	applied	\N	\N	\N	\N	55394	55394	55395
14263	16657	123	applied	\N	\N	\N	\N	55396	55396	54407
14263	16659	124	applied	\N	\N	\N	\N	55397	55397	55398
14263	16660	125	applied	\N	\N	\N	\N	55399	55399	55400
14266	16991	0	applied	\N	\N	\N	\N	55415	55415	55416
14266	16992	1	applied	\N	\N	\N	\N	55417	55417	55418
14266	16993	2	applied	\N	\N	\N	\N	55419	55419	55420
14266	16994	3	applied	\N	\N	\N	\N	55421	55421	55422
14266	16995	4	applied	\N	\N	\N	\N	55423	55423	55424
14266	16996	5	applied	\N	\N	\N	\N	55425	55425	55426
14266	16997	6	applied	\N	\N	\N	\N	55427	55427	55428
14266	16998	7	applied	\N	\N	\N	\N	55429	55429	55430
14266	16999	8	applied	\N	\N	\N	\N	55431	55431	55432
14266	17000	9	applied	\N	\N	\N	\N	55433	55433	55434
14266	17001	10	applied	\N	\N	\N	\N	55435	55435	55436
14266	17002	11	applied	\N	\N	\N	\N	55437	55437	55438
14273	17007	0	applied	\N	\N	\N	\N	55453	55453	55454
14273	17008	1	applied	\N	\N	\N	\N	55455	55455	55456
14273	17009	2	applied	\N	\N	\N	\N	55457	55457	55458
14273	17010	3	applied	\N	\N	\N	\N	55459	55459	55460
14273	17011	4	applied	\N	\N	\N	\N	55461	55461	55462
14273	17012	5	applied	\N	\N	\N	\N	55463	55463	55464
14273	17013	6	applied	\N	\N	\N	\N	55465	55465	55466
14273	17014	7	applied	\N	\N	\N	\N	55467	55467	55468
14281	17034	0	applied	\N	\N	\N	\N	55517	55517	55518
14281	17035	1	applied	\N	\N	\N	\N	55519	55519	55520
14281	17036	2	applied	\N	\N	\N	\N	55521	55521	55522
14281	17037	3	applied	\N	\N	\N	\N	55523	55523	55524
14281	17038	4	applied	\N	\N	\N	\N	55525	55525	55526
14281	17039	5	applied	\N	\N	\N	\N	55527	55527	55528
14281	17040	6	applied	\N	\N	\N	\N	55529	55529	55530
14281	17041	7	applied	\N	\N	\N	\N	55531	55531	55532
14283	17042	0	applied	\N	\N	\N	\N	55552	55552	55553
14283	17043	1	applied	\N	\N	\N	\N	55554	55554	55555
14283	17036	2	applied	\N	\N	\N	\N	55521	55521	55522
14283	17037	3	applied	\N	\N	\N	\N	55523	55523	55524
14283	17038	4	applied	\N	\N	\N	\N	55525	55525	55526
14283	17039	5	applied	\N	\N	\N	\N	55527	55527	55528
14283	17040	6	applied	\N	\N	\N	\N	55529	55529	55530
14283	17041	7	applied	\N	\N	\N	\N	55531	55531	55532
14283	17044	8	applied	\N	\N	\N	\N	55556	55556	55557
14283	17045	9	applied	\N	\N	\N	\N	55558	55558	55559
14283	17046	10	applied	\N	\N	\N	\N	55560	55560	55561
14283	17047	11	applied	\N	\N	\N	\N	55562	55562	55563
14283	17048	12	applied	\N	\N	\N	\N	55564	55564	55565
14283	17049	13	applied	\N	\N	\N	\N	55566	55566	55567
14286	17050	0	applied	\N	\N	\N	\N	55569	55569	55570
14286	17051	1	applied	\N	\N	\N	\N	55571	55571	55572
14286	17052	2	applied	\N	\N	\N	\N	55573	55573	55574
14286	17053	3	applied	\N	\N	\N	\N	55575	55575	55576
14290	17056	0	applied	\N	\N	\N	\N	55588	55588	55589
14290	17057	1	applied	\N	\N	\N	\N	55590	55590	55591
14290	17054	2	applied	\N	\N	\N	\N	55583	55583	55584
14290	17055	3	applied	\N	\N	\N	\N	55585	55585	55586
14290	17058	4	applied	\N	\N	\N	\N	55592	55592	55593
14290	17059	5	applied	\N	\N	\N	\N	55594	55594	55595
14290	17060	6	applied	\N	\N	\N	\N	55596	55596	55597
14295	17062	0	applied	\N	\N	\N	\N	55605	55605	55606
14295	17063	2	applied	\N	\N	\N	\N	55607	55607	55608
14295	17064	3	applied	\N	\N	\N	\N	55609	55609	55610
14296	17065	0	applied	\N	\N	\N	\N	55619	55619	55620
14296	17066	1	applied	\N	\N	\N	\N	55621	55621	55622
14305	17100	0	applied	\N	\N	\N	\N	55882	55882	55883
14305	17101	1	applied	\N	\N	\N	\N	55884	55884	55885
14305	17102	2	applied	\N	\N	\N	\N	55886	55886	55887
14305	17103	3	applied	\N	\N	\N	\N	55888	55888	55889
14305	17104	4	applied	\N	\N	\N	\N	55890	55890	55891
14305	17105	5	applied	\N	\N	\N	\N	55892	55892	55893
14305	17106	6	applied	\N	\N	\N	\N	55894	55894	55895
14308	17107	0	applied	\N	\N	\N	\N	55899	55899	55900
14308	17108	1	applied	\N	\N	\N	\N	55901	55901	55902
14308	17109	2	applied	\N	\N	\N	\N	55903	55903	55904
14308	17110	3	applied	\N	\N	\N	\N	55905	55905	55906
14308	17111	4	applied	\N	\N	\N	\N	55907	55907	55908
14308	17112	5	applied	\N	\N	\N	\N	55909	55909	55910
14308	17113	6	applied	\N	\N	\N	\N	55911	55911	55912
14310	17117	0	applied	\N	\N	\N	\N	55924	55924	55925
14310	17118	1	applied	\N	\N	\N	\N	55926	55926	55927
14310	17119	2	applied	\N	\N	\N	\N	55928	55928	55929
14310	17120	3	applied	\N	\N	\N	\N	55930	55930	55931
14313	17121	0	applied	\N	\N	\N	\N	55936	55936	55937
14313	17122	1	applied	\N	\N	\N	\N	55938	55938	55939
14313	17123	2	applied	\N	\N	\N	\N	55940	55940	55941
14318	17124	0	applied	\N	\N	\N	\N	55947	55947	55948
14318	17125	1	applied	\N	\N	\N	\N	55949	55949	55950
14318	17126	2	applied	\N	\N	\N	\N	55951	55951	55952
14319	17127	0	applied	\N	\N	\N	\N	55959	55959	55960
14319	17128	1	applied	\N	\N	\N	\N	55961	55961	55962
14319	17129	2	applied	\N	\N	\N	\N	55963	55963	55964
14319	17130	3	applied	\N	\N	\N	\N	55965	55965	55966
14324	17138	0	applied	\N	\N	\N	\N	55984	55984	55985
14324	17139	1	applied	\N	\N	\N	\N	55986	55986	55987
14324	17140	2	applied	\N	\N	\N	\N	55988	55988	55989
14324	17141	3	applied	\N	\N	\N	\N	55990	55990	55991
14326	17142	0	applied	\N	\N	\N	\N	55995	55995	55996
14326	17143	1	applied	\N	\N	\N	\N	55997	55997	55998
14326	17144	2	applied	\N	\N	\N	\N	55999	55999	56000
14329	17154	0	applied	\N	\N	\N	\N	56024	56024	56025
14329	17155	1	applied	\N	\N	\N	\N	56026	56026	56027
14329	17156	2	applied	\N	\N	\N	\N	56028	56028	56029
14334	17169	0	applied	\N	\N	\N	\N	56061	56061	56062
14334	17170	1	applied	\N	\N	\N	\N	56063	56063	56064
14334	17171	2	applied	\N	\N	\N	\N	56065	56065	56066
14334	17172	3	applied	\N	\N	\N	\N	56067	56067	56068
14337	17185	0	applied	\N	\N	\N	\N	56096	56096	56097
14337	17186	1	applied	\N	\N	\N	\N	56098	56098	56099
14337	17187	2	applied	\N	\N	\N	\N	56100	56100	56101
14337	17188	3	applied	\N	\N	\N	\N	56102	56102	56103
14340	17197	0	applied	\N	\N	\N	\N	56125	56125	56126
14340	17198	1	applied	\N	\N	\N	\N	56127	56127	56128
14282	16940	87	applied	\N	\N	\N	\N	55214	55214	55361
14282	16947	88	applied	\N	\N	\N	\N	55230	55230	55362
14282	16951	89	applied	\N	\N	\N	\N	55238	55238	55363
14282	16955	90	applied	\N	\N	\N	\N	55248	55248	55364
14282	16958	91	applied	\N	\N	\N	\N	55255	55255	55365
14282	16959	92	applied	\N	\N	\N	\N	55257	55257	55366
14282	16966	93	applied	\N	\N	\N	\N	55278	55278	55367
14282	16970	94	applied	\N	\N	\N	\N	55289	55289	55368
14282	16974	96	applied	\N	\N	\N	\N	55303	55303	55369
14282	16978	97	applied	\N	\N	\N	\N	55314	55314	55370
14282	16982	98	applied	\N	\N	\N	\N	55325	55325	55536
14282	16987	99	applied	\N	\N	\N	\N	55403	55403	55537
14282	16991	100	applied	\N	\N	\N	\N	55415	55415	55538
14282	16992	101	applied	\N	\N	\N	\N	55417	55417	55539
14282	16993	102	applied	\N	\N	\N	\N	55419	55419	55540
14282	17003	103	applied	\N	\N	\N	\N	55442	55442	55541
14282	17007	104	applied	\N	\N	\N	\N	55453	55453	55542
14282	17008	105	applied	\N	\N	\N	\N	55455	55455	55543
14282	17015	106	applied	\N	\N	\N	\N	55473	55473	55544
14282	17022	107	applied	\N	\N	\N	\N	55488	55488	55545
14282	17023	108	applied	\N	\N	\N	\N	55490	55490	55546
14282	17030	109	applied	\N	\N	\N	\N	55508	55508	55547
14282	17034	110	applied	\N	\N	\N	\N	55517	55517	55548
14282	17035	111	applied	\N	\N	\N	\N	55519	55519	55549
14282	16636	112	applied	\N	\N	\N	\N	54343	54343	25661
14282	16632	113	applied	\N	\N	\N	\N	54331	54331	54332
14284	17050	0	applied	\N	\N	\N	\N	55569	55569	55570
14284	17051	1	applied	\N	\N	\N	\N	55571	55571	55572
14284	17052	2	applied	\N	\N	\N	\N	55573	55573	55574
14284	17053	3	applied	\N	\N	\N	\N	55575	55575	55576
14293	17061	0	applied	\N	\N	\N	\N	55602	55602	55603
14293	17062	2	applied	\N	\N	\N	\N	55605	55605	55606
14293	17063	3	applied	\N	\N	\N	\N	55607	55607	55608
14293	17064	4	applied	\N	\N	\N	\N	55609	55609	55610
14298	17076	0	applied	\N	\N	\N	\N	55644	55644	55645
14298	17077	1	applied	\N	\N	\N	\N	55646	55646	55647
14298	17078	2	applied	\N	\N	\N	\N	55648	55648	55649
14298	17079	3	applied	\N	\N	\N	\N	55650	55650	55651
14301	17088	0	applied	\N	\N	\N	\N	55674	55674	55675
14301	17089	1	applied	\N	\N	\N	\N	55676	55676	55677
14301	17090	2	applied	\N	\N	\N	\N	55678	55678	55679
14304	16982	0	applied	\N	\N	\N	\N	55325	55325	55536
14304	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14304	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14304	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14304	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14304	16987	5	applied	\N	\N	\N	\N	55403	55403	55537
14304	16991	6	applied	\N	\N	\N	\N	55415	55415	55538
14304	16992	7	applied	\N	\N	\N	\N	55417	55417	55539
14304	16993	8	applied	\N	\N	\N	\N	55419	55419	55540
14304	17003	9	applied	\N	\N	\N	\N	55442	55442	55541
14304	17007	10	applied	\N	\N	\N	\N	55453	55453	55542
14304	17008	11	applied	\N	\N	\N	\N	55455	55455	55543
14304	17015	12	applied	\N	\N	\N	\N	55473	55473	55544
14304	17022	13	applied	\N	\N	\N	\N	55488	55488	55545
14304	17023	14	applied	\N	\N	\N	\N	55490	55490	55546
14304	17030	15	applied	\N	\N	\N	\N	55508	55508	55547
14304	17034	16	applied	\N	\N	\N	\N	55517	55517	55548
14304	17035	17	applied	\N	\N	\N	\N	55519	55519	55549
14304	17042	18	applied	\N	\N	\N	\N	55552	55552	55703
14304	17043	19	applied	\N	\N	\N	\N	55554	55554	55704
14304	17050	20	applied	\N	\N	\N	\N	55569	55569	55705
14304	17056	21	applied	\N	\N	\N	\N	55588	55588	55706
14304	17057	22	applied	\N	\N	\N	\N	55590	55590	55707
14304	17061	23	applied	\N	\N	\N	\N	55602	55602	55708
14304	17067	24	applied	\N	\N	\N	\N	55624	55624	55709
14304	17068	25	applied	\N	\N	\N	\N	55626	55626	55710
14304	17076	26	applied	\N	\N	\N	\N	55644	55644	55711
14304	17080	27	applied	\N	\N	\N	\N	55654	55654	55712
14304	17081	28	applied	\N	\N	\N	\N	55656	55656	55713
14304	17088	29	applied	\N	\N	\N	\N	55674	55674	55714
14304	17089	30	applied	\N	\N	\N	\N	55676	55676	55715
14304	17090	31	applied	\N	\N	\N	\N	55678	55678	55716
14304	16661	32	applied	\N	\N	\N	\N	55717	55717	54425
14304	16665	33	applied	\N	\N	\N	\N	55718	55718	55719
14304	16666	34	applied	\N	\N	\N	\N	55720	55720	55721
14304	16667	35	applied	\N	\N	\N	\N	55722	55722	54431
14304	16668	36	applied	\N	\N	\N	\N	55723	55723	55724
14304	17072	37	applied	\N	\N	1000000000	\N	55634	55634	55635
14304	16669	38	applied	\N	\N	\N	\N	55725	55725	55726
14304	16670	39	applied	\N	\N	\N	\N	55727	55727	54437
14304	16671	40	applied	\N	\N	\N	\N	55728	55728	55729
14304	16672	41	applied	\N	\N	\N	\N	55730	55730	55731
14304	16673	42	applied	\N	\N	\N	\N	55732	55732	54447
14304	16675	43	applied	\N	\N	\N	\N	55733	55733	55734
14304	16676	44	applied	\N	\N	\N	\N	55735	55735	55736
14304	16677	45	applied	\N	\N	\N	\N	55737	55737	54455
14304	16679	46	applied	\N	\N	\N	\N	55738	55738	55739
14304	16680	47	applied	\N	\N	\N	\N	55740	55740	55741
14304	16681	48	applied	\N	\N	\N	\N	55742	55742	54465
14304	16683	49	applied	\N	\N	\N	\N	55743	55743	55744
14304	16684	50	applied	\N	\N	\N	\N	55745	55745	55746
14304	16685	51	applied	\N	\N	\N	\N	55747	55747	54476
14304	16687	52	applied	\N	\N	\N	\N	55748	55748	55749
14304	16688	53	applied	\N	\N	\N	\N	55750	55750	55751
14304	16689	54	applied	\N	\N	\N	\N	55752	55752	55753
14304	16691	55	applied	\N	\N	\N	\N	55754	55754	54490
14304	16692	56	applied	\N	\N	\N	\N	55755	55755	55756
14304	16693	57	applied	\N	\N	\N	\N	55757	55757	55758
14304	16697	58	applied	\N	\N	\N	\N	55759	55759	55760
14304	16698	59	applied	\N	\N	\N	\N	55761	55761	55762
14304	16699	60	applied	\N	\N	\N	\N	55763	55763	54514
14304	16700	61	applied	\N	\N	\N	\N	55764	55764	55765
14304	16701	62	applied	\N	\N	\N	\N	55766	55766	55767
14304	16702	63	applied	\N	\N	\N	\N	55768	55768	54523
14304	16703	64	applied	\N	\N	\N	\N	55769	55769	55770
14304	16704	65	applied	\N	\N	\N	\N	55771	55771	55772
14304	16706	66	applied	\N	\N	\N	\N	55773	55773	54539
14304	16707	67	applied	\N	\N	\N	\N	55774	55774	55775
14304	16710	68	applied	\N	\N	\N	\N	55776	55776	54550
14304	16711	69	applied	\N	\N	\N	\N	55777	55777	55778
14304	16712	70	applied	\N	\N	\N	\N	55779	55779	55780
14304	16713	71	applied	\N	\N	\N	\N	55781	55781	55782
14304	16715	72	applied	\N	\N	\N	\N	55783	55783	55784
14304	16716	73	applied	\N	\N	\N	\N	55785	55785	55786
14304	16718	74	applied	\N	\N	\N	\N	55787	55787	55788
14304	16719	75	applied	\N	\N	\N	\N	55789	55789	55790
14304	16722	76	applied	\N	\N	\N	\N	55791	55791	55792
14304	16723	77	applied	\N	\N	\N	\N	55793	55793	55794
14304	16724	78	applied	\N	\N	\N	\N	55795	55795	55796
14304	16725	79	applied	\N	\N	\N	\N	55797	55797	55798
14304	16727	80	applied	\N	\N	\N	\N	55799	55799	55800
14304	16728	81	applied	\N	\N	\N	\N	55801	55801	55802
14304	16730	82	applied	\N	\N	\N	\N	55803	55803	55804
14304	16731	83	applied	\N	\N	\N	\N	55805	55805	55806
14304	16733	84	applied	\N	\N	\N	\N	55807	55807	55808
14304	16734	85	applied	\N	\N	\N	\N	55809	55809	55810
14304	16736	86	applied	\N	\N	\N	\N	55811	55811	55812
14304	16737	87	applied	\N	\N	\N	\N	55813	55813	55814
14304	16738	88	applied	\N	\N	\N	\N	55815	55815	55816
14304	16739	89	applied	\N	\N	\N	\N	55817	55817	55818
14304	16741	90	applied	\N	\N	\N	\N	55819	55819	55820
14304	16742	91	applied	\N	\N	\N	\N	55821	55821	55822
14304	16744	92	applied	\N	\N	\N	\N	55823	55823	55824
14304	16745	93	applied	\N	\N	\N	\N	55825	55825	55826
14304	16748	94	applied	\N	\N	\N	\N	55827	55827	55828
14304	16749	95	applied	\N	\N	\N	\N	55829	55829	55830
14304	16750	96	applied	\N	\N	\N	\N	55831	55831	55832
14304	16751	97	applied	\N	\N	\N	\N	55833	55833	55834
14304	16755	98	applied	\N	\N	\N	\N	55835	55835	55836
14304	16756	99	applied	\N	\N	\N	\N	55837	55837	55838
14304	16757	100	applied	\N	\N	\N	\N	55839	55839	54731
14304	16758	101	applied	\N	\N	\N	\N	55840	55840	55841
14304	16759	102	applied	\N	\N	\N	\N	55842	55842	55843
14304	16760	103	applied	\N	\N	\N	\N	55844	55844	54737
14304	16761	104	applied	\N	\N	\N	\N	55845	55845	55846
14304	16762	105	applied	\N	\N	\N	\N	55847	55847	55848
14304	16764	106	applied	\N	\N	\N	\N	55849	55849	54746
14304	16765	107	applied	\N	\N	\N	\N	55850	55850	55851
14304	16766	108	applied	\N	\N	\N	\N	55852	55852	55853
14304	16768	110	applied	\N	\N	\N	\N	55855	55855	54759
14304	16769	111	applied	\N	\N	1000000000	\N	55856	55856	54757
14304	16770	112	applied	\N	\N	\N	\N	55857	55857	55858
14304	16771	113	applied	\N	\N	\N	\N	55859	55859	55860
14304	16774	114	applied	\N	\N	\N	\N	55861	55861	54771
14304	16775	115	applied	\N	\N	\N	\N	55862	55862	55863
14304	16776	116	applied	\N	\N	\N	\N	55864	55864	55865
14304	16777	117	applied	\N	\N	\N	\N	55866	55866	54777
14304	16778	118	applied	\N	\N	\N	\N	55867	55867	55868
14304	16779	119	applied	\N	\N	\N	\N	55869	55869	55870
14304	16782	120	applied	\N	\N	\N	\N	55871	55871	54790
14304	16783	121	applied	\N	\N	\N	\N	55872	55872	55873
14304	16784	122	applied	\N	\N	\N	\N	55874	55874	54794
14304	16785	123	applied	\N	\N	\N	\N	55875	55875	55876
14304	16787	124	applied	\N	\N	\N	\N	55877	55877	55878
14304	16788	125	applied	\N	\N	\N	\N	55879	55879	54813
14309	17114	0	applied	\N	\N	\N	\N	55916	55916	55917
14309	17115	1	applied	\N	\N	\N	\N	55918	55918	55919
14309	17116	2	applied	\N	\N	\N	\N	55920	55920	55921
14316	17124	0	applied	\N	\N	\N	\N	55947	55947	55948
14316	17125	1	applied	\N	\N	\N	\N	55949	55949	55950
14316	17126	2	applied	\N	\N	\N	\N	55951	55951	55952
14321	17127	0	applied	\N	\N	\N	\N	55959	55959	55960
14321	17128	1	applied	\N	\N	\N	\N	55961	55961	55962
14321	17129	2	applied	\N	\N	\N	\N	55963	55963	55964
14321	17130	3	applied	\N	\N	\N	\N	55965	55965	55966
14325	17142	0	applied	\N	\N	\N	\N	55995	55995	55996
14325	17143	1	applied	\N	\N	\N	\N	55997	55997	55998
14325	17144	2	applied	\N	\N	\N	\N	55999	55999	56000
14325	17145	3	applied	\N	\N	\N	\N	56001	56001	56002
14328	17150	0	applied	\N	\N	\N	\N	56014	56014	56015
14328	17151	1	applied	\N	\N	\N	\N	56016	56016	56017
14328	17152	2	applied	\N	\N	\N	\N	56018	56018	56019
14328	17153	3	applied	\N	\N	\N	\N	56020	56020	56021
14333	17161	0	applied	\N	\N	\N	\N	56044	56044	56045
14333	17162	1	applied	\N	\N	\N	\N	56046	56046	56047
14333	17163	2	applied	\N	\N	\N	\N	56048	56048	56049
14333	17164	3	applied	\N	\N	1000000000	\N	56050	56050	56051
14333	17165	4	applied	\N	\N	\N	\N	56052	56052	56053
14333	17166	5	applied	\N	\N	\N	\N	56054	56054	56055
14333	17167	6	applied	\N	\N	\N	\N	56056	56056	56057
14333	17168	7	applied	\N	\N	\N	\N	56058	56058	56059
14336	17181	0	applied	\N	\N	\N	\N	56086	56086	56087
14336	17182	1	applied	\N	\N	\N	\N	56088	56088	56089
14336	17183	2	applied	\N	\N	\N	\N	56090	56090	56091
14336	17184	3	applied	\N	\N	\N	\N	56092	56092	56093
14354	17234	0	applied	\N	\N	\N	\N	56222	56222	56223
14354	17235	1	applied	\N	\N	\N	\N	56224	56224	56225
14354	17236	2	applied	\N	\N	\N	\N	56226	56226	56227
14354	17237	3	applied	\N	\N	\N	\N	56228	56228	56229
14356	17239	0	applied	\N	\N	\N	\N	56236	56236	56237
14356	17240	1	applied	\N	\N	\N	\N	56238	56238	56239
14356	17241	2	applied	\N	\N	\N	\N	56240	56240	56241
14356	17242	3	applied	\N	\N	\N	\N	56242	56242	56243
14356	17243	4	applied	\N	\N	\N	\N	56244	56244	56245
14356	17244	5	applied	\N	\N	\N	\N	56246	56246	56247
14356	17245	6	applied	\N	\N	\N	\N	56248	56248	56249
14356	17246	7	applied	\N	\N	\N	\N	56250	56250	56251
14358	17247	0	applied	\N	\N	\N	\N	56257	56257	56258
14358	17248	1	applied	\N	\N	\N	\N	56259	56259	56260
14358	17249	2	applied	\N	\N	\N	\N	56261	56261	56262
14358	17250	3	applied	\N	\N	\N	\N	56263	56263	56264
14362	17240	0	applied	\N	\N	\N	\N	56254	56254	56239
14362	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14362	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14362	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14362	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14362	16780	5	applied	\N	\N	\N	\N	54782	54782	54783
14362	16781	6	applied	\N	\N	\N	\N	54784	54784	54785
14362	16786	7	applied	\N	\N	\N	\N	54806	54806	54807
14362	16790	8	applied	\N	\N	\N	\N	54816	54816	54817
14362	16792	9	applied	\N	\N	\N	\N	54824	54824	54825
14362	16795	10	applied	\N	\N	\N	\N	54832	54832	54833
14362	16799	11	applied	\N	\N	\N	\N	54849	54849	54850
14362	16800	13	applied	\N	\N	\N	\N	54851	54851	54852
14362	16805	14	applied	\N	\N	\N	\N	54862	54862	54863
14362	16809	15	applied	\N	\N	\N	\N	54871	54871	54872
14362	16812	16	applied	\N	\N	\N	\N	54878	54878	54879
14362	16813	17	applied	\N	\N	\N	\N	54880	54880	54881
14362	16820	18	applied	\N	\N	\N	\N	54896	54896	54897
14362	16821	19	applied	\N	\N	\N	\N	54900	54900	54901
14362	16827	20	applied	\N	\N	\N	\N	54914	54914	54990
14362	16828	21	applied	\N	\N	\N	\N	54916	54916	54991
14362	16835	22	applied	\N	\N	\N	\N	54933	54933	55334
14362	16838	23	applied	\N	\N	\N	\N	54941	54941	55335
14362	16842	24	applied	\N	\N	\N	\N	54949	54949	55336
14362	16846	25	applied	\N	\N	\N	\N	54959	54959	55337
14362	16850	26	applied	\N	\N	\N	\N	54970	54970	55338
14362	16854	27	applied	\N	\N	\N	\N	54980	54980	55339
14338	17188	3	applied	\N	\N	\N	\N	56102	56102	56103
14341	17197	0	applied	\N	\N	\N	\N	56125	56125	56126
14341	17198	1	applied	\N	\N	\N	\N	56127	56127	56128
14341	17199	2	applied	\N	\N	\N	\N	56129	56129	56130
14341	17200	3	applied	\N	\N	\N	\N	56131	56131	56132
14344	17201	0	applied	\N	\N	\N	\N	56137	56137	56138
14344	17202	1	applied	\N	\N	\N	\N	56139	56139	56140
14344	17203	2	applied	\N	\N	\N	\N	56141	56141	56142
14344	17204	3	applied	\N	\N	\N	\N	56143	56143	56144
14344	17205	4	applied	\N	\N	\N	\N	56145	56145	56146
14344	17206	5	applied	\N	\N	\N	\N	56147	56147	56148
14344	17207	6	applied	\N	\N	\N	\N	56149	56149	56150
14346	17208	0	applied	\N	\N	\N	\N	56156	56156	56157
14346	17209	1	applied	\N	\N	\N	\N	56158	56158	56159
14346	17210	2	applied	\N	\N	\N	\N	56160	56160	56161
14346	17211	3	applied	\N	\N	\N	\N	56162	56162	56163
14346	17212	4	applied	\N	\N	\N	\N	56164	56164	56165
14346	17213	5	applied	\N	\N	\N	\N	56166	56166	56167
14346	17214	6	applied	\N	\N	\N	\N	56168	56168	56169
14346	17215	7	applied	\N	\N	\N	\N	56170	56170	56171
14348	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14348	16554	1	applied	\N	\N	\N	\N	54121	54121	54122
14348	16555	2	applied	\N	\N	\N	\N	54123	54123	54124
14348	16563	3	applied	\N	\N	\N	\N	54141	54141	54142
14348	16567	4	applied	\N	\N	\N	\N	54158	54158	54159
14348	16572	5	applied	\N	\N	\N	\N	54171	54171	54172
14348	16573	6	applied	\N	\N	\N	\N	54173	54173	54174
14348	17018	7	applied	\N	\N	\N	\N	55480	55480	55481
14348	17019	8	applied	\N	\N	\N	\N	55482	55482	55483
14348	17020	9	applied	\N	\N	\N	\N	55484	55484	55485
14348	17021	10	applied	\N	\N	\N	\N	55486	55486	55487
14348	16580	11	applied	\N	\N	\N	\N	54189	54189	54190
14348	16584	12	applied	\N	\N	\N	\N	54202	54202	54203
14348	16592	13	applied	\N	\N	\N	\N	54220	54220	54221
14348	16596	14	applied	\N	\N	\N	\N	54232	54232	54233
14348	16600	15	applied	\N	\N	\N	\N	54241	54241	54242
14348	16604	16	applied	\N	\N	\N	\N	54257	54257	54258
14348	16608	17	applied	\N	\N	\N	\N	54268	54268	54269
14348	16609	18	applied	\N	\N	\N	\N	54270	54270	54271
14348	16616	19	applied	\N	\N	\N	\N	54287	54287	54288
14348	16623	20	applied	\N	\N	\N	\N	54304	54304	54305
14348	16624	21	applied	\N	\N	\N	\N	54306	54306	54307
14348	16631	22	applied	\N	\N	\N	\N	54327	54327	54328
14348	16635	23	applied	\N	\N	\N	\N	54341	54341	54342
14348	16639	24	applied	\N	\N	\N	\N	54351	54351	54352
14348	16643	25	applied	\N	\N	\N	\N	54362	54362	54363
14348	16647	26	applied	\N	\N	\N	\N	54372	54372	54373
14348	16650	27	applied	\N	\N	\N	\N	54382	54382	54383
14348	16654	28	applied	\N	\N	\N	\N	54394	54394	54395
14348	16658	29	applied	\N	\N	\N	\N	54402	54402	54403
14348	16662	30	applied	\N	\N	\N	\N	54418	54418	54419
14348	16663	31	applied	\N	\N	\N	\N	54420	54420	54421
14348	16664	32	applied	\N	\N	\N	\N	54422	54422	54423
14348	16674	33	applied	\N	\N	\N	\N	54444	54444	54445
14348	16678	34	applied	\N	\N	\N	\N	54452	54452	54453
14348	16682	35	applied	\N	\N	\N	\N	54462	54462	54463
14348	16686	36	applied	\N	\N	\N	\N	54473	54473	54474
14348	16690	37	applied	\N	\N	\N	\N	54485	54485	54486
14348	16694	38	applied	\N	\N	\N	\N	54501	54501	54502
14348	16695	39	applied	\N	\N	\N	\N	54503	54503	54504
14348	16696	40	applied	\N	\N	\N	\N	54505	54505	54506
14348	16705	41	applied	\N	\N	\N	\N	54534	54534	54535
14348	16708	42	applied	\N	\N	\N	\N	54543	54543	54544
14348	16709	43	applied	\N	\N	\N	\N	54545	54545	54546
14348	16714	44	applied	\N	\N	\N	\N	54615	54615	54616
14348	16717	45	applied	\N	\N	\N	\N	54624	54624	54625
14348	16720	46	applied	\N	\N	\N	\N	54633	54633	54634
14348	16721	47	applied	\N	\N	\N	\N	54635	54635	54636
14348	16726	48	applied	\N	\N	\N	\N	54646	54646	54647
14348	16729	49	applied	\N	\N	\N	\N	54655	54655	54656
14348	16732	50	applied	\N	\N	\N	\N	54663	54663	54664
14348	16735	51	applied	\N	\N	\N	\N	54672	54672	54673
14348	16740	52	applied	\N	\N	\N	\N	54683	54683	54684
14348	16743	53	applied	\N	\N	\N	\N	54694	54694	54695
14348	16746	54	applied	\N	\N	\N	\N	54702	54702	54703
14348	16747	55	applied	\N	\N	\N	\N	54704	54704	54705
14348	16752	56	applied	\N	\N	\N	\N	54716	54716	54717
14348	16753	57	applied	\N	\N	\N	\N	54720	54720	54721
14348	16754	58	applied	\N	\N	\N	\N	54722	54722	54723
14348	16763	59	applied	\N	\N	\N	\N	54741	54741	54742
14348	16767	60	applied	\N	\N	\N	\N	54752	54752	54753
14348	16772	61	applied	\N	\N	\N	\N	54764	54764	54765
14348	16773	62	applied	\N	\N	\N	\N	54766	54766	54767
14348	16780	63	applied	\N	\N	\N	\N	54782	54782	54783
14348	16781	64	applied	\N	\N	\N	\N	54784	54784	54785
14348	16786	65	applied	\N	\N	\N	\N	54806	54806	54807
14348	16790	66	applied	\N	\N	\N	\N	54816	54816	54817
14348	16792	67	applied	\N	\N	\N	\N	54824	54824	54825
14348	16795	68	applied	\N	\N	\N	\N	54832	54832	54833
14348	16799	69	applied	\N	\N	\N	\N	54849	54849	54850
14348	16800	70	applied	\N	\N	\N	\N	54851	54851	54852
14348	16805	71	applied	\N	\N	\N	\N	54862	54862	54863
14348	16809	72	applied	\N	\N	\N	\N	54871	54871	54872
14348	16812	73	applied	\N	\N	\N	\N	54878	54878	54879
14348	16813	75	applied	\N	\N	\N	\N	54880	54880	54881
14348	16820	76	applied	\N	\N	\N	\N	54896	54896	54897
14348	16821	77	applied	\N	\N	\N	\N	54900	54900	54901
14348	16827	78	applied	\N	\N	\N	\N	54914	54914	54990
14348	16828	79	applied	\N	\N	\N	\N	54916	54916	54991
14348	16835	80	applied	\N	\N	\N	\N	54933	54933	55334
14348	16838	81	applied	\N	\N	\N	\N	54941	54941	55335
14348	16842	82	applied	\N	\N	\N	\N	54949	54949	55336
14348	16846	83	applied	\N	\N	\N	\N	54959	54959	55337
14348	16850	84	applied	\N	\N	\N	\N	54970	54970	55338
14348	16854	85	applied	\N	\N	\N	\N	54980	54980	55339
14348	16858	86	applied	\N	\N	\N	\N	54997	54997	55340
14348	16862	87	applied	\N	\N	\N	\N	55008	55008	55341
14348	16866	88	applied	\N	\N	\N	\N	55020	55020	55342
14348	16867	89	applied	\N	\N	\N	\N	55022	55022	55343
14348	16868	90	applied	\N	\N	\N	\N	55024	55024	55344
14348	16877	91	applied	\N	\N	\N	\N	55043	55043	55345
14348	16883	92	applied	\N	\N	\N	\N	55064	55064	55346
14348	16884	93	applied	\N	\N	\N	\N	55066	55066	55347
14348	16889	94	applied	\N	\N	\N	\N	55077	55077	55348
14348	16893	95	applied	\N	\N	\N	\N	55089	55089	55349
14348	16897	96	applied	\N	\N	\N	\N	55099	55099	55350
14348	16901	97	applied	\N	\N	\N	\N	55109	55109	55351
14348	16905	98	applied	\N	\N	\N	\N	55120	55120	55352
14348	16909	99	applied	\N	\N	\N	\N	55132	55132	55353
14340	17199	2	applied	\N	\N	\N	\N	56129	56129	56130
14340	17200	3	applied	\N	\N	\N	\N	56131	56131	56132
14343	17201	0	applied	\N	\N	\N	\N	56137	56137	56138
14343	17202	1	applied	\N	\N	\N	\N	56139	56139	56140
14343	17203	2	applied	\N	\N	\N	\N	56141	56141	56142
14343	17204	3	applied	\N	\N	\N	\N	56143	56143	56144
14343	17205	4	applied	\N	\N	\N	\N	56145	56145	56146
14343	17206	5	applied	\N	\N	\N	\N	56147	56147	56148
14343	17207	6	applied	\N	\N	\N	\N	56149	56149	56150
14345	17208	0	applied	\N	\N	\N	\N	56156	56156	56157
14345	17209	1	applied	\N	\N	\N	\N	56158	56158	56159
14345	17210	2	applied	\N	\N	\N	\N	56160	56160	56161
14345	17211	3	applied	\N	\N	\N	\N	56162	56162	56163
14345	17212	4	applied	\N	\N	\N	\N	56164	56164	56165
14345	17213	5	applied	\N	\N	\N	\N	56166	56166	56167
14345	17214	6	applied	\N	\N	\N	\N	56168	56168	56169
14345	17215	7	applied	\N	\N	\N	\N	56170	56170	56171
14347	17216	0	applied	\N	\N	\N	\N	56175	56175	56176
14347	17217	1	applied	\N	\N	\N	\N	56177	56177	56178
14347	17218	2	applied	\N	\N	\N	\N	56179	56179	56180
14347	17219	3	applied	\N	\N	\N	\N	56181	56181	56182
14350	17223	0	applied	\N	\N	\N	\N	56195	56195	56196
14350	17224	1	applied	\N	\N	\N	\N	56197	56197	56198
14350	17225	2	applied	\N	\N	\N	\N	56199	56199	56200
14350	17226	3	applied	\N	\N	\N	\N	56201	56201	56202
14350	17227	4	applied	\N	\N	\N	\N	56203	56203	56204
14350	17228	5	applied	\N	\N	\N	\N	56205	56205	56206
14350	17229	6	applied	\N	\N	\N	\N	56207	56207	56208
14352	17230	0	applied	\N	\N	\N	\N	56212	56212	56213
14352	17231	1	applied	\N	\N	\N	\N	56214	56214	56215
14352	17232	2	applied	\N	\N	\N	\N	56216	56216	56217
14352	17233	3	applied	\N	\N	\N	\N	56218	56218	56219
14357	17240	0	applied	\N	\N	\N	\N	56254	56254	56239
14357	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14357	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14357	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14357	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14357	17072	5	applied	\N	\N	1000000000	\N	55634	55634	55635
14360	17247	0	applied	\N	\N	\N	\N	56257	56257	56258
14360	17248	1	applied	\N	\N	\N	\N	56259	56259	56260
14360	17249	2	applied	\N	\N	\N	\N	56261	56261	56262
14360	17250	3	applied	\N	\N	\N	\N	56263	56263	56264
14370	17258	0	applied	\N	\N	\N	\N	56342	56342	56343
14370	17259	1	applied	\N	\N	\N	\N	56344	56344	56345
14370	17260	2	applied	\N	\N	\N	\N	56346	56346	56347
14384	17285	0	applied	\N	\N	\N	\N	56420	56420	56421
14384	17286	1	applied	\N	\N	\N	\N	56422	56422	56423
14384	17287	2	applied	\N	\N	\N	\N	56424	56424	56425
14384	17288	3	applied	\N	\N	\N	\N	56426	56426	56427
14384	17289	4	applied	\N	\N	\N	\N	56428	56428	56429
14384	17290	5	applied	\N	\N	\N	\N	56430	56430	56431
14386	17291	0	applied	\N	\N	\N	\N	56436	56436	56437
14386	17292	1	applied	\N	\N	\N	\N	56438	56438	56439
14386	17293	2	applied	\N	\N	\N	\N	56440	56440	56441
14394	17314	0	applied	\N	\N	\N	\N	56497	56497	56498
14394	17315	1	applied	\N	\N	\N	\N	56499	56499	56500
14394	17316	2	applied	\N	\N	\N	\N	56501	56501	56502
14400	17320	0	applied	\N	\N	\N	\N	56512	56512	56513
14400	17321	1	applied	\N	\N	\N	\N	56514	56514	56515
14400	17322	2	applied	\N	\N	\N	\N	56517	56517	56518
14401	17323	0	applied	\N	\N	\N	\N	56525	56525	56526
14401	17324	1	applied	\N	\N	\N	\N	56527	56527	56528
14401	17325	2	applied	\N	\N	\N	\N	56529	56529	56530
14404	17240	0	applied	\N	\N	\N	\N	56254	56254	56239
14404	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14404	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14404	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14404	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14404	17072	5	applied	\N	\N	1000000000	\N	55634	55634	55635
14406	17330	0	applied	\N	\N	\N	\N	56545	56545	56546
14406	17331	1	applied	\N	\N	\N	\N	56547	56547	56548
14409	17330	0	applied	\N	\N	\N	\N	56545	56545	56546
14409	17331	1	applied	\N	\N	\N	\N	56547	56547	56548
14414	17344	0	applied	\N	\N	\N	\N	56585	56585	56586
14414	17345	1	applied	\N	\N	\N	\N	56587	56587	56588
14414	17346	2	applied	\N	\N	\N	\N	56589	56589	56589
14414	17350	3	applied	\N	\N	\N	\N	56598	56598	56599
14414	17348	4	applied	\N	\N	\N	\N	56600	56600	56595
14414	17351	5	applied	\N	\N	\N	\N	56601	56601	56602
14414	17352	6	applied	\N	\N	\N	\N	56603	56603	56604
14414	17353	7	applied	\N	\N	\N	\N	56605	56605	56606
14414	17354	8	applied	\N	\N	\N	\N	56607	56607	56608
14414	17355	9	applied	\N	\N	\N	\N	56609	56609	56610
14414	17356	10	applied	\N	\N	\N	\N	56611	56611	56612
14414	17357	11	applied	\N	\N	\N	\N	56613	56613	56614
14414	17358	12	applied	\N	\N	\N	\N	56615	56615	56616
14416	17362	0	applied	\N	\N	\N	\N	56637	56637	56638
14416	17363	1	applied	\N	\N	\N	\N	56639	56639	56640
14416	17364	2	applied	\N	\N	\N	\N	56641	56641	56642
14420	17365	0	applied	\N	\N	\N	\N	56648	56648	56649
14425	17327	0	applied	\N	\N	\N	\N	56535	56535	33908
14425	17346	1	applied	\N	\N	\N	\N	56589	56589	56589
14430	16647	0	applied	\N	\N	\N	\N	54372	54372	54373
14430	16650	1	applied	\N	\N	\N	\N	54382	54382	54383
14430	16654	2	applied	\N	\N	\N	\N	54394	54394	54395
14430	16658	3	applied	\N	\N	\N	\N	54402	54402	54403
14430	16662	4	applied	\N	\N	\N	\N	54418	54418	54419
14430	16663	5	applied	\N	\N	\N	\N	54420	54420	54421
14430	16664	6	applied	\N	\N	\N	\N	54422	54422	54423
14430	16674	7	applied	\N	\N	\N	\N	54444	54444	54445
14430	16678	8	applied	\N	\N	\N	\N	54452	54452	54453
14430	16682	9	applied	\N	\N	\N	\N	54462	54462	54463
14430	16686	10	applied	\N	\N	\N	\N	54473	54473	54474
14430	16690	11	applied	\N	\N	\N	\N	54485	54485	54486
14430	16694	12	applied	\N	\N	\N	\N	54501	54501	54502
14430	16695	13	applied	\N	\N	\N	\N	54503	54503	54504
14430	16696	14	applied	\N	\N	\N	\N	54505	54505	54506
14430	16705	15	applied	\N	\N	\N	\N	54534	54534	54535
14430	16708	16	applied	\N	\N	\N	\N	54543	54543	54544
14430	16709	17	applied	\N	\N	\N	\N	54545	54545	54546
14430	16714	18	applied	\N	\N	\N	\N	54615	54615	54616
14430	16717	19	applied	\N	\N	\N	\N	54624	54624	54625
14430	16720	20	applied	\N	\N	\N	\N	54633	54633	54634
14430	16721	21	applied	\N	\N	\N	\N	54635	54635	54636
14430	16726	22	applied	\N	\N	\N	\N	54646	54646	54647
14430	16729	23	applied	\N	\N	\N	\N	54655	54655	54656
14430	16732	24	applied	\N	\N	\N	\N	54663	54663	54664
14430	16735	25	applied	\N	\N	\N	\N	54672	54672	54673
14430	16740	26	applied	\N	\N	\N	\N	54683	54683	54684
14342	17205	4	applied	\N	\N	\N	\N	56145	56145	56146
14342	17206	5	applied	\N	\N	\N	\N	56147	56147	56148
14342	17207	6	applied	\N	\N	\N	\N	56149	56149	56150
14349	17220	0	applied	\N	\N	\N	\N	56187	56187	56188
14349	17221	1	applied	\N	\N	\N	\N	56189	56189	56190
14349	17222	2	applied	\N	\N	\N	\N	56191	56191	56192
14359	17247	0	applied	\N	\N	\N	\N	56257	56257	56258
14359	17248	1	applied	\N	\N	\N	\N	56259	56259	56260
14359	17249	2	applied	\N	\N	\N	\N	56261	56261	56262
14359	17250	3	applied	\N	\N	\N	\N	56263	56263	56264
14363	17247	0	applied	\N	\N	\N	\N	56257	56257	56258
14363	17248	1	applied	\N	\N	\N	\N	56259	56259	56260
14363	17249	2	applied	\N	\N	\N	\N	56261	56261	56262
14363	17250	3	applied	\N	\N	\N	\N	56263	56263	56264
14368	17255	0	applied	\N	\N	\N	\N	56331	56331	56332
14368	17256	1	applied	\N	\N	\N	\N	56333	56333	56334
14368	17257	2	applied	\N	\N	\N	\N	56335	56335	56336
14376	16708	0	applied	\N	\N	\N	\N	54543	54543	54544
14376	17240	1	applied	\N	\N	\N	\N	56254	56254	56239
14376	17018	2	applied	\N	\N	\N	\N	55480	55480	55481
14376	17019	3	applied	\N	\N	\N	\N	55482	55482	55483
14376	17020	4	applied	\N	\N	\N	\N	55484	55484	55485
14376	17021	5	applied	\N	\N	\N	\N	55486	55486	55487
14376	16709	6	applied	\N	\N	\N	\N	54545	54545	54546
14376	16714	7	applied	\N	\N	\N	\N	54615	54615	54616
14376	16717	8	applied	\N	\N	\N	\N	54624	54624	54625
14376	16720	9	applied	\N	\N	\N	\N	54633	54633	54634
14376	16721	10	applied	\N	\N	\N	\N	54635	54635	54636
14376	16726	11	applied	\N	\N	\N	\N	54646	54646	54647
14376	16729	12	applied	\N	\N	\N	\N	54655	54655	54656
14376	16732	13	applied	\N	\N	\N	\N	54663	54663	54664
14376	16735	14	applied	\N	\N	\N	\N	54672	54672	54673
14376	16740	15	applied	\N	\N	\N	\N	54683	54683	54684
14376	16743	16	applied	\N	\N	\N	\N	54694	54694	54695
14376	16746	17	applied	\N	\N	\N	\N	54702	54702	54703
14376	16747	18	applied	\N	\N	\N	\N	54704	54704	54705
14376	16752	19	applied	\N	\N	\N	\N	54716	54716	54717
14376	16753	20	applied	\N	\N	\N	\N	54720	54720	54721
14376	16754	21	applied	\N	\N	\N	\N	54722	54722	54723
14376	16763	22	applied	\N	\N	\N	\N	54741	54741	54742
14376	16767	23	applied	\N	\N	\N	\N	54752	54752	54753
14376	16772	24	applied	\N	\N	\N	\N	54764	54764	54765
14376	16773	25	applied	\N	\N	\N	\N	54766	54766	54767
14376	16780	26	applied	\N	\N	\N	\N	54782	54782	54783
14376	16781	27	applied	\N	\N	\N	\N	54784	54784	54785
14376	16786	28	applied	\N	\N	\N	\N	54806	54806	54807
14376	16790	29	applied	\N	\N	\N	\N	54816	54816	54817
14376	16792	30	applied	\N	\N	\N	\N	54824	54824	54825
14376	16795	31	applied	\N	\N	\N	\N	54832	54832	54833
14376	16799	32	applied	\N	\N	\N	\N	54849	54849	54850
14376	16800	33	applied	\N	\N	\N	\N	54851	54851	54852
14376	16805	34	applied	\N	\N	\N	\N	54862	54862	54863
14376	16809	35	applied	\N	\N	\N	\N	54871	54871	54872
14376	16812	36	applied	\N	\N	\N	\N	54878	54878	54879
14376	16813	37	applied	\N	\N	\N	\N	54880	54880	54881
14376	16820	38	applied	\N	\N	\N	\N	54896	54896	54897
14376	16821	39	applied	\N	\N	\N	\N	54900	54900	54901
14376	16827	40	applied	\N	\N	\N	\N	54914	54914	54990
14376	16828	41	applied	\N	\N	\N	\N	54916	54916	54991
14376	16835	42	applied	\N	\N	\N	\N	54933	54933	55334
14376	16838	43	applied	\N	\N	\N	\N	54941	54941	55335
14376	16842	44	applied	\N	\N	\N	\N	54949	54949	55336
14376	16846	45	applied	\N	\N	\N	\N	54959	54959	55337
14376	16850	46	applied	\N	\N	\N	\N	54970	54970	55338
14376	16854	47	applied	\N	\N	\N	\N	54980	54980	55339
14376	16858	48	applied	\N	\N	\N	\N	54997	54997	55340
14376	16862	49	applied	\N	\N	\N	\N	55008	55008	55341
14376	16866	50	applied	\N	\N	\N	\N	55020	55020	55342
14376	16867	51	applied	\N	\N	\N	\N	55022	55022	55343
14376	16868	52	applied	\N	\N	\N	\N	55024	55024	55344
14376	16877	53	applied	\N	\N	\N	\N	55043	55043	55345
14376	16883	54	applied	\N	\N	\N	\N	55064	55064	55346
14376	16884	55	applied	\N	\N	\N	\N	55066	55066	55347
14376	16889	56	applied	\N	\N	\N	\N	55077	55077	55348
14376	16893	57	applied	\N	\N	\N	\N	55089	55089	55349
14376	16897	58	applied	\N	\N	\N	\N	55099	55099	55350
14376	16901	59	applied	\N	\N	\N	\N	55109	55109	55351
14376	16905	60	applied	\N	\N	\N	\N	55120	55120	55352
14376	16909	61	applied	\N	\N	\N	\N	55132	55132	55353
14376	16913	62	applied	\N	\N	\N	\N	55143	55143	55354
14376	16920	63	applied	\N	\N	\N	\N	55163	55163	55355
14376	16921	64	applied	\N	\N	\N	\N	55165	55165	55356
14376	16928	65	applied	\N	\N	\N	\N	55180	55180	55357
14376	16932	66	applied	\N	\N	\N	\N	55192	55192	55358
14376	16936	67	applied	\N	\N	\N	\N	55202	55202	55359
14376	16939	68	applied	\N	\N	\N	\N	55212	55212	55360
14376	16940	69	applied	\N	\N	\N	\N	55214	55214	55361
14376	16947	70	applied	\N	\N	\N	\N	55230	55230	55362
14376	16951	71	applied	\N	\N	\N	\N	55238	55238	55363
14376	16955	72	applied	\N	\N	\N	\N	55248	55248	55364
14376	16958	73	applied	\N	\N	\N	\N	55255	55255	55365
14376	16959	74	applied	\N	\N	\N	\N	55257	55257	55366
14376	16966	75	applied	\N	\N	\N	\N	55278	55278	55367
14376	16970	76	applied	\N	\N	\N	\N	55289	55289	55368
14376	16974	77	applied	\N	\N	\N	\N	55303	55303	55369
14376	16978	78	applied	\N	\N	\N	\N	55314	55314	55370
14376	16982	79	applied	\N	\N	\N	\N	55325	55325	55536
14376	16987	80	applied	\N	\N	\N	\N	55403	55403	55537
14376	16991	81	applied	\N	\N	\N	\N	55415	55415	55538
14376	16992	82	applied	\N	\N	\N	\N	55417	55417	55539
14376	16993	83	applied	\N	\N	\N	\N	55419	55419	55540
14376	17003	84	applied	\N	\N	\N	\N	55442	55442	55541
14376	17007	85	applied	\N	\N	\N	\N	55453	55453	55542
14376	17008	86	applied	\N	\N	\N	\N	55455	55455	55543
14376	17015	87	applied	\N	\N	\N	\N	55473	55473	55544
14376	17022	88	applied	\N	\N	\N	\N	55488	55488	55545
14376	17023	89	applied	\N	\N	\N	\N	55490	55490	55546
14376	17030	90	applied	\N	\N	\N	\N	55508	55508	55547
14376	17034	91	applied	\N	\N	\N	\N	55517	55517	55548
14376	17035	92	applied	\N	\N	\N	\N	55519	55519	55549
14376	17042	93	applied	\N	\N	\N	\N	55552	55552	55703
14376	17043	94	applied	\N	\N	\N	\N	55554	55554	55704
14376	17050	95	applied	\N	\N	\N	\N	55569	55569	55705
14376	17056	96	applied	\N	\N	\N	\N	55588	55588	55706
14376	17057	97	applied	\N	\N	\N	\N	55590	55590	55707
14376	17061	98	applied	\N	\N	\N	\N	55602	55602	55708
14376	17067	99	applied	\N	\N	\N	\N	55624	55624	55709
14376	17068	100	applied	\N	\N	\N	\N	55626	55626	55710
14376	17076	101	applied	\N	\N	\N	\N	55644	55644	55711
14376	17080	102	applied	\N	\N	\N	\N	55654	55654	55712
14348	16913	100	applied	\N	\N	\N	\N	55143	55143	55354
14348	16920	101	applied	\N	\N	\N	\N	55163	55163	55355
14348	16921	102	applied	\N	\N	\N	\N	55165	55165	55356
14348	16928	103	applied	\N	\N	\N	\N	55180	55180	55357
14348	16932	104	applied	\N	\N	\N	\N	55192	55192	55358
14348	16936	105	applied	\N	\N	\N	\N	55202	55202	55359
14348	16939	106	applied	\N	\N	\N	\N	55212	55212	55360
14348	16940	107	applied	\N	\N	\N	\N	55214	55214	55361
14348	16947	108	applied	\N	\N	\N	\N	55230	55230	55362
14348	16951	109	applied	\N	\N	\N	\N	55238	55238	55363
14348	16955	110	applied	\N	\N	\N	\N	55248	55248	55364
14348	16958	111	applied	\N	\N	\N	\N	55255	55255	55365
14348	16959	112	applied	\N	\N	\N	\N	55257	55257	55366
14348	16966	113	applied	\N	\N	\N	\N	55278	55278	55367
14348	16970	114	applied	\N	\N	\N	\N	55289	55289	55368
14348	16974	115	applied	\N	\N	\N	\N	55303	55303	55369
14348	16978	116	applied	\N	\N	\N	\N	55314	55314	55370
14348	16982	117	applied	\N	\N	\N	\N	55325	55325	55536
14348	16987	118	applied	\N	\N	\N	\N	55403	55403	55537
14348	16991	119	applied	\N	\N	\N	\N	55415	55415	55538
14348	16992	120	applied	\N	\N	\N	\N	55417	55417	55539
14348	16993	121	applied	\N	\N	\N	\N	55419	55419	55540
14348	17003	122	applied	\N	\N	\N	\N	55442	55442	55541
14348	17007	123	applied	\N	\N	\N	\N	55453	55453	55542
14348	17008	124	applied	\N	\N	\N	\N	55455	55455	55543
14348	17015	125	applied	\N	\N	\N	\N	55473	55473	55544
14351	17223	0	applied	\N	\N	\N	\N	56195	56195	56196
14351	17224	1	applied	\N	\N	\N	\N	56197	56197	56198
14351	17225	2	applied	\N	\N	\N	\N	56199	56199	56200
14351	17226	3	applied	\N	\N	\N	\N	56201	56201	56202
14351	17227	4	applied	\N	\N	\N	\N	56203	56203	56204
14351	17228	5	applied	\N	\N	\N	\N	56205	56205	56206
14351	17229	6	applied	\N	\N	\N	\N	56207	56207	56208
14353	17234	0	applied	\N	\N	\N	\N	56222	56222	56223
14353	17235	1	applied	\N	\N	\N	\N	56224	56224	56225
14353	17236	2	applied	\N	\N	\N	\N	56226	56226	56227
14353	17237	3	applied	\N	\N	\N	\N	56228	56228	56229
14355	17238	0	applied	\N	\N	\N	\N	56232	56232	56233
14361	17247	0	applied	\N	\N	\N	\N	56257	56257	56258
14361	17248	1	applied	\N	\N	\N	\N	56259	56259	56260
14361	17249	2	applied	\N	\N	\N	\N	56261	56261	56262
14361	17250	3	applied	\N	\N	\N	\N	56263	56263	56264
14364	17240	0	applied	\N	\N	\N	\N	56316	56316	56239
14364	17022	1	applied	\N	\N	\N	\N	55488	55488	55545
14364	17023	2	applied	\N	\N	\N	\N	55490	55490	55546
14364	17030	3	applied	\N	\N	\N	\N	55508	55508	55547
14364	17034	4	applied	\N	\N	\N	\N	55517	55517	55548
14364	17035	5	applied	\N	\N	\N	\N	55519	55519	55549
14364	17042	6	applied	\N	\N	\N	\N	55552	55552	55703
14364	17043	7	applied	\N	\N	\N	\N	55554	55554	55704
14364	17050	8	applied	\N	\N	\N	\N	55569	55569	55705
14364	17056	9	applied	\N	\N	\N	\N	55588	55588	55706
14364	17057	10	applied	\N	\N	\N	\N	55590	55590	55707
14364	17061	11	applied	\N	\N	\N	\N	55602	55602	55708
14364	17067	12	applied	\N	\N	\N	\N	55624	55624	55709
14364	17068	13	applied	\N	\N	\N	\N	55626	55626	55710
14364	17076	14	applied	\N	\N	\N	\N	55644	55644	55711
14364	17080	15	applied	\N	\N	\N	\N	55654	55654	55712
14364	17081	16	applied	\N	\N	\N	\N	55656	55656	55713
14364	17088	17	applied	\N	\N	\N	\N	55674	55674	55714
14364	17089	18	applied	\N	\N	\N	\N	55676	55676	55715
14364	17090	19	applied	\N	\N	\N	\N	55678	55678	55716
14364	17100	20	applied	\N	\N	\N	\N	55882	55882	56274
14364	17101	21	applied	\N	\N	\N	\N	55884	55884	56275
14364	17107	22	applied	\N	\N	\N	\N	55899	55899	56276
14364	17108	23	applied	\N	\N	\N	\N	55901	55901	56277
14364	17114	24	applied	\N	\N	\N	\N	55916	55916	56278
14364	17117	25	applied	\N	\N	\N	\N	55924	55924	56279
14364	17121	26	applied	\N	\N	\N	\N	55936	55936	56280
14364	17124	27	applied	\N	\N	\N	\N	55947	55947	56281
14364	17127	28	applied	\N	\N	\N	\N	55959	55959	56282
14364	17131	29	applied	\N	\N	\N	\N	55969	55969	56283
14364	17132	30	applied	\N	\N	\N	\N	55971	55971	56284
14364	17138	31	applied	\N	\N	\N	\N	55984	55984	56285
14364	17142	32	applied	\N	\N	\N	\N	55995	55995	56286
14364	17146	33	applied	\N	\N	\N	\N	56004	56004	56287
14364	17150	34	applied	\N	\N	\N	\N	56014	56014	56288
14364	17154	35	applied	\N	\N	\N	\N	56024	56024	56289
14364	17157	36	applied	\N	\N	\N	\N	56033	56033	56290
14364	17161	37	applied	\N	\N	\N	\N	56044	56044	56291
14364	17162	38	applied	\N	\N	\N	\N	56046	56046	56292
14364	17169	39	applied	\N	\N	\N	\N	56061	56061	56293
14364	17173	40	applied	\N	\N	\N	\N	56069	56069	56294
14364	17174	41	applied	\N	\N	\N	\N	56071	56071	56295
14364	17181	42	applied	\N	\N	\N	\N	56086	56086	56296
14364	17185	43	applied	\N	\N	\N	\N	56096	56096	56297
14364	17189	44	applied	\N	\N	\N	\N	56107	56107	56298
14364	17190	45	applied	\N	\N	\N	\N	56109	56109	56299
14364	17197	46	applied	\N	\N	\N	\N	56125	56125	56300
14364	17201	47	applied	\N	\N	\N	\N	56137	56137	56301
14364	17208	48	applied	\N	\N	\N	\N	56156	56156	56302
14364	17209	49	applied	\N	\N	\N	\N	56158	56158	56303
14364	17216	50	applied	\N	\N	\N	\N	56175	56175	56304
14364	17220	51	applied	\N	\N	\N	\N	56187	56187	56305
14364	17223	52	applied	\N	\N	\N	\N	56195	56195	56306
14364	17224	53	applied	\N	\N	\N	\N	56197	56197	56307
14364	17230	54	applied	\N	\N	\N	\N	56212	56212	56308
14364	17234	55	applied	\N	\N	\N	\N	56222	56222	56309
14364	17238	56	applied	\N	\N	\N	\N	56232	56232	56310
14364	17239	57	applied	\N	\N	\N	\N	56236	56236	56311
14364	17247	58	applied	\N	\N	\N	\N	56257	56257	56312
14364	17251	59	applied	\N	\N	\N	\N	56317	56317	56318
14364	16556	60	applied	\N	\N	\N	\N	54125	54125	54126
14364	16636	61	applied	\N	\N	\N	\N	54343	54343	25661
14364	16586	62	applied	\N	\N	\N	\N	54206	54206	1254
14364	16568	63	applied	\N	\N	\N	\N	54160	54160	25661
14364	17072	64	applied	\N	\N	1000000000	\N	55634	55634	55635
14364	16557	65	applied	\N	\N	\N	\N	54127	54127	54128
14364	16558	66	applied	\N	\N	\N	\N	54129	54129	54130
14364	16559	67	applied	\N	\N	\N	\N	54131	54131	54132
14364	16560	68	applied	\N	\N	\N	\N	54133	54133	54134
14364	16561	69	applied	\N	\N	\N	\N	54135	54135	54136
14364	16564	70	applied	\N	\N	\N	\N	54144	54144	54145
14364	16565	71	applied	\N	\N	\N	\N	54146	54146	54147
14364	16566	72	applied	\N	\N	\N	\N	54148	54148	54149
14364	16569	73	applied	\N	\N	\N	\N	54161	54161	54162
14364	16570	75	applied	\N	\N	\N	\N	54163	54163	54164
14364	16571	76	applied	\N	\N	\N	\N	54165	54165	54166
14364	16574	77	applied	\N	\N	\N	\N	54175	54175	54176
14364	16575	78	applied	\N	\N	\N	\N	54177	54177	54178
14362	16858	28	applied	\N	\N	\N	\N	54997	54997	55340
14362	16862	29	applied	\N	\N	\N	\N	55008	55008	55341
14362	16866	30	applied	\N	\N	\N	\N	55020	55020	55342
14362	16867	31	applied	\N	\N	\N	\N	55022	55022	55343
14362	16868	32	applied	\N	\N	\N	\N	55024	55024	55344
14362	16877	33	applied	\N	\N	\N	\N	55043	55043	55345
14362	16883	34	applied	\N	\N	\N	\N	55064	55064	55346
14362	16884	35	applied	\N	\N	\N	\N	55066	55066	55347
14362	16889	36	applied	\N	\N	\N	\N	55077	55077	55348
14362	16893	37	applied	\N	\N	\N	\N	55089	55089	55349
14362	16897	38	applied	\N	\N	\N	\N	55099	55099	55350
14362	16901	39	applied	\N	\N	\N	\N	55109	55109	55351
14362	16905	40	applied	\N	\N	\N	\N	55120	55120	55352
14362	16909	41	applied	\N	\N	\N	\N	55132	55132	55353
14362	16913	42	applied	\N	\N	\N	\N	55143	55143	55354
14362	16920	43	applied	\N	\N	\N	\N	55163	55163	55355
14362	16921	44	applied	\N	\N	\N	\N	55165	55165	55356
14362	16928	45	applied	\N	\N	\N	\N	55180	55180	55357
14362	16932	46	applied	\N	\N	\N	\N	55192	55192	55358
14362	16936	47	applied	\N	\N	\N	\N	55202	55202	55359
14362	16939	48	applied	\N	\N	\N	\N	55212	55212	55360
14362	16940	49	applied	\N	\N	\N	\N	55214	55214	55361
14362	16947	50	applied	\N	\N	\N	\N	55230	55230	55362
14362	16951	51	applied	\N	\N	\N	\N	55238	55238	55363
14362	16955	52	applied	\N	\N	\N	\N	55248	55248	55364
14362	16958	53	applied	\N	\N	\N	\N	55255	55255	55365
14362	16959	54	applied	\N	\N	\N	\N	55257	55257	55366
14362	16966	55	applied	\N	\N	\N	\N	55278	55278	55367
14362	16970	56	applied	\N	\N	\N	\N	55289	55289	55368
14362	16974	57	applied	\N	\N	\N	\N	55303	55303	55369
14362	16978	58	applied	\N	\N	\N	\N	55314	55314	55370
14362	16982	59	applied	\N	\N	\N	\N	55325	55325	55536
14362	16987	60	applied	\N	\N	\N	\N	55403	55403	55537
14362	16991	61	applied	\N	\N	\N	\N	55415	55415	55538
14362	16992	62	applied	\N	\N	\N	\N	55417	55417	55539
14362	16993	63	applied	\N	\N	\N	\N	55419	55419	55540
14362	17003	64	applied	\N	\N	\N	\N	55442	55442	55541
14362	17007	65	applied	\N	\N	\N	\N	55453	55453	55542
14362	17008	66	applied	\N	\N	\N	\N	55455	55455	55543
14362	17015	67	applied	\N	\N	\N	\N	55473	55473	55544
14362	17022	68	applied	\N	\N	\N	\N	55488	55488	55545
14362	17023	69	applied	\N	\N	\N	\N	55490	55490	55546
14362	17030	70	applied	\N	\N	\N	\N	55508	55508	55547
14362	17034	71	applied	\N	\N	\N	\N	55517	55517	55548
14362	17035	72	applied	\N	\N	\N	\N	55519	55519	55549
14362	17042	73	applied	\N	\N	\N	\N	55552	55552	55703
14362	17043	74	applied	\N	\N	\N	\N	55554	55554	55704
14362	17050	75	applied	\N	\N	\N	\N	55569	55569	55705
14362	17056	76	applied	\N	\N	\N	\N	55588	55588	55706
14362	17057	77	applied	\N	\N	\N	\N	55590	55590	55707
14362	17061	78	applied	\N	\N	\N	\N	55602	55602	55708
14362	17067	79	applied	\N	\N	\N	\N	55624	55624	55709
14362	17068	80	applied	\N	\N	\N	\N	55626	55626	55710
14362	17076	81	applied	\N	\N	\N	\N	55644	55644	55711
14362	17080	82	applied	\N	\N	\N	\N	55654	55654	55712
14362	17081	83	applied	\N	\N	\N	\N	55656	55656	55713
14362	17088	84	applied	\N	\N	\N	\N	55674	55674	55714
14362	17089	85	applied	\N	\N	\N	\N	55676	55676	55715
14362	17090	86	applied	\N	\N	\N	\N	55678	55678	55716
14362	17100	87	applied	\N	\N	\N	\N	55882	55882	56274
14362	17101	88	applied	\N	\N	\N	\N	55884	55884	56275
14362	17107	89	applied	\N	\N	\N	\N	55899	55899	56276
14362	17108	90	applied	\N	\N	\N	\N	55901	55901	56277
14362	17114	91	applied	\N	\N	\N	\N	55916	55916	56278
14362	17117	92	applied	\N	\N	\N	\N	55924	55924	56279
14362	17121	93	applied	\N	\N	\N	\N	55936	55936	56280
14362	17124	94	applied	\N	\N	\N	\N	55947	55947	56281
14362	17127	95	applied	\N	\N	\N	\N	55959	55959	56282
14362	17131	96	applied	\N	\N	\N	\N	55969	55969	56283
14362	17132	97	applied	\N	\N	\N	\N	55971	55971	56284
14362	17138	98	applied	\N	\N	\N	\N	55984	55984	56285
14362	17142	99	applied	\N	\N	\N	\N	55995	55995	56286
14362	17146	100	applied	\N	\N	\N	\N	56004	56004	56287
14362	17150	101	applied	\N	\N	\N	\N	56014	56014	56288
14362	17154	102	applied	\N	\N	\N	\N	56024	56024	56289
14362	17157	103	applied	\N	\N	\N	\N	56033	56033	56290
14362	17161	104	applied	\N	\N	\N	\N	56044	56044	56291
14362	17162	105	applied	\N	\N	\N	\N	56046	56046	56292
14362	17169	106	applied	\N	\N	\N	\N	56061	56061	56293
14362	17173	107	applied	\N	\N	\N	\N	56069	56069	56294
14362	17174	108	applied	\N	\N	\N	\N	56071	56071	56295
14362	17181	109	applied	\N	\N	\N	\N	56086	56086	56296
14362	17185	110	applied	\N	\N	\N	\N	56096	56096	56297
14362	17189	111	applied	\N	\N	\N	\N	56107	56107	56298
14362	17190	112	applied	\N	\N	\N	\N	56109	56109	56299
14362	17197	113	applied	\N	\N	\N	\N	56125	56125	56300
14362	17201	114	applied	\N	\N	\N	\N	56137	56137	56301
14362	17208	115	applied	\N	\N	\N	\N	56156	56156	56302
14362	17209	116	applied	\N	\N	\N	\N	56158	56158	56303
14362	17216	117	applied	\N	\N	\N	\N	56175	56175	56304
14362	17220	118	applied	\N	\N	\N	\N	56187	56187	56305
14362	17223	119	applied	\N	\N	\N	\N	56195	56195	56306
14362	17224	120	applied	\N	\N	\N	\N	56197	56197	56307
14362	17230	121	applied	\N	\N	\N	\N	56212	56212	56308
14362	17234	122	applied	\N	\N	\N	\N	56222	56222	56309
14362	17238	123	applied	\N	\N	\N	\N	56232	56232	56310
14362	17239	124	applied	\N	\N	\N	\N	56236	56236	56311
14362	17247	125	applied	\N	\N	\N	\N	56257	56257	56312
14365	17251	0	applied	\N	\N	\N	\N	56317	56317	56322
14365	17252	1	applied	\N	\N	\N	\N	56323	56323	56324
14365	17253	2	applied	\N	\N	\N	\N	56325	56325	56326
14365	17254	3	applied	\N	\N	1000000000	\N	56327	56327	56328
14367	17255	0	applied	\N	\N	\N	\N	56331	56331	56332
14367	17256	1	applied	\N	\N	\N	\N	56333	56333	56334
14367	17257	2	applied	\N	\N	\N	\N	56335	56335	56336
14371	17258	0	applied	\N	\N	\N	\N	56342	56342	56343
14371	17259	1	applied	\N	\N	\N	\N	56344	56344	56345
14371	17260	2	applied	\N	\N	\N	\N	56346	56346	56347
14374	17261	0	applied	\N	\N	\N	\N	56353	56353	56354
14374	17262	1	applied	\N	\N	\N	\N	56355	56355	56356
14374	17263	2	applied	\N	\N	\N	\N	56357	56357	56358
14380	17267	0	applied	\N	\N	\N	\N	56376	56376	56377
14382	17276	0	applied	\N	\N	\N	\N	56398	56398	56399
14382	17277	1	applied	\N	\N	\N	\N	56400	56400	56401
14382	17278	2	applied	\N	\N	\N	\N	56402	56402	56403
14382	17279	3	applied	\N	\N	\N	\N	56404	56404	56405
14382	17280	4	applied	\N	\N	\N	\N	56406	56406	56407
14382	17281	5	applied	\N	\N	\N	\N	56408	56408	56409
14385	17285	0	applied	\N	\N	\N	\N	56420	56420	56421
14385	17286	1	applied	\N	\N	\N	\N	56422	56422	56423
14364	16576	79	applied	\N	\N	\N	\N	54179	54179	54180
14364	16577	80	applied	\N	\N	\N	\N	54181	54181	54182
14364	16578	81	applied	\N	\N	\N	\N	54183	54183	54184
14364	16579	82	applied	\N	\N	\N	\N	54185	54185	54186
14364	16581	83	applied	\N	\N	\N	\N	54191	54191	54192
14364	16582	84	applied	\N	\N	\N	\N	54193	54193	54194
14364	16583	85	applied	\N	\N	\N	\N	54195	54195	54196
14364	16585	86	applied	\N	\N	\N	\N	54204	54204	54205
14364	16587	87	applied	\N	\N	\N	\N	54207	54207	54208
14364	16588	88	applied	\N	\N	\N	\N	54209	54209	54210
14364	16589	89	applied	\N	\N	\N	\N	54211	54211	54212
14364	16590	90	applied	\N	\N	\N	\N	54213	54213	54214
14364	16591	91	applied	\N	\N	\N	\N	54215	54215	54216
14364	16593	92	applied	\N	\N	\N	\N	54222	54222	54223
14364	16594	93	applied	\N	\N	\N	\N	54224	54224	54225
14364	16595	94	applied	\N	\N	\N	\N	54226	54226	54227
14364	16597	95	applied	\N	\N	\N	\N	54234	54234	54235
14364	16598	96	applied	\N	\N	\N	\N	54236	54236	54237
14364	16599	97	applied	\N	\N	\N	\N	54238	54238	54239
14364	16601	98	applied	\N	\N	\N	\N	54244	54244	54245
14364	16602	99	applied	\N	\N	\N	\N	54246	54246	54247
14364	16603	100	applied	\N	\N	\N	\N	54248	54248	54249
14364	16605	101	applied	\N	\N	\N	\N	54259	54259	54260
14364	16606	102	applied	\N	\N	\N	\N	54261	54261	54262
14364	16607	103	applied	\N	\N	\N	\N	54263	54263	54264
14364	16610	104	applied	\N	\N	\N	\N	54272	54272	54273
14364	16611	105	applied	\N	\N	\N	\N	54274	54274	54275
14364	16612	106	applied	\N	\N	\N	\N	54276	54276	54277
14364	16613	107	applied	\N	\N	\N	\N	54278	54278	54279
14364	16614	108	applied	\N	\N	\N	\N	54280	54280	54281
14364	16615	109	applied	\N	\N	\N	\N	54282	54282	54283
14364	16617	110	applied	\N	\N	\N	\N	54289	54289	54290
14364	16618	111	applied	\N	\N	1000000000	\N	54291	54291	54292
14364	16619	112	applied	\N	\N	1000000000	\N	54293	54293	54294
14364	16620	113	applied	\N	\N	\N	\N	54295	54295	54296
14364	16621	114	applied	\N	\N	\N	\N	54297	54297	54298
14364	16622	115	applied	\N	\N	\N	\N	54302	54302	54303
14364	16625	116	applied	\N	\N	\N	\N	54308	54308	54309
14364	16626	117	applied	\N	\N	\N	\N	54310	54310	54311
14364	16627	118	applied	\N	\N	\N	\N	54312	54312	54313
14364	16628	119	applied	\N	\N	\N	\N	54314	54314	54315
14364	16629	120	applied	\N	\N	\N	\N	54316	54316	54317
14364	16630	121	applied	\N	\N	\N	\N	54318	54318	54319
14364	16632	122	applied	\N	\N	\N	\N	54331	54331	54332
14364	16633	123	applied	\N	\N	\N	\N	54333	54333	54334
14364	16634	124	applied	\N	\N	\N	\N	54335	54335	54336
14364	16637	125	applied	\N	\N	\N	\N	54345	54345	54346
14366	17255	0	applied	\N	\N	\N	\N	56331	56331	56332
14366	17256	1	applied	\N	\N	\N	\N	56333	56333	56334
14366	17257	2	applied	\N	\N	\N	\N	56335	56335	56336
14369	17255	0	applied	\N	\N	\N	\N	56331	56331	56332
14369	17256	1	applied	\N	\N	\N	\N	56333	56333	56334
14369	17257	2	applied	\N	\N	\N	\N	56335	56335	56336
14377	16460	0	applied	\N	\N	\N	\N	53871	53871	53872
14377	16474	1	applied	\N	\N	\N	\N	53901	53901	53902
14377	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	54140	54140	\N
14377	16400	3	applied	\N	\N	\N	\N	53725	53725	53726
14377	17240	4	applied	\N	\N	\N	\N	56316	56316	56239
14377	16406	5	applied	\N	\N	\N	\N	53738	53738	53739
14377	16410	6	applied	\N	\N	\N	\N	53748	53748	53749
14377	16414	7	applied	\N	\N	\N	\N	53759	53759	53760
14377	16415	8	applied	\N	\N	\N	\N	53761	53761	53762
14377	17018	9	applied	\N	\N	\N	\N	55480	55480	55481
14377	17019	10	applied	\N	\N	\N	\N	55482	55482	55483
14377	17020	11	applied	\N	\N	\N	\N	55484	55484	55485
14377	17021	12	applied	\N	\N	\N	\N	55486	55486	55487
14377	16422	13	applied	\N	\N	\N	\N	53777	53777	53778
14377	16426	14	applied	\N	\N	\N	\N	53791	53791	53792
14377	16431	15	applied	\N	\N	\N	\N	53804	53804	53805
14377	16432	16	applied	\N	\N	\N	\N	53806	53806	53807
14377	16440	17	applied	\N	\N	\N	\N	53823	53823	53824
14377	16445	18	applied	\N	\N	\N	\N	53837	53837	53838
14377	16446	19	applied	\N	\N	\N	\N	53839	53839	53840
14377	16447	20	applied	\N	\N	\N	\N	53841	53841	53842
14377	16457	21	applied	\N	\N	\N	\N	53863	53863	53864
14377	16459	22	applied	\N	\N	\N	\N	53867	53867	53868
14377	16461	23	applied	\N	\N	\N	\N	53873	53873	53874
14377	16462	24	applied	\N	\N	\N	\N	53875	53875	53876
14377	16475	25	applied	\N	\N	\N	\N	53903	53903	53904
14377	16476	26	applied	\N	\N	\N	\N	53905	53905	53906
14377	16477	27	applied	\N	\N	\N	\N	53907	53907	53908
14377	16487	28	applied	\N	\N	\N	\N	53930	53930	53931
14377	16491	29	applied	\N	\N	\N	\N	53940	53940	53941
14377	16496	30	applied	\N	\N	\N	\N	53953	53953	53954
14377	16499	31	applied	\N	\N	\N	\N	53960	53960	53961
14377	16504	32	applied	\N	\N	\N	\N	53970	53970	53971
14377	16509	33	applied	\N	\N	\N	\N	53982	53982	53983
14377	16514	34	applied	\N	\N	\N	\N	53995	53995	53996
14377	16516	35	applied	\N	\N	\N	\N	54003	54003	54004
14377	16517	36	applied	\N	\N	\N	\N	54005	54005	54006
14377	16525	37	applied	\N	\N	\N	\N	54039	54039	54040
14377	16530	39	applied	\N	\N	\N	\N	54050	54050	54051
14377	16531	40	applied	\N	\N	\N	\N	54054	54054	54055
14377	16537	41	applied	\N	\N	\N	\N	54073	54073	54074
14377	16540	42	applied	\N	\N	\N	\N	54086	54086	54087
14377	16541	43	applied	\N	\N	\N	\N	54088	54088	54089
14377	16546	44	applied	\N	\N	\N	\N	54102	54102	54103
14377	16547	45	applied	\N	\N	\N	\N	54104	54104	54105
14377	16554	46	applied	\N	\N	\N	\N	54121	54121	54122
14377	16555	47	applied	\N	\N	\N	\N	54123	54123	54124
14377	16563	48	applied	\N	\N	\N	\N	54141	54141	54142
14377	16567	49	applied	\N	\N	\N	\N	54158	54158	54159
14377	16572	50	applied	\N	\N	\N	\N	54171	54171	54172
14377	16573	51	applied	\N	\N	\N	\N	54173	54173	54174
14377	16580	52	applied	\N	\N	\N	\N	54189	54189	54190
14377	16584	53	applied	\N	\N	\N	\N	54202	54202	54203
14377	16592	54	applied	\N	\N	\N	\N	54220	54220	54221
14377	16596	55	applied	\N	\N	\N	\N	54232	54232	54233
14377	16600	56	applied	\N	\N	\N	\N	54241	54241	54242
14377	16604	57	applied	\N	\N	\N	\N	54257	54257	54258
14377	16608	58	applied	\N	\N	\N	\N	54268	54268	54269
14377	16609	59	applied	\N	\N	\N	\N	54270	54270	54271
14377	16616	60	applied	\N	\N	\N	\N	54287	54287	54288
14377	16623	61	applied	\N	\N	\N	\N	54304	54304	54305
14377	16624	62	applied	\N	\N	\N	\N	54306	54306	54307
14377	16631	63	applied	\N	\N	\N	\N	54327	54327	54328
14377	16635	64	applied	\N	\N	\N	\N	54341	54341	54342
14377	16639	65	applied	\N	\N	\N	\N	54351	54351	54352
14377	16643	66	applied	\N	\N	\N	\N	54362	54362	54363
14376	17081	103	applied	\N	\N	\N	\N	55656	55656	55713
14376	17088	104	applied	\N	\N	\N	\N	55674	55674	55714
14376	17089	105	applied	\N	\N	\N	\N	55676	55676	55715
14376	17090	106	applied	\N	\N	\N	\N	55678	55678	55716
14376	17100	107	applied	\N	\N	\N	\N	55882	55882	56274
14376	17101	108	applied	\N	\N	\N	\N	55884	55884	56275
14376	17107	109	applied	\N	\N	\N	\N	55899	55899	56276
14376	17108	110	applied	\N	\N	\N	\N	55901	55901	56277
14376	17114	111	applied	\N	\N	\N	\N	55916	55916	56278
14376	17117	112	applied	\N	\N	\N	\N	55924	55924	56279
14376	17121	113	applied	\N	\N	\N	\N	55936	55936	56280
14376	17124	114	applied	\N	\N	\N	\N	55947	55947	56281
14376	17127	115	applied	\N	\N	\N	\N	55959	55959	56282
14376	17131	117	applied	\N	\N	\N	\N	55969	55969	56283
14376	17132	118	applied	\N	\N	\N	\N	55971	55971	56284
14376	17138	119	applied	\N	\N	\N	\N	55984	55984	56285
14376	17142	120	applied	\N	\N	\N	\N	55995	55995	56286
14376	17146	121	applied	\N	\N	\N	\N	56004	56004	56287
14376	17150	122	applied	\N	\N	\N	\N	56014	56014	56288
14376	17154	123	applied	\N	\N	\N	\N	56024	56024	56289
14376	17157	124	applied	\N	\N	\N	\N	56033	56033	56290
14376	17161	125	applied	\N	\N	\N	\N	56044	56044	56291
14378	17261	0	applied	\N	\N	\N	\N	56353	56353	56354
14378	17264	1	applied	\N	\N	\N	\N	56368	56368	56369
14378	17265	2	applied	\N	\N	\N	\N	56370	56370	56371
14378	17266	3	applied	\N	\N	\N	\N	56372	56372	56373
14383	17282	0	applied	\N	\N	\N	\N	56412	56412	56413
14383	17283	1	applied	\N	\N	\N	\N	56414	56414	56415
14383	17284	2	applied	\N	\N	\N	\N	56416	56416	56417
14389	17294	0	applied	\N	\N	\N	\N	56448	56448	56449
14389	17295	1	applied	\N	\N	\N	\N	56450	56450	56451
14389	17296	2	applied	\N	\N	\N	\N	56452	56452	56453
14389	17297	3	applied	\N	\N	\N	\N	56454	56454	56455
14389	17298	4	applied	\N	\N	\N	\N	56456	56456	56457
14389	17299	5	applied	\N	\N	\N	\N	56458	56458	56459
14389	17300	6	applied	\N	\N	\N	\N	56460	56460	56461
14389	17301	7	applied	\N	\N	\N	\N	56462	56462	56463
14389	17302	8	applied	\N	\N	\N	\N	56464	56464	56465
14389	17303	9	applied	\N	\N	\N	\N	56466	56466	56467
14389	17304	10	applied	\N	\N	\N	\N	56468	56468	56469
14389	17305	11	applied	\N	\N	\N	\N	56470	56470	56471
14389	17306	12	applied	\N	\N	\N	\N	56472	56472	56473
14389	17307	13	applied	\N	\N	\N	\N	56474	56474	56475
14399	17320	0	applied	\N	\N	\N	\N	56512	56512	56513
14399	17321	1	applied	\N	\N	\N	\N	56514	56514	56515
14399	17322	2	applied	\N	\N	\N	\N	56517	56517	56518
14403	17326	0	applied	\N	\N	\N	\N	56533	56533	56534
14403	17327	1	applied	\N	\N	\N	\N	56535	56535	33908
14403	17328	2	applied	\N	\N	\N	\N	56536	56536	56537
14403	17329	3	applied	\N	\N	\N	\N	56538	56538	56539
14405	17330	0	applied	\N	\N	\N	\N	56545	56545	56546
14405	17331	1	applied	\N	\N	\N	\N	56547	56547	56548
14408	17330	0	applied	\N	\N	\N	\N	56545	56545	56546
14408	17331	1	applied	\N	\N	\N	\N	56547	56547	56548
14413	17344	0	applied	\N	\N	\N	\N	56585	56585	56586
14413	17345	1	applied	\N	\N	\N	\N	56587	56587	56588
14413	17346	2	applied	\N	\N	\N	\N	56589	56589	56589
14413	17347	3	applied	\N	\N	\N	\N	56590	56590	56591
14413	17348	4	applied	\N	\N	\N	\N	56592	56592	56593
14413	17349	5	applied	\N	\N	\N	\N	56594	56594	56595
14415	17359	0	applied	\N	\N	\N	\N	56619	56619	56620
14415	17352	1	applied	\N	\N	\N	\N	56621	56621	56622
14415	17353	2	applied	\N	\N	\N	\N	56623	56623	56604
14415	17354	3	applied	\N	\N	\N	\N	56624	56624	56625
14415	17355	4	applied	\N	\N	\N	\N	56626	56626	56608
14415	17356	5	applied	\N	\N	\N	\N	56627	56627	56628
14415	17357	6	applied	\N	\N	\N	\N	56629	56629	56612
14415	17358	7	applied	\N	\N	\N	\N	56630	56630	56631
14415	17360	8	applied	\N	\N	\N	\N	56632	56632	56616
14415	17361	9	applied	\N	\N	\N	\N	56633	56633	56634
14422	17366	0	applied	\N	\N	\N	\N	56653	56653	56654
14422	17367	1	applied	\N	\N	\N	\N	56655	56655	56656
14422	17368	2	applied	\N	\N	\N	\N	56657	56657	56658
14422	17369	3	applied	\N	\N	\N	\N	56659	56659	56660
14422	17370	4	applied	\N	\N	\N	\N	56661	56661	56662
14427	17376	0	applied	\N	\N	\N	\N	56681	56681	56682
14427	17377	1	applied	\N	\N	\N	\N	56683	56683	56684
14427	17378	2	applied	\N	\N	\N	\N	56685	56685	56686
14427	17379	3	applied	\N	\N	\N	\N	56687	56687	56688
14432	17389	0	applied	\N	\N	\N	\N	56714	56714	56715
14432	17390	1	applied	\N	\N	\N	\N	56716	56716	56717
14432	17391	2	applied	\N	\N	\N	\N	56718	56718	56719
14432	17392	3	applied	\N	\N	\N	\N	56720	56720	56721
14432	17393	4	applied	\N	\N	\N	\N	56722	56722	56723
14432	17394	5	applied	\N	\N	\N	\N	56724	56724	56725
14432	17395	6	applied	\N	\N	\N	\N	56726	56726	56727
14432	17396	7	applied	\N	\N	\N	\N	56728	56728	56729
14432	17397	8	applied	\N	\N	\N	\N	56730	56730	56731
14432	17398	9	applied	\N	\N	\N	\N	56732	56732	56733
14432	17399	10	applied	\N	\N	\N	\N	56734	56734	56735
14440	17425	0	applied	\N	\N	\N	\N	56795	56795	56796
14440	17426	1	applied	\N	\N	\N	\N	56797	56797	56798
14440	17427	3	applied	\N	\N	\N	\N	56800	56800	56801
14440	17428	4	applied	\N	\N	\N	\N	56802	56802	56803
14450	17448	0	applied	\N	\N	\N	\N	56854	56854	56855
14450	17449	1	applied	\N	\N	\N	\N	56856	56856	56857
14452	17453	0	applied	\N	\N	\N	\N	56869	56869	56870
14452	17454	1	applied	\N	\N	\N	\N	56871	56871	56872
14452	17455	2	applied	\N	\N	\N	\N	56873	56873	56874
14455	17456	0	applied	\N	\N	\N	\N	56878	56878	56879
14455	17457	1	applied	\N	\N	\N	\N	56880	56880	56881
14455	17458	2	applied	\N	\N	\N	\N	56882	56882	56883
14455	17459	3	applied	\N	\N	\N	\N	56884	56884	56885
14457	17468	0	applied	\N	\N	\N	\N	56907	56907	56908
14457	17469	1	applied	\N	\N	\N	\N	56909	56909	56910
14457	17470	2	applied	\N	\N	\N	\N	56911	56911	56912
14457	17471	3	applied	\N	\N	\N	\N	56913	56913	56914
14463	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14463	17484	1	applied	\N	\N	\N	\N	56945	56945	56946
14463	17485	2	applied	\N	\N	\N	\N	56947	56947	56948
14463	17486	3	applied	\N	\N	\N	\N	56949	56949	56950
14465	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14467	17495	0	applied	\N	\N	\N	\N	56975	56975	56976
14467	17496	1	applied	\N	\N	\N	\N	56977	56977	56978
14467	17497	2	applied	\N	\N	\N	\N	56979	56979	56980
14467	17498	3	applied	\N	\N	\N	\N	56981	56981	56982
14469	17495	0	applied	\N	\N	\N	\N	56975	56975	56976
14469	17496	1	applied	\N	\N	\N	\N	56977	56977	56978
14469	17497	2	applied	\N	\N	\N	\N	56979	56979	56980
14469	17498	3	applied	\N	\N	\N	\N	56981	56981	56982
14379	17267	0	applied	\N	\N	\N	\N	56376	56376	56377
14379	17262	1	applied	\N	\N	\N	\N	56355	56355	56356
14379	17263	2	applied	\N	\N	\N	\N	56357	56357	56358
14379	17268	3	applied	\N	\N	\N	\N	56378	56378	56379
14379	17269	4	applied	\N	\N	\N	\N	56380	56380	56381
14379	17270	5	applied	\N	\N	\N	\N	56382	56382	56383
14379	17271	6	applied	\N	\N	\N	\N	56384	56384	56385
14379	17272	7	applied	\N	\N	\N	\N	56386	56386	56387
14379	17273	8	applied	\N	\N	\N	\N	56388	56388	56389
14379	17274	9	applied	\N	\N	\N	\N	56390	56390	56391
14379	17275	10	applied	\N	\N	\N	\N	56392	56392	56393
14381	17267	0	applied	\N	\N	\N	\N	56376	56376	56377
14381	17262	1	applied	\N	\N	\N	\N	56355	56355	56356
14381	17263	2	applied	\N	\N	\N	\N	56357	56357	56358
14381	17268	3	applied	\N	\N	\N	\N	56378	56378	56379
14381	17269	4	applied	\N	\N	\N	\N	56380	56380	56381
14381	17270	5	applied	\N	\N	\N	\N	56382	56382	56383
14381	17271	6	applied	\N	\N	\N	\N	56384	56384	56385
14381	17272	7	applied	\N	\N	\N	\N	56386	56386	56387
14381	17273	8	applied	\N	\N	\N	\N	56388	56388	56389
14381	17274	9	applied	\N	\N	\N	\N	56390	56390	56391
14381	17275	10	applied	\N	\N	\N	\N	56392	56392	56393
14390	17308	0	applied	\N	\N	\N	\N	56478	56478	56479
14390	17309	1	applied	\N	\N	\N	\N	56480	56480	56481
14390	17310	2	applied	\N	\N	\N	\N	56482	56482	56483
14392	17308	0	applied	\N	\N	\N	\N	56478	56478	56479
14395	17317	0	applied	\N	\N	\N	\N	56505	56505	56506
14395	17318	1	applied	\N	\N	\N	\N	56507	56507	56508
14395	17319	2	applied	\N	\N	\N	\N	56509	56509	56510
14397	17320	0	applied	\N	\N	\N	\N	56512	56512	56513
14397	17321	1	applied	\N	\N	\N	\N	56514	56514	56515
14407	17330	0	applied	\N	\N	\N	\N	56545	56545	56546
14407	17331	1	applied	\N	\N	\N	\N	56547	56547	56548
14410	17327	0	applied	\N	\N	\N	\N	56535	56535	33908
14411	17332	0	applied	\N	\N	\N	\N	56557	56557	56558
14417	17362	0	applied	\N	\N	\N	\N	56637	56637	56638
14417	17363	1	applied	\N	\N	\N	\N	56639	56639	56640
14417	17364	2	applied	\N	\N	\N	\N	56641	56641	56642
14421	17366	0	applied	\N	\N	\N	\N	56653	56653	56654
14421	17367	1	applied	\N	\N	\N	\N	56655	56655	56656
14421	17368	2	applied	\N	\N	\N	\N	56657	56657	56658
14421	17369	3	applied	\N	\N	\N	\N	56659	56659	56660
14421	17370	4	applied	\N	\N	\N	\N	56661	56661	56662
14423	17371	0	applied	\N	\N	\N	\N	56666	56666	56667
14423	17372	1	applied	\N	\N	\N	\N	56668	56668	56669
14428	17380	0	applied	\N	\N	\N	\N	56692	56692	56693
14428	17381	1	applied	\N	\N	\N	\N	56694	56694	56695
14428	17382	2	applied	\N	\N	\N	\N	56696	56696	56697
14428	17383	3	applied	\N	\N	\N	\N	56698	56698	56699
14428	17384	4	applied	\N	\N	\N	\N	56700	56700	56701
14428	17385	5	applied	\N	\N	\N	\N	56702	56702	56703
14428	17386	6	applied	\N	\N	\N	\N	56704	56704	56705
14428	17387	7	applied	\N	\N	\N	\N	56706	56706	56707
14433	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14433	17401	1	applied	\N	\N	\N	\N	56738	56738	56739
14433	17402	2	applied	\N	\N	\N	\N	56740	56740	56741
14433	17403	3	applied	\N	\N	\N	\N	56742	56742	56743
14433	17404	4	applied	\N	\N	\N	\N	56744	56744	56745
14434	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14434	17401	1	applied	\N	\N	\N	\N	56738	56738	56739
14434	17402	2	applied	\N	\N	\N	\N	56740	56740	56741
14434	17403	3	applied	\N	\N	\N	\N	56742	56742	56743
14436	17412	0	applied	\N	\N	\N	\N	56765	56765	56766
14436	17413	1	applied	\N	\N	\N	\N	56767	56767	56768
14436	17414	2	applied	\N	\N	\N	\N	56769	56769	56770
14438	17415	0	applied	\N	\N	\N	\N	56774	56774	56775
14438	17416	1	applied	\N	\N	\N	\N	56776	56776	56777
14438	17417	2	applied	\N	\N	\N	\N	56778	56778	56779
14438	17418	3	applied	\N	\N	\N	\N	56780	56780	56781
14441	17429	0	applied	\N	\N	\N	\N	56806	56806	56807
14441	17430	1	applied	\N	\N	\N	\N	56808	56808	56809
14441	17431	2	applied	\N	\N	\N	\N	56810	56810	56811
14441	17432	3	applied	\N	\N	\N	\N	56812	56812	56813
14446	17439	0	applied	\N	\N	\N	\N	56830	56830	56831
14446	17440	1	applied	\N	\N	\N	\N	56832	56832	56833
14446	17441	2	applied	\N	\N	\N	\N	56834	56834	56835
14451	17450	0	applied	\N	\N	\N	\N	56861	56861	56862
14451	17451	1	applied	\N	\N	\N	\N	56863	56863	56864
14451	17452	2	applied	\N	\N	\N	\N	56865	56865	56866
14456	17460	0	applied	\N	\N	\N	\N	56889	56889	56890
14456	17461	1	applied	\N	\N	\N	\N	56891	56891	56892
14456	17462	2	applied	\N	\N	\N	\N	56893	56893	56894
14456	17463	3	applied	\N	\N	\N	\N	56895	56895	56896
14456	17464	4	applied	\N	\N	\N	\N	56897	56897	56898
14456	17465	5	applied	\N	\N	\N	\N	56899	56899	56900
14456	17466	6	applied	\N	\N	\N	\N	56901	56901	56902
14456	17467	7	applied	\N	\N	\N	\N	56903	56903	56904
14459	17479	0	applied	\N	\N	\N	\N	56933	56933	56934
14459	17480	1	applied	\N	\N	\N	\N	56935	56935	56936
14459	17481	2	applied	\N	\N	\N	\N	56937	56937	56938
14459	17482	3	applied	\N	\N	\N	\N	56939	56939	56940
14461	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14461	17484	1	applied	\N	\N	\N	\N	56945	56945	56946
14461	17485	2	applied	\N	\N	\N	\N	56947	56947	56948
14461	17486	3	applied	\N	\N	\N	\N	56949	56949	56950
14464	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14464	17484	1	applied	\N	\N	\N	\N	56945	56945	56946
14464	17485	2	applied	\N	\N	\N	\N	56947	56947	56948
14464	17486	3	applied	\N	\N	\N	\N	56949	56949	56950
14473	17502	0	applied	\N	\N	\N	\N	56997	56997	56998
14473	17503	1	applied	\N	\N	\N	\N	56999	56999	57000
14473	17504	2	applied	\N	\N	\N	\N	57001	57001	57002
14473	17505	3	applied	\N	\N	\N	\N	57003	57003	57004
14478	17521	0	applied	\N	\N	\N	\N	57042	57042	57043
14478	17522	1	applied	\N	\N	\N	\N	57044	57044	57045
14478	17523	2	applied	\N	\N	\N	\N	57046	57046	57047
14478	17524	3	applied	\N	\N	\N	\N	57048	57048	57049
14478	17525	4	applied	\N	\N	\N	\N	57050	57050	57051
14478	17526	5	applied	\N	\N	\N	\N	57052	57052	57053
14478	17527	6	applied	\N	\N	\N	\N	57054	57054	57055
14478	17528	7	applied	\N	\N	\N	\N	57056	57056	57057
14481	17541	0	applied	\N	\N	\N	\N	57087	57087	57088
14481	17542	1	applied	\N	\N	\N	\N	57089	57089	57090
14481	17543	2	applied	\N	\N	\N	\N	57091	57091	57092
14481	17544	3	applied	\N	\N	\N	\N	57093	57093	57094
14485	17545	0	applied	\N	\N	\N	\N	57099	57099	57100
14488	17240	0	applied	\N	\N	\N	\N	56254	56254	56239
14488	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14488	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14488	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14385	17287	2	applied	\N	\N	\N	\N	56424	56424	56425
14385	17288	3	applied	\N	\N	\N	\N	56426	56426	56427
14385	17289	4	applied	\N	\N	\N	\N	56428	56428	56429
14385	17290	5	applied	\N	\N	\N	\N	56430	56430	56431
14388	17240	0	applied	\N	\N	\N	\N	56445	56445	56239
14388	17018	1	applied	\N	\N	\N	\N	55480	55480	55481
14388	17019	2	applied	\N	\N	\N	\N	55482	55482	55483
14388	17020	3	applied	\N	\N	\N	\N	55484	55484	55485
14388	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14388	17072	5	applied	\N	\N	1000000000	\N	55634	55634	55635
14391	17308	0	applied	\N	\N	\N	\N	56478	56478	56479
14391	17309	1	applied	\N	\N	\N	\N	56480	56480	56481
14391	17310	2	applied	\N	\N	\N	\N	56482	56482	56483
14393	17311	0	applied	\N	\N	\N	\N	56489	56489	56490
14393	17312	1	applied	\N	\N	\N	\N	56491	56491	56492
14393	17313	2	applied	\N	\N	\N	\N	56493	56493	56494
14398	17320	0	applied	\N	\N	\N	\N	56512	56512	56513
14398	17321	1	applied	\N	\N	\N	\N	56514	56514	56515
14398	17322	2	applied	\N	\N	\N	\N	56517	56517	56518
14402	17326	0	applied	\N	\N	\N	\N	56533	56533	56534
14402	17327	1	applied	\N	\N	\N	\N	56535	56535	33908
14402	17328	2	applied	\N	\N	\N	\N	56536	56536	56537
14402	17329	3	applied	\N	\N	\N	\N	56538	56538	56539
14412	17333	0	applied	\N	\N	\N	\N	56562	56562	56563
14412	17334	1	applied	\N	\N	\N	\N	56564	56564	56565
14412	17335	2	applied	\N	\N	\N	\N	56566	56566	56567
14412	17336	3	applied	\N	\N	\N	\N	56568	56568	56569
14412	17337	4	applied	\N	\N	\N	\N	56570	56570	56571
14412	17338	5	applied	\N	\N	\N	\N	56572	56572	56573
14412	17339	6	applied	\N	\N	\N	\N	56574	56574	56575
14412	17340	7	applied	\N	\N	\N	\N	56576	56576	56577
14412	17341	8	applied	\N	\N	\N	\N	56578	56578	56579
14412	17342	9	applied	\N	\N	\N	\N	56580	56580	56581
14412	17343	10	applied	\N	\N	\N	\N	56582	56582	56583
14418	17362	0	applied	\N	\N	\N	\N	56637	56637	56638
14419	17365	0	applied	\N	\N	\N	\N	56648	56648	56649
14424	17373	0	applied	\N	\N	\N	\N	56672	56672	56673
14424	17374	1	applied	\N	\N	\N	\N	56674	56674	56675
14424	17375	2	applied	\N	\N	\N	\N	56676	56676	56677
14426	17376	0	applied	\N	\N	\N	\N	56681	56681	56682
14426	17377	1	applied	\N	\N	\N	\N	56683	56683	56684
14426	17378	2	applied	\N	\N	\N	\N	56685	56685	56686
14426	17379	3	applied	\N	\N	\N	\N	56687	56687	56688
14431	17388	0	applied	\N	\N	\N	\N	56711	56711	56712
14437	17412	0	applied	\N	\N	\N	\N	56765	56765	56766
14437	17413	1	applied	\N	\N	\N	\N	56767	56767	56768
14437	17414	2	applied	\N	\N	\N	\N	56769	56769	56770
14439	17419	0	applied	\N	\N	\N	\N	56782	56782	56783
14439	17420	1	applied	\N	\N	\N	\N	56784	56784	56785
14439	17421	2	applied	\N	\N	\N	\N	56786	56786	56787
14439	17422	3	applied	\N	\N	\N	\N	56788	56788	56789
14439	17423	4	applied	\N	\N	\N	\N	56790	56790	56791
14439	17424	5	applied	\N	\N	\N	\N	56792	56792	56793
14442	17429	0	applied	\N	\N	\N	\N	56806	56806	56807
14442	17430	1	applied	\N	\N	\N	\N	56808	56808	56809
14442	17431	2	applied	\N	\N	\N	\N	56810	56810	56811
14442	17432	3	applied	\N	\N	\N	\N	56812	56812	56813
14444	17240	0	applied	\N	\N	\N	\N	56238	56238	56239
14444	17327	1	applied	\N	\N	\N	\N	56535	56535	33908
14444	17346	2	applied	\N	\N	\N	\N	56589	56589	56589
14444	17024	3	applied	\N	\N	\N	\N	55494	55494	55495
14444	17025	4	applied	\N	\N	\N	\N	55496	55496	55497
14444	17072	5	applied	\N	\N	1000000000	\N	55634	55634	55635
14444	17026	6	applied	\N	\N	\N	\N	55498	55498	55499
14444	17027	7	applied	\N	\N	\N	\N	55500	55500	55501
14444	17028	8	applied	\N	\N	\N	\N	55502	55502	55503
14444	17029	9	applied	\N	\N	\N	\N	55504	55504	55505
14447	17439	0	applied	\N	\N	\N	\N	56830	56830	56831
14447	17440	1	applied	\N	\N	\N	\N	56832	56832	56833
14447	17441	2	applied	\N	\N	\N	\N	56834	56834	56835
14449	17448	0	applied	\N	\N	\N	\N	56854	56854	56855
14449	17449	1	applied	\N	\N	\N	\N	56856	56856	56857
14454	17456	0	applied	\N	\N	\N	\N	56878	56878	56879
14454	17457	1	applied	\N	\N	\N	\N	56880	56880	56881
14454	17458	2	applied	\N	\N	\N	\N	56882	56882	56883
14454	17459	3	applied	\N	\N	\N	\N	56884	56884	56885
14460	17479	0	applied	\N	\N	\N	\N	56933	56933	56934
14460	17480	1	applied	\N	\N	\N	\N	56935	56935	56936
14460	17481	2	applied	\N	\N	\N	\N	56937	56937	56938
14460	17482	3	applied	\N	\N	\N	\N	56939	56939	56940
14462	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14462	17484	1	applied	\N	\N	\N	\N	56945	56945	56946
14462	17485	2	applied	\N	\N	\N	\N	56947	56947	56948
14462	17486	3	applied	\N	\N	\N	\N	56949	56949	56950
14466	17487	0	applied	\N	\N	\N	\N	56957	56957	56958
14466	17488	1	applied	\N	\N	\N	\N	56959	56959	56960
14466	17489	2	applied	\N	\N	\N	\N	56961	56961	56962
14466	17490	3	applied	\N	\N	\N	\N	56963	56963	56964
14466	17491	4	applied	\N	\N	\N	\N	56965	56965	56966
14466	17492	5	applied	\N	\N	\N	\N	56967	56967	56968
14466	17493	6	applied	\N	\N	\N	\N	56969	56969	56970
14466	17494	7	applied	\N	\N	\N	\N	56971	56971	56972
14474	17506	0	applied	\N	\N	\N	\N	57005	57005	57006
14474	17507	1	applied	\N	\N	\N	\N	57007	57007	57008
14474	17508	2	applied	\N	\N	\N	\N	57009	57009	57010
14474	17509	3	applied	\N	\N	\N	\N	57011	57011	57012
14474	17510	4	applied	\N	\N	\N	\N	57013	57013	57014
14474	17511	5	applied	\N	\N	\N	\N	57015	57015	57016
14474	17512	6	applied	\N	\N	\N	\N	57017	57017	57018
14474	17513	7	applied	\N	\N	\N	\N	57019	57019	57020
14474	17514	8	applied	\N	\N	\N	\N	57021	57021	57022
14474	17515	9	applied	\N	\N	\N	\N	57023	57023	57024
14474	17516	11	applied	\N	\N	\N	\N	57026	57026	57027
14474	17517	12	applied	\N	\N	\N	\N	57028	57028	57029
14474	17518	13	applied	\N	\N	\N	\N	57030	57030	57031
14474	17519	14	applied	\N	\N	\N	\N	57032	57032	57033
14474	17520	15	applied	\N	\N	\N	\N	57034	57034	57035
14479	17521	0	applied	\N	\N	\N	\N	57042	57042	57043
14479	17522	1	applied	\N	\N	\N	\N	57044	57044	57045
14479	17523	2	applied	\N	\N	\N	\N	57046	57046	57047
14479	17524	3	applied	\N	\N	\N	\N	57048	57048	57049
14479	17525	4	applied	\N	\N	\N	\N	57050	57050	57051
14479	17526	5	applied	\N	\N	\N	\N	57052	57052	57053
14479	17527	6	applied	\N	\N	\N	\N	57054	57054	57055
14479	17528	7	applied	\N	\N	\N	\N	57056	57056	57057
14484	17541	0	applied	\N	\N	\N	\N	57087	57087	57088
14484	17542	1	applied	\N	\N	\N	\N	57089	57089	57090
14484	17543	2	applied	\N	\N	\N	\N	57091	57091	57092
14484	17544	3	applied	\N	\N	\N	\N	57093	57093	57094
14430	16743	27	applied	\N	\N	\N	\N	54694	54694	54695
14430	16746	28	applied	\N	\N	\N	\N	54702	54702	54703
14430	16747	29	applied	\N	\N	\N	\N	54704	54704	54705
14430	16752	30	applied	\N	\N	\N	\N	54716	54716	54717
14430	16753	31	applied	\N	\N	\N	\N	54720	54720	54721
14430	16754	32	applied	\N	\N	\N	\N	54722	54722	54723
14430	16763	33	applied	\N	\N	\N	\N	54741	54741	54742
14430	16767	34	applied	\N	\N	\N	\N	54752	54752	54753
14430	16772	35	applied	\N	\N	\N	\N	54764	54764	54765
14430	16773	36	applied	\N	\N	\N	\N	54766	54766	54767
14430	16780	37	applied	\N	\N	\N	\N	54782	54782	54783
14430	16781	38	applied	\N	\N	\N	\N	54784	54784	54785
14430	16786	39	applied	\N	\N	\N	\N	54806	54806	54807
14430	16790	40	applied	\N	\N	\N	\N	54816	54816	54817
14430	16792	41	applied	\N	\N	\N	\N	54824	54824	54825
14430	16795	42	applied	\N	\N	\N	\N	54832	54832	54833
14430	16799	43	applied	\N	\N	\N	\N	54849	54849	54850
14430	16800	44	applied	\N	\N	\N	\N	54851	54851	54852
14435	17405	0	applied	\N	\N	\N	\N	56749	56749	56750
14435	17406	1	applied	\N	\N	\N	\N	56751	56751	56752
14435	17404	2	applied	\N	\N	\N	\N	56744	56744	56745
14435	17407	3	applied	\N	\N	\N	\N	56753	56753	56754
14435	17408	4	applied	\N	\N	\N	\N	56755	56755	56756
14435	17409	5	applied	\N	\N	\N	\N	56757	56757	56758
14435	17410	6	applied	\N	\N	\N	\N	56759	56759	56760
14435	17411	7	applied	\N	\N	\N	\N	56761	56761	56762
14443	17433	0	applied	\N	\N	\N	\N	56815	56815	56816
14443	17434	1	applied	\N	\N	\N	\N	56817	56817	56818
14443	17435	2	applied	\N	\N	\N	\N	56819	56819	56820
14445	17436	0	applied	\N	\N	\N	\N	56824	56824	56825
14445	17437	1	applied	\N	\N	\N	\N	56826	56826	56827
14445	17438	2	applied	\N	\N	\N	\N	56828	56828	56829
14448	17442	0	applied	\N	\N	\N	\N	56840	56840	56841
14448	17443	1	applied	\N	\N	\N	\N	56842	56842	56843
14448	17444	2	applied	\N	\N	\N	\N	56844	56844	56845
14448	17445	3	applied	\N	\N	\N	\N	56846	56846	56847
14448	17446	4	applied	\N	\N	\N	\N	56848	56848	56849
14448	17447	5	applied	\N	\N	\N	\N	56850	56850	56851
14453	17453	0	applied	\N	\N	\N	\N	56869	56869	56870
14453	17454	1	applied	\N	\N	\N	\N	56871	56871	56872
14453	17455	2	applied	\N	\N	\N	\N	56873	56873	56874
14458	17472	0	applied	\N	\N	\N	\N	56917	56917	56918
14458	17473	1	applied	\N	\N	\N	\N	56919	56919	56920
14458	17474	2	applied	\N	\N	\N	\N	56921	56921	56922
14458	17475	3	applied	\N	\N	\N	\N	56923	56923	56924
14458	17476	4	applied	\N	\N	\N	\N	56925	56925	56926
14458	17477	5	applied	\N	\N	\N	\N	56927	56927	56928
14458	17478	6	applied	\N	\N	\N	\N	56929	56929	56930
14468	17495	0	applied	\N	\N	\N	\N	56975	56975	56976
14468	17496	1	applied	\N	\N	\N	\N	56977	56977	56978
14468	17497	2	applied	\N	\N	\N	\N	56979	56979	56980
14468	17498	3	applied	\N	\N	\N	\N	56981	56981	56982
14470	17483	0	applied	\N	\N	\N	\N	56943	56943	56944
14470	17487	1	applied	\N	\N	\N	\N	56957	56957	56958
14470	17488	2	applied	\N	\N	\N	\N	56959	56959	56960
14470	17495	3	applied	\N	\N	\N	\N	56975	56975	56976
14470	17484	4	applied	\N	\N	\N	\N	56945	56945	56946
14470	17485	5	applied	\N	\N	\N	\N	56947	56947	56948
14470	17486	6	applied	\N	\N	\N	\N	56949	56949	56950
14470	17489	7	applied	\N	\N	\N	\N	56961	56961	56962
14470	17490	8	applied	\N	\N	\N	\N	56963	56963	56964
14470	17491	9	applied	\N	\N	\N	\N	56965	56965	56966
14470	17492	10	applied	\N	\N	\N	\N	56967	56967	56968
14470	17493	11	applied	\N	\N	\N	\N	56969	56969	56970
14470	17494	12	applied	\N	\N	\N	\N	56971	56971	56972
14470	17496	13	applied	\N	\N	\N	\N	56977	56977	56978
14470	17497	14	applied	\N	\N	\N	\N	56979	56979	56980
14470	17498	15	applied	\N	\N	\N	\N	56981	56981	56982
14472	17502	0	applied	\N	\N	\N	\N	56997	56997	56998
14477	17506	0	applied	\N	\N	\N	\N	57005	57005	57006
14477	17507	1	applied	\N	\N	\N	\N	57007	57007	57008
14477	17508	2	applied	\N	\N	\N	\N	57009	57009	57010
14477	17509	3	applied	\N	\N	\N	\N	57011	57011	57012
14477	17510	4	applied	\N	\N	\N	\N	57013	57013	57014
14480	17529	0	applied	\N	\N	\N	\N	57062	57062	57063
14480	17530	1	applied	\N	\N	\N	\N	57064	57064	57065
14480	17531	2	applied	\N	\N	\N	\N	57066	57066	57067
14480	17532	3	applied	\N	\N	\N	\N	57068	57068	57069
14480	17533	4	applied	\N	\N	\N	\N	57070	57070	57071
14480	17534	5	applied	\N	\N	\N	\N	57072	57072	57073
14480	17535	6	applied	\N	\N	\N	\N	57074	57074	57075
14480	17536	7	applied	\N	\N	\N	\N	57076	57076	57077
14480	17537	8	applied	\N	\N	\N	\N	57078	57078	57079
14480	17538	9	applied	\N	\N	\N	\N	57080	57080	57081
14480	17539	10	applied	\N	\N	\N	\N	57082	57082	57083
14480	17540	11	applied	\N	\N	\N	\N	57084	57084	57085
14491	17554	0	applied	\N	\N	\N	\N	57125	57125	57126
14491	17548	1	applied	\N	\N	\N	\N	57106	57106	57107
14491	17555	2	applied	\N	\N	\N	\N	57127	57127	57128
14491	17556	3	applied	\N	\N	\N	\N	57129	57129	57130
14491	17557	4	applied	\N	\N	\N	\N	57131	57131	57132
14491	17558	5	applied	\N	\N	\N	\N	57133	57133	57134
14491	17559	6	applied	\N	\N	\N	\N	57135	57135	57136
14491	17560	7	applied	\N	\N	\N	\N	57137	57137	57138
14491	17561	8	applied	\N	\N	\N	\N	57139	57139	57140
14491	17562	9	applied	\N	\N	\N	\N	57141	57141	57142
14491	17563	10	applied	\N	\N	\N	\N	57143	57143	57144
14491	17564	11	applied	\N	\N	\N	\N	57145	57145	57146
14491	17565	12	applied	\N	\N	\N	\N	57147	57147	57148
14491	17566	13	applied	\N	\N	\N	\N	57149	57149	57150
14491	17567	14	applied	\N	\N	\N	\N	57151	57151	57152
14491	17568	15	applied	\N	\N	\N	\N	57153	57153	57154
14491	17569	16	applied	\N	\N	\N	\N	57155	57155	57156
14497	17574	0	applied	\N	\N	\N	\N	57219	57219	57220
14497	17575	1	applied	\N	\N	\N	\N	57221	57221	57222
14497	17576	2	applied	\N	\N	\N	\N	57223	57223	57224
14499	17575	0	applied	\N	\N	\N	\N	57221	57221	57222
14499	17576	1	applied	\N	\N	\N	\N	57223	57223	57224
14502	17574	0	applied	\N	\N	\N	\N	57219	57219	57220
14502	17577	1	applied	\N	\N	\N	\N	57228	57228	57229
14502	17578	2	applied	\N	\N	\N	\N	57230	57230	57231
14502	17579	3	applied	\N	\N	\N	\N	57234	57234	57235
14502	17580	4	applied	\N	\N	\N	\N	57236	57236	57237
14502	17581	5	applied	\N	\N	\N	\N	57238	57238	57239
14502	17582	6	applied	\N	\N	\N	\N	57240	57240	57241
14502	17583	7	applied	\N	\N	\N	\N	57242	57242	57243
14504	17584	0	applied	\N	\N	\N	\N	57246	57246	57247
14504	17585	1	applied	\N	\N	\N	\N	57249	57249	57250
14504	17586	2	applied	\N	\N	\N	\N	57251	57251	57252
14504	17587	3	applied	\N	\N	\N	\N	57253	57253	57254
14471	17499	0	applied	\N	\N	\N	\N	56989	56989	56990
14471	17500	1	applied	\N	\N	\N	\N	56991	56991	56992
14471	17501	2	applied	\N	\N	\N	\N	56993	56993	56994
14475	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14483	17541	0	applied	\N	\N	\N	\N	57087	57087	57088
14487	17545	0	applied	\N	\N	\N	\N	57099	57099	57100
14487	17546	1	applied	\N	\N	\N	\N	57102	57102	57103
14487	17547	2	applied	\N	\N	\N	\N	57104	57104	57105
14487	17548	3	applied	\N	\N	\N	\N	57106	57106	57107
14490	17554	0	applied	\N	\N	\N	\N	57125	57125	57126
14490	17548	1	applied	\N	\N	\N	\N	57106	57106	57107
14490	17555	2	applied	\N	\N	\N	\N	57127	57127	57128
14490	17556	3	applied	\N	\N	\N	\N	57129	57129	57130
14490	17557	4	applied	\N	\N	\N	\N	57131	57131	57132
14490	17558	5	applied	\N	\N	\N	\N	57133	57133	57134
14490	17559	6	applied	\N	\N	\N	\N	57135	57135	57136
14490	17560	7	applied	\N	\N	\N	\N	57137	57137	57138
14490	17561	8	applied	\N	\N	\N	\N	57139	57139	57140
14490	17562	9	applied	\N	\N	\N	\N	57141	57141	57142
14490	17563	10	applied	\N	\N	\N	\N	57143	57143	57144
14490	17564	11	applied	\N	\N	\N	\N	57145	57145	57146
14490	17565	12	applied	\N	\N	\N	\N	57147	57147	57148
14490	17566	13	applied	\N	\N	\N	\N	57149	57149	57150
14490	17567	14	applied	\N	\N	\N	\N	57151	57151	57152
14490	17568	15	applied	\N	\N	\N	\N	57153	57153	57154
14490	17569	16	applied	\N	\N	\N	\N	57155	57155	57156
14492	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14492	17251	1	applied	\N	\N	\N	\N	56317	56317	56318
14492	17255	2	applied	\N	\N	\N	\N	56331	56331	57159
14492	17258	3	applied	\N	\N	\N	\N	56342	56342	57160
14492	17261	4	applied	\N	\N	\N	\N	56353	56353	57161
14492	17264	5	applied	\N	\N	\N	\N	56368	56368	57162
14492	17265	6	applied	\N	\N	\N	\N	56370	56370	57163
14492	17266	7	applied	\N	\N	\N	\N	56372	56372	57164
14492	17267	8	applied	\N	\N	\N	\N	56376	56376	57165
14492	17276	9	applied	\N	\N	\N	\N	56398	56398	57166
14492	17277	10	applied	\N	\N	\N	\N	56400	56400	57167
14492	17282	11	applied	\N	\N	\N	\N	56412	56412	57168
14492	17285	13	applied	\N	\N	\N	\N	56420	56420	57170
14492	17286	14	applied	\N	\N	\N	\N	56422	56422	57171
14492	17291	15	applied	\N	\N	\N	\N	56436	56436	57172
14492	17294	16	applied	\N	\N	\N	\N	56448	56448	57173
14492	17295	17	applied	\N	\N	\N	\N	56450	56450	57174
14492	17296	18	applied	\N	\N	\N	\N	56452	56452	57175
14492	17297	19	applied	\N	\N	\N	\N	56454	56454	57176
14492	17298	20	applied	\N	\N	\N	\N	56456	56456	57177
14492	17308	21	applied	\N	\N	\N	\N	56478	56478	57178
14492	17311	22	applied	\N	\N	\N	\N	56489	56489	57179
14492	17314	23	applied	\N	\N	\N	\N	56497	56497	57180
14492	17317	24	applied	\N	\N	\N	\N	56505	56505	57181
14492	17320	25	applied	\N	\N	\N	\N	56512	56512	57182
14492	17323	26	applied	\N	\N	\N	\N	56525	56525	57183
14492	17326	27	applied	\N	\N	\N	\N	56533	56533	57184
14492	17332	28	applied	\N	\N	\N	\N	56557	56557	57185
14492	17333	29	applied	\N	\N	\N	\N	56562	56562	57186
14492	17334	30	applied	\N	\N	\N	\N	56564	56564	57187
14492	17335	31	applied	\N	\N	\N	\N	56566	56566	57188
14492	17336	32	applied	\N	\N	\N	\N	56568	56568	57189
14492	17337	33	applied	\N	\N	\N	\N	56570	56570	57190
14492	17344	34	applied	\N	\N	\N	\N	56585	56585	57191
14492	17345	35	applied	\N	\N	\N	\N	56587	56587	57192
14492	17359	36	applied	\N	\N	\N	\N	56619	56619	57193
14492	17362	37	applied	\N	\N	\N	\N	56637	56637	57194
14492	17365	38	applied	\N	\N	\N	\N	56648	56648	57195
14492	17366	39	applied	\N	\N	\N	\N	56653	56653	57196
14492	17371	40	applied	\N	\N	\N	\N	56666	56666	57197
14492	17373	41	applied	\N	\N	\N	\N	56672	56672	57198
14492	17376	42	applied	\N	\N	\N	\N	56681	56681	57199
14492	17380	43	applied	\N	\N	\N	\N	56692	56692	57200
14492	17381	44	applied	\N	\N	\N	\N	56694	56694	57201
14492	17388	45	applied	\N	\N	\N	\N	56711	56711	57202
14495	17570	0	applied	\N	\N	\N	\N	57205	57205	57206
14495	17571	1	applied	\N	\N	\N	\N	57207	57207	57208
14495	17572	2	applied	\N	\N	\N	\N	57209	57209	57210
14495	17573	3	applied	\N	\N	\N	\N	57211	57211	57212
14496	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14496	17327	1	applied	\N	\N	\N	\N	56535	56535	33908
14496	17346	2	applied	\N	\N	\N	\N	56589	56589	56589
14501	17574	0	applied	\N	\N	\N	\N	57219	57219	57220
14501	17577	1	applied	\N	\N	\N	\N	57228	57228	57229
14501	17578	2	applied	\N	\N	\N	\N	57230	57230	57231
14501	17579	3	applied	\N	\N	\N	\N	57234	57234	57235
14501	17580	4	applied	\N	\N	\N	\N	57236	57236	57237
14501	17581	5	applied	\N	\N	\N	\N	57238	57238	57239
14501	17582	6	applied	\N	\N	\N	\N	57240	57240	57241
14501	17583	7	applied	\N	\N	\N	\N	57242	57242	57243
14503	17584	0	applied	\N	\N	\N	\N	57246	57246	57247
14507	17612	0	applied	\N	\N	\N	\N	57306	57306	57307
14507	17613	1	applied	\N	\N	\N	\N	57308	57308	57309
14507	17614	2	applied	\N	\N	\N	\N	57310	57310	57311
14507	17615	3	applied	\N	\N	\N	\N	57312	57312	57313
14507	17616	4	applied	\N	\N	\N	\N	57314	57314	57315
14515	17624	0	applied	\N	\N	\N	\N	57339	57339	57340
14515	17625	1	applied	\N	\N	\N	\N	57341	57341	57342
14515	17630	2	applied	\N	\N	\N	\N	57352	57352	57353
14515	17627	3	applied	\N	\N	\N	\N	57354	57354	57355
14515	17628	4	applied	\N	\N	\N	\N	57356	57356	57350
14515	17629	5	applied	\N	\N	\N	\N	57357	57357	57358
14516	17631	0	applied	\N	\N	\N	\N	57362	57362	57363
14516	17632	1	applied	\N	\N	\N	\N	57364	57364	57365
14521	17633	0	applied	\N	\N	\N	\N	57370	57370	57371
14521	17634	1	applied	\N	\N	\N	\N	57372	57372	57373
14521	17635	2	applied	\N	\N	\N	\N	57374	57374	57375
14521	17636	3	applied	\N	\N	\N	\N	57376	57376	57377
14521	17637	4	applied	\N	\N	\N	\N	57378	57378	57379
14521	17638	5	applied	\N	\N	\N	\N	57380	57380	57381
14523	17642	0	applied	\N	\N	\N	\N	57391	57391	57392
14523	17643	1	applied	\N	\N	\N	\N	57393	57393	57394
14526	17656	0	applied	\N	\N	\N	\N	57423	57423	57424
14526	17657	1	applied	\N	\N	\N	\N	57425	57425	57426
14529	17656	0	applied	\N	\N	\N	\N	57423	57423	57424
14529	17657	1	applied	\N	\N	\N	\N	57425	57425	57426
14534	17660	0	applied	\N	\N	\N	\N	57442	57442	57443
14534	17661	1	applied	\N	\N	\N	\N	57444	57444	57445
14539	17672	0	applied	\N	\N	\N	\N	57472	57472	57473
14539	17673	1	applied	\N	\N	\N	\N	57474	57474	57475
14539	17674	2	applied	\N	\N	\N	\N	57476	57476	57477
14539	17675	3	applied	\N	\N	\N	\N	57478	57478	57479
14539	17676	4	applied	\N	\N	\N	\N	57480	57480	57481
14539	17677	5	applied	\N	\N	\N	\N	57482	57482	57483
14486	17545	0	applied	\N	\N	\N	\N	57099	57099	57100
14486	17546	1	applied	\N	\N	\N	\N	57102	57102	57103
14486	17547	2	applied	\N	\N	\N	\N	57104	57104	57105
14486	17548	3	applied	\N	\N	\N	\N	57106	57106	57107
14494	17570	0	applied	\N	\N	\N	\N	57205	57205	57206
14494	17571	1	applied	\N	\N	\N	\N	57207	57207	57208
14494	17572	2	applied	\N	\N	\N	\N	57209	57209	57210
14494	17573	3	applied	\N	\N	\N	\N	57211	57211	57212
14498	17574	0	applied	\N	\N	\N	\N	57219	57219	57220
14500	17574	0	applied	\N	\N	\N	\N	57219	57219	57220
14500	17577	1	applied	\N	\N	\N	\N	57228	57228	57229
14500	17578	2	applied	\N	\N	\N	\N	57230	57230	57231
14506	17604	0	applied	\N	\N	\N	\N	57288	57288	57289
14506	17605	1	applied	\N	\N	\N	\N	57290	57290	57291
14506	17606	2	applied	\N	\N	\N	\N	57292	57292	57293
14506	17607	3	applied	\N	\N	\N	\N	57294	57294	57295
14506	17608	4	applied	\N	\N	\N	\N	57296	57296	57297
14506	17609	5	applied	\N	\N	\N	\N	57298	57298	57299
14506	17610	6	applied	\N	\N	\N	\N	57300	57300	57301
14506	17611	7	applied	\N	\N	\N	\N	57302	57302	57303
14509	17617	0	applied	\N	\N	\N	\N	57319	57319	57320
14514	17624	0	applied	\N	\N	\N	\N	57339	57339	57340
14514	17625	1	applied	\N	\N	\N	\N	57341	57341	57342
14514	17630	2	applied	\N	\N	\N	\N	57352	57352	57353
14514	17627	3	applied	\N	\N	\N	\N	57354	57354	57355
14514	17628	4	applied	\N	\N	\N	\N	57356	57356	57350
14514	17629	5	applied	\N	\N	\N	\N	57357	57357	57358
14522	17639	0	applied	\N	\N	\N	\N	57383	57383	57384
14522	17640	1	applied	\N	\N	\N	\N	57385	57385	57386
14522	17641	2	applied	\N	\N	\N	\N	57387	57387	57388
14531	17658	0	applied	\N	\N	\N	\N	57434	57434	57435
14531	17659	1	applied	\N	\N	\N	\N	57436	57436	57437
14533	17660	0	applied	\N	\N	\N	\N	57442	57442	57443
14533	17661	1	applied	\N	\N	\N	\N	57444	57444	57445
14538	17668	0	applied	\N	\N	\N	\N	57462	57462	57463
14538	17669	1	applied	\N	\N	\N	\N	57464	57464	57465
14538	17670	2	applied	\N	\N	\N	\N	57466	57466	57467
14538	17671	3	applied	\N	\N	\N	\N	57468	57468	57469
14541	17681	0	applied	\N	\N	\N	\N	57492	57492	57493
14541	17682	1	applied	\N	\N	\N	\N	57494	57494	57495
14541	17683	2	applied	\N	\N	\N	\N	57496	57496	57497
14541	17684	3	applied	\N	\N	\N	\N	57498	57498	57499
14541	17685	4	applied	\N	\N	\N	\N	57500	57500	57501
14541	17686	5	applied	\N	\N	\N	\N	57502	57502	57503
14547	17693	0	applied	\N	\N	\N	\N	57526	57526	57527
14547	17694	1	applied	\N	\N	\N	\N	57528	57528	57529
14547	17695	2	applied	\N	\N	\N	\N	57530	57530	57531
14547	17696	3	applied	\N	\N	\N	\N	57532	57532	57533
14547	17697	4	applied	\N	\N	\N	\N	57534	57534	57535
14547	17698	5	applied	\N	\N	\N	\N	57536	57536	57537
14547	17699	6	applied	\N	\N	\N	\N	57538	57538	57539
14547	17700	7	applied	\N	\N	\N	\N	57540	57540	57541
14547	17701	8	applied	\N	\N	\N	\N	57542	57542	57543
14547	17702	9	applied	\N	\N	\N	\N	57544	57544	57545
14547	17703	10	applied	\N	\N	\N	\N	57546	57546	57547
14547	17704	11	applied	\N	\N	\N	\N	57548	57548	57549
14552	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14552	17706	1	applied	\N	\N	\N	\N	57555	57555	57556
14552	17707	2	applied	\N	\N	\N	\N	57557	57557	57558
14552	17708	3	applied	\N	\N	\N	\N	57559	57559	57560
14552	17709	4	applied	\N	\N	\N	\N	57561	57561	57562
14552	17710	5	applied	\N	\N	\N	\N	57563	57563	57564
14552	17711	6	applied	\N	\N	\N	\N	57565	57565	57566
14552	17712	7	applied	\N	\N	\N	\N	57567	57567	57568
14552	17713	8	applied	\N	\N	\N	\N	57569	57569	57570
14552	17714	9	applied	\N	\N	\N	\N	57571	57571	57572
14555	17715	0	applied	\N	\N	\N	\N	57576	57576	57577
14555	17716	1	applied	\N	\N	\N	\N	57578	57578	57579
14555	17717	2	applied	\N	\N	\N	\N	57580	57580	57581
14558	17718	0	applied	\N	\N	\N	\N	57589	57589	57590
14558	17719	1	applied	\N	\N	\N	\N	57591	57591	57592
14558	17720	2	applied	\N	\N	\N	\N	57593	57593	57594
14563	17726	0	applied	\N	\N	\N	\N	57612	57612	57613
14563	17727	1	applied	\N	\N	\N	\N	57614	57614	57615
14566	17726	0	applied	\N	\N	\N	\N	57612	57612	57613
14566	17727	1	applied	\N	\N	\N	\N	57614	57614	57615
14568	17733	0	applied	\N	\N	\N	\N	57631	57631	57632
14568	17734	1	applied	\N	\N	\N	\N	57633	57633	57634
14568	17735	2	applied	\N	\N	\N	\N	57635	57635	57636
14568	17736	3	applied	\N	\N	\N	\N	57637	57637	57638
14568	17737	4	applied	\N	\N	\N	\N	57639	57639	57640
14568	17738	5	applied	\N	\N	\N	\N	57641	57641	57642
14573	17739	0	applied	\N	\N	\N	\N	57649	57649	57650
14573	17740	1	applied	\N	\N	\N	\N	57651	57651	57652
14577	17743	0	applied	\N	\N	\N	\N	57665	57665	57666
14577	17744	1	applied	\N	\N	\N	\N	57667	57667	57668
14579	17745	0	applied	\N	\N	\N	\N	57671	57671	57672
14582	17747	0	applied	\N	\N	\N	\N	57677	57677	57678
14589	17754	0	applied	\N	\N	\N	\N	57704	57704	57705
14589	17755	1	applied	\N	\N	\N	\N	57706	57706	57707
14589	17756	2	applied	\N	\N	\N	\N	57708	57708	57709
14591	17757	0	applied	\N	\N	\N	\N	57715	57715	57716
14591	17758	1	applied	\N	\N	\N	\N	57717	57717	57718
14591	17759	2	applied	\N	\N	\N	\N	57719	57719	57720
14594	17763	0	applied	\N	\N	\N	\N	57729	57729	57730
14594	17764	1	applied	\N	\N	\N	\N	57731	57731	57732
14594	17765	2	applied	\N	\N	\N	\N	57733	57733	57734
14598	17766	0	applied	\N	\N	\N	\N	57743	57743	57744
14598	17767	1	applied	\N	\N	\N	\N	57745	57745	57746
14598	17768	2	applied	\N	\N	\N	\N	57747	57747	57748
14604	17772	0	applied	\N	\N	\N	\N	57763	57763	57764
14604	17773	1	applied	\N	\N	\N	\N	57765	57765	57766
14604	17774	2	applied	\N	\N	\N	\N	57767	57767	57768
14607	17778	0	applied	\N	\N	\N	\N	57778	57778	57779
14607	17779	1	applied	\N	\N	\N	\N	57780	57780	57781
14607	17780	2	applied	\N	\N	\N	\N	57782	57782	57783
14610	17781	0	applied	\N	\N	\N	\N	57788	57788	57789
14610	17782	1	applied	\N	\N	\N	\N	57790	57790	57791
14610	17783	2	applied	\N	\N	\N	\N	57792	57792	57793
14610	17784	3	applied	\N	\N	\N	\N	57794	57794	57795
14610	17785	4	applied	\N	\N	\N	\N	57796	57796	57797
14610	17786	5	applied	\N	\N	\N	\N	57798	57798	57799
14610	17787	6	applied	\N	\N	\N	\N	57800	57800	57801
14610	17788	7	applied	\N	\N	\N	\N	57802	57802	57803
14610	17789	8	applied	\N	\N	\N	\N	57804	57804	57805
14610	17790	9	applied	\N	\N	\N	\N	57806	57806	57807
14610	17791	10	applied	\N	\N	\N	\N	57808	57808	57809
14612	17794	0	applied	\N	\N	\N	\N	57819	57819	57820
14612	17795	1	applied	\N	\N	\N	\N	57821	57821	57822
14612	17796	2	applied	\N	\N	\N	\N	57823	57823	57824
14488	17021	4	applied	\N	\N	\N	\N	55486	55486	55487
14488	17327	5	applied	\N	\N	\N	\N	56535	56535	33908
14488	17346	6	applied	\N	\N	\N	\N	56589	56589	56589
14488	17072	7	applied	\N	\N	1000000000	\N	55634	55634	55635
14489	17549	0	applied	\N	\N	\N	\N	57114	57114	57115
14489	17550	1	applied	\N	\N	\N	\N	57116	57116	57117
14489	17551	2	applied	\N	\N	\N	\N	57118	57118	57119
14489	17552	3	applied	\N	\N	\N	\N	57120	57120	57121
14489	17553	4	applied	\N	\N	\N	\N	57122	57122	57123
14489	17546	5	applied	\N	\N	\N	\N	57102	57102	57103
14489	17547	6	applied	\N	\N	\N	\N	57104	57104	57105
14493	17570	0	applied	\N	\N	\N	\N	57205	57205	57206
14493	17571	1	applied	\N	\N	\N	\N	57207	57207	57208
14493	17572	2	applied	\N	\N	\N	\N	57209	57209	57210
14493	17573	3	applied	\N	\N	\N	\N	57211	57211	57212
14505	17588	0	applied	\N	\N	\N	\N	57255	57255	57256
14505	17589	1	applied	\N	\N	\N	\N	57257	57257	57258
14505	17590	2	applied	\N	\N	\N	\N	57259	57259	57260
14505	17591	3	applied	\N	\N	\N	\N	57261	57261	57262
14505	17585	4	applied	\N	\N	\N	\N	57249	57249	57250
14505	17586	5	applied	\N	\N	\N	\N	57251	57251	57252
14505	17587	6	applied	\N	\N	\N	\N	57253	57253	57254
14505	17592	7	applied	\N	\N	\N	\N	57263	57263	57264
14505	17593	8	applied	\N	\N	\N	\N	57265	57265	57266
14505	17594	9	applied	\N	\N	\N	\N	57267	57267	57268
14505	17595	10	applied	\N	\N	\N	\N	57269	57269	57270
14505	17596	11	applied	\N	\N	\N	\N	57271	57271	57272
14505	17597	12	applied	\N	\N	\N	\N	57273	57273	57274
14505	17598	13	applied	\N	\N	\N	\N	57275	57275	57276
14505	17599	14	applied	\N	\N	\N	\N	57277	57277	57278
14505	17600	15	applied	\N	\N	\N	\N	57279	57279	57280
14505	17601	16	applied	\N	\N	\N	\N	57281	57281	57282
14505	17602	17	applied	\N	\N	\N	\N	57283	57283	57284
14505	17603	18	applied	\N	\N	\N	\N	57285	57285	57286
14511	17617	0	applied	\N	\N	\N	\N	57319	57319	57320
14511	17618	1	applied	\N	\N	\N	\N	57323	57323	57324
14511	17619	2	applied	\N	\N	\N	\N	57325	57325	57326
14511	17620	3	applied	\N	\N	\N	\N	57327	57327	57328
14511	17621	4	applied	\N	\N	\N	\N	57329	57329	57330
14511	17622	5	applied	\N	\N	\N	\N	57331	57331	57332
14511	17623	6	applied	\N	\N	\N	\N	57333	57333	57334
14513	17624	0	applied	\N	\N	\N	\N	57339	57339	57340
14513	17625	1	applied	\N	\N	\N	\N	57341	57341	57342
14513	17630	2	applied	\N	\N	\N	\N	57352	57352	57353
14513	17627	3	applied	\N	\N	\N	\N	57354	57354	57355
14513	17628	4	applied	\N	\N	\N	\N	57356	57356	57350
14513	17629	5	applied	\N	\N	\N	\N	57357	57357	57358
14518	17631	0	applied	\N	\N	\N	\N	57362	57362	57363
14518	17632	1	applied	\N	\N	\N	\N	57364	57364	57365
14520	17631	0	applied	\N	\N	\N	\N	57362	57362	57363
14520	17632	1	applied	\N	\N	\N	\N	57364	57364	57365
14525	17650	0	applied	\N	\N	\N	\N	57409	57409	57410
14525	17651	1	applied	\N	\N	\N	\N	57411	57411	57412
14525	17652	2	applied	\N	\N	\N	\N	57413	57413	57414
14525	17653	3	applied	\N	\N	\N	\N	57415	57415	57416
14525	17654	4	applied	\N	\N	\N	\N	57417	57417	57418
14525	17655	5	applied	\N	\N	\N	\N	57419	57419	57420
14528	17656	0	applied	\N	\N	\N	\N	57423	57423	57424
14528	17657	1	applied	\N	\N	\N	\N	57425	57425	57426
14530	17658	0	applied	\N	\N	\N	\N	57434	57434	57435
14530	17659	1	applied	\N	\N	\N	\N	57436	57436	57437
14537	17664	0	applied	\N	\N	\N	\N	57452	57452	57453
14537	17665	1	applied	\N	\N	\N	\N	57454	57454	57455
14537	17666	2	applied	\N	\N	\N	\N	57456	57456	57457
14537	17667	3	applied	\N	\N	\N	\N	57458	57458	57459
14540	17678	0	applied	\N	\N	\N	\N	57485	57485	57486
14540	17679	1	applied	\N	\N	\N	\N	57487	57487	57488
14540	17680	2	applied	\N	\N	\N	\N	57489	57489	57490
14546	17689	0	applied	\N	\N	\N	\N	57515	57515	57516
14546	17690	1	applied	\N	\N	\N	\N	57517	57517	57518
14546	17691	2	applied	\N	\N	\N	\N	57519	57519	57520
14546	17692	3	applied	\N	\N	\N	\N	57521	57521	57522
14554	17715	0	applied	\N	\N	\N	\N	57576	57576	57577
14554	17716	1	applied	\N	\N	\N	\N	57578	57578	57579
14554	17717	2	applied	\N	\N	\N	\N	57580	57580	57581
14557	17715	0	applied	\N	\N	\N	\N	57576	57576	57577
14557	17716	1	applied	\N	\N	\N	\N	57578	57578	57579
14557	17717	2	applied	\N	\N	\N	\N	57580	57580	57581
14567	17726	0	applied	\N	\N	\N	\N	57612	57612	57613
14567	17728	1	applied	\N	\N	\N	\N	57620	57620	57621
14567	17729	2	applied	\N	\N	\N	\N	57622	57622	57623
14567	17730	3	applied	\N	\N	\N	\N	57624	57624	56868
14567	17731	4	applied	\N	\N	\N	\N	57625	57625	57626
14567	17732	5	applied	\N	\N	\N	\N	57627	57627	57628
14571	17733	0	applied	\N	\N	\N	\N	57631	57631	57632
14571	17734	1	applied	\N	\N	\N	\N	57633	57633	57634
14571	17735	2	applied	\N	\N	\N	\N	57635	57635	57636
14571	17736	3	applied	\N	\N	\N	\N	57637	57637	57638
14571	17737	4	applied	\N	\N	\N	\N	57639	57639	57640
14571	17738	5	applied	\N	\N	\N	\N	57641	57641	57642
14572	17739	0	applied	\N	\N	\N	\N	57649	57649	57650
14572	17740	1	applied	\N	\N	\N	\N	57651	57651	57652
14574	17739	0	applied	\N	\N	\N	\N	57649	57649	57650
14574	17740	1	applied	\N	\N	\N	\N	57651	57651	57652
14581	17747	0	applied	\N	\N	\N	\N	57677	57677	57678
14584	17748	0	applied	\N	\N	\N	\N	57683	57683	57684
14586	17751	0	applied	\N	\N	\N	\N	57695	57695	57696
14586	17752	1	applied	\N	\N	\N	\N	57697	57697	57698
14586	17753	2	applied	\N	\N	\N	\N	57699	57699	57700
14588	17754	0	applied	\N	\N	\N	\N	57704	57704	57705
14588	17755	1	applied	\N	\N	\N	\N	57706	57706	57707
14588	17756	2	applied	\N	\N	\N	\N	57708	57708	57709
14593	17763	0	applied	\N	\N	\N	\N	57729	57729	57730
14593	17764	1	applied	\N	\N	\N	\N	57731	57731	57732
14593	17765	2	applied	\N	\N	\N	\N	57733	57733	57734
14597	17766	0	applied	\N	\N	\N	\N	57743	57743	57744
14597	17767	1	applied	\N	\N	\N	\N	57745	57745	57746
14597	17768	2	applied	\N	\N	\N	\N	57747	57747	57748
14602	17769	0	applied	\N	\N	\N	\N	57754	57754	57755
14602	17770	1	applied	\N	\N	\N	\N	57756	57756	57757
14602	17771	2	applied	\N	\N	\N	\N	57758	57758	57759
14606	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14606	17719	1	applied	\N	\N	\N	\N	57591	57591	57592
14609	17781	0	applied	\N	\N	\N	\N	57788	57788	57789
14609	17782	1	applied	\N	\N	\N	\N	57790	57790	57791
14609	17783	2	applied	\N	\N	\N	\N	57792	57792	57793
14609	17784	3	applied	\N	\N	\N	\N	57794	57794	57795
14609	17785	4	applied	\N	\N	\N	\N	57796	57796	57797
14609	17786	5	applied	\N	\N	\N	\N	57798	57798	57799
14510	17617	0	applied	\N	\N	\N	\N	57319	57319	57320
14510	17618	1	applied	\N	\N	\N	\N	57323	57323	57324
14510	17619	2	applied	\N	\N	\N	\N	57325	57325	57326
14510	17620	3	applied	\N	\N	\N	\N	57327	57327	57328
14510	17621	4	applied	\N	\N	\N	\N	57329	57329	57330
14510	17622	5	applied	\N	\N	\N	\N	57331	57331	57332
14510	17623	6	applied	\N	\N	\N	\N	57333	57333	57334
14512	17624	0	applied	\N	\N	\N	\N	57339	57339	57340
14512	17625	1	applied	\N	\N	\N	\N	57341	57341	57342
14512	17626	2	applied	\N	\N	\N	\N	57343	57343	57344
14512	17627	3	applied	\N	\N	\N	\N	57345	57345	57346
14512	17628	4	applied	\N	\N	\N	\N	57347	57347	57348
14512	17629	5	applied	\N	\N	\N	\N	57349	57349	57350
14517	17631	0	applied	\N	\N	\N	\N	57362	57362	57363
14517	17632	1	applied	\N	\N	\N	\N	57364	57364	57365
14524	17644	0	applied	\N	\N	\N	\N	57395	57395	57396
14524	17645	1	applied	\N	\N	\N	\N	57397	57397	57398
14524	17646	2	applied	\N	\N	\N	\N	57399	57399	57400
14524	17647	3	applied	\N	\N	\N	\N	57401	57401	57402
14524	17648	4	applied	\N	\N	\N	\N	57403	57403	57404
14524	17649	5	applied	\N	\N	\N	\N	57405	57405	57406
14527	17656	0	applied	\N	\N	\N	\N	57423	57423	57424
14527	17657	1	applied	\N	\N	\N	\N	57425	57425	57426
14535	17660	0	applied	\N	\N	\N	\N	57442	57442	57443
14535	17661	1	applied	\N	\N	\N	\N	57444	57444	57445
14536	17662	0	applied	\N	\N	\N	\N	57448	57448	57449
14536	17663	1	applied	\N	\N	\N	\N	57450	57450	57451
14543	17681	0	applied	\N	\N	\N	\N	57492	57492	57493
14543	17682	1	applied	\N	\N	\N	\N	57494	57494	57495
14543	17683	2	applied	\N	\N	\N	\N	57496	57496	57497
14543	17684	3	applied	\N	\N	\N	\N	57498	57498	57499
14543	17685	4	applied	\N	\N	\N	\N	57500	57500	57501
14543	17686	5	applied	\N	\N	\N	\N	57502	57502	57503
14545	17689	0	applied	\N	\N	\N	\N	57515	57515	57516
14545	17690	1	applied	\N	\N	\N	\N	57517	57517	57518
14545	17691	2	applied	\N	\N	\N	\N	57519	57519	57520
14545	17692	3	applied	\N	\N	\N	\N	57521	57521	57522
14551	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14551	17706	1	applied	\N	\N	\N	\N	57555	57555	57556
14551	17707	2	applied	\N	\N	\N	\N	57557	57557	57558
14551	17708	3	applied	\N	\N	\N	\N	57559	57559	57560
14551	17709	4	applied	\N	\N	\N	\N	57561	57561	57562
14551	17710	5	applied	\N	\N	\N	\N	57563	57563	57564
14551	17711	6	applied	\N	\N	\N	\N	57565	57565	57566
14551	17712	7	applied	\N	\N	\N	\N	57567	57567	57568
14551	17713	8	applied	\N	\N	\N	\N	57569	57569	57570
14551	17714	9	applied	\N	\N	\N	\N	57571	57571	57572
14553	17715	0	applied	\N	\N	\N	\N	57576	57576	57577
14553	17716	1	applied	\N	\N	\N	\N	57578	57578	57579
14553	17717	2	applied	\N	\N	\N	\N	57580	57580	57581
14556	17715	0	applied	\N	\N	\N	\N	57576	57576	57577
14556	17716	1	applied	\N	\N	\N	\N	57578	57578	57579
14556	17717	2	applied	\N	\N	\N	\N	57580	57580	57581
14565	17727	0	applied	\N	\N	\N	\N	57614	57614	57615
14570	17733	0	applied	\N	\N	\N	\N	57631	57631	57632
14570	17734	1	applied	\N	\N	\N	\N	57633	57633	57634
14570	17735	2	applied	\N	\N	\N	\N	57635	57635	57636
14570	17736	3	applied	\N	\N	\N	\N	57637	57637	57638
14570	17737	4	applied	\N	\N	\N	\N	57639	57639	57640
14570	17738	5	applied	\N	\N	\N	\N	57641	57641	57642
14576	17741	0	applied	\N	\N	\N	\N	57657	57657	57658
14576	17742	1	applied	\N	\N	\N	\N	57659	57659	57660
14583	17748	0	applied	\N	\N	\N	\N	57683	57683	57684
14585	17749	0	applied	\N	\N	\N	\N	57689	57689	57690
14585	17750	1	applied	\N	\N	\N	\N	57691	57691	57692
14592	17760	0	applied	\N	\N	\N	\N	57721	57721	57722
14592	17761	1	applied	\N	\N	\N	\N	57723	57723	57724
14592	17762	2	applied	\N	\N	\N	\N	57725	57725	57726
14596	17763	0	applied	\N	\N	\N	\N	57729	57729	57730
14596	17764	1	applied	\N	\N	\N	\N	57731	57731	57732
14596	17765	2	applied	\N	\N	\N	\N	57733	57733	57734
14601	17769	0	applied	\N	\N	\N	\N	57754	57754	57755
14601	17770	1	applied	\N	\N	\N	\N	57756	57756	57757
14601	17771	2	applied	\N	\N	\N	\N	57758	57758	57759
14608	17778	0	applied	\N	\N	\N	\N	57778	57778	57779
14608	17779	1	applied	\N	\N	\N	\N	57780	57780	57781
14608	17780	2	applied	\N	\N	\N	\N	57782	57782	57783
14611	17792	0	applied	\N	\N	\N	\N	57813	57813	57814
14611	17793	1	applied	\N	\N	\N	\N	57815	57815	57816
14626	17815	0	applied	\N	\N	\N	\N	57872	57872	57873
14626	17816	1	applied	\N	\N	\N	\N	57874	57874	57875
14626	17817	2	applied	\N	\N	\N	\N	57876	57876	57877
14633	17830	0	applied	\N	\N	\N	\N	57913	57913	57914
14633	17831	1	applied	\N	\N	\N	\N	57915	57915	57916
14633	17832	2	applied	\N	\N	\N	\N	57917	57917	57918
14633	17833	3	applied	\N	\N	\N	\N	57919	57919	57920
14633	17834	4	applied	\N	\N	\N	\N	57921	57921	57922
14633	17835	5	applied	\N	\N	\N	\N	57923	57923	57924
14633	17836	6	applied	\N	\N	\N	\N	57925	57925	57926
14633	17837	7	applied	\N	\N	\N	\N	57927	57927	57928
14633	17838	8	applied	\N	\N	\N	\N	57929	57929	57930
14641	17845	0	applied	\N	\N	\N	\N	57952	57952	57953
14641	17846	1	applied	\N	\N	\N	\N	57954	57954	57955
14646	17864	0	applied	\N	\N	\N	\N	57999	57999	58000
14646	17865	1	applied	\N	\N	\N	\N	58001	58001	58002
14646	17866	2	applied	\N	\N	\N	\N	58003	58003	58004
14651	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14651	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14651	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14654	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14654	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14654	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14661	17879	0	applied	\N	\N	\N	\N	58049	58049	58050
14661	17880	1	applied	\N	\N	\N	\N	58051	58051	58052
14661	17881	2	applied	\N	\N	\N	\N	58053	58053	58054
14661	17882	3	applied	\N	\N	\N	\N	58055	58055	58056
14661	17883	4	applied	\N	\N	\N	\N	58057	58057	58058
14665	17887	0	applied	\N	\N	\N	\N	58073	58073	58074
14665	17888	1	applied	\N	\N	\N	\N	58075	58075	58076
14665	17889	2	applied	\N	\N	\N	\N	58077	58077	58078
14665	17890	3	applied	\N	\N	\N	\N	58079	58079	58080
14665	17891	4	applied	\N	\N	\N	\N	58081	58081	58082
14665	17892	5	applied	\N	\N	\N	\N	58083	58083	58084
14668	17925	0	applied	\N	\N	\N	\N	58154	58154	58155
14668	17926	1	applied	\N	\N	\N	\N	58156	58156	58157
14668	17927	2	applied	\N	\N	\N	\N	58158	58158	58159
14668	17928	3	applied	\N	\N	\N	\N	58160	58160	58161
14668	17929	4	applied	\N	\N	\N	\N	58162	58162	58163
14668	17930	5	applied	\N	\N	\N	\N	58164	58164	58165
14668	17931	6	applied	\N	\N	\N	\N	58166	58166	58167
14542	17681	0	applied	\N	\N	\N	\N	57492	57492	57493
14542	17682	1	applied	\N	\N	\N	\N	57494	57494	57495
14542	17683	2	applied	\N	\N	\N	\N	57496	57496	57497
14542	17684	3	applied	\N	\N	\N	\N	57498	57498	57499
14542	17685	4	applied	\N	\N	\N	\N	57500	57500	57501
14542	17686	5	applied	\N	\N	\N	\N	57502	57502	57503
14544	17687	0	applied	\N	\N	\N	\N	57509	57509	57510
14544	17688	1	applied	\N	\N	\N	\N	57511	57511	57512
14548	17693	0	applied	\N	\N	\N	\N	57526	57526	57527
14548	17694	1	applied	\N	\N	\N	\N	57528	57528	57529
14548	17695	2	applied	\N	\N	\N	\N	57530	57530	57531
14548	17696	3	applied	\N	\N	\N	\N	57532	57532	57533
14548	17697	4	applied	\N	\N	\N	\N	57534	57534	57535
14548	17698	5	applied	\N	\N	\N	\N	57536	57536	57537
14548	17699	6	applied	\N	\N	\N	\N	57538	57538	57539
14548	17700	7	applied	\N	\N	\N	\N	57540	57540	57541
14548	17701	8	applied	\N	\N	\N	\N	57542	57542	57543
14548	17702	9	applied	\N	\N	\N	\N	57544	57544	57545
14548	17703	10	applied	\N	\N	\N	\N	57546	57546	57547
14548	17704	11	applied	\N	\N	\N	\N	57548	57548	57549
14550	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14550	17706	1	applied	\N	\N	\N	\N	57555	57555	57556
14550	17707	2	applied	\N	\N	\N	\N	57557	57557	57558
14550	17708	3	applied	\N	\N	\N	\N	57559	57559	57560
14550	17709	4	applied	\N	\N	\N	\N	57561	57561	57562
14550	17710	5	applied	\N	\N	\N	\N	57563	57563	57564
14550	17711	6	applied	\N	\N	\N	\N	57565	57565	57566
14550	17712	7	applied	\N	\N	\N	\N	57567	57567	57568
14550	17713	8	applied	\N	\N	\N	\N	57569	57569	57570
14550	17714	9	applied	\N	\N	\N	\N	57571	57571	57572
14559	17721	0	applied	\N	\N	\N	\N	57596	57596	57597
14559	17722	1	applied	\N	\N	\N	\N	57598	57598	57599
14559	17723	2	applied	\N	\N	\N	\N	57600	57600	57601
14561	17724	0	applied	\N	\N	\N	\N	57603	57603	57604
14561	17725	1	applied	\N	\N	\N	\N	57605	57605	57606
14562	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14562	17499	1	applied	\N	\N	\N	\N	56989	56989	56990
14562	17502	2	applied	\N	\N	\N	\N	56997	56997	56998
14562	17506	3	applied	\N	\N	\N	\N	57005	57005	57006
14562	17507	4	applied	\N	\N	\N	\N	57007	57007	57008
14562	17508	5	applied	\N	\N	\N	\N	57009	57009	57010
14562	17509	6	applied	\N	\N	\N	\N	57011	57011	57012
14562	17521	7	applied	\N	\N	\N	\N	57042	57042	57043
14562	17522	8	applied	\N	\N	\N	\N	57044	57044	57045
14562	17529	9	applied	\N	\N	\N	\N	57062	57062	57063
14562	17530	10	applied	\N	\N	\N	\N	57064	57064	57065
14562	17531	11	applied	\N	\N	\N	\N	57066	57066	57067
14562	17541	12	applied	\N	\N	\N	\N	57087	57087	57088
14562	17545	13	applied	\N	\N	\N	\N	57099	57099	57100
14562	17549	14	applied	\N	\N	\N	\N	57114	57114	57115
14562	17550	15	applied	\N	\N	\N	\N	57116	57116	57117
14562	17551	16	applied	\N	\N	\N	\N	57118	57118	57119
14562	17552	17	applied	\N	\N	\N	\N	57120	57120	57121
14562	17553	18	applied	\N	\N	\N	\N	57122	57122	57123
14562	17554	19	applied	\N	\N	\N	\N	57125	57125	57126
14562	17570	20	applied	\N	\N	\N	\N	57205	57205	57206
14562	17574	21	applied	\N	\N	\N	\N	57219	57219	57220
14562	17577	22	applied	\N	\N	\N	\N	57228	57228	57229
14562	17578	23	applied	\N	\N	\N	\N	57230	57230	57231
14562	17584	24	applied	\N	\N	\N	\N	57246	57246	57247
14562	17588	26	applied	\N	\N	\N	\N	57255	57255	57256
14562	17589	27	applied	\N	\N	\N	\N	57257	57257	57258
14562	17590	28	applied	\N	\N	\N	\N	57259	57259	57260
14562	17591	29	applied	\N	\N	\N	\N	57261	57261	57262
14562	17604	30	applied	\N	\N	\N	\N	57288	57288	57289
14562	17605	31	applied	\N	\N	\N	\N	57290	57290	57291
14562	17612	32	applied	\N	\N	\N	\N	57306	57306	57307
14562	17613	33	applied	\N	\N	\N	\N	57308	57308	57309
14562	17617	34	applied	\N	\N	\N	\N	57319	57319	57320
14562	17624	35	applied	\N	\N	\N	\N	57339	57339	57340
14562	17625	36	applied	\N	\N	\N	\N	57341	57341	57342
14562	17631	37	applied	\N	\N	\N	\N	57362	57362	57363
14562	17633	38	applied	\N	\N	\N	\N	57370	57370	57371
14562	17634	39	applied	\N	\N	\N	\N	57372	57372	57373
14562	17639	40	applied	\N	\N	\N	\N	57383	57383	57384
14562	17642	41	applied	\N	\N	\N	\N	57391	57391	57392
14562	17644	42	applied	\N	\N	\N	\N	57395	57395	57396
14562	17645	43	applied	\N	\N	\N	\N	57397	57397	57398
14562	17650	44	applied	\N	\N	\N	\N	57409	57409	57410
14562	17651	45	applied	\N	\N	\N	\N	57411	57411	57412
14562	17656	46	applied	\N	\N	\N	\N	57423	57423	57424
14562	17658	47	applied	\N	\N	\N	\N	57434	57434	57435
14562	17660	48	applied	\N	\N	\N	\N	57442	57442	57443
14562	17662	49	applied	\N	\N	\N	\N	57448	57448	57449
14562	17664	50	applied	\N	\N	\N	\N	57452	57452	57453
14562	17665	51	applied	\N	\N	\N	\N	57454	57454	57455
14562	17668	52	applied	\N	\N	\N	\N	57462	57462	57463
14562	17669	53	applied	\N	\N	\N	\N	57464	57464	57465
14562	17672	54	applied	\N	\N	\N	\N	57472	57472	57473
14562	17673	55	applied	\N	\N	\N	\N	57474	57474	57475
14562	17678	56	applied	\N	\N	\N	\N	57485	57485	57486
14562	17681	57	applied	\N	\N	\N	\N	57492	57492	57493
14562	17682	58	applied	\N	\N	\N	\N	57494	57494	57495
14562	17687	59	applied	\N	\N	\N	\N	57509	57509	57510
14562	17689	60	applied	\N	\N	\N	\N	57515	57515	57516
14562	17690	61	applied	\N	\N	\N	\N	57517	57517	57518
14562	17693	62	applied	\N	\N	\N	\N	57526	57526	57527
14562	17694	63	applied	\N	\N	\N	\N	57528	57528	57529
14562	17695	64	applied	\N	\N	\N	\N	57530	57530	57531
14562	17696	65	applied	\N	\N	\N	\N	57532	57532	57533
14562	17706	66	applied	\N	\N	\N	\N	57555	57555	57556
14562	17707	67	applied	\N	\N	\N	\N	57557	57557	57558
14562	17708	68	applied	\N	\N	\N	\N	57559	57559	57560
14562	17715	69	applied	\N	\N	\N	\N	57576	57576	57577
14562	17718	70	applied	\N	\N	\N	\N	57589	57589	57590
14562	17721	71	applied	\N	\N	\N	\N	57596	57596	57597
14562	17724	72	applied	\N	\N	\N	\N	57603	57603	57604
14562	17719	73	applied	\N	\N	\N	\N	57591	57591	57592
14562	17500	74	applied	\N	\N	\N	\N	56991	56991	56992
14562	17501	75	applied	\N	\N	\N	\N	56993	56993	56994
14562	17503	76	applied	\N	\N	\N	\N	56999	56999	57000
14562	17504	77	applied	\N	\N	\N	\N	57001	57001	57002
14562	17505	78	applied	\N	\N	\N	\N	57003	57003	57004
14562	17510	79	applied	\N	\N	\N	\N	57013	57013	57014
14562	17511	80	applied	\N	\N	\N	\N	57015	57015	57016
14562	17512	81	applied	\N	\N	\N	\N	57017	57017	57018
14562	17513	82	applied	\N	\N	\N	\N	57019	57019	57020
14562	17514	83	applied	\N	\N	\N	\N	57021	57021	57022
14562	17515	84	applied	\N	\N	\N	\N	57023	57023	57024
14562	17516	85	applied	\N	\N	\N	\N	57026	57026	57027
14562	17517	86	applied	\N	\N	\N	\N	57028	57028	57029
14562	17518	87	applied	\N	\N	\N	\N	57030	57030	57031
14562	17519	88	applied	\N	\N	\N	\N	57032	57032	57033
14562	17520	89	applied	\N	\N	\N	\N	57034	57034	57035
14562	17523	90	applied	\N	\N	\N	\N	57046	57046	57047
14562	17524	91	applied	\N	\N	\N	\N	57048	57048	57049
14562	17525	92	applied	\N	\N	\N	\N	57050	57050	57051
14562	17526	93	applied	\N	\N	\N	\N	57052	57052	57053
14562	17527	94	applied	\N	\N	\N	\N	57054	57054	57055
14562	17528	95	applied	\N	\N	\N	\N	57056	57056	57057
14562	17532	96	applied	\N	\N	\N	\N	57068	57068	57069
14562	17533	97	applied	\N	\N	\N	\N	57070	57070	57071
14562	17534	98	applied	\N	\N	\N	\N	57072	57072	57073
14562	17535	99	applied	\N	\N	\N	\N	57074	57074	57075
14562	17536	100	applied	\N	\N	\N	\N	57076	57076	57077
14562	17537	101	applied	\N	\N	\N	\N	57078	57078	57079
14562	17538	102	applied	\N	\N	\N	\N	57080	57080	57081
14562	17539	103	applied	\N	\N	\N	\N	57082	57082	57083
14562	17540	104	applied	\N	\N	\N	\N	57084	57084	57085
14562	17542	105	applied	\N	\N	\N	\N	57089	57089	57090
14562	17543	106	applied	\N	\N	\N	\N	57091	57091	57092
14562	17544	107	applied	\N	\N	\N	\N	57093	57093	57094
14562	17546	108	applied	\N	\N	\N	\N	57102	57102	57103
14562	17547	109	applied	\N	\N	\N	\N	57104	57104	57105
14562	17548	110	applied	\N	\N	\N	\N	57106	57106	57107
14562	17555	111	applied	\N	\N	\N	\N	57127	57127	57128
14562	17556	112	applied	\N	\N	\N	\N	57129	57129	57130
14562	17557	113	applied	\N	\N	\N	\N	57131	57131	57132
14562	17558	114	applied	\N	\N	\N	\N	57133	57133	57134
14562	17559	115	applied	\N	\N	\N	\N	57135	57135	57136
14562	17560	116	applied	\N	\N	\N	\N	57137	57137	57138
14562	17561	117	applied	\N	\N	\N	\N	57139	57139	57140
14562	17562	118	applied	\N	\N	\N	\N	57141	57141	57142
14562	17563	119	applied	\N	\N	\N	\N	57143	57143	57144
14562	17564	120	applied	\N	\N	\N	\N	57145	57145	57146
14562	17565	121	applied	\N	\N	\N	\N	57147	57147	57148
14562	17566	122	applied	\N	\N	\N	\N	57149	57149	57150
14562	17567	123	applied	\N	\N	\N	\N	57151	57151	57152
14562	17568	124	applied	\N	\N	\N	\N	57153	57153	57154
14562	17569	125	applied	\N	\N	\N	\N	57155	57155	57156
14564	17726	0	applied	\N	\N	\N	\N	57612	57612	57613
14564	17727	1	applied	\N	\N	\N	\N	57614	57614	57615
14569	17733	0	applied	\N	\N	\N	\N	57631	57631	57632
14569	17734	1	applied	\N	\N	\N	\N	57633	57633	57634
14569	17735	2	applied	\N	\N	\N	\N	57635	57635	57636
14569	17736	3	applied	\N	\N	\N	\N	57637	57637	57638
14569	17737	4	applied	\N	\N	\N	\N	57639	57639	57640
14569	17738	5	applied	\N	\N	\N	\N	57641	57641	57642
14575	17741	0	applied	\N	\N	\N	\N	57657	57657	57658
14575	17742	1	applied	\N	\N	\N	\N	57659	57659	57660
14578	17743	0	applied	\N	\N	\N	\N	57665	57665	57666
14578	17744	1	applied	\N	\N	\N	\N	57667	57667	57668
14580	17746	0	applied	\N	\N	\N	\N	57674	57674	57675
14587	17751	0	applied	\N	\N	\N	\N	57695	57695	57696
14587	17752	1	applied	\N	\N	\N	\N	57697	57697	57698
14587	17753	2	applied	\N	\N	\N	\N	57699	57699	57700
14590	17754	0	applied	\N	\N	\N	\N	57704	57704	57705
14590	17755	1	applied	\N	\N	\N	\N	57706	57706	57707
14590	17756	2	applied	\N	\N	\N	\N	57708	57708	57709
14595	17763	0	applied	\N	\N	\N	\N	57729	57729	57730
14595	17764	1	applied	\N	\N	\N	\N	57731	57731	57732
14595	17765	2	applied	\N	\N	\N	\N	57733	57733	57734
14600	17766	0	applied	\N	\N	\N	\N	57743	57743	57744
14600	17767	1	applied	\N	\N	\N	\N	57745	57745	57746
14600	17768	2	applied	\N	\N	\N	\N	57747	57747	57748
14603	17769	0	applied	\N	\N	\N	\N	57754	57754	57755
14603	17770	1	applied	\N	\N	\N	\N	57756	57756	57757
14603	17771	2	applied	\N	\N	\N	\N	57758	57758	57759
14605	17775	0	applied	\N	\N	\N	\N	57770	57770	57771
14605	17776	1	applied	\N	\N	\N	\N	57772	57772	57773
14605	17777	2	applied	\N	\N	\N	\N	57774	57774	57775
14613	17794	0	applied	\N	\N	\N	\N	57819	57819	57820
14613	17795	1	applied	\N	\N	\N	\N	57821	57821	57822
14613	17796	2	applied	\N	\N	\N	\N	57823	57823	57824
14618	17809	0	applied	\N	\N	\N	\N	57856	57856	57857
14618	17810	1	applied	\N	\N	\N	\N	57858	57858	57859
14618	17811	2	applied	\N	\N	\N	\N	57860	57860	57861
14625	17815	0	applied	\N	\N	\N	\N	57872	57872	57873
14625	17816	1	applied	\N	\N	\N	\N	57874	57874	57875
14625	17817	2	applied	\N	\N	\N	\N	57876	57876	57877
14627	17818	0	applied	\N	\N	\N	\N	57884	57884	57885
14627	17819	1	applied	\N	\N	\N	\N	57886	57886	57887
14627	17820	2	applied	\N	\N	\N	\N	57888	57888	57889
14627	17821	3	applied	\N	\N	\N	\N	57890	57890	57891
14627	17822	4	applied	\N	\N	\N	\N	57892	57892	57893
14627	17823	5	applied	\N	\N	\N	\N	57894	57894	57895
14630	17827	0	applied	\N	\N	\N	\N	57904	57904	57905
14630	17828	1	applied	\N	\N	\N	\N	57906	57906	57907
14630	17829	2	applied	\N	\N	\N	\N	57908	57908	57909
14632	17830	0	applied	\N	\N	\N	\N	57913	57913	57914
14632	17831	1	applied	\N	\N	\N	\N	57915	57915	57916
14632	17832	2	applied	\N	\N	\N	\N	57917	57917	57918
14632	17833	3	applied	\N	\N	\N	\N	57919	57919	57920
14632	17834	4	applied	\N	\N	\N	\N	57921	57921	57922
14632	17835	5	applied	\N	\N	\N	\N	57923	57923	57924
14632	17836	6	applied	\N	\N	\N	\N	57925	57925	57926
14632	17837	7	applied	\N	\N	\N	\N	57927	57927	57928
14632	17838	8	applied	\N	\N	\N	\N	57929	57929	57930
14638	17839	0	applied	\N	\N	\N	\N	57934	57934	57935
14638	17840	1	applied	\N	\N	\N	\N	57936	57936	57937
14638	17841	2	applied	\N	\N	\N	\N	57938	57938	57939
14638	17842	3	applied	\N	\N	\N	\N	57940	57940	57941
14638	17843	4	applied	\N	\N	\N	\N	57942	57942	57943
14638	17844	5	applied	\N	\N	\N	\N	57944	57944	57945
14640	17845	0	applied	\N	\N	\N	\N	57952	57952	57953
14640	17846	1	applied	\N	\N	\N	\N	57954	57954	57955
14642	17400	0	applied	\N	\N	\N	\N	56737	56737	47675
14642	17705	1	applied	\N	\N	1000000000	\N	57553	57553	57554
14642	17380	2	applied	\N	\N	\N	\N	56692	56692	56693
14642	17381	3	applied	\N	\N	\N	\N	56694	56694	56695
14642	17388	4	applied	\N	\N	\N	\N	56711	56711	56712
14642	17389	5	applied	\N	\N	\N	\N	56714	56714	56715
14642	17390	6	applied	\N	\N	\N	\N	56716	56716	56717
14642	17401	7	applied	\N	\N	\N	\N	56738	56738	56739
14642	17405	8	applied	\N	\N	\N	\N	56749	56749	56750
14642	17406	9	applied	\N	\N	\N	\N	56751	56751	56752
14642	17412	10	applied	\N	\N	\N	\N	56765	56765	56766
14642	17415	11	applied	\N	\N	\N	\N	56774	56774	56775
14642	17419	12	applied	\N	\N	\N	\N	56782	56782	56783
14609	17787	6	applied	\N	\N	\N	\N	57800	57800	57801
14609	17788	7	applied	\N	\N	\N	\N	57802	57802	57803
14609	17789	8	applied	\N	\N	\N	\N	57804	57804	57805
14609	17790	9	applied	\N	\N	\N	\N	57806	57806	57807
14609	17791	10	applied	\N	\N	\N	\N	57808	57808	57809
14614	17794	0	applied	\N	\N	\N	\N	57819	57819	57820
14614	17795	1	applied	\N	\N	\N	\N	57821	57821	57822
14614	17796	2	applied	\N	\N	\N	\N	57823	57823	57824
14616	17797	0	applied	\N	\N	\N	\N	57828	57828	57829
14616	17798	1	applied	\N	\N	\N	\N	57830	57830	57831
14616	17799	2	applied	\N	\N	\N	\N	57832	57832	57833
14620	17809	0	applied	\N	\N	\N	\N	57856	57856	57857
14620	17810	1	applied	\N	\N	\N	\N	57858	57858	57859
14620	17811	2	applied	\N	\N	\N	\N	57860	57860	57861
14622	17809	0	applied	\N	\N	\N	\N	57856	57856	57857
14622	17810	1	applied	\N	\N	\N	\N	57858	57858	57859
14622	17811	2	applied	\N	\N	\N	\N	57860	57860	57861
14623	17812	0	applied	\N	\N	\N	\N	57866	57866	57867
14623	17813	1	applied	\N	\N	\N	\N	57868	57868	57869
14623	17814	2	applied	\N	\N	\N	\N	57870	57870	57871
14628	17824	0	applied	\N	\N	\N	\N	57897	57897	57898
14628	17825	1	applied	\N	\N	\N	\N	57899	57899	57900
14628	17826	2	applied	\N	\N	\N	\N	57901	57901	57902
14631	17827	0	applied	\N	\N	\N	\N	57904	57904	57905
14631	17828	1	applied	\N	\N	\N	\N	57906	57906	57907
14631	17829	2	applied	\N	\N	\N	\N	57908	57908	57909
14636	17839	0	applied	\N	\N	\N	\N	57934	57934	57935
14636	17840	1	applied	\N	\N	\N	\N	57936	57936	57937
14636	17841	2	applied	\N	\N	\N	\N	57938	57938	57939
14636	17842	3	applied	\N	\N	\N	\N	57940	57940	57941
14636	17843	4	applied	\N	\N	\N	\N	57942	57942	57943
14636	17844	5	applied	\N	\N	\N	\N	57944	57944	57945
14644	17849	0	applied	\N	\N	\N	\N	57967	57967	57968
14644	17850	1	applied	\N	\N	\N	\N	57969	57969	57970
14644	17851	2	applied	\N	\N	\N	\N	57971	57971	57972
14644	17852	3	applied	\N	\N	\N	\N	57973	57973	57974
14644	17853	4	applied	\N	\N	\N	\N	57975	57975	57976
14644	17854	5	applied	\N	\N	\N	\N	57977	57977	57978
14644	17855	6	applied	\N	\N	\N	\N	57979	57979	57980
14644	17856	7	applied	\N	\N	\N	\N	57981	57981	57982
14644	17857	8	applied	\N	\N	\N	\N	57983	57983	57984
14644	17858	9	applied	\N	\N	\N	\N	57985	57985	57986
14644	17859	10	applied	\N	\N	\N	\N	57987	57987	57988
14644	17860	11	applied	\N	\N	\N	\N	57989	57989	57990
14647	17864	0	applied	\N	\N	\N	\N	57999	57999	58000
14647	17865	1	applied	\N	\N	\N	\N	58001	58001	58002
14647	17866	2	applied	\N	\N	\N	\N	58003	58003	58004
14649	17867	0	applied	\N	\N	\N	\N	58010	58010	58011
14649	17868	1	applied	\N	\N	\N	\N	58012	58012	58013
14649	17869	2	applied	\N	\N	\N	\N	58014	58014	58015
14649	17870	3	applied	\N	\N	\N	\N	58016	58016	58017
14649	17871	4	applied	\N	\N	\N	\N	58018	58018	58019
14649	17872	6	applied	\N	\N	\N	\N	58021	58021	58022
14652	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14652	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14652	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14659	17876	0	applied	\N	\N	\N	\N	58042	58042	58043
14659	17877	1	applied	\N	\N	\N	\N	58044	58044	58045
14659	17878	2	applied	\N	\N	\N	\N	58046	58046	58047
14663	17884	0	applied	\N	\N	\N	\N	58065	58065	58066
14663	17885	1	applied	\N	\N	\N	\N	58067	58067	58068
14663	17886	2	applied	\N	\N	\N	\N	58069	58069	58070
14675	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14675	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14675	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14675	17944	3	applied	\N	\N	\N	\N	58201	58201	58202
14675	17945	4	applied	\N	\N	\N	\N	58203	58203	58204
14675	17946	5	applied	\N	\N	\N	\N	58205	58205	58206
14675	17947	6	applied	\N	\N	\N	\N	58207	58207	58208
14675	17948	7	applied	\N	\N	\N	\N	58209	58209	58210
14675	17949	8	applied	\N	\N	\N	\N	58211	58211	58212
14675	17950	9	applied	\N	\N	\N	\N	58213	58213	58214
14675	17951	10	applied	\N	\N	\N	\N	58215	58215	58216
14675	17952	11	applied	\N	\N	\N	\N	58217	58217	58218
14675	17953	12	applied	\N	\N	\N	\N	58219	58219	58220
14675	17954	13	applied	\N	\N	\N	\N	58221	58221	58222
14675	17955	14	applied	\N	\N	\N	\N	58223	58223	58224
14675	17956	15	applied	\N	\N	\N	\N	58225	58225	58226
14675	17957	16	applied	\N	\N	\N	\N	58227	58227	58228
14675	17958	17	applied	\N	\N	\N	\N	58229	58229	58230
14675	17959	18	applied	\N	\N	\N	\N	58231	58231	58232
14675	17960	19	applied	\N	\N	\N	\N	58233	58233	58234
14675	17961	20	applied	\N	\N	\N	\N	58235	58235	58236
14675	17962	21	applied	\N	\N	\N	\N	58237	58237	58238
14675	17963	22	applied	\N	\N	\N	\N	58239	58239	58240
14675	17964	23	applied	\N	\N	\N	\N	58241	58241	58242
14678	17965	0	applied	\N	\N	\N	\N	58250	58250	58251
14678	17966	1	applied	\N	\N	\N	\N	58252	58252	58253
14678	17967	2	applied	\N	\N	\N	\N	58254	58254	58255
14678	17968	3	applied	\N	\N	\N	\N	58256	58256	58257
14678	17969	4	applied	\N	\N	\N	\N	58258	58258	58259
14678	17970	5	applied	\N	\N	\N	\N	58260	58260	58261
14678	17971	6	applied	\N	\N	\N	\N	58262	58262	58263
14678	17972	7	applied	\N	\N	\N	\N	58264	58264	58265
14678	17973	8	applied	\N	\N	\N	\N	58266	58266	58267
14678	17974	9	applied	\N	\N	\N	\N	58268	58268	58269
14678	17975	10	applied	\N	\N	\N	\N	58270	58270	58271
14678	17976	11	applied	\N	\N	\N	\N	58272	58272	58273
14678	17977	13	applied	\N	\N	\N	\N	58275	58275	58276
14678	17978	14	applied	\N	\N	\N	\N	58277	58277	58278
14678	17979	15	applied	\N	\N	\N	\N	58279	58279	58280
14678	17980	16	applied	\N	\N	\N	\N	58281	58281	58282
14679	17981	0	applied	\N	\N	\N	\N	58285	58285	58286
14679	17982	1	applied	\N	\N	\N	\N	58287	58287	58288
14679	17983	2	applied	\N	\N	\N	\N	58289	58289	58290
14679	17984	3	applied	\N	\N	\N	\N	58291	58291	58292
14679	17985	4	applied	\N	\N	\N	\N	58293	58293	58294
14679	17986	5	applied	\N	\N	\N	\N	58295	58295	58296
14679	17987	6	applied	\N	\N	\N	\N	58297	58297	58298
14679	17988	7	applied	\N	\N	\N	\N	58299	58299	58300
14679	17989	8	applied	\N	\N	\N	\N	58301	58301	58302
14679	17990	9	applied	\N	\N	\N	\N	58303	58303	58304
14679	17991	10	applied	\N	\N	\N	\N	58305	58305	58306
14679	17992	11	applied	\N	\N	\N	\N	58307	58307	58308
14679	17993	12	applied	\N	\N	\N	\N	58309	58309	58310
14679	17994	13	applied	\N	\N	\N	\N	58311	58311	58312
14679	17995	14	applied	\N	\N	\N	\N	58313	58313	58314
14679	17996	15	applied	\N	\N	\N	\N	58315	58315	58316
14679	17997	16	applied	\N	\N	\N	\N	58317	58317	58318
14679	17998	17	applied	\N	\N	\N	\N	58319	58319	58320
14615	17794	0	applied	\N	\N	\N	\N	57819	57819	57820
14615	17795	1	applied	\N	\N	\N	\N	57821	57821	57822
14615	17796	2	applied	\N	\N	\N	\N	57823	57823	57824
14617	17800	0	applied	\N	\N	\N	\N	57836	57836	57837
14617	17801	1	applied	\N	\N	\N	\N	57838	57838	57839
14617	17802	2	applied	\N	\N	\N	\N	57840	57840	57841
14617	17803	3	applied	\N	\N	\N	\N	57842	57842	57843
14617	17804	4	applied	\N	\N	\N	\N	57844	57844	57845
14617	17805	5	applied	\N	\N	\N	\N	57846	57846	57847
14617	17806	6	applied	\N	\N	\N	\N	57848	57848	57849
14617	17807	7	applied	\N	\N	\N	\N	57850	57850	57851
14617	17808	8	applied	\N	\N	\N	\N	57852	57852	57853
14621	17809	0	applied	\N	\N	\N	\N	57856	57856	57857
14621	17810	1	applied	\N	\N	\N	\N	57858	57858	57859
14621	17811	2	applied	\N	\N	\N	\N	57860	57860	57861
14624	17815	0	applied	\N	\N	\N	\N	57872	57872	57873
14624	17816	1	applied	\N	\N	\N	\N	57874	57874	57875
14624	17817	2	applied	\N	\N	\N	\N	57876	57876	57877
14629	17827	0	applied	\N	\N	\N	\N	57904	57904	57905
14629	17828	1	applied	\N	\N	\N	\N	57906	57906	57907
14629	17829	2	applied	\N	\N	\N	\N	57908	57908	57909
14637	17839	0	applied	\N	\N	\N	\N	57934	57934	57935
14637	17840	1	applied	\N	\N	\N	\N	57936	57936	57937
14637	17841	2	applied	\N	\N	\N	\N	57938	57938	57939
14637	17842	3	applied	\N	\N	\N	\N	57940	57940	57941
14637	17843	4	applied	\N	\N	\N	\N	57942	57942	57943
14637	17844	5	applied	\N	\N	\N	\N	57944	57944	57945
14639	17845	0	applied	\N	\N	\N	\N	57952	57952	57953
14639	17846	1	applied	\N	\N	\N	\N	57954	57954	57955
14643	17847	0	applied	\N	\N	\N	\N	57962	57962	57963
14643	17848	1	applied	\N	\N	\N	\N	57964	57964	57965
14653	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14653	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14653	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14656	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14656	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14656	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14657	17876	0	applied	\N	\N	\N	\N	58042	58042	58043
14657	17877	1	applied	\N	\N	\N	\N	58044	58044	58045
14657	17878	2	applied	\N	\N	\N	\N	58046	58046	58047
14662	17879	0	applied	\N	\N	\N	\N	58049	58049	58050
14662	17880	1	applied	\N	\N	\N	\N	58051	58051	58052
14662	17881	2	applied	\N	\N	\N	\N	58053	58053	58054
14662	17882	3	applied	\N	\N	\N	\N	58055	58055	58056
14662	17883	4	applied	\N	\N	\N	\N	58057	58057	58058
14664	17884	0	applied	\N	\N	\N	\N	58065	58065	58066
14664	17885	1	applied	\N	\N	\N	\N	58067	58067	58068
14664	17886	2	applied	\N	\N	\N	\N	58069	58069	58070
14666	17893	0	applied	\N	\N	\N	\N	58086	58086	58087
14666	17894	1	applied	\N	\N	\N	\N	58088	58088	58089
14666	17895	2	applied	\N	\N	\N	\N	58090	58090	58091
14666	17896	3	applied	\N	\N	\N	\N	58092	58092	58093
14666	17897	4	applied	\N	\N	\N	\N	58094	58094	58095
14666	17898	5	applied	\N	\N	\N	\N	58096	58096	58097
14666	17899	6	applied	\N	\N	\N	\N	58098	58098	58099
14666	17900	7	applied	\N	\N	\N	\N	58100	58100	58101
14667	17901	0	applied	\N	\N	\N	\N	58104	58104	58105
14667	17902	1	applied	\N	\N	\N	\N	58106	58106	58107
14667	17903	2	applied	\N	\N	\N	\N	58108	58108	58109
14667	17904	3	applied	\N	\N	\N	\N	58110	58110	58111
14667	17905	4	applied	\N	\N	\N	\N	58112	58112	58113
14667	17906	5	applied	\N	\N	\N	\N	58114	58114	58115
14667	17907	6	applied	\N	\N	\N	\N	58116	58116	58117
14667	17908	7	applied	\N	\N	\N	\N	58118	58118	58119
14667	17909	8	applied	\N	\N	\N	\N	58120	58120	58121
14667	17910	9	applied	\N	\N	\N	\N	58122	58122	58123
14667	17911	10	applied	\N	\N	\N	\N	58124	58124	58125
14667	17912	11	applied	\N	\N	\N	\N	58126	58126	58127
14667	17913	12	applied	\N	\N	\N	\N	58128	58128	58129
14667	17914	13	applied	\N	\N	\N	\N	58130	58130	58131
14667	17915	14	applied	\N	\N	\N	\N	58132	58132	58133
14667	17916	15	applied	\N	\N	\N	\N	58134	58134	58135
14667	17917	16	applied	\N	\N	\N	\N	58136	58136	58137
14667	17918	17	applied	\N	\N	\N	\N	58138	58138	58139
14667	17919	18	applied	\N	\N	\N	\N	58140	58140	58141
14667	17920	19	applied	\N	\N	\N	\N	58142	58142	58143
14667	17921	20	applied	\N	\N	\N	\N	58144	58144	58145
14667	17922	21	applied	\N	\N	\N	\N	58146	58146	58147
14667	17923	22	applied	\N	\N	\N	\N	58148	58148	58149
14667	17924	23	applied	\N	\N	\N	\N	58150	58150	58151
14669	17925	0	applied	\N	\N	\N	\N	58154	58154	58155
14669	17926	1	applied	\N	\N	\N	\N	58156	58156	58157
14669	17927	2	applied	\N	\N	\N	\N	58158	58158	58159
14669	17928	3	applied	\N	\N	\N	\N	58160	58160	58161
14669	17929	4	applied	\N	\N	\N	\N	58162	58162	58163
14669	17930	5	applied	\N	\N	\N	\N	58164	58164	58165
14669	17931	6	applied	\N	\N	\N	\N	58166	58166	58167
14672	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14672	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14672	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14680	17887	0	applied	\N	\N	\N	\N	58338	58338	58074
14680	17889	1	applied	\N	\N	\N	\N	58339	58339	58078
14680	17890	2	applied	\N	\N	\N	\N	58340	58340	58080
14680	17891	3	applied	\N	\N	\N	\N	58341	58341	58082
14680	17893	4	applied	\N	\N	\N	\N	58342	58342	58087
14680	17895	5	applied	\N	\N	\N	\N	58343	58343	58091
14680	17896	6	applied	\N	\N	\N	\N	58344	58344	58093
14680	17897	7	applied	\N	\N	\N	\N	58345	58345	58095
14680	17898	8	applied	\N	\N	\N	\N	58346	58346	58097
14680	17899	9	applied	\N	\N	\N	\N	58347	58347	58099
14680	17901	10	applied	\N	\N	\N	\N	58348	58348	58105
14680	17905	11	applied	\N	\N	\N	\N	58349	58349	58113
14680	17906	12	applied	\N	\N	\N	\N	58350	58350	58115
14680	17907	13	applied	\N	\N	\N	\N	58351	58351	58117
14680	17908	14	applied	\N	\N	\N	\N	58352	58352	58119
14680	17909	15	applied	\N	\N	\N	\N	58353	58353	58121
14680	17910	16	applied	\N	\N	\N	\N	58354	58354	58123
14680	17911	17	applied	\N	\N	\N	\N	58355	58355	58125
14680	17912	18	applied	\N	\N	\N	\N	58356	58356	58127
14680	17913	19	applied	\N	\N	\N	\N	58357	58357	58129
14680	17914	20	applied	\N	\N	\N	\N	58358	58358	58131
14680	17915	21	applied	\N	\N	\N	\N	58359	58359	58133
14680	17916	22	applied	\N	\N	\N	\N	58360	58360	58135
14680	17917	23	applied	\N	\N	\N	\N	58361	58361	58137
14680	17918	24	applied	\N	\N	\N	\N	58362	58362	58139
14680	17919	25	applied	\N	\N	\N	\N	58363	58363	58141
14680	17920	26	applied	\N	\N	\N	\N	58364	58364	58143
14680	17921	27	applied	\N	\N	\N	\N	58365	58365	58145
14680	17925	28	applied	\N	\N	\N	\N	58366	58366	58155
14680	17926	29	applied	\N	\N	\N	\N	58367	58367	58157
14642	17420	13	applied	\N	\N	\N	\N	56784	56784	56785
14642	17425	14	applied	\N	\N	\N	\N	56795	56795	56796
14642	17429	15	applied	\N	\N	\N	\N	56806	56806	56807
14642	17433	16	applied	\N	\N	\N	\N	56815	56815	56816
14642	17436	17	applied	\N	\N	\N	\N	56824	56824	56825
14642	17450	18	applied	\N	\N	\N	\N	56861	56861	56862
14642	17453	19	applied	\N	\N	\N	\N	56869	56869	56870
14642	17456	20	applied	\N	\N	\N	\N	56878	56878	56879
14642	17460	21	applied	\N	\N	\N	\N	56889	56889	56890
14642	17461	22	applied	\N	\N	\N	\N	56891	56891	56892
14642	17468	23	applied	\N	\N	\N	\N	56907	56907	56908
14642	17472	24	applied	\N	\N	\N	\N	56917	56917	56918
14642	17473	25	applied	\N	\N	\N	\N	56919	56919	56920
14642	17479	26	applied	\N	\N	\N	\N	56933	56933	56934
14642	17483	27	applied	\N	\N	\N	\N	56943	56943	56944
14642	17487	28	applied	\N	\N	\N	\N	56957	56957	56958
14642	17488	29	applied	\N	\N	\N	\N	56959	56959	56960
14642	17495	30	applied	\N	\N	\N	\N	56975	56975	56976
14642	17499	31	applied	\N	\N	\N	\N	56989	56989	56990
14642	17502	32	applied	\N	\N	\N	\N	56997	56997	56998
14642	17506	33	applied	\N	\N	\N	\N	57005	57005	57006
14642	17507	34	applied	\N	\N	\N	\N	57007	57007	57008
14642	17508	35	applied	\N	\N	\N	\N	57009	57009	57010
14642	17509	36	applied	\N	\N	\N	\N	57011	57011	57012
14642	17521	37	applied	\N	\N	\N	\N	57042	57042	57043
14642	17522	38	applied	\N	\N	\N	\N	57044	57044	57045
14642	17529	39	applied	\N	\N	\N	\N	57062	57062	57063
14642	17530	40	applied	\N	\N	\N	\N	57064	57064	57065
14642	17531	41	applied	\N	\N	\N	\N	57066	57066	57067
14642	17541	42	applied	\N	\N	\N	\N	57087	57087	57088
14642	17545	43	applied	\N	\N	\N	\N	57099	57099	57100
14642	17549	44	applied	\N	\N	\N	\N	57114	57114	57115
14642	17550	45	applied	\N	\N	\N	\N	57116	57116	57117
14642	17551	46	applied	\N	\N	\N	\N	57118	57118	57119
14642	17552	47	applied	\N	\N	\N	\N	57120	57120	57121
14642	17553	48	applied	\N	\N	\N	\N	57122	57122	57123
14642	17554	49	applied	\N	\N	\N	\N	57125	57125	57126
14642	17570	50	applied	\N	\N	\N	\N	57205	57205	57206
14642	17574	51	applied	\N	\N	\N	\N	57219	57219	57220
14642	17577	52	applied	\N	\N	\N	\N	57228	57228	57229
14642	17578	53	applied	\N	\N	\N	\N	57230	57230	57231
14642	17584	54	applied	\N	\N	\N	\N	57246	57246	57247
14642	17588	55	applied	\N	\N	\N	\N	57255	57255	57256
14642	17589	56	applied	\N	\N	\N	\N	57257	57257	57258
14642	17590	57	applied	\N	\N	\N	\N	57259	57259	57260
14642	17591	58	applied	\N	\N	\N	\N	57261	57261	57262
14642	17604	59	applied	\N	\N	\N	\N	57288	57288	57289
14642	17605	60	applied	\N	\N	\N	\N	57290	57290	57291
14642	17612	61	applied	\N	\N	\N	\N	57306	57306	57307
14642	17613	62	applied	\N	\N	\N	\N	57308	57308	57309
14642	17617	64	applied	\N	\N	\N	\N	57319	57319	57320
14642	17624	65	applied	\N	\N	\N	\N	57339	57339	57340
14642	17625	66	applied	\N	\N	\N	\N	57341	57341	57342
14642	17631	67	applied	\N	\N	\N	\N	57362	57362	57363
14642	17633	68	applied	\N	\N	\N	\N	57370	57370	57371
14642	17634	69	applied	\N	\N	\N	\N	57372	57372	57373
14642	17639	70	applied	\N	\N	\N	\N	57383	57383	57384
14642	17642	71	applied	\N	\N	\N	\N	57391	57391	57392
14642	17644	72	applied	\N	\N	\N	\N	57395	57395	57396
14642	17645	73	applied	\N	\N	\N	\N	57397	57397	57398
14642	17650	74	applied	\N	\N	\N	\N	57409	57409	57410
14642	17651	75	applied	\N	\N	\N	\N	57411	57411	57412
14642	17656	76	applied	\N	\N	\N	\N	57423	57423	57424
14642	17658	77	applied	\N	\N	\N	\N	57434	57434	57435
14642	17660	78	applied	\N	\N	\N	\N	57442	57442	57443
14642	17662	79	applied	\N	\N	\N	\N	57448	57448	57449
14642	17664	80	applied	\N	\N	\N	\N	57452	57452	57453
14642	17665	81	applied	\N	\N	\N	\N	57454	57454	57455
14642	17668	82	applied	\N	\N	\N	\N	57462	57462	57463
14642	17669	83	applied	\N	\N	\N	\N	57464	57464	57465
14642	17672	84	applied	\N	\N	\N	\N	57472	57472	57473
14642	17673	85	applied	\N	\N	\N	\N	57474	57474	57475
14642	17678	86	applied	\N	\N	\N	\N	57485	57485	57486
14642	17681	87	applied	\N	\N	\N	\N	57492	57492	57493
14642	17682	88	applied	\N	\N	\N	\N	57494	57494	57495
14642	17687	89	applied	\N	\N	\N	\N	57509	57509	57510
14642	17689	90	applied	\N	\N	\N	\N	57515	57515	57516
14642	17690	91	applied	\N	\N	\N	\N	57517	57517	57518
14642	17693	92	applied	\N	\N	\N	\N	57526	57526	57527
14642	17694	93	applied	\N	\N	\N	\N	57528	57528	57529
14642	17695	94	applied	\N	\N	\N	\N	57530	57530	57531
14642	17696	95	applied	\N	\N	\N	\N	57532	57532	57533
14642	17706	96	applied	\N	\N	\N	\N	57555	57555	57556
14642	17707	97	applied	\N	\N	\N	\N	57557	57557	57558
14642	17708	98	applied	\N	\N	\N	\N	57559	57559	57560
14642	17715	99	applied	\N	\N	\N	\N	57576	57576	57577
14642	17718	100	applied	\N	\N	\N	\N	57589	57589	57590
14642	17721	101	applied	\N	\N	\N	\N	57596	57596	57597
14642	17724	102	applied	\N	\N	\N	\N	57603	57603	57604
14642	17726	103	applied	\N	\N	\N	\N	57612	57612	57613
14642	17728	104	applied	\N	\N	\N	\N	57620	57620	57621
14642	17729	105	applied	\N	\N	\N	\N	57622	57622	57623
14642	17733	106	applied	\N	\N	\N	\N	57631	57631	57632
14642	17734	107	applied	\N	\N	\N	\N	57633	57633	57634
14642	17735	108	applied	\N	\N	\N	\N	57635	57635	57636
14642	17739	109	applied	\N	\N	\N	\N	57649	57649	57650
14642	17741	110	applied	\N	\N	\N	\N	57657	57657	57658
14642	17743	111	applied	\N	\N	\N	\N	57665	57665	57666
14642	17751	112	applied	\N	\N	\N	\N	57695	57695	57696
14642	17754	113	applied	\N	\N	\N	\N	57704	57704	57705
14642	17757	114	applied	\N	\N	\N	\N	57715	57715	57716
14642	17760	115	applied	\N	\N	\N	\N	57721	57721	57722
14642	17763	116	applied	\N	\N	\N	\N	57729	57729	57730
14642	17766	117	applied	\N	\N	\N	\N	57743	57743	57744
14642	17769	118	applied	\N	\N	\N	\N	57754	57754	57755
14642	17772	119	applied	\N	\N	\N	\N	57763	57763	57764
14642	17775	120	applied	\N	\N	\N	\N	57770	57770	57771
14642	17778	121	applied	\N	\N	\N	\N	57778	57778	57779
14642	17781	122	applied	\N	\N	\N	\N	57788	57788	57789
14642	17782	123	applied	\N	\N	\N	\N	57790	57790	57791
14642	17783	124	applied	\N	\N	\N	\N	57792	57792	57793
14642	17784	125	applied	\N	\N	\N	\N	57794	57794	57795
14645	17861	0	applied	\N	\N	\N	\N	57992	57992	57993
14645	17862	1	applied	\N	\N	\N	\N	57994	57994	57995
14645	17863	2	applied	\N	\N	\N	\N	57996	57996	57997
14648	17792	0	applied	\N	\N	\N	\N	57813	57813	57814
14648	17794	1	applied	\N	\N	\N	\N	57819	57819	57820
14648	17797	2	applied	\N	\N	\N	\N	57828	57828	57829
14648	17800	3	applied	\N	\N	\N	\N	57836	57836	57837
14648	17801	4	applied	\N	\N	\N	\N	57838	57838	57839
14648	17802	5	applied	\N	\N	\N	\N	57840	57840	57841
14648	17809	6	applied	\N	\N	\N	\N	57856	57856	57857
14648	17812	7	applied	\N	\N	\N	\N	57866	57866	57867
14648	17815	8	applied	\N	\N	\N	\N	57872	57872	57873
14648	17818	9	applied	\N	\N	\N	\N	57884	57884	57885
14648	17819	10	applied	\N	\N	\N	\N	57886	57886	57887
14648	17824	11	applied	\N	\N	\N	\N	57897	57897	57898
14648	17827	12	applied	\N	\N	\N	\N	57904	57904	57905
14648	17830	13	applied	\N	\N	\N	\N	57913	57913	57914
14648	17831	14	applied	\N	\N	\N	\N	57915	57915	57916
14648	17832	15	applied	\N	\N	\N	\N	57917	57917	57918
14648	17839	16	applied	\N	\N	\N	\N	57934	57934	57935
14648	17840	17	applied	\N	\N	\N	\N	57936	57936	57937
14648	17849	18	applied	\N	\N	\N	\N	57967	57967	57968
14648	17850	19	applied	\N	\N	\N	\N	57969	57969	57970
14648	17861	20	applied	\N	\N	\N	\N	57992	57992	57993
14648	17864	21	applied	\N	\N	\N	\N	57999	57999	58000
14648	17719	22	applied	\N	\N	\N	\N	57591	57591	57592
14648	17382	23	applied	\N	\N	\N	\N	56696	56696	56697
14648	17383	24	applied	\N	\N	\N	\N	56698	56698	56699
14648	17384	25	applied	\N	\N	\N	\N	56700	56700	56701
14648	17385	26	applied	\N	\N	\N	\N	56702	56702	56703
14648	17386	27	applied	\N	\N	\N	\N	56704	56704	56705
14648	17387	28	applied	\N	\N	\N	\N	56706	56706	56707
14648	17391	29	applied	\N	\N	\N	\N	56718	56718	56719
14648	17392	30	applied	\N	\N	\N	\N	56720	56720	56721
14648	17393	31	applied	\N	\N	\N	\N	56722	56722	56723
14648	17394	32	applied	\N	\N	\N	\N	56724	56724	56725
14648	17395	33	applied	\N	\N	\N	\N	56726	56726	56727
14648	17396	34	applied	\N	\N	\N	\N	56728	56728	56729
14648	17397	35	applied	\N	\N	\N	\N	56730	56730	56731
14648	17398	36	applied	\N	\N	\N	\N	56732	56732	56733
14648	17399	37	applied	\N	\N	\N	\N	56734	56734	56735
14648	17402	38	applied	\N	\N	\N	\N	56740	56740	56741
14648	17403	39	applied	\N	\N	\N	\N	56742	56742	56743
14648	17404	40	applied	\N	\N	\N	\N	56744	56744	56745
14648	17407	41	applied	\N	\N	\N	\N	56753	56753	56754
14648	17408	42	applied	\N	\N	\N	\N	56755	56755	56756
14648	17409	43	applied	\N	\N	\N	\N	56757	56757	56758
14648	17410	44	applied	\N	\N	\N	\N	56759	56759	56760
14648	17411	45	applied	\N	\N	\N	\N	56761	56761	56762
14648	17413	46	applied	\N	\N	\N	\N	56767	56767	56768
14648	17414	47	applied	\N	\N	\N	\N	56769	56769	56770
14648	17416	48	applied	\N	\N	\N	\N	56776	56776	56777
14648	17417	49	applied	\N	\N	\N	\N	56778	56778	56779
14648	17418	50	applied	\N	\N	\N	\N	56780	56780	56781
14648	17421	51	applied	\N	\N	\N	\N	56786	56786	56787
14648	17422	52	applied	\N	\N	\N	\N	56788	56788	56789
14648	17423	53	applied	\N	\N	\N	\N	56790	56790	56791
14648	17424	54	applied	\N	\N	\N	\N	56792	56792	56793
14648	17426	55	applied	\N	\N	\N	\N	56797	56797	56798
14648	17427	56	applied	\N	\N	\N	\N	56800	56800	56801
14648	17428	57	applied	\N	\N	\N	\N	56802	56802	56803
14648	17430	58	applied	\N	\N	\N	\N	56808	56808	56809
14648	17431	59	applied	\N	\N	\N	\N	56810	56810	56811
14648	17432	60	applied	\N	\N	\N	\N	56812	56812	56813
14648	17434	61	applied	\N	\N	\N	\N	56817	56817	56818
14648	17435	62	applied	\N	\N	\N	\N	56819	56819	56820
14648	17437	64	applied	\N	\N	\N	\N	56826	56826	56827
14648	17438	65	applied	\N	\N	\N	\N	56828	56828	56829
14648	17439	66	applied	\N	\N	\N	\N	56830	56830	56831
14648	17440	67	applied	\N	\N	\N	\N	56832	56832	56833
14648	17441	68	applied	\N	\N	\N	\N	56834	56834	56835
14648	17442	69	applied	\N	\N	\N	\N	56840	56840	56841
14648	17443	70	applied	\N	\N	\N	\N	56842	56842	56843
14648	17444	71	applied	\N	\N	\N	\N	56844	56844	56845
14648	17445	72	applied	\N	\N	\N	\N	56846	56846	56847
14648	17446	73	applied	\N	\N	\N	\N	56848	56848	56849
14648	17447	74	applied	\N	\N	\N	\N	56850	56850	56851
14648	17448	75	applied	\N	\N	\N	\N	56854	56854	56855
14648	17449	76	applied	\N	\N	\N	\N	56856	56856	56857
14648	17451	77	applied	\N	\N	\N	\N	56863	56863	56864
14648	17452	78	applied	\N	\N	\N	\N	56865	56865	56866
14648	17454	79	applied	\N	\N	\N	\N	56871	56871	56872
14648	17455	80	applied	\N	\N	\N	\N	56873	56873	56874
14648	17457	81	applied	\N	\N	\N	\N	56880	56880	56881
14648	17458	82	applied	\N	\N	\N	\N	56882	56882	56883
14648	17459	83	applied	\N	\N	\N	\N	56884	56884	56885
14648	17462	84	applied	\N	\N	\N	\N	56893	56893	56894
14648	17463	85	applied	\N	\N	\N	\N	56895	56895	56896
14648	17464	86	applied	\N	\N	\N	\N	56897	56897	56898
14648	17465	87	applied	\N	\N	\N	\N	56899	56899	56900
14648	17466	88	applied	\N	\N	\N	\N	56901	56901	56902
14648	17467	89	applied	\N	\N	\N	\N	56903	56903	56904
14648	17469	90	applied	\N	\N	\N	\N	56909	56909	56910
14648	17470	91	applied	\N	\N	\N	\N	56911	56911	56912
14648	17471	92	applied	\N	\N	\N	\N	56913	56913	56914
14648	17474	93	applied	\N	\N	\N	\N	56921	56921	56922
14648	17475	94	applied	\N	\N	\N	\N	56923	56923	56924
14648	17476	95	applied	\N	\N	\N	\N	56925	56925	56926
14648	17477	96	applied	\N	\N	\N	\N	56927	56927	56928
14648	17478	97	applied	\N	\N	\N	\N	56929	56929	56930
14648	17480	98	applied	\N	\N	\N	\N	56935	56935	56936
14648	17481	99	applied	\N	\N	\N	\N	56937	56937	56938
14648	17482	100	applied	\N	\N	\N	\N	56939	56939	56940
14648	17484	101	applied	\N	\N	\N	\N	56945	56945	56946
14648	17485	102	applied	\N	\N	\N	\N	56947	56947	56948
14648	17486	103	applied	\N	\N	\N	\N	56949	56949	56950
14648	17489	104	applied	\N	\N	\N	\N	56961	56961	56962
14648	17490	105	applied	\N	\N	\N	\N	56963	56963	56964
14648	17491	106	applied	\N	\N	\N	\N	56965	56965	56966
14648	17492	107	applied	\N	\N	\N	\N	56967	56967	56968
14648	17493	108	applied	\N	\N	\N	\N	56969	56969	56970
14648	17494	109	applied	\N	\N	\N	\N	56971	56971	56972
14648	17496	110	applied	\N	\N	\N	\N	56977	56977	56978
14648	17497	111	applied	\N	\N	\N	\N	56979	56979	56980
14648	17498	112	applied	\N	\N	\N	\N	56981	56981	56982
14648	17500	113	applied	\N	\N	\N	\N	56991	56991	56992
14648	17501	114	applied	\N	\N	\N	\N	56993	56993	56994
14648	17503	115	applied	\N	\N	\N	\N	56999	56999	57000
14648	17504	116	applied	\N	\N	\N	\N	57001	57001	57002
14648	17505	117	applied	\N	\N	\N	\N	57003	57003	57004
14648	17510	118	applied	\N	\N	\N	\N	57013	57013	57014
14648	17511	119	applied	\N	\N	\N	\N	57015	57015	57016
14648	17512	120	applied	\N	\N	\N	\N	57017	57017	57018
14648	17513	121	applied	\N	\N	\N	\N	57019	57019	57020
14648	17514	122	applied	\N	\N	\N	\N	57021	57021	57022
14648	17515	123	applied	\N	\N	\N	\N	57023	57023	57024
14648	17516	124	applied	\N	\N	\N	\N	57026	57026	57027
14648	17517	125	applied	\N	\N	\N	\N	57028	57028	57029
14650	17873	0	applied	\N	\N	\N	\N	58025	58025	58026
14650	17874	1	applied	\N	\N	\N	\N	58027	58027	58028
14650	17875	2	applied	\N	\N	\N	\N	58029	58029	58030
14658	17876	0	applied	\N	\N	\N	\N	58042	58042	58043
14658	17877	1	applied	\N	\N	\N	\N	58044	58044	58045
14658	17878	2	applied	\N	\N	\N	\N	58046	58046	58047
14660	17879	0	applied	\N	\N	\N	\N	58049	58049	58050
14660	17880	1	applied	\N	\N	\N	\N	58051	58051	58052
14660	17881	2	applied	\N	\N	\N	\N	58053	58053	58054
14660	17882	3	applied	\N	\N	\N	\N	58055	58055	58056
14660	17883	4	applied	\N	\N	\N	\N	58057	58057	58058
14670	17933	0	applied	\N	\N	\N	\N	58173	58173	58174
14670	17934	1	applied	\N	\N	\N	\N	58175	58175	58176
14670	17935	2	applied	\N	\N	\N	\N	58177	58177	58178
14670	17936	3	applied	\N	\N	\N	\N	58179	58179	58180
14670	17937	4	applied	\N	\N	\N	\N	58181	58181	58182
14670	17938	5	applied	\N	\N	\N	\N	58183	58183	58184
14670	17939	6	applied	\N	\N	\N	\N	58185	58185	58186
14670	17932	7	applied	\N	\N	\N	\N	58168	58168	58169
14670	17940	8	applied	\N	\N	\N	\N	58187	58187	58188
14673	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14673	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14673	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14673	17944	3	applied	\N	\N	\N	\N	58201	58201	58202
14673	17945	4	applied	\N	\N	\N	\N	58203	58203	58204
14673	17946	5	applied	\N	\N	\N	\N	58205	58205	58206
14673	17947	6	applied	\N	\N	\N	\N	58207	58207	58208
14673	17948	7	applied	\N	\N	\N	\N	58209	58209	58210
14673	17949	8	applied	\N	\N	\N	\N	58211	58211	58212
14673	17950	9	applied	\N	\N	\N	\N	58213	58213	58214
14673	17951	10	applied	\N	\N	\N	\N	58215	58215	58216
14673	17952	11	applied	\N	\N	\N	\N	58217	58217	58218
14673	17953	12	applied	\N	\N	\N	\N	58219	58219	58220
14673	17954	13	applied	\N	\N	\N	\N	58221	58221	58222
14673	17955	14	applied	\N	\N	\N	\N	58223	58223	58224
14673	17956	15	applied	\N	\N	\N	\N	58225	58225	58226
14673	17957	16	applied	\N	\N	\N	\N	58227	58227	58228
14673	17958	17	applied	\N	\N	\N	\N	58229	58229	58230
14673	17959	18	applied	\N	\N	\N	\N	58231	58231	58232
14673	17960	19	applied	\N	\N	\N	\N	58233	58233	58234
14673	17961	20	applied	\N	\N	\N	\N	58235	58235	58236
14673	17962	21	applied	\N	\N	\N	\N	58237	58237	58238
14673	17963	22	applied	\N	\N	\N	\N	58239	58239	58240
14673	17964	23	applied	\N	\N	\N	\N	58241	58241	58242
14676	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14676	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14676	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14676	17944	3	applied	\N	\N	\N	\N	58201	58201	58202
14676	17945	4	applied	\N	\N	\N	\N	58203	58203	58204
14676	17946	5	applied	\N	\N	\N	\N	58205	58205	58206
14676	17947	6	applied	\N	\N	\N	\N	58207	58207	58208
14676	17948	7	applied	\N	\N	\N	\N	58209	58209	58210
14676	17949	8	applied	\N	\N	\N	\N	58211	58211	58212
14676	17950	9	applied	\N	\N	\N	\N	58213	58213	58214
14676	17951	10	applied	\N	\N	\N	\N	58215	58215	58216
14676	17952	11	applied	\N	\N	\N	\N	58217	58217	58218
14676	17953	12	applied	\N	\N	\N	\N	58219	58219	58220
14676	17954	13	applied	\N	\N	\N	\N	58221	58221	58222
14676	17955	14	applied	\N	\N	\N	\N	58223	58223	58224
14676	17956	15	applied	\N	\N	\N	\N	58225	58225	58226
14676	17957	16	applied	\N	\N	\N	\N	58227	58227	58228
14676	17958	17	applied	\N	\N	\N	\N	58229	58229	58230
14676	17959	18	applied	\N	\N	\N	\N	58231	58231	58232
14676	17960	19	applied	\N	\N	\N	\N	58233	58233	58234
14676	17961	20	applied	\N	\N	\N	\N	58235	58235	58236
14676	17962	21	applied	\N	\N	\N	\N	58237	58237	58238
14676	17963	22	applied	\N	\N	\N	\N	58239	58239	58240
14676	17964	23	applied	\N	\N	\N	\N	58241	58241	58242
14677	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14677	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14677	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14677	17944	3	applied	\N	\N	\N	\N	58201	58201	58202
14677	17945	4	applied	\N	\N	\N	\N	58203	58203	58204
14677	17946	5	applied	\N	\N	\N	\N	58205	58205	58206
14677	17947	6	applied	\N	\N	\N	\N	58207	58207	58208
14677	17948	7	applied	\N	\N	\N	\N	58209	58209	58210
14677	17949	8	applied	\N	\N	\N	\N	58211	58211	58212
14677	17950	9	applied	\N	\N	\N	\N	58213	58213	58214
14677	17951	10	applied	\N	\N	\N	\N	58215	58215	58216
14677	17952	11	applied	\N	\N	\N	\N	58217	58217	58218
14677	17953	12	applied	\N	\N	\N	\N	58219	58219	58220
14677	17954	13	applied	\N	\N	\N	\N	58221	58221	58222
14677	17955	14	applied	\N	\N	\N	\N	58223	58223	58224
14677	17956	15	applied	\N	\N	\N	\N	58225	58225	58226
14677	17957	16	applied	\N	\N	\N	\N	58227	58227	58228
14677	17958	17	applied	\N	\N	\N	\N	58229	58229	58230
14677	17959	18	applied	\N	\N	\N	\N	58231	58231	58232
14677	17960	19	applied	\N	\N	\N	\N	58233	58233	58234
14677	17961	20	applied	\N	\N	\N	\N	58235	58235	58236
14677	17962	21	applied	\N	\N	\N	\N	58237	58237	58238
14677	17963	22	applied	\N	\N	\N	\N	58239	58239	58240
14677	17964	23	applied	\N	\N	\N	\N	58241	58241	58242
14681	17981	0	applied	\N	\N	\N	\N	58285	58285	58286
14681	17982	1	applied	\N	\N	\N	\N	58287	58287	58288
14681	17983	2	applied	\N	\N	\N	\N	58289	58289	58290
14681	17984	3	applied	\N	\N	\N	\N	58291	58291	58292
14681	17985	4	applied	\N	\N	\N	\N	58293	58293	58294
14681	17986	5	applied	\N	\N	\N	\N	58295	58295	58296
14681	17987	6	applied	\N	\N	\N	\N	58297	58297	58298
14681	17988	7	applied	\N	\N	\N	\N	58299	58299	58300
14681	17989	8	applied	\N	\N	\N	\N	58301	58301	58302
14681	17990	9	applied	\N	\N	\N	\N	58303	58303	58304
14681	17991	10	applied	\N	\N	\N	\N	58305	58305	58306
14681	17992	11	applied	\N	\N	\N	\N	58307	58307	58308
14681	17993	12	applied	\N	\N	\N	\N	58309	58309	58310
14681	17994	13	applied	\N	\N	\N	\N	58311	58311	58312
14681	17995	14	applied	\N	\N	\N	\N	58313	58313	58314
14681	17996	15	applied	\N	\N	\N	\N	58315	58315	58316
14681	17997	16	applied	\N	\N	\N	\N	58317	58317	58318
14681	17998	17	applied	\N	\N	\N	\N	58319	58319	58320
14681	17999	18	applied	\N	\N	\N	\N	58321	58321	58322
14681	18000	19	applied	\N	\N	\N	\N	58323	58323	58324
14681	18001	20	applied	\N	\N	\N	\N	58325	58325	58326
14681	18002	21	applied	\N	\N	\N	\N	58327	58327	58328
14681	18003	22	applied	\N	\N	\N	\N	58329	58329	58330
14681	18004	23	applied	\N	\N	\N	\N	58331	58331	58332
14698	18035	0	applied	\N	\N	\N	\N	58461	58461	58462
14698	18036	1	applied	\N	\N	\N	\N	58463	58463	58464
14705	18043	0	applied	\N	\N	\N	\N	58556	58556	58557
14705	18044	1	applied	\N	\N	\N	\N	58558	58558	58559
14668	17932	7	applied	\N	\N	\N	\N	58168	58168	58169
14671	17933	0	applied	\N	\N	\N	\N	58173	58173	58174
14671	17934	1	applied	\N	\N	\N	\N	58175	58175	58176
14671	17935	2	applied	\N	\N	\N	\N	58177	58177	58178
14671	17936	3	applied	\N	\N	\N	\N	58179	58179	58180
14671	17937	4	applied	\N	\N	\N	\N	58181	58181	58182
14671	17938	5	applied	\N	\N	\N	\N	58183	58183	58184
14671	17939	6	applied	\N	\N	\N	\N	58185	58185	58186
14671	17932	7	applied	\N	\N	\N	\N	58168	58168	58169
14671	17940	8	applied	\N	\N	\N	\N	58187	58187	58188
14674	17941	0	applied	\N	\N	\N	\N	58193	58193	58194
14674	17942	1	applied	\N	\N	\N	\N	58195	58195	58196
14674	17943	2	applied	\N	\N	\N	\N	58197	58197	58198
14674	17944	3	applied	\N	\N	\N	\N	58201	58201	58202
14674	17945	4	applied	\N	\N	\N	\N	58203	58203	58204
14674	17946	5	applied	\N	\N	\N	\N	58205	58205	58206
14674	17947	6	applied	\N	\N	\N	\N	58207	58207	58208
14674	17948	7	applied	\N	\N	\N	\N	58209	58209	58210
14674	17949	8	applied	\N	\N	\N	\N	58211	58211	58212
14674	17950	9	applied	\N	\N	\N	\N	58213	58213	58214
14674	17951	10	applied	\N	\N	\N	\N	58215	58215	58216
14674	17952	11	applied	\N	\N	\N	\N	58217	58217	58218
14674	17953	12	applied	\N	\N	\N	\N	58219	58219	58220
14674	17954	13	applied	\N	\N	\N	\N	58221	58221	58222
14674	17955	14	applied	\N	\N	\N	\N	58223	58223	58224
14674	17956	15	applied	\N	\N	\N	\N	58225	58225	58226
14674	17957	16	applied	\N	\N	\N	\N	58227	58227	58228
14674	17958	17	applied	\N	\N	\N	\N	58229	58229	58230
14674	17959	18	applied	\N	\N	\N	\N	58231	58231	58232
14674	17960	19	applied	\N	\N	\N	\N	58233	58233	58234
14674	17961	20	applied	\N	\N	\N	\N	58235	58235	58236
14674	17962	21	applied	\N	\N	\N	\N	58237	58237	58238
14674	17963	22	applied	\N	\N	\N	\N	58239	58239	58240
14674	17964	23	applied	\N	\N	\N	\N	58241	58241	58242
14682	17981	0	applied	\N	\N	\N	\N	58285	58285	58286
14682	17982	1	applied	\N	\N	\N	\N	58287	58287	58288
14682	17983	2	applied	\N	\N	\N	\N	58289	58289	58290
14682	17984	3	applied	\N	\N	\N	\N	58291	58291	58292
14682	17985	4	applied	\N	\N	\N	\N	58293	58293	58294
14682	17986	5	applied	\N	\N	\N	\N	58295	58295	58296
14682	17987	6	applied	\N	\N	\N	\N	58297	58297	58298
14682	17988	7	applied	\N	\N	\N	\N	58299	58299	58300
14682	17989	8	applied	\N	\N	\N	\N	58301	58301	58302
14682	17990	9	applied	\N	\N	\N	\N	58303	58303	58304
14682	17991	10	applied	\N	\N	\N	\N	58305	58305	58306
14682	17992	11	applied	\N	\N	\N	\N	58307	58307	58308
14682	17993	12	applied	\N	\N	\N	\N	58309	58309	58310
14682	17994	13	applied	\N	\N	\N	\N	58311	58311	58312
14682	17995	14	applied	\N	\N	\N	\N	58313	58313	58314
14682	17996	15	applied	\N	\N	\N	\N	58315	58315	58316
14682	17997	16	applied	\N	\N	\N	\N	58317	58317	58318
14682	17998	17	applied	\N	\N	\N	\N	58319	58319	58320
14682	17999	18	applied	\N	\N	\N	\N	58321	58321	58322
14682	18000	19	applied	\N	\N	\N	\N	58323	58323	58324
14682	18001	20	applied	\N	\N	\N	\N	58325	58325	58326
14682	18002	21	applied	\N	\N	\N	\N	58327	58327	58328
14682	18003	22	applied	\N	\N	\N	\N	58329	58329	58330
14682	18004	23	applied	\N	\N	\N	\N	58331	58331	58332
14685	18005	0	applied	\N	\N	\N	\N	58377	58377	58378
14685	18006	1	applied	\N	\N	\N	\N	58379	58379	58380
14685	18007	2	applied	\N	\N	\N	\N	58381	58381	58382
14685	18008	3	applied	\N	\N	\N	\N	58383	58383	58384
14685	18009	4	applied	\N	\N	\N	\N	58385	58385	58386
14685	18010	5	applied	\N	\N	\N	\N	58387	58387	58388
14685	18011	6	applied	\N	\N	\N	\N	58389	58389	58390
14685	18012	7	applied	\N	\N	\N	\N	58391	58391	58392
14685	18013	8	applied	\N	\N	\N	\N	58393	58393	58394
14687	18014	0	applied	\N	\N	\N	\N	58398	58398	58399
14687	18015	1	applied	\N	\N	\N	\N	58400	58400	58401
14687	18016	2	applied	\N	\N	\N	\N	58402	58402	58403
14687	18017	3	applied	\N	\N	\N	\N	58404	58404	58405
14687	18018	4	applied	\N	\N	\N	\N	58406	58406	58407
14687	18019	5	applied	\N	\N	\N	\N	58408	58408	58409
14687	18020	6	applied	\N	\N	\N	\N	58410	58410	58411
14689	18021	0	applied	\N	\N	\N	\N	58416	58416	58417
14689	18022	1	applied	\N	\N	\N	\N	58418	58418	58419
14689	18023	2	applied	\N	\N	\N	\N	58420	58420	58421
14689	18024	3	applied	\N	\N	\N	\N	58422	58422	58423
14689	18025	4	applied	\N	\N	\N	\N	58424	58424	58425
14689	18026	5	applied	\N	\N	\N	\N	58426	58426	58427
14694	18029	0	applied	\N	\N	\N	\N	58441	58441	58442
14694	18030	1	applied	\N	\N	\N	\N	58443	58443	58444
14694	18031	2	applied	\N	\N	\N	\N	58445	58445	58446
14694	18032	3	applied	\N	\N	\N	\N	58447	58447	58448
14696	18033	0	applied	\N	\N	\N	\N	58453	58453	58454
14696	18034	1	applied	\N	\N	\N	\N	58455	58455	58456
14699	18035	0	applied	\N	\N	\N	\N	58461	58461	58462
14699	18036	1	applied	\N	\N	\N	\N	58463	58463	58464
14701	18037	0	applied	\N	\N	\N	\N	58539	58539	58540
14701	18038	1	applied	\N	\N	\N	\N	58541	58541	58542
14701	18039	2	applied	\N	\N	\N	\N	58543	58543	58544
14701	18040	3	applied	\N	\N	\N	\N	58545	58545	58546
14706	18043	0	applied	\N	\N	\N	\N	58556	58556	58557
14706	18044	1	applied	\N	\N	\N	\N	58558	58558	58559
14708	18045	0	applied	\N	\N	\N	\N	58563	58563	58564
14708	18046	1	applied	\N	\N	\N	\N	58565	58565	58566
14708	18047	2	applied	\N	\N	\N	\N	58567	58567	58568
14708	18048	3	applied	\N	\N	\N	\N	58569	58569	58570
14708	18049	4	applied	\N	\N	\N	\N	58571	58571	58572
14711	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14711	17687	1	applied	\N	\N	\N	\N	57509	57509	57510
14711	17887	2	applied	\N	\N	\N	\N	58338	58338	58074
14711	17689	3	applied	\N	\N	\N	\N	57515	57515	57516
14711	17690	4	applied	\N	\N	\N	\N	57517	57517	57518
14711	17693	5	applied	\N	\N	\N	\N	57526	57526	57527
14711	17694	6	applied	\N	\N	\N	\N	57528	57528	57529
14711	17695	7	applied	\N	\N	\N	\N	57530	57530	57531
14711	17696	8	applied	\N	\N	\N	\N	57532	57532	57533
14711	17706	9	applied	\N	\N	\N	\N	57555	57555	57556
14711	17707	10	applied	\N	\N	\N	\N	57557	57557	57558
14711	17708	11	applied	\N	\N	\N	\N	57559	57559	57560
14711	17889	12	applied	\N	\N	\N	\N	58339	58339	58078
14711	17890	13	applied	\N	\N	\N	\N	58340	58340	58080
14711	17891	14	applied	\N	\N	\N	\N	58341	58341	58082
14711	17893	15	applied	\N	\N	\N	\N	58342	58342	58087
14711	17715	16	applied	\N	\N	\N	\N	57576	57576	57577
14711	17718	17	applied	\N	\N	\N	\N	57589	57589	57590
14711	17721	18	applied	\N	\N	\N	\N	57596	57596	57597
14711	17724	19	applied	\N	\N	\N	\N	57603	57603	57604
14711	17726	20	applied	\N	\N	\N	\N	57612	57612	57613
14679	17999	18	applied	\N	\N	\N	\N	58321	58321	58322
14679	18000	19	applied	\N	\N	\N	\N	58323	58323	58324
14679	18001	20	applied	\N	\N	\N	\N	58325	58325	58326
14679	18002	21	applied	\N	\N	\N	\N	58327	58327	58328
14679	18003	22	applied	\N	\N	\N	\N	58329	58329	58330
14679	18004	23	applied	\N	\N	\N	\N	58331	58331	58332
14683	17887	0	applied	\N	\N	\N	\N	58338	58338	58074
14683	17889	1	applied	\N	\N	\N	\N	58339	58339	58078
14683	17890	2	applied	\N	\N	\N	\N	58340	58340	58080
14683	17891	3	applied	\N	\N	\N	\N	58341	58341	58082
14683	17893	4	applied	\N	\N	\N	\N	58342	58342	58087
14683	17895	5	applied	\N	\N	\N	\N	58343	58343	58091
14683	17896	6	applied	\N	\N	\N	\N	58344	58344	58093
14683	17897	7	applied	\N	\N	\N	\N	58345	58345	58095
14683	17898	8	applied	\N	\N	\N	\N	58346	58346	58097
14683	17899	9	applied	\N	\N	\N	\N	58347	58347	58099
14683	17901	10	applied	\N	\N	\N	\N	58348	58348	58105
14683	17905	11	applied	\N	\N	\N	\N	58349	58349	58113
14683	17906	12	applied	\N	\N	\N	\N	58350	58350	58115
14683	17907	13	applied	\N	\N	\N	\N	58351	58351	58117
14683	17908	14	applied	\N	\N	\N	\N	58352	58352	58119
14683	17909	15	applied	\N	\N	\N	\N	58353	58353	58121
14683	17910	16	applied	\N	\N	\N	\N	58354	58354	58123
14683	17911	17	applied	\N	\N	\N	\N	58355	58355	58125
14683	17912	18	applied	\N	\N	\N	\N	58356	58356	58127
14683	17913	19	applied	\N	\N	\N	\N	58357	58357	58129
14683	17914	20	applied	\N	\N	\N	\N	58358	58358	58131
14683	17915	21	applied	\N	\N	\N	\N	58359	58359	58133
14683	17916	22	applied	\N	\N	\N	\N	58360	58360	58135
14683	17917	23	applied	\N	\N	\N	\N	58361	58361	58137
14683	17918	24	applied	\N	\N	\N	\N	58362	58362	58139
14683	17919	25	applied	\N	\N	\N	\N	58363	58363	58141
14683	17920	26	applied	\N	\N	\N	\N	58364	58364	58143
14683	17921	27	applied	\N	\N	\N	\N	58365	58365	58145
14683	17925	28	applied	\N	\N	\N	\N	58366	58366	58155
14683	17926	29	applied	\N	\N	\N	\N	58367	58367	58157
14686	18006	0	applied	\N	\N	\N	\N	58379	58379	58380
14686	18012	1	applied	\N	\N	\N	\N	58391	58391	58392
14686	18013	2	applied	\N	\N	\N	\N	58393	58393	58394
14688	18014	0	applied	\N	\N	\N	\N	58398	58398	58399
14688	18015	1	applied	\N	\N	\N	\N	58400	58400	58401
14688	18016	2	applied	\N	\N	\N	\N	58402	58402	58403
14688	18017	3	applied	\N	\N	\N	\N	58404	58404	58405
14688	18018	4	applied	\N	\N	\N	\N	58406	58406	58407
14688	18019	5	applied	\N	\N	\N	\N	58408	58408	58409
14688	18020	6	applied	\N	\N	\N	\N	58410	58410	58411
14690	18021	0	applied	\N	\N	\N	\N	58416	58416	58417
14690	18022	1	applied	\N	\N	\N	\N	58418	58418	58419
14690	18023	2	applied	\N	\N	\N	\N	58420	58420	58421
14690	18024	3	applied	\N	\N	\N	\N	58422	58422	58423
14690	18025	4	applied	\N	\N	\N	\N	58424	58424	58425
14690	18026	5	applied	\N	\N	\N	\N	58426	58426	58427
14692	18027	0	applied	\N	\N	\N	\N	58433	58433	58434
14692	18028	1	applied	\N	\N	\N	\N	58435	58435	58436
14695	18029	0	applied	\N	\N	\N	\N	58441	58441	58442
14695	18030	1	applied	\N	\N	\N	\N	58443	58443	58444
14695	18031	2	applied	\N	\N	\N	\N	58445	58445	58446
14695	18032	3	applied	\N	\N	\N	\N	58447	58447	58448
14700	17887	0	applied	\N	\N	\N	\N	58468	58468	58074
14700	17889	1	applied	\N	\N	\N	\N	58469	58469	58078
14700	17890	2	applied	\N	\N	\N	\N	58470	58470	58080
14700	17891	3	applied	\N	\N	\N	\N	58471	58471	58082
14700	17893	4	applied	\N	\N	\N	\N	58472	58472	58087
14700	17895	5	applied	\N	\N	\N	\N	58473	58473	58091
14700	17896	6	applied	\N	\N	\N	\N	58474	58474	58093
14700	17897	7	applied	\N	\N	\N	\N	58475	58475	58095
14700	17898	8	applied	\N	\N	\N	\N	58476	58476	58097
14700	17899	9	applied	\N	\N	\N	\N	58477	58477	58099
14700	17901	10	applied	\N	\N	\N	\N	58478	58478	58105
14700	17905	11	applied	\N	\N	\N	\N	58479	58479	58113
14700	17906	12	applied	\N	\N	\N	\N	58480	58480	58115
14700	17907	13	applied	\N	\N	\N	\N	58481	58481	58117
14700	17908	14	applied	\N	\N	\N	\N	58482	58482	58119
14700	17909	15	applied	\N	\N	\N	\N	58483	58483	58121
14700	17910	16	applied	\N	\N	\N	\N	58484	58484	58123
14700	17911	17	applied	\N	\N	\N	\N	58485	58485	58125
14700	17912	18	applied	\N	\N	\N	\N	58486	58486	58127
14700	17913	19	applied	\N	\N	\N	\N	58487	58487	58129
14700	17914	20	applied	\N	\N	\N	\N	58488	58488	58131
14700	17915	21	applied	\N	\N	\N	\N	58489	58489	58133
14700	17916	22	applied	\N	\N	\N	\N	58490	58490	58135
14700	17917	23	applied	\N	\N	\N	\N	58491	58491	58137
14700	17918	24	applied	\N	\N	\N	\N	58492	58492	58139
14700	17919	25	applied	\N	\N	\N	\N	58493	58493	58141
14700	17920	26	applied	\N	\N	\N	\N	58494	58494	58143
14700	17921	27	applied	\N	\N	\N	\N	58495	58495	58145
14700	17925	28	applied	\N	\N	\N	\N	58496	58496	58155
14700	17926	29	applied	\N	\N	\N	\N	58497	58497	58157
14700	17927	30	applied	\N	\N	\N	\N	58498	58498	58159
14700	17929	31	applied	\N	\N	\N	\N	58499	58499	58163
14700	17930	32	applied	\N	\N	\N	\N	58500	58500	58165
14700	17931	33	applied	\N	\N	\N	\N	58501	58501	58167
14700	17934	34	applied	\N	\N	\N	\N	58502	58502	58176
14700	17935	35	applied	\N	\N	\N	\N	58503	58503	58178
14700	17936	36	applied	\N	\N	\N	\N	58504	58504	58180
14700	17937	37	applied	\N	\N	\N	\N	58505	58505	58182
14700	17938	38	applied	\N	\N	\N	\N	58506	58506	58184
14700	17939	39	applied	\N	\N	\N	\N	58507	58507	58186
14700	17944	40	applied	\N	\N	\N	\N	58508	58508	58202
14700	17945	41	applied	\N	\N	\N	\N	58509	58509	58204
14700	17946	42	applied	\N	\N	\N	\N	58510	58510	58206
14700	17947	43	applied	\N	\N	\N	\N	58511	58511	58208
14700	17948	44	applied	\N	\N	\N	\N	58512	58512	58210
14700	17949	45	applied	\N	\N	\N	\N	58513	58513	58212
14700	17950	46	applied	\N	\N	\N	\N	58514	58514	58214
14700	17951	47	applied	\N	\N	\N	\N	58515	58515	58216
14700	17952	48	applied	\N	\N	\N	\N	58516	58516	58218
14700	17953	49	applied	\N	\N	\N	\N	58517	58517	58220
14700	17954	50	applied	\N	\N	\N	\N	58518	58518	58222
14700	17955	51	applied	\N	\N	\N	\N	58519	58519	58224
14700	17956	52	applied	\N	\N	\N	\N	58520	58520	58226
14700	17957	53	applied	\N	\N	\N	\N	58521	58521	58228
14700	17958	54	applied	\N	\N	\N	\N	58522	58522	58230
14700	17959	55	applied	\N	\N	\N	\N	58523	58523	58232
14700	17960	56	applied	\N	\N	\N	\N	58524	58524	58234
14700	17961	57	applied	\N	\N	\N	\N	58525	58525	58236
14700	17965	58	applied	\N	\N	\N	\N	58526	58526	58251
14700	17967	59	applied	\N	\N	\N	\N	58527	58527	58255
14700	17968	60	applied	\N	\N	\N	\N	58528	58528	58257
14700	17969	61	applied	\N	\N	\N	\N	58529	58529	58259
14680	17927	30	applied	\N	\N	\N	\N	58368	58368	58159
14680	17929	31	applied	\N	\N	\N	\N	58369	58369	58163
14680	17930	32	applied	\N	\N	\N	\N	58370	58370	58165
14684	18005	0	applied	\N	\N	\N	\N	58377	58377	58378
14684	18006	1	applied	\N	\N	\N	\N	58379	58379	58380
14684	18007	2	applied	\N	\N	\N	\N	58381	58381	58382
14684	18008	3	applied	\N	\N	\N	\N	58383	58383	58384
14684	18009	4	applied	\N	\N	\N	\N	58385	58385	58386
14684	18010	5	applied	\N	\N	\N	\N	58387	58387	58388
14684	18011	6	applied	\N	\N	\N	\N	58389	58389	58390
14684	18012	7	applied	\N	\N	\N	\N	58391	58391	58392
14684	18013	8	applied	\N	\N	\N	\N	58393	58393	58394
14691	18021	0	applied	\N	\N	\N	\N	58416	58416	58417
14691	18022	1	applied	\N	\N	\N	\N	58418	58418	58419
14691	18023	2	applied	\N	\N	\N	\N	58420	58420	58421
14691	18024	3	applied	\N	\N	\N	\N	58422	58422	58423
14691	18025	4	applied	\N	\N	\N	\N	58424	58424	58425
14691	18026	5	applied	\N	\N	\N	\N	58426	58426	58427
14693	18027	0	applied	\N	\N	\N	\N	58433	58433	58434
14693	18028	1	applied	\N	\N	\N	\N	58435	58435	58436
14697	18033	0	applied	\N	\N	\N	\N	58453	58453	58454
14697	18034	1	applied	\N	\N	\N	\N	58455	58455	58456
14703	18037	0	applied	\N	\N	\N	\N	58539	58539	58540
14703	18038	1	applied	\N	\N	\N	\N	58541	58541	58542
14703	18039	2	applied	\N	\N	\N	\N	58543	58543	58544
14703	18040	3	applied	\N	\N	\N	\N	58545	58545	58546
14704	18041	0	applied	\N	\N	\N	\N	58551	58551	58552
14704	18042	1	applied	\N	\N	\N	\N	58553	58553	58554
14707	18043	0	applied	\N	\N	\N	\N	58556	58556	58557
14707	18044	1	applied	\N	\N	\N	\N	58558	58558	58559
14710	18050	0	applied	\N	\N	\N	\N	58574	58574	58575
14710	18051	1	applied	\N	\N	\N	\N	58576	58576	58577
14710	18052	2	applied	\N	\N	\N	\N	58578	58578	58579
14710	18053	3	applied	\N	\N	\N	\N	58580	58580	58581
14710	18054	4	applied	\N	\N	\N	\N	58582	58582	58583
14710	18055	5	applied	\N	\N	\N	\N	58584	58584	58585
14712	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14712	17887	1	applied	\N	\N	\N	\N	58661	58661	58074
14712	17889	2	applied	\N	\N	\N	\N	58662	58662	58078
14712	17890	3	applied	\N	\N	\N	\N	58663	58663	58080
14712	17891	4	applied	\N	\N	\N	\N	58664	58664	58082
14712	17893	5	applied	\N	\N	\N	\N	58665	58665	58087
14712	17895	6	applied	\N	\N	\N	\N	58666	58666	58091
14712	17896	7	applied	\N	\N	\N	\N	58667	58667	58093
14712	17897	8	applied	\N	\N	\N	\N	58668	58668	58095
14712	17898	9	applied	\N	\N	\N	\N	58669	58669	58097
14712	17899	10	applied	\N	\N	\N	\N	58670	58670	58099
14712	17901	11	applied	\N	\N	\N	\N	58671	58671	58105
14712	17905	12	applied	\N	\N	\N	\N	58672	58672	58113
14712	17906	13	applied	\N	\N	\N	\N	58673	58673	58115
14712	17907	14	applied	\N	\N	\N	\N	58674	58674	58117
14712	17908	15	applied	\N	\N	\N	\N	58675	58675	58119
14712	17909	16	applied	\N	\N	\N	\N	58676	58676	58121
14712	17910	17	applied	\N	\N	\N	\N	58677	58677	58123
14712	17911	18	applied	\N	\N	\N	\N	58678	58678	58125
14712	17912	19	applied	\N	\N	\N	\N	58679	58679	58127
14712	17913	20	applied	\N	\N	\N	\N	58680	58680	58129
14712	17914	21	applied	\N	\N	\N	\N	58681	58681	58131
14712	17915	22	applied	\N	\N	\N	\N	58682	58682	58133
14712	17916	23	applied	\N	\N	\N	\N	58683	58683	58135
14712	17917	24	applied	\N	\N	\N	\N	58684	58684	58137
14712	17918	25	applied	\N	\N	\N	\N	58685	58685	58139
14712	17919	26	applied	\N	\N	\N	\N	58686	58686	58141
14712	17920	27	applied	\N	\N	\N	\N	58687	58687	58143
14712	17921	28	applied	\N	\N	\N	\N	58688	58688	58145
14712	17925	29	applied	\N	\N	\N	\N	58689	58689	58155
14712	17926	30	applied	\N	\N	\N	\N	58690	58690	58157
14712	17927	31	applied	\N	\N	\N	\N	58691	58691	58159
14712	17929	32	applied	\N	\N	\N	\N	58692	58692	58163
14712	17930	33	applied	\N	\N	\N	\N	58693	58693	58165
14712	17931	34	applied	\N	\N	\N	\N	58694	58694	58167
14712	17934	35	applied	\N	\N	\N	\N	58695	58695	58176
14718	18068	0	applied	\N	\N	\N	\N	58727	58727	58728
14718	18069	1	applied	\N	\N	\N	\N	58729	58729	58730
14720	18072	0	applied	\N	\N	\N	\N	58740	58740	58741
14720	18073	1	applied	\N	\N	\N	\N	58742	58742	58743
14720	18074	2	applied	\N	\N	\N	\N	58744	58744	58745
14720	18075	3	applied	\N	\N	\N	\N	58746	58746	58747
14723	18077	0	applied	\N	\N	\N	\N	58754	58754	58755
14723	18078	1	applied	\N	\N	\N	\N	58756	58756	58757
14730	18083	0	applied	\N	\N	\N	\N	58778	58778	58779
14730	18084	1	applied	\N	\N	\N	\N	58780	58780	58781
14740	18103	0	applied	\N	\N	\N	\N	58833	58833	58834
14740	18104	1	applied	\N	\N	\N	\N	58835	58835	58836
14746	18111	0	applied	\N	\N	\N	\N	58891	58891	58892
14746	18112	1	applied	\N	\N	\N	\N	58893	58893	58894
14749	18119	0	applied	\N	\N	\N	\N	58911	58911	58912
14749	18120	1	applied	\N	\N	\N	\N	58913	58913	58914
14754	18127	0	applied	\N	\N	\N	\N	58933	58933	58934
14754	18128	1	applied	\N	\N	\N	\N	58935	58935	58936
14756	18129	0	applied	\N	\N	\N	\N	58939	58939	58940
14756	18130	1	applied	\N	\N	\N	\N	58941	58941	58942
14761	18136	0	applied	\N	\N	\N	\N	58960	58960	58961
14761	18137	1	applied	\N	\N	\N	\N	58962	58962	58963
14769	18148	0	applied	\N	\N	\N	\N	58992	58992	58993
14769	18149	1	applied	\N	\N	\N	\N	58994	58994	58995
14781	18164	0	applied	\N	\N	\N	\N	59035	59035	59036
14781	18165	1	applied	\N	\N	\N	\N	59037	59037	59038
14783	18168	0	applied	\N	\N	\N	\N	59047	59047	59048
14783	18169	1	applied	\N	\N	\N	\N	59049	59049	59050
14786	18174	0	applied	\N	\N	\N	\N	59064	59064	59065
14786	18175	1	applied	\N	\N	\N	\N	59066	59066	59067
14788	18176	0	applied	\N	\N	\N	\N	59072	59072	59073
14788	18177	1	applied	\N	\N	\N	\N	59074	59074	59075
14791	18184	0	applied	\N	\N	\N	\N	59093	59093	59094
14791	18185	1	applied	\N	\N	\N	\N	59095	59095	59096
14797	18196	0	applied	\N	\N	\N	\N	59127	59127	59128
14797	18197	1	applied	\N	\N	\N	\N	59129	59129	51758
14797	18198	2	applied	\N	\N	\N	\N	59130	59130	59131
14799	18201	0	applied	\N	\N	\N	\N	59141	59141	59142
14799	18202	1	applied	\N	\N	\N	\N	59143	59143	59144
14802	18207	0	applied	\N	\N	\N	\N	59157	59157	59158
14802	18208	1	applied	\N	\N	\N	\N	59159	59159	59160
14802	18209	2	applied	\N	\N	\N	\N	59161	59161	59162
14802	18210	3	applied	\N	\N	\N	\N	59163	59163	59164
14802	18211	4	applied	\N	\N	\N	\N	59165	59165	59166
14807	18214	0	applied	\N	\N	\N	\N	59177	59177	59178
14807	18215	1	applied	\N	\N	\N	\N	59179	59179	59180
14807	18216	2	applied	\N	\N	\N	\N	59181	59181	59182
14809	18217	0	applied	\N	\N	\N	\N	59188	59188	59189
14700	17970	62	applied	\N	\N	\N	\N	58530	58530	58261
14700	17971	63	applied	\N	\N	\N	\N	58531	58531	58263
14700	17972	64	applied	\N	\N	\N	\N	58532	58532	58265
14700	17973	65	applied	\N	\N	\N	\N	58533	58533	58267
14700	17975	66	applied	\N	\N	\N	\N	58534	58534	58271
14700	17976	67	applied	\N	\N	\N	\N	58535	58535	58273
14702	18037	0	applied	\N	\N	\N	\N	58539	58539	58540
14702	18038	1	applied	\N	\N	\N	\N	58541	58541	58542
14702	18039	2	applied	\N	\N	\N	\N	58543	58543	58544
14702	18040	3	applied	\N	\N	\N	\N	58545	58545	58546
14709	18050	0	applied	\N	\N	\N	\N	58574	58574	58575
14709	18051	1	applied	\N	\N	\N	\N	58576	58576	58577
14709	18052	2	applied	\N	\N	\N	\N	58578	58578	58579
14709	18053	3	applied	\N	\N	\N	\N	58580	58580	58581
14709	18054	4	applied	\N	\N	\N	\N	58582	58582	58583
14709	18055	5	applied	\N	\N	\N	\N	58584	58584	58585
14715	18056	0	applied	\N	\N	\N	\N	58698	58698	58699
14715	18057	1	applied	\N	\N	\N	\N	58700	58700	58701
14715	18058	2	applied	\N	\N	\N	\N	58702	58702	58703
14715	18059	3	applied	\N	\N	\N	\N	58704	58704	58705
14715	18060	4	applied	\N	\N	\N	\N	58706	58706	58707
14715	18061	5	applied	\N	\N	\N	\N	58708	58708	58709
14715	18062	6	applied	\N	\N	\N	\N	58710	58710	58711
14715	18063	7	applied	\N	\N	\N	\N	58712	58712	58713
14715	18064	8	applied	\N	\N	\N	\N	58714	58714	58715
14715	18065	9	applied	\N	\N	\N	\N	58716	58716	58717
14717	18068	0	applied	\N	\N	\N	\N	58727	58727	58728
14717	18069	1	applied	\N	\N	\N	\N	58729	58729	58730
14719	18070	0	applied	\N	\N	\N	\N	58734	58734	58735
14719	18071	1	applied	\N	\N	\N	\N	58736	58736	58737
14722	18077	0	applied	\N	\N	\N	\N	58754	58754	58755
14722	18078	1	applied	\N	\N	\N	\N	58756	58756	58757
14727	18079	0	applied	\N	\N	\N	\N	58765	58765	58766
14727	18080	1	applied	\N	\N	\N	\N	58767	58767	58768
14727	18081	2	applied	\N	\N	\N	\N	58769	58769	58770
14727	18082	3	applied	\N	\N	\N	\N	58771	58771	58772
14729	18083	0	applied	\N	\N	\N	\N	58778	58778	58779
14729	18084	1	applied	\N	\N	\N	\N	58780	58780	58781
14733	18085	0	applied	\N	\N	\N	\N	58784	58784	58785
14733	18086	1	applied	\N	\N	\N	\N	58786	58786	58787
14733	18087	2	applied	\N	\N	\N	\N	58788	58788	58789
14733	18088	3	applied	\N	\N	\N	\N	58790	58790	58791
14733	18089	4	applied	\N	\N	\N	\N	58792	58792	58793
14733	18090	5	applied	\N	\N	\N	\N	58794	58794	58795
14733	18091	6	applied	\N	\N	\N	\N	58796	58796	58797
14733	18092	7	applied	\N	\N	\N	\N	58798	58798	58799
14737	18101	0	applied	\N	\N	\N	\N	58826	58826	58827
14737	18102	1	applied	\N	\N	\N	\N	58828	58828	58829
14743	18105	0	applied	\N	\N	\N	\N	58838	58838	58839
14743	18106	1	applied	\N	\N	\N	\N	58840	58840	58841
14743	18107	2	applied	\N	\N	\N	\N	58842	58842	58843
14743	18108	3	applied	\N	\N	\N	\N	58844	58844	58845
14744	18109	0	applied	\N	\N	\N	\N	58850	58850	58851
14744	18110	1	applied	\N	\N	\N	\N	58852	58852	58853
14748	18117	0	applied	\N	\N	\N	\N	58906	58906	58907
14748	18118	1	applied	\N	\N	\N	\N	58908	58908	58909
14751	18121	0	applied	\N	\N	\N	\N	58916	58916	58917
14751	18122	1	applied	\N	\N	\N	\N	58918	58918	58919
14753	18125	0	applied	\N	\N	\N	\N	58928	58928	58929
14753	18126	1	applied	\N	\N	\N	\N	58930	58930	58931
14764	18138	0	applied	\N	\N	\N	\N	58967	58967	58968
14764	18139	1	applied	\N	\N	\N	\N	58969	58969	58970
14764	18140	2	applied	\N	\N	\N	\N	58971	58971	58972
14764	18141	3	applied	\N	\N	\N	\N	58973	58973	58974
14764	18142	4	applied	\N	\N	\N	\N	58975	58975	58976
14764	18143	5	applied	\N	\N	\N	\N	58977	58977	58978
14766	18144	0	applied	\N	\N	\N	\N	58981	58981	58982
14766	18145	2	applied	\N	\N	\N	\N	58984	58984	58985
14766	18146	3	applied	\N	\N	\N	\N	58986	58986	58987
14766	18147	4	applied	\N	\N	\N	\N	58988	58988	58989
14771	18154	0	applied	\N	\N	\N	\N	59010	59010	59011
14771	18155	1	applied	\N	\N	\N	\N	59012	59012	59013
14778	18158	0	applied	\N	\N	\N	\N	59020	59020	59021
14778	18159	1	applied	\N	\N	\N	\N	59022	59022	59023
14778	18160	2	applied	\N	\N	\N	\N	59024	59024	59025
14778	18161	3	applied	\N	\N	\N	\N	59026	59026	59027
14778	18162	4	applied	\N	\N	\N	\N	59028	59028	59029
14778	18163	5	applied	\N	\N	\N	\N	59030	59030	59031
14785	18170	0	applied	\N	\N	\N	\N	59053	59053	59054
14785	18171	1	applied	\N	\N	\N	\N	59055	59055	59056
14785	18172	2	applied	\N	\N	\N	\N	59057	59057	59058
14785	18173	3	applied	\N	\N	\N	\N	59059	59059	59060
14796	18196	0	applied	\N	\N	\N	\N	59127	59127	59128
14796	18197	1	applied	\N	\N	\N	\N	59129	59129	51758
14796	18198	2	applied	\N	\N	\N	\N	59130	59130	59131
14801	18203	0	applied	\N	\N	\N	\N	59147	59147	59148
14801	18204	1	applied	\N	\N	\N	\N	59149	59149	59150
14801	18205	2	applied	\N	\N	\N	\N	59151	59151	59152
14801	18206	3	applied	\N	\N	\N	\N	59153	59153	59154
14804	18212	0	applied	\N	\N	\N	\N	59169	59169	59170
14804	18213	1	applied	\N	\N	\N	\N	59171	59171	59172
14830	18259	0	applied	\N	\N	\N	\N	59305	59305	59306
14830	18260	1	applied	\N	\N	\N	\N	59307	59307	59308
14830	18261	2	applied	\N	\N	\N	\N	59309	59309	59310
14830	18262	3	applied	\N	\N	\N	\N	59311	59311	59312
14832	18264	0	applied	\N	\N	\N	\N	59322	59322	59323
14832	18263	1	applied	\N	\N	\N	\N	59318	59318	59319
14835	18264	0	applied	\N	\N	\N	\N	59322	59322	59323
14835	18263	1	applied	\N	\N	\N	\N	59318	59318	59319
14840	18269	0	applied	\N	\N	\N	\N	59339	59339	59340
14840	18270	1	applied	\N	\N	\N	\N	59341	59341	59342
14840	18271	2	applied	\N	\N	\N	\N	59343	59343	59344
14840	18272	3	applied	\N	\N	\N	\N	59345	59345	59346
14840	18273	4	applied	\N	\N	\N	\N	59347	59347	59348
14840	18274	5	applied	\N	\N	\N	\N	59349	59349	59350
14840	18275	6	applied	\N	\N	\N	\N	59351	59351	59352
14840	18276	7	applied	\N	\N	\N	\N	59353	59353	59354
14841	18277	0	applied	\N	\N	\N	\N	59360	59360	59361
14841	18278	1	applied	\N	\N	\N	\N	59362	59362	59363
14841	18279	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	59364	59364	\N
14844	18280	0	applied	\N	\N	\N	\N	59367	59367	59368
14844	18281	1	applied	\N	\N	\N	\N	59369	59369	59370
14846	17887	0	applied	\N	\N	\N	\N	58338	58338	58074
14846	18209	1	applied	\N	\N	\N	\N	59161	59161	59162
14846	18220	2	applied	\N	\N	\N	\N	59317	59317	47675
14846	18215	3	applied	\N	\N	\N	\N	59179	59179	59196
14846	18197	4	applied	\N	\N	\N	\N	59129	59129	51758
14846	17889	5	applied	\N	\N	\N	\N	58339	58339	58078
14846	17890	6	applied	\N	\N	\N	\N	58340	58340	58080
14711	17728	21	applied	\N	\N	\N	\N	57620	57620	57621
14711	17729	22	applied	\N	\N	\N	\N	57622	57622	57623
14711	17733	24	applied	\N	\N	\N	\N	57631	57631	57632
14711	17734	25	applied	\N	\N	\N	\N	57633	57633	57634
14711	17895	26	applied	\N	\N	\N	\N	58343	58343	58091
14711	17896	27	applied	\N	\N	\N	\N	58344	58344	58093
14711	17897	28	applied	\N	\N	\N	\N	58345	58345	58095
14711	17898	29	applied	\N	\N	\N	\N	58346	58346	58097
14711	17899	30	applied	\N	\N	\N	\N	58347	58347	58099
14711	17901	31	applied	\N	\N	\N	\N	58348	58348	58105
14711	17905	32	applied	\N	\N	\N	\N	58349	58349	58113
14711	17906	33	applied	\N	\N	\N	\N	58350	58350	58115
14711	17907	34	applied	\N	\N	\N	\N	58351	58351	58117
14711	17908	35	applied	\N	\N	\N	\N	58352	58352	58119
14711	17909	36	applied	\N	\N	\N	\N	58353	58353	58121
14711	17910	37	applied	\N	\N	\N	\N	58354	58354	58123
14711	17911	38	applied	\N	\N	\N	\N	58355	58355	58125
14711	17912	39	applied	\N	\N	\N	\N	58356	58356	58127
14711	17913	40	applied	\N	\N	\N	\N	58357	58357	58129
14711	17914	41	applied	\N	\N	\N	\N	58358	58358	58131
14711	17915	42	applied	\N	\N	\N	\N	58359	58359	58133
14711	17916	43	applied	\N	\N	\N	\N	58360	58360	58135
14711	17917	44	applied	\N	\N	\N	\N	58361	58361	58137
14711	17918	45	applied	\N	\N	\N	\N	58362	58362	58139
14711	17919	46	applied	\N	\N	\N	\N	58363	58363	58141
14711	17920	47	applied	\N	\N	\N	\N	58364	58364	58143
14711	17921	48	applied	\N	\N	\N	\N	58365	58365	58145
14711	17925	49	applied	\N	\N	\N	\N	58366	58366	58155
14711	17926	50	applied	\N	\N	\N	\N	58367	58367	58157
14711	17927	51	applied	\N	\N	\N	\N	58368	58368	58159
14711	17929	52	applied	\N	\N	\N	\N	58369	58369	58163
14711	17930	53	applied	\N	\N	\N	\N	58370	58370	58165
14711	17931	54	applied	\N	\N	\N	\N	58589	58589	58167
14711	17934	55	applied	\N	\N	\N	\N	58590	58590	58176
14711	17935	56	applied	\N	\N	\N	\N	58591	58591	58178
14711	17936	57	applied	\N	\N	\N	\N	58592	58592	58180
14711	17937	58	applied	\N	\N	\N	\N	58593	58593	58182
14711	17938	59	applied	\N	\N	\N	\N	58594	58594	58184
14711	17939	60	applied	\N	\N	\N	\N	58595	58595	58186
14711	17944	61	applied	\N	\N	\N	\N	58596	58596	58202
14711	17945	62	applied	\N	\N	\N	\N	58597	58597	58204
14711	17946	63	applied	\N	\N	\N	\N	58598	58598	58206
14711	17947	64	applied	\N	\N	\N	\N	58599	58599	58208
14711	17948	65	applied	\N	\N	\N	\N	58600	58600	58210
14711	17949	66	applied	\N	\N	\N	\N	58601	58601	58212
14711	17950	67	applied	\N	\N	\N	\N	58602	58602	58214
14711	17951	68	applied	\N	\N	\N	\N	58603	58603	58216
14711	17952	69	applied	\N	\N	\N	\N	58604	58604	58218
14711	17953	70	applied	\N	\N	\N	\N	58605	58605	58220
14711	17954	71	applied	\N	\N	\N	\N	58606	58606	58222
14711	17955	72	applied	\N	\N	\N	\N	58607	58607	58224
14711	17956	73	applied	\N	\N	\N	\N	58608	58608	58226
14711	17957	74	applied	\N	\N	\N	\N	58609	58609	58228
14711	17958	75	applied	\N	\N	\N	\N	58610	58610	58230
14711	17959	76	applied	\N	\N	\N	\N	58611	58611	58232
14711	17960	77	applied	\N	\N	\N	\N	58612	58612	58234
14711	17961	78	applied	\N	\N	\N	\N	58613	58613	58236
14711	17965	79	applied	\N	\N	\N	\N	58614	58614	58251
14711	17967	80	applied	\N	\N	\N	\N	58615	58615	58255
14711	17968	81	applied	\N	\N	\N	\N	58616	58616	58257
14711	17969	82	applied	\N	\N	\N	\N	58617	58617	58259
14711	17970	83	applied	\N	\N	\N	\N	58618	58618	58261
14711	17971	84	applied	\N	\N	\N	\N	58619	58619	58263
14711	17972	85	applied	\N	\N	\N	\N	58620	58620	58265
14711	17973	86	applied	\N	\N	\N	\N	58621	58621	58267
14711	17975	87	applied	\N	\N	\N	\N	58622	58622	58271
14711	17976	88	applied	\N	\N	\N	\N	58623	58623	58273
14711	17977	89	applied	\N	\N	\N	\N	58624	58624	58276
14711	17978	90	applied	\N	\N	\N	\N	58625	58625	58278
14711	17984	91	applied	\N	\N	\N	\N	58626	58626	58292
14711	17985	92	applied	\N	\N	\N	\N	58627	58627	58294
14711	17986	93	applied	\N	\N	\N	\N	58628	58628	58296
14711	17987	94	applied	\N	\N	\N	\N	58629	58629	58298
14711	17988	95	applied	\N	\N	\N	\N	58630	58630	58300
14711	17989	96	applied	\N	\N	\N	\N	58631	58631	58302
14711	17990	97	applied	\N	\N	\N	\N	58632	58632	58304
14711	17991	98	applied	\N	\N	\N	\N	58633	58633	58306
14711	17992	99	applied	\N	\N	\N	\N	58634	58634	58308
14711	17993	100	applied	\N	\N	\N	\N	58635	58635	58310
14711	17994	101	applied	\N	\N	\N	\N	58636	58636	58312
14711	17995	102	applied	\N	\N	\N	\N	58637	58637	58314
14711	17996	103	applied	\N	\N	\N	\N	58638	58638	58316
14711	17997	104	applied	\N	\N	\N	\N	58639	58639	58318
14711	17998	105	applied	\N	\N	\N	\N	58640	58640	58320
14711	17999	106	applied	\N	\N	\N	\N	58641	58641	58322
14711	18000	107	applied	\N	\N	\N	\N	58642	58642	58324
14711	18001	108	applied	\N	\N	\N	\N	58643	58643	58326
14711	18005	109	applied	\N	\N	\N	\N	58644	58644	58378
14711	18007	110	applied	\N	\N	\N	\N	58645	58645	58382
14711	18008	111	applied	\N	\N	\N	\N	58646	58646	58384
14711	18009	112	applied	\N	\N	\N	\N	58647	58647	58386
14711	18010	113	applied	\N	\N	\N	\N	58648	58648	58388
14711	18011	114	applied	\N	\N	\N	\N	58649	58649	58390
14711	18015	115	applied	\N	\N	\N	\N	58650	58650	58401
14711	18016	116	applied	\N	\N	\N	\N	58651	58651	58403
14711	18017	117	applied	\N	\N	\N	\N	58652	58652	58405
14711	18018	118	applied	\N	\N	\N	\N	58653	58653	58407
14711	18019	119	applied	\N	\N	\N	\N	58654	58654	58409
14711	18022	120	applied	\N	\N	\N	\N	58655	58655	58419
14711	18023	121	applied	\N	\N	\N	\N	58656	58656	58421
14711	18024	122	applied	\N	\N	\N	\N	58657	58657	58423
14711	18025	123	applied	\N	\N	\N	\N	58658	58658	58425
14711	17735	124	applied	\N	\N	\N	\N	57635	57635	57636
14711	17739	125	applied	\N	\N	\N	\N	57649	57649	57650
14714	18056	0	applied	\N	\N	\N	\N	58698	58698	58699
14714	18057	1	applied	\N	\N	\N	\N	58700	58700	58701
14714	18058	2	applied	\N	\N	\N	\N	58702	58702	58703
14714	18059	3	applied	\N	\N	\N	\N	58704	58704	58705
14714	18060	4	applied	\N	\N	\N	\N	58706	58706	58707
14714	18061	5	applied	\N	\N	\N	\N	58708	58708	58709
14714	18062	6	applied	\N	\N	\N	\N	58710	58710	58711
14714	18063	7	applied	\N	\N	\N	\N	58712	58712	58713
14714	18064	8	applied	\N	\N	\N	\N	58714	58714	58715
14714	18065	9	applied	\N	\N	\N	\N	58716	58716	58717
14716	18066	0	applied	\N	\N	\N	\N	58721	58721	58722
14716	18067	1	applied	\N	\N	\N	\N	58723	58723	58724
14725	18077	0	applied	\N	\N	\N	\N	58754	58754	58755
14725	18078	1	applied	\N	\N	\N	\N	58756	58756	58757
14726	18079	0	applied	\N	\N	\N	\N	58765	58765	58766
14726	18080	1	applied	\N	\N	\N	\N	58767	58767	58768
14721	18076	0	applied	\N	\N	\N	\N	58750	58750	58751
14724	18077	0	applied	\N	\N	\N	\N	58754	58754	58755
14724	18078	1	applied	\N	\N	\N	\N	58756	58756	58757
14728	18079	0	applied	\N	\N	\N	\N	58765	58765	58766
14728	18080	1	applied	\N	\N	\N	\N	58767	58767	58768
14728	18081	2	applied	\N	\N	\N	\N	58769	58769	58770
14728	18082	3	applied	\N	\N	\N	\N	58771	58771	58772
14731	18085	0	applied	\N	\N	\N	\N	58784	58784	58785
14731	18086	1	applied	\N	\N	\N	\N	58786	58786	58787
14731	18087	2	applied	\N	\N	\N	\N	58788	58788	58789
14731	18088	3	applied	\N	\N	\N	\N	58790	58790	58791
14731	18089	4	applied	\N	\N	\N	\N	58792	58792	58793
14731	18090	5	applied	\N	\N	\N	\N	58794	58794	58795
14731	18091	6	applied	\N	\N	\N	\N	58796	58796	58797
14731	18092	7	applied	\N	\N	\N	\N	58798	58798	58799
14736	18093	0	applied	\N	\N	\N	\N	58808	58808	58809
14736	18094	1	applied	\N	\N	\N	\N	58810	58810	58811
14736	18095	2	applied	\N	\N	\N	\N	58812	58812	58813
14736	18096	3	applied	\N	\N	\N	\N	58814	58814	58815
14736	18097	4	applied	\N	\N	\N	\N	58816	58816	58817
14736	18098	5	applied	\N	\N	\N	\N	58818	58818	58819
14736	18099	6	applied	\N	\N	\N	\N	58820	58820	58821
14736	18100	7	applied	\N	\N	\N	\N	58822	58822	58823
14738	18101	0	applied	\N	\N	\N	\N	58826	58826	58827
14738	18102	1	applied	\N	\N	\N	\N	58828	58828	58829
14741	18105	0	applied	\N	\N	\N	\N	58838	58838	58839
14741	18106	1	applied	\N	\N	\N	\N	58840	58840	58841
14741	18107	2	applied	\N	\N	\N	\N	58842	58842	58843
14741	18108	3	applied	\N	\N	\N	\N	58844	58844	58845
14747	18113	0	applied	\N	\N	\N	\N	58896	58896	58897
14747	18114	1	applied	\N	\N	\N	\N	58898	58898	58899
14747	18115	2	applied	\N	\N	\N	\N	58900	58900	58901
14747	18116	3	applied	\N	\N	\N	\N	58902	58902	58903
14752	18123	0	applied	\N	\N	\N	\N	58922	58922	58923
14752	18124	1	applied	\N	\N	\N	\N	58924	58924	58925
14757	18131	0	applied	\N	\N	\N	\N	58945	58945	58946
14759	18132	0	applied	\N	\N	\N	\N	58950	58950	58951
14759	18133	1	applied	\N	\N	\N	\N	58952	58952	58953
14762	18136	0	applied	\N	\N	\N	\N	58960	58960	58961
14762	18137	1	applied	\N	\N	\N	\N	58962	58962	58963
14765	18144	0	applied	\N	\N	\N	\N	58981	58981	58982
14765	18145	2	applied	\N	\N	\N	\N	58984	58984	58985
14765	18146	3	applied	\N	\N	\N	\N	58986	58986	58987
14765	18147	4	applied	\N	\N	\N	\N	58988	58988	58989
14767	18148	0	applied	\N	\N	\N	\N	58992	58992	58993
14767	18149	1	applied	\N	\N	\N	\N	58994	58994	58995
14772	18156	0	applied	\N	\N	\N	\N	59015	59015	59016
14772	18157	1	applied	\N	\N	\N	\N	59017	59017	59018
14777	18158	0	applied	\N	\N	\N	\N	59020	59020	59021
14777	18159	1	applied	\N	\N	\N	\N	59022	59022	59023
14777	18160	2	applied	\N	\N	\N	\N	59024	59024	59025
14777	18161	3	applied	\N	\N	\N	\N	59026	59026	59027
14777	18162	4	applied	\N	\N	\N	\N	59028	59028	59029
14777	18163	5	applied	\N	\N	\N	\N	59030	59030	59031
14779	18164	0	applied	\N	\N	\N	\N	59035	59035	59036
14779	18165	1	applied	\N	\N	\N	\N	59037	59037	59038
14784	18170	0	applied	\N	\N	\N	\N	59053	59053	59054
14784	18171	1	applied	\N	\N	\N	\N	59055	59055	59056
14784	18172	2	applied	\N	\N	\N	\N	59057	59057	59058
14784	18173	3	applied	\N	\N	\N	\N	59059	59059	59060
14787	18174	0	applied	\N	\N	\N	\N	59064	59064	59065
14787	18175	1	applied	\N	\N	\N	\N	59066	59066	59067
14789	18178	0	applied	\N	\N	\N	\N	59078	59078	59079
14789	18179	1	applied	\N	\N	\N	\N	59080	59080	59081
14789	18180	2	applied	\N	\N	\N	\N	59082	59082	59083
14789	18181	3	applied	\N	\N	\N	\N	59084	59084	59085
14792	18186	0	applied	\N	\N	\N	\N	59099	59099	59100
14792	18187	1	applied	\N	\N	\N	\N	59101	59101	59102
14795	18194	0	applied	\N	\N	\N	\N	59121	59121	59122
14795	18195	1	applied	\N	\N	\N	\N	59123	59123	59124
14803	18212	0	applied	\N	\N	\N	\N	59169	59169	59170
14803	18213	1	applied	\N	\N	\N	\N	59171	59171	59172
14805	18214	0	applied	\N	\N	\N	\N	59177	59177	59178
14805	18215	1	applied	\N	\N	\N	\N	59179	59179	59180
14805	18216	2	applied	\N	\N	\N	\N	59181	59181	59182
14808	18215	0	applied	\N	\N	\N	\N	59179	59179	59180
14813	18220	0	applied	\N	\N	\N	\N	59196	59196	47675
14813	18221	1	applied	\N	\N	\N	\N	59197	59197	59198
14813	18222	2	applied	\N	\N	\N	\N	59203	59203	59204
14813	18223	3	applied	\N	\N	\N	\N	59205	59205	59206
14813	18224	4	applied	\N	\N	\N	\N	59207	59207	59208
14813	18225	5	applied	\N	\N	\N	\N	59209	59209	59210
14813	18226	6	applied	\N	\N	\N	\N	59211	59211	59212
14813	18227	7	applied	\N	\N	\N	\N	59213	59213	59214
14813	18228	8	applied	\N	\N	\N	\N	59215	59215	59216
14815	18231	0	applied	\N	\N	\N	\N	59225	59225	59226
14815	18232	1	applied	\N	\N	\N	\N	59227	59227	59228
14818	18237	0	applied	\N	\N	\N	\N	59243	59243	59244
14818	18238	1	applied	\N	\N	\N	\N	59245	59245	59246
14818	18239	2	applied	\N	\N	\N	\N	59247	59247	59248
14818	18240	3	applied	\N	\N	\N	\N	59249	59249	59250
14821	18243	0	applied	\N	\N	\N	\N	59259	59259	59260
14821	18244	1	applied	\N	\N	\N	\N	59261	59261	59262
14823	18246	0	applied	\N	\N	\N	\N	59269	59269	59270
14826	18251	0	applied	\N	\N	\N	\N	59285	59285	59286
14826	18252	1	applied	\N	\N	\N	\N	59287	59287	59288
14826	18253	2	applied	\N	\N	\N	\N	59289	59289	59290
14826	18254	3	applied	\N	\N	\N	\N	59291	59291	59292
14826	18255	4	applied	\N	\N	\N	\N	59293	59293	59294
14826	18256	5	applied	\N	\N	\N	\N	59295	59295	59296
14829	18259	0	applied	\N	\N	\N	\N	59305	59305	59306
14829	18260	1	applied	\N	\N	\N	\N	59307	59307	59308
14829	18261	2	applied	\N	\N	\N	\N	59309	59309	59310
14829	18262	3	applied	\N	\N	\N	\N	59311	59311	59312
14831	18209	0	applied	\N	\N	\N	\N	59161	59161	59162
14831	18220	1	applied	\N	\N	\N	\N	59317	59317	47675
14831	18215	2	applied	\N	\N	\N	\N	59179	59179	59196
14831	18197	3	applied	\N	\N	\N	\N	59129	59129	51758
14831	18155	4	applied	\N	\N	\N	\N	59012	59012	59013
14831	18157	5	applied	\N	\N	\N	\N	59017	59017	59018
14831	18161	6	applied	\N	\N	\N	\N	59026	59026	59027
14831	18162	7	applied	\N	\N	\N	\N	59028	59028	59029
14831	18218	8	applied	\N	\N	\N	\N	59190	59190	25661
14831	18163	9	applied	\N	\N	\N	\N	59030	59030	59031
14831	18165	10	applied	\N	\N	\N	\N	59037	59037	59038
14831	18167	11	applied	\N	\N	\N	\N	59044	59044	59045
14831	18169	12	applied	\N	\N	\N	\N	59049	59049	59050
14831	18172	13	applied	\N	\N	\N	\N	59057	59057	59058
14831	18173	14	applied	\N	\N	\N	\N	59059	59059	59060
14831	18175	15	applied	\N	\N	\N	\N	59066	59066	59067
14726	18081	2	applied	\N	\N	\N	\N	58769	58769	58770
14726	18082	3	applied	\N	\N	\N	\N	58771	58771	58772
14732	18085	0	applied	\N	\N	\N	\N	58784	58784	58785
14732	18086	1	applied	\N	\N	\N	\N	58786	58786	58787
14732	18087	2	applied	\N	\N	\N	\N	58788	58788	58789
14732	18088	3	applied	\N	\N	\N	\N	58790	58790	58791
14732	18089	4	applied	\N	\N	\N	\N	58792	58792	58793
14732	18090	5	applied	\N	\N	\N	\N	58794	58794	58795
14732	18091	6	applied	\N	\N	\N	\N	58796	58796	58797
14732	18092	7	applied	\N	\N	\N	\N	58798	58798	58799
14739	18103	0	applied	\N	\N	\N	\N	58833	58833	58834
14739	18104	1	applied	\N	\N	\N	\N	58835	58835	58836
14742	18105	0	applied	\N	\N	\N	\N	58838	58838	58839
14742	18106	1	applied	\N	\N	\N	\N	58840	58840	58841
14742	18107	2	applied	\N	\N	\N	\N	58842	58842	58843
14742	18108	3	applied	\N	\N	\N	\N	58844	58844	58845
14745	17705	0	applied	\N	\N	1000000000	\N	57553	57553	57554
14745	17887	1	applied	\N	\N	\N	\N	58468	58468	58074
14745	17889	2	applied	\N	\N	\N	\N	58469	58469	58078
14745	17890	3	applied	\N	\N	\N	\N	58470	58470	58080
14745	17891	4	applied	\N	\N	\N	\N	58471	58471	58082
14745	17893	5	applied	\N	\N	\N	\N	58472	58472	58087
14745	17895	6	applied	\N	\N	\N	\N	58473	58473	58091
14745	17896	7	applied	\N	\N	\N	\N	58474	58474	58093
14745	17897	8	applied	\N	\N	\N	\N	58475	58475	58095
14745	17898	9	applied	\N	\N	\N	\N	58476	58476	58097
14745	17899	10	applied	\N	\N	\N	\N	58477	58477	58099
14745	17901	11	applied	\N	\N	\N	\N	58478	58478	58105
14745	17905	12	applied	\N	\N	\N	\N	58479	58479	58113
14745	17906	13	applied	\N	\N	\N	\N	58480	58480	58115
14745	17907	14	applied	\N	\N	\N	\N	58481	58481	58117
14745	17908	15	applied	\N	\N	\N	\N	58482	58482	58119
14745	17909	16	applied	\N	\N	\N	\N	58483	58483	58121
14745	17910	17	applied	\N	\N	\N	\N	58484	58484	58123
14745	17911	18	applied	\N	\N	\N	\N	58485	58485	58125
14745	17912	19	applied	\N	\N	\N	\N	58486	58486	58127
14745	17913	20	applied	\N	\N	\N	\N	58487	58487	58129
14745	17914	21	applied	\N	\N	\N	\N	58488	58488	58131
14745	17915	22	applied	\N	\N	\N	\N	58489	58489	58133
14745	17916	23	applied	\N	\N	\N	\N	58490	58490	58135
14745	17917	24	applied	\N	\N	\N	\N	58491	58491	58137
14745	17918	25	applied	\N	\N	\N	\N	58492	58492	58139
14745	17919	26	applied	\N	\N	\N	\N	58493	58493	58141
14745	17920	27	applied	\N	\N	\N	\N	58494	58494	58143
14745	17921	28	applied	\N	\N	\N	\N	58495	58495	58145
14745	17925	29	applied	\N	\N	\N	\N	58496	58496	58155
14745	17926	30	applied	\N	\N	\N	\N	58497	58497	58157
14745	17927	31	applied	\N	\N	\N	\N	58498	58498	58159
14745	17929	32	applied	\N	\N	\N	\N	58499	58499	58163
14745	17930	33	applied	\N	\N	\N	\N	58500	58500	58165
14745	17931	34	applied	\N	\N	\N	\N	58501	58501	58167
14745	17934	35	applied	\N	\N	\N	\N	58502	58502	58176
14745	17935	36	applied	\N	\N	\N	\N	58503	58503	58178
14745	17936	37	applied	\N	\N	\N	\N	58504	58504	58180
14745	17937	38	applied	\N	\N	\N	\N	58505	58505	58182
14745	17938	39	applied	\N	\N	\N	\N	58506	58506	58184
14745	17939	40	applied	\N	\N	\N	\N	58507	58507	58186
14745	17944	41	applied	\N	\N	\N	\N	58508	58508	58202
14745	17945	42	applied	\N	\N	\N	\N	58509	58509	58204
14745	17946	43	applied	\N	\N	\N	\N	58510	58510	58206
14745	17947	44	applied	\N	\N	\N	\N	58511	58511	58208
14745	17948	46	applied	\N	\N	\N	\N	58512	58512	58210
14745	17949	47	applied	\N	\N	\N	\N	58513	58513	58212
14745	17950	48	applied	\N	\N	\N	\N	58514	58514	58214
14745	17951	49	applied	\N	\N	\N	\N	58515	58515	58216
14745	17952	50	applied	\N	\N	\N	\N	58516	58516	58218
14745	17953	51	applied	\N	\N	\N	\N	58517	58517	58220
14745	17954	52	applied	\N	\N	\N	\N	58518	58518	58222
14745	17955	53	applied	\N	\N	\N	\N	58519	58519	58224
14745	17956	54	applied	\N	\N	\N	\N	58520	58520	58226
14745	17957	55	applied	\N	\N	\N	\N	58521	58521	58228
14745	17958	56	applied	\N	\N	\N	\N	58522	58522	58230
14745	17959	57	applied	\N	\N	\N	\N	58523	58523	58232
14745	17960	58	applied	\N	\N	\N	\N	58524	58524	58234
14745	17961	59	applied	\N	\N	\N	\N	58525	58525	58236
14745	17965	60	applied	\N	\N	\N	\N	58526	58526	58251
14745	17967	61	applied	\N	\N	\N	\N	58527	58527	58255
14745	17968	62	applied	\N	\N	\N	\N	58528	58528	58257
14745	17969	63	applied	\N	\N	\N	\N	58529	58529	58259
14745	17970	64	applied	\N	\N	\N	\N	58530	58530	58261
14745	17971	65	applied	\N	\N	\N	\N	58531	58531	58263
14745	17972	66	applied	\N	\N	\N	\N	58532	58532	58265
14745	17973	67	applied	\N	\N	\N	\N	58533	58533	58267
14745	17975	68	applied	\N	\N	\N	\N	58534	58534	58271
14745	17976	69	applied	\N	\N	\N	\N	58535	58535	58273
14745	17977	70	applied	\N	\N	\N	\N	58857	58857	58276
14745	17978	71	applied	\N	\N	\N	\N	58858	58858	58278
14745	17984	72	applied	\N	\N	\N	\N	58859	58859	58292
14745	17985	73	applied	\N	\N	\N	\N	58860	58860	58294
14745	17986	74	applied	\N	\N	\N	\N	58861	58861	58296
14745	17987	75	applied	\N	\N	\N	\N	58862	58862	58298
14745	17988	76	applied	\N	\N	\N	\N	58863	58863	58300
14745	17989	77	applied	\N	\N	\N	\N	58864	58864	58302
14745	17990	78	applied	\N	\N	\N	\N	58865	58865	58304
14745	17991	79	applied	\N	\N	\N	\N	58866	58866	58306
14745	17992	80	applied	\N	\N	\N	\N	58867	58867	58308
14745	17993	81	applied	\N	\N	\N	\N	58868	58868	58310
14745	17994	82	applied	\N	\N	\N	\N	58869	58869	58312
14745	17995	83	applied	\N	\N	\N	\N	58870	58870	58314
14745	17996	84	applied	\N	\N	\N	\N	58871	58871	58316
14745	17997	85	applied	\N	\N	\N	\N	58872	58872	58318
14745	17998	86	applied	\N	\N	\N	\N	58873	58873	58320
14745	17999	87	applied	\N	\N	\N	\N	58874	58874	58322
14745	18000	88	applied	\N	\N	\N	\N	58875	58875	58324
14745	18001	89	applied	\N	\N	\N	\N	58876	58876	58326
14745	18005	90	applied	\N	\N	\N	\N	58877	58877	58378
14745	18007	91	applied	\N	\N	\N	\N	58878	58878	58382
14745	18008	92	applied	\N	\N	\N	\N	58879	58879	58384
14745	18009	93	applied	\N	\N	\N	\N	58880	58880	58386
14745	18010	94	applied	\N	\N	\N	\N	58881	58881	58388
14745	18011	95	applied	\N	\N	\N	\N	58882	58882	58390
14745	18015	96	applied	\N	\N	\N	\N	58883	58883	58401
14745	18016	97	applied	\N	\N	\N	\N	58884	58884	58403
14745	18017	98	applied	\N	\N	\N	\N	58885	58885	58405
14745	18018	99	applied	\N	\N	\N	\N	58886	58886	58407
14745	18019	100	applied	\N	\N	\N	\N	58887	58887	58409
14750	18121	0	applied	\N	\N	\N	\N	58916	58916	58917
14750	18122	1	applied	\N	\N	\N	\N	58918	58918	58919
14755	18127	0	applied	\N	\N	\N	\N	58933	58933	58934
14755	18128	1	applied	\N	\N	\N	\N	58935	58935	58936
14758	18131	0	applied	\N	\N	\N	\N	58945	58945	58946
14760	18134	0	applied	\N	\N	\N	\N	58955	58955	58956
14760	18135	1	applied	\N	\N	\N	\N	58957	58957	58958
14763	18138	0	applied	\N	\N	\N	\N	58967	58967	58968
14763	18139	1	applied	\N	\N	\N	\N	58969	58969	58970
14763	18140	2	applied	\N	\N	\N	\N	58971	58971	58972
14763	18141	3	applied	\N	\N	\N	\N	58973	58973	58974
14763	18142	4	applied	\N	\N	\N	\N	58975	58975	58976
14763	18143	5	applied	\N	\N	\N	\N	58977	58977	58978
14768	18148	0	applied	\N	\N	\N	\N	58992	58992	58993
14768	18149	1	applied	\N	\N	\N	\N	58994	58994	58995
14770	18150	0	applied	\N	\N	\N	\N	59000	59000	59001
14770	18151	1	applied	\N	\N	\N	\N	59002	59002	59003
14770	18152	2	applied	\N	\N	\N	\N	59004	59004	59005
14770	18153	3	applied	\N	\N	\N	\N	59006	59006	59007
14782	18166	0	applied	\N	\N	\N	\N	59042	59042	59043
14782	18167	1	applied	\N	\N	\N	\N	59044	59044	59045
14790	18182	0	applied	\N	\N	\N	\N	59087	59087	59088
14790	18183	1	applied	\N	\N	\N	\N	59089	59089	59090
14793	18188	0	applied	\N	\N	\N	\N	59105	59105	59106
14793	18189	1	applied	\N	\N	\N	\N	59107	59107	59108
14793	18190	2	applied	\N	\N	\N	\N	59109	59109	59110
14793	18191	3	applied	\N	\N	\N	\N	59111	59111	59112
14793	18192	4	applied	\N	\N	\N	\N	59113	59113	59114
14793	18193	5	applied	\N	\N	\N	\N	59115	59115	59116
14798	18199	0	applied	\N	\N	\N	\N	59135	59135	59136
14798	18200	1	applied	\N	\N	\N	\N	59137	59137	59138
14800	18201	0	applied	\N	\N	\N	\N	59141	59141	59142
14800	18202	1	applied	\N	\N	\N	\N	59143	59143	59144
14806	18214	0	applied	\N	\N	\N	\N	59177	59177	59178
14806	18215	1	applied	\N	\N	\N	\N	59179	59179	59180
14811	18220	0	applied	\N	\N	\N	\N	59196	59196	47675
14811	18221	1	applied	\N	\N	\N	\N	59197	59197	59198
14817	18235	0	applied	\N	\N	\N	\N	59237	59237	59238
14817	18236	1	applied	\N	\N	\N	\N	59239	59239	59240
14820	18243	0	applied	\N	\N	\N	\N	59259	59259	59260
14820	18244	1	applied	\N	\N	\N	\N	59261	59261	59262
14822	18245	0	applied	\N	\N	\N	\N	59267	59267	59268
14822	18246	1	applied	\N	\N	\N	\N	59269	59269	59270
14825	18247	0	applied	\N	\N	\N	\N	59273	59273	59274
14825	18248	1	applied	\N	\N	\N	\N	59275	59275	59276
14825	18249	2	applied	\N	\N	\N	\N	59277	59277	59278
14825	18250	3	applied	\N	\N	\N	\N	59279	59279	59280
14828	18259	0	applied	\N	\N	\N	\N	59305	59305	59306
14828	18260	1	applied	\N	\N	\N	\N	59307	59307	59308
14828	18261	2	applied	\N	\N	\N	\N	59309	59309	59310
14828	18262	3	applied	\N	\N	\N	\N	59311	59311	59312
14833	18264	0	applied	\N	\N	\N	\N	59322	59322	59323
14833	18263	1	applied	\N	\N	\N	\N	59318	59318	59319
14837	18267	0	applied	\N	\N	\N	\N	59334	59334	59335
14837	18268	1	applied	\N	\N	\N	\N	59336	59336	59337
14838	18269	0	applied	\N	\N	\N	\N	59339	59339	59340
14838	18270	1	applied	\N	\N	\N	\N	59341	59341	59342
14838	18271	2	applied	\N	\N	\N	\N	59343	59343	59344
14838	18272	3	applied	\N	\N	\N	\N	59345	59345	59346
14838	18273	4	applied	\N	\N	\N	\N	59347	59347	59348
14838	18274	5	applied	\N	\N	\N	\N	59349	59349	59350
14838	18275	6	applied	\N	\N	\N	\N	59351	59351	59352
14838	18276	7	applied	\N	\N	\N	\N	59353	59353	59354
14843	18280	0	applied	\N	\N	\N	\N	59367	59367	59368
14843	18281	1	applied	\N	\N	\N	\N	59369	59369	59370
14856	18296	0	applied	\N	\N	\N	\N	59414	59414	59415
14856	18297	1	applied	\N	\N	\N	\N	59416	59416	59417
14856	18298	2	applied	\N	\N	\N	\N	59418	59418	59419
14863	18304	0	applied	\N	\N	\N	\N	59441	59441	59442
14863	18301	1	applied	\N	\N	\N	\N	59425	59425	59426
14863	18302	2	applied	\N	\N	\N	\N	59427	59427	59428
14863	18303	3	applied	\N	\N	\N	\N	59429	59429	59430
14863	18305	4	applied	\N	\N	\N	\N	59443	59443	59444
14867	18310	0	applied	\N	\N	\N	\N	59468	59468	59469
14867	18311	1	applied	\N	\N	\N	\N	59470	59470	59471
14872	18312	0	applied	\N	\N	1000000000	\N	59477	59477	59478
14872	18313	1	applied	\N	\N	\N	\N	59479	59479	59480
14872	18314	2	applied	\N	\N	\N	\N	59481	59481	59482
14872	18315	3	applied	\N	\N	\N	\N	59483	59483	59484
14872	18316	4	applied	\N	\N	\N	\N	59485	59485	59486
14872	18317	5	applied	\N	\N	\N	\N	59487	59487	59488
14872	18318	6	applied	\N	\N	\N	\N	59489	59489	59490
14875	18319	0	applied	\N	\N	\N	\N	59495	59495	59496
14875	18320	1	applied	\N	\N	\N	\N	59497	59497	59498
14879	18332	0	applied	\N	\N	\N	\N	59525	59525	59526
14879	18333	1	applied	\N	\N	\N	\N	59527	59527	59528
14879	18334	2	applied	\N	\N	\N	\N	59529	59529	59530
14882	18335	0	applied	\N	\N	1000000000	\N	59533	59533	59534
14882	18336	1	applied	\N	\N	1000000000	\N	59535	59535	59536
14882	18337	2	applied	\N	\N	\N	\N	59537	59537	59538
14882	18338	3	applied	\N	\N	\N	\N	59539	59539	59540
14882	18339	4	applied	\N	\N	\N	\N	59541	59541	59542
14882	18340	5	applied	\N	\N	\N	\N	59543	59543	59544
14882	18341	6	applied	\N	\N	\N	\N	59545	59545	59546
14882	18342	7	applied	\N	\N	\N	\N	59547	59547	59548
14882	18343	8	applied	\N	\N	\N	\N	59549	59549	59550
14884	18349	0	applied	\N	\N	\N	\N	59565	59565	59566
14884	18350	1	applied	\N	\N	\N	\N	59567	59567	59568
14884	18351	2	applied	\N	\N	\N	\N	59569	59569	59570
14888	18376	0	applied	\N	\N	\N	\N	59624	59624	59625
14888	18377	1	applied	\N	\N	\N	\N	59626	59626	59627
14888	18378	2	applied	\N	\N	\N	\N	59628	59628	59629
14888	18379	3	applied	\N	\N	\N	\N	59630	59630	59631
14893	18388	0	applied	\N	\N	\N	\N	59655	59655	59656
14893	18389	1	applied	\N	\N	\N	\N	59657	59657	59658
14893	18390	3	applied	\N	\N	\N	\N	59660	59660	59661
14893	18391	4	applied	\N	\N	\N	\N	59662	59662	59663
14893	18392	5	applied	\N	\N	\N	\N	59664	59664	59665
14893	18393	6	applied	\N	\N	\N	\N	59666	59666	59667
14893	18394	7	applied	\N	\N	\N	\N	59668	59668	59669
14893	18395	8	applied	\N	\N	\N	\N	59670	59670	59671
14899	18396	0	applied	\N	\N	\N	\N	59678	59678	59679
14899	18397	1	applied	\N	\N	\N	\N	59680	59680	59681
14899	18398	2	applied	\N	\N	\N	\N	59682	59682	59683
14899	18399	3	applied	\N	\N	\N	\N	59684	59684	59685
14910	18418	0	applied	\N	\N	\N	\N	59743	59743	59744
14910	18419	1	applied	\N	\N	\N	\N	59745	59745	59746
14910	18420	2	applied	\N	\N	\N	\N	59747	59747	59748
14910	18421	3	applied	\N	\N	\N	\N	59749	59749	59750
14919	18442	0	applied	\N	\N	\N	\N	59800	59800	59801
14919	18443	1	applied	\N	\N	\N	\N	59802	59802	59803
14919	18444	2	applied	\N	\N	\N	\N	59804	59804	59805
14921	18445	0	applied	\N	\N	\N	\N	59811	59811	59812
14809	18218	1	applied	\N	\N	\N	\N	59190	59190	25661
14809	18219	2	applied	\N	\N	\N	\N	59191	59191	59192
14812	18220	0	applied	\N	\N	\N	\N	59196	59196	47675
14812	18221	1	applied	\N	\N	\N	\N	59197	59197	59198
14812	18222	2	applied	\N	\N	\N	\N	59203	59203	59204
14812	18223	3	applied	\N	\N	\N	\N	59205	59205	59206
14812	18224	4	applied	\N	\N	\N	\N	59207	59207	59208
14812	18225	5	applied	\N	\N	\N	\N	59209	59209	59210
14812	18226	6	applied	\N	\N	\N	\N	59211	59211	59212
14812	18227	7	applied	\N	\N	\N	\N	59213	59213	59214
14812	18228	8	applied	\N	\N	\N	\N	59215	59215	59216
14814	18229	0	applied	\N	\N	\N	\N	59219	59219	59220
14814	18230	1	applied	\N	\N	\N	\N	59221	59221	59222
14816	18233	0	applied	\N	\N	\N	\N	59231	59231	59232
14816	18234	1	applied	\N	\N	\N	\N	59233	59233	59234
14819	18241	0	applied	\N	\N	\N	\N	59253	59253	59254
14819	18242	1	applied	\N	\N	\N	\N	59255	59255	59256
14824	18247	0	applied	\N	\N	\N	\N	59273	59273	59274
14824	18248	1	applied	\N	\N	\N	\N	59275	59275	59276
14824	18249	2	applied	\N	\N	\N	\N	59277	59277	59278
14824	18250	3	applied	\N	\N	\N	\N	59279	59279	59280
14827	18257	0	applied	\N	\N	\N	\N	59299	59299	59300
14827	18258	1	applied	\N	\N	\N	\N	59301	59301	59302
14836	18265	0	applied	\N	\N	\N	\N	59328	59328	59329
14836	18266	1	applied	\N	\N	\N	\N	59330	59330	59331
14842	18280	0	applied	\N	\N	\N	\N	59367	59367	59368
14842	18281	1	applied	\N	\N	\N	\N	59369	59369	59370
14847	18282	0	applied	\N	\N	\N	\N	59374	59374	59375
14847	18283	1	applied	\N	\N	\N	\N	59376	59376	59377
14852	18292	0	applied	\N	\N	\N	\N	59401	59401	59402
14852	18293	1	applied	\N	\N	\N	\N	59403	59403	59404
14855	18296	0	applied	\N	\N	\N	\N	59414	59414	59415
14855	18297	1	applied	\N	\N	\N	\N	59416	59416	59417
14855	18298	2	applied	\N	\N	\N	\N	59418	59418	59419
14855	18299	4	applied	\N	\N	\N	\N	59421	59421	59422
14855	18300	5	applied	\N	\N	\N	\N	59423	59423	59424
14855	18301	6	applied	\N	\N	\N	\N	59425	59425	59426
14855	18302	7	applied	\N	\N	\N	\N	59427	59427	59428
14855	18303	8	applied	\N	\N	\N	\N	59429	59429	59430
14857	18296	0	applied	\N	\N	\N	\N	59414	59414	59415
14857	18297	1	applied	\N	\N	\N	\N	59416	59416	59417
14857	18298	2	applied	\N	\N	\N	\N	59418	59418	59419
14857	18299	4	applied	\N	\N	\N	\N	59421	59421	59422
14857	18300	5	applied	\N	\N	\N	\N	59423	59423	59424
14857	18301	6	applied	\N	\N	\N	\N	59425	59425	59426
14857	18302	7	applied	\N	\N	\N	\N	59427	59427	59428
14857	18303	8	applied	\N	\N	\N	\N	59429	59429	59430
14860	18304	0	applied	\N	\N	\N	\N	59441	59441	59442
14860	18305	1	applied	\N	\N	\N	\N	59443	59443	59444
14862	18304	0	applied	\N	\N	\N	\N	59441	59441	59442
14862	18301	1	applied	\N	\N	\N	\N	59425	59425	59426
14862	18302	2	applied	\N	\N	\N	\N	59427	59427	59428
14862	18303	3	applied	\N	\N	\N	\N	59429	59429	59430
14862	18305	4	applied	\N	\N	\N	\N	59443	59443	59444
14866	18310	0	applied	\N	\N	\N	\N	59468	59468	59469
14866	18311	1	applied	\N	\N	\N	\N	59470	59470	59471
14874	18319	0	applied	\N	\N	\N	\N	59495	59495	59496
14874	18320	1	applied	\N	\N	\N	\N	59497	59497	59498
14881	18335	0	applied	\N	\N	1000000000	\N	59533	59533	59534
14881	18336	1	applied	\N	\N	1000000000	\N	59535	59535	59536
14881	18337	2	applied	\N	\N	\N	\N	59537	59537	59538
14881	18338	3	applied	\N	\N	\N	\N	59539	59539	59540
14881	18339	4	applied	\N	\N	\N	\N	59541	59541	59542
14881	18340	5	applied	\N	\N	\N	\N	59543	59543	59544
14881	18341	6	applied	\N	\N	\N	\N	59545	59545	59546
14881	18342	7	applied	\N	\N	\N	\N	59547	59547	59548
14881	18343	8	applied	\N	\N	\N	\N	59549	59549	59550
14887	18364	0	applied	\N	\N	\N	\N	59599	59599	59600
14887	18365	1	applied	\N	\N	\N	\N	59601	59601	59602
14887	18366	2	applied	\N	\N	\N	\N	59603	59603	59604
14887	18367	3	applied	\N	\N	\N	\N	59605	59605	59606
14887	18368	4	applied	\N	\N	\N	\N	59607	59607	59608
14887	18369	5	applied	\N	\N	\N	\N	59609	59609	59610
14887	18370	6	applied	\N	\N	\N	\N	59611	59611	59612
14887	18371	7	applied	\N	\N	\N	\N	59613	59613	59614
14887	18372	8	applied	\N	\N	\N	\N	59615	59615	59616
14887	18373	9	applied	\N	\N	\N	\N	59617	59617	59618
14887	18374	10	applied	\N	\N	\N	\N	59619	59619	59620
14887	18375	11	applied	\N	\N	\N	\N	59621	59621	59622
14890	18380	0	applied	\N	\N	\N	\N	59633	59633	59634
14890	18381	1	applied	\N	\N	\N	\N	59635	59635	59636
14890	18382	2	applied	\N	\N	\N	\N	59637	59637	59638
14890	18383	3	applied	\N	\N	\N	\N	59639	59639	59640
14900	18400	0	applied	\N	\N	\N	\N	59692	59692	59693
14900	18401	1	applied	\N	\N	\N	\N	59694	59694	59695
14900	18402	2	applied	\N	\N	\N	\N	59696	59696	59697
14903	18405	0	applied	\N	\N	\N	\N	59705	59705	59706
14903	18406	1	applied	\N	\N	\N	\N	59707	59707	59708
14903	18407	2	applied	\N	\N	\N	\N	59709	59709	59710
14903	18408	3	applied	\N	\N	\N	\N	59711	59711	59712
14907	18412	0	applied	\N	\N	\N	\N	59726	59726	59727
14907	18413	1	applied	\N	\N	\N	\N	59728	59728	59729
14912	18418	0	applied	\N	\N	\N	\N	59743	59743	59744
14912	18419	1	applied	\N	\N	\N	\N	59745	59745	59746
14912	18420	2	applied	\N	\N	\N	\N	59747	59747	59748
14912	18421	3	applied	\N	\N	\N	\N	59749	59749	59750
14916	18440	0	applied	\N	\N	\N	\N	59793	59793	59794
14916	18441	1	applied	\N	\N	\N	\N	59795	59795	59796
14918	18442	0	applied	\N	\N	\N	\N	59800	59800	59801
14918	18443	1	applied	\N	\N	\N	\N	59802	59802	59803
14918	18444	2	applied	\N	\N	\N	\N	59804	59804	59805
14920	18445	0	applied	\N	\N	\N	\N	59811	59811	59812
14920	18446	1	applied	\N	\N	\N	\N	59813	59813	59364
14920	18447	2	applied	\N	\N	\N	\N	59814	59814	59815
14922	18448	0	applied	\N	\N	\N	\N	59818	59818	59819
14927	18454	0	applied	\N	\N	\N	\N	59837	59837	59838
14927	18455	1	applied	\N	\N	\N	\N	59839	59839	59840
14932	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14932	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14932	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14932	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14932	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14941	18465	0	applied	\N	\N	\N	\N	59873	59873	59874
14941	18466	1	applied	\N	\N	\N	\N	59875	59875	59876
14943	18467	0	applied	\N	\N	\N	\N	59881	59881	59882
14943	18468	1	applied	\N	\N	\N	\N	59883	59883	59884
14946	18483	0	applied	\N	\N	\N	\N	59920	59920	59921
14946	18484	1	applied	\N	\N	\N	\N	59922	59922	59923
14949	18485	0	applied	\N	\N	\N	\N	59928	59928	59929
14831	18177	16	applied	\N	\N	\N	\N	59074	59074	59075
14831	18180	17	applied	\N	\N	\N	\N	59082	59082	59083
14831	18181	18	applied	\N	\N	\N	\N	59084	59084	59085
14831	18183	19	applied	\N	\N	\N	\N	59089	59089	59090
14831	18185	20	applied	\N	\N	\N	\N	59095	59095	59096
14831	18187	21	applied	\N	\N	\N	\N	59101	59101	59102
14831	18191	22	applied	\N	\N	\N	\N	59111	59111	59112
14831	18192	23	applied	\N	\N	\N	\N	59113	59113	59114
14831	18193	24	applied	\N	\N	\N	\N	59115	59115	59116
14831	18195	25	applied	\N	\N	\N	\N	59123	59123	59124
14831	18198	26	applied	\N	\N	\N	\N	59130	59130	59131
14831	18200	27	applied	\N	\N	\N	\N	59137	59137	59138
14831	18202	28	applied	\N	\N	\N	\N	59143	59143	59144
14831	18205	29	applied	\N	\N	\N	\N	59151	59151	59152
14831	18206	30	applied	\N	\N	\N	\N	59153	59153	59154
14831	18210	31	applied	\N	\N	\N	\N	59163	59163	59164
14831	18211	32	applied	\N	\N	\N	\N	59165	59165	59166
14831	18213	33	applied	\N	\N	\N	\N	59171	59171	59172
14831	18216	34	applied	\N	\N	\N	\N	59181	59181	59182
14831	18219	35	applied	\N	\N	\N	\N	59191	59191	59192
14831	18225	36	applied	\N	\N	\N	\N	59209	59209	59210
14831	18226	37	applied	\N	\N	\N	\N	59211	59211	59212
14831	18227	38	applied	\N	\N	\N	\N	59213	59213	59214
14831	18228	39	applied	\N	\N	\N	\N	59215	59215	59216
14831	18230	40	applied	\N	\N	\N	\N	59221	59221	59222
14831	18232	41	applied	\N	\N	\N	\N	59227	59227	59228
14831	18234	42	applied	\N	\N	\N	\N	59233	59233	59234
14831	18236	43	applied	\N	\N	\N	\N	59239	59239	59240
14831	18239	44	applied	\N	\N	\N	\N	59247	59247	59248
14831	18240	45	applied	\N	\N	\N	\N	59249	59249	59250
14831	18242	46	applied	\N	\N	\N	\N	59255	59255	59256
14831	18244	47	applied	\N	\N	\N	\N	59261	59261	59262
14831	18246	48	applied	\N	\N	\N	\N	59269	59269	59270
14831	18249	49	applied	\N	\N	\N	\N	59277	59277	59278
14831	18250	50	applied	\N	\N	\N	\N	59279	59279	59280
14831	18254	51	applied	\N	\N	\N	\N	59291	59291	59292
14831	18255	52	applied	\N	\N	\N	\N	59293	59293	59294
14831	18256	53	applied	\N	\N	\N	\N	59295	59295	59296
14831	18258	54	applied	\N	\N	\N	\N	59301	59301	59302
14831	18261	55	applied	\N	\N	\N	\N	59309	59309	59310
14831	18262	56	applied	\N	\N	\N	\N	59311	59311	59312
14831	18263	57	applied	\N	\N	\N	\N	59318	59318	59319
14839	18269	0	applied	\N	\N	\N	\N	59339	59339	59340
14839	18270	1	applied	\N	\N	\N	\N	59341	59341	59342
14839	18271	2	applied	\N	\N	\N	\N	59343	59343	59344
14839	18272	3	applied	\N	\N	\N	\N	59345	59345	59346
14839	18273	4	applied	\N	\N	\N	\N	59347	59347	59348
14839	18274	5	applied	\N	\N	\N	\N	59349	59349	59350
14839	18275	6	applied	\N	\N	\N	\N	59351	59351	59352
14839	18276	7	applied	\N	\N	\N	\N	59353	59353	59354
14845	18282	0	applied	\N	\N	\N	\N	59374	59374	59375
14845	18283	1	applied	\N	\N	\N	\N	59376	59376	59377
14848	18284	0	applied	\N	\N	\N	\N	59382	59382	59383
14848	18285	1	applied	\N	\N	\N	\N	59384	59384	59385
14848	18286	2	applied	\N	\N	\N	\N	59386	59386	59387
14848	18287	3	applied	\N	\N	\N	\N	59388	59388	59389
14848	18288	4	applied	\N	\N	\N	\N	59390	59390	59391
14848	18289	5	applied	\N	\N	\N	\N	59392	59392	59393
14850	18290	0	applied	\N	\N	\N	\N	59397	59397	59398
14850	18291	1	applied	\N	\N	\N	\N	59399	59399	59400
14858	18304	0	applied	\N	\N	\N	\N	59441	59441	59442
14858	18305	1	applied	\N	\N	\N	\N	59443	59443	59444
14865	18308	0	applied	\N	\N	\N	\N	59462	59462	59463
14865	18309	1	applied	\N	\N	\N	\N	59464	59464	59465
14868	18310	0	applied	\N	\N	\N	\N	59468	59468	59469
14868	18311	1	applied	\N	\N	\N	\N	59470	59470	59471
14870	18312	0	applied	\N	\N	1000000000	\N	59477	59477	59478
14870	18313	1	applied	\N	\N	\N	\N	59479	59479	59480
14870	18314	2	applied	\N	\N	\N	\N	59481	59481	59482
14870	18315	3	applied	\N	\N	\N	\N	59483	59483	59484
14870	18316	4	applied	\N	\N	\N	\N	59485	59485	59486
14870	18317	5	applied	\N	\N	\N	\N	59487	59487	59488
14870	18318	6	applied	\N	\N	\N	\N	59489	59489	59490
14876	18319	0	applied	\N	\N	\N	\N	59495	59495	59496
14876	18320	1	applied	\N	\N	\N	\N	59497	59497	59498
14877	18321	0	applied	\N	\N	\N	\N	59501	59501	59502
14877	18322	1	applied	\N	\N	\N	\N	59503	59503	59504
14877	18323	2	applied	\N	\N	\N	\N	59505	59505	59506
14877	18324	3	applied	\N	\N	\N	\N	59507	59507	59508
14877	18325	4	applied	\N	\N	\N	\N	59509	59509	59510
14877	18326	5	applied	\N	\N	\N	\N	59511	59511	47675
14877	18327	6	applied	\N	\N	\N	\N	59512	59512	59513
14880	18335	0	applied	\N	\N	1000000000	\N	59533	59533	59534
14880	18336	1	applied	\N	\N	1000000000	\N	59535	59535	59536
14880	18337	2	applied	\N	\N	\N	\N	59537	59537	59538
14880	18338	3	applied	\N	\N	\N	\N	59539	59539	59540
14880	18339	4	applied	\N	\N	\N	\N	59541	59541	59542
14880	18340	5	applied	\N	\N	\N	\N	59543	59543	59544
14880	18341	6	applied	\N	\N	\N	\N	59545	59545	59546
14880	18342	7	applied	\N	\N	\N	\N	59547	59547	59548
14880	18343	8	applied	\N	\N	\N	\N	59549	59549	59550
14885	18349	0	applied	\N	\N	\N	\N	59565	59565	59566
14885	18350	1	applied	\N	\N	\N	\N	59567	59567	59568
14885	18351	2	applied	\N	\N	\N	\N	59569	59569	59570
14891	18384	0	applied	\N	\N	\N	\N	59645	59645	59646
14891	18385	1	applied	\N	\N	\N	\N	59647	59647	59648
14891	18386	2	applied	\N	\N	\N	\N	59649	59649	59650
14891	18387	3	applied	\N	\N	\N	\N	59651	59651	59652
14894	18388	0	applied	\N	\N	\N	\N	59655	59655	59656
14894	18389	1	applied	\N	\N	\N	\N	59657	59657	59658
14894	18390	3	applied	\N	\N	\N	\N	59660	59660	59661
14894	18391	4	applied	\N	\N	\N	\N	59662	59662	59663
14894	18392	5	applied	\N	\N	\N	\N	59664	59664	59665
14894	18393	6	applied	\N	\N	\N	\N	59666	59666	59667
14894	18394	7	applied	\N	\N	\N	\N	59668	59668	59669
14894	18395	8	applied	\N	\N	\N	\N	59670	59670	59671
14897	18396	0	applied	\N	\N	\N	\N	59678	59678	59679
14897	18397	1	applied	\N	\N	\N	\N	59680	59680	59681
14897	18398	2	applied	\N	\N	\N	\N	59682	59682	59683
14897	18399	3	applied	\N	\N	\N	\N	59684	59684	59685
14901	18403	0	applied	\N	\N	\N	\N	59700	59700	59701
14901	18404	1	applied	\N	\N	\N	\N	59702	59702	59703
14904	18405	0	applied	\N	\N	\N	\N	59705	59705	59706
14904	18406	1	applied	\N	\N	\N	\N	59707	59707	59708
14904	18407	2	applied	\N	\N	\N	\N	59709	59709	59710
14904	18408	3	applied	\N	\N	\N	\N	59711	59711	59712
14908	18414	0	applied	\N	\N	\N	\N	59731	59731	59732
14908	18415	1	applied	\N	\N	\N	\N	59733	59733	59734
14908	18416	2	applied	\N	\N	\N	\N	59735	59735	59736
14846	17891	7	applied	\N	\N	\N	\N	58341	58341	58082
14846	17893	8	applied	\N	\N	\N	\N	58342	58342	58087
14846	17895	9	applied	\N	\N	\N	\N	58343	58343	58091
14846	17896	10	applied	\N	\N	\N	\N	58344	58344	58093
14846	17897	11	applied	\N	\N	\N	\N	58345	58345	58095
14846	17898	12	applied	\N	\N	\N	\N	58346	58346	58097
14846	17899	13	applied	\N	\N	\N	\N	58347	58347	58099
14846	17901	14	applied	\N	\N	\N	\N	58348	58348	58105
14846	17905	15	applied	\N	\N	\N	\N	58349	58349	58113
14846	17906	16	applied	\N	\N	\N	\N	58350	58350	58115
14846	17907	17	applied	\N	\N	\N	\N	58351	58351	58117
14846	17908	18	applied	\N	\N	\N	\N	58352	58352	58119
14846	17909	19	applied	\N	\N	\N	\N	58353	58353	58121
14846	17910	20	applied	\N	\N	\N	\N	58354	58354	58123
14846	17911	21	applied	\N	\N	\N	\N	58355	58355	58125
14846	17912	22	applied	\N	\N	\N	\N	58356	58356	58127
14846	17913	23	applied	\N	\N	\N	\N	58357	58357	58129
14846	17914	24	applied	\N	\N	\N	\N	58358	58358	58131
14846	17915	25	applied	\N	\N	\N	\N	58359	58359	58133
14846	17916	26	applied	\N	\N	\N	\N	58360	58360	58135
14846	17917	27	applied	\N	\N	\N	\N	58361	58361	58137
14846	17918	28	applied	\N	\N	\N	\N	58362	58362	58139
14846	17919	29	applied	\N	\N	\N	\N	58363	58363	58141
14846	17920	30	applied	\N	\N	\N	\N	58364	58364	58143
14846	17921	31	applied	\N	\N	\N	\N	58365	58365	58145
14846	17925	32	applied	\N	\N	\N	\N	58366	58366	58155
14846	17926	33	applied	\N	\N	\N	\N	58367	58367	58157
14846	17927	34	applied	\N	\N	\N	\N	58368	58368	58159
14846	17929	35	applied	\N	\N	\N	\N	58369	58369	58163
14846	17930	36	applied	\N	\N	\N	\N	58370	58370	58165
14846	17931	37	applied	\N	\N	\N	\N	58589	58589	58167
14846	17934	38	applied	\N	\N	\N	\N	58590	58590	58176
14846	17935	39	applied	\N	\N	\N	\N	58591	58591	58178
14846	17936	40	applied	\N	\N	\N	\N	58592	58592	58180
14846	17937	41	applied	\N	\N	\N	\N	58593	58593	58182
14846	17938	42	applied	\N	\N	\N	\N	58594	58594	58184
14846	17939	43	applied	\N	\N	\N	\N	58595	58595	58186
14846	17944	44	applied	\N	\N	\N	\N	58596	58596	58202
14846	17945	45	applied	\N	\N	\N	\N	58597	58597	58204
14846	17946	46	applied	\N	\N	\N	\N	58598	58598	58206
14846	17947	47	applied	\N	\N	\N	\N	58599	58599	58208
14846	17948	48	applied	\N	\N	\N	\N	58600	58600	58210
14846	17949	49	applied	\N	\N	\N	\N	58601	58601	58212
14846	17950	50	applied	\N	\N	\N	\N	58602	58602	58214
14846	17951	51	applied	\N	\N	\N	\N	58603	58603	58216
14846	17952	52	applied	\N	\N	\N	\N	58604	58604	58218
14846	17953	53	applied	\N	\N	\N	\N	58605	58605	58220
14846	17954	54	applied	\N	\N	\N	\N	58606	58606	58222
14846	17955	55	applied	\N	\N	\N	\N	58607	58607	58224
14846	17956	56	applied	\N	\N	\N	\N	58608	58608	58226
14846	17957	57	applied	\N	\N	\N	\N	58609	58609	58228
14846	17958	58	applied	\N	\N	\N	\N	58610	58610	58230
14846	17959	59	applied	\N	\N	\N	\N	58611	58611	58232
14846	17960	60	applied	\N	\N	\N	\N	58612	58612	58234
14846	17961	61	applied	\N	\N	\N	\N	58613	58613	58236
14846	17965	62	applied	\N	\N	\N	\N	58614	58614	58251
14846	17967	63	applied	\N	\N	\N	\N	58615	58615	58255
14846	17968	64	applied	\N	\N	\N	\N	58616	58616	58257
14846	17969	65	applied	\N	\N	\N	\N	58617	58617	58259
14846	17970	66	applied	\N	\N	\N	\N	58618	58618	58261
14846	17971	67	applied	\N	\N	\N	\N	58619	58619	58263
14846	17972	68	applied	\N	\N	\N	\N	58620	58620	58265
14846	17973	69	applied	\N	\N	\N	\N	58621	58621	58267
14846	17975	70	applied	\N	\N	\N	\N	58622	58622	58271
14846	17976	71	applied	\N	\N	\N	\N	58623	58623	58273
14846	17977	72	applied	\N	\N	\N	\N	58624	58624	58276
14846	17978	73	applied	\N	\N	\N	\N	58625	58625	58278
14846	17984	74	applied	\N	\N	\N	\N	58626	58626	58292
14846	17985	75	applied	\N	\N	\N	\N	58627	58627	58294
14849	18284	0	applied	\N	\N	\N	\N	59382	59382	59383
14849	18285	1	applied	\N	\N	\N	\N	59384	59384	59385
14849	18286	2	applied	\N	\N	\N	\N	59386	59386	59387
14849	18287	3	applied	\N	\N	\N	\N	59388	59388	59389
14849	18288	4	applied	\N	\N	\N	\N	59390	59390	59391
14849	18289	5	applied	\N	\N	\N	\N	59392	59392	59393
14851	18292	0	applied	\N	\N	\N	\N	59401	59401	59402
14851	18293	1	applied	\N	\N	\N	\N	59403	59403	59404
14853	18294	0	applied	\N	\N	\N	\N	59409	59409	59410
14853	18295	1	applied	\N	\N	\N	\N	59411	59411	59412
14854	18296	0	applied	\N	\N	\N	\N	59414	59414	59415
14854	18297	1	applied	\N	\N	\N	\N	59416	59416	59417
14854	18298	2	applied	\N	\N	\N	\N	59418	59418	59419
14854	18299	4	applied	\N	\N	\N	\N	59421	59421	59422
14854	18300	5	applied	\N	\N	\N	\N	59423	59423	59424
14854	18301	6	applied	\N	\N	\N	\N	59425	59425	59426
14854	18302	7	applied	\N	\N	\N	\N	59427	59427	59428
14854	18303	8	applied	\N	\N	\N	\N	59429	59429	59430
14859	18304	0	applied	\N	\N	\N	\N	59441	59441	59442
14859	18305	1	applied	\N	\N	\N	\N	59443	59443	59444
14861	18296	0	applied	\N	\N	\N	\N	59414	59414	59415
14861	18297	1	applied	\N	\N	\N	\N	59416	59416	59417
14861	18298	2	applied	\N	\N	\N	\N	59418	59418	59419
14861	18299	4	applied	\N	\N	\N	\N	59421	59421	59422
14861	18300	5	applied	\N	\N	\N	\N	59423	59423	59424
14864	18306	0	applied	\N	\N	\N	\N	59458	59458	59459
14864	18307	1	applied	\N	\N	\N	\N	59460	59460	59461
14869	18310	0	applied	\N	\N	\N	\N	59468	59468	59469
14869	18311	1	applied	\N	\N	\N	\N	59470	59470	59471
14871	18312	0	applied	\N	\N	1000000000	\N	59477	59477	59478
14871	18313	1	applied	\N	\N	\N	\N	59479	59479	59480
14871	18314	2	applied	\N	\N	\N	\N	59481	59481	59482
14871	18315	3	applied	\N	\N	\N	\N	59483	59483	59484
14871	18316	4	applied	\N	\N	\N	\N	59485	59485	59486
14871	18317	5	applied	\N	\N	\N	\N	59487	59487	59488
14871	18318	6	applied	\N	\N	\N	\N	59489	59489	59490
14873	18319	0	applied	\N	\N	\N	\N	59495	59495	59496
14873	18320	1	applied	\N	\N	\N	\N	59497	59497	59498
14878	18328	0	applied	\N	\N	\N	\N	59515	59515	59516
14878	18329	1	applied	\N	\N	\N	\N	59517	59517	59518
14878	18330	2	applied	\N	\N	\N	\N	59519	59519	59520
14878	18331	3	applied	\N	\N	\N	\N	59521	59521	59522
14883	18344	0	applied	\N	\N	\N	\N	59554	59554	59555
14883	18345	1	applied	\N	\N	\N	\N	59556	59556	59557
14883	18346	2	applied	\N	\N	\N	\N	59558	59558	59559
14883	18347	3	applied	\N	\N	\N	\N	59560	59560	59561
14883	18348	4	applied	\N	\N	\N	\N	59562	59562	59563
14886	18352	0	applied	\N	\N	\N	\N	59574	59574	59575
14886	18353	1	applied	\N	\N	\N	\N	59576	59576	59577
14886	18354	2	applied	\N	\N	\N	\N	59578	59578	59579
14886	18355	3	applied	\N	\N	\N	\N	59580	59580	59581
14886	18356	4	applied	\N	\N	\N	\N	59582	59582	59583
14886	18357	5	applied	\N	\N	\N	\N	59584	59584	59585
14886	18358	6	applied	\N	\N	\N	\N	59586	59586	59587
14886	18359	7	applied	\N	\N	\N	\N	59588	59588	59589
14886	18360	8	applied	\N	\N	\N	\N	59590	59590	59591
14886	18361	9	applied	\N	\N	\N	\N	59592	59592	59593
14886	18362	10	applied	\N	\N	\N	\N	59594	59594	59595
14886	18363	11	applied	\N	\N	\N	\N	59596	59596	59597
14889	18380	0	applied	\N	\N	\N	\N	59633	59633	59634
14889	18381	1	applied	\N	\N	\N	\N	59635	59635	59636
14889	18382	2	applied	\N	\N	\N	\N	59637	59637	59638
14889	18383	3	applied	\N	\N	\N	\N	59639	59639	59640
14892	18388	0	applied	\N	\N	\N	\N	59655	59655	59656
14892	18389	1	applied	\N	\N	\N	\N	59657	59657	59658
14892	18390	3	applied	\N	\N	\N	\N	59660	59660	59661
14892	18391	4	applied	\N	\N	\N	\N	59662	59662	59663
14892	18392	5	applied	\N	\N	\N	\N	59664	59664	59665
14892	18393	6	applied	\N	\N	\N	\N	59666	59666	59667
14892	18394	7	applied	\N	\N	\N	\N	59668	59668	59669
14892	18395	8	applied	\N	\N	\N	\N	59670	59670	59671
14895	18388	0	applied	\N	\N	\N	\N	59655	59655	59656
14895	18389	1	applied	\N	\N	\N	\N	59657	59657	59658
14895	18390	3	applied	\N	\N	\N	\N	59660	59660	59661
14895	18391	4	applied	\N	\N	\N	\N	59662	59662	59663
14895	18392	5	applied	\N	\N	\N	\N	59664	59664	59665
14895	18393	6	applied	\N	\N	\N	\N	59666	59666	59667
14895	18394	7	applied	\N	\N	\N	\N	59668	59668	59669
14895	18395	8	applied	\N	\N	\N	\N	59670	59670	59671
14898	18396	0	applied	\N	\N	\N	\N	59678	59678	59679
14898	18397	1	applied	\N	\N	\N	\N	59680	59680	59681
14898	18398	2	applied	\N	\N	\N	\N	59682	59682	59683
14898	18399	3	applied	\N	\N	\N	\N	59684	59684	59685
14902	18405	0	applied	\N	\N	\N	\N	59705	59705	59706
14902	18406	1	applied	\N	\N	\N	\N	59707	59707	59708
14902	18407	2	applied	\N	\N	\N	\N	59709	59709	59710
14902	18408	3	applied	\N	\N	\N	\N	59711	59711	59712
14905	18405	0	applied	\N	\N	\N	\N	59705	59705	59706
14905	18406	1	applied	\N	\N	\N	\N	59707	59707	59708
14905	18407	2	applied	\N	\N	\N	\N	59709	59709	59710
14905	18408	3	applied	\N	\N	\N	\N	59711	59711	59712
14906	18409	0	applied	\N	\N	\N	\N	59718	59718	59719
14906	18410	1	applied	\N	\N	\N	\N	59720	59720	59721
14906	18411	2	applied	\N	\N	\N	\N	59722	59722	59723
14909	18414	0	applied	\N	\N	\N	\N	59731	59731	59732
14909	18415	1	applied	\N	\N	\N	\N	59733	59733	59734
14909	18416	2	applied	\N	\N	\N	\N	59735	59735	59736
14909	18417	3	applied	\N	\N	\N	\N	59737	59737	59738
14911	18418	0	applied	\N	\N	\N	\N	59743	59743	59744
14911	18419	1	applied	\N	\N	\N	\N	59745	59745	59746
14911	18420	2	applied	\N	\N	\N	\N	59747	59747	59748
14911	18421	3	applied	\N	\N	\N	\N	59749	59749	59750
14913	18422	0	applied	\N	\N	\N	\N	59754	59754	59755
14913	18423	1	applied	\N	\N	\N	\N	59756	59756	59757
14913	18424	2	applied	\N	\N	1000000000	\N	59758	59758	59759
14913	18425	3	applied	\N	\N	\N	\N	59760	59760	59761
14915	18440	0	applied	\N	\N	\N	\N	59793	59793	59794
14915	18441	1	applied	\N	\N	\N	\N	59795	59795	59796
14917	18442	0	applied	\N	\N	\N	\N	59800	59800	59801
14917	18443	1	applied	\N	\N	\N	\N	59802	59802	59803
14917	18444	2	applied	\N	\N	\N	\N	59804	59804	59805
14926	18452	0	applied	\N	\N	\N	\N	59832	59832	59833
14926	18453	1	applied	\N	\N	\N	\N	59834	59834	59835
14929	18459	0	applied	\N	\N	\N	\N	59849	59849	59850
14935	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14935	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14935	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14935	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14935	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14940	18465	0	applied	\N	\N	\N	\N	59873	59873	59874
14940	18466	1	applied	\N	\N	\N	\N	59875	59875	59876
14942	18467	0	applied	\N	\N	\N	\N	59881	59881	59882
14942	18468	1	applied	\N	\N	\N	\N	59883	59883	59884
14944	18469	0	applied	\N	\N	\N	\N	59889	59889	59890
14948	18485	0	applied	\N	\N	\N	\N	59928	59928	59929
14948	18486	1	applied	\N	\N	\N	\N	59930	59930	59931
14948	18487	2	applied	\N	\N	\N	\N	59932	59932	59933
14948	18488	3	applied	\N	\N	\N	\N	59934	59934	59935
14948	18489	4	applied	\N	\N	\N	\N	59936	59936	59937
14954	18490	0	applied	\N	\N	\N	\N	59943	59943	59944
14954	18491	1	applied	\N	\N	\N	\N	59945	59945	59946
14954	18492	2	applied	\N	\N	\N	\N	59947	59947	59948
14956	18494	0	applied	\N	\N	\N	\N	59955	59955	59956
14956	18495	1	applied	\N	\N	\N	\N	59957	59957	59958
14956	18496	2	applied	\N	\N	\N	\N	59959	59959	59960
14959	18494	0	applied	\N	\N	\N	\N	59955	59955	59956
14959	18495	1	applied	\N	\N	\N	\N	59957	59957	59958
14959	18496	2	applied	\N	\N	\N	\N	59959	59959	59960
14963	18504	0	applied	\N	\N	\N	\N	59982	59982	59983
14963	18505	1	applied	\N	\N	\N	\N	59984	59984	59985
14976	18533	0	applied	\N	\N	\N	\N	60059	60059	60060
14976	18534	1	applied	\N	\N	\N	\N	60061	60061	60062
14976	18535	2	applied	\N	\N	\N	\N	60063	60063	60064
14978	18536	0	applied	\N	\N	\N	\N	60069	60069	60070
14978	18537	1	applied	\N	\N	\N	\N	60071	60071	60072
14981	18536	0	applied	\N	\N	\N	\N	60069	60069	60070
14981	18537	1	applied	\N	\N	\N	\N	60071	60071	60072
14990	18545	0	applied	\N	\N	\N	\N	60103	60103	60104
14990	18546	1	applied	\N	\N	\N	\N	60105	60105	60106
14990	18547	2	applied	\N	\N	\N	\N	60107	60107	60108
15001	18561	0	applied	\N	\N	\N	\N	60150	60150	60151
15001	18562	1	applied	\N	\N	\N	\N	60154	60154	60155
15001	18563	2	applied	\N	\N	\N	\N	60156	60156	60157
15001	18564	3	applied	\N	\N	\N	\N	60158	60158	60159
15003	18565	0	applied	\N	\N	\N	\N	60193	60193	60194
15003	18566	1	applied	\N	\N	\N	\N	60195	60195	60196
15006	18567	0	applied	\N	\N	\N	\N	60201	60201	60202
15006	18568	1	applied	\N	\N	\N	\N	60203	60203	60204
15006	18569	2	applied	\N	\N	\N	\N	60205	60205	60206
15006	18570	3	applied	\N	\N	\N	\N	60207	60207	60208
15006	18571	4	applied	\N	\N	\N	\N	60209	60209	60210
15013	18580	0	applied	\N	\N	\N	\N	60237	60237	60238
15013	18581	1	applied	\N	\N	\N	\N	60239	60239	60240
15013	18582	2	applied	\N	\N	\N	\N	60241	60241	60242
15018	18592	0	applied	\N	\N	\N	\N	60270	60270	60271
15018	18593	1	applied	\N	\N	\N	\N	60272	60272	60273
15018	18594	2	applied	\N	\N	\N	\N	60274	60274	60275
15024	18597	0	applied	\N	\N	\N	\N	60285	60285	60286
15024	18598	1	applied	\N	\N	\N	\N	60287	60287	60288
15024	18599	2	applied	\N	\N	\N	\N	60289	60289	60290
15024	18600	3	applied	\N	\N	\N	\N	60291	60291	60292
14908	18417	3	applied	\N	\N	\N	\N	59737	59737	59738
14914	18426	0	applied	\N	\N	\N	\N	59764	59764	59765
14914	18427	1	applied	\N	\N	\N	\N	59766	59766	59767
14914	18428	2	applied	\N	\N	\N	\N	59768	59768	59769
14914	18429	3	applied	\N	\N	\N	\N	59770	59770	59771
14914	18430	4	applied	\N	\N	\N	\N	59772	59772	59773
14914	18431	5	applied	\N	\N	\N	\N	59774	59774	59775
14914	18432	6	applied	\N	\N	\N	\N	59776	59776	59777
14914	18433	7	applied	\N	\N	\N	\N	59778	59778	59779
14914	18434	8	applied	\N	\N	\N	\N	59780	59780	59781
14914	18435	9	applied	\N	\N	\N	\N	59782	59782	59783
14914	18436	10	applied	\N	\N	\N	\N	59784	59784	59785
14914	18437	11	applied	\N	\N	\N	\N	59786	59786	59787
14914	18438	12	applied	\N	\N	\N	\N	59788	59788	59789
14914	18439	13	applied	\N	\N	\N	\N	59790	59790	59791
14924	18448	0	applied	\N	\N	\N	\N	59818	59818	59819
14928	18456	0	applied	\N	\N	\N	\N	59841	59841	59842
14928	18457	1	applied	\N	\N	\N	\N	59843	59843	59844
14928	18458	2	applied	\N	\N	\N	\N	59845	59845	59846
14931	18459	0	applied	\N	\N	\N	\N	59849	59849	59850
14934	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14934	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14934	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14934	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14934	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14938	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14938	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14938	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14938	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14938	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14939	18465	0	applied	\N	\N	\N	\N	59873	59873	59874
14939	18466	1	applied	\N	\N	\N	\N	59875	59875	59876
14945	18470	0	applied	\N	\N	\N	\N	59893	59893	59894
14945	18471	1	applied	\N	\N	\N	\N	59895	59895	59896
14945	18472	2	applied	\N	\N	\N	\N	59897	59897	59898
14945	18473	3	applied	\N	\N	\N	\N	59899	59899	59900
14945	18474	4	applied	\N	\N	\N	\N	59901	59901	59902
14945	18475	5	applied	\N	\N	\N	\N	59903	59903	59904
14945	18476	6	applied	\N	\N	\N	\N	59905	59905	59906
14945	18477	7	applied	\N	\N	\N	\N	59907	59907	59908
14945	18478	8	applied	\N	\N	\N	\N	59909	59909	59910
14945	18479	9	applied	\N	\N	\N	\N	59911	59911	59912
14945	18480	10	applied	\N	\N	\N	\N	59913	59913	59914
14945	18481	11	applied	\N	\N	\N	\N	59915	59915	59916
14945	18482	12	applied	\N	\N	\N	\N	59917	59917	59918
14947	18483	0	applied	\N	\N	\N	\N	59920	59920	59921
14947	18484	1	applied	\N	\N	\N	\N	59922	59922	59923
14953	18490	0	applied	\N	\N	\N	\N	59943	59943	59944
14953	18491	1	applied	\N	\N	\N	\N	59945	59945	59946
14953	18492	2	applied	\N	\N	\N	\N	59947	59947	59948
14955	18493	0	applied	\N	\N	\N	\N	59951	59951	59952
14958	18494	0	applied	\N	\N	\N	\N	59955	59955	59956
14958	18495	1	applied	\N	\N	\N	\N	59957	59957	59958
14958	18496	2	applied	\N	\N	\N	\N	59959	59959	59960
14960	18497	0	applied	\N	\N	\N	\N	59965	59965	59966
14960	18498	1	applied	\N	\N	\N	\N	59967	59967	59968
14960	18499	2	applied	\N	\N	\N	\N	59969	59969	59970
14960	18500	3	applied	\N	\N	\N	\N	59971	59971	59972
14960	18501	4	applied	\N	\N	\N	\N	59973	59973	59974
14965	18509	0	applied	\N	\N	\N	\N	59995	59995	59996
14965	18510	1	applied	\N	\N	\N	\N	59997	59997	59998
14965	18511	2	applied	\N	\N	\N	\N	59999	59999	60000
14968	18512	0	applied	\N	\N	\N	\N	60003	60003	60004
14970	18516	0	applied	\N	\N	\N	\N	60017	60017	60018
14970	18517	1	applied	\N	\N	\N	\N	60019	60019	60020
14970	18518	2	applied	\N	\N	\N	\N	60021	60021	60022
14970	18519	3	applied	\N	\N	\N	\N	60023	60023	60024
14970	18520	4	applied	\N	\N	1000000000	\N	60025	60025	60026
14970	18521	5	applied	\N	\N	\N	\N	60027	60027	60028
14973	18524	0	applied	\N	\N	\N	\N	60037	60037	60038
14973	18525	1	applied	\N	\N	\N	\N	60039	60039	60040
14975	18529	0	applied	\N	\N	\N	\N	60050	60050	60051
14975	18530	1	applied	\N	\N	\N	\N	60052	60052	60053
14975	18531	2	applied	\N	\N	\N	\N	60054	60054	60055
14975	18532	3	applied	\N	\N	\N	\N	60056	60056	60057
14980	18536	0	applied	\N	\N	\N	\N	60069	60069	60070
14980	18537	1	applied	\N	\N	\N	\N	60071	60071	60072
14982	18538	0	applied	\N	\N	\N	\N	60079	60079	60080
14982	18539	1	applied	\N	\N	\N	\N	60081	60081	60082
14982	18540	2	applied	\N	\N	\N	\N	60083	60083	60084
14985	18541	0	applied	\N	\N	\N	\N	60087	60087	60088
14987	18542	0	applied	\N	\N	\N	\N	60095	60095	60096
14987	18543	1	applied	\N	\N	\N	\N	60097	60097	60098
14987	18544	2	applied	\N	\N	\N	\N	60099	60099	60100
14989	18545	0	applied	\N	\N	\N	\N	60103	60103	60104
14989	18546	1	applied	\N	\N	\N	\N	60105	60105	60106
14989	18547	2	applied	\N	\N	\N	\N	60107	60107	60108
14994	18550	0	applied	\N	\N	\N	\N	60122	60122	60123
14994	18551	1	applied	\N	\N	\N	\N	60124	60124	60125
14994	18552	2	applied	\N	\N	\N	\N	60126	60126	60127
14994	18553	3	applied	\N	\N	\N	\N	60128	60128	60129
14994	18554	4	applied	\N	\N	1000000000	\N	60130	60130	60131
14996	18555	0	applied	\N	\N	\N	\N	60136	60136	60137
14996	18556	1	applied	\N	\N	\N	\N	60138	60138	60139
14996	18557	2	applied	\N	\N	\N	\N	60140	60140	60141
14998	18561	0	applied	\N	\N	\N	\N	60150	60150	60151
15005	18567	0	applied	\N	\N	\N	\N	60201	60201	60202
15005	18568	1	applied	\N	\N	\N	\N	60203	60203	60204
15005	18569	2	applied	\N	\N	\N	\N	60205	60205	60206
15005	18570	3	applied	\N	\N	\N	\N	60207	60207	60208
15005	18571	4	applied	\N	\N	\N	\N	60209	60209	60210
15008	18572	0	applied	\N	\N	\N	\N	60215	60215	60216
15008	18573	1	applied	\N	\N	\N	\N	60217	60217	60218
15010	18574	0	applied	\N	\N	\N	\N	60220	60220	60221
15010	18575	1	applied	\N	\N	\N	\N	60222	60222	60223
15012	18578	0	applied	\N	\N	\N	\N	60233	60233	60234
15012	18579	1	applied	\N	\N	\N	\N	60235	60235	60236
15015	18583	0	applied	\N	\N	\N	\N	60246	60246	60247
15015	18584	1	applied	\N	\N	\N	\N	60248	60248	60249
15015	18585	2	applied	\N	\N	\N	\N	60250	60250	60251
15015	18586	3	applied	\N	\N	\N	\N	60252	60252	60253
15015	18587	4	applied	\N	\N	\N	\N	60254	60254	60255
15023	18597	0	applied	\N	\N	\N	\N	60285	60285	60286
15023	18598	1	applied	\N	\N	\N	\N	60287	60287	60288
15023	18599	2	applied	\N	\N	\N	\N	60289	60289	60290
15023	18600	3	applied	\N	\N	\N	\N	60291	60291	60292
15023	18601	4	applied	\N	\N	\N	\N	60293	60293	60294
15023	18602	5	applied	\N	\N	\N	\N	60295	60295	60296
15023	18603	6	applied	\N	\N	\N	\N	60297	60297	60298
14921	18446	1	applied	\N	\N	\N	\N	59813	59813	59364
14921	18447	2	applied	\N	\N	\N	\N	59814	59814	59815
14923	18448	0	applied	\N	\N	\N	\N	59818	59818	59819
14925	18449	0	applied	\N	\N	\N	\N	59824	59824	59825
14925	18450	1	applied	\N	\N	\N	\N	59826	59826	59827
14925	18451	2	applied	\N	\N	\N	\N	59828	59828	59829
14930	18459	0	applied	\N	\N	\N	\N	59849	59849	59850
14933	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14933	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14933	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14933	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14933	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14937	18460	0	applied	\N	\N	\N	\N	59854	59854	59855
14937	18461	1	applied	\N	\N	\N	\N	59856	59856	59857
14937	18462	2	applied	\N	\N	\N	\N	59858	59858	59859
14937	18463	3	applied	\N	\N	\N	\N	59860	59860	59861
14937	18464	4	applied	\N	\N	\N	\N	59862	59862	59863
14962	18502	0	applied	\N	\N	\N	\N	59976	59976	59977
14962	18503	1	applied	\N	\N	\N	\N	59978	59978	59979
14964	18506	0	applied	\N	\N	\N	\N	59988	59988	59989
14964	18507	1	applied	\N	\N	\N	\N	59990	59990	59991
14964	18508	2	applied	\N	\N	\N	\N	59992	59992	59993
14967	18512	0	applied	\N	\N	\N	\N	60003	60003	60004
14969	18513	0	applied	\N	\N	\N	\N	60009	60009	60010
14969	18514	1	applied	\N	\N	\N	\N	60011	60011	60012
14969	18515	2	applied	\N	\N	\N	\N	60013	60013	60014
14972	18524	0	applied	\N	\N	\N	\N	60037	60037	60038
14972	18525	1	applied	\N	\N	\N	\N	60039	60039	60040
14974	18526	0	applied	\N	\N	\N	\N	60043	60043	60044
14974	18527	1	applied	\N	\N	\N	\N	60045	60045	60046
14974	18528	2	applied	\N	\N	\N	\N	60047	60047	60048
14984	18541	0	applied	\N	\N	\N	\N	60087	60087	60088
14986	18541	0	applied	\N	\N	\N	\N	60087	60087	60088
14988	18545	0	applied	\N	\N	\N	\N	60103	60103	60104
14988	18546	1	applied	\N	\N	\N	\N	60105	60105	60106
14988	18547	2	applied	\N	\N	\N	\N	60107	60107	60108
14993	18550	0	applied	\N	\N	\N	\N	60122	60122	60123
14993	18551	1	applied	\N	\N	\N	\N	60124	60124	60125
14993	18552	2	applied	\N	\N	\N	\N	60126	60126	60127
14993	18553	3	applied	\N	\N	\N	\N	60128	60128	60129
14993	18554	4	applied	\N	\N	1000000000	\N	60130	60130	60131
14995	18555	0	applied	\N	\N	\N	\N	60136	60136	60137
14995	18556	1	applied	\N	\N	\N	\N	60138	60138	60139
14995	18557	2	applied	\N	\N	\N	\N	60140	60140	60141
15000	18561	0	applied	\N	\N	\N	\N	60150	60150	60151
15000	18562	1	applied	\N	\N	\N	\N	60154	60154	60155
15000	18563	2	applied	\N	\N	\N	\N	60156	60156	60157
15000	18564	3	applied	\N	\N	\N	\N	60158	60158	60159
15007	18572	0	applied	\N	\N	\N	\N	60215	60215	60216
15007	18573	1	applied	\N	\N	\N	\N	60217	60217	60218
15009	18574	0	applied	\N	\N	\N	\N	60220	60220	60221
15009	18575	1	applied	\N	\N	\N	\N	60222	60222	60223
15017	18589	0	applied	\N	\N	\N	\N	60262	60262	60263
15017	18590	1	applied	\N	\N	\N	\N	60264	60264	60265
15017	18591	2	applied	\N	\N	\N	\N	60266	60266	60267
15020	18592	0	applied	\N	\N	\N	\N	60270	60270	60271
15020	18593	1	applied	\N	\N	\N	\N	60272	60272	60273
15020	18594	2	applied	\N	\N	\N	\N	60274	60274	60275
15022	18595	0	applied	\N	\N	\N	\N	60278	60278	60279
15022	18596	1	applied	\N	\N	\N	\N	60280	60280	60281
15027	18608	0	applied	\N	\N	\N	\N	60312	60312	60313
15027	18609	1	applied	\N	\N	\N	\N	60314	60314	60315
15027	18610	2	applied	\N	\N	\N	\N	60316	60316	60317
15029	18611	0	applied	\N	\N	\N	\N	60322	60322	60323
15029	18612	1	applied	\N	\N	\N	\N	60324	60324	60325
15034	18618	0	applied	\N	\N	\N	\N	60344	60344	60345
15034	18619	1	applied	\N	\N	\N	\N	60346	60346	60347
15034	18620	2	applied	\N	\N	\N	\N	60348	60348	60349
15034	18621	3	applied	\N	\N	\N	\N	60350	60350	60351
15034	18622	4	applied	\N	\N	\N	\N	60352	60352	60353
15037	18623	0	applied	\N	\N	\N	\N	60356	60356	60357
15041	18624	0	applied	\N	\N	\N	\N	60362	60362	60363
15041	18625	2	applied	\N	\N	\N	\N	60365	60365	60366
15041	18626	3	applied	\N	\N	\N	\N	60367	60367	60368
15045	18627	0	applied	\N	\N	\N	\N	60377	60377	60378
15045	18628	1	applied	\N	\N	\N	\N	60379	60379	60380
15048	18631	0	applied	\N	\N	\N	\N	60391	60391	60392
15048	18632	1	applied	\N	\N	\N	\N	60393	60393	60394
15054	18558	0	applied	\N	\N	\N	\N	60144	60144	60145
15054	18561	1	applied	\N	\N	\N	\N	60150	60150	60151
15054	18562	2	applied	\N	\N	\N	\N	60154	60154	60155
15054	18565	3	applied	\N	\N	\N	\N	60193	60193	60194
15054	18567	4	applied	\N	\N	\N	\N	60201	60201	60202
15054	18568	5	applied	\N	\N	\N	\N	60203	60203	60204
15054	18572	6	applied	\N	\N	\N	\N	60215	60215	60216
15054	18574	7	applied	\N	\N	\N	\N	60220	60220	60221
15054	18576	8	applied	\N	\N	\N	\N	60228	60228	60229
15054	18578	9	applied	\N	\N	\N	\N	60233	60233	60234
15054	18580	10	applied	\N	\N	\N	\N	60237	60237	60238
15054	18583	11	applied	\N	\N	\N	\N	60246	60246	60247
15054	18584	12	applied	\N	\N	\N	\N	60248	60248	60249
15054	18588	13	applied	\N	\N	\N	\N	60258	60258	60259
15054	18589	14	applied	\N	\N	\N	\N	60262	60262	60263
15054	18592	15	applied	\N	\N	\N	\N	60270	60270	60271
15054	18595	16	applied	\N	\N	\N	\N	60278	60278	60279
15054	18597	17	applied	\N	\N	\N	\N	60285	60285	60286
15054	18598	18	applied	\N	\N	\N	\N	60287	60287	60288
15054	18599	19	applied	\N	\N	\N	\N	60289	60289	60290
15054	18600	20	applied	\N	\N	\N	\N	60291	60291	60292
15054	18607	21	applied	\N	\N	\N	\N	60309	60309	60310
15054	18608	22	applied	\N	\N	\N	\N	60312	60312	60313
15054	18611	23	applied	\N	\N	\N	\N	60322	60322	60323
15054	18613	24	applied	\N	\N	\N	\N	60328	60328	60329
15054	18616	25	applied	\N	\N	\N	\N	60337	60337	60338
15054	18618	26	applied	\N	\N	\N	\N	60344	60344	60345
15054	18619	27	applied	\N	\N	\N	\N	60346	60346	60347
15054	18623	28	applied	\N	\N	\N	\N	60356	60356	60357
15054	18624	29	applied	\N	\N	\N	\N	60362	60362	60363
15054	18627	30	applied	\N	\N	\N	\N	60377	60377	60378
15054	18629	31	applied	\N	\N	\N	\N	60385	60385	60386
15054	18631	32	applied	\N	\N	\N	\N	60391	60391	60392
15054	18633	33	applied	\N	\N	\N	\N	60398	60398	60399
15054	18559	34	applied	\N	\N	\N	\N	60146	60146	60147
15054	18560	35	applied	\N	\N	\N	\N	60148	60148	60149
15054	18563	36	applied	\N	\N	\N	\N	60156	60156	60157
15054	18564	37	applied	\N	\N	\N	\N	60158	60158	60159
15054	18566	38	applied	\N	\N	\N	\N	60195	60195	60196
15054	18569	39	applied	\N	\N	\N	\N	60205	60205	60206
15054	18570	40	applied	\N	\N	\N	\N	60207	60207	60208
15054	18571	41	applied	\N	\N	\N	\N	60209	60209	60210
14949	18486	1	applied	\N	\N	\N	\N	59930	59930	59931
14949	18487	2	applied	\N	\N	\N	\N	59932	59932	59933
14949	18488	3	applied	\N	\N	\N	\N	59934	59934	59935
14949	18489	4	applied	\N	\N	\N	\N	59936	59936	59937
14951	18485	0	applied	\N	\N	\N	\N	59928	59928	59929
14951	18486	1	applied	\N	\N	\N	\N	59930	59930	59931
14951	18487	2	applied	\N	\N	\N	\N	59932	59932	59933
14951	18488	3	applied	\N	\N	\N	\N	59934	59934	59935
14951	18489	4	applied	\N	\N	\N	\N	59936	59936	59937
14957	18494	0	applied	\N	\N	\N	\N	59955	59955	59956
14957	18495	1	applied	\N	\N	\N	\N	59957	59957	59958
14957	18496	2	applied	\N	\N	\N	\N	59959	59959	59960
14961	18502	0	applied	\N	\N	\N	\N	59976	59976	59977
14961	18503	1	applied	\N	\N	\N	\N	59978	59978	59979
14966	18512	0	applied	\N	\N	\N	\N	60003	60003	60004
14971	18522	0	applied	\N	\N	\N	\N	60031	60031	60032
14971	18523	1	applied	\N	\N	\N	\N	60033	60033	60034
14977	18533	0	applied	\N	\N	\N	\N	60059	60059	60060
14977	18534	1	applied	\N	\N	\N	\N	60061	60061	60062
14977	18535	2	applied	\N	\N	\N	\N	60063	60063	60064
14979	18536	0	applied	\N	\N	\N	\N	60069	60069	60070
14979	18537	1	applied	\N	\N	\N	\N	60071	60071	60072
14983	18541	0	applied	\N	\N	\N	\N	60087	60087	60088
14991	18545	0	applied	\N	\N	\N	\N	60103	60103	60104
14991	18546	1	applied	\N	\N	\N	\N	60105	60105	60106
14991	18547	2	applied	\N	\N	\N	\N	60107	60107	60108
14992	18548	0	applied	\N	\N	\N	\N	60115	60115	60116
14992	18549	2	applied	\N	\N	\N	\N	60118	60118	60119
14997	18558	0	applied	\N	\N	\N	\N	60144	60144	60145
14997	18559	1	applied	\N	\N	\N	\N	60146	60146	60147
14997	18560	2	applied	\N	\N	\N	\N	60148	60148	60149
15002	18312	0	applied	\N	\N	1000000000	\N	59477	59477	59478
15002	18220	1	applied	\N	\N	\N	\N	59196	59196	47675
15002	18221	2	applied	\N	\N	\N	\N	59197	59197	59198
15002	18222	3	applied	\N	\N	\N	\N	59203	59203	59204
15002	18223	4	applied	\N	\N	\N	\N	59205	59205	59206
15002	18224	5	applied	\N	\N	\N	\N	59207	59207	59208
15002	18229	6	applied	\N	\N	\N	\N	59219	59219	59220
15002	18231	7	applied	\N	\N	\N	\N	59225	59225	59226
15002	18233	8	applied	\N	\N	\N	\N	59231	59231	59232
15002	18235	9	applied	\N	\N	\N	\N	59237	59237	59238
15002	18237	10	applied	\N	\N	\N	\N	59243	59243	59244
15002	18238	11	applied	\N	\N	\N	\N	59245	59245	59246
15002	18241	12	applied	\N	\N	\N	\N	59253	59253	59254
15002	18243	13	applied	\N	\N	\N	\N	59259	59259	59260
15002	18245	14	applied	\N	\N	\N	\N	59267	59267	59268
15002	18247	15	applied	\N	\N	\N	\N	59273	59273	59274
15002	18248	16	applied	\N	\N	\N	\N	59275	59275	59276
15002	18251	17	applied	\N	\N	\N	\N	59285	59285	59286
15002	18252	18	applied	\N	\N	\N	\N	59287	59287	59288
15002	18253	19	applied	\N	\N	\N	\N	59289	59289	59290
15002	18257	20	applied	\N	\N	\N	\N	59299	59299	59300
15002	18259	21	applied	\N	\N	\N	\N	59305	59305	59306
15002	18260	22	applied	\N	\N	\N	\N	59307	59307	59308
15002	18264	23	applied	\N	\N	\N	\N	59322	59322	59323
15002	18265	24	applied	\N	\N	\N	\N	59328	59328	59329
15002	18267	25	applied	\N	\N	\N	\N	59334	59334	59335
15002	18269	26	applied	\N	\N	\N	\N	59339	59339	59340
15002	18270	27	applied	\N	\N	\N	\N	59341	59341	59342
15002	18271	28	applied	\N	\N	\N	\N	59343	59343	59344
15002	18272	29	applied	\N	\N	\N	\N	59345	59345	59346
15002	18277	30	applied	\N	\N	\N	\N	59360	59360	59361
15002	18280	31	applied	\N	\N	\N	\N	59367	59367	59368
15002	18282	32	applied	\N	\N	\N	\N	59374	59374	59375
15002	18284	33	applied	\N	\N	\N	\N	59382	59382	59383
15002	18285	34	applied	\N	\N	\N	\N	59384	59384	59385
15002	18286	35	applied	\N	\N	\N	\N	59386	59386	59387
15002	18290	36	applied	\N	\N	\N	\N	59397	59397	59398
15002	18292	37	applied	\N	\N	\N	\N	59401	59401	59402
15002	18294	38	applied	\N	\N	\N	\N	59409	59409	59410
15002	18296	39	applied	\N	\N	\N	\N	59414	59414	59415
15002	18297	40	applied	\N	\N	\N	\N	59416	59416	59417
15002	18298	41	applied	\N	\N	\N	\N	59418	59418	59419
15002	18299	42	applied	\N	\N	\N	\N	59421	59421	59422
15002	18304	43	applied	\N	\N	\N	\N	59441	59441	59442
15002	18306	44	applied	\N	\N	\N	\N	59458	59458	59459
15002	18308	45	applied	\N	\N	\N	\N	59462	59462	59463
15002	18310	46	applied	\N	\N	\N	\N	59468	59468	59469
15002	18313	47	applied	\N	\N	\N	\N	59479	59479	59480
15002	18314	48	applied	\N	\N	\N	\N	59481	59481	59482
15002	18315	49	applied	\N	\N	\N	\N	59483	59483	59484
15002	18319	50	applied	\N	\N	\N	\N	59495	59495	59496
15002	18321	51	applied	\N	\N	\N	\N	59501	59501	59502
15002	18322	52	applied	\N	\N	\N	\N	59503	59503	59504
15002	18328	53	applied	\N	\N	\N	\N	59515	59515	59516
15002	18332	54	applied	\N	\N	\N	\N	59525	59525	59526
15002	18337	55	applied	\N	\N	\N	\N	59537	59537	59538
15002	18338	56	applied	\N	\N	\N	\N	59539	59539	59540
15002	18344	57	applied	\N	\N	\N	\N	59554	59554	59555
15002	18349	58	applied	\N	\N	\N	\N	59565	59565	59566
15002	18364	59	applied	\N	\N	\N	\N	59599	59599	59600
15002	18365	60	applied	\N	\N	\N	\N	59601	59601	59602
15002	18366	61	applied	\N	\N	\N	\N	59603	59603	59604
15002	18367	62	applied	\N	\N	\N	\N	59605	59605	59606
15002	18368	63	applied	\N	\N	\N	\N	59607	59607	59608
15002	18369	64	applied	\N	\N	\N	\N	59609	59609	59610
15002	18376	65	applied	\N	\N	\N	\N	59624	59624	59625
15002	18380	66	applied	\N	\N	\N	\N	59633	59633	59634
15002	18384	67	applied	\N	\N	\N	\N	59645	59645	59646
15002	18388	68	applied	\N	\N	\N	\N	59655	59655	59656
15002	18389	69	applied	\N	\N	\N	\N	59657	59657	59658
15002	18396	70	applied	\N	\N	\N	\N	59678	59678	59679
15002	18400	71	applied	\N	\N	\N	\N	59692	59692	59693
15002	18403	72	applied	\N	\N	\N	\N	59700	59700	59701
15002	18405	73	applied	\N	\N	\N	\N	59705	59705	59706
15002	18409	74	applied	\N	\N	\N	\N	59718	59718	59719
15002	18412	75	applied	\N	\N	\N	\N	59726	59726	59727
15002	18414	76	applied	\N	\N	\N	\N	59731	59731	59732
15002	18418	77	applied	\N	\N	\N	\N	59743	59743	59744
15002	18422	78	applied	\N	\N	\N	\N	59754	59754	59755
15002	18426	79	applied	\N	\N	\N	\N	59764	59764	59765
15002	18427	80	applied	\N	\N	\N	\N	59766	59766	59767
15002	18428	81	applied	\N	\N	\N	\N	59768	59768	59769
15002	18429	82	applied	\N	\N	\N	\N	59770	59770	59771
15002	18430	83	applied	\N	\N	\N	\N	59772	59772	59773
15002	18431	84	applied	\N	\N	\N	\N	59774	59774	59775
15002	18440	85	applied	\N	\N	\N	\N	59793	59793	59794
15002	18442	86	applied	\N	\N	\N	\N	59800	59800	59801
15002	18445	87	applied	\N	\N	\N	\N	59811	59811	59812
15002	18448	88	applied	\N	\N	\N	\N	59818	59818	59819
15002	18449	89	applied	\N	\N	\N	\N	59824	59824	59825
15002	18452	90	applied	\N	\N	\N	\N	59832	59832	59833
15002	18454	91	applied	\N	\N	\N	\N	59837	59837	59838
15002	18456	92	applied	\N	\N	\N	\N	59841	59841	59842
15002	18459	93	applied	\N	\N	\N	\N	59849	59849	59850
15002	18460	94	applied	\N	\N	\N	\N	59854	59854	59855
15002	18461	95	applied	\N	\N	\N	\N	59856	59856	59857
15002	18465	96	applied	\N	\N	\N	\N	59873	59873	60162
15002	18467	97	applied	\N	\N	\N	\N	59881	59881	60163
15002	18469	98	applied	\N	\N	\N	\N	59889	59889	60164
15002	18470	99	applied	\N	\N	\N	\N	59893	59893	60165
15002	18471	100	applied	\N	\N	\N	\N	59895	59895	60166
15002	18472	101	applied	\N	\N	\N	\N	59897	59897	60167
15002	18473	102	applied	\N	\N	\N	\N	59899	59899	60168
15002	18474	103	applied	\N	\N	\N	\N	59901	59901	60169
15002	18483	104	applied	\N	\N	\N	\N	59920	59920	60170
15002	18485	105	applied	\N	\N	\N	\N	59928	59928	60171
15002	18486	106	applied	\N	\N	\N	\N	59930	59930	60172
15002	18490	107	applied	\N	\N	\N	\N	59943	59943	60173
15002	18493	108	applied	\N	\N	\N	\N	59951	59951	60174
15002	18494	109	applied	\N	\N	\N	\N	59955	59955	60175
15002	18497	110	applied	\N	\N	\N	\N	59965	59965	60176
15002	18498	111	applied	\N	\N	\N	\N	59967	59967	60177
15002	18502	112	applied	\N	\N	\N	\N	59976	59976	60178
15002	18504	113	applied	\N	\N	\N	\N	59982	59982	60179
15002	18506	114	applied	\N	\N	\N	\N	59988	59988	60180
15002	18509	115	applied	\N	\N	\N	\N	59995	59995	60181
15002	18512	116	applied	\N	\N	\N	\N	60003	60003	60182
15002	18513	117	applied	\N	\N	\N	\N	60009	60009	60183
15002	18516	118	applied	\N	\N	\N	\N	60017	60017	60184
15002	18517	119	applied	\N	\N	\N	\N	60019	60019	60185
15002	18522	120	applied	\N	\N	\N	\N	60031	60031	60186
15002	18524	121	applied	\N	\N	\N	\N	60037	60037	60187
15002	18526	122	applied	\N	\N	\N	\N	60043	60043	60188
15002	18529	123	applied	\N	\N	\N	\N	60050	60050	60189
15002	18530	124	applied	\N	\N	\N	\N	60052	60052	60190
15002	18533	125	applied	\N	\N	\N	\N	60059	60059	60191
15004	18565	0	applied	\N	\N	\N	\N	60193	60193	60194
15004	18566	1	applied	\N	\N	\N	\N	60195	60195	60196
15011	18576	0	applied	\N	\N	\N	\N	60228	60228	60229
15011	18577	1	applied	\N	\N	\N	\N	60230	60230	60231
15014	18580	0	applied	\N	\N	\N	\N	60237	60237	60238
15014	18581	1	applied	\N	\N	\N	\N	60239	60239	60240
15014	18582	2	applied	\N	\N	\N	\N	60241	60241	60242
15016	18588	0	applied	\N	\N	\N	\N	60258	60258	60259
15019	18592	0	applied	\N	\N	\N	\N	60270	60270	60271
15019	18593	1	applied	\N	\N	\N	\N	60272	60272	60273
15019	18594	2	applied	\N	\N	\N	\N	60274	60274	60275
15021	18595	0	applied	\N	\N	\N	\N	60278	60278	60279
15021	18596	1	applied	\N	\N	\N	\N	60280	60280	60281
15031	18312	0	applied	\N	\N	1000000000	\N	59477	59477	59478
15031	18346	1	applied	\N	\N	\N	\N	59558	59558	59559
15031	18279	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	59364	59364	\N
15031	18326	3	applied	\N	\N	\N	\N	59511	59511	47675
15036	18623	0	applied	\N	\N	\N	\N	60356	60356	60357
15039	18623	0	applied	\N	\N	\N	\N	60356	60356	60357
15040	18624	0	applied	\N	\N	\N	\N	60362	60362	60363
15040	18625	2	applied	\N	\N	\N	\N	60365	60365	60366
15040	18626	3	applied	\N	\N	\N	\N	60367	60367	60368
15047	18631	0	applied	\N	\N	\N	\N	60391	60391	60392
15047	18632	1	applied	\N	\N	\N	\N	60393	60393	60394
15056	18636	0	applied	\N	\N	\N	\N	60411	60411	60412
15056	18637	1	applied	\N	\N	\N	\N	60413	60413	60414
15056	18638	2	applied	\N	\N	\N	\N	60415	60415	60416
15058	18639	0	applied	\N	\N	\N	\N	60421	60421	60422
15058	18640	1	applied	\N	\N	\N	\N	60423	60423	60424
15023	18604	7	applied	\N	\N	\N	\N	60299	60299	60300
15023	18605	8	applied	\N	\N	\N	\N	60301	60301	60302
15023	18606	9	applied	\N	\N	\N	\N	60303	60303	60304
15025	18607	0	applied	\N	\N	\N	\N	60309	60309	60310
15028	18608	0	applied	\N	\N	\N	\N	60312	60312	60313
15028	18609	1	applied	\N	\N	\N	\N	60314	60314	60315
15028	18610	2	applied	\N	\N	\N	\N	60316	60316	60317
15030	18613	0	applied	\N	\N	\N	\N	60328	60328	60329
15030	18614	1	applied	\N	\N	\N	\N	60330	60330	60331
15030	18615	2	applied	\N	\N	\N	\N	60332	60332	60333
15032	18616	0	applied	\N	\N	\N	\N	60337	60337	60338
15032	18617	1	applied	\N	\N	\N	\N	60339	60339	60340
15038	18623	0	applied	\N	\N	\N	\N	60356	60356	60357
15042	18624	0	applied	\N	\N	\N	\N	60362	60362	60363
15042	18625	2	applied	\N	\N	\N	\N	60365	60365	60366
15042	18626	3	applied	\N	\N	\N	\N	60367	60367	60368
15050	18633	0	applied	\N	\N	\N	\N	60398	60398	60399
15055	18634	0	applied	\N	\N	\N	\N	60406	60406	60407
15055	18635	1	applied	\N	\N	\N	\N	60408	60408	60409
15060	18641	0	applied	\N	\N	\N	\N	60426	60426	60427
15060	18642	1	applied	\N	\N	\N	\N	60428	60428	60429
15060	18643	2	applied	\N	\N	\N	\N	60430	60430	60431
15060	18644	3	applied	\N	\N	\N	\N	60432	60432	60433
15063	18641	0	applied	\N	\N	\N	\N	60426	60426	60427
15063	18642	1	applied	\N	\N	\N	\N	60428	60428	60429
15063	18643	2	applied	\N	\N	\N	\N	60430	60430	60431
15063	18644	3	applied	\N	\N	\N	\N	60432	60432	60433
15024	18601	4	applied	\N	\N	\N	\N	60293	60293	60294
15024	18602	5	applied	\N	\N	\N	\N	60295	60295	60296
15024	18603	6	applied	\N	\N	\N	\N	60297	60297	60298
15024	18604	7	applied	\N	\N	\N	\N	60299	60299	60300
15024	18605	8	applied	\N	\N	\N	\N	60301	60301	60302
15024	18606	9	applied	\N	\N	\N	\N	60303	60303	60304
15026	18608	0	applied	\N	\N	\N	\N	60312	60312	60313
15026	18609	1	applied	\N	\N	\N	\N	60314	60314	60315
15026	18610	2	applied	\N	\N	\N	\N	60316	60316	60317
15033	18574	0	applied	\N	\N	\N	\N	60220	60220	60221
15033	18576	1	applied	\N	\N	\N	\N	60228	60228	60229
15033	18578	2	applied	\N	\N	\N	\N	60233	60233	60234
15033	18580	3	applied	\N	\N	\N	\N	60237	60237	60238
15033	18583	4	applied	\N	\N	\N	\N	60246	60246	60247
15033	18584	5	applied	\N	\N	\N	\N	60248	60248	60249
15033	18588	6	applied	\N	\N	\N	\N	60258	60258	60259
15033	18589	7	applied	\N	\N	\N	\N	60262	60262	60263
15033	18592	8	applied	\N	\N	\N	\N	60270	60270	60271
15033	18595	9	applied	\N	\N	\N	\N	60278	60278	60279
15033	18597	10	applied	\N	\N	\N	\N	60285	60285	60286
15033	18598	11	applied	\N	\N	\N	\N	60287	60287	60288
15033	18599	12	applied	\N	\N	\N	\N	60289	60289	60290
15033	18600	13	applied	\N	\N	\N	\N	60291	60291	60292
15033	18607	14	applied	\N	\N	\N	\N	60309	60309	60310
15033	18608	15	applied	\N	\N	\N	\N	60312	60312	60313
15033	18611	16	applied	\N	\N	\N	\N	60322	60322	60323
15033	18613	17	applied	\N	\N	\N	\N	60328	60328	60329
15033	18616	18	applied	\N	\N	\N	\N	60337	60337	60338
15033	18575	19	applied	\N	\N	\N	\N	60222	60222	60223
15033	18577	20	applied	\N	\N	\N	\N	60230	60230	60231
15033	18579	21	applied	\N	\N	\N	\N	60235	60235	60236
15033	18581	22	applied	\N	\N	\N	\N	60239	60239	60240
15033	18582	23	applied	\N	\N	\N	\N	60241	60241	60242
15033	18585	24	applied	\N	\N	\N	\N	60250	60250	60251
15033	18586	25	applied	\N	\N	\N	\N	60252	60252	60253
15033	18587	26	applied	\N	\N	\N	\N	60254	60254	60255
15033	18590	27	applied	\N	\N	\N	\N	60264	60264	60265
15033	18591	28	applied	\N	\N	\N	\N	60266	60266	60267
15033	18593	29	applied	\N	\N	\N	\N	60272	60272	60273
15033	18594	30	applied	\N	\N	\N	\N	60274	60274	60275
15033	18596	31	applied	\N	\N	\N	\N	60280	60280	60281
15033	18601	32	applied	\N	\N	\N	\N	60293	60293	60294
15033	18602	33	applied	\N	\N	\N	\N	60295	60295	60296
15033	18603	34	applied	\N	\N	\N	\N	60297	60297	60298
15033	18604	35	applied	\N	\N	\N	\N	60299	60299	60300
15033	18605	36	applied	\N	\N	\N	\N	60301	60301	60302
15033	18606	37	applied	\N	\N	\N	\N	60303	60303	60304
15033	18609	38	applied	\N	\N	\N	\N	60314	60314	60315
15033	18610	39	applied	\N	\N	\N	\N	60316	60316	60317
15033	18612	40	applied	\N	\N	\N	\N	60324	60324	60325
15033	18614	41	applied	\N	\N	\N	\N	60330	60330	60331
15033	18615	42	applied	\N	\N	\N	\N	60332	60332	60333
15033	18617	43	applied	\N	\N	\N	\N	60339	60339	60340
15035	18618	0	applied	\N	\N	\N	\N	60344	60344	60345
15035	18619	1	applied	\N	\N	\N	\N	60346	60346	60347
15035	18620	2	applied	\N	\N	\N	\N	60348	60348	60349
15035	18621	3	applied	\N	\N	\N	\N	60350	60350	60351
15035	18622	4	applied	\N	\N	\N	\N	60352	60352	60353
15043	18624	0	applied	\N	\N	\N	\N	60362	60362	60363
15043	18625	2	applied	\N	\N	\N	\N	60365	60365	60366
15043	18626	3	applied	\N	\N	\N	\N	60367	60367	60368
15044	18627	0	applied	\N	\N	\N	\N	60377	60377	60378
15044	18628	1	applied	\N	\N	\N	\N	60379	60379	60380
15046	18629	0	applied	\N	\N	\N	\N	60385	60385	60386
15046	18630	1	applied	\N	\N	\N	\N	60387	60387	60388
15049	18631	0	applied	\N	\N	\N	\N	60391	60391	60392
15049	18632	1	applied	\N	\N	\N	\N	60393	60393	60394
15051	18633	0	applied	\N	\N	\N	\N	60398	60398	60399
15061	18641	0	applied	\N	\N	\N	\N	60426	60426	60427
15061	18642	1	applied	\N	\N	\N	\N	60428	60428	60429
15061	18643	2	applied	\N	\N	\N	\N	60430	60430	60431
15061	18644	3	applied	\N	\N	\N	\N	60432	60432	60433
15054	18573	42	applied	\N	\N	\N	\N	60217	60217	60218
15054	18575	43	applied	\N	\N	\N	\N	60222	60222	60223
15054	18577	44	applied	\N	\N	\N	\N	60230	60230	60231
15054	18579	45	applied	\N	\N	\N	\N	60235	60235	60236
15054	18581	46	applied	\N	\N	\N	\N	60239	60239	60240
15054	18582	47	applied	\N	\N	\N	\N	60241	60241	60242
15054	18585	48	applied	\N	\N	\N	\N	60250	60250	60251
15054	18586	49	applied	\N	\N	\N	\N	60252	60252	60253
15054	18587	50	applied	\N	\N	\N	\N	60254	60254	60255
15054	18590	51	applied	\N	\N	\N	\N	60264	60264	60265
15054	18591	52	applied	\N	\N	\N	\N	60266	60266	60267
15054	18593	53	applied	\N	\N	\N	\N	60272	60272	60273
15054	18594	54	applied	\N	\N	\N	\N	60274	60274	60275
15054	18596	55	applied	\N	\N	\N	\N	60280	60280	60281
15054	18601	56	applied	\N	\N	\N	\N	60293	60293	60294
15054	18602	57	applied	\N	\N	\N	\N	60295	60295	60296
15054	18603	58	applied	\N	\N	\N	\N	60297	60297	60298
15054	18604	59	applied	\N	\N	\N	\N	60299	60299	60300
15054	18605	60	applied	\N	\N	\N	\N	60301	60301	60302
15054	18606	61	applied	\N	\N	\N	\N	60303	60303	60304
15054	18609	62	applied	\N	\N	\N	\N	60314	60314	60315
15054	18610	63	applied	\N	\N	\N	\N	60316	60316	60317
15054	18612	64	applied	\N	\N	\N	\N	60324	60324	60325
15054	18614	65	applied	\N	\N	\N	\N	60330	60330	60331
15054	18615	66	applied	\N	\N	\N	\N	60332	60332	60333
15054	18617	67	applied	\N	\N	\N	\N	60339	60339	60340
15054	18620	68	applied	\N	\N	\N	\N	60348	60348	60349
15054	18621	69	applied	\N	\N	\N	\N	60350	60350	60351
15054	18622	70	applied	\N	\N	\N	\N	60352	60352	60353
15054	18625	71	applied	\N	\N	\N	\N	60365	60365	60366
15054	18626	72	applied	\N	\N	\N	\N	60367	60367	60368
15054	18628	73	applied	\N	\N	\N	\N	60379	60379	60380
15054	18630	74	applied	\N	\N	\N	\N	60387	60387	60388
15054	18632	75	applied	\N	\N	\N	\N	60393	60393	60394
15057	18636	0	applied	\N	\N	\N	\N	60411	60411	60412
15057	18637	1	applied	\N	\N	\N	\N	60413	60413	60414
15057	18638	2	applied	\N	\N	\N	\N	60415	60415	60416
15059	18639	0	applied	\N	\N	\N	\N	60421	60421	60422
15059	18640	1	applied	\N	\N	\N	\N	60423	60423	60424
15062	18641	0	applied	\N	\N	\N	\N	60426	60426	60427
15062	18642	1	applied	\N	\N	\N	\N	60428	60428	60429
15062	18643	2	applied	\N	\N	\N	\N	60430	60430	60431
15062	18644	3	applied	\N	\N	\N	\N	60432	60432	60433
15064	18641	0	applied	\N	\N	\N	\N	60426	60426	60427
15064	18642	1	applied	\N	\N	\N	\N	60428	60428	60429
15064	18643	2	applied	\N	\N	\N	\N	60430	60430	60431
15064	18644	3	applied	\N	\N	\N	\N	60432	60432	60433
15065	18645	0	applied	\N	\N	\N	\N	60441	60441	60442
15065	18646	1	applied	\N	\N	\N	\N	60443	60443	60444
15066	18645	0	applied	\N	\N	\N	\N	60441	60441	60442
15066	18646	1	applied	\N	\N	\N	\N	60443	60443	60444
15067	18647	0	applied	\N	\N	\N	\N	60448	60448	60449
15067	18648	1	applied	\N	\N	\N	\N	60450	60450	60451
15068	18647	0	applied	\N	\N	\N	\N	60448	60448	60449
15068	18648	1	applied	\N	\N	\N	\N	60450	60450	60451
15069	18649	0	applied	\N	\N	\N	\N	60455	60455	60456
15070	18649	0	applied	\N	\N	\N	\N	60455	60455	60456
15071	18649	0	applied	\N	\N	\N	\N	60455	60455	60456
15072	18650	0	applied	\N	\N	\N	\N	60460	60460	60461
15073	18651	0	applied	\N	\N	\N	\N	60463	60463	60464
15074	18652	0	applied	\N	\N	\N	\N	60465	60465	60466
15074	18653	1	applied	\N	\N	\N	\N	60467	60467	60468
15075	18654	0	applied	\N	\N	\N	\N	60470	60470	60471
15075	18655	1	applied	\N	\N	\N	\N	60472	60472	60473
15076	18656	0	applied	\N	\N	\N	\N	60476	60476	60477
15077	18657	0	applied	\N	\N	\N	\N	60479	60479	60480
15077	18658	1	applied	\N	\N	\N	\N	60481	60481	60482
15077	18659	2	applied	\N	\N	\N	\N	60483	60483	60484
15077	18660	3	applied	\N	\N	\N	\N	60485	60485	60486
15077	18661	4	applied	\N	\N	\N	\N	60487	60487	60488
15078	18657	0	applied	\N	\N	\N	\N	60479	60479	60480
15078	18658	1	applied	\N	\N	\N	\N	60481	60481	60482
15078	18659	2	applied	\N	\N	\N	\N	60483	60483	60484
15078	18660	3	applied	\N	\N	\N	\N	60485	60485	60486
15078	18661	4	applied	\N	\N	\N	\N	60487	60487	60488
15079	18657	0	applied	\N	\N	\N	\N	60479	60479	60480
15079	18658	1	applied	\N	\N	\N	\N	60481	60481	60482
15079	18659	2	applied	\N	\N	\N	\N	60483	60483	60484
15079	18660	3	applied	\N	\N	\N	\N	60485	60485	60486
15079	18661	4	applied	\N	\N	\N	\N	60487	60487	60488
15080	18662	0	applied	\N	\N	\N	\N	60493	60493	60494
15080	18663	1	applied	\N	\N	\N	\N	60495	60495	60496
15080	18664	2	applied	\N	\N	\N	\N	60497	60497	60498
15081	18665	0	applied	\N	\N	\N	\N	60501	60501	60502
15081	18666	1	applied	\N	\N	\N	\N	60503	60503	60504
15081	18667	2	applied	\N	\N	\N	\N	60505	60505	60506
15082	18665	0	applied	\N	\N	\N	\N	60501	60501	60502
15082	18666	1	applied	\N	\N	\N	\N	60503	60503	60504
15082	18667	2	applied	\N	\N	\N	\N	60505	60505	60506
15083	18668	0	applied	\N	\N	\N	\N	60511	60511	60512
15083	18669	1	applied	\N	\N	\N	\N	60513	60513	60514
15084	18670	0	applied	\N	\N	\N	\N	60516	60516	60517
15084	18671	1	applied	\N	\N	\N	\N	60518	60518	60519
15085	18672	0	applied	\N	\N	\N	\N	60522	60522	60523
15086	18673	0	applied	\N	\N	\N	\N	60526	60526	60527
15086	18674	1	applied	\N	\N	\N	\N	60528	60528	60529
15087	18673	0	applied	\N	\N	\N	\N	60526	60526	60527
15087	18674	1	applied	\N	\N	\N	\N	60528	60528	60529
15088	18675	0	applied	\N	\N	\N	\N	60533	60533	60534
15089	18675	0	applied	\N	\N	\N	\N	60533	60533	60534
15090	18676	0	applied	\N	\N	\N	\N	60539	60539	60540
15090	18677	1	applied	\N	\N	\N	\N	60541	60541	60542
15091	18678	0	applied	\N	\N	\N	\N	60544	60544	60545
15091	18679	1	applied	\N	\N	\N	\N	60546	60546	60547
15094	18680	0	applied	\N	\N	\N	\N	60551	60551	60552
15095	18680	0	applied	\N	\N	\N	\N	60551	60551	60552
15096	18680	0	applied	\N	\N	\N	\N	60551	60551	60552
15098	18681	0	applied	\N	\N	\N	\N	60559	60559	60560
15099	18682	0	applied	\N	\N	\N	\N	60563	60563	60564
15099	18683	1	applied	\N	\N	\N	\N	60565	60565	60566
15100	18682	0	applied	\N	\N	\N	\N	60563	60563	60564
15100	18683	1	applied	\N	\N	\N	\N	60565	60565	60566
15103	18684	0	applied	\N	\N	\N	\N	60571	60571	60572
15103	18685	1	applied	\N	\N	\N	\N	60573	60573	60574
15103	18686	2	applied	\N	\N	\N	\N	60575	60575	60576
15104	18687	0	applied	\N	\N	\N	\N	60578	60578	60579
15105	18688	0	applied	\N	\N	\N	\N	60582	60582	60583
15105	18689	1	applied	\N	\N	\N	\N	60584	60584	60585
15106	18688	0	applied	\N	\N	\N	\N	60582	60582	60583
15106	18690	1	applied	\N	\N	\N	\N	60588	60588	60589
15106	18689	2	applied	\N	\N	\N	\N	60584	60584	60585
15106	18691	3	applied	\N	\N	\N	\N	60590	60590	60591
15106	18692	4	applied	\N	\N	1000000000	\N	60592	60592	60593
15106	18693	5	applied	\N	\N	1000000000	\N	60594	60594	60595
15106	18694	6	applied	\N	\N	1000000000	\N	60596	60596	60597
15106	18695	7	applied	\N	\N	\N	\N	60598	60598	60599
15109	18690	0	applied	\N	\N	\N	\N	60588	60588	60589
15109	18691	1	applied	\N	\N	\N	\N	60590	60590	60591
15109	18692	2	applied	\N	\N	1000000000	\N	60592	60592	60593
15109	18693	3	applied	\N	\N	1000000000	\N	60594	60594	60595
15109	18694	4	applied	\N	\N	1000000000	\N	60596	60596	60597
15109	18695	5	applied	\N	\N	\N	\N	60598	60598	60599
15111	18698	0	applied	\N	\N	\N	\N	60611	60611	60612
15111	18699	1	applied	\N	\N	\N	\N	60613	60613	60614
15111	18700	2	applied	\N	\N	\N	\N	60615	60615	60616
15111	18701	3	applied	\N	\N	\N	\N	60617	60617	60618
15114	18705	0	applied	\N	\N	\N	\N	60628	60628	60629
15114	18706	1	applied	\N	\N	\N	\N	60630	60630	60631
15114	18707	2	applied	\N	\N	\N	\N	60632	60632	60633
15117	18712	0	applied	\N	\N	\N	\N	60648	60648	60649
15125	18717	0	applied	\N	\N	\N	\N	60666	60666	60667
15129	18723	0	applied	\N	\N	\N	\N	60685	60685	60686
15129	18724	1	applied	\N	\N	\N	\N	60687	60687	60688
15129	18725	2	applied	\N	\N	\N	\N	60689	60689	60690
15129	18726	3	applied	\N	\N	\N	\N	60691	60691	60692
15129	18727	4	applied	\N	\N	\N	\N	60693	60693	60694
15138	18737	0	applied	\N	\N	\N	\N	60726	60726	60727
15138	18738	1	applied	\N	\N	\N	\N	60728	60728	60729
15140	18739	0	applied	\N	\N	\N	\N	60734	60734	60735
15140	18740	1	applied	\N	\N	\N	\N	60736	60736	60737
15148	18751	0	applied	\N	\N	\N	\N	60772	60772	60773
15148	18752	1	applied	\N	\N	\N	\N	60774	60774	60775
15148	18753	2	applied	\N	\N	\N	\N	60776	60776	60777
15148	18754	3	applied	\N	\N	\N	\N	60778	60778	60779
15148	18755	4	applied	\N	\N	\N	\N	60780	60780	60781
15148	18756	5	applied	\N	\N	\N	\N	60782	60782	60783
15153	18763	0	applied	\N	\N	\N	\N	60807	60807	60808
15153	18764	1	applied	\N	\N	\N	\N	60809	60809	60810
15155	18765	0	applied	\N	\N	\N	\N	60816	60816	60817
15155	18766	1	applied	\N	\N	\N	\N	60818	60818	60819
15158	18769	0	applied	\N	\N	\N	\N	60829	60829	60830
15158	18770	1	applied	\N	\N	\N	\N	60831	60831	60832
15158	18771	2	applied	\N	\N	\N	\N	60833	60833	60834
15165	18777	0	applied	\N	\N	\N	\N	60857	60857	60858
15165	18778	1	applied	\N	\N	\N	\N	60859	60859	60860
15165	18779	2	applied	\N	\N	\N	\N	60861	60861	60862
15168	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15168	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15168	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15168	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15176	18785	0	applied	\N	\N	\N	\N	60893	60893	60894
15176	18786	1	applied	\N	\N	\N	\N	60895	60895	60896
15176	18787	2	applied	\N	\N	\N	\N	60897	60897	60898
15178	18788	0	applied	\N	\N	\N	\N	60903	60903	60904
15178	18789	1	applied	\N	\N	\N	\N	60905	60905	60906
15178	18790	2	applied	\N	\N	\N	\N	60907	60907	60908
15183	18797	0	applied	\N	\N	\N	\N	60927	60927	60928
15183	18798	1	applied	\N	\N	\N	\N	60929	60929	60930
15183	18799	2	applied	\N	\N	\N	\N	60931	60931	60932
15193	18818	0	applied	\N	\N	\N	\N	60980	60980	60981
15193	18819	1	applied	\N	\N	\N	\N	60982	60982	60983
15193	18820	2	applied	\N	\N	\N	\N	60984	60984	60985
15200	18825	0	applied	\N	\N	\N	\N	61004	61004	61005
15200	18826	1	applied	\N	\N	\N	\N	61006	61006	61007
15200	18827	2	applied	\N	\N	\N	\N	61008	61008	61009
15202	18828	0	applied	\N	\N	\N	\N	61012	61012	61013
15202	18829	1	applied	\N	\N	\N	\N	61014	61014	61015
15209	18833	0	applied	\N	\N	\N	\N	61031	61031	61032
15209	18834	1	applied	\N	\N	\N	\N	61033	61033	61034
15209	18835	2	applied	\N	\N	\N	\N	61035	61035	61036
15209	18836	3	applied	\N	\N	\N	\N	61037	61037	61038
15216	18844	0	applied	\N	\N	\N	\N	61062	61062	61063
15216	18845	1	applied	\N	\N	\N	\N	61064	61064	61065
15225	18858	0	applied	\N	\N	\N	\N	61102	61102	61103
15225	18859	1	applied	\N	\N	\N	\N	61104	61104	61105
15225	18860	2	applied	\N	\N	\N	\N	61106	61106	61107
15227	18858	0	applied	\N	\N	\N	\N	61102	61102	61103
15227	18859	1	applied	\N	\N	\N	\N	61104	61104	61105
15227	18860	2	applied	\N	\N	\N	\N	61106	61106	61107
15229	18861	0	applied	\N	\N	\N	\N	61113	61113	61114
15236	18868	0	applied	\N	\N	\N	\N	61134	61134	61135
15236	18869	1	applied	\N	\N	\N	\N	61136	61136	61137
15238	18868	0	applied	\N	\N	\N	\N	61134	61134	61135
15238	18869	1	applied	\N	\N	\N	\N	61136	61136	61137
15241	18874	0	applied	\N	\N	\N	\N	61154	61154	61155
15241	18875	1	applied	\N	\N	\N	\N	61156	61156	61157
15241	18876	2	applied	\N	\N	\N	\N	61158	61158	61159
15241	18877	3	applied	\N	\N	\N	\N	61160	61160	61161
15241	18878	4	applied	\N	\N	\N	\N	61162	61162	61163
15241	18879	5	applied	\N	\N	\N	\N	61164	61164	61165
15241	18880	6	applied	\N	\N	\N	\N	61166	61166	61167
15247	18893	0	applied	\N	\N	\N	\N	61199	61199	61200
15247	18894	1	applied	\N	\N	\N	\N	61201	61201	61202
15247	18895	2	applied	\N	\N	\N	\N	61203	61203	61204
15247	18896	3	applied	\N	\N	\N	\N	61205	61205	61206
15247	18897	4	applied	\N	\N	\N	\N	61207	61207	61208
15247	18898	5	applied	\N	\N	\N	\N	61209	61209	61210
15247	18899	6	applied	\N	\N	\N	\N	61211	61211	61212
15252	18905	0	applied	\N	\N	\N	\N	61233	61233	61234
15252	18906	1	applied	\N	\N	\N	\N	61235	61235	61236
15252	18907	2	applied	\N	\N	\N	\N	61237	61237	61238
15252	18908	3	applied	\N	\N	\N	\N	61239	61239	61240
15254	18905	0	applied	\N	\N	\N	\N	61233	61233	61234
15254	18906	1	applied	\N	\N	\N	\N	61235	61235	61236
15254	18907	2	applied	\N	\N	\N	\N	61237	61237	61238
15254	18908	3	applied	\N	\N	\N	\N	61239	61239	61240
15257	18909	0	applied	\N	\N	\N	\N	61247	61247	61248
15257	18910	1	applied	\N	\N	\N	\N	61249	61249	61250
15257	18911	2	applied	\N	\N	\N	\N	61251	61251	61252
15257	18912	3	applied	\N	\N	\N	\N	61253	61253	61254
15257	18913	4	applied	\N	\N	\N	\N	61255	61255	61256
15257	18914	5	applied	\N	\N	\N	\N	61257	61257	61258
15257	18915	6	applied	\N	\N	\N	\N	61259	61259	61260
15257	18916	7	applied	\N	\N	\N	\N	61261	61261	61262
15257	18917	8	applied	\N	\N	\N	\N	61263	61263	61264
15257	18918	10	applied	\N	\N	\N	\N	61266	61266	61267
15264	18927	0	applied	\N	\N	\N	\N	61298	61298	61299
15269	18928	0	applied	\N	\N	\N	\N	61304	61304	61305
15269	18929	1	applied	\N	\N	\N	\N	61306	61306	61307
15107	18690	0	applied	\N	\N	\N	\N	60588	60588	60589
15107	18691	1	applied	\N	\N	\N	\N	60590	60590	60591
15107	18692	2	applied	\N	\N	1000000000	\N	60592	60592	60593
15107	18693	3	applied	\N	\N	1000000000	\N	60594	60594	60595
15107	18694	4	applied	\N	\N	1000000000	\N	60596	60596	60597
15107	18695	5	applied	\N	\N	\N	\N	60598	60598	60599
15110	18696	0	applied	\N	\N	\N	\N	60605	60605	60606
15110	18697	1	applied	\N	\N	\N	\N	60607	60607	60608
15115	18708	0	applied	\N	\N	\N	\N	60636	60636	60637
15119	18713	0	applied	\N	\N	\N	\N	60651	60651	60652
15119	18714	1	applied	\N	\N	\N	\N	60653	60653	60654
15122	18717	0	applied	\N	\N	\N	\N	60666	60666	60667
15124	18717	0	applied	\N	\N	\N	\N	60666	60666	60667
15130	18723	0	applied	\N	\N	\N	\N	60685	60685	60686
15130	18724	1	applied	\N	\N	\N	\N	60687	60687	60688
15130	18725	2	applied	\N	\N	\N	\N	60689	60689	60690
15130	18726	3	applied	\N	\N	\N	\N	60691	60691	60692
15130	18727	4	applied	\N	\N	\N	\N	60693	60693	60694
15133	18731	0	applied	\N	\N	\N	\N	60708	60708	60709
15133	18732	1	applied	\N	\N	\N	\N	60710	60710	60711
15139	18737	0	applied	\N	\N	\N	\N	60726	60726	60727
15139	18738	1	applied	\N	\N	\N	\N	60728	60728	60729
15142	18741	0	applied	\N	\N	\N	\N	60739	60739	60740
15150	18757	0	applied	\N	\N	\N	\N	60785	60785	60786
15150	18758	1	applied	\N	\N	\N	\N	60787	60787	60788
15150	18759	2	applied	\N	\N	\N	\N	60789	60789	60790
15150	18760	3	applied	\N	\N	\N	\N	60791	60791	60792
15150	18761	4	applied	\N	\N	\N	\N	60793	60793	60794
15150	18762	6	applied	\N	\N	\N	\N	60796	60796	60797
15154	18764	0	applied	\N	\N	\N	\N	60809	60809	60810
15156	18765	0	applied	\N	\N	\N	\N	60816	60816	60817
15156	18766	1	applied	\N	\N	\N	\N	60818	60818	60819
15159	18769	0	applied	\N	\N	\N	\N	60829	60829	60830
15159	18770	1	applied	\N	\N	\N	\N	60831	60831	60832
15159	18771	2	applied	\N	\N	\N	\N	60833	60833	60834
15161	18772	0	applied	\N	\N	1000000000	\N	60839	60839	60840
15163	18776	0	applied	\N	\N	\N	\N	60851	60851	60852
15169	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15169	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15169	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15169	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15172	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15172	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15172	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15172	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15174	18784	0	applied	\N	\N	\N	\N	60887	60887	60888
15181	18791	0	applied	\N	\N	1000000000	\N	60912	60912	60913
15181	18792	1	applied	\N	\N	\N	\N	60914	60914	60915
15181	18793	2	applied	\N	\N	\N	\N	60916	60916	60917
15181	18794	3	applied	\N	\N	1000000000	\N	60918	60918	60919
15181	18795	4	applied	\N	\N	\N	\N	60920	60920	60921
15181	18796	5	applied	\N	\N	\N	\N	60922	60922	60923
15186	18800	0	applied	\N	\N	\N	\N	60937	60937	60938
15186	18801	1	applied	\N	\N	\N	\N	60939	60939	60940
15188	18802	0	applied	\N	\N	\N	\N	60945	60945	60946
15189	18803	0	applied	\N	\N	\N	\N	60949	60949	60950
15189	18804	1	applied	\N	\N	\N	\N	60951	60951	60952
15189	18805	2	applied	\N	\N	\N	\N	60953	60953	60954
15189	18806	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	60955	60955	\N
15189	18807	4	applied	\N	\N	\N	\N	60956	60956	13107
15189	18808	5	applied	\N	\N	\N	\N	60957	60957	23829
15189	18809	6	applied	\N	\N	\N	\N	60958	60958	60959
15189	18810	7	applied	\N	\N	\N	\N	60960	60960	60961
15189	18811	8	applied	\N	\N	\N	\N	60962	60962	60963
15189	18812	9	applied	\N	\N	\N	\N	60964	60964	60965
15189	18813	10	applied	\N	\N	\N	\N	60966	60966	60967
15191	18814	0	applied	\N	\N	\N	\N	60970	60970	60971
15191	18815	1	applied	\N	\N	\N	\N	60972	60972	60973
15196	18772	0	applied	\N	\N	1000000000	\N	60839	60839	60840
15196	18744	1	applied	\N	\N	\N	\N	60756	60756	60757
15196	18745	2	applied	\N	\N	\N	\N	60758	60758	60759
15196	18746	3	applied	\N	\N	\N	\N	60760	60760	60761
15196	18751	4	applied	\N	\N	\N	\N	60772	60772	60773
15196	18752	5	applied	\N	\N	\N	\N	60774	60774	60775
15196	18753	6	applied	\N	\N	\N	\N	60776	60776	60777
15196	18757	7	applied	\N	\N	\N	\N	60785	60785	60786
15196	18758	8	applied	\N	\N	\N	\N	60787	60787	60788
15196	18763	9	applied	\N	\N	\N	\N	60807	60807	60808
15196	18765	10	applied	\N	\N	\N	\N	60816	60816	60817
15196	18767	11	applied	\N	\N	\N	\N	60823	60823	60824
15196	18769	12	applied	\N	\N	\N	\N	60829	60829	60830
15196	18773	13	applied	\N	\N	\N	\N	60841	60841	60842
15196	18776	14	applied	\N	\N	\N	\N	60851	60851	60852
15196	18777	15	applied	\N	\N	\N	\N	60857	60857	60858
15196	18780	16	applied	\N	\N	\N	\N	60867	60867	60868
15196	18784	17	applied	\N	\N	\N	\N	60887	60887	60888
15196	18785	18	applied	\N	\N	\N	\N	60893	60893	60894
15196	18788	19	applied	\N	\N	\N	\N	60903	60903	60904
15196	18792	20	applied	\N	\N	\N	\N	60914	60914	60915
15196	18793	21	applied	\N	\N	\N	\N	60916	60916	60917
15196	18797	22	applied	\N	\N	\N	\N	60927	60927	60928
15196	18798	23	applied	\N	\N	\N	\N	60929	60929	60930
15196	18800	24	applied	\N	\N	\N	\N	60937	60937	60938
15196	18802	25	applied	\N	\N	\N	\N	60945	60945	60946
15196	18803	26	applied	\N	\N	\N	\N	60949	60949	60950
15196	18804	27	applied	\N	\N	\N	\N	60951	60951	60952
15196	18805	28	applied	\N	\N	\N	\N	60953	60953	60954
15196	18814	29	applied	\N	\N	\N	\N	60970	60970	60971
15196	18816	30	applied	\N	\N	\N	\N	60975	60975	60976
15196	18818	31	applied	\N	\N	\N	\N	60980	60980	60981
15196	18821	32	applied	\N	\N	\N	\N	60989	60989	60990
15196	18747	33	applied	\N	\N	\N	\N	60762	60762	60763
15196	18748	34	applied	\N	\N	\N	\N	60764	60764	60765
15196	18749	35	applied	\N	\N	1000000000	\N	60766	60766	60767
15196	18750	36	applied	\N	\N	\N	\N	60768	60768	60769
15196	18754	37	applied	\N	\N	\N	\N	60778	60778	60779
15196	18755	38	applied	\N	\N	\N	\N	60780	60780	60781
15196	18756	39	applied	\N	\N	\N	\N	60782	60782	60783
15196	18759	40	applied	\N	\N	\N	\N	60789	60789	60790
15196	18760	41	applied	\N	\N	\N	\N	60791	60791	60792
15196	18761	42	applied	\N	\N	\N	\N	60793	60793	60794
15196	18762	43	applied	\N	\N	\N	\N	60796	60796	60797
15196	18764	45	applied	\N	\N	\N	\N	60809	60809	60810
15196	18766	46	applied	\N	\N	\N	\N	60818	60818	60819
15196	18768	47	applied	\N	\N	\N	\N	60825	60825	60826
15196	18770	48	applied	\N	\N	\N	\N	60831	60831	60832
15196	18771	49	applied	\N	\N	\N	\N	60833	60833	60834
15196	18774	50	applied	\N	\N	\N	\N	60843	60843	60844
15108	18690	0	applied	\N	\N	\N	\N	60588	60588	60589
15108	18691	1	applied	\N	\N	\N	\N	60590	60590	60591
15108	18692	2	applied	\N	\N	1000000000	\N	60592	60592	60593
15108	18693	3	applied	\N	\N	1000000000	\N	60594	60594	60595
15108	18694	4	applied	\N	\N	1000000000	\N	60596	60596	60597
15108	18695	5	applied	\N	\N	\N	\N	60598	60598	60599
15116	18709	0	applied	\N	\N	\N	\N	60640	60640	60641
15116	18710	1	applied	\N	\N	\N	\N	60642	60642	60643
15116	18711	2	applied	\N	\N	\N	\N	60644	60644	60645
15120	18713	0	applied	\N	\N	\N	\N	60651	60651	60652
15120	18714	1	applied	\N	\N	\N	\N	60653	60653	60654
15121	18715	0	applied	\N	\N	\N	\N	60660	60660	60661
15121	18716	1	applied	\N	\N	\N	\N	60662	60662	60663
15126	18718	0	applied	\N	\N	\N	\N	60671	60671	60672
15126	18719	1	applied	\N	\N	\N	\N	60673	60673	60674
15126	18720	2	applied	\N	\N	\N	\N	60675	60675	60676
15127	18709	0	applied	\N	\N	\N	\N	60640	60640	60641
15127	18710	1	applied	\N	\N	\N	\N	60642	60642	60643
15127	18711	2	applied	\N	\N	\N	\N	60644	60644	60645
15131	18728	0	applied	\N	\N	\N	\N	60698	60698	60699
15134	18733	0	applied	\N	\N	\N	\N	60713	60713	60714
15134	18734	1	applied	\N	\N	\N	\N	60715	60715	60716
15134	18735	2	applied	\N	\N	\N	\N	60717	60717	60718
15137	18736	0	applied	\N	\N	\N	\N	60723	60723	60724
15144	18742	0	applied	\N	\N	\N	\N	60747	60747	60748
15144	18743	1	applied	\N	\N	\N	\N	60749	60749	60750
15146	18718	0	applied	\N	\N	\N	\N	60671	60671	60672
15146	18719	1	applied	\N	\N	\N	\N	60673	60673	60674
15146	18721	2	applied	\N	\N	\N	\N	60679	60679	60680
15146	18723	3	applied	\N	\N	\N	\N	60685	60685	60686
15146	18724	4	applied	\N	\N	\N	\N	60687	60687	60688
15146	18725	5	applied	\N	\N	\N	\N	60689	60689	60690
15146	18728	6	applied	\N	\N	\N	\N	60698	60698	60699
15146	18729	7	applied	\N	\N	\N	\N	60702	60702	60703
15146	18731	8	applied	\N	\N	\N	\N	60708	60708	60709
15146	18733	9	applied	\N	\N	\N	\N	60713	60713	60714
15146	18734	10	applied	\N	\N	\N	\N	60715	60715	60716
15146	18736	11	applied	\N	\N	\N	\N	60723	60723	60724
15146	18737	12	applied	\N	\N	\N	\N	60726	60726	60727
15146	18739	13	applied	\N	\N	\N	\N	60734	60734	60735
15146	18741	14	applied	\N	\N	\N	\N	60739	60739	60740
15146	18742	15	applied	\N	\N	\N	\N	60747	60747	60748
15146	18720	16	applied	\N	\N	\N	\N	60675	60675	60676
15146	18722	17	applied	\N	\N	\N	\N	60681	60681	60682
15146	18726	18	applied	\N	\N	\N	\N	60691	60691	60692
15146	18727	19	applied	\N	\N	\N	\N	60693	60693	60694
15146	18730	20	applied	\N	\N	\N	\N	60704	60704	60705
15146	18732	21	applied	\N	\N	\N	\N	60710	60710	60711
15146	18735	22	applied	\N	\N	\N	\N	60717	60717	60718
15146	18738	23	applied	\N	\N	\N	\N	60728	60728	60729
15146	18740	24	applied	\N	\N	\N	\N	60736	60736	60737
15146	18743	25	applied	\N	\N	\N	\N	60749	60749	60750
15147	18744	0	applied	\N	\N	\N	\N	60756	60756	60757
15147	18745	1	applied	\N	\N	\N	\N	60758	60758	60759
15147	18746	2	applied	\N	\N	\N	\N	60760	60760	60761
15147	18747	3	applied	\N	\N	\N	\N	60762	60762	60763
15147	18748	4	applied	\N	\N	\N	\N	60764	60764	60765
15147	18749	5	applied	\N	\N	1000000000	\N	60766	60766	60767
15147	18750	6	applied	\N	\N	\N	\N	60768	60768	60769
15157	18767	0	applied	\N	\N	\N	\N	60823	60823	60824
15157	18768	1	applied	\N	\N	\N	\N	60825	60825	60826
15166	18777	0	applied	\N	\N	\N	\N	60857	60857	60858
15166	18778	1	applied	\N	\N	\N	\N	60859	60859	60860
15166	18779	2	applied	\N	\N	\N	\N	60861	60861	60862
15177	18785	0	applied	\N	\N	\N	\N	60893	60893	60894
15177	18786	1	applied	\N	\N	\N	\N	60895	60895	60896
15177	18787	2	applied	\N	\N	\N	\N	60897	60897	60898
15179	18788	0	applied	\N	\N	\N	\N	60903	60903	60904
15179	18789	1	applied	\N	\N	\N	\N	60905	60905	60906
15179	18790	2	applied	\N	\N	\N	\N	60907	60907	60908
15182	18797	0	applied	\N	\N	\N	\N	60927	60927	60928
15182	18798	1	applied	\N	\N	\N	\N	60929	60929	60930
15182	18799	2	applied	\N	\N	\N	\N	60931	60931	60932
15184	18797	0	applied	\N	\N	\N	\N	60927	60927	60928
15184	18798	1	applied	\N	\N	\N	\N	60929	60929	60930
15184	18799	2	applied	\N	\N	\N	\N	60931	60931	60932
15192	18816	0	applied	\N	\N	\N	\N	60975	60975	60976
15192	18817	1	applied	\N	\N	\N	\N	60977	60977	60978
15194	18818	0	applied	\N	\N	\N	\N	60980	60980	60981
15194	18819	1	applied	\N	\N	\N	\N	60982	60982	60983
15194	18820	2	applied	\N	\N	\N	\N	60984	60984	60985
15199	18825	0	applied	\N	\N	\N	\N	61004	61004	61005
15199	18826	1	applied	\N	\N	\N	\N	61006	61006	61007
15199	18827	2	applied	\N	\N	\N	\N	61008	61008	61009
15201	18828	0	applied	\N	\N	\N	\N	61012	61012	61013
15201	18829	1	applied	\N	\N	\N	\N	61014	61014	61015
15204	18830	0	applied	\N	\N	\N	\N	61018	61018	61019
15204	18831	1	applied	\N	\N	\N	\N	61020	61020	61021
15204	18832	2	applied	\N	\N	\N	\N	61022	61022	61023
15208	18833	0	applied	\N	\N	\N	\N	61031	61031	61032
15208	18834	1	applied	\N	\N	\N	\N	61033	61033	61034
15208	18835	2	applied	\N	\N	\N	\N	61035	61035	61036
15208	18836	3	applied	\N	\N	\N	\N	61037	61037	61038
15210	18837	0	applied	\N	\N	\N	\N	61041	61041	61042
15210	18838	1	applied	\N	\N	\N	\N	61043	61043	61044
15210	18839	2	applied	\N	\N	\N	\N	61045	61045	61046
15215	18844	0	applied	\N	\N	\N	\N	61062	61062	61063
15215	18845	1	applied	\N	\N	\N	\N	61064	61064	61065
15218	18851	0	applied	\N	\N	\N	\N	61082	61082	61083
15218	18852	1	applied	\N	\N	\N	\N	61084	61084	61085
15218	18853	2	applied	\N	\N	\N	\N	61086	61086	61087
15218	18854	3	applied	\N	\N	\N	\N	61088	61088	61089
15218	18855	4	applied	\N	\N	\N	\N	61090	61090	61091
15220	18851	0	applied	\N	\N	\N	\N	61082	61082	61083
15220	18852	1	applied	\N	\N	\N	\N	61084	61084	61085
15220	18853	2	applied	\N	\N	\N	\N	61086	61086	61087
15220	18854	3	applied	\N	\N	\N	\N	61088	61088	61089
15220	18855	4	applied	\N	\N	\N	\N	61090	61090	61091
15222	18856	0	applied	\N	\N	\N	\N	61096	61096	61097
15222	18857	1	applied	\N	\N	\N	\N	61098	61098	61099
15224	18856	0	applied	\N	\N	\N	\N	61096	61096	61097
15224	18857	1	applied	\N	\N	\N	\N	61098	61098	61099
15231	18862	0	applied	\N	\N	\N	\N	61119	61119	61120
15231	18863	1	applied	\N	\N	\N	\N	61121	61121	61122
15231	18864	2	applied	\N	\N	\N	\N	61123	61123	61124
15233	18865	0	applied	\N	\N	\N	\N	61126	61126	61127
15233	18866	1	applied	\N	\N	\N	\N	61128	61128	61129
15233	18867	2	applied	\N	\N	\N	\N	61130	61130	61131
15240	18872	0	applied	\N	\N	\N	\N	61148	61148	61149
15113	18702	0	applied	\N	\N	\N	\N	60621	60621	60622
15113	18703	1	applied	\N	\N	\N	\N	60623	60623	60624
15113	18704	2	applied	\N	\N	\N	\N	60625	60625	60626
15118	18713	0	applied	\N	\N	\N	\N	60651	60651	60652
15118	18714	1	applied	\N	\N	\N	\N	60653	60653	60654
15123	18717	0	applied	\N	\N	\N	\N	60666	60666	60667
15128	18721	0	applied	\N	\N	\N	\N	60679	60679	60680
15128	18722	1	applied	\N	\N	\N	\N	60681	60681	60682
15132	18729	0	applied	\N	\N	\N	\N	60702	60702	60703
15132	18730	1	applied	\N	\N	\N	\N	60704	60704	60705
15135	18733	0	applied	\N	\N	\N	\N	60713	60713	60714
15135	18734	1	applied	\N	\N	\N	\N	60715	60715	60716
15135	18735	2	applied	\N	\N	\N	\N	60717	60717	60718
15141	18741	0	applied	\N	\N	\N	\N	60739	60739	60740
15143	18741	0	applied	\N	\N	\N	\N	60739	60739	60740
15145	18742	0	applied	\N	\N	\N	\N	60747	60747	60748
15145	18743	1	applied	\N	\N	\N	\N	60749	60749	60750
15149	18757	0	applied	\N	\N	\N	\N	60785	60785	60786
15149	18758	1	applied	\N	\N	\N	\N	60787	60787	60788
15149	18759	2	applied	\N	\N	\N	\N	60789	60789	60790
15149	18760	3	applied	\N	\N	\N	\N	60791	60791	60792
15149	18761	4	applied	\N	\N	\N	\N	60793	60793	60794
15149	18762	6	applied	\N	\N	\N	\N	60796	60796	60797
15151	18757	0	applied	\N	\N	\N	\N	60785	60785	60786
15151	18758	1	applied	\N	\N	\N	\N	60787	60787	60788
15151	18759	2	applied	\N	\N	\N	\N	60789	60789	60790
15151	18760	3	applied	\N	\N	\N	\N	60791	60791	60792
15151	18761	4	applied	\N	\N	\N	\N	60793	60793	60794
15151	18762	6	applied	\N	\N	\N	\N	60796	60796	60797
15160	18772	0	applied	\N	\N	1000000000	\N	60839	60839	60840
15160	18773	1	applied	\N	\N	\N	\N	60841	60841	60842
15160	18774	2	applied	\N	\N	\N	\N	60843	60843	60844
15160	18775	3	applied	\N	\N	\N	\N	60845	60845	60846
15162	18776	0	applied	\N	\N	\N	\N	60851	60851	60852
15164	18776	0	applied	\N	\N	\N	\N	60851	60851	60852
15167	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15167	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15167	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15167	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15170	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15170	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15170	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15170	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15171	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15171	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15171	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15171	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15173	18780	0	applied	\N	\N	\N	\N	60867	60867	60868
15173	18781	1	applied	\N	\N	\N	\N	60869	60869	60870
15173	18782	2	applied	\N	\N	\N	\N	60871	60871	60872
15173	18783	3	applied	\N	\N	\N	\N	60873	60873	60874
15175	18784	0	applied	\N	\N	\N	\N	60887	60887	60888
15180	18791	0	applied	\N	\N	1000000000	\N	60912	60912	60913
15180	18792	1	applied	\N	\N	\N	\N	60914	60914	60915
15180	18793	2	applied	\N	\N	\N	\N	60916	60916	60917
15180	18794	3	applied	\N	\N	1000000000	\N	60918	60918	60919
15180	18795	4	applied	\N	\N	\N	\N	60920	60920	60921
15180	18796	5	applied	\N	\N	\N	\N	60922	60922	60923
15185	18800	0	applied	\N	\N	\N	\N	60937	60937	60938
15185	18801	1	applied	\N	\N	\N	\N	60939	60939	60940
15187	18800	0	applied	\N	\N	\N	\N	60937	60937	60938
15187	18801	1	applied	\N	\N	\N	\N	60939	60939	60940
15190	18803	0	applied	\N	\N	\N	\N	60949	60949	60950
15190	18804	1	applied	\N	\N	\N	\N	60951	60951	60952
15190	18805	2	applied	\N	\N	\N	\N	60953	60953	60954
15190	18806	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	60955	60955	\N
15190	18807	4	applied	\N	\N	\N	\N	60956	60956	13107
15190	18808	5	applied	\N	\N	\N	\N	60957	60957	23829
15190	18809	6	applied	\N	\N	\N	\N	60958	60958	60959
15190	18810	7	applied	\N	\N	\N	\N	60960	60960	60961
15190	18811	8	applied	\N	\N	\N	\N	60962	60962	60963
15190	18812	9	applied	\N	\N	\N	\N	60964	60964	60965
15190	18813	10	applied	\N	\N	\N	\N	60966	60966	60967
15195	18821	0	applied	\N	\N	\N	\N	60989	60989	60990
15195	18822	1	applied	\N	\N	\N	\N	60991	60991	60992
15197	18823	0	applied	\N	\N	\N	\N	60996	60996	60997
15197	18824	1	applied	\N	\N	\N	\N	60998	60998	60999
15206	18830	0	applied	\N	\N	\N	\N	61018	61018	61019
15206	18831	1	applied	\N	\N	\N	\N	61020	61020	61021
15206	18832	2	applied	\N	\N	\N	\N	61022	61022	61023
15211	18840	0	applied	\N	\N	\N	\N	61047	61047	61048
15211	18841	1	applied	\N	\N	\N	\N	61049	61049	61050
15213	18842	0	applied	\N	\N	\N	\N	61053	61053	61054
15213	18843	1	applied	\N	\N	\N	\N	61055	61055	61056
15219	18851	0	applied	\N	\N	\N	\N	61082	61082	61083
15219	18852	1	applied	\N	\N	\N	\N	61084	61084	61085
15219	18853	2	applied	\N	\N	\N	\N	61086	61086	61087
15219	18854	3	applied	\N	\N	\N	\N	61088	61088	61089
15219	18855	4	applied	\N	\N	\N	\N	61090	61090	61091
15221	18851	0	applied	\N	\N	\N	\N	61082	61082	61083
15221	18852	1	applied	\N	\N	\N	\N	61084	61084	61085
15221	18853	2	applied	\N	\N	\N	\N	61086	61086	61087
15221	18854	3	applied	\N	\N	\N	\N	61088	61088	61089
15221	18855	4	applied	\N	\N	\N	\N	61090	61090	61091
15223	18856	0	applied	\N	\N	\N	\N	61096	61096	61097
15223	18857	1	applied	\N	\N	\N	\N	61098	61098	61099
15226	18858	0	applied	\N	\N	\N	\N	61102	61102	61103
15226	18859	1	applied	\N	\N	\N	\N	61104	61104	61105
15226	18860	2	applied	\N	\N	\N	\N	61106	61106	61107
15232	18865	0	applied	\N	\N	\N	\N	61126	61126	61127
15232	18866	1	applied	\N	\N	\N	\N	61128	61128	61129
15232	18867	2	applied	\N	\N	\N	\N	61130	61130	61131
15234	18865	0	applied	\N	\N	\N	\N	61126	61126	61127
15234	18866	1	applied	\N	\N	\N	\N	61128	61128	61129
15234	18867	2	applied	\N	\N	\N	\N	61130	61130	61131
15237	18868	0	applied	\N	\N	\N	\N	61134	61134	61135
15237	18869	1	applied	\N	\N	\N	\N	61136	61136	61137
15242	18881	0	applied	\N	\N	\N	\N	61170	61170	61171
15242	18882	1	applied	\N	\N	\N	\N	61172	61172	61173
15242	18883	2	applied	\N	\N	\N	\N	61174	61174	61175
15244	18884	0	applied	\N	\N	\N	\N	61176	61176	61177
15244	18885	1	applied	\N	\N	\N	\N	61178	61178	61179
15250	18900	0	applied	\N	\N	\N	\N	61217	61217	61218
15250	18901	1	applied	\N	\N	\N	\N	61219	61219	61220
15250	18902	2	applied	\N	\N	\N	\N	61221	61221	61222
15260	18919	0	applied	\N	\N	\N	\N	61272	61272	61273
15260	18920	1	applied	\N	\N	\N	\N	61274	61274	61275
15262	18921	0	applied	\N	\N	\N	\N	61280	61280	61281
15262	18922	1	applied	\N	\N	\N	\N	61282	61282	61283
15196	18775	51	applied	\N	\N	\N	\N	60845	60845	60846
15196	18778	52	applied	\N	\N	\N	\N	60859	60859	60860
15196	18779	53	applied	\N	\N	\N	\N	60861	60861	60862
15196	18781	54	applied	\N	\N	\N	\N	60869	60869	60870
15196	18782	55	applied	\N	\N	\N	\N	60871	60871	60872
15196	18783	56	applied	\N	\N	\N	\N	60873	60873	60874
15196	18786	57	applied	\N	\N	\N	\N	60895	60895	60896
15196	18787	58	applied	\N	\N	\N	\N	60897	60897	60898
15196	18789	59	applied	\N	\N	\N	\N	60905	60905	60906
15196	18790	60	applied	\N	\N	\N	\N	60907	60907	60908
15196	18791	61	applied	\N	\N	1000000000	\N	60912	60912	60913
15196	18794	62	applied	\N	\N	1000000000	\N	60918	60918	60919
15196	18795	63	applied	\N	\N	\N	\N	60920	60920	60921
15196	18796	64	applied	\N	\N	\N	\N	60922	60922	60923
15196	18799	65	applied	\N	\N	\N	\N	60931	60931	60932
15196	18801	66	applied	\N	\N	\N	\N	60939	60939	60940
15196	18809	67	applied	\N	\N	\N	\N	60958	60958	60959
15196	18810	68	applied	\N	\N	\N	\N	60960	60960	60961
15196	18811	69	applied	\N	\N	\N	\N	60962	60962	60963
15196	18812	70	applied	\N	\N	\N	\N	60964	60964	60965
15196	18813	71	applied	\N	\N	\N	\N	60966	60966	60967
15196	18815	72	applied	\N	\N	\N	\N	60972	60972	60973
15196	18817	73	applied	\N	\N	\N	\N	60977	60977	60978
15196	18819	74	applied	\N	\N	\N	\N	60982	60982	60983
15196	18820	75	applied	\N	\N	\N	\N	60984	60984	60985
15196	18822	76	applied	\N	\N	\N	\N	60991	60991	60992
15198	18823	0	applied	\N	\N	\N	\N	60996	60996	60997
15198	18824	1	applied	\N	\N	\N	\N	60998	60998	60999
15203	18830	0	applied	\N	\N	\N	\N	61018	61018	61019
15203	18831	1	applied	\N	\N	\N	\N	61020	61020	61021
15203	18832	2	applied	\N	\N	\N	\N	61022	61022	61023
15205	18831	0	applied	\N	\N	\N	\N	61020	61020	61021
15205	18832	1	applied	\N	\N	\N	\N	61022	61022	61023
15207	18830	0	applied	\N	\N	\N	\N	61018	61018	61019
15207	18831	1	applied	\N	\N	\N	\N	61020	61020	61021
15207	18832	2	applied	\N	\N	\N	\N	61022	61022	61023
15212	18842	0	applied	\N	\N	\N	\N	61053	61053	61054
15212	18843	1	applied	\N	\N	\N	\N	61055	61055	61056
15214	18842	0	applied	\N	\N	\N	\N	61053	61053	61054
15214	18843	1	applied	\N	\N	\N	\N	61055	61055	61056
15217	18846	0	applied	\N	\N	\N	\N	61070	61070	61071
15217	18847	1	applied	\N	\N	\N	\N	61072	61072	61073
15217	18848	2	applied	\N	\N	\N	\N	61074	61074	61075
15217	18849	3	applied	\N	\N	\N	\N	61076	61076	61077
15217	18850	4	applied	\N	\N	\N	\N	61078	61078	61079
15228	18861	0	applied	\N	\N	\N	\N	61113	61113	61114
15230	18861	0	applied	\N	\N	\N	\N	61113	61113	61114
15235	18868	0	applied	\N	\N	\N	\N	61134	61134	61135
15235	18869	1	applied	\N	\N	\N	\N	61136	61136	61137
15239	18870	0	applied	\N	\N	\N	\N	61142	61142	61143
15239	18871	1	applied	\N	\N	\N	\N	61144	61144	61145
15245	18886	0	applied	\N	\N	\N	\N	61183	61183	61184
15245	18887	1	applied	\N	\N	\N	\N	61185	61185	61186
15245	18888	2	applied	\N	\N	\N	\N	61187	61187	61188
15245	18889	3	applied	\N	\N	\N	\N	61189	61189	61190
15245	18890	4	applied	\N	\N	\N	\N	61191	61191	61192
15248	18893	0	applied	\N	\N	\N	\N	61199	61199	61200
15248	18894	1	applied	\N	\N	\N	\N	61201	61201	61202
15248	18895	2	applied	\N	\N	\N	\N	61203	61203	61204
15248	18896	3	applied	\N	\N	\N	\N	61205	61205	61206
15248	18897	4	applied	\N	\N	\N	\N	61207	61207	61208
15248	18898	5	applied	\N	\N	\N	\N	61209	61209	61210
15248	18899	6	applied	\N	\N	\N	\N	61211	61211	61212
15253	18905	0	applied	\N	\N	\N	\N	61233	61233	61234
15253	18906	1	applied	\N	\N	\N	\N	61235	61235	61236
15253	18907	2	applied	\N	\N	\N	\N	61237	61237	61238
15253	18908	3	applied	\N	\N	\N	\N	61239	61239	61240
15255	18905	0	applied	\N	\N	\N	\N	61233	61233	61234
15255	18906	1	applied	\N	\N	\N	\N	61235	61235	61236
15255	18907	2	applied	\N	\N	\N	\N	61237	61237	61238
15255	18908	3	applied	\N	\N	\N	\N	61239	61239	61240
15256	18909	0	applied	\N	\N	\N	\N	61247	61247	61248
15256	18910	1	applied	\N	\N	\N	\N	61249	61249	61250
15256	18911	2	applied	\N	\N	\N	\N	61251	61251	61252
15256	18912	3	applied	\N	\N	\N	\N	61253	61253	61254
15256	18913	4	applied	\N	\N	\N	\N	61255	61255	61256
15256	18914	5	applied	\N	\N	\N	\N	61257	61257	61258
15256	18915	6	applied	\N	\N	\N	\N	61259	61259	61260
15256	18916	7	applied	\N	\N	\N	\N	61261	61261	61262
15256	18917	8	applied	\N	\N	\N	\N	61263	61263	61264
15256	18918	10	applied	\N	\N	\N	\N	61266	61266	61267
15258	18909	0	applied	\N	\N	\N	\N	61247	61247	61248
15258	18910	1	applied	\N	\N	\N	\N	61249	61249	61250
15258	18911	2	applied	\N	\N	\N	\N	61251	61251	61252
15258	18912	3	applied	\N	\N	\N	\N	61253	61253	61254
15258	18913	4	applied	\N	\N	\N	\N	61255	61255	61256
15258	18914	5	applied	\N	\N	\N	\N	61257	61257	61258
15258	18915	6	applied	\N	\N	\N	\N	61259	61259	61260
15258	18916	7	applied	\N	\N	\N	\N	61261	61261	61262
15258	18917	8	applied	\N	\N	\N	\N	61263	61263	61264
15258	18918	10	applied	\N	\N	\N	\N	61266	61266	61267
15263	18924	0	applied	\N	\N	\N	\N	61290	61290	61291
15263	18925	1	applied	\N	\N	\N	\N	61292	61292	61293
15263	18926	2	applied	\N	\N	\N	\N	61294	61294	61295
15268	18928	0	applied	\N	\N	\N	\N	61304	61304	61305
15268	18929	1	applied	\N	\N	\N	\N	61306	61306	61307
15268	18930	2	applied	\N	\N	\N	\N	61308	61308	61309
15268	18931	3	applied	\N	\N	\N	\N	61310	61310	61311
15268	18932	4	applied	\N	\N	\N	\N	61312	61312	61313
15270	18933	0	applied	\N	\N	\N	\N	61318	61318	61319
15270	18934	1	applied	\N	\N	1000000000	\N	61320	61320	61321
15270	18935	2	applied	\N	\N	\N	\N	61322	61322	61323
15270	18936	3	applied	\N	\N	\N	\N	61324	61324	61325
15272	18937	0	applied	\N	\N	\N	\N	61328	61328	61329
15272	18938	1	applied	\N	\N	\N	\N	61330	61330	61331
15273	18939	0	applied	\N	\N	\N	\N	61334	61334	61335
15273	18940	1	applied	\N	\N	\N	\N	61336	61336	61337
15273	18941	2	applied	\N	\N	\N	\N	61338	61338	61339
15273	18942	3	applied	\N	\N	\N	\N	61340	61340	61341
15273	18943	4	applied	\N	\N	\N	\N	61342	61342	61343
15273	18944	5	applied	\N	\N	\N	\N	61344	61344	61345
15273	18945	6	applied	\N	\N	\N	\N	61346	61346	61347
15273	18946	7	applied	\N	\N	\N	\N	61348	61348	61349
15280	18951	0	applied	\N	\N	\N	\N	61366	61366	61367
15280	18952	1	applied	\N	\N	\N	\N	61368	61368	61369
15280	18953	2	applied	\N	\N	\N	\N	61370	61370	61371
15282	18956	0	applied	\N	\N	\N	\N	61381	61381	61382
15287	18972	0	applied	\N	\N	\N	\N	61421	61421	61422
15287	18973	1	applied	\N	\N	\N	\N	61423	61423	61424
15240	18873	1	applied	\N	\N	\N	\N	61150	61150	61151
15243	18884	0	applied	\N	\N	\N	\N	61176	61176	61177
15243	18885	1	applied	\N	\N	\N	\N	61178	61178	61179
15246	18891	0	applied	\N	\N	\N	\N	61195	61195	61196
15246	18892	1	applied	\N	\N	\N	\N	61197	61197	61198
15249	18900	0	applied	\N	\N	\N	\N	61217	61217	61218
15249	18901	1	applied	\N	\N	\N	\N	61219	61219	61220
15249	18902	2	applied	\N	\N	\N	\N	61221	61221	61222
15251	18903	0	applied	\N	\N	\N	\N	61227	61227	61228
15251	18904	1	applied	\N	\N	\N	\N	61229	61229	61230
15259	18919	0	applied	\N	\N	\N	\N	61272	61272	61273
15259	18920	1	applied	\N	\N	\N	\N	61274	61274	61275
15261	18921	0	applied	\N	\N	\N	\N	61280	61280	61281
15261	18922	1	applied	\N	\N	\N	\N	61282	61282	61283
15261	18923	2	applied	\N	\N	\N	\N	61284	61284	61285
15266	18927	0	applied	\N	\N	\N	\N	61298	61298	61299
15276	18947	0	applied	\N	\N	\N	\N	61352	61352	61353
15276	18948	1	applied	\N	\N	\N	\N	61354	61354	61355
15276	18949	2	applied	\N	\N	\N	\N	61356	61356	61357
15276	18950	3	applied	\N	\N	\N	\N	61358	61358	61359
15278	18951	0	applied	\N	\N	\N	\N	61366	61366	61367
15278	18952	1	applied	\N	\N	\N	\N	61368	61368	61369
15278	18953	2	applied	\N	\N	\N	\N	61370	61370	61371
15283	18957	0	applied	\N	\N	\N	\N	61384	61384	61385
15283	18958	1	applied	\N	\N	\N	\N	61386	61386	61387
15283	18959	2	applied	\N	\N	\N	\N	61388	61388	61389
15286	18962	0	applied	\N	\N	\N	\N	61398	61398	61399
15286	18963	1	applied	\N	\N	\N	\N	61400	61400	61401
15286	18964	2	applied	\N	\N	\N	\N	61402	61402	61403
15286	18965	3	applied	\N	\N	\N	\N	61404	61404	61405
15286	18966	4	applied	\N	\N	\N	\N	61406	61406	61407
15286	18967	5	applied	\N	\N	\N	\N	61408	61408	61409
15286	18968	6	applied	\N	\N	\N	\N	61410	61410	61411
15286	18969	7	applied	\N	\N	\N	\N	61412	61412	61413
15286	18970	8	applied	\N	\N	\N	\N	61414	61414	61415
15286	18971	9	applied	\N	\N	\N	\N	61416	61416	61417
15289	18979	0	applied	\N	\N	\N	\N	61439	61439	61440
15289	18980	1	applied	\N	\N	\N	\N	61441	61441	61442
15292	18985	0	applied	\N	\N	\N	\N	61456	61456	61457
15292	18986	1	applied	\N	\N	\N	\N	61458	61458	61459
15292	18987	2	applied	\N	\N	\N	\N	61460	61460	61461
15294	18988	0	applied	\N	\N	\N	\N	61464	61464	61465
15294	18989	1	applied	\N	\N	\N	\N	61466	61466	61467
15294	18990	2	applied	\N	\N	\N	\N	61468	61468	61469
15297	18993	0	applied	\N	\N	\N	\N	61481	61481	61482
15297	18994	1	applied	\N	\N	\N	\N	61483	61483	61484
15303	18995	0	applied	\N	\N	\N	\N	61491	61491	61492
15303	18996	1	applied	\N	\N	\N	\N	61493	61493	61494
15303	18997	2	applied	\N	\N	\N	\N	61495	61495	61496
15303	18998	3	applied	\N	\N	\N	\N	61497	61497	61498
15303	18999	4	applied	\N	\N	\N	\N	61501	61501	61502
15303	19000	5	applied	\N	\N	\N	\N	61503	61503	61504
15303	19001	6	applied	\N	\N	\N	\N	61505	61505	61506
15303	19002	7	applied	\N	\N	\N	\N	61507	61507	61508
15306	18995	0	applied	\N	\N	\N	\N	61491	61491	61492
15306	18996	1	applied	\N	\N	\N	\N	61493	61493	61494
15306	18997	2	applied	\N	\N	\N	\N	61495	61495	61496
15306	18998	3	applied	\N	\N	\N	\N	61497	61497	61498
15306	18999	4	applied	\N	\N	\N	\N	61501	61501	61502
15306	19000	5	applied	\N	\N	\N	\N	61503	61503	61504
15306	19001	6	applied	\N	\N	\N	\N	61505	61505	61506
15306	19002	7	applied	\N	\N	\N	\N	61507	61507	61508
15307	19003	0	applied	\N	\N	\N	\N	61514	61514	61515
15317	19019	0	applied	\N	\N	\N	\N	61563	61563	61564
15317	19020	1	applied	\N	\N	\N	\N	61565	61565	61566
15319	19021	0	applied	\N	\N	\N	\N	61570	61570	61571
15319	19022	1	applied	\N	\N	\N	\N	61572	61572	61573
15322	19031	0	applied	\N	\N	\N	\N	61595	61595	61596
15327	19038	0	applied	\N	\N	\N	\N	61615	61615	61616
15327	19039	1	applied	\N	\N	\N	\N	61617	61617	61618
15330	19047	0	applied	\N	\N	\N	\N	61638	61638	61639
15330	19048	1	applied	\N	\N	\N	\N	61640	61640	61641
15330	19049	2	applied	\N	\N	\N	\N	61642	61642	61643
15332	19047	0	applied	\N	\N	\N	\N	61638	61638	61639
15332	19048	1	applied	\N	\N	\N	\N	61640	61640	61641
15332	19049	2	applied	\N	\N	\N	\N	61642	61642	61643
15340	19063	0	applied	\N	\N	\N	\N	61685	61685	61686
15340	19064	1	applied	\N	\N	\N	\N	61687	61687	61688
15340	19065	2	applied	\N	\N	\N	\N	61689	61689	61690
15340	19066	3	applied	\N	\N	\N	\N	61691	61691	61692
15340	19067	4	applied	\N	\N	\N	\N	61693	61693	61694
15340	19068	5	applied	\N	\N	\N	\N	61695	61695	61696
15340	19069	6	applied	\N	\N	\N	\N	61697	61697	61698
15345	19073	0	applied	\N	\N	\N	\N	61709	61709	61710
15345	19074	1	applied	\N	\N	\N	\N	61711	61711	61712
15347	19075	0	applied	\N	\N	\N	\N	61715	61715	61716
15347	19076	2	applied	\N	\N	\N	\N	61718	61718	61719
15347	19077	3	applied	\N	\N	\N	\N	61720	61720	61721
15349	19078	0	applied	\N	\N	\N	\N	61725	61725	61726
15356	19084	0	applied	\N	\N	\N	\N	61746	61746	61747
15356	19085	1	applied	\N	\N	\N	\N	61748	61748	61749
15356	19086	2	applied	\N	\N	\N	\N	61750	61750	61751
15358	19087	0	applied	\N	\N	\N	\N	61752	61752	61753
15358	19088	1	applied	\N	\N	\N	\N	61754	61754	61755
15367	19091	0	applied	\N	\N	\N	\N	61766	61766	61767
15367	19092	1	applied	\N	\N	\N	\N	61768	61768	61769
15367	19093	2	applied	\N	\N	\N	\N	61770	61770	61771
15367	19094	3	applied	\N	\N	\N	\N	61772	61772	61773
15367	19095	4	applied	\N	\N	\N	\N	61774	61774	61775
15372	19103	0	applied	\N	\N	\N	\N	61798	61798	61799
15372	19104	1	applied	\N	\N	\N	\N	61800	61800	61801
15372	19105	2	applied	\N	\N	\N	\N	61802	61802	61803
15374	19106	0	applied	\N	\N	\N	\N	61807	61807	61808
15391	19133	0	applied	\N	\N	\N	\N	61879	61879	61880
15391	19134	1	applied	\N	\N	\N	\N	61881	61881	61882
15391	19135	2	applied	\N	\N	\N	\N	61883	61883	61884
15393	19136	0	applied	\N	\N	\N	\N	61887	61887	61888
15393	19137	1	applied	\N	\N	\N	\N	61889	61889	61890
15395	19127	0	applied	\N	\N	\N	\N	61862	61862	23829
15399	19143	0	applied	\N	\N	\N	\N	61912	61912	61913
15399	19144	1	applied	\N	\N	\N	\N	61914	61914	61915
15402	19152	0	applied	\N	\N	\N	\N	61936	61936	61937
15402	19153	2	applied	\N	\N	\N	\N	61939	61939	61940
15402	19154	3	applied	\N	\N	\N	\N	61941	61941	61942
15404	19152	0	applied	\N	\N	\N	\N	61936	61936	61937
15404	19153	2	applied	\N	\N	\N	\N	61939	61939	61940
15404	19154	3	applied	\N	\N	\N	\N	61941	61941	61942
15407	19162	0	applied	\N	\N	\N	\N	61969	61969	61970
15407	19163	1	applied	\N	\N	\N	\N	61971	61971	61972
15407	19164	2	applied	\N	\N	\N	\N	61973	61973	61974
15262	18923	2	applied	\N	\N	\N	\N	61284	61284	61285
15265	18927	0	applied	\N	\N	\N	\N	61298	61298	61299
15267	18928	0	applied	\N	\N	\N	\N	61304	61304	61305
15267	18929	1	applied	\N	\N	\N	\N	61306	61306	61307
15267	18930	2	applied	\N	\N	\N	\N	61308	61308	61309
15267	18931	3	applied	\N	\N	\N	\N	61310	61310	61311
15267	18932	4	applied	\N	\N	\N	\N	61312	61312	61313
15275	18947	0	applied	\N	\N	\N	\N	61352	61352	61353
15275	18948	1	applied	\N	\N	\N	\N	61354	61354	61355
15275	18949	2	applied	\N	\N	\N	\N	61356	61356	61357
15275	18950	3	applied	\N	\N	\N	\N	61358	61358	61359
15277	18943	0	applied	\N	\N	\N	\N	61342	61342	61343
15279	18951	0	applied	\N	\N	\N	\N	61366	61366	61367
15279	18952	1	applied	\N	\N	\N	\N	61368	61368	61369
15279	18953	2	applied	\N	\N	\N	\N	61370	61370	61371
15284	18960	0	applied	\N	\N	\N	\N	61392	61392	61393
15284	18961	1	applied	\N	\N	\N	\N	61394	61394	61395
15285	18962	0	applied	\N	\N	\N	\N	61398	61398	61399
15285	18963	1	applied	\N	\N	\N	\N	61400	61400	61401
15285	18964	2	applied	\N	\N	\N	\N	61402	61402	61403
15285	18965	3	applied	\N	\N	\N	\N	61404	61404	61405
15285	18966	4	applied	\N	\N	\N	\N	61406	61406	61407
15285	18967	5	applied	\N	\N	\N	\N	61408	61408	61409
15285	18968	6	applied	\N	\N	\N	\N	61410	61410	61411
15285	18969	7	applied	\N	\N	\N	\N	61412	61412	61413
15285	18970	8	applied	\N	\N	\N	\N	61414	61414	61415
15285	18971	9	applied	\N	\N	\N	\N	61416	61416	61417
15288	18974	0	applied	\N	\N	\N	\N	61427	61427	61428
15288	18975	1	applied	\N	\N	\N	\N	61429	61429	61430
15288	18976	2	applied	\N	\N	\N	\N	61431	61431	61432
15288	18977	3	applied	\N	\N	\N	\N	61433	61433	61434
15288	18978	4	applied	\N	\N	\N	\N	61435	61435	61436
15293	18988	0	applied	\N	\N	\N	\N	61464	61464	61465
15293	18989	1	applied	\N	\N	\N	\N	61466	61466	61467
15293	18990	2	applied	\N	\N	\N	\N	61468	61468	61469
15305	18995	0	applied	\N	\N	\N	\N	61491	61491	61492
15305	18996	1	applied	\N	\N	\N	\N	61493	61493	61494
15305	18997	2	applied	\N	\N	\N	\N	61495	61495	61496
15305	18998	3	applied	\N	\N	\N	\N	61497	61497	61498
15305	18999	4	applied	\N	\N	\N	\N	61501	61501	61502
15305	19000	5	applied	\N	\N	\N	\N	61503	61503	61504
15305	19001	6	applied	\N	\N	\N	\N	61505	61505	61506
15305	19002	7	applied	\N	\N	\N	\N	61507	61507	61508
15309	19004	0	applied	\N	\N	\N	\N	61519	61519	61520
15309	19005	1	applied	\N	\N	\N	\N	61521	61521	61522
15309	19006	2	applied	\N	\N	\N	\N	61523	61523	61524
15311	19007	0	applied	\N	\N	\N	\N	61528	61528	61529
15311	19008	1	applied	\N	\N	\N	\N	61530	61530	61531
15314	19009	0	applied	\N	\N	\N	\N	61535	61535	61536
15314	19010	1	applied	\N	\N	\N	\N	61537	61537	61538
15314	19011	2	applied	\N	\N	\N	\N	61539	61539	61540
15316	19016	0	applied	\N	\N	\N	\N	61555	61555	61556
15316	19017	1	applied	\N	\N	\N	\N	61557	61557	61558
15316	19018	2	applied	\N	\N	\N	\N	61559	61559	61560
15324	19032	0	applied	\N	\N	\N	\N	61599	61599	61600
15324	19033	1	applied	\N	\N	\N	\N	61601	61601	61602
15324	19034	2	applied	\N	\N	\N	\N	61603	61603	61604
15326	19035	0	applied	\N	\N	\N	\N	61609	61609	61610
15326	19036	1	applied	\N	\N	\N	\N	61611	61611	61612
15326	19037	2	applied	\N	\N	\N	\N	61613	61613	61614
15329	19040	0	applied	\N	\N	\N	\N	61623	61623	61624
15329	19041	1	applied	\N	\N	\N	\N	61625	61625	61626
15329	19042	2	applied	\N	\N	\N	\N	61627	61627	61628
15329	19043	3	applied	\N	\N	\N	\N	61629	61629	61630
15329	19044	4	applied	\N	\N	\N	\N	61631	61631	61632
15329	19045	5	applied	\N	\N	\N	\N	61633	61633	61634
15329	19046	6	applied	\N	\N	\N	\N	61635	61635	61636
15334	19054	0	applied	\N	\N	\N	\N	61658	61658	61659
15334	19055	1	applied	\N	\N	\N	\N	61660	61660	61661
15337	19056	0	applied	\N	\N	\N	\N	61665	61665	61666
15337	19057	1	applied	\N	\N	\N	\N	61667	61667	61668
15337	19058	2	applied	\N	\N	\N	\N	61669	61669	61670
15337	19059	3	applied	\N	\N	\N	\N	61671	61671	61672
15337	19060	4	applied	\N	\N	\N	\N	61673	61673	61674
15337	19061	5	applied	\N	\N	\N	\N	61675	61675	61676
15337	19062	6	applied	\N	\N	\N	\N	61677	61677	61678
15342	19070	0	applied	\N	\N	\N	\N	61700	61700	61701
15342	19071	1	applied	\N	\N	\N	\N	61702	61702	61703
15342	19072	2	applied	\N	\N	\N	\N	61704	61704	61705
15351	19079	0	applied	\N	\N	\N	\N	61731	61731	61732
15351	19080	1	applied	\N	\N	\N	\N	61733	61733	61734
15351	19081	2	applied	\N	\N	\N	\N	61735	61735	61736
15353	19082	0	applied	\N	\N	\N	\N	61740	61740	61741
15353	19083	1	applied	\N	\N	\N	\N	61742	61742	61743
15360	19089	0	applied	\N	\N	\N	\N	61758	61758	61759
15360	19090	1	applied	\N	\N	\N	\N	61760	61760	61761
15365	19091	0	applied	\N	\N	\N	\N	61766	61766	61767
15365	19092	1	applied	\N	\N	\N	\N	61768	61768	61769
15365	19093	2	applied	\N	\N	\N	\N	61770	61770	61771
15365	19094	3	applied	\N	\N	\N	\N	61772	61772	61773
15365	19095	4	applied	\N	\N	\N	\N	61774	61774	61775
15369	19096	0	applied	\N	\N	\N	\N	61782	61782	61783
15369	19097	1	applied	\N	\N	\N	\N	61784	61784	61785
15369	19098	2	applied	\N	\N	\N	\N	61786	61786	61787
15369	19099	3	applied	\N	\N	\N	\N	61788	61788	61789
15369	19100	4	applied	\N	\N	\N	\N	61790	61790	61791
15378	19107	0	applied	\N	\N	\N	\N	61814	61814	61815
15378	19108	1	applied	\N	\N	\N	\N	61816	61816	61817
15378	19109	2	applied	\N	\N	\N	\N	61818	61818	61819
15378	19110	3	applied	\N	\N	\N	\N	61820	61820	61821
15378	19111	4	applied	\N	\N	\N	\N	61822	61822	61823
15378	19112	5	applied	\N	\N	\N	\N	61824	61824	61825
15379	19113	0	applied	\N	\N	\N	\N	61830	61830	61831
15379	19114	1	applied	\N	\N	\N	\N	61832	61832	61833
15379	19115	2	applied	\N	\N	\N	\N	61834	61834	61835
15379	19116	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	61836	61836	\N
15379	19117	4	applied	\N	\N	\N	\N	61837	61837	61838
15379	19118	5	applied	\N	\N	\N	\N	61839	61839	61840
15379	19119	6	applied	\N	\N	\N	\N	61841	61841	61842
15388	19131	0	applied	\N	\N	\N	\N	61871	61871	61872
15388	19132	1	applied	\N	\N	\N	\N	61873	61873	61874
15397	19138	0	applied	\N	\N	\N	\N	61898	61898	61899
15397	19139	1	applied	\N	\N	\N	\N	61900	61900	61901
15403	19152	0	applied	\N	\N	\N	\N	61936	61936	61937
15403	19153	2	applied	\N	\N	\N	\N	61939	61939	61940
15403	19154	3	applied	\N	\N	\N	\N	61941	61941	61942
15408	19162	0	applied	\N	\N	\N	\N	61969	61969	61970
15408	19163	1	applied	\N	\N	\N	\N	61971	61971	61972
15408	19164	2	applied	\N	\N	\N	\N	61973	61973	61974
15269	18930	2	applied	\N	\N	\N	\N	61308	61308	61309
15269	18931	3	applied	\N	\N	\N	\N	61310	61310	61311
15269	18932	4	applied	\N	\N	\N	\N	61312	61312	61313
15271	18933	0	applied	\N	\N	\N	\N	61318	61318	61319
15271	18934	1	applied	\N	\N	1000000000	\N	61320	61320	61321
15271	18935	2	applied	\N	\N	\N	\N	61322	61322	61323
15271	18936	3	applied	\N	\N	\N	\N	61324	61324	61325
15274	18939	0	applied	\N	\N	\N	\N	61334	61334	61335
15274	18940	1	applied	\N	\N	\N	\N	61336	61336	61337
15274	18941	2	applied	\N	\N	\N	\N	61338	61338	61339
15274	18942	3	applied	\N	\N	\N	\N	61340	61340	61341
15274	18943	4	applied	\N	\N	\N	\N	61342	61342	61343
15274	18944	5	applied	\N	\N	\N	\N	61344	61344	61345
15274	18945	6	applied	\N	\N	\N	\N	61346	61346	61347
15274	18946	7	applied	\N	\N	\N	\N	61348	61348	61349
15281	18954	0	applied	\N	\N	\N	\N	61377	61377	61378
15281	18955	1	applied	\N	\N	\N	\N	61379	61379	61380
15291	18984	0	applied	\N	\N	\N	\N	61452	61452	61453
15296	18772	0	applied	\N	\N	1000000000	\N	60839	60839	60840
15296	18312	1	applied	\N	\N	1000000000	\N	59477	59477	59478
15296	18209	2	applied	\N	\N	\N	\N	59161	59161	59162
15296	18220	3	applied	\N	\N	\N	\N	59317	59317	47675
15296	18215	4	applied	\N	\N	\N	\N	59179	59179	59196
15296	18197	5	applied	\N	\N	\N	\N	59129	59129	51758
15296	18346	6	applied	\N	\N	\N	\N	59558	59558	59559
15296	18279	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	59364	59364	\N
15296	18218	8	applied	\N	\N	\N	\N	59190	59190	25661
15296	18326	9	applied	\N	\N	\N	\N	59511	59511	47675
15298	18993	0	applied	\N	\N	\N	\N	61481	61481	61482
15298	18994	1	applied	\N	\N	\N	\N	61483	61483	61484
15304	18956	0	applied	\N	\N	\N	\N	61381	61381	61382
15304	18957	1	applied	\N	\N	\N	\N	61384	61384	61385
15304	18960	2	applied	\N	\N	\N	\N	61392	61392	61393
15304	18962	3	applied	\N	\N	\N	\N	61398	61398	61399
15304	18963	4	applied	\N	\N	\N	\N	61400	61400	61401
15304	18964	5	applied	\N	\N	\N	\N	61402	61402	61403
15304	18965	6	applied	\N	\N	\N	\N	61404	61404	61405
15304	18972	7	applied	\N	\N	\N	\N	61421	61421	61422
15304	18974	8	applied	\N	\N	\N	\N	61427	61427	61428
15304	18975	9	applied	\N	\N	\N	\N	61429	61429	61430
15304	18979	10	applied	\N	\N	\N	\N	61439	61439	61440
15304	18981	11	applied	\N	\N	\N	\N	61444	61444	61445
15304	18984	12	applied	\N	\N	\N	\N	61452	61452	61453
15304	18985	13	applied	\N	\N	\N	\N	61456	61456	61457
15304	18988	14	applied	\N	\N	\N	\N	61464	61464	61465
15304	18991	15	applied	\N	\N	\N	\N	61474	61474	61475
15304	18993	16	applied	\N	\N	\N	\N	61481	61481	61482
15304	18995	17	applied	\N	\N	\N	\N	61491	61491	61492
15304	18996	18	applied	\N	\N	\N	\N	61493	61493	61494
15304	18997	19	applied	\N	\N	\N	\N	61495	61495	61496
15304	18958	20	applied	\N	\N	\N	\N	61386	61386	61387
15304	18959	21	applied	\N	\N	\N	\N	61388	61388	61389
15304	18961	22	applied	\N	\N	\N	\N	61394	61394	61395
15304	18966	23	applied	\N	\N	\N	\N	61406	61406	61407
15304	18967	24	applied	\N	\N	\N	\N	61408	61408	61409
15304	18968	25	applied	\N	\N	\N	\N	61410	61410	61411
15304	18969	26	applied	\N	\N	\N	\N	61412	61412	61413
15304	18970	27	applied	\N	\N	\N	\N	61414	61414	61415
15304	18971	28	applied	\N	\N	\N	\N	61416	61416	61417
15304	18973	29	applied	\N	\N	\N	\N	61423	61423	61424
15304	18976	30	applied	\N	\N	\N	\N	61431	61431	61432
15304	18977	31	applied	\N	\N	\N	\N	61433	61433	61434
15304	18978	32	applied	\N	\N	\N	\N	61435	61435	61436
15304	18980	33	applied	\N	\N	\N	\N	61441	61441	61442
15304	18982	34	applied	\N	\N	\N	\N	61446	61446	61447
15304	18983	35	applied	\N	\N	\N	\N	61448	61448	61449
15304	18986	36	applied	\N	\N	\N	\N	61458	61458	61459
15304	18987	37	applied	\N	\N	\N	\N	61460	61460	61461
15304	18989	38	applied	\N	\N	\N	\N	61466	61466	61467
15304	18990	39	applied	\N	\N	\N	\N	61468	61468	61469
15304	18992	40	applied	\N	\N	\N	\N	61476	61476	61477
15304	18994	41	applied	\N	\N	\N	\N	61483	61483	61484
15304	18998	42	applied	\N	\N	\N	\N	61497	61497	61498
15304	18999	43	applied	\N	\N	\N	\N	61501	61501	61502
15304	19000	44	applied	\N	\N	\N	\N	61503	61503	61504
15304	19001	45	applied	\N	\N	\N	\N	61505	61505	61506
15304	19002	46	applied	\N	\N	\N	\N	61507	61507	61508
15310	19004	0	applied	\N	\N	\N	\N	61519	61519	61520
15310	19005	1	applied	\N	\N	\N	\N	61521	61521	61522
15310	19006	2	applied	\N	\N	\N	\N	61523	61523	61524
15312	19007	0	applied	\N	\N	\N	\N	61528	61528	61529
15312	19008	1	applied	\N	\N	\N	\N	61530	61530	61531
15315	19012	0	applied	\N	\N	\N	\N	61545	61545	61546
15315	19013	1	applied	\N	\N	\N	\N	61547	61547	61548
15315	19014	2	applied	\N	\N	\N	\N	61549	61549	61550
15315	19015	3	applied	\N	\N	\N	\N	61551	61551	61552
15320	19023	0	applied	\N	\N	\N	\N	61576	61576	61577
15320	19024	1	applied	\N	\N	\N	\N	61578	61578	61579
15320	19025	2	applied	\N	\N	\N	\N	61580	61580	61581
15320	19026	3	applied	\N	\N	\N	\N	61582	61582	61583
15320	19027	4	applied	\N	\N	\N	\N	61584	61584	61585
15325	19032	0	applied	\N	\N	\N	\N	61599	61599	61600
15325	19033	1	applied	\N	\N	\N	\N	61601	61601	61602
15325	19034	2	applied	\N	\N	\N	\N	61603	61603	61604
15333	19050	0	applied	\N	\N	\N	\N	61649	61649	61650
15333	19051	1	applied	\N	\N	\N	\N	61651	61651	61652
15333	19052	2	applied	\N	\N	\N	\N	61653	61653	61654
15333	19053	3	applied	\N	\N	\N	\N	61655	61655	61656
15335	19054	0	applied	\N	\N	\N	\N	61658	61658	61659
15335	19055	1	applied	\N	\N	\N	\N	61660	61660	61661
15336	19056	0	applied	\N	\N	\N	\N	61665	61665	61666
15336	19057	1	applied	\N	\N	\N	\N	61667	61667	61668
15336	19058	2	applied	\N	\N	\N	\N	61669	61669	61670
15336	19059	3	applied	\N	\N	\N	\N	61671	61671	61672
15336	19060	4	applied	\N	\N	\N	\N	61673	61673	61674
15336	19061	5	applied	\N	\N	\N	\N	61675	61675	61676
15336	19062	6	applied	\N	\N	\N	\N	61677	61677	61678
15338	19056	0	applied	\N	\N	\N	\N	61665	61665	61666
15338	19057	1	applied	\N	\N	\N	\N	61667	61667	61668
15338	19058	2	applied	\N	\N	\N	\N	61669	61669	61670
15338	19059	3	applied	\N	\N	\N	\N	61671	61671	61672
15338	19060	4	applied	\N	\N	\N	\N	61673	61673	61674
15338	19061	5	applied	\N	\N	\N	\N	61675	61675	61676
15338	19062	6	applied	\N	\N	\N	\N	61677	61677	61678
15341	19070	0	applied	\N	\N	\N	\N	61700	61700	61701
15341	19071	1	applied	\N	\N	\N	\N	61702	61702	61703
15341	19072	2	applied	\N	\N	\N	\N	61704	61704	61705
15343	19073	0	applied	\N	\N	\N	\N	61709	61709	61710
15343	19074	1	applied	\N	\N	\N	\N	61711	61711	61712
15290	18981	0	applied	\N	\N	\N	\N	61444	61444	61445
15290	18982	1	applied	\N	\N	\N	\N	61446	61446	61447
15290	18983	2	applied	\N	\N	\N	\N	61448	61448	61449
15295	18991	0	applied	\N	\N	\N	\N	61474	61474	61475
15295	18992	1	applied	\N	\N	\N	\N	61476	61476	61477
15299	18993	0	applied	\N	\N	\N	\N	61481	61481	61482
15299	18994	1	applied	\N	\N	\N	\N	61483	61483	61484
15302	18995	0	applied	\N	\N	\N	\N	61491	61491	61492
15302	18996	1	applied	\N	\N	\N	\N	61493	61493	61494
15302	18997	2	applied	\N	\N	\N	\N	61495	61495	61496
15302	18998	3	applied	\N	\N	\N	\N	61497	61497	61498
15308	19003	0	applied	\N	\N	\N	\N	61514	61514	61515
15313	19009	0	applied	\N	\N	\N	\N	61535	61535	61536
15313	19010	1	applied	\N	\N	\N	\N	61537	61537	61538
15313	19011	2	applied	\N	\N	\N	\N	61539	61539	61540
15318	19019	0	applied	\N	\N	\N	\N	61563	61563	61564
15318	19020	1	applied	\N	\N	\N	\N	61565	61565	61566
15321	19028	0	applied	\N	\N	\N	\N	61587	61587	61588
15321	19029	1	applied	\N	\N	\N	\N	61589	61589	61590
15321	19030	2	applied	\N	\N	\N	\N	61591	61591	61592
15323	19031	0	applied	\N	\N	\N	\N	61595	61595	61596
15328	19038	0	applied	\N	\N	\N	\N	61615	61615	61616
15328	19039	1	applied	\N	\N	\N	\N	61617	61617	61618
15331	19047	0	applied	\N	\N	\N	\N	61638	61638	61639
15331	19048	1	applied	\N	\N	\N	\N	61640	61640	61641
15331	19049	2	applied	\N	\N	\N	\N	61642	61642	61643
15339	19056	0	applied	\N	\N	\N	\N	61665	61665	61666
15339	19057	1	applied	\N	\N	\N	\N	61667	61667	61668
15339	19058	2	applied	\N	\N	\N	\N	61669	61669	61670
15339	19059	3	applied	\N	\N	\N	\N	61671	61671	61672
15339	19060	4	applied	\N	\N	\N	\N	61673	61673	61674
15339	19061	5	applied	\N	\N	\N	\N	61675	61675	61676
15339	19062	6	applied	\N	\N	\N	\N	61677	61677	61678
15344	19073	0	applied	\N	\N	\N	\N	61709	61709	61710
15344	19074	1	applied	\N	\N	\N	\N	61711	61711	61712
15346	19075	0	applied	\N	\N	\N	\N	61715	61715	61716
15346	19076	2	applied	\N	\N	\N	\N	61718	61718	61719
15346	19077	3	applied	\N	\N	\N	\N	61720	61720	61721
15348	19078	0	applied	\N	\N	\N	\N	61725	61725	61726
15364	19091	0	applied	\N	\N	\N	\N	61766	61766	61767
15364	19092	1	applied	\N	\N	\N	\N	61768	61768	61769
15364	19093	2	applied	\N	\N	\N	\N	61770	61770	61771
15364	19094	3	applied	\N	\N	\N	\N	61772	61772	61773
15364	19095	4	applied	\N	\N	\N	\N	61774	61774	61775
15366	19091	0	applied	\N	\N	\N	\N	61766	61766	61767
15366	19092	1	applied	\N	\N	\N	\N	61768	61768	61769
15366	19093	2	applied	\N	\N	\N	\N	61770	61770	61771
15366	19094	3	applied	\N	\N	\N	\N	61772	61772	61773
15366	19095	4	applied	\N	\N	\N	\N	61774	61774	61775
15371	19103	0	applied	\N	\N	\N	\N	61798	61798	61799
15371	19104	1	applied	\N	\N	\N	\N	61800	61800	61801
15371	19105	2	applied	\N	\N	\N	\N	61802	61802	61803
15373	19106	0	applied	\N	\N	\N	\N	61807	61807	61808
15375	19106	0	applied	\N	\N	\N	\N	61807	61807	61808
15381	19120	0	applied	\N	\N	\N	\N	61846	61846	61847
15381	19121	1	applied	\N	\N	\N	\N	61848	61848	61849
15381	19122	2	applied	\N	\N	\N	\N	61850	61850	61851
15381	19123	3	applied	\N	\N	\N	\N	61852	61852	61853
15381	19124	4	applied	\N	\N	\N	\N	61854	61854	61855
15381	19125	5	applied	\N	\N	\N	\N	61856	61856	61857
15383	19126	0	applied	\N	\N	\N	\N	61860	61860	61861
15383	19127	1	applied	\N	\N	\N	\N	61862	61862	23829
15392	19136	0	applied	\N	\N	\N	\N	61887	61887	61888
15392	19137	1	applied	\N	\N	\N	\N	61889	61889	61890
15394	19136	0	applied	\N	\N	\N	\N	61887	61887	61888
15394	19137	1	applied	\N	\N	\N	\N	61889	61889	61890
15400	19145	0	applied	\N	\N	\N	\N	61918	61918	61919
15400	19146	1	applied	\N	\N	\N	\N	61920	61920	61921
15405	19155	0	applied	\N	\N	\N	\N	61951	61951	61952
15417	19175	0	applied	\N	\N	\N	\N	62013	62013	62014
15417	19176	1	applied	\N	\N	\N	\N	62015	62015	62016
15417	19177	2	applied	\N	\N	\N	\N	62017	62017	62018
15422	19182	0	applied	\N	\N	\N	\N	62032	62032	62033
15422	19183	1	applied	\N	\N	\N	\N	62034	62034	62035
15424	19184	0	applied	\N	\N	\N	\N	62041	62041	62042
15424	19185	1	applied	\N	\N	\N	\N	62043	62043	62044
15424	19186	2	applied	\N	\N	\N	\N	62045	62045	62046
15434	19201	0	applied	\N	\N	\N	\N	62093	62093	62094
15434	19202	1	applied	\N	\N	\N	\N	62095	62095	62096
15434	19203	2	applied	\N	\N	\N	\N	62097	62097	62098
15434	19204	3	applied	\N	\N	\N	\N	62099	62099	62100
15434	19205	4	applied	\N	\N	\N	\N	62101	62101	62102
15437	19210	0	applied	\N	\N	\N	\N	62114	62114	62115
15437	19211	1	applied	\N	\N	\N	\N	62116	62116	62117
15437	19212	2	applied	\N	\N	\N	\N	62118	62118	62119
15437	19213	3	applied	\N	\N	\N	\N	62120	62120	62121
15437	19214	4	applied	\N	\N	\N	\N	62122	62122	62123
15439	19210	0	applied	\N	\N	\N	\N	62114	62114	62115
15439	19211	1	applied	\N	\N	\N	\N	62116	62116	62117
15439	19212	2	applied	\N	\N	\N	\N	62118	62118	62119
15439	19213	3	applied	\N	\N	\N	\N	62120	62120	62121
15439	19214	4	applied	\N	\N	\N	\N	62122	62122	62123
15441	19215	0	applied	\N	\N	\N	\N	62129	62129	62130
15441	19216	1	applied	\N	\N	\N	\N	62131	62131	62132
15443	19215	0	applied	\N	\N	\N	\N	62129	62129	62130
15443	19216	1	applied	\N	\N	\N	\N	62131	62131	62132
15446	19222	0	applied	\N	\N	\N	\N	62150	62150	62151
15446	19223	1	applied	\N	\N	\N	\N	62152	62152	62153
15449	19231	0	applied	\N	\N	\N	\N	62169	62169	62170
15449	19232	1	applied	\N	\N	\N	\N	62171	62171	62172
15449	19233	2	applied	\N	\N	\N	\N	62173	62173	62174
15456	19241	0	applied	\N	\N	\N	\N	62198	62198	62199
15456	19242	1	applied	\N	\N	\N	\N	62200	62200	62201
15458	19243	0	applied	\N	\N	\N	\N	62203	62203	62204
15458	19244	1	applied	\N	\N	\N	\N	62205	62205	62206
15467	19250	0	applied	\N	\N	\N	\N	62228	62228	62229
15467	19251	1	applied	\N	\N	\N	\N	62230	62230	62231
15467	19252	2	applied	\N	\N	\N	\N	62232	62232	62233
15467	19253	3	applied	\N	\N	\N	\N	62234	62234	62235
15472	19262	0	applied	\N	\N	\N	\N	62260	62260	62261
15472	19263	1	applied	\N	\N	\N	\N	62262	62262	62263
15476	19262	0	applied	\N	\N	\N	\N	62260	62260	62261
15476	19263	1	applied	\N	\N	\N	\N	62262	62262	62263
15479	19269	0	applied	\N	\N	\N	\N	62283	62283	62284
15479	19270	1	applied	\N	\N	\N	\N	62285	62285	62286
15479	19271	2	applied	\N	\N	\N	\N	62287	62287	62288
15479	19272	3	applied	\N	\N	\N	\N	62289	62289	62290
15481	19269	0	applied	\N	\N	\N	\N	62283	62283	62284
15481	19270	1	applied	\N	\N	\N	\N	62285	62285	62286
15481	19271	2	applied	\N	\N	\N	\N	62287	62287	62288
15350	19079	0	applied	\N	\N	\N	\N	61731	61731	61732
15350	19080	1	applied	\N	\N	\N	\N	61733	61733	61734
15350	19081	2	applied	\N	\N	\N	\N	61735	61735	61736
15352	19082	0	applied	\N	\N	\N	\N	61740	61740	61741
15352	19083	1	applied	\N	\N	\N	\N	61742	61742	61743
15357	19084	0	applied	\N	\N	\N	\N	61746	61746	61747
15357	19085	1	applied	\N	\N	\N	\N	61748	61748	61749
15357	19086	2	applied	\N	\N	\N	\N	61750	61750	61751
15361	19089	0	applied	\N	\N	\N	\N	61758	61758	61759
15361	19090	1	applied	\N	\N	\N	\N	61760	61760	61761
15368	19096	0	applied	\N	\N	\N	\N	61782	61782	61783
15368	19097	1	applied	\N	\N	\N	\N	61784	61784	61785
15368	19098	2	applied	\N	\N	\N	\N	61786	61786	61787
15368	19099	3	applied	\N	\N	\N	\N	61788	61788	61789
15368	19100	4	applied	\N	\N	\N	\N	61790	61790	61791
15370	19101	0	applied	\N	\N	\N	\N	61793	61793	61794
15370	19102	1	applied	\N	\N	\N	\N	61795	61795	61796
15377	19082	0	applied	\N	\N	\N	\N	61740	61740	61741
15377	19084	1	applied	\N	\N	\N	\N	61746	61746	61747
15377	19087	2	applied	\N	\N	\N	\N	61752	61752	61753
15377	19089	3	applied	\N	\N	\N	\N	61758	61758	61759
15377	19091	4	applied	\N	\N	\N	\N	61766	61766	61767
15377	19092	5	applied	\N	\N	\N	\N	61768	61768	61769
15377	19096	6	applied	\N	\N	\N	\N	61782	61782	61783
15377	19097	7	applied	\N	\N	\N	\N	61784	61784	61785
15377	19101	8	applied	\N	\N	\N	\N	61793	61793	61794
15377	19103	9	applied	\N	\N	\N	\N	61798	61798	61799
15377	19106	10	applied	\N	\N	\N	\N	61807	61807	61808
15377	19107	11	applied	\N	\N	\N	\N	61814	61814	61815
15377	19108	12	applied	\N	\N	\N	\N	61816	61816	61817
15377	19083	13	applied	\N	\N	\N	\N	61742	61742	61743
15377	19085	14	applied	\N	\N	\N	\N	61748	61748	61749
15377	19086	15	applied	\N	\N	\N	\N	61750	61750	61751
15377	19088	16	applied	\N	\N	\N	\N	61754	61754	61755
15377	19090	17	applied	\N	\N	\N	\N	61760	61760	61761
15377	19093	18	applied	\N	\N	\N	\N	61770	61770	61771
15377	19094	19	applied	\N	\N	\N	\N	61772	61772	61773
15377	19095	20	applied	\N	\N	\N	\N	61774	61774	61775
15377	19098	21	applied	\N	\N	\N	\N	61786	61786	61787
15377	19099	22	applied	\N	\N	\N	\N	61788	61788	61789
15377	19100	23	applied	\N	\N	\N	\N	61790	61790	61791
15377	19102	24	applied	\N	\N	\N	\N	61795	61795	61796
15377	19104	25	applied	\N	\N	\N	\N	61800	61800	61801
15377	19105	26	applied	\N	\N	\N	\N	61802	61802	61803
15377	19109	27	applied	\N	\N	\N	\N	61818	61818	61819
15377	19110	28	applied	\N	\N	\N	\N	61820	61820	61821
15377	19111	29	applied	\N	\N	\N	\N	61822	61822	61823
15377	19112	30	applied	\N	\N	\N	\N	61824	61824	61825
15380	18772	0	applied	\N	\N	1000000000	\N	60839	60839	60840
15380	19116	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	61836	61836	\N
15385	19128	0	applied	\N	\N	\N	\N	61865	61865	61866
15385	19129	1	applied	\N	\N	\N	\N	61867	61867	61868
15385	19130	2	applied	\N	\N	\N	\N	61869	61869	61870
15387	19131	0	applied	\N	\N	\N	\N	61871	61871	61872
15387	19132	1	applied	\N	\N	\N	\N	61873	61873	61874
15396	19138	0	applied	\N	\N	\N	\N	61898	61898	61899
15396	19139	1	applied	\N	\N	\N	\N	61900	61900	61901
15398	19140	0	applied	\N	\N	\N	\N	61904	61904	61905
15398	19141	1	applied	\N	\N	\N	\N	61906	61906	61907
15398	19142	2	applied	\N	\N	\N	\N	61908	61908	61909
15401	19147	0	applied	\N	\N	\N	\N	61924	61924	61925
15401	19148	1	applied	\N	\N	\N	\N	61926	61926	61927
15401	19149	2	applied	\N	\N	\N	\N	61928	61928	61929
15401	19150	3	applied	\N	\N	\N	\N	61930	61930	61931
15401	19151	4	applied	\N	\N	\N	\N	61932	61932	61933
15406	19156	0	applied	\N	\N	\N	\N	61955	61955	61956
15406	19157	1	applied	\N	\N	\N	\N	61957	61957	61958
15406	19158	2	applied	\N	\N	\N	\N	61959	61959	61960
15406	19159	3	applied	\N	\N	\N	\N	61961	61961	61962
15406	19160	4	applied	\N	\N	\N	\N	61963	61963	61964
15406	19161	5	applied	\N	\N	\N	\N	61965	61965	61966
15409	19162	0	applied	\N	\N	\N	\N	61969	61969	61970
15409	19163	1	applied	\N	\N	\N	\N	61971	61971	61972
15409	19164	2	applied	\N	\N	\N	\N	61973	61973	61974
15409	19165	3	applied	\N	\N	\N	\N	61975	61975	61976
15413	19168	0	applied	\N	\N	\N	\N	61990	61990	61991
15413	19169	1	applied	\N	\N	\N	\N	61992	61992	61993
15413	19170	2	applied	\N	\N	\N	\N	61994	61994	61995
15413	19171	3	applied	\N	\N	\N	\N	61996	61996	61997
15415	19172	0	applied	\N	\N	\N	\N	62005	62005	62006
15415	19173	1	applied	\N	\N	\N	\N	62007	62007	62008
15415	19174	2	applied	\N	\N	\N	\N	62009	62009	62010
15420	19182	0	applied	\N	\N	\N	\N	62032	62032	62033
15420	19183	1	applied	\N	\N	\N	\N	62034	62034	62035
15427	19189	0	applied	\N	\N	\N	\N	62057	62057	62058
15427	19190	1	applied	\N	\N	\N	\N	62059	62059	62060
15429	19189	0	applied	\N	\N	\N	\N	62057	62057	62058
15429	19190	1	applied	\N	\N	\N	\N	62059	62059	62060
15431	19191	0	applied	\N	\N	\N	\N	62068	62068	62069
15431	19192	1	applied	\N	\N	\N	\N	62070	62070	62071
15431	19193	2	applied	\N	\N	\N	\N	62072	62072	62073
15432	19194	0	applied	\N	\N	\N	\N	62076	62076	62077
15432	19195	1	applied	\N	\N	\N	\N	62078	62078	62079
15432	19196	2	applied	\N	\N	\N	\N	62080	62080	62081
15432	19197	3	applied	\N	\N	\N	\N	62082	62082	62083
15432	19198	4	applied	\N	\N	\N	\N	62084	62084	62085
15432	19199	5	applied	\N	\N	\N	\N	62086	62086	62087
15432	19200	6	applied	\N	\N	\N	\N	62088	62088	62089
15435	19206	0	applied	\N	\N	\N	\N	62104	62104	62105
15435	19207	1	applied	\N	\N	\N	\N	62106	62106	62107
15435	19208	2	applied	\N	\N	\N	\N	62108	62108	62109
15435	19209	3	applied	\N	\N	\N	\N	62110	62110	62111
15438	19210	0	applied	\N	\N	\N	\N	62114	62114	62115
15438	19211	1	applied	\N	\N	\N	\N	62116	62116	62117
15438	19212	2	applied	\N	\N	\N	\N	62118	62118	62119
15438	19213	3	applied	\N	\N	\N	\N	62120	62120	62121
15438	19214	4	applied	\N	\N	\N	\N	62122	62122	62123
15447	19224	0	applied	\N	\N	\N	\N	62154	62154	62155
15447	19225	1	applied	\N	\N	\N	\N	62156	62156	62157
15447	19226	2	applied	\N	\N	\N	\N	62158	62158	62159
15447	19227	3	applied	\N	\N	\N	\N	62160	62160	62161
15447	19228	4	applied	\N	\N	\N	\N	62162	62162	62163
15447	19229	5	applied	\N	\N	\N	\N	62164	62164	62165
15447	19230	6	applied	\N	\N	\N	\N	62166	62166	62167
15452	19234	0	applied	\N	\N	\N	\N	62181	62181	62182
15452	19235	1	applied	\N	\N	\N	\N	62183	62183	62184
15452	19236	2	applied	\N	\N	\N	\N	62185	62185	62186
15452	19237	3	applied	\N	\N	\N	\N	62187	62187	62188
15452	19238	4	applied	\N	\N	\N	\N	62189	62189	62190
15407	19165	3	applied	\N	\N	\N	\N	61975	61975	61976
15411	19166	0	applied	\N	\N	\N	\N	61984	61984	61985
15411	19167	1	applied	\N	\N	\N	\N	61986	61986	61987
15416	19175	0	applied	\N	\N	\N	\N	62013	62013	62014
15416	19176	1	applied	\N	\N	\N	\N	62015	62015	62016
15416	19177	2	applied	\N	\N	\N	\N	62017	62017	62018
15418	19175	0	applied	\N	\N	\N	\N	62013	62013	62014
15418	19176	1	applied	\N	\N	\N	\N	62015	62015	62016
15418	19177	2	applied	\N	\N	\N	\N	62017	62017	62018
15423	19184	0	applied	\N	\N	\N	\N	62041	62041	62042
15423	19185	1	applied	\N	\N	\N	\N	62043	62043	62044
15423	19186	2	applied	\N	\N	\N	\N	62045	62045	62046
15425	19187	0	applied	\N	\N	\N	\N	62051	62051	62052
15425	19188	1	applied	\N	\N	\N	\N	62053	62053	62054
15433	19194	0	applied	\N	\N	\N	\N	62076	62076	62077
15433	19195	1	applied	\N	\N	\N	\N	62078	62078	62079
15433	19196	2	applied	\N	\N	\N	\N	62080	62080	62081
15433	19197	3	applied	\N	\N	\N	\N	62082	62082	62083
15433	19198	4	applied	\N	\N	\N	\N	62084	62084	62085
15433	19199	5	applied	\N	\N	\N	\N	62086	62086	62087
15433	19200	6	applied	\N	\N	\N	\N	62088	62088	62089
15440	19187	0	applied	\N	\N	\N	\N	62051	62051	62052
15440	19189	1	applied	\N	\N	\N	\N	62057	62057	62058
15440	19191	2	applied	\N	\N	\N	\N	62068	62068	62069
15440	19194	3	applied	\N	\N	\N	\N	62076	62076	62077
15440	19195	4	applied	\N	\N	\N	\N	62078	62078	62079
15440	19196	5	applied	\N	\N	\N	\N	62080	62080	62081
15440	19201	6	applied	\N	\N	\N	\N	62093	62093	62094
15440	19202	7	applied	\N	\N	\N	\N	62095	62095	62096
15440	19206	8	applied	\N	\N	\N	\N	62104	62104	62105
15440	19207	9	applied	\N	\N	\N	\N	62106	62106	62107
15440	19210	10	applied	\N	\N	\N	\N	62114	62114	62115
15440	19211	11	applied	\N	\N	\N	\N	62116	62116	62117
15440	19188	12	applied	\N	\N	\N	\N	62053	62053	62054
15440	19190	13	applied	\N	\N	\N	\N	62059	62059	62060
15440	19192	14	applied	\N	\N	\N	\N	62070	62070	62071
15440	19193	15	applied	\N	\N	\N	\N	62072	62072	62073
15440	19197	16	applied	\N	\N	\N	\N	62082	62082	62083
15440	19198	17	applied	\N	\N	\N	\N	62084	62084	62085
15440	19199	18	applied	\N	\N	\N	\N	62086	62086	62087
15440	19200	19	applied	\N	\N	\N	\N	62088	62088	62089
15440	19203	20	applied	\N	\N	\N	\N	62097	62097	62098
15440	19204	21	applied	\N	\N	\N	\N	62099	62099	62100
15440	19205	22	applied	\N	\N	\N	\N	62101	62101	62102
15440	19208	23	applied	\N	\N	\N	\N	62108	62108	62109
15440	19209	24	applied	\N	\N	\N	\N	62110	62110	62111
15440	19212	25	applied	\N	\N	\N	\N	62118	62118	62119
15440	19213	26	applied	\N	\N	\N	\N	62120	62120	62121
15440	19214	27	applied	\N	\N	\N	\N	62122	62122	62123
15442	19215	0	applied	\N	\N	\N	\N	62129	62129	62130
15442	19216	1	applied	\N	\N	\N	\N	62131	62131	62132
15444	19215	0	applied	\N	\N	\N	\N	62129	62129	62130
15444	19216	1	applied	\N	\N	\N	\N	62131	62131	62132
15448	19231	0	applied	\N	\N	\N	\N	62169	62169	62170
15448	19232	1	applied	\N	\N	\N	\N	62171	62171	62172
15448	19233	2	applied	\N	\N	\N	\N	62173	62173	62174
15457	19241	0	applied	\N	\N	\N	\N	62198	62198	62199
15457	19242	1	applied	\N	\N	\N	\N	62200	62200	62201
15460	19245	0	applied	\N	\N	\N	\N	62209	62209	62210
15460	19246	1	applied	\N	\N	\N	\N	62211	62211	62212
15471	19259	0	applied	\N	\N	\N	\N	62252	62252	62253
15471	19260	1	applied	\N	\N	\N	\N	62254	62254	62255
15471	19261	2	applied	\N	\N	\N	\N	62256	62256	62257
15473	19262	0	applied	\N	\N	\N	\N	62260	62260	62261
15473	19263	1	applied	\N	\N	\N	\N	62262	62262	62263
15475	19262	0	applied	\N	\N	\N	\N	62260	62260	62261
15475	19263	1	applied	\N	\N	\N	\N	62262	62262	62263
15478	19264	0	applied	\N	\N	\N	\N	62271	62271	62272
15478	19265	1	applied	\N	\N	\N	\N	62273	62273	62274
15478	19266	2	applied	\N	\N	\N	\N	62275	62275	62276
15478	19267	3	applied	\N	\N	\N	\N	62277	62277	62278
15478	19268	4	applied	\N	\N	\N	\N	62279	62279	62280
15480	19269	0	applied	\N	\N	\N	\N	62283	62283	62284
15480	19270	1	applied	\N	\N	\N	\N	62285	62285	62286
15480	19271	2	applied	\N	\N	\N	\N	62287	62287	62288
15480	19272	3	applied	\N	\N	\N	\N	62289	62289	62290
15485	19278	0	applied	\N	\N	\N	\N	62309	62309	62310
15485	19279	1	applied	\N	\N	\N	\N	62311	62311	62312
15485	19280	2	applied	\N	\N	\N	\N	62313	62313	62314
15487	19278	0	applied	\N	\N	\N	\N	62309	62309	62310
15487	19279	1	applied	\N	\N	\N	\N	62311	62311	62312
15487	19280	2	applied	\N	\N	\N	\N	62313	62313	62314
15489	19281	0	applied	\N	\N	\N	\N	62321	62321	62322
15499	19294	0	applied	\N	\N	\N	\N	62360	62360	62361
15499	19295	1	applied	\N	\N	\N	\N	62362	62362	62363
15499	19296	2	applied	\N	\N	\N	\N	62364	62364	62365
15501	19297	0	applied	\N	\N	\N	\N	62369	62369	62370
15501	19298	1	applied	\N	\N	\N	\N	62371	62371	62372
15501	19299	2	applied	\N	\N	\N	\N	62373	62373	62374
15503	19300	0	applied	\N	\N	\N	\N	62377	62377	62378
15504	19301	0	applied	\N	\N	\N	\N	62380	62380	62381
15504	19302	1	applied	\N	\N	\N	\N	62382	62382	62383
15504	19303	2	applied	\N	\N	\N	\N	62384	62384	62385
15504	19304	3	applied	\N	\N	\N	\N	62386	62386	62387
15504	19305	4	applied	\N	\N	\N	\N	62388	62388	62389
15504	19306	5	applied	\N	\N	\N	\N	62390	62390	62391
15504	19307	6	applied	\N	\N	\N	\N	62392	62392	62393
15504	19308	7	applied	\N	\N	\N	\N	62394	62394	62395
15508	19309	0	applied	\N	\N	\N	\N	62398	62398	62399
15508	19310	1	applied	\N	\N	\N	\N	62400	62400	62401
15515	19313	0	applied	\N	\N	1000000000	\N	62410	62410	62411
15515	19311	2	applied	\N	\N	\N	\N	62404	62404	62405
15515	19315	3	applied	\N	\N	\N	\N	62415	62415	62416
15515	19316	4	applied	\N	\N	\N	\N	62417	62417	62418
15521	19328	0	applied	\N	\N	\N	\N	62460	62460	62461
15521	19329	1	applied	\N	\N	\N	\N	62462	62462	62463
15521	19330	2	applied	\N	\N	\N	\N	62464	62464	62465
15521	19331	3	applied	\N	\N	\N	\N	62466	62466	62467
15523	19332	0	applied	\N	\N	\N	\N	62470	62470	62471
15523	19333	1	applied	\N	\N	\N	\N	62472	62472	62473
15523	19334	2	applied	\N	\N	\N	\N	62474	62474	62475
15523	19335	3	applied	\N	\N	\N	\N	62476	62476	62477
15523	19336	4	applied	\N	\N	\N	\N	62478	62478	62479
15523	19337	5	applied	\N	\N	\N	\N	62480	62480	62481
15525	19338	0	applied	\N	\N	\N	\N	62487	62487	62488
15525	19339	1	applied	\N	\N	\N	\N	62489	62489	62490
15527	19338	0	applied	\N	\N	\N	\N	62487	62487	62488
15527	19339	1	applied	\N	\N	\N	\N	62489	62489	62490
15530	19342	0	applied	\N	\N	\N	\N	62503	62503	62504
15530	19343	1	applied	\N	\N	\N	\N	62505	62505	62506
15408	19165	3	applied	\N	\N	\N	\N	61975	61975	61976
15410	19162	0	applied	\N	\N	\N	\N	61969	61969	61970
15410	19163	1	applied	\N	\N	\N	\N	61971	61971	61972
15410	19164	2	applied	\N	\N	\N	\N	61973	61973	61974
15410	19165	3	applied	\N	\N	\N	\N	61975	61975	61976
15412	19168	0	applied	\N	\N	\N	\N	61990	61990	61991
15412	19169	1	applied	\N	\N	\N	\N	61992	61992	61993
15412	19170	2	applied	\N	\N	\N	\N	61994	61994	61995
15412	19171	3	applied	\N	\N	\N	\N	61996	61996	61997
15414	19162	0	applied	\N	\N	\N	\N	62001	62001	61970
15414	19163	1	applied	\N	\N	\N	\N	62002	62002	61972
15419	19178	0	applied	\N	\N	\N	\N	62022	62022	62023
15419	19179	1	applied	\N	\N	\N	\N	62024	62024	62025
15419	19180	2	applied	\N	\N	\N	\N	62026	62026	62027
15419	19181	3	applied	\N	\N	\N	\N	62028	62028	62029
15421	19182	0	applied	\N	\N	\N	\N	62032	62032	62033
15421	19183	1	applied	\N	\N	\N	\N	62034	62034	62035
15426	19189	0	applied	\N	\N	\N	\N	62057	62057	62058
15426	19190	1	applied	\N	\N	\N	\N	62059	62059	62060
15428	19189	0	applied	\N	\N	\N	\N	62057	62057	62058
15428	19190	1	applied	\N	\N	\N	\N	62059	62059	62060
15430	19191	0	applied	\N	\N	\N	\N	62068	62068	62069
15430	19192	1	applied	\N	\N	\N	\N	62070	62070	62071
15430	19193	2	applied	\N	\N	\N	\N	62072	62072	62073
15436	19206	0	applied	\N	\N	\N	\N	62104	62104	62105
15436	19207	1	applied	\N	\N	\N	\N	62106	62106	62107
15436	19208	2	applied	\N	\N	\N	\N	62108	62108	62109
15436	19209	3	applied	\N	\N	\N	\N	62110	62110	62111
15445	19217	0	applied	\N	\N	\N	\N	62139	62139	62140
15445	19218	1	applied	\N	\N	\N	\N	62141	62141	62142
15445	19219	2	applied	\N	\N	\N	\N	62143	62143	62144
15445	19220	3	applied	\N	\N	\N	\N	62145	62145	62146
15445	19221	4	applied	\N	\N	\N	\N	62147	62147	62148
15453	19234	0	applied	\N	\N	\N	\N	62181	62181	62182
15453	19235	1	applied	\N	\N	\N	\N	62183	62183	62184
15453	19236	2	applied	\N	\N	\N	\N	62185	62185	62186
15453	19237	3	applied	\N	\N	\N	\N	62187	62187	62188
15453	19238	4	applied	\N	\N	\N	\N	62189	62189	62190
15453	19239	5	applied	\N	\N	\N	\N	62191	62191	62192
15453	19240	6	applied	\N	\N	\N	\N	62193	62193	62194
15455	19234	0	applied	\N	\N	\N	\N	62181	62181	62182
15455	19235	1	applied	\N	\N	\N	\N	62183	62183	62184
15455	19236	2	applied	\N	\N	\N	\N	62185	62185	62186
15455	19237	3	applied	\N	\N	\N	\N	62187	62187	62188
15455	19238	4	applied	\N	\N	\N	\N	62189	62189	62190
15455	19239	5	applied	\N	\N	\N	\N	62191	62191	62192
15455	19240	6	applied	\N	\N	\N	\N	62193	62193	62194
15462	19247	0	applied	\N	\N	\N	\N	62218	62218	62219
15462	19248	1	applied	\N	\N	\N	\N	62220	62220	62221
15462	19249	2	applied	\N	\N	\N	\N	62222	62222	62223
15469	19254	0	applied	\N	\N	\N	\N	62238	62238	62239
15469	19255	1	applied	\N	\N	\N	\N	62242	62242	62243
15469	19256	2	applied	\N	\N	\N	\N	62244	62244	62245
15474	19262	0	applied	\N	\N	\N	\N	62260	62260	62261
15474	19263	1	applied	\N	\N	\N	\N	62262	62262	62263
15483	19276	0	applied	\N	\N	\N	\N	62303	62303	62304
15483	19277	1	applied	\N	\N	\N	\N	62305	62305	62306
15494	19282	0	applied	\N	\N	\N	\N	62329	62329	62330
15494	19283	1	applied	\N	\N	\N	\N	62331	62331	62332
15494	19284	2	applied	\N	\N	\N	\N	62333	62333	62334
15494	19285	3	applied	\N	\N	\N	\N	62335	62335	62336
15494	19286	4	applied	\N	\N	\N	\N	62337	62337	62338
15494	19287	5	applied	\N	\N	\N	\N	62339	62339	62340
15495	19288	0	applied	\N	\N	\N	\N	62343	62343	62344
15495	19289	1	applied	\N	\N	\N	\N	62345	62345	62346
15495	19290	2	applied	\N	\N	\N	\N	62347	62347	62348
15495	19291	3	applied	\N	\N	\N	\N	62349	62349	62350
15495	19292	4	applied	\N	\N	\N	\N	62351	62351	62352
15495	19293	5	applied	\N	\N	\N	\N	62353	62353	62354
15507	19309	0	applied	\N	\N	\N	\N	62398	62398	62399
15507	19310	1	applied	\N	\N	\N	\N	62400	62400	62401
15511	19312	0	applied	\N	\N	\N	\N	62406	62406	62407
15513	19313	0	applied	\N	\N	1000000000	\N	62410	62410	62411
15513	19311	2	applied	\N	\N	\N	\N	62404	62404	62405
15513	19314	3	applied	\N	\N	\N	\N	62413	62413	62414
15513	19315	4	applied	\N	\N	\N	\N	62415	62415	62416
15513	19316	5	applied	\N	\N	\N	\N	62417	62417	62418
15518	19323	0	applied	\N	\N	\N	\N	62444	62444	62445
15518	19324	1	applied	\N	\N	\N	\N	62446	62446	62447
15528	19340	0	applied	\N	\N	\N	\N	62497	62497	62498
15528	19341	1	applied	\N	\N	\N	\N	62499	62499	62500
15531	19349	0	applied	\N	\N	\N	\N	62520	62520	62521
15531	19350	1	applied	\N	\N	\N	\N	62522	62522	62523
15531	19351	2	applied	\N	\N	\N	\N	62524	62524	62525
15539	19366	0	applied	\N	\N	\N	\N	62564	62564	62565
15539	19367	1	applied	\N	\N	\N	\N	62566	62566	62567
15539	19368	2	applied	\N	\N	\N	\N	62568	62568	62569
15539	19369	3	applied	\N	\N	\N	\N	62570	62570	62571
15550	19394	0	applied	\N	\N	\N	\N	62634	62634	62635
15550	19395	1	applied	\N	\N	\N	\N	62636	62636	62637
15563	19422	0	applied	\N	\N	\N	\N	62713	62713	62714
15565	19422	0	applied	\N	\N	\N	\N	62713	62713	62714
15571	19431	0	applied	\N	\N	\N	\N	62742	62742	62743
15571	19432	1	applied	\N	\N	\N	\N	62744	62744	62745
15573	19435	0	applied	\N	\N	\N	\N	62752	62752	62753
15575	19435	0	applied	\N	\N	\N	\N	62752	62752	62753
15578	19437	0	applied	\N	\N	\N	\N	62761	62761	62762
15578	19438	1	applied	\N	\N	\N	\N	62763	62763	62764
15578	19439	2	applied	\N	\N	1000000000	\N	62765	62765	62766
15582	19447	0	applied	\N	\N	\N	\N	62784	62784	62785
15586	19450	0	applied	\N	\N	\N	\N	62797	62797	62798
15586	19451	1	applied	\N	\N	\N	\N	62799	62799	62800
15586	19452	2	applied	\N	\N	\N	\N	62801	62801	62802
15586	19453	3	applied	\N	\N	\N	\N	62803	62803	62804
15589	19456	0	applied	\N	\N	\N	\N	62812	62812	62813
15589	19457	1	applied	\N	\N	\N	\N	62814	62814	62815
15589	19458	2	applied	\N	\N	\N	\N	62816	62816	62817
15589	19459	3	applied	\N	\N	\N	\N	62818	62818	62819
15589	19460	4	applied	\N	\N	\N	\N	62820	62820	62821
15589	19461	5	applied	\N	\N	\N	\N	62822	62822	62823
15591	19456	0	applied	\N	\N	\N	\N	62812	62812	62813
15591	19457	1	applied	\N	\N	\N	\N	62814	62814	62815
15591	19458	2	applied	\N	\N	\N	\N	62816	62816	62817
15591	19459	3	applied	\N	\N	\N	\N	62818	62818	62819
15591	19460	4	applied	\N	\N	\N	\N	62820	62820	62821
15591	19461	5	applied	\N	\N	\N	\N	62822	62822	62823
15597	19468	0	applied	\N	\N	\N	\N	62848	62848	62849
15597	19469	1	applied	\N	\N	\N	\N	62850	62850	62851
15604	19476	0	applied	\N	\N	\N	\N	62876	62876	62877
15452	19239	5	applied	\N	\N	\N	\N	62191	62191	62192
15452	19240	6	applied	\N	\N	\N	\N	62193	62193	62194
15454	19234	0	applied	\N	\N	\N	\N	62181	62181	62182
15454	19235	1	applied	\N	\N	\N	\N	62183	62183	62184
15454	19236	2	applied	\N	\N	\N	\N	62185	62185	62186
15454	19237	3	applied	\N	\N	\N	\N	62187	62187	62188
15454	19238	4	applied	\N	\N	\N	\N	62189	62189	62190
15454	19239	5	applied	\N	\N	\N	\N	62191	62191	62192
15454	19240	6	applied	\N	\N	\N	\N	62193	62193	62194
15459	19245	0	applied	\N	\N	\N	\N	62209	62209	62210
15459	19246	1	applied	\N	\N	\N	\N	62211	62211	62212
15461	19003	0	applied	\N	\N	\N	\N	61514	61514	61515
15461	19162	1	applied	\N	\N	\N	\N	61969	61969	61970
15461	19163	2	applied	\N	\N	\N	\N	61971	61971	61972
15461	19169	3	applied	\N	\N	\N	\N	61992	61992	61993
15461	19170	4	applied	\N	\N	\N	\N	61994	61994	61995
15461	19004	5	applied	\N	\N	\N	\N	61519	61519	61520
15461	19007	6	applied	\N	\N	\N	\N	61528	61528	61529
15461	19009	7	applied	\N	\N	\N	\N	61535	61535	61536
15461	19012	8	applied	\N	\N	\N	\N	61545	61545	61546
15461	19013	9	applied	\N	\N	\N	\N	61547	61547	61548
15461	19016	10	applied	\N	\N	\N	\N	61555	61555	61556
15461	19019	11	applied	\N	\N	\N	\N	61563	61563	61564
15461	19021	12	applied	\N	\N	\N	\N	61570	61570	61571
15461	19023	13	applied	\N	\N	\N	\N	61576	61576	61577
15461	19024	14	applied	\N	\N	\N	\N	61578	61578	61579
15461	19028	15	applied	\N	\N	\N	\N	61587	61587	61588
15461	19031	17	applied	\N	\N	\N	\N	61595	61595	61596
15461	19032	18	applied	\N	\N	\N	\N	61599	61599	61600
15461	19035	19	applied	\N	\N	\N	\N	61609	61609	61610
15461	19038	20	applied	\N	\N	\N	\N	61615	61615	61616
15461	19040	21	applied	\N	\N	\N	\N	61623	61623	61624
15461	19041	22	applied	\N	\N	\N	\N	61625	61625	61626
15461	19042	23	applied	\N	\N	\N	\N	61627	61627	61628
15461	19047	24	applied	\N	\N	\N	\N	61638	61638	61639
15461	19050	25	applied	\N	\N	\N	\N	61649	61649	61650
15461	19051	26	applied	\N	\N	\N	\N	61651	61651	61652
15461	19054	27	applied	\N	\N	\N	\N	61658	61658	61659
15461	19056	28	applied	\N	\N	\N	\N	61665	61665	61666
15461	19057	29	applied	\N	\N	\N	\N	61667	61667	61668
15461	19058	30	applied	\N	\N	\N	\N	61669	61669	61670
15461	19063	31	applied	\N	\N	\N	\N	61685	61685	61686
15461	19064	32	applied	\N	\N	\N	\N	61687	61687	61688
15461	19065	33	applied	\N	\N	\N	\N	61689	61689	61690
15461	19070	34	applied	\N	\N	\N	\N	61700	61700	61701
15461	19073	35	applied	\N	\N	\N	\N	61709	61709	61710
15461	19075	36	applied	\N	\N	\N	\N	61715	61715	61716
15461	19078	37	applied	\N	\N	\N	\N	61725	61725	61726
15461	19079	38	applied	\N	\N	\N	\N	61731	61731	61732
15461	19082	39	applied	\N	\N	\N	\N	61740	61740	61741
15461	19084	40	applied	\N	\N	\N	\N	61746	61746	61747
15461	19087	41	applied	\N	\N	\N	\N	61752	61752	61753
15461	19089	42	applied	\N	\N	\N	\N	61758	61758	61759
15461	19091	43	applied	\N	\N	\N	\N	61766	61766	61767
15461	19092	44	applied	\N	\N	\N	\N	61768	61768	61769
15461	19096	45	applied	\N	\N	\N	\N	61782	61782	61783
15461	19097	46	applied	\N	\N	\N	\N	61784	61784	61785
15461	19101	47	applied	\N	\N	\N	\N	61793	61793	61794
15461	19103	48	applied	\N	\N	\N	\N	61798	61798	61799
15461	19106	49	applied	\N	\N	\N	\N	61807	61807	61808
15461	19107	50	applied	\N	\N	\N	\N	61814	61814	61815
15461	19108	51	applied	\N	\N	\N	\N	61816	61816	61817
15461	19113	52	applied	\N	\N	\N	\N	61830	61830	61831
15461	19114	53	applied	\N	\N	\N	\N	61832	61832	61833
15461	19115	54	applied	\N	\N	\N	\N	61834	61834	61835
15461	19120	55	applied	\N	\N	\N	\N	61846	61846	61847
15461	19121	56	applied	\N	\N	\N	\N	61848	61848	61849
15461	19126	57	applied	\N	\N	\N	\N	61860	61860	61861
15461	19128	58	applied	\N	\N	\N	\N	61865	61865	61866
15461	19131	59	applied	\N	\N	\N	\N	61871	61871	61872
15461	19133	60	applied	\N	\N	\N	\N	61879	61879	61880
15461	19136	61	applied	\N	\N	\N	\N	61887	61887	61888
15461	19138	62	applied	\N	\N	\N	\N	61898	61898	61899
15461	19140	63	applied	\N	\N	\N	\N	61904	61904	61905
15461	19143	64	applied	\N	\N	\N	\N	61912	61912	61913
15461	19145	65	applied	\N	\N	\N	\N	61918	61918	61919
15461	19147	66	applied	\N	\N	\N	\N	61924	61924	61925
15461	19148	67	applied	\N	\N	\N	\N	61926	61926	61927
15461	19152	68	applied	\N	\N	\N	\N	61936	61936	61937
15461	19155	69	applied	\N	\N	\N	\N	61951	61951	61952
15461	19156	70	applied	\N	\N	\N	\N	61955	61955	61956
15461	19157	71	applied	\N	\N	\N	\N	61957	61957	61958
15461	19164	72	applied	\N	\N	\N	\N	61973	61973	61974
15461	19166	73	applied	\N	\N	\N	\N	61984	61984	61985
15461	19168	74	applied	\N	\N	\N	\N	61990	61990	61991
15461	19172	75	applied	\N	\N	\N	\N	62005	62005	62006
15461	19175	76	applied	\N	\N	\N	\N	62013	62013	62014
15461	19178	77	applied	\N	\N	\N	\N	62022	62022	62023
15461	19179	78	applied	\N	\N	\N	\N	62024	62024	62025
15461	19182	79	applied	\N	\N	\N	\N	62032	62032	62033
15461	19184	80	applied	\N	\N	\N	\N	62041	62041	62042
15461	19187	81	applied	\N	\N	\N	\N	62051	62051	62052
15461	19189	82	applied	\N	\N	\N	\N	62057	62057	62058
15461	19191	83	applied	\N	\N	\N	\N	62068	62068	62069
15461	19194	84	applied	\N	\N	\N	\N	62076	62076	62077
15461	19195	85	applied	\N	\N	\N	\N	62078	62078	62079
15461	19196	86	applied	\N	\N	\N	\N	62080	62080	62081
15461	19201	87	applied	\N	\N	\N	\N	62093	62093	62094
15461	19202	88	applied	\N	\N	\N	\N	62095	62095	62096
15461	19206	89	applied	\N	\N	\N	\N	62104	62104	62105
15461	19207	90	applied	\N	\N	\N	\N	62106	62106	62107
15461	19210	91	applied	\N	\N	\N	\N	62114	62114	62115
15461	19211	92	applied	\N	\N	\N	\N	62116	62116	62117
15461	19215	93	applied	\N	\N	\N	\N	62129	62129	62130
15461	19217	94	applied	\N	\N	\N	\N	62139	62139	62140
15461	19218	95	applied	\N	\N	\N	\N	62141	62141	62142
15461	19222	96	applied	\N	\N	\N	\N	62150	62150	62151
15461	19224	97	applied	\N	\N	\N	\N	62154	62154	62155
15461	19225	98	applied	\N	\N	\N	\N	62156	62156	62157
15461	19226	99	applied	\N	\N	\N	\N	62158	62158	62159
15461	19231	100	applied	\N	\N	\N	\N	62169	62169	62170
15461	19234	101	applied	\N	\N	\N	\N	62181	62181	62182
15461	19235	102	applied	\N	\N	\N	\N	62183	62183	62184
15461	19236	103	applied	\N	\N	\N	\N	62185	62185	62186
15461	19241	104	applied	\N	\N	\N	\N	62198	62198	62199
15461	19243	105	applied	\N	\N	\N	\N	62203	62203	62204
15461	19245	106	applied	\N	\N	\N	\N	62209	62209	62210
15461	19116	107	failed	Amount_insufficient_to_create_account	\N	\N	\N	61836	61836	\N
15461	19005	108	applied	\N	\N	\N	\N	61521	61521	61522
15461	19127	109	applied	\N	\N	\N	\N	61862	61862	23829
15461	19006	110	applied	\N	\N	\N	\N	61523	61523	61524
15461	19008	111	applied	\N	\N	\N	\N	61530	61530	61531
15461	19010	112	applied	\N	\N	\N	\N	61537	61537	61538
15461	19011	113	applied	\N	\N	\N	\N	61539	61539	61540
15461	19014	114	applied	\N	\N	\N	\N	61549	61549	61550
15461	19015	115	applied	\N	\N	\N	\N	61551	61551	61552
15461	19017	116	applied	\N	\N	\N	\N	61557	61557	61558
15461	19018	117	applied	\N	\N	\N	\N	61559	61559	61560
15461	19020	118	applied	\N	\N	\N	\N	61565	61565	61566
15461	19022	119	applied	\N	\N	\N	\N	61572	61572	61573
15461	19025	120	applied	\N	\N	\N	\N	61580	61580	61581
15461	19026	121	applied	\N	\N	\N	\N	61582	61582	61583
15461	19027	122	applied	\N	\N	\N	\N	61584	61584	61585
15461	19029	123	applied	\N	\N	\N	\N	61589	61589	61590
15461	19030	124	applied	\N	\N	\N	\N	61591	61591	61592
15461	19033	125	applied	\N	\N	\N	\N	61601	61601	61602
15463	19247	0	applied	\N	\N	\N	\N	62218	62218	62219
15463	19248	1	applied	\N	\N	\N	\N	62220	62220	62221
15463	19249	2	applied	\N	\N	\N	\N	62222	62222	62223
15468	19254	0	applied	\N	\N	\N	\N	62238	62238	62239
15470	19257	0	applied	\N	\N	\N	\N	62247	62247	62248
15470	19258	1	applied	\N	\N	\N	\N	62249	62249	62250
15477	19264	0	applied	\N	\N	\N	\N	62271	62271	62272
15477	19265	1	applied	\N	\N	\N	\N	62273	62273	62274
15477	19266	2	applied	\N	\N	\N	\N	62275	62275	62276
15477	19267	3	applied	\N	\N	\N	\N	62277	62277	62278
15477	19268	4	applied	\N	\N	\N	\N	62279	62279	62280
15482	19273	0	applied	\N	\N	\N	\N	62295	62295	62296
15482	19274	1	applied	\N	\N	\N	\N	62297	62297	62298
15482	19275	2	applied	\N	\N	\N	\N	62299	62299	62300
15493	19162	0	applied	\N	\N	\N	\N	62324	62324	61970
15493	19163	1	applied	\N	\N	\N	\N	62325	62325	61972
15493	19169	2	applied	\N	\N	\N	\N	62326	62326	61993
15493	19170	3	applied	\N	\N	\N	\N	62327	62327	61995
15497	19288	0	applied	\N	\N	\N	\N	62343	62343	62344
15497	19289	1	applied	\N	\N	\N	\N	62345	62345	62346
15497	19290	2	applied	\N	\N	\N	\N	62347	62347	62348
15497	19291	3	applied	\N	\N	\N	\N	62349	62349	62350
15497	19292	4	applied	\N	\N	\N	\N	62351	62351	62352
15497	19293	5	applied	\N	\N	\N	\N	62353	62353	62354
15500	19294	0	applied	\N	\N	\N	\N	62360	62360	62361
15500	19295	1	applied	\N	\N	\N	\N	62362	62362	62363
15500	19296	2	applied	\N	\N	\N	\N	62364	62364	62365
15510	19311	0	applied	\N	\N	\N	\N	62404	62404	62405
15510	19312	1	applied	\N	\N	\N	\N	62406	62406	62407
15512	19313	0	applied	\N	\N	1000000000	\N	62410	62410	62411
15512	19311	2	applied	\N	\N	\N	\N	62404	62404	62405
15512	19314	3	applied	\N	\N	\N	\N	62413	62413	62414
15512	19315	4	applied	\N	\N	\N	\N	62415	62415	62416
15512	19316	5	applied	\N	\N	\N	\N	62417	62417	62418
15514	19313	0	applied	\N	\N	1000000000	\N	62410	62410	62411
15514	19311	2	applied	\N	\N	\N	\N	62404	62404	62405
15514	19314	3	applied	\N	\N	\N	\N	62413	62413	62414
15514	19315	4	applied	\N	\N	\N	\N	62415	62415	62416
15514	19316	5	applied	\N	\N	\N	\N	62417	62417	62418
15517	19319	0	applied	\N	\N	\N	\N	62434	62434	62435
15517	19320	1	applied	\N	\N	\N	\N	62436	62436	62437
15517	19321	2	applied	\N	\N	\N	\N	62438	62438	62439
15517	19322	3	applied	\N	\N	\N	\N	62440	62440	62441
15532	19349	0	applied	\N	\N	\N	\N	62520	62520	62521
15532	19350	1	applied	\N	\N	\N	\N	62522	62522	62523
15532	19351	2	applied	\N	\N	\N	\N	62524	62524	62525
15537	19358	0	applied	\N	\N	\N	\N	62546	62546	62547
15537	19359	1	applied	\N	\N	\N	\N	62548	62548	62549
15537	19360	2	applied	\N	\N	\N	\N	62550	62550	62551
15537	19361	3	applied	\N	\N	\N	\N	62552	62552	62553
15537	19362	4	applied	\N	\N	\N	\N	62554	62554	62555
15537	19363	5	applied	\N	\N	\N	\N	62556	62556	62557
15540	19370	0	applied	\N	\N	\N	\N	62574	62574	62575
15540	19371	1	applied	\N	\N	\N	\N	62576	62576	62577
15540	19372	2	applied	\N	\N	\N	\N	62578	62578	62579
15545	19377	0	applied	\N	\N	\N	\N	62595	62595	62596
15545	19378	1	applied	\N	\N	\N	\N	62597	62597	62598
15545	19379	2	applied	\N	\N	\N	\N	62599	62599	62600
15546	19380	0	applied	\N	\N	\N	\N	62603	62603	62604
15546	19381	1	applied	\N	\N	\N	\N	62605	62605	62606
15546	19382	2	applied	\N	\N	\N	\N	62607	62607	62608
15546	19383	3	applied	\N	\N	\N	\N	62609	62609	62610
15546	19384	4	applied	\N	\N	\N	\N	62611	62611	62612
15546	19385	5	applied	\N	\N	\N	\N	62613	62613	62614
15546	19386	6	applied	\N	\N	\N	\N	62615	62615	62616
15546	19387	7	applied	\N	\N	\N	\N	62617	62617	62618
15546	19388	8	applied	\N	\N	\N	\N	62619	62619	62620
15554	19405	0	applied	\N	\N	\N	\N	62667	62667	62668
15554	19406	1	applied	\N	\N	\N	\N	62669	62669	62670
15554	19407	2	applied	\N	\N	\N	\N	62671	62671	62672
15554	19408	3	applied	\N	\N	\N	\N	62673	62673	62674
15554	19409	4	applied	\N	\N	\N	\N	62675	62675	62676
15567	19425	0	applied	\N	\N	\N	\N	62724	62724	62725
15567	19426	1	applied	\N	\N	\N	\N	62726	62726	62727
15570	19430	0	applied	\N	\N	\N	\N	62738	62738	62739
15579	19437	0	applied	\N	\N	\N	\N	62761	62761	62762
15579	19438	1	applied	\N	\N	\N	\N	62763	62763	62764
15579	19439	2	applied	\N	\N	1000000000	\N	62765	62765	62766
15584	19448	0	applied	\N	\N	\N	\N	62790	62790	62791
15584	19449	1	applied	\N	\N	\N	\N	62792	62792	62793
15587	19450	0	applied	\N	\N	\N	\N	62797	62797	62798
15587	19451	1	applied	\N	\N	\N	\N	62799	62799	62800
15587	19452	2	applied	\N	\N	\N	\N	62801	62801	62802
15587	19453	3	applied	\N	\N	\N	\N	62803	62803	62804
15592	19462	0	applied	\N	\N	\N	\N	62828	62828	62829
15592	19463	1	applied	\N	\N	\N	\N	62830	62830	62831
15592	19464	2	applied	\N	\N	\N	\N	62832	62832	62833
15592	19465	3	applied	\N	\N	\N	\N	62834	62834	62835
15593	19466	0	applied	\N	\N	\N	\N	62838	62838	62839
15593	19467	1	applied	\N	\N	\N	\N	62840	62840	62841
15595	19466	0	applied	\N	\N	\N	\N	62838	62838	62839
15595	19467	1	applied	\N	\N	\N	\N	62840	62840	62841
15600	19472	0	applied	\N	\N	\N	\N	62859	62859	62860
15600	19473	2	applied	\N	\N	\N	\N	62862	62862	62863
15602	19474	0	applied	\N	\N	\N	\N	62866	62866	62867
15602	19475	1	applied	\N	\N	\N	\N	62868	62868	62869
15610	19487	0	applied	\N	\N	\N	\N	62906	62906	62907
15610	19488	1	applied	\N	\N	\N	\N	62908	62908	62909
15610	19489	2	applied	\N	\N	\N	\N	62910	62910	49653
15612	19487	0	applied	\N	\N	\N	\N	62906	62906	62907
15612	19488	1	applied	\N	\N	\N	\N	62908	62908	62909
15612	19489	2	applied	\N	\N	\N	\N	62910	62910	49653
15481	19272	3	applied	\N	\N	\N	\N	62289	62289	62290
15484	19278	0	applied	\N	\N	\N	\N	62309	62309	62310
15484	19279	1	applied	\N	\N	\N	\N	62311	62311	62312
15484	19280	2	applied	\N	\N	\N	\N	62313	62313	62314
15496	19288	0	applied	\N	\N	\N	\N	62343	62343	62344
15496	19289	1	applied	\N	\N	\N	\N	62345	62345	62346
15496	19290	2	applied	\N	\N	\N	\N	62347	62347	62348
15496	19291	3	applied	\N	\N	\N	\N	62349	62349	62350
15496	19292	4	applied	\N	\N	\N	\N	62351	62351	62352
15496	19293	5	applied	\N	\N	\N	\N	62353	62353	62354
15502	19297	0	applied	\N	\N	\N	\N	62369	62369	62370
15502	19298	1	applied	\N	\N	\N	\N	62371	62371	62372
15502	19299	2	applied	\N	\N	\N	\N	62373	62373	62374
15509	19309	0	applied	\N	\N	\N	\N	62398	62398	62399
15509	19310	1	applied	\N	\N	\N	\N	62400	62400	62401
15516	19314	0	applied	\N	\N	\N	\N	62413	62413	62414
15516	19317	1	applied	\N	\N	\N	\N	62427	62427	62428
15516	19318	2	applied	\N	\N	\N	\N	62429	62429	62430
15519	19325	0	applied	\N	\N	\N	\N	62450	62450	62451
15519	19326	1	applied	\N	\N	\N	\N	62452	62452	62453
15519	19327	2	applied	\N	\N	\N	\N	62454	62454	62455
15522	19332	0	applied	\N	\N	\N	\N	62470	62470	62471
15522	19333	1	applied	\N	\N	\N	\N	62472	62472	62473
15522	19334	2	applied	\N	\N	\N	\N	62474	62474	62475
15522	19335	3	applied	\N	\N	\N	\N	62476	62476	62477
15522	19336	4	applied	\N	\N	\N	\N	62478	62478	62479
15522	19337	5	applied	\N	\N	\N	\N	62480	62480	62481
15524	19332	0	applied	\N	\N	\N	\N	62470	62470	62471
15524	19333	1	applied	\N	\N	\N	\N	62472	62472	62473
15524	19334	2	applied	\N	\N	\N	\N	62474	62474	62475
15524	19335	3	applied	\N	\N	\N	\N	62476	62476	62477
15524	19336	4	applied	\N	\N	\N	\N	62478	62478	62479
15524	19337	5	applied	\N	\N	\N	\N	62480	62480	62481
15526	19338	0	applied	\N	\N	\N	\N	62487	62487	62488
15526	19339	1	applied	\N	\N	\N	\N	62489	62489	62490
15529	19342	0	applied	\N	\N	\N	\N	62503	62503	62504
15529	19343	1	applied	\N	\N	\N	\N	62505	62505	62506
15529	19344	2	applied	\N	\N	\N	\N	62507	62507	62508
15529	19345	3	applied	\N	\N	\N	\N	62509	62509	62510
15529	19346	4	applied	\N	\N	\N	\N	62511	62511	62512
15529	19347	5	applied	\N	\N	\N	\N	62513	62513	62514
15529	19348	6	applied	\N	\N	\N	\N	62515	62515	62516
15534	19352	0	applied	\N	\N	\N	\N	62529	62529	62530
15534	19353	1	applied	\N	\N	\N	\N	62531	62531	62532
15534	19354	2	applied	\N	\N	\N	\N	62533	62533	62534
15534	19355	3	applied	\N	\N	\N	\N	62535	62535	62536
15534	19356	4	applied	\N	\N	\N	\N	62537	62537	62538
15536	19352	0	applied	\N	\N	\N	\N	62529	62529	62530
15536	19353	1	applied	\N	\N	\N	\N	62531	62531	62532
15536	19357	2	applied	\N	\N	\N	\N	62542	62542	62543
15536	19354	3	applied	\N	\N	\N	\N	62533	62533	62534
15536	19355	4	applied	\N	\N	\N	\N	62535	62535	62536
15536	19356	5	applied	\N	\N	\N	\N	62537	62537	62538
15542	19373	0	applied	\N	\N	\N	\N	62582	62582	62583
15542	19374	1	applied	\N	\N	\N	\N	62584	62584	62585
15542	19375	2	applied	\N	\N	\N	\N	62586	62586	62587
15542	19376	3	applied	\N	\N	\N	\N	62588	62588	62589
15544	19373	0	applied	\N	\N	\N	\N	62582	62582	62583
15544	19374	1	applied	\N	\N	\N	\N	62584	62584	62585
15544	19375	2	applied	\N	\N	\N	\N	62586	62586	62587
15544	19376	3	applied	\N	\N	\N	\N	62588	62588	62589
15548	19389	0	applied	\N	\N	\N	\N	62622	62622	62623
15548	19390	1	applied	\N	\N	\N	\N	62624	62624	62625
15548	19391	2	applied	\N	\N	\N	\N	62626	62626	62627
15548	19392	3	applied	\N	\N	\N	\N	62628	62628	62629
15548	19393	4	applied	\N	\N	\N	\N	62630	62630	62631
15551	19396	0	applied	\N	\N	\N	\N	62640	62640	62641
15551	19397	2	applied	\N	\N	\N	\N	62643	62643	62644
15551	19398	3	applied	\N	\N	\N	\N	62645	62645	62646
15551	19399	4	applied	\N	\N	\N	\N	62647	62647	62648
15551	19400	5	applied	\N	\N	\N	\N	62649	62649	62650
15551	19401	6	applied	\N	\N	\N	\N	62651	62651	62652
15551	19402	7	applied	\N	\N	\N	\N	62653	62653	62654
15551	19403	8	applied	\N	\N	\N	\N	62655	62655	62656
15553	19404	0	applied	\N	\N	\N	\N	62661	62661	62662
15556	19410	0	applied	\N	\N	\N	\N	62679	62679	62680
15556	19411	1	applied	\N	\N	\N	\N	62681	62681	62682
15556	19412	2	applied	\N	\N	\N	\N	62683	62683	62684
15556	19413	3	applied	\N	\N	\N	\N	62685	62685	62686
15556	19414	4	applied	\N	\N	1000000000	\N	62687	62687	62688
15556	19415	5	applied	\N	\N	\N	\N	62689	62689	62690
15558	19410	0	applied	\N	\N	\N	\N	62679	62679	62680
15558	19411	1	applied	\N	\N	\N	\N	62681	62681	62682
15558	19412	2	applied	\N	\N	\N	\N	62683	62683	62684
15558	19413	3	applied	\N	\N	\N	\N	62685	62685	62686
15558	19414	4	applied	\N	\N	1000000000	\N	62687	62687	62688
15558	19415	5	applied	\N	\N	\N	\N	62689	62689	62690
15559	19313	0	applied	\N	\N	1000000000	\N	62410	62410	62411
15559	19143	1	applied	\N	\N	\N	\N	61912	61912	61913
15559	19145	2	applied	\N	\N	\N	\N	61918	61918	61919
15559	19147	3	applied	\N	\N	\N	\N	61924	61924	61925
15559	19148	4	applied	\N	\N	\N	\N	61926	61926	61927
15559	19152	5	applied	\N	\N	\N	\N	61936	61936	61937
15559	19155	6	applied	\N	\N	\N	\N	61951	61951	61952
15559	19156	7	applied	\N	\N	\N	\N	61955	61955	61956
15559	19157	8	applied	\N	\N	\N	\N	61957	61957	61958
15559	19162	9	applied	\N	\N	\N	\N	61969	61969	61970
15559	19163	10	applied	\N	\N	\N	\N	61971	61971	61972
15559	19169	11	applied	\N	\N	\N	\N	61992	61992	61993
15559	19170	12	applied	\N	\N	\N	\N	61994	61994	61995
15559	19164	13	applied	\N	\N	\N	\N	61973	61973	61974
15559	19166	14	applied	\N	\N	\N	\N	61984	61984	61985
15559	19168	15	applied	\N	\N	\N	\N	61990	61990	61991
15559	19172	17	applied	\N	\N	\N	\N	62005	62005	62006
15559	19175	18	applied	\N	\N	\N	\N	62013	62013	62014
15559	19178	19	applied	\N	\N	\N	\N	62022	62022	62023
15559	19179	20	applied	\N	\N	\N	\N	62024	62024	62025
15559	19182	21	applied	\N	\N	\N	\N	62032	62032	62033
15559	19184	22	applied	\N	\N	\N	\N	62041	62041	62042
15559	19187	23	applied	\N	\N	\N	\N	62051	62051	62052
15559	19189	24	applied	\N	\N	\N	\N	62057	62057	62058
15559	19191	25	applied	\N	\N	\N	\N	62068	62068	62069
15559	19194	26	applied	\N	\N	\N	\N	62076	62076	62077
15559	19195	27	applied	\N	\N	\N	\N	62078	62078	62079
15559	19196	28	applied	\N	\N	\N	\N	62080	62080	62081
15559	19201	29	applied	\N	\N	\N	\N	62093	62093	62094
15559	19202	30	applied	\N	\N	\N	\N	62095	62095	62096
15559	19206	31	applied	\N	\N	\N	\N	62104	62104	62105
15559	19207	32	applied	\N	\N	\N	\N	62106	62106	62107
15530	19344	2	applied	\N	\N	\N	\N	62507	62507	62508
15530	19345	3	applied	\N	\N	\N	\N	62509	62509	62510
15530	19346	4	applied	\N	\N	\N	\N	62511	62511	62512
15530	19347	5	applied	\N	\N	\N	\N	62513	62513	62514
15530	19348	6	applied	\N	\N	\N	\N	62515	62515	62516
15538	19364	0	applied	\N	\N	\N	\N	62560	62560	62561
15538	19365	1	applied	\N	\N	\N	\N	62562	62562	62563
15541	19373	0	applied	\N	\N	\N	\N	62582	62582	62583
15541	19374	1	applied	\N	\N	\N	\N	62584	62584	62585
15541	19375	2	applied	\N	\N	\N	\N	62586	62586	62587
15541	19376	3	applied	\N	\N	\N	\N	62588	62588	62589
15543	19373	0	applied	\N	\N	\N	\N	62582	62582	62583
15543	19374	1	applied	\N	\N	\N	\N	62584	62584	62585
15543	19375	2	applied	\N	\N	\N	\N	62586	62586	62587
15543	19376	3	applied	\N	\N	\N	\N	62588	62588	62589
15547	19389	0	applied	\N	\N	\N	\N	62622	62622	62623
15547	19390	1	applied	\N	\N	\N	\N	62624	62624	62625
15547	19391	2	applied	\N	\N	\N	\N	62626	62626	62627
15547	19392	3	applied	\N	\N	\N	\N	62628	62628	62629
15547	19393	4	applied	\N	\N	\N	\N	62630	62630	62631
15549	19394	0	applied	\N	\N	\N	\N	62634	62634	62635
15549	19395	1	applied	\N	\N	\N	\N	62636	62636	62637
15552	19404	0	applied	\N	\N	\N	\N	62661	62661	62662
15555	19405	0	applied	\N	\N	\N	\N	62667	62667	62668
15555	19406	1	applied	\N	\N	\N	\N	62669	62669	62670
15555	19407	2	applied	\N	\N	\N	\N	62671	62671	62672
15555	19408	3	applied	\N	\N	\N	\N	62673	62673	62674
15555	19409	4	applied	\N	\N	\N	\N	62675	62675	62676
15557	19410	0	applied	\N	\N	\N	\N	62679	62679	62680
15557	19411	1	applied	\N	\N	\N	\N	62681	62681	62682
15557	19412	2	applied	\N	\N	\N	\N	62683	62683	62684
15557	19413	3	applied	\N	\N	\N	\N	62685	62685	62686
15557	19414	4	applied	\N	\N	1000000000	\N	62687	62687	62688
15557	19415	5	applied	\N	\N	\N	\N	62689	62689	62690
15560	19416	0	applied	\N	\N	\N	\N	62695	62695	62696
15560	19417	1	applied	\N	\N	\N	\N	62697	62697	62698
15560	19418	2	applied	\N	\N	\N	\N	62699	62699	62700
15560	19419	3	applied	\N	\N	\N	\N	62703	62703	62704
15560	19420	4	applied	\N	\N	1000000000	\N	62705	62705	62706
15560	19421	5	applied	\N	\N	\N	\N	62707	62707	62708
15568	19427	0	applied	\N	\N	\N	\N	62730	62730	62731
15568	19428	1	applied	\N	\N	\N	\N	62732	62732	62733
15568	19429	2	applied	\N	\N	\N	\N	62734	62734	62735
15577	19436	0	applied	\N	\N	\N	\N	62757	62757	62758
15581	19447	0	applied	\N	\N	\N	\N	62784	62784	62785
15588	19454	0	applied	\N	\N	\N	\N	62807	62807	62808
15588	19455	1	applied	\N	\N	\N	\N	62809	62809	62810
15594	19466	0	applied	\N	\N	\N	\N	62838	62838	62839
15594	19467	1	applied	\N	\N	\N	\N	62840	62840	62841
15596	19466	0	applied	\N	\N	\N	\N	62838	62838	62839
15596	19467	1	applied	\N	\N	\N	\N	62840	62840	62841
15599	19472	0	applied	\N	\N	\N	\N	62859	62859	62860
15599	19473	2	applied	\N	\N	\N	\N	62862	62862	62863
15601	19474	0	applied	\N	\N	\N	\N	62866	62866	62867
15601	19475	1	applied	\N	\N	\N	\N	62868	62868	62869
15613	19490	0	applied	\N	\N	\N	\N	62916	62916	62917
15613	19491	1	applied	\N	\N	\N	\N	62918	62918	49660
15615	19492	0	applied	\N	\N	\N	\N	62920	62920	62921
15615	19493	1	applied	\N	\N	\N	\N	62922	62922	62923
15618	19496	0	applied	\N	\N	\N	\N	62931	62931	62932
15618	19497	1	applied	\N	\N	\N	\N	62933	62933	62934
15618	19498	2	applied	\N	\N	\N	\N	62935	62935	49671
15618	19499	3	applied	\N	\N	\N	\N	62936	62936	62937
15618	19500	4	applied	\N	\N	\N	\N	62938	62938	49685
15623	19507	0	applied	\N	\N	\N	\N	62958	62958	62959
15623	19508	1	applied	\N	\N	\N	\N	62960	62960	62961
15623	19509	2	applied	\N	\N	\N	\N	62962	62962	62963
15623	19510	3	applied	\N	\N	\N	\N	62964	62964	49717
15623	19511	4	applied	\N	\N	\N	\N	62965	62965	49728
15623	19512	5	applied	\N	\N	\N	\N	62966	62966	49730
15625	19513	0	applied	\N	\N	\N	\N	62969	62969	62970
15625	19514	1	applied	\N	\N	\N	\N	62971	62971	49732
15625	19515	2	applied	\N	\N	\N	\N	62972	62972	49734
15625	19516	3	applied	\N	\N	\N	\N	62973	62973	49736
15630	19523	0	applied	\N	\N	\N	\N	62990	62990	62991
15630	19524	1	applied	\N	\N	\N	\N	62992	62992	49755
15630	19525	2	applied	\N	\N	\N	\N	62993	62993	62994
15632	19523	0	applied	\N	\N	\N	\N	62990	62990	62991
15632	19524	1	applied	\N	\N	\N	\N	62992	62992	49755
15632	19525	2	applied	\N	\N	\N	\N	62993	62993	62994
15634	19526	0	applied	\N	\N	\N	\N	63001	63001	63002
15634	19527	1	applied	\N	\N	\N	\N	63003	63003	63004
15634	19528	2	applied	\N	\N	\N	\N	63005	63005	63006
15634	19529	3	applied	\N	\N	\N	\N	63007	63007	49778
15636	19526	0	applied	\N	\N	\N	\N	63001	63001	63002
15636	19527	1	applied	\N	\N	\N	\N	63003	63003	63004
15636	19528	2	applied	\N	\N	\N	\N	63005	63005	63006
15636	19529	3	applied	\N	\N	\N	\N	63007	63007	49778
15638	19526	0	applied	\N	\N	\N	\N	63001	63001	63002
15638	19527	1	applied	\N	\N	\N	\N	63003	63003	63004
15638	19528	2	applied	\N	\N	\N	\N	63005	63005	63006
15638	19529	3	applied	\N	\N	\N	\N	63007	63007	49778
15643	19533	0	applied	\N	\N	\N	\N	63034	63034	63035
15643	19534	1	applied	\N	\N	\N	\N	63036	63036	63037
15645	19535	0	applied	\N	\N	\N	\N	63038	63038	63039
15645	19536	1	applied	\N	\N	\N	\N	63040	63040	63041
15645	19537	2	applied	\N	\N	\N	\N	63042	63042	49796
15645	19538	3	applied	\N	\N	\N	\N	63043	63043	63044
15650	19549	0	applied	\N	\N	\N	\N	63072	63072	63073
15650	19550	1	applied	\N	\N	\N	\N	63074	63074	63075
15650	19551	2	applied	\N	\N	\N	\N	63076	63076	63077
15650	19552	3	applied	\N	\N	\N	\N	63078	63078	63079
15650	19553	4	applied	\N	\N	\N	\N	63080	63080	63081
15650	19554	6	applied	\N	\N	\N	\N	63083	63083	49852
15653	19555	0	applied	\N	\N	\N	\N	63086	63086	63087
15653	19556	1	applied	\N	\N	\N	\N	63088	63088	49856
15653	19557	2	applied	\N	\N	\N	\N	63089	63089	49858
15655	19562	0	applied	\N	\N	\N	\N	63105	63105	63106
15655	19563	1	applied	\N	\N	\N	\N	63107	63107	63108
15655	19564	2	applied	\N	\N	\N	\N	63109	63109	63110
15658	19565	0	applied	\N	\N	\N	\N	63115	63115	63116
15658	19566	1	applied	\N	\N	\N	\N	63117	63117	63118
15658	19567	2	applied	\N	\N	\N	\N	63119	63119	63120
15658	19568	3	applied	\N	\N	\N	\N	63121	63121	63122
15658	19569	4	applied	\N	\N	\N	\N	63123	63123	49894
15658	19570	5	applied	\N	\N	\N	\N	63124	63124	49896
15658	19571	6	applied	\N	\N	\N	\N	63125	63125	49902
15660	19575	0	applied	\N	\N	\N	\N	63135	63135	63136
15660	19576	1	applied	\N	\N	\N	\N	63137	63137	63138
15559	19210	33	applied	\N	\N	\N	\N	62114	62114	62115
15559	19211	34	applied	\N	\N	\N	\N	62116	62116	62117
15559	19215	35	applied	\N	\N	\N	\N	62129	62129	62130
15559	19217	36	applied	\N	\N	\N	\N	62139	62139	62140
15559	19218	37	applied	\N	\N	\N	\N	62141	62141	62142
15559	19222	38	applied	\N	\N	\N	\N	62150	62150	62151
15559	19224	39	applied	\N	\N	\N	\N	62154	62154	62155
15559	19225	40	applied	\N	\N	\N	\N	62156	62156	62157
15559	19226	41	applied	\N	\N	\N	\N	62158	62158	62159
15559	19231	42	applied	\N	\N	\N	\N	62169	62169	62170
15559	19234	43	applied	\N	\N	\N	\N	62181	62181	62182
15559	19235	44	applied	\N	\N	\N	\N	62183	62183	62184
15559	19236	45	applied	\N	\N	\N	\N	62185	62185	62186
15559	19241	46	applied	\N	\N	\N	\N	62198	62198	62199
15559	19243	47	applied	\N	\N	\N	\N	62203	62203	62204
15559	19245	48	applied	\N	\N	\N	\N	62209	62209	62210
15559	19247	49	applied	\N	\N	\N	\N	62218	62218	62219
15559	19250	50	applied	\N	\N	\N	\N	62228	62228	62229
15559	19251	51	applied	\N	\N	\N	\N	62230	62230	62231
15559	19254	52	applied	\N	\N	\N	\N	62238	62238	62239
15559	19257	53	applied	\N	\N	\N	\N	62247	62247	62248
15559	19259	54	applied	\N	\N	\N	\N	62252	62252	62253
15559	19262	55	applied	\N	\N	\N	\N	62260	62260	62261
15559	19264	56	applied	\N	\N	\N	\N	62271	62271	62272
15559	19265	57	applied	\N	\N	\N	\N	62273	62273	62274
15559	19269	58	applied	\N	\N	\N	\N	62283	62283	62284
15559	19270	59	applied	\N	\N	\N	\N	62285	62285	62286
15559	19273	60	applied	\N	\N	\N	\N	62295	62295	62296
15559	19276	61	applied	\N	\N	\N	\N	62303	62303	62304
15559	19278	62	applied	\N	\N	\N	\N	62309	62309	62310
15559	19281	63	applied	\N	\N	\N	\N	62321	62321	62322
15559	19282	64	applied	\N	\N	\N	\N	62329	62329	62330
15559	19283	65	applied	\N	\N	\N	\N	62331	62331	62332
15559	19288	66	applied	\N	\N	\N	\N	62343	62343	62344
15559	19289	67	applied	\N	\N	\N	\N	62345	62345	62346
15559	19290	68	applied	\N	\N	\N	\N	62347	62347	62348
15559	19294	69	applied	\N	\N	\N	\N	62360	62360	62361
15559	19297	70	applied	\N	\N	\N	\N	62369	62369	62370
15559	19300	71	applied	\N	\N	\N	\N	62377	62377	62378
15559	19301	72	applied	\N	\N	\N	\N	62380	62380	62381
15559	19302	73	applied	\N	\N	\N	\N	62382	62382	62383
15559	19303	74	applied	\N	\N	\N	\N	62384	62384	62385
15559	19309	75	applied	\N	\N	\N	\N	62398	62398	62399
15559	19311	76	applied	\N	\N	\N	\N	62404	62404	62405
15559	19314	77	applied	\N	\N	\N	\N	62413	62413	62414
15559	19317	78	applied	\N	\N	\N	\N	62427	62427	62428
15559	19319	79	applied	\N	\N	\N	\N	62434	62434	62435
15559	19323	80	applied	\N	\N	\N	\N	62444	62444	62445
15559	19325	81	applied	\N	\N	\N	\N	62450	62450	62451
15559	19328	82	applied	\N	\N	\N	\N	62460	62460	62461
15559	19329	83	applied	\N	\N	\N	\N	62462	62462	62463
15559	19333	84	applied	\N	\N	\N	\N	62472	62472	62473
15559	19334	85	applied	\N	\N	\N	\N	62474	62474	62475
15559	19338	86	applied	\N	\N	\N	\N	62487	62487	62488
15559	19340	87	applied	\N	\N	\N	\N	62497	62497	62498
15559	19342	88	applied	\N	\N	\N	\N	62503	62503	62504
15559	19343	89	applied	\N	\N	\N	\N	62505	62505	62506
15559	19344	90	applied	\N	\N	\N	\N	62507	62507	62508
15559	19349	91	applied	\N	\N	\N	\N	62520	62520	62521
15559	19352	92	applied	\N	\N	\N	\N	62529	62529	62530
15559	19353	93	applied	\N	\N	\N	\N	62531	62531	62532
15559	19357	94	applied	\N	\N	\N	\N	62542	62542	62543
15559	19358	95	applied	\N	\N	\N	\N	62546	62546	62547
15559	19359	96	applied	\N	\N	\N	\N	62548	62548	62549
15559	19364	97	applied	\N	\N	\N	\N	62560	62560	62561
15559	19366	98	applied	\N	\N	\N	\N	62564	62564	62565
15559	19367	99	applied	\N	\N	\N	\N	62566	62566	62567
15559	19370	100	applied	\N	\N	\N	\N	62574	62574	62575
15559	19373	101	applied	\N	\N	\N	\N	62582	62582	62583
15559	19374	102	applied	\N	\N	\N	\N	62584	62584	62585
15559	19377	103	applied	\N	\N	\N	\N	62595	62595	62596
15559	19380	104	applied	\N	\N	\N	\N	62603	62603	62604
15559	19381	105	applied	\N	\N	\N	\N	62605	62605	62606
15559	19382	106	applied	\N	\N	\N	\N	62607	62607	62608
15559	19383	107	applied	\N	\N	\N	\N	62609	62609	62610
15559	19389	108	applied	\N	\N	\N	\N	62622	62622	62623
15559	19390	109	applied	\N	\N	\N	\N	62624	62624	62625
15559	19394	110	applied	\N	\N	\N	\N	62634	62634	62635
15559	19396	111	applied	\N	\N	\N	\N	62640	62640	62641
15559	19397	112	applied	\N	\N	\N	\N	62643	62643	62644
15559	19398	113	applied	\N	\N	\N	\N	62645	62645	62646
15559	19404	114	applied	\N	\N	\N	\N	62661	62661	62662
15559	19405	115	applied	\N	\N	\N	\N	62667	62667	62668
15559	19406	116	applied	\N	\N	\N	\N	62669	62669	62670
15559	19410	117	applied	\N	\N	\N	\N	62679	62679	62680
15559	19411	118	applied	\N	\N	\N	\N	62681	62681	62682
15559	19416	119	applied	\N	\N	\N	\N	62695	62695	62696
15559	19417	120	applied	\N	\N	\N	\N	62697	62697	62698
15559	19418	121	applied	\N	\N	\N	\N	62699	62699	62700
15559	19144	122	applied	\N	\N	\N	\N	61914	61914	61915
15559	19146	123	applied	\N	\N	\N	\N	61920	61920	61921
15559	19149	124	applied	\N	\N	\N	\N	61928	61928	61929
15559	19150	125	applied	\N	\N	\N	\N	61930	61930	61931
15561	19416	0	applied	\N	\N	\N	\N	62695	62695	62696
15561	19417	1	applied	\N	\N	\N	\N	62697	62697	62698
15561	19418	2	applied	\N	\N	\N	\N	62699	62699	62700
15561	19419	3	applied	\N	\N	\N	\N	62703	62703	62704
15561	19420	4	applied	\N	\N	1000000000	\N	62705	62705	62706
15561	19421	5	applied	\N	\N	\N	\N	62707	62707	62708
15564	19422	0	applied	\N	\N	\N	\N	62713	62713	62714
15566	19423	0	applied	\N	\N	\N	\N	62718	62718	62719
15566	19424	1	applied	\N	\N	\N	\N	62720	62720	62721
15569	19427	0	applied	\N	\N	\N	\N	62730	62730	62731
15569	19428	1	applied	\N	\N	\N	\N	62732	62732	62733
15569	19429	2	applied	\N	\N	\N	\N	62734	62734	62735
15572	19433	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	62747	62747	\N
15572	19434	1	applied	\N	\N	\N	\N	62748	62748	62749
15574	19435	0	applied	\N	\N	\N	\N	62752	62752	62753
15576	19435	0	applied	\N	\N	\N	\N	62752	62752	62753
15580	19440	0	applied	\N	\N	\N	\N	62768	62768	62769
15580	19441	1	applied	\N	\N	\N	\N	62770	62770	62771
15580	19442	2	applied	\N	\N	\N	\N	62772	62772	62773
15580	19443	3	applied	\N	\N	\N	\N	62774	62774	62775
15580	19444	4	applied	\N	\N	\N	\N	62776	62776	62777
15580	19445	5	applied	\N	\N	1000000000	\N	62778	62778	62779
15580	19446	6	applied	\N	\N	1000000000	\N	62780	62780	62781
15583	19447	0	applied	\N	\N	\N	\N	62784	62784	62785
15585	19448	0	applied	\N	\N	\N	\N	62790	62790	62791
15585	19449	1	applied	\N	\N	\N	\N	62792	62792	62793
15590	19456	0	applied	\N	\N	\N	\N	62812	62812	62813
15590	19457	1	applied	\N	\N	\N	\N	62814	62814	62815
15590	19458	2	applied	\N	\N	\N	\N	62816	62816	62817
15590	19459	3	applied	\N	\N	\N	\N	62818	62818	62819
15590	19460	4	applied	\N	\N	\N	\N	62820	62820	62821
15590	19461	5	applied	\N	\N	\N	\N	62822	62822	62823
15598	19470	0	applied	\N	\N	\N	\N	62853	62853	62854
15598	19471	1	applied	\N	\N	\N	\N	62855	62855	62856
15603	19476	0	applied	\N	\N	\N	\N	62876	62876	62877
15603	19477	1	applied	\N	\N	\N	\N	62878	62878	62879
15605	19478	0	applied	\N	\N	\N	\N	62884	62884	62885
15605	19479	1	applied	\N	\N	\N	\N	62886	62886	49638
15607	19478	0	applied	\N	\N	\N	\N	62884	62884	62885
15607	19479	1	applied	\N	\N	\N	\N	62886	62886	49638
15608	19480	0	applied	\N	\N	\N	\N	62892	62892	62893
15608	19481	1	applied	\N	\N	\N	\N	62894	62894	62895
15608	19482	2	applied	\N	\N	\N	\N	62896	62896	62897
15608	19483	3	applied	\N	\N	\N	\N	62898	62898	62899
15608	19484	4	applied	\N	\N	\N	\N	62900	62900	49641
15608	19485	5	applied	\N	\N	\N	\N	62901	62901	62902
15608	19486	6	applied	\N	\N	\N	\N	62903	62903	62904
15620	19501	0	applied	\N	\N	\N	\N	62943	62943	62944
15620	19502	1	applied	\N	\N	\N	\N	62945	62945	62946
15622	19503	0	applied	\N	\N	\N	\N	62949	62949	62950
15622	19504	1	applied	\N	\N	\N	\N	62951	62951	62952
15622	19505	2	applied	\N	\N	\N	\N	62953	62953	49705
15622	19506	3	applied	\N	\N	\N	\N	62954	62954	62955
15629	19520	0	applied	\N	\N	\N	\N	62985	62985	62986
15629	19521	1	applied	\N	\N	\N	\N	62987	62987	49751
15629	19522	2	applied	\N	\N	\N	\N	62988	62988	49753
15640	19530	0	applied	\N	\N	\N	\N	63024	63024	63025
15640	19531	1	applied	\N	\N	\N	\N	63026	63026	63027
15640	19532	2	applied	\N	\N	\N	\N	63028	63028	63029
15642	19533	0	applied	\N	\N	\N	\N	63034	63034	63035
15642	19534	1	applied	\N	\N	\N	\N	63036	63036	63037
15647	19539	0	applied	\N	\N	\N	\N	63051	63051	63052
15647	19540	1	applied	\N	\N	\N	\N	63053	63053	63054
15647	19541	2	applied	\N	\N	\N	\N	63055	63055	63056
15647	19542	3	applied	\N	\N	\N	\N	63057	63057	63058
15647	19543	4	applied	\N	\N	\N	\N	63059	63059	49816
15647	19544	5	applied	\N	\N	\N	\N	63060	63060	49818
15649	19545	0	applied	\N	\N	\N	\N	63062	63062	63063
15649	19546	1	applied	\N	\N	\N	\N	63064	63064	63065
15649	19547	2	applied	\N	\N	\N	\N	63066	63066	49827
15649	19548	3	applied	\N	\N	\N	\N	63067	63067	49829
15652	19555	0	applied	\N	\N	\N	\N	63086	63086	63087
15652	19556	1	applied	\N	\N	\N	\N	63088	63088	49856
15652	19557	2	applied	\N	\N	\N	\N	63089	63089	49858
15654	19558	0	applied	\N	\N	\N	\N	63097	63097	63098
15654	19559	1	applied	\N	\N	\N	\N	63099	63099	63100
15654	19560	2	applied	\N	\N	\N	\N	63101	63101	63102
15654	19561	3	applied	\N	\N	\N	\N	63103	63103	49866
15657	19565	0	applied	\N	\N	\N	\N	63115	63115	63116
15657	19566	1	applied	\N	\N	\N	\N	63117	63117	63118
15657	19567	2	applied	\N	\N	\N	\N	63119	63119	63120
15657	19568	3	applied	\N	\N	\N	\N	63121	63121	63122
15657	19569	4	applied	\N	\N	\N	\N	63123	63123	49894
15657	19570	5	applied	\N	\N	\N	\N	63124	63124	49896
15657	19571	6	applied	\N	\N	\N	\N	63125	63125	49902
15659	19572	0	applied	\N	\N	\N	\N	63129	63129	63130
15659	19573	1	applied	\N	\N	\N	\N	63131	63131	49911
15659	19574	2	applied	\N	\N	\N	\N	63132	63132	49913
15662	19582	0	applied	\N	\N	\N	\N	63151	63151	63152
15662	19583	1	applied	\N	\N	\N	\N	63153	63153	63154
15662	19584	2	applied	\N	\N	\N	\N	63155	63155	49950
15662	19585	3	applied	\N	\N	\N	\N	63156	63156	49952
15662	19586	4	applied	\N	\N	\N	\N	63157	63157	49956
15662	19587	5	applied	\N	\N	\N	\N	63158	63158	49958
15665	19595	0	applied	\N	\N	\N	\N	63178	63178	63179
15665	19596	1	applied	\N	\N	\N	\N	63180	63180	63181
15665	19597	2	applied	\N	\N	\N	\N	63182	63182	63183
15665	19598	3	applied	\N	\N	\N	\N	63184	63184	63185
15665	19599	4	applied	\N	\N	\N	\N	63186	63186	50005
15665	19600	5	applied	\N	\N	\N	\N	63187	63187	50007
15667	19595	0	applied	\N	\N	\N	\N	63178	63178	63179
15667	19596	1	applied	\N	\N	\N	\N	63180	63180	63181
15667	19597	2	applied	\N	\N	\N	\N	63182	63182	63183
15667	19598	3	applied	\N	\N	\N	\N	63184	63184	63185
15667	19599	4	applied	\N	\N	\N	\N	63186	63186	50005
15667	19600	5	applied	\N	\N	\N	\N	63187	63187	50007
15669	19591	0	applied	\N	\N	\N	\N	63169	63169	63170
15669	19592	1	applied	\N	\N	\N	\N	63171	63171	63172
15669	19593	2	applied	\N	\N	\N	\N	63173	63173	63174
15669	19594	3	applied	\N	\N	\N	\N	63175	63175	63176
15672	19601	0	applied	\N	\N	\N	\N	63196	63196	63197
15672	19602	1	applied	\N	\N	\N	\N	63198	63198	63199
15672	19603	2	applied	\N	\N	\N	\N	63200	63200	63201
15672	19604	3	applied	\N	\N	\N	\N	63202	63202	63203
15672	19605	4	applied	\N	\N	\N	\N	63204	63204	63205
15672	19606	5	applied	\N	\N	\N	\N	63206	63206	50031
15672	19607	6	applied	\N	\N	\N	\N	63207	63207	63208
15674	19608	0	applied	\N	\N	\N	\N	63214	63214	63215
15674	19609	1	applied	\N	\N	\N	\N	63216	63216	50033
15674	19610	2	applied	\N	\N	\N	\N	63217	63217	50043
15676	19611	0	applied	\N	\N	\N	\N	63221	63221	63222
15676	19612	1	applied	\N	\N	\N	\N	63223	63223	63224
15676	19613	2	applied	\N	\N	\N	\N	63225	63225	50047
15676	19614	3	applied	\N	\N	\N	\N	63226	63226	50057
15689	19621	0	applied	\N	\N	\N	\N	63254	63254	63255
15689	19622	1	applied	\N	\N	\N	\N	63256	63256	63257
15689	19623	2	applied	\N	\N	\N	\N	63258	63258	63259
15689	19624	3	applied	\N	\N	\N	\N	63260	63260	63261
15689	19625	4	applied	\N	\N	\N	\N	63262	63262	50094
15691	19621	0	applied	\N	\N	\N	\N	63254	63254	63255
15691	19622	1	applied	\N	\N	\N	\N	63256	63256	63257
15691	19623	2	applied	\N	\N	\N	\N	63258	63258	63259
15691	19624	3	applied	\N	\N	\N	\N	63260	63260	63261
15691	19625	4	applied	\N	\N	\N	\N	63262	63262	50094
15691	19626	5	applied	\N	\N	\N	\N	63265	63265	63266
15691	19627	6	applied	\N	\N	\N	\N	63267	63267	50104
15696	19634	0	applied	\N	\N	\N	\N	63281	63281	63282
15696	19635	1	applied	\N	\N	\N	\N	63283	63283	63284
15696	19636	2	applied	\N	\N	\N	\N	63285	63285	50136
15696	19637	3	applied	\N	\N	\N	\N	63286	63286	50138
15707	19649	0	applied	\N	\N	\N	\N	63324	63324	63325
15707	19650	1	applied	\N	\N	\N	\N	63326	63326	50172
15707	19651	2	applied	\N	\N	\N	\N	63327	63327	50181
15710	19655	0	applied	\N	\N	\N	\N	63335	63335	63336
15710	19656	1	applied	\N	\N	\N	\N	63337	63337	63338
15710	19657	2	applied	\N	\N	\N	\N	63339	63339	63340
15604	19477	1	applied	\N	\N	\N	\N	62878	62878	62879
15606	19478	0	applied	\N	\N	\N	\N	62884	62884	62885
15606	19479	1	applied	\N	\N	\N	\N	62886	62886	49638
15609	19487	0	applied	\N	\N	\N	\N	62906	62906	62907
15609	19488	1	applied	\N	\N	\N	\N	62908	62908	62909
15609	19489	2	applied	\N	\N	\N	\N	62910	62910	49653
15611	19487	0	applied	\N	\N	\N	\N	62906	62906	62907
15611	19488	1	applied	\N	\N	\N	\N	62908	62908	62909
15611	19489	2	applied	\N	\N	\N	\N	62910	62910	49653
15616	19494	0	applied	\N	\N	\N	\N	62926	62926	62927
15616	19495	1	applied	\N	\N	\N	\N	62928	62928	49664
15621	19503	0	applied	\N	\N	\N	\N	62949	62949	62950
15621	19504	1	applied	\N	\N	\N	\N	62951	62951	62952
15621	19505	2	applied	\N	\N	\N	\N	62953	62953	49705
15621	19506	3	applied	\N	\N	\N	\N	62954	62954	62955
15626	19517	0	applied	\N	\N	\N	\N	62977	62977	62978
15626	19518	1	applied	\N	\N	\N	\N	62979	62979	62980
15626	19519	2	applied	\N	\N	\N	\N	62981	62981	62982
15628	19520	0	applied	\N	\N	\N	\N	62985	62985	62986
15628	19521	1	applied	\N	\N	\N	\N	62987	62987	49751
15628	19522	2	applied	\N	\N	\N	\N	62988	62988	49753
15631	19523	0	applied	\N	\N	\N	\N	62990	62990	62991
15631	19524	1	applied	\N	\N	\N	\N	62992	62992	49755
15631	19525	2	applied	\N	\N	\N	\N	62993	62993	62994
15641	19530	0	applied	\N	\N	\N	\N	63024	63024	63025
15641	19531	1	applied	\N	\N	\N	\N	63026	63026	63027
15641	19532	2	applied	\N	\N	\N	\N	63028	63028	63029
15648	19545	0	applied	\N	\N	\N	\N	63062	63062	63063
15648	19546	1	applied	\N	\N	\N	\N	63064	63064	63065
15648	19547	2	applied	\N	\N	\N	\N	63066	63066	49827
15648	19548	3	applied	\N	\N	\N	\N	63067	63067	49829
15651	19555	0	applied	\N	\N	\N	\N	63086	63086	63087
15651	19556	1	applied	\N	\N	\N	\N	63088	63088	49856
15651	19557	2	applied	\N	\N	\N	\N	63089	63089	49858
15656	19562	0	applied	\N	\N	\N	\N	63105	63105	63106
15656	19563	1	applied	\N	\N	\N	\N	63107	63107	63108
15656	19564	2	applied	\N	\N	\N	\N	63109	63109	63110
15675	19608	0	applied	\N	\N	\N	\N	63214	63214	63215
15675	19609	1	applied	\N	\N	\N	\N	63216	63216	50033
15675	19610	2	applied	\N	\N	\N	\N	63217	63217	50043
15677	19611	0	applied	\N	\N	\N	\N	63221	63221	63222
15677	19612	1	applied	\N	\N	\N	\N	63223	63223	63224
15677	19613	2	applied	\N	\N	\N	\N	63225	63225	50047
15677	19614	3	applied	\N	\N	\N	\N	63226	63226	50057
15680	19611	0	applied	\N	\N	\N	\N	63221	63221	63222
15680	19612	1	applied	\N	\N	\N	\N	63223	63223	63224
15680	19613	2	applied	\N	\N	\N	\N	63225	63225	50047
15680	19614	3	applied	\N	\N	\N	\N	63226	63226	50057
15686	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15686	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15686	19620	2	applied	\N	\N	\N	\N	63243	63243	63244
15688	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15688	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15688	19620	2	applied	\N	\N	\N	\N	63243	63243	63244
15695	19631	0	applied	\N	\N	\N	\N	63276	63276	63277
15695	19632	1	applied	\N	\N	\N	\N	63278	63278	50130
15695	19633	2	applied	\N	\N	\N	\N	63279	63279	50132
15697	19634	0	applied	\N	\N	\N	\N	63281	63281	63282
15697	19635	1	applied	\N	\N	\N	\N	63283	63283	63284
15697	19636	2	applied	\N	\N	\N	\N	63285	63285	50136
15697	19637	3	applied	\N	\N	\N	\N	63286	63286	50138
15699	19634	0	applied	\N	\N	\N	\N	63281	63281	63282
15699	19635	1	applied	\N	\N	\N	\N	63283	63283	63284
15699	19636	2	applied	\N	\N	\N	\N	63285	63285	50136
15699	19637	3	applied	\N	\N	\N	\N	63286	63286	50138
15708	19652	0	applied	\N	\N	\N	\N	63328	63328	63329
15708	19653	1	applied	\N	\N	\N	\N	63330	63330	63331
15708	19654	2	applied	\N	\N	\N	\N	63332	63332	63333
15711	19432	0	applied	\N	\N	\N	\N	63352	63352	63353
15718	19672	0	applied	\N	\N	\N	\N	63435	63435	63436
15718	19673	1	applied	\N	\N	\N	\N	63437	63437	63438
15718	19674	2	applied	\N	\N	\N	\N	63439	63439	63440
15718	19675	3	applied	\N	\N	\N	\N	63441	63441	63442
15718	19676	4	applied	\N	\N	\N	\N	63443	63443	63444
15718	19677	5	applied	\N	\N	\N	\N	63445	63445	50255
15718	19678	6	applied	\N	\N	\N	\N	63446	63446	50257
15718	19679	7	applied	\N	\N	\N	\N	63447	63447	50261
15718	19680	8	applied	\N	\N	\N	\N	63448	63448	50263
15718	19681	9	applied	\N	\N	\N	\N	63449	63449	50267
15723	19688	0	applied	\N	\N	\N	\N	63468	63468	63469
15723	19689	1	applied	\N	\N	\N	\N	63470	63470	63471
15723	19690	2	applied	\N	\N	\N	\N	63472	63472	50289
15730	19698	0	applied	\N	\N	\N	\N	63494	63494	63495
15730	19699	1	applied	\N	\N	\N	\N	63496	63496	50318
15730	19700	2	applied	\N	\N	\N	\N	63497	63497	63498
15733	19716	0	applied	\N	\N	\N	\N	63528	63528	63529
15733	19717	1	applied	\N	\N	\N	\N	63530	63530	63531
15733	19718	2	applied	\N	\N	\N	\N	63532	63532	50400
15735	19719	0	applied	\N	\N	\N	\N	63535	63535	63536
15735	19720	1	applied	\N	\N	\N	\N	63537	63537	50402
15735	19721	2	applied	\N	\N	\N	\N	63538	63538	50410
15736	19722	0	applied	\N	\N	\N	\N	63541	63541	63542
15736	19723	1	applied	\N	\N	\N	\N	63543	63543	63544
15736	19724	2	applied	\N	\N	\N	\N	63545	63545	63546
15736	19725	3	applied	\N	\N	\N	\N	63547	63547	50420
15736	19726	4	applied	\N	\N	\N	\N	63548	63548	63549
15736	19727	5	applied	\N	\N	\N	\N	63550	63550	63551
15736	19728	6	applied	\N	\N	\N	\N	63552	63552	50424
15736	19729	7	applied	\N	\N	\N	\N	63553	63553	63554
15736	19730	9	applied	\N	\N	\N	\N	63556	63556	63557
15736	19731	10	applied	\N	\N	\N	\N	63558	63558	50436
15736	19732	11	applied	\N	\N	\N	\N	63559	63559	63560
15738	19733	0	applied	\N	\N	1000000000	\N	63566	63566	63567
15738	19734	1	applied	\N	\N	\N	\N	63568	63568	63569
15738	19735	2	applied	\N	\N	\N	\N	63570	63570	50449
15743	19743	0	applied	\N	\N	\N	\N	63586	63586	63587
15743	19744	1	applied	\N	\N	\N	\N	63588	63588	63589
15743	19745	2	applied	\N	\N	\N	\N	63590	63590	63591
15749	19757	0	applied	\N	\N	\N	\N	63618	63618	63603
15749	19758	1	applied	\N	\N	\N	\N	63619	63619	63620
15749	19759	2	applied	\N	\N	\N	\N	63621	63621	63622
15749	19760	3	applied	\N	\N	\N	\N	63623	63623	63624
15749	19761	4	applied	\N	\N	\N	\N	63625	63625	63626
15749	19762	5	applied	\N	\N	\N	\N	63627	63627	50529
15749	19763	6	applied	\N	\N	\N	\N	63628	63628	50541
15749	19764	7	applied	\N	\N	\N	\N	63629	63629	50543
15749	19765	8	applied	\N	\N	\N	\N	63630	63630	63631
15749	19766	9	applied	\N	\N	\N	\N	63632	63632	50550
15749	19767	10	applied	\N	\N	\N	\N	63633	63633	50562
15749	19768	11	applied	\N	\N	\N	\N	63634	63634	50566
15614	19492	0	applied	\N	\N	\N	\N	62920	62920	62921
15614	19493	1	applied	\N	\N	\N	\N	62922	62922	62923
15617	19496	0	applied	\N	\N	\N	\N	62931	62931	62932
15617	19497	1	applied	\N	\N	\N	\N	62933	62933	62934
15617	19498	2	applied	\N	\N	\N	\N	62935	62935	49671
15617	19499	3	applied	\N	\N	\N	\N	62936	62936	62937
15617	19500	4	applied	\N	\N	\N	\N	62938	62938	49685
15619	19501	0	applied	\N	\N	\N	\N	62943	62943	62944
15619	19502	1	applied	\N	\N	\N	\N	62945	62945	62946
15624	19513	0	applied	\N	\N	\N	\N	62969	62969	62970
15624	19514	1	applied	\N	\N	\N	\N	62971	62971	49732
15624	19515	2	applied	\N	\N	\N	\N	62972	62972	49734
15624	19516	3	applied	\N	\N	\N	\N	62973	62973	49736
15633	19523	0	applied	\N	\N	\N	\N	62990	62990	62991
15633	19524	1	applied	\N	\N	\N	\N	62992	62992	49755
15633	19525	2	applied	\N	\N	\N	\N	62993	62993	62994
15635	19526	0	applied	\N	\N	\N	\N	63001	63001	63002
15635	19527	1	applied	\N	\N	\N	\N	63003	63003	63004
15635	19528	2	applied	\N	\N	\N	\N	63005	63005	63006
15635	19529	3	applied	\N	\N	\N	\N	63007	63007	49778
15637	19526	0	applied	\N	\N	\N	\N	63001	63001	63002
15637	19527	1	applied	\N	\N	\N	\N	63003	63003	63004
15637	19528	2	applied	\N	\N	\N	\N	63005	63005	63006
15637	19529	3	applied	\N	\N	\N	\N	63007	63007	49778
15639	19507	0	applied	\N	\N	\N	\N	62958	62958	62959
15639	19508	1	applied	\N	\N	\N	\N	62960	62960	62961
15639	19513	2	applied	\N	\N	\N	\N	62969	62969	62970
15639	19517	3	applied	\N	\N	\N	\N	62977	62977	62978
15639	19520	4	applied	\N	\N	\N	\N	62985	62985	62986
15639	19509	5	applied	\N	\N	\N	\N	62962	62962	62963
15639	19514	6	applied	\N	\N	\N	\N	62971	62971	63015
15639	19510	7	applied	\N	\N	\N	\N	62964	62964	63016
15639	19511	8	applied	\N	\N	\N	\N	62965	62965	63017
15639	19515	9	applied	\N	\N	\N	\N	62972	62972	63018
15639	19518	10	applied	\N	\N	\N	\N	62979	62979	63019
15639	19522	11	applied	\N	\N	\N	\N	62988	62988	63020
15639	19525	12	applied	\N	\N	\N	\N	62993	62993	62982
15639	19512	13	applied	\N	\N	\N	\N	62966	62966	49751
15639	19516	14	applied	\N	\N	\N	\N	62973	62973	63021
15639	19519	15	applied	\N	\N	\N	\N	62981	62981	63022
15639	19521	16	applied	\N	\N	\N	\N	62987	62987	49770
15644	19535	0	applied	\N	\N	\N	\N	63038	63038	63039
15644	19536	1	applied	\N	\N	\N	\N	63040	63040	63041
15644	19537	2	applied	\N	\N	\N	\N	63042	63042	49796
15644	19538	3	applied	\N	\N	\N	\N	63043	63043	63044
15646	19535	0	applied	\N	\N	\N	\N	63038	63038	63039
15646	19536	1	applied	\N	\N	\N	\N	63040	63040	63041
15646	19537	2	applied	\N	\N	\N	\N	63042	63042	49796
15646	19538	3	applied	\N	\N	\N	\N	63043	63043	63044
15661	19578	0	applied	\N	\N	\N	\N	63142	63142	63143
15661	19579	1	applied	\N	\N	\N	\N	63144	63144	63145
15661	19580	2	applied	\N	\N	\N	\N	63146	63146	49935
15661	19581	3	applied	\N	\N	\N	\N	63147	63147	63148
15664	19591	0	applied	\N	\N	\N	\N	63169	63169	63170
15664	19592	1	applied	\N	\N	\N	\N	63171	63171	63172
15664	19593	2	applied	\N	\N	\N	\N	63173	63173	63174
15664	19594	3	applied	\N	\N	\N	\N	63175	63175	63176
15671	19601	0	applied	\N	\N	\N	\N	63196	63196	63197
15671	19602	1	applied	\N	\N	\N	\N	63198	63198	63199
15671	19603	2	applied	\N	\N	\N	\N	63200	63200	63201
15671	19604	3	applied	\N	\N	\N	\N	63202	63202	63203
15671	19605	4	applied	\N	\N	\N	\N	63204	63204	63205
15671	19606	5	applied	\N	\N	\N	\N	63206	63206	50031
15671	19607	6	applied	\N	\N	\N	\N	63207	63207	63208
15673	19601	0	applied	\N	\N	\N	\N	63196	63196	63197
15673	19602	1	applied	\N	\N	\N	\N	63198	63198	63199
15673	19603	2	applied	\N	\N	\N	\N	63200	63200	63201
15673	19604	3	applied	\N	\N	\N	\N	63202	63202	63203
15673	19605	4	applied	\N	\N	\N	\N	63204	63204	63205
15673	19606	5	applied	\N	\N	\N	\N	63206	63206	50031
15673	19607	6	applied	\N	\N	\N	\N	63207	63207	63208
15678	19611	0	applied	\N	\N	\N	\N	63221	63221	63222
15678	19612	1	applied	\N	\N	\N	\N	63223	63223	63224
15678	19613	2	applied	\N	\N	\N	\N	63225	63225	50047
15678	19614	3	applied	\N	\N	\N	\N	63226	63226	50057
15682	19615	0	applied	\N	\N	\N	\N	63232	63232	63233
15682	19616	1	applied	\N	\N	\N	\N	63234	63234	50059
15682	19617	2	applied	\N	\N	\N	\N	63235	63235	50074
15684	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15684	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15687	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15687	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15687	19620	2	applied	\N	\N	\N	\N	63243	63243	63244
15693	19628	0	applied	\N	\N	\N	\N	63271	63271	63272
15693	19629	1	applied	\N	\N	\N	\N	63273	63273	50115
15693	19630	2	applied	\N	\N	\N	\N	63274	63274	50128
15698	19634	0	applied	\N	\N	\N	\N	63281	63281	63282
15698	19635	1	applied	\N	\N	\N	\N	63283	63283	63284
15698	19636	2	applied	\N	\N	\N	\N	63285	63285	50136
15698	19637	3	applied	\N	\N	\N	\N	63286	63286	50138
15700	19638	0	applied	\N	\N	\N	\N	63292	63292	63293
15700	19639	2	applied	\N	\N	\N	\N	63295	63295	63296
15702	19638	0	applied	\N	\N	\N	\N	63292	63292	63293
15702	19639	2	applied	\N	\N	\N	\N	63295	63295	63296
15702	19643	3	applied	\N	\N	\N	\N	63305	63305	63306
15702	19644	4	applied	\N	\N	\N	\N	63307	63307	50146
15702	19640	5	applied	\N	\N	\N	\N	63299	63299	63300
15702	19641	6	applied	\N	\N	\N	\N	63301	63301	50154
15702	19642	7	applied	\N	\N	\N	\N	63303	63303	50156
15704	19645	0	applied	\N	\N	\N	\N	63311	63311	63312
15704	19646	1	applied	\N	\N	\N	\N	63313	63313	50154
15704	19643	2	applied	\N	\N	\N	\N	63305	63305	63314
15704	19647	3	applied	\N	\N	\N	\N	63315	63315	50158
15704	19644	4	applied	\N	\N	\N	\N	63307	63307	63316
15704	19648	5	applied	\N	\N	\N	\N	63317	63317	50170
15706	19645	0	applied	\N	\N	\N	\N	63311	63311	63312
15706	19646	1	applied	\N	\N	\N	\N	63313	63313	50144
15706	19643	2	applied	\N	\N	\N	\N	63305	63305	63302
15706	19644	3	applied	\N	\N	\N	\N	63307	63307	63322
15706	19648	4	applied	\N	\N	\N	\N	63317	63317	50154
15706	19640	5	applied	\N	\N	\N	\N	63299	63299	63300
15706	19641	6	applied	\N	\N	\N	\N	63301	63301	50156
15706	19642	7	applied	\N	\N	\N	\N	63303	63303	50168
15706	19647	8	applied	\N	\N	\N	\N	63315	63315	50170
15716	19668	0	applied	\N	\N	\N	\N	63367	63367	63368
15716	19669	1	applied	\N	\N	\N	\N	63369	63369	50225
15716	19670	2	applied	\N	\N	\N	\N	63370	63370	50237
15716	19671	3	applied	\N	\N	\N	\N	63371	63371	63372
15721	19685	0	applied	\N	\N	\N	\N	63459	63459	63460
15721	19686	1	applied	\N	\N	\N	\N	63461	63461	63462
15660	19577	2	applied	\N	\N	\N	\N	63139	63139	63140
15663	19588	0	applied	\N	\N	\N	\N	63161	63161	63162
15663	19589	1	applied	\N	\N	\N	\N	63163	63163	63164
15663	19590	2	applied	\N	\N	\N	\N	63165	63165	63166
15666	19595	0	applied	\N	\N	\N	\N	63178	63178	63179
15666	19596	1	applied	\N	\N	\N	\N	63180	63180	63181
15666	19597	2	applied	\N	\N	\N	\N	63182	63182	63183
15666	19598	3	applied	\N	\N	\N	\N	63184	63184	63185
15666	19599	4	applied	\N	\N	\N	\N	63186	63186	50005
15666	19600	5	applied	\N	\N	\N	\N	63187	63187	50007
15668	19595	0	applied	\N	\N	\N	\N	63178	63178	63179
15668	19596	1	applied	\N	\N	\N	\N	63180	63180	63181
15668	19597	2	applied	\N	\N	\N	\N	63182	63182	63183
15668	19598	3	applied	\N	\N	\N	\N	63184	63184	63185
15668	19599	4	applied	\N	\N	\N	\N	63186	63186	50005
15668	19600	5	applied	\N	\N	\N	\N	63187	63187	50007
15670	19595	0	applied	\N	\N	\N	\N	63178	63178	63179
15670	19596	1	applied	\N	\N	\N	\N	63180	63180	63181
15670	19597	2	applied	\N	\N	\N	\N	63182	63182	63183
15670	19598	3	applied	\N	\N	\N	\N	63184	63184	63185
15670	19599	4	applied	\N	\N	\N	\N	63186	63186	50005
15670	19600	5	applied	\N	\N	\N	\N	63187	63187	50007
15679	19611	0	applied	\N	\N	\N	\N	63221	63221	63222
15679	19612	1	applied	\N	\N	\N	\N	63223	63223	63224
15679	19613	2	applied	\N	\N	\N	\N	63225	63225	50047
15679	19614	3	applied	\N	\N	\N	\N	63226	63226	50057
15681	19615	0	applied	\N	\N	\N	\N	63232	63232	63233
15681	19616	1	applied	\N	\N	\N	\N	63234	63234	50059
15681	19617	2	applied	\N	\N	\N	\N	63235	63235	50074
15683	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15683	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15683	19620	2	applied	\N	\N	\N	\N	63243	63243	63244
15685	19618	0	applied	\N	\N	\N	\N	63240	63240	63241
15685	19619	1	applied	\N	\N	\N	\N	63242	63242	50078
15685	19620	2	applied	\N	\N	\N	\N	63243	63243	63244
15690	19621	0	applied	\N	\N	\N	\N	63254	63254	63255
15690	19622	1	applied	\N	\N	\N	\N	63256	63256	63257
15690	19623	2	applied	\N	\N	\N	\N	63258	63258	63259
15690	19624	3	applied	\N	\N	\N	\N	63260	63260	63261
15690	19625	4	applied	\N	\N	\N	\N	63262	63262	50094
15690	19626	5	applied	\N	\N	\N	\N	63265	63265	63266
15690	19627	6	applied	\N	\N	\N	\N	63267	63267	50104
15694	19631	0	applied	\N	\N	\N	\N	63276	63276	63277
15694	19632	1	applied	\N	\N	\N	\N	63278	63278	50130
15694	19633	2	applied	\N	\N	\N	\N	63279	63279	50132
15701	19638	0	applied	\N	\N	\N	\N	63292	63292	63293
15701	19639	2	applied	\N	\N	\N	\N	63295	63295	63296
15701	19640	3	applied	\N	\N	\N	\N	63299	63299	63300
15701	19641	4	applied	\N	\N	\N	\N	63301	63301	63302
15701	19642	5	applied	\N	\N	\N	\N	63303	63303	50148
15703	19638	0	applied	\N	\N	\N	\N	63292	63292	63293
15703	19639	2	applied	\N	\N	\N	\N	63295	63295	63296
15703	19643	3	applied	\N	\N	\N	\N	63305	63305	63306
15703	19644	4	applied	\N	\N	\N	\N	63307	63307	50146
15703	19640	5	applied	\N	\N	\N	\N	63299	63299	63300
15703	19641	6	applied	\N	\N	\N	\N	63301	63301	50154
15703	19642	7	applied	\N	\N	\N	\N	63303	63303	50156
15705	19645	0	applied	\N	\N	\N	\N	63311	63311	63312
15705	19646	1	applied	\N	\N	\N	\N	63313	63313	50154
15705	19643	2	applied	\N	\N	\N	\N	63305	63305	63314
15705	19647	3	applied	\N	\N	\N	\N	63315	63315	50158
15705	19644	4	applied	\N	\N	\N	\N	63307	63307	63316
15705	19648	5	applied	\N	\N	\N	\N	63317	63317	50170
15713	19665	0	applied	\N	\N	\N	\N	63356	63356	63357
15713	19666	1	applied	\N	\N	\N	\N	63358	63358	63359
15713	19667	2	applied	\N	\N	\N	\N	63360	63360	63361
15715	19668	0	applied	\N	\N	\N	\N	63367	63367	63368
15715	19669	1	applied	\N	\N	\N	\N	63369	63369	50225
15715	19670	2	applied	\N	\N	\N	\N	63370	63370	50237
15715	19671	3	applied	\N	\N	\N	\N	63371	63371	63372
15717	19419	0	applied	\N	\N	\N	\N	62703	62703	62704
15717	19422	1	applied	\N	\N	\N	\N	62713	62713	62714
15717	19423	2	applied	\N	\N	\N	\N	62718	62718	62719
15717	19424	3	applied	\N	\N	\N	\N	62720	62720	62721
15717	19425	4	applied	\N	\N	\N	\N	62724	62724	62725
15717	19426	5	applied	\N	\N	\N	\N	62726	62726	62727
15717	19427	6	applied	\N	\N	\N	\N	62730	62730	62731
15717	19428	7	applied	\N	\N	\N	\N	62732	62732	62733
15717	19429	8	applied	\N	\N	\N	\N	62734	62734	62735
15717	19430	9	applied	\N	\N	\N	\N	62738	62738	62739
15717	19431	10	applied	\N	\N	\N	\N	62742	62742	62743
15717	19434	11	applied	\N	\N	\N	\N	62748	62748	62749
15717	19435	12	applied	\N	\N	\N	\N	62752	62752	62753
15717	19436	13	applied	\N	\N	\N	\N	62757	62757	62758
15717	19437	14	applied	\N	\N	\N	\N	62761	62761	62762
15717	19438	15	applied	\N	\N	\N	\N	62763	62763	62764
15717	19440	17	applied	\N	\N	\N	\N	62768	62768	62769
15717	19441	18	applied	\N	\N	\N	\N	62770	62770	62771
15717	19442	19	applied	\N	\N	\N	\N	62772	62772	62773
15717	19443	20	applied	\N	\N	\N	\N	62774	62774	62775
15717	19444	21	applied	\N	\N	\N	\N	62776	62776	62777
15717	19447	22	applied	\N	\N	\N	\N	62784	62784	62785
15717	19448	23	applied	\N	\N	\N	\N	62790	62790	62791
15717	19450	24	applied	\N	\N	\N	\N	62797	62797	62798
15717	19451	25	applied	\N	\N	\N	\N	62799	62799	62800
15717	19454	26	applied	\N	\N	\N	\N	62807	62807	62808
15717	19456	27	applied	\N	\N	\N	\N	62812	62812	62813
15717	19457	28	applied	\N	\N	\N	\N	62814	62814	62815
15717	19458	29	applied	\N	\N	\N	\N	62816	62816	62817
15717	19462	30	applied	\N	\N	\N	\N	62828	62828	62829
15717	19463	31	applied	\N	\N	\N	\N	62830	62830	62831
15717	19470	32	applied	\N	\N	\N	\N	62853	62853	62854
15717	19472	33	applied	\N	\N	\N	\N	62859	62859	62860
15717	19474	34	applied	\N	\N	\N	\N	62866	62866	62867
15717	19476	35	applied	\N	\N	\N	\N	62876	62876	62877
15717	19478	36	applied	\N	\N	\N	\N	62884	62884	62885
15717	19480	37	applied	\N	\N	\N	\N	62892	62892	62893
15717	19481	38	applied	\N	\N	\N	\N	62894	62894	62895
15717	19482	39	applied	\N	\N	\N	\N	62896	62896	62897
15717	19487	40	applied	\N	\N	\N	\N	62906	62906	62907
15717	19490	41	applied	\N	\N	\N	\N	62916	62916	62917
15717	19492	42	applied	\N	\N	\N	\N	62920	62920	62921
15717	19494	43	applied	\N	\N	\N	\N	62926	62926	62927
15717	19496	44	applied	\N	\N	\N	\N	62931	62931	62932
15717	19497	45	applied	\N	\N	\N	\N	62933	62933	62934
15717	19501	46	applied	\N	\N	\N	\N	62943	62943	62944
15717	19503	47	applied	\N	\N	\N	\N	62949	62949	62950
15717	19507	48	applied	\N	\N	\N	\N	62958	62958	62959
15717	19508	49	applied	\N	\N	\N	\N	62960	62960	62961
15717	19513	50	applied	\N	\N	\N	\N	62969	62969	62970
15710	19658	3	applied	\N	\N	\N	\N	63341	63341	50195
15710	19659	4	applied	\N	\N	\N	\N	63342	63342	63343
15710	19660	5	applied	\N	\N	\N	\N	63344	63344	63345
15710	19661	6	applied	\N	\N	\N	\N	63346	63346	50201
15710	19662	7	applied	\N	\N	\N	\N	63347	63347	50205
15710	19663	8	applied	\N	\N	\N	\N	63348	63348	50207
15710	19664	9	applied	\N	\N	\N	\N	63349	63349	50215
15712	19665	0	applied	\N	\N	\N	\N	63356	63356	63357
15712	19666	1	applied	\N	\N	\N	\N	63358	63358	63359
15712	19667	2	applied	\N	\N	\N	\N	63360	63360	63361
15714	19665	0	applied	\N	\N	\N	\N	63356	63356	63357
15714	19666	1	applied	\N	\N	\N	\N	63358	63358	63359
15714	19667	2	applied	\N	\N	\N	\N	63360	63360	63361
15719	19672	0	applied	\N	\N	\N	\N	63435	63435	63436
15719	19673	1	applied	\N	\N	\N	\N	63437	63437	63438
15719	19674	2	applied	\N	\N	\N	\N	63439	63439	63440
15719	19675	3	applied	\N	\N	\N	\N	63441	63441	63442
15719	19676	4	applied	\N	\N	\N	\N	63443	63443	63444
15719	19677	5	applied	\N	\N	\N	\N	63445	63445	50255
15719	19678	6	applied	\N	\N	\N	\N	63446	63446	50257
15719	19679	7	applied	\N	\N	\N	\N	63447	63447	50261
15719	19680	8	applied	\N	\N	\N	\N	63448	63448	50263
15719	19681	9	applied	\N	\N	\N	\N	63449	63449	50267
15726	19691	0	applied	\N	\N	\N	\N	63477	63477	63478
15726	19692	1	applied	\N	\N	\N	\N	63479	63479	50293
15726	19693	2	applied	\N	\N	\N	\N	63480	63480	63481
15726	19694	3	applied	\N	\N	\N	\N	63482	63482	50302
15731	19701	0	applied	\N	\N	\N	\N	63501	63501	63502
15731	19702	1	applied	\N	\N	\N	\N	63503	63503	63504
15731	19703	2	applied	\N	\N	\N	\N	63505	63505	63506
15731	19704	3	applied	\N	\N	\N	\N	63507	63507	50331
15731	19705	4	applied	\N	\N	\N	\N	63508	63508	50342
15731	19706	5	applied	\N	\N	\N	\N	63509	63509	50350
15731	19707	6	applied	\N	\N	\N	\N	63510	63510	50352
15734	19719	0	applied	\N	\N	\N	\N	63535	63535	63536
15734	19720	1	applied	\N	\N	\N	\N	63537	63537	50402
15734	19721	2	applied	\N	\N	\N	\N	63538	63538	50410
15739	19733	0	applied	\N	\N	1000000000	\N	63566	63566	63567
15739	19734	1	applied	\N	\N	\N	\N	63568	63568	63569
15742	19743	0	applied	\N	\N	\N	\N	63586	63586	63587
15742	19744	1	applied	\N	\N	\N	\N	63588	63588	63589
15742	19745	2	applied	\N	\N	\N	\N	63590	63590	63591
15744	19746	0	applied	\N	\N	\N	\N	63594	63594	63595
15744	19747	1	applied	\N	\N	\N	\N	63596	63596	63597
15744	19748	2	applied	\N	\N	\N	\N	63598	63598	50503
15744	19749	3	applied	\N	\N	\N	\N	63599	63599	63600
15758	19791	0	applied	\N	\N	\N	\N	63682	63682	63683
15758	19792	1	applied	\N	\N	\N	\N	63684	63684	63685
15758	19793	2	applied	\N	\N	\N	\N	63686	63686	50689
15760	19794	0	applied	\N	\N	\N	\N	63690	63690	63691
15760	19795	1	applied	\N	\N	\N	\N	63692	63692	50699
15760	19796	2	applied	\N	\N	\N	\N	63693	63693	50707
15760	19797	3	applied	\N	\N	\N	\N	63694	63694	50709
15763	19807	0	applied	\N	\N	\N	\N	63712	63712	63713
15763	19808	1	applied	\N	\N	\N	\N	63714	63714	50751
15763	19809	2	applied	\N	\N	\N	\N	63715	63715	50759
15765	19813	0	applied	\N	\N	\N	\N	63723	63723	63724
15765	19814	1	applied	\N	\N	\N	\N	63725	63725	50778
15765	19815	2	applied	\N	\N	\N	\N	63726	63726	50790
15765	19816	3	applied	\N	\N	\N	\N	63727	63727	50792
15770	19827	0	applied	\N	\N	\N	\N	63751	63751	63752
15770	19828	1	applied	\N	\N	\N	\N	63753	63753	63754
15770	19829	2	applied	\N	\N	\N	\N	63755	63755	63756
15770	19830	3	applied	\N	\N	\N	\N	63757	63757	50846
15770	19831	4	applied	\N	\N	\N	\N	63758	63758	50857
15776	19853	0	applied	\N	\N	\N	\N	63800	63800	63801
15776	19854	1	applied	\N	\N	\N	\N	63802	63802	50956
15776	19848	2	applied	\N	\N	\N	\N	63792	63792	50962
15776	19849	3	applied	\N	\N	\N	\N	63793	63793	63803
15776	19850	4	applied	\N	\N	\N	\N	63795	63795	50978
15776	19851	5	applied	\N	\N	\N	\N	63796	63796	50980
15776	19852	6	applied	\N	\N	\N	\N	63797	63797	63804
15776	19855	7	applied	\N	\N	\N	\N	63805	63805	50986
15778	19856	0	applied	\N	\N	\N	\N	63809	63809	63810
15785	19866	0	applied	\N	\N	\N	\N	63837	63837	63838
15785	19867	1	applied	\N	\N	\N	\N	63839	63839	63840
15785	19868	2	applied	\N	\N	\N	\N	63841	63841	63842
15785	19869	3	applied	\N	\N	\N	\N	63843	63843	63844
15785	19870	4	applied	\N	\N	\N	\N	63845	63845	51032
15785	19871	5	applied	\N	\N	\N	\N	63846	63846	51034
15791	19892	0	applied	\N	\N	\N	\N	63892	63892	63893
15791	19893	1	applied	\N	\N	\N	\N	63894	63894	51098
15791	19894	2	applied	\N	\N	\N	\N	63895	63895	63896
15793	19895	0	applied	\N	\N	\N	\N	63899	63899	63900
15793	19896	1	applied	\N	\N	\N	\N	63901	63901	51102
15793	19897	2	applied	\N	\N	\N	\N	63902	63902	63903
15793	19898	3	applied	\N	\N	\N	\N	63904	63904	63905
15796	19909	0	applied	\N	\N	\N	\N	63931	63931	63932
15796	19910	1	applied	\N	\N	\N	\N	63933	63933	63934
15796	19911	2	applied	\N	\N	\N	\N	63935	63935	63936
15796	19912	3	applied	\N	\N	\N	\N	63937	63937	63938
15796	19913	4	applied	\N	\N	\N	\N	63939	63939	63940
15796	19914	5	applied	\N	\N	\N	\N	63941	63941	51144
15796	19915	7	applied	\N	\N	\N	\N	63943	63943	51148
15796	19916	8	applied	\N	\N	\N	\N	63944	63944	63945
15796	19917	9	applied	\N	\N	\N	\N	63946	63946	51152
15796	19918	10	applied	\N	\N	\N	\N	63947	63947	51154
15796	19919	11	applied	\N	\N	\N	\N	63948	63948	63949
15796	19920	12	applied	\N	\N	\N	\N	63950	63950	51158
15796	19921	13	applied	\N	\N	\N	\N	63951	63951	63952
15796	19922	14	applied	\N	\N	\N	\N	63953	63953	51164
15796	19923	15	applied	\N	\N	\N	\N	63954	63954	63955
15796	19924	16	applied	\N	\N	\N	\N	63956	63956	51170
15801	19934	0	applied	\N	\N	\N	\N	63978	63978	63979
15801	19935	1	applied	\N	\N	\N	\N	63980	63980	63981
15801	19936	2	applied	\N	\N	\N	\N	63982	63982	63983
15804	19942	0	applied	\N	\N	\N	\N	63995	63995	63996
15804	19944	1	applied	\N	\N	\N	\N	64001	64001	64002
15804	19943	2	applied	\N	\N	\N	\N	63997	63997	51218
15806	19949	0	applied	\N	\N	\N	\N	64011	64011	64012
15806	19950	1	applied	\N	\N	\N	\N	64013	64013	51232
15806	19951	2	applied	\N	\N	\N	\N	64014	64014	51234
15811	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15811	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15811	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15811	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15811	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15811	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15811	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15811	19963	7	applied	\N	\N	\N	\N	64046	64046	51253
15717	19517	51	applied	\N	\N	\N	\N	62977	62977	62978
15717	19520	52	applied	\N	\N	\N	\N	62985	62985	62986
15717	19523	53	applied	\N	\N	\N	\N	62990	62990	62991
15717	19526	54	applied	\N	\N	\N	\N	63001	63001	63002
15717	19530	55	applied	\N	\N	\N	\N	63024	63024	63025
15717	19533	56	applied	\N	\N	\N	\N	63034	63034	63035
15717	19535	57	applied	\N	\N	\N	\N	63038	63038	63039
15717	19539	58	applied	\N	\N	\N	\N	63051	63051	63052
15717	19540	59	applied	\N	\N	\N	\N	63053	63053	63054
15717	19545	60	applied	\N	\N	\N	\N	63062	63062	63063
15717	19549	61	applied	\N	\N	\N	\N	63072	63072	63073
15717	19550	62	applied	\N	\N	\N	\N	63074	63074	63075
15717	19555	63	applied	\N	\N	\N	\N	63086	63086	63087
15717	19558	64	applied	\N	\N	\N	\N	63097	63097	63098
15717	19562	65	applied	\N	\N	\N	\N	63105	63105	63106
15717	19565	66	applied	\N	\N	\N	\N	63115	63115	63116
15717	19566	67	applied	\N	\N	\N	\N	63117	63117	63118
15717	19572	68	applied	\N	\N	\N	\N	63129	63129	63130
15717	19575	69	applied	\N	\N	\N	\N	63135	63135	63136
15717	19578	70	applied	\N	\N	\N	\N	63142	63142	63143
15717	19582	71	applied	\N	\N	\N	\N	63151	63151	63152
15717	19583	72	applied	\N	\N	\N	\N	63153	63153	63154
15717	19588	73	applied	\N	\N	\N	\N	63161	63161	63162
15717	19591	74	applied	\N	\N	\N	\N	63169	63169	63170
15717	19595	75	applied	\N	\N	\N	\N	63178	63178	63179
15717	19596	76	applied	\N	\N	\N	\N	63180	63180	63181
15717	19601	77	applied	\N	\N	\N	\N	63196	63196	63197
15717	19602	78	applied	\N	\N	\N	\N	63198	63198	63199
15717	19608	79	applied	\N	\N	\N	\N	63214	63214	63215
15717	19611	80	applied	\N	\N	\N	\N	63221	63221	63222
15717	19615	81	applied	\N	\N	\N	\N	63232	63232	63233
15717	19618	82	applied	\N	\N	\N	\N	63240	63240	63241
15717	19621	83	applied	\N	\N	\N	\N	63254	63254	63255
15717	19622	84	applied	\N	\N	\N	\N	63256	63256	63257
15717	19628	85	applied	\N	\N	\N	\N	63271	63271	63272
15717	19631	86	applied	\N	\N	\N	\N	63276	63276	63277
15717	19634	87	applied	\N	\N	\N	\N	63281	63281	63282
15717	19638	88	applied	\N	\N	\N	\N	63292	63292	63293
15717	19639	89	applied	\N	\N	\N	\N	63295	63295	63296
15717	19645	90	applied	\N	\N	\N	\N	63311	63311	63312
15717	19649	91	applied	\N	\N	\N	\N	63324	63324	63325
15717	19652	92	applied	\N	\N	\N	\N	63328	63328	63329
15717	19655	93	applied	\N	\N	\N	\N	63335	63335	63336
15717	19656	94	applied	\N	\N	\N	\N	63337	63337	63338
15717	19657	95	applied	\N	\N	\N	\N	63339	63339	63340
15717	19665	96	applied	\N	\N	\N	\N	63356	63356	63357
15717	19668	97	applied	\N	\N	\N	\N	63367	63367	63368
15717	19432	98	applied	\N	\N	\N	\N	63377	63377	63378
15717	19151	99	applied	\N	\N	\N	\N	63379	63379	63380
15717	19153	100	applied	\N	\N	\N	\N	63381	63381	63382
15717	19154	101	applied	\N	\N	\N	\N	63383	63383	63384
15717	19158	102	applied	\N	\N	\N	\N	63385	63385	63386
15717	19159	103	applied	\N	\N	\N	\N	63387	63387	63388
15717	19160	104	applied	\N	\N	\N	\N	63389	63389	63390
15717	19161	105	applied	\N	\N	\N	\N	63391	63391	63392
15717	19165	106	applied	\N	\N	\N	\N	63393	63393	63394
15717	19167	107	applied	\N	\N	\N	\N	63395	63395	63396
15717	19171	108	applied	\N	\N	\N	\N	63397	63397	63398
15717	19173	109	applied	\N	\N	\N	\N	63399	63399	63400
15717	19174	110	applied	\N	\N	\N	\N	63401	63401	63402
15717	19176	111	applied	\N	\N	\N	\N	63403	63403	63404
15717	19177	112	applied	\N	\N	\N	\N	63405	63405	63406
15717	19180	113	applied	\N	\N	\N	\N	63407	63407	63408
15717	19181	114	applied	\N	\N	\N	\N	63409	63409	63410
15717	19183	115	applied	\N	\N	\N	\N	63411	63411	63412
15717	19185	116	applied	\N	\N	\N	\N	63413	63413	63414
15717	19186	117	applied	\N	\N	\N	\N	63415	63415	63416
15717	19188	118	applied	\N	\N	\N	\N	63417	63417	63418
15717	19190	119	applied	\N	\N	\N	\N	63419	63419	63420
15717	19192	120	applied	\N	\N	\N	\N	63421	63421	63422
15717	19193	121	applied	\N	\N	\N	\N	63423	63423	63424
15717	19197	122	applied	\N	\N	\N	\N	63425	63425	63426
15717	19198	123	applied	\N	\N	\N	\N	63427	63427	63428
15717	19199	124	applied	\N	\N	\N	\N	63429	63429	63430
15717	19200	125	applied	\N	\N	\N	\N	63431	63431	63432
15720	19682	0	applied	\N	\N	\N	\N	63452	63452	63453
15720	19683	1	applied	\N	\N	\N	\N	63454	63454	50269
15720	19684	2	applied	\N	\N	\N	\N	63455	63455	63456
15722	19685	0	applied	\N	\N	\N	\N	63459	63459	63460
15722	19686	1	applied	\N	\N	\N	\N	63461	63461	63462
15722	19687	2	applied	\N	\N	\N	\N	63463	63463	50285
15725	19688	0	applied	\N	\N	\N	\N	63468	63468	63469
15725	19689	1	applied	\N	\N	\N	\N	63470	63470	63471
15725	19690	2	applied	\N	\N	\N	\N	63472	63472	50289
15727	19691	0	applied	\N	\N	\N	\N	63477	63477	63478
15727	19692	1	applied	\N	\N	\N	\N	63479	63479	50293
15727	19693	2	applied	\N	\N	\N	\N	63480	63480	63481
15727	19694	3	applied	\N	\N	\N	\N	63482	63482	50302
15729	19698	0	applied	\N	\N	\N	\N	63494	63494	63495
15729	19699	1	applied	\N	\N	\N	\N	63496	63496	50318
15729	19700	2	applied	\N	\N	\N	\N	63497	63497	63498
15732	19708	0	applied	\N	\N	\N	\N	63512	63512	63513
15732	19709	1	applied	\N	\N	\N	\N	63514	63514	63515
15732	19710	2	applied	\N	\N	\N	\N	63516	63516	63517
15732	19711	3	applied	\N	\N	\N	\N	63518	63518	50358
15732	19712	4	applied	\N	\N	\N	\N	63519	63519	63520
15732	19713	5	applied	\N	\N	1000000000	\N	63521	63521	63522
15732	19714	6	applied	\N	\N	\N	\N	63523	63523	63524
15732	19715	7	applied	\N	\N	\N	\N	63525	63525	63526
15740	19736	0	applied	\N	\N	\N	\N	63573	63573	63574
15740	19737	1	applied	\N	\N	\N	\N	63575	63575	63576
15740	19738	2	applied	\N	\N	\N	\N	63577	63577	50471
15740	19739	3	applied	\N	\N	\N	\N	63578	63578	50473
15740	19740	4	applied	\N	\N	\N	\N	63579	63579	50477
15740	19741	5	applied	\N	\N	\N	\N	63580	63580	63581
15740	19742	6	applied	\N	\N	\N	\N	63582	63582	50481
15745	19733	0	applied	\N	\N	1000000000	\N	63566	63566	63567
15745	19750	1	applied	\N	\N	\N	\N	63603	63603	63604
15745	19713	2	applied	\N	\N	1000000000	\N	63521	63521	63522
15745	19726	3	applied	\N	\N	\N	\N	63548	63548	63549
15747	19750	0	applied	\N	\N	\N	\N	63603	63603	63604
15747	19751	1	applied	\N	\N	\N	\N	63607	63607	63608
15747	19752	2	applied	\N	\N	\N	\N	63609	63609	63610
15747	19753	3	applied	\N	\N	\N	\N	63611	63611	50507
15747	19754	4	applied	\N	\N	\N	\N	63612	63612	50519
15747	19755	5	applied	\N	\N	\N	\N	63613	63613	50523
15747	19756	6	applied	\N	\N	\N	\N	63614	63614	50527
15748	19757	0	applied	\N	\N	\N	\N	63618	63618	63603
15748	19758	1	applied	\N	\N	\N	\N	63619	63619	63620
15721	19687	2	applied	\N	\N	\N	\N	63463	63463	50285
15724	19688	0	applied	\N	\N	\N	\N	63468	63468	63469
15724	19689	1	applied	\N	\N	\N	\N	63470	63470	63471
15724	19690	2	applied	\N	\N	\N	\N	63472	63472	50289
15728	19695	0	applied	\N	\N	\N	\N	63486	63486	63487
15728	19696	1	applied	\N	\N	\N	\N	63488	63488	63489
15728	19697	2	applied	\N	\N	\N	\N	63490	63490	63491
15737	19722	0	applied	\N	\N	\N	\N	63541	63541	63542
15737	19723	1	applied	\N	\N	\N	\N	63543	63543	63544
15737	19724	2	applied	\N	\N	\N	\N	63545	63545	63546
15737	19725	3	applied	\N	\N	\N	\N	63547	63547	50420
15737	19726	4	applied	\N	\N	\N	\N	63548	63548	63549
15737	19727	5	applied	\N	\N	\N	\N	63550	63550	63551
15737	19728	6	applied	\N	\N	\N	\N	63552	63552	50424
15737	19729	7	applied	\N	\N	\N	\N	63553	63553	63554
15737	19730	9	applied	\N	\N	\N	\N	63556	63556	63557
15737	19731	10	applied	\N	\N	\N	\N	63558	63558	50436
15737	19732	11	applied	\N	\N	\N	\N	63559	63559	63560
15741	19736	0	applied	\N	\N	\N	\N	63573	63573	63574
15741	19737	1	applied	\N	\N	\N	\N	63575	63575	63576
15741	19738	2	applied	\N	\N	\N	\N	63577	63577	50471
15741	19739	3	applied	\N	\N	\N	\N	63578	63578	50473
15741	19740	4	applied	\N	\N	\N	\N	63579	63579	50477
15741	19741	5	applied	\N	\N	\N	\N	63580	63580	63581
15741	19742	6	applied	\N	\N	\N	\N	63582	63582	50481
15746	19750	0	applied	\N	\N	\N	\N	63603	63603	63604
15746	19751	1	applied	\N	\N	\N	\N	63607	63607	63608
15746	19752	2	applied	\N	\N	\N	\N	63609	63609	63610
15746	19753	3	applied	\N	\N	\N	\N	63611	63611	50507
15746	19754	4	applied	\N	\N	\N	\N	63612	63612	50519
15746	19755	5	applied	\N	\N	\N	\N	63613	63613	50523
15746	19756	6	applied	\N	\N	\N	\N	63614	63614	50527
15752	19778	0	applied	\N	\N	\N	\N	63653	63653	63654
15752	19779	1	applied	\N	\N	\N	\N	63655	63655	63656
15752	19780	2	applied	\N	\N	\N	\N	63657	63657	63658
15752	19781	3	applied	\N	\N	\N	\N	63659	63659	63660
15752	19782	4	applied	\N	\N	\N	\N	63661	63661	50640
15752	19783	5	applied	\N	\N	\N	\N	63662	63662	63663
15752	19784	6	applied	\N	\N	\N	\N	63664	63664	50648
15754	19778	0	applied	\N	\N	\N	\N	63653	63653	63654
15754	19779	1	applied	\N	\N	\N	\N	63655	63655	63656
15754	19780	2	applied	\N	\N	\N	\N	63657	63657	63658
15754	19781	3	applied	\N	\N	\N	\N	63659	63659	63660
15754	19782	4	applied	\N	\N	\N	\N	63661	63661	50640
15754	19783	5	applied	\N	\N	\N	\N	63662	63662	63663
15754	19784	6	applied	\N	\N	\N	\N	63664	63664	50648
15757	19791	0	applied	\N	\N	\N	\N	63682	63682	63683
15757	19792	1	applied	\N	\N	\N	\N	63684	63684	63685
15757	19793	2	applied	\N	\N	\N	\N	63686	63686	50689
15759	19794	0	applied	\N	\N	\N	\N	63690	63690	63691
15759	19795	1	applied	\N	\N	\N	\N	63692	63692	50699
15759	19796	2	applied	\N	\N	\N	\N	63693	63693	50707
15759	19797	3	applied	\N	\N	\N	\N	63694	63694	50709
15762	19807	0	applied	\N	\N	\N	\N	63712	63712	63713
15762	19808	1	applied	\N	\N	\N	\N	63714	63714	50751
15762	19809	2	applied	\N	\N	\N	\N	63715	63715	50759
15767	19817	0	applied	\N	\N	\N	\N	63730	63730	10497
15767	19818	1	applied	\N	\N	\N	\N	63731	63731	63732
15767	19819	2	applied	\N	\N	\N	\N	63733	63733	63734
15767	19820	3	applied	\N	\N	\N	\N	63735	63735	63736
15767	19821	4	applied	\N	\N	\N	\N	63737	63737	50806
15767	19822	5	applied	\N	\N	\N	\N	63738	63738	50817
15767	19823	6	applied	\N	\N	\N	\N	63739	63739	50823
15775	19845	0	applied	\N	\N	\N	\N	63786	63786	63787
15775	19846	1	applied	\N	\N	\N	\N	63788	63788	50936
15775	19847	2	applied	\N	\N	\N	\N	63789	63789	50938
15775	19848	3	applied	\N	\N	\N	\N	63792	63792	50954
15775	19849	4	applied	\N	\N	\N	\N	63793	63793	63794
15775	19850	5	applied	\N	\N	\N	\N	63795	63795	50964
15775	19851	6	applied	\N	\N	\N	\N	63796	63796	50976
15775	19852	7	applied	\N	\N	\N	\N	63797	63797	63798
15780	19859	0	applied	\N	\N	\N	\N	63817	63817	63818
15780	19860	1	applied	\N	\N	\N	\N	63819	63819	51007
15780	19861	2	applied	\N	\N	\N	\N	63820	63820	63821
15782	19862	0	applied	\N	\N	\N	\N	63826	63826	63827
15782	19863	1	applied	\N	\N	\N	\N	63828	63828	63829
15782	19864	2	applied	\N	\N	\N	\N	63830	63830	51021
15782	19865	3	applied	\N	\N	\N	\N	63831	63831	63832
15784	19862	0	applied	\N	\N	\N	\N	63826	63826	63827
15784	19863	1	applied	\N	\N	\N	\N	63828	63828	63829
15784	19864	2	applied	\N	\N	\N	\N	63830	63830	51021
15788	19882	0	applied	\N	\N	\N	\N	63869	63869	63870
15788	19883	1	applied	\N	\N	\N	\N	63871	63871	63872
15788	19884	2	applied	\N	\N	\N	\N	63873	63873	63874
15788	19885	3	applied	\N	\N	\N	\N	63875	63875	63876
15788	19886	4	applied	\N	\N	\N	\N	63877	63877	63878
15790	19887	0	applied	\N	\N	\N	\N	63882	63882	63883
15790	19888	1	applied	\N	\N	\N	\N	63884	63884	63885
15790	19889	2	applied	\N	\N	\N	\N	63886	63886	51081
15790	19890	3	applied	\N	\N	\N	\N	63887	63887	51089
15790	19891	4	applied	\N	\N	\N	\N	63888	63888	63889
15795	19905	0	applied	\N	\N	\N	\N	63922	63922	63923
15795	19906	1	applied	\N	\N	\N	\N	63924	63924	63925
15795	19907	2	applied	\N	\N	\N	\N	63926	63926	63927
15795	19908	3	applied	\N	\N	\N	\N	63928	63928	63929
15803	19942	0	applied	\N	\N	\N	\N	63995	63995	63996
15803	19943	1	applied	\N	\N	\N	\N	63997	63997	63998
15808	19733	0	applied	\N	\N	1000000000	\N	63566	63566	63567
15808	19817	1	applied	\N	\N	\N	\N	63730	63730	10497
15808	19934	2	applied	\N	\N	\N	\N	63978	63978	63979
15808	19750	3	applied	\N	\N	\N	\N	63603	63603	63604
15808	19946	4	applied	\N	\N	\N	\N	64005	64005	64020
15808	19828	5	applied	\N	\N	\N	\N	63753	63753	63754
15808	19840	6	applied	\N	\N	\N	\N	63777	63777	63778
15808	19713	7	applied	\N	\N	1000000000	\N	63521	63521	63522
15808	19726	8	applied	\N	\N	\N	\N	63548	63548	63549
15817	19970	0	applied	\N	\N	\N	\N	64062	64062	64063
15817	19971	1	applied	\N	\N	\N	\N	64064	64064	64065
15817	19972	2	applied	\N	\N	\N	\N	64066	64066	64067
15817	19973	3	applied	\N	\N	\N	\N	64068	64068	64069
15817	19974	4	applied	\N	\N	\N	\N	64070	64070	64071
15817	19975	5	applied	\N	\N	\N	\N	64072	64072	64073
15817	19976	6	applied	\N	\N	\N	\N	64074	64074	64075
15817	19977	7	applied	\N	\N	\N	\N	64076	64076	64077
15817	19978	8	applied	\N	\N	\N	\N	64078	64078	64079
15817	19979	9	applied	\N	\N	\N	\N	64080	64080	64081
15817	19980	10	applied	\N	\N	\N	\N	64082	64082	64083
15817	19981	11	applied	\N	\N	\N	\N	64084	64084	64085
15817	19982	12	applied	\N	\N	\N	\N	64086	64086	64087
15748	19759	2	applied	\N	\N	\N	\N	63621	63621	63622
15748	19760	3	applied	\N	\N	\N	\N	63623	63623	63624
15748	19761	4	applied	\N	\N	\N	\N	63625	63625	63626
15748	19762	5	applied	\N	\N	\N	\N	63627	63627	50529
15748	19763	6	applied	\N	\N	\N	\N	63628	63628	50541
15748	19764	7	applied	\N	\N	\N	\N	63629	63629	50543
15748	19765	8	applied	\N	\N	\N	\N	63630	63630	63631
15748	19766	9	applied	\N	\N	\N	\N	63632	63632	50550
15748	19767	10	applied	\N	\N	\N	\N	63633	63633	50562
15748	19768	11	applied	\N	\N	\N	\N	63634	63634	50566
15748	19769	12	applied	\N	\N	\N	\N	63635	63635	50581
15748	19770	13	applied	\N	\N	\N	\N	63636	63636	50592
15750	19757	0	applied	\N	\N	\N	\N	63618	63618	63603
15750	19758	1	applied	\N	\N	\N	\N	63619	63619	63620
15750	19759	2	applied	\N	\N	\N	\N	63621	63621	63622
15750	19760	3	applied	\N	\N	\N	\N	63623	63623	63624
15750	19761	4	applied	\N	\N	\N	\N	63625	63625	63626
15750	19762	5	applied	\N	\N	\N	\N	63627	63627	50529
15750	19763	6	applied	\N	\N	\N	\N	63628	63628	50541
15750	19764	7	applied	\N	\N	\N	\N	63629	63629	50543
15750	19765	8	applied	\N	\N	\N	\N	63630	63630	63631
15750	19766	9	applied	\N	\N	\N	\N	63632	63632	50550
15750	19767	10	applied	\N	\N	\N	\N	63633	63633	50562
15750	19768	11	applied	\N	\N	\N	\N	63634	63634	50566
15750	19769	12	applied	\N	\N	\N	\N	63635	63635	50581
15750	19770	13	applied	\N	\N	\N	\N	63636	63636	50592
15753	19778	0	applied	\N	\N	\N	\N	63653	63653	63654
15753	19779	1	applied	\N	\N	\N	\N	63655	63655	63656
15753	19780	2	applied	\N	\N	\N	\N	63657	63657	63658
15753	19781	3	applied	\N	\N	\N	\N	63659	63659	63660
15753	19782	4	applied	\N	\N	\N	\N	63661	63661	50640
15753	19783	5	applied	\N	\N	\N	\N	63662	63662	63663
15753	19784	6	applied	\N	\N	\N	\N	63664	63664	50648
15755	19778	0	applied	\N	\N	\N	\N	63653	63653	63654
15755	19779	1	applied	\N	\N	\N	\N	63655	63655	63656
15755	19780	2	applied	\N	\N	\N	\N	63657	63657	63658
15755	19781	3	applied	\N	\N	\N	\N	63659	63659	63660
15755	19782	4	applied	\N	\N	\N	\N	63661	63661	50640
15755	19783	5	applied	\N	\N	\N	\N	63662	63662	63663
15755	19784	6	applied	\N	\N	\N	\N	63664	63664	50648
15755	19785	7	applied	\N	\N	\N	\N	63670	63670	50662
15761	19798	0	applied	\N	\N	\N	\N	63697	63697	63698
15761	19799	1	applied	\N	\N	\N	\N	63699	63699	63700
15761	19800	2	applied	\N	\N	\N	\N	63701	63701	63702
15761	19801	3	applied	\N	\N	\N	\N	63703	63703	50711
15761	19802	4	applied	\N	\N	\N	\N	63704	63704	50713
15761	19803	5	applied	\N	\N	\N	\N	63705	63705	50724
15761	19804	6	applied	\N	\N	\N	\N	63706	63706	50731
15761	19805	7	applied	\N	\N	\N	\N	63707	63707	50737
15761	19806	8	applied	\N	\N	\N	\N	63708	63708	63709
15766	19817	0	applied	\N	\N	\N	\N	63730	63730	10497
15766	19818	1	applied	\N	\N	\N	\N	63731	63731	63732
15766	19819	2	applied	\N	\N	\N	\N	63733	63733	63734
15766	19820	3	applied	\N	\N	\N	\N	63735	63735	63736
15766	19821	4	applied	\N	\N	\N	\N	63737	63737	50806
15766	19822	5	applied	\N	\N	\N	\N	63738	63738	50817
15766	19823	6	applied	\N	\N	\N	\N	63739	63739	50823
15768	19817	0	applied	\N	\N	\N	\N	63730	63730	10497
15768	19818	1	applied	\N	\N	\N	\N	63731	63731	63732
15768	19819	2	applied	\N	\N	\N	\N	63733	63733	63734
15768	19820	3	applied	\N	\N	\N	\N	63735	63735	63736
15768	19821	4	applied	\N	\N	\N	\N	63737	63737	50806
15768	19822	5	applied	\N	\N	\N	\N	63738	63738	50817
15768	19823	6	applied	\N	\N	\N	\N	63739	63739	50823
15771	19832	0	applied	\N	\N	\N	\N	63761	63761	63762
15771	19833	1	applied	\N	\N	\N	\N	63763	63763	50865
15771	19834	2	applied	\N	\N	\N	\N	63764	63764	63765
15772	19835	0	applied	\N	\N	\N	\N	63768	63768	63769
15772	19836	1	applied	\N	\N	\N	\N	63770	63770	63771
15772	19837	2	applied	\N	\N	\N	\N	63772	63772	63773
15772	19838	3	applied	\N	\N	\N	\N	63774	63774	63775
15772	19839	4	applied	\N	\N	\N	\N	63776	63776	50884
15772	19840	5	applied	\N	\N	\N	\N	63777	63777	63778
15772	19841	6	applied	\N	\N	\N	\N	63779	63779	50888
15772	19842	7	applied	\N	\N	\N	\N	63780	63780	50892
15772	19843	8	applied	\N	\N	\N	\N	63781	63781	50900
15772	19844	9	applied	\N	\N	\N	\N	63782	63782	50918
15774	19845	0	applied	\N	\N	\N	\N	63786	63786	63787
15774	19846	1	applied	\N	\N	\N	\N	63788	63788	50936
15774	19847	2	applied	\N	\N	\N	\N	63789	63789	50938
15781	19859	0	applied	\N	\N	\N	\N	63817	63817	63818
15781	19860	1	applied	\N	\N	\N	\N	63819	63819	51007
15781	19861	2	applied	\N	\N	\N	\N	63820	63820	63821
15783	19862	0	applied	\N	\N	\N	\N	63826	63826	63827
15783	19863	1	applied	\N	\N	\N	\N	63828	63828	63829
15783	19864	2	applied	\N	\N	\N	\N	63830	63830	51021
15783	19865	3	applied	\N	\N	\N	\N	63831	63831	63832
15786	19872	0	applied	\N	\N	\N	\N	63849	63849	63850
15786	19873	1	applied	\N	\N	\N	\N	63851	63851	63852
15786	19874	2	applied	\N	\N	\N	\N	63853	63853	51036
15786	19875	3	applied	\N	\N	\N	\N	63854	63854	51044
15789	19882	0	applied	\N	\N	\N	\N	63869	63869	63870
15789	19883	1	applied	\N	\N	\N	\N	63871	63871	63872
15789	19884	2	applied	\N	\N	\N	\N	63873	63873	63874
15797	19925	0	applied	\N	\N	\N	\N	63959	63959	63960
15797	19926	1	applied	\N	\N	\N	\N	63961	63961	63962
15797	19927	2	applied	\N	\N	\N	\N	63963	63963	51174
15799	19928	0	applied	\N	\N	\N	\N	63967	63967	63968
15799	19929	1	applied	\N	\N	\N	\N	63969	63969	51176
15799	19930	2	applied	\N	\N	\N	\N	63970	63970	63971
15802	19937	0	applied	\N	\N	\N	\N	63985	63985	63986
15802	19938	1	applied	\N	\N	\N	\N	63987	63987	51196
15802	19939	2	applied	\N	\N	\N	\N	63988	63988	63989
15802	19940	3	applied	\N	\N	\N	\N	63990	63990	63991
15802	19941	4	applied	\N	\N	\N	\N	63992	63992	63993
15807	19949	0	applied	\N	\N	\N	\N	64011	64011	64012
15807	19952	1	applied	\N	\N	\N	\N	64017	64017	51234
15807	19950	2	applied	\N	\N	\N	\N	64013	64013	64018
15807	19951	3	applied	\N	\N	\N	\N	64014	64014	51236
15812	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15812	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15812	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15812	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15812	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15812	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15812	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15812	19967	7	applied	\N	\N	\N	\N	64052	64052	64053
15812	19968	8	applied	\N	\N	\N	\N	64054	64054	64049
15812	19963	9	applied	\N	\N	\N	\N	64046	64046	51266
15812	19964	10	applied	\N	\N	\N	\N	64047	64047	51268
15749	19769	12	applied	\N	\N	\N	\N	63635	63635	50581
15749	19770	13	applied	\N	\N	\N	\N	63636	63636	50592
15751	19771	0	applied	\N	\N	\N	\N	63641	63641	63642
15751	19772	1	applied	\N	\N	\N	\N	63643	63643	63644
15751	19773	2	applied	\N	\N	\N	\N	63645	63645	50594
15751	19774	3	applied	\N	\N	\N	\N	63646	63646	50600
15751	19775	4	applied	\N	\N	\N	\N	63647	63647	50604
15751	19776	5	applied	\N	\N	\N	\N	63648	63648	50610
15751	19777	6	applied	\N	\N	\N	\N	63649	63649	63650
15756	19786	0	applied	\N	\N	\N	\N	63672	63672	63673
15756	19787	1	applied	\N	\N	\N	\N	63674	63674	63675
15756	19788	2	applied	\N	\N	\N	\N	63676	63676	50664
15756	19789	3	applied	\N	\N	\N	\N	63677	63677	50668
15756	19785	4	applied	\N	\N	\N	\N	63670	63670	50670
15756	19790	5	applied	\N	\N	\N	\N	63678	63678	63679
15764	19810	0	applied	\N	\N	\N	\N	63718	63718	63719
15764	19811	1	applied	\N	\N	\N	\N	63720	63720	50773
15764	19812	2	applied	\N	\N	\N	\N	63721	63721	50775
15769	19824	0	applied	\N	\N	\N	\N	63745	63745	63746
15769	19825	1	applied	\N	\N	\N	\N	63747	63747	50825
15769	19826	2	applied	\N	\N	\N	\N	63748	63748	50836
15773	19835	0	applied	\N	\N	\N	\N	63768	63768	63769
15773	19836	1	applied	\N	\N	\N	\N	63770	63770	63771
15773	19837	2	applied	\N	\N	\N	\N	63772	63772	63773
15773	19838	3	applied	\N	\N	\N	\N	63774	63774	63775
15773	19839	4	applied	\N	\N	\N	\N	63776	63776	50884
15773	19840	5	applied	\N	\N	\N	\N	63777	63777	63778
15773	19841	6	applied	\N	\N	\N	\N	63779	63779	50888
15773	19842	7	applied	\N	\N	\N	\N	63780	63780	50892
15773	19843	8	applied	\N	\N	\N	\N	63781	63781	50900
15773	19844	9	applied	\N	\N	\N	\N	63782	63782	50918
15777	19853	0	applied	\N	\N	\N	\N	63800	63800	63801
15777	19854	1	applied	\N	\N	\N	\N	63802	63802	50956
15777	19848	2	applied	\N	\N	\N	\N	63792	63792	50962
15777	19849	3	applied	\N	\N	\N	\N	63793	63793	63803
15777	19850	4	applied	\N	\N	\N	\N	63795	63795	50978
15777	19851	5	applied	\N	\N	\N	\N	63796	63796	50980
15777	19852	6	applied	\N	\N	\N	\N	63797	63797	63804
15777	19855	7	applied	\N	\N	\N	\N	63805	63805	50986
15779	19856	0	applied	\N	\N	\N	\N	63809	63809	63810
15779	19857	1	applied	\N	\N	\N	\N	63813	63813	50994
15779	19858	2	applied	\N	\N	\N	\N	63814	63814	51003
15787	19876	0	applied	\N	\N	\N	\N	63857	63857	63858
15787	19877	1	applied	\N	\N	\N	\N	63859	63859	63860
15787	19878	2	applied	\N	\N	\N	\N	63861	63861	63862
15787	19879	3	applied	\N	\N	\N	\N	63863	63863	51048
15787	19880	4	applied	\N	\N	\N	\N	63864	63864	63865
15787	19881	5	applied	\N	\N	\N	\N	63866	63866	51059
15792	19895	0	applied	\N	\N	\N	\N	63899	63899	63900
15792	19896	1	applied	\N	\N	\N	\N	63901	63901	51102
15792	19897	2	applied	\N	\N	\N	\N	63902	63902	63903
15792	19898	3	applied	\N	\N	\N	\N	63904	63904	63905
15794	19899	0	applied	\N	\N	\N	\N	63910	63910	63911
15794	19900	1	applied	\N	\N	\N	\N	63912	63912	63913
15794	19901	2	applied	\N	\N	\N	\N	63914	63914	63915
15794	19902	3	applied	\N	\N	\N	\N	63916	63916	51120
15794	19903	4	applied	\N	\N	\N	\N	63917	63917	51122
15794	19904	5	applied	\N	\N	\N	\N	63918	63918	63919
15798	19925	0	applied	\N	\N	\N	\N	63959	63959	63960
15798	19926	1	applied	\N	\N	\N	\N	63961	63961	63962
15798	19927	2	applied	\N	\N	\N	\N	63963	63963	51174
15800	19931	0	applied	\N	\N	\N	\N	63972	63972	63973
15800	19932	1	applied	\N	\N	\N	\N	63974	63974	51187
15800	19933	2	applied	\N	\N	\N	\N	63975	63975	51194
15805	19945	0	applied	\N	\N	\N	\N	64003	64003	64004
15805	19946	1	applied	\N	\N	\N	\N	64005	64005	64006
15805	19947	2	applied	\N	\N	\N	\N	64007	64007	51216
15805	19944	3	applied	\N	\N	\N	\N	64001	64001	51224
15805	19948	4	applied	\N	\N	\N	\N	64008	64008	51226
15809	19953	0	applied	\N	\N	\N	\N	64023	64023	64024
15809	19952	1	applied	\N	\N	\N	\N	64017	64017	51236
15809	19954	2	applied	\N	\N	\N	\N	64025	64025	64026
15809	19955	3	applied	\N	\N	\N	\N	64027	64027	64028
15813	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15813	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15813	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15813	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15813	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15813	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15813	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15813	19967	7	applied	\N	\N	\N	\N	64052	64052	64053
15813	19968	8	applied	\N	\N	\N	\N	64054	64054	64049
15813	19963	9	applied	\N	\N	\N	\N	64046	64046	51266
15813	19964	10	applied	\N	\N	\N	\N	64047	64047	51268
15813	19965	11	applied	\N	\N	\N	\N	64048	64048	64055
15813	19966	12	applied	\N	\N	\N	\N	64050	64050	51270
15813	19969	13	applied	\N	\N	\N	\N	64056	64056	51279
15814	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15814	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15814	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15814	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15814	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15814	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15814	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15814	19967	7	applied	\N	\N	\N	\N	64052	64052	64053
15814	19968	8	applied	\N	\N	\N	\N	64054	64054	64049
15814	19963	9	applied	\N	\N	\N	\N	64046	64046	51266
15814	19964	10	applied	\N	\N	\N	\N	64047	64047	51268
15814	19965	11	applied	\N	\N	\N	\N	64048	64048	64055
15814	19966	12	applied	\N	\N	\N	\N	64050	64050	51270
15814	19969	13	applied	\N	\N	\N	\N	64056	64056	51279
15825	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15825	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15825	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15825	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15825	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15825	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15825	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15825	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15825	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15825	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15825	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15825	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15825	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15825	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15825	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15825	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15825	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15825	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15825	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15811	19964	8	applied	\N	\N	\N	\N	64047	64047	51256
15811	19965	9	applied	\N	\N	\N	\N	64048	64048	64049
15811	19966	10	applied	\N	\N	\N	\N	64050	64050	51258
15815	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15815	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15815	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15815	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15815	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15815	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15815	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15815	19967	7	applied	\N	\N	\N	\N	64052	64052	64053
15815	19968	8	applied	\N	\N	\N	\N	64054	64054	64049
15815	19963	9	applied	\N	\N	\N	\N	64046	64046	51266
15815	19964	10	applied	\N	\N	\N	\N	64047	64047	51268
15815	19965	11	applied	\N	\N	\N	\N	64048	64048	64055
15815	19966	12	applied	\N	\N	\N	\N	64050	64050	51270
15815	19969	13	applied	\N	\N	\N	\N	64056	64056	51279
15821	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15821	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15821	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15821	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15821	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15821	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15821	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15821	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15821	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15821	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15821	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15821	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15821	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15821	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15821	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15821	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15821	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15821	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15821	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15826	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15826	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15826	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15826	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15826	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15826	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15826	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15826	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15826	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15826	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15826	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15826	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15826	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15826	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15826	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15826	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15826	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15826	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15826	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15828	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15828	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15828	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15828	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15828	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15828	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15828	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15828	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15828	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15828	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15828	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15828	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15828	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15828	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15828	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15828	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15828	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15828	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15828	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15830	20026	0	applied	\N	\N	\N	\N	64186	64186	64187
15830	20027	1	applied	\N	\N	\N	\N	64188	64188	64189
15830	20028	2	applied	\N	\N	\N	\N	64190	64190	64191
15830	20029	3	applied	\N	\N	\N	\N	64192	64192	64193
15830	20030	4	applied	\N	\N	\N	\N	64194	64194	51379
15832	20031	0	applied	\N	\N	\N	\N	64199	64199	64200
15832	20032	1	applied	\N	\N	\N	\N	64201	64201	64202
15832	20033	2	applied	\N	\N	\N	\N	64203	64203	64204
15832	20034	3	applied	\N	\N	\N	\N	64205	64205	64206
15832	20035	4	applied	\N	\N	\N	\N	64207	64207	64208
15834	20036	0	applied	\N	\N	\N	\N	64212	64212	64213
15834	20037	1	applied	\N	\N	\N	\N	64214	64214	64215
15834	20038	2	applied	\N	\N	\N	\N	64216	64216	64217
15834	20039	3	applied	\N	\N	\N	\N	64218	64218	64219
15834	20040	4	applied	\N	\N	\N	\N	64220	64220	51385
15834	20041	5	applied	\N	\N	\N	\N	64221	64221	64222
15834	20042	6	applied	\N	\N	\N	\N	64223	64223	64224
15838	20066	0	applied	\N	\N	\N	\N	64275	64275	64276
15838	20067	1	applied	\N	\N	\N	\N	64277	64277	64278
15844	20069	0	applied	\N	\N	\N	\N	64287	64287	64288
15844	20070	1	applied	\N	\N	\N	\N	64289	64289	51447
15844	20071	2	applied	\N	\N	\N	\N	64290	64290	64291
15844	20072	3	applied	\N	\N	\N	\N	64292	64292	64293
15849	20076	0	applied	\N	\N	\N	\N	64307	64307	64308
15849	20077	1	applied	\N	\N	\N	\N	64309	64309	64310
15849	20078	2	applied	\N	\N	\N	\N	64311	64311	64312
15849	20079	3	applied	\N	\N	\N	\N	64313	64313	64314
15849	20080	4	applied	\N	\N	\N	\N	64315	64315	64316
15849	20081	5	applied	\N	\N	\N	\N	64317	64317	51484
15849	20082	6	applied	\N	\N	\N	\N	64318	64318	51490
15849	20083	7	applied	\N	\N	\N	\N	64319	64319	51492
15849	20084	8	applied	\N	\N	\N	\N	64320	64320	64321
15849	20085	9	applied	\N	\N	\N	\N	64322	64322	51500
15851	20086	0	applied	\N	\N	1000000000	\N	64329	64329	64330
15851	20087	1	applied	\N	\N	\N	\N	64331	64331	64332
15851	20088	2	applied	\N	\N	\N	\N	64333	64333	64334
15851	20089	3	applied	\N	\N	\N	\N	64335	64335	64336
15858	20099	0	applied	\N	\N	\N	\N	64360	64360	64361
15858	20100	1	applied	\N	\N	\N	\N	64362	64362	64363
15858	20101	2	applied	\N	\N	\N	\N	64364	64364	64365
15861	20102	0	applied	\N	\N	\N	\N	64372	64372	64373
15861	20103	1	applied	\N	\N	\N	\N	64374	64374	64375
15861	20104	2	applied	\N	\N	\N	\N	64376	64376	51646
15861	20105	3	applied	\N	\N	\N	\N	64377	64377	51648
15861	20106	4	applied	\N	\N	\N	\N	64378	64378	64379
15861	20107	5	applied	\N	\N	\N	\N	64380	64380	51668
15812	19965	11	applied	\N	\N	\N	\N	64048	64048	64055
15812	19966	12	applied	\N	\N	\N	\N	64050	64050	51270
15812	19969	13	applied	\N	\N	\N	\N	64056	64056	51279
15816	19956	0	applied	\N	\N	\N	\N	64032	64032	64033
15816	19957	1	applied	\N	\N	\N	\N	64034	64034	64035
15816	19958	2	applied	\N	\N	\N	\N	64036	64036	64037
15816	19959	3	applied	\N	\N	\N	\N	64038	64038	64039
15816	19960	4	applied	\N	\N	\N	\N	64040	64040	64041
15816	19961	5	applied	\N	\N	\N	\N	64042	64042	64043
15816	19962	6	applied	\N	\N	\N	\N	64044	64044	64045
15816	19963	7	applied	\N	\N	\N	\N	64046	64046	51253
15816	19964	8	applied	\N	\N	\N	\N	64047	64047	51256
15816	19965	9	applied	\N	\N	\N	\N	64048	64048	64049
15816	19966	10	applied	\N	\N	\N	\N	64050	64050	51258
15818	19989	0	applied	\N	\N	\N	\N	64097	64097	64098
15818	19990	1	applied	\N	\N	\N	\N	64099	64099	64100
15818	19991	2	applied	\N	\N	\N	\N	64101	64101	64102
15818	19992	3	applied	\N	\N	\N	\N	64103	64103	64104
15818	19993	4	applied	\N	\N	\N	\N	64105	64105	51316
15822	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15822	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15822	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15822	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15822	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15822	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15822	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15822	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15822	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15822	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15822	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15822	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15822	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15822	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15822	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15822	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15822	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15822	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15822	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15824	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15824	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15824	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15824	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15824	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15824	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15824	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15824	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15824	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15824	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15824	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15824	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15824	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15824	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15824	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15824	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15824	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15824	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15824	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15827	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15827	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15827	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15827	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15827	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15827	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15827	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15827	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15827	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15827	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15827	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15827	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15827	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15827	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15827	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15827	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15827	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15827	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15827	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15839	20066	0	applied	\N	\N	\N	\N	64275	64275	64276
15839	20067	1	applied	\N	\N	\N	\N	64277	64277	64278
15839	20068	2	applied	\N	\N	\N	\N	64279	64279	51445
15842	20069	0	applied	\N	\N	\N	\N	64287	64287	64288
15842	20070	1	applied	\N	\N	\N	\N	64289	64289	51447
15842	20071	2	applied	\N	\N	\N	\N	64290	64290	64291
15842	20072	3	applied	\N	\N	\N	\N	64292	64292	64293
15847	20076	0	applied	\N	\N	\N	\N	64307	64307	64308
15847	20077	1	applied	\N	\N	\N	\N	64309	64309	64310
15847	20078	2	applied	\N	\N	\N	\N	64311	64311	64312
15847	20079	3	applied	\N	\N	\N	\N	64313	64313	64314
15847	20080	4	applied	\N	\N	\N	\N	64315	64315	64316
15847	20081	5	applied	\N	\N	\N	\N	64317	64317	51484
15847	20082	6	applied	\N	\N	\N	\N	64318	64318	51490
15847	20083	7	applied	\N	\N	\N	\N	64319	64319	51492
15847	20084	8	applied	\N	\N	\N	\N	64320	64320	64321
15847	20085	9	applied	\N	\N	\N	\N	64322	64322	51500
15852	20086	0	applied	\N	\N	1000000000	\N	64329	64329	64330
15852	20087	1	applied	\N	\N	\N	\N	64331	64331	64332
15852	20088	2	applied	\N	\N	\N	\N	64333	64333	64334
15852	20089	3	applied	\N	\N	\N	\N	64335	64335	64336
15854	20090	0	applied	\N	\N	\N	\N	64341	64341	64342
15854	20091	1	applied	\N	\N	\N	\N	64343	64343	64344
15854	20092	2	applied	\N	\N	\N	\N	64345	64345	51603
15854	20093	3	applied	\N	\N	\N	\N	64346	64346	64347
15854	20094	4	applied	\N	\N	\N	\N	64348	64348	64349
15854	20095	5	applied	\N	\N	\N	\N	64350	64350	51611
15856	20096	0	applied	\N	\N	\N	\N	64354	64354	64355
15856	20097	1	applied	\N	\N	\N	\N	64356	64356	64357
15856	20098	2	applied	\N	\N	\N	\N	64358	64358	51638
15863	20109	0	applied	\N	\N	\N	\N	64407	64407	64408
15863	20110	1	applied	\N	\N	\N	\N	64409	64409	51676
15863	20111	3	applied	\N	\N	\N	\N	64411	64411	64412
15866	20112	0	applied	\N	\N	\N	\N	64415	64415	64416
15866	20113	1	applied	\N	\N	\N	\N	64417	64417	51687
15866	20114	2	applied	\N	\N	\N	\N	64418	64418	64419
15866	20115	3	applied	\N	\N	\N	\N	64420	64420	51695
15868	20119	0	applied	\N	\N	\N	\N	64435	64435	64436
15868	20120	1	applied	\N	\N	\N	\N	64437	64437	64438
15868	20121	2	applied	\N	\N	\N	\N	64439	64439	64440
15873	20132	0	applied	\N	\N	\N	\N	64462	64462	64463
15873	20133	1	applied	\N	\N	\N	\N	64464	64464	64465
15873	20134	2	applied	\N	\N	\N	\N	64466	64466	28605
15873	20135	3	applied	\N	\N	\N	\N	64467	64467	64468
15817	19983	13	applied	\N	\N	\N	\N	64088	64088	51291
15817	19984	14	applied	\N	\N	\N	\N	64089	64089	64090
15817	19985	15	applied	\N	\N	\N	\N	64091	64091	51306
15817	19986	16	applied	\N	\N	\N	\N	64092	64092	64093
15817	19987	17	applied	\N	\N	\N	\N	64094	64094	51310
15817	19988	18	applied	\N	\N	\N	\N	64095	64095	51312
15819	19989	0	applied	\N	\N	\N	\N	64097	64097	64098
15819	19990	1	applied	\N	\N	\N	\N	64099	64099	64100
15819	19991	2	applied	\N	\N	\N	\N	64101	64101	64102
15819	19992	3	applied	\N	\N	\N	\N	64103	64103	64104
15819	19993	4	applied	\N	\N	\N	\N	64105	64105	51316
15820	19994	0	applied	\N	\N	\N	\N	64109	64109	64110
15820	19995	1	applied	\N	\N	\N	\N	64111	64111	64112
15820	19996	2	applied	\N	\N	\N	\N	64113	64113	64114
15820	19997	3	applied	\N	\N	\N	\N	64115	64115	64116
15820	19998	4	applied	\N	\N	\N	\N	64117	64117	64118
15820	19999	5	applied	\N	\N	\N	\N	64119	64119	64120
15820	20000	6	applied	\N	\N	\N	\N	64121	64121	64122
15820	20001	7	applied	\N	\N	\N	\N	64123	64123	64124
15820	20002	8	applied	\N	\N	\N	\N	64125	64125	51331
15820	20003	9	applied	\N	\N	\N	\N	64126	64126	64127
15820	20004	10	applied	\N	\N	\N	\N	64128	64128	51341
15820	20005	11	applied	\N	\N	\N	\N	64129	64129	51343
15820	20006	12	applied	\N	\N	\N	\N	64130	64130	64131
15823	20007	0	applied	\N	\N	\N	\N	64134	64134	64135
15823	20008	1	applied	\N	\N	\N	\N	64136	64136	64137
15823	20009	2	applied	\N	\N	\N	\N	64138	64138	64139
15823	20010	3	applied	\N	\N	\N	\N	64140	64140	64141
15823	20011	4	applied	\N	\N	\N	\N	64142	64142	64143
15823	20012	5	applied	\N	\N	\N	\N	64144	64144	64145
15823	20013	6	applied	\N	\N	\N	\N	64146	64146	64147
15823	20014	8	applied	\N	\N	\N	\N	64149	64149	64150
15823	20015	9	applied	\N	\N	\N	\N	64151	64151	64152
15823	20016	10	applied	\N	\N	\N	\N	64153	64153	64154
15823	20017	11	applied	\N	\N	\N	\N	64155	64155	64156
15823	20018	12	applied	\N	\N	\N	\N	64157	64157	64158
15823	20019	13	applied	\N	\N	\N	\N	64159	64159	51345
15823	20020	14	applied	\N	\N	\N	\N	64160	64160	64161
15823	20021	15	applied	\N	\N	\N	\N	64162	64162	64163
15823	20022	16	applied	\N	\N	\N	\N	64164	64164	51369
15823	20023	17	applied	\N	\N	\N	\N	64165	64165	64166
15823	20024	18	applied	\N	\N	\N	\N	64167	64167	51373
15823	20025	19	applied	\N	\N	\N	\N	64168	64168	51375
15829	20026	0	applied	\N	\N	\N	\N	64186	64186	64187
15829	20027	1	applied	\N	\N	\N	\N	64188	64188	64189
15829	20028	2	applied	\N	\N	\N	\N	64190	64190	64191
15829	20029	3	applied	\N	\N	\N	\N	64192	64192	64193
15829	20030	4	applied	\N	\N	\N	\N	64194	64194	51379
15831	20031	0	applied	\N	\N	\N	\N	64199	64199	64200
15831	20032	1	applied	\N	\N	\N	\N	64201	64201	64202
15831	20033	2	applied	\N	\N	\N	\N	64203	64203	64204
15831	20034	3	applied	\N	\N	\N	\N	64205	64205	64206
15831	20035	4	applied	\N	\N	\N	\N	64207	64207	64208
15837	20066	0	applied	\N	\N	\N	\N	64275	64275	64276
15837	20067	1	applied	\N	\N	\N	\N	64277	64277	64278
15837	20068	2	applied	\N	\N	\N	\N	64279	64279	51445
15840	20066	0	applied	\N	\N	\N	\N	64275	64275	64276
15840	20067	1	applied	\N	\N	\N	\N	64277	64277	64278
15840	20068	2	applied	\N	\N	\N	\N	64279	64279	51445
15841	20069	0	applied	\N	\N	\N	\N	64287	64287	64288
15841	20070	1	applied	\N	\N	\N	\N	64289	64289	51447
15841	20071	2	applied	\N	\N	\N	\N	64290	64290	64291
15841	20072	3	applied	\N	\N	\N	\N	64292	64292	64293
15843	20069	0	applied	\N	\N	\N	\N	64287	64287	64288
15843	20070	1	applied	\N	\N	\N	\N	64289	64289	51447
15843	20071	2	applied	\N	\N	\N	\N	64290	64290	64291
15843	20072	3	applied	\N	\N	\N	\N	64292	64292	64293
15846	20073	0	applied	\N	\N	\N	\N	64299	64299	64300
15846	20074	1	applied	\N	\N	\N	\N	64301	64301	51457
15846	20075	2	applied	\N	\N	\N	\N	64302	64302	64303
15848	20076	0	applied	\N	\N	\N	\N	64307	64307	64308
15848	20077	1	applied	\N	\N	\N	\N	64309	64309	64310
15848	20078	2	applied	\N	\N	\N	\N	64311	64311	64312
15848	20079	3	applied	\N	\N	\N	\N	64313	64313	64314
15848	20080	4	applied	\N	\N	\N	\N	64315	64315	64316
15848	20081	5	applied	\N	\N	\N	\N	64317	64317	51484
15848	20082	6	applied	\N	\N	\N	\N	64318	64318	51490
15848	20083	7	applied	\N	\N	\N	\N	64319	64319	51492
15848	20084	8	applied	\N	\N	\N	\N	64320	64320	64321
15848	20085	9	applied	\N	\N	\N	\N	64322	64322	51500
15860	20102	0	applied	\N	\N	\N	\N	64372	64372	64373
15860	20103	1	applied	\N	\N	\N	\N	64374	64374	64375
15860	20104	2	applied	\N	\N	\N	\N	64376	64376	51646
15860	20105	3	applied	\N	\N	\N	\N	64377	64377	51648
15860	20106	4	applied	\N	\N	\N	\N	64378	64378	64379
15860	20107	5	applied	\N	\N	\N	\N	64380	64380	51668
15860	20108	6	applied	\N	\N	\N	\N	64381	64381	51670
15862	19733	0	applied	\N	\N	1000000000	\N	63566	63566	63567
15862	20086	1	applied	\N	\N	1000000000	\N	64329	64329	64330
15862	19817	2	applied	\N	\N	\N	\N	63730	63730	10497
15862	19934	3	applied	\N	\N	\N	\N	63978	63978	63979
15862	19750	4	applied	\N	\N	\N	\N	63603	63603	63604
15862	19946	5	applied	\N	\N	\N	\N	64005	64005	64386
15862	19956	6	applied	\N	\N	\N	\N	64387	64387	64033
15862	20007	7	applied	\N	\N	\N	\N	64134	64134	64135
15862	20008	8	applied	\N	\N	\N	\N	64136	64136	64137
15862	19957	9	applied	\N	\N	\N	\N	64388	64388	64035
15862	19958	10	applied	\N	\N	\N	\N	64389	64389	64037
15862	20010	11	applied	\N	\N	\N	\N	64140	64140	64141
15862	20011	12	applied	\N	\N	\N	\N	64142	64142	64143
15862	20012	13	applied	\N	\N	\N	\N	64144	64144	64145
15862	19962	14	applied	\N	\N	\N	\N	64390	64390	64045
15862	19973	15	applied	\N	\N	\N	\N	64391	64391	64069
15862	19974	16	applied	\N	\N	\N	\N	64392	64392	64071
15862	19975	17	applied	\N	\N	\N	\N	64393	64393	64073
15862	19976	18	applied	\N	\N	\N	\N	64394	64394	64075
15862	19977	19	applied	\N	\N	\N	\N	64395	64395	64077
15862	19978	20	applied	\N	\N	\N	\N	64396	64396	64079
15862	19979	21	applied	\N	\N	\N	\N	64397	64397	64081
15862	19980	22	applied	\N	\N	\N	\N	64398	64398	64083
15862	19981	23	applied	\N	\N	\N	\N	64399	64399	64085
15862	19989	24	applied	\N	\N	\N	\N	64400	64400	64098
15862	19990	25	applied	\N	\N	\N	\N	64401	64401	64100
15862	19997	26	applied	\N	\N	\N	\N	64402	64402	64116
15862	19998	27	applied	\N	\N	\N	\N	64403	64403	64118
15862	19999	28	applied	\N	\N	\N	\N	64404	64404	64120
15862	20015	29	applied	\N	\N	\N	\N	64151	64151	64152
15862	20016	30	applied	\N	\N	\N	\N	64153	64153	64154
15862	20017	31	applied	\N	\N	\N	\N	64155	64155	64156
15833	20036	0	applied	\N	\N	\N	\N	64212	64212	64213
15833	20037	1	applied	\N	\N	\N	\N	64214	64214	64215
15833	20038	2	applied	\N	\N	\N	\N	64216	64216	64217
15833	20039	3	applied	\N	\N	\N	\N	64218	64218	64219
15833	20040	4	applied	\N	\N	\N	\N	64220	64220	51385
15833	20041	5	applied	\N	\N	\N	\N	64221	64221	64222
15833	20042	6	applied	\N	\N	\N	\N	64223	64223	64224
15835	20043	0	applied	\N	\N	\N	\N	64229	64229	64230
15835	20044	1	applied	\N	\N	\N	\N	64231	64231	64232
15835	20045	2	applied	\N	\N	\N	\N	64233	64233	64234
15835	20046	3	applied	\N	\N	\N	\N	64235	64235	64236
15835	20047	4	applied	\N	\N	\N	\N	64237	64237	51407
15835	20048	5	applied	\N	\N	\N	\N	64238	64238	51409
15836	20049	0	applied	\N	\N	\N	\N	64241	64241	64242
15836	20050	1	applied	\N	\N	\N	\N	64243	64243	64244
15836	20051	2	applied	\N	\N	\N	\N	64245	64245	64246
15836	20052	3	applied	\N	\N	\N	\N	64247	64247	64248
15836	20053	4	applied	\N	\N	\N	\N	64249	64249	64250
15836	20054	5	applied	\N	\N	\N	\N	64251	64251	64252
15836	20055	6	applied	\N	\N	\N	\N	64253	64253	64254
15836	20056	7	applied	\N	\N	\N	\N	64255	64255	64256
15836	20057	8	applied	\N	\N	\N	\N	64257	64257	64258
15836	20058	9	applied	\N	\N	\N	\N	64259	64259	64260
15836	20059	10	applied	\N	\N	\N	\N	64261	64261	64262
15836	20060	11	applied	\N	\N	\N	\N	64263	64263	64264
15836	20061	12	applied	\N	\N	\N	\N	64265	64265	64266
15836	20062	13	applied	\N	\N	\N	\N	64267	64267	51425
15836	20063	14	applied	\N	\N	\N	\N	64268	64268	64269
15836	20064	15	applied	\N	\N	\N	\N	64270	64270	64271
15836	20065	16	applied	\N	\N	\N	\N	64272	64272	51437
15845	20073	0	applied	\N	\N	\N	\N	64299	64299	64300
15845	20074	1	applied	\N	\N	\N	\N	64301	64301	51457
15845	20075	2	applied	\N	\N	\N	\N	64302	64302	64303
15850	20076	0	applied	\N	\N	\N	\N	64307	64307	64308
15850	20077	1	applied	\N	\N	\N	\N	64309	64309	64310
15850	20078	2	applied	\N	\N	\N	\N	64311	64311	64312
15850	20079	3	applied	\N	\N	\N	\N	64313	64313	64314
15850	20080	4	applied	\N	\N	\N	\N	64315	64315	64316
15850	20081	5	applied	\N	\N	\N	\N	64317	64317	51484
15850	20082	6	applied	\N	\N	\N	\N	64318	64318	51490
15850	20083	7	applied	\N	\N	\N	\N	64319	64319	51492
15850	20084	8	applied	\N	\N	\N	\N	64320	64320	64321
15850	20085	9	applied	\N	\N	\N	\N	64322	64322	51500
15853	20086	0	applied	\N	\N	1000000000	\N	64329	64329	64330
15853	20087	1	applied	\N	\N	\N	\N	64331	64331	64332
15853	20088	2	applied	\N	\N	\N	\N	64333	64333	64334
15853	20089	3	applied	\N	\N	\N	\N	64335	64335	64336
15855	20090	0	applied	\N	\N	\N	\N	64341	64341	64342
15855	20091	1	applied	\N	\N	\N	\N	64343	64343	64344
15855	20092	2	applied	\N	\N	\N	\N	64345	64345	51603
15855	20093	3	applied	\N	\N	\N	\N	64346	64346	64347
15855	20094	4	applied	\N	\N	\N	\N	64348	64348	64349
15855	20095	5	applied	\N	\N	\N	\N	64350	64350	51611
15857	20099	0	applied	\N	\N	\N	\N	64360	64360	64361
15857	20100	1	applied	\N	\N	\N	\N	64362	64362	64363
15857	20101	2	applied	\N	\N	\N	\N	64364	64364	64365
15859	20099	0	applied	\N	\N	\N	\N	64360	64360	64361
15859	20100	1	applied	\N	\N	\N	\N	64362	64362	64363
15859	20101	2	applied	\N	\N	\N	\N	64364	64364	64365
15864	20112	0	applied	\N	\N	\N	\N	64415	64415	64416
15864	20113	1	applied	\N	\N	\N	\N	64417	64417	51687
15864	20114	2	applied	\N	\N	\N	\N	64418	64418	64419
15864	20115	3	applied	\N	\N	\N	\N	64420	64420	51695
15871	20125	0	applied	\N	\N	\N	\N	64448	64448	64449
15871	20126	1	applied	\N	\N	\N	\N	64450	64450	64451
15871	20127	2	applied	\N	\N	\N	\N	64452	64452	51739
15871	20128	3	applied	\N	\N	\N	\N	64453	64453	51741
15878	20134	0	applied	\N	\N	\N	\N	64466	64466	28605
15880	20140	0	applied	\N	\N	\N	\N	64486	64486	64487
15886	20134	0	applied	\N	\N	\N	\N	64466	64466	28605
15889	20149	0	applied	\N	\N	\N	\N	64509	64509	64510
15889	20150	1	applied	\N	\N	\N	\N	64511	64511	64512
15889	20151	2	applied	\N	\N	\N	\N	64513	64513	64514
15889	20152	3	applied	\N	\N	\N	\N	64515	64515	64516
15889	20153	4	applied	\N	\N	\N	\N	64517	64517	64518
15889	20154	5	applied	\N	\N	\N	\N	64519	64519	51812
15889	20155	6	applied	\N	\N	\N	\N	64520	64520	51818
15889	20156	7	applied	\N	\N	\N	\N	64521	64521	51826
15889	20157	8	applied	\N	\N	\N	\N	64522	64522	51828
15894	20165	0	applied	\N	\N	\N	\N	64543	64543	64544
15894	20166	1	applied	\N	\N	\N	\N	64545	64545	51862
15894	20167	2	applied	\N	\N	\N	\N	64546	64546	64547
15898	20177	0	applied	\N	\N	\N	\N	64568	64568	64569
15898	20178	1	applied	\N	\N	\N	\N	64570	64570	64571
15898	20179	2	applied	\N	\N	\N	\N	64572	64572	51900
15899	20180	0	applied	\N	\N	\N	\N	64576	64576	64577
15899	20181	1	applied	\N	\N	\N	\N	64578	64578	51913
15899	20182	2	applied	\N	\N	\N	\N	64579	64579	64580
15902	20186	0	applied	\N	\N	\N	\N	64587	64587	64588
15902	20187	1	applied	\N	\N	\N	\N	64589	64589	64590
15902	20188	2	applied	\N	\N	\N	\N	64591	64591	51921
15902	20189	3	applied	\N	\N	\N	\N	64592	64592	51928
15902	20190	4	applied	\N	\N	\N	\N	64593	64593	64594
15902	20191	5	applied	\N	\N	\N	\N	64595	64595	51934
15905	20192	0	applied	\N	\N	\N	\N	64601	64601	64602
15905	20193	1	applied	\N	\N	\N	\N	64603	64603	64604
15905	20194	2	applied	\N	\N	\N	\N	64605	64605	64606
15905	20195	3	applied	\N	\N	\N	\N	64607	64607	64608
15905	20196	4	applied	\N	\N	\N	\N	64609	64609	51948
15905	20197	5	applied	\N	\N	\N	\N	64610	64610	51950
15909	20198	0	applied	\N	\N	\N	\N	64615	64615	64616
15909	20199	1	applied	\N	\N	\N	\N	64617	64617	51952
15914	20209	0	applied	\N	\N	\N	\N	64642	64642	64643
15914	20210	1	applied	\N	\N	\N	\N	64644	64644	64645
15914	20211	2	applied	\N	\N	\N	\N	64646	64646	64647
15914	20212	3	applied	\N	\N	\N	\N	64648	64648	64649
15914	20213	4	applied	\N	\N	\N	\N	64650	64650	64651
15914	20214	5	applied	\N	\N	\N	\N	64652	64652	51997
15917	20215	0	applied	\N	\N	\N	\N	64657	64657	64658
15917	20216	1	applied	\N	\N	\N	\N	64659	64659	64660
15917	20217	2	applied	\N	\N	\N	\N	64661	64661	64662
15917	20220	3	applied	\N	\N	\N	\N	64668	64668	64669
15917	20218	4	applied	\N	\N	\N	\N	64663	64663	64670
15917	20219	5	applied	\N	\N	\N	\N	64664	64664	64671
15921	20224	0	applied	\N	\N	\N	\N	64683	64683	64684
15921	20225	1	applied	\N	\N	\N	\N	64685	64685	52031
15921	20226	2	applied	\N	\N	\N	\N	64686	64686	64687
15926	20233	0	applied	\N	\N	\N	\N	64701	64701	64702
15926	20234	1	applied	\N	\N	\N	\N	64703	64703	52059
15926	20235	2	applied	\N	\N	\N	\N	64704	64704	52061
15861	20108	6	applied	\N	\N	\N	\N	64381	64381	51670
15865	20112	0	applied	\N	\N	\N	\N	64415	64415	64416
15865	20113	1	applied	\N	\N	\N	\N	64417	64417	51687
15865	20114	2	applied	\N	\N	\N	\N	64418	64418	64419
15865	20115	3	applied	\N	\N	\N	\N	64420	64420	51695
15867	20116	0	applied	\N	\N	\N	\N	64428	64428	64429
15867	20117	1	applied	\N	\N	\N	\N	64430	64430	64431
15867	20118	2	applied	\N	\N	\N	\N	64432	64432	51711
15870	20125	0	applied	\N	\N	\N	\N	64448	64448	64449
15870	20126	1	applied	\N	\N	\N	\N	64450	64450	64451
15870	20127	2	applied	\N	\N	\N	\N	64452	64452	51739
15870	20128	3	applied	\N	\N	\N	\N	64453	64453	51741
15872	20129	0	applied	\N	\N	\N	\N	64456	64456	64457
15872	20130	1	applied	\N	\N	\N	\N	64458	64458	51743
15872	20131	2	applied	\N	\N	\N	\N	64459	64459	64460
15879	20134	0	applied	\N	\N	\N	\N	64466	64466	28605
15885	20140	0	applied	\N	\N	\N	\N	64486	64486	64487
15885	20143	1	applied	\N	\N	\N	\N	64493	64493	64494
15885	20141	2	applied	\N	\N	\N	\N	64489	64489	51773
15885	20142	3	applied	\N	\N	\N	\N	64490	64490	51792
15888	20143	0	applied	\N	\N	\N	\N	64493	64493	64494
15888	20144	1	applied	\N	\N	\N	\N	64496	64496	64497
15888	20145	2	applied	\N	\N	\N	\N	64498	64498	64499
15888	20146	3	applied	\N	\N	\N	\N	64500	64500	64501
15888	20147	4	applied	\N	\N	\N	\N	64502	64502	64503
15888	20148	5	applied	\N	\N	\N	\N	64504	64504	51802
15891	20158	0	applied	\N	\N	\N	\N	64524	64524	64525
15891	20159	1	applied	\N	\N	\N	\N	64526	64526	64527
15891	20160	2	applied	\N	\N	\N	\N	64528	64528	51840
15891	20161	3	applied	\N	\N	\N	\N	64529	64529	51848
15896	20177	0	applied	\N	\N	\N	\N	64568	64568	64569
15896	20178	1	applied	\N	\N	\N	\N	64570	64570	64571
15896	20179	2	applied	\N	\N	\N	\N	64572	64572	51900
15901	20186	0	applied	\N	\N	\N	\N	64587	64587	64588
15901	20187	1	applied	\N	\N	\N	\N	64589	64589	64590
15901	20188	2	applied	\N	\N	\N	\N	64591	64591	51921
15901	20189	3	applied	\N	\N	\N	\N	64592	64592	51928
15901	20190	4	applied	\N	\N	\N	\N	64593	64593	64594
15901	20191	5	applied	\N	\N	\N	\N	64595	64595	51934
15903	20186	0	applied	\N	\N	\N	\N	64587	64587	64588
15903	20187	1	applied	\N	\N	\N	\N	64589	64589	64590
15903	20188	2	applied	\N	\N	\N	\N	64591	64591	51921
15903	20189	3	applied	\N	\N	\N	\N	64592	64592	51928
15903	20190	4	applied	\N	\N	\N	\N	64593	64593	64594
15903	20191	5	applied	\N	\N	\N	\N	64595	64595	51934
15910	20200	0	applied	\N	\N	\N	\N	64622	64622	64623
15910	20201	1	applied	\N	\N	\N	\N	64624	64624	64625
15910	20202	2	applied	\N	\N	\N	\N	64626	64626	64627
15912	20203	0	applied	\N	\N	\N	\N	64630	64630	64631
15912	20204	1	applied	\N	\N	\N	\N	64632	64632	51964
15912	20205	2	applied	\N	\N	\N	\N	64633	64633	51973
15929	20236	0	applied	\N	\N	\N	\N	64709	64709	64710
15929	20237	1	applied	\N	\N	\N	\N	64711	64711	64712
15932	20247	0	applied	\N	\N	\N	\N	64734	64734	64735
15932	20248	1	applied	\N	\N	\N	\N	64736	64736	64737
15932	20249	2	applied	\N	\N	\N	\N	64738	64738	64739
15936	20250	0	applied	\N	\N	\N	\N	64745	64745	64746
15936	20251	1	applied	\N	\N	\N	\N	64747	64747	64748
15936	20252	2	applied	\N	\N	\N	\N	64749	64749	52109
15941	20256	0	applied	\N	\N	\N	\N	64759	64759	64760
15941	20257	1	applied	\N	\N	\N	\N	64761	64761	52117
15941	20258	2	applied	\N	\N	\N	\N	64762	64762	64763
15944	20271	0	applied	\N	\N	\N	\N	64792	64792	64793
15944	20272	1	applied	\N	\N	\N	\N	64794	64794	52163
15944	20273	2	applied	\N	\N	\N	\N	64795	64795	64796
15946	20274	0	applied	\N	\N	\N	\N	64801	64801	64802
15946	20275	1	applied	\N	\N	\N	\N	64803	64803	52173
15946	20276	2	applied	\N	\N	\N	\N	64804	64804	64805
15951	20283	0	applied	\N	\N	\N	\N	64820	64820	64821
15951	20284	1	applied	\N	\N	\N	\N	64822	64822	64823
15951	20285	2	applied	\N	\N	\N	\N	64824	64824	64825
15959	20295	0	applied	\N	\N	\N	\N	64851	64851	64852
15959	20296	1	applied	\N	\N	\N	\N	64853	64853	52235
15959	20297	2	applied	\N	\N	\N	\N	64854	64854	52242
15961	20295	0	applied	\N	\N	\N	\N	64851	64851	64852
15961	20296	1	applied	\N	\N	\N	\N	64853	64853	52235
15961	20297	2	applied	\N	\N	\N	\N	64854	64854	52242
15963	20298	0	applied	\N	\N	\N	\N	64859	64859	64860
15963	20299	1	applied	\N	\N	\N	\N	64861	64861	64862
15963	20300	2	applied	\N	\N	\N	\N	64863	64863	64864
15963	20301	3	applied	\N	\N	\N	\N	64865	64865	52252
15963	20302	4	applied	\N	\N	\N	\N	64866	64866	64867
15963	20303	5	applied	\N	\N	\N	\N	64868	64868	64869
15967	20307	0	applied	\N	\N	\N	\N	64882	64882	64883
15967	20308	1	applied	\N	\N	\N	\N	64884	64884	64885
15967	20309	2	applied	\N	\N	\N	\N	64886	64886	52275
15967	20310	3	applied	\N	\N	\N	\N	64887	64887	64888
15967	20311	4	applied	\N	\N	\N	\N	64889	64889	64890
15967	20312	5	applied	\N	\N	\N	\N	64891	64891	64892
15974	20319	0	applied	\N	\N	\N	\N	64910	64910	64911
15974	20320	1	applied	\N	\N	\N	\N	64912	64912	64913
15974	20321	2	applied	\N	\N	\N	\N	64914	64914	64915
15977	20322	0	applied	\N	\N	\N	\N	64919	64919	64920
15977	20323	1	applied	\N	\N	\N	\N	64921	64921	64922
15977	20324	2	applied	\N	\N	\N	\N	64923	64923	64924
15977	20325	3	applied	\N	\N	\N	\N	64925	64925	64926
15977	20326	4	applied	\N	\N	\N	\N	64927	64927	64928
15977	20327	5	applied	\N	\N	\N	\N	64929	64929	64930
15977	20328	6	applied	\N	\N	\N	\N	64931	64931	64932
15977	20329	7	applied	\N	\N	\N	\N	64933	64933	64934
15977	20330	8	applied	\N	\N	\N	\N	64935	64935	64936
15977	20331	9	applied	\N	\N	\N	\N	64937	64937	64938
15977	20332	10	applied	\N	\N	\N	\N	64939	64939	64940
15977	20333	11	applied	\N	\N	\N	\N	64941	64941	52336
15977	20334	12	applied	\N	\N	\N	\N	64942	64942	52338
15977	20335	13	applied	\N	\N	\N	\N	64943	64943	64944
15977	20336	14	applied	\N	\N	\N	\N	64945	64945	52342
15977	20337	15	applied	\N	\N	\N	\N	64946	64946	52351
15982	20344	0	applied	\N	\N	\N	\N	64965	64965	64966
15982	20345	1	applied	\N	\N	\N	\N	64967	64967	64968
15982	20346	2	applied	\N	\N	\N	\N	64969	64969	64970
15982	20347	3	applied	\N	\N	\N	\N	64971	64971	64972
15982	20348	4	applied	\N	\N	\N	\N	64973	64973	64974
15982	20349	5	applied	\N	\N	\N	\N	64975	64975	52381
15985	20353	0	applied	\N	\N	\N	\N	64983	64983	64984
15985	20354	1	applied	\N	\N	\N	\N	64985	64985	64986
15985	20355	2	applied	\N	\N	\N	\N	64987	64987	64988
15987	20356	0	applied	\N	\N	\N	\N	64993	64993	64994
15987	20357	1	applied	\N	\N	\N	\N	64995	64995	64996
15987	20358	2	applied	\N	\N	\N	\N	64997	64997	64998
15862	20018	32	applied	\N	\N	\N	\N	64157	64157	64158
15862	20026	33	applied	\N	\N	\N	\N	64186	64186	64187
15862	20027	34	applied	\N	\N	\N	\N	64188	64188	64189
15862	20028	35	applied	\N	\N	\N	\N	64190	64190	64191
15862	20031	36	applied	\N	\N	\N	\N	64199	64199	64200
15862	20033	37	applied	\N	\N	\N	\N	64203	64203	64204
15862	20037	38	applied	\N	\N	\N	\N	64214	64214	64215
15862	20038	39	applied	\N	\N	\N	\N	64216	64216	64217
15862	20039	40	applied	\N	\N	\N	\N	64218	64218	64219
15862	20044	41	applied	\N	\N	\N	\N	64231	64231	64232
15869	20122	0	applied	\N	\N	\N	\N	64443	64443	64444
15869	20123	1	applied	\N	\N	\N	\N	64445	64445	51721
15869	20124	2	applied	\N	\N	\N	\N	64446	64446	51727
15874	20132	0	applied	\N	\N	\N	\N	64462	64462	64463
15874	20133	1	applied	\N	\N	\N	\N	64464	64464	64465
15874	20134	2	applied	\N	\N	\N	\N	64466	64466	28605
15874	20135	3	applied	\N	\N	\N	\N	64467	64467	64468
15876	20136	0	applied	\N	\N	\N	\N	64473	64473	64474
15876	20137	1	applied	\N	\N	\N	\N	64475	64475	64476
15876	20138	2	applied	\N	\N	\N	\N	64477	64477	64478
15876	20139	3	applied	\N	\N	\N	\N	64479	64479	64480
15881	20140	0	applied	\N	\N	\N	\N	64486	64486	64487
15881	20141	1	applied	\N	\N	\N	\N	64489	64489	51773
15881	20142	2	applied	\N	\N	\N	\N	64490	64490	51792
15887	20143	0	applied	\N	\N	\N	\N	64493	64493	64494
15887	20144	1	applied	\N	\N	\N	\N	64496	64496	64497
15887	20145	2	applied	\N	\N	\N	\N	64498	64498	64499
15887	20146	3	applied	\N	\N	\N	\N	64500	64500	64501
15887	20147	4	applied	\N	\N	\N	\N	64502	64502	64503
15887	20148	5	applied	\N	\N	\N	\N	64504	64504	51802
15890	20158	0	applied	\N	\N	\N	\N	64524	64524	64525
15890	20159	1	applied	\N	\N	\N	\N	64526	64526	64527
15890	20160	2	applied	\N	\N	\N	\N	64528	64528	51840
15890	20161	3	applied	\N	\N	\N	\N	64529	64529	51848
15895	20168	0	applied	\N	\N	\N	\N	64550	64550	64551
15895	20169	1	applied	\N	\N	\N	\N	64552	64552	64553
15895	20170	2	applied	\N	\N	\N	\N	64554	64554	64555
15895	20171	3	applied	\N	\N	\N	\N	64556	64556	64557
15895	20172	4	applied	\N	\N	\N	\N	64558	64558	64559
15895	20173	5	applied	\N	\N	\N	\N	64560	64560	64561
15895	20174	6	applied	\N	\N	\N	\N	64562	64562	51892
15895	20175	7	applied	\N	\N	\N	\N	64563	64563	64564
15895	20176	8	applied	\N	\N	\N	\N	64565	64565	64566
15900	20183	0	applied	\N	\N	\N	\N	64581	64581	64582
15900	20184	1	applied	\N	\N	\N	\N	64583	64583	64584
15900	20185	2	applied	\N	\N	\N	\N	64585	64585	64586
15906	20192	0	applied	\N	\N	\N	\N	64601	64601	64602
15906	20193	1	applied	\N	\N	\N	\N	64603	64603	64604
15906	20194	2	applied	\N	\N	\N	\N	64605	64605	64606
15906	20195	3	applied	\N	\N	\N	\N	64607	64607	64608
15906	20196	4	applied	\N	\N	\N	\N	64609	64609	51948
15906	20197	5	applied	\N	\N	\N	\N	64610	64610	51950
15915	20209	0	applied	\N	\N	\N	\N	64642	64642	64643
15915	20210	1	applied	\N	\N	\N	\N	64644	64644	64645
15915	20211	2	applied	\N	\N	\N	\N	64646	64646	64647
15915	20212	3	applied	\N	\N	\N	\N	64648	64648	64649
15915	20213	4	applied	\N	\N	\N	\N	64650	64650	64651
15915	20214	5	applied	\N	\N	\N	\N	64652	64652	51997
15918	20215	0	applied	\N	\N	\N	\N	64657	64657	64658
15918	20216	1	applied	\N	\N	\N	\N	64659	64659	64660
15918	20217	2	applied	\N	\N	\N	\N	64661	64661	64662
15918	20220	3	applied	\N	\N	\N	\N	64668	64668	64669
15918	20218	4	applied	\N	\N	\N	\N	64663	64663	64670
15918	20219	5	applied	\N	\N	\N	\N	64664	64664	64671
15922	20224	0	applied	\N	\N	\N	\N	64683	64683	64684
15922	20225	1	applied	\N	\N	\N	\N	64685	64685	52031
15922	20226	2	applied	\N	\N	\N	\N	64686	64686	64687
15924	20227	0	applied	\N	\N	\N	\N	64691	64691	64692
15924	20228	1	applied	\N	\N	\N	\N	64693	64693	64694
15924	20229	2	applied	\N	\N	\N	\N	64695	64695	64696
15924	20230	3	applied	\N	\N	\N	\N	64697	64697	52041
15924	20231	4	applied	\N	\N	\N	\N	64698	64698	52047
15924	20232	5	applied	\N	\N	\N	\N	64699	64699	52051
15927	20233	0	applied	\N	\N	\N	\N	64701	64701	64702
15927	20234	1	applied	\N	\N	\N	\N	64703	64703	52059
15927	20235	2	applied	\N	\N	\N	\N	64704	64704	52061
15940	20256	0	applied	\N	\N	\N	\N	64759	64759	64760
15940	20257	1	applied	\N	\N	\N	\N	64761	64761	52117
15940	20258	2	applied	\N	\N	\N	\N	64762	64762	64763
15943	20265	0	applied	\N	\N	\N	\N	64781	64781	64782
15943	20266	1	applied	\N	\N	\N	\N	64783	64783	64784
15943	20267	2	applied	\N	\N	\N	\N	64785	64785	64786
15943	20268	3	applied	\N	\N	\N	\N	64787	64787	52155
15943	20269	4	applied	\N	\N	\N	\N	64788	64788	64789
15943	20270	5	applied	\N	\N	\N	\N	64790	64790	52159
15953	20289	0	applied	\N	\N	\N	\N	64835	64835	64836
15953	20290	1	applied	\N	\N	\N	\N	64837	64837	52214
15953	20291	2	applied	\N	\N	\N	\N	64838	64838	64839
15955	20292	0	applied	\N	\N	\N	\N	64842	64842	64843
15955	20293	1	applied	\N	\N	\N	\N	64844	64844	64845
15955	20294	2	applied	\N	\N	\N	\N	64846	64846	64847
15958	20295	0	applied	\N	\N	\N	\N	64851	64851	64852
15958	20296	1	applied	\N	\N	\N	\N	64853	64853	52235
15958	20297	2	applied	\N	\N	\N	\N	64854	64854	52242
15962	20298	0	applied	\N	\N	\N	\N	64859	64859	64860
15962	20299	1	applied	\N	\N	\N	\N	64861	64861	64862
15962	20300	2	applied	\N	\N	\N	\N	64863	64863	64864
15962	20301	3	applied	\N	\N	\N	\N	64865	64865	52252
15962	20302	4	applied	\N	\N	\N	\N	64866	64866	64867
15962	20303	5	applied	\N	\N	\N	\N	64868	64868	64869
15964	20298	0	applied	\N	\N	\N	\N	64859	64859	64860
15964	20299	1	applied	\N	\N	\N	\N	64861	64861	64862
15964	20300	2	applied	\N	\N	\N	\N	64863	64863	64864
15964	20301	3	applied	\N	\N	\N	\N	64865	64865	52252
15964	20302	4	applied	\N	\N	\N	\N	64866	64866	64867
15964	20303	5	applied	\N	\N	\N	\N	64868	64868	64869
15970	20307	0	applied	\N	\N	\N	\N	64882	64882	64883
15970	20308	1	applied	\N	\N	\N	\N	64884	64884	64885
15970	20309	2	applied	\N	\N	\N	\N	64886	64886	52275
15970	20310	3	applied	\N	\N	\N	\N	64887	64887	64888
15970	20311	4	applied	\N	\N	\N	\N	64889	64889	64890
15970	20312	5	applied	\N	\N	\N	\N	64891	64891	64892
15973	20316	0	applied	\N	\N	\N	\N	64906	64906	64907
15973	20317	1	applied	\N	\N	\N	\N	64908	64908	52297
15973	20318	2	applied	\N	\N	\N	\N	64909	64909	52302
15976	20086	0	applied	\N	\N	1000000000	\N	64329	64329	64330
15976	20134	1	applied	\N	\N	\N	\N	64466	64466	28605
15980	20338	0	applied	\N	\N	\N	\N	64949	64949	64950
15980	20339	1	applied	\N	\N	\N	\N	64951	64951	64952
15980	20340	2	applied	\N	\N	\N	\N	64953	64953	64954
15875	20136	0	applied	\N	\N	\N	\N	64473	64473	64474
15875	20137	1	applied	\N	\N	\N	\N	64475	64475	64476
15875	20138	2	applied	\N	\N	\N	\N	64477	64477	64478
15875	20139	3	applied	\N	\N	\N	\N	64479	64479	64480
15883	20140	0	applied	\N	\N	\N	\N	64486	64486	64487
15883	20141	1	applied	\N	\N	\N	\N	64489	64489	51773
15883	20142	2	applied	\N	\N	\N	\N	64490	64490	51792
15892	20158	0	applied	\N	\N	\N	\N	64524	64524	64525
15892	20159	1	applied	\N	\N	\N	\N	64526	64526	64527
15892	20160	2	applied	\N	\N	\N	\N	64528	64528	51840
15892	20161	3	applied	\N	\N	\N	\N	64529	64529	51848
15893	20162	0	applied	\N	\N	\N	\N	64535	64535	64536
15893	20163	1	applied	\N	\N	\N	\N	64537	64537	64538
15893	20164	2	applied	\N	\N	\N	\N	64539	64539	64540
15897	20177	0	applied	\N	\N	\N	\N	64568	64568	64569
15897	20178	1	applied	\N	\N	\N	\N	64570	64570	64571
15897	20179	2	applied	\N	\N	\N	\N	64572	64572	51900
15904	20192	0	applied	\N	\N	\N	\N	64601	64601	64602
15904	20193	1	applied	\N	\N	\N	\N	64603	64603	64604
15904	20194	2	applied	\N	\N	\N	\N	64605	64605	64606
15904	20195	3	applied	\N	\N	\N	\N	64607	64607	64608
15904	20196	4	applied	\N	\N	\N	\N	64609	64609	51948
15904	20197	5	applied	\N	\N	\N	\N	64610	64610	51950
15907	20192	0	applied	\N	\N	\N	\N	64601	64601	64602
15907	20193	1	applied	\N	\N	\N	\N	64603	64603	64604
15907	20194	2	applied	\N	\N	\N	\N	64605	64605	64606
15907	20195	3	applied	\N	\N	\N	\N	64607	64607	64608
15907	20196	4	applied	\N	\N	\N	\N	64609	64609	51948
15907	20197	5	applied	\N	\N	\N	\N	64610	64610	51950
15908	20198	0	applied	\N	\N	\N	\N	64615	64615	64616
15908	20199	1	applied	\N	\N	\N	\N	64617	64617	51952
15911	20200	0	applied	\N	\N	\N	\N	64622	64622	64623
15911	20201	1	applied	\N	\N	\N	\N	64624	64624	64625
15911	20202	2	applied	\N	\N	\N	\N	64626	64626	64627
15913	20206	0	applied	\N	\N	\N	\N	64636	64636	64637
15913	20207	1	applied	\N	\N	\N	\N	64638	64638	51977
15913	20208	2	applied	\N	\N	\N	\N	64639	64639	64640
15916	20215	0	applied	\N	\N	\N	\N	64657	64657	64658
15916	20216	1	applied	\N	\N	\N	\N	64659	64659	64660
15916	20217	2	applied	\N	\N	\N	\N	64661	64661	64662
15916	20218	3	applied	\N	\N	\N	\N	64663	64663	52008
15916	20219	4	applied	\N	\N	\N	\N	64664	64664	64665
15919	20215	0	applied	\N	\N	\N	\N	64657	64657	64658
15919	20216	1	applied	\N	\N	\N	\N	64659	64659	64660
15919	20217	2	applied	\N	\N	\N	\N	64661	64661	64662
15919	20220	3	applied	\N	\N	\N	\N	64668	64668	64669
15919	20218	4	applied	\N	\N	\N	\N	64663	64663	64670
15919	20219	5	applied	\N	\N	\N	\N	64664	64664	64671
15920	20221	0	applied	\N	\N	\N	\N	64676	64676	64677
15920	20222	1	applied	\N	\N	\N	\N	64678	64678	64679
15920	20223	2	applied	\N	\N	\N	\N	64680	64680	52027
15923	20227	0	applied	\N	\N	\N	\N	64691	64691	64692
15923	20228	1	applied	\N	\N	\N	\N	64693	64693	64694
15923	20229	2	applied	\N	\N	\N	\N	64695	64695	64696
15923	20230	3	applied	\N	\N	\N	\N	64697	64697	52041
15923	20231	4	applied	\N	\N	\N	\N	64698	64698	52047
15923	20232	5	applied	\N	\N	\N	\N	64699	64699	52051
15925	20233	0	applied	\N	\N	\N	\N	64701	64701	64702
15925	20234	1	applied	\N	\N	\N	\N	64703	64703	52059
15925	20235	2	applied	\N	\N	\N	\N	64704	64704	52061
15930	20238	0	applied	\N	\N	\N	\N	64716	64716	64717
15930	20239	1	applied	\N	\N	\N	\N	64718	64718	64719
15930	20240	2	applied	\N	\N	\N	\N	64720	64720	64721
15930	20241	3	applied	\N	\N	\N	\N	64722	64722	52073
15930	20242	4	applied	\N	\N	\N	\N	64723	64723	64724
15930	20243	5	applied	\N	\N	\N	\N	64725	64725	64726
15930	20244	6	applied	\N	\N	\N	\N	64727	64727	52095
15930	20245	7	applied	\N	\N	\N	\N	64728	64728	64729
15930	20246	8	applied	\N	\N	\N	\N	64730	64730	52099
15933	20247	0	applied	\N	\N	\N	\N	64734	64734	64735
15933	20248	1	applied	\N	\N	\N	\N	64736	64736	64737
15933	20249	2	applied	\N	\N	\N	\N	64738	64738	64739
15937	20253	0	applied	\N	\N	\N	\N	64752	64752	64753
15937	20254	1	applied	\N	\N	\N	\N	64754	64754	52113
15937	20255	2	applied	\N	\N	\N	\N	64755	64755	64756
15939	20256	0	applied	\N	\N	\N	\N	64759	64759	64760
15939	20257	1	applied	\N	\N	\N	\N	64761	64761	52117
15939	20258	2	applied	\N	\N	\N	\N	64762	64762	64763
15947	20274	0	applied	\N	\N	\N	\N	64801	64801	64802
15947	20275	1	applied	\N	\N	\N	\N	64803	64803	52173
15947	20276	2	applied	\N	\N	\N	\N	64804	64804	64805
15949	20277	0	applied	\N	\N	\N	\N	64809	64809	64810
15949	20278	1	applied	\N	\N	\N	\N	64811	64811	64812
15949	20279	2	applied	\N	\N	\N	\N	64813	64813	52177
15949	20280	3	applied	\N	\N	\N	\N	64814	64814	52183
15949	20281	4	applied	\N	\N	\N	\N	64815	64815	64816
15949	20282	5	applied	\N	\N	\N	\N	64817	64817	52195
15954	20292	0	applied	\N	\N	\N	\N	64842	64842	64843
15954	20293	1	applied	\N	\N	\N	\N	64844	64844	64845
15954	20294	2	applied	\N	\N	\N	\N	64846	64846	64847
15956	20292	0	applied	\N	\N	\N	\N	64842	64842	64843
15956	20293	1	applied	\N	\N	\N	\N	64844	64844	64845
15956	20294	2	applied	\N	\N	\N	\N	64846	64846	64847
15965	20304	0	applied	\N	\N	\N	\N	64875	64875	64876
15965	20305	1	applied	\N	\N	\N	\N	64877	64877	64878
15965	20306	2	applied	\N	\N	\N	\N	64879	64879	52267
15968	20307	0	applied	\N	\N	\N	\N	64882	64882	64883
15968	20308	1	applied	\N	\N	\N	\N	64884	64884	64885
15968	20309	2	applied	\N	\N	\N	\N	64886	64886	52275
15968	20310	3	applied	\N	\N	\N	\N	64887	64887	64888
15968	20311	4	applied	\N	\N	\N	\N	64889	64889	64890
15968	20312	5	applied	\N	\N	\N	\N	64891	64891	64892
15972	20313	0	applied	\N	\N	\N	\N	64899	64899	64900
15972	20314	1	applied	\N	\N	\N	\N	64901	64901	64902
15972	20315	2	applied	\N	\N	\N	\N	64903	64903	52295
15975	20319	0	applied	\N	\N	\N	\N	64910	64910	64911
15975	20320	1	applied	\N	\N	\N	\N	64912	64912	64913
15975	20321	2	applied	\N	\N	\N	\N	64914	64914	64915
15978	20338	0	applied	\N	\N	\N	\N	64949	64949	64950
15978	20339	1	applied	\N	\N	\N	\N	64951	64951	64952
15978	20340	2	applied	\N	\N	\N	\N	64953	64953	64954
15983	20350	0	applied	\N	\N	\N	\N	64977	64977	64978
15983	20351	1	applied	\N	\N	\N	\N	64979	64979	52389
15983	20352	2	applied	\N	\N	\N	\N	64980	64980	52391
15986	20353	0	applied	\N	\N	\N	\N	64983	64983	64984
15986	20354	1	applied	\N	\N	\N	\N	64985	64985	64986
15986	20355	2	applied	\N	\N	\N	\N	64987	64987	64988
15988	20362	0	applied	\N	\N	\N	\N	65005	65005	65006
15988	20363	1	applied	\N	\N	\N	\N	65007	65007	52426
15988	20364	2	applied	\N	\N	\N	\N	65008	65008	65009
15928	20236	0	applied	\N	\N	\N	\N	64709	64709	64710
15928	20237	1	applied	\N	\N	\N	\N	64711	64711	64712
15931	20238	0	applied	\N	\N	\N	\N	64716	64716	64717
15931	20239	1	applied	\N	\N	\N	\N	64718	64718	64719
15931	20240	2	applied	\N	\N	\N	\N	64720	64720	64721
15931	20241	3	applied	\N	\N	\N	\N	64722	64722	52073
15931	20242	4	applied	\N	\N	\N	\N	64723	64723	64724
15931	20243	5	applied	\N	\N	\N	\N	64725	64725	64726
15931	20244	6	applied	\N	\N	\N	\N	64727	64727	52095
15931	20245	7	applied	\N	\N	\N	\N	64728	64728	64729
15931	20246	8	applied	\N	\N	\N	\N	64730	64730	52099
15934	20247	0	applied	\N	\N	\N	\N	64734	64734	64735
15934	20248	1	applied	\N	\N	\N	\N	64736	64736	64737
15934	20249	2	applied	\N	\N	\N	\N	64738	64738	64739
15935	20250	0	applied	\N	\N	\N	\N	64745	64745	64746
15935	20251	1	applied	\N	\N	\N	\N	64747	64747	64748
15935	20252	2	applied	\N	\N	\N	\N	64749	64749	52109
15938	20253	0	applied	\N	\N	\N	\N	64752	64752	64753
15938	20254	1	applied	\N	\N	\N	\N	64754	64754	52113
15938	20255	2	applied	\N	\N	\N	\N	64755	64755	64756
15942	20259	0	applied	\N	\N	\N	\N	64770	64770	64771
15942	20260	1	applied	\N	\N	\N	\N	64772	64772	64773
15942	20261	2	applied	\N	\N	\N	\N	64774	64774	64775
15942	20262	3	applied	\N	\N	\N	\N	64776	64776	52139
15942	20263	4	applied	\N	\N	\N	\N	64777	64777	64778
15942	20264	5	applied	\N	\N	\N	\N	64779	64779	52143
15945	20271	0	applied	\N	\N	\N	\N	64792	64792	64793
15945	20272	1	applied	\N	\N	\N	\N	64794	64794	52163
15945	20273	2	applied	\N	\N	\N	\N	64795	64795	64796
15950	20277	0	applied	\N	\N	\N	\N	64809	64809	64810
15950	20278	1	applied	\N	\N	\N	\N	64811	64811	64812
15950	20279	2	applied	\N	\N	\N	\N	64813	64813	52177
15950	20280	3	applied	\N	\N	\N	\N	64814	64814	52183
15950	20281	4	applied	\N	\N	\N	\N	64815	64815	64816
15950	20282	5	applied	\N	\N	\N	\N	64817	64817	52195
15952	20286	0	applied	\N	\N	\N	\N	64828	64828	64829
15952	20287	1	applied	\N	\N	\N	\N	64830	64830	64831
15952	20288	2	applied	\N	\N	\N	\N	64832	64832	52210
15957	20295	0	applied	\N	\N	\N	\N	64851	64851	64852
15957	20296	1	applied	\N	\N	\N	\N	64853	64853	52235
15957	20297	2	applied	\N	\N	\N	\N	64854	64854	52242
15960	20295	0	applied	\N	\N	\N	\N	64851	64851	64852
15960	20296	1	applied	\N	\N	\N	\N	64853	64853	52235
15960	20297	2	applied	\N	\N	\N	\N	64854	64854	52242
15969	20307	0	applied	\N	\N	\N	\N	64882	64882	64883
15969	20308	1	applied	\N	\N	\N	\N	64884	64884	64885
15969	20309	2	applied	\N	\N	\N	\N	64886	64886	52275
15969	20310	3	applied	\N	\N	\N	\N	64887	64887	64888
15969	20311	4	applied	\N	\N	\N	\N	64889	64889	64890
15969	20312	5	applied	\N	\N	\N	\N	64891	64891	64892
15971	20307	0	applied	\N	\N	\N	\N	64882	64882	64883
15971	20308	1	applied	\N	\N	\N	\N	64884	64884	64885
15971	20309	2	applied	\N	\N	\N	\N	64886	64886	52275
15971	20310	3	applied	\N	\N	\N	\N	64887	64887	64888
15971	20311	4	applied	\N	\N	\N	\N	64889	64889	64890
15971	20312	5	applied	\N	\N	\N	\N	64891	64891	64892
15979	20338	0	applied	\N	\N	\N	\N	64949	64949	64950
15979	20339	1	applied	\N	\N	\N	\N	64951	64951	64952
15979	20340	2	applied	\N	\N	\N	\N	64953	64953	64954
15989	20362	0	applied	\N	\N	\N	\N	65005	65005	65006
15989	20363	1	applied	\N	\N	\N	\N	65007	65007	52426
15989	20364	2	applied	\N	\N	\N	\N	65008	65008	65009
15993	20371	0	applied	\N	\N	\N	\N	65027	65027	65028
15993	20372	1	applied	\N	\N	\N	\N	65029	65029	52465
15993	20373	2	applied	\N	\N	\N	\N	65030	65030	65031
15999	20383	0	applied	\N	\N	\N	\N	65050	65050	65051
15999	20384	1	applied	\N	\N	\N	\N	65052	65052	65053
15999	20385	2	applied	\N	\N	\N	\N	65054	65054	65055
15999	20386	3	applied	\N	\N	1000000000	\N	65056	65056	65057
15999	20387	4	applied	\N	\N	\N	\N	65058	65058	65059
15999	20388	5	applied	\N	\N	\N	\N	65060	65060	52500
15999	20389	6	applied	\N	\N	\N	\N	65061	65061	65062
15999	20390	7	applied	\N	\N	\N	\N	65063	65063	65064
15999	20391	8	applied	\N	\N	\N	\N	65065	65065	52512
15999	20392	9	applied	\N	\N	\N	\N	65066	65066	52516
16002	20402	0	applied	\N	\N	\N	\N	65086	65086	65087
16002	20403	1	applied	\N	\N	\N	\N	65088	65088	52547
16002	20404	2	applied	\N	\N	\N	\N	65089	65089	65090
16005	20409	0	applied	\N	\N	\N	\N	65101	65101	65102
16005	20410	1	applied	\N	\N	\N	\N	65103	65103	65104
16005	20411	2	applied	\N	\N	\N	\N	65105	65105	65106
16005	20412	3	applied	\N	\N	\N	\N	65107	65107	65108
16005	20413	4	applied	\N	\N	\N	\N	65109	65109	65110
16005	20414	5	applied	\N	\N	\N	\N	65111	65111	65112
16005	20415	6	applied	\N	\N	\N	\N	65113	65113	52584
16005	20416	7	applied	\N	\N	\N	\N	65114	65114	52586
16005	20417	8	applied	\N	\N	\N	\N	65115	65115	52588
16005	20418	9	applied	\N	\N	\N	\N	65116	65116	65117
16009	20422	0	applied	\N	\N	\N	\N	65126	65126	65127
16009	20423	1	applied	\N	\N	\N	\N	65128	65128	65129
16009	20424	2	applied	\N	\N	\N	\N	65130	65130	65131
16009	20425	3	applied	\N	\N	\N	\N	65132	65132	65133
16009	20426	4	applied	\N	\N	\N	\N	65134	65134	65135
16009	20427	5	applied	\N	\N	\N	\N	65136	65136	65137
16009	20428	6	applied	\N	\N	\N	\N	65138	65138	52602
16009	20429	7	applied	\N	\N	\N	\N	65139	65139	65140
16009	20430	8	applied	\N	\N	\N	\N	65141	65141	52616
16009	20431	9	applied	\N	\N	\N	\N	65142	65142	65143
16009	20432	10	applied	\N	\N	\N	\N	65144	65144	65145
16009	20433	11	applied	\N	\N	\N	\N	65146	65146	52622
16009	20434	12	applied	\N	\N	\N	\N	65147	65147	65148
16009	20435	13	applied	\N	\N	\N	\N	65149	65149	52636
16009	20436	14	applied	\N	\N	\N	\N	65150	65150	52638
16009	20437	15	applied	\N	\N	\N	\N	65151	65151	65152
16011	20438	0	applied	\N	\N	\N	\N	65159	65159	65160
16011	20439	1	applied	\N	\N	\N	\N	65161	65161	65162
16011	20440	2	applied	\N	\N	\N	\N	65163	65163	52656
16011	20441	3	applied	\N	\N	\N	\N	65164	65164	65165
16017	20445	0	applied	\N	\N	\N	\N	65179	65179	65180
16017	20446	1	applied	\N	\N	\N	\N	65181	65181	52666
16017	20447	2	applied	\N	\N	\N	\N	65182	65182	65183
16027	20462	0	applied	\N	\N	\N	\N	65219	65219	65220
16027	20463	1	applied	\N	\N	\N	\N	65221	65221	65222
16027	20464	2	applied	\N	\N	\N	\N	65223	65223	65224
16027	20465	3	applied	\N	\N	\N	\N	65225	65225	65226
16027	20466	4	applied	\N	\N	\N	\N	65227	65227	52703
16027	20467	5	applied	\N	\N	\N	\N	65228	65228	65229
16027	20468	6	applied	\N	\N	\N	\N	65230	65230	52722
16027	20469	7	applied	\N	\N	\N	\N	65231	65231	52726
16027	20470	8	applied	\N	\N	\N	\N	65232	65232	52728
15981	20341	0	applied	\N	\N	\N	\N	64957	64957	64958
15981	20342	1	applied	\N	\N	\N	\N	64959	64959	64960
15981	20343	2	applied	\N	\N	\N	\N	64961	64961	64962
15984	20353	0	applied	\N	\N	\N	\N	64983	64983	64984
15984	20354	1	applied	\N	\N	\N	\N	64985	64985	64986
15984	20355	2	applied	\N	\N	\N	\N	64987	64987	64988
15991	20365	0	applied	\N	\N	\N	\N	65012	65012	65013
15991	20366	1	applied	\N	\N	\N	\N	65014	65014	65015
15991	20367	2	applied	\N	\N	\N	\N	65016	65016	52443
15994	20371	0	applied	\N	\N	\N	\N	65027	65027	65028
15994	20372	1	applied	\N	\N	\N	\N	65029	65029	52465
15994	20373	2	applied	\N	\N	\N	\N	65030	65030	65031
15996	20377	0	applied	\N	\N	\N	\N	65040	65040	65041
15996	20378	1	applied	\N	\N	\N	\N	65042	65042	52479
15996	20379	2	applied	\N	\N	\N	\N	65043	65043	52484
16000	20393	0	applied	\N	\N	\N	\N	65069	65069	65070
16000	20394	1	applied	\N	\N	\N	\N	65071	65071	65072
16000	20395	2	applied	\N	\N	\N	\N	65073	65073	65074
16000	20396	3	applied	\N	\N	\N	\N	65075	65075	65076
16000	20397	4	applied	\N	\N	\N	\N	65077	65077	52520
16000	20398	5	applied	\N	\N	\N	\N	65078	65078	65079
16000	20399	6	applied	\N	\N	\N	\N	65080	65080	52533
16000	20400	7	applied	\N	\N	\N	\N	65081	65081	52543
16000	20401	8	applied	\N	\N	\N	\N	65082	65082	65083
16012	20438	0	applied	\N	\N	\N	\N	65159	65159	65160
16012	20439	1	applied	\N	\N	\N	\N	65161	65161	65162
16012	20440	2	applied	\N	\N	\N	\N	65163	65163	52656
16012	20441	3	applied	\N	\N	\N	\N	65164	65164	65165
16015	20442	0	applied	\N	\N	\N	\N	65171	65171	65172
16015	20443	1	applied	\N	\N	\N	\N	65173	65173	65174
16015	20444	2	applied	\N	\N	\N	\N	65175	65175	52662
16018	20445	0	applied	\N	\N	\N	\N	65179	65179	65180
16018	20446	1	applied	\N	\N	\N	\N	65181	65181	52666
16018	20447	2	applied	\N	\N	\N	\N	65182	65182	65183
16022	20455	0	applied	\N	\N	\N	\N	65201	65201	65202
16022	20456	1	applied	\N	\N	\N	\N	65203	65203	52689
16022	20457	2	applied	\N	\N	\N	\N	65204	65204	52693
16047	20518	0	applied	\N	\N	\N	\N	65336	65336	65337
16047	20519	1	applied	\N	\N	\N	\N	65338	65338	52844
16047	20520	2	applied	\N	\N	\N	\N	65339	65339	52846
16052	20531	0	applied	\N	\N	\N	\N	65365	65365	65366
16052	20532	1	applied	\N	\N	\N	\N	65367	65367	65368
16052	20533	2	applied	\N	\N	\N	\N	65369	65369	52886
16052	20534	3	applied	\N	\N	\N	\N	65370	65370	52888
16052	20535	4	applied	\N	\N	\N	\N	65371	65371	52890
16052	20536	5	applied	\N	\N	\N	\N	65372	65372	65373
16054	20200	0	applied	\N	\N	\N	\N	64622	64622	64623
16054	20203	1	applied	\N	\N	\N	\N	64630	64630	64631
16054	20206	2	applied	\N	\N	\N	\N	64636	64636	64637
16054	20209	3	applied	\N	\N	\N	\N	64642	64642	64643
16054	20210	4	applied	\N	\N	\N	\N	64644	64644	64645
16054	20215	5	applied	\N	\N	\N	\N	64657	64657	64658
16054	20216	6	applied	\N	\N	\N	\N	64659	64659	64660
16054	20221	7	applied	\N	\N	\N	\N	64676	64676	64677
16054	20386	8	applied	\N	\N	1000000000	\N	65056	65056	65057
16054	20224	9	applied	\N	\N	\N	\N	64683	64683	64684
16054	20227	10	applied	\N	\N	\N	\N	64691	64691	64692
16054	20228	11	applied	\N	\N	\N	\N	64693	64693	64694
16054	20233	12	applied	\N	\N	\N	\N	64701	64701	64702
16054	20236	13	applied	\N	\N	\N	\N	64709	64709	64710
16054	20238	14	applied	\N	\N	\N	\N	64716	64716	64717
16054	20239	15	applied	\N	\N	\N	\N	64718	64718	64719
16054	20240	16	applied	\N	\N	\N	\N	64720	64720	64721
16054	20247	17	applied	\N	\N	\N	\N	64734	64734	64735
16054	20250	18	applied	\N	\N	\N	\N	64745	64745	64746
16054	20253	19	applied	\N	\N	\N	\N	64752	64752	64753
16054	20256	20	applied	\N	\N	\N	\N	64759	64759	64760
16054	20259	21	applied	\N	\N	\N	\N	64770	64770	64771
16054	20260	22	applied	\N	\N	\N	\N	64772	64772	64773
16054	20265	23	applied	\N	\N	\N	\N	64781	64781	64782
16054	20266	24	applied	\N	\N	\N	\N	64783	64783	64784
16054	20271	25	applied	\N	\N	\N	\N	64792	64792	64793
16054	20274	26	applied	\N	\N	\N	\N	64801	64801	64802
16054	20277	27	applied	\N	\N	\N	\N	64809	64809	64810
16054	20278	28	applied	\N	\N	\N	\N	64811	64811	64812
16054	20283	29	applied	\N	\N	\N	\N	64820	64820	64821
16054	20286	30	applied	\N	\N	\N	\N	64828	64828	64829
16054	20289	31	applied	\N	\N	\N	\N	64835	64835	64836
16054	20292	32	applied	\N	\N	\N	\N	64842	64842	64843
16054	20295	33	applied	\N	\N	\N	\N	64851	64851	64852
16054	20298	34	applied	\N	\N	\N	\N	64859	64859	64860
16054	20299	35	applied	\N	\N	\N	\N	64861	64861	64862
16054	20304	36	applied	\N	\N	\N	\N	64875	64875	64876
16054	20307	37	applied	\N	\N	\N	\N	64882	64882	64883
16054	20308	38	applied	\N	\N	\N	\N	64884	64884	64885
16054	20313	39	applied	\N	\N	\N	\N	64899	64899	64900
16054	20316	40	applied	\N	\N	\N	\N	64906	64906	64907
16054	20319	41	applied	\N	\N	\N	\N	64910	64910	64911
16054	20322	42	applied	\N	\N	\N	\N	64919	64919	64920
16054	20323	43	applied	\N	\N	\N	\N	64921	64921	64922
16054	20324	44	applied	\N	\N	\N	\N	64923	64923	64924
16054	20325	45	applied	\N	\N	\N	\N	64925	64925	64926
16054	20326	46	applied	\N	\N	\N	\N	64927	64927	64928
16054	20338	47	applied	\N	\N	\N	\N	64949	64949	64950
16054	20341	48	applied	\N	\N	\N	\N	64957	64957	64958
16054	20344	49	applied	\N	\N	\N	\N	64965	64965	64966
16054	20345	50	applied	\N	\N	\N	\N	64967	64967	64968
16054	20350	51	applied	\N	\N	\N	\N	64977	64977	64978
16054	20353	52	applied	\N	\N	\N	\N	64983	64983	64984
16054	20356	53	applied	\N	\N	\N	\N	64993	64993	64994
16054	20357	54	applied	\N	\N	\N	\N	64995	64995	64996
16054	20362	55	applied	\N	\N	\N	\N	65005	65005	65006
16054	20365	56	applied	\N	\N	\N	\N	65012	65012	65013
16054	20368	57	applied	\N	\N	\N	\N	65019	65019	65020
16054	20371	58	applied	\N	\N	\N	\N	65027	65027	65028
16054	20374	59	applied	\N	\N	\N	\N	65034	65034	65035
16054	20377	60	applied	\N	\N	\N	\N	65040	65040	65041
16054	20380	61	applied	\N	\N	\N	\N	65045	65045	65046
16054	20383	62	applied	\N	\N	\N	\N	65050	65050	65051
16054	20384	63	applied	\N	\N	\N	\N	65052	65052	65053
16054	20385	64	applied	\N	\N	\N	\N	65054	65054	65055
16054	20393	65	applied	\N	\N	\N	\N	65069	65069	65070
16054	20394	66	applied	\N	\N	\N	\N	65071	65071	65072
16054	20395	67	applied	\N	\N	\N	\N	65073	65073	65074
16054	20402	68	applied	\N	\N	\N	\N	65086	65086	65087
16054	20405	69	applied	\N	\N	\N	\N	65092	65092	65093
16054	20409	70	applied	\N	\N	\N	\N	65101	65101	65102
16054	20410	71	applied	\N	\N	\N	\N	65103	65103	65104
16054	20411	72	applied	\N	\N	\N	\N	65105	65105	65106
16054	20419	73	applied	\N	\N	\N	\N	65121	65121	65122
15987	20359	3	applied	\N	\N	\N	\N	64999	64999	65000
15987	20360	4	applied	\N	\N	\N	\N	65001	65001	52416
15987	20361	5	applied	\N	\N	\N	\N	65002	65002	52424
15992	20368	0	applied	\N	\N	\N	\N	65019	65019	65020
15992	20369	2	applied	\N	\N	\N	\N	65022	65022	65023
15992	20370	3	applied	\N	\N	\N	\N	65024	65024	52453
15997	20380	0	applied	\N	\N	\N	\N	65045	65045	65046
15997	20381	1	applied	\N	\N	\N	\N	65047	65047	52486
15997	20382	2	applied	\N	\N	\N	\N	65048	65048	65049
16003	20405	0	applied	\N	\N	\N	\N	65092	65092	65093
16003	20406	1	applied	\N	\N	\N	\N	65094	65094	52553
16003	20407	2	applied	\N	\N	\N	\N	65095	65095	65096
16003	20408	3	applied	\N	\N	\N	\N	65097	65097	65098
16006	20419	0	applied	\N	\N	\N	\N	65121	65121	65122
16006	20420	1	applied	\N	\N	\N	\N	65123	65123	65124
16006	20421	2	applied	\N	\N	\N	\N	65125	65125	52596
16007	20422	0	applied	\N	\N	\N	\N	65126	65126	65127
16007	20423	1	applied	\N	\N	\N	\N	65128	65128	65129
16007	20424	2	applied	\N	\N	\N	\N	65130	65130	65131
16007	20425	3	applied	\N	\N	\N	\N	65132	65132	65133
16007	20426	4	applied	\N	\N	\N	\N	65134	65134	65135
16007	20427	5	applied	\N	\N	\N	\N	65136	65136	65137
16007	20428	6	applied	\N	\N	\N	\N	65138	65138	52602
16007	20429	7	applied	\N	\N	\N	\N	65139	65139	65140
16007	20430	8	applied	\N	\N	\N	\N	65141	65141	52616
16007	20431	9	applied	\N	\N	\N	\N	65142	65142	65143
16007	20432	10	applied	\N	\N	\N	\N	65144	65144	65145
16007	20433	11	applied	\N	\N	\N	\N	65146	65146	52622
16007	20434	12	applied	\N	\N	\N	\N	65147	65147	65148
16007	20435	13	applied	\N	\N	\N	\N	65149	65149	52636
16007	20436	14	applied	\N	\N	\N	\N	65150	65150	52638
16007	20437	15	applied	\N	\N	\N	\N	65151	65151	65152
16020	20448	0	applied	\N	\N	\N	\N	65187	65187	65188
16020	20449	1	applied	\N	\N	\N	\N	65189	65189	52668
16020	20450	2	applied	\N	\N	\N	\N	65190	65190	52672
16020	20451	3	applied	\N	\N	\N	\N	65191	65191	65192
16023	20458	0	applied	\N	\N	\N	\N	65207	65207	65208
16023	20459	1	applied	\N	\N	\N	\N	65209	65209	65210
16023	20460	3	applied	\N	\N	\N	\N	65212	65212	52695
16023	20461	4	applied	\N	\N	\N	\N	65213	65213	52699
16025	20458	0	applied	\N	\N	\N	\N	65207	65207	65208
16025	20459	1	applied	\N	\N	\N	\N	65209	65209	65210
16025	20460	3	applied	\N	\N	\N	\N	65212	65212	52695
16025	20461	4	applied	\N	\N	\N	\N	65213	65213	52699
16028	20471	0	applied	\N	\N	\N	\N	65236	65236	65237
16028	20472	1	applied	\N	\N	\N	\N	65238	65238	52730
16028	20473	2	applied	\N	\N	\N	\N	65239	65239	65240
16028	20474	3	applied	\N	\N	\N	\N	65241	65241	52734
16030	20475	0	applied	\N	\N	\N	\N	65243	65243	65244
16030	20476	1	applied	\N	\N	\N	\N	65245	65245	52736
16030	20477	2	applied	\N	\N	\N	\N	65246	65246	65247
16033	20485	0	applied	\N	\N	\N	\N	65264	65264	65265
16033	20486	1	applied	\N	\N	\N	\N	65266	65266	52752
16033	20487	2	applied	\N	\N	\N	\N	65267	65267	52756
16036	20495	0	applied	\N	\N	\N	\N	65284	65284	65285
16036	20496	1	applied	\N	\N	\N	\N	65286	65286	65287
16036	20497	2	applied	\N	\N	\N	\N	65288	65288	65289
16036	20498	3	applied	\N	\N	\N	\N	65290	65290	52795
16038	20501	0	applied	\N	\N	\N	\N	65296	65296	65297
16038	20502	1	applied	\N	\N	\N	\N	65298	65298	52801
16038	20503	2	applied	\N	\N	\N	\N	65299	65299	65300
16041	20504	0	applied	\N	\N	\N	\N	65303	65303	65304
16041	20505	1	applied	\N	\N	\N	\N	65305	65305	52813
16041	20506	2	applied	\N	\N	\N	\N	65306	65306	52815
16041	20507	3	applied	\N	\N	\N	\N	65307	65307	65308
16045	20514	0	applied	\N	\N	\N	\N	65328	65328	65329
16045	20515	1	applied	\N	\N	\N	\N	65330	65330	52838
16045	20516	2	applied	\N	\N	\N	\N	65331	65331	52840
16045	20517	3	applied	\N	\N	\N	\N	65332	65332	52842
16050	20524	0	applied	\N	\N	\N	\N	65351	65351	65352
16050	20525	1	applied	\N	\N	\N	\N	65353	65353	52862
16050	20526	2	applied	\N	\N	\N	\N	65354	65354	52864
16050	20527	3	applied	\N	\N	\N	\N	65355	65355	65356
16053	20531	0	applied	\N	\N	\N	\N	65365	65365	65366
16053	20532	1	applied	\N	\N	\N	\N	65367	65367	65368
16053	20533	2	applied	\N	\N	\N	\N	65369	65369	52886
16053	20534	3	applied	\N	\N	\N	\N	65370	65370	52888
16053	20535	4	applied	\N	\N	\N	\N	65371	65371	52890
16053	20536	5	applied	\N	\N	\N	\N	65372	65372	65373
16055	20537	0	applied	\N	\N	\N	\N	65379	65379	65380
16055	20538	1	applied	\N	\N	\N	\N	65381	65381	52901
16055	20539	2	applied	\N	\N	\N	\N	65382	65382	65383
16055	20540	3	applied	\N	\N	\N	\N	65384	65384	65385
16058	20541	0	applied	\N	\N	\N	\N	65388	65388	65389
16058	20542	1	applied	\N	\N	\N	\N	65390	65390	65391
16058	20543	2	applied	\N	\N	\N	\N	65392	65392	65393
16058	20544	3	applied	\N	\N	\N	\N	65394	65394	52907
16058	20545	4	applied	\N	\N	\N	\N	65395	65395	52909
16058	20546	5	applied	\N	\N	\N	\N	65396	65396	65397
16058	20547	6	applied	\N	\N	\N	\N	65398	65398	52918
16060	20548	0	applied	\N	\N	\N	\N	65402	65402	65403
16060	20549	1	applied	\N	\N	\N	\N	65404	65404	65405
16060	20550	2	applied	\N	\N	\N	\N	65406	65406	65407
16060	20551	3	applied	\N	\N	\N	\N	65408	65408	52928
16064	20552	0	applied	\N	\N	\N	\N	65411	65411	65412
16064	20553	1	applied	\N	\N	\N	\N	65413	65413	65414
16064	20554	2	applied	\N	\N	\N	\N	65415	65415	65416
16064	20555	3	applied	\N	\N	\N	\N	65417	65417	52938
16069	20562	0	applied	\N	\N	\N	\N	65439	65439	65440
16069	20563	1	applied	\N	\N	\N	\N	65441	65441	65442
16069	20564	2	applied	\N	\N	\N	\N	65443	65443	65444
16069	20565	3	applied	\N	\N	\N	\N	65445	65445	52962
16069	20566	4	applied	\N	\N	\N	\N	65446	65446	65447
16069	20567	5	applied	\N	\N	\N	\N	65448	65448	65449
16069	20568	6	applied	\N	\N	\N	\N	65450	65450	65451
16072	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16072	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16072	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16072	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16072	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16072	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16072	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16075	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16075	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16075	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16075	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16075	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16075	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16075	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16082	20581	0	applied	\N	\N	\N	\N	65490	65490	65491
15990	20362	0	applied	\N	\N	\N	\N	65005	65005	65006
15990	20363	1	applied	\N	\N	\N	\N	65007	65007	52426
15990	20364	2	applied	\N	\N	\N	\N	65008	65008	65009
15995	20374	0	applied	\N	\N	\N	\N	65034	65034	65035
15995	20375	1	applied	\N	\N	\N	\N	65036	65036	65037
15995	20376	2	applied	\N	\N	\N	\N	65038	65038	65039
15998	20383	0	applied	\N	\N	\N	\N	65050	65050	65051
15998	20384	1	applied	\N	\N	\N	\N	65052	65052	65053
15998	20385	2	applied	\N	\N	\N	\N	65054	65054	65055
15998	20386	3	applied	\N	\N	1000000000	\N	65056	65056	65057
15998	20387	4	applied	\N	\N	\N	\N	65058	65058	65059
15998	20388	5	applied	\N	\N	\N	\N	65060	65060	52500
15998	20389	6	applied	\N	\N	\N	\N	65061	65061	65062
15998	20390	7	applied	\N	\N	\N	\N	65063	65063	65064
15998	20391	8	applied	\N	\N	\N	\N	65065	65065	52512
15998	20392	9	applied	\N	\N	\N	\N	65066	65066	52516
16001	20402	0	applied	\N	\N	\N	\N	65086	65086	65087
16001	20403	1	applied	\N	\N	\N	\N	65088	65088	52547
16001	20404	2	applied	\N	\N	\N	\N	65089	65089	65090
16004	20409	0	applied	\N	\N	\N	\N	65101	65101	65102
16004	20410	1	applied	\N	\N	\N	\N	65103	65103	65104
16004	20411	2	applied	\N	\N	\N	\N	65105	65105	65106
16004	20412	3	applied	\N	\N	\N	\N	65107	65107	65108
16004	20413	4	applied	\N	\N	\N	\N	65109	65109	65110
16004	20414	5	applied	\N	\N	\N	\N	65111	65111	65112
16004	20415	6	applied	\N	\N	\N	\N	65113	65113	52584
16004	20416	7	applied	\N	\N	\N	\N	65114	65114	52586
16004	20417	8	applied	\N	\N	\N	\N	65115	65115	52588
16004	20418	9	applied	\N	\N	\N	\N	65116	65116	65117
16008	20422	0	applied	\N	\N	\N	\N	65126	65126	65127
16008	20423	1	applied	\N	\N	\N	\N	65128	65128	65129
16008	20424	2	applied	\N	\N	\N	\N	65130	65130	65131
16008	20425	3	applied	\N	\N	\N	\N	65132	65132	65133
16008	20426	4	applied	\N	\N	\N	\N	65134	65134	65135
16008	20427	5	applied	\N	\N	\N	\N	65136	65136	65137
16008	20428	6	applied	\N	\N	\N	\N	65138	65138	52602
16008	20429	7	applied	\N	\N	\N	\N	65139	65139	65140
16008	20430	8	applied	\N	\N	\N	\N	65141	65141	52616
16008	20431	9	applied	\N	\N	\N	\N	65142	65142	65143
16008	20432	10	applied	\N	\N	\N	\N	65144	65144	65145
16008	20433	11	applied	\N	\N	\N	\N	65146	65146	52622
16008	20434	12	applied	\N	\N	\N	\N	65147	65147	65148
16008	20435	13	applied	\N	\N	\N	\N	65149	65149	52636
16008	20436	14	applied	\N	\N	\N	\N	65150	65150	52638
16008	20437	15	applied	\N	\N	\N	\N	65151	65151	65152
16010	20438	0	applied	\N	\N	\N	\N	65159	65159	65160
16010	20439	1	applied	\N	\N	\N	\N	65161	65161	65162
16010	20440	2	applied	\N	\N	\N	\N	65163	65163	52656
16010	20441	3	applied	\N	\N	\N	\N	65164	65164	65165
16013	20438	0	applied	\N	\N	\N	\N	65159	65159	65160
16013	20439	1	applied	\N	\N	\N	\N	65161	65161	65162
16013	20440	2	applied	\N	\N	\N	\N	65163	65163	52656
16013	20441	3	applied	\N	\N	\N	\N	65164	65164	65165
16014	20442	0	applied	\N	\N	\N	\N	65171	65171	65172
16014	20443	1	applied	\N	\N	\N	\N	65173	65173	65174
16014	20444	2	applied	\N	\N	\N	\N	65175	65175	52662
16016	20442	0	applied	\N	\N	\N	\N	65171	65171	65172
16016	20443	1	applied	\N	\N	\N	\N	65173	65173	65174
16016	20444	2	applied	\N	\N	\N	\N	65175	65175	52662
16019	20445	0	applied	\N	\N	\N	\N	65179	65179	65180
16019	20446	1	applied	\N	\N	\N	\N	65181	65181	52666
16019	20447	2	applied	\N	\N	\N	\N	65182	65182	65183
16021	20452	0	applied	\N	\N	\N	\N	65195	65195	65196
16021	20453	1	applied	\N	\N	\N	\N	65197	65197	65198
16021	20454	2	applied	\N	\N	\N	\N	65199	65199	65200
16024	20458	0	applied	\N	\N	\N	\N	65207	65207	65208
16024	20459	1	applied	\N	\N	\N	\N	65209	65209	65210
16024	20460	3	applied	\N	\N	\N	\N	65212	65212	52695
16024	20461	4	applied	\N	\N	\N	\N	65213	65213	52699
16026	20462	0	applied	\N	\N	\N	\N	65219	65219	65220
16026	20463	1	applied	\N	\N	\N	\N	65221	65221	65222
16026	20464	2	applied	\N	\N	\N	\N	65223	65223	65224
16026	20465	3	applied	\N	\N	\N	\N	65225	65225	65226
16026	20466	4	applied	\N	\N	\N	\N	65227	65227	52703
16026	20467	5	applied	\N	\N	\N	\N	65228	65228	65229
16026	20468	6	applied	\N	\N	\N	\N	65230	65230	52722
16026	20469	7	applied	\N	\N	\N	\N	65231	65231	52726
16026	20470	8	applied	\N	\N	\N	\N	65232	65232	52728
16031	20478	0	applied	\N	\N	\N	\N	65250	65250	65251
16031	20479	1	applied	\N	\N	\N	\N	65252	65252	65253
16031	20480	2	applied	\N	\N	\N	\N	65254	65254	52740
16031	20481	3	applied	\N	\N	\N	\N	65255	65255	52742
16031	20482	4	applied	\N	\N	\N	\N	65256	65256	65257
16031	20483	5	applied	\N	\N	\N	\N	65258	65258	65259
16031	20484	6	applied	\N	\N	\N	\N	65260	65260	65261
16034	20488	0	applied	\N	\N	\N	\N	65270	65270	65271
16034	20489	1	applied	\N	\N	\N	\N	65272	65272	65273
16034	20490	2	applied	\N	\N	\N	\N	65274	65274	65275
16034	20491	3	applied	\N	\N	\N	\N	65276	65276	52765
16034	20492	4	applied	\N	\N	\N	\N	65277	65277	52767
16034	20493	5	applied	\N	\N	\N	\N	65278	65278	65279
16034	20494	6	applied	\N	\N	\N	\N	65280	65280	52776
16039	20504	0	applied	\N	\N	\N	\N	65303	65303	65304
16039	20505	1	applied	\N	\N	\N	\N	65305	65305	52813
16039	20506	2	applied	\N	\N	\N	\N	65306	65306	52815
16039	20507	3	applied	\N	\N	\N	\N	65307	65307	65308
16042	20504	0	applied	\N	\N	\N	\N	65303	65303	65304
16042	20505	1	applied	\N	\N	\N	\N	65305	65305	52813
16042	20506	2	applied	\N	\N	\N	\N	65306	65306	52815
16042	20507	3	applied	\N	\N	\N	\N	65307	65307	65308
16043	20508	0	applied	\N	\N	\N	\N	65316	65316	65317
16043	20509	1	applied	\N	\N	\N	\N	65318	65318	65319
16043	20510	2	applied	\N	\N	\N	\N	65320	65320	65321
16046	20514	0	applied	\N	\N	\N	\N	65328	65328	65329
16046	20515	1	applied	\N	\N	\N	\N	65330	65330	52838
16046	20516	2	applied	\N	\N	\N	\N	65331	65331	52840
16046	20517	3	applied	\N	\N	\N	\N	65332	65332	52842
16048	20521	0	applied	\N	\N	\N	\N	65342	65342	65343
16048	20522	1	applied	\N	\N	\N	\N	65344	65344	65345
16048	20523	2	applied	\N	\N	\N	\N	65346	65346	65347
16063	20548	0	applied	\N	\N	\N	\N	65402	65402	65403
16063	20549	1	applied	\N	\N	\N	\N	65404	65404	65405
16063	20550	2	applied	\N	\N	\N	\N	65406	65406	65407
16063	20551	3	applied	\N	\N	\N	\N	65408	65408	52928
16067	20558	0	applied	\N	\N	\N	\N	65426	65426	65427
16067	20559	1	applied	\N	\N	\N	\N	65428	65428	52958
16067	20560	2	applied	\N	\N	\N	\N	65429	65429	65430
16067	20561	3	applied	\N	\N	\N	\N	65431	65431	52960
16070	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16070	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16029	20475	0	applied	\N	\N	\N	\N	65243	65243	65244
16029	20476	1	applied	\N	\N	\N	\N	65245	65245	52736
16029	20477	2	applied	\N	\N	\N	\N	65246	65246	65247
16035	20488	0	applied	\N	\N	\N	\N	65270	65270	65271
16035	20489	1	applied	\N	\N	\N	\N	65272	65272	65273
16035	20490	2	applied	\N	\N	\N	\N	65274	65274	65275
16035	20491	3	applied	\N	\N	\N	\N	65276	65276	52765
16035	20492	4	applied	\N	\N	\N	\N	65277	65277	52767
16035	20493	5	applied	\N	\N	\N	\N	65278	65278	65279
16035	20494	6	applied	\N	\N	\N	\N	65280	65280	52776
16037	20495	0	applied	\N	\N	\N	\N	65284	65284	65285
16037	20496	1	applied	\N	\N	\N	\N	65286	65286	65287
16037	20499	2	applied	\N	\N	\N	\N	65292	65292	65293
16037	20497	3	applied	\N	\N	\N	\N	65288	65288	65294
16037	20500	4	applied	\N	\N	\N	\N	65295	65295	52797
16037	20498	5	applied	\N	\N	\N	\N	65290	65290	52799
16040	20504	0	applied	\N	\N	\N	\N	65303	65303	65304
16040	20505	1	applied	\N	\N	\N	\N	65305	65305	52813
16040	20506	2	applied	\N	\N	\N	\N	65306	65306	52815
16040	20507	3	applied	\N	\N	\N	\N	65307	65307	65308
16044	20511	0	applied	\N	\N	\N	\N	65322	65322	65323
16044	20512	1	applied	\N	\N	\N	\N	65324	65324	52832
16044	20513	2	applied	\N	\N	\N	\N	65325	65325	52836
16049	20521	0	applied	\N	\N	\N	\N	65342	65342	65343
16049	20522	1	applied	\N	\N	\N	\N	65344	65344	65345
16049	20523	2	applied	\N	\N	\N	\N	65346	65346	65347
16051	20528	0	applied	\N	\N	\N	\N	65359	65359	65360
16051	20529	1	applied	\N	\N	\N	\N	65361	65361	52875
16051	20530	2	applied	\N	\N	\N	\N	65362	65362	52877
16056	20537	0	applied	\N	\N	\N	\N	65379	65379	65380
16056	20538	1	applied	\N	\N	\N	\N	65381	65381	52901
16056	20539	2	applied	\N	\N	\N	\N	65382	65382	65383
16056	20540	3	applied	\N	\N	\N	\N	65384	65384	65385
16061	20548	0	applied	\N	\N	\N	\N	65402	65402	65403
16061	20549	1	applied	\N	\N	\N	\N	65404	65404	65405
16061	20550	2	applied	\N	\N	\N	\N	65406	65406	65407
16061	20551	3	applied	\N	\N	\N	\N	65408	65408	52928
16065	20552	0	applied	\N	\N	\N	\N	65411	65411	65412
16065	20553	1	applied	\N	\N	\N	\N	65413	65413	65414
16065	20556	2	applied	\N	\N	\N	\N	65420	65420	65421
16065	20554	3	applied	\N	\N	\N	\N	65415	65415	65422
16065	20555	4	applied	\N	\N	\N	\N	65417	65417	65423
16065	20557	5	applied	\N	\N	\N	\N	65424	65424	52948
16068	20558	0	applied	\N	\N	\N	\N	65426	65426	65427
16068	20559	1	applied	\N	\N	\N	\N	65428	65428	65436
16068	20556	2	applied	\N	\N	\N	\N	65420	65420	65437
16068	20557	3	applied	\N	\N	\N	\N	65424	65424	52958
16068	20560	4	applied	\N	\N	\N	\N	65429	65429	65430
16068	20561	5	applied	\N	\N	\N	\N	65431	65431	52960
16071	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16071	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16071	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16071	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16071	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16071	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16071	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16074	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16074	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16074	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16074	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16074	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16074	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16074	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16079	20578	0	applied	\N	\N	\N	\N	65481	65481	65482
16079	20579	1	applied	\N	\N	\N	\N	65483	65483	53002
16079	20580	2	applied	\N	\N	\N	\N	65484	65484	65485
16081	20578	0	applied	\N	\N	\N	\N	65481	65481	65482
16081	20579	1	applied	\N	\N	\N	\N	65483	65483	53002
16081	20580	2	applied	\N	\N	\N	\N	65484	65484	65485
16086	20584	0	applied	\N	\N	\N	\N	65498	65498	65499
16086	20585	1	applied	\N	\N	\N	\N	65500	65500	65501
16086	20586	2	applied	\N	\N	\N	\N	65502	65502	65503
16092	20612	0	applied	\N	\N	\N	\N	65557	65557	65558
16092	20613	1	applied	\N	\N	\N	\N	65559	65559	65560
16092	20614	2	applied	\N	\N	\N	\N	65561	65561	53104
16092	20615	3	applied	\N	\N	\N	\N	65562	65562	65563
16092	20616	4	applied	\N	\N	\N	\N	65564	65564	53106
16092	20617	5	applied	\N	\N	\N	\N	65565	65565	53110
16092	20618	6	applied	\N	\N	\N	\N	65566	65566	53112
16095	20619	0	applied	\N	\N	\N	\N	65568	65568	65569
16095	20620	1	applied	\N	\N	\N	\N	65570	65570	53121
16095	20621	2	applied	\N	\N	\N	\N	65571	65571	65572
16097	20626	0	applied	\N	\N	\N	\N	65586	65586	65587
16097	20627	1	applied	\N	\N	\N	\N	65588	65588	65589
16097	20628	2	applied	\N	\N	\N	\N	65590	65590	53137
16097	20629	3	applied	\N	\N	\N	\N	65591	65591	65592
16097	20630	4	applied	\N	\N	\N	\N	65593	65593	65594
16097	20631	5	applied	\N	\N	\N	\N	65595	65595	53149
16104	20639	0	applied	\N	\N	\N	\N	65633	65633	65634
16104	20640	1	applied	\N	\N	\N	\N	65635	65635	65636
16104	20641	3	applied	\N	\N	\N	\N	65638	65638	65639
16111	20655	0	applied	\N	\N	\N	\N	65670	65670	65671
16111	20656	1	applied	\N	\N	\N	\N	65672	65672	53223
16111	20657	2	applied	\N	\N	\N	\N	65673	65673	53227
16111	20658	3	applied	\N	\N	\N	\N	65674	65674	65675
16112	20659	0	applied	\N	\N	\N	\N	65677	65677	65678
16112	20660	1	applied	\N	\N	\N	\N	65679	65679	65680
16112	20661	2	applied	\N	\N	\N	\N	65681	65681	65682
16112	20662	3	applied	\N	\N	\N	\N	65683	65683	65684
16112	20663	4	applied	\N	\N	\N	\N	65685	65685	53229
16112	20664	5	applied	\N	\N	\N	\N	65686	65686	53233
16112	20665	6	applied	\N	\N	\N	\N	65687	65687	65688
16112	20666	7	applied	\N	\N	\N	\N	65689	65689	53237
16112	20667	8	applied	\N	\N	\N	\N	65690	65690	65691
16112	20668	9	applied	\N	\N	\N	\N	65692	65692	53252
16112	20669	10	applied	\N	\N	\N	\N	65693	65693	65694
16112	20670	11	applied	\N	\N	\N	\N	65695	65695	53259
16112	20671	12	applied	\N	\N	\N	\N	65696	65696	65697
16117	20678	0	applied	\N	\N	\N	\N	65711	65711	65712
16117	20679	1	applied	\N	\N	\N	\N	65713	65713	53278
16117	20680	2	applied	\N	\N	\N	\N	65714	65714	53286
16117	20681	3	applied	\N	\N	\N	\N	65715	65715	53288
16119	20682	0	applied	\N	\N	\N	\N	65719	65719	65720
16119	20683	1	applied	\N	\N	\N	\N	65721	65721	65722
16119	20684	2	applied	\N	\N	\N	\N	65723	65723	53301
16119	20685	3	applied	\N	\N	\N	\N	65724	65724	65725
16119	20686	4	applied	\N	\N	\N	\N	65726	65726	53306
16119	20687	5	applied	\N	\N	\N	\N	65727	65727	65728
16127	20708	0	applied	\N	\N	\N	\N	65773	65773	65774
16127	20709	1	applied	\N	\N	\N	\N	65775	65775	53373
16054	20422	74	applied	\N	\N	\N	\N	65126	65126	65127
16054	20423	75	applied	\N	\N	\N	\N	65128	65128	65129
16054	20424	76	applied	\N	\N	\N	\N	65130	65130	65131
16054	20425	77	applied	\N	\N	\N	\N	65132	65132	65133
16054	20426	78	applied	\N	\N	\N	\N	65134	65134	65135
16054	20438	79	applied	\N	\N	\N	\N	65159	65159	65160
16054	20442	80	applied	\N	\N	\N	\N	65171	65171	65172
16054	20445	81	applied	\N	\N	\N	\N	65179	65179	65180
16054	20448	82	applied	\N	\N	\N	\N	65187	65187	65188
16054	20452	83	applied	\N	\N	\N	\N	65195	65195	65196
16054	20455	84	applied	\N	\N	\N	\N	65201	65201	65202
16054	20458	85	applied	\N	\N	\N	\N	65207	65207	65208
16054	20462	86	applied	\N	\N	\N	\N	65219	65219	65220
16054	20463	87	applied	\N	\N	\N	\N	65221	65221	65222
16054	20464	88	applied	\N	\N	\N	\N	65223	65223	65224
16054	20471	89	applied	\N	\N	\N	\N	65236	65236	65237
16054	20475	90	applied	\N	\N	\N	\N	65243	65243	65244
16054	20478	91	applied	\N	\N	\N	\N	65250	65250	65251
16054	20479	92	applied	\N	\N	\N	\N	65252	65252	65253
16054	20485	93	applied	\N	\N	\N	\N	65264	65264	65265
16054	20488	94	applied	\N	\N	\N	\N	65270	65270	65271
16054	20489	95	applied	\N	\N	\N	\N	65272	65272	65273
16054	20495	96	applied	\N	\N	\N	\N	65284	65284	65285
16054	20496	97	applied	\N	\N	\N	\N	65286	65286	65287
16054	20501	98	applied	\N	\N	\N	\N	65296	65296	65297
16054	20504	99	applied	\N	\N	\N	\N	65303	65303	65304
16054	20508	100	applied	\N	\N	\N	\N	65316	65316	65317
16054	20511	101	applied	\N	\N	\N	\N	65322	65322	65323
16054	20514	102	applied	\N	\N	\N	\N	65328	65328	65329
16054	20518	103	applied	\N	\N	\N	\N	65336	65336	65337
16054	20521	104	applied	\N	\N	\N	\N	65342	65342	65343
16054	20524	105	applied	\N	\N	\N	\N	65351	65351	65352
16054	20528	106	applied	\N	\N	\N	\N	65359	65359	65360
16054	20531	107	applied	\N	\N	\N	\N	65365	65365	65366
16054	20532	108	applied	\N	\N	\N	\N	65367	65367	65368
16054	20201	109	applied	\N	\N	\N	\N	64624	64624	64625
16054	20202	110	applied	\N	\N	\N	\N	64626	64626	64627
16054	20328	111	applied	\N	\N	\N	\N	64931	64931	64932
16054	20204	112	applied	\N	\N	\N	\N	64632	64632	51964
16054	20208	113	applied	\N	\N	\N	\N	64639	64639	65377
16054	20391	114	applied	\N	\N	\N	\N	65065	65065	51973
16054	20205	115	applied	\N	\N	\N	\N	64633	64633	51977
16054	20207	116	applied	\N	\N	\N	\N	64638	64638	51983
16057	20541	0	applied	\N	\N	\N	\N	65388	65388	65389
16057	20542	1	applied	\N	\N	\N	\N	65390	65390	65391
16057	20543	2	applied	\N	\N	\N	\N	65392	65392	65393
16057	20544	3	applied	\N	\N	\N	\N	65394	65394	52907
16057	20545	4	applied	\N	\N	\N	\N	65395	65395	52909
16057	20546	5	applied	\N	\N	\N	\N	65396	65396	65397
16057	20547	6	applied	\N	\N	\N	\N	65398	65398	52918
16059	20548	0	applied	\N	\N	\N	\N	65402	65402	65403
16059	20549	1	applied	\N	\N	\N	\N	65404	65404	65405
16059	20550	2	applied	\N	\N	\N	\N	65406	65406	65407
16059	20551	3	applied	\N	\N	\N	\N	65408	65408	52928
16062	20548	0	applied	\N	\N	\N	\N	65402	65402	65403
16062	20549	1	applied	\N	\N	\N	\N	65404	65404	65405
16062	20550	2	applied	\N	\N	\N	\N	65406	65406	65407
16062	20551	3	applied	\N	\N	\N	\N	65408	65408	52928
16066	20558	0	applied	\N	\N	\N	\N	65426	65426	65427
16066	20559	1	applied	\N	\N	\N	\N	65428	65428	52958
16066	20560	2	applied	\N	\N	\N	\N	65429	65429	65430
16066	20561	3	applied	\N	\N	\N	\N	65431	65431	52960
16078	20576	0	applied	\N	\N	\N	\N	65475	65475	65476
16080	20578	0	applied	\N	\N	\N	\N	65481	65481	65482
16080	20579	1	applied	\N	\N	\N	\N	65483	65483	53002
16080	20580	2	applied	\N	\N	\N	\N	65484	65484	65485
16084	20582	0	applied	\N	\N	\N	\N	65492	65492	65493
16084	20583	1	applied	\N	\N	\N	\N	65494	65494	53006
16087	20584	0	applied	\N	\N	\N	\N	65498	65498	65499
16087	20585	1	applied	\N	\N	\N	\N	65500	65500	65501
16087	20586	2	applied	\N	\N	\N	\N	65502	65502	65503
16088	20581	0	applied	\N	\N	\N	\N	65490	65490	65491
16088	20585	1	applied	\N	\N	\N	\N	65500	65500	53006
16088	20582	2	applied	\N	\N	\N	\N	65492	65492	65508
16088	20583	3	applied	\N	\N	\N	\N	65494	65494	65501
16090	20590	0	applied	\N	\N	\N	\N	65514	65514	65515
16090	20591	1	applied	\N	\N	\N	\N	65516	65516	65517
16090	20592	2	applied	\N	\N	\N	\N	65518	65518	65519
16090	20593	3	applied	\N	\N	\N	\N	65520	65520	65521
16090	20594	4	applied	\N	\N	\N	\N	65522	65522	65523
16090	20595	5	applied	\N	\N	\N	\N	65524	65524	65525
16090	20596	6	applied	\N	\N	\N	\N	65526	65526	53034
16090	20597	7	applied	\N	\N	\N	\N	65527	65527	65528
16090	20598	8	applied	\N	\N	\N	\N	65529	65529	53038
16090	20599	9	applied	\N	\N	\N	\N	65530	65530	53054
16090	20600	10	applied	\N	\N	\N	\N	65531	65531	65532
16090	20601	11	applied	\N	\N	\N	\N	65533	65533	65534
16090	20602	12	applied	\N	\N	\N	\N	65535	65535	65536
16090	20603	13	applied	\N	\N	\N	\N	65537	65537	65538
16090	20604	14	applied	\N	\N	\N	\N	65539	65539	65540
16090	20605	15	applied	\N	\N	\N	\N	65541	65541	65542
16090	20606	16	applied	\N	\N	\N	\N	65543	65543	65544
16090	20607	17	applied	\N	\N	\N	\N	65545	65545	65546
16090	20608	18	applied	\N	\N	\N	\N	65547	65547	53086
16090	20609	19	applied	\N	\N	\N	\N	65548	65548	65549
16090	20610	20	applied	\N	\N	\N	\N	65550	65550	53088
16090	20611	21	applied	\N	\N	\N	\N	65551	65551	65552
16102	20639	0	applied	\N	\N	\N	\N	65633	65633	65634
16102	20640	1	applied	\N	\N	\N	\N	65635	65635	65636
16102	20641	3	applied	\N	\N	\N	\N	65638	65638	65639
16107	20649	0	applied	\N	\N	\N	\N	65655	65655	65656
16107	20650	1	applied	\N	\N	\N	\N	65657	65657	53215
16107	20651	2	applied	\N	\N	\N	\N	65658	65658	53217
16109	20649	0	applied	\N	\N	\N	\N	65655	65655	65656
16109	20650	1	applied	\N	\N	\N	\N	65657	65657	53215
16109	20651	2	applied	\N	\N	\N	\N	65658	65658	53217
16115	20675	0	applied	\N	\N	\N	\N	65706	65706	65707
16115	20676	1	applied	\N	\N	\N	\N	65708	65708	53274
16115	20677	2	applied	\N	\N	\N	\N	65709	65709	53276
16120	20688	0	applied	\N	\N	\N	\N	65733	65733	65734
16120	20689	1	applied	\N	\N	\N	\N	65735	65735	53321
16120	20690	2	applied	\N	\N	\N	\N	65736	65736	53325
16120	20691	3	applied	\N	\N	\N	\N	65737	65737	65738
16122	20692	0	applied	\N	\N	\N	\N	65740	65740	65741
16122	20693	1	applied	\N	\N	\N	\N	65742	65742	53327
16122	20694	2	applied	\N	\N	\N	\N	65743	65743	53334
16125	20698	0	applied	\N	\N	\N	\N	65752	65752	65753
16125	20699	1	applied	\N	\N	\N	\N	65754	65754	65755
16125	20700	2	applied	\N	\N	\N	\N	65756	65756	53348
16125	20701	3	applied	\N	\N	\N	\N	65757	65757	65758
16070	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16070	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16070	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16070	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16070	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16073	20569	0	applied	\N	\N	\N	\N	65453	65453	65454
16073	20570	1	applied	\N	\N	\N	\N	65455	65455	65456
16073	20571	2	applied	\N	\N	\N	\N	65457	65457	52980
16073	20572	3	applied	\N	\N	\N	\N	65458	65458	65459
16073	20573	4	applied	\N	\N	\N	\N	65460	65460	65461
16073	20574	5	applied	\N	\N	\N	\N	65462	65462	65463
16073	20575	6	applied	\N	\N	\N	\N	65464	65464	52996
16076	20576	0	applied	\N	\N	\N	\N	65475	65475	65476
16076	20577	1	applied	\N	\N	\N	\N	65477	65477	52998
16083	20581	0	applied	\N	\N	\N	\N	65490	65490	65491
16083	20582	1	applied	\N	\N	\N	\N	65492	65492	65493
16083	20583	2	applied	\N	\N	\N	\N	65494	65494	53006
16085	20584	0	applied	\N	\N	\N	\N	65498	65498	65499
16085	20585	1	applied	\N	\N	\N	\N	65500	65500	65501
16085	20586	2	applied	\N	\N	\N	\N	65502	65502	65503
16089	20587	0	applied	\N	\N	\N	\N	65510	65510	65511
16089	20588	1	applied	\N	\N	\N	\N	65512	65512	53030
16089	20589	2	applied	\N	\N	\N	\N	65513	65513	53032
16094	20619	0	applied	\N	\N	\N	\N	65568	65568	65569
16094	20620	1	applied	\N	\N	\N	\N	65570	65570	53121
16094	20621	2	applied	\N	\N	\N	\N	65571	65571	65572
16096	20622	0	applied	\N	\N	\N	\N	65579	65579	65580
16096	20623	1	applied	\N	\N	\N	\N	65581	65581	53125
16096	20624	2	applied	\N	\N	\N	\N	65582	65582	53127
16096	20625	3	applied	\N	\N	\N	\N	65583	65583	65584
16099	20632	0	applied	\N	\N	\N	\N	65597	65597	65598
16099	20633	1	applied	\N	\N	\N	\N	65599	65599	65600
16099	20634	2	applied	\N	\N	\N	\N	65601	65601	53160
16101	20635	0	applied	\N	\N	\N	\N	65625	65625	65626
16101	20636	1	applied	\N	\N	\N	\N	65627	65627	65628
16101	20637	2	applied	\N	\N	\N	\N	65629	65629	65630
16101	20638	3	applied	\N	\N	\N	\N	65631	65631	53176
16106	20642	0	applied	\N	\N	\N	\N	65642	65642	65643
16106	20643	1	applied	\N	\N	\N	\N	65644	65644	65645
16106	20644	2	applied	\N	\N	\N	\N	65646	65646	53184
16106	20645	3	applied	\N	\N	\N	\N	65647	65647	65648
16106	20646	4	applied	\N	\N	\N	\N	65649	65649	53186
16106	20647	5	applied	\N	\N	\N	\N	65650	65650	53190
16106	20648	6	applied	\N	\N	\N	\N	65651	65651	53211
16110	20652	0	applied	\N	\N	\N	\N	65663	65663	65664
16110	20653	1	applied	\N	\N	\N	\N	65665	65665	53221
16110	20654	2	applied	\N	\N	\N	\N	65666	65666	65667
16114	20672	0	applied	\N	\N	\N	\N	65699	65699	65700
16114	20673	1	applied	\N	\N	\N	\N	65701	65701	65702
16114	20674	2	applied	\N	\N	\N	\N	65703	65703	53272
16116	20678	0	applied	\N	\N	\N	\N	65711	65711	65712
16116	20679	1	applied	\N	\N	\N	\N	65713	65713	53278
16116	20680	2	applied	\N	\N	\N	\N	65714	65714	53286
16116	20681	3	applied	\N	\N	\N	\N	65715	65715	53288
16121	20692	0	applied	\N	\N	\N	\N	65740	65740	65741
16121	20693	1	applied	\N	\N	\N	\N	65742	65742	53327
16121	20694	2	applied	\N	\N	\N	\N	65743	65743	53334
16124	20698	0	applied	\N	\N	\N	\N	65752	65752	65753
16124	20699	1	applied	\N	\N	\N	\N	65754	65754	65755
16124	20700	2	applied	\N	\N	\N	\N	65756	65756	53348
16124	20701	3	applied	\N	\N	\N	\N	65757	65757	65758
16124	20702	4	applied	\N	\N	\N	\N	65759	65759	53356
16124	20703	5	applied	\N	\N	\N	\N	65760	65760	65761
16124	20704	6	applied	\N	\N	\N	\N	65762	65762	65763
16126	20705	0	applied	\N	\N	\N	\N	65768	65768	65769
16126	20706	1	applied	\N	\N	\N	\N	65770	65770	53369
16126	20707	2	applied	\N	\N	\N	\N	65771	65771	65772
16131	20712	0	applied	\N	\N	\N	\N	65792	65792	65793
16131	20713	1	applied	\N	\N	\N	\N	65794	65794	53379
16131	20714	2	applied	\N	\N	\N	\N	65795	65795	53381
16131	20711	3	applied	\N	\N	\N	\N	65789	65789	53383
16138	20724	0	applied	\N	\N	\N	\N	65822	65822	65823
16138	20725	1	applied	\N	\N	\N	\N	65824	65824	65825
16138	20726	2	applied	\N	\N	\N	\N	65826	65826	65827
16138	20727	3	applied	\N	\N	\N	\N	65828	65828	65829
16138	20728	4	applied	\N	\N	\N	\N	65830	65830	53427
16138	20729	5	applied	\N	\N	\N	\N	65831	65831	65832
16140	20724	0	applied	\N	\N	\N	\N	65822	65822	65823
16140	20725	1	applied	\N	\N	\N	\N	65824	65824	65825
16140	20726	2	applied	\N	\N	\N	\N	65826	65826	65827
16140	20727	3	applied	\N	\N	\N	\N	65828	65828	65829
16140	20728	4	applied	\N	\N	\N	\N	65830	65830	53427
16140	20729	5	applied	\N	\N	\N	\N	65831	65831	65832
16143	20736	0	applied	\N	\N	\N	\N	65850	65850	65851
16143	20737	1	applied	\N	\N	\N	\N	65852	65852	53454
16143	20738	2	applied	\N	\N	\N	\N	65853	65853	65854
16150	20751	0	applied	\N	\N	\N	\N	65885	65885	65886
16150	20752	1	applied	\N	\N	\N	\N	65887	65887	53487
16150	20753	2	applied	\N	\N	\N	\N	65888	65888	53494
16150	20754	3	applied	\N	\N	\N	\N	65889	65889	53496
16152	20755	0	applied	\N	\N	\N	\N	65893	65893	65894
16152	20756	1	applied	\N	\N	\N	\N	65895	65895	53500
16152	20757	2	applied	\N	\N	\N	\N	65896	65896	65897
16154	20730	0	applied	\N	\N	\N	\N	65839	65839	65840
16154	20731	1	applied	\N	\N	\N	\N	65841	65841	65842
16154	20736	2	applied	\N	\N	\N	\N	65850	65850	65851
16154	20739	3	applied	\N	\N	\N	\N	65858	65858	65859
16154	20742	4	applied	\N	\N	\N	\N	65864	65864	65865
16154	20743	5	applied	\N	\N	\N	\N	65866	65866	65867
16154	20748	6	applied	\N	\N	\N	\N	65876	65876	65877
16154	20751	7	applied	\N	\N	\N	\N	65885	65885	65886
16154	20755	8	applied	\N	\N	\N	\N	65893	65893	65894
16154	20732	9	applied	\N	\N	\N	\N	65843	65843	53435
16154	20733	10	applied	\N	\N	\N	\N	65844	65844	65845
16154	20738	11	applied	\N	\N	\N	\N	65853	65853	65901
16154	20740	12	applied	\N	\N	\N	\N	65860	65860	53447
16154	20744	13	applied	\N	\N	\N	\N	65868	65868	65902
16154	20750	14	applied	\N	\N	\N	\N	65880	65880	65903
16154	20753	15	applied	\N	\N	\N	\N	65888	65888	53456
16154	20757	16	applied	\N	\N	\N	\N	65896	65896	65904
16154	20734	17	applied	\N	\N	\N	\N	65846	65846	53464
16154	20745	18	applied	\N	\N	\N	\N	65869	65869	65862
16154	20752	19	applied	\N	\N	\N	\N	65887	65887	65905
16154	20735	20	applied	\N	\N	\N	\N	65847	65847	65906
16154	20737	21	applied	\N	\N	\N	\N	65852	65852	65907
16154	20741	22	applied	\N	\N	\N	\N	65861	65861	65908
16154	20746	23	applied	\N	\N	\N	\N	65870	65870	65909
16154	20747	24	applied	\N	\N	\N	\N	65872	65872	65910
16154	20749	25	applied	\N	\N	\N	\N	65878	65878	65911
16154	20754	26	applied	\N	\N	\N	\N	65889	65889	65912
16082	20582	1	applied	\N	\N	\N	\N	65492	65492	65493
16082	20583	2	applied	\N	\N	\N	\N	65494	65494	53006
16091	20590	0	applied	\N	\N	\N	\N	65514	65514	65515
16091	20591	1	applied	\N	\N	\N	\N	65516	65516	65517
16091	20592	2	applied	\N	\N	\N	\N	65518	65518	65519
16091	20593	3	applied	\N	\N	\N	\N	65520	65520	65521
16091	20594	4	applied	\N	\N	\N	\N	65522	65522	65523
16091	20595	5	applied	\N	\N	\N	\N	65524	65524	65525
16091	20596	6	applied	\N	\N	\N	\N	65526	65526	53034
16091	20597	7	applied	\N	\N	\N	\N	65527	65527	65528
16091	20598	8	applied	\N	\N	\N	\N	65529	65529	53038
16091	20599	9	applied	\N	\N	\N	\N	65530	65530	53054
16091	20600	10	applied	\N	\N	\N	\N	65531	65531	65532
16091	20601	11	applied	\N	\N	\N	\N	65533	65533	65534
16091	20602	12	applied	\N	\N	\N	\N	65535	65535	65536
16091	20603	13	applied	\N	\N	\N	\N	65537	65537	65538
16091	20604	14	applied	\N	\N	\N	\N	65539	65539	65540
16091	20605	15	applied	\N	\N	\N	\N	65541	65541	65542
16091	20606	16	applied	\N	\N	\N	\N	65543	65543	65544
16091	20607	17	applied	\N	\N	\N	\N	65545	65545	65546
16091	20608	18	applied	\N	\N	\N	\N	65547	65547	53086
16091	20609	19	applied	\N	\N	\N	\N	65548	65548	65549
16091	20610	20	applied	\N	\N	\N	\N	65550	65550	53088
16091	20611	21	applied	\N	\N	\N	\N	65551	65551	65552
16093	20619	0	applied	\N	\N	\N	\N	65568	65568	65569
16093	20620	1	applied	\N	\N	\N	\N	65570	65570	53121
16093	20621	2	applied	\N	\N	\N	\N	65571	65571	65572
16098	20632	0	applied	\N	\N	\N	\N	65597	65597	65598
16098	20633	1	applied	\N	\N	\N	\N	65599	65599	65600
16098	20634	2	applied	\N	\N	\N	\N	65601	65601	53160
16100	20419	0	applied	\N	\N	\N	\N	65121	65121	65122
16100	20422	1	applied	\N	\N	\N	\N	65126	65126	65127
16100	20423	2	applied	\N	\N	\N	\N	65128	65128	65129
16100	20424	3	applied	\N	\N	\N	\N	65130	65130	65131
16100	20425	4	applied	\N	\N	\N	\N	65132	65132	65133
16100	20426	5	applied	\N	\N	\N	\N	65134	65134	65135
16100	20438	6	applied	\N	\N	\N	\N	65159	65159	65160
16100	20442	7	applied	\N	\N	\N	\N	65171	65171	65172
16100	20445	8	applied	\N	\N	\N	\N	65179	65179	65180
16100	20448	9	applied	\N	\N	\N	\N	65187	65187	65188
16100	20452	10	applied	\N	\N	\N	\N	65195	65195	65196
16100	20455	11	applied	\N	\N	\N	\N	65201	65201	65202
16100	20458	12	applied	\N	\N	\N	\N	65207	65207	65208
16100	20462	13	applied	\N	\N	\N	\N	65219	65219	65220
16100	20463	14	applied	\N	\N	\N	\N	65221	65221	65222
16100	20464	15	applied	\N	\N	\N	\N	65223	65223	65224
16100	20471	16	applied	\N	\N	\N	\N	65236	65236	65237
16100	20475	17	applied	\N	\N	\N	\N	65243	65243	65244
16100	20478	18	applied	\N	\N	\N	\N	65250	65250	65251
16100	20479	19	applied	\N	\N	\N	\N	65252	65252	65253
16100	20485	20	applied	\N	\N	\N	\N	65264	65264	65265
16100	20488	21	applied	\N	\N	\N	\N	65270	65270	65271
16100	20489	22	applied	\N	\N	\N	\N	65272	65272	65273
16100	20495	23	applied	\N	\N	\N	\N	65284	65284	65285
16100	20496	24	applied	\N	\N	\N	\N	65286	65286	65287
16100	20501	25	applied	\N	\N	\N	\N	65296	65296	65297
16100	20504	26	applied	\N	\N	\N	\N	65303	65303	65304
16100	20508	27	applied	\N	\N	\N	\N	65316	65316	65317
16100	20511	28	applied	\N	\N	\N	\N	65322	65322	65323
16100	20514	29	applied	\N	\N	\N	\N	65328	65328	65329
16100	20518	30	applied	\N	\N	\N	\N	65336	65336	65337
16100	20521	31	applied	\N	\N	\N	\N	65342	65342	65343
16100	20524	32	applied	\N	\N	\N	\N	65351	65351	65352
16100	20528	33	applied	\N	\N	\N	\N	65359	65359	65360
16100	20531	34	applied	\N	\N	\N	\N	65365	65365	65366
16100	20532	35	applied	\N	\N	\N	\N	65367	65367	65368
16100	20537	36	applied	\N	\N	\N	\N	65379	65379	65380
16100	20541	37	applied	\N	\N	\N	\N	65388	65388	65389
16100	20542	38	applied	\N	\N	\N	\N	65390	65390	65391
16100	20548	39	applied	\N	\N	\N	\N	65402	65402	65403
16100	20552	40	applied	\N	\N	\N	\N	65411	65411	65412
16100	20553	41	applied	\N	\N	\N	\N	65413	65413	65414
16100	20558	42	applied	\N	\N	\N	\N	65426	65426	65427
16100	20562	43	applied	\N	\N	\N	\N	65439	65439	65440
16100	20563	44	applied	\N	\N	\N	\N	65441	65441	65442
16100	20569	45	applied	\N	\N	\N	\N	65453	65453	65454
16100	20570	46	applied	\N	\N	\N	\N	65455	65455	65456
16100	20576	47	applied	\N	\N	\N	\N	65475	65475	65476
16100	20578	48	applied	\N	\N	\N	\N	65481	65481	65482
16100	20581	49	applied	\N	\N	\N	\N	65490	65490	65491
16100	20584	50	applied	\N	\N	\N	\N	65498	65498	65499
16100	20587	51	applied	\N	\N	\N	\N	65510	65510	65511
16100	20590	52	applied	\N	\N	\N	\N	65514	65514	65515
16100	20591	53	applied	\N	\N	\N	\N	65516	65516	65517
16100	20592	54	applied	\N	\N	\N	\N	65518	65518	65519
16100	20593	55	applied	\N	\N	\N	\N	65520	65520	65521
16100	20594	56	applied	\N	\N	\N	\N	65522	65522	65523
16100	20595	58	applied	\N	\N	\N	\N	65524	65524	65525
16100	20612	59	applied	\N	\N	\N	\N	65557	65557	65558
16100	20613	60	applied	\N	\N	\N	\N	65559	65559	65560
16100	20619	61	applied	\N	\N	\N	\N	65568	65568	65569
16100	20622	62	applied	\N	\N	\N	\N	65579	65579	65580
16100	20626	63	applied	\N	\N	\N	\N	65586	65586	65587
16100	20627	64	applied	\N	\N	\N	\N	65588	65588	65589
16100	20632	65	applied	\N	\N	\N	\N	65597	65597	65598
16100	20420	66	applied	\N	\N	\N	\N	65123	65123	65124
16100	20543	67	applied	\N	\N	\N	\N	65392	65392	65393
16100	20564	68	applied	\N	\N	\N	\N	65443	65443	65444
16100	20430	69	applied	\N	\N	\N	\N	65141	65141	52594
16100	20431	70	applied	\N	\N	\N	\N	65142	65142	65607
16100	20432	71	applied	\N	\N	\N	\N	65144	65144	65137
16100	20433	72	applied	\N	\N	\N	\N	65146	65146	52600
16100	20434	73	applied	\N	\N	\N	\N	65147	65147	65608
16100	20440	74	applied	\N	\N	\N	\N	65163	65163	65140
16100	20444	75	applied	\N	\N	\N	\N	65175	65175	52616
16100	20435	76	applied	\N	\N	\N	\N	65149	65149	52618
16100	20441	77	applied	\N	\N	\N	\N	65164	65164	65143
16100	20449	78	applied	\N	\N	\N	\N	65189	65189	52620
16100	20460	79	applied	\N	\N	\N	\N	65212	65212	65145
16100	20474	80	applied	\N	\N	\N	\N	65241	65241	65609
16100	20480	81	applied	\N	\N	\N	\N	65254	65254	52622
16100	20492	82	applied	\N	\N	\N	\N	65277	65277	52624
16100	20506	83	applied	\N	\N	\N	\N	65306	65306	65148
16100	20517	84	applied	\N	\N	\N	\N	65332	65332	52636
16100	20447	85	applied	\N	\N	\N	\N	65182	65182	65610
16100	20451	86	applied	\N	\N	\N	\N	65191	65191	52640
16100	20453	87	applied	\N	\N	\N	\N	65197	65197	65152
16100	20456	88	applied	\N	\N	\N	\N	65203	65203	52644
16100	20459	89	applied	\N	\N	\N	\N	65209	65209	65611
16100	20465	90	applied	\N	\N	\N	\N	65225	65225	65165
16100	20467	91	applied	\N	\N	\N	\N	65228	65228	52660
16100	20468	92	applied	\N	\N	\N	\N	65230	65230	65612
16100	20472	93	applied	\N	\N	\N	\N	65238	65238	65613
16100	20476	94	applied	\N	\N	\N	\N	65245	65245	52666
16100	20481	95	applied	\N	\N	\N	\N	65255	65255	65183
16100	20482	96	applied	\N	\N	\N	\N	65256	65256	65614
16100	20486	97	applied	\N	\N	\N	\N	65266	65266	52672
16100	20490	98	applied	\N	\N	\N	\N	65274	65274	65192
16100	20493	99	applied	\N	\N	\N	\N	65278	65278	65198
16100	20499	100	applied	\N	\N	\N	\N	65292	65292	52687
16100	20500	101	applied	\N	\N	\N	\N	65295	65295	65615
16100	20502	102	applied	\N	\N	\N	\N	65298	65298	65616
16100	20507	103	applied	\N	\N	\N	\N	65307	65307	52693
16100	20509	104	applied	\N	\N	\N	\N	65318	65318	65210
16100	20512	105	applied	\N	\N	\N	\N	65324	65324	65617
16100	20516	106	applied	\N	\N	\N	\N	65331	65331	52699
16100	20520	107	applied	\N	\N	\N	\N	65339	65339	65226
16100	20522	108	applied	\N	\N	\N	\N	65344	65344	65618
16100	20525	109	applied	\N	\N	\N	\N	65353	65353	52705
16100	20529	110	applied	\N	\N	\N	\N	65361	65361	65619
16100	20421	111	applied	\N	\N	\N	\N	65125	65125	52724
16100	20427	112	applied	\N	\N	\N	\N	65136	65136	65620
16100	20428	113	applied	\N	\N	\N	\N	65138	65138	52730
16100	20429	114	applied	\N	\N	\N	\N	65139	65139	65240
16100	20436	115	applied	\N	\N	\N	\N	65150	65150	52736
16100	20437	116	applied	\N	\N	\N	\N	65151	65151	65247
16100	20439	117	applied	\N	\N	\N	\N	65161	65161	52742
16100	20443	118	applied	\N	\N	\N	\N	65173	65173	65621
16100	20446	119	applied	\N	\N	\N	\N	65181	65181	52748
16100	20450	120	applied	\N	\N	\N	\N	65190	65190	65622
16100	20454	121	applied	\N	\N	\N	\N	65199	65199	52754
16100	20457	122	applied	\N	\N	\N	\N	65204	65204	65275
16100	20461	123	applied	\N	\N	\N	\N	65213	65213	52765
16100	20466	124	applied	\N	\N	\N	\N	65227	65227	65279
16100	20527	125	applied	\N	\N	\N	\N	65355	65355	52774
16103	20639	0	applied	\N	\N	\N	\N	65633	65633	65634
16103	20640	1	applied	\N	\N	\N	\N	65635	65635	65636
16103	20641	3	applied	\N	\N	\N	\N	65638	65638	65639
16105	20642	0	applied	\N	\N	\N	\N	65642	65642	65643
16105	20643	1	applied	\N	\N	\N	\N	65644	65644	65645
16105	20644	2	applied	\N	\N	\N	\N	65646	65646	53184
16105	20645	3	applied	\N	\N	\N	\N	65647	65647	65648
16105	20646	4	applied	\N	\N	\N	\N	65649	65649	53186
16105	20647	5	applied	\N	\N	\N	\N	65650	65650	53190
16105	20648	6	applied	\N	\N	\N	\N	65651	65651	53211
16108	20649	0	applied	\N	\N	\N	\N	65655	65655	65656
16108	20650	1	applied	\N	\N	\N	\N	65657	65657	53215
16108	20651	2	applied	\N	\N	\N	\N	65658	65658	53217
16113	20672	0	applied	\N	\N	\N	\N	65699	65699	65700
16113	20673	1	applied	\N	\N	\N	\N	65701	65701	65702
16113	20674	2	applied	\N	\N	\N	\N	65703	65703	53272
16118	20682	0	applied	\N	\N	\N	\N	65719	65719	65720
16118	20683	1	applied	\N	\N	\N	\N	65721	65721	65722
16118	20684	2	applied	\N	\N	\N	\N	65723	65723	53301
16118	20685	3	applied	\N	\N	\N	\N	65724	65724	65725
16118	20686	4	applied	\N	\N	\N	\N	65726	65726	53306
16118	20687	5	applied	\N	\N	\N	\N	65727	65727	65728
16123	20695	0	applied	\N	\N	\N	\N	65746	65746	65747
16123	20696	1	applied	\N	\N	\N	\N	65748	65748	53336
16123	20697	2	applied	\N	\N	\N	\N	65749	65749	65750
16130	20712	0	applied	\N	\N	\N	\N	65792	65792	65793
16130	20713	1	applied	\N	\N	\N	\N	65794	65794	53379
16130	20714	2	applied	\N	\N	\N	\N	65795	65795	53381
16130	20711	3	applied	\N	\N	\N	\N	65789	65789	53383
16133	20715	0	applied	\N	\N	\N	\N	65798	65798	65799
16133	20716	1	applied	\N	\N	\N	\N	65800	65800	53390
16135	20717	0	applied	\N	\N	\N	\N	65804	65804	65805
16135	20718	1	applied	\N	\N	\N	\N	65806	65806	65807
16135	20719	2	applied	\N	\N	\N	\N	65808	65808	53394
16135	20720	3	applied	\N	\N	\N	\N	65809	65809	65810
16135	20721	4	applied	\N	\N	\N	\N	65811	65811	65812
16135	20722	5	applied	\N	\N	\N	\N	65813	65813	65814
16135	20723	6	applied	\N	\N	\N	\N	65815	65815	53415
16142	20736	0	applied	\N	\N	\N	\N	65850	65850	65851
16142	20737	1	applied	\N	\N	\N	\N	65852	65852	53454
16142	20738	2	applied	\N	\N	\N	\N	65853	65853	65854
16145	20739	0	applied	\N	\N	\N	\N	65858	65858	65859
16145	20740	1	applied	\N	\N	\N	\N	65860	65860	53458
16145	20741	2	applied	\N	\N	\N	\N	65861	65861	65862
16147	20742	0	applied	\N	\N	\N	\N	65864	65864	65865
16147	20743	1	applied	\N	\N	\N	\N	65866	65866	65867
16147	20744	2	applied	\N	\N	\N	\N	65868	65868	53466
16147	20745	3	applied	\N	\N	\N	\N	65869	65869	53468
16147	20746	4	applied	\N	\N	\N	\N	65870	65870	65871
16147	20747	5	applied	\N	\N	\N	\N	65872	65872	53481
16159	20761	0	applied	\N	\N	\N	\N	65922	65922	65923
16159	20762	1	applied	\N	\N	\N	\N	65924	65924	53519
16159	20763	2	applied	\N	\N	\N	\N	65925	65925	53521
16160	20761	0	applied	\N	\N	\N	\N	65922	65922	65923
16160	20762	1	applied	\N	\N	\N	\N	65924	65924	53519
16160	20763	2	applied	\N	\N	\N	\N	65925	65925	53521
16165	20774	0	applied	\N	\N	\N	\N	65953	65953	65954
16165	20775	1	applied	\N	\N	\N	\N	65955	65955	65956
16165	20776	2	applied	\N	\N	\N	\N	65957	65957	65958
16165	20777	3	applied	\N	\N	\N	\N	65959	65959	53562
16168	20781	0	applied	\N	\N	\N	\N	65968	65968	65969
16168	20782	1	applied	\N	\N	\N	\N	65970	65970	65971
16168	20783	2	applied	\N	\N	\N	\N	65972	65972	65973
16170	20784	0	applied	\N	\N	\N	\N	65976	65976	65977
16170	20785	1	applied	\N	\N	\N	\N	65978	65978	65979
16170	20786	2	applied	\N	\N	\N	\N	65980	65980	53576
16170	20787	3	applied	\N	\N	\N	\N	65981	65981	65982
16173	20784	0	applied	\N	\N	\N	\N	65976	65976	65977
16173	20785	1	applied	\N	\N	\N	\N	65978	65978	65979
16173	20786	2	applied	\N	\N	\N	\N	65980	65980	53576
16173	20787	3	applied	\N	\N	\N	\N	65981	65981	65982
16174	20788	0	applied	\N	\N	\N	\N	65989	65989	65990
16174	20789	1	applied	\N	\N	\N	\N	65991	65991	65992
16179	20796	0	applied	\N	\N	\N	\N	66056	66056	66057
16179	20797	1	applied	\N	\N	\N	\N	66058	66058	66059
16179	20798	2	applied	\N	\N	\N	\N	66060	66060	66061
16179	20799	3	applied	\N	\N	\N	\N	66062	66062	53602
16181	20800	0	applied	\N	\N	\N	\N	66067	66067	53608
16181	20801	1	applied	\N	\N	\N	\N	66068	66068	66069
16182	20802	0	applied	\N	\N	\N	\N	66072	66072	66073
16182	20803	1	applied	\N	\N	\N	\N	66074	66074	66075
16182	20804	2	applied	\N	\N	\N	\N	66076	66076	66077
16182	20805	3	applied	\N	\N	\N	\N	66078	66078	53610
16182	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16125	20702	4	applied	\N	\N	\N	\N	65759	65759	53356
16125	20703	5	applied	\N	\N	\N	\N	65760	65760	65761
16125	20704	6	applied	\N	\N	\N	\N	65762	65762	65763
16128	20708	0	applied	\N	\N	\N	\N	65773	65773	65774
16128	20709	1	applied	\N	\N	\N	\N	65775	65775	53373
16128	20710	2	applied	\N	\N	\N	\N	65776	65776	53377
16132	20715	0	applied	\N	\N	\N	\N	65798	65798	65799
16132	20716	1	applied	\N	\N	\N	\N	65800	65800	53390
16144	20739	0	applied	\N	\N	\N	\N	65858	65858	65859
16144	20740	1	applied	\N	\N	\N	\N	65860	65860	53458
16144	20741	2	applied	\N	\N	\N	\N	65861	65861	65862
16149	20748	0	applied	\N	\N	\N	\N	65876	65876	65877
16149	20749	1	applied	\N	\N	\N	\N	65878	65878	65879
16149	20750	2	applied	\N	\N	\N	\N	65880	65880	53485
16156	20758	0	applied	\N	\N	\N	\N	65914	65914	65915
16156	20759	1	applied	\N	\N	\N	\N	65916	65916	53507
16156	20760	2	applied	\N	\N	\N	\N	65917	65917	65918
16158	20761	0	applied	\N	\N	\N	\N	65922	65922	65923
16158	20762	1	applied	\N	\N	\N	\N	65924	65924	53519
16158	20763	2	applied	\N	\N	\N	\N	65925	65925	53521
16162	20764	0	applied	\N	\N	\N	\N	65933	65933	65934
16162	20765	1	applied	\N	\N	\N	\N	65935	65935	65936
16162	20766	2	applied	\N	\N	\N	\N	65937	65937	53525
16162	20767	3	applied	\N	\N	\N	\N	65938	65938	53527
16167	20781	0	applied	\N	\N	\N	\N	65968	65968	65969
16167	20782	1	applied	\N	\N	\N	\N	65970	65970	65971
16167	20783	2	applied	\N	\N	\N	\N	65972	65972	65973
16172	20784	0	applied	\N	\N	\N	\N	65976	65976	65977
16172	20785	1	applied	\N	\N	\N	\N	65978	65978	65979
16172	20786	2	applied	\N	\N	\N	\N	65980	65980	53576
16172	20787	3	applied	\N	\N	\N	\N	65981	65981	65982
16176	20790	0	applied	\N	\N	\N	\N	66041	66041	66042
16176	20791	1	applied	\N	\N	\N	\N	66043	66043	66044
16176	20792	2	applied	\N	\N	\N	\N	66045	66045	53586
16186	20802	0	applied	\N	\N	\N	\N	66072	66072	66073
16186	20803	1	applied	\N	\N	\N	\N	66074	66074	66075
16186	20804	2	applied	\N	\N	\N	\N	66076	66076	66077
16186	20805	3	applied	\N	\N	\N	\N	66078	66078	53610
16186	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16186	20807	5	applied	\N	\N	\N	\N	66080	66080	53621
16186	20808	6	applied	\N	\N	\N	\N	66081	66081	66082
16186	20809	7	applied	\N	\N	\N	\N	66083	66083	53625
16186	20810	8	applied	\N	\N	\N	\N	66084	66084	53629
16186	20811	9	applied	\N	\N	\N	\N	66085	66085	53631
16186	20812	10	applied	\N	\N	\N	\N	66086	66086	53643
16188	20813	0	applied	\N	\N	\N	\N	66094	66094	66095
16188	20814	1	applied	\N	\N	1000000000	\N	66096	66096	66097
16188	20815	2	applied	\N	\N	\N	\N	66098	66098	66099
16188	20816	3	applied	\N	\N	\N	\N	66100	66100	53647
16190	20806	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16190	20814	1	applied	\N	\N	1000000000	\N	66096	66096	66097
16193	20831	0	applied	\N	\N	\N	\N	66131	66131	66132
16193	20832	1	applied	\N	\N	\N	\N	66133	66133	66134
16193	20833	2	applied	\N	\N	\N	\N	66135	66135	53686
16193	20834	3	applied	\N	\N	\N	\N	66136	66136	66137
16200	20845	0	applied	\N	\N	\N	\N	66161	66161	66162
16200	20846	1	applied	\N	\N	\N	\N	66163	66163	66164
16200	20847	2	applied	\N	\N	\N	\N	66165	66165	53719
16202	20849	0	applied	\N	\N	\N	\N	66171	66171	53730
16202	20850	1	applied	\N	\N	\N	\N	66172	66172	66173
16205	20851	0	applied	\N	\N	\N	\N	66179	66179	66180
16205	20848	1	applied	\N	\N	\N	\N	66169	66169	66170
16205	20852	2	applied	\N	\N	\N	\N	66181	66181	66182
16205	20853	3	applied	\N	\N	\N	\N	66183	66183	53732
16205	20854	4	applied	\N	\N	\N	\N	66184	66184	53736
16205	20855	5	applied	\N	\N	\N	\N	66185	66185	66186
16209	20867	0	applied	\N	\N	\N	\N	66216	66216	66217
16209	20868	1	applied	\N	\N	\N	\N	66218	66218	53751
16209	20869	2	applied	\N	\N	\N	\N	66219	66219	53755
16212	20877	0	applied	\N	\N	\N	\N	66240	66240	66241
16212	20878	1	applied	\N	\N	\N	\N	66242	66242	66243
16212	20879	2	applied	\N	\N	\N	\N	66244	66244	66245
16212	20880	3	applied	\N	\N	\N	\N	66246	66246	66247
16212	20881	4	applied	\N	\N	\N	\N	66248	66248	53795
16214	20877	0	applied	\N	\N	\N	\N	66240	66240	66241
16214	20878	1	applied	\N	\N	\N	\N	66242	66242	66243
16214	20883	2	applied	\N	\N	\N	\N	66254	66254	66255
16214	20879	3	applied	\N	\N	\N	\N	66244	66244	66245
16214	20882	4	applied	\N	\N	\N	\N	66251	66251	53784
16214	20880	5	applied	\N	\N	\N	\N	66246	66246	66252
16214	20881	6	applied	\N	\N	\N	\N	66248	66248	53797
16217	20889	0	applied	\N	\N	\N	\N	66269	66269	66270
16217	20890	1	applied	\N	\N	\N	\N	66271	66271	53817
16217	20891	2	applied	\N	\N	\N	\N	66272	66272	53819
16219	20892	0	applied	\N	\N	\N	\N	66277	66277	66278
16219	20893	1	applied	\N	\N	\N	\N	66279	66279	66280
16219	20894	2	applied	\N	\N	\N	\N	66281	66281	53828
16219	20895	3	applied	\N	\N	\N	\N	66282	66282	53830
16224	20904	0	applied	\N	\N	\N	\N	66302	66302	66303
16224	20908	1	applied	\N	\N	\N	\N	66312	66312	66313
16224	20905	2	applied	\N	\N	\N	\N	66304	66304	66314
16224	20907	3	applied	\N	\N	\N	\N	66308	66308	66315
16224	20909	4	applied	\N	\N	\N	\N	66316	66316	66317
16224	20910	5	applied	\N	\N	1000000000	\N	66318	66318	66319
16224	20906	6	applied	\N	\N	\N	\N	66307	66307	53880
16224	20911	7	applied	\N	\N	\N	\N	66320	66320	53882
16229	20922	0	applied	\N	\N	\N	\N	66345	66345	66346
16229	20923	1	applied	\N	\N	\N	\N	66347	66347	66348
16229	20924	2	applied	\N	\N	\N	\N	66349	66349	53912
16232	20931	0	applied	\N	\N	\N	\N	66361	66361	66362
16232	20932	1	applied	\N	\N	\N	\N	66363	66363	66364
16232	20933	2	applied	\N	\N	\N	\N	66365	66365	66366
16236	20935	0	applied	\N	\N	\N	\N	66375	66375	66376
16236	20934	1	applied	\N	\N	\N	\N	66372	66372	66373
16236	20936	2	applied	\N	\N	\N	\N	66377	66377	66378
16236	20937	3	applied	\N	\N	\N	\N	66379	66379	53937
16239	20817	0	applied	\N	\N	\N	\N	66104	66104	66105
16239	20857	1	applied	\N	\N	1000000000	\N	66196	66196	66197
16239	20858	2	applied	\N	\N	1000000000	\N	66198	66198	66199
16239	20818	3	applied	\N	\N	\N	\N	66106	66106	66107
16239	20824	4	applied	\N	\N	\N	\N	66118	66118	66119
16239	20825	5	applied	\N	\N	\N	\N	66120	66120	66121
16239	20831	6	applied	\N	\N	\N	\N	66131	66131	66132
16239	20859	7	applied	\N	\N	1000000000	\N	66200	66200	66201
16239	20860	8	applied	\N	\N	1000000000	\N	66202	66202	66203
16239	20835	9	applied	\N	\N	\N	\N	66140	66140	66141
16239	20836	10	applied	\N	\N	\N	\N	66142	66142	66143
16239	20841	11	applied	\N	\N	\N	\N	66151	66151	66152
16127	20710	2	applied	\N	\N	\N	\N	65776	65776	53377
16129	20386	0	applied	\N	\N	1000000000	\N	65056	65056	65057
16129	20328	1	applied	\N	\N	\N	\N	64931	64931	64932
16129	20543	2	applied	\N	\N	\N	\N	65392	65392	65393
16129	20564	3	applied	\N	\N	\N	\N	65443	65443	65444
16129	20391	4	applied	\N	\N	\N	\N	65065	65065	65781
16129	20396	5	applied	\N	\N	\N	\N	65075	65075	52235
16129	20407	6	applied	\N	\N	\N	\N	65095	65095	65782
16129	20412	7	applied	\N	\N	\N	\N	65107	65107	52240
16129	20435	8	applied	\N	\N	\N	\N	65149	65149	52242
16129	20441	9	applied	\N	\N	\N	\N	65164	65164	65783
16129	20449	10	applied	\N	\N	\N	\N	65189	65189	64864
16129	20460	11	applied	\N	\N	\N	\N	65212	65212	52244
16129	20474	12	applied	\N	\N	\N	\N	65241	65241	65784
16129	20480	13	applied	\N	\N	\N	\N	65254	65254	52252
16129	20492	14	applied	\N	\N	\N	\N	65277	65277	52254
16129	20506	15	applied	\N	\N	\N	\N	65306	65306	64867
16129	20517	16	applied	\N	\N	\N	\N	65332	65332	65785
16129	20527	17	applied	\N	\N	\N	\N	65355	65355	52256
16129	20539	18	applied	\N	\N	\N	\N	65382	65382	64869
16129	20551	19	applied	\N	\N	\N	\N	65408	65408	52263
16129	20561	20	applied	\N	\N	\N	\N	65431	65431	52265
16129	20572	21	applied	\N	\N	\N	\N	65458	65458	64878
16129	20583	22	applied	\N	\N	\N	\N	65494	65494	65786
16129	20610	23	applied	\N	\N	\N	\N	65550	65550	52267
16129	20611	24	applied	\N	\N	\N	\N	65551	65551	65787
16129	20615	25	applied	\N	\N	\N	\N	65562	65562	52275
16129	20623	26	applied	\N	\N	\N	\N	65581	65581	52277
16129	20637	27	applied	\N	\N	\N	\N	65629	65629	64888
16129	20646	28	applied	\N	\N	\N	\N	65649	65649	65788
16129	20656	29	applied	\N	\N	\N	\N	65672	65672	52279
16129	20663	30	applied	\N	\N	\N	\N	65685	65685	64890
16129	20679	31	applied	\N	\N	\N	\N	65713	65713	52281
16129	20691	32	applied	\N	\N	\N	\N	65737	65737	52283
16129	20700	33	applied	\N	\N	\N	\N	65756	65756	64892
16129	20711	34	applied	\N	\N	\N	\N	65789	65789	65790
16134	20717	0	applied	\N	\N	\N	\N	65804	65804	65805
16134	20718	1	applied	\N	\N	\N	\N	65806	65806	65807
16134	20719	2	applied	\N	\N	\N	\N	65808	65808	53394
16134	20720	3	applied	\N	\N	\N	\N	65809	65809	65810
16134	20721	4	applied	\N	\N	\N	\N	65811	65811	65812
16134	20722	5	applied	\N	\N	\N	\N	65813	65813	65814
16134	20723	6	applied	\N	\N	\N	\N	65815	65815	53415
16136	20717	0	applied	\N	\N	\N	\N	65804	65804	65805
16136	20718	1	applied	\N	\N	\N	\N	65806	65806	65807
16136	20719	2	applied	\N	\N	\N	\N	65808	65808	53394
16136	20720	3	applied	\N	\N	\N	\N	65809	65809	65810
16136	20721	4	applied	\N	\N	\N	\N	65811	65811	65812
16136	20722	5	applied	\N	\N	\N	\N	65813	65813	65814
16136	20723	6	applied	\N	\N	\N	\N	65815	65815	53415
16139	20724	0	applied	\N	\N	\N	\N	65822	65822	65823
16139	20725	1	applied	\N	\N	\N	\N	65824	65824	65825
16139	20726	2	applied	\N	\N	\N	\N	65826	65826	65827
16139	20727	3	applied	\N	\N	\N	\N	65828	65828	65829
16139	20728	4	applied	\N	\N	\N	\N	65830	65830	53427
16139	20729	5	applied	\N	\N	\N	\N	65831	65831	65832
16141	20730	0	applied	\N	\N	\N	\N	65839	65839	65840
16141	20731	1	applied	\N	\N	\N	\N	65841	65841	65842
16141	20732	2	applied	\N	\N	\N	\N	65843	65843	53435
16141	20733	3	applied	\N	\N	\N	\N	65844	65844	65845
16141	20734	4	applied	\N	\N	\N	\N	65846	65846	53445
16141	20735	5	applied	\N	\N	\N	\N	65847	65847	53447
16146	20742	0	applied	\N	\N	\N	\N	65864	65864	65865
16146	20743	1	applied	\N	\N	\N	\N	65866	65866	65867
16146	20744	2	applied	\N	\N	\N	\N	65868	65868	53466
16146	20745	3	applied	\N	\N	\N	\N	65869	65869	53468
16146	20746	4	applied	\N	\N	\N	\N	65870	65870	65871
16146	20747	5	applied	\N	\N	\N	\N	65872	65872	53481
16148	20748	0	applied	\N	\N	\N	\N	65876	65876	65877
16148	20749	1	applied	\N	\N	\N	\N	65878	65878	65879
16148	20750	2	applied	\N	\N	\N	\N	65880	65880	53485
16151	20751	0	applied	\N	\N	\N	\N	65885	65885	65886
16151	20752	1	applied	\N	\N	\N	\N	65887	65887	53487
16151	20753	2	applied	\N	\N	\N	\N	65888	65888	53494
16151	20754	3	applied	\N	\N	\N	\N	65889	65889	53496
16153	20755	0	applied	\N	\N	\N	\N	65893	65893	65894
16153	20756	1	applied	\N	\N	\N	\N	65895	65895	53500
16153	20757	2	applied	\N	\N	\N	\N	65896	65896	65897
16155	20758	0	applied	\N	\N	\N	\N	65914	65914	65915
16155	20759	1	applied	\N	\N	\N	\N	65916	65916	53507
16155	20760	2	applied	\N	\N	\N	\N	65917	65917	65918
16157	20761	0	applied	\N	\N	\N	\N	65922	65922	65923
16157	20762	1	applied	\N	\N	\N	\N	65924	65924	53519
16157	20763	2	applied	\N	\N	\N	\N	65925	65925	53521
16161	20761	0	applied	\N	\N	\N	\N	65922	65922	65923
16161	20762	1	applied	\N	\N	\N	\N	65924	65924	53519
16161	20763	2	applied	\N	\N	\N	\N	65925	65925	53521
16164	20771	0	applied	\N	\N	\N	\N	65948	65948	65949
16164	20772	1	applied	\N	\N	\N	\N	65950	65950	65951
16164	20773	2	applied	\N	\N	\N	\N	65952	65952	53556
16171	20784	0	applied	\N	\N	\N	\N	65976	65976	65977
16171	20785	1	applied	\N	\N	\N	\N	65978	65978	65979
16171	20786	2	applied	\N	\N	\N	\N	65980	65980	53576
16171	20787	3	applied	\N	\N	\N	\N	65981	65981	65982
16175	20635	0	applied	\N	\N	\N	\N	65625	65625	65626
16175	20639	1	applied	\N	\N	\N	\N	65633	65633	65634
16175	20642	2	applied	\N	\N	\N	\N	65642	65642	65643
16175	20643	3	applied	\N	\N	\N	\N	65644	65644	65645
16175	20649	4	applied	\N	\N	\N	\N	65655	65655	65656
16175	20652	5	applied	\N	\N	\N	\N	65663	65663	65664
16175	20655	6	applied	\N	\N	\N	\N	65670	65670	65671
16175	20659	7	applied	\N	\N	\N	\N	65677	65677	65678
16175	20660	8	applied	\N	\N	\N	\N	65679	65679	65680
16175	20661	9	applied	\N	\N	\N	\N	65681	65681	65682
16175	20662	10	applied	\N	\N	\N	\N	65683	65683	65684
16175	20672	11	applied	\N	\N	\N	\N	65699	65699	65700
16175	20675	12	applied	\N	\N	\N	\N	65706	65706	65707
16175	20678	13	applied	\N	\N	\N	\N	65711	65711	65712
16175	20682	14	applied	\N	\N	\N	\N	65719	65719	65720
16175	20683	15	applied	\N	\N	\N	\N	65721	65721	65722
16175	20688	16	applied	\N	\N	\N	\N	65733	65733	65734
16175	20692	17	applied	\N	\N	\N	\N	65740	65740	65741
16175	20695	18	applied	\N	\N	\N	\N	65746	65746	65747
16175	20698	19	applied	\N	\N	\N	\N	65752	65752	65753
16175	20699	20	applied	\N	\N	\N	\N	65754	65754	65755
16175	20705	21	applied	\N	\N	\N	\N	65768	65768	65769
16175	20708	22	applied	\N	\N	\N	\N	65773	65773	65774
16175	20712	23	applied	\N	\N	\N	\N	65792	65792	65994
16175	20715	24	applied	\N	\N	\N	\N	65798	65798	65995
16175	20717	25	applied	\N	\N	\N	\N	65804	65804	65996
16154	20756	27	applied	\N	\N	\N	\N	65895	65895	65897
16163	20768	0	applied	\N	\N	\N	\N	65940	65940	65941
16163	20769	1	applied	\N	\N	\N	\N	65942	65942	65943
16163	20770	2	applied	\N	\N	\N	\N	65944	65944	65945
16166	20778	0	applied	\N	\N	\N	\N	65962	65962	65963
16166	20779	1	applied	\N	\N	\N	\N	65964	65964	53564
16166	20780	2	applied	\N	\N	\N	\N	65965	65965	53566
16169	20781	0	applied	\N	\N	\N	\N	65968	65968	65969
16169	20782	1	applied	\N	\N	\N	\N	65970	65970	65971
16169	20783	2	applied	\N	\N	\N	\N	65972	65972	65973
16177	20793	0	applied	\N	\N	\N	\N	66048	66048	66049
16177	20794	1	applied	\N	\N	\N	\N	66050	66050	53588
16177	20795	2	applied	\N	\N	\N	\N	66051	66051	53590
16183	20802	0	applied	\N	\N	\N	\N	66072	66072	66073
16183	20803	1	applied	\N	\N	\N	\N	66074	66074	66075
16183	20804	2	applied	\N	\N	\N	\N	66076	66076	66077
16183	20805	3	applied	\N	\N	\N	\N	66078	66078	53610
16183	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16183	20807	5	applied	\N	\N	\N	\N	66080	66080	53621
16183	20808	6	applied	\N	\N	\N	\N	66081	66081	66082
16183	20809	7	applied	\N	\N	\N	\N	66083	66083	53625
16183	20810	8	applied	\N	\N	\N	\N	66084	66084	53629
16183	20811	9	applied	\N	\N	\N	\N	66085	66085	53631
16183	20812	10	applied	\N	\N	\N	\N	66086	66086	53643
16189	20813	0	applied	\N	\N	\N	\N	66094	66094	66095
16189	20814	1	applied	\N	\N	1000000000	\N	66096	66096	66097
16189	20815	2	applied	\N	\N	\N	\N	66098	66098	66099
16189	20816	3	applied	\N	\N	\N	\N	66100	66100	53647
16191	20817	0	applied	\N	\N	\N	\N	66104	66104	66105
16191	20818	1	applied	\N	\N	\N	\N	66106	66106	66107
16191	20819	2	applied	\N	\N	\N	\N	66108	66108	53649
16191	20820	3	applied	\N	\N	\N	\N	66109	66109	66110
16191	20821	4	applied	\N	\N	\N	\N	66111	66111	66112
16191	20822	5	applied	\N	\N	\N	\N	66113	66113	66114
16191	20823	6	applied	\N	\N	\N	\N	66115	66115	66116
16197	20845	0	applied	\N	\N	\N	\N	66161	66161	66162
16197	20846	1	applied	\N	\N	\N	\N	66163	66163	66164
16197	20847	2	applied	\N	\N	\N	\N	66165	66165	53719
16201	20848	0	applied	\N	\N	\N	\N	66169	66169	66170
16201	20849	1	applied	\N	\N	\N	\N	66171	66171	53730
16201	20850	2	applied	\N	\N	\N	\N	66172	66172	66173
16218	20892	0	applied	\N	\N	\N	\N	66277	66277	66278
16218	20893	1	applied	\N	\N	\N	\N	66279	66279	66280
16218	20894	2	applied	\N	\N	\N	\N	66281	66281	53828
16218	20895	3	applied	\N	\N	\N	\N	66282	66282	53830
16220	20896	0	applied	\N	\N	\N	\N	66284	66284	66285
16220	20897	1	applied	\N	\N	\N	\N	66286	66286	53844
16220	20898	2	applied	\N	\N	\N	\N	66287	66287	66288
16223	20901	0	applied	\N	\N	\N	\N	66295	66295	66296
16223	20904	1	applied	\N	\N	\N	\N	66302	66302	66303
16223	20905	2	applied	\N	\N	\N	\N	66304	66304	53850
16223	20902	4	applied	\N	\N	\N	\N	66297	66297	66306
16223	20906	5	applied	\N	\N	\N	\N	66307	66307	66299
16223	20903	6	applied	\N	\N	\N	\N	66298	66298	53858
16223	20907	7	applied	\N	\N	\N	\N	66308	66308	66309
16227	20915	0	applied	\N	\N	\N	\N	66331	66331	66332
16227	20916	1	applied	\N	\N	\N	\N	66333	66333	66334
16227	20917	2	applied	\N	\N	\N	\N	66335	66335	66336
16227	20918	3	applied	\N	\N	\N	\N	66337	66337	53892
16227	20919	4	applied	\N	\N	\N	\N	66338	66338	53894
16227	20920	5	applied	\N	\N	\N	\N	66339	66339	53896
16227	20921	6	applied	\N	\N	\N	\N	66340	66340	53898
16233	20931	0	applied	\N	\N	\N	\N	66361	66361	66362
16233	20932	1	applied	\N	\N	\N	\N	66363	66363	66364
16233	20933	2	applied	\N	\N	\N	\N	66365	66365	66366
16235	20857	0	applied	\N	\N	1000000000	\N	66196	66196	66197
16235	20858	1	applied	\N	\N	1000000000	\N	66198	66198	66199
16235	20859	2	applied	\N	\N	1000000000	\N	66200	66200	66201
16235	20860	3	applied	\N	\N	1000000000	\N	66202	66202	66203
16235	20934	4	applied	\N	\N	\N	\N	66372	66372	66373
16235	20806	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16235	20814	6	applied	\N	\N	1000000000	\N	66096	66096	66097
16235	20826	7	applied	\N	\N	\N	\N	66122	66122	66123
16235	20851	8	applied	\N	\N	\N	\N	66222	66222	66223
16235	20863	9	applied	\N	\N	\N	\N	66207	66207	66208
16235	20864	10	applied	\N	\N	\N	\N	66209	66209	66210
16235	20865	11	applied	\N	\N	\N	\N	66211	66211	66212
16235	20866	12	applied	\N	\N	\N	\N	66213	66213	66214
16235	20910	13	applied	\N	\N	1000000000	\N	66318	66318	66319
16238	20938	0	applied	\N	\N	\N	\N	66381	66381	66382
16238	20939	1	applied	\N	\N	\N	\N	66383	66383	66384
16238	20940	2	applied	\N	\N	\N	\N	66385	66385	53944
16238	20941	3	applied	\N	\N	\N	\N	66386	66386	53946
16238	20942	4	applied	\N	\N	\N	\N	66387	66387	53948
16240	20899	0	applied	\N	\N	\N	\N	66290	66290	66291
16240	20901	1	applied	\N	\N	\N	\N	66295	66295	66296
16240	20904	2	applied	\N	\N	\N	\N	66302	66302	66303
16240	20908	3	applied	\N	\N	\N	\N	66312	66312	66313
16240	20912	4	applied	\N	\N	\N	\N	66323	66323	66324
16240	20915	5	applied	\N	\N	\N	\N	66331	66331	66332
16240	20916	6	applied	\N	\N	\N	\N	66333	66333	66334
16240	20922	8	applied	\N	\N	\N	\N	66345	66345	66346
16240	20925	9	applied	\N	\N	\N	\N	66350	66350	66351
16240	20929	10	applied	\N	\N	\N	\N	66357	66357	66358
16240	20931	11	applied	\N	\N	\N	\N	66361	66361	66362
16240	20935	12	applied	\N	\N	\N	\N	66375	66375	66376
16240	20938	13	applied	\N	\N	\N	\N	66381	66381	66382
16240	20934	14	applied	\N	\N	\N	\N	66372	66372	66373
16240	20939	15	applied	\N	\N	\N	\N	66383	66383	66384
16240	20900	16	applied	\N	\N	\N	\N	66292	66292	66293
16240	20905	17	applied	\N	\N	\N	\N	66304	66304	53850
16240	20910	18	applied	\N	\N	1000000000	\N	66318	66318	66319
16240	20902	19	applied	\N	\N	\N	\N	66297	66297	66306
16240	20906	20	applied	\N	\N	\N	\N	66307	66307	66299
16240	20911	21	applied	\N	\N	\N	\N	66320	66320	53856
16240	20913	22	applied	\N	\N	\N	\N	66325	66325	66315
16240	20918	23	applied	\N	\N	\N	\N	66337	66337	66309
16240	20919	24	applied	\N	\N	\N	\N	66338	66338	53878
16240	20924	25	applied	\N	\N	\N	\N	66349	66349	66396
16240	20921	26	applied	\N	\N	\N	\N	66340	66340	53882
16240	20927	27	applied	\N	\N	\N	\N	66353	66353	66397
16240	20903	28	applied	\N	\N	\N	\N	66298	66298	53886
16242	20943	0	applied	\N	\N	\N	\N	66400	66400	66401
16242	20944	1	applied	\N	\N	\N	\N	66402	66402	66403
16242	20945	2	applied	\N	\N	\N	\N	66404	66404	53958
16244	20949	0	applied	\N	\N	\N	\N	66414	66414	66415
16244	20950	1	applied	\N	\N	\N	\N	66416	66416	53976
16244	20951	2	applied	\N	\N	\N	\N	66417	66417	66418
16175	20718	26	applied	\N	\N	\N	\N	65806	65806	65997
16175	20724	27	applied	\N	\N	\N	\N	65822	65822	65998
16175	20725	28	applied	\N	\N	\N	\N	65824	65824	65999
16175	20730	29	applied	\N	\N	\N	\N	65839	65839	66000
16175	20731	30	applied	\N	\N	\N	\N	65841	65841	66001
16175	20736	31	applied	\N	\N	\N	\N	65850	65850	66002
16175	20739	32	applied	\N	\N	\N	\N	65858	65858	66003
16175	20742	33	applied	\N	\N	\N	\N	65864	65864	66004
16175	20743	34	applied	\N	\N	\N	\N	65866	65866	66005
16175	20748	35	applied	\N	\N	\N	\N	65876	65876	66006
16175	20751	36	applied	\N	\N	\N	\N	65885	65885	66007
16175	20755	37	applied	\N	\N	\N	\N	65893	65893	66008
16175	20758	38	applied	\N	\N	\N	\N	65914	65914	66009
16175	20761	39	applied	\N	\N	\N	\N	65922	65922	66010
16175	20764	40	applied	\N	\N	\N	\N	65933	65933	66011
16175	20768	41	applied	\N	\N	\N	\N	65940	65940	66012
16175	20771	42	applied	\N	\N	\N	\N	65948	65948	66013
16175	20774	43	applied	\N	\N	\N	\N	65953	65953	66014
16175	20778	44	applied	\N	\N	\N	\N	65962	65962	66015
16175	20781	45	applied	\N	\N	\N	\N	65968	65968	66016
16175	20784	46	applied	\N	\N	\N	\N	65976	65976	66017
16175	20539	47	applied	\N	\N	\N	\N	65382	65382	66018
16175	20551	48	applied	\N	\N	\N	\N	65408	65408	52776
16175	20561	49	applied	\N	\N	\N	\N	65431	65431	52791
16175	20572	50	applied	\N	\N	\N	\N	65458	65458	65293
16175	20583	51	applied	\N	\N	\N	\N	65494	65494	65289
16175	20469	52	applied	\N	\N	\N	\N	65231	65231	52795
16175	20470	53	applied	\N	\N	\N	\N	65232	65232	66019
16175	20473	54	applied	\N	\N	\N	\N	65239	65239	52801
16175	20477	55	applied	\N	\N	\N	\N	65246	65246	65300
16175	20610	56	applied	\N	\N	\N	\N	65550	65550	52811
16175	20535	58	applied	\N	\N	\N	\N	65371	65371	52813
16175	20536	59	applied	\N	\N	\N	\N	65372	65372	66021
16175	20538	60	applied	\N	\N	\N	\N	65381	65381	52817
16175	20544	61	applied	\N	\N	\N	\N	65394	65394	52819
16175	20545	62	applied	\N	\N	\N	\N	65395	65395	65321
16175	20550	63	applied	\N	\N	\N	\N	65406	65406	52832
16175	20556	64	applied	\N	\N	\N	\N	65420	65420	52834
16175	20557	65	applied	\N	\N	\N	\N	65424	65424	66022
16175	20560	66	applied	\N	\N	\N	\N	65429	65429	52838
16175	20565	67	applied	\N	\N	\N	\N	65445	65445	52840
16175	20566	68	applied	\N	\N	\N	\N	65446	65446	66023
16175	20571	69	applied	\N	\N	\N	\N	65457	65457	52844
16175	20575	70	applied	\N	\N	\N	\N	65464	65464	52846
16175	20580	71	applied	\N	\N	\N	\N	65484	65484	65345
16175	20582	72	applied	\N	\N	\N	\N	65492	65492	52850
16175	20586	73	applied	\N	\N	\N	\N	65502	65502	52852
16175	20588	74	applied	\N	\N	\N	\N	65512	65512	66024
16175	20596	75	applied	\N	\N	\N	\N	65526	65526	52864
16175	20597	76	applied	\N	\N	\N	\N	65527	65527	52866
16175	20598	77	applied	\N	\N	\N	\N	65529	65529	66025
16175	20599	78	applied	\N	\N	\N	\N	65530	65530	52877
16175	20600	79	applied	\N	\N	\N	\N	65531	65531	52879
16175	20608	80	applied	\N	\N	\N	\N	65547	65547	66026
16175	20609	81	applied	\N	\N	\N	\N	65548	65548	52888
16175	20614	82	applied	\N	\N	\N	\N	65561	65561	52890
16175	20616	83	applied	\N	\N	\N	\N	65564	65564	65373
16175	20620	84	applied	\N	\N	\N	\N	65570	65570	52901
16175	20624	85	applied	\N	\N	\N	\N	65582	65582	52903
16175	20630	86	applied	\N	\N	\N	\N	65593	65593	65385
16175	20631	87	applied	\N	\N	\N	\N	65595	65595	52907
16175	20633	88	applied	\N	\N	\N	\N	65599	65599	52909
16175	20636	89	applied	\N	\N	\N	\N	65627	65627	66027
16175	20641	90	applied	\N	\N	\N	\N	65638	65638	52916
16175	20644	91	applied	\N	\N	\N	\N	65646	65646	52918
16175	20645	92	applied	\N	\N	\N	\N	65647	65647	66028
16175	20651	93	applied	\N	\N	\N	\N	65658	65658	52926
16175	20654	94	applied	\N	\N	\N	\N	65666	65666	52928
16175	20483	95	applied	\N	\N	\N	\N	65258	65258	65416
16175	20484	96	applied	\N	\N	\N	\N	65260	65260	52938
16175	20487	97	applied	\N	\N	\N	\N	65267	65267	65436
16175	20491	98	applied	\N	\N	\N	\N	65276	65276	52950
16175	20494	99	applied	\N	\N	\N	\N	65280	65280	65430
16175	20497	100	applied	\N	\N	\N	\N	65288	65288	52962
16175	20498	101	applied	\N	\N	\N	\N	65290	65290	66029
16175	20503	102	applied	\N	\N	\N	\N	65299	65299	52972
16175	20505	103	applied	\N	\N	\N	\N	65305	65305	66030
16175	20510	104	applied	\N	\N	\N	\N	65320	65320	52982
16175	20513	105	applied	\N	\N	\N	\N	65325	65325	66031
16175	20515	106	applied	\N	\N	\N	\N	65330	65330	52988
16175	20519	107	applied	\N	\N	\N	\N	65338	65338	66032
16175	20523	108	applied	\N	\N	\N	\N	65346	65346	53000
16175	20526	109	applied	\N	\N	\N	\N	65354	65354	65485
16175	20530	110	applied	\N	\N	\N	\N	65362	65362	53006
16175	20533	111	applied	\N	\N	\N	\N	65369	65369	65501
16175	20534	112	applied	\N	\N	\N	\N	65370	65370	53022
16175	20540	113	applied	\N	\N	\N	\N	65384	65384	66033
16175	20546	114	applied	\N	\N	\N	\N	65396	65396	53034
16175	20547	115	applied	\N	\N	\N	\N	65398	65398	66034
16175	20549	116	applied	\N	\N	\N	\N	65404	65404	53054
16175	20554	117	applied	\N	\N	\N	\N	65415	65415	66035
16175	20555	118	applied	\N	\N	\N	\N	65417	65417	53060
16175	20559	119	applied	\N	\N	\N	\N	65428	65428	66036
16175	20567	120	applied	\N	\N	\N	\N	65448	65448	53066
16175	20568	121	applied	\N	\N	\N	\N	65450	65450	66037
16175	20573	122	applied	\N	\N	\N	\N	65460	65460	53078
16175	20574	123	applied	\N	\N	\N	\N	65462	65462	66038
16175	20577	124	applied	\N	\N	\N	\N	65477	65477	53084
16175	20579	125	applied	\N	\N	\N	\N	65483	65483	65549
16178	20793	0	applied	\N	\N	\N	\N	66048	66048	66049
16178	20794	1	applied	\N	\N	\N	\N	66050	66050	53588
16178	20795	2	applied	\N	\N	\N	\N	66051	66051	53590
16180	20796	0	applied	\N	\N	\N	\N	66056	66056	66057
16180	20797	1	applied	\N	\N	\N	\N	66058	66058	66059
16180	20798	2	applied	\N	\N	\N	\N	66060	66060	66061
16180	20799	3	applied	\N	\N	\N	\N	66062	66062	53602
16185	20802	0	applied	\N	\N	\N	\N	66072	66072	66073
16185	20803	1	applied	\N	\N	\N	\N	66074	66074	66075
16185	20804	2	applied	\N	\N	\N	\N	66076	66076	66077
16185	20805	3	applied	\N	\N	\N	\N	66078	66078	53610
16185	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16185	20807	5	applied	\N	\N	\N	\N	66080	66080	53621
16185	20808	6	applied	\N	\N	\N	\N	66081	66081	66082
16185	20809	7	applied	\N	\N	\N	\N	66083	66083	53625
16185	20810	8	applied	\N	\N	\N	\N	66084	66084	53629
16185	20811	9	applied	\N	\N	\N	\N	66085	66085	53631
16185	20812	10	applied	\N	\N	\N	\N	66086	66086	53643
16187	20813	0	applied	\N	\N	\N	\N	66094	66094	66095
16187	20814	1	applied	\N	\N	1000000000	\N	66096	66096	66097
16182	20807	5	applied	\N	\N	\N	\N	66080	66080	53621
16182	20808	6	applied	\N	\N	\N	\N	66081	66081	66082
16182	20809	7	applied	\N	\N	\N	\N	66083	66083	53625
16182	20810	8	applied	\N	\N	\N	\N	66084	66084	53629
16182	20811	9	applied	\N	\N	\N	\N	66085	66085	53631
16182	20812	10	applied	\N	\N	\N	\N	66086	66086	53643
16184	20802	0	applied	\N	\N	\N	\N	66072	66072	66073
16184	20803	1	applied	\N	\N	\N	\N	66074	66074	66075
16184	20804	2	applied	\N	\N	\N	\N	66076	66076	66077
16184	20805	3	applied	\N	\N	\N	\N	66078	66078	53610
16184	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	66079	66079	\N
16184	20807	5	applied	\N	\N	\N	\N	66080	66080	53621
16184	20808	6	applied	\N	\N	\N	\N	66081	66081	66082
16184	20809	7	applied	\N	\N	\N	\N	66083	66083	53625
16184	20810	8	applied	\N	\N	\N	\N	66084	66084	53629
16184	20811	9	applied	\N	\N	\N	\N	66085	66085	53631
16184	20812	10	applied	\N	\N	\N	\N	66086	66086	53643
16194	20835	0	applied	\N	\N	\N	\N	66140	66140	66141
16194	20836	1	applied	\N	\N	\N	\N	66142	66142	66143
16194	20837	2	applied	\N	\N	\N	\N	66144	66144	53698
16194	20838	3	applied	\N	\N	\N	\N	66145	66145	66146
16194	20839	4	applied	\N	\N	\N	\N	66147	66147	66148
16194	20840	5	applied	\N	\N	\N	\N	66149	66149	53706
16196	20841	0	applied	\N	\N	\N	\N	66151	66151	66152
16196	20842	1	applied	\N	\N	\N	\N	66153	66153	53708
16196	20843	2	applied	\N	\N	\N	\N	66154	66154	66155
16196	20844	3	applied	\N	\N	\N	\N	66156	66156	53717
16199	20845	0	applied	\N	\N	\N	\N	66161	66161	66162
16199	20846	1	applied	\N	\N	\N	\N	66163	66163	66164
16199	20847	2	applied	\N	\N	\N	\N	66165	66165	53719
16203	20848	0	applied	\N	\N	\N	\N	66169	66169	66170
16203	20849	1	applied	\N	\N	\N	\N	66171	66171	53730
16203	20850	2	applied	\N	\N	\N	\N	66172	66172	66173
16206	20851	0	applied	\N	\N	\N	\N	66179	66179	66180
16206	20848	1	applied	\N	\N	\N	\N	66169	66169	66170
16206	20852	2	applied	\N	\N	\N	\N	66181	66181	66182
16206	20853	3	applied	\N	\N	\N	\N	66183	66183	53732
16206	20854	4	applied	\N	\N	\N	\N	66184	66184	53736
16206	20855	5	applied	\N	\N	\N	\N	66185	66185	66186
16210	20857	0	applied	\N	\N	1000000000	\N	66196	66196	66197
16210	20858	1	applied	\N	\N	1000000000	\N	66198	66198	66199
16210	20859	2	applied	\N	\N	1000000000	\N	66200	66200	66201
16210	20860	3	applied	\N	\N	1000000000	\N	66202	66202	66203
16210	20826	4	applied	\N	\N	\N	\N	66122	66122	66123
16210	20851	5	applied	\N	\N	\N	\N	66222	66222	66223
16210	20863	6	applied	\N	\N	\N	\N	66207	66207	66208
16210	20864	7	applied	\N	\N	\N	\N	66209	66209	66210
16210	20865	8	applied	\N	\N	\N	\N	66211	66211	66212
16210	20866	9	applied	\N	\N	\N	\N	66213	66213	66214
16213	20877	0	applied	\N	\N	\N	\N	66240	66240	66241
16213	20878	1	applied	\N	\N	\N	\N	66242	66242	66243
16213	20879	2	applied	\N	\N	\N	\N	66244	66244	66245
16213	20882	3	applied	\N	\N	\N	\N	66251	66251	53784
16213	20880	4	applied	\N	\N	\N	\N	66246	66246	66252
16213	20881	5	applied	\N	\N	\N	\N	66248	66248	53797
16215	20883	0	applied	\N	\N	\N	\N	66254	66254	66255
16215	20884	1	applied	\N	\N	\N	\N	66257	66257	66258
16215	20885	2	applied	\N	\N	\N	\N	66259	66259	66260
16215	20886	3	applied	\N	\N	\N	\N	66261	66261	66262
16215	20887	4	applied	\N	\N	\N	\N	66263	66263	66264
16215	20888	5	applied	\N	\N	\N	\N	66265	66265	66266
16222	20901	0	applied	\N	\N	\N	\N	66295	66295	66296
16222	20902	1	applied	\N	\N	\N	\N	66297	66297	53852
16222	20903	2	applied	\N	\N	\N	\N	66298	66298	66299
16225	20912	0	applied	\N	\N	\N	\N	66323	66323	66324
16225	20913	1	applied	\N	\N	\N	\N	66325	66325	66326
16225	20914	2	applied	\N	\N	\N	\N	66327	66327	66328
16226	20915	0	applied	\N	\N	\N	\N	66331	66331	66332
16226	20916	1	applied	\N	\N	\N	\N	66333	66333	66334
16226	20917	2	applied	\N	\N	\N	\N	66335	66335	66336
16226	20918	3	applied	\N	\N	\N	\N	66337	66337	53892
16226	20919	4	applied	\N	\N	\N	\N	66338	66338	53894
16226	20920	5	applied	\N	\N	\N	\N	66339	66339	53896
16226	20921	6	applied	\N	\N	\N	\N	66340	66340	53898
16230	20925	0	applied	\N	\N	\N	\N	66350	66350	66351
16230	20926	1	applied	\N	\N	\N	\N	66352	66352	53916
16230	20927	2	applied	\N	\N	\N	\N	66353	66353	66354
16230	20928	3	applied	\N	\N	\N	\N	66355	66355	53918
16237	20938	0	applied	\N	\N	\N	\N	66381	66381	66382
16237	20939	1	applied	\N	\N	\N	\N	66383	66383	66384
16237	20940	2	applied	\N	\N	\N	\N	66385	66385	53944
16237	20941	3	applied	\N	\N	\N	\N	66386	66386	53946
16237	20942	4	applied	\N	\N	\N	\N	66387	66387	53948
16241	20943	0	applied	\N	\N	\N	\N	66400	66400	66401
16241	20944	1	applied	\N	\N	\N	\N	66402	66402	66403
16241	20945	2	applied	\N	\N	\N	\N	66404	66404	53958
16246	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16246	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16252	20955	0	applied	\N	\N	\N	\N	66431	66431	66432
16252	20956	1	applied	\N	\N	\N	\N	66433	66433	53991
16252	20957	2	applied	\N	\N	\N	\N	66434	66434	54008
16255	20965	0	applied	\N	\N	\N	\N	66450	66450	66451
16255	20966	1	applied	\N	\N	\N	\N	66452	66452	54020
16255	20967	2	applied	\N	\N	\N	\N	66453	66453	54042
16259	20968	0	applied	\N	\N	\N	\N	66499	66499	66500
16259	20969	1	applied	\N	\N	\N	\N	66501	66501	66502
16259	20970	2	applied	\N	\N	\N	\N	66503	66503	66504
16269	20995	0	applied	\N	\N	\N	\N	66563	66563	66564
16269	20996	1	applied	\N	\N	\N	\N	66565	66565	66566
16269	20997	2	applied	\N	\N	\N	\N	66567	66567	66568
16270	20998	0	applied	\N	\N	\N	\N	66569	66569	66570
16270	20999	1	applied	\N	\N	\N	\N	66571	66571	66572
16270	21000	2	applied	\N	\N	\N	\N	66573	66573	66574
16270	21001	3	applied	\N	\N	\N	\N	66575	66575	66576
16270	21002	4	applied	\N	\N	\N	\N	66577	66577	54132
16270	21003	5	applied	\N	\N	\N	\N	66578	66578	66579
16270	21004	6	applied	\N	\N	\N	\N	66580	66580	66581
16270	21005	7	applied	\N	\N	\N	\N	66582	66582	54145
16270	21006	8	applied	\N	\N	\N	\N	66583	66583	66583
16270	21007	9	applied	\N	\N	\N	\N	66584	66584	54149
16270	21008	10	applied	\N	\N	\N	\N	66585	66585	54162
16270	21009	11	applied	\N	\N	\N	\N	66586	66586	54166
16270	21010	12	applied	\N	\N	\N	\N	66587	66587	54176
16187	20815	2	applied	\N	\N	\N	\N	66098	66098	66099
16187	20816	3	applied	\N	\N	\N	\N	66100	66100	53647
16192	20824	0	applied	\N	\N	\N	\N	66118	66118	66119
16192	20825	1	applied	\N	\N	\N	\N	66120	66120	66121
16192	20826	2	applied	\N	\N	\N	\N	66122	66122	66123
16192	20827	3	applied	\N	\N	\N	\N	66124	66124	66125
16192	20828	4	applied	\N	\N	\N	\N	66126	66126	53678
16192	20829	5	applied	\N	\N	\N	\N	66127	66127	53680
16192	20830	6	applied	\N	\N	\N	\N	66128	66128	66129
16195	20841	0	applied	\N	\N	\N	\N	66151	66151	66152
16195	20842	1	applied	\N	\N	\N	\N	66153	66153	53708
16195	20843	2	applied	\N	\N	\N	\N	66154	66154	66155
16195	20844	3	applied	\N	\N	\N	\N	66156	66156	53717
16198	20845	0	applied	\N	\N	\N	\N	66161	66161	66162
16198	20846	1	applied	\N	\N	\N	\N	66163	66163	66164
16198	20847	2	applied	\N	\N	\N	\N	66165	66165	53719
16204	20851	0	applied	\N	\N	\N	\N	66179	66179	66180
16204	20848	1	applied	\N	\N	\N	\N	66169	66169	66170
16204	20852	2	applied	\N	\N	\N	\N	66181	66181	66182
16204	20853	3	applied	\N	\N	\N	\N	66183	66183	53732
16204	20854	4	applied	\N	\N	\N	\N	66184	66184	53736
16204	20855	5	applied	\N	\N	\N	\N	66185	66185	66186
16207	20848	0	applied	\N	\N	\N	\N	66169	66169	66170
16207	20852	1	applied	\N	\N	\N	\N	66181	66181	66182
16207	20855	2	applied	\N	\N	\N	\N	66185	66185	66192
16208	20856	0	applied	\N	\N	\N	\N	66194	66194	66195
16208	20857	1	applied	\N	\N	1000000000	\N	66196	66196	66197
16208	20858	2	applied	\N	\N	1000000000	\N	66198	66198	66199
16208	20859	3	applied	\N	\N	1000000000	\N	66200	66200	66201
16208	20860	4	applied	\N	\N	1000000000	\N	66202	66202	66203
16208	20861	5	applied	\N	\N	\N	\N	66204	66204	53743
16208	20862	6	applied	\N	\N	\N	\N	66205	66205	66206
16208	20863	7	applied	\N	\N	\N	\N	66207	66207	66208
16208	20864	8	applied	\N	\N	\N	\N	66209	66209	66210
16208	20865	9	applied	\N	\N	\N	\N	66211	66211	66212
16208	20866	10	applied	\N	\N	\N	\N	66213	66213	66214
16211	20870	0	applied	\N	\N	\N	\N	66226	66226	66227
16211	20871	1	applied	\N	\N	\N	\N	66228	66228	66229
16211	20872	2	applied	\N	\N	\N	\N	66230	66230	66231
16211	20873	3	applied	\N	\N	\N	\N	66232	66232	66233
16211	20874	4	applied	\N	\N	\N	\N	66234	66234	66235
16211	20875	5	applied	\N	\N	\N	\N	66236	66236	53771
16211	20876	6	applied	\N	\N	\N	\N	66237	66237	53774
16216	20889	0	applied	\N	\N	\N	\N	66269	66269	66270
16216	20890	1	applied	\N	\N	\N	\N	66271	66271	53817
16216	20891	2	applied	\N	\N	\N	\N	66272	66272	53819
16221	20899	0	applied	\N	\N	\N	\N	66290	66290	66291
16221	20900	1	applied	\N	\N	\N	\N	66292	66292	66293
16228	20912	0	applied	\N	\N	\N	\N	66323	66323	66324
16228	20915	1	applied	\N	\N	\N	\N	66331	66331	66332
16228	20916	2	applied	\N	\N	\N	\N	66333	66333	66334
16228	20913	3	applied	\N	\N	\N	\N	66325	66325	66326
16228	20918	4	applied	\N	\N	\N	\N	66337	66337	53886
16228	20919	5	applied	\N	\N	\N	\N	66338	66338	53888
16228	20921	6	applied	\N	\N	\N	\N	66340	66340	66342
16228	20914	7	applied	\N	\N	\N	\N	66327	66327	53892
16228	20917	8	applied	\N	\N	\N	\N	66335	66335	66343
16228	20920	9	applied	\N	\N	\N	\N	66339	66339	53898
16231	20929	0	applied	\N	\N	\N	\N	66357	66357	66358
16231	20930	1	applied	\N	\N	\N	\N	66359	66359	53922
16234	20931	0	applied	\N	\N	\N	\N	66361	66361	66362
16234	20932	1	applied	\N	\N	\N	\N	66363	66363	66364
16234	20933	2	applied	\N	\N	\N	\N	66365	66365	66366
16247	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16247	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16250	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16250	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16260	20968	0	applied	\N	\N	\N	\N	66499	66499	66500
16260	20969	1	applied	\N	\N	\N	\N	66501	66501	66502
16260	20970	2	applied	\N	\N	\N	\N	66503	66503	66504
16263	20978	0	applied	\N	\N	\N	\N	66526	66526	66527
16263	20979	1	applied	\N	\N	\N	\N	66528	66528	66529
16263	20980	2	applied	\N	\N	\N	\N	66530	66530	66531
16263	20981	3	applied	\N	\N	\N	\N	66532	66532	66533
16263	20982	4	applied	\N	\N	\N	\N	66534	66534	66535
16263	20983	5	applied	\N	\N	\N	\N	66536	66536	66537
16263	20984	6	applied	\N	\N	\N	\N	66538	66538	66539
16268	20988	0	applied	\N	\N	\N	\N	66551	66551	66552
16268	20989	1	applied	\N	\N	\N	\N	66553	66553	66554
16268	20990	2	applied	\N	\N	\N	\N	66555	66555	66556
16268	20991	3	applied	\N	\N	\N	\N	66557	66557	54113
16268	20992	4	applied	\N	\N	\N	\N	66558	66558	66559
16268	20993	5	applied	\N	\N	\N	\N	66560	66560	54117
16268	20994	6	applied	\N	\N	\N	\N	66561	66561	54126
16239	20845	12	applied	\N	\N	\N	\N	66161	66161	66162
16239	20848	13	applied	\N	\N	\N	\N	66169	66169	66170
16239	20852	14	applied	\N	\N	\N	\N	66181	66181	66182
16239	20856	15	applied	\N	\N	\N	\N	66194	66194	66195
16239	20867	16	applied	\N	\N	\N	\N	66216	66216	66217
16239	20870	17	applied	\N	\N	\N	\N	66226	66226	66227
16239	20871	18	applied	\N	\N	\N	\N	66228	66228	66229
16239	20877	19	applied	\N	\N	\N	\N	66240	66240	66241
16239	20878	20	applied	\N	\N	\N	\N	66242	66242	66243
16239	20883	21	applied	\N	\N	\N	\N	66254	66254	66255
16239	20884	22	applied	\N	\N	\N	\N	66257	66257	66258
16239	20889	23	applied	\N	\N	\N	\N	66269	66269	66270
16239	20892	24	applied	\N	\N	\N	\N	66277	66277	66278
16239	20896	25	applied	\N	\N	\N	\N	66284	66284	66285
16239	20899	26	applied	\N	\N	\N	\N	66290	66290	66291
16239	20901	27	applied	\N	\N	\N	\N	66295	66295	66296
16239	20904	28	applied	\N	\N	\N	\N	66302	66302	66303
16239	20908	29	applied	\N	\N	\N	\N	66312	66312	66313
16239	20912	30	applied	\N	\N	\N	\N	66323	66323	66324
16239	20915	31	applied	\N	\N	\N	\N	66331	66331	66332
16239	20916	32	applied	\N	\N	\N	\N	66333	66333	66334
16239	20922	33	applied	\N	\N	\N	\N	66345	66345	66346
16239	20925	34	applied	\N	\N	\N	\N	66350	66350	66351
16239	20929	35	applied	\N	\N	\N	\N	66357	66357	66358
16239	20931	36	applied	\N	\N	\N	\N	66361	66361	66362
16239	20935	37	applied	\N	\N	\N	\N	66375	66375	66376
16239	20938	38	applied	\N	\N	\N	\N	66381	66381	66382
16239	20934	39	applied	\N	\N	\N	\N	66372	66372	66373
16239	20939	40	applied	\N	\N	\N	\N	66383	66383	66384
16239	20826	41	applied	\N	\N	\N	\N	66122	66122	66123
16239	20851	42	applied	\N	\N	\N	\N	66222	66222	66223
16239	20819	43	applied	\N	\N	\N	\N	66108	66108	53649
16239	20833	44	applied	\N	\N	\N	\N	66135	66135	66391
16239	20843	45	applied	\N	\N	\N	\N	66154	66154	66110
16239	20853	46	applied	\N	\N	\N	\N	66183	66183	53651
16239	20872	47	applied	\N	\N	\N	\N	66230	66230	66112
16239	20885	48	applied	\N	\N	\N	\N	66259	66259	53660
16239	20893	49	applied	\N	\N	\N	\N	66279	66279	53662
16239	20905	50	applied	\N	\N	\N	\N	66304	66304	66114
16239	20863	51	applied	\N	\N	\N	\N	66207	66207	66208
16239	20864	52	applied	\N	\N	\N	\N	66209	66209	66210
16239	20865	53	applied	\N	\N	\N	\N	66211	66211	66212
16239	20866	54	applied	\N	\N	\N	\N	66213	66213	66214
16239	20910	55	applied	\N	\N	1000000000	\N	66318	66318	66319
16239	20921	56	applied	\N	\N	\N	\N	66340	66340	66392
16239	20927	57	applied	\N	\N	\N	\N	66353	66353	53664
16239	20820	58	applied	\N	\N	\N	\N	66109	66109	53674
16239	20822	59	applied	\N	\N	\N	\N	66113	66113	66393
16239	20942	60	applied	\N	\N	\N	\N	66387	66387	53678
16243	20946	0	applied	\N	\N	\N	\N	66407	66407	66408
16243	20947	1	applied	\N	\N	\N	\N	66409	66409	66410
16243	20948	2	applied	\N	\N	\N	\N	66411	66411	53966
16245	20949	0	applied	\N	\N	\N	\N	66414	66414	66415
16245	20950	1	applied	\N	\N	\N	\N	66416	66416	53976
16245	20951	2	applied	\N	\N	\N	\N	66417	66417	66418
16245	20952	3	applied	\N	\N	\N	\N	66419	66419	53978
16248	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16248	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16251	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16251	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16254	20962	0	applied	\N	\N	\N	\N	66444	66444	66445
16254	20963	1	applied	\N	\N	\N	\N	66446	66446	54014
16254	20964	2	applied	\N	\N	\N	\N	66447	66447	54018
16257	20965	0	applied	\N	\N	\N	\N	66450	66450	66451
16257	20966	1	applied	\N	\N	\N	\N	66452	66452	54020
16257	20967	2	applied	\N	\N	\N	\N	66453	66453	54042
16261	20971	0	applied	\N	\N	\N	\N	66509	66509	66510
16261	20972	1	applied	\N	\N	\N	\N	66511	66511	66512
16261	20973	2	applied	\N	\N	\N	\N	66513	66513	66514
16261	20974	3	applied	\N	\N	\N	\N	66515	66515	66516
16261	20975	4	applied	\N	\N	\N	\N	66517	66517	54064
16264	20985	0	applied	\N	\N	\N	\N	66541	66541	66542
16264	20986	1	applied	\N	\N	\N	\N	66543	66543	66544
16264	20987	2	applied	\N	\N	\N	\N	66545	66545	54109
16244	20952	3	applied	\N	\N	\N	\N	66419	66419	53978
16249	20953	0	applied	\N	\N	\N	\N	66423	66423	66424
16249	20954	1	applied	\N	\N	\N	\N	66425	66425	53989
16253	20958	0	applied	\N	\N	\N	\N	66437	66437	66438
16253	20959	1	applied	\N	\N	\N	\N	66439	66439	54010
16253	20960	2	applied	\N	\N	\N	\N	66440	66440	66441
16253	20961	3	applied	\N	\N	\N	\N	66442	66442	66443
16256	20965	0	applied	\N	\N	\N	\N	66450	66450	66451
16256	20966	1	applied	\N	\N	\N	\N	66452	66452	54020
16256	20967	2	applied	\N	\N	\N	\N	66453	66453	54042
16258	20857	0	applied	\N	\N	1000000000	\N	66196	66196	66197
16258	20511	1	applied	\N	\N	\N	\N	65322	65322	65323
16258	20858	2	applied	\N	\N	1000000000	\N	66198	66198	66199
16258	20514	3	applied	\N	\N	\N	\N	65328	65328	65329
16258	20518	4	applied	\N	\N	\N	\N	65336	65336	65337
16258	20521	5	applied	\N	\N	\N	\N	65342	65342	65343
16258	20524	6	applied	\N	\N	\N	\N	65351	65351	65352
16258	20859	7	applied	\N	\N	1000000000	\N	66200	66200	66201
16258	20860	8	applied	\N	\N	1000000000	\N	66202	66202	66203
16258	20528	9	applied	\N	\N	\N	\N	65359	65359	65360
16258	20531	10	applied	\N	\N	\N	\N	65365	65365	65366
16258	20532	11	applied	\N	\N	\N	\N	65367	65367	65368
16258	20537	12	applied	\N	\N	\N	\N	65379	65379	65380
16258	20541	13	applied	\N	\N	\N	\N	65388	65388	65389
16258	20542	14	applied	\N	\N	\N	\N	65390	65390	65391
16258	20548	15	applied	\N	\N	\N	\N	65402	65402	65403
16258	20552	16	applied	\N	\N	\N	\N	65411	65411	65412
16258	20553	17	applied	\N	\N	\N	\N	65413	65413	65414
16258	20558	18	applied	\N	\N	\N	\N	65426	65426	65427
16258	20562	19	applied	\N	\N	\N	\N	65439	65439	65440
16258	20563	20	applied	\N	\N	\N	\N	65441	65441	65442
16258	20569	21	applied	\N	\N	\N	\N	65453	65453	65454
16258	20570	22	applied	\N	\N	\N	\N	65455	65455	65456
16258	20576	23	applied	\N	\N	\N	\N	65475	65475	65476
16258	20578	24	applied	\N	\N	\N	\N	65481	65481	65482
16258	20581	25	applied	\N	\N	\N	\N	65490	65490	65491
16258	20584	26	applied	\N	\N	\N	\N	65498	65498	65499
16258	20587	27	applied	\N	\N	\N	\N	65510	65510	65511
16258	20590	28	applied	\N	\N	\N	\N	65514	65514	65515
16258	20591	29	applied	\N	\N	\N	\N	65516	65516	65517
16258	20592	30	applied	\N	\N	\N	\N	65518	65518	65519
16258	20593	31	applied	\N	\N	\N	\N	65520	65520	65521
16258	20594	32	applied	\N	\N	\N	\N	65522	65522	65523
16258	20595	33	applied	\N	\N	\N	\N	65524	65524	65525
16258	20612	34	applied	\N	\N	\N	\N	65557	65557	65558
16258	20613	35	applied	\N	\N	\N	\N	65559	65559	65560
16258	20619	36	applied	\N	\N	\N	\N	65568	65568	65569
16258	20622	37	applied	\N	\N	\N	\N	65579	65579	65580
16258	20626	38	applied	\N	\N	\N	\N	65586	65586	65587
16258	20627	39	applied	\N	\N	\N	\N	65588	65588	65589
16258	20632	40	applied	\N	\N	\N	\N	65597	65597	65598
16258	20635	41	applied	\N	\N	\N	\N	65625	65625	65626
16258	20639	42	applied	\N	\N	\N	\N	65633	65633	65634
16258	20642	43	applied	\N	\N	\N	\N	65642	65642	65643
16258	20643	44	applied	\N	\N	\N	\N	65644	65644	65645
16258	20649	45	applied	\N	\N	\N	\N	65655	65655	65656
16258	20652	46	applied	\N	\N	\N	\N	65663	65663	65664
16258	20655	47	applied	\N	\N	\N	\N	65670	65670	65671
16258	20659	48	applied	\N	\N	\N	\N	65677	65677	65678
16258	20660	49	applied	\N	\N	\N	\N	65679	65679	65680
16258	20661	50	applied	\N	\N	\N	\N	65681	65681	65682
16258	20662	51	applied	\N	\N	\N	\N	65683	65683	65684
16258	20672	52	applied	\N	\N	\N	\N	65699	65699	65700
16258	20675	53	applied	\N	\N	\N	\N	65706	65706	65707
16258	20678	55	applied	\N	\N	\N	\N	65711	65711	65712
16258	20682	56	applied	\N	\N	\N	\N	65719	65719	65720
16258	20683	57	applied	\N	\N	\N	\N	65721	65721	65722
16258	20688	58	applied	\N	\N	\N	\N	65733	65733	65734
16258	20692	59	applied	\N	\N	\N	\N	65740	65740	65741
16258	20695	60	applied	\N	\N	\N	\N	65746	65746	65747
16258	20698	61	applied	\N	\N	\N	\N	65752	65752	65753
16258	20699	62	applied	\N	\N	\N	\N	65754	65754	65755
16258	20705	63	applied	\N	\N	\N	\N	65768	65768	65769
16258	20708	64	applied	\N	\N	\N	\N	65773	65773	65774
16258	20712	65	applied	\N	\N	\N	\N	65792	65792	65994
16258	20715	66	applied	\N	\N	\N	\N	65798	65798	65995
16258	20717	67	applied	\N	\N	\N	\N	65804	65804	65996
16258	20718	68	applied	\N	\N	\N	\N	65806	65806	65997
16258	20724	69	applied	\N	\N	\N	\N	65822	65822	65998
16258	20725	70	applied	\N	\N	\N	\N	65824	65824	65999
16258	20730	71	applied	\N	\N	\N	\N	65839	65839	66000
16258	20731	72	applied	\N	\N	\N	\N	65841	65841	66001
16258	20736	73	applied	\N	\N	\N	\N	65850	65850	66002
16258	20739	74	applied	\N	\N	\N	\N	65858	65858	66003
16258	20742	75	applied	\N	\N	\N	\N	65864	65864	66004
16258	20743	76	applied	\N	\N	\N	\N	65866	65866	66005
16258	20748	77	applied	\N	\N	\N	\N	65876	65876	66006
16258	20751	78	applied	\N	\N	\N	\N	65885	65885	66007
16258	20755	79	applied	\N	\N	\N	\N	65893	65893	66008
16258	20758	80	applied	\N	\N	\N	\N	65914	65914	66009
16258	20761	81	applied	\N	\N	\N	\N	65922	65922	66010
16258	20764	82	applied	\N	\N	\N	\N	65933	65933	66011
16258	20768	83	applied	\N	\N	\N	\N	65940	65940	66012
16258	20771	84	applied	\N	\N	\N	\N	65948	65948	66013
16258	20774	85	applied	\N	\N	\N	\N	65953	65953	66014
16258	20778	86	applied	\N	\N	\N	\N	65962	65962	66015
16258	20781	87	applied	\N	\N	\N	\N	65968	65968	66016
16258	20784	88	applied	\N	\N	\N	\N	65976	65976	66017
16258	20788	89	applied	\N	\N	\N	\N	65989	65989	66460
16258	20790	90	applied	\N	\N	\N	\N	66041	66041	66461
16258	20793	91	applied	\N	\N	\N	\N	66048	66048	66462
16258	20796	92	applied	\N	\N	\N	\N	66056	66056	66463
16258	20802	93	applied	\N	\N	\N	\N	66072	66072	66464
16258	20803	94	applied	\N	\N	\N	\N	66074	66074	66465
16258	20804	95	applied	\N	\N	\N	\N	66076	66076	66466
16258	20813	96	applied	\N	\N	\N	\N	66094	66094	66467
16258	20817	97	applied	\N	\N	\N	\N	66104	66104	66468
16258	20818	98	applied	\N	\N	\N	\N	66106	66106	66469
16258	20824	99	applied	\N	\N	\N	\N	66118	66118	66470
16258	20825	100	applied	\N	\N	\N	\N	66120	66120	66471
16258	20831	101	applied	\N	\N	\N	\N	66131	66131	66472
16258	20835	102	applied	\N	\N	\N	\N	66140	66140	66473
16258	20836	103	applied	\N	\N	\N	\N	66142	66142	66474
16258	20841	104	applied	\N	\N	\N	\N	66151	66151	66475
16258	20845	105	applied	\N	\N	\N	\N	66161	66161	66476
16258	20848	106	applied	\N	\N	\N	\N	66169	66169	66477
16258	20852	107	applied	\N	\N	\N	\N	66181	66181	66478
16258	20856	108	applied	\N	\N	\N	\N	66194	66194	66479
16258	20867	109	applied	\N	\N	\N	\N	66216	66216	66480
16258	20870	110	applied	\N	\N	\N	\N	66226	66226	66481
16258	20871	111	applied	\N	\N	\N	\N	66228	66228	66482
16258	20877	112	applied	\N	\N	\N	\N	66240	66240	66483
16258	20878	113	applied	\N	\N	\N	\N	66242	66242	66484
16258	20883	114	applied	\N	\N	\N	\N	66254	66254	66485
16258	20884	115	applied	\N	\N	\N	\N	66257	66257	66486
16258	20889	116	applied	\N	\N	\N	\N	66269	66269	66487
16258	20892	117	applied	\N	\N	\N	\N	66277	66277	66488
16258	20896	118	applied	\N	\N	\N	\N	66284	66284	66489
16258	20899	119	applied	\N	\N	\N	\N	66290	66290	66490
16258	20901	120	applied	\N	\N	\N	\N	66295	66295	66491
16258	20904	121	applied	\N	\N	\N	\N	66302	66302	66492
16258	20908	122	applied	\N	\N	\N	\N	66312	66312	66493
16258	20912	123	applied	\N	\N	\N	\N	66323	66323	66494
16258	20915	124	applied	\N	\N	\N	\N	66331	66331	66495
16258	20916	125	applied	\N	\N	\N	\N	66333	66333	66496
16262	20971	0	applied	\N	\N	\N	\N	66509	66509	66510
16262	20972	1	applied	\N	\N	\N	\N	66511	66511	66512
16262	20973	2	applied	\N	\N	\N	\N	66513	66513	66514
16262	20974	3	applied	\N	\N	\N	\N	66515	66515	66516
16262	20976	4	applied	\N	\N	\N	\N	66520	66520	66521
16262	20975	5	applied	\N	\N	\N	\N	66517	66517	66522
16262	20977	6	applied	\N	\N	\N	\N	66523	66523	66524
16265	20985	0	applied	\N	\N	\N	\N	66541	66541	66542
16265	20986	1	applied	\N	\N	\N	\N	66543	66543	66544
16265	20987	2	applied	\N	\N	\N	\N	66545	66545	54109
16271	21011	0	applied	\N	\N	\N	\N	66589	66589	66590
16271	21012	1	applied	\N	\N	\N	\N	66591	66591	66592
16271	21013	2	applied	\N	\N	\N	\N	66593	66593	54178
16271	21014	3	applied	\N	\N	\N	\N	66594	66594	66594
16271	21015	4	applied	\N	\N	\N	\N	66595	66595	66596
16271	21016	5	applied	\N	\N	\N	\N	66597	66597	54184
16271	21017	6	applied	\N	\N	\N	\N	66598	66598	54186
16271	21018	7	applied	\N	\N	\N	\N	66599	66599	66600
16272	21011	0	applied	\N	\N	\N	\N	66589	66589	66590
16272	21012	1	applied	\N	\N	\N	\N	66591	66591	66592
16272	21013	2	applied	\N	\N	\N	\N	66593	66593	54178
16272	21014	3	applied	\N	\N	\N	\N	66594	66594	66594
16272	21015	4	applied	\N	\N	\N	\N	66595	66595	66596
16272	21016	5	applied	\N	\N	\N	\N	66597	66597	54184
16272	21017	6	applied	\N	\N	\N	\N	66598	66598	54186
16272	21018	7	applied	\N	\N	\N	\N	66599	66599	66600
16273	21011	0	applied	\N	\N	\N	\N	66589	66589	66590
16273	21012	1	applied	\N	\N	\N	\N	66591	66591	66592
16273	21013	2	applied	\N	\N	\N	\N	66593	66593	54178
16273	21014	3	applied	\N	\N	\N	\N	66594	66594	66594
16273	21015	4	applied	\N	\N	\N	\N	66595	66595	66596
16273	21016	5	applied	\N	\N	\N	\N	66597	66597	54184
16273	21017	6	applied	\N	\N	\N	\N	66598	66598	54186
16273	21018	7	applied	\N	\N	\N	\N	66599	66599	66600
16274	21019	0	applied	\N	\N	\N	\N	66605	66605	66606
16274	21020	1	applied	\N	\N	\N	\N	66607	66607	66608
16274	21021	2	applied	\N	\N	\N	\N	66609	66609	66610
16275	21022	0	applied	\N	\N	\N	\N	66613	66613	66614
16275	21023	1	applied	\N	\N	\N	\N	66615	66615	54205
16275	21024	2	applied	\N	\N	\N	\N	66616	66616	54210
16276	21025	0	applied	\N	\N	\N	\N	66619	66619	66620
16276	21026	1	applied	\N	\N	\N	\N	66621	66621	66622
16276	21027	2	applied	\N	\N	\N	\N	66623	66623	54214
16276	21028	3	applied	\N	\N	\N	\N	66624	66624	54216
16277	21025	0	applied	\N	\N	\N	\N	66619	66619	66620
16277	21026	1	applied	\N	\N	\N	\N	66621	66621	66622
16277	21027	2	applied	\N	\N	\N	\N	66623	66623	54214
16277	21028	3	applied	\N	\N	\N	\N	66624	66624	54216
16278	21025	0	applied	\N	\N	\N	\N	66619	66619	66620
16278	21026	1	applied	\N	\N	\N	\N	66621	66621	66622
16278	21027	2	applied	\N	\N	\N	\N	66623	66623	54214
16278	21028	3	applied	\N	\N	\N	\N	66624	66624	54216
16279	21025	0	applied	\N	\N	\N	\N	66619	66619	66620
16279	21026	1	applied	\N	\N	\N	\N	66621	66621	66622
16279	21027	2	applied	\N	\N	\N	\N	66623	66623	54214
16279	21028	3	applied	\N	\N	\N	\N	66624	66624	54216
16280	21025	0	applied	\N	\N	\N	\N	66619	66619	66620
16280	21026	1	applied	\N	\N	\N	\N	66621	66621	66622
16280	21027	2	applied	\N	\N	\N	\N	66623	66623	54214
16280	21028	3	applied	\N	\N	\N	\N	66624	66624	54216
16281	21029	0	applied	\N	\N	\N	\N	66630	66630	66631
16281	21030	1	applied	\N	\N	\N	\N	66632	66632	54223
16282	21029	0	applied	\N	\N	\N	\N	66630	66630	66631
16282	21030	1	applied	\N	\N	\N	\N	66632	66632	54223
16282	21031	2	applied	\N	\N	\N	\N	66634	66634	66635
16283	21029	0	applied	\N	\N	\N	\N	66630	66630	66631
16283	21030	1	applied	\N	\N	\N	\N	66632	66632	54223
16283	21031	2	applied	\N	\N	\N	\N	66634	66634	66635
16284	21029	0	applied	\N	\N	\N	\N	66630	66630	66631
16284	21030	1	applied	\N	\N	\N	\N	66632	66632	54223
16284	21031	2	applied	\N	\N	\N	\N	66634	66634	66635
16285	21029	0	applied	\N	\N	\N	\N	66630	66630	66631
16285	21030	1	applied	\N	\N	\N	\N	66632	66632	54223
16285	21031	2	applied	\N	\N	\N	\N	66634	66634	66635
16287	21032	0	applied	\N	\N	\N	\N	66641	66641	66642
16287	21033	1	applied	\N	\N	\N	\N	66643	66643	66644
16288	21032	0	applied	\N	\N	\N	\N	66641	66641	66642
16288	21034	1	applied	\N	\N	\N	\N	66647	66647	66648
16288	21033	2	applied	\N	\N	\N	\N	66643	66643	54237
16289	21032	0	applied	\N	\N	\N	\N	66641	66641	66642
16289	21034	1	applied	\N	\N	\N	\N	66647	66647	66648
16290	21032	0	applied	\N	\N	\N	\N	66641	66641	66642
16290	21034	1	applied	\N	\N	\N	\N	66647	66647	66648
16290	21033	2	applied	\N	\N	\N	\N	66643	66643	54237
16291	21035	0	applied	\N	\N	\N	\N	66652	66652	66653
16291	21036	1	applied	\N	\N	\N	\N	66654	66654	54239
16292	21037	0	applied	\N	\N	\N	\N	66656	66656	66657
16292	21038	1	applied	\N	\N	\N	\N	66658	66658	66659
16292	21039	2	applied	\N	\N	\N	\N	66660	66660	54247
16292	21040	3	applied	\N	\N	\N	\N	66661	66661	54249
16293	20922	0	applied	\N	\N	\N	\N	66345	66345	66664
16293	20925	1	applied	\N	\N	\N	\N	66350	66350	66665
16293	20929	2	applied	\N	\N	\N	\N	66357	66357	66666
16293	20931	3	applied	\N	\N	\N	\N	66361	66361	66667
16293	20935	4	applied	\N	\N	\N	\N	66375	66375	66668
16293	20938	5	applied	\N	\N	\N	\N	66381	66381	66669
16293	20943	6	applied	\N	\N	\N	\N	66400	66400	66670
16293	20946	7	applied	\N	\N	\N	\N	66407	66407	66671
16293	20949	8	applied	\N	\N	\N	\N	66414	66414	66672
16293	20953	9	applied	\N	\N	\N	\N	66423	66423	66673
16293	20955	10	applied	\N	\N	\N	\N	66431	66431	66674
16293	20958	11	applied	\N	\N	\N	\N	66437	66437	66675
16293	20962	12	applied	\N	\N	\N	\N	66444	66444	66676
16293	20965	13	applied	\N	\N	\N	\N	66450	66450	66677
16293	20968	14	applied	\N	\N	\N	\N	66499	66499	66678
16293	20971	15	applied	\N	\N	\N	\N	66509	66509	66679
16293	20972	16	applied	\N	\N	\N	\N	66511	66511	66680
16293	20978	17	applied	\N	\N	\N	\N	66526	66526	66681
16293	20979	18	applied	\N	\N	\N	\N	66528	66528	66682
16293	20985	19	applied	\N	\N	\N	\N	66541	66541	66683
16293	20988	20	applied	\N	\N	\N	\N	66551	66551	66684
16293	20989	21	applied	\N	\N	\N	\N	66553	66553	66685
16293	20995	22	applied	\N	\N	\N	\N	66563	66563	66686
16293	20998	23	applied	\N	\N	\N	\N	66569	66569	66687
16293	20999	24	applied	\N	\N	\N	\N	66571	66571	66688
16293	21000	25	applied	\N	\N	\N	\N	66573	66573	66689
16293	21001	26	applied	\N	\N	\N	\N	66575	66575	66690
16293	21011	27	applied	\N	\N	\N	\N	66589	66589	66691
16293	21012	28	applied	\N	\N	\N	\N	66591	66591	66692
16293	21019	29	applied	\N	\N	\N	\N	66605	66605	66693
16293	21022	30	applied	\N	\N	\N	\N	66613	66613	66694
16293	21025	31	applied	\N	\N	\N	\N	66619	66619	66695
16293	21029	32	applied	\N	\N	\N	\N	66630	66630	66696
16293	21032	33	applied	\N	\N	\N	\N	66641	66641	66697
16293	21035	34	applied	\N	\N	\N	\N	66652	66652	66698
16293	20934	35	applied	\N	\N	\N	\N	66372	66372	66373
16293	20939	36	applied	\N	\N	\N	\N	66383	66383	66384
16293	20806	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	66699	66699	\N
16293	20814	38	applied	\N	\N	1000000000	\N	66700	66700	66097
16293	20826	39	applied	\N	\N	\N	\N	66701	66701	66123
16293	20851	40	applied	\N	\N	\N	\N	66702	66702	66223
16293	20512	41	applied	\N	\N	\N	\N	65324	65324	52832
16293	20513	42	applied	\N	\N	\N	\N	65325	65325	52836
16293	20515	43	applied	\N	\N	\N	\N	65330	65330	52838
16293	20519	44	applied	\N	\N	\N	\N	65338	65338	52842
16293	20516	45	applied	\N	\N	\N	\N	65331	65331	66703
16293	20520	46	applied	\N	\N	\N	\N	65339	65339	66704
16293	20522	47	applied	\N	\N	\N	\N	65344	65344	52848
16293	20525	48	applied	\N	\N	\N	\N	65353	65353	66705
16293	20529	49	applied	\N	\N	\N	\N	65361	65361	65347
16293	20543	50	applied	\N	\N	\N	\N	65392	65392	65393
16293	20564	51	applied	\N	\N	\N	\N	65443	65443	65444
16293	20517	52	applied	\N	\N	\N	\N	65332	65332	52852
16293	20863	53	applied	\N	\N	\N	\N	66207	66207	66208
16293	20864	55	applied	\N	\N	\N	\N	66209	66209	66210
16293	20865	56	applied	\N	\N	\N	\N	66211	66211	66212
16293	20866	57	applied	\N	\N	\N	\N	66213	66213	66214
16293	20910	58	applied	\N	\N	1000000000	\N	66318	66318	66319
16293	20527	59	applied	\N	\N	\N	\N	65355	65355	52862
16293	20539	60	applied	\N	\N	\N	\N	65382	65382	66024
16293	20551	61	applied	\N	\N	\N	\N	65408	65408	66707
16293	20561	62	applied	\N	\N	\N	\N	65431	65431	52864
16293	20572	63	applied	\N	\N	\N	\N	65458	65458	65356
16293	20583	64	applied	\N	\N	\N	\N	65494	65494	52866
16293	20610	65	applied	\N	\N	\N	\N	65550	65550	52875
16293	20535	66	applied	\N	\N	\N	\N	65371	65371	66708
16293	20536	67	applied	\N	\N	\N	\N	65372	65372	66709
16293	20538	68	applied	\N	\N	\N	\N	65381	65381	52886
16293	20544	69	applied	\N	\N	\N	\N	65394	65394	66710
16293	20545	70	applied	\N	\N	\N	\N	65395	65395	66711
16293	20550	71	applied	\N	\N	\N	\N	65406	65406	52899
16293	20556	72	applied	\N	\N	\N	\N	65420	65420	66712
16293	20557	73	applied	\N	\N	\N	\N	65424	65424	65383
16293	20560	74	applied	\N	\N	\N	\N	65429	65429	52905
16293	20565	75	applied	\N	\N	\N	\N	65445	65445	66713
16293	20566	76	applied	\N	\N	\N	\N	65446	65446	66714
16293	20571	77	applied	\N	\N	\N	\N	65457	65457	52914
16293	20575	78	applied	\N	\N	\N	\N	65464	65464	65397
16293	20580	79	applied	\N	\N	\N	\N	65484	65484	66715
16293	20582	80	applied	\N	\N	\N	\N	65492	65492	52924
16293	20586	81	applied	\N	\N	\N	\N	65502	65502	65405
16293	20588	82	applied	\N	\N	\N	\N	65512	65512	65407
16293	20596	83	applied	\N	\N	\N	\N	65526	65526	52934
16293	20597	84	applied	\N	\N	\N	\N	65527	65527	65416
16293	20598	85	applied	\N	\N	\N	\N	65529	65529	65422
16293	20599	86	applied	\N	\N	\N	\N	65530	65530	52946
16293	20600	87	applied	\N	\N	\N	\N	65531	65531	65436
16293	20608	88	applied	\N	\N	\N	\N	65547	65547	65437
16293	20609	89	applied	\N	\N	\N	\N	65548	65548	52958
16293	20614	90	applied	\N	\N	\N	\N	65561	65561	65430
16293	20616	91	applied	\N	\N	\N	\N	65564	65564	66716
16293	20620	92	applied	\N	\N	\N	\N	65570	65570	52968
16293	20624	93	applied	\N	\N	\N	\N	65582	65582	66029
16293	20630	94	applied	\N	\N	\N	\N	65593	65593	65449
16293	20631	95	applied	\N	\N	\N	\N	65595	65595	52978
16293	20633	96	applied	\N	\N	\N	\N	65599	65599	66030
16293	20636	97	applied	\N	\N	\N	\N	65627	65627	65459
16293	20641	98	applied	\N	\N	\N	\N	65638	65638	52984
16293	20644	99	applied	\N	\N	\N	\N	65646	65646	66031
16293	20645	100	applied	\N	\N	\N	\N	65647	65647	65463
16293	20651	101	applied	\N	\N	\N	\N	65658	65658	52996
16293	20654	102	applied	\N	\N	\N	\N	65666	65666	66032
16293	21006	103	applied	\N	\N	\N	\N	66583	66583	66583
16293	21014	104	applied	\N	\N	\N	\N	66594	66594	66594
16293	20523	105	applied	\N	\N	\N	\N	65346	65346	53000
16293	20526	106	applied	\N	\N	\N	\N	65354	65354	65485
16293	20530	107	applied	\N	\N	\N	\N	65362	65362	53006
16293	20533	108	applied	\N	\N	\N	\N	65369	65369	65501
16293	20534	109	applied	\N	\N	\N	\N	65370	65370	53022
16293	20540	110	applied	\N	\N	\N	\N	65384	65384	66033
16293	20546	111	applied	\N	\N	\N	\N	65396	65396	53034
16293	20547	112	applied	\N	\N	\N	\N	65398	65398	66034
16293	20549	113	applied	\N	\N	\N	\N	65404	65404	53054
16293	20554	114	applied	\N	\N	\N	\N	65415	65415	66035
16293	20555	115	applied	\N	\N	\N	\N	65417	65417	53060
16293	20559	116	applied	\N	\N	\N	\N	65428	65428	66036
16293	20567	117	applied	\N	\N	\N	\N	65448	65448	53066
16293	20568	118	applied	\N	\N	\N	\N	65450	65450	66037
16293	20573	119	applied	\N	\N	\N	\N	65460	65460	53078
16293	20574	120	applied	\N	\N	\N	\N	65462	65462	66038
16293	20577	121	applied	\N	\N	\N	\N	65477	65477	53084
16293	20579	122	applied	\N	\N	\N	\N	65483	65483	65549
16293	20585	123	applied	\N	\N	\N	\N	65500	65500	53102
16293	20589	124	applied	\N	\N	\N	\N	65513	65513	66717
16293	20601	125	applied	\N	\N	\N	\N	65533	65533	53108
16298	21054	0	applied	\N	\N	\N	\N	66746	66746	66747
16298	21055	1	applied	\N	\N	\N	\N	66748	66748	66749
16298	21056	2	applied	\N	\N	\N	\N	66750	66750	66751
16300	21054	0	applied	\N	\N	\N	\N	66746	66746	66747
16300	21055	1	applied	\N	\N	\N	\N	66748	66748	66749
16300	21056	2	applied	\N	\N	\N	\N	66750	66750	66751
16303	21060	0	applied	\N	\N	\N	\N	66763	66763	66764
16303	21061	1	applied	\N	\N	\N	\N	66765	66765	66766
16294	21041	0	applied	\N	\N	\N	\N	66720	66720	66721
16294	21042	1	applied	\N	\N	\N	\N	66722	66722	66723
16294	21043	2	applied	\N	\N	\N	\N	66724	66724	54260
16294	21044	3	applied	\N	\N	\N	\N	66725	66725	66726
16294	21045	4	applied	\N	\N	\N	\N	66727	66727	66728
16294	21046	5	applied	\N	\N	\N	\N	66729	66729	54275
16296	21047	0	applied	\N	\N	\N	\N	66730	66730	66731
16296	21048	1	applied	\N	\N	\N	\N	66732	66732	54277
16296	21049	2	applied	\N	\N	\N	\N	66733	66733	66734
16296	21050	3	applied	\N	\N	\N	\N	66735	66735	54281
16301	21057	0	applied	\N	\N	\N	\N	66756	66756	66757
16301	21058	1	applied	\N	\N	\N	\N	66758	66758	66759
16301	21059	2	applied	\N	\N	\N	\N	66760	66760	54313
16306	20971	0	applied	\N	\N	\N	\N	66509	66509	66510
16306	20972	1	applied	\N	\N	\N	\N	66511	66511	66512
16306	20978	2	applied	\N	\N	\N	\N	66526	66526	66527
16306	20979	3	applied	\N	\N	\N	\N	66528	66528	66529
16306	20985	4	applied	\N	\N	\N	\N	66541	66541	66542
16306	20988	5	applied	\N	\N	\N	\N	66551	66551	66552
16306	20989	6	applied	\N	\N	\N	\N	66553	66553	66554
16306	20995	7	applied	\N	\N	\N	\N	66563	66563	66564
16306	20998	8	applied	\N	\N	\N	\N	66569	66569	66570
16306	20999	9	applied	\N	\N	\N	\N	66571	66571	66572
16306	21000	10	applied	\N	\N	\N	\N	66573	66573	66574
16306	21001	11	applied	\N	\N	\N	\N	66575	66575	66576
16306	21011	12	applied	\N	\N	\N	\N	66589	66589	66590
16306	21012	13	applied	\N	\N	\N	\N	66591	66591	66592
16306	21019	14	applied	\N	\N	\N	\N	66605	66605	66606
16306	21022	15	applied	\N	\N	\N	\N	66613	66613	66614
16306	21025	16	applied	\N	\N	\N	\N	66619	66619	66620
16306	21029	17	applied	\N	\N	\N	\N	66630	66630	66631
16306	21032	18	applied	\N	\N	\N	\N	66641	66641	66642
16306	21035	19	applied	\N	\N	\N	\N	66652	66652	66653
16306	21037	20	applied	\N	\N	\N	\N	66656	66656	66657
16306	21041	21	applied	\N	\N	\N	\N	66720	66720	66721
16306	21042	22	applied	\N	\N	\N	\N	66722	66722	66723
16306	21047	24	applied	\N	\N	\N	\N	66730	66730	66731
16306	21051	25	applied	\N	\N	\N	\N	66740	66740	66741
16306	21054	26	applied	\N	\N	\N	\N	66746	66746	66747
16306	21057	27	applied	\N	\N	\N	\N	66756	66756	66757
16306	21060	28	applied	\N	\N	\N	\N	66763	66763	66764
16306	21063	29	applied	\N	\N	\N	\N	66772	66772	66773
16306	20973	30	applied	\N	\N	\N	\N	66513	66513	66514
16306	20974	31	applied	\N	\N	\N	\N	66515	66515	66516
16306	20980	32	applied	\N	\N	\N	\N	66530	66530	66522
16306	20976	33	applied	\N	\N	\N	\N	66520	66520	66524
16306	20975	34	applied	\N	\N	\N	\N	66517	66517	54076
16306	20977	35	applied	\N	\N	\N	\N	66523	66523	66531
16306	20981	36	applied	\N	\N	\N	\N	66532	66532	66533
16306	20982	37	applied	\N	\N	\N	\N	66534	66534	66535
16306	20986	38	applied	\N	\N	\N	\N	66543	66543	54095
16306	20991	39	applied	\N	\N	\N	\N	66557	66557	66539
16306	20992	40	applied	\N	\N	\N	\N	66558	66558	66544
16306	20996	41	applied	\N	\N	\N	\N	66565	66565	54107
16306	21003	42	applied	\N	\N	\N	\N	66578	66578	66780
16306	21004	43	applied	\N	\N	\N	\N	66580	66580	66556
16306	21005	44	applied	\N	\N	\N	\N	66582	66582	54113
16306	21006	45	applied	\N	\N	\N	\N	66583	66583	66583
16306	21014	46	applied	\N	\N	\N	\N	66594	66594	66594
16306	20983	47	applied	\N	\N	\N	\N	66536	66536	54115
16306	20993	48	applied	\N	\N	\N	\N	66560	66560	66559
16306	21002	49	applied	\N	\N	\N	\N	66577	66577	54117
16306	21013	50	applied	\N	\N	\N	\N	66593	66593	66781
16306	21026	51	applied	\N	\N	\N	\N	66621	66621	66782
16306	21038	52	applied	\N	\N	\N	\N	66658	66658	54126
16306	21049	53	applied	\N	\N	\N	\N	66733	66733	54128
16306	21059	54	applied	\N	\N	\N	\N	66760	66760	66566
16306	20984	55	applied	\N	\N	\N	\N	66538	66538	66568
16306	20987	56	applied	\N	\N	\N	\N	66545	66545	66579
16306	20990	57	applied	\N	\N	\N	\N	66555	66555	66783
16306	20994	58	applied	\N	\N	\N	\N	66561	66561	66784
16306	20997	59	applied	\N	\N	\N	\N	66567	66567	66785
16306	21017	60	applied	\N	\N	\N	\N	66598	66598	54164
16306	21018	61	applied	\N	\N	\N	\N	66599	66599	54166
16306	21021	62	applied	\N	\N	\N	\N	66609	66609	66786
16306	21023	63	applied	\N	\N	\N	\N	66615	66615	54178
16306	21007	64	applied	\N	\N	\N	\N	66584	66584	66596
16306	21008	65	applied	\N	\N	\N	\N	66585	66585	54184
16306	21009	66	applied	\N	\N	\N	\N	66586	66586	66787
16306	21010	67	applied	\N	\N	\N	\N	66587	66587	54194
16306	21015	68	applied	\N	\N	\N	\N	66595	66595	66610
16306	21016	69	applied	\N	\N	\N	\N	66597	66597	54208
16306	21020	70	applied	\N	\N	\N	\N	66607	66607	66622
16306	21024	71	applied	\N	\N	\N	\N	66616	66616	54214
16306	21027	72	applied	\N	\N	\N	\N	66623	66623	66788
16306	21030	73	applied	\N	\N	\N	\N	66632	66632	54225
16306	21033	74	applied	\N	\N	\N	\N	66643	66643	66648
16306	21039	75	applied	\N	\N	\N	\N	66660	66660	54237
16306	21043	76	applied	\N	\N	\N	\N	66724	66724	66659
16306	21046	77	applied	\N	\N	\N	\N	66729	66729	54247
16306	21050	78	applied	\N	\N	\N	\N	66735	66735	66789
16306	21053	79	applied	\N	\N	\N	\N	66743	66743	54262
16306	21056	80	applied	\N	\N	\N	\N	66750	66750	66728
16306	21058	81	applied	\N	\N	\N	\N	66758	66758	54275
16306	21062	82	applied	\N	\N	\N	\N	66767	66767	66734
16306	21064	83	applied	\N	\N	\N	\N	66774	66774	54281
16306	21028	84	applied	\N	\N	\N	\N	66624	66624	54283
16306	21031	85	applied	\N	\N	\N	\N	66634	66634	66790
16306	21034	86	applied	\N	\N	\N	\N	66647	66647	54296
16306	21036	87	applied	\N	\N	\N	\N	66654	66654	54298
16306	21040	88	applied	\N	\N	\N	\N	66661	66661	66751
16306	21044	89	applied	\N	\N	\N	\N	66725	66725	54311
16306	21045	90	applied	\N	\N	\N	\N	66727	66727	54313
16306	21048	91	applied	\N	\N	\N	\N	66732	66732	66766
16306	21052	92	applied	\N	\N	\N	\N	66742	66742	54317
16306	21055	93	applied	\N	\N	\N	\N	66748	66748	54319
16306	21061	94	applied	\N	\N	\N	\N	66765	66765	66775
16306	21065	95	applied	\N	\N	\N	\N	66776	66776	54334
16308	21069	0	applied	\N	\N	\N	\N	66800	66800	66801
16308	21070	1	applied	\N	\N	\N	\N	66802	66802	66803
16308	21071	2	applied	\N	\N	\N	\N	66804	66804	54348
16308	21072	3	applied	\N	\N	\N	\N	66805	66805	54354
16308	21073	4	applied	\N	\N	\N	\N	66806	66806	54358
16308	21074	5	applied	\N	\N	\N	\N	66807	66807	66808
16308	21075	6	applied	\N	\N	\N	\N	66809	66809	55380
16311	21069	0	applied	\N	\N	\N	\N	66800	66800	66801
16311	21070	1	applied	\N	\N	\N	\N	66802	66802	66803
16311	21071	2	applied	\N	\N	\N	\N	66804	66804	54348
16311	21072	3	applied	\N	\N	\N	\N	66805	66805	54354
16311	21073	4	applied	\N	\N	\N	\N	66806	66806	54358
16295	21047	0	applied	\N	\N	\N	\N	66730	66730	66731
16295	21048	1	applied	\N	\N	\N	\N	66732	66732	54277
16295	21049	2	applied	\N	\N	\N	\N	66733	66733	66734
16295	21050	3	applied	\N	\N	\N	\N	66735	66735	54281
16302	21060	0	applied	\N	\N	\N	\N	66763	66763	66764
16302	21061	1	applied	\N	\N	\N	\N	66765	66765	66766
16302	21062	2	applied	\N	\N	\N	\N	66767	66767	66768
16312	21069	0	applied	\N	\N	\N	\N	66800	66800	66801
16312	21070	1	applied	\N	\N	\N	\N	66802	66802	66803
16312	21071	2	applied	\N	\N	\N	\N	66804	66804	54348
16312	21072	3	applied	\N	\N	\N	\N	66805	66805	54354
16312	21073	4	applied	\N	\N	\N	\N	66806	66806	54358
16312	21074	5	applied	\N	\N	\N	\N	66807	66807	66808
16312	21075	6	applied	\N	\N	\N	\N	66809	66809	55380
16321	21097	0	applied	\N	\N	\N	\N	66859	66859	66860
16321	21098	1	applied	\N	\N	\N	\N	66861	66861	54433
16326	21112	0	applied	\N	\N	\N	\N	66888	66888	66889
16326	21113	1	applied	\N	\N	\N	\N	66890	66890	55744
16326	21114	2	applied	\N	\N	\N	\N	66891	66891	55746
16326	21115	3	applied	\N	\N	\N	\N	66892	66892	54476
16333	21146	0	applied	\N	\N	\N	\N	66949	66949	66950
16333	21147	1	applied	\N	\N	\N	\N	66951	66951	54629
16333	21148	2	applied	\N	\N	\N	\N	66952	66952	55790
16333	21149	3	applied	\N	\N	\N	\N	66953	66953	55792
16335	21150	0	applied	\N	\N	1000000000	\N	66960	66960	66961
16335	21151	1	applied	\N	\N	\N	\N	66962	66962	66963
16335	21152	2	applied	\N	\N	\N	\N	66964	66964	66965
16335	21153	3	applied	\N	\N	\N	\N	66966	66966	54640
16335	21154	4	applied	\N	\N	\N	\N	66967	66967	54642
16335	21155	5	applied	\N	\N	\N	\N	66968	66968	54644
16338	21163	0	applied	\N	\N	\N	\N	66983	66983	66984
16338	21164	1	applied	\N	\N	\N	\N	66985	66985	55808
16338	21165	2	applied	\N	\N	\N	\N	66986	66986	55810
16346	21184	0	applied	\N	\N	\N	\N	67024	67024	67025
16346	21185	1	applied	\N	\N	\N	\N	67026	67026	54713
16346	21186	2	applied	\N	\N	\N	\N	67027	67027	55836
16348	21187	0	applied	\N	\N	\N	\N	67032	67032	67033
16348	21188	1	applied	\N	\N	\N	\N	67034	67034	55838
16348	21189	2	applied	\N	\N	\N	\N	67035	67035	54731
16350	21190	0	applied	\N	\N	\N	\N	67042	67042	67043
16350	21191	1	applied	\N	\N	\N	\N	67044	67044	67045
16350	21192	2	applied	\N	\N	\N	\N	67046	67046	54735
16354	21217	0	applied	\N	\N	\N	\N	67083	67083	67084
16354	21218	1	applied	\N	\N	\N	\N	67085	67085	67086
16354	21219	2	applied	\N	\N	\N	\N	67087	67087	54813
16354	21220	3	applied	\N	\N	\N	\N	67088	67088	54821
16354	21221	4	applied	\N	\N	\N	\N	67089	67089	54827
16354	21222	5	applied	\N	\N	\N	\N	67090	67090	67091
16359	21230	0	applied	\N	\N	\N	\N	67112	67112	67113
16359	21231	1	applied	\N	\N	\N	\N	67114	67114	67115
16359	21232	2	applied	\N	\N	\N	\N	67116	67116	54860
16359	21233	3	applied	\N	\N	\N	\N	67117	67117	54866
16359	21234	4	applied	\N	\N	\N	\N	67118	67118	54868
16359	21235	5	applied	\N	\N	\N	\N	67119	67119	54874
16364	21243	0	applied	\N	\N	\N	\N	67139	67139	67140
16364	21244	1	applied	\N	\N	\N	\N	67141	67141	67142
16364	21245	2	applied	\N	\N	\N	\N	67143	67143	67144
16364	21246	3	applied	\N	\N	\N	\N	67145	67145	67146
16369	21258	0	applied	\N	\N	\N	\N	67172	67172	54927
16369	21259	1	applied	\N	\N	\N	\N	67173	67173	54929
16374	21122	0	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16374	21243	1	applied	\N	\N	\N	\N	67139	67139	67140
16374	21247	2	applied	\N	\N	\N	\N	67148	67148	67149
16374	21248	3	applied	\N	\N	\N	\N	67150	67150	67151
16374	21254	4	applied	\N	\N	\N	\N	67162	67162	67163
16374	21150	5	applied	\N	\N	1000000000	\N	66960	66960	66961
16374	21166	6	applied	\N	\N	\N	\N	66987	66987	66961
16374	20934	7	applied	\N	\N	\N	\N	66372	66372	66373
16374	20939	8	applied	\N	\N	\N	\N	66383	66383	66384
16374	21250	9	applied	\N	\N	\N	\N	67154	67154	67155
16374	20863	10	applied	\N	\N	\N	\N	66207	66207	66208
16374	20864	11	applied	\N	\N	\N	\N	66209	66209	66210
16374	20865	12	applied	\N	\N	\N	\N	66211	66211	66212
16374	20866	13	applied	\N	\N	\N	\N	66213	66213	66214
16374	20910	14	applied	\N	\N	1000000000	\N	66318	66318	66319
16374	21006	15	applied	\N	\N	\N	\N	66583	66583	66583
16374	21014	16	applied	\N	\N	\N	\N	66594	66594	66594
16377	21279	0	applied	\N	\N	\N	\N	67219	67219	67220
16377	21280	1	applied	\N	\N	\N	\N	67221	67221	67222
16377	21281	2	applied	\N	\N	\N	\N	67223	67223	67224
16381	21288	0	applied	\N	\N	\N	\N	67240	67240	67241
16381	21289	1	applied	\N	\N	\N	\N	67242	67242	55013
16381	21290	2	applied	\N	\N	\N	\N	67243	67243	67244
16384	21291	0	applied	\N	\N	\N	\N	67247	67247	67248
16384	21292	1	applied	\N	\N	\N	\N	67249	67249	55027
16384	21293	2	applied	\N	\N	\N	\N	67250	67250	67251
16386	21298	0	applied	\N	\N	\N	\N	67265	67265	67266
16386	21299	1	applied	\N	\N	\N	\N	67267	67267	55037
16386	21300	2	applied	\N	\N	\N	\N	67268	67268	55041
16389	21308	0	applied	\N	\N	\N	\N	67284	67284	67285
16389	21309	1	applied	\N	\N	\N	\N	67286	67286	67287
16389	21310	2	applied	\N	\N	\N	\N	67288	67288	67289
16389	21311	3	applied	\N	\N	\N	\N	67290	67290	55069
16389	21312	4	applied	\N	\N	\N	\N	67291	67291	55073
16389	21313	5	applied	\N	\N	\N	\N	67292	67292	67293
16389	21314	6	applied	\N	\N	\N	\N	67294	67294	67294
16389	21315	7	applied	\N	\N	\N	\N	67295	67295	67296
16389	21316	8	applied	\N	\N	\N	\N	67297	67297	67298
16389	21317	9	applied	\N	\N	\N	\N	67299	67299	55092
16389	21318	10	applied	\N	\N	\N	\N	67300	67300	55094
16394	21323	0	applied	\N	\N	\N	\N	67313	67313	67314
16394	21326	1	applied	\N	\N	\N	\N	67321	67321	67322
16394	21327	2	applied	\N	\N	\N	\N	67323	67323	67324
16394	21324	3	applied	\N	\N	\N	\N	67315	67315	67316
16394	21328	4	applied	\N	\N	\N	\N	67325	67325	55106
16394	21329	5	applied	\N	\N	\N	\N	67326	67326	55112
16394	21330	6	applied	\N	\N	\N	\N	67327	67327	55114
16394	21325	7	applied	\N	\N	\N	\N	67317	67317	55116
16394	21331	8	applied	\N	\N	\N	\N	67328	67328	55125
16394	21332	9	applied	\N	\N	\N	\N	67329	67329	55127
16399	21344	0	applied	\N	\N	\N	\N	67356	67356	67357
16399	21345	1	applied	\N	\N	\N	\N	67358	67358	55168
16399	21346	2	applied	\N	\N	\N	\N	67359	67359	55170
16409	21363	0	applied	\N	\N	\N	\N	67397	67397	67398
16409	21365	1	applied	\N	\N	\N	\N	67401	67401	67402
16409	21364	2	applied	\N	\N	\N	\N	67399	67399	55221
16411	21366	0	applied	\N	\N	\N	\N	67406	67406	67407
16411	21367	1	applied	\N	\N	\N	\N	67408	67408	67409
16411	21368	2	applied	\N	\N	\N	\N	67410	67410	67411
16297	21051	0	applied	\N	\N	\N	\N	66740	66740	66741
16297	21052	1	applied	\N	\N	\N	\N	66742	66742	54283
16297	21053	2	applied	\N	\N	\N	\N	66743	66743	54290
16299	21054	0	applied	\N	\N	\N	\N	66746	66746	66747
16299	21055	1	applied	\N	\N	\N	\N	66748	66748	66749
16299	21056	2	applied	\N	\N	\N	\N	66750	66750	66751
16304	21063	0	applied	\N	\N	\N	\N	66772	66772	66773
16304	21064	1	applied	\N	\N	\N	\N	66774	66774	66775
16304	21065	2	applied	\N	\N	\N	\N	66776	66776	54334
16309	21069	0	applied	\N	\N	\N	\N	66800	66800	66801
16309	21070	1	applied	\N	\N	\N	\N	66802	66802	66803
16309	21071	2	applied	\N	\N	\N	\N	66804	66804	54348
16309	21072	3	applied	\N	\N	\N	\N	66805	66805	54354
16309	21073	4	applied	\N	\N	\N	\N	66806	66806	54358
16309	21074	5	applied	\N	\N	\N	\N	66807	66807	66808
16309	21075	6	applied	\N	\N	\N	\N	66809	66809	55380
16313	21076	0	applied	\N	\N	\N	\N	66819	66819	66820
16313	21077	1	applied	\N	\N	\N	\N	66821	66821	54370
16313	21078	2	applied	\N	\N	\N	\N	66822	66822	54375
16316	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16316	21090	1	applied	\N	\N	\N	\N	66842	66842	66843
16316	21091	2	applied	\N	\N	\N	\N	66844	66844	55400
16316	21092	3	applied	\N	\N	\N	\N	66845	66845	54412
16316	21093	4	applied	\N	\N	\N	\N	66846	66846	55719
16319	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16319	21090	1	applied	\N	\N	\N	\N	66842	66842	66843
16319	21091	2	applied	\N	\N	\N	\N	66844	66844	55400
16319	21092	3	applied	\N	\N	\N	\N	66845	66845	54412
16319	21093	4	applied	\N	\N	\N	\N	66846	66846	55719
16320	21094	0	applied	\N	\N	\N	\N	66853	66853	66854
16320	21095	1	applied	\N	\N	\N	\N	66855	66855	54427
16320	21096	2	applied	\N	\N	\N	\N	66856	66856	54431
16323	21102	0	applied	\N	\N	\N	\N	66870	66870	66871
16323	21103	1	applied	\N	\N	\N	\N	66872	66872	54441
16323	21104	2	applied	\N	\N	\N	\N	66873	66873	54447
16323	21105	3	applied	\N	\N	\N	\N	66874	66874	66875
16328	21116	0	applied	\N	\N	\N	\N	66896	66896	66897
16328	21117	1	applied	\N	\N	\N	\N	66898	66898	66899
16328	21118	2	applied	\N	\N	\N	\N	66900	66900	66901
16328	21119	3	applied	\N	\N	\N	\N	66902	66902	55751
16328	21120	4	applied	\N	\N	\N	\N	66903	66903	66904
16328	21121	5	applied	\N	\N	\N	\N	66905	66905	55756
16330	21122	0	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16330	21123	1	applied	\N	\N	\N	\N	66909	66909	66910
16330	21124	2	applied	\N	\N	\N	\N	66911	66911	66912
16330	21125	3	applied	\N	\N	\N	\N	66913	66913	66914
16330	21126	4	applied	\N	\N	\N	\N	66915	66915	66916
16330	21127	5	applied	\N	\N	\N	\N	66917	66917	66918
16330	21128	6	applied	\N	\N	\N	\N	66919	66919	66920
16330	21129	7	applied	\N	\N	\N	\N	66921	66921	55758
16330	21130	8	applied	\N	\N	\N	\N	66922	66922	55760
16330	21131	9	applied	\N	\N	\N	\N	66923	66923	66924
16330	21132	10	applied	\N	\N	\N	\N	66925	66925	55765
16330	21133	11	applied	\N	\N	\N	\N	66926	66926	66927
16330	21134	12	applied	\N	\N	\N	\N	66928	66928	55770
16330	21135	13	applied	\N	\N	\N	\N	66929	66929	66930
16330	21136	14	applied	\N	\N	\N	\N	66931	66931	54539
16330	21137	15	applied	\N	\N	\N	\N	66932	66932	54548
16330	21138	16	applied	\N	\N	\N	\N	66933	66933	55778
16330	21139	17	applied	\N	\N	\N	\N	66934	66934	55780
16330	21140	18	applied	\N	\N	\N	\N	66935	66935	54554
16330	21141	19	applied	\N	\N	\N	\N	66936	66936	55782
16330	21142	20	applied	\N	\N	\N	\N	66937	66937	54618
16332	21146	0	applied	\N	\N	\N	\N	66949	66949	66950
16332	21147	1	applied	\N	\N	\N	\N	66951	66951	54629
16332	21148	2	applied	\N	\N	\N	\N	66952	66952	55790
16332	21149	3	applied	\N	\N	\N	\N	66953	66953	55792
16337	21160	0	applied	\N	\N	\N	\N	66976	66976	66977
16337	21161	1	applied	\N	\N	\N	\N	66978	66978	66979
16337	21162	2	applied	\N	\N	\N	\N	66980	66980	55806
16340	21170	0	applied	\N	\N	\N	\N	66995	66995	66996
16340	21171	1	applied	\N	\N	\N	\N	66997	66997	66998
16340	21172	2	applied	\N	\N	\N	\N	66999	66999	54681
16340	21173	3	applied	\N	\N	\N	\N	67000	67000	54686
16343	21177	0	applied	\N	\N	\N	\N	67008	67008	67009
16343	21178	1	applied	\N	\N	\N	\N	67010	67010	67011
16343	21179	2	applied	\N	\N	\N	\N	67012	67012	54707
16345	21184	0	applied	\N	\N	\N	\N	67024	67024	67025
16345	21185	1	applied	\N	\N	\N	\N	67026	67026	54713
16345	21186	2	applied	\N	\N	\N	\N	67027	67027	55836
16347	21187	0	applied	\N	\N	\N	\N	67032	67032	67033
16347	21188	1	applied	\N	\N	\N	\N	67034	67034	55838
16347	21189	2	applied	\N	\N	\N	\N	67035	67035	54731
16349	21187	0	applied	\N	\N	\N	\N	67032	67032	67033
16349	21188	1	applied	\N	\N	\N	\N	67034	67034	55838
16349	21189	2	applied	\N	\N	\N	\N	67035	67035	54731
16353	21207	0	applied	\N	\N	\N	\N	67068	67068	67069
16353	21208	1	applied	\N	\N	\N	\N	67070	67070	67071
16353	21209	2	applied	\N	\N	\N	\N	67072	67072	67073
16353	21210	3	applied	\N	\N	\N	\N	67074	67074	54775
16353	21211	4	applied	\N	\N	\N	\N	67075	67075	55868
16353	21212	5	applied	\N	\N	\N	\N	67076	67076	54779
16353	21213	6	applied	\N	\N	\N	\N	67077	67077	55870
16353	21214	7	applied	\N	\N	\N	\N	67078	67078	55873
16353	21215	8	applied	\N	\N	\N	\N	67079	67079	55876
16353	21216	9	applied	\N	\N	\N	\N	67080	67080	55878
16356	21226	0	applied	\N	\N	\N	\N	67100	67100	67101
16356	21227	1	applied	\N	\N	\N	\N	67102	67102	67103
16356	21228	2	applied	\N	\N	\N	\N	67104	67104	67105
16356	21229	3	applied	\N	\N	\N	\N	67106	67106	67107
16358	21226	0	applied	\N	\N	\N	\N	67100	67100	67101
16358	21227	1	applied	\N	\N	\N	\N	67102	67102	67103
16358	21228	2	applied	\N	\N	\N	\N	67104	67104	67105
16358	21229	3	applied	\N	\N	\N	\N	67106	67106	67107
16361	21236	0	applied	\N	\N	\N	\N	67121	67121	67122
16361	21237	1	applied	\N	\N	\N	\N	67123	67123	54876
16361	21238	2	applied	\N	\N	\N	\N	67124	67124	67125
16361	21239	3	applied	\N	\N	\N	\N	67126	67126	54885
16366	21247	0	applied	\N	\N	\N	\N	67148	67148	67149
16366	21248	1	applied	\N	\N	\N	\N	67150	67150	67151
16366	21254	2	applied	\N	\N	\N	\N	67162	67162	67163
16366	21249	3	applied	\N	\N	\N	\N	67152	67152	67153
16366	21255	4	applied	\N	\N	\N	\N	67164	67164	67165
16366	21250	5	applied	\N	\N	\N	\N	67154	67154	67155
16366	21251	6	applied	\N	\N	\N	\N	67156	67156	54905
16366	21253	7	applied	\N	\N	\N	\N	67159	67159	54909
16366	21256	8	applied	\N	\N	\N	\N	67166	67166	54911
16366	21252	9	applied	\N	\N	\N	\N	67157	67157	67167
16366	21257	10	applied	\N	\N	\N	\N	67168	67168	67169
16303	21062	2	applied	\N	\N	\N	\N	66767	66767	66768
16305	21063	0	applied	\N	\N	\N	\N	66772	66772	66773
16305	21064	1	applied	\N	\N	\N	\N	66774	66774	66775
16305	21065	2	applied	\N	\N	\N	\N	66776	66776	54334
16307	21066	0	applied	\N	\N	\N	\N	66793	66793	66794
16307	21067	1	applied	\N	\N	\N	\N	66795	66795	66796
16307	21068	2	applied	\N	\N	\N	\N	66797	66797	54346
16310	21069	0	applied	\N	\N	\N	\N	66800	66800	66801
16310	21070	1	applied	\N	\N	\N	\N	66802	66802	66803
16310	21071	2	applied	\N	\N	\N	\N	66804	66804	54348
16310	21072	3	applied	\N	\N	\N	\N	66805	66805	54354
16310	21073	4	applied	\N	\N	\N	\N	66806	66806	54358
16310	21074	5	applied	\N	\N	\N	\N	66807	66807	66808
16310	21075	6	applied	\N	\N	\N	\N	66809	66809	55380
16314	21079	0	applied	\N	\N	\N	\N	66825	66825	66826
16314	21080	1	applied	\N	\N	\N	\N	66827	66827	54385
16314	21081	2	applied	\N	\N	\N	\N	66828	66828	55388
16314	21082	3	applied	\N	\N	\N	\N	66829	66829	54387
16317	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16317	21090	1	applied	\N	\N	\N	\N	66842	66842	66843
16317	21091	2	applied	\N	\N	\N	\N	66844	66844	55400
16317	21092	3	applied	\N	\N	\N	\N	66845	66845	54412
16317	21093	4	applied	\N	\N	\N	\N	66846	66846	55719
16324	21106	0	applied	\N	\N	\N	\N	66876	66876	66877
16324	21107	1	applied	\N	\N	\N	\N	66878	66878	55736
16324	21108	2	applied	\N	\N	\N	\N	66879	66879	55739
16327	21112	0	applied	\N	\N	\N	\N	66888	66888	66889
16327	21113	1	applied	\N	\N	\N	\N	66890	66890	55744
16327	21114	2	applied	\N	\N	\N	\N	66891	66891	55746
16327	21115	3	applied	\N	\N	\N	\N	66892	66892	54476
16331	21143	0	applied	\N	\N	\N	\N	66942	66942	66943
16331	21144	1	applied	\N	\N	\N	\N	66944	66944	66945
16331	21145	2	applied	\N	\N	\N	\N	66946	66946	54627
16336	21156	0	applied	\N	\N	\N	\N	66970	66970	66971
16336	21157	1	applied	\N	\N	\N	\N	66972	66972	54649
16336	21158	2	applied	\N	\N	\N	\N	66973	66973	55800
16336	21159	3	applied	\N	\N	\N	\N	66974	66974	55802
16341	21174	0	applied	\N	\N	\N	\N	67003	67003	67004
16341	21175	1	applied	\N	\N	\N	\N	67005	67005	67006
16341	21176	2	applied	\N	\N	\N	\N	67007	67007	54697
16351	21190	0	applied	\N	\N	\N	\N	67042	67042	67043
16351	21191	1	applied	\N	\N	\N	\N	67044	67044	67045
16351	21192	2	applied	\N	\N	\N	\N	67046	67046	54735
16355	21223	0	applied	\N	\N	\N	\N	67094	67094	67095
16355	21224	1	applied	\N	\N	\N	\N	67096	67096	54835
16355	21225	2	applied	\N	\N	\N	\N	67097	67097	54839
16357	21226	0	applied	\N	\N	\N	\N	67100	67100	67101
16357	21227	1	applied	\N	\N	\N	\N	67102	67102	67103
16357	21228	2	applied	\N	\N	\N	\N	67104	67104	67105
16357	21229	3	applied	\N	\N	\N	\N	67106	67106	67107
16360	21236	0	applied	\N	\N	\N	\N	67121	67121	67122
16360	21237	1	applied	\N	\N	\N	\N	67123	67123	54876
16360	21238	2	applied	\N	\N	\N	\N	67124	67124	67125
16360	21239	3	applied	\N	\N	\N	\N	67126	67126	54885
16362	21240	0	applied	\N	\N	\N	\N	67130	67130	67131
16362	21241	1	applied	\N	\N	\N	\N	67132	67132	54889
16362	21242	2	applied	\N	\N	\N	\N	67133	67133	67134
16367	21258	0	applied	\N	\N	\N	\N	67172	67172	54927
16367	21259	1	applied	\N	\N	\N	\N	67173	67173	54929
16379	21279	0	applied	\N	\N	\N	\N	67219	67219	67220
16379	21280	1	applied	\N	\N	\N	\N	67221	67221	67222
16379	21281	2	applied	\N	\N	\N	\N	67223	67223	67224
16382	21291	0	applied	\N	\N	\N	\N	67247	67247	67248
16382	21292	1	applied	\N	\N	\N	\N	67249	67249	55027
16382	21293	2	applied	\N	\N	\N	\N	67250	67250	67251
16387	21298	0	applied	\N	\N	\N	\N	67265	67265	67266
16387	21299	1	applied	\N	\N	\N	\N	67267	67267	55037
16387	21300	2	applied	\N	\N	\N	\N	67268	67268	55041
16390	21319	0	applied	\N	\N	\N	\N	67302	67302	67303
16390	21320	1	applied	\N	\N	\N	\N	67304	67304	67305
16390	21321	2	applied	\N	\N	\N	\N	67306	67306	67307
16390	21322	3	applied	\N	\N	\N	\N	67308	67308	67308
16392	21319	0	applied	\N	\N	\N	\N	67302	67302	67303
16392	21323	1	applied	\N	\N	\N	\N	67313	67313	67314
16392	21320	2	applied	\N	\N	\N	\N	67304	67304	67305
16392	21321	3	applied	\N	\N	\N	\N	67306	67306	67307
16392	21324	4	applied	\N	\N	\N	\N	67315	67315	67316
16392	21322	5	applied	\N	\N	\N	\N	67308	67308	67308
16392	21325	6	applied	\N	\N	\N	\N	67317	67317	55112
16395	21323	0	applied	\N	\N	\N	\N	67313	67313	67314
16395	21326	1	applied	\N	\N	\N	\N	67321	67321	67322
16395	21327	2	applied	\N	\N	\N	\N	67323	67323	67324
16395	21324	3	applied	\N	\N	\N	\N	67315	67315	67316
16395	21328	4	applied	\N	\N	\N	\N	67325	67325	55106
16395	21329	5	applied	\N	\N	\N	\N	67326	67326	55112
16395	21330	6	applied	\N	\N	\N	\N	67327	67327	55114
16395	21325	7	applied	\N	\N	\N	\N	67317	67317	55116
16395	21331	8	applied	\N	\N	\N	\N	67328	67328	55125
16395	21332	9	applied	\N	\N	\N	\N	67329	67329	55127
16397	21333	0	applied	\N	\N	\N	\N	67332	67332	67333
16397	21334	1	applied	\N	\N	\N	\N	67334	67334	55137
16397	21335	2	applied	\N	\N	\N	\N	67335	67335	67336
16402	21347	0	applied	\N	\N	\N	\N	67364	67364	67365
16402	21348	1	applied	\N	\N	\N	\N	67366	67366	67367
16402	21349	3	applied	\N	\N	\N	\N	67369	67369	55172
16402	21350	4	applied	\N	\N	\N	\N	67370	67370	55176
16402	21351	5	applied	\N	\N	\N	\N	67371	67371	67372
16402	21352	6	applied	\N	\N	\N	\N	67373	67373	55178
16402	21353	7	applied	\N	\N	\N	\N	67374	67374	67375
16407	21363	0	applied	\N	\N	\N	\N	67397	67397	67398
16407	21364	1	applied	\N	\N	\N	\N	67399	67399	55219
16410	21363	0	applied	\N	\N	\N	\N	67397	67397	67398
16410	21365	1	applied	\N	\N	\N	\N	67401	67401	67402
16410	21364	2	applied	\N	\N	\N	\N	67399	67399	55221
16412	21372	0	applied	\N	\N	\N	\N	67420	67420	67421
16412	21373	1	applied	\N	\N	\N	\N	67422	67422	67423
16412	21374	2	applied	\N	\N	\N	\N	67424	67424	55241
16412	21375	3	applied	\N	\N	\N	\N	67425	67425	67426
16414	21372	0	applied	\N	\N	\N	\N	67420	67420	67421
16414	21373	1	applied	\N	\N	\N	\N	67422	67422	67423
16414	21374	2	applied	\N	\N	\N	\N	67424	67424	55241
16414	21375	3	applied	\N	\N	\N	\N	67425	67425	67426
16416	21376	0	applied	\N	\N	\N	\N	67435	67435	67436
16416	21377	1	applied	\N	\N	\N	\N	67437	67437	55251
16416	21378	2	applied	\N	\N	\N	\N	67438	67438	55253
16418	21376	0	applied	\N	\N	\N	\N	67435	67435	67436
16418	21377	1	applied	\N	\N	\N	\N	67437	67437	55251
16418	21378	2	applied	\N	\N	\N	\N	67438	67438	55253
16423	21386	0	applied	\N	\N	\N	\N	67460	67460	67461
16423	21387	1	applied	\N	\N	\N	\N	67462	67462	67463
16311	21074	5	applied	\N	\N	\N	\N	66807	66807	66808
16311	21075	6	applied	\N	\N	\N	\N	66809	66809	55380
16315	21083	0	applied	\N	\N	\N	\N	66831	66831	66832
16315	21084	1	applied	\N	\N	\N	\N	66833	66833	66834
16315	21085	2	applied	\N	\N	\N	\N	66835	66835	54389
16315	21086	3	applied	\N	\N	\N	\N	66836	66836	55393
16315	21087	4	applied	\N	\N	\N	\N	66837	66837	55395
16315	21088	5	applied	\N	\N	\N	\N	66838	66838	55398
16318	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16318	21090	1	applied	\N	\N	\N	\N	66842	66842	66843
16318	21091	2	applied	\N	\N	\N	\N	66844	66844	55400
16318	21092	3	applied	\N	\N	\N	\N	66845	66845	54412
16318	21093	4	applied	\N	\N	\N	\N	66846	66846	55719
16322	21099	0	applied	\N	\N	\N	\N	66863	66863	66864
16322	21100	1	applied	\N	\N	\N	\N	66865	66865	54435
16322	21101	2	applied	\N	\N	\N	\N	66866	66866	66867
16325	21109	0	applied	\N	\N	\N	\N	66882	66882	66883
16325	21110	1	applied	\N	\N	\N	\N	66884	66884	54457
16325	21111	2	applied	\N	\N	\N	\N	66885	66885	54465
16329	21122	0	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16329	21123	1	applied	\N	\N	\N	\N	66909	66909	66910
16329	21124	2	applied	\N	\N	\N	\N	66911	66911	66912
16329	21125	3	applied	\N	\N	\N	\N	66913	66913	66914
16329	21126	4	applied	\N	\N	\N	\N	66915	66915	66916
16329	21127	5	applied	\N	\N	\N	\N	66917	66917	66918
16329	21128	6	applied	\N	\N	\N	\N	66919	66919	66920
16329	21129	7	applied	\N	\N	\N	\N	66921	66921	55758
16329	21130	8	applied	\N	\N	\N	\N	66922	66922	55760
16329	21131	9	applied	\N	\N	\N	\N	66923	66923	66924
16329	21132	10	applied	\N	\N	\N	\N	66925	66925	55765
16329	21133	11	applied	\N	\N	\N	\N	66926	66926	66927
16329	21134	12	applied	\N	\N	\N	\N	66928	66928	55770
16329	21135	13	applied	\N	\N	\N	\N	66929	66929	66930
16329	21136	14	applied	\N	\N	\N	\N	66931	66931	54539
16329	21137	15	applied	\N	\N	\N	\N	66932	66932	54548
16329	21138	16	applied	\N	\N	\N	\N	66933	66933	55778
16329	21139	17	applied	\N	\N	\N	\N	66934	66934	55780
16329	21140	18	applied	\N	\N	\N	\N	66935	66935	54554
16329	21141	19	applied	\N	\N	\N	\N	66936	66936	55782
16329	21142	20	applied	\N	\N	\N	\N	66937	66937	54618
16334	21146	0	applied	\N	\N	\N	\N	66949	66949	66950
16334	21147	1	applied	\N	\N	\N	\N	66951	66951	54629
16334	21148	2	applied	\N	\N	\N	\N	66952	66952	55790
16334	21149	3	applied	\N	\N	\N	\N	66953	66953	55792
16339	21166	0	applied	\N	\N	\N	\N	66987	66987	66961
16339	21167	1	applied	\N	\N	\N	\N	66988	66988	66989
16339	21168	2	applied	\N	\N	\N	\N	66990	66990	55812
16339	21169	3	applied	\N	\N	\N	\N	66991	66991	55814
16342	21177	0	applied	\N	\N	\N	\N	67008	67008	67009
16342	21178	1	applied	\N	\N	\N	\N	67010	67010	67011
16342	21179	2	applied	\N	\N	\N	\N	67012	67012	54707
16344	21180	0	applied	\N	\N	\N	\N	67017	67017	67018
16344	21181	1	applied	\N	\N	\N	\N	67019	67019	54709
16344	21182	2	applied	\N	\N	\N	\N	67020	67020	55830
16344	21183	3	applied	\N	\N	\N	\N	67021	67021	55832
16352	21193	0	applied	\N	\N	\N	\N	67049	67049	67050
16352	21194	1	applied	\N	\N	\N	\N	67051	67051	67052
16352	21195	2	applied	\N	\N	\N	\N	67053	67053	67054
16352	21196	3	applied	\N	\N	\N	\N	67055	67055	67056
16352	21197	4	applied	\N	\N	\N	\N	67057	67057	54737
16352	21198	5	applied	\N	\N	\N	\N	67058	67058	55846
16352	21199	6	applied	\N	\N	\N	\N	67059	67059	55848
16352	21200	7	applied	\N	\N	\N	\N	67060	67060	55851
16352	21201	8	applied	\N	\N	\N	\N	67061	67061	55853
16352	21202	9	applied	\N	\N	\N	\N	67062	67062	55858
16352	21203	10	applied	\N	\N	\N	\N	67063	67063	54761
16352	21204	11	applied	\N	\N	\N	\N	67064	67064	54769
16352	21205	12	applied	\N	\N	\N	\N	67065	67065	55863
16352	21206	13	applied	\N	\N	\N	\N	67066	67066	54773
16363	21240	0	applied	\N	\N	\N	\N	67130	67130	67131
16363	21241	1	applied	\N	\N	\N	\N	67132	67132	54889
16365	21243	0	applied	\N	\N	\N	\N	67139	67139	67140
16365	21247	1	applied	\N	\N	\N	\N	67148	67148	67149
16365	21248	2	applied	\N	\N	\N	\N	67150	67150	67151
16365	21244	3	applied	\N	\N	\N	\N	67141	67141	67142
16365	21249	4	applied	\N	\N	\N	\N	67152	67152	67153
16365	21250	5	applied	\N	\N	\N	\N	67154	67154	67155
16365	21245	6	applied	\N	\N	\N	\N	67143	67143	67144
16365	21251	7	applied	\N	\N	\N	\N	67156	67156	54893
16365	21252	8	applied	\N	\N	\N	\N	67157	67157	67146
16365	21246	9	applied	\N	\N	\N	\N	67145	67145	67158
16365	21253	10	applied	\N	\N	\N	\N	67159	67159	67160
16370	21260	0	applied	\N	\N	\N	\N	67176	67176	67177
16370	21261	1	applied	\N	\N	\N	\N	67178	67178	67179
16370	21262	2	applied	\N	\N	\N	\N	67180	67180	67181
16372	21263	0	applied	\N	\N	\N	\N	67185	67185	67186
16372	21264	1	applied	\N	\N	\N	\N	67187	67187	67188
16372	21265	2	applied	\N	\N	\N	\N	67189	67189	67190
16372	21266	3	applied	\N	\N	\N	\N	67191	67191	54946
16375	21272	0	applied	\N	\N	\N	\N	67204	67204	67205
16375	21273	1	applied	\N	\N	\N	\N	67206	67206	67207
16375	21274	2	applied	\N	\N	\N	\N	67208	67208	67209
16375	21275	3	applied	\N	\N	\N	\N	67210	67210	67211
16375	21276	4	applied	\N	\N	\N	\N	67212	67212	67213
16375	21277	5	applied	\N	\N	\N	\N	67214	67214	54975
16375	21278	6	applied	\N	\N	\N	\N	67215	67215	67216
16378	21279	0	applied	\N	\N	\N	\N	67219	67219	67220
16378	21280	1	applied	\N	\N	\N	\N	67221	67221	67222
16378	21281	2	applied	\N	\N	\N	\N	67223	67223	67224
16380	21282	0	applied	\N	\N	\N	\N	67229	67229	67230
16380	21283	1	applied	\N	\N	\N	\N	67231	67231	67232
16380	21284	2	applied	\N	\N	\N	\N	67233	67233	55000
16380	21285	3	applied	\N	\N	\N	\N	67234	67234	55002
16380	21286	4	applied	\N	\N	\N	\N	67235	67235	67236
16380	21287	5	applied	\N	\N	\N	\N	67237	67237	55004
16383	21291	0	applied	\N	\N	\N	\N	67247	67247	67248
16383	21292	1	applied	\N	\N	\N	\N	67249	67249	55027
16383	21293	2	applied	\N	\N	\N	\N	67250	67250	67251
16391	21319	0	applied	\N	\N	\N	\N	67302	67302	67303
16391	21320	1	applied	\N	\N	\N	\N	67304	67304	67305
16391	21321	2	applied	\N	\N	\N	\N	67306	67306	67307
16391	21322	3	applied	\N	\N	\N	\N	67308	67308	67308
16393	21314	0	applied	\N	\N	\N	\N	67294	67294	67294
16393	21322	1	applied	\N	\N	\N	\N	67308	67308	67308
16398	21336	0	applied	\N	\N	\N	\N	67341	67341	67342
16398	21337	1	applied	\N	\N	1000000000	\N	67343	67343	67344
16398	21338	2	applied	\N	\N	\N	\N	67345	67345	67346
16398	21339	3	applied	\N	\N	\N	\N	67347	67347	55146
16398	21340	4	applied	\N	\N	\N	\N	67348	67348	67349
16368	21258	0	applied	\N	\N	\N	\N	67172	67172	54927
16368	21259	1	applied	\N	\N	\N	\N	67173	67173	54929
16371	21260	0	applied	\N	\N	\N	\N	67176	67176	67177
16371	21262	1	applied	\N	\N	\N	\N	67180	67180	54931
16373	21267	0	applied	\N	\N	\N	\N	67193	67193	67194
16373	21268	1	applied	\N	\N	\N	\N	67195	67195	67196
16373	21269	2	applied	\N	\N	\N	\N	67197	67197	54948
16373	21270	3	applied	\N	\N	\N	\N	67198	67198	67199
16373	21271	4	applied	\N	\N	\N	\N	67200	67200	54956
16376	21279	0	applied	\N	\N	\N	\N	67219	67219	67220
16376	21280	1	applied	\N	\N	\N	\N	67221	67221	67222
16376	21281	2	applied	\N	\N	\N	\N	67223	67223	67224
16385	21294	0	applied	\N	\N	\N	\N	67257	67257	67258
16385	21295	1	applied	\N	\N	\N	\N	67259	67259	55031
16385	21296	2	applied	\N	\N	\N	\N	67260	67260	55033
16385	21297	3	applied	\N	\N	\N	\N	67261	67261	67262
16388	21301	0	applied	\N	\N	\N	\N	67271	67271	67272
16388	21302	1	applied	\N	\N	\N	\N	67273	67273	67274
16388	21303	2	applied	\N	\N	\N	\N	67275	67275	55047
16388	21304	3	applied	\N	\N	\N	\N	67276	67276	55051
16388	21305	4	applied	\N	\N	\N	\N	67277	67277	67278
16388	21306	5	applied	\N	\N	\N	\N	67279	67279	55060
16388	21307	6	applied	\N	\N	\N	\N	67280	67280	67281
16396	21333	0	applied	\N	\N	\N	\N	67332	67332	67333
16396	21334	1	applied	\N	\N	\N	\N	67334	67334	55137
16396	21335	2	applied	\N	\N	\N	\N	67335	67335	67336
16401	21347	0	applied	\N	\N	\N	\N	67364	67364	67365
16401	21348	1	applied	\N	\N	\N	\N	67366	67366	67367
16401	21349	3	applied	\N	\N	\N	\N	67369	67369	55172
16401	21350	4	applied	\N	\N	\N	\N	67370	67370	55176
16401	21351	5	applied	\N	\N	\N	\N	67371	67371	67372
16401	21352	6	applied	\N	\N	\N	\N	67373	67373	55178
16401	21353	7	applied	\N	\N	\N	\N	67374	67374	67375
16404	21354	0	applied	\N	\N	\N	\N	67378	67378	67379
16404	21355	1	applied	\N	\N	\N	\N	67380	67380	67381
16404	21356	2	applied	\N	\N	\N	\N	67382	67382	55195
16406	21360	0	applied	\N	\N	\N	\N	67389	67389	67390
16406	21361	1	applied	\N	\N	\N	\N	67391	67391	67392
16406	21362	2	applied	\N	\N	\N	\N	67393	67393	67394
16415	21372	0	applied	\N	\N	\N	\N	67420	67420	67421
16415	21373	1	applied	\N	\N	\N	\N	67422	67422	67423
16415	21374	2	applied	\N	\N	\N	\N	67424	67424	55241
16415	21375	3	applied	\N	\N	\N	\N	67425	67425	67426
16422	21382	0	applied	\N	\N	\N	\N	67450	67450	67451
16422	21383	1	applied	\N	\N	\N	\N	67452	67452	67453
16422	21384	2	applied	\N	\N	\N	\N	67454	67454	55266
16422	21385	3	applied	\N	\N	\N	\N	67455	67455	67456
16424	21386	0	applied	\N	\N	\N	\N	67460	67460	67461
16424	21387	1	applied	\N	\N	\N	\N	67462	67462	67463
16424	21388	2	applied	\N	\N	\N	\N	67464	67464	67465
16424	21389	3	applied	\N	\N	\N	\N	67466	67466	55282
16424	21390	4	applied	\N	\N	\N	\N	67467	67467	55286
16424	21391	5	applied	\N	\N	\N	\N	67468	67468	55294
16427	21392	0	applied	\N	\N	\N	\N	67475	67475	67476
16427	21393	1	applied	\N	\N	\N	\N	67477	67477	67477
16427	21394	2	applied	\N	\N	\N	\N	67478	67478	67479
16427	21395	3	applied	\N	\N	\N	\N	67480	67480	55306
16431	21400	0	applied	\N	\N	\N	\N	67492	67492	67493
16431	21401	1	applied	\N	\N	\N	\N	67494	67494	67495
16431	21402	2	applied	\N	\N	\N	\N	67496	67496	67497
16431	21403	3	applied	\N	\N	\N	\N	67498	67498	67498
16431	21404	4	applied	\N	\N	\N	\N	67499	67499	67500
16431	21405	5	applied	\N	\N	\N	\N	67501	67501	67501
16431	21406	6	applied	\N	\N	\N	\N	67502	67502	55330
16434	21407	0	applied	\N	\N	\N	\N	67508	67508	67509
16434	21408	1	applied	\N	\N	\N	\N	67510	67510	67511
16434	21409	2	applied	\N	\N	\N	\N	67512	67512	67513
16434	21410	3	applied	\N	\N	\N	\N	67514	67514	67515
16434	21411	4	applied	\N	\N	\N	\N	67516	67516	55332
16434	21412	5	applied	\N	\N	\N	\N	67517	67517	55406
16434	21413	6	applied	\N	\N	\N	\N	67518	67518	67518
16434	21414	7	applied	\N	\N	\N	\N	67519	67519	67520
16434	21415	8	applied	\N	\N	\N	\N	67521	67521	67522
16434	21416	9	applied	\N	\N	\N	\N	67523	67523	55424
16434	21417	10	applied	\N	\N	\N	\N	67524	67524	67525
16434	21418	11	applied	\N	\N	\N	\N	67526	67526	67527
16436	21419	0	applied	\N	\N	\N	\N	67530	67530	67531
16436	21420	1	applied	\N	\N	\N	\N	67532	67532	55428
16436	21421	2	applied	\N	\N	\N	\N	67533	67533	67533
16436	21422	3	applied	\N	\N	\N	\N	67534	67534	67535
16443	21431	0	applied	\N	\N	\N	\N	67557	67557	67558
16443	21432	1	applied	\N	\N	\N	\N	67559	67559	67560
16443	21433	2	applied	\N	\N	\N	\N	67561	67561	67562
16443	21434	3	applied	\N	\N	\N	\N	67563	67563	55464
16452	21460	0	applied	\N	\N	\N	\N	67619	67619	67620
16452	21461	1	applied	\N	\N	\N	\N	67621	67621	67622
16452	21462	2	applied	\N	\N	1000000000	\N	67623	67623	67624
16452	21463	3	applied	\N	\N	\N	\N	67625	67625	55559
16452	21464	4	applied	\N	\N	\N	\N	67626	67626	67627
16452	21465	5	applied	\N	\N	\N	\N	67628	67628	55565
16452	21466	6	applied	\N	\N	\N	\N	67629	67629	55567
16452	21467	7	applied	\N	\N	\N	\N	67630	67630	67631
16454	21326	0	applied	\N	\N	\N	\N	67321	67321	67322
16454	21327	1	applied	\N	\N	\N	\N	67323	67323	67324
16454	21333	2	applied	\N	\N	\N	\N	67332	67332	67333
16454	21336	3	applied	\N	\N	\N	\N	67341	67341	67342
16454	21337	4	applied	\N	\N	1000000000	\N	67343	67343	67344
16454	21462	5	applied	\N	\N	1000000000	\N	67623	67623	67624
16454	21409	6	applied	\N	\N	\N	\N	67512	67512	67513
16454	21338	7	applied	\N	\N	\N	\N	67345	67345	67346
16454	21344	8	applied	\N	\N	\N	\N	67356	67356	67357
16454	21347	9	applied	\N	\N	\N	\N	67364	67364	67365
16454	21348	10	applied	\N	\N	\N	\N	67366	67366	67367
16454	21354	11	applied	\N	\N	\N	\N	67378	67378	67379
16454	21357	12	applied	\N	\N	\N	\N	67385	67385	67386
16454	21360	13	applied	\N	\N	\N	\N	67389	67389	67390
16454	21363	14	applied	\N	\N	\N	\N	67397	67397	67398
16454	21366	15	applied	\N	\N	\N	\N	67406	67406	67407
16454	21367	16	applied	\N	\N	\N	\N	67408	67408	67409
16454	21372	17	applied	\N	\N	\N	\N	67420	67420	67421
16454	21376	18	applied	\N	\N	\N	\N	67435	67435	67436
16454	21379	19	applied	\N	\N	\N	\N	67444	67444	67445
16454	21382	20	applied	\N	\N	\N	\N	67450	67450	67451
16454	21386	21	applied	\N	\N	\N	\N	67460	67460	67461
16454	21387	22	applied	\N	\N	\N	\N	67462	67462	67463
16454	21392	23	applied	\N	\N	\N	\N	67475	67475	67476
16454	21396	24	applied	\N	\N	\N	\N	67481	67481	67482
16454	21400	25	applied	\N	\N	\N	\N	67492	67492	67493
16454	21401	26	applied	\N	\N	\N	\N	67494	67494	67495
16398	21341	5	applied	\N	\N	\N	\N	67350	67350	55152
16398	21342	6	applied	\N	\N	\N	\N	67351	67351	67352
16398	21343	7	applied	\N	\N	\N	\N	67353	67353	67354
16400	21344	0	applied	\N	\N	\N	\N	67356	67356	67357
16400	21345	1	applied	\N	\N	\N	\N	67358	67358	55168
16400	21346	2	applied	\N	\N	\N	\N	67359	67359	55170
16403	21354	0	applied	\N	\N	\N	\N	67378	67378	67379
16403	21355	1	applied	\N	\N	\N	\N	67380	67380	67381
16403	21356	2	applied	\N	\N	\N	\N	67382	67382	55195
16405	21357	0	applied	\N	\N	\N	\N	67385	67385	67386
16405	21358	1	applied	\N	\N	\N	\N	67387	67387	55197
16405	21359	2	applied	\N	\N	\N	\N	67388	67388	55199
16408	21363	0	applied	\N	\N	\N	\N	67397	67397	67398
16408	21365	1	applied	\N	\N	\N	\N	67401	67401	67402
16408	21364	2	applied	\N	\N	\N	\N	67399	67399	55221
16413	21372	0	applied	\N	\N	\N	\N	67420	67420	67421
16413	21373	1	applied	\N	\N	\N	\N	67422	67422	67423
16413	21374	2	applied	\N	\N	\N	\N	67424	67424	55241
16413	21375	3	applied	\N	\N	\N	\N	67425	67425	67426
16417	21377	0	applied	\N	\N	\N	\N	67437	67437	55251
16417	21378	1	applied	\N	\N	\N	\N	67438	67438	55253
16419	21376	0	applied	\N	\N	\N	\N	67435	67435	67436
16419	21379	1	applied	\N	\N	\N	\N	67444	67444	67445
16419	21380	2	applied	\N	\N	\N	\N	67446	67446	55260
16419	21381	3	applied	\N	\N	\N	\N	67447	67447	67448
16421	21382	0	applied	\N	\N	\N	\N	67450	67450	67451
16421	21383	1	applied	\N	\N	\N	\N	67452	67452	67453
16421	21384	2	applied	\N	\N	\N	\N	67454	67454	55266
16421	21385	3	applied	\N	\N	\N	\N	67455	67455	67456
16426	21392	0	applied	\N	\N	\N	\N	67475	67475	67476
16426	21393	1	applied	\N	\N	\N	\N	67477	67477	67477
16426	21394	2	applied	\N	\N	\N	\N	67478	67478	67479
16426	21395	3	applied	\N	\N	\N	\N	67480	67480	55306
16428	21396	0	applied	\N	\N	\N	\N	67481	67481	67482
16428	21397	1	applied	\N	\N	\N	\N	67483	67483	55308
16428	21398	2	applied	\N	\N	\N	\N	67484	67484	55310
16428	21399	3	applied	\N	\N	\N	\N	67485	67485	55317
16433	21400	0	applied	\N	\N	\N	\N	67492	67492	67493
16433	21401	1	applied	\N	\N	\N	\N	67494	67494	67495
16433	21402	2	applied	\N	\N	\N	\N	67496	67496	67497
16433	21403	3	applied	\N	\N	\N	\N	67498	67498	67498
16433	21404	4	applied	\N	\N	\N	\N	67499	67499	67500
16433	21405	5	applied	\N	\N	\N	\N	67501	67501	67501
16433	21406	6	applied	\N	\N	\N	\N	67502	67502	55330
16438	21424	0	applied	\N	\N	\N	\N	67541	67541	67542
16438	21425	1	applied	\N	\N	\N	\N	67543	67543	67544
16440	21423	0	applied	\N	\N	\N	\N	67539	67539	67540
16440	21426	1	applied	\N	\N	\N	\N	67546	67546	67547
16440	21427	2	applied	\N	\N	\N	\N	67548	67548	55448
16446	21438	0	applied	\N	\N	\N	\N	67575	67575	67576
16446	21439	1	applied	\N	\N	\N	\N	67577	67577	67578
16446	21440	2	applied	\N	\N	\N	\N	67579	67579	67580
16446	21441	3	applied	\N	\N	\N	\N	67581	67581	55478
16446	21442	4	applied	\N	\N	\N	\N	67582	67582	55495
16446	21443	5	applied	\N	\N	\N	\N	67583	67583	67584
16446	21444	6	applied	\N	\N	\N	\N	67585	67585	55499
16446	21445	7	applied	\N	\N	\N	\N	67586	67586	67587
16446	21446	8	applied	\N	\N	\N	\N	67588	67588	55503
16446	21447	9	applied	\N	\N	\N	\N	67589	67589	67590
16449	21450	0	applied	\N	\N	\N	\N	67598	67598	67599
16449	21451	1	applied	\N	\N	\N	\N	67600	67600	67601
16449	21452	2	applied	\N	\N	\N	\N	67602	67602	67603
16449	21453	3	applied	\N	\N	\N	\N	67604	67604	55524
16449	21454	4	applied	\N	\N	\N	\N	67605	67605	67606
16449	21455	5	applied	\N	\N	\N	\N	67607	67607	55528
16449	21456	6	applied	\N	\N	\N	\N	67608	67608	67609
16451	21460	0	applied	\N	\N	\N	\N	67619	67619	67620
16451	21461	1	applied	\N	\N	\N	\N	67621	67621	67622
16451	21462	2	applied	\N	\N	1000000000	\N	67623	67623	67624
16451	21463	3	applied	\N	\N	\N	\N	67625	67625	55559
16451	21464	4	applied	\N	\N	\N	\N	67626	67626	67627
16451	21465	5	applied	\N	\N	\N	\N	67628	67628	55565
16451	21466	6	applied	\N	\N	\N	\N	67629	67629	55567
16451	21467	7	applied	\N	\N	\N	\N	67630	67630	67631
16461	21488	0	applied	\N	\N	\N	\N	67720	67720	67721
16461	21489	1	applied	\N	\N	\N	\N	67722	67722	55637
16461	21490	2	applied	\N	\N	\N	\N	67723	67723	67724
16463	21491	0	applied	\N	\N	\N	\N	67726	67726	67727
16463	21492	1	applied	\N	\N	\N	\N	67728	67728	67729
16470	21500	0	applied	\N	\N	\N	\N	67751	67751	67752
16470	21501	1	applied	\N	\N	\N	\N	67753	67753	55667
16470	21502	2	applied	\N	\N	\N	\N	67754	67754	67755
16472	21337	0	applied	\N	\N	1000000000	\N	67343	67343	67344
16472	21462	1	applied	\N	\N	1000000000	\N	67623	67623	67624
16472	21409	2	applied	\N	\N	\N	\N	67759	67759	67513
16472	21314	3	applied	\N	\N	\N	\N	67294	67294	67294
16472	21322	4	applied	\N	\N	\N	\N	67308	67308	67308
16472	21393	5	applied	\N	\N	\N	\N	67477	67477	67477
16472	21403	6	applied	\N	\N	\N	\N	67498	67498	67498
16472	21405	7	applied	\N	\N	\N	\N	67501	67501	67501
16472	21413	8	applied	\N	\N	\N	\N	67518	67518	67518
16472	21421	9	applied	\N	\N	\N	\N	67533	67533	67533
16479	21513	0	applied	\N	\N	\N	\N	67785	67785	67786
16479	21514	1	applied	\N	\N	\N	\N	67787	67787	67788
16479	21515	2	applied	\N	\N	\N	\N	67789	67789	67790
16485	21534	0	applied	\N	\N	\N	\N	67828	67828	67829
16485	21535	1	applied	\N	\N	\N	\N	67830	67830	67831
16485	21536	2	applied	\N	\N	\N	\N	67832	67832	67833
16491	21544	0	applied	\N	\N	\N	\N	67854	67854	67855
16491	21545	1	applied	\N	\N	\N	\N	67856	67856	67857
16491	21546	2	applied	\N	\N	\N	\N	67858	67858	55976
16491	21547	3	applied	\N	\N	\N	\N	67859	67859	67860
16494	21554	0	applied	\N	\N	\N	\N	67876	67876	67877
16494	21555	1	applied	\N	\N	\N	\N	67878	67878	67879
16494	21556	2	applied	\N	\N	\N	\N	67880	67880	56000
16494	21557	3	applied	\N	\N	\N	\N	67881	67881	56002
16497	21571	0	applied	\N	\N	\N	\N	67903	67903	67904
16497	21572	1	applied	\N	\N	\N	\N	67905	67905	67906
16497	21573	2	applied	\N	\N	\N	\N	67907	67907	56049
16500	21582	0	applied	\N	\N	\N	\N	67924	67924	67925
16500	21583	1	applied	\N	\N	\N	\N	67926	67926	56068
16500	21584	2	applied	\N	\N	\N	\N	67927	67927	67928
16505	21593	0	applied	\N	\N	\N	\N	67948	67948	67949
16505	21594	1	applied	\N	\N	\N	\N	67950	67950	56091
16505	21595	2	applied	\N	\N	\N	\N	67951	67951	56093
16508	21607	0	applied	\N	\N	\N	\N	67975	67975	67976
16508	21608	1	applied	\N	\N	\N	\N	67977	67977	67978
16508	21609	2	applied	\N	\N	\N	\N	67979	67979	67980
16508	21610	3	applied	\N	\N	\N	\N	67981	67981	56128
16411	21369	3	applied	\N	\N	\N	\N	67412	67412	67413
16411	21370	4	applied	\N	\N	\N	\N	67414	67414	67415
16411	21371	5	applied	\N	\N	\N	\N	67416	67416	67417
16420	21382	0	applied	\N	\N	\N	\N	67450	67450	67451
16420	21383	1	applied	\N	\N	\N	\N	67452	67452	67453
16420	21384	2	applied	\N	\N	\N	\N	67454	67454	55266
16420	21385	3	applied	\N	\N	\N	\N	67455	67455	67456
16425	21386	0	applied	\N	\N	\N	\N	67460	67460	67461
16425	21387	1	applied	\N	\N	\N	\N	67462	67462	67463
16425	21388	2	applied	\N	\N	\N	\N	67464	67464	67465
16425	21389	3	applied	\N	\N	\N	\N	67466	67466	55282
16425	21390	4	applied	\N	\N	\N	\N	67467	67467	55286
16425	21391	5	applied	\N	\N	\N	\N	67468	67468	55294
16429	21396	0	applied	\N	\N	\N	\N	67481	67481	67482
16429	21397	1	applied	\N	\N	\N	\N	67483	67483	55308
16429	21398	2	applied	\N	\N	\N	\N	67484	67484	55310
16429	21399	3	applied	\N	\N	\N	\N	67485	67485	55317
16432	21400	0	applied	\N	\N	\N	\N	67492	67492	67493
16432	21401	1	applied	\N	\N	\N	\N	67494	67494	67495
16432	21402	2	applied	\N	\N	\N	\N	67496	67496	67497
16432	21403	3	applied	\N	\N	\N	\N	67498	67498	67498
16432	21404	4	applied	\N	\N	\N	\N	67499	67499	67500
16432	21405	5	applied	\N	\N	\N	\N	67501	67501	67501
16432	21406	6	applied	\N	\N	\N	\N	67502	67502	55330
16437	21423	0	applied	\N	\N	\N	\N	67539	67539	67540
16437	21424	1	applied	\N	\N	\N	\N	67541	67541	67542
16437	21425	2	applied	\N	\N	\N	\N	67543	67543	67544
16439	21423	0	applied	\N	\N	\N	\N	67539	67539	67540
16439	21426	1	applied	\N	\N	\N	\N	67546	67546	67547
16439	21427	2	applied	\N	\N	\N	\N	67548	67548	55448
16441	21426	0	applied	\N	\N	\N	\N	67546	67546	67547
16441	21427	1	applied	\N	\N	\N	\N	67548	67548	55448
16444	21435	0	applied	\N	\N	\N	\N	67566	67566	67567
16444	21436	2	applied	\N	\N	\N	\N	67569	67569	67570
16444	21437	3	applied	\N	\N	\N	\N	67571	67571	67572
16447	21448	0	applied	\N	\N	\N	\N	67593	67593	67594
16447	21449	1	applied	\N	\N	\N	\N	67595	67595	55513
16457	21471	0	applied	\N	\N	\N	\N	67684	67684	67685
16457	21472	1	applied	\N	\N	\N	\N	67686	67686	55584
16457	21473	2	applied	\N	\N	\N	\N	67687	67687	55593
16460	21484	0	applied	\N	\N	\N	\N	67710	67710	67711
16460	21485	1	applied	\N	\N	\N	\N	67712	67712	55629
16460	21486	2	applied	\N	\N	\N	\N	67713	67713	67714
16460	21487	3	applied	\N	\N	\N	\N	67715	67715	55633
16462	21488	0	applied	\N	\N	\N	\N	67720	67720	67721
16462	21489	1	applied	\N	\N	\N	\N	67722	67722	55637
16462	21490	2	applied	\N	\N	\N	\N	67723	67723	67724
16469	21496	0	applied	\N	\N	\N	\N	67739	67739	67740
16469	21497	1	applied	\N	\N	\N	\N	67741	67741	67742
16469	21498	2	applied	\N	\N	\N	\N	67743	67743	67744
16469	21499	3	applied	\N	\N	\N	\N	67745	67745	55663
16473	21503	0	applied	\N	\N	\N	\N	67762	67762	67763
16473	21504	1	applied	\N	\N	\N	\N	67764	67764	67765
16473	21505	2	applied	\N	\N	\N	\N	67766	67766	67767
16475	21503	0	applied	\N	\N	\N	\N	67762	67762	67763
16475	21504	1	applied	\N	\N	\N	\N	67764	67764	67765
16475	21505	2	applied	\N	\N	\N	\N	67766	67766	67767
16478	21513	0	applied	\N	\N	\N	\N	67785	67785	67786
16478	21514	1	applied	\N	\N	\N	\N	67787	67787	67788
16478	21515	2	applied	\N	\N	\N	\N	67789	67789	67790
16481	21513	0	applied	\N	\N	\N	\N	67785	67785	67786
16481	21514	1	applied	\N	\N	\N	\N	67787	67787	67788
16481	21515	2	applied	\N	\N	\N	\N	67789	67789	67790
16482	21516	0	applied	\N	\N	\N	\N	67793	67793	67794
16482	21517	1	applied	\N	\N	\N	\N	67795	67795	67796
16482	21518	2	applied	\N	\N	\N	\N	67797	67797	55891
16482	21519	3	applied	\N	\N	\N	\N	67798	67798	55893
16483	21520	0	applied	\N	\N	\N	\N	67801	67801	67802
16483	21521	1	applied	\N	\N	1000000000	\N	67803	67803	67804
16483	21522	2	applied	\N	\N	\N	\N	67805	67805	67806
16483	21523	4	applied	\N	\N	\N	\N	67808	67808	67809
16483	21524	5	applied	\N	\N	\N	\N	67810	67810	67811
16483	21525	6	applied	\N	\N	\N	\N	67812	67812	67813
16483	21526	7	applied	\N	\N	\N	\N	67814	67814	55895
16483	21527	8	applied	\N	\N	\N	\N	67815	67815	67816
16483	21528	9	applied	\N	\N	\N	\N	67817	67817	55908
16483	21529	10	applied	\N	\N	\N	\N	67818	67818	67819
16483	21530	11	applied	\N	\N	\N	\N	67820	67820	55919
16483	21531	12	applied	\N	\N	\N	\N	67821	67821	55921
16483	21532	13	applied	\N	\N	\N	\N	67822	67822	67823
16483	21533	14	applied	\N	\N	\N	\N	67824	67824	67825
16490	21540	0	applied	\N	\N	\N	\N	67848	67848	67849
16490	21541	1	applied	\N	\N	\N	\N	67850	67850	55964
16490	21542	2	applied	\N	\N	\N	\N	67851	67851	67852
16490	21543	3	applied	\N	\N	\N	\N	67853	67853	55966
16496	21558	0	applied	\N	\N	\N	\N	67883	67883	67884
16496	21559	1	applied	\N	\N	\N	\N	67885	67885	67886
16496	21560	2	applied	\N	\N	\N	\N	67887	67887	67888
16496	21561	3	applied	\N	\N	\N	\N	67889	67889	67890
16496	21562	4	applied	\N	\N	\N	\N	67891	67891	67892
16496	21563	5	applied	\N	\N	\N	\N	67893	67893	56007
16496	21564	6	applied	\N	\N	\N	\N	67894	67894	56009
16496	21565	7	applied	\N	\N	\N	\N	67895	67895	67896
16496	21566	8	applied	\N	\N	\N	\N	67897	67897	56017
16496	21567	9	applied	\N	\N	\N	\N	67898	67898	56021
16496	21568	10	applied	\N	\N	\N	\N	67899	67899	56027
16496	21569	11	applied	\N	\N	\N	\N	67900	67900	56036
16496	21570	12	applied	\N	\N	\N	\N	67901	67901	56038
16501	21582	0	applied	\N	\N	\N	\N	67924	67924	67925
16501	21583	1	applied	\N	\N	\N	\N	67926	67926	56068
16501	21584	2	applied	\N	\N	\N	\N	67927	67927	67928
16504	21585	0	applied	\N	\N	\N	\N	67933	67933	67934
16504	21586	1	applied	\N	\N	\N	\N	67935	67935	67936
16504	21587	2	applied	\N	\N	\N	\N	67937	67937	67938
16504	21588	3	applied	\N	\N	\N	\N	67939	67939	56076
16504	21589	4	applied	\N	\N	\N	\N	67940	67940	56080
16504	21590	5	applied	\N	\N	\N	\N	67941	67941	67942
16504	21591	6	applied	\N	\N	\N	\N	67943	67943	56084
16504	21592	7	applied	\N	\N	\N	\N	67944	67944	56089
16506	21593	0	applied	\N	\N	\N	\N	67948	67948	67949
16506	21594	1	applied	\N	\N	\N	\N	67950	67950	56091
16506	21595	2	applied	\N	\N	\N	\N	67951	67951	56093
16513	21630	0	applied	\N	\N	\N	\N	68018	68018	68019
16513	21631	1	applied	\N	\N	\N	\N	68020	68020	56182
16513	21632	2	applied	\N	\N	\N	\N	68021	68021	56192
16513	21633	3	applied	\N	\N	\N	\N	68022	68022	68023
16519	21637	0	applied	\N	\N	\N	\N	68047	68047	68048
16519	21638	1	applied	\N	\N	\N	\N	68049	68049	68050
16519	21635	2	applied	\N	\N	\N	\N	68038	68038	56208
16519	21639	3	applied	\N	\N	\N	\N	68051	68051	56215
16423	21388	2	applied	\N	\N	\N	\N	67464	67464	67465
16423	21389	3	applied	\N	\N	\N	\N	67466	67466	55282
16423	21390	4	applied	\N	\N	\N	\N	67467	67467	55286
16423	21391	5	applied	\N	\N	\N	\N	67468	67468	55294
16430	21396	0	applied	\N	\N	\N	\N	67481	67481	67482
16430	21397	1	applied	\N	\N	\N	\N	67483	67483	55308
16430	21398	2	applied	\N	\N	\N	\N	67484	67484	55310
16430	21399	3	applied	\N	\N	\N	\N	67485	67485	55317
16435	21419	0	applied	\N	\N	\N	\N	67530	67530	67531
16435	21420	1	applied	\N	\N	\N	\N	67532	67532	55428
16435	21421	2	applied	\N	\N	\N	\N	67533	67533	67533
16435	21422	3	applied	\N	\N	\N	\N	67534	67534	67535
16442	21428	0	applied	\N	\N	\N	\N	67552	67552	67553
16442	21429	1	applied	\N	\N	\N	\N	67554	67554	55450
16442	21430	2	applied	\N	\N	\N	\N	67555	67555	55458
16445	21438	0	applied	\N	\N	\N	\N	67575	67575	67576
16445	21439	1	applied	\N	\N	\N	\N	67577	67577	67578
16445	21440	2	applied	\N	\N	\N	\N	67579	67579	67580
16445	21441	3	applied	\N	\N	\N	\N	67581	67581	55478
16445	21442	4	applied	\N	\N	\N	\N	67582	67582	55495
16445	21443	5	applied	\N	\N	\N	\N	67583	67583	67584
16445	21444	6	applied	\N	\N	\N	\N	67585	67585	55499
16445	21445	7	applied	\N	\N	\N	\N	67586	67586	67587
16445	21446	8	applied	\N	\N	\N	\N	67588	67588	55503
16445	21447	9	applied	\N	\N	\N	\N	67589	67589	67590
16448	21450	0	applied	\N	\N	\N	\N	67598	67598	67599
16448	21451	1	applied	\N	\N	\N	\N	67600	67600	67601
16448	21452	2	applied	\N	\N	\N	\N	67602	67602	67603
16448	21453	3	applied	\N	\N	\N	\N	67604	67604	55524
16448	21454	4	applied	\N	\N	\N	\N	67605	67605	67606
16448	21455	5	applied	\N	\N	\N	\N	67607	67607	55528
16448	21456	6	applied	\N	\N	\N	\N	67608	67608	67609
16450	21457	0	applied	\N	\N	\N	\N	67614	67614	67615
16450	21458	1	applied	\N	\N	\N	\N	67616	67616	55532
16450	21459	2	applied	\N	\N	\N	\N	67617	67617	55557
16453	21460	0	applied	\N	\N	\N	\N	67619	67619	67620
16453	21461	1	applied	\N	\N	\N	\N	67621	67621	67622
16453	21462	2	applied	\N	\N	1000000000	\N	67623	67623	67624
16453	21463	3	applied	\N	\N	\N	\N	67625	67625	55559
16453	21464	4	applied	\N	\N	\N	\N	67626	67626	67627
16453	21465	5	applied	\N	\N	\N	\N	67628	67628	55565
16453	21466	6	applied	\N	\N	\N	\N	67629	67629	55567
16453	21467	7	applied	\N	\N	\N	\N	67630	67630	67631
16455	21468	0	applied	\N	\N	\N	\N	67676	67676	67677
16455	21469	1	applied	\N	\N	\N	\N	67678	67678	67679
16455	21470	2	applied	\N	\N	\N	\N	67680	67680	67681
16458	21474	0	applied	\N	\N	\N	\N	67692	67692	67693
16458	21475	1	applied	\N	\N	\N	\N	67694	67694	67695
16458	21476	2	applied	\N	\N	\N	\N	67696	67696	67697
16458	21477	3	applied	\N	\N	\N	\N	67698	67698	67699
16458	21478	4	applied	\N	\N	\N	\N	67700	67700	55595
16458	21479	5	applied	\N	\N	\N	\N	67701	67701	55597
16458	21480	6	applied	\N	\N	\N	\N	67702	67702	67703
16458	21481	7	applied	\N	\N	\N	\N	67704	67704	67705
16458	21482	8	applied	\N	\N	\N	\N	67706	67706	55620
16458	21483	9	applied	\N	\N	\N	\N	67707	67707	55622
16465	21493	0	applied	\N	\N	\N	\N	67733	67733	67734
16465	21494	1	applied	\N	\N	\N	\N	67735	67735	55649
16465	21495	2	applied	\N	\N	\N	\N	67736	67736	55651
16467	21496	0	applied	\N	\N	\N	\N	67739	67739	67740
16467	21497	1	applied	\N	\N	\N	\N	67741	67741	67742
16467	21498	2	applied	\N	\N	\N	\N	67743	67743	67744
16467	21499	3	applied	\N	\N	\N	\N	67745	67745	55663
16474	21503	0	applied	\N	\N	\N	\N	67762	67762	67763
16474	21504	1	applied	\N	\N	\N	\N	67764	67764	67765
16474	21505	2	applied	\N	\N	\N	\N	67766	67766	67767
16476	21506	0	applied	\N	\N	\N	\N	67772	67772	67773
16476	21507	1	applied	\N	\N	\N	\N	67774	67774	55687
16476	21508	2	applied	\N	\N	\N	\N	67775	67775	55689
16476	21509	3	applied	\N	\N	\N	\N	67776	67776	67777
16484	21534	0	applied	\N	\N	\N	\N	67828	67828	67829
16484	21535	1	applied	\N	\N	\N	\N	67830	67830	67831
16484	21536	2	applied	\N	\N	\N	\N	67832	67832	67833
16487	21534	0	applied	\N	\N	\N	\N	67828	67828	67829
16487	21535	1	applied	\N	\N	\N	\N	67830	67830	67831
16487	21536	2	applied	\N	\N	\N	\N	67832	67832	67833
16493	21548	0	applied	\N	\N	\N	\N	67865	67865	67866
16493	21549	1	applied	\N	\N	\N	\N	67867	67867	67868
16493	21550	2	applied	\N	\N	\N	\N	67869	67869	67870
16493	21551	3	applied	\N	\N	\N	\N	67871	67871	67872
16493	21552	4	applied	\N	\N	\N	\N	67873	67873	55987
16493	21553	5	applied	\N	\N	\N	\N	67874	67874	55991
16499	21578	0	applied	\N	\N	1000000000	\N	67916	67916	67917
16499	21579	1	applied	\N	\N	\N	\N	67918	67918	67919
16499	21580	2	applied	\N	\N	\N	\N	67920	67920	56059
16499	21581	3	applied	\N	\N	\N	\N	67921	67921	67922
16502	21585	0	applied	\N	\N	\N	\N	67933	67933	67934
16502	21586	1	applied	\N	\N	\N	\N	67935	67935	67936
16502	21587	2	applied	\N	\N	\N	\N	67937	67937	67938
16502	21588	3	applied	\N	\N	\N	\N	67939	67939	56076
16502	21589	4	applied	\N	\N	\N	\N	67940	67940	56080
16502	21590	5	applied	\N	\N	\N	\N	67941	67941	67942
16502	21591	6	applied	\N	\N	\N	\N	67943	67943	56084
16502	21592	7	applied	\N	\N	\N	\N	67944	67944	56089
16507	21596	0	applied	\N	\N	\N	\N	67954	67954	67955
16507	21597	1	applied	\N	\N	\N	\N	67956	67956	67957
16507	21598	2	applied	\N	\N	\N	\N	67958	67958	67959
16507	21599	3	applied	\N	\N	1000000000	\N	67960	67960	67961
16507	21600	4	applied	\N	\N	\N	\N	67962	67962	67963
16507	21601	5	applied	\N	\N	\N	\N	67964	67964	56103
16507	21602	6	applied	\N	\N	\N	\N	67965	67965	67966
16507	21603	7	applied	\N	\N	\N	\N	67967	67967	67968
16507	21604	8	applied	\N	\N	\N	\N	67969	67969	56118
16507	21605	9	applied	\N	\N	\N	\N	67970	67970	67971
16507	21606	10	applied	\N	\N	\N	\N	67972	67972	56120
16511	21630	0	applied	\N	\N	\N	\N	68018	68018	68019
16511	21631	1	applied	\N	\N	\N	\N	68020	68020	56182
16511	21632	2	applied	\N	\N	\N	\N	68021	68021	56192
16511	21633	3	applied	\N	\N	\N	\N	68022	68022	68023
16514	21630	0	applied	\N	\N	\N	\N	68018	68018	68019
16514	21631	1	applied	\N	\N	\N	\N	68020	68020	56182
16514	21632	2	applied	\N	\N	\N	\N	68021	68021	56192
16514	21633	3	applied	\N	\N	\N	\N	68022	68022	68023
16523	21521	0	applied	\N	\N	1000000000	\N	68064	68064	67804
16523	21409	1	applied	\N	\N	\N	\N	67512	67512	67803
16523	21314	2	applied	\N	\N	\N	\N	67294	67294	67294
16523	21322	3	applied	\N	\N	\N	\N	67308	67308	67308
16523	21393	4	applied	\N	\N	\N	\N	67477	67477	67477
16523	21403	5	applied	\N	\N	\N	\N	67498	67498	67498
16454	21407	27	applied	\N	\N	\N	\N	67508	67508	67509
16454	21408	28	applied	\N	\N	\N	\N	67510	67510	67511
16454	21410	29	applied	\N	\N	\N	\N	67514	67514	67515
16454	21419	30	applied	\N	\N	\N	\N	67530	67530	67531
16454	21423	32	applied	\N	\N	\N	\N	67539	67539	67540
16454	21428	33	applied	\N	\N	\N	\N	67552	67552	67553
16454	21431	34	applied	\N	\N	\N	\N	67557	67557	67558
16454	21435	35	applied	\N	\N	\N	\N	67566	67566	67567
16454	21438	36	applied	\N	\N	\N	\N	67575	67575	67576
16454	21439	37	applied	\N	\N	\N	\N	67577	67577	67578
16454	21440	38	applied	\N	\N	\N	\N	67579	67579	67580
16454	21448	39	applied	\N	\N	\N	\N	67593	67593	67594
16454	21450	40	applied	\N	\N	\N	\N	67598	67598	67638
16454	21451	41	applied	\N	\N	\N	\N	67600	67600	67639
16454	21457	42	applied	\N	\N	\N	\N	67614	67614	67640
16454	21460	43	applied	\N	\N	\N	\N	67619	67619	67641
16454	21461	44	applied	\N	\N	\N	\N	67621	67621	67642
16454	21328	45	applied	\N	\N	\N	\N	67325	67325	55114
16454	21393	46	applied	\N	\N	\N	\N	67477	67477	67477
16454	21403	47	applied	\N	\N	\N	\N	67498	67498	67498
16454	21331	48	applied	\N	\N	\N	\N	67328	67328	55116
16454	21329	49	applied	\N	\N	\N	\N	67326	67326	55123
16454	21342	50	applied	\N	\N	\N	\N	67351	67351	67643
16454	21332	51	applied	\N	\N	\N	\N	67329	67329	67644
16454	21334	52	applied	\N	\N	\N	\N	67334	67334	67645
16454	21340	53	applied	\N	\N	\N	\N	67348	67348	67336
16454	21341	54	applied	\N	\N	\N	\N	67350	67350	67646
16454	21345	55	applied	\N	\N	\N	\N	67358	67358	67647
16454	21349	56	applied	\N	\N	\N	\N	67369	67369	67352
16454	21350	57	applied	\N	\N	\N	\N	67370	67370	67648
16454	21330	58	applied	\N	\N	\N	\N	67327	67327	55168
16454	21335	59	applied	\N	\N	\N	\N	67335	67335	55170
16454	21339	60	applied	\N	\N	\N	\N	67347	67347	67649
16454	21405	61	applied	\N	\N	\N	\N	67501	67501	67501
16454	21413	62	applied	\N	\N	\N	\N	67518	67518	67518
16454	21421	63	applied	\N	\N	\N	\N	67533	67533	67533
16454	21356	64	applied	\N	\N	\N	\N	67382	67382	67650
16454	21359	65	applied	\N	\N	\N	\N	67388	67388	67372
16454	21352	66	applied	\N	\N	\N	\N	67373	67373	55178
16454	21364	67	applied	\N	\N	\N	\N	67399	67399	55183
16454	21373	68	applied	\N	\N	\N	\N	67422	67422	67375
16454	21384	69	applied	\N	\N	\N	\N	67454	67454	55185
16454	21397	70	applied	\N	\N	\N	\N	67483	67483	67381
16454	21417	71	applied	\N	\N	\N	\N	67524	67524	67651
16454	21420	72	applied	\N	\N	\N	\N	67532	67532	55187
16454	21433	73	applied	\N	\N	\N	\N	67561	67561	55195
16454	21443	74	applied	\N	\N	\N	\N	67583	67583	67652
16454	21456	75	applied	\N	\N	\N	\N	67608	67608	55197
16454	21466	76	applied	\N	\N	\N	\N	67629	67629	67653
16454	21362	77	applied	\N	\N	\N	\N	67393	67393	55205
16454	21365	78	applied	\N	\N	\N	\N	67401	67401	55217
16454	21369	79	applied	\N	\N	\N	\N	67412	67412	67654
16454	21370	80	applied	\N	\N	\N	\N	67414	67414	55223
16454	21375	81	applied	\N	\N	\N	\N	67425	67425	67655
16454	21377	82	applied	\N	\N	\N	\N	67437	67437	55233
16454	21380	83	applied	\N	\N	\N	\N	67446	67446	67417
16454	21383	84	applied	\N	\N	\N	\N	67452	67452	55241
16454	21390	85	applied	\N	\N	\N	\N	67467	67467	67426
16454	21391	86	applied	\N	\N	\N	\N	67468	67468	55251
16454	21395	87	applied	\N	\N	\N	\N	67480	67480	67656
16454	21398	88	applied	\N	\N	\N	\N	67484	67484	55262
16454	21402	89	applied	\N	\N	\N	\N	67496	67496	67657
16454	21411	90	applied	\N	\N	\N	\N	67516	67516	55268
16454	21414	91	applied	\N	\N	\N	\N	67519	67519	67465
16454	21418	92	applied	\N	\N	\N	\N	67526	67526	55284
16454	21422	93	applied	\N	\N	\N	\N	67534	67534	67658
16454	21425	94	applied	\N	\N	\N	\N	67543	67543	67659
16454	21426	95	applied	\N	\N	\N	\N	67546	67546	67660
16454	21429	96	applied	\N	\N	\N	\N	67554	67554	67661
16454	21434	97	applied	\N	\N	\N	\N	67563	67563	67662
16454	21436	98	applied	\N	\N	\N	\N	67569	67569	67663
16454	21442	99	applied	\N	\N	\N	\N	67582	67582	67500
16454	21446	100	applied	\N	\N	\N	\N	67588	67588	67664
16454	21447	101	applied	\N	\N	\N	\N	67589	67589	67665
16454	21449	102	applied	\N	\N	\N	\N	67595	67595	67666
16454	21452	103	applied	\N	\N	\N	\N	67602	67602	67522
16454	21453	104	applied	\N	\N	\N	\N	67604	67604	67525
16454	21459	105	applied	\N	\N	\N	\N	67617	67617	67527
16454	21464	106	applied	\N	\N	\N	\N	67626	67626	67667
16454	21465	107	applied	\N	\N	\N	\N	67628	67628	67542
16454	21343	108	applied	\N	\N	\N	\N	67353	67353	55436
16454	21346	109	applied	\N	\N	\N	\N	67359	67359	67668
16454	21351	110	applied	\N	\N	\N	\N	67371	67371	67547
16454	21353	111	applied	\N	\N	\N	\N	67374	67374	55448
16454	21355	112	applied	\N	\N	\N	\N	67380	67380	67669
16454	21358	113	applied	\N	\N	\N	\N	67387	67387	67670
16454	21361	114	applied	\N	\N	\N	\N	67391	67391	55460
16454	21368	115	applied	\N	\N	\N	\N	67410	67410	67562
16454	21371	116	applied	\N	\N	\N	\N	67416	67416	67671
16454	21374	117	applied	\N	\N	\N	\N	67424	67424	55466
16454	21378	118	applied	\N	\N	\N	\N	67438	67438	67570
16454	21381	119	applied	\N	\N	\N	\N	67447	67447	67572
16454	21385	120	applied	\N	\N	\N	\N	67455	67455	55478
16454	21388	121	applied	\N	\N	\N	\N	67464	67464	67672
16454	21389	122	applied	\N	\N	\N	\N	67466	67466	67584
16454	21394	123	applied	\N	\N	\N	\N	67478	67478	55499
16454	21399	124	applied	\N	\N	\N	\N	67485	67485	67587
16454	21404	125	applied	\N	\N	\N	\N	67499	67499	67673
16456	21471	0	applied	\N	\N	\N	\N	67684	67684	67685
16456	21472	1	applied	\N	\N	\N	\N	67686	67686	55584
16456	21473	2	applied	\N	\N	\N	\N	67687	67687	55593
16459	21484	0	applied	\N	\N	\N	\N	67710	67710	67711
16459	21485	1	applied	\N	\N	\N	\N	67712	67712	55629
16459	21486	2	applied	\N	\N	\N	\N	67713	67713	67714
16459	21487	3	applied	\N	\N	\N	\N	67715	67715	55633
16464	21491	0	applied	\N	\N	\N	\N	67726	67726	67727
16464	21492	1	applied	\N	\N	\N	\N	67728	67728	67729
16466	21496	0	applied	\N	\N	\N	\N	67739	67739	67740
16466	21497	1	applied	\N	\N	\N	\N	67741	67741	67742
16466	21498	2	applied	\N	\N	\N	\N	67743	67743	67744
16466	21499	3	applied	\N	\N	\N	\N	67745	67745	55663
16468	21496	0	applied	\N	\N	\N	\N	67739	67739	67740
16468	21497	1	applied	\N	\N	\N	\N	67741	67741	67742
16468	21498	2	applied	\N	\N	\N	\N	67743	67743	67744
16468	21499	3	applied	\N	\N	\N	\N	67745	67745	55663
16471	21500	0	applied	\N	\N	\N	\N	67751	67751	67752
16471	21501	1	applied	\N	\N	\N	\N	67753	67753	55667
16471	21502	2	applied	\N	\N	\N	\N	67754	67754	67755
16477	21510	0	applied	\N	\N	\N	\N	67779	67779	67780
16477	21511	1	applied	\N	\N	\N	\N	67781	67781	55695
16477	21512	2	applied	\N	\N	\N	\N	67782	67782	55697
16480	21513	0	applied	\N	\N	\N	\N	67785	67785	67786
16480	21514	1	applied	\N	\N	\N	\N	67787	67787	67788
16480	21515	2	applied	\N	\N	\N	\N	67789	67789	67790
16486	21534	0	applied	\N	\N	\N	\N	67828	67828	67829
16486	21535	1	applied	\N	\N	\N	\N	67830	67830	67831
16486	21536	2	applied	\N	\N	\N	\N	67832	67832	67833
16488	21534	0	applied	\N	\N	\N	\N	67828	67828	67829
16488	21535	1	applied	\N	\N	\N	\N	67830	67830	67831
16488	21536	2	applied	\N	\N	\N	\N	67832	67832	67833
16489	21537	0	applied	\N	\N	\N	\N	67842	67842	67843
16489	21538	1	applied	\N	\N	\N	\N	67844	67844	55941
16489	21539	2	applied	\N	\N	\N	\N	67845	67845	55952
16492	21544	0	applied	\N	\N	\N	\N	67854	67854	67855
16492	21545	1	applied	\N	\N	\N	\N	67856	67856	67857
16492	21546	2	applied	\N	\N	\N	\N	67858	67858	55976
16492	21547	3	applied	\N	\N	\N	\N	67859	67859	67860
16495	21554	0	applied	\N	\N	\N	\N	67876	67876	67877
16495	21555	1	applied	\N	\N	\N	\N	67878	67878	67879
16495	21556	2	applied	\N	\N	\N	\N	67880	67880	56000
16495	21557	3	applied	\N	\N	\N	\N	67881	67881	56002
16498	21574	0	applied	\N	\N	\N	\N	67909	67909	67910
16498	21575	1	applied	\N	\N	\N	\N	67911	67911	56055
16498	21576	2	applied	\N	\N	\N	\N	67912	67912	67913
16498	21577	3	applied	\N	\N	\N	\N	67914	67914	56057
16503	21585	0	applied	\N	\N	\N	\N	67933	67933	67934
16503	21586	1	applied	\N	\N	\N	\N	67935	67935	67936
16503	21587	2	applied	\N	\N	\N	\N	67937	67937	67938
16503	21588	3	applied	\N	\N	\N	\N	67939	67939	56076
16503	21589	4	applied	\N	\N	\N	\N	67940	67940	56080
16503	21590	5	applied	\N	\N	\N	\N	67941	67941	67942
16503	21591	6	applied	\N	\N	\N	\N	67943	67943	56084
16503	21592	7	applied	\N	\N	\N	\N	67944	67944	56089
16509	21607	0	applied	\N	\N	\N	\N	67975	67975	67976
16509	21608	1	applied	\N	\N	\N	\N	67977	67977	67978
16509	21609	2	applied	\N	\N	\N	\N	67979	67979	67980
16509	21610	3	applied	\N	\N	\N	\N	67981	67981	56128
16509	21611	4	applied	\N	\N	\N	\N	67982	67982	67983
16509	21612	5	applied	\N	\N	\N	\N	67984	67984	56132
16509	21613	6	applied	\N	\N	\N	\N	67985	67985	67986
16510	21614	0	applied	\N	\N	\N	\N	67990	67990	67991
16510	21615	1	applied	\N	\N	\N	\N	67992	67992	67993
16510	21616	2	applied	\N	\N	\N	\N	67994	67994	67995
16510	21617	3	applied	\N	\N	\N	\N	67996	67996	67997
16510	21618	5	applied	\N	\N	\N	\N	67999	67999	68000
16510	21619	6	applied	\N	\N	\N	\N	68001	68001	56142
16510	21620	7	applied	\N	\N	\N	\N	68002	68002	56144
16510	21621	8	applied	\N	\N	\N	\N	68003	68003	68004
16510	21622	9	applied	\N	\N	\N	\N	68005	68005	68006
16510	21623	10	applied	\N	\N	\N	\N	68007	68007	56161
16510	21624	11	applied	\N	\N	\N	\N	68008	68008	56163
16510	21625	12	applied	\N	\N	\N	\N	68009	68009	56167
16510	21626	13	applied	\N	\N	\N	\N	68010	68010	56169
16510	21627	14	applied	\N	\N	\N	\N	68011	68011	56178
16510	21628	15	applied	\N	\N	\N	\N	68012	68012	68013
16510	21629	16	applied	\N	\N	\N	\N	68014	68014	68015
16515	21630	0	applied	\N	\N	\N	\N	68018	68018	68019
16515	21631	1	applied	\N	\N	\N	\N	68020	68020	56182
16515	21632	2	applied	\N	\N	\N	\N	68021	68021	56192
16515	21633	3	applied	\N	\N	\N	\N	68022	68022	68023
16517	21634	0	applied	\N	\N	\N	\N	68036	68036	68037
16517	21635	1	applied	\N	\N	\N	\N	68038	68038	56202
16517	21636	2	applied	\N	\N	\N	\N	68039	68039	68040
16521	21640	0	applied	\N	\N	\N	\N	68055	68055	68056
16521	21641	1	applied	\N	\N	\N	\N	68057	68057	68058
16521	21642	2	applied	\N	\N	\N	\N	68059	68059	68060
16521	21643	3	applied	\N	\N	\N	\N	68061	68061	56225
16525	21644	0	applied	\N	\N	\N	\N	68068	68068	68069
16525	21645	1	applied	\N	\N	\N	\N	68070	68070	68071
16525	21646	2	applied	\N	\N	\N	\N	68072	68072	68073
16529	21659	0	applied	\N	\N	\N	\N	68099	68099	68100
16529	21660	1	applied	\N	\N	\N	\N	68101	68101	68102
16529	21661	2	applied	\N	\N	\N	\N	68103	68103	68104
16531	21662	0	applied	\N	\N	\N	\N	68107	68107	68108
16531	21663	1	applied	\N	\N	\N	\N	68109	68109	68110
16531	21664	2	applied	\N	\N	\N	\N	68111	68111	56334
16531	21665	3	applied	\N	\N	\N	\N	68112	68112	56336
16531	21666	4	applied	\N	\N	\N	\N	68113	68113	56345
16531	21667	5	applied	\N	\N	\N	\N	68114	68114	68115
16531	21668	6	applied	\N	\N	\N	\N	68116	68116	56347
16533	21669	0	applied	\N	\N	\N	\N	68120	68120	68121
16533	21670	1	applied	\N	\N	\N	\N	68122	68122	56356
16533	21671	2	applied	\N	\N	\N	\N	68123	68123	56358
16536	21669	0	applied	\N	\N	\N	\N	68120	68120	68121
16536	21670	1	applied	\N	\N	\N	\N	68122	68122	56356
16536	21671	2	applied	\N	\N	\N	\N	68123	68123	56358
16542	21672	0	applied	\N	\N	\N	\N	68131	68131	68132
16542	21673	1	applied	\N	\N	\N	\N	68133	68133	68134
16542	21674	2	applied	\N	\N	\N	\N	68135	68135	68136
16542	21675	3	applied	\N	\N	\N	\N	68137	68137	68138
16542	21676	4	applied	\N	\N	\N	\N	68139	68139	68140
16542	21677	5	applied	\N	\N	\N	\N	68141	68141	68142
16542	21678	6	applied	\N	\N	\N	\N	68143	68143	68144
16542	21679	7	applied	\N	\N	\N	\N	68145	68145	56381
16542	21680	8	applied	\N	\N	\N	\N	68146	68146	56383
16542	21681	9	applied	\N	\N	\N	\N	68147	68147	68148
16542	21682	10	applied	\N	\N	\N	\N	68149	68149	56387
16542	21683	11	applied	\N	\N	\N	\N	68150	68150	56389
16542	21684	12	applied	\N	\N	\N	\N	68151	68151	68152
16542	21685	13	applied	\N	\N	\N	\N	68153	68153	68154
16552	21686	0	applied	\N	\N	\N	\N	68164	68164	68165
16552	21687	1	applied	\N	\N	\N	\N	68166	68166	68167
16552	21688	2	applied	\N	\N	\N	\N	68168	68168	68169
16552	21689	3	applied	\N	\N	\N	\N	68170	68170	56407
16554	21691	0	applied	\N	\N	\N	\N	68177	68177	68178
16554	21692	1	applied	\N	\N	\N	\N	68179	68179	68180
16554	21693	2	applied	\N	\N	\N	\N	68181	68181	56415
16554	21694	3	applied	\N	\N	\N	\N	68182	68182	68183
16554	21695	4	applied	\N	\N	\N	\N	68184	68184	56425
16555	21696	0	applied	\N	\N	\N	\N	68186	68186	68187
16555	21697	1	applied	\N	\N	\N	\N	68188	68188	68189
16555	21698	2	applied	\N	\N	\N	\N	68190	68190	68191
16555	21699	3	applied	\N	\N	\N	\N	68192	68192	68193
16555	21700	4	applied	\N	\N	\N	\N	68194	68194	68195
16555	21701	5	applied	\N	\N	\N	\N	68196	68196	68197
16555	21702	6	applied	\N	\N	\N	\N	68198	68198	56429
16555	21703	7	applied	\N	\N	\N	\N	68199	68199	56431
16555	21704	8	applied	\N	\N	\N	\N	68200	68200	68201
16555	21705	9	applied	\N	\N	\N	\N	68202	68202	68203
16555	21706	10	applied	\N	\N	\N	\N	68204	68204	68205
16508	21611	4	applied	\N	\N	\N	\N	67982	67982	67983
16508	21612	5	applied	\N	\N	\N	\N	67984	67984	56132
16508	21613	6	applied	\N	\N	\N	\N	67985	67985	67986
16512	21630	0	applied	\N	\N	\N	\N	68018	68018	68019
16512	21631	1	applied	\N	\N	\N	\N	68020	68020	56182
16512	21632	2	applied	\N	\N	\N	\N	68021	68021	56192
16512	21633	3	applied	\N	\N	\N	\N	68022	68022	68023
16516	21634	0	applied	\N	\N	\N	\N	68036	68036	68037
16516	21635	1	applied	\N	\N	\N	\N	68038	68038	56202
16516	21636	2	applied	\N	\N	\N	\N	68039	68039	68040
16518	21634	0	applied	\N	\N	\N	\N	68036	68036	68037
16518	21636	1	applied	\N	\N	\N	\N	68039	68039	68045
16520	21637	0	applied	\N	\N	\N	\N	68047	68047	68048
16520	21638	1	applied	\N	\N	\N	\N	68049	68049	68050
16520	21635	2	applied	\N	\N	\N	\N	68038	68038	56208
16520	21639	3	applied	\N	\N	\N	\N	68051	68051	56215
16528	21659	0	applied	\N	\N	\N	\N	68099	68099	68100
16528	21660	1	applied	\N	\N	\N	\N	68101	68101	68102
16528	21661	2	applied	\N	\N	\N	\N	68103	68103	68104
16545	21672	0	applied	\N	\N	\N	\N	68131	68131	68132
16545	21673	1	applied	\N	\N	\N	\N	68133	68133	68134
16545	21674	2	applied	\N	\N	\N	\N	68135	68135	68136
16545	21675	3	applied	\N	\N	\N	\N	68137	68137	68138
16545	21676	4	applied	\N	\N	\N	\N	68139	68139	68140
16545	21677	5	applied	\N	\N	\N	\N	68141	68141	68142
16545	21678	6	applied	\N	\N	\N	\N	68143	68143	68144
16545	21679	7	applied	\N	\N	\N	\N	68145	68145	56381
16545	21680	8	applied	\N	\N	\N	\N	68146	68146	56383
16545	21681	9	applied	\N	\N	\N	\N	68147	68147	68148
16545	21682	10	applied	\N	\N	\N	\N	68149	68149	56387
16545	21683	11	applied	\N	\N	\N	\N	68150	68150	56389
16545	21684	12	applied	\N	\N	\N	\N	68151	68151	68152
16545	21685	13	applied	\N	\N	\N	\N	68153	68153	68154
16551	21686	0	applied	\N	\N	\N	\N	68164	68164	68165
16551	21687	1	applied	\N	\N	\N	\N	68166	68166	68167
16551	21688	2	applied	\N	\N	\N	\N	68168	68168	68169
16551	21689	3	applied	\N	\N	\N	\N	68170	68170	56407
16553	21690	0	applied	\N	\N	\N	\N	68174	68174	56409
16557	21709	0	applied	\N	\N	\N	\N	68211	68211	68212
16557	21710	1	applied	\N	\N	\N	\N	68213	68213	68214
16557	21711	2	applied	\N	\N	\N	\N	68215	68215	56467
16559	21712	0	applied	\N	\N	\N	\N	68219	68219	68220
16559	21713	1	applied	\N	\N	\N	\N	68221	68221	68222
16559	21714	2	applied	\N	\N	\N	\N	68223	68223	56471
16561	21715	0	applied	\N	\N	\N	\N	68228	68228	68229
16561	21716	1	applied	\N	\N	\N	\N	68230	68230	56473
16561	21717	2	applied	\N	\N	\N	\N	68231	68231	56475
16564	21673	0	applied	\N	\N	\N	\N	68133	68133	68134
16564	21662	1	applied	\N	\N	\N	\N	68107	68107	68108
16564	21719	2	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16564	21663	3	applied	\N	\N	\N	\N	68109	68109	68110
16564	21669	4	applied	\N	\N	\N	\N	68120	68120	68121
16564	21672	5	applied	\N	\N	\N	\N	68131	68131	68132
16564	21674	6	applied	\N	\N	\N	\N	68135	68135	68136
16564	21675	7	applied	\N	\N	\N	\N	68137	68137	68138
16564	21676	8	applied	\N	\N	\N	\N	68139	68139	68140
16564	21686	9	applied	\N	\N	\N	\N	68164	68164	68165
16564	21691	10	applied	\N	\N	\N	\N	68177	68177	68178
16564	21692	11	applied	\N	\N	\N	\N	68179	68179	68180
16564	21696	12	applied	\N	\N	\N	\N	68186	68186	68187
16564	21697	13	applied	\N	\N	\N	\N	68188	68188	68189
16564	21698	14	applied	\N	\N	\N	\N	68190	68190	68191
16564	21699	15	applied	\N	\N	\N	\N	68192	68192	68193
16564	21709	16	applied	\N	\N	\N	\N	68211	68211	68212
16564	21712	17	applied	\N	\N	\N	\N	68219	68219	68220
16564	21715	18	applied	\N	\N	\N	\N	68228	68228	68229
16564	21718	19	applied	\N	\N	\N	\N	68232	68232	68233
16564	21724	20	applied	\N	\N	\N	\N	68242	68242	68243
16564	21727	21	applied	\N	\N	\N	\N	68247	68247	68248
16564	21664	22	applied	\N	\N	\N	\N	68111	68111	56334
16564	21665	23	applied	\N	\N	\N	\N	68112	68112	56336
16564	21666	24	applied	\N	\N	\N	\N	68113	68113	56345
16564	21667	25	applied	\N	\N	\N	\N	68114	68114	68115
16564	21677	26	applied	\N	\N	\N	\N	68141	68141	68249
16564	21688	27	applied	\N	\N	\N	\N	68168	68168	56347
16564	21702	28	applied	\N	\N	\N	\N	68198	68198	68250
16564	21668	29	applied	\N	\N	\N	\N	68116	68116	68251
16564	21670	30	applied	\N	\N	\N	\N	68122	68122	56358
16564	21678	31	applied	\N	\N	\N	\N	68143	68143	56379
16564	21679	32	applied	\N	\N	\N	\N	68145	68145	68252
16564	21680	33	applied	\N	\N	\N	\N	68146	68146	68253
16564	21681	34	applied	\N	\N	\N	\N	68147	68147	68254
16564	21687	35	applied	\N	\N	\N	\N	68166	68166	56385
16564	21693	36	applied	\N	\N	\N	\N	68181	68181	56387
16564	21694	37	applied	\N	\N	\N	\N	68182	68182	68255
16564	21700	38	applied	\N	\N	\N	\N	68194	68194	68256
16564	21701	39	applied	\N	\N	\N	\N	68196	68196	68152
16564	21671	40	applied	\N	\N	\N	\N	68123	68123	68154
16564	21682	41	applied	\N	\N	\N	\N	68149	68149	68169
16564	21683	42	applied	\N	\N	\N	\N	68150	68150	56407
16564	21684	43	applied	\N	\N	\N	\N	68151	68151	56409
16564	21685	44	applied	\N	\N	\N	\N	68153	68153	68257
16564	21689	45	applied	\N	\N	\N	\N	68170	68170	68258
16564	21690	46	applied	\N	\N	\N	\N	68174	68174	68195
16564	21707	47	applied	\N	\N	\N	\N	68206	68206	68197
16564	21708	48	applied	\N	\N	\N	\N	68208	68208	68259
16564	21713	49	applied	\N	\N	\N	\N	68221	68221	56431
16564	21717	50	applied	\N	\N	\N	\N	68231	68231	56439
16564	21721	51	applied	\N	\N	\N	\N	68236	68236	68260
16564	21723	52	applied	\N	\N	\N	\N	68239	68239	68203
16564	21725	53	applied	\N	\N	\N	\N	68244	68244	68261
16564	21728	54	applied	\N	\N	\N	\N	68262	68262	56461
16564	21695	55	applied	\N	\N	\N	\N	68184	68184	68209
16564	21703	56	applied	\N	\N	\N	\N	68199	68199	68214
16564	21704	57	applied	\N	\N	\N	\N	68200	68200	68222
16564	21705	58	applied	\N	\N	\N	\N	68202	68202	56471
16564	21706	59	applied	\N	\N	\N	\N	68204	68204	56473
16564	21710	60	applied	\N	\N	\N	\N	68213	68213	68263
16564	21714	61	applied	\N	\N	\N	\N	68223	68223	68264
16564	21716	62	applied	\N	\N	\N	\N	68230	68230	68265
16564	21720	63	applied	\N	\N	\N	\N	68235	68235	56494
16564	21726	64	applied	\N	\N	\N	\N	68245	68245	56500
16564	21729	66	applied	\N	\N	\N	\N	68267	68267	68268
16564	21711	67	applied	\N	\N	\N	\N	68215	68215	68269
16564	21722	68	applied	\N	\N	\N	\N	68237	68237	56508
16564	21730	69	applied	\N	\N	\N	\N	68270	68270	68271
16567	21737	0	applied	\N	\N	\N	\N	68289	68289	68290
16567	21738	1	applied	\N	\N	1000000000	\N	68291	68291	68292
16567	21739	2	applied	\N	\N	\N	\N	68293	68293	68294
16522	21640	0	applied	\N	\N	\N	\N	68055	68055	68056
16522	21641	1	applied	\N	\N	\N	\N	68057	68057	68058
16522	21642	2	applied	\N	\N	\N	\N	68059	68059	68060
16522	21643	3	applied	\N	\N	\N	\N	68061	68061	56225
16526	21647	0	applied	\N	\N	\N	\N	68075	68075	68076
16526	21648	1	applied	\N	\N	\N	\N	68077	68077	68078
16526	21649	2	applied	\N	\N	\N	\N	68079	68079	68080
16526	21650	3	applied	\N	\N	\N	\N	68081	68081	56245
16526	21651	4	applied	\N	\N	\N	\N	68082	68082	68083
16530	21659	0	applied	\N	\N	\N	\N	68099	68099	68100
16530	21660	1	applied	\N	\N	\N	\N	68101	68101	68102
16530	21661	2	applied	\N	\N	\N	\N	68103	68103	68104
16534	21669	0	applied	\N	\N	\N	\N	68120	68120	68121
16534	21670	1	applied	\N	\N	\N	\N	68122	68122	56356
16534	21671	2	applied	\N	\N	\N	\N	68123	68123	56358
16537	21669	0	applied	\N	\N	\N	\N	68120	68120	68121
16537	21670	1	applied	\N	\N	\N	\N	68122	68122	56356
16537	21671	2	applied	\N	\N	\N	\N	68123	68123	56358
16546	21672	0	applied	\N	\N	\N	\N	68131	68131	68132
16546	21673	1	applied	\N	\N	\N	\N	68133	68133	68134
16546	21674	2	applied	\N	\N	\N	\N	68135	68135	68136
16546	21675	3	applied	\N	\N	\N	\N	68137	68137	68138
16546	21676	4	applied	\N	\N	\N	\N	68139	68139	68140
16546	21677	5	applied	\N	\N	\N	\N	68141	68141	68142
16546	21678	6	applied	\N	\N	\N	\N	68143	68143	68144
16546	21679	7	applied	\N	\N	\N	\N	68145	68145	56381
16546	21680	8	applied	\N	\N	\N	\N	68146	68146	56383
16546	21681	9	applied	\N	\N	\N	\N	68147	68147	68148
16546	21682	10	applied	\N	\N	\N	\N	68149	68149	56387
16546	21683	11	applied	\N	\N	\N	\N	68150	68150	56389
16546	21684	12	applied	\N	\N	\N	\N	68151	68151	68152
16546	21685	13	applied	\N	\N	\N	\N	68153	68153	68154
16550	21686	0	applied	\N	\N	\N	\N	68164	68164	68165
16550	21687	1	applied	\N	\N	\N	\N	68166	68166	68167
16550	21688	2	applied	\N	\N	\N	\N	68168	68168	68169
16550	21689	3	applied	\N	\N	\N	\N	68170	68170	56407
16558	21709	0	applied	\N	\N	\N	\N	68211	68211	68212
16558	21710	1	applied	\N	\N	\N	\N	68213	68213	68214
16558	21711	2	applied	\N	\N	\N	\N	68215	68215	56467
16563	21724	0	applied	\N	\N	\N	\N	68242	68242	68243
16563	21725	1	applied	\N	\N	\N	\N	68244	68244	56494
16563	21726	2	applied	\N	\N	\N	\N	68245	68245	56500
16565	21727	0	applied	\N	\N	\N	\N	68247	68247	68248
16565	21729	1	applied	\N	\N	\N	\N	68267	68267	68268
16565	21730	2	applied	\N	\N	\N	\N	68270	68270	68269
16565	21728	3	applied	\N	\N	\N	\N	68262	68262	68271
16566	21731	0	applied	\N	\N	\N	\N	68275	68275	68276
16566	21732	1	applied	\N	\N	\N	\N	68277	68277	68278
16566	21733	2	applied	\N	\N	\N	\N	68279	68279	68280
16566	21734	3	applied	\N	\N	\N	\N	68281	68281	68282
16566	21735	4	applied	\N	\N	\N	\N	68283	68283	68284
16566	21736	5	applied	\N	\N	\N	\N	68285	68285	68286
16570	21731	0	applied	\N	\N	\N	\N	68275	68275	68276
16570	21732	1	applied	\N	\N	\N	\N	68277	68277	68278
16570	21737	2	applied	\N	\N	\N	\N	68289	68289	68290
16570	21741	3	applied	\N	\N	\N	\N	68300	68300	68301
16570	21738	4	applied	\N	\N	1000000000	\N	68291	68291	68292
16570	21733	5	applied	\N	\N	\N	\N	68279	68279	68280
16570	21734	6	applied	\N	\N	\N	\N	68281	68281	68282
16570	21735	7	applied	\N	\N	\N	\N	68283	68283	68284
16570	21739	8	applied	\N	\N	\N	\N	68293	68293	56530
16570	21742	9	applied	\N	\N	\N	\N	68302	68302	56537
16570	21743	10	applied	\N	\N	\N	\N	68303	68303	68296
16570	21736	11	applied	\N	\N	\N	\N	68285	68285	68304
16570	21740	12	applied	\N	\N	\N	\N	68295	68295	56546
16570	21744	13	applied	\N	\N	\N	\N	68305	68305	56548
16573	21741	0	applied	\N	\N	\N	\N	68300	68300	68301
16573	21745	1	applied	\N	\N	\N	\N	68307	68307	68308
16573	21742	2	applied	\N	\N	\N	\N	68302	68302	68310
16573	21747	3	applied	\N	\N	\N	\N	68311	68311	56548
16573	21743	4	applied	\N	\N	\N	\N	68303	68303	56573
16573	21744	5	applied	\N	\N	\N	\N	68305	68305	56577
16575	21752	0	applied	\N	\N	\N	\N	68325	68325	68326
16575	21753	1	applied	\N	\N	\N	\N	68327	68327	68328
16575	21754	2	applied	\N	\N	\N	\N	68329	68329	56622
16575	21755	3	applied	\N	\N	\N	\N	68330	68330	68331
16578	21756	0	applied	\N	\N	\N	\N	68338	68338	68339
16578	21757	1	applied	\N	\N	\N	\N	68340	68340	68341
16578	21758	2	applied	\N	\N	\N	\N	68342	68342	68343
16578	21759	3	applied	\N	\N	\N	\N	68344	68344	56604
16578	21760	4	applied	\N	\N	\N	\N	68345	68345	56606
16578	21761	5	applied	\N	\N	\N	\N	68346	68346	56608
16578	21762	6	applied	\N	\N	\N	\N	68347	68347	56610
16578	21763	7	applied	\N	\N	\N	\N	68348	68348	68349
16578	21764	8	applied	\N	\N	\N	\N	68350	68350	56614
16578	21765	9	applied	\N	\N	\N	\N	68351	68351	56616
16580	21766	0	applied	\N	\N	\N	\N	68358	68358	68359
16580	21767	1	applied	\N	\N	\N	\N	68360	68360	68361
16580	21768	2	applied	\N	\N	\N	\N	68362	68362	68363
16580	21769	3	applied	\N	\N	\N	\N	68364	68364	68365
16583	21766	0	applied	\N	\N	\N	\N	68358	68358	68359
16583	21767	1	applied	\N	\N	\N	\N	68360	68360	68361
16583	21770	2	applied	\N	\N	\N	\N	68367	68367	56634
16583	21768	3	applied	\N	\N	\N	\N	68362	68362	56640
16583	21769	4	applied	\N	\N	\N	\N	68364	68364	68368
16583	21771	5	applied	\N	\N	\N	\N	68369	68369	56656
16587	21778	0	applied	\N	\N	\N	\N	68390	68390	68391
16587	21779	1	applied	\N	\N	\N	\N	68392	68392	68393
16587	21780	2	applied	\N	\N	\N	\N	68394	68394	68395
16587	21781	3	applied	\N	\N	\N	\N	68396	68396	68397
16587	21782	4	applied	\N	\N	\N	\N	68398	68398	68399
16587	21783	5	applied	\N	\N	\N	\N	68400	68400	68401
16592	21794	0	applied	\N	\N	\N	\N	68425	68425	68426
16592	21795	1	applied	\N	\N	\N	\N	68427	68427	56707
16592	21796	2	applied	\N	\N	\N	\N	68428	68428	68429
16596	21798	0	applied	\N	\N	\N	\N	68439	68439	68439
16596	21799	1	applied	\N	\N	\N	\N	68440	68440	68441
16596	21800	2	applied	\N	\N	\N	\N	68442	68442	56719
16596	21801	3	applied	\N	\N	\N	\N	68443	68443	56721
16596	21802	4	applied	\N	\N	\N	\N	68444	68444	68445
16599	21803	0	applied	\N	\N	\N	\N	68449	68449	68450
16599	21804	2	applied	\N	\N	\N	\N	68452	68452	68453
16599	21805	3	applied	\N	\N	\N	\N	68454	68454	68455
16604	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16604	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16604	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16607	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16607	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16607	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16611	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16523	21405	6	applied	\N	\N	\N	\N	67501	67501	67501
16523	21413	7	applied	\N	\N	\N	\N	67518	67518	67518
16523	21421	8	applied	\N	\N	\N	\N	67533	67533	67533
16524	21640	0	applied	\N	\N	\N	\N	68055	68055	68056
16524	21641	1	applied	\N	\N	\N	\N	68057	68057	68058
16524	21642	2	applied	\N	\N	\N	\N	68059	68059	68060
16524	21643	3	applied	\N	\N	\N	\N	68061	68061	56225
16527	21652	0	applied	\N	\N	\N	\N	68086	68086	68087
16527	21653	1	applied	\N	\N	\N	\N	68088	68088	68089
16527	21654	2	applied	\N	\N	\N	\N	68090	68090	68091
16527	21655	3	applied	\N	\N	\N	\N	68092	68092	56249
16527	21656	4	applied	\N	\N	\N	\N	68093	68093	68094
16527	21657	5	applied	\N	\N	\N	\N	68095	68095	56260
16527	21658	6	applied	\N	\N	\N	\N	68096	68096	56262
16532	21662	0	applied	\N	\N	\N	\N	68107	68107	68108
16532	21663	1	applied	\N	\N	\N	\N	68109	68109	68110
16532	21664	2	applied	\N	\N	\N	\N	68111	68111	56334
16532	21665	3	applied	\N	\N	\N	\N	68112	68112	56336
16532	21666	4	applied	\N	\N	\N	\N	68113	68113	56345
16532	21667	5	applied	\N	\N	\N	\N	68114	68114	68115
16532	21668	6	applied	\N	\N	\N	\N	68116	68116	56347
16535	21669	0	applied	\N	\N	\N	\N	68120	68120	68121
16535	21670	1	applied	\N	\N	\N	\N	68122	68122	56356
16535	21671	2	applied	\N	\N	\N	\N	68123	68123	56358
16538	21670	0	applied	\N	\N	\N	\N	68122	68122	56356
16538	21671	1	applied	\N	\N	\N	\N	68123	68123	56358
16544	21672	0	applied	\N	\N	\N	\N	68131	68131	68132
16544	21673	1	applied	\N	\N	\N	\N	68133	68133	68134
16544	21674	2	applied	\N	\N	\N	\N	68135	68135	68136
16544	21675	3	applied	\N	\N	\N	\N	68137	68137	68138
16544	21676	4	applied	\N	\N	\N	\N	68139	68139	68140
16544	21677	5	applied	\N	\N	\N	\N	68141	68141	68142
16544	21678	6	applied	\N	\N	\N	\N	68143	68143	68144
16544	21679	7	applied	\N	\N	\N	\N	68145	68145	56381
16544	21680	8	applied	\N	\N	\N	\N	68146	68146	56383
16544	21681	9	applied	\N	\N	\N	\N	68147	68147	68148
16544	21682	10	applied	\N	\N	\N	\N	68149	68149	56387
16544	21683	11	applied	\N	\N	\N	\N	68150	68150	56389
16544	21684	12	applied	\N	\N	\N	\N	68151	68151	68152
16544	21685	13	applied	\N	\N	\N	\N	68153	68153	68154
16547	21672	0	applied	\N	\N	\N	\N	68131	68131	68132
16547	21673	1	applied	\N	\N	\N	\N	68133	68133	68134
16547	21674	2	applied	\N	\N	\N	\N	68135	68135	68136
16547	21675	3	applied	\N	\N	\N	\N	68137	68137	68138
16547	21676	4	applied	\N	\N	\N	\N	68139	68139	68140
16547	21677	5	applied	\N	\N	\N	\N	68141	68141	68142
16556	21709	0	applied	\N	\N	\N	\N	68211	68211	68212
16556	21710	1	applied	\N	\N	\N	\N	68213	68213	68214
16556	21711	2	applied	\N	\N	\N	\N	68215	68215	56467
16569	21737	0	applied	\N	\N	\N	\N	68289	68289	68290
16569	21738	1	applied	\N	\N	1000000000	\N	68291	68291	68292
16569	21739	2	applied	\N	\N	\N	\N	68293	68293	68294
16569	21740	3	applied	\N	\N	\N	\N	68295	68295	68296
16571	21741	0	applied	\N	\N	\N	\N	68300	68300	68301
16571	21745	1	applied	\N	\N	\N	\N	68307	68307	68308
16571	21746	2	applied	\N	\N	\N	\N	68309	68309	68292
16571	21742	3	applied	\N	\N	\N	\N	68302	68302	68310
16571	21747	4	applied	\N	\N	\N	\N	68311	68311	56548
16571	21743	5	applied	\N	\N	\N	\N	68303	68303	56573
16571	21744	6	applied	\N	\N	\N	\N	68305	68305	56577
16571	21748	7	applied	\N	\N	\N	\N	68312	68312	68313
16574	21749	0	applied	\N	\N	\N	\N	68318	68318	68319
16574	21746	1	applied	\N	\N	\N	\N	68309	68309	68292
16574	21750	2	applied	\N	\N	\N	\N	68320	68320	56581
16574	21748	3	applied	\N	\N	\N	\N	68312	68312	56591
16574	21751	4	applied	\N	\N	\N	\N	68321	68321	68322
16579	21756	0	applied	\N	\N	\N	\N	68338	68338	68339
16579	21757	1	applied	\N	\N	\N	\N	68340	68340	68341
16579	21758	2	applied	\N	\N	\N	\N	68342	68342	68343
16579	21759	3	applied	\N	\N	\N	\N	68344	68344	56604
16579	21760	4	applied	\N	\N	\N	\N	68345	68345	56606
16579	21761	5	applied	\N	\N	\N	\N	68346	68346	56608
16579	21762	6	applied	\N	\N	\N	\N	68347	68347	56610
16579	21763	7	applied	\N	\N	\N	\N	68348	68348	68349
16579	21764	8	applied	\N	\N	\N	\N	68350	68350	56614
16579	21765	9	applied	\N	\N	\N	\N	68351	68351	56616
16581	21766	0	applied	\N	\N	\N	\N	68358	68358	68359
16581	21767	1	applied	\N	\N	\N	\N	68360	68360	68361
16581	21770	2	applied	\N	\N	\N	\N	68367	68367	56634
16581	21768	3	applied	\N	\N	\N	\N	68362	68362	56640
16581	21769	4	applied	\N	\N	\N	\N	68364	68364	68368
16581	21771	5	applied	\N	\N	\N	\N	68369	68369	56656
16584	21756	0	applied	\N	\N	\N	\N	68338	68338	68339
16584	21757	1	applied	\N	\N	\N	\N	68340	68340	68341
16584	21758	2	applied	\N	\N	\N	\N	68342	68342	68343
16584	21766	3	applied	\N	\N	\N	\N	68358	68358	68359
16584	21767	4	applied	\N	\N	\N	\N	68360	68360	68361
16584	21759	5	applied	\N	\N	\N	\N	68344	68344	56604
16584	21760	6	applied	\N	\N	\N	\N	68345	68345	56606
16584	21761	7	applied	\N	\N	\N	\N	68346	68346	56608
16584	21762	8	applied	\N	\N	\N	\N	68347	68347	56610
16584	21763	9	applied	\N	\N	\N	\N	68348	68348	68349
16584	21768	10	applied	\N	\N	\N	\N	68362	68362	68374
16584	21769	11	applied	\N	\N	\N	\N	68364	68364	56631
16585	21772	0	applied	\N	\N	\N	\N	68376	68376	68377
16585	21773	1	applied	\N	\N	\N	\N	68378	68378	68379
16585	21770	2	applied	\N	\N	\N	\N	68367	68367	68368
16585	21774	3	applied	\N	\N	\N	\N	68380	68380	56642
16585	21775	4	applied	\N	\N	\N	\N	68381	68381	56656
16585	21771	5	applied	\N	\N	\N	\N	68369	68369	56658
16585	21776	6	applied	\N	\N	\N	\N	68382	68382	68383
16585	21777	7	applied	\N	\N	\N	\N	68384	68384	68385
16590	21789	0	applied	\N	\N	\N	\N	68414	68414	68415
16590	21790	1	applied	\N	\N	\N	\N	68416	68416	68417
16590	21791	2	applied	\N	\N	\N	\N	68418	68418	68419
16590	21792	3	applied	\N	\N	\N	\N	68420	68420	56701
16590	21793	4	applied	\N	\N	\N	\N	68421	68421	56703
16593	21794	0	applied	\N	\N	\N	\N	68425	68425	68426
16593	21795	1	applied	\N	\N	\N	\N	68427	68427	56707
16593	21796	2	applied	\N	\N	\N	\N	68428	68428	68429
16597	21798	0	applied	\N	\N	\N	\N	68439	68439	68439
16597	21799	1	applied	\N	\N	\N	\N	68440	68440	68441
16597	21800	2	applied	\N	\N	\N	\N	68442	68442	56719
16597	21801	3	applied	\N	\N	\N	\N	68443	68443	56721
16597	21802	4	applied	\N	\N	\N	\N	68444	68444	68445
16601	21806	0	applied	\N	\N	\N	\N	68460	68460	68461
16601	21807	1	applied	\N	\N	\N	\N	68462	68462	68463
16601	21808	2	applied	\N	\N	\N	\N	68464	68464	56735
16605	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16605	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16555	21707	11	applied	\N	\N	\N	\N	68206	68206	68207
16555	21708	12	applied	\N	\N	\N	\N	68208	68208	68209
16560	21712	0	applied	\N	\N	\N	\N	68219	68219	68220
16560	21713	1	applied	\N	\N	\N	\N	68221	68221	68222
16560	21714	2	applied	\N	\N	\N	\N	68223	68223	56471
16562	21718	0	applied	\N	\N	\N	\N	68232	68232	68233
16562	21719	1	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16562	21720	2	applied	\N	\N	\N	\N	68235	68235	56481
16562	21721	3	applied	\N	\N	\N	\N	68236	68236	56483
16562	21722	4	applied	\N	\N	\N	\N	68237	68237	68238
16562	21723	5	applied	\N	\N	\N	\N	68239	68239	56492
16568	21737	0	applied	\N	\N	\N	\N	68289	68289	68290
16568	21738	1	applied	\N	\N	1000000000	\N	68291	68291	68292
16568	21739	2	applied	\N	\N	\N	\N	68293	68293	68294
16568	21740	3	applied	\N	\N	\N	\N	68295	68295	68296
16572	21741	0	applied	\N	\N	\N	\N	68300	68300	68301
16572	21745	1	applied	\N	\N	\N	\N	68307	68307	68308
16572	21746	2	applied	\N	\N	\N	\N	68309	68309	68292
16572	21742	3	applied	\N	\N	\N	\N	68302	68302	68310
16572	21747	4	applied	\N	\N	\N	\N	68311	68311	56548
16572	21743	5	applied	\N	\N	\N	\N	68303	68303	56573
16572	21744	6	applied	\N	\N	\N	\N	68305	68305	56577
16572	21748	7	applied	\N	\N	\N	\N	68312	68312	68313
16577	21756	0	applied	\N	\N	\N	\N	68338	68338	68339
16577	21757	1	applied	\N	\N	\N	\N	68340	68340	68341
16577	21758	2	applied	\N	\N	\N	\N	68342	68342	68343
16577	21759	3	applied	\N	\N	\N	\N	68344	68344	56604
16577	21760	4	applied	\N	\N	\N	\N	68345	68345	56606
16577	21761	5	applied	\N	\N	\N	\N	68346	68346	56608
16577	21762	6	applied	\N	\N	\N	\N	68347	68347	56610
16577	21763	7	applied	\N	\N	\N	\N	68348	68348	68349
16577	21764	8	applied	\N	\N	\N	\N	68350	68350	56614
16577	21765	9	applied	\N	\N	\N	\N	68351	68351	56616
16589	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16589	21785	1	applied	\N	\N	\N	\N	68406	68406	68407
16589	21786	2	applied	\N	\N	\N	\N	68408	68408	56686
16589	21787	3	applied	\N	\N	\N	\N	68409	68409	68410
16589	21788	4	applied	\N	\N	\N	\N	68411	68411	68412
16598	21803	0	applied	\N	\N	\N	\N	68449	68449	68450
16598	21804	2	applied	\N	\N	\N	\N	68452	68452	68453
16598	21805	3	applied	\N	\N	\N	\N	68454	68454	68455
16600	21803	0	applied	\N	\N	\N	\N	68449	68449	68450
16600	21804	2	applied	\N	\N	\N	\N	68452	68452	68453
16600	21805	3	applied	\N	\N	\N	\N	68454	68454	68455
16603	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16603	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16603	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16606	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16606	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16606	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16609	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16609	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16609	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16613	21819	0	applied	\N	\N	\N	\N	68506	68506	68507
16613	21820	1	applied	\N	\N	\N	\N	68508	68508	56768
16613	21821	2	applied	\N	\N	\N	\N	68509	68509	56770
16616	21826	0	applied	\N	\N	\N	\N	68521	68521	68522
16616	21827	1	applied	\N	\N	\N	\N	68523	68523	56789
16616	21828	2	applied	\N	\N	\N	\N	68524	68524	56791
16620	21833	0	applied	\N	\N	\N	\N	68531	68531	68532
16620	21834	1	applied	\N	\N	\N	\N	68533	68533	56803
16620	21835	2	applied	\N	\N	\N	\N	68534	68534	68535
16623	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16623	21789	1	applied	\N	\N	\N	\N	68414	68414	68415
16623	21790	2	applied	\N	\N	\N	\N	68416	68416	68417
16623	21797	3	applied	\N	\N	\N	\N	68435	68435	68436
16623	21558	4	applied	\N	\N	\N	\N	67883	67883	67884
16623	21578	5	applied	\N	\N	1000000000	\N	67916	67916	67917
16623	21599	6	applied	\N	\N	1000000000	\N	67960	67960	67961
16623	21554	7	applied	\N	\N	\N	\N	67876	67876	67877
16623	21559	8	applied	\N	\N	\N	\N	67885	67885	67886
16623	21560	9	applied	\N	\N	\N	\N	67887	67887	67888
16623	21561	10	applied	\N	\N	\N	\N	67889	67889	67890
16623	21571	11	applied	\N	\N	\N	\N	67903	67903	67904
16623	21574	12	applied	\N	\N	\N	\N	67909	67909	67910
16623	21579	13	applied	\N	\N	\N	\N	67918	67918	67919
16623	21582	14	applied	\N	\N	\N	\N	67924	67924	67925
16623	21585	15	applied	\N	\N	\N	\N	67933	67933	67934
16623	21586	16	applied	\N	\N	\N	\N	67935	67935	67936
16623	21587	17	applied	\N	\N	\N	\N	67937	67937	67938
16623	21593	18	applied	\N	\N	\N	\N	67948	67948	67949
16623	21596	19	applied	\N	\N	\N	\N	67954	67954	67955
16623	21597	20	applied	\N	\N	\N	\N	67956	67956	67957
16623	21598	21	applied	\N	\N	\N	\N	67958	67958	67959
16623	21607	22	applied	\N	\N	\N	\N	67975	67975	67976
16623	21608	23	applied	\N	\N	\N	\N	67977	67977	67978
16623	21719	24	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16623	21614	25	applied	\N	\N	\N	\N	67990	67990	67991
16623	21615	26	applied	\N	\N	\N	\N	67992	67992	67993
16623	21616	27	applied	\N	\N	\N	\N	67994	67994	67995
16623	21617	28	applied	\N	\N	\N	\N	67996	67996	67997
16623	21618	29	applied	\N	\N	\N	\N	67999	67999	68000
16623	21630	30	applied	\N	\N	\N	\N	68018	68018	68019
16623	21634	31	applied	\N	\N	\N	\N	68036	68036	68037
16623	21637	32	applied	\N	\N	\N	\N	68047	68047	68048
16623	21640	33	applied	\N	\N	\N	\N	68055	68055	68056
16623	21644	34	applied	\N	\N	\N	\N	68068	68068	68069
16623	21647	35	applied	\N	\N	\N	\N	68075	68075	68076
16623	21648	36	applied	\N	\N	\N	\N	68077	68077	68078
16623	21652	37	applied	\N	\N	\N	\N	68086	68086	68087
16623	21653	38	applied	\N	\N	\N	\N	68088	68088	68089
16623	21659	39	applied	\N	\N	\N	\N	68099	68099	68100
16623	21662	40	applied	\N	\N	\N	\N	68107	68107	68108
16623	21663	41	applied	\N	\N	\N	\N	68109	68109	68110
16623	21738	42	applied	\N	\N	1000000000	\N	68291	68291	68292
16623	21746	43	applied	\N	\N	\N	\N	68309	68309	68292
16623	21669	44	applied	\N	\N	\N	\N	68120	68120	68121
16623	21672	45	applied	\N	\N	\N	\N	68131	68131	68132
16623	21674	46	applied	\N	\N	\N	\N	68135	68135	68136
16623	21675	47	applied	\N	\N	\N	\N	68137	68137	68138
16623	21676	48	applied	\N	\N	\N	\N	68139	68139	68140
16623	21686	49	applied	\N	\N	\N	\N	68164	68164	68165
16623	21691	50	applied	\N	\N	\N	\N	68177	68177	68178
16623	21692	51	applied	\N	\N	\N	\N	68179	68179	68180
16623	21696	52	applied	\N	\N	\N	\N	68186	68186	68187
16623	21697	53	applied	\N	\N	\N	\N	68188	68188	68189
16623	21698	54	applied	\N	\N	\N	\N	68190	68190	68191
16623	21699	55	applied	\N	\N	\N	\N	68192	68192	68193
16623	21709	56	applied	\N	\N	\N	\N	68211	68211	68212
16567	21740	3	applied	\N	\N	\N	\N	68295	68295	68296
16576	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16576	21122	1	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16576	21243	2	applied	\N	\N	\N	\N	67139	67139	67140
16576	21247	3	applied	\N	\N	\N	\N	67148	67148	67149
16576	21248	4	applied	\N	\N	\N	\N	67150	67150	67151
16576	21254	5	applied	\N	\N	\N	\N	67162	67162	67163
16576	21150	6	applied	\N	\N	1000000000	\N	66960	66960	66961
16576	21166	7	applied	\N	\N	\N	\N	66987	66987	66961
16576	21337	8	applied	\N	\N	1000000000	\N	67343	67343	67344
16576	21521	9	applied	\N	\N	1000000000	\N	68064	68064	67804
16576	21462	10	applied	\N	\N	1000000000	\N	67623	67623	67624
16576	21578	11	applied	\N	\N	1000000000	\N	67916	67916	67917
16576	21599	12	applied	\N	\N	1000000000	\N	67960	67960	67961
16576	21409	13	applied	\N	\N	\N	\N	67512	67512	67803
16576	21719	14	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16576	21738	15	applied	\N	\N	1000000000	\N	68334	68334	68292
16576	21746	16	applied	\N	\N	\N	\N	68335	68335	68292
16576	20939	17	applied	\N	\N	\N	\N	66383	66383	66384
16576	21250	18	applied	\N	\N	\N	\N	67154	67154	67155
16576	21006	19	applied	\N	\N	\N	\N	66583	66583	66583
16576	21014	20	applied	\N	\N	\N	\N	66594	66594	66594
16576	21314	21	applied	\N	\N	\N	\N	67294	67294	67294
16576	21322	22	applied	\N	\N	\N	\N	67308	67308	67308
16576	21393	23	applied	\N	\N	\N	\N	67477	67477	67477
16576	21403	24	applied	\N	\N	\N	\N	67498	67498	67498
16576	21405	25	applied	\N	\N	\N	\N	67501	67501	67501
16576	21413	26	applied	\N	\N	\N	\N	67518	67518	67518
16576	21421	27	applied	\N	\N	\N	\N	67533	67533	67533
16582	21766	0	applied	\N	\N	\N	\N	68358	68358	68359
16582	21767	1	applied	\N	\N	\N	\N	68360	68360	68361
16582	21770	2	applied	\N	\N	\N	\N	68367	68367	56634
16582	21768	3	applied	\N	\N	\N	\N	68362	68362	56640
16582	21769	4	applied	\N	\N	\N	\N	68364	68364	68368
16582	21771	5	applied	\N	\N	\N	\N	68369	68369	56656
16586	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16586	21122	1	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16586	21243	2	applied	\N	\N	\N	\N	67139	67139	67140
16586	21247	3	applied	\N	\N	\N	\N	67148	67148	67149
16586	21248	4	applied	\N	\N	\N	\N	67150	67150	67151
16586	21254	5	applied	\N	\N	\N	\N	67162	67162	67163
16586	21150	6	applied	\N	\N	1000000000	\N	66960	66960	66961
16586	21166	7	applied	\N	\N	\N	\N	66987	66987	66961
16586	21337	8	applied	\N	\N	1000000000	\N	67343	67343	67344
16586	21521	9	applied	\N	\N	1000000000	\N	68064	68064	67804
16586	21035	10	applied	\N	\N	\N	\N	66652	66652	66653
16586	21037	11	applied	\N	\N	\N	\N	66656	66656	66657
16586	21041	12	applied	\N	\N	\N	\N	66720	66720	66721
16586	21042	13	applied	\N	\N	\N	\N	66722	66722	66723
16586	21047	14	applied	\N	\N	\N	\N	66730	66730	66731
16586	21051	15	applied	\N	\N	\N	\N	66740	66740	66741
16586	21054	16	applied	\N	\N	\N	\N	66746	66746	66747
16586	21057	17	applied	\N	\N	\N	\N	66756	66756	66757
16586	21060	18	applied	\N	\N	\N	\N	66763	66763	66764
16586	21063	19	applied	\N	\N	\N	\N	66772	66772	66773
16586	21066	20	applied	\N	\N	\N	\N	66793	66793	66794
16586	21069	21	applied	\N	\N	\N	\N	66800	66800	66801
16586	21070	22	applied	\N	\N	\N	\N	66802	66802	66803
16586	21462	23	applied	\N	\N	1000000000	\N	67623	67623	67624
16586	21578	24	applied	\N	\N	1000000000	\N	67916	67916	67917
16586	21599	25	applied	\N	\N	1000000000	\N	67960	67960	67961
16586	21409	26	applied	\N	\N	\N	\N	67512	67512	67803
16586	21719	27	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16586	21076	28	applied	\N	\N	\N	\N	66819	66819	66820
16586	21079	29	applied	\N	\N	\N	\N	66825	66825	66826
16586	21083	30	applied	\N	\N	\N	\N	66831	66831	66832
16586	21738	31	applied	\N	\N	1000000000	\N	68334	68334	68292
16586	21746	32	applied	\N	\N	\N	\N	68335	68335	68292
16586	21084	33	applied	\N	\N	\N	\N	66833	66833	66834
16586	21090	34	applied	\N	\N	\N	\N	66842	66842	66843
16586	21094	35	applied	\N	\N	\N	\N	66853	66853	66854
16586	21097	36	applied	\N	\N	\N	\N	66859	66859	66860
16586	21099	37	applied	\N	\N	\N	\N	66863	66863	66864
16586	21102	38	applied	\N	\N	\N	\N	66870	66870	66871
16586	21106	39	applied	\N	\N	\N	\N	66876	66876	66877
16586	21109	40	applied	\N	\N	\N	\N	66882	66882	66883
16586	21112	41	applied	\N	\N	\N	\N	66888	66888	66889
16586	21116	42	applied	\N	\N	\N	\N	66896	66896	66897
16586	21117	43	applied	\N	\N	\N	\N	66898	66898	66899
16586	21123	44	applied	\N	\N	\N	\N	66909	66909	66910
16586	21124	45	applied	\N	\N	\N	\N	66911	66911	66912
16586	21125	46	applied	\N	\N	\N	\N	66913	66913	66914
16586	21126	47	applied	\N	\N	\N	\N	66915	66915	66916
16586	21127	48	applied	\N	\N	\N	\N	66917	66917	66918
16586	21128	49	applied	\N	\N	\N	\N	66919	66919	66920
16586	21143	50	applied	\N	\N	\N	\N	66942	66942	66943
16586	21146	51	applied	\N	\N	\N	\N	66949	66949	66950
16586	21151	52	applied	\N	\N	\N	\N	66962	66962	66963
16586	21152	53	applied	\N	\N	\N	\N	66964	66964	66965
16586	21156	54	applied	\N	\N	\N	\N	66970	66970	66971
16586	21160	55	applied	\N	\N	\N	\N	66976	66976	66977
16586	21163	56	applied	\N	\N	\N	\N	66983	66983	66984
16586	21167	57	applied	\N	\N	\N	\N	66988	66988	66989
16586	21170	58	applied	\N	\N	\N	\N	66995	66995	66996
16586	21174	59	applied	\N	\N	\N	\N	67003	67003	67004
16586	21177	60	applied	\N	\N	\N	\N	67008	67008	67009
16586	21180	61	applied	\N	\N	\N	\N	67017	67017	67018
16586	21184	62	applied	\N	\N	\N	\N	67024	67024	67025
16586	21187	64	applied	\N	\N	\N	\N	67032	67032	67033
16586	21190	65	applied	\N	\N	\N	\N	67042	67042	67043
16586	21193	66	applied	\N	\N	\N	\N	67049	67049	67050
16586	21194	67	applied	\N	\N	\N	\N	67051	67051	67052
16586	21195	68	applied	\N	\N	\N	\N	67053	67053	67054
16586	21196	69	applied	\N	\N	\N	\N	67055	67055	67056
16586	21207	70	applied	\N	\N	\N	\N	67068	67068	67069
16586	21208	71	applied	\N	\N	\N	\N	67070	67070	67071
16586	21209	72	applied	\N	\N	\N	\N	67072	67072	67073
16586	21217	73	applied	\N	\N	\N	\N	67083	67083	67084
16586	21218	74	applied	\N	\N	\N	\N	67085	67085	67086
16586	21223	75	applied	\N	\N	\N	\N	67094	67094	67095
16586	21226	76	applied	\N	\N	\N	\N	67100	67100	67101
16586	21230	77	applied	\N	\N	\N	\N	67112	67112	67113
16586	21231	78	applied	\N	\N	\N	\N	67114	67114	67115
16586	21236	79	applied	\N	\N	\N	\N	67121	67121	67122
16586	21240	80	applied	\N	\N	\N	\N	67130	67130	67131
16586	21244	81	applied	\N	\N	\N	\N	67141	67141	67142
16586	21249	82	applied	\N	\N	\N	\N	67152	67152	67153
16586	21255	83	applied	\N	\N	\N	\N	67164	67164	67165
16586	21260	84	applied	\N	\N	\N	\N	67176	67176	67177
16586	21263	85	applied	\N	\N	\N	\N	67185	67185	67186
16586	21267	86	applied	\N	\N	\N	\N	67193	67193	67194
16586	21268	87	applied	\N	\N	\N	\N	67195	67195	67196
16586	21272	88	applied	\N	\N	\N	\N	67204	67204	67205
16586	21273	89	applied	\N	\N	\N	\N	67206	67206	67207
16586	21279	90	applied	\N	\N	\N	\N	67219	67219	67220
16586	21282	91	applied	\N	\N	\N	\N	67229	67229	67230
16586	21283	92	applied	\N	\N	\N	\N	67231	67231	67232
16586	21288	93	applied	\N	\N	\N	\N	67240	67240	67241
16586	21291	94	applied	\N	\N	\N	\N	67247	67247	67248
16586	21294	95	applied	\N	\N	\N	\N	67257	67257	67258
16586	21298	96	applied	\N	\N	\N	\N	67265	67265	67266
16586	21301	97	applied	\N	\N	\N	\N	67271	67271	67272
16586	21302	98	applied	\N	\N	\N	\N	67273	67273	67274
16586	21308	99	applied	\N	\N	\N	\N	67284	67284	67285
16586	21309	100	applied	\N	\N	\N	\N	67286	67286	67287
16586	21310	101	applied	\N	\N	\N	\N	67288	67288	67289
16586	21319	102	applied	\N	\N	\N	\N	67302	67302	67303
16586	21323	103	applied	\N	\N	\N	\N	67313	67313	67314
16586	21326	104	applied	\N	\N	\N	\N	67321	67321	67322
16586	21327	105	applied	\N	\N	\N	\N	67323	67323	67324
16586	21333	106	applied	\N	\N	\N	\N	67332	67332	67333
16586	21336	107	applied	\N	\N	\N	\N	67341	67341	67342
16586	21338	108	applied	\N	\N	\N	\N	67345	67345	67346
16586	21344	109	applied	\N	\N	\N	\N	67356	67356	67357
16586	21347	110	applied	\N	\N	\N	\N	67364	67364	67365
16586	21348	111	applied	\N	\N	\N	\N	67366	67366	67367
16586	21354	112	applied	\N	\N	\N	\N	67378	67378	67379
16586	21357	113	applied	\N	\N	\N	\N	67385	67385	67386
16586	21360	114	applied	\N	\N	\N	\N	67389	67389	67390
16586	21363	115	applied	\N	\N	\N	\N	67397	67397	67398
16586	21366	116	applied	\N	\N	\N	\N	67406	67406	67407
16586	21367	117	applied	\N	\N	\N	\N	67408	67408	67409
16586	21372	118	applied	\N	\N	\N	\N	67420	67420	67421
16586	21376	119	applied	\N	\N	\N	\N	67435	67435	67436
16586	21379	120	applied	\N	\N	\N	\N	67444	67444	67445
16586	21382	121	applied	\N	\N	\N	\N	67450	67450	67451
16586	21386	122	applied	\N	\N	\N	\N	67460	67460	67461
16586	21387	123	applied	\N	\N	\N	\N	67462	67462	67463
16586	21392	124	applied	\N	\N	\N	\N	67475	67475	67476
16586	21396	125	applied	\N	\N	\N	\N	67481	67481	67482
16588	21778	0	applied	\N	\N	\N	\N	68390	68390	68391
16588	21779	1	applied	\N	\N	\N	\N	68392	68392	68393
16588	21780	2	applied	\N	\N	\N	\N	68394	68394	68395
16588	21781	3	applied	\N	\N	\N	\N	68396	68396	68397
16588	21782	4	applied	\N	\N	\N	\N	68398	68398	68399
16588	21783	5	applied	\N	\N	\N	\N	68400	68400	68401
16591	21789	0	applied	\N	\N	\N	\N	68414	68414	68415
16591	21790	1	applied	\N	\N	\N	\N	68416	68416	68417
16594	21794	0	applied	\N	\N	\N	\N	68425	68425	68426
16594	21795	1	applied	\N	\N	\N	\N	68427	68427	56707
16594	21796	2	applied	\N	\N	\N	\N	68428	68428	68429
16595	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16595	21789	1	applied	\N	\N	\N	\N	68414	68414	68415
16595	21790	2	applied	\N	\N	\N	\N	68416	68416	68417
16595	21797	3	applied	\N	\N	\N	\N	68435	68435	68436
16602	21809	0	applied	\N	\N	\N	\N	68467	68467	56741
16610	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16610	21789	1	applied	\N	\N	\N	\N	68414	68414	68415
16610	21790	2	applied	\N	\N	\N	\N	68416	68416	68417
16610	21797	3	applied	\N	\N	\N	\N	68435	68435	68436
16610	21772	4	applied	\N	\N	\N	\N	68376	68376	68377
16610	21773	5	applied	\N	\N	\N	\N	68378	68378	68379
16610	21778	6	applied	\N	\N	\N	\N	68390	68390	68391
16610	21779	7	applied	\N	\N	\N	\N	68392	68392	68393
16610	21785	8	applied	\N	\N	\N	\N	68406	68406	68407
16610	21791	9	applied	\N	\N	\N	\N	68418	68418	68419
16610	21794	10	applied	\N	\N	\N	\N	68425	68425	68426
16610	21799	11	applied	\N	\N	\N	\N	68440	68440	68441
16610	21803	12	applied	\N	\N	\N	\N	68449	68449	68450
16610	21806	13	applied	\N	\N	\N	\N	68460	68460	68461
16610	21810	14	applied	\N	\N	\N	\N	68470	68470	68471
16610	21774	15	applied	\N	\N	\N	\N	68380	68380	68484
16610	21786	16	applied	\N	\N	\N	\N	68408	68408	56616
16610	21800	17	applied	\N	\N	\N	\N	68442	68442	68485
16610	21775	18	applied	\N	\N	\N	\N	68381	68381	56634
16610	21780	19	applied	\N	\N	\N	\N	68394	68394	56640
16610	21783	20	applied	\N	\N	\N	\N	68400	68400	68368
16610	21787	21	applied	\N	\N	\N	\N	68409	68409	68486
16610	21792	22	applied	\N	\N	\N	\N	68420	68420	68487
16610	21796	23	applied	\N	\N	\N	\N	68428	68428	56658
16610	21801	24	applied	\N	\N	\N	\N	68443	68443	56660
16610	21804	25	applied	\N	\N	\N	\N	68452	68452	68488
16610	21808	26	applied	\N	\N	\N	\N	68464	68464	68385
16610	21811	27	applied	\N	\N	\N	\N	68472	68472	68395
16622	21833	0	applied	\N	\N	\N	\N	68531	68531	68532
16622	21834	1	applied	\N	\N	\N	\N	68533	68533	56803
16622	21835	2	applied	\N	\N	\N	\N	68534	68534	68535
16624	21836	0	applied	\N	\N	\N	\N	68544	68544	68545
16624	21837	1	applied	\N	\N	\N	\N	68546	68546	56811
16626	21838	0	applied	\N	\N	\N	\N	68549	68549	68550
16626	21839	1	applied	\N	\N	\N	\N	68551	68551	56813
16626	21840	2	applied	\N	\N	\N	\N	68552	68552	68553
16629	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16629	21789	1	applied	\N	\N	\N	\N	68414	68414	68415
16629	21790	2	applied	\N	\N	\N	\N	68416	68416	68417
16629	21797	3	applied	\N	\N	\N	\N	68435	68435	68436
16629	21731	4	applied	\N	\N	\N	\N	68275	68275	68276
16629	21732	5	applied	\N	\N	\N	\N	68277	68277	68278
16629	21737	6	applied	\N	\N	\N	\N	68289	68289	68290
16629	21741	7	applied	\N	\N	\N	\N	68300	68300	68301
16629	21745	8	applied	\N	\N	\N	\N	68307	68307	68308
16629	21749	9	applied	\N	\N	\N	\N	68318	68318	68319
16629	21752	10	applied	\N	\N	\N	\N	68325	68325	68326
16629	21756	11	applied	\N	\N	\N	\N	68338	68338	68339
16629	21738	12	applied	\N	\N	1000000000	\N	68291	68291	68292
16629	21746	13	applied	\N	\N	\N	\N	68309	68309	68292
16629	21757	14	applied	\N	\N	\N	\N	68340	68340	68341
16629	21758	15	applied	\N	\N	\N	\N	68342	68342	68343
16629	21766	16	applied	\N	\N	\N	\N	68358	68358	68359
16629	21767	17	applied	\N	\N	\N	\N	68360	68360	68361
16629	21772	18	applied	\N	\N	\N	\N	68376	68376	68377
16629	21773	19	applied	\N	\N	\N	\N	68378	68378	68379
16629	21778	20	applied	\N	\N	\N	\N	68390	68390	68391
16629	21779	21	applied	\N	\N	\N	\N	68392	68392	68393
16629	21785	22	applied	\N	\N	\N	\N	68406	68406	68407
16629	21791	23	applied	\N	\N	\N	\N	68418	68418	68419
16629	21794	24	applied	\N	\N	\N	\N	68425	68425	68426
16605	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16608	21810	0	applied	\N	\N	\N	\N	68470	68470	68471
16608	21811	1	applied	\N	\N	\N	\N	68472	68472	68473
16608	21809	2	applied	\N	\N	\N	\N	68467	68467	56743
16612	21816	0	applied	\N	\N	\N	\N	68500	68500	68501
16612	21817	1	applied	\N	\N	\N	\N	68502	68502	68503
16612	21818	2	applied	\N	\N	\N	\N	68504	68504	68505
16619	21829	0	applied	\N	\N	\N	\N	68525	68525	68436
16619	21830	1	applied	\N	\N	\N	\N	68526	68526	68527
16619	21831	2	applied	\N	\N	\N	\N	68528	68528	56798
16619	21832	3	applied	\N	\N	\N	\N	68529	68529	56801
16621	21833	0	applied	\N	\N	\N	\N	68531	68531	68532
16621	21834	1	applied	\N	\N	\N	\N	68533	68533	56803
16621	21835	2	applied	\N	\N	\N	\N	68534	68534	68535
16631	21854	0	applied	\N	\N	\N	\N	68604	68604	68605
16631	21855	1	applied	\N	\N	\N	\N	68606	68606	68607
16631	21856	2	applied	\N	\N	\N	\N	68608	68608	62660
16631	21857	3	applied	\N	\N	\N	\N	68609	68609	56851
16631	21858	4	applied	\N	\N	\N	\N	68610	68610	68611
16631	21859	5	applied	\N	\N	\N	\N	68612	68612	56857
16633	21860	0	applied	\N	\N	\N	\N	68615	68615	68616
16633	21861	1	applied	\N	\N	\N	\N	68617	68617	68618
16633	21862	2	applied	\N	\N	\N	\N	68619	68619	56866
16633	21863	3	applied	\N	\N	\N	\N	68620	68620	62660
16635	21860	0	applied	\N	\N	\N	\N	68615	68615	68616
16635	21861	1	applied	\N	\N	\N	\N	68617	68617	68618
16635	21862	2	applied	\N	\N	\N	\N	68619	68619	56866
16635	21863	3	applied	\N	\N	\N	\N	68620	68620	62660
16638	21873	0	applied	\N	\N	\N	\N	68644	68644	68645
16638	21874	1	applied	\N	\N	\N	\N	68646	68646	68647
16638	21875	2	applied	\N	\N	\N	\N	68648	68648	56885
16638	21876	3	applied	\N	\N	\N	\N	68649	68649	68650
16638	21877	4	applied	\N	\N	\N	\N	68651	68651	68652
16638	21878	5	applied	\N	\N	\N	\N	68653	68653	56900
16638	21879	6	applied	\N	\N	\N	\N	68654	68654	56902
16644	21887	0	applied	\N	\N	\N	\N	68676	68676	68677
16644	21888	1	applied	\N	\N	\N	\N	68678	68678	68679
16644	21889	2	applied	\N	\N	\N	\N	68680	68680	68681
16644	21890	3	applied	\N	\N	\N	\N	68682	68682	68683
16644	21891	4	applied	\N	\N	\N	\N	68684	68684	56924
16644	21892	5	applied	\N	\N	\N	\N	68685	68685	56926
16644	21893	6	applied	\N	\N	\N	\N	68686	68686	68687
16644	21894	7	applied	\N	\N	\N	\N	68688	68688	56936
16644	21895	8	applied	\N	\N	\N	\N	68689	68689	68690
16644	21896	9	applied	\N	\N	\N	\N	68691	68691	56946
16644	21897	10	applied	\N	\N	\N	\N	68692	68692	68693
16644	21898	11	applied	\N	\N	\N	\N	68694	68694	56950
16646	21899	0	applied	\N	\N	\N	\N	68697	68697	68698
16646	21900	1	applied	\N	\N	\N	\N	68699	68699	56964
16646	21901	2	applied	\N	\N	\N	\N	68702	68702	68703
16648	21902	0	applied	\N	\N	\N	\N	68707	68707	68708
16648	21903	1	applied	\N	\N	\N	\N	68709	68709	68710
16648	21904	2	applied	\N	\N	\N	\N	68711	68711	68712
16651	21905	0	applied	\N	\N	\N	\N	68719	68719	68720
16651	21906	1	applied	\N	\N	\N	\N	68721	68721	68722
16651	21907	2	applied	\N	\N	\N	\N	68723	68723	68724
16651	21908	3	applied	\N	\N	\N	\N	68725	68725	56978
16651	21909	4	applied	\N	\N	\N	\N	68726	68726	68727
16651	21910	5	applied	\N	\N	\N	\N	68728	68728	56982
16653	21911	0	applied	\N	\N	\N	\N	68732	68732	68733
16653	21912	1	applied	\N	\N	\N	\N	68734	68734	68735
16653	21913	2	applied	\N	\N	\N	\N	68736	68736	68737
16653	21914	3	applied	\N	\N	\N	\N	68738	68738	56994
16653	21915	4	applied	\N	\N	\N	\N	68739	68739	57000
16653	21916	5	applied	\N	\N	\N	\N	68740	68740	57002
16653	21917	6	applied	\N	\N	\N	\N	68741	68741	68742
16665	21933	0	applied	\N	\N	\N	\N	68784	68784	68785
16665	21934	1	applied	\N	\N	\N	\N	68786	68786	68787
16665	21935	2	applied	\N	\N	\N	\N	68788	68788	68789
16667	21940	0	applied	\N	\N	\N	\N	68804	68804	68805
16667	21941	1	applied	\N	\N	\N	\N	68806	68806	68807
16667	21942	2	applied	\N	\N	\N	\N	68808	68808	68809
16672	21946	0	applied	\N	\N	\N	\N	68820	68820	68821
16672	21947	1	applied	\N	\N	\N	\N	68822	68822	68823
16672	21948	2	applied	\N	\N	\N	\N	68824	68824	57081
16672	21949	3	applied	\N	\N	\N	\N	68825	68825	68826
16672	21950	4	applied	\N	\N	\N	\N	68827	68827	57085
16672	21951	5	applied	\N	\N	\N	\N	68828	68828	57090
16675	21952	0	applied	\N	\N	\N	\N	68831	68831	68832
16675	21953	1	applied	\N	\N	\N	\N	68833	68833	68834
16675	21954	2	applied	\N	\N	\N	\N	68835	68835	57092
16675	21955	3	applied	\N	\N	\N	\N	68836	68836	57094
16675	21956	4	applied	\N	\N	\N	\N	68837	68837	57105
16675	21957	5	applied	\N	\N	\N	\N	68838	68838	68839
16675	21958	6	applied	\N	\N	\N	\N	68840	68840	57128
16677	21952	0	applied	\N	\N	\N	\N	68831	68831	68832
16677	21953	1	applied	\N	\N	\N	\N	68833	68833	68834
16677	21954	2	applied	\N	\N	\N	\N	68835	68835	57092
16677	21955	3	applied	\N	\N	\N	\N	68836	68836	57094
16677	21956	4	applied	\N	\N	\N	\N	68837	68837	57105
16677	21957	5	applied	\N	\N	\N	\N	68838	68838	68839
16677	21958	6	applied	\N	\N	\N	\N	68840	68840	57128
16682	21975	0	applied	\N	\N	\N	\N	68872	68872	68873
16682	21976	1	applied	\N	\N	\N	\N	68874	68874	68875
16682	21977	2	applied	\N	\N	\N	\N	68876	68876	68877
16682	21978	3	applied	\N	\N	\N	\N	68878	68878	57156
16682	21979	4	applied	\N	\N	\N	\N	68879	68879	57208
16682	21980	6	applied	\N	\N	\N	\N	68881	68881	68882
16682	21981	7	applied	\N	\N	\N	\N	68883	68883	57222
16688	21984	0	applied	\N	\N	\N	\N	68899	68899	68900
16688	21985	1	applied	\N	\N	\N	\N	68901	68901	68902
16688	21986	2	applied	\N	\N	\N	\N	68903	68903	68904
16688	21987	3	applied	\N	\N	\N	\N	68905	68905	68906
16688	21988	4	applied	\N	\N	\N	\N	68907	68907	68908
16688	21989	5	applied	\N	\N	\N	\N	68909	68909	57235
16688	21990	6	applied	\N	\N	\N	\N	68910	68910	57239
16688	21991	7	applied	\N	\N	\N	\N	68911	68911	57241
16688	21992	8	applied	\N	\N	\N	\N	68912	68912	68913
16688	21993	9	applied	\N	\N	\N	\N	68914	68914	68915
16688	21994	10	applied	\N	\N	\N	\N	68916	68916	57254
16688	21995	11	applied	\N	\N	\N	\N	68917	68917	68918
16688	21996	12	applied	\N	\N	\N	\N	68919	68919	68920
16688	21997	13	applied	\N	\N	\N	\N	68921	68921	68922
16688	21998	14	applied	\N	\N	\N	\N	68923	68923	68924
16688	21999	15	applied	\N	\N	\N	\N	68925	68925	57274
16691	22007	0	applied	\N	\N	\N	\N	68941	68941	68942
16691	22008	1	applied	\N	\N	\N	\N	68943	68943	68944
16691	22009	2	applied	\N	\N	\N	\N	68945	68945	68946
16691	22010	3	applied	\N	\N	\N	\N	68947	68947	57293
16691	22011	4	applied	\N	\N	\N	\N	68948	68948	68949
16611	21812	1	applied	\N	\N	\N	\N	68491	68491	68492
16611	21813	2	applied	\N	\N	\N	\N	68493	68493	68494
16611	21811	3	applied	\N	\N	\N	\N	68472	68472	56745
16611	21814	4	applied	\N	\N	\N	\N	68495	68495	68496
16611	21815	5	applied	\N	\N	\N	\N	68497	68497	56756
16614	21822	0	applied	\N	\N	\N	\N	68512	68512	68513
16614	21823	1	applied	\N	\N	\N	\N	68514	68514	56779
16614	21824	2	applied	\N	\N	\N	\N	68515	68515	68516
16614	21825	3	applied	\N	\N	\N	\N	68517	68517	68518
16625	21838	0	applied	\N	\N	\N	\N	68549	68549	68550
16625	21839	1	applied	\N	\N	\N	\N	68551	68551	56813
16625	21840	2	applied	\N	\N	\N	\N	68552	68552	68553
16628	21848	0	applied	\N	\N	\N	\N	68573	68573	68574
16628	21849	1	applied	\N	\N	\N	\N	68575	68575	56843
16628	21850	2	applied	\N	\N	\N	\N	68576	68576	56845
16630	21851	0	applied	\N	\N	\N	\N	68579	68579	68580
16630	21853	1	applied	\N	\N	\N	\N	68597	68597	68601
16630	21852	2	applied	\N	\N	\N	\N	68595	68595	68598
16637	21870	0	applied	\N	\N	\N	\N	68638	68638	68639
16637	21871	1	applied	\N	\N	\N	\N	68640	68640	68641
16637	21872	2	applied	\N	\N	\N	\N	68642	68642	68643
16640	21880	0	applied	\N	\N	\N	\N	68659	68659	68660
16640	21881	1	applied	\N	\N	\N	\N	68661	68661	56904
16640	21882	2	applied	\N	\N	\N	\N	68662	68662	68663
16650	21905	0	applied	\N	\N	\N	\N	68719	68719	68720
16650	21906	1	applied	\N	\N	\N	\N	68721	68721	68722
16650	21907	2	applied	\N	\N	\N	\N	68723	68723	68724
16650	21908	3	applied	\N	\N	\N	\N	68725	68725	56978
16650	21909	4	applied	\N	\N	\N	\N	68726	68726	68727
16650	21910	5	applied	\N	\N	\N	\N	68728	68728	56982
16657	21918	0	applied	\N	\N	\N	\N	68750	68750	68751
16657	21919	1	applied	\N	\N	\N	\N	68752	68752	68753
16657	21920	2	applied	\N	\N	\N	\N	68754	68754	68755
16662	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16662	21854	1	applied	\N	\N	\N	\N	68604	68604	68605
16662	21864	2	applied	\N	\N	\N	\N	68626	68626	68627
16662	21865	3	applied	\N	\N	\N	\N	68628	68628	68629
16662	21866	4	applied	\N	\N	\N	\N	68630	68630	68631
16662	21789	5	applied	\N	\N	\N	\N	68414	68414	68415
16662	21790	6	applied	\N	\N	\N	\N	68416	68416	68417
16662	21797	7	applied	\N	\N	\N	\N	68435	68435	68436
16662	21337	8	applied	\N	\N	1000000000	\N	67343	67343	67344
16662	21521	9	applied	\N	\N	1000000000	\N	68064	68064	67804
16662	21462	10	applied	\N	\N	1000000000	\N	67623	67623	67624
16662	21578	11	applied	\N	\N	1000000000	\N	67916	67916	67917
16662	21599	12	applied	\N	\N	1000000000	\N	67960	67960	67961
16662	21409	13	applied	\N	\N	\N	\N	67512	67512	67803
16662	21719	14	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16662	21738	15	applied	\N	\N	1000000000	\N	68334	68334	68292
16662	21746	16	applied	\N	\N	\N	\N	68335	68335	68292
16662	21856	17	applied	\N	\N	\N	\N	68608	68608	62660
16662	21393	18	applied	\N	\N	\N	\N	67477	67477	67477
16662	21403	19	applied	\N	\N	\N	\N	67498	67498	67498
16662	21405	20	applied	\N	\N	\N	\N	67501	67501	67501
16662	21413	21	applied	\N	\N	\N	\N	67518	67518	67518
16662	21421	22	applied	\N	\N	\N	\N	67533	67533	67533
16662	21863	23	applied	\N	\N	\N	\N	68620	68620	62660
16664	21933	0	applied	\N	\N	\N	\N	68784	68784	68785
16664	21934	1	applied	\N	\N	\N	\N	68786	68786	68787
16664	21935	2	applied	\N	\N	\N	\N	68788	68788	68789
16669	21943	0	applied	\N	\N	\N	\N	68813	68813	68814
16669	21944	1	applied	\N	\N	\N	\N	68815	68815	57077
16669	21945	2	applied	\N	\N	\N	\N	68816	68816	57079
16674	21952	0	applied	\N	\N	\N	\N	68831	68831	68832
16674	21953	1	applied	\N	\N	\N	\N	68833	68833	68834
16674	21954	2	applied	\N	\N	\N	\N	68835	68835	57092
16674	21955	3	applied	\N	\N	\N	\N	68836	68836	57094
16674	21956	4	applied	\N	\N	\N	\N	68837	68837	57105
16674	21957	5	applied	\N	\N	\N	\N	68838	68838	68839
16674	21958	6	applied	\N	\N	\N	\N	68840	68840	57128
16676	21952	0	applied	\N	\N	\N	\N	68831	68831	68832
16676	21953	1	applied	\N	\N	\N	\N	68833	68833	68834
16676	21954	2	applied	\N	\N	\N	\N	68835	68835	57092
16676	21955	3	applied	\N	\N	\N	\N	68836	68836	57094
16676	21956	4	applied	\N	\N	\N	\N	68837	68837	57105
16676	21957	5	applied	\N	\N	\N	\N	68838	68838	68839
16676	21958	6	applied	\N	\N	\N	\N	68840	68840	57128
16678	21959	0	applied	\N	\N	\N	\N	68845	68845	68846
16678	21960	1	applied	\N	\N	\N	\N	68847	68847	57130
16678	21961	2	applied	\N	\N	\N	\N	68848	68848	57132
16681	21965	0	applied	\N	\N	\N	\N	68856	68856	68857
16681	21966	1	applied	\N	\N	\N	\N	68858	68858	68859
16681	21967	2	applied	\N	\N	\N	\N	68860	68860	68861
16681	21968	3	applied	\N	\N	\N	\N	68862	68862	57138
16681	21969	4	applied	\N	\N	\N	\N	68863	68863	57142
16681	21970	5	applied	\N	\N	\N	\N	68864	68864	57144
16681	21971	6	applied	\N	\N	\N	\N	68865	68865	57148
16681	21972	7	applied	\N	\N	\N	\N	68866	68866	68867
16681	21973	8	applied	\N	\N	\N	\N	68868	68868	68869
16681	21974	9	applied	\N	\N	\N	\N	68870	68870	57154
16684	21982	0	applied	\N	\N	\N	\N	68890	68890	68891
16684	21983	1	applied	\N	\N	\N	\N	68892	68892	68893
16690	22007	0	applied	\N	\N	\N	\N	68941	68941	68942
16690	22008	1	applied	\N	\N	\N	\N	68943	68943	68944
16690	22009	2	applied	\N	\N	\N	\N	68945	68945	68946
16690	22010	3	applied	\N	\N	\N	\N	68947	68947	57293
16690	22011	4	applied	\N	\N	\N	\N	68948	68948	68949
16690	22012	5	applied	\N	\N	\N	\N	68950	68950	68951
16690	22013	6	applied	\N	\N	\N	\N	68952	68952	68953
16692	22007	0	applied	\N	\N	\N	\N	68941	68941	68942
16692	22008	1	applied	\N	\N	\N	\N	68943	68943	68944
16692	22009	2	applied	\N	\N	\N	\N	68945	68945	68946
16692	22010	3	applied	\N	\N	\N	\N	68947	68947	57293
16692	22011	4	applied	\N	\N	\N	\N	68948	68948	68949
16692	22012	5	applied	\N	\N	\N	\N	68950	68950	68951
16692	22013	6	applied	\N	\N	\N	\N	68952	68952	68953
16698	22031	0	applied	\N	\N	\N	\N	68995	68995	68996
16698	22032	1	applied	\N	\N	\N	\N	68997	68997	68998
16698	22033	2	applied	\N	\N	\N	\N	68999	68999	69000
16698	22034	3	applied	\N	\N	\N	\N	69001	69001	57377
16703	22044	0	applied	\N	\N	\N	\N	69024	69024	69025
16703	22045	1	applied	\N	\N	\N	\N	69026	69026	69027
16703	22046	2	applied	\N	\N	\N	\N	69028	69028	69029
16705	22047	0	applied	\N	\N	\N	\N	69034	69034	69035
16705	22048	1	applied	\N	\N	\N	\N	69036	69036	69037
16705	22049	2	applied	\N	\N	\N	\N	69038	69038	69039
16705	22050	3	applied	\N	\N	\N	\N	69040	69040	57414
16705	22051	4	applied	\N	\N	\N	\N	69041	69041	69042
16705	22052	5	applied	\N	\N	\N	\N	69043	69043	69044
16623	21712	57	applied	\N	\N	\N	\N	68219	68219	68220
16623	21715	58	applied	\N	\N	\N	\N	68228	68228	68229
16623	21718	59	applied	\N	\N	\N	\N	68232	68232	68233
16623	21724	60	applied	\N	\N	\N	\N	68242	68242	68243
16623	21727	61	applied	\N	\N	\N	\N	68247	68247	68248
16623	21731	62	applied	\N	\N	\N	\N	68275	68275	68276
16623	21732	63	applied	\N	\N	\N	\N	68277	68277	68278
16623	21737	64	applied	\N	\N	\N	\N	68289	68289	68290
16623	21741	65	applied	\N	\N	\N	\N	68300	68300	68301
16623	21745	66	applied	\N	\N	\N	\N	68307	68307	68308
16623	21749	67	applied	\N	\N	\N	\N	68318	68318	68319
16623	21752	68	applied	\N	\N	\N	\N	68325	68325	68326
16623	21756	69	applied	\N	\N	\N	\N	68338	68338	68339
16623	21757	70	applied	\N	\N	\N	\N	68340	68340	68341
16623	21758	71	applied	\N	\N	\N	\N	68342	68342	68343
16623	21766	72	applied	\N	\N	\N	\N	68358	68358	68359
16623	21767	73	applied	\N	\N	\N	\N	68360	68360	68361
16623	21772	74	applied	\N	\N	\N	\N	68376	68376	68377
16623	21773	75	applied	\N	\N	\N	\N	68378	68378	68379
16623	21778	76	applied	\N	\N	\N	\N	68390	68390	68391
16623	21779	77	applied	\N	\N	\N	\N	68392	68392	68393
16623	21785	78	applied	\N	\N	\N	\N	68406	68406	68407
16623	21791	79	applied	\N	\N	\N	\N	68418	68418	68419
16623	21794	80	applied	\N	\N	\N	\N	68425	68425	68426
16623	21799	81	applied	\N	\N	\N	\N	68440	68440	68441
16623	21803	82	applied	\N	\N	\N	\N	68449	68449	68450
16623	21806	83	applied	\N	\N	\N	\N	68460	68460	68461
16623	21810	85	applied	\N	\N	\N	\N	68470	68470	68471
16623	21812	86	applied	\N	\N	\N	\N	68491	68491	68492
16623	21816	87	applied	\N	\N	\N	\N	68500	68500	68501
16623	21819	88	applied	\N	\N	\N	\N	68506	68506	68507
16623	21822	89	applied	\N	\N	\N	\N	68512	68512	68513
16623	21826	90	applied	\N	\N	\N	\N	68521	68521	68522
16623	21830	91	applied	\N	\N	\N	\N	68526	68526	68527
16623	21555	92	applied	\N	\N	\N	\N	67878	67878	67879
16623	21556	93	applied	\N	\N	\N	\N	67880	67880	56000
16623	21562	94	applied	\N	\N	\N	\N	67891	67891	68539
16623	21557	95	applied	\N	\N	\N	\N	67881	67881	67892
16623	21563	96	applied	\N	\N	\N	\N	67893	67893	56007
16623	21576	97	applied	\N	\N	\N	\N	67912	67912	68540
16623	21592	98	applied	\N	\N	\N	\N	67944	67944	56009
16623	21606	99	applied	\N	\N	\N	\N	67972	67972	56011
16623	21609	100	applied	\N	\N	\N	\N	67979	67979	67896
16623	21619	101	applied	\N	\N	\N	\N	68001	68001	68541
16627	21841	0	applied	\N	\N	\N	\N	68558	68558	68559
16627	21842	1	applied	\N	\N	\N	\N	68560	68560	68561
16627	21843	2	applied	\N	\N	\N	\N	68562	68562	56827
16627	21844	3	applied	\N	\N	\N	\N	68563	68563	68564
16627	21845	4	applied	\N	\N	\N	\N	68565	68565	68566
16627	21846	5	applied	\N	\N	\N	\N	68567	68567	68568
16627	21847	6	applied	\N	\N	\N	\N	68569	68569	68570
16632	21854	0	applied	\N	\N	\N	\N	68604	68604	68605
16632	21855	1	applied	\N	\N	\N	\N	68606	68606	68607
16632	21857	2	applied	\N	\N	\N	\N	68609	68609	56851
16632	21858	3	applied	\N	\N	\N	\N	68610	68610	68611
16632	21859	4	applied	\N	\N	\N	\N	68612	68612	56857
16634	21860	0	applied	\N	\N	\N	\N	68615	68615	68616
16634	21861	1	applied	\N	\N	\N	\N	68617	68617	68618
16634	21862	2	applied	\N	\N	\N	\N	68619	68619	56866
16634	21863	3	applied	\N	\N	\N	\N	68620	68620	62660
16645	21887	0	applied	\N	\N	\N	\N	68676	68676	68677
16645	21888	1	applied	\N	\N	\N	\N	68678	68678	68679
16645	21889	2	applied	\N	\N	\N	\N	68680	68680	68681
16645	21890	3	applied	\N	\N	\N	\N	68682	68682	68683
16645	21899	4	applied	\N	\N	\N	\N	68697	68697	68698
16645	21891	5	applied	\N	\N	\N	\N	68684	68684	56924
16645	21892	6	applied	\N	\N	\N	\N	68685	68685	56926
16645	21893	7	applied	\N	\N	\N	\N	68686	68686	68687
16645	21894	8	applied	\N	\N	\N	\N	68688	68688	56936
16645	21895	9	applied	\N	\N	\N	\N	68689	68689	68690
16645	21896	10	applied	\N	\N	\N	\N	68691	68691	56946
16645	21900	11	applied	\N	\N	\N	\N	68699	68699	68700
16645	21897	12	applied	\N	\N	\N	\N	68692	68692	68701
16645	21898	13	applied	\N	\N	\N	\N	68694	68694	56964
16645	21901	14	applied	\N	\N	\N	\N	68702	68702	68703
16647	21902	0	applied	\N	\N	\N	\N	68707	68707	68708
16647	21903	1	applied	\N	\N	\N	\N	68709	68709	68710
16647	21904	2	applied	\N	\N	\N	\N	68711	68711	68712
16652	21911	0	applied	\N	\N	\N	\N	68732	68732	68733
16652	21912	1	applied	\N	\N	\N	\N	68734	68734	68735
16652	21913	2	applied	\N	\N	\N	\N	68736	68736	68737
16652	21914	3	applied	\N	\N	\N	\N	68738	68738	56994
16652	21915	4	applied	\N	\N	\N	\N	68739	68739	57000
16652	21916	5	applied	\N	\N	\N	\N	68740	68740	57002
16652	21917	6	applied	\N	\N	\N	\N	68741	68741	68742
16655	21911	0	applied	\N	\N	\N	\N	68732	68732	68733
16655	21912	1	applied	\N	\N	\N	\N	68734	68734	68735
16655	21913	2	applied	\N	\N	\N	\N	68736	68736	68737
16655	21914	3	applied	\N	\N	\N	\N	68738	68738	56994
16655	21915	4	applied	\N	\N	\N	\N	68739	68739	57000
16655	21916	5	applied	\N	\N	\N	\N	68740	68740	57002
16655	21917	6	applied	\N	\N	\N	\N	68741	68741	68742
16656	21911	0	applied	\N	\N	\N	\N	68732	68732	68733
16656	21912	1	applied	\N	\N	\N	\N	68734	68734	68735
16656	21913	2	applied	\N	\N	\N	\N	68736	68736	68737
16656	21914	3	applied	\N	\N	\N	\N	68738	68738	56994
16656	21915	4	applied	\N	\N	\N	\N	68739	68739	57000
16656	21916	5	applied	\N	\N	\N	\N	68740	68740	57002
16656	21917	6	applied	\N	\N	\N	\N	68741	68741	68742
16660	21924	0	applied	\N	\N	\N	\N	68764	68764	68765
16660	21925	1	applied	\N	\N	\N	\N	68766	68766	68767
16660	21926	2	applied	\N	\N	\N	\N	68768	68768	68769
16660	21927	3	applied	\N	\N	\N	\N	68770	68770	68771
16660	21928	4	applied	\N	\N	\N	\N	68772	68772	68773
16660	21929	5	applied	\N	\N	\N	\N	68774	68774	57031
16660	21930	6	applied	\N	\N	\N	\N	68775	68775	57033
16660	21931	7	applied	\N	\N	\N	\N	68776	68776	57035
16660	21932	8	applied	\N	\N	\N	\N	68777	68777	57049
16666	21936	0	applied	\N	\N	\N	\N	68796	68796	68797
16666	21937	1	applied	\N	\N	\N	\N	68798	68798	68799
16666	21938	2	applied	\N	\N	\N	\N	68800	68800	57057
16666	21939	3	applied	\N	\N	\N	\N	68801	68801	57069
16668	21936	0	applied	\N	\N	\N	\N	68796	68796	68797
16668	21940	1	applied	\N	\N	\N	\N	68804	68804	68805
16668	21937	2	applied	\N	\N	\N	\N	68798	68798	68799
16668	21941	3	applied	\N	\N	\N	\N	68806	68806	57069
16668	21938	4	applied	\N	\N	\N	\N	68800	68800	57071
16668	21939	5	applied	\N	\N	\N	\N	68801	68801	68807
16668	21942	6	applied	\N	\N	\N	\N	68808	68808	68809
16671	21943	0	applied	\N	\N	\N	\N	68813	68813	68814
16629	21799	25	applied	\N	\N	\N	\N	68440	68440	68441
16629	21803	26	applied	\N	\N	\N	\N	68449	68449	68450
16629	21806	27	applied	\N	\N	\N	\N	68460	68460	68461
16629	21810	28	applied	\N	\N	\N	\N	68470	68470	68471
16629	21812	29	applied	\N	\N	\N	\N	68491	68491	68492
16629	21816	30	applied	\N	\N	\N	\N	68500	68500	68501
16629	21819	31	applied	\N	\N	\N	\N	68506	68506	68507
16629	21822	32	applied	\N	\N	\N	\N	68512	68512	68513
16629	21826	33	applied	\N	\N	\N	\N	68521	68521	68522
16629	21830	34	applied	\N	\N	\N	\N	68526	68526	68527
16629	21833	35	applied	\N	\N	\N	\N	68531	68531	68532
16629	21836	36	applied	\N	\N	\N	\N	68544	68544	68545
16629	21838	37	applied	\N	\N	\N	\N	68549	68549	68550
16629	21841	38	applied	\N	\N	\N	\N	68558	68558	68559
16629	21842	39	applied	\N	\N	\N	\N	68560	68560	68561
16629	21848	40	applied	\N	\N	\N	\N	68573	68573	68574
16629	21851	41	applied	\N	\N	\N	\N	68579	68579	68580
16629	21733	42	applied	\N	\N	\N	\N	68279	68279	68280
16629	21734	43	applied	\N	\N	\N	\N	68281	68281	68282
16629	21735	44	applied	\N	\N	\N	\N	68283	68283	68284
16629	21739	45	applied	\N	\N	\N	\N	68293	68293	56530
16629	21742	46	applied	\N	\N	\N	\N	68302	68302	56537
16629	21747	47	applied	\N	\N	\N	\N	68311	68311	68304
16629	21743	48	applied	\N	\N	\N	\N	68303	68303	68310
16629	21755	49	applied	\N	\N	\N	\N	68330	68330	56546
16629	21759	50	applied	\N	\N	\N	\N	68344	68344	68581
16629	21774	51	applied	\N	\N	\N	\N	68380	68380	56548
16629	21786	52	applied	\N	\N	\N	\N	68408	68408	56573
16629	21800	53	applied	\N	\N	\N	\N	68442	68442	56575
16629	21813	54	applied	\N	\N	\N	\N	68493	68493	56577
16629	21736	55	applied	\N	\N	\N	\N	68285	68285	68313
16629	21740	56	applied	\N	\N	\N	\N	68295	68295	56583
16629	21750	57	applied	\N	\N	\N	\N	68320	68320	68322
16629	21753	58	applied	\N	\N	\N	\N	68327	68327	68328
16629	21761	59	applied	\N	\N	\N	\N	68346	68346	68331
16629	21825	60	applied	\N	\N	\N	\N	68517	68517	56604
16629	21837	61	applied	\N	\N	\N	\N	68546	68546	68582
16629	21844	62	applied	\N	\N	\N	\N	68563	68563	56606
16629	21744	63	applied	\N	\N	\N	\N	68305	68305	68583
16629	21748	64	applied	\N	\N	\N	\N	68312	68312	68584
16629	21751	65	applied	\N	\N	\N	\N	68321	68321	56628
16629	21754	66	applied	\N	\N	\N	\N	68329	68329	56612
16629	21760	67	applied	\N	\N	\N	\N	68345	68345	56614
16629	21762	68	applied	\N	\N	\N	\N	68347	68347	68484
16629	21763	69	applied	\N	\N	\N	\N	68348	68348	68485
16629	21768	70	applied	\N	\N	\N	\N	68362	68362	56634
16629	21769	71	applied	\N	\N	\N	\N	68364	68364	56640
16629	21775	72	applied	\N	\N	\N	\N	68381	68381	68368
16629	21780	73	applied	\N	\N	\N	\N	68394	68394	68486
16629	21783	74	applied	\N	\N	\N	\N	68400	68400	68487
16629	21787	75	applied	\N	\N	\N	\N	68409	68409	56658
16629	21792	76	applied	\N	\N	\N	\N	68420	68420	56660
16629	21796	77	applied	\N	\N	\N	\N	68428	68428	68488
16629	21801	78	applied	\N	\N	\N	\N	68443	68443	68385
16629	21804	79	applied	\N	\N	\N	\N	68452	68452	68395
16629	21808	80	applied	\N	\N	\N	\N	68464	68464	56675
16629	21811	81	applied	\N	\N	\N	\N	68472	68472	56677
16629	21814	82	applied	\N	\N	\N	\N	68495	68495	68399
16629	21817	83	applied	\N	\N	\N	\N	68502	68502	68401
16629	21820	84	applied	\N	\N	\N	\N	68508	68508	56688
16629	21824	85	applied	\N	\N	\N	\N	68515	68515	68585
16629	21827	86	applied	\N	\N	\N	\N	68523	68523	68412
16629	21832	87	applied	\N	\N	\N	\N	68529	68529	56701
16629	21835	88	applied	\N	\N	\N	\N	68534	68534	68586
16629	21840	89	applied	\N	\N	\N	\N	68552	68552	68587
16629	21843	90	applied	\N	\N	\N	\N	68562	68562	56707
16629	21847	91	applied	\N	\N	\N	\N	68569	68569	68429
16629	21764	92	applied	\N	\N	\N	\N	68350	68350	56721
16629	21765	93	applied	\N	\N	\N	\N	68351	68351	68445
16629	21770	94	applied	\N	\N	\N	\N	68367	68367	56727
16629	21771	95	applied	\N	\N	\N	\N	68369	68369	68588
16629	21776	96	applied	\N	\N	\N	\N	68382	68382	56733
16629	21777	97	applied	\N	\N	\N	\N	68384	68384	68473
16629	21781	98	applied	\N	\N	\N	\N	68396	68396	56743
16629	21782	99	applied	\N	\N	\N	\N	68398	68398	68496
16629	21788	100	applied	\N	\N	\N	\N	68411	68411	56756
16629	21793	101	applied	\N	\N	\N	\N	68421	68421	68589
16629	21795	102	applied	\N	\N	\N	\N	68427	68427	56762
16629	21802	103	applied	\N	\N	\N	\N	68444	68444	68590
16629	21805	104	applied	\N	\N	\N	\N	68454	68454	68591
16629	21807	105	applied	\N	\N	\N	\N	68462	68462	68516
16629	21809	106	applied	\N	\N	\N	\N	68467	68467	56789
16629	21815	107	applied	\N	\N	\N	\N	68497	68497	56791
16629	21818	108	applied	\N	\N	\N	\N	68504	68504	56798
16629	21821	109	applied	\N	\N	\N	\N	68509	68509	68592
16629	21823	110	applied	\N	\N	\N	\N	68514	68514	56809
16629	21828	111	applied	\N	\N	\N	\N	68524	68524	68593
16629	21831	112	applied	\N	\N	\N	\N	68528	68528	56818
16629	21834	113	applied	\N	\N	\N	\N	68533	68533	56827
16629	21839	114	applied	\N	\N	\N	\N	68551	68551	68594
16629	21845	115	applied	\N	\N	\N	\N	68565	68565	56833
16629	21846	116	applied	\N	\N	\N	\N	68567	68567	68570
16629	21849	117	applied	\N	\N	\N	\N	68575	68575	56843
16629	21852	118	applied	\N	\N	\N	\N	68595	68595	68596
16629	21850	119	applied	\N	\N	\N	\N	68576	68576	56847
16629	21853	120	applied	\N	\N	\N	\N	68597	68597	68598
16636	21864	0	applied	\N	\N	\N	\N	68626	68626	68627
16636	21865	1	applied	\N	\N	\N	\N	68628	68628	68629
16636	21866	2	applied	\N	\N	\N	\N	68630	68630	68631
16636	21867	3	applied	\N	\N	\N	\N	68632	68632	68633
16636	21868	4	applied	\N	\N	\N	\N	68634	68634	68635
16636	21869	5	applied	\N	\N	\N	\N	68636	68636	56874
16639	21873	0	applied	\N	\N	\N	\N	68644	68644	68645
16639	21874	1	applied	\N	\N	\N	\N	68646	68646	68647
16639	21875	2	applied	\N	\N	\N	\N	68648	68648	56885
16639	21876	3	applied	\N	\N	\N	\N	68649	68649	68650
16639	21877	4	applied	\N	\N	\N	\N	68651	68651	68652
16639	21878	5	applied	\N	\N	\N	\N	68653	68653	56900
16639	21879	6	applied	\N	\N	\N	\N	68654	68654	56902
16641	21883	0	applied	\N	\N	\N	\N	68666	68666	68667
16641	21884	1	applied	\N	\N	\N	\N	68668	68668	68669
16641	21885	2	applied	\N	\N	\N	\N	68670	68670	56914
16641	21886	3	applied	\N	\N	\N	\N	68671	68671	68672
16649	21902	0	applied	\N	\N	\N	\N	68707	68707	68708
16649	21903	1	applied	\N	\N	\N	\N	68709	68709	68710
16649	21904	2	applied	\N	\N	\N	\N	68711	68711	68712
16654	21911	0	applied	\N	\N	\N	\N	68732	68732	68733
16654	21912	1	applied	\N	\N	\N	\N	68734	68734	68735
16654	21913	2	applied	\N	\N	\N	\N	68736	68736	68737
16654	21914	3	applied	\N	\N	\N	\N	68738	68738	56994
16654	21915	4	applied	\N	\N	\N	\N	68739	68739	57000
16654	21916	5	applied	\N	\N	\N	\N	68740	68740	57002
16654	21917	6	applied	\N	\N	\N	\N	68741	68741	68742
16658	21921	0	applied	\N	\N	\N	\N	68758	68758	68759
16658	21922	1	applied	\N	\N	\N	\N	68760	68760	68761
16658	21923	2	applied	\N	\N	\N	\N	68762	68762	57024
16659	21924	0	applied	\N	\N	\N	\N	68764	68764	68765
16659	21925	1	applied	\N	\N	\N	\N	68766	68766	68767
16659	21926	2	applied	\N	\N	\N	\N	68768	68768	68769
16659	21927	3	applied	\N	\N	\N	\N	68770	68770	68771
16659	21928	4	applied	\N	\N	\N	\N	68772	68772	68773
16659	21929	5	applied	\N	\N	\N	\N	68774	68774	57031
16659	21930	6	applied	\N	\N	\N	\N	68775	68775	57033
16659	21931	7	applied	\N	\N	\N	\N	68776	68776	57035
16659	21932	8	applied	\N	\N	\N	\N	68777	68777	57049
16661	21924	0	applied	\N	\N	\N	\N	68764	68764	68765
16661	21925	1	applied	\N	\N	\N	\N	68766	68766	68767
16661	21926	2	applied	\N	\N	\N	\N	68768	68768	68769
16661	21927	3	applied	\N	\N	\N	\N	68770	68770	68771
16661	21928	4	applied	\N	\N	\N	\N	68772	68772	68773
16661	21929	5	applied	\N	\N	\N	\N	68774	68774	57031
16661	21930	6	applied	\N	\N	\N	\N	68775	68775	57033
16661	21931	7	applied	\N	\N	\N	\N	68776	68776	57035
16661	21932	8	applied	\N	\N	\N	\N	68777	68777	57049
16663	21933	0	applied	\N	\N	\N	\N	68784	68784	68785
16663	21934	1	applied	\N	\N	\N	\N	68786	68786	68787
16663	21935	2	applied	\N	\N	\N	\N	68788	68788	68789
16670	21943	0	applied	\N	\N	\N	\N	68813	68813	68814
16670	21944	1	applied	\N	\N	\N	\N	68815	68815	57077
16670	21945	2	applied	\N	\N	\N	\N	68816	68816	57079
16679	21959	0	applied	\N	\N	\N	\N	68845	68845	68846
16679	21960	1	applied	\N	\N	\N	\N	68847	68847	57130
16679	21961	2	applied	\N	\N	\N	\N	68848	68848	57132
16683	21975	0	applied	\N	\N	\N	\N	68872	68872	68873
16683	21976	1	applied	\N	\N	\N	\N	68874	68874	68875
16683	21977	2	applied	\N	\N	\N	\N	68876	68876	68877
16683	21978	3	applied	\N	\N	\N	\N	68878	68878	57156
16683	21979	4	applied	\N	\N	\N	\N	68879	68879	57208
16683	21980	6	applied	\N	\N	\N	\N	68881	68881	68882
16683	21981	7	applied	\N	\N	\N	\N	68883	68883	57222
16685	21982	0	applied	\N	\N	\N	\N	68890	68890	68891
16685	21983	1	applied	\N	\N	\N	\N	68892	68892	68893
16699	22035	0	applied	\N	\N	\N	\N	69003	69003	69004
16699	22036	1	applied	\N	\N	\N	\N	69005	69005	57379
16699	22037	2	applied	\N	\N	\N	\N	69006	69006	57381
16702	22040	0	applied	\N	\N	\N	\N	69014	69014	69015
16702	22041	1	applied	\N	\N	\N	\N	69016	69016	57388
16702	22042	2	applied	\N	\N	\N	\N	69017	69017	57394
16702	22043	3	applied	\N	\N	\N	\N	69018	69018	69019
16708	22054	0	applied	\N	\N	\N	\N	69078	69078	69079
16708	22055	1	applied	\N	\N	\N	\N	69080	69080	57420
16708	22056	2	applied	\N	\N	\N	\N	69081	69081	57426
16709	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16709	21854	1	applied	\N	\N	\N	\N	68604	68604	68605
16709	21864	2	applied	\N	\N	\N	\N	68626	68626	68627
16709	21865	3	applied	\N	\N	\N	\N	68628	68628	68629
16709	21866	4	applied	\N	\N	\N	\N	68630	68630	68631
16709	21789	5	applied	\N	\N	\N	\N	68414	68414	68415
16709	21790	6	applied	\N	\N	\N	\N	68416	68416	68417
16709	21797	7	applied	\N	\N	\N	\N	68435	68435	68436
16709	21756	8	applied	\N	\N	\N	\N	68338	68338	68339
16709	21757	9	applied	\N	\N	\N	\N	68340	68340	68341
16709	21758	10	applied	\N	\N	\N	\N	68342	68342	68343
16709	21766	11	applied	\N	\N	\N	\N	68358	68358	68359
16709	21767	12	applied	\N	\N	\N	\N	68360	68360	68361
16709	21772	13	applied	\N	\N	\N	\N	68376	68376	68377
16709	21773	14	applied	\N	\N	\N	\N	68378	68378	68379
16709	21778	15	applied	\N	\N	\N	\N	68390	68390	68391
16709	21779	16	applied	\N	\N	\N	\N	68392	68392	68393
16709	21785	17	applied	\N	\N	\N	\N	68406	68406	68407
16709	21791	18	applied	\N	\N	\N	\N	68418	68418	68419
16709	21794	19	applied	\N	\N	\N	\N	68425	68425	68426
16709	21799	20	applied	\N	\N	\N	\N	68440	68440	68441
16709	21803	21	applied	\N	\N	\N	\N	68449	68449	68450
16709	21806	22	applied	\N	\N	\N	\N	68460	68460	68461
16709	21810	23	applied	\N	\N	\N	\N	68470	68470	68471
16709	21812	24	applied	\N	\N	\N	\N	68491	68491	68492
16709	21816	25	applied	\N	\N	\N	\N	68500	68500	68501
16709	21819	26	applied	\N	\N	\N	\N	68506	68506	68507
16709	21822	27	applied	\N	\N	\N	\N	68512	68512	68513
16709	21826	28	applied	\N	\N	\N	\N	68521	68521	68522
16709	21830	29	applied	\N	\N	\N	\N	68526	68526	68527
16709	21833	30	applied	\N	\N	\N	\N	68531	68531	68532
16709	21836	31	applied	\N	\N	\N	\N	68544	68544	68545
16709	21838	32	applied	\N	\N	\N	\N	68549	68549	68550
16709	21841	33	applied	\N	\N	\N	\N	68558	68558	68559
16709	21842	34	applied	\N	\N	\N	\N	68560	68560	68561
16709	21848	35	applied	\N	\N	\N	\N	68573	68573	68574
16709	21851	36	applied	\N	\N	\N	\N	68579	68579	68580
16709	21855	37	applied	\N	\N	\N	\N	68606	68606	68607
16709	21860	38	applied	\N	\N	\N	\N	68615	68615	68616
16709	21867	39	applied	\N	\N	\N	\N	68632	68632	68633
16709	21870	40	applied	\N	\N	\N	\N	68638	68638	68639
16709	21873	41	applied	\N	\N	\N	\N	68644	68644	68645
16709	21874	42	applied	\N	\N	\N	\N	68646	68646	68647
16709	21880	43	applied	\N	\N	\N	\N	68659	68659	68660
16709	21883	44	applied	\N	\N	\N	\N	68666	68666	68667
16709	21887	45	applied	\N	\N	\N	\N	68676	68676	68677
16709	21888	46	applied	\N	\N	\N	\N	68678	68678	68679
16709	21889	47	applied	\N	\N	\N	\N	68680	68680	68681
16709	21890	48	applied	\N	\N	\N	\N	68682	68682	68683
16709	21899	49	applied	\N	\N	\N	\N	68697	68697	68698
16709	21902	50	applied	\N	\N	\N	\N	68707	68707	68708
16709	21905	51	applied	\N	\N	\N	\N	68719	68719	68720
16709	21906	52	applied	\N	\N	\N	\N	68721	68721	68722
16709	21911	53	applied	\N	\N	\N	\N	68732	68732	68733
16709	21912	54	applied	\N	\N	\N	\N	68734	68734	68735
16709	21918	55	applied	\N	\N	\N	\N	68750	68750	68751
16709	21921	56	applied	\N	\N	\N	\N	68758	68758	68759
16709	21924	57	applied	\N	\N	\N	\N	68764	68764	68765
16709	21925	58	applied	\N	\N	\N	\N	68766	68766	68767
16709	21926	59	applied	\N	\N	\N	\N	68768	68768	68769
16709	21933	60	applied	\N	\N	\N	\N	68784	68784	68785
16709	21936	61	applied	\N	\N	\N	\N	68796	68796	68797
16709	21940	62	applied	\N	\N	\N	\N	68804	68804	68805
16709	21943	64	applied	\N	\N	\N	\N	68813	68813	68814
16709	21946	65	applied	\N	\N	\N	\N	68820	68820	68821
16709	21947	66	applied	\N	\N	\N	\N	68822	68822	68823
16709	21952	67	applied	\N	\N	\N	\N	68831	68831	68832
16709	21953	68	applied	\N	\N	\N	\N	68833	68833	68834
16671	21944	1	applied	\N	\N	\N	\N	68815	68815	57077
16671	21945	2	applied	\N	\N	\N	\N	68816	68816	57079
16673	21946	0	applied	\N	\N	\N	\N	68820	68820	68821
16673	21947	1	applied	\N	\N	\N	\N	68822	68822	68823
16673	21948	2	applied	\N	\N	\N	\N	68824	68824	57081
16673	21949	3	applied	\N	\N	\N	\N	68825	68825	68826
16673	21950	4	applied	\N	\N	\N	\N	68827	68827	57085
16673	21951	5	applied	\N	\N	\N	\N	68828	68828	57090
16680	21962	0	applied	\N	\N	\N	\N	68851	68851	68852
16680	21963	1	applied	\N	\N	\N	\N	68853	68853	57134
16680	21964	2	applied	\N	\N	\N	\N	68854	68854	68855
16687	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16687	21854	1	applied	\N	\N	\N	\N	68604	68604	68605
16687	21864	2	applied	\N	\N	\N	\N	68626	68626	68627
16687	21865	4	applied	\N	\N	\N	\N	68628	68628	68629
16687	21866	5	applied	\N	\N	\N	\N	68630	68630	68631
16687	21789	6	applied	\N	\N	\N	\N	68414	68414	68415
16687	21790	7	applied	\N	\N	\N	\N	68416	68416	68417
16687	21797	8	applied	\N	\N	\N	\N	68435	68435	68436
16687	21578	9	applied	\N	\N	1000000000	\N	67916	67916	67917
16687	21599	10	applied	\N	\N	1000000000	\N	67960	67960	67961
16687	21520	11	applied	\N	\N	\N	\N	67801	67801	67802
16687	21521	12	applied	\N	\N	1000000000	\N	67803	67803	67804
16687	21558	13	applied	\N	\N	\N	\N	68895	68895	68896
16687	21522	14	applied	\N	\N	\N	\N	67805	67805	67806
16687	21523	15	applied	\N	\N	\N	\N	67808	67808	67809
16687	21524	16	applied	\N	\N	\N	\N	67810	67810	67811
16687	21534	17	applied	\N	\N	\N	\N	67828	67828	67829
16687	21537	18	applied	\N	\N	\N	\N	67842	67842	67843
16687	21540	19	applied	\N	\N	\N	\N	67848	67848	67849
16687	21545	20	applied	\N	\N	\N	\N	67856	67856	67857
16687	21548	21	applied	\N	\N	\N	\N	67865	67865	67866
16687	21549	22	applied	\N	\N	\N	\N	67867	67867	67868
16687	21554	23	applied	\N	\N	\N	\N	67876	67876	67877
16687	21559	24	applied	\N	\N	\N	\N	67885	67885	67886
16687	21560	25	applied	\N	\N	\N	\N	67887	67887	67888
16687	21561	26	applied	\N	\N	\N	\N	67889	67889	67890
16687	21571	27	applied	\N	\N	\N	\N	67903	67903	67904
16687	21574	28	applied	\N	\N	\N	\N	67909	67909	67910
16687	21579	29	applied	\N	\N	\N	\N	67918	67918	67919
16687	21582	30	applied	\N	\N	\N	\N	67924	67924	67925
16687	21585	31	applied	\N	\N	\N	\N	67933	67933	67934
16687	21586	32	applied	\N	\N	\N	\N	67935	67935	67936
16687	21587	33	applied	\N	\N	\N	\N	67937	67937	67938
16687	21593	34	applied	\N	\N	\N	\N	67948	67948	67949
16687	21596	35	applied	\N	\N	\N	\N	67954	67954	67955
16687	21597	36	applied	\N	\N	\N	\N	67956	67956	67957
16687	21598	37	applied	\N	\N	\N	\N	67958	67958	67959
16687	21607	38	applied	\N	\N	\N	\N	67975	67975	67976
16687	21608	39	applied	\N	\N	\N	\N	67977	67977	67978
16687	21719	40	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16687	21614	41	applied	\N	\N	\N	\N	67990	67990	67991
16687	21615	42	applied	\N	\N	\N	\N	67992	67992	67993
16687	21616	43	applied	\N	\N	\N	\N	67994	67994	67995
16687	21617	44	applied	\N	\N	\N	\N	67996	67996	67997
16687	21618	45	applied	\N	\N	\N	\N	67999	67999	68000
16687	21630	46	applied	\N	\N	\N	\N	68018	68018	68019
16687	21634	47	applied	\N	\N	\N	\N	68036	68036	68037
16687	21637	48	applied	\N	\N	\N	\N	68047	68047	68048
16687	21640	49	applied	\N	\N	\N	\N	68055	68055	68056
16687	21644	50	applied	\N	\N	\N	\N	68068	68068	68069
16687	21647	51	applied	\N	\N	\N	\N	68075	68075	68076
16687	21648	52	applied	\N	\N	\N	\N	68077	68077	68078
16687	21652	53	applied	\N	\N	\N	\N	68086	68086	68087
16687	21653	54	applied	\N	\N	\N	\N	68088	68088	68089
16687	21659	55	applied	\N	\N	\N	\N	68099	68099	68100
16687	21662	56	applied	\N	\N	\N	\N	68107	68107	68108
16687	21663	57	applied	\N	\N	\N	\N	68109	68109	68110
16687	21738	58	applied	\N	\N	1000000000	\N	68291	68291	68292
16687	21746	59	applied	\N	\N	\N	\N	68309	68309	68292
16687	21669	60	applied	\N	\N	\N	\N	68120	68120	68121
16687	21672	61	applied	\N	\N	\N	\N	68131	68131	68132
16687	21674	62	applied	\N	\N	\N	\N	68135	68135	68136
16687	21675	63	applied	\N	\N	\N	\N	68137	68137	68138
16687	21676	64	applied	\N	\N	\N	\N	68139	68139	68140
16687	21686	65	applied	\N	\N	\N	\N	68164	68164	68165
16687	21691	66	applied	\N	\N	\N	\N	68177	68177	68178
16687	21692	67	applied	\N	\N	\N	\N	68179	68179	68180
16687	21696	68	applied	\N	\N	\N	\N	68186	68186	68187
16687	21697	69	applied	\N	\N	\N	\N	68188	68188	68189
16687	21698	70	applied	\N	\N	\N	\N	68190	68190	68191
16687	21699	71	applied	\N	\N	\N	\N	68192	68192	68193
16687	21709	72	applied	\N	\N	\N	\N	68211	68211	68212
16687	21712	73	applied	\N	\N	\N	\N	68219	68219	68220
16687	21715	74	applied	\N	\N	\N	\N	68228	68228	68229
16687	21718	75	applied	\N	\N	\N	\N	68232	68232	68233
16687	21724	76	applied	\N	\N	\N	\N	68242	68242	68243
16687	21727	77	applied	\N	\N	\N	\N	68247	68247	68248
16687	21731	78	applied	\N	\N	\N	\N	68275	68275	68276
16687	21732	79	applied	\N	\N	\N	\N	68277	68277	68278
16687	21737	80	applied	\N	\N	\N	\N	68289	68289	68290
16687	21741	81	applied	\N	\N	\N	\N	68300	68300	68301
16687	21745	82	applied	\N	\N	\N	\N	68307	68307	68308
16687	21749	83	applied	\N	\N	\N	\N	68318	68318	68319
16687	21752	84	applied	\N	\N	\N	\N	68325	68325	68326
16687	21756	85	applied	\N	\N	\N	\N	68338	68338	68339
16687	21757	86	applied	\N	\N	\N	\N	68340	68340	68341
16687	21758	87	applied	\N	\N	\N	\N	68342	68342	68343
16687	21766	88	applied	\N	\N	\N	\N	68358	68358	68359
16687	21767	89	applied	\N	\N	\N	\N	68360	68360	68361
16687	21772	90	applied	\N	\N	\N	\N	68376	68376	68377
16687	21773	91	applied	\N	\N	\N	\N	68378	68378	68379
16687	21778	92	applied	\N	\N	\N	\N	68390	68390	68391
16687	21779	93	applied	\N	\N	\N	\N	68392	68392	68393
16687	21785	94	applied	\N	\N	\N	\N	68406	68406	68407
16687	21791	95	applied	\N	\N	\N	\N	68418	68418	68419
16687	21794	96	applied	\N	\N	\N	\N	68425	68425	68426
16687	21799	97	applied	\N	\N	\N	\N	68440	68440	68441
16687	21803	98	applied	\N	\N	\N	\N	68449	68449	68450
16687	21806	99	applied	\N	\N	\N	\N	68460	68460	68461
16687	21810	100	applied	\N	\N	\N	\N	68470	68470	68471
16687	21812	101	applied	\N	\N	\N	\N	68491	68491	68492
16687	21816	102	applied	\N	\N	\N	\N	68500	68500	68501
16687	21819	103	applied	\N	\N	\N	\N	68506	68506	68507
16687	21822	104	applied	\N	\N	\N	\N	68512	68512	68513
16687	21826	105	applied	\N	\N	\N	\N	68521	68521	68522
16687	21830	106	applied	\N	\N	\N	\N	68526	68526	68527
16687	21833	107	applied	\N	\N	\N	\N	68531	68531	68532
16687	21836	108	applied	\N	\N	\N	\N	68544	68544	68545
16687	21838	109	applied	\N	\N	\N	\N	68549	68549	68550
16687	21841	110	applied	\N	\N	\N	\N	68558	68558	68559
16687	21842	111	applied	\N	\N	\N	\N	68560	68560	68561
16687	21848	112	applied	\N	\N	\N	\N	68573	68573	68574
16687	21851	113	applied	\N	\N	\N	\N	68579	68579	68580
16687	21855	114	applied	\N	\N	\N	\N	68606	68606	68607
16687	21860	115	applied	\N	\N	\N	\N	68615	68615	68616
16687	21867	116	applied	\N	\N	\N	\N	68632	68632	68633
16687	21870	117	applied	\N	\N	\N	\N	68638	68638	68639
16687	21873	118	applied	\N	\N	\N	\N	68644	68644	68645
16687	21874	119	applied	\N	\N	\N	\N	68646	68646	68647
16687	21880	120	applied	\N	\N	\N	\N	68659	68659	68660
16687	21883	121	applied	\N	\N	\N	\N	68666	68666	68667
16687	21887	122	applied	\N	\N	\N	\N	68676	68676	68677
16687	21888	123	applied	\N	\N	\N	\N	68678	68678	68679
16687	21889	124	applied	\N	\N	\N	\N	68680	68680	68681
16687	21890	125	applied	\N	\N	\N	\N	68682	68682	68683
16689	22000	0	applied	\N	\N	\N	\N	68927	68927	68928
16689	22001	1	applied	\N	\N	\N	\N	68929	68929	68930
16689	22002	2	applied	\N	\N	\N	\N	68931	68931	68932
16689	22003	3	applied	\N	\N	\N	\N	68933	68933	68934
16689	22004	4	applied	\N	\N	\N	\N	68935	68935	57278
16689	22005	5	applied	\N	\N	\N	\N	68936	68936	68937
16689	22006	6	applied	\N	\N	\N	\N	68938	68938	57284
16694	22017	0	applied	\N	\N	\N	\N	68967	68967	68968
16694	22018	1	applied	\N	\N	\N	\N	68969	68969	57315
16697	22028	0	applied	\N	\N	\N	\N	68988	68988	68989
16697	22029	1	applied	\N	\N	\N	\N	68990	68990	57348
16697	22030	2	applied	\N	\N	\N	\N	68991	68991	68992
16700	22038	0	applied	\N	\N	\N	\N	69009	69009	69010
16700	22039	1	applied	\N	\N	\N	\N	69011	69011	57386
16707	21854	0	applied	\N	\N	\N	\N	68604	68604	68605
16707	21864	1	applied	\N	\N	\N	\N	68626	68626	68627
16707	21865	2	applied	\N	\N	\N	\N	68628	68628	68629
16707	21866	3	applied	\N	\N	\N	\N	68630	68630	68631
16707	21812	4	applied	\N	\N	\N	\N	68491	68491	68492
16707	21816	5	applied	\N	\N	\N	\N	68500	68500	68501
16707	21819	6	applied	\N	\N	\N	\N	68506	68506	68507
16707	21822	7	applied	\N	\N	\N	\N	68512	68512	68513
16707	21826	8	applied	\N	\N	\N	\N	68521	68521	68522
16707	21830	9	applied	\N	\N	\N	\N	68526	68526	68527
16707	21833	10	applied	\N	\N	\N	\N	68531	68531	68532
16707	21836	11	applied	\N	\N	\N	\N	68544	68544	68545
16707	21838	12	applied	\N	\N	\N	\N	68549	68549	68550
16707	21841	13	applied	\N	\N	\N	\N	68558	68558	68559
16707	21842	14	applied	\N	\N	\N	\N	68560	68560	68561
16707	21848	15	applied	\N	\N	\N	\N	68573	68573	68574
16707	21851	16	applied	\N	\N	\N	\N	68579	68579	68580
16707	21855	17	applied	\N	\N	\N	\N	68606	68606	68607
16707	21860	18	applied	\N	\N	\N	\N	68615	68615	68616
16707	21867	20	applied	\N	\N	\N	\N	68632	68632	68633
16707	21870	21	applied	\N	\N	\N	\N	68638	68638	68639
16707	21873	22	applied	\N	\N	\N	\N	68644	68644	68645
16707	21874	23	applied	\N	\N	\N	\N	68646	68646	68647
16707	21880	24	applied	\N	\N	\N	\N	68659	68659	68660
16707	21883	25	applied	\N	\N	\N	\N	68666	68666	68667
16707	21887	26	applied	\N	\N	\N	\N	68676	68676	68677
16707	21888	27	applied	\N	\N	\N	\N	68678	68678	68679
16707	21889	28	applied	\N	\N	\N	\N	68680	68680	68681
16707	21890	29	applied	\N	\N	\N	\N	68682	68682	68683
16707	21899	30	applied	\N	\N	\N	\N	68697	68697	68698
16707	21902	31	applied	\N	\N	\N	\N	68707	68707	68708
16707	21905	32	applied	\N	\N	\N	\N	68719	68719	68720
16707	21906	33	applied	\N	\N	\N	\N	68721	68721	68722
16707	21911	34	applied	\N	\N	\N	\N	68732	68732	68733
16707	21912	35	applied	\N	\N	\N	\N	68734	68734	68735
16707	21918	36	applied	\N	\N	\N	\N	68750	68750	68751
16707	21921	37	applied	\N	\N	\N	\N	68758	68758	68759
16707	21924	38	applied	\N	\N	\N	\N	68764	68764	68765
16707	21925	39	applied	\N	\N	\N	\N	68766	68766	68767
16707	21926	40	applied	\N	\N	\N	\N	68768	68768	68769
16707	21933	41	applied	\N	\N	\N	\N	68784	68784	68785
16707	21936	42	applied	\N	\N	\N	\N	68796	68796	68797
16707	21940	43	applied	\N	\N	\N	\N	68804	68804	68805
16707	21943	44	applied	\N	\N	\N	\N	68813	68813	68814
16707	21946	45	applied	\N	\N	\N	\N	68820	68820	68821
16707	21947	46	applied	\N	\N	\N	\N	68822	68822	68823
16707	21952	47	applied	\N	\N	\N	\N	68831	68831	68832
16707	21953	48	applied	\N	\N	\N	\N	68833	68833	68834
16707	21959	49	applied	\N	\N	\N	\N	68845	68845	68846
16707	21962	50	applied	\N	\N	\N	\N	68851	68851	68852
16707	21965	51	applied	\N	\N	\N	\N	68856	68856	68857
16707	21966	52	applied	\N	\N	\N	\N	68858	68858	68859
16707	21967	53	applied	\N	\N	\N	\N	68860	68860	68861
16707	21975	54	applied	\N	\N	\N	\N	68872	68872	68873
16707	21976	55	applied	\N	\N	\N	\N	68874	68874	68875
16707	21982	56	applied	\N	\N	\N	\N	68890	68890	68891
16707	21984	57	applied	\N	\N	\N	\N	68899	68899	68900
16707	21985	58	applied	\N	\N	\N	\N	68901	68901	68902
16707	21986	59	applied	\N	\N	\N	\N	68903	68903	68904
16707	21987	60	applied	\N	\N	\N	\N	68905	68905	68906
16707	21988	61	applied	\N	\N	\N	\N	68907	68907	68908
16707	22000	62	applied	\N	\N	\N	\N	68927	68927	68928
16707	22001	63	applied	\N	\N	\N	\N	68929	68929	68930
16707	22007	64	applied	\N	\N	\N	\N	68941	68941	68942
16707	22008	65	applied	\N	\N	\N	\N	68943	68943	68944
16707	22014	66	applied	\N	\N	\N	\N	68959	68959	68960
16707	22017	67	applied	\N	\N	\N	\N	68967	68967	69050
16707	22019	68	applied	\N	\N	\N	\N	68974	68974	69051
16707	22020	69	applied	\N	\N	\N	\N	68976	68976	69052
16707	22028	70	applied	\N	\N	\N	\N	68988	68988	69053
16707	22031	71	applied	\N	\N	\N	\N	68995	68995	69054
16707	22035	72	applied	\N	\N	\N	\N	69003	69003	69055
16707	22038	73	applied	\N	\N	\N	\N	69009	69009	69056
16707	22040	74	applied	\N	\N	\N	\N	69014	69014	69057
16707	22044	75	applied	\N	\N	\N	\N	69024	69024	69058
16707	22047	76	applied	\N	\N	\N	\N	69034	69034	69059
16707	22048	77	applied	\N	\N	\N	\N	69036	69036	69060
16707	21856	78	applied	\N	\N	\N	\N	68608	68608	62660
16707	21814	79	applied	\N	\N	\N	\N	68495	68495	56675
16707	21813	80	applied	\N	\N	\N	\N	68493	68493	68397
16707	21817	81	applied	\N	\N	\N	\N	68502	68502	69061
16707	21820	82	applied	\N	\N	\N	\N	68508	68508	56684
16707	21824	83	applied	\N	\N	\N	\N	68515	68515	56686
16707	21827	84	applied	\N	\N	\N	\N	68523	68523	68410
16707	21832	85	applied	\N	\N	\N	\N	68529	68529	56697
16707	21863	86	applied	\N	\N	\N	\N	68620	68620	62660
16707	21825	87	applied	\N	\N	\N	\N	68517	68517	68412
16707	21837	88	applied	\N	\N	\N	\N	68546	68546	56699
16707	21844	89	applied	\N	\N	\N	\N	68563	68563	56701
16691	22012	5	applied	\N	\N	\N	\N	68950	68950	68951
16691	22013	6	applied	\N	\N	\N	\N	68952	68952	68953
16693	22014	0	applied	\N	\N	\N	\N	68959	68959	68960
16693	22015	1	applied	\N	\N	\N	\N	68961	68961	68962
16693	22016	2	applied	\N	\N	\N	\N	68963	68963	68964
16695	22017	0	applied	\N	\N	\N	\N	68967	68967	68968
16695	22018	1	applied	\N	\N	\N	\N	68969	68969	57315
16696	22019	0	applied	\N	\N	\N	\N	68974	68974	68975
16696	22020	1	applied	\N	\N	\N	\N	68976	68976	68977
16696	22021	2	applied	\N	\N	\N	\N	68978	68978	57326
16696	22022	3	applied	\N	\N	\N	\N	68979	68979	57328
16696	22023	4	applied	\N	\N	\N	\N	68980	68980	68981
16696	22024	5	applied	\N	\N	\N	\N	68982	68982	57332
16696	22025	6	applied	\N	\N	\N	\N	68983	68983	68984
16696	22026	7	applied	\N	\N	\N	\N	68985	68985	57344
16696	22027	8	applied	\N	\N	\N	\N	68986	68986	57355
16701	22040	0	applied	\N	\N	\N	\N	69014	69014	69015
16701	22041	1	applied	\N	\N	\N	\N	69016	69016	57388
16701	22042	2	applied	\N	\N	\N	\N	69017	69017	57394
16701	22043	3	applied	\N	\N	\N	\N	69018	69018	69019
16704	22044	0	applied	\N	\N	\N	\N	69024	69024	69025
16704	22045	1	applied	\N	\N	\N	\N	69026	69026	69027
16704	22046	2	applied	\N	\N	\N	\N	69028	69028	69029
16712	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16712	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16712	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16717	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16717	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16717	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16721	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16721	21854	1	applied	\N	\N	\N	\N	68604	68604	68605
16721	21864	2	applied	\N	\N	\N	\N	68626	68626	68627
16721	21865	3	applied	\N	\N	\N	\N	68628	68628	68629
16721	21866	4	applied	\N	\N	\N	\N	68630	68630	68631
16721	21789	5	applied	\N	\N	\N	\N	68414	68414	68415
16721	21790	6	applied	\N	\N	\N	\N	68416	68416	68417
16721	21797	7	applied	\N	\N	\N	\N	68435	68435	68436
16721	21396	8	applied	\N	\N	\N	\N	67481	67481	67482
16721	21400	9	applied	\N	\N	\N	\N	67492	67492	67493
16721	21521	10	applied	\N	\N	1000000000	\N	68064	68064	67804
16721	21462	11	applied	\N	\N	1000000000	\N	67623	67623	67624
16721	21578	12	applied	\N	\N	1000000000	\N	67916	67916	67917
16721	21599	13	applied	\N	\N	1000000000	\N	67960	67960	67961
16721	21409	14	applied	\N	\N	\N	\N	67512	67512	67803
16721	21719	15	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16721	21401	16	applied	\N	\N	\N	\N	67494	67494	67495
16721	21407	17	applied	\N	\N	\N	\N	67508	67508	67509
16721	21408	18	applied	\N	\N	\N	\N	67510	67510	67511
16721	21410	19	applied	\N	\N	\N	\N	67514	67514	67515
16721	21419	20	applied	\N	\N	\N	\N	67530	67530	67531
16721	21423	21	applied	\N	\N	\N	\N	67539	67539	67540
16721	21428	22	applied	\N	\N	\N	\N	67552	67552	67553
16721	21431	23	applied	\N	\N	\N	\N	67557	67557	67558
16721	21435	24	applied	\N	\N	\N	\N	67566	67566	67567
16721	21438	25	applied	\N	\N	\N	\N	67575	67575	67576
16721	21439	26	applied	\N	\N	\N	\N	67577	67577	67578
16721	21440	27	applied	\N	\N	\N	\N	67579	67579	67580
16721	21448	28	applied	\N	\N	\N	\N	67593	67593	67594
16721	21450	29	applied	\N	\N	\N	\N	67598	67598	67638
16721	21451	30	applied	\N	\N	\N	\N	67600	67600	67639
16721	21457	31	applied	\N	\N	\N	\N	67614	67614	67640
16721	21460	32	applied	\N	\N	\N	\N	67619	67619	67641
16721	21461	33	applied	\N	\N	\N	\N	67621	67621	67642
16721	21468	34	applied	\N	\N	\N	\N	67676	67676	69140
16721	21471	35	applied	\N	\N	\N	\N	67684	67684	69141
16721	21474	36	applied	\N	\N	\N	\N	67692	67692	69142
16721	21475	37	applied	\N	\N	\N	\N	67694	67694	69143
16721	21476	38	applied	\N	\N	\N	\N	67696	67696	69144
16721	21484	39	applied	\N	\N	\N	\N	67710	67710	69145
16721	21488	40	applied	\N	\N	\N	\N	67720	67720	69146
16721	21491	41	applied	\N	\N	\N	\N	67726	67726	69147
16721	21493	42	applied	\N	\N	\N	\N	67733	67733	69148
16721	21496	43	applied	\N	\N	\N	\N	67739	67739	69149
16721	21500	44	applied	\N	\N	\N	\N	67751	67751	69150
16721	21503	45	applied	\N	\N	\N	\N	67762	67762	69151
16721	21506	46	applied	\N	\N	\N	\N	67772	67772	69152
16721	21510	47	applied	\N	\N	\N	\N	67779	67779	69153
16721	21513	48	applied	\N	\N	\N	\N	67785	67785	69154
16721	21516	49	applied	\N	\N	\N	\N	67793	67793	69155
16721	21520	50	applied	\N	\N	\N	\N	67801	67801	69156
16721	21522	51	applied	\N	\N	\N	\N	67805	67805	69157
16721	21523	52	applied	\N	\N	\N	\N	67808	67808	69158
16721	21524	53	applied	\N	\N	\N	\N	67810	67810	69159
16721	21534	54	applied	\N	\N	\N	\N	67828	67828	69160
16721	21537	55	applied	\N	\N	\N	\N	67842	67842	69161
16721	21540	57	applied	\N	\N	\N	\N	67848	67848	69163
16721	21545	58	applied	\N	\N	\N	\N	67856	67856	69164
16721	21548	59	applied	\N	\N	\N	\N	67865	67865	69165
16721	21549	60	applied	\N	\N	\N	\N	67867	67867	69166
16721	21554	61	applied	\N	\N	\N	\N	67876	67876	69167
16721	21559	62	applied	\N	\N	\N	\N	67885	67885	69168
16721	21560	63	applied	\N	\N	\N	\N	67887	67887	69169
16721	21561	64	applied	\N	\N	\N	\N	67889	67889	69170
16721	21571	65	applied	\N	\N	\N	\N	67903	67903	69171
16721	21574	66	applied	\N	\N	\N	\N	67909	67909	69172
16721	21579	67	applied	\N	\N	\N	\N	67918	67918	69173
16721	21582	68	applied	\N	\N	\N	\N	67924	67924	69174
16721	21585	69	applied	\N	\N	\N	\N	67933	67933	69175
16721	21586	70	applied	\N	\N	\N	\N	67935	67935	69176
16721	21587	71	applied	\N	\N	\N	\N	67937	67937	69177
16721	21593	72	applied	\N	\N	\N	\N	67948	67948	69178
16721	21596	73	applied	\N	\N	\N	\N	67954	67954	69179
16721	21597	74	applied	\N	\N	\N	\N	67956	67956	69180
16721	21598	75	applied	\N	\N	\N	\N	67958	67958	69181
16721	21607	76	applied	\N	\N	\N	\N	67975	67975	69182
16721	21608	77	applied	\N	\N	\N	\N	67977	67977	69183
16721	21614	78	applied	\N	\N	\N	\N	67990	67990	69184
16721	21615	79	applied	\N	\N	\N	\N	67992	67992	69185
16721	21616	80	applied	\N	\N	\N	\N	67994	67994	69186
16721	21617	81	applied	\N	\N	\N	\N	67996	67996	69187
16721	21618	82	applied	\N	\N	\N	\N	67999	67999	69188
16721	21630	83	applied	\N	\N	\N	\N	68018	68018	69189
16721	21634	84	applied	\N	\N	\N	\N	68036	68036	69190
16721	21637	85	applied	\N	\N	\N	\N	68047	68047	69191
16721	21640	86	applied	\N	\N	\N	\N	68055	68055	69192
16721	21644	87	applied	\N	\N	\N	\N	68068	68068	69193
16721	21647	88	applied	\N	\N	\N	\N	68075	68075	69194
16721	21648	89	applied	\N	\N	\N	\N	68077	68077	69195
16721	21652	90	applied	\N	\N	\N	\N	68086	68086	69196
16705	22053	6	applied	\N	\N	\N	\N	69045	69045	57418
16706	22047	0	applied	\N	\N	\N	\N	69034	69034	69035
16706	22048	1	applied	\N	\N	\N	\N	69036	69036	69037
16706	22049	2	applied	\N	\N	\N	\N	69038	69038	69039
16706	22050	3	applied	\N	\N	\N	\N	69040	69040	57414
16706	22051	4	applied	\N	\N	\N	\N	69041	69041	69042
16706	22052	5	applied	\N	\N	\N	\N	69043	69043	69044
16706	22053	6	applied	\N	\N	\N	\N	69045	69045	57418
16711	22067	0	applied	\N	\N	\N	\N	69109	69109	69110
16711	22068	1	applied	\N	\N	\N	\N	69111	69111	57479
16711	22069	2	applied	\N	\N	\N	\N	69112	69112	69113
16714	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16714	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16714	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16716	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16716	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16716	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16720	22073	0	applied	\N	\N	\N	\N	69129	69129	69130
16720	22074	1	applied	\N	\N	\N	\N	69131	69131	69132
16720	22075	2	applied	\N	\N	\N	\N	69133	69133	57490
16720	22076	3	applied	\N	\N	\N	\N	69134	69134	57497
16720	22077	4	applied	\N	\N	\N	\N	69135	69135	57499
16720	22078	5	applied	\N	\N	\N	\N	69136	69136	69137
16720	22079	6	applied	\N	\N	\N	\N	69138	69138	57501
16722	22040	0	applied	\N	\N	\N	\N	69014	69014	69015
16722	22044	1	applied	\N	\N	\N	\N	69024	69024	69025
16722	22047	2	applied	\N	\N	\N	\N	69034	69034	69035
16722	22048	3	applied	\N	\N	\N	\N	69036	69036	69037
16722	22054	4	applied	\N	\N	\N	\N	69078	69078	69079
16722	22057	5	applied	\N	\N	\N	\N	69090	69090	69091
16722	22058	6	applied	\N	\N	\N	\N	69092	69092	69093
16722	22059	7	applied	\N	\N	\N	\N	69094	69094	69095
16722	22067	8	applied	\N	\N	\N	\N	69109	69109	69110
16722	22070	9	applied	\N	\N	\N	\N	69114	69114	69115
16722	22073	10	applied	\N	\N	\N	\N	69129	69129	69130
16722	22074	11	applied	\N	\N	\N	\N	69131	69131	69132
16722	22080	12	applied	\N	\N	\N	\N	69232	69232	69233
16722	22041	13	applied	\N	\N	\N	\N	69016	69016	57388
16722	22042	14	applied	\N	\N	\N	\N	69017	69017	57394
16722	22045	15	applied	\N	\N	\N	\N	69026	69026	57400
16722	22046	16	applied	\N	\N	\N	\N	69028	69028	57402
16722	22049	17	applied	\N	\N	\N	\N	69038	69038	69234
16722	22050	18	applied	\N	\N	\N	\N	69040	69040	69235
16722	22051	19	applied	\N	\N	\N	\N	69041	69041	69236
16722	22052	20	applied	\N	\N	\N	\N	69043	69043	57416
16722	22055	21	applied	\N	\N	\N	\N	69080	69080	69237
16722	22043	22	applied	\N	\N	\N	\N	69018	69018	69238
16722	22053	23	applied	\N	\N	\N	\N	69045	69045	57420
16722	22062	24	applied	\N	\N	\N	\N	69098	69098	69239
16722	22079	25	applied	\N	\N	\N	\N	69138	69138	57426
16722	22064	26	applied	\N	\N	\N	\N	69102	69102	69240
16722	22065	27	applied	\N	\N	\N	\N	69103	69103	57451
16722	22066	28	applied	\N	\N	\N	\N	69105	69105	69241
16722	22068	29	applied	\N	\N	\N	\N	69111	69111	57467
16722	22072	30	applied	\N	\N	\N	\N	69118	69118	69242
16722	22075	31	applied	\N	\N	\N	\N	69133	69133	69243
16722	22076	32	applied	\N	\N	\N	\N	69134	69134	69113
16722	22081	33	applied	\N	\N	\N	\N	69244	69244	57483
16722	22056	34	applied	\N	\N	\N	\N	69081	69081	69119
16722	22060	35	applied	\N	\N	\N	\N	69096	69096	69245
16722	22061	36	applied	\N	\N	\N	\N	69097	69097	69246
16722	22063	37	applied	\N	\N	\N	\N	69100	69100	57497
16722	22069	38	applied	\N	\N	\N	\N	69112	69112	57499
16722	22071	39	applied	\N	\N	\N	\N	69116	69116	69137
16722	22077	40	applied	\N	\N	\N	\N	69135	69135	69247
16722	22078	41	applied	\N	\N	\N	\N	69136	69136	69248
16722	22082	42	applied	\N	\N	\N	\N	69249	69249	57512
16725	22087	0	applied	\N	\N	\N	\N	69262	69262	69263
16725	22088	1	applied	\N	\N	\N	\N	69264	69264	69265
16725	22089	2	applied	\N	\N	\N	\N	69266	69266	57535
16725	22090	3	applied	\N	\N	\N	\N	69267	69267	69268
16725	22091	4	applied	\N	\N	\N	\N	69269	69269	69270
16731	22095	0	applied	\N	\N	\N	\N	69284	69284	69285
16731	22096	1	applied	\N	\N	\N	\N	69286	69286	57545
16733	22097	0	applied	\N	\N	\N	\N	69289	69289	69290
16733	22098	1	applied	\N	\N	\N	\N	69291	69291	69292
16733	22099	2	applied	\N	\N	\N	\N	69293	69293	57549
16738	22104	0	applied	\N	\N	\N	\N	69307	69307	69308
16738	22105	1	applied	\N	\N	\N	\N	69309	69309	69310
16738	22106	2	applied	\N	\N	\N	\N	69311	69311	69312
16738	22107	3	applied	\N	\N	\N	\N	69313	69313	57568
16738	22108	4	applied	\N	\N	\N	\N	69314	69314	69315
16748	22117	0	applied	\N	\N	\N	\N	69343	69343	69344
16748	22118	1	applied	\N	\N	\N	\N	69345	69345	69346
16748	22119	2	applied	\N	\N	\N	\N	69347	69347	69348
16748	22120	3	applied	\N	\N	\N	\N	69349	69349	69350
16748	22121	4	applied	\N	\N	\N	\N	69351	69351	69352
16748	22122	5	applied	\N	\N	\N	\N	69353	69353	57601
16748	22123	6	applied	\N	\N	\N	\N	69354	69354	57606
16748	22124	7	applied	\N	\N	\N	\N	69355	69355	69356
16748	22125	8	applied	\N	\N	\N	\N	69357	69357	69358
16748	22126	9	applied	\N	\N	\N	\N	69359	69359	57626
16753	22134	0	applied	\N	\N	\N	\N	69381	69381	69382
16753	22135	1	applied	\N	\N	\N	\N	69383	69383	57642
16753	22136	2	applied	\N	\N	\N	\N	69384	69384	69385
16757	22140	0	applied	\N	\N	\N	\N	69439	69439	69440
16757	22141	1	applied	\N	\N	\N	\N	69441	69441	69442
16757	22142	2	applied	\N	\N	\N	\N	69443	69443	69444
16762	22143	0	applied	\N	\N	\N	\N	69451	69451	69452
16762	22144	1	applied	\N	\N	\N	\N	69453	69453	57675
16762	22145	2	applied	\N	\N	\N	\N	69454	69454	57678
16768	22151	0	applied	\N	\N	\N	\N	69490	69490	69491
16768	22152	1	applied	\N	\N	\N	\N	69492	69492	69493
16768	22153	2	applied	\N	\N	\N	\N	69494	69494	57698
16768	22154	3	applied	\N	\N	\N	\N	69495	69495	57700
16777	22181	0	applied	\N	\N	\N	\N	69563	69563	69564
16777	22182	1	applied	\N	\N	\N	\N	69565	69565	69566
16777	22183	2	applied	\N	\N	\N	\N	69567	69567	69568
16777	22184	3	applied	\N	\N	\N	\N	69569	69569	69570
16777	22185	4	applied	\N	\N	\N	\N	69571	69571	69572
16777	22186	5	applied	\N	\N	\N	\N	69573	69573	69574
16777	22187	6	applied	\N	\N	\N	\N	69575	69575	69576
16783	22194	0	applied	\N	\N	\N	\N	69589	69589	69590
16783	22195	1	applied	\N	\N	\N	\N	69591	69591	69592
16783	22196	2	applied	\N	\N	\N	\N	69593	69593	57816
16783	22197	3	applied	\N	\N	\N	\N	69594	69594	69595
16783	22198	4	applied	\N	\N	\N	\N	69596	69596	69597
16783	22199	5	applied	\N	\N	\N	\N	69598	69598	57831
16783	22200	6	applied	\N	\N	\N	\N	69599	69599	69600
16785	22201	0	applied	\N	\N	\N	\N	69628	69628	69629
16707	21857	90	applied	\N	\N	\N	\N	68609	68609	69062
16707	21875	91	applied	\N	\N	\N	\N	68648	68648	68586
16707	21885	92	applied	\N	\N	\N	\N	68670	68670	56703
16707	21891	93	applied	\N	\N	\N	\N	68684	68684	68587
16707	21908	94	applied	\N	\N	\N	\N	68725	68725	56705
16707	21913	95	applied	\N	\N	\N	\N	68736	68736	56707
16707	21927	96	applied	\N	\N	\N	\N	68770	68770	69063
16707	21938	97	applied	\N	\N	\N	\N	68800	68800	68429
16707	21950	98	applied	\N	\N	\N	\N	68827	68827	56719
16707	21954	99	applied	\N	\N	\N	\N	68835	68835	69064
16707	21968	100	applied	\N	\N	\N	\N	68862	68862	56721
16707	21977	101	applied	\N	\N	\N	\N	68876	68876	56723
16707	21989	102	applied	\N	\N	\N	\N	68909	68909	69065
16707	22004	103	applied	\N	\N	\N	\N	68935	68935	68445
16707	22011	104	applied	\N	\N	\N	\N	68948	68948	56725
16707	22023	105	applied	\N	\N	\N	\N	68980	68980	68453
16707	22034	106	applied	\N	\N	\N	\N	69001	69001	56727
16707	22043	107	applied	\N	\N	\N	\N	69018	69018	56729
16707	22053	108	applied	\N	\N	\N	\N	69045	69045	68455
16707	21835	109	applied	\N	\N	\N	\N	68534	68534	56731
16707	21840	110	applied	\N	\N	\N	\N	68552	68552	56733
16707	21843	111	applied	\N	\N	\N	\N	68562	68562	69066
16707	21847	112	applied	\N	\N	\N	\N	68569	68569	56741
16707	21850	113	applied	\N	\N	\N	\N	68576	68576	56743
16707	21853	114	applied	\N	\N	\N	\N	68597	68597	69067
16707	21858	115	applied	\N	\N	\N	\N	68610	68610	56754
16707	21861	116	applied	\N	\N	\N	\N	68617	68617	56756
16707	21868	117	applied	\N	\N	\N	\N	68634	68634	68503
16707	21871	118	applied	\N	\N	\N	\N	68640	68640	56760
16707	21877	119	applied	\N	\N	\N	\N	68651	68651	56762
16707	21878	120	applied	\N	\N	\N	\N	68653	68653	69068
16707	21881	121	applied	\N	\N	\N	\N	68661	68661	56770
16707	21884	122	applied	\N	\N	\N	\N	68668	68668	68591
16710	22057	0	applied	\N	\N	\N	\N	69090	69090	69091
16710	22058	1	applied	\N	\N	\N	\N	69092	69092	69093
16710	22059	2	applied	\N	\N	\N	\N	69094	69094	69095
16710	22060	3	applied	\N	\N	\N	\N	69096	69096	57437
16710	22061	4	applied	\N	\N	\N	\N	69097	69097	57445
16710	22062	5	applied	\N	\N	\N	\N	69098	69098	69099
16710	22063	6	applied	\N	\N	\N	\N	69100	69100	69101
16710	22064	7	applied	\N	\N	\N	\N	69102	69102	57459
16710	22065	8	applied	\N	\N	\N	\N	69103	69103	69104
16710	22066	9	applied	\N	\N	\N	\N	69105	69105	69106
16719	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16719	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16719	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16724	22080	0	applied	\N	\N	\N	\N	69232	69232	69233
16724	22083	1	applied	\N	\N	\N	\N	69252	69252	69253
16724	22082	2	applied	\N	\N	\N	\N	69249	69249	57503
16724	22084	3	applied	\N	\N	\N	\N	69254	69254	69255
16724	22085	4	applied	\N	\N	\N	\N	69256	69256	57512
16724	22081	5	applied	\N	\N	\N	\N	69244	69244	57520
16724	22086	6	applied	\N	\N	\N	\N	69257	69257	69258
16730	22095	0	applied	\N	\N	\N	\N	69284	69284	69285
16730	22096	1	applied	\N	\N	\N	\N	69286	69286	57545
16732	22097	0	applied	\N	\N	\N	\N	69289	69289	69290
16732	22098	1	applied	\N	\N	\N	\N	69291	69291	69292
16732	22099	2	applied	\N	\N	\N	\N	69293	69293	57549
16735	22100	0	applied	\N	\N	\N	\N	69297	69297	69298
16735	22101	1	applied	\N	\N	\N	\N	69299	69299	69300
16735	22102	2	applied	\N	\N	\N	\N	69301	69301	57564
16735	22103	3	applied	\N	\N	\N	\N	69302	69302	69302
16737	22104	0	applied	\N	\N	\N	\N	69307	69307	69308
16737	22105	1	applied	\N	\N	\N	\N	69309	69309	69310
16737	22106	2	applied	\N	\N	\N	\N	69311	69311	69312
16737	22107	3	applied	\N	\N	\N	\N	69313	69313	57568
16737	22108	4	applied	\N	\N	\N	\N	69314	69314	69315
16742	22109	0	applied	\N	\N	\N	\N	69322	69322	69323
16742	22110	1	applied	\N	\N	\N	\N	69324	69324	69325
16742	22111	2	applied	\N	\N	\N	\N	69326	69326	69327
16742	22112	3	applied	\N	\N	\N	\N	69328	69328	69328
16742	22113	4	applied	\N	\N	\N	\N	69329	69329	57570
16742	22114	5	applied	\N	\N	\N	\N	69330	69330	57572
16742	22115	6	applied	\N	\N	\N	\N	69331	69331	57579
16742	22116	7	applied	\N	\N	\N	\N	69332	69332	69333
16747	22117	0	applied	\N	\N	\N	\N	69343	69343	69344
16747	22118	1	applied	\N	\N	\N	\N	69345	69345	69346
16747	22119	2	applied	\N	\N	\N	\N	69347	69347	69348
16747	22120	3	applied	\N	\N	\N	\N	69349	69349	69350
16747	22121	4	applied	\N	\N	\N	\N	69351	69351	69352
16747	22122	5	applied	\N	\N	\N	\N	69353	69353	57601
16747	22123	6	applied	\N	\N	\N	\N	69354	69354	57606
16747	22124	7	applied	\N	\N	\N	\N	69355	69355	69356
16747	22125	8	applied	\N	\N	\N	\N	69357	69357	69358
16747	22126	9	applied	\N	\N	\N	\N	69359	69359	57626
16751	22127	0	applied	\N	\N	\N	\N	69364	69364	69365
16751	22128	1	applied	\N	\N	\N	\N	69366	69366	69367
16751	22129	2	applied	\N	\N	\N	\N	69368	69368	57628
16751	22130	3	applied	\N	\N	\N	\N	69369	69369	69370
16755	22137	0	applied	\N	\N	\N	\N	69389	69389	69390
16755	22138	1	applied	\N	\N	\N	\N	69391	69391	69392
16755	22139	2	applied	\N	\N	\N	\N	69393	69393	69394
16760	22140	0	applied	\N	\N	\N	\N	69439	69439	69440
16760	22141	1	applied	\N	\N	\N	\N	69441	69441	69442
16760	22142	2	applied	\N	\N	\N	\N	69443	69443	69444
16761	22143	0	applied	\N	\N	\N	\N	69451	69451	69452
16761	22144	1	applied	\N	\N	\N	\N	69453	69453	57675
16761	22145	2	applied	\N	\N	\N	\N	69454	69454	57678
16766	22149	0	applied	\N	\N	\N	\N	69463	69463	69464
16766	22150	1	applied	\N	\N	\N	\N	69465	69465	69466
16771	22158	0	applied	\N	\N	\N	\N	69502	69502	69503
16771	22159	1	applied	\N	\N	\N	\N	69504	69504	69505
16771	22160	2	applied	\N	\N	\N	\N	69506	69506	69507
16771	22161	3	applied	\N	\N	\N	\N	69508	69508	57720
16771	22162	4	applied	\N	\N	\N	\N	69509	69509	57724
16771	22163	5	applied	\N	\N	\N	\N	69510	69510	57726
16771	22164	6	applied	\N	\N	\N	\N	69511	69511	69512
16772	21854	0	applied	\N	\N	\N	\N	68604	68604	68605
16772	21864	1	applied	\N	\N	\N	\N	68626	68626	68627
16772	21865	2	applied	\N	\N	\N	\N	68628	68628	68629
16772	21866	3	applied	\N	\N	\N	\N	68630	68630	68631
16772	21855	4	applied	\N	\N	\N	\N	68606	68606	68607
16772	21860	5	applied	\N	\N	\N	\N	68615	68615	68616
16772	21867	6	applied	\N	\N	\N	\N	68632	68632	68633
16772	21870	7	applied	\N	\N	\N	\N	68638	68638	68639
16772	21873	8	applied	\N	\N	\N	\N	68644	68644	68645
16772	21874	9	applied	\N	\N	\N	\N	68646	68646	68647
16772	21880	10	applied	\N	\N	\N	\N	68659	68659	68660
16772	21883	11	applied	\N	\N	\N	\N	68666	68666	68667
16772	22105	12	applied	\N	\N	\N	\N	69338	69338	69310
16709	21959	69	applied	\N	\N	\N	\N	68845	68845	68846
16709	21962	70	applied	\N	\N	\N	\N	68851	68851	68852
16709	21965	71	applied	\N	\N	\N	\N	68856	68856	68857
16709	21966	72	applied	\N	\N	\N	\N	68858	68858	68859
16709	21967	73	applied	\N	\N	\N	\N	68860	68860	68861
16709	21975	74	applied	\N	\N	\N	\N	68872	68872	68873
16709	21976	75	applied	\N	\N	\N	\N	68874	68874	68875
16709	21982	76	applied	\N	\N	\N	\N	68890	68890	68891
16709	21984	77	applied	\N	\N	\N	\N	68899	68899	68900
16709	21985	78	applied	\N	\N	\N	\N	68901	68901	68902
16709	21986	79	applied	\N	\N	\N	\N	68903	68903	68904
16709	21987	80	applied	\N	\N	\N	\N	68905	68905	68906
16709	21988	81	applied	\N	\N	\N	\N	68907	68907	68908
16709	22000	82	applied	\N	\N	\N	\N	68927	68927	68928
16709	22001	83	applied	\N	\N	\N	\N	68929	68929	68930
16709	22007	84	applied	\N	\N	\N	\N	68941	68941	68942
16709	22008	85	applied	\N	\N	\N	\N	68943	68943	68944
16709	22014	86	applied	\N	\N	\N	\N	68959	68959	68960
16709	22017	87	applied	\N	\N	\N	\N	68967	68967	69050
16709	22019	88	applied	\N	\N	\N	\N	68974	68974	69051
16709	22020	89	applied	\N	\N	\N	\N	68976	68976	69052
16709	22028	90	applied	\N	\N	\N	\N	68988	68988	69053
16709	22031	91	applied	\N	\N	\N	\N	68995	68995	69054
16709	22035	92	applied	\N	\N	\N	\N	69003	69003	69055
16709	22038	93	applied	\N	\N	\N	\N	69009	69009	69056
16709	22040	94	applied	\N	\N	\N	\N	69014	69014	69057
16709	22044	95	applied	\N	\N	\N	\N	69024	69024	69058
16709	22047	96	applied	\N	\N	\N	\N	69034	69034	69059
16709	22048	97	applied	\N	\N	\N	\N	69036	69036	69060
16709	22054	98	applied	\N	\N	\N	\N	69078	69078	69083
16709	21856	99	applied	\N	\N	\N	\N	68608	68608	62660
16709	21759	100	applied	\N	\N	\N	\N	68344	68344	56604
16709	21774	101	applied	\N	\N	\N	\N	68380	68380	68582
16709	21786	102	applied	\N	\N	\N	\N	68408	68408	56606
16709	21800	103	applied	\N	\N	\N	\N	68442	68442	56625
16709	21813	104	applied	\N	\N	\N	\N	68493	68493	68583
16709	21760	105	applied	\N	\N	\N	\N	68345	68345	68584
16709	21761	106	applied	\N	\N	\N	\N	68346	68346	68349
16709	21762	107	applied	\N	\N	\N	\N	68347	68347	68374
16709	21763	108	applied	\N	\N	\N	\N	68348	68348	56631
16709	21768	109	applied	\N	\N	\N	\N	68362	68362	56616
16709	21769	110	applied	\N	\N	\N	\N	68364	68364	68363
16709	21775	111	applied	\N	\N	\N	\N	68381	68381	68365
16709	21780	112	applied	\N	\N	\N	\N	68394	68394	69084
16709	21783	113	applied	\N	\N	\N	\N	68400	68400	56642
16709	21787	114	applied	\N	\N	\N	\N	68409	68409	56656
16709	21792	115	applied	\N	\N	\N	\N	68420	68420	69085
16709	21796	116	applied	\N	\N	\N	\N	68428	68428	69086
16709	21801	117	applied	\N	\N	\N	\N	68443	68443	68383
16709	21804	118	applied	\N	\N	\N	\N	68452	68452	56662
16709	21863	119	applied	\N	\N	\N	\N	68620	68620	62660
16709	21825	120	applied	\N	\N	\N	\N	68517	68517	68385
16709	21837	121	applied	\N	\N	\N	\N	68546	68546	56669
16709	21844	122	applied	\N	\N	\N	\N	68563	68563	68395
16709	21857	123	applied	\N	\N	\N	\N	68609	68609	69087
16709	21875	124	applied	\N	\N	\N	\N	68648	68648	56675
16709	21885	125	applied	\N	\N	\N	\N	68670	68670	68397
16713	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16715	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16715	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16715	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16718	22070	0	applied	\N	\N	\N	\N	69114	69114	69115
16718	22071	2	applied	\N	\N	\N	\N	69116	69116	69117
16718	22072	3	applied	\N	\N	\N	\N	69118	69118	69119
16727	22087	0	applied	\N	\N	\N	\N	69262	69262	69263
16727	22088	1	applied	\N	\N	\N	\N	69264	69264	69265
16727	22089	2	applied	\N	\N	\N	\N	69266	69266	57535
16727	22090	3	applied	\N	\N	\N	\N	69267	69267	69268
16727	22091	4	applied	\N	\N	\N	\N	69269	69269	69270
16728	22092	0	applied	\N	\N	\N	\N	69276	69276	69277
16728	22093	1	applied	\N	\N	\N	\N	69278	69278	69279
16728	22094	2	applied	\N	\N	\N	\N	69280	69280	69281
16734	22100	0	applied	\N	\N	\N	\N	69297	69297	69298
16734	22101	1	applied	\N	\N	\N	\N	69299	69299	69300
16734	22102	2	applied	\N	\N	\N	\N	69301	69301	57564
16734	22103	3	applied	\N	\N	\N	\N	69302	69302	69302
16736	22104	0	applied	\N	\N	\N	\N	69307	69307	69308
16736	22105	1	applied	\N	\N	\N	\N	69309	69309	69310
16736	22106	2	applied	\N	\N	\N	\N	69311	69311	69312
16736	22107	3	applied	\N	\N	\N	\N	69313	69313	57568
16736	22108	4	applied	\N	\N	\N	\N	69314	69314	69315
16741	22109	0	applied	\N	\N	\N	\N	69322	69322	69323
16741	22110	1	applied	\N	\N	\N	\N	69324	69324	69325
16741	22111	2	applied	\N	\N	\N	\N	69326	69326	69327
16741	22112	3	applied	\N	\N	\N	\N	69328	69328	69328
16741	22113	4	applied	\N	\N	\N	\N	69329	69329	57570
16741	22114	5	applied	\N	\N	\N	\N	69330	69330	57572
16741	22115	6	applied	\N	\N	\N	\N	69331	69331	57579
16741	22116	7	applied	\N	\N	\N	\N	69332	69332	69333
16744	22105	0	applied	\N	\N	\N	\N	69338	69338	69310
16746	22117	0	applied	\N	\N	\N	\N	69343	69343	69344
16746	22118	1	applied	\N	\N	\N	\N	69345	69345	69346
16746	22119	2	applied	\N	\N	\N	\N	69347	69347	69348
16746	22120	3	applied	\N	\N	\N	\N	69349	69349	69350
16746	22121	4	applied	\N	\N	\N	\N	69351	69351	69352
16746	22122	5	applied	\N	\N	\N	\N	69353	69353	57601
16746	22123	6	applied	\N	\N	\N	\N	69354	69354	57606
16746	22124	7	applied	\N	\N	\N	\N	69355	69355	69356
16746	22125	8	applied	\N	\N	\N	\N	69357	69357	69358
16746	22126	9	applied	\N	\N	\N	\N	69359	69359	57626
16750	22127	0	applied	\N	\N	\N	\N	69364	69364	69365
16750	22128	1	applied	\N	\N	\N	\N	69366	69366	69367
16750	22129	2	applied	\N	\N	\N	\N	69368	69368	57628
16750	22130	3	applied	\N	\N	\N	\N	69369	69369	69370
16752	22131	0	applied	\N	\N	\N	\N	69376	69376	69377
16752	22132	1	applied	\N	\N	\N	\N	69378	69378	69379
16752	22133	2	applied	\N	\N	\N	\N	69380	69380	57640
16756	21899	0	applied	\N	\N	\N	\N	68697	68697	68698
16756	21902	1	applied	\N	\N	\N	\N	68707	68707	68708
16756	21905	2	applied	\N	\N	\N	\N	68719	68719	68720
16756	21906	4	applied	\N	\N	\N	\N	68721	68721	68722
16756	21911	5	applied	\N	\N	\N	\N	68732	68732	68733
16756	21912	6	applied	\N	\N	\N	\N	68734	68734	68735
16756	21918	7	applied	\N	\N	\N	\N	68750	68750	68751
16756	21921	8	applied	\N	\N	\N	\N	68758	68758	68759
16756	21924	9	applied	\N	\N	\N	\N	68764	68764	68765
16756	21925	10	applied	\N	\N	\N	\N	68766	68766	68767
16756	21926	11	applied	\N	\N	\N	\N	68768	68768	68769
16756	21933	12	applied	\N	\N	\N	\N	68784	68784	68785
16756	21936	13	applied	\N	\N	\N	\N	68796	68796	68797
16721	21653	91	applied	\N	\N	\N	\N	68088	68088	69197
16721	21659	92	applied	\N	\N	\N	\N	68099	68099	69198
16721	21662	93	applied	\N	\N	\N	\N	68107	68107	69199
16721	21663	94	applied	\N	\N	\N	\N	68109	68109	69200
16721	21738	95	applied	\N	\N	1000000000	\N	68291	68291	68292
16721	21746	96	applied	\N	\N	\N	\N	68309	68309	68292
16721	21669	97	applied	\N	\N	\N	\N	68120	68120	69201
16721	21672	98	applied	\N	\N	\N	\N	68131	68131	69202
16721	21674	99	applied	\N	\N	\N	\N	68135	68135	69203
16721	21675	100	applied	\N	\N	\N	\N	68137	68137	69204
16721	21676	101	applied	\N	\N	\N	\N	68139	68139	69205
16721	21686	102	applied	\N	\N	\N	\N	68164	68164	69206
16721	21691	103	applied	\N	\N	\N	\N	68177	68177	69207
16721	21692	104	applied	\N	\N	\N	\N	68179	68179	69208
16721	21696	105	applied	\N	\N	\N	\N	68186	68186	69209
16721	21697	106	applied	\N	\N	\N	\N	68188	68188	69210
16721	21698	107	applied	\N	\N	\N	\N	68190	68190	69211
16721	21699	108	applied	\N	\N	\N	\N	68192	68192	69212
16721	21709	109	applied	\N	\N	\N	\N	68211	68211	69213
16721	21712	110	applied	\N	\N	\N	\N	68219	68219	69214
16721	21715	111	applied	\N	\N	\N	\N	68228	68228	69215
16721	21718	112	applied	\N	\N	\N	\N	68232	68232	69216
16721	21724	113	applied	\N	\N	\N	\N	68242	68242	69217
16721	21727	114	applied	\N	\N	\N	\N	68247	68247	69218
16721	21731	115	applied	\N	\N	\N	\N	68275	68275	69219
16721	21732	116	applied	\N	\N	\N	\N	68277	68277	69220
16721	21737	117	applied	\N	\N	\N	\N	68289	68289	69221
16721	21741	118	applied	\N	\N	\N	\N	68300	68300	69222
16721	21745	119	applied	\N	\N	\N	\N	68307	68307	69223
16721	21749	120	applied	\N	\N	\N	\N	68318	68318	69224
16721	21752	121	applied	\N	\N	\N	\N	68325	68325	69225
16721	21756	122	applied	\N	\N	\N	\N	68338	68338	69226
16721	21757	123	applied	\N	\N	\N	\N	68340	68340	69227
16721	21758	124	applied	\N	\N	\N	\N	68342	68342	69228
16721	21766	125	applied	\N	\N	\N	\N	68358	68358	69229
16723	22080	0	applied	\N	\N	\N	\N	69232	69232	69233
16723	22083	1	applied	\N	\N	\N	\N	69252	69252	69253
16723	22082	2	applied	\N	\N	\N	\N	69249	69249	57503
16723	22084	3	applied	\N	\N	\N	\N	69254	69254	69255
16723	22085	4	applied	\N	\N	\N	\N	69256	69256	57512
16723	22081	5	applied	\N	\N	\N	\N	69244	69244	57520
16723	22086	6	applied	\N	\N	\N	\N	69257	69257	69258
16726	22087	0	applied	\N	\N	\N	\N	69262	69262	69263
16726	22088	1	applied	\N	\N	\N	\N	69264	69264	69265
16726	22089	2	applied	\N	\N	\N	\N	69266	69266	57535
16726	22090	3	applied	\N	\N	\N	\N	69267	69267	69268
16726	22091	4	applied	\N	\N	\N	\N	69269	69269	69270
16739	22104	0	applied	\N	\N	\N	\N	69307	69307	69308
16739	22105	1	applied	\N	\N	\N	\N	69309	69309	69310
16739	22106	2	applied	\N	\N	\N	\N	69311	69311	69312
16739	22107	3	applied	\N	\N	\N	\N	69313	69313	57568
16739	22108	4	applied	\N	\N	\N	\N	69314	69314	69315
16740	22109	0	applied	\N	\N	\N	\N	69322	69322	69323
16740	22110	1	applied	\N	\N	\N	\N	69324	69324	69325
16740	22111	2	applied	\N	\N	\N	\N	69326	69326	69327
16740	22112	3	applied	\N	\N	\N	\N	69328	69328	69328
16740	22113	4	applied	\N	\N	\N	\N	69329	69329	57570
16740	22114	5	applied	\N	\N	\N	\N	69330	69330	57572
16740	22115	6	applied	\N	\N	\N	\N	69331	69331	57579
16740	22116	7	applied	\N	\N	\N	\N	69332	69332	69333
16743	21122	0	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16743	21243	1	applied	\N	\N	\N	\N	67139	67139	67140
16743	21247	2	applied	\N	\N	\N	\N	67148	67148	67149
16743	21248	3	applied	\N	\N	\N	\N	67150	67150	67151
16743	21254	4	applied	\N	\N	\N	\N	67162	67162	67163
16743	21150	5	applied	\N	\N	1000000000	\N	66960	66960	66961
16743	21166	6	applied	\N	\N	\N	\N	66987	66987	66961
16743	21784	7	applied	\N	\N	\N	\N	68404	68404	68405
16743	21854	8	applied	\N	\N	\N	\N	68604	68604	68605
16743	21864	9	applied	\N	\N	\N	\N	68626	68626	68627
16743	21865	10	applied	\N	\N	\N	\N	68628	68628	68629
16743	21866	11	applied	\N	\N	\N	\N	68630	68630	68631
16743	21789	12	applied	\N	\N	\N	\N	68414	68414	68415
16743	21790	13	applied	\N	\N	\N	\N	68416	68416	68417
16743	21797	14	applied	\N	\N	\N	\N	68435	68435	68436
16743	20857	15	applied	\N	\N	1000000000	\N	66196	66196	66197
16743	20858	16	applied	\N	\N	1000000000	\N	66198	66198	66199
16743	20768	17	applied	\N	\N	\N	\N	65940	65940	65941
16743	20771	18	applied	\N	\N	\N	\N	65948	65948	65949
16743	20774	19	applied	\N	\N	\N	\N	65953	65953	65954
16743	21521	20	applied	\N	\N	1000000000	\N	68064	68064	67804
16743	22105	21	applied	\N	\N	\N	\N	69338	69338	69310
16743	22109	22	applied	\N	\N	\N	\N	69339	69339	69323
16743	20778	23	applied	\N	\N	\N	\N	65962	65962	65963
16743	20781	24	applied	\N	\N	\N	\N	65968	65968	65969
16743	20784	25	applied	\N	\N	\N	\N	65976	65976	65977
16743	20788	26	applied	\N	\N	\N	\N	65989	65989	65990
16743	20790	27	applied	\N	\N	\N	\N	66041	66041	66042
16743	20793	28	applied	\N	\N	\N	\N	66048	66048	66049
16743	20796	29	applied	\N	\N	\N	\N	66056	66056	66057
16743	21409	30	applied	\N	\N	\N	\N	67512	67512	67803
16743	20859	31	applied	\N	\N	1000000000	\N	66200	66200	66201
16743	20860	32	applied	\N	\N	1000000000	\N	66202	66202	66203
16743	21337	33	applied	\N	\N	1000000000	\N	67343	67343	67344
16743	21462	34	applied	\N	\N	1000000000	\N	67623	67623	67624
16743	21578	35	applied	\N	\N	1000000000	\N	67916	67916	67917
16743	21599	36	applied	\N	\N	1000000000	\N	67960	67960	67961
16743	21719	37	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16743	20802	38	applied	\N	\N	\N	\N	66072	66072	66073
16743	20803	39	applied	\N	\N	\N	\N	66074	66074	66075
16743	20804	40	applied	\N	\N	\N	\N	66076	66076	66077
16743	20813	41	applied	\N	\N	\N	\N	66094	66094	66095
16743	20817	42	applied	\N	\N	\N	\N	66104	66104	66105
16743	20818	43	applied	\N	\N	\N	\N	66106	66106	66107
16743	20824	44	applied	\N	\N	\N	\N	66118	66118	66119
16743	20825	45	applied	\N	\N	\N	\N	66120	66120	66121
16743	20831	46	applied	\N	\N	\N	\N	66131	66131	66132
16743	20835	47	applied	\N	\N	\N	\N	66140	66140	66141
16743	20836	48	applied	\N	\N	\N	\N	66142	66142	66143
16743	20841	49	applied	\N	\N	\N	\N	66151	66151	66152
16743	20845	50	applied	\N	\N	\N	\N	66161	66161	66162
16743	20848	51	applied	\N	\N	\N	\N	66169	66169	66170
16743	20852	52	applied	\N	\N	\N	\N	66181	66181	66182
16743	20856	53	applied	\N	\N	\N	\N	66194	66194	66195
16743	20867	54	applied	\N	\N	\N	\N	66216	66216	66217
16743	20870	55	applied	\N	\N	\N	\N	66226	66226	66227
16743	20871	56	applied	\N	\N	\N	\N	66228	66228	66229
16743	20877	57	applied	\N	\N	\N	\N	66240	66240	66241
16743	20878	58	applied	\N	\N	\N	\N	66242	66242	66243
16743	20883	59	applied	\N	\N	\N	\N	66254	66254	66255
16743	20884	60	applied	\N	\N	\N	\N	66257	66257	66258
16743	20889	61	applied	\N	\N	\N	\N	66269	66269	66270
16743	20892	62	applied	\N	\N	\N	\N	66277	66277	66278
16743	20896	63	applied	\N	\N	\N	\N	66284	66284	66285
16743	20899	64	applied	\N	\N	\N	\N	66290	66290	66291
16743	20901	65	applied	\N	\N	\N	\N	66295	66295	66296
16743	20904	66	applied	\N	\N	\N	\N	66302	66302	66303
16743	20908	67	applied	\N	\N	\N	\N	66312	66312	66313
16743	20912	69	applied	\N	\N	\N	\N	66323	66323	66324
16743	20915	70	applied	\N	\N	\N	\N	66331	66331	66332
16743	20916	71	applied	\N	\N	\N	\N	66333	66333	66334
16743	20922	72	applied	\N	\N	\N	\N	66345	66345	66346
16743	20925	73	applied	\N	\N	\N	\N	66350	66350	66351
16743	20929	74	applied	\N	\N	\N	\N	66357	66357	66358
16743	20931	75	applied	\N	\N	\N	\N	66361	66361	66362
16743	20935	76	applied	\N	\N	\N	\N	66375	66375	66376
16743	20938	77	applied	\N	\N	\N	\N	66381	66381	66382
16743	20943	78	applied	\N	\N	\N	\N	66400	66400	66401
16743	20946	79	applied	\N	\N	\N	\N	66407	66407	66408
16743	20949	80	applied	\N	\N	\N	\N	66414	66414	66415
16743	20953	81	applied	\N	\N	\N	\N	66423	66423	66424
16743	20955	82	applied	\N	\N	\N	\N	66431	66431	66432
16743	20958	83	applied	\N	\N	\N	\N	66437	66437	66438
16743	20962	84	applied	\N	\N	\N	\N	66444	66444	66445
16743	20965	85	applied	\N	\N	\N	\N	66450	66450	66451
16743	20968	86	applied	\N	\N	\N	\N	66499	66499	66500
16743	20971	87	applied	\N	\N	\N	\N	66509	66509	66510
16743	20972	88	applied	\N	\N	\N	\N	66511	66511	66512
16743	20978	89	applied	\N	\N	\N	\N	66526	66526	66527
16743	20979	90	applied	\N	\N	\N	\N	66528	66528	66529
16743	20985	91	applied	\N	\N	\N	\N	66541	66541	66542
16743	20988	92	applied	\N	\N	\N	\N	66551	66551	66552
16743	20989	93	applied	\N	\N	\N	\N	66553	66553	66554
16743	20995	94	applied	\N	\N	\N	\N	66563	66563	66564
16743	20998	95	applied	\N	\N	\N	\N	66569	66569	66570
16743	20999	96	applied	\N	\N	\N	\N	66571	66571	66572
16743	21000	97	applied	\N	\N	\N	\N	66573	66573	66574
16743	21001	98	applied	\N	\N	\N	\N	66575	66575	66576
16743	21011	99	applied	\N	\N	\N	\N	66589	66589	66590
16743	21012	100	applied	\N	\N	\N	\N	66591	66591	66592
16743	21019	101	applied	\N	\N	\N	\N	66605	66605	66606
16743	21022	102	applied	\N	\N	\N	\N	66613	66613	66614
16743	21025	103	applied	\N	\N	\N	\N	66619	66619	66620
16743	21029	104	applied	\N	\N	\N	\N	66630	66630	66631
16743	21032	105	applied	\N	\N	\N	\N	66641	66641	66642
16743	21035	106	applied	\N	\N	\N	\N	66652	66652	66653
16743	21037	107	applied	\N	\N	\N	\N	66656	66656	66657
16743	21041	108	applied	\N	\N	\N	\N	66720	66720	66721
16743	21042	109	applied	\N	\N	\N	\N	66722	66722	66723
16743	21047	110	applied	\N	\N	\N	\N	66730	66730	66731
16743	21051	111	applied	\N	\N	\N	\N	66740	66740	66741
16743	21054	112	applied	\N	\N	\N	\N	66746	66746	66747
16743	21057	113	applied	\N	\N	\N	\N	66756	66756	66757
16743	21060	114	applied	\N	\N	\N	\N	66763	66763	66764
16743	21063	115	applied	\N	\N	\N	\N	66772	66772	66773
16743	21066	116	applied	\N	\N	\N	\N	66793	66793	66794
16743	21069	117	applied	\N	\N	\N	\N	66800	66800	66801
16743	21070	118	applied	\N	\N	\N	\N	66802	66802	66803
16743	21076	119	applied	\N	\N	\N	\N	66819	66819	66820
16743	21079	120	applied	\N	\N	\N	\N	66825	66825	66826
16743	21083	121	applied	\N	\N	\N	\N	66831	66831	66832
16743	21738	122	applied	\N	\N	1000000000	\N	68334	68334	68292
16743	21746	123	applied	\N	\N	\N	\N	68335	68335	68292
16743	21084	124	applied	\N	\N	\N	\N	66833	66833	66834
16743	21090	125	applied	\N	\N	\N	\N	66842	66842	66843
16745	22117	0	applied	\N	\N	\N	\N	69343	69343	69344
16745	22118	1	applied	\N	\N	\N	\N	69345	69345	69346
16745	22119	2	applied	\N	\N	\N	\N	69347	69347	69348
16745	22120	3	applied	\N	\N	\N	\N	69349	69349	69350
16745	22121	4	applied	\N	\N	\N	\N	69351	69351	69352
16745	22122	5	applied	\N	\N	\N	\N	69353	69353	57601
16745	22123	6	applied	\N	\N	\N	\N	69354	69354	57606
16745	22124	7	applied	\N	\N	\N	\N	69355	69355	69356
16745	22125	8	applied	\N	\N	\N	\N	69357	69357	69358
16745	22126	9	applied	\N	\N	\N	\N	69359	69359	57626
16749	22127	0	applied	\N	\N	\N	\N	69364	69364	69365
16749	22128	1	applied	\N	\N	\N	\N	69366	69366	69367
16749	22129	2	applied	\N	\N	\N	\N	69368	69368	57628
16749	22130	3	applied	\N	\N	\N	\N	69369	69369	69370
16754	22134	0	applied	\N	\N	\N	\N	69381	69381	69382
16754	22135	1	applied	\N	\N	\N	\N	69383	69383	57642
16754	22136	2	applied	\N	\N	\N	\N	69384	69384	69385
16758	22140	0	applied	\N	\N	\N	\N	69439	69439	69440
16758	22141	1	applied	\N	\N	\N	\N	69441	69441	69442
16758	22142	2	applied	\N	\N	\N	\N	69443	69443	69444
16763	22143	0	applied	\N	\N	\N	\N	69451	69451	69452
16763	22144	1	applied	\N	\N	\N	\N	69453	69453	57675
16763	22145	2	applied	\N	\N	\N	\N	69454	69454	57678
16764	22146	0	applied	\N	\N	\N	\N	69459	69459	69460
16764	22147	1	applied	\N	\N	\N	\N	69461	69461	57684
16764	22148	2	applied	\N	\N	\N	\N	69462	69462	57690
16767	22137	0	applied	\N	\N	\N	\N	69389	69389	69469
16767	22143	1	applied	\N	\N	\N	\N	69451	69451	69470
16767	22146	2	applied	\N	\N	\N	\N	69459	69459	69471
16767	22149	4	applied	\N	\N	\N	\N	69463	69463	69473
16767	21611	5	applied	\N	\N	\N	\N	67982	67982	69474
16767	21620	6	applied	\N	\N	\N	\N	68002	68002	56064
16767	21622	7	applied	\N	\N	\N	\N	68005	68005	67922
16767	21623	8	applied	\N	\N	\N	\N	68007	68007	69475
16767	21628	9	applied	\N	\N	\N	\N	68012	68012	56074
16767	21643	10	applied	\N	\N	\N	\N	68061	68061	67928
16767	21657	11	applied	\N	\N	\N	\N	68095	68095	69476
16767	21667	12	applied	\N	\N	\N	\N	68114	68114	56076
16767	21677	13	applied	\N	\N	\N	\N	68141	68141	69477
16767	21688	14	applied	\N	\N	\N	\N	68168	68168	56078
16767	21702	15	applied	\N	\N	\N	\N	68198	68198	56080
16767	21629	16	applied	\N	\N	\N	\N	68014	68014	67942
16767	21633	17	applied	\N	\N	\N	\N	68022	68022	69478
16767	21635	18	applied	\N	\N	\N	\N	68038	68038	56089
16767	21639	19	applied	\N	\N	\N	\N	68051	68051	69479
16767	21641	20	applied	\N	\N	\N	\N	68057	68057	69480
16767	21645	21	applied	\N	\N	\N	\N	68070	68070	56099
16767	21650	22	applied	\N	\N	\N	\N	68081	68081	67963
16767	21655	23	applied	\N	\N	\N	\N	68092	68092	69481
16767	21656	24	applied	\N	\N	\N	\N	68093	68093	56112
16767	21660	25	applied	\N	\N	\N	\N	68101	68101	67966
16767	21666	26	applied	\N	\N	\N	\N	68113	68113	67968
16767	21668	27	applied	\N	\N	\N	\N	68116	68116	56118
16756	21940	14	applied	\N	\N	\N	\N	68804	68804	68805
16756	21943	15	applied	\N	\N	\N	\N	68813	68813	68814
16756	21946	16	applied	\N	\N	\N	\N	68820	68820	68821
16756	21947	17	applied	\N	\N	\N	\N	68822	68822	68823
16756	21952	18	applied	\N	\N	\N	\N	68831	68831	68832
16756	21953	19	applied	\N	\N	\N	\N	68833	68833	68834
16756	21959	20	applied	\N	\N	\N	\N	68845	68845	68846
16756	21962	21	applied	\N	\N	\N	\N	68851	68851	68852
16756	21965	22	applied	\N	\N	\N	\N	68856	68856	68857
16756	21966	23	applied	\N	\N	\N	\N	68858	68858	68859
16756	22105	24	applied	\N	\N	\N	\N	69338	69338	69310
16756	22109	25	applied	\N	\N	\N	\N	69339	69339	69323
16756	22128	26	applied	\N	\N	\N	\N	69398	69398	69367
16756	21967	27	applied	\N	\N	\N	\N	68860	68860	68861
16756	21975	28	applied	\N	\N	\N	\N	68872	68872	68873
16756	21976	29	applied	\N	\N	\N	\N	68874	68874	68875
16756	21982	30	applied	\N	\N	\N	\N	68890	68890	68891
16756	21984	31	applied	\N	\N	\N	\N	68899	68899	68900
16756	21985	32	applied	\N	\N	\N	\N	68901	68901	68902
16756	21986	33	applied	\N	\N	\N	\N	68903	68903	68904
16756	21987	34	applied	\N	\N	\N	\N	68905	68905	68906
16756	21988	35	applied	\N	\N	\N	\N	68907	68907	68908
16756	22000	36	applied	\N	\N	\N	\N	68927	68927	68928
16756	22001	37	applied	\N	\N	\N	\N	68929	68929	68930
16756	22007	38	applied	\N	\N	\N	\N	68941	68941	68942
16756	22008	39	applied	\N	\N	\N	\N	68943	68943	68944
16756	22014	40	applied	\N	\N	\N	\N	68959	68959	68960
16756	22017	41	applied	\N	\N	\N	\N	68967	68967	69050
16756	22019	42	applied	\N	\N	\N	\N	68974	68974	69051
16756	22020	43	applied	\N	\N	\N	\N	68976	68976	69052
16756	22028	44	applied	\N	\N	\N	\N	68988	68988	69053
16756	22031	45	applied	\N	\N	\N	\N	68995	68995	69054
16756	22035	46	applied	\N	\N	\N	\N	69003	69003	69055
16756	22038	47	applied	\N	\N	\N	\N	69009	69009	69056
16756	22040	48	applied	\N	\N	\N	\N	69014	69014	69057
16756	22044	49	applied	\N	\N	\N	\N	69024	69024	69058
16756	22047	50	applied	\N	\N	\N	\N	69034	69034	69059
16756	22048	51	applied	\N	\N	\N	\N	69036	69036	69060
16756	22054	52	applied	\N	\N	\N	\N	69078	69078	69083
16756	22057	53	applied	\N	\N	\N	\N	69090	69090	69399
16756	22058	54	applied	\N	\N	\N	\N	69092	69092	69400
16756	22059	55	applied	\N	\N	\N	\N	69094	69094	69401
16756	22067	56	applied	\N	\N	\N	\N	69109	69109	69402
16756	22070	57	applied	\N	\N	\N	\N	69114	69114	69403
16756	22073	58	applied	\N	\N	\N	\N	69129	69129	69404
16756	22074	59	applied	\N	\N	\N	\N	69131	69131	69405
16756	22080	60	applied	\N	\N	\N	\N	69232	69232	69406
16756	22083	61	applied	\N	\N	\N	\N	69252	69252	69407
16756	22087	62	applied	\N	\N	\N	\N	69262	69262	69408
16756	22088	63	applied	\N	\N	\N	\N	69264	69264	69409
16756	22092	64	applied	\N	\N	\N	\N	69276	69276	69410
16756	22095	65	applied	\N	\N	\N	\N	69284	69284	69411
16756	22097	66	applied	\N	\N	\N	\N	69289	69289	69412
16756	22100	67	applied	\N	\N	\N	\N	69297	69297	69413
16756	22104	68	applied	\N	\N	\N	\N	69307	69307	69414
16756	22110	69	applied	\N	\N	\N	\N	69324	69324	69415
16756	22111	70	applied	\N	\N	\N	\N	69326	69326	69416
16756	22117	71	applied	\N	\N	\N	\N	69343	69343	69417
16756	22118	72	applied	\N	\N	\N	\N	69345	69345	69418
16756	22119	73	applied	\N	\N	\N	\N	69347	69347	69419
16756	22127	74	applied	\N	\N	\N	\N	69364	69364	69420
16756	22131	75	applied	\N	\N	\N	\N	69376	69376	69421
16756	22134	76	applied	\N	\N	\N	\N	69381	69381	69422
16756	21856	77	applied	\N	\N	\N	\N	68608	68608	62660
16756	21525	78	applied	\N	\N	\N	\N	67812	67812	67813
16756	21526	79	applied	\N	\N	\N	\N	67814	67814	55895
16756	21527	80	applied	\N	\N	\N	\N	67815	67815	67816
16756	21542	81	applied	\N	\N	\N	\N	67851	67851	69423
16756	21557	82	applied	\N	\N	\N	\N	67881	67881	55906
16756	21563	83	applied	\N	\N	\N	\N	67893	67893	55908
16756	21576	84	applied	\N	\N	\N	\N	67912	67912	69424
16756	21592	85	applied	\N	\N	\N	\N	67944	67944	55910
16756	21528	86	applied	\N	\N	\N	\N	67817	67817	55912
16756	21529	87	applied	\N	\N	\N	\N	67818	67818	69425
16756	21530	88	applied	\N	\N	\N	\N	67820	67820	67823
16756	21863	89	applied	\N	\N	\N	\N	68620	68620	62660
16756	21606	90	applied	\N	\N	\N	\N	67972	67972	55929
16756	21609	91	applied	\N	\N	\N	\N	67979	67979	67825
16756	21619	92	applied	\N	\N	\N	\N	68001	68001	69426
16756	21631	93	applied	\N	\N	\N	\N	68020	68020	55931
16756	22103	94	applied	\N	\N	\N	\N	69302	69302	69302
16756	22112	95	applied	\N	\N	\N	\N	69328	69328	69328
16756	21531	96	applied	\N	\N	\N	\N	67821	67821	67833
16756	21535	97	applied	\N	\N	\N	\N	67830	67830	69427
16756	21539	98	applied	\N	\N	\N	\N	67845	67845	69428
16756	21541	99	applied	\N	\N	\N	\N	67850	67850	67852
16756	21546	100	applied	\N	\N	\N	\N	67858	67858	69429
16756	21551	101	applied	\N	\N	\N	\N	67871	67871	69430
16756	21532	102	applied	\N	\N	\N	\N	67822	67822	55978
16756	21533	103	applied	\N	\N	\N	\N	67824	67824	55980
16756	21536	104	applied	\N	\N	\N	\N	67832	67832	67872
16756	21538	105	applied	\N	\N	\N	\N	67844	67844	55987
16756	21543	106	applied	\N	\N	\N	\N	67853	67853	55989
16756	21547	107	applied	\N	\N	\N	\N	67859	67859	69431
16756	21550	108	applied	\N	\N	\N	\N	67869	67869	55998
16756	21552	109	applied	\N	\N	\N	\N	67873	67873	56000
16756	21555	110	applied	\N	\N	\N	\N	67878	67878	68539
16756	21562	111	applied	\N	\N	\N	\N	67891	67891	56007
16756	21564	112	applied	\N	\N	\N	\N	67894	67894	56009
16756	21565	113	applied	\N	\N	\N	\N	67895	67895	67896
16756	21566	114	applied	\N	\N	\N	\N	67897	67897	56017
16756	21573	115	applied	\N	\N	\N	\N	67907	67907	56019
16756	21577	116	applied	\N	\N	\N	\N	67914	67914	69432
16756	21580	117	applied	\N	\N	\N	\N	67920	67920	56027
16756	21584	118	applied	\N	\N	\N	\N	67927	67927	56029
16756	21588	119	applied	\N	\N	\N	\N	67939	67939	69433
16756	21590	120	applied	\N	\N	\N	\N	67941	67941	56038
16756	21595	121	applied	\N	\N	\N	\N	67951	67951	56040
16756	21603	122	applied	\N	\N	\N	\N	67967	67967	69434
16756	21604	123	applied	\N	\N	\N	\N	67969	67969	69435
16756	21605	124	applied	\N	\N	\N	\N	67970	67970	56055
16756	21610	125	applied	\N	\N	\N	\N	67981	67981	69436
16759	22140	0	applied	\N	\N	\N	\N	69439	69439	69440
16759	22141	1	applied	\N	\N	\N	\N	69441	69441	69442
16759	22142	2	applied	\N	\N	\N	\N	69443	69443	69444
16765	22149	0	applied	\N	\N	\N	\N	69463	69463	69464
16765	22150	1	applied	\N	\N	\N	\N	69465	69465	69466
16770	22158	0	applied	\N	\N	\N	\N	69502	69502	69503
16770	22159	1	applied	\N	\N	\N	\N	69504	69504	69505
16770	22160	2	applied	\N	\N	\N	\N	69506	69506	69507
16767	21670	28	applied	\N	\N	\N	\N	68122	68122	67971
16767	21678	29	applied	\N	\N	\N	\N	68143	68143	67980
16767	21679	30	applied	\N	\N	\N	\N	68145	68145	56128
16767	21680	31	applied	\N	\N	\N	\N	68146	68146	67983
16767	21681	32	applied	\N	\N	\N	\N	68147	68147	69482
16767	21687	33	applied	\N	\N	\N	\N	68166	68166	56140
16767	21693	34	applied	\N	\N	\N	\N	68181	68181	67986
16767	21694	35	applied	\N	\N	\N	\N	68182	68182	69483
16767	21700	36	applied	\N	\N	\N	\N	68194	68194	56146
16767	21701	37	applied	\N	\N	\N	\N	68196	68196	68004
16767	21707	38	applied	\N	\N	\N	\N	68206	68206	68006
16767	21708	39	applied	\N	\N	\N	\N	68208	68208	56161
16767	21713	40	applied	\N	\N	\N	\N	68221	68221	69484
16767	21717	41	applied	\N	\N	\N	\N	68231	68231	69485
16767	21721	42	applied	\N	\N	\N	\N	68236	68236	56167
16767	21723	43	applied	\N	\N	\N	\N	68239	68239	69486
16767	21725	44	applied	\N	\N	\N	\N	68244	68244	69487
16767	21728	45	applied	\N	\N	\N	\N	68262	68262	56178
16767	21733	46	applied	\N	\N	\N	\N	68279	68279	68013
16767	21736	47	applied	\N	\N	\N	\N	68285	68285	68015
16767	21740	48	applied	\N	\N	\N	\N	68295	68295	56190
16767	21744	49	applied	\N	\N	\N	\N	68305	68305	56192
16767	21748	50	applied	\N	\N	\N	\N	68312	68312	68023
16767	21751	51	applied	\N	\N	\N	\N	68321	68321	56202
16767	21754	52	applied	\N	\N	\N	\N	68329	68329	56204
16767	21760	53	applied	\N	\N	\N	\N	68345	68345	68050
16767	21762	54	applied	\N	\N	\N	\N	68347	68347	56208
16767	21763	55	applied	\N	\N	\N	\N	68348	68348	56215
16767	21768	56	applied	\N	\N	\N	\N	68362	68362	68058
16767	21769	57	applied	\N	\N	\N	\N	68364	68364	56219
16767	21775	58	applied	\N	\N	\N	\N	68381	68381	56225
16767	21780	59	applied	\N	\N	\N	\N	68394	68394	68071
16767	21783	60	applied	\N	\N	\N	\N	68400	68400	56229
16767	21787	61	applied	\N	\N	\N	\N	68409	68409	56241
16767	21792	62	applied	\N	\N	\N	\N	68420	68420	68080
16767	21796	63	applied	\N	\N	\N	\N	68428	68428	56245
16769	22155	0	applied	\N	\N	\N	\N	69496	69496	69497
16769	22156	1	applied	\N	\N	\N	\N	69498	69498	57707
16769	22157	2	applied	\N	\N	\N	\N	69499	69499	57709
16773	22165	0	applied	\N	\N	\N	\N	69529	69529	69530
16773	22166	1	applied	\N	\N	\N	\N	69531	69531	69532
16773	22167	2	applied	\N	\N	\N	\N	69533	69533	69534
16773	22168	3	applied	\N	\N	\N	\N	69535	69535	69536
16773	22169	4	applied	\N	\N	\N	\N	69537	69537	69538
16773	22170	5	applied	\N	\N	\N	\N	69539	69539	57746
16773	22171	6	applied	\N	\N	\N	\N	69540	69540	69541
16773	22172	7	applied	\N	\N	\N	\N	69542	69542	69543
16773	22173	8	applied	\N	\N	\N	\N	69544	69544	69545
16773	22174	9	applied	\N	\N	\N	\N	69546	69546	57759
16773	22175	10	applied	\N	\N	\N	\N	69547	69547	69548
16773	22176	11	applied	\N	\N	\N	\N	69549	69549	69550
16773	22177	12	applied	\N	\N	\N	\N	69551	69551	57773
16775	22178	0	applied	\N	\N	\N	\N	69555	69555	69556
16775	22179	1	applied	\N	\N	\N	\N	69557	69557	69558
16775	22180	2	applied	\N	\N	\N	\N	69559	69559	57781
16778	22188	0	applied	\N	\N	\N	\N	69577	69577	69578
16778	22189	1	applied	\N	\N	\N	\N	69579	69579	57803
16778	22190	2	applied	\N	\N	\N	\N	69580	69580	69581
16780	22191	0	applied	\N	\N	\N	\N	69584	69584	69585
16780	22192	1	applied	\N	\N	\N	\N	69586	69586	57807
16780	22193	2	applied	\N	\N	\N	\N	69587	69587	69588
16789	22201	0	applied	\N	\N	\N	\N	69628	69628	69629
16789	22202	1	applied	\N	\N	\N	\N	69630	69630	57843
16789	22203	2	applied	\N	\N	\N	\N	69631	69631	69632
16791	22207	0	applied	\N	\N	\N	\N	69646	69646	69647
16791	22208	1	applied	\N	\N	\N	\N	69648	69648	57851
16791	22209	2	applied	\N	\N	\N	\N	69649	69649	69650
16793	22210	0	applied	\N	\N	\N	\N	69655	69655	69656
16793	22211	1	applied	\N	\N	\N	\N	69657	69657	57853
16793	22212	2	applied	\N	\N	\N	\N	69658	69658	69659
16796	22217	0	applied	\N	\N	\N	\N	69671	69671	69663
16796	22218	1	applied	\N	\N	\N	\N	69672	69672	69673
16796	22219	2	applied	\N	\N	\N	\N	69674	69674	69675
16796	22220	3	applied	\N	\N	\N	\N	69676	69676	69677
16796	22221	4	applied	\N	\N	\N	\N	69678	69678	69679
16796	22222	5	applied	\N	\N	\N	\N	69680	69680	69681
16796	22223	6	applied	\N	\N	\N	\N	69682	69682	69683
16796	22224	7	applied	\N	\N	\N	\N	69684	69684	57871
16796	22225	8	applied	\N	\N	\N	\N	69685	69685	69686
16796	22226	9	applied	\N	\N	\N	\N	69687	69687	69688
16796	22227	10	applied	\N	\N	\N	\N	69689	69689	57889
16801	22231	0	applied	\N	\N	\N	\N	69700	69700	69701
16801	22232	1	applied	\N	\N	\N	\N	69702	69702	69703
16801	22233	2	applied	\N	\N	\N	\N	69704	69704	57900
16801	22234	3	applied	\N	\N	\N	\N	69705	69705	69706
16803	22235	0	applied	\N	\N	\N	\N	69711	69711	69712
16803	22236	1	applied	\N	\N	\N	\N	69713	69713	69714
16803	22237	2	applied	\N	\N	\N	\N	69715	69715	69716
16810	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16810	22105	1	applied	\N	\N	\N	\N	69338	69338	69310
16810	22109	2	applied	\N	\N	\N	\N	69339	69339	69323
16810	22128	3	applied	\N	\N	\N	\N	69398	69398	69367
16810	22220	4	applied	\N	\N	\N	\N	69742	69742	69677
16810	22221	5	applied	\N	\N	\N	\N	69743	69743	69679
16810	22103	6	applied	\N	\N	\N	\N	69302	69302	69302
16810	22112	7	applied	\N	\N	\N	\N	69328	69328	69328
16812	22246	0	applied	\N	\N	\N	\N	69747	69747	69748
16812	22247	1	applied	\N	\N	\N	\N	69749	69749	69750
16812	22248	2	applied	\N	\N	\N	\N	69751	69751	69752
16812	22249	3	applied	\N	\N	\N	\N	69753	69753	57926
16812	22250	4	applied	\N	\N	\N	\N	69754	69754	57928
16812	22251	5	applied	\N	\N	\N	\N	69755	69755	69756
16812	22252	6	applied	\N	\N	\N	\N	69757	69757	69758
16812	22253	7	applied	\N	\N	\N	\N	69759	69759	69760
16812	22254	8	applied	\N	\N	\N	\N	69761	69761	57943
16812	22255	9	applied	\N	\N	\N	\N	69762	69762	57945
16812	22256	10	applied	\N	\N	\N	\N	69763	69763	69764
16815	22257	0	applied	\N	\N	\N	\N	69772	69772	69773
16815	22258	1	applied	\N	\N	\N	\N	69774	69774	69775
16817	22259	0	applied	\N	\N	\N	\N	69780	69780	69781
16817	22260	1	applied	\N	\N	\N	\N	69782	69782	69783
16820	22266	0	applied	\N	\N	\N	\N	69797	69797	69798
16820	22267	1	applied	\N	\N	\N	\N	69799	69799	57978
16822	22268	0	applied	\N	\N	\N	\N	69803	69803	69804
16822	22269	1	applied	\N	\N	\N	\N	69805	69805	69806
16822	22270	2	applied	\N	\N	\N	\N	69807	69807	57982
16825	22271	0	applied	\N	\N	\N	\N	69810	69810	69811
16825	22272	1	applied	\N	\N	\N	\N	69812	69812	57984
16829	22277	0	applied	\N	\N	\N	\N	69825	69825	69826
16829	22278	1	applied	\N	\N	\N	\N	69827	69827	57995
16770	22161	3	applied	\N	\N	\N	\N	69508	69508	57720
16770	22162	4	applied	\N	\N	\N	\N	69509	69509	57724
16770	22163	5	applied	\N	\N	\N	\N	69510	69510	57726
16770	22164	6	applied	\N	\N	\N	\N	69511	69511	69512
16774	22165	0	applied	\N	\N	\N	\N	69529	69529	69530
16774	22166	1	applied	\N	\N	\N	\N	69531	69531	69532
16774	22167	2	applied	\N	\N	\N	\N	69533	69533	69534
16774	22168	3	applied	\N	\N	\N	\N	69535	69535	69536
16774	22169	4	applied	\N	\N	\N	\N	69537	69537	69538
16774	22170	5	applied	\N	\N	\N	\N	69539	69539	57746
16774	22171	6	applied	\N	\N	\N	\N	69540	69540	69541
16774	22172	7	applied	\N	\N	\N	\N	69542	69542	69543
16774	22173	8	applied	\N	\N	\N	\N	69544	69544	69545
16774	22174	9	applied	\N	\N	\N	\N	69546	69546	57759
16774	22175	10	applied	\N	\N	\N	\N	69547	69547	69548
16774	22176	11	applied	\N	\N	\N	\N	69549	69549	69550
16774	22177	12	applied	\N	\N	\N	\N	69551	69551	57773
16776	22178	0	applied	\N	\N	\N	\N	69555	69555	69556
16776	22179	1	applied	\N	\N	\N	\N	69557	69557	69558
16776	22180	2	applied	\N	\N	\N	\N	69559	69559	57781
16779	22188	0	applied	\N	\N	\N	\N	69577	69577	69578
16779	22189	1	applied	\N	\N	\N	\N	69579	69579	57803
16779	22190	2	applied	\N	\N	\N	\N	69580	69580	69581
16781	22194	0	applied	\N	\N	\N	\N	69589	69589	69590
16781	22195	1	applied	\N	\N	\N	\N	69591	69591	69592
16781	22196	2	applied	\N	\N	\N	\N	69593	69593	57816
16781	22197	3	applied	\N	\N	\N	\N	69594	69594	69595
16781	22198	4	applied	\N	\N	\N	\N	69596	69596	69597
16781	22199	5	applied	\N	\N	\N	\N	69598	69598	57831
16781	22200	6	applied	\N	\N	\N	\N	69599	69599	69600
16787	22201	0	applied	\N	\N	\N	\N	69628	69628	69629
16787	22202	1	applied	\N	\N	\N	\N	69630	69630	57843
16787	22203	2	applied	\N	\N	\N	\N	69631	69631	69632
16792	22207	0	applied	\N	\N	\N	\N	69646	69646	69647
16792	22208	1	applied	\N	\N	\N	\N	69648	69648	57851
16792	22209	2	applied	\N	\N	\N	\N	69649	69649	69650
16794	22210	0	applied	\N	\N	\N	\N	69655	69655	69656
16794	22211	1	applied	\N	\N	\N	\N	69657	69657	57853
16794	22212	2	applied	\N	\N	\N	\N	69658	69658	69659
16808	22243	0	applied	\N	\N	\N	\N	69733	69733	69734
16808	22244	1	applied	\N	\N	\N	\N	69735	69735	69736
16808	22245	2	applied	\N	\N	\N	\N	69737	69737	69738
16813	22246	0	applied	\N	\N	\N	\N	69747	69747	69748
16813	22247	1	applied	\N	\N	\N	\N	69749	69749	69750
16813	22248	2	applied	\N	\N	\N	\N	69751	69751	69752
16813	22249	3	applied	\N	\N	\N	\N	69753	69753	57926
16813	22250	4	applied	\N	\N	\N	\N	69754	69754	57928
16813	22251	5	applied	\N	\N	\N	\N	69755	69755	69756
16813	22252	6	applied	\N	\N	\N	\N	69757	69757	69758
16813	22253	7	applied	\N	\N	\N	\N	69759	69759	69760
16813	22254	8	applied	\N	\N	\N	\N	69761	69761	57943
16813	22255	9	applied	\N	\N	\N	\N	69762	69762	57945
16813	22256	10	applied	\N	\N	\N	\N	69763	69763	69764
16818	22261	0	applied	\N	\N	\N	\N	69786	69786	69787
16818	22262	1	applied	\N	\N	\N	\N	69788	69788	69789
16818	22263	2	applied	\N	\N	\N	\N	69790	69790	69791
16818	22264	3	applied	\N	\N	\N	\N	69792	69792	69793
16818	22265	4	applied	\N	\N	\N	\N	69794	69794	57976
16827	22277	0	applied	\N	\N	\N	\N	69825	69825	69826
16827	22278	1	applied	\N	\N	\N	\N	69827	69827	57995
16827	22279	2	applied	\N	\N	\N	\N	69828	69828	69829
16839	22287	0	applied	\N	\N	\N	\N	69855	69855	69856
16839	22288	1	applied	\N	\N	\N	\N	69857	69857	69858
16840	22289	0	applied	\N	\N	\N	\N	69864	69864	69865
16840	22290	1	applied	\N	\N	\N	\N	69866	69866	58022
16840	22291	2	applied	\N	\N	\N	\N	69867	69867	69868
16850	22312	0	applied	\N	\N	\N	\N	69913	69913	69914
16850	22313	1	applied	\N	\N	\N	\N	69915	69915	69916
16850	22314	2	applied	\N	\N	\N	\N	69917	69917	69918
16854	22312	0	applied	\N	\N	\N	\N	69913	69913	69914
16854	22313	1	applied	\N	\N	\N	\N	69915	69915	69916
16854	22314	2	applied	\N	\N	\N	\N	69917	69917	69918
16857	22315	0	applied	\N	\N	\N	\N	69943	69943	69944
16857	22316	1	applied	\N	\N	\N	\N	69945	69945	69946
16857	22317	2	applied	\N	\N	\N	\N	69947	69947	58188
16857	22318	3	applied	\N	\N	\N	\N	69948	69948	69949
16857	22319	4	applied	\N	\N	\N	\N	69950	69950	58238
16857	22320	5	applied	\N	\N	\N	\N	69951	69951	58240
16857	22321	6	applied	\N	\N	\N	\N	69952	69952	58242
16863	22322	0	applied	\N	\N	\N	\N	69954	69954	69955
16863	22323	1	applied	\N	\N	\N	\N	69956	69956	69957
16863	22324	2	applied	\N	\N	\N	\N	69958	69958	69959
16869	22329	0	applied	\N	\N	\N	\N	70014	70014	70028
16869	22330	1	applied	\N	\N	\N	\N	70016	70016	70029
16869	22331	2	applied	\N	\N	\N	\N	70018	70018	70030
16869	22332	3	applied	\N	\N	\N	\N	70020	70020	70031
16869	22333	4	applied	\N	\N	\N	\N	70032	70032	70033
16869	22334	5	applied	\N	\N	\N	\N	70034	70034	70035
16869	22335	6	applied	\N	\N	\N	\N	70036	70036	70037
16869	22336	7	applied	\N	\N	\N	\N	70038	70038	58394
16869	22337	8	applied	\N	\N	\N	\N	70039	70039	70040
16869	22338	9	applied	\N	\N	\N	\N	70041	70041	70042
16869	22339	10	applied	\N	\N	\N	\N	70043	70043	70044
16869	22340	11	applied	\N	\N	\N	\N	70045	70045	70046
16869	22341	12	applied	\N	\N	\N	\N	70047	70047	70048
16873	22344	0	applied	\N	\N	\N	\N	70060	70060	70061
16873	22345	1	applied	\N	\N	\N	\N	70062	70062	70063
16873	22346	2	applied	\N	\N	\N	\N	70064	70064	58464
16873	22347	3	applied	\N	\N	\N	\N	70065	70065	58544
16879	22361	0	applied	\N	\N	\N	\N	70098	70098	70099
16879	22362	1	applied	\N	\N	\N	\N	70100	70100	70101
16879	22363	2	applied	\N	\N	\N	\N	70102	70102	70103
16879	22364	3	applied	\N	\N	\N	\N	70104	70104	58583
16879	22365	4	applied	\N	\N	\N	\N	70105	70105	70106
16879	22366	5	applied	\N	\N	\N	\N	70107	70107	70108
16879	22367	6	applied	\N	\N	\N	\N	70109	70109	70110
16879	22368	7	applied	\N	\N	\N	\N	70111	70111	58711
16879	22369	8	applied	\N	\N	\N	\N	70112	70112	58713
16879	22370	9	applied	\N	\N	\N	\N	70113	70113	70114
16879	22371	10	applied	\N	\N	\N	\N	70115	70115	70116
16882	22372	0	applied	\N	\N	\N	\N	70118	70118	70119
16882	22373	1	applied	\N	\N	\N	\N	70120	70120	70121
16882	22374	2	applied	\N	\N	\N	\N	70122	70122	70123
16886	22382	0	applied	\N	\N	\N	\N	70156	70156	70157
16886	22383	1	applied	\N	\N	\N	\N	70158	70158	70159
16886	22384	2	applied	\N	\N	\N	\N	70160	70160	70161
16888	22385	0	applied	\N	\N	\N	\N	70164	70164	70165
16888	22386	1	applied	\N	\N	\N	\N	70166	70166	70167
16888	22387	2	applied	\N	\N	\N	\N	70168	70168	70169
16891	22385	0	applied	\N	\N	\N	\N	70164	70164	70165
16772	22109	13	applied	\N	\N	\N	\N	69339	69339	69323
16772	22128	14	applied	\N	\N	\N	\N	69398	69398	69367
16772	21887	15	applied	\N	\N	\N	\N	68676	68676	68677
16772	21888	16	applied	\N	\N	\N	\N	68678	68678	68679
16772	21889	17	applied	\N	\N	\N	\N	68680	68680	68681
16772	21890	18	applied	\N	\N	\N	\N	68682	68682	68683
16772	21899	19	applied	\N	\N	\N	\N	68697	68697	68698
16772	21902	20	applied	\N	\N	\N	\N	68707	68707	68708
16772	21905	21	applied	\N	\N	\N	\N	68719	68719	68720
16772	21906	22	applied	\N	\N	\N	\N	68721	68721	68722
16772	21911	23	applied	\N	\N	\N	\N	68732	68732	68733
16772	21912	24	applied	\N	\N	\N	\N	68734	68734	68735
16772	21918	25	applied	\N	\N	\N	\N	68750	68750	68751
16772	21921	26	applied	\N	\N	\N	\N	68758	68758	68759
16772	21924	27	applied	\N	\N	\N	\N	68764	68764	68765
16772	21925	28	applied	\N	\N	\N	\N	68766	68766	68767
16772	21926	29	applied	\N	\N	\N	\N	68768	68768	68769
16772	21933	30	applied	\N	\N	\N	\N	68784	68784	68785
16772	21936	31	applied	\N	\N	\N	\N	68796	68796	68797
16772	21940	32	applied	\N	\N	\N	\N	68804	68804	68805
16772	21943	33	applied	\N	\N	\N	\N	68813	68813	68814
16772	21946	34	applied	\N	\N	\N	\N	68820	68820	68821
16772	21947	35	applied	\N	\N	\N	\N	68822	68822	68823
16772	21952	36	applied	\N	\N	\N	\N	68831	68831	68832
16772	21953	37	applied	\N	\N	\N	\N	68833	68833	68834
16772	21959	38	applied	\N	\N	\N	\N	68845	68845	68846
16772	21962	39	applied	\N	\N	\N	\N	68851	68851	68852
16772	21965	40	applied	\N	\N	\N	\N	68856	68856	68857
16772	21966	41	applied	\N	\N	\N	\N	68858	68858	68859
16772	21967	42	applied	\N	\N	\N	\N	68860	68860	68861
16772	21975	43	applied	\N	\N	\N	\N	68872	68872	68873
16772	21976	44	applied	\N	\N	\N	\N	68874	68874	68875
16772	21982	45	applied	\N	\N	\N	\N	68890	68890	68891
16772	21984	46	applied	\N	\N	\N	\N	68899	68899	68900
16772	21985	47	applied	\N	\N	\N	\N	68901	68901	68902
16772	21986	48	applied	\N	\N	\N	\N	68903	68903	68904
16772	21987	49	applied	\N	\N	\N	\N	68905	68905	68906
16772	21988	50	applied	\N	\N	\N	\N	68907	68907	68908
16772	22000	51	applied	\N	\N	\N	\N	68927	68927	68928
16772	22001	52	applied	\N	\N	\N	\N	68929	68929	68930
16772	22007	53	applied	\N	\N	\N	\N	68941	68941	68942
16772	22008	54	applied	\N	\N	\N	\N	68943	68943	68944
16772	22014	55	applied	\N	\N	\N	\N	68959	68959	68960
16772	22017	56	applied	\N	\N	\N	\N	68967	68967	69050
16772	22019	57	applied	\N	\N	\N	\N	68974	68974	69051
16772	22020	58	applied	\N	\N	\N	\N	68976	68976	69052
16772	22028	59	applied	\N	\N	\N	\N	68988	68988	69053
16772	22031	60	applied	\N	\N	\N	\N	68995	68995	69054
16772	22035	61	applied	\N	\N	\N	\N	69003	69003	69055
16772	22038	62	applied	\N	\N	\N	\N	69009	69009	69056
16772	22040	63	applied	\N	\N	\N	\N	69014	69014	69057
16772	22044	64	applied	\N	\N	\N	\N	69024	69024	69058
16772	22047	65	applied	\N	\N	\N	\N	69034	69034	69059
16772	22048	66	applied	\N	\N	\N	\N	69036	69036	69060
16772	22054	67	applied	\N	\N	\N	\N	69078	69078	69083
16772	22057	68	applied	\N	\N	\N	\N	69090	69090	69399
16772	22058	69	applied	\N	\N	\N	\N	69092	69092	69400
16772	22059	70	applied	\N	\N	\N	\N	69094	69094	69401
16772	22067	71	applied	\N	\N	\N	\N	69109	69109	69402
16772	22070	72	applied	\N	\N	\N	\N	69114	69114	69403
16772	22073	73	applied	\N	\N	\N	\N	69129	69129	69404
16772	22074	74	applied	\N	\N	\N	\N	69131	69131	69405
16772	22080	75	applied	\N	\N	\N	\N	69232	69232	69406
16772	22083	76	applied	\N	\N	\N	\N	69252	69252	69407
16772	22087	77	applied	\N	\N	\N	\N	69262	69262	69408
16772	22088	78	applied	\N	\N	\N	\N	69264	69264	69409
16772	22092	79	applied	\N	\N	\N	\N	69276	69276	69410
16772	22095	80	applied	\N	\N	\N	\N	69284	69284	69411
16772	22097	81	applied	\N	\N	\N	\N	69289	69289	69412
16772	22100	82	applied	\N	\N	\N	\N	69297	69297	69413
16772	22104	83	applied	\N	\N	\N	\N	69307	69307	69414
16772	22110	84	applied	\N	\N	\N	\N	69324	69324	69415
16772	22111	85	applied	\N	\N	\N	\N	69326	69326	69416
16772	22117	86	applied	\N	\N	\N	\N	69343	69343	69417
16772	22118	87	applied	\N	\N	\N	\N	69345	69345	69418
16772	22119	88	applied	\N	\N	\N	\N	69347	69347	69419
16772	22127	89	applied	\N	\N	\N	\N	69364	69364	69420
16772	22131	90	applied	\N	\N	\N	\N	69376	69376	69421
16772	22134	91	applied	\N	\N	\N	\N	69381	69381	69422
16772	22137	92	applied	\N	\N	\N	\N	69389	69389	69469
16772	22143	93	applied	\N	\N	\N	\N	69451	69451	69470
16772	22146	94	applied	\N	\N	\N	\N	69459	69459	69471
16772	22149	95	applied	\N	\N	\N	\N	69463	69463	69473
16772	22151	96	applied	\N	\N	\N	\N	69490	69490	69517
16772	22155	97	applied	\N	\N	\N	\N	69496	69496	69518
16772	22158	98	applied	\N	\N	\N	\N	69502	69502	69519
16772	22159	99	applied	\N	\N	\N	\N	69504	69504	69520
16772	21856	100	applied	\N	\N	\N	\N	68608	68608	62660
16772	21857	101	applied	\N	\N	\N	\N	68609	68609	56851
16772	21875	102	applied	\N	\N	\N	\N	68648	68648	69521
16772	21858	103	applied	\N	\N	\N	\N	68610	68610	56855
16772	21861	104	applied	\N	\N	\N	\N	68617	68617	56857
16772	21868	105	applied	\N	\N	\N	\N	68634	68634	68618
16772	21859	106	applied	\N	\N	\N	\N	68612	68612	56866
16772	21885	107	applied	\N	\N	\N	\N	68670	68670	69522
16772	21891	108	applied	\N	\N	\N	\N	68684	68684	68635
16772	21908	109	applied	\N	\N	\N	\N	68725	68725	56872
16772	21913	110	applied	\N	\N	\N	\N	68736	68736	69523
16772	21927	111	applied	\N	\N	\N	\N	68770	68770	56874
16772	21938	112	applied	\N	\N	\N	\N	68800	68800	56881
16772	21950	113	applied	\N	\N	\N	\N	68827	68827	68641
16772	21954	114	applied	\N	\N	\N	\N	68835	68835	69524
16772	21968	115	applied	\N	\N	\N	\N	68862	68862	56883
16772	21977	116	applied	\N	\N	\N	\N	68876	68876	68643
16772	21989	117	applied	\N	\N	\N	\N	68909	68909	56885
16772	21871	118	applied	\N	\N	\N	\N	68640	68640	69525
16772	21877	119	applied	\N	\N	\N	\N	68651	68651	56896
16772	21878	120	applied	\N	\N	\N	\N	68653	68653	56898
16772	21881	121	applied	\N	\N	\N	\N	68661	68661	69526
16772	21884	122	applied	\N	\N	\N	\N	68668	68668	56902
16772	21892	123	applied	\N	\N	\N	\N	68685	68685	56904
16772	21862	124	applied	\N	\N	\N	\N	68619	68619	68663
16772	21869	125	applied	\N	\N	\N	\N	68636	68636	56914
16782	22194	0	applied	\N	\N	\N	\N	69589	69589	69590
16782	22195	1	applied	\N	\N	\N	\N	69591	69591	69592
16782	22196	2	applied	\N	\N	\N	\N	69593	69593	57816
16782	22197	3	applied	\N	\N	\N	\N	69594	69594	69595
16782	22198	4	applied	\N	\N	\N	\N	69596	69596	69597
16782	22199	5	applied	\N	\N	\N	\N	69598	69598	57831
16782	22200	6	applied	\N	\N	\N	\N	69599	69599	69600
16784	22054	0	applied	\N	\N	\N	\N	69078	69078	69083
16784	22057	1	applied	\N	\N	\N	\N	69090	69090	69399
16784	22058	2	applied	\N	\N	\N	\N	69092	69092	69400
16784	22059	3	applied	\N	\N	\N	\N	69094	69094	69401
16784	22067	4	applied	\N	\N	\N	\N	69109	69109	69402
16784	22070	5	applied	\N	\N	\N	\N	69114	69114	69403
16784	22105	6	applied	\N	\N	\N	\N	69338	69338	69310
16784	22109	7	applied	\N	\N	\N	\N	69339	69339	69323
16784	22128	8	applied	\N	\N	\N	\N	69398	69398	69367
16784	22073	9	applied	\N	\N	\N	\N	69129	69129	69404
16784	22074	10	applied	\N	\N	\N	\N	69131	69131	69405
16784	22080	11	applied	\N	\N	\N	\N	69232	69232	69406
16784	22083	12	applied	\N	\N	\N	\N	69252	69252	69407
16784	22087	13	applied	\N	\N	\N	\N	69262	69262	69408
16784	22088	14	applied	\N	\N	\N	\N	69264	69264	69409
16784	22092	15	applied	\N	\N	\N	\N	69276	69276	69410
16784	22095	16	applied	\N	\N	\N	\N	69284	69284	69411
16784	22097	17	applied	\N	\N	\N	\N	69289	69289	69412
16784	22100	20	applied	\N	\N	\N	\N	69297	69297	69413
16784	22104	21	applied	\N	\N	\N	\N	69307	69307	69414
16784	22110	22	applied	\N	\N	\N	\N	69324	69324	69415
16784	22111	23	applied	\N	\N	\N	\N	69326	69326	69416
16784	22117	24	applied	\N	\N	\N	\N	69343	69343	69417
16784	22118	25	applied	\N	\N	\N	\N	69345	69345	69418
16784	22119	26	applied	\N	\N	\N	\N	69347	69347	69419
16784	22127	27	applied	\N	\N	\N	\N	69364	69364	69420
16784	22131	28	applied	\N	\N	\N	\N	69376	69376	69421
16784	22134	29	applied	\N	\N	\N	\N	69381	69381	69422
16784	22137	30	applied	\N	\N	\N	\N	69389	69389	69469
16784	22143	31	applied	\N	\N	\N	\N	69451	69451	69470
16784	22146	32	applied	\N	\N	\N	\N	69459	69459	69471
16784	22149	33	applied	\N	\N	\N	\N	69463	69463	69473
16784	22151	34	applied	\N	\N	\N	\N	69490	69490	69517
16784	22155	35	applied	\N	\N	\N	\N	69496	69496	69518
16784	22158	36	applied	\N	\N	\N	\N	69502	69502	69519
16784	22159	37	applied	\N	\N	\N	\N	69504	69504	69520
16784	22165	38	applied	\N	\N	\N	\N	69529	69529	69610
16784	22166	39	applied	\N	\N	\N	\N	69531	69531	69611
16784	22167	40	applied	\N	\N	\N	\N	69533	69533	69612
16784	22168	41	applied	\N	\N	\N	\N	69535	69535	69613
16784	22178	42	applied	\N	\N	\N	\N	69555	69555	69614
16784	22181	43	applied	\N	\N	\N	\N	69563	69563	69615
16784	22182	44	applied	\N	\N	\N	\N	69565	69565	69616
16784	22188	45	applied	\N	\N	\N	\N	69577	69577	69617
16784	22191	46	applied	\N	\N	\N	\N	69584	69584	69618
16784	22194	47	applied	\N	\N	\N	\N	69589	69589	69619
16784	22195	48	applied	\N	\N	\N	\N	69591	69591	69620
16784	22062	49	applied	\N	\N	\N	\N	69098	69098	56779
16784	21892	50	applied	\N	\N	\N	\N	68685	68685	68516
16784	22079	51	applied	\N	\N	\N	\N	69138	69138	68518
16784	22085	52	applied	\N	\N	\N	\N	69256	69256	56787
16784	22096	53	applied	\N	\N	\N	\N	69286	69286	56789
16784	22103	54	applied	\N	\N	\N	\N	69302	69302	69302
16784	22112	55	applied	\N	\N	\N	\N	69328	69328	69328
16784	21897	56	applied	\N	\N	\N	\N	68692	68692	69621
16784	21898	57	applied	\N	\N	\N	\N	68694	68694	69622
16784	22108	58	applied	\N	\N	\N	\N	69314	69314	56793
16784	22122	59	applied	\N	\N	\N	\N	69353	69353	56798
16784	22133	60	applied	\N	\N	\N	\N	69380	69380	69623
16784	22140	61	applied	\N	\N	\N	\N	69439	69439	56801
16784	22153	62	applied	\N	\N	\N	\N	69494	69494	68592
16784	22164	63	applied	\N	\N	\N	\N	69511	69511	69624
16784	22175	64	applied	\N	\N	\N	\N	69547	69547	56803
16784	22183	65	applied	\N	\N	\N	\N	69567	69567	56809
16797	22217	0	applied	\N	\N	\N	\N	69671	69671	69663
16797	22218	1	applied	\N	\N	\N	\N	69672	69672	69673
16797	22219	2	applied	\N	\N	\N	\N	69674	69674	69675
16797	22220	3	applied	\N	\N	\N	\N	69676	69676	69677
16797	22221	4	applied	\N	\N	\N	\N	69678	69678	69679
16797	22222	5	applied	\N	\N	\N	\N	69680	69680	69681
16797	22223	6	applied	\N	\N	\N	\N	69682	69682	69683
16797	22224	7	applied	\N	\N	\N	\N	69684	69684	57871
16797	22225	8	applied	\N	\N	\N	\N	69685	69685	69686
16797	22226	9	applied	\N	\N	\N	\N	69687	69687	69688
16797	22227	10	applied	\N	\N	\N	\N	69689	69689	57889
16799	22228	0	applied	\N	\N	\N	\N	69693	69693	69694
16799	22229	1	applied	\N	\N	\N	\N	69695	69695	69696
16799	22230	2	applied	\N	\N	\N	\N	69697	69697	57893
16804	22238	0	applied	\N	\N	\N	\N	69719	69719	69720
16804	22239	1	applied	\N	\N	\N	\N	69721	69721	57909
16804	22240	2	applied	\N	\N	\N	\N	69722	69722	69723
16806	22241	0	applied	\N	\N	\N	\N	69725	69725	69726
16806	22242	1	applied	\N	\N	\N	\N	69727	69727	69728
16816	22257	0	applied	\N	\N	\N	\N	69772	69772	69773
16816	22258	1	applied	\N	\N	\N	\N	69774	69774	69775
16821	22268	0	applied	\N	\N	\N	\N	69803	69803	69804
16821	22269	1	applied	\N	\N	\N	\N	69805	69805	69806
16821	22270	2	applied	\N	\N	\N	\N	69807	69807	57982
16823	22271	0	applied	\N	\N	\N	\N	69810	69810	69811
16823	22272	1	applied	\N	\N	\N	\N	69812	69812	57984
16828	22277	0	applied	\N	\N	\N	\N	69825	69825	69826
16828	22278	1	applied	\N	\N	\N	\N	69827	69827	57995
16828	22279	2	applied	\N	\N	\N	\N	69828	69828	69829
16830	22280	0	applied	\N	\N	\N	\N	69833	69833	69834
16830	22281	1	applied	\N	\N	\N	\N	69835	69835	69836
16830	22282	2	applied	\N	\N	\N	\N	69837	69837	69838
16834	22283	0	applied	\N	\N	\N	\N	69843	69843	69844
16834	22284	1	applied	\N	\N	\N	\N	69845	69845	69846
16834	22285	2	applied	\N	\N	\N	\N	69847	69847	69848
16834	22286	3	applied	\N	\N	\N	\N	69849	69849	58017
16836	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16836	21784	1	applied	\N	\N	\N	\N	68404	68404	68405
16836	21854	2	applied	\N	\N	\N	\N	68604	68604	68605
16836	21864	3	applied	\N	\N	\N	\N	68626	68626	68627
16836	21865	4	applied	\N	\N	\N	\N	68628	68628	68629
16836	21866	5	applied	\N	\N	\N	\N	68630	68630	68631
16836	21789	6	applied	\N	\N	\N	\N	68414	68414	68415
16836	21790	7	applied	\N	\N	\N	\N	68416	68416	68417
16836	21797	8	applied	\N	\N	\N	\N	68435	68435	68436
16836	22105	9	applied	\N	\N	\N	\N	69338	69338	69310
16836	22109	10	applied	\N	\N	\N	\N	69339	69339	69323
16836	22128	11	applied	\N	\N	\N	\N	69398	69398	69367
16836	21719	12	failed	Receiver_not_present	\N	\N	\N	68234	68234	\N
16836	21691	13	applied	\N	\N	\N	\N	68177	68177	68178
16836	21692	14	applied	\N	\N	\N	\N	68179	68179	68180
16836	21696	15	applied	\N	\N	\N	\N	68186	68186	68187
16836	21697	16	applied	\N	\N	\N	\N	68188	68188	68189
16836	21698	17	applied	\N	\N	\N	\N	68190	68190	68191
16836	21699	18	applied	\N	\N	\N	\N	68192	68192	68193
16785	22202	1	applied	\N	\N	\N	\N	69630	69630	57843
16785	22203	2	applied	\N	\N	\N	\N	69631	69631	69632
16786	21784	0	applied	\N	\N	\N	\N	68404	68404	68405
16786	21854	1	applied	\N	\N	\N	\N	68604	68604	68605
16786	21864	2	applied	\N	\N	\N	\N	68626	68626	68627
16786	21865	3	applied	\N	\N	\N	\N	68628	68628	68629
16786	21866	4	applied	\N	\N	\N	\N	68630	68630	68631
16786	21789	5	applied	\N	\N	\N	\N	68414	68414	68415
16786	21790	6	applied	\N	\N	\N	\N	68416	68416	68417
16786	21797	7	applied	\N	\N	\N	\N	68435	68435	68436
16786	22105	8	applied	\N	\N	\N	\N	69338	69338	69310
16786	22109	9	applied	\N	\N	\N	\N	69339	69339	69323
16786	22128	10	applied	\N	\N	\N	\N	69398	69398	69367
16786	21719	11	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16786	21738	12	applied	\N	\N	1000000000	\N	68334	68334	68292
16786	21746	13	applied	\N	\N	\N	\N	68335	68335	68292
16786	21856	14	applied	\N	\N	\N	\N	68608	68608	62660
16786	21863	15	applied	\N	\N	\N	\N	68620	68620	62660
16786	22103	16	applied	\N	\N	\N	\N	69302	69302	69302
16786	22112	17	applied	\N	\N	\N	\N	69328	69328	69328
16788	22201	0	applied	\N	\N	\N	\N	69628	69628	69629
16788	22202	1	applied	\N	\N	\N	\N	69630	69630	57843
16788	22203	2	applied	\N	\N	\N	\N	69631	69631	69632
16790	22204	0	applied	\N	\N	\N	\N	69640	69640	69641
16790	22205	1	applied	\N	\N	\N	\N	69642	69642	69643
16790	22206	2	applied	\N	\N	\N	\N	69644	69644	69645
16795	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16795	22214	1	applied	\N	\N	\N	\N	69665	69665	69666
16795	22215	2	applied	\N	\N	\N	\N	69667	69667	57861
16795	22216	3	applied	\N	\N	\N	\N	69668	69668	69669
16798	22217	0	applied	\N	\N	\N	\N	69671	69671	69663
16798	22218	1	applied	\N	\N	\N	\N	69672	69672	69673
16798	22219	2	applied	\N	\N	\N	\N	69674	69674	69675
16798	22220	3	applied	\N	\N	\N	\N	69676	69676	69677
16798	22221	4	applied	\N	\N	\N	\N	69678	69678	69679
16798	22222	5	applied	\N	\N	\N	\N	69680	69680	69681
16798	22223	6	applied	\N	\N	\N	\N	69682	69682	69683
16798	22224	7	applied	\N	\N	\N	\N	69684	69684	57871
16798	22225	8	applied	\N	\N	\N	\N	69685	69685	69686
16798	22226	9	applied	\N	\N	\N	\N	69687	69687	69688
16798	22227	10	applied	\N	\N	\N	\N	69689	69689	57889
16800	22231	0	applied	\N	\N	\N	\N	69700	69700	69701
16800	22232	1	applied	\N	\N	\N	\N	69702	69702	69703
16800	22233	2	applied	\N	\N	\N	\N	69704	69704	57900
16800	22234	3	applied	\N	\N	\N	\N	69705	69705	69706
16802	22235	0	applied	\N	\N	\N	\N	69711	69711	69712
16802	22236	1	applied	\N	\N	\N	\N	69713	69713	69714
16802	22237	2	applied	\N	\N	\N	\N	69715	69715	69716
16805	22238	0	applied	\N	\N	\N	\N	69719	69719	69720
16805	22239	1	applied	\N	\N	\N	\N	69721	69721	57909
16805	22240	2	applied	\N	\N	\N	\N	69722	69722	69723
16807	22241	0	applied	\N	\N	\N	\N	69725	69725	69726
16807	22242	1	applied	\N	\N	\N	\N	69727	69727	69728
16814	22246	0	applied	\N	\N	\N	\N	69747	69747	69748
16814	22247	1	applied	\N	\N	\N	\N	69749	69749	69750
16814	22248	2	applied	\N	\N	\N	\N	69751	69751	69752
16814	22249	3	applied	\N	\N	\N	\N	69753	69753	57926
16814	22250	4	applied	\N	\N	\N	\N	69754	69754	57928
16814	22251	5	applied	\N	\N	\N	\N	69755	69755	69756
16814	22252	6	applied	\N	\N	\N	\N	69757	69757	69758
16814	22253	7	applied	\N	\N	\N	\N	69759	69759	69760
16814	22254	8	applied	\N	\N	\N	\N	69761	69761	57943
16814	22255	9	applied	\N	\N	\N	\N	69762	69762	57945
16814	22256	10	applied	\N	\N	\N	\N	69763	69763	69764
16819	22266	0	applied	\N	\N	\N	\N	69797	69797	69798
16819	22267	1	applied	\N	\N	\N	\N	69799	69799	57978
16824	22271	0	applied	\N	\N	\N	\N	69810	69810	69811
16824	22272	1	applied	\N	\N	\N	\N	69812	69812	57984
16826	22273	0	applied	\N	\N	\N	\N	69816	69816	69817
16826	22274	1	applied	\N	\N	\N	\N	69818	69818	57986
16826	22275	2	applied	\N	\N	\N	\N	69819	69819	69820
16826	22276	3	applied	\N	\N	\N	\N	69821	69821	69822
16831	22280	0	applied	\N	\N	\N	\N	69833	69833	69834
16831	22281	1	applied	\N	\N	\N	\N	69835	69835	69836
16831	22282	2	applied	\N	\N	\N	\N	69837	69837	69838
16835	22283	0	applied	\N	\N	\N	\N	69843	69843	69844
16835	22284	1	applied	\N	\N	\N	\N	69845	69845	69846
16835	22285	2	applied	\N	\N	\N	\N	69847	69847	69848
16835	22286	3	applied	\N	\N	\N	\N	69849	69849	58017
16837	22287	0	applied	\N	\N	\N	\N	69855	69855	69856
16837	22288	1	applied	\N	\N	\N	\N	69857	69857	69858
16842	22289	0	applied	\N	\N	\N	\N	69864	69864	69865
16842	22290	1	applied	\N	\N	\N	\N	69866	69866	58022
16842	22291	2	applied	\N	\N	\N	\N	69867	69867	69868
16844	22299	0	applied	\N	\N	\N	\N	69886	69886	69887
16844	22300	1	applied	\N	\N	\N	\N	69888	69888	58058
16844	22301	2	applied	\N	\N	\N	\N	69889	69889	58068
16846	22302	0	applied	\N	\N	\N	\N	69891	69891	69892
16846	22303	1	applied	\N	\N	\N	\N	69893	69893	69894
16846	22304	2	applied	\N	\N	\N	\N	69895	69895	58084
16852	22312	0	applied	\N	\N	\N	\N	69913	69913	69914
16852	22313	1	applied	\N	\N	\N	\N	69915	69915	69916
16852	22314	2	applied	\N	\N	\N	\N	69917	69917	69918
16855	22235	0	applied	\N	\N	\N	\N	69711	69711	69712
16855	22238	1	applied	\N	\N	\N	\N	69719	69719	69720
16855	22241	2	applied	\N	\N	\N	\N	69725	69725	69726
16855	22243	3	applied	\N	\N	\N	\N	69733	69733	69734
16855	22246	4	applied	\N	\N	\N	\N	69747	69747	69748
16855	22247	5	applied	\N	\N	\N	\N	69749	69749	69750
16855	22248	6	applied	\N	\N	\N	\N	69751	69751	69752
16855	22257	7	applied	\N	\N	\N	\N	69772	69772	69773
16855	22259	8	applied	\N	\N	\N	\N	69780	69780	69781
16855	22261	9	applied	\N	\N	\N	\N	69786	69786	69787
16855	22266	10	applied	\N	\N	\N	\N	69797	69797	69798
16855	22268	11	applied	\N	\N	\N	\N	69803	69803	69804
16855	22271	12	applied	\N	\N	\N	\N	69810	69810	69811
16855	22273	13	applied	\N	\N	\N	\N	69816	69816	69817
16855	22277	14	applied	\N	\N	\N	\N	69825	69825	69826
16855	22280	15	applied	\N	\N	\N	\N	69833	69833	69834
16855	22283	16	applied	\N	\N	\N	\N	69843	69843	69844
16855	22287	17	applied	\N	\N	\N	\N	69855	69855	69856
16855	22289	18	applied	\N	\N	\N	\N	69864	69864	69865
16855	22292	20	applied	\N	\N	\N	\N	69872	69872	69873
16855	22293	21	applied	\N	\N	\N	\N	69874	69874	69875
16855	22299	22	applied	\N	\N	\N	\N	69886	69886	69887
16855	22302	23	applied	\N	\N	\N	\N	69891	69891	69892
16855	22305	24	applied	\N	\N	\N	\N	69898	69898	69899
16855	22309	25	applied	\N	\N	\N	\N	69905	69905	69906
16855	22312	26	applied	\N	\N	\N	\N	69913	69913	69914
16829	22279	2	applied	\N	\N	\N	\N	69828	69828	69829
16832	22280	0	applied	\N	\N	\N	\N	69833	69833	69834
16832	22281	1	applied	\N	\N	\N	\N	69835	69835	69836
16832	22282	2	applied	\N	\N	\N	\N	69837	69837	69838
16833	21089	0	applied	\N	\N	\N	\N	66841	66841	66841
16833	21122	1	failed	Receiver_not_present	\N	\N	\N	66908	66908	\N
16833	21243	2	applied	\N	\N	\N	\N	67139	67139	67140
16833	22213	3	applied	\N	\N	1000000000	\N	69663	69663	69664
16833	21247	4	applied	\N	\N	\N	\N	67148	67148	67149
16833	21248	5	applied	\N	\N	\N	\N	67150	67150	67151
16833	21254	6	applied	\N	\N	\N	\N	67162	67162	67163
16833	21150	7	applied	\N	\N	1000000000	\N	66960	66960	66961
16833	21166	8	applied	\N	\N	\N	\N	66987	66987	66961
16833	21784	9	applied	\N	\N	\N	\N	68404	68404	68405
16833	21854	10	applied	\N	\N	\N	\N	68604	68604	68605
16833	21864	11	applied	\N	\N	\N	\N	68626	68626	68627
16833	21865	12	applied	\N	\N	\N	\N	68628	68628	68629
16833	21866	13	applied	\N	\N	\N	\N	68630	68630	68631
16833	21789	14	applied	\N	\N	\N	\N	68414	68414	68415
16833	21790	15	applied	\N	\N	\N	\N	68416	68416	68417
16833	21797	16	applied	\N	\N	\N	\N	68435	68435	68436
16833	21337	17	applied	\N	\N	1000000000	\N	67343	67343	67344
16833	21521	18	applied	\N	\N	1000000000	\N	68064	68064	67804
16833	22105	19	applied	\N	\N	\N	\N	69338	69338	69310
16833	22109	20	applied	\N	\N	\N	\N	69339	69339	69323
16833	22128	21	applied	\N	\N	\N	\N	69398	69398	69367
16833	21462	22	applied	\N	\N	1000000000	\N	67623	67623	67624
16833	21578	23	applied	\N	\N	1000000000	\N	67916	67916	67917
16833	21599	24	applied	\N	\N	1000000000	\N	67960	67960	67961
16833	21409	25	applied	\N	\N	\N	\N	67512	67512	67803
16833	21719	26	failed	Receiver_not_present	\N	\N	\N	5293	5293	\N
16833	21738	27	applied	\N	\N	1000000000	\N	68334	68334	68292
16833	21746	28	applied	\N	\N	\N	\N	68335	68335	68292
16833	22220	29	applied	\N	\N	\N	\N	69742	69742	69677
16833	22221	30	applied	\N	\N	\N	\N	69743	69743	69679
16833	21856	31	applied	\N	\N	\N	\N	68608	68608	62660
16833	21250	32	applied	\N	\N	\N	\N	67154	67154	67155
16833	21863	33	applied	\N	\N	\N	\N	68620	68620	62660
16833	21006	34	applied	\N	\N	\N	\N	66583	66583	66583
16833	21014	35	applied	\N	\N	\N	\N	66594	66594	66594
16833	21314	36	applied	\N	\N	\N	\N	67294	67294	67294
16833	21322	37	applied	\N	\N	\N	\N	67308	67308	67308
16833	21393	38	applied	\N	\N	\N	\N	67477	67477	67477
16833	21403	39	applied	\N	\N	\N	\N	67498	67498	67498
16833	21405	40	applied	\N	\N	\N	\N	67501	67501	67501
16833	21413	41	applied	\N	\N	\N	\N	67518	67518	67518
16833	21421	42	applied	\N	\N	\N	\N	67533	67533	67533
16833	22103	43	applied	\N	\N	\N	\N	69302	69302	69302
16833	22112	44	applied	\N	\N	\N	\N	69328	69328	69328
16838	22287	0	applied	\N	\N	\N	\N	69855	69855	69856
16838	22288	1	applied	\N	\N	\N	\N	69857	69857	69858
16845	22299	0	applied	\N	\N	\N	\N	69886	69886	69887
16845	22300	1	applied	\N	\N	\N	\N	69888	69888	58058
16845	22301	2	applied	\N	\N	\N	\N	69889	69889	58068
16847	22302	0	applied	\N	\N	\N	\N	69891	69891	69892
16847	22303	1	applied	\N	\N	\N	\N	69893	69893	69894
16847	22304	2	applied	\N	\N	\N	\N	69895	69895	58084
16849	22309	0	applied	\N	\N	\N	\N	69905	69905	69906
16849	22310	1	applied	\N	\N	\N	\N	69907	69907	69908
16849	22311	2	applied	\N	\N	\N	\N	69909	69909	69910
16853	22312	0	applied	\N	\N	\N	\N	69913	69913	69914
16853	22313	1	applied	\N	\N	\N	\N	69915	69915	69916
16853	22314	2	applied	\N	\N	\N	\N	69917	69917	69918
16865	22322	0	applied	\N	\N	\N	\N	69954	69954	69955
16865	22323	1	applied	\N	\N	\N	\N	69956	69956	69957
16865	22324	2	applied	\N	\N	\N	\N	69958	69958	69959
16868	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16868	22057	1	applied	\N	\N	\N	\N	69090	69090	69399
16868	22058	2	applied	\N	\N	\N	\N	69092	69092	69400
16868	22059	3	applied	\N	\N	\N	\N	69094	69094	69401
16868	22067	4	applied	\N	\N	\N	\N	69109	69109	69402
16868	22070	5	applied	\N	\N	\N	\N	69114	69114	69403
16868	22105	6	applied	\N	\N	\N	\N	69338	69338	69310
16868	22109	7	applied	\N	\N	\N	\N	69339	69339	69323
16868	22128	8	applied	\N	\N	\N	\N	69398	69398	69367
16868	22073	9	applied	\N	\N	\N	\N	69129	69129	69404
16868	22074	10	applied	\N	\N	\N	\N	69131	69131	69405
16868	22080	11	applied	\N	\N	\N	\N	69232	69232	69406
16868	22083	12	applied	\N	\N	\N	\N	69252	69252	69407
16868	22087	13	applied	\N	\N	\N	\N	69262	69262	69408
16868	22088	14	applied	\N	\N	\N	\N	69264	69264	69409
16868	22092	15	applied	\N	\N	\N	\N	69276	69276	69410
16868	22095	16	applied	\N	\N	\N	\N	69284	69284	69411
16868	22097	17	applied	\N	\N	\N	\N	69289	69289	69412
16868	22100	18	applied	\N	\N	\N	\N	69297	69297	69413
16868	22104	19	applied	\N	\N	\N	\N	69307	69307	69414
16868	22110	20	applied	\N	\N	\N	\N	69324	69324	69415
16868	22111	21	applied	\N	\N	\N	\N	69326	69326	69416
16868	22117	22	applied	\N	\N	\N	\N	69343	69343	69417
16868	22118	23	applied	\N	\N	\N	\N	69345	69345	69418
16868	22119	24	applied	\N	\N	\N	\N	69347	69347	69419
16868	22127	25	applied	\N	\N	\N	\N	69364	69364	69420
16868	22131	26	applied	\N	\N	\N	\N	69376	69376	69421
16868	22134	27	applied	\N	\N	\N	\N	69381	69381	69422
16868	22137	28	applied	\N	\N	\N	\N	69389	69389	69469
16868	22143	29	applied	\N	\N	\N	\N	69451	69451	69470
16868	22146	30	applied	\N	\N	\N	\N	69459	69459	69471
16868	22149	31	applied	\N	\N	\N	\N	69463	69463	69473
16868	22151	32	applied	\N	\N	\N	\N	69490	69490	69517
16868	22155	33	applied	\N	\N	\N	\N	69496	69496	69518
16868	22158	34	applied	\N	\N	\N	\N	69502	69502	69519
16868	22159	35	applied	\N	\N	\N	\N	69504	69504	69520
16868	22165	36	applied	\N	\N	\N	\N	69529	69529	69610
16868	22166	37	applied	\N	\N	\N	\N	69531	69531	69611
16868	22167	38	applied	\N	\N	\N	\N	69533	69533	69612
16868	22168	39	applied	\N	\N	\N	\N	69535	69535	69613
16868	22178	40	applied	\N	\N	\N	\N	69555	69555	69614
16868	22181	41	applied	\N	\N	\N	\N	69563	69563	69615
16868	22182	42	applied	\N	\N	\N	\N	69565	69565	69616
16868	22188	43	applied	\N	\N	\N	\N	69577	69577	69617
16868	22191	44	applied	\N	\N	\N	\N	69584	69584	69618
16868	22194	45	applied	\N	\N	\N	\N	69589	69589	69619
16868	22195	46	applied	\N	\N	\N	\N	69591	69591	69620
16868	22201	47	applied	\N	\N	\N	\N	69628	69628	69974
16868	22204	48	applied	\N	\N	\N	\N	69640	69640	69975
16868	22207	49	applied	\N	\N	\N	\N	69646	69646	69976
16868	22210	50	applied	\N	\N	\N	\N	69655	69655	69977
16868	22214	51	applied	\N	\N	\N	\N	69665	69665	69978
16836	21709	19	applied	\N	\N	\N	\N	68211	68211	68212
16836	21712	20	applied	\N	\N	\N	\N	68219	68219	68220
16836	21715	21	applied	\N	\N	\N	\N	68228	68228	68229
16836	21718	22	applied	\N	\N	\N	\N	68232	68232	68233
16836	21724	23	applied	\N	\N	\N	\N	68242	68242	68243
16836	21727	24	applied	\N	\N	\N	\N	68247	68247	68248
16836	21731	25	applied	\N	\N	\N	\N	68275	68275	68276
16836	21732	27	applied	\N	\N	\N	\N	68277	68277	68278
16836	21737	28	applied	\N	\N	\N	\N	68289	68289	68290
16836	21741	29	applied	\N	\N	\N	\N	68300	68300	68301
16836	21745	30	applied	\N	\N	\N	\N	68307	68307	68308
16836	21749	31	applied	\N	\N	\N	\N	68318	68318	68319
16836	21752	32	applied	\N	\N	\N	\N	68325	68325	68326
16836	21756	33	applied	\N	\N	\N	\N	68338	68338	68339
16836	21738	34	applied	\N	\N	1000000000	\N	68291	68291	68292
16836	21746	35	applied	\N	\N	\N	\N	68309	68309	68292
16836	21757	36	applied	\N	\N	\N	\N	68340	68340	68341
16836	21758	37	applied	\N	\N	\N	\N	68342	68342	68343
16836	21766	38	applied	\N	\N	\N	\N	68358	68358	68359
16836	21767	39	applied	\N	\N	\N	\N	68360	68360	68361
16836	21772	40	applied	\N	\N	\N	\N	68376	68376	68377
16836	21773	41	applied	\N	\N	\N	\N	68378	68378	68379
16836	21778	42	applied	\N	\N	\N	\N	68390	68390	68391
16836	21779	43	applied	\N	\N	\N	\N	68392	68392	68393
16836	21785	44	applied	\N	\N	\N	\N	68406	68406	68407
16836	21791	45	applied	\N	\N	\N	\N	68418	68418	68419
16836	21794	46	applied	\N	\N	\N	\N	68425	68425	68426
16836	21799	47	applied	\N	\N	\N	\N	68440	68440	68441
16836	21803	48	applied	\N	\N	\N	\N	68449	68449	68450
16836	21806	49	applied	\N	\N	\N	\N	68460	68460	68461
16836	21810	50	applied	\N	\N	\N	\N	68470	68470	68471
16836	21812	51	applied	\N	\N	\N	\N	68491	68491	68492
16836	21816	52	applied	\N	\N	\N	\N	68500	68500	68501
16836	21819	53	applied	\N	\N	\N	\N	68506	68506	68507
16836	21822	54	applied	\N	\N	\N	\N	68512	68512	68513
16836	21826	55	applied	\N	\N	\N	\N	68521	68521	68522
16836	21830	56	applied	\N	\N	\N	\N	68526	68526	68527
16836	21833	57	applied	\N	\N	\N	\N	68531	68531	68532
16836	21836	58	applied	\N	\N	\N	\N	68544	68544	68545
16836	21838	59	applied	\N	\N	\N	\N	68549	68549	68550
16836	21841	60	applied	\N	\N	\N	\N	68558	68558	68559
16836	21842	61	applied	\N	\N	\N	\N	68560	68560	68561
16836	21848	62	applied	\N	\N	\N	\N	68573	68573	68574
16836	21851	63	applied	\N	\N	\N	\N	68579	68579	68580
16836	21855	64	applied	\N	\N	\N	\N	68606	68606	68607
16836	21860	65	applied	\N	\N	\N	\N	68615	68615	68616
16836	21867	66	applied	\N	\N	\N	\N	68632	68632	68633
16836	21870	67	applied	\N	\N	\N	\N	68638	68638	68639
16836	21873	68	applied	\N	\N	\N	\N	68644	68644	68645
16836	21874	69	applied	\N	\N	\N	\N	68646	68646	68647
16841	22289	0	applied	\N	\N	\N	\N	69864	69864	69865
16841	22290	1	applied	\N	\N	\N	\N	69866	69866	58022
16841	22291	2	applied	\N	\N	\N	\N	69867	69867	69868
16843	22292	0	applied	\N	\N	\N	\N	69872	69872	69873
16843	22293	1	applied	\N	\N	\N	\N	69874	69874	69875
16843	22294	2	applied	\N	\N	\N	\N	69876	69876	69877
16843	22295	3	applied	\N	\N	\N	\N	69878	69878	69879
16843	22296	4	applied	\N	\N	\N	\N	69880	69880	69881
16843	22297	5	applied	\N	\N	\N	\N	69882	69882	58054
16843	22298	6	applied	\N	\N	\N	\N	69883	69883	58056
16848	22305	0	applied	\N	\N	\N	\N	69898	69898	69899
16848	22306	1	applied	\N	\N	\N	\N	69900	69900	58101
16848	22307	2	applied	\N	\N	\N	\N	69901	69901	69902
16848	22308	3	applied	\N	\N	\N	\N	69903	69903	58147
16851	22312	0	applied	\N	\N	\N	\N	69913	69913	69914
16851	22313	1	applied	\N	\N	\N	\N	69915	69915	69916
16851	22314	2	applied	\N	\N	\N	\N	69917	69917	69918
16864	22322	0	applied	\N	\N	\N	\N	69954	69954	69955
16864	22323	1	applied	\N	\N	\N	\N	69956	69956	69957
16864	22324	2	applied	\N	\N	\N	\N	69958	69958	69959
16866	22325	0	applied	\N	\N	\N	\N	69964	69964	69965
16866	22326	1	applied	\N	\N	\N	\N	69966	69966	58282
16866	22327	2	applied	\N	\N	\N	\N	69967	69967	69968
16866	22328	3	applied	\N	\N	\N	\N	69969	69969	69970
16870	22329	0	applied	\N	\N	\N	\N	70014	70014	70028
16870	22330	1	applied	\N	\N	\N	\N	70016	70016	70029
16870	22331	2	applied	\N	\N	\N	\N	70018	70018	70030
16870	22332	3	applied	\N	\N	\N	\N	70020	70020	70031
16870	22333	4	applied	\N	\N	\N	\N	70032	70032	70033
16870	22334	5	applied	\N	\N	\N	\N	70034	70034	70035
16870	22335	6	applied	\N	\N	\N	\N	70036	70036	70037
16870	22336	7	applied	\N	\N	\N	\N	70038	70038	58394
16870	22337	8	applied	\N	\N	\N	\N	70039	70039	70040
16870	22338	9	applied	\N	\N	\N	\N	70041	70041	70042
16870	22339	10	applied	\N	\N	\N	\N	70043	70043	70044
16870	22340	11	applied	\N	\N	\N	\N	70045	70045	70046
16870	22341	12	applied	\N	\N	\N	\N	70047	70047	70048
16874	22344	0	applied	\N	\N	\N	\N	70060	70060	70061
16874	22345	1	applied	\N	\N	\N	\N	70062	70062	70063
16874	22346	2	applied	\N	\N	\N	\N	70064	70064	58464
16874	22347	3	applied	\N	\N	\N	\N	70065	70065	58544
16876	22348	0	applied	\N	\N	\N	\N	70069	70069	70070
16876	22349	1	applied	\N	\N	\N	\N	70071	70071	70072
16876	22350	2	applied	\N	\N	\N	\N	70073	70073	70074
16876	22351	3	applied	\N	\N	\N	\N	70075	70075	58546
16876	22352	4	applied	\N	\N	\N	\N	70076	70076	70077
16876	22353	5	applied	\N	\N	\N	\N	70078	70078	70079
16876	22354	6	applied	\N	\N	\N	\N	70080	70080	70081
16876	22355	7	applied	\N	\N	\N	\N	70082	70082	70083
16876	22356	8	applied	\N	\N	\N	\N	70084	70084	70085
16884	22378	0	applied	\N	\N	\N	\N	70135	70135	70136
16884	22379	1	applied	\N	\N	\N	\N	70137	70137	70138
16884	22380	2	applied	\N	\N	\N	\N	70139	70139	58745
16884	22381	3	applied	\N	\N	\N	\N	70140	70140	58747
16887	22382	0	applied	\N	\N	\N	\N	70156	70156	70157
16887	22383	1	applied	\N	\N	\N	\N	70158	70158	70159
16887	22384	2	applied	\N	\N	\N	\N	70160	70160	70161
16889	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16889	21905	1	applied	\N	\N	\N	\N	68719	68719	68720
16889	21906	2	applied	\N	\N	\N	\N	68721	68721	68722
16889	21911	3	applied	\N	\N	\N	\N	68732	68732	68733
16889	21912	4	applied	\N	\N	\N	\N	68734	68734	68735
16889	21918	5	applied	\N	\N	\N	\N	68750	68750	68751
16889	21921	6	applied	\N	\N	\N	\N	68758	68758	68759
16889	21924	7	applied	\N	\N	\N	\N	68764	68764	68765
16889	21925	8	applied	\N	\N	\N	\N	68766	68766	68767
16889	21926	9	applied	\N	\N	\N	\N	68768	68768	68769
16889	21933	10	applied	\N	\N	\N	\N	68784	68784	68785
16889	21936	11	applied	\N	\N	\N	\N	68796	68796	68797
16855	22245	27	applied	\N	\N	\N	\N	69737	69737	69927
16855	22249	28	applied	\N	\N	\N	\N	69753	69753	57902
16855	22262	29	applied	\N	\N	\N	\N	69788	69788	69714
16855	22275	30	applied	\N	\N	\N	\N	69819	69819	57907
16855	22236	31	applied	\N	\N	\N	\N	69713	69713	57909
16855	22286	32	applied	\N	\N	\N	\N	69849	69849	69928
16855	22296	33	applied	\N	\N	\N	\N	69880	69880	57920
16855	22307	34	applied	\N	\N	\N	\N	69901	69901	69723
16855	22240	35	applied	\N	\N	\N	\N	69722	69722	69728
16855	22242	36	applied	\N	\N	\N	\N	69727	69727	69738
16855	22253	37	applied	\N	\N	\N	\N	69759	69759	57928
16855	22254	38	applied	\N	\N	\N	\N	69761	69761	57930
16855	22255	39	applied	\N	\N	\N	\N	69762	69762	69929
16855	22256	40	applied	\N	\N	\N	\N	69763	69763	69930
16855	22258	41	applied	\N	\N	\N	\N	69774	69774	69931
16855	22264	42	applied	\N	\N	\N	\N	69792	69792	57953
16855	22265	43	applied	\N	\N	\N	\N	69794	69794	57955
16855	22267	44	applied	\N	\N	\N	\N	69799	69799	69783
16855	22269	45	applied	\N	\N	\N	\N	69805	69805	69791
16855	22274	46	applied	\N	\N	\N	\N	69818	69818	69793
16855	22276	47	applied	\N	\N	\N	\N	69821	69821	57976
16855	22278	48	applied	\N	\N	\N	\N	69827	69827	57978
16855	22282	49	applied	\N	\N	\N	\N	69837	69837	69806
16855	22285	50	applied	\N	\N	\N	\N	69847	69847	69932
16855	22288	51	applied	\N	\N	\N	\N	69857	69857	69933
16855	22291	52	applied	\N	\N	\N	\N	69867	69867	57988
16855	22294	53	applied	\N	\N	\N	\N	69876	69876	57990
16855	22297	54	applied	\N	\N	\N	\N	69882	69882	69934
16855	22300	55	applied	\N	\N	\N	\N	69888	69888	69836
16855	22304	56	applied	\N	\N	\N	\N	69895	69895	69838
16855	22306	57	applied	\N	\N	\N	\N	69900	69900	58015
16855	22311	58	applied	\N	\N	\N	\N	69909	69909	58017
16855	22313	59	applied	\N	\N	\N	\N	69915	69915	69858
16855	22237	60	applied	\N	\N	\N	\N	69715	69715	58022
16855	22239	61	applied	\N	\N	\N	\N	69721	69721	58028
16855	22244	62	applied	\N	\N	\N	\N	69735	69735	69935
16855	22250	63	applied	\N	\N	\N	\N	69754	69754	69877
16855	22251	64	applied	\N	\N	\N	\N	69755	69755	69879
16855	22252	65	applied	\N	\N	\N	\N	69757	69757	58047
16855	22260	66	applied	\N	\N	\N	\N	69782	69782	58054
16855	22263	67	applied	\N	\N	\N	\N	69790	69790	58056
16855	22270	68	applied	\N	\N	\N	\N	69807	69807	69936
16855	22272	69	applied	\N	\N	\N	\N	69812	69812	69937
16855	22279	70	applied	\N	\N	\N	\N	69828	69828	69938
16855	22281	71	applied	\N	\N	\N	\N	69835	69835	58070
16855	22284	72	applied	\N	\N	\N	\N	69845	69845	58084
16855	22290	73	applied	\N	\N	\N	\N	69866	69866	69939
16855	22295	74	applied	\N	\N	\N	\N	69878	69878	69902
16855	22298	75	applied	\N	\N	\N	\N	69883	69883	58147
16855	22301	76	applied	\N	\N	\N	\N	69889	69889	69908
16855	22303	77	applied	\N	\N	\N	\N	69893	69893	69940
16855	22308	78	applied	\N	\N	\N	\N	69903	69903	58151
16855	22310	79	applied	\N	\N	\N	\N	69907	69907	69916
16855	22314	80	applied	\N	\N	\N	\N	69917	69917	69918
16875	22344	0	applied	\N	\N	\N	\N	70060	70060	70061
16875	22345	1	applied	\N	\N	\N	\N	70062	70062	70063
16875	22346	2	applied	\N	\N	\N	\N	70064	70064	58464
16875	22347	3	applied	\N	\N	\N	\N	70065	70065	58544
16877	22357	0	applied	\N	\N	\N	\N	70088	70088	70089
16877	22358	1	applied	\N	\N	\N	\N	70090	70090	70091
16877	22359	2	applied	\N	\N	\N	\N	70092	70092	70093
16877	22360	3	applied	\N	\N	\N	\N	70094	70094	70095
16880	22372	0	applied	\N	\N	\N	\N	70118	70118	70119
16880	22373	1	applied	\N	\N	\N	\N	70120	70120	70121
16880	22374	2	applied	\N	\N	\N	\N	70122	70122	70123
16885	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16885	22083	1	applied	\N	\N	\N	\N	69252	69252	69253
16885	22105	2	applied	\N	\N	\N	\N	69338	69338	69310
16885	22109	3	applied	\N	\N	\N	\N	69339	69339	69323
16885	22128	4	applied	\N	\N	\N	\N	69398	69398	69367
16885	22087	5	applied	\N	\N	\N	\N	69262	69262	69263
16885	22088	6	applied	\N	\N	\N	\N	69264	69264	69265
16885	22092	7	applied	\N	\N	\N	\N	69276	69276	69277
16885	22095	8	applied	\N	\N	\N	\N	69284	69284	69285
16885	22097	9	applied	\N	\N	\N	\N	69289	69289	69290
16885	22100	10	applied	\N	\N	\N	\N	69297	69297	69298
16885	22104	11	applied	\N	\N	\N	\N	69307	69307	69308
16885	22110	12	applied	\N	\N	\N	\N	69324	69324	69325
16885	22111	13	applied	\N	\N	\N	\N	69326	69326	69327
16885	22117	14	applied	\N	\N	\N	\N	69343	69343	69344
16885	22118	15	applied	\N	\N	\N	\N	69345	69345	69346
16885	22119	16	applied	\N	\N	\N	\N	69347	69347	69348
16885	22127	17	applied	\N	\N	\N	\N	69364	69364	69365
16885	22131	18	applied	\N	\N	\N	\N	69376	69376	69377
16885	22134	19	applied	\N	\N	\N	\N	69381	69381	69382
16885	22137	20	applied	\N	\N	\N	\N	69389	69389	69390
16885	22143	21	applied	\N	\N	\N	\N	69451	69451	69452
16885	22146	22	applied	\N	\N	\N	\N	69459	69459	69460
16885	22149	23	applied	\N	\N	\N	\N	69463	69463	69464
16885	22151	24	applied	\N	\N	\N	\N	69490	69490	69491
16885	22155	25	applied	\N	\N	\N	\N	69496	69496	69497
16885	22158	26	applied	\N	\N	\N	\N	69502	69502	69503
16885	22159	27	applied	\N	\N	\N	\N	69504	69504	69505
16885	22165	28	applied	\N	\N	\N	\N	69529	69529	69530
16885	22166	29	applied	\N	\N	\N	\N	69531	69531	69532
16885	22167	30	applied	\N	\N	\N	\N	69533	69533	69534
16885	22168	31	applied	\N	\N	\N	\N	69535	69535	69536
16885	22178	32	applied	\N	\N	\N	\N	69555	69555	69556
16885	22181	33	applied	\N	\N	\N	\N	69563	69563	69564
16885	22182	34	applied	\N	\N	\N	\N	69565	69565	69566
16885	22188	35	applied	\N	\N	\N	\N	69577	69577	69578
16885	22191	36	applied	\N	\N	\N	\N	69584	69584	69585
16885	22194	37	applied	\N	\N	\N	\N	69589	69589	69590
16885	22195	38	applied	\N	\N	\N	\N	69591	69591	69592
16885	22201	39	applied	\N	\N	\N	\N	69628	69628	69629
16885	22204	40	applied	\N	\N	\N	\N	69640	69640	69641
16885	22207	41	applied	\N	\N	\N	\N	69646	69646	69647
16885	22210	42	applied	\N	\N	\N	\N	69655	69655	69656
16885	22214	43	applied	\N	\N	\N	\N	69665	69665	69666
16885	22218	44	applied	\N	\N	\N	\N	69672	69672	69673
16885	22219	45	applied	\N	\N	\N	\N	69674	69674	69675
16885	22228	46	applied	\N	\N	\N	\N	69693	69693	69694
16885	22231	47	applied	\N	\N	\N	\N	69700	69700	69701
16885	22235	48	applied	\N	\N	\N	\N	69711	69711	69712
16885	22238	49	applied	\N	\N	\N	\N	69719	69719	69720
16885	22241	50	applied	\N	\N	\N	\N	69725	69725	69726
16885	22243	51	applied	\N	\N	\N	\N	69733	69733	69734
16885	22246	52	applied	\N	\N	\N	\N	69747	69747	69748
16885	22247	53	applied	\N	\N	\N	\N	69749	69749	69750
16885	22248	54	applied	\N	\N	\N	\N	69751	69751	69752
16868	22218	52	applied	\N	\N	\N	\N	69672	69672	69979
16868	22219	53	applied	\N	\N	\N	\N	69674	69674	69980
16868	22228	54	applied	\N	\N	\N	\N	69693	69693	69981
16868	22231	55	applied	\N	\N	\N	\N	69700	69700	69982
16868	22235	56	applied	\N	\N	\N	\N	69711	69711	69983
16868	22238	57	applied	\N	\N	\N	\N	69719	69719	69984
16868	22241	58	applied	\N	\N	\N	\N	69725	69725	69985
16868	22243	59	applied	\N	\N	\N	\N	69733	69733	69986
16868	22246	60	applied	\N	\N	\N	\N	69747	69747	69987
16868	22247	61	applied	\N	\N	\N	\N	69749	69749	69988
16868	22248	62	applied	\N	\N	\N	\N	69751	69751	69989
16868	22257	64	applied	\N	\N	\N	\N	69772	69772	69991
16868	22259	65	applied	\N	\N	\N	\N	69780	69780	69992
16868	22261	66	applied	\N	\N	\N	\N	69786	69786	69993
16868	22266	67	applied	\N	\N	\N	\N	69797	69797	69994
16868	22268	68	applied	\N	\N	\N	\N	69803	69803	69995
16868	22271	69	applied	\N	\N	\N	\N	69810	69810	69996
16868	22273	70	applied	\N	\N	\N	\N	69816	69816	69997
16868	22277	71	applied	\N	\N	\N	\N	69825	69825	69998
16868	22280	72	applied	\N	\N	\N	\N	69833	69833	69999
16868	22283	73	applied	\N	\N	\N	\N	69843	69843	70000
16868	22287	74	applied	\N	\N	\N	\N	69855	69855	70001
16868	22289	75	applied	\N	\N	\N	\N	69864	69864	70002
16868	22292	76	applied	\N	\N	\N	\N	69872	69872	70003
16868	22293	77	applied	\N	\N	\N	\N	69874	69874	70004
16868	22299	78	applied	\N	\N	\N	\N	69886	69886	70005
16868	22302	79	applied	\N	\N	\N	\N	69891	69891	70006
16868	22305	80	applied	\N	\N	\N	\N	69898	69898	70007
16868	22309	81	applied	\N	\N	\N	\N	69905	69905	70008
16868	22312	82	applied	\N	\N	\N	\N	69913	69913	70009
16868	22315	83	applied	\N	\N	\N	\N	69943	69943	70010
16868	22316	84	applied	\N	\N	\N	\N	69945	69945	70011
16868	22322	85	applied	\N	\N	\N	\N	69954	69954	70012
16868	22325	86	applied	\N	\N	\N	\N	69964	69964	70013
16868	22329	87	applied	\N	\N	\N	\N	70014	70014	70015
16868	22330	88	applied	\N	\N	\N	\N	70016	70016	70017
16868	22331	89	applied	\N	\N	\N	\N	70018	70018	70019
16868	22332	90	applied	\N	\N	\N	\N	70020	70020	70021
16868	22220	91	applied	\N	\N	\N	\N	70022	70022	69677
16868	22221	92	applied	\N	\N	\N	\N	70023	70023	69679
16868	22222	93	applied	\N	\N	\N	\N	70024	70024	69681
16868	22223	94	applied	\N	\N	\N	\N	70025	70025	69683
16868	21891	95	applied	\N	\N	\N	\N	68684	68684	56677
16868	21908	96	applied	\N	\N	\N	\N	68725	68725	69061
16868	21913	97	applied	\N	\N	\N	\N	68736	68736	68399
16868	21927	98	applied	\N	\N	\N	\N	68770	68770	56684
16868	21938	99	applied	\N	\N	\N	\N	68800	68800	68401
16868	21950	100	applied	\N	\N	\N	\N	68827	68827	56686
16868	21954	101	applied	\N	\N	\N	\N	68835	68835	56688
16868	21968	102	applied	\N	\N	\N	\N	68862	68862	68410
16868	21977	103	applied	\N	\N	\N	\N	68876	68876	68585
16868	21989	104	applied	\N	\N	\N	\N	68909	68909	56697
16868	22004	105	applied	\N	\N	\N	\N	68935	68935	68412
16868	22011	106	applied	\N	\N	\N	\N	68948	68948	56699
16868	22023	107	applied	\N	\N	\N	\N	68980	68980	56701
16868	22034	108	applied	\N	\N	\N	\N	69001	69001	69062
16868	22043	109	applied	\N	\N	\N	\N	69018	69018	68586
16868	22053	110	applied	\N	\N	\N	\N	69045	69045	56703
16868	22062	111	applied	\N	\N	\N	\N	69098	69098	68587
16868	22079	112	applied	\N	\N	\N	\N	69138	69138	56705
16868	22085	113	applied	\N	\N	\N	\N	69256	69256	56707
16868	22096	114	applied	\N	\N	\N	\N	69286	69286	69063
16868	22103	115	applied	\N	\N	\N	\N	69302	69302	69302
16868	22112	116	applied	\N	\N	\N	\N	69328	69328	69328
16868	22108	117	applied	\N	\N	\N	\N	69314	69314	68429
16868	22122	118	applied	\N	\N	\N	\N	69353	69353	56719
16868	22133	119	applied	\N	\N	\N	\N	69380	69380	69064
16868	22140	120	applied	\N	\N	\N	\N	69439	69439	56721
16868	22153	121	applied	\N	\N	\N	\N	69494	69494	56723
16868	22164	122	applied	\N	\N	\N	\N	69511	69511	69065
16868	22175	123	applied	\N	\N	\N	\N	69547	69547	68445
16868	22183	124	applied	\N	\N	\N	\N	69567	69567	56725
16868	22197	125	applied	\N	\N	\N	\N	69594	69594	68453
16871	22329	0	applied	\N	\N	\N	\N	70014	70014	70028
16871	22330	1	applied	\N	\N	\N	\N	70016	70016	70029
16871	22331	2	applied	\N	\N	\N	\N	70018	70018	70030
16871	22332	3	applied	\N	\N	\N	\N	70020	70020	70031
16871	22333	4	applied	\N	\N	\N	\N	70032	70032	70033
16871	22334	5	applied	\N	\N	\N	\N	70034	70034	70035
16871	22335	6	applied	\N	\N	\N	\N	70036	70036	70037
16871	22336	7	applied	\N	\N	\N	\N	70038	70038	58394
16871	22337	8	applied	\N	\N	\N	\N	70039	70039	70040
16871	22338	9	applied	\N	\N	\N	\N	70041	70041	70042
16871	22339	10	applied	\N	\N	\N	\N	70043	70043	70044
16871	22340	11	applied	\N	\N	\N	\N	70045	70045	70046
16871	22341	12	applied	\N	\N	\N	\N	70047	70047	70048
16872	22342	0	applied	\N	\N	\N	\N	70055	70055	70056
16872	22343	1	applied	\N	\N	\N	\N	70057	70057	70058
16881	22372	0	applied	\N	\N	\N	\N	70118	70118	70119
16881	22373	1	applied	\N	\N	\N	\N	70120	70120	70121
16881	22374	2	applied	\N	\N	\N	\N	70122	70122	70123
16883	22375	0	applied	\N	\N	\N	\N	70130	70130	70131
16883	22376	1	applied	\N	\N	\N	\N	70132	70132	58730
16883	22377	2	applied	\N	\N	\N	\N	70133	70133	58737
16890	22385	0	applied	\N	\N	\N	\N	70164	70164	70165
16890	22386	1	applied	\N	\N	\N	\N	70166	70166	70167
16890	22387	2	applied	\N	\N	\N	\N	70168	70168	70169
16892	22388	0	applied	\N	\N	\N	\N	70179	70179	70180
16892	22389	1	applied	\N	\N	\N	\N	70181	70181	70182
16892	22390	2	applied	\N	\N	\N	\N	70183	70183	58793
16895	22391	0	applied	\N	\N	\N	\N	70185	70185	70186
16895	22392	1	applied	\N	\N	\N	\N	70187	70187	70188
16895	22393	2	applied	\N	\N	\N	\N	70189	70189	58795
16895	22394	3	applied	\N	\N	\N	\N	70190	70190	58797
16897	22397	0	applied	\N	\N	\N	\N	70199	70199	65473
16897	22400	1	applied	\N	\N	\N	\N	70202	70202	70208
16897	22401	2	applied	\N	\N	\N	\N	70204	70204	70209
16903	22405	0	applied	\N	\N	\N	\N	70221	70221	70222
16903	22406	1	applied	\N	\N	\N	\N	70223	70223	70224
16903	22407	2	applied	\N	\N	\N	\N	70225	70225	70226
16909	22421	0	applied	\N	\N	\N	\N	70256	70256	70257
16909	22422	1	applied	\N	\N	\N	\N	70258	70258	70259
16909	22423	2	applied	\N	\N	\N	\N	70260	70260	70261
16909	22424	3	applied	\N	\N	\N	\N	70262	70262	70263
16909	22425	4	applied	\N	\N	\N	\N	70264	70264	70265
16909	22426	5	applied	\N	\N	\N	\N	70266	70266	58919
16909	22427	6	applied	\N	\N	\N	\N	70267	70267	58925
16912	22421	0	applied	\N	\N	\N	\N	70256	70256	70257
16912	22422	1	applied	\N	\N	\N	\N	70258	70258	70259
16912	22423	2	applied	\N	\N	\N	\N	70260	70260	70261
16885	22257	55	applied	\N	\N	\N	\N	69772	69772	69773
16885	22259	56	applied	\N	\N	\N	\N	69780	69780	69781
16885	22261	57	applied	\N	\N	\N	\N	69786	69786	69787
16885	22266	58	applied	\N	\N	\N	\N	69797	69797	69798
16885	22268	59	applied	\N	\N	\N	\N	69803	69803	69804
16885	22271	60	applied	\N	\N	\N	\N	69810	69810	69811
16885	22273	61	applied	\N	\N	\N	\N	69816	69816	69817
16885	22277	62	applied	\N	\N	\N	\N	69825	69825	69826
16885	22280	63	applied	\N	\N	\N	\N	69833	69833	69834
16885	22283	64	applied	\N	\N	\N	\N	69843	69843	69844
16885	22287	65	applied	\N	\N	\N	\N	69855	69855	69856
16885	22289	66	applied	\N	\N	\N	\N	69864	69864	69865
16885	22292	67	applied	\N	\N	\N	\N	69872	69872	69873
16885	22293	68	applied	\N	\N	\N	\N	69874	69874	69875
16885	22299	69	applied	\N	\N	\N	\N	69886	69886	69887
16885	22302	70	applied	\N	\N	\N	\N	69891	69891	69892
16885	22305	71	applied	\N	\N	\N	\N	69898	69898	69899
16885	22309	72	applied	\N	\N	\N	\N	69905	69905	69906
16885	22312	73	applied	\N	\N	\N	\N	69913	69913	69914
16885	22315	74	applied	\N	\N	\N	\N	69943	69943	69944
16885	22316	75	applied	\N	\N	\N	\N	69945	69945	69946
16885	22322	76	applied	\N	\N	\N	\N	69954	69954	69955
16885	22325	77	applied	\N	\N	\N	\N	69964	69964	69965
16885	22329	78	applied	\N	\N	\N	\N	70014	70014	70028
16885	22330	79	applied	\N	\N	\N	\N	70016	70016	70029
16885	22331	80	applied	\N	\N	\N	\N	70018	70018	70030
16885	22332	81	applied	\N	\N	\N	\N	70020	70020	70031
16885	22342	82	applied	\N	\N	\N	\N	70055	70055	70056
16885	22344	83	applied	\N	\N	\N	\N	70060	70060	70061
16885	22348	84	applied	\N	\N	\N	\N	70069	70069	70070
16885	22349	85	applied	\N	\N	\N	\N	70071	70071	70072
16885	22350	86	applied	\N	\N	\N	\N	70073	70073	70074
16885	22357	87	applied	\N	\N	\N	\N	70088	70088	70089
16885	22361	88	applied	\N	\N	\N	\N	70098	70098	70099
16885	22362	89	applied	\N	\N	\N	\N	70100	70100	70101
16885	22363	90	applied	\N	\N	\N	\N	70102	70102	70103
16885	22372	91	applied	\N	\N	\N	\N	70118	70118	70119
16885	22375	92	applied	\N	\N	\N	\N	70130	70130	70131
16885	22378	93	applied	\N	\N	\N	\N	70135	70135	70136
16885	22220	94	applied	\N	\N	\N	\N	69676	69676	69677
16885	22221	95	applied	\N	\N	\N	\N	69678	69678	69679
16885	22222	96	applied	\N	\N	\N	\N	69680	69680	69681
16885	22223	97	applied	\N	\N	\N	\N	69682	69682	69683
16885	22084	98	applied	\N	\N	\N	\N	69254	69254	70143
16885	22089	99	applied	\N	\N	\N	\N	69266	69266	70144
16885	22086	100	applied	\N	\N	\N	\N	69257	69257	70145
16885	22090	101	applied	\N	\N	\N	\N	69267	69267	57537
16885	22091	102	applied	\N	\N	\N	\N	69269	69269	57539
16885	22093	103	applied	\N	\N	\N	\N	69278	69278	70146
16885	22094	104	applied	\N	\N	\N	\N	69280	69280	57543
16885	22098	105	applied	\N	\N	\N	\N	69291	69291	57545
16885	22101	106	applied	\N	\N	\N	\N	69299	69299	69292
16885	22106	107	applied	\N	\N	\N	\N	69311	69311	70147
16885	22099	108	applied	\N	\N	\N	\N	69293	69293	69300
16885	22102	109	applied	\N	\N	\N	\N	69301	69301	57564
16885	22107	110	applied	\N	\N	\N	\N	69313	69313	57566
16885	22085	111	applied	\N	\N	\N	\N	69256	69256	70148
16885	22096	112	applied	\N	\N	\N	\N	69286	69286	57568
16885	22103	113	applied	\N	\N	\N	\N	69302	69302	69302
16885	22112	114	applied	\N	\N	\N	\N	69328	69328	69328
16885	22108	115	applied	\N	\N	\N	\N	69314	69314	69315
16885	22122	116	applied	\N	\N	\N	\N	69353	69353	70149
16885	22133	117	applied	\N	\N	\N	\N	69380	69380	57570
16885	22140	118	applied	\N	\N	\N	\N	69439	69439	70150
16885	22153	119	applied	\N	\N	\N	\N	69494	69494	57572
16885	22164	120	applied	\N	\N	\N	\N	69511	69511	70151
16885	22175	121	applied	\N	\N	\N	\N	69547	69547	70152
16885	22183	122	applied	\N	\N	\N	\N	69567	69567	57579
16885	22197	123	applied	\N	\N	\N	\N	69594	69594	70153
16885	22209	124	applied	\N	\N	\N	\N	69649	69649	57581
16885	22225	125	applied	\N	\N	\N	\N	69685	69685	69333
16894	22391	0	applied	\N	\N	\N	\N	70185	70185	70186
16894	22392	1	applied	\N	\N	\N	\N	70187	70187	70188
16894	22393	2	applied	\N	\N	\N	\N	70189	70189	58795
16894	22394	3	applied	\N	\N	\N	\N	70190	70190	58797
16896	22395	0	applied	\N	\N	\N	\N	70195	70195	70196
16896	22396	1	applied	\N	\N	\N	\N	70197	70197	70198
16896	22397	2	applied	\N	\N	\N	\N	70199	70199	65473
16896	22398	3	applied	\N	\N	\N	\N	70200	70200	58799
16896	22399	4	applied	\N	\N	\N	\N	70201	70201	58817
16896	22400	5	applied	\N	\N	\N	\N	70202	70202	70203
16896	22401	6	applied	\N	\N	\N	\N	70204	70204	70205
16900	22395	0	applied	\N	\N	\N	\N	70195	70195	70196
16900	22396	1	applied	\N	\N	\N	\N	70197	70197	70198
16900	22397	2	applied	\N	\N	\N	\N	70199	70199	65473
16900	22398	3	applied	\N	\N	\N	\N	70200	70200	58799
16900	22399	4	applied	\N	\N	\N	\N	70201	70201	58817
16900	22400	5	applied	\N	\N	\N	\N	70202	70202	70203
16900	22401	6	applied	\N	\N	\N	\N	70204	70204	70205
16905	22408	0	applied	\N	\N	\N	\N	70229	70229	70230
16905	22409	1	applied	\N	\N	\N	\N	70231	70231	58836
16905	22410	2	applied	\N	\N	\N	\N	70232	70232	58843
16908	22421	0	applied	\N	\N	\N	\N	70256	70256	70257
16908	22422	1	applied	\N	\N	\N	\N	70258	70258	70259
16908	22423	2	applied	\N	\N	\N	\N	70260	70260	70261
16908	22424	3	applied	\N	\N	\N	\N	70262	70262	70263
16908	22425	4	applied	\N	\N	\N	\N	70264	70264	70265
16908	22426	5	applied	\N	\N	\N	\N	70266	70266	58919
16908	22427	6	applied	\N	\N	\N	\N	70267	70267	58925
16919	22434	0	applied	\N	\N	\N	\N	70293	70293	70294
16919	22435	1	applied	\N	\N	\N	\N	70295	70295	58946
16919	22436	2	applied	\N	\N	\N	\N	70296	70296	58953
16919	22437	3	applied	\N	\N	\N	\N	70297	70297	70298
16922	22434	0	applied	\N	\N	\N	\N	70293	70293	70294
16922	22435	1	applied	\N	\N	\N	\N	70295	70295	58946
16922	22436	2	applied	\N	\N	\N	\N	70296	70296	58953
16922	22437	3	applied	\N	\N	\N	\N	70297	70297	70298
16932	22460	0	applied	\N	\N	\N	\N	70355	70355	70356
16932	22461	1	applied	\N	\N	\N	\N	70357	70357	59027
16932	22462	2	applied	\N	\N	\N	\N	70358	70358	70359
16938	22468	0	applied	\N	\N	\N	\N	70377	70377	70378
16938	22469	1	applied	\N	\N	\N	\N	70379	70379	70380
16938	22470	2	applied	\N	\N	\N	\N	70381	70381	70382
16938	22471	3	applied	\N	\N	\N	\N	70383	70383	70384
16938	22472	4	applied	\N	\N	\N	\N	70385	70385	70386
16938	22473	5	applied	\N	\N	\N	\N	70387	70387	70388
16938	22474	6	applied	\N	\N	\N	\N	70389	70389	59060
16939	22475	0	applied	\N	\N	\N	\N	70395	70395	70396
16939	22476	1	applied	\N	\N	\N	\N	70397	70397	70398
16939	22477	2	applied	\N	\N	\N	\N	70399	70399	70400
16889	21940	12	applied	\N	\N	\N	\N	68804	68804	68805
16889	21943	13	applied	\N	\N	\N	\N	68813	68813	68814
16889	21946	14	applied	\N	\N	\N	\N	68820	68820	68821
16889	21947	15	applied	\N	\N	\N	\N	68822	68822	68823
16889	21952	16	applied	\N	\N	\N	\N	68831	68831	68832
16889	21953	17	applied	\N	\N	\N	\N	68833	68833	68834
16889	21959	18	applied	\N	\N	\N	\N	68845	68845	68846
16889	21962	19	applied	\N	\N	\N	\N	68851	68851	68852
16889	21965	20	applied	\N	\N	\N	\N	68856	68856	68857
16889	21966	21	applied	\N	\N	\N	\N	68858	68858	68859
16889	22105	22	applied	\N	\N	\N	\N	69338	69338	69310
16889	22109	23	applied	\N	\N	\N	\N	69339	69339	69323
16889	22128	24	applied	\N	\N	\N	\N	69398	69398	69367
16889	21967	25	applied	\N	\N	\N	\N	68860	68860	68861
16889	21975	26	applied	\N	\N	\N	\N	68872	68872	68873
16889	21976	27	applied	\N	\N	\N	\N	68874	68874	68875
16889	21982	28	applied	\N	\N	\N	\N	68890	68890	68891
16889	21984	29	applied	\N	\N	\N	\N	68899	68899	68900
16889	21985	30	applied	\N	\N	\N	\N	68901	68901	68902
16889	21986	31	applied	\N	\N	\N	\N	68903	68903	68904
16889	21987	32	applied	\N	\N	\N	\N	68905	68905	68906
16889	21988	33	applied	\N	\N	\N	\N	68907	68907	68908
16889	22000	34	applied	\N	\N	\N	\N	68927	68927	68928
16889	22001	35	applied	\N	\N	\N	\N	68929	68929	68930
16889	22007	36	applied	\N	\N	\N	\N	68941	68941	68942
16889	22008	37	applied	\N	\N	\N	\N	68943	68943	68944
16889	22014	38	applied	\N	\N	\N	\N	68959	68959	68960
16889	22017	39	applied	\N	\N	\N	\N	68967	68967	69050
16889	22019	40	applied	\N	\N	\N	\N	68974	68974	69051
16889	22020	41	applied	\N	\N	\N	\N	68976	68976	69052
16889	22028	42	applied	\N	\N	\N	\N	68988	68988	69053
16889	22031	43	applied	\N	\N	\N	\N	68995	68995	69054
16889	22035	44	applied	\N	\N	\N	\N	69003	69003	69055
16889	22038	45	applied	\N	\N	\N	\N	69009	69009	69056
16889	22040	46	applied	\N	\N	\N	\N	69014	69014	69057
16889	22044	47	applied	\N	\N	\N	\N	69024	69024	69058
16889	22047	48	applied	\N	\N	\N	\N	69034	69034	69059
16889	22048	49	applied	\N	\N	\N	\N	69036	69036	69060
16889	22054	50	applied	\N	\N	\N	\N	69078	69078	69083
16889	22057	51	applied	\N	\N	\N	\N	69090	69090	69399
16889	22058	52	applied	\N	\N	\N	\N	69092	69092	69400
16889	22059	53	applied	\N	\N	\N	\N	69094	69094	69401
16889	22067	54	applied	\N	\N	\N	\N	69109	69109	69402
16889	22070	55	applied	\N	\N	\N	\N	69114	69114	69403
16889	22073	56	applied	\N	\N	\N	\N	69129	69129	69404
16889	22074	57	applied	\N	\N	\N	\N	69131	69131	69405
16889	22080	58	applied	\N	\N	\N	\N	69232	69232	69406
16889	22083	59	applied	\N	\N	\N	\N	69252	69252	69407
16889	22087	60	applied	\N	\N	\N	\N	69262	69262	69408
16889	22088	61	applied	\N	\N	\N	\N	69264	69264	69409
16889	22092	62	applied	\N	\N	\N	\N	69276	69276	69410
16889	22095	63	applied	\N	\N	\N	\N	69284	69284	69411
16889	22097	64	applied	\N	\N	\N	\N	69289	69289	69412
16889	22100	65	applied	\N	\N	\N	\N	69297	69297	69413
16889	22104	66	applied	\N	\N	\N	\N	69307	69307	69414
16889	22110	67	applied	\N	\N	\N	\N	69324	69324	69415
16889	22111	68	applied	\N	\N	\N	\N	69326	69326	69416
16889	22117	69	applied	\N	\N	\N	\N	69343	69343	69417
16889	22118	70	applied	\N	\N	\N	\N	69345	69345	69418
16889	22119	71	applied	\N	\N	\N	\N	69347	69347	69419
16889	22127	72	applied	\N	\N	\N	\N	69364	69364	69420
16889	22131	73	applied	\N	\N	\N	\N	69376	69376	69421
16889	22134	74	applied	\N	\N	\N	\N	69381	69381	69422
16889	22137	75	applied	\N	\N	\N	\N	69389	69389	69469
16889	22143	76	applied	\N	\N	\N	\N	69451	69451	69470
16889	22146	77	applied	\N	\N	\N	\N	69459	69459	69471
16889	22149	78	applied	\N	\N	\N	\N	69463	69463	69473
16889	22151	79	applied	\N	\N	\N	\N	69490	69490	69517
16889	22155	80	applied	\N	\N	\N	\N	69496	69496	69518
16889	22158	81	applied	\N	\N	\N	\N	69502	69502	69519
16889	22159	82	applied	\N	\N	\N	\N	69504	69504	69520
16889	22165	83	applied	\N	\N	\N	\N	69529	69529	69610
16889	22166	84	applied	\N	\N	\N	\N	69531	69531	69611
16889	22167	85	applied	\N	\N	\N	\N	69533	69533	69612
16889	22168	86	applied	\N	\N	\N	\N	69535	69535	69613
16889	22178	87	applied	\N	\N	\N	\N	69555	69555	69614
16889	22181	88	applied	\N	\N	\N	\N	69563	69563	69615
16889	22182	89	applied	\N	\N	\N	\N	69565	69565	69616
16889	22188	90	applied	\N	\N	\N	\N	69577	69577	69617
16889	22191	91	applied	\N	\N	\N	\N	69584	69584	69618
16889	22194	92	applied	\N	\N	\N	\N	69589	69589	69619
16889	22195	93	applied	\N	\N	\N	\N	69591	69591	69620
16889	22201	94	applied	\N	\N	\N	\N	69628	69628	69974
16889	22204	95	applied	\N	\N	\N	\N	69640	69640	69975
16889	22207	96	applied	\N	\N	\N	\N	69646	69646	69976
16889	22210	97	applied	\N	\N	\N	\N	69655	69655	69977
16889	22214	98	applied	\N	\N	\N	\N	69665	69665	69978
16889	22218	99	applied	\N	\N	\N	\N	69672	69672	69979
16889	22219	100	applied	\N	\N	\N	\N	69674	69674	69980
16889	22228	101	applied	\N	\N	\N	\N	69693	69693	69981
16889	22231	102	applied	\N	\N	\N	\N	69700	69700	69982
16889	22235	104	applied	\N	\N	\N	\N	69711	69711	69983
16889	22238	105	applied	\N	\N	\N	\N	69719	69719	69984
16889	22241	106	applied	\N	\N	\N	\N	69725	69725	69985
16889	22243	107	applied	\N	\N	\N	\N	69733	69733	69986
16889	22246	108	applied	\N	\N	\N	\N	69747	69747	69987
16889	22247	109	applied	\N	\N	\N	\N	69749	69749	69988
16889	22248	110	applied	\N	\N	\N	\N	69751	69751	69989
16889	22257	111	applied	\N	\N	\N	\N	69772	69772	69991
16889	22259	112	applied	\N	\N	\N	\N	69780	69780	69992
16889	22261	113	applied	\N	\N	\N	\N	69786	69786	69993
16889	22266	114	applied	\N	\N	\N	\N	69797	69797	69994
16889	22268	115	applied	\N	\N	\N	\N	69803	69803	69995
16889	22271	116	applied	\N	\N	\N	\N	69810	69810	69996
16889	22273	117	applied	\N	\N	\N	\N	69816	69816	69997
16889	22277	118	applied	\N	\N	\N	\N	69825	69825	69998
16889	22280	119	applied	\N	\N	\N	\N	69833	69833	69999
16889	22283	120	applied	\N	\N	\N	\N	69843	69843	70000
16889	22287	121	applied	\N	\N	\N	\N	69855	69855	70001
16889	22289	122	applied	\N	\N	\N	\N	69864	69864	70002
16889	22292	123	applied	\N	\N	\N	\N	69872	69872	70003
16889	22293	124	applied	\N	\N	\N	\N	69874	69874	70004
16889	22299	125	applied	\N	\N	\N	\N	69886	69886	70005
16893	22391	0	applied	\N	\N	\N	\N	70185	70185	70186
16893	22392	1	applied	\N	\N	\N	\N	70187	70187	70188
16893	22393	2	applied	\N	\N	\N	\N	70189	70189	58795
16893	22394	3	applied	\N	\N	\N	\N	70190	70190	58797
16899	22397	0	applied	\N	\N	\N	\N	70199	70199	65473
16902	22395	0	applied	\N	\N	\N	\N	70195	70195	70196
16902	22396	1	applied	\N	\N	\N	\N	70197	70197	70198
16891	22386	1	applied	\N	\N	\N	\N	70166	70166	70167
16891	22387	2	applied	\N	\N	\N	\N	70168	70168	70169
16898	22397	0	applied	\N	\N	\N	\N	70199	70199	65473
16901	22397	0	applied	\N	\N	\N	\N	70199	70199	65473
16904	22405	0	applied	\N	\N	\N	\N	70221	70221	70222
16904	22406	1	applied	\N	\N	\N	\N	70223	70223	70224
16904	22407	2	applied	\N	\N	\N	\N	70225	70225	70226
16906	22408	0	applied	\N	\N	\N	\N	70229	70229	70230
16906	22409	1	applied	\N	\N	\N	\N	70231	70231	58836
16906	22410	2	applied	\N	\N	\N	\N	70232	70232	58843
16910	22421	0	applied	\N	\N	\N	\N	70256	70256	70257
16910	22422	1	applied	\N	\N	\N	\N	70258	70258	70259
16910	22423	2	applied	\N	\N	\N	\N	70260	70260	70261
16910	22424	3	applied	\N	\N	\N	\N	70262	70262	70263
16910	22425	4	applied	\N	\N	\N	\N	70264	70264	70265
16910	22426	5	applied	\N	\N	\N	\N	70266	70266	58919
16910	22427	6	applied	\N	\N	\N	\N	70267	70267	58925
16916	22428	0	applied	\N	\N	\N	\N	70273	70273	70274
16916	22429	1	applied	\N	\N	\N	\N	70275	70275	58931
16916	22430	2	applied	\N	\N	\N	\N	70276	70276	70277
16918	22431	0	applied	\N	\N	\N	\N	70284	70284	70285
16918	22432	1	applied	\N	\N	\N	\N	70286	70286	70287
16918	22433	2	applied	\N	\N	\N	\N	70288	70288	70289
16924	22438	0	applied	\N	\N	\N	\N	70305	70305	70306
16924	22439	1	applied	\N	\N	\N	\N	70307	70307	70308
16924	22440	2	applied	\N	\N	\N	\N	70309	70309	70310
16924	22441	3	applied	\N	\N	\N	\N	70311	70311	70312
16924	22442	4	applied	\N	\N	\N	\N	70313	70313	70314
16924	22443	5	applied	\N	\N	\N	\N	70315	70315	70316
16924	22444	6	applied	\N	\N	\N	\N	70317	70317	58974
16924	22445	7	applied	\N	\N	\N	\N	70318	70318	58976
16924	22446	8	applied	\N	\N	\N	\N	70319	70319	70320
16924	22447	9	applied	\N	\N	\N	\N	70321	70321	58978
16924	22448	10	applied	\N	\N	\N	\N	70322	70322	70323
16924	22449	11	applied	\N	\N	\N	\N	70324	70324	70325
16926	22450	0	applied	\N	\N	\N	\N	70329	70329	70330
16926	22451	1	applied	\N	\N	1000000000	\N	70331	70331	70332
16926	22452	2	applied	\N	\N	\N	\N	70333	70333	70334
16926	22453	3	applied	\N	\N	\N	\N	70335	70335	70336
16931	22460	0	applied	\N	\N	\N	\N	70355	70355	70356
16931	22461	1	applied	\N	\N	\N	\N	70357	70357	59027
16931	22462	2	applied	\N	\N	\N	\N	70358	70358	70359
16933	22463	0	applied	\N	\N	\N	\N	70364	70364	70365
16933	22464	1	applied	\N	\N	\N	\N	70366	70366	70367
16933	22465	2	applied	\N	\N	\N	\N	70368	70368	70369
16936	22468	0	applied	\N	\N	\N	\N	70377	70377	70378
16936	22469	1	applied	\N	\N	\N	\N	70379	70379	70380
16936	22470	2	applied	\N	\N	\N	\N	70381	70381	70382
16936	22471	3	applied	\N	\N	\N	\N	70383	70383	70384
16936	22472	4	applied	\N	\N	\N	\N	70385	70385	70386
16936	22473	5	applied	\N	\N	\N	\N	70387	70387	70388
16936	22474	6	applied	\N	\N	\N	\N	70389	70389	59060
16941	22478	0	applied	\N	\N	\N	\N	70403	70403	70404
16941	22479	1	applied	\N	\N	\N	\N	70405	70405	70406
16941	22480	2	applied	\N	\N	\N	\N	70407	70407	70408
16943	22481	0	applied	\N	\N	\N	\N	70410	70410	70411
16946	22482	0	applied	\N	\N	\N	\N	70415	70415	70416
16946	22483	1	applied	\N	\N	\N	\N	70417	70417	70418
16947	22302	0	applied	\N	\N	\N	\N	69891	69891	70006
16947	22305	1	applied	\N	\N	\N	\N	69898	69898	70007
16947	22309	2	applied	\N	\N	\N	\N	69905	69905	70008
16947	22312	3	applied	\N	\N	\N	\N	69913	69913	70009
16947	22315	4	applied	\N	\N	\N	\N	69943	69943	70010
16947	22451	5	applied	\N	\N	1000000000	\N	70331	70331	70332
16947	22316	6	applied	\N	\N	\N	\N	69945	69945	70011
16947	22322	7	applied	\N	\N	\N	\N	69954	69954	70012
16947	22325	8	applied	\N	\N	\N	\N	69964	69964	70013
16947	22329	9	applied	\N	\N	\N	\N	70014	70014	70015
16947	22330	10	applied	\N	\N	\N	\N	70016	70016	70017
16947	22331	11	applied	\N	\N	\N	\N	70018	70018	70019
16947	22332	12	applied	\N	\N	\N	\N	70020	70020	70021
16947	22342	13	applied	\N	\N	\N	\N	70055	70055	70424
16947	22344	14	applied	\N	\N	\N	\N	70060	70060	70425
16947	22348	15	applied	\N	\N	\N	\N	70069	70069	70426
16947	22349	16	applied	\N	\N	\N	\N	70071	70071	70427
16947	22350	17	applied	\N	\N	\N	\N	70073	70073	70428
16947	22357	18	applied	\N	\N	\N	\N	70088	70088	70429
16947	22361	19	applied	\N	\N	\N	\N	70098	70098	70430
16947	22362	20	applied	\N	\N	\N	\N	70100	70100	70431
16947	22363	21	applied	\N	\N	\N	\N	70102	70102	70432
16947	22372	22	applied	\N	\N	\N	\N	70118	70118	70433
16947	22375	23	applied	\N	\N	\N	\N	70130	70130	70434
16947	22378	24	applied	\N	\N	\N	\N	70135	70135	70435
16947	22382	25	applied	\N	\N	\N	\N	70156	70156	70436
16947	22385	26	applied	\N	\N	\N	\N	70164	70164	70437
16947	22388	27	applied	\N	\N	\N	\N	70179	70179	70438
16947	22391	28	applied	\N	\N	\N	\N	70185	70185	70439
16947	22395	29	applied	\N	\N	\N	\N	70195	70195	70440
16947	22396	30	applied	\N	\N	\N	\N	70197	70197	70441
16947	22402	31	applied	\N	\N	\N	\N	70212	70212	70442
16947	22405	32	applied	\N	\N	\N	\N	70221	70221	70443
16947	22408	33	applied	\N	\N	\N	\N	70229	70229	70444
16947	22411	34	applied	\N	\N	\N	\N	70236	70236	70445
16947	22397	35	applied	\N	\N	\N	\N	70199	70199	65473
16947	22412	36	applied	\N	\N	\N	\N	70238	70238	70446
16947	22413	37	applied	\N	\N	\N	\N	70240	70240	70447
16947	22421	38	applied	\N	\N	\N	\N	70256	70256	70448
16947	22422	39	applied	\N	\N	\N	\N	70258	70258	70449
16947	22428	40	applied	\N	\N	\N	\N	70273	70273	70450
16947	22431	41	applied	\N	\N	\N	\N	70284	70284	70451
16947	22434	42	applied	\N	\N	\N	\N	70293	70293	70452
16947	22438	43	applied	\N	\N	\N	\N	70305	70305	70453
16947	22439	44	applied	\N	\N	\N	\N	70307	70307	70454
16947	22440	45	applied	\N	\N	\N	\N	70309	70309	70455
16947	22441	46	applied	\N	\N	\N	\N	70311	70311	70456
16947	22450	47	applied	\N	\N	\N	\N	70329	70329	70457
16947	22454	48	applied	\N	\N	\N	\N	70339	70339	70458
16947	22460	49	applied	\N	\N	\N	\N	70355	70355	70459
16947	22463	50	applied	\N	\N	\N	\N	70364	70364	70460
16947	22466	51	applied	\N	\N	\N	\N	70372	70372	70461
16947	22468	52	applied	\N	\N	\N	\N	70377	70377	70462
16947	22469	53	applied	\N	\N	\N	\N	70379	70379	70463
16947	22475	54	applied	\N	\N	\N	\N	70395	70395	70464
16947	22478	55	applied	\N	\N	\N	\N	70403	70403	70465
16947	22481	56	applied	\N	\N	\N	\N	70410	70410	70466
16947	22482	57	applied	\N	\N	\N	\N	70415	70415	70467
16947	22220	58	applied	\N	\N	\N	\N	70022	70022	69677
16947	22221	59	applied	\N	\N	\N	\N	70023	70023	69679
16947	22222	60	applied	\N	\N	\N	\N	70024	70024	69681
16902	22402	2	applied	\N	\N	\N	\N	70212	70212	70213
16902	22403	3	applied	\N	\N	\N	\N	70214	70214	70215
16902	22398	4	applied	\N	\N	\N	\N	70200	70200	70203
16902	22399	5	applied	\N	\N	\N	\N	70201	70201	70216
16902	22404	6	applied	\N	\N	\N	\N	70217	70217	70218
16907	22411	0	applied	\N	\N	\N	\N	70236	70236	70237
16907	22412	1	applied	\N	\N	\N	\N	70238	70238	70239
16907	22413	2	applied	\N	\N	\N	\N	70240	70240	70241
16907	22414	3	applied	\N	\N	\N	\N	70242	70242	58845
16907	22415	4	applied	\N	\N	\N	\N	70243	70243	70244
16907	22416	5	applied	\N	\N	\N	\N	70245	70245	58853
16907	22417	6	applied	\N	\N	\N	\N	70246	70246	70247
16907	22418	7	applied	\N	\N	\N	\N	70248	70248	70249
16907	22419	8	applied	\N	\N	\N	\N	70250	70250	70251
16907	22420	9	applied	\N	\N	\N	\N	70252	70252	70253
16911	22421	0	applied	\N	\N	\N	\N	70256	70256	70257
16911	22422	1	applied	\N	\N	\N	\N	70258	70258	70259
16911	22423	2	applied	\N	\N	\N	\N	70260	70260	70261
16911	22424	3	applied	\N	\N	\N	\N	70262	70262	70263
16911	22425	4	applied	\N	\N	\N	\N	70264	70264	70265
16911	22426	5	applied	\N	\N	\N	\N	70266	70266	58919
16911	22427	6	applied	\N	\N	\N	\N	70267	70267	58925
16913	22428	0	applied	\N	\N	\N	\N	70273	70273	70274
16913	22429	1	applied	\N	\N	\N	\N	70275	70275	58931
16913	22430	2	applied	\N	\N	\N	\N	70276	70276	70277
16915	22428	0	applied	\N	\N	\N	\N	70273	70273	70274
16915	22429	1	applied	\N	\N	\N	\N	70275	70275	58931
16915	22430	2	applied	\N	\N	\N	\N	70276	70276	70277
16921	22434	0	applied	\N	\N	\N	\N	70293	70293	70294
16921	22435	1	applied	\N	\N	\N	\N	70295	70295	58946
16921	22436	2	applied	\N	\N	\N	\N	70296	70296	58953
16921	22437	3	applied	\N	\N	\N	\N	70297	70297	70298
16925	22438	0	applied	\N	\N	\N	\N	70305	70305	70306
16925	22439	1	applied	\N	\N	\N	\N	70307	70307	70308
16925	22440	2	applied	\N	\N	\N	\N	70309	70309	70310
16925	22441	3	applied	\N	\N	\N	\N	70311	70311	70312
16925	22442	4	applied	\N	\N	\N	\N	70313	70313	70314
16925	22443	5	applied	\N	\N	\N	\N	70315	70315	70316
16925	22444	6	applied	\N	\N	\N	\N	70317	70317	58974
16925	22445	7	applied	\N	\N	\N	\N	70318	70318	58976
16925	22446	8	applied	\N	\N	\N	\N	70319	70319	70320
16925	22447	9	applied	\N	\N	\N	\N	70321	70321	58978
16925	22448	10	applied	\N	\N	\N	\N	70322	70322	70323
16925	22449	11	applied	\N	\N	\N	\N	70324	70324	70325
16927	22454	0	applied	\N	\N	\N	\N	70339	70339	70340
16927	22455	1	applied	\N	\N	\N	\N	70341	70341	59005
16927	22456	2	applied	\N	\N	\N	\N	70342	70342	59007
16929	22451	0	applied	\N	\N	1000000000	\N	70331	70331	70332
16929	22438	1	applied	\N	\N	\N	\N	70305	70305	70306
16929	22439	2	applied	\N	\N	\N	\N	70307	70307	70308
16929	22440	3	applied	\N	\N	\N	\N	70309	70309	70310
16929	22441	4	applied	\N	\N	\N	\N	70311	70311	70312
16929	22450	5	applied	\N	\N	\N	\N	70329	70329	70330
16929	22454	6	applied	\N	\N	\N	\N	70339	70339	70340
16929	22442	7	applied	\N	\N	\N	\N	70313	70313	70314
16929	22443	8	applied	\N	\N	\N	\N	70315	70315	70316
16929	22444	9	applied	\N	\N	\N	\N	70317	70317	58974
16929	22445	10	applied	\N	\N	\N	\N	70318	70318	58976
16929	22446	11	applied	\N	\N	\N	\N	70319	70319	70320
16929	22457	12	applied	\N	\N	\N	\N	70345	70345	70346
16929	22447	13	applied	\N	\N	\N	\N	70321	70321	70347
16929	22448	14	applied	\N	\N	\N	\N	70322	70322	58987
16929	22452	15	applied	\N	\N	\N	\N	70333	70333	70325
16929	22455	16	applied	\N	\N	\N	\N	70341	70341	70334
16929	22449	17	applied	\N	\N	\N	\N	70324	70324	70336
16929	22453	18	applied	\N	\N	\N	\N	70335	70335	70348
16929	22456	19	applied	\N	\N	\N	\N	70342	70342	70349
16929	22458	20	applied	\N	\N	\N	\N	70350	70350	70351
16934	22463	0	applied	\N	\N	\N	\N	70364	70364	70365
16934	22464	1	applied	\N	\N	\N	\N	70366	70366	70367
16934	22465	2	applied	\N	\N	\N	\N	70368	70368	70369
16937	22468	0	applied	\N	\N	\N	\N	70377	70377	70378
16937	22469	1	applied	\N	\N	\N	\N	70379	70379	70380
16937	22470	2	applied	\N	\N	\N	\N	70381	70381	70382
16937	22471	3	applied	\N	\N	\N	\N	70383	70383	70384
16937	22472	4	applied	\N	\N	\N	\N	70385	70385	70386
16937	22473	5	applied	\N	\N	\N	\N	70387	70387	70388
16937	22474	6	applied	\N	\N	\N	\N	70389	70389	59060
16951	22489	0	applied	\N	\N	\N	\N	70501	70501	70502
16951	22490	1	applied	\N	\N	\N	\N	70503	70503	70504
16951	22491	2	applied	\N	\N	\N	\N	70505	70505	70506
16951	22492	3	applied	\N	\N	\N	\N	70507	70507	70508
16951	22493	4	applied	\N	\N	\N	\N	70509	70509	70510
16953	22494	0	applied	\N	\N	\N	\N	70513	70513	70514
16953	22495	1	applied	\N	\N	\N	\N	70515	70515	70516
16953	22496	2	applied	\N	\N	\N	\N	70517	70517	70518
16953	22497	3	applied	\N	\N	\N	\N	70519	70519	59112
16956	22498	0	applied	\N	\N	\N	\N	70523	70523	70524
16956	22499	1	applied	\N	\N	\N	\N	70525	70525	70526
16956	22500	2	applied	\N	\N	1000000000	\N	70527	70527	70528
16956	22501	3	applied	\N	\N	\N	\N	70529	70529	70530
16956	22502	4	applied	\N	\N	\N	\N	70531	70531	70532
16956	22503	5	applied	\N	\N	\N	\N	70533	70533	70534
16960	22506	0	applied	\N	\N	\N	\N	70549	70549	70550
16963	22510	0	applied	\N	\N	\N	\N	70561	70561	70562
16963	22511	1	applied	\N	\N	\N	\N	70563	70563	70564
16963	22512	2	applied	\N	\N	\N	\N	70565	70565	70566
16963	22513	3	applied	\N	\N	\N	\N	70567	70567	59131
16963	22514	4	applied	\N	\N	\N	\N	70568	70568	70569
16963	22515	5	applied	\N	\N	\N	\N	70570	70570	70571
16966	22510	0	applied	\N	\N	\N	\N	70561	70561	70562
16966	22511	1	applied	\N	\N	\N	\N	70563	70563	70564
16966	22512	2	applied	\N	\N	\N	\N	70565	70565	70566
16966	22513	3	applied	\N	\N	\N	\N	70567	70567	59131
16966	22514	4	applied	\N	\N	\N	\N	70568	70568	70569
16966	22515	5	applied	\N	\N	\N	\N	70570	70570	70571
16969	22451	0	applied	\N	\N	1000000000	\N	70331	70331	70332
16969	22500	1	applied	\N	\N	1000000000	\N	70527	70527	70528
16969	22397	2	applied	\N	\N	\N	\N	70199	70199	65473
16975	22519	0	applied	\N	\N	\N	\N	70592	70592	70593
16975	22520	1	applied	\N	\N	\N	\N	70594	70594	59152
16985	22527	0	applied	\N	\N	\N	\N	70617	70617	70618
16985	22528	1	applied	\N	\N	\N	\N	70619	70619	70620
16985	22529	2	applied	\N	\N	\N	\N	70621	70621	59164
16985	22530	3	applied	\N	\N	\N	\N	70622	70622	70623
16985	22531	4	applied	\N	\N	\N	\N	70624	70624	70625
16991	22536	0	applied	\N	\N	\N	\N	70641	70641	70642
16991	22537	1	applied	\N	\N	\N	\N	70643	70643	59182
16991	22538	2	applied	\N	\N	\N	\N	70644	70644	70645
16912	22424	3	applied	\N	\N	\N	\N	70262	70262	70263
16912	22425	4	applied	\N	\N	\N	\N	70264	70264	70265
16912	22426	5	applied	\N	\N	\N	\N	70266	70266	58919
16912	22427	6	applied	\N	\N	\N	\N	70267	70267	58925
16914	22428	0	applied	\N	\N	\N	\N	70273	70273	70274
16914	22429	1	applied	\N	\N	\N	\N	70275	70275	58931
16914	22430	2	applied	\N	\N	\N	\N	70276	70276	70277
16917	22431	0	applied	\N	\N	\N	\N	70284	70284	70285
16917	22432	1	applied	\N	\N	\N	\N	70286	70286	70287
16917	22433	2	applied	\N	\N	\N	\N	70288	70288	70289
16920	22434	0	applied	\N	\N	\N	\N	70293	70293	70294
16920	22435	1	applied	\N	\N	\N	\N	70295	70295	58946
16920	22436	2	applied	\N	\N	\N	\N	70296	70296	58953
16920	22437	3	applied	\N	\N	\N	\N	70297	70297	70298
16923	22434	0	applied	\N	\N	\N	\N	70293	70293	70294
16923	22435	1	applied	\N	\N	\N	\N	70295	70295	58946
16923	22436	2	applied	\N	\N	\N	\N	70296	70296	58953
16923	22437	3	applied	\N	\N	\N	\N	70297	70297	70298
16928	22454	0	applied	\N	\N	\N	\N	70339	70339	70340
16928	22455	1	applied	\N	\N	\N	\N	70341	70341	59005
16928	22456	2	applied	\N	\N	\N	\N	70342	70342	59007
16930	22457	0	applied	\N	\N	\N	\N	70345	70345	70349
16930	22459	1	applied	\N	\N	\N	\N	70353	70353	59013
16930	22458	2	applied	\N	\N	\N	\N	70350	70350	59018
16935	22466	0	applied	\N	\N	\N	\N	70372	70372	70373
16935	22467	1	applied	\N	\N	\N	\N	70374	70374	70375
16940	22478	0	applied	\N	\N	\N	\N	70403	70403	70404
16940	22479	1	applied	\N	\N	\N	\N	70405	70405	70406
16940	22480	2	applied	\N	\N	\N	\N	70407	70407	70408
16942	22481	0	applied	\N	\N	\N	\N	70410	70410	70411
16945	22482	0	applied	\N	\N	\N	\N	70415	70415	70416
16945	22483	1	applied	\N	\N	\N	\N	70417	70417	70418
16949	22487	0	applied	\N	\N	\N	\N	70498	70498	70499
16949	22488	1	applied	\N	\N	\N	\N	70500	70500	59090
16958	22498	0	applied	\N	\N	\N	\N	70523	70523	70524
16958	22499	1	applied	\N	\N	\N	\N	70525	70525	70526
16958	22500	2	applied	\N	\N	1000000000	\N	70527	70527	70528
16958	22501	3	applied	\N	\N	\N	\N	70529	70529	70530
16958	22502	4	applied	\N	\N	\N	\N	70531	70531	70532
16958	22503	5	applied	\N	\N	\N	\N	70533	70533	70534
16961	22507	0	applied	\N	\N	\N	\N	70553	70553	70554
16961	22508	1	applied	\N	\N	\N	\N	70555	70555	70556
16961	22509	2	applied	\N	\N	\N	\N	70557	70557	70558
16970	22516	0	applied	\N	\N	\N	\N	70583	70583	70584
16970	22517	1	applied	\N	\N	\N	\N	70585	70585	70586
16970	22518	2	applied	\N	\N	\N	\N	70587	70587	70588
16973	22519	0	applied	\N	\N	\N	\N	70592	70592	70593
16973	22520	1	applied	\N	\N	\N	\N	70594	70594	59152
16978	22521	0	applied	\N	\N	\N	\N	70601	70601	70602
16981	22525	0	applied	\N	\N	\N	\N	70611	70611	70612
16981	22526	1	applied	\N	\N	\N	\N	70613	70613	70614
16988	22532	0	applied	\N	\N	\N	\N	70631	70631	70632
16988	22533	1	applied	\N	\N	\N	\N	70633	70633	59172
16990	22534	0	applied	\N	\N	\N	\N	70636	70636	70637
16990	22535	1	applied	\N	\N	\N	\N	70638	70638	70639
16999	22546	0	applied	\N	\N	\N	\N	70665	70665	70666
16999	22547	1	applied	\N	\N	\N	\N	70667	70667	70668
17001	22546	0	applied	\N	\N	\N	\N	70665	70665	70666
17001	22547	1	applied	\N	\N	\N	\N	70667	70667	70668
17004	22553	0	applied	\N	\N	\N	\N	70686	70686	70687
17004	22554	1	applied	\N	\N	\N	\N	70688	70688	70689
17004	22555	2	applied	\N	\N	\N	\N	70690	70690	59222
17004	22556	3	applied	\N	\N	\N	\N	70691	70691	70692
17012	22573	0	applied	\N	\N	\N	\N	70733	70733	70734
17012	22574	1	applied	\N	\N	\N	\N	70735	70735	70736
17017	22585	0	applied	\N	\N	\N	\N	70763	70763	70764
17017	22586	1	applied	\N	\N	\N	\N	70765	70765	70766
17017	22587	2	applied	\N	\N	\N	\N	70767	70767	70768
17029	22598	0	applied	\N	\N	\N	\N	70820	70820	70821
17029	22599	1	applied	\N	\N	\N	\N	70822	70822	70823
17033	22600	0	applied	\N	\N	\N	\N	70831	70831	70832
17033	22598	1	applied	\N	\N	\N	\N	70820	70820	70823
17033	22601	2	applied	\N	\N	\N	\N	70833	70833	70834
17033	22602	3	applied	\N	\N	\N	\N	70835	70835	70836
17036	22603	0	applied	\N	\N	\N	\N	70840	70840	70841
17036	22604	1	applied	\N	\N	\N	\N	70842	70842	70843
17036	22602	2	applied	\N	\N	\N	\N	70835	70835	70844
17038	22605	0	applied	\N	\N	\N	\N	70849	70849	70850
17038	22606	1	applied	\N	\N	\N	\N	70851	70851	59363
17038	22607	2	applied	\N	\N	\N	\N	70852	70852	59370
17040	22612	0	applied	\N	\N	\N	\N	70862	70862	70863
17040	22613	1	applied	\N	\N	\N	\N	70864	70864	59391
17040	22614	2	applied	\N	\N	\N	\N	70865	70865	70866
17043	22621	0	applied	\N	\N	\N	\N	70883	70883	70884
17043	22622	1	applied	\N	\N	\N	\N	70885	70885	70886
17043	22623	2	applied	\N	\N	\N	\N	70887	70887	70888
17043	22624	3	applied	\N	\N	\N	\N	70889	70889	70890
17043	22625	4	applied	\N	\N	\N	\N	70891	70891	70892
17043	22626	5	applied	\N	\N	\N	\N	70893	70893	59428
17050	22634	0	applied	\N	\N	\N	\N	70913	70913	70914
17050	22635	1	applied	\N	\N	\N	\N	70915	70915	70916
17050	22636	2	applied	\N	\N	\N	\N	70917	70917	70918
17052	22388	0	applied	\N	\N	\N	\N	70179	70179	70180
17052	22391	1	applied	\N	\N	\N	\N	70185	70185	70186
17052	22451	2	applied	\N	\N	1000000000	\N	70331	70331	70332
17052	22500	3	applied	\N	\N	1000000000	\N	70527	70527	70528
17052	22570	4	applied	\N	\N	1000000000	\N	70725	70725	70726
17052	22395	5	applied	\N	\N	\N	\N	70195	70195	70196
17052	22396	6	applied	\N	\N	\N	\N	70197	70197	70198
17052	22402	7	applied	\N	\N	\N	\N	70212	70212	70213
17052	22405	8	applied	\N	\N	\N	\N	70221	70221	70222
17052	22408	9	applied	\N	\N	\N	\N	70229	70229	70230
17052	22411	10	applied	\N	\N	\N	\N	70236	70236	70237
17052	22397	11	applied	\N	\N	\N	\N	70199	70199	65473
17052	22412	12	applied	\N	\N	\N	\N	70238	70238	70239
17052	22413	13	applied	\N	\N	\N	\N	70240	70240	70241
17052	22421	14	applied	\N	\N	\N	\N	70256	70256	70257
17052	22422	15	applied	\N	\N	\N	\N	70258	70258	70259
17052	22428	16	applied	\N	\N	\N	\N	70273	70273	70274
17052	22431	17	applied	\N	\N	\N	\N	70284	70284	70285
17052	22434	18	applied	\N	\N	\N	\N	70293	70293	70294
17052	22438	19	applied	\N	\N	\N	\N	70305	70305	70306
17052	22439	20	applied	\N	\N	\N	\N	70307	70307	70308
17052	22440	21	applied	\N	\N	\N	\N	70309	70309	70310
17052	22441	22	applied	\N	\N	\N	\N	70311	70311	70312
17052	22450	23	applied	\N	\N	\N	\N	70329	70329	70330
17052	22454	24	applied	\N	\N	\N	\N	70339	70339	70340
17052	22460	25	applied	\N	\N	\N	\N	70355	70355	70356
17052	22463	26	applied	\N	\N	\N	\N	70364	70364	70365
16944	22482	0	applied	\N	\N	\N	\N	70415	70415	70416
16944	22483	1	applied	\N	\N	\N	\N	70417	70417	70418
16948	22484	0	applied	\N	\N	\N	\N	70492	70492	70493
16948	22485	1	applied	\N	\N	\N	\N	70494	70494	70495
16948	22486	2	applied	\N	\N	\N	\N	70496	70496	70497
16954	22494	0	applied	\N	\N	\N	\N	70513	70513	70514
16954	22495	1	applied	\N	\N	\N	\N	70515	70515	70516
16954	22496	2	applied	\N	\N	\N	\N	70517	70517	70518
16954	22497	3	applied	\N	\N	\N	\N	70519	70519	59112
16957	22498	0	applied	\N	\N	\N	\N	70523	70523	70524
16957	22499	1	applied	\N	\N	\N	\N	70525	70525	70526
16957	22500	2	applied	\N	\N	1000000000	\N	70527	70527	70528
16957	22501	3	applied	\N	\N	\N	\N	70529	70529	70530
16957	22502	4	applied	\N	\N	\N	\N	70531	70531	70532
16957	22503	5	applied	\N	\N	\N	\N	70533	70533	70534
16964	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
16964	22451	1	applied	\N	\N	1000000000	\N	70331	70331	70332
16964	22500	2	applied	\N	\N	1000000000	\N	70527	70527	70528
16964	22397	3	applied	\N	\N	\N	\N	70199	70199	65473
16964	22220	4	applied	\N	\N	\N	\N	69676	69676	69677
16964	22221	5	applied	\N	\N	\N	\N	69678	69678	69679
16964	22222	6	applied	\N	\N	\N	\N	69680	69680	69681
16964	22223	7	applied	\N	\N	\N	\N	69682	69682	69683
16967	22510	0	applied	\N	\N	\N	\N	70561	70561	70562
16967	22511	1	applied	\N	\N	\N	\N	70563	70563	70564
16967	22512	2	applied	\N	\N	\N	\N	70565	70565	70566
16967	22513	3	applied	\N	\N	\N	\N	70567	70567	59131
16967	22514	4	applied	\N	\N	\N	\N	70568	70568	70569
16967	22515	5	applied	\N	\N	\N	\N	70570	70570	70571
16972	22519	0	applied	\N	\N	\N	\N	70592	70592	70593
16972	22520	1	applied	\N	\N	\N	\N	70594	70594	59152
16976	22519	0	applied	\N	\N	\N	\N	70592	70592	70593
16976	22520	1	applied	\N	\N	\N	\N	70594	70594	59152
16980	22522	0	applied	\N	\N	\N	\N	70605	70605	70606
16980	22523	1	applied	\N	\N	\N	\N	70607	70607	70608
16980	22524	2	applied	\N	\N	\N	\N	70609	70609	59154
16983	22525	0	applied	\N	\N	\N	\N	70611	70611	70612
16983	22526	1	applied	\N	\N	\N	\N	70613	70613	70614
16986	22527	0	applied	\N	\N	\N	\N	70617	70617	70618
16986	22528	1	applied	\N	\N	\N	\N	70619	70619	70620
16986	22529	2	applied	\N	\N	\N	\N	70621	70621	59164
16986	22530	3	applied	\N	\N	\N	\N	70622	70622	70623
16986	22531	4	applied	\N	\N	\N	\N	70624	70624	70625
16987	22532	0	applied	\N	\N	\N	\N	70631	70631	70632
16987	22533	1	applied	\N	\N	\N	\N	70633	70633	59172
16994	22539	0	applied	\N	\N	\N	\N	70648	70648	70649
16994	22540	1	applied	\N	\N	\N	\N	70650	70650	70651
17003	22550	0	applied	\N	\N	\N	\N	70680	70680	70681
17003	22551	1	applied	\N	\N	\N	\N	70682	70682	70683
17003	22552	2	applied	\N	\N	\N	\N	70684	70684	70685
17009	22564	0	applied	\N	\N	\N	\N	70710	70710	70711
17009	22565	1	applied	\N	\N	\N	\N	70712	70712	70713
17009	22566	2	applied	\N	\N	\N	\N	70714	70714	70715
17009	22567	3	applied	\N	\N	\N	\N	70716	70716	59248
17009	22568	4	applied	\N	\N	\N	\N	70717	70717	70718
17011	22569	0	applied	\N	\N	\N	\N	70723	70723	70724
17011	22570	1	applied	\N	\N	1000000000	\N	70725	70725	70726
17011	22571	2	applied	\N	\N	\N	\N	70727	70727	70728
17011	22572	3	applied	\N	\N	\N	\N	70729	70729	70730
17014	22575	0	applied	\N	\N	\N	\N	70739	70739	70740
17014	22576	1	applied	\N	\N	\N	\N	70741	70741	70742
17014	22577	2	applied	\N	\N	\N	\N	70743	70743	70744
17014	22578	3	applied	\N	\N	\N	\N	70745	70745	70746
17014	22579	4	applied	\N	\N	\N	\N	70747	70747	70748
17014	22580	5	applied	\N	\N	\N	\N	70749	70749	70750
17014	22581	6	applied	\N	\N	\N	\N	70751	70751	59292
17022	22588	0	applied	\N	\N	\N	\N	70772	70772	70773
17022	22589	1	applied	\N	\N	\N	\N	70774	70774	70775
17022	22590	2	applied	\N	\N	\N	\N	70776	70776	70777
17022	22591	3	applied	\N	\N	\N	\N	70778	70778	70779
17022	22592	4	applied	\N	\N	\N	\N	70780	70780	70781
17022	22593	5	applied	\N	\N	\N	\N	70782	70782	70783
17022	22594	6	applied	\N	\N	\N	\N	70784	70784	59331
17023	22588	0	applied	\N	\N	\N	\N	70772	70772	70773
17023	22589	1	applied	\N	\N	\N	\N	70774	70774	70775
17023	22590	2	applied	\N	\N	\N	\N	70776	70776	70777
17023	22591	3	applied	\N	\N	\N	\N	70778	70778	70779
17023	22592	4	applied	\N	\N	\N	\N	70780	70780	70781
17023	22593	5	applied	\N	\N	\N	\N	70782	70782	70783
17023	22594	6	applied	\N	\N	\N	\N	70784	70784	59331
17026	22595	0	applied	\N	\N	\N	\N	70791	70791	70792
17026	22596	1	applied	\N	\N	\N	\N	70793	70793	70794
17026	22597	2	applied	\N	\N	\N	\N	70795	70795	70796
17028	22598	0	applied	\N	\N	\N	\N	70820	70820	70821
17028	22599	1	applied	\N	\N	\N	\N	70822	70822	70823
17032	22599	0	applied	\N	\N	\N	\N	70822	70822	59348
17035	22603	0	applied	\N	\N	\N	\N	70840	70840	70841
17035	22604	1	applied	\N	\N	\N	\N	70842	70842	70843
17035	22602	2	applied	\N	\N	\N	\N	70835	70835	70844
17037	22605	0	applied	\N	\N	\N	\N	70849	70849	70850
17037	22606	1	applied	\N	\N	\N	\N	70851	70851	59363
17037	22607	2	applied	\N	\N	\N	\N	70852	70852	59370
17042	22618	0	applied	\N	\N	\N	\N	70876	70876	70877
17042	22619	1	applied	\N	\N	\N	\N	70878	70878	70879
17042	22620	2	applied	\N	\N	\N	\N	70880	70880	70881
17054	22641	0	applied	\N	\N	\N	\N	70940	70940	70941
17054	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17054	22642	2	applied	\N	\N	\N	\N	70942	70942	70943
17054	22643	3	applied	\N	\N	\N	\N	70944	70944	59490
17059	22655	0	applied	\N	\N	\N	\N	70971	70971	70972
17059	22656	1	applied	\N	\N	\N	\N	70973	70973	59528
17059	22657	2	applied	\N	\N	\N	\N	70974	70974	59530
17062	22661	0	applied	\N	\N	\N	\N	70981	70981	70982
17062	22662	1	applied	\N	\N	\N	\N	70983	70983	70984
17062	22663	2	applied	\N	\N	\N	\N	70985	70985	59550
17062	22664	3	applied	\N	\N	\N	\N	70986	70986	59557
17069	22681	0	applied	\N	\N	\N	\N	71029	71029	71030
17069	22682	1	applied	\N	\N	\N	\N	71031	71031	59591
17069	22683	2	applied	\N	\N	\N	\N	71032	71032	71033
17072	22684	0	applied	\N	\N	\N	\N	71035	71035	71036
17072	22685	1	applied	\N	\N	\N	\N	71037	71037	71038
17072	22687	2	applied	\N	\N	\N	\N	71041	71041	59597
17074	22688	0	applied	\N	\N	\N	\N	71049	71049	71050
17074	22689	1	applied	\N	\N	\N	\N	71051	71051	59616
17078	22693	0	applied	\N	\N	\N	\N	71066	71066	71067
17078	22694	1	applied	\N	\N	\N	\N	71068	71068	59627
17078	22695	2	applied	\N	\N	\N	\N	71069	71069	59629
17082	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17082	22716	1	applied	\N	\N	\N	\N	71108	71108	71109
16947	22223	61	applied	\N	\N	\N	\N	70025	70025	69683
16947	21907	62	applied	\N	\N	\N	\N	68723	68723	68724
16947	21908	63	applied	\N	\N	\N	\N	68725	68725	56978
16947	21913	64	applied	\N	\N	\N	\N	68736	68736	56980
16947	21927	65	applied	\N	\N	\N	\N	68770	68770	68727
16947	21938	66	applied	\N	\N	\N	\N	68800	68800	70468
16947	21950	67	applied	\N	\N	\N	\N	68827	68827	56982
16947	21954	68	applied	\N	\N	\N	\N	68835	68835	68737
16947	21968	69	applied	\N	\N	\N	\N	68862	68862	56992
16947	21977	70	applied	\N	\N	\N	\N	68876	68876	56994
16947	21989	71	applied	\N	\N	\N	\N	68909	68909	70469
16947	21915	72	applied	\N	\N	\N	\N	68739	68739	70470
16947	22004	73	applied	\N	\N	\N	\N	68935	68935	57002
16947	21909	74	applied	\N	\N	\N	\N	68726	68726	70471
16947	21910	75	applied	\N	\N	\N	\N	68728	68728	57014
16947	21914	76	applied	\N	\N	\N	\N	68738	68738	57016
16947	22011	77	applied	\N	\N	\N	\N	68948	68948	57018
16947	22023	78	applied	\N	\N	\N	\N	68980	68980	68755
16947	22034	79	applied	\N	\N	\N	\N	69001	69001	70472
16947	22043	80	applied	\N	\N	\N	\N	69018	69018	57020
16947	22053	81	applied	\N	\N	\N	\N	69045	69045	68761
16947	22062	82	applied	\N	\N	\N	\N	69098	69098	57022
16947	22079	83	applied	\N	\N	\N	\N	69138	69138	57024
16947	22085	84	applied	\N	\N	\N	\N	69256	69256	68771
16947	22096	85	applied	\N	\N	\N	\N	69286	69286	70473
16947	22103	86	applied	\N	\N	\N	\N	69302	69302	69302
16947	22112	87	applied	\N	\N	\N	\N	69328	69328	69328
16947	22108	88	applied	\N	\N	\N	\N	69314	69314	57027
16947	22122	89	applied	\N	\N	\N	\N	69353	69353	68773
16947	22133	90	applied	\N	\N	\N	\N	69380	69380	57029
16947	22140	91	applied	\N	\N	\N	\N	69439	69439	57031
16947	22153	92	applied	\N	\N	\N	\N	69494	69494	70474
16947	21916	93	applied	\N	\N	\N	\N	68740	68740	70475
16947	21919	94	applied	\N	\N	\N	\N	68752	68752	57035
16947	21923	95	applied	\N	\N	\N	\N	68762	68762	70476
16947	21929	96	applied	\N	\N	\N	\N	68774	68774	70477
16947	21930	97	applied	\N	\N	\N	\N	68775	68775	57051
16947	21934	98	applied	\N	\N	\N	\N	68786	68786	68789
16947	21939	99	applied	\N	\N	\N	\N	68801	68801	70478
16947	21942	100	applied	\N	\N	\N	\N	68808	68808	57057
16947	21944	101	applied	\N	\N	\N	\N	68815	68815	57069
16947	21948	102	applied	\N	\N	\N	\N	68824	68824	70479
16947	21951	104	applied	\N	\N	\N	\N	68828	68828	57073
16947	21957	105	applied	\N	\N	\N	\N	68838	68838	57075
16947	21958	106	applied	\N	\N	\N	\N	68840	68840	70481
16947	21960	107	applied	\N	\N	\N	\N	68847	68847	57079
16947	21963	108	applied	\N	\N	\N	\N	68853	68853	57081
16947	21972	109	applied	\N	\N	\N	\N	68866	68866	70482
16947	21973	110	applied	\N	\N	\N	\N	68868	68868	57085
16947	21974	111	applied	\N	\N	\N	\N	68870	68870	57090
16947	21978	112	applied	\N	\N	\N	\N	68878	68878	70483
16947	21979	113	applied	\N	\N	\N	\N	68879	68879	57094
16947	21993	114	applied	\N	\N	\N	\N	68914	68914	57103
16947	21994	115	applied	\N	\N	\N	\N	68916	68916	70484
16947	21995	116	applied	\N	\N	\N	\N	68917	68917	57107
16947	21996	117	applied	\N	\N	\N	\N	68919	68919	70485
16947	22164	118	applied	\N	\N	\N	\N	69511	69511	57130
16947	22175	119	applied	\N	\N	\N	\N	69547	69547	70486
16947	22183	120	applied	\N	\N	\N	\N	69567	69567	70487
16947	22197	121	applied	\N	\N	\N	\N	69594	69594	57132
16947	22209	122	applied	\N	\N	\N	\N	69649	69649	70488
16947	22225	123	applied	\N	\N	\N	\N	69685	69685	57134
16947	22234	124	applied	\N	\N	\N	\N	69705	69705	57136
16947	22245	125	applied	\N	\N	\N	\N	69737	69737	70489
16955	22498	0	applied	\N	\N	\N	\N	70523	70523	70524
16955	22499	1	applied	\N	\N	\N	\N	70525	70525	70526
16955	22500	2	applied	\N	\N	1000000000	\N	70527	70527	70528
16955	22501	3	applied	\N	\N	\N	\N	70529	70529	70530
16955	22502	4	applied	\N	\N	\N	\N	70531	70531	70532
16955	22503	5	applied	\N	\N	\N	\N	70533	70533	70534
16959	22504	0	applied	\N	\N	\N	\N	70543	70543	70544
16959	22505	1	applied	\N	\N	\N	\N	70545	70545	70546
16962	22507	0	applied	\N	\N	\N	\N	70553	70553	70554
16962	22508	1	applied	\N	\N	\N	\N	70555	70555	70556
16962	22509	2	applied	\N	\N	\N	\N	70557	70557	70558
16965	22510	0	applied	\N	\N	\N	\N	70561	70561	70562
16965	22511	1	applied	\N	\N	\N	\N	70563	70563	70564
16965	22512	2	applied	\N	\N	\N	\N	70565	70565	70566
16965	22513	3	applied	\N	\N	\N	\N	70567	70567	59131
16965	22514	4	applied	\N	\N	\N	\N	70568	70568	70569
16965	22515	5	applied	\N	\N	\N	\N	70570	70570	70571
16968	22510	0	applied	\N	\N	\N	\N	70561	70561	70562
16968	22511	1	applied	\N	\N	\N	\N	70563	70563	70564
16968	22512	2	applied	\N	\N	\N	\N	70565	70565	70566
16968	22513	3	applied	\N	\N	\N	\N	70567	70567	59131
16968	22514	4	applied	\N	\N	\N	\N	70568	70568	70569
16968	22515	5	applied	\N	\N	\N	\N	70570	70570	70571
16971	22516	0	applied	\N	\N	\N	\N	70583	70583	70584
16971	22517	1	applied	\N	\N	\N	\N	70585	70585	70586
16971	22518	2	applied	\N	\N	\N	\N	70587	70587	70588
16974	22519	0	applied	\N	\N	\N	\N	70592	70592	70593
16974	22520	1	applied	\N	\N	\N	\N	70594	70594	59152
16979	22521	0	applied	\N	\N	\N	\N	70601	70601	70602
16982	22525	0	applied	\N	\N	\N	\N	70611	70611	70612
16982	22526	1	applied	\N	\N	\N	\N	70613	70613	70614
16984	22527	0	applied	\N	\N	\N	\N	70617	70617	70618
16984	22528	1	applied	\N	\N	\N	\N	70619	70619	70620
16984	22529	2	applied	\N	\N	\N	\N	70621	70621	59164
16984	22530	3	applied	\N	\N	\N	\N	70622	70622	70623
16984	22531	4	applied	\N	\N	\N	\N	70624	70624	70625
16989	22532	0	applied	\N	\N	\N	\N	70631	70631	70632
16989	22533	1	applied	\N	\N	\N	\N	70633	70633	59172
17000	22546	0	applied	\N	\N	\N	\N	70665	70665	70666
17000	22547	1	applied	\N	\N	\N	\N	70667	70667	70668
17002	22548	0	applied	\N	\N	\N	\N	70674	70674	70675
17002	22549	1	applied	\N	\N	\N	\N	70676	70676	70677
17005	22553	0	applied	\N	\N	\N	\N	70686	70686	70687
17005	22554	1	applied	\N	\N	\N	\N	70688	70688	70689
17005	22555	2	applied	\N	\N	\N	\N	70690	70690	59222
17005	22556	3	applied	\N	\N	\N	\N	70691	70691	70692
17007	22557	0	applied	\N	\N	\N	\N	70695	70695	70696
17007	22558	1	applied	\N	\N	\N	\N	70697	70697	70698
17007	22559	2	applied	\N	\N	\N	\N	70699	70699	70700
17007	22560	3	applied	\N	\N	\N	\N	70701	70701	59234
17007	22561	4	applied	\N	\N	\N	\N	70702	70702	70703
17010	22564	0	applied	\N	\N	\N	\N	70710	70710	70711
17010	22565	1	applied	\N	\N	\N	\N	70712	70712	70713
17010	22566	2	applied	\N	\N	\N	\N	70714	70714	70715
17010	22567	3	applied	\N	\N	\N	\N	70716	70716	59248
17010	22568	4	applied	\N	\N	\N	\N	70717	70717	70718
16998	22541	0	applied	\N	\N	\N	\N	70654	70654	70655
16998	22542	1	applied	\N	\N	\N	\N	70656	70656	70657
16998	22543	2	applied	\N	\N	\N	\N	70658	70658	70659
16998	22544	3	applied	\N	\N	\N	\N	70660	70660	70661
16998	22545	4	applied	\N	\N	\N	\N	70662	70662	59212
17006	22553	0	applied	\N	\N	\N	\N	70686	70686	70687
17006	22554	1	applied	\N	\N	\N	\N	70688	70688	70689
17006	22555	2	applied	\N	\N	\N	\N	70690	70690	59222
17006	22556	3	applied	\N	\N	\N	\N	70691	70691	70692
17008	22562	0	applied	\N	\N	\N	\N	70705	70705	70706
17008	22563	1	applied	\N	\N	\N	\N	70707	70707	59240
17016	22582	0	applied	\N	\N	\N	\N	70753	70753	70754
17016	22583	1	applied	\N	\N	\N	\N	70755	70755	59294
17016	22584	3	applied	\N	\N	\N	\N	70757	70757	70758
17019	22585	0	applied	\N	\N	\N	\N	70763	70763	70764
17019	22586	1	applied	\N	\N	\N	\N	70765	70765	70766
17019	22587	2	applied	\N	\N	\N	\N	70767	70767	70768
17021	22588	0	applied	\N	\N	\N	\N	70772	70772	70773
17021	22589	1	applied	\N	\N	\N	\N	70774	70774	70775
17021	22590	2	applied	\N	\N	\N	\N	70776	70776	70777
17021	22591	3	applied	\N	\N	\N	\N	70778	70778	70779
17021	22592	4	applied	\N	\N	\N	\N	70780	70780	70781
17021	22593	5	applied	\N	\N	\N	\N	70782	70782	70783
17021	22594	6	applied	\N	\N	\N	\N	70784	70784	59331
17025	22596	0	applied	\N	\N	\N	\N	70793	70793	70794
17025	22597	1	applied	\N	\N	\N	\N	70795	70795	70796
17031	22598	0	applied	\N	\N	\N	\N	70820	70820	70821
17031	22599	1	applied	\N	\N	\N	\N	70822	70822	70823
17039	22608	0	applied	\N	\N	\N	\N	70856	70856	70857
17039	22609	1	applied	\N	\N	\N	\N	70858	70858	70859
17039	22610	2	applied	\N	\N	\N	\N	70860	70860	59377
17039	22611	3	applied	\N	\N	\N	\N	70861	70861	59389
17047	22627	0	applied	\N	\N	\N	\N	70897	70897	70898
17047	22628	1	applied	\N	\N	\N	\N	70899	70899	59430
17047	22629	2	applied	\N	\N	\N	\N	70900	70900	70901
17047	22630	3	applied	\N	\N	\N	\N	70902	70902	59444
17049	22632	0	applied	\N	\N	\N	\N	70909	70909	59461
17049	22633	1	applied	\N	\N	\N	\N	70910	70910	70911
17051	22637	0	applied	\N	\N	\N	\N	70921	70921	70922
17051	22638	1	applied	\N	\N	\N	\N	70923	70923	70924
17051	22639	2	applied	\N	\N	\N	\N	70925	70925	59488
17058	22648	0	applied	\N	\N	\N	\N	70958	70958	70959
17058	22649	1	applied	\N	\N	\N	\N	70960	70960	70961
17058	22650	2	applied	\N	\N	\N	\N	70962	70962	59508
17058	22651	3	applied	\N	\N	\N	\N	70963	70963	70964
17058	22652	4	applied	\N	\N	\N	\N	70965	70965	70966
17058	22653	5	applied	\N	\N	\N	\N	70967	70967	59520
17058	22654	6	applied	\N	\N	\N	\N	70968	70968	70969
17061	22661	0	applied	\N	\N	\N	\N	70981	70981	70982
17061	22662	1	applied	\N	\N	\N	\N	70983	70983	70984
17061	22663	2	applied	\N	\N	\N	\N	70985	70985	59550
17061	22664	3	applied	\N	\N	\N	\N	70986	70986	59557
17066	22666	0	applied	\N	\N	\N	\N	70999	70999	71000
17066	22667	1	applied	\N	\N	\N	\N	71001	71001	71002
17066	22668	2	applied	\N	\N	\N	\N	71003	71003	71004
17066	22669	3	applied	\N	\N	\N	\N	71005	71005	71006
17066	22665	4	applied	\N	\N	\N	\N	70994	70994	70995
17066	22670	5	applied	\N	\N	\N	\N	71007	71007	59561
17066	22671	6	applied	\N	\N	\N	\N	71008	71008	59563
17066	22672	7	applied	\N	\N	\N	\N	71009	71009	71010
17066	22673	8	applied	\N	\N	\N	\N	71011	71011	71012
17066	22674	9	applied	\N	\N	\N	\N	71013	71013	71014
17066	22675	10	applied	\N	\N	\N	\N	71015	71015	71016
17066	22676	11	applied	\N	\N	\N	\N	71017	71017	71018
17066	22677	12	applied	\N	\N	\N	\N	71019	71019	71020
17068	22678	0	applied	\N	\N	\N	\N	71023	71023	71024
17068	22679	1	applied	\N	\N	\N	\N	71025	71025	71026
17068	22680	2	applied	\N	\N	\N	\N	71027	71027	59589
17071	22684	0	applied	\N	\N	\N	\N	71035	71035	71036
17071	22685	1	applied	\N	\N	\N	\N	71037	71037	71038
17071	22686	2	applied	\N	\N	\N	\N	71039	71039	71040
17071	22687	3	applied	\N	\N	\N	\N	71041	71041	71042
17073	22688	0	applied	\N	\N	\N	\N	71049	71049	71050
17073	22689	1	applied	\N	\N	\N	\N	71051	71051	59616
17081	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17081	22716	1	applied	\N	\N	\N	\N	71108	71108	71109
17081	22717	2	applied	\N	\N	\N	\N	71110	71110	71111
17081	22718	3	applied	\N	\N	\N	\N	71112	71112	59685
17083	22719	0	applied	\N	\N	\N	\N	71117	71117	71118
17083	22720	1	applied	\N	\N	\N	\N	71119	71119	71120
17083	22721	2	applied	\N	\N	\N	\N	71121	71121	59697
17083	22722	3	applied	\N	\N	\N	\N	71122	71122	59708
17086	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17086	22600	1	applied	\N	\N	\N	\N	70831	70831	70832
17086	22603	2	applied	\N	\N	\N	\N	70840	70840	70841
17086	22640	3	applied	\N	\N	1000000000	\N	70936	70936	70937
17086	22605	4	applied	\N	\N	\N	\N	70849	70849	70850
17086	22608	5	applied	\N	\N	\N	\N	70856	70856	70857
17086	22612	6	applied	\N	\N	\N	\N	70862	70862	70863
17086	22615	7	applied	\N	\N	\N	\N	70869	70869	70870
17086	22618	8	applied	\N	\N	\N	\N	70876	70876	70877
17086	22621	9	applied	\N	\N	\N	\N	70883	70883	70884
17086	22622	10	applied	\N	\N	\N	\N	70885	70885	70886
17086	22627	11	applied	\N	\N	\N	\N	70897	70897	70898
17086	22631	12	applied	\N	\N	\N	\N	70907	70907	70908
17086	22634	13	applied	\N	\N	\N	\N	70913	70913	70914
17086	22698	14	applied	\N	\N	\N	\N	71076	71076	71077
17086	22637	15	applied	\N	\N	\N	\N	70921	70921	70922
17086	22641	16	applied	\N	\N	\N	\N	70940	70940	70941
17086	22645	17	applied	\N	\N	\N	\N	70951	70951	70952
17086	22648	18	applied	\N	\N	\N	\N	70958	70958	70959
17086	22649	19	applied	\N	\N	\N	\N	70960	70960	70961
17086	22655	20	applied	\N	\N	\N	\N	70971	70971	70972
17086	22658	21	applied	\N	\N	\N	\N	70976	70976	70977
17086	22661	22	applied	\N	\N	\N	\N	70981	70981	70982
17086	22666	23	applied	\N	\N	\N	\N	70999	70999	71000
17086	22667	24	applied	\N	\N	\N	\N	71001	71001	71002
17086	22668	25	applied	\N	\N	\N	\N	71003	71003	71004
17086	22669	26	applied	\N	\N	\N	\N	71005	71005	71006
17086	22678	27	applied	\N	\N	\N	\N	71023	71023	71024
17086	22681	28	applied	\N	\N	\N	\N	71029	71029	71030
17086	22684	29	applied	\N	\N	\N	\N	71035	71035	71036
17086	22688	30	applied	\N	\N	\N	\N	71049	71049	71050
17086	22690	31	applied	\N	\N	\N	\N	71056	71056	71057
17086	22693	32	applied	\N	\N	\N	\N	71066	71066	71067
17086	22696	33	applied	\N	\N	\N	\N	71072	71072	71073
17086	22697	34	applied	\N	\N	\N	\N	71074	71074	71075
17086	22704	35	applied	\N	\N	\N	\N	71088	71088	71089
17086	22705	36	applied	\N	\N	\N	\N	71090	71090	71091
17086	22706	37	applied	\N	\N	\N	\N	71092	71092	71093
17013	22573	0	applied	\N	\N	\N	\N	70733	70733	70734
17013	22574	1	applied	\N	\N	\N	\N	70735	70735	70736
17015	22582	0	applied	\N	\N	\N	\N	70753	70753	70754
17015	22583	1	applied	\N	\N	\N	\N	70755	70755	59294
17015	22584	3	applied	\N	\N	\N	\N	70757	70757	70758
17018	22585	0	applied	\N	\N	\N	\N	70763	70763	70764
17018	22586	1	applied	\N	\N	\N	\N	70765	70765	70766
17018	22587	2	applied	\N	\N	\N	\N	70767	70767	70768
17020	22588	0	applied	\N	\N	\N	\N	70772	70772	70773
17020	22589	1	applied	\N	\N	\N	\N	70774	70774	70775
17020	22590	2	applied	\N	\N	\N	\N	70776	70776	70777
17020	22591	3	applied	\N	\N	\N	\N	70778	70778	70779
17020	22592	4	applied	\N	\N	\N	\N	70780	70780	70781
17020	22593	5	applied	\N	\N	\N	\N	70782	70782	70783
17020	22594	6	applied	\N	\N	\N	\N	70784	70784	59331
17024	22595	0	applied	\N	\N	\N	\N	70791	70791	70792
17024	22596	1	applied	\N	\N	\N	\N	70793	70793	70794
17024	22597	2	applied	\N	\N	\N	\N	70795	70795	70796
17027	22489	0	applied	\N	\N	\N	\N	70501	70501	70502
17027	22490	1	applied	\N	\N	\N	\N	70503	70503	70504
17027	22494	2	applied	\N	\N	\N	\N	70513	70513	70514
17027	22495	3	applied	\N	\N	\N	\N	70515	70515	70516
17027	22498	4	applied	\N	\N	\N	\N	70523	70523	70524
17027	22499	5	applied	\N	\N	\N	\N	70525	70525	70526
17027	22500	6	applied	\N	\N	1000000000	\N	70527	70527	70528
17027	22570	7	applied	\N	\N	1000000000	\N	70725	70725	70726
17027	22504	8	applied	\N	\N	\N	\N	70543	70543	70544
17027	22506	9	applied	\N	\N	\N	\N	70549	70549	70550
17027	22507	10	applied	\N	\N	\N	\N	70553	70553	70554
17027	22510	11	applied	\N	\N	\N	\N	70561	70561	70562
17027	22511	12	applied	\N	\N	\N	\N	70563	70563	70564
17027	22512	13	applied	\N	\N	\N	\N	70565	70565	70566
17027	22516	14	applied	\N	\N	\N	\N	70583	70583	70584
17027	22519	15	applied	\N	\N	\N	\N	70592	70592	70593
17027	22521	16	applied	\N	\N	\N	\N	70601	70601	70602
17027	22522	17	applied	\N	\N	\N	\N	70605	70605	70606
17027	22525	18	applied	\N	\N	\N	\N	70611	70611	70612
17027	22527	19	applied	\N	\N	\N	\N	70617	70617	70618
17027	22528	20	applied	\N	\N	\N	\N	70619	70619	70620
17027	22532	21	applied	\N	\N	\N	\N	70631	70631	70632
17027	22534	22	applied	\N	\N	\N	\N	70636	70636	70637
17027	22536	24	applied	\N	\N	\N	\N	70641	70641	70642
17027	22539	25	applied	\N	\N	\N	\N	70648	70648	70649
17027	22541	26	applied	\N	\N	\N	\N	70654	70654	70655
17027	22542	27	applied	\N	\N	\N	\N	70656	70656	70657
17027	22546	28	applied	\N	\N	\N	\N	70665	70665	70666
17027	22548	29	applied	\N	\N	\N	\N	70674	70674	70675
17027	22550	30	applied	\N	\N	\N	\N	70680	70680	70681
17027	22553	31	applied	\N	\N	\N	\N	70686	70686	70687
17027	22554	32	applied	\N	\N	\N	\N	70688	70688	70689
17027	22557	33	applied	\N	\N	\N	\N	70695	70695	70696
17027	22558	34	applied	\N	\N	\N	\N	70697	70697	70698
17027	22562	35	applied	\N	\N	\N	\N	70705	70705	70706
17027	22564	36	applied	\N	\N	\N	\N	70710	70710	70711
17027	22565	37	applied	\N	\N	\N	\N	70712	70712	70713
17027	22569	38	applied	\N	\N	\N	\N	70723	70723	70724
17027	22573	39	applied	\N	\N	\N	\N	70733	70733	70734
17027	22575	40	applied	\N	\N	\N	\N	70739	70739	70740
17027	22576	41	applied	\N	\N	\N	\N	70741	70741	70742
17027	22582	42	applied	\N	\N	\N	\N	70753	70753	70754
17027	22585	43	applied	\N	\N	\N	\N	70763	70763	70764
17027	22588	44	applied	\N	\N	\N	\N	70772	70772	70773
17027	22589	45	applied	\N	\N	\N	\N	70774	70774	70775
17027	22595	46	applied	\N	\N	\N	\N	70791	70791	70792
17027	22491	47	applied	\N	\N	\N	\N	70505	70505	70506
17027	22492	48	applied	\N	\N	\N	\N	70507	70507	70508
17027	22496	49	applied	\N	\N	\N	\N	70517	70517	59102
17027	22497	50	applied	\N	\N	\N	\N	70519	70519	70801
17027	22501	51	applied	\N	\N	\N	\N	70529	70529	70802
17027	22502	52	applied	\N	\N	\N	\N	70531	70531	59114
17027	22505	53	applied	\N	\N	\N	\N	70545	70545	70534
17027	22509	54	applied	\N	\N	\N	\N	70557	70557	70546
17027	22513	55	applied	\N	\N	\N	\N	70567	70567	59124
17027	22572	56	applied	\N	\N	\N	\N	70729	70729	59131
17027	22574	57	applied	\N	\N	\N	\N	70735	70735	59138
17027	22578	58	applied	\N	\N	\N	\N	70745	70745	59144
17027	22579	59	applied	\N	\N	\N	\N	70747	70747	59152
17027	22583	60	applied	\N	\N	\N	\N	70755	70755	59154
17027	22586	61	applied	\N	\N	\N	\N	70765	70765	59164
17027	22590	62	applied	\N	\N	\N	\N	70776	70776	59166
17027	22591	63	applied	\N	\N	\N	\N	70778	70778	59172
17027	22597	64	applied	\N	\N	\N	\N	70795	70795	59182
17027	22514	65	applied	\N	\N	\N	\N	70568	70568	70645
17027	22515	66	applied	\N	\N	\N	\N	70570	70570	70651
17027	22518	67	applied	\N	\N	\N	\N	70587	70587	59210
17027	22520	68	applied	\N	\N	\N	\N	70594	70594	70803
17027	22524	69	applied	\N	\N	\N	\N	70609	70609	70804
17027	22526	70	applied	\N	\N	\N	\N	70613	70613	59214
17027	22530	71	applied	\N	\N	\N	\N	70622	70622	70683
17027	22531	72	applied	\N	\N	\N	\N	70624	70624	70685
17027	22493	73	applied	\N	\N	\N	\N	70509	70509	70805
17027	22503	74	applied	\N	\N	\N	\N	70533	70533	59222
17027	22508	75	applied	\N	\N	\N	\N	70555	70555	70806
17027	22517	76	applied	\N	\N	\N	\N	70585	70585	70692
17027	22523	77	applied	\N	\N	\N	\N	70607	70607	59228
17027	22529	78	applied	\N	\N	\N	\N	70621	70621	70700
17027	22537	79	applied	\N	\N	\N	\N	70643	70643	70807
17027	22543	80	applied	\N	\N	\N	\N	70658	70658	59234
17027	22551	81	applied	\N	\N	\N	\N	70682	70682	70703
17027	22561	82	applied	\N	\N	\N	\N	70702	70702	70808
17027	22566	83	applied	\N	\N	\N	\N	70714	70714	59240
17027	22577	84	applied	\N	\N	\N	\N	70743	70743	70715
17027	22592	85	applied	\N	\N	\N	\N	70780	70780	70809
17027	22533	86	applied	\N	\N	\N	\N	70633	70633	70810
17027	22535	87	applied	\N	\N	\N	\N	70638	70638	59250
17027	22538	88	applied	\N	\N	\N	\N	70644	70644	70811
17027	22540	89	applied	\N	\N	\N	\N	70650	70650	70730
17027	22544	90	applied	\N	\N	\N	\N	70660	70660	59262
17027	22545	91	applied	\N	\N	\N	\N	70662	70662	70744
17027	22547	92	applied	\N	\N	\N	\N	70667	70667	70812
17027	22549	93	applied	\N	\N	\N	\N	70676	70676	59278
17027	22552	94	applied	\N	\N	\N	\N	70684	70684	70748
17027	22555	95	applied	\N	\N	\N	\N	70690	70690	70750
17027	22556	96	applied	\N	\N	\N	\N	70691	70691	59292
17027	22559	97	applied	\N	\N	\N	\N	70699	70699	70813
17027	22560	98	applied	\N	\N	\N	\N	70701	70701	70814
17027	22563	99	applied	\N	\N	\N	\N	70707	70707	59296
17027	22567	100	applied	\N	\N	\N	\N	70716	70716	70766
17027	22568	101	applied	\N	\N	\N	\N	70717	70717	70768
17027	22571	102	applied	\N	\N	\N	\N	70727	70727	59310
17027	22580	103	applied	\N	\N	\N	\N	70749	70749	70815
17027	22581	104	applied	\N	\N	\N	\N	70751	70751	70779
17027	22584	105	applied	\N	\N	\N	\N	70757	70757	59319
17027	22587	106	applied	\N	\N	\N	\N	70767	70767	70816
17027	22593	107	applied	\N	\N	\N	\N	70782	70782	70817
17027	22594	108	applied	\N	\N	\N	\N	70784	70784	59337
17027	22596	109	applied	\N	\N	\N	\N	70793	70793	70796
17030	22595	0	applied	\N	\N	\N	\N	70791	70791	70792
17030	22596	1	applied	\N	\N	\N	\N	70793	70793	70794
17030	22598	2	applied	\N	\N	\N	\N	70820	70820	70827
17030	22597	3	applied	\N	\N	\N	\N	70795	70795	70821
17030	22599	4	applied	\N	\N	\N	\N	70822	70822	70823
17034	22600	0	applied	\N	\N	\N	\N	70831	70831	70832
17034	22601	1	applied	\N	\N	\N	\N	70833	70833	70834
17041	22615	0	applied	\N	\N	\N	\N	70869	70869	70870
17041	22616	1	applied	\N	\N	\N	\N	70871	70871	70872
17041	22617	2	applied	\N	\N	\N	\N	70873	70873	70874
17044	22621	0	applied	\N	\N	\N	\N	70883	70883	70884
17044	22622	1	applied	\N	\N	\N	\N	70885	70885	70886
17044	22623	2	applied	\N	\N	\N	\N	70887	70887	70888
17044	22624	3	applied	\N	\N	\N	\N	70889	70889	70890
17044	22625	4	applied	\N	\N	\N	\N	70891	70891	70892
17044	22626	5	applied	\N	\N	\N	\N	70893	70893	59428
17046	22627	0	applied	\N	\N	\N	\N	70897	70897	70898
17046	22628	1	applied	\N	\N	\N	\N	70899	70899	59430
17046	22629	2	applied	\N	\N	\N	\N	70900	70900	70901
17046	22630	3	applied	\N	\N	\N	\N	70902	70902	59444
17048	22631	0	applied	\N	\N	\N	\N	70907	70907	70908
17048	22632	1	applied	\N	\N	\N	\N	70909	70909	59461
17048	22633	2	applied	\N	\N	\N	\N	70910	70910	70911
17053	22570	0	applied	\N	\N	1000000000	\N	70725	70725	70726
17053	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17056	22641	0	applied	\N	\N	\N	\N	70940	70940	70941
17056	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17056	22644	2	applied	\N	\N	\N	\N	70946	70946	59490
17056	22642	3	applied	\N	\N	\N	\N	70942	70942	70947
17056	22643	4	applied	\N	\N	\N	\N	70944	70944	59498
17057	22645	0	applied	\N	\N	\N	\N	70951	70951	70952
17057	22646	1	applied	\N	\N	\N	\N	70953	70953	70954
17057	22647	2	applied	\N	\N	\N	\N	70955	70955	70956
17060	22658	0	applied	\N	\N	\N	\N	70976	70976	70977
17060	22659	1	applied	\N	\N	\N	\N	70978	70978	59542
17060	22660	2	applied	\N	\N	\N	\N	70979	70979	59546
17063	22213	0	applied	\N	\N	1000000000	\N	69663	69663	69664
17063	22165	1	applied	\N	\N	\N	\N	69529	69529	69610
17063	22451	2	applied	\N	\N	1000000000	\N	70331	70331	70332
17063	22166	3	applied	\N	\N	\N	\N	69531	69531	69611
17063	22500	4	applied	\N	\N	1000000000	\N	70527	70527	70528
17063	22570	5	applied	\N	\N	1000000000	\N	70725	70725	70726
17063	22640	6	applied	\N	\N	1000000000	\N	70936	70936	70937
17063	22167	7	applied	\N	\N	\N	\N	69533	69533	69612
17063	22168	8	applied	\N	\N	\N	\N	69535	69535	69613
17063	22178	9	applied	\N	\N	\N	\N	69555	69555	69614
17063	22181	10	applied	\N	\N	\N	\N	69563	69563	69615
17063	22182	11	applied	\N	\N	\N	\N	69565	69565	69616
17063	22188	12	applied	\N	\N	\N	\N	69577	69577	69617
17063	22191	13	applied	\N	\N	\N	\N	69584	69584	69618
17063	22194	14	applied	\N	\N	\N	\N	69589	69589	69619
17063	22195	15	applied	\N	\N	\N	\N	69591	69591	69620
17063	22201	16	applied	\N	\N	\N	\N	69628	69628	69974
17063	22204	17	applied	\N	\N	\N	\N	69640	69640	69975
17063	22207	18	applied	\N	\N	\N	\N	69646	69646	69976
17063	22210	19	applied	\N	\N	\N	\N	69655	69655	69977
17063	22214	20	applied	\N	\N	\N	\N	69665	69665	69978
17063	22218	21	applied	\N	\N	\N	\N	69672	69672	69979
17063	22219	22	applied	\N	\N	\N	\N	69674	69674	69980
17063	22228	23	applied	\N	\N	\N	\N	69693	69693	69981
17063	22231	24	applied	\N	\N	\N	\N	69700	69700	69982
17070	22684	0	applied	\N	\N	\N	\N	71035	71035	71036
17070	22685	1	applied	\N	\N	\N	\N	71037	71037	71038
17070	22686	2	applied	\N	\N	\N	\N	71039	71039	71040
17070	22687	3	applied	\N	\N	\N	\N	71041	71041	71042
17077	22690	0	applied	\N	\N	\N	\N	71056	71056	71057
17077	22689	1	applied	\N	\N	\N	\N	71051	71051	59616
17077	22691	2	applied	\N	\N	\N	\N	71058	71058	71059
17077	22692	3	applied	\N	\N	\N	\N	71060	71060	71061
17080	22704	0	applied	\N	\N	\N	\N	71088	71088	71089
17080	22705	1	applied	\N	\N	\N	\N	71090	71090	71091
17080	22706	2	applied	\N	\N	\N	\N	71092	71092	71093
17080	22707	3	applied	\N	\N	\N	\N	71094	71094	70579
17080	22708	4	applied	\N	\N	\N	\N	71095	71095	71096
17080	22709	5	applied	\N	\N	\N	\N	71097	71097	59652
17080	22710	6	applied	\N	\N	\N	\N	71098	71098	71099
17080	22711	7	applied	\N	\N	\N	\N	71100	71100	59663
17080	22712	8	applied	\N	\N	\N	\N	71101	71101	59667
17080	22713	9	applied	\N	\N	\N	\N	71102	71102	59669
17080	22714	10	applied	\N	\N	\N	\N	71103	71103	59681
17087	22732	0	applied	\N	\N	\N	\N	71171	71171	71172
17087	22733	1	applied	\N	\N	\N	\N	71173	71173	71174
17087	22734	2	applied	\N	\N	\N	\N	71175	71175	59748
17090	22738	0	applied	\N	\N	\N	\N	71186	71186	71187
17090	22739	1	applied	\N	\N	\N	\N	71188	71188	71189
17090	22740	2	applied	\N	\N	\N	\N	71190	71190	59781
17095	22748	0	applied	\N	\N	\N	\N	71211	71211	71212
17095	22749	1	applied	\N	\N	\N	\N	71213	71213	71214
17095	22750	2	applied	\N	\N	\N	\N	71215	71215	71216
17095	22751	3	applied	\N	\N	\N	\N	71217	71217	59789
17095	22752	4	applied	\N	\N	\N	\N	71218	71218	71219
17098	22732	0	applied	\N	\N	\N	\N	71171	71171	71172
17098	22735	1	applied	\N	\N	\N	\N	71178	71178	71179
17098	22738	2	applied	\N	\N	\N	\N	71186	71186	71187
17098	22741	3	applied	\N	\N	\N	\N	71193	71193	71194
17098	22744	4	applied	\N	\N	\N	\N	71201	71201	71202
17098	22746	5	applied	\N	\N	\N	\N	71205	71205	71206
17098	22748	6	applied	\N	\N	\N	\N	71211	71211	71212
17098	22749	7	applied	\N	\N	\N	\N	71213	71213	71214
17098	22736	8	applied	\N	\N	\N	\N	71180	71180	71225
17098	22701	9	applied	\N	\N	\N	\N	71081	71081	71226
17098	22740	10	applied	\N	\N	\N	\N	71190	71190	59695
17098	22712	11	applied	\N	\N	\N	\N	71101	71101	71227
17098	22713	12	applied	\N	\N	\N	\N	71102	71102	71228
17098	22714	13	applied	\N	\N	\N	\N	71103	71103	71229
17098	22718	14	applied	\N	\N	\N	\N	71112	71112	71230
17098	22743	15	applied	\N	\N	\N	\N	71197	71197	71231
17098	22722	16	applied	\N	\N	\N	\N	71122	71122	71137
17098	22724	17	applied	\N	\N	\N	\N	71125	71125	71139
17098	22728	18	applied	\N	\N	\N	\N	71134	71134	71174
17098	22734	19	applied	\N	\N	\N	\N	71175	71175	59748
17052	22466	27	applied	\N	\N	\N	\N	70372	70372	70373
17052	22468	28	applied	\N	\N	\N	\N	70377	70377	70378
17052	22469	29	applied	\N	\N	\N	\N	70379	70379	70380
17052	22475	30	applied	\N	\N	\N	\N	70395	70395	70396
17052	22478	31	applied	\N	\N	\N	\N	70403	70403	70404
17052	22481	32	applied	\N	\N	\N	\N	70410	70410	70411
17052	22482	33	applied	\N	\N	\N	\N	70415	70415	70416
17052	22484	34	applied	\N	\N	\N	\N	70492	70492	70493
17052	22487	35	applied	\N	\N	\N	\N	70498	70498	70499
17052	22489	36	applied	\N	\N	\N	\N	70501	70501	70502
17052	22490	37	applied	\N	\N	\N	\N	70503	70503	70504
17052	22494	38	applied	\N	\N	\N	\N	70513	70513	70514
17052	22495	39	applied	\N	\N	\N	\N	70515	70515	70516
17052	22498	40	applied	\N	\N	\N	\N	70523	70523	70524
17052	22499	41	applied	\N	\N	\N	\N	70525	70525	70526
17052	22504	42	applied	\N	\N	\N	\N	70543	70543	70544
17052	22506	43	applied	\N	\N	\N	\N	70549	70549	70550
17052	22507	44	applied	\N	\N	\N	\N	70553	70553	70554
17052	22510	45	applied	\N	\N	\N	\N	70561	70561	70562
17052	22511	47	applied	\N	\N	\N	\N	70563	70563	70564
17052	22512	48	applied	\N	\N	\N	\N	70565	70565	70566
17052	22516	49	applied	\N	\N	\N	\N	70583	70583	70584
17052	22519	50	applied	\N	\N	\N	\N	70592	70592	70593
17052	22521	51	applied	\N	\N	\N	\N	70601	70601	70602
17052	22522	52	applied	\N	\N	\N	\N	70605	70605	70606
17052	22525	53	applied	\N	\N	\N	\N	70611	70611	70612
17052	22527	54	applied	\N	\N	\N	\N	70617	70617	70618
17052	22528	55	applied	\N	\N	\N	\N	70619	70619	70620
17052	22532	56	applied	\N	\N	\N	\N	70631	70631	70632
17052	22534	57	applied	\N	\N	\N	\N	70636	70636	70637
17052	22536	58	applied	\N	\N	\N	\N	70641	70641	70642
17052	22539	59	applied	\N	\N	\N	\N	70648	70648	70649
17052	22541	60	applied	\N	\N	\N	\N	70654	70654	70655
17052	22542	61	applied	\N	\N	\N	\N	70656	70656	70657
17052	22546	62	applied	\N	\N	\N	\N	70665	70665	70666
17052	22548	63	applied	\N	\N	\N	\N	70674	70674	70675
17052	22550	64	applied	\N	\N	\N	\N	70680	70680	70681
17052	22553	65	applied	\N	\N	\N	\N	70686	70686	70687
17052	22554	66	applied	\N	\N	\N	\N	70688	70688	70689
17052	22557	67	applied	\N	\N	\N	\N	70695	70695	70696
17052	22558	68	applied	\N	\N	\N	\N	70697	70697	70698
17052	22562	69	applied	\N	\N	\N	\N	70705	70705	70706
17052	22564	70	applied	\N	\N	\N	\N	70710	70710	70711
17052	22565	71	applied	\N	\N	\N	\N	70712	70712	70713
17052	22569	72	applied	\N	\N	\N	\N	70723	70723	70724
17052	22573	73	applied	\N	\N	\N	\N	70733	70733	70734
17052	22575	74	applied	\N	\N	\N	\N	70739	70739	70740
17052	22576	75	applied	\N	\N	\N	\N	70741	70741	70742
17052	22582	76	applied	\N	\N	\N	\N	70753	70753	70754
17052	22585	77	applied	\N	\N	\N	\N	70763	70763	70764
17052	22588	78	applied	\N	\N	\N	\N	70772	70772	70773
17052	22589	79	applied	\N	\N	\N	\N	70774	70774	70775
17052	22595	80	applied	\N	\N	\N	\N	70791	70791	70792
17052	22600	81	applied	\N	\N	\N	\N	70831	70831	70832
17052	22603	82	applied	\N	\N	\N	\N	70840	70840	70841
17052	22605	83	applied	\N	\N	\N	\N	70849	70849	70850
17052	22608	84	applied	\N	\N	\N	\N	70856	70856	70857
17052	22612	85	applied	\N	\N	\N	\N	70862	70862	70863
17052	22615	86	applied	\N	\N	\N	\N	70869	70869	70870
17052	22618	87	applied	\N	\N	\N	\N	70876	70876	70877
17052	22621	88	applied	\N	\N	\N	\N	70883	70883	70884
17052	22622	89	applied	\N	\N	\N	\N	70885	70885	70886
17052	22627	90	applied	\N	\N	\N	\N	70897	70897	70898
17052	22631	91	applied	\N	\N	\N	\N	70907	70907	70908
17052	22634	92	applied	\N	\N	\N	\N	70913	70913	70914
17052	22637	93	applied	\N	\N	\N	\N	70921	70921	70922
17052	22392	94	applied	\N	\N	\N	\N	70187	70187	70927
17052	22389	95	applied	\N	\N	\N	\N	70181	70181	70928
17052	22390	96	applied	\N	\N	\N	\N	70183	70183	70188
17052	22403	97	applied	\N	\N	\N	\N	70214	70214	70929
17052	22415	98	applied	\N	\N	\N	\N	70243	70243	58795
17052	22423	99	applied	\N	\N	\N	\N	70260	70260	70930
17052	22393	100	applied	\N	\N	\N	\N	70189	70189	58797
17052	22394	101	applied	\N	\N	\N	\N	70190	70190	58799
17052	22398	102	applied	\N	\N	\N	\N	70200	70200	58817
17052	22399	103	applied	\N	\N	\N	\N	70201	70201	58819
17052	22404	104	applied	\N	\N	\N	\N	70217	70217	58821
17052	22400	105	applied	\N	\N	\N	\N	70202	70202	70218
17052	22401	106	applied	\N	\N	\N	\N	70204	70204	70224
17052	22406	107	applied	\N	\N	\N	\N	70223	70223	58829
17052	22409	108	applied	\N	\N	\N	\N	70231	70231	70931
17052	22416	109	applied	\N	\N	\N	\N	70245	70245	70932
17052	22417	110	applied	\N	\N	\N	\N	70246	70246	58843
17052	22418	111	applied	\N	\N	\N	\N	70248	70248	70933
17052	22425	112	applied	\N	\N	\N	\N	70264	70264	70244
17052	22426	113	applied	\N	\N	\N	\N	70266	70266	58853
17052	22407	114	applied	\N	\N	\N	\N	70225	70225	58894
17052	22410	115	applied	\N	\N	\N	\N	70232	70232	58901
17052	22414	116	applied	\N	\N	\N	\N	70242	70242	58903
17052	22419	117	applied	\N	\N	\N	\N	70250	70250	58909
17052	22420	118	applied	\N	\N	\N	\N	70252	70252	58914
17052	22424	119	applied	\N	\N	\N	\N	70262	70262	58919
17052	22427	120	applied	\N	\N	\N	\N	70267	70267	58925
17052	22429	121	applied	\N	\N	\N	\N	70275	70275	58931
17052	22433	122	applied	\N	\N	\N	\N	70288	70288	58936
17052	22436	123	applied	\N	\N	\N	\N	70296	70296	58942
17052	22442	124	applied	\N	\N	\N	\N	70313	70313	58946
17052	22443	125	applied	\N	\N	\N	\N	70315	70315	58953
17055	22641	0	applied	\N	\N	\N	\N	70940	70940	70941
17055	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17055	22644	2	applied	\N	\N	\N	\N	70946	70946	59490
17055	22642	3	applied	\N	\N	\N	\N	70942	70942	70947
17055	22643	4	applied	\N	\N	\N	\N	70944	70944	59498
17065	22665	0	applied	\N	\N	\N	\N	70994	70994	70995
17067	22451	0	applied	\N	\N	1000000000	\N	70331	70331	70332
17067	22500	1	applied	\N	\N	1000000000	\N	70527	70527	70528
17067	22570	2	applied	\N	\N	1000000000	\N	70725	70725	70726
17067	22640	3	applied	\N	\N	1000000000	\N	70936	70936	70937
17067	22397	4	applied	\N	\N	\N	\N	70199	70199	65473
17075	22688	0	applied	\N	\N	\N	\N	71049	71049	71050
17076	22690	0	applied	\N	\N	\N	\N	71056	71056	71057
17076	22689	1	applied	\N	\N	\N	\N	71051	71051	59616
17076	22691	2	applied	\N	\N	\N	\N	71058	71058	71059
17076	22692	3	applied	\N	\N	\N	\N	71060	71060	71061
17079	22696	0	applied	\N	\N	\N	\N	71072	71072	71073
17079	22697	1	applied	\N	\N	\N	\N	71074	71074	71075
17079	22698	2	applied	\N	\N	\N	\N	71076	71076	71077
17079	22699	3	applied	\N	\N	\N	\N	71078	71078	59631
17079	22700	4	applied	\N	\N	\N	\N	71079	71079	71080
17079	22701	5	applied	\N	\N	\N	\N	71081	71081	59640
17079	22702	6	applied	\N	\N	\N	\N	71082	71082	71083
17079	22703	7	applied	\N	\N	\N	\N	71084	71084	71085
17085	22726	0	applied	\N	\N	\N	\N	71130	71130	71131
17085	22727	1	applied	\N	\N	\N	\N	71132	71132	71133
17085	22728	2	applied	\N	\N	\N	\N	71134	71134	59723
17085	22729	3	applied	\N	\N	\N	\N	71135	71135	59729
17085	22730	4	applied	\N	\N	\N	\N	71136	71136	71137
17085	22731	5	applied	\N	\N	\N	\N	71138	71138	71139
17089	22738	0	applied	\N	\N	\N	\N	71186	71186	71187
17089	22739	1	applied	\N	\N	\N	\N	71188	71188	71189
17089	22740	2	applied	\N	\N	\N	\N	71190	71190	59781
17094	22746	0	applied	\N	\N	\N	\N	71205	71205	71206
17094	22747	1	applied	\N	\N	\N	\N	71207	71207	71208
17101	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17101	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17101	22698	2	applied	\N	\N	\N	\N	71076	71076	71077
17101	22707	3	applied	\N	\N	\N	\N	71094	71094	70579
17108	22762	0	applied	\N	\N	\N	\N	71262	71262	71263
17108	22763	1	applied	\N	\N	\N	\N	71264	71264	59805
17113	22770	0	applied	\N	\N	\N	\N	71284	71284	71285
17113	22771	1	applied	\N	\N	\N	\N	71286	71286	59829
17117	22772	0	applied	\N	\N	\N	\N	71300	71300	71301
17117	22773	1	applied	\N	\N	\N	\N	71302	71302	59835
17117	22774	2	applied	\N	\N	\N	\N	71303	71303	71304
17122	22782	0	applied	\N	\N	\N	\N	71324	71324	71325
17122	22783	1	applied	\N	\N	\N	\N	71326	71326	59859
17082	22717	2	applied	\N	\N	\N	\N	71110	71110	71111
17082	22718	3	applied	\N	\N	\N	\N	71112	71112	59685
17084	22723	0	applied	\N	\N	\N	\N	71123	71123	71124
17084	22724	1	applied	\N	\N	\N	\N	71125	71125	71126
17084	22725	2	applied	\N	\N	\N	\N	71127	71127	59712
17091	22741	0	applied	\N	\N	\N	\N	71193	71193	71194
17091	22742	1	applied	\N	\N	\N	\N	71195	71195	71196
17091	22743	2	applied	\N	\N	\N	\N	71197	71197	71198
17093	22744	0	applied	\N	\N	\N	\N	71201	71201	71202
17093	22745	1	applied	\N	\N	\N	\N	71203	71203	59785
17097	22748	0	applied	\N	\N	\N	\N	71211	71211	71212
17097	22749	1	applied	\N	\N	\N	\N	71213	71213	71214
17097	22750	2	applied	\N	\N	\N	\N	71215	71215	71216
17097	22751	3	applied	\N	\N	\N	\N	71217	71217	59789
17097	22752	4	applied	\N	\N	\N	\N	71218	71218	71219
17103	22753	0	applied	\N	\N	\N	\N	71236	71236	71237
17103	22755	1	applied	\N	\N	\N	\N	71243	71243	71244
17103	22754	2	applied	\N	\N	\N	\N	71238	71238	59791
17103	22756	3	applied	\N	\N	\N	\N	71245	71245	71246
17105	22757	0	applied	\N	\N	\N	\N	71250	71250	71251
17105	22758	1	applied	\N	\N	\N	\N	71252	71252	59796
17105	22759	2	applied	\N	\N	\N	\N	71253	71253	71254
17107	22762	0	applied	\N	\N	\N	\N	71262	71262	71263
17107	22763	1	applied	\N	\N	\N	\N	71264	71264	59805
17110	22765	0	applied	\N	\N	\N	\N	71270	71270	59815
17110	22766	1	applied	\N	\N	\N	\N	71271	71271	71272
17110	22767	2	applied	\N	\N	\N	\N	71273	71273	71274
17112	22770	0	applied	\N	\N	\N	\N	71284	71284	71285
17112	22771	1	applied	\N	\N	\N	\N	71286	71286	59829
17119	22775	0	applied	\N	\N	\N	\N	71307	71307	71308
17119	22776	1	applied	\N	\N	\N	\N	71309	71309	59840
17121	22779	0	applied	\N	\N	\N	\N	71317	71317	71318
17121	22780	1	applied	\N	\N	\N	\N	71319	71319	71320
17121	22781	2	applied	\N	\N	\N	\N	71321	71321	59846
17086	22716	38	applied	\N	\N	\N	\N	71108	71108	71109
17086	22719	40	applied	\N	\N	\N	\N	71117	71117	71118
17086	22723	41	applied	\N	\N	\N	\N	71123	71123	71124
17086	22726	42	applied	\N	\N	\N	\N	71130	71130	71131
17086	22727	43	applied	\N	\N	\N	\N	71132	71132	71133
17086	22598	44	applied	\N	\N	\N	\N	70820	70820	70821
17086	22707	45	applied	\N	\N	\N	\N	71094	71094	70579
17086	22601	46	applied	\N	\N	\N	\N	70833	70833	71143
17086	22604	47	applied	\N	\N	\N	\N	70842	70842	70836
17086	22602	48	applied	\N	\N	\N	\N	70835	70835	59354
17086	22606	49	applied	\N	\N	\N	\N	70851	70851	71144
17086	22610	50	applied	\N	\N	\N	\N	70860	70860	71145
17086	22614	51	applied	\N	\N	\N	\N	70865	70865	59370
17086	22599	52	applied	\N	\N	\N	\N	70822	70822	70859
17086	22609	53	applied	\N	\N	\N	\N	70858	70858	71146
17086	22619	54	applied	\N	\N	\N	\N	70878	70878	59377
17086	22617	55	applied	\N	\N	\N	\N	70873	70873	71147
17086	22625	56	applied	\N	\N	\N	\N	70891	70891	71148
17086	22626	57	applied	\N	\N	\N	\N	70893	70893	59391
17086	22629	58	applied	\N	\N	\N	\N	70900	70900	70866
17086	22633	59	applied	\N	\N	\N	\N	70910	70910	71149
17086	22636	60	applied	\N	\N	\N	\N	70917	70917	59400
17086	22639	61	applied	\N	\N	\N	\N	70925	70925	70879
17086	22642	62	applied	\N	\N	\N	\N	70942	70942	71150
17086	22646	63	applied	\N	\N	\N	\N	70953	70953	59412
17086	22651	64	applied	\N	\N	\N	\N	70963	70963	70888
17086	22652	65	applied	\N	\N	\N	\N	70965	70965	71151
17086	22656	66	applied	\N	\N	\N	\N	70973	70973	59426
17086	22660	67	applied	\N	\N	\N	\N	70979	70979	71152
17086	22662	68	applied	\N	\N	\N	\N	70983	70983	71153
17086	22670	69	applied	\N	\N	\N	\N	71007	71007	59430
17086	22671	70	applied	\N	\N	\N	\N	71008	71008	70901
17086	22672	71	applied	\N	\N	\N	\N	71009	71009	71154
17086	22673	72	applied	\N	\N	\N	\N	71011	71011	59461
17086	22680	73	applied	\N	\N	\N	\N	71027	71027	70911
17086	22682	74	applied	\N	\N	\N	\N	71031	71031	71155
17086	22685	75	applied	\N	\N	\N	\N	71037	71037	59471
17086	22692	76	applied	\N	\N	\N	\N	71060	71060	71156
17086	22694	77	applied	\N	\N	\N	\N	71068	71068	70924
17086	22699	78	applied	\N	\N	\N	\N	71078	71078	59488
17086	22702	79	applied	\N	\N	\N	\N	71082	71082	70943
17086	22708	80	applied	\N	\N	\N	\N	71095	71095	71157
17086	22710	81	applied	\N	\N	\N	\N	71098	71098	59498
17086	22711	82	applied	\N	\N	\N	\N	71100	71100	70954
17086	22717	83	applied	\N	\N	\N	\N	71110	71110	71158
17086	22720	84	applied	\N	\N	\N	\N	71119	71119	59508
17086	22725	85	applied	\N	\N	\N	\N	71127	71127	70964
17086	22729	86	applied	\N	\N	\N	\N	71135	71135	70966
17086	22730	87	applied	\N	\N	\N	\N	71136	71136	59518
17086	22607	88	applied	\N	\N	\N	\N	70852	70852	59522
17086	22611	89	applied	\N	\N	\N	\N	70861	70861	59528
17086	22613	90	applied	\N	\N	\N	\N	70864	70864	59530
17086	22616	91	applied	\N	\N	\N	\N	70871	70871	59542
17086	22620	92	applied	\N	\N	\N	\N	70880	70880	71159
17086	22623	93	applied	\N	\N	\N	\N	70887	70887	71160
17086	22624	94	applied	\N	\N	\N	\N	70889	70889	70995
17086	22628	95	applied	\N	\N	\N	\N	70899	70899	71161
17086	22632	96	applied	\N	\N	\N	\N	70909	70909	71010
17086	22635	97	applied	\N	\N	\N	\N	70915	70915	59570
17086	22638	98	applied	\N	\N	\N	\N	70923	70923	71162
17086	22644	99	applied	\N	\N	\N	\N	70946	70946	59579
17086	22647	100	applied	\N	\N	\N	\N	70955	70955	71163
17086	22630	101	applied	\N	\N	\N	\N	70902	70902	59583
17086	22643	102	applied	\N	\N	\N	\N	70944	70944	71020
17086	22650	103	applied	\N	\N	\N	\N	70962	70962	59585
17086	22664	104	applied	\N	\N	\N	\N	70986	70986	59587
17086	22665	105	applied	\N	\N	\N	\N	70994	70994	71026
17086	22687	106	applied	\N	\N	\N	\N	71041	71041	71164
17086	22703	107	applied	\N	\N	\N	\N	71084	71084	59589
17086	22709	108	applied	\N	\N	\N	\N	71097	71097	71165
17086	22721	109	applied	\N	\N	\N	\N	71121	71121	59591
17086	22653	110	applied	\N	\N	\N	\N	70967	70967	71033
17086	22654	111	applied	\N	\N	\N	\N	70968	70968	59597
17086	22657	112	applied	\N	\N	\N	\N	70974	70974	71042
17086	22659	113	applied	\N	\N	\N	\N	70978	70978	59616
17086	22663	114	applied	\N	\N	\N	\N	70985	70985	71059
17086	22674	115	applied	\N	\N	\N	\N	71013	71013	59622
17086	22675	116	applied	\N	\N	\N	\N	71015	71015	71166
17086	22676	117	applied	\N	\N	\N	\N	71017	71017	59631
17086	22677	118	applied	\N	\N	\N	\N	71019	71019	71080
17086	22679	119	applied	\N	\N	\N	\N	71025	71025	59640
17086	22683	120	applied	\N	\N	\N	\N	71032	71032	71085
17086	22686	121	applied	\N	\N	\N	\N	71039	71039	59652
17086	22689	122	applied	\N	\N	\N	\N	71051	71051	71167
17086	22691	123	applied	\N	\N	\N	\N	71058	71058	59665
17086	22695	124	applied	\N	\N	\N	\N	71069	71069	71168
17086	22700	125	applied	\N	\N	\N	\N	71079	71079	59671
17088	22735	0	applied	\N	\N	\N	\N	71178	71178	71179
17088	22736	1	applied	\N	\N	\N	\N	71180	71180	71181
17088	22737	2	applied	\N	\N	\N	\N	71182	71182	71183
17096	22748	0	applied	\N	\N	\N	\N	71211	71211	71212
17096	22749	1	applied	\N	\N	\N	\N	71213	71213	71214
17096	22750	2	applied	\N	\N	\N	\N	71215	71215	71216
17096	22751	3	applied	\N	\N	\N	\N	71217	71217	59789
17096	22752	4	applied	\N	\N	\N	\N	71218	71218	71219
17100	22753	0	applied	\N	\N	\N	\N	71236	71236	71237
17100	22754	1	applied	\N	\N	\N	\N	71238	71238	59791
17106	22760	0	applied	\N	\N	\N	\N	71257	71257	71258
17106	22761	1	applied	\N	\N	\N	\N	71259	71259	71260
17114	22770	0	applied	\N	\N	\N	\N	71284	71284	71285
17114	22771	1	applied	\N	\N	\N	\N	71286	71286	59829
17120	22777	0	applied	\N	\N	\N	\N	71313	71313	71314
17120	22778	1	applied	\N	\N	\N	\N	71315	71315	59844
17123	22782	0	applied	\N	\N	\N	\N	71324	71324	71325
17123	22783	1	applied	\N	\N	\N	\N	71326	71326	59859
17098	22742	20	applied	\N	\N	\N	\N	71195	71195	71232
17098	22745	21	applied	\N	\N	\N	\N	71203	71203	59750
17098	22747	22	applied	\N	\N	\N	\N	71207	71207	71183
17098	22750	23	applied	\N	\N	\N	\N	71215	71215	59777
17098	22751	24	applied	\N	\N	\N	\N	71217	71217	59779
17098	22752	25	applied	\N	\N	\N	\N	71218	71218	59781
17098	22731	26	applied	\N	\N	\N	\N	71138	71138	71198
17098	22733	27	applied	\N	\N	\N	\N	71173	71173	71233
17098	22737	28	applied	\N	\N	\N	\N	71182	71182	71216
17098	22739	29	applied	\N	\N	\N	\N	71188	71188	71219
17102	22753	0	applied	\N	\N	\N	\N	71236	71236	71237
17102	22755	1	applied	\N	\N	\N	\N	71243	71243	71244
17102	22754	2	applied	\N	\N	\N	\N	71238	71238	59791
17102	22756	3	applied	\N	\N	\N	\N	71245	71245	71246
17104	22757	0	applied	\N	\N	\N	\N	71250	71250	71251
17104	22758	1	applied	\N	\N	\N	\N	71252	71252	59796
17104	22759	2	applied	\N	\N	\N	\N	71253	71253	71254
17109	22764	0	applied	\N	\N	\N	\N	71268	71268	71269
17109	22765	1	applied	\N	\N	\N	\N	71270	71270	59815
17109	22766	2	applied	\N	\N	\N	\N	71271	71271	71272
17109	22767	3	applied	\N	\N	\N	\N	71273	71273	71274
17111	22768	0	applied	\N	\N	\N	\N	71278	71278	71279
17111	22769	1	applied	\N	\N	\N	\N	71280	71280	71281
17115	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17115	22688	1	applied	\N	\N	\N	\N	71049	71049	71050
17115	22690	2	applied	\N	\N	\N	\N	71056	71056	71057
17115	22693	3	applied	\N	\N	\N	\N	71066	71066	71067
17115	22696	4	applied	\N	\N	\N	\N	71072	71072	71073
17115	22697	5	applied	\N	\N	\N	\N	71074	71074	71075
17115	22704	6	applied	\N	\N	\N	\N	71088	71088	71089
17115	22705	7	applied	\N	\N	\N	\N	71090	71090	71091
17115	22706	8	applied	\N	\N	\N	\N	71092	71092	71093
17115	22716	9	applied	\N	\N	\N	\N	71108	71108	71109
17115	22698	10	applied	\N	\N	\N	\N	71076	71076	71077
17115	22719	11	applied	\N	\N	\N	\N	71117	71117	71118
17115	22723	12	applied	\N	\N	\N	\N	71123	71123	71124
17115	22726	13	applied	\N	\N	\N	\N	71130	71130	71131
17115	22727	14	applied	\N	\N	\N	\N	71132	71132	71133
17115	22732	15	applied	\N	\N	\N	\N	71171	71171	71172
17115	22735	16	applied	\N	\N	\N	\N	71178	71178	71179
17115	22738	17	applied	\N	\N	\N	\N	71186	71186	71187
17115	22741	18	applied	\N	\N	\N	\N	71193	71193	71194
17115	22744	19	applied	\N	\N	\N	\N	71201	71201	71202
17115	22746	20	applied	\N	\N	\N	\N	71205	71205	71206
17115	22748	21	applied	\N	\N	\N	\N	71211	71211	71212
17115	22749	22	applied	\N	\N	\N	\N	71213	71213	71214
17115	22753	23	applied	\N	\N	\N	\N	71236	71236	71237
17115	22755	24	applied	\N	\N	\N	\N	71243	71243	71244
17115	22757	25	applied	\N	\N	\N	\N	71250	71250	71251
17115	22760	26	applied	\N	\N	\N	\N	71257	71257	71258
17115	22762	27	applied	\N	\N	\N	\N	71262	71262	71263
17115	22764	28	applied	\N	\N	\N	\N	71268	71268	71269
17115	22768	29	applied	\N	\N	\N	\N	71278	71278	71279
17115	22770	30	applied	\N	\N	\N	\N	71284	71284	71285
17115	22707	31	applied	\N	\N	\N	\N	71094	71094	70579
17115	22689	32	applied	\N	\N	\N	\N	71051	71051	59616
17115	22691	33	applied	\N	\N	\N	\N	71058	71058	71059
17115	22695	34	applied	\N	\N	\N	\N	71069	71069	59622
17115	22700	35	applied	\N	\N	\N	\N	71079	71079	71166
17115	22701	36	applied	\N	\N	\N	\N	71081	71081	59631
17115	22767	37	applied	\N	\N	\N	\N	71273	71273	71274
17115	22692	38	applied	\N	\N	\N	\N	71060	71060	71293
17115	22694	39	applied	\N	\N	\N	\N	71068	71068	59638
17115	22699	40	applied	\N	\N	\N	\N	71078	71078	59640
17115	22702	41	applied	\N	\N	\N	\N	71082	71082	71083
17115	22708	42	applied	\N	\N	\N	\N	71095	71095	59650
17115	22710	43	applied	\N	\N	\N	\N	71098	71098	59652
17115	22711	44	applied	\N	\N	\N	\N	71100	71100	71099
17115	22717	45	applied	\N	\N	\N	\N	71110	71110	59663
17115	22720	46	applied	\N	\N	\N	\N	71119	71119	59665
17115	22725	47	applied	\N	\N	\N	\N	71127	71127	71294
17115	22729	48	applied	\N	\N	\N	\N	71135	71135	59669
17115	22730	49	applied	\N	\N	\N	\N	71136	71136	59671
17115	22736	50	applied	\N	\N	\N	\N	71180	71180	71225
17115	22740	51	applied	\N	\N	\N	\N	71190	71190	59683
17115	22712	52	applied	\N	\N	\N	\N	71101	71101	59695
17115	22713	53	applied	\N	\N	\N	\N	71102	71102	71227
17115	22714	54	applied	\N	\N	\N	\N	71103	71103	71228
17115	22718	55	applied	\N	\N	\N	\N	71112	71112	71229
17115	22703	56	applied	\N	\N	\N	\N	71084	71084	59712
17115	22709	57	applied	\N	\N	\N	\N	71097	71097	59721
17115	22721	58	applied	\N	\N	\N	\N	71121	71121	71230
17115	22743	59	applied	\N	\N	\N	\N	71197	71197	71231
17115	22722	60	applied	\N	\N	\N	\N	71122	71122	71137
17115	22724	61	applied	\N	\N	\N	\N	71125	71125	71139
17115	22728	62	applied	\N	\N	\N	\N	71134	71134	71174
17115	22734	63	applied	\N	\N	\N	\N	71175	71175	59748
17115	22742	64	applied	\N	\N	\N	\N	71195	71195	71232
17115	22745	65	applied	\N	\N	\N	\N	71203	71203	59750
17115	22747	66	applied	\N	\N	\N	\N	71207	71207	71183
17115	22750	67	applied	\N	\N	\N	\N	71215	71215	59777
17115	22751	68	applied	\N	\N	\N	\N	71217	71217	59779
17115	22754	69	applied	\N	\N	\N	\N	71238	71238	71196
17115	22756	70	applied	\N	\N	\N	\N	71245	71245	71198
17115	22752	71	applied	\N	\N	\N	\N	71218	71218	71295
17115	22758	72	applied	\N	\N	\N	\N	71252	71252	59785
17115	22766	73	applied	\N	\N	\N	\N	71271	71271	71233
17115	22759	74	applied	\N	\N	\N	\N	71253	71253	59787
17115	22761	75	applied	\N	\N	\N	\N	71259	71259	71296
17115	22763	76	applied	\N	\N	\N	\N	71264	71264	71219
17115	22765	77	applied	\N	\N	\N	\N	71270	71270	59791
17115	22769	78	applied	\N	\N	\N	\N	71280	71280	71246
17115	22771	79	applied	\N	\N	\N	\N	71286	71286	71297
17115	22731	80	applied	\N	\N	\N	\N	71138	71138	71260
17115	22733	81	applied	\N	\N	\N	\N	71173	71173	71298
17115	22737	82	applied	\N	\N	\N	\N	71182	71182	59827
17115	22739	83	applied	\N	\N	\N	\N	71188	71188	59829
17118	22775	0	applied	\N	\N	\N	\N	71307	71307	71308
17118	22776	1	applied	\N	\N	\N	\N	71309	71309	59840
17124	22784	0	applied	\N	\N	\N	\N	71330	71330	71331
17124	22785	1	applied	\N	\N	\N	\N	71332	71332	71333
17125	22784	0	applied	\N	\N	\N	\N	71330	71330	71331
17125	22785	1	applied	\N	\N	\N	\N	71332	71332	71333
17126	22786	0	applied	\N	\N	\N	\N	71336	71336	71337
17126	22787	1	applied	\N	\N	\N	\N	71338	71338	71339
17126	22788	2	applied	\N	\N	\N	\N	71340	71340	59863
17127	22753	0	applied	\N	\N	\N	\N	71236	71236	71237
17127	22755	1	applied	\N	\N	\N	\N	71243	71243	71244
17127	22757	2	applied	\N	\N	\N	\N	71250	71250	71251
17127	22760	3	applied	\N	\N	\N	\N	71257	71257	71258
17127	22762	4	applied	\N	\N	\N	\N	71262	71262	71263
17127	22764	5	applied	\N	\N	\N	\N	71268	71268	71269
17127	22768	6	applied	\N	\N	\N	\N	71278	71278	71279
17127	22770	8	applied	\N	\N	\N	\N	71284	71284	71285
17127	22772	9	applied	\N	\N	\N	\N	71300	71300	71301
17127	22775	10	applied	\N	\N	\N	\N	71307	71307	71308
17127	22777	11	applied	\N	\N	\N	\N	71313	71313	71314
17127	22779	12	applied	\N	\N	\N	\N	71317	71317	71318
17127	22782	13	applied	\N	\N	\N	\N	71324	71324	71325
17127	22784	14	applied	\N	\N	\N	\N	71330	71330	71331
17127	22786	15	applied	\N	\N	\N	\N	71336	71336	71337
17127	22754	16	applied	\N	\N	\N	\N	71238	71238	59791
17127	22756	17	applied	\N	\N	\N	\N	71245	71245	71246
17127	22767	18	applied	\N	\N	\N	\N	71273	71273	71274
17127	22758	19	applied	\N	\N	\N	\N	71252	71252	59796
17127	22766	20	applied	\N	\N	\N	\N	71271	71271	71297
17127	22774	21	applied	\N	\N	\N	\N	71303	71303	71254
17127	22781	22	applied	\N	\N	\N	\N	71321	71321	59803
17127	22788	23	applied	\N	\N	\N	\N	71340	71340	71260
17127	22759	24	applied	\N	\N	\N	\N	71253	71253	59805
17127	22761	25	applied	\N	\N	\N	\N	71259	71259	59815
17127	22763	26	applied	\N	\N	\N	\N	71264	71264	59827
17127	22765	27	applied	\N	\N	\N	\N	71270	71270	71343
17127	22769	28	applied	\N	\N	\N	\N	71280	71280	71344
17127	22771	29	applied	\N	\N	\N	\N	71286	71286	71304
17127	22773	30	applied	\N	\N	\N	\N	71302	71302	59840
17127	22776	31	applied	\N	\N	\N	\N	71309	71309	59844
17127	22778	32	applied	\N	\N	\N	\N	71315	71315	71320
17127	22780	33	applied	\N	\N	\N	\N	71319	71319	71345
17127	22783	34	applied	\N	\N	\N	\N	71326	71326	71346
17127	22785	35	applied	\N	\N	\N	\N	71332	71332	59861
17129	22790	0	applied	\N	\N	\N	\N	71353	71353	71354
17129	22791	1	applied	\N	\N	\N	\N	71355	71355	71356
17129	22792	2	applied	\N	\N	\N	\N	71357	71357	71358
17132	22793	0	applied	\N	\N	\N	\N	71360	71360	71361
17132	22794	1	applied	\N	\N	\N	\N	71362	71362	59876
17132	22795	2	applied	\N	\N	\N	\N	71363	71363	59884
17134	22796	0	applied	\N	\N	\N	\N	71369	71369	71370
17134	22797	1	applied	\N	\N	\N	\N	71371	71371	71372
17134	22798	2	applied	\N	\N	\N	\N	71373	71373	59904
17134	22799	3	applied	\N	\N	\N	\N	71374	71374	71375
17139	22804	0	applied	\N	\N	\N	\N	71390	71390	71391
17139	22805	1	applied	\N	\N	\N	\N	71392	71392	59912
17141	22809	0	applied	\N	\N	\N	\N	71402	71402	71403
17141	22810	1	applied	\N	\N	\N	\N	71404	71404	59916
17141	22811	2	applied	\N	\N	\N	\N	71405	71405	71406
17141	22812	3	applied	\N	\N	\N	\N	71407	71407	71408
17149	22841	0	applied	\N	\N	\N	\N	71463	71463	71464
17149	22842	1	applied	\N	\N	\N	\N	71465	71465	60100
17149	22843	2	applied	\N	\N	\N	\N	71466	71466	71467
17149	22844	3	applied	\N	\N	\N	\N	71468	71468	60108
17155	22848	0	applied	\N	\N	\N	\N	71482	71482	71483
17155	22849	1	applied	\N	\N	\N	\N	71484	71484	71485
17155	22850	2	applied	\N	\N	\N	\N	71486	71486	71487
17155	22851	3	applied	\N	\N	\N	\N	71488	71488	60139
17155	22852	4	applied	\N	\N	\N	\N	71489	71489	71490
17155	22853	5	applied	\N	\N	\N	\N	71491	71491	60157
17155	22854	6	applied	\N	\N	\N	\N	71492	71492	60159
17155	22855	7	applied	\N	\N	\N	\N	71493	71493	71494
17155	22856	8	applied	\N	\N	\N	\N	71495	71495	71496
17155	22857	9	applied	\N	\N	\N	\N	71497	71497	71498
17159	22858	0	applied	\N	\N	\N	\N	71508	71508	71486
17159	22859	1	applied	\N	\N	\N	\N	71509	71509	71510
17159	22860	2	applied	\N	\N	\N	\N	71511	71511	71512
17159	22861	3	applied	\N	\N	\N	\N	71513	71513	60231
17159	22862	4	applied	\N	\N	\N	\N	71514	71514	60240
17159	22863	5	applied	\N	\N	\N	\N	71515	71515	60251
17159	22864	6	applied	\N	\N	\N	\N	71516	71516	60253
17169	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17169	22500	1	applied	\N	\N	1000000000	\N	70527	70527	70528
17169	22570	2	applied	\N	\N	1000000000	\N	70725	70725	70726
17169	22640	3	applied	\N	\N	1000000000	\N	70936	70936	70937
17169	22698	4	applied	\N	\N	\N	\N	71076	71076	71077
17169	22790	5	applied	\N	\N	\N	\N	71353	71353	71354
17169	22806	6	applied	\N	\N	1000000000	\N	71396	71396	71397
17169	22830	7	applied	\N	\N	1000000000	\N	71441	71441	71442
17169	22850	8	applied	\N	\N	\N	\N	71505	71505	71487
17169	22707	9	applied	\N	\N	\N	\N	71094	71094	71486
17169	22767	10	applied	\N	\N	\N	\N	71273	71273	71274
17172	22902	0	applied	\N	\N	\N	\N	71598	71598	71599
17172	22903	1	applied	\N	\N	\N	\N	71600	71600	71601
17172	22904	2	applied	\N	\N	\N	\N	71602	71602	60506
17174	22908	0	applied	\N	\N	\N	\N	71611	71611	71612
17174	22909	1	applied	\N	\N	\N	\N	71613	71613	60542
17174	22910	2	applied	\N	\N	\N	\N	71614	71614	71615
17174	22911	3	applied	\N	\N	\N	\N	71616	71616	71617
17178	22912	0	applied	\N	\N	\N	\N	71625	71625	71626
17178	22913	1	applied	\N	\N	\N	\N	71627	71627	71628
17178	22914	2	applied	\N	\N	\N	\N	71629	71629	60566
17181	22915	0	applied	\N	\N	\N	\N	71632	71632	71633
17181	22916	1	applied	\N	\N	\N	\N	71634	71634	28166
17181	22917	2	applied	\N	\N	\N	\N	71635	71635	71636
17181	22918	3	applied	\N	\N	\N	\N	71637	71637	71638
17181	22919	4	applied	\N	\N	\N	\N	71639	71639	71640
17181	22920	5	applied	\N	\N	\N	\N	71641	71641	71642
17192	22937	0	applied	\N	\N	\N	\N	71683	71683	71684
17192	22938	1	applied	\N	\N	\N	\N	71685	71685	60718
17192	22939	2	applied	\N	\N	\N	\N	71686	71686	60729
17195	22940	0	applied	\N	\N	\N	\N	71691	71691	71692
17195	22941	1	applied	\N	\N	\N	\N	71693	71693	71694
17195	22942	2	applied	\N	\N	\N	\N	71695	71695	60750
17195	22943	3	applied	\N	\N	\N	\N	71696	71696	60763
17199	22947	0	applied	\N	\N	\N	\N	71709	71709	71710
17199	22948	1	applied	\N	\N	\N	\N	71711	71711	71712
17199	22949	2	applied	\N	\N	\N	\N	71713	71713	60783
17199	22950	3	applied	\N	\N	\N	\N	71714	71714	60792
17199	22951	4	applied	\N	\N	\N	\N	71715	71715	60797
17199	22952	5	applied	\N	\N	\N	\N	71716	71716	60810
17204	22956	0	applied	\N	\N	\N	\N	71727	71727	71728
17204	22957	1	applied	\N	\N	\N	\N	71729	71729	71730
17204	22958	2	applied	\N	\N	\N	\N	71731	71731	60860
17216	22970	0	applied	\N	\N	\N	\N	71766	71766	60940
17217	22972	0	applied	\N	\N	\N	\N	71775	71775	71776
17217	22973	1	applied	\N	\N	\N	\N	71777	71777	71778
17217	22974	2	applied	\N	\N	\N	\N	71779	71779	60963
17217	22975	3	applied	\N	\N	\N	\N	71780	71780	60967
17217	22976	4	applied	\N	\N	\N	\N	71781	71781	60973
17217	22977	5	applied	\N	\N	\N	\N	71782	71782	60983
17217	22978	6	applied	\N	\N	\N	\N	71783	71783	60992
17128	22789	0	applied	\N	\N	\N	\N	71349	71349	71350
17130	22793	0	applied	\N	\N	\N	\N	71360	71360	71361
17130	22794	1	applied	\N	\N	\N	\N	71362	71362	59876
17130	22795	2	applied	\N	\N	\N	\N	71363	71363	59884
17131	22793	0	applied	\N	\N	\N	\N	71360	71360	71361
17131	22794	1	applied	\N	\N	\N	\N	71362	71362	59876
17131	22795	2	applied	\N	\N	\N	\N	71363	71363	59884
17133	22796	0	applied	\N	\N	\N	\N	71369	71369	71370
17133	22797	1	applied	\N	\N	\N	\N	71371	71371	71372
17133	22798	2	applied	\N	\N	\N	\N	71373	71373	59904
17133	22799	3	applied	\N	\N	\N	\N	71374	71374	71375
17135	22800	0	applied	\N	\N	\N	\N	71378	71378	71379
17135	22801	1	applied	\N	\N	\N	\N	71380	71380	59908
17136	22800	0	applied	\N	\N	\N	\N	71378	71378	71379
17136	22801	1	applied	\N	\N	\N	\N	71380	71380	59908
17137	22802	0	applied	\N	\N	\N	\N	71384	71384	71385
17137	22803	1	applied	\N	\N	\N	\N	71386	71386	71387
17138	22804	0	applied	\N	\N	\N	\N	71390	71390	71391
17138	22805	1	applied	\N	\N	\N	\N	71392	71392	59912
17140	22806	0	applied	\N	\N	1000000000	\N	71396	71396	71397
17140	22807	1	applied	\N	\N	\N	\N	71398	71398	71399
17140	22808	2	applied	\N	\N	\N	\N	71400	71400	59914
17143	22822	0	applied	\N	\N	\N	\N	71424	71424	71425
17143	22823	1	applied	\N	\N	\N	\N	71426	71426	59991
17143	22824	2	applied	\N	\N	\N	\N	71427	71427	59998
17145	22825	0	applied	\N	\N	\N	\N	71431	71431	71432
17145	22826	1	applied	\N	\N	\N	\N	71433	71433	71434
17145	22827	2	applied	\N	\N	\N	\N	71435	71435	60022
17147	22828	0	applied	\N	\N	\N	\N	71437	71437	71438
17147	22829	1	applied	\N	\N	\N	\N	71439	71439	71440
17147	22830	2	applied	\N	\N	1000000000	\N	71441	71441	71442
17147	22831	3	applied	\N	\N	\N	\N	71443	71443	71444
17147	22832	4	applied	\N	\N	\N	\N	71445	71445	60028
17147	22833	5	applied	\N	\N	\N	\N	71446	71446	60034
17147	22834	6	applied	\N	\N	\N	\N	71447	71447	60046
17147	22835	7	applied	\N	\N	\N	\N	71448	71448	71449
17148	22836	0	applied	\N	\N	\N	\N	71452	71452	71453
17148	22837	1	applied	\N	\N	\N	\N	71454	71454	71455
17148	22838	2	applied	\N	\N	\N	\N	71456	71456	71457
17148	22839	3	applied	\N	\N	\N	\N	71458	71458	71459
17148	22840	4	applied	\N	\N	\N	\N	71460	71460	60084
17151	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17151	22570	1	applied	\N	\N	1000000000	\N	70725	70725	70726
17151	22521	2	applied	\N	\N	\N	\N	70601	70601	70602
17151	22522	3	applied	\N	\N	\N	\N	70605	70605	70606
17151	22640	4	applied	\N	\N	1000000000	\N	70936	70936	70937
17151	22698	5	applied	\N	\N	\N	\N	71076	71076	71077
17151	22790	6	applied	\N	\N	\N	\N	71353	71353	71354
17151	22806	7	applied	\N	\N	1000000000	\N	71396	71396	71397
17151	22830	8	applied	\N	\N	1000000000	\N	71441	71441	71442
17151	22525	9	applied	\N	\N	\N	\N	70611	70611	70612
17151	22527	10	applied	\N	\N	\N	\N	70617	70617	70618
17151	22528	11	applied	\N	\N	\N	\N	70619	70619	70620
17151	22532	12	applied	\N	\N	\N	\N	70631	70631	70632
17151	22534	13	applied	\N	\N	\N	\N	70636	70636	70637
17151	22536	14	applied	\N	\N	\N	\N	70641	70641	70642
17151	22539	15	applied	\N	\N	\N	\N	70648	70648	70649
17151	22541	16	applied	\N	\N	\N	\N	70654	70654	70655
17151	22542	17	applied	\N	\N	\N	\N	70656	70656	70657
17151	22546	18	applied	\N	\N	\N	\N	70665	70665	70666
17151	22548	19	applied	\N	\N	\N	\N	70674	70674	70675
17151	22550	20	applied	\N	\N	\N	\N	70680	70680	70681
17151	22553	21	applied	\N	\N	\N	\N	70686	70686	70687
17151	22554	22	applied	\N	\N	\N	\N	70688	70688	70689
17151	22557	23	applied	\N	\N	\N	\N	70695	70695	70696
17151	22558	24	applied	\N	\N	\N	\N	70697	70697	70698
17151	22562	25	applied	\N	\N	\N	\N	70705	70705	70706
17151	22564	26	applied	\N	\N	\N	\N	70710	70710	70711
17151	22565	27	applied	\N	\N	\N	\N	70712	70712	70713
17151	22569	28	applied	\N	\N	\N	\N	70723	70723	70724
17151	22573	29	applied	\N	\N	\N	\N	70733	70733	70734
17151	22575	30	applied	\N	\N	\N	\N	70739	70739	70740
17151	22576	31	applied	\N	\N	\N	\N	70741	70741	70742
17151	22582	32	applied	\N	\N	\N	\N	70753	70753	70754
17151	22585	33	applied	\N	\N	\N	\N	70763	70763	70764
17151	22588	34	applied	\N	\N	\N	\N	70772	70772	70773
17151	22589	35	applied	\N	\N	\N	\N	70774	70774	70775
17151	22595	36	applied	\N	\N	\N	\N	70791	70791	70792
17151	22600	37	applied	\N	\N	\N	\N	70831	70831	70832
17151	22603	38	applied	\N	\N	\N	\N	70840	70840	70841
17151	22605	39	applied	\N	\N	\N	\N	70849	70849	70850
17151	22608	40	applied	\N	\N	\N	\N	70856	70856	70857
17151	22612	41	applied	\N	\N	\N	\N	70862	70862	70863
17151	22615	42	applied	\N	\N	\N	\N	70869	70869	70870
17151	22618	43	applied	\N	\N	\N	\N	70876	70876	70877
17151	22621	44	applied	\N	\N	\N	\N	70883	70883	70884
17151	22622	45	applied	\N	\N	\N	\N	70885	70885	70886
17151	22627	46	applied	\N	\N	\N	\N	70897	70897	70898
17151	22631	47	applied	\N	\N	\N	\N	70907	70907	70908
17151	22634	48	applied	\N	\N	\N	\N	70913	70913	70914
17151	22637	49	applied	\N	\N	\N	\N	70921	70921	70922
17151	22641	50	applied	\N	\N	\N	\N	70940	70940	70941
17151	22645	51	applied	\N	\N	\N	\N	70951	70951	70952
17151	22648	52	applied	\N	\N	\N	\N	70958	70958	70959
17151	22649	53	applied	\N	\N	\N	\N	70960	70960	70961
17151	22655	54	applied	\N	\N	\N	\N	70971	70971	70972
17151	22658	55	applied	\N	\N	\N	\N	70976	70976	70977
17151	22661	56	applied	\N	\N	\N	\N	70981	70981	70982
17151	22666	57	applied	\N	\N	\N	\N	70999	70999	71000
17151	22667	58	applied	\N	\N	\N	\N	71001	71001	71002
17151	22668	59	applied	\N	\N	\N	\N	71003	71003	71004
17151	22669	60	applied	\N	\N	\N	\N	71005	71005	71006
17151	22678	61	applied	\N	\N	\N	\N	71023	71023	71024
17151	22681	62	applied	\N	\N	\N	\N	71029	71029	71030
17151	22684	63	applied	\N	\N	\N	\N	71035	71035	71036
17151	22688	64	applied	\N	\N	\N	\N	71049	71049	71050
17151	22690	65	applied	\N	\N	\N	\N	71056	71056	71057
17151	22693	66	applied	\N	\N	\N	\N	71066	71066	71067
17151	22696	67	applied	\N	\N	\N	\N	71072	71072	71073
17151	22697	68	applied	\N	\N	\N	\N	71074	71074	71075
17151	22704	69	applied	\N	\N	\N	\N	71088	71088	71089
17151	22705	70	applied	\N	\N	\N	\N	71090	71090	71091
17151	22706	71	applied	\N	\N	\N	\N	71092	71092	71093
17151	22716	72	applied	\N	\N	\N	\N	71108	71108	71109
17151	22719	73	applied	\N	\N	\N	\N	71117	71117	71118
17151	22723	74	applied	\N	\N	\N	\N	71123	71123	71124
17151	22726	75	applied	\N	\N	\N	\N	71130	71130	71131
17151	22727	76	applied	\N	\N	\N	\N	71132	71132	71133
17151	22732	77	applied	\N	\N	\N	\N	71171	71171	71172
17142	22813	0	applied	\N	\N	\N	\N	71411	71411	71412
17142	22814	1	applied	\N	\N	\N	\N	71413	71413	71414
17142	22815	2	applied	\N	\N	\N	\N	71415	71415	71416
17142	22816	3	applied	\N	\N	\N	\N	71417	71417	59937
17142	22817	4	applied	\N	\N	\N	\N	71418	71418	59946
17142	22818	5	applied	\N	\N	\N	\N	71419	71419	59958
17142	22819	6	applied	\N	\N	\N	\N	71420	71420	59970
17142	22820	7	applied	\N	\N	\N	\N	71421	71421	59974
17142	22821	8	applied	\N	\N	\N	\N	71422	71422	59985
17144	22822	0	applied	\N	\N	\N	\N	71424	71424	71425
17144	22823	1	applied	\N	\N	\N	\N	71426	71426	59991
17144	22824	2	applied	\N	\N	\N	\N	71427	71427	59998
17150	22841	0	applied	\N	\N	\N	\N	71463	71463	71464
17150	22842	1	applied	\N	\N	\N	\N	71465	71465	60100
17150	22843	2	applied	\N	\N	\N	\N	71466	71466	71467
17150	22844	3	applied	\N	\N	\N	\N	71468	71468	60108
17156	22848	0	applied	\N	\N	\N	\N	71482	71482	71483
17156	22849	1	applied	\N	\N	\N	\N	71484	71484	71485
17156	22850	2	applied	\N	\N	\N	\N	71486	71486	71487
17156	22851	3	applied	\N	\N	\N	\N	71488	71488	60139
17156	22852	4	applied	\N	\N	\N	\N	71489	71489	71490
17156	22853	5	applied	\N	\N	\N	\N	71491	71491	60157
17156	22854	6	applied	\N	\N	\N	\N	71492	71492	60159
17156	22855	7	applied	\N	\N	\N	\N	71493	71493	71494
17156	22856	8	applied	\N	\N	\N	\N	71495	71495	71496
17156	22857	9	applied	\N	\N	\N	\N	71497	71497	71498
17157	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17157	22640	1	applied	\N	\N	1000000000	\N	70936	70936	70937
17157	22698	2	applied	\N	\N	\N	\N	71076	71076	71077
17157	22790	3	applied	\N	\N	\N	\N	71353	71353	71354
17157	22806	4	applied	\N	\N	1000000000	\N	71396	71396	71397
17157	22830	5	applied	\N	\N	1000000000	\N	71441	71441	71442
17157	22850	6	applied	\N	\N	\N	\N	71505	71505	71487
17157	22707	7	applied	\N	\N	\N	\N	71094	71094	71486
17157	22767	8	applied	\N	\N	\N	\N	71273	71273	71274
17160	22858	0	applied	\N	\N	\N	\N	71508	71508	71486
17160	22859	1	applied	\N	\N	\N	\N	71509	71509	71510
17160	22860	2	applied	\N	\N	\N	\N	71511	71511	71512
17160	22861	3	applied	\N	\N	\N	\N	71513	71513	60231
17160	22862	4	applied	\N	\N	\N	\N	71514	71514	60240
17160	22863	5	applied	\N	\N	\N	\N	71515	71515	60251
17160	22864	6	applied	\N	\N	\N	\N	71516	71516	60253
17164	22879	0	applied	\N	\N	\N	\N	71549	71549	71550
17164	22880	1	applied	\N	\N	\N	\N	71551	71551	60333
17164	22881	2	applied	\N	\N	\N	\N	71552	71552	60349
17167	22885	0	applied	\N	\N	\N	\N	71560	71560	71561
17167	22886	1	applied	\N	\N	\N	\N	71562	71562	71563
17167	22887	2	applied	\N	\N	\N	\N	71568	71568	71569
17167	22888	3	applied	\N	\N	\N	\N	71570	71570	71571
17167	22889	4	applied	\N	\N	\N	\N	71572	71572	60388
17167	22890	5	applied	\N	\N	\N	\N	71573	71573	71574
17167	22891	6	applied	\N	\N	\N	\N	71575	71575	60416
17167	22892	7	applied	\N	\N	\N	\N	71576	71576	60424
17167	22893	8	applied	\N	\N	\N	\N	71577	71577	60433
17167	22894	9	applied	\N	\N	\N	\N	71578	71578	60444
17175	22908	0	applied	\N	\N	\N	\N	71611	71611	71612
17175	22909	1	applied	\N	\N	\N	\N	71613	71613	60542
17175	22910	2	applied	\N	\N	\N	\N	71614	71614	71615
17175	22911	3	applied	\N	\N	\N	\N	71616	71616	71617
17179	22912	0	applied	\N	\N	\N	\N	71625	71625	71626
17179	22913	1	applied	\N	\N	\N	\N	71627	71627	71628
17179	22914	2	applied	\N	\N	\N	\N	71629	71629	60566
17182	22915	0	applied	\N	\N	\N	\N	71632	71632	71633
17182	22916	1	applied	\N	\N	\N	\N	71634	71634	28166
17182	22917	2	applied	\N	\N	\N	\N	71635	71635	71636
17182	22918	3	applied	\N	\N	\N	\N	71637	71637	71638
17182	22919	4	applied	\N	\N	\N	\N	71639	71639	71640
17182	22920	5	applied	\N	\N	\N	\N	71641	71641	71642
17184	22916	0	applied	\N	\N	\N	\N	71634	71634	28166
17185	22916	0	applied	\N	\N	\N	\N	71634	71634	28166
17188	22921	0	applied	\N	\N	\N	\N	71648	71648	71649
17188	22922	1	applied	\N	\N	\N	\N	71650	71650	71651
17188	22923	2	applied	\N	\N	\N	\N	71652	71652	71653
17188	22924	3	applied	\N	\N	\N	\N	71654	71654	71655
17188	22925	4	applied	\N	\N	\N	\N	71656	71656	60631
17188	22926	5	applied	\N	\N	\N	\N	71657	71657	60643
17188	22927	6	applied	\N	\N	\N	\N	71658	71658	60645
17188	22928	7	applied	\N	\N	\N	\N	71659	71659	60654
17188	22929	8	applied	\N	\N	\N	\N	71660	71660	60663
17190	22930	0	applied	\N	\N	\N	\N	71669	71669	71670
17190	22931	1	applied	\N	\N	\N	\N	71671	71671	60676
17190	22932	2	applied	\N	\N	\N	\N	71672	71672	71673
17190	22933	3	applied	\N	\N	\N	\N	71674	71674	60692
17193	22916	0	applied	\N	\N	\N	\N	71634	71634	28166
17196	22940	0	applied	\N	\N	\N	\N	71691	71691	71692
17196	22942	1	applied	\N	\N	\N	\N	71695	71695	71700
17196	22943	2	applied	\N	\N	\N	\N	71696	71696	71694
17200	22953	0	applied	\N	\N	\N	\N	71719	71719	71720
17200	22954	1	applied	\N	\N	\N	\N	71721	71721	60826
17200	22955	2	applied	\N	\N	\N	\N	71722	71722	60832
17205	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17205	22570	1	applied	\N	\N	1000000000	\N	70725	70725	70726
17205	22640	2	applied	\N	\N	1000000000	\N	70936	70936	70937
17205	22698	3	applied	\N	\N	\N	\N	71076	71076	71077
17205	22790	4	applied	\N	\N	\N	\N	71353	71353	71354
17205	22806	5	applied	\N	\N	1000000000	\N	71396	71396	71397
17205	22830	6	applied	\N	\N	1000000000	\N	71441	71441	71442
17205	22850	7	applied	\N	\N	\N	\N	71505	71505	71487
17205	22707	8	applied	\N	\N	\N	\N	71094	71094	71486
17205	22916	9	applied	\N	\N	\N	\N	71634	71634	28166
17205	22767	10	applied	\N	\N	\N	\N	71736	71736	71274
17206	22956	0	applied	\N	\N	\N	\N	71727	71727	71728
17206	22957	1	applied	\N	\N	\N	\N	71729	71729	71730
17206	22958	2	applied	\N	\N	\N	\N	71731	71731	60860
17209	22959	0	applied	\N	\N	\N	\N	71741	71741	71742
17209	22960	1	applied	\N	\N	\N	\N	71743	71743	60870
17209	22961	2	applied	\N	\N	\N	\N	71745	71745	60872
17213	22969	0	applied	\N	\N	\N	\N	71764	71764	71765
17213	22970	1	applied	\N	\N	\N	\N	71766	71766	60940
17213	22971	2	applied	\N	\N	\N	\N	71767	71767	60961
17218	22972	0	applied	\N	\N	\N	\N	71775	71775	71776
17218	22973	1	applied	\N	\N	\N	\N	71777	71777	71778
17218	22974	2	applied	\N	\N	\N	\N	71779	71779	60963
17218	22975	3	applied	\N	\N	\N	\N	71780	71780	60967
17218	22976	4	applied	\N	\N	\N	\N	71781	71781	60973
17218	22977	5	applied	\N	\N	\N	\N	71782	71782	60983
17218	22978	6	applied	\N	\N	\N	\N	71783	71783	60992
17224	22985	0	applied	\N	\N	\N	\N	71799	71799	71800
17224	22986	1	applied	\N	\N	\N	\N	71801	71801	71802
17151	22735	78	applied	\N	\N	\N	\N	71178	71178	71179
17151	22738	79	applied	\N	\N	\N	\N	71186	71186	71187
17151	22741	80	applied	\N	\N	\N	\N	71193	71193	71194
17151	22744	81	applied	\N	\N	\N	\N	71201	71201	71202
17151	22746	82	applied	\N	\N	\N	\N	71205	71205	71206
17151	22748	83	applied	\N	\N	\N	\N	71211	71211	71212
17151	22749	84	applied	\N	\N	\N	\N	71213	71213	71214
17151	22753	85	applied	\N	\N	\N	\N	71236	71236	71237
17151	22755	86	applied	\N	\N	\N	\N	71243	71243	71244
17151	22757	87	applied	\N	\N	\N	\N	71250	71250	71251
17151	22760	88	applied	\N	\N	\N	\N	71257	71257	71258
17151	22762	89	applied	\N	\N	\N	\N	71262	71262	71263
17151	22764	90	applied	\N	\N	\N	\N	71268	71268	71269
17151	22768	91	applied	\N	\N	\N	\N	71278	71278	71279
17151	22770	92	applied	\N	\N	\N	\N	71284	71284	71285
17151	22772	93	applied	\N	\N	\N	\N	71300	71300	71301
17151	22775	94	applied	\N	\N	\N	\N	71307	71307	71308
17151	22777	95	applied	\N	\N	\N	\N	71313	71313	71314
17151	22779	96	applied	\N	\N	\N	\N	71317	71317	71318
17151	22782	97	applied	\N	\N	\N	\N	71324	71324	71325
17151	22784	98	applied	\N	\N	\N	\N	71330	71330	71331
17151	22786	99	applied	\N	\N	\N	\N	71336	71336	71337
17151	22789	100	applied	\N	\N	\N	\N	71349	71349	71350
17151	22791	102	applied	\N	\N	\N	\N	71355	71355	71356
17151	22793	103	applied	\N	\N	\N	\N	71360	71360	71361
17151	22796	104	applied	\N	\N	\N	\N	71369	71369	71370
17151	22797	105	applied	\N	\N	\N	\N	71371	71371	71372
17151	22800	106	applied	\N	\N	\N	\N	71378	71378	71379
17151	22802	107	applied	\N	\N	\N	\N	71384	71384	71385
17151	22804	108	applied	\N	\N	\N	\N	71390	71390	71391
17151	22807	109	applied	\N	\N	\N	\N	71398	71398	71399
17151	22809	110	applied	\N	\N	\N	\N	71402	71402	71403
17151	22813	111	applied	\N	\N	\N	\N	71411	71411	71412
17151	22814	112	applied	\N	\N	\N	\N	71413	71413	71414
17151	22815	113	applied	\N	\N	\N	\N	71415	71415	71416
17151	22822	114	applied	\N	\N	\N	\N	71424	71424	71425
17151	22825	115	applied	\N	\N	\N	\N	71431	71431	71432
17151	22828	116	applied	\N	\N	\N	\N	71437	71437	71438
17151	22829	117	applied	\N	\N	\N	\N	71439	71439	71440
17151	22836	118	applied	\N	\N	\N	\N	71452	71452	71453
17151	22837	119	applied	\N	\N	\N	\N	71454	71454	71455
17151	22841	120	applied	\N	\N	\N	\N	71463	71463	71464
17151	22707	121	applied	\N	\N	\N	\N	71094	71094	70579
17151	22767	122	applied	\N	\N	\N	\N	71273	71273	71274
17151	22523	123	applied	\N	\N	\N	\N	70607	70607	70608
17151	22529	124	applied	\N	\N	\N	\N	70621	70621	71472
17151	22537	125	applied	\N	\N	\N	\N	70643	70643	59154
17154	22848	0	applied	\N	\N	\N	\N	71482	71482	71483
17154	22849	1	applied	\N	\N	\N	\N	71484	71484	71485
17154	22850	2	applied	\N	\N	\N	\N	71486	71486	71487
17154	22851	3	applied	\N	\N	\N	\N	71488	71488	60139
17154	22852	4	applied	\N	\N	\N	\N	71489	71489	71490
17154	22853	5	applied	\N	\N	\N	\N	71491	71491	60157
17154	22854	6	applied	\N	\N	\N	\N	71492	71492	60159
17154	22855	7	applied	\N	\N	\N	\N	71493	71493	71494
17154	22856	8	applied	\N	\N	\N	\N	71495	71495	71496
17154	22857	9	applied	\N	\N	\N	\N	71497	71497	71498
17158	22858	0	applied	\N	\N	\N	\N	71508	71508	71486
17158	22859	1	applied	\N	\N	\N	\N	71509	71509	71510
17158	22860	2	applied	\N	\N	\N	\N	71511	71511	71512
17158	22861	3	applied	\N	\N	\N	\N	71513	71513	60231
17158	22862	4	applied	\N	\N	\N	\N	71514	71514	60240
17158	22863	5	applied	\N	\N	\N	\N	71515	71515	60251
17158	22864	6	applied	\N	\N	\N	\N	71516	71516	60253
17162	22865	0	applied	\N	\N	\N	\N	71522	71522	71523
17162	22866	1	applied	\N	\N	\N	\N	71524	71524	60265
17162	22867	2	applied	\N	\N	\N	\N	71525	71525	60273
17162	22868	3	applied	\N	\N	\N	\N	71526	71526	71527
17163	22869	0	applied	\N	\N	\N	\N	71530	71530	71531
17163	22870	1	applied	\N	\N	\N	\N	71532	71532	71533
17163	22871	2	applied	\N	\N	\N	\N	71534	71534	71535
17163	22872	3	applied	\N	\N	\N	\N	71536	71536	71537
17163	22873	4	applied	\N	\N	\N	\N	71538	71538	71539
17163	22874	5	applied	\N	\N	\N	\N	71540	71540	71541
17163	22875	6	applied	\N	\N	\N	\N	71542	71542	60302
17163	22876	7	applied	\N	\N	\N	\N	71543	71543	60315
17163	22877	8	applied	\N	\N	\N	\N	71544	71544	60317
17163	22878	9	applied	\N	\N	\N	\N	71545	71545	71546
17166	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17166	22698	1	applied	\N	\N	\N	\N	71076	71076	71077
17166	22790	2	applied	\N	\N	\N	\N	71353	71353	71354
17166	22806	3	applied	\N	\N	1000000000	\N	71396	71396	71397
17166	22830	4	applied	\N	\N	1000000000	\N	71441	71441	71442
17166	22850	5	applied	\N	\N	\N	\N	71505	71505	71487
17166	22666	6	applied	\N	\N	\N	\N	70999	70999	71000
17166	22667	7	applied	\N	\N	\N	\N	71001	71001	71002
17166	22668	8	applied	\N	\N	\N	\N	71003	71003	71004
17166	22669	9	applied	\N	\N	\N	\N	71005	71005	71006
17166	22678	10	applied	\N	\N	\N	\N	71023	71023	71024
17166	22681	11	applied	\N	\N	\N	\N	71029	71029	71030
17166	22684	12	applied	\N	\N	\N	\N	71035	71035	71036
17166	22688	13	applied	\N	\N	\N	\N	71049	71049	71050
17166	22690	14	applied	\N	\N	\N	\N	71056	71056	71057
17166	22693	15	applied	\N	\N	\N	\N	71066	71066	71067
17166	22696	16	applied	\N	\N	\N	\N	71072	71072	71073
17166	22697	17	applied	\N	\N	\N	\N	71074	71074	71075
17166	22704	18	applied	\N	\N	\N	\N	71088	71088	71089
17166	22705	19	applied	\N	\N	\N	\N	71090	71090	71091
17166	22706	20	applied	\N	\N	\N	\N	71092	71092	71093
17166	22716	21	applied	\N	\N	\N	\N	71108	71108	71109
17166	22719	22	applied	\N	\N	\N	\N	71117	71117	71118
17166	22723	23	applied	\N	\N	\N	\N	71123	71123	71124
17166	22726	24	applied	\N	\N	\N	\N	71130	71130	71131
17166	22727	25	applied	\N	\N	\N	\N	71132	71132	71133
17166	22732	26	applied	\N	\N	\N	\N	71171	71171	71172
17166	22735	27	applied	\N	\N	\N	\N	71178	71178	71179
17166	22738	28	applied	\N	\N	\N	\N	71186	71186	71187
17166	22741	29	applied	\N	\N	\N	\N	71193	71193	71194
17166	22744	30	applied	\N	\N	\N	\N	71201	71201	71202
17166	22746	31	applied	\N	\N	\N	\N	71205	71205	71206
17166	22748	32	applied	\N	\N	\N	\N	71211	71211	71212
17166	22749	33	applied	\N	\N	\N	\N	71213	71213	71214
17166	22753	34	applied	\N	\N	\N	\N	71236	71236	71237
17166	22755	35	applied	\N	\N	\N	\N	71243	71243	71244
17166	22757	36	applied	\N	\N	\N	\N	71250	71250	71251
17166	22760	37	applied	\N	\N	\N	\N	71257	71257	71258
17166	22762	38	applied	\N	\N	\N	\N	71262	71262	71263
17166	22764	39	applied	\N	\N	\N	\N	71268	71268	71269
17166	22768	40	applied	\N	\N	\N	\N	71278	71278	71279
17152	22845	0	applied	\N	\N	\N	\N	71475	71475	71476
17152	22846	1	applied	\N	\N	\N	\N	71477	71477	60127
17152	22847	2	applied	\N	\N	\N	\N	71478	71478	71479
17153	22848	0	applied	\N	\N	\N	\N	71482	71482	71483
17153	22849	1	applied	\N	\N	\N	\N	71484	71484	71485
17153	22850	2	applied	\N	\N	\N	\N	71486	71486	71487
17153	22851	3	applied	\N	\N	\N	\N	71488	71488	60139
17153	22852	4	applied	\N	\N	\N	\N	71489	71489	71490
17153	22853	5	applied	\N	\N	\N	\N	71491	71491	60157
17153	22854	6	applied	\N	\N	\N	\N	71492	71492	60159
17153	22855	7	applied	\N	\N	\N	\N	71493	71493	71494
17153	22856	8	applied	\N	\N	\N	\N	71495	71495	71496
17153	22857	9	applied	\N	\N	\N	\N	71497	71497	71498
17161	22858	0	applied	\N	\N	\N	\N	71508	71508	71486
17161	22859	1	applied	\N	\N	\N	\N	71509	71509	71510
17161	22860	2	applied	\N	\N	\N	\N	71511	71511	71512
17161	22861	3	applied	\N	\N	\N	\N	71513	71513	60231
17161	22862	4	applied	\N	\N	\N	\N	71514	71514	60240
17161	22863	5	applied	\N	\N	\N	\N	71515	71515	60251
17161	22864	6	applied	\N	\N	\N	\N	71516	71516	60253
17165	22882	0	applied	\N	\N	\N	\N	71553	71553	71554
17165	22883	1	applied	\N	\N	\N	\N	71555	71555	60351
17165	22884	2	applied	\N	\N	\N	\N	71556	71556	71557
17168	22885	0	applied	\N	\N	\N	\N	71560	71560	71561
17168	22886	1	applied	\N	\N	\N	\N	71562	71562	71563
17168	22887	2	applied	\N	\N	\N	\N	71568	71568	71569
17168	22888	3	applied	\N	\N	\N	\N	71570	71570	71571
17168	22889	4	applied	\N	\N	\N	\N	71572	71572	60388
17168	22890	5	applied	\N	\N	\N	\N	71573	71573	71574
17168	22891	6	applied	\N	\N	\N	\N	71575	71575	60416
17168	22892	7	applied	\N	\N	\N	\N	71576	71576	60424
17168	22893	8	applied	\N	\N	\N	\N	71577	71577	60433
17168	22894	9	applied	\N	\N	\N	\N	71578	71578	60444
17170	22895	0	applied	\N	\N	\N	\N	71584	71584	71585
17170	22896	1	applied	\N	\N	\N	\N	71586	71586	71587
17170	22897	2	applied	\N	\N	\N	\N	71588	71588	71589
17170	22898	3	applied	\N	\N	\N	\N	71590	71590	71591
17170	22899	4	applied	\N	\N	\N	\N	71592	71592	60468
17170	22900	5	applied	\N	\N	\N	\N	71593	71593	71594
17170	22901	6	applied	\N	\N	\N	\N	71595	71595	71596
17176	22908	0	applied	\N	\N	\N	\N	71611	71611	71612
17176	22909	1	applied	\N	\N	\N	\N	71613	71613	60542
17176	22910	2	applied	\N	\N	\N	\N	71614	71614	71615
17176	22911	3	applied	\N	\N	\N	\N	71616	71616	71617
17189	22921	0	applied	\N	\N	\N	\N	71648	71648	71649
17189	22922	1	applied	\N	\N	\N	\N	71650	71650	71651
17189	22923	2	applied	\N	\N	\N	\N	71652	71652	71653
17189	22924	3	applied	\N	\N	\N	\N	71654	71654	71655
17189	22925	4	applied	\N	\N	\N	\N	71656	71656	60631
17189	22926	5	applied	\N	\N	\N	\N	71657	71657	60643
17189	22927	6	applied	\N	\N	\N	\N	71658	71658	60645
17189	22928	7	applied	\N	\N	\N	\N	71659	71659	60654
17189	22929	8	applied	\N	\N	\N	\N	71660	71660	60663
17191	22934	0	applied	\N	\N	\N	\N	71676	71676	71677
17191	22935	1	applied	\N	\N	\N	\N	71678	71678	71679
17191	22936	2	applied	\N	\N	\N	\N	71680	71680	71681
17197	22940	0	applied	\N	\N	\N	\N	71691	71691	71692
17197	22941	1	applied	\N	\N	\N	\N	71693	71693	71694
17197	22942	2	applied	\N	\N	\N	\N	71695	71695	60750
17197	22943	3	applied	\N	\N	\N	\N	71696	71696	60763
17201	22953	0	applied	\N	\N	\N	\N	71719	71719	71720
17201	22954	1	applied	\N	\N	\N	\N	71721	71721	60826
17201	22955	2	applied	\N	\N	\N	\N	71722	71722	60832
17207	22959	0	applied	\N	\N	\N	\N	71741	71741	71742
17207	22960	1	applied	\N	\N	\N	\N	71743	71743	60870
17211	22962	0	applied	\N	\N	\N	\N	71749	71749	71750
17211	22963	1	applied	\N	\N	\N	\N	71751	71751	71752
17211	22964	2	applied	\N	\N	\N	\N	71753	71753	60896
17211	22965	3	applied	\N	\N	\N	\N	71754	71754	71755
17214	22969	0	applied	\N	\N	\N	\N	71764	71764	71765
17214	22970	1	applied	\N	\N	\N	\N	71766	71766	60940
17214	22971	2	applied	\N	\N	\N	\N	71767	71767	60961
17219	22972	0	applied	\N	\N	\N	\N	71775	71775	71776
17219	22973	1	applied	\N	\N	\N	\N	71777	71777	71778
17219	22974	2	applied	\N	\N	\N	\N	71779	71779	60963
17219	22975	3	applied	\N	\N	\N	\N	71780	71780	60967
17219	22976	4	applied	\N	\N	\N	\N	71781	71781	60973
17219	22977	5	applied	\N	\N	\N	\N	71782	71782	60983
17219	22978	6	applied	\N	\N	\N	\N	71783	71783	60992
17226	22991	0	applied	\N	\N	\N	\N	71814	71814	71815
17226	22992	1	applied	\N	\N	\N	\N	71816	71816	61077
17226	22993	2	applied	\N	\N	\N	\N	71817	71817	71818
17229	22998	0	applied	\N	\N	\N	\N	71830	71830	71831
17229	22999	1	applied	\N	\N	\N	\N	71832	71832	71833
17229	23000	2	applied	\N	\N	\N	\N	71834	71834	61107
17229	23001	3	applied	\N	\N	\N	\N	71835	71835	61122
17229	23002	4	applied	\N	\N	\N	\N	71836	71836	71837
17229	23003	5	applied	\N	\N	\N	\N	71838	71838	71839
17241	23023	0	applied	\N	\N	\N	\N	71881	71881	71882
17241	23024	1	applied	\N	\N	\N	\N	71883	71883	71884
17241	23025	2	applied	\N	\N	\N	\N	71885	71885	71886
17241	23026	3	applied	\N	\N	\N	\N	71887	71887	61258
17241	23027	4	applied	\N	\N	\N	\N	71888	71888	71889
17241	23028	5	applied	\N	\N	\N	\N	71890	71890	61264
17241	23029	6	applied	\N	\N	\N	\N	71891	71891	61275
17243	23030	0	applied	\N	\N	\N	\N	71898	71898	71899
17243	23031	1	applied	\N	\N	\N	\N	71900	71900	61285
17243	23032	2	applied	\N	\N	\N	\N	71901	71901	71902
17249	23035	0	applied	\N	\N	\N	\N	71932	71932	71933
17249	23036	1	applied	\N	\N	\N	\N	71934	71934	71935
17249	23037	2	applied	\N	\N	\N	\N	71936	71936	61323
17249	23038	3	applied	\N	\N	\N	\N	71937	71937	71938
17249	23039	4	applied	\N	\N	\N	\N	71939	71939	61345
17249	23040	5	applied	\N	\N	\N	\N	71940	71940	61349
17252	23044	0	applied	\N	\N	\N	\N	71948	71948	71949
17252	23045	1	applied	\N	\N	\N	\N	71950	71950	71951
17252	23046	2	applied	\N	\N	\N	\N	71952	71952	61380
17252	23047	3	applied	\N	\N	\N	\N	71953	71953	61389
17252	23048	4	applied	\N	\N	\N	\N	71954	71954	61407
17252	23049	5	applied	\N	\N	\N	\N	71955	71955	71956
17266	23068	0	applied	\N	\N	\N	\N	72001	72001	72002
17266	23069	1	applied	\N	\N	\N	\N	72003	72003	61522
17266	23070	2	applied	\N	\N	\N	\N	72004	72004	61531
17268	23072	0	applied	\N	\N	\N	\N	72010	72010	72011
17268	23073	1	applied	\N	\N	\N	\N	72012	72012	72013
17268	23074	2	applied	\N	\N	\N	\N	72014	72014	61550
17268	23075	3	applied	\N	\N	\N	\N	72015	72015	61558
17278	23087	0	applied	\N	\N	\N	\N	72042	72042	72043
17278	23088	1	applied	\N	\N	\N	\N	72044	72044	72045
17278	23089	3	applied	\N	\N	\N	\N	72047	72047	72048
17166	22770	41	applied	\N	\N	\N	\N	71284	71284	71285
17166	22772	42	applied	\N	\N	\N	\N	71300	71300	71301
17166	22775	43	applied	\N	\N	\N	\N	71307	71307	71308
17166	22777	44	applied	\N	\N	\N	\N	71313	71313	71314
17166	22779	45	applied	\N	\N	\N	\N	71317	71317	71318
17166	22782	46	applied	\N	\N	\N	\N	71324	71324	71325
17166	22784	47	applied	\N	\N	\N	\N	71330	71330	71331
17166	22786	48	applied	\N	\N	\N	\N	71336	71336	71337
17166	22789	49	applied	\N	\N	\N	\N	71349	71349	71350
17166	22791	50	applied	\N	\N	\N	\N	71355	71355	71356
17166	22793	51	applied	\N	\N	\N	\N	71360	71360	71361
17166	22796	52	applied	\N	\N	\N	\N	71369	71369	71370
17166	22797	53	applied	\N	\N	\N	\N	71371	71371	71372
17166	22800	54	applied	\N	\N	\N	\N	71378	71378	71379
17166	22802	55	applied	\N	\N	\N	\N	71384	71384	71385
17166	22804	56	applied	\N	\N	\N	\N	71390	71390	71391
17166	22807	57	applied	\N	\N	\N	\N	71398	71398	71399
17166	22809	58	applied	\N	\N	\N	\N	71402	71402	71403
17166	22813	59	applied	\N	\N	\N	\N	71411	71411	71412
17166	22814	60	applied	\N	\N	\N	\N	71413	71413	71414
17166	22815	61	applied	\N	\N	\N	\N	71415	71415	71416
17166	22822	62	applied	\N	\N	\N	\N	71424	71424	71425
17166	22825	63	applied	\N	\N	\N	\N	71431	71431	71432
17166	22828	64	applied	\N	\N	\N	\N	71437	71437	71438
17166	22829	65	applied	\N	\N	\N	\N	71439	71439	71440
17166	22836	66	applied	\N	\N	\N	\N	71452	71452	71453
17166	22837	67	applied	\N	\N	\N	\N	71454	71454	71455
17166	22841	68	applied	\N	\N	\N	\N	71463	71463	71464
17166	22845	69	applied	\N	\N	\N	\N	71475	71475	71476
17166	22848	70	applied	\N	\N	\N	\N	71482	71482	71483
17166	22849	71	applied	\N	\N	\N	\N	71484	71484	71485
17166	22859	72	applied	\N	\N	\N	\N	71509	71509	71510
17166	22860	73	applied	\N	\N	\N	\N	71511	71511	71512
17166	22865	74	applied	\N	\N	\N	\N	71522	71522	71523
17166	22869	75	applied	\N	\N	\N	\N	71530	71530	71531
17166	22870	76	applied	\N	\N	\N	\N	71532	71532	71533
17166	22871	77	applied	\N	\N	\N	\N	71534	71534	71535
17166	22879	78	applied	\N	\N	\N	\N	71549	71549	71550
17166	22882	79	applied	\N	\N	\N	\N	71553	71553	71554
17166	22885	80	applied	\N	\N	\N	\N	71560	71560	71561
17166	22886	81	applied	\N	\N	\N	\N	71562	71562	71563
17166	22707	82	applied	\N	\N	\N	\N	71094	71094	71486
17166	22665	83	applied	\N	\N	\N	\N	70994	70994	70995
17166	22670	84	applied	\N	\N	\N	\N	71007	71007	59561
17166	22767	85	applied	\N	\N	\N	\N	71273	71273	71274
17166	22671	86	applied	\N	\N	\N	\N	71008	71008	59563
17166	22672	87	applied	\N	\N	\N	\N	71009	71009	71010
17166	22673	88	applied	\N	\N	\N	\N	71011	71011	71012
17166	22680	89	applied	\N	\N	\N	\N	71027	71027	59575
17166	22682	90	applied	\N	\N	\N	\N	71031	71031	71162
17166	22685	91	applied	\N	\N	\N	\N	71037	71037	71016
17166	22692	92	applied	\N	\N	\N	\N	71060	71060	59581
17166	22694	93	applied	\N	\N	\N	\N	71068	71068	71163
17166	22699	94	applied	\N	\N	\N	\N	71078	71078	71020
17166	22702	95	applied	\N	\N	\N	\N	71082	71082	59587
17166	22708	96	applied	\N	\N	\N	\N	71095	71095	71164
17166	22710	97	applied	\N	\N	\N	\N	71098	71098	71165
17166	22711	98	applied	\N	\N	\N	\N	71100	71100	59593
17166	22717	99	applied	\N	\N	\N	\N	71110	71110	71033
17166	22720	100	applied	\N	\N	\N	\N	71119	71119	71038
17166	22725	101	applied	\N	\N	\N	\N	71127	71127	59612
17166	22729	102	applied	\N	\N	\N	\N	71135	71135	71042
17166	22730	103	applied	\N	\N	\N	\N	71136	71136	71564
17166	22736	104	applied	\N	\N	\N	\N	71180	71180	59618
17166	22740	105	applied	\N	\N	\N	\N	71190	71190	71059
17166	22674	106	applied	\N	\N	\N	\N	71013	71013	59622
17166	22675	107	applied	\N	\N	\N	\N	71015	71015	71166
17166	22676	108	applied	\N	\N	\N	\N	71017	71017	59631
17166	22677	109	applied	\N	\N	\N	\N	71019	71019	71080
17166	22679	110	applied	\N	\N	\N	\N	71025	71025	59640
17166	22683	111	applied	\N	\N	\N	\N	71032	71032	71085
17166	22686	112	applied	\N	\N	\N	\N	71039	71039	59652
17166	22689	113	applied	\N	\N	\N	\N	71051	71051	71167
17166	22691	114	applied	\N	\N	\N	\N	71058	71058	59665
17166	22695	115	applied	\N	\N	\N	\N	71069	71069	71168
17166	22700	116	applied	\N	\N	\N	\N	71079	71079	59671
17166	22701	117	applied	\N	\N	\N	\N	71081	71081	71111
17166	22712	118	applied	\N	\N	\N	\N	71101	71101	59685
17166	22713	119	applied	\N	\N	\N	\N	71102	71102	59697
17166	22714	120	applied	\N	\N	\N	\N	71103	71103	59708
17166	22718	121	applied	\N	\N	\N	\N	71112	71112	71126
17166	22743	122	applied	\N	\N	\N	\N	71197	71197	59712
17166	22722	123	applied	\N	\N	\N	\N	71122	71122	59723
17166	22724	124	applied	\N	\N	\N	\N	71125	71125	59734
17166	22728	125	applied	\N	\N	\N	\N	71134	71134	71565
17171	22902	0	applied	\N	\N	\N	\N	71598	71598	71599
17171	22903	1	applied	\N	\N	\N	\N	71600	71600	71601
17171	22904	2	applied	\N	\N	\N	\N	71602	71602	60506
17173	22905	0	applied	\N	\N	\N	\N	71605	71605	71606
17173	22906	1	applied	\N	\N	\N	\N	71607	71607	71608
17173	22907	2	applied	\N	\N	\N	\N	71609	71609	71610
17177	22908	0	applied	\N	\N	\N	\N	71611	71611	71612
17177	22909	1	applied	\N	\N	\N	\N	71613	71613	60542
17177	22910	2	applied	\N	\N	\N	\N	71614	71614	71615
17177	22911	3	applied	\N	\N	\N	\N	71616	71616	71617
17180	22915	0	applied	\N	\N	\N	\N	71632	71632	71633
17180	22916	1	applied	\N	\N	\N	\N	71634	71634	28166
17180	22917	2	applied	\N	\N	\N	\N	71635	71635	71636
17180	22918	3	applied	\N	\N	\N	\N	71637	71637	71638
17180	22919	4	applied	\N	\N	\N	\N	71639	71639	71640
17180	22920	5	applied	\N	\N	\N	\N	71641	71641	71642
17183	22916	0	applied	\N	\N	\N	\N	71634	71634	28166
17194	22940	0	applied	\N	\N	\N	\N	71691	71691	71692
17194	22941	1	applied	\N	\N	\N	\N	71693	71693	71694
17194	22942	2	applied	\N	\N	\N	\N	71695	71695	60750
17194	22943	3	applied	\N	\N	\N	\N	71696	71696	60763
17198	22944	0	applied	\N	\N	\N	\N	71702	71702	71703
17198	22945	1	applied	\N	\N	\N	\N	71704	71704	60769
17198	22946	2	applied	\N	\N	\N	\N	71705	71705	71706
17202	22953	0	applied	\N	\N	\N	\N	71719	71719	71720
17202	22954	1	applied	\N	\N	\N	\N	71721	71721	60826
17202	22955	2	applied	\N	\N	\N	\N	71722	71722	60832
17203	22956	0	applied	\N	\N	\N	\N	71727	71727	71728
17203	22957	1	applied	\N	\N	\N	\N	71729	71729	71730
17203	22958	2	applied	\N	\N	\N	\N	71731	71731	60860
17208	22959	0	applied	\N	\N	\N	\N	71741	71741	71742
17208	22960	1	applied	\N	\N	\N	\N	71743	71743	60870
17208	22961	2	applied	\N	\N	\N	\N	71745	71745	60872
17210	22959	0	applied	\N	\N	\N	\N	71741	71741	71742
17210	22960	1	applied	\N	\N	\N	\N	71743	71743	60870
17210	22961	2	applied	\N	\N	\N	\N	71745	71745	60872
17212	22966	0	applied	\N	\N	\N	\N	71758	71758	71759
17212	22967	1	applied	\N	\N	\N	\N	71760	71760	60923
17212	22968	2	applied	\N	\N	\N	\N	71761	71761	60932
17215	22969	0	applied	\N	\N	\N	\N	71764	71764	71765
17215	22970	1	applied	\N	\N	\N	\N	71766	71766	60940
17215	22971	2	applied	\N	\N	\N	\N	71767	71767	60961
17222	22985	0	applied	\N	\N	\N	\N	71799	71799	71800
17222	22986	1	applied	\N	\N	\N	\N	71801	71801	71802
17222	22987	2	applied	\N	\N	\N	\N	71803	71803	71804
17232	23004	0	applied	\N	\N	\N	\N	71844	71844	71845
17232	23005	1	applied	\N	\N	\N	\N	71846	71846	71847
17232	23006	3	applied	\N	\N	\N	\N	71849	71849	61151
17232	23007	4	applied	\N	\N	\N	\N	71850	71850	61161
17232	23008	5	applied	\N	\N	\N	\N	71851	71851	61165
17232	23009	6	applied	\N	\N	\N	\N	71852	71852	61167
17232	23010	7	applied	\N	\N	\N	\N	71853	71853	61175
17234	23011	0	applied	\N	\N	\N	\N	71858	71858	71859
17234	23012	1	applied	\N	\N	\N	\N	71860	71860	71861
17234	23013	2	applied	\N	\N	\N	\N	71862	71862	61188
17234	23014	3	applied	\N	\N	\N	\N	71863	71863	61192
17234	23015	4	applied	\N	\N	\N	\N	71864	71864	61198
17234	23016	5	applied	\N	\N	\N	\N	71865	71865	71866
17234	23017	6	applied	\N	\N	\N	\N	71867	71867	61210
17242	23023	0	applied	\N	\N	\N	\N	71881	71881	71882
17242	23024	1	applied	\N	\N	\N	\N	71883	71883	71884
17242	23025	2	applied	\N	\N	\N	\N	71885	71885	71886
17242	23026	3	applied	\N	\N	\N	\N	71887	71887	61258
17242	23027	4	applied	\N	\N	\N	\N	71888	71888	71889
17242	23028	5	applied	\N	\N	\N	\N	71890	71890	61264
17242	23029	6	applied	\N	\N	\N	\N	71891	71891	61275
17244	23030	0	applied	\N	\N	\N	\N	71898	71898	71899
17244	23031	1	applied	\N	\N	\N	\N	71900	71900	61285
17244	23032	2	applied	\N	\N	\N	\N	71901	71901	71902
17248	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17248	22595	1	applied	\N	\N	\N	\N	70791	70791	70792
17248	22600	2	applied	\N	\N	\N	\N	70831	70831	70832
17248	22603	3	applied	\N	\N	\N	\N	70840	70840	70841
17248	22640	4	applied	\N	\N	1000000000	\N	70936	70936	70937
17248	22605	5	applied	\N	\N	\N	\N	70849	70849	70850
17248	22608	6	applied	\N	\N	\N	\N	70856	70856	70857
17248	22612	7	applied	\N	\N	\N	\N	70862	70862	70863
17248	22615	8	applied	\N	\N	\N	\N	70869	70869	70870
17248	22618	9	applied	\N	\N	\N	\N	70876	70876	70877
17248	22621	10	applied	\N	\N	\N	\N	70883	70883	70884
17248	22622	11	applied	\N	\N	\N	\N	70885	70885	70886
17248	22627	12	applied	\N	\N	\N	\N	70897	70897	70898
17248	22631	13	applied	\N	\N	\N	\N	70907	70907	70908
17248	22634	14	applied	\N	\N	\N	\N	70913	70913	70914
17248	22698	15	applied	\N	\N	\N	\N	71076	71076	71077
17248	22790	16	applied	\N	\N	\N	\N	71353	71353	71354
17248	22806	17	applied	\N	\N	1000000000	\N	71396	71396	71397
17248	22830	18	applied	\N	\N	1000000000	\N	71441	71441	71442
17248	22850	19	applied	\N	\N	\N	\N	71505	71505	71487
17248	22637	20	applied	\N	\N	\N	\N	70921	70921	70922
17248	22641	21	applied	\N	\N	\N	\N	70940	70940	70941
17248	22645	22	applied	\N	\N	\N	\N	70951	70951	70952
17248	22648	23	applied	\N	\N	\N	\N	70958	70958	70959
17248	22649	24	applied	\N	\N	\N	\N	70960	70960	70961
17248	22655	25	applied	\N	\N	\N	\N	70971	70971	70972
17248	22658	26	applied	\N	\N	\N	\N	70976	70976	70977
17248	22661	27	applied	\N	\N	\N	\N	70981	70981	70982
17248	22666	28	applied	\N	\N	\N	\N	70999	70999	71000
17248	22667	29	applied	\N	\N	\N	\N	71001	71001	71002
17248	22668	30	applied	\N	\N	\N	\N	71003	71003	71004
17248	22669	31	applied	\N	\N	\N	\N	71005	71005	71006
17248	22678	32	applied	\N	\N	\N	\N	71023	71023	71024
17248	22681	33	applied	\N	\N	\N	\N	71029	71029	71030
17248	22684	34	applied	\N	\N	\N	\N	71035	71035	71036
17248	22688	35	applied	\N	\N	\N	\N	71049	71049	71050
17248	22690	36	applied	\N	\N	\N	\N	71056	71056	71057
17248	22693	37	applied	\N	\N	\N	\N	71066	71066	71067
17248	22696	38	applied	\N	\N	\N	\N	71072	71072	71073
17248	22697	39	applied	\N	\N	\N	\N	71074	71074	71075
17248	22704	40	applied	\N	\N	\N	\N	71088	71088	71089
17248	22705	41	applied	\N	\N	\N	\N	71090	71090	71091
17248	22706	42	applied	\N	\N	\N	\N	71092	71092	71093
17248	22716	43	applied	\N	\N	\N	\N	71108	71108	71109
17248	22719	44	applied	\N	\N	\N	\N	71117	71117	71118
17248	22723	45	applied	\N	\N	\N	\N	71123	71123	71124
17248	22726	46	applied	\N	\N	\N	\N	71130	71130	71131
17248	22727	47	applied	\N	\N	\N	\N	71132	71132	71133
17248	22732	48	applied	\N	\N	\N	\N	71171	71171	71172
17248	22735	49	applied	\N	\N	\N	\N	71178	71178	71179
17248	22738	50	applied	\N	\N	\N	\N	71186	71186	71187
17248	22741	51	applied	\N	\N	\N	\N	71193	71193	71194
17248	22744	52	applied	\N	\N	\N	\N	71201	71201	71202
17248	22746	53	applied	\N	\N	\N	\N	71205	71205	71206
17248	22748	54	applied	\N	\N	\N	\N	71211	71211	71212
17248	22749	55	applied	\N	\N	\N	\N	71213	71213	71214
17248	22753	56	applied	\N	\N	\N	\N	71236	71236	71237
17248	22755	57	applied	\N	\N	\N	\N	71243	71243	71244
17248	22757	58	applied	\N	\N	\N	\N	71250	71250	71251
17248	22760	59	applied	\N	\N	\N	\N	71257	71257	71258
17248	22762	60	applied	\N	\N	\N	\N	71262	71262	71263
17248	22764	61	applied	\N	\N	\N	\N	71268	71268	71269
17248	22768	62	applied	\N	\N	\N	\N	71278	71278	71279
17248	22770	63	applied	\N	\N	\N	\N	71284	71284	71285
17248	22772	64	applied	\N	\N	\N	\N	71300	71300	71301
17248	22775	65	applied	\N	\N	\N	\N	71307	71307	71308
17248	22777	66	applied	\N	\N	\N	\N	71313	71313	71314
17248	22779	67	applied	\N	\N	\N	\N	71317	71317	71318
17248	22782	68	applied	\N	\N	\N	\N	71324	71324	71325
17248	22784	69	applied	\N	\N	\N	\N	71330	71330	71331
17248	22786	70	applied	\N	\N	\N	\N	71336	71336	71337
17248	22789	71	applied	\N	\N	\N	\N	71349	71349	71350
17248	22791	72	applied	\N	\N	\N	\N	71355	71355	71356
17248	22793	73	applied	\N	\N	\N	\N	71360	71360	71361
17248	22796	74	applied	\N	\N	\N	\N	71369	71369	71370
17248	22797	75	applied	\N	\N	\N	\N	71371	71371	71372
17248	22800	76	applied	\N	\N	\N	\N	71378	71378	71379
17248	22802	77	applied	\N	\N	\N	\N	71384	71384	71385
17248	22804	78	applied	\N	\N	\N	\N	71390	71390	71391
17248	22807	79	applied	\N	\N	\N	\N	71398	71398	71399
17248	22809	80	applied	\N	\N	\N	\N	71402	71402	71403
17248	22813	81	applied	\N	\N	\N	\N	71411	71411	71412
17248	22814	82	applied	\N	\N	\N	\N	71413	71413	71414
17248	22815	83	applied	\N	\N	\N	\N	71415	71415	71416
17248	22822	84	applied	\N	\N	\N	\N	71424	71424	71425
17220	22979	0	applied	\N	\N	\N	\N	71789	71789	71790
17220	22980	1	applied	\N	\N	\N	\N	71791	71791	71792
17220	22981	2	applied	\N	\N	\N	\N	71793	71793	60999
17220	22982	3	applied	\N	\N	\N	\N	71794	71794	61007
17220	22983	4	applied	\N	\N	\N	\N	71795	71795	61015
17220	22984	5	applied	\N	\N	\N	\N	71796	71796	61023
17223	22985	0	applied	\N	\N	\N	\N	71799	71799	71800
17223	22986	1	applied	\N	\N	\N	\N	71801	71801	71802
17223	22987	2	applied	\N	\N	\N	\N	71803	71803	71804
17227	22994	0	applied	\N	\N	\N	\N	71821	71821	71822
17227	22995	1	applied	\N	\N	\N	\N	71823	71823	61089
17227	22996	2	applied	\N	\N	\N	\N	71824	71824	71825
17227	22997	3	applied	\N	\N	\N	\N	71826	71826	71827
17230	23004	0	applied	\N	\N	\N	\N	71844	71844	71845
17230	23005	1	applied	\N	\N	\N	\N	71846	71846	71847
17230	23006	3	applied	\N	\N	\N	\N	71849	71849	61151
17230	23007	4	applied	\N	\N	\N	\N	71850	71850	61161
17230	23008	5	applied	\N	\N	\N	\N	71851	71851	61165
17230	23009	6	applied	\N	\N	\N	\N	71852	71852	61167
17230	23010	7	applied	\N	\N	\N	\N	71853	71853	61175
17233	23004	0	applied	\N	\N	\N	\N	71844	71844	71845
17233	23005	1	applied	\N	\N	\N	\N	71846	71846	71847
17233	23006	3	applied	\N	\N	\N	\N	71849	71849	61151
17233	23007	4	applied	\N	\N	\N	\N	71850	71850	61161
17233	23008	5	applied	\N	\N	\N	\N	71851	71851	61165
17233	23009	6	applied	\N	\N	\N	\N	71852	71852	61167
17233	23010	7	applied	\N	\N	\N	\N	71853	71853	61175
17235	23018	0	applied	\N	\N	\N	\N	71870	71870	71871
17235	23019	1	applied	\N	\N	\N	\N	71872	71872	61220
17235	23020	2	applied	\N	\N	\N	\N	71873	71873	61222
17237	23021	0	applied	\N	\N	\N	\N	71877	71877	71878
17237	23022	1	applied	\N	\N	\N	\N	71879	71879	61238
17245	23030	0	applied	\N	\N	\N	\N	71898	71898	71899
17245	23031	1	applied	\N	\N	\N	\N	71900	71900	61285
17245	23032	2	applied	\N	\N	\N	\N	71901	71901	71902
17246	23033	0	applied	\N	\N	\N	\N	71905	71905	71906
17246	23034	1	applied	\N	\N	\N	\N	71907	71907	61313
17251	23041	0	applied	\N	\N	\N	\N	71942	71942	71943
17251	23042	1	applied	\N	\N	\N	\N	71944	71944	61357
17251	23043	2	applied	\N	\N	\N	\N	71945	71945	61369
17254	23044	0	applied	\N	\N	\N	\N	71948	71948	71949
17254	23045	1	applied	\N	\N	\N	\N	71950	71950	71951
17254	23046	2	applied	\N	\N	\N	\N	71952	71952	61380
17254	23047	3	applied	\N	\N	\N	\N	71953	71953	61389
17254	23048	4	applied	\N	\N	\N	\N	71954	71954	61407
17254	23049	5	applied	\N	\N	\N	\N	71955	71955	71956
17255	23050	0	applied	\N	\N	\N	\N	71961	71961	71962
17255	23051	1	applied	\N	\N	\N	\N	71963	71963	61413
17255	23052	2	applied	\N	\N	\N	\N	71964	71964	61417
17257	23052	0	applied	\N	\N	\N	\N	71964	71964	61415
17260	23056	0	applied	\N	\N	\N	\N	71978	71978	71979
17260	23057	1	applied	\N	\N	\N	\N	71980	71980	71981
17260	23054	2	applied	\N	\N	\N	\N	71971	71971	71973
17260	23058	3	applied	\N	\N	\N	\N	71982	71982	61442
17260	23059	4	applied	\N	\N	\N	\N	71983	71983	61449
17260	23060	5	applied	\N	\N	\N	\N	71984	71984	71985
17260	23061	6	applied	\N	\N	\N	\N	71986	71986	71987
17262	23062	0	applied	\N	\N	\N	\N	71991	71991	71992
17262	23063	1	applied	\N	\N	\N	\N	71993	71993	61477
17262	23064	2	applied	\N	\N	\N	\N	71994	71994	61498
17267	23071	0	applied	\N	\N	\N	\N	72007	72007	61538
17275	23081	0	applied	\N	\N	\N	\N	72028	72028	72029
17275	23082	1	applied	\N	\N	\N	\N	72030	72030	61590
17275	23083	2	applied	\N	\N	\N	\N	72031	72031	61602
17280	23087	0	applied	\N	\N	\N	\N	72042	72042	72043
17280	23088	1	applied	\N	\N	\N	\N	72044	72044	72045
17280	23089	3	applied	\N	\N	\N	\N	72047	72047	72048
17281	23087	0	applied	\N	\N	\N	\N	72042	72042	72043
17281	23088	1	applied	\N	\N	\N	\N	72044	72044	72045
17281	23089	3	applied	\N	\N	\N	\N	72047	72047	72048
17283	23090	0	applied	\N	\N	\N	\N	72060	72060	72061
17283	23091	1	applied	\N	\N	\N	\N	72062	72062	61636
17283	23092	2	applied	\N	\N	\N	\N	72063	72063	61643
17289	23114	0	applied	\N	\N	\N	\N	72106	72106	72107
17289	23115	1	applied	\N	\N	\N	\N	72108	72108	61775
17289	23116	2	applied	\N	\N	\N	\N	72109	72109	61789
17301	22715	0	applied	\N	\N	\N	\N	71106	71106	71107
17301	22698	1	applied	\N	\N	\N	\N	71076	71076	71077
17301	22790	2	applied	\N	\N	\N	\N	71353	71353	71354
17301	22806	3	applied	\N	\N	1000000000	\N	71396	71396	71397
17301	22830	4	applied	\N	\N	1000000000	\N	71441	71441	71442
17301	22850	5	applied	\N	\N	\N	\N	71505	71505	71487
17301	22707	6	applied	\N	\N	\N	\N	71094	71094	71486
17301	22916	7	applied	\N	\N	\N	\N	71634	71634	28166
17301	22767	8	applied	\N	\N	\N	\N	72186	72186	71274
17305	23159	0	applied	\N	\N	\N	\N	72200	72200	72201
17305	23160	1	applied	\N	\N	\N	\N	72202	72202	72203
17305	23161	2	applied	\N	\N	\N	\N	72204	72204	62060
17305	23162	3	applied	\N	\N	\N	\N	72205	72205	72206
17305	23163	4	applied	\N	\N	\N	\N	72207	72207	62083
17305	23164	5	applied	\N	\N	\N	\N	72208	72208	62087
17317	23181	0	applied	\N	\N	\N	\N	72252	72252	72253
17317	23182	1	applied	\N	\N	\N	\N	72254	72254	62174
17317	23183	2	applied	\N	\N	\N	\N	72255	72255	62188
17325	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17325	23193	1	applied	\N	\N	\N	\N	72280	72280	72281
17325	23194	2	applied	\N	\N	\N	\N	72282	72282	72283
17325	23195	3	applied	\N	\N	\N	\N	72284	72284	62243
17325	23196	4	applied	\N	\N	\N	\N	72285	72285	62245
17325	23197	5	applied	\N	\N	\N	\N	72286	72286	62255
17325	23198	6	applied	\N	\N	\N	\N	72287	72287	62263
17336	23219	0	applied	\N	\N	\N	\N	72344	72344	72345
17336	23220	1	applied	\N	\N	\N	\N	72346	72346	72347
17336	23221	2	applied	\N	\N	\N	\N	72348	72348	62334
17336	23216	3	applied	\N	\N	\N	\N	72337	72337	72349
17336	23222	4	applied	\N	\N	\N	\N	72350	72350	62350
17336	23217	5	applied	\N	\N	\N	\N	72338	72338	62354
17336	23223	6	applied	\N	\N	\N	\N	72351	72351	62365
17336	23224	7	applied	\N	\N	\N	\N	72352	72352	62374
17336	23225	8	applied	\N	\N	\N	\N	72353	72353	62389
17341	23235	0	applied	\N	\N	\N	\N	72375	72375	72376
17341	23236	1	applied	\N	\N	\N	\N	72377	72377	62447
17341	23237	2	applied	\N	\N	\N	\N	72378	72378	62455
17348	23244	0	applied	\N	\N	\N	\N	72397	72397	72398
17348	23245	1	applied	\N	\N	\N	\N	72399	72399	62512
17348	23246	2	applied	\N	\N	\N	\N	72400	72400	72401
17352	23249	0	applied	\N	\N	\N	\N	72412	72412	72413
17352	23250	1	applied	\N	\N	\N	\N	72414	72414	72415
17352	23251	2	applied	\N	\N	\N	\N	72416	72416	62538
17224	22987	2	applied	\N	\N	\N	\N	71803	71803	71804
17225	22988	0	applied	\N	\N	\N	\N	71808	71808	71809
17225	22989	1	applied	\N	\N	\N	\N	71810	71810	61050
17225	22990	2	applied	\N	\N	\N	\N	71811	71811	61065
17228	22998	0	applied	\N	\N	\N	\N	71830	71830	71831
17228	22999	1	applied	\N	\N	\N	\N	71832	71832	71833
17228	23000	2	applied	\N	\N	\N	\N	71834	71834	61107
17228	23001	3	applied	\N	\N	\N	\N	71835	71835	61122
17228	23002	4	applied	\N	\N	\N	\N	71836	71836	71837
17228	23003	5	applied	\N	\N	\N	\N	71838	71838	71839
17231	23004	0	applied	\N	\N	\N	\N	71844	71844	71845
17231	23005	1	applied	\N	\N	\N	\N	71846	71846	71847
17231	23006	3	applied	\N	\N	\N	\N	71849	71849	61151
17231	23007	4	applied	\N	\N	\N	\N	71850	71850	61161
17231	23008	5	applied	\N	\N	\N	\N	71851	71851	61165
17231	23009	6	applied	\N	\N	\N	\N	71852	71852	61167
17231	23010	7	applied	\N	\N	\N	\N	71853	71853	61175
17236	23018	0	applied	\N	\N	\N	\N	71870	71870	71871
17236	23019	1	applied	\N	\N	\N	\N	71872	71872	61220
17236	23020	2	applied	\N	\N	\N	\N	71873	71873	61222
17238	23021	0	applied	\N	\N	\N	\N	71877	71877	71878
17238	23022	1	applied	\N	\N	\N	\N	71879	71879	61238
17240	23023	0	applied	\N	\N	\N	\N	71881	71881	71882
17240	23024	1	applied	\N	\N	\N	\N	71883	71883	71884
17240	23025	2	applied	\N	\N	\N	\N	71885	71885	71886
17240	23026	3	applied	\N	\N	\N	\N	71887	71887	61258
17240	23027	4	applied	\N	\N	\N	\N	71888	71888	71889
17240	23028	5	applied	\N	\N	\N	\N	71890	71890	61264
17240	23029	6	applied	\N	\N	\N	\N	71891	71891	61275
17247	22916	0	applied	\N	\N	\N	\N	71634	71634	28166
17256	23050	0	applied	\N	\N	\N	\N	71961	71961	71962
17256	23051	1	applied	\N	\N	\N	\N	71963	71963	61413
17256	23052	2	applied	\N	\N	\N	\N	71964	71964	61417
17258	23050	0	applied	\N	\N	\N	\N	71961	71961	71962
17258	23053	1	applied	\N	\N	\N	\N	71969	71969	71970
17258	23054	2	applied	\N	\N	\N	\N	71971	71971	61424
17258	23051	3	applied	\N	\N	\N	\N	71963	71963	61432
17258	23055	4	applied	\N	\N	\N	\N	71972	71972	71973
17263	23065	0	applied	\N	\N	\N	\N	71995	71995	71996
17263	23066	1	applied	\N	\N	\N	\N	71997	71997	61504
17263	23067	2	applied	\N	\N	\N	\N	71998	71998	71999
17265	23068	0	applied	\N	\N	\N	\N	72001	72001	72002
17265	23069	1	applied	\N	\N	\N	\N	72003	72003	61522
17265	23070	2	applied	\N	\N	\N	\N	72004	72004	61531
17270	23076	0	applied	\N	\N	\N	\N	72018	72018	72019
17270	23077	1	applied	\N	\N	\N	\N	72020	72020	61566
17272	23078	0	applied	\N	\N	\N	\N	72022	72022	72023
17272	23079	1	applied	\N	\N	\N	\N	72024	72024	61581
17272	23080	2	applied	\N	\N	\N	\N	72025	72025	61583
17277	23084	0	applied	\N	\N	\N	\N	72036	72036	72037
17277	23085	1	applied	\N	\N	\N	\N	72038	72038	61612
17277	23086	2	applied	\N	\N	\N	\N	72039	72039	61614
17282	23087	0	applied	\N	\N	\N	\N	72042	72042	72043
17282	23088	1	applied	\N	\N	\N	\N	72044	72044	72045
17282	23089	3	applied	\N	\N	\N	\N	72047	72047	72048
17284	23093	0	applied	\N	\N	\N	\N	72066	72066	72067
17284	23094	1	applied	\N	\N	\N	\N	72068	72068	72069
17284	23095	2	applied	\N	\N	\N	\N	72070	72070	61656
17284	23096	3	applied	\N	\N	\N	\N	72071	72071	61672
17284	23097	4	applied	\N	\N	\N	\N	72072	72072	72073
17284	23098	5	applied	\N	\N	\N	\N	72074	72074	61678
17287	23099	0	applied	\N	\N	\N	\N	72080	72080	72081
17287	23100	1	applied	\N	\N	\N	\N	72082	72082	72083
17287	23101	2	applied	\N	\N	\N	\N	72084	72084	72085
17287	23102	3	applied	\N	\N	\N	\N	72086	72086	61694
17287	23103	4	applied	\N	\N	\N	\N	72087	72087	61698
17287	23104	5	applied	\N	\N	\N	\N	72088	72088	72089
17287	23105	6	applied	\N	\N	\N	\N	72090	72090	61712
17287	23106	7	applied	\N	\N	\N	\N	72091	72091	61721
17287	23107	8	applied	\N	\N	\N	\N	72092	72092	72093
17290	23117	0	applied	\N	\N	\N	\N	72112	72112	72113
17294	23119	0	applied	\N	\N	\N	\N	72119	72119	72120
17294	23120	1	applied	\N	\N	\N	\N	72121	72121	61791
17294	23118	2	applied	\N	\N	\N	\N	72116	72116	61801
17294	23121	3	applied	\N	\N	\N	\N	72122	72122	61819
17295	23122	0	applied	\N	\N	\N	\N	72125	72125	72126
17295	23123	1	applied	\N	\N	\N	\N	72127	72127	72128
17295	23124	2	applied	\N	\N	\N	\N	72129	72129	72130
17295	23125	3	applied	\N	\N	\N	\N	72131	72131	61823
17295	23126	4	applied	\N	\N	\N	\N	72132	72132	61838
17295	23127	5	applied	\N	\N	\N	\N	72133	72133	61842
17295	23128	6	applied	\N	\N	\N	\N	72134	72134	61853
17295	23129	7	applied	\N	\N	\N	\N	72135	72135	61855
17295	23130	8	applied	\N	\N	\N	\N	72136	72136	61868
17297	23131	0	applied	\N	\N	\N	\N	72140	72140	72141
17297	23132	1	applied	\N	\N	\N	\N	72142	72142	61874
17297	23133	2	applied	\N	\N	\N	\N	72143	72143	61882
17298	23134	0	applied	\N	\N	\N	\N	72146	72146	72147
17298	23135	1	applied	\N	\N	\N	\N	72148	72148	72149
17298	23136	2	applied	\N	\N	\N	\N	72150	72150	72151
17298	23137	3	applied	\N	\N	\N	\N	72152	72152	72153
17298	23138	4	applied	\N	\N	\N	\N	72154	72154	61890
17298	23139	5	applied	\N	\N	\N	\N	72155	72155	72156
17298	23140	6	applied	\N	\N	\N	\N	72157	72157	61915
17298	23141	7	applied	\N	\N	\N	\N	72158	72158	61929
17298	23142	8	applied	\N	\N	\N	\N	72159	72159	61933
17298	23143	9	applied	\N	\N	\N	\N	72160	72160	61940
17298	23144	10	applied	\N	\N	\N	\N	72161	72161	72162
17298	23145	11	applied	\N	\N	\N	\N	72163	72163	61962
17302	23149	0	applied	\N	\N	\N	\N	72173	72173	72174
17302	23150	1	applied	\N	\N	\N	\N	72175	72175	72176
17302	23151	2	applied	\N	\N	\N	\N	72177	72177	72178
17302	23152	3	applied	\N	\N	\N	\N	72179	72179	62010
17302	23153	4	applied	\N	\N	\N	\N	72180	72180	72181
17302	23154	5	applied	\N	\N	\N	\N	72182	72182	72183
17306	23165	0	applied	\N	\N	\N	\N	72211	72211	72212
17306	23166	1	applied	\N	\N	\N	\N	72213	72213	62098
17306	23167	2	applied	\N	\N	\N	\N	72214	72214	62100
17308	23168	0	applied	\N	\N	\N	\N	72217	72217	72218
17308	23169	1	applied	\N	\N	\N	\N	72219	72219	72220
17313	23174	0	applied	\N	\N	\N	\N	72233	72233	72234
17313	23176	1	applied	\N	\N	\N	\N	72237	72237	72238
17313	23177	2	applied	\N	\N	\N	\N	72239	72239	72240
17313	23175	3	applied	\N	\N	\N	\N	72235	72235	62153
17313	23178	5	applied	\N	\N	\N	\N	72242	72242	62163
17315	23179	0	applied	\N	\N	\N	\N	72245	72245	72246
17315	23180	1	applied	\N	\N	\N	\N	72247	72247	62167
17320	23189	0	applied	\N	\N	\N	\N	72268	72268	72269
17320	23190	1	applied	\N	\N	\N	\N	72270	72270	62223
17320	23191	2	applied	\N	\N	\N	\N	72271	72271	62233
17248	22825	85	applied	\N	\N	\N	\N	71431	71431	71432
17248	22828	86	applied	\N	\N	\N	\N	71437	71437	71438
17248	22829	87	applied	\N	\N	\N	\N	71439	71439	71440
17248	22836	88	applied	\N	\N	\N	\N	71452	71452	71453
17248	22837	89	applied	\N	\N	\N	\N	71454	71454	71455
17248	22841	90	applied	\N	\N	\N	\N	71463	71463	71464
17248	22845	91	applied	\N	\N	\N	\N	71475	71475	71476
17248	22848	92	applied	\N	\N	\N	\N	71482	71482	71483
17248	22849	93	applied	\N	\N	\N	\N	71484	71484	71485
17248	22859	94	applied	\N	\N	\N	\N	71509	71509	71510
17248	22860	95	applied	\N	\N	\N	\N	71511	71511	71512
17248	22865	96	applied	\N	\N	\N	\N	71522	71522	71523
17248	22869	97	applied	\N	\N	\N	\N	71530	71530	71531
17248	22870	98	applied	\N	\N	\N	\N	71532	71532	71533
17248	22871	99	applied	\N	\N	\N	\N	71534	71534	71535
17248	22879	100	applied	\N	\N	\N	\N	71549	71549	71550
17248	22882	101	applied	\N	\N	\N	\N	71553	71553	71554
17248	22885	102	applied	\N	\N	\N	\N	71560	71560	71561
17248	22886	103	applied	\N	\N	\N	\N	71562	71562	71563
17248	22887	104	applied	\N	\N	\N	\N	71568	71568	71569
17248	22895	105	applied	\N	\N	\N	\N	71584	71584	71585
17248	22896	107	applied	\N	\N	\N	\N	71586	71586	71587
17248	22902	108	applied	\N	\N	\N	\N	71598	71598	71599
17248	22905	109	applied	\N	\N	\N	\N	71605	71605	71913
17248	22908	110	applied	\N	\N	\N	\N	71611	71611	71914
17248	22912	111	applied	\N	\N	\N	\N	71625	71625	71915
17248	22915	112	applied	\N	\N	\N	\N	71632	71632	71916
17248	22921	113	applied	\N	\N	\N	\N	71648	71648	71917
17248	22922	114	applied	\N	\N	\N	\N	71650	71650	71918
17248	22923	115	applied	\N	\N	\N	\N	71652	71652	71919
17248	22930	116	applied	\N	\N	\N	\N	71669	71669	71920
17248	22934	117	applied	\N	\N	\N	\N	71676	71676	71921
17248	22937	118	applied	\N	\N	\N	\N	71683	71683	71922
17248	22940	119	applied	\N	\N	\N	\N	71691	71691	71923
17248	22944	120	applied	\N	\N	\N	\N	71702	71702	71924
17248	22947	121	applied	\N	\N	\N	\N	71709	71709	71925
17248	22948	122	applied	\N	\N	\N	\N	71711	71711	71926
17248	22953	123	applied	\N	\N	\N	\N	71719	71719	71927
17248	22956	124	applied	\N	\N	\N	\N	71727	71727	71928
17248	22959	125	applied	\N	\N	\N	\N	71741	71741	71929
17250	23041	0	applied	\N	\N	\N	\N	71942	71942	71943
17250	23042	1	applied	\N	\N	\N	\N	71944	71944	61357
17250	23043	2	applied	\N	\N	\N	\N	71945	71945	61369
17253	23044	0	applied	\N	\N	\N	\N	71948	71948	71949
17253	23045	1	applied	\N	\N	\N	\N	71950	71950	71951
17253	23046	2	applied	\N	\N	\N	\N	71952	71952	61380
17253	23047	3	applied	\N	\N	\N	\N	71953	71953	61389
17253	23048	4	applied	\N	\N	\N	\N	71954	71954	61407
17253	23049	5	applied	\N	\N	\N	\N	71955	71955	71956
17259	23050	0	applied	\N	\N	\N	\N	71961	71961	71962
17259	23053	1	applied	\N	\N	\N	\N	71969	71969	71970
17259	23051	2	applied	\N	\N	\N	\N	71963	71963	61417
17259	23055	3	applied	\N	\N	\N	\N	71972	71972	71976
17274	23081	0	applied	\N	\N	\N	\N	72028	72028	72029
17274	23082	1	applied	\N	\N	\N	\N	72030	72030	61590
17274	23083	2	applied	\N	\N	\N	\N	72031	72031	61602
17279	23087	0	applied	\N	\N	\N	\N	72042	72042	72043
17279	23088	1	applied	\N	\N	\N	\N	72044	72044	72045
17279	23089	3	applied	\N	\N	\N	\N	72047	72047	72048
17286	23093	0	applied	\N	\N	\N	\N	72066	72066	72067
17286	23094	1	applied	\N	\N	\N	\N	72068	72068	72069
17286	23095	2	applied	\N	\N	\N	\N	72070	72070	61656
17286	23096	3	applied	\N	\N	\N	\N	72071	72071	61672
17286	23097	4	applied	\N	\N	\N	\N	72072	72072	72073
17286	23098	5	applied	\N	\N	\N	\N	72074	72074	61678
17292	23117	0	applied	\N	\N	\N	\N	72112	72112	72113
17292	23118	1	applied	\N	\N	\N	\N	72116	72116	61796
17296	23122	0	applied	\N	\N	\N	\N	72125	72125	72126
17296	23123	1	applied	\N	\N	\N	\N	72127	72127	72128
17296	23124	2	applied	\N	\N	\N	\N	72129	72129	72130
17296	23125	3	applied	\N	\N	\N	\N	72131	72131	61823
17296	23126	4	applied	\N	\N	\N	\N	72132	72132	61838
17296	23127	5	applied	\N	\N	\N	\N	72133	72133	61842
17296	23128	6	applied	\N	\N	\N	\N	72134	72134	61853
17296	23129	7	applied	\N	\N	\N	\N	72135	72135	61855
17296	23130	8	applied	\N	\N	\N	\N	72136	72136	61868
17300	23149	0	applied	\N	\N	\N	\N	72173	72173	72174
17300	23150	1	applied	\N	\N	\N	\N	72175	72175	72176
17300	23151	2	applied	\N	\N	\N	\N	72177	72177	72178
17300	23152	3	applied	\N	\N	\N	\N	72179	72179	62010
17300	23153	4	applied	\N	\N	\N	\N	72180	72180	72181
17300	23154	5	applied	\N	\N	\N	\N	72182	72182	72183
17303	23149	0	applied	\N	\N	\N	\N	72173	72173	72174
17303	23150	1	applied	\N	\N	\N	\N	72175	72175	72176
17303	23151	2	applied	\N	\N	\N	\N	72177	72177	72178
17303	23152	3	applied	\N	\N	\N	\N	72179	72179	62010
17303	23153	4	applied	\N	\N	\N	\N	72180	72180	72181
17303	23154	5	applied	\N	\N	\N	\N	72182	72182	72183
17304	23155	0	applied	\N	\N	\N	\N	72192	72192	72193
17304	23156	1	applied	\N	\N	\N	\N	72194	72194	72195
17304	23157	2	applied	\N	\N	\N	\N	72196	72196	62035
17304	23158	3	applied	\N	\N	\N	\N	72197	72197	62046
17310	23170	0	applied	\N	\N	\N	\N	72223	72223	72224
17310	23171	1	applied	\N	\N	\N	\N	72225	72225	62119
17310	23172	2	applied	\N	\N	\N	\N	72226	72226	62123
17312	23174	0	applied	\N	\N	\N	\N	72233	72233	72234
17312	23173	1	applied	\N	\N	\N	\N	72230	72230	62132
17312	23175	2	applied	\N	\N	\N	\N	72235	72235	62146
17314	23174	0	applied	\N	\N	\N	\N	72233	72233	72234
17314	23176	1	applied	\N	\N	\N	\N	72237	72237	72238
17314	23177	2	applied	\N	\N	\N	\N	72239	72239	72240
17314	23175	3	applied	\N	\N	\N	\N	72235	72235	62153
17314	23178	5	applied	\N	\N	\N	\N	72242	72242	62163
17319	23187	0	applied	\N	\N	\N	\N	72263	72263	72264
17319	23188	1	applied	\N	\N	\N	\N	72265	72265	62212
17322	23189	0	applied	\N	\N	\N	\N	72268	72268	72269
17322	23190	1	applied	\N	\N	\N	\N	72270	72270	62223
17322	23191	2	applied	\N	\N	\N	\N	72271	72271	62233
17324	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17324	23193	1	applied	\N	\N	\N	\N	72280	72280	72281
17324	23194	2	applied	\N	\N	\N	\N	72282	72282	72283
17324	23195	3	applied	\N	\N	\N	\N	72284	72284	62243
17324	23196	4	applied	\N	\N	\N	\N	72285	72285	62245
17324	23197	5	applied	\N	\N	\N	\N	72286	72286	62255
17324	23198	6	applied	\N	\N	\N	\N	72287	72287	62263
17331	23201	0	applied	\N	\N	\N	\N	72310	72310	72311
17331	23202	1	applied	\N	\N	\N	\N	72312	72312	72313
17331	23203	2	applied	\N	\N	\N	\N	72314	72314	72315
17331	23204	3	applied	\N	\N	\N	\N	44630	44630	72316
17331	23205	4	applied	\N	\N	\N	\N	44632	44632	72317
17285	23093	0	applied	\N	\N	\N	\N	72066	72066	72067
17285	23094	1	applied	\N	\N	\N	\N	72068	72068	72069
17285	23095	2	applied	\N	\N	\N	\N	72070	72070	61656
17285	23096	3	applied	\N	\N	\N	\N	72071	72071	61672
17285	23097	4	applied	\N	\N	\N	\N	72072	72072	72073
17285	23098	5	applied	\N	\N	\N	\N	72074	72074	61678
17288	23108	0	applied	\N	\N	\N	\N	72095	72095	72096
17288	23109	1	applied	\N	\N	\N	\N	72097	72097	72098
17288	23110	2	applied	\N	\N	\N	\N	72099	72099	72100
17288	23111	3	applied	\N	\N	\N	\N	72101	72101	61751
17288	23112	4	applied	\N	\N	\N	\N	72102	72102	61755
17288	23113	5	applied	\N	\N	\N	\N	72103	72103	61771
17291	23117	0	applied	\N	\N	\N	\N	72112	72112	72113
17291	23118	1	applied	\N	\N	\N	\N	72116	72116	61796
17299	23146	0	applied	\N	\N	\N	\N	72166	72166	72167
17299	23147	1	applied	\N	\N	\N	\N	72168	72168	61966
17299	23148	2	applied	\N	\N	\N	\N	72169	72169	72170
17307	23165	0	applied	\N	\N	\N	\N	72211	72211	72212
17307	23166	1	applied	\N	\N	\N	\N	72213	72213	62098
17307	23167	2	applied	\N	\N	\N	\N	72214	72214	62100
17309	23170	0	applied	\N	\N	\N	\N	72223	72223	72224
17309	23171	1	applied	\N	\N	\N	\N	72225	72225	62119
17309	23172	2	applied	\N	\N	\N	\N	72226	72226	62123
17311	23173	0	applied	\N	\N	\N	\N	72230	72230	62132
17316	23179	0	applied	\N	\N	\N	\N	72245	72245	72246
17316	23180	1	applied	\N	\N	\N	\N	72247	72247	62167
17318	23184	0	applied	\N	\N	\N	\N	72256	72256	72257
17318	23185	1	applied	\N	\N	\N	\N	72258	72258	72259
17318	23186	2	applied	\N	\N	\N	\N	72260	72260	62201
17321	23189	0	applied	\N	\N	\N	\N	72268	72268	72269
17321	23190	1	applied	\N	\N	\N	\N	72270	72270	62223
17321	23191	2	applied	\N	\N	\N	\N	72271	72271	62233
17323	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17323	23193	1	applied	\N	\N	\N	\N	72280	72280	72281
17323	23194	2	applied	\N	\N	\N	\N	72282	72282	72283
17323	23195	3	applied	\N	\N	\N	\N	72284	72284	62243
17323	23196	4	applied	\N	\N	\N	\N	72285	72285	62245
17323	23197	5	applied	\N	\N	\N	\N	72286	72286	62255
17323	23198	6	applied	\N	\N	\N	\N	72287	72287	62263
17328	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17328	23134	1	applied	\N	\N	\N	\N	72146	72146	72147
17328	23156	2	applied	\N	\N	\N	\N	72194	72194	72195
17328	23135	3	applied	\N	\N	\N	\N	72148	72148	72149
17328	23136	4	applied	\N	\N	\N	\N	72150	72150	72151
17328	23137	5	applied	\N	\N	\N	\N	72152	72152	72153
17328	23146	6	applied	\N	\N	\N	\N	72166	72166	72167
17328	23149	7	applied	\N	\N	\N	\N	72173	72173	72174
17328	23150	8	applied	\N	\N	\N	\N	72175	72175	72176
17328	23155	9	applied	\N	\N	\N	\N	72192	72192	72193
17328	23159	10	applied	\N	\N	\N	\N	72200	72200	72201
17328	23160	11	applied	\N	\N	\N	\N	72202	72202	72203
17328	23165	12	applied	\N	\N	\N	\N	72211	72211	72212
17328	23168	13	applied	\N	\N	\N	\N	72217	72217	72218
17328	23170	14	applied	\N	\N	\N	\N	72223	72223	72224
17328	23174	15	applied	\N	\N	\N	\N	72233	72233	72234
17328	23176	16	applied	\N	\N	\N	\N	72237	72237	72238
17328	23179	17	applied	\N	\N	\N	\N	72245	72245	72246
17328	23181	18	applied	\N	\N	\N	\N	72252	72252	72253
17328	23184	19	applied	\N	\N	\N	\N	72256	72256	72257
17328	23187	20	applied	\N	\N	\N	\N	72263	72263	72264
17328	23189	21	applied	\N	\N	\N	\N	72268	72268	72269
17328	23193	22	applied	\N	\N	\N	\N	72280	72280	72281
17328	23194	23	applied	\N	\N	\N	\N	72282	72282	72283
17328	23199	24	applied	\N	\N	\N	\N	72295	72295	72296
17328	23138	25	applied	\N	\N	\N	\N	72154	72154	61890
17328	23139	26	applied	\N	\N	\N	\N	72155	72155	72156
17328	23140	27	applied	\N	\N	\N	\N	72157	72157	61915
17328	23141	28	applied	\N	\N	\N	\N	72158	72158	61929
17328	23142	29	applied	\N	\N	\N	\N	72159	72159	61933
17328	23147	30	applied	\N	\N	\N	\N	72168	72168	61942
17328	23151	31	applied	\N	\N	\N	\N	72177	72177	61962
17328	23154	32	applied	\N	\N	\N	\N	72182	72182	61966
17328	23158	33	applied	\N	\N	\N	\N	72197	72197	61987
17328	23161	34	applied	\N	\N	\N	\N	72204	72204	62008
17328	23164	35	applied	\N	\N	\N	\N	72208	72208	72181
17328	23166	36	applied	\N	\N	\N	\N	72213	72213	72183
17328	23169	37	applied	\N	\N	\N	\N	72219	72219	72300
17328	23172	38	applied	\N	\N	\N	\N	72226	72226	72301
17328	23175	39	applied	\N	\N	\N	\N	72235	72235	62071
17328	23143	40	applied	\N	\N	\N	\N	72160	72160	62073
17328	23144	41	applied	\N	\N	\N	\N	72161	72161	72302
17328	23145	42	applied	\N	\N	\N	\N	72163	72163	62087
17328	23148	43	applied	\N	\N	\N	\N	72169	72169	62089
17328	23152	44	applied	\N	\N	\N	\N	72179	72179	72303
17328	23153	45	applied	\N	\N	\N	\N	72180	72180	62102
17328	23157	46	applied	\N	\N	\N	\N	72196	72196	72220
17328	23162	47	applied	\N	\N	\N	\N	72205	72205	62119
17328	23163	48	applied	\N	\N	\N	\N	72207	72207	62121
17328	23167	49	applied	\N	\N	\N	\N	72214	72214	72304
17328	23171	50	applied	\N	\N	\N	\N	72225	72225	62144
17328	23173	51	applied	\N	\N	\N	\N	72230	72230	62146
17328	23177	52	applied	\N	\N	\N	\N	72239	72239	62153
17328	23183	53	applied	\N	\N	\N	\N	72255	72255	62161
17328	23186	54	applied	\N	\N	\N	\N	72260	72260	72305
17328	23191	55	applied	\N	\N	\N	\N	72271	72271	62167
17328	23195	56	applied	\N	\N	\N	\N	72284	72284	62172
17328	23196	57	applied	\N	\N	\N	\N	72285	72285	72306
17328	23178	58	applied	\N	\N	\N	\N	72242	72242	62192
17328	23180	59	applied	\N	\N	\N	\N	72247	72247	62201
17328	23182	60	applied	\N	\N	\N	\N	72254	72254	62212
17328	23185	61	applied	\N	\N	\N	\N	72258	72258	62223
17328	23188	63	applied	\N	\N	\N	\N	72265	72265	62235
17328	23190	64	applied	\N	\N	\N	\N	72270	72270	62245
17328	23197	65	applied	\N	\N	\N	\N	72286	72286	62255
17328	23198	66	applied	\N	\N	\N	\N	72287	72287	62263
17328	23200	67	applied	\N	\N	\N	\N	72297	72297	62278
17330	23201	0	applied	\N	\N	\N	\N	72310	72310	72311
17330	23202	1	applied	\N	\N	\N	\N	72312	72312	72313
17330	23203	2	applied	\N	\N	\N	\N	72314	72314	72315
17330	23204	3	applied	\N	\N	\N	\N	44630	44630	72316
17330	23205	4	applied	\N	\N	\N	\N	44632	44632	72317
17330	23206	5	applied	\N	\N	\N	\N	44634	44634	72318
17330	23207	6	applied	\N	\N	\N	\N	44636	44636	72319
17330	23208	7	applied	\N	\N	\N	\N	18200	18200	72320
17330	23209	8	applied	\N	\N	\N	\N	72321	72321	72322
17330	23210	9	applied	\N	\N	\N	\N	72323	72323	62288
17330	23211	10	applied	\N	\N	\N	\N	72324	72324	62298
17332	23212	0	applied	\N	\N	\N	\N	72329	72329	72330
17332	23213	1	applied	\N	\N	\N	\N	72331	72331	72332
17332	23214	2	applied	\N	\N	\N	\N	72333	72333	62300
17326	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17326	23193	1	applied	\N	\N	\N	\N	72280	72280	72281
17326	23194	2	applied	\N	\N	\N	\N	72282	72282	72283
17326	23195	3	applied	\N	\N	\N	\N	72284	72284	62243
17326	23196	4	applied	\N	\N	\N	\N	72285	72285	62245
17326	23197	5	applied	\N	\N	\N	\N	72286	72286	62255
17326	23198	6	applied	\N	\N	\N	\N	72287	72287	62263
17327	23199	0	applied	\N	\N	\N	\N	72295	72295	72296
17327	23200	1	applied	\N	\N	\N	\N	72297	72297	62278
17329	23201	0	applied	\N	\N	\N	\N	72310	72310	72311
17329	23202	1	applied	\N	\N	\N	\N	72312	72312	72313
17329	23203	2	applied	\N	\N	\N	\N	72314	72314	72315
17329	23204	3	applied	\N	\N	\N	\N	44630	44630	72316
17329	23205	4	applied	\N	\N	\N	\N	44632	44632	72317
17329	23206	5	applied	\N	\N	\N	\N	44634	44634	72318
17329	23207	6	applied	\N	\N	\N	\N	44636	44636	72319
17329	23208	7	applied	\N	\N	\N	\N	18200	18200	72320
17329	23209	8	applied	\N	\N	\N	\N	72321	72321	72322
17329	23210	9	applied	\N	\N	\N	\N	72323	72323	62288
17329	23211	10	applied	\N	\N	\N	\N	72324	72324	62298
17334	23218	0	applied	\N	\N	\N	\N	72340	72340	62314
17339	23232	0	applied	\N	\N	\N	\N	72366	72366	72367
17339	23233	1	applied	\N	\N	\N	\N	72368	72368	62437
17339	23234	2	applied	\N	\N	\N	\N	72369	72369	72370
17344	23241	0	applied	\N	\N	\N	\N	72387	72387	72388
17344	23242	1	applied	\N	\N	\N	\N	72389	72389	72390
17344	23243	2	applied	\N	\N	\N	\N	72391	72391	62500
17346	23241	0	applied	\N	\N	\N	\N	72387	72387	72388
17346	23242	1	applied	\N	\N	\N	\N	72389	72389	72390
17346	23243	2	applied	\N	\N	\N	\N	72391	72391	62500
17349	23244	0	applied	\N	\N	\N	\N	72397	72397	72398
17349	23246	1	applied	\N	\N	\N	\N	72400	72400	62510
17353	23252	0	applied	\N	\N	\N	\N	72418	72418	72419
17353	23253	1	applied	\N	\N	\N	\N	72420	72420	62553
17356	23254	0	applied	\N	\N	\N	\N	72423	72423	72424
17356	23255	1	applied	\N	\N	\N	\N	72425	72425	72426
17356	23256	2	applied	\N	\N	\N	\N	72427	72427	72428
17356	23257	3	applied	\N	\N	\N	\N	72429	72429	62557
17356	23258	4	applied	\N	\N	\N	\N	72430	72430	62569
17356	23259	5	applied	\N	\N	\N	\N	72431	72431	62577
17356	23260	6	applied	\N	\N	\N	\N	72432	72432	62587
17356	23261	7	applied	\N	\N	\N	\N	72433	72433	62589
17356	23262	9	applied	\N	\N	\N	\N	72435	72435	72436
17358	23263	0	applied	\N	\N	\N	\N	72440	72440	72441
17358	23264	1	applied	\N	\N	\N	\N	72442	72442	72443
17358	23265	2	applied	\N	\N	\N	\N	72444	72444	62616
17361	23263	0	applied	\N	\N	\N	\N	72440	72440	72441
17361	23264	1	applied	\N	\N	\N	\N	72442	72442	72443
17361	23265	2	applied	\N	\N	\N	\N	72444	72444	62616
17366	23269	0	applied	\N	\N	\N	\N	72456	72456	72457
17366	23270	1	applied	\N	\N	\N	\N	72458	72458	72459
17366	23271	2	applied	\N	\N	\N	\N	72460	72460	62631
17366	23272	3	applied	\N	\N	\N	\N	72461	72461	62648
17366	23273	4	applied	\N	\N	\N	\N	72462	72462	62652
17370	23280	0	applied	\N	\N	\N	\N	72479	72479	72480
17370	23281	1	applied	\N	\N	\N	\N	72481	72481	72482
17372	23282	0	applied	\N	\N	\N	\N	72486	72486	72487
17372	23283	1	applied	\N	\N	\N	\N	72488	72488	72489
17372	23284	2	applied	\N	\N	\N	\N	72490	72490	72491
17376	23285	0	applied	\N	\N	\N	\N	72499	72499	72500
17376	23286	1	applied	\N	\N	\N	\N	72501	72501	72502
17376	23287	2	applied	\N	\N	\N	\N	72503	72503	72504
17379	23291	0	applied	\N	\N	\N	\N	72511	72511	72512
17379	23292	1	applied	\N	\N	\N	\N	72513	72513	72514
17379	23293	2	applied	\N	\N	\N	\N	72515	72515	72516
17379	23294	3	applied	\N	\N	\N	\N	72517	72517	72518
17379	23295	4	applied	\N	\N	\N	\N	72519	72519	72520
17379	23296	5	applied	\N	\N	\N	\N	72521	72521	72522
17385	23315	0	applied	\N	\N	\N	\N	72567	72567	72568
17385	23314	1	applied	\N	\N	\N	\N	72564	72564	72565
17385	23316	2	applied	\N	\N	\N	\N	72569	72569	72570
17390	23320	0	applied	\N	\N	\N	\N	72581	72581	72582
17390	23321	1	applied	\N	\N	\N	\N	72583	72583	72584
17390	23322	2	applied	\N	\N	\N	\N	72585	72585	72586
17390	23323	3	applied	\N	\N	\N	\N	72587	72587	72588
17390	23324	4	applied	\N	\N	1000000000	\N	72589	72589	72590
17390	23329	5	applied	\N	\N	\N	\N	72620	72620	72621
17390	23330	6	applied	\N	\N	\N	\N	72622	72622	72623
17390	23325	7	applied	\N	\N	\N	\N	72601	72601	72624
17390	23331	8	applied	\N	\N	\N	\N	72625	72625	72626
17390	23326	9	applied	\N	\N	\N	\N	72602	72602	72627
17390	23327	10	applied	\N	\N	\N	\N	72604	72604	72628
17390	23328	11	applied	\N	\N	\N	\N	72605	72605	72629
17392	23332	0	applied	\N	\N	\N	\N	72637	72637	72638
17392	23333	1	applied	\N	\N	\N	\N	72639	72639	72640
17392	23334	2	applied	\N	\N	\N	\N	72641	72641	72642
17392	23335	3	applied	\N	\N	\N	\N	72643	72643	72644
17392	23336	4	applied	\N	\N	\N	\N	72645	72645	72646
17392	23337	5	applied	\N	\N	\N	\N	72647	72647	72648
17392	23338	6	applied	\N	\N	\N	\N	72649	72649	72650
17395	23340	0	applied	\N	\N	\N	\N	72656	72656	72657
17395	23341	1	applied	\N	\N	\N	\N	72658	72658	72659
17395	23342	2	applied	\N	\N	\N	\N	72660	72660	72661
17395	23343	3	applied	\N	\N	\N	\N	72662	72662	72663
17395	23344	4	applied	\N	\N	\N	\N	72664	72664	72665
17399	23356	0	applied	\N	\N	\N	\N	72695	72695	72696
17399	23357	1	applied	\N	\N	\N	\N	72697	72697	72698
17399	23358	2	applied	\N	\N	\N	\N	72699	72699	72700
17399	23359	3	applied	\N	\N	\N	\N	72701	72701	72702
17399	23360	4	applied	\N	\N	\N	\N	72703	72703	72704
17399	23361	5	applied	\N	\N	\N	\N	72705	72705	72706
17399	23362	6	applied	\N	\N	\N	\N	72707	72707	72708
17399	23363	7	applied	\N	\N	\N	\N	72709	72709	72710
17399	23364	8	applied	\N	\N	\N	\N	72711	72711	72712
17403	23367	0	applied	\N	\N	\N	\N	72724	72724	72725
17403	23368	1	applied	\N	\N	\N	\N	72726	72726	72727
17403	23369	2	applied	\N	\N	\N	\N	72728	72728	72729
17406	23373	0	applied	\N	\N	\N	\N	72740	72740	72741
17406	23374	1	applied	\N	\N	\N	\N	72742	72742	72743
17406	23375	2	applied	\N	\N	\N	\N	72744	72744	72745
17411	23387	0	applied	\N	\N	\N	\N	72775	72775	72776
17411	23388	1	applied	\N	\N	\N	\N	72777	72777	72778
17411	23389	2	applied	\N	\N	\N	\N	72779	72779	72780
17416	23390	0	applied	\N	\N	\N	\N	72785	72785	72786
17416	23391	1	applied	\N	\N	\N	\N	72787	72787	72788
17417	23392	0	applied	\N	\N	\N	\N	72794	72794	72795
17417	23393	1	applied	\N	\N	\N	\N	72796	72796	72797
17420	23397	0	applied	\N	\N	\N	\N	72808	72808	72809
17420	23398	1	applied	\N	\N	\N	\N	72810	72810	72811
17422	23399	0	applied	\N	\N	\N	\N	72816	72816	72817
17331	23206	5	applied	\N	\N	\N	\N	44634	44634	72318
17331	23209	6	applied	\N	\N	\N	\N	72321	72321	72322
17331	23210	7	applied	\N	\N	\N	\N	72323	72323	62288
17331	23211	8	applied	\N	\N	\N	\N	72324	72324	62298
17333	23212	0	applied	\N	\N	\N	\N	72329	72329	72330
17333	23213	1	applied	\N	\N	\N	\N	72331	72331	72332
17333	23216	2	applied	\N	\N	\N	\N	72337	72337	62306
17333	23217	3	applied	\N	\N	\N	\N	72338	72338	62314
17333	23214	4	applied	\N	\N	\N	\N	72333	72333	62334
17333	23215	5	applied	\N	\N	\N	\N	72334	72334	62338
17338	23229	0	applied	\N	\N	\N	\N	72362	72362	72363
17338	23230	1	applied	\N	\N	\N	\N	72364	72364	62416
17338	23231	2	applied	\N	\N	\N	\N	72365	72365	62418
17343	23238	0	applied	\N	\N	\N	\N	72380	72380	72381
17343	23239	1	applied	\N	\N	\N	\N	72382	72382	62467
17343	23240	2	applied	\N	\N	\N	\N	72383	72383	72384
17355	23254	0	applied	\N	\N	\N	\N	72423	72423	72424
17355	23255	1	applied	\N	\N	\N	\N	72425	72425	72426
17355	23256	2	applied	\N	\N	\N	\N	72427	72427	72428
17355	23257	3	applied	\N	\N	\N	\N	72429	72429	62557
17355	23258	4	applied	\N	\N	\N	\N	72430	72430	62569
17355	23259	5	applied	\N	\N	\N	\N	72431	72431	62577
17355	23260	6	applied	\N	\N	\N	\N	72432	72432	62587
17355	23261	7	applied	\N	\N	\N	\N	72433	72433	62589
17355	23262	9	applied	\N	\N	\N	\N	72435	72435	72436
17357	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17357	23156	1	applied	\N	\N	\N	\N	72194	72194	72195
17357	22916	2	applied	\N	\N	\N	\N	71634	71634	28166
17364	23269	0	applied	\N	\N	\N	\N	72456	72456	72457
17364	23270	1	applied	\N	\N	\N	\N	72458	72458	72459
17364	23271	2	applied	\N	\N	\N	\N	72460	72460	62631
17364	23272	3	applied	\N	\N	\N	\N	72461	72461	62648
17364	23273	4	applied	\N	\N	\N	\N	72462	72462	62652
17368	23270	0	applied	\N	\N	\N	\N	72458	72458	72459
17368	23274	1	applied	\N	\N	\N	\N	72468	72468	72469
17368	23275	2	applied	\N	\N	\N	\N	72470	72470	72471
17368	23276	3	applied	\N	\N	\N	\N	72472	72472	62654
17368	23277	4	applied	\N	\N	\N	\N	72473	72473	62672
17368	23278	5	applied	\N	\N	\N	\N	72474	72474	62676
17368	23279	6	applied	\N	\N	\N	\N	72475	72475	72476
17374	23282	0	applied	\N	\N	\N	\N	72486	72486	72487
17374	23283	1	applied	\N	\N	\N	\N	72488	72488	72489
17374	23284	2	applied	\N	\N	\N	\N	72490	72490	72491
17380	23297	0	applied	\N	\N	\N	\N	72525	72525	72526
17380	23298	1	applied	\N	\N	\N	\N	72527	72527	72528
17380	23299	2	applied	\N	\N	\N	\N	72529	72529	72530
17380	23300	3	applied	\N	\N	\N	\N	72531	72531	72532
17380	23301	4	applied	\N	\N	\N	\N	72533	72533	72534
17380	23302	5	applied	\N	\N	\N	\N	72535	72535	72536
17380	23303	6	applied	\N	\N	\N	\N	72537	72537	72538
17380	23304	7	applied	\N	\N	\N	\N	72539	72539	72540
17386	23315	0	applied	\N	\N	\N	\N	72567	72567	72568
17386	23314	1	applied	\N	\N	\N	\N	72564	72564	72565
17386	23316	2	applied	\N	\N	\N	\N	72569	72569	72570
17387	23315	0	applied	\N	\N	\N	\N	72567	72567	72568
17387	23317	1	applied	\N	\N	\N	\N	72574	72574	72575
17387	23316	2	applied	\N	\N	\N	\N	72569	72569	72570
17387	23318	3	applied	\N	\N	\N	\N	72576	72576	72577
17387	23319	4	applied	\N	\N	\N	\N	72578	72578	72579
17388	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17388	23179	1	applied	\N	\N	\N	\N	72245	72245	72246
17388	23181	2	applied	\N	\N	\N	\N	72252	72252	72253
17388	23184	3	applied	\N	\N	\N	\N	72256	72256	72257
17388	23187	4	applied	\N	\N	\N	\N	72263	72263	72264
17388	23189	5	applied	\N	\N	\N	\N	72268	72268	72269
17388	23193	6	applied	\N	\N	\N	\N	72280	72280	72281
17388	23194	7	applied	\N	\N	\N	\N	72282	72282	72283
17388	23199	8	applied	\N	\N	\N	\N	72295	72295	72296
17388	23209	9	applied	\N	\N	\N	\N	72321	72321	72322
17388	23212	10	applied	\N	\N	\N	\N	72329	72329	72330
17388	23213	11	applied	\N	\N	\N	\N	72331	72331	72332
17388	23219	12	applied	\N	\N	\N	\N	72344	72344	72345
17388	23220	13	applied	\N	\N	\N	\N	72346	72346	72347
17388	23226	14	applied	\N	\N	\N	\N	72355	72355	72356
17388	23229	15	applied	\N	\N	\N	\N	72362	72362	72363
17388	23232	16	applied	\N	\N	\N	\N	72366	72366	72367
17388	23235	17	applied	\N	\N	\N	\N	72375	72375	72376
17388	23238	18	applied	\N	\N	\N	\N	72380	72380	72381
17388	23241	19	applied	\N	\N	\N	\N	72387	72387	72388
17388	23244	20	applied	\N	\N	\N	\N	72397	72397	72398
17388	23247	21	applied	\N	\N	\N	\N	72406	72406	72407
17388	23249	22	applied	\N	\N	\N	\N	72412	72412	72413
17388	23252	23	applied	\N	\N	\N	\N	72418	72418	72419
17388	23254	24	applied	\N	\N	\N	\N	72423	72423	72424
17388	23255	25	applied	\N	\N	\N	\N	72425	72425	72426
17388	23256	26	applied	\N	\N	\N	\N	72427	72427	72428
17388	23263	27	applied	\N	\N	\N	\N	72440	72440	72441
17388	23266	28	applied	\N	\N	\N	\N	72449	72449	72450
17388	23269	29	applied	\N	\N	\N	\N	72456	72456	72457
17388	23270	30	applied	\N	\N	\N	\N	72458	72458	72459
17388	23274	31	applied	\N	\N	\N	\N	72468	72468	72469
17388	23275	32	applied	\N	\N	\N	\N	72470	72470	72471
17388	23280	33	applied	\N	\N	\N	\N	72479	72479	72480
17388	23282	34	applied	\N	\N	\N	\N	72486	72486	72487
17388	23285	35	applied	\N	\N	\N	\N	72499	72499	72500
17388	23288	36	applied	\N	\N	\N	\N	72505	72505	72506
17388	23291	37	applied	\N	\N	\N	\N	72511	72511	72512
17388	23292	38	applied	\N	\N	\N	\N	72513	72513	72514
17388	23297	39	applied	\N	\N	\N	\N	72525	72525	72526
17388	23298	40	applied	\N	\N	\N	\N	72527	72527	72528
17388	23299	41	applied	\N	\N	\N	\N	72529	72529	72530
17388	23305	42	applied	\N	\N	\N	\N	72542	72542	72543
17388	23306	43	applied	\N	\N	\N	\N	72544	72544	72545
17388	23311	44	applied	\N	\N	\N	\N	72556	72556	72557
17388	23315	45	applied	\N	\N	\N	\N	72567	72567	72568
17388	23317	46	applied	\N	\N	\N	\N	72574	72574	72575
17388	23320	47	applied	\N	\N	\N	\N	72581	72581	72582
17388	23321	48	applied	\N	\N	\N	\N	72583	72583	72584
17388	23322	49	applied	\N	\N	\N	\N	72585	72585	72586
17388	23323	50	applied	\N	\N	\N	\N	72587	72587	72588
17388	23324	51	applied	\N	\N	1000000000	\N	72589	72589	72590
17388	23183	52	applied	\N	\N	\N	\N	72255	72255	62165
17388	23186	53	applied	\N	\N	\N	\N	72260	72260	72591
17388	23191	54	applied	\N	\N	\N	\N	72271	72271	62174
17388	23195	55	applied	\N	\N	\N	\N	72284	72284	62188
17388	23196	56	applied	\N	\N	\N	\N	72285	72285	62192
17388	23210	57	applied	\N	\N	\N	\N	72323	72323	62194
17388	23214	58	applied	\N	\N	\N	\N	72333	72333	72592
17388	23215	59	applied	\N	\N	\N	\N	72334	72334	62212
17388	23218	60	applied	\N	\N	\N	\N	72340	72340	62221
17332	23215	3	applied	\N	\N	\N	\N	72334	72334	72335
17335	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17337	23226	0	applied	\N	\N	\N	\N	72355	72355	72356
17337	23227	1	applied	\N	\N	\N	\N	72357	72357	62393
17337	23228	2	applied	\N	\N	\N	\N	72358	72358	72359
17340	23232	0	applied	\N	\N	\N	\N	72366	72366	72367
17340	23233	1	applied	\N	\N	\N	\N	72368	72368	62437
17340	23234	2	applied	\N	\N	\N	\N	72369	72369	72370
17342	23238	0	applied	\N	\N	\N	\N	72380	72380	72381
17342	23239	1	applied	\N	\N	\N	\N	72382	72382	62467
17342	23240	2	applied	\N	\N	\N	\N	72383	72383	72384
17345	23241	0	applied	\N	\N	\N	\N	72387	72387	72388
17345	23242	1	applied	\N	\N	\N	\N	72389	72389	72390
17345	23243	2	applied	\N	\N	\N	\N	72391	72391	62500
17350	23244	0	applied	\N	\N	\N	\N	72397	72397	72398
17350	23245	1	applied	\N	\N	\N	\N	72399	72399	62512
17350	23246	2	applied	\N	\N	\N	\N	72400	72400	72401
17351	23244	0	applied	\N	\N	\N	\N	72397	72397	72398
17351	23247	1	applied	\N	\N	\N	\N	72406	72406	72407
17351	23245	2	applied	\N	\N	\N	\N	72399	72399	62512
17351	23248	3	applied	\N	\N	\N	\N	72408	72408	62516
17351	23246	4	applied	\N	\N	\N	\N	72400	72400	72409
17354	23254	0	applied	\N	\N	\N	\N	72423	72423	72424
17354	23255	1	applied	\N	\N	\N	\N	72425	72425	72426
17354	23256	2	applied	\N	\N	\N	\N	72427	72427	72428
17354	23257	3	applied	\N	\N	\N	\N	72429	72429	62557
17354	23258	4	applied	\N	\N	\N	\N	72430	72430	62569
17354	23259	5	applied	\N	\N	\N	\N	72431	72431	62577
17354	23260	6	applied	\N	\N	\N	\N	72432	72432	62587
17354	23261	7	applied	\N	\N	\N	\N	72433	72433	62589
17354	23262	9	applied	\N	\N	\N	\N	72435	72435	72436
17359	23263	0	applied	\N	\N	\N	\N	72440	72440	72441
17359	23264	1	applied	\N	\N	\N	\N	72442	72442	72443
17359	23265	2	applied	\N	\N	\N	\N	72444	72444	62616
17362	23263	0	applied	\N	\N	\N	\N	72440	72440	72441
17362	23264	1	applied	\N	\N	\N	\N	72442	72442	72443
17362	23265	2	applied	\N	\N	\N	\N	72444	72444	62616
17367	23269	0	applied	\N	\N	\N	\N	72456	72456	72457
17367	23271	1	applied	\N	\N	\N	\N	72460	72460	62631
17367	23272	2	applied	\N	\N	\N	\N	72461	72461	62648
17367	23273	3	applied	\N	\N	\N	\N	72462	72462	62652
17373	23282	0	applied	\N	\N	\N	\N	72486	72486	72487
17373	23283	1	applied	\N	\N	\N	\N	72488	72488	72489
17373	23284	2	applied	\N	\N	\N	\N	72490	72490	72491
17377	23288	0	applied	\N	\N	\N	\N	72505	72505	72506
17377	23289	1	applied	\N	\N	\N	\N	72507	72507	72508
17377	23290	2	applied	\N	\N	\N	\N	72509	72509	72510
17381	23305	0	applied	\N	\N	\N	\N	72542	72542	72543
17381	23306	1	applied	\N	\N	\N	\N	72544	72544	72545
17381	23307	2	applied	\N	\N	\N	\N	72546	72546	72547
17381	23308	3	applied	\N	\N	\N	\N	72548	72548	72549
17381	23309	4	applied	\N	\N	\N	\N	72550	72550	72551
17381	23310	5	applied	\N	\N	\N	\N	72552	72552	72553
17383	23311	0	applied	\N	\N	\N	\N	72556	72556	72557
17383	23312	1	applied	\N	\N	\N	\N	72558	72558	72559
17383	23313	2	applied	\N	\N	\N	\N	72560	72560	72561
17391	23192	0	applied	\N	\N	\N	\N	72634	72634	72279
17391	22715	1	applied	\N	\N	\N	\N	71106	71106	71107
17391	22698	2	applied	\N	\N	\N	\N	71076	71076	71077
17391	22790	3	applied	\N	\N	\N	\N	71353	71353	71354
17391	22806	4	applied	\N	\N	1000000000	\N	71396	71396	71397
17391	22830	5	applied	\N	\N	1000000000	\N	71441	71441	71442
17391	22850	6	applied	\N	\N	\N	\N	71505	71505	71487
17391	22666	7	applied	\N	\N	\N	\N	70999	70999	71000
17391	22667	8	applied	\N	\N	\N	\N	71001	71001	71002
17393	23332	0	applied	\N	\N	\N	\N	72637	72637	72638
17393	23333	1	applied	\N	\N	\N	\N	72639	72639	72640
17393	23334	2	applied	\N	\N	\N	\N	72641	72641	72642
17393	23335	3	applied	\N	\N	\N	\N	72643	72643	72644
17393	23336	4	applied	\N	\N	\N	\N	72645	72645	72646
17393	23337	5	applied	\N	\N	\N	\N	72647	72647	72648
17393	23338	6	applied	\N	\N	\N	\N	72649	72649	72650
17393	23339	7	applied	\N	\N	\N	\N	72653	72653	72654
17396	23345	0	applied	\N	\N	\N	\N	72668	72668	72669
17396	23346	1	applied	\N	\N	\N	\N	72670	72670	72671
17402	23365	0	applied	\N	\N	\N	\N	72717	72717	72718
17402	23366	1	applied	\N	\N	\N	\N	72719	72719	72720
17404	23370	0	applied	\N	\N	\N	\N	72732	72732	72733
17404	23371	1	applied	\N	\N	\N	\N	72734	72734	72735
17404	23372	2	applied	\N	\N	\N	\N	72736	72736	72737
17407	23376	0	applied	\N	\N	\N	\N	72748	72748	72749
17407	23377	1	applied	\N	\N	\N	\N	72750	72750	72751
17407	23378	2	applied	\N	\N	\N	\N	72752	72752	72753
17407	23379	3	applied	\N	\N	\N	\N	72754	72754	72755
17407	23380	4	applied	\N	\N	\N	\N	72756	72756	72757
17407	23381	5	applied	\N	\N	\N	\N	72758	72758	72759
17413	23387	0	applied	\N	\N	\N	\N	72775	72775	72776
17413	23388	1	applied	\N	\N	\N	\N	72777	72777	72778
17413	23389	2	applied	\N	\N	\N	\N	72779	72779	72780
17414	23390	0	applied	\N	\N	\N	\N	72785	72785	72786
17414	23391	1	applied	\N	\N	\N	\N	72787	72787	72788
17421	23399	0	applied	\N	\N	\N	\N	72816	72816	72817
17421	23400	1	applied	\N	\N	\N	\N	72818	72818	72819
17421	23401	2	applied	\N	\N	\N	\N	72820	72820	72821
17421	23402	3	applied	\N	\N	\N	\N	72822	72822	72823
17421	23403	4	applied	\N	\N	\N	\N	72824	72824	72825
17421	23404	5	applied	\N	\N	\N	\N	72826	72826	72827
17426	23409	0	applied	\N	\N	\N	\N	72845	72845	72846
17426	23410	1	applied	\N	\N	\N	\N	72847	72847	72848
17426	23411	2	applied	\N	\N	\N	\N	72849	72849	72850
17426	23412	3	applied	\N	\N	\N	\N	72851	72851	72852
17426	23413	4	applied	\N	\N	\N	\N	72853	72853	72854
17426	23414	5	applied	\N	\N	\N	\N	72855	72855	72856
17426	23415	6	applied	\N	\N	\N	\N	72857	72857	72858
17426	23416	7	applied	\N	\N	\N	\N	72859	72859	72860
17431	23422	0	applied	\N	\N	\N	\N	72879	72879	72880
17431	23423	1	applied	\N	\N	\N	\N	72881	72881	72882
17431	23424	2	applied	\N	\N	\N	\N	72883	72883	72884
17431	23425	3	applied	\N	\N	\N	\N	72885	72885	72886
17437	23429	0	applied	\N	\N	\N	\N	5821	5821	72930
17437	23430	1	applied	\N	\N	\N	\N	72931	72931	72932
17437	23431	2	applied	\N	\N	\N	\N	72933	72933	72934
17440	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17440	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17440	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17440	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17440	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17440	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17443	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17360	23263	0	applied	\N	\N	\N	\N	72440	72440	72441
17360	23264	1	applied	\N	\N	\N	\N	72442	72442	72443
17360	23265	2	applied	\N	\N	\N	\N	72444	72444	62616
17363	23266	0	applied	\N	\N	\N	\N	72449	72449	72450
17363	23267	1	applied	\N	\N	\N	\N	72451	72451	62620
17363	23268	2	applied	\N	\N	\N	\N	72452	72452	72453
17365	23269	0	applied	\N	\N	\N	\N	72456	72456	72457
17365	23270	1	applied	\N	\N	\N	\N	72458	72458	72459
17365	23271	2	applied	\N	\N	\N	\N	72460	72460	62631
17365	23272	3	applied	\N	\N	\N	\N	72461	72461	62648
17365	23273	4	applied	\N	\N	\N	\N	72462	72462	62652
17369	23280	0	applied	\N	\N	\N	\N	72479	72479	72480
17369	23281	1	applied	\N	\N	\N	\N	72481	72481	72482
17371	23282	0	applied	\N	\N	\N	\N	72486	72486	72487
17371	23283	1	applied	\N	\N	\N	\N	72488	72488	72489
17371	23284	2	applied	\N	\N	\N	\N	72490	72490	72491
17375	23283	0	applied	\N	\N	\N	\N	72488	72488	72489
17375	23284	1	applied	\N	\N	\N	\N	72490	72490	72491
17378	23291	0	applied	\N	\N	\N	\N	72511	72511	72512
17378	23292	1	applied	\N	\N	\N	\N	72513	72513	72514
17378	23293	2	applied	\N	\N	\N	\N	72515	72515	72516
17378	23294	3	applied	\N	\N	\N	\N	72517	72517	72518
17378	23295	4	applied	\N	\N	\N	\N	72519	72519	72520
17378	23296	5	applied	\N	\N	\N	\N	72521	72521	72522
17382	23305	0	applied	\N	\N	\N	\N	72542	72542	72543
17382	23306	1	applied	\N	\N	\N	\N	72544	72544	72545
17382	23307	2	applied	\N	\N	\N	\N	72546	72546	72547
17382	23308	3	applied	\N	\N	\N	\N	72548	72548	72549
17382	23309	4	applied	\N	\N	\N	\N	72550	72550	72551
17382	23310	5	applied	\N	\N	\N	\N	72552	72552	72553
17384	23314	0	applied	\N	\N	\N	\N	72564	72564	72565
17389	23320	0	applied	\N	\N	\N	\N	72581	72581	72582
17389	23321	1	applied	\N	\N	\N	\N	72583	72583	72584
17389	23322	2	applied	\N	\N	\N	\N	72585	72585	72586
17389	23323	3	applied	\N	\N	\N	\N	72587	72587	72588
17389	23324	4	applied	\N	\N	1000000000	\N	72589	72589	72590
17389	23329	5	applied	\N	\N	\N	\N	72620	72620	72621
17389	23330	6	applied	\N	\N	\N	\N	72622	72622	72623
17389	23325	7	applied	\N	\N	\N	\N	72601	72601	72624
17389	23331	8	applied	\N	\N	\N	\N	72625	72625	72626
17389	23326	9	applied	\N	\N	\N	\N	72602	72602	72627
17389	23327	10	applied	\N	\N	\N	\N	72604	72604	72628
17389	23328	11	applied	\N	\N	\N	\N	72605	72605	72629
17394	23340	0	applied	\N	\N	\N	\N	72656	72656	72657
17394	23341	1	applied	\N	\N	\N	\N	72658	72658	72659
17394	23342	2	applied	\N	\N	\N	\N	72660	72660	72661
17394	23343	3	applied	\N	\N	\N	\N	72662	72662	72663
17394	23344	4	applied	\N	\N	\N	\N	72664	72664	72665
17397	23347	0	applied	\N	\N	\N	\N	72674	72674	72675
17397	23348	1	applied	\N	\N	\N	\N	72676	72676	72677
17397	23349	2	applied	\N	\N	\N	\N	72678	72678	72679
17397	23350	3	applied	\N	\N	\N	\N	72680	72680	72681
17397	23351	5	applied	\N	\N	\N	\N	72683	72683	72684
17397	23352	6	applied	\N	\N	\N	\N	72685	72685	72686
17397	23353	7	applied	\N	\N	\N	\N	72687	72687	72688
17397	23354	8	applied	\N	\N	\N	\N	72689	72689	72690
17397	23355	9	applied	\N	\N	\N	\N	72691	72691	72692
17398	23356	0	applied	\N	\N	\N	\N	72695	72695	72696
17398	23357	1	applied	\N	\N	\N	\N	72697	72697	72698
17398	23358	2	applied	\N	\N	\N	\N	72699	72699	72700
17398	23359	3	applied	\N	\N	\N	\N	72701	72701	72702
17398	23360	4	applied	\N	\N	\N	\N	72703	72703	72704
17398	23361	5	applied	\N	\N	\N	\N	72705	72705	72706
17398	23362	6	applied	\N	\N	\N	\N	72707	72707	72708
17398	23363	7	applied	\N	\N	\N	\N	72709	72709	72710
17398	23364	8	applied	\N	\N	\N	\N	72711	72711	72712
17405	23373	0	applied	\N	\N	\N	\N	72740	72740	72741
17405	23374	1	applied	\N	\N	\N	\N	72742	72742	72743
17405	23375	2	applied	\N	\N	\N	\N	72744	72744	72745
17408	23376	0	applied	\N	\N	\N	\N	72748	72748	72749
17408	23377	1	applied	\N	\N	\N	\N	72750	72750	72751
17408	23378	2	applied	\N	\N	\N	\N	72752	72752	72753
17408	23379	3	applied	\N	\N	\N	\N	72754	72754	72755
17408	23380	4	applied	\N	\N	\N	\N	72756	72756	72757
17408	23381	5	applied	\N	\N	\N	\N	72758	72758	72759
17410	23387	0	applied	\N	\N	\N	\N	72775	72775	72776
17410	23388	1	applied	\N	\N	\N	\N	72777	72777	72778
17410	23389	2	applied	\N	\N	\N	\N	72779	72779	72780
17415	23390	0	applied	\N	\N	\N	\N	72785	72785	72786
17415	23391	1	applied	\N	\N	\N	\N	72787	72787	72788
17419	23397	0	applied	\N	\N	\N	\N	72808	72808	72809
17419	23398	1	applied	\N	\N	\N	\N	72810	72810	72811
17424	23405	0	applied	\N	\N	\N	\N	72833	72833	72834
17424	23406	1	applied	\N	\N	\N	\N	72835	72835	72836
17424	23407	2	applied	\N	\N	\N	\N	72837	72837	72838
17424	23408	3	applied	\N	\N	\N	\N	72839	72839	72840
17429	23419	0	applied	\N	\N	\N	\N	72871	72871	72872
17429	23420	1	applied	\N	\N	\N	\N	72873	72873	72874
17429	23421	2	applied	\N	\N	\N	\N	72875	72875	72876
17434	23426	0	applied	\N	\N	\N	\N	72918	72918	72919
17434	23427	1	applied	\N	\N	\N	\N	72920	72920	72921
17434	23428	2	applied	\N	\N	\N	\N	72922	72922	72923
17438	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17438	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17438	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17438	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17438	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17438	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17441	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17441	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17441	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17441	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17441	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17441	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17449	23446	0	applied	\N	\N	\N	\N	72982	72982	72983
17449	23447	1	applied	\N	\N	\N	\N	72984	72984	72985
17451	23192	0	applied	\N	\N	\N	\N	73026	73026	72279
17451	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17451	22715	2	applied	\N	\N	\N	\N	71106	71106	71107
17451	22641	3	applied	\N	\N	\N	\N	70940	70940	70941
17451	22645	4	applied	\N	\N	\N	\N	70951	70951	70952
17451	23449	5	applied	\N	\N	\N	\N	73027	73027	72992
17451	23450	6	applied	\N	\N	\N	\N	73028	73028	72994
17451	23451	7	applied	\N	\N	\N	\N	73029	73029	72996
17451	23452	8	applied	\N	\N	\N	\N	73030	73030	72998
17451	23453	9	applied	\N	\N	\N	\N	73031	73031	73000
17451	23454	10	applied	\N	\N	\N	\N	73032	73032	73002
17451	23455	11	applied	\N	\N	\N	\N	73033	73033	73004
17451	23394	12	applied	\N	\N	\N	\N	73034	73034	72801
17388	23221	61	applied	\N	\N	\N	\N	72348	72348	72593
17388	23222	62	applied	\N	\N	\N	\N	72350	72350	62235
17388	23228	63	applied	\N	\N	\N	\N	72358	72358	72594
17388	23231	64	applied	\N	\N	\N	\N	72365	72365	62250
17388	23234	65	applied	\N	\N	\N	\N	72369	72369	62255
17388	23236	66	applied	\N	\N	\N	\N	72377	72377	72595
17388	23240	67	applied	\N	\N	\N	\N	72383	72383	62276
17388	23243	68	applied	\N	\N	\N	\N	72391	72391	62278
17388	23246	69	applied	\N	\N	\N	\N	72400	72400	62288
17388	23251	70	applied	\N	\N	\N	\N	72416	72416	62290
17388	23260	71	applied	\N	\N	\N	\N	72432	72432	72596
17388	23261	72	applied	\N	\N	\N	\N	72433	72433	62306
17388	23262	73	applied	\N	\N	\N	\N	72435	72435	62312
17388	23265	74	applied	\N	\N	\N	\N	72444	72444	72597
17388	23268	75	applied	\N	\N	\N	\N	72452	72452	62336
17388	23271	76	applied	\N	\N	\N	\N	72460	72460	72349
17388	23276	77	applied	\N	\N	\N	\N	72472	72472	62350
17388	23277	78	applied	\N	\N	\N	\N	72473	72473	62352
17388	23284	79	applied	\N	\N	\N	\N	72490	72490	72598
17388	23286	80	applied	\N	\N	\N	\N	72501	72501	62365
17388	23289	81	applied	\N	\N	\N	\N	72507	72507	62372
17388	23295	82	applied	\N	\N	\N	\N	72519	72519	62387
17388	23296	83	applied	\N	\N	\N	\N	72521	72521	62389
17388	23301	84	applied	\N	\N	\N	\N	72533	72533	72599
17388	23302	85	applied	\N	\N	\N	\N	72535	72535	62395
17388	23309	86	applied	\N	\N	\N	\N	72550	72550	62401
17388	23310	87	applied	\N	\N	\N	\N	72552	72552	62416
17388	23313	88	applied	\N	\N	\N	\N	72560	72560	62418
17388	23316	89	applied	\N	\N	\N	\N	72569	72569	72600
17388	23318	90	applied	\N	\N	\N	\N	72576	72576	62439
17388	23325	91	applied	\N	\N	\N	\N	72601	72601	62441
17388	23326	92	applied	\N	\N	\N	\N	72602	72602	72603
17388	23327	93	applied	\N	\N	\N	\N	72604	72604	62455
17388	23328	94	applied	\N	\N	\N	\N	72605	72605	72606
17388	23180	95	applied	\N	\N	\N	\N	72247	72247	72384
17388	23182	96	applied	\N	\N	\N	\N	72254	72254	72390
17388	23185	97	applied	\N	\N	\N	\N	72258	72258	72607
17388	23188	98	applied	\N	\N	\N	\N	72265	72265	62514
17388	23190	99	applied	\N	\N	\N	\N	72270	72270	62523
17388	23197	100	applied	\N	\N	\N	\N	72286	72286	62534
17388	23198	101	applied	\N	\N	\N	\N	72287	72287	62538
17388	23200	102	applied	\N	\N	\N	\N	72297	72297	62553
17388	23211	103	applied	\N	\N	\N	\N	72324	72324	62557
17388	23216	104	applied	\N	\N	\N	\N	72337	72337	62569
17388	23217	105	applied	\N	\N	\N	\N	72338	72338	62577
17388	23223	106	applied	\N	\N	\N	\N	72351	72351	72608
17388	23224	107	applied	\N	\N	\N	\N	72352	72352	72436
17388	23225	108	applied	\N	\N	\N	\N	72353	72353	72443
17388	23227	109	applied	\N	\N	\N	\N	72357	72357	72609
17388	23230	110	applied	\N	\N	\N	\N	72364	72364	62627
17388	23233	111	applied	\N	\N	\N	\N	72368	72368	62631
17388	23237	112	applied	\N	\N	\N	\N	72378	72378	62648
17388	23239	113	applied	\N	\N	\N	\N	72382	72382	62652
17388	23242	114	applied	\N	\N	\N	\N	72389	72389	62656
17388	23245	115	applied	\N	\N	\N	\N	72399	72399	62674
17388	23248	116	applied	\N	\N	\N	\N	72408	72408	62684
17388	23250	117	applied	\N	\N	\N	\N	72414	72414	72610
17388	23253	118	applied	\N	\N	\N	\N	72420	72420	72611
17388	23257	119	applied	\N	\N	\N	\N	72429	72429	72491
17388	23258	120	applied	\N	\N	\N	\N	72430	72430	72612
17388	23259	121	applied	\N	\N	\N	\N	72431	72431	72613
17388	23264	122	applied	\N	\N	\N	\N	72442	72442	72614
17388	23267	123	applied	\N	\N	\N	\N	72451	72451	72615
17388	23272	125	applied	\N	\N	\N	\N	72461	72461	72617
17400	23356	0	applied	\N	\N	\N	\N	72695	72695	72696
17400	23357	1	applied	\N	\N	\N	\N	72697	72697	72698
17400	23358	2	applied	\N	\N	\N	\N	72699	72699	72700
17400	23359	3	applied	\N	\N	\N	\N	72701	72701	72702
17400	23360	4	applied	\N	\N	\N	\N	72703	72703	72704
17400	23361	5	applied	\N	\N	\N	\N	72705	72705	72706
17400	23362	6	applied	\N	\N	\N	\N	72707	72707	72708
17400	23363	7	applied	\N	\N	\N	\N	72709	72709	72710
17400	23364	8	applied	\N	\N	\N	\N	72711	72711	72712
17401	23365	0	applied	\N	\N	\N	\N	72717	72717	72718
17401	23366	1	applied	\N	\N	\N	\N	72719	72719	72720
17409	23382	0	applied	\N	\N	\N	\N	72763	72763	72764
17409	23383	1	applied	\N	\N	\N	\N	72765	72765	72766
17409	23384	2	applied	\N	\N	\N	\N	72767	72767	72768
17409	23385	3	applied	\N	\N	\N	\N	72769	72769	72770
17409	23386	4	applied	\N	\N	\N	\N	72771	72771	72772
17412	23387	0	applied	\N	\N	\N	\N	72775	72775	72776
17412	23388	1	applied	\N	\N	\N	\N	72777	72777	72778
17412	23389	2	applied	\N	\N	\N	\N	72779	72779	72780
17418	23394	0	applied	\N	\N	\N	\N	72800	72800	72801
17418	23395	1	applied	\N	\N	\N	\N	72802	72802	72803
17418	23396	2	applied	\N	\N	\N	\N	72804	72804	72805
17423	23399	0	applied	\N	\N	\N	\N	72816	72816	72817
17423	23400	1	applied	\N	\N	\N	\N	72818	72818	72819
17423	23401	2	applied	\N	\N	\N	\N	72820	72820	72821
17423	23402	3	applied	\N	\N	\N	\N	72822	72822	72823
17423	23403	4	applied	\N	\N	\N	\N	72824	72824	72825
17423	23404	5	applied	\N	\N	\N	\N	72826	72826	72827
17428	23417	0	applied	\N	\N	\N	\N	72863	72863	72864
17428	23418	1	applied	\N	\N	\N	\N	72865	72865	72866
17430	23422	0	applied	\N	\N	\N	\N	72879	72879	72880
17430	23423	1	applied	\N	\N	\N	\N	72881	72881	72882
17430	23424	2	applied	\N	\N	\N	\N	72883	72883	72884
17430	23425	3	applied	\N	\N	\N	\N	72885	72885	72886
17433	23426	0	applied	\N	\N	\N	\N	72918	72918	72919
17433	23427	1	applied	\N	\N	\N	\N	72920	72920	72921
17433	23428	2	applied	\N	\N	\N	\N	72922	72922	72923
17447	23440	0	applied	\N	\N	\N	\N	72967	72967	72968
17447	23441	1	applied	\N	\N	\N	\N	72969	72969	72970
17447	23442	2	applied	\N	\N	\N	\N	72971	72971	72972
17447	23443	3	applied	\N	\N	\N	\N	72973	72973	72974
17447	23444	4	applied	\N	\N	\N	\N	72975	72975	72976
17447	23445	5	applied	\N	\N	\N	\N	72977	72977	72978
17448	23446	0	applied	\N	\N	\N	\N	72982	72982	72983
17448	23447	1	applied	\N	\N	\N	\N	72984	72984	72985
17453	23472	0	applied	\N	\N	\N	\N	73056	73056	73057
17453	23473	1	applied	\N	\N	\N	\N	73058	73058	73059
17453	23474	2	applied	\N	\N	\N	\N	73060	73060	73061
17453	23475	3	applied	\N	\N	\N	\N	73062	73062	73063
17453	23476	4	applied	\N	\N	\N	\N	73064	73064	73065
17453	23477	5	applied	\N	\N	\N	\N	73066	73066	73067
17453	23478	6	applied	\N	\N	\N	\N	73068	73068	73069
17456	23487	0	applied	\N	\N	\N	\N	73092	73092	73093
17456	23488	1	applied	\N	\N	\N	\N	73094	73094	73095
17456	23489	2	applied	\N	\N	\N	\N	73096	73096	73097
17456	23490	3	applied	\N	\N	\N	\N	73098	73098	73099
17422	23400	1	applied	\N	\N	\N	\N	72818	72818	72819
17422	23401	2	applied	\N	\N	\N	\N	72820	72820	72821
17422	23402	3	applied	\N	\N	\N	\N	72822	72822	72823
17422	23403	4	applied	\N	\N	\N	\N	72824	72824	72825
17422	23404	5	applied	\N	\N	\N	\N	72826	72826	72827
17425	23405	0	applied	\N	\N	\N	\N	72833	72833	72834
17425	23406	1	applied	\N	\N	\N	\N	72835	72835	72836
17425	23407	2	applied	\N	\N	\N	\N	72837	72837	72838
17425	23408	3	applied	\N	\N	\N	\N	72839	72839	72840
17427	23417	0	applied	\N	\N	\N	\N	72863	72863	72864
17427	23418	1	applied	\N	\N	\N	\N	72865	72865	72866
17432	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17432	23159	1	applied	\N	\N	\N	\N	72200	72200	72201
17432	23394	2	applied	\N	\N	\N	\N	72800	72800	72801
17432	23160	3	applied	\N	\N	\N	\N	72202	72202	72203
17432	23165	4	applied	\N	\N	\N	\N	72211	72211	72212
17432	23168	5	applied	\N	\N	\N	\N	72217	72217	72218
17432	23170	6	applied	\N	\N	\N	\N	72223	72223	72224
17432	23174	7	applied	\N	\N	\N	\N	72233	72233	72234
17432	23176	8	applied	\N	\N	\N	\N	72237	72237	72238
17432	23423	9	applied	\N	\N	\N	\N	72881	72881	72889
17432	23179	10	applied	\N	\N	\N	\N	72245	72245	72246
17432	23181	11	applied	\N	\N	\N	\N	72252	72252	72253
17432	23184	12	applied	\N	\N	\N	\N	72256	72256	72257
17432	23187	13	applied	\N	\N	\N	\N	72263	72263	72264
17432	23189	14	applied	\N	\N	\N	\N	72268	72268	72269
17432	23193	15	applied	\N	\N	\N	\N	72280	72280	72281
17432	23194	16	applied	\N	\N	\N	\N	72282	72282	72283
17432	23199	17	applied	\N	\N	\N	\N	72295	72295	72296
17432	23209	18	applied	\N	\N	\N	\N	72321	72321	72322
17432	23212	19	applied	\N	\N	\N	\N	72329	72329	72330
17432	23213	20	applied	\N	\N	\N	\N	72331	72331	72332
17432	23219	21	applied	\N	\N	\N	\N	72344	72344	72345
17432	23220	22	applied	\N	\N	\N	\N	72346	72346	72347
17432	23226	23	applied	\N	\N	\N	\N	72355	72355	72356
17432	23229	24	applied	\N	\N	\N	\N	72362	72362	72363
17432	23232	25	applied	\N	\N	\N	\N	72366	72366	72367
17432	23235	26	applied	\N	\N	\N	\N	72375	72375	72376
17432	23238	27	applied	\N	\N	\N	\N	72380	72380	72381
17432	23241	28	applied	\N	\N	\N	\N	72387	72387	72388
17432	23244	30	applied	\N	\N	\N	\N	72397	72397	72398
17432	23247	31	applied	\N	\N	\N	\N	72406	72406	72407
17432	23249	32	applied	\N	\N	\N	\N	72412	72412	72413
17432	23252	33	applied	\N	\N	\N	\N	72418	72418	72419
17432	23254	34	applied	\N	\N	\N	\N	72423	72423	72424
17432	23255	35	applied	\N	\N	\N	\N	72425	72425	72426
17432	23256	36	applied	\N	\N	\N	\N	72427	72427	72428
17432	23263	37	applied	\N	\N	\N	\N	72440	72440	72441
17432	23266	38	applied	\N	\N	\N	\N	72449	72449	72450
17432	23269	39	applied	\N	\N	\N	\N	72456	72456	72457
17432	23270	40	applied	\N	\N	\N	\N	72458	72458	72459
17432	23274	41	applied	\N	\N	\N	\N	72468	72468	72469
17432	23275	42	applied	\N	\N	\N	\N	72470	72470	72471
17432	23280	43	applied	\N	\N	\N	\N	72479	72479	72480
17432	23282	44	applied	\N	\N	\N	\N	72486	72486	72487
17432	23285	45	applied	\N	\N	\N	\N	72499	72499	72500
17432	23288	46	applied	\N	\N	\N	\N	72505	72505	72506
17432	23291	47	applied	\N	\N	\N	\N	72511	72511	72512
17432	23292	48	applied	\N	\N	\N	\N	72513	72513	72514
17432	23297	49	applied	\N	\N	\N	\N	72525	72525	72526
17432	23298	50	applied	\N	\N	\N	\N	72527	72527	72528
17432	23299	51	applied	\N	\N	\N	\N	72529	72529	72530
17432	23305	52	applied	\N	\N	\N	\N	72542	72542	72543
17432	23306	53	applied	\N	\N	\N	\N	72544	72544	72545
17432	23311	54	applied	\N	\N	\N	\N	72556	72556	72557
17432	23315	55	applied	\N	\N	\N	\N	72567	72567	72568
17432	23317	56	applied	\N	\N	\N	\N	72574	72574	72575
17432	23320	57	applied	\N	\N	\N	\N	72581	72581	72582
17432	23321	58	applied	\N	\N	\N	\N	72583	72583	72584
17432	23322	59	applied	\N	\N	\N	\N	72585	72585	72586
17432	23323	60	applied	\N	\N	\N	\N	72587	72587	72588
17432	23332	61	applied	\N	\N	\N	\N	72637	72637	72638
17432	23333	62	applied	\N	\N	\N	\N	72639	72639	72640
17432	23340	63	applied	\N	\N	\N	\N	72656	72656	72657
17432	23341	64	applied	\N	\N	\N	\N	72658	72658	72659
17432	23345	65	applied	\N	\N	\N	\N	72668	72668	72669
17432	23347	66	applied	\N	\N	\N	\N	72674	72674	72675
17432	23348	67	applied	\N	\N	\N	\N	72676	72676	72677
17432	23349	68	applied	\N	\N	\N	\N	72678	72678	72679
17432	23356	69	applied	\N	\N	\N	\N	72695	72695	72891
17432	23357	70	applied	\N	\N	\N	\N	72697	72697	72892
17432	23358	71	applied	\N	\N	\N	\N	72699	72699	72893
17432	23367	72	applied	\N	\N	\N	\N	72724	72724	72894
17432	23370	73	applied	\N	\N	\N	\N	72732	72732	72895
17432	23373	74	applied	\N	\N	\N	\N	72740	72740	72896
17432	23376	75	applied	\N	\N	\N	\N	72748	72748	72897
17432	23377	76	applied	\N	\N	\N	\N	72750	72750	72898
17432	23382	77	applied	\N	\N	\N	\N	72763	72763	72899
17432	23383	78	applied	\N	\N	\N	\N	72765	72765	72900
17432	23387	79	applied	\N	\N	\N	\N	72775	72775	72901
17432	23399	80	applied	\N	\N	\N	\N	72816	72816	72902
17432	23400	81	applied	\N	\N	\N	\N	72818	72818	72903
17432	23407	82	applied	\N	\N	\N	\N	72837	72837	72904
17432	23411	83	applied	\N	\N	\N	\N	72849	72849	72905
17432	23412	84	applied	\N	\N	\N	\N	72851	72851	72906
17432	23417	85	applied	\N	\N	\N	\N	72863	72863	72907
17432	23419	86	applied	\N	\N	\N	\N	72871	72871	72908
17432	23422	87	applied	\N	\N	\N	\N	72879	72879	72909
17432	23324	88	applied	\N	\N	1000000000	\N	72589	72589	72590
17432	23161	89	applied	\N	\N	\N	\N	72204	72204	62060
17432	23162	90	applied	\N	\N	\N	\N	72205	72205	72206
17432	23163	91	applied	\N	\N	\N	\N	72207	72207	62083
17432	23167	92	applied	\N	\N	\N	\N	72214	72214	62085
17432	23171	93	applied	\N	\N	\N	\N	72225	72225	72910
17432	23173	94	applied	\N	\N	\N	\N	72230	72230	62098
17432	23177	95	applied	\N	\N	\N	\N	72239	72239	62100
17432	23183	96	applied	\N	\N	\N	\N	72255	72255	62109
17432	23186	97	applied	\N	\N	\N	\N	72260	72260	62111
17432	23191	98	applied	\N	\N	\N	\N	72271	72271	72911
17432	23195	99	applied	\N	\N	\N	\N	72284	72284	62123
17432	23196	100	applied	\N	\N	\N	\N	72285	72285	62132
17432	23210	101	applied	\N	\N	\N	\N	72323	72323	72240
17432	23334	102	applied	\N	\N	\N	\N	72641	72641	72642
17432	23164	103	applied	\N	\N	\N	\N	72208	72208	62153
17432	23166	104	applied	\N	\N	\N	\N	72213	72213	62163
17432	23169	105	applied	\N	\N	\N	\N	72219	72219	62167
17432	23172	106	applied	\N	\N	\N	\N	72226	72226	62174
17432	23175	107	applied	\N	\N	\N	\N	72235	72235	62190
17432	23214	108	applied	\N	\N	\N	\N	72333	72333	72259
17432	23215	109	applied	\N	\N	\N	\N	72334	72334	62201
17432	23218	110	applied	\N	\N	\N	\N	72340	72340	62206
17432	23221	111	applied	\N	\N	\N	\N	72348	72348	72912
17432	23222	112	applied	\N	\N	\N	\N	72350	72350	62223
17432	23228	113	applied	\N	\N	\N	\N	72358	72358	62233
17432	23231	114	applied	\N	\N	\N	\N	72365	72365	62243
17432	23234	115	applied	\N	\N	\N	\N	72369	72369	62245
17432	23236	116	applied	\N	\N	\N	\N	72377	72377	72913
17432	23240	117	applied	\N	\N	\N	\N	72383	72383	62257
17432	23243	118	applied	\N	\N	\N	\N	72391	72391	62263
17432	23246	119	applied	\N	\N	\N	\N	72400	72400	72914
17432	23251	120	applied	\N	\N	\N	\N	72416	72416	62280
17432	23260	121	applied	\N	\N	\N	\N	72432	72432	72915
17432	23261	122	applied	\N	\N	\N	\N	72433	72433	62298
17432	23262	123	applied	\N	\N	\N	\N	72435	72435	62300
17432	23265	124	applied	\N	\N	\N	\N	72444	72444	72335
17432	23268	125	applied	\N	\N	\N	\N	72452	72452	62314
17435	23426	0	applied	\N	\N	\N	\N	72918	72918	72919
17435	23427	1	applied	\N	\N	\N	\N	72920	72920	72921
17435	23428	2	applied	\N	\N	\N	\N	72922	72922	72923
17436	23429	0	applied	\N	\N	\N	\N	5821	5821	72930
17436	23430	1	applied	\N	\N	\N	\N	72931	72931	72932
17436	23431	2	applied	\N	\N	\N	\N	72933	72933	72934
17439	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17439	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17439	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17439	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17439	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17439	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17442	23432	0	applied	\N	\N	\N	\N	72938	72938	72939
17442	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17442	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17442	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17442	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17442	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17444	23438	0	applied	\N	\N	\N	\N	72961	72961	72962
17444	23439	1	applied	\N	\N	\N	\N	72963	72963	72964
17445	23440	0	applied	\N	\N	\N	\N	72967	72967	72968
17445	23441	1	applied	\N	\N	\N	\N	72969	72969	72970
17445	23442	2	applied	\N	\N	\N	\N	72971	72971	72972
17445	23443	3	applied	\N	\N	\N	\N	72973	72973	72974
17445	23444	4	applied	\N	\N	\N	\N	72975	72975	72976
17445	23445	5	applied	\N	\N	\N	\N	72977	72977	72978
17452	23466	0	applied	\N	\N	\N	\N	73043	73043	73044
17452	23467	1	applied	\N	\N	\N	\N	73045	73045	73046
17452	23468	2	applied	\N	\N	\N	\N	73047	73047	73048
17452	23469	3	applied	\N	\N	\N	\N	73049	73049	73050
17452	23470	4	applied	\N	\N	\N	\N	73051	73051	73052
17452	23471	5	applied	\N	\N	\N	\N	73053	73053	73054
17458	23487	0	applied	\N	\N	\N	\N	73092	73092	73093
17458	23488	1	applied	\N	\N	\N	\N	73094	73094	73095
17458	23489	2	applied	\N	\N	\N	\N	73096	73096	73097
17458	23490	3	applied	\N	\N	\N	\N	73098	73098	73099
17458	23491	4	applied	\N	\N	\N	\N	73100	73100	73101
17458	23506	5	applied	\N	\N	\N	\N	73132	73132	73133
17458	23507	6	applied	\N	\N	\N	\N	73134	73134	73135
17458	23492	7	applied	\N	\N	\N	\N	73102	73102	73103
17458	23493	8	applied	\N	\N	\N	\N	73104	73104	73105
17458	23494	9	applied	\N	\N	\N	\N	73106	73106	73107
17458	23495	10	applied	\N	\N	\N	\N	73108	73108	73109
17458	23496	11	applied	\N	\N	\N	\N	73110	73110	73111
17458	23497	12	applied	\N	\N	\N	\N	73112	73112	73113
17458	23498	13	applied	\N	\N	\N	\N	73114	73114	73115
17458	23499	14	applied	\N	\N	\N	\N	73116	73116	73117
17458	23500	15	applied	\N	\N	\N	\N	73118	73118	73119
17458	23501	16	applied	\N	\N	\N	\N	73120	73120	73121
17458	23508	17	applied	\N	\N	\N	\N	73136	73136	73137
17458	23509	18	applied	\N	\N	\N	\N	73138	73138	73139
17458	23510	19	applied	\N	\N	\N	\N	73140	73140	73141
17458	23511	20	applied	\N	\N	\N	\N	73142	73142	73143
17458	23512	21	applied	\N	\N	\N	\N	73144	73144	73145
17458	23513	22	applied	\N	\N	\N	\N	73146	73146	73147
17458	23514	23	applied	\N	\N	\N	\N	73148	73148	73149
17458	23515	24	applied	\N	\N	\N	\N	73150	73150	73151
17458	23516	25	applied	\N	\N	\N	\N	73152	73152	73153
17458	23517	26	applied	\N	\N	\N	\N	73154	73154	73155
17458	23518	27	applied	\N	\N	\N	\N	73156	73156	73157
17458	23502	28	applied	\N	\N	\N	\N	73122	73122	73123
17458	23503	29	applied	\N	\N	\N	\N	73124	73124	73125
17458	23519	30	applied	\N	\N	\N	\N	73158	73158	73159
17458	23504	31	applied	\N	\N	\N	\N	73126	73126	73160
17458	23505	32	applied	\N	\N	\N	\N	73128	73128	73161
17458	23520	33	applied	\N	\N	\N	\N	73162	73162	73163
17458	23521	34	applied	\N	\N	\N	\N	73164	73164	73165
17458	23522	35	applied	\N	\N	\N	\N	73166	73166	73167
17463	23506	0	applied	\N	\N	\N	\N	73132	73132	73133
17463	23507	1	applied	\N	\N	\N	\N	73134	73134	73135
17463	23529	2	applied	\N	\N	\N	\N	73183	73183	73184
17463	23508	3	applied	\N	\N	\N	\N	73136	73136	73137
17463	23509	4	applied	\N	\N	\N	\N	73138	73138	73139
17463	23510	5	applied	\N	\N	\N	\N	73140	73140	73141
17463	23511	6	applied	\N	\N	\N	\N	73142	73142	73143
17463	23512	7	applied	\N	\N	\N	\N	73144	73144	73145
17463	23513	8	applied	\N	\N	\N	\N	73146	73146	73147
17463	23514	9	applied	\N	\N	\N	\N	73148	73148	73149
17463	23515	10	applied	\N	\N	\N	\N	73150	73150	73151
17463	23516	11	applied	\N	\N	\N	\N	73152	73152	73153
17463	23517	12	applied	\N	\N	\N	\N	73154	73154	73155
17463	23518	13	applied	\N	\N	\N	\N	73156	73156	73157
17463	23523	14	applied	\N	\N	\N	\N	73171	73171	73172
17463	23524	15	applied	\N	\N	\N	\N	73173	73173	73174
17463	23525	16	applied	\N	\N	\N	\N	73175	73175	73176
17463	23526	17	applied	\N	\N	\N	\N	73177	73177	73178
17463	23527	18	applied	\N	\N	\N	\N	73179	73179	73180
17463	23519	19	applied	\N	\N	\N	\N	73158	73158	73161
17463	23520	20	applied	\N	\N	\N	\N	73162	73162	73163
17463	23530	21	applied	\N	\N	\N	\N	73185	73185	73192
17463	23521	22	applied	\N	\N	\N	\N	73164	73164	73193
17463	23522	23	applied	\N	\N	\N	\N	73166	73166	73186
17463	23531	24	applied	\N	\N	\N	\N	73187	73187	73188
17464	23532	0	applied	\N	\N	\N	\N	73196	73196	73197
17464	23533	1	applied	\N	\N	\N	\N	73198	73198	73199
17464	23534	2	applied	\N	\N	\N	\N	73200	73200	73201
17464	23535	3	applied	\N	\N	\N	\N	73202	73202	73203
17464	23536	4	applied	\N	\N	\N	\N	73204	73204	73205
17464	23537	5	applied	\N	\N	\N	\N	73206	73206	73207
17464	23538	6	applied	\N	\N	\N	\N	73208	73208	73209
17464	23539	7	applied	\N	\N	\N	\N	73210	73210	73211
17464	23540	8	applied	\N	\N	\N	\N	73212	73212	73213
17464	23541	10	applied	\N	\N	\N	\N	73215	73215	73216
17464	23542	11	applied	\N	\N	\N	\N	73217	73217	73218
17443	23433	1	applied	\N	\N	\N	\N	72940	72940	72941
17443	23434	2	applied	\N	\N	\N	\N	72942	72942	72943
17443	23435	3	applied	\N	\N	\N	\N	72944	72944	72945
17443	23436	5	applied	\N	\N	\N	\N	72947	72947	72948
17443	23437	6	applied	\N	\N	\N	\N	72949	72949	72950
17446	23440	0	applied	\N	\N	\N	\N	72967	72967	72968
17446	23441	1	applied	\N	\N	\N	\N	72969	72969	72970
17446	23442	2	applied	\N	\N	\N	\N	72971	72971	72972
17446	23443	3	applied	\N	\N	\N	\N	72973	72973	72974
17446	23444	4	applied	\N	\N	\N	\N	72975	72975	72976
17446	23445	5	applied	\N	\N	\N	\N	72977	72977	72978
17450	23448	0	applied	\N	\N	1000000000	\N	72989	72989	72990
17450	23449	1	applied	\N	\N	\N	\N	72991	72991	72992
17450	23450	2	applied	\N	\N	\N	\N	72993	72993	72994
17450	23451	3	applied	\N	\N	\N	\N	72995	72995	72996
17450	23452	4	applied	\N	\N	\N	\N	72997	72997	72998
17450	23453	5	applied	\N	\N	\N	\N	72999	72999	73000
17450	23454	6	applied	\N	\N	\N	\N	73001	73001	73002
17450	23455	7	applied	\N	\N	\N	\N	73003	73003	73004
17450	23456	8	applied	\N	\N	\N	\N	73005	73005	73006
17450	23457	9	applied	\N	\N	\N	\N	73007	73007	73008
17450	23458	10	applied	\N	\N	\N	\N	73009	73009	73010
17450	23459	11	applied	\N	\N	\N	\N	73011	73011	73012
17450	23460	12	applied	\N	\N	\N	\N	73013	73013	73014
17450	23461	13	applied	\N	\N	\N	\N	73015	73015	73016
17450	23462	14	applied	\N	\N	\N	\N	73017	73017	73018
17450	23463	15	applied	\N	\N	\N	\N	73019	73019	73020
17450	23464	16	applied	\N	\N	\N	\N	73021	73021	73022
17450	23465	17	applied	\N	\N	\N	\N	73023	73023	73024
17455	23479	0	applied	\N	\N	\N	\N	73074	73074	73075
17455	23480	1	applied	\N	\N	\N	\N	73076	73076	73077
17455	23481	2	applied	\N	\N	\N	\N	73078	73078	73079
17455	23482	3	applied	\N	\N	\N	\N	73080	73080	73081
17455	23483	4	applied	\N	\N	\N	\N	73082	73082	73083
17455	23484	5	applied	\N	\N	\N	\N	73084	73084	73085
17455	23485	6	applied	\N	\N	\N	\N	73086	73086	73087
17455	23486	7	applied	\N	\N	\N	\N	73088	73088	73089
17460	23523	0	applied	\N	\N	\N	\N	73171	73171	73172
17460	23524	1	applied	\N	\N	\N	\N	73173	73173	73174
17460	23525	2	applied	\N	\N	\N	\N	73175	73175	73176
17460	23526	3	applied	\N	\N	\N	\N	73177	73177	73178
17460	23527	4	applied	\N	\N	\N	\N	73179	73179	73180
17460	23528	5	applied	\N	\N	\N	\N	73181	73181	73182
17460	23529	6	applied	\N	\N	\N	\N	73183	73183	73184
17460	23530	7	applied	\N	\N	\N	\N	73185	73185	73186
17460	23531	8	applied	\N	\N	\N	\N	73187	73187	73188
17465	23538	0	applied	\N	\N	\N	\N	73208	73208	73209
17465	23539	1	applied	\N	\N	\N	\N	73210	73210	73211
17465	23542	2	applied	\N	\N	\N	\N	73217	73217	73218
17465	23543	3	applied	\N	\N	\N	\N	73219	73219	73220
17465	23544	4	applied	\N	\N	\N	\N	73221	73221	73222
17467	23532	0	applied	\N	\N	\N	\N	73196	73196	73197
17467	23533	1	applied	\N	\N	\N	\N	73198	73198	73199
17467	23534	3	applied	\N	\N	\N	\N	73200	73200	73201
17467	23535	4	applied	\N	\N	\N	\N	73202	73202	73203
17467	23536	5	applied	\N	\N	\N	\N	73204	73204	73205
17467	23537	6	applied	\N	\N	\N	\N	73206	73206	73207
17467	23545	7	applied	\N	\N	\N	\N	73293	73293	73294
17467	23546	8	applied	\N	\N	\N	\N	73295	73295	73296
17467	23540	9	applied	\N	\N	\N	\N	73212	73212	73213
17467	23541	10	applied	\N	\N	\N	\N	73215	73215	73216
17467	23547	11	applied	\N	\N	\N	\N	73297	73297	47675
17467	23548	12	applied	\N	\N	\N	\N	73298	73298	73299
17472	23536	0	applied	\N	\N	\N	\N	73204	73204	73205
17472	23537	1	applied	\N	\N	\N	\N	73206	73206	73207
17472	23545	2	applied	\N	\N	\N	\N	73293	73293	73294
17472	23546	3	applied	\N	\N	\N	\N	73295	73295	73296
17472	23563	4	applied	\N	\N	\N	\N	73333	73333	73334
17472	23540	5	applied	\N	\N	\N	\N	73212	73212	73213
17472	23541	6	applied	\N	\N	\N	\N	73215	73215	73216
17472	23549	7	applied	\N	\N	\N	\N	73302	73302	73303
17472	23550	8	applied	\N	\N	\N	\N	73304	73304	73305
17472	23551	9	applied	\N	\N	\N	\N	73306	73306	73307
17472	23552	10	applied	\N	\N	\N	\N	73308	73308	73309
17472	23553	11	applied	\N	\N	\N	\N	73310	73310	73311
17472	23554	12	applied	\N	\N	\N	\N	73312	73312	73313
17472	23555	13	applied	\N	\N	\N	\N	73314	73314	73315
17472	23556	14	applied	\N	\N	\N	\N	73316	73316	73317
17472	23557	15	applied	\N	\N	\N	\N	73318	73318	73319
17472	23558	16	applied	\N	\N	\N	\N	73320	73320	73321
17472	23559	17	applied	\N	\N	\N	\N	73322	73322	73323
17472	23560	18	applied	\N	\N	\N	\N	73324	73324	73325
17472	23564	19	applied	\N	\N	\N	\N	73335	73335	73336
17472	23565	20	applied	\N	\N	\N	\N	73337	73337	73338
17472	23566	21	applied	\N	\N	\N	\N	73339	73339	73340
17472	23567	22	applied	\N	\N	\N	\N	73341	73341	73342
17472	23561	23	applied	\N	\N	\N	\N	73326	73326	73327
17472	23547	24	applied	\N	\N	\N	\N	73297	73297	47675
17472	23562	25	applied	\N	\N	\N	\N	73328	73328	73329
17472	23548	26	applied	\N	\N	\N	\N	73298	73298	73330
17472	23568	27	applied	\N	\N	\N	\N	73343	73343	73344
17472	23569	28	applied	\N	\N	\N	\N	73345	73345	73346
17474	23536	0	applied	\N	\N	\N	\N	73204	73204	73205
17474	23537	1	applied	\N	\N	\N	\N	73206	73206	73207
17474	23545	2	applied	\N	\N	\N	\N	73293	73293	73294
17474	23546	3	applied	\N	\N	\N	\N	73295	73295	73296
17474	23563	4	applied	\N	\N	\N	\N	73333	73333	73334
17474	23540	5	applied	\N	\N	\N	\N	73212	73212	73213
17474	23541	6	applied	\N	\N	\N	\N	73215	73215	73216
17474	23549	7	applied	\N	\N	\N	\N	73302	73302	73303
17474	23550	8	applied	\N	\N	\N	\N	73304	73304	73305
17474	23551	9	applied	\N	\N	\N	\N	73306	73306	73307
17474	23552	10	applied	\N	\N	\N	\N	73308	73308	73309
17474	23553	11	applied	\N	\N	\N	\N	73310	73310	73311
17474	23554	12	applied	\N	\N	\N	\N	73312	73312	73313
17474	23555	13	applied	\N	\N	\N	\N	73314	73314	73315
17474	23556	14	applied	\N	\N	\N	\N	73316	73316	73317
17474	23557	15	applied	\N	\N	\N	\N	73318	73318	73319
17474	23558	16	applied	\N	\N	\N	\N	73320	73320	73321
17474	23559	17	applied	\N	\N	\N	\N	73322	73322	73323
17474	23560	18	applied	\N	\N	\N	\N	73324	73324	73325
17474	23564	19	applied	\N	\N	\N	\N	73335	73335	73336
17474	23565	20	applied	\N	\N	\N	\N	73337	73337	73338
17474	23566	21	applied	\N	\N	\N	\N	73339	73339	73340
17474	23567	22	applied	\N	\N	\N	\N	73341	73341	73342
17474	23561	23	applied	\N	\N	\N	\N	73326	73326	73327
17474	23547	24	applied	\N	\N	\N	\N	73297	73297	47675
17474	23562	25	applied	\N	\N	\N	\N	73328	73328	73329
17474	23548	26	applied	\N	\N	\N	\N	73298	73298	73330
17474	23568	27	applied	\N	\N	\N	\N	73343	73343	73344
17451	22640	13	applied	\N	\N	1000000000	\N	70936	70936	70937
17451	23456	14	applied	\N	\N	\N	\N	73035	73035	73006
17451	23457	15	applied	\N	\N	\N	\N	73036	73036	73008
17451	23458	16	applied	\N	\N	\N	\N	73037	73037	73010
17451	23459	17	applied	\N	\N	\N	\N	73038	73038	73012
17451	22648	18	applied	\N	\N	\N	\N	70958	70958	70959
17451	22698	19	applied	\N	\N	\N	\N	71076	71076	71077
17451	22790	20	applied	\N	\N	\N	\N	71353	71353	71354
17451	22806	21	applied	\N	\N	1000000000	\N	71396	71396	71397
17451	22830	22	applied	\N	\N	1000000000	\N	71441	71441	71442
17451	22649	23	applied	\N	\N	\N	\N	70960	70960	70961
17451	22655	24	applied	\N	\N	\N	\N	70971	70971	70972
17451	22658	25	applied	\N	\N	\N	\N	70976	70976	70977
17451	22661	26	applied	\N	\N	\N	\N	70981	70981	70982
17451	22850	27	applied	\N	\N	\N	\N	71505	71505	71487
17451	22666	28	applied	\N	\N	\N	\N	70999	70999	71000
17451	22667	29	applied	\N	\N	\N	\N	71001	71001	71002
17451	22668	30	applied	\N	\N	\N	\N	71003	71003	71004
17451	22669	31	applied	\N	\N	\N	\N	71005	71005	71006
17451	22678	32	applied	\N	\N	\N	\N	71023	71023	71024
17451	22681	33	applied	\N	\N	\N	\N	71029	71029	71030
17451	22684	34	applied	\N	\N	\N	\N	71035	71035	71036
17451	22688	35	applied	\N	\N	\N	\N	71049	71049	71050
17451	22690	36	applied	\N	\N	\N	\N	71056	71056	71057
17451	22693	37	applied	\N	\N	\N	\N	71066	71066	71067
17451	22696	38	applied	\N	\N	\N	\N	71072	71072	71073
17451	22697	39	applied	\N	\N	\N	\N	71074	71074	71075
17451	22704	40	applied	\N	\N	\N	\N	71088	71088	71089
17451	22705	41	applied	\N	\N	\N	\N	71090	71090	71091
17451	22706	42	applied	\N	\N	\N	\N	71092	71092	71093
17451	22716	43	applied	\N	\N	\N	\N	71108	71108	71109
17451	22719	44	applied	\N	\N	\N	\N	71117	71117	71118
17451	23423	45	applied	\N	\N	\N	\N	73039	73039	72889
17451	22723	47	applied	\N	\N	\N	\N	71123	71123	71124
17451	22726	48	applied	\N	\N	\N	\N	71130	71130	71131
17451	22727	49	applied	\N	\N	\N	\N	71132	71132	71133
17451	22732	50	applied	\N	\N	\N	\N	71171	71171	71172
17451	22735	51	applied	\N	\N	\N	\N	71178	71178	71179
17451	22738	52	applied	\N	\N	\N	\N	71186	71186	71187
17451	22741	53	applied	\N	\N	\N	\N	71193	71193	71194
17451	22744	54	applied	\N	\N	\N	\N	71201	71201	71202
17451	22746	55	applied	\N	\N	\N	\N	71205	71205	71206
17451	22748	56	applied	\N	\N	\N	\N	71211	71211	71212
17451	22749	57	applied	\N	\N	\N	\N	71213	71213	71214
17451	22753	58	applied	\N	\N	\N	\N	71236	71236	71237
17451	22755	59	applied	\N	\N	\N	\N	71243	71243	71244
17451	22757	60	applied	\N	\N	\N	\N	71250	71250	71251
17451	23156	61	applied	\N	\N	\N	\N	72194	72194	72195
17451	22760	62	applied	\N	\N	\N	\N	71257	71257	71258
17451	22762	63	applied	\N	\N	\N	\N	71262	71262	71263
17451	22764	64	applied	\N	\N	\N	\N	71268	71268	71269
17451	22768	65	applied	\N	\N	\N	\N	71278	71278	71279
17451	22770	66	applied	\N	\N	\N	\N	71284	71284	71285
17451	22772	67	applied	\N	\N	\N	\N	71300	71300	71301
17451	22775	68	applied	\N	\N	\N	\N	71307	71307	71308
17451	22777	69	applied	\N	\N	\N	\N	71313	71313	71314
17451	22779	70	applied	\N	\N	\N	\N	71317	71317	71318
17451	22782	71	applied	\N	\N	\N	\N	71324	71324	71325
17451	22784	72	applied	\N	\N	\N	\N	71330	71330	71331
17451	22786	73	applied	\N	\N	\N	\N	71336	71336	71337
17451	22789	74	applied	\N	\N	\N	\N	71349	71349	71350
17451	22791	75	applied	\N	\N	\N	\N	71355	71355	71356
17451	22793	76	applied	\N	\N	\N	\N	71360	71360	71361
17451	22796	77	applied	\N	\N	\N	\N	71369	71369	71370
17451	22797	78	applied	\N	\N	\N	\N	71371	71371	71372
17451	22800	79	applied	\N	\N	\N	\N	71378	71378	71379
17451	22802	80	applied	\N	\N	\N	\N	71384	71384	71385
17451	22804	81	applied	\N	\N	\N	\N	71390	71390	71391
17451	22807	82	applied	\N	\N	\N	\N	71398	71398	71399
17451	22809	83	applied	\N	\N	\N	\N	71402	71402	71403
17451	22813	84	applied	\N	\N	\N	\N	71411	71411	71412
17451	22814	85	applied	\N	\N	\N	\N	71413	71413	71414
17451	22815	86	applied	\N	\N	\N	\N	71415	71415	71416
17451	22822	87	applied	\N	\N	\N	\N	71424	71424	71425
17451	22825	88	applied	\N	\N	\N	\N	71431	71431	71432
17451	22828	89	applied	\N	\N	\N	\N	71437	71437	71438
17451	22829	90	applied	\N	\N	\N	\N	71439	71439	71440
17451	22836	91	applied	\N	\N	\N	\N	71452	71452	71453
17451	22837	92	applied	\N	\N	\N	\N	71454	71454	71455
17451	22841	93	applied	\N	\N	\N	\N	71463	71463	71464
17451	22845	94	applied	\N	\N	\N	\N	71475	71475	71476
17451	22848	95	applied	\N	\N	\N	\N	71482	71482	71483
17451	22849	96	applied	\N	\N	\N	\N	71484	71484	71485
17451	22859	97	applied	\N	\N	\N	\N	71509	71509	71510
17451	22860	98	applied	\N	\N	\N	\N	71511	71511	71512
17451	22865	99	applied	\N	\N	\N	\N	71522	71522	71523
17451	22869	100	applied	\N	\N	\N	\N	71530	71530	71531
17451	22870	101	applied	\N	\N	\N	\N	71532	71532	71533
17451	22871	102	applied	\N	\N	\N	\N	71534	71534	71535
17451	22879	103	applied	\N	\N	\N	\N	71549	71549	71550
17451	22882	104	applied	\N	\N	\N	\N	71553	71553	71554
17451	22885	105	applied	\N	\N	\N	\N	71560	71560	71561
17451	22886	106	applied	\N	\N	\N	\N	71562	71562	71563
17451	22887	107	applied	\N	\N	\N	\N	71568	71568	71569
17451	22895	108	applied	\N	\N	\N	\N	71584	71584	71585
17451	22896	109	applied	\N	\N	\N	\N	71586	71586	71587
17451	22902	110	applied	\N	\N	\N	\N	71598	71598	71599
17451	22905	111	applied	\N	\N	\N	\N	71605	71605	71913
17451	22908	112	applied	\N	\N	\N	\N	71611	71611	71914
17451	22912	113	applied	\N	\N	\N	\N	71625	71625	71915
17451	22915	114	applied	\N	\N	\N	\N	71632	71632	71916
17451	22921	115	applied	\N	\N	\N	\N	71648	71648	71917
17451	22922	116	applied	\N	\N	\N	\N	71650	71650	71918
17451	22923	117	applied	\N	\N	\N	\N	71652	71652	71919
17451	22930	118	applied	\N	\N	\N	\N	71669	71669	71920
17451	22934	119	applied	\N	\N	\N	\N	71676	71676	71921
17451	22937	120	applied	\N	\N	\N	\N	71683	71683	71922
17451	22940	121	applied	\N	\N	\N	\N	71691	71691	71923
17451	22944	122	applied	\N	\N	\N	\N	71702	71702	71924
17451	22947	123	applied	\N	\N	\N	\N	71709	71709	71925
17451	22948	124	applied	\N	\N	\N	\N	71711	71711	71926
17451	22953	125	applied	\N	\N	\N	\N	71719	71719	71927
17454	23472	0	applied	\N	\N	\N	\N	73056	73056	73057
17454	23473	1	applied	\N	\N	\N	\N	73058	73058	73059
17454	23474	2	applied	\N	\N	\N	\N	73060	73060	73061
17454	23475	3	applied	\N	\N	\N	\N	73062	73062	73063
17454	23476	4	applied	\N	\N	\N	\N	73064	73064	73065
17454	23477	5	applied	\N	\N	\N	\N	73066	73066	73067
17454	23478	6	applied	\N	\N	\N	\N	73068	73068	73069
17456	23491	4	applied	\N	\N	\N	\N	73100	73100	73101
17456	23492	5	applied	\N	\N	\N	\N	73102	73102	73103
17456	23493	6	applied	\N	\N	\N	\N	73104	73104	73105
17456	23494	7	applied	\N	\N	\N	\N	73106	73106	73107
17456	23495	8	applied	\N	\N	\N	\N	73108	73108	73109
17456	23496	9	applied	\N	\N	\N	\N	73110	73110	73111
17456	23497	10	applied	\N	\N	\N	\N	73112	73112	73113
17456	23498	11	applied	\N	\N	\N	\N	73114	73114	73115
17456	23499	12	applied	\N	\N	\N	\N	73116	73116	73117
17456	23500	13	applied	\N	\N	\N	\N	73118	73118	73119
17456	23501	14	applied	\N	\N	\N	\N	73120	73120	73121
17456	23502	15	applied	\N	\N	\N	\N	73122	73122	73123
17456	23503	16	applied	\N	\N	\N	\N	73124	73124	73125
17456	23504	17	applied	\N	\N	\N	\N	73126	73126	73127
17456	23505	18	applied	\N	\N	\N	\N	73128	73128	73129
17461	23523	0	applied	\N	\N	\N	\N	73171	73171	73172
17461	23524	1	applied	\N	\N	\N	\N	73173	73173	73174
17461	23525	2	applied	\N	\N	\N	\N	73175	73175	73176
17461	23526	3	applied	\N	\N	\N	\N	73177	73177	73178
17461	23527	4	applied	\N	\N	\N	\N	73179	73179	73180
17461	23528	5	applied	\N	\N	\N	\N	73181	73181	73182
17461	23529	6	applied	\N	\N	\N	\N	73183	73183	73184
17461	23530	7	applied	\N	\N	\N	\N	73185	73185	73186
17461	23531	8	applied	\N	\N	\N	\N	73187	73187	73188
17466	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17466	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17466	23449	2	applied	\N	\N	\N	\N	73227	73227	72992
17466	23450	3	applied	\N	\N	\N	\N	73228	73228	72994
17466	23451	4	applied	\N	\N	\N	\N	73229	73229	72996
17466	23452	5	applied	\N	\N	\N	\N	73230	73230	72998
17466	23453	6	applied	\N	\N	\N	\N	73231	73231	73000
17466	23454	7	applied	\N	\N	\N	\N	73232	73232	73002
17466	23455	8	applied	\N	\N	\N	\N	73233	73233	73004
17466	23394	9	applied	\N	\N	\N	\N	72800	72800	72801
17466	23068	10	applied	\N	\N	\N	\N	72001	72001	72002
17466	23072	11	applied	\N	\N	\N	\N	72010	72010	72011
17466	23073	12	applied	\N	\N	\N	\N	72012	72012	72013
17466	23076	13	applied	\N	\N	\N	\N	72018	72018	72019
17466	23078	14	applied	\N	\N	\N	\N	72022	72022	72023
17466	23081	15	applied	\N	\N	\N	\N	72028	72028	72029
17466	23456	16	applied	\N	\N	\N	\N	73234	73234	73006
17466	23457	17	applied	\N	\N	\N	\N	73235	73235	73008
17466	23458	18	applied	\N	\N	\N	\N	73236	73236	73010
17466	23459	19	applied	\N	\N	\N	\N	73237	73237	73012
17466	23467	20	applied	\N	\N	\N	\N	73238	73238	73046
17466	23468	21	applied	\N	\N	\N	\N	73239	73239	73048
17466	23469	22	applied	\N	\N	\N	\N	73240	73240	73050
17466	23492	23	applied	\N	\N	\N	\N	73102	73102	73103
17466	23470	24	applied	\N	\N	\N	\N	73241	73241	73052
17466	23473	25	applied	\N	\N	\N	\N	73242	73242	73059
17466	23474	26	applied	\N	\N	\N	\N	73243	73243	73061
17466	23475	27	applied	\N	\N	\N	\N	73244	73244	73063
17466	23476	28	applied	\N	\N	\N	\N	73245	73245	73065
17466	23477	29	applied	\N	\N	\N	\N	73246	73246	73067
17466	23480	30	applied	\N	\N	\N	\N	73247	73247	73077
17466	23481	31	applied	\N	\N	\N	\N	73248	73248	73079
17466	23482	32	applied	\N	\N	\N	\N	73249	73249	73081
17466	23483	33	applied	\N	\N	\N	\N	73250	73250	73083
17466	23484	34	applied	\N	\N	\N	\N	73251	73251	73085
17466	23487	36	applied	\N	\N	\N	\N	73253	73253	73093
17466	23488	37	applied	\N	\N	\N	\N	73254	73254	73095
17466	23491	38	applied	\N	\N	\N	\N	73255	73255	73101
17466	23423	39	applied	\N	\N	\N	\N	72881	72881	72889
17466	23084	40	applied	\N	\N	\N	\N	72036	72036	72037
17466	23087	41	applied	\N	\N	\N	\N	72042	72042	72043
17466	23090	42	applied	\N	\N	\N	\N	72060	72060	72061
17466	23093	43	applied	\N	\N	\N	\N	72066	72066	72067
17466	23094	44	applied	\N	\N	\N	\N	72068	72068	72069
17466	23099	45	applied	\N	\N	\N	\N	72080	72080	72081
17466	23100	46	applied	\N	\N	\N	\N	72082	72082	72083
17466	23101	47	applied	\N	\N	\N	\N	72084	72084	72085
17466	23108	48	applied	\N	\N	\N	\N	72095	72095	72096
17466	23109	49	applied	\N	\N	\N	\N	72097	72097	72098
17466	23114	50	applied	\N	\N	\N	\N	72106	72106	72107
17466	23117	51	applied	\N	\N	\N	\N	72112	72112	72113
17466	23119	52	applied	\N	\N	\N	\N	72119	72119	72120
17466	23122	53	applied	\N	\N	\N	\N	72125	72125	72126
17466	23123	54	applied	\N	\N	\N	\N	72127	72127	72128
17466	23124	55	applied	\N	\N	\N	\N	72129	72129	72130
17466	23131	56	applied	\N	\N	\N	\N	72140	72140	72141
17466	23134	57	applied	\N	\N	\N	\N	72146	72146	72147
17466	23156	58	applied	\N	\N	\N	\N	72194	72194	72195
17466	23493	59	applied	\N	\N	\N	\N	73256	73256	73105
17466	23494	60	applied	\N	\N	\N	\N	73257	73257	73107
17466	23495	61	applied	\N	\N	\N	\N	73258	73258	73109
17466	23496	62	applied	\N	\N	\N	\N	73259	73259	73111
17466	23497	63	applied	\N	\N	\N	\N	73260	73260	73113
17466	23498	64	applied	\N	\N	\N	\N	73261	73261	73115
17466	23499	65	applied	\N	\N	\N	\N	73262	73262	73117
17466	23500	66	applied	\N	\N	\N	\N	73263	73263	73119
17466	23501	67	applied	\N	\N	\N	\N	73264	73264	73121
17466	23508	68	applied	\N	\N	\N	\N	73265	73265	73137
17466	23509	69	applied	\N	\N	\N	\N	73266	73266	73139
17466	23510	70	applied	\N	\N	\N	\N	73267	73267	73141
17466	23511	71	applied	\N	\N	\N	\N	73268	73268	73143
17466	23512	72	applied	\N	\N	\N	\N	73269	73269	73145
17466	23513	73	applied	\N	\N	\N	\N	73270	73270	73147
17466	23514	74	applied	\N	\N	\N	\N	73271	73271	73149
17466	23515	75	applied	\N	\N	\N	\N	73272	73272	73151
17466	23516	76	applied	\N	\N	\N	\N	73273	73273	73153
17466	23517	77	applied	\N	\N	\N	\N	73274	73274	73155
17466	23518	78	applied	\N	\N	\N	\N	73275	73275	73157
17466	23523	79	applied	\N	\N	\N	\N	73276	73276	73172
17466	23524	80	applied	\N	\N	\N	\N	73277	73277	73174
17466	23525	81	applied	\N	\N	\N	\N	73278	73278	73176
17466	23526	82	applied	\N	\N	\N	\N	73279	73279	73178
17466	23527	83	applied	\N	\N	\N	\N	73280	73280	73180
17466	23528	84	applied	\N	\N	\N	\N	73281	73281	73182
17466	23532	85	applied	\N	\N	\N	\N	73282	73282	73197
17466	23533	86	applied	\N	\N	\N	\N	73283	73283	73199
17466	23534	87	applied	\N	\N	\N	\N	73284	73284	73201
17466	23535	88	applied	\N	\N	\N	\N	73285	73285	73203
17466	23536	89	applied	\N	\N	\N	\N	73286	73286	73205
17466	23537	90	applied	\N	\N	\N	\N	73287	73287	73207
17466	23540	91	applied	\N	\N	\N	\N	73288	73288	73213
17466	23541	92	applied	\N	\N	\N	\N	73289	73289	73216
17466	23135	93	applied	\N	\N	\N	\N	72148	72148	72149
17466	23136	94	applied	\N	\N	\N	\N	72150	72150	72151
17466	23137	95	applied	\N	\N	\N	\N	72152	72152	72153
17466	23146	96	applied	\N	\N	\N	\N	72166	72166	72167
17457	23487	0	applied	\N	\N	\N	\N	73092	73092	73093
17457	23488	1	applied	\N	\N	\N	\N	73094	73094	73095
17457	23489	2	applied	\N	\N	\N	\N	73096	73096	73097
17457	23490	3	applied	\N	\N	\N	\N	73098	73098	73099
17457	23491	4	applied	\N	\N	\N	\N	73100	73100	73101
17457	23506	5	applied	\N	\N	\N	\N	73132	73132	73133
17457	23507	6	applied	\N	\N	\N	\N	73134	73134	73135
17457	23492	7	applied	\N	\N	\N	\N	73102	73102	73103
17457	23493	8	applied	\N	\N	\N	\N	73104	73104	73105
17457	23494	9	applied	\N	\N	\N	\N	73106	73106	73107
17457	23495	10	applied	\N	\N	\N	\N	73108	73108	73109
17457	23496	11	applied	\N	\N	\N	\N	73110	73110	73111
17457	23497	12	applied	\N	\N	\N	\N	73112	73112	73113
17457	23498	13	applied	\N	\N	\N	\N	73114	73114	73115
17457	23499	14	applied	\N	\N	\N	\N	73116	73116	73117
17457	23500	15	applied	\N	\N	\N	\N	73118	73118	73119
17457	23501	16	applied	\N	\N	\N	\N	73120	73120	73121
17457	23508	17	applied	\N	\N	\N	\N	73136	73136	73137
17457	23509	18	applied	\N	\N	\N	\N	73138	73138	73139
17457	23510	19	applied	\N	\N	\N	\N	73140	73140	73141
17457	23511	20	applied	\N	\N	\N	\N	73142	73142	73143
17457	23512	21	applied	\N	\N	\N	\N	73144	73144	73145
17457	23513	22	applied	\N	\N	\N	\N	73146	73146	73147
17457	23514	23	applied	\N	\N	\N	\N	73148	73148	73149
17457	23515	24	applied	\N	\N	\N	\N	73150	73150	73151
17457	23516	25	applied	\N	\N	\N	\N	73152	73152	73153
17457	23517	26	applied	\N	\N	\N	\N	73154	73154	73155
17457	23518	27	applied	\N	\N	\N	\N	73156	73156	73157
17457	23502	28	applied	\N	\N	\N	\N	73122	73122	73123
17457	23503	29	applied	\N	\N	\N	\N	73124	73124	73125
17457	23519	30	applied	\N	\N	\N	\N	73158	73158	73159
17457	23504	31	applied	\N	\N	\N	\N	73126	73126	73160
17457	23505	32	applied	\N	\N	\N	\N	73128	73128	73161
17457	23520	33	applied	\N	\N	\N	\N	73162	73162	73163
17457	23521	34	applied	\N	\N	\N	\N	73164	73164	73165
17457	23522	35	applied	\N	\N	\N	\N	73166	73166	73167
17459	23506	0	applied	\N	\N	\N	\N	73132	73132	73133
17459	23507	1	applied	\N	\N	\N	\N	73134	73134	73135
17459	23508	2	applied	\N	\N	\N	\N	73136	73136	73137
17459	23509	3	applied	\N	\N	\N	\N	73138	73138	73139
17459	23510	4	applied	\N	\N	\N	\N	73140	73140	73141
17459	23511	5	applied	\N	\N	\N	\N	73142	73142	73143
17459	23512	6	applied	\N	\N	\N	\N	73144	73144	73145
17459	23513	7	applied	\N	\N	\N	\N	73146	73146	73147
17459	23514	8	applied	\N	\N	\N	\N	73148	73148	73149
17459	23515	9	applied	\N	\N	\N	\N	73150	73150	73151
17459	23516	10	applied	\N	\N	\N	\N	73152	73152	73153
17459	23517	11	applied	\N	\N	\N	\N	73154	73154	73155
17459	23518	12	applied	\N	\N	\N	\N	73156	73156	73157
17459	23519	13	applied	\N	\N	\N	\N	73158	73158	73161
17459	23520	14	applied	\N	\N	\N	\N	73162	73162	73163
17459	23521	15	applied	\N	\N	\N	\N	73164	73164	73165
17459	23522	16	applied	\N	\N	\N	\N	73166	73166	73167
17462	23506	0	applied	\N	\N	\N	\N	73132	73132	73133
17462	23507	1	applied	\N	\N	\N	\N	73134	73134	73135
17462	23508	2	applied	\N	\N	\N	\N	73136	73136	73137
17462	23509	3	applied	\N	\N	\N	\N	73138	73138	73139
17462	23510	4	applied	\N	\N	\N	\N	73140	73140	73141
17462	23511	5	applied	\N	\N	\N	\N	73142	73142	73143
17462	23512	6	applied	\N	\N	\N	\N	73144	73144	73145
17462	23513	7	applied	\N	\N	\N	\N	73146	73146	73147
17462	23514	8	applied	\N	\N	\N	\N	73148	73148	73149
17462	23515	9	applied	\N	\N	\N	\N	73150	73150	73151
17462	23516	10	applied	\N	\N	\N	\N	73152	73152	73153
17462	23517	11	applied	\N	\N	\N	\N	73154	73154	73155
17462	23518	12	applied	\N	\N	\N	\N	73156	73156	73157
17462	23523	13	applied	\N	\N	\N	\N	73171	73171	73172
17462	23524	14	applied	\N	\N	\N	\N	73173	73173	73174
17462	23525	15	applied	\N	\N	\N	\N	73175	73175	73176
17462	23526	16	applied	\N	\N	\N	\N	73177	73177	73178
17462	23527	17	applied	\N	\N	\N	\N	73179	73179	73180
17462	23519	18	applied	\N	\N	\N	\N	73158	73158	73161
17462	23520	19	applied	\N	\N	\N	\N	73162	73162	73163
17462	23530	20	applied	\N	\N	\N	\N	73185	73185	73192
17462	23521	21	applied	\N	\N	\N	\N	73164	73164	73193
17462	23522	22	applied	\N	\N	\N	\N	73166	73166	73186
17462	23531	23	applied	\N	\N	\N	\N	73187	73187	73188
17469	23532	0	applied	\N	\N	\N	\N	73196	73196	73197
17469	23533	1	applied	\N	\N	\N	\N	73198	73198	73199
17469	23534	3	applied	\N	\N	\N	\N	73200	73200	73201
17469	23535	4	applied	\N	\N	\N	\N	73202	73202	73203
17476	23573	0	applied	\N	\N	\N	\N	73357	73357	73358
17476	23574	1	applied	\N	\N	\N	\N	73359	73359	73360
17476	23575	2	applied	\N	\N	\N	\N	73361	73361	73362
17479	23585	0	applied	\N	\N	\N	\N	73384	73384	73385
17479	23586	1	applied	\N	\N	\N	\N	73386	73386	73387
17479	23587	2	applied	\N	\N	\N	\N	73388	73388	73389
17479	23588	3	applied	\N	\N	\N	\N	73390	73390	73391
17479	23589	4	applied	\N	\N	\N	\N	73392	73392	73393
17479	23590	5	applied	\N	\N	\N	\N	73394	73394	73395
17479	23591	6	applied	\N	\N	\N	\N	73396	73396	73397
17479	23592	7	applied	\N	\N	\N	\N	73398	73398	73399
17481	23593	0	applied	\N	\N	\N	\N	73406	73406	73407
17481	23594	1	applied	\N	\N	\N	\N	73408	73408	73409
17481	23595	2	applied	\N	\N	\N	\N	73410	73410	73411
17481	23596	3	applied	\N	\N	\N	\N	73412	73412	73413
17481	23597	4	applied	\N	\N	\N	\N	73414	73414	73415
17481	23598	5	applied	\N	\N	\N	\N	73416	73416	73417
17481	23599	6	applied	\N	\N	\N	\N	73418	73418	73419
17481	23600	7	applied	\N	\N	\N	\N	73420	73420	73421
17487	23601	0	applied	\N	\N	\N	\N	73427	73427	73428
17487	23602	1	applied	\N	\N	\N	\N	73429	73429	73430
17487	23603	2	applied	\N	\N	\N	\N	73431	73431	73432
17487	23604	3	applied	\N	\N	\N	\N	73433	73433	73434
17487	23605	4	applied	\N	\N	\N	\N	73435	73435	73436
17487	23599	5	applied	\N	\N	\N	\N	73418	73418	73421
17487	23606	6	applied	\N	\N	\N	\N	73437	73437	73438
17487	23607	7	applied	\N	\N	\N	\N	73439	73439	73440
17490	23617	0	applied	\N	\N	\N	\N	73468	73468	73469
17490	23618	1	applied	\N	\N	\N	\N	73470	73470	73471
17490	23619	2	applied	\N	\N	\N	\N	73472	73472	73473
17490	23620	3	applied	\N	\N	\N	\N	73474	73474	73475
17490	23621	4	applied	\N	\N	\N	\N	73476	73476	73477
17490	23622	5	applied	\N	\N	\N	\N	73478	73478	73479
17490	23623	6	applied	\N	\N	\N	\N	73480	73480	73481
17490	23624	7	applied	\N	\N	\N	\N	73482	73482	73483
17497	23631	0	applied	\N	\N	\N	\N	73508	73508	73509
17497	23632	1	applied	\N	\N	\N	\N	73510	73510	73511
17502	23641	0	applied	\N	\N	\N	\N	73539	73539	73540
17502	23642	1	applied	\N	\N	\N	\N	73541	73541	73542
17464	23543	12	applied	\N	\N	\N	\N	73219	73219	73220
17464	23544	13	applied	\N	\N	\N	\N	73221	73221	73222
17477	23576	0	applied	\N	\N	\N	\N	73364	73364	73365
17477	23577	1	applied	\N	\N	\N	\N	73366	73366	73367
17477	23578	2	applied	\N	\N	\N	\N	73368	73368	73369
17477	23579	3	applied	\N	\N	\N	\N	73370	73370	73371
17477	23580	4	applied	\N	\N	\N	\N	73372	73372	73373
17477	23581	5	applied	\N	\N	\N	\N	73374	73374	73375
17477	23582	6	applied	\N	\N	\N	\N	73376	73376	73377
17477	23583	7	applied	\N	\N	\N	\N	73378	73378	73379
17477	23584	8	applied	\N	\N	\N	\N	73380	73380	73381
17482	23593	0	applied	\N	\N	\N	\N	73406	73406	73407
17482	23594	1	applied	\N	\N	\N	\N	73408	73408	73409
17482	23595	2	applied	\N	\N	\N	\N	73410	73410	73411
17482	23596	3	applied	\N	\N	\N	\N	73412	73412	73413
17482	23597	4	applied	\N	\N	\N	\N	73414	73414	73415
17482	23598	5	applied	\N	\N	\N	\N	73416	73416	73417
17482	23600	6	applied	\N	\N	\N	\N	73420	73420	73423
17484	23601	0	applied	\N	\N	\N	\N	73427	73427	73428
17484	23602	1	applied	\N	\N	\N	\N	73429	73429	73430
17484	23603	2	applied	\N	\N	\N	\N	73431	73431	73432
17484	23604	3	applied	\N	\N	\N	\N	73433	73433	73434
17484	23605	4	applied	\N	\N	\N	\N	73435	73435	73436
17484	23599	5	applied	\N	\N	\N	\N	73418	73418	73421
17484	23606	6	applied	\N	\N	\N	\N	73437	73437	73438
17484	23607	7	applied	\N	\N	\N	\N	73439	73439	73440
17491	23617	0	applied	\N	\N	\N	\N	73468	73468	73469
17491	23618	1	applied	\N	\N	\N	\N	73470	73470	73471
17491	23619	2	applied	\N	\N	\N	\N	73472	73472	73473
17491	23620	3	applied	\N	\N	\N	\N	73474	73474	73475
17491	23621	4	applied	\N	\N	\N	\N	73476	73476	73477
17491	23622	5	applied	\N	\N	\N	\N	73478	73478	73479
17491	23623	6	applied	\N	\N	\N	\N	73480	73480	73481
17491	23624	7	applied	\N	\N	\N	\N	73482	73482	73483
17493	23625	0	applied	\N	\N	\N	\N	73489	73489	73490
17493	23626	1	applied	\N	\N	\N	\N	73491	73491	73492
17495	23627	0	applied	\N	\N	\N	\N	73495	73495	73496
17495	23628	1	applied	\N	\N	\N	\N	73497	73497	73498
17498	23633	0	applied	\N	\N	\N	\N	73513	73513	73514
17498	23634	1	applied	\N	\N	\N	\N	73515	73515	73516
17506	23647	0	applied	\N	\N	\N	\N	73554	73554	73555
17506	23648	1	applied	\N	\N	\N	\N	73556	73556	73557
17506	23649	2	applied	\N	\N	\N	\N	73558	73558	73559
17506	23650	3	applied	\N	\N	\N	\N	73560	73560	73561
17506	23651	4	applied	\N	\N	\N	\N	73562	73562	73563
17506	23652	5	applied	\N	\N	\N	\N	73564	73564	73565
17508	23655	0	applied	\N	\N	\N	\N	73576	73576	73580
17511	23653	0	applied	\N	\N	\N	\N	73572	73572	73573
17511	23656	1	applied	\N	\N	\N	\N	73582	73582	73583
17511	23659	2	applied	\N	\N	\N	\N	73590	73590	73591
17511	23660	3	applied	\N	\N	\N	\N	73592	73592	73593
17511	23661	4	applied	\N	\N	\N	\N	73594	73594	73595
17511	23654	5	applied	\N	\N	\N	\N	73574	73574	73577
17511	23657	6	applied	\N	\N	\N	\N	73584	73584	73585
17511	23664	7	applied	\N	\N	\N	\N	73600	73600	73610
17511	23665	8	applied	\N	\N	\N	\N	73602	73602	73599
17511	23658	9	applied	\N	\N	\N	\N	73586	73586	73611
17511	23662	10	applied	\N	\N	\N	\N	73596	73596	73612
17511	23663	11	applied	\N	\N	\N	\N	73598	73598	73603
17511	23666	12	applied	\N	\N	\N	\N	73604	73604	73605
17511	23667	13	applied	\N	\N	\N	\N	73606	73606	73607
17518	23675	0	applied	\N	\N	\N	\N	73638	73638	73639
17518	23676	1	applied	\N	\N	\N	\N	73640	73640	25661
17518	23677	2	applied	\N	\N	\N	\N	73641	73641	73642
17525	23682	0	applied	\N	\N	\N	\N	73662	73662	73663
17525	23683	1	applied	\N	\N	\N	\N	73664	73664	73665
17525	23684	2	applied	\N	\N	\N	\N	73666	73666	73667
17525	23685	3	applied	\N	\N	\N	\N	73668	73668	73669
17525	23686	4	applied	\N	\N	\N	\N	73670	73670	73671
17525	23687	5	applied	\N	\N	\N	\N	73672	73672	73673
17525	23688	6	applied	\N	\N	\N	\N	73674	73674	73675
17525	23689	7	applied	\N	\N	\N	\N	73676	73676	73677
17529	23702	0	applied	\N	\N	\N	\N	73707	73707	73708
17529	23703	1	applied	\N	\N	\N	\N	73709	73709	73710
17529	23704	2	applied	\N	\N	\N	\N	73711	73711	73712
17529	23705	3	applied	\N	\N	\N	\N	73713	73713	73714
17529	23706	4	applied	\N	\N	\N	\N	73715	73715	73716
17533	23713	0	applied	\N	\N	\N	\N	73738	73738	73739
17533	23714	1	applied	\N	\N	\N	\N	73740	73740	73741
17533	23715	2	applied	\N	\N	\N	\N	73742	73742	73743
17534	23716	0	applied	\N	\N	\N	\N	73745	73745	73746
17534	23717	1	applied	\N	\N	\N	\N	73747	73747	73748
17534	23718	2	applied	\N	\N	\N	\N	73749	73749	73750
17534	23719	3	applied	\N	\N	\N	\N	73751	73751	73752
17534	23720	4	applied	\N	\N	\N	\N	73753	73753	73754
17534	23721	5	applied	\N	\N	\N	\N	73755	73755	73756
17534	23722	6	applied	\N	\N	\N	\N	73757	73757	73758
17534	23723	8	applied	\N	\N	\N	\N	73760	73760	73761
17534	23724	9	applied	\N	\N	\N	\N	73762	73762	73763
17534	23725	10	applied	\N	\N	\N	\N	73764	73764	73765
17534	23726	11	applied	\N	\N	\N	\N	73766	73766	73767
17534	23727	12	applied	\N	\N	\N	\N	73768	73768	73769
17537	23728	0	applied	\N	\N	\N	\N	73772	73772	73773
17537	23729	1	applied	\N	\N	\N	\N	73774	73774	73775
17537	23730	2	applied	\N	\N	\N	\N	73776	73776	73777
17541	23734	0	applied	\N	\N	\N	\N	73795	73795	73796
17541	23735	1	applied	\N	\N	\N	\N	73797	73797	73798
17541	23736	2	applied	\N	\N	\N	\N	73799	73799	73800
17541	23737	3	applied	\N	\N	\N	\N	73801	73801	73802
17541	23738	4	applied	\N	\N	\N	\N	73803	73803	73804
17544	23734	0	applied	\N	\N	\N	\N	73795	73795	73796
17544	23735	1	applied	\N	\N	\N	\N	73797	73797	73798
17544	23736	2	applied	\N	\N	\N	\N	73799	73799	73800
17544	23737	3	applied	\N	\N	\N	\N	73801	73801	73802
17544	23738	4	applied	\N	\N	\N	\N	73803	73803	73804
17553	23748	0	applied	\N	\N	\N	\N	73837	73837	73838
17553	23749	1	applied	\N	\N	\N	\N	73839	73839	73840
17553	23750	2	applied	\N	\N	\N	\N	73841	73841	73842
17555	23751	0	applied	\N	\N	\N	\N	73847	73847	73848
17555	23752	1	applied	\N	\N	\N	\N	73849	73849	73850
17555	23753	2	applied	\N	\N	\N	\N	73851	73851	73852
17563	23757	0	applied	\N	\N	\N	\N	73868	73868	73869
17563	23758	1	applied	\N	\N	\N	\N	73870	73870	73871
17563	23759	2	applied	\N	\N	\N	\N	73872	73872	73873
17569	23766	0	applied	\N	\N	\N	\N	73893	73893	73894
17569	23767	1	applied	\N	\N	\N	\N	73895	73895	73896
17569	23768	2	applied	\N	\N	\N	\N	73897	73897	73898
17573	23734	0	applied	\N	\N	\N	\N	73795	73795	73796
17573	23735	1	applied	\N	\N	\N	\N	73797	73797	73798
17573	23740	2	applied	\N	\N	\N	\N	73813	73813	73814
17466	23149	97	applied	\N	\N	\N	\N	72173	72173	72174
17466	23150	98	applied	\N	\N	\N	\N	72175	72175	72176
17466	23155	99	applied	\N	\N	\N	\N	72192	72192	72193
17466	23159	100	applied	\N	\N	\N	\N	72200	72200	72201
17466	23160	101	applied	\N	\N	\N	\N	72202	72202	72203
17466	23165	102	applied	\N	\N	\N	\N	72211	72211	72212
17466	23168	103	applied	\N	\N	\N	\N	72217	72217	72218
17466	23170	104	applied	\N	\N	\N	\N	72223	72223	72224
17466	23174	105	applied	\N	\N	\N	\N	72233	72233	72234
17466	23176	106	applied	\N	\N	\N	\N	72237	72237	72238
17466	23179	107	applied	\N	\N	\N	\N	72245	72245	72246
17466	23181	108	applied	\N	\N	\N	\N	72252	72252	72253
17466	23184	109	applied	\N	\N	\N	\N	72256	72256	72257
17466	23187	110	applied	\N	\N	\N	\N	72263	72263	72264
17466	23189	111	applied	\N	\N	\N	\N	72268	72268	72269
17466	23193	112	applied	\N	\N	\N	\N	72280	72280	72281
17466	23194	113	applied	\N	\N	\N	\N	72282	72282	72283
17466	23199	114	applied	\N	\N	\N	\N	72295	72295	72296
17466	23209	115	applied	\N	\N	\N	\N	72321	72321	72322
17466	23212	116	applied	\N	\N	\N	\N	72329	72329	72330
17466	23213	117	applied	\N	\N	\N	\N	72331	72331	72332
17466	23219	118	applied	\N	\N	\N	\N	72344	72344	72345
17466	23220	119	applied	\N	\N	\N	\N	72346	72346	72347
17466	23226	120	applied	\N	\N	\N	\N	72355	72355	72356
17466	23229	121	applied	\N	\N	\N	\N	72362	72362	72363
17466	23232	122	applied	\N	\N	\N	\N	72366	72366	72367
17466	23235	123	applied	\N	\N	\N	\N	72375	72375	72376
17466	23238	124	applied	\N	\N	\N	\N	72380	72380	72381
17466	23241	125	applied	\N	\N	\N	\N	72387	72387	72388
17468	23532	0	applied	\N	\N	\N	\N	73196	73196	73197
17468	23533	1	applied	\N	\N	\N	\N	73198	73198	73199
17468	23534	3	applied	\N	\N	\N	\N	73200	73200	73201
17468	23535	4	applied	\N	\N	\N	\N	73202	73202	73203
17468	23536	5	applied	\N	\N	\N	\N	73204	73204	73205
17468	23537	6	applied	\N	\N	\N	\N	73206	73206	73207
17468	23545	7	applied	\N	\N	\N	\N	73293	73293	73294
17468	23546	8	applied	\N	\N	\N	\N	73295	73295	73296
17468	23540	9	applied	\N	\N	\N	\N	73212	73212	73213
17468	23541	10	applied	\N	\N	\N	\N	73215	73215	73216
17468	23549	11	applied	\N	\N	\N	\N	73302	73302	73303
17468	23550	12	applied	\N	\N	\N	\N	73304	73304	73305
17468	23551	13	applied	\N	\N	\N	\N	73306	73306	73307
17468	23552	14	applied	\N	\N	\N	\N	73308	73308	73309
17468	23553	15	applied	\N	\N	\N	\N	73310	73310	73311
17468	23554	16	applied	\N	\N	\N	\N	73312	73312	73313
17468	23555	17	applied	\N	\N	\N	\N	73314	73314	73315
17468	23556	18	applied	\N	\N	\N	\N	73316	73316	73317
17468	23557	19	applied	\N	\N	\N	\N	73318	73318	73319
17468	23558	20	applied	\N	\N	\N	\N	73320	73320	73321
17468	23559	21	applied	\N	\N	\N	\N	73322	73322	73323
17468	23560	22	applied	\N	\N	\N	\N	73324	73324	73325
17468	23561	23	applied	\N	\N	\N	\N	73326	73326	73327
17468	23547	24	applied	\N	\N	\N	\N	73297	73297	47675
17468	23562	25	applied	\N	\N	\N	\N	73328	73328	73329
17468	23548	26	applied	\N	\N	\N	\N	73298	73298	73330
17475	23570	0	applied	\N	\N	\N	\N	73349	73349	73350
17475	23571	1	applied	\N	\N	\N	\N	73351	73351	73352
17475	23572	2	applied	\N	\N	\N	\N	73353	73353	73354
17478	23585	0	applied	\N	\N	\N	\N	73384	73384	73385
17478	23586	1	applied	\N	\N	\N	\N	73386	73386	73387
17478	23587	2	applied	\N	\N	\N	\N	73388	73388	73389
17478	23588	3	applied	\N	\N	\N	\N	73390	73390	73391
17478	23589	4	applied	\N	\N	\N	\N	73392	73392	73393
17478	23590	5	applied	\N	\N	\N	\N	73394	73394	73395
17478	23591	6	applied	\N	\N	\N	\N	73396	73396	73397
17478	23592	7	applied	\N	\N	\N	\N	73398	73398	73399
17486	23601	0	applied	\N	\N	\N	\N	73427	73427	73428
17486	23602	1	applied	\N	\N	\N	\N	73429	73429	73430
17486	23603	2	applied	\N	\N	\N	\N	73431	73431	73432
17486	23604	3	applied	\N	\N	\N	\N	73433	73433	73434
17486	23605	4	applied	\N	\N	\N	\N	73435	73435	73436
17486	23599	5	applied	\N	\N	\N	\N	73418	73418	73421
17486	23606	6	applied	\N	\N	\N	\N	73437	73437	73438
17486	23607	7	applied	\N	\N	\N	\N	73439	73439	73440
17488	23601	0	applied	\N	\N	\N	\N	73427	73427	73428
17488	23602	1	applied	\N	\N	\N	\N	73429	73429	73430
17488	23603	2	applied	\N	\N	\N	\N	73431	73431	73432
17488	23604	3	applied	\N	\N	\N	\N	73433	73433	73434
17488	23605	4	applied	\N	\N	\N	\N	73435	73435	73436
17488	23599	5	applied	\N	\N	\N	\N	73418	73418	73421
17488	23606	6	applied	\N	\N	\N	\N	73437	73437	73438
17488	23607	7	applied	\N	\N	\N	\N	73439	73439	73440
17492	23617	0	applied	\N	\N	\N	\N	73468	73468	73469
17492	23618	1	applied	\N	\N	\N	\N	73470	73470	73471
17492	23619	2	applied	\N	\N	\N	\N	73472	73472	73473
17492	23620	3	applied	\N	\N	\N	\N	73474	73474	73475
17492	23621	4	applied	\N	\N	\N	\N	73476	73476	73477
17492	23622	5	applied	\N	\N	\N	\N	73478	73478	73479
17492	23623	6	applied	\N	\N	\N	\N	73480	73480	73481
17492	23624	7	applied	\N	\N	\N	\N	73482	73482	73483
17494	23627	0	applied	\N	\N	\N	\N	73495	73495	73496
17494	23628	1	applied	\N	\N	\N	\N	73497	73497	73498
17500	23633	0	applied	\N	\N	\N	\N	73513	73513	73514
17500	23634	1	applied	\N	\N	\N	\N	73515	73515	73516
17501	23635	0	applied	\N	\N	\N	\N	73523	73523	73524
17501	23636	2	applied	\N	\N	\N	\N	73526	73526	73527
17501	23637	3	applied	\N	\N	\N	\N	73528	73528	73529
17501	23638	4	applied	\N	\N	\N	\N	73530	73530	73531
17501	23639	5	applied	\N	\N	\N	\N	73532	73532	73533
17501	23640	6	applied	\N	\N	\N	\N	73534	73534	73535
17504	23647	0	applied	\N	\N	\N	\N	73554	73554	73555
17504	23648	1	applied	\N	\N	\N	\N	73556	73556	73557
17504	23649	2	applied	\N	\N	\N	\N	73558	73558	73559
17504	23650	3	applied	\N	\N	\N	\N	73560	73560	73561
17504	23651	4	applied	\N	\N	\N	\N	73562	73562	73563
17504	23652	5	applied	\N	\N	\N	\N	73564	73564	73565
17514	23670	0	applied	\N	\N	\N	\N	73622	73622	73623
17514	23671	1	applied	\N	\N	\N	\N	73624	73624	73625
17514	23672	2	applied	\N	\N	\N	\N	73626	73626	73627
17516	23673	0	applied	\N	\N	\N	\N	73632	73632	73633
17516	23674	1	applied	\N	\N	\N	\N	73634	73634	73635
17521	23678	0	applied	\N	\N	\N	\N	73647	73647	73648
17521	23679	1	applied	\N	\N	\N	\N	73649	73649	73650
17524	23680	0	applied	\N	\N	\N	\N	73655	73655	73656
17524	23681	1	applied	\N	\N	\N	\N	73657	73657	73658
17527	23699	0	applied	\N	\N	\N	\N	73699	73699	73700
17527	23700	1	applied	\N	\N	\N	\N	73701	73701	73702
17527	23701	2	applied	\N	\N	\N	\N	73703	73703	73704
17532	23710	0	applied	\N	\N	\N	\N	73730	73730	73731
17532	23711	1	applied	\N	\N	\N	\N	73732	73732	73733
17474	23569	28	applied	\N	\N	\N	\N	73345	73345	73346
17480	23585	0	applied	\N	\N	\N	\N	73384	73384	73385
17480	23586	1	applied	\N	\N	\N	\N	73386	73386	73387
17480	23587	2	applied	\N	\N	\N	\N	73388	73388	73389
17480	23588	3	applied	\N	\N	\N	\N	73390	73390	73391
17480	23589	4	applied	\N	\N	\N	\N	73392	73392	73393
17480	23590	5	applied	\N	\N	\N	\N	73394	73394	73395
17480	23591	6	applied	\N	\N	\N	\N	73396	73396	73397
17480	23592	7	applied	\N	\N	\N	\N	73398	73398	73399
17483	23593	0	applied	\N	\N	\N	\N	73406	73406	73407
17483	23594	1	applied	\N	\N	\N	\N	73408	73408	73409
17483	23595	2	applied	\N	\N	\N	\N	73410	73410	73411
17483	23596	3	applied	\N	\N	\N	\N	73412	73412	73413
17483	23597	4	applied	\N	\N	\N	\N	73414	73414	73415
17483	23598	5	applied	\N	\N	\N	\N	73416	73416	73417
17483	23599	6	applied	\N	\N	\N	\N	73418	73418	73419
17483	23600	7	applied	\N	\N	\N	\N	73420	73420	73421
17485	23601	0	applied	\N	\N	\N	\N	73427	73427	73428
17485	23602	1	applied	\N	\N	\N	\N	73429	73429	73430
17485	23603	2	applied	\N	\N	\N	\N	73431	73431	73432
17485	23604	3	applied	\N	\N	\N	\N	73433	73433	73434
17485	23605	4	applied	\N	\N	\N	\N	73435	73435	73436
17485	23607	5	applied	\N	\N	\N	\N	73439	73439	73442
17489	23608	0	applied	\N	\N	\N	\N	73449	73449	73450
17489	23609	1	applied	\N	\N	\N	\N	73451	73451	73452
17489	23610	2	applied	\N	\N	\N	\N	73453	73453	73454
17489	23611	3	applied	\N	\N	\N	\N	73455	73455	73456
17489	23612	4	applied	\N	\N	\N	\N	73457	73457	73458
17489	23613	5	applied	\N	\N	\N	\N	73459	73459	73460
17489	23614	6	applied	\N	\N	\N	\N	73461	73461	73462
17489	23615	7	applied	\N	\N	\N	\N	73463	73463	73464
17489	23616	8	applied	\N	\N	\N	\N	73465	73465	25661
17496	23629	0	applied	\N	\N	\N	\N	73503	73503	73504
17496	23630	1	applied	\N	\N	\N	\N	73505	73505	73506
17499	23633	0	applied	\N	\N	\N	\N	73513	73513	73514
17499	23634	1	applied	\N	\N	\N	\N	73515	73515	73516
17503	23644	0	applied	\N	\N	\N	\N	73547	73547	73548
17503	23645	1	applied	\N	\N	\N	\N	73549	73549	73550
17503	23646	2	applied	\N	\N	\N	\N	73551	73551	73552
17512	23659	0	applied	\N	\N	\N	\N	73590	73590	73591
17512	23660	1	applied	\N	\N	\N	\N	73592	73592	73593
17512	23661	2	applied	\N	\N	\N	\N	73594	73594	73595
17512	23662	3	applied	\N	\N	\N	\N	73596	73596	73597
17512	23663	4	applied	\N	\N	\N	\N	73598	73598	73599
17512	23664	5	applied	\N	\N	\N	\N	73600	73600	73601
17512	23665	6	applied	\N	\N	\N	\N	73602	73602	73603
17512	23666	7	applied	\N	\N	\N	\N	73604	73604	73605
17512	23667	8	applied	\N	\N	\N	\N	73606	73606	73607
17513	23668	0	applied	\N	\N	\N	\N	73616	73616	73617
17513	23669	1	applied	\N	\N	\N	\N	73618	73618	73619
17519	23675	0	applied	\N	\N	\N	\N	73638	73638	73639
17519	23676	1	applied	\N	\N	\N	\N	73640	73640	25661
17519	23677	2	applied	\N	\N	\N	\N	73641	73641	73642
17520	23678	0	applied	\N	\N	\N	\N	73647	73647	73648
17520	23679	1	applied	\N	\N	\N	\N	73649	73649	73650
17523	23680	0	applied	\N	\N	\N	\N	73655	73655	73656
17523	23681	1	applied	\N	\N	\N	\N	73657	73657	73658
17526	23690	0	applied	\N	\N	\N	\N	73680	73680	73681
17526	23691	1	applied	\N	\N	\N	\N	73682	73682	73683
17526	23692	2	applied	\N	\N	\N	\N	73684	73684	73685
17526	23693	3	applied	\N	\N	\N	\N	73686	73686	73687
17526	23694	4	applied	\N	\N	\N	\N	73688	73688	73689
17526	23695	5	applied	\N	\N	\N	\N	73690	73690	73691
17526	23696	6	applied	\N	\N	\N	\N	73692	73692	73693
17526	23697	7	applied	\N	\N	\N	\N	73694	73694	73695
17526	23698	8	applied	\N	\N	\N	\N	73696	73696	73697
17530	23702	0	applied	\N	\N	\N	\N	73707	73707	73708
17530	23703	1	applied	\N	\N	\N	\N	73709	73709	73710
17530	23704	2	applied	\N	\N	\N	\N	73711	73711	73712
17530	23705	3	applied	\N	\N	\N	\N	73713	73713	73714
17530	23706	4	applied	\N	\N	\N	\N	73715	73715	73716
17531	23707	0	applied	\N	\N	\N	\N	73722	73722	73723
17531	23708	1	applied	\N	\N	\N	\N	73724	73724	73725
17531	23709	2	applied	\N	\N	\N	\N	73726	73726	73727
17535	23716	0	applied	\N	\N	\N	\N	73745	73745	73746
17535	23717	1	applied	\N	\N	\N	\N	73747	73747	73748
17535	23718	2	applied	\N	\N	\N	\N	73749	73749	73750
17535	23719	3	applied	\N	\N	\N	\N	73751	73751	73752
17535	23720	4	applied	\N	\N	\N	\N	73753	73753	73754
17535	23721	5	applied	\N	\N	\N	\N	73755	73755	73756
17535	23722	6	applied	\N	\N	\N	\N	73757	73757	73758
17535	23723	8	applied	\N	\N	\N	\N	73760	73760	73761
17535	23724	9	applied	\N	\N	\N	\N	73762	73762	73763
17535	23725	10	applied	\N	\N	\N	\N	73764	73764	73765
17535	23726	11	applied	\N	\N	\N	\N	73766	73766	73767
17535	23727	12	applied	\N	\N	\N	\N	73768	73768	73769
17539	23731	0	applied	\N	\N	\N	\N	73784	73784	73785
17539	23732	1	applied	\N	\N	\N	\N	73786	73786	73787
17539	23733	2	applied	\N	\N	\N	\N	73788	73788	73789
17542	23734	0	applied	\N	\N	\N	\N	73795	73795	73796
17542	23735	1	applied	\N	\N	\N	\N	73797	73797	73798
17542	23736	2	applied	\N	\N	\N	\N	73799	73799	73800
17542	23737	3	applied	\N	\N	\N	\N	73801	73801	73802
17542	23738	4	applied	\N	\N	\N	\N	73803	73803	73804
17542	23739	5	applied	\N	\N	\N	\N	73806	73806	73807
17546	23742	0	applied	\N	\N	\N	\N	73819	73819	73820
17546	23743	1	applied	\N	\N	\N	\N	73821	73821	73822
17546	23744	2	applied	\N	\N	\N	\N	73823	73823	73824
17556	23751	0	applied	\N	\N	\N	\N	73847	73847	73848
17556	23752	1	applied	\N	\N	\N	\N	73849	73849	73850
17556	23753	2	applied	\N	\N	\N	\N	73851	73851	73852
17558	23751	0	applied	\N	\N	\N	\N	73847	73847	73848
17558	23752	1	applied	\N	\N	\N	\N	73849	73849	73850
17558	23753	2	applied	\N	\N	\N	\N	73851	73851	73852
17559	23754	0	applied	\N	\N	\N	\N	73858	73858	73859
17559	23755	1	applied	\N	\N	\N	\N	73860	73860	73861
17559	23756	2	applied	\N	\N	\N	\N	73862	73862	73863
17564	23760	0	applied	\N	\N	\N	\N	73878	73878	73879
17564	23761	1	applied	\N	\N	\N	\N	73880	73880	73881
17564	23762	2	applied	\N	\N	\N	\N	73882	73882	73883
17564	23763	3	applied	\N	\N	\N	\N	73884	73884	73885
17564	23764	4	applied	\N	\N	\N	\N	73886	73886	73887
17564	23765	5	applied	\N	\N	\N	\N	73888	73888	73889
17566	23766	0	applied	\N	\N	\N	\N	73893	73893	73894
17566	23767	1	applied	\N	\N	\N	\N	73895	73895	73896
17566	23768	2	applied	\N	\N	\N	\N	73897	73897	73898
17570	23766	0	applied	\N	\N	\N	\N	73893	73893	73894
17570	23767	1	applied	\N	\N	\N	\N	73895	73895	73896
17570	23768	2	applied	\N	\N	\N	\N	73897	73897	73898
17580	23775	0	applied	\N	\N	\N	\N	73931	73931	73932
17502	23643	2	applied	\N	\N	\N	\N	73543	73543	73544
17505	23647	0	applied	\N	\N	\N	\N	73554	73554	73555
17505	23648	1	applied	\N	\N	\N	\N	73556	73556	73557
17505	23649	2	applied	\N	\N	\N	\N	73558	73558	73559
17505	23650	3	applied	\N	\N	\N	\N	73560	73560	73561
17505	23651	4	applied	\N	\N	\N	\N	73562	73562	73563
17505	23652	5	applied	\N	\N	\N	\N	73564	73564	73565
17507	23653	0	applied	\N	\N	\N	\N	73572	73572	73573
17507	23654	1	applied	\N	\N	\N	\N	73574	73574	73575
17507	23655	2	applied	\N	\N	\N	\N	73576	73576	73577
17509	23653	0	applied	\N	\N	\N	\N	73572	73572	73573
17509	23656	1	applied	\N	\N	\N	\N	73582	73582	73583
17509	23654	2	applied	\N	\N	\N	\N	73574	73574	73577
17509	23657	3	applied	\N	\N	\N	\N	73584	73584	73585
17509	23658	4	applied	\N	\N	\N	\N	73586	73586	73587
17510	23659	0	applied	\N	\N	\N	\N	73590	73590	73591
17510	23660	1	applied	\N	\N	\N	\N	73592	73592	73593
17510	23661	2	applied	\N	\N	\N	\N	73594	73594	73595
17510	23662	3	applied	\N	\N	\N	\N	73596	73596	73597
17510	23663	4	applied	\N	\N	\N	\N	73598	73598	73599
17510	23664	5	applied	\N	\N	\N	\N	73600	73600	73601
17510	23665	6	applied	\N	\N	\N	\N	73602	73602	73603
17510	23666	7	applied	\N	\N	\N	\N	73604	73604	73605
17510	23667	8	applied	\N	\N	\N	\N	73606	73606	73607
17515	23670	0	applied	\N	\N	\N	\N	73622	73622	73623
17515	23671	1	applied	\N	\N	\N	\N	73624	73624	73625
17515	23672	2	applied	\N	\N	\N	\N	73626	73626	73627
17517	23675	0	applied	\N	\N	\N	\N	73638	73638	73639
17517	23676	1	applied	\N	\N	\N	\N	73640	73640	25661
17517	23677	2	applied	\N	\N	\N	\N	73641	73641	73642
17522	23678	0	applied	\N	\N	\N	\N	73647	73647	73648
17522	23679	1	applied	\N	\N	\N	\N	73649	73649	73650
17528	23702	0	applied	\N	\N	\N	\N	73707	73707	73708
17528	23703	1	applied	\N	\N	\N	\N	73709	73709	73710
17528	23704	2	applied	\N	\N	\N	\N	73711	73711	73712
17528	23705	3	applied	\N	\N	\N	\N	73713	73713	73714
17528	23706	4	applied	\N	\N	\N	\N	73715	73715	73716
17536	23728	0	applied	\N	\N	\N	\N	73772	73772	73773
17536	23729	1	applied	\N	\N	\N	\N	73774	73774	73775
17536	23730	2	applied	\N	\N	\N	\N	73776	73776	73777
17538	23676	0	applied	\N	\N	\N	\N	73640	73640	25661
17538	23599	1	applied	\N	\N	\N	\N	73418	73418	73421
17538	23616	2	applied	\N	\N	\N	\N	73465	73465	25661
17545	23740	0	applied	\N	\N	\N	\N	73813	73813	73814
17545	23741	1	applied	\N	\N	\N	\N	73815	73815	73816
17548	23742	0	applied	\N	\N	\N	\N	73819	73819	73820
17548	23743	1	applied	\N	\N	\N	\N	73821	73821	73822
17548	23744	2	applied	\N	\N	\N	\N	73823	73823	73824
17550	23745	0	applied	\N	\N	\N	\N	73828	73828	73829
17550	23746	1	applied	\N	\N	\N	\N	73830	73830	73831
17550	23747	2	applied	\N	\N	\N	\N	73832	73832	73833
17552	23748	0	applied	\N	\N	\N	\N	73837	73837	73838
17552	23749	1	applied	\N	\N	\N	\N	73839	73839	73840
17552	23750	2	applied	\N	\N	\N	\N	73841	73841	73842
17554	23751	0	applied	\N	\N	\N	\N	73847	73847	73848
17554	23752	1	applied	\N	\N	\N	\N	73849	73849	73850
17554	23753	2	applied	\N	\N	\N	\N	73851	73851	73852
17561	23754	0	applied	\N	\N	\N	\N	73858	73858	73859
17561	23755	1	applied	\N	\N	\N	\N	73860	73860	73861
17561	23756	2	applied	\N	\N	\N	\N	73862	73862	73863
17572	23769	0	applied	\N	\N	\N	\N	73903	73903	73904
17572	23770	1	applied	\N	\N	\N	\N	73905	73905	73906
17572	23771	2	applied	\N	\N	\N	\N	73907	73907	73908
17572	23772	3	applied	\N	\N	\N	\N	73909	73909	73910
17572	23773	4	applied	\N	\N	\N	\N	73911	73911	73912
17572	23774	5	applied	\N	\N	\N	\N	73913	73913	73914
17574	23775	0	applied	\N	\N	\N	\N	73931	73931	73932
17574	23776	1	applied	\N	\N	\N	\N	73933	73933	73934
17574	23777	2	applied	\N	\N	\N	\N	73935	73935	73936
17584	23784	0	applied	\N	\N	\N	\N	73964	73964	73965
17584	23785	1	applied	\N	\N	\N	\N	73966	73966	73967
17584	23786	2	applied	\N	\N	\N	\N	73968	73968	73969
17584	23787	3	applied	\N	\N	\N	\N	73970	73970	73971
17584	23788	4	applied	\N	\N	\N	\N	73972	73972	73973
17584	23789	5	applied	\N	\N	\N	\N	73974	73974	73975
17584	23790	6	applied	\N	\N	\N	\N	73976	73976	73977
17584	23791	7	applied	\N	\N	\N	\N	73978	73978	73979
17584	23792	8	applied	\N	\N	\N	\N	73980	73980	73981
17586	23784	0	applied	\N	\N	\N	\N	73964	73964	73965
17586	23785	1	applied	\N	\N	\N	\N	73966	73966	73967
17586	23786	2	applied	\N	\N	\N	\N	73968	73968	73969
17586	23787	3	applied	\N	\N	\N	\N	73970	73970	73971
17586	23788	4	applied	\N	\N	\N	\N	73972	73972	73973
17586	23789	5	applied	\N	\N	\N	\N	73974	73974	73975
17586	23790	6	applied	\N	\N	\N	\N	73976	73976	73977
17586	23791	7	applied	\N	\N	\N	\N	73978	73978	73979
17586	23792	8	applied	\N	\N	\N	\N	73980	73980	73981
17589	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17589	23800	1	applied	\N	\N	\N	\N	74002	74002	74003
17589	23801	2	applied	\N	\N	\N	\N	74004	74004	74005
17589	23802	3	applied	\N	\N	\N	\N	74006	74006	74007
17591	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17591	23800	1	applied	\N	\N	\N	\N	74002	74002	74003
17591	23801	2	applied	\N	\N	\N	\N	74004	74004	74005
17591	23802	3	applied	\N	\N	\N	\N	74006	74006	74007
17595	23806	0	applied	\N	\N	\N	\N	74026	74026	74027
17595	23807	1	applied	\N	\N	\N	\N	74028	74028	74029
17595	23808	3	applied	\N	\N	\N	\N	74031	74031	74032
17597	23809	0	applied	\N	\N	\N	\N	74037	74037	74038
17597	23810	1	applied	\N	\N	\N	\N	74039	74039	74040
17597	23811	2	applied	\N	\N	\N	\N	74041	74041	74042
17605	23817	0	applied	\N	\N	\N	\N	74103	74103	74104
17605	23818	1	applied	\N	\N	\N	\N	74105	74105	74106
17605	23819	2	applied	\N	\N	\N	\N	74107	74107	74108
17605	23815	3	applied	\N	\N	\N	\N	74098	74098	74099
17605	23816	4	applied	\N	\N	\N	\N	74100	74100	74101
17605	23812	5	applied	\N	\N	\N	\N	74048	74048	74110
17605	23820	6	applied	\N	\N	\N	\N	74111	74111	74112
17605	23821	7	applied	\N	\N	\N	\N	74113	74113	74114
17605	23822	8	applied	\N	\N	\N	\N	74115	74115	74116
17607	23817	0	applied	\N	\N	\N	\N	74103	74103	74104
17607	23818	1	applied	\N	\N	\N	\N	74105	74105	74106
17607	23819	2	applied	\N	\N	\N	\N	74107	74107	74108
17607	23823	3	applied	\N	\N	\N	\N	74118	74118	74119
17607	23824	4	applied	\N	\N	\N	\N	74120	74120	74121
17607	23812	5	applied	\N	\N	\N	\N	74048	74048	74124
17607	23820	6	applied	\N	\N	\N	\N	74111	74111	74125
17607	23821	7	applied	\N	\N	\N	\N	74113	74113	74126
17607	23822	8	applied	\N	\N	\N	\N	74115	74115	74127
17607	23825	9	applied	\N	\N	\N	\N	74128	74128	74129
17532	23712	2	applied	\N	\N	\N	\N	73734	73734	73735
17540	23731	0	applied	\N	\N	\N	\N	73784	73784	73785
17540	23732	1	applied	\N	\N	\N	\N	73786	73786	73787
17540	23733	2	applied	\N	\N	\N	\N	73788	73788	73789
17543	23734	0	applied	\N	\N	\N	\N	73795	73795	73796
17543	23735	1	applied	\N	\N	\N	\N	73797	73797	73798
17543	23736	2	applied	\N	\N	\N	\N	73799	73799	73800
17543	23737	3	applied	\N	\N	\N	\N	73801	73801	73802
17543	23738	4	applied	\N	\N	\N	\N	73803	73803	73804
17547	23742	0	applied	\N	\N	\N	\N	73819	73819	73820
17547	23743	1	applied	\N	\N	\N	\N	73821	73821	73822
17547	23744	2	applied	\N	\N	\N	\N	73823	73823	73824
17549	23745	0	applied	\N	\N	\N	\N	73828	73828	73829
17549	23746	1	applied	\N	\N	\N	\N	73830	73830	73831
17549	23747	2	applied	\N	\N	\N	\N	73832	73832	73833
17551	23748	0	applied	\N	\N	\N	\N	73837	73837	73838
17551	23749	1	applied	\N	\N	\N	\N	73839	73839	73840
17551	23750	2	applied	\N	\N	\N	\N	73841	73841	73842
17557	23751	0	applied	\N	\N	\N	\N	73847	73847	73848
17557	23752	1	applied	\N	\N	\N	\N	73849	73849	73850
17557	23753	2	applied	\N	\N	\N	\N	73851	73851	73852
17560	23754	0	applied	\N	\N	\N	\N	73858	73858	73859
17560	23755	1	applied	\N	\N	\N	\N	73860	73860	73861
17560	23756	2	applied	\N	\N	\N	\N	73862	73862	73863
17562	23757	0	applied	\N	\N	\N	\N	73868	73868	73869
17562	23758	1	applied	\N	\N	\N	\N	73870	73870	73871
17562	23759	2	applied	\N	\N	\N	\N	73872	73872	73873
17565	23760	0	applied	\N	\N	\N	\N	73878	73878	73879
17565	23761	1	applied	\N	\N	\N	\N	73880	73880	73881
17565	23762	2	applied	\N	\N	\N	\N	73882	73882	73883
17565	23763	3	applied	\N	\N	\N	\N	73884	73884	73885
17565	23764	4	applied	\N	\N	\N	\N	73886	73886	73887
17565	23765	5	applied	\N	\N	\N	\N	73888	73888	73889
17567	23766	0	applied	\N	\N	\N	\N	73893	73893	73894
17567	23767	1	applied	\N	\N	\N	\N	73895	73895	73896
17567	23768	2	applied	\N	\N	\N	\N	73897	73897	73898
17571	23769	0	applied	\N	\N	\N	\N	73903	73903	73904
17571	23770	1	applied	\N	\N	\N	\N	73905	73905	73906
17571	23771	2	applied	\N	\N	\N	\N	73907	73907	73908
17571	23772	3	applied	\N	\N	\N	\N	73909	73909	73910
17571	23773	4	applied	\N	\N	\N	\N	73911	73911	73912
17571	23774	5	applied	\N	\N	\N	\N	73913	73913	73914
17576	23775	0	applied	\N	\N	\N	\N	73931	73931	73932
17576	23776	1	applied	\N	\N	\N	\N	73933	73933	73934
17576	23777	2	applied	\N	\N	\N	\N	73935	73935	73936
17581	23781	0	applied	\N	\N	\N	\N	73951	73951	73952
17581	23783	1	applied	\N	\N	\N	\N	73958	73958	73962
17581	23782	2	applied	\N	\N	\N	\N	73954	73954	73959
17583	23784	0	applied	\N	\N	\N	\N	73964	73964	73965
17583	23785	1	applied	\N	\N	\N	\N	73966	73966	73967
17583	23786	2	applied	\N	\N	\N	\N	73968	73968	73969
17583	23787	3	applied	\N	\N	\N	\N	73970	73970	73971
17583	23788	4	applied	\N	\N	\N	\N	73972	73972	73973
17583	23789	5	applied	\N	\N	\N	\N	73974	73974	73975
17583	23790	6	applied	\N	\N	\N	\N	73976	73976	73977
17583	23791	7	applied	\N	\N	\N	\N	73978	73978	73979
17583	23792	8	applied	\N	\N	\N	\N	73980	73980	73981
17588	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17588	23800	1	applied	\N	\N	\N	\N	74002	74002	74003
17588	23801	2	applied	\N	\N	\N	\N	74004	74004	74005
17588	23802	3	applied	\N	\N	\N	\N	74006	74006	74007
17593	23803	0	applied	\N	\N	\N	\N	74016	74016	74017
17593	23804	1	applied	\N	\N	\N	\N	74018	74018	74019
17593	23805	2	applied	\N	\N	\N	\N	74020	74020	74021
17599	23192	0	applied	\N	\N	\N	\N	74051	74051	72279
17599	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17599	22790	2	applied	\N	\N	\N	\N	71353	71353	71354
17599	22806	3	applied	\N	\N	1000000000	\N	71396	71396	71397
17599	23449	4	applied	\N	\N	\N	\N	74052	74052	72992
17599	23450	5	applied	\N	\N	\N	\N	74053	74053	72994
17599	23451	6	applied	\N	\N	\N	\N	74054	74054	72996
17599	23452	7	applied	\N	\N	\N	\N	74055	74055	72998
17599	23453	8	applied	\N	\N	\N	\N	74056	74056	73000
17599	23454	10	applied	\N	\N	\N	\N	74058	74058	73002
17599	23455	11	applied	\N	\N	\N	\N	74059	74059	73004
17599	23394	12	applied	\N	\N	\N	\N	74060	74060	72801
17604	23817	0	applied	\N	\N	\N	\N	74103	74103	74104
17604	23818	1	applied	\N	\N	\N	\N	74105	74105	74106
17604	23819	2	applied	\N	\N	\N	\N	74107	74107	74108
17604	23815	3	applied	\N	\N	\N	\N	74098	74098	74099
17604	23816	4	applied	\N	\N	\N	\N	74100	74100	74101
17606	23817	0	applied	\N	\N	\N	\N	74103	74103	74104
17606	23818	1	applied	\N	\N	\N	\N	74105	74105	74106
17606	23819	2	applied	\N	\N	\N	\N	74107	74107	74108
17606	23823	3	applied	\N	\N	\N	\N	74118	74118	74119
17606	23824	4	applied	\N	\N	\N	\N	74120	74120	74121
17608	23826	0	applied	\N	\N	\N	\N	74132	74132	74133
17608	23827	1	applied	\N	\N	\N	\N	74134	74134	74135
17620	23838	0	applied	\N	\N	\N	\N	74169	74169	74170
17620	23839	1	applied	\N	\N	\N	\N	74171	74171	74172
17620	23840	2	applied	\N	\N	\N	\N	74173	74173	74174
17621	23839	0	applied	\N	\N	\N	\N	74171	74171	74172
17624	23844	0	applied	\N	\N	\N	\N	74190	74190	74191
17624	23845	1	applied	\N	\N	\N	\N	74192	74192	74193
17624	23846	2	applied	\N	\N	\N	\N	74194	74194	74195
17626	23847	0	applied	\N	\N	\N	\N	74199	74199	74200
17626	23848	1	applied	\N	\N	\N	\N	74201	74201	74202
17626	23849	2	applied	\N	\N	\N	\N	74203	74203	74204
17626	23850	3	applied	\N	\N	\N	\N	74205	74205	74206
17626	23851	4	applied	\N	\N	\N	\N	74207	74207	74208
17626	23852	5	applied	\N	\N	\N	\N	74209	74209	74210
17638	23862	0	applied	\N	\N	\N	\N	74334	74334	74335
17638	23863	1	applied	\N	\N	\N	\N	74336	74336	74337
17638	23864	2	applied	\N	\N	\N	\N	74338	74338	74339
17640	23865	0	applied	\N	\N	\N	\N	74345	74345	74346
17640	23866	1	applied	\N	\N	\N	\N	74347	74347	74348
17640	23867	2	applied	\N	\N	\N	\N	74349	74349	74350
17642	23868	0	applied	\N	\N	\N	\N	74355	74355	74356
17642	23869	1	applied	\N	\N	\N	\N	74357	74357	74358
17642	23870	2	applied	\N	\N	\N	\N	74359	74359	74360
17645	23876	0	applied	\N	\N	1000000000	\N	74373	74373	74374
17645	23877	1	applied	\N	\N	\N	\N	74375	74375	74376
17645	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17645	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17645	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17645	23881	5	applied	\N	\N	\N	\N	74383	74383	74384
17645	23882	6	applied	\N	\N	\N	\N	74385	74385	74386
17647	23876	0	applied	\N	\N	1000000000	\N	74373	74373	74374
17647	23877	1	applied	\N	\N	\N	\N	74375	74375	74376
17573	23742	3	applied	\N	\N	\N	\N	73819	73819	73820
17573	23745	4	applied	\N	\N	\N	\N	73828	73828	73829
17573	23748	5	applied	\N	\N	\N	\N	73837	73837	73838
17573	23751	6	applied	\N	\N	\N	\N	73847	73847	73848
17573	23754	7	applied	\N	\N	\N	\N	73858	73858	73859
17573	23757	8	applied	\N	\N	\N	\N	73868	73868	73869
17573	23760	9	applied	\N	\N	\N	\N	73878	73878	73879
17573	23761	10	applied	\N	\N	\N	\N	73880	73880	73881
17573	23766	11	applied	\N	\N	\N	\N	73893	73893	73894
17573	23769	12	applied	\N	\N	\N	\N	73903	73903	73904
17573	23736	13	applied	\N	\N	\N	\N	73799	73799	73800
17573	23737	14	applied	\N	\N	\N	\N	73801	73801	73802
17573	23738	15	applied	\N	\N	\N	\N	73803	73803	73804
17573	23739	16	applied	\N	\N	\N	\N	73806	73806	73807
17573	23744	17	applied	\N	\N	\N	\N	73823	73823	73918
17573	23746	18	applied	\N	\N	\N	\N	73830	73830	73919
17573	23750	19	applied	\N	\N	\N	\N	73841	73841	73822
17573	23752	20	applied	\N	\N	\N	\N	73849	73849	73824
17573	23755	21	applied	\N	\N	\N	\N	73860	73860	73831
17573	23758	22	applied	\N	\N	\N	\N	73870	73870	73920
17573	23763	23	applied	\N	\N	\N	\N	73884	73884	73921
17573	23764	24	applied	\N	\N	\N	\N	73886	73886	73840
17573	23741	25	applied	\N	\N	\N	\N	73815	73815	73922
17573	23743	26	applied	\N	\N	\N	\N	73821	73821	73923
17573	23747	27	applied	\N	\N	\N	\N	73832	73832	73861
17573	23749	28	applied	\N	\N	\N	\N	73839	73839	73863
17573	23753	29	applied	\N	\N	\N	\N	73851	73851	73924
17573	23756	30	applied	\N	\N	\N	\N	73862	73862	73925
17573	23759	31	applied	\N	\N	\N	\N	73872	73872	73926
17573	23762	32	applied	\N	\N	\N	\N	73882	73882	73887
17573	23768	33	applied	\N	\N	\N	\N	73897	73897	73927
17573	23771	34	applied	\N	\N	\N	\N	73907	73907	73928
17573	23765	35	applied	\N	\N	\N	\N	73888	73888	73929
17573	23767	36	applied	\N	\N	\N	\N	73895	73895	73908
17575	23775	0	applied	\N	\N	\N	\N	73931	73931	73932
17575	23776	1	applied	\N	\N	\N	\N	73933	73933	73934
17575	23777	2	applied	\N	\N	\N	\N	73935	73935	73936
17579	23778	0	applied	\N	\N	\N	\N	73943	73943	73944
17579	23779	1	applied	\N	\N	\N	\N	73945	73945	73946
17579	23780	2	applied	\N	\N	\N	\N	73947	73947	73948
17585	23784	0	applied	\N	\N	\N	\N	73964	73964	73965
17585	23785	1	applied	\N	\N	\N	\N	73966	73966	73967
17585	23786	2	applied	\N	\N	\N	\N	73968	73968	73969
17585	23787	3	applied	\N	\N	\N	\N	73970	73970	73971
17585	23788	4	applied	\N	\N	\N	\N	73972	73972	73973
17585	23789	5	applied	\N	\N	\N	\N	73974	73974	73975
17585	23790	6	applied	\N	\N	\N	\N	73976	73976	73977
17585	23791	7	applied	\N	\N	\N	\N	73978	73978	73979
17585	23792	8	applied	\N	\N	\N	\N	73980	73980	73981
17587	23793	0	applied	\N	\N	\N	\N	73986	73986	73987
17587	23794	1	applied	\N	\N	\N	\N	73988	73988	73989
17587	23795	2	applied	\N	\N	\N	\N	73990	73990	73991
17587	23796	3	applied	\N	\N	\N	\N	73992	73992	73993
17587	23797	4	applied	\N	\N	\N	\N	73994	73994	73995
17587	23798	5	applied	\N	\N	\N	\N	73996	73996	73997
17590	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17590	23802	1	applied	\N	\N	\N	\N	74006	74006	74011
17594	23800	0	applied	\N	\N	\N	\N	74002	74002	74003
17594	23803	1	applied	\N	\N	\N	\N	74016	74016	74017
17594	23801	2	applied	\N	\N	\N	\N	74004	74004	74007
17594	23804	3	applied	\N	\N	\N	\N	74018	74018	74019
17594	23805	4	applied	\N	\N	\N	\N	74020	74020	74021
17598	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17598	23758	1	applied	\N	\N	\N	\N	73870	73870	73871
17598	23763	2	applied	\N	\N	\N	\N	73884	73884	74043
17598	23764	3	applied	\N	\N	\N	\N	73886	73886	73925
17598	23768	4	applied	\N	\N	\N	\N	73897	73897	73883
17598	23771	5	applied	\N	\N	\N	\N	73907	73907	73885
17598	23772	6	applied	\N	\N	\N	\N	73909	73909	73887
17598	23777	7	applied	\N	\N	\N	\N	73935	73935	73927
17598	23779	8	applied	\N	\N	\N	\N	73945	73945	73928
17598	23783	9	applied	\N	\N	\N	\N	73958	73958	73896
17598	23787	10	applied	\N	\N	\N	\N	73970	73970	73898
17598	23790	11	applied	\N	\N	\N	\N	73976	73976	73908
17598	23792	12	applied	\N	\N	\N	\N	73980	73980	73910
17598	23795	13	applied	\N	\N	\N	\N	73990	73990	74044
17598	23796	14	applied	\N	\N	\N	\N	73992	73992	74045
17598	23801	15	applied	\N	\N	\N	\N	74004	74004	73914
17598	23804	16	applied	\N	\N	\N	\N	74018	74018	74046
17598	23808	17	applied	\N	\N	\N	\N	74031	74031	74047
17598	23811	18	applied	\N	\N	\N	\N	74041	74041	73953
17598	23812	19	applied	\N	\N	\N	\N	74048	74048	74049
17600	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17600	23784	1	applied	\N	\N	\N	\N	73964	73964	73965
17600	23785	2	applied	\N	\N	\N	\N	73966	73966	73967
17600	23786	3	applied	\N	\N	\N	\N	73968	73968	73969
17600	23793	4	applied	\N	\N	\N	\N	73986	73986	73987
17600	23794	5	applied	\N	\N	\N	\N	73988	73988	73989
17600	23800	6	applied	\N	\N	\N	\N	74002	74002	74003
17600	23803	7	applied	\N	\N	\N	\N	74016	74016	74017
17600	23806	8	applied	\N	\N	\N	\N	74026	74026	74027
17600	23809	9	applied	\N	\N	\N	\N	74037	74037	74038
17600	23813	10	applied	\N	\N	\N	\N	74063	74063	74064
17600	23788	11	applied	\N	\N	\N	\N	73972	73972	74065
17600	23789	12	applied	\N	\N	\N	\N	73974	73974	74066
17600	23791	13	applied	\N	\N	\N	\N	73978	73978	74067
17600	23797	14	applied	\N	\N	\N	\N	73994	73994	74068
17600	23798	15	applied	\N	\N	\N	\N	73996	73996	73981
17600	23802	16	applied	\N	\N	\N	\N	74006	74006	74069
17600	23805	17	applied	\N	\N	\N	\N	74020	74020	74070
17600	23807	18	applied	\N	\N	\N	\N	74028	74028	74071
17600	23810	19	applied	\N	\N	\N	\N	74039	74039	74005
17600	23814	20	applied	\N	\N	\N	\N	74072	74072	74007
17602	23813	0	applied	\N	\N	\N	\N	74063	74063	74064
17602	23814	1	applied	\N	\N	\N	\N	74072	74072	74095
17610	23828	0	applied	\N	\N	\N	\N	74137	74137	74138
17610	23829	1	applied	\N	\N	\N	\N	74139	74139	74140
17610	23830	2	applied	\N	\N	\N	\N	74141	74141	74142
17610	23831	3	applied	\N	\N	\N	\N	74143	74143	74144
17614	23832	0	applied	\N	\N	\N	\N	74149	74149	74150
17614	23833	1	applied	\N	\N	\N	\N	74151	74151	74152
17614	23834	2	applied	\N	\N	\N	\N	74153	74153	74154
17616	23835	0	applied	\N	\N	\N	\N	74159	74159	74160
17616	23836	1	applied	\N	\N	\N	\N	74161	74161	74162
17616	23837	2	applied	\N	\N	\N	\N	74163	74163	74164
17618	23838	0	applied	\N	\N	\N	\N	74169	74169	74170
17618	23839	1	applied	\N	\N	\N	\N	74171	74171	74172
17618	23840	2	applied	\N	\N	\N	\N	74173	74173	74174
17628	23847	0	applied	\N	\N	\N	\N	74199	74199	74200
17628	23848	1	applied	\N	\N	\N	\N	74201	74201	74202
17580	23778	1	applied	\N	\N	\N	\N	73943	73943	73944
17580	23781	2	applied	\N	\N	\N	\N	73951	73951	73952
17580	23776	3	applied	\N	\N	\N	\N	73933	73933	73934
17580	23780	4	applied	\N	\N	\N	\N	73947	73947	73953
17580	23782	5	applied	\N	\N	\N	\N	73954	73954	73955
17580	23777	6	applied	\N	\N	\N	\N	73935	73935	73956
17580	23779	7	applied	\N	\N	\N	\N	73945	73945	73957
17580	23783	8	applied	\N	\N	\N	\N	73958	73958	73959
17592	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17592	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17592	23449	2	applied	\N	\N	\N	\N	73227	73227	72992
17592	23450	3	applied	\N	\N	\N	\N	73228	73228	72994
17592	23451	4	applied	\N	\N	\N	\N	73229	73229	72996
17592	23452	5	applied	\N	\N	\N	\N	73230	73230	72998
17592	23453	6	applied	\N	\N	\N	\N	73231	73231	73000
17592	23454	7	applied	\N	\N	\N	\N	73232	73232	73002
17592	23455	8	applied	\N	\N	\N	\N	73233	73233	73004
17592	23394	9	applied	\N	\N	\N	\N	72800	72800	72801
17592	23577	10	applied	\N	\N	\N	\N	73366	73366	73367
17592	23608	11	applied	\N	\N	\N	\N	73449	73449	73450
17592	23456	12	applied	\N	\N	\N	\N	73234	73234	73006
17592	23457	13	applied	\N	\N	\N	\N	73235	73235	73008
17592	23458	14	applied	\N	\N	\N	\N	73236	73236	73010
17592	23459	15	applied	\N	\N	\N	\N	73237	73237	73012
17592	23467	16	applied	\N	\N	\N	\N	73238	73238	73046
17592	23468	17	applied	\N	\N	\N	\N	73239	73239	73048
17592	23469	18	applied	\N	\N	\N	\N	73240	73240	73050
17592	23492	19	applied	\N	\N	\N	\N	73102	73102	73103
17592	23470	20	applied	\N	\N	\N	\N	73241	73241	73052
17592	23473	21	applied	\N	\N	\N	\N	73242	73242	73059
17592	23474	22	applied	\N	\N	\N	\N	73243	73243	73061
17592	23475	23	applied	\N	\N	\N	\N	73244	73244	73063
17592	23476	24	applied	\N	\N	\N	\N	73245	73245	73065
17592	23477	25	applied	\N	\N	\N	\N	73246	73246	73067
17592	23480	26	applied	\N	\N	\N	\N	73247	73247	73077
17592	23481	27	applied	\N	\N	\N	\N	73248	73248	73079
17592	23482	28	applied	\N	\N	\N	\N	73249	73249	73081
17592	23483	29	applied	\N	\N	\N	\N	73250	73250	73083
17592	23484	30	applied	\N	\N	\N	\N	73251	73251	73085
17592	23487	31	applied	\N	\N	\N	\N	73253	73253	73093
17592	23488	32	applied	\N	\N	\N	\N	73254	73254	73095
17592	23491	33	applied	\N	\N	\N	\N	73255	73255	73101
17592	23423	34	applied	\N	\N	\N	\N	72881	72881	72889
17596	23448	0	applied	\N	\N	1000000000	\N	72989	72989	72990
17596	23449	1	applied	\N	\N	\N	\N	72991	72991	72992
17596	23450	2	applied	\N	\N	\N	\N	72993	72993	72994
17596	23451	3	applied	\N	\N	\N	\N	72995	72995	72996
17596	23452	4	applied	\N	\N	\N	\N	72997	72997	72998
17596	23453	5	applied	\N	\N	\N	\N	72999	72999	73000
17596	23454	6	applied	\N	\N	\N	\N	73001	73001	73002
17596	23455	7	applied	\N	\N	\N	\N	73003	73003	73004
17596	23394	8	applied	\N	\N	\N	\N	72800	72800	72801
17596	23577	9	applied	\N	\N	\N	\N	73366	73366	73367
17596	23608	10	applied	\N	\N	\N	\N	73449	73449	73450
17596	23456	11	applied	\N	\N	\N	\N	73005	73005	73006
17596	23457	12	applied	\N	\N	\N	\N	73007	73007	73008
17596	23458	13	applied	\N	\N	\N	\N	73009	73009	73010
17596	23459	14	applied	\N	\N	\N	\N	73011	73011	73012
17596	23467	15	applied	\N	\N	\N	\N	73045	73045	73046
17596	23468	16	applied	\N	\N	\N	\N	73047	73047	73048
17596	23469	17	applied	\N	\N	\N	\N	73049	73049	73050
17596	23382	18	applied	\N	\N	\N	\N	72763	72763	72764
17596	23383	19	applied	\N	\N	\N	\N	72765	72765	72766
17596	23387	20	applied	\N	\N	\N	\N	72775	72775	72776
17596	23399	21	applied	\N	\N	\N	\N	72816	72816	72817
17596	23492	22	applied	\N	\N	\N	\N	73102	73102	73103
17596	23470	23	applied	\N	\N	\N	\N	73051	73051	73052
17596	23473	24	applied	\N	\N	\N	\N	73058	73058	73059
17596	23474	25	applied	\N	\N	\N	\N	73060	73060	73061
17596	23475	26	applied	\N	\N	\N	\N	73062	73062	73063
17596	23476	27	applied	\N	\N	\N	\N	73064	73064	73065
17596	23477	28	applied	\N	\N	\N	\N	73066	73066	73067
17596	23480	29	applied	\N	\N	\N	\N	73076	73076	73077
17596	23481	30	applied	\N	\N	\N	\N	73078	73078	73079
17596	23482	31	applied	\N	\N	\N	\N	73080	73080	73081
17596	23483	32	applied	\N	\N	\N	\N	73082	73082	73083
17596	23484	33	applied	\N	\N	\N	\N	73084	73084	73085
17596	23487	34	applied	\N	\N	\N	\N	73092	73092	73093
17596	23488	35	applied	\N	\N	\N	\N	73094	73094	73095
17596	23491	36	applied	\N	\N	\N	\N	73100	73100	73101
17596	23423	37	applied	\N	\N	\N	\N	72881	72881	72889
17596	23400	38	applied	\N	\N	\N	\N	72818	72818	72819
17596	23407	39	applied	\N	\N	\N	\N	72837	72837	72838
17596	23411	40	applied	\N	\N	\N	\N	72849	72849	72850
17596	23412	41	applied	\N	\N	\N	\N	72851	72851	72852
17596	23417	42	applied	\N	\N	\N	\N	72863	72863	72864
17596	23419	43	applied	\N	\N	\N	\N	72871	72871	72872
17596	23422	44	applied	\N	\N	\N	\N	72879	72879	72880
17596	23426	45	applied	\N	\N	\N	\N	72918	72918	72919
17596	23430	46	applied	\N	\N	\N	\N	72931	72931	72932
17596	23432	47	applied	\N	\N	\N	\N	72938	72938	72939
17596	23433	48	applied	\N	\N	\N	\N	72940	72940	72941
17596	23438	49	applied	\N	\N	\N	\N	72961	72961	72962
17596	23440	50	applied	\N	\N	\N	\N	72967	72967	72968
17596	23441	51	applied	\N	\N	\N	\N	72969	72969	72970
17596	23446	52	applied	\N	\N	\N	\N	72982	72982	72983
17596	23460	53	applied	\N	\N	\N	\N	73013	73013	73014
17596	23461	54	applied	\N	\N	\N	\N	73015	73015	73016
17596	23466	55	applied	\N	\N	\N	\N	73043	73043	73044
17596	23472	56	applied	\N	\N	\N	\N	73056	73056	73057
17596	23479	57	applied	\N	\N	\N	\N	73074	73074	73075
17596	23489	58	applied	\N	\N	\N	\N	73096	73096	73097
17596	23490	59	applied	\N	\N	\N	\N	73098	73098	73099
17596	23506	60	applied	\N	\N	\N	\N	73132	73132	73133
17596	23507	61	applied	\N	\N	\N	\N	73134	73134	73135
17596	23529	62	applied	\N	\N	\N	\N	73183	73183	73184
17596	23538	63	applied	\N	\N	\N	\N	73208	73208	73209
17596	23539	64	applied	\N	\N	\N	\N	73210	73210	73211
17596	23545	65	applied	\N	\N	\N	\N	73293	73293	73294
17596	23546	66	applied	\N	\N	\N	\N	73295	73295	73296
17596	23563	67	applied	\N	\N	\N	\N	73333	73333	73334
17596	23570	68	applied	\N	\N	\N	\N	73349	73349	73350
17596	23573	69	applied	\N	\N	\N	\N	73357	73357	73358
17596	23578	70	applied	\N	\N	\N	\N	73368	73368	73369
17596	23579	71	applied	\N	\N	\N	\N	73370	73370	73371
17596	23585	72	applied	\N	\N	\N	\N	73384	73384	73385
17596	23594	73	applied	\N	\N	\N	\N	73408	73408	73409
17596	23603	74	applied	\N	\N	\N	\N	73431	73431	73432
17596	23610	75	applied	\N	\N	\N	\N	73453	73453	73454
17596	23617	76	applied	\N	\N	\N	\N	73468	73468	73469
17596	23625	77	applied	\N	\N	\N	\N	73489	73489	73490
17596	23627	78	applied	\N	\N	\N	\N	73495	73495	73496
17596	23629	79	applied	\N	\N	\N	\N	73503	73503	73504
17596	23631	80	applied	\N	\N	\N	\N	73508	73508	73509
17596	23633	81	applied	\N	\N	\N	\N	73513	73513	73514
17596	23635	83	applied	\N	\N	\N	\N	73523	73523	73524
17596	23641	84	applied	\N	\N	\N	\N	73539	73539	73540
17596	23644	85	applied	\N	\N	\N	\N	73547	73547	73548
17596	23647	86	applied	\N	\N	\N	\N	73554	73554	73555
17596	23648	87	applied	\N	\N	\N	\N	73556	73556	73557
17596	23653	88	applied	\N	\N	\N	\N	73572	73572	73573
17596	23656	89	applied	\N	\N	\N	\N	73582	73582	73583
17596	23659	90	applied	\N	\N	\N	\N	73590	73590	73591
17596	23660	91	applied	\N	\N	\N	\N	73592	73592	73593
17596	23661	92	applied	\N	\N	\N	\N	73594	73594	73595
17596	23668	93	applied	\N	\N	\N	\N	73616	73616	73617
17596	23670	94	applied	\N	\N	\N	\N	73622	73622	73623
17596	23673	95	applied	\N	\N	\N	\N	73632	73632	73633
17596	23675	96	applied	\N	\N	\N	\N	73638	73638	73639
17596	23678	97	applied	\N	\N	\N	\N	73647	73647	73648
17596	23680	98	applied	\N	\N	\N	\N	73655	73655	73656
17596	23682	99	applied	\N	\N	\N	\N	73662	73662	73663
17596	23683	100	applied	\N	\N	\N	\N	73664	73664	73665
17596	23690	101	applied	\N	\N	\N	\N	73680	73680	73681
17596	23691	102	applied	\N	\N	\N	\N	73682	73682	73683
17596	23692	103	applied	\N	\N	\N	\N	73684	73684	73685
17596	23699	104	applied	\N	\N	\N	\N	73699	73699	73700
17596	23702	105	applied	\N	\N	\N	\N	73707	73707	73708
17596	23493	106	applied	\N	\N	\N	\N	73104	73104	73105
17596	23494	107	applied	\N	\N	\N	\N	73106	73106	73107
17596	23495	108	applied	\N	\N	\N	\N	73108	73108	73109
17596	23496	109	applied	\N	\N	\N	\N	73110	73110	73111
17596	23497	110	applied	\N	\N	\N	\N	73112	73112	73113
17596	23498	111	applied	\N	\N	\N	\N	73114	73114	73115
17596	23499	112	applied	\N	\N	\N	\N	73116	73116	73117
17596	23500	113	applied	\N	\N	\N	\N	73118	73118	73119
17596	23501	114	applied	\N	\N	\N	\N	73120	73120	73121
17596	23508	115	applied	\N	\N	\N	\N	73136	73136	73137
17596	23509	116	applied	\N	\N	\N	\N	73138	73138	73139
17596	23510	117	applied	\N	\N	\N	\N	73140	73140	73141
17596	23511	118	applied	\N	\N	\N	\N	73142	73142	73143
17596	23512	119	applied	\N	\N	\N	\N	73144	73144	73145
17596	23513	120	applied	\N	\N	\N	\N	73146	73146	73147
17596	23514	121	applied	\N	\N	\N	\N	73148	73148	73149
17596	23515	122	applied	\N	\N	\N	\N	73150	73150	73151
17596	23516	123	applied	\N	\N	\N	\N	73152	73152	73153
17596	23517	124	applied	\N	\N	\N	\N	73154	73154	73155
17596	23518	125	applied	\N	\N	\N	\N	73156	73156	73157
17601	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17601	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17601	23449	2	applied	\N	\N	\N	\N	73227	73227	72992
17601	23450	3	applied	\N	\N	\N	\N	73228	73228	72994
17601	23451	4	applied	\N	\N	\N	\N	73229	73229	72996
17601	23452	5	applied	\N	\N	\N	\N	73230	73230	72998
17601	23453	6	applied	\N	\N	\N	\N	73231	73231	73000
17601	23454	7	applied	\N	\N	\N	\N	73232	73232	73002
17601	23455	8	applied	\N	\N	\N	\N	73233	73233	73004
17601	23394	9	applied	\N	\N	\N	\N	72800	72800	72801
17601	23577	10	applied	\N	\N	\N	\N	73366	73366	73367
17601	23608	11	applied	\N	\N	\N	\N	73449	73449	73450
17601	23068	12	applied	\N	\N	\N	\N	72001	72001	72002
17601	23072	13	applied	\N	\N	\N	\N	72010	72010	72011
17601	23073	14	applied	\N	\N	\N	\N	72012	72012	72013
17601	23076	15	applied	\N	\N	\N	\N	72018	72018	72019
17601	23078	16	applied	\N	\N	\N	\N	72022	72022	72023
17601	23081	17	applied	\N	\N	\N	\N	72028	72028	72029
17601	23456	18	applied	\N	\N	\N	\N	73234	73234	73006
17601	23457	19	applied	\N	\N	\N	\N	73235	73235	73008
17601	23458	20	applied	\N	\N	\N	\N	73236	73236	73010
17601	23459	21	applied	\N	\N	\N	\N	73237	73237	73012
17601	23467	22	applied	\N	\N	\N	\N	73238	73238	73046
17601	23468	23	applied	\N	\N	\N	\N	73239	73239	73048
17601	23469	24	applied	\N	\N	\N	\N	73240	73240	73050
17601	23492	25	applied	\N	\N	\N	\N	73102	73102	73103
17601	23470	26	applied	\N	\N	\N	\N	73241	73241	73052
17601	23473	27	applied	\N	\N	\N	\N	73242	73242	73059
17601	23474	28	applied	\N	\N	\N	\N	73243	73243	73061
17601	23475	29	applied	\N	\N	\N	\N	73244	73244	73063
17601	23476	30	applied	\N	\N	\N	\N	73245	73245	73065
17601	23477	31	applied	\N	\N	\N	\N	73246	73246	73067
17601	23480	32	applied	\N	\N	\N	\N	73247	73247	73077
17601	23481	33	applied	\N	\N	\N	\N	73248	73248	73079
17601	23482	34	applied	\N	\N	\N	\N	73249	73249	73081
17601	23483	36	applied	\N	\N	\N	\N	73250	73250	73083
17601	23484	37	applied	\N	\N	\N	\N	73251	73251	73085
17601	23487	38	applied	\N	\N	\N	\N	73253	73253	73093
17601	23488	39	applied	\N	\N	\N	\N	73254	73254	73095
17601	23491	40	applied	\N	\N	\N	\N	73255	73255	73101
17601	23423	41	applied	\N	\N	\N	\N	72881	72881	72889
17601	23084	42	applied	\N	\N	\N	\N	72036	72036	72037
17601	23087	43	applied	\N	\N	\N	\N	72042	72042	72043
17601	23090	44	applied	\N	\N	\N	\N	72060	72060	72061
17601	23093	45	applied	\N	\N	\N	\N	72066	72066	72067
17601	23094	46	applied	\N	\N	\N	\N	72068	72068	72069
17601	23099	47	applied	\N	\N	\N	\N	72080	72080	72081
17601	23100	48	applied	\N	\N	\N	\N	72082	72082	72083
17601	23101	49	applied	\N	\N	\N	\N	72084	72084	72085
17601	23108	50	applied	\N	\N	\N	\N	72095	72095	72096
17601	23109	51	applied	\N	\N	\N	\N	72097	72097	72098
17601	23114	52	applied	\N	\N	\N	\N	72106	72106	72107
17601	23117	53	applied	\N	\N	\N	\N	72112	72112	72113
17601	23119	54	applied	\N	\N	\N	\N	72119	72119	72120
17601	23122	55	applied	\N	\N	\N	\N	72125	72125	72126
17601	23123	56	applied	\N	\N	\N	\N	72127	72127	72128
17601	23124	57	applied	\N	\N	\N	\N	72129	72129	72130
17601	23131	58	applied	\N	\N	\N	\N	72140	72140	72141
17601	23134	59	applied	\N	\N	\N	\N	72146	72146	72147
17601	23156	60	applied	\N	\N	\N	\N	72194	72194	72195
17601	23493	61	applied	\N	\N	\N	\N	73256	73256	73105
17601	23494	62	applied	\N	\N	\N	\N	73257	73257	73107
17601	23495	63	applied	\N	\N	\N	\N	73258	73258	73109
17601	23496	64	applied	\N	\N	\N	\N	73259	73259	73111
17601	23497	65	applied	\N	\N	\N	\N	73260	73260	73113
17601	23498	66	applied	\N	\N	\N	\N	73261	73261	73115
17601	23499	67	applied	\N	\N	\N	\N	73262	73262	73117
17601	23500	68	applied	\N	\N	\N	\N	73263	73263	73119
17601	23501	69	applied	\N	\N	\N	\N	73264	73264	73121
17601	23508	70	applied	\N	\N	\N	\N	73265	73265	73137
17601	23509	71	applied	\N	\N	\N	\N	73266	73266	73139
17601	23510	72	applied	\N	\N	\N	\N	73267	73267	73141
17601	23511	73	applied	\N	\N	\N	\N	73268	73268	73143
17601	23512	74	applied	\N	\N	\N	\N	73269	73269	73145
17601	23513	75	applied	\N	\N	\N	\N	73270	73270	73147
17601	23514	76	applied	\N	\N	\N	\N	73271	73271	73149
17601	23515	77	applied	\N	\N	\N	\N	73272	73272	73151
17601	23516	78	applied	\N	\N	\N	\N	73273	73273	73153
17601	23517	79	applied	\N	\N	\N	\N	73274	73274	73155
17601	23518	80	applied	\N	\N	\N	\N	73275	73275	73157
17601	23523	81	applied	\N	\N	\N	\N	73276	73276	73172
17601	23524	82	applied	\N	\N	\N	\N	73277	73277	73174
17601	23525	83	applied	\N	\N	\N	\N	73278	73278	73176
17601	23526	84	applied	\N	\N	\N	\N	73279	73279	73178
17601	23527	85	applied	\N	\N	\N	\N	73280	73280	73180
17601	23528	86	applied	\N	\N	\N	\N	73281	73281	73182
17601	23532	87	applied	\N	\N	\N	\N	73282	73282	73197
17601	23533	88	applied	\N	\N	\N	\N	73283	73283	73199
17601	23534	89	applied	\N	\N	\N	\N	73284	73284	73201
17601	23535	90	applied	\N	\N	\N	\N	73285	73285	73203
17601	23536	91	applied	\N	\N	\N	\N	73286	73286	73205
17601	23537	92	applied	\N	\N	\N	\N	73287	73287	73207
17601	23540	93	applied	\N	\N	\N	\N	73288	73288	73213
17601	23541	94	applied	\N	\N	\N	\N	73289	73289	73216
17601	23549	95	applied	\N	\N	\N	\N	74076	74076	73303
17601	23550	96	applied	\N	\N	\N	\N	74077	74077	73305
17601	23551	97	applied	\N	\N	\N	\N	74078	74078	73307
17601	23552	98	applied	\N	\N	\N	\N	74079	74079	73309
17601	23553	99	applied	\N	\N	\N	\N	74080	74080	73311
17601	23554	100	applied	\N	\N	\N	\N	74081	74081	73313
17601	23555	101	applied	\N	\N	\N	\N	74082	74082	73315
17601	23556	102	applied	\N	\N	\N	\N	74083	74083	73317
17601	23557	103	applied	\N	\N	\N	\N	74084	74084	73319
17601	23558	104	applied	\N	\N	\N	\N	74085	74085	73321
17601	23135	105	applied	\N	\N	\N	\N	72148	72148	72149
17601	23136	106	applied	\N	\N	\N	\N	72150	72150	72151
17601	23137	107	applied	\N	\N	\N	\N	72152	72152	72153
17601	23146	108	applied	\N	\N	\N	\N	72166	72166	72167
17601	23149	109	applied	\N	\N	\N	\N	72173	72173	72174
17601	23150	110	applied	\N	\N	\N	\N	72175	72175	72176
17601	23155	111	applied	\N	\N	\N	\N	72192	72192	72193
17601	23159	112	applied	\N	\N	\N	\N	72200	72200	72201
17601	23160	113	applied	\N	\N	\N	\N	72202	72202	72203
17601	23165	114	applied	\N	\N	\N	\N	72211	72211	72212
17601	23168	115	applied	\N	\N	\N	\N	72217	72217	72218
17601	23170	116	applied	\N	\N	\N	\N	72223	72223	72224
17601	23174	117	applied	\N	\N	\N	\N	72233	72233	72234
17601	23176	118	applied	\N	\N	\N	\N	72237	72237	72238
17601	23559	119	applied	\N	\N	\N	\N	74086	74086	73323
17601	23560	120	applied	\N	\N	\N	\N	74087	74087	73325
17601	23564	121	applied	\N	\N	\N	\N	74088	74088	73336
17601	23565	122	applied	\N	\N	\N	\N	74089	74089	73338
17601	23566	123	applied	\N	\N	\N	\N	74090	74090	73340
17601	23567	124	applied	\N	\N	\N	\N	74091	74091	73342
17601	23576	125	applied	\N	\N	\N	\N	74092	74092	73365
17603	23815	0	applied	\N	\N	\N	\N	74098	74098	74099
17603	23816	1	applied	\N	\N	\N	\N	74100	74100	74101
17611	23828	0	applied	\N	\N	\N	\N	74137	74137	74138
17611	23829	1	applied	\N	\N	\N	\N	74139	74139	74140
17611	23830	2	applied	\N	\N	\N	\N	74141	74141	74142
17611	23831	3	applied	\N	\N	\N	\N	74143	74143	74144
17612	23828	0	applied	\N	\N	\N	\N	74137	74137	74138
17612	23829	1	applied	\N	\N	\N	\N	74139	74139	74140
17612	23830	2	applied	\N	\N	\N	\N	74141	74141	74142
17612	23831	3	applied	\N	\N	\N	\N	74143	74143	74144
17615	23832	0	applied	\N	\N	\N	\N	74149	74149	74150
17615	23833	1	applied	\N	\N	\N	\N	74151	74151	74152
17615	23834	2	applied	\N	\N	\N	\N	74153	74153	74154
17617	23835	0	applied	\N	\N	\N	\N	74159	74159	74160
17617	23836	1	applied	\N	\N	\N	\N	74161	74161	74162
17617	23837	2	applied	\N	\N	\N	\N	74163	74163	74164
17619	23838	0	applied	\N	\N	\N	\N	74169	74169	74170
17619	23839	1	applied	\N	\N	\N	\N	74171	74171	74172
17619	23840	2	applied	\N	\N	\N	\N	74173	74173	74174
17623	23844	0	applied	\N	\N	\N	\N	74190	74190	74191
17623	23845	1	applied	\N	\N	\N	\N	74192	74192	74193
17623	23846	2	applied	\N	\N	\N	\N	74194	74194	74195
17631	23853	0	applied	\N	\N	\N	\N	74216	74216	74217
17631	23854	1	applied	\N	\N	\N	\N	74218	74218	74219
17631	23855	2	applied	\N	\N	\N	\N	74220	74220	74221
17635	23859	0	applied	\N	\N	\N	\N	74325	74325	74326
17635	23860	1	applied	\N	\N	\N	\N	74327	74327	74328
17635	23861	2	applied	\N	\N	\N	\N	74329	74329	74330
17644	23876	0	applied	\N	\N	1000000000	\N	74373	74373	74374
17644	23877	1	applied	\N	\N	\N	\N	74375	74375	74376
17644	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17644	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17644	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17644	23881	5	applied	\N	\N	\N	\N	74383	74383	74384
17644	23882	6	applied	\N	\N	\N	\N	74385	74385	74386
17649	23890	0	applied	\N	\N	\N	\N	74408	74408	74409
17649	23891	2	applied	\N	\N	\N	\N	74411	74411	74412
17652	23892	0	applied	\N	\N	\N	\N	74541	74541	74542
17652	23893	1	applied	\N	\N	\N	\N	74543	74543	74544
17656	23896	0	applied	\N	\N	\N	\N	74556	74556	74557
17656	23897	1	applied	\N	\N	\N	\N	74558	74558	74559
17660	23898	0	applied	\N	\N	\N	\N	74563	74563	74564
17660	23899	1	applied	\N	\N	\N	\N	74565	74565	74566
17667	23908	0	applied	\N	\N	\N	\N	74591	74591	74592
17667	23909	1	applied	\N	\N	\N	\N	74593	74593	74594
17670	23871	0	applied	\N	\N	1000000000	\N	74363	74363	74364
17670	23876	1	applied	\N	\N	1000000000	\N	74373	74373	74374
17670	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17670	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17670	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17670	23179	5	applied	\N	\N	\N	\N	72245	72245	72246
17670	23181	6	applied	\N	\N	\N	\N	72252	72252	72253
17670	23184	7	applied	\N	\N	\N	\N	72256	72256	72257
17670	23187	8	applied	\N	\N	\N	\N	72263	72263	72264
17670	23189	9	applied	\N	\N	\N	\N	72268	72268	72269
17670	23193	10	applied	\N	\N	\N	\N	72280	72280	72281
17670	23194	11	applied	\N	\N	\N	\N	72282	72282	72283
17670	23199	12	applied	\N	\N	\N	\N	72295	72295	72296
17670	23209	13	applied	\N	\N	\N	\N	72321	72321	72322
17670	23212	14	applied	\N	\N	\N	\N	72329	72329	72330
17670	23213	15	applied	\N	\N	\N	\N	72331	72331	72332
17670	23219	16	applied	\N	\N	\N	\N	72344	72344	72345
17670	23220	17	applied	\N	\N	\N	\N	72346	72346	72347
17670	23226	18	applied	\N	\N	\N	\N	72355	72355	72356
17670	23229	19	applied	\N	\N	\N	\N	72362	72362	72363
17609	23828	0	applied	\N	\N	\N	\N	74137	74137	74138
17609	23829	1	applied	\N	\N	\N	\N	74139	74139	74140
17609	23830	2	applied	\N	\N	\N	\N	74141	74141	74142
17609	23831	3	applied	\N	\N	\N	\N	74143	74143	74144
17613	23832	0	applied	\N	\N	\N	\N	74149	74149	74150
17613	23833	1	applied	\N	\N	\N	\N	74151	74151	74152
17613	23834	2	applied	\N	\N	\N	\N	74153	74153	74154
17622	23841	0	applied	\N	\N	\N	\N	74182	74182	74183
17622	23842	1	applied	\N	\N	\N	\N	74184	74184	74185
17622	23843	2	applied	\N	\N	\N	\N	74186	74186	74187
17625	23844	0	applied	\N	\N	\N	\N	74190	74190	74191
17625	23845	1	applied	\N	\N	\N	\N	74192	74192	74193
17625	23846	2	applied	\N	\N	\N	\N	74194	74194	74195
17627	23847	0	applied	\N	\N	\N	\N	74199	74199	74200
17627	23848	1	applied	\N	\N	\N	\N	74201	74201	74202
17627	23849	2	applied	\N	\N	\N	\N	74203	74203	74204
17627	23850	3	applied	\N	\N	\N	\N	74205	74205	74206
17627	23851	4	applied	\N	\N	\N	\N	74207	74207	74208
17627	23852	5	applied	\N	\N	\N	\N	74209	74209	74210
17629	23853	0	applied	\N	\N	\N	\N	74216	74216	74217
17629	23854	1	applied	\N	\N	\N	\N	74218	74218	74219
17629	23855	2	applied	\N	\N	\N	\N	74220	74220	74221
17632	23192	0	applied	\N	\N	\N	\N	72278	72278	72279
17632	23448	1	applied	\N	\N	1000000000	\N	72989	72989	72990
17632	22885	2	applied	\N	\N	\N	\N	71560	71560	71561
17632	22886	3	applied	\N	\N	\N	\N	71562	71562	71563
17632	22887	4	applied	\N	\N	\N	\N	71568	71568	71569
17632	23449	5	applied	\N	\N	\N	\N	74052	74052	72992
17632	23450	6	applied	\N	\N	\N	\N	74053	74053	72994
17632	23451	7	applied	\N	\N	\N	\N	74054	74054	72996
17632	23452	8	applied	\N	\N	\N	\N	74055	74055	72998
17632	23453	9	applied	\N	\N	\N	\N	74056	74056	73000
17632	23454	10	applied	\N	\N	\N	\N	74058	74058	73002
17632	23455	11	applied	\N	\N	\N	\N	74059	74059	73004
17632	22895	12	applied	\N	\N	\N	\N	71584	71584	71585
17632	22896	13	applied	\N	\N	\N	\N	71586	71586	71587
17632	22902	14	applied	\N	\N	\N	\N	71598	71598	71599
17632	23394	15	applied	\N	\N	\N	\N	72800	72800	72801
17632	23577	16	applied	\N	\N	\N	\N	73366	73366	73367
17632	23608	17	applied	\N	\N	\N	\N	73449	73449	73450
17632	23456	18	applied	\N	\N	\N	\N	74227	74227	73006
17632	23457	19	applied	\N	\N	\N	\N	74228	74228	73008
17632	23458	20	applied	\N	\N	\N	\N	74229	74229	73010
17632	23459	21	applied	\N	\N	\N	\N	74230	74230	73012
17632	23467	22	applied	\N	\N	\N	\N	74231	74231	73046
17632	23468	23	applied	\N	\N	\N	\N	74232	74232	73048
17632	23469	24	applied	\N	\N	\N	\N	74233	74233	73050
17632	22905	25	applied	\N	\N	\N	\N	71605	71605	71913
17632	22908	26	applied	\N	\N	\N	\N	71611	71611	71914
17632	23492	27	applied	\N	\N	\N	\N	73102	73102	73103
17632	23470	28	applied	\N	\N	\N	\N	74234	74234	73052
17632	23473	29	applied	\N	\N	\N	\N	74235	74235	73059
17632	23474	30	applied	\N	\N	\N	\N	74236	74236	73061
17632	23475	31	applied	\N	\N	\N	\N	74237	74237	73063
17632	23476	32	applied	\N	\N	\N	\N	74238	74238	73065
17632	23477	33	applied	\N	\N	\N	\N	74239	74239	73067
17632	23480	34	applied	\N	\N	\N	\N	74240	74240	73077
17632	23481	35	applied	\N	\N	\N	\N	74241	74241	73079
17632	23482	36	applied	\N	\N	\N	\N	74242	74242	73081
17632	23483	37	applied	\N	\N	\N	\N	74243	74243	73083
17632	23484	38	applied	\N	\N	\N	\N	74244	74244	73085
17632	23487	39	applied	\N	\N	\N	\N	74245	74245	73093
17632	23488	40	applied	\N	\N	\N	\N	74246	74246	73095
17632	23491	41	applied	\N	\N	\N	\N	74247	74247	73101
17632	22912	42	applied	\N	\N	\N	\N	71625	71625	71915
17632	22915	43	applied	\N	\N	\N	\N	71632	71632	71916
17632	22921	44	applied	\N	\N	\N	\N	71648	71648	71917
17632	22922	45	applied	\N	\N	\N	\N	71650	71650	71918
17632	22923	46	applied	\N	\N	\N	\N	71652	71652	71919
17632	22930	47	applied	\N	\N	\N	\N	71669	71669	71920
17632	22934	48	applied	\N	\N	\N	\N	71676	71676	71921
17632	22937	49	applied	\N	\N	\N	\N	71683	71683	71922
17632	22940	51	applied	\N	\N	\N	\N	71691	71691	71923
17632	22944	52	applied	\N	\N	\N	\N	71702	71702	71924
17632	22947	53	applied	\N	\N	\N	\N	71709	71709	71925
17632	22948	54	applied	\N	\N	\N	\N	71711	71711	71926
17632	22953	55	applied	\N	\N	\N	\N	71719	71719	71927
17632	22956	56	applied	\N	\N	\N	\N	71727	71727	71928
17632	22959	57	applied	\N	\N	\N	\N	71741	71741	71929
17632	22962	58	applied	\N	\N	\N	\N	71749	71749	74249
17632	22966	59	applied	\N	\N	\N	\N	71758	71758	74250
17632	22969	60	applied	\N	\N	\N	\N	71764	71764	74251
17632	22972	61	applied	\N	\N	\N	\N	71775	71775	74252
17632	23423	62	applied	\N	\N	\N	\N	72881	72881	72889
17632	23156	63	applied	\N	\N	\N	\N	72194	72194	72195
17632	23493	64	applied	\N	\N	\N	\N	74253	74253	73105
17632	23494	65	applied	\N	\N	\N	\N	74254	74254	73107
17632	23495	66	applied	\N	\N	\N	\N	74255	74255	73109
17632	23496	67	applied	\N	\N	\N	\N	74256	74256	73111
17632	23497	68	applied	\N	\N	\N	\N	74257	74257	73113
17632	23498	69	applied	\N	\N	\N	\N	74258	74258	73115
17632	23499	70	applied	\N	\N	\N	\N	74259	74259	73117
17632	23500	71	applied	\N	\N	\N	\N	74260	74260	73119
17632	23501	72	applied	\N	\N	\N	\N	74261	74261	73121
17632	23508	73	applied	\N	\N	\N	\N	74262	74262	73137
17632	23509	74	applied	\N	\N	\N	\N	74263	74263	73139
17632	23510	75	applied	\N	\N	\N	\N	74264	74264	73141
17632	23511	76	applied	\N	\N	\N	\N	74265	74265	73143
17632	23512	77	applied	\N	\N	\N	\N	74266	74266	73145
17632	23513	78	applied	\N	\N	\N	\N	74267	74267	73147
17632	23514	79	applied	\N	\N	\N	\N	74268	74268	73149
17632	23515	80	applied	\N	\N	\N	\N	74269	74269	73151
17632	23516	81	applied	\N	\N	\N	\N	74270	74270	73153
17632	23517	82	applied	\N	\N	\N	\N	74271	74271	73155
17632	23518	83	applied	\N	\N	\N	\N	74272	74272	73157
17632	23523	84	applied	\N	\N	\N	\N	74273	74273	73172
17632	23524	85	applied	\N	\N	\N	\N	74274	74274	73174
17632	23525	86	applied	\N	\N	\N	\N	74275	74275	73176
17632	23526	87	applied	\N	\N	\N	\N	74276	74276	73178
17632	23527	88	applied	\N	\N	\N	\N	74277	74277	73180
17632	23528	89	applied	\N	\N	\N	\N	74278	74278	73182
17632	23532	90	applied	\N	\N	\N	\N	74279	74279	73197
17632	23533	91	applied	\N	\N	\N	\N	74280	74280	73199
17632	23534	92	applied	\N	\N	\N	\N	74281	74281	73201
17632	23535	93	applied	\N	\N	\N	\N	74282	74282	73203
17632	23536	94	applied	\N	\N	\N	\N	74283	74283	73205
17632	23537	95	applied	\N	\N	\N	\N	74284	74284	73207
17632	23540	96	applied	\N	\N	\N	\N	74285	74285	73213
17632	23541	97	applied	\N	\N	\N	\N	74286	74286	73216
17632	23549	98	applied	\N	\N	\N	\N	74287	74287	73303
17628	23849	2	applied	\N	\N	\N	\N	74203	74203	74204
17628	23850	3	applied	\N	\N	\N	\N	74205	74205	74206
17628	23851	4	applied	\N	\N	\N	\N	74207	74207	74208
17628	23852	5	applied	\N	\N	\N	\N	74209	74209	74210
17630	23853	0	applied	\N	\N	\N	\N	74216	74216	74217
17630	23854	1	applied	\N	\N	\N	\N	74218	74218	74219
17630	23855	2	applied	\N	\N	\N	\N	74220	74220	74221
17634	23859	0	applied	\N	\N	\N	\N	74325	74325	74326
17634	23860	1	applied	\N	\N	\N	\N	74327	74327	74328
17634	23861	2	applied	\N	\N	\N	\N	74329	74329	74330
17637	23862	0	applied	\N	\N	\N	\N	74334	74334	74335
17637	23863	1	applied	\N	\N	\N	\N	74336	74336	74337
17637	23864	2	applied	\N	\N	\N	\N	74338	74338	74339
17646	23876	0	applied	\N	\N	1000000000	\N	74373	74373	74374
17646	23877	1	applied	\N	\N	\N	\N	74375	74375	74376
17646	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17646	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17646	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17646	23881	5	applied	\N	\N	\N	\N	74383	74383	74384
17646	23882	6	applied	\N	\N	\N	\N	74385	74385	74386
17655	23892	0	applied	\N	\N	\N	\N	74541	74541	74542
17655	23894	1	applied	\N	\N	\N	\N	74550	74550	74551
17655	23893	2	applied	\N	\N	\N	\N	74543	74543	74544
17655	23895	3	applied	\N	\N	\N	\N	74552	74552	74553
17663	23904	0	applied	\N	\N	\N	\N	74579	74579	74580
17663	23905	1	applied	\N	\N	\N	\N	74581	74581	74582
17663	23906	2	applied	\N	\N	\N	\N	74583	74583	74584
17663	23907	3	applied	\N	\N	\N	\N	74585	74585	74586
17666	23908	0	applied	\N	\N	\N	\N	74591	74591	74592
17666	23909	1	applied	\N	\N	\N	\N	74593	74593	74594
17672	23914	0	applied	\N	\N	\N	\N	74657	74657	74658
17672	23915	1	applied	\N	\N	\N	\N	74659	74659	74660
17673	23916	0	applied	\N	\N	\N	\N	74665	74665	74666
17673	23917	1	applied	\N	\N	\N	\N	74667	74667	74668
17673	23918	2	applied	\N	\N	\N	\N	74669	74669	74670
17673	23919	3	applied	\N	\N	\N	\N	74671	74671	74672
17673	23920	4	applied	\N	\N	\N	\N	74673	74673	74674
17673	23921	5	applied	\N	\N	\N	\N	74675	74675	74676
17673	23922	6	applied	\N	\N	\N	\N	74677	74677	74678
17673	23923	7	applied	\N	\N	\N	\N	74679	74679	74680
17673	23924	8	applied	\N	\N	\N	\N	74681	74681	74682
17673	23925	9	applied	\N	\N	\N	\N	74683	74683	74684
17675	23926	0	applied	\N	\N	\N	\N	74689	74689	74690
17675	23927	1	applied	\N	\N	\N	\N	74691	74691	74692
17684	23934	0	applied	\N	\N	1000000000	\N	74714	74714	74715
17684	23935	1	applied	\N	\N	\N	\N	74716	74716	74717
17684	23936	2	applied	\N	\N	\N	\N	74718	74718	74719
17687	23937	0	applied	\N	\N	\N	\N	74723	74723	74724
17687	23938	1	applied	\N	\N	\N	\N	74725	74725	74726
17693	23957	0	applied	\N	\N	\N	\N	74775	74775	74776
17693	23958	1	applied	\N	\N	\N	\N	74777	74777	74778
17693	23959	2	applied	\N	\N	\N	\N	74779	74779	74780
17693	23960	3	applied	\N	\N	\N	\N	74781	74781	74782
17699	23972	0	applied	\N	\N	\N	\N	74814	74814	74815
17704	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17704	23973	1	applied	\N	\N	\N	\N	74826	74826	74827
17707	23975	0	applied	\N	\N	\N	\N	74838	74838	74839
17707	23976	1	applied	\N	\N	\N	\N	74840	74840	74841
17710	23979	0	applied	\N	\N	\N	\N	74848	74848	74849
17710	23980	1	applied	\N	\N	\N	\N	74850	74850	74851
17713	23981	0	applied	\N	\N	\N	\N	74852	74852	74853
17713	23982	1	applied	\N	\N	\N	\N	74854	74854	74855
17713	23983	2	applied	\N	\N	\N	\N	74856	74856	74857
17713	23984	3	applied	\N	\N	\N	\N	74858	74858	74859
17715	23985	0	applied	\N	\N	\N	\N	74864	74864	74865
17715	23986	1	applied	\N	\N	\N	\N	74866	74866	74867
17715	23987	2	applied	\N	\N	\N	\N	74868	74868	74869
17715	23988	3	applied	\N	\N	\N	\N	74870	74870	74871
17717	23989	0	applied	\N	\N	\N	\N	74876	74876	74877
17717	23990	1	applied	\N	\N	\N	\N	74878	74878	74879
17717	23991	2	applied	\N	\N	\N	\N	74880	74880	74881
17717	23992	3	applied	\N	\N	\N	\N	74882	74882	74883
17722	24000	0	applied	\N	\N	\N	\N	74905	74905	74906
17722	24001	1	applied	\N	\N	\N	\N	74907	74907	74908
17727	24008	0	applied	\N	\N	\N	\N	74925	74925	74926
17727	24009	1	applied	\N	\N	\N	\N	74927	74927	74928
17727	24010	2	applied	\N	\N	\N	\N	74929	74929	74930
17727	24011	3	applied	\N	\N	\N	\N	74931	74931	74932
17727	24012	4	applied	\N	\N	\N	\N	74933	74933	74934
17727	24013	5	applied	\N	\N	\N	\N	74935	74935	74936
17727	24014	6	applied	\N	\N	\N	\N	74937	74937	74938
17732	24022	0	applied	\N	\N	\N	\N	74966	74966	74967
17732	24023	1	applied	\N	\N	\N	\N	74968	74968	74969
17732	24024	2	applied	\N	\N	\N	\N	74970	74970	74971
17732	24025	3	applied	\N	\N	\N	\N	74972	74972	74973
17732	24026	4	applied	\N	\N	\N	\N	74974	74974	74975
17732	24027	5	applied	\N	\N	\N	\N	74976	74976	74977
17739	24058	0	applied	\N	\N	\N	\N	75045	75045	75054
17739	24060	1	applied	\N	\N	\N	\N	75050	75050	75059
17749	24067	0	applied	\N	\N	\N	\N	75088	75088	75089
17749	24068	1	applied	\N	\N	\N	\N	75090	75090	75091
17749	24069	2	applied	\N	\N	\N	\N	75092	75092	75093
17749	24070	3	applied	\N	\N	\N	\N	75094	75094	75095
17757	24081	0	applied	\N	\N	\N	\N	75128	75128	75129
17757	24082	1	applied	\N	\N	\N	\N	75130	75130	75131
17757	24083	2	applied	\N	\N	\N	\N	75132	75132	75133
17757	24084	3	applied	\N	\N	\N	\N	75134	75134	75135
17757	24085	4	applied	\N	\N	\N	\N	75136	75136	75137
17757	24086	5	applied	\N	\N	\N	\N	75138	75138	75139
17757	24087	6	applied	\N	\N	\N	\N	75140	75140	75141
17757	24088	7	applied	\N	\N	\N	\N	75142	75142	75143
17757	24089	8	applied	\N	\N	\N	\N	75144	75144	75145
17757	24090	9	applied	\N	\N	\N	\N	75146	75146	75147
17757	24091	10	applied	\N	\N	\N	\N	75148	75148	75149
17757	24092	11	applied	\N	\N	\N	\N	75150	75150	75151
17759	24093	0	applied	\N	\N	\N	\N	75156	75156	75157
17759	24094	1	applied	\N	\N	\N	\N	75158	75158	75159
17759	24095	2	applied	\N	\N	\N	\N	75160	75160	75161
17761	24096	0	applied	\N	\N	\N	\N	75164	75164	75165
17761	24097	1	applied	\N	\N	\N	\N	75166	75166	75167
17761	24098	2	applied	\N	\N	\N	\N	75168	75168	75169
17775	24135	0	applied	\N	\N	\N	\N	75257	75257	75258
17775	24136	1	applied	\N	\N	\N	\N	75259	75259	75260
17775	24137	2	applied	\N	\N	\N	\N	75261	75261	75262
17775	24138	3	applied	\N	\N	\N	\N	75263	75263	75264
17775	24139	4	applied	\N	\N	\N	\N	75265	75265	75266
17775	24140	5	applied	\N	\N	\N	\N	75267	75267	75268
17775	24141	6	applied	\N	\N	\N	\N	75269	75269	75270
17775	24142	7	applied	\N	\N	\N	\N	75271	75271	75272
17632	23550	99	applied	\N	\N	\N	\N	74288	74288	73305
17632	23551	100	applied	\N	\N	\N	\N	74289	74289	73307
17632	23552	101	applied	\N	\N	\N	\N	74290	74290	73309
17632	23553	102	applied	\N	\N	\N	\N	74291	74291	73311
17632	23554	103	applied	\N	\N	\N	\N	74292	74292	73313
17632	23555	104	applied	\N	\N	\N	\N	74293	74293	73315
17632	23556	105	applied	\N	\N	\N	\N	74294	74294	73317
17632	23557	106	applied	\N	\N	\N	\N	74295	74295	73319
17632	23558	107	applied	\N	\N	\N	\N	74296	74296	73321
17632	22973	108	applied	\N	\N	\N	\N	71777	71777	74297
17632	22979	109	applied	\N	\N	\N	\N	71789	71789	74298
17632	22980	110	applied	\N	\N	\N	\N	71791	71791	74299
17632	22985	111	applied	\N	\N	\N	\N	71799	71799	74300
17632	22988	112	applied	\N	\N	\N	\N	71808	71808	74301
17632	22991	113	applied	\N	\N	\N	\N	71814	71814	74302
17632	22994	114	applied	\N	\N	\N	\N	71821	71821	74303
17632	22998	115	applied	\N	\N	\N	\N	71830	71830	74304
17632	22999	116	applied	\N	\N	\N	\N	71832	71832	74305
17632	23004	117	applied	\N	\N	\N	\N	71844	71844	74306
17632	23005	118	applied	\N	\N	\N	\N	71846	71846	74307
17632	23011	119	applied	\N	\N	\N	\N	71858	71858	74308
17632	23012	120	applied	\N	\N	\N	\N	71860	71860	74309
17632	23018	121	applied	\N	\N	\N	\N	71870	71870	74310
17632	23021	122	applied	\N	\N	\N	\N	71877	71877	74311
17632	23023	123	applied	\N	\N	\N	\N	71881	71881	74312
17632	23024	124	applied	\N	\N	\N	\N	71883	71883	74313
17632	23030	125	applied	\N	\N	\N	\N	71898	71898	74314
17633	23856	0	applied	\N	\N	\N	\N	74317	74317	74318
17633	23857	1	applied	\N	\N	\N	\N	74319	74319	74320
17633	23858	2	applied	\N	\N	\N	\N	74321	74321	74322
17636	23862	0	applied	\N	\N	\N	\N	74334	74334	74335
17636	23863	1	applied	\N	\N	\N	\N	74336	74336	74337
17636	23864	2	applied	\N	\N	\N	\N	74338	74338	74339
17639	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17639	23523	1	applied	\N	\N	\N	\N	73171	73171	73172
17639	23524	2	applied	\N	\N	\N	\N	73173	73173	73174
17639	23525	3	applied	\N	\N	\N	\N	73175	73175	73176
17639	23577	4	applied	\N	\N	\N	\N	73366	73366	73367
17639	23608	5	applied	\N	\N	\N	\N	73449	73449	73450
17639	23526	6	applied	\N	\N	\N	\N	73177	73177	73178
17639	23527	7	applied	\N	\N	\N	\N	73179	73179	73180
17639	23528	8	applied	\N	\N	\N	\N	73181	73181	73182
17639	23532	9	applied	\N	\N	\N	\N	73196	73196	73197
17639	23533	10	applied	\N	\N	\N	\N	73198	73198	73199
17639	23534	11	applied	\N	\N	\N	\N	73200	73200	73201
17639	23535	12	applied	\N	\N	\N	\N	73202	73202	73203
17639	23536	13	applied	\N	\N	\N	\N	73204	73204	73205
17639	23537	14	applied	\N	\N	\N	\N	73206	73206	73207
17639	23529	15	applied	\N	\N	\N	\N	73183	73183	73184
17639	23538	16	applied	\N	\N	\N	\N	73208	73208	73209
17639	23539	17	applied	\N	\N	\N	\N	73210	73210	73211
17639	23545	18	applied	\N	\N	\N	\N	73293	73293	73294
17639	23546	19	applied	\N	\N	\N	\N	73295	73295	73296
17639	23563	21	applied	\N	\N	\N	\N	73333	73333	73334
17639	23570	22	applied	\N	\N	\N	\N	73349	73349	73350
17639	23573	23	applied	\N	\N	\N	\N	73357	73357	73358
17639	23578	24	applied	\N	\N	\N	\N	73368	73368	73369
17639	23579	25	applied	\N	\N	\N	\N	73370	73370	73371
17639	23585	26	applied	\N	\N	\N	\N	73384	73384	73385
17639	23594	27	applied	\N	\N	\N	\N	73408	73408	73409
17639	23603	28	applied	\N	\N	\N	\N	73431	73431	73432
17639	23610	29	applied	\N	\N	\N	\N	73453	73453	73454
17639	23617	30	applied	\N	\N	\N	\N	73468	73468	73469
17639	23625	31	applied	\N	\N	\N	\N	73489	73489	73490
17639	23627	32	applied	\N	\N	\N	\N	73495	73495	73496
17639	23629	33	applied	\N	\N	\N	\N	73503	73503	73504
17639	23631	34	applied	\N	\N	\N	\N	73508	73508	73509
17639	23633	35	applied	\N	\N	\N	\N	73513	73513	73514
17639	23635	36	applied	\N	\N	\N	\N	73523	73523	73524
17639	23641	37	applied	\N	\N	\N	\N	73539	73539	73540
17639	23644	38	applied	\N	\N	\N	\N	73547	73547	73548
17639	23647	39	applied	\N	\N	\N	\N	73554	73554	73555
17639	23648	40	applied	\N	\N	\N	\N	73556	73556	73557
17639	23653	41	applied	\N	\N	\N	\N	73572	73572	73573
17639	23656	42	applied	\N	\N	\N	\N	73582	73582	73583
17639	23659	43	applied	\N	\N	\N	\N	73590	73590	73591
17639	23660	44	applied	\N	\N	\N	\N	73592	73592	73593
17639	23661	45	applied	\N	\N	\N	\N	73594	73594	73595
17639	23668	46	applied	\N	\N	\N	\N	73616	73616	73617
17639	23670	47	applied	\N	\N	\N	\N	73622	73622	73623
17639	23673	48	applied	\N	\N	\N	\N	73632	73632	73633
17639	23675	49	applied	\N	\N	\N	\N	73638	73638	73639
17639	23678	50	applied	\N	\N	\N	\N	73647	73647	73648
17639	23680	51	applied	\N	\N	\N	\N	73655	73655	73656
17639	23682	52	applied	\N	\N	\N	\N	73662	73662	73663
17639	23683	53	applied	\N	\N	\N	\N	73664	73664	73665
17639	23690	54	applied	\N	\N	\N	\N	73680	73680	73681
17639	23691	55	applied	\N	\N	\N	\N	73682	73682	73683
17639	23692	56	applied	\N	\N	\N	\N	73684	73684	73685
17639	23699	57	applied	\N	\N	\N	\N	73699	73699	73700
17639	23702	58	applied	\N	\N	\N	\N	73707	73707	73708
17639	23540	59	applied	\N	\N	\N	\N	73212	73212	73213
17639	23541	60	applied	\N	\N	\N	\N	73215	73215	73216
17639	23549	61	applied	\N	\N	\N	\N	73302	73302	73303
17639	23550	62	applied	\N	\N	\N	\N	73304	73304	73305
17639	23551	63	applied	\N	\N	\N	\N	73306	73306	73307
17639	23552	64	applied	\N	\N	\N	\N	73308	73308	73309
17639	23553	65	applied	\N	\N	\N	\N	73310	73310	73311
17639	23554	66	applied	\N	\N	\N	\N	73312	73312	73313
17639	23555	67	applied	\N	\N	\N	\N	73314	73314	73315
17639	23556	68	applied	\N	\N	\N	\N	73316	73316	73317
17639	23557	69	applied	\N	\N	\N	\N	73318	73318	73319
17639	23558	70	applied	\N	\N	\N	\N	73320	73320	73321
17639	23707	71	applied	\N	\N	\N	\N	73722	73722	73723
17639	23710	72	applied	\N	\N	\N	\N	73730	73730	73731
17639	23713	73	applied	\N	\N	\N	\N	73738	73738	73739
17639	23716	74	applied	\N	\N	\N	\N	73745	73745	73746
17639	23717	75	applied	\N	\N	\N	\N	73747	73747	73748
17639	23718	76	applied	\N	\N	\N	\N	73749	73749	73750
17639	23719	77	applied	\N	\N	\N	\N	73751	73751	73752
17639	23728	78	applied	\N	\N	\N	\N	73772	73772	73773
17639	23731	79	applied	\N	\N	\N	\N	73784	73784	73785
17639	23734	80	applied	\N	\N	\N	\N	73795	73795	73796
17639	23735	81	applied	\N	\N	\N	\N	73797	73797	73798
17639	23740	82	applied	\N	\N	\N	\N	73813	73813	73814
17639	23742	83	applied	\N	\N	\N	\N	73819	73819	73820
17639	23745	84	applied	\N	\N	\N	\N	73828	73828	73829
17639	23748	85	applied	\N	\N	\N	\N	73837	73837	73838
17639	23751	86	applied	\N	\N	\N	\N	73847	73847	73848
17639	23754	87	applied	\N	\N	\N	\N	73858	73858	73859
17639	23757	88	applied	\N	\N	\N	\N	73868	73868	73869
17639	23760	89	applied	\N	\N	\N	\N	73878	73878	73879
17639	23761	90	applied	\N	\N	\N	\N	73880	73880	73881
17639	23766	91	applied	\N	\N	\N	\N	73893	73893	73894
17639	23769	92	applied	\N	\N	\N	\N	73903	73903	73904
17639	23770	93	applied	\N	\N	\N	\N	73905	73905	73906
17639	23775	94	applied	\N	\N	\N	\N	73931	73931	73932
17639	23778	95	applied	\N	\N	\N	\N	73943	73943	73944
17639	23781	96	applied	\N	\N	\N	\N	73951	73951	73952
17639	23559	97	applied	\N	\N	\N	\N	73322	73322	73323
17639	23560	98	applied	\N	\N	\N	\N	73324	73324	73325
17639	23564	99	applied	\N	\N	\N	\N	73335	73335	73336
17639	23565	100	applied	\N	\N	\N	\N	73337	73337	73338
17639	23566	101	applied	\N	\N	\N	\N	73339	73339	73340
17639	23567	102	applied	\N	\N	\N	\N	73341	73341	73342
17639	23576	103	applied	\N	\N	\N	\N	73364	73364	73365
17639	23580	104	applied	\N	\N	\N	\N	73372	73372	73373
17639	23586	105	applied	\N	\N	\N	\N	73386	73386	73387
17639	23587	106	applied	\N	\N	\N	\N	73388	73388	73389
17639	23588	107	applied	\N	\N	\N	\N	73390	73390	73391
17639	23589	108	applied	\N	\N	\N	\N	73392	73392	73393
17639	23590	109	applied	\N	\N	\N	\N	73394	73394	73395
17639	23593	110	applied	\N	\N	\N	\N	73406	73406	73407
17639	23595	111	applied	\N	\N	\N	\N	73410	73410	73411
17639	23596	112	applied	\N	\N	\N	\N	73412	73412	73413
17639	23597	113	applied	\N	\N	\N	\N	73414	73414	73415
17639	23598	114	applied	\N	\N	\N	\N	73416	73416	73417
17639	23601	115	applied	\N	\N	\N	\N	73427	73427	73428
17639	23602	116	applied	\N	\N	\N	\N	73429	73429	73430
17639	23604	117	applied	\N	\N	\N	\N	73433	73433	73434
17639	23605	118	applied	\N	\N	\N	\N	73435	73435	73436
17639	23609	119	applied	\N	\N	\N	\N	73451	73451	73452
17639	23611	120	applied	\N	\N	\N	\N	73455	73455	73456
17639	23612	121	applied	\N	\N	\N	\N	73457	73457	73458
17639	23613	122	applied	\N	\N	\N	\N	73459	73459	73460
17639	23618	123	applied	\N	\N	\N	\N	73470	73470	73471
17639	23619	124	applied	\N	\N	\N	\N	73472	73472	73473
17639	23620	125	applied	\N	\N	\N	\N	73474	73474	73475
17641	23865	0	applied	\N	\N	\N	\N	74345	74345	74346
17641	23866	1	applied	\N	\N	\N	\N	74347	74347	74348
17641	23867	2	applied	\N	\N	\N	\N	74349	74349	74350
17643	23871	0	applied	\N	\N	1000000000	\N	74363	74363	74364
17643	23872	1	applied	\N	\N	\N	\N	74365	74365	74366
17643	23873	2	applied	\N	\N	\N	\N	74367	74367	74368
17643	23874	3	applied	\N	\N	\N	\N	74369	74369	74370
17643	23875	4	applied	\N	\N	\N	\N	74371	74371	74372
17648	23883	0	applied	\N	\N	\N	\N	74393	74393	74394
17648	23884	1	applied	\N	\N	\N	\N	74395	74395	74396
17648	23885	2	applied	\N	\N	\N	\N	74397	74397	74398
17648	23886	3	applied	\N	\N	\N	\N	74399	74399	74400
17648	23887	4	applied	\N	\N	\N	\N	74401	74401	74402
17648	23888	5	applied	\N	\N	\N	\N	74403	74403	74404
17648	23889	6	applied	\N	\N	\N	\N	74405	74405	74406
17651	23035	0	applied	\N	\N	\N	\N	71932	71932	74418
17651	23036	1	applied	\N	\N	\N	\N	71934	71934	74419
17651	23041	2	applied	\N	\N	\N	\N	71942	71942	74420
17651	23871	3	applied	\N	\N	1000000000	\N	74363	74363	74364
17651	23876	4	applied	\N	\N	1000000000	\N	74373	74373	74374
17651	23044	5	applied	\N	\N	\N	\N	71948	71948	74421
17651	23045	6	applied	\N	\N	\N	\N	71950	71950	74422
17651	23050	7	applied	\N	\N	\N	\N	71961	71961	74423
17651	23053	8	applied	\N	\N	\N	\N	71969	71969	74424
17651	23056	9	applied	\N	\N	\N	\N	71978	71978	74425
17651	23057	10	applied	\N	\N	\N	\N	71980	71980	74426
17651	23062	11	applied	\N	\N	\N	\N	71991	71991	74427
17651	23065	12	applied	\N	\N	\N	\N	71995	71995	74428
17651	23068	13	applied	\N	\N	\N	\N	72001	72001	74429
17651	23072	14	applied	\N	\N	\N	\N	72010	72010	74430
17651	23073	15	applied	\N	\N	\N	\N	72012	72012	74431
17651	23076	16	applied	\N	\N	\N	\N	72018	72018	74432
17651	23078	17	applied	\N	\N	\N	\N	72022	72022	74433
17651	23081	18	applied	\N	\N	\N	\N	72028	72028	74434
17651	23084	19	applied	\N	\N	\N	\N	72036	72036	74435
17651	23087	20	applied	\N	\N	\N	\N	72042	72042	74436
17651	23090	21	applied	\N	\N	\N	\N	72060	72060	74437
17651	23093	22	applied	\N	\N	\N	\N	72066	72066	74438
17651	23094	23	applied	\N	\N	\N	\N	72068	72068	74439
17651	23099	24	applied	\N	\N	\N	\N	72080	72080	74440
17651	23100	25	applied	\N	\N	\N	\N	72082	72082	74441
17651	23101	26	applied	\N	\N	\N	\N	72084	72084	74442
17651	23108	27	applied	\N	\N	\N	\N	72095	72095	74443
17651	23109	28	applied	\N	\N	\N	\N	72097	72097	74444
17651	23114	29	applied	\N	\N	\N	\N	72106	72106	74445
17651	23117	30	applied	\N	\N	\N	\N	72112	72112	74446
17651	23119	31	applied	\N	\N	\N	\N	72119	72119	74447
17651	23122	32	applied	\N	\N	\N	\N	72125	72125	74448
17651	23123	33	applied	\N	\N	\N	\N	72127	72127	74449
17651	23124	34	applied	\N	\N	\N	\N	72129	72129	74450
17651	23131	35	applied	\N	\N	\N	\N	72140	72140	74451
17651	23134	36	applied	\N	\N	\N	\N	72146	72146	74452
17651	23878	37	applied	\N	\N	1000000000	\N	74377	74377	74378
17651	23879	38	applied	\N	\N	1000000000	\N	74379	74379	74380
17651	23880	39	applied	\N	\N	1000000000	\N	74381	74381	74382
17651	23135	40	applied	\N	\N	\N	\N	72148	72148	74453
17651	23136	41	applied	\N	\N	\N	\N	72150	72150	74454
17651	23137	42	applied	\N	\N	\N	\N	72152	72152	74455
17651	23146	43	applied	\N	\N	\N	\N	72166	72166	74456
17651	23149	44	applied	\N	\N	\N	\N	72173	72173	74457
17651	23150	45	applied	\N	\N	\N	\N	72175	72175	74458
17651	23155	46	applied	\N	\N	\N	\N	72192	72192	74459
17651	23159	47	applied	\N	\N	\N	\N	72200	72200	74460
17651	23160	48	applied	\N	\N	\N	\N	72202	72202	74461
17651	23165	49	applied	\N	\N	\N	\N	72211	72211	74462
17651	23168	51	applied	\N	\N	\N	\N	72217	72217	74464
17651	23170	52	applied	\N	\N	\N	\N	72223	72223	74465
17651	23174	53	applied	\N	\N	\N	\N	72233	72233	74466
17651	23176	54	applied	\N	\N	\N	\N	72237	72237	74467
17651	23179	55	applied	\N	\N	\N	\N	72245	72245	74468
17651	23181	56	applied	\N	\N	\N	\N	72252	72252	74469
17651	23184	57	applied	\N	\N	\N	\N	72256	72256	74470
17651	23187	58	applied	\N	\N	\N	\N	72263	72263	74471
17651	23189	59	applied	\N	\N	\N	\N	72268	72268	74472
17651	23193	60	applied	\N	\N	\N	\N	72280	72280	74473
17651	23194	61	applied	\N	\N	\N	\N	72282	72282	74474
17651	23199	62	applied	\N	\N	\N	\N	72295	72295	74475
17651	23209	63	applied	\N	\N	\N	\N	72321	72321	74476
17651	23212	64	applied	\N	\N	\N	\N	72329	72329	74477
17651	23213	65	applied	\N	\N	\N	\N	72331	72331	74478
17651	23219	66	applied	\N	\N	\N	\N	72344	72344	74479
17647	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17647	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17647	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17647	23881	5	applied	\N	\N	\N	\N	74383	74383	74384
17647	23882	6	applied	\N	\N	\N	\N	74385	74385	74386
17650	23890	0	applied	\N	\N	\N	\N	74408	74408	74409
17650	23891	2	applied	\N	\N	\N	\N	74411	74411	74412
17654	23894	0	applied	\N	\N	\N	\N	74550	74550	74551
17654	23895	1	applied	\N	\N	\N	\N	74552	74552	74553
17657	23896	0	applied	\N	\N	\N	\N	74556	74556	74557
17657	23897	1	applied	\N	\N	\N	\N	74558	74558	74559
17661	23900	0	applied	\N	\N	\N	\N	74569	74569	74570
17661	23901	1	applied	\N	\N	\N	\N	74571	74571	74572
17661	23902	2	applied	\N	\N	\N	\N	74573	74573	74574
17661	23903	3	applied	\N	\N	\N	\N	74575	74575	74576
17664	23908	0	applied	\N	\N	\N	\N	74591	74591	74592
17664	23909	1	applied	\N	\N	\N	\N	74593	74593	74594
17668	23910	0	applied	\N	\N	\N	\N	74600	74600	74601
17668	23911	1	applied	\N	\N	\N	\N	74602	74602	74603
17677	23926	0	applied	\N	\N	\N	\N	74689	74689	74690
17677	23927	1	applied	\N	\N	\N	\N	74691	74691	74692
17681	23932	0	applied	\N	\N	\N	\N	74707	74707	74708
17681	23933	1	applied	\N	\N	\N	\N	74709	74709	74710
17683	23934	0	applied	\N	\N	1000000000	\N	74714	74714	74715
17683	23935	1	applied	\N	\N	\N	\N	74716	74716	74717
17683	23936	2	applied	\N	\N	\N	\N	74718	74718	74719
17686	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17686	23871	1	applied	\N	\N	1000000000	\N	74363	74363	74364
17686	23876	2	applied	\N	\N	1000000000	\N	74373	74373	74374
17686	23878	3	applied	\N	\N	1000000000	\N	74377	74377	74378
17686	23879	4	applied	\N	\N	1000000000	\N	74379	74379	74380
17686	23880	5	applied	\N	\N	1000000000	\N	74381	74381	74382
17686	23934	6	applied	\N	\N	1000000000	\N	74714	74714	74715
17686	23676	7	applied	\N	\N	\N	\N	73640	73640	25661
17686	23873	8	applied	\N	\N	\N	\N	74367	74367	74727
17688	23799	0	applied	\N	\N	\N	\N	74000	74000	74001
17688	23871	1	applied	\N	\N	1000000000	\N	74363	74363	74364
17688	23876	2	applied	\N	\N	1000000000	\N	74373	74373	74374
17688	23878	3	applied	\N	\N	1000000000	\N	74377	74377	74378
17688	23879	4	applied	\N	\N	1000000000	\N	74379	74379	74380
17688	23880	5	applied	\N	\N	1000000000	\N	74381	74381	74382
17688	23934	6	applied	\N	\N	1000000000	\N	74714	74714	74715
17688	23873	7	applied	\N	\N	\N	\N	74367	74367	74731
17690	23939	0	applied	\N	\N	\N	\N	74734	74734	74735
17690	23940	1	applied	\N	\N	\N	\N	74736	74736	74737
17690	23941	2	applied	\N	\N	\N	\N	74738	74738	74739
17690	23942	3	applied	\N	\N	\N	\N	74740	74740	74741
17690	23943	4	applied	\N	\N	\N	\N	74742	74742	74743
17690	23944	5	applied	\N	\N	\N	\N	74744	74744	74745
17690	23945	6	applied	\N	\N	\N	\N	74746	74746	74747
17690	23946	7	applied	\N	\N	\N	\N	74748	74748	74749
17690	23947	8	applied	\N	\N	\N	\N	74750	74750	74751
17690	23948	9	applied	\N	\N	\N	\N	74752	74752	74753
17690	23949	10	applied	\N	\N	\N	\N	74754	74754	74755
17690	23950	11	applied	\N	\N	\N	\N	74756	74756	74757
17690	23951	12	applied	\N	\N	\N	\N	74758	74758	74759
17690	23952	13	applied	\N	\N	\N	\N	74760	74760	74761
17690	23953	14	applied	\N	\N	\N	\N	74762	74762	74763
17690	23954	15	applied	\N	\N	\N	\N	74764	74764	74765
17692	23955	0	applied	\N	\N	\N	\N	74768	74768	74769
17692	23956	1	applied	\N	\N	\N	\N	74770	74770	74771
17700	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17700	23972	1	applied	\N	\N	\N	\N	74814	74814	74815
17702	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17702	23973	1	applied	\N	\N	\N	\N	74826	74826	74827
17702	23974	2	applied	\N	\N	\N	\N	74828	74828	74829
17706	23973	0	applied	\N	\N	\N	\N	74826	74826	74827
17706	23974	1	applied	\N	\N	\N	\N	74828	74828	74829
17711	23981	0	applied	\N	\N	\N	\N	74852	74852	74853
17711	23982	1	applied	\N	\N	\N	\N	74854	74854	74855
17711	23983	2	applied	\N	\N	\N	\N	74856	74856	74857
17711	23984	3	applied	\N	\N	\N	\N	74858	74858	74859
17719	23993	0	applied	\N	\N	1000000000	\N	74884	74884	74885
17719	23994	1	applied	\N	\N	\N	\N	74886	74886	74887
17719	23995	2	applied	\N	\N	\N	\N	74888	74888	74889
17719	23996	3	applied	\N	\N	\N	\N	74890	74890	74891
17719	23997	4	applied	\N	\N	\N	\N	74892	74892	74893
17719	23998	5	applied	\N	\N	\N	\N	74894	74894	74895
17719	23999	6	applied	\N	\N	\N	\N	74896	74896	74897
17721	23993	0	applied	\N	\N	1000000000	\N	74884	74884	74885
17721	23994	1	applied	\N	\N	\N	\N	74886	74886	74887
17721	23995	2	applied	\N	\N	\N	\N	74888	74888	74889
17721	23996	3	applied	\N	\N	\N	\N	74890	74890	74891
17721	23997	4	applied	\N	\N	\N	\N	74892	74892	74893
17721	23998	5	applied	\N	\N	\N	\N	74894	74894	74895
17721	23999	6	applied	\N	\N	\N	\N	74896	74896	74897
17723	24002	0	applied	\N	\N	\N	\N	74911	74911	74912
17723	24003	1	applied	\N	\N	\N	\N	74913	74913	74914
17723	24004	2	applied	\N	\N	\N	\N	74915	74915	74916
17726	24005	0	applied	\N	\N	\N	\N	74919	74919	74920
17726	24006	1	applied	\N	\N	\N	\N	74921	74921	74922
17726	24007	2	applied	\N	\N	\N	\N	74923	74923	74924
17728	24015	0	applied	\N	\N	\N	\N	74941	74941	74942
17728	24016	1	applied	\N	\N	\N	\N	74943	74943	74944
17728	24017	2	applied	\N	\N	\N	\N	74945	74945	74946
17731	24020	0	applied	\N	\N	\N	\N	74959	74959	74960
17731	24021	1	applied	\N	\N	\N	\N	74961	74961	74962
17731	24019	2	applied	\N	\N	\N	\N	74956	74956	74963
17731	24018	3	applied	\N	\N	\N	\N	74954	74954	74964
17734	24036	0	applied	\N	\N	\N	\N	74997	74997	74998
17734	24037	1	applied	\N	\N	\N	\N	74999	74999	74999
17734	24038	2	applied	\N	\N	\N	\N	75000	75000	75001
17734	24039	3	applied	\N	\N	\N	\N	75002	75002	75003
17734	24040	4	applied	\N	\N	\N	\N	75004	75004	75005
17734	24041	5	applied	\N	\N	\N	\N	75006	75006	75007
17734	24042	6	applied	\N	\N	\N	\N	75008	75008	75009
17737	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17737	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17737	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17737	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17737	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17737	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17737	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17745	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17745	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17745	24058	2	applied	\N	\N	\N	\N	75045	75045	75054
17745	24059	3	applied	\N	\N	\N	\N	75048	75048	75042
17745	24060	4	applied	\N	\N	\N	\N	75050	75050	75055
17651	23220	67	applied	\N	\N	\N	\N	72346	72346	74480
17651	23226	68	applied	\N	\N	\N	\N	72355	72355	74481
17651	23229	69	applied	\N	\N	\N	\N	72362	72362	74482
17651	23232	70	applied	\N	\N	\N	\N	72366	72366	74483
17651	23235	71	applied	\N	\N	\N	\N	72375	72375	74484
17651	23238	72	applied	\N	\N	\N	\N	72380	72380	74485
17651	23241	73	applied	\N	\N	\N	\N	72387	72387	74486
17651	23244	74	applied	\N	\N	\N	\N	72397	72397	74487
17651	23247	75	applied	\N	\N	\N	\N	72406	72406	74488
17651	23249	76	applied	\N	\N	\N	\N	72412	72412	74489
17651	23252	77	applied	\N	\N	\N	\N	72418	72418	74490
17651	23254	78	applied	\N	\N	\N	\N	72423	72423	74491
17651	23255	79	applied	\N	\N	\N	\N	72425	72425	74492
17651	23256	80	applied	\N	\N	\N	\N	72427	72427	74493
17651	23263	81	applied	\N	\N	\N	\N	72440	72440	74494
17651	23266	82	applied	\N	\N	\N	\N	72449	72449	74495
17651	23269	83	applied	\N	\N	\N	\N	72456	72456	74496
17651	23270	84	applied	\N	\N	\N	\N	72458	72458	74497
17651	23274	85	applied	\N	\N	\N	\N	72468	72468	74498
17651	23275	86	applied	\N	\N	\N	\N	72470	72470	74499
17651	23280	87	applied	\N	\N	\N	\N	72479	72479	74500
17651	23282	88	applied	\N	\N	\N	\N	72486	72486	74501
17651	23285	89	applied	\N	\N	\N	\N	72499	72499	74502
17651	23288	90	applied	\N	\N	\N	\N	72505	72505	74503
17651	23291	91	applied	\N	\N	\N	\N	72511	72511	74504
17651	23292	92	applied	\N	\N	\N	\N	72513	72513	74505
17651	23297	93	applied	\N	\N	\N	\N	72525	72525	74506
17651	23298	94	applied	\N	\N	\N	\N	72527	72527	74507
17651	23299	95	applied	\N	\N	\N	\N	72529	72529	74508
17651	23305	96	applied	\N	\N	\N	\N	72542	72542	74509
17651	23306	97	applied	\N	\N	\N	\N	72544	72544	74510
17651	23311	98	applied	\N	\N	\N	\N	72556	72556	74511
17651	23315	99	applied	\N	\N	\N	\N	72567	72567	74512
17651	23317	100	applied	\N	\N	\N	\N	72574	72574	74513
17651	23320	101	applied	\N	\N	\N	\N	72581	72581	74514
17651	23321	102	applied	\N	\N	\N	\N	72583	72583	74515
17651	23322	103	applied	\N	\N	\N	\N	72585	72585	74516
17651	23323	104	applied	\N	\N	\N	\N	72587	72587	74517
17651	23332	105	applied	\N	\N	\N	\N	72637	72637	74518
17651	23333	106	applied	\N	\N	\N	\N	72639	72639	74519
17651	23340	107	applied	\N	\N	\N	\N	72656	72656	74520
17651	23341	108	applied	\N	\N	\N	\N	72658	72658	74521
17651	23345	109	applied	\N	\N	\N	\N	72668	72668	74522
17651	23347	110	applied	\N	\N	\N	\N	72674	72674	74523
17651	23348	111	applied	\N	\N	\N	\N	72676	72676	74524
17651	23349	112	applied	\N	\N	\N	\N	72678	72678	74525
17651	23356	113	applied	\N	\N	\N	\N	72695	72695	74526
17651	23357	114	applied	\N	\N	\N	\N	72697	72697	74527
17651	23358	115	applied	\N	\N	\N	\N	72699	72699	74528
17651	23367	116	applied	\N	\N	\N	\N	72724	72724	74529
17651	23370	117	applied	\N	\N	\N	\N	72732	72732	74530
17651	23373	118	applied	\N	\N	\N	\N	72740	72740	74531
17651	23376	119	applied	\N	\N	\N	\N	72748	72748	74532
17651	23377	120	applied	\N	\N	\N	\N	72750	72750	74533
17651	23382	121	applied	\N	\N	\N	\N	72763	72763	74534
17651	23383	122	applied	\N	\N	\N	\N	72765	72765	74535
17651	23387	123	applied	\N	\N	\N	\N	72775	72775	74536
17651	23399	124	applied	\N	\N	\N	\N	72816	72816	74537
17651	23400	125	applied	\N	\N	\N	\N	72818	72818	74538
17653	23871	0	applied	\N	\N	1000000000	\N	74363	74363	74364
17653	23876	1	applied	\N	\N	1000000000	\N	74373	74373	74374
17653	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17653	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17653	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17653	23873	5	applied	\N	\N	\N	\N	74367	74367	74547
17658	23896	0	applied	\N	\N	\N	\N	74556	74556	74557
17658	23897	1	applied	\N	\N	\N	\N	74558	74558	74559
17659	23898	0	applied	\N	\N	\N	\N	74563	74563	74564
17659	23899	1	applied	\N	\N	\N	\N	74565	74565	74566
17662	23904	0	applied	\N	\N	\N	\N	74579	74579	74580
17662	23905	1	applied	\N	\N	\N	\N	74581	74581	74582
17662	23906	2	applied	\N	\N	\N	\N	74583	74583	74584
17662	23907	3	applied	\N	\N	\N	\N	74585	74585	74586
17665	23908	0	applied	\N	\N	\N	\N	74591	74591	74592
17665	23909	1	applied	\N	\N	\N	\N	74593	74593	74594
17669	23912	0	applied	\N	\N	\N	\N	74606	74606	74607
17669	23913	1	applied	\N	\N	\N	\N	74608	74608	74609
17671	23914	0	applied	\N	\N	\N	\N	74657	74657	74658
17671	23915	1	applied	\N	\N	\N	\N	74659	74659	74660
17678	23871	0	applied	\N	\N	1000000000	\N	74363	74363	74364
17678	23876	1	applied	\N	\N	1000000000	\N	74373	74373	74374
17678	23878	2	applied	\N	\N	1000000000	\N	74377	74377	74378
17678	23879	3	applied	\N	\N	1000000000	\N	74379	74379	74380
17678	23880	4	applied	\N	\N	1000000000	\N	74381	74381	74382
17678	23873	5	applied	\N	\N	\N	\N	74367	74367	74693
17679	23928	0	applied	\N	\N	\N	\N	74695	74695	74696
17679	23929	1	applied	\N	\N	\N	\N	74697	74697	74698
17682	23932	0	applied	\N	\N	\N	\N	74707	74707	74708
17682	23933	1	applied	\N	\N	\N	\N	74709	74709	74710
17695	23961	0	applied	\N	\N	\N	\N	74787	74787	74788
17695	23962	1	applied	\N	\N	\N	\N	74789	74789	74790
17698	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17698	23972	1	applied	\N	\N	\N	\N	74814	74814	74815
17701	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17701	23972	1	applied	\N	\N	\N	\N	74814	74814	74815
17703	23934	0	applied	\N	\N	1000000000	\N	74714	74714	74715
17709	23979	0	applied	\N	\N	\N	\N	74848	74848	74849
17709	23980	1	applied	\N	\N	\N	\N	74850	74850	74851
17712	23934	0	applied	\N	\N	1000000000	\N	74714	74714	74715
17714	23985	0	applied	\N	\N	\N	\N	74864	74864	74865
17714	23986	1	applied	\N	\N	\N	\N	74866	74866	74867
17714	23987	2	applied	\N	\N	\N	\N	74868	74868	74869
17714	23988	3	applied	\N	\N	\N	\N	74870	74870	74871
17724	24002	0	applied	\N	\N	\N	\N	74911	74911	74912
17724	24003	1	applied	\N	\N	\N	\N	74913	74913	74914
17724	24004	2	applied	\N	\N	\N	\N	74915	74915	74916
17729	23996	0	applied	\N	\N	\N	\N	74890	74890	74948
17729	23998	1	applied	\N	\N	\N	\N	74894	74894	74719
17729	24001	2	applied	\N	\N	\N	\N	74907	74907	74949
17729	24003	3	applied	\N	\N	\N	\N	74913	74913	74950
17729	24006	4	applied	\N	\N	\N	\N	74921	74921	74751
17729	24011	5	applied	\N	\N	\N	\N	74931	74931	74951
17729	24012	6	applied	\N	\N	\N	\N	74933	74933	74952
17729	24014	7	applied	\N	\N	\N	\N	74937	74937	74953
17729	24018	8	applied	\N	\N	\N	\N	74954	74954	74755
17729	24017	9	applied	\N	\N	\N	\N	74945	74945	74955
17729	24019	10	applied	\N	\N	\N	\N	74956	74956	74957
17735	24036	0	applied	\N	\N	\N	\N	74997	74997	74998
17670	23232	20	applied	\N	\N	\N	\N	72366	72366	72367
17670	23235	21	applied	\N	\N	\N	\N	72375	72375	72376
17670	23238	22	applied	\N	\N	\N	\N	72380	72380	72381
17670	23241	23	applied	\N	\N	\N	\N	72387	72387	72388
17670	23244	24	applied	\N	\N	\N	\N	72397	72397	72398
17670	23247	25	applied	\N	\N	\N	\N	72406	72406	72407
17670	23249	26	applied	\N	\N	\N	\N	72412	72412	72413
17670	23252	27	applied	\N	\N	\N	\N	72418	72418	72419
17670	23254	28	applied	\N	\N	\N	\N	72423	72423	72424
17670	23255	29	applied	\N	\N	\N	\N	72425	72425	72426
17670	23256	30	applied	\N	\N	\N	\N	72427	72427	72428
17670	23263	31	applied	\N	\N	\N	\N	72440	72440	72441
17670	23266	32	applied	\N	\N	\N	\N	72449	72449	72450
17670	23269	33	applied	\N	\N	\N	\N	72456	72456	72457
17670	23270	34	applied	\N	\N	\N	\N	72458	72458	72459
17670	23274	36	applied	\N	\N	\N	\N	72468	72468	72469
17670	23275	37	applied	\N	\N	\N	\N	72470	72470	72471
17670	23280	38	applied	\N	\N	\N	\N	72479	72479	72480
17670	23282	39	applied	\N	\N	\N	\N	72486	72486	72487
17670	23285	40	applied	\N	\N	\N	\N	72499	72499	72500
17670	23288	41	applied	\N	\N	\N	\N	72505	72505	72506
17670	23291	42	applied	\N	\N	\N	\N	72511	72511	72512
17670	23292	43	applied	\N	\N	\N	\N	72513	72513	72514
17670	23297	44	applied	\N	\N	\N	\N	72525	72525	72526
17670	23298	45	applied	\N	\N	\N	\N	72527	72527	72528
17670	23299	46	applied	\N	\N	\N	\N	72529	72529	72530
17670	23305	47	applied	\N	\N	\N	\N	72542	72542	72543
17670	23306	48	applied	\N	\N	\N	\N	72544	72544	72545
17670	23311	49	applied	\N	\N	\N	\N	72556	72556	72557
17670	23315	50	applied	\N	\N	\N	\N	72567	72567	72568
17670	23317	51	applied	\N	\N	\N	\N	72574	72574	72575
17670	23320	52	applied	\N	\N	\N	\N	72581	72581	72582
17670	23321	53	applied	\N	\N	\N	\N	72583	72583	72584
17670	23322	54	applied	\N	\N	\N	\N	72585	72585	72586
17670	23323	55	applied	\N	\N	\N	\N	72587	72587	72588
17670	23332	56	applied	\N	\N	\N	\N	72637	72637	72638
17670	23333	57	applied	\N	\N	\N	\N	72639	72639	72640
17670	23340	58	applied	\N	\N	\N	\N	72656	72656	72657
17670	23341	59	applied	\N	\N	\N	\N	72658	72658	72659
17670	23345	60	applied	\N	\N	\N	\N	72668	72668	72669
17670	23347	61	applied	\N	\N	\N	\N	72674	72674	72675
17670	23348	62	applied	\N	\N	\N	\N	72676	72676	72677
17670	23349	63	applied	\N	\N	\N	\N	72678	72678	72679
17670	23356	64	applied	\N	\N	\N	\N	72695	72695	72891
17670	23357	65	applied	\N	\N	\N	\N	72697	72697	72892
17670	23358	66	applied	\N	\N	\N	\N	72699	72699	72893
17670	23367	67	applied	\N	\N	\N	\N	72724	72724	72894
17670	23370	68	applied	\N	\N	\N	\N	72732	72732	72895
17670	23373	69	applied	\N	\N	\N	\N	72740	72740	72896
17670	23376	70	applied	\N	\N	\N	\N	72748	72748	72897
17670	23377	71	applied	\N	\N	\N	\N	72750	72750	72898
17670	23382	72	applied	\N	\N	\N	\N	72763	72763	72899
17670	23383	73	applied	\N	\N	\N	\N	72765	72765	72900
17670	23387	74	applied	\N	\N	\N	\N	72775	72775	72901
17670	23399	75	applied	\N	\N	\N	\N	72816	72816	72902
17670	23400	76	applied	\N	\N	\N	\N	72818	72818	72903
17670	23407	77	applied	\N	\N	\N	\N	72837	72837	72904
17670	23411	78	applied	\N	\N	\N	\N	72849	72849	72905
17670	23412	79	applied	\N	\N	\N	\N	72851	72851	72906
17670	23417	80	applied	\N	\N	\N	\N	72863	72863	72907
17670	23419	81	applied	\N	\N	\N	\N	72871	72871	72908
17670	23422	82	applied	\N	\N	\N	\N	72879	72879	72909
17670	23426	83	applied	\N	\N	\N	\N	72918	72918	74612
17670	23430	84	applied	\N	\N	\N	\N	72931	72931	74613
17670	23432	85	applied	\N	\N	\N	\N	72938	72938	74614
17670	23433	86	applied	\N	\N	\N	\N	72940	72940	74615
17670	23438	87	applied	\N	\N	\N	\N	72961	72961	74616
17670	23440	88	applied	\N	\N	\N	\N	72967	72967	74617
17670	23441	89	applied	\N	\N	\N	\N	72969	72969	74618
17670	23446	90	applied	\N	\N	\N	\N	72982	72982	74619
17670	23460	91	applied	\N	\N	\N	\N	73013	73013	74620
17670	23461	92	applied	\N	\N	\N	\N	73015	73015	74621
17670	23466	93	applied	\N	\N	\N	\N	73043	73043	74622
17670	23472	94	applied	\N	\N	\N	\N	73056	73056	74623
17670	23479	95	applied	\N	\N	\N	\N	73074	73074	74624
17670	23489	96	applied	\N	\N	\N	\N	73096	73096	74625
17670	23490	97	applied	\N	\N	\N	\N	73098	73098	74626
17670	23506	98	applied	\N	\N	\N	\N	73132	73132	74627
17670	23507	99	applied	\N	\N	\N	\N	73134	73134	74628
17670	23529	100	applied	\N	\N	\N	\N	73183	73183	74629
17670	23538	101	applied	\N	\N	\N	\N	73208	73208	74630
17670	23539	102	applied	\N	\N	\N	\N	73210	73210	74631
17670	23545	103	applied	\N	\N	\N	\N	73293	73293	74632
17670	23546	104	applied	\N	\N	\N	\N	73295	73295	74633
17670	23563	105	applied	\N	\N	\N	\N	73333	73333	74634
17670	23570	106	applied	\N	\N	\N	\N	73349	73349	74635
17670	23573	107	applied	\N	\N	\N	\N	73357	73357	74636
17670	23578	108	applied	\N	\N	\N	\N	73368	73368	74637
17670	23579	109	applied	\N	\N	\N	\N	73370	73370	74638
17670	23585	110	applied	\N	\N	\N	\N	73384	73384	74639
17670	23594	111	applied	\N	\N	\N	\N	73408	73408	74640
17670	23603	112	applied	\N	\N	\N	\N	73431	73431	74641
17670	23610	113	applied	\N	\N	\N	\N	73453	73453	74642
17670	23617	114	applied	\N	\N	\N	\N	73468	73468	74643
17670	23625	115	applied	\N	\N	\N	\N	73489	73489	74644
17670	23627	116	applied	\N	\N	\N	\N	73495	73495	74645
17670	23629	117	applied	\N	\N	\N	\N	73503	73503	74646
17670	23631	118	applied	\N	\N	\N	\N	73508	73508	74647
17670	23633	119	applied	\N	\N	\N	\N	73513	73513	74648
17670	23635	120	applied	\N	\N	\N	\N	73523	73523	74649
17670	23641	121	applied	\N	\N	\N	\N	73539	73539	74650
17670	23644	122	applied	\N	\N	\N	\N	73547	73547	74651
17670	23647	123	applied	\N	\N	\N	\N	73554	73554	74652
17670	23648	124	applied	\N	\N	\N	\N	73556	73556	74653
17670	23653	125	applied	\N	\N	\N	\N	73572	73572	74654
17674	23916	0	applied	\N	\N	\N	\N	74665	74665	74666
17674	23917	1	applied	\N	\N	\N	\N	74667	74667	74668
17674	23918	2	applied	\N	\N	\N	\N	74669	74669	74670
17674	23919	3	applied	\N	\N	\N	\N	74671	74671	74672
17674	23920	4	applied	\N	\N	\N	\N	74673	74673	74674
17674	23921	5	applied	\N	\N	\N	\N	74675	74675	74676
17674	23922	6	applied	\N	\N	\N	\N	74677	74677	74678
17674	23923	7	applied	\N	\N	\N	\N	74679	74679	74680
17674	23924	8	applied	\N	\N	\N	\N	74681	74681	74682
17674	23925	9	applied	\N	\N	\N	\N	74683	74683	74684
17676	23926	0	applied	\N	\N	\N	\N	74689	74689	74690
17676	23927	1	applied	\N	\N	\N	\N	74691	74691	74692
17680	23930	0	applied	\N	\N	\N	\N	74701	74701	74702
17680	23931	1	applied	\N	\N	\N	\N	74703	74703	74704
17685	23937	0	applied	\N	\N	\N	\N	74723	74723	74724
17685	23938	1	applied	\N	\N	\N	\N	74725	74725	74726
17689	23939	0	applied	\N	\N	\N	\N	74734	74734	74735
17689	23940	1	applied	\N	\N	\N	\N	74736	74736	74737
17689	23941	2	applied	\N	\N	\N	\N	74738	74738	74739
17689	23942	3	applied	\N	\N	\N	\N	74740	74740	74741
17689	23943	4	applied	\N	\N	\N	\N	74742	74742	74743
17689	23944	5	applied	\N	\N	\N	\N	74744	74744	74745
17689	23945	6	applied	\N	\N	\N	\N	74746	74746	74747
17689	23946	7	applied	\N	\N	\N	\N	74748	74748	74749
17689	23947	8	applied	\N	\N	\N	\N	74750	74750	74751
17689	23948	9	applied	\N	\N	\N	\N	74752	74752	74753
17689	23949	10	applied	\N	\N	\N	\N	74754	74754	74755
17689	23950	11	applied	\N	\N	\N	\N	74756	74756	74757
17689	23951	12	applied	\N	\N	\N	\N	74758	74758	74759
17689	23952	13	applied	\N	\N	\N	\N	74760	74760	74761
17689	23953	14	applied	\N	\N	\N	\N	74762	74762	74763
17689	23954	15	applied	\N	\N	\N	\N	74764	74764	74765
17691	23955	0	applied	\N	\N	\N	\N	74768	74768	74769
17691	23956	1	applied	\N	\N	\N	\N	74770	74770	74771
17694	23957	0	applied	\N	\N	\N	\N	74775	74775	74776
17694	23958	1	applied	\N	\N	\N	\N	74777	74777	74778
17694	23959	2	applied	\N	\N	\N	\N	74779	74779	74780
17694	23960	3	applied	\N	\N	\N	\N	74781	74781	74782
17696	23963	0	applied	\N	\N	\N	\N	74793	74793	74794
17696	23964	1	applied	\N	\N	\N	\N	74795	74795	74796
17697	23965	0	applied	\N	\N	\N	\N	74798	74798	74799
17697	23966	1	applied	\N	\N	\N	\N	74800	74800	74801
17697	23967	2	applied	\N	\N	\N	\N	74802	74802	74803
17697	23968	3	applied	\N	\N	\N	\N	74804	74804	74805
17697	23969	4	applied	\N	\N	\N	\N	74806	74806	74807
17697	23970	5	applied	\N	\N	\N	\N	74808	74808	74809
17705	23971	0	applied	\N	\N	\N	\N	74812	74812	74813
17705	23973	1	applied	\N	\N	\N	\N	74826	74826	74827
17705	23974	2	applied	\N	\N	\N	\N	74828	74828	74829
17708	23977	0	applied	\N	\N	\N	\N	74844	74844	74845
17708	23978	1	applied	\N	\N	\N	\N	74846	74846	74847
17716	23985	0	applied	\N	\N	\N	\N	74864	74864	74865
17716	23986	1	applied	\N	\N	\N	\N	74866	74866	74867
17716	23987	2	applied	\N	\N	\N	\N	74868	74868	74869
17716	23988	3	applied	\N	\N	\N	\N	74870	74870	74871
17718	23993	0	applied	\N	\N	1000000000	\N	74884	74884	74885
17718	23994	1	applied	\N	\N	\N	\N	74886	74886	74887
17718	23995	2	applied	\N	\N	\N	\N	74888	74888	74889
17718	23996	3	applied	\N	\N	\N	\N	74890	74890	74891
17718	23997	4	applied	\N	\N	\N	\N	74892	74892	74893
17718	23998	5	applied	\N	\N	\N	\N	74894	74894	74895
17718	23999	6	applied	\N	\N	\N	\N	74896	74896	74897
17720	23993	0	applied	\N	\N	1000000000	\N	74884	74884	74885
17720	23994	1	applied	\N	\N	\N	\N	74886	74886	74887
17720	23995	2	applied	\N	\N	\N	\N	74888	74888	74889
17720	23996	3	applied	\N	\N	\N	\N	74890	74890	74891
17720	23997	4	applied	\N	\N	\N	\N	74892	74892	74893
17720	23998	5	applied	\N	\N	\N	\N	74894	74894	74895
17720	23999	6	applied	\N	\N	\N	\N	74896	74896	74897
17725	24005	0	applied	\N	\N	\N	\N	74919	74919	74920
17725	24006	1	applied	\N	\N	\N	\N	74921	74921	74922
17725	24007	2	applied	\N	\N	\N	\N	74923	74923	74924
17730	24020	0	applied	\N	\N	\N	\N	74959	74959	74960
17730	24021	1	applied	\N	\N	\N	\N	74961	74961	74962
17730	24019	2	applied	\N	\N	\N	\N	74956	74956	74963
17730	24018	3	applied	\N	\N	\N	\N	74954	74954	74964
17733	24028	0	applied	\N	\N	\N	\N	74980	74980	74980
17733	24029	1	applied	\N	\N	\N	\N	74981	74981	74982
17733	24030	2	applied	\N	\N	\N	\N	74983	74983	74984
17733	24031	3	applied	\N	\N	\N	\N	74985	74985	74986
17733	24032	4	applied	\N	\N	\N	\N	74987	74987	74988
17733	24033	5	applied	\N	\N	\N	\N	74989	74989	74990
17733	24034	6	applied	\N	\N	\N	\N	74991	74991	74992
17733	24035	7	applied	\N	\N	\N	\N	74993	74993	74994
17736	24043	0	applied	\N	\N	\N	\N	75014	75014	74999
17736	24044	1	applied	\N	\N	\N	\N	75015	75015	75016
17736	24045	2	applied	\N	\N	\N	\N	75017	75017	75018
17736	24046	3	applied	\N	\N	\N	\N	75019	75019	75020
17736	24047	4	applied	\N	\N	\N	\N	75021	75021	75022
17736	24048	5	applied	\N	\N	\N	\N	75023	75023	75024
17736	24049	6	applied	\N	\N	\N	\N	75025	75025	75026
17736	24050	7	applied	\N	\N	\N	\N	75027	75027	75028
17736	24051	8	applied	\N	\N	\N	\N	75029	75029	75030
17736	24052	9	applied	\N	\N	\N	\N	75031	75031	75032
17736	24053	10	applied	\N	\N	\N	\N	75033	75033	75034
17740	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17740	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17740	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17740	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17740	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17740	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17740	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17742	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17742	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17742	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17742	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17742	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17742	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17742	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17744	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17744	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17744	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17744	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17744	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17744	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17744	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17747	24061	0	applied	\N	\N	\N	\N	75071	75071	75072
17747	24062	1	applied	\N	\N	\N	\N	75073	75073	75074
17747	24063	2	applied	\N	\N	\N	\N	75075	75075	75076
17747	24064	3	applied	\N	\N	\N	\N	75077	75077	75078
17747	24065	4	applied	\N	\N	\N	\N	75079	75079	75080
17747	24066	5	applied	\N	\N	\N	\N	75081	75081	75082
17750	24067	0	applied	\N	\N	\N	\N	75088	75088	75089
17750	24068	1	applied	\N	\N	\N	\N	75090	75090	75091
17750	24069	2	applied	\N	\N	\N	\N	75092	75092	75093
17750	24070	3	applied	\N	\N	\N	\N	75094	75094	75095
17754	24074	0	applied	\N	\N	\N	\N	75112	75112	75113
17754	24075	1	applied	\N	\N	\N	\N	75114	75114	75115
17754	24076	2	applied	\N	\N	\N	\N	75116	75116	75117
17758	24081	0	applied	\N	\N	\N	\N	75128	75128	75129
17758	24082	1	applied	\N	\N	\N	\N	75130	75130	75131
17758	24083	2	applied	\N	\N	\N	\N	75132	75132	75133
17758	24084	3	applied	\N	\N	\N	\N	75134	75134	75135
17758	24085	4	applied	\N	\N	\N	\N	75136	75136	75137
17735	24037	1	applied	\N	\N	\N	\N	74999	74999	74999
17735	24038	2	applied	\N	\N	\N	\N	75000	75000	75001
17735	24039	3	applied	\N	\N	\N	\N	75002	75002	75003
17735	24040	4	applied	\N	\N	\N	\N	75004	75004	75005
17735	24041	5	applied	\N	\N	\N	\N	75006	75006	75007
17735	24042	6	applied	\N	\N	\N	\N	75008	75008	75009
17738	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17738	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17738	24058	2	applied	\N	\N	\N	\N	75045	75045	75054
17738	24059	3	applied	\N	\N	\N	\N	75048	75048	75042
17738	24060	4	applied	\N	\N	\N	\N	75050	75050	75055
17741	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17741	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17741	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17741	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17741	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17741	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17741	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17743	24054	0	applied	\N	\N	\N	\N	75037	75037	75038
17743	24055	1	applied	\N	\N	\N	\N	75039	75039	75040
17743	24056	2	applied	\N	\N	\N	\N	75041	75041	75042
17743	24057	3	applied	\N	\N	\N	\N	75043	75043	75044
17743	24058	4	applied	\N	\N	\N	\N	75045	75045	75046
17743	24059	6	applied	\N	\N	\N	\N	75048	75048	75049
17743	24060	7	applied	\N	\N	\N	\N	75050	75050	75051
17746	24061	0	applied	\N	\N	\N	\N	75071	75071	75072
17746	24062	1	applied	\N	\N	\N	\N	75073	75073	75074
17746	24063	2	applied	\N	\N	\N	\N	75075	75075	75076
17746	24064	3	applied	\N	\N	\N	\N	75077	75077	75078
17746	24065	4	applied	\N	\N	\N	\N	75079	75079	75080
17746	24066	5	applied	\N	\N	\N	\N	75081	75081	75082
17751	23817	0	applied	\N	\N	\N	\N	74103	74103	74104
17751	23818	1	applied	\N	\N	\N	\N	74105	74105	74106
17751	24043	2	applied	\N	\N	\N	\N	75014	75014	71028
17751	24037	3	applied	\N	\N	\N	\N	74999	74999	74999
17751	24028	4	applied	\N	\N	\N	\N	74980	74980	74980
17751	23871	5	applied	\N	\N	1000000000	\N	74363	74363	74364
17751	23876	6	applied	\N	\N	1000000000	\N	74373	74373	74374
17751	23819	7	applied	\N	\N	\N	\N	74107	74107	74108
17751	23878	8	applied	\N	\N	1000000000	\N	74377	74377	74378
17751	23879	10	applied	\N	\N	1000000000	\N	74379	74379	74380
17751	23880	11	applied	\N	\N	1000000000	\N	74381	74381	74382
17751	23934	12	applied	\N	\N	1000000000	\N	74714	74714	74715
17751	23993	13	applied	\N	\N	1000000000	\N	74884	74884	74885
17751	23823	14	applied	\N	\N	\N	\N	74118	74118	74119
17751	23826	15	applied	\N	\N	\N	\N	74132	74132	74133
17751	23828	16	applied	\N	\N	\N	\N	74137	74137	74138
17751	23832	17	applied	\N	\N	\N	\N	74149	74149	74150
17751	23835	18	applied	\N	\N	\N	\N	74159	74159	74160
17751	23838	19	applied	\N	\N	\N	\N	74169	74169	74170
17751	23841	20	applied	\N	\N	\N	\N	74182	74182	74183
17751	23844	21	applied	\N	\N	\N	\N	74190	74190	74191
17751	23847	22	applied	\N	\N	\N	\N	74199	74199	74200
17751	23848	23	applied	\N	\N	\N	\N	74201	74201	74202
17751	23853	24	applied	\N	\N	\N	\N	74216	74216	74217
17751	23856	25	applied	\N	\N	\N	\N	74317	74317	74318
17751	23859	26	applied	\N	\N	\N	\N	74325	74325	74326
17751	23862	27	applied	\N	\N	\N	\N	74334	74334	74335
17751	23865	28	applied	\N	\N	\N	\N	74345	74345	74346
17751	23868	29	applied	\N	\N	\N	\N	74355	74355	74356
17751	23872	30	applied	\N	\N	\N	\N	74365	74365	74366
17751	23877	31	applied	\N	\N	\N	\N	74375	74375	74376
17751	23883	32	applied	\N	\N	\N	\N	74393	74393	74394
17751	23884	33	applied	\N	\N	\N	\N	74395	74395	74396
17751	23885	34	applied	\N	\N	\N	\N	74397	74397	74398
17751	23890	35	applied	\N	\N	\N	\N	74408	74408	74409
17751	23892	36	applied	\N	\N	\N	\N	74541	74541	74542
17751	23894	37	applied	\N	\N	\N	\N	74550	74550	74551
17751	23896	38	applied	\N	\N	\N	\N	74556	74556	74557
17751	23898	39	applied	\N	\N	\N	\N	74563	74563	74564
17751	23900	40	applied	\N	\N	\N	\N	74569	74569	74570
17751	23901	41	applied	\N	\N	\N	\N	74571	74571	74572
17751	23904	42	applied	\N	\N	\N	\N	74579	74579	74580
17751	23905	43	applied	\N	\N	\N	\N	74581	74581	74582
17751	23908	44	applied	\N	\N	\N	\N	74591	74591	74592
17751	23910	45	applied	\N	\N	\N	\N	74600	74600	74601
17751	23912	46	applied	\N	\N	\N	\N	74606	74606	74607
17751	23914	47	applied	\N	\N	\N	\N	74657	74657	74658
17751	23916	48	applied	\N	\N	\N	\N	74665	74665	74666
17751	23917	49	applied	\N	\N	\N	\N	74667	74667	74668
17751	23918	50	applied	\N	\N	\N	\N	74669	74669	74670
17751	23919	51	applied	\N	\N	\N	\N	74671	74671	74672
17751	23920	52	applied	\N	\N	\N	\N	74673	74673	74674
17751	23926	53	applied	\N	\N	\N	\N	74689	74689	74690
17751	23928	54	applied	\N	\N	\N	\N	74695	74695	74696
17751	23930	55	applied	\N	\N	\N	\N	74701	74701	74702
17751	23932	56	applied	\N	\N	\N	\N	74707	74707	74708
17751	23935	57	applied	\N	\N	\N	\N	74716	74716	74717
17751	23937	58	applied	\N	\N	\N	\N	74723	74723	74724
17751	23939	59	applied	\N	\N	\N	\N	74734	74734	74735
17751	23940	60	applied	\N	\N	\N	\N	74736	74736	74737
17751	23941	61	applied	\N	\N	\N	\N	74738	74738	74739
17751	23942	62	applied	\N	\N	\N	\N	74740	74740	74741
17751	23943	63	applied	\N	\N	\N	\N	74742	74742	74743
17751	23944	64	applied	\N	\N	\N	\N	74744	74744	74745
17751	23945	65	applied	\N	\N	\N	\N	74746	74746	74747
17751	23946	66	applied	\N	\N	\N	\N	74748	74748	74749
17751	23955	67	applied	\N	\N	\N	\N	74768	74768	74769
17751	23957	68	applied	\N	\N	\N	\N	74775	74775	74776
17751	23958	69	applied	\N	\N	\N	\N	74777	74777	74778
17753	24071	0	applied	\N	\N	\N	\N	75104	75104	75105
17753	24072	1	applied	\N	\N	\N	\N	75106	75106	75107
17753	24073	2	applied	\N	\N	\N	\N	75108	75108	75109
17755	24077	0	applied	\N	\N	\N	\N	75119	75119	75120
17755	24078	1	applied	\N	\N	\N	\N	75121	75121	75122
17755	24079	2	applied	\N	\N	\N	\N	75123	75123	75124
17755	24080	3	applied	\N	\N	\N	\N	75125	75125	75126
17756	24081	0	applied	\N	\N	\N	\N	75128	75128	75129
17756	24082	1	applied	\N	\N	\N	\N	75130	75130	75131
17756	24083	2	applied	\N	\N	\N	\N	75132	75132	75133
17756	24084	3	applied	\N	\N	\N	\N	75134	75134	75135
17756	24085	4	applied	\N	\N	\N	\N	75136	75136	75137
17756	24086	5	applied	\N	\N	\N	\N	75138	75138	75139
17756	24087	6	applied	\N	\N	\N	\N	75140	75140	75141
17756	24088	7	applied	\N	\N	\N	\N	75142	75142	75143
17756	24089	8	applied	\N	\N	\N	\N	75144	75144	75145
17756	24090	9	applied	\N	\N	\N	\N	75146	75146	75147
17756	24091	10	applied	\N	\N	\N	\N	75148	75148	75149
17756	24092	11	applied	\N	\N	\N	\N	75150	75150	75151
17748	24061	0	applied	\N	\N	\N	\N	75071	75071	75072
17748	24062	1	applied	\N	\N	\N	\N	75073	75073	75074
17748	24063	2	applied	\N	\N	\N	\N	75075	75075	75076
17748	24064	3	applied	\N	\N	\N	\N	75077	75077	75078
17748	24065	4	applied	\N	\N	\N	\N	75079	75079	75080
17748	24066	5	applied	\N	\N	\N	\N	75081	75081	75082
17752	24071	0	applied	\N	\N	\N	\N	75104	75104	75105
17752	24072	1	applied	\N	\N	\N	\N	75106	75106	75107
17752	24073	2	applied	\N	\N	\N	\N	75108	75108	75109
17763	24096	0	applied	\N	\N	\N	\N	75164	75164	75165
17763	24097	1	applied	\N	\N	\N	\N	75166	75166	75167
17763	24098	2	applied	\N	\N	\N	\N	75168	75168	75169
17765	24096	0	applied	\N	\N	\N	\N	75164	75164	75165
17765	24097	1	applied	\N	\N	\N	\N	75166	75166	75167
17765	24098	2	applied	\N	\N	\N	\N	75168	75168	75169
17767	24106	0	applied	\N	\N	\N	\N	75188	75188	75189
17767	24107	1	applied	\N	\N	\N	\N	75190	75190	75191
17767	24108	2	applied	\N	\N	\N	\N	75192	75192	75193
17767	24109	3	applied	\N	\N	\N	\N	75194	75194	75195
17767	24110	4	applied	\N	\N	\N	\N	75196	75196	75197
17767	24111	5	applied	\N	\N	\N	\N	75198	75198	75199
17767	24112	6	applied	\N	\N	\N	\N	75200	75200	75201
17773	24131	0	applied	\N	\N	\N	\N	75245	75245	75246
17773	24132	1	applied	\N	\N	\N	\N	75247	75247	75248
17773	24133	2	applied	\N	\N	\N	\N	75249	75249	75250
17773	24134	3	applied	\N	\N	\N	\N	75251	75251	75252
17786	24164	0	applied	\N	\N	\N	\N	75328	75328	75329
17786	24165	1	applied	\N	\N	\N	\N	75330	75330	75331
17786	24166	2	applied	\N	\N	\N	\N	75332	75332	75333
17799	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17799	24185	1	applied	\N	\N	\N	\N	75385	75385	75386
17799	24186	2	applied	\N	\N	\N	\N	75387	75387	75388
17802	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17802	24185	1	applied	\N	\N	\N	\N	75385	75385	75386
17802	24186	2	applied	\N	\N	\N	\N	75387	75387	75388
17806	24189	0	applied	\N	\N	\N	\N	75399	75399	75400
17806	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17806	24187	2	applied	\N	\N	\N	\N	75394	75394	75395
17806	24191	3	applied	\N	\N	\N	\N	75402	75402	75403
17806	24188	4	applied	\N	\N	\N	\N	75396	75396	75404
17811	24206	0	applied	\N	\N	\N	\N	75441	75441	75442
17811	24207	1	applied	\N	\N	\N	\N	75443	75443	75444
17813	24208	0	applied	\N	\N	\N	\N	75447	75447	75448
17813	24209	1	applied	\N	\N	\N	\N	75449	75449	75450
17813	24210	2	applied	\N	\N	\N	\N	75451	75451	75452
17821	24217	0	applied	\N	\N	\N	\N	75475	75475	75476
17821	24218	1	applied	\N	\N	\N	\N	75477	75477	75478
17821	24219	2	applied	\N	\N	\N	\N	75479	75479	75480
17821	24220	3	applied	\N	\N	\N	\N	75481	75481	75482
17823	24221	0	applied	\N	\N	\N	\N	75486	75486	75487
17823	24222	1	applied	\N	\N	\N	\N	75488	75488	75489
17823	24223	2	applied	\N	\N	\N	\N	75490	75490	75491
17828	24234	0	applied	\N	\N	\N	\N	75519	75519	75520
17828	24235	1	applied	\N	\N	\N	\N	75521	75521	75522
17828	24236	2	applied	\N	\N	\N	\N	75523	75523	75524
17833	24237	0	applied	\N	\N	\N	\N	75529	75529	75530
17833	24238	1	applied	\N	\N	\N	\N	75531	75531	75532
17833	24239	2	applied	\N	\N	\N	\N	75533	75533	75534
17833	24240	3	applied	\N	\N	\N	\N	75535	75535	75536
17833	24241	4	applied	\N	\N	\N	\N	75537	75537	75538
17833	24242	5	applied	\N	\N	\N	\N	75539	75539	75540
17833	24243	6	applied	\N	\N	\N	\N	75541	75541	75542
17838	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17838	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17838	24248	2	applied	\N	\N	\N	\N	75555	75555	75556
17838	24249	3	applied	\N	\N	\N	\N	75557	75557	75558
17838	24246	4	applied	\N	\N	\N	\N	75549	75549	75559
17838	24247	5	applied	\N	\N	\N	\N	75551	75551	75560
17842	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17842	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17842	24248	2	applied	\N	\N	\N	\N	75555	75555	75556
17842	24249	3	applied	\N	\N	\N	\N	75557	75557	75558
17842	24246	4	applied	\N	\N	\N	\N	75549	75549	75559
17842	24247	5	applied	\N	\N	\N	\N	75551	75551	75560
17843	24251	0	applied	\N	\N	\N	\N	75572	75572	75573
17843	24250	1	applied	\N	\N	\N	\N	75567	75567	75568
17843	24252	2	applied	\N	\N	\N	\N	75574	75574	75575
17843	24253	3	applied	\N	\N	\N	\N	75576	75576	75577
17847	24251	0	applied	\N	\N	\N	\N	75572	75572	75573
17847	24250	1	applied	\N	\N	\N	\N	75567	75567	75568
17847	24252	2	applied	\N	\N	\N	\N	75574	75574	75575
17847	24253	3	applied	\N	\N	\N	\N	75576	75576	75577
17852	24260	0	applied	\N	\N	\N	\N	75604	75604	75605
17852	24261	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17852	24262	2	applied	\N	\N	\N	\N	75607	75607	75608
17852	24263	3	applied	\N	\N	\N	\N	75609	75609	75610
17857	24264	0	applied	\N	\N	\N	\N	75614	75614	75615
17857	24265	1	applied	\N	\N	\N	\N	75616	75616	75617
17857	24266	2	applied	\N	\N	\N	\N	75618	75618	75619
17862	24273	0	applied	\N	\N	\N	\N	75644	75644	75645
17862	24274	1	applied	\N	\N	\N	\N	75646	75646	75647
17862	24275	2	applied	\N	\N	\N	\N	75648	75648	75649
17862	24276	3	applied	\N	\N	\N	\N	75650	75650	75651
17871	24297	0	applied	\N	\N	\N	\N	75721	75721	75722
17871	24298	1	applied	\N	\N	\N	\N	75723	75723	75724
17871	24299	2	applied	\N	\N	\N	\N	75725	75725	75726
17871	24300	3	applied	\N	\N	\N	\N	75727	75727	75728
17876	24307	0	applied	\N	\N	\N	\N	75745	75745	75746
17876	24308	1	applied	\N	\N	\N	\N	75747	75747	75748
17876	24309	2	applied	\N	\N	\N	\N	75749	75749	75750
17876	24310	3	applied	\N	\N	\N	\N	75751	75751	75752
17877	24311	0	applied	\N	\N	\N	\N	75758	75758	75759
17877	24312	1	applied	\N	\N	\N	\N	75760	75760	75761
17877	24313	2	applied	\N	\N	\N	\N	75762	75762	75763
17883	24324	0	applied	\N	\N	\N	\N	75786	75786	75787
17883	24325	1	applied	\N	\N	\N	\N	75788	75788	75789
17883	24326	3	applied	\N	\N	\N	\N	75791	75791	75792
17884	24327	0	applied	\N	\N	\N	\N	75801	75801	75802
17884	24328	1	applied	\N	\N	\N	\N	75803	75803	75804
17884	24329	2	applied	\N	\N	\N	\N	75805	75805	75806
17884	24330	3	applied	\N	\N	\N	\N	75807	75807	75808
17884	24331	4	applied	\N	\N	\N	\N	75809	75809	75810
17884	24332	5	applied	\N	\N	\N	\N	75811	75811	75812
17884	24333	6	applied	\N	\N	\N	\N	75813	75813	75814
17889	24340	0	applied	\N	\N	\N	\N	75834	75834	75835
17889	24341	1	applied	\N	\N	\N	\N	75836	75836	75826
17889	24342	2	applied	\N	\N	\N	\N	75837	75837	75828
17889	24336	3	applied	\N	\N	\N	\N	75821	75821	75838
17889	24337	4	applied	\N	\N	\N	\N	75823	75823	75839
17758	24086	5	applied	\N	\N	\N	\N	75138	75138	75139
17758	24087	6	applied	\N	\N	\N	\N	75140	75140	75141
17758	24088	7	applied	\N	\N	\N	\N	75142	75142	75143
17758	24089	8	applied	\N	\N	\N	\N	75144	75144	75145
17758	24090	9	applied	\N	\N	\N	\N	75146	75146	75147
17758	24091	10	applied	\N	\N	\N	\N	75148	75148	75149
17758	24092	11	applied	\N	\N	\N	\N	75150	75150	75151
17760	24093	0	applied	\N	\N	\N	\N	75156	75156	75157
17760	24094	1	applied	\N	\N	\N	\N	75158	75158	75159
17760	24095	2	applied	\N	\N	\N	\N	75160	75160	75161
17762	24096	0	applied	\N	\N	\N	\N	75164	75164	75165
17762	24097	1	applied	\N	\N	\N	\N	75166	75166	75167
17762	24098	2	applied	\N	\N	\N	\N	75168	75168	75169
17766	24099	0	applied	\N	\N	\N	\N	75173	75173	75174
17766	24100	1	applied	\N	\N	\N	\N	75175	75175	75176
17766	24101	2	applied	\N	\N	\N	\N	75177	75177	75178
17766	24102	3	applied	\N	\N	\N	\N	75179	75179	75180
17766	24103	4	applied	\N	\N	\N	\N	75181	75181	75182
17766	24104	5	applied	\N	\N	\N	\N	75183	75183	75184
17766	24105	6	applied	\N	\N	\N	\N	75185	75185	75186
17769	24113	0	applied	\N	\N	\N	\N	75205	75205	75206
17769	24114	1	applied	\N	\N	\N	\N	75207	75207	75208
17769	24115	2	applied	\N	\N	\N	\N	75209	75209	75210
17770	24116	0	applied	\N	\N	\N	\N	75213	75213	75214
17770	24117	1	applied	\N	\N	\N	\N	75215	75215	75216
17770	24118	2	applied	\N	\N	\N	\N	75217	75217	75218
17770	24119	3	applied	\N	\N	\N	\N	75219	75219	75220
17770	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
17770	24121	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
17770	24122	6	applied	\N	\N	\N	\N	75223	75223	75224
17770	24123	7	applied	\N	\N	\N	\N	75225	75225	75226
17770	24124	8	applied	\N	\N	\N	\N	75227	75227	75228
17770	24125	9	applied	\N	\N	\N	\N	75229	75229	75230
17770	24126	10	applied	\N	\N	\N	\N	75231	75231	75232
17770	24127	11	applied	\N	\N	\N	\N	75233	75233	75234
17770	24128	12	applied	\N	\N	\N	\N	75235	75235	75236
17770	24129	13	applied	\N	\N	\N	\N	75237	75237	75238
17770	24130	14	applied	\N	\N	\N	\N	75239	75239	75240
17772	24131	0	applied	\N	\N	\N	\N	75245	75245	75246
17772	24132	1	applied	\N	\N	\N	\N	75247	75247	75248
17772	24133	2	applied	\N	\N	\N	\N	75249	75249	75250
17772	24134	3	applied	\N	\N	\N	\N	75251	75251	75252
17780	24152	0	applied	\N	\N	\N	\N	75298	75298	75299
17780	24153	1	applied	\N	\N	\N	\N	75300	75300	75301
17780	24154	2	applied	\N	\N	\N	\N	75302	75302	75303
17780	24155	3	applied	\N	\N	\N	\N	75304	75304	75305
17780	24156	4	applied	\N	\N	\N	\N	75306	75306	75307
17780	24157	5	applied	\N	\N	\N	\N	75308	75308	75309
17783	24161	0	applied	\N	\N	\N	\N	75319	75319	75320
17783	24162	1	applied	\N	\N	\N	\N	75321	75321	75322
17783	24163	2	applied	\N	\N	\N	\N	75323	75323	75324
17785	24164	0	applied	\N	\N	\N	\N	75328	75328	75329
17785	24165	1	applied	\N	\N	\N	\N	75330	75330	75331
17785	24166	2	applied	\N	\N	\N	\N	75332	75332	75333
17789	24164	0	applied	\N	\N	\N	\N	75328	75328	75329
17789	24165	1	applied	\N	\N	\N	\N	75330	75330	75331
17789	24166	2	applied	\N	\N	\N	\N	75332	75332	75333
17793	24167	0	applied	\N	\N	\N	\N	75339	75339	75340
17793	24168	1	applied	\N	\N	\N	\N	75341	75341	75342
17793	24169	2	applied	\N	\N	\N	\N	75343	75343	75344
17793	24170	3	applied	\N	\N	\N	\N	75345	75345	75346
17793	24171	4	applied	\N	\N	\N	\N	75347	75347	75348
17793	24172	5	applied	\N	\N	\N	\N	75349	75349	75350
17793	24173	6	applied	\N	\N	\N	\N	75351	75351	75352
17795	24167	0	applied	\N	\N	\N	\N	75339	75339	75340
17795	24168	1	applied	\N	\N	\N	\N	75341	75341	75342
17795	24169	2	applied	\N	\N	\N	\N	75343	75343	75344
17795	24170	3	applied	\N	\N	\N	\N	75345	75345	75346
17795	24171	4	applied	\N	\N	\N	\N	75347	75347	75348
17795	24172	5	applied	\N	\N	\N	\N	75349	75349	75350
17795	24173	6	applied	\N	\N	\N	\N	75351	75351	75352
17797	24176	0	applied	\N	\N	\N	\N	75363	75363	75364
17797	24177	1	applied	\N	\N	\N	\N	75365	75365	75366
17797	24178	2	applied	\N	\N	\N	\N	75367	75367	75368
17797	24179	3	applied	\N	\N	\N	\N	75369	75369	75370
17797	24180	4	applied	\N	\N	\N	\N	75371	75371	75372
17801	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17801	24185	1	applied	\N	\N	\N	\N	75385	75385	75386
17801	24186	2	applied	\N	\N	\N	\N	75387	75387	75388
17805	24189	0	applied	\N	\N	\N	\N	75399	75399	75400
17805	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17805	24187	2	applied	\N	\N	\N	\N	75394	75394	75395
17805	24191	3	applied	\N	\N	\N	\N	75402	75402	75403
17805	24188	4	applied	\N	\N	\N	\N	75396	75396	75404
17807	24189	0	applied	\N	\N	\N	\N	75399	75399	75400
17807	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17807	24187	2	applied	\N	\N	\N	\N	75394	75394	75395
17807	24192	3	applied	\N	\N	\N	\N	75406	75406	75407
17807	24191	4	applied	\N	\N	\N	\N	75402	75402	75397
17807	24188	5	applied	\N	\N	\N	\N	75396	75396	75408
17807	24193	6	applied	\N	\N	\N	\N	75409	75409	75410
17810	24204	0	applied	\N	\N	\N	\N	75435	75435	75436
17810	24205	1	applied	\N	\N	\N	\N	75437	75437	75438
17816	24208	0	applied	\N	\N	\N	\N	75447	75447	75448
17816	24209	1	applied	\N	\N	\N	\N	75449	75449	75450
17816	24210	2	applied	\N	\N	\N	\N	75451	75451	75452
17818	24211	0	applied	\N	\N	\N	\N	75459	75459	75460
17818	24212	1	applied	\N	\N	\N	\N	75461	75461	75462
17818	24213	2	applied	\N	\N	\N	\N	75463	75463	75464
17820	24214	0	applied	\N	\N	\N	\N	75469	75469	75470
17820	24215	1	applied	\N	\N	\N	\N	75471	75471	75472
17820	24216	2	applied	\N	\N	\N	\N	75473	75473	75474
17827	24230	0	applied	\N	\N	\N	\N	75508	75508	75509
17827	24231	1	applied	\N	\N	\N	\N	75510	75510	75511
17827	24232	2	applied	\N	\N	\N	\N	75512	75512	75513
17827	24233	3	applied	\N	\N	\N	\N	75514	75514	75515
17831	24234	0	applied	\N	\N	\N	\N	75519	75519	75520
17831	24235	1	applied	\N	\N	\N	\N	75521	75521	75522
17831	24236	2	applied	\N	\N	\N	\N	75523	75523	75524
17837	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17837	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17837	24248	2	applied	\N	\N	\N	\N	75555	75555	75556
17837	24249	3	applied	\N	\N	\N	\N	75557	75557	75558
17837	24246	4	applied	\N	\N	\N	\N	75549	75549	75559
17837	24247	5	applied	\N	\N	\N	\N	75551	75551	75560
17841	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17841	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17841	24248	2	applied	\N	\N	\N	\N	75555	75555	75556
17764	24096	0	applied	\N	\N	\N	\N	75164	75164	75165
17764	24097	1	applied	\N	\N	\N	\N	75166	75166	75167
17764	24098	2	applied	\N	\N	\N	\N	75168	75168	75169
17768	24106	0	applied	\N	\N	\N	\N	75188	75188	75189
17768	24107	1	applied	\N	\N	\N	\N	75190	75190	75191
17768	24108	2	applied	\N	\N	\N	\N	75192	75192	75193
17768	24109	3	applied	\N	\N	\N	\N	75194	75194	75195
17768	24110	4	applied	\N	\N	\N	\N	75196	75196	75197
17768	24111	5	applied	\N	\N	\N	\N	75198	75198	75199
17768	24112	6	applied	\N	\N	\N	\N	75200	75200	75201
17771	24116	0	applied	\N	\N	\N	\N	75213	75213	75214
17771	24117	1	applied	\N	\N	\N	\N	75215	75215	75216
17771	24118	2	applied	\N	\N	\N	\N	75217	75217	75218
17771	24119	3	applied	\N	\N	\N	\N	75219	75219	75220
17771	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
17771	24121	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
17771	24122	6	applied	\N	\N	\N	\N	75223	75223	75224
17771	24123	7	applied	\N	\N	\N	\N	75225	75225	75226
17771	24124	8	applied	\N	\N	\N	\N	75227	75227	75228
17771	24125	9	applied	\N	\N	\N	\N	75229	75229	75230
17771	24126	10	applied	\N	\N	\N	\N	75231	75231	75232
17771	24127	11	applied	\N	\N	\N	\N	75233	75233	75234
17771	24128	12	applied	\N	\N	\N	\N	75235	75235	75236
17771	24129	13	applied	\N	\N	\N	\N	75237	75237	75238
17771	24130	14	applied	\N	\N	\N	\N	75239	75239	75240
17774	24135	0	applied	\N	\N	\N	\N	75257	75257	75258
17774	24136	1	applied	\N	\N	\N	\N	75259	75259	75260
17774	24137	2	applied	\N	\N	\N	\N	75261	75261	75262
17774	24138	3	applied	\N	\N	\N	\N	75263	75263	75264
17774	24139	4	applied	\N	\N	\N	\N	75265	75265	75266
17774	24140	5	applied	\N	\N	\N	\N	75267	75267	75268
17774	24141	6	applied	\N	\N	\N	\N	75269	75269	75270
17774	24142	7	applied	\N	\N	\N	\N	75271	75271	75272
17774	24143	8	applied	\N	\N	\N	\N	75273	75273	75274
17774	24144	9	applied	\N	\N	\N	\N	75275	75275	75276
17776	24145	0	applied	\N	\N	\N	\N	75281	75281	75282
17776	24146	1	applied	\N	\N	\N	\N	75283	75283	75284
17776	24147	2	applied	\N	\N	\N	\N	75285	75285	75286
17776	24148	3	applied	\N	\N	\N	\N	75287	75287	75288
17781	24158	0	applied	\N	\N	\N	\N	75311	75311	75312
17781	24159	1	applied	\N	\N	\N	\N	75313	75313	75314
17781	24160	2	applied	\N	\N	\N	\N	75315	75315	75316
17798	24181	0	applied	\N	\N	\N	\N	75375	75375	75376
17798	24182	1	applied	\N	\N	\N	\N	75377	75377	75378
17798	24183	2	applied	\N	\N	\N	\N	75379	75379	75380
17800	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17800	24185	1	applied	\N	\N	\N	\N	75385	75385	75386
17800	24186	2	applied	\N	\N	\N	\N	75387	75387	75388
17803	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17808	24194	0	applied	\N	\N	\N	\N	75412	75412	75413
17809	24195	0	applied	\N	\N	1000000000	\N	75415	75415	75416
17809	24194	1	applied	\N	\N	\N	\N	75412	75412	75413
17809	24196	2	applied	\N	\N	\N	\N	75417	75417	75418
17809	24197	3	applied	\N	\N	\N	\N	75419	75419	75420
17809	24198	4	applied	\N	\N	\N	\N	75421	75421	75422
17809	24199	5	applied	\N	\N	\N	\N	75423	75423	75424
17809	24200	6	applied	\N	\N	\N	\N	75425	75425	75426
17809	24201	7	applied	\N	\N	\N	\N	75427	75427	75428
17809	24202	8	applied	\N	\N	\N	\N	75429	75429	75430
17809	24203	9	applied	\N	\N	\N	\N	75431	75431	75432
17812	24206	0	applied	\N	\N	\N	\N	75441	75441	75442
17812	24207	1	applied	\N	\N	\N	\N	75443	75443	75444
17814	24208	0	applied	\N	\N	\N	\N	75447	75447	75448
17814	24209	1	applied	\N	\N	\N	\N	75449	75449	75450
17814	24210	2	applied	\N	\N	\N	\N	75451	75451	75452
17819	24211	0	applied	\N	\N	\N	\N	75459	75459	75460
17819	24212	1	applied	\N	\N	\N	\N	75461	75461	75462
17819	24213	2	applied	\N	\N	\N	\N	75463	75463	75464
17824	24224	0	applied	\N	\N	\N	\N	75493	75493	75494
17824	24225	1	applied	\N	\N	\N	\N	75495	75495	75496
17824	24226	2	applied	\N	\N	\N	\N	75497	75497	75498
17824	24227	3	applied	\N	\N	\N	\N	75499	75499	75500
17824	24228	4	applied	\N	\N	\N	\N	75501	75501	75502
17824	24229	5	applied	\N	\N	\N	\N	75503	75503	75504
17829	24234	0	applied	\N	\N	\N	\N	75519	75519	75520
17829	24235	1	applied	\N	\N	\N	\N	75521	75521	75522
17829	24236	2	applied	\N	\N	\N	\N	75523	75523	75524
17834	24237	0	applied	\N	\N	\N	\N	75529	75529	75530
17834	24238	1	applied	\N	\N	\N	\N	75531	75531	75532
17834	24239	2	applied	\N	\N	\N	\N	75533	75533	75534
17834	24240	3	applied	\N	\N	\N	\N	75535	75535	75536
17834	24241	4	applied	\N	\N	\N	\N	75537	75537	75538
17834	24242	5	applied	\N	\N	\N	\N	75539	75539	75540
17834	24243	6	applied	\N	\N	\N	\N	75541	75541	75542
17839	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17839	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17839	24248	2	applied	\N	\N	\N	\N	75555	75555	75556
17839	24249	3	applied	\N	\N	\N	\N	75557	75557	75558
17839	24246	4	applied	\N	\N	\N	\N	75549	75549	75559
17839	24247	5	applied	\N	\N	\N	\N	75551	75551	75560
17844	24251	0	applied	\N	\N	\N	\N	75572	75572	75573
17844	24250	1	applied	\N	\N	\N	\N	75567	75567	75568
17844	24252	2	applied	\N	\N	\N	\N	75574	75574	75575
17844	24253	3	applied	\N	\N	\N	\N	75576	75576	75577
17848	24254	0	applied	\N	\N	\N	\N	75588	75588	75589
17848	24255	1	applied	\N	\N	\N	\N	75590	75590	75591
17848	24256	2	applied	\N	\N	\N	\N	75592	75592	75593
17853	24260	0	applied	\N	\N	\N	\N	75604	75604	75605
17853	24261	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17853	24262	2	applied	\N	\N	\N	\N	75607	75607	75608
17853	24263	3	applied	\N	\N	\N	\N	75609	75609	75610
17854	24264	0	applied	\N	\N	\N	\N	75614	75614	75615
17854	24265	1	applied	\N	\N	\N	\N	75616	75616	75617
17854	24266	2	applied	\N	\N	\N	\N	75618	75618	75619
17858	24267	0	applied	\N	\N	\N	\N	75625	75625	75626
17858	24268	1	applied	\N	\N	\N	\N	75627	75627	75628
17858	24269	2	applied	\N	\N	\N	\N	75629	75629	75630
17859	24270	0	applied	\N	\N	\N	\N	75633	75633	75634
17859	24271	1	applied	\N	\N	\N	\N	75635	75635	75636
17859	24272	2	applied	\N	\N	\N	\N	75637	75637	75638
17863	24273	0	applied	\N	\N	\N	\N	75644	75644	75645
17863	24274	1	applied	\N	\N	\N	\N	75646	75646	75647
17863	24275	2	applied	\N	\N	\N	\N	75648	75648	75649
17863	24276	3	applied	\N	\N	\N	\N	75650	75650	75651
17866	24043	0	applied	\N	\N	\N	\N	75014	75014	71028
17866	24037	1	applied	\N	\N	\N	\N	74999	74999	74999
17866	23993	2	applied	\N	\N	1000000000	\N	74884	74884	74885
17866	24195	3	applied	\N	\N	1000000000	\N	75621	75621	75416
17775	24143	8	applied	\N	\N	\N	\N	75273	75273	75274
17775	24144	9	applied	\N	\N	\N	\N	75275	75275	75276
17777	24149	0	applied	\N	\N	\N	\N	75289	75289	75290
17777	24150	1	applied	\N	\N	\N	\N	75291	75291	75292
17777	24151	2	applied	\N	\N	\N	\N	75293	75293	75294
17782	24161	0	applied	\N	\N	\N	\N	75319	75319	75320
17782	24162	1	applied	\N	\N	\N	\N	75321	75321	75322
17782	24163	2	applied	\N	\N	\N	\N	75323	75323	75324
17788	24164	0	applied	\N	\N	\N	\N	75328	75328	75329
17788	24165	1	applied	\N	\N	\N	\N	75330	75330	75331
17788	24166	2	applied	\N	\N	\N	\N	75332	75332	75333
17794	24167	0	applied	\N	\N	\N	\N	75339	75339	75340
17794	24168	1	applied	\N	\N	\N	\N	75341	75341	75342
17794	24169	2	applied	\N	\N	\N	\N	75343	75343	75344
17794	24170	3	applied	\N	\N	\N	\N	75345	75345	75346
17794	24171	4	applied	\N	\N	\N	\N	75347	75347	75348
17794	24172	5	applied	\N	\N	\N	\N	75349	75349	75350
17794	24173	6	applied	\N	\N	\N	\N	75351	75351	75352
17796	24174	0	applied	\N	\N	\N	\N	75358	75358	75359
17796	24175	1	applied	\N	\N	\N	\N	75360	75360	75361
17804	24184	0	applied	\N	\N	\N	\N	75383	75383	75384
17804	24185	1	applied	\N	\N	\N	\N	75385	75385	75386
17804	24186	2	applied	\N	\N	\N	\N	75387	75387	75388
17804	24187	3	applied	\N	\N	\N	\N	75394	75394	75395
17804	24188	4	applied	\N	\N	\N	\N	75396	75396	75397
17815	24208	0	applied	\N	\N	\N	\N	75447	75447	75448
17815	24209	1	applied	\N	\N	\N	\N	75449	75449	75450
17815	24210	2	applied	\N	\N	\N	\N	75451	75451	75452
17822	24217	0	applied	\N	\N	\N	\N	75475	75475	75476
17822	24218	1	applied	\N	\N	\N	\N	75477	75477	75478
17822	24219	2	applied	\N	\N	\N	\N	75479	75479	75480
17822	24220	3	applied	\N	\N	\N	\N	75481	75481	75482
17825	24224	0	applied	\N	\N	\N	\N	75493	75493	75494
17825	24225	1	applied	\N	\N	\N	\N	75495	75495	75496
17825	24226	2	applied	\N	\N	\N	\N	75497	75497	75498
17825	24227	3	applied	\N	\N	\N	\N	75499	75499	75500
17825	24228	4	applied	\N	\N	\N	\N	75501	75501	75502
17825	24229	5	applied	\N	\N	\N	\N	75503	75503	75504
17826	24230	0	applied	\N	\N	\N	\N	75508	75508	75509
17826	24231	1	applied	\N	\N	\N	\N	75510	75510	75511
17826	24232	2	applied	\N	\N	\N	\N	75512	75512	75513
17826	24233	3	applied	\N	\N	\N	\N	75514	75514	75515
17830	24234	0	applied	\N	\N	\N	\N	75519	75519	75520
17830	24235	1	applied	\N	\N	\N	\N	75521	75521	75522
17830	24236	2	applied	\N	\N	\N	\N	75523	75523	75524
17835	24237	0	applied	\N	\N	\N	\N	75529	75529	75530
17835	24238	1	applied	\N	\N	\N	\N	75531	75531	75532
17835	24239	2	applied	\N	\N	\N	\N	75533	75533	75534
17835	24240	3	applied	\N	\N	\N	\N	75535	75535	75536
17835	24241	4	applied	\N	\N	\N	\N	75537	75537	75538
17835	24242	5	applied	\N	\N	\N	\N	75539	75539	75540
17835	24243	6	applied	\N	\N	\N	\N	75541	75541	75542
17836	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17836	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17836	24246	2	applied	\N	\N	\N	\N	75549	75549	75550
17836	24247	3	applied	\N	\N	\N	\N	75551	75551	75552
17845	24251	0	applied	\N	\N	\N	\N	75572	75572	75573
17845	24250	1	applied	\N	\N	\N	\N	75567	75567	75568
17845	24253	2	applied	\N	\N	\N	\N	75576	75576	75582
17849	24254	0	applied	\N	\N	\N	\N	75588	75588	75589
17849	24255	1	applied	\N	\N	\N	\N	75590	75590	75591
17849	24256	2	applied	\N	\N	\N	\N	75592	75592	75593
17855	24043	0	applied	\N	\N	\N	\N	75014	75014	71028
17855	23876	1	applied	\N	\N	1000000000	\N	74373	74373	74374
17855	23877	2	applied	\N	\N	\N	\N	74375	74375	74376
17855	24037	3	applied	\N	\N	\N	\N	74999	74999	74999
17855	23883	4	applied	\N	\N	\N	\N	74393	74393	74394
17855	23884	5	applied	\N	\N	\N	\N	74395	74395	74396
17855	23885	6	applied	\N	\N	\N	\N	74397	74397	74398
17855	23890	7	applied	\N	\N	\N	\N	74408	74408	74409
17855	24028	8	applied	\N	\N	\N	\N	74980	74980	74980
17855	23892	9	applied	\N	\N	\N	\N	74541	74541	74542
17855	23894	10	applied	\N	\N	\N	\N	74550	74550	74551
17855	23896	11	applied	\N	\N	\N	\N	74556	74556	74557
17855	23898	12	applied	\N	\N	\N	\N	74563	74563	74564
17855	23900	13	applied	\N	\N	\N	\N	74569	74569	74570
17855	23901	14	applied	\N	\N	\N	\N	74571	74571	74572
17855	23904	15	applied	\N	\N	\N	\N	74579	74579	74580
17855	23905	16	applied	\N	\N	\N	\N	74581	74581	74582
17855	23908	17	applied	\N	\N	\N	\N	74591	74591	74592
17855	23910	18	applied	\N	\N	\N	\N	74600	74600	74601
17855	23912	20	applied	\N	\N	\N	\N	74606	74606	74607
17855	23878	21	applied	\N	\N	1000000000	\N	74377	74377	74378
17855	23879	22	applied	\N	\N	1000000000	\N	74379	74379	74380
17855	23880	23	applied	\N	\N	1000000000	\N	74381	74381	74382
17855	23934	24	applied	\N	\N	1000000000	\N	74714	74714	74715
17855	23993	25	applied	\N	\N	1000000000	\N	74884	74884	74885
17855	24195	26	applied	\N	\N	1000000000	\N	75621	75621	75416
17855	23914	27	applied	\N	\N	\N	\N	74657	74657	74658
17855	23916	28	applied	\N	\N	\N	\N	74665	74665	74666
17855	23917	29	applied	\N	\N	\N	\N	74667	74667	74668
17855	23918	30	applied	\N	\N	\N	\N	74669	74669	74670
17855	23919	31	applied	\N	\N	\N	\N	74671	74671	74672
17855	23920	32	applied	\N	\N	\N	\N	74673	74673	74674
17855	23926	33	applied	\N	\N	\N	\N	74689	74689	74690
17855	23928	34	applied	\N	\N	\N	\N	74695	74695	74696
17855	23930	35	applied	\N	\N	\N	\N	74701	74701	74702
17855	23932	36	applied	\N	\N	\N	\N	74707	74707	74708
17855	23935	37	applied	\N	\N	\N	\N	74716	74716	74717
17855	23937	38	applied	\N	\N	\N	\N	74723	74723	74724
17855	23939	39	applied	\N	\N	\N	\N	74734	74734	74735
17855	23940	40	applied	\N	\N	\N	\N	74736	74736	74737
17855	23941	41	applied	\N	\N	\N	\N	74738	74738	74739
17855	23942	42	applied	\N	\N	\N	\N	74740	74740	74741
17855	23943	43	applied	\N	\N	\N	\N	74742	74742	74743
17855	23944	44	applied	\N	\N	\N	\N	74744	74744	74745
17855	23945	45	applied	\N	\N	\N	\N	74746	74746	74747
17855	23946	46	applied	\N	\N	\N	\N	74748	74748	74749
17855	23955	47	applied	\N	\N	\N	\N	74768	74768	74769
17855	23957	48	applied	\N	\N	\N	\N	74775	74775	74776
17855	23958	49	applied	\N	\N	\N	\N	74777	74777	74778
17855	23961	50	applied	\N	\N	\N	\N	74787	74787	74788
17855	23963	51	applied	\N	\N	\N	\N	74793	74793	74794
17855	23965	52	applied	\N	\N	\N	\N	74798	74798	74799
17855	23966	53	applied	\N	\N	\N	\N	74800	74800	74801
17855	23967	54	applied	\N	\N	\N	\N	74802	74802	74803
17855	23971	55	applied	\N	\N	\N	\N	74812	74812	74813
17855	23973	56	applied	\N	\N	\N	\N	74826	74826	74827
17855	23975	57	applied	\N	\N	\N	\N	74838	74838	74839
17841	24249	3	applied	\N	\N	\N	\N	75557	75557	75558
17841	24246	4	applied	\N	\N	\N	\N	75549	75549	75559
17841	24247	5	applied	\N	\N	\N	\N	75551	75551	75560
17841	24250	6	applied	\N	\N	\N	\N	75567	75567	75568
17846	24244	0	applied	\N	\N	\N	\N	75545	75545	75546
17846	24245	1	applied	\N	\N	\N	\N	75547	75547	75548
17846	24251	2	applied	\N	\N	\N	\N	75572	75572	75573
17846	24248	3	applied	\N	\N	\N	\N	75555	75555	75556
17846	24249	4	applied	\N	\N	\N	\N	75557	75557	75558
17846	24253	5	applied	\N	\N	\N	\N	75576	75576	75584
17846	24246	6	applied	\N	\N	\N	\N	75549	75549	75585
17846	24247	7	applied	\N	\N	\N	\N	75551	75551	75575
17846	24250	8	applied	\N	\N	\N	\N	75567	75567	75582
17850	24254	0	applied	\N	\N	\N	\N	75588	75588	75589
17850	24255	1	applied	\N	\N	\N	\N	75590	75590	75591
17851	24257	0	applied	\N	\N	\N	\N	75596	75596	75597
17851	24258	1	applied	\N	\N	\N	\N	75598	75598	75599
17851	24259	2	applied	\N	\N	\N	\N	75600	75600	75601
17856	24264	0	applied	\N	\N	\N	\N	75614	75614	75615
17856	24265	1	applied	\N	\N	\N	\N	75616	75616	75617
17856	24266	2	applied	\N	\N	\N	\N	75618	75618	75619
17861	24270	0	applied	\N	\N	\N	\N	75633	75633	75634
17861	24271	1	applied	\N	\N	\N	\N	75635	75635	75636
17861	24272	2	applied	\N	\N	\N	\N	75637	75637	75638
17870	24297	0	applied	\N	\N	\N	\N	75721	75721	75722
17870	24298	1	applied	\N	\N	\N	\N	75723	75723	75724
17870	24299	2	applied	\N	\N	\N	\N	75725	75725	75726
17870	24300	3	applied	\N	\N	\N	\N	75727	75727	75728
17875	24307	0	applied	\N	\N	\N	\N	75745	75745	75746
17875	24308	1	applied	\N	\N	\N	\N	75747	75747	75748
17875	24309	2	applied	\N	\N	\N	\N	75749	75749	75750
17875	24310	3	applied	\N	\N	\N	\N	75751	75751	75752
17882	24324	0	applied	\N	\N	\N	\N	75786	75786	75787
17882	24325	1	applied	\N	\N	\N	\N	75788	75788	75789
17882	24326	3	applied	\N	\N	\N	\N	75791	75791	75792
17888	24334	0	applied	\N	\N	\N	\N	75817	75817	75818
17888	24335	1	applied	\N	\N	\N	\N	75819	75819	75820
17888	24338	2	applied	\N	\N	\N	\N	75825	75825	75831
17888	24339	3	applied	\N	\N	\N	\N	75827	75827	75832
17892	24340	0	applied	\N	\N	\N	\N	75834	75834	75835
17892	24341	1	applied	\N	\N	\N	\N	75836	75836	75847
17892	24342	2	applied	\N	\N	\N	\N	75837	75837	75839
17892	24343	3	applied	\N	\N	\N	\N	75840	75840	75841
17893	24344	0	applied	\N	\N	\N	\N	75849	75849	75850
17893	24345	1	applied	\N	\N	\N	\N	75851	75851	75852
17893	24346	2	applied	\N	\N	\N	\N	75853	75853	75854
17900	24364	0	applied	\N	\N	\N	\N	75941	75941	75942
17900	24365	1	applied	\N	\N	\N	\N	75943	75943	75944
17900	24366	2	applied	\N	\N	\N	\N	75945	75945	75946
17900	24367	3	applied	\N	\N	\N	\N	75947	75947	75948
17900	24368	4	applied	\N	\N	\N	\N	75949	75949	75950
17900	24369	5	applied	\N	\N	\N	\N	75951	75951	75952
17900	24370	6	applied	\N	\N	\N	\N	75953	75953	75954
17901	24371	0	applied	\N	\N	\N	\N	75956	75956	75957
17901	24372	1	applied	\N	\N	\N	\N	75958	75958	75959
17901	24373	2	applied	\N	\N	\N	\N	75960	75960	75961
17901	24374	3	applied	\N	\N	\N	\N	75962	75962	75963
17901	24375	4	applied	\N	\N	\N	\N	75964	75964	75965
17901	24376	5	applied	\N	\N	\N	\N	75966	75966	75967
17901	24377	6	applied	\N	\N	\N	\N	75968	75968	75969
17905	24364	0	applied	\N	\N	\N	\N	75941	75941	75942
17905	24365	1	applied	\N	\N	\N	\N	75943	75943	75944
17905	24371	2	applied	\N	\N	\N	\N	75956	75956	75957
17905	24372	3	applied	\N	\N	\N	\N	75958	75958	75959
17905	24366	4	applied	\N	\N	\N	\N	75945	75945	75946
17905	24367	5	applied	\N	\N	\N	\N	75947	75947	75948
17905	24375	6	applied	\N	\N	\N	\N	75964	75964	75975
17905	24368	7	applied	\N	\N	\N	\N	75949	75949	75976
17905	24376	8	applied	\N	\N	\N	\N	75966	75966	75954
17905	24377	9	applied	\N	\N	\N	\N	75968	75968	75977
17906	24378	0	applied	\N	\N	\N	\N	75979	75979	75980
17906	24379	1	applied	\N	\N	\N	\N	75981	75981	75982
17910	24380	0	applied	\N	\N	\N	\N	75988	75988	75989
17910	24381	1	applied	\N	\N	\N	\N	75990	75990	75991
17911	24382	0	applied	\N	\N	\N	\N	75994	75994	75995
17911	24383	1	applied	\N	\N	\N	\N	75996	75996	75997
17911	24384	2	applied	\N	\N	\N	\N	75998	75998	75999
17911	24385	3	applied	\N	\N	\N	\N	76000	76000	76001
17911	24386	4	applied	\N	\N	\N	\N	76002	76002	76003
17911	24387	5	applied	\N	\N	\N	\N	76004	76004	76005
17917	24398	0	applied	\N	\N	\N	\N	76034	76034	76035
17917	24399	1	applied	\N	\N	\N	\N	76036	76036	76037
17917	24400	2	applied	\N	\N	\N	\N	76038	76038	76039
17924	24410	0	applied	\N	\N	\N	\N	76066	76066	76067
17924	24411	1	applied	\N	\N	\N	\N	76068	76068	76069
17924	24412	2	applied	\N	\N	\N	\N	76070	76070	76071
17929	24417	0	applied	\N	\N	\N	\N	76087	76087	76088
17929	24418	1	applied	\N	\N	\N	\N	76089	76089	76090
17929	24419	2	applied	\N	\N	\N	\N	76091	76091	76092
17929	24420	3	applied	\N	\N	\N	\N	76093	76093	76094
17935	24432	0	applied	\N	\N	\N	\N	76124	76124	76125
17935	24434	1	applied	\N	\N	\N	\N	76129	76129	76130
17935	24433	2	applied	\N	\N	\N	\N	76126	76126	76131
17940	24439	0	applied	\N	\N	\N	\N	76146	76146	76147
17940	24440	1	applied	\N	\N	\N	\N	76148	76148	76149
17940	24441	2	applied	\N	\N	\N	\N	76150	76150	76151
17946	24449	0	applied	\N	\N	\N	\N	76175	76175	76176
17946	24450	1	applied	\N	\N	\N	\N	76177	76177	76178
17946	24451	2	applied	\N	\N	\N	\N	76179	76179	76180
17946	24452	3	applied	\N	\N	\N	\N	76181	76181	76182
17946	24453	4	applied	\N	\N	\N	\N	76183	76183	76184
17946	24454	5	applied	\N	\N	\N	\N	76185	76185	76186
17946	24455	6	applied	\N	\N	\N	\N	76187	76187	76188
17952	24466	0	applied	\N	\N	\N	\N	76218	76218	76219
17952	24467	1	applied	\N	\N	\N	\N	76220	76220	76221
17952	24468	2	applied	\N	\N	\N	\N	76222	76222	76223
17957	24472	0	applied	\N	\N	\N	\N	76247	76247	76248
17957	24473	1	applied	\N	\N	\N	\N	76249	76249	76250
17957	24474	2	applied	\N	\N	\N	\N	76251	76251	76252
17957	24475	3	applied	\N	\N	\N	\N	76253	76253	76254
17960	24476	0	applied	\N	\N	\N	\N	76284	76284	76285
17960	24477	1	applied	\N	\N	\N	\N	76286	76286	76287
17960	24478	2	applied	\N	\N	\N	\N	76288	76288	76289
17960	24479	3	applied	\N	\N	\N	\N	76290	76290	76291
17960	24480	4	applied	\N	\N	\N	\N	76292	76292	76293
17960	24481	5	applied	\N	\N	\N	\N	76294	76294	76295
17966	24492	0	applied	\N	\N	\N	\N	76366	76366	76367
17966	24493	1	applied	\N	\N	\N	\N	76368	76368	76369
17966	24494	2	applied	\N	\N	\N	\N	76370	76370	76371
17966	24495	3	applied	\N	\N	\N	\N	76372	76372	76373
17855	23977	58	applied	\N	\N	\N	\N	74844	74844	74845
17855	23979	59	applied	\N	\N	\N	\N	74848	74848	74849
17855	23981	60	applied	\N	\N	\N	\N	74852	74852	74853
17855	23982	61	applied	\N	\N	\N	\N	74854	74854	74855
17855	23985	62	applied	\N	\N	\N	\N	74864	74864	74865
17855	23986	63	applied	\N	\N	\N	\N	74866	74866	74867
17855	23989	64	applied	\N	\N	\N	\N	74876	74876	74877
17855	23990	65	applied	\N	\N	\N	\N	74878	74878	74879
17855	23994	66	applied	\N	\N	\N	\N	74886	74886	74887
17855	23995	67	applied	\N	\N	\N	\N	74888	74888	74889
17855	24000	68	applied	\N	\N	\N	\N	74905	74905	74906
17855	24002	69	applied	\N	\N	\N	\N	74911	74911	74912
17855	24005	70	applied	\N	\N	\N	\N	74919	74919	74920
17855	24008	71	applied	\N	\N	\N	\N	74925	74925	74926
17855	24009	72	applied	\N	\N	\N	\N	74927	74927	74928
17855	24015	73	applied	\N	\N	\N	\N	74941	74941	74942
17855	24020	74	applied	\N	\N	\N	\N	74959	74959	74960
17855	24022	75	applied	\N	\N	\N	\N	74966	74966	74967
17855	24023	76	applied	\N	\N	\N	\N	74968	74968	74969
17855	24029	77	applied	\N	\N	\N	\N	74981	74981	74982
17855	24030	78	applied	\N	\N	\N	\N	74983	74983	74984
17855	24036	79	applied	\N	\N	\N	\N	74997	74997	74998
17855	24038	80	applied	\N	\N	\N	\N	75000	75000	75001
17855	24044	81	applied	\N	\N	\N	\N	75015	75015	75016
17855	24045	82	applied	\N	\N	\N	\N	75017	75017	75018
17855	24046	83	applied	\N	\N	\N	\N	75019	75019	75020
17855	24054	84	applied	\N	\N	\N	\N	75037	75037	75038
17855	24055	85	applied	\N	\N	\N	\N	75039	75039	75040
17855	24061	86	applied	\N	\N	\N	\N	75071	75071	75072
17855	24062	87	applied	\N	\N	\N	\N	75073	75073	75074
17855	24067	88	applied	\N	\N	\N	\N	75088	75088	75089
17855	24071	89	applied	\N	\N	\N	\N	75104	75104	75105
17855	24074	90	applied	\N	\N	\N	\N	75112	75112	75113
17855	24077	91	applied	\N	\N	\N	\N	75119	75119	75120
17855	24081	92	applied	\N	\N	\N	\N	75128	75128	75129
17855	24082	93	applied	\N	\N	\N	\N	75130	75130	75131
17855	24083	94	applied	\N	\N	\N	\N	75132	75132	75133
17855	24084	95	applied	\N	\N	\N	\N	75134	75134	75135
17855	24093	96	applied	\N	\N	\N	\N	75156	75156	75157
17855	24096	97	applied	\N	\N	\N	\N	75164	75164	75165
17855	24099	98	applied	\N	\N	\N	\N	75173	75173	75174
17855	24100	99	applied	\N	\N	\N	\N	75175	75175	75176
17855	24106	100	applied	\N	\N	\N	\N	75188	75188	75189
17855	24107	101	applied	\N	\N	\N	\N	75190	75190	75191
17855	24113	102	applied	\N	\N	\N	\N	75205	75205	75206
17855	24116	103	applied	\N	\N	\N	\N	75213	75213	75214
17855	24117	104	applied	\N	\N	\N	\N	75215	75215	75216
17855	24118	105	applied	\N	\N	\N	\N	75217	75217	75218
17855	24119	106	applied	\N	\N	\N	\N	75219	75219	75220
17855	24131	107	applied	\N	\N	\N	\N	75245	75245	75246
17855	24135	108	applied	\N	\N	\N	\N	75257	75257	75258
17855	24136	109	applied	\N	\N	\N	\N	75259	75259	75260
17855	24137	110	applied	\N	\N	\N	\N	75261	75261	75262
17855	24145	111	applied	\N	\N	\N	\N	75281	75281	75282
17855	24149	112	applied	\N	\N	\N	\N	75289	75289	75290
17855	24152	113	applied	\N	\N	\N	\N	75298	75298	75299
17855	24153	114	applied	\N	\N	\N	\N	75300	75300	75301
17855	24158	115	applied	\N	\N	\N	\N	75311	75311	75312
17855	24161	116	applied	\N	\N	\N	\N	75319	75319	75320
17855	24164	117	applied	\N	\N	\N	\N	75328	75328	75329
17855	24167	118	applied	\N	\N	\N	\N	75339	75339	75340
17855	24168	119	applied	\N	\N	\N	\N	75341	75341	75342
17855	24176	120	applied	\N	\N	\N	\N	75363	75363	75364
17855	24177	121	applied	\N	\N	\N	\N	75365	75365	75366
17855	24181	122	applied	\N	\N	\N	\N	75375	75375	75376
17855	24184	123	applied	\N	\N	\N	\N	75383	75383	75384
17855	24189	124	applied	\N	\N	\N	\N	75399	75399	75400
17855	24194	125	applied	\N	\N	\N	\N	75412	75412	75413
17860	24270	0	applied	\N	\N	\N	\N	75633	75633	75634
17860	24271	1	applied	\N	\N	\N	\N	75635	75635	75636
17860	24272	2	applied	\N	\N	\N	\N	75637	75637	75638
17864	24273	0	applied	\N	\N	\N	\N	75644	75644	75645
17864	24274	1	applied	\N	\N	\N	\N	75646	75646	75647
17864	24275	2	applied	\N	\N	\N	\N	75648	75648	75649
17864	24276	3	applied	\N	\N	\N	\N	75650	75650	75651
17865	24277	0	applied	\N	\N	\N	\N	75656	75656	75657
17865	24278	1	applied	\N	\N	\N	\N	75658	75658	75659
17865	24279	2	applied	\N	\N	\N	\N	75660	75660	75661
17867	24281	0	applied	\N	\N	\N	\N	75685	75685	75686
17867	24282	1	applied	\N	\N	\N	\N	75687	75687	75688
17867	24283	2	applied	\N	\N	\N	\N	75689	75689	75690
17867	24284	3	applied	\N	\N	\N	\N	75691	75691	75692
17867	24280	4	applied	\N	\N	\N	\N	75665	75665	75666
17867	24285	5	applied	\N	\N	\N	\N	75693	75693	75694
17867	24286	6	applied	\N	\N	\N	\N	75695	75695	75696
17867	24287	7	applied	\N	\N	\N	\N	75697	75697	75698
17868	24288	0	applied	\N	\N	\N	\N	75700	75700	75701
17868	24289	1	applied	\N	\N	\N	\N	75702	75702	75703
17868	24290	2	applied	\N	\N	\N	\N	75704	75704	75705
17868	24291	3	applied	\N	\N	\N	\N	75706	75706	75707
17868	24292	4	applied	\N	\N	\N	\N	75708	75708	75709
17868	24293	5	applied	\N	\N	\N	\N	75710	75710	75711
17868	24294	6	applied	\N	\N	\N	\N	75712	75712	75713
17868	24295	7	applied	\N	\N	\N	\N	75714	75714	75715
17868	24296	8	applied	\N	\N	\N	\N	75716	75716	75717
17869	24280	0	applied	\N	\N	\N	\N	75665	75665	75666
17874	24307	0	applied	\N	\N	\N	\N	75745	75745	75746
17874	24308	1	applied	\N	\N	\N	\N	75747	75747	75748
17874	24309	2	applied	\N	\N	\N	\N	75749	75749	75750
17874	24310	3	applied	\N	\N	\N	\N	75751	75751	75752
17881	24324	0	applied	\N	\N	\N	\N	75786	75786	75787
17881	24325	1	applied	\N	\N	\N	\N	75788	75788	75789
17881	24326	3	applied	\N	\N	\N	\N	75791	75791	75792
17887	24334	0	applied	\N	\N	\N	\N	75817	75817	75818
17887	24335	1	applied	\N	\N	\N	\N	75819	75819	75820
17887	24336	2	applied	\N	\N	\N	\N	75821	75821	75822
17887	24337	3	applied	\N	\N	\N	\N	75823	75823	75824
17887	24338	4	applied	\N	\N	\N	\N	75825	75825	75826
17887	24339	5	applied	\N	\N	\N	\N	75827	75827	75828
17891	24340	0	applied	\N	\N	\N	\N	75834	75834	75835
17891	24341	1	applied	\N	\N	\N	\N	75836	75836	75826
17891	24342	2	applied	\N	\N	\N	\N	75837	75837	75828
17891	24336	3	applied	\N	\N	\N	\N	75821	75821	75838
17891	24337	4	applied	\N	\N	\N	\N	75823	75823	75839
17891	24343	5	applied	\N	\N	\N	\N	75840	75840	75841
17896	24195	0	applied	\N	\N	1000000000	\N	75415	75415	75416
17896	24167	1	applied	\N	\N	\N	\N	75339	75339	75340
17896	24168	2	applied	\N	\N	\N	\N	75341	75341	75342
17896	24176	3	applied	\N	\N	\N	\N	75363	75363	75364
17896	24177	4	applied	\N	\N	\N	\N	75365	75365	75366
17866	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
17866	24190	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17866	24261	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17866	24121	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
17866	24133	8	applied	\N	\N	\N	\N	75249	75249	75415
17866	23996	9	applied	\N	\N	\N	\N	74890	74890	75664
17866	24280	10	applied	\N	\N	\N	\N	75665	75665	75666
17866	24014	11	applied	\N	\N	\N	\N	74937	74937	73438
17866	24018	12	applied	\N	\N	\N	\N	74954	74954	75667
17866	24035	13	applied	\N	\N	\N	\N	74993	74993	73440
17866	24049	14	applied	\N	\N	\N	\N	75025	75025	75668
17866	24059	15	applied	\N	\N	\N	\N	75048	75048	73462
17866	24069	16	applied	\N	\N	\N	\N	75092	75092	75669
17866	24080	17	applied	\N	\N	\N	\N	75125	75125	75670
17866	24092	18	applied	\N	\N	\N	\N	75150	75150	73464
17866	24102	19	applied	\N	\N	\N	\N	75179	75179	75671
17866	24111	20	applied	\N	\N	\N	\N	75198	75198	73481
17866	24128	21	applied	\N	\N	\N	\N	75235	75235	75672
17866	24139	22	applied	\N	\N	\N	\N	75265	75265	75673
17866	24146	23	applied	\N	\N	\N	\N	75283	75283	73483
17866	24156	24	applied	\N	\N	\N	\N	75306	75306	75674
17866	24171	25	applied	\N	\N	\N	\N	75347	75347	75675
17866	24178	26	applied	\N	\N	\N	\N	75367	75367	73492
17866	24191	27	applied	\N	\N	\N	\N	75402	75402	75676
17866	24198	28	applied	\N	\N	\N	\N	75421	75421	75677
17866	24209	29	applied	\N	\N	\N	\N	75449	75449	73498
17866	24218	30	applied	\N	\N	\N	\N	75477	75477	75678
17866	24233	31	applied	\N	\N	\N	\N	75514	75514	75679
17866	24239	32	applied	\N	\N	\N	\N	75533	75533	73506
17866	24252	33	applied	\N	\N	\N	\N	75574	75574	75680
17866	24266	34	applied	\N	\N	\N	\N	75618	75618	75681
17866	24274	35	applied	\N	\N	\N	\N	75646	75646	73511
17872	24301	0	applied	\N	\N	\N	\N	75732	75732	75733
17872	24302	1	applied	\N	\N	\N	\N	75734	75734	75735
17872	24303	2	applied	\N	\N	\N	\N	75736	75736	75737
17873	24304	0	applied	\N	\N	\N	\N	75739	75739	75740
17873	24305	1	applied	\N	\N	\N	\N	75741	75741	75742
17873	24306	2	applied	\N	\N	\N	\N	75743	75743	75744
17878	24311	0	applied	\N	\N	\N	\N	75758	75758	75759
17878	24312	1	applied	\N	\N	\N	\N	75760	75760	75761
17878	24313	2	applied	\N	\N	\N	\N	75762	75762	75763
17879	24314	0	applied	\N	\N	\N	\N	75764	75764	75765
17879	24315	1	applied	\N	\N	\N	\N	75766	75766	75767
17879	24316	2	applied	\N	\N	\N	\N	75768	75768	75769
17879	24317	3	applied	\N	\N	\N	\N	75770	75770	75771
17879	24318	4	applied	\N	\N	\N	\N	75772	75772	75773
17879	24319	5	applied	\N	\N	\N	\N	75774	75774	75775
17879	24320	6	applied	\N	\N	\N	\N	75776	75776	75777
17879	24321	7	applied	\N	\N	\N	\N	75778	75778	75779
17879	24322	8	applied	\N	\N	\N	\N	75780	75780	75781
17879	24323	9	applied	\N	\N	\N	\N	75782	75782	75783
17880	24324	0	applied	\N	\N	\N	\N	75786	75786	75787
17880	24325	1	applied	\N	\N	\N	\N	75788	75788	75789
17880	24326	3	applied	\N	\N	\N	\N	75791	75791	75792
17885	24327	0	applied	\N	\N	\N	\N	75801	75801	75802
17885	24328	1	applied	\N	\N	\N	\N	75803	75803	75804
17885	24329	2	applied	\N	\N	\N	\N	75805	75805	75806
17885	24330	3	applied	\N	\N	\N	\N	75807	75807	75808
17885	24331	4	applied	\N	\N	\N	\N	75809	75809	75810
17885	24332	5	applied	\N	\N	\N	\N	75811	75811	75812
17885	24333	6	applied	\N	\N	\N	\N	75813	75813	75814
17890	24340	0	applied	\N	\N	\N	\N	75834	75834	75835
17890	24341	1	applied	\N	\N	\N	\N	75836	75836	75826
17890	24342	2	applied	\N	\N	\N	\N	75837	75837	75828
17890	24336	3	applied	\N	\N	\N	\N	75821	75821	75838
17890	24337	4	applied	\N	\N	\N	\N	75823	75823	75839
17890	24343	5	applied	\N	\N	\N	\N	75840	75840	75841
17895	24344	0	applied	\N	\N	\N	\N	75849	75849	75850
17895	24345	1	applied	\N	\N	\N	\N	75851	75851	75852
17895	24346	2	applied	\N	\N	\N	\N	75853	75853	75854
17897	24347	0	applied	\N	\N	1000000000	\N	75904	75904	75905
17897	24348	1	applied	\N	\N	\N	\N	75906	75906	75907
17897	24349	2	applied	\N	\N	\N	\N	75908	75908	75909
17897	24350	3	applied	\N	\N	\N	\N	75910	75910	75911
17897	24351	4	applied	\N	\N	\N	\N	75912	75912	75913
17897	24352	5	applied	\N	\N	\N	\N	75914	75914	75915
17897	24353	6	applied	\N	\N	\N	\N	75916	75916	75917
17897	24354	7	applied	\N	\N	\N	\N	75918	75918	75919
17897	24355	8	applied	\N	\N	\N	\N	75920	75920	75921
17897	24356	9	applied	\N	\N	\N	\N	75922	75922	75923
17897	24357	10	applied	\N	\N	\N	\N	75924	75924	75925
17897	24358	11	applied	\N	\N	\N	\N	75926	75926	75927
17897	24359	12	applied	\N	\N	\N	\N	75928	75928	75929
17897	24360	13	applied	\N	\N	\N	\N	75930	75930	75931
17897	24361	14	applied	\N	\N	\N	\N	75932	75932	75933
17897	24362	15	applied	\N	\N	\N	\N	75934	75934	75935
17897	24363	16	applied	\N	\N	\N	\N	75936	75936	75937
17903	24371	0	applied	\N	\N	\N	\N	75956	75956	75957
17903	24372	1	applied	\N	\N	\N	\N	75958	75958	75959
17903	24373	2	applied	\N	\N	\N	\N	75960	75960	75961
17903	24374	3	applied	\N	\N	\N	\N	75962	75962	75963
17903	24375	4	applied	\N	\N	\N	\N	75964	75964	75965
17903	24376	5	applied	\N	\N	\N	\N	75966	75966	75967
17903	24377	6	applied	\N	\N	\N	\N	75968	75968	75969
17908	24378	0	applied	\N	\N	\N	\N	75979	75979	75980
17908	24379	1	applied	\N	\N	\N	\N	75981	75981	75982
17913	24382	0	applied	\N	\N	\N	\N	75994	75994	75995
17913	24383	1	applied	\N	\N	\N	\N	75996	75996	75997
17913	24384	2	applied	\N	\N	\N	\N	75998	75998	75999
17913	24385	3	applied	\N	\N	\N	\N	76000	76000	76001
17913	24386	4	applied	\N	\N	\N	\N	76002	76002	76003
17913	24387	5	applied	\N	\N	\N	\N	76004	76004	76005
17921	24403	0	applied	\N	\N	\N	\N	76051	76051	76052
17921	24404	1	applied	\N	\N	\N	\N	76053	76053	76054
17921	24405	2	applied	\N	\N	\N	\N	76055	76055	76056
17921	24406	3	applied	\N	\N	\N	\N	76057	76057	76058
17922	24407	0	applied	\N	\N	\N	\N	76060	76060	76061
17922	24408	1	applied	\N	\N	\N	\N	76062	76062	76063
17922	24409	2	applied	\N	\N	\N	\N	76064	76064	76065
17927	24413	0	applied	\N	\N	\N	\N	76076	76076	76077
17927	24414	1	applied	\N	\N	\N	\N	76078	76078	76078
17927	24415	2	applied	\N	\N	\N	\N	76079	76079	76080
17927	24416	3	applied	\N	\N	\N	\N	76081	76081	76082
17931	24417	0	applied	\N	\N	\N	\N	76087	76087	76088
17931	24418	1	applied	\N	\N	\N	\N	76089	76089	76090
17931	24419	2	applied	\N	\N	\N	\N	76091	76091	76092
17931	24420	3	applied	\N	\N	\N	\N	76093	76093	76094
17932	24421	0	applied	\N	\N	\N	\N	76100	76100	76101
17889	24343	5	applied	\N	\N	\N	\N	75840	75840	75841
17894	24344	0	applied	\N	\N	\N	\N	75849	75849	75850
17894	24345	1	applied	\N	\N	\N	\N	75851	75851	75852
17894	24346	2	applied	\N	\N	\N	\N	75853	75853	75854
17902	24371	0	applied	\N	\N	\N	\N	75956	75956	75957
17902	24372	1	applied	\N	\N	\N	\N	75958	75958	75959
17902	24373	2	applied	\N	\N	\N	\N	75960	75960	75961
17902	24374	3	applied	\N	\N	\N	\N	75962	75962	75963
17902	24375	4	applied	\N	\N	\N	\N	75964	75964	75965
17902	24376	5	applied	\N	\N	\N	\N	75966	75966	75967
17902	24377	6	applied	\N	\N	\N	\N	75968	75968	75969
17907	24378	0	applied	\N	\N	\N	\N	75979	75979	75980
17907	24379	1	applied	\N	\N	\N	\N	75981	75981	75982
17912	24382	0	applied	\N	\N	\N	\N	75994	75994	75995
17912	24383	1	applied	\N	\N	\N	\N	75996	75996	75997
17912	24384	2	applied	\N	\N	\N	\N	75998	75998	75999
17912	24385	3	applied	\N	\N	\N	\N	76000	76000	76001
17912	24386	4	applied	\N	\N	\N	\N	76002	76002	76003
17912	24387	5	applied	\N	\N	\N	\N	76004	76004	76005
17918	24398	0	applied	\N	\N	\N	\N	76034	76034	76035
17918	24399	1	applied	\N	\N	\N	\N	76036	76036	76037
17918	24400	2	applied	\N	\N	\N	\N	76038	76038	76039
17923	24410	0	applied	\N	\N	\N	\N	76066	76066	76067
17923	24411	1	applied	\N	\N	\N	\N	76068	76068	76069
17923	24412	2	applied	\N	\N	\N	\N	76070	76070	76071
17928	24417	0	applied	\N	\N	\N	\N	76087	76087	76088
17928	24418	1	applied	\N	\N	\N	\N	76089	76089	76090
17928	24419	2	applied	\N	\N	\N	\N	76091	76091	76092
17928	24420	3	applied	\N	\N	\N	\N	76093	76093	76094
17934	24432	0	applied	\N	\N	\N	\N	76124	76124	76125
17934	24433	1	applied	\N	\N	\N	\N	76126	76126	76127
17939	24435	0	applied	\N	\N	\N	\N	76136	76136	76137
17939	24436	1	applied	\N	\N	\N	\N	76138	76138	76139
17939	24438	2	applied	\N	\N	\N	\N	76144	76144	76144
17939	24437	3	applied	\N	\N	\N	\N	76140	76140	76141
17944	24446	0	applied	\N	\N	\N	\N	76168	76168	76169
17944	24447	1	applied	\N	\N	\N	\N	76170	76170	76171
17944	24448	2	applied	\N	\N	\N	\N	76172	76172	76173
17945	24449	0	applied	\N	\N	\N	\N	76175	76175	76176
17945	24450	1	applied	\N	\N	\N	\N	76177	76177	76178
17945	24451	2	applied	\N	\N	\N	\N	76179	76179	76180
17945	24452	3	applied	\N	\N	\N	\N	76181	76181	76182
17945	24453	4	applied	\N	\N	\N	\N	76183	76183	76184
17945	24454	5	applied	\N	\N	\N	\N	76185	76185	76186
17945	24455	6	applied	\N	\N	\N	\N	76187	76187	76188
17950	24459	0	applied	\N	\N	\N	\N	76201	76201	76202
17950	24460	1	applied	\N	\N	\N	\N	76203	76203	76204
17950	24461	2	applied	\N	\N	\N	\N	76205	76205	76206
17951	24462	0	applied	\N	\N	\N	\N	76209	76209	76210
17951	24463	1	applied	\N	\N	\N	\N	76211	76211	76212
17951	24464	2	applied	\N	\N	\N	\N	76213	76213	76214
17951	24465	3	applied	\N	\N	\N	\N	76215	76215	76216
17956	24469	0	applied	\N	\N	\N	\N	76235	76235	76236
17956	24470	1	applied	\N	\N	\N	\N	76237	76237	76238
17956	24471	2	applied	\N	\N	\N	\N	76239	76239	76240
17959	24043	0	applied	\N	\N	\N	\N	75014	75014	71028
17959	24037	1	applied	\N	\N	\N	\N	74999	74999	74999
17959	24028	2	applied	\N	\N	\N	\N	74980	74980	74980
17959	23993	3	applied	\N	\N	1000000000	\N	74884	74884	74885
17959	24195	4	applied	\N	\N	1000000000	\N	75621	75621	75416
17959	24347	5	applied	\N	\N	1000000000	\N	76256	76256	75905
17959	24120	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
17959	24414	7	applied	\N	\N	\N	\N	76078	76078	76078
17959	24190	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17959	24261	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17959	24121	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
17959	24133	11	applied	\N	\N	\N	\N	75249	75249	75904
17959	23996	12	applied	\N	\N	\N	\N	74890	74890	76257
17959	24423	13	applied	\N	\N	\N	\N	76104	76104	76104
17959	24438	14	applied	\N	\N	\N	\N	76144	76144	76144
17959	24280	15	applied	\N	\N	\N	\N	75665	75665	75666
17959	24014	16	applied	\N	\N	\N	\N	74937	74937	74185
17959	24018	17	applied	\N	\N	\N	\N	74954	74954	76258
17959	24035	18	applied	\N	\N	\N	\N	74993	74993	74187
17959	24049	19	applied	\N	\N	\N	\N	75025	75025	76259
17959	24059	20	applied	\N	\N	\N	\N	75048	75048	76260
17959	24069	21	applied	\N	\N	\N	\N	75092	75092	74193
17959	24080	22	applied	\N	\N	\N	\N	75125	75125	76261
17959	24092	23	applied	\N	\N	\N	\N	75150	75150	74195
17959	24102	24	applied	\N	\N	\N	\N	75179	75179	76262
17959	24111	25	applied	\N	\N	\N	\N	75198	75198	76263
17959	24128	26	applied	\N	\N	\N	\N	75235	75235	74204
17959	24139	27	applied	\N	\N	\N	\N	75265	75265	76264
17959	24146	28	applied	\N	\N	\N	\N	75283	75283	74206
17959	24156	29	applied	\N	\N	\N	\N	75306	75306	76265
17959	24171	30	applied	\N	\N	\N	\N	75347	75347	74208
17959	24178	31	applied	\N	\N	\N	\N	75367	75367	76266
17959	24191	32	applied	\N	\N	\N	\N	75402	75402	76267
17959	24198	33	applied	\N	\N	\N	\N	75421	75421	74210
17959	24209	34	applied	\N	\N	\N	\N	75449	75449	76268
17959	24218	35	applied	\N	\N	\N	\N	75477	75477	76269
17959	24233	36	applied	\N	\N	\N	\N	75514	75514	74219
17959	24239	37	applied	\N	\N	\N	\N	75533	75533	76270
17959	24252	38	applied	\N	\N	\N	\N	75574	75574	74221
17959	24266	39	applied	\N	\N	\N	\N	75618	75618	74693
17959	24274	40	applied	\N	\N	\N	\N	75646	75646	76271
17959	24284	41	applied	\N	\N	\N	\N	75691	75691	74320
17959	24298	42	applied	\N	\N	\N	\N	75723	75723	76272
17959	24309	43	applied	\N	\N	\N	\N	75749	75749	74322
17959	24318	44	applied	\N	\N	\N	\N	75772	75772	76273
17959	24331	45	applied	\N	\N	\N	\N	75809	75809	74328
17959	24341	46	applied	\N	\N	\N	\N	75836	75836	76274
17959	24353	47	applied	\N	\N	\N	\N	75916	75916	76275
17959	24367	48	applied	\N	\N	\N	\N	75947	75947	74330
17959	24375	49	applied	\N	\N	\N	\N	75964	75964	76276
17959	24384	50	applied	\N	\N	\N	\N	75998	75998	74337
17959	24394	51	applied	\N	\N	\N	\N	76024	76024	76277
17959	24404	52	applied	\N	\N	\N	\N	76053	76053	76278
17959	24420	53	applied	\N	\N	\N	\N	76093	76093	74339
17959	24429	54	applied	\N	\N	\N	\N	76116	76116	76279
17959	24440	55	applied	\N	\N	\N	\N	76148	76148	74348
17959	24454	56	applied	\N	\N	\N	\N	76185	76185	76280
17959	24465	57	applied	\N	\N	\N	\N	76215	76215	76281
17959	24474	58	applied	\N	\N	\N	\N	76251	76251	74350
17965	24492	0	applied	\N	\N	\N	\N	76366	76366	76367
17965	24493	1	applied	\N	\N	\N	\N	76368	76368	76369
17965	24494	2	applied	\N	\N	\N	\N	76370	76370	76371
17896	24181	5	applied	\N	\N	\N	\N	75375	75375	75376
17896	24184	6	applied	\N	\N	\N	\N	75383	75383	75384
17896	24189	7	applied	\N	\N	\N	\N	75399	75399	75400
17896	24194	8	applied	\N	\N	\N	\N	75412	75412	75413
17896	24196	9	applied	\N	\N	\N	\N	75417	75417	75418
17896	24211	10	applied	\N	\N	\N	\N	75459	75459	75460
17896	24214	11	applied	\N	\N	\N	\N	75469	75469	75470
17896	24217	12	applied	\N	\N	\N	\N	75475	75475	75476
17896	24221	13	applied	\N	\N	\N	\N	75486	75486	75487
17896	24224	14	applied	\N	\N	\N	\N	75493	75493	75494
17896	24225	15	applied	\N	\N	\N	\N	75495	75495	75496
17896	24230	16	applied	\N	\N	\N	\N	75508	75508	75509
17896	24234	17	applied	\N	\N	\N	\N	75519	75519	75520
17896	24237	18	applied	\N	\N	\N	\N	75529	75529	75530
17896	24238	19	applied	\N	\N	\N	\N	75531	75531	75532
17896	24244	20	applied	\N	\N	\N	\N	75545	75545	75546
17896	24245	21	applied	\N	\N	\N	\N	75547	75547	75548
17896	24251	22	applied	\N	\N	\N	\N	75572	75572	75573
17896	24254	23	applied	\N	\N	\N	\N	75588	75588	75589
17896	24257	24	applied	\N	\N	\N	\N	75596	75596	75597
17896	24260	25	applied	\N	\N	\N	\N	75604	75604	75605
17896	24264	26	applied	\N	\N	\N	\N	75614	75614	75615
17896	24267	27	applied	\N	\N	\N	\N	75625	75625	75626
17896	24270	28	applied	\N	\N	\N	\N	75633	75633	75634
17896	24273	29	applied	\N	\N	\N	\N	75644	75644	75645
17896	24277	30	applied	\N	\N	\N	\N	75656	75656	75657
17896	24281	31	applied	\N	\N	\N	\N	75685	75685	75686
17896	24282	32	applied	\N	\N	\N	\N	75687	75687	75688
17896	24288	33	applied	\N	\N	\N	\N	75700	75700	75701
17896	24289	34	applied	\N	\N	\N	\N	75702	75702	75703
17896	24290	35	applied	\N	\N	\N	\N	75704	75704	75705
17896	24297	36	applied	\N	\N	\N	\N	75721	75721	75722
17896	24301	37	applied	\N	\N	\N	\N	75732	75732	75733
17896	24304	38	applied	\N	\N	\N	\N	75739	75739	75740
17896	24307	39	applied	\N	\N	\N	\N	75745	75745	75746
17896	24311	40	applied	\N	\N	\N	\N	75758	75758	75759
17896	24314	41	applied	\N	\N	\N	\N	75764	75764	75765
17896	24315	42	applied	\N	\N	\N	\N	75766	75766	75767
17896	24316	43	applied	\N	\N	\N	\N	75768	75768	75769
17896	24324	44	applied	\N	\N	\N	\N	75786	75786	75787
17896	24327	45	applied	\N	\N	\N	\N	75801	75801	75802
17896	24328	46	applied	\N	\N	\N	\N	75803	75803	75804
17896	24334	47	applied	\N	\N	\N	\N	75817	75817	75818
17896	24335	48	applied	\N	\N	\N	\N	75819	75819	75820
17896	24340	49	applied	\N	\N	\N	\N	75834	75834	75835
17896	24344	50	applied	\N	\N	\N	\N	75849	75849	75850
17896	24190	51	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17896	24261	52	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17896	24280	53	applied	\N	\N	\N	\N	75665	75665	75666
17896	24169	54	applied	\N	\N	\N	\N	75343	75343	75344
17896	24170	55	applied	\N	\N	\N	\N	75345	75345	75346
17896	24175	56	applied	\N	\N	\N	\N	75360	75360	75861
17896	24179	57	applied	\N	\N	\N	\N	75369	75369	75350
17896	24182	58	applied	\N	\N	\N	\N	75377	75377	75862
17896	24171	59	applied	\N	\N	\N	\N	75347	75347	75352
17896	24178	60	applied	\N	\N	\N	\N	75367	75367	75863
17896	24191	61	applied	\N	\N	\N	\N	75402	75402	75864
17896	24198	62	applied	\N	\N	\N	\N	75421	75421	75359
17896	24209	63	applied	\N	\N	\N	\N	75449	75449	75865
17896	24218	64	applied	\N	\N	\N	\N	75477	75477	75361
17896	24172	65	applied	\N	\N	\N	\N	75349	75349	75370
17896	24173	66	applied	\N	\N	\N	\N	75351	75351	75372
17896	24174	67	applied	\N	\N	\N	\N	75358	75358	75866
17896	24180	68	applied	\N	\N	\N	\N	75371	75371	75867
17896	24183	69	applied	\N	\N	\N	\N	75379	75379	75868
17896	24185	70	applied	\N	\N	\N	\N	75385	75385	75395
17896	24186	71	applied	\N	\N	\N	\N	75387	75387	75407
17896	24187	72	applied	\N	\N	\N	\N	75394	75394	75404
17896	24192	73	applied	\N	\N	\N	\N	75406	75406	75408
17896	24201	74	applied	\N	\N	\N	\N	75427	75427	75869
17896	24202	75	applied	\N	\N	\N	\N	75429	75429	75870
17896	24188	76	applied	\N	\N	\N	\N	75396	75396	75422
17896	24193	77	applied	\N	\N	\N	\N	75409	75409	75424
17896	24197	78	applied	\N	\N	\N	\N	75419	75419	75426
17896	24199	79	applied	\N	\N	\N	\N	75423	75423	75871
17896	24200	80	applied	\N	\N	\N	\N	75425	75425	75432
17896	24204	81	applied	\N	\N	\N	\N	75435	75435	75436
17896	24206	82	applied	\N	\N	\N	\N	75441	75441	75872
17896	24208	83	applied	\N	\N	\N	\N	75447	75447	75873
17896	24212	84	applied	\N	\N	\N	\N	75461	75461	75874
17896	24216	85	applied	\N	\N	\N	\N	75473	75473	75875
17896	24220	86	applied	\N	\N	\N	\N	75481	75481	75876
17896	24203	87	applied	\N	\N	\N	\N	75431	75431	75877
17896	24205	88	applied	\N	\N	\N	\N	75437	75437	75878
17896	24207	89	applied	\N	\N	\N	\N	75443	75443	75879
17896	24210	90	applied	\N	\N	\N	\N	75451	75451	75474
17896	24213	91	applied	\N	\N	\N	\N	75463	75463	75880
17896	24215	92	applied	\N	\N	\N	\N	75471	75471	75881
17896	24219	93	applied	\N	\N	\N	\N	75479	75479	75482
17896	24222	94	applied	\N	\N	\N	\N	75488	75488	75489
17896	24226	95	applied	\N	\N	\N	\N	75497	75497	75882
17896	24227	96	applied	\N	\N	\N	\N	75499	75499	75883
17896	24231	97	applied	\N	\N	\N	\N	75510	75510	75884
17896	24235	98	applied	\N	\N	\N	\N	75521	75521	75885
17896	24223	99	applied	\N	\N	\N	\N	75490	75490	75886
17896	24233	100	applied	\N	\N	\N	\N	75514	75514	75887
17896	24239	101	applied	\N	\N	\N	\N	75533	75533	75504
17896	24252	102	applied	\N	\N	\N	\N	75574	75574	75888
17896	24266	103	applied	\N	\N	\N	\N	75618	75618	75511
17896	24274	105	applied	\N	\N	\N	\N	75646	75646	75890
17896	24284	106	applied	\N	\N	\N	\N	75691	75691	75891
17896	24298	107	applied	\N	\N	\N	\N	75723	75723	75513
17896	24309	108	applied	\N	\N	\N	\N	75749	75749	75515
17896	24318	109	applied	\N	\N	\N	\N	75772	75772	75892
17896	24331	110	applied	\N	\N	\N	\N	75809	75809	75522
17896	24341	111	applied	\N	\N	\N	\N	75836	75836	75893
17896	24228	112	applied	\N	\N	\N	\N	75501	75501	75534
17896	24229	113	applied	\N	\N	\N	\N	75503	75503	75894
17896	24232	114	applied	\N	\N	\N	\N	75512	75512	75895
17896	24236	115	applied	\N	\N	\N	\N	75523	75523	75896
17896	24240	116	applied	\N	\N	\N	\N	75535	75535	75897
17896	24241	117	applied	\N	\N	\N	\N	75537	75537	75556
17896	24246	118	applied	\N	\N	\N	\N	75549	75549	75898
17896	24247	119	applied	\N	\N	\N	\N	75551	75551	75899
17896	24250	120	applied	\N	\N	\N	\N	75567	75567	75584
17896	24255	121	applied	\N	\N	\N	\N	75590	75590	75585
17896	24259	122	applied	\N	\N	\N	\N	75600	75600	75575
17896	24262	123	applied	\N	\N	\N	\N	75607	75607	75582
17896	24265	124	applied	\N	\N	\N	\N	75616	75616	75900
17896	24269	125	applied	\N	\N	\N	\N	75629	75629	75901
17898	24347	0	applied	\N	\N	1000000000	\N	75904	75904	75905
17898	24348	1	applied	\N	\N	\N	\N	75906	75906	75907
17898	24349	2	applied	\N	\N	\N	\N	75908	75908	75909
17898	24350	3	applied	\N	\N	\N	\N	75910	75910	75911
17898	24351	4	applied	\N	\N	\N	\N	75912	75912	75913
17898	24352	5	applied	\N	\N	\N	\N	75914	75914	75915
17898	24353	6	applied	\N	\N	\N	\N	75916	75916	75917
17898	24354	7	applied	\N	\N	\N	\N	75918	75918	75919
17898	24355	8	applied	\N	\N	\N	\N	75920	75920	75921
17898	24356	9	applied	\N	\N	\N	\N	75922	75922	75923
17898	24357	10	applied	\N	\N	\N	\N	75924	75924	75925
17898	24358	11	applied	\N	\N	\N	\N	75926	75926	75927
17898	24359	12	applied	\N	\N	\N	\N	75928	75928	75929
17898	24360	13	applied	\N	\N	\N	\N	75930	75930	75931
17898	24361	14	applied	\N	\N	\N	\N	75932	75932	75933
17898	24362	15	applied	\N	\N	\N	\N	75934	75934	75935
17898	24363	16	applied	\N	\N	\N	\N	75936	75936	75937
17899	24364	0	applied	\N	\N	\N	\N	75941	75941	75942
17899	24365	1	applied	\N	\N	\N	\N	75943	75943	75944
17899	24366	2	applied	\N	\N	\N	\N	75945	75945	75946
17899	24367	3	applied	\N	\N	\N	\N	75947	75947	75948
17899	24368	4	applied	\N	\N	\N	\N	75949	75949	75950
17899	24369	5	applied	\N	\N	\N	\N	75951	75951	75952
17899	24370	6	applied	\N	\N	\N	\N	75953	75953	75954
17904	24371	0	applied	\N	\N	\N	\N	75956	75956	75957
17904	24372	1	applied	\N	\N	\N	\N	75958	75958	75959
17904	24373	2	applied	\N	\N	\N	\N	75960	75960	75961
17904	24374	3	applied	\N	\N	\N	\N	75962	75962	75963
17904	24375	4	applied	\N	\N	\N	\N	75964	75964	75965
17904	24376	5	applied	\N	\N	\N	\N	75966	75966	75967
17904	24377	6	applied	\N	\N	\N	\N	75968	75968	75969
17909	24380	0	applied	\N	\N	\N	\N	75988	75988	75989
17909	24381	1	applied	\N	\N	\N	\N	75990	75990	75991
17914	24382	0	applied	\N	\N	\N	\N	75994	75994	75995
17914	24383	1	applied	\N	\N	\N	\N	75996	75996	75997
17914	24384	2	applied	\N	\N	\N	\N	75998	75998	75999
17914	24385	3	applied	\N	\N	\N	\N	76000	76000	76001
17914	24386	4	applied	\N	\N	\N	\N	76002	76002	76003
17914	24387	5	applied	\N	\N	\N	\N	76004	76004	76005
17915	24388	0	applied	\N	\N	\N	\N	76012	76012	76013
17915	24389	1	applied	\N	\N	\N	\N	76014	76014	76015
17915	24390	2	applied	\N	\N	\N	\N	76016	76016	76017
17916	24391	0	applied	\N	\N	\N	\N	76018	76018	76019
17916	24392	1	applied	\N	\N	\N	\N	76020	76020	76021
17916	24393	2	applied	\N	\N	\N	\N	76022	76022	76023
17916	24394	3	applied	\N	\N	\N	\N	76024	76024	76025
17916	24395	4	applied	\N	\N	\N	\N	76026	76026	76027
17916	24396	5	applied	\N	\N	\N	\N	76028	76028	76029
17916	24397	6	applied	\N	\N	\N	\N	76030	76030	76031
17920	24401	0	applied	\N	\N	\N	\N	76046	76046	76047
17920	24402	1	applied	\N	\N	\N	\N	76048	76048	76049
17925	24410	0	applied	\N	\N	\N	\N	76066	76066	76067
17925	24411	1	applied	\N	\N	\N	\N	76068	76068	76069
17925	24412	2	applied	\N	\N	\N	\N	76070	76070	76071
17926	24413	0	applied	\N	\N	\N	\N	76076	76076	76077
17926	24414	1	applied	\N	\N	\N	\N	76078	76078	76078
17926	24415	2	applied	\N	\N	\N	\N	76079	76079	76080
17926	24416	3	applied	\N	\N	\N	\N	76081	76081	76082
17930	24417	0	applied	\N	\N	\N	\N	76087	76087	76088
17930	24418	1	applied	\N	\N	\N	\N	76089	76089	76090
17930	24419	2	applied	\N	\N	\N	\N	76091	76091	76092
17930	24420	3	applied	\N	\N	\N	\N	76093	76093	76094
17936	24432	0	applied	\N	\N	\N	\N	76124	76124	76125
17936	24434	1	applied	\N	\N	\N	\N	76129	76129	76130
17936	24433	2	applied	\N	\N	\N	\N	76126	76126	76131
17941	24439	0	applied	\N	\N	\N	\N	76146	76146	76147
17941	24440	1	applied	\N	\N	\N	\N	76148	76148	76149
17941	24442	2	applied	\N	\N	\N	\N	76154	76154	76155
17941	24441	3	applied	\N	\N	\N	\N	76150	76150	76156
17942	24443	0	applied	\N	\N	\N	\N	76158	76158	76159
17942	24444	1	applied	\N	\N	\N	\N	76160	76160	76161
17942	24445	2	applied	\N	\N	\N	\N	76162	76162	76163
17947	24449	0	applied	\N	\N	\N	\N	76175	76175	76176
17947	24450	1	applied	\N	\N	\N	\N	76177	76177	76178
17947	24451	2	applied	\N	\N	\N	\N	76179	76179	76180
17947	24452	3	applied	\N	\N	\N	\N	76181	76181	76182
17947	24453	4	applied	\N	\N	\N	\N	76183	76183	76184
17947	24454	5	applied	\N	\N	\N	\N	76185	76185	76186
17947	24455	6	applied	\N	\N	\N	\N	76187	76187	76188
17953	24196	0	applied	\N	\N	\N	\N	75417	75417	75418
17953	24211	1	applied	\N	\N	\N	\N	75459	75459	75460
17953	24214	2	applied	\N	\N	\N	\N	75469	75469	75470
17953	24195	3	applied	\N	\N	1000000000	\N	75415	75415	75416
17953	24347	4	applied	\N	\N	1000000000	\N	75904	75904	75905
17953	24217	5	applied	\N	\N	\N	\N	75475	75475	75476
17953	24221	6	applied	\N	\N	\N	\N	75486	75486	75487
17953	24224	7	applied	\N	\N	\N	\N	75493	75493	75494
17953	24225	8	applied	\N	\N	\N	\N	75495	75495	75496
17953	24230	9	applied	\N	\N	\N	\N	75508	75508	75509
17953	24234	10	applied	\N	\N	\N	\N	75519	75519	75520
17953	24237	11	applied	\N	\N	\N	\N	75529	75529	75530
17953	24238	12	applied	\N	\N	\N	\N	75531	75531	75532
17953	24244	13	applied	\N	\N	\N	\N	75545	75545	75546
17953	24245	14	applied	\N	\N	\N	\N	75547	75547	75548
17953	24251	15	applied	\N	\N	\N	\N	75572	75572	75573
17953	24254	16	applied	\N	\N	\N	\N	75588	75588	75589
17953	24257	17	applied	\N	\N	\N	\N	75596	75596	75597
17953	24260	18	applied	\N	\N	\N	\N	75604	75604	75605
17953	24264	19	applied	\N	\N	\N	\N	75614	75614	75615
17953	24267	20	applied	\N	\N	\N	\N	75625	75625	75626
17953	24270	21	applied	\N	\N	\N	\N	75633	75633	75634
17953	24273	22	applied	\N	\N	\N	\N	75644	75644	75645
17953	24277	23	applied	\N	\N	\N	\N	75656	75656	75657
17953	24281	24	applied	\N	\N	\N	\N	75685	75685	75686
17953	24282	25	applied	\N	\N	\N	\N	75687	75687	75688
17953	24288	26	applied	\N	\N	\N	\N	75700	75700	75701
17953	24289	27	applied	\N	\N	\N	\N	75702	75702	75703
17953	24290	28	applied	\N	\N	\N	\N	75704	75704	75705
17953	24297	29	applied	\N	\N	\N	\N	75721	75721	75722
17953	24301	30	applied	\N	\N	\N	\N	75732	75732	75733
17953	24304	31	applied	\N	\N	\N	\N	75739	75739	75740
17953	24307	32	applied	\N	\N	\N	\N	75745	75745	75746
17953	24311	33	applied	\N	\N	\N	\N	75758	75758	75759
17953	24314	34	applied	\N	\N	\N	\N	75764	75764	75765
17953	24315	35	applied	\N	\N	\N	\N	75766	75766	75767
17953	24316	36	applied	\N	\N	\N	\N	75768	75768	75769
17953	24324	37	applied	\N	\N	\N	\N	75786	75786	75787
17953	24327	38	applied	\N	\N	\N	\N	75801	75801	75802
17932	24422	1	applied	\N	\N	\N	\N	76102	76102	76103
17932	24423	2	applied	\N	\N	\N	\N	76104	76104	76104
17932	24424	3	applied	\N	\N	\N	\N	76105	76105	76106
17932	24425	4	applied	\N	\N	\N	\N	76107	76107	76108
17932	24426	5	applied	\N	\N	\N	\N	76109	76109	76110
17932	24427	6	applied	\N	\N	\N	\N	76111	76111	76112
17933	24428	0	applied	\N	\N	\N	\N	76114	76114	76115
17933	24429	1	applied	\N	\N	\N	\N	76116	76116	76117
17933	24430	2	applied	\N	\N	\N	\N	76118	76118	76119
17933	24431	3	applied	\N	\N	\N	\N	76120	76120	76121
17937	24432	0	applied	\N	\N	\N	\N	76124	76124	76125
17937	24434	1	applied	\N	\N	\N	\N	76129	76129	76130
17937	24433	2	applied	\N	\N	\N	\N	76126	76126	76131
17938	24435	0	applied	\N	\N	\N	\N	76136	76136	76137
17938	24436	1	applied	\N	\N	\N	\N	76138	76138	76139
17938	24437	2	applied	\N	\N	\N	\N	76140	76140	76141
17943	24443	0	applied	\N	\N	\N	\N	76158	76158	76159
17943	24444	1	applied	\N	\N	\N	\N	76160	76160	76161
17943	24445	2	applied	\N	\N	\N	\N	76162	76162	76163
17948	24449	0	applied	\N	\N	\N	\N	76175	76175	76176
17948	24450	1	applied	\N	\N	\N	\N	76177	76177	76178
17948	24451	2	applied	\N	\N	\N	\N	76179	76179	76180
17948	24452	3	applied	\N	\N	\N	\N	76181	76181	76182
17948	24453	4	applied	\N	\N	\N	\N	76183	76183	76184
17948	24454	5	applied	\N	\N	\N	\N	76185	76185	76186
17948	24455	6	applied	\N	\N	\N	\N	76187	76187	76188
17949	24456	0	applied	\N	\N	\N	\N	76194	76194	76195
17949	24457	1	applied	\N	\N	\N	\N	76196	76196	76197
17949	24458	2	applied	\N	\N	\N	\N	76198	76198	76199
17955	24469	0	applied	\N	\N	\N	\N	76235	76235	76236
17955	24470	1	applied	\N	\N	\N	\N	76237	76237	76238
17955	24471	2	applied	\N	\N	\N	\N	76239	76239	76240
17961	24043	0	applied	\N	\N	\N	\N	75014	75014	71028
17961	24037	1	applied	\N	\N	\N	\N	74999	74999	74999
17961	24028	2	applied	\N	\N	\N	\N	74980	74980	74980
17961	23993	3	applied	\N	\N	1000000000	\N	74884	74884	74885
17961	24195	4	applied	\N	\N	1000000000	\N	75621	75621	75416
17961	24347	5	applied	\N	\N	1000000000	\N	76256	76256	75905
17961	24120	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
17961	24414	7	applied	\N	\N	\N	\N	76078	76078	76078
17961	24190	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
17961	24261	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17961	24121	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
17961	24133	11	applied	\N	\N	\N	\N	75249	75249	75904
17961	23996	12	applied	\N	\N	\N	\N	74890	74890	76298
17961	24423	13	applied	\N	\N	\N	\N	76104	76104	76104
17961	24438	14	applied	\N	\N	\N	\N	76144	76144	76144
17961	24280	15	applied	\N	\N	\N	\N	75665	75665	75666
17961	23998	16	applied	\N	\N	\N	\N	74894	74894	74881
17961	24001	17	applied	\N	\N	\N	\N	74907	74907	76299
17961	24003	18	applied	\N	\N	\N	\N	74913	74913	74891
17961	24006	19	applied	\N	\N	\N	\N	74921	74921	76300
17961	24011	20	applied	\N	\N	\N	\N	74931	74931	76301
17961	24012	21	applied	\N	\N	\N	\N	74933	74933	76302
17961	24014	22	applied	\N	\N	\N	\N	74937	74937	76303
17961	24018	23	applied	\N	\N	\N	\N	74954	74954	74897
17961	24035	24	applied	\N	\N	\N	\N	74993	74993	76304
17961	24049	25	applied	\N	\N	\N	\N	75025	75025	74908
17961	24059	26	applied	\N	\N	\N	\N	75048	75048	76305
17961	24069	27	applied	\N	\N	\N	\N	75092	75092	74914
17961	24080	28	applied	\N	\N	\N	\N	75125	75125	76306
17961	24017	29	applied	\N	\N	\N	\N	74945	74945	74916
17961	24019	30	applied	\N	\N	\N	\N	74956	74956	74922
17961	24024	31	applied	\N	\N	\N	\N	74970	74970	76307
17961	24025	32	applied	\N	\N	\N	\N	74972	74972	76308
17961	24031	33	applied	\N	\N	\N	\N	74985	74985	74930
17961	24034	34	applied	\N	\N	\N	\N	74991	74991	74932
17961	24041	35	applied	\N	\N	\N	\N	75006	75006	74934
17961	24042	36	applied	\N	\N	\N	\N	75008	75008	76309
17961	24050	37	applied	\N	\N	\N	\N	75027	75027	74938
17961	24051	38	applied	\N	\N	\N	\N	75029	75029	76310
17961	24052	39	applied	\N	\N	\N	\N	75031	75031	76311
17961	24058	40	applied	\N	\N	\N	\N	75045	75045	76312
17961	24060	41	applied	\N	\N	\N	\N	75050	75050	74962
17961	24063	42	applied	\N	\N	\N	\N	75075	75075	74963
17961	24064	43	applied	\N	\N	\N	\N	75077	75077	76313
17961	24070	44	applied	\N	\N	\N	\N	75094	75094	76314
17961	24073	45	applied	\N	\N	\N	\N	75108	75108	76315
17961	24076	46	applied	\N	\N	\N	\N	75116	75116	74975
17961	24079	47	applied	\N	\N	\N	\N	75123	75123	76316
17961	24085	48	applied	\N	\N	\N	\N	75136	75136	76317
17961	24086	49	applied	\N	\N	\N	\N	75138	75138	76318
17961	24087	50	applied	\N	\N	\N	\N	75140	75140	74988
17961	24095	51	applied	\N	\N	\N	\N	75160	75160	76319
17961	24098	52	applied	\N	\N	\N	\N	75168	75168	76320
17961	24101	53	applied	\N	\N	\N	\N	75177	75177	74994
17961	24103	54	applied	\N	\N	\N	\N	75181	75181	76321
17961	24109	55	applied	\N	\N	\N	\N	75194	75194	76322
17961	24110	56	applied	\N	\N	\N	\N	75196	75196	75005
17961	24115	57	applied	\N	\N	\N	\N	75209	75209	75007
17961	24123	58	applied	\N	\N	\N	\N	75225	75225	75009
17961	24124	59	applied	\N	\N	\N	\N	75227	75227	76323
17961	24129	60	applied	\N	\N	\N	\N	75237	75237	76324
17961	24130	61	applied	\N	\N	\N	\N	75239	75239	75024
17961	24132	62	applied	\N	\N	\N	\N	75247	75247	76325
17961	24138	63	applied	\N	\N	\N	\N	75263	75263	76326
17961	24140	64	applied	\N	\N	\N	\N	75267	75267	76327
17961	24141	65	applied	\N	\N	\N	\N	75269	75269	76328
17961	24148	66	applied	\N	\N	\N	\N	75287	75287	75034
17961	24150	67	applied	\N	\N	\N	\N	75291	75291	75054
17961	24155	68	applied	\N	\N	\N	\N	75304	75304	75059
17961	24157	69	applied	\N	\N	\N	\N	75308	75308	75044
17961	24160	70	applied	\N	\N	\N	\N	75315	75315	75046
17961	24092	71	applied	\N	\N	\N	\N	75150	75150	75049
17961	24102	72	applied	\N	\N	\N	\N	75179	75179	76329
17961	24111	73	applied	\N	\N	\N	\N	75198	75198	75051
17961	24128	74	applied	\N	\N	\N	\N	75235	75235	76330
17961	24139	75	applied	\N	\N	\N	\N	75265	75265	75076
17961	24146	76	applied	\N	\N	\N	\N	75283	75283	76331
17961	24156	77	applied	\N	\N	\N	\N	75306	75306	75078
17961	24171	78	applied	\N	\N	\N	\N	75347	75347	76332
17961	24178	79	applied	\N	\N	\N	\N	75367	75367	76333
17961	24191	80	applied	\N	\N	\N	\N	75402	75402	75080
17961	24198	81	applied	\N	\N	\N	\N	75421	75421	76334
17961	24209	82	applied	\N	\N	\N	\N	75449	75449	76335
17961	24218	83	applied	\N	\N	\N	\N	75477	75477	75082
17961	24233	84	applied	\N	\N	\N	\N	75514	75514	76336
17953	24328	39	applied	\N	\N	\N	\N	75803	75803	75804
17953	24334	40	applied	\N	\N	\N	\N	75817	75817	75818
17953	24335	41	applied	\N	\N	\N	\N	75819	75819	75820
17953	24340	42	applied	\N	\N	\N	\N	75834	75834	75835
17953	24344	43	applied	\N	\N	\N	\N	75849	75849	75850
17953	24348	44	applied	\N	\N	\N	\N	75906	75906	75907
17953	24349	45	applied	\N	\N	\N	\N	75908	75908	75909
17953	24350	46	applied	\N	\N	\N	\N	75910	75910	75911
17953	24351	47	applied	\N	\N	\N	\N	75912	75912	75913
17953	24352	48	applied	\N	\N	\N	\N	75914	75914	75915
17953	24364	49	applied	\N	\N	\N	\N	75941	75941	75942
17953	24365	50	applied	\N	\N	\N	\N	75943	75943	75944
17953	24371	51	applied	\N	\N	\N	\N	75956	75956	75957
17953	24372	52	applied	\N	\N	\N	\N	75958	75958	75959
17953	24382	53	applied	\N	\N	\N	\N	75994	75994	75995
17953	24388	54	applied	\N	\N	\N	\N	76012	76012	76013
17953	24391	55	applied	\N	\N	\N	\N	76018	76018	76019
17953	24392	56	applied	\N	\N	\N	\N	76020	76020	76021
17953	24398	57	applied	\N	\N	\N	\N	76034	76034	76035
17953	24401	58	applied	\N	\N	\N	\N	76046	76046	76047
17953	24403	59	applied	\N	\N	\N	\N	76051	76051	76052
17953	24407	60	applied	\N	\N	\N	\N	76060	76060	76061
17953	24410	61	applied	\N	\N	\N	\N	76066	76066	76067
17953	24413	63	applied	\N	\N	\N	\N	76076	76076	76077
17953	24417	64	applied	\N	\N	\N	\N	76087	76087	76088
17953	24421	65	applied	\N	\N	\N	\N	76100	76100	76101
17953	24422	66	applied	\N	\N	\N	\N	76102	76102	76103
17953	24428	67	applied	\N	\N	\N	\N	76114	76114	76115
17953	24432	68	applied	\N	\N	\N	\N	76124	76124	76125
17953	24435	69	applied	\N	\N	\N	\N	76136	76136	76137
17953	24439	70	applied	\N	\N	\N	\N	76146	76146	76147
17953	24443	71	applied	\N	\N	\N	\N	76158	76158	76159
17953	24446	72	applied	\N	\N	\N	\N	76168	76168	76169
17953	24449	73	applied	\N	\N	\N	\N	76175	76175	76176
17953	24450	74	applied	\N	\N	\N	\N	76177	76177	76178
17953	24456	75	applied	\N	\N	\N	\N	76194	76194	76195
17953	24459	76	applied	\N	\N	\N	\N	76201	76201	76202
17953	24462	77	applied	\N	\N	\N	\N	76209	76209	76210
17953	24466	78	applied	\N	\N	\N	\N	76218	76218	76219
17953	24261	79	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
17953	24197	80	applied	\N	\N	\N	\N	75419	75419	75420
17953	24414	81	applied	\N	\N	\N	\N	76078	76078	76078
17953	24423	82	applied	\N	\N	\N	\N	76104	76104	76104
17953	24438	83	applied	\N	\N	\N	\N	76144	76144	76144
17953	24198	84	applied	\N	\N	\N	\N	75421	75421	75422
17953	24209	85	applied	\N	\N	\N	\N	75449	75449	76225
17953	24218	86	applied	\N	\N	\N	\N	75477	75477	76226
17953	24280	87	applied	\N	\N	\N	\N	75665	75665	75666
17953	24199	88	applied	\N	\N	\N	\N	75423	75423	76227
17953	24200	89	applied	\N	\N	\N	\N	75425	75425	75428
17953	24204	90	applied	\N	\N	\N	\N	75435	75435	76228
17953	24206	91	applied	\N	\N	\N	\N	75441	75441	76229
17953	24208	92	applied	\N	\N	\N	\N	75447	75447	75438
17953	24212	93	applied	\N	\N	\N	\N	75461	75461	75442
17953	24216	94	applied	\N	\N	\N	\N	75473	75473	76230
17953	24220	95	applied	\N	\N	\N	\N	75481	75481	75450
17953	24201	96	applied	\N	\N	\N	\N	75427	75427	75452
17953	24202	97	applied	\N	\N	\N	\N	75429	75429	75876
17953	24203	98	applied	\N	\N	\N	\N	75431	75431	75877
17953	24205	99	applied	\N	\N	\N	\N	75437	75437	75878
17953	24207	100	applied	\N	\N	\N	\N	75443	75443	75879
17953	24210	101	applied	\N	\N	\N	\N	75451	75451	75474
17953	24213	102	applied	\N	\N	\N	\N	75463	75463	75880
17953	24215	103	applied	\N	\N	\N	\N	75471	75471	75881
17953	24219	104	applied	\N	\N	\N	\N	75479	75479	75482
17953	24222	105	applied	\N	\N	\N	\N	75488	75488	75489
17953	24226	106	applied	\N	\N	\N	\N	75497	75497	75882
17953	24227	107	applied	\N	\N	\N	\N	75499	75499	75883
17953	24231	108	applied	\N	\N	\N	\N	75510	75510	75884
17953	24235	109	applied	\N	\N	\N	\N	75521	75521	75885
17953	24223	110	applied	\N	\N	\N	\N	75490	75490	75886
17953	24233	111	applied	\N	\N	\N	\N	75514	75514	75887
17953	24239	112	applied	\N	\N	\N	\N	75533	75533	75504
17953	24252	113	applied	\N	\N	\N	\N	75574	75574	75888
17953	24266	114	applied	\N	\N	\N	\N	75618	75618	75511
17953	24274	115	applied	\N	\N	\N	\N	75646	75646	75890
17953	24284	116	applied	\N	\N	\N	\N	75691	75691	75891
17953	24298	117	applied	\N	\N	\N	\N	75723	75723	75513
17953	24309	118	applied	\N	\N	\N	\N	75749	75749	75515
17953	24318	119	applied	\N	\N	\N	\N	75772	75772	75892
17953	24331	120	applied	\N	\N	\N	\N	75809	75809	75522
17953	24341	121	applied	\N	\N	\N	\N	75836	75836	75893
17953	24353	122	applied	\N	\N	\N	\N	75916	75916	76231
17953	24367	123	applied	\N	\N	\N	\N	75947	75947	75524
17953	24375	124	applied	\N	\N	\N	\N	75964	75964	75534
17953	24384	125	applied	\N	\N	\N	\N	75998	75998	76232
17954	24469	0	applied	\N	\N	\N	\N	76235	76235	76236
17954	24470	1	applied	\N	\N	\N	\N	76237	76237	76238
17954	24471	2	applied	\N	\N	\N	\N	76239	76239	76240
17958	24472	0	applied	\N	\N	\N	\N	76247	76247	76248
17958	24473	1	applied	\N	\N	\N	\N	76249	76249	76250
17958	24474	2	applied	\N	\N	\N	\N	76251	76251	76252
17958	24475	3	applied	\N	\N	\N	\N	76253	76253	76254
17968	24502	0	applied	\N	\N	\N	\N	76391	76391	76392
17968	24503	1	applied	\N	\N	\N	\N	76393	76393	76394
17973	24511	0	applied	\N	\N	\N	\N	76418	76418	76419
17973	24506	1	applied	\N	\N	\N	\N	76406	76406	76407
17973	24507	2	applied	\N	\N	\N	\N	76408	76408	76409
17973	24508	3	applied	\N	\N	\N	\N	76410	76410	76411
17973	24509	4	applied	\N	\N	\N	\N	76412	76412	76413
17973	24512	5	applied	\N	\N	\N	\N	76420	76420	76421
17973	24510	6	applied	\N	\N	\N	\N	76414	76414	76422
17973	24513	7	applied	\N	\N	\N	\N	76423	76423	76424
17978	24518	0	applied	\N	\N	\N	\N	76440	76440	76441
17978	24519	1	applied	\N	\N	\N	\N	76442	76442	76443
17978	24520	2	applied	\N	\N	\N	\N	76444	76444	76445
17978	24521	3	applied	\N	\N	\N	\N	76446	76446	76447
17998	24589	0	applied	\N	\N	\N	\N	76656	76656	76657
17998	24590	1	applied	\N	\N	\N	\N	76658	76658	76659
18000	24591	0	applied	\N	\N	\N	\N	76661	76661	76662
18000	24592	1	applied	\N	\N	\N	\N	76663	76663	47675
18000	24593	2	applied	\N	\N	\N	\N	76664	76664	76665
18000	24594	3	applied	\N	\N	\N	\N	76666	76666	76667
18000	24595	4	applied	\N	\N	\N	\N	76668	76668	76669
18007	24596	0	applied	\N	\N	\N	\N	76675	76675	76676
18007	24599	1	applied	\N	\N	\N	\N	76682	76682	76683
18007	24602	2	applied	\N	\N	\N	\N	76693	76693	76694
18007	24603	3	applied	\N	\N	\N	\N	76695	76695	76696
18007	24597	4	applied	\N	\N	\N	\N	76677	76677	76697
17961	24239	85	applied	\N	\N	\N	\N	75533	75533	76337
17961	24252	86	applied	\N	\N	\N	\N	75574	75574	75091
17961	24266	87	applied	\N	\N	\N	\N	75618	75618	75093
17961	24274	88	applied	\N	\N	\N	\N	75646	75646	76338
17961	24284	89	applied	\N	\N	\N	\N	75691	75691	75095
17961	24298	90	applied	\N	\N	\N	\N	75723	75723	76339
17961	24309	91	applied	\N	\N	\N	\N	75749	75749	76340
17961	24318	92	applied	\N	\N	\N	\N	75772	75772	75107
17961	24331	93	applied	\N	\N	\N	\N	75809	75809	76341
17962	24482	0	applied	\N	\N	\N	\N	76344	76344	76345
17962	24483	1	applied	\N	\N	\N	\N	76346	76346	76347
17962	24484	2	applied	\N	\N	\N	\N	76348	76348	76349
17962	24485	3	applied	\N	\N	\N	\N	76350	76350	76351
17962	24486	4	applied	\N	\N	\N	\N	76352	76352	76353
17962	24487	5	applied	\N	\N	\N	\N	76354	76354	76355
17962	24488	6	applied	\N	\N	\N	\N	76356	76356	76357
17963	24489	0	applied	\N	\N	\N	\N	76359	76359	76360
17963	24490	1	applied	\N	\N	\N	\N	76361	76361	76362
17963	24491	2	applied	\N	\N	\N	\N	76363	76363	76364
17964	24492	0	applied	\N	\N	\N	\N	76366	76366	76367
17964	24493	1	applied	\N	\N	\N	\N	76368	76368	76369
17964	24494	2	applied	\N	\N	\N	\N	76370	76370	76371
17964	24495	3	applied	\N	\N	\N	\N	76372	76372	76373
17964	24496	4	applied	\N	\N	\N	\N	76374	76374	76375
17964	24497	5	applied	\N	\N	\N	\N	76376	76376	76377
17964	24498	6	applied	\N	\N	\N	\N	76378	76378	76379
17964	24499	7	applied	\N	\N	\N	\N	76380	76380	76381
17964	24500	8	applied	\N	\N	\N	\N	76382	76382	76383
17964	24501	9	applied	\N	\N	\N	\N	76384	76384	76385
17969	24502	0	applied	\N	\N	\N	\N	76391	76391	76392
17969	24503	1	applied	\N	\N	\N	\N	76393	76393	76394
17974	24511	0	applied	\N	\N	\N	\N	76418	76418	76419
17974	24506	1	applied	\N	\N	\N	\N	76406	76406	76407
17974	24507	2	applied	\N	\N	\N	\N	76408	76408	76409
17974	24508	3	applied	\N	\N	\N	\N	76410	76410	76411
17974	24509	4	applied	\N	\N	\N	\N	76412	76412	76413
17974	24512	5	applied	\N	\N	\N	\N	76420	76420	76421
17974	24510	6	applied	\N	\N	\N	\N	76414	76414	76422
17974	24513	7	applied	\N	\N	\N	\N	76423	76423	76424
17979	24518	0	applied	\N	\N	\N	\N	76440	76440	76441
17979	24519	1	applied	\N	\N	\N	\N	76442	76442	76443
17979	24520	2	applied	\N	\N	\N	\N	76444	76444	76445
17980	24522	0	applied	\N	\N	\N	\N	76451	76451	76452
17980	24523	1	applied	\N	\N	\N	\N	76453	76453	76454
17980	24524	2	applied	\N	\N	\N	\N	76455	76455	76456
17980	24525	3	applied	\N	\N	\N	\N	76457	76457	76458
17980	24526	4	applied	\N	\N	\N	\N	76459	76459	76460
17980	24527	5	applied	\N	\N	\N	\N	76461	76461	76462
17990	24566	0	applied	\N	\N	\N	\N	76554	76554	76555
17990	24567	1	applied	\N	\N	1000000000	\N	76556	76556	76557
17990	24568	2	applied	\N	\N	\N	\N	76558	76558	76559
17990	24569	3	applied	\N	\N	\N	\N	76560	76560	76561
17990	24570	4	applied	\N	\N	\N	\N	76562	76562	76563
17992	24571	0	applied	\N	\N	1000000000	\N	76567	76567	76568
17992	24572	1	applied	\N	\N	\N	\N	76569	76569	76570
17992	24573	2	applied	\N	\N	\N	\N	76571	76571	76572
17992	24574	3	applied	\N	\N	\N	\N	76573	76573	76574
17992	24575	4	applied	\N	\N	1000000000	\N	76575	76575	76576
17992	24576	5	applied	\N	\N	\N	\N	76577	76577	76578
17992	24577	6	applied	\N	\N	\N	\N	76579	76579	76580
17992	24578	7	applied	\N	\N	\N	\N	76581	76581	76582
17992	24579	8	applied	\N	\N	\N	\N	76583	76583	76584
17992	24580	9	applied	\N	\N	\N	\N	76585	76585	76586
17992	24581	10	applied	\N	\N	\N	\N	76587	76587	76588
17992	24582	11	applied	\N	\N	\N	\N	76589	76589	76590
17993	24583	0	applied	\N	\N	\N	\N	76593	76593	76594
17993	24584	1	applied	\N	\N	\N	\N	76595	76595	76596
17993	24585	2	applied	\N	\N	\N	\N	76597	76597	76598
17994	24489	0	applied	\N	\N	\N	\N	76359	76359	76360
17994	24560	1	applied	\N	\N	1000000000	\N	76537	76537	76601
17994	24567	2	applied	\N	\N	1000000000	\N	76556	76556	76557
17994	24571	3	applied	\N	\N	1000000000	\N	76567	76567	76568
17994	24556	4	applied	\N	\N	\N	\N	76528	76528	76602
17994	24575	5	applied	\N	\N	1000000000	\N	76575	76575	76576
17994	24514	6	applied	\N	\N	\N	\N	76603	76603	76604
17994	24529	7	applied	\N	\N	\N	\N	76605	76605	76606
17994	24492	8	applied	\N	\N	\N	\N	76366	76366	76367
17994	24493	9	applied	\N	\N	\N	\N	76368	76368	76369
17994	24494	10	applied	\N	\N	\N	\N	76370	76370	76371
17994	24502	11	applied	\N	\N	\N	\N	76391	76391	76392
17994	24504	12	applied	\N	\N	\N	\N	76401	76401	76402
17994	24505	13	applied	\N	\N	\N	\N	76403	76403	76404
17994	24511	14	applied	\N	\N	\N	\N	76418	76418	76419
17994	24538	15	applied	\N	\N	\N	\N	76488	76488	76607
17994	24544	16	applied	\N	\N	\N	\N	76501	76501	76538
17994	24515	17	applied	\N	\N	\N	\N	76431	76431	76432
17994	24518	18	applied	\N	\N	\N	\N	76440	76440	76441
17994	24522	19	applied	\N	\N	\N	\N	76451	76451	76452
17994	24523	21	applied	\N	\N	\N	\N	76453	76453	76454
17994	24528	22	applied	\N	\N	\N	\N	76466	76466	76467
17994	24530	23	applied	\N	\N	\N	\N	76470	76470	76471
17994	24536	24	applied	\N	\N	\N	\N	76484	76484	76485
17994	24537	25	applied	\N	\N	\N	\N	76486	76486	76487
17994	24545	26	applied	\N	\N	\N	\N	76503	76503	76504
17994	24546	27	applied	\N	\N	\N	\N	76505	76505	76506
17994	24552	28	applied	\N	\N	\N	\N	76518	76518	76519
17994	24555	29	applied	\N	\N	\N	\N	76526	76526	76527
17994	24559	30	applied	\N	\N	\N	\N	76535	76535	76536
17994	24563	31	applied	\N	\N	\N	\N	76545	76545	76546
17994	24566	32	applied	\N	\N	\N	\N	76554	76554	76555
17994	24572	33	applied	\N	\N	\N	\N	76569	76569	76570
17994	24573	34	applied	\N	\N	\N	\N	76571	76571	76572
17994	24574	35	applied	\N	\N	\N	\N	76573	76573	76574
17994	24583	36	applied	\N	\N	\N	\N	76593	76593	76594
17994	24490	37	applied	\N	\N	\N	\N	76361	76361	76362
17994	24496	38	applied	\N	\N	\N	\N	76374	76374	76609
17994	24497	39	applied	\N	\N	\N	\N	76376	76376	76373
17994	24547	40	applied	\N	\N	\N	\N	76507	76507	76507
17994	24491	41	applied	\N	\N	\N	\N	76363	76363	76610
17994	24495	42	applied	\N	\N	\N	\N	76372	76372	76377
17994	24498	43	applied	\N	\N	\N	\N	76378	76378	76379
17994	24499	44	applied	\N	\N	\N	\N	76380	76380	76381
17994	24500	45	applied	\N	\N	\N	\N	76382	76382	76383
17994	24507	46	applied	\N	\N	\N	\N	76408	76408	76611
17994	24501	47	applied	\N	\N	\N	\N	76384	76384	76612
17994	24503	48	applied	\N	\N	\N	\N	76393	76393	76613
17994	24506	49	applied	\N	\N	\N	\N	76406	76406	76409
17994	24508	50	applied	\N	\N	\N	\N	76410	76410	76411
17994	24520	51	applied	\N	\N	\N	\N	76444	76444	76614
17965	24495	3	applied	\N	\N	\N	\N	76372	76372	76373
17965	24496	4	applied	\N	\N	\N	\N	76374	76374	76375
17965	24497	5	applied	\N	\N	\N	\N	76376	76376	76377
17965	24498	6	applied	\N	\N	\N	\N	76378	76378	76379
17965	24499	7	applied	\N	\N	\N	\N	76380	76380	76381
17965	24500	8	applied	\N	\N	\N	\N	76382	76382	76383
17965	24501	9	applied	\N	\N	\N	\N	76384	76384	76385
17970	24502	0	applied	\N	\N	\N	\N	76391	76391	76392
17970	24503	1	applied	\N	\N	\N	\N	76393	76393	76394
17971	24504	0	applied	\N	\N	\N	\N	76401	76401	76402
17971	24505	1	applied	\N	\N	\N	\N	76403	76403	76404
17975	24511	0	applied	\N	\N	\N	\N	76418	76418	76419
17975	24506	1	applied	\N	\N	\N	\N	76406	76406	76407
17975	24507	2	applied	\N	\N	\N	\N	76408	76408	76409
17975	24508	3	applied	\N	\N	\N	\N	76410	76410	76411
17975	24509	4	applied	\N	\N	\N	\N	76412	76412	76413
17975	24512	5	applied	\N	\N	\N	\N	76420	76420	76421
17975	24510	6	applied	\N	\N	\N	\N	76414	76414	76422
17975	24513	7	applied	\N	\N	\N	\N	76423	76423	76424
17976	24514	0	applied	\N	\N	1000000000	\N	76429	76429	76430
17976	24515	1	applied	\N	\N	\N	\N	76431	76431	76432
17976	24516	2	applied	\N	\N	\N	\N	76433	76433	76434
17976	24517	3	applied	\N	\N	\N	\N	76435	76435	76436
17981	24522	0	applied	\N	\N	\N	\N	76451	76451	76452
17981	24523	1	applied	\N	\N	\N	\N	76453	76453	76454
17981	24524	2	applied	\N	\N	\N	\N	76455	76455	76456
17981	24525	3	applied	\N	\N	\N	\N	76457	76457	76458
17981	24526	4	applied	\N	\N	\N	\N	76459	76459	76460
17981	24527	5	applied	\N	\N	\N	\N	76461	76461	76462
17982	24528	0	applied	\N	\N	\N	\N	76466	76466	76467
17982	24529	1	applied	\N	\N	\N	\N	76468	76468	76469
17982	24530	2	applied	\N	\N	\N	\N	76470	76470	76471
17982	24531	3	applied	\N	\N	\N	\N	76472	76472	76473
17982	24532	4	applied	\N	\N	\N	\N	76474	76474	76475
17982	24533	5	applied	\N	\N	\N	\N	76476	76476	76477
17982	24534	6	applied	\N	\N	\N	\N	76478	76478	76479
17982	24535	7	applied	\N	\N	\N	\N	76480	76480	76481
17983	24536	0	applied	\N	\N	\N	\N	76484	76484	76485
17983	24537	1	applied	\N	\N	\N	\N	76486	76486	76487
17983	24538	2	applied	\N	\N	\N	\N	76488	76488	76489
17983	24539	3	applied	\N	\N	\N	\N	76490	76490	76491
17983	24540	4	applied	\N	\N	\N	\N	76492	76492	76493
17983	24541	5	applied	\N	\N	\N	\N	76494	76494	76495
17983	24542	6	applied	\N	\N	\N	\N	76496	76496	76497
17983	24543	7	applied	\N	\N	\N	\N	76498	76498	76499
17984	24544	0	applied	\N	\N	\N	\N	76501	76501	76502
17984	24545	1	applied	\N	\N	\N	\N	76503	76503	76504
17984	24546	2	applied	\N	\N	\N	\N	76505	76505	76506
17984	24547	3	applied	\N	\N	\N	\N	76507	76507	76507
17984	24548	4	applied	\N	\N	\N	\N	76508	76508	76509
17984	24549	5	applied	\N	\N	\N	\N	76510	76510	76511
17984	24550	6	applied	\N	\N	\N	\N	76512	76512	76513
17984	24551	7	applied	\N	\N	\N	\N	76514	76514	76515
17985	24552	0	applied	\N	\N	\N	\N	76518	76518	76519
17985	24553	1	applied	\N	\N	\N	\N	76520	76520	76521
17985	24554	2	applied	\N	\N	\N	\N	76522	76522	76523
17988	24563	0	applied	\N	\N	\N	\N	76545	76545	76546
17988	24564	1	applied	\N	\N	\N	\N	76547	76547	76548
17988	24565	2	applied	\N	\N	\N	\N	76549	76549	76550
17989	24563	0	applied	\N	\N	\N	\N	76545	76545	76546
17989	24564	1	applied	\N	\N	\N	\N	76547	76547	76548
17989	24565	2	applied	\N	\N	\N	\N	76549	76549	76550
17999	24591	0	applied	\N	\N	\N	\N	76661	76661	76662
17999	24592	1	applied	\N	\N	\N	\N	76663	76663	47675
17999	24593	2	applied	\N	\N	\N	\N	76664	76664	76665
17999	24594	3	applied	\N	\N	\N	\N	76666	76666	76667
17999	24595	4	applied	\N	\N	\N	\N	76668	76668	76669
18001	24591	0	applied	\N	\N	\N	\N	76661	76661	76662
18001	24592	1	applied	\N	\N	\N	\N	76663	76663	47675
18001	24593	2	applied	\N	\N	\N	\N	76664	76664	76665
18001	24594	3	applied	\N	\N	\N	\N	76666	76666	76667
18001	24595	4	applied	\N	\N	\N	\N	76668	76668	76669
18006	24596	0	applied	\N	\N	\N	\N	76675	76675	76676
18006	24599	1	applied	\N	\N	\N	\N	76682	76682	76683
18006	24597	2	applied	\N	\N	\N	\N	76677	76677	76678
18006	24598	3	applied	\N	\N	\N	\N	76679	76679	76680
18006	24600	4	applied	\N	\N	\N	\N	76684	76684	76685
18006	24601	5	applied	\N	\N	\N	\N	76686	76686	76687
18009	24602	0	applied	\N	\N	\N	\N	76693	76693	76694
18009	24603	1	applied	\N	\N	\N	\N	76695	76695	76700
18009	24604	2	applied	\N	\N	\N	\N	76701	76701	76702
18009	24605	3	applied	\N	\N	\N	\N	76703	76703	76704
18010	24606	0	applied	\N	\N	\N	\N	76709	76709	76710
18010	24607	1	applied	\N	\N	\N	\N	76711	76711	76712
18010	24608	2	applied	\N	\N	\N	\N	76713	76713	76714
18010	24609	3	applied	\N	\N	\N	\N	76715	76715	76716
18017	24620	0	applied	\N	\N	\N	\N	76748	76748	76749
18017	24621	1	applied	\N	\N	\N	\N	76750	76750	76751
18017	24622	2	applied	\N	\N	\N	\N	76752	76752	76753
18022	24627	0	applied	\N	\N	\N	\N	76770	76770	76771
18022	24628	1	applied	\N	\N	\N	\N	76772	76772	76773
18022	24629	2	applied	\N	\N	\N	\N	76774	76774	76775
18022	24630	3	applied	\N	\N	\N	\N	76776	76776	76777
18022	24631	4	applied	\N	\N	\N	\N	76778	76778	76779
18022	24632	5	applied	\N	\N	\N	\N	76780	76780	76781
18027	24642	0	applied	\N	\N	\N	\N	76808	76808	76809
18027	24643	1	applied	\N	\N	\N	\N	76810	76810	76811
18031	24644	0	applied	\N	\N	\N	\N	76812	76812	76813
18031	24645	1	applied	\N	\N	\N	\N	76814	76814	76815
18031	24646	2	applied	\N	\N	\N	\N	76816	76816	76817
18034	24560	0	applied	\N	\N	1000000000	\N	76537	76537	76601
18034	24567	1	applied	\N	\N	1000000000	\N	76556	76556	76557
18034	24571	2	applied	\N	\N	1000000000	\N	76567	76567	76568
18034	24592	3	applied	\N	\N	\N	\N	76663	76663	47675
18034	24556	4	applied	\N	\N	\N	\N	76528	76528	76602
18034	24575	5	applied	\N	\N	1000000000	\N	76575	76575	76576
18034	24514	6	applied	\N	\N	\N	\N	76603	76603	76604
18034	24529	7	applied	\N	\N	\N	\N	76605	76605	76606
18034	24538	8	applied	\N	\N	\N	\N	76488	76488	76607
18034	24544	9	applied	\N	\N	\N	\N	76501	76501	76538
18034	24547	10	applied	\N	\N	\N	\N	76507	76507	76507
18034	24423	11	applied	\N	\N	\N	\N	76104	76104	76104
18034	24438	12	applied	\N	\N	\N	\N	76144	76144	76144
18034	24609	13	applied	\N	\N	\N	\N	76715	76715	76716
18034	24626	14	applied	\N	\N	\N	\N	13663	13663	47675
18035	24649	0	applied	\N	\N	\N	\N	76829	76829	76830
18035	24650	1	applied	\N	\N	\N	\N	76831	76831	76832
18035	24651	2	applied	\N	\N	\N	\N	76833	76833	76834
18035	24652	3	applied	\N	\N	\N	\N	76835	76835	76836
17966	24496	4	applied	\N	\N	\N	\N	76374	76374	76375
17966	24497	5	applied	\N	\N	\N	\N	76376	76376	76377
17966	24498	6	applied	\N	\N	\N	\N	76378	76378	76379
17966	24499	7	applied	\N	\N	\N	\N	76380	76380	76381
17966	24500	8	applied	\N	\N	\N	\N	76382	76382	76383
17966	24501	9	applied	\N	\N	\N	\N	76384	76384	76385
17967	24502	0	applied	\N	\N	\N	\N	76391	76391	76392
17967	24503	1	applied	\N	\N	\N	\N	76393	76393	76394
17972	24504	0	applied	\N	\N	\N	\N	76401	76401	76402
17972	24505	1	applied	\N	\N	\N	\N	76403	76403	76404
17972	24506	2	applied	\N	\N	\N	\N	76406	76406	76407
17972	24507	3	applied	\N	\N	\N	\N	76408	76408	76409
17972	24508	4	applied	\N	\N	\N	\N	76410	76410	76411
17972	24509	5	applied	\N	\N	\N	\N	76412	76412	76413
17972	24510	6	applied	\N	\N	\N	\N	76414	76414	76415
17977	24514	0	applied	\N	\N	1000000000	\N	76429	76429	76430
17977	24515	1	applied	\N	\N	\N	\N	76431	76431	76432
17977	24516	2	applied	\N	\N	\N	\N	76433	76433	76434
17977	24517	3	applied	\N	\N	\N	\N	76435	76435	76436
17986	24555	0	applied	\N	\N	\N	\N	76526	76526	76527
17986	24556	1	applied	\N	\N	\N	\N	76528	76528	76529
17986	24557	2	applied	\N	\N	\N	\N	76530	76530	76531
17986	24558	3	applied	\N	\N	\N	\N	76532	76532	76533
17987	24559	0	applied	\N	\N	\N	\N	76535	76535	76536
17987	24560	1	applied	\N	\N	\N	\N	76537	76537	76538
17987	24561	2	applied	\N	\N	\N	\N	76539	76539	76540
17987	24562	3	applied	\N	\N	\N	\N	76541	76541	76542
17991	24566	0	applied	\N	\N	\N	\N	76554	76554	76555
17991	24567	1	applied	\N	\N	1000000000	\N	76556	76556	76557
17991	24568	2	applied	\N	\N	\N	\N	76558	76558	76559
17991	24569	3	applied	\N	\N	\N	\N	76560	76560	76561
17991	24570	4	applied	\N	\N	\N	\N	76562	76562	76563
17995	24586	0	applied	\N	\N	\N	\N	76646	76646	76647
17995	24587	1	applied	\N	\N	\N	\N	76648	76648	76649
17995	24588	2	applied	\N	\N	\N	\N	76650	76650	76651
17997	24586	0	applied	\N	\N	\N	\N	76646	76646	76647
17997	24587	1	applied	\N	\N	\N	\N	76648	76648	76649
17997	24588	2	applied	\N	\N	\N	\N	76650	76650	76651
18002	24596	0	applied	\N	\N	\N	\N	76675	76675	76676
18002	24597	1	applied	\N	\N	\N	\N	76677	76677	76678
18002	24598	2	applied	\N	\N	\N	\N	76679	76679	76680
18004	24596	0	applied	\N	\N	\N	\N	76675	76675	76676
18004	24597	1	applied	\N	\N	\N	\N	76677	76677	76678
18004	24598	2	applied	\N	\N	\N	\N	76679	76679	76680
18013	24606	0	applied	\N	\N	\N	\N	76709	76709	76710
18013	24611	1	applied	\N	\N	\N	\N	76723	76723	76724
18013	24607	2	applied	\N	\N	\N	\N	76711	76711	76712
18013	24610	3	applied	\N	\N	\N	\N	76719	76719	76720
18013	24608	4	applied	\N	\N	\N	\N	76713	76713	76721
18013	24612	5	applied	\N	\N	\N	\N	76725	76725	76726
18013	24609	6	applied	\N	\N	\N	\N	76715	76715	76716
18015	24613	0	applied	\N	\N	\N	\N	76731	76731	76732
18015	24614	1	applied	\N	\N	\N	\N	76733	76733	76734
18015	24615	2	applied	\N	\N	\N	\N	76735	76735	76736
18015	24616	3	applied	\N	\N	\N	\N	76737	76737	76738
18018	24620	0	applied	\N	\N	\N	\N	76748	76748	76749
18018	24621	1	applied	\N	\N	\N	\N	76750	76750	76751
18018	24622	2	applied	\N	\N	\N	\N	76752	76752	76753
18020	24623	0	applied	\N	\N	\N	\N	76760	76760	76761
18020	24624	1	applied	\N	\N	\N	\N	76762	76762	76763
18020	24625	2	applied	\N	\N	\N	\N	76764	76764	76765
18020	24626	3	applied	\N	\N	\N	\N	13663	13663	47675
18025	24640	0	applied	\N	\N	\N	\N	76801	76801	76802
18025	24641	1	applied	\N	\N	\N	\N	76803	76803	76804
18028	24644	0	applied	\N	\N	\N	\N	76812	76812	76813
18028	24645	1	applied	\N	\N	\N	\N	76814	76814	76815
18028	24646	2	applied	\N	\N	\N	\N	76816	76816	76817
18041	24658	0	applied	\N	\N	\N	\N	76856	76856	76857
18041	24659	1	applied	\N	\N	\N	\N	76858	76858	76859
18043	24660	0	applied	\N	\N	\N	\N	76869	76869	76870
18043	24661	1	applied	\N	\N	\N	\N	76871	76871	76872
18043	24662	2	applied	\N	\N	\N	\N	76873	76873	76874
18045	24660	0	applied	\N	\N	\N	\N	76869	76869	76870
18045	24661	1	applied	\N	\N	\N	\N	76871	76871	76872
18045	24662	2	applied	\N	\N	\N	\N	76873	76873	76874
18052	24671	0	applied	\N	\N	\N	\N	76903	76903	76904
18052	24672	1	applied	\N	\N	\N	\N	76905	76905	76906
18052	24673	2	applied	\N	\N	\N	\N	76907	76907	76908
18052	24674	3	applied	\N	\N	\N	\N	76909	76909	76910
18067	24694	0	applied	\N	\N	\N	\N	76965	76965	76966
18067	24695	1	applied	\N	\N	\N	\N	76967	76967	76968
18067	24696	2	applied	\N	\N	\N	\N	76969	76969	76970
18074	24699	0	applied	\N	\N	\N	\N	76984	76984	76985
18074	24700	1	applied	\N	\N	\N	\N	76986	76986	76987
18074	24701	2	applied	\N	\N	\N	\N	76988	76988	76989
18074	24702	3	applied	\N	\N	\N	\N	76990	76990	76991
18080	24717	0	applied	\N	\N	\N	\N	77027	77027	77028
18080	24718	1	applied	\N	\N	\N	\N	77029	77029	77030
18080	24719	2	applied	\N	\N	\N	\N	77031	77031	77032
18082	24720	0	applied	\N	\N	\N	\N	77037	77037	77038
18082	24721	1	applied	\N	\N	\N	\N	77039	77039	77040
18092	24732	0	applied	\N	\N	\N	\N	77083	77083	77084
18092	24733	1	applied	\N	\N	\N	\N	77085	77085	77086
18092	24734	2	applied	\N	\N	\N	\N	77087	77087	77088
18094	24735	0	applied	\N	\N	\N	\N	77094	77094	77095
18094	24736	1	applied	\N	\N	\N	\N	77096	77096	77097
18099	24744	0	applied	\N	\N	\N	\N	77118	77118	77119
18099	24745	1	applied	\N	\N	\N	\N	77120	77120	77121
18102	24752	0	applied	\N	\N	\N	\N	77139	77139	77140
18102	24753	1	applied	\N	\N	\N	\N	77141	77141	77142
18109	24744	0	applied	\N	\N	\N	\N	77118	77118	77119
18109	24746	1	applied	\N	\N	\N	\N	77124	77124	77125
18109	24748	2	applied	\N	\N	\N	\N	77130	77130	77131
18109	24749	3	applied	\N	\N	\N	\N	77132	77132	77133
18109	24752	4	applied	\N	\N	\N	\N	77139	77139	77140
18109	24754	5	applied	\N	\N	\N	\N	77146	77146	77147
18109	24758	6	applied	\N	\N	\N	\N	77155	77155	77156
18109	24745	7	applied	\N	\N	\N	\N	77120	77120	77121
18109	24747	8	applied	\N	\N	\N	\N	77126	77126	77127
18109	24753	9	applied	\N	\N	\N	\N	77141	77141	77164
18109	24755	10	applied	\N	\N	\N	\N	77148	77148	77165
18109	24750	11	applied	\N	\N	\N	\N	77134	77134	77166
18109	24751	12	applied	\N	\N	\N	\N	77136	77136	77149
18109	24756	13	applied	\N	\N	\N	\N	77150	77150	77151
18109	24757	14	applied	\N	\N	\N	\N	77152	77152	77153
18109	24759	15	applied	\N	\N	\N	\N	77157	77157	77158
18112	24764	0	applied	\N	\N	\N	\N	77177	77177	77178
18112	24765	1	applied	\N	\N	\N	\N	77179	77179	77180
18119	24777	0	applied	\N	\N	\N	\N	77224	77224	77225
17994	24531	52	applied	\N	\N	\N	\N	76472	76472	76413
17994	24541	53	applied	\N	\N	\N	\N	76494	76494	76615
17994	24509	54	applied	\N	\N	\N	\N	76412	76412	76415
17994	24512	55	applied	\N	\N	\N	\N	76420	76420	76422
17994	24516	56	applied	\N	\N	\N	\N	76433	76433	76616
17994	24521	57	applied	\N	\N	\N	\N	76446	76446	76617
17994	24524	58	applied	\N	\N	\N	\N	76455	76455	76618
17994	24525	59	applied	\N	\N	\N	\N	76457	76457	76436
17994	24532	60	applied	\N	\N	\N	\N	76474	76474	76619
17994	24535	61	applied	\N	\N	\N	\N	76480	76480	76445
17994	24539	62	applied	\N	\N	\N	\N	76490	76490	76447
17994	24543	63	applied	\N	\N	\N	\N	76498	76498	76456
17994	24550	64	applied	\N	\N	\N	\N	76512	76512	76458
17994	24551	65	applied	\N	\N	\N	\N	76514	76514	76620
17994	24553	66	applied	\N	\N	\N	\N	76520	76520	76621
17994	24557	67	applied	\N	\N	\N	\N	76530	76530	76462
17994	24558	68	applied	\N	\N	\N	\N	76532	76532	76473
17994	24565	69	applied	\N	\N	\N	\N	76549	76549	76475
17994	24569	70	applied	\N	\N	\N	\N	76560	76560	76622
17994	24576	71	applied	\N	\N	\N	\N	76577	76577	76623
17994	24510	72	applied	\N	\N	\N	\N	76414	76414	76624
17994	24513	73	applied	\N	\N	\N	\N	76423	76423	76481
17994	24517	74	applied	\N	\N	\N	\N	76435	76435	76625
17994	24519	75	applied	\N	\N	\N	\N	76442	76442	76495
17994	24526	76	applied	\N	\N	\N	\N	76459	76459	76497
17994	24527	77	applied	\N	\N	\N	\N	76461	76461	76626
17994	24533	78	applied	\N	\N	\N	\N	76476	76476	76627
17994	24534	79	applied	\N	\N	\N	\N	76478	76478	76628
17994	24540	80	applied	\N	\N	\N	\N	76492	76492	76515
17994	24542	81	applied	\N	\N	\N	\N	76496	76496	76629
17994	24548	82	applied	\N	\N	\N	\N	76508	76508	76630
17994	24549	83	applied	\N	\N	\N	\N	76510	76510	76631
17994	24554	84	applied	\N	\N	\N	\N	76522	76522	76632
17994	24561	85	applied	\N	\N	\N	\N	76539	76539	76633
17994	24562	86	applied	\N	\N	\N	\N	76541	76541	76634
17994	24564	87	applied	\N	\N	\N	\N	76547	76547	76635
17994	24568	88	applied	\N	\N	\N	\N	76558	76558	76636
17994	24577	89	applied	\N	\N	\N	\N	76579	76579	76637
17994	24578	90	applied	\N	\N	\N	\N	76581	76581	76638
17994	24579	91	applied	\N	\N	\N	\N	76583	76583	76639
17994	24584	92	applied	\N	\N	\N	\N	76595	76595	76640
17994	24570	93	applied	\N	\N	\N	\N	76562	76562	76641
17994	24580	94	applied	\N	\N	\N	\N	76585	76585	76642
17994	24581	95	applied	\N	\N	\N	\N	76587	76587	76643
17994	24582	96	applied	\N	\N	\N	\N	76589	76589	76596
17994	24585	97	applied	\N	\N	\N	\N	76597	76597	76598
17996	24586	0	applied	\N	\N	\N	\N	76646	76646	76647
17996	24587	1	applied	\N	\N	\N	\N	76648	76648	76649
17996	24588	2	applied	\N	\N	\N	\N	76650	76650	76651
18005	24596	0	applied	\N	\N	\N	\N	76675	76675	76676
18005	24599	1	applied	\N	\N	\N	\N	76682	76682	76683
18005	24597	2	applied	\N	\N	\N	\N	76677	76677	76678
18005	24598	3	applied	\N	\N	\N	\N	76679	76679	76680
18005	24600	4	applied	\N	\N	\N	\N	76684	76684	76685
18005	24601	5	applied	\N	\N	\N	\N	76686	76686	76687
18008	24602	0	applied	\N	\N	\N	\N	76693	76693	76694
18008	24603	1	applied	\N	\N	\N	\N	76695	76695	76700
18008	24604	2	applied	\N	\N	\N	\N	76701	76701	76702
18008	24605	3	applied	\N	\N	\N	\N	76703	76703	76704
18012	24611	0	applied	\N	\N	\N	\N	76723	76723	76724
18012	24612	1	applied	\N	\N	\N	\N	76725	76725	76726
18021	24623	0	applied	\N	\N	\N	\N	76760	76760	76761
18021	24624	1	applied	\N	\N	\N	\N	76762	76762	76763
18021	24625	2	applied	\N	\N	\N	\N	76764	76764	76765
18021	24626	3	applied	\N	\N	\N	\N	13663	13663	47675
18024	24636	0	applied	\N	\N	\N	\N	76791	76791	76792
18024	24637	1	applied	\N	\N	\N	\N	76793	76793	76794
18024	24638	2	applied	\N	\N	\N	\N	76795	76795	76796
18024	24639	3	applied	\N	\N	\N	\N	76797	76797	76798
18026	24640	0	applied	\N	\N	\N	\N	76801	76801	76802
18026	24641	1	applied	\N	\N	\N	\N	76803	76803	76804
18030	24644	0	applied	\N	\N	\N	\N	76812	76812	76813
18030	24645	1	applied	\N	\N	\N	\N	76814	76814	76815
18030	24646	2	applied	\N	\N	\N	\N	76816	76816	76817
18040	24658	0	applied	\N	\N	\N	\N	76856	76856	76857
18040	24659	1	applied	\N	\N	\N	\N	76858	76858	76859
18042	24347	0	applied	\N	\N	1000000000	\N	75904	75904	75905
18042	24560	1	applied	\N	\N	1000000000	\N	76537	76537	76601
18042	24567	2	applied	\N	\N	1000000000	\N	76556	76556	76557
18042	24571	3	applied	\N	\N	1000000000	\N	76567	76567	76568
18042	24592	4	applied	\N	\N	\N	\N	76663	76663	47675
18042	24556	5	applied	\N	\N	\N	\N	76528	76528	76602
18042	24575	6	applied	\N	\N	1000000000	\N	76575	76575	76576
18042	24514	7	applied	\N	\N	\N	\N	76864	76864	76604
18042	24529	8	applied	\N	\N	\N	\N	76865	76865	76606
18042	24538	9	applied	\N	\N	\N	\N	76866	76866	76607
18042	24544	10	applied	\N	\N	\N	\N	76867	76867	76538
18042	24261	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
18042	24414	12	applied	\N	\N	\N	\N	76078	76078	76078
18042	24547	13	applied	\N	\N	\N	\N	76507	76507	76507
18042	24423	14	applied	\N	\N	\N	\N	76104	76104	76104
18042	24438	15	applied	\N	\N	\N	\N	76144	76144	76144
18042	24280	16	applied	\N	\N	\N	\N	75665	75665	75666
18042	24609	17	applied	\N	\N	\N	\N	76715	76715	76716
18042	24626	18	applied	\N	\N	\N	\N	13663	13663	47675
18046	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18046	24664	1	applied	\N	\N	\N	\N	76881	76881	76882
18046	24665	2	applied	\N	\N	\N	\N	76883	76883	76884
18056	24675	0	applied	\N	\N	\N	\N	76913	76913	76914
18056	24676	1	applied	\N	\N	\N	\N	76915	76915	76916
18056	24677	2	applied	\N	\N	\N	\N	76917	76917	76918
18058	24678	0	applied	\N	\N	\N	\N	76924	76924	76925
18058	24679	1	applied	\N	\N	\N	\N	76926	76926	47675
18058	24680	2	applied	\N	\N	\N	\N	76927	76927	76928
18058	24681	3	applied	\N	\N	\N	\N	76929	76929	76930
18058	24682	4	applied	\N	\N	\N	\N	76931	76931	76932
18058	24683	5	applied	\N	\N	\N	\N	76933	76933	76934
18059	24678	0	applied	\N	\N	\N	\N	76924	76924	76925
18059	24679	1	applied	\N	\N	\N	\N	76926	76926	47675
18059	24680	2	applied	\N	\N	\N	\N	76927	76927	76928
18059	24681	3	applied	\N	\N	\N	\N	76929	76929	76930
18059	24682	4	applied	\N	\N	\N	\N	76931	76931	76932
18059	24683	5	applied	\N	\N	\N	\N	76933	76933	76934
18066	24693	0	applied	\N	\N	\N	\N	76961	76961	76962
18073	24699	0	applied	\N	\N	\N	\N	76984	76984	76985
18073	24700	1	applied	\N	\N	\N	\N	76986	76986	76987
18073	24701	2	applied	\N	\N	\N	\N	76988	76988	76989
18073	24702	3	applied	\N	\N	\N	\N	76990	76990	76991
18007	24598	5	applied	\N	\N	\N	\N	76679	76679	76698
18007	24600	6	applied	\N	\N	\N	\N	76684	76684	76699
18007	24601	7	applied	\N	\N	\N	\N	76686	76686	76700
18007	24604	8	applied	\N	\N	\N	\N	76701	76701	76702
18007	24605	9	applied	\N	\N	\N	\N	76703	76703	76704
18011	24606	0	applied	\N	\N	\N	\N	76709	76709	76710
18011	24607	1	applied	\N	\N	\N	\N	76711	76711	76712
18011	24610	2	applied	\N	\N	\N	\N	76719	76719	76720
18011	24608	3	applied	\N	\N	\N	\N	76713	76713	76721
18011	24609	4	applied	\N	\N	\N	\N	76715	76715	76716
18014	24606	0	applied	\N	\N	\N	\N	76709	76709	76710
18014	24611	1	applied	\N	\N	\N	\N	76723	76723	76724
18014	24607	2	applied	\N	\N	\N	\N	76711	76711	76712
18014	24610	3	applied	\N	\N	\N	\N	76719	76719	76720
18014	24608	4	applied	\N	\N	\N	\N	76713	76713	76721
18014	24612	5	applied	\N	\N	\N	\N	76725	76725	76726
18014	24609	6	applied	\N	\N	\N	\N	76715	76715	76716
18016	24617	0	applied	\N	\N	\N	\N	76741	76741	76742
18016	24618	1	applied	\N	\N	\N	\N	76743	76743	76744
18016	24619	2	applied	\N	\N	\N	\N	76745	76745	76746
18019	24620	0	applied	\N	\N	\N	\N	76748	76748	76749
18019	24622	1	applied	\N	\N	\N	\N	76752	76752	76758
18023	24633	0	applied	\N	\N	\N	\N	76784	76784	76785
18023	24634	1	applied	\N	\N	\N	\N	76786	76786	76787
18023	24635	2	applied	\N	\N	\N	\N	76788	76788	76789
18029	24644	0	applied	\N	\N	\N	\N	76812	76812	76813
18029	24645	1	applied	\N	\N	\N	\N	76814	76814	76815
18029	24646	2	applied	\N	\N	\N	\N	76816	76816	76817
18032	24647	0	applied	\N	\N	\N	\N	76824	76824	76825
18032	24648	1	applied	\N	\N	\N	\N	76826	76826	76827
18033	24649	0	applied	\N	\N	\N	\N	76829	76829	76830
18033	24650	1	applied	\N	\N	\N	\N	76831	76831	76832
18033	24651	2	applied	\N	\N	\N	\N	76833	76833	76834
18033	24652	3	applied	\N	\N	\N	\N	76835	76835	76836
18038	24656	0	applied	\N	\N	\N	\N	76848	76848	76849
18038	24657	1	applied	\N	\N	\N	\N	76850	76850	76851
18039	24656	0	applied	\N	\N	\N	\N	76848	76848	76849
18039	24657	1	applied	\N	\N	\N	\N	76850	76850	76851
18044	24660	0	applied	\N	\N	\N	\N	76869	76869	76870
18044	24661	1	applied	\N	\N	\N	\N	76871	76871	76872
18044	24662	2	applied	\N	\N	\N	\N	76873	76873	76874
18048	24666	0	applied	\N	\N	\N	\N	76887	76887	76888
18048	24667	1	applied	\N	\N	\N	\N	76889	76889	76890
18050	24668	0	applied	\N	\N	\N	\N	76896	76896	76897
18050	24669	1	applied	\N	\N	\N	\N	76898	76898	76899
18050	24670	2	applied	\N	\N	\N	\N	76900	76900	76901
18055	24675	0	applied	\N	\N	\N	\N	76913	76913	76914
18055	24676	1	applied	\N	\N	\N	\N	76915	76915	76916
18055	24677	2	applied	\N	\N	\N	\N	76917	76917	76918
18061	24684	0	applied	\N	\N	\N	\N	76937	76937	76938
18061	24685	1	applied	\N	\N	\N	\N	76939	76939	76940
18061	24686	2	applied	\N	\N	\N	\N	76941	76941	47675
18061	24687	3	applied	\N	\N	\N	\N	76942	76942	76943
18061	24688	4	applied	\N	\N	\N	\N	76944	76944	76945
18061	24689	5	applied	\N	\N	\N	\N	76946	76946	76947
18063	24690	0	applied	\N	\N	\N	\N	76952	76952	76953
18065	24691	0	applied	\N	\N	\N	\N	76957	76957	70512
18065	24690	1	applied	\N	\N	\N	\N	76952	76952	76953
18065	24692	2	applied	\N	\N	\N	\N	76958	76958	76959
18068	24697	0	applied	\N	\N	\N	\N	76973	76973	76974
18068	24698	1	applied	\N	\N	\N	\N	76975	76975	76976
18070	24697	0	applied	\N	\N	\N	\N	76973	76973	76974
18070	24698	1	applied	\N	\N	\N	\N	76975	76975	76976
18072	24697	0	applied	\N	\N	\N	\N	76973	76973	76974
18072	24698	1	applied	\N	\N	\N	\N	76975	76975	76976
18075	24703	0	applied	\N	\N	\N	\N	76995	76995	76996
18075	24704	1	applied	\N	\N	\N	\N	76997	76997	76998
18075	24705	2	applied	\N	\N	\N	\N	76999	76999	77000
18075	24706	3	applied	\N	\N	\N	\N	77001	77001	77002
18075	24707	4	applied	\N	\N	\N	\N	77003	77003	77004
18075	24708	5	applied	\N	\N	\N	\N	77005	77005	77006
18075	24709	6	applied	\N	\N	\N	\N	77007	77007	77008
18078	24715	0	applied	\N	\N	\N	\N	77021	77021	77022
18078	24716	1	applied	\N	\N	\N	\N	77023	77023	77024
18084	24722	0	applied	\N	\N	\N	\N	77043	77043	77044
18084	24723	1	applied	\N	\N	\N	\N	77045	77045	77046
18084	24724	2	applied	\N	\N	\N	\N	77047	77047	77048
18084	24725	3	applied	\N	\N	\N	\N	77049	77049	77050
18084	24726	4	applied	\N	\N	\N	\N	77051	77051	77052
18084	24727	5	applied	\N	\N	\N	\N	77053	77053	77054
18084	24728	6	applied	\N	\N	\N	\N	77055	77055	77056
18088	24729	0	applied	\N	\N	\N	\N	77067	77067	77068
18088	24730	1	applied	\N	\N	\N	\N	77069	77069	77070
18090	24731	0	applied	\N	\N	\N	\N	77079	77079	77080
18095	24737	0	applied	\N	\N	\N	\N	77100	77100	77101
18095	24738	1	applied	\N	\N	\N	\N	77102	77102	77103
18097	24739	0	applied	\N	\N	\N	\N	77106	77106	77107
18097	24740	1	applied	\N	\N	\N	\N	77108	77108	77109
18097	24741	2	applied	\N	\N	\N	\N	77110	77110	77111
18100	24746	0	applied	\N	\N	\N	\N	77124	77124	77125
18100	24747	1	applied	\N	\N	\N	\N	77126	77126	77127
18103	24754	0	applied	\N	\N	\N	\N	77146	77146	77147
18103	24755	1	applied	\N	\N	\N	\N	77148	77148	77149
18103	24756	2	applied	\N	\N	\N	\N	77150	77150	77151
18103	24757	3	applied	\N	\N	\N	\N	77152	77152	77153
18105	24754	0	applied	\N	\N	\N	\N	77146	77146	77147
18105	24755	1	applied	\N	\N	\N	\N	77148	77148	77149
18105	24756	2	applied	\N	\N	\N	\N	77150	77150	77151
18105	24757	3	applied	\N	\N	\N	\N	77152	77152	77153
18114	24764	0	applied	\N	\N	\N	\N	77177	77177	77178
18114	24765	1	applied	\N	\N	\N	\N	77179	77179	77180
18117	24766	0	applied	\N	\N	\N	\N	77199	77199	77200
18117	24767	1	applied	\N	\N	\N	\N	77201	77201	77202
18117	24768	2	applied	\N	\N	\N	\N	77203	77203	77204
18117	24769	3	applied	\N	\N	\N	\N	77205	77205	77206
18117	24770	4	applied	\N	\N	\N	\N	77207	77207	77208
18117	24771	5	applied	\N	\N	\N	\N	77209	77209	77210
18117	24772	6	applied	\N	\N	\N	\N	77211	77211	77212
18117	24773	7	applied	\N	\N	\N	\N	77213	77213	77214
18117	24774	8	applied	\N	\N	\N	\N	77215	77215	77216
18117	24775	9	applied	\N	\N	\N	\N	77217	77217	77218
18117	24776	10	applied	\N	\N	\N	\N	77219	77219	77220
18122	24780	0	applied	\N	\N	\N	\N	77234	77234	77235
18122	24781	1	applied	\N	\N	\N	\N	77236	77236	77237
18122	24782	2	applied	\N	\N	\N	\N	77238	77238	77239
18122	24783	3	applied	\N	\N	\N	\N	77240	77240	77241
18127	24789	0	applied	\N	\N	\N	\N	77265	77265	77266
18127	24790	1	applied	\N	\N	\N	\N	77267	77267	77268
18127	24791	2	applied	\N	\N	\N	\N	77269	77269	77270
18127	24792	3	applied	\N	\N	\N	\N	77271	77271	77272
18036	24653	0	applied	\N	\N	\N	\N	76839	76839	76840
18036	24654	1	applied	\N	\N	\N	\N	76841	76841	76842
18036	24655	2	applied	\N	\N	\N	\N	76843	76843	76844
18037	24653	0	applied	\N	\N	\N	\N	76839	76839	76840
18037	24654	1	applied	\N	\N	\N	\N	76841	76841	76842
18037	24655	2	applied	\N	\N	\N	\N	76843	76843	76844
18047	24666	0	applied	\N	\N	\N	\N	76887	76887	76888
18047	24667	1	applied	\N	\N	\N	\N	76889	76889	76890
18049	24666	0	applied	\N	\N	\N	\N	76887	76887	76888
18049	24667	1	applied	\N	\N	\N	\N	76889	76889	76890
18051	24668	0	applied	\N	\N	\N	\N	76896	76896	76897
18051	24669	1	applied	\N	\N	\N	\N	76898	76898	76899
18051	24670	2	applied	\N	\N	\N	\N	76900	76900	76901
18054	24675	0	applied	\N	\N	\N	\N	76913	76913	76914
18054	24676	1	applied	\N	\N	\N	\N	76915	76915	76916
18054	24677	2	applied	\N	\N	\N	\N	76917	76917	76918
18057	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18057	24675	1	applied	\N	\N	\N	\N	76913	76913	76914
18057	24560	3	applied	\N	\N	1000000000	\N	76537	76537	76601
18060	24684	0	applied	\N	\N	\N	\N	76937	76937	76938
18060	24685	1	applied	\N	\N	\N	\N	76939	76939	76940
18060	24686	2	applied	\N	\N	\N	\N	76941	76941	47675
18060	24687	3	applied	\N	\N	\N	\N	76942	76942	76943
18060	24688	4	applied	\N	\N	\N	\N	76944	76944	76945
18060	24689	5	applied	\N	\N	\N	\N	76946	76946	76947
18062	24684	0	applied	\N	\N	\N	\N	76937	76937	76938
18062	24685	1	applied	\N	\N	\N	\N	76939	76939	76940
18062	24686	2	applied	\N	\N	\N	\N	76941	76941	47675
18062	24687	3	applied	\N	\N	\N	\N	76942	76942	76943
18062	24688	4	applied	\N	\N	\N	\N	76944	76944	76945
18062	24689	5	applied	\N	\N	\N	\N	76946	76946	76947
18064	24690	0	applied	\N	\N	\N	\N	76952	76952	76953
18069	24697	0	applied	\N	\N	\N	\N	76973	76973	76974
18069	24698	1	applied	\N	\N	\N	\N	76975	76975	76976
18071	24697	0	applied	\N	\N	\N	\N	76973	76973	76974
18071	24698	1	applied	\N	\N	\N	\N	76975	76975	76976
18077	24715	0	applied	\N	\N	\N	\N	77021	77021	77022
18077	24716	1	applied	\N	\N	\N	\N	77023	77023	77024
18079	24717	0	applied	\N	\N	\N	\N	77027	77027	77028
18079	24718	1	applied	\N	\N	\N	\N	77029	77029	77030
18079	24719	2	applied	\N	\N	\N	\N	77031	77031	77032
18081	24717	0	applied	\N	\N	\N	\N	77027	77027	77028
18081	24718	1	applied	\N	\N	\N	\N	77029	77029	77030
18081	24719	2	applied	\N	\N	\N	\N	77031	77031	77032
18085	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18085	24675	1	applied	\N	\N	\N	\N	76913	76913	76914
18085	24691	2	applied	\N	\N	\N	\N	76957	76957	70512
18085	24686	3	applied	\N	\N	\N	\N	76941	76941	47675
18085	24615	4	applied	\N	\N	\N	\N	76735	76735	77058
18085	24630	5	applied	\N	\N	\N	\N	76776	76776	76712
18085	24637	6	applied	\N	\N	\N	\N	76793	76793	77059
18085	24645	7	applied	\N	\N	\N	\N	76814	76814	76720
18085	24654	8	applied	\N	\N	\N	\N	76841	76841	76714
18085	24662	9	applied	\N	\N	\N	\N	76873	76873	77060
18085	24670	10	applied	\N	\N	\N	\N	76900	76900	76721
18085	24681	11	applied	\N	\N	\N	\N	76929	76929	77061
18085	24689	12	applied	\N	\N	\N	\N	76946	76946	77062
18085	24696	13	applied	\N	\N	\N	\N	76969	76969	76726
18085	24709	14	applied	\N	\N	\N	\N	77007	77007	77063
18085	24712	15	applied	\N	\N	\N	\N	77014	77014	76734
18085	24719	16	applied	\N	\N	\N	\N	77031	77031	76736
18085	24725	17	applied	\N	\N	\N	\N	77049	77049	77064
18085	24626	18	applied	\N	\N	\N	\N	13663	13663	47675
18087	24729	0	applied	\N	\N	\N	\N	77067	77067	77068
18087	24730	1	applied	\N	\N	\N	\N	77069	77069	77070
18104	24754	0	applied	\N	\N	\N	\N	77146	77146	77147
18104	24755	1	applied	\N	\N	\N	\N	77148	77148	77149
18104	24756	2	applied	\N	\N	\N	\N	77150	77150	77151
18104	24757	3	applied	\N	\N	\N	\N	77152	77152	77153
18106	24758	0	applied	\N	\N	\N	\N	77155	77155	77156
18106	24759	1	applied	\N	\N	\N	\N	77157	77157	77158
18111	24764	0	applied	\N	\N	\N	\N	77177	77177	77178
18111	24765	1	applied	\N	\N	\N	\N	77179	77179	77180
18115	24731	0	applied	\N	\N	\N	\N	77079	77079	77080
18115	24732	1	applied	\N	\N	\N	\N	77083	77083	77084
18115	24735	2	applied	\N	\N	\N	\N	77094	77094	77095
18115	24737	3	applied	\N	\N	\N	\N	77100	77100	77101
18115	24739	4	applied	\N	\N	\N	\N	77106	77106	77107
18115	24742	5	applied	\N	\N	\N	\N	77114	77114	77115
18115	24744	6	applied	\N	\N	\N	\N	77118	77118	77119
18115	24746	7	applied	\N	\N	\N	\N	77124	77124	77125
18115	24748	8	applied	\N	\N	\N	\N	77130	77130	77131
18115	24749	9	applied	\N	\N	\N	\N	77132	77132	77133
18115	24752	10	applied	\N	\N	\N	\N	77139	77139	77140
18115	24754	11	applied	\N	\N	\N	\N	77146	77146	77147
18115	24758	12	applied	\N	\N	\N	\N	77155	77155	77156
18115	24760	13	applied	\N	\N	\N	\N	77161	77161	77162
18115	24761	14	applied	\N	\N	\N	\N	77169	77169	77170
18115	24764	15	applied	\N	\N	\N	\N	77177	77177	77178
18115	24733	16	applied	\N	\N	\N	\N	77085	77085	77086
18115	24736	17	applied	\N	\N	\N	\N	77096	77096	77189
18115	24738	18	applied	\N	\N	\N	\N	77102	77102	77190
18115	24734	19	applied	\N	\N	\N	\N	77087	77087	77103
18115	24740	20	applied	\N	\N	\N	\N	77108	77108	77109
18115	24743	21	applied	\N	\N	\N	\N	77116	77116	77191
18115	24745	22	applied	\N	\N	\N	\N	77120	77120	77192
18115	24747	23	applied	\N	\N	\N	\N	77126	77126	77193
18115	24750	24	applied	\N	\N	\N	\N	77134	77134	77165
18115	24741	25	applied	\N	\N	\N	\N	77110	77110	77135
18115	24753	26	applied	\N	\N	\N	\N	77141	77141	77194
18115	24755	27	applied	\N	\N	\N	\N	77148	77148	77166
18115	24762	28	applied	\N	\N	\N	\N	77171	77171	77137
18115	24751	29	applied	\N	\N	\N	\N	77136	77136	77195
18115	24756	30	applied	\N	\N	\N	\N	77150	77150	77196
18115	24757	31	applied	\N	\N	\N	\N	77152	77152	77197
18115	24759	32	applied	\N	\N	\N	\N	77157	77157	77172
18115	24763	33	applied	\N	\N	\N	\N	77173	77173	77174
18115	24765	34	applied	\N	\N	\N	\N	77179	77179	77180
18118	24766	0	applied	\N	\N	\N	\N	77199	77199	77200
18118	24767	1	applied	\N	\N	\N	\N	77201	77201	77202
18118	24768	2	applied	\N	\N	\N	\N	77203	77203	77204
18118	24769	3	applied	\N	\N	\N	\N	77205	77205	77206
18118	24770	4	applied	\N	\N	\N	\N	77207	77207	77208
18118	24771	5	applied	\N	\N	\N	\N	77209	77209	77210
18118	24772	6	applied	\N	\N	\N	\N	77211	77211	77212
18118	24773	7	applied	\N	\N	\N	\N	77213	77213	77214
18118	24774	8	applied	\N	\N	\N	\N	77215	77215	77216
18118	24775	9	applied	\N	\N	\N	\N	77217	77217	77218
18118	24776	10	applied	\N	\N	\N	\N	77219	77219	77220
18076	24710	0	applied	\N	\N	\N	\N	77010	77010	77011
18076	24711	1	applied	\N	\N	\N	\N	77012	77012	77013
18076	24712	2	applied	\N	\N	\N	\N	77014	77014	77015
18076	24713	3	applied	\N	\N	\N	\N	77016	77016	77017
18076	24714	4	applied	\N	\N	\N	\N	77018	77018	77019
18086	24722	0	applied	\N	\N	\N	\N	77043	77043	77044
18086	24723	1	applied	\N	\N	\N	\N	77045	77045	77046
18086	24724	2	applied	\N	\N	\N	\N	77047	77047	77048
18086	24725	3	applied	\N	\N	\N	\N	77049	77049	77050
18086	24726	4	applied	\N	\N	\N	\N	77051	77051	77052
18086	24727	5	applied	\N	\N	\N	\N	77053	77053	77054
18086	24728	6	applied	\N	\N	\N	\N	77055	77055	77056
18089	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18089	24675	1	applied	\N	\N	\N	\N	76913	76913	76914
18089	24691	2	applied	\N	\N	\N	\N	76957	76957	70512
18089	24686	3	applied	\N	\N	\N	\N	76941	76941	47675
18089	24560	4	applied	\N	\N	1000000000	\N	76537	76537	76601
18089	24469	5	applied	\N	\N	\N	\N	76235	76235	76236
18089	24472	6	applied	\N	\N	\N	\N	76247	76247	76248
18089	24567	7	applied	\N	\N	1000000000	\N	76556	76556	76557
18089	24571	8	applied	\N	\N	1000000000	\N	76567	76567	76568
18089	24476	9	applied	\N	\N	\N	\N	76284	76284	76285
18089	24477	10	applied	\N	\N	\N	\N	76286	76286	76287
18089	24482	11	applied	\N	\N	\N	\N	76344	76344	76345
18089	24483	12	applied	\N	\N	\N	\N	76346	76346	76347
18089	24489	13	applied	\N	\N	\N	\N	76359	76359	76360
18089	24592	14	applied	\N	\N	\N	\N	76663	76663	47675
18089	24556	15	applied	\N	\N	\N	\N	76528	76528	76602
18089	24575	16	applied	\N	\N	1000000000	\N	76575	76575	76576
18089	24514	17	applied	\N	\N	\N	\N	76864	76864	76604
18089	24529	18	applied	\N	\N	\N	\N	76865	76865	76606
18089	24492	19	applied	\N	\N	\N	\N	76366	76366	76367
18089	24493	20	applied	\N	\N	\N	\N	76368	76368	76369
18089	24494	21	applied	\N	\N	\N	\N	76370	76370	76371
18089	24502	22	applied	\N	\N	\N	\N	76391	76391	76392
18089	24504	23	applied	\N	\N	\N	\N	76401	76401	76402
18089	24505	24	applied	\N	\N	\N	\N	76403	76403	76404
18089	24511	25	applied	\N	\N	\N	\N	76418	76418	76419
18089	24538	26	applied	\N	\N	\N	\N	76866	76866	76607
18089	24544	27	applied	\N	\N	\N	\N	76867	76867	76538
18089	24515	28	applied	\N	\N	\N	\N	76431	76431	76432
18089	24518	29	applied	\N	\N	\N	\N	76440	76440	76441
18089	24522	30	applied	\N	\N	\N	\N	76451	76451	76452
18089	24523	31	applied	\N	\N	\N	\N	76453	76453	76454
18089	24528	32	applied	\N	\N	\N	\N	76466	76466	76467
18089	24530	33	applied	\N	\N	\N	\N	76470	76470	76471
18089	24536	34	applied	\N	\N	\N	\N	76484	76484	76485
18089	24537	35	applied	\N	\N	\N	\N	76486	76486	76487
18089	24545	36	applied	\N	\N	\N	\N	76503	76503	76504
18089	24546	37	applied	\N	\N	\N	\N	76505	76505	76506
18089	24552	38	applied	\N	\N	\N	\N	76518	76518	76519
18089	24555	39	applied	\N	\N	\N	\N	76526	76526	76527
18089	24559	40	applied	\N	\N	\N	\N	76535	76535	76536
18089	24563	41	applied	\N	\N	\N	\N	76545	76545	76546
18089	24566	42	applied	\N	\N	\N	\N	76554	76554	76555
18089	24572	43	applied	\N	\N	\N	\N	76569	76569	76570
18089	24573	44	applied	\N	\N	\N	\N	76571	76571	76572
18089	24574	45	applied	\N	\N	\N	\N	76573	76573	76574
18089	24583	46	applied	\N	\N	\N	\N	76593	76593	76594
18089	24586	47	applied	\N	\N	\N	\N	76646	76646	76647
18089	24589	48	applied	\N	\N	\N	\N	76656	76656	76657
18089	24591	49	applied	\N	\N	\N	\N	76661	76661	76662
18089	24596	50	applied	\N	\N	\N	\N	76675	76675	76676
18089	24599	51	applied	\N	\N	\N	\N	76682	76682	76683
18089	24602	52	applied	\N	\N	\N	\N	76693	76693	76694
18089	24606	53	applied	\N	\N	\N	\N	76709	76709	76710
18089	24611	54	applied	\N	\N	\N	\N	76723	76723	76724
18089	24613	55	applied	\N	\N	\N	\N	76731	76731	76732
18089	24617	56	applied	\N	\N	\N	\N	76741	76741	76742
18089	24620	57	applied	\N	\N	\N	\N	76748	76748	76749
18089	24623	58	applied	\N	\N	\N	\N	76760	76760	76761
18089	24627	59	applied	\N	\N	\N	\N	76770	76770	76771
18089	24628	60	applied	\N	\N	\N	\N	76772	76772	76773
18089	24633	61	applied	\N	\N	\N	\N	76784	76784	76785
18089	24636	63	applied	\N	\N	\N	\N	76791	76791	76792
18089	24640	64	applied	\N	\N	\N	\N	76801	76801	76802
18089	24642	65	applied	\N	\N	\N	\N	76808	76808	76809
18089	24644	66	applied	\N	\N	\N	\N	76812	76812	76813
18089	24647	67	applied	\N	\N	\N	\N	76824	76824	76825
18089	24649	68	applied	\N	\N	\N	\N	76829	76829	76830
18089	24650	69	applied	\N	\N	\N	\N	76831	76831	76832
18089	24653	70	applied	\N	\N	\N	\N	76839	76839	76840
18089	24656	71	applied	\N	\N	\N	\N	76848	76848	76849
18089	24658	72	applied	\N	\N	\N	\N	76856	76856	76857
18089	24660	73	applied	\N	\N	\N	\N	76869	76869	76870
18089	24664	74	applied	\N	\N	\N	\N	76881	76881	76882
18089	24666	75	applied	\N	\N	\N	\N	76887	76887	76888
18089	24668	76	applied	\N	\N	\N	\N	76896	76896	76897
18089	24671	77	applied	\N	\N	\N	\N	76903	76903	76904
18089	24672	78	applied	\N	\N	\N	\N	76905	76905	76906
18089	24676	79	applied	\N	\N	\N	\N	76915	76915	76916
18089	24678	80	applied	\N	\N	\N	\N	76924	76924	76925
18089	24680	81	applied	\N	\N	\N	\N	76927	76927	76928
18089	24684	82	applied	\N	\N	\N	\N	76937	76937	76938
18089	24685	83	applied	\N	\N	\N	\N	76939	76939	76940
18089	24690	84	applied	\N	\N	\N	\N	76952	76952	76953
18089	24693	85	applied	\N	\N	\N	\N	76961	76961	76962
18089	24694	86	applied	\N	\N	\N	\N	76965	76965	76966
18089	24697	87	applied	\N	\N	\N	\N	76973	76973	76974
18089	24699	88	applied	\N	\N	\N	\N	76984	76984	76985
18089	24700	89	applied	\N	\N	\N	\N	76986	76986	76987
18089	24703	90	applied	\N	\N	\N	\N	76995	76995	76996
18089	24704	91	applied	\N	\N	\N	\N	76997	76997	76998
18089	24705	92	applied	\N	\N	\N	\N	76999	76999	77000
18089	24710	93	applied	\N	\N	\N	\N	77010	77010	77011
18089	24711	94	applied	\N	\N	\N	\N	77012	77012	77013
18089	24715	95	applied	\N	\N	\N	\N	77021	77021	77022
18089	24717	96	applied	\N	\N	\N	\N	77027	77027	77028
18089	24720	97	applied	\N	\N	\N	\N	77037	77037	77038
18089	24722	98	applied	\N	\N	\N	\N	77043	77043	77044
18089	24723	99	applied	\N	\N	\N	\N	77045	77045	77046
18089	24724	100	applied	\N	\N	\N	\N	77047	77047	77048
18089	24729	101	applied	\N	\N	\N	\N	77067	77067	77068
18089	24394	102	applied	\N	\N	\N	\N	76024	76024	75536
18089	24404	103	applied	\N	\N	\N	\N	76053	76053	75894
18089	24547	104	applied	\N	\N	\N	\N	76507	76507	76507
18089	24609	105	applied	\N	\N	\N	\N	76715	76715	76716
18089	24626	106	applied	\N	\N	\N	\N	13663	13663	47675
18089	24420	107	applied	\N	\N	\N	\N	76093	76093	75538
18089	24429	108	applied	\N	\N	\N	\N	76116	76116	77075
18089	24440	109	applied	\N	\N	\N	\N	76148	76148	75895
18089	24454	110	applied	\N	\N	\N	\N	76185	76185	75540
18089	24465	111	applied	\N	\N	\N	\N	76215	76215	77076
18089	24474	112	applied	\N	\N	\N	\N	76251	76251	75896
18089	24488	113	applied	\N	\N	\N	\N	76356	76356	75542
18089	24497	114	applied	\N	\N	\N	\N	76376	76376	75897
18089	24508	115	applied	\N	\N	\N	\N	76410	76410	75550
18089	24520	116	applied	\N	\N	\N	\N	76444	76444	75556
18089	24531	117	applied	\N	\N	\N	\N	76472	76472	75552
18089	24541	118	applied	\N	\N	\N	\N	76494	76494	75898
18089	24558	119	applied	\N	\N	\N	\N	76532	76532	75558
18089	24569	120	applied	\N	\N	\N	\N	76560	76560	75899
18089	24576	121	applied	\N	\N	\N	\N	76577	76577	75559
18089	24595	122	applied	\N	\N	\N	\N	76668	76668	75584
18089	24603	123	applied	\N	\N	\N	\N	76695	76695	75560
18089	24615	124	applied	\N	\N	\N	\N	76735	76735	75585
18089	24630	125	applied	\N	\N	\N	\N	76776	76776	75568
18091	24732	0	applied	\N	\N	\N	\N	77083	77083	77084
18091	24733	1	applied	\N	\N	\N	\N	77085	77085	77086
18091	24734	2	applied	\N	\N	\N	\N	77087	77087	77088
18093	24732	0	applied	\N	\N	\N	\N	77083	77083	77084
18093	24733	1	applied	\N	\N	\N	\N	77085	77085	77086
18093	24734	2	applied	\N	\N	\N	\N	77087	77087	77088
18096	24737	0	applied	\N	\N	\N	\N	77100	77100	77101
18096	24738	1	applied	\N	\N	\N	\N	77102	77102	77103
18098	24742	0	applied	\N	\N	\N	\N	77114	77114	77115
18098	24743	1	applied	\N	\N	\N	\N	77116	77116	77117
18101	24748	0	applied	\N	\N	\N	\N	77130	77130	77131
18101	24749	1	applied	\N	\N	\N	\N	77132	77132	77133
18101	24750	2	applied	\N	\N	\N	\N	77134	77134	77135
18101	24751	3	applied	\N	\N	\N	\N	77136	77136	77137
18108	24758	0	applied	\N	\N	\N	\N	77155	77155	77156
18108	24760	1	applied	\N	\N	\N	\N	77161	77161	77162
18108	24759	2	applied	\N	\N	\N	\N	77157	77157	77158
18110	24761	0	applied	\N	\N	\N	\N	77169	77169	77170
18110	24762	1	applied	\N	\N	\N	\N	77171	77171	77172
18110	24763	2	applied	\N	\N	\N	\N	77173	77173	77174
18113	24764	0	applied	\N	\N	\N	\N	77177	77177	77178
18113	24765	1	applied	\N	\N	\N	\N	77179	77179	77180
18120	24777	0	applied	\N	\N	\N	\N	77224	77224	77225
18120	24778	1	applied	\N	\N	\N	\N	77226	77226	77227
18120	24779	2	applied	\N	\N	\N	\N	77228	77228	77229
18125	24784	0	applied	\N	\N	\N	\N	77243	77243	77244
18125	24785	1	applied	\N	\N	\N	\N	77245	77245	77246
18125	24786	2	applied	\N	\N	\N	\N	77247	77247	77248
18125	24787	3	applied	\N	\N	\N	\N	77249	77249	77250
18125	24788	4	applied	\N	\N	\N	\N	77251	77251	77252
18128	24789	0	applied	\N	\N	\N	\N	77265	77265	77266
18128	24790	1	applied	\N	\N	\N	\N	77267	77267	77268
18128	24791	2	applied	\N	\N	\N	\N	77269	77269	77270
18128	24792	3	applied	\N	\N	\N	\N	77271	77271	77272
18128	24793	4	applied	\N	\N	\N	\N	77273	77273	77274
18128	24794	5	applied	\N	\N	\N	\N	77275	77275	77276
18128	24795	6	applied	\N	\N	\N	\N	77277	77277	77278
18131	24800	0	applied	\N	\N	\N	\N	77293	77293	77294
18131	24801	1	applied	\N	\N	\N	\N	77295	77295	77296
18131	24802	2	applied	\N	\N	\N	\N	77297	77297	77298
18119	24778	1	applied	\N	\N	\N	\N	77226	77226	77227
18119	24779	2	applied	\N	\N	\N	\N	77228	77228	77229
18121	24777	0	applied	\N	\N	\N	\N	77224	77224	77225
18121	24778	1	applied	\N	\N	\N	\N	77226	77226	77227
18121	24779	2	applied	\N	\N	\N	\N	77228	77228	77229
18124	24784	0	applied	\N	\N	\N	\N	77243	77243	77244
18124	24785	1	applied	\N	\N	\N	\N	77245	77245	77246
18124	24786	2	applied	\N	\N	\N	\N	77247	77247	77248
18124	24787	3	applied	\N	\N	\N	\N	77249	77249	77250
18124	24788	4	applied	\N	\N	\N	\N	77251	77251	77252
18126	24691	0	applied	\N	\N	\N	\N	76957	76957	70512
18126	24693	1	applied	\N	\N	\N	\N	76961	76961	76962
18126	24694	2	applied	\N	\N	\N	\N	76965	76965	76966
18126	24697	3	applied	\N	\N	\N	\N	76973	76973	76974
18126	24699	4	applied	\N	\N	\N	\N	76984	76984	76985
18126	24700	5	applied	\N	\N	\N	\N	76986	76986	76987
18126	24703	6	applied	\N	\N	\N	\N	76995	76995	76996
18126	24704	7	applied	\N	\N	\N	\N	76997	76997	76998
18126	24705	8	applied	\N	\N	\N	\N	76999	76999	77000
18126	24710	9	applied	\N	\N	\N	\N	77010	77010	77011
18126	24711	10	applied	\N	\N	\N	\N	77012	77012	77013
18126	24715	11	applied	\N	\N	\N	\N	77021	77021	77022
18126	24717	12	applied	\N	\N	\N	\N	77027	77027	77028
18126	24720	13	applied	\N	\N	\N	\N	77037	77037	77038
18126	24722	14	applied	\N	\N	\N	\N	77043	77043	77044
18126	24723	15	applied	\N	\N	\N	\N	77045	77045	77046
18126	24724	16	applied	\N	\N	\N	\N	77047	77047	77048
18126	24729	17	applied	\N	\N	\N	\N	77067	77067	77068
18126	24731	18	applied	\N	\N	\N	\N	77079	77079	77080
18126	24732	19	applied	\N	\N	\N	\N	77083	77083	77084
18126	24735	20	applied	\N	\N	\N	\N	77094	77094	77095
18126	24737	21	applied	\N	\N	\N	\N	77100	77100	77101
18126	24739	22	applied	\N	\N	\N	\N	77106	77106	77107
18126	24742	23	applied	\N	\N	\N	\N	77114	77114	77115
18126	24744	24	applied	\N	\N	\N	\N	77118	77118	77119
18126	24746	25	applied	\N	\N	\N	\N	77124	77124	77125
18126	24748	26	applied	\N	\N	\N	\N	77130	77130	77131
18126	24749	27	applied	\N	\N	\N	\N	77132	77132	77133
18126	24752	28	applied	\N	\N	\N	\N	77139	77139	77140
18126	24754	29	applied	\N	\N	\N	\N	77146	77146	77147
18126	24758	30	applied	\N	\N	\N	\N	77155	77155	77156
18126	24760	31	applied	\N	\N	\N	\N	77161	77161	77162
18126	24761	32	applied	\N	\N	\N	\N	77169	77169	77170
18126	24764	33	applied	\N	\N	\N	\N	77177	77177	77178
18126	24766	34	applied	\N	\N	\N	\N	77199	77199	77200
18126	24767	35	applied	\N	\N	\N	\N	77201	77201	77202
18126	24768	36	applied	\N	\N	\N	\N	77203	77203	77204
18126	24769	37	applied	\N	\N	\N	\N	77205	77205	77206
18126	24770	38	applied	\N	\N	\N	\N	77207	77207	77208
18126	24777	39	applied	\N	\N	\N	\N	77224	77224	77225
18126	24780	40	applied	\N	\N	\N	\N	77234	77234	77235
18126	24781	41	applied	\N	\N	\N	\N	77236	77236	77237
18126	24784	42	applied	\N	\N	\N	\N	77243	77243	77244
18126	24785	43	applied	\N	\N	\N	\N	77245	77245	77246
18126	24692	44	applied	\N	\N	\N	\N	76958	76958	76959
18126	24696	45	applied	\N	\N	\N	\N	76969	76969	77255
18126	24709	46	applied	\N	\N	\N	\N	77007	77007	77256
18126	24712	47	applied	\N	\N	\N	\N	77014	77014	76968
18126	24719	48	applied	\N	\N	\N	\N	77031	77031	76970
18126	24725	49	applied	\N	\N	\N	\N	77049	77049	77257
18126	24734	50	applied	\N	\N	\N	\N	77087	77087	77258
18126	24741	51	applied	\N	\N	\N	\N	77110	77110	76976
18126	24753	52	applied	\N	\N	\N	\N	77141	77141	77259
18126	24755	53	applied	\N	\N	\N	\N	77148	77148	77260
18126	24762	54	applied	\N	\N	\N	\N	77171	77171	76989
18126	24773	55	applied	\N	\N	\N	\N	77213	77213	77261
18126	24778	56	applied	\N	\N	\N	\N	77226	77226	77262
18126	24786	57	applied	\N	\N	\N	\N	77247	77247	76991
18129	24796	0	applied	\N	\N	\N	\N	77283	77283	77284
18129	24797	1	applied	\N	\N	\N	\N	77285	77285	77286
18129	24798	2	applied	\N	\N	\N	\N	77287	77287	77288
18129	24799	3	applied	\N	\N	\N	\N	77289	77289	77290
18134	24803	0	applied	\N	\N	\N	\N	77302	77302	77303
18134	24804	1	applied	\N	\N	\N	\N	77304	77304	77305
18127	24793	4	applied	\N	\N	\N	\N	77273	77273	77274
18127	24794	5	applied	\N	\N	\N	\N	77275	77275	77276
18127	24795	6	applied	\N	\N	\N	\N	77277	77277	77278
18130	24800	0	applied	\N	\N	\N	\N	77293	77293	77294
18130	24801	1	applied	\N	\N	\N	\N	77295	77295	77296
18130	24802	2	applied	\N	\N	\N	\N	77297	77297	77298
18132	24800	0	applied	\N	\N	\N	\N	77293	77293	77294
18132	24801	1	applied	\N	\N	\N	\N	77295	77295	77296
18132	24802	2	applied	\N	\N	\N	\N	77297	77297	77298
18135	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18135	24043	1	applied	\N	\N	\N	\N	75014	75014	71028
18135	24675	2	applied	\N	\N	\N	\N	76913	76913	76914
18135	24691	3	applied	\N	\N	\N	\N	76957	76957	70512
18135	24037	4	applied	\N	\N	\N	\N	74999	74999	74999
18135	24686	5	applied	\N	\N	\N	\N	76941	76941	47675
18135	24028	6	applied	\N	\N	\N	\N	74980	74980	74980
18135	24560	7	applied	\N	\N	1000000000	\N	76537	76537	76601
18135	24592	8	applied	\N	\N	\N	\N	76663	76663	47675
18135	23993	9	applied	\N	\N	1000000000	\N	74884	74884	74885
18135	24195	10	applied	\N	\N	1000000000	\N	75621	75621	75416
18135	24347	11	applied	\N	\N	1000000000	\N	76256	76256	75905
18135	24567	12	applied	\N	\N	1000000000	\N	77310	77310	76557
18135	24571	13	applied	\N	\N	1000000000	\N	77311	77311	76568
18135	24556	14	applied	\N	\N	\N	\N	76528	76528	76602
18135	24575	15	applied	\N	\N	1000000000	\N	77312	77312	76576
18135	24514	16	applied	\N	\N	\N	\N	77313	77313	76604
18135	24529	17	applied	\N	\N	\N	\N	77314	77314	76606
18135	24538	18	applied	\N	\N	\N	\N	76866	76866	76607
18135	24544	19	applied	\N	\N	\N	\N	76867	76867	76538
18135	24120	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	75221	75221	\N
18135	24414	21	applied	\N	\N	\N	\N	76078	76078	76078
18135	24190	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	75401	75401	\N
18135	24261	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	75606	75606	\N
18135	24547	24	applied	\N	\N	\N	\N	76507	76507	76507
18135	24121	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	75222	75222	\N
18135	24133	26	applied	\N	\N	\N	\N	75249	75249	76575
18135	23996	27	applied	\N	\N	\N	\N	74890	74890	76271
18135	24423	28	applied	\N	\N	\N	\N	76104	76104	76104
18135	24438	29	applied	\N	\N	\N	\N	76144	76144	76144
18135	24280	30	applied	\N	\N	\N	\N	75665	75665	75666
18135	24609	31	applied	\N	\N	\N	\N	76715	76715	76716
18135	24626	32	applied	\N	\N	\N	\N	13663	13663	47675
18135	24014	33	applied	\N	\N	\N	\N	74937	74937	74320
18135	24018	34	applied	\N	\N	\N	\N	74954	74954	76272
18135	24035	35	applied	\N	\N	\N	\N	74993	74993	74322
18135	24049	36	applied	\N	\N	\N	\N	75025	75025	76273
18135	24059	37	applied	\N	\N	\N	\N	75048	75048	74328
18135	24069	38	applied	\N	\N	\N	\N	75092	75092	76274
18135	24080	39	applied	\N	\N	\N	\N	75125	75125	76275
18135	24092	41	applied	\N	\N	\N	\N	75150	75150	74330
18135	24102	42	applied	\N	\N	\N	\N	75179	75179	76276
18135	24111	43	applied	\N	\N	\N	\N	75198	75198	74337
18135	24128	44	applied	\N	\N	\N	\N	75235	75235	76277
18135	24139	45	applied	\N	\N	\N	\N	75265	75265	76278
18135	24146	46	applied	\N	\N	\N	\N	75283	75283	74339
18135	24156	47	applied	\N	\N	\N	\N	75306	75306	76279
18135	24171	48	applied	\N	\N	\N	\N	75347	75347	74348
18135	24178	49	applied	\N	\N	\N	\N	75367	75367	76280
18135	24191	50	applied	\N	\N	\N	\N	75402	75402	76281
18135	24198	51	applied	\N	\N	\N	\N	75421	75421	74350
18135	24209	52	applied	\N	\N	\N	\N	75449	75449	77316
18135	24218	53	applied	\N	\N	\N	\N	75477	75477	77317
18135	24233	54	applied	\N	\N	\N	\N	75514	75514	74358
18135	24239	55	applied	\N	\N	\N	\N	75533	75533	77318
18135	24252	56	applied	\N	\N	\N	\N	75574	75574	74360
18135	24266	57	applied	\N	\N	\N	\N	75618	75618	74368
18135	24274	58	applied	\N	\N	\N	\N	75646	75646	77319
18135	24284	59	applied	\N	\N	\N	\N	75691	75691	77320
18135	24298	60	applied	\N	\N	\N	\N	75723	75723	74370
18135	24309	61	applied	\N	\N	\N	\N	75749	75749	77321
18135	24318	62	applied	\N	\N	\N	\N	75772	75772	74372
18135	24331	63	applied	\N	\N	\N	\N	75809	75809	77322
18135	24341	64	applied	\N	\N	\N	\N	75836	75836	74384
18135	24353	65	applied	\N	\N	\N	\N	75916	75916	77323
18135	24367	66	applied	\N	\N	\N	\N	75947	75947	77324
18135	24375	67	applied	\N	\N	\N	\N	75964	75964	74386
18135	24384	68	applied	\N	\N	\N	\N	75998	75998	77325
18135	24394	69	applied	\N	\N	\N	\N	76024	76024	77326
18135	24404	70	applied	\N	\N	\N	\N	76053	76053	74400
18135	24420	71	applied	\N	\N	\N	\N	76093	76093	77327
18135	24429	72	applied	\N	\N	\N	\N	76116	76116	77328
18135	24440	73	applied	\N	\N	\N	\N	76148	76148	74402
18135	24454	74	applied	\N	\N	\N	\N	76185	76185	77329
18135	24465	75	applied	\N	\N	\N	\N	76215	76215	77330
18135	24474	76	applied	\N	\N	\N	\N	76251	76251	74404
18135	24488	77	applied	\N	\N	\N	\N	76356	76356	77331
18135	24497	78	applied	\N	\N	\N	\N	76376	76376	74406
18135	24508	79	applied	\N	\N	\N	\N	76410	76410	77332
18135	24520	80	applied	\N	\N	\N	\N	76444	76444	77333
18135	24531	81	applied	\N	\N	\N	\N	76472	76472	74412
18135	24541	82	applied	\N	\N	\N	\N	76494	76494	77334
18135	24558	83	applied	\N	\N	\N	\N	76532	76532	77335
18135	24569	84	applied	\N	\N	\N	\N	76560	76560	74544
18135	24576	85	applied	\N	\N	\N	\N	76577	76577	77336
18135	24595	86	applied	\N	\N	\N	\N	76668	76668	77337
18135	24603	87	applied	\N	\N	\N	\N	76695	76695	74553
18135	24615	88	applied	\N	\N	\N	\N	76735	76735	77338
18135	24630	89	applied	\N	\N	\N	\N	76776	76776	77339
18135	24637	90	applied	\N	\N	\N	\N	76793	76793	74559
18135	24645	91	applied	\N	\N	\N	\N	76814	76814	77340
18135	24654	92	applied	\N	\N	\N	\N	76841	76841	77341
18135	24662	93	applied	\N	\N	\N	\N	76873	76873	74566
18135	24670	94	applied	\N	\N	\N	\N	76900	76900	77342
18135	24681	95	applied	\N	\N	\N	\N	76929	76929	77343
18135	24689	96	applied	\N	\N	\N	\N	76946	76946	74574
18135	24696	97	applied	\N	\N	\N	\N	76969	76969	77344
18135	24709	98	applied	\N	\N	\N	\N	77007	77007	77345
18135	24712	99	applied	\N	\N	\N	\N	77014	77014	74576
18135	24719	100	applied	\N	\N	\N	\N	77031	77031	77346
18135	24725	101	applied	\N	\N	\N	\N	77049	77049	77347
18135	24734	102	applied	\N	\N	\N	\N	77087	77087	74584
18135	24741	103	applied	\N	\N	\N	\N	77110	77110	77348
18135	24753	104	applied	\N	\N	\N	\N	77141	77141	77349
18135	24755	105	applied	\N	\N	\N	\N	77148	77148	74586
18135	24762	106	applied	\N	\N	\N	\N	77171	77171	77350
18135	24773	107	applied	\N	\N	\N	\N	77213	77213	77351
18135	24778	108	applied	\N	\N	\N	\N	77226	77226	74594
18133	24803	0	applied	\N	\N	\N	\N	77302	77302	77303
18133	24804	1	applied	\N	\N	\N	\N	77304	77304	77305
18135	24786	109	applied	\N	\N	\N	\N	77247	77247	77352
18135	24792	110	applied	\N	\N	\N	\N	77271	77271	77353
18135	24802	111	applied	\N	\N	\N	\N	77297	77297	74603
18136	24805	0	applied	\N	\N	\N	\N	77356	77356	77357
18136	24806	1	applied	\N	\N	\N	\N	77358	77358	77359
18136	24807	2	applied	\N	\N	\N	\N	77360	77360	77361
18136	24808	3	applied	\N	\N	\N	\N	77362	77362	77363
18136	24809	4	applied	\N	\N	\N	\N	77364	77364	77365
18136	24810	5	applied	\N	\N	\N	\N	77366	77366	77367
18136	24811	6	applied	\N	\N	\N	\N	77368	77368	77369
18137	24805	0	applied	\N	\N	\N	\N	77356	77356	77357
18137	24806	1	applied	\N	\N	\N	\N	77358	77358	77359
18137	24807	2	applied	\N	\N	\N	\N	77360	77360	77361
18137	24808	3	applied	\N	\N	\N	\N	77362	77362	77363
18137	24809	4	applied	\N	\N	\N	\N	77364	77364	77365
18137	24810	5	applied	\N	\N	\N	\N	77366	77366	77367
18137	24811	6	applied	\N	\N	\N	\N	77368	77368	77369
18138	24805	0	applied	\N	\N	\N	\N	77356	77356	77357
18138	24806	1	applied	\N	\N	\N	\N	77358	77358	77359
18138	24807	2	applied	\N	\N	\N	\N	77360	77360	77361
18138	24808	3	applied	\N	\N	\N	\N	77362	77362	77363
18138	24809	4	applied	\N	\N	\N	\N	77364	77364	77365
18138	24810	5	applied	\N	\N	\N	\N	77366	77366	77367
18138	24811	6	applied	\N	\N	\N	\N	77368	77368	77369
18139	24812	0	applied	\N	\N	\N	\N	77374	77374	77375
18139	24813	1	applied	\N	\N	\N	\N	77376	77376	77377
18140	24812	0	applied	\N	\N	\N	\N	77374	77374	77375
18140	24813	1	applied	\N	\N	\N	\N	77376	77376	77377
18141	24814	0	applied	\N	\N	\N	\N	77380	77380	77381
18141	24815	1	applied	\N	\N	\N	\N	77382	77382	77383
18142	24816	0	applied	\N	\N	\N	\N	77385	77385	77386
18142	24817	1	applied	\N	\N	\N	\N	77387	77387	77388
18142	24818	2	applied	\N	\N	\N	\N	77389	77389	77390
18142	24819	3	applied	\N	\N	\N	\N	77391	77391	77392
18142	24820	4	applied	\N	\N	\N	\N	77393	77393	77394
18143	24816	0	applied	\N	\N	\N	\N	77385	77385	77386
18143	24817	1	applied	\N	\N	\N	\N	77387	77387	77388
18143	24818	2	applied	\N	\N	\N	\N	77389	77389	77390
18143	24819	3	applied	\N	\N	\N	\N	77391	77391	77392
18143	24820	4	applied	\N	\N	\N	\N	77393	77393	77394
18144	24821	0	applied	\N	\N	\N	\N	77398	77398	77399
18144	24822	1	applied	\N	\N	\N	\N	77400	77400	77401
18145	24823	0	applied	\N	\N	\N	\N	77404	77404	77405
18145	24824	1	applied	\N	\N	\N	\N	77406	77406	77407
18146	24823	0	applied	\N	\N	\N	\N	77404	77404	77405
18146	24824	1	applied	\N	\N	\N	\N	77406	77406	77407
18147	24823	0	applied	\N	\N	\N	\N	77404	77404	77405
18147	24824	1	applied	\N	\N	\N	\N	77406	77406	77407
18148	24825	0	applied	\N	\N	\N	\N	77412	77412	77413
18148	24826	1	applied	\N	\N	\N	\N	77414	77414	77415
18148	24827	2	applied	\N	\N	\N	\N	77416	77416	77417
18150	24828	0	applied	\N	\N	\N	\N	77419	77419	77419
18150	24829	1	applied	\N	\N	\N	\N	77420	77420	77421
18150	24830	2	applied	\N	\N	\N	\N	77422	77422	77423
18150	24831	3	applied	\N	\N	\N	\N	77424	77424	77425
18150	24832	4	applied	\N	\N	\N	\N	77426	77426	77427
18150	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18150	24834	6	applied	\N	\N	\N	\N	77430	77430	77431
18150	24835	7	applied	\N	\N	\N	\N	77432	77432	77433
18150	24836	8	applied	\N	\N	\N	\N	77434	77434	77435
18150	24837	9	applied	\N	\N	\N	\N	77436	77436	77437
18150	24838	10	applied	\N	\N	\N	\N	77438	77438	77439
18150	24839	11	applied	\N	\N	\N	\N	77440	77440	77441
18150	24840	12	applied	\N	\N	\N	\N	77442	77442	77443
18150	24841	14	applied	\N	\N	\N	\N	77445	77445	77446
18150	24842	15	applied	\N	\N	\N	\N	77447	77447	77448
18151	24828	0	applied	\N	\N	\N	\N	77419	77419	77419
18151	24829	1	applied	\N	\N	\N	\N	77420	77420	77421
18151	24830	2	applied	\N	\N	\N	\N	77422	77422	77423
18151	24831	3	applied	\N	\N	\N	\N	77424	77424	77425
18151	24832	4	applied	\N	\N	\N	\N	77426	77426	77427
18151	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18151	24834	6	applied	\N	\N	\N	\N	77430	77430	77431
18151	24835	7	applied	\N	\N	\N	\N	77432	77432	77433
18151	24836	8	applied	\N	\N	\N	\N	77434	77434	77435
18151	24837	9	applied	\N	\N	\N	\N	77436	77436	77437
18151	24838	10	applied	\N	\N	\N	\N	77438	77438	77439
18151	24839	11	applied	\N	\N	\N	\N	77440	77440	77441
18151	24840	12	applied	\N	\N	\N	\N	77442	77442	77443
18151	24841	14	applied	\N	\N	\N	\N	77445	77445	77446
18151	24842	15	applied	\N	\N	\N	\N	77447	77447	77448
18152	24828	0	applied	\N	\N	\N	\N	77419	77419	77419
18152	24829	1	applied	\N	\N	\N	\N	77420	77420	77421
18152	24830	2	applied	\N	\N	\N	\N	77422	77422	77423
18152	24831	3	applied	\N	\N	\N	\N	77424	77424	77425
18152	24832	4	applied	\N	\N	\N	\N	77426	77426	77427
18152	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18152	24834	6	applied	\N	\N	\N	\N	77430	77430	77431
18152	24835	7	applied	\N	\N	\N	\N	77432	77432	77433
18152	24836	8	applied	\N	\N	\N	\N	77434	77434	77435
18152	24837	9	applied	\N	\N	\N	\N	77436	77436	77437
18152	24838	10	applied	\N	\N	\N	\N	77438	77438	77439
18152	24839	11	applied	\N	\N	\N	\N	77440	77440	77441
18152	24840	12	applied	\N	\N	\N	\N	77442	77442	77443
18152	24841	14	applied	\N	\N	\N	\N	77445	77445	77446
18152	24842	15	applied	\N	\N	\N	\N	77447	77447	77448
18153	24717	0	applied	\N	\N	\N	\N	77027	77027	77028
18153	24828	1	applied	\N	\N	\N	\N	77419	77419	77419
18153	24833	2	applied	\N	\N	1000000000	\N	77428	77428	77429
18153	24720	3	applied	\N	\N	\N	\N	77037	77037	77038
18153	24722	4	applied	\N	\N	\N	\N	77043	77043	77044
18153	24723	5	applied	\N	\N	\N	\N	77045	77045	77046
18153	24724	6	applied	\N	\N	\N	\N	77047	77047	77048
18153	24729	7	applied	\N	\N	\N	\N	77067	77067	77068
18153	24731	8	applied	\N	\N	\N	\N	77079	77079	77080
18153	24732	9	applied	\N	\N	\N	\N	77083	77083	77084
18153	24735	10	applied	\N	\N	\N	\N	77094	77094	77095
18153	24737	11	applied	\N	\N	\N	\N	77100	77100	77101
18153	24739	12	applied	\N	\N	\N	\N	77106	77106	77107
18153	24742	13	applied	\N	\N	\N	\N	77114	77114	77115
18153	24744	14	applied	\N	\N	\N	\N	77118	77118	77119
18153	24746	15	applied	\N	\N	\N	\N	77124	77124	77125
18153	24748	16	applied	\N	\N	\N	\N	77130	77130	77131
18153	24749	17	applied	\N	\N	\N	\N	77132	77132	77133
18153	24752	18	applied	\N	\N	\N	\N	77139	77139	77140
18153	24754	19	applied	\N	\N	\N	\N	77146	77146	77147
18153	24758	20	applied	\N	\N	\N	\N	77155	77155	77156
18153	24760	21	applied	\N	\N	\N	\N	77161	77161	77162
18153	24761	22	applied	\N	\N	\N	\N	77169	77169	77170
18153	24764	23	applied	\N	\N	\N	\N	77177	77177	77178
18153	24766	24	applied	\N	\N	\N	\N	77199	77199	77200
18153	24767	25	applied	\N	\N	\N	\N	77201	77201	77202
18153	24768	26	applied	\N	\N	\N	\N	77203	77203	77204
18153	24769	27	applied	\N	\N	\N	\N	77205	77205	77206
18153	24770	28	applied	\N	\N	\N	\N	77207	77207	77208
18153	24777	29	applied	\N	\N	\N	\N	77224	77224	77225
18153	24780	30	applied	\N	\N	\N	\N	77234	77234	77235
18153	24781	31	applied	\N	\N	\N	\N	77236	77236	77237
18153	24784	32	applied	\N	\N	\N	\N	77243	77243	77244
18153	24785	33	applied	\N	\N	\N	\N	77245	77245	77246
18153	24789	34	applied	\N	\N	\N	\N	77265	77265	77266
18153	24790	35	applied	\N	\N	\N	\N	77267	77267	77268
18153	24791	36	applied	\N	\N	\N	\N	77269	77269	77270
18153	24796	37	applied	\N	\N	\N	\N	77283	77283	77284
18153	24797	38	applied	\N	\N	\N	\N	77285	77285	77286
18153	24800	39	applied	\N	\N	\N	\N	77293	77293	77294
18153	24803	40	applied	\N	\N	\N	\N	77302	77302	77303
18153	24805	41	applied	\N	\N	\N	\N	77356	77356	77357
18153	24806	42	applied	\N	\N	\N	\N	77358	77358	77359
18153	24807	43	applied	\N	\N	\N	\N	77360	77360	77361
18153	24812	44	applied	\N	\N	\N	\N	77374	77374	77375
18153	24814	45	applied	\N	\N	\N	\N	77380	77380	77381
18153	24816	46	applied	\N	\N	\N	\N	77385	77385	77386
18153	24817	47	applied	\N	\N	\N	\N	77387	77387	77388
18153	24821	48	applied	\N	\N	\N	\N	77398	77398	77399
18153	24823	49	applied	\N	\N	\N	\N	77404	77404	77405
18153	24825	50	applied	\N	\N	\N	\N	77412	77412	77413
18153	24829	51	applied	\N	\N	\N	\N	77420	77420	77421
18153	24830	52	applied	\N	\N	\N	\N	77422	77422	77423
18153	24831	53	applied	\N	\N	\N	\N	77424	77424	77425
18153	24832	54	applied	\N	\N	\N	\N	77426	77426	77427
18153	24718	55	applied	\N	\N	\N	\N	77029	77029	77030
18153	24827	56	applied	\N	\N	\N	\N	77416	77416	77451
18153	24835	57	applied	\N	\N	\N	\N	77432	77432	77040
18153	24836	58	applied	\N	\N	\N	\N	77434	77434	77452
18153	24839	59	applied	\N	\N	\N	\N	77440	77440	77052
18153	24840	60	applied	\N	\N	\N	\N	77442	77442	77453
18153	24719	61	applied	\N	\N	\N	\N	77031	77031	77054
18153	24725	62	applied	\N	\N	\N	\N	77049	77049	77454
18153	24734	64	applied	\N	\N	\N	\N	77087	77087	77456
18153	24721	65	applied	\N	\N	\N	\N	77039	77039	77457
18153	24726	66	applied	\N	\N	\N	\N	77051	77051	77458
18153	24727	67	applied	\N	\N	\N	\N	77053	77053	77459
18153	24728	68	applied	\N	\N	\N	\N	77055	77055	77460
18153	24730	69	applied	\N	\N	\N	\N	77069	77069	77461
18153	24733	70	applied	\N	\N	\N	\N	77085	77085	77111
18153	24736	71	applied	\N	\N	\N	\N	77096	77096	77117
18153	24738	72	applied	\N	\N	\N	\N	77102	77102	77121
18153	24740	73	applied	\N	\N	\N	\N	77108	77108	77127
18153	24743	74	applied	\N	\N	\N	\N	77116	77116	77135
18153	24745	75	applied	\N	\N	\N	\N	77120	77120	77137
18153	24747	76	applied	\N	\N	\N	\N	77126	77126	77195
18153	24750	77	applied	\N	\N	\N	\N	77134	77134	77196
18153	24741	78	applied	\N	\N	\N	\N	77110	77110	77462
18153	24753	79	applied	\N	\N	\N	\N	77141	77141	77153
18153	24755	80	applied	\N	\N	\N	\N	77148	77148	77197
18153	24762	81	applied	\N	\N	\N	\N	77171	77171	77463
18153	24773	82	applied	\N	\N	\N	\N	77213	77213	77158
18153	24778	83	applied	\N	\N	\N	\N	77226	77226	77172
18153	24786	84	applied	\N	\N	\N	\N	77247	77247	77464
18153	24792	85	applied	\N	\N	\N	\N	77271	77271	77465
18153	24802	86	applied	\N	\N	\N	\N	77297	77297	77174
18153	24809	87	applied	\N	\N	\N	\N	77364	77364	77466
18153	24820	88	applied	\N	\N	\N	\N	77393	77393	77467
18153	24824	89	applied	\N	\N	\N	\N	77406	77406	77180
18153	24837	90	applied	\N	\N	\N	\N	77436	77436	77468
18153	24751	91	applied	\N	\N	\N	\N	77136	77136	77469
18153	24756	92	applied	\N	\N	\N	\N	77150	77150	77214
18153	24757	93	applied	\N	\N	\N	\N	77152	77152	77216
18153	24759	94	applied	\N	\N	\N	\N	77157	77157	77218
18153	24763	95	applied	\N	\N	\N	\N	77173	77173	77220
18153	24765	96	applied	\N	\N	\N	\N	77179	77179	77470
18153	24771	97	applied	\N	\N	\N	\N	77209	77209	77471
18153	24772	98	applied	\N	\N	\N	\N	77211	77211	77472
18153	24774	99	applied	\N	\N	\N	\N	77215	77215	77473
18153	24775	100	applied	\N	\N	\N	\N	77217	77217	77474
18153	24776	101	applied	\N	\N	\N	\N	77219	77219	77272
18153	24779	102	applied	\N	\N	\N	\N	77228	77228	77274
18153	24782	103	applied	\N	\N	\N	\N	77238	77238	77276
18153	24783	104	applied	\N	\N	\N	\N	77240	77240	77278
18153	24787	105	applied	\N	\N	\N	\N	77249	77249	77288
18153	24788	106	applied	\N	\N	\N	\N	77251	77251	77290
18153	24793	107	applied	\N	\N	\N	\N	77273	77273	77296
18153	24794	108	applied	\N	\N	\N	\N	77275	77275	77475
18153	24795	109	applied	\N	\N	\N	\N	77277	77277	77476
18153	24798	110	applied	\N	\N	\N	\N	77287	77287	77477
18153	24799	111	applied	\N	\N	\N	\N	77289	77289	77478
18153	24801	112	applied	\N	\N	\N	\N	77295	77295	77479
18153	24804	113	applied	\N	\N	\N	\N	77304	77304	77480
18153	24808	114	applied	\N	\N	\N	\N	77362	77362	77481
18153	24810	115	applied	\N	\N	\N	\N	77366	77366	77482
18153	24811	116	applied	\N	\N	\N	\N	77368	77368	77394
18153	24813	117	applied	\N	\N	\N	\N	77376	77376	77401
18153	24815	118	applied	\N	\N	\N	\N	77382	77382	77483
18153	24818	119	applied	\N	\N	\N	\N	77389	77389	77417
18153	24819	120	applied	\N	\N	\N	\N	77391	77391	77431
18153	24822	121	applied	\N	\N	\N	\N	77400	77400	77484
18153	24826	122	applied	\N	\N	\N	\N	77414	77414	77485
18153	24834	123	applied	\N	\N	\N	\N	77430	77430	77486
18153	24838	124	applied	\N	\N	\N	\N	77438	77438	77443
18153	24841	125	applied	\N	\N	\N	\N	77445	77445	77446
18156	24843	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77492	77492	\N
18156	24844	1	applied	\N	\N	\N	\N	77493	77493	77494
18156	24845	2	applied	\N	\N	\N	\N	77495	77495	77496
18156	24846	3	applied	\N	\N	\N	\N	77497	77497	77498
18156	24847	4	applied	\N	\N	\N	\N	77499	77499	77500
18156	24848	5	applied	\N	\N	\N	\N	77501	77501	77502
18156	24849	6	applied	\N	\N	\N	\N	77503	77503	77504
18156	24850	7	applied	\N	\N	\N	\N	77505	77505	77506
18156	24851	8	applied	\N	\N	\N	\N	77507	77507	77508
18156	24852	9	applied	\N	\N	\N	\N	77509	77509	77510
18156	24853	10	applied	\N	\N	\N	\N	77511	77511	77512
18156	24854	11	applied	\N	\N	\N	\N	77513	77513	77514
18156	24855	12	applied	\N	\N	\N	\N	77515	77515	77516
18156	24856	13	applied	\N	\N	\N	\N	77517	77517	77518
18166	24883	0	applied	\N	\N	\N	\N	77584	77584	77585
18166	24884	1	applied	\N	\N	\N	\N	77586	77586	77587
18166	24885	2	applied	\N	\N	\N	\N	77588	77588	77589
18154	24828	0	applied	\N	\N	\N	\N	77419	77419	77419
18154	24829	1	applied	\N	\N	\N	\N	77420	77420	77421
18154	24830	2	applied	\N	\N	\N	\N	77422	77422	77423
18154	24831	3	applied	\N	\N	\N	\N	77424	77424	77425
18154	24832	4	applied	\N	\N	\N	\N	77426	77426	77427
18154	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18154	24834	6	applied	\N	\N	\N	\N	77430	77430	77431
18154	24835	7	applied	\N	\N	\N	\N	77432	77432	77433
18154	24836	8	applied	\N	\N	\N	\N	77434	77434	77435
18154	24837	9	applied	\N	\N	\N	\N	77436	77436	77437
18154	24838	10	applied	\N	\N	\N	\N	77438	77438	77439
18154	24839	11	applied	\N	\N	\N	\N	77440	77440	77441
18154	24840	12	applied	\N	\N	\N	\N	77442	77442	77443
18154	24841	14	applied	\N	\N	\N	\N	77445	77445	77446
18154	24842	15	applied	\N	\N	\N	\N	77447	77447	77448
18155	24843	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77492	77492	\N
18155	24844	1	applied	\N	\N	\N	\N	77493	77493	77494
18155	24845	2	applied	\N	\N	\N	\N	77495	77495	77496
18155	24846	3	applied	\N	\N	\N	\N	77497	77497	77498
18155	24847	4	applied	\N	\N	\N	\N	77499	77499	77500
18155	24848	5	applied	\N	\N	\N	\N	77501	77501	77502
18155	24849	6	applied	\N	\N	\N	\N	77503	77503	77504
18155	24850	7	applied	\N	\N	\N	\N	77505	77505	77506
18155	24851	8	applied	\N	\N	\N	\N	77507	77507	77508
18155	24852	9	applied	\N	\N	\N	\N	77509	77509	77510
18155	24853	10	applied	\N	\N	\N	\N	77511	77511	77512
18155	24854	11	applied	\N	\N	\N	\N	77513	77513	77514
18155	24855	12	applied	\N	\N	\N	\N	77515	77515	77516
18155	24856	13	applied	\N	\N	\N	\N	77517	77517	77518
18160	24864	0	applied	\N	\N	\N	\N	77541	77541	77542
18160	24865	1	applied	\N	\N	\N	\N	77543	77543	77544
18160	24866	2	applied	\N	\N	\N	\N	77545	77545	77546
18160	24867	3	applied	\N	\N	\N	\N	77547	77547	77548
18160	24868	4	applied	\N	\N	\N	\N	77549	77549	77550
18160	24869	5	applied	\N	\N	\N	\N	77551	77551	77552
18165	24880	0	applied	\N	\N	\N	\N	77576	77576	77577
18165	24881	1	applied	\N	\N	\N	\N	77578	77578	77579
18165	24882	2	applied	\N	\N	\N	\N	77580	77580	77581
18168	24890	0	applied	\N	\N	\N	\N	77600	77600	77601
18168	24891	1	applied	\N	\N	\N	\N	77602	77602	77603
18168	24892	2	applied	\N	\N	\N	\N	77604	77604	77605
18168	24893	3	applied	\N	\N	\N	\N	77606	77606	77607
18168	24894	4	applied	\N	\N	\N	\N	77608	77608	77609
18168	24895	5	applied	\N	\N	\N	\N	77610	77610	77611
18168	24896	6	applied	\N	\N	\N	\N	77612	77612	77613
18168	24897	7	applied	\N	\N	\N	\N	77614	77614	77615
18168	24898	8	applied	\N	\N	\N	\N	77616	77616	77617
18168	24899	9	applied	\N	\N	\N	\N	77618	77618	77619
18171	24903	0	applied	\N	\N	\N	\N	77632	77632	77633
18171	24904	1	applied	\N	\N	\N	\N	77634	77634	77635
18171	24905	2	applied	\N	\N	\N	\N	77636	77636	77637
18171	24906	3	applied	\N	\N	\N	\N	77638	77638	77639
18171	24907	4	applied	\N	\N	\N	\N	77640	77640	77641
18171	24908	5	applied	\N	\N	\N	\N	77642	77642	77643
18174	24913	0	applied	\N	\N	\N	\N	77658	77658	77659
18174	24914	1	applied	\N	\N	\N	\N	77660	77660	77661
18174	24915	2	applied	\N	\N	\N	\N	77662	77662	77663
18174	24916	3	applied	\N	\N	\N	\N	77664	77664	77665
18174	24917	4	applied	\N	\N	\N	\N	77666	77666	77667
18179	24929	0	applied	\N	\N	\N	\N	77696	77696	77697
18179	24930	1	applied	\N	\N	\N	\N	77698	77698	77699
18186	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18186	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18186	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18186	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18186	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18197	24939	0	applied	\N	\N	\N	\N	77747	77747	77748
18197	24940	1	applied	\N	\N	\N	\N	77749	77749	77750
18199	24939	0	applied	\N	\N	\N	\N	77747	77747	77748
18199	24941	1	applied	\N	\N	\N	\N	77753	77753	77754
18199	24940	2	applied	\N	\N	\N	\N	77749	77749	77750
18199	24942	3	applied	\N	\N	\N	\N	77755	77755	77756
18208	24951	0	applied	\N	\N	\N	\N	77782	77782	77783
18210	24952	0	applied	\N	\N	\N	\N	77785	77785	77786
18210	24953	1	applied	\N	\N	\N	\N	77787	77787	77788
18210	24951	2	applied	\N	\N	\N	\N	77782	77782	77783
18211	24952	0	applied	\N	\N	\N	\N	77785	77785	77786
18211	24953	1	applied	\N	\N	\N	\N	77787	77787	77788
18211	24954	2	applied	\N	\N	\N	\N	77791	77791	77792
18211	24955	3	applied	\N	\N	\N	\N	77793	77793	77794
18211	24956	4	applied	\N	\N	\N	\N	77795	77795	77796
18211	24957	5	applied	\N	\N	\N	\N	77797	77797	77798
18211	24958	6	applied	\N	\N	\N	\N	77799	77799	77800
18211	24959	7	applied	\N	\N	\N	\N	77801	77801	77802
18211	24960	8	applied	\N	\N	\N	\N	77803	77803	77804
18211	24961	9	applied	\N	\N	\N	\N	77805	77805	77805
18213	24952	0	applied	\N	\N	\N	\N	77785	77785	77786
18213	24953	1	applied	\N	\N	\N	\N	77787	77787	77788
18213	24954	2	applied	\N	\N	\N	\N	77791	77791	77792
18213	24955	3	applied	\N	\N	\N	\N	77793	77793	77794
18213	24956	4	applied	\N	\N	\N	\N	77795	77795	77796
18213	24957	5	applied	\N	\N	\N	\N	77797	77797	77798
18213	24958	6	applied	\N	\N	\N	\N	77799	77799	77800
18213	24959	7	applied	\N	\N	\N	\N	77801	77801	77802
18213	24960	8	applied	\N	\N	\N	\N	77803	77803	77804
18213	24961	9	applied	\N	\N	\N	\N	77805	77805	77805
18215	24962	0	applied	\N	\N	\N	\N	77810	77810	77811
18215	24963	1	applied	\N	\N	\N	\N	77812	77812	77813
18215	24964	2	applied	\N	\N	\N	\N	77814	77814	77814
18215	24965	3	applied	\N	\N	\N	\N	77815	77815	77816
18224	24973	0	applied	\N	\N	\N	\N	77845	77845	77846
18224	24974	1	applied	\N	\N	\N	\N	77847	77847	77848
18224	24975	2	applied	\N	\N	\N	\N	77849	77849	77850
18224	24976	3	applied	\N	\N	\N	\N	77851	77851	77852
18224	24977	4	applied	\N	\N	\N	\N	77853	77853	77854
18229	24985	0	applied	\N	\N	\N	\N	77914	77914	77915
18229	24986	1	applied	\N	\N	\N	\N	77916	77916	77917
18229	24987	2	applied	\N	\N	\N	\N	77918	77918	77919
18238	24996	0	applied	\N	\N	\N	\N	77953	77953	77954
18238	24997	1	applied	\N	\N	\N	\N	77955	77955	77956
18240	24996	0	applied	\N	\N	\N	\N	77953	77953	77954
18240	24997	1	applied	\N	\N	\N	\N	77955	77955	77956
18245	25003	0	applied	\N	\N	\N	\N	77976	77976	77977
18245	25004	1	applied	\N	\N	\N	\N	77978	77978	77979
18248	25014	0	applied	\N	\N	\N	\N	78002	78002	78003
18248	25015	1	applied	\N	\N	\N	\N	78004	78004	78005
18248	25016	2	applied	\N	\N	\N	\N	78006	78006	78007
18251	25017	0	applied	\N	\N	\N	\N	78010	78010	78011
18251	25018	1	applied	\N	\N	\N	\N	78012	78012	78013
18157	24857	0	applied	\N	\N	\N	\N	77521	77521	77522
18157	24858	1	applied	\N	\N	\N	\N	77523	77523	77524
18157	24859	2	applied	\N	\N	\N	\N	77525	77525	77526
18157	24860	3	applied	\N	\N	\N	\N	77527	77527	77528
18157	24861	4	applied	\N	\N	\N	\N	77529	77529	77530
18157	24862	5	applied	\N	\N	\N	\N	77531	77531	77532
18157	24863	6	applied	\N	\N	\N	\N	77533	77533	77534
18159	24857	0	applied	\N	\N	\N	\N	77521	77521	77522
18159	24858	1	applied	\N	\N	\N	\N	77523	77523	77524
18159	24859	2	applied	\N	\N	\N	\N	77525	77525	77526
18159	24860	3	applied	\N	\N	\N	\N	77527	77527	77528
18159	24861	4	applied	\N	\N	\N	\N	77529	77529	77530
18159	24862	5	applied	\N	\N	\N	\N	77531	77531	77532
18159	24863	6	applied	\N	\N	\N	\N	77533	77533	77534
18162	24870	0	applied	\N	\N	\N	\N	77554	77554	77555
18162	24871	1	applied	\N	\N	\N	\N	77556	77556	77557
18162	24872	2	applied	\N	\N	\N	\N	77558	77558	77559
18162	24873	3	applied	\N	\N	\N	\N	77560	77560	77561
18164	24874	0	applied	\N	\N	\N	\N	77567	77567	77568
18164	24875	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77569	77569	\N
18164	24876	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	77570	77570	\N
18164	24877	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	77571	77571	\N
18164	24878	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	77572	77572	\N
18164	24879	5	applied	\N	\N	\N	\N	77573	77573	77574
18167	24887	0	applied	\N	\N	\N	\N	77593	77593	77594
18167	24888	1	applied	\N	\N	\N	\N	77595	77595	77596
18167	24889	2	applied	\N	\N	\N	\N	77597	77597	77598
18170	24900	0	applied	\N	\N	\N	\N	77622	77622	77623
18170	24901	1	applied	\N	\N	\N	\N	77624	77624	77625
18170	24902	2	applied	\N	\N	\N	\N	77626	77626	77627
18173	24909	0	applied	\N	\N	\N	\N	77648	77648	77649
18173	24910	1	applied	\N	\N	\N	\N	77650	77650	77651
18173	24911	2	applied	\N	\N	\N	\N	77652	77652	77653
18173	24912	3	applied	\N	\N	\N	\N	77654	77654	77655
18181	24931	0	applied	\N	\N	\N	\N	77702	77702	77703
18181	24932	1	applied	\N	\N	\N	\N	77704	77704	77705
18181	24933	2	applied	\N	\N	\N	\N	77706	77706	77707
18195	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18195	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18195	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18195	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18195	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18201	24943	0	applied	\N	\N	\N	\N	77760	77760	77761
18201	24944	1	applied	\N	\N	\N	\N	77762	77762	77763
18203	24945	0	applied	\N	\N	\N	\N	77768	77768	77769
18203	24946	1	applied	\N	\N	\N	\N	77770	77770	30431
18203	24947	2	applied	\N	\N	\N	\N	77771	77771	77771
18203	24948	3	applied	\N	\N	\N	\N	77772	77772	77771
18203	24949	4	applied	\N	\N	\N	\N	77773	77773	77774
18203	24950	5	applied	\N	\N	\N	\N	77775	77775	77776
18223	24760	0	applied	\N	\N	\N	\N	77161	77161	77162
18223	24828	1	applied	\N	\N	\N	\N	77419	77419	77419
18223	24833	2	applied	\N	\N	1000000000	\N	77428	77428	77429
18223	24761	3	applied	\N	\N	\N	\N	77169	77169	77170
18223	24764	4	applied	\N	\N	\N	\N	77177	77177	77178
18223	24766	5	applied	\N	\N	\N	\N	77199	77199	77200
18223	24767	6	applied	\N	\N	\N	\N	77201	77201	77202
18223	24768	7	applied	\N	\N	\N	\N	77203	77203	77204
18223	24769	8	applied	\N	\N	\N	\N	77205	77205	77206
18223	24770	9	applied	\N	\N	\N	\N	77207	77207	77208
18223	24777	10	applied	\N	\N	\N	\N	77224	77224	77225
18223	24780	11	applied	\N	\N	\N	\N	77234	77234	77235
18223	24781	12	applied	\N	\N	\N	\N	77236	77236	77237
18223	24784	13	applied	\N	\N	\N	\N	77243	77243	77244
18223	24785	14	applied	\N	\N	\N	\N	77245	77245	77246
18223	24789	15	applied	\N	\N	\N	\N	77265	77265	77266
18223	24790	16	applied	\N	\N	\N	\N	77267	77267	77268
18223	24791	17	applied	\N	\N	\N	\N	77269	77269	77270
18223	24796	18	applied	\N	\N	\N	\N	77283	77283	77284
18223	24797	19	applied	\N	\N	\N	\N	77285	77285	77286
18223	24800	20	applied	\N	\N	\N	\N	77293	77293	77294
18223	24803	21	applied	\N	\N	\N	\N	77302	77302	77303
18223	24805	22	applied	\N	\N	\N	\N	77356	77356	77357
18223	24806	23	applied	\N	\N	\N	\N	77358	77358	77359
18223	24807	24	applied	\N	\N	\N	\N	77360	77360	77361
18223	24812	25	applied	\N	\N	\N	\N	77374	77374	77375
18223	24814	26	applied	\N	\N	\N	\N	77380	77380	77381
18223	24816	27	applied	\N	\N	\N	\N	77385	77385	77386
18223	24817	28	applied	\N	\N	\N	\N	77387	77387	77388
18223	24821	29	applied	\N	\N	\N	\N	77398	77398	77399
18223	24823	30	applied	\N	\N	\N	\N	77404	77404	77405
18223	24825	31	applied	\N	\N	\N	\N	77412	77412	77413
18223	24829	32	applied	\N	\N	\N	\N	77420	77420	77421
18223	24830	33	applied	\N	\N	\N	\N	77422	77422	77423
18223	24831	34	applied	\N	\N	\N	\N	77424	77424	77425
18223	24832	35	applied	\N	\N	\N	\N	77426	77426	77427
18223	24844	36	applied	\N	\N	\N	\N	77493	77493	77494
18223	24845	37	applied	\N	\N	\N	\N	77495	77495	77496
18223	24846	38	applied	\N	\N	\N	\N	77497	77497	77498
18223	24847	39	applied	\N	\N	\N	\N	77499	77499	77500
18223	24857	40	applied	\N	\N	\N	\N	77521	77521	77522
18223	24858	41	applied	\N	\N	\N	\N	77523	77523	77524
18223	24864	42	applied	\N	\N	\N	\N	77541	77541	77542
18223	24865	43	applied	\N	\N	\N	\N	77543	77543	77544
18223	24870	44	applied	\N	\N	\N	\N	77554	77554	77555
18223	24874	45	applied	\N	\N	\N	\N	77567	77567	77568
18223	24880	46	applied	\N	\N	\N	\N	77576	77576	77577
18223	24883	47	applied	\N	\N	\N	\N	77584	77584	77585
18223	24887	48	applied	\N	\N	\N	\N	77593	77593	77594
18223	24890	49	applied	\N	\N	\N	\N	77600	77600	77601
18223	24891	50	applied	\N	\N	\N	\N	77602	77602	77603
18223	24892	51	applied	\N	\N	\N	\N	77604	77604	77605
18223	24900	52	applied	\N	\N	\N	\N	77622	77622	77623
18223	24903	53	applied	\N	\N	\N	\N	77632	77632	77633
18223	24904	54	applied	\N	\N	\N	\N	77634	77634	77635
18223	24909	55	applied	\N	\N	\N	\N	77648	77648	77649
18223	24910	56	applied	\N	\N	\N	\N	77650	77650	77651
18223	24913	57	applied	\N	\N	\N	\N	77658	77658	77659
18223	24914	58	applied	\N	\N	\N	\N	77660	77660	77661
18223	24920	59	applied	\N	\N	\N	\N	77674	77674	77675
18226	24978	0	applied	\N	\N	\N	\N	77856	77856	77857
18226	24979	1	applied	\N	\N	\N	\N	77858	77858	77859
18226	24980	2	applied	\N	\N	\N	\N	77860	77860	77861
18228	24981	0	applied	\N	\N	\N	\N	77905	77905	77906
18228	24982	1	applied	\N	\N	\N	\N	77907	77907	77908
18228	24983	2	applied	\N	\N	\N	\N	77909	77909	77910
18228	24984	3	applied	\N	\N	\N	\N	77911	77911	77912
18231	24990	0	applied	\N	\N	\N	\N	77926	77926	77927
18158	24857	0	applied	\N	\N	\N	\N	77521	77521	77522
18158	24858	1	applied	\N	\N	\N	\N	77523	77523	77524
18158	24859	2	applied	\N	\N	\N	\N	77525	77525	77526
18158	24860	3	applied	\N	\N	\N	\N	77527	77527	77528
18158	24861	4	applied	\N	\N	\N	\N	77529	77529	77530
18158	24862	5	applied	\N	\N	\N	\N	77531	77531	77532
18158	24863	6	applied	\N	\N	\N	\N	77533	77533	77534
18161	24870	0	applied	\N	\N	\N	\N	77554	77554	77555
18161	24871	1	applied	\N	\N	\N	\N	77556	77556	77557
18161	24872	2	applied	\N	\N	\N	\N	77558	77558	77559
18161	24873	3	applied	\N	\N	\N	\N	77560	77560	77561
18163	24870	0	applied	\N	\N	\N	\N	77554	77554	77555
18163	24871	1	applied	\N	\N	\N	\N	77556	77556	77557
18163	24872	2	applied	\N	\N	\N	\N	77558	77558	77559
18163	24873	3	applied	\N	\N	\N	\N	77560	77560	77561
18169	24900	0	applied	\N	\N	\N	\N	77622	77622	77623
18169	24901	1	applied	\N	\N	\N	\N	77624	77624	77625
18169	24902	2	applied	\N	\N	\N	\N	77626	77626	77627
18178	24929	0	applied	\N	\N	\N	\N	77696	77696	77697
18178	24930	1	applied	\N	\N	\N	\N	77698	77698	77699
18180	24931	0	applied	\N	\N	\N	\N	77702	77702	77703
18180	24932	1	applied	\N	\N	\N	\N	77704	77704	77705
18180	24933	2	applied	\N	\N	\N	\N	77706	77706	77707
18182	24931	0	applied	\N	\N	\N	\N	77702	77702	77703
18182	24932	1	applied	\N	\N	\N	\N	77704	77704	77705
18182	24933	2	applied	\N	\N	\N	\N	77706	77706	77707
18187	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18187	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18187	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18187	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18187	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18189	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18189	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18189	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18189	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18189	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18192	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18192	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18192	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18192	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18192	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18193	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18193	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18193	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18193	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18193	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18196	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18196	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18196	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18196	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18196	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18198	24939	0	applied	\N	\N	\N	\N	77747	77747	77748
18198	24940	1	applied	\N	\N	\N	\N	77749	77749	77750
18202	24939	0	applied	\N	\N	\N	\N	77747	77747	77748
18202	24941	1	applied	\N	\N	\N	\N	77753	77753	77754
18202	24943	2	applied	\N	\N	\N	\N	77760	77760	77761
18202	24940	3	applied	\N	\N	\N	\N	77749	77749	77750
18202	24942	4	applied	\N	\N	\N	\N	77755	77755	77756
18202	24944	5	applied	\N	\N	\N	\N	77762	77762	77763
18204	24945	0	applied	\N	\N	\N	\N	77768	77768	77769
18204	24946	1	applied	\N	\N	\N	\N	77770	77770	30431
18204	24947	2	applied	\N	\N	\N	\N	77771	77771	77771
18204	24948	3	applied	\N	\N	\N	\N	77772	77772	77771
18204	24949	4	applied	\N	\N	\N	\N	77773	77773	77774
18204	24950	5	applied	\N	\N	\N	\N	77775	77775	77776
18206	24945	0	applied	\N	\N	\N	\N	77768	77768	77769
18206	24946	1	applied	\N	\N	\N	\N	77770	77770	30431
18206	24947	2	applied	\N	\N	\N	\N	77771	77771	77771
18206	24948	3	applied	\N	\N	\N	\N	77772	77772	77771
18206	24949	4	applied	\N	\N	\N	\N	77773	77773	77774
18206	24950	5	applied	\N	\N	\N	\N	77775	77775	77776
18216	24962	0	applied	\N	\N	\N	\N	77810	77810	77811
18216	24963	1	applied	\N	\N	\N	\N	77812	77812	77813
18216	24964	2	applied	\N	\N	\N	\N	77814	77814	77814
18216	24965	3	applied	\N	\N	\N	\N	77815	77815	77816
18218	24966	0	applied	\N	\N	\N	\N	77821	77821	77822
18218	24967	1	applied	\N	\N	\N	\N	77823	77823	77824
18218	24968	2	applied	\N	\N	\N	\N	77825	77825	77825
18218	24969	3	applied	\N	\N	\N	\N	77826	77826	77826
18218	24970	4	applied	\N	\N	\N	\N	77827	77827	77827
18220	24971	0	applied	\N	\N	\N	\N	77832	77832	77833
18220	24972	1	applied	\N	\N	\N	\N	77834	77834	77835
18222	24663	0	applied	\N	\N	1000000000	\N	76879	76879	76880
18222	24675	1	applied	\N	\N	\N	\N	76913	76913	76914
18222	24691	2	applied	\N	\N	\N	\N	76957	76957	70512
18222	24686	3	applied	\N	\N	\N	\N	76941	76941	47675
18222	24828	4	applied	\N	\N	\N	\N	77419	77419	77419
18222	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18222	24946	6	applied	\N	\N	\N	\N	77840	77840	30431
18222	24947	7	applied	\N	\N	\N	\N	77771	77771	77771
18222	24948	8	applied	\N	\N	\N	\N	77772	77772	77771
18222	24961	9	applied	\N	\N	\N	\N	77805	77805	77805
18222	24964	10	applied	\N	\N	\N	\N	77814	77814	77814
18222	24968	11	applied	\N	\N	\N	\N	77825	77825	77825
18222	24969	12	applied	\N	\N	\N	\N	77826	77826	77826
18222	24970	13	applied	\N	\N	\N	\N	77827	77827	77827
18225	24978	0	applied	\N	\N	\N	\N	77856	77856	77857
18225	24979	1	applied	\N	\N	\N	\N	77858	77858	77859
18225	24980	2	applied	\N	\N	\N	\N	77860	77860	77861
18227	24828	0	applied	\N	\N	\N	\N	77419	77419	77419
18227	24829	1	applied	\N	\N	\N	\N	77420	77420	77421
18227	24830	2	applied	\N	\N	\N	\N	77422	77422	77423
18227	24831	3	applied	\N	\N	\N	\N	77424	77424	77425
18227	24832	4	applied	\N	\N	\N	\N	77426	77426	77427
18227	24833	5	applied	\N	\N	1000000000	\N	77428	77428	77429
18227	24844	6	applied	\N	\N	\N	\N	77493	77493	77494
18227	24845	7	applied	\N	\N	\N	\N	77495	77495	77496
18227	24846	8	applied	\N	\N	\N	\N	77497	77497	77498
18227	24847	9	applied	\N	\N	\N	\N	77499	77499	77500
18227	24857	10	applied	\N	\N	\N	\N	77521	77521	77522
18227	24858	11	applied	\N	\N	\N	\N	77523	77523	77524
18227	24864	12	applied	\N	\N	\N	\N	77541	77541	77542
18227	24865	14	applied	\N	\N	\N	\N	77543	77543	77544
18227	24870	15	applied	\N	\N	\N	\N	77554	77554	77555
18227	24874	16	applied	\N	\N	\N	\N	77567	77567	77568
18227	24880	17	applied	\N	\N	\N	\N	77576	77576	77577
18227	24883	18	applied	\N	\N	\N	\N	77584	77584	77585
18227	24887	19	applied	\N	\N	\N	\N	77593	77593	77594
18227	24890	20	applied	\N	\N	\N	\N	77600	77600	77601
18166	24886	3	applied	\N	\N	\N	\N	77590	77590	77591
18172	24903	0	applied	\N	\N	\N	\N	77632	77632	77633
18172	24904	1	applied	\N	\N	\N	\N	77634	77634	77635
18172	24905	2	applied	\N	\N	\N	\N	77636	77636	77637
18172	24906	3	applied	\N	\N	\N	\N	77638	77638	77639
18172	24907	4	applied	\N	\N	\N	\N	77640	77640	77641
18172	24908	5	applied	\N	\N	\N	\N	77642	77642	77643
18175	24913	0	applied	\N	\N	\N	\N	77658	77658	77659
18175	24914	1	applied	\N	\N	\N	\N	77660	77660	77661
18175	24915	2	applied	\N	\N	\N	\N	77662	77662	77663
18175	24916	3	applied	\N	\N	\N	\N	77664	77664	77665
18175	24917	4	applied	\N	\N	\N	\N	77666	77666	77667
18176	24918	0	applied	\N	\N	\N	\N	77672	77672	77672
18176	24919	1	applied	\N	\N	\N	\N	77673	77673	77673
18176	24920	2	applied	\N	\N	\N	\N	77674	77674	77675
18176	24921	3	applied	\N	\N	\N	\N	77676	77676	77677
18176	24922	4	applied	\N	\N	\N	\N	77678	77678	77679
18176	24923	5	applied	\N	\N	\N	\N	77680	77680	77681
18176	24924	6	applied	\N	\N	\N	\N	77682	77682	77683
18176	24925	7	applied	\N	\N	\N	\N	77684	77684	77685
18176	24926	8	applied	\N	\N	\N	\N	77686	77686	77687
18176	24927	9	applied	\N	\N	\N	\N	77688	77688	77689
18176	24928	10	applied	\N	\N	\N	\N	77690	77690	77691
18185	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18185	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18185	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18185	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18185	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18188	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18188	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18188	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18188	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18188	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18190	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18190	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18190	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18190	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18190	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18194	24934	0	applied	\N	\N	\N	\N	77713	77713	77714
18194	24935	1	applied	\N	\N	\N	\N	77715	77715	77716
18194	24936	2	applied	\N	\N	\N	\N	77717	77717	77718
18194	24937	3	applied	\N	\N	\N	\N	77719	77719	77720
18194	24938	4	applied	\N	\N	\N	\N	77721	77721	77722
18200	24939	0	applied	\N	\N	\N	\N	77747	77747	77748
18200	24941	1	applied	\N	\N	\N	\N	77753	77753	77754
18200	24940	2	applied	\N	\N	\N	\N	77749	77749	77750
18200	24942	3	applied	\N	\N	\N	\N	77755	77755	77756
18205	24945	0	applied	\N	\N	\N	\N	77768	77768	77769
18205	24946	1	applied	\N	\N	\N	\N	77770	77770	30431
18205	24947	2	applied	\N	\N	\N	\N	77771	77771	77771
18205	24948	3	applied	\N	\N	\N	\N	77772	77772	77771
18205	24949	4	applied	\N	\N	\N	\N	77773	77773	77774
18205	24950	5	applied	\N	\N	\N	\N	77775	77775	77776
18209	24952	0	applied	\N	\N	\N	\N	77785	77785	77786
18209	24953	1	applied	\N	\N	\N	\N	77787	77787	77788
18209	24951	2	applied	\N	\N	\N	\N	77782	77782	77783
18212	24952	0	applied	\N	\N	\N	\N	77785	77785	77786
18212	24953	1	applied	\N	\N	\N	\N	77787	77787	77788
18212	24961	2	applied	\N	\N	\N	\N	77805	77805	77805
18214	24962	0	applied	\N	\N	\N	\N	77810	77810	77811
18214	24963	1	applied	\N	\N	\N	\N	77812	77812	77813
18214	24964	2	applied	\N	\N	\N	\N	77814	77814	77814
18214	24965	3	applied	\N	\N	\N	\N	77815	77815	77816
18219	24966	0	applied	\N	\N	\N	\N	77821	77821	77822
18219	24967	1	applied	\N	\N	\N	\N	77823	77823	77824
18219	24968	2	applied	\N	\N	\N	\N	77825	77825	77825
18219	24969	3	applied	\N	\N	\N	\N	77826	77826	77826
18219	24970	4	applied	\N	\N	\N	\N	77827	77827	77827
18221	24971	0	applied	\N	\N	\N	\N	77832	77832	77833
18221	24972	1	applied	\N	\N	\N	\N	77834	77834	77835
18230	24988	0	applied	\N	\N	\N	\N	77921	77921	77922
18230	24989	1	applied	\N	\N	\N	\N	77923	77923	77924
18235	24994	0	applied	\N	\N	\N	\N	77944	77944	77945
18237	24995	0	applied	\N	\N	\N	\N	77948	77948	77949
18237	24994	1	applied	\N	\N	\N	\N	77944	77944	77945
18239	24996	0	applied	\N	\N	\N	\N	77953	77953	77954
18239	24997	1	applied	\N	\N	\N	\N	77955	77955	77956
18244	25003	0	applied	\N	\N	\N	\N	77976	77976	77977
18244	25004	1	applied	\N	\N	\N	\N	77978	77978	77979
18246	25005	0	applied	\N	\N	\N	\N	77981	77981	77982
18246	25006	1	applied	\N	\N	\N	\N	77983	77983	77984
18247	25007	0	applied	\N	\N	\N	\N	77987	77987	77988
18247	25008	1	applied	\N	\N	\N	\N	77989	77989	77990
18247	25009	2	applied	\N	\N	\N	\N	77991	77991	77992
18247	25010	3	applied	\N	\N	\N	\N	77993	77993	77994
18247	25011	4	applied	\N	\N	\N	\N	77995	77995	77996
18247	25012	5	applied	\N	\N	\N	\N	77997	77997	77998
18247	25013	6	applied	\N	\N	\N	\N	77999	77999	78000
18250	24992	0	applied	\N	\N	\N	\N	77938	77938	77939
18250	24995	1	applied	\N	\N	\N	\N	77948	77948	77949
18250	24996	2	applied	\N	\N	\N	\N	77953	77953	77954
18250	24998	3	applied	\N	\N	\N	\N	77961	77961	77962
18250	24999	4	applied	\N	\N	\N	\N	77963	77963	77964
18250	25003	5	applied	\N	\N	\N	\N	77976	77976	77977
18250	25005	6	applied	\N	\N	\N	\N	77981	77981	77982
18250	25007	7	applied	\N	\N	\N	\N	77987	77987	77988
18250	25008	8	applied	\N	\N	\N	\N	77989	77989	77990
18250	25009	9	applied	\N	\N	\N	\N	77991	77991	77992
18250	25014	10	applied	\N	\N	\N	\N	78002	78002	78003
18250	25017	11	applied	\N	\N	\N	\N	78010	78010	78011
18250	24994	12	applied	\N	\N	\N	\N	77944	77944	78018
18250	24993	13	applied	\N	\N	\N	\N	77940	77940	77945
18250	25000	14	applied	\N	\N	\N	\N	77965	77965	78019
18250	25010	15	applied	\N	\N	\N	\N	77993	77993	78020
18250	25015	16	applied	\N	\N	\N	\N	78004	78004	77956
18250	24997	17	applied	\N	\N	\N	\N	77955	77955	78021
18250	25001	18	applied	\N	\N	\N	\N	77967	77967	78022
18250	25002	19	applied	\N	\N	\N	\N	77969	77969	78023
18250	25004	20	applied	\N	\N	\N	\N	77978	77978	78024
18250	25006	21	applied	\N	\N	\N	\N	77983	77983	78025
18250	25011	22	applied	\N	\N	\N	\N	77995	77995	78026
18250	25012	23	applied	\N	\N	\N	\N	77997	77997	78027
18250	25013	24	applied	\N	\N	\N	\N	77999	77999	78005
18250	25016	25	applied	\N	\N	\N	\N	78006	78006	78007
18250	25018	26	applied	\N	\N	\N	\N	78012	78012	78013
18256	25019	0	applied	\N	\N	\N	\N	78034	78034	78035
18256	25021	1	applied	\N	\N	\N	\N	78040	78040	78041
18256	25020	2	applied	\N	\N	\N	\N	78036	78036	78037
18256	25022	3	applied	\N	\N	\N	\N	78042	78042	78043
18260	25024	0	applied	\N	\N	\N	\N	78050	78050	78051
18227	24891	21	applied	\N	\N	\N	\N	77602	77602	77603
18227	24892	22	applied	\N	\N	\N	\N	77604	77604	77605
18227	24900	23	applied	\N	\N	\N	\N	77622	77622	77623
18227	24903	24	applied	\N	\N	\N	\N	77632	77632	77633
18227	24904	25	applied	\N	\N	\N	\N	77634	77634	77635
18227	24909	26	applied	\N	\N	\N	\N	77648	77648	77649
18227	24910	27	applied	\N	\N	\N	\N	77650	77650	77651
18227	24913	28	applied	\N	\N	\N	\N	77658	77658	77659
18227	24914	29	applied	\N	\N	\N	\N	77660	77660	77661
18227	24920	30	applied	\N	\N	\N	\N	77674	77674	77675
18227	24921	31	applied	\N	\N	\N	\N	77676	77676	77677
18227	24922	32	applied	\N	\N	\N	\N	77678	77678	77679
18227	24923	33	applied	\N	\N	\N	\N	77680	77680	77681
18227	24929	34	applied	\N	\N	\N	\N	77696	77696	77697
18227	24931	35	applied	\N	\N	\N	\N	77702	77702	77703
18227	24934	36	applied	\N	\N	\N	\N	77713	77713	77714
18227	24935	37	applied	\N	\N	\N	\N	77715	77715	77716
18227	24939	38	applied	\N	\N	\N	\N	77747	77747	77748
18227	24941	39	applied	\N	\N	\N	\N	77753	77753	77754
18227	24943	40	applied	\N	\N	\N	\N	77760	77760	77761
18227	24945	41	applied	\N	\N	\N	\N	77768	77768	77769
18227	24952	42	applied	\N	\N	\N	\N	77785	77785	77786
18227	24953	43	applied	\N	\N	\N	\N	77787	77787	77788
18227	24954	44	applied	\N	\N	\N	\N	77791	77791	77792
18227	24955	45	applied	\N	\N	\N	\N	77793	77793	77794
18227	24956	46	applied	\N	\N	\N	\N	77795	77795	77796
18227	24962	47	applied	\N	\N	\N	\N	77810	77810	77811
18227	24966	48	applied	\N	\N	\N	\N	77821	77821	77822
18227	24971	49	applied	\N	\N	\N	\N	77832	77832	77833
18227	24973	50	applied	\N	\N	\N	\N	77845	77845	77846
18227	24974	51	applied	\N	\N	\N	\N	77847	77847	77848
18227	24978	52	applied	\N	\N	\N	\N	77856	77856	77857
18227	24946	53	applied	\N	\N	\N	\N	77770	77770	30431
18227	24947	54	applied	\N	\N	\N	\N	77771	77771	77771
18227	24948	55	applied	\N	\N	\N	\N	77772	77772	77771
18227	24834	56	applied	\N	\N	\N	\N	77430	77430	77431
18227	24835	57	applied	\N	\N	\N	\N	77432	77432	77433
18227	24836	58	applied	\N	\N	\N	\N	77434	77434	77435
18227	24837	59	applied	\N	\N	\N	\N	77436	77436	77437
18227	24848	60	applied	\N	\N	\N	\N	77501	77501	77485
18227	24838	61	applied	\N	\N	\N	\N	77438	77438	77486
18227	24839	62	applied	\N	\N	\N	\N	77440	77440	77865
18227	24840	63	applied	\N	\N	\N	\N	77442	77442	77866
18227	24853	64	applied	\N	\N	\N	\N	77511	77511	77446
18227	24854	65	applied	\N	\N	\N	\N	77513	77513	77867
18227	24841	66	applied	\N	\N	\N	\N	77445	77445	77868
18227	24842	67	applied	\N	\N	\N	\N	77447	77447	77869
18227	24849	68	applied	\N	\N	\N	\N	77503	77503	77870
18227	24850	69	applied	\N	\N	\N	\N	77505	77505	77871
18227	24851	70	applied	\N	\N	\N	\N	77507	77507	77872
18227	24852	71	applied	\N	\N	\N	\N	77509	77509	77514
18227	24859	72	applied	\N	\N	\N	\N	77525	77525	77873
18227	24860	73	applied	\N	\N	\N	\N	77527	77527	77874
18227	24868	74	applied	\N	\N	\N	\N	77549	77549	77875
18227	24869	75	applied	\N	\N	\N	\N	77551	77551	77530
18227	24872	76	applied	\N	\N	\N	\N	77558	77558	77534
18227	24881	77	applied	\N	\N	\N	\N	77578	77578	77876
18227	24885	78	applied	\N	\N	\N	\N	77588	77588	77877
18227	24855	79	applied	\N	\N	\N	\N	77515	77515	77878
18227	24856	80	applied	\N	\N	\N	\N	77517	77517	77552
18227	24861	81	applied	\N	\N	\N	\N	77529	77529	77557
18227	24862	82	applied	\N	\N	\N	\N	77531	77531	77879
18227	24866	83	applied	\N	\N	\N	\N	77545	77545	77561
18227	24867	84	applied	\N	\N	\N	\N	77547	77547	77574
18227	24871	85	applied	\N	\N	\N	\N	77556	77556	77880
18227	24879	86	applied	\N	\N	\N	\N	77573	77573	77881
18227	24882	87	applied	\N	\N	\N	\N	77580	77580	77587
18227	24863	88	applied	\N	\N	\N	\N	77533	77533	77882
18227	24873	89	applied	\N	\N	\N	\N	77560	77560	77883
18227	24884	90	applied	\N	\N	\N	\N	77586	77586	77589
18227	24893	91	applied	\N	\N	\N	\N	77606	77606	77884
18227	24906	92	applied	\N	\N	\N	\N	77638	77638	77591
18227	24915	93	applied	\N	\N	\N	\N	77662	77662	77885
18227	24924	94	applied	\N	\N	\N	\N	77682	77682	77596
18227	24932	95	applied	\N	\N	\N	\N	77704	77704	77886
18227	24937	96	applied	\N	\N	\N	\N	77719	77719	77887
18227	24950	97	applied	\N	\N	\N	\N	77775	77775	77598
18227	24957	98	applied	\N	\N	\N	\N	77797	77797	77607
18227	24963	99	applied	\N	\N	\N	\N	77812	77812	77888
18227	24975	100	applied	\N	\N	\N	\N	77849	77849	77889
18227	24886	101	applied	\N	\N	\N	\N	77590	77590	77890
18227	24888	102	applied	\N	\N	\N	\N	77595	77595	77891
18227	24895	103	applied	\N	\N	\N	\N	77610	77610	77892
18227	24896	104	applied	\N	\N	\N	\N	77612	77612	77893
18227	24897	105	applied	\N	\N	\N	\N	77614	77614	77617
18227	24902	106	applied	\N	\N	\N	\N	77626	77626	77894
18227	24905	107	applied	\N	\N	\N	\N	77636	77636	77895
18227	24889	108	applied	\N	\N	\N	\N	77597	77597	77896
18227	24894	109	applied	\N	\N	\N	\N	77608	77608	77637
18227	24898	110	applied	\N	\N	\N	\N	77616	77616	77897
18227	24899	111	applied	\N	\N	\N	\N	77618	77618	77898
18227	24901	112	applied	\N	\N	\N	\N	77624	77624	77899
18227	24907	113	applied	\N	\N	\N	\N	77640	77640	77900
18227	24908	114	applied	\N	\N	\N	\N	77642	77642	77901
18227	24911	115	applied	\N	\N	\N	\N	77652	77652	77902
18227	24912	116	applied	\N	\N	\N	\N	77654	77654	77683
18227	24961	117	applied	\N	\N	\N	\N	77805	77805	77805
18227	24964	118	applied	\N	\N	\N	\N	77814	77814	77814
18227	24968	119	applied	\N	\N	\N	\N	77825	77825	77825
18227	24969	120	applied	\N	\N	\N	\N	77826	77826	77826
18227	24970	121	applied	\N	\N	\N	\N	77827	77827	77827
18227	24980	122	applied	\N	\N	\N	\N	77860	77860	77861
18227	24916	123	applied	\N	\N	\N	\N	77664	77664	77685
18227	24917	124	applied	\N	\N	\N	\N	77666	77666	77687
18227	24925	125	applied	\N	\N	\N	\N	77684	77684	77689
18232	24990	0	applied	\N	\N	\N	\N	77926	77926	77927
18232	24991	1	applied	\N	\N	\N	\N	77928	77928	77929
18234	24992	0	applied	\N	\N	\N	\N	77938	77938	77939
18234	24993	1	applied	\N	\N	\N	\N	77940	77940	77941
18241	24998	0	applied	\N	\N	\N	\N	77961	77961	77962
18241	24999	1	applied	\N	\N	\N	\N	77963	77963	77964
18241	25000	2	applied	\N	\N	\N	\N	77965	77965	77966
18241	25001	3	applied	\N	\N	\N	\N	77967	77967	77968
18241	25002	4	applied	\N	\N	\N	\N	77969	77969	77970
18243	24998	0	applied	\N	\N	\N	\N	77961	77961	77962
18243	24999	1	applied	\N	\N	\N	\N	77963	77963	77964
18243	25000	2	applied	\N	\N	\N	\N	77965	77965	77966
18243	25001	3	applied	\N	\N	\N	\N	77967	77967	77968
18243	25002	4	applied	\N	\N	\N	\N	77969	77969	77970
18249	25017	0	applied	\N	\N	\N	\N	78010	78010	78011
18231	24991	1	applied	\N	\N	\N	\N	77928	77928	77929
18233	24864	0	applied	\N	\N	\N	\N	77541	77541	77542
18233	24875	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77569	77569	\N
18233	24876	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	77570	77570	\N
18233	24877	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	77571	77571	\N
18233	24878	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	77572	77572	\N
18233	24865	5	applied	\N	\N	\N	\N	77543	77543	77544
18233	24870	6	applied	\N	\N	\N	\N	77554	77554	77555
18233	24874	7	applied	\N	\N	\N	\N	77567	77567	77568
18233	24880	8	applied	\N	\N	\N	\N	77576	77576	77577
18233	24883	9	applied	\N	\N	\N	\N	77584	77584	77585
18233	24887	10	applied	\N	\N	\N	\N	77593	77593	77594
18233	24890	11	applied	\N	\N	\N	\N	77600	77600	77601
18233	24891	12	applied	\N	\N	\N	\N	77602	77602	77603
18233	24892	13	applied	\N	\N	\N	\N	77604	77604	77605
18233	24900	14	applied	\N	\N	\N	\N	77622	77622	77623
18233	24903	15	applied	\N	\N	\N	\N	77632	77632	77633
18233	24904	16	applied	\N	\N	\N	\N	77634	77634	77635
18233	24909	17	applied	\N	\N	\N	\N	77648	77648	77649
18233	24910	18	applied	\N	\N	\N	\N	77650	77650	77651
18233	24913	19	applied	\N	\N	\N	\N	77658	77658	77659
18233	24914	20	applied	\N	\N	\N	\N	77660	77660	77661
18233	24920	21	applied	\N	\N	\N	\N	77674	77674	77675
18233	24921	22	applied	\N	\N	\N	\N	77676	77676	77677
18233	24922	23	applied	\N	\N	\N	\N	77678	77678	77679
18233	24923	24	applied	\N	\N	\N	\N	77680	77680	77681
18233	24929	25	applied	\N	\N	\N	\N	77696	77696	77697
18233	24931	26	applied	\N	\N	\N	\N	77702	77702	77703
18233	24934	27	applied	\N	\N	\N	\N	77713	77713	77714
18233	24935	28	applied	\N	\N	\N	\N	77715	77715	77716
18233	24939	29	applied	\N	\N	\N	\N	77747	77747	77748
18233	24941	30	applied	\N	\N	\N	\N	77753	77753	77754
18233	24943	31	applied	\N	\N	\N	\N	77760	77760	77761
18233	24945	32	applied	\N	\N	\N	\N	77768	77768	77769
18233	24952	33	applied	\N	\N	\N	\N	77785	77785	77786
18233	24953	34	applied	\N	\N	\N	\N	77787	77787	77788
18233	24954	35	applied	\N	\N	\N	\N	77791	77791	77792
18233	24955	36	applied	\N	\N	\N	\N	77793	77793	77794
18233	24956	37	applied	\N	\N	\N	\N	77795	77795	77796
18233	24962	38	applied	\N	\N	\N	\N	77810	77810	77811
18233	24966	39	applied	\N	\N	\N	\N	77821	77821	77822
18233	24971	40	applied	\N	\N	\N	\N	77832	77832	77833
18233	24973	41	applied	\N	\N	\N	\N	77845	77845	77846
18233	24974	42	applied	\N	\N	\N	\N	77847	77847	77848
18233	24978	43	applied	\N	\N	\N	\N	77856	77856	77857
18233	24981	44	applied	\N	\N	\N	\N	77905	77905	77906
18233	24985	45	applied	\N	\N	\N	\N	77914	77914	77915
18233	24988	46	applied	\N	\N	\N	\N	77921	77921	77922
18233	24990	47	applied	\N	\N	\N	\N	77926	77926	77927
18233	24946	48	applied	\N	\N	\N	\N	77770	77770	30431
18233	24947	49	applied	\N	\N	\N	\N	77771	77771	77771
18233	24948	50	applied	\N	\N	\N	\N	77772	77772	77771
18233	24866	51	applied	\N	\N	\N	\N	77545	77545	77546
18233	24867	52	applied	\N	\N	\N	\N	77547	77547	77548
18233	24871	53	applied	\N	\N	\N	\N	77556	77556	77877
18233	24879	54	applied	\N	\N	\N	\N	77573	77573	77878
18233	24882	55	applied	\N	\N	\N	\N	77580	77580	77552
18233	24873	56	applied	\N	\N	\N	\N	77560	77560	77933
18233	24884	57	applied	\N	\N	\N	\N	77586	77586	77557
18233	24893	58	applied	\N	\N	\N	\N	77606	77606	77934
18233	24906	59	applied	\N	\N	\N	\N	77638	77638	77879
18233	24915	60	applied	\N	\N	\N	\N	77662	77662	77559
18233	24924	61	applied	\N	\N	\N	\N	77682	77682	77561
18233	24932	62	applied	\N	\N	\N	\N	77704	77704	77935
18233	24937	63	applied	\N	\N	\N	\N	77719	77719	77574
18233	24950	64	applied	\N	\N	\N	\N	77775	77775	77936
18233	24957	65	applied	\N	\N	\N	\N	77797	77797	77880
18233	24963	66	applied	\N	\N	\N	\N	77812	77812	77579
18233	24975	67	applied	\N	\N	\N	\N	77849	77849	77881
18233	24886	68	applied	\N	\N	\N	\N	77590	77590	77587
18233	24888	69	applied	\N	\N	\N	\N	77595	77595	77883
18233	24895	70	applied	\N	\N	\N	\N	77610	77610	77884
18233	24896	71	applied	\N	\N	\N	\N	77612	77612	77885
18233	24897	72	applied	\N	\N	\N	\N	77614	77614	77886
18233	24902	73	applied	\N	\N	\N	\N	77626	77626	77598
18233	24905	74	applied	\N	\N	\N	\N	77636	77636	77888
18233	24987	75	applied	\N	\N	\N	\N	77918	77918	77889
18233	24961	76	applied	\N	\N	\N	\N	77805	77805	77805
18233	24964	77	applied	\N	\N	\N	\N	77814	77814	77814
18233	24968	78	applied	\N	\N	\N	\N	77825	77825	77825
18233	24969	79	applied	\N	\N	\N	\N	77826	77826	77826
18233	24970	80	applied	\N	\N	\N	\N	77827	77827	77827
18233	24980	81	applied	\N	\N	\N	\N	77860	77860	77861
18233	24982	82	applied	\N	\N	\N	\N	77907	77907	77908
18233	24983	83	applied	\N	\N	\N	\N	77909	77909	77910
18236	24995	0	applied	\N	\N	\N	\N	77948	77948	77949
18236	24994	1	applied	\N	\N	\N	\N	77944	77944	77945
18242	24998	0	applied	\N	\N	\N	\N	77961	77961	77962
18242	24999	1	applied	\N	\N	\N	\N	77963	77963	77964
18242	25000	2	applied	\N	\N	\N	\N	77965	77965	77966
18242	25001	3	applied	\N	\N	\N	\N	77967	77967	77968
18242	25002	4	applied	\N	\N	\N	\N	77969	77969	77970
18252	25017	0	applied	\N	\N	\N	\N	78010	78010	78011
18252	25018	1	applied	\N	\N	\N	\N	78012	78012	78013
18254	25019	0	applied	\N	\N	\N	\N	78034	78034	78035
18254	25020	1	applied	\N	\N	\N	\N	78036	78036	78037
18259	25024	0	applied	\N	\N	\N	\N	78050	78050	78051
18259	25023	1	applied	\N	\N	\N	\N	78046	78046	78047
18259	25025	2	applied	\N	\N	\N	\N	78052	78052	78053
18261	25026	0	applied	\N	\N	\N	\N	78056	78056	78057
18261	25027	1	applied	\N	\N	\N	\N	78058	78058	78059
18264	25035	0	applied	\N	\N	\N	\N	78080	78080	78081
18264	25036	1	applied	\N	\N	\N	\N	78082	78082	78083
18266	25037	0	applied	\N	\N	\N	\N	78087	78087	78088
18266	25038	1	applied	\N	\N	\N	\N	78089	78089	78090
18266	25039	2	applied	\N	\N	\N	\N	78091	78091	78092
18272	25050	0	applied	\N	\N	\N	\N	78119	78119	78120
18272	25051	1	applied	\N	\N	\N	\N	78121	78121	78122
18272	25052	2	applied	\N	\N	\N	\N	78123	78123	78124
18272	25053	3	applied	\N	\N	\N	\N	78125	78125	78126
18272	25054	4	applied	\N	\N	\N	\N	78127	78127	78128
18274	25050	0	applied	\N	\N	\N	\N	78119	78119	78120
18274	25051	1	applied	\N	\N	\N	\N	78121	78121	78122
18274	25052	2	applied	\N	\N	\N	\N	78123	78123	78124
18274	25053	3	applied	\N	\N	\N	\N	78125	78125	78126
18274	25054	4	applied	\N	\N	\N	\N	78127	78127	78128
18278	25062	0	applied	\N	\N	\N	\N	78150	78150	78151
18278	25063	1	applied	\N	\N	\N	\N	78152	78152	78153
18249	25018	1	applied	\N	\N	\N	\N	78012	78012	78013
18253	25017	0	applied	\N	\N	\N	\N	78010	78010	78011
18253	25018	1	applied	\N	\N	\N	\N	78012	78012	78013
18258	25024	0	applied	\N	\N	\N	\N	78050	78050	78051
18258	25023	1	applied	\N	\N	\N	\N	78046	78046	78047
18258	25025	2	applied	\N	\N	\N	\N	78052	78052	78053
18262	25028	0	applied	\N	\N	\N	\N	78062	78062	78063
18262	25029	1	applied	\N	\N	\N	\N	78064	78064	78065
18265	25035	0	applied	\N	\N	\N	\N	78080	78080	78081
18265	25036	1	applied	\N	\N	\N	\N	78082	78082	78083
18270	25043	0	applied	\N	\N	\N	\N	78103	78103	78104
18270	25044	1	applied	\N	\N	\N	\N	78105	78105	78106
18280	25064	0	applied	\N	\N	\N	\N	78155	78155	78156
18280	25065	1	applied	\N	\N	\N	\N	78157	78157	78158
18281	25066	0	applied	\N	\N	\N	\N	78161	78161	78162
18281	25067	1	applied	\N	\N	\N	\N	78163	78163	78164
18282	25068	0	applied	\N	\N	\N	\N	78167	78167	78168
18282	25069	1	applied	\N	\N	\N	\N	78169	78169	78170
18282	25070	2	applied	\N	\N	\N	\N	78171	78171	78172
18282	25071	3	applied	\N	\N	\N	\N	78173	78173	78174
18282	25072	4	applied	\N	\N	\N	\N	78175	78175	78176
18286	25075	0	applied	\N	\N	\N	\N	78209	78209	78210
18286	25076	1	applied	\N	\N	\N	\N	78211	78211	78212
18286	25077	2	applied	\N	\N	\N	\N	78213	78213	78214
18289	25085	0	applied	\N	\N	\N	\N	78234	78234	78235
18289	25086	1	applied	\N	\N	\N	\N	78236	78236	78237
18289	25087	2	applied	\N	\N	\N	\N	78238	78238	78239
18289	25088	3	applied	\N	\N	\N	\N	78240	78240	78241
18289	25089	4	applied	\N	\N	\N	\N	78242	78242	5488
18289	25090	5	applied	\N	\N	\N	\N	78243	78243	78244
18291	25091	0	applied	\N	\N	\N	\N	78246	78246	78247
18291	25092	1	applied	\N	\N	\N	\N	78248	78248	78249
18291	25093	2	applied	\N	\N	\N	\N	78250	78250	5488
18298	25097	0	applied	\N	\N	\N	\N	78262	78262	78263
18298	25098	1	applied	\N	\N	\N	\N	78264	78264	78265
18299	25097	0	applied	\N	\N	\N	\N	78262	78262	78263
18299	25098	1	applied	\N	\N	\N	\N	78264	78264	78265
18301	25099	0	applied	\N	\N	\N	\N	78272	78272	78273
18301	25100	1	applied	\N	\N	\N	\N	78274	78274	78275
18301	25101	2	applied	\N	\N	\N	\N	78276	78276	78277
18303	25099	0	applied	\N	\N	\N	\N	78272	78272	78273
18303	25100	1	applied	\N	\N	\N	\N	78274	78274	78275
18303	25101	2	applied	\N	\N	\N	\N	78276	78276	78277
18309	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18309	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18309	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18309	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18309	25111	4	applied	\N	\N	\N	\N	78305	78305	78306
18309	25112	5	applied	\N	\N	\N	\N	78307	78307	78308
18309	25113	6	applied	\N	\N	\N	\N	78309	78309	78310
18309	25114	7	applied	\N	\N	\N	\N	78311	78311	78312
18309	25115	8	applied	\N	\N	\N	\N	78313	78313	78314
18309	25116	9	applied	\N	\N	\N	\N	78315	78315	78316
18309	25117	10	applied	\N	\N	\N	\N	78317	78317	78318
18309	25118	11	applied	\N	\N	\N	\N	78319	78319	78320
18309	25119	12	applied	\N	\N	\N	\N	78321	78321	78322
18309	25120	13	applied	\N	\N	\N	\N	78323	78323	78324
18309	25121	14	applied	\N	\N	\N	\N	78325	78325	5488
18309	25122	15	applied	\N	\N	\N	\N	78326	78326	78327
18309	25123	16	applied	\N	\N	\N	\N	78328	78328	78329
18309	25124	17	applied	\N	\N	\N	\N	78330	78330	78331
18309	25125	18	applied	\N	\N	\N	\N	78332	78332	78333
18311	25126	0	applied	\N	\N	\N	\N	78339	78339	78340
18311	25127	1	applied	\N	\N	\N	\N	78341	78341	78342
18314	25128	0	applied	\N	\N	\N	\N	78345	78345	78346
18314	25129	1	applied	\N	\N	\N	\N	78347	78347	78348
18314	25130	2	applied	\N	\N	\N	\N	78349	78349	78350
18319	25140	0	applied	\N	\N	\N	\N	78389	78389	78390
18319	25141	1	applied	\N	\N	\N	\N	78391	78391	78392
18326	25150	0	applied	\N	\N	\N	\N	78419	78419	78420
18326	25148	1	applied	\N	\N	\N	\N	78413	78413	78414
18326	25149	2	applied	\N	\N	\N	\N	78415	78415	78416
18327	25150	0	applied	\N	\N	\N	\N	78419	78419	78420
18327	25148	1	applied	\N	\N	\N	\N	78413	78413	78414
18327	25149	2	applied	\N	\N	\N	\N	78415	78415	78416
18334	25167	0	applied	\N	\N	\N	\N	78466	78466	78467
18334	25168	1	applied	\N	\N	\N	\N	78468	78468	78469
18337	25170	0	applied	\N	\N	\N	\N	78475	78475	78476
18337	25171	1	applied	\N	\N	\N	\N	78477	78477	78478
18337	25172	2	applied	\N	\N	\N	\N	78479	78479	78480
18337	25173	3	applied	\N	\N	\N	\N	78481	78481	78482
18337	25174	4	applied	\N	\N	\N	\N	78483	78483	78484
18342	25177	0	applied	\N	\N	\N	\N	78493	78493	78494
18342	25178	1	applied	\N	\N	\N	\N	78495	78495	78496
18342	25179	2	applied	\N	\N	\N	\N	78497	78497	78498
18342	25180	3	applied	\N	\N	\N	\N	78499	78499	78500
18342	25181	4	applied	\N	\N	\N	\N	78501	78501	78502
18342	25182	5	applied	\N	\N	\N	\N	78503	78503	78503
18342	25183	6	applied	\N	\N	\N	\N	78504	78504	78504
18342	25184	7	applied	\N	\N	\N	\N	78505	78505	78506
18342	25185	8	applied	\N	\N	\N	\N	78507	78507	78508
18344	25186	0	applied	\N	\N	\N	\N	78513	78513	78514
18344	25187	1	applied	\N	\N	\N	\N	78515	78515	78516
18352	25209	0	applied	\N	\N	\N	\N	78568	78568	78569
18352	25210	1	applied	\N	\N	\N	\N	78570	78570	78571
18352	25211	2	applied	\N	\N	\N	\N	78572	78572	78573
18352	25212	3	applied	\N	\N	\N	\N	78574	78574	78575
18352	25213	4	applied	\N	\N	\N	\N	78576	78576	78577
18355	25218	0	applied	\N	\N	\N	\N	78590	78590	78591
18355	25219	1	applied	\N	\N	\N	\N	78592	78592	78593
18355	25220	2	applied	\N	\N	\N	\N	78594	78594	78595
18360	25227	0	applied	\N	\N	\N	\N	78615	78615	78616
18360	25228	1	applied	\N	\N	\N	\N	78617	78617	78618
18362	25227	0	applied	\N	\N	\N	\N	78615	78615	78616
18362	25228	1	applied	\N	\N	\N	\N	78617	78617	78618
18364	25229	0	applied	\N	\N	\N	\N	78623	78623	78624
18364	25230	1	applied	\N	\N	\N	\N	78625	78625	78626
18369	25238	0	applied	\N	\N	\N	\N	78651	78651	78652
18369	25239	1	applied	\N	\N	\N	\N	78653	78653	78654
18369	25240	2	applied	\N	\N	\N	\N	78655	78655	78656
18369	25241	3	applied	\N	\N	\N	\N	78657	78657	78658
18369	25242	4	applied	\N	\N	\N	\N	78659	78659	78660
18374	25247	0	applied	\N	\N	\N	\N	78689	78689	78690
18374	25248	1	applied	\N	\N	\N	\N	78691	78691	78692
18382	25256	0	applied	\N	\N	\N	\N	78718	78718	78719
18382	25257	2	applied	\N	\N	\N	\N	78721	78721	78722
18382	25258	3	applied	\N	\N	\N	\N	78723	78723	78724
18382	25259	4	applied	\N	\N	\N	\N	78725	78725	78726
18382	25260	5	applied	\N	\N	\N	\N	78727	78727	78728
18392	25275	0	applied	\N	\N	\N	\N	78812	78812	78813
18255	25021	0	applied	\N	\N	\N	\N	78040	78040	78041
18255	25022	1	applied	\N	\N	\N	\N	78042	78042	78043
18257	25023	0	applied	\N	\N	\N	\N	78046	78046	78047
18267	25040	0	applied	\N	\N	\N	\N	78093	78093	78094
18267	25041	1	applied	\N	\N	\N	\N	78095	78095	78096
18269	25042	0	applied	\N	\N	\N	\N	78100	78100	78101
18273	25050	0	applied	\N	\N	\N	\N	78119	78119	78120
18273	25051	1	applied	\N	\N	\N	\N	78121	78121	78122
18273	25052	2	applied	\N	\N	\N	\N	78123	78123	78124
18273	25053	3	applied	\N	\N	\N	\N	78125	78125	78126
18273	25054	4	applied	\N	\N	\N	\N	78127	78127	78128
18275	25055	0	applied	\N	\N	\N	\N	78132	78132	78133
18275	25056	1	applied	\N	\N	\N	\N	78134	78134	78135
18275	25057	2	applied	\N	\N	\N	\N	78136	78136	78137
18275	25058	3	applied	\N	\N	\N	\N	78138	78138	78139
18279	25062	0	applied	\N	\N	\N	\N	78150	78150	78151
18279	25063	1	applied	\N	\N	\N	\N	78152	78152	78153
18285	25075	0	applied	\N	\N	\N	\N	78209	78209	78210
18285	25076	1	applied	\N	\N	\N	\N	78211	78211	78212
18285	25077	2	applied	\N	\N	\N	\N	78213	78213	78214
18287	25075	0	applied	\N	\N	\N	\N	78209	78209	78210
18287	25078	1	applied	\N	\N	\N	\N	78219	78219	78220
18287	25076	2	applied	\N	\N	\N	\N	78211	78211	78212
18287	25077	3	applied	\N	\N	\N	\N	78213	78213	78214
18292	25091	0	applied	\N	\N	\N	\N	78246	78246	78247
18292	25092	1	applied	\N	\N	\N	\N	78248	78248	78249
18292	25093	2	applied	\N	\N	\N	\N	78250	78250	5488
18297	25097	0	applied	\N	\N	\N	\N	78262	78262	78263
18297	25098	1	applied	\N	\N	\N	\N	78264	78264	78265
18305	25102	0	applied	\N	\N	\N	\N	78281	78281	78282
18305	25103	1	applied	\N	\N	\N	\N	78283	78283	78284
18307	25104	0	applied	\N	\N	\N	\N	78290	78290	78291
18307	25105	1	applied	\N	\N	\N	\N	78292	78292	78293
18307	25106	2	applied	\N	\N	\N	\N	78294	78294	78295
18318	25140	0	applied	\N	\N	\N	\N	78389	78389	78390
18318	25141	1	applied	\N	\N	\N	\N	78391	78391	78392
18322	25142	0	applied	\N	\N	\N	\N	78395	78395	78396
18322	25143	1	applied	\N	\N	\N	\N	78397	78397	78398
18328	25150	0	applied	\N	\N	\N	\N	78419	78419	78420
18328	25151	1	applied	\N	\N	\N	\N	78424	78424	78425
18328	25152	2	applied	\N	\N	\N	\N	78426	78426	78427
18328	25153	3	applied	\N	\N	\N	\N	78428	78428	78429
18328	25154	4	applied	\N	\N	\N	\N	78430	78430	78431
18332	25160	0	applied	\N	\N	\N	\N	78448	78448	78449
18332	25161	1	applied	\N	\N	\N	\N	78450	78450	78451
18335	25169	0	applied	\N	\N	\N	\N	78471	78471	78472
18345	25188	0	applied	\N	\N	\N	\N	78521	78521	78522
18345	25189	1	applied	\N	\N	\N	\N	78523	78523	78524
18345	25190	2	applied	\N	\N	\N	\N	78525	78525	78526
18345	25191	3	applied	\N	\N	\N	\N	78527	78527	78527
18345	25192	4	applied	\N	\N	\N	\N	78528	78528	78528
18350	25200	0	applied	\N	\N	\N	\N	78550	78550	78551
18350	25201	1	applied	\N	\N	\N	\N	78552	78552	78553
18350	25202	2	applied	\N	\N	\N	\N	78554	78554	78554
18350	25203	3	applied	\N	\N	\N	\N	78555	78555	78555
18350	25204	4	applied	\N	\N	\N	\N	78556	78556	78556
18350	25205	5	applied	\N	\N	\N	\N	78557	78557	78557
18350	25206	6	applied	\N	\N	\N	\N	78558	78558	78559
18353	25214	0	applied	\N	\N	\N	\N	78579	78579	78580
18353	25215	1	applied	\N	\N	\N	\N	78581	78581	78582
18358	25225	0	applied	\N	\N	\N	\N	78609	78609	78610
18358	25226	1	applied	\N	\N	\N	\N	78611	78611	78612
18365	25231	0	applied	\N	\N	\N	\N	78628	78628	78629
18365	25232	1	applied	\N	\N	\N	\N	78630	78630	78631
18365	25233	2	applied	\N	\N	\N	\N	78632	78632	78633
18365	25234	3	applied	\N	\N	\N	\N	78634	78634	78635
18365	25235	4	applied	\N	\N	\N	\N	78636	78636	78637
18367	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18367	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18367	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18367	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18367	25131	4	applied	\N	\N	\N	\N	78370	78370	78371
18367	25132	5	applied	\N	\N	\N	\N	78372	78372	78373
18367	25133	6	applied	\N	\N	\N	\N	78374	78374	78375
18367	25134	7	applied	\N	\N	\N	\N	78376	78376	78377
18367	24828	8	applied	\N	\N	\N	\N	77419	77419	77419
18367	24833	9	applied	\N	\N	1000000000	\N	77428	77428	77429
18367	24789	10	applied	\N	\N	\N	\N	77265	77265	77266
18367	24790	11	applied	\N	\N	\N	\N	77267	77267	77268
18367	24791	12	applied	\N	\N	\N	\N	77269	77269	77270
18367	24796	13	applied	\N	\N	\N	\N	77283	77283	77284
18367	24797	14	applied	\N	\N	\N	\N	77285	77285	77286
18367	24800	15	applied	\N	\N	\N	\N	77293	77293	77294
18367	24803	16	applied	\N	\N	\N	\N	77302	77302	77303
18367	24805	17	applied	\N	\N	\N	\N	77356	77356	77357
18367	25079	18	applied	\N	\N	\N	\N	78222	78222	78223
18367	25080	19	applied	\N	\N	\N	\N	78224	78224	78225
18367	25086	20	applied	\N	\N	\N	\N	78236	78236	78237
18367	24806	21	applied	\N	\N	\N	\N	77358	77358	77359
18367	25087	22	applied	\N	\N	\N	\N	78238	78238	78239
18367	24807	23	applied	\N	\N	\N	\N	77360	77360	77361
18367	24812	24	applied	\N	\N	\N	\N	77374	77374	77375
18367	24814	25	applied	\N	\N	\N	\N	77380	77380	77381
18367	24816	26	applied	\N	\N	\N	\N	77385	77385	77386
18367	24817	27	applied	\N	\N	\N	\N	77387	77387	77388
18367	24821	28	applied	\N	\N	\N	\N	77398	77398	77399
18367	24823	29	applied	\N	\N	\N	\N	77404	77404	77405
18367	24825	30	applied	\N	\N	\N	\N	77412	77412	77413
18367	24829	31	applied	\N	\N	\N	\N	77420	77420	77421
18367	24830	32	applied	\N	\N	\N	\N	77422	77422	77423
18367	24831	33	applied	\N	\N	\N	\N	77424	77424	77425
18367	24832	34	applied	\N	\N	\N	\N	77426	77426	77427
18367	24844	35	applied	\N	\N	\N	\N	77493	77493	77494
18367	24845	36	applied	\N	\N	\N	\N	77495	77495	77496
18367	24846	37	applied	\N	\N	\N	\N	77497	77497	77498
18367	24847	38	applied	\N	\N	\N	\N	77499	77499	77500
18367	24857	39	applied	\N	\N	\N	\N	77521	77521	77522
18367	24858	40	applied	\N	\N	\N	\N	77523	77523	77524
18367	24864	41	applied	\N	\N	\N	\N	77541	77541	77542
18367	24865	42	applied	\N	\N	\N	\N	77543	77543	77544
18367	24870	44	applied	\N	\N	\N	\N	77554	77554	77555
18367	24874	45	applied	\N	\N	\N	\N	77567	77567	77568
18367	24880	46	applied	\N	\N	\N	\N	77576	77576	77577
18367	24883	47	applied	\N	\N	\N	\N	77584	77584	77585
18367	24887	48	applied	\N	\N	\N	\N	77593	77593	77594
18367	24890	49	applied	\N	\N	\N	\N	77600	77600	77601
18367	24891	50	applied	\N	\N	\N	\N	77602	77602	77603
18367	24892	51	applied	\N	\N	\N	\N	77604	77604	77605
18367	24900	52	applied	\N	\N	\N	\N	77622	77622	77623
18367	24903	53	applied	\N	\N	\N	\N	77632	77632	77633
18260	25023	1	applied	\N	\N	\N	\N	78046	78046	78047
18260	25025	2	applied	\N	\N	\N	\N	78052	78052	78053
18263	25030	0	applied	\N	\N	\N	\N	78068	78068	78069
18263	25031	1	applied	\N	\N	\N	\N	78070	78070	78071
18263	25032	2	applied	\N	\N	\N	\N	78072	78072	78073
18263	25033	3	applied	\N	\N	\N	\N	78074	78074	78075
18263	25034	4	applied	\N	\N	\N	\N	78076	78076	78077
18268	25040	0	applied	\N	\N	\N	\N	78093	78093	78094
18268	25041	1	applied	\N	\N	\N	\N	78095	78095	78096
18271	25045	0	applied	\N	\N	\N	\N	78107	78107	78108
18271	25046	1	applied	\N	\N	\N	\N	78109	78109	78110
18271	25047	2	applied	\N	\N	\N	\N	78111	78111	78112
18271	25048	3	applied	\N	\N	\N	\N	78113	78113	78114
18271	25049	4	applied	\N	\N	\N	\N	78115	78115	78116
18276	25059	0	applied	\N	\N	\N	\N	78142	78142	78143
18276	25060	1	applied	\N	\N	\N	\N	78144	78144	78145
18276	25061	2	applied	\N	\N	\N	\N	78146	78146	78147
18277	25062	0	applied	\N	\N	\N	\N	78150	78150	78151
18277	25063	1	applied	\N	\N	\N	\N	78152	78152	78153
18283	25073	0	applied	\N	\N	\N	\N	78179	78179	78180
18283	25074	1	applied	\N	\N	\N	\N	78181	78181	78182
18288	25079	0	applied	\N	\N	\N	\N	78222	78222	78223
18288	25080	1	applied	\N	\N	\N	\N	78224	78224	78225
18288	25078	2	applied	\N	\N	\N	\N	78219	78219	78220
18288	25081	3	applied	\N	\N	\N	\N	78226	78226	78227
18288	25082	4	applied	\N	\N	\N	\N	78228	78228	5488
18288	25083	5	applied	\N	\N	\N	\N	78229	78229	78230
18288	25084	6	applied	\N	\N	\N	\N	78231	78231	78232
18293	25094	0	applied	\N	\N	\N	\N	78253	78253	78254
18293	25095	1	applied	\N	\N	\N	\N	78255	78255	78256
18293	25096	2	applied	\N	\N	\N	\N	78257	78257	78258
18295	25094	0	applied	\N	\N	\N	\N	78253	78253	78254
18295	25095	1	applied	\N	\N	\N	\N	78255	78255	78256
18295	25096	2	applied	\N	\N	\N	\N	78257	78257	78258
18304	25102	0	applied	\N	\N	\N	\N	78281	78281	78282
18304	25103	1	applied	\N	\N	\N	\N	78283	78283	78284
18306	25102	0	applied	\N	\N	\N	\N	78281	78281	78282
18306	25103	1	applied	\N	\N	\N	\N	78283	78283	78284
18312	25128	0	applied	\N	\N	\N	\N	78345	78345	78346
18312	25129	1	applied	\N	\N	\N	\N	78347	78347	78348
18312	25130	2	applied	\N	\N	\N	\N	78349	78349	78350
18316	25128	0	applied	\N	\N	\N	\N	78345	78345	78346
18316	25129	1	applied	\N	\N	\N	\N	78347	78347	78348
18316	25130	2	applied	\N	\N	\N	\N	78349	78349	78350
18320	25140	0	applied	\N	\N	\N	\N	78389	78389	78390
18320	25141	1	applied	\N	\N	\N	\N	78391	78391	78392
18324	25146	0	applied	\N	\N	\N	\N	78409	78409	78410
18324	25147	1	applied	\N	\N	\N	\N	78411	78411	78412
18329	25150	0	applied	\N	\N	\N	\N	78419	78419	78420
18329	25151	1	applied	\N	\N	\N	\N	78424	78424	78425
18329	25152	2	applied	\N	\N	\N	\N	78426	78426	78427
18329	25153	3	applied	\N	\N	\N	\N	78428	78428	78429
18329	25154	4	applied	\N	\N	\N	\N	78430	78430	78431
18331	25155	0	applied	\N	\N	\N	\N	78436	78436	78437
18331	25156	1	applied	\N	\N	\N	\N	78438	78438	78439
18331	25157	2	applied	\N	\N	\N	\N	78440	78440	78441
18331	25158	3	applied	\N	\N	\N	\N	78442	78442	78443
18331	25159	4	applied	\N	\N	\N	\N	78444	78444	78445
18347	25193	0	applied	\N	\N	\N	\N	78530	78530	78531
18347	25194	1	applied	\N	\N	\N	\N	78532	78532	78533
18347	25195	2	applied	\N	\N	\N	\N	78534	78534	78535
18347	25197	3	applied	\N	\N	\N	\N	78538	78538	78538
18349	25193	0	applied	\N	\N	\N	\N	78530	78530	78531
18349	25194	1	applied	\N	\N	\N	\N	78532	78532	78533
18349	25195	2	applied	\N	\N	\N	\N	78534	78534	78535
18349	25196	3	applied	\N	\N	\N	\N	78536	78536	78537
18349	25197	4	applied	\N	\N	\N	\N	78538	78538	78538
18349	25198	5	applied	\N	\N	\N	\N	78539	78539	78540
18349	25199	6	applied	\N	\N	\N	\N	78541	78541	78542
18351	25207	0	applied	\N	\N	\N	\N	78562	78562	78563
18351	25208	1	applied	\N	\N	\N	\N	78564	78564	78565
18354	25216	0	applied	\N	\N	\N	\N	78584	78584	78585
18354	25217	1	applied	\N	\N	\N	\N	78586	78586	78587
18357	25221	0	applied	\N	\N	\N	\N	78600	78600	78601
18357	25222	1	applied	\N	\N	\N	\N	78602	78602	78603
18357	25223	2	applied	\N	\N	\N	\N	78604	78604	78605
18357	25224	3	applied	\N	\N	\N	\N	78606	78606	78607
18368	25238	0	applied	\N	\N	\N	\N	78651	78651	78652
18368	25239	1	applied	\N	\N	\N	\N	78653	78653	78654
18368	25240	2	applied	\N	\N	\N	\N	78655	78655	78656
18368	25241	3	applied	\N	\N	\N	\N	78657	78657	78658
18368	25242	4	applied	\N	\N	\N	\N	78659	78659	78660
18371	25243	0	applied	\N	\N	\N	\N	78675	78675	78676
18371	25244	1	applied	\N	\N	\N	\N	78677	78677	78678
18376	25249	0	applied	\N	\N	\N	\N	78695	78695	78696
18376	25250	1	applied	\N	\N	\N	\N	78697	78697	78698
18376	25251	2	applied	\N	\N	\N	\N	78699	78699	78700
18387	25272	0	applied	\N	\N	\N	\N	78801	78801	78802
18387	25273	1	applied	\N	\N	\N	\N	78803	78803	78804
18387	25274	2	applied	\N	\N	\N	\N	78805	78805	78806
18394	25277	0	applied	\N	\N	\N	\N	78822	78822	78823
18394	25278	1	applied	\N	\N	\N	\N	78824	78824	78825
18396	25282	0	applied	\N	\N	\N	\N	78836	78836	78837
18396	25283	1	applied	\N	\N	\N	\N	78838	78838	78839
18399	25289	0	applied	\N	\N	\N	\N	78855	78855	78856
18399	25290	1	applied	\N	\N	\N	\N	78857	78857	78858
18399	25291	2	applied	\N	\N	\N	\N	78859	78859	78860
18399	25292	3	applied	\N	\N	\N	\N	78861	78861	78862
18401	25293	0	applied	\N	\N	\N	\N	78866	78866	78867
18401	25294	1	applied	\N	\N	\N	\N	78868	78868	78869
18404	25295	0	applied	\N	\N	\N	\N	78872	78872	78873
18404	25296	1	applied	\N	\N	\N	\N	78874	78874	78875
18404	25297	2	applied	\N	\N	\N	\N	78876	78876	78877
18411	25312	0	applied	\N	\N	\N	\N	78916	78916	78917
18411	25313	1	applied	\N	\N	\N	\N	78918	78918	78919
18411	25314	2	applied	\N	\N	\N	\N	78920	78920	78921
18413	25312	0	applied	\N	\N	\N	\N	78916	78916	78917
18413	25313	1	applied	\N	\N	\N	\N	78918	78918	78919
18413	25314	2	applied	\N	\N	\N	\N	78920	78920	78921
18414	25315	0	applied	\N	\N	\N	\N	78923	78923	78924
18414	25316	1	applied	\N	\N	\N	\N	78925	78925	78926
18414	25317	2	applied	\N	\N	\N	\N	78927	78927	78928
18414	25318	3	applied	\N	\N	\N	\N	78929	78929	78930
18414	25319	4	applied	\N	\N	\N	\N	78931	78931	78932
18414	25320	5	applied	\N	\N	\N	\N	78933	78933	78934
18414	25321	6	applied	\N	\N	\N	\N	78935	78935	78936
18414	25322	7	applied	\N	\N	\N	\N	78937	78937	78938
18414	25323	8	applied	\N	\N	\N	\N	78939	78939	78940
18414	25324	9	applied	\N	\N	\N	\N	78941	78941	78942
18416	25315	0	applied	\N	\N	\N	\N	78923	78923	78924
18284	24996	0	applied	\N	\N	\N	\N	77953	77953	77954
18284	24998	1	applied	\N	\N	\N	\N	77961	77961	77962
18284	24999	2	applied	\N	\N	\N	\N	77963	77963	77964
18284	25003	3	applied	\N	\N	\N	\N	77976	77976	77977
18284	25005	4	applied	\N	\N	\N	\N	77981	77981	77982
18284	25007	5	applied	\N	\N	\N	\N	77987	77987	77988
18284	25008	6	applied	\N	\N	\N	\N	77989	77989	77990
18284	25009	7	applied	\N	\N	\N	\N	77991	77991	77992
18284	25014	8	applied	\N	\N	\N	\N	78002	78002	78003
18284	25017	9	applied	\N	\N	\N	\N	78010	78010	78011
18284	25019	10	applied	\N	\N	\N	\N	78034	78034	78035
18284	25021	11	applied	\N	\N	\N	\N	78040	78040	78041
18284	25024	12	applied	\N	\N	\N	\N	78050	78050	78051
18284	25026	13	applied	\N	\N	\N	\N	78056	78056	78057
18284	25028	14	applied	\N	\N	\N	\N	78062	78062	78063
18284	25030	15	applied	\N	\N	\N	\N	78068	78068	78069
18284	25031	16	applied	\N	\N	\N	\N	78070	78070	78071
18284	25035	17	applied	\N	\N	\N	\N	78080	78080	78081
18284	25037	18	applied	\N	\N	\N	\N	78087	78087	78088
18284	25040	19	applied	\N	\N	\N	\N	78093	78093	78094
18284	25042	20	applied	\N	\N	\N	\N	78100	78100	78101
18284	25043	21	applied	\N	\N	\N	\N	78103	78103	78104
18284	25045	22	applied	\N	\N	\N	\N	78107	78107	78108
18284	25046	23	applied	\N	\N	\N	\N	78109	78109	78110
18284	25050	24	applied	\N	\N	\N	\N	78119	78119	78120
18284	25051	25	applied	\N	\N	\N	\N	78121	78121	78122
18284	25055	26	applied	\N	\N	\N	\N	78132	78132	78133
18284	25056	27	applied	\N	\N	\N	\N	78134	78134	78135
18284	25059	28	applied	\N	\N	\N	\N	78142	78142	78143
18284	25062	29	applied	\N	\N	\N	\N	78150	78150	78151
18284	25064	30	applied	\N	\N	\N	\N	78155	78155	78156
18284	25066	32	applied	\N	\N	\N	\N	78161	78161	78162
18284	25068	33	applied	\N	\N	\N	\N	78167	78167	78168
18284	25069	34	applied	\N	\N	\N	\N	78169	78169	78170
18284	25073	35	applied	\N	\N	\N	\N	78179	78179	78180
18284	25000	36	applied	\N	\N	\N	\N	77965	77965	78019
18284	25010	37	applied	\N	\N	\N	\N	77993	77993	78020
18284	25015	38	applied	\N	\N	\N	\N	78004	78004	77956
18284	25023	39	applied	\N	\N	\N	\N	78046	78046	77966
18284	25032	40	applied	\N	\N	\N	\N	78072	78072	78185
18284	25039	41	applied	\N	\N	\N	\N	78091	78091	78021
18284	25047	42	applied	\N	\N	\N	\N	78111	78111	77968
18284	25054	43	applied	\N	\N	\N	\N	78127	78127	78186
18284	25061	44	applied	\N	\N	\N	\N	78146	78146	78022
18284	25070	45	applied	\N	\N	\N	\N	78171	78171	77970
18284	24997	46	applied	\N	\N	\N	\N	77955	77955	77979
18284	25001	47	applied	\N	\N	\N	\N	77967	77967	77984
18284	25002	48	applied	\N	\N	\N	\N	77969	77969	78187
18284	25004	49	applied	\N	\N	\N	\N	77978	77978	78188
18284	25006	50	applied	\N	\N	\N	\N	77983	77983	78189
18284	25011	51	applied	\N	\N	\N	\N	77995	77995	78190
18284	25012	52	applied	\N	\N	\N	\N	77997	77997	78191
18284	25013	53	applied	\N	\N	\N	\N	77999	77999	78192
18284	25016	54	applied	\N	\N	\N	\N	78006	78006	78193
18284	25018	55	applied	\N	\N	\N	\N	78012	78012	78047
18284	25020	56	applied	\N	\N	\N	\N	78036	78036	78053
18284	25022	57	applied	\N	\N	\N	\N	78042	78042	78059
18284	25025	58	applied	\N	\N	\N	\N	78052	78052	78065
18284	25027	59	applied	\N	\N	\N	\N	78058	78058	78194
18284	25029	60	applied	\N	\N	\N	\N	78064	78064	78195
18284	25033	61	applied	\N	\N	\N	\N	78074	78074	78196
18284	25034	62	applied	\N	\N	\N	\N	78076	78076	78197
18284	25036	63	applied	\N	\N	\N	\N	78082	78082	78198
18284	25038	64	applied	\N	\N	\N	\N	78089	78089	78199
18284	25041	65	applied	\N	\N	\N	\N	78095	78095	78112
18284	25044	66	applied	\N	\N	\N	\N	78105	78105	78114
18284	25048	67	applied	\N	\N	\N	\N	78113	78113	78116
18284	25049	68	applied	\N	\N	\N	\N	78115	78115	78124
18284	25052	69	applied	\N	\N	\N	\N	78123	78123	78126
18284	25053	70	applied	\N	\N	\N	\N	78125	78125	78200
18284	25057	71	applied	\N	\N	\N	\N	78136	78136	78201
18284	25058	72	applied	\N	\N	\N	\N	78138	78138	78202
18284	25060	73	applied	\N	\N	\N	\N	78144	78144	78203
18284	25063	74	applied	\N	\N	\N	\N	78152	78152	78204
18284	25065	75	applied	\N	\N	\N	\N	78157	78157	78205
18284	25067	76	applied	\N	\N	\N	\N	78163	78163	78172
18284	25071	77	applied	\N	\N	\N	\N	78173	78173	78174
18284	25072	78	applied	\N	\N	\N	\N	78175	78175	78176
18284	25074	79	applied	\N	\N	\N	\N	78181	78181	78182
18290	25091	0	applied	\N	\N	\N	\N	78246	78246	78247
18290	25092	1	applied	\N	\N	\N	\N	78248	78248	78249
18290	25093	2	applied	\N	\N	\N	\N	78250	78250	5488
18294	25094	0	applied	\N	\N	\N	\N	78253	78253	78254
18294	25095	1	applied	\N	\N	\N	\N	78255	78255	78256
18294	25096	2	applied	\N	\N	\N	\N	78257	78257	78258
18296	25097	0	applied	\N	\N	\N	\N	78262	78262	78263
18296	25098	1	applied	\N	\N	\N	\N	78264	78264	78265
18300	25097	0	applied	\N	\N	\N	\N	78262	78262	78263
18302	25099	0	applied	\N	\N	\N	\N	78272	78272	78273
18302	25100	1	applied	\N	\N	\N	\N	78274	78274	78275
18302	25101	2	applied	\N	\N	\N	\N	78276	78276	78277
18308	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18308	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18308	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18308	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18308	25111	4	applied	\N	\N	\N	\N	78305	78305	78306
18308	25112	5	applied	\N	\N	\N	\N	78307	78307	78308
18308	25113	6	applied	\N	\N	\N	\N	78309	78309	78310
18308	25114	7	applied	\N	\N	\N	\N	78311	78311	78312
18308	25115	8	applied	\N	\N	\N	\N	78313	78313	78314
18308	25116	9	applied	\N	\N	\N	\N	78315	78315	78316
18308	25117	10	applied	\N	\N	\N	\N	78317	78317	78318
18308	25118	11	applied	\N	\N	\N	\N	78319	78319	78320
18308	25119	12	applied	\N	\N	\N	\N	78321	78321	78322
18308	25120	13	applied	\N	\N	\N	\N	78323	78323	78324
18308	25121	14	applied	\N	\N	\N	\N	78325	78325	5488
18308	25122	15	applied	\N	\N	\N	\N	78326	78326	78327
18308	25123	16	applied	\N	\N	\N	\N	78328	78328	78329
18308	25124	17	applied	\N	\N	\N	\N	78330	78330	78331
18308	25125	18	applied	\N	\N	\N	\N	78332	78332	78333
18310	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18310	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18310	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18310	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18310	25111	4	applied	\N	\N	\N	\N	78305	78305	78306
18310	25112	5	applied	\N	\N	\N	\N	78307	78307	78308
18310	25113	6	applied	\N	\N	\N	\N	78309	78309	78310
18310	25114	7	applied	\N	\N	\N	\N	78311	78311	78312
18310	25115	8	applied	\N	\N	\N	\N	78313	78313	78314
18310	25116	9	applied	\N	\N	\N	\N	78315	78315	78316
18310	25117	10	applied	\N	\N	\N	\N	78317	78317	78318
18310	25118	11	applied	\N	\N	\N	\N	78319	78319	78320
18310	25119	12	applied	\N	\N	\N	\N	78321	78321	78322
18310	25120	13	applied	\N	\N	\N	\N	78323	78323	78324
18310	25121	14	applied	\N	\N	\N	\N	78325	78325	5488
18310	25122	15	applied	\N	\N	\N	\N	78326	78326	78327
18310	25123	16	applied	\N	\N	\N	\N	78328	78328	78329
18310	25124	17	applied	\N	\N	\N	\N	78330	78330	78331
18310	25125	18	applied	\N	\N	\N	\N	78332	78332	78333
18313	25128	0	applied	\N	\N	\N	\N	78345	78345	78346
18313	25129	1	applied	\N	\N	\N	\N	78347	78347	78348
18313	25130	2	applied	\N	\N	\N	\N	78349	78349	78350
18315	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18315	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18315	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18315	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18315	25075	4	applied	\N	\N	\N	\N	78209	78209	78210
18315	25079	5	applied	\N	\N	\N	\N	78222	78222	78223
18315	25080	6	applied	\N	\N	\N	\N	78224	78224	78225
18315	25078	7	applied	\N	\N	\N	\N	78219	78219	78220
18315	25081	8	applied	\N	\N	\N	\N	78226	78226	78227
18315	25085	9	applied	\N	\N	\N	\N	78234	78234	78235
18315	25091	10	applied	\N	\N	\N	\N	78246	78246	78247
18315	25094	11	applied	\N	\N	\N	\N	78253	78253	78254
18315	25086	12	applied	\N	\N	\N	\N	78236	78236	78237
18315	25087	13	applied	\N	\N	\N	\N	78238	78238	78239
18315	25097	14	applied	\N	\N	\N	\N	78262	78262	78263
18315	25099	15	applied	\N	\N	\N	\N	78272	78272	78273
18315	25102	16	applied	\N	\N	\N	\N	78281	78281	78282
18315	25104	17	applied	\N	\N	\N	\N	78290	78290	78291
18315	25111	18	applied	\N	\N	\N	\N	78305	78305	78306
18315	25112	19	applied	\N	\N	\N	\N	78307	78307	78308
18315	25113	20	applied	\N	\N	\N	\N	78309	78309	78310
18315	25114	21	applied	\N	\N	\N	\N	78311	78311	78312
18315	25115	22	applied	\N	\N	\N	\N	78313	78313	78314
18315	25126	23	applied	\N	\N	\N	\N	78339	78339	78340
18315	25128	24	applied	\N	\N	\N	\N	78345	78345	78346
18315	25129	25	applied	\N	\N	\N	\N	78347	78347	78355
18315	25076	26	applied	\N	\N	\N	\N	78211	78211	78212
18315	25088	27	applied	\N	\N	\N	\N	78240	78240	78356
18315	25077	28	applied	\N	\N	\N	\N	78213	78213	78357
18315	25096	29	applied	\N	\N	\N	\N	78257	78257	78258
18315	25082	30	applied	\N	\N	\N	\N	78228	78228	5488
18315	25089	31	applied	\N	\N	\N	\N	78242	78242	5488
18315	25093	32	applied	\N	\N	\N	\N	78250	78250	5488
18315	25100	33	applied	\N	\N	\N	\N	78274	78274	78358
18315	25121	34	applied	\N	\N	\N	\N	78325	78325	5488
18315	25083	35	applied	\N	\N	\N	\N	78229	78229	78359
18315	25084	36	applied	\N	\N	\N	\N	78231	78231	78360
18315	25090	37	applied	\N	\N	\N	\N	78243	78243	78361
18315	25092	38	applied	\N	\N	\N	\N	78248	78248	78362
18315	25095	39	applied	\N	\N	\N	\N	78255	78255	78363
18315	25098	40	applied	\N	\N	\N	\N	78264	78264	78275
18315	25103	41	applied	\N	\N	\N	\N	78283	78283	78284
18315	25105	42	applied	\N	\N	\N	\N	78292	78292	78293
18315	25116	43	applied	\N	\N	\N	\N	78315	78315	78316
18315	25117	44	applied	\N	\N	\N	\N	78317	78317	78318
18315	25118	45	applied	\N	\N	\N	\N	78319	78319	78320
18315	25119	46	applied	\N	\N	\N	\N	78321	78321	78322
18315	25120	47	applied	\N	\N	\N	\N	78323	78323	78324
18315	25127	48	applied	\N	\N	\N	\N	78341	78341	78364
18315	25130	49	applied	\N	\N	\N	\N	78349	78349	78365
18315	25122	50	applied	\N	\N	\N	\N	78326	78326	78366
18315	25123	51	applied	\N	\N	\N	\N	78328	78328	78350
18315	25101	52	applied	\N	\N	\N	\N	78276	78276	78277
18315	25106	53	applied	\N	\N	\N	\N	78294	78294	78295
18315	25124	54	applied	\N	\N	\N	\N	78330	78330	78367
18315	25125	55	applied	\N	\N	\N	\N	78332	78332	78348
18317	25131	0	applied	\N	\N	\N	\N	78370	78370	78371
18317	25132	1	applied	\N	\N	\N	\N	78372	78372	78373
18317	25133	2	applied	\N	\N	\N	\N	78374	78374	78375
18317	25134	3	applied	\N	\N	\N	\N	78376	78376	78377
18317	25135	4	applied	\N	\N	\N	\N	78378	78378	78379
18317	25136	5	applied	\N	\N	\N	\N	78380	78380	78381
18317	25137	6	applied	\N	\N	\N	\N	78382	78382	78383
18317	25138	7	applied	\N	\N	\N	\N	78384	78384	78385
18317	25139	8	applied	\N	\N	\N	\N	78386	78386	78387
18321	25142	0	applied	\N	\N	\N	\N	78395	78395	78396
18321	25143	1	applied	\N	\N	\N	\N	78397	78397	78398
18323	25144	0	applied	\N	\N	\N	\N	78403	78403	78404
18323	25145	1	applied	\N	\N	\N	\N	78405	78405	78406
18325	25148	0	applied	\N	\N	\N	\N	78413	78413	78414
18325	25149	1	applied	\N	\N	\N	\N	78415	78415	78416
18330	25155	0	applied	\N	\N	\N	\N	78436	78436	78437
18330	25156	1	applied	\N	\N	\N	\N	78438	78438	78439
18330	25157	2	applied	\N	\N	\N	\N	78440	78440	78441
18330	25158	3	applied	\N	\N	\N	\N	78442	78442	78443
18330	25159	4	applied	\N	\N	\N	\N	78444	78444	78445
18333	25162	0	applied	\N	\N	\N	\N	78454	78454	78455
18333	25163	1	applied	\N	\N	\N	\N	78456	78456	78457
18333	25164	2	applied	\N	\N	\N	\N	78458	78458	78459
18333	25165	3	applied	\N	\N	\N	\N	78460	78460	78461
18333	25166	4	applied	\N	\N	\N	\N	78462	78462	78463
18336	25170	0	applied	\N	\N	\N	\N	78475	78475	78476
18336	25171	1	applied	\N	\N	\N	\N	78477	78477	78478
18336	25172	2	applied	\N	\N	\N	\N	78479	78479	78480
18336	25173	3	applied	\N	\N	\N	\N	78481	78481	78482
18336	25174	4	applied	\N	\N	\N	\N	78483	78483	78484
18338	25175	0	applied	\N	\N	\N	\N	78488	78488	78489
18338	25176	1	applied	\N	\N	\N	\N	78490	78490	78491
18343	25186	0	applied	\N	\N	\N	\N	78513	78513	78514
18343	25187	1	applied	\N	\N	\N	\N	78515	78515	78516
18346	25193	0	applied	\N	\N	\N	\N	78530	78530	78531
18346	25194	1	applied	\N	\N	\N	\N	78532	78532	78533
18346	25195	2	applied	\N	\N	\N	\N	78534	78534	78535
18346	25196	3	applied	\N	\N	\N	\N	78536	78536	78537
18346	25197	4	applied	\N	\N	\N	\N	78538	78538	78538
18346	25198	5	applied	\N	\N	\N	\N	78539	78539	78540
18346	25199	6	applied	\N	\N	\N	\N	78541	78541	78542
18348	25193	0	applied	\N	\N	\N	\N	78530	78530	78531
18348	25194	1	applied	\N	\N	\N	\N	78532	78532	78533
18348	25195	2	applied	\N	\N	\N	\N	78534	78534	78535
18348	25196	3	applied	\N	\N	\N	\N	78536	78536	78537
18348	25197	4	applied	\N	\N	\N	\N	78538	78538	78538
18348	25198	5	applied	\N	\N	\N	\N	78539	78539	78540
18348	25199	6	applied	\N	\N	\N	\N	78541	78541	78542
18356	25218	0	applied	\N	\N	\N	\N	78590	78590	78591
18356	25219	1	applied	\N	\N	\N	\N	78592	78592	78593
18356	25220	2	applied	\N	\N	\N	\N	78594	78594	78595
18359	25227	0	applied	\N	\N	\N	\N	78615	78615	78616
18359	25228	1	applied	\N	\N	\N	\N	78617	78617	78618
18361	25227	0	applied	\N	\N	\N	\N	78615	78615	78616
18361	25228	1	applied	\N	\N	\N	\N	78617	78617	78618
18363	25229	0	applied	\N	\N	\N	\N	78623	78623	78624
18363	25230	1	applied	\N	\N	\N	\N	78625	78625	78626
18366	25236	0	applied	\N	\N	\N	\N	78640	78640	78641
18366	25237	1	applied	\N	\N	\N	\N	78642	78642	78643
18370	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18370	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18370	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18370	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18370	25131	4	applied	\N	\N	\N	\N	78370	78370	78371
18370	25132	5	applied	\N	\N	\N	\N	78372	78372	78373
18370	25133	6	applied	\N	\N	\N	\N	78374	78374	78375
18370	25134	7	applied	\N	\N	\N	\N	78376	78376	78377
18370	25079	8	applied	\N	\N	\N	\N	78222	78222	78223
18370	25080	9	applied	\N	\N	\N	\N	78224	78224	78225
18370	25086	11	applied	\N	\N	\N	\N	78236	78236	78237
18370	25087	12	applied	\N	\N	\N	\N	78238	78238	78239
18370	25019	13	applied	\N	\N	\N	\N	78034	78034	78035
18370	25021	14	applied	\N	\N	\N	\N	78040	78040	78041
18370	25024	15	applied	\N	\N	\N	\N	78050	78050	78051
18370	25026	16	applied	\N	\N	\N	\N	78056	78056	78057
18370	25028	17	applied	\N	\N	\N	\N	78062	78062	78063
18370	25030	18	applied	\N	\N	\N	\N	78068	78068	78069
18370	25031	19	applied	\N	\N	\N	\N	78070	78070	78071
18370	25035	20	applied	\N	\N	\N	\N	78080	78080	78081
18370	25037	21	applied	\N	\N	\N	\N	78087	78087	78088
18370	25040	22	applied	\N	\N	\N	\N	78093	78093	78094
18370	25042	23	applied	\N	\N	\N	\N	78100	78100	78101
18370	25043	24	applied	\N	\N	\N	\N	78103	78103	78104
18370	25045	25	applied	\N	\N	\N	\N	78107	78107	78108
18370	25046	26	applied	\N	\N	\N	\N	78109	78109	78110
18370	25050	27	applied	\N	\N	\N	\N	78119	78119	78120
18370	25051	28	applied	\N	\N	\N	\N	78121	78121	78122
18370	25055	29	applied	\N	\N	\N	\N	78132	78132	78133
18370	25056	30	applied	\N	\N	\N	\N	78134	78134	78135
18370	25059	31	applied	\N	\N	\N	\N	78142	78142	78143
18370	25062	32	applied	\N	\N	\N	\N	78150	78150	78151
18370	25064	33	applied	\N	\N	\N	\N	78155	78155	78156
18370	25066	34	applied	\N	\N	\N	\N	78161	78161	78162
18370	25068	35	applied	\N	\N	\N	\N	78167	78167	78168
18370	25069	36	applied	\N	\N	\N	\N	78169	78169	78170
18370	25073	37	applied	\N	\N	\N	\N	78179	78179	78180
18370	25075	38	applied	\N	\N	\N	\N	78209	78209	78210
18370	25078	39	applied	\N	\N	\N	\N	78219	78219	78220
18370	25081	40	applied	\N	\N	\N	\N	78226	78226	78227
18370	25085	41	applied	\N	\N	\N	\N	78234	78234	78235
18370	25091	42	applied	\N	\N	\N	\N	78246	78246	78247
18370	25094	43	applied	\N	\N	\N	\N	78253	78253	78254
18370	25097	44	applied	\N	\N	\N	\N	78262	78262	78263
18370	25099	45	applied	\N	\N	\N	\N	78272	78272	78273
18370	25102	46	applied	\N	\N	\N	\N	78281	78281	78282
18370	25104	47	applied	\N	\N	\N	\N	78290	78290	78291
18370	25111	48	applied	\N	\N	\N	\N	78305	78305	78306
18370	25112	49	applied	\N	\N	\N	\N	78307	78307	78308
18370	25113	50	applied	\N	\N	\N	\N	78309	78309	78310
18370	25114	51	applied	\N	\N	\N	\N	78311	78311	78312
18370	25115	52	applied	\N	\N	\N	\N	78313	78313	78314
18370	25126	53	applied	\N	\N	\N	\N	78339	78339	78340
18370	25128	54	applied	\N	\N	\N	\N	78345	78345	78346
18370	25135	55	applied	\N	\N	\N	\N	78378	78378	78379
18370	25136	56	applied	\N	\N	\N	\N	78380	78380	78381
18370	25140	57	applied	\N	\N	\N	\N	78389	78389	78390
18370	25142	58	applied	\N	\N	\N	\N	78395	78395	78396
18370	25144	59	applied	\N	\N	\N	\N	78403	78403	78404
18370	25146	60	applied	\N	\N	\N	\N	78409	78409	78410
18370	25150	61	applied	\N	\N	\N	\N	78419	78419	78420
18370	25151	62	applied	\N	\N	\N	\N	78424	78424	78425
18370	25152	63	applied	\N	\N	\N	\N	78426	78426	78427
18370	25155	64	applied	\N	\N	\N	\N	78436	78436	78437
18370	25156	65	applied	\N	\N	\N	\N	78438	78438	78439
18370	25160	66	applied	\N	\N	\N	\N	78448	78448	78449
18370	25162	67	applied	\N	\N	\N	\N	78454	78454	78455
18370	25163	68	applied	\N	\N	\N	\N	78456	78456	78457
18370	25167	69	applied	\N	\N	\N	\N	78466	78466	78467
18370	25169	70	applied	\N	\N	\N	\N	78471	78471	78472
18370	25170	71	applied	\N	\N	\N	\N	78475	78475	78476
18370	25171	72	applied	\N	\N	\N	\N	78477	78477	78478
18370	25175	73	applied	\N	\N	\N	\N	78488	78488	78489
18370	25177	74	applied	\N	\N	\N	\N	78493	78493	78494
18370	25178	75	applied	\N	\N	\N	\N	78495	78495	78496
18370	25179	76	applied	\N	\N	\N	\N	78497	78497	78498
18370	25186	77	applied	\N	\N	\N	\N	78513	78513	78514
18370	25188	78	applied	\N	\N	\N	\N	78521	78521	78522
18370	25193	79	applied	\N	\N	\N	\N	78530	78530	78531
18370	25194	80	applied	\N	\N	\N	\N	78532	78532	78533
18370	25195	81	applied	\N	\N	\N	\N	78534	78534	78535
18370	25200	82	applied	\N	\N	\N	\N	78550	78550	78551
18370	25207	83	applied	\N	\N	\N	\N	78562	78562	78563
18370	25209	84	applied	\N	\N	\N	\N	78568	78568	78569
18370	25210	85	applied	\N	\N	\N	\N	78570	78570	78571
18370	25214	86	applied	\N	\N	\N	\N	78579	78579	78580
18370	25216	87	applied	\N	\N	\N	\N	78584	78584	78585
18370	25218	88	applied	\N	\N	\N	\N	78590	78590	78591
18370	25221	89	applied	\N	\N	\N	\N	78600	78600	78601
18370	25222	90	applied	\N	\N	\N	\N	78602	78602	78603
18370	25225	91	applied	\N	\N	\N	\N	78609	78609	78610
18370	25227	92	applied	\N	\N	\N	\N	78615	78615	78616
18370	25229	93	applied	\N	\N	\N	\N	78623	78623	78624
18370	25231	94	applied	\N	\N	\N	\N	78628	78628	78629
18370	25232	95	applied	\N	\N	\N	\N	78630	78630	78631
18370	25236	96	applied	\N	\N	\N	\N	78640	78640	78641
18370	25238	97	applied	\N	\N	\N	\N	78651	78651	78652
18370	25239	98	applied	\N	\N	\N	\N	78653	78653	78654
18370	25129	99	applied	\N	\N	\N	\N	78347	78347	78355
18370	25096	100	applied	\N	\N	\N	\N	78257	78257	78258
18370	25082	101	applied	\N	\N	\N	\N	78228	78228	5488
18370	25089	102	applied	\N	\N	\N	\N	78242	78242	5488
18370	25093	103	applied	\N	\N	\N	\N	78250	78250	5488
18370	25020	104	applied	\N	\N	\N	\N	78036	78036	78037
18370	25023	105	applied	\N	\N	\N	\N	78046	78046	78193
18370	25032	106	applied	\N	\N	\N	\N	78072	78072	78666
18370	25121	107	applied	\N	\N	\N	\N	78325	78325	5488
18370	25101	108	applied	\N	\N	\N	\N	78276	78276	78277
18370	25106	109	applied	\N	\N	\N	\N	78294	78294	78295
18370	25182	110	applied	\N	\N	\N	\N	78503	78503	78503
18370	25183	111	applied	\N	\N	\N	\N	78504	78504	78504
18370	25191	112	applied	\N	\N	\N	\N	78527	78527	78527
18370	25192	113	applied	\N	\N	\N	\N	78528	78528	78528
18367	24904	54	applied	\N	\N	\N	\N	77634	77634	77635
18367	24909	55	applied	\N	\N	\N	\N	77648	77648	77649
18367	24910	56	applied	\N	\N	\N	\N	77650	77650	77651
18367	24913	57	applied	\N	\N	\N	\N	77658	77658	77659
18367	24914	58	applied	\N	\N	\N	\N	77660	77660	77661
18367	24920	59	applied	\N	\N	\N	\N	77674	77674	77675
18367	24921	60	applied	\N	\N	\N	\N	77676	77676	77677
18367	24922	61	applied	\N	\N	\N	\N	77678	77678	77679
18367	24923	62	applied	\N	\N	\N	\N	77680	77680	77681
18367	24929	63	applied	\N	\N	\N	\N	77696	77696	77697
18367	24931	64	applied	\N	\N	\N	\N	77702	77702	77703
18367	24934	65	applied	\N	\N	\N	\N	77713	77713	77714
18367	24935	66	applied	\N	\N	\N	\N	77715	77715	77716
18367	24939	67	applied	\N	\N	\N	\N	77747	77747	77748
18367	24941	68	applied	\N	\N	\N	\N	77753	77753	77754
18367	24943	69	applied	\N	\N	\N	\N	77760	77760	77761
18367	24945	70	applied	\N	\N	\N	\N	77768	77768	77769
18367	24952	71	applied	\N	\N	\N	\N	77785	77785	77786
18367	24953	72	applied	\N	\N	\N	\N	77787	77787	77788
18367	24954	73	applied	\N	\N	\N	\N	77791	77791	77792
18367	24955	74	applied	\N	\N	\N	\N	77793	77793	77794
18367	24956	75	applied	\N	\N	\N	\N	77795	77795	77796
18367	24962	76	applied	\N	\N	\N	\N	77810	77810	77811
18367	24966	77	applied	\N	\N	\N	\N	77821	77821	77822
18367	24971	78	applied	\N	\N	\N	\N	77832	77832	77833
18367	24973	79	applied	\N	\N	\N	\N	77845	77845	77846
18367	24974	80	applied	\N	\N	\N	\N	77847	77847	77848
18367	24978	81	applied	\N	\N	\N	\N	77856	77856	77857
18367	24981	82	applied	\N	\N	\N	\N	77905	77905	77906
18367	24985	83	applied	\N	\N	\N	\N	77914	77914	77915
18367	24988	84	applied	\N	\N	\N	\N	77921	77921	77922
18367	24990	85	applied	\N	\N	\N	\N	77926	77926	77927
18367	24992	86	applied	\N	\N	\N	\N	77938	77938	77939
18367	24995	87	applied	\N	\N	\N	\N	77948	77948	77949
18367	24996	88	applied	\N	\N	\N	\N	77953	77953	77954
18367	24998	89	applied	\N	\N	\N	\N	77961	77961	77962
18367	24999	90	applied	\N	\N	\N	\N	77963	77963	77964
18367	25003	91	applied	\N	\N	\N	\N	77976	77976	77977
18367	25005	92	applied	\N	\N	\N	\N	77981	77981	77982
18367	25007	93	applied	\N	\N	\N	\N	77987	77987	77988
18367	25008	94	applied	\N	\N	\N	\N	77989	77989	77990
18367	25009	95	applied	\N	\N	\N	\N	77991	77991	77992
18367	25014	96	applied	\N	\N	\N	\N	78002	78002	78003
18367	25017	97	applied	\N	\N	\N	\N	78010	78010	78011
18367	25019	98	applied	\N	\N	\N	\N	78034	78034	78035
18367	25021	99	applied	\N	\N	\N	\N	78040	78040	78041
18367	25024	100	applied	\N	\N	\N	\N	78050	78050	78051
18367	25026	101	applied	\N	\N	\N	\N	78056	78056	78057
18367	25028	102	applied	\N	\N	\N	\N	78062	78062	78063
18367	25030	103	applied	\N	\N	\N	\N	78068	78068	78069
18367	25031	104	applied	\N	\N	\N	\N	78070	78070	78071
18367	25035	105	applied	\N	\N	\N	\N	78080	78080	78081
18367	25037	106	applied	\N	\N	\N	\N	78087	78087	78088
18367	25040	107	applied	\N	\N	\N	\N	78093	78093	78094
18367	25042	108	applied	\N	\N	\N	\N	78100	78100	78101
18367	25043	109	applied	\N	\N	\N	\N	78103	78103	78104
18367	25045	110	applied	\N	\N	\N	\N	78107	78107	78108
18367	25046	111	applied	\N	\N	\N	\N	78109	78109	78110
18367	25050	112	applied	\N	\N	\N	\N	78119	78119	78120
18367	25051	113	applied	\N	\N	\N	\N	78121	78121	78122
18367	25055	114	applied	\N	\N	\N	\N	78132	78132	78133
18367	25056	115	applied	\N	\N	\N	\N	78134	78134	78135
18367	25059	116	applied	\N	\N	\N	\N	78142	78142	78143
18367	25062	117	applied	\N	\N	\N	\N	78150	78150	78151
18367	25064	118	applied	\N	\N	\N	\N	78155	78155	78156
18367	25066	119	applied	\N	\N	\N	\N	78161	78161	78162
18367	25068	120	applied	\N	\N	\N	\N	78167	78167	78168
18367	25069	121	applied	\N	\N	\N	\N	78169	78169	78170
18367	25073	122	applied	\N	\N	\N	\N	78179	78179	78180
18367	25075	123	applied	\N	\N	\N	\N	78209	78209	78210
18367	25078	124	applied	\N	\N	\N	\N	78219	78219	78220
18372	25243	0	applied	\N	\N	\N	\N	78675	78675	78676
18372	25244	1	applied	\N	\N	\N	\N	78677	78677	78678
18375	25249	0	applied	\N	\N	\N	\N	78695	78695	78696
18375	25250	1	applied	\N	\N	\N	\N	78697	78697	78698
18375	25251	2	applied	\N	\N	\N	\N	78699	78699	78700
18377	25252	0	applied	\N	\N	\N	\N	78705	78705	78706
18377	25253	1	applied	\N	\N	\N	\N	78707	78707	78708
18380	25256	0	applied	\N	\N	\N	\N	78718	78718	78719
18380	25257	2	applied	\N	\N	\N	\N	78721	78721	78722
18380	25258	3	applied	\N	\N	\N	\N	78723	78723	78724
18380	25259	4	applied	\N	\N	\N	\N	78725	78725	78726
18380	25260	5	applied	\N	\N	\N	\N	78727	78727	78728
18385	25266	0	applied	\N	\N	\N	\N	78786	78786	78787
18385	25267	1	applied	\N	\N	\N	\N	78788	78788	78789
18388	25272	0	applied	\N	\N	\N	\N	78801	78801	78802
18388	25273	1	applied	\N	\N	\N	\N	78803	78803	78804
18388	25274	2	applied	\N	\N	\N	\N	78805	78805	78806
18390	25275	0	applied	\N	\N	\N	\N	78812	78812	78813
18390	25276	1	applied	\N	\N	\N	\N	78814	78814	78815
18397	25284	0	applied	\N	\N	\N	\N	78842	78842	78843
18397	25285	1	applied	\N	\N	\N	\N	78844	78844	78845
18400	25289	0	applied	\N	\N	\N	\N	78855	78855	78856
18400	25290	1	applied	\N	\N	\N	\N	78857	78857	78858
18400	25291	2	applied	\N	\N	\N	\N	78859	78859	78860
18400	25292	3	applied	\N	\N	\N	\N	78861	78861	78862
18403	25295	0	applied	\N	\N	\N	\N	78872	78872	78873
18403	25296	1	applied	\N	\N	\N	\N	78874	78874	78875
18403	25297	2	applied	\N	\N	\N	\N	78876	78876	78877
18405	25298	0	applied	\N	\N	\N	\N	78884	78884	78885
18405	25299	1	applied	\N	\N	\N	\N	78886	78886	78887
18405	25300	2	applied	\N	\N	\N	\N	78888	78888	78889
18407	25301	0	applied	\N	\N	\N	\N	78892	78892	78893
18407	25302	1	applied	\N	\N	\N	\N	78894	78894	78895
18407	25303	2	applied	\N	\N	\N	\N	78896	78896	78897
18410	25309	0	applied	\N	\N	\N	\N	78909	78909	78910
18410	25310	1	applied	\N	\N	\N	\N	78911	78911	78912
18410	25311	2	applied	\N	\N	\N	\N	78913	78913	78914
18415	25315	0	applied	\N	\N	\N	\N	78923	78923	78924
18415	25316	1	applied	\N	\N	\N	\N	78925	78925	78926
18415	25317	2	applied	\N	\N	\N	\N	78927	78927	78928
18415	25318	3	applied	\N	\N	\N	\N	78929	78929	78930
18415	25319	4	applied	\N	\N	\N	\N	78931	78931	78932
18415	25320	5	applied	\N	\N	\N	\N	78933	78933	78934
18415	25321	6	applied	\N	\N	\N	\N	78935	78935	78936
18415	25322	7	applied	\N	\N	\N	\N	78937	78937	78938
18415	25323	8	applied	\N	\N	\N	\N	78939	78939	78940
18415	25324	9	applied	\N	\N	\N	\N	78941	78941	78942
18417	25325	0	applied	\N	\N	\N	\N	78949	78949	78950
18417	25326	1	applied	\N	\N	\N	\N	78951	78951	78952
18370	25197	114	applied	\N	\N	\N	\N	78538	78538	78538
18370	25039	115	applied	\N	\N	\N	\N	78091	78091	78043
18370	25047	116	applied	\N	\N	\N	\N	78111	78111	78047
18370	25054	117	applied	\N	\N	\N	\N	78127	78127	78667
18370	25061	118	applied	\N	\N	\N	\N	78146	78146	78668
18370	25070	119	applied	\N	\N	\N	\N	78171	78171	78053
18370	25076	120	applied	\N	\N	\N	\N	78211	78211	78669
18370	25088	121	applied	\N	\N	\N	\N	78240	78240	78670
18370	25100	122	applied	\N	\N	\N	\N	78274	78274	78059
18370	25122	123	applied	\N	\N	\N	\N	78326	78326	78671
18370	25123	124	applied	\N	\N	\N	\N	78328	78328	78672
18370	25137	125	applied	\N	\N	\N	\N	78382	78382	78065
18373	25245	0	applied	\N	\N	\N	\N	78683	78683	78684
18373	25246	1	applied	\N	\N	\N	\N	78685	78685	78686
18378	25254	0	applied	\N	\N	\N	\N	78711	78711	78712
18378	25255	1	applied	\N	\N	\N	\N	78713	78713	78714
18381	25243	0	applied	\N	\N	\N	\N	78675	78675	78676
18381	25245	1	applied	\N	\N	\N	\N	78683	78683	78684
18381	25247	2	applied	\N	\N	\N	\N	78689	78689	78690
18381	25249	3	applied	\N	\N	\N	\N	78695	78695	78696
18381	25252	4	applied	\N	\N	\N	\N	78705	78705	78706
18381	25254	5	applied	\N	\N	\N	\N	78711	78711	78712
18381	25256	6	applied	\N	\N	\N	\N	78718	78718	78719
18381	25257	7	applied	\N	\N	\N	\N	78721	78721	78722
18381	25143	8	applied	\N	\N	\N	\N	78397	78397	78073
18381	25149	9	applied	\N	\N	\N	\N	78415	78415	78731
18381	25159	11	applied	\N	\N	\N	\N	78444	78444	78194
18381	25166	12	applied	\N	\N	\N	\N	78462	78462	78075
18381	25172	13	applied	\N	\N	\N	\N	78479	78479	78733
18381	25180	14	applied	\N	\N	\N	\N	78499	78499	78195
18381	25190	15	applied	\N	\N	\N	\N	78525	78525	78077
18381	25201	16	applied	\N	\N	\N	\N	78552	78552	78734
18381	25211	17	applied	\N	\N	\N	\N	78572	78572	78196
18381	25219	18	applied	\N	\N	\N	\N	78592	78592	78083
18381	25228	19	applied	\N	\N	\N	\N	78617	78617	78735
18381	25233	20	applied	\N	\N	\N	\N	78632	78632	78197
18381	25240	21	applied	\N	\N	\N	\N	78655	78655	78090
18381	25251	22	applied	\N	\N	\N	\N	78699	78699	78092
18381	25260	23	applied	\N	\N	\N	\N	78727	78727	78198
18381	25202	24	applied	\N	\N	\N	\N	78554	78554	78554
18381	25203	25	applied	\N	\N	\N	\N	78555	78555	78555
18381	25204	26	applied	\N	\N	\N	\N	78556	78556	78556
18381	25205	27	applied	\N	\N	\N	\N	78557	78557	78557
18381	25124	28	applied	\N	\N	\N	\N	78330	78330	78367
18381	25125	29	applied	\N	\N	\N	\N	78332	78332	78348
18381	25022	30	applied	\N	\N	\N	\N	78042	78042	78199
18381	25025	31	applied	\N	\N	\N	\N	78052	78052	78112
18381	25027	32	applied	\N	\N	\N	\N	78058	78058	78114
18381	25029	33	applied	\N	\N	\N	\N	78064	78064	78116
18381	25033	34	applied	\N	\N	\N	\N	78074	78074	78124
18381	25034	35	applied	\N	\N	\N	\N	78076	78076	78126
18381	25036	36	applied	\N	\N	\N	\N	78082	78082	78200
18381	25038	37	applied	\N	\N	\N	\N	78089	78089	78201
18381	25041	38	applied	\N	\N	\N	\N	78095	78095	78202
18381	25044	39	applied	\N	\N	\N	\N	78105	78105	78203
18381	25048	40	applied	\N	\N	\N	\N	78113	78113	78204
18381	25049	41	applied	\N	\N	\N	\N	78115	78115	78205
18381	25052	42	applied	\N	\N	\N	\N	78123	78123	78172
18381	25053	43	applied	\N	\N	\N	\N	78125	78125	78174
18381	25057	44	applied	\N	\N	\N	\N	78136	78136	78176
18381	25058	45	applied	\N	\N	\N	\N	78138	78138	78182
18381	25060	46	applied	\N	\N	\N	\N	78144	78144	78736
18381	25063	47	applied	\N	\N	\N	\N	78152	78152	78358
18381	25065	48	applied	\N	\N	\N	\N	78157	78157	78359
18381	25067	49	applied	\N	\N	\N	\N	78163	78163	78360
18381	25071	50	applied	\N	\N	\N	\N	78173	78173	78361
18381	25072	51	applied	\N	\N	\N	\N	78175	78175	78362
18381	25074	52	applied	\N	\N	\N	\N	78181	78181	78363
18381	25077	53	applied	\N	\N	\N	\N	78213	78213	78275
18381	25083	54	applied	\N	\N	\N	\N	78229	78229	78284
18381	25084	55	applied	\N	\N	\N	\N	78231	78231	78293
18381	25090	56	applied	\N	\N	\N	\N	78243	78243	78316
18381	25092	57	applied	\N	\N	\N	\N	78248	78248	78318
18381	25095	58	applied	\N	\N	\N	\N	78255	78255	78320
18381	25098	59	applied	\N	\N	\N	\N	78264	78264	78322
18381	25103	60	applied	\N	\N	\N	\N	78283	78283	78324
18381	25105	61	applied	\N	\N	\N	\N	78292	78292	78364
18381	25116	62	applied	\N	\N	\N	\N	78315	78315	78365
18381	25117	63	applied	\N	\N	\N	\N	78317	78317	78383
18381	25118	64	applied	\N	\N	\N	\N	78319	78319	78385
18381	25119	65	applied	\N	\N	\N	\N	78321	78321	78387
18381	25120	66	applied	\N	\N	\N	\N	78323	78323	78392
18381	25127	67	applied	\N	\N	\N	\N	78341	78341	78737
18381	25130	68	applied	\N	\N	\N	\N	78349	78349	78738
18381	25138	69	applied	\N	\N	\N	\N	78384	78384	78739
18381	25139	70	applied	\N	\N	\N	\N	78386	78386	78740
18381	25141	71	applied	\N	\N	\N	\N	78391	78391	78741
18381	25145	72	applied	\N	\N	\N	\N	78405	78405	78742
18381	25147	73	applied	\N	\N	\N	\N	78411	78411	78743
18381	25148	74	applied	\N	\N	\N	\N	78413	78413	78445
18381	25153	75	applied	\N	\N	\N	\N	78428	78428	78451
18381	25154	76	applied	\N	\N	\N	\N	78430	78430	78459
18381	25157	77	applied	\N	\N	\N	\N	78440	78440	78461
18381	25158	78	applied	\N	\N	\N	\N	78442	78442	78744
18381	25161	79	applied	\N	\N	\N	\N	78450	78450	78745
18381	25164	80	applied	\N	\N	\N	\N	78458	78458	78746
18381	25165	81	applied	\N	\N	\N	\N	78460	78460	78747
18381	25168	82	applied	\N	\N	\N	\N	78468	78468	78500
18381	25173	83	applied	\N	\N	\N	\N	78481	78481	78502
18381	25174	84	applied	\N	\N	\N	\N	78483	78483	78506
18381	25176	85	applied	\N	\N	\N	\N	78490	78490	78508
18381	25181	86	applied	\N	\N	\N	\N	78501	78501	78516
18381	25184	87	applied	\N	\N	\N	\N	78505	78505	78524
18381	25185	88	applied	\N	\N	\N	\N	78507	78507	78748
18381	25187	89	applied	\N	\N	\N	\N	78515	78515	78749
18381	25189	90	applied	\N	\N	\N	\N	78523	78523	78750
18381	25196	91	applied	\N	\N	\N	\N	78536	78536	78751
18381	25198	92	applied	\N	\N	\N	\N	78539	78539	78752
18381	25199	93	applied	\N	\N	\N	\N	78541	78541	78573
18381	25206	94	applied	\N	\N	\N	\N	78558	78558	78575
18381	25208	95	applied	\N	\N	\N	\N	78564	78564	78577
18381	25212	96	applied	\N	\N	\N	\N	78574	78574	78582
18381	25213	97	applied	\N	\N	\N	\N	78576	78576	78587
18381	25215	98	applied	\N	\N	\N	\N	78581	78581	78753
18381	25217	99	applied	\N	\N	\N	\N	78586	78586	78754
18381	25220	100	applied	\N	\N	\N	\N	78594	78594	78755
18381	25223	101	applied	\N	\N	\N	\N	78604	78604	78756
18381	25224	102	applied	\N	\N	\N	\N	78606	78606	78757
18381	25226	103	applied	\N	\N	\N	\N	78611	78611	78633
18381	25230	104	applied	\N	\N	\N	\N	78625	78625	78635
18381	25234	105	applied	\N	\N	\N	\N	78634	78634	78637
18381	25235	106	applied	\N	\N	\N	\N	78636	78636	78643
18381	25237	107	applied	\N	\N	\N	\N	78642	78642	78758
18381	25241	108	applied	\N	\N	\N	\N	78657	78657	78759
18381	25242	109	applied	\N	\N	\N	\N	78659	78659	78760
18381	25244	110	applied	\N	\N	\N	\N	78677	78677	78761
18381	25246	111	applied	\N	\N	\N	\N	78685	78685	78762
18381	25248	112	applied	\N	\N	\N	\N	78691	78691	78763
18381	25250	113	applied	\N	\N	\N	\N	78697	78697	78764
18381	25253	114	applied	\N	\N	\N	\N	78707	78707	78765
18381	25255	115	applied	\N	\N	\N	\N	78713	78713	78766
18381	25258	116	applied	\N	\N	\N	\N	78723	78723	78767
18381	25259	117	applied	\N	\N	\N	\N	78725	78725	78728
18383	25261	0	applied	\N	\N	\N	\N	78772	78772	78773
18383	25262	1	applied	\N	\N	\N	\N	78774	78774	78775
18383	25263	2	applied	\N	\N	\N	\N	78776	78776	78777
18383	25264	3	applied	\N	\N	\N	\N	78778	78778	78779
18383	25265	4	applied	\N	\N	\N	\N	78780	78780	78781
18386	25268	0	applied	\N	\N	\N	\N	78791	78791	78792
18386	25269	1	applied	\N	\N	\N	\N	78793	78793	78794
18386	25270	2	applied	\N	\N	\N	\N	78795	78795	78796
18386	25271	3	applied	\N	\N	\N	\N	78797	78797	78798
18389	25272	0	applied	\N	\N	\N	\N	78801	78801	78802
18389	25273	1	applied	\N	\N	\N	\N	78803	78803	78804
18389	25274	2	applied	\N	\N	\N	\N	78805	78805	78806
18391	25275	0	applied	\N	\N	\N	\N	78812	78812	78813
18391	25276	1	applied	\N	\N	\N	\N	78814	78814	78815
18393	25277	0	applied	\N	\N	\N	\N	78822	78822	78823
18393	25278	1	applied	\N	\N	\N	\N	78824	78824	78825
18395	25279	0	applied	\N	\N	\N	\N	78830	78830	78831
18395	25280	1	applied	\N	\N	\N	\N	78832	78832	78833
18395	25281	2	applied	\N	\N	\N	\N	78834	78834	78835
18398	25286	0	applied	\N	\N	\N	\N	78847	78847	78848
18398	25287	1	applied	\N	\N	\N	\N	78849	78849	78850
18398	25288	2	applied	\N	\N	\N	\N	78851	78851	78852
18406	25298	0	applied	\N	\N	\N	\N	78884	78884	78885
18406	25299	1	applied	\N	\N	\N	\N	78886	78886	78887
18406	25300	2	applied	\N	\N	\N	\N	78888	78888	78889
18408	25304	0	applied	\N	\N	\N	\N	78899	78899	78900
18408	25305	1	applied	\N	\N	\N	\N	78901	78901	78902
18418	25313	0	applied	\N	\N	\N	\N	78918	78918	78955
18418	25308	1	applied	\N	\N	\N	\N	78908	78908	47675
18418	25320	2	applied	\N	\N	\N	\N	78933	78933	78956
18418	25321	3	applied	\N	\N	\N	\N	78935	78935	78833
18418	25323	4	applied	\N	\N	\N	\N	78939	78939	78957
18418	25327	5	applied	\N	\N	\N	\N	78953	78953	78839
18418	25328	6	applied	\N	\N	\N	\N	78958	78958	78959
18422	25298	0	applied	\N	\N	\N	\N	78884	78884	78885
18422	25299	1	applied	\N	\N	\N	\N	78886	78886	78887
18422	25301	2	applied	\N	\N	\N	\N	78892	78892	78893
18422	25304	3	applied	\N	\N	\N	\N	78899	78899	78900
18422	25306	4	applied	\N	\N	\N	\N	78904	78904	78905
18422	25309	5	applied	\N	\N	\N	\N	78909	78909	78910
18422	25312	6	applied	\N	\N	\N	\N	78916	78916	78917
18422	25315	7	applied	\N	\N	\N	\N	78923	78923	78924
18422	25316	8	applied	\N	\N	\N	\N	78925	78925	78926
18422	25317	9	applied	\N	\N	\N	\N	78927	78927	78928
18422	25325	10	applied	\N	\N	\N	\N	78949	78949	78950
18422	25329	11	applied	\N	\N	\N	\N	78962	78962	78963
18422	25313	12	applied	\N	\N	\N	\N	78918	78918	78977
18422	25300	13	applied	\N	\N	\N	\N	78888	78888	78978
18422	25302	14	applied	\N	\N	\N	\N	78894	78894	78979
18422	25305	15	applied	\N	\N	\N	\N	78901	78901	78980
18422	25307	16	applied	\N	\N	\N	\N	78906	78906	78912
18422	25308	17	applied	\N	\N	\N	\N	78908	78908	47675
18422	25320	18	applied	\N	\N	\N	\N	78933	78933	78981
18422	25321	19	applied	\N	\N	\N	\N	78935	78935	78982
18422	25303	20	applied	\N	\N	\N	\N	78896	78896	78919
18422	25310	21	applied	\N	\N	\N	\N	78911	78911	78983
18422	25318	22	applied	\N	\N	\N	\N	78929	78929	78984
18422	25323	23	applied	\N	\N	\N	\N	78939	78939	78930
18422	25311	24	applied	\N	\N	\N	\N	78913	78913	78932
18422	25314	25	applied	\N	\N	\N	\N	78920	78920	78947
18422	25319	26	applied	\N	\N	\N	\N	78931	78931	78985
18422	25322	27	applied	\N	\N	\N	\N	78937	78937	78940
18422	25324	28	applied	\N	\N	\N	\N	78941	78941	78942
18422	25326	29	applied	\N	\N	\N	\N	78951	78951	78952
18422	25330	30	applied	\N	\N	\N	\N	78964	78964	78986
18422	25327	31	applied	\N	\N	\N	\N	78953	78953	78965
18422	25328	32	applied	\N	\N	\N	\N	78958	78958	78966
18422	25332	33	applied	\N	\N	\N	\N	78970	78970	78971
18427	25293	0	applied	\N	\N	\N	\N	78866	78866	78867
18427	25295	1	applied	\N	\N	\N	\N	78872	78872	78873
18427	25298	2	applied	\N	\N	\N	\N	78884	78884	78885
18427	25299	3	applied	\N	\N	\N	\N	78886	78886	78887
18427	25301	4	applied	\N	\N	\N	\N	78892	78892	78893
18427	25304	5	applied	\N	\N	\N	\N	78899	78899	78900
18427	25306	6	applied	\N	\N	\N	\N	78904	78904	78905
18427	25309	7	applied	\N	\N	\N	\N	78909	78909	78910
18427	25312	8	applied	\N	\N	\N	\N	78916	78916	78917
18427	25315	9	applied	\N	\N	\N	\N	78923	78923	78924
18427	25316	10	applied	\N	\N	\N	\N	78925	78925	78926
18427	25317	11	applied	\N	\N	\N	\N	78927	78927	78928
18427	25325	12	applied	\N	\N	\N	\N	78949	78949	78950
18427	25329	13	applied	\N	\N	\N	\N	78962	78962	78963
18427	25331	14	applied	\N	\N	\N	\N	78968	78968	78969
18427	25335	15	applied	\N	\N	\N	\N	78988	78988	78989
18427	25338	16	applied	\N	\N	\N	\N	78996	78996	78997
18427	25340	17	applied	\N	\N	\N	\N	79000	79000	79001
18427	25343	18	applied	\N	\N	\N	\N	79008	79008	79009
18427	25294	19	applied	\N	\N	\N	\N	78868	78868	78869
18427	25313	20	applied	\N	\N	\N	\N	78918	78918	79010
18427	25308	21	applied	\N	\N	\N	\N	78908	78908	47675
18427	25320	22	applied	\N	\N	\N	\N	78933	78933	78877
18427	25296	23	applied	\N	\N	\N	\N	78874	78874	78889
18427	25300	24	applied	\N	\N	\N	\N	78888	78888	78895
18427	25302	25	applied	\N	\N	\N	\N	78894	78894	79011
18427	25305	26	applied	\N	\N	\N	\N	78901	78901	79012
18427	25307	27	applied	\N	\N	\N	\N	78906	78906	79013
18427	25321	28	applied	\N	\N	\N	\N	78935	78935	78914
18427	25297	29	applied	\N	\N	\N	\N	78876	78876	78982
18427	25303	30	applied	\N	\N	\N	\N	78896	78896	78919
18427	25310	31	applied	\N	\N	\N	\N	78911	78911	78983
18427	25318	32	applied	\N	\N	\N	\N	78929	78929	78984
18427	25333	33	applied	\N	\N	\N	\N	78972	78972	78921
18427	25344	34	applied	\N	\N	\N	\N	79014	79014	78930
18427	25323	35	applied	\N	\N	\N	\N	78939	78939	78945
18427	25311	36	applied	\N	\N	\N	\N	78913	78913	78934
18427	25314	37	applied	\N	\N	\N	\N	78920	78920	79015
18427	25319	38	applied	\N	\N	\N	\N	78931	78931	79016
18392	25276	1	applied	\N	\N	\N	\N	78814	78814	78815
18402	25295	0	applied	\N	\N	\N	\N	78872	78872	78873
18402	25296	1	applied	\N	\N	\N	\N	78874	78874	78875
18402	25297	2	applied	\N	\N	\N	\N	78876	78876	78877
18409	25306	0	applied	\N	\N	\N	\N	78904	78904	78905
18409	25307	1	applied	\N	\N	\N	\N	78906	78906	78907
18409	25308	2	applied	\N	\N	\N	\N	78908	78908	47675
18412	25312	0	applied	\N	\N	\N	\N	78916	78916	78917
18412	25313	1	applied	\N	\N	\N	\N	78918	78918	78919
18412	25314	2	applied	\N	\N	\N	\N	78920	78920	78921
18419	25329	0	applied	\N	\N	\N	\N	78962	78962	78963
18419	25330	1	applied	\N	\N	\N	\N	78964	78964	78965
18419	25328	2	applied	\N	\N	\N	\N	78958	78958	78966
18421	25331	0	applied	\N	\N	\N	\N	78968	78968	78969
18421	25332	1	applied	\N	\N	\N	\N	78970	78970	78971
18421	25333	2	applied	\N	\N	\N	\N	78972	78972	78973
18421	25334	3	applied	\N	\N	\N	\N	78974	78974	78975
18424	25335	0	applied	\N	\N	\N	\N	78988	78988	78989
18424	25336	2	applied	\N	\N	\N	\N	78991	78991	78992
18424	25337	3	applied	\N	\N	\N	\N	78993	78993	78994
18426	25340	0	applied	\N	\N	\N	\N	79000	79000	79001
18426	25341	1	applied	\N	\N	\N	\N	79002	79002	79003
18426	25342	2	applied	\N	\N	\N	\N	79004	79004	79005
18428	25343	0	applied	\N	\N	\N	\N	79008	79008	79009
18428	25344	1	applied	\N	\N	\N	\N	79014	79014	79024
18428	25345	2	applied	\N	\N	\N	\N	79025	79025	79026
18428	25346	3	applied	\N	\N	\N	\N	79027	79027	79028
18431	25350	0	applied	\N	\N	\N	\N	79039	79039	79040
18431	25351	1	applied	\N	\N	\N	\N	79041	79041	79042
18431	25352	2	applied	\N	\N	\N	\N	79043	79043	79044
18431	25353	3	applied	\N	\N	\N	\N	79045	79045	79046
18431	25354	4	applied	\N	\N	\N	\N	79047	79047	79048
18431	25355	5	applied	\N	\N	\N	\N	79049	79049	79050
18431	25356	6	applied	\N	\N	\N	\N	79051	79051	79052
18435	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18435	24843	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77492	77492	\N
18435	25108	2	applied	\N	\N	\N	\N	78299	78299	78300
18435	25109	3	applied	\N	\N	\N	\N	78301	78301	78302
18435	25110	4	applied	\N	\N	\N	\N	78303	78303	78304
18435	25131	5	applied	\N	\N	\N	\N	78370	78370	78371
18435	25132	6	applied	\N	\N	\N	\N	78372	78372	78373
18435	25133	7	applied	\N	\N	\N	\N	78374	78374	78375
18435	25134	8	applied	\N	\N	\N	\N	78376	78376	78377
18435	25079	9	applied	\N	\N	\N	\N	78222	78222	78223
18435	25080	10	applied	\N	\N	\N	\N	78224	78224	78225
18435	25086	11	applied	\N	\N	\N	\N	78236	78236	78237
18435	25087	12	applied	\N	\N	\N	\N	78238	78238	78239
18435	24875	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	77569	77569	\N
18435	24876	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	77570	77570	\N
18435	24877	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	77571	77571	\N
18435	24878	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	77572	77572	\N
18435	24844	17	applied	\N	\N	\N	\N	77493	77493	77494
18435	24845	18	applied	\N	\N	\N	\N	77495	77495	77496
18435	24846	19	applied	\N	\N	\N	\N	77497	77497	77498
18435	24847	20	applied	\N	\N	\N	\N	77499	77499	77500
18435	24857	21	applied	\N	\N	\N	\N	77521	77521	77522
18435	24858	22	applied	\N	\N	\N	\N	77523	77523	77524
18435	24864	23	applied	\N	\N	\N	\N	77541	77541	77542
18435	24865	24	applied	\N	\N	\N	\N	77543	77543	77544
18435	24870	25	applied	\N	\N	\N	\N	77554	77554	77555
18435	24874	26	applied	\N	\N	\N	\N	77567	77567	77568
18435	24880	27	applied	\N	\N	\N	\N	77576	77576	77577
18435	24883	28	applied	\N	\N	\N	\N	77584	77584	77585
18435	24887	29	applied	\N	\N	\N	\N	77593	77593	77594
18435	24890	30	applied	\N	\N	\N	\N	77600	77600	77601
18435	24891	31	applied	\N	\N	\N	\N	77602	77602	77603
18435	24892	32	applied	\N	\N	\N	\N	77604	77604	77605
18435	24900	33	applied	\N	\N	\N	\N	77622	77622	77623
18435	24903	34	applied	\N	\N	\N	\N	77632	77632	77633
18435	24904	35	applied	\N	\N	\N	\N	77634	77634	77635
18435	24909	36	applied	\N	\N	\N	\N	77648	77648	77649
18435	24910	37	applied	\N	\N	\N	\N	77650	77650	77651
18435	24913	38	applied	\N	\N	\N	\N	77658	77658	77659
18435	24914	39	applied	\N	\N	\N	\N	77660	77660	77661
18435	24920	40	applied	\N	\N	\N	\N	77674	77674	77675
18435	24921	41	applied	\N	\N	\N	\N	77676	77676	77677
18435	24922	42	applied	\N	\N	\N	\N	77678	77678	77679
18435	24923	43	applied	\N	\N	\N	\N	77680	77680	77681
18435	24929	44	applied	\N	\N	\N	\N	77696	77696	77697
18435	24931	45	applied	\N	\N	\N	\N	77702	77702	77703
18435	24934	46	applied	\N	\N	\N	\N	77713	77713	77714
18435	24935	47	applied	\N	\N	\N	\N	77715	77715	77716
18435	24939	48	applied	\N	\N	\N	\N	77747	77747	77748
18435	24941	49	applied	\N	\N	\N	\N	77753	77753	77754
18435	24943	50	applied	\N	\N	\N	\N	77760	77760	77761
18435	24945	51	applied	\N	\N	\N	\N	77768	77768	77769
18435	24952	52	applied	\N	\N	\N	\N	77785	77785	77786
18435	24953	53	applied	\N	\N	\N	\N	77787	77787	77788
18435	24954	54	applied	\N	\N	\N	\N	77791	77791	77792
18435	24955	55	applied	\N	\N	\N	\N	77793	77793	77794
18435	24956	56	applied	\N	\N	\N	\N	77795	77795	77796
18435	24962	57	applied	\N	\N	\N	\N	77810	77810	77811
18435	24966	58	applied	\N	\N	\N	\N	77821	77821	77822
18435	24971	59	applied	\N	\N	\N	\N	77832	77832	77833
18435	24973	60	applied	\N	\N	\N	\N	77845	77845	77846
18435	24974	61	applied	\N	\N	\N	\N	77847	77847	77848
18435	24978	62	applied	\N	\N	\N	\N	77856	77856	77857
18435	24981	64	applied	\N	\N	\N	\N	77905	77905	77906
18435	24985	65	applied	\N	\N	\N	\N	77914	77914	77915
18435	24988	66	applied	\N	\N	\N	\N	77921	77921	77922
18435	24990	67	applied	\N	\N	\N	\N	77926	77926	77927
18435	24992	68	applied	\N	\N	\N	\N	77938	77938	77939
18435	24995	69	applied	\N	\N	\N	\N	77948	77948	77949
18435	24996	70	applied	\N	\N	\N	\N	77953	77953	77954
18435	24998	71	applied	\N	\N	\N	\N	77961	77961	77962
18435	24999	72	applied	\N	\N	\N	\N	77963	77963	77964
18435	25003	73	applied	\N	\N	\N	\N	77976	77976	77977
18435	25005	74	applied	\N	\N	\N	\N	77981	77981	77982
18435	25007	75	applied	\N	\N	\N	\N	77987	77987	77988
18435	25008	76	applied	\N	\N	\N	\N	77989	77989	77990
18435	25009	77	applied	\N	\N	\N	\N	77991	77991	77992
18435	25014	78	applied	\N	\N	\N	\N	78002	78002	78003
18435	25017	79	applied	\N	\N	\N	\N	78010	78010	78011
18435	25019	80	applied	\N	\N	\N	\N	78034	78034	78035
18435	25021	81	applied	\N	\N	\N	\N	78040	78040	78041
18435	25024	82	applied	\N	\N	\N	\N	78050	78050	78051
18435	25026	83	applied	\N	\N	\N	\N	78056	78056	78057
18416	25316	1	applied	\N	\N	\N	\N	78925	78925	78926
18416	25317	2	applied	\N	\N	\N	\N	78927	78927	78928
18416	25318	3	applied	\N	\N	\N	\N	78929	78929	78930
18416	25320	4	applied	\N	\N	\N	\N	78933	78933	78945
18416	25321	5	applied	\N	\N	\N	\N	78935	78935	78946
18416	25323	6	applied	\N	\N	\N	\N	78939	78939	78947
18423	25335	0	applied	\N	\N	\N	\N	78988	78988	78989
18423	25336	2	applied	\N	\N	\N	\N	78991	78991	78992
18423	25337	3	applied	\N	\N	\N	\N	78993	78993	78994
18425	25338	0	applied	\N	\N	\N	\N	78996	78996	78997
18425	25339	1	applied	\N	\N	\N	\N	78998	78998	78999
18430	25347	0	applied	\N	\N	\N	\N	79031	79031	79032
18430	25348	1	applied	\N	\N	\N	\N	79033	79033	79034
18430	25349	2	applied	\N	\N	\N	\N	79035	79035	79036
18433	25350	0	applied	\N	\N	\N	\N	79039	79039	79040
18433	25351	1	applied	\N	\N	\N	\N	79041	79041	79042
18433	25352	2	applied	\N	\N	\N	\N	79043	79043	79044
18433	25353	3	applied	\N	\N	\N	\N	79045	79045	79046
18433	25354	4	applied	\N	\N	\N	\N	79047	79047	79048
18433	25355	5	applied	\N	\N	\N	\N	79049	79049	79050
18433	25356	6	applied	\N	\N	\N	\N	79051	79051	79052
18436	25357	0	applied	\N	\N	\N	\N	79063	79063	79064
18436	25358	1	applied	\N	\N	\N	\N	79065	79065	79066
18436	25359	2	applied	\N	\N	\N	\N	79067	79067	79068
18438	25358	0	applied	\N	\N	\N	\N	79065	79065	79066
18438	25359	1	applied	\N	\N	\N	\N	79067	79067	79068
18440	25357	0	applied	\N	\N	\N	\N	79063	79063	79064
18440	25358	1	applied	\N	\N	\N	\N	79065	79065	79066
18440	25359	2	applied	\N	\N	\N	\N	79067	79067	79068
18443	25366	0	applied	\N	\N	\N	\N	79089	79089	79090
18443	25367	1	applied	\N	\N	\N	\N	79091	79091	79092
18443	25368	2	applied	\N	\N	\N	\N	79093	79093	79094
18450	25379	0	applied	\N	\N	\N	\N	79127	79127	79128
18450	25380	1	applied	\N	\N	\N	\N	79129	79129	79130
18450	25381	2	applied	\N	\N	\N	\N	79131	79131	79132
18454	25382	0	applied	\N	\N	\N	\N	79167	79167	79168
18454	25383	1	applied	\N	\N	\N	\N	79169	79169	79170
18454	25384	2	applied	\N	\N	\N	\N	79171	79171	79172
18457	25385	0	applied	\N	\N	\N	\N	79177	79177	79178
18457	25388	1	applied	\N	\N	\N	\N	79183	79183	79184
18457	25386	2	applied	\N	\N	\N	\N	79179	79179	79185
18457	25387	3	applied	\N	\N	\N	\N	79181	79181	79186
18465	25392	0	applied	\N	\N	\N	\N	79199	79199	79200
18465	25393	1	applied	\N	\N	\N	\N	79201	79201	79202
18469	25401	0	applied	\N	\N	\N	\N	79226	79226	79227
18469	25402	1	applied	\N	\N	\N	\N	79228	79228	79229
18469	25403	2	applied	\N	\N	\N	\N	79230	79230	79231
18469	25404	3	applied	\N	\N	1000000000	\N	79232	79232	79233
18469	25405	4	applied	\N	\N	\N	\N	79234	79234	79235
18469	25406	5	applied	\N	\N	\N	\N	79236	79236	79237
18469	25407	6	applied	\N	\N	\N	\N	79238	79238	79239
18469	25408	7	applied	\N	\N	\N	\N	79240	79240	79241
18469	25409	8	applied	\N	\N	\N	\N	79242	79242	79243
18469	25410	9	applied	\N	\N	\N	\N	79244	79244	79245
18469	25411	10	applied	\N	\N	\N	\N	79246	79246	79247
18474	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18474	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18474	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18474	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18474	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18474	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18474	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18474	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18477	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18477	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18477	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18477	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18477	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18477	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18477	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18477	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18484	25423	0	applied	\N	\N	\N	\N	79287	79287	79288
18484	25424	1	applied	\N	\N	\N	\N	79289	79289	79290
18484	25425	2	applied	\N	\N	\N	\N	79291	79291	79292
18484	25426	3	applied	\N	\N	\N	\N	79293	79293	79294
18484	25427	4	applied	\N	\N	\N	\N	79295	79295	79296
18484	25428	5	applied	\N	\N	\N	\N	79297	79297	79298
18484	25429	6	applied	\N	\N	\N	\N	79299	79299	79300
18484	25430	7	applied	\N	\N	\N	\N	79301	79301	79302
18484	25431	8	applied	\N	\N	\N	\N	79303	79303	79304
18484	25432	9	applied	\N	\N	\N	\N	79305	79305	79306
18489	25445	0	applied	\N	\N	\N	\N	79338	79338	79339
18489	25446	1	applied	\N	\N	\N	\N	79340	79340	79341
18491	25447	0	applied	\N	\N	\N	\N	79344	79344	79345
18491	25448	1	applied	\N	\N	\N	\N	79346	79346	79347
18491	25449	2	applied	\N	\N	\N	\N	79348	79348	79349
18496	25454	0	applied	\N	\N	\N	\N	79364	79364	79365
18496	25455	1	applied	\N	\N	1000000000	\N	79366	79366	79367
18496	25456	2	applied	\N	\N	\N	\N	79368	79368	79369
18496	25457	3	applied	\N	\N	\N	\N	79370	79370	79371
18498	25462	0	applied	\N	\N	\N	\N	79386	79386	79387
18498	25463	1	applied	\N	\N	\N	\N	79388	79388	79389
18498	25464	2	applied	\N	\N	\N	\N	79390	79390	79391
18498	25465	3	applied	\N	\N	\N	\N	79392	79392	79393
18510	25491	0	applied	\N	\N	\N	\N	79462	79462	79463
18510	25492	1	applied	\N	\N	\N	\N	79464	79464	79465
18512	25493	0	applied	\N	\N	\N	\N	79471	79471	79471
18512	25494	1	applied	\N	\N	\N	\N	79472	79472	79473
18512	25495	2	applied	\N	\N	\N	\N	79474	79474	79475
18514	25493	0	applied	\N	\N	\N	\N	79471	79471	79471
18514	25404	1	applied	\N	\N	1000000000	\N	79232	79232	79233
18514	25455	2	applied	\N	\N	1000000000	\N	79366	79366	79367
18514	25496	3	applied	\N	\N	1000000000	\N	79478	79478	79479
18514	25459	4	applied	\N	\N	\N	\N	79480	79480	79481
18514	25332	5	applied	\N	\N	\N	\N	78970	78970	79147
18514	25336	6	applied	\N	\N	\N	\N	78991	78991	78850
18514	25339	7	applied	\N	\N	\N	\N	78998	78998	79148
18514	25341	8	applied	\N	\N	\N	\N	79002	79002	78860
18514	25345	9	applied	\N	\N	\N	\N	79025	79025	79149
18514	25348	10	applied	\N	\N	\N	\N	79033	79033	79150
18514	25355	11	applied	\N	\N	\N	\N	79049	79049	78869
18514	25356	12	applied	\N	\N	\N	\N	79051	79051	79010
18514	25359	13	applied	\N	\N	\N	\N	79067	79067	78877
18514	25362	14	applied	\N	\N	\N	\N	79080	79080	78977
18514	25365	15	applied	\N	\N	\N	\N	79086	79086	79151
18514	25367	16	applied	\N	\N	\N	\N	79091	79091	78895
18514	25371	17	applied	\N	\N	\N	\N	79101	79101	78979
18514	25373	18	applied	\N	\N	\N	\N	79105	79105	78902
18514	25378	19	applied	\N	\N	\N	\N	79119	79119	79012
18417	25327	2	applied	\N	\N	\N	\N	78953	78953	78954
18420	25329	0	applied	\N	\N	\N	\N	78962	78962	78963
18420	25330	1	applied	\N	\N	\N	\N	78964	78964	78965
18420	25328	2	applied	\N	\N	\N	\N	78958	78958	78966
18429	25347	0	applied	\N	\N	\N	\N	79031	79031	79032
18429	25348	1	applied	\N	\N	\N	\N	79033	79033	79034
18429	25349	2	applied	\N	\N	\N	\N	79035	79035	79036
18439	25358	0	applied	\N	\N	\N	\N	79065	79065	79066
18439	25359	1	applied	\N	\N	\N	\N	79067	79067	79068
18442	25366	0	applied	\N	\N	\N	\N	79089	79089	79090
18442	25367	1	applied	\N	\N	\N	\N	79091	79091	79092
18442	25368	2	applied	\N	\N	\N	\N	79093	79093	79094
18444	25369	0	applied	\N	\N	\N	\N	79097	79097	79098
18444	25370	1	applied	\N	\N	\N	\N	79099	79099	79100
18444	25371	2	applied	\N	\N	\N	\N	79101	79101	79102
18452	25379	0	applied	\N	\N	\N	\N	79127	79127	79128
18452	25380	1	applied	\N	\N	\N	\N	79129	79129	79130
18452	25381	2	applied	\N	\N	\N	\N	79131	79131	79132
18453	25261	0	applied	\N	\N	\N	\N	78772	78772	78773
18453	25262	1	applied	\N	\N	\N	\N	78774	78774	78775
18453	25266	2	applied	\N	\N	\N	\N	78786	78786	78787
18453	25268	3	applied	\N	\N	\N	\N	78791	78791	78792
18453	25269	4	applied	\N	\N	\N	\N	78793	78793	78794
18453	25272	5	applied	\N	\N	\N	\N	78801	78801	78802
18453	25275	6	applied	\N	\N	\N	\N	78812	78812	78813
18453	25277	7	applied	\N	\N	\N	\N	78822	78822	78823
18453	25279	8	applied	\N	\N	\N	\N	78830	78830	78831
18453	25282	9	applied	\N	\N	\N	\N	78836	78836	78837
18453	25284	10	applied	\N	\N	\N	\N	78842	78842	78843
18453	25286	11	applied	\N	\N	\N	\N	78847	78847	78848
18453	25289	12	applied	\N	\N	\N	\N	78855	78855	78856
18453	25290	13	applied	\N	\N	\N	\N	78857	78857	78858
18453	25293	14	applied	\N	\N	\N	\N	78866	78866	78867
18453	25295	15	applied	\N	\N	\N	\N	78872	78872	78873
18453	25298	16	applied	\N	\N	\N	\N	78884	78884	78885
18453	25299	17	applied	\N	\N	\N	\N	78886	78886	78887
18453	25301	18	applied	\N	\N	\N	\N	78892	78892	78893
18453	25304	19	applied	\N	\N	\N	\N	78899	78899	78900
18453	25306	20	applied	\N	\N	\N	\N	78904	78904	78905
18453	25309	21	applied	\N	\N	\N	\N	78909	78909	78910
18453	25312	22	applied	\N	\N	\N	\N	78916	78916	78917
18453	25315	23	applied	\N	\N	\N	\N	78923	78923	78924
18453	25316	24	applied	\N	\N	\N	\N	78925	78925	78926
18453	25317	25	applied	\N	\N	\N	\N	78927	78927	78928
18453	25325	26	applied	\N	\N	\N	\N	78949	78949	78950
18453	25329	27	applied	\N	\N	\N	\N	78962	78962	78963
18453	25331	28	applied	\N	\N	\N	\N	78968	78968	78969
18453	25335	29	applied	\N	\N	\N	\N	78988	78988	78989
18453	25338	30	applied	\N	\N	\N	\N	78996	78996	78997
18453	25340	31	applied	\N	\N	\N	\N	79000	79000	79001
18453	25343	32	applied	\N	\N	\N	\N	79008	79008	79009
18453	25347	33	applied	\N	\N	\N	\N	79031	79031	79032
18453	25350	34	applied	\N	\N	\N	\N	79039	79039	79040
18453	25351	35	applied	\N	\N	\N	\N	79041	79041	79042
18453	25357	36	applied	\N	\N	\N	\N	79063	79063	79064
18453	25360	37	applied	\N	\N	\N	\N	79076	79076	79077
18453	25361	38	applied	\N	\N	\N	\N	79078	79078	79079
18453	25366	39	applied	\N	\N	\N	\N	79089	79089	79090
18453	25369	40	applied	\N	\N	\N	\N	79097	79097	79098
18453	25372	41	applied	\N	\N	\N	\N	79103	79103	79104
18453	25375	42	applied	\N	\N	\N	\N	79113	79113	79114
18453	25379	43	applied	\N	\N	\N	\N	79127	79127	79128
18453	25263	44	applied	\N	\N	\N	\N	78776	78776	78777
18453	25313	45	applied	\N	\N	\N	\N	78918	78918	79139
18453	25308	46	applied	\N	\N	\N	\N	78908	78908	47675
18453	25320	47	applied	\N	\N	\N	\N	78933	78933	79140
18453	25321	48	applied	\N	\N	\N	\N	78935	78935	78781
18453	25323	49	applied	\N	\N	\N	\N	78939	78939	79141
18453	25264	50	applied	\N	\N	\N	\N	78778	78778	79142
18453	25265	51	applied	\N	\N	\N	\N	78780	78780	79143
18453	25267	52	applied	\N	\N	\N	\N	78788	78788	79144
18453	25270	53	applied	\N	\N	\N	\N	78795	78795	79145
18453	25274	54	applied	\N	\N	\N	\N	78805	78805	79146
18453	25281	55	applied	\N	\N	\N	\N	78834	78834	78815
18453	25327	56	applied	\N	\N	\N	\N	78953	78953	78955
18453	25328	57	applied	\N	\N	\N	\N	78958	78958	78956
18453	25332	58	applied	\N	\N	\N	\N	78970	78970	78833
18453	25336	59	applied	\N	\N	\N	\N	78991	78991	78957
18453	25339	60	applied	\N	\N	\N	\N	78998	78998	78839
18453	25341	61	applied	\N	\N	\N	\N	79002	79002	78959
18453	25345	62	applied	\N	\N	\N	\N	79025	79025	79147
18453	25348	63	applied	\N	\N	\N	\N	79033	79033	78850
18453	25355	64	applied	\N	\N	\N	\N	79049	79049	79148
18453	25356	65	applied	\N	\N	\N	\N	79051	79051	78860
18453	25359	66	applied	\N	\N	\N	\N	79067	79067	79149
18453	25362	67	applied	\N	\N	\N	\N	79080	79080	79150
18453	25365	68	applied	\N	\N	\N	\N	79086	79086	78869
18453	25367	69	applied	\N	\N	\N	\N	79091	79091	79010
18453	25371	70	applied	\N	\N	\N	\N	79101	79101	78877
18453	25373	71	applied	\N	\N	\N	\N	79105	79105	78977
18453	25288	72	applied	\N	\N	\N	\N	78851	78851	78889
18453	25297	73	applied	\N	\N	\N	\N	78876	78876	79151
18453	25303	74	applied	\N	\N	\N	\N	78896	78896	78978
18453	25310	75	applied	\N	\N	\N	\N	78911	78911	78895
18453	25318	76	applied	\N	\N	\N	\N	78929	78929	78897
18453	25333	77	applied	\N	\N	\N	\N	78972	78972	78979
18453	25344	78	applied	\N	\N	\N	\N	79014	79014	79011
18453	25352	79	applied	\N	\N	\N	\N	79043	79043	78902
18453	25364	80	applied	\N	\N	\N	\N	79084	79084	78980
18453	25376	81	applied	\N	\N	\N	\N	79115	79115	79012
18453	25271	82	applied	\N	\N	\N	\N	78797	78797	79013
18453	25273	83	applied	\N	\N	\N	\N	78803	78803	78982
18453	25276	84	applied	\N	\N	\N	\N	78814	78814	78984
18453	25278	85	applied	\N	\N	\N	\N	78824	78824	79152
18453	25280	86	applied	\N	\N	\N	\N	78832	78832	78946
18453	25283	87	applied	\N	\N	\N	\N	78838	78838	78936
18453	25285	88	applied	\N	\N	\N	\N	78844	78844	78938
18453	25287	89	applied	\N	\N	\N	\N	78849	78849	79153
18453	25291	90	applied	\N	\N	\N	\N	78859	78859	79154
18453	25292	91	applied	\N	\N	\N	\N	78861	78861	79155
18453	25294	92	applied	\N	\N	\N	\N	78868	78868	79156
18453	25296	93	applied	\N	\N	\N	\N	78874	78874	78966
18453	25300	94	applied	\N	\N	\N	\N	78888	78888	78973
18453	25302	95	applied	\N	\N	\N	\N	78894	78894	78975
18453	25305	96	applied	\N	\N	\N	\N	78901	78901	79022
18453	25307	97	applied	\N	\N	\N	\N	78906	78906	79157
18453	25311	98	applied	\N	\N	\N	\N	78913	78913	79003
18453	25314	99	applied	\N	\N	\N	\N	78920	78920	79005
18453	25319	100	applied	\N	\N	\N	\N	78931	78931	79026
18453	25322	101	applied	\N	\N	\N	\N	78937	78937	79028
18427	25322	39	applied	\N	\N	\N	\N	78937	78937	79017
18427	25324	40	applied	\N	\N	\N	\N	78941	78941	79018
18427	25326	41	applied	\N	\N	\N	\N	78951	78951	78954
18427	25330	42	applied	\N	\N	\N	\N	78964	78964	78965
18427	25334	43	applied	\N	\N	\N	\N	78974	78974	79019
18427	25337	44	applied	\N	\N	\N	\N	78993	78993	79020
18427	25342	45	applied	\N	\N	\N	\N	79004	79004	79021
18427	25327	46	applied	\N	\N	\N	\N	78953	78953	79022
18427	25328	47	applied	\N	\N	\N	\N	78958	78958	78994
18427	25332	48	applied	\N	\N	\N	\N	78970	78970	78999
18427	25336	49	applied	\N	\N	\N	\N	78991	78991	79003
18427	25339	50	applied	\N	\N	\N	\N	78998	78998	79023
18427	25341	51	applied	\N	\N	\N	\N	79002	79002	79024
18427	25345	52	applied	\N	\N	\N	\N	79025	79025	79026
18427	25346	53	applied	\N	\N	\N	\N	79027	79027	79028
18432	25350	0	applied	\N	\N	\N	\N	79039	79039	79040
18432	25351	1	applied	\N	\N	\N	\N	79041	79041	79042
18432	25352	2	applied	\N	\N	\N	\N	79043	79043	79044
18432	25353	3	applied	\N	\N	\N	\N	79045	79045	79046
18432	25354	4	applied	\N	\N	\N	\N	79047	79047	79048
18432	25355	5	applied	\N	\N	\N	\N	79049	79049	79050
18432	25356	6	applied	\N	\N	\N	\N	79051	79051	79052
18434	25350	0	applied	\N	\N	\N	\N	79039	79039	79040
18434	25351	1	applied	\N	\N	\N	\N	79041	79041	79042
18434	25352	2	applied	\N	\N	\N	\N	79043	79043	79044
18434	25353	3	applied	\N	\N	\N	\N	79045	79045	79046
18434	25354	4	applied	\N	\N	\N	\N	79047	79047	79048
18434	25355	5	applied	\N	\N	\N	\N	79049	79049	79050
18434	25356	6	applied	\N	\N	\N	\N	79051	79051	79052
18445	25372	0	applied	\N	\N	\N	\N	79103	79103	79104
18445	25373	1	applied	\N	\N	\N	\N	79105	79105	79106
18445	25374	2	applied	\N	\N	\N	\N	79107	79107	79108
18447	25375	0	applied	\N	\N	\N	\N	79113	79113	79114
18447	25376	1	applied	\N	\N	\N	\N	79115	79115	79116
18447	25377	2	applied	\N	\N	\N	\N	79117	79117	79118
18447	25378	3	applied	\N	\N	\N	\N	79119	79119	79120
18449	25375	0	applied	\N	\N	\N	\N	79113	79113	79114
18449	25376	1	applied	\N	\N	\N	\N	79115	79115	79116
18449	25377	2	applied	\N	\N	\N	\N	79117	79117	79118
18449	25378	3	applied	\N	\N	\N	\N	79119	79119	79120
18456	25385	0	applied	\N	\N	\N	\N	79177	79177	79178
18456	25386	1	applied	\N	\N	\N	\N	79179	79179	79180
18456	25387	2	applied	\N	\N	\N	\N	79181	79181	79182
18458	25385	0	applied	\N	\N	\N	\N	79177	79177	79178
18458	25388	1	applied	\N	\N	\N	\N	79183	79183	79184
18458	25386	2	applied	\N	\N	\N	\N	79179	79179	79185
18458	25387	3	applied	\N	\N	\N	\N	79181	79181	79186
18464	25392	0	applied	\N	\N	\N	\N	79199	79199	79200
18464	25393	1	applied	\N	\N	\N	\N	79201	79201	79202
18466	25392	0	applied	\N	\N	\N	\N	79199	79199	79200
18466	25393	1	applied	\N	\N	\N	\N	79201	79201	79202
18473	25412	0	applied	\N	\N	\N	\N	79250	79250	79251
18473	25414	1	applied	\N	\N	\N	\N	79254	79254	79255
18473	25413	2	applied	\N	\N	\N	\N	79252	79252	79256
18476	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18476	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18476	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18476	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18476	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18476	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18476	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18476	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18480	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18480	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18480	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18480	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18480	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18480	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18480	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18480	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18483	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18483	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18483	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18483	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18483	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18483	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18483	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18483	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18488	25441	0	applied	\N	\N	\N	\N	79328	79328	79329
18488	25442	1	applied	\N	\N	\N	\N	79330	79330	79331
18488	25443	2	applied	\N	\N	\N	\N	79332	79332	79333
18488	25444	3	applied	\N	\N	\N	\N	79334	79334	79335
18493	25450	0	applied	\N	\N	\N	\N	79353	79353	79354
18493	25451	1	applied	\N	\N	\N	\N	79355	79355	79356
18493	25452	2	applied	\N	\N	\N	\N	79357	79357	79358
18493	25453	3	applied	\N	\N	\N	\N	79359	79359	79360
18500	25107	0	applied	\N	\N	\N	\N	78297	78297	78298
18500	25108	1	applied	\N	\N	\N	\N	78299	78299	78300
18500	25109	2	applied	\N	\N	\N	\N	78301	78301	78302
18500	25110	3	applied	\N	\N	\N	\N	78303	78303	78304
18500	25131	4	applied	\N	\N	\N	\N	78370	78370	78371
18500	25132	5	applied	\N	\N	\N	\N	78372	78372	78373
18500	25133	6	applied	\N	\N	\N	\N	78374	78374	78375
18500	25134	7	applied	\N	\N	\N	\N	78376	78376	78377
18500	25079	8	applied	\N	\N	\N	\N	78222	78222	78223
18500	25080	9	applied	\N	\N	\N	\N	78224	78224	78225
18500	25086	10	applied	\N	\N	\N	\N	78236	78236	78237
18500	25087	11	applied	\N	\N	\N	\N	78238	78238	78239
18500	24981	12	applied	\N	\N	\N	\N	77905	77905	77906
18500	24985	14	applied	\N	\N	\N	\N	77914	77914	77915
18500	24988	15	applied	\N	\N	\N	\N	77921	77921	77922
18500	24990	16	applied	\N	\N	\N	\N	77926	77926	77927
18500	24992	17	applied	\N	\N	\N	\N	77938	77938	77939
18500	24995	18	applied	\N	\N	\N	\N	77948	77948	77949
18500	24996	19	applied	\N	\N	\N	\N	77953	77953	77954
18500	24998	20	applied	\N	\N	\N	\N	77961	77961	77962
18500	24999	21	applied	\N	\N	\N	\N	77963	77963	77964
18500	25003	22	applied	\N	\N	\N	\N	77976	77976	77977
18500	25005	23	applied	\N	\N	\N	\N	77981	77981	77982
18500	25007	24	applied	\N	\N	\N	\N	77987	77987	77988
18500	25008	25	applied	\N	\N	\N	\N	77989	77989	77990
18500	25009	26	applied	\N	\N	\N	\N	77991	77991	77992
18500	25014	27	applied	\N	\N	\N	\N	78002	78002	78003
18500	25017	28	applied	\N	\N	\N	\N	78010	78010	78011
18500	25404	29	applied	\N	\N	1000000000	\N	79412	79412	79233
18500	25455	30	applied	\N	\N	1000000000	\N	79413	79413	79367
18500	25019	31	applied	\N	\N	\N	\N	78034	78034	78035
18500	25021	32	applied	\N	\N	\N	\N	78040	78040	78041
18500	25024	33	applied	\N	\N	\N	\N	78050	78050	78051
18435	25028	84	applied	\N	\N	\N	\N	78062	78062	78063
18435	25030	85	applied	\N	\N	\N	\N	78068	78068	78069
18435	25031	86	applied	\N	\N	\N	\N	78070	78070	78071
18435	25035	87	applied	\N	\N	\N	\N	78080	78080	78081
18435	25037	88	applied	\N	\N	\N	\N	78087	78087	78088
18435	25040	89	applied	\N	\N	\N	\N	78093	78093	78094
18435	25042	90	applied	\N	\N	\N	\N	78100	78100	78101
18435	25043	91	applied	\N	\N	\N	\N	78103	78103	78104
18435	25045	92	applied	\N	\N	\N	\N	78107	78107	78108
18435	25046	93	applied	\N	\N	\N	\N	78109	78109	78110
18435	25050	94	applied	\N	\N	\N	\N	78119	78119	78120
18435	25051	95	applied	\N	\N	\N	\N	78121	78121	78122
18435	25055	96	applied	\N	\N	\N	\N	78132	78132	78133
18435	25056	97	applied	\N	\N	\N	\N	78134	78134	78135
18435	25059	98	applied	\N	\N	\N	\N	78142	78142	78143
18435	25062	99	applied	\N	\N	\N	\N	78150	78150	78151
18435	25064	100	applied	\N	\N	\N	\N	78155	78155	78156
18435	25066	101	applied	\N	\N	\N	\N	78161	78161	78162
18435	25068	102	applied	\N	\N	\N	\N	78167	78167	78168
18435	25069	103	applied	\N	\N	\N	\N	78169	78169	78170
18435	25073	104	applied	\N	\N	\N	\N	78179	78179	78180
18435	25075	105	applied	\N	\N	\N	\N	78209	78209	78210
18435	25078	106	applied	\N	\N	\N	\N	78219	78219	78220
18435	25081	107	applied	\N	\N	\N	\N	78226	78226	78227
18435	25085	108	applied	\N	\N	\N	\N	78234	78234	78235
18435	25091	109	applied	\N	\N	\N	\N	78246	78246	78247
18435	25094	110	applied	\N	\N	\N	\N	78253	78253	78254
18435	25097	111	applied	\N	\N	\N	\N	78262	78262	78263
18435	25099	112	applied	\N	\N	\N	\N	78272	78272	78273
18435	25102	113	applied	\N	\N	\N	\N	78281	78281	78282
18435	25104	114	applied	\N	\N	\N	\N	78290	78290	78291
18435	25111	115	applied	\N	\N	\N	\N	78305	78305	78306
18435	25112	116	applied	\N	\N	\N	\N	78307	78307	78308
18435	25113	117	applied	\N	\N	\N	\N	78309	78309	78310
18435	25114	118	applied	\N	\N	\N	\N	78311	78311	78312
18435	25115	119	applied	\N	\N	\N	\N	78313	78313	78314
18435	25126	120	applied	\N	\N	\N	\N	78339	78339	78340
18435	25128	121	applied	\N	\N	\N	\N	78345	78345	78346
18435	25135	122	applied	\N	\N	\N	\N	78378	78378	78379
18435	25136	123	applied	\N	\N	\N	\N	78380	78380	78381
18435	25140	124	applied	\N	\N	\N	\N	78389	78389	78390
18435	25142	125	applied	\N	\N	\N	\N	78395	78395	78396
18437	25357	0	applied	\N	\N	\N	\N	79063	79063	79064
18437	25358	1	applied	\N	\N	\N	\N	79065	79065	79066
18437	25359	2	applied	\N	\N	\N	\N	79067	79067	79068
18441	25360	0	applied	\N	\N	\N	\N	79076	79076	79077
18441	25361	1	applied	\N	\N	\N	\N	79078	79078	79079
18441	25362	2	applied	\N	\N	\N	\N	79080	79080	79081
18441	25363	3	applied	\N	\N	\N	\N	79082	79082	79083
18441	25364	4	applied	\N	\N	\N	\N	79084	79084	79085
18441	25365	5	applied	\N	\N	\N	\N	79086	79086	79087
18446	25372	0	applied	\N	\N	\N	\N	79103	79103	79104
18446	25373	1	applied	\N	\N	\N	\N	79105	79105	79106
18446	25374	2	applied	\N	\N	\N	\N	79107	79107	79108
18448	25375	0	applied	\N	\N	\N	\N	79113	79113	79114
18448	25376	1	applied	\N	\N	\N	\N	79115	79115	79116
18448	25377	2	applied	\N	\N	\N	\N	79117	79117	79118
18448	25378	3	applied	\N	\N	\N	\N	79119	79119	79120
18451	25379	0	applied	\N	\N	\N	\N	79127	79127	79128
18451	25380	1	applied	\N	\N	\N	\N	79129	79129	79130
18451	25381	2	applied	\N	\N	\N	\N	79131	79131	79132
18455	25382	0	applied	\N	\N	\N	\N	79167	79167	79168
18455	25383	1	applied	\N	\N	\N	\N	79169	79169	79170
18455	25384	2	applied	\N	\N	\N	\N	79171	79171	79172
18459	25385	0	applied	\N	\N	\N	\N	79177	79177	79178
18459	25388	1	applied	\N	\N	\N	\N	79183	79183	79184
18459	25386	2	applied	\N	\N	\N	\N	79179	79179	79185
18459	25387	3	applied	\N	\N	\N	\N	79181	79181	79186
18462	25389	0	applied	\N	\N	\N	\N	79192	79192	79193
18462	25390	1	applied	\N	\N	\N	\N	79194	79194	79195
18462	25391	2	applied	\N	\N	\N	\N	79196	79196	79197
18467	25394	0	applied	\N	\N	\N	\N	79208	79208	79209
18467	25395	1	applied	\N	\N	\N	\N	79210	79210	79211
18467	25396	2	applied	\N	\N	\N	\N	79212	79212	79213
18467	25397	3	applied	\N	\N	\N	\N	79214	79214	79215
18467	25398	4	applied	\N	\N	\N	\N	79216	79216	79217
18467	25399	5	applied	\N	\N	\N	\N	79218	79218	79219
18467	25400	6	applied	\N	\N	\N	\N	79220	79220	79221
18470	25412	0	applied	\N	\N	\N	\N	79250	79250	79251
18470	25413	1	applied	\N	\N	\N	\N	79252	79252	79253
18472	25412	0	applied	\N	\N	\N	\N	79250	79250	79251
18472	25414	1	applied	\N	\N	\N	\N	79254	79254	79255
18472	25413	2	applied	\N	\N	\N	\N	79252	79252	79256
18479	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18479	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18479	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18479	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18479	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18479	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18479	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18479	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18481	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18481	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18481	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18481	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18481	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18481	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18481	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18481	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18485	25433	0	applied	\N	\N	\N	\N	79309	79309	79310
18485	25434	1	applied	\N	\N	\N	\N	79311	79311	79312
18485	25435	2	applied	\N	\N	\N	\N	79313	79313	79314
18485	25436	3	applied	\N	\N	\N	\N	79315	79315	79316
18485	25437	4	applied	\N	\N	\N	\N	79317	79317	79318
18485	25438	5	applied	\N	\N	\N	\N	79319	79319	79320
18485	25439	6	applied	\N	\N	\N	\N	79321	79321	79322
18485	25440	7	applied	\N	\N	\N	\N	79323	79323	79324
18487	25433	0	applied	\N	\N	\N	\N	79309	79309	79310
18487	25434	1	applied	\N	\N	\N	\N	79311	79311	79312
18487	25435	2	applied	\N	\N	\N	\N	79313	79313	79314
18487	25436	3	applied	\N	\N	\N	\N	79315	79315	79316
18487	25437	4	applied	\N	\N	\N	\N	79317	79317	79318
18487	25438	5	applied	\N	\N	\N	\N	79319	79319	79320
18487	25439	6	applied	\N	\N	\N	\N	79321	79321	79322
18487	25440	7	applied	\N	\N	\N	\N	79323	79323	79324
18492	25450	0	applied	\N	\N	\N	\N	79353	79353	79354
18492	25451	1	applied	\N	\N	\N	\N	79355	79355	79356
18492	25452	2	applied	\N	\N	\N	\N	79357	79357	79358
18492	25453	3	applied	\N	\N	\N	\N	79359	79359	79360
18494	25454	0	applied	\N	\N	\N	\N	79364	79364	79365
18453	25324	102	applied	\N	\N	\N	\N	78941	78941	79158
18453	25326	103	applied	\N	\N	\N	\N	78951	78951	79044
18453	25330	104	applied	\N	\N	\N	\N	78964	78964	79046
18453	25334	105	applied	\N	\N	\N	\N	78974	78974	79048
18453	25337	106	applied	\N	\N	\N	\N	78993	78993	79159
18453	25342	107	applied	\N	\N	\N	\N	79004	79004	79160
18453	25346	108	applied	\N	\N	\N	\N	79027	79027	79068
18453	25349	109	applied	\N	\N	\N	\N	79035	79035	79161
18453	25353	110	applied	\N	\N	\N	\N	79045	79045	79085
18453	25354	111	applied	\N	\N	\N	\N	79047	79047	79162
18453	25358	112	applied	\N	\N	\N	\N	79065	79065	79163
18453	25363	113	applied	\N	\N	\N	\N	79082	79082	79164
18453	25368	114	applied	\N	\N	\N	\N	79093	79093	79102
18453	25370	115	applied	\N	\N	\N	\N	79099	79099	79165
18453	25374	116	applied	\N	\N	\N	\N	79107	79107	79116
18453	25377	117	applied	\N	\N	\N	\N	79117	79117	79118
18460	25385	0	applied	\N	\N	\N	\N	79177	79177	79178
18460	25388	1	applied	\N	\N	\N	\N	79183	79183	79184
18460	25386	2	applied	\N	\N	\N	\N	79179	79179	79185
18460	25387	3	applied	\N	\N	\N	\N	79181	79181	79186
18463	25392	0	applied	\N	\N	\N	\N	79199	79199	79200
18463	25393	1	applied	\N	\N	\N	\N	79201	79201	79202
18468	25394	0	applied	\N	\N	\N	\N	79208	79208	79209
18468	25395	1	applied	\N	\N	\N	\N	79210	79210	79211
18468	25396	2	applied	\N	\N	\N	\N	79212	79212	79213
18468	25397	3	applied	\N	\N	\N	\N	79214	79214	79215
18468	25398	4	applied	\N	\N	\N	\N	79216	79216	79217
18468	25399	5	applied	\N	\N	\N	\N	79218	79218	79219
18468	25400	6	applied	\N	\N	\N	\N	79220	79220	79221
18471	25412	0	applied	\N	\N	\N	\N	79250	79250	79251
18471	25414	1	applied	\N	\N	\N	\N	79254	79254	79255
18471	25413	2	applied	\N	\N	\N	\N	79252	79252	79256
18475	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18475	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18475	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18475	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18475	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18475	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18475	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18475	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18478	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18478	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18478	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18478	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18478	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18478	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18478	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18478	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18482	25415	0	applied	\N	\N	\N	\N	79260	79260	79261
18482	25416	1	applied	\N	\N	\N	\N	79262	79262	79263
18482	25417	2	applied	\N	\N	\N	\N	79264	79264	79265
18482	25418	3	applied	\N	\N	\N	\N	79266	79266	79267
18482	25419	4	applied	\N	\N	\N	\N	79268	79268	79269
18482	25420	5	applied	\N	\N	\N	\N	79270	79270	79271
18482	25421	6	applied	\N	\N	\N	\N	79272	79272	79273
18482	25422	7	applied	\N	\N	\N	\N	79274	79274	79275
18486	25433	0	applied	\N	\N	\N	\N	79309	79309	79310
18486	25434	1	applied	\N	\N	\N	\N	79311	79311	79312
18486	25435	2	applied	\N	\N	\N	\N	79313	79313	79314
18486	25436	3	applied	\N	\N	\N	\N	79315	79315	79316
18486	25437	4	applied	\N	\N	\N	\N	79317	79317	79318
18486	25438	5	applied	\N	\N	\N	\N	79319	79319	79320
18486	25439	6	applied	\N	\N	\N	\N	79321	79321	79322
18486	25440	7	applied	\N	\N	\N	\N	79323	79323	79324
18490	25447	0	applied	\N	\N	\N	\N	79344	79344	79345
18490	25448	1	applied	\N	\N	\N	\N	79346	79346	79347
18490	25449	2	applied	\N	\N	\N	\N	79348	79348	79349
18495	25454	0	applied	\N	\N	\N	\N	79364	79364	79365
18495	25455	1	applied	\N	\N	1000000000	\N	79366	79366	79367
18495	25456	2	applied	\N	\N	\N	\N	79368	79368	79369
18495	25457	3	applied	\N	\N	\N	\N	79370	79370	79371
18497	25458	0	applied	\N	\N	\N	\N	79376	79376	79377
18497	25459	1	applied	\N	\N	\N	\N	79378	79378	79379
18497	25460	2	applied	\N	\N	\N	\N	79380	79380	79381
18497	25461	3	applied	\N	\N	\N	\N	79382	79382	79383
18504	25480	0	applied	\N	\N	\N	\N	79434	79434	79435
18504	25481	1	applied	\N	\N	\N	\N	79436	79436	79437
18504	25482	2	applied	\N	\N	\N	\N	79438	79438	79439
18511	25490	0	applied	\N	\N	\N	\N	79460	79460	79461
18511	25491	1	applied	\N	\N	\N	\N	79462	79462	79463
18511	25492	2	applied	\N	\N	\N	\N	79464	79464	79465
18513	25493	0	applied	\N	\N	\N	\N	79471	79471	79471
18513	25494	1	applied	\N	\N	\N	\N	79472	79472	79473
18513	25495	2	applied	\N	\N	\N	\N	79474	79474	79475
18515	25498	0	applied	\N	\N	\N	\N	79493	79493	79494
18515	25496	1	applied	\N	\N	1000000000	\N	79478	79478	79479
18515	25497	2	applied	\N	\N	\N	\N	79490	79490	79495
18515	25499	3	applied	\N	\N	\N	\N	79496	79496	79497
18515	25500	4	applied	\N	\N	\N	\N	79498	79498	79499
18518	25509	0	applied	\N	\N	\N	\N	79520	79520	79521
18518	25510	1	applied	\N	\N	\N	\N	79522	79522	79523
18518	25508	2	applied	\N	\N	\N	\N	79517	79517	79524
18527	25526	0	applied	\N	\N	\N	\N	79566	79566	79567
18527	25527	1	applied	\N	\N	\N	\N	79568	79568	79569
18527	25528	2	applied	\N	\N	\N	\N	79570	79570	79571
18530	25535	0	applied	\N	\N	\N	\N	79590	79590	79591
18530	25536	1	applied	\N	\N	\N	\N	79592	79592	79593
18530	25537	2	applied	\N	\N	\N	\N	79594	79594	79595
18533	25552	0	applied	\N	\N	\N	\N	79629	79629	79630
18533	25553	1	applied	\N	\N	\N	\N	79631	79631	79632
18533	25554	2	applied	\N	\N	\N	\N	79633	79633	79634
18535	25552	0	applied	\N	\N	\N	\N	79629	79629	79630
18535	25553	1	applied	\N	\N	\N	\N	79631	79631	79632
18535	25554	2	applied	\N	\N	\N	\N	79633	79633	79634
18538	25562	0	applied	\N	\N	\N	\N	79658	79658	79659
18538	25563	1	applied	\N	\N	\N	\N	79660	79660	79661
18538	25564	2	applied	\N	\N	\N	\N	79662	79662	79663
18547	25578	0	applied	\N	\N	\N	\N	79708	79708	79709
18547	25579	1	applied	\N	\N	\N	\N	79710	79710	79711
18547	25580	2	applied	\N	\N	\N	\N	79712	79712	79713
18547	25581	3	applied	\N	\N	\N	\N	79714	79714	79715
18549	25578	0	applied	\N	\N	\N	\N	79708	79708	79709
18549	25579	1	applied	\N	\N	\N	\N	79710	79710	79711
18549	25580	2	applied	\N	\N	\N	\N	79712	79712	79713
18549	25581	3	applied	\N	\N	\N	\N	79714	79714	79715
18560	25619	0	applied	\N	\N	\N	\N	79806	79806	79807
18560	25620	1	applied	\N	\N	\N	\N	79808	79808	79809
18560	25621	2	applied	\N	\N	\N	\N	79810	79810	79811
18566	25634	0	applied	\N	\N	\N	\N	79844	79844	79845
18494	25455	1	applied	\N	\N	1000000000	\N	79366	79366	79367
18494	25456	2	applied	\N	\N	\N	\N	79368	79368	79369
18494	25457	3	applied	\N	\N	\N	\N	79370	79370	79371
18499	25466	0	applied	\N	\N	\N	\N	79396	79396	79397
18499	25467	1	applied	\N	\N	\N	\N	79398	79398	79399
18499	25468	2	applied	\N	\N	\N	\N	79400	79400	79373
18499	25469	3	applied	\N	\N	\N	\N	79401	79401	79402
18499	25470	4	applied	\N	\N	\N	\N	79403	79403	79404
18499	25471	5	applied	\N	\N	\N	\N	79405	79405	79406
18499	25472	6	applied	\N	\N	\N	\N	79407	79407	79408
18501	25473	0	applied	\N	\N	\N	\N	79416	79416	79417
18501	25474	1	applied	\N	\N	\N	\N	79418	79418	79419
18501	25475	2	applied	\N	\N	\N	\N	79420	79420	79421
18503	25476	0	applied	\N	\N	\N	\N	79424	79424	79425
18503	25477	1	applied	\N	\N	\N	\N	79426	79426	79427
18503	25478	2	applied	\N	\N	\N	\N	79428	79428	79429
18503	25479	3	applied	\N	\N	\N	\N	79430	79430	79431
18506	25483	0	applied	\N	\N	\N	\N	79444	79444	79445
18506	25484	1	applied	\N	\N	\N	\N	79446	79446	79447
18506	25485	2	applied	\N	\N	\N	\N	79448	79448	79449
18506	25486	3	applied	\N	\N	\N	\N	79450	79450	79451
18506	25487	4	applied	\N	\N	\N	\N	79452	79452	79453
18506	25488	5	applied	\N	\N	\N	\N	79454	79454	79455
18506	25489	6	applied	\N	\N	\N	\N	79456	79456	79457
18522	25511	0	applied	\N	\N	\N	\N	79528	79528	79529
18522	25512	1	applied	\N	\N	\N	\N	79530	79530	79531
18522	25513	2	applied	\N	\N	\N	\N	79532	79532	79533
18522	25514	3	applied	\N	\N	\N	\N	79534	79534	79535
18522	25515	4	applied	\N	\N	\N	\N	79536	79536	79537
18522	25516	5	applied	\N	\N	\N	\N	79538	79538	79539
18522	25517	6	applied	\N	\N	\N	\N	79540	79540	79541
18525	25522	0	applied	\N	\N	\N	\N	79552	79552	79553
18525	25523	1	applied	\N	\N	\N	\N	79554	79554	79555
18525	25524	2	applied	\N	\N	\N	\N	79556	79556	79557
18525	25525	3	applied	\N	\N	\N	\N	79558	79558	79559
18529	25532	0	applied	\N	\N	\N	\N	79582	79582	79583
18529	25533	1	applied	\N	\N	\N	\N	79584	79584	79585
18529	25534	2	applied	\N	\N	\N	\N	79586	79586	79587
18537	25555	0	applied	\N	\N	\N	\N	79643	79643	79644
18537	25556	1	applied	\N	\N	\N	\N	79645	79645	79646
18537	25557	2	applied	\N	\N	\N	\N	79647	79647	79648
18537	25558	3	applied	\N	\N	\N	\N	79649	79649	79650
18537	25559	4	applied	\N	\N	\N	\N	79651	79651	79652
18537	25560	5	applied	\N	\N	\N	\N	79653	79653	79654
18537	25561	6	applied	\N	\N	\N	\N	79655	79655	79656
18540	25565	0	applied	\N	\N	\N	\N	79666	79666	79667
18540	25566	1	applied	\N	\N	\N	\N	79668	79668	79669
18540	25567	2	applied	\N	\N	\N	\N	79670	79670	79671
18542	25568	0	applied	\N	\N	\N	\N	79678	79678	79679
18542	25569	1	applied	\N	\N	\N	\N	79680	79680	79681
18542	25570	2	applied	\N	\N	\N	\N	79682	79682	79683
18542	25571	3	applied	\N	\N	\N	\N	79684	79684	79685
18545	25575	0	applied	\N	\N	\N	\N	79696	79696	79697
18545	25576	1	applied	\N	\N	\N	\N	79698	79698	79699
18545	25577	2	applied	\N	\N	\N	\N	79700	79700	79701
18552	25594	0	applied	\N	\N	\N	\N	79746	79746	79747
18552	25595	1	applied	\N	\N	\N	\N	79748	79748	79749
18552	25596	2	applied	\N	\N	\N	\N	79750	79750	79751
18552	25597	3	applied	\N	\N	\N	\N	79752	79752	79753
18555	25598	0	applied	\N	\N	\N	\N	79757	79757	79758
18555	25599	1	applied	\N	\N	\N	\N	79759	79759	79760
18555	25600	2	applied	\N	\N	\N	\N	79761	79761	79762
18555	25601	3	applied	\N	\N	\N	\N	79763	79763	79764
18555	25602	4	applied	\N	\N	\N	\N	79765	79765	79766
18555	25603	5	applied	\N	\N	\N	\N	79767	79767	79768
18555	25604	6	applied	\N	\N	\N	\N	79769	79769	79770
18555	25605	7	applied	\N	\N	\N	\N	79771	79771	79772
18555	25606	8	applied	\N	\N	\N	\N	79773	79773	79774
18555	25607	9	applied	\N	\N	\N	\N	79775	79775	79776
18555	25608	10	applied	\N	\N	\N	\N	79777	79777	79778
18555	25609	11	applied	\N	\N	\N	\N	79779	79779	79780
18555	25610	12	applied	\N	\N	\N	\N	79781	79781	79782
18558	25615	0	applied	\N	\N	\N	\N	79796	79796	79797
18558	25616	1	applied	\N	\N	\N	\N	79798	79798	79799
18558	25617	2	applied	\N	\N	\N	\N	79800	79800	79801
18558	25618	3	applied	\N	\N	\N	\N	79802	79802	79803
18563	25629	0	applied	\N	\N	\N	\N	79832	79832	79833
18563	25630	1	applied	\N	\N	\N	\N	79834	79834	79835
18563	25631	2	applied	\N	\N	\N	\N	79837	79837	79838
18563	25632	3	applied	\N	\N	\N	\N	79839	79839	79840
18563	25633	4	applied	\N	\N	\N	\N	79841	79841	79842
18565	25634	0	applied	\N	\N	\N	\N	79844	79844	79845
18565	25635	1	applied	\N	\N	\N	\N	79846	79846	79847
18565	25636	2	applied	\N	\N	\N	\N	79848	79848	79849
18565	25631	3	applied	\N	\N	\N	\N	79837	79837	79852
18565	25632	4	applied	\N	\N	\N	\N	79839	79839	79853
18565	25637	5	applied	\N	\N	\N	\N	79854	79854	79855
18565	25633	6	applied	\N	\N	\N	\N	79841	79841	79856
18567	25638	0	applied	\N	\N	\N	\N	79860	79860	79861
18567	25639	1	applied	\N	\N	\N	\N	79862	79862	79863
18576	25647	0	applied	\N	\N	\N	\N	79884	79884	79885
18578	25648	0	applied	\N	\N	\N	\N	79890	79890	79891
18578	25649	1	applied	\N	\N	\N	\N	79892	79892	79893
18581	25657	0	applied	\N	\N	1000000000	\N	79911	79911	79912
18581	25658	1	applied	\N	\N	\N	\N	79913	79913	79914
18581	25659	2	applied	\N	\N	\N	\N	79915	79915	79916
18581	25660	3	applied	\N	\N	\N	\N	79917	79917	79918
18582	25661	0	applied	\N	\N	\N	\N	79920	79920	79921
18582	25662	1	applied	\N	\N	\N	\N	79922	79922	79923
18582	25663	2	applied	\N	\N	\N	\N	79924	79924	79925
18582	25664	3	applied	\N	\N	\N	\N	79926	79926	79927
18582	25665	4	applied	\N	\N	\N	\N	79928	79928	79929
18582	25666	5	applied	\N	\N	\N	\N	79930	79930	79931
18582	25667	6	applied	\N	\N	\N	\N	79932	79932	79933
18592	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18592	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18592	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18592	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18592	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18597	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18597	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18597	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18597	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18597	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18600	25687	0	applied	\N	\N	\N	\N	80009	80009	80010
18600	25688	1	applied	\N	\N	\N	\N	80011	80011	80012
18605	25695	0	applied	\N	\N	\N	\N	80035	80035	80036
18605	25696	1	applied	\N	\N	\N	\N	80037	80037	80038
18608	25697	0	applied	\N	\N	\N	\N	80043	80043	80044
18500	25026	34	applied	\N	\N	\N	\N	78056	78056	78057
18500	25028	35	applied	\N	\N	\N	\N	78062	78062	78063
18500	25030	36	applied	\N	\N	\N	\N	78068	78068	78069
18500	25031	37	applied	\N	\N	\N	\N	78070	78070	78071
18500	25035	38	applied	\N	\N	\N	\N	78080	78080	78081
18500	25037	39	applied	\N	\N	\N	\N	78087	78087	78088
18500	25040	40	applied	\N	\N	\N	\N	78093	78093	78094
18500	25042	41	applied	\N	\N	\N	\N	78100	78100	78101
18500	25043	42	applied	\N	\N	\N	\N	78103	78103	78104
18500	25045	43	applied	\N	\N	\N	\N	78107	78107	78108
18500	25046	44	applied	\N	\N	\N	\N	78109	78109	78110
18500	25050	45	applied	\N	\N	\N	\N	78119	78119	78120
18500	25051	46	applied	\N	\N	\N	\N	78121	78121	78122
18500	25055	47	applied	\N	\N	\N	\N	78132	78132	78133
18500	25056	48	applied	\N	\N	\N	\N	78134	78134	78135
18500	25059	49	applied	\N	\N	\N	\N	78142	78142	78143
18500	25062	50	applied	\N	\N	\N	\N	78150	78150	78151
18500	25064	51	applied	\N	\N	\N	\N	78155	78155	78156
18500	25066	52	applied	\N	\N	\N	\N	78161	78161	78162
18500	25068	53	applied	\N	\N	\N	\N	78167	78167	78168
18500	25069	54	applied	\N	\N	\N	\N	78169	78169	78170
18500	25073	55	applied	\N	\N	\N	\N	78179	78179	78180
18500	25075	56	applied	\N	\N	\N	\N	78209	78209	78210
18500	25078	57	applied	\N	\N	\N	\N	78219	78219	78220
18500	25081	58	applied	\N	\N	\N	\N	78226	78226	78227
18500	25085	59	applied	\N	\N	\N	\N	78234	78234	78235
18500	25091	60	applied	\N	\N	\N	\N	78246	78246	78247
18500	25094	61	applied	\N	\N	\N	\N	78253	78253	78254
18500	25097	62	applied	\N	\N	\N	\N	78262	78262	78263
18500	25099	63	applied	\N	\N	\N	\N	78272	78272	78273
18500	25102	64	applied	\N	\N	\N	\N	78281	78281	78282
18500	25104	65	applied	\N	\N	\N	\N	78290	78290	78291
18500	25111	66	applied	\N	\N	\N	\N	78305	78305	78306
18500	25112	67	applied	\N	\N	\N	\N	78307	78307	78308
18500	25113	68	applied	\N	\N	\N	\N	78309	78309	78310
18500	25114	69	applied	\N	\N	\N	\N	78311	78311	78312
18500	25115	70	applied	\N	\N	\N	\N	78313	78313	78314
18500	25126	71	applied	\N	\N	\N	\N	78339	78339	78340
18500	25128	72	applied	\N	\N	\N	\N	78345	78345	78346
18500	25135	73	applied	\N	\N	\N	\N	78378	78378	78379
18500	25136	74	applied	\N	\N	\N	\N	78380	78380	78381
18500	25140	75	applied	\N	\N	\N	\N	78389	78389	78390
18500	25142	76	applied	\N	\N	\N	\N	78395	78395	78396
18500	25144	77	applied	\N	\N	\N	\N	78403	78403	78404
18500	25146	78	applied	\N	\N	\N	\N	78409	78409	78410
18500	25150	79	applied	\N	\N	\N	\N	78419	78419	78420
18500	25151	80	applied	\N	\N	\N	\N	78424	78424	78425
18500	25152	81	applied	\N	\N	\N	\N	78426	78426	78427
18500	25155	82	applied	\N	\N	\N	\N	78436	78436	78437
18500	25156	83	applied	\N	\N	\N	\N	78438	78438	78439
18500	25160	84	applied	\N	\N	\N	\N	78448	78448	78449
18500	25162	85	applied	\N	\N	\N	\N	78454	78454	78455
18500	25163	86	applied	\N	\N	\N	\N	78456	78456	78457
18500	25167	87	applied	\N	\N	\N	\N	78466	78466	78467
18500	25169	88	applied	\N	\N	\N	\N	78471	78471	78472
18500	25170	89	applied	\N	\N	\N	\N	78475	78475	78476
18500	25171	90	applied	\N	\N	\N	\N	78477	78477	78478
18500	25175	91	applied	\N	\N	\N	\N	78488	78488	78489
18500	25177	92	applied	\N	\N	\N	\N	78493	78493	78494
18500	25178	93	applied	\N	\N	\N	\N	78495	78495	78496
18500	25179	94	applied	\N	\N	\N	\N	78497	78497	78498
18500	25186	95	applied	\N	\N	\N	\N	78513	78513	78514
18500	25188	96	applied	\N	\N	\N	\N	78521	78521	78522
18500	25193	97	applied	\N	\N	\N	\N	78530	78530	78531
18500	25194	98	applied	\N	\N	\N	\N	78532	78532	78533
18500	25195	99	applied	\N	\N	\N	\N	78534	78534	78535
18500	25200	100	applied	\N	\N	\N	\N	78550	78550	78551
18500	25207	101	applied	\N	\N	\N	\N	78562	78562	78563
18500	25209	102	applied	\N	\N	\N	\N	78568	78568	78569
18500	25210	103	applied	\N	\N	\N	\N	78570	78570	78571
18500	25214	104	applied	\N	\N	\N	\N	78579	78579	78580
18500	25216	105	applied	\N	\N	\N	\N	78584	78584	78585
18500	25218	106	applied	\N	\N	\N	\N	78590	78590	78591
18500	25221	107	applied	\N	\N	\N	\N	78600	78600	78601
18500	25222	108	applied	\N	\N	\N	\N	78602	78602	78603
18500	25225	109	applied	\N	\N	\N	\N	78609	78609	78610
18500	25227	110	applied	\N	\N	\N	\N	78615	78615	78616
18500	25229	111	applied	\N	\N	\N	\N	78623	78623	78624
18500	25231	112	applied	\N	\N	\N	\N	78628	78628	78629
18500	25232	113	applied	\N	\N	\N	\N	78630	78630	78631
18500	25236	114	applied	\N	\N	\N	\N	78640	78640	78641
18500	25238	115	applied	\N	\N	\N	\N	78651	78651	78652
18500	25239	116	applied	\N	\N	\N	\N	78653	78653	78654
18500	25243	117	applied	\N	\N	\N	\N	78675	78675	78676
18500	25245	118	applied	\N	\N	\N	\N	78683	78683	78684
18500	25247	119	applied	\N	\N	\N	\N	78689	78689	78690
18500	25249	120	applied	\N	\N	\N	\N	78695	78695	78696
18500	25252	121	applied	\N	\N	\N	\N	78705	78705	78706
18500	25254	122	applied	\N	\N	\N	\N	78711	78711	78712
18500	25256	123	applied	\N	\N	\N	\N	78718	78718	78719
18500	25257	124	applied	\N	\N	\N	\N	78721	78721	78722
18500	25261	125	applied	\N	\N	\N	\N	78772	78772	78773
18502	25473	0	applied	\N	\N	\N	\N	79416	79416	79417
18502	25474	1	applied	\N	\N	\N	\N	79418	79418	79419
18502	25475	2	applied	\N	\N	\N	\N	79420	79420	79421
18505	25480	0	applied	\N	\N	\N	\N	79434	79434	79435
18505	25481	1	applied	\N	\N	\N	\N	79436	79436	79437
18505	25482	2	applied	\N	\N	\N	\N	79438	79438	79439
18509	25490	0	applied	\N	\N	\N	\N	79460	79460	79461
18509	25491	1	applied	\N	\N	\N	\N	79462	79462	79463
18509	25492	2	applied	\N	\N	\N	\N	79464	79464	79465
18516	25501	0	applied	\N	\N	\N	\N	79502	79502	79503
18516	25502	1	applied	\N	\N	\N	\N	79504	79504	79505
18516	25503	2	applied	\N	\N	\N	\N	79506	79506	23829
18516	25504	3	applied	\N	\N	\N	\N	79507	79507	79508
18516	25505	4	applied	\N	\N	\N	\N	79509	79509	79510
18516	25506	5	applied	\N	\N	\N	\N	79511	79511	79512
18516	25507	6	applied	\N	\N	\N	\N	79513	79513	79514
18519	25509	0	applied	\N	\N	\N	\N	79520	79520	79521
18519	25510	1	applied	\N	\N	\N	\N	79522	79522	79523
18519	25508	2	applied	\N	\N	\N	\N	79517	79517	79524
18523	25518	0	applied	\N	\N	\N	\N	79544	79544	79544
18523	25519	1	applied	\N	\N	\N	\N	79545	79545	79546
18523	25520	2	applied	\N	\N	\N	\N	79547	79547	79548
18523	25521	3	applied	\N	\N	\N	\N	79549	79549	79550
18528	25529	0	applied	\N	\N	\N	\N	79574	79574	79575
18528	25530	1	applied	\N	\N	\N	\N	79576	79576	79577
18528	25531	2	applied	\N	\N	\N	\N	79578	79578	79579
18531	25538	0	applied	\N	\N	1000000000	\N	79597	79597	79598
18531	25539	1	applied	\N	\N	\N	\N	79599	79599	79600
18514	25380	20	applied	\N	\N	\N	\N	79129	79129	78912
18514	25383	21	applied	\N	\N	\N	\N	79169	79169	78981
18514	25388	22	applied	\N	\N	\N	\N	79183	79183	78982
18514	25390	23	applied	\N	\N	\N	\N	79194	79194	78983
18514	25393	24	applied	\N	\N	\N	\N	79201	79201	78921
18514	25399	25	applied	\N	\N	\N	\N	79218	79218	79152
18514	25400	26	applied	\N	\N	\N	\N	79220	79220	78932
18514	25405	27	applied	\N	\N	\N	\N	79234	79234	78934
18514	25409	28	applied	\N	\N	\N	\N	79242	79242	78936
18514	25410	29	applied	\N	\N	\N	\N	79244	79244	78985
18514	25414	30	applied	\N	\N	\N	\N	79254	79254	79016
18514	25417	31	applied	\N	\N	\N	\N	79264	79264	79153
18514	25421	32	applied	\N	\N	\N	\N	79272	79272	78942
18514	25434	33	applied	\N	\N	\N	\N	79311	79311	79018
18514	25436	34	applied	\N	\N	\N	\N	79315	79315	79155
18514	25437	35	applied	\N	\N	\N	\N	79317	79317	78986
18514	25438	36	applied	\N	\N	\N	\N	79319	79319	78965
18514	25439	37	applied	\N	\N	\N	\N	79321	79321	78966
18514	25440	38	applied	\N	\N	\N	\N	79323	79323	78971
18514	25443	39	applied	\N	\N	\N	\N	79332	79332	79020
18514	25446	40	applied	\N	\N	\N	\N	79340	79340	78975
18514	25449	41	applied	\N	\N	\N	\N	79348	79348	78992
18514	25451	42	applied	\N	\N	\N	\N	79355	79355	79482
18514	25457	43	applied	\N	\N	\N	\N	79370	79370	79157
18514	25461	44	applied	\N	\N	\N	\N	79382	79382	79483
18514	25463	45	applied	\N	\N	\N	\N	79388	79388	79484
18514	25469	46	applied	\N	\N	\N	\N	79401	79401	79005
18514	25470	47	applied	\N	\N	\N	\N	79403	79403	79485
18514	25475	48	applied	\N	\N	\N	\N	79420	79420	79486
18514	25477	49	applied	\N	\N	\N	\N	79426	79426	79028
18514	25482	50	applied	\N	\N	\N	\N	79438	79438	79034
18514	25486	51	applied	\N	\N	\N	\N	79450	79450	79487
18514	25489	52	applied	\N	\N	\N	\N	79456	79456	79044
18514	25491	53	applied	\N	\N	\N	\N	79462	79462	79488
18514	25495	54	applied	\N	\N	\N	\N	79474	79474	79489
18514	25497	55	applied	\N	\N	\N	\N	79490	79490	79048
18517	25503	0	applied	\N	\N	\N	\N	79506	79506	23829
18517	25506	1	applied	\N	\N	\N	\N	79511	79511	79050
18517	25507	2	applied	\N	\N	\N	\N	79513	79513	79052
18517	25508	3	applied	\N	\N	\N	\N	79517	79517	79160
18524	25522	0	applied	\N	\N	\N	\N	79552	79552	79553
18524	25523	1	applied	\N	\N	\N	\N	79554	79554	79555
18524	25524	2	applied	\N	\N	\N	\N	79556	79556	79557
18524	25525	3	applied	\N	\N	\N	\N	79558	79558	79559
18526	25522	0	applied	\N	\N	\N	\N	79552	79552	79553
18526	25523	1	applied	\N	\N	\N	\N	79554	79554	79555
18526	25524	2	applied	\N	\N	\N	\N	79556	79556	79557
18526	25525	3	applied	\N	\N	\N	\N	79558	79558	79559
18532	25545	0	applied	\N	\N	\N	\N	79613	79613	79614
18532	25546	1	applied	\N	\N	\N	\N	79615	79615	79616
18532	25547	2	applied	\N	\N	\N	\N	79617	79617	79618
18532	25548	3	applied	\N	\N	\N	\N	79619	79619	79620
18532	25549	4	applied	\N	\N	\N	\N	79621	79621	79622
18532	25550	5	applied	\N	\N	\N	\N	79623	79623	79624
18532	25551	6	applied	\N	\N	\N	\N	79625	79625	79626
18534	25552	0	applied	\N	\N	\N	\N	79629	79629	79630
18534	25553	1	applied	\N	\N	\N	\N	79631	79631	79632
18534	25554	2	applied	\N	\N	\N	\N	79633	79633	79634
18539	25565	0	applied	\N	\N	\N	\N	79666	79666	79667
18539	25566	1	applied	\N	\N	\N	\N	79668	79668	79669
18539	25567	2	applied	\N	\N	\N	\N	79670	79670	79671
18544	25575	0	applied	\N	\N	\N	\N	79696	79696	79697
18544	25576	1	applied	\N	\N	\N	\N	79698	79698	79699
18544	25577	2	applied	\N	\N	\N	\N	79700	79700	79701
18548	25578	0	applied	\N	\N	\N	\N	79708	79708	79709
18548	25579	1	applied	\N	\N	\N	\N	79710	79710	79711
18548	25580	2	applied	\N	\N	\N	\N	79712	79712	79713
18548	25581	3	applied	\N	\N	\N	\N	79714	79714	79715
18551	25584	0	applied	\N	\N	\N	\N	79724	79724	79725
18551	25585	1	applied	\N	\N	\N	\N	79726	79726	79727
18551	25586	2	applied	\N	\N	\N	\N	79728	79728	79729
18551	25587	3	applied	\N	\N	\N	\N	79730	79730	79731
18551	25588	4	applied	\N	\N	\N	\N	79732	79732	79733
18551	25589	5	applied	\N	\N	\N	\N	79734	79734	79735
18551	25590	6	applied	\N	\N	\N	\N	79736	79736	79737
18551	25591	7	applied	\N	\N	\N	\N	79738	79738	79739
18551	25592	8	applied	\N	\N	\N	\N	79740	79740	79741
18551	25593	9	applied	\N	\N	\N	\N	79742	79742	79743
18557	25615	0	applied	\N	\N	\N	\N	79796	79796	79797
18557	25616	1	applied	\N	\N	\N	\N	79798	79798	79799
18557	25617	2	applied	\N	\N	\N	\N	79800	79800	79801
18557	25618	3	applied	\N	\N	\N	\N	79802	79802	79803
18559	25619	0	applied	\N	\N	\N	\N	79806	79806	79807
18559	25620	1	applied	\N	\N	\N	\N	79808	79808	79809
18559	25621	2	applied	\N	\N	\N	\N	79810	79810	79811
18562	25629	0	applied	\N	\N	\N	\N	79832	79832	79833
18562	25630	1	applied	\N	\N	\N	\N	79834	79834	79835
18569	25640	0	applied	\N	\N	\N	\N	79865	79865	79866
18569	25641	1	applied	\N	\N	\N	\N	79867	79867	79868
18569	25642	2	applied	\N	\N	\N	\N	79869	79869	79870
18571	25643	0	applied	\N	\N	\N	\N	79873	79873	79874
18571	25644	1	applied	\N	\N	\N	\N	79875	79875	79876
18571	25645	2	applied	\N	\N	\N	\N	79877	79877	79878
18571	25646	3	applied	\N	\N	\N	\N	79879	79879	79880
18585	25668	0	applied	\N	\N	\N	\N	79935	79935	79936
18585	25669	1	applied	\N	\N	\N	\N	79937	79937	79938
18585	25670	2	applied	\N	\N	\N	\N	79939	79939	79940
18585	25671	3	applied	\N	\N	\N	\N	79941	79941	79942
18586	25668	0	applied	\N	\N	\N	\N	79935	79935	79936
18586	25669	1	applied	\N	\N	\N	\N	79937	79937	79938
18586	25670	2	applied	\N	\N	\N	\N	79939	79939	79940
18586	25671	3	applied	\N	\N	\N	\N	79941	79941	79942
18589	25680	0	applied	\N	\N	\N	\N	79971	79971	79972
18589	25681	1	applied	\N	\N	\N	\N	79973	79973	79974
18591	25680	0	applied	\N	\N	\N	\N	79971	79971	79972
18591	25681	1	applied	\N	\N	\N	\N	79973	79973	79974
18595	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18595	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18595	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18595	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18595	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18599	25684	0	applied	\N	\N	\N	\N	79984	79984	79985
18602	25689	0	applied	\N	\N	\N	\N	80017	80017	80018
18602	25690	1	applied	\N	\N	\N	\N	80019	80019	80020
18607	25697	0	applied	\N	\N	\N	\N	80043	80043	80044
18607	25698	1	applied	\N	\N	\N	\N	80045	80045	80046
18611	25699	0	applied	\N	\N	\N	\N	80054	80054	80055
18611	25700	1	applied	\N	\N	\N	\N	80056	80056	80057
18611	25701	2	applied	\N	\N	\N	\N	80058	80058	80059
18613	25702	0	applied	\N	\N	1000000000	\N	80062	80062	80063
18531	25540	2	applied	\N	\N	\N	\N	79601	79601	79602
18531	25541	3	applied	\N	\N	\N	\N	79603	79603	79604
18531	25542	4	applied	\N	\N	\N	\N	79605	79605	79606
18531	25543	5	applied	\N	\N	\N	\N	79607	79607	79608
18531	25544	6	applied	\N	\N	\N	\N	79609	79609	79610
18536	25518	0	applied	\N	\N	\N	\N	79639	79639	79639
18536	25538	1	applied	\N	\N	1000000000	\N	79640	79640	79598
18536	25493	2	applied	\N	\N	\N	\N	79471	79471	79471
18536	25404	3	applied	\N	\N	1000000000	\N	79232	79232	79233
18536	25455	4	applied	\N	\N	1000000000	\N	79366	79366	79367
18536	25496	5	applied	\N	\N	1000000000	\N	79478	79478	79479
18536	25459	6	applied	\N	\N	\N	\N	79480	79480	79481
18541	25565	0	applied	\N	\N	\N	\N	79666	79666	79667
18541	25566	1	applied	\N	\N	\N	\N	79668	79668	79669
18541	25567	2	applied	\N	\N	\N	\N	79670	79670	79671
18543	25572	0	applied	\N	\N	\N	\N	79688	79688	79689
18543	25573	1	applied	\N	\N	\N	\N	79690	79690	79691
18543	25574	2	applied	\N	\N	\N	\N	79692	79692	79693
18546	25575	0	applied	\N	\N	\N	\N	79696	79696	79697
18546	25576	1	applied	\N	\N	\N	\N	79698	79698	79699
18546	25577	2	applied	\N	\N	\N	\N	79700	79700	79701
18550	25582	0	applied	\N	\N	\N	\N	79719	79719	79720
18550	25583	1	applied	\N	\N	\N	\N	79721	79721	79722
18554	25598	0	applied	\N	\N	\N	\N	79757	79757	79758
18554	25599	1	applied	\N	\N	\N	\N	79759	79759	79760
18554	25600	2	applied	\N	\N	\N	\N	79761	79761	79762
18554	25601	3	applied	\N	\N	\N	\N	79763	79763	79764
18554	25602	4	applied	\N	\N	\N	\N	79765	79765	79766
18554	25603	5	applied	\N	\N	\N	\N	79767	79767	79768
18554	25604	6	applied	\N	\N	\N	\N	79769	79769	79770
18554	25605	7	applied	\N	\N	\N	\N	79771	79771	79772
18554	25606	8	applied	\N	\N	\N	\N	79773	79773	79774
18554	25607	9	applied	\N	\N	\N	\N	79775	79775	79776
18554	25608	10	applied	\N	\N	\N	\N	79777	79777	79778
18554	25609	11	applied	\N	\N	\N	\N	79779	79779	79780
18554	25610	12	applied	\N	\N	\N	\N	79781	79781	79782
18556	25611	0	applied	\N	\N	\N	\N	79786	79786	79787
18556	25612	1	applied	\N	\N	\N	\N	79788	79788	79789
18556	25613	2	applied	\N	\N	\N	\N	79790	79790	79791
18556	25614	3	applied	\N	\N	\N	\N	79792	79792	79793
18561	25622	0	applied	\N	\N	\N	\N	79816	79816	79817
18561	25623	1	applied	\N	\N	\N	\N	79818	79818	79819
18561	25624	2	applied	\N	\N	\N	\N	79820	79820	79821
18561	25625	3	applied	\N	\N	\N	\N	79822	79822	79823
18561	25626	4	applied	\N	\N	\N	\N	79824	79824	79825
18561	25627	5	applied	\N	\N	\N	\N	79826	79826	79827
18561	25628	6	applied	\N	\N	\N	\N	79828	79828	79829
18564	25634	0	applied	\N	\N	\N	\N	79844	79844	79845
18564	25635	1	applied	\N	\N	\N	\N	79846	79846	79847
18564	25636	2	applied	\N	\N	\N	\N	79848	79848	79849
18580	25655	0	applied	\N	\N	\N	\N	79907	79907	79908
18580	25656	1	applied	\N	\N	\N	\N	79909	79909	79910
18584	25668	0	applied	\N	\N	\N	\N	79935	79935	79936
18584	25669	1	applied	\N	\N	\N	\N	79937	79937	79938
18584	25670	2	applied	\N	\N	\N	\N	79939	79939	79940
18584	25671	3	applied	\N	\N	\N	\N	79941	79941	79942
18588	25674	0	applied	\N	\N	1000000000	\N	79957	79957	79958
18588	25675	1	applied	\N	\N	\N	\N	79959	79959	79960
18588	25676	2	applied	\N	\N	\N	\N	79961	79961	79962
18588	25677	3	applied	\N	\N	\N	\N	79963	79963	79964
18588	25678	4	applied	\N	\N	\N	\N	79965	79965	79966
18588	25679	5	applied	\N	\N	\N	\N	79967	79967	79968
18594	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18594	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18594	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18594	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18594	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18596	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18596	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18596	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18596	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18596	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18598	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18598	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18598	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18598	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18598	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18604	25692	0	applied	\N	\N	\N	\N	80027	80027	80028
18604	25693	1	applied	\N	\N	\N	\N	80029	80029	80030
18604	25694	2	applied	\N	\N	\N	\N	80031	80031	80032
18606	25695	0	applied	\N	\N	\N	\N	80035	80035	80036
18606	25696	1	applied	\N	\N	\N	\N	80037	80037	80038
18609	25697	0	applied	\N	\N	\N	\N	80043	80043	80044
18609	25698	1	applied	\N	\N	\N	\N	80045	80045	80046
18617	25721	0	applied	\N	\N	\N	\N	80106	80106	80107
18624	25729	0	applied	\N	\N	\N	\N	80134	80134	80135
18624	25730	1	applied	\N	\N	\N	\N	80136	80136	80137
18624	25731	2	applied	\N	\N	\N	\N	80138	80138	80139
18627	25739	0	applied	\N	\N	\N	\N	80158	80158	80159
18627	25740	1	applied	\N	\N	\N	\N	80160	80160	80161
18627	25741	2	applied	\N	\N	\N	\N	80162	80162	80163
18627	25742	3	applied	\N	\N	\N	\N	80164	80164	80165
18627	25743	4	applied	\N	\N	\N	\N	80166	80166	80167
18638	25768	0	applied	\N	\N	\N	\N	80234	80234	80235
18638	25769	1	applied	\N	\N	\N	\N	80236	80236	80237
18638	25770	2	applied	\N	\N	\N	\N	80238	80238	80239
18638	25771	3	applied	\N	\N	\N	\N	80240	80240	80241
18643	25779	0	applied	\N	\N	\N	\N	80264	80264	80265
18643	25780	1	applied	\N	\N	\N	\N	80266	80266	80267
18645	25779	0	applied	\N	\N	\N	\N	80264	80264	80265
18645	25780	1	applied	\N	\N	\N	\N	80266	80266	80267
18647	25781	0	applied	\N	\N	\N	\N	80273	80273	80274
18647	25782	1	applied	\N	\N	\N	\N	80275	80275	80276
18647	25783	2	applied	\N	\N	\N	\N	80277	80277	80278
18647	25784	3	applied	\N	\N	\N	\N	80279	80279	80280
18647	25785	4	applied	\N	\N	\N	\N	80281	80281	80282
18652	25789	0	applied	\N	\N	\N	\N	80296	80296	80297
18652	25790	1	applied	\N	\N	\N	\N	80298	80298	80299
18652	25791	2	applied	\N	\N	\N	\N	80300	80300	80301
18655	25796	0	applied	\N	\N	\N	\N	80316	80316	80317
18655	25797	1	applied	\N	\N	\N	\N	80318	80318	80319
18655	25798	2	applied	\N	\N	\N	\N	80320	80320	80321
18655	25799	3	applied	\N	\N	\N	\N	80322	80322	80145
18655	25800	4	applied	\N	\N	\N	\N	80323	80323	80324
18655	25801	5	applied	\N	\N	\N	\N	80325	80325	80326
18658	25796	0	applied	\N	\N	\N	\N	80316	80316	80317
18658	25797	1	applied	\N	\N	\N	\N	80318	80318	80319
18658	25798	2	applied	\N	\N	\N	\N	80320	80320	80321
18658	25799	3	applied	\N	\N	\N	\N	80322	80322	80145
18566	25635	1	applied	\N	\N	\N	\N	79846	79846	79847
18566	25636	2	applied	\N	\N	\N	\N	79848	79848	79849
18566	25631	3	applied	\N	\N	\N	\N	79837	79837	79852
18566	25632	4	applied	\N	\N	\N	\N	79839	79839	79853
18566	25637	5	applied	\N	\N	\N	\N	79854	79854	79855
18566	25633	6	applied	\N	\N	\N	\N	79841	79841	79856
18568	25638	0	applied	\N	\N	\N	\N	79860	79860	79861
18568	25639	1	applied	\N	\N	\N	\N	79862	79862	79863
18572	25643	0	applied	\N	\N	\N	\N	79873	79873	79874
18572	25644	1	applied	\N	\N	\N	\N	79875	79875	79876
18572	25645	2	applied	\N	\N	\N	\N	79877	79877	79878
18572	25646	3	applied	\N	\N	\N	\N	79879	79879	79880
18577	25647	0	applied	\N	\N	\N	\N	79884	79884	79885
18579	25650	0	applied	\N	\N	\N	\N	79895	79895	79896
18579	25651	1	applied	\N	\N	\N	\N	79897	79897	79898
18579	25652	2	applied	\N	\N	\N	\N	79899	79899	79900
18579	25653	3	applied	\N	\N	\N	\N	79901	79901	79902
18579	25654	4	applied	\N	\N	\N	\N	79903	79903	79904
18583	25668	0	applied	\N	\N	\N	\N	79935	79935	79936
18583	25669	1	applied	\N	\N	\N	\N	79937	79937	79938
18583	25670	2	applied	\N	\N	\N	\N	79939	79939	79940
18583	25671	3	applied	\N	\N	\N	\N	79941	79941	79942
18587	25672	0	applied	\N	\N	\N	\N	79951	79951	79952
18587	25673	1	applied	\N	\N	\N	\N	79953	79953	79954
18590	25680	0	applied	\N	\N	\N	\N	79971	79971	79972
18590	25681	1	applied	\N	\N	\N	\N	79973	79973	79974
18593	25682	0	applied	\N	\N	\N	\N	79980	79980	79981
18593	25683	1	applied	\N	\N	\N	\N	79982	79982	79983
18593	25684	2	applied	\N	\N	\N	\N	79984	79984	79985
18593	25685	4	applied	\N	\N	\N	\N	79987	79987	79988
18593	25686	5	applied	\N	\N	\N	\N	79989	79989	79990
18601	25687	0	applied	\N	\N	\N	\N	80009	80009	80010
18601	25688	1	applied	\N	\N	\N	\N	80011	80011	80012
18603	25691	0	applied	\N	\N	\N	\N	80023	80023	80024
18610	25697	0	applied	\N	\N	\N	\N	80043	80043	80044
18610	25698	1	applied	\N	\N	\N	\N	80045	80045	80046
18612	25699	0	applied	\N	\N	\N	\N	80054	80054	80055
18612	25700	1	applied	\N	\N	\N	\N	80056	80056	80057
18612	25701	2	applied	\N	\N	\N	\N	80058	80058	80059
18614	25702	0	applied	\N	\N	1000000000	\N	80062	80062	80063
18614	25703	1	applied	\N	\N	\N	\N	80064	80064	80065
18614	25704	2	applied	\N	\N	\N	\N	80066	80066	80067
18614	25705	3	applied	\N	\N	\N	\N	80068	80068	80069
18614	25706	4	applied	\N	\N	\N	\N	80070	80070	80071
18614	25707	5	applied	\N	\N	\N	\N	80072	80072	80073
18614	25708	6	applied	\N	\N	\N	\N	80074	80074	80075
18614	25709	7	applied	\N	\N	\N	\N	80076	80076	80077
18614	25710	8	applied	\N	\N	\N	\N	80078	80078	80079
18614	25711	9	applied	\N	\N	\N	\N	80080	80080	80081
18614	25712	10	applied	\N	\N	\N	\N	80082	80082	80083
18614	25713	11	applied	\N	\N	\N	\N	80084	80084	80085
18614	25714	12	applied	\N	\N	\N	\N	80086	80086	80087
18614	25715	13	applied	\N	\N	\N	\N	80088	80088	80089
18614	25716	14	applied	\N	\N	\N	\N	80090	80090	80091
18614	25717	15	applied	\N	\N	\N	\N	80092	80092	80093
18614	25718	16	applied	\N	\N	\N	\N	80094	80094	80095
18619	25722	0	applied	\N	\N	\N	\N	80112	80112	80113
18619	25723	1	applied	\N	\N	\N	\N	80114	80114	80115
18621	25724	0	applied	\N	\N	\N	\N	80120	80120	80121
18621	25725	1	applied	\N	\N	\N	\N	80122	80122	80123
18621	25726	2	applied	\N	\N	\N	\N	80124	80124	80125
18626	25737	0	applied	\N	\N	\N	\N	80152	80152	80153
18626	25738	1	applied	\N	\N	\N	\N	80154	80154	80155
18629	25739	0	applied	\N	\N	\N	\N	80158	80158	80159
18629	25740	1	applied	\N	\N	\N	\N	80160	80160	80161
18629	25741	2	applied	\N	\N	\N	\N	80162	80162	80163
18629	25742	3	applied	\N	\N	\N	\N	80164	80164	80165
18629	25743	4	applied	\N	\N	\N	\N	80166	80166	80167
18634	25753	0	applied	\N	\N	\N	\N	80197	80197	80198
18634	25754	1	applied	\N	\N	\N	\N	80199	80199	80200
18634	25755	2	applied	\N	\N	\N	\N	80201	80201	80202
18634	25756	3	applied	\N	\N	\N	\N	80203	80203	80204
18634	25757	4	applied	\N	\N	\N	\N	80205	80205	80206
18637	25760	0	applied	\N	\N	\N	\N	80216	80216	80217
18637	25761	1	applied	\N	\N	\N	\N	80218	80218	80219
18637	25762	2	applied	\N	\N	\N	\N	80220	80220	80221
18637	25763	3	applied	\N	\N	\N	\N	80222	80222	80223
18637	25764	4	applied	\N	\N	\N	\N	80224	80224	80225
18637	25765	5	applied	\N	\N	\N	\N	80226	80226	80227
18637	25766	6	applied	\N	\N	1000000000	\N	80228	80228	80229
18637	25767	7	applied	\N	\N	\N	\N	80230	80230	80231
18640	25772	0	applied	\N	\N	\N	\N	80246	80246	80247
18640	25773	1	applied	\N	\N	\N	\N	80248	80248	80249
18640	25774	2	applied	\N	\N	\N	\N	80250	80250	80251
18640	25775	3	applied	\N	\N	\N	\N	80252	80252	80253
18640	25776	4	applied	\N	\N	\N	\N	80254	80254	80255
18640	25777	5	applied	\N	\N	\N	\N	80256	80256	80257
18640	25778	6	applied	\N	\N	\N	\N	80258	80258	80259
18642	25779	0	applied	\N	\N	\N	\N	80264	80264	80265
18642	25780	1	applied	\N	\N	\N	\N	80266	80266	80267
18649	25786	0	applied	\N	\N	\N	\N	80287	80287	80288
18649	25787	1	applied	\N	\N	\N	\N	80289	80289	80290
18651	25786	0	applied	\N	\N	\N	\N	80287	80287	80288
18651	25788	1	applied	\N	\N	\N	\N	80294	80294	80295
18657	25796	0	applied	\N	\N	\N	\N	80316	80316	80317
18657	25797	1	applied	\N	\N	\N	\N	80318	80318	80319
18657	25798	2	applied	\N	\N	\N	\N	80320	80320	80321
18657	25799	3	applied	\N	\N	\N	\N	80322	80322	80145
18657	25800	4	applied	\N	\N	\N	\N	80323	80323	80324
18657	25801	5	applied	\N	\N	\N	\N	80325	80325	80326
18661	25805	0	applied	\N	\N	\N	\N	80340	80340	80341
18661	25806	1	applied	\N	\N	\N	\N	80342	80342	80343
18661	25807	2	applied	\N	\N	\N	\N	80344	80344	80345
18663	25768	0	applied	\N	\N	\N	\N	80234	80234	80235
18663	25769	1	applied	\N	\N	\N	\N	80236	80236	80237
18663	25772	2	applied	\N	\N	\N	\N	80246	80246	80247
18663	25773	3	applied	\N	\N	\N	\N	80248	80248	80249
18663	25807	4	applied	\N	\N	\N	\N	80344	80344	80345
18663	25766	5	applied	\N	\N	1000000000	\N	80228	80228	80229
18663	25720	6	applied	\N	\N	\N	\N	80102	80102	80103
18663	25725	7	applied	\N	\N	\N	\N	80122	80122	80355
18663	25726	8	applied	\N	\N	\N	\N	80124	80124	80356
18663	25728	9	applied	\N	\N	\N	\N	80132	80132	80357
18663	25730	10	applied	\N	\N	\N	\N	80136	80136	80358
18663	25735	11	applied	\N	\N	\N	\N	80147	80147	80359
18663	25736	12	applied	\N	\N	\N	\N	80149	80149	80360
18663	25738	13	applied	\N	\N	\N	\N	80154	80154	80361
18663	25741	14	applied	\N	\N	\N	\N	80162	80162	80362
18663	25799	15	applied	\N	\N	\N	\N	80322	80322	75295
18608	25698	1	applied	\N	\N	\N	\N	80045	80045	80046
18616	25721	0	applied	\N	\N	\N	\N	80106	80106	80107
18618	25722	0	applied	\N	\N	\N	\N	80112	80112	80113
18618	25723	1	applied	\N	\N	\N	\N	80114	80114	80115
18623	25729	0	applied	\N	\N	\N	\N	80134	80134	80135
18623	25730	1	applied	\N	\N	\N	\N	80136	80136	80137
18623	25731	2	applied	\N	\N	\N	\N	80138	80138	80139
18628	25739	0	applied	\N	\N	\N	\N	80158	80158	80159
18628	25740	1	applied	\N	\N	\N	\N	80160	80160	80161
18628	25741	2	applied	\N	\N	\N	\N	80162	80162	80163
18628	25742	3	applied	\N	\N	\N	\N	80164	80164	80165
18628	25743	4	applied	\N	\N	\N	\N	80166	80166	80167
18631	25744	0	applied	\N	\N	\N	\N	80173	80173	80174
18631	25745	1	applied	\N	\N	\N	\N	80175	80175	80176
18631	25746	2	applied	\N	\N	\N	\N	80177	80177	80178
18631	25747	3	applied	\N	\N	\N	\N	80179	80179	80180
18631	25748	4	applied	\N	\N	\N	\N	80181	80181	80182
18633	25749	0	applied	\N	\N	\N	\N	80188	80188	80189
18633	25750	1	applied	\N	\N	\N	\N	80190	80190	80191
18633	25751	2	applied	\N	\N	\N	\N	80192	80192	80193
18633	25752	3	applied	\N	\N	\N	\N	80194	80194	80195
18636	25758	0	applied	\N	\N	\N	\N	80210	80210	80211
18636	25759	1	applied	\N	\N	\N	\N	80212	80212	80213
18639	25768	0	applied	\N	\N	\N	\N	80234	80234	80235
18639	25769	1	applied	\N	\N	\N	\N	80236	80236	80237
18639	25770	2	applied	\N	\N	\N	\N	80238	80238	80239
18639	25771	3	applied	\N	\N	\N	\N	80240	80240	80241
18648	25781	0	applied	\N	\N	\N	\N	80273	80273	80274
18648	25782	1	applied	\N	\N	\N	\N	80275	80275	80276
18648	25783	2	applied	\N	\N	\N	\N	80277	80277	80278
18648	25784	3	applied	\N	\N	\N	\N	80279	80279	80280
18648	25785	4	applied	\N	\N	\N	\N	80281	80281	80282
18654	25792	0	applied	\N	\N	\N	\N	80304	80304	80305
18654	25793	1	applied	\N	\N	\N	\N	80306	80306	80307
18654	25794	2	applied	\N	\N	\N	\N	80308	80308	80309
18654	25795	3	applied	\N	\N	\N	\N	80310	80310	80311
18660	25802	0	applied	\N	\N	\N	\N	80333	80333	80334
18660	25803	1	applied	\N	\N	\N	\N	80335	80335	80336
18660	25804	2	applied	\N	\N	\N	\N	80337	80337	80338
18665	25814	0	applied	\N	\N	\N	\N	80387	80387	80388
18665	25815	1	applied	\N	\N	\N	\N	80389	80389	80390
18672	25816	0	applied	\N	\N	\N	\N	80397	80397	80398
18672	25817	1	applied	\N	\N	1000000000	\N	80399	80399	80400
18672	25818	2	applied	\N	\N	\N	\N	80401	80401	80402
18672	25819	3	applied	\N	\N	\N	\N	80403	80403	80404
18676	25820	0	applied	\N	\N	1000000000	\N	80421	80421	80422
18676	25821	1	applied	\N	\N	\N	\N	80423	80423	80424
18676	25822	2	applied	\N	\N	\N	\N	80425	80425	80426
18678	25823	0	applied	\N	\N	\N	\N	80431	80431	80432
18678	25824	1	applied	\N	\N	1000000000	\N	80433	80433	80434
18678	25825	2	applied	\N	\N	1000000000	\N	80435	80435	80436
18678	25826	3	applied	\N	\N	1000000000	\N	80437	80437	80438
18678	25827	4	applied	\N	\N	\N	\N	80439	80439	80440
18682	25842	0	applied	\N	\N	\N	\N	80517	80517	80518
18682	25843	1	applied	\N	\N	1000000000	\N	80519	80519	80520
18682	25844	2	applied	\N	\N	\N	\N	80521	80521	80522
18682	25845	3	applied	\N	\N	\N	\N	80523	80523	80524
18682	25846	4	applied	\N	\N	\N	\N	80525	80525	80526
18682	25847	5	applied	\N	\N	\N	\N	80527	80527	80528
18687	25851	0	applied	\N	\N	\N	\N	80540	80540	80541
18687	25852	2	applied	\N	\N	\N	\N	80543	80543	80544
18691	25851	0	applied	\N	\N	\N	\N	80540	80540	80541
18691	25853	1	applied	\N	\N	\N	\N	80554	80554	80555
18691	25854	2	applied	\N	\N	\N	\N	80556	80556	80557
18691	25855	3	applied	\N	\N	\N	\N	80558	80558	80559
18691	25852	4	applied	\N	\N	\N	\N	80543	80543	80560
18691	25856	5	applied	\N	\N	\N	\N	80561	80561	80562
18691	25857	6	applied	\N	\N	\N	\N	80563	80563	80564
18694	25858	0	applied	\N	\N	\N	\N	80571	80571	80572
18694	25859	1	applied	\N	\N	\N	\N	80573	80573	80574
18694	25860	2	applied	\N	\N	\N	\N	80575	80575	80576
18694	25861	3	applied	\N	\N	\N	\N	80577	80577	80578
18698	25862	0	applied	\N	\N	\N	\N	80581	80581	80582
18698	25863	1	applied	\N	\N	\N	\N	80583	80583	80584
18698	25864	2	applied	\N	\N	\N	\N	80585	80585	80586
18700	25865	0	applied	\N	\N	\N	\N	80603	80603	80604
18700	25866	1	applied	\N	\N	\N	\N	80605	80605	80606
18700	25867	2	applied	\N	\N	\N	\N	80607	80607	80608
18700	25868	3	applied	\N	\N	\N	\N	80609	80609	80610
18703	25874	0	applied	\N	\N	\N	\N	80626	80626	80627
18703	25875	1	applied	\N	\N	\N	\N	80628	80628	80629
18705	25876	0	applied	\N	\N	\N	\N	80632	80632	80633
18705	25877	1	applied	\N	\N	\N	\N	80634	80634	80635
18712	25891	0	applied	\N	\N	\N	\N	80675	80675	80676
18712	25892	1	applied	\N	\N	\N	\N	80677	80677	80678
18712	25893	2	applied	\N	\N	\N	\N	80679	80679	80680
18712	25894	3	applied	\N	\N	\N	\N	80681	80681	80682
18712	25895	4	applied	\N	\N	\N	\N	80683	80683	80684
18712	25896	5	applied	\N	\N	\N	\N	80685	80685	80686
18712	25897	6	applied	\N	\N	\N	\N	80687	80687	80383
18712	25898	7	applied	\N	\N	\N	\N	80688	80688	80689
18712	25899	8	applied	\N	\N	\N	\N	80690	80690	80691
18712	25900	9	applied	\N	\N	\N	\N	80692	80692	80693
18714	25901	0	applied	\N	\N	\N	\N	80698	80698	80699
18714	25902	1	applied	\N	\N	\N	\N	80700	80700	80701
18714	25903	2	applied	\N	\N	\N	\N	80702	80702	80703
18717	25906	0	applied	\N	\N	\N	\N	80711	80711	80712
18717	25907	1	applied	\N	\N	\N	\N	80713	80713	80714
18719	25911	0	applied	\N	\N	\N	\N	80727	80727	80728
18719	25912	1	applied	\N	\N	\N	\N	80729	80729	80730
18719	25913	2	applied	\N	\N	\N	\N	80731	80731	80732
18719	25914	3	applied	\N	\N	\N	\N	80733	80733	80734
18729	25931	0	applied	\N	\N	\N	\N	80781	80781	80782
18729	25932	1	applied	\N	\N	\N	\N	80783	80783	80784
18735	25942	0	applied	\N	\N	\N	\N	80810	80810	80811
18735	25943	1	applied	\N	\N	\N	\N	80812	80812	80813
18735	25944	2	applied	\N	\N	\N	\N	80814	80814	80815
18740	25949	0	applied	\N	\N	\N	\N	80830	80830	80831
18740	25950	1	applied	\N	\N	\N	\N	80832	80832	80833
18740	25951	2	applied	\N	\N	\N	\N	80834	80834	80835
18744	25962	0	applied	\N	\N	\N	\N	80866	80866	80867
18744	25963	1	applied	\N	\N	\N	\N	80868	80868	80869
18744	25964	2	applied	\N	\N	\N	\N	80870	80870	80871
18747	25969	0	applied	\N	\N	\N	\N	80885	80885	80886
18747	25970	1	applied	\N	\N	\N	\N	80887	80887	80888
18747	25971	2	applied	\N	\N	\N	\N	80889	80889	80890
18747	25972	3	applied	\N	\N	\N	\N	80891	80891	80892
18747	25973	4	applied	\N	\N	\N	\N	80893	80893	80894
18749	25974	0	applied	\N	\N	\N	\N	80900	80900	80901
18613	25703	1	applied	\N	\N	\N	\N	80064	80064	80065
18613	25704	2	applied	\N	\N	\N	\N	80066	80066	80067
18613	25705	3	applied	\N	\N	\N	\N	80068	80068	80069
18613	25706	4	applied	\N	\N	\N	\N	80070	80070	80071
18613	25707	5	applied	\N	\N	\N	\N	80072	80072	80073
18613	25708	6	applied	\N	\N	\N	\N	80074	80074	80075
18613	25709	7	applied	\N	\N	\N	\N	80076	80076	80077
18613	25710	8	applied	\N	\N	\N	\N	80078	80078	80079
18613	25711	9	applied	\N	\N	\N	\N	80080	80080	80081
18613	25712	10	applied	\N	\N	\N	\N	80082	80082	80083
18613	25713	11	applied	\N	\N	\N	\N	80084	80084	80085
18613	25714	12	applied	\N	\N	\N	\N	80086	80086	80087
18613	25715	13	applied	\N	\N	\N	\N	80088	80088	80089
18613	25716	14	applied	\N	\N	\N	\N	80090	80090	80091
18613	25717	15	applied	\N	\N	\N	\N	80092	80092	80093
18613	25718	16	applied	\N	\N	\N	\N	80094	80094	80095
18615	25719	0	applied	\N	\N	\N	\N	80100	80100	80101
18615	25720	1	applied	\N	\N	\N	\N	80102	80102	80103
18620	25724	0	applied	\N	\N	\N	\N	80120	80120	80121
18620	25725	1	applied	\N	\N	\N	\N	80122	80122	80123
18620	25726	2	applied	\N	\N	\N	\N	80124	80124	80125
18622	25727	0	applied	\N	\N	\N	\N	80130	80130	80131
18622	25728	1	applied	\N	\N	\N	\N	80132	80132	80133
18625	25732	0	applied	\N	\N	\N	\N	80141	80141	80142
18625	25733	1	applied	\N	\N	\N	\N	80143	80143	80144
18625	25734	2	applied	\N	\N	\N	\N	80145	80145	80146
18625	25735	3	applied	\N	\N	\N	\N	80147	80147	80148
18625	25736	4	applied	\N	\N	\N	\N	80149	80149	80150
18630	25744	0	applied	\N	\N	\N	\N	80173	80173	80174
18630	25745	1	applied	\N	\N	\N	\N	80175	80175	80176
18630	25746	2	applied	\N	\N	\N	\N	80177	80177	80178
18630	25747	3	applied	\N	\N	\N	\N	80179	80179	80180
18630	25748	4	applied	\N	\N	\N	\N	80181	80181	80182
18632	25744	0	applied	\N	\N	\N	\N	80173	80173	80174
18632	25745	1	applied	\N	\N	\N	\N	80175	80175	80176
18632	25746	2	applied	\N	\N	\N	\N	80177	80177	80178
18632	25747	3	applied	\N	\N	\N	\N	80179	80179	80180
18632	25748	4	applied	\N	\N	\N	\N	80181	80181	80182
18635	25753	0	applied	\N	\N	\N	\N	80197	80197	80198
18635	25754	1	applied	\N	\N	\N	\N	80199	80199	80200
18635	25755	2	applied	\N	\N	\N	\N	80201	80201	80202
18635	25756	3	applied	\N	\N	\N	\N	80203	80203	80204
18635	25757	4	applied	\N	\N	\N	\N	80205	80205	80206
18641	25772	0	applied	\N	\N	\N	\N	80246	80246	80247
18641	25773	1	applied	\N	\N	\N	\N	80248	80248	80249
18641	25774	2	applied	\N	\N	\N	\N	80250	80250	80251
18641	25775	3	applied	\N	\N	\N	\N	80252	80252	80253
18641	25776	4	applied	\N	\N	\N	\N	80254	80254	80255
18641	25777	5	applied	\N	\N	\N	\N	80256	80256	80257
18641	25778	6	applied	\N	\N	\N	\N	80258	80258	80259
18644	25779	0	applied	\N	\N	\N	\N	80264	80264	80265
18644	25780	1	applied	\N	\N	\N	\N	80266	80266	80267
18646	25779	0	applied	\N	\N	\N	\N	80264	80264	80265
18646	25780	1	applied	\N	\N	\N	\N	80266	80266	80267
18650	25787	0	applied	\N	\N	\N	\N	80289	80289	80290
18653	25792	0	applied	\N	\N	\N	\N	80304	80304	80305
18653	25793	1	applied	\N	\N	\N	\N	80306	80306	80307
18653	25794	2	applied	\N	\N	\N	\N	80308	80308	80309
18653	25795	3	applied	\N	\N	\N	\N	80310	80310	80311
18656	25796	0	applied	\N	\N	\N	\N	80316	80316	80317
18656	25797	1	applied	\N	\N	\N	\N	80318	80318	80319
18656	25798	2	applied	\N	\N	\N	\N	80320	80320	80321
18656	25799	3	applied	\N	\N	\N	\N	80322	80322	80145
18656	25800	4	applied	\N	\N	\N	\N	80323	80323	80324
18656	25801	5	applied	\N	\N	\N	\N	80325	80325	80326
18659	25796	0	applied	\N	\N	\N	\N	80316	80316	80317
18659	25797	1	applied	\N	\N	\N	\N	80318	80318	80319
18659	25798	2	applied	\N	\N	\N	\N	80320	80320	80321
18659	25799	3	applied	\N	\N	\N	\N	80322	80322	80145
18659	25800	4	applied	\N	\N	\N	\N	80323	80323	80324
18659	25801	5	applied	\N	\N	\N	\N	80325	80325	80326
18662	25808	0	applied	\N	\N	\N	\N	80347	80347	80348
18662	25809	1	applied	\N	\N	\N	\N	80349	80349	80350
18662	25810	2	applied	\N	\N	\N	\N	80351	80351	80352
18667	25814	0	applied	\N	\N	\N	\N	80387	80387	80388
18667	25815	1	applied	\N	\N	\N	\N	80389	80389	80390
18673	25518	0	applied	\N	\N	\N	\N	79639	79639	79639
18673	25538	1	applied	\N	\N	1000000000	\N	79640	79640	79598
18673	25578	2	applied	\N	\N	\N	\N	80411	80411	79709
18673	25594	3	applied	\N	\N	\N	\N	80412	80412	79747
18673	25615	4	applied	\N	\N	\N	\N	80413	80413	79797
18673	25622	5	applied	\N	\N	\N	\N	80414	80414	79817
18673	25634	6	applied	\N	\N	\N	\N	80415	80415	79845
18673	25640	7	applied	\N	\N	\N	\N	80416	80416	79866
18673	25643	8	applied	\N	\N	\N	\N	80417	80417	79874
18673	25768	9	applied	\N	\N	\N	\N	80234	80234	80235
18673	25769	10	applied	\N	\N	\N	\N	80236	80236	80237
18673	25772	11	applied	\N	\N	\N	\N	80246	80246	80247
18673	25773	12	applied	\N	\N	\N	\N	80248	80248	80249
18673	25493	13	applied	\N	\N	\N	\N	79471	79471	79471
18673	25404	14	applied	\N	\N	1000000000	\N	79232	79232	79233
18673	25455	15	applied	\N	\N	1000000000	\N	79366	79366	79367
18673	25496	16	applied	\N	\N	1000000000	\N	79478	79478	79479
18673	25657	17	applied	\N	\N	1000000000	\N	79911	79911	79912
18673	25674	18	applied	\N	\N	1000000000	\N	79957	79957	79958
18673	25702	19	applied	\N	\N	1000000000	\N	80062	80062	80063
18673	25293	20	applied	\N	\N	\N	\N	78866	78866	78867
18673	25295	21	applied	\N	\N	\N	\N	78872	78872	78873
18673	25298	22	applied	\N	\N	\N	\N	78884	78884	78885
18673	25299	23	applied	\N	\N	\N	\N	78886	78886	78887
18673	25301	24	applied	\N	\N	\N	\N	78892	78892	78893
18673	25304	25	applied	\N	\N	\N	\N	78899	78899	78900
18673	25306	26	applied	\N	\N	\N	\N	78904	78904	78905
18673	25309	27	applied	\N	\N	\N	\N	78909	78909	78910
18673	25312	28	applied	\N	\N	\N	\N	78916	78916	78917
18673	25315	29	applied	\N	\N	\N	\N	78923	78923	78924
18673	25316	30	applied	\N	\N	\N	\N	78925	78925	78926
18673	25317	31	applied	\N	\N	\N	\N	78927	78927	78928
18673	25325	32	applied	\N	\N	\N	\N	78949	78949	78950
18673	25329	33	applied	\N	\N	\N	\N	78962	78962	78963
18673	25331	34	applied	\N	\N	\N	\N	78968	78968	78969
18673	25335	35	applied	\N	\N	\N	\N	78988	78988	78989
18673	25338	36	applied	\N	\N	\N	\N	78996	78996	78997
18673	25340	37	applied	\N	\N	\N	\N	79000	79000	79001
18673	25343	38	applied	\N	\N	\N	\N	79008	79008	79009
18673	25347	39	applied	\N	\N	\N	\N	79031	79031	79032
18673	25350	40	applied	\N	\N	\N	\N	79039	79039	79040
18673	25351	41	applied	\N	\N	\N	\N	79041	79041	79042
18673	25357	42	applied	\N	\N	\N	\N	79063	79063	79064
18658	25800	4	applied	\N	\N	\N	\N	80323	80323	80324
18658	25801	5	applied	\N	\N	\N	\N	80325	80325	80326
18664	25811	0	applied	\N	\N	\N	\N	80379	80379	80380
18664	25812	1	applied	\N	\N	\N	\N	80381	80381	80382
18664	25813	2	applied	\N	\N	\N	\N	80383	80383	80384
18666	25814	0	applied	\N	\N	\N	\N	80387	80387	80388
18666	25815	1	applied	\N	\N	\N	\N	80389	80389	80390
18668	25814	0	applied	\N	\N	\N	\N	80387	80387	80388
18668	25815	1	applied	\N	\N	\N	\N	80389	80389	80390
18671	25816	0	applied	\N	\N	\N	\N	80397	80397	80398
18671	25817	1	applied	\N	\N	1000000000	\N	80399	80399	80400
18671	25818	2	applied	\N	\N	\N	\N	80401	80401	80402
18671	25819	3	applied	\N	\N	\N	\N	80403	80403	80404
18679	25828	0	applied	\N	\N	\N	\N	80442	80442	80443
18679	25829	1	applied	\N	\N	\N	\N	80444	80444	80445
18679	25830	2	applied	\N	\N	\N	\N	80446	80446	80447
18683	25848	0	applied	\N	\N	\N	\N	80530	80530	80531
18683	25849	1	applied	\N	\N	\N	\N	80532	80532	80533
18688	25851	0	applied	\N	\N	\N	\N	80540	80540	80541
18688	25852	2	applied	\N	\N	\N	\N	80543	80543	80544
18701	25865	0	applied	\N	\N	\N	\N	80603	80603	80604
18701	25866	1	applied	\N	\N	\N	\N	80605	80605	80606
18701	25867	2	applied	\N	\N	\N	\N	80607	80607	80608
18701	25868	3	applied	\N	\N	\N	\N	80609	80609	80610
18704	25876	0	applied	\N	\N	\N	\N	80632	80632	80633
18704	25877	1	applied	\N	\N	\N	\N	80634	80634	80635
18706	25876	0	applied	\N	\N	\N	\N	80632	80632	80633
18706	25877	1	applied	\N	\N	\N	\N	80634	80634	80635
18707	25878	0	applied	\N	\N	\N	\N	80641	80641	80642
18707	25879	1	applied	\N	\N	\N	\N	80643	80643	80644
18707	25880	2	applied	\N	\N	\N	\N	80645	80645	80646
18707	25881	3	applied	\N	\N	\N	\N	80647	80647	80648
18707	25882	4	applied	\N	\N	\N	\N	80649	80649	80650
18707	25883	5	applied	\N	\N	\N	\N	80651	80651	80652
18707	25884	6	applied	\N	\N	\N	\N	80653	80653	80654
18710	25890	0	applied	\N	\N	\N	\N	80669	80669	80670
18713	25891	0	applied	\N	\N	\N	\N	80675	80675	80676
18713	25892	1	applied	\N	\N	\N	\N	80677	80677	80678
18713	25893	2	applied	\N	\N	\N	\N	80679	80679	80680
18713	25894	3	applied	\N	\N	\N	\N	80681	80681	80682
18713	25895	4	applied	\N	\N	\N	\N	80683	80683	80684
18713	25896	5	applied	\N	\N	\N	\N	80685	80685	80686
18713	25897	6	applied	\N	\N	\N	\N	80687	80687	80383
18713	25898	7	applied	\N	\N	\N	\N	80688	80688	80689
18713	25899	8	applied	\N	\N	\N	\N	80690	80690	80691
18713	25900	9	applied	\N	\N	\N	\N	80692	80692	80693
18715	25904	0	applied	\N	\N	\N	\N	80706	80706	80707
18715	25905	1	applied	\N	\N	\N	\N	80708	80708	80709
18723	25920	0	applied	\N	\N	\N	\N	80750	80750	80751
18723	25921	1	applied	\N	\N	\N	\N	80752	80752	80753
18723	25922	2	applied	\N	\N	\N	\N	80754	80754	80755
18723	25923	3	applied	\N	\N	1000000000	\N	80756	80756	80757
18723	25924	4	applied	\N	\N	\N	\N	80758	80758	80759
18723	25925	5	applied	\N	\N	\N	\N	80760	80760	80761
18728	25929	0	applied	\N	\N	\N	\N	80774	80774	80775
18728	25930	1	applied	\N	\N	\N	\N	80776	80776	80777
18733	25938	0	applied	\N	\N	\N	\N	80800	80800	80801
18733	25939	1	applied	\N	\N	\N	\N	80802	80802	80803
18733	25940	2	applied	\N	\N	\N	\N	80804	80804	80805
18733	25941	3	applied	\N	\N	\N	\N	80806	80806	80807
18738	25949	0	applied	\N	\N	\N	\N	80830	80830	80831
18738	25950	1	applied	\N	\N	\N	\N	80832	80832	80833
18738	25951	2	applied	\N	\N	\N	\N	80834	80834	80835
18738	25952	3	applied	\N	\N	\N	\N	80836	80836	80837
18743	25958	0	applied	\N	\N	\N	\N	80854	80854	80855
18743	25959	1	applied	\N	\N	\N	\N	80856	80856	80857
18743	25960	2	applied	\N	\N	\N	\N	80858	80858	80859
18743	25961	3	applied	\N	\N	\N	\N	80860	80860	80861
18745	25965	0	applied	\N	\N	\N	\N	80873	80873	80874
18745	25966	1	applied	\N	\N	\N	\N	80875	80875	80876
18751	25981	0	applied	\N	\N	\N	\N	80917	80917	80918
18751	25982	1	applied	\N	\N	\N	\N	80919	80919	80920
18758	25991	0	applied	\N	\N	\N	\N	80943	80943	80944
18758	25992	1	applied	\N	\N	\N	\N	80945	80945	80946
18763	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18763	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18763	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18767	25999	0	applied	\N	\N	\N	\N	80972	80972	80972
18767	26000	1	applied	\N	\N	\N	\N	80973	80973	80974
18767	26001	2	applied	\N	\N	\N	\N	80975	80975	80976
18771	26002	0	applied	\N	\N	\N	\N	80980	80980	80981
18771	26003	1	applied	\N	\N	\N	\N	80982	80982	80983
18784	26024	0	applied	\N	\N	\N	\N	81047	81047	81048
18784	26025	1	applied	\N	\N	\N	\N	81049	81049	81050
18784	26026	2	applied	\N	\N	\N	\N	81051	81051	81052
18786	26027	0	applied	\N	\N	\N	\N	81056	81056	81057
18786	26028	1	applied	\N	\N	\N	\N	81058	81058	81059
18786	26029	2	applied	\N	\N	\N	\N	81060	81060	81061
18786	26030	3	applied	\N	\N	\N	\N	81062	81062	81063
18786	26031	4	applied	\N	\N	\N	\N	81064	81064	81065
18791	26039	0	applied	\N	\N	\N	\N	81090	81090	81091
18791	26040	1	applied	\N	\N	\N	\N	81092	81092	81093
18799	26058	0	applied	\N	\N	\N	\N	81137	81137	81138
18799	26059	1	applied	\N	\N	\N	\N	81139	81139	81140
18799	26060	2	applied	\N	\N	\N	\N	81141	81141	81142
18802	26065	0	applied	\N	\N	\N	\N	81159	81159	81160
18802	26066	1	applied	\N	\N	\N	\N	81161	81161	81162
18802	26067	2	applied	\N	\N	\N	\N	81163	81163	81164
18802	26068	3	applied	\N	\N	\N	\N	81165	81165	81166
18802	26069	4	applied	\N	\N	\N	\N	81167	81167	81168
18804	26070	0	applied	\N	\N	\N	\N	81171	81171	81172
18804	26071	1	applied	\N	\N	\N	\N	81173	81173	81174
18809	26077	0	applied	\N	\N	\N	\N	81192	81192	81193
18809	26078	1	applied	\N	\N	\N	\N	81194	81194	81195
18811	26077	0	applied	\N	\N	\N	\N	81192	81192	81193
18811	26078	1	applied	\N	\N	\N	\N	81194	81194	81195
18814	26079	0	applied	\N	\N	\N	\N	81199	81199	81200
18814	26080	1	applied	\N	\N	\N	\N	81201	81201	81202
18814	26081	2	applied	\N	\N	\N	\N	81203	81203	81204
18814	26082	3	applied	\N	\N	\N	\N	81205	81205	81206
18814	26083	4	applied	\N	\N	\N	\N	81207	81207	81208
18816	26085	0	applied	\N	\N	\N	\N	81217	81217	81218
18823	26090	0	applied	\N	\N	\N	\N	81238	81238	81239
18823	26091	1	applied	\N	\N	\N	\N	81240	81240	81241
18835	26101	0	applied	\N	\N	\N	\N	81279	81279	81280
18838	26103	0	applied	\N	\N	\N	\N	81288	81288	81289
18838	26104	1	applied	\N	\N	\N	\N	81290	81290	81291
18838	26105	2	applied	\N	\N	\N	\N	81292	81292	81293
18840	26106	0	applied	\N	\N	\N	\N	81296	81296	81297
18663	25743	16	applied	\N	\N	\N	\N	80166	80166	80165
18663	25746	17	applied	\N	\N	\N	\N	80177	80177	80167
18663	25747	18	applied	\N	\N	\N	\N	80179	80179	80178
18663	25751	19	applied	\N	\N	\N	\N	80192	80192	80180
18663	25752	20	applied	\N	\N	\N	\N	80194	80194	80363
18663	25756	21	applied	\N	\N	\N	\N	80203	80203	80364
18663	25757	22	applied	\N	\N	\N	\N	80205	80205	80365
18663	25759	23	applied	\N	\N	\N	\N	80212	80212	80366
18663	25763	24	applied	\N	\N	\N	\N	80222	80222	80367
18663	25764	25	applied	\N	\N	\N	\N	80224	80224	80368
18663	25767	26	applied	\N	\N	\N	\N	80230	80230	80369
18663	25771	27	applied	\N	\N	\N	\N	80240	80240	80227
18663	25776	28	applied	\N	\N	\N	\N	80254	80254	80231
18663	25777	29	applied	\N	\N	\N	\N	80256	80256	80241
18663	25780	30	applied	\N	\N	\N	\N	80266	80266	80255
18663	25783	31	applied	\N	\N	\N	\N	80277	80277	80257
18663	25784	32	applied	\N	\N	\N	\N	80279	80279	80370
18663	25787	33	applied	\N	\N	\N	\N	80289	80289	80371
18663	25788	34	applied	\N	\N	\N	\N	80294	80294	80372
18663	25790	35	applied	\N	\N	\N	\N	80298	80298	80373
18663	25794	36	applied	\N	\N	\N	\N	80308	80308	80374
18663	25795	37	applied	\N	\N	\N	\N	80310	80310	80375
18663	25800	38	applied	\N	\N	\N	\N	80323	80323	80301
18663	25801	39	applied	\N	\N	\N	\N	80325	80325	80309
18663	25803	40	applied	\N	\N	\N	\N	80335	80335	80311
18663	25806	41	applied	\N	\N	\N	\N	80342	80342	80376
18663	25810	42	applied	\N	\N	\N	\N	80351	80351	80377
18670	25816	0	applied	\N	\N	\N	\N	80397	80397	80398
18670	25817	1	applied	\N	\N	1000000000	\N	80399	80399	80400
18670	25818	2	applied	\N	\N	\N	\N	80401	80401	80402
18670	25819	3	applied	\N	\N	\N	\N	80403	80403	80404
18674	25820	0	applied	\N	\N	1000000000	\N	80421	80421	80422
18674	25821	1	applied	\N	\N	\N	\N	80423	80423	80424
18674	25822	2	applied	\N	\N	\N	\N	80425	80425	80426
18680	25831	0	applied	\N	\N	\N	\N	80450	80450	80451
18680	25832	1	applied	\N	\N	\N	\N	80452	80452	80453
18680	25833	2	applied	\N	\N	\N	\N	80454	80454	80455
18680	25834	3	applied	\N	\N	\N	\N	80456	80456	80457
18680	25835	4	applied	\N	\N	\N	\N	80458	80458	80459
18680	25836	5	applied	\N	\N	\N	\N	80460	80460	80461
18680	25837	6	applied	\N	\N	\N	\N	80462	80462	80463
18680	25838	7	applied	\N	\N	\N	\N	80464	80464	80465
18680	25839	8	applied	\N	\N	\N	\N	80466	80466	80467
18680	25840	9	applied	\N	\N	\N	\N	80468	80468	80469
18680	25841	10	applied	\N	\N	\N	\N	80470	80470	80471
18685	25850	0	applied	\N	\N	\N	\N	80536	80536	80537
18685	25848	1	applied	\N	\N	\N	\N	80530	80530	80531
18685	25849	2	applied	\N	\N	\N	\N	80532	80532	80533
18692	25851	0	applied	\N	\N	\N	\N	80540	80540	80541
18692	25853	1	applied	\N	\N	\N	\N	80554	80554	80555
18692	25854	2	applied	\N	\N	\N	\N	80556	80556	80557
18692	25855	3	applied	\N	\N	\N	\N	80558	80558	80559
18692	25852	4	applied	\N	\N	\N	\N	80543	80543	80560
18692	25856	5	applied	\N	\N	\N	\N	80561	80561	80562
18692	25857	6	applied	\N	\N	\N	\N	80563	80563	80564
18696	25862	0	applied	\N	\N	\N	\N	80581	80581	80582
18696	25863	1	applied	\N	\N	\N	\N	80583	80583	80584
18696	25864	2	applied	\N	\N	\N	\N	80585	80585	80586
18709	25890	0	applied	\N	\N	\N	\N	80669	80669	80670
18720	25915	0	applied	\N	\N	\N	\N	80737	80737	80738
18720	25916	1	applied	\N	\N	\N	\N	80739	80739	80740
18722	25917	0	applied	\N	\N	\N	\N	80743	80743	80744
18722	25918	1	applied	\N	\N	\N	\N	80745	80745	80746
18722	25919	2	applied	\N	\N	\N	\N	80747	80747	80748
18725	25926	0	applied	\N	\N	\N	\N	80764	80764	80765
18725	25927	1	applied	\N	\N	\N	\N	80766	80766	80767
18725	25928	2	applied	\N	\N	\N	\N	80768	80768	80769
18727	25929	0	applied	\N	\N	\N	\N	80774	80774	80775
18727	25930	1	applied	\N	\N	\N	\N	80776	80776	80777
18732	25933	0	applied	\N	\N	\N	\N	80786	80786	80787
18732	25934	1	applied	\N	\N	\N	\N	80788	80788	80789
18732	25935	2	applied	\N	\N	\N	\N	80790	80790	80791
18732	25936	3	applied	\N	\N	\N	\N	80792	80792	80793
18732	25937	4	applied	\N	\N	\N	\N	80794	80794	80795
18737	25942	0	applied	\N	\N	\N	\N	80810	80810	80811
18737	25943	1	applied	\N	\N	\N	\N	80812	80812	80813
18737	25944	2	applied	\N	\N	\N	\N	80814	80814	80815
18737	25945	3	applied	\N	\N	\N	\N	80816	80816	80817
18737	25946	4	applied	\N	\N	\N	\N	80818	80818	80819
18737	25947	5	applied	\N	\N	\N	\N	80820	80820	80821
18737	25948	6	applied	\N	\N	\N	\N	80822	80822	80823
18742	25958	0	applied	\N	\N	\N	\N	80854	80854	80855
18742	25959	1	applied	\N	\N	\N	\N	80856	80856	80857
18742	25960	2	applied	\N	\N	\N	\N	80858	80858	80859
18742	25961	3	applied	\N	\N	\N	\N	80860	80860	80861
18748	25955	0	applied	\N	\N	\N	\N	80846	80846	80847
18748	25959	1	applied	\N	\N	\N	\N	80856	80856	80897
18748	25935	2	applied	\N	\N	\N	\N	80790	80790	80898
18750	25976	0	applied	\N	\N	\N	\N	80905	80905	80906
18750	25977	1	applied	\N	\N	\N	\N	80907	80907	80908
18750	25978	2	applied	\N	\N	\N	\N	80909	80909	80910
18750	25979	3	applied	\N	\N	\N	\N	80911	80911	80912
18750	25980	4	applied	\N	\N	\N	\N	80913	80913	80914
18753	25985	0	applied	\N	\N	1000000000	\N	80926	80926	80927
18753	25986	1	applied	\N	\N	\N	\N	80928	80928	80929
18753	25987	2	applied	\N	\N	\N	\N	80930	80930	80931
18753	25988	3	applied	\N	\N	\N	\N	80932	80932	80933
18755	25989	0	applied	\N	\N	\N	\N	80937	80937	80938
18755	25990	1	applied	\N	\N	\N	\N	80939	80939	80940
18760	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18760	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18760	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18762	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18762	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18762	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18766	25999	0	applied	\N	\N	\N	\N	80972	80972	80972
18766	26000	1	applied	\N	\N	\N	\N	80973	80973	80974
18766	26001	2	applied	\N	\N	\N	\N	80975	80975	80976
18769	26002	0	applied	\N	\N	\N	\N	80980	80980	80981
18769	26003	1	applied	\N	\N	\N	\N	80982	80982	80983
18773	26007	0	applied	\N	\N	\N	\N	80998	80998	80999
18773	26008	1	applied	\N	\N	\N	\N	81000	81000	81001
18776	26009	0	applied	\N	\N	\N	\N	81005	81005	81006
18776	26010	1	applied	\N	\N	\N	\N	81007	81007	81008
18776	26011	2	applied	\N	\N	\N	\N	81009	81009	81010
18776	26012	3	applied	\N	\N	\N	\N	81011	81011	81012
18776	26013	4	applied	\N	\N	\N	\N	81013	81013	81014
18776	26014	6	applied	\N	\N	\N	\N	81016	81016	81017
18776	26015	7	applied	\N	\N	\N	\N	81018	81018	81019
18673	25360	43	applied	\N	\N	\N	\N	79076	79076	79077
18673	25361	44	applied	\N	\N	\N	\N	79078	79078	79079
18673	25366	45	applied	\N	\N	\N	\N	79089	79089	79090
18673	25369	46	applied	\N	\N	\N	\N	79097	79097	79098
18673	25372	47	applied	\N	\N	\N	\N	79103	79103	79104
18673	25375	48	applied	\N	\N	\N	\N	79113	79113	79114
18673	25379	49	applied	\N	\N	\N	\N	79127	79127	79128
18673	25382	50	applied	\N	\N	\N	\N	79167	79167	79168
18673	25385	51	applied	\N	\N	\N	\N	79177	79177	79178
18673	25389	52	applied	\N	\N	\N	\N	79192	79192	79193
18673	25392	53	applied	\N	\N	\N	\N	79199	79199	79200
18673	25394	54	applied	\N	\N	\N	\N	79208	79208	79209
18673	25395	55	applied	\N	\N	\N	\N	79210	79210	79211
18673	25401	56	applied	\N	\N	\N	\N	79226	79226	79227
18673	25402	57	applied	\N	\N	\N	\N	79228	79228	79229
18673	25403	58	applied	\N	\N	\N	\N	79230	79230	79231
18673	25412	59	applied	\N	\N	\N	\N	79250	79250	79251
18673	25415	60	applied	\N	\N	\N	\N	79260	79260	79261
18673	25416	61	applied	\N	\N	\N	\N	79262	79262	79263
18673	25423	62	applied	\N	\N	\N	\N	79287	79287	79288
18673	25424	63	applied	\N	\N	\N	\N	79289	79289	79290
18673	25425	64	applied	\N	\N	\N	\N	79291	79291	79292
18673	25426	65	applied	\N	\N	\N	\N	79293	79293	79294
18673	25433	66	applied	\N	\N	\N	\N	79309	79309	79310
18673	25441	68	applied	\N	\N	\N	\N	79328	79328	79329
18673	25445	69	applied	\N	\N	\N	\N	79338	79338	79339
18673	25447	70	applied	\N	\N	\N	\N	79344	79344	79345
18673	25450	71	applied	\N	\N	\N	\N	79353	79353	79354
18673	25454	72	applied	\N	\N	\N	\N	79364	79364	79365
18673	25458	73	applied	\N	\N	\N	\N	79376	79376	79377
18673	25462	74	applied	\N	\N	\N	\N	79386	79386	79387
18673	25466	75	applied	\N	\N	\N	\N	79396	79396	79397
18673	25467	76	applied	\N	\N	\N	\N	79398	79398	79399
18673	25473	77	applied	\N	\N	\N	\N	79416	79416	79417
18673	25476	78	applied	\N	\N	\N	\N	79424	79424	79425
18673	25480	79	applied	\N	\N	\N	\N	79434	79434	79435
18673	25483	80	applied	\N	\N	\N	\N	79444	79444	79445
18673	25484	81	applied	\N	\N	\N	\N	79446	79446	79447
18673	25490	82	applied	\N	\N	\N	\N	79460	79460	79461
18673	25494	83	applied	\N	\N	\N	\N	79472	79472	79473
18673	25498	84	applied	\N	\N	\N	\N	79493	79493	79494
18673	25501	85	applied	\N	\N	\N	\N	79502	79502	79503
18673	25502	86	applied	\N	\N	\N	\N	79504	79504	79505
18673	25509	87	applied	\N	\N	\N	\N	79520	79520	79521
18673	25511	88	applied	\N	\N	\N	\N	79528	79528	79529
18673	25512	89	applied	\N	\N	\N	\N	79530	79530	79531
18673	25519	90	applied	\N	\N	\N	\N	79545	79545	79546
18673	25522	91	applied	\N	\N	\N	\N	79552	79552	79553
18673	25526	92	applied	\N	\N	\N	\N	79566	79566	79567
18673	25529	93	applied	\N	\N	\N	\N	79574	79574	79575
18673	25532	94	applied	\N	\N	\N	\N	79582	79582	79583
18673	25535	95	applied	\N	\N	\N	\N	79590	79590	79591
18673	25539	96	applied	\N	\N	\N	\N	79599	79599	79600
18673	25540	97	applied	\N	\N	\N	\N	79601	79601	79602
18673	25545	98	applied	\N	\N	\N	\N	79613	79613	79614
18673	25546	99	applied	\N	\N	\N	\N	79615	79615	79616
18673	25552	100	applied	\N	\N	\N	\N	79629	79629	79630
18673	25555	101	applied	\N	\N	\N	\N	79643	79643	79644
18673	25556	102	applied	\N	\N	\N	\N	79645	79645	79646
18673	25562	103	applied	\N	\N	\N	\N	79658	79658	79659
18673	25565	104	applied	\N	\N	\N	\N	79666	79666	79667
18673	25568	105	applied	\N	\N	\N	\N	79678	79678	79679
18673	25572	106	applied	\N	\N	\N	\N	79688	79688	79689
18673	25575	107	applied	\N	\N	\N	\N	79696	79696	79697
18673	25579	108	applied	\N	\N	\N	\N	79710	79710	79711
18673	25582	109	applied	\N	\N	\N	\N	79719	79719	79720
18673	25584	110	applied	\N	\N	\N	\N	79724	79724	79725
18673	25585	111	applied	\N	\N	\N	\N	79726	79726	79727
18673	25586	112	applied	\N	\N	\N	\N	79728	79728	79729
18673	25595	113	applied	\N	\N	\N	\N	79748	79748	79749
18675	25820	0	applied	\N	\N	1000000000	\N	80421	80421	80422
18675	25821	1	applied	\N	\N	\N	\N	80423	80423	80424
18675	25822	2	applied	\N	\N	\N	\N	80425	80425	80426
18677	25820	0	applied	\N	\N	1000000000	\N	80421	80421	80422
18677	25822	1	applied	\N	\N	\N	\N	80425	80425	80426
18681	25768	0	applied	\N	\N	\N	\N	80234	80234	80235
18681	25769	1	applied	\N	\N	\N	\N	80236	80236	80237
18681	25772	2	applied	\N	\N	\N	\N	80246	80246	80247
18681	25773	3	applied	\N	\N	\N	\N	80248	80248	80249
18681	25817	4	applied	\N	\N	1000000000	\N	80399	80399	80400
18681	25702	5	applied	\N	\N	1000000000	\N	80062	80062	80063
18681	25820	6	applied	\N	\N	1000000000	\N	80421	80421	80422
18681	25824	7	applied	\N	\N	1000000000	\N	80433	80433	80434
18681	25825	8	applied	\N	\N	1000000000	\N	80435	80435	80436
18681	25826	9	applied	\N	\N	1000000000	\N	80437	80437	80438
18681	25807	10	applied	\N	\N	\N	\N	80344	80344	80345
18681	25690	11	applied	\N	\N	\N	\N	80019	80019	80020
18681	25693	12	applied	\N	\N	\N	\N	80029	80029	80030
18681	25766	13	applied	\N	\N	1000000000	\N	80228	80228	80229
18681	25734	14	applied	\N	\N	\N	\N	80145	80145	80146
18681	25694	15	applied	\N	\N	\N	\N	80031	80031	80032
18681	25701	16	applied	\N	\N	\N	\N	80058	80058	80474
18681	25710	17	applied	\N	\N	\N	\N	80078	80078	80475
18681	25813	18	applied	\N	\N	\N	\N	80476	80476	80477
18681	25713	19	applied	\N	\N	\N	\N	80084	80084	80038
18681	25696	20	applied	\N	\N	\N	\N	80037	80037	80046
18681	25698	21	applied	\N	\N	\N	\N	80045	80045	80057
18681	25700	22	applied	\N	\N	\N	\N	80056	80056	80478
18681	25711	23	applied	\N	\N	\N	\N	80080	80080	80479
18681	25712	24	applied	\N	\N	\N	\N	80082	80082	80085
18681	25723	25	applied	\N	\N	\N	\N	80114	80114	80480
18681	25731	26	applied	\N	\N	\N	\N	80138	80138	80481
18681	25799	27	applied	\N	\N	\N	\N	80322	80322	80145
18681	25742	28	applied	\N	\N	\N	\N	80164	80164	80087
18681	25748	29	applied	\N	\N	\N	\N	80181	80181	80482
18681	25755	30	applied	\N	\N	\N	\N	80201	80201	80483
18681	25765	31	applied	\N	\N	\N	\N	80226	80226	80089
18681	25778	32	applied	\N	\N	\N	\N	80258	80258	80484
18681	25714	33	applied	\N	\N	\N	\N	80086	80086	80485
18681	25715	34	applied	\N	\N	\N	\N	80088	80088	80486
18681	25716	35	applied	\N	\N	\N	\N	80090	80090	80487
18681	25717	36	applied	\N	\N	\N	\N	80092	80092	80115
18681	25718	37	applied	\N	\N	\N	\N	80094	80094	80123
18681	25720	38	applied	\N	\N	\N	\N	80102	80102	80125
18681	25725	39	applied	\N	\N	\N	\N	80122	80122	80133
18681	25726	40	applied	\N	\N	\N	\N	80124	80124	80137
18681	25728	41	applied	\N	\N	\N	\N	80132	80132	80488
18681	25730	42	applied	\N	\N	\N	\N	80136	80136	80489
18681	25735	43	applied	\N	\N	\N	\N	80147	80147	80490
18681	25736	44	applied	\N	\N	\N	\N	80149	80149	80491
18681	25738	45	applied	\N	\N	\N	\N	80154	80154	80492
18681	25741	46	applied	\N	\N	\N	\N	80162	80162	80493
18681	25785	47	applied	\N	\N	\N	\N	80281	80281	80494
18681	25791	48	applied	\N	\N	\N	\N	80300	80300	80178
18681	25798	49	applied	\N	\N	\N	\N	80320	80320	80495
18681	25809	50	applied	\N	\N	\N	\N	80349	80349	80496
18681	25819	51	applied	\N	\N	\N	\N	80403	80403	80180
18681	25829	52	applied	\N	\N	\N	\N	80444	80444	80182
18681	25837	53	applied	\N	\N	\N	\N	80462	80462	80497
18681	25743	54	applied	\N	\N	\N	\N	80166	80166	80498
18681	25746	55	applied	\N	\N	\N	\N	80177	80177	80202
18681	25747	56	applied	\N	\N	\N	\N	80179	80179	80204
18681	25751	57	applied	\N	\N	\N	\N	80192	80192	80206
18681	25752	58	applied	\N	\N	\N	\N	80194	80194	80213
18681	25756	59	applied	\N	\N	\N	\N	80203	80203	80223
18681	25757	60	applied	\N	\N	\N	\N	80205	80205	80225
18681	25759	61	applied	\N	\N	\N	\N	80212	80212	80499
18681	25763	62	applied	\N	\N	\N	\N	80222	80222	80500
18681	25764	63	applied	\N	\N	\N	\N	80224	80224	80501
18681	25767	64	applied	\N	\N	\N	\N	80230	80230	80502
18681	25771	65	applied	\N	\N	\N	\N	80240	80240	80503
18681	25776	66	applied	\N	\N	\N	\N	80254	80254	80504
18681	25777	67	applied	\N	\N	\N	\N	80256	80256	80505
18681	25780	68	applied	\N	\N	\N	\N	80266	80266	80282
18681	25783	69	applied	\N	\N	\N	\N	80277	80277	80290
18681	25784	70	applied	\N	\N	\N	\N	80279	80279	80295
18681	25787	71	applied	\N	\N	\N	\N	80289	80289	80299
18681	25788	72	applied	\N	\N	\N	\N	80294	80294	80506
18681	25790	73	applied	\N	\N	\N	\N	80298	80298	80507
18681	25794	74	applied	\N	\N	\N	\N	80308	80308	80508
18681	25795	75	applied	\N	\N	\N	\N	80310	80310	80509
18681	25800	76	applied	\N	\N	\N	\N	80323	80323	80510
18681	25801	77	applied	\N	\N	\N	\N	80325	80325	80511
18681	25803	78	applied	\N	\N	\N	\N	80335	80335	80350
18681	25806	79	applied	\N	\N	\N	\N	80342	80342	80352
18681	25810	80	applied	\N	\N	\N	\N	80351	80351	80382
18681	25812	81	applied	\N	\N	\N	\N	80381	80381	80390
18681	25815	82	applied	\N	\N	\N	\N	80389	80389	80402
18681	25818	83	applied	\N	\N	\N	\N	80401	80401	80512
18681	25822	84	applied	\N	\N	\N	\N	80425	80425	80513
18681	25827	85	applied	\N	\N	\N	\N	80439	80439	80514
18681	25830	86	applied	\N	\N	\N	\N	80446	80446	80515
18681	25836	87	applied	\N	\N	\N	\N	80460	80460	80463
18681	25838	88	applied	\N	\N	\N	\N	80464	80464	80465
18681	25839	89	applied	\N	\N	\N	\N	80466	80466	80467
18681	25840	90	applied	\N	\N	\N	\N	80468	80468	80469
18681	25841	91	applied	\N	\N	\N	\N	80470	80470	80471
18684	25850	0	applied	\N	\N	\N	\N	80536	80536	80537
18684	25848	1	applied	\N	\N	\N	\N	80530	80530	80531
18684	25849	2	applied	\N	\N	\N	\N	80532	80532	80533
18686	25851	0	applied	\N	\N	\N	\N	80540	80540	80541
18686	25852	2	applied	\N	\N	\N	\N	80543	80543	80544
18693	25858	0	applied	\N	\N	\N	\N	80571	80571	80572
18693	25859	1	applied	\N	\N	\N	\N	80573	80573	80574
18693	25860	2	applied	\N	\N	\N	\N	80575	80575	80576
18693	25861	3	applied	\N	\N	\N	\N	80577	80577	80578
18695	25862	0	applied	\N	\N	\N	\N	80581	80581	80582
18695	25863	1	applied	\N	\N	\N	\N	80583	80583	80584
18695	25864	2	applied	\N	\N	\N	\N	80585	80585	80586
18697	25862	0	applied	\N	\N	\N	\N	80581	80581	80582
18697	25863	1	applied	\N	\N	\N	\N	80583	80583	80584
18697	25864	2	applied	\N	\N	\N	\N	80585	80585	80586
18699	25843	0	applied	\N	\N	1000000000	\N	80519	80519	80520
18699	25828	1	applied	\N	\N	\N	\N	80442	80442	80443
18699	25831	2	applied	\N	\N	\N	\N	80450	80450	80451
18699	25832	3	applied	\N	\N	\N	\N	80452	80452	80453
18699	25833	4	applied	\N	\N	\N	\N	80454	80454	80455
18699	25834	5	applied	\N	\N	\N	\N	80456	80456	80457
18699	25835	6	applied	\N	\N	\N	\N	80458	80458	80459
18699	25842	7	applied	\N	\N	\N	\N	80517	80517	80518
18699	25844	8	applied	\N	\N	\N	\N	80521	80521	80522
18699	25850	9	applied	\N	\N	\N	\N	80536	80536	80537
18699	25851	10	applied	\N	\N	\N	\N	80540	80540	80541
18699	25853	11	applied	\N	\N	\N	\N	80554	80554	80555
18699	25854	12	applied	\N	\N	\N	\N	80556	80556	80557
18699	25858	13	applied	\N	\N	\N	\N	80571	80571	80572
18699	25859	14	applied	\N	\N	\N	\N	80573	80573	80574
18699	25862	15	applied	\N	\N	\N	\N	80581	80581	80582
18699	25848	16	applied	\N	\N	\N	\N	80530	80530	80531
18699	25829	17	applied	\N	\N	\N	\N	80444	80444	80445
18699	25837	18	applied	\N	\N	\N	\N	80462	80462	80514
18699	25847	19	applied	\N	\N	\N	\N	80527	80527	80592
18699	25855	20	applied	\N	\N	\N	\N	80558	80558	80447
18699	25864	21	applied	\N	\N	\N	\N	80585	80585	80515
18699	25830	22	applied	\N	\N	\N	\N	80446	80446	80463
18699	25836	23	applied	\N	\N	\N	\N	80460	80460	80465
18699	25838	24	applied	\N	\N	\N	\N	80464	80464	80467
18699	25839	25	applied	\N	\N	\N	\N	80466	80466	80469
18699	25840	26	applied	\N	\N	\N	\N	80468	80468	80471
18699	25841	27	applied	\N	\N	\N	\N	80470	80470	80524
18699	25845	28	applied	\N	\N	\N	\N	80523	80523	80526
18699	25846	29	applied	\N	\N	\N	\N	80525	80525	80593
18699	25849	30	applied	\N	\N	\N	\N	80532	80532	80594
18699	25852	31	applied	\N	\N	\N	\N	80543	80543	80595
18699	25856	33	applied	\N	\N	\N	\N	80561	80561	80597
18699	25857	34	applied	\N	\N	\N	\N	80563	80563	80598
18699	25860	35	applied	\N	\N	\N	\N	80575	80575	80599
18699	25861	36	applied	\N	\N	\N	\N	80577	80577	80600
18699	25863	37	applied	\N	\N	\N	\N	80583	80583	80586
18702	25869	0	applied	\N	\N	\N	\N	80615	80615	80616
18702	25870	1	applied	\N	\N	\N	\N	80617	80617	80618
18702	25871	2	applied	\N	\N	\N	\N	80619	80619	80620
18702	25872	3	applied	\N	\N	\N	\N	80621	80621	80622
18702	25873	4	applied	\N	\N	\N	\N	80623	80623	80624
18708	25885	0	applied	\N	\N	\N	\N	80657	80657	80658
18708	25886	1	applied	\N	\N	\N	\N	80659	80659	80660
18708	25887	2	applied	\N	\N	\N	\N	80661	80661	80662
18708	25888	3	applied	\N	\N	\N	\N	80663	80663	80664
18708	25889	4	applied	\N	\N	\N	\N	80665	80665	80666
18711	25578	0	applied	\N	\N	\N	\N	80411	80411	79709
18711	25594	1	applied	\N	\N	\N	\N	80412	80412	79747
18711	25615	2	applied	\N	\N	\N	\N	80413	80413	79797
18711	25622	3	applied	\N	\N	\N	\N	80414	80414	79817
18711	25634	4	applied	\N	\N	\N	\N	80415	80415	79845
18711	25640	5	applied	\N	\N	\N	\N	80416	80416	79866
18711	25643	6	applied	\N	\N	\N	\N	80417	80417	79874
18711	25768	7	applied	\N	\N	\N	\N	80234	80234	80235
18711	25769	8	applied	\N	\N	\N	\N	80236	80236	80237
18711	25772	9	applied	\N	\N	\N	\N	80246	80246	80247
18711	25773	10	applied	\N	\N	\N	\N	80248	80248	80249
18711	25843	11	applied	\N	\N	1000000000	\N	80519	80519	80520
18711	25657	12	applied	\N	\N	1000000000	\N	79911	79911	79912
18711	25817	13	applied	\N	\N	1000000000	\N	80399	80399	80400
18711	25674	14	applied	\N	\N	1000000000	\N	79957	79957	79958
18711	25702	15	applied	\N	\N	1000000000	\N	80062	80062	80063
18711	25820	16	applied	\N	\N	1000000000	\N	80421	80421	80422
18711	25824	17	applied	\N	\N	1000000000	\N	80433	80433	80434
18711	25825	18	applied	\N	\N	1000000000	\N	80435	80435	80436
18711	25826	19	applied	\N	\N	1000000000	\N	80437	80437	80438
18711	25848	20	applied	\N	\N	\N	\N	80530	80530	80531
18711	25807	21	applied	\N	\N	\N	\N	80344	80344	80345
18711	25766	22	applied	\N	\N	1000000000	\N	80228	80228	80229
18711	25734	23	applied	\N	\N	\N	\N	80145	80145	80146
18711	25813	24	applied	\N	\N	\N	\N	80476	80476	80477
18711	25799	25	applied	\N	\N	\N	\N	80322	80322	80145
18711	25660	26	applied	\N	\N	\N	\N	79917	79917	79918
18716	25906	0	applied	\N	\N	\N	\N	80711	80711	80712
18716	25907	1	applied	\N	\N	\N	\N	80713	80713	80714
18718	25908	0	applied	\N	\N	\N	\N	80719	80719	80720
18718	25909	1	applied	\N	\N	\N	\N	80721	80721	80722
18718	25910	2	applied	\N	\N	\N	\N	80723	80723	80724
18721	25917	0	applied	\N	\N	\N	\N	80743	80743	80744
18721	25918	1	applied	\N	\N	\N	\N	80745	80745	80746
18721	25919	2	applied	\N	\N	\N	\N	80747	80747	80748
18724	25926	0	applied	\N	\N	\N	\N	80764	80764	80765
18724	25927	1	applied	\N	\N	\N	\N	80766	80766	80767
18724	25928	2	applied	\N	\N	\N	\N	80768	80768	80769
18726	25926	0	applied	\N	\N	\N	\N	80764	80764	80765
18726	25927	1	applied	\N	\N	\N	\N	80766	80766	80767
18726	25928	2	applied	\N	\N	\N	\N	80768	80768	80769
18731	25933	0	applied	\N	\N	\N	\N	80786	80786	80787
18731	25934	1	applied	\N	\N	\N	\N	80788	80788	80789
18731	25935	2	applied	\N	\N	\N	\N	80790	80790	80791
18731	25936	3	applied	\N	\N	\N	\N	80792	80792	80793
18731	25937	4	applied	\N	\N	\N	\N	80794	80794	80795
18734	25942	0	applied	\N	\N	\N	\N	80810	80810	80811
18734	25943	1	applied	\N	\N	\N	\N	80812	80812	80813
18734	25944	2	applied	\N	\N	\N	\N	80814	80814	80815
18734	25945	3	applied	\N	\N	\N	\N	80816	80816	80817
18734	25946	4	applied	\N	\N	\N	\N	80818	80818	80819
18734	25947	5	applied	\N	\N	\N	\N	80820	80820	80821
18734	25948	6	applied	\N	\N	\N	\N	80822	80822	80823
18736	25942	0	applied	\N	\N	\N	\N	80810	80810	80811
18736	25943	1	applied	\N	\N	\N	\N	80812	80812	80813
18736	25944	2	applied	\N	\N	\N	\N	80814	80814	80815
18736	25945	3	applied	\N	\N	\N	\N	80816	80816	80817
18736	25946	4	applied	\N	\N	\N	\N	80818	80818	80819
18736	25947	5	applied	\N	\N	\N	\N	80820	80820	80821
18736	25948	6	applied	\N	\N	\N	\N	80822	80822	80823
18739	25949	0	applied	\N	\N	\N	\N	80830	80830	80831
18739	25950	1	applied	\N	\N	\N	\N	80832	80832	80833
18739	25951	2	applied	\N	\N	\N	\N	80834	80834	80835
18739	25952	3	applied	\N	\N	\N	\N	80836	80836	80837
18741	25953	0	applied	\N	\N	\N	\N	80842	80842	80843
18741	25954	1	applied	\N	\N	\N	\N	80844	80844	80845
18741	25955	2	applied	\N	\N	\N	\N	80846	80846	80847
18741	25956	3	applied	\N	\N	\N	\N	80848	80848	80849
18741	25957	4	applied	\N	\N	\N	\N	80850	80850	80851
18746	25967	0	applied	\N	\N	\N	\N	80879	80879	80880
18746	25968	1	applied	\N	\N	\N	\N	80881	80881	80882
18754	25985	0	applied	\N	\N	1000000000	\N	80926	80926	80927
18754	25986	1	applied	\N	\N	\N	\N	80928	80928	80929
18754	25987	2	applied	\N	\N	\N	\N	80930	80930	80931
18754	25988	3	applied	\N	\N	\N	\N	80932	80932	80933
18756	25989	0	applied	\N	\N	\N	\N	80937	80937	80938
18756	25990	1	applied	\N	\N	\N	\N	80939	80939	80940
18761	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18761	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18761	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18764	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18764	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18764	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18765	25996	0	applied	\N	\N	\N	\N	80956	80956	80957
18765	25997	1	applied	\N	\N	\N	\N	80958	80958	80959
18765	25998	2	applied	\N	\N	\N	\N	80960	80960	80961
18774	26007	0	applied	\N	\N	\N	\N	80998	80998	80999
18774	26008	1	applied	\N	\N	\N	\N	81000	81000	81001
18777	26019	0	applied	\N	\N	\N	\N	81028	81028	81029
18777	26020	1	applied	\N	\N	\N	\N	81030	81030	81031
18777	26021	2	applied	\N	\N	\N	\N	81032	81032	81033
18789	26034	0	applied	\N	\N	\N	\N	81075	81075	81076
18789	26035	1	applied	\N	\N	\N	\N	81077	81077	81078
18789	26036	2	applied	\N	\N	\N	\N	81079	81079	81080
18789	26037	3	applied	\N	\N	\N	\N	81081	81081	81082
18789	26038	4	applied	\N	\N	\N	\N	81083	81083	81084
18794	26041	0	applied	\N	\N	\N	\N	81097	81097	81098
18794	26042	1	applied	\N	\N	\N	\N	81099	81099	81100
18794	26043	2	applied	\N	\N	\N	\N	81101	81101	81102
18794	26044	3	applied	\N	\N	\N	\N	81103	81103	81104
18794	26045	4	applied	\N	\N	\N	\N	81105	81105	81106
18794	26046	5	applied	\N	\N	\N	\N	81107	81107	81108
18795	26047	0	applied	\N	\N	\N	\N	81113	81113	81114
18795	26048	1	applied	\N	\N	\N	\N	81115	81115	81116
18795	26049	2	applied	\N	\N	\N	\N	81117	81117	81118
18795	26050	3	applied	\N	\N	\N	\N	81119	81119	81120
18795	26051	4	applied	\N	\N	\N	\N	81121	81121	81122
18795	26052	5	applied	\N	\N	\N	\N	81123	81123	81124
18795	26053	6	applied	\N	\N	\N	\N	81125	81125	81126
18795	26054	7	applied	\N	\N	\N	\N	81127	81127	81128
18795	26055	8	applied	\N	\N	\N	\N	81129	81129	81130
18795	26056	9	applied	\N	\N	\N	\N	81131	81131	81132
18795	26057	10	applied	\N	\N	\N	\N	81133	81133	81134
18805	26072	0	applied	\N	\N	\N	\N	81177	81177	81178
18805	26073	1	applied	\N	\N	\N	\N	81179	81179	81180
18807	26074	0	applied	\N	\N	\N	\N	81182	81182	81183
18807	26075	1	applied	\N	\N	\N	\N	81184	81184	81185
18807	26076	2	applied	\N	\N	\N	\N	81186	81186	81187
18812	26079	0	applied	\N	\N	\N	\N	81199	81199	81200
18812	26080	1	applied	\N	\N	\N	\N	81201	81201	81202
18812	26081	2	applied	\N	\N	\N	\N	81203	81203	81204
18812	26082	3	applied	\N	\N	\N	\N	81205	81205	81206
18812	26083	4	applied	\N	\N	\N	\N	81207	81207	81208
18821	26088	0	applied	\N	\N	\N	\N	81229	81229	81230
18826	26092	0	applied	\N	\N	\N	\N	81246	81246	81247
18828	26093	0	applied	\N	\N	\N	\N	81249	81249	81250
18833	26098	0	applied	\N	\N	\N	\N	81270	81270	81271
18836	26102	0	applied	\N	\N	\N	\N	81282	81282	81283
18749	25975	1	applied	\N	\N	\N	\N	80902	80902	80903
18752	25983	0	applied	\N	\N	\N	\N	80922	80922	80923
18752	25984	1	applied	\N	\N	\N	\N	80924	80924	80925
18757	25991	0	applied	\N	\N	\N	\N	80943	80943	80944
18757	25992	1	applied	\N	\N	\N	\N	80945	80945	80946
18759	25993	0	applied	\N	\N	\N	\N	80950	80950	80951
18759	25994	1	applied	\N	\N	\N	\N	80952	80952	80953
18759	25995	2	applied	\N	\N	\N	\N	80954	80954	80955
18768	26002	0	applied	\N	\N	\N	\N	80980	80980	80981
18768	26003	1	applied	\N	\N	\N	\N	80982	80982	80983
18770	26002	0	applied	\N	\N	\N	\N	80980	80980	80981
18770	26003	1	applied	\N	\N	\N	\N	80982	80982	80983
18772	26004	0	applied	\N	\N	\N	\N	80990	80990	80991
18772	26005	1	applied	\N	\N	\N	\N	80992	80992	80993
18772	26006	2	applied	\N	\N	\N	\N	80994	80994	80995
18775	26007	0	applied	\N	\N	\N	\N	80998	80998	80999
18775	26008	1	applied	\N	\N	\N	\N	81000	81000	81001
18778	26019	0	applied	\N	\N	\N	\N	81028	81028	81029
18778	26020	1	applied	\N	\N	\N	\N	81030	81030	81031
18778	26021	2	applied	\N	\N	\N	\N	81032	81032	81033
18780	26022	0	applied	\N	\N	\N	\N	81039	81039	81040
18780	26023	1	applied	\N	\N	\N	\N	81041	81041	81042
18782	26022	0	applied	\N	\N	\N	\N	81039	81039	81040
18782	26023	1	applied	\N	\N	\N	\N	81041	81041	81042
18785	26027	0	applied	\N	\N	\N	\N	81056	81056	81057
18785	26028	1	applied	\N	\N	\N	\N	81058	81058	81059
18785	26029	2	applied	\N	\N	\N	\N	81060	81060	81061
18785	26030	3	applied	\N	\N	\N	\N	81062	81062	81063
18785	26031	4	applied	\N	\N	\N	\N	81064	81064	81065
18787	26032	0	applied	\N	\N	\N	\N	81069	81069	81070
18787	26033	1	applied	\N	\N	\N	\N	81071	81071	81072
18792	26039	0	applied	\N	\N	\N	\N	81090	81090	81091
18792	26040	1	applied	\N	\N	\N	\N	81092	81092	81093
18796	26058	0	applied	\N	\N	\N	\N	81137	81137	81138
18796	26059	1	applied	\N	\N	\N	\N	81139	81139	81140
18796	26060	2	applied	\N	\N	\N	\N	81141	81141	81142
18798	26058	0	applied	\N	\N	\N	\N	81137	81137	81138
18798	26059	1	applied	\N	\N	\N	\N	81139	81139	81140
18798	26060	2	applied	\N	\N	\N	\N	81141	81141	81142
18800	26061	0	applied	\N	\N	\N	\N	81148	81148	81149
18800	26062	1	applied	\N	\N	\N	\N	81150	81150	81151
18803	26065	0	applied	\N	\N	\N	\N	81159	81159	81160
18803	26066	1	applied	\N	\N	\N	\N	81161	81161	81162
18803	26067	2	applied	\N	\N	\N	\N	81163	81163	81164
18803	26068	3	applied	\N	\N	\N	\N	81165	81165	81166
18803	26069	4	applied	\N	\N	\N	\N	81167	81167	81168
18808	26074	0	applied	\N	\N	\N	\N	81182	81182	81183
18808	26075	1	applied	\N	\N	\N	\N	81184	81184	81185
18808	26076	2	applied	\N	\N	\N	\N	81186	81186	81187
18810	26077	0	applied	\N	\N	\N	\N	81192	81192	81193
18810	26078	1	applied	\N	\N	\N	\N	81194	81194	81195
18813	26079	0	applied	\N	\N	\N	\N	81199	81199	81200
18813	26080	1	applied	\N	\N	\N	\N	81201	81201	81202
18813	26081	2	applied	\N	\N	\N	\N	81203	81203	81204
18813	26082	3	applied	\N	\N	\N	\N	81205	81205	81206
18813	26083	4	applied	\N	\N	\N	\N	81207	81207	81208
18815	26084	0	applied	\N	\N	\N	\N	81213	81213	81214
18817	26085	0	applied	\N	\N	\N	\N	81217	81217	81218
18822	26089	0	applied	\N	\N	\N	\N	81235	81235	81236
18824	26090	0	applied	\N	\N	\N	\N	81238	81238	81239
18824	26091	1	applied	\N	\N	\N	\N	81240	81240	81241
18829	26093	0	applied	\N	\N	\N	\N	81249	81249	81250
18831	26094	0	applied	\N	\N	\N	\N	81258	81258	81259
18831	26095	1	applied	\N	\N	\N	\N	81260	81260	81261
18831	26096	2	applied	\N	\N	\N	\N	81262	81262	81263
18834	26099	0	applied	\N	\N	\N	\N	81273	81273	81274
18834	26100	1	applied	\N	\N	\N	\N	81275	81275	81276
18839	26106	0	applied	\N	\N	\N	\N	81296	81296	81297
18842	26109	0	applied	\N	\N	\N	\N	81308	81308	81309
18842	26110	1	applied	\N	\N	\N	\N	81310	81310	81311
18845	26115	0	applied	\N	\N	\N	\N	81324	81324	81325
18845	26116	1	applied	\N	\N	\N	\N	81326	81326	81327
18845	26117	2	applied	\N	\N	\N	\N	81328	81328	81329
18850	26122	0	applied	\N	\N	\N	\N	81347	81347	81348
18853	26122	0	applied	\N	\N	\N	\N	81347	81347	81348
18857	26127	0	applied	\N	\N	\N	\N	81370	81370	81371
18860	26129	0	applied	\N	\N	\N	\N	81378	81378	81379
18860	26130	1	applied	\N	\N	\N	\N	81380	81380	81381
18860	26131	2	applied	\N	\N	\N	\N	81382	81382	81383
18865	26134	0	applied	\N	\N	\N	\N	81393	81393	81394
18865	26135	1	applied	\N	\N	\N	\N	81395	81395	81396
18875	26144	0	applied	\N	\N	\N	\N	81429	81429	81430
18877	26144	0	applied	\N	\N	\N	\N	81429	81429	81430
18882	26152	0	applied	\N	\N	\N	\N	81465	81465	81466
18890	26161	0	applied	\N	\N	\N	\N	81494	81494	81495
18890	26162	1	applied	\N	\N	\N	\N	81496	81496	81497
18893	26163	0	applied	\N	\N	\N	\N	81502	81502	81503
18893	26164	1	applied	\N	\N	\N	\N	81504	81504	81505
18899	26167	0	applied	\N	\N	\N	\N	81520	81520	81521
18899	26168	1	applied	\N	\N	\N	\N	81522	81522	81523
18902	25518	0	applied	\N	\N	\N	\N	79639	79639	79639
18902	25538	1	applied	\N	\N	1000000000	\N	79640	79640	79598
18902	25578	2	applied	\N	\N	\N	\N	80411	80411	79709
18902	25594	3	applied	\N	\N	\N	\N	80412	80412	79747
18902	25615	4	applied	\N	\N	\N	\N	80413	80413	79797
18902	25622	5	applied	\N	\N	\N	\N	80414	80414	79817
18904	26169	0	applied	\N	\N	\N	\N	81528	81528	81529
18904	26170	1	applied	\N	\N	\N	\N	81533	81533	81534
18904	26171	2	applied	\N	\N	\N	\N	81535	81535	81536
18904	26172	3	applied	\N	\N	\N	\N	81537	81537	81538
18906	26173	0	applied	\N	\N	\N	\N	81539	81539	81540
18907	26174	0	applied	\N	\N	\N	\N	81544	81544	81545
18907	26175	1	applied	\N	\N	\N	\N	81546	81546	81547
18907	26176	2	applied	\N	\N	\N	\N	81548	81548	81549
18907	26177	3	applied	\N	\N	\N	\N	81550	81550	81551
18907	26178	4	applied	\N	\N	\N	\N	81552	81552	81553
18912	26182	0	applied	\N	\N	\N	\N	81565	81565	81566
18912	26183	1	applied	\N	\N	\N	\N	81567	81567	81568
18922	26191	0	applied	\N	\N	\N	\N	81596	81596	81597
18924	26192	0	applied	\N	\N	\N	\N	81602	81602	81603
18927	26195	0	applied	\N	\N	\N	\N	81612	81612	81613
18931	26197	0	applied	\N	\N	\N	\N	81622	81622	81623
18931	26198	1	applied	\N	\N	\N	\N	81624	81624	81625
18933	26197	0	applied	\N	\N	\N	\N	81622	81622	81623
18933	26198	1	applied	\N	\N	\N	\N	81624	81624	81625
18938	26202	0	applied	\N	\N	\N	\N	81642	81642	81643
18938	26203	1	applied	\N	\N	\N	\N	81644	81644	81645
18940	26204	0	applied	\N	\N	\N	\N	81648	81648	81649
18941	26205	0	applied	\N	\N	\N	\N	81651	81651	81652
18941	26206	1	applied	\N	\N	\N	\N	81653	81653	81654
18776	26016	8	applied	\N	\N	\N	\N	81020	81020	81021
18776	26017	9	applied	\N	\N	\N	\N	81022	81022	81023
18776	26018	10	applied	\N	\N	\N	\N	81024	81024	81025
18779	26019	0	applied	\N	\N	\N	\N	81028	81028	81029
18779	26020	1	applied	\N	\N	\N	\N	81030	81030	81031
18779	26021	2	applied	\N	\N	\N	\N	81032	81032	81033
18781	26022	0	applied	\N	\N	\N	\N	81039	81039	81040
18781	26023	1	applied	\N	\N	\N	\N	81041	81041	81042
18783	26024	0	applied	\N	\N	\N	\N	81047	81047	81048
18783	26025	1	applied	\N	\N	\N	\N	81049	81049	81050
18783	26026	2	applied	\N	\N	\N	\N	81051	81051	81052
18788	26034	0	applied	\N	\N	\N	\N	81075	81075	81076
18788	26035	1	applied	\N	\N	\N	\N	81077	81077	81078
18788	26036	2	applied	\N	\N	\N	\N	81079	81079	81080
18788	26037	3	applied	\N	\N	\N	\N	81081	81081	81082
18788	26038	4	applied	\N	\N	\N	\N	81083	81083	81084
18790	26036	0	applied	\N	\N	\N	\N	81079	81079	81080
18790	26037	1	applied	\N	\N	\N	\N	81081	81081	81082
18790	26038	2	applied	\N	\N	\N	\N	81083	81083	81084
18793	26041	0	applied	\N	\N	\N	\N	81097	81097	81098
18793	26042	1	applied	\N	\N	\N	\N	81099	81099	81100
18793	26043	2	applied	\N	\N	\N	\N	81101	81101	81102
18793	26044	3	applied	\N	\N	\N	\N	81103	81103	81104
18793	26045	4	applied	\N	\N	\N	\N	81105	81105	81106
18793	26046	5	applied	\N	\N	\N	\N	81107	81107	81108
18797	26058	0	applied	\N	\N	\N	\N	81137	81137	81138
18797	26059	1	applied	\N	\N	\N	\N	81139	81139	81140
18797	26060	2	applied	\N	\N	\N	\N	81141	81141	81142
18801	26063	0	applied	\N	\N	\N	\N	81153	81153	81154
18801	26064	1	applied	\N	\N	\N	\N	81155	81155	81156
18806	26074	0	applied	\N	\N	\N	\N	81182	81182	81183
18806	26075	1	applied	\N	\N	\N	\N	81184	81184	81185
18806	26076	2	applied	\N	\N	\N	\N	81186	81186	81187
18818	26086	0	applied	\N	\N	\N	\N	81223	81223	81224
18818	26087	1	applied	\N	\N	\N	\N	81225	81225	81226
18820	26088	0	applied	\N	\N	\N	\N	81229	81229	81230
18825	26090	0	applied	\N	\N	\N	\N	81238	81238	81239
18825	26091	1	applied	\N	\N	\N	\N	81240	81240	81241
18827	26093	0	applied	\N	\N	\N	\N	81249	81249	81250
18830	26093	0	applied	\N	\N	\N	\N	81249	81249	81250
18832	26097	0	applied	\N	\N	\N	\N	81266	81266	81267
18837	26102	0	applied	\N	\N	\N	\N	81282	81282	81283
18843	26111	0	applied	\N	\N	\N	\N	81313	81313	81314
18843	26112	1	applied	\N	\N	\N	\N	81315	81315	81316
18843	26113	2	applied	\N	\N	\N	\N	81317	81317	81318
18846	26115	0	applied	\N	\N	\N	\N	81324	81324	81325
18846	26116	1	applied	\N	\N	\N	\N	81326	81326	81327
18846	26117	2	applied	\N	\N	\N	\N	81328	81328	81329
18848	26119	0	applied	\N	\N	\N	\N	81337	81337	81338
18851	26122	0	applied	\N	\N	\N	\N	81347	81347	81348
18855	26123	0	applied	\N	\N	\N	\N	81358	81358	81359
18855	26124	1	applied	\N	\N	\N	\N	81360	81360	81361
18858	26128	0	applied	\N	\N	\N	\N	81374	81374	81375
18861	26129	0	applied	\N	\N	\N	\N	81378	81378	81379
18861	26130	1	applied	\N	\N	\N	\N	81380	81380	81381
18861	26131	2	applied	\N	\N	\N	\N	81382	81382	81383
18863	26132	0	applied	\N	\N	\N	\N	81386	81386	81387
18863	26133	1	applied	\N	\N	\N	\N	81388	81388	81389
18868	26139	0	applied	\N	\N	\N	\N	81410	81410	81411
18873	26144	0	applied	\N	\N	\N	\N	81429	81429	81430
18880	26149	0	applied	\N	\N	\N	\N	81456	81456	81457
18883	26153	0	applied	\N	\N	\N	\N	81469	81469	81470
18885	26154	0	applied	\N	\N	\N	\N	81475	81475	81476
18885	26155	1	applied	\N	\N	\N	\N	81477	81477	81478
18888	26160	0	applied	\N	\N	\N	\N	81490	81490	81491
18891	26163	0	applied	\N	\N	\N	\N	81502	81502	81503
18891	26164	1	applied	\N	\N	\N	\N	81504	81504	81505
18894	26163	0	applied	\N	\N	\N	\N	81502	81502	81503
18894	26164	1	applied	\N	\N	\N	\N	81504	81504	81505
18897	26165	0	applied	\N	\N	\N	\N	81514	81514	81515
18910	26179	0	applied	\N	\N	\N	\N	81556	81556	81557
18915	26184	0	applied	\N	\N	\N	\N	81572	81572	81573
18915	26185	1	applied	\N	\N	\N	\N	81574	81574	81575
18917	26186	0	applied	\N	\N	\N	\N	81581	81581	81582
18920	26145	0	applied	\N	\N	\N	\N	81445	81445	81446
18920	26146	1	applied	\N	\N	\N	\N	81447	81447	81448
18920	26148	2	applied	\N	\N	\N	\N	81452	81452	81453
18920	26149	3	applied	\N	\N	\N	\N	81456	81456	81457
18920	26150	4	applied	\N	\N	\N	\N	81459	81459	81460
18920	26152	5	applied	\N	\N	\N	\N	81465	81465	81466
18920	26153	6	applied	\N	\N	\N	\N	81469	81469	81470
18920	26154	7	applied	\N	\N	\N	\N	81475	81475	81476
18920	26156	8	applied	\N	\N	\N	\N	81481	81481	81482
18920	26157	9	applied	\N	\N	\N	\N	81483	81483	81484
18920	26158	10	applied	\N	\N	\N	\N	81485	81485	81486
18920	26160	11	applied	\N	\N	\N	\N	81490	81490	81491
18920	26161	12	applied	\N	\N	\N	\N	81494	81494	81495
18920	26162	13	applied	\N	\N	\N	\N	81496	81496	81497
18920	26163	14	applied	\N	\N	\N	\N	81502	81502	81503
18920	26165	15	applied	\N	\N	\N	\N	81514	81514	81515
18920	26166	16	applied	\N	\N	\N	\N	81517	81517	81518
18920	26167	17	applied	\N	\N	\N	\N	81520	81520	81521
18920	26169	18	applied	\N	\N	\N	\N	81528	81528	81529
18920	26170	19	applied	\N	\N	\N	\N	81533	81533	81534
18920	26171	20	applied	\N	\N	\N	\N	81535	81535	81536
18920	26173	21	applied	\N	\N	\N	\N	81539	81539	81540
18920	26174	22	applied	\N	\N	\N	\N	81544	81544	81545
18920	26175	23	applied	\N	\N	\N	\N	81546	81546	81547
18920	26176	24	applied	\N	\N	\N	\N	81548	81548	81549
18920	26177	25	applied	\N	\N	\N	\N	81550	81550	81551
18920	26179	26	applied	\N	\N	\N	\N	81556	81556	81557
18920	26180	27	applied	\N	\N	\N	\N	81560	81560	81561
18920	26182	28	applied	\N	\N	\N	\N	81565	81565	81566
18920	26183	29	applied	\N	\N	\N	\N	81567	81567	81568
18920	26184	30	applied	\N	\N	\N	\N	81572	81572	81573
18920	26186	31	applied	\N	\N	\N	\N	81581	81581	81582
18920	26187	32	applied	\N	\N	\N	\N	81584	81584	81585
18920	26188	33	applied	\N	\N	\N	\N	81586	81586	81587
18920	26189	34	applied	\N	\N	\N	\N	81590	81590	81591
18920	26147	35	applied	\N	\N	\N	\N	81449	81449	81450
18920	26151	36	applied	\N	\N	\N	\N	81461	81461	81462
18920	26155	37	applied	\N	\N	\N	\N	81477	81477	81478
18920	26159	38	applied	\N	\N	\N	\N	81487	81487	81488
18920	26164	39	applied	\N	\N	\N	\N	81504	81504	81505
18920	26168	40	applied	\N	\N	\N	\N	81522	81522	81523
18920	26172	41	applied	\N	\N	\N	\N	81537	81537	81538
18920	26178	42	applied	\N	\N	\N	\N	81552	81552	81553
18920	26181	43	applied	\N	\N	\N	\N	81562	81562	81563
18920	26185	44	applied	\N	\N	\N	\N	81574	81574	81575
18920	26190	45	applied	\N	\N	\N	\N	81592	81592	81593
18841	26107	0	applied	\N	\N	\N	\N	81302	81302	81303
18841	26108	1	applied	\N	\N	\N	\N	81304	81304	81305
18844	26114	0	applied	\N	\N	\N	\N	81320	81320	81321
18847	26118	0	applied	\N	\N	\N	\N	81333	81333	81334
18854	26122	0	applied	\N	\N	\N	\N	81347	81347	81348
18859	26128	0	applied	\N	\N	\N	\N	81374	81374	81375
18862	26132	0	applied	\N	\N	\N	\N	81386	81386	81387
18862	26133	1	applied	\N	\N	\N	\N	81388	81388	81389
18867	26137	0	applied	\N	\N	\N	\N	81405	81405	81406
18867	26138	1	applied	\N	\N	\N	\N	81407	81407	81408
18870	26140	0	applied	\N	\N	\N	\N	81414	81414	81415
18870	26141	1	applied	\N	\N	\N	\N	81416	81416	81417
18870	26142	2	applied	\N	\N	\N	\N	81418	81418	81419
18872	26143	0	applied	\N	\N	\N	\N	81425	81425	81426
18874	26144	0	applied	\N	\N	\N	\N	81429	81429	81430
18879	26148	0	applied	\N	\N	\N	\N	81452	81452	81453
18887	26157	0	applied	\N	\N	\N	\N	81483	81483	81484
18887	26158	1	applied	\N	\N	\N	\N	81485	81485	81486
18887	26159	2	applied	\N	\N	\N	\N	81487	81487	81488
18896	26161	0	applied	\N	\N	\N	\N	81494	81494	81495
18896	26162	1	applied	\N	\N	\N	\N	81496	81496	81497
18896	26163	2	applied	\N	\N	\N	\N	81502	81502	81503
18896	26164	3	applied	\N	\N	\N	\N	81504	81504	81505
18901	26169	0	applied	\N	\N	\N	\N	81528	81528	81529
18911	26180	0	applied	\N	\N	\N	\N	81560	81560	81561
18911	26181	1	applied	\N	\N	\N	\N	81562	81562	81563
18914	26184	0	applied	\N	\N	\N	\N	81572	81572	81573
18914	26185	1	applied	\N	\N	\N	\N	81574	81574	81575
18916	26184	0	applied	\N	\N	\N	\N	81572	81572	81573
18916	26185	1	applied	\N	\N	\N	\N	81574	81574	81575
18919	26189	0	applied	\N	\N	\N	\N	81590	81590	81591
18919	26190	1	applied	\N	\N	\N	\N	81592	81592	81593
18921	26191	0	applied	\N	\N	\N	\N	81596	81596	81597
18923	26191	0	applied	\N	\N	\N	\N	81596	81596	81597
18926	26195	0	applied	\N	\N	\N	\N	81612	81612	81613
18928	26195	0	applied	\N	\N	\N	\N	81612	81612	81613
18930	26196	0	applied	\N	\N	\N	\N	81619	81619	81620
18935	26200	0	applied	\N	\N	\N	\N	81633	81633	81634
18937	26201	0	applied	\N	\N	\N	\N	81638	81638	81639
18947	26211	0	applied	\N	\N	\N	\N	81673	81673	81674
18947	26212	1	applied	\N	\N	\N	\N	81675	81675	81676
18947	26213	2	applied	\N	\N	\N	\N	81677	81677	81678
18950	26214	0	applied	\N	\N	\N	\N	81681	81681	81682
18954	26217	0	applied	\N	\N	\N	\N	81692	81692	81693
18954	26218	1	applied	\N	\N	\N	\N	81694	81694	81695
18954	26219	2	applied	\N	\N	\N	\N	81696	81696	81697
18963	26225	0	applied	\N	\N	\N	\N	81717	81717	81718
18965	26226	0	applied	\N	\N	\N	\N	81723	81723	81724
18970	26229	0	applied	\N	\N	\N	\N	81739	81739	81740
18970	26230	1	applied	\N	\N	\N	\N	81741	81741	81742
18973	26232	0	applied	\N	\N	\N	\N	81749	81749	81750
18973	26233	1	applied	\N	\N	\N	\N	81751	81751	81752
18982	26240	0	applied	\N	\N	\N	\N	81776	81776	81777
18982	26241	1	applied	\N	\N	\N	\N	81778	81778	81779
18984	26242	0	applied	\N	\N	\N	\N	81782	81782	81783
18987	26243	0	applied	\N	\N	\N	\N	81786	81786	81787
18987	26244	1	applied	\N	\N	\N	\N	81788	81788	81789
18987	26245	2	applied	\N	\N	\N	\N	81790	81790	81791
18987	26246	3	applied	\N	\N	\N	\N	81792	81792	81793
18991	26248	0	applied	\N	\N	\N	\N	81802	81802	81803
18991	26249	1	applied	\N	\N	\N	\N	81804	81804	81805
18995	26250	0	applied	\N	\N	\N	\N	81808	81808	81809
19000	26254	0	applied	\N	\N	\N	\N	81823	81823	81824
19011	26259	0	applied	\N	\N	\N	\N	81845	81845	81846
19011	26260	1	applied	\N	\N	\N	\N	81847	81847	81848
19020	26265	0	applied	\N	\N	\N	\N	81871	81871	81872
19020	26266	1	applied	\N	\N	\N	\N	81873	81873	81874
19020	26267	2	applied	\N	\N	\N	\N	81875	81875	79274
19020	26268	3	applied	\N	\N	\N	\N	81876	81876	81877
19023	26269	0	applied	\N	\N	\N	\N	81881	81881	81882
19028	26278	0	applied	\N	\N	\N	\N	81902	81902	81903
19031	26283	0	applied	\N	\N	\N	\N	81917	81917	81918
19036	26287	0	applied	\N	\N	\N	\N	81930	81930	81931
19047	26302	0	applied	\N	\N	\N	\N	81975	81975	81976
19050	26305	0	applied	\N	\N	\N	\N	81985	81985	81986
19050	26306	1	applied	\N	\N	\N	\N	81987	81987	81988
19050	26307	2	applied	\N	\N	\N	\N	81989	81989	81990
19050	26308	3	applied	\N	\N	\N	\N	81991	81991	81992
19050	26309	4	applied	\N	\N	\N	\N	81993	81993	81994
19053	26311	0	applied	\N	\N	\N	\N	82002	82002	82003
19053	26312	1	applied	\N	\N	\N	\N	82004	82004	82005
19053	26313	2	applied	\N	\N	\N	\N	82006	82006	82007
19054	26314	0	applied	\N	\N	\N	\N	82011	82011	82012
19054	26315	1	applied	\N	\N	\N	\N	82013	82013	82014
19054	26316	2	applied	\N	\N	\N	\N	82015	82015	82016
19054	26317	3	applied	\N	\N	\N	\N	82017	82017	82018
19054	26318	4	applied	\N	\N	\N	\N	82019	82019	82020
19054	26319	5	applied	\N	\N	\N	\N	82021	82021	82022
19056	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19056	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19058	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19058	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19065	26333	0	applied	\N	\N	\N	\N	82060	82060	82061
19065	26334	1	applied	\N	\N	\N	\N	82062	82062	28166
19065	26335	2	applied	\N	\N	\N	\N	82063	82063	82064
19065	26336	3	applied	\N	\N	\N	\N	82065	82065	75338
19067	26337	0	applied	\N	\N	\N	\N	82068	82068	82068
19067	26338	1	applied	\N	\N	\N	\N	82069	82069	82070
19072	26341	0	applied	\N	\N	\N	\N	82082	82082	82083
19072	26342	1	applied	\N	\N	\N	\N	82084	82084	82085
19074	26341	0	applied	\N	\N	\N	\N	82082	82082	82083
19074	26342	1	applied	\N	\N	\N	\N	82084	82084	82085
19079	26347	0	applied	\N	\N	\N	\N	82105	82105	82106
19081	26348	0	applied	\N	\N	\N	\N	82109	82109	82110
19087	26362	0	applied	\N	\N	\N	\N	82143	82143	82144
19090	26351	0	applied	\N	\N	\N	\N	82119	82119	82119
19090	26363	1	applied	\N	\N	1000000000	\N	82149	82149	82150
19090	26364	2	applied	\N	\N	\N	\N	82151	82151	82152
19090	26347	3	applied	\N	\N	\N	\N	82105	82105	82106
19090	26348	4	applied	\N	\N	\N	\N	82109	82109	82110
19090	26357	5	applied	\N	\N	\N	\N	82132	82132	82132
19090	26358	6	applied	\N	\N	\N	\N	82133	82133	82133
19090	26359	7	applied	\N	\N	\N	\N	82134	82134	82134
19090	26368	8	applied	\N	\N	\N	\N	82159	82159	82159
19090	26349	9	applied	\N	\N	\N	\N	82113	82113	82114
19090	26352	10	applied	\N	\N	\N	\N	82120	82120	82121
19090	26353	11	applied	\N	\N	\N	\N	82122	82122	82123
19090	26354	12	applied	\N	\N	\N	\N	82126	82126	82127
19090	26355	13	applied	\N	\N	\N	\N	82128	82128	82129
19090	26356	14	applied	\N	\N	\N	\N	82130	82130	82131
18849	26120	0	applied	\N	\N	\N	\N	81341	81341	81342
18849	26121	1	applied	\N	\N	\N	\N	81343	81343	81344
18852	26122	0	applied	\N	\N	\N	\N	81347	81347	81348
18856	26125	0	applied	\N	\N	\N	\N	81364	81364	81365
18856	26126	1	applied	\N	\N	\N	\N	81366	81366	81367
18864	26134	0	applied	\N	\N	\N	\N	81393	81393	81394
18864	26135	1	applied	\N	\N	\N	\N	81395	81395	81396
18866	26136	0	applied	\N	\N	\N	\N	81401	81401	81402
18869	26140	0	applied	\N	\N	\N	\N	81414	81414	81415
18869	26141	1	applied	\N	\N	\N	\N	81416	81416	81417
18869	26142	2	applied	\N	\N	\N	\N	81418	81418	81419
18871	26140	0	applied	\N	\N	\N	\N	81414	81414	81415
18871	26141	1	applied	\N	\N	\N	\N	81416	81416	81417
18871	26142	2	applied	\N	\N	\N	\N	81418	81418	81419
18876	26074	0	applied	\N	\N	\N	\N	81182	81182	81183
18876	26077	1	applied	\N	\N	\N	\N	81192	81192	81193
18876	26079	2	applied	\N	\N	\N	\N	81199	81199	81200
18876	26080	3	applied	\N	\N	\N	\N	81201	81201	81202
18876	26081	4	applied	\N	\N	\N	\N	81203	81203	81204
18876	26084	5	applied	\N	\N	\N	\N	81213	81213	81214
18876	26085	6	applied	\N	\N	\N	\N	81217	81217	81218
18876	26086	7	applied	\N	\N	\N	\N	81223	81223	81224
18876	26088	8	applied	\N	\N	\N	\N	81229	81229	81230
18876	26089	9	applied	\N	\N	\N	\N	81235	81235	81236
18876	26090	10	applied	\N	\N	\N	\N	81238	81238	81239
18876	26092	11	applied	\N	\N	\N	\N	81246	81246	81247
18876	26093	12	applied	\N	\N	\N	\N	81249	81249	81250
18876	26094	13	applied	\N	\N	\N	\N	81258	81258	81259
18876	26095	14	applied	\N	\N	\N	\N	81260	81260	81261
18876	26097	15	applied	\N	\N	\N	\N	81266	81266	81267
18876	26098	16	applied	\N	\N	\N	\N	81270	81270	81271
18876	26099	17	applied	\N	\N	\N	\N	81273	81273	81274
18876	26101	18	applied	\N	\N	\N	\N	81279	81279	81280
18876	26102	19	applied	\N	\N	\N	\N	81282	81282	81283
18876	26103	20	applied	\N	\N	\N	\N	81288	81288	81289
18876	26104	21	applied	\N	\N	\N	\N	81290	81290	81291
18876	26106	22	applied	\N	\N	\N	\N	81296	81296	81297
18876	26107	23	applied	\N	\N	\N	\N	81302	81302	81303
18876	26109	24	applied	\N	\N	\N	\N	81308	81308	81309
18876	26110	25	applied	\N	\N	\N	\N	81310	81310	81311
18876	26111	26	applied	\N	\N	\N	\N	81313	81313	81314
18876	26112	27	applied	\N	\N	\N	\N	81315	81315	81316
18876	26114	28	applied	\N	\N	\N	\N	81320	81320	81321
18876	26115	29	applied	\N	\N	\N	\N	81324	81324	81325
18876	26116	30	applied	\N	\N	\N	\N	81326	81326	81327
18876	26118	31	applied	\N	\N	\N	\N	81333	81333	81334
18876	26119	32	applied	\N	\N	\N	\N	81337	81337	81338
18876	26120	33	applied	\N	\N	\N	\N	81341	81341	81342
18876	26122	34	applied	\N	\N	\N	\N	81347	81347	81348
18876	26123	36	applied	\N	\N	\N	\N	81358	81358	81359
18876	26124	37	applied	\N	\N	\N	\N	81360	81360	81361
18876	26125	38	applied	\N	\N	\N	\N	81364	81364	81365
18876	26127	39	applied	\N	\N	\N	\N	81370	81370	81371
18876	26128	40	applied	\N	\N	\N	\N	81374	81374	81375
18876	26129	41	applied	\N	\N	\N	\N	81378	81378	81379
18876	26130	42	applied	\N	\N	\N	\N	81380	81380	81381
18876	26132	43	applied	\N	\N	\N	\N	81386	81386	81387
18876	26134	44	applied	\N	\N	\N	\N	81393	81393	81394
18876	26135	45	applied	\N	\N	\N	\N	81395	81395	81396
18876	26136	46	applied	\N	\N	\N	\N	81401	81401	81402
18876	26137	47	applied	\N	\N	\N	\N	81405	81405	81406
18876	26139	48	applied	\N	\N	\N	\N	81410	81410	81411
18876	26140	49	applied	\N	\N	\N	\N	81414	81414	81415
18876	26141	50	applied	\N	\N	\N	\N	81416	81416	81417
18876	26143	51	applied	\N	\N	\N	\N	81425	81425	81426
18876	26144	52	applied	\N	\N	\N	\N	81429	81429	81430
18876	26075	53	applied	\N	\N	\N	\N	81184	81184	81185
18876	26076	54	applied	\N	\N	\N	\N	81186	81186	81187
18876	26083	55	applied	\N	\N	\N	\N	81207	81207	81437
18876	26087	56	applied	\N	\N	\N	\N	81225	81225	81438
18876	26091	57	applied	\N	\N	\N	\N	81240	81240	81195
18876	26096	58	applied	\N	\N	\N	\N	81262	81262	81439
18876	26100	59	applied	\N	\N	\N	\N	81275	81275	81440
18876	26105	60	applied	\N	\N	\N	\N	81292	81292	81206
18876	26108	61	applied	\N	\N	\N	\N	81304	81304	81208
18876	26113	62	applied	\N	\N	\N	\N	81317	81317	81226
18876	26117	63	applied	\N	\N	\N	\N	81328	81328	81241
18876	26121	64	applied	\N	\N	\N	\N	81343	81343	81263
18876	26078	65	applied	\N	\N	\N	\N	81194	81194	81305
18876	26082	66	applied	\N	\N	\N	\N	81205	81205	81344
18876	26126	67	applied	\N	\N	\N	\N	81366	81366	81367
18876	26131	68	applied	\N	\N	\N	\N	81382	81382	81383
18876	26133	69	applied	\N	\N	\N	\N	81388	81388	81389
18876	26138	70	applied	\N	\N	\N	\N	81407	81407	81408
18876	26142	71	applied	\N	\N	\N	\N	81418	81418	81419
18878	26145	0	applied	\N	\N	\N	\N	81445	81445	81446
18878	26146	1	applied	\N	\N	\N	\N	81447	81447	81448
18878	26147	2	applied	\N	\N	\N	\N	81449	81449	81450
18881	26150	0	applied	\N	\N	\N	\N	81459	81459	81460
18881	26151	1	applied	\N	\N	\N	\N	81461	81461	81462
18884	26153	0	applied	\N	\N	\N	\N	81469	81469	81470
18886	26156	0	applied	\N	\N	\N	\N	81481	81481	81482
18889	26161	0	applied	\N	\N	\N	\N	81494	81494	81495
18889	26162	1	applied	\N	\N	\N	\N	81496	81496	81497
18892	26163	0	applied	\N	\N	\N	\N	81502	81502	81503
18892	26164	1	applied	\N	\N	\N	\N	81504	81504	81505
18895	26163	0	applied	\N	\N	\N	\N	81502	81502	81503
18895	26164	1	applied	\N	\N	\N	\N	81504	81504	81505
18898	26166	0	applied	\N	\N	\N	\N	81517	81517	81518
18900	26167	0	applied	\N	\N	\N	\N	81520	81520	81521
18900	26168	1	applied	\N	\N	\N	\N	81522	81522	81523
18903	26170	0	applied	\N	\N	\N	\N	81533	81533	81534
18903	26171	1	applied	\N	\N	\N	\N	81535	81535	81536
18903	26172	2	applied	\N	\N	\N	\N	81537	81537	81538
18905	26173	0	applied	\N	\N	\N	\N	81539	81539	81540
18913	26182	0	applied	\N	\N	\N	\N	81565	81565	81566
18913	26183	1	applied	\N	\N	\N	\N	81567	81567	81568
18918	26187	0	applied	\N	\N	\N	\N	81584	81584	81585
18918	26188	1	applied	\N	\N	\N	\N	81586	81586	81587
18925	26193	0	applied	\N	\N	\N	\N	81606	81606	81607
18925	26194	1	applied	\N	\N	\N	\N	81608	81608	81609
18934	26199	0	applied	\N	\N	\N	\N	81630	81630	81631
18939	26202	0	applied	\N	\N	\N	\N	81642	81642	81643
18939	26203	1	applied	\N	\N	\N	\N	81644	81644	81645
18942	26205	0	applied	\N	\N	\N	\N	81651	81651	81652
18942	26206	1	applied	\N	\N	\N	\N	81653	81653	81654
18942	26207	2	applied	\N	\N	\N	\N	81655	81655	81656
18942	26208	3	applied	\N	\N	\N	\N	81657	81657	81658
18944	26209	0	applied	\N	\N	1000000000	\N	81663	81663	81664
18944	26210	1	applied	\N	\N	\N	\N	81665	81665	81666
18929	26195	0	applied	\N	\N	\N	\N	81612	81612	81613
18932	26197	0	applied	\N	\N	\N	\N	81622	81622	81623
18932	26198	1	applied	\N	\N	\N	\N	81624	81624	81625
18936	26200	0	applied	\N	\N	\N	\N	81633	81633	81634
18946	26209	0	applied	\N	\N	1000000000	\N	81663	81663	81664
18953	26215	0	applied	\N	\N	\N	\N	81685	81685	81686
18953	26216	1	applied	\N	\N	\N	\N	81687	81687	81688
18955	26220	0	applied	\N	\N	\N	\N	81699	81699	81700
18962	26222	0	applied	\N	\N	\N	\N	81707	81707	81708
18962	26223	1	applied	\N	\N	\N	\N	81709	81709	81710
18962	26224	2	applied	\N	\N	\N	\N	81711	81711	81712
18964	26225	0	applied	\N	\N	\N	\N	81717	81717	81718
18967	26227	0	applied	\N	\N	\N	\N	81727	81727	81728
18967	26228	1	applied	\N	\N	\N	\N	81729	81729	81730
18969	26227	0	applied	\N	\N	\N	\N	81727	81727	81728
18969	26228	1	applied	\N	\N	\N	\N	81729	81729	81730
18971	26231	0	applied	\N	\N	\N	\N	81745	81745	81746
18979	26239	0	applied	\N	\N	\N	\N	81771	81771	81772
18993	26248	0	applied	\N	\N	\N	\N	81802	81802	81803
18993	26249	1	applied	\N	\N	\N	\N	81804	81804	81805
18994	26248	0	applied	\N	\N	\N	\N	81802	81802	81803
18994	26249	1	applied	\N	\N	\N	\N	81804	81804	81805
19001	26254	0	applied	\N	\N	\N	\N	81823	81823	81824
19006	26255	0	applied	\N	\N	\N	\N	81829	81829	81830
19006	26256	1	applied	\N	\N	\N	\N	81833	81833	81834
19008	26258	0	applied	\N	\N	\N	\N	81838	81838	81839
19012	26259	0	applied	\N	\N	\N	\N	81845	81845	81846
19012	26260	1	applied	\N	\N	\N	\N	81847	81847	81848
19015	26261	0	applied	\N	\N	\N	\N	81854	81854	81855
19015	26262	1	applied	\N	\N	\N	\N	81856	81856	81857
19021	26265	0	applied	\N	\N	\N	\N	81871	81871	81872
19021	26266	1	applied	\N	\N	\N	\N	81873	81873	81874
19021	26267	2	applied	\N	\N	\N	\N	81875	81875	79274
19021	26268	3	applied	\N	\N	\N	\N	81876	81876	81877
19024	26269	0	applied	\N	\N	\N	\N	81881	81881	81882
19027	26276	0	applied	\N	\N	\N	\N	81898	81898	81899
19027	26277	1	applied	\N	\N	\N	\N	81900	81900	81901
19030	26282	0	applied	\N	\N	\N	\N	81913	81913	81914
19033	26283	0	applied	\N	\N	\N	\N	81917	81917	81918
19037	26288	0	applied	\N	\N	\N	\N	81934	81934	81935
19043	26292	0	applied	\N	\N	\N	\N	81950	81950	81951
19043	26293	1	applied	\N	\N	\N	\N	81952	81952	81953
19043	26294	2	applied	\N	\N	\N	\N	81954	81954	81955
19043	26295	3	applied	\N	\N	\N	\N	81956	81956	81957
19043	26296	4	applied	\N	\N	\N	\N	81958	81958	81959
19043	26297	5	applied	\N	\N	\N	\N	81960	81960	81961
19046	26302	0	applied	\N	\N	\N	\N	81975	81975	81976
19048	26303	0	applied	\N	\N	\N	\N	81980	81980	81981
19048	26304	1	applied	\N	\N	\N	\N	81982	81982	81983
19049	26305	0	applied	\N	\N	\N	\N	81985	81985	81986
19049	26306	1	applied	\N	\N	\N	\N	81987	81987	81988
19049	26307	2	applied	\N	\N	\N	\N	81989	81989	81990
19049	26308	3	applied	\N	\N	\N	\N	81991	81991	81992
19049	26309	4	applied	\N	\N	\N	\N	81993	81993	81994
19051	26310	0	applied	\N	\N	\N	\N	81998	81998	81999
19055	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19055	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19057	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19057	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19060	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19060	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19066	26337	0	applied	\N	\N	\N	\N	82068	82068	82068
19066	26338	1	applied	\N	\N	\N	\N	82069	82069	82070
19071	26341	0	applied	\N	\N	\N	\N	82082	82082	82083
19071	26342	1	applied	\N	\N	\N	\N	82084	82084	82085
19075	26343	0	applied	\N	\N	\N	\N	82090	82090	82091
19078	26345	0	applied	\N	\N	\N	\N	82097	82097	82098
19078	26346	1	applied	\N	\N	\N	\N	82099	82099	82100
19080	26348	0	applied	\N	\N	\N	\N	82109	82109	82110
19083	26351	0	applied	\N	\N	\N	\N	82119	82119	82119
19083	26352	1	applied	\N	\N	\N	\N	82120	82120	82121
19083	26353	2	applied	\N	\N	\N	\N	82122	82122	82123
19086	26354	0	applied	\N	\N	\N	\N	82126	82126	82127
19086	26355	1	applied	\N	\N	\N	\N	82128	82128	82129
19086	26356	2	applied	\N	\N	\N	\N	82130	82130	82131
19086	26357	3	applied	\N	\N	\N	\N	82132	82132	82132
19086	26358	4	applied	\N	\N	\N	\N	82133	82133	82133
19086	26359	5	applied	\N	\N	\N	\N	82134	82134	82134
19086	26360	6	applied	\N	\N	\N	\N	82135	82135	82136
19086	26361	7	applied	\N	\N	1000000000	\N	82137	82137	82138
19096	26322	0	applied	\N	\N	1000000000	\N	82034	82034	82035
19096	26264	1	applied	\N	\N	\N	\N	81866	81866	81867
19096	26324	2	applied	\N	\N	1000000000	\N	82038	82038	82039
19096	26325	3	applied	\N	\N	1000000000	\N	82040	82040	82041
19096	26326	4	applied	\N	\N	1000000000	\N	82042	82042	82043
19096	26327	5	applied	\N	\N	1000000000	\N	82044	82044	82045
19096	26328	6	applied	\N	\N	1000000000	\N	82046	82046	82047
19096	26329	7	applied	\N	\N	1000000000	\N	82048	82048	82049
19096	26330	8	applied	\N	\N	1000000000	\N	82050	82050	82051
19096	26363	9	applied	\N	\N	1000000000	\N	82149	82149	82150
19096	26364	10	applied	\N	\N	\N	\N	82151	82151	82152
19096	26260	11	applied	\N	\N	\N	\N	81847	81847	81848
19096	26267	12	applied	\N	\N	\N	\N	81875	81875	79274
19096	26372	13	applied	\N	\N	\N	\N	82167	82167	81752
19096	26297	14	applied	\N	\N	\N	\N	81960	81960	81961
19096	26373	15	applied	\N	\N	\N	\N	82168	82168	81805
19096	26378	16	applied	\N	\N	\N	\N	82184	82184	81834
19096	26381	17	applied	\N	\N	\N	\N	82193	82193	81877
19096	26244	18	applied	\N	\N	\N	\N	81788	81788	81789
19096	26245	19	applied	\N	\N	\N	\N	81790	81790	81791
19096	26246	20	applied	\N	\N	\N	\N	81792	81792	81793
19096	26375	21	applied	\N	\N	\N	\N	82175	82175	81911
19096	26377	22	applied	\N	\N	\N	\N	82182	82182	81959
19096	26380	23	applied	\N	\N	\N	\N	82191	82191	81994
19103	26385	0	applied	\N	\N	\N	\N	82210	82210	82211
19103	26386	1	applied	\N	\N	\N	\N	82212	82212	82213
19103	26387	2	applied	\N	\N	\N	\N	82214	82214	82215
19103	26388	3	applied	\N	\N	\N	\N	82216	82216	82217
19103	26389	4	applied	\N	\N	\N	\N	82218	82218	82219
19103	26390	5	applied	\N	\N	\N	\N	82220	82220	82221
19105	26393	0	applied	\N	\N	\N	\N	82235	82235	82236
19105	26394	1	applied	\N	\N	\N	\N	82237	82237	82238
19105	26395	2	applied	\N	\N	\N	\N	82239	82239	82240
19105	26396	3	applied	\N	\N	\N	\N	82241	82241	82242
19108	26405	0	applied	\N	\N	\N	\N	82260	82260	82261
19108	26406	1	applied	\N	\N	\N	\N	82262	82262	82263
19108	26407	2	applied	\N	\N	\N	\N	82264	82264	82264
19108	26408	3	applied	\N	\N	\N	\N	82265	82265	82266
18941	26207	2	applied	\N	\N	\N	\N	81655	81655	81656
18941	26208	3	applied	\N	\N	\N	\N	81657	81657	81658
18943	26209	0	applied	\N	\N	1000000000	\N	81663	81663	81664
18943	26210	1	applied	\N	\N	\N	\N	81665	81665	81666
18945	26209	0	applied	\N	\N	1000000000	\N	81663	81663	81664
18945	26210	1	applied	\N	\N	\N	\N	81665	81665	81666
18948	26211	0	applied	\N	\N	\N	\N	81673	81673	81674
18948	26212	1	applied	\N	\N	\N	\N	81675	81675	81676
18948	26213	2	applied	\N	\N	\N	\N	81677	81677	81678
18952	26215	0	applied	\N	\N	\N	\N	81685	81685	81686
18952	26216	1	applied	\N	\N	\N	\N	81687	81687	81688
18957	26221	0	applied	\N	\N	\N	\N	81703	81703	81704
18961	26222	0	applied	\N	\N	\N	\N	81707	81707	81708
18961	26223	1	applied	\N	\N	\N	\N	81709	81709	81710
18961	26224	2	applied	\N	\N	\N	\N	81711	81711	81712
18966	26227	0	applied	\N	\N	\N	\N	81727	81727	81728
18966	26228	1	applied	\N	\N	\N	\N	81729	81729	81730
18968	26227	0	applied	\N	\N	\N	\N	81727	81727	81728
18968	26228	1	applied	\N	\N	\N	\N	81729	81729	81730
18974	26232	0	applied	\N	\N	\N	\N	81749	81749	81750
18974	26233	1	applied	\N	\N	\N	\N	81751	81751	81752
18975	26232	0	applied	\N	\N	\N	\N	81749	81749	81750
18975	26233	1	applied	\N	\N	\N	\N	81751	81751	81752
18978	26239	0	applied	\N	\N	\N	\N	81771	81771	81772
18980	26239	0	applied	\N	\N	\N	\N	81771	81771	81772
18983	26240	0	applied	\N	\N	\N	\N	81776	81776	81777
18983	26241	1	applied	\N	\N	\N	\N	81778	81778	81779
18985	26242	0	applied	\N	\N	\N	\N	81782	81782	81783
18989	26247	0	applied	\N	\N	\N	\N	81796	81796	81797
18992	26248	0	applied	\N	\N	\N	\N	81802	81802	81803
18992	26249	1	applied	\N	\N	\N	\N	81804	81804	81805
18996	26250	0	applied	\N	\N	\N	\N	81808	81808	81809
18998	26252	0	applied	\N	\N	\N	\N	81816	81816	81817
18998	26253	1	applied	\N	\N	\N	\N	81818	81818	81819
19005	26226	0	applied	\N	\N	\N	\N	81723	81723	81724
19005	26227	1	applied	\N	\N	\N	\N	81727	81727	81728
19005	26229	2	applied	\N	\N	\N	\N	81739	81739	81740
19005	26230	3	applied	\N	\N	\N	\N	81741	81741	81742
19005	26231	4	applied	\N	\N	\N	\N	81745	81745	81746
19005	26232	5	applied	\N	\N	\N	\N	81749	81749	81750
19005	26234	6	applied	\N	\N	\N	\N	81759	81759	81760
19005	26235	7	applied	\N	\N	\N	\N	81761	81761	81762
19005	26236	8	applied	\N	\N	\N	\N	81763	81763	81764
19005	26237	9	applied	\N	\N	\N	\N	81765	81765	81766
19005	26239	10	applied	\N	\N	\N	\N	81771	81771	81772
19005	26240	11	applied	\N	\N	\N	\N	81776	81776	81777
19005	26242	12	applied	\N	\N	\N	\N	81782	81782	81783
19005	26243	13	applied	\N	\N	\N	\N	81786	81786	81787
19005	26247	14	applied	\N	\N	\N	\N	81796	81796	81797
19005	26248	15	applied	\N	\N	\N	\N	81802	81802	81803
19005	26250	16	applied	\N	\N	\N	\N	81808	81808	81809
19005	26251	17	applied	\N	\N	\N	\N	81812	81812	81813
19005	26252	18	applied	\N	\N	\N	\N	81816	81816	81817
19005	26254	19	applied	\N	\N	\N	\N	81823	81823	81824
19005	26255	20	applied	\N	\N	\N	\N	81829	81829	81830
19005	26228	21	applied	\N	\N	\N	\N	81729	81729	81730
19005	26233	22	applied	\N	\N	\N	\N	81751	81751	81752
19005	26238	23	applied	\N	\N	\N	\N	81767	81767	81768
19005	26241	24	applied	\N	\N	\N	\N	81778	81778	81779
19005	26249	25	applied	\N	\N	\N	\N	81804	81804	81805
19005	26244	26	applied	\N	\N	\N	\N	81788	81788	81789
19005	26245	27	applied	\N	\N	\N	\N	81790	81790	81791
19005	26246	28	applied	\N	\N	\N	\N	81792	81792	81793
19005	26253	29	applied	\N	\N	\N	\N	81818	81818	81819
19007	26257	0	applied	\N	\N	\N	\N	81836	81836	81837
19010	26258	0	applied	\N	\N	\N	\N	81838	81838	81839
19014	26261	0	applied	\N	\N	\N	\N	81854	81854	81855
19014	26262	1	applied	\N	\N	\N	\N	81856	81856	81857
19018	26263	0	applied	\N	\N	\N	\N	81864	81864	81865
19018	26264	1	applied	\N	\N	\N	\N	81866	81866	81867
19025	26270	0	applied	\N	\N	\N	\N	81885	81885	81886
19026	26271	0	applied	\N	\N	\N	\N	81887	81887	81888
19026	26272	1	applied	\N	\N	\N	\N	81889	81889	81890
19026	26273	2	applied	\N	\N	\N	\N	81891	81891	81892
19026	26274	3	applied	\N	\N	\N	\N	81893	81893	81894
19026	26275	4	applied	\N	\N	\N	\N	81895	81895	81896
19029	26279	0	applied	\N	\N	\N	\N	81906	81906	81907
19029	26280	1	applied	\N	\N	\N	\N	81908	81908	81909
19029	26281	2	applied	\N	\N	\N	\N	81910	81910	81911
19032	26283	0	applied	\N	\N	\N	\N	81917	81917	81918
19034	26284	0	applied	\N	\N	\N	\N	81921	81921	81922
19034	26285	1	applied	\N	\N	\N	\N	81923	81923	81924
19039	26289	0	applied	\N	\N	\N	\N	81938	81938	81939
19039	26290	1	applied	\N	\N	\N	\N	81940	81940	81941
19042	26292	0	applied	\N	\N	\N	\N	81950	81950	81951
19042	26293	1	applied	\N	\N	\N	\N	81952	81952	81953
19042	26294	2	applied	\N	\N	\N	\N	81954	81954	81955
19042	26295	3	applied	\N	\N	\N	\N	81956	81956	81957
19042	26296	4	applied	\N	\N	\N	\N	81958	81958	81959
19042	26297	5	applied	\N	\N	\N	\N	81960	81960	81961
19045	26302	0	applied	\N	\N	\N	\N	81975	81975	81976
19059	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19059	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19063	26322	0	applied	\N	\N	1000000000	\N	82034	82034	82035
19063	26323	1	applied	\N	\N	\N	\N	82036	82036	82037
19063	26324	2	applied	\N	\N	1000000000	\N	82038	82038	82039
19063	26325	3	applied	\N	\N	1000000000	\N	82040	82040	82041
19063	26326	4	applied	\N	\N	1000000000	\N	82042	82042	82043
19063	26327	5	applied	\N	\N	1000000000	\N	82044	82044	82045
19063	26328	6	applied	\N	\N	1000000000	\N	82046	82046	82047
19063	26329	7	applied	\N	\N	1000000000	\N	82048	82048	82049
19063	26330	8	applied	\N	\N	1000000000	\N	82050	82050	82051
19063	26331	9	applied	\N	\N	\N	\N	82052	82052	33908
19068	26339	0	applied	\N	\N	\N	\N	82075	82075	82076
19070	26340	0	applied	\N	\N	\N	\N	82080	82080	82081
19073	26341	0	applied	\N	\N	\N	\N	82082	82082	82083
19073	26342	1	applied	\N	\N	\N	\N	82084	82084	82085
19077	26345	0	applied	\N	\N	\N	\N	82097	82097	82098
19077	26346	1	applied	\N	\N	\N	\N	82099	82099	82100
19082	26349	0	applied	\N	\N	\N	\N	82113	82113	82114
19082	26350	1	applied	\N	\N	\N	\N	82115	82115	82116
19085	26354	0	applied	\N	\N	\N	\N	82126	82126	82127
19085	26355	1	applied	\N	\N	\N	\N	82128	82128	82129
19085	26356	2	applied	\N	\N	\N	\N	82130	82130	82131
19085	26357	3	applied	\N	\N	\N	\N	82132	82132	82132
19085	26358	4	applied	\N	\N	\N	\N	82133	82133	82133
19085	26359	5	applied	\N	\N	\N	\N	82134	82134	82134
19085	26360	6	applied	\N	\N	\N	\N	82135	82135	82136
18949	26214	0	applied	\N	\N	\N	\N	81681	81681	81682
18956	26220	0	applied	\N	\N	\N	\N	81699	81699	81700
18958	26221	0	applied	\N	\N	\N	\N	81703	81703	81704
18960	26222	0	applied	\N	\N	\N	\N	81707	81707	81708
18960	26223	1	applied	\N	\N	\N	\N	81709	81709	81710
18960	26224	2	applied	\N	\N	\N	\N	81711	81711	81712
18972	26232	0	applied	\N	\N	\N	\N	81749	81749	81750
18972	26233	1	applied	\N	\N	\N	\N	81751	81751	81752
18976	26232	0	applied	\N	\N	\N	\N	81749	81749	81750
18976	26233	1	applied	\N	\N	\N	\N	81751	81751	81752
18977	26234	0	applied	\N	\N	\N	\N	81759	81759	81760
18977	26235	1	applied	\N	\N	\N	\N	81761	81761	81762
18977	26236	2	applied	\N	\N	\N	\N	81763	81763	81764
18977	26237	3	applied	\N	\N	\N	\N	81765	81765	81766
18977	26238	4	applied	\N	\N	\N	\N	81767	81767	81768
18986	26243	0	applied	\N	\N	\N	\N	81786	81786	81787
18986	26244	1	applied	\N	\N	\N	\N	81788	81788	81789
18986	26245	2	applied	\N	\N	\N	\N	81790	81790	81791
18986	26246	3	applied	\N	\N	\N	\N	81792	81792	81793
18988	26243	0	applied	\N	\N	\N	\N	81786	81786	81787
18988	26244	1	applied	\N	\N	\N	\N	81788	81788	81789
18988	26245	2	applied	\N	\N	\N	\N	81790	81790	81791
18988	26246	3	applied	\N	\N	\N	\N	81792	81792	81793
18990	26247	0	applied	\N	\N	\N	\N	81796	81796	81797
18997	26251	0	applied	\N	\N	\N	\N	81812	81812	81813
18999	26252	0	applied	\N	\N	\N	\N	81816	81816	81817
18999	26253	1	applied	\N	\N	\N	\N	81818	81818	81819
19009	26258	0	applied	\N	\N	\N	\N	81838	81838	81839
19013	26259	0	applied	\N	\N	\N	\N	81845	81845	81846
19013	26260	1	applied	\N	\N	\N	\N	81847	81847	81848
19016	26261	0	applied	\N	\N	\N	\N	81854	81854	81855
19016	26262	1	applied	\N	\N	\N	\N	81856	81856	81857
19017	26261	0	applied	\N	\N	\N	\N	81854	81854	81855
19017	26262	1	applied	\N	\N	\N	\N	81856	81856	81857
19022	26269	0	applied	\N	\N	\N	\N	81881	81881	81882
19035	26286	0	applied	\N	\N	\N	\N	81926	81926	81927
19038	26289	0	applied	\N	\N	\N	\N	81938	81938	81939
19038	26290	1	applied	\N	\N	\N	\N	81940	81940	81941
19040	26291	0	applied	\N	\N	\N	\N	81945	81945	81946
19044	26298	0	applied	\N	\N	\N	\N	81966	81966	81967
19044	26299	1	applied	\N	\N	\N	\N	81968	81968	81969
19044	26300	2	applied	\N	\N	\N	\N	81970	81970	81971
19044	26301	3	applied	\N	\N	\N	\N	81972	81972	81973
19052	26311	0	applied	\N	\N	\N	\N	82002	82002	82003
19052	26312	1	applied	\N	\N	\N	\N	82004	82004	82005
19052	26313	2	applied	\N	\N	\N	\N	82006	82006	82007
19061	26320	0	applied	\N	\N	\N	\N	82024	82024	82025
19061	26321	1	applied	\N	\N	\N	\N	82026	82026	82027
19062	26322	0	applied	\N	\N	1000000000	\N	82034	82034	82035
19062	26323	1	applied	\N	\N	\N	\N	82036	82036	82037
19062	26324	2	applied	\N	\N	1000000000	\N	82038	82038	82039
19062	26325	3	applied	\N	\N	1000000000	\N	82040	82040	82041
19062	26326	4	applied	\N	\N	1000000000	\N	82042	82042	82043
19062	26327	5	applied	\N	\N	1000000000	\N	82044	82044	82045
19062	26328	6	applied	\N	\N	1000000000	\N	82046	82046	82047
19062	26329	7	applied	\N	\N	1000000000	\N	82048	82048	82049
19062	26330	8	applied	\N	\N	1000000000	\N	82050	82050	82051
19062	26331	9	applied	\N	\N	\N	\N	82052	82052	33908
19064	26332	0	applied	\N	\N	\N	\N	82057	82057	82058
19069	26339	0	applied	\N	\N	\N	\N	82075	82075	82076
19076	26344	0	applied	\N	\N	\N	\N	82093	82093	82094
19084	26354	0	applied	\N	\N	\N	\N	82126	82126	82127
19084	26355	1	applied	\N	\N	\N	\N	82128	82128	82129
19084	26356	2	applied	\N	\N	\N	\N	82130	82130	82131
19084	26357	3	applied	\N	\N	\N	\N	82132	82132	82132
19084	26358	4	applied	\N	\N	\N	\N	82133	82133	82133
19084	26359	5	applied	\N	\N	\N	\N	82134	82134	82134
19084	26360	6	applied	\N	\N	\N	\N	82135	82135	82136
19084	26361	7	applied	\N	\N	1000000000	\N	82137	82137	82138
19089	26363	0	applied	\N	\N	1000000000	\N	82149	82149	82150
19089	26364	1	applied	\N	\N	\N	\N	82151	82151	82152
19089	26365	2	applied	\N	\N	\N	\N	82153	82153	82154
19089	26366	3	applied	\N	\N	\N	\N	82155	82155	82156
19089	26367	4	applied	\N	\N	\N	\N	82157	82157	82158
19089	26368	5	applied	\N	\N	\N	\N	82159	82159	82159
19089	26369	6	applied	\N	\N	\N	\N	82160	82160	82161
19092	26376	0	applied	\N	\N	\N	\N	82180	82180	82181
19092	26377	1	applied	\N	\N	\N	\N	82182	82182	82183
19092	26378	2	applied	\N	\N	\N	\N	82184	82184	82185
19094	26379	0	applied	\N	\N	\N	\N	82189	82189	82190
19094	26380	1	applied	\N	\N	\N	\N	82191	82191	82192
19094	26381	2	applied	\N	\N	\N	\N	82193	82193	82194
19098	26379	0	applied	\N	\N	\N	\N	82189	82189	82190
19098	26380	1	applied	\N	\N	\N	\N	82191	82191	82192
19098	26381	2	applied	\N	\N	\N	\N	82193	82193	82194
19101	26385	0	applied	\N	\N	\N	\N	82210	82210	82211
19101	26386	1	applied	\N	\N	\N	\N	82212	82212	82213
19101	26387	2	applied	\N	\N	\N	\N	82214	82214	82215
19101	26388	3	applied	\N	\N	\N	\N	82216	82216	82217
19101	26389	4	applied	\N	\N	\N	\N	82218	82218	82219
19101	26390	5	applied	\N	\N	\N	\N	82220	82220	82221
19106	26397	0	applied	\N	\N	\N	\N	82244	82244	82244
19106	26398	1	applied	\N	\N	\N	\N	82245	82245	82246
19106	26399	2	applied	\N	\N	\N	\N	82247	82247	82247
19106	26400	3	applied	\N	\N	\N	\N	82248	82248	82249
19106	26401	4	applied	\N	\N	\N	\N	82250	82250	82251
19106	26402	5	applied	\N	\N	\N	\N	82252	82252	82253
19106	26403	6	applied	\N	\N	\N	\N	82254	82254	82255
19106	26404	7	applied	\N	\N	\N	\N	82256	82256	82257
19111	26417	0	applied	\N	\N	\N	\N	82286	82286	82287
19111	26418	1	applied	\N	\N	\N	\N	82288	82288	82289
19122	26428	0	applied	\N	\N	\N	\N	82337	82337	82338
19122	26429	1	applied	\N	\N	\N	\N	82339	82339	82340
19122	26430	2	applied	\N	\N	\N	\N	82341	82341	82342
19122	26431	3	applied	\N	\N	\N	\N	82343	82343	82344
19124	26432	0	applied	\N	\N	\N	\N	82349	82349	82350
19124	26433	1	applied	\N	\N	\N	\N	82351	82351	82352
19131	26440	0	applied	\N	\N	\N	\N	82399	82399	82400
19131	26441	1	applied	\N	\N	\N	\N	82401	82401	82402
19131	26436	2	applied	\N	\N	1000000000	\N	82368	82368	82369
19131	26438	3	applied	\N	\N	\N	\N	82394	82394	82403
19131	26437	4	applied	\N	\N	\N	\N	82370	82370	82404
19131	26439	5	applied	\N	\N	\N	\N	82396	82396	82405
19134	26448	0	applied	\N	\N	\N	\N	82422	82422	82423
19134	26449	1	applied	\N	\N	\N	\N	82424	82424	82425
19134	26450	2	applied	\N	\N	\N	\N	82426	82426	82427
19134	26451	3	applied	\N	\N	\N	\N	82428	82428	82429
19134	26452	4	applied	\N	\N	\N	\N	82430	82430	82431
19085	26361	7	applied	\N	\N	1000000000	\N	82137	82137	82138
19088	26362	0	applied	\N	\N	\N	\N	82143	82143	82144
19091	26370	0	applied	\N	\N	\N	\N	82163	82163	82164
19091	26371	1	applied	\N	\N	\N	\N	82165	82165	82166
19091	26372	2	applied	\N	\N	\N	\N	82167	82167	82169
19091	26374	3	applied	\N	\N	\N	\N	82173	82173	82170
19091	26373	4	applied	\N	\N	\N	\N	82168	82168	82174
19091	26375	5	applied	\N	\N	\N	\N	82175	82175	82176
19093	26376	0	applied	\N	\N	\N	\N	82180	82180	82181
19093	26377	1	applied	\N	\N	\N	\N	82182	82182	82183
19093	26378	2	applied	\N	\N	\N	\N	82184	82184	82185
19097	26379	0	applied	\N	\N	\N	\N	82189	82189	82190
19097	26380	1	applied	\N	\N	\N	\N	82191	82191	82192
19097	26381	2	applied	\N	\N	\N	\N	82193	82193	82194
19100	26385	0	applied	\N	\N	\N	\N	82210	82210	82211
19100	26386	1	applied	\N	\N	\N	\N	82212	82212	82213
19100	26387	2	applied	\N	\N	\N	\N	82214	82214	82215
19100	26388	3	applied	\N	\N	\N	\N	82216	82216	82217
19100	26389	4	applied	\N	\N	\N	\N	82218	82218	82219
19100	26390	5	applied	\N	\N	\N	\N	82220	82220	82221
19102	26385	0	applied	\N	\N	\N	\N	82210	82210	82211
19102	26386	1	applied	\N	\N	\N	\N	82212	82212	82213
19102	26387	2	applied	\N	\N	\N	\N	82214	82214	82215
19102	26388	3	applied	\N	\N	\N	\N	82216	82216	82217
19102	26389	4	applied	\N	\N	\N	\N	82218	82218	82219
19102	26390	5	applied	\N	\N	\N	\N	82220	82220	82221
19104	26391	0	applied	\N	\N	\N	\N	82229	82229	82230
19104	26392	1	applied	\N	\N	\N	\N	82231	82231	82232
19110	26414	0	applied	\N	\N	\N	\N	82280	82280	82280
19110	26415	1	applied	\N	\N	\N	\N	82281	82281	82282
19110	26416	2	applied	\N	\N	\N	\N	82283	82283	82284
19113	26419	0	applied	\N	\N	\N	\N	82292	82292	82293
19118	26426	0	applied	\N	\N	\N	\N	82310	82310	82311
19118	26427	1	applied	\N	\N	\N	\N	82312	82312	82313
19120	26426	0	applied	\N	\N	\N	\N	82310	82310	82311
19120	26427	1	applied	\N	\N	\N	\N	82312	82312	82313
19123	26428	0	applied	\N	\N	\N	\N	82337	82337	82338
19123	26429	1	applied	\N	\N	\N	\N	82339	82339	82340
19123	26430	2	applied	\N	\N	\N	\N	82341	82341	82342
19123	26431	3	applied	\N	\N	\N	\N	82343	82343	82344
19125	26432	0	applied	\N	\N	\N	\N	82349	82349	82350
19125	26433	1	applied	\N	\N	\N	\N	82351	82351	82352
19127	26434	0	applied	\N	\N	\N	\N	82357	82357	82358
19127	26435	1	applied	\N	\N	\N	\N	82359	82359	82360
19129	26434	0	applied	\N	\N	\N	\N	82357	82357	82358
19129	26435	1	applied	\N	\N	\N	\N	82359	82359	82360
19132	26440	0	applied	\N	\N	\N	\N	82399	82399	82400
19132	26441	1	applied	\N	\N	\N	\N	82401	82401	82402
19132	26436	2	applied	\N	\N	1000000000	\N	82368	82368	82369
19132	26438	3	applied	\N	\N	\N	\N	82394	82394	82403
19132	26437	4	applied	\N	\N	\N	\N	82370	82370	82404
19132	26439	5	applied	\N	\N	\N	\N	82396	82396	82405
19135	26458	0	applied	\N	\N	\N	\N	82444	82444	82445
19135	26459	1	applied	\N	\N	\N	\N	82446	82446	82447
19135	26460	2	applied	\N	\N	\N	\N	82448	82448	82449
19136	26461	0	applied	\N	\N	\N	\N	82452	82452	82453
19136	26462	1	applied	\N	\N	\N	\N	82454	82454	82455
19136	26463	2	applied	\N	\N	\N	\N	82456	82456	82457
19144	26478	0	applied	\N	\N	\N	\N	82497	82497	82498
19144	26479	1	applied	\N	\N	\N	\N	82499	82499	82500
19144	26480	2	applied	\N	\N	\N	\N	82501	82501	82502
19146	26481	0	applied	\N	\N	\N	\N	82507	82507	82508
19146	26482	1	applied	\N	\N	\N	\N	82509	82509	82510
19146	26483	2	applied	\N	\N	\N	\N	82511	82511	82512
19149	26487	0	applied	\N	\N	\N	\N	82522	82522	82523
19149	26488	1	applied	\N	\N	\N	\N	82524	82524	82525
19149	26489	2	applied	\N	\N	\N	\N	82526	82526	82527
19149	26490	3	applied	\N	\N	\N	\N	82528	82528	82529
19150	26491	0	applied	\N	\N	\N	\N	82533	82533	82534
19150	26492	1	applied	\N	\N	\N	\N	82535	82535	82536
19150	26493	2	applied	\N	\N	\N	\N	82537	82537	82538
19150	26494	3	applied	\N	\N	\N	\N	82539	82539	82540
19150	26495	4	applied	\N	\N	\N	\N	82541	82541	82542
19150	26496	5	applied	\N	\N	\N	\N	82543	82543	82544
19150	26497	6	applied	\N	\N	\N	\N	82545	82545	82546
19150	26498	7	applied	\N	\N	\N	\N	82547	82547	82548
19150	26499	8	applied	\N	\N	\N	\N	82549	82549	82550
19150	26500	9	applied	\N	\N	\N	\N	82551	82551	82552
19150	26501	10	applied	\N	\N	\N	\N	82553	82553	82554
19150	26502	11	applied	\N	\N	\N	\N	82555	82555	82556
19150	26503	12	applied	\N	\N	\N	\N	82557	82557	82558
19150	26504	13	applied	\N	\N	\N	\N	82559	82559	82560
19150	26505	14	applied	\N	\N	\N	\N	82561	82561	82562
19150	26506	15	applied	\N	\N	\N	\N	82563	82563	82564
19150	26507	16	applied	\N	\N	\N	\N	82565	82565	82566
19150	26508	17	applied	\N	\N	\N	\N	82567	82567	82568
19150	26509	18	applied	\N	\N	\N	\N	82569	82569	82570
19153	26510	0	applied	\N	\N	\N	\N	82573	82573	82574
19153	26511	2	applied	\N	\N	\N	\N	82576	82576	82577
19153	26512	3	applied	\N	\N	\N	\N	82578	82578	82579
19153	26513	4	applied	\N	\N	\N	\N	82580	82580	82581
19159	26521	0	applied	\N	\N	\N	\N	82610	82610	82611
19159	26522	1	applied	\N	\N	\N	\N	82612	82612	82613
19159	26523	2	applied	\N	\N	\N	\N	82614	82614	82615
19159	26524	3	applied	\N	\N	\N	\N	82616	82616	82617
19166	26536	0	applied	\N	\N	\N	\N	82651	82651	82652
19166	26537	1	applied	\N	\N	\N	\N	82653	82653	82654
19166	26538	2	applied	\N	\N	\N	\N	82655	82655	82656
19166	26539	3	applied	\N	\N	\N	\N	82657	82657	82658
19166	26540	4	applied	\N	\N	\N	\N	82659	82659	82660
19166	26541	5	applied	\N	\N	\N	\N	82661	82661	82662
19166	26542	6	applied	\N	\N	\N	\N	82663	82663	82664
19169	26550	0	applied	\N	\N	\N	\N	82685	82685	82686
19169	26551	1	applied	\N	\N	\N	\N	82687	82687	82688
19169	26552	2	applied	\N	\N	\N	\N	82689	82689	82690
19177	26580	0	applied	\N	\N	\N	\N	82758	82758	82759
19177	26581	1	applied	\N	\N	\N	\N	82760	82760	82761
19177	26582	2	applied	\N	\N	\N	\N	82762	82762	82763
19179	26583	0	applied	\N	\N	\N	\N	82768	82768	82769
19179	26584	1	applied	\N	\N	\N	\N	82770	82770	82771
19179	26585	2	applied	\N	\N	\N	\N	82772	82772	82773
19179	26586	3	applied	\N	\N	\N	\N	82774	82774	82775
19179	26587	4	applied	\N	\N	\N	\N	82776	82776	82777
19186	26595	0	applied	\N	\N	\N	\N	82812	82812	82812
19186	26596	1	applied	\N	\N	\N	\N	82813	82813	82814
19186	26597	2	applied	\N	\N	\N	\N	82815	82815	82816
19186	26598	3	applied	\N	\N	\N	\N	82817	82817	82818
19186	26599	4	applied	\N	\N	\N	\N	82819	82819	82820
19186	26594	5	applied	\N	\N	\N	\N	82807	82807	82821
19090	26362	15	applied	\N	\N	\N	\N	82143	82143	82144
19090	26365	16	applied	\N	\N	\N	\N	82153	82153	82154
19090	26366	17	applied	\N	\N	\N	\N	82155	82155	82156
19090	26367	18	applied	\N	\N	\N	\N	82157	82157	82158
19090	26370	19	applied	\N	\N	\N	\N	82163	82163	82164
19090	26371	20	applied	\N	\N	\N	\N	82165	82165	82166
19090	26361	21	applied	\N	\N	1000000000	\N	82137	82137	82138
19090	26372	22	applied	\N	\N	\N	\N	82167	82167	82136
19090	26373	23	applied	\N	\N	\N	\N	82168	82168	82169
19090	26350	24	applied	\N	\N	\N	\N	82115	82115	82170
19090	26360	25	applied	\N	\N	\N	\N	82135	82135	82171
19090	26369	26	applied	\N	\N	\N	\N	82160	82160	82172
19090	26374	27	applied	\N	\N	\N	\N	82173	82173	82174
19090	26375	28	applied	\N	\N	\N	\N	82175	82175	82176
19095	26379	0	applied	\N	\N	\N	\N	82189	82189	82190
19095	26380	1	applied	\N	\N	\N	\N	82191	82191	82192
19095	26381	2	applied	\N	\N	\N	\N	82193	82193	82194
19099	26382	0	applied	\N	\N	\N	\N	82202	82202	82203
19099	26383	1	applied	\N	\N	\N	\N	82204	82204	82205
19099	26384	2	applied	\N	\N	\N	\N	82206	82206	82207
19107	26405	0	applied	\N	\N	\N	\N	82260	82260	82261
19107	26406	1	applied	\N	\N	\N	\N	82262	82262	82263
19107	26407	2	applied	\N	\N	\N	\N	82264	82264	82264
19107	26408	3	applied	\N	\N	\N	\N	82265	82265	82266
19107	26409	4	applied	\N	\N	\N	\N	82267	82267	82268
19107	26410	5	applied	\N	\N	\N	\N	82269	82269	82270
19109	26411	0	applied	\N	\N	\N	\N	82274	82274	82275
19109	26412	1	applied	\N	\N	\N	\N	82276	82276	82277
19109	26413	2	applied	\N	\N	\N	\N	82278	82278	75338
19112	26419	0	applied	\N	\N	\N	\N	82292	82292	82293
19117	26426	0	applied	\N	\N	\N	\N	82310	82310	82311
19117	26427	1	applied	\N	\N	\N	\N	82312	82312	82313
19119	26426	0	applied	\N	\N	\N	\N	82310	82310	82311
19119	26427	1	applied	\N	\N	\N	\N	82312	82312	82313
19126	26434	0	applied	\N	\N	\N	\N	82357	82357	82358
19126	26435	1	applied	\N	\N	\N	\N	82359	82359	82360
19128	26434	0	applied	\N	\N	\N	\N	82357	82357	82358
19128	26435	1	applied	\N	\N	\N	\N	82359	82359	82360
19133	26442	0	applied	\N	\N	\N	\N	82408	82408	82409
19133	26443	1	applied	\N	\N	\N	\N	82410	82410	82411
19133	26444	2	applied	\N	\N	\N	\N	82412	82412	82413
19133	26445	3	applied	\N	\N	\N	\N	82414	82414	82415
19133	26446	4	applied	\N	\N	\N	\N	82416	82416	82417
19133	26447	5	applied	\N	\N	\N	\N	82418	82418	82419
19151	26510	0	applied	\N	\N	\N	\N	82573	82573	82574
19151	26511	2	applied	\N	\N	\N	\N	82576	82576	82577
19151	26512	3	applied	\N	\N	\N	\N	82578	82578	82579
19151	26513	4	applied	\N	\N	\N	\N	82580	82580	82581
19158	26518	0	applied	\N	\N	\N	\N	82600	82600	82601
19158	26519	1	applied	\N	\N	\N	\N	82602	82602	82603
19158	26520	2	applied	\N	\N	\N	\N	82604	82604	82605
19161	26525	0	applied	\N	\N	\N	\N	82619	82619	82620
19161	26526	1	applied	\N	\N	\N	\N	82621	82621	82622
19161	26531	2	applied	\N	\N	\N	\N	82631	82631	82626
19161	26527	3	applied	\N	\N	\N	\N	82623	82623	82628
19161	26532	4	applied	\N	\N	\N	\N	82632	82632	82633
19161	26528	5	applied	\N	\N	\N	\N	82625	82625	82634
19161	26529	6	applied	\N	\N	\N	\N	82627	82627	82635
19161	26530	7	applied	\N	\N	\N	\N	82629	82629	82630
19163	26533	0	applied	\N	\N	\N	\N	82637	82637	82638
19163	26534	1	applied	\N	\N	\N	\N	82639	82639	82640
19163	26535	2	applied	\N	\N	\N	\N	82641	82641	82642
19167	26536	0	applied	\N	\N	\N	\N	82651	82651	82652
19167	26537	1	applied	\N	\N	\N	\N	82653	82653	82654
19167	26538	2	applied	\N	\N	\N	\N	82655	82655	82656
19167	26539	3	applied	\N	\N	\N	\N	82657	82657	82658
19167	26540	4	applied	\N	\N	\N	\N	82659	82659	82660
19167	26541	5	applied	\N	\N	\N	\N	82661	82661	82662
19167	26542	6	applied	\N	\N	\N	\N	82663	82663	82664
19170	26553	0	applied	\N	\N	\N	\N	82691	82691	82692
19170	26554	1	applied	\N	\N	\N	\N	82693	82693	82694
19170	26555	2	applied	\N	\N	\N	\N	82695	82695	82696
19173	26559	0	applied	\N	\N	\N	\N	82709	82709	82710
19173	26560	1	applied	\N	\N	\N	\N	82711	82711	82712
19173	26561	2	applied	\N	\N	\N	\N	82713	82713	82714
19173	26562	3	applied	\N	\N	\N	\N	82715	82715	82716
19173	26563	4	applied	\N	\N	\N	\N	82717	82717	82718
19173	26564	5	applied	\N	\N	\N	\N	82719	82719	82720
19173	26565	6	applied	\N	\N	\N	\N	82721	82721	82722
19173	26566	7	applied	\N	\N	\N	\N	82723	82723	82724
19173	26567	8	applied	\N	\N	\N	\N	82725	82725	82726
19173	26568	9	applied	\N	\N	\N	\N	82727	82727	82728
19173	26569	10	applied	\N	\N	\N	\N	82729	82729	82730
19173	26570	11	applied	\N	\N	\N	\N	82731	82731	82732
19173	26571	12	applied	\N	\N	\N	\N	82733	82733	82734
19173	26572	13	applied	\N	\N	\N	\N	82735	82735	82736
19176	26577	0	applied	\N	\N	\N	\N	82748	82748	82749
19176	26578	1	applied	\N	\N	\N	\N	82750	82750	82751
19176	26579	2	applied	\N	\N	\N	\N	82752	82752	82753
19183	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19183	26589	1	applied	\N	\N	\N	\N	82794	82794	82795
19183	26590	2	applied	\N	\N	\N	\N	82796	82796	82797
19183	26591	3	applied	\N	\N	\N	\N	82798	82798	82799
19197	26622	0	applied	\N	\N	\N	\N	82886	82886	82887
19197	26623	1	applied	\N	\N	\N	\N	82888	82888	82889
19197	26624	2	applied	\N	\N	\N	\N	82890	82890	82891
19197	26625	3	applied	\N	\N	\N	\N	82892	82892	82893
19197	26626	4	applied	\N	\N	\N	\N	82894	82894	82895
19197	26627	5	applied	\N	\N	\N	\N	82896	82896	82897
19197	26628	6	applied	\N	\N	\N	\N	82898	82898	82899
19208	26662	0	applied	\N	\N	\N	\N	82992	82992	82993
19208	26663	1	applied	\N	\N	\N	\N	82994	82994	82995
19208	26664	2	applied	\N	\N	\N	\N	82996	82996	82997
19210	26665	0	applied	\N	\N	\N	\N	83000	83000	83001
19210	26666	1	applied	\N	\N	\N	\N	83002	83002	83003
19210	26667	2	applied	\N	\N	\N	\N	83004	83004	83005
19210	26668	3	applied	\N	\N	\N	\N	83006	83006	83007
19214	26672	0	applied	\N	\N	\N	\N	83019	83019	83020
19214	26673	1	applied	\N	\N	\N	\N	83021	83021	83022
19214	26674	2	applied	\N	\N	\N	\N	83023	83023	83024
19214	26675	3	applied	\N	\N	\N	\N	83025	83025	83026
19214	26676	4	applied	\N	\N	\N	\N	83027	83027	83028
19214	26677	5	applied	\N	\N	\N	\N	83029	83029	83030
19214	26678	6	applied	\N	\N	\N	\N	83031	83031	83032
19214	26679	7	applied	\N	\N	\N	\N	83033	83033	83034
19214	26680	8	applied	\N	\N	\N	\N	83035	83035	83036
19214	26681	9	applied	\N	\N	\N	\N	83037	83037	83038
19214	26682	10	applied	\N	\N	\N	\N	83039	83039	83040
19214	26683	11	applied	\N	\N	\N	\N	83041	83041	83042
19214	26684	12	applied	\N	\N	\N	\N	83043	83043	83044
19108	26409	4	applied	\N	\N	\N	\N	82267	82267	82268
19108	26410	5	applied	\N	\N	\N	\N	82269	82269	82270
19116	26420	0	applied	\N	\N	\N	\N	82296	82296	82297
19116	26421	1	applied	\N	\N	\N	\N	82298	82298	82299
19116	26422	2	applied	\N	\N	\N	\N	82300	82300	82301
19116	26423	3	applied	\N	\N	\N	\N	82302	82302	82303
19116	26424	4	applied	\N	\N	\N	\N	82304	82304	82305
19116	26425	5	applied	\N	\N	\N	\N	82306	82306	82307
19121	26322	0	applied	\N	\N	1000000000	\N	82321	82321	82035
19121	26209	1	applied	\N	\N	1000000000	\N	81663	81663	81664
19121	26264	2	applied	\N	\N	\N	\N	82322	82322	81867
19121	26324	3	applied	\N	\N	1000000000	\N	82323	82323	82039
19121	26325	4	applied	\N	\N	1000000000	\N	82324	82324	82041
19121	26326	5	applied	\N	\N	1000000000	\N	82325	82325	82043
19121	26216	6	applied	\N	\N	\N	\N	82326	82326	82327
19121	26327	7	applied	\N	\N	1000000000	\N	82328	82328	82045
19121	26328	8	applied	\N	\N	1000000000	\N	82329	82329	82047
19121	26329	9	applied	\N	\N	1000000000	\N	82330	82330	82049
19121	26330	10	applied	\N	\N	1000000000	\N	82331	82331	82051
19121	26363	11	applied	\N	\N	1000000000	\N	82332	82332	82150
19121	26364	12	applied	\N	\N	\N	\N	82333	82333	82152
19121	26260	13	applied	\N	\N	\N	\N	81847	81847	81848
19121	26267	14	applied	\N	\N	\N	\N	81875	81875	79274
19121	26198	15	applied	\N	\N	\N	\N	81624	81624	81625
19121	26372	16	applied	\N	\N	\N	\N	82167	82167	81658
19121	26297	17	applied	\N	\N	\N	\N	81960	81960	81961
19121	26373	18	applied	\N	\N	\N	\N	82168	82168	81712
19121	26378	19	applied	\N	\N	\N	\N	82184	82184	81752
19121	26381	20	applied	\N	\N	\N	\N	82193	82193	81779
19121	26384	21	applied	\N	\N	\N	\N	82206	82206	81819
19121	26389	22	applied	\N	\N	\N	\N	82218	82218	81857
19121	26390	23	applied	\N	\N	\N	\N	82220	82220	81896
19121	26391	24	applied	\N	\N	\N	\N	82229	82229	81911
19121	26395	25	applied	\N	\N	\N	\N	82239	82239	81941
19121	26401	26	applied	\N	\N	\N	\N	82250	82250	81973
19121	26402	28	applied	\N	\N	\N	\N	82252	82252	81994
19130	26322	0	applied	\N	\N	1000000000	\N	82034	82034	82035
19130	26324	1	applied	\N	\N	1000000000	\N	82038	82038	82039
19130	26325	2	applied	\N	\N	1000000000	\N	82040	82040	82041
19130	26326	3	applied	\N	\N	1000000000	\N	82042	82042	82043
19130	26327	4	applied	\N	\N	1000000000	\N	82044	82044	82045
19130	26328	5	applied	\N	\N	1000000000	\N	82046	82046	82047
19130	26329	6	applied	\N	\N	1000000000	\N	82048	82048	82049
19130	26330	7	applied	\N	\N	1000000000	\N	82050	82050	82051
19130	26363	8	applied	\N	\N	1000000000	\N	82149	82149	82150
19130	26364	9	applied	\N	\N	\N	\N	82151	82151	82152
19130	26361	10	applied	\N	\N	1000000000	\N	82137	82137	82138
19130	26436	11	applied	\N	\N	1000000000	\N	82368	82368	82369
19130	26372	12	applied	\N	\N	\N	\N	82167	82167	81901
19130	26437	13	applied	\N	\N	\N	\N	82370	82370	82371
19130	26297	14	applied	\N	\N	\N	\N	81960	81960	81961
19130	26373	15	applied	\N	\N	\N	\N	82168	82168	81941
19130	26378	16	applied	\N	\N	\N	\N	82184	82184	81973
19130	26381	17	applied	\N	\N	\N	\N	82193	82193	81994
19130	26384	18	applied	\N	\N	\N	\N	82206	82206	82022
19130	26389	19	applied	\N	\N	\N	\N	82218	82218	82064
19130	26390	20	applied	\N	\N	\N	\N	82220	82220	82100
19130	26391	21	applied	\N	\N	\N	\N	82229	82229	82136
19130	26395	22	applied	\N	\N	\N	\N	82239	82239	82372
19130	26401	23	applied	\N	\N	\N	\N	82250	82250	82170
19130	26402	24	applied	\N	\N	\N	\N	82252	82252	82172
19130	26410	25	applied	\N	\N	\N	\N	82269	82269	82373
19130	26375	26	applied	\N	\N	\N	\N	82175	82175	82374
19130	26377	27	applied	\N	\N	\N	\N	82182	82182	82375
19130	26380	28	applied	\N	\N	\N	\N	82191	82191	82376
19130	26383	29	applied	\N	\N	\N	\N	82204	82204	82194
19130	26387	30	applied	\N	\N	\N	\N	82214	82214	82205
19130	26388	31	applied	\N	\N	\N	\N	82216	82216	82377
19130	26392	32	applied	\N	\N	\N	\N	82231	82231	82378
19130	26396	33	applied	\N	\N	\N	\N	82241	82241	82379
19130	26403	34	applied	\N	\N	\N	\N	82254	82254	82221
19130	26404	35	applied	\N	\N	\N	\N	82256	82256	82380
19130	26408	36	applied	\N	\N	\N	\N	82265	82265	82381
19130	26409	37	applied	\N	\N	\N	\N	82267	82267	82382
19130	26412	38	applied	\N	\N	\N	\N	82276	82276	82251
19130	26416	39	applied	\N	\N	\N	\N	82283	82283	82383
19130	26418	40	applied	\N	\N	\N	\N	82288	82288	82384
19130	26419	41	applied	\N	\N	\N	\N	82292	82292	82385
19130	26423	42	applied	\N	\N	\N	\N	82302	82302	82386
19130	26424	43	applied	\N	\N	\N	\N	82304	82304	82387
19130	26425	44	applied	\N	\N	\N	\N	82306	82306	82388
19130	26427	45	applied	\N	\N	\N	\N	82312	82312	82389
19130	26430	46	applied	\N	\N	\N	\N	82341	82341	82390
19130	26431	47	applied	\N	\N	\N	\N	82343	82343	82391
19130	26433	48	applied	\N	\N	\N	\N	82351	82351	82392
19130	26435	49	applied	\N	\N	\N	\N	82359	82359	82393
19130	26438	50	applied	\N	\N	\N	\N	82394	82394	82395
19130	26439	51	applied	\N	\N	\N	\N	82396	82396	82397
19130	26413	52	applied	\N	\N	\N	\N	82278	82278	75338
19137	26464	0	applied	\N	\N	\N	\N	82460	82460	82461
19137	26465	1	applied	\N	\N	\N	\N	82462	82462	82463
19137	26466	2	applied	\N	\N	\N	\N	82464	82464	82465
19137	26467	3	applied	\N	\N	\N	\N	82466	82466	82467
19138	26464	0	applied	\N	\N	\N	\N	82460	82460	82461
19138	26466	1	applied	\N	\N	\N	\N	82464	82464	82469
19138	26467	2	applied	\N	\N	\N	\N	82466	82466	82463
19139	26464	0	applied	\N	\N	\N	\N	82460	82460	82461
19139	26465	1	applied	\N	\N	\N	\N	82462	82462	82463
19139	26466	2	applied	\N	\N	\N	\N	82464	82464	82465
19139	26467	3	applied	\N	\N	\N	\N	82466	82466	82467
19140	26468	0	applied	\N	\N	\N	\N	82472	82472	82473
19140	26469	1	applied	\N	\N	\N	\N	82474	82474	82475
19140	26470	2	applied	\N	\N	\N	\N	82476	82476	82477
19141	26468	0	applied	\N	\N	\N	\N	82472	82472	82473
19141	26469	1	applied	\N	\N	\N	\N	82474	82474	82475
19141	26470	2	applied	\N	\N	\N	\N	82476	82476	82477
19142	26471	0	applied	\N	\N	\N	\N	82481	82481	82482
19142	26472	1	applied	\N	\N	\N	\N	82483	82483	82484
19142	26473	2	applied	\N	\N	\N	\N	82485	82485	82486
19142	26474	3	applied	\N	\N	\N	\N	82487	82487	82488
19142	26475	4	applied	\N	\N	\N	\N	82489	82489	82490
19142	26476	5	applied	\N	\N	\N	\N	82491	82491	82492
19142	26477	6	applied	\N	\N	\N	\N	82493	82493	82494
19143	26471	0	applied	\N	\N	\N	\N	82481	82481	82482
19143	26472	1	applied	\N	\N	\N	\N	82483	82483	82484
19143	26473	2	applied	\N	\N	\N	\N	82485	82485	82486
19143	26474	3	applied	\N	\N	\N	\N	82487	82487	82488
19134	26453	5	applied	\N	\N	\N	\N	82432	82432	82433
19134	26454	6	applied	\N	\N	\N	\N	82434	82434	82435
19134	26455	7	applied	\N	\N	\N	\N	82436	82436	82437
19134	26456	8	applied	\N	\N	\N	\N	82438	82438	82439
19134	26457	9	applied	\N	\N	\N	\N	82440	82440	82441
19148	26487	0	applied	\N	\N	\N	\N	82522	82522	82523
19148	26488	1	applied	\N	\N	\N	\N	82524	82524	82525
19148	26489	2	applied	\N	\N	\N	\N	82526	82526	82527
19148	26490	3	applied	\N	\N	\N	\N	82528	82528	82529
19152	26510	0	applied	\N	\N	\N	\N	82573	82573	82574
19152	26511	2	applied	\N	\N	\N	\N	82576	82576	82577
19152	26512	3	applied	\N	\N	\N	\N	82578	82578	82579
19152	26513	4	applied	\N	\N	\N	\N	82580	82580	82581
19155	26510	0	applied	\N	\N	\N	\N	82573	82573	82574
19155	26511	2	applied	\N	\N	\N	\N	82576	82576	82577
19155	26512	3	applied	\N	\N	\N	\N	82578	82578	82579
19155	26513	4	applied	\N	\N	\N	\N	82580	82580	82581
19156	26514	0	applied	\N	\N	\N	\N	82590	82590	82591
19156	26515	1	applied	\N	\N	\N	\N	82592	82592	82593
19156	26516	2	applied	\N	\N	\N	\N	82594	82594	82595
19156	26517	3	applied	\N	\N	\N	\N	82596	82596	82597
19164	26533	0	applied	\N	\N	\N	\N	82637	82637	82638
19164	26534	1	applied	\N	\N	\N	\N	82639	82639	82640
19164	26535	2	applied	\N	\N	\N	\N	82641	82641	82642
19165	26533	0	applied	\N	\N	\N	\N	82637	82637	82638
19165	26534	1	applied	\N	\N	\N	\N	82639	82639	82640
19165	26535	2	applied	\N	\N	\N	\N	82641	82641	82642
19168	26543	0	applied	\N	\N	\N	\N	82669	82669	82670
19168	26544	1	applied	\N	\N	\N	\N	82671	82671	82672
19168	26545	2	applied	\N	\N	\N	\N	82673	82673	82674
19168	26546	3	applied	\N	\N	\N	\N	82675	82675	82676
19168	26547	4	applied	\N	\N	\N	\N	82677	82677	82678
19168	26548	5	applied	\N	\N	\N	\N	82679	82679	82680
19168	26549	6	applied	\N	\N	\N	\N	82681	82681	82682
19171	26553	0	applied	\N	\N	\N	\N	82691	82691	82692
19171	26554	1	applied	\N	\N	\N	\N	82693	82693	82694
19171	26555	2	applied	\N	\N	\N	\N	82695	82695	82696
19174	26573	0	applied	\N	\N	\N	\N	82738	82738	82739
19174	26574	1	applied	\N	\N	\N	\N	82740	82740	82741
19174	26575	2	applied	\N	\N	\N	\N	82742	82742	82743
19174	26576	3	applied	\N	\N	\N	\N	82744	82744	82745
19181	26583	0	applied	\N	\N	\N	\N	82768	82768	82769
19181	26584	1	applied	\N	\N	\N	\N	82770	82770	82771
19181	26585	2	applied	\N	\N	\N	\N	82772	82772	82773
19181	26586	3	applied	\N	\N	\N	\N	82774	82774	82775
19181	26587	4	applied	\N	\N	\N	\N	82776	82776	82777
19185	26592	0	applied	\N	\N	\N	\N	82803	82803	82804
19185	26593	1	applied	\N	\N	\N	\N	82805	82805	82806
19188	26603	0	applied	\N	\N	\N	\N	82834	82834	82835
19188	26604	1	applied	\N	\N	\N	\N	82836	82836	82837
19188	26605	2	applied	\N	\N	\N	\N	82838	82838	82839
19190	26606	0	applied	\N	\N	\N	\N	82843	82843	82844
19190	26607	1	applied	\N	\N	\N	\N	82845	82845	82846
19190	26608	2	applied	\N	\N	\N	\N	82847	82847	82848
19193	26616	0	applied	\N	\N	\N	\N	82868	82868	82869
19193	26617	1	applied	\N	\N	\N	\N	82870	82870	82871
19193	26618	2	applied	\N	\N	\N	\N	82872	82872	82873
19195	26616	0	applied	\N	\N	\N	\N	82868	82868	82869
19195	26617	1	applied	\N	\N	\N	\N	82870	82870	82871
19195	26618	2	applied	\N	\N	\N	\N	82872	82872	82873
19198	26622	0	applied	\N	\N	\N	\N	82886	82886	82887
19198	26623	1	applied	\N	\N	\N	\N	82888	82888	82889
19198	26624	2	applied	\N	\N	\N	\N	82890	82890	82891
19198	26625	3	applied	\N	\N	\N	\N	82892	82892	82893
19198	26626	4	applied	\N	\N	\N	\N	82894	82894	82895
19198	26627	5	applied	\N	\N	\N	\N	82896	82896	82897
19198	26628	6	applied	\N	\N	\N	\N	82898	82898	82899
19202	26629	0	applied	\N	\N	\N	\N	82912	82912	82913
19202	26630	1	applied	\N	\N	\N	\N	82914	82914	82915
19202	26633	2	applied	\N	\N	\N	\N	82920	82920	82928
19202	26634	3	applied	\N	\N	\N	\N	82922	82922	82929
19202	26635	4	applied	\N	\N	\N	\N	82924	82924	82921
19206	26659	0	applied	\N	\N	\N	\N	82982	82982	82983
19206	26660	1	applied	\N	\N	\N	\N	82984	82984	82985
19206	26661	2	applied	\N	\N	\N	\N	82986	82986	82987
19211	26665	0	applied	\N	\N	\N	\N	83000	83000	83001
19211	26666	1	applied	\N	\N	\N	\N	83002	83002	83003
19211	26667	2	applied	\N	\N	\N	\N	83004	83004	83005
19211	26668	3	applied	\N	\N	\N	\N	83006	83006	83007
19213	26669	0	applied	\N	\N	\N	\N	83012	83012	83013
19213	26670	1	applied	\N	\N	\N	\N	83014	83014	83015
19213	26671	2	applied	\N	\N	\N	\N	83016	83016	83017
19215	26672	0	applied	\N	\N	\N	\N	83019	83019	83020
19215	26673	1	applied	\N	\N	\N	\N	83021	83021	83022
19215	26674	2	applied	\N	\N	\N	\N	83023	83023	83024
19215	26675	3	applied	\N	\N	\N	\N	83025	83025	83026
19215	26676	4	applied	\N	\N	\N	\N	83027	83027	83028
19215	26677	5	applied	\N	\N	\N	\N	83029	83029	83030
19215	26679	6	applied	\N	\N	\N	\N	83033	83033	83061
19215	26680	7	applied	\N	\N	\N	\N	83035	83035	83062
19215	26681	8	applied	\N	\N	\N	\N	83037	83037	83063
19215	26682	9	applied	\N	\N	\N	\N	83039	83039	83064
19215	26684	10	applied	\N	\N	\N	\N	83043	83043	83065
19215	26685	11	applied	\N	\N	\N	\N	83045	83045	83066
19215	26686	12	applied	\N	\N	\N	\N	83047	83047	83067
19215	26687	13	applied	\N	\N	\N	\N	83049	83049	83068
19223	26702	0	applied	\N	\N	\N	\N	83101	83101	83102
19223	26703	1	applied	\N	\N	\N	\N	83103	83103	83104
19223	26706	2	applied	\N	\N	\N	\N	83111	83111	83112
19223	26704	3	applied	\N	\N	\N	\N	83105	83105	83113
19223	26705	4	applied	\N	\N	\N	\N	83107	83107	83114
19223	26707	5	applied	\N	\N	\N	\N	83115	83115	83116
19226	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19226	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19226	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19226	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19226	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19233	26713	0	applied	\N	\N	\N	\N	83140	83140	83141
19233	26714	1	applied	\N	\N	\N	\N	83142	83142	83143
19233	26715	2	applied	\N	\N	\N	\N	83144	83144	83145
19236	26716	0	applied	\N	\N	\N	\N	83147	83147	83148
19236	26717	1	applied	\N	\N	\N	\N	83149	83149	83150
19236	26718	2	applied	\N	\N	\N	\N	83151	83151	83152
19240	26719	0	applied	\N	\N	\N	\N	83159	83159	83160
19240	26720	1	applied	\N	\N	\N	\N	83161	83161	83162
19240	26721	2	applied	\N	\N	\N	\N	83163	83163	83164
19248	26738	0	applied	\N	\N	1000000000	\N	83210	83210	83211
19248	26739	1	applied	\N	\N	\N	\N	83212	83212	83213
19248	26740	2	applied	\N	\N	\N	\N	83214	83214	83215
19143	26475	4	applied	\N	\N	\N	\N	82489	82489	82490
19145	26478	0	applied	\N	\N	\N	\N	82497	82497	82498
19145	26479	1	applied	\N	\N	\N	\N	82499	82499	82500
19145	26480	2	applied	\N	\N	\N	\N	82501	82501	82502
19147	26484	0	applied	\N	\N	\N	\N	82514	82514	82515
19147	26485	1	applied	\N	\N	\N	\N	82516	82516	82517
19147	26486	2	applied	\N	\N	\N	\N	82518	82518	82519
19154	26510	0	applied	\N	\N	\N	\N	82573	82573	82574
19154	26511	2	applied	\N	\N	\N	\N	82576	82576	82577
19154	26512	3	applied	\N	\N	\N	\N	82578	82578	82579
19154	26513	4	applied	\N	\N	\N	\N	82580	82580	82581
19157	26518	0	applied	\N	\N	\N	\N	82600	82600	82601
19157	26519	1	applied	\N	\N	\N	\N	82602	82602	82603
19157	26520	2	applied	\N	\N	\N	\N	82604	82604	82605
19160	26525	0	applied	\N	\N	\N	\N	82619	82619	82620
19160	26526	1	applied	\N	\N	\N	\N	82621	82621	82622
19160	26527	2	applied	\N	\N	\N	\N	82623	82623	82624
19160	26528	3	applied	\N	\N	\N	\N	82625	82625	82626
19160	26529	4	applied	\N	\N	\N	\N	82627	82627	82628
19160	26530	5	applied	\N	\N	\N	\N	82629	82629	82630
19162	26533	0	applied	\N	\N	\N	\N	82637	82637	82638
19162	26534	1	applied	\N	\N	\N	\N	82639	82639	82640
19162	26535	2	applied	\N	\N	\N	\N	82641	82641	82642
19172	26556	0	applied	\N	\N	\N	\N	82701	82701	82702
19172	26557	1	applied	\N	\N	\N	\N	82703	82703	82704
19172	26558	2	applied	\N	\N	\N	\N	82705	82705	82706
19175	26577	0	applied	\N	\N	\N	\N	82748	82748	82749
19175	26578	1	applied	\N	\N	\N	\N	82750	82750	82751
19175	26579	2	applied	\N	\N	\N	\N	82752	82752	82753
19178	26580	0	applied	\N	\N	\N	\N	82758	82758	82759
19178	26581	1	applied	\N	\N	\N	\N	82760	82760	82761
19178	26582	2	applied	\N	\N	\N	\N	82762	82762	82763
19180	26322	0	applied	\N	\N	1000000000	\N	82034	82034	82035
19180	26311	1	applied	\N	\N	\N	\N	82002	82002	82003
19180	26312	2	applied	\N	\N	\N	\N	82004	82004	82005
19180	26314	3	applied	\N	\N	\N	\N	82011	82011	82012
19180	26560	4	applied	\N	\N	\N	\N	82711	82711	82712
19180	26561	5	applied	\N	\N	\N	\N	82713	82713	82714
19180	26562	6	applied	\N	\N	\N	\N	82715	82715	82716
19180	26565	7	applied	\N	\N	\N	\N	82721	82721	82722
19180	26584	8	applied	\N	\N	\N	\N	82770	82770	82771
19180	26324	9	applied	\N	\N	1000000000	\N	82038	82038	82039
19180	26325	10	applied	\N	\N	1000000000	\N	82040	82040	82041
19180	26326	11	applied	\N	\N	1000000000	\N	82042	82042	82043
19180	26315	12	applied	\N	\N	\N	\N	82013	82013	82014
19180	26316	13	applied	\N	\N	\N	\N	82015	82015	82016
19180	26317	14	applied	\N	\N	\N	\N	82017	82017	82018
19180	26318	15	applied	\N	\N	\N	\N	82019	82019	82020
19180	26320	16	applied	\N	\N	\N	\N	82024	82024	82025
19180	26323	17	applied	\N	\N	\N	\N	82036	82036	82037
19180	26332	18	applied	\N	\N	\N	\N	82057	82057	82058
19180	26333	19	applied	\N	\N	\N	\N	82060	82060	82061
19180	26338	20	applied	\N	\N	\N	\N	82069	82069	82070
19180	26339	21	applied	\N	\N	\N	\N	82075	82075	82076
19180	26340	22	applied	\N	\N	\N	\N	82080	82080	82081
19180	26341	23	applied	\N	\N	\N	\N	82082	82082	82083
19180	26343	24	applied	\N	\N	\N	\N	82090	82090	82091
19180	26344	25	applied	\N	\N	\N	\N	82093	82093	82094
19180	26345	26	applied	\N	\N	\N	\N	82097	82097	82098
19180	26347	27	applied	\N	\N	\N	\N	82105	82105	82106
19180	26348	28	applied	\N	\N	\N	\N	82109	82109	82110
19180	26349	29	applied	\N	\N	\N	\N	82113	82113	82114
19180	26352	30	applied	\N	\N	\N	\N	82120	82120	82121
19180	26353	31	applied	\N	\N	\N	\N	82122	82122	82123
19180	26354	32	applied	\N	\N	\N	\N	82126	82126	82127
19180	26355	33	applied	\N	\N	\N	\N	82128	82128	82129
19180	26356	34	applied	\N	\N	\N	\N	82130	82130	82131
19180	26362	35	applied	\N	\N	\N	\N	82143	82143	82144
19180	26365	36	applied	\N	\N	\N	\N	82153	82153	82154
19180	26366	37	applied	\N	\N	\N	\N	82155	82155	82156
19180	26367	38	applied	\N	\N	\N	\N	82157	82157	82158
19180	26370	39	applied	\N	\N	\N	\N	82163	82163	82164
19180	26371	40	applied	\N	\N	\N	\N	82165	82165	82166
19180	26376	41	applied	\N	\N	\N	\N	82180	82180	82181
19180	26379	42	applied	\N	\N	\N	\N	82189	82189	82190
19180	26382	43	applied	\N	\N	\N	\N	82202	82202	82203
19180	26385	44	applied	\N	\N	\N	\N	82210	82210	82211
19180	26386	45	applied	\N	\N	\N	\N	82212	82212	82213
19180	26393	46	applied	\N	\N	\N	\N	82235	82235	82236
19180	26394	48	applied	\N	\N	\N	\N	82237	82237	82238
19180	26398	49	applied	\N	\N	\N	\N	82245	82245	82246
19180	26400	50	applied	\N	\N	\N	\N	82248	82248	82249
19180	26405	51	applied	\N	\N	\N	\N	82260	82260	82261
19180	26406	52	applied	\N	\N	\N	\N	82262	82262	82263
19180	26411	53	applied	\N	\N	\N	\N	82274	82274	82275
19180	26415	54	applied	\N	\N	\N	\N	82281	82281	82282
19180	26417	55	applied	\N	\N	\N	\N	82286	82286	82287
19180	26420	56	applied	\N	\N	\N	\N	82296	82296	82297
19180	26421	57	applied	\N	\N	\N	\N	82298	82298	82299
19180	26422	58	applied	\N	\N	\N	\N	82300	82300	82301
19180	26426	59	applied	\N	\N	\N	\N	82310	82310	82311
19180	26428	60	applied	\N	\N	\N	\N	82337	82337	82338
19180	26429	61	applied	\N	\N	\N	\N	82339	82339	82340
19180	26432	62	applied	\N	\N	\N	\N	82349	82349	82350
19180	26434	63	applied	\N	\N	\N	\N	82357	82357	82358
19180	26440	64	applied	\N	\N	\N	\N	82399	82399	82400
19180	26441	65	applied	\N	\N	\N	\N	82401	82401	82402
19180	26442	66	applied	\N	\N	\N	\N	82408	82408	82409
19180	26443	67	applied	\N	\N	\N	\N	82410	82410	82411
19180	26448	68	applied	\N	\N	\N	\N	82422	82422	82423
19180	26449	69	applied	\N	\N	\N	\N	82424	82424	82425
19180	26450	70	applied	\N	\N	\N	\N	82426	82426	82427
19180	26458	71	applied	\N	\N	\N	\N	82444	82444	82445
19180	26461	72	applied	\N	\N	\N	\N	82452	82452	82453
19180	26464	73	applied	\N	\N	\N	\N	82460	82460	82461
19180	26468	74	applied	\N	\N	\N	\N	82472	82472	82473
19180	26471	75	applied	\N	\N	\N	\N	82481	82481	82482
19180	26472	76	applied	\N	\N	\N	\N	82483	82483	82484
19180	26478	77	applied	\N	\N	\N	\N	82497	82497	82498
19180	26481	78	applied	\N	\N	\N	\N	82507	82507	82508
19180	26484	79	applied	\N	\N	\N	\N	82514	82514	82515
19180	26487	80	applied	\N	\N	\N	\N	82522	82522	82523
19180	26491	81	applied	\N	\N	\N	\N	82533	82533	82534
19180	26492	82	applied	\N	\N	\N	\N	82535	82535	82536
19180	26493	83	applied	\N	\N	\N	\N	82537	82537	82538
19180	26494	84	applied	\N	\N	\N	\N	82539	82539	82540
19180	26495	85	applied	\N	\N	\N	\N	82541	82541	82542
19180	26327	86	applied	\N	\N	1000000000	\N	82044	82044	82045
19180	26328	87	applied	\N	\N	1000000000	\N	82046	82046	82047
19180	26329	88	applied	\N	\N	1000000000	\N	82048	82048	82049
19180	26330	89	applied	\N	\N	1000000000	\N	82050	82050	82051
19180	26363	90	applied	\N	\N	1000000000	\N	82149	82149	82150
19180	26364	91	applied	\N	\N	\N	\N	82151	82151	82152
19180	26510	92	applied	\N	\N	\N	\N	82573	82573	82574
19180	26514	93	applied	\N	\N	\N	\N	82590	82590	82591
19180	26518	94	applied	\N	\N	\N	\N	82600	82600	82601
19180	26521	95	applied	\N	\N	\N	\N	82610	82610	82611
19180	26525	96	applied	\N	\N	\N	\N	82619	82619	82620
19180	26526	97	applied	\N	\N	\N	\N	82621	82621	82622
19180	26533	98	applied	\N	\N	\N	\N	82637	82637	82638
19180	26536	99	applied	\N	\N	\N	\N	82651	82651	82652
19180	26537	100	applied	\N	\N	\N	\N	82653	82653	82654
19180	26543	101	applied	\N	\N	\N	\N	82669	82669	82670
19180	26544	102	applied	\N	\N	\N	\N	82671	82671	82672
19180	26550	103	applied	\N	\N	\N	\N	82685	82685	82686
19180	26553	104	applied	\N	\N	\N	\N	82691	82691	82692
19180	26556	105	applied	\N	\N	\N	\N	82701	82701	82781
19180	26559	106	applied	\N	\N	\N	\N	82709	82709	82782
19180	26563	107	applied	\N	\N	\N	\N	82717	82717	82783
19180	26564	108	applied	\N	\N	\N	\N	82719	82719	82784
19180	26573	109	applied	\N	\N	\N	\N	82738	82738	82785
19180	26577	110	applied	\N	\N	\N	\N	82748	82748	82786
19180	26580	111	applied	\N	\N	\N	\N	82758	82758	82787
19180	26583	112	applied	\N	\N	\N	\N	82768	82768	82788
19180	26331	113	applied	\N	\N	\N	\N	82052	82052	33908
19180	26361	114	applied	\N	\N	1000000000	\N	82137	82137	82138
19180	26436	115	applied	\N	\N	1000000000	\N	82368	82368	82369
19180	26372	116	applied	\N	\N	\N	\N	82167	82167	82022
19180	26497	117	applied	\N	\N	\N	\N	82545	82545	82546
19180	26437	118	applied	\N	\N	\N	\N	82370	82370	82371
19180	26498	119	applied	\N	\N	\N	\N	82547	82547	82548
19180	26499	120	applied	\N	\N	\N	\N	82549	82549	82550
19180	26515	121	applied	\N	\N	\N	\N	82592	82592	82593
19180	26373	122	applied	\N	\N	\N	\N	82168	82168	82085
19180	26378	123	applied	\N	\N	\N	\N	82184	82184	82116
19180	26313	124	applied	\N	\N	\N	\N	82006	82006	82136
19180	26381	125	applied	\N	\N	\N	\N	82193	82193	82372
19182	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19182	26589	1	applied	\N	\N	\N	\N	82794	82794	82795
19182	26590	2	applied	\N	\N	\N	\N	82796	82796	82797
19182	26591	3	applied	\N	\N	\N	\N	82798	82798	82799
19184	26592	0	applied	\N	\N	\N	\N	82803	82803	82804
19184	26593	1	applied	\N	\N	\N	\N	82805	82805	82806
19184	26594	2	applied	\N	\N	\N	\N	82807	82807	82808
19187	26595	0	applied	\N	\N	\N	\N	82812	82812	82812
19187	26596	1	applied	\N	\N	\N	\N	82813	82813	82814
19187	26597	2	applied	\N	\N	\N	\N	82815	82815	82816
19187	26598	3	applied	\N	\N	\N	\N	82817	82817	82818
19187	26599	4	applied	\N	\N	\N	\N	82819	82819	82820
19187	26594	5	applied	\N	\N	\N	\N	82807	82807	82821
19187	26600	6	applied	\N	\N	\N	\N	82822	82822	82823
19187	26601	7	applied	\N	\N	\N	\N	82824	82824	82825
19187	26602	9	applied	\N	\N	\N	\N	82827	82827	82828
19192	26609	0	applied	\N	\N	\N	\N	82851	82851	82852
19192	26610	1	applied	\N	\N	\N	\N	82853	82853	82854
19192	26611	2	applied	\N	\N	\N	\N	82855	82855	82856
19192	26612	3	applied	\N	\N	\N	\N	82857	82857	82858
19192	26613	4	applied	\N	\N	\N	\N	82859	82859	82860
19192	26614	5	applied	\N	\N	\N	\N	82861	82861	82862
19192	26615	6	applied	\N	\N	\N	\N	82863	82863	82864
19196	26619	0	applied	\N	\N	\N	\N	82880	82880	82881
19196	26620	1	applied	\N	\N	\N	\N	82882	82882	82883
19196	26621	2	applied	\N	\N	\N	\N	82884	82884	82885
19200	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19200	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19200	26322	2	applied	\N	\N	1000000000	\N	82321	82321	82035
19200	26209	3	applied	\N	\N	1000000000	\N	81663	81663	81664
19200	26061	4	applied	\N	\N	\N	\N	81148	81148	81149
19200	26063	5	applied	\N	\N	\N	\N	81153	81153	81154
19200	26264	6	applied	\N	\N	\N	\N	82322	82322	81867
19200	26560	7	applied	\N	\N	\N	\N	82905	82905	82712
19200	26561	8	applied	\N	\N	\N	\N	82906	82906	82714
19200	26562	9	applied	\N	\N	\N	\N	82907	82907	82716
19200	26565	10	applied	\N	\N	\N	\N	82908	82908	82722
19200	26065	11	applied	\N	\N	\N	\N	81159	81159	81160
19200	26066	12	applied	\N	\N	\N	\N	81161	81161	81162
19200	26070	13	applied	\N	\N	\N	\N	81171	81171	81172
19200	26324	14	applied	\N	\N	1000000000	\N	82323	82323	82039
19200	26325	15	applied	\N	\N	1000000000	\N	82324	82324	82041
19200	26326	16	applied	\N	\N	1000000000	\N	82325	82325	82043
19200	26072	17	applied	\N	\N	\N	\N	81177	81177	81178
19200	26074	18	applied	\N	\N	\N	\N	81182	81182	81183
19200	26077	19	applied	\N	\N	\N	\N	81192	81192	81193
19200	26079	20	applied	\N	\N	\N	\N	81199	81199	81200
19200	26080	21	applied	\N	\N	\N	\N	81201	81201	81202
19200	26081	22	applied	\N	\N	\N	\N	81203	81203	81204
19200	26084	23	applied	\N	\N	\N	\N	81213	81213	81214
19200	26085	24	applied	\N	\N	\N	\N	81217	81217	81218
19200	26086	25	applied	\N	\N	\N	\N	81223	81223	81224
19200	26088	26	applied	\N	\N	\N	\N	81229	81229	81230
19200	26089	27	applied	\N	\N	\N	\N	81235	81235	81236
19200	26090	28	applied	\N	\N	\N	\N	81238	81238	81239
19200	26092	29	applied	\N	\N	\N	\N	81246	81246	81247
19200	26093	30	applied	\N	\N	\N	\N	81249	81249	81250
19200	26094	31	applied	\N	\N	\N	\N	81258	81258	81259
19200	26095	32	applied	\N	\N	\N	\N	81260	81260	81261
19200	26097	33	applied	\N	\N	\N	\N	81266	81266	81267
19200	26098	34	applied	\N	\N	\N	\N	81270	81270	81271
19200	26099	35	applied	\N	\N	\N	\N	81273	81273	81274
19200	26101	36	applied	\N	\N	\N	\N	81279	81279	81280
19200	26102	37	applied	\N	\N	\N	\N	81282	81282	81283
19200	26103	38	applied	\N	\N	\N	\N	81288	81288	81289
19200	26104	39	applied	\N	\N	\N	\N	81290	81290	81291
19200	26216	40	applied	\N	\N	\N	\N	82326	82326	82327
19200	26106	41	applied	\N	\N	\N	\N	81296	81296	81297
19200	26107	42	applied	\N	\N	\N	\N	81302	81302	81303
19200	26109	43	applied	\N	\N	\N	\N	81308	81308	81309
19200	26110	44	applied	\N	\N	\N	\N	81310	81310	81311
19200	26111	45	applied	\N	\N	\N	\N	81313	81313	81314
19200	26112	46	applied	\N	\N	\N	\N	81315	81315	81316
19200	26114	47	applied	\N	\N	\N	\N	81320	81320	81321
19200	26115	48	applied	\N	\N	\N	\N	81324	81324	81325
19200	26116	49	applied	\N	\N	\N	\N	81326	81326	81327
19200	26118	50	applied	\N	\N	\N	\N	81333	81333	81334
19200	26119	51	applied	\N	\N	\N	\N	81337	81337	81338
19200	26120	52	applied	\N	\N	\N	\N	81341	81341	81342
19200	26122	53	applied	\N	\N	\N	\N	81347	81347	81348
19186	26600	6	applied	\N	\N	\N	\N	82822	82822	82823
19186	26601	7	applied	\N	\N	\N	\N	82824	82824	82825
19186	26602	9	applied	\N	\N	\N	\N	82827	82827	82828
19189	26603	0	applied	\N	\N	\N	\N	82834	82834	82835
19189	26604	1	applied	\N	\N	\N	\N	82836	82836	82837
19189	26605	2	applied	\N	\N	\N	\N	82838	82838	82839
19191	26609	0	applied	\N	\N	\N	\N	82851	82851	82852
19191	26610	1	applied	\N	\N	\N	\N	82853	82853	82854
19191	26611	2	applied	\N	\N	\N	\N	82855	82855	82856
19191	26612	3	applied	\N	\N	\N	\N	82857	82857	82858
19191	26613	4	applied	\N	\N	\N	\N	82859	82859	82860
19191	26614	5	applied	\N	\N	\N	\N	82861	82861	82862
19191	26615	6	applied	\N	\N	\N	\N	82863	82863	82864
19194	26616	0	applied	\N	\N	\N	\N	82868	82868	82869
19194	26617	1	applied	\N	\N	\N	\N	82870	82870	82871
19194	26618	2	applied	\N	\N	\N	\N	82872	82872	82873
19199	26622	0	applied	\N	\N	\N	\N	82886	82886	82887
19199	26623	1	applied	\N	\N	\N	\N	82888	82888	82889
19199	26624	2	applied	\N	\N	\N	\N	82890	82890	82891
19199	26625	3	applied	\N	\N	\N	\N	82892	82892	82893
19199	26626	4	applied	\N	\N	\N	\N	82894	82894	82895
19199	26627	5	applied	\N	\N	\N	\N	82896	82896	82897
19199	26628	6	applied	\N	\N	\N	\N	82898	82898	82899
19203	26636	0	applied	\N	\N	\N	\N	82931	82931	82932
19203	26637	1	applied	\N	\N	\N	\N	82933	82933	82934
19203	26638	2	applied	\N	\N	\N	\N	82935	82935	82936
19203	26639	3	applied	\N	\N	\N	\N	82937	82937	82938
19203	26640	4	applied	\N	\N	\N	\N	82939	82939	82940
19203	26641	5	applied	\N	\N	\N	\N	82941	82941	82942
19207	26659	0	applied	\N	\N	\N	\N	82982	82982	82983
19207	26661	1	applied	\N	\N	\N	\N	82986	82986	82990
19209	26662	0	applied	\N	\N	\N	\N	82992	82992	82993
19209	26663	1	applied	\N	\N	\N	\N	82994	82994	82995
19209	26664	2	applied	\N	\N	\N	\N	82996	82996	82997
19212	26665	0	applied	\N	\N	\N	\N	83000	83000	83001
19212	26666	1	applied	\N	\N	\N	\N	83002	83002	83003
19212	26668	2	applied	\N	\N	\N	\N	83006	83006	83011
19216	26672	0	applied	\N	\N	\N	\N	83019	83019	83020
19216	26673	1	applied	\N	\N	\N	\N	83021	83021	83022
19216	26674	2	applied	\N	\N	\N	\N	83023	83023	83024
19216	26675	3	applied	\N	\N	\N	\N	83025	83025	83026
19216	26676	4	applied	\N	\N	\N	\N	83027	83027	83028
19216	26677	5	applied	\N	\N	\N	\N	83029	83029	83030
19216	26678	6	applied	\N	\N	\N	\N	83031	83031	83032
19216	26679	7	applied	\N	\N	\N	\N	83033	83033	83034
19216	26680	8	applied	\N	\N	\N	\N	83035	83035	83036
19216	26681	9	applied	\N	\N	\N	\N	83037	83037	83038
19216	26682	10	applied	\N	\N	\N	\N	83039	83039	83040
19216	26683	11	applied	\N	\N	\N	\N	83041	83041	83042
19216	26684	12	applied	\N	\N	\N	\N	83043	83043	83044
19216	26685	13	applied	\N	\N	\N	\N	83045	83045	83046
19216	26686	14	applied	\N	\N	\N	\N	83047	83047	83048
19216	26687	15	applied	\N	\N	\N	\N	83049	83049	83050
19216	26688	16	applied	\N	\N	\N	\N	83051	83051	83052
19216	26689	17	applied	\N	\N	\N	\N	83053	83053	83054
19216	26690	18	applied	\N	\N	\N	\N	83055	83055	83056
19216	26691	19	applied	\N	\N	\N	\N	83057	83057	83058
19219	26692	0	applied	\N	\N	\N	\N	83072	83072	83073
19219	26693	1	applied	\N	\N	\N	\N	83074	83074	83075
19219	26694	2	applied	\N	\N	\N	\N	83076	83076	83077
19219	26695	3	applied	\N	\N	\N	\N	83078	83078	83079
19219	26696	4	applied	\N	\N	\N	\N	83080	83080	83081
19219	26697	5	applied	\N	\N	\N	\N	83082	83082	83083
19219	26698	6	applied	\N	\N	\N	\N	83084	83084	83085
19219	26699	8	applied	\N	\N	\N	\N	83087	83087	83088
19219	26700	9	applied	\N	\N	\N	\N	83089	83089	83090
19219	26701	10	applied	\N	\N	\N	\N	83091	83091	83092
19220	26692	0	applied	\N	\N	\N	\N	83072	83072	83073
19220	26693	1	applied	\N	\N	\N	\N	83074	83074	83075
19220	26694	2	applied	\N	\N	\N	\N	83076	83076	83077
19220	26695	3	applied	\N	\N	\N	\N	83078	83078	83079
19220	26696	4	applied	\N	\N	\N	\N	83080	83080	83081
19220	26697	5	applied	\N	\N	\N	\N	83082	83082	83083
19220	26698	6	applied	\N	\N	\N	\N	83084	83084	83085
19220	26699	8	applied	\N	\N	\N	\N	83087	83087	83088
19220	26700	9	applied	\N	\N	\N	\N	83089	83089	83090
19220	26701	10	applied	\N	\N	\N	\N	83091	83091	83092
19232	26712	0	applied	\N	\N	\N	\N	83127	83127	83138
19234	26713	0	applied	\N	\N	\N	\N	83140	83140	83141
19234	26714	1	applied	\N	\N	\N	\N	83142	83142	83143
19234	26715	2	applied	\N	\N	\N	\N	83144	83144	83145
19237	26716	0	applied	\N	\N	\N	\N	83147	83147	83148
19237	26717	1	applied	\N	\N	\N	\N	83149	83149	83150
19237	26718	2	applied	\N	\N	\N	\N	83151	83151	83152
19238	26717	0	applied	\N	\N	\N	\N	83149	83149	83150
19238	26718	1	applied	\N	\N	\N	\N	83151	83151	83152
19241	26719	0	applied	\N	\N	\N	\N	83159	83159	83160
19241	26720	1	applied	\N	\N	\N	\N	83161	83161	83162
19241	26721	2	applied	\N	\N	\N	\N	83163	83163	83164
19245	26734	0	applied	\N	\N	\N	\N	83200	83200	83201
19245	26735	1	applied	\N	\N	\N	\N	83202	83202	83203
19245	26736	2	applied	\N	\N	\N	\N	83204	83204	83205
19245	26737	3	applied	\N	\N	\N	\N	83206	83206	83207
19250	26748	0	applied	\N	\N	\N	\N	83234	83234	83235
19250	26749	1	applied	\N	\N	\N	\N	83236	83236	83237
19250	26750	2	applied	\N	\N	\N	\N	83238	83238	83239
19258	26762	0	applied	\N	\N	\N	\N	83303	83303	83304
19258	26763	1	applied	\N	\N	\N	\N	83305	83305	83306
19258	26764	2	applied	\N	\N	\N	\N	83307	83307	83308
19258	26765	3	applied	\N	\N	\N	\N	83309	83309	83310
19258	26766	4	applied	\N	\N	\N	\N	83311	83311	83312
19258	26767	5	applied	\N	\N	\N	\N	83313	83313	83314
19258	26768	6	applied	\N	\N	\N	\N	83315	83315	83316
19258	26769	7	applied	\N	\N	\N	\N	83317	83317	83318
19258	26770	8	applied	\N	\N	\N	\N	83319	83319	83320
19258	26771	9	applied	\N	\N	\N	\N	83321	83321	83322
19262	26772	0	applied	\N	\N	\N	\N	83331	83331	83332
19262	26773	1	applied	\N	\N	\N	\N	83333	83333	83334
19262	26774	2	applied	\N	\N	\N	\N	83335	83335	83336
19268	26785	0	applied	\N	\N	\N	\N	83362	83362	83363
19268	26786	1	applied	\N	\N	\N	\N	83367	83367	83370
19268	26787	2	applied	\N	\N	\N	\N	83371	83371	83372
19271	26788	0	applied	\N	\N	\N	\N	83379	83379	83380
19271	26789	1	applied	\N	\N	\N	\N	83381	83381	83382
19271	26790	2	applied	\N	\N	\N	\N	83383	83383	83384
19274	26795	0	applied	\N	\N	\N	\N	83394	83394	83395
19274	26796	1	applied	\N	\N	\N	\N	83396	83396	83397
19274	26797	2	applied	\N	\N	\N	\N	83398	83398	83399
19279	26802	0	applied	\N	\N	\N	\N	83413	83413	83414
19279	26803	1	applied	\N	\N	\N	\N	83415	83415	83416
19200	26123	54	applied	\N	\N	\N	\N	81358	81358	81359
19200	26124	55	applied	\N	\N	\N	\N	81360	81360	81361
19200	26125	56	applied	\N	\N	\N	\N	81364	81364	81365
19200	26127	57	applied	\N	\N	\N	\N	81370	81370	81371
19200	26128	59	applied	\N	\N	\N	\N	81374	81374	81375
19200	26129	60	applied	\N	\N	\N	\N	81378	81378	81379
19200	26130	61	applied	\N	\N	\N	\N	81380	81380	81381
19200	26132	62	applied	\N	\N	\N	\N	81386	81386	81387
19200	26134	63	applied	\N	\N	\N	\N	81393	81393	81394
19200	26135	64	applied	\N	\N	\N	\N	81395	81395	81396
19200	26136	65	applied	\N	\N	\N	\N	81401	81401	81402
19200	26137	66	applied	\N	\N	\N	\N	81405	81405	81406
19200	26139	67	applied	\N	\N	\N	\N	81410	81410	81411
19200	26140	68	applied	\N	\N	\N	\N	81414	81414	81415
19200	26141	69	applied	\N	\N	\N	\N	81416	81416	81417
19200	26143	70	applied	\N	\N	\N	\N	81425	81425	81426
19200	26144	71	applied	\N	\N	\N	\N	81429	81429	81430
19200	26145	72	applied	\N	\N	\N	\N	81445	81445	81446
19200	26146	73	applied	\N	\N	\N	\N	81447	81447	81448
19200	26148	74	applied	\N	\N	\N	\N	81452	81452	81453
19200	26149	75	applied	\N	\N	\N	\N	81456	81456	81457
19200	26150	76	applied	\N	\N	\N	\N	81459	81459	81460
19200	26152	77	applied	\N	\N	\N	\N	81465	81465	81466
19200	26153	78	applied	\N	\N	\N	\N	81469	81469	81470
19200	26154	79	applied	\N	\N	\N	\N	81475	81475	81476
19200	26156	80	applied	\N	\N	\N	\N	81481	81481	81482
19200	26157	81	applied	\N	\N	\N	\N	81483	81483	81484
19200	26158	82	applied	\N	\N	\N	\N	81485	81485	81486
19200	26160	83	applied	\N	\N	\N	\N	81490	81490	81491
19200	26161	84	applied	\N	\N	\N	\N	81494	81494	81495
19200	26162	85	applied	\N	\N	\N	\N	81496	81496	81497
19200	26163	86	applied	\N	\N	\N	\N	81502	81502	81503
19200	26327	87	applied	\N	\N	1000000000	\N	82328	82328	82045
19200	26328	88	applied	\N	\N	1000000000	\N	82329	82329	82047
19200	26329	89	applied	\N	\N	1000000000	\N	82330	82330	82049
19200	26330	90	applied	\N	\N	1000000000	\N	82331	82331	82051
19200	26363	91	applied	\N	\N	1000000000	\N	82332	82332	82150
19200	26364	92	applied	\N	\N	\N	\N	82333	82333	82152
19200	26165	93	applied	\N	\N	\N	\N	81514	81514	81515
19200	26166	94	applied	\N	\N	\N	\N	81517	81517	81518
19200	26167	95	applied	\N	\N	\N	\N	81520	81520	81521
19200	26169	96	applied	\N	\N	\N	\N	81528	81528	81529
19200	26170	97	applied	\N	\N	\N	\N	81533	81533	81534
19200	26171	98	applied	\N	\N	\N	\N	81535	81535	81536
19200	26173	99	applied	\N	\N	\N	\N	81539	81539	81540
19200	26174	100	applied	\N	\N	\N	\N	81544	81544	81545
19200	26175	101	applied	\N	\N	\N	\N	81546	81546	81547
19200	26176	102	applied	\N	\N	\N	\N	81548	81548	81549
19200	26177	103	applied	\N	\N	\N	\N	81550	81550	81551
19200	26179	104	applied	\N	\N	\N	\N	81556	81556	81557
19200	26180	105	applied	\N	\N	\N	\N	81560	81560	81561
19200	26182	106	applied	\N	\N	\N	\N	81565	81565	81566
19200	26183	107	applied	\N	\N	\N	\N	81567	81567	81568
19200	26184	108	applied	\N	\N	\N	\N	81572	81572	81573
19200	26186	109	applied	\N	\N	\N	\N	81581	81581	81582
19200	26187	110	applied	\N	\N	\N	\N	81584	81584	81585
19200	26188	111	applied	\N	\N	\N	\N	81586	81586	81587
19200	26189	112	applied	\N	\N	\N	\N	81590	81590	81591
19200	26191	113	applied	\N	\N	\N	\N	81596	81596	81597
19200	26192	114	applied	\N	\N	\N	\N	81602	81602	81603
19200	26193	115	applied	\N	\N	\N	\N	81606	81606	81607
19200	26195	116	applied	\N	\N	\N	\N	81612	81612	81613
19200	26196	117	applied	\N	\N	\N	\N	81619	81619	81620
19200	26197	118	applied	\N	\N	\N	\N	81622	81622	81623
19200	26199	119	applied	\N	\N	\N	\N	81630	81630	81631
19200	26200	120	applied	\N	\N	\N	\N	81633	81633	81634
19200	26201	121	applied	\N	\N	\N	\N	81638	81638	81639
19200	26202	122	applied	\N	\N	\N	\N	81642	81642	81643
19200	26204	123	applied	\N	\N	\N	\N	81648	81648	81649
19200	26205	124	applied	\N	\N	\N	\N	81651	81651	81652
19200	26206	125	applied	\N	\N	\N	\N	81653	81653	81654
19201	26629	0	applied	\N	\N	\N	\N	82912	82912	82913
19201	26630	1	applied	\N	\N	\N	\N	82914	82914	82915
19201	26631	2	applied	\N	\N	\N	\N	82916	82916	82917
19201	26632	3	applied	\N	\N	\N	\N	82918	82918	82919
19201	26633	4	applied	\N	\N	\N	\N	82920	82920	82921
19201	26634	5	applied	\N	\N	\N	\N	82922	82922	82923
19201	26635	6	applied	\N	\N	\N	\N	82924	82924	82925
19204	26636	0	applied	\N	\N	\N	\N	82931	82931	82932
19204	26637	1	applied	\N	\N	\N	\N	82933	82933	82934
19204	26638	2	applied	\N	\N	\N	\N	82935	82935	82936
19204	26639	3	applied	\N	\N	\N	\N	82937	82937	82938
19204	26640	4	applied	\N	\N	\N	\N	82939	82939	82940
19204	26641	5	applied	\N	\N	\N	\N	82941	82941	82942
19205	26642	0	applied	\N	\N	\N	\N	82947	82947	82948
19205	26643	1	applied	\N	\N	\N	\N	82949	82949	82950
19205	26644	2	applied	\N	\N	\N	\N	82951	82951	82952
19205	26645	3	applied	\N	\N	\N	\N	82953	82953	82954
19205	26646	4	applied	\N	\N	\N	\N	82955	82955	82956
19205	26647	5	applied	\N	\N	\N	\N	82957	82957	82958
19205	26648	6	applied	\N	\N	\N	\N	82959	82959	82960
19205	26649	7	applied	\N	\N	\N	\N	82961	82961	82962
19205	26650	8	applied	\N	\N	\N	\N	82963	82963	82964
19205	26651	9	applied	\N	\N	\N	\N	82965	82965	47675
19205	26652	10	applied	\N	\N	\N	\N	82966	82966	82967
19205	26653	11	applied	\N	\N	\N	\N	82968	82968	82969
19205	26654	12	applied	\N	\N	\N	\N	82970	82970	82971
19205	26655	13	applied	\N	\N	\N	\N	82972	82972	82973
19205	26656	14	applied	\N	\N	\N	\N	82974	82974	82975
19205	26657	15	applied	\N	\N	\N	\N	82976	82976	82977
19205	26658	16	applied	\N	\N	\N	\N	82978	82978	82979
19221	26702	0	applied	\N	\N	\N	\N	83101	83101	83102
19221	26703	1	applied	\N	\N	\N	\N	83103	83103	83104
19221	26704	2	applied	\N	\N	\N	\N	83105	83105	83106
19221	26705	3	applied	\N	\N	\N	\N	83107	83107	83108
19224	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19224	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19224	26708	2	applied	\N	\N	1000000000	\N	83118	83118	83119
19224	26651	3	applied	\N	\N	\N	\N	82965	82965	47675
19227	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19227	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19227	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19227	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19227	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19229	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19229	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19229	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19229	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19229	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19214	26685	13	applied	\N	\N	\N	\N	83045	83045	83046
19214	26686	14	applied	\N	\N	\N	\N	83047	83047	83048
19214	26687	15	applied	\N	\N	\N	\N	83049	83049	83050
19214	26688	16	applied	\N	\N	\N	\N	83051	83051	83052
19214	26689	17	applied	\N	\N	\N	\N	83053	83053	83054
19214	26690	18	applied	\N	\N	\N	\N	83055	83055	83056
19214	26691	19	applied	\N	\N	\N	\N	83057	83057	83058
19217	26692	0	applied	\N	\N	\N	\N	83072	83072	83073
19217	26693	1	applied	\N	\N	\N	\N	83074	83074	83075
19217	26694	2	applied	\N	\N	\N	\N	83076	83076	83077
19217	26695	3	applied	\N	\N	\N	\N	83078	83078	83079
19217	26696	4	applied	\N	\N	\N	\N	83080	83080	83081
19217	26697	5	applied	\N	\N	\N	\N	83082	83082	83083
19217	26698	6	applied	\N	\N	\N	\N	83084	83084	83085
19217	26699	8	applied	\N	\N	\N	\N	83087	83087	83088
19217	26700	9	applied	\N	\N	\N	\N	83089	83089	83090
19217	26701	10	applied	\N	\N	\N	\N	83091	83091	83092
19218	26692	0	applied	\N	\N	\N	\N	83072	83072	83073
19218	26693	1	applied	\N	\N	\N	\N	83074	83074	83075
19218	26694	2	applied	\N	\N	\N	\N	83076	83076	83077
19218	26695	3	applied	\N	\N	\N	\N	83078	83078	83079
19218	26696	4	applied	\N	\N	\N	\N	83080	83080	83081
19218	26697	5	applied	\N	\N	\N	\N	83082	83082	83083
19218	26698	6	applied	\N	\N	\N	\N	83084	83084	83085
19218	26699	8	applied	\N	\N	\N	\N	83087	83087	83088
19218	26700	9	applied	\N	\N	\N	\N	83089	83089	83090
19218	26701	10	applied	\N	\N	\N	\N	83091	83091	83092
19222	26702	0	applied	\N	\N	\N	\N	83101	83101	83102
19222	26703	1	applied	\N	\N	\N	\N	83103	83103	83104
19222	26706	2	applied	\N	\N	\N	\N	83111	83111	83112
19222	26704	3	applied	\N	\N	\N	\N	83105	83105	83113
19222	26705	4	applied	\N	\N	\N	\N	83107	83107	83114
19222	26707	5	applied	\N	\N	\N	\N	83115	83115	83116
19225	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19225	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19225	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19225	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19225	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19228	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19228	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19228	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19228	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19228	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19230	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19230	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19230	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19230	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19230	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19231	26708	0	applied	\N	\N	1000000000	\N	83118	83118	83119
19231	26709	1	applied	\N	\N	\N	\N	83121	83121	83122
19231	26710	2	applied	\N	\N	\N	\N	83123	83123	83124
19231	26711	3	applied	\N	\N	\N	\N	83125	83125	83126
19231	26712	4	applied	\N	\N	\N	\N	83127	83127	83128
19235	26716	0	applied	\N	\N	\N	\N	83147	83147	83148
19235	26717	1	applied	\N	\N	\N	\N	83149	83149	83150
19235	26718	2	applied	\N	\N	\N	\N	83151	83151	83152
19239	26719	0	applied	\N	\N	\N	\N	83159	83159	83160
19239	26720	1	applied	\N	\N	\N	\N	83161	83161	83162
19239	26721	2	applied	\N	\N	\N	\N	83163	83163	83164
19244	26727	0	applied	\N	\N	\N	\N	83185	83185	24815
19244	26728	1	applied	\N	\N	\N	\N	83186	83186	83187
19244	26729	2	applied	\N	\N	\N	\N	83188	83188	83189
19244	26730	3	applied	\N	\N	\N	\N	83190	83190	83191
19244	26731	4	applied	\N	\N	\N	\N	83192	83192	83193
19244	26732	5	applied	\N	\N	\N	\N	83194	83194	83195
19244	26733	6	applied	\N	\N	\N	\N	83196	83196	83197
19247	26738	0	applied	\N	\N	1000000000	\N	83210	83210	83211
19247	26739	1	applied	\N	\N	\N	\N	83212	83212	83213
19247	26740	2	applied	\N	\N	\N	\N	83214	83214	83215
19249	26741	0	applied	\N	\N	\N	\N	83219	83219	83220
19249	26742	1	applied	\N	\N	\N	\N	83221	83221	83222
19249	26743	2	applied	\N	\N	\N	\N	83223	83223	83224
19249	26744	3	applied	\N	\N	\N	\N	83225	83225	83226
19249	26745	4	applied	\N	\N	\N	\N	83227	83227	83228
19249	26746	5	applied	\N	\N	\N	\N	83229	83229	83230
19249	26747	6	applied	\N	\N	\N	\N	83231	83231	83232
19254	26754	0	applied	\N	\N	\N	\N	83249	83249	83250
19254	26755	1	applied	\N	\N	\N	\N	83251	83251	83252
19254	26756	2	applied	\N	\N	\N	\N	83253	83253	83254
19254	26757	3	applied	\N	\N	\N	\N	83255	83255	83256
19254	26758	4	applied	\N	\N	\N	\N	83257	83257	83258
19254	26759	5	applied	\N	\N	\N	\N	83259	83259	83260
19254	26760	6	applied	\N	\N	\N	\N	83261	83261	83262
19254	26761	7	applied	\N	\N	\N	\N	83263	83263	83264
19261	26762	0	applied	\N	\N	\N	\N	83303	83303	83304
19261	26763	1	applied	\N	\N	\N	\N	83305	83305	83306
19261	26764	2	applied	\N	\N	\N	\N	83307	83307	83308
19261	26765	3	applied	\N	\N	\N	\N	83309	83309	83310
19261	26766	4	applied	\N	\N	\N	\N	83311	83311	83312
19261	26767	5	applied	\N	\N	\N	\N	83313	83313	83314
19261	26768	6	applied	\N	\N	\N	\N	83315	83315	83316
19261	26769	7	applied	\N	\N	\N	\N	83317	83317	83318
19261	26770	8	applied	\N	\N	\N	\N	83319	83319	83320
19261	26771	9	applied	\N	\N	\N	\N	83321	83321	83322
19263	26775	0	applied	\N	\N	\N	\N	83339	83339	83340
19263	26776	1	applied	\N	\N	\N	\N	83341	83341	83342
19263	26777	2	applied	\N	\N	\N	\N	83343	83343	83344
19266	26772	0	applied	\N	\N	\N	\N	83331	83331	83332
19266	26775	1	applied	\N	\N	\N	\N	83339	83339	83340
19266	26778	2	applied	\N	\N	\N	\N	83347	83347	83348
19266	26782	3	applied	\N	\N	\N	\N	83356	83356	83357
19266	26785	4	applied	\N	\N	\N	\N	83362	83362	83363
19266	26773	5	applied	\N	\N	\N	\N	83333	83333	83334
19266	26777	6	applied	\N	\N	\N	\N	83343	83343	83364
19266	26780	7	applied	\N	\N	\N	\N	83351	83351	83336
19266	26774	8	applied	\N	\N	\N	\N	83335	83335	83342
19266	26776	9	applied	\N	\N	\N	\N	83341	83341	83365
19266	26779	10	applied	\N	\N	\N	\N	83349	83349	83352
19266	26784	11	applied	\N	\N	\N	\N	83360	83360	83366
19266	26786	12	applied	\N	\N	\N	\N	83367	83367	83368
19266	26781	13	applied	\N	\N	\N	\N	83353	83353	83369
19266	26783	14	applied	\N	\N	\N	\N	83358	83358	83370
19266	26787	15	applied	\N	\N	\N	\N	83371	83371	83372
19269	26785	0	applied	\N	\N	\N	\N	83362	83362	83363
19269	26786	1	applied	\N	\N	\N	\N	83367	83367	83370
19269	26787	2	applied	\N	\N	\N	\N	83371	83371	83372
19276	26795	0	applied	\N	\N	\N	\N	83394	83394	83395
19276	26796	1	applied	\N	\N	\N	\N	83396	83396	83397
19276	26797	2	applied	\N	\N	\N	\N	83398	83398	83399
19242	26719	0	applied	\N	\N	\N	\N	83159	83159	83160
19242	26720	1	applied	\N	\N	\N	\N	83161	83161	83162
19242	26721	2	applied	\N	\N	\N	\N	83163	83163	83164
19243	26722	0	applied	\N	\N	\N	\N	83173	83173	83174
19243	26723	1	applied	\N	\N	\N	\N	83175	83175	83176
19243	26724	2	applied	\N	\N	\N	\N	83177	83177	83178
19243	26725	3	applied	\N	\N	\N	\N	83179	83179	83180
19243	26726	4	applied	\N	\N	\N	\N	83181	83181	83182
19246	26738	0	applied	\N	\N	1000000000	\N	83210	83210	83211
19246	26739	1	applied	\N	\N	\N	\N	83212	83212	83213
19246	26740	2	applied	\N	\N	\N	\N	83214	83214	83215
19251	26748	0	applied	\N	\N	\N	\N	83234	83234	83235
19251	26749	1	applied	\N	\N	\N	\N	83236	83236	83237
19251	26750	2	applied	\N	\N	\N	\N	83238	83238	83239
19253	26751	0	applied	\N	\N	\N	\N	83243	83243	83244
19253	26752	1	applied	\N	\N	\N	\N	83245	83245	83246
19253	26753	2	applied	\N	\N	\N	\N	83247	83247	83248
19256	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19256	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19256	26708	2	applied	\N	\N	1000000000	\N	83118	83118	83119
19256	26322	3	applied	\N	\N	1000000000	\N	82034	82034	82035
19256	26723	4	applied	\N	\N	\N	\N	83175	83175	83176
19256	26560	5	applied	\N	\N	\N	\N	82711	82711	82712
19256	26561	6	applied	\N	\N	\N	\N	82713	82713	82714
19256	26562	7	applied	\N	\N	\N	\N	82715	82715	82716
19256	26738	8	applied	\N	\N	1000000000	\N	83210	83210	83211
19256	26565	9	applied	\N	\N	\N	\N	82721	82721	82722
19256	26584	10	applied	\N	\N	\N	\N	82770	82770	82771
19256	26324	11	applied	\N	\N	1000000000	\N	82038	82038	82039
19256	26325	12	applied	\N	\N	1000000000	\N	82040	82040	82041
19256	26326	13	applied	\N	\N	1000000000	\N	82042	82042	82043
19256	26327	14	applied	\N	\N	1000000000	\N	82044	82044	82045
19256	26328	15	applied	\N	\N	1000000000	\N	82046	82046	82047
19256	26329	16	applied	\N	\N	1000000000	\N	82048	82048	82049
19256	26330	17	applied	\N	\N	1000000000	\N	82050	82050	82051
19256	26363	18	applied	\N	\N	1000000000	\N	82149	82149	82150
19256	26364	19	applied	\N	\N	\N	\N	82151	82151	82152
19256	26361	20	applied	\N	\N	1000000000	\N	82137	82137	82138
19256	26436	21	applied	\N	\N	1000000000	\N	82368	82368	82369
19256	26372	22	applied	\N	\N	\N	\N	82167	82167	81973
19256	26497	23	applied	\N	\N	\N	\N	82545	82545	82546
19256	26437	24	applied	\N	\N	\N	\N	82370	82370	82371
19256	26498	25	applied	\N	\N	\N	\N	82547	82547	82548
19256	26499	26	applied	\N	\N	\N	\N	82549	82549	82550
19256	26515	27	applied	\N	\N	\N	\N	82592	82592	82593
19256	26373	28	applied	\N	\N	\N	\N	82168	82168	82007
19256	26378	29	applied	\N	\N	\N	\N	82184	82184	82027
19256	26381	30	applied	\N	\N	\N	\N	82193	82193	82085
19256	26384	31	applied	\N	\N	\N	\N	82206	82206	82116
19256	26389	32	applied	\N	\N	\N	\N	82218	82218	82161
19256	26390	33	applied	\N	\N	\N	\N	82220	82220	82169
19256	26391	34	applied	\N	\N	\N	\N	82229	82229	82171
19256	26395	35	applied	\N	\N	\N	\N	82239	82239	82174
19256	26401	36	applied	\N	\N	\N	\N	82250	82250	83269
19256	26402	37	applied	\N	\N	\N	\N	82252	82252	82374
19256	26410	38	applied	\N	\N	\N	\N	82269	82269	82183
19256	26447	39	applied	\N	\N	\N	\N	82418	82418	82185
19256	26452	40	applied	\N	\N	\N	\N	82430	82430	82376
19256	26757	41	applied	\N	\N	\N	\N	83255	83255	83256
19256	26651	42	applied	\N	\N	\N	\N	82965	82965	47675
19256	26456	43	applied	\N	\N	\N	\N	82438	82438	83270
19256	26457	44	applied	\N	\N	\N	\N	82440	82440	83271
19256	26375	45	applied	\N	\N	\N	\N	82175	82175	83272
19256	26377	46	applied	\N	\N	\N	\N	82182	82182	83273
19256	26380	47	applied	\N	\N	\N	\N	82191	82191	83274
19256	26383	48	applied	\N	\N	\N	\N	82204	82204	82219
19256	26387	49	applied	\N	\N	\N	\N	82214	82214	83275
19256	26388	50	applied	\N	\N	\N	\N	82216	82216	83276
19256	26392	51	applied	\N	\N	\N	\N	82231	82231	82240
19256	26396	52	applied	\N	\N	\N	\N	82241	82241	82242
19256	26403	53	applied	\N	\N	\N	\N	82254	82254	83277
19256	26404	54	applied	\N	\N	\N	\N	82256	82256	83278
19256	26408	55	applied	\N	\N	\N	\N	82265	82265	83279
19256	26409	56	applied	\N	\N	\N	\N	82267	82267	83280
19256	26412	57	applied	\N	\N	\N	\N	82276	82276	83281
19256	26460	58	applied	\N	\N	\N	\N	82448	82448	82387
19256	26462	59	applied	\N	\N	\N	\N	82454	82454	83282
19256	26466	60	applied	\N	\N	\N	\N	82464	82464	82277
19256	26470	61	applied	\N	\N	\N	\N	82476	82476	82389
19256	26474	62	applied	\N	\N	\N	\N	82487	82487	83283
19256	26475	63	applied	\N	\N	\N	\N	82489	82489	82289
19256	26479	64	applied	\N	\N	\N	\N	82499	82499	82391
19256	26483	65	applied	\N	\N	\N	\N	82511	82511	83284
19256	26485	66	applied	\N	\N	\N	\N	82516	82516	82303
19256	26488	67	applied	\N	\N	\N	\N	82524	82524	82393
19256	26416	68	applied	\N	\N	\N	\N	82283	82283	82395
19256	26418	69	applied	\N	\N	\N	\N	82288	82288	82397
19256	26419	70	applied	\N	\N	\N	\N	82292	82292	83285
19256	26423	71	applied	\N	\N	\N	\N	82302	82302	83286
19256	26424	72	applied	\N	\N	\N	\N	82304	82304	83287
19256	26425	73	applied	\N	\N	\N	\N	82306	82306	83288
19256	26427	74	applied	\N	\N	\N	\N	82312	82312	83289
19256	26430	75	applied	\N	\N	\N	\N	82341	82341	83290
19256	26431	76	applied	\N	\N	\N	\N	82343	82343	83291
19256	26433	77	applied	\N	\N	\N	\N	82351	82351	83292
19256	26435	79	applied	\N	\N	\N	\N	82359	82359	83294
19256	26438	80	applied	\N	\N	\N	\N	82394	82394	83295
19256	26439	81	applied	\N	\N	\N	\N	82396	82396	83296
19256	26444	82	applied	\N	\N	\N	\N	82412	82412	83297
19256	26445	83	applied	\N	\N	\N	\N	82414	82414	83298
19256	26453	84	applied	\N	\N	\N	\N	82432	82432	82439
19259	26762	0	applied	\N	\N	\N	\N	83303	83303	83304
19259	26763	1	applied	\N	\N	\N	\N	83305	83305	83306
19259	26764	2	applied	\N	\N	\N	\N	83307	83307	83308
19259	26765	3	applied	\N	\N	\N	\N	83309	83309	83310
19259	26766	4	applied	\N	\N	\N	\N	83311	83311	83312
19259	26767	5	applied	\N	\N	\N	\N	83313	83313	83314
19259	26768	6	applied	\N	\N	\N	\N	83315	83315	83316
19259	26769	7	applied	\N	\N	\N	\N	83317	83317	83318
19259	26770	8	applied	\N	\N	\N	\N	83319	83319	83320
19259	26771	9	applied	\N	\N	\N	\N	83321	83321	83322
19265	26782	0	applied	\N	\N	\N	\N	83356	83356	83357
19265	26783	1	applied	\N	\N	\N	\N	83358	83358	83359
19265	26784	2	applied	\N	\N	\N	\N	83360	83360	83361
19272	26791	0	applied	\N	\N	\N	\N	83385	83385	83386
19272	26792	1	applied	\N	\N	\N	\N	83387	83387	83388
19272	26793	2	applied	\N	\N	\N	\N	83389	83389	83390
19272	26794	3	applied	\N	\N	\N	\N	83391	83391	83392
19252	26751	0	applied	\N	\N	\N	\N	83243	83243	83244
19252	26752	1	applied	\N	\N	\N	\N	83245	83245	83246
19252	26753	2	applied	\N	\N	\N	\N	83247	83247	83248
19255	26754	0	applied	\N	\N	\N	\N	83249	83249	83250
19255	26755	1	applied	\N	\N	\N	\N	83251	83251	83252
19255	26756	2	applied	\N	\N	\N	\N	83253	83253	83254
19255	26757	3	applied	\N	\N	\N	\N	83255	83255	83256
19255	26758	4	applied	\N	\N	\N	\N	83257	83257	83258
19255	26759	5	applied	\N	\N	\N	\N	83259	83259	83260
19255	26760	6	applied	\N	\N	\N	\N	83261	83261	83262
19255	26761	7	applied	\N	\N	\N	\N	83263	83263	83264
19257	26762	0	applied	\N	\N	\N	\N	83303	83303	83304
19257	26763	1	applied	\N	\N	\N	\N	83305	83305	83306
19257	26764	2	applied	\N	\N	\N	\N	83307	83307	83308
19257	26765	3	applied	\N	\N	\N	\N	83309	83309	83310
19257	26766	4	applied	\N	\N	\N	\N	83311	83311	83312
19257	26767	5	applied	\N	\N	\N	\N	83313	83313	83314
19257	26768	6	applied	\N	\N	\N	\N	83315	83315	83316
19257	26769	7	applied	\N	\N	\N	\N	83317	83317	83318
19257	26770	8	applied	\N	\N	\N	\N	83319	83319	83320
19257	26771	9	applied	\N	\N	\N	\N	83321	83321	83322
19260	26762	0	applied	\N	\N	\N	\N	83303	83303	83304
19260	26763	1	applied	\N	\N	\N	\N	83305	83305	83306
19260	26764	2	applied	\N	\N	\N	\N	83307	83307	83308
19260	26765	3	applied	\N	\N	\N	\N	83309	83309	83310
19260	26766	4	applied	\N	\N	\N	\N	83311	83311	83312
19260	26767	5	applied	\N	\N	\N	\N	83313	83313	83314
19260	26768	6	applied	\N	\N	\N	\N	83315	83315	83316
19260	26769	7	applied	\N	\N	\N	\N	83317	83317	83318
19260	26770	8	applied	\N	\N	\N	\N	83319	83319	83320
19260	26771	9	applied	\N	\N	\N	\N	83321	83321	83322
19264	26778	0	applied	\N	\N	\N	\N	83347	83347	83348
19264	26779	1	applied	\N	\N	\N	\N	83349	83349	83350
19264	26780	2	applied	\N	\N	\N	\N	83351	83351	83352
19264	26781	3	applied	\N	\N	\N	\N	83353	83353	83354
19267	26785	0	applied	\N	\N	\N	\N	83362	83362	83363
19267	26786	1	applied	\N	\N	\N	\N	83367	83367	83370
19267	26787	2	applied	\N	\N	\N	\N	83371	83371	83372
19270	26785	0	applied	\N	\N	\N	\N	83362	83362	83363
19270	26786	1	applied	\N	\N	\N	\N	83367	83367	83370
19270	26787	2	applied	\N	\N	\N	\N	83371	83371	83372
19273	26795	0	applied	\N	\N	\N	\N	83394	83394	83395
19273	26796	1	applied	\N	\N	\N	\N	83396	83396	83397
19273	26797	2	applied	\N	\N	\N	\N	83398	83398	83399
19278	26802	0	applied	\N	\N	\N	\N	83413	83413	83414
19278	26803	1	applied	\N	\N	\N	\N	83415	83415	83416
19278	26804	2	applied	\N	\N	\N	\N	83417	83417	83418
19278	26805	3	applied	\N	\N	\N	\N	83419	83419	83420
19278	26806	4	applied	\N	\N	\N	\N	83421	83421	83422
19278	26807	5	applied	\N	\N	\N	\N	83423	83423	83424
19280	26808	0	applied	\N	\N	\N	\N	83427	83427	83428
19280	26809	1	applied	\N	\N	\N	\N	83429	83429	83430
19280	26810	2	applied	\N	\N	\N	\N	83431	83431	83432
19283	26815	0	applied	\N	\N	\N	\N	83445	83445	83446
19283	26816	1	applied	\N	\N	\N	\N	83447	83447	83448
19283	26817	2	applied	\N	\N	\N	\N	83449	83449	83450
19283	26818	3	applied	\N	\N	\N	\N	83451	83451	83452
19283	26819	4	applied	\N	\N	\N	\N	83453	83453	83454
19283	26820	5	applied	\N	\N	\N	\N	83455	83455	83456
19283	26821	6	applied	\N	\N	\N	\N	83457	83457	83458
19285	26822	0	applied	\N	\N	\N	\N	83463	83463	83464
19285	26823	1	applied	\N	\N	\N	\N	83465	83465	83466
19285	26824	2	applied	\N	\N	\N	\N	83467	83467	83468
19285	26825	3	applied	\N	\N	\N	\N	83469	83469	83470
19285	26826	4	applied	\N	\N	\N	\N	83471	83471	83472
19285	26827	5	applied	\N	\N	\N	\N	83473	83473	83474
19285	26828	6	applied	\N	\N	\N	\N	83475	83475	83476
19285	26829	7	applied	\N	\N	\N	\N	83477	83477	83478
19291	26848	0	applied	\N	\N	\N	\N	83524	83524	83525
19291	26849	1	applied	\N	\N	\N	\N	83526	83526	83527
19291	26850	2	applied	\N	\N	\N	\N	83528	83528	83529
19291	26851	3	applied	\N	\N	\N	\N	83530	83530	83531
19291	26852	4	applied	\N	\N	\N	\N	83532	83532	83533
19291	26853	5	applied	\N	\N	\N	\N	83534	83534	83535
19291	26854	6	applied	\N	\N	\N	\N	83536	83536	83537
19298	26865	0	applied	\N	\N	\N	\N	83568	83568	83569
19298	26866	1	applied	\N	\N	\N	\N	83570	83570	83571
19298	26867	2	applied	\N	\N	\N	\N	83572	83572	83573
19300	26871	0	applied	\N	\N	\N	\N	83582	83582	83583
19300	26872	1	applied	\N	\N	\N	\N	83584	83584	83585
19300	26873	2	applied	\N	\N	\N	\N	83586	83586	83587
19300	26874	3	applied	\N	\N	\N	\N	83588	83588	83589
19303	26878	0	applied	\N	\N	\N	\N	83601	83601	83602
19303	26879	1	applied	\N	\N	\N	\N	83603	83603	83604
19303	26880	2	applied	\N	\N	\N	\N	83605	83605	83606
19303	26881	3	applied	\N	\N	\N	\N	83607	83607	83608
19303	26882	4	applied	\N	\N	\N	\N	83609	83609	83610
19303	26883	5	applied	\N	\N	\N	\N	83611	83611	83612
19303	26884	6	applied	\N	\N	\N	\N	83613	83613	83614
19303	26885	7	applied	\N	\N	\N	\N	83615	83615	83616
19303	26886	8	applied	\N	\N	\N	\N	83617	83617	83618
19303	26887	9	applied	\N	\N	\N	\N	83619	83619	83620
19303	26888	10	applied	\N	\N	\N	\N	83621	83621	83622
19303	26889	11	applied	\N	\N	\N	\N	83623	83623	83624
19303	26890	12	applied	\N	\N	\N	\N	83625	83625	83626
19303	26891	13	applied	\N	\N	\N	\N	83627	83627	83628
19303	26892	14	applied	\N	\N	\N	\N	83629	83629	83630
19303	26893	15	applied	\N	\N	\N	\N	83631	83631	83632
19303	26894	16	applied	\N	\N	\N	\N	83633	83633	83634
19303	26895	17	applied	\N	\N	\N	\N	83635	83635	83636
19303	26896	18	applied	\N	\N	\N	\N	83637	83637	83637
19303	26897	19	applied	\N	\N	\N	\N	83638	83638	83639
19306	26878	0	applied	\N	\N	\N	\N	83601	83601	83602
19306	26879	1	applied	\N	\N	\N	\N	83603	83603	83604
19306	26880	2	applied	\N	\N	\N	\N	83605	83605	83606
19306	26881	3	applied	\N	\N	\N	\N	83607	83607	83608
19306	26882	4	applied	\N	\N	\N	\N	83609	83609	83610
19306	26883	5	applied	\N	\N	\N	\N	83611	83611	83612
19306	26884	6	applied	\N	\N	\N	\N	83613	83613	83614
19306	26885	7	applied	\N	\N	\N	\N	83615	83615	83616
19306	26886	8	applied	\N	\N	\N	\N	83617	83617	83618
19306	26887	9	applied	\N	\N	\N	\N	83619	83619	83620
19306	26888	10	applied	\N	\N	\N	\N	83621	83621	83622
19306	26889	11	applied	\N	\N	\N	\N	83623	83623	83624
19306	26890	12	applied	\N	\N	\N	\N	83625	83625	83626
19306	26891	13	applied	\N	\N	\N	\N	83627	83627	83628
19306	26892	14	applied	\N	\N	\N	\N	83629	83629	83630
19306	26893	15	applied	\N	\N	\N	\N	83631	83631	83632
19306	26894	16	applied	\N	\N	\N	\N	83633	83633	83634
19306	26895	17	applied	\N	\N	\N	\N	83635	83635	83636
19275	26795	0	applied	\N	\N	\N	\N	83394	83394	83395
19275	26796	1	applied	\N	\N	\N	\N	83396	83396	83397
19275	26797	2	applied	\N	\N	\N	\N	83398	83398	83399
19286	26822	0	applied	\N	\N	\N	\N	83463	83463	83464
19286	26823	1	applied	\N	\N	\N	\N	83465	83465	83466
19286	26824	2	applied	\N	\N	\N	\N	83467	83467	83468
19286	26825	3	applied	\N	\N	\N	\N	83469	83469	83470
19286	26826	4	applied	\N	\N	\N	\N	83471	83471	83472
19286	26827	5	applied	\N	\N	\N	\N	83473	83473	83474
19286	26828	6	applied	\N	\N	\N	\N	83475	83475	83476
19286	26829	7	applied	\N	\N	\N	\N	83477	83477	83478
19289	26834	0	applied	\N	\N	\N	\N	83494	83494	83495
19289	26835	1	applied	\N	\N	\N	\N	83496	83496	83497
19289	26836	2	applied	\N	\N	\N	\N	83498	83498	83499
19289	26837	3	applied	\N	\N	\N	\N	83500	83500	83501
19289	26838	4	applied	\N	\N	\N	\N	83502	83502	83503
19289	26839	5	applied	\N	\N	1000000000	\N	83504	83504	83505
19289	26840	6	applied	\N	\N	1000000000	\N	83506	83506	83507
19289	26841	7	applied	\N	\N	1000000000	\N	83508	83508	83509
19289	26842	8	applied	\N	\N	\N	\N	83510	83510	83511
19289	26843	9	applied	\N	\N	\N	\N	83512	83512	83513
19289	26844	10	applied	\N	\N	\N	\N	83514	83514	83515
19289	26845	11	applied	\N	\N	\N	\N	83516	83516	83517
19289	26846	12	applied	\N	\N	1000000000	\N	83518	83518	83519
19289	26847	13	applied	\N	\N	1000000000	\N	83520	83520	83521
19294	26855	0	applied	\N	\N	\N	\N	83541	83541	83542
19294	26856	1	applied	\N	\N	\N	\N	83543	83543	83544
19294	26857	2	applied	\N	\N	\N	\N	83545	83545	83546
19296	26858	0	applied	\N	\N	\N	\N	83553	83553	83554
19296	26859	1	applied	\N	\N	\N	\N	83555	83555	83556
19296	26860	2	applied	\N	\N	\N	\N	83557	83557	83558
19296	26861	3	applied	\N	\N	\N	\N	83559	83559	83560
19296	26862	4	applied	\N	\N	\N	\N	83561	83561	83562
19296	26863	5	applied	\N	\N	\N	\N	83563	83563	83564
19296	26864	6	applied	\N	\N	\N	\N	83565	83565	83566
19301	26875	0	applied	\N	\N	\N	\N	83592	83592	83593
19301	26876	1	applied	\N	\N	\N	\N	83594	83594	83595
19301	26877	2	applied	\N	\N	\N	\N	83596	83596	83597
19305	26878	0	applied	\N	\N	\N	\N	83601	83601	83602
19305	26879	1	applied	\N	\N	\N	\N	83603	83603	83604
19305	26880	2	applied	\N	\N	\N	\N	83605	83605	83606
19305	26881	3	applied	\N	\N	\N	\N	83607	83607	83608
19305	26882	4	applied	\N	\N	\N	\N	83609	83609	83610
19305	26883	5	applied	\N	\N	\N	\N	83611	83611	83612
19305	26884	6	applied	\N	\N	\N	\N	83613	83613	83614
19305	26885	7	applied	\N	\N	\N	\N	83615	83615	83616
19305	26886	8	applied	\N	\N	\N	\N	83617	83617	83618
19305	26887	9	applied	\N	\N	\N	\N	83619	83619	83620
19305	26888	10	applied	\N	\N	\N	\N	83621	83621	83622
19305	26889	11	applied	\N	\N	\N	\N	83623	83623	83624
19305	26890	12	applied	\N	\N	\N	\N	83625	83625	83626
19305	26891	13	applied	\N	\N	\N	\N	83627	83627	83628
19305	26892	14	applied	\N	\N	\N	\N	83629	83629	83630
19305	26893	15	applied	\N	\N	\N	\N	83631	83631	83632
19305	26894	16	applied	\N	\N	\N	\N	83633	83633	83634
19305	26895	17	applied	\N	\N	\N	\N	83635	83635	83636
19305	26896	18	applied	\N	\N	\N	\N	83637	83637	83637
19305	26897	19	applied	\N	\N	\N	\N	83638	83638	83639
19309	26905	0	applied	\N	\N	\N	\N	83662	83662	83663
19309	26906	1	applied	\N	\N	\N	\N	83664	83664	83665
19316	26924	0	applied	\N	\N	\N	\N	83709	83709	83710
19316	26925	1	applied	\N	\N	\N	\N	83711	83711	83712
19316	26926	2	applied	\N	\N	\N	\N	83713	83713	83714
19316	26927	3	applied	\N	\N	\N	\N	83715	83715	83716
19316	26928	4	applied	\N	\N	\N	\N	83717	83717	83718
19316	26929	5	applied	\N	\N	\N	\N	83719	83719	83720
19316	26930	6	applied	\N	\N	\N	\N	83721	83721	83722
19324	26955	0	applied	\N	\N	\N	\N	83811	83811	83812
19324	26956	1	applied	\N	\N	\N	\N	83813	83813	83814
19324	26957	2	applied	\N	\N	\N	\N	83815	83815	83816
19324	26958	3	applied	\N	\N	\N	\N	83817	83817	83818
19324	26959	4	applied	\N	\N	\N	\N	83819	83819	83820
19324	26960	5	applied	\N	\N	\N	\N	83821	83821	83822
19324	26961	6	applied	\N	\N	\N	\N	83823	83823	83824
19324	26962	7	applied	\N	\N	\N	\N	83825	83825	83826
19324	26963	8	applied	\N	\N	\N	\N	83827	83827	83828
19327	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19327	26965	1	applied	\N	\N	\N	\N	83834	83834	83835
19327	26966	2	applied	\N	\N	\N	\N	83836	83836	83837
19327	26967	3	applied	\N	\N	\N	\N	83838	83838	83839
19327	26968	4	applied	\N	\N	\N	\N	83840	83840	83841
19327	26969	5	applied	\N	\N	\N	\N	83842	83842	83843
19327	26970	6	applied	\N	\N	\N	\N	83844	83844	83845
19327	26971	7	applied	\N	\N	\N	\N	83846	83846	83847
19327	26972	8	applied	\N	\N	\N	\N	83848	83848	83849
19327	26973	9	applied	\N	\N	\N	\N	83850	83850	83851
19327	26974	10	applied	\N	\N	\N	\N	83852	83852	83853
19329	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19329	26965	1	applied	\N	\N	\N	\N	83834	83834	83835
19329	26966	2	applied	\N	\N	\N	\N	83836	83836	83837
19329	26967	3	applied	\N	\N	\N	\N	83838	83838	83839
19329	26968	4	applied	\N	\N	\N	\N	83840	83840	83841
19329	26969	5	applied	\N	\N	\N	\N	83842	83842	83843
19329	26970	6	applied	\N	\N	\N	\N	83844	83844	83845
19329	26971	7	applied	\N	\N	\N	\N	83846	83846	83847
19329	26972	8	applied	\N	\N	\N	\N	83848	83848	83849
19329	26973	9	applied	\N	\N	\N	\N	83850	83850	83851
19329	26974	10	applied	\N	\N	\N	\N	83852	83852	83853
19339	27012	0	applied	\N	\N	\N	\N	83948	83948	83949
19339	27013	1	applied	\N	\N	\N	\N	83950	83950	83951
19339	27014	2	applied	\N	\N	\N	\N	83952	83952	83952
19339	27015	3	applied	\N	\N	\N	\N	83953	83953	83954
19339	27016	4	applied	\N	\N	\N	\N	83955	83955	83955
19339	27017	5	applied	\N	\N	\N	\N	83956	83956	83957
19339	27018	6	applied	\N	\N	\N	\N	83958	83958	83958
19339	27019	7	applied	\N	\N	\N	\N	83959	83959	83960
19339	27020	8	applied	\N	\N	\N	\N	83961	83961	83962
19339	27021	9	applied	\N	\N	\N	\N	83963	83963	83964
19346	27028	0	applied	\N	\N	\N	\N	83986	83986	83987
19346	27029	1	applied	\N	\N	\N	\N	83988	83988	83989
19346	27030	2	applied	\N	\N	\N	\N	83990	83990	83991
19346	27031	3	applied	\N	\N	\N	\N	83992	83992	83993
19353	27036	0	applied	\N	\N	\N	\N	84027	84027	84028
19356	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19356	27051	1	applied	\N	\N	\N	\N	84065	84065	84066
19356	27052	2	applied	\N	\N	\N	\N	84067	84067	84068
19356	27053	3	applied	\N	\N	\N	\N	84069	84069	84070
19356	27054	4	applied	\N	\N	\N	\N	84071	84071	84072
19356	26887	5	applied	\N	\N	\N	\N	83619	83619	83620
19277	26798	0	applied	\N	\N	\N	\N	83404	83404	83405
19277	26799	1	applied	\N	\N	\N	\N	83406	83406	83407
19277	26800	2	applied	\N	\N	\N	\N	83408	83408	83409
19277	26801	3	applied	\N	\N	\N	\N	83410	83410	83411
19282	26811	0	applied	\N	\N	\N	\N	83435	83435	83436
19282	26812	1	applied	\N	\N	\N	\N	83437	83437	83438
19282	26813	2	applied	\N	\N	\N	\N	83439	83439	83440
19282	26814	3	applied	\N	\N	\N	\N	83441	83441	83442
19287	26822	0	applied	\N	\N	\N	\N	83463	83463	83464
19287	26823	1	applied	\N	\N	\N	\N	83465	83465	83466
19287	26824	2	applied	\N	\N	\N	\N	83467	83467	83468
19287	26825	3	applied	\N	\N	\N	\N	83469	83469	83470
19287	26826	4	applied	\N	\N	\N	\N	83471	83471	83472
19287	26827	5	applied	\N	\N	\N	\N	83473	83473	83474
19287	26828	6	applied	\N	\N	\N	\N	83475	83475	83476
19287	26829	7	applied	\N	\N	\N	\N	83477	83477	83478
19290	26848	0	applied	\N	\N	\N	\N	83524	83524	83525
19290	26849	1	applied	\N	\N	\N	\N	83526	83526	83527
19290	26850	2	applied	\N	\N	\N	\N	83528	83528	83529
19290	26851	3	applied	\N	\N	\N	\N	83530	83530	83531
19290	26852	4	applied	\N	\N	\N	\N	83532	83532	83533
19290	26853	5	applied	\N	\N	\N	\N	83534	83534	83535
19290	26854	6	applied	\N	\N	\N	\N	83536	83536	83537
19292	26848	0	applied	\N	\N	\N	\N	83524	83524	83525
19292	26849	1	applied	\N	\N	\N	\N	83526	83526	83527
19292	26850	2	applied	\N	\N	\N	\N	83528	83528	83529
19292	26851	3	applied	\N	\N	\N	\N	83530	83530	83531
19292	26852	4	applied	\N	\N	\N	\N	83532	83532	83533
19292	26853	5	applied	\N	\N	\N	\N	83534	83534	83535
19292	26854	6	applied	\N	\N	\N	\N	83536	83536	83537
19295	26855	0	applied	\N	\N	\N	\N	83541	83541	83542
19295	26856	1	applied	\N	\N	\N	\N	83543	83543	83544
19295	26857	2	applied	\N	\N	\N	\N	83545	83545	83546
19297	26865	0	applied	\N	\N	\N	\N	83568	83568	83569
19297	26866	1	applied	\N	\N	\N	\N	83570	83570	83571
19297	26867	2	applied	\N	\N	\N	\N	83572	83572	83573
19299	26868	0	applied	\N	\N	\N	\N	83574	83574	83575
19299	26869	1	applied	\N	\N	\N	\N	83576	83576	83577
19299	26870	2	applied	\N	\N	\N	\N	83578	83578	83579
19307	26898	0	applied	\N	\N	\N	\N	83645	83645	83646
19307	26899	1	applied	\N	\N	\N	\N	83647	83647	83648
19307	26900	2	applied	\N	\N	\N	\N	83649	83649	83650
19307	26901	3	applied	\N	\N	\N	\N	83651	83651	83652
19307	26902	4	applied	\N	\N	\N	\N	83653	83653	83654
19307	26903	5	applied	\N	\N	\N	\N	83655	83655	83656
19307	26904	6	applied	\N	\N	\N	\N	83657	83657	83658
19312	26921	0	applied	\N	\N	\N	\N	83700	83700	83701
19312	26922	1	applied	\N	\N	\N	\N	83702	83702	83703
19312	26923	2	applied	\N	\N	\N	\N	83704	83704	83705
19317	26931	0	applied	\N	\N	\N	\N	83725	83725	83726
19317	26932	1	applied	\N	\N	\N	\N	83727	83727	83728
19317	26933	2	applied	\N	\N	\N	\N	83729	83729	83730
19317	26934	3	applied	\N	\N	\N	\N	83731	83731	83732
19317	26935	4	applied	\N	\N	\N	\N	83733	83733	83734
19317	26936	5	applied	\N	\N	\N	\N	83735	83735	83736
19317	26937	6	applied	\N	\N	\N	\N	83737	83737	83738
19317	26938	7	applied	\N	\N	\N	\N	83739	83739	83740
19319	26939	0	applied	\N	\N	\N	\N	83745	83745	83746
19319	26940	1	applied	\N	\N	\N	\N	83747	83747	83748
19319	26941	2	applied	\N	\N	\N	\N	83749	83749	83750
19321	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19321	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19321	26798	2	applied	\N	\N	\N	\N	83404	83404	83405
19321	26708	3	applied	\N	\N	1000000000	\N	83118	83118	83119
19321	26815	4	applied	\N	\N	\N	\N	83445	83445	83446
19321	26723	5	applied	\N	\N	\N	\N	83175	83175	83176
19321	26560	6	applied	\N	\N	\N	\N	82711	82711	82712
19321	26561	7	applied	\N	\N	\N	\N	82713	82713	82714
19321	26562	8	applied	\N	\N	\N	\N	82715	82715	82716
19321	26738	9	applied	\N	\N	1000000000	\N	83210	83210	83211
19321	26823	10	applied	\N	\N	\N	\N	83762	83762	83466
19321	26824	11	applied	\N	\N	\N	\N	83763	83763	83468
19321	26565	12	applied	\N	\N	\N	\N	82721	82721	82722
19321	26584	13	applied	\N	\N	\N	\N	82770	82770	82771
19321	26825	14	applied	\N	\N	\N	\N	83764	83764	83470
19321	26826	15	applied	\N	\N	\N	\N	83765	83765	83472
19321	26827	16	applied	\N	\N	\N	\N	83766	83766	83474
19321	26878	17	applied	\N	\N	\N	\N	83767	83767	83602
19321	26881	18	applied	\N	\N	\N	\N	83768	83768	83608
19321	26882	19	applied	\N	\N	\N	\N	83769	83769	83610
19321	26883	20	applied	\N	\N	\N	\N	83770	83770	83612
19321	26884	21	applied	\N	\N	\N	\N	83771	83771	83614
19321	26910	22	applied	\N	\N	\N	\N	83772	83772	83677
19321	26911	23	applied	\N	\N	\N	\N	83773	83773	83679
19321	26912	24	applied	\N	\N	\N	\N	83774	83774	83681
19321	26914	25	applied	\N	\N	\N	\N	83775	83775	83685
19321	26915	26	applied	\N	\N	\N	\N	83776	83776	83687
19321	26932	27	applied	\N	\N	\N	\N	83777	83777	83728
19321	26933	28	applied	\N	\N	\N	\N	83778	83778	83730
19321	26934	29	applied	\N	\N	\N	\N	83779	83779	83732
19321	26935	30	applied	\N	\N	\N	\N	83780	83780	83734
19321	26936	31	applied	\N	\N	\N	\N	83781	83781	83736
19321	26887	32	applied	\N	\N	\N	\N	83619	83619	83782
19321	26836	33	applied	\N	\N	\N	\N	83783	83783	83499
19321	26839	34	applied	\N	\N	1000000000	\N	83504	83504	83505
19321	26840	35	applied	\N	\N	1000000000	\N	83506	83506	83507
19321	26841	36	applied	\N	\N	1000000000	\N	83508	83508	83509
19321	26757	37	applied	\N	\N	\N	\N	83255	83255	83256
19321	26651	38	applied	\N	\N	\N	\N	82965	82965	47675
19321	26844	39	applied	\N	\N	\N	\N	83514	83514	83515
19321	26845	40	applied	\N	\N	\N	\N	83516	83516	83517
19321	26846	41	applied	\N	\N	1000000000	\N	83518	83518	83519
19321	26847	42	applied	\N	\N	1000000000	\N	83520	83520	83521
19321	26917	43	applied	\N	\N	1000000000	\N	83690	83690	83691
19321	26918	44	applied	\N	\N	1000000000	\N	83692	83692	83693
19321	26896	45	applied	\N	\N	\N	\N	83637	83637	83637
19322	26798	0	applied	\N	\N	\N	\N	83404	83404	83405
19322	26708	1	applied	\N	\N	1000000000	\N	83118	83118	83119
19322	26815	2	applied	\N	\N	\N	\N	83445	83445	83446
19322	26723	3	applied	\N	\N	\N	\N	83175	83175	83176
19322	26738	4	applied	\N	\N	1000000000	\N	83210	83210	83211
19322	26823	5	applied	\N	\N	\N	\N	83762	83762	83466
19322	26824	6	applied	\N	\N	\N	\N	83763	83763	83468
19322	26825	7	applied	\N	\N	\N	\N	83764	83764	83470
19322	26616	8	applied	\N	\N	\N	\N	82868	82868	82869
19322	26619	9	applied	\N	\N	\N	\N	82880	82880	82881
19322	26622	10	applied	\N	\N	\N	\N	82886	82886	82887
19322	26623	11	applied	\N	\N	\N	\N	82888	82888	82889
19279	26804	2	applied	\N	\N	\N	\N	83417	83417	83418
19279	26805	3	applied	\N	\N	\N	\N	83419	83419	83420
19279	26806	4	applied	\N	\N	\N	\N	83421	83421	83422
19279	26807	5	applied	\N	\N	\N	\N	83423	83423	83424
19281	26808	0	applied	\N	\N	\N	\N	83427	83427	83428
19281	26809	1	applied	\N	\N	\N	\N	83429	83429	83430
19281	26810	2	applied	\N	\N	\N	\N	83431	83431	83432
19284	26815	0	applied	\N	\N	\N	\N	83445	83445	83446
19284	26816	1	applied	\N	\N	\N	\N	83447	83447	83448
19284	26817	2	applied	\N	\N	\N	\N	83449	83449	83450
19284	26818	3	applied	\N	\N	\N	\N	83451	83451	83452
19284	26819	4	applied	\N	\N	\N	\N	83453	83453	83454
19284	26820	5	applied	\N	\N	\N	\N	83455	83455	83456
19284	26821	6	applied	\N	\N	\N	\N	83457	83457	83458
19288	26830	0	applied	\N	\N	\N	\N	83485	83485	83486
19288	26831	1	applied	\N	\N	\N	\N	83487	83487	83488
19288	26832	2	applied	\N	\N	\N	\N	83489	83489	83490
19288	26833	3	applied	\N	\N	\N	\N	83491	83491	83492
19293	26855	0	applied	\N	\N	\N	\N	83541	83541	83542
19293	26856	1	applied	\N	\N	\N	\N	83543	83543	83544
19293	26857	2	applied	\N	\N	\N	\N	83545	83545	83546
19304	26878	0	applied	\N	\N	\N	\N	83601	83601	83602
19304	26879	1	applied	\N	\N	\N	\N	83603	83603	83604
19304	26880	2	applied	\N	\N	\N	\N	83605	83605	83606
19304	26881	3	applied	\N	\N	\N	\N	83607	83607	83608
19304	26882	4	applied	\N	\N	\N	\N	83609	83609	83610
19304	26883	5	applied	\N	\N	\N	\N	83611	83611	83612
19304	26884	6	applied	\N	\N	\N	\N	83613	83613	83614
19304	26885	7	applied	\N	\N	\N	\N	83615	83615	83616
19304	26886	8	applied	\N	\N	\N	\N	83617	83617	83618
19304	26887	9	applied	\N	\N	\N	\N	83619	83619	83620
19304	26888	10	applied	\N	\N	\N	\N	83621	83621	83622
19304	26889	11	applied	\N	\N	\N	\N	83623	83623	83624
19304	26890	12	applied	\N	\N	\N	\N	83625	83625	83626
19304	26891	13	applied	\N	\N	\N	\N	83627	83627	83628
19304	26892	14	applied	\N	\N	\N	\N	83629	83629	83630
19304	26893	15	applied	\N	\N	\N	\N	83631	83631	83632
19304	26894	16	applied	\N	\N	\N	\N	83633	83633	83634
19304	26895	17	applied	\N	\N	\N	\N	83635	83635	83636
19304	26896	18	applied	\N	\N	\N	\N	83637	83637	83637
19304	26897	19	applied	\N	\N	\N	\N	83638	83638	83639
19311	26910	0	applied	\N	\N	\N	\N	83676	83676	83677
19311	26911	1	applied	\N	\N	\N	\N	83678	83678	83679
19311	26912	2	applied	\N	\N	\N	\N	83680	83680	83681
19311	26913	3	applied	\N	\N	\N	\N	83682	83682	83683
19311	26914	4	applied	\N	\N	\N	\N	83684	83684	83685
19311	26915	5	applied	\N	\N	\N	\N	83686	83686	83687
19311	26916	6	applied	\N	\N	\N	\N	83688	83688	83689
19311	26917	7	applied	\N	\N	1000000000	\N	83690	83690	83691
19311	26918	8	applied	\N	\N	1000000000	\N	83692	83692	83693
19311	26919	9	applied	\N	\N	\N	\N	83694	83694	83695
19311	26920	10	applied	\N	\N	\N	\N	83696	83696	83697
19314	26921	0	applied	\N	\N	\N	\N	83700	83700	83701
19314	26922	1	applied	\N	\N	\N	\N	83702	83702	83703
19314	26923	2	applied	\N	\N	\N	\N	83704	83704	83705
19315	26921	0	applied	\N	\N	\N	\N	83700	83700	83701
19315	26922	1	applied	\N	\N	\N	\N	83702	83702	83703
19315	26923	2	applied	\N	\N	\N	\N	83704	83704	83705
19326	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19326	26965	1	applied	\N	\N	\N	\N	83834	83834	83835
19326	26966	2	applied	\N	\N	\N	\N	83836	83836	83837
19326	26967	3	applied	\N	\N	\N	\N	83838	83838	83839
19326	26968	4	applied	\N	\N	\N	\N	83840	83840	83841
19326	26969	5	applied	\N	\N	\N	\N	83842	83842	83843
19326	26970	6	applied	\N	\N	\N	\N	83844	83844	83845
19326	26971	7	applied	\N	\N	\N	\N	83846	83846	83847
19326	26972	8	applied	\N	\N	\N	\N	83848	83848	83849
19326	26973	9	applied	\N	\N	\N	\N	83850	83850	83851
19326	26974	10	applied	\N	\N	\N	\N	83852	83852	83853
19331	26975	0	applied	\N	\N	\N	\N	83860	83860	83861
19331	26976	1	applied	\N	\N	\N	\N	83862	83862	83863
19331	26977	2	applied	\N	\N	\N	\N	83864	83864	83865
19331	26978	3	applied	\N	\N	\N	\N	83866	83866	83867
19331	26979	5	applied	\N	\N	\N	\N	83869	83869	83870
19331	26980	6	applied	\N	\N	\N	\N	83871	83871	83872
19331	26981	7	applied	\N	\N	\N	\N	83873	83873	83874
19331	26982	8	applied	\N	\N	\N	\N	83875	83875	83876
19331	26983	9	applied	\N	\N	\N	\N	83877	83877	83878
19331	26984	10	applied	\N	\N	\N	\N	83879	83879	83880
19334	26985	0	applied	\N	\N	\N	\N	83886	83886	83887
19334	26986	1	applied	\N	\N	\N	\N	83888	83888	83889
19334	26987	2	applied	\N	\N	\N	\N	83890	83890	83891
19334	26988	3	applied	\N	\N	\N	\N	83892	83892	83893
19336	27004	0	applied	\N	\N	\N	\N	83929	83929	83930
19336	27005	1	applied	\N	\N	\N	\N	83931	83931	83932
19336	27006	2	applied	\N	\N	\N	\N	83933	83933	83934
19336	27007	3	applied	\N	\N	\N	\N	83935	83935	83936
19338	27008	0	applied	\N	\N	\N	\N	83940	83940	83941
19338	27009	1	applied	\N	\N	\N	\N	83942	83942	83943
19338	27010	2	applied	\N	\N	\N	\N	83944	83944	83945
19338	27011	3	applied	\N	\N	\N	\N	83946	83946	83946
19345	27025	0	applied	\N	\N	\N	\N	83979	83979	83980
19345	27026	1	applied	\N	\N	\N	\N	83981	83981	83982
19345	27027	2	applied	\N	\N	\N	\N	83983	83983	83984
19352	27035	0	applied	\N	\N	\N	\N	84025	84025	84026
19352	27036	1	applied	\N	\N	\N	\N	84027	84027	84028
19352	27037	2	applied	\N	\N	\N	\N	84029	84029	84030
19354	27035	0	applied	\N	\N	\N	\N	84025	84025	84026
19354	27038	1	applied	\N	\N	\N	\N	84036	84036	84037
19354	27039	2	applied	\N	\N	\N	\N	84038	84038	84039
19354	27040	3	applied	\N	\N	\N	\N	84040	84040	84041
19354	27041	4	applied	\N	\N	\N	\N	84042	84042	84043
19354	27042	5	applied	\N	\N	\N	\N	84044	84044	84045
19354	27043	6	applied	\N	\N	\N	\N	84046	84046	84047
19354	27037	7	applied	\N	\N	\N	\N	84029	84029	84048
19354	27044	8	applied	\N	\N	\N	\N	84049	84049	84050
19354	27045	9	applied	\N	\N	\N	\N	84051	84051	84052
19354	27046	10	applied	\N	\N	\N	\N	84053	84053	84054
19354	27047	11	applied	\N	\N	\N	\N	84055	84055	84056
19355	27048	0	applied	\N	\N	\N	\N	84059	84059	84060
19355	27049	1	applied	\N	\N	\N	\N	84061	84061	84062
19355	27050	2	applied	\N	\N	\N	\N	84063	84063	84064
19355	27051	3	applied	\N	\N	\N	\N	84065	84065	84066
19355	27052	4	applied	\N	\N	\N	\N	84067	84067	84068
19355	27053	5	applied	\N	\N	\N	\N	84069	84069	84070
19355	27054	6	applied	\N	\N	\N	\N	84071	84071	84072
19355	27055	7	applied	\N	\N	\N	\N	84073	84073	84074
19355	27056	8	applied	\N	\N	1000000000	\N	84075	84075	84076
19355	27057	9	applied	\N	\N	\N	\N	84077	84077	84078
19306	26896	18	applied	\N	\N	\N	\N	83637	83637	83637
19306	26897	19	applied	\N	\N	\N	\N	83638	83638	83639
19308	26898	0	applied	\N	\N	\N	\N	83645	83645	83646
19308	26899	1	applied	\N	\N	\N	\N	83647	83647	83648
19308	26900	2	applied	\N	\N	\N	\N	83649	83649	83650
19308	26901	3	applied	\N	\N	\N	\N	83651	83651	83652
19308	26902	4	applied	\N	\N	\N	\N	83653	83653	83654
19308	26903	5	applied	\N	\N	\N	\N	83655	83655	83656
19308	26904	6	applied	\N	\N	\N	\N	83657	83657	83658
19310	26907	0	applied	\N	\N	\N	\N	83668	83668	83669
19310	26908	1	applied	\N	\N	\N	\N	83670	83670	83671
19310	26909	2	applied	\N	\N	\N	\N	83672	83672	83673
19313	26921	0	applied	\N	\N	\N	\N	83700	83700	83701
19313	26922	1	applied	\N	\N	\N	\N	83702	83702	83703
19313	26923	2	applied	\N	\N	\N	\N	83704	83704	83705
19318	26931	0	applied	\N	\N	\N	\N	83725	83725	83726
19318	26932	1	applied	\N	\N	\N	\N	83727	83727	83728
19318	26933	2	applied	\N	\N	\N	\N	83729	83729	83730
19318	26934	3	applied	\N	\N	\N	\N	83731	83731	83732
19318	26935	4	applied	\N	\N	\N	\N	83733	83733	83734
19318	26936	5	applied	\N	\N	\N	\N	83735	83735	83736
19318	26937	6	applied	\N	\N	\N	\N	83737	83737	83738
19318	26938	7	applied	\N	\N	\N	\N	83739	83739	83740
19320	26942	0	applied	\N	\N	\N	\N	83753	83753	83754
19320	26943	1	applied	\N	\N	\N	\N	83755	83755	83756
19320	26944	2	applied	\N	\N	\N	\N	83757	83757	83758
19320	26945	3	applied	\N	\N	\N	\N	83759	83759	83760
19323	26946	0	applied	\N	\N	\N	\N	83785	83785	83786
19323	26947	1	applied	\N	\N	\N	\N	83787	83787	83788
19323	26948	2	applied	\N	\N	\N	\N	83789	83789	83790
19323	26949	3	applied	\N	\N	\N	\N	83798	83798	83799
19323	26950	4	applied	\N	\N	\N	\N	83800	83800	83801
19323	26951	5	applied	\N	\N	\N	\N	83802	83802	83803
19323	26952	6	applied	\N	\N	\N	\N	83804	83804	83805
19323	26953	7	applied	\N	\N	\N	\N	83806	83806	83807
19323	26954	8	applied	\N	\N	\N	\N	83808	83808	83809
19328	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19328	26965	1	applied	\N	\N	\N	\N	83834	83834	83835
19328	26966	2	applied	\N	\N	\N	\N	83836	83836	83837
19328	26967	3	applied	\N	\N	\N	\N	83838	83838	83839
19328	26968	4	applied	\N	\N	\N	\N	83840	83840	83841
19328	26969	5	applied	\N	\N	\N	\N	83842	83842	83843
19328	26970	6	applied	\N	\N	\N	\N	83844	83844	83845
19328	26971	7	applied	\N	\N	\N	\N	83846	83846	83847
19328	26972	8	applied	\N	\N	\N	\N	83848	83848	83849
19328	26973	9	applied	\N	\N	\N	\N	83850	83850	83851
19328	26974	10	applied	\N	\N	\N	\N	83852	83852	83853
19330	26975	0	applied	\N	\N	\N	\N	83860	83860	83861
19330	26976	1	applied	\N	\N	\N	\N	83862	83862	83863
19330	26977	2	applied	\N	\N	\N	\N	83864	83864	83865
19330	26978	3	applied	\N	\N	\N	\N	83866	83866	83867
19330	26979	5	applied	\N	\N	\N	\N	83869	83869	83870
19330	26980	6	applied	\N	\N	\N	\N	83871	83871	83872
19330	26981	7	applied	\N	\N	\N	\N	83873	83873	83874
19330	26982	8	applied	\N	\N	\N	\N	83875	83875	83876
19330	26983	9	applied	\N	\N	\N	\N	83877	83877	83878
19330	26984	10	applied	\N	\N	\N	\N	83879	83879	83880
19333	26985	0	applied	\N	\N	\N	\N	83886	83886	83887
19333	26986	1	applied	\N	\N	\N	\N	83888	83888	83889
19333	26987	2	applied	\N	\N	\N	\N	83890	83890	83891
19333	26988	3	applied	\N	\N	\N	\N	83892	83892	83893
19335	26989	0	applied	\N	\N	\N	\N	83899	83899	83900
19335	26990	1	applied	\N	\N	\N	\N	83901	83901	83902
19335	26991	2	applied	\N	\N	\N	\N	83903	83903	83904
19335	26992	3	applied	\N	\N	\N	\N	83905	83905	83906
19335	26993	4	applied	\N	\N	\N	\N	83907	83907	83908
19335	26994	5	applied	\N	\N	\N	\N	83909	83909	83910
19335	26995	6	applied	\N	\N	\N	\N	83911	83911	83912
19335	26996	7	applied	\N	\N	\N	\N	83913	83913	83914
19335	26997	8	applied	\N	\N	\N	\N	83915	83915	83916
19335	26998	9	applied	\N	\N	\N	\N	83917	83917	83918
19335	26999	10	applied	\N	\N	\N	\N	83919	83919	83920
19335	27000	11	applied	\N	\N	\N	\N	83921	83921	83922
19335	27001	12	applied	\N	\N	\N	\N	83923	83923	83924
19335	27002	13	applied	\N	\N	\N	\N	83925	83925	83926
19335	27003	14	applied	\N	\N	\N	\N	83927	83927	12588
19341	27012	0	applied	\N	\N	\N	\N	83948	83948	83949
19341	27013	1	applied	\N	\N	\N	\N	83950	83950	83951
19341	27014	2	applied	\N	\N	\N	\N	83952	83952	83952
19341	27015	3	applied	\N	\N	\N	\N	83953	83953	83954
19341	27016	4	applied	\N	\N	\N	\N	83955	83955	83955
19341	27017	5	applied	\N	\N	\N	\N	83956	83956	83957
19341	27018	6	applied	\N	\N	\N	\N	83958	83958	83958
19341	27019	7	applied	\N	\N	\N	\N	83959	83959	83960
19341	27020	8	applied	\N	\N	\N	\N	83961	83961	83962
19341	27021	9	applied	\N	\N	\N	\N	83963	83963	83964
19343	27012	0	applied	\N	\N	\N	\N	83948	83948	83949
19343	27013	1	applied	\N	\N	\N	\N	83950	83950	83951
19343	27014	2	applied	\N	\N	\N	\N	83952	83952	83952
19343	27015	3	applied	\N	\N	\N	\N	83953	83953	83954
19343	27016	4	applied	\N	\N	\N	\N	83955	83955	83955
19343	27017	5	applied	\N	\N	\N	\N	83956	83956	83957
19343	27018	6	applied	\N	\N	\N	\N	83958	83958	83958
19343	27019	7	applied	\N	\N	\N	\N	83959	83959	83960
19343	27020	8	applied	\N	\N	\N	\N	83961	83961	83962
19343	27021	9	applied	\N	\N	\N	\N	83963	83963	83964
19349	26964	0	applied	\N	\N	\N	\N	83833	83833	47675
19349	26955	1	applied	\N	\N	\N	\N	83998	83998	83812
19349	26956	2	applied	\N	\N	\N	\N	83999	83999	83814
19349	26958	3	applied	\N	\N	\N	\N	84000	84000	83818
19349	26959	4	applied	\N	\N	\N	\N	84001	84001	83820
19349	26960	5	applied	\N	\N	\N	\N	84002	84002	83822
19349	26977	6	applied	\N	\N	\N	\N	84003	84003	83865
19349	26978	7	applied	\N	\N	\N	\N	84004	84004	83867
19349	26979	8	applied	\N	\N	\N	\N	84005	84005	83870
19349	26980	10	applied	\N	\N	\N	\N	84007	84007	83872
19349	26981	11	applied	\N	\N	\N	\N	84008	84008	83874
19349	26989	12	applied	\N	\N	\N	\N	84009	84009	83900
19349	26990	13	applied	\N	\N	\N	\N	84010	84010	83902
19349	26991	14	applied	\N	\N	\N	\N	84011	84011	83904
19349	26992	15	applied	\N	\N	\N	\N	84012	84012	83906
19349	26993	16	applied	\N	\N	\N	\N	84013	84013	83908
19349	27003	17	applied	\N	\N	\N	\N	83927	83927	12588
19349	27011	18	applied	\N	\N	\N	\N	83946	83946	83946
19349	27014	19	applied	\N	\N	\N	\N	83952	83952	83952
19349	27016	20	applied	\N	\N	\N	\N	83955	83955	83955
19349	27018	21	applied	\N	\N	\N	\N	83958	83958	83958
19351	27035	0	applied	\N	\N	\N	\N	84025	84025	84026
19351	27036	1	applied	\N	\N	\N	\N	84027	84027	84028
19351	27037	2	applied	\N	\N	\N	\N	84029	84029	84030
19322	26629	12	applied	\N	\N	\N	\N	82912	82912	82913
19322	26630	13	applied	\N	\N	\N	\N	82914	82914	82915
19322	26636	14	applied	\N	\N	\N	\N	82931	82931	82932
19322	26637	15	applied	\N	\N	\N	\N	82933	82933	82934
19322	26642	16	applied	\N	\N	\N	\N	82947	82947	82948
19322	26643	17	applied	\N	\N	\N	\N	82949	82949	82950
19322	26644	18	applied	\N	\N	\N	\N	82951	82951	82952
19322	26645	19	applied	\N	\N	\N	\N	82953	82953	82954
19322	26646	20	applied	\N	\N	\N	\N	82955	82955	82956
19322	26659	21	applied	\N	\N	\N	\N	82982	82982	82983
19322	26662	22	applied	\N	\N	\N	\N	82992	82992	82993
19322	26665	23	applied	\N	\N	\N	\N	83000	83000	83001
19322	26669	24	applied	\N	\N	\N	\N	83012	83012	83013
19322	26672	25	applied	\N	\N	\N	\N	83019	83019	83020
19322	26673	26	applied	\N	\N	\N	\N	83021	83021	83022
19322	26674	27	applied	\N	\N	\N	\N	83023	83023	83024
19322	26675	28	applied	\N	\N	\N	\N	83025	83025	83026
19322	26676	29	applied	\N	\N	\N	\N	83027	83027	83028
19322	26677	30	applied	\N	\N	\N	\N	83029	83029	83030
19322	26692	31	applied	\N	\N	\N	\N	83072	83072	83073
19322	26693	32	applied	\N	\N	\N	\N	83074	83074	83075
19322	26694	33	applied	\N	\N	\N	\N	83076	83076	83077
19322	26702	34	applied	\N	\N	\N	\N	83101	83101	83102
19322	26703	35	applied	\N	\N	\N	\N	83103	83103	83104
19322	26709	36	applied	\N	\N	\N	\N	83121	83121	83122
19322	26713	37	applied	\N	\N	\N	\N	83140	83140	83141
19322	26716	38	applied	\N	\N	\N	\N	83147	83147	83148
19322	26719	39	applied	\N	\N	\N	\N	83159	83159	83160
19322	26722	40	applied	\N	\N	\N	\N	83173	83173	83174
19322	26728	41	applied	\N	\N	\N	\N	83186	83186	83187
19322	26729	42	applied	\N	\N	\N	\N	83188	83188	83189
19322	26734	43	applied	\N	\N	\N	\N	83200	83200	83201
19322	26741	44	applied	\N	\N	\N	\N	83219	83219	83220
19322	26742	45	applied	\N	\N	\N	\N	83221	83221	83222
19322	26748	46	applied	\N	\N	\N	\N	83234	83234	83235
19322	26751	47	applied	\N	\N	\N	\N	83243	83243	83244
19322	26754	48	applied	\N	\N	\N	\N	83249	83249	83250
19322	26755	49	applied	\N	\N	\N	\N	83251	83251	83252
19322	26762	50	applied	\N	\N	\N	\N	83303	83303	83304
19322	26763	51	applied	\N	\N	\N	\N	83305	83305	83306
19322	26764	52	applied	\N	\N	\N	\N	83307	83307	83308
19322	26772	53	applied	\N	\N	\N	\N	83331	83331	83332
19322	26775	54	applied	\N	\N	\N	\N	83339	83339	83340
19322	26778	55	applied	\N	\N	\N	\N	83347	83347	83348
19322	26782	56	applied	\N	\N	\N	\N	83356	83356	83357
19322	26785	57	applied	\N	\N	\N	\N	83362	83362	83363
19322	26788	58	applied	\N	\N	\N	\N	83379	83379	83380
19322	26791	59	applied	\N	\N	\N	\N	83385	83385	83386
19322	26795	60	applied	\N	\N	\N	\N	83394	83394	83395
19322	26799	61	applied	\N	\N	\N	\N	83406	83406	83407
19322	26802	62	applied	\N	\N	\N	\N	83413	83413	83414
19322	26803	63	applied	\N	\N	\N	\N	83415	83415	83416
19322	26808	64	applied	\N	\N	\N	\N	83427	83427	83428
19322	26811	65	applied	\N	\N	\N	\N	83435	83435	83436
19322	26816	66	applied	\N	\N	\N	\N	83447	83447	83448
19322	26817	67	applied	\N	\N	\N	\N	83449	83449	83450
19322	26822	68	applied	\N	\N	\N	\N	83463	83463	83464
19322	26830	69	applied	\N	\N	\N	\N	83485	83485	83486
19322	26834	70	applied	\N	\N	\N	\N	83494	83494	83495
19322	26835	71	applied	\N	\N	\N	\N	83496	83496	83497
19322	26848	72	applied	\N	\N	\N	\N	83524	83524	83525
19322	26849	73	applied	\N	\N	\N	\N	83526	83526	83527
19322	26855	74	applied	\N	\N	\N	\N	83541	83541	83542
19322	26858	75	applied	\N	\N	\N	\N	83553	83553	83554
19322	26859	76	applied	\N	\N	\N	\N	83555	83555	83556
19322	26865	77	applied	\N	\N	\N	\N	83568	83568	83569
19322	26868	78	applied	\N	\N	\N	\N	83574	83574	83575
19322	26871	79	applied	\N	\N	\N	\N	83582	83582	83583
19322	26875	80	applied	\N	\N	\N	\N	83592	83592	83593
19322	26879	81	applied	\N	\N	\N	\N	83603	83603	83604
19322	26880	82	applied	\N	\N	\N	\N	83605	83605	83606
19322	26885	83	applied	\N	\N	\N	\N	83615	83615	83616
19322	26886	84	applied	\N	\N	\N	\N	83617	83617	83618
19322	26898	85	applied	\N	\N	\N	\N	83645	83645	83646
19322	26899	86	applied	\N	\N	\N	\N	83647	83647	83648
19322	26907	87	applied	\N	\N	\N	\N	83668	83668	83669
19322	26913	88	applied	\N	\N	\N	\N	83682	83682	83683
19322	26921	89	applied	\N	\N	\N	\N	83700	83700	83701
19322	26924	90	applied	\N	\N	\N	\N	83709	83709	83710
19322	26925	91	applied	\N	\N	\N	\N	83711	83711	83712
19322	26931	92	applied	\N	\N	\N	\N	83725	83725	83726
19322	26939	93	applied	\N	\N	\N	\N	83745	83745	83746
19322	26942	94	applied	\N	\N	\N	\N	83753	83753	83754
19322	26946	95	applied	\N	\N	\N	\N	83785	83785	83786
19322	26947	96	applied	\N	\N	\N	\N	83787	83787	83788
19322	26948	97	applied	\N	\N	\N	\N	83789	83789	83790
19322	26826	98	applied	\N	\N	\N	\N	83765	83765	83472
19322	26827	99	applied	\N	\N	\N	\N	83766	83766	83474
19322	26878	100	applied	\N	\N	\N	\N	83767	83767	83602
19322	26881	101	applied	\N	\N	\N	\N	83768	83768	83608
19322	26882	102	applied	\N	\N	\N	\N	83769	83769	83610
19322	26883	103	applied	\N	\N	\N	\N	83770	83770	83612
19322	26884	104	applied	\N	\N	\N	\N	83771	83771	83614
19322	26910	106	applied	\N	\N	\N	\N	83772	83772	83677
19322	26911	107	applied	\N	\N	\N	\N	83773	83773	83679
19322	26912	108	applied	\N	\N	\N	\N	83774	83774	83681
19322	26914	109	applied	\N	\N	\N	\N	83775	83775	83685
19322	26915	110	applied	\N	\N	\N	\N	83776	83776	83687
19322	26932	111	applied	\N	\N	\N	\N	83777	83777	83728
19322	26933	112	applied	\N	\N	\N	\N	83778	83778	83730
19322	26934	113	applied	\N	\N	\N	\N	83779	83779	83732
19322	26935	114	applied	\N	\N	\N	\N	83780	83780	83734
19322	26936	115	applied	\N	\N	\N	\N	83781	83781	83736
19322	26887	116	applied	\N	\N	\N	\N	83619	83619	83782
19322	26617	117	applied	\N	\N	\N	\N	82870	82870	82871
19322	26836	118	applied	\N	\N	\N	\N	83783	83783	83499
19322	26625	119	applied	\N	\N	\N	\N	82892	82892	83792
19322	26618	120	applied	\N	\N	\N	\N	82872	82872	83793
19322	26620	121	applied	\N	\N	\N	\N	82882	82882	83794
19322	26624	122	applied	\N	\N	\N	\N	82890	82890	83795
19322	26839	123	applied	\N	\N	1000000000	\N	83504	83504	83505
19322	26840	124	applied	\N	\N	1000000000	\N	83506	83506	83507
19322	26841	125	applied	\N	\N	1000000000	\N	83508	83508	83509
19325	26955	0	applied	\N	\N	\N	\N	83811	83811	83812
19325	26956	1	applied	\N	\N	\N	\N	83813	83813	83814
19325	26957	2	applied	\N	\N	\N	\N	83815	83815	83816
19325	26958	3	applied	\N	\N	\N	\N	83817	83817	83818
19325	26959	4	applied	\N	\N	\N	\N	83819	83819	83820
19325	26960	5	applied	\N	\N	\N	\N	83821	83821	83822
19325	26961	6	applied	\N	\N	\N	\N	83823	83823	83824
19325	26962	7	applied	\N	\N	\N	\N	83825	83825	83826
19325	26963	8	applied	\N	\N	\N	\N	83827	83827	83828
19332	26985	0	applied	\N	\N	\N	\N	83886	83886	83887
19332	26986	1	applied	\N	\N	\N	\N	83888	83888	83889
19332	26987	2	applied	\N	\N	\N	\N	83890	83890	83891
19332	26988	3	applied	\N	\N	\N	\N	83892	83892	83893
19337	27004	0	applied	\N	\N	\N	\N	83929	83929	83930
19337	27005	1	applied	\N	\N	\N	\N	83931	83931	83932
19337	27007	2	applied	\N	\N	\N	\N	83935	83935	83938
19340	27012	0	applied	\N	\N	\N	\N	83948	83948	83949
19340	27013	1	applied	\N	\N	\N	\N	83950	83950	83951
19340	27014	2	applied	\N	\N	\N	\N	83952	83952	83952
19340	27015	3	applied	\N	\N	\N	\N	83953	83953	83954
19340	27016	4	applied	\N	\N	\N	\N	83955	83955	83955
19340	27017	5	applied	\N	\N	\N	\N	83956	83956	83957
19340	27018	6	applied	\N	\N	\N	\N	83958	83958	83958
19340	27019	7	applied	\N	\N	\N	\N	83959	83959	83960
19340	27020	8	applied	\N	\N	\N	\N	83961	83961	83962
19340	27021	9	applied	\N	\N	\N	\N	83963	83963	83964
19342	27012	0	applied	\N	\N	\N	\N	83948	83948	83949
19342	27013	1	applied	\N	\N	\N	\N	83950	83950	83951
19342	27014	2	applied	\N	\N	\N	\N	83952	83952	83952
19342	27015	3	applied	\N	\N	\N	\N	83953	83953	83954
19342	27016	4	applied	\N	\N	\N	\N	83955	83955	83955
19342	27017	5	applied	\N	\N	\N	\N	83956	83956	83957
19342	27018	6	applied	\N	\N	\N	\N	83958	83958	83958
19342	27019	7	applied	\N	\N	\N	\N	83959	83959	83960
19342	27020	8	applied	\N	\N	\N	\N	83961	83961	83962
19342	27021	9	applied	\N	\N	\N	\N	83963	83963	83964
19344	27022	0	applied	\N	\N	\N	\N	83973	83973	83974
19344	27023	1	applied	\N	\N	\N	\N	83975	83975	83976
19344	27024	2	applied	\N	\N	\N	\N	83977	83977	83978
19347	27028	0	applied	\N	\N	\N	\N	83986	83986	83987
19347	27029	1	applied	\N	\N	\N	\N	83988	83988	83989
19347	27030	2	applied	\N	\N	\N	\N	83990	83990	83991
19347	27031	3	applied	\N	\N	\N	\N	83992	83992	83993
19350	27032	0	applied	\N	\N	\N	\N	84017	84017	84018
19350	27033	1	applied	\N	\N	\N	\N	84019	84019	84020
19350	27034	2	applied	\N	\N	\N	\N	84021	84021	84022
19357	27048	0	applied	\N	\N	\N	\N	84059	84059	84060
19357	27049	1	applied	\N	\N	\N	\N	84061	84061	84062
19357	27050	2	applied	\N	\N	\N	\N	84063	84063	84064
19357	27051	3	applied	\N	\N	\N	\N	84065	84065	84066
19357	27052	4	applied	\N	\N	\N	\N	84067	84067	84068
19357	27053	5	applied	\N	\N	\N	\N	84069	84069	84070
19357	27054	6	applied	\N	\N	\N	\N	84071	84071	84072
19357	27055	7	applied	\N	\N	\N	\N	84073	84073	84074
19357	27056	8	applied	\N	\N	1000000000	\N	84075	84075	84076
19357	27057	9	applied	\N	\N	\N	\N	84077	84077	84078
19357	27058	10	applied	\N	\N	\N	\N	84079	84079	84080
19357	27059	11	applied	\N	\N	\N	\N	84081	84081	84082
19357	27060	12	applied	\N	\N	\N	\N	84083	84083	84084
19357	27061	13	applied	\N	\N	\N	\N	84085	84085	84086
19357	27062	14	applied	\N	\N	\N	\N	84087	84087	84088
19360	27063	0	applied	\N	\N	\N	\N	84098	84098	84099
19360	27064	1	applied	\N	\N	\N	\N	84100	84100	84101
19360	27065	2	applied	\N	\N	\N	\N	84102	84102	84103
19363	27070	0	applied	\N	\N	\N	\N	84116	84116	84117
19363	27071	1	applied	\N	\N	\N	\N	84118	84118	84119
19363	27072	2	applied	\N	\N	\N	\N	84120	84120	84121
19363	27073	3	applied	\N	\N	\N	\N	84122	84122	84123
19363	27074	4	applied	\N	\N	\N	\N	84124	84124	84125
19370	27088	0	applied	\N	\N	\N	\N	84159	84159	84160
19370	27089	1	applied	\N	\N	\N	\N	84161	84161	84162
19370	27090	2	applied	\N	\N	\N	\N	84163	84163	84164
19370	27091	3	applied	\N	\N	\N	\N	84165	84165	84165
19370	27092	4	applied	\N	\N	\N	\N	84166	84166	84167
19373	27093	0	applied	\N	\N	\N	\N	84172	84172	84173
19373	27094	1	applied	\N	\N	\N	\N	84174	84174	84175
19373	27095	2	applied	\N	\N	\N	\N	84176	84176	84177
19375	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19375	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19375	27098	2	applied	\N	\N	\N	\N	84186	84186	84187
19378	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19378	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19378	27098	2	applied	\N	\N	\N	\N	84186	84186	84187
19382	27099	0	applied	\N	\N	\N	\N	84200	84200	84201
19382	27100	1	applied	\N	\N	\N	\N	84202	84202	84203
19385	27101	0	applied	\N	\N	\N	\N	84205	84205	84206
19385	27102	1	applied	\N	\N	\N	\N	84207	84207	84208
19385	27103	2	applied	\N	\N	\N	\N	84209	84209	84210
19385	27104	3	applied	\N	\N	\N	\N	84211	84211	84212
19392	27127	0	applied	\N	\N	\N	\N	84272	84272	84273
19392	27128	1	applied	\N	\N	\N	\N	84274	84274	84275
19397	27133	0	applied	\N	\N	\N	\N	84287	84287	84288
19397	27134	1	applied	\N	\N	\N	\N	84289	84289	84290
19397	27135	2	applied	\N	\N	\N	\N	84291	84291	84292
19397	27136	3	applied	\N	\N	\N	\N	84293	84293	84294
19403	27141	0	applied	\N	\N	\N	\N	84315	84315	84316
19403	27142	1	applied	\N	\N	\N	\N	84317	84317	84318
19407	27148	0	applied	\N	\N	\N	\N	84335	84335	84336
19407	27149	1	applied	\N	\N	\N	\N	84337	84337	84338
19407	27150	2	applied	\N	\N	\N	\N	84339	84339	84340
19407	27151	3	applied	\N	\N	\N	\N	84341	84341	84342
19409	27152	0	applied	\N	\N	\N	\N	84370	84370	84371
19409	27153	1	applied	\N	\N	\N	\N	84372	84372	84373
19409	27154	2	applied	\N	\N	\N	\N	84374	84374	84375
19415	27168	0	applied	\N	\N	\N	\N	84408	84408	84409
19415	27169	1	applied	\N	\N	\N	\N	84410	84410	84411
19415	27170	2	applied	\N	\N	\N	\N	84412	84412	84413
19417	27171	0	applied	\N	\N	\N	\N	84416	84416	84417
19417	27172	1	applied	\N	\N	\N	\N	84418	84418	84419
19417	27173	2	applied	\N	\N	\N	\N	84420	84420	84421
19417	27174	3	applied	\N	\N	\N	\N	84422	84422	84423
19421	27178	0	applied	\N	\N	\N	\N	84440	84440	84441
19421	27179	1	applied	\N	\N	\N	\N	84442	84442	84443
19421	27180	2	applied	\N	\N	\N	\N	84444	84444	84445
19421	27181	3	applied	\N	\N	\N	\N	84446	84446	84447
19421	27182	4	applied	\N	\N	\N	\N	84448	84448	84449
19421	27183	5	applied	\N	\N	\N	\N	84450	84450	84451
19421	27184	6	applied	\N	\N	\N	\N	84452	84452	84453
19425	27191	0	applied	\N	\N	\N	\N	84472	84472	84473
19425	27192	1	applied	\N	\N	\N	\N	84474	84474	84475
19425	27193	2	applied	\N	\N	\N	\N	84476	84476	84477
19425	27194	3	applied	\N	\N	\N	\N	84478	84478	84479
19430	27202	0	applied	\N	\N	1000000000	\N	84502	84502	84503
19430	27203	1	applied	\N	\N	\N	\N	84504	84504	84505
19430	27204	2	applied	\N	\N	\N	\N	84506	84506	84507
19355	27058	10	applied	\N	\N	\N	\N	84079	84079	84080
19355	27059	11	applied	\N	\N	\N	\N	84081	84081	84082
19355	27060	12	applied	\N	\N	\N	\N	84083	84083	84084
19355	27061	13	applied	\N	\N	\N	\N	84085	84085	84086
19355	27062	14	applied	\N	\N	\N	\N	84087	84087	84088
19359	27048	0	applied	\N	\N	\N	\N	84059	84059	84060
19359	27049	1	applied	\N	\N	\N	\N	84061	84061	84062
19359	27050	2	applied	\N	\N	\N	\N	84063	84063	84064
19359	27051	3	applied	\N	\N	\N	\N	84065	84065	84066
19359	27052	4	applied	\N	\N	\N	\N	84067	84067	84068
19359	27053	5	applied	\N	\N	\N	\N	84069	84069	84070
19359	27054	6	applied	\N	\N	\N	\N	84071	84071	84072
19359	27055	7	applied	\N	\N	\N	\N	84073	84073	84074
19359	27056	8	applied	\N	\N	1000000000	\N	84075	84075	84076
19359	27057	9	applied	\N	\N	\N	\N	84077	84077	84078
19359	27058	10	applied	\N	\N	\N	\N	84079	84079	84080
19359	27059	11	applied	\N	\N	\N	\N	84081	84081	84082
19359	27060	12	applied	\N	\N	\N	\N	84083	84083	84084
19359	27061	13	applied	\N	\N	\N	\N	84085	84085	84086
19359	27062	14	applied	\N	\N	\N	\N	84087	84087	84088
19364	27075	0	applied	\N	\N	\N	\N	84128	84128	84129
19364	27076	1	applied	\N	\N	\N	\N	84130	84130	84131
19364	27077	2	applied	\N	\N	\N	\N	84132	84132	84133
19369	27085	0	applied	\N	\N	\N	\N	84153	84153	84154
19369	27086	1	applied	\N	\N	\N	\N	84155	84155	84156
19369	27087	2	applied	\N	\N	\N	\N	84157	84157	84158
19379	27051	0	applied	\N	\N	\N	\N	84065	84065	84066
19379	27052	1	applied	\N	\N	\N	\N	84067	84067	84068
19379	27053	2	applied	\N	\N	\N	\N	84069	84069	84070
19379	27054	3	applied	\N	\N	\N	\N	84071	84071	84072
19379	27056	4	applied	\N	\N	1000000000	\N	84075	84075	84076
19381	27099	0	applied	\N	\N	\N	\N	84200	84200	84201
19381	27100	1	applied	\N	\N	\N	\N	84202	84202	84203
19383	27101	0	applied	\N	\N	\N	\N	84205	84205	84206
19383	27102	1	applied	\N	\N	\N	\N	84207	84207	84208
19383	27103	2	applied	\N	\N	\N	\N	84209	84209	84210
19383	27104	3	applied	\N	\N	\N	\N	84211	84211	84212
19389	27122	0	applied	\N	\N	\N	\N	84256	84256	84257
19389	27123	1	applied	\N	\N	1000000000	\N	84258	84258	84259
19389	27124	2	applied	\N	\N	\N	\N	84260	84260	84261
19389	27125	3	applied	\N	\N	\N	\N	84262	84262	84263
19389	27126	4	applied	\N	\N	\N	\N	84264	84264	84265
19395	27129	0	applied	\N	\N	\N	\N	84279	84279	24815
19395	27130	1	applied	\N	\N	\N	\N	84280	84280	84281
19395	27131	2	applied	\N	\N	\N	\N	84282	84282	84283
19395	27132	3	applied	\N	\N	\N	\N	84284	84284	84285
19406	27145	0	applied	\N	\N	\N	\N	84326	84326	84327
19406	27147	1	applied	\N	\N	\N	\N	84331	84331	84334
19406	27146	2	applied	\N	\N	\N	\N	84328	84328	84332
19408	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19408	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19408	26798	2	applied	\N	\N	\N	\N	83404	83404	83405
19408	26363	3	applied	\N	\N	1000000000	\N	82149	82149	82150
19408	26354	4	applied	\N	\N	\N	\N	82126	82126	82127
19408	26708	5	applied	\N	\N	1000000000	\N	83118	83118	83119
19408	26364	6	applied	\N	\N	\N	\N	82151	82151	82152
19408	26355	7	applied	\N	\N	\N	\N	82128	82128	82129
19408	26815	8	applied	\N	\N	\N	\N	83445	83445	83446
19408	26723	9	applied	\N	\N	\N	\N	83175	83175	83176
19408	26356	10	applied	\N	\N	\N	\N	82130	82130	82131
19408	26362	11	applied	\N	\N	\N	\N	82143	82143	82144
19408	26365	12	applied	\N	\N	\N	\N	82153	82153	82154
19408	26366	13	applied	\N	\N	\N	\N	82155	82155	82156
19408	26367	14	applied	\N	\N	\N	\N	82157	82157	82158
19408	26560	15	applied	\N	\N	\N	\N	82711	82711	82712
19408	26561	16	applied	\N	\N	\N	\N	82713	82713	82714
19408	26562	17	applied	\N	\N	\N	\N	82715	82715	82716
19408	26738	18	applied	\N	\N	1000000000	\N	83210	83210	83211
19408	26823	19	applied	\N	\N	\N	\N	83762	83762	83466
19408	26824	20	applied	\N	\N	\N	\N	83763	83763	83468
19408	26370	21	applied	\N	\N	\N	\N	82163	82163	82164
19408	26371	22	applied	\N	\N	\N	\N	82165	82165	82166
19408	26376	23	applied	\N	\N	\N	\N	82180	82180	82181
19408	26379	24	applied	\N	\N	\N	\N	82189	82189	82190
19408	26382	25	applied	\N	\N	\N	\N	82202	82202	82203
19408	26385	26	applied	\N	\N	\N	\N	82210	82210	82211
19408	26386	27	applied	\N	\N	\N	\N	82212	82212	82213
19408	26393	28	applied	\N	\N	\N	\N	82235	82235	82236
19408	26394	29	applied	\N	\N	\N	\N	82237	82237	82238
19408	26398	30	applied	\N	\N	\N	\N	82245	82245	82246
19408	26565	31	applied	\N	\N	\N	\N	82721	82721	82722
19408	26584	32	applied	\N	\N	\N	\N	82770	82770	82771
19408	26825	33	applied	\N	\N	\N	\N	83764	83764	83470
19408	26357	34	applied	\N	\N	\N	\N	82132	82132	82132
19408	27051	35	applied	\N	\N	\N	\N	84065	84065	84066
19408	27052	36	applied	\N	\N	\N	\N	84067	84067	84068
19408	27053	37	applied	\N	\N	\N	\N	84069	84069	84070
19408	27054	38	applied	\N	\N	\N	\N	84071	84071	84072
19408	26400	39	applied	\N	\N	\N	\N	82248	82248	82249
19408	26405	40	applied	\N	\N	\N	\N	82260	82260	82261
19408	26406	41	applied	\N	\N	\N	\N	82262	82262	82263
19408	26411	42	applied	\N	\N	\N	\N	82274	82274	82275
19408	26415	43	applied	\N	\N	\N	\N	82281	82281	82282
19408	26417	44	applied	\N	\N	\N	\N	82286	82286	82287
19408	26420	45	applied	\N	\N	\N	\N	82296	82296	82297
19408	26421	46	applied	\N	\N	\N	\N	82298	82298	82299
19408	26422	47	applied	\N	\N	\N	\N	82300	82300	82301
19408	26426	48	applied	\N	\N	\N	\N	82310	82310	82311
19408	26428	49	applied	\N	\N	\N	\N	82337	82337	82338
19408	26429	50	applied	\N	\N	\N	\N	82339	82339	82340
19408	26432	51	applied	\N	\N	\N	\N	82349	82349	82350
19408	26434	52	applied	\N	\N	\N	\N	82357	82357	82358
19408	26440	53	applied	\N	\N	\N	\N	82399	82399	82400
19408	26441	54	applied	\N	\N	\N	\N	82401	82401	82402
19408	26442	55	applied	\N	\N	\N	\N	82408	82408	82409
19408	26443	56	applied	\N	\N	\N	\N	82410	82410	82411
19408	26448	57	applied	\N	\N	\N	\N	82422	82422	82423
19408	26449	58	applied	\N	\N	\N	\N	82424	82424	82425
19408	26450	59	applied	\N	\N	\N	\N	82426	82426	82427
19408	26458	60	applied	\N	\N	\N	\N	82444	82444	82445
19408	26461	61	applied	\N	\N	\N	\N	82452	82452	82453
19408	26464	62	applied	\N	\N	\N	\N	82460	82460	82461
19408	26358	63	applied	\N	\N	\N	\N	82133	82133	82133
19408	26359	64	applied	\N	\N	\N	\N	82134	82134	82134
19408	26368	65	applied	\N	\N	\N	\N	82159	82159	82159
19408	26397	66	applied	\N	\N	\N	\N	82244	82244	82244
19408	26399	67	applied	\N	\N	\N	\N	82247	82247	82247
19408	26468	68	applied	\N	\N	\N	\N	82472	82472	82473
19408	26471	69	applied	\N	\N	\N	\N	82481	82481	82482
19356	26917	6	applied	\N	\N	1000000000	\N	83690	83690	83691
19356	26918	7	applied	\N	\N	1000000000	\N	83692	83692	83693
19356	27056	8	applied	\N	\N	1000000000	\N	84075	84075	84076
19356	26896	9	applied	\N	\N	\N	\N	83637	83637	83637
19356	27003	10	applied	\N	\N	\N	\N	83927	83927	12588
19362	27066	0	applied	\N	\N	\N	\N	84106	84106	84107
19362	27067	1	applied	\N	\N	\N	\N	84108	84108	84109
19362	27068	2	applied	\N	\N	\N	\N	84110	84110	84111
19362	27069	3	applied	\N	\N	\N	\N	84112	84112	84113
19365	27075	0	applied	\N	\N	\N	\N	84128	84128	84129
19365	27076	1	applied	\N	\N	\N	\N	84130	84130	84131
19365	27077	2	applied	\N	\N	\N	\N	84132	84132	84133
19367	27078	0	applied	\N	\N	\N	\N	84138	84138	84139
19367	27079	1	applied	\N	\N	\N	\N	84140	84140	84141
19367	27080	2	applied	\N	\N	\N	\N	84142	84142	84143
19367	27081	3	applied	\N	\N	\N	\N	84144	84144	84145
19367	27082	4	applied	\N	\N	\N	\N	84146	84146	84147
19367	27083	5	applied	\N	\N	\N	\N	84148	84148	84149
19367	27084	6	applied	\N	\N	\N	\N	84150	84150	84151
19372	27093	0	applied	\N	\N	\N	\N	84172	84172	84173
19372	27094	1	applied	\N	\N	\N	\N	84174	84174	84175
19372	27095	2	applied	\N	\N	\N	\N	84176	84176	84177
19374	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19374	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19374	27098	2	applied	\N	\N	\N	\N	84186	84186	84187
19377	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19377	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19377	27098	2	applied	\N	\N	\N	\N	84186	84186	84187
19380	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19380	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19384	27101	0	applied	\N	\N	\N	\N	84205	84205	84206
19384	27102	1	applied	\N	\N	\N	\N	84207	84207	84208
19384	27103	2	applied	\N	\N	\N	\N	84209	84209	84210
19384	27104	3	applied	\N	\N	\N	\N	84211	84211	84212
19386	27105	0	applied	\N	\N	\N	\N	84218	84218	84219
19386	27106	1	applied	\N	\N	\N	\N	84220	84220	84221
19386	27107	2	applied	\N	\N	\N	\N	84222	84222	84223
19387	27108	0	applied	\N	\N	\N	\N	84226	84226	84227
19387	27109	1	applied	\N	\N	\N	\N	84228	84228	84229
19387	27110	2	applied	\N	\N	\N	\N	84230	84230	84231
19387	27111	3	applied	\N	\N	\N	\N	84232	84232	84233
19387	27112	4	applied	\N	\N	1000000000	\N	84234	84234	84235
19387	27113	5	applied	\N	\N	\N	\N	84236	84236	84237
19387	27114	6	applied	\N	\N	\N	\N	84238	84238	84239
19387	27115	7	applied	\N	\N	\N	\N	84240	84240	84241
19387	27116	8	applied	\N	\N	\N	\N	84242	84242	84243
19387	27117	9	applied	\N	\N	\N	\N	84244	84244	84245
19387	27118	10	applied	\N	\N	\N	\N	84246	84246	84247
19387	27119	11	applied	\N	\N	\N	\N	84248	84248	84249
19387	27120	12	applied	\N	\N	\N	\N	84250	84250	84251
19387	27121	13	applied	\N	\N	\N	\N	84252	84252	84253
19390	27122	0	applied	\N	\N	\N	\N	84256	84256	84257
19390	27123	1	applied	\N	\N	1000000000	\N	84258	84258	84259
19390	27124	2	applied	\N	\N	\N	\N	84260	84260	84261
19390	27125	3	applied	\N	\N	\N	\N	84262	84262	84263
19390	27126	4	applied	\N	\N	\N	\N	84264	84264	84265
19396	27133	0	applied	\N	\N	\N	\N	84287	84287	84288
19396	27134	1	applied	\N	\N	\N	\N	84289	84289	84290
19396	27135	2	applied	\N	\N	\N	\N	84291	84291	84292
19396	27136	3	applied	\N	\N	\N	\N	84293	84293	84294
19399	27133	0	applied	\N	\N	\N	\N	84287	84287	84288
19399	27134	1	applied	\N	\N	\N	\N	84289	84289	84290
19399	27135	2	applied	\N	\N	\N	\N	84291	84291	84292
19399	27136	3	applied	\N	\N	\N	\N	84293	84293	84294
19400	27137	0	applied	\N	\N	\N	\N	84303	84303	84304
19400	27138	1	applied	\N	\N	\N	\N	84305	84305	84306
19400	27139	2	applied	\N	\N	\N	\N	84307	84307	84308
19400	27140	3	applied	\N	\N	\N	\N	84309	84309	84310
19402	27141	0	applied	\N	\N	\N	\N	84315	84315	84316
19402	27142	1	applied	\N	\N	\N	\N	84317	84317	84318
19402	27143	2	applied	\N	\N	\N	\N	84319	84319	84320
19402	27144	3	applied	\N	\N	\N	\N	84321	84321	84322
19411	27155	0	applied	\N	\N	\N	\N	84378	84378	84379
19411	27156	1	applied	\N	\N	\N	\N	84380	84380	84381
19411	27157	2	applied	\N	\N	\N	\N	84382	84382	84383
19411	27158	3	applied	\N	\N	\N	\N	84384	84384	84385
19411	27159	4	applied	\N	\N	\N	\N	84386	84386	84387
19411	27160	5	applied	\N	\N	\N	\N	84388	84388	84389
19411	27161	6	applied	\N	\N	\N	\N	84390	84390	84391
19414	27168	0	applied	\N	\N	\N	\N	84408	84408	84409
19414	27169	1	applied	\N	\N	\N	\N	84410	84410	84411
19414	27170	2	applied	\N	\N	\N	\N	84412	84412	84413
19416	27171	0	applied	\N	\N	\N	\N	84416	84416	84417
19416	27172	1	applied	\N	\N	\N	\N	84418	84418	84419
19416	27173	2	applied	\N	\N	\N	\N	84420	84420	84421
19416	27174	3	applied	\N	\N	\N	\N	84422	84422	84423
19419	26588	0	applied	\N	\N	\N	\N	82793	82793	82793
19419	26595	1	applied	\N	\N	\N	\N	82812	82812	82812
19419	26798	2	applied	\N	\N	\N	\N	83404	83404	83405
19420	27178	0	applied	\N	\N	\N	\N	84440	84440	84441
19420	27179	1	applied	\N	\N	\N	\N	84442	84442	84443
19420	27180	2	applied	\N	\N	\N	\N	84444	84444	84445
19420	27181	3	applied	\N	\N	\N	\N	84446	84446	84447
19420	27182	4	applied	\N	\N	\N	\N	84448	84448	84449
19420	27183	5	applied	\N	\N	\N	\N	84450	84450	84451
19420	27184	6	applied	\N	\N	\N	\N	84452	84452	84453
19427	27195	0	applied	\N	\N	\N	\N	84483	84483	84484
19427	27196	1	applied	\N	\N	1000000000	\N	84485	84485	84486
19427	27197	2	applied	\N	\N	\N	\N	84487	84487	84488
19427	27198	3	applied	\N	\N	\N	\N	84489	84489	84490
19437	27223	0	applied	\N	\N	\N	\N	84552	84552	84553
19437	27224	1	applied	\N	\N	\N	\N	84554	84554	84555
19437	27225	2	applied	\N	\N	\N	\N	84556	84556	84557
19454	27272	0	applied	\N	\N	\N	\N	84678	84678	84679
19454	27273	1	applied	\N	\N	\N	\N	84680	84680	84681
19454	27274	2	applied	\N	\N	\N	\N	84682	84682	84683
19462	27295	0	applied	\N	\N	\N	\N	84736	84736	84737
19462	27296	1	applied	\N	\N	\N	\N	84738	84738	84739
19464	27297	0	applied	\N	\N	\N	\N	84744	84744	84745
19464	27298	1	applied	\N	\N	\N	\N	84746	84746	84747
19464	27299	2	applied	\N	\N	\N	\N	84748	84748	84749
19464	27300	3	applied	\N	\N	\N	\N	84750	84750	84751
19467	27304	0	applied	\N	\N	\N	\N	84762	84762	84763
19467	27305	1	applied	\N	\N	\N	\N	84764	84764	84765
19467	27306	2	applied	\N	\N	\N	\N	84766	84766	84767
19467	27307	3	applied	\N	\N	1000000000	\N	84768	84768	84769
19467	27308	4	applied	\N	\N	\N	\N	84770	84770	84771
19467	27309	5	applied	\N	\N	\N	\N	84772	84772	84773
19467	27310	6	applied	\N	\N	\N	\N	84774	84774	84775
19358	27048	0	applied	\N	\N	\N	\N	84059	84059	84060
19358	27049	1	applied	\N	\N	\N	\N	84061	84061	84062
19358	27050	2	applied	\N	\N	\N	\N	84063	84063	84064
19358	27051	3	applied	\N	\N	\N	\N	84065	84065	84066
19358	27052	4	applied	\N	\N	\N	\N	84067	84067	84068
19358	27053	5	applied	\N	\N	\N	\N	84069	84069	84070
19358	27054	6	applied	\N	\N	\N	\N	84071	84071	84072
19358	27055	7	applied	\N	\N	\N	\N	84073	84073	84074
19358	27056	8	applied	\N	\N	1000000000	\N	84075	84075	84076
19358	27057	9	applied	\N	\N	\N	\N	84077	84077	84078
19358	27058	10	applied	\N	\N	\N	\N	84079	84079	84080
19358	27059	11	applied	\N	\N	\N	\N	84081	84081	84082
19358	27060	12	applied	\N	\N	\N	\N	84083	84083	84084
19358	27061	13	applied	\N	\N	\N	\N	84085	84085	84086
19358	27062	14	applied	\N	\N	\N	\N	84087	84087	84088
19361	27066	0	applied	\N	\N	\N	\N	84106	84106	84107
19361	27067	1	applied	\N	\N	\N	\N	84108	84108	84109
19361	27068	2	applied	\N	\N	\N	\N	84110	84110	84111
19361	27069	3	applied	\N	\N	\N	\N	84112	84112	84113
19366	27075	0	applied	\N	\N	\N	\N	84128	84128	84129
19366	27076	1	applied	\N	\N	\N	\N	84130	84130	84131
19366	27077	2	applied	\N	\N	\N	\N	84132	84132	84133
19368	27078	0	applied	\N	\N	\N	\N	84138	84138	84139
19368	27079	1	applied	\N	\N	\N	\N	84140	84140	84141
19368	27080	2	applied	\N	\N	\N	\N	84142	84142	84143
19368	27081	3	applied	\N	\N	\N	\N	84144	84144	84145
19368	27082	4	applied	\N	\N	\N	\N	84146	84146	84147
19368	27083	5	applied	\N	\N	\N	\N	84148	84148	84149
19368	27084	6	applied	\N	\N	\N	\N	84150	84150	84151
19371	27088	0	applied	\N	\N	\N	\N	84159	84159	84160
19371	27089	1	applied	\N	\N	\N	\N	84161	84161	84162
19371	27090	2	applied	\N	\N	\N	\N	84163	84163	84164
19371	27091	3	applied	\N	\N	\N	\N	84165	84165	84165
19371	27092	4	applied	\N	\N	\N	\N	84166	84166	84167
19376	27096	0	applied	\N	\N	\N	\N	84182	84182	84183
19376	27097	1	applied	\N	\N	\N	\N	84184	84184	84185
19376	27098	2	applied	\N	\N	\N	\N	84186	84186	84187
19388	27122	0	applied	\N	\N	\N	\N	84256	84256	84257
19388	27123	1	applied	\N	\N	1000000000	\N	84258	84258	84259
19388	27124	2	applied	\N	\N	\N	\N	84260	84260	84261
19388	27125	3	applied	\N	\N	\N	\N	84262	84262	84263
19388	27126	4	applied	\N	\N	\N	\N	84264	84264	84265
19391	27122	0	applied	\N	\N	\N	\N	84256	84256	84257
19391	27123	1	applied	\N	\N	1000000000	\N	84258	84258	84259
19391	27124	2	applied	\N	\N	\N	\N	84260	84260	84261
19391	27125	3	applied	\N	\N	\N	\N	84262	84262	84263
19391	27126	4	applied	\N	\N	\N	\N	84264	84264	84265
19393	27127	0	applied	\N	\N	\N	\N	84272	84272	84273
19393	27128	1	applied	\N	\N	\N	\N	84274	84274	84275
19398	27133	0	applied	\N	\N	\N	\N	84287	84287	84288
19398	27134	1	applied	\N	\N	\N	\N	84289	84289	84290
19398	27135	2	applied	\N	\N	\N	\N	84291	84291	84292
19398	27136	3	applied	\N	\N	\N	\N	84293	84293	84294
19401	27112	0	applied	\N	\N	1000000000	\N	84234	84234	84235
19404	27141	0	applied	\N	\N	\N	\N	84315	84315	84316
19404	27142	1	applied	\N	\N	\N	\N	84317	84317	84318
19404	27143	2	applied	\N	\N	\N	\N	84319	84319	84320
19404	27144	3	applied	\N	\N	\N	\N	84321	84321	84322
19405	27145	0	applied	\N	\N	\N	\N	84326	84326	84327
19405	27143	1	applied	\N	\N	\N	\N	84319	84319	84320
19405	27146	2	applied	\N	\N	\N	\N	84328	84328	84329
19405	27144	3	applied	\N	\N	\N	\N	84321	84321	84330
19405	27147	4	applied	\N	\N	\N	\N	84331	84331	84332
19422	27180	0	applied	\N	\N	\N	\N	84444	84444	84445
19422	27181	1	applied	\N	\N	\N	\N	84446	84446	84447
19422	27184	2	applied	\N	\N	\N	\N	84452	84452	84456
19426	27191	0	applied	\N	\N	\N	\N	84472	84472	84473
19426	27192	1	applied	\N	\N	\N	\N	84474	84474	84475
19426	27193	2	applied	\N	\N	\N	\N	84476	84476	84477
19426	27194	3	applied	\N	\N	\N	\N	84478	84478	84479
19428	27199	0	applied	\N	\N	\N	\N	84492	84492	84493
19428	27200	1	applied	\N	\N	\N	\N	84494	84494	84495
19428	27201	2	applied	\N	\N	\N	\N	84496	84496	84497
19431	27212	0	applied	\N	\N	\N	\N	84524	84524	84525
19431	27213	1	applied	\N	\N	\N	\N	84526	84526	84527
19431	27214	2	applied	\N	\N	\N	\N	84528	84528	84529
19439	27226	0	applied	\N	\N	\N	\N	84562	84562	84563
19439	27227	1	applied	\N	\N	\N	\N	84564	84564	84565
19439	27228	2	applied	\N	\N	\N	\N	84566	84566	84567
19439	27229	3	applied	\N	\N	\N	\N	84568	84568	84569
19439	27230	4	applied	\N	\N	\N	\N	84570	84570	84571
19439	27231	5	applied	\N	\N	\N	\N	84572	84572	84573
19439	27232	6	applied	\N	\N	\N	\N	84574	84574	84575
19439	27233	7	applied	\N	\N	\N	\N	84576	84576	84577
19439	27234	8	applied	\N	\N	1000000000	\N	84578	84578	84579
19439	27235	9	applied	\N	\N	\N	\N	84580	84580	84581
19439	27236	10	applied	\N	\N	\N	\N	84582	84582	84583
19439	27237	11	applied	\N	\N	\N	\N	84584	84584	84585
19439	27238	12	applied	\N	\N	\N	\N	84586	84586	84587
19439	27239	13	applied	\N	\N	\N	\N	84588	84588	84589
19439	27240	14	applied	\N	\N	\N	\N	84590	84590	84591
19439	27241	15	applied	\N	\N	\N	\N	84592	84592	84593
19439	27242	16	applied	\N	\N	\N	\N	84594	84594	84595
19439	27243	17	applied	\N	\N	\N	\N	84596	84596	84597
19441	27244	0	applied	\N	\N	\N	\N	84600	84600	84601
19441	27245	1	applied	\N	\N	\N	\N	84602	84602	84603
19441	27246	2	applied	\N	\N	\N	\N	84604	84604	84605
19441	27247	3	applied	\N	\N	\N	\N	84606	84606	84607
19446	27255	0	applied	\N	\N	\N	\N	84626	84626	84627
19446	27256	1	applied	\N	\N	\N	\N	84628	84628	84629
19446	27257	2	applied	\N	\N	\N	\N	84630	84630	84631
19446	27258	3	applied	\N	\N	\N	\N	84632	84632	84633
19446	27259	4	applied	\N	\N	\N	\N	84634	84634	84635
19451	27262	0	applied	\N	\N	\N	\N	84650	84650	84651
19451	27263	1	applied	\N	\N	\N	\N	84653	84653	84659
19453	27265	0	applied	\N	\N	\N	\N	84662	84662	84663
19453	27266	1	applied	\N	\N	\N	\N	84664	84664	84665
19453	27260	2	applied	\N	\N	\N	\N	84639	84639	84666
19453	27261	3	applied	\N	\N	\N	\N	84641	84641	84654
19453	27264	4	applied	\N	\N	\N	\N	84655	84655	84656
19453	27267	5	applied	\N	\N	\N	\N	84667	84667	84668
19453	27268	6	applied	\N	\N	\N	\N	84669	84669	84670
19453	27269	7	applied	\N	\N	\N	\N	84671	84671	84672
19453	27270	8	applied	\N	\N	\N	\N	84673	84673	84674
19453	27271	9	applied	\N	\N	\N	\N	84675	84675	84676
19456	27275	0	applied	\N	\N	\N	\N	84686	84686	84687
19456	27276	1	applied	\N	\N	\N	\N	84688	84688	84689
19456	27277	2	applied	\N	\N	\N	\N	84690	84690	84691
19461	27292	0	applied	\N	\N	\N	\N	84727	84727	84728
19408	26472	70	applied	\N	\N	\N	\N	82483	82483	82484
19408	26478	71	applied	\N	\N	\N	\N	82497	82497	82498
19408	26481	72	applied	\N	\N	\N	\N	82507	82507	82508
19408	26484	73	applied	\N	\N	\N	\N	82514	82514	82515
19408	26487	74	applied	\N	\N	\N	\N	82522	82522	82523
19408	26491	75	applied	\N	\N	\N	\N	82533	82533	82534
19408	26492	76	applied	\N	\N	\N	\N	82535	82535	82536
19408	26493	77	applied	\N	\N	\N	\N	82537	82537	82538
19408	26494	78	applied	\N	\N	\N	\N	82539	82539	82540
19408	26495	79	applied	\N	\N	\N	\N	82541	82541	82542
19408	26407	80	applied	\N	\N	\N	\N	82264	82264	82264
19408	26414	81	applied	\N	\N	\N	\N	82280	82280	82280
19408	26510	82	applied	\N	\N	\N	\N	82573	82573	82574
19408	26514	83	applied	\N	\N	\N	\N	82590	82590	82591
19408	26518	84	applied	\N	\N	\N	\N	82600	82600	82601
19408	26521	85	applied	\N	\N	\N	\N	82610	82610	82611
19408	26525	86	applied	\N	\N	\N	\N	82619	82619	82620
19408	26526	87	applied	\N	\N	\N	\N	82621	82621	82622
19408	26533	88	applied	\N	\N	\N	\N	82637	82637	82638
19408	26536	89	applied	\N	\N	\N	\N	82651	82651	82652
19408	26537	90	applied	\N	\N	\N	\N	82653	82653	82654
19408	26543	91	applied	\N	\N	\N	\N	82669	82669	82670
19408	26544	92	applied	\N	\N	\N	\N	82671	82671	82672
19408	26550	93	applied	\N	\N	\N	\N	82685	82685	82686
19408	26553	94	applied	\N	\N	\N	\N	82691	82691	82692
19408	26556	95	applied	\N	\N	\N	\N	82701	82701	82781
19408	26559	96	applied	\N	\N	\N	\N	82709	82709	82782
19408	26563	97	applied	\N	\N	\N	\N	82717	82717	82783
19408	26564	99	applied	\N	\N	\N	\N	82719	82719	82784
19408	26573	100	applied	\N	\N	\N	\N	82738	82738	82785
19408	26577	101	applied	\N	\N	\N	\N	82748	82748	82786
19408	26580	102	applied	\N	\N	\N	\N	82758	82758	82787
19408	26583	103	applied	\N	\N	\N	\N	82768	82768	82788
19408	26589	104	applied	\N	\N	\N	\N	82794	82794	84346
19408	26592	105	applied	\N	\N	\N	\N	82803	82803	84347
19408	26596	106	applied	\N	\N	\N	\N	82813	82813	84348
19408	26597	107	applied	\N	\N	\N	\N	82815	82815	84349
19408	26603	108	applied	\N	\N	\N	\N	82834	82834	84350
19408	26606	109	applied	\N	\N	\N	\N	82843	82843	84351
19408	26609	110	applied	\N	\N	\N	\N	82851	82851	84352
19408	26610	111	applied	\N	\N	\N	\N	82853	82853	84353
19408	26616	112	applied	\N	\N	\N	\N	82868	82868	84354
19408	26619	113	applied	\N	\N	\N	\N	82880	82880	84355
19408	26622	114	applied	\N	\N	\N	\N	82886	82886	84356
19408	26623	115	applied	\N	\N	\N	\N	82888	82888	84357
19408	26629	116	applied	\N	\N	\N	\N	82912	82912	84358
19408	26630	117	applied	\N	\N	\N	\N	82914	82914	84359
19408	26636	118	applied	\N	\N	\N	\N	82931	82931	84360
19408	26637	119	applied	\N	\N	\N	\N	82933	82933	84361
19408	26642	120	applied	\N	\N	\N	\N	82947	82947	84362
19408	26643	121	applied	\N	\N	\N	\N	82949	82949	84363
19408	26644	122	applied	\N	\N	\N	\N	82951	82951	84364
19408	26645	123	applied	\N	\N	\N	\N	82953	82953	84365
19408	26646	124	applied	\N	\N	\N	\N	82955	82955	84366
19408	26659	125	applied	\N	\N	\N	\N	82982	82982	84367
19410	27152	0	applied	\N	\N	\N	\N	84370	84370	84371
19410	27153	1	applied	\N	\N	\N	\N	84372	84372	84373
19410	27154	2	applied	\N	\N	\N	\N	84374	84374	84375
19413	27162	0	applied	\N	\N	\N	\N	84394	84394	84395
19413	27163	1	applied	\N	\N	\N	\N	84396	84396	84397
19413	27164	2	applied	\N	\N	\N	\N	84398	84398	84399
19413	27165	3	applied	\N	\N	\N	\N	84400	84400	84401
19413	27166	4	applied	\N	\N	\N	\N	84402	84402	84403
19413	27167	5	applied	\N	\N	\N	\N	84404	84404	84405
19418	27175	0	applied	\N	\N	\N	\N	84428	84428	84429
19418	27176	1	applied	\N	\N	\N	\N	84430	84430	84431
19418	27177	2	applied	\N	\N	\N	\N	84432	84432	84433
19423	27178	0	applied	\N	\N	\N	\N	84440	84440	84441
19423	27179	1	applied	\N	\N	\N	\N	84442	84442	84443
19423	27180	2	applied	\N	\N	\N	\N	84444	84444	84445
19423	27181	3	applied	\N	\N	\N	\N	84446	84446	84447
19423	27182	4	applied	\N	\N	\N	\N	84448	84448	84449
19423	27183	5	applied	\N	\N	\N	\N	84450	84450	84451
19423	27184	6	applied	\N	\N	\N	\N	84452	84452	84453
19424	27185	0	applied	\N	\N	\N	\N	84459	84459	84460
19424	27186	1	applied	\N	\N	\N	\N	84461	84461	84462
19424	27187	2	applied	\N	\N	\N	\N	84463	84463	84464
19424	27188	3	applied	\N	\N	\N	\N	84465	84465	84466
19424	27189	4	applied	\N	\N	\N	\N	84467	84467	84468
19424	27190	5	applied	\N	\N	\N	\N	84469	84469	84470
19429	27199	0	applied	\N	\N	\N	\N	84492	84492	84493
19429	27200	1	applied	\N	\N	\N	\N	84494	84494	84495
19429	27201	2	applied	\N	\N	\N	\N	84496	84496	84497
19432	27212	0	applied	\N	\N	\N	\N	84524	84524	84525
19432	27213	1	applied	\N	\N	\N	\N	84526	84526	84527
19432	27214	2	applied	\N	\N	\N	\N	84528	84528	84529
19435	27215	0	applied	\N	\N	\N	\N	84534	84534	84535
19435	27216	1	applied	\N	\N	\N	\N	84536	84536	84537
19435	27217	2	applied	\N	\N	\N	\N	84538	84538	84539
19435	27218	3	applied	\N	\N	\N	\N	84540	84540	84541
19435	27219	4	applied	\N	\N	\N	\N	84542	84542	84543
19435	27220	5	applied	\N	\N	\N	\N	84544	84544	84545
19435	27221	6	applied	\N	\N	\N	\N	84546	84546	84547
19435	27222	7	applied	\N	\N	\N	\N	84548	84548	84549
19436	27223	0	applied	\N	\N	\N	\N	84552	84552	84553
19436	27224	1	applied	\N	\N	\N	\N	84554	84554	84555
19436	27225	2	applied	\N	\N	\N	\N	84556	84556	84557
19440	27226	0	applied	\N	\N	\N	\N	84562	84562	84563
19440	27227	1	applied	\N	\N	\N	\N	84564	84564	84565
19440	27228	2	applied	\N	\N	\N	\N	84566	84566	84567
19440	27229	3	applied	\N	\N	\N	\N	84568	84568	84569
19440	27230	4	applied	\N	\N	\N	\N	84570	84570	84571
19440	27231	5	applied	\N	\N	\N	\N	84572	84572	84573
19440	27232	6	applied	\N	\N	\N	\N	84574	84574	84575
19440	27233	7	applied	\N	\N	\N	\N	84576	84576	84577
19440	27234	8	applied	\N	\N	1000000000	\N	84578	84578	84579
19440	27235	9	applied	\N	\N	\N	\N	84580	84580	84581
19440	27236	10	applied	\N	\N	\N	\N	84582	84582	84583
19440	27237	11	applied	\N	\N	\N	\N	84584	84584	84585
19440	27238	12	applied	\N	\N	\N	\N	84586	84586	84587
19440	27239	13	applied	\N	\N	\N	\N	84588	84588	84589
19440	27240	14	applied	\N	\N	\N	\N	84590	84590	84591
19440	27241	15	applied	\N	\N	\N	\N	84592	84592	84593
19440	27242	16	applied	\N	\N	\N	\N	84594	84594	84595
19440	27243	17	applied	\N	\N	\N	\N	84596	84596	84597
19442	27248	0	applied	\N	\N	\N	\N	84610	84610	84611
19442	27249	1	applied	\N	\N	\N	\N	84612	84612	84613
19442	27250	2	applied	\N	\N	\N	\N	84614	84614	84615
19442	27251	3	applied	\N	\N	\N	\N	84616	84616	84617
19447	27255	0	applied	\N	\N	\N	\N	84626	84626	84627
19430	27205	3	applied	\N	\N	\N	\N	84508	84508	84509
19430	27206	4	applied	\N	\N	\N	\N	84510	84510	84511
19430	27207	5	applied	\N	\N	\N	\N	84512	84512	84513
19430	27208	6	applied	\N	\N	\N	\N	84514	84514	84515
19430	27209	7	applied	\N	\N	\N	\N	84516	84516	84517
19430	27210	8	applied	\N	\N	\N	\N	84518	84518	84519
19430	27211	9	applied	\N	\N	\N	\N	84520	84520	84521
19433	27215	0	applied	\N	\N	\N	\N	84534	84534	84535
19433	27216	1	applied	\N	\N	\N	\N	84536	84536	84537
19433	27217	2	applied	\N	\N	\N	\N	84538	84538	84539
19433	27218	3	applied	\N	\N	\N	\N	84540	84540	84541
19433	27219	4	applied	\N	\N	\N	\N	84542	84542	84543
19433	27220	5	applied	\N	\N	\N	\N	84544	84544	84545
19433	27221	6	applied	\N	\N	\N	\N	84546	84546	84547
19433	27222	7	applied	\N	\N	\N	\N	84548	84548	84549
19443	27252	0	applied	\N	\N	\N	\N	84620	84620	84621
19443	27253	1	applied	\N	\N	\N	\N	84622	84622	84623
19443	27254	2	applied	\N	\N	\N	\N	84624	84624	84625
19448	27255	0	applied	\N	\N	\N	\N	84626	84626	84627
19448	27256	1	applied	\N	\N	\N	\N	84628	84628	84629
19448	27257	2	applied	\N	\N	\N	\N	84630	84630	84631
19448	27260	3	applied	\N	\N	\N	\N	84639	84639	84640
19448	27261	4	applied	\N	\N	\N	\N	84641	84641	84642
19448	27258	5	applied	\N	\N	\N	\N	84632	84632	84643
19448	27259	6	applied	\N	\N	\N	\N	84634	84634	84644
19450	27262	0	applied	\N	\N	\N	\N	84650	84650	84651
19450	27260	1	applied	\N	\N	\N	\N	84639	84639	84652
19450	27261	2	applied	\N	\N	\N	\N	84641	84641	84644
19450	27263	3	applied	\N	\N	\N	\N	84653	84653	84654
19450	27264	4	applied	\N	\N	\N	\N	84655	84655	84656
19452	27262	0	applied	\N	\N	\N	\N	84650	84650	84651
19452	27260	1	applied	\N	\N	\N	\N	84639	84639	84652
19452	27261	2	applied	\N	\N	\N	\N	84641	84641	84644
19452	27263	3	applied	\N	\N	\N	\N	84653	84653	84654
19452	27264	4	applied	\N	\N	\N	\N	84655	84655	84656
19455	27275	0	applied	\N	\N	\N	\N	84686	84686	84687
19455	27276	1	applied	\N	\N	\N	\N	84688	84688	84689
19455	27277	2	applied	\N	\N	\N	\N	84690	84690	84691
19457	27278	0	applied	\N	\N	\N	\N	84695	84695	84696
19457	27279	1	applied	\N	\N	\N	\N	84697	84697	84698
19457	27280	2	applied	\N	\N	\N	\N	84699	84699	84700
19457	27281	3	applied	\N	\N	\N	\N	84701	84701	84702
19458	27282	0	applied	\N	\N	\N	\N	84705	84705	84706
19458	27283	1	applied	\N	\N	\N	\N	84707	84707	84708
19458	27284	2	applied	\N	\N	\N	\N	84709	84709	84710
19458	27285	3	applied	\N	\N	\N	\N	84711	84711	84712
19458	27286	4	applied	\N	\N	\N	\N	84713	84713	84714
19458	27287	5	applied	\N	\N	\N	\N	84715	84715	84716
19458	27288	6	applied	\N	\N	\N	\N	84717	84717	84718
19458	27289	7	applied	\N	\N	\N	\N	84719	84719	84720
19458	27290	8	applied	\N	\N	\N	\N	84721	84721	84722
19458	27291	9	applied	\N	\N	\N	\N	84723	84723	84724
19460	27292	0	applied	\N	\N	\N	\N	84727	84727	84728
19460	27293	1	applied	\N	\N	\N	\N	84729	84729	84730
19463	27295	0	applied	\N	\N	\N	\N	84736	84736	84737
19463	27296	1	applied	\N	\N	\N	\N	84738	84738	84739
19468	27315	0	applied	\N	\N	\N	\N	84785	84785	84786
19468	27316	1	applied	\N	\N	\N	\N	84787	84787	84788
19468	27317	2	applied	\N	\N	\N	\N	84789	84789	84790
19475	27335	0	applied	\N	\N	\N	\N	84833	84833	84834
19475	27336	1	applied	\N	\N	\N	\N	84835	84835	84836
19475	27337	2	applied	\N	\N	\N	\N	84837	84837	84838
19475	27338	3	applied	\N	\N	\N	\N	84839	84839	84840
19475	27339	4	applied	\N	\N	\N	\N	84841	84841	84842
19480	27347	0	applied	\N	\N	\N	\N	84869	84869	84870
19483	27348	0	applied	\N	\N	\N	\N	84873	84873	84874
19483	27347	1	applied	\N	\N	\N	\N	84869	84869	84870
19483	27349	2	applied	\N	\N	\N	\N	84877	84877	84878
19484	27350	0	applied	\N	\N	\N	\N	84881	84881	84882
19484	27351	1	applied	\N	\N	\N	\N	84883	84883	84878
19484	27349	2	applied	\N	\N	\N	\N	84877	84877	84884
19487	27352	0	applied	\N	\N	\N	\N	84888	84888	84889
19487	27355	1	applied	\N	\N	\N	\N	84895	84895	84857
19487	27353	2	applied	\N	\N	\N	\N	84890	84890	84891
19487	27354	3	applied	\N	\N	\N	\N	84892	84892	84893
19489	27355	0	applied	\N	\N	\N	\N	84895	84895	84857
19489	27356	1	applied	\N	\N	\N	\N	84897	84897	84898
19489	27357	2	applied	\N	\N	\N	\N	84899	84899	84900
19489	27358	3	applied	\N	\N	\N	\N	84901	84901	84902
19491	27359	0	applied	\N	\N	1000000000	\N	84907	84907	84908
19491	27360	1	applied	\N	\N	\N	\N	84909	84909	84910
19491	27363	2	applied	\N	\N	\N	\N	84916	84916	84917
19491	27361	3	applied	\N	\N	\N	\N	84911	84911	84918
19491	27362	4	applied	\N	\N	\N	\N	84913	84913	84919
19496	27377	0	applied	\N	\N	\N	\N	84953	84953	84954
19496	27378	1	applied	\N	\N	\N	\N	84955	84955	84956
19496	27379	2	applied	\N	\N	\N	\N	84957	84957	84958
19502	27383	0	applied	\N	\N	\N	\N	84971	84971	84972
19502	27384	1	applied	\N	\N	\N	\N	84973	84973	84974
19502	27385	2	applied	\N	\N	\N	\N	84975	84975	84976
19502	27386	3	applied	\N	\N	\N	\N	84977	84977	84978
19506	27387	0	applied	\N	\N	\N	\N	84986	84986	84987
19506	27388	1	applied	\N	\N	\N	\N	84988	84988	84989
19506	27389	2	applied	\N	\N	\N	\N	84990	84990	84991
19506	27390	3	applied	\N	\N	\N	\N	84992	84992	84993
19506	27391	4	applied	\N	\N	\N	\N	84994	84994	84995
19506	27392	5	applied	\N	\N	\N	\N	84996	84996	84997
19511	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19511	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19511	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19511	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19516	27403	0	applied	\N	\N	\N	\N	85035	85035	85036
19516	27404	1	applied	\N	\N	\N	\N	85037	85037	85038
19516	27405	2	applied	\N	\N	\N	\N	85039	85039	85040
19516	27406	3	applied	\N	\N	\N	\N	85041	85041	85042
19523	27410	0	applied	\N	\N	\N	\N	85059	85059	85060
19523	27411	1	applied	\N	\N	\N	\N	85061	85061	85062
19523	27412	2	applied	\N	\N	\N	\N	85063	85063	85064
19525	27413	0	applied	\N	\N	\N	\N	85065	85065	85066
19525	27414	1	applied	\N	\N	\N	\N	85067	85067	85068
19525	27415	2	applied	\N	\N	\N	\N	85071	85071	85072
19527	27416	0	applied	\N	\N	\N	\N	85075	85075	85076
19527	27417	1	applied	\N	\N	\N	\N	85077	85077	85078
19527	27418	2	applied	\N	\N	\N	\N	85079	85079	85080
19527	27419	3	applied	\N	\N	\N	\N	85081	85081	85082
19530	27416	0	applied	\N	\N	\N	\N	85075	85075	85076
19530	27417	1	applied	\N	\N	\N	\N	85077	85077	85078
19530	27418	2	applied	\N	\N	\N	\N	85079	85079	85080
19530	27419	3	applied	\N	\N	\N	\N	85081	85081	85082
19532	27423	0	applied	\N	\N	\N	\N	85093	85093	85094
19447	27256	1	applied	\N	\N	\N	\N	84628	84628	84629
19447	27257	2	applied	\N	\N	\N	\N	84630	84630	84631
19447	27260	3	applied	\N	\N	\N	\N	84639	84639	84640
19447	27261	4	applied	\N	\N	\N	\N	84641	84641	84642
19447	27258	5	applied	\N	\N	\N	\N	84632	84632	84643
19447	27259	6	applied	\N	\N	\N	\N	84634	84634	84644
19449	27255	0	applied	\N	\N	\N	\N	84626	84626	84627
19449	27256	1	applied	\N	\N	\N	\N	84628	84628	84629
19449	27257	2	applied	\N	\N	\N	\N	84630	84630	84631
19449	27260	3	applied	\N	\N	\N	\N	84639	84639	84640
19449	27261	4	applied	\N	\N	\N	\N	84641	84641	84642
19449	27258	5	applied	\N	\N	\N	\N	84632	84632	84643
19449	27259	6	applied	\N	\N	\N	\N	84634	84634	84644
19459	27292	0	applied	\N	\N	\N	\N	84727	84727	84728
19459	27293	1	applied	\N	\N	\N	\N	84729	84729	84730
19459	27294	2	applied	\N	\N	\N	\N	84731	84731	84732
19466	27301	0	applied	\N	\N	\N	\N	84756	84756	84757
19466	27302	1	applied	\N	\N	\N	\N	84758	84758	84759
19466	27303	2	applied	\N	\N	\N	\N	84760	84760	84761
19469	27318	0	applied	\N	\N	\N	\N	84792	84792	84793
19474	27328	0	applied	\N	\N	\N	\N	84818	84818	84819
19474	27329	1	applied	\N	\N	\N	\N	84820	84820	84821
19474	27330	2	applied	\N	\N	\N	\N	84822	84822	84823
19474	27331	3	applied	\N	\N	1000000000	\N	84824	84824	84825
19474	27332	4	applied	\N	\N	1000000000	\N	84826	84826	84827
19474	27333	5	applied	\N	\N	\N	\N	84828	84828	84829
19474	27334	6	applied	\N	\N	\N	\N	84830	84830	84831
19477	27335	0	applied	\N	\N	\N	\N	84833	84833	84834
19477	27336	1	applied	\N	\N	\N	\N	84835	84835	84836
19477	27337	2	applied	\N	\N	\N	\N	84837	84837	84838
19477	27338	3	applied	\N	\N	\N	\N	84839	84839	84840
19477	27339	4	applied	\N	\N	\N	\N	84841	84841	84842
19485	27350	0	applied	\N	\N	\N	\N	84881	84881	84882
19485	27351	1	applied	\N	\N	\N	\N	84883	84883	84878
19485	27349	2	applied	\N	\N	\N	\N	84877	84877	84884
19490	27359	0	applied	\N	\N	1000000000	\N	84907	84907	84908
19490	27360	1	applied	\N	\N	\N	\N	84909	84909	84910
19490	27361	2	applied	\N	\N	\N	\N	84911	84911	84912
19490	27362	3	applied	\N	\N	\N	\N	84913	84913	84914
19493	27360	0	applied	\N	\N	\N	\N	84909	84909	84910
19493	27363	1	applied	\N	\N	\N	\N	84916	84916	84917
19493	27361	2	applied	\N	\N	\N	\N	84911	84911	84918
19493	27362	3	applied	\N	\N	\N	\N	84913	84913	84919
19494	27364	0	applied	\N	\N	\N	\N	84925	84925	84926
19494	27365	1	applied	\N	\N	\N	\N	84927	84927	84928
19494	27366	2	applied	\N	\N	\N	\N	84929	84929	84930
19495	27367	0	applied	\N	\N	\N	\N	84932	84932	84933
19495	27368	1	applied	\N	\N	\N	\N	84934	84934	84935
19495	27369	2	applied	\N	\N	\N	\N	84936	84936	84937
19495	27370	3	applied	\N	\N	\N	\N	84938	84938	84939
19495	27371	4	applied	\N	\N	\N	\N	84940	84940	84941
19495	27372	5	applied	\N	\N	\N	\N	84942	84942	84943
19495	27373	6	applied	\N	\N	\N	\N	84944	84944	84945
19495	27374	7	applied	\N	\N	\N	\N	84946	84946	84947
19495	27375	8	applied	\N	\N	\N	\N	84948	84948	84949
19495	27376	9	applied	\N	\N	\N	\N	84950	84950	84951
19500	27383	0	applied	\N	\N	\N	\N	84971	84971	84972
19500	27384	1	applied	\N	\N	\N	\N	84973	84973	84974
19500	27385	2	applied	\N	\N	\N	\N	84975	84975	84976
19500	27386	3	applied	\N	\N	\N	\N	84977	84977	84978
19504	27387	0	applied	\N	\N	\N	\N	84986	84986	84987
19504	27388	1	applied	\N	\N	\N	\N	84988	84988	84989
19504	27389	2	applied	\N	\N	\N	\N	84990	84990	84991
19504	27390	3	applied	\N	\N	\N	\N	84992	84992	84993
19504	27391	4	applied	\N	\N	\N	\N	84994	84994	84995
19504	27392	5	applied	\N	\N	\N	\N	84996	84996	84997
19509	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19509	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19509	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19509	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19512	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19512	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19512	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19512	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19515	27397	0	applied	\N	\N	\N	\N	85021	85021	85022
19515	27400	1	applied	\N	\N	\N	\N	85028	85028	85029
19515	27398	2	applied	\N	\N	\N	\N	85023	85023	85024
19515	27399	3	applied	\N	\N	\N	\N	85025	85025	85026
19515	27401	4	applied	\N	\N	\N	\N	85030	85030	85031
19515	27402	5	applied	\N	\N	\N	\N	85032	85032	85033
19520	27407	0	applied	\N	\N	\N	\N	85049	85049	85050
19520	27408	1	applied	\N	\N	\N	\N	85051	85051	85052
19520	27409	2	applied	\N	\N	\N	\N	85053	85053	85054
19524	27413	0	applied	\N	\N	\N	\N	85065	85065	85066
19524	27414	1	applied	\N	\N	\N	\N	85067	85067	85068
19529	27416	0	applied	\N	\N	\N	\N	85075	85075	85076
19529	27417	1	applied	\N	\N	\N	\N	85077	85077	85078
19529	27418	2	applied	\N	\N	\N	\N	85079	85079	85080
19529	27419	3	applied	\N	\N	\N	\N	85081	85081	85082
19533	27430	0	applied	\N	\N	\N	\N	85109	85109	85110
19533	27431	2	applied	\N	\N	\N	\N	85112	85112	85113
19533	27432	3	applied	\N	\N	\N	\N	85114	85114	85115
19538	27400	0	applied	\N	\N	\N	\N	85028	85028	85029
19538	27403	1	applied	\N	\N	\N	\N	85035	85035	85036
19538	27407	2	applied	\N	\N	\N	\N	85049	85049	85050
19538	27410	3	applied	\N	\N	\N	\N	85059	85059	85060
19538	27413	4	applied	\N	\N	\N	\N	85065	85065	85066
19538	27416	5	applied	\N	\N	\N	\N	85075	85075	85076
19538	27420	6	applied	\N	\N	\N	\N	85085	85085	85086
19538	27423	7	applied	\N	\N	\N	\N	85093	85093	85094
19538	27424	8	applied	\N	\N	\N	\N	85095	85095	85096
19538	27430	9	applied	\N	\N	\N	\N	85109	85109	85110
19538	27433	10	applied	\N	\N	\N	\N	85120	85120	85121
19538	27401	11	applied	\N	\N	\N	\N	85030	85030	85031
19538	27404	12	applied	\N	\N	\N	\N	85037	85037	85129
19538	27408	13	applied	\N	\N	\N	\N	85051	85051	85130
19538	27406	14	applied	\N	\N	\N	\N	85041	85041	85038
19538	27418	15	applied	\N	\N	\N	\N	85079	85079	85131
19538	27412	16	applied	\N	\N	\N	\N	85063	85063	85040
19538	27402	17	applied	\N	\N	\N	\N	85032	85032	85052
19538	27405	18	applied	\N	\N	\N	\N	85039	85039	85054
19538	27409	19	applied	\N	\N	\N	\N	85053	85053	85062
19538	27411	20	applied	\N	\N	\N	\N	85061	85061	85132
19538	27414	21	applied	\N	\N	\N	\N	85067	85067	85133
19538	27419	22	applied	\N	\N	\N	\N	85081	85081	85078
19538	27422	23	applied	\N	\N	\N	\N	85089	85089	85134
19538	27425	24	applied	\N	\N	\N	\N	85097	85097	85088
19538	27426	25	applied	\N	\N	\N	\N	85099	85099	85090
19538	27432	26	applied	\N	\N	\N	\N	85114	85114	85098
19461	27293	1	applied	\N	\N	\N	\N	84729	84729	84730
19461	27294	2	applied	\N	\N	\N	\N	84731	84731	84732
19465	27297	0	applied	\N	\N	\N	\N	84744	84744	84745
19465	27298	1	applied	\N	\N	\N	\N	84746	84746	84747
19465	27299	2	applied	\N	\N	\N	\N	84748	84748	84749
19465	27300	3	applied	\N	\N	\N	\N	84750	84750	84751
19471	27318	0	applied	\N	\N	\N	\N	84792	84792	84793
19471	27319	1	applied	\N	\N	\N	\N	84796	84796	84797
19471	27320	2	applied	\N	\N	\N	\N	84798	84798	84799
19473	27325	0	applied	\N	\N	\N	\N	84811	84811	84812
19473	27326	1	applied	\N	\N	\N	\N	84813	84813	84814
19473	27327	2	applied	\N	\N	\N	\N	84815	84815	84816
19476	27335	0	applied	\N	\N	\N	\N	84833	84833	84834
19476	27337	1	applied	\N	\N	\N	\N	84837	84837	84845
19476	27338	2	applied	\N	\N	\N	\N	84839	84839	84846
19476	27339	3	applied	\N	\N	\N	\N	84841	84841	84842
19478	27340	0	applied	\N	\N	\N	\N	84849	84849	84850
19478	27341	1	applied	\N	\N	\N	\N	84851	84851	84852
19478	27336	2	applied	\N	\N	\N	\N	84835	84835	84840
19478	27342	3	applied	\N	\N	\N	\N	84853	84853	84854
19478	27343	4	applied	\N	\N	\N	\N	84855	84855	84856
19478	27344	5	applied	\N	\N	\N	\N	84857	84857	84858
19478	27345	6	applied	\N	\N	\N	\N	84859	84859	84860
19478	27346	8	applied	\N	\N	\N	\N	84862	84862	84863
19481	27348	0	applied	\N	\N	\N	\N	84873	84873	84874
19481	27347	1	applied	\N	\N	\N	\N	84869	84869	84870
19492	27359	0	applied	\N	\N	1000000000	\N	84907	84907	84908
19492	27360	1	applied	\N	\N	\N	\N	84909	84909	84910
19492	27363	2	applied	\N	\N	\N	\N	84916	84916	84917
19492	27361	3	applied	\N	\N	\N	\N	84911	84911	84918
19492	27362	4	applied	\N	\N	\N	\N	84913	84913	84919
19497	27377	0	applied	\N	\N	\N	\N	84953	84953	84954
19497	27378	1	applied	\N	\N	\N	\N	84955	84955	84956
19497	27379	2	applied	\N	\N	\N	\N	84957	84957	84958
19499	27383	0	applied	\N	\N	\N	\N	84971	84971	84972
19499	27384	1	applied	\N	\N	\N	\N	84973	84973	84974
19499	27385	2	applied	\N	\N	\N	\N	84975	84975	84976
19499	27386	3	applied	\N	\N	\N	\N	84977	84977	84978
19503	27383	0	applied	\N	\N	\N	\N	84971	84971	84972
19503	27384	1	applied	\N	\N	\N	\N	84973	84973	84974
19503	27385	2	applied	\N	\N	\N	\N	84975	84975	84976
19503	27386	3	applied	\N	\N	\N	\N	84977	84977	84978
19507	27387	0	applied	\N	\N	\N	\N	84986	84986	84987
19507	27388	1	applied	\N	\N	\N	\N	84988	84988	84989
19507	27389	2	applied	\N	\N	\N	\N	84990	84990	84991
19507	27390	3	applied	\N	\N	\N	\N	84992	84992	84993
19507	27391	4	applied	\N	\N	\N	\N	84994	84994	84995
19507	27392	5	applied	\N	\N	\N	\N	84996	84996	84997
19508	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19508	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19508	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19508	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19514	27397	0	applied	\N	\N	\N	\N	85021	85021	85022
19514	27398	1	applied	\N	\N	\N	\N	85023	85023	85024
19514	27399	2	applied	\N	\N	\N	\N	85025	85025	85026
19517	27403	0	applied	\N	\N	\N	\N	85035	85035	85036
19517	27404	1	applied	\N	\N	\N	\N	85037	85037	85038
19517	27405	2	applied	\N	\N	\N	\N	85039	85039	85040
19517	27406	3	applied	\N	\N	\N	\N	85041	85041	85042
19519	27407	0	applied	\N	\N	\N	\N	85049	85049	85050
19519	27408	1	applied	\N	\N	\N	\N	85051	85051	85052
19519	27409	2	applied	\N	\N	\N	\N	85053	85053	85054
19526	27413	0	applied	\N	\N	\N	\N	85065	85065	85066
19526	27414	1	applied	\N	\N	\N	\N	85067	85067	85068
19526	27415	2	applied	\N	\N	\N	\N	85071	85071	85072
19528	27416	0	applied	\N	\N	\N	\N	85075	85075	85076
19528	27417	1	applied	\N	\N	\N	\N	85077	85077	85078
19528	27418	2	applied	\N	\N	\N	\N	85079	85079	85080
19528	27419	3	applied	\N	\N	\N	\N	85081	85081	85082
19537	27433	0	applied	\N	\N	\N	\N	85120	85120	85121
19537	27434	1	applied	\N	\N	\N	\N	85122	85122	85123
19537	27435	2	applied	\N	\N	\N	\N	85124	85124	85125
19539	27436	0	applied	\N	\N	\N	\N	85140	85140	85141
19539	27437	1	applied	\N	\N	\N	\N	85142	85142	85143
19539	27438	2	applied	\N	\N	\N	\N	85144	85144	85145
19539	27439	3	applied	\N	\N	\N	\N	85146	85146	85147
19549	27456	0	applied	\N	\N	\N	\N	85196	85196	85197
19549	27457	1	applied	\N	\N	\N	\N	85198	85198	85199
19549	27458	2	applied	\N	\N	\N	\N	85200	85200	85201
19549	27459	3	applied	\N	\N	\N	\N	85202	85202	85203
19549	27460	4	applied	\N	\N	\N	\N	85204	85204	85205
19549	27461	5	applied	\N	\N	\N	\N	85206	85206	85207
19549	27462	6	applied	\N	\N	\N	\N	85208	85208	85209
19467	27311	7	applied	\N	\N	\N	\N	84776	84776	84777
19467	27312	8	applied	\N	\N	\N	\N	84778	84778	84779
19467	27313	9	applied	\N	\N	\N	\N	84780	84780	84781
19467	27314	10	applied	\N	\N	\N	\N	84782	84782	84783
19470	27318	0	applied	\N	\N	\N	\N	84792	84792	84793
19470	27319	1	applied	\N	\N	\N	\N	84796	84796	84797
19470	27320	2	applied	\N	\N	\N	\N	84798	84798	84799
19472	27321	0	applied	\N	\N	\N	\N	84801	84801	84802
19472	27322	1	applied	\N	\N	\N	\N	84803	84803	84804
19472	27323	2	applied	\N	\N	\N	\N	84805	84805	84806
19472	27324	3	applied	\N	\N	\N	\N	84807	84807	84808
19479	27340	0	applied	\N	\N	\N	\N	84849	84849	84850
19479	27341	1	applied	\N	\N	\N	\N	84851	84851	84852
19479	27336	2	applied	\N	\N	\N	\N	84835	84835	84840
19479	27342	3	applied	\N	\N	\N	\N	84853	84853	84854
19479	27343	4	applied	\N	\N	\N	\N	84855	84855	84856
19479	27344	5	applied	\N	\N	\N	\N	84857	84857	84858
19479	27345	6	applied	\N	\N	\N	\N	84859	84859	84860
19479	27346	8	applied	\N	\N	\N	\N	84862	84862	84863
19482	27348	0	applied	\N	\N	\N	\N	84873	84873	84874
19482	27347	1	applied	\N	\N	\N	\N	84869	84869	84870
19482	27349	2	applied	\N	\N	\N	\N	84877	84877	84878
19486	27352	0	applied	\N	\N	\N	\N	84888	84888	84889
19486	27353	1	applied	\N	\N	\N	\N	84890	84890	84891
19486	27354	2	applied	\N	\N	\N	\N	84892	84892	84893
19488	27355	0	applied	\N	\N	\N	\N	84895	84895	84857
19488	27356	1	applied	\N	\N	\N	\N	84897	84897	84898
19488	27357	2	applied	\N	\N	\N	\N	84899	84899	84900
19488	27358	3	applied	\N	\N	\N	\N	84901	84901	84902
19498	27380	0	applied	\N	\N	\N	\N	84963	84963	84964
19498	27381	1	applied	\N	\N	\N	\N	84965	84965	84966
19498	27382	2	applied	\N	\N	\N	\N	84967	84967	84968
19501	27383	0	applied	\N	\N	\N	\N	84971	84971	84972
19501	27384	1	applied	\N	\N	\N	\N	84973	84973	84974
19501	27385	2	applied	\N	\N	\N	\N	84975	84975	84976
19501	27386	3	applied	\N	\N	\N	\N	84977	84977	84978
19505	27387	0	applied	\N	\N	\N	\N	84986	84986	84987
19505	27388	1	applied	\N	\N	\N	\N	84988	84988	84989
19505	27389	2	applied	\N	\N	\N	\N	84990	84990	84991
19505	27390	3	applied	\N	\N	\N	\N	84992	84992	84993
19505	27391	4	applied	\N	\N	\N	\N	84994	84994	84995
19505	27392	5	applied	\N	\N	\N	\N	84996	84996	84997
19510	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19510	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19510	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19510	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19513	27393	0	applied	\N	\N	\N	\N	85005	85005	85006
19513	27394	1	applied	\N	\N	\N	\N	85007	85007	85008
19513	27395	2	applied	\N	\N	\N	\N	85009	85009	85010
19513	27396	3	applied	\N	\N	\N	\N	85011	85011	85012
19518	27359	0	applied	\N	\N	1000000000	\N	84907	84907	84908
19518	27329	1	applied	\N	\N	\N	\N	84820	84820	84821
19518	27307	2	applied	\N	\N	1000000000	\N	84768	84768	84769
19518	27331	3	applied	\N	\N	1000000000	\N	84824	84824	84825
19518	27332	4	applied	\N	\N	1000000000	\N	84826	84826	84827
19518	27333	5	applied	\N	\N	\N	\N	84828	84828	84829
19518	27344	6	applied	\N	\N	\N	\N	85047	85047	84858
19518	27339	7	applied	\N	\N	\N	\N	84841	84841	84842
19521	27407	0	applied	\N	\N	\N	\N	85049	85049	85050
19521	27408	1	applied	\N	\N	\N	\N	85051	85051	85052
19521	27409	2	applied	\N	\N	\N	\N	85053	85053	85054
19522	27410	0	applied	\N	\N	\N	\N	85059	85059	85060
19522	27411	1	applied	\N	\N	\N	\N	85061	85061	85062
19522	27412	2	applied	\N	\N	\N	\N	85063	85063	85064
19531	27420	0	applied	\N	\N	\N	\N	85085	85085	85086
19531	27421	1	applied	\N	\N	\N	\N	85087	85087	85088
19531	27422	2	applied	\N	\N	\N	\N	85089	85089	85090
19534	27430	0	applied	\N	\N	\N	\N	85109	85109	85110
19534	27431	2	applied	\N	\N	\N	\N	85112	85112	85113
19534	27432	3	applied	\N	\N	\N	\N	85114	85114	85115
19536	27433	0	applied	\N	\N	\N	\N	85120	85120	85121
19536	27434	1	applied	\N	\N	\N	\N	85122	85122	85123
19536	27435	2	applied	\N	\N	\N	\N	85124	85124	85125
19541	27436	0	applied	\N	\N	\N	\N	85140	85140	85141
19541	27437	1	applied	\N	\N	\N	\N	85142	85142	85143
19541	27438	2	applied	\N	\N	\N	\N	85144	85144	85145
19541	27439	3	applied	\N	\N	\N	\N	85146	85146	85147
19543	27443	0	applied	\N	\N	\N	\N	85159	85159	85160
19543	27444	1	applied	\N	\N	\N	\N	85161	85161	85162
19543	27445	2	applied	\N	\N	\N	\N	85163	85163	85164
19543	27446	3	applied	\N	\N	\N	\N	85165	85165	85166
19543	27447	4	applied	\N	\N	\N	\N	85167	85167	85168
19543	27448	5	applied	\N	\N	\N	\N	85169	85169	85170
19543	27449	6	applied	\N	\N	\N	\N	85171	85171	85172
19546	27443	0	applied	\N	\N	\N	\N	85159	85159	85160
19546	27444	1	applied	\N	\N	\N	\N	85161	85161	85162
19546	27445	2	applied	\N	\N	\N	\N	85163	85163	85164
19546	27450	3	applied	\N	\N	\N	\N	85175	85175	85176
19546	27446	4	applied	\N	\N	\N	\N	85165	85165	85177
19546	27451	5	applied	\N	\N	\N	\N	85178	85178	85179
19546	27452	6	applied	\N	\N	\N	\N	85180	85180	85170
19546	27447	7	applied	\N	\N	\N	\N	85167	85167	85172
19546	27448	8	applied	\N	\N	\N	\N	85169	85169	85181
19546	27449	9	applied	\N	\N	\N	\N	85171	85171	85182
19532	27424	1	applied	\N	\N	\N	\N	85095	85095	85096
19532	27425	2	applied	\N	\N	\N	\N	85097	85097	85098
19532	27426	3	applied	\N	\N	\N	\N	85099	85099	85100
19532	27427	4	applied	\N	\N	\N	\N	85101	85101	85102
19532	27428	5	applied	\N	\N	\N	\N	85103	85103	85104
19532	27429	6	applied	\N	\N	\N	\N	85105	85105	85106
19544	27443	0	applied	\N	\N	\N	\N	85159	85159	85160
19544	27444	1	applied	\N	\N	\N	\N	85161	85161	85162
19544	27445	2	applied	\N	\N	\N	\N	85163	85163	85164
19544	27450	3	applied	\N	\N	\N	\N	85175	85175	85176
19544	27446	4	applied	\N	\N	\N	\N	85165	85165	85177
19544	27451	5	applied	\N	\N	\N	\N	85178	85178	85179
19544	27452	6	applied	\N	\N	\N	\N	85180	85180	85170
19544	27447	7	applied	\N	\N	\N	\N	85167	85167	85172
19544	27448	8	applied	\N	\N	\N	\N	85169	85169	85181
19544	27449	9	applied	\N	\N	\N	\N	85171	85171	85182
19548	27453	0	applied	\N	\N	\N	\N	85188	85188	85189
19548	27454	1	applied	\N	\N	\N	\N	85190	85190	85191
19548	27455	2	applied	\N	\N	\N	\N	85192	85192	85193
19538	27434	27	applied	\N	\N	\N	\N	85122	85122	85100
19538	27429	28	applied	\N	\N	\N	\N	85105	85105	85135
19538	27415	29	applied	\N	\N	\N	\N	85071	85071	85136
19538	27417	30	applied	\N	\N	\N	\N	85077	85077	85106
19538	27421	31	applied	\N	\N	\N	\N	85087	85087	85113
19538	27427	32	applied	\N	\N	\N	\N	85101	85101	85137
19538	27428	33	applied	\N	\N	\N	\N	85103	85103	85138
19538	27431	34	applied	\N	\N	\N	\N	85112	85112	85123
19538	27435	35	applied	\N	\N	\N	\N	85124	85124	85125
19540	27436	0	applied	\N	\N	\N	\N	85140	85140	85141
19540	27437	1	applied	\N	\N	\N	\N	85142	85142	85143
19540	27438	2	applied	\N	\N	\N	\N	85144	85144	85145
19542	27440	0	applied	\N	\N	\N	\N	85152	85152	85153
19542	27441	1	applied	\N	\N	\N	\N	85154	85154	85155
19542	27442	2	applied	\N	\N	\N	\N	85156	85156	85157
19545	27443	0	applied	\N	\N	\N	\N	85159	85159	85160
19545	27444	1	applied	\N	\N	\N	\N	85161	85161	85162
19545	27445	2	applied	\N	\N	\N	\N	85163	85163	85164
19545	27450	3	applied	\N	\N	\N	\N	85175	85175	85176
19545	27446	4	applied	\N	\N	\N	\N	85165	85165	85177
19545	27451	5	applied	\N	\N	\N	\N	85178	85178	85179
19545	27452	6	applied	\N	\N	\N	\N	85180	85180	85170
19545	27447	7	applied	\N	\N	\N	\N	85167	85167	85172
19545	27448	8	applied	\N	\N	\N	\N	85169	85169	85181
19545	27449	9	applied	\N	\N	\N	\N	85171	85171	85182
19547	27453	0	applied	\N	\N	\N	\N	85188	85188	85189
19547	27454	1	applied	\N	\N	\N	\N	85190	85190	85191
19547	27455	2	applied	\N	\N	\N	\N	85192	85192	85193
19550	27456	0	applied	\N	\N	\N	\N	85196	85196	85197
19550	27457	1	applied	\N	\N	\N	\N	85198	85198	85199
19550	27458	2	applied	\N	\N	\N	\N	85200	85200	85201
19550	27459	3	applied	\N	\N	\N	\N	85202	85202	85203
19550	27460	4	applied	\N	\N	\N	\N	85204	85204	85205
19550	27461	5	applied	\N	\N	\N	\N	85206	85206	85207
19550	27462	6	applied	\N	\N	\N	\N	85208	85208	85209
19551	27202	0	applied	\N	\N	1000000000	\N	84502	84502	84503
19551	26798	1	applied	\N	\N	\N	\N	83404	83404	83405
19551	26708	2	applied	\N	\N	1000000000	\N	83118	83118	83119
19551	26815	3	applied	\N	\N	\N	\N	83445	83445	83446
19551	26723	4	applied	\N	\N	\N	\N	83175	83175	83176
19551	27359	5	applied	\N	\N	1000000000	\N	84907	84907	84908
19551	26738	6	applied	\N	\N	1000000000	\N	83210	83210	83211
19551	26823	7	applied	\N	\N	\N	\N	83762	83762	83466
19551	26824	8	applied	\N	\N	\N	\N	83763	83763	83468
19551	26825	9	applied	\N	\N	\N	\N	83764	83764	83470
19551	27051	10	applied	\N	\N	\N	\N	84065	84065	84066
19551	27052	11	applied	\N	\N	\N	\N	84067	84067	84068
19551	27053	12	applied	\N	\N	\N	\N	84069	84069	84070
19551	27054	13	applied	\N	\N	\N	\N	84071	84071	84072
19551	27196	14	applied	\N	\N	1000000000	\N	84485	84485	84486
19551	26826	15	applied	\N	\N	\N	\N	83765	83765	83472
19551	26827	16	applied	\N	\N	\N	\N	83766	83766	83474
19551	26878	17	applied	\N	\N	\N	\N	83767	83767	83602
19551	26881	18	applied	\N	\N	\N	\N	83768	83768	83608
19551	26882	19	applied	\N	\N	\N	\N	83769	83769	83610
19551	26883	20	applied	\N	\N	\N	\N	83770	83770	83612
19551	26884	21	applied	\N	\N	\N	\N	83771	83771	83614
19551	26910	22	applied	\N	\N	\N	\N	83772	83772	83677
19551	26911	23	applied	\N	\N	\N	\N	83773	83773	83679
19551	26912	24	applied	\N	\N	\N	\N	83774	83774	83681
19551	26914	25	applied	\N	\N	\N	\N	83775	83775	83685
19551	26915	26	applied	\N	\N	\N	\N	83776	83776	83687
19551	26932	27	applied	\N	\N	\N	\N	83777	83777	83728
19551	26933	28	applied	\N	\N	\N	\N	83778	83778	83730
19551	26934	29	applied	\N	\N	\N	\N	83779	83779	83732
19551	26935	30	applied	\N	\N	\N	\N	83780	83780	83734
19551	26936	31	applied	\N	\N	\N	\N	83781	83781	83736
19551	26955	32	applied	\N	\N	\N	\N	83998	83998	83812
19551	26956	33	applied	\N	\N	\N	\N	83999	83999	83814
19551	26958	34	applied	\N	\N	\N	\N	84000	84000	83818
19551	26959	35	applied	\N	\N	\N	\N	84001	84001	83820
19551	26960	36	applied	\N	\N	\N	\N	84002	84002	83822
19551	26977	37	applied	\N	\N	\N	\N	84003	84003	83865
19551	26978	38	applied	\N	\N	\N	\N	84004	84004	83867
19551	26979	39	applied	\N	\N	\N	\N	84005	84005	83870
19551	26980	40	applied	\N	\N	\N	\N	84007	84007	83872
19551	26981	41	applied	\N	\N	\N	\N	84008	84008	83874
19551	26989	42	applied	\N	\N	\N	\N	84009	84009	83900
19551	26990	43	applied	\N	\N	\N	\N	84010	84010	83902
19551	26991	44	applied	\N	\N	\N	\N	84011	84011	83904
19551	26992	45	applied	\N	\N	\N	\N	84012	84012	83906
19551	26993	46	applied	\N	\N	\N	\N	84013	84013	83908
19551	26887	47	applied	\N	\N	\N	\N	83619	83619	83782
19551	27329	48	applied	\N	\N	\N	\N	85212	85212	84821
19551	26836	49	applied	\N	\N	\N	\N	83783	83783	83499
19551	27207	50	applied	\N	\N	\N	\N	84512	84512	84513
19551	27221	51	applied	\N	\N	\N	\N	84546	84546	84547
19551	27232	52	applied	\N	\N	\N	\N	84574	84574	84575
19551	27344	53	applied	\N	\N	\N	\N	85213	85213	84858
19551	26839	54	applied	\N	\N	1000000000	\N	83504	83504	83505
19551	26840	55	applied	\N	\N	1000000000	\N	83506	83506	83507
19551	26841	56	applied	\N	\N	1000000000	\N	83508	83508	83509
19551	26757	57	applied	\N	\N	\N	\N	83255	83255	83256
19551	26651	58	applied	\N	\N	\N	\N	82965	82965	47675
19551	26844	59	applied	\N	\N	\N	\N	83514	83514	83515
19551	26845	60	applied	\N	\N	\N	\N	83516	83516	83517
19551	26846	61	applied	\N	\N	1000000000	\N	83518	83518	83519
19551	26847	62	applied	\N	\N	1000000000	\N	83520	83520	83521
19551	26917	63	applied	\N	\N	1000000000	\N	83690	83690	83691
19551	26918	64	applied	\N	\N	1000000000	\N	83692	83692	83693
19551	27056	65	applied	\N	\N	1000000000	\N	84075	84075	84076
19551	27112	66	applied	\N	\N	1000000000	\N	84234	84234	84235
19551	27234	67	applied	\N	\N	1000000000	\N	84578	84578	84579
19551	27307	68	applied	\N	\N	1000000000	\N	84768	84768	84769
19551	27331	69	applied	\N	\N	1000000000	\N	84824	84824	84825
19551	27332	70	applied	\N	\N	1000000000	\N	84826	84826	84827
19551	27333	71	applied	\N	\N	\N	\N	84828	84828	84829
19551	27339	72	applied	\N	\N	\N	\N	84841	84841	84842
19551	26896	73	applied	\N	\N	\N	\N	83637	83637	83637
19551	27003	74	applied	\N	\N	\N	\N	83927	83927	12588
19551	27011	75	applied	\N	\N	\N	\N	83946	83946	83946
19551	27014	76	applied	\N	\N	\N	\N	83952	83952	83952
19551	27016	77	applied	\N	\N	\N	\N	83955	83955	83955
19551	27018	78	applied	\N	\N	\N	\N	83958	83958	83958
19552	27463	0	applied	\N	\N	\N	\N	85215	85215	85216
19552	27464	1	applied	\N	\N	\N	\N	85217	85217	85218
19552	27465	2	applied	\N	\N	\N	\N	85219	85219	85220
19552	27466	3	applied	\N	\N	\N	\N	85221	85221	85222
19552	27467	4	applied	\N	\N	\N	\N	85223	85223	85224
19552	27468	5	applied	\N	\N	\N	\N	85225	85225	85226
19555	27469	0	applied	\N	\N	\N	\N	85228	85228	85229
19555	27470	1	applied	\N	\N	\N	\N	85230	85230	85231
19555	27472	2	applied	\N	\N	\N	\N	85234	85234	85235
19555	27471	3	applied	\N	\N	\N	\N	85232	85232	85236
19559	27473	0	applied	\N	\N	\N	\N	85257	85257	85258
19559	27474	1	applied	\N	\N	\N	\N	85259	85259	85260
19561	27478	0	applied	\N	\N	\N	\N	85271	85271	85272
19561	27479	1	applied	\N	\N	\N	\N	85273	85273	85274
19561	27480	2	applied	\N	\N	\N	\N	85275	85275	85276
19561	27481	3	applied	\N	\N	\N	\N	85277	85277	85278
19569	27496	0	applied	\N	\N	\N	\N	85318	85318	85319
19569	27497	1	applied	\N	\N	\N	\N	85320	85320	85321
19569	27498	2	applied	\N	\N	\N	\N	85322	85322	85323
19587	27527	0	applied	\N	\N	\N	\N	85423	85423	85424
19587	27528	1	applied	\N	\N	\N	\N	85425	85425	85426
19587	27529	2	applied	\N	\N	\N	\N	85427	85427	85428
19591	27530	0	applied	\N	\N	\N	\N	85436	85436	85437
19591	27531	1	applied	\N	\N	\N	\N	85438	85438	85439
19591	27532	2	applied	\N	\N	\N	\N	85440	85440	85441
19595	27533	0	applied	\N	\N	\N	\N	85446	85446	85447
19595	27534	1	applied	\N	\N	\N	\N	85448	85448	85449
19595	27535	2	applied	\N	\N	\N	\N	85450	85450	85451
19599	27550	0	applied	\N	\N	\N	\N	85483	85483	85484
19599	27551	1	applied	\N	\N	\N	\N	85485	85485	85486
19599	27552	2	applied	\N	\N	\N	\N	85487	85487	85488
19608	27569	0	applied	\N	\N	\N	\N	85534	85534	85535
19608	27570	1	applied	\N	\N	\N	\N	85536	85536	85537
19608	27571	2	applied	\N	\N	\N	\N	85538	85538	85539
19608	27572	3	applied	\N	\N	\N	\N	85540	85540	85541
19608	27573	4	applied	\N	\N	\N	\N	85542	85542	85543
19608	27574	5	applied	\N	\N	\N	\N	85544	85544	85545
19608	27575	6	applied	\N	\N	\N	\N	85546	85546	85547
19611	27579	0	applied	\N	\N	\N	\N	85558	85558	85559
19611	27580	1	applied	\N	\N	\N	\N	85560	85560	85561
19611	27581	2	applied	\N	\N	\N	\N	85562	85562	85563
19611	27582	3	applied	\N	\N	\N	\N	85564	85564	85565
19611	27583	4	applied	\N	\N	\N	\N	85566	85566	85567
19611	27584	5	applied	\N	\N	\N	\N	85568	85568	85569
19611	27585	6	applied	\N	\N	\N	\N	85570	85570	85571
19614	27593	0	applied	\N	\N	\N	\N	85590	85590	85591
19614	27594	1	applied	\N	\N	\N	\N	85592	85592	85593
19614	27595	2	applied	\N	\N	\N	\N	85594	85594	85595
19614	27596	3	applied	\N	\N	\N	\N	85596	85596	85597
19614	27597	4	applied	\N	\N	\N	\N	85598	85598	85599
19614	27598	5	applied	\N	\N	\N	\N	85600	85600	85601
19614	27599	6	applied	\N	\N	\N	\N	85602	85602	85603
19614	27600	7	applied	\N	\N	\N	\N	85604	85604	85605
19614	27601	8	applied	\N	\N	\N	\N	85606	85606	85607
19617	27602	0	applied	\N	\N	\N	\N	85613	85613	85614
19617	27603	1	applied	\N	\N	\N	\N	85615	85615	85616
19617	27604	2	applied	\N	\N	\N	\N	85617	85617	85618
19617	27605	4	applied	\N	\N	\N	\N	85620	85620	85621
19617	27606	5	applied	\N	\N	\N	\N	85622	85622	85623
19617	27607	6	applied	\N	\N	\N	\N	85624	85624	85625
19617	27608	7	applied	\N	\N	\N	\N	85626	85626	85627
19617	27609	8	applied	\N	\N	\N	\N	85628	85628	85629
19617	27610	9	applied	\N	\N	\N	\N	85630	85630	85631
19622	27611	0	applied	\N	\N	\N	\N	85685	85685	85686
19622	27612	1	applied	\N	\N	\N	\N	85687	85687	85688
19622	27613	2	applied	\N	\N	\N	\N	85689	85689	85690
19622	27614	3	applied	\N	\N	\N	\N	85691	85691	85692
19622	27615	4	applied	\N	\N	\N	\N	85693	85693	85694
19622	27616	5	applied	\N	\N	\N	\N	85695	85695	85696
19622	27617	6	applied	\N	\N	\N	\N	85697	85697	85698
19624	27621	0	applied	\N	\N	\N	\N	85707	85707	85708
19624	27622	1	applied	\N	\N	\N	\N	85709	85709	85710
19624	27623	2	applied	\N	\N	\N	\N	85711	85711	85712
19624	27624	3	applied	\N	\N	\N	\N	85713	85713	85714
19624	27625	4	applied	\N	\N	\N	\N	85715	85715	85716
19624	27626	5	applied	\N	\N	\N	\N	85717	85717	85718
19624	27627	6	applied	\N	\N	\N	\N	85719	85719	85720
19625	27628	0	applied	\N	\N	\N	\N	85722	85722	85723
19625	27629	1	applied	\N	\N	\N	\N	85724	85724	85725
19625	27630	2	applied	\N	\N	\N	\N	85726	85726	85727
19625	27631	3	applied	\N	\N	\N	\N	85728	85728	85729
19625	27632	4	applied	\N	\N	\N	\N	85730	85730	85731
19625	27633	5	applied	\N	\N	\N	\N	85732	85732	85733
19625	27634	6	applied	\N	\N	\N	\N	85734	85734	85735
19625	27635	7	applied	\N	\N	\N	\N	85736	85736	85737
19625	27636	8	applied	\N	\N	\N	\N	85738	85738	85739
19625	27637	9	applied	\N	\N	\N	\N	85740	85740	85741
19625	27638	10	applied	\N	\N	\N	\N	85742	85742	85743
19625	27639	11	applied	\N	\N	\N	\N	85744	85744	85745
19625	27640	12	applied	\N	\N	\N	\N	85746	85746	85747
19630	27651	0	applied	\N	\N	\N	\N	85775	85775	85776
19630	27652	1	applied	\N	\N	\N	\N	85777	85777	85778
19630	27653	2	applied	\N	\N	\N	\N	85779	85779	85780
19639	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19639	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19639	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19642	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19642	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19642	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19644	27674	0	applied	\N	\N	\N	\N	85864	85864	85865
19644	27675	1	applied	\N	\N	\N	\N	85866	85866	85867
19644	27676	2	applied	\N	\N	\N	\N	85868	85868	85869
19644	27677	3	applied	\N	\N	\N	\N	85870	85870	85871
19644	27678	4	applied	\N	\N	\N	\N	85872	85872	85873
19644	27679	5	applied	\N	\N	\N	\N	85874	85874	85875
19644	27680	6	applied	\N	\N	\N	\N	85876	85876	85877
19647	27579	0	applied	\N	\N	\N	\N	85558	85558	85559
19647	27580	1	applied	\N	\N	\N	\N	85560	85560	85561
19647	27586	2	applied	\N	\N	\N	\N	85573	85573	85574
19647	27587	3	applied	\N	\N	\N	\N	85575	85575	85576
19647	27593	4	applied	\N	\N	\N	\N	85590	85590	85591
19647	27594	5	applied	\N	\N	\N	\N	85592	85592	85593
19647	27595	6	applied	\N	\N	\N	\N	85594	85594	85595
19647	27602	7	applied	\N	\N	\N	\N	85613	85613	85614
19647	27603	8	applied	\N	\N	\N	\N	85615	85615	85616
19647	27604	9	applied	\N	\N	\N	\N	85617	85617	85618
19647	27611	10	applied	\N	\N	\N	\N	85685	85685	85686
19647	27612	11	applied	\N	\N	\N	\N	85687	85687	85688
19647	27618	12	applied	\N	\N	\N	\N	85701	85701	85702
19647	27621	13	applied	\N	\N	\N	\N	85707	85707	85708
19647	27622	14	applied	\N	\N	\N	\N	85709	85709	85710
19647	27628	15	applied	\N	\N	\N	\N	85722	85722	85723
19647	27629	16	applied	\N	\N	\N	\N	85724	85724	85725
19647	27630	17	applied	\N	\N	\N	\N	85726	85726	85727
19553	27469	0	applied	\N	\N	\N	\N	85228	85228	85229
19553	27470	1	applied	\N	\N	\N	\N	85230	85230	85231
19553	27471	2	applied	\N	\N	\N	\N	85232	85232	85233
19554	27469	0	applied	\N	\N	\N	\N	85228	85228	85229
19554	27470	1	applied	\N	\N	\N	\N	85230	85230	85231
19554	27472	2	applied	\N	\N	\N	\N	85234	85234	85235
19554	27471	3	applied	\N	\N	\N	\N	85232	85232	85236
19556	27469	0	applied	\N	\N	\N	\N	85228	85228	85229
19556	27470	1	applied	\N	\N	\N	\N	85230	85230	85231
19556	27472	2	applied	\N	\N	\N	\N	85234	85234	85235
19556	27471	3	applied	\N	\N	\N	\N	85232	85232	85236
19557	27436	0	applied	\N	\N	\N	\N	85140	85140	85141
19557	27440	1	applied	\N	\N	\N	\N	85152	85152	85153
19557	27443	2	applied	\N	\N	\N	\N	85159	85159	85160
19557	27444	3	applied	\N	\N	\N	\N	85161	85161	85162
19557	27445	4	applied	\N	\N	\N	\N	85163	85163	85164
19557	27453	5	applied	\N	\N	\N	\N	85188	85188	85189
19557	27456	6	applied	\N	\N	\N	\N	85196	85196	85197
19557	27457	8	applied	\N	\N	\N	\N	85198	85198	85199
19557	27463	9	applied	\N	\N	\N	\N	85215	85215	85216
19557	27464	10	applied	\N	\N	\N	\N	85217	85217	85218
19557	27469	11	applied	\N	\N	\N	\N	85228	85228	85229
19557	27437	12	applied	\N	\N	\N	\N	85142	85142	85143
19557	27438	13	applied	\N	\N	\N	\N	85144	85144	85145
19557	27442	14	applied	\N	\N	\N	\N	85156	85156	85242
19557	27446	15	applied	\N	\N	\N	\N	85165	85165	85155
19557	27439	16	applied	\N	\N	\N	\N	85146	85146	85243
19557	27441	17	applied	\N	\N	\N	\N	85154	85154	85166
19557	27450	18	applied	\N	\N	\N	\N	85175	85175	85177
19557	27451	19	applied	\N	\N	\N	\N	85178	85178	85179
19557	27452	20	applied	\N	\N	\N	\N	85180	85180	85170
19557	27454	21	applied	\N	\N	\N	\N	85190	85190	85244
19557	27458	22	applied	\N	\N	\N	\N	85200	85200	85245
19557	27459	23	applied	\N	\N	\N	\N	85202	85202	85181
19557	27466	24	applied	\N	\N	\N	\N	85221	85221	85246
19557	27467	25	applied	\N	\N	\N	\N	85223	85223	85247
19557	27472	26	applied	\N	\N	\N	\N	85234	85234	85248
19557	27447	27	applied	\N	\N	\N	\N	85167	85167	85249
19557	27448	28	applied	\N	\N	\N	\N	85169	85169	85203
19557	27449	29	applied	\N	\N	\N	\N	85171	85171	85250
19557	27455	30	applied	\N	\N	\N	\N	85192	85192	85251
19557	27460	31	applied	\N	\N	\N	\N	85204	85204	85209
19557	27470	32	applied	\N	\N	\N	\N	85230	85230	85252
19557	27461	33	applied	\N	\N	\N	\N	85206	85206	85253
19557	27462	34	applied	\N	\N	\N	\N	85208	85208	85224
19557	27465	35	applied	\N	\N	\N	\N	85219	85219	85226
19557	27468	36	applied	\N	\N	\N	\N	85225	85225	85235
19557	27471	37	applied	\N	\N	\N	\N	85232	85232	85236
19558	27473	0	applied	\N	\N	\N	\N	85257	85257	85258
19558	27474	1	applied	\N	\N	\N	\N	85259	85259	85260
19558	27472	2	applied	\N	\N	\N	\N	85234	85234	85261
19558	27475	3	applied	\N	\N	\N	\N	85262	85262	85263
19560	27476	0	applied	\N	\N	\N	\N	85265	85265	85266
19560	27477	1	applied	\N	\N	\N	\N	85267	85267	85268
19562	27482	0	applied	\N	\N	\N	\N	85281	85281	85282
19562	27483	1	applied	\N	\N	\N	\N	85283	85283	85284
19562	27484	2	applied	\N	\N	\N	\N	85285	85285	85286
19562	27485	3	applied	\N	\N	\N	\N	85287	85287	85288
19563	27486	0	applied	\N	\N	\N	\N	85289	85289	85290
19563	27487	1	applied	\N	\N	\N	\N	85291	85291	85292
19563	27488	2	applied	\N	\N	\N	\N	85293	85293	85294
19564	27489	0	applied	\N	\N	\N	\N	85297	85297	85298
19564	27490	1	applied	\N	\N	\N	\N	85299	85299	85300
19564	27491	2	applied	\N	\N	\N	\N	85301	85301	85302
19565	27492	0	applied	\N	\N	\N	\N	85305	85305	85306
19565	27493	1	applied	\N	\N	\N	\N	85307	85307	85308
19565	27494	2	applied	\N	\N	\N	\N	85309	85309	85310
19566	27492	0	applied	\N	\N	\N	\N	85305	85305	85306
19566	27493	1	applied	\N	\N	\N	\N	85307	85307	85308
19566	27495	2	applied	\N	\N	\N	\N	85313	85313	85314
19566	27494	3	applied	\N	\N	\N	\N	85309	85309	85315
19567	27496	0	applied	\N	\N	\N	\N	85318	85318	85319
19567	27497	1	applied	\N	\N	\N	\N	85320	85320	85321
19567	27498	2	applied	\N	\N	\N	\N	85322	85322	85323
19568	27202	0	applied	\N	\N	1000000000	\N	84502	84502	84503
19568	27191	1	applied	\N	\N	\N	\N	84472	84472	84473
19568	27359	2	applied	\N	\N	1000000000	\N	84907	84907	84908
19568	27195	3	applied	\N	\N	\N	\N	84483	84483	84484
19568	27203	4	applied	\N	\N	\N	\N	84504	84504	84505
19568	27199	5	applied	\N	\N	\N	\N	84492	84492	84493
19568	27196	6	applied	\N	\N	1000000000	\N	84485	84485	84486
19568	27204	7	applied	\N	\N	\N	\N	84506	84506	84507
19568	27205	8	applied	\N	\N	\N	\N	84508	84508	84509
19568	27212	9	applied	\N	\N	\N	\N	84524	84524	84525
19568	27215	10	applied	\N	\N	\N	\N	84534	84534	84535
19568	27216	11	applied	\N	\N	\N	\N	84536	84536	84537
19568	27223	12	applied	\N	\N	\N	\N	84552	84552	84553
19568	27226	13	applied	\N	\N	\N	\N	84562	84562	84563
19568	27227	14	applied	\N	\N	\N	\N	84564	84564	84565
19568	27228	15	applied	\N	\N	\N	\N	84566	84566	84567
19568	27229	16	applied	\N	\N	\N	\N	84568	84568	84569
19568	27230	17	applied	\N	\N	\N	\N	84570	84570	84571
19568	27244	18	applied	\N	\N	\N	\N	84600	84600	84601
19568	27248	19	applied	\N	\N	\N	\N	84610	84610	84611
19568	27252	20	applied	\N	\N	\N	\N	84620	84620	84621
19568	27255	21	applied	\N	\N	\N	\N	84626	84626	84627
19568	27256	22	applied	\N	\N	\N	\N	84628	84628	84629
19568	27262	23	applied	\N	\N	\N	\N	84650	84650	84651
19568	27265	24	applied	\N	\N	\N	\N	84662	84662	84663
19568	27266	25	applied	\N	\N	\N	\N	84664	84664	84665
19568	27272	26	applied	\N	\N	\N	\N	84678	84678	84679
19568	27275	27	applied	\N	\N	\N	\N	84686	84686	84687
19568	27278	28	applied	\N	\N	\N	\N	84695	84695	84696
19568	27282	29	applied	\N	\N	\N	\N	84705	84705	84706
19568	27283	30	applied	\N	\N	\N	\N	84707	84707	84708
19568	27284	31	applied	\N	\N	\N	\N	84709	84709	84710
19568	27292	32	applied	\N	\N	\N	\N	84727	84727	84728
19568	27295	33	applied	\N	\N	\N	\N	84736	84736	84737
19568	27297	34	applied	\N	\N	\N	\N	84744	84744	84745
19568	27301	35	applied	\N	\N	\N	\N	84756	84756	84757
19568	27304	36	applied	\N	\N	\N	\N	84762	84762	84763
19568	27305	37	applied	\N	\N	\N	\N	84764	84764	84765
19568	27306	38	applied	\N	\N	\N	\N	84766	84766	84767
19568	27315	39	applied	\N	\N	\N	\N	84785	84785	84786
19568	27318	40	applied	\N	\N	\N	\N	84792	84792	84793
19568	27321	41	applied	\N	\N	\N	\N	84801	84801	84802
19568	27325	42	applied	\N	\N	\N	\N	84811	84811	84812
19568	27328	43	applied	\N	\N	\N	\N	84818	84818	84819
19568	27335	44	applied	\N	\N	\N	\N	84833	84833	84834
19568	27340	45	applied	\N	\N	\N	\N	84849	84849	84850
19568	27341	46	applied	\N	\N	\N	\N	84851	84851	84852
19568	27348	47	applied	\N	\N	\N	\N	84873	84873	84874
19568	27352	48	applied	\N	\N	\N	\N	84888	84888	84889
19568	27356	49	applied	\N	\N	\N	\N	84897	84897	84898
19568	27360	50	applied	\N	\N	\N	\N	84909	84909	84910
19568	27364	51	applied	\N	\N	\N	\N	84925	84925	84926
19568	27367	52	applied	\N	\N	\N	\N	84932	84932	84933
19568	27368	53	applied	\N	\N	\N	\N	84934	84934	84935
19568	27369	54	applied	\N	\N	\N	\N	84936	84936	84937
19568	27377	55	applied	\N	\N	\N	\N	84953	84953	84954
19568	27380	56	applied	\N	\N	\N	\N	84963	84963	84964
19568	27383	57	applied	\N	\N	\N	\N	84971	84971	84972
19568	27387	58	applied	\N	\N	\N	\N	84986	84986	84987
19568	27388	59	applied	\N	\N	\N	\N	84988	84988	84989
19568	27393	60	applied	\N	\N	\N	\N	85005	85005	85006
19568	27397	61	applied	\N	\N	\N	\N	85021	85021	85022
19568	27400	62	applied	\N	\N	\N	\N	85028	85028	85029
19568	27403	63	applied	\N	\N	\N	\N	85035	85035	85036
19568	27407	64	applied	\N	\N	\N	\N	85049	85049	85050
19568	27410	65	applied	\N	\N	\N	\N	85059	85059	85060
19568	27413	66	applied	\N	\N	\N	\N	85065	85065	85066
19568	27416	67	applied	\N	\N	\N	\N	85075	85075	85076
19568	27420	68	applied	\N	\N	\N	\N	85085	85085	85086
19568	27423	69	applied	\N	\N	\N	\N	85093	85093	85094
19568	27424	70	applied	\N	\N	\N	\N	85095	85095	85096
19568	27430	71	applied	\N	\N	\N	\N	85109	85109	85110
19568	27433	72	applied	\N	\N	\N	\N	85120	85120	85121
19568	27436	73	applied	\N	\N	\N	\N	85140	85140	85141
19568	27440	74	applied	\N	\N	\N	\N	85152	85152	85153
19568	27443	75	applied	\N	\N	\N	\N	85159	85159	85160
19568	27444	76	applied	\N	\N	\N	\N	85161	85161	85162
19568	27445	77	applied	\N	\N	\N	\N	85163	85163	85164
19568	27453	78	applied	\N	\N	\N	\N	85188	85188	85189
19568	27456	79	applied	\N	\N	\N	\N	85196	85196	85197
19568	27457	80	applied	\N	\N	\N	\N	85198	85198	85199
19568	27463	81	applied	\N	\N	\N	\N	85215	85215	85216
19568	27464	82	applied	\N	\N	\N	\N	85217	85217	85218
19568	27469	83	applied	\N	\N	\N	\N	85228	85228	85229
19568	27473	84	applied	\N	\N	\N	\N	85257	85257	85258
19568	27476	85	applied	\N	\N	\N	\N	85265	85265	85266
19568	27478	87	applied	\N	\N	\N	\N	85271	85271	85272
19568	27482	88	applied	\N	\N	\N	\N	85281	85281	85282
19568	27486	89	applied	\N	\N	\N	\N	85289	85289	85290
19568	27489	90	applied	\N	\N	\N	\N	85297	85297	85298
19568	27492	91	applied	\N	\N	\N	\N	85305	85305	85306
19568	27496	92	applied	\N	\N	\N	\N	85318	85318	85319
19568	27329	93	applied	\N	\N	\N	\N	84820	84820	84821
19568	27192	94	applied	\N	\N	\N	\N	84474	84474	84475
19568	27193	95	applied	\N	\N	\N	\N	84476	84476	84477
19568	27207	96	applied	\N	\N	\N	\N	84512	84512	84513
19568	27221	97	applied	\N	\N	\N	\N	84546	84546	84547
19568	27232	98	applied	\N	\N	\N	\N	84574	84574	84575
19568	27194	99	applied	\N	\N	\N	\N	84478	84478	84479
19568	27206	100	applied	\N	\N	\N	\N	84510	84510	85327
19568	27218	101	applied	\N	\N	\N	\N	84540	84540	85328
19568	27231	102	applied	\N	\N	\N	\N	84572	84572	84488
19568	27246	103	applied	\N	\N	\N	\N	84604	84604	85329
19568	27257	104	applied	\N	\N	\N	\N	84630	84630	84490
19568	27234	105	applied	\N	\N	1000000000	\N	84578	84578	84579
19568	27307	106	applied	\N	\N	1000000000	\N	84768	84768	84769
19568	27331	107	applied	\N	\N	1000000000	\N	84824	84824	84825
19568	27332	108	applied	\N	\N	1000000000	\N	84826	84826	84827
19568	27333	109	applied	\N	\N	\N	\N	84828	84828	84829
19568	27344	110	applied	\N	\N	\N	\N	85047	85047	84858
19568	27197	111	applied	\N	\N	\N	\N	84487	84487	84495
19568	27200	112	applied	\N	\N	\N	\N	84494	84494	84511
19568	27208	113	applied	\N	\N	\N	\N	84514	84514	84515
19568	27339	114	applied	\N	\N	\N	\N	84841	84841	84842
19568	27198	115	applied	\N	\N	\N	\N	84489	84489	85330
19568	27201	116	applied	\N	\N	\N	\N	84496	84496	85331
19568	27209	117	applied	\N	\N	\N	\N	84516	84516	84521
19568	27214	118	applied	\N	\N	\N	\N	84528	84528	85332
19568	27217	119	applied	\N	\N	\N	\N	84538	84538	85333
19568	27222	120	applied	\N	\N	\N	\N	84548	84548	84541
19568	27224	121	applied	\N	\N	\N	\N	84554	84554	85334
19568	27233	122	applied	\N	\N	\N	\N	84576	84576	85335
19568	27210	123	applied	\N	\N	\N	\N	84518	84518	85336
19568	27211	124	applied	\N	\N	\N	\N	84520	84520	84555
19568	27213	125	applied	\N	\N	\N	\N	84526	84526	84557
19577	27508	0	applied	\N	\N	\N	\N	85369	85369	85370
19577	27509	1	applied	\N	\N	\N	\N	85371	85371	85372
19577	27510	2	applied	\N	\N	\N	\N	85373	85373	85374
19577	27511	3	applied	\N	\N	\N	\N	85375	85375	85376
19580	27519	0	applied	\N	\N	\N	\N	85396	85396	85397
19580	27518	1	applied	\N	\N	\N	\N	85393	85393	85398
19582	27520	0	applied	\N	\N	\N	\N	85400	85400	85401
19582	27521	1	applied	\N	\N	\N	\N	85402	85402	85403
19582	27522	2	applied	\N	\N	\N	\N	85404	85404	85405
19585	27523	0	applied	\N	\N	\N	\N	85410	85410	85411
19585	27524	1	applied	\N	\N	\N	\N	85412	85412	85413
19585	27525	2	applied	\N	\N	\N	\N	85414	85414	85415
19585	27526	3	applied	\N	\N	\N	\N	85416	85416	85417
19586	27527	0	applied	\N	\N	\N	\N	85423	85423	85424
19586	27528	1	applied	\N	\N	\N	\N	85425	85425	85426
19586	27529	2	applied	\N	\N	\N	\N	85427	85427	85428
19598	27550	0	applied	\N	\N	\N	\N	85483	85483	85484
19598	27551	1	applied	\N	\N	\N	\N	85485	85485	85486
19598	27552	2	applied	\N	\N	\N	\N	85487	85487	85488
19601	27553	0	applied	\N	\N	\N	\N	85493	85493	85494
19601	27554	1	applied	\N	\N	\N	\N	85495	85495	85496
19601	27555	2	applied	\N	\N	\N	\N	85497	85497	85498
19601	27556	3	applied	\N	\N	\N	\N	85499	85499	85500
19601	27557	4	applied	\N	\N	\N	\N	85501	85501	85502
19601	27558	5	applied	\N	\N	\N	\N	85503	85503	85504
19601	27559	6	applied	\N	\N	\N	\N	85505	85505	85506
19603	27563	0	applied	\N	\N	\N	\N	85517	85517	85518
19603	27564	1	applied	\N	\N	\N	\N	85519	85519	85520
19603	27565	2	applied	\N	\N	\N	\N	85521	85521	85522
19606	27566	0	applied	\N	\N	\N	\N	85525	85525	85526
19606	27567	1	applied	\N	\N	\N	\N	85527	85527	85528
19606	27568	2	applied	\N	\N	\N	\N	85529	85529	85530
19610	27576	0	applied	\N	\N	\N	\N	85550	85550	85551
19610	27577	1	applied	\N	\N	\N	\N	85552	85552	85553
19610	27578	2	applied	\N	\N	\N	\N	85554	85554	85555
19621	27611	0	applied	\N	\N	\N	\N	85685	85685	85686
19621	27612	1	applied	\N	\N	\N	\N	85687	85687	85688
19621	27613	2	applied	\N	\N	\N	\N	85689	85689	85690
19621	27614	3	applied	\N	\N	\N	\N	85691	85691	85692
19570	27498	0	applied	\N	\N	\N	\N	85322	85322	85340
19572	27496	0	applied	\N	\N	\N	\N	85318	85318	85319
19572	27499	1	applied	\N	\N	\N	\N	85342	85342	85343
19572	27497	2	applied	\N	\N	\N	\N	85320	85320	85323
19572	27500	3	applied	\N	\N	\N	\N	85344	85344	85345
19574	27500	0	applied	\N	\N	\N	\N	85344	85344	85345
19576	27504	0	applied	\N	\N	\N	\N	85359	85359	85360
19576	27505	1	applied	\N	\N	\N	\N	85361	85361	85362
19576	27506	2	applied	\N	\N	\N	\N	85363	85363	85364
19576	27507	3	applied	\N	\N	\N	\N	85365	85365	85366
19579	27518	0	applied	\N	\N	\N	\N	85393	85393	85394
19581	27520	0	applied	\N	\N	\N	\N	85400	85400	85401
19581	27521	1	applied	\N	\N	\N	\N	85402	85402	85403
19581	27522	2	applied	\N	\N	\N	\N	85404	85404	85405
19584	27523	0	applied	\N	\N	\N	\N	85410	85410	85411
19584	27524	1	applied	\N	\N	\N	\N	85412	85412	85413
19584	27525	2	applied	\N	\N	\N	\N	85414	85414	85415
19584	27526	3	applied	\N	\N	\N	\N	85416	85416	85417
19590	27527	0	applied	\N	\N	\N	\N	85423	85423	85424
19590	27528	1	applied	\N	\N	\N	\N	85425	85425	85426
19590	27529	2	applied	\N	\N	\N	\N	85427	85427	85428
19597	27540	0	applied	\N	\N	\N	\N	85461	85461	85462
19597	27541	1	applied	\N	\N	\N	\N	85463	85463	85464
19597	27542	2	applied	\N	\N	\N	\N	85465	85465	85466
19597	27543	3	applied	\N	\N	\N	\N	85467	85467	85468
19597	27544	4	applied	\N	\N	\N	\N	85469	85469	85470
19597	27545	5	applied	\N	\N	\N	\N	85471	85471	85472
19597	27546	6	applied	\N	\N	\N	\N	85473	85473	85474
19597	27547	7	applied	\N	\N	\N	\N	85475	85475	85476
19597	27548	8	applied	\N	\N	\N	\N	85477	85477	85478
19597	27549	9	applied	\N	\N	\N	\N	85479	85479	85480
19600	27553	0	applied	\N	\N	\N	\N	85493	85493	85494
19600	27554	1	applied	\N	\N	\N	\N	85495	85495	85496
19600	27555	2	applied	\N	\N	\N	\N	85497	85497	85498
19600	27556	3	applied	\N	\N	\N	\N	85499	85499	85500
19600	27557	4	applied	\N	\N	\N	\N	85501	85501	85502
19600	27558	5	applied	\N	\N	\N	\N	85503	85503	85504
19600	27559	6	applied	\N	\N	\N	\N	85505	85505	85506
19602	27560	0	applied	\N	\N	\N	\N	85511	85511	85512
19602	27561	1	applied	\N	\N	\N	\N	85513	85513	85514
19602	27562	2	applied	\N	\N	\N	\N	85515	85515	85516
19605	27566	0	applied	\N	\N	\N	\N	85525	85525	85526
19605	27567	1	applied	\N	\N	\N	\N	85527	85527	85528
19605	27568	2	applied	\N	\N	\N	\N	85529	85529	85530
19607	27202	0	applied	\N	\N	1000000000	\N	84502	84502	84503
19607	27359	1	applied	\N	\N	1000000000	\N	84907	84907	84908
19607	27203	2	applied	\N	\N	\N	\N	84504	84504	84505
19607	27196	3	applied	\N	\N	1000000000	\N	84485	84485	84486
19607	27329	4	applied	\N	\N	\N	\N	84820	84820	84821
19607	27207	5	applied	\N	\N	\N	\N	84512	84512	84513
19607	27221	6	applied	\N	\N	\N	\N	84546	84546	84547
19607	27232	7	applied	\N	\N	\N	\N	84574	84574	84575
19607	27344	8	applied	\N	\N	\N	\N	85047	85047	84858
19607	27135	9	applied	\N	\N	\N	\N	84291	84291	84292
19607	27142	10	applied	\N	\N	\N	\N	84317	84317	84318
19613	27586	0	applied	\N	\N	\N	\N	85573	85573	85574
19613	27587	1	applied	\N	\N	\N	\N	85575	85575	85576
19613	27588	2	applied	\N	\N	\N	\N	85577	85577	85578
19613	27589	3	applied	\N	\N	\N	\N	85579	85579	85580
19613	27590	4	applied	\N	\N	\N	\N	85581	85581	85582
19613	27591	5	applied	\N	\N	\N	\N	85583	85583	85584
19613	27592	6	applied	\N	\N	\N	\N	85585	85585	85586
19616	27593	0	applied	\N	\N	\N	\N	85590	85590	85591
19616	27594	1	applied	\N	\N	\N	\N	85592	85592	85593
19616	27595	2	applied	\N	\N	\N	\N	85594	85594	85595
19616	27596	3	applied	\N	\N	\N	\N	85596	85596	85597
19616	27597	4	applied	\N	\N	\N	\N	85598	85598	85599
19616	27598	5	applied	\N	\N	\N	\N	85600	85600	85601
19616	27599	6	applied	\N	\N	\N	\N	85602	85602	85603
19616	27600	7	applied	\N	\N	\N	\N	85604	85604	85605
19616	27601	8	applied	\N	\N	\N	\N	85606	85606	85607
19619	27602	0	applied	\N	\N	\N	\N	85613	85613	85614
19619	27603	1	applied	\N	\N	\N	\N	85615	85615	85616
19619	27604	2	applied	\N	\N	\N	\N	85617	85617	85618
19619	27605	4	applied	\N	\N	\N	\N	85620	85620	85621
19619	27606	5	applied	\N	\N	\N	\N	85622	85622	85623
19619	27607	6	applied	\N	\N	\N	\N	85624	85624	85625
19619	27608	7	applied	\N	\N	\N	\N	85626	85626	85627
19619	27609	8	applied	\N	\N	\N	\N	85628	85628	85629
19619	27610	9	applied	\N	\N	\N	\N	85630	85630	85631
19620	27473	0	applied	\N	\N	\N	\N	85257	85257	85258
19620	27476	1	applied	\N	\N	\N	\N	85265	85265	85266
19620	27478	2	applied	\N	\N	\N	\N	85271	85271	85272
19620	27482	3	applied	\N	\N	\N	\N	85281	85281	85282
19620	27486	4	applied	\N	\N	\N	\N	85289	85289	85290
19620	27489	5	applied	\N	\N	\N	\N	85297	85297	85298
19620	27492	6	applied	\N	\N	\N	\N	85305	85305	85306
19620	27496	7	applied	\N	\N	\N	\N	85318	85318	85319
19620	27499	8	applied	\N	\N	\N	\N	85342	85342	85343
19620	27501	9	applied	\N	\N	\N	\N	85352	85352	85353
19620	27504	10	applied	\N	\N	\N	\N	85359	85359	85360
19620	27508	11	applied	\N	\N	\N	\N	85369	85369	85370
19620	27509	12	applied	\N	\N	\N	\N	85371	85371	85372
19620	27512	13	applied	\N	\N	\N	\N	85378	85378	85379
19620	27520	14	applied	\N	\N	\N	\N	85400	85400	85401
19620	27523	15	applied	\N	\N	\N	\N	85410	85410	85411
19620	27527	16	applied	\N	\N	\N	\N	85423	85423	85424
19620	27530	17	applied	\N	\N	\N	\N	85436	85436	85437
19620	27533	18	applied	\N	\N	\N	\N	85446	85446	85447
19620	27536	19	applied	\N	\N	\N	\N	85453	85453	85454
19620	27540	20	applied	\N	\N	\N	\N	85461	85461	85462
19620	27541	21	applied	\N	\N	\N	\N	85463	85463	85464
19620	27542	22	applied	\N	\N	\N	\N	85465	85465	85466
19620	27550	23	applied	\N	\N	\N	\N	85483	85483	85484
19620	27553	24	applied	\N	\N	\N	\N	85493	85493	85494
19620	27554	25	applied	\N	\N	\N	\N	85495	85495	85496
19620	27560	26	applied	\N	\N	\N	\N	85511	85511	85512
19620	27563	27	applied	\N	\N	\N	\N	85517	85517	85518
19620	27566	28	applied	\N	\N	\N	\N	85525	85525	85526
19620	27569	29	applied	\N	\N	\N	\N	85534	85534	85535
19620	27570	30	applied	\N	\N	\N	\N	85536	85536	85537
19620	27576	31	applied	\N	\N	\N	\N	85550	85550	85551
19620	27579	32	applied	\N	\N	\N	\N	85558	85558	85559
19620	27580	33	applied	\N	\N	\N	\N	85560	85560	85561
19620	27586	34	applied	\N	\N	\N	\N	85573	85573	85574
19620	27587	35	applied	\N	\N	\N	\N	85575	85575	85576
19620	27593	36	applied	\N	\N	\N	\N	85590	85590	85591
19620	27594	37	applied	\N	\N	\N	\N	85592	85592	85593
19620	27595	38	applied	\N	\N	\N	\N	85594	85594	85595
19571	27496	0	applied	\N	\N	\N	\N	85318	85318	85319
19571	27499	1	applied	\N	\N	\N	\N	85342	85342	85343
19571	27497	2	applied	\N	\N	\N	\N	85320	85320	85323
19571	27500	3	applied	\N	\N	\N	\N	85344	85344	85345
19573	27499	0	applied	\N	\N	\N	\N	85342	85342	85343
19573	27500	1	applied	\N	\N	\N	\N	85344	85344	85345
19575	27499	0	applied	\N	\N	\N	\N	85342	85342	85343
19575	27501	1	applied	\N	\N	\N	\N	85352	85352	85353
19575	27502	2	applied	\N	\N	\N	\N	85354	85354	85355
19575	27503	3	applied	\N	\N	\N	\N	85356	85356	85357
19578	27512	0	applied	\N	\N	\N	\N	85378	85378	85379
19578	27513	1	applied	\N	\N	\N	\N	85380	85380	85381
19578	27514	2	applied	\N	\N	\N	\N	85382	85382	85383
19578	27515	3	applied	\N	\N	\N	\N	85384	85384	85385
19578	27516	5	applied	\N	\N	\N	\N	85387	85387	85388
19578	27517	6	applied	\N	\N	\N	\N	85389	85389	85390
19583	27523	0	applied	\N	\N	\N	\N	85410	85410	85411
19583	27524	1	applied	\N	\N	\N	\N	85412	85412	85413
19583	27525	2	applied	\N	\N	\N	\N	85414	85414	85415
19583	27526	3	applied	\N	\N	\N	\N	85416	85416	85417
19588	27527	0	applied	\N	\N	\N	\N	85423	85423	85424
19588	27528	1	applied	\N	\N	\N	\N	85425	85425	85426
19588	27529	2	applied	\N	\N	\N	\N	85427	85427	85428
19592	27530	0	applied	\N	\N	\N	\N	85436	85436	85437
19592	27531	1	applied	\N	\N	\N	\N	85438	85438	85439
19592	27532	2	applied	\N	\N	\N	\N	85440	85440	85441
19594	27530	0	applied	\N	\N	\N	\N	85436	85436	85437
19594	27531	1	applied	\N	\N	\N	\N	85438	85438	85439
19594	27532	2	applied	\N	\N	\N	\N	85440	85440	85441
19596	27536	0	applied	\N	\N	\N	\N	85453	85453	85454
19596	27537	1	applied	\N	\N	\N	\N	85455	85455	85456
19596	27538	2	applied	\N	\N	\N	\N	85457	85457	85458
19596	27539	3	applied	\N	\N	\N	\N	85459	85459	85460
19604	27566	0	applied	\N	\N	\N	\N	85525	85525	85526
19604	27567	1	applied	\N	\N	\N	\N	85527	85527	85528
19604	27568	2	applied	\N	\N	\N	\N	85529	85529	85530
19609	27202	0	applied	\N	\N	1000000000	\N	84502	84502	84503
19609	27359	1	applied	\N	\N	1000000000	\N	84907	84907	84908
19609	27123	2	applied	\N	\N	1000000000	\N	84258	84258	84259
19609	27203	3	applied	\N	\N	\N	\N	84504	84504	84505
19609	27196	4	applied	\N	\N	1000000000	\N	84485	84485	84486
19609	27112	5	applied	\N	\N	1000000000	\N	84234	84234	84235
19609	27329	6	applied	\N	\N	\N	\N	84820	84820	84821
19609	27207	7	applied	\N	\N	\N	\N	84512	84512	84513
19609	27221	8	applied	\N	\N	\N	\N	84546	84546	84547
19609	27232	9	applied	\N	\N	\N	\N	84574	84574	84575
19609	27234	10	applied	\N	\N	1000000000	\N	84578	84578	84579
19609	27307	11	applied	\N	\N	1000000000	\N	84768	84768	84769
19609	27331	12	applied	\N	\N	1000000000	\N	84824	84824	84825
19609	27332	13	applied	\N	\N	1000000000	\N	84826	84826	84827
19609	27333	14	applied	\N	\N	\N	\N	84828	84828	84829
19609	27344	15	applied	\N	\N	\N	\N	85047	85047	84858
19609	27339	16	applied	\N	\N	\N	\N	84841	84841	84842
19609	27135	17	applied	\N	\N	\N	\N	84291	84291	84292
19609	27142	18	applied	\N	\N	\N	\N	84317	84317	84318
19612	27586	0	applied	\N	\N	\N	\N	85573	85573	85574
19612	27587	1	applied	\N	\N	\N	\N	85575	85575	85576
19612	27588	2	applied	\N	\N	\N	\N	85577	85577	85578
19612	27589	3	applied	\N	\N	\N	\N	85579	85579	85580
19612	27590	4	applied	\N	\N	\N	\N	85581	85581	85582
19612	27591	5	applied	\N	\N	\N	\N	85583	85583	85584
19612	27592	6	applied	\N	\N	\N	\N	85585	85585	85586
19615	27593	0	applied	\N	\N	\N	\N	85590	85590	85591
19615	27594	1	applied	\N	\N	\N	\N	85592	85592	85593
19615	27595	2	applied	\N	\N	\N	\N	85594	85594	85595
19615	27596	3	applied	\N	\N	\N	\N	85596	85596	85597
19615	27597	4	applied	\N	\N	\N	\N	85598	85598	85599
19615	27598	5	applied	\N	\N	\N	\N	85600	85600	85601
19615	27599	6	applied	\N	\N	\N	\N	85602	85602	85603
19615	27600	7	applied	\N	\N	\N	\N	85604	85604	85605
19615	27601	8	applied	\N	\N	\N	\N	85606	85606	85607
19618	27602	0	applied	\N	\N	\N	\N	85613	85613	85614
19618	27603	1	applied	\N	\N	\N	\N	85615	85615	85616
19618	27604	2	applied	\N	\N	\N	\N	85617	85617	85618
19618	27605	4	applied	\N	\N	\N	\N	85620	85620	85621
19618	27606	5	applied	\N	\N	\N	\N	85622	85622	85623
19618	27607	6	applied	\N	\N	\N	\N	85624	85624	85625
19618	27608	7	applied	\N	\N	\N	\N	85626	85626	85627
19618	27609	8	applied	\N	\N	\N	\N	85628	85628	85629
19618	27610	9	applied	\N	\N	\N	\N	85630	85630	85631
19626	27628	0	applied	\N	\N	\N	\N	85722	85722	85723
19626	27629	1	applied	\N	\N	\N	\N	85724	85724	85725
19626	27630	2	applied	\N	\N	\N	\N	85726	85726	85727
19626	27631	3	applied	\N	\N	\N	\N	85728	85728	85729
19626	27632	4	applied	\N	\N	\N	\N	85730	85730	85731
19626	27633	5	applied	\N	\N	\N	\N	85732	85732	85733
19626	27634	6	applied	\N	\N	\N	\N	85734	85734	85735
19626	27635	7	applied	\N	\N	\N	\N	85736	85736	85737
19626	27636	8	applied	\N	\N	\N	\N	85738	85738	85739
19626	27637	9	applied	\N	\N	\N	\N	85740	85740	85741
19626	27638	10	applied	\N	\N	\N	\N	85742	85742	85743
19626	27639	11	applied	\N	\N	\N	\N	85744	85744	85745
19626	27640	12	applied	\N	\N	\N	\N	85746	85746	85747
19628	27641	0	applied	\N	\N	\N	\N	85754	85754	85755
19628	27642	1	applied	\N	\N	\N	\N	85756	85756	85757
19628	27643	2	applied	\N	\N	\N	\N	85758	85758	85759
19628	27644	3	applied	\N	\N	\N	\N	85760	85760	85761
19628	27645	4	applied	\N	\N	\N	\N	85762	85762	85763
19628	27646	5	applied	\N	\N	\N	\N	85764	85764	85765
19628	27647	6	applied	\N	\N	\N	\N	85766	85766	85767
19631	27654	0	applied	\N	\N	\N	\N	85783	85783	85784
19631	27655	1	applied	\N	\N	\N	\N	85785	85785	85786
19631	27656	2	applied	\N	\N	\N	\N	85787	85787	85788
19631	27657	3	applied	\N	\N	\N	\N	85789	85789	85790
19631	27658	4	applied	\N	\N	\N	\N	85791	85791	85792
19631	27659	5	applied	\N	\N	\N	\N	85793	85793	85794
19631	27660	6	applied	\N	\N	\N	\N	85795	85795	85796
19633	27593	0	applied	\N	\N	\N	\N	85590	85590	85591
19633	27594	1	applied	\N	\N	\N	\N	85592	85592	85593
19633	27595	2	applied	\N	\N	\N	\N	85594	85594	85595
19633	27602	3	applied	\N	\N	\N	\N	85613	85613	85614
19633	27603	4	applied	\N	\N	\N	\N	85615	85615	85616
19633	27604	5	applied	\N	\N	\N	\N	85617	85617	85618
19633	27611	6	applied	\N	\N	\N	\N	85685	85685	85686
19633	27612	7	applied	\N	\N	\N	\N	85687	85687	85688
19633	27618	8	applied	\N	\N	\N	\N	85701	85701	85702
19633	27621	9	applied	\N	\N	\N	\N	85707	85707	85708
19633	27622	10	applied	\N	\N	\N	\N	85709	85709	85710
19633	27628	11	applied	\N	\N	\N	\N	85722	85722	85723
19620	27602	39	applied	\N	\N	\N	\N	85613	85613	85614
19620	27603	40	applied	\N	\N	\N	\N	85615	85615	85616
19620	27604	41	applied	\N	\N	\N	\N	85617	85617	85618
19620	27474	42	applied	\N	\N	\N	\N	85259	85259	85261
19620	27477	43	applied	\N	\N	\N	\N	85267	85267	85642
19620	27479	44	applied	\N	\N	\N	\N	85273	85273	85643
19620	27483	45	applied	\N	\N	\N	\N	85283	85283	85644
19620	27475	46	applied	\N	\N	\N	\N	85262	85262	85645
19620	27488	47	applied	\N	\N	\N	\N	85293	85293	85646
19620	27490	48	applied	\N	\N	\N	\N	85299	85299	85286
19620	27493	49	applied	\N	\N	\N	\N	85307	85307	85292
19620	27497	50	applied	\N	\N	\N	\N	85320	85320	85294
19620	27503	51	applied	\N	\N	\N	\N	85356	85356	85300
19620	27480	52	applied	\N	\N	\N	\N	85275	85275	85302
19620	27481	53	applied	\N	\N	\N	\N	85277	85277	85647
19620	27484	54	applied	\N	\N	\N	\N	85285	85285	85310
19620	27487	55	applied	\N	\N	\N	\N	85291	85291	85315
19620	27507	56	applied	\N	\N	\N	\N	85365	85365	85321
19620	27510	57	applied	\N	\N	\N	\N	85373	85373	85648
19620	27511	58	applied	\N	\N	\N	\N	85375	85375	85355
19620	27513	59	applied	\N	\N	\N	\N	85380	85380	85357
19620	27518	60	applied	\N	\N	\N	\N	85393	85393	85364
19620	27485	61	applied	\N	\N	\N	\N	85287	85287	85649
19620	27494	62	applied	\N	\N	\N	\N	85309	85309	85650
19620	27505	63	applied	\N	\N	\N	\N	85361	85361	85366
19620	27514	64	applied	\N	\N	\N	\N	85382	85382	85651
19620	27524	65	applied	\N	\N	\N	\N	85412	85412	85652
19620	27538	66	applied	\N	\N	\N	\N	85457	85457	85374
19620	27544	67	applied	\N	\N	\N	\N	85469	85469	85653
19620	27555	68	applied	\N	\N	\N	\N	85497	85497	85654
19620	27571	69	applied	\N	\N	\N	\N	85538	85538	85376
19620	27522	70	applied	\N	\N	\N	\N	85404	85404	85381
19620	27526	71	applied	\N	\N	\N	\N	85416	85416	85385
19620	27528	72	applied	\N	\N	\N	\N	85425	85425	85655
19620	27532	73	applied	\N	\N	\N	\N	85440	85440	85397
19620	27534	74	applied	\N	\N	\N	\N	85448	85448	85398
19620	27537	75	applied	\N	\N	\N	\N	85455	85455	85656
19620	27545	76	applied	\N	\N	\N	\N	85471	85471	85413
19620	27546	77	applied	\N	\N	\N	\N	85473	85473	85657
19620	27547	78	applied	\N	\N	\N	\N	85475	85475	85658
19620	27552	79	applied	\N	\N	\N	\N	85487	85487	85659
19620	27556	80	applied	\N	\N	\N	\N	85499	85499	85439
19620	27557	81	applied	\N	\N	\N	\N	85501	85501	85441
19620	27561	82	applied	\N	\N	\N	\N	85513	85513	85449
19620	27565	83	applied	\N	\N	\N	\N	85521	85521	85660
19620	27567	84	applied	\N	\N	\N	\N	85527	85527	85458
19620	27572	85	applied	\N	\N	\N	\N	85540	85540	85661
19620	27573	86	applied	\N	\N	\N	\N	85542	85542	85662
19620	27577	87	applied	\N	\N	\N	\N	85552	85552	85663
19620	27581	88	applied	\N	\N	\N	\N	85562	85562	85664
19620	27583	89	applied	\N	\N	\N	\N	85566	85566	85665
19620	27588	90	applied	\N	\N	\N	\N	85577	85577	85480
19620	27590	91	applied	\N	\N	\N	\N	85581	85581	85666
19620	27597	92	applied	\N	\N	\N	\N	85598	85598	85498
19620	27598	93	applied	\N	\N	\N	\N	85600	85600	85500
19620	27599	94	applied	\N	\N	\N	\N	85602	85602	85502
19620	27607	96	applied	\N	\N	\N	\N	85624	85624	85668
19620	27608	97	applied	\N	\N	\N	\N	85626	85626	85669
19620	27585	98	applied	\N	\N	\N	\N	85570	85570	85514
19620	27589	99	applied	\N	\N	\N	\N	85579	85579	85670
19620	27609	100	applied	\N	\N	\N	\N	85628	85628	85516
19620	27491	101	applied	\N	\N	\N	\N	85301	85301	85520
19620	27495	102	applied	\N	\N	\N	\N	85313	85313	85671
19620	27498	103	applied	\N	\N	\N	\N	85322	85322	85672
19620	27500	104	applied	\N	\N	\N	\N	85344	85344	85528
19620	27502	105	applied	\N	\N	\N	\N	85354	85354	85530
19620	27506	106	applied	\N	\N	\N	\N	85363	85363	85673
19620	27515	107	applied	\N	\N	\N	\N	85384	85384	85541
19620	27516	108	applied	\N	\N	\N	\N	85387	85387	85674
19620	27517	109	applied	\N	\N	\N	\N	85389	85389	85675
19620	27519	110	applied	\N	\N	\N	\N	85396	85396	85676
19620	27521	111	applied	\N	\N	\N	\N	85402	85402	85677
19620	27525	112	applied	\N	\N	\N	\N	85414	85414	85553
19620	27529	113	applied	\N	\N	\N	\N	85427	85427	85555
19620	27531	114	applied	\N	\N	\N	\N	85438	85438	85678
19620	27535	115	applied	\N	\N	\N	\N	85450	85450	85679
19620	27539	116	applied	\N	\N	\N	\N	85459	85459	85680
19620	27543	117	applied	\N	\N	\N	\N	85467	85467	85567
19620	27548	118	applied	\N	\N	\N	\N	85477	85477	85569
19620	27549	119	applied	\N	\N	\N	\N	85479	85479	85681
19620	27551	120	applied	\N	\N	\N	\N	85485	85485	85578
19620	27558	121	applied	\N	\N	\N	\N	85503	85503	85682
19620	27559	122	applied	\N	\N	\N	\N	85505	85505	85582
19620	27562	123	applied	\N	\N	\N	\N	85515	85515	85584
19620	27564	124	applied	\N	\N	\N	\N	85519	85519	85586
19620	27568	125	applied	\N	\N	\N	\N	85529	85529	85597
19627	27628	0	applied	\N	\N	\N	\N	85722	85722	85723
19627	27629	1	applied	\N	\N	\N	\N	85724	85724	85725
19627	27630	2	applied	\N	\N	\N	\N	85726	85726	85727
19627	27631	3	applied	\N	\N	\N	\N	85728	85728	85729
19627	27632	4	applied	\N	\N	\N	\N	85730	85730	85731
19627	27633	5	applied	\N	\N	\N	\N	85732	85732	85733
19627	27634	6	applied	\N	\N	\N	\N	85734	85734	85735
19627	27635	7	applied	\N	\N	\N	\N	85736	85736	85737
19627	27636	8	applied	\N	\N	\N	\N	85738	85738	85739
19627	27637	9	applied	\N	\N	\N	\N	85740	85740	85741
19627	27638	10	applied	\N	\N	\N	\N	85742	85742	85743
19627	27639	11	applied	\N	\N	\N	\N	85744	85744	85745
19627	27640	12	applied	\N	\N	\N	\N	85746	85746	85747
19629	27648	0	applied	\N	\N	\N	\N	85769	85769	85770
19629	27649	1	applied	\N	\N	\N	\N	85771	85771	85772
19629	27650	2	applied	\N	\N	\N	\N	85773	85773	85774
19632	27654	0	applied	\N	\N	\N	\N	85783	85783	85784
19632	27655	1	applied	\N	\N	\N	\N	85785	85785	85786
19632	27656	2	applied	\N	\N	\N	\N	85787	85787	85788
19632	27657	3	applied	\N	\N	\N	\N	85789	85789	85790
19632	27658	4	applied	\N	\N	\N	\N	85791	85791	85792
19632	27659	5	applied	\N	\N	\N	\N	85793	85793	85794
19632	27660	6	applied	\N	\N	\N	\N	85795	85795	85796
19634	27661	0	applied	\N	\N	\N	\N	85825	85825	85826
19634	27662	1	applied	\N	\N	\N	\N	85827	85827	85828
19634	27663	2	applied	\N	\N	\N	\N	85829	85829	85830
19637	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19637	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19637	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19640	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19640	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19640	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19643	27674	0	applied	\N	\N	\N	\N	85864	85864	85865
19643	27675	1	applied	\N	\N	\N	\N	85866	85866	85867
19621	27615	4	applied	\N	\N	\N	\N	85693	85693	85694
19621	27616	5	applied	\N	\N	\N	\N	85695	85695	85696
19621	27617	6	applied	\N	\N	\N	\N	85697	85697	85698
19623	27618	0	applied	\N	\N	\N	\N	85701	85701	85702
19623	27619	1	applied	\N	\N	\N	\N	85703	85703	85704
19623	27620	2	applied	\N	\N	\N	\N	85705	85705	85706
19635	27664	0	applied	\N	\N	\N	\N	85833	85833	85834
19635	27665	1	applied	\N	\N	\N	\N	85835	85835	85836
19635	27666	2	applied	\N	\N	\N	\N	85837	85837	85838
19635	27667	3	applied	\N	\N	\N	\N	85839	85839	85840
19635	27668	4	applied	\N	\N	\N	\N	85841	85841	85842
19635	27669	5	applied	\N	\N	\N	\N	85843	85843	85844
19635	27670	6	applied	\N	\N	\N	\N	85845	85845	85846
19638	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19638	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19638	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19641	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19641	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19641	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19646	27681	0	applied	\N	\N	\N	\N	85881	85881	85882
19646	27682	1	applied	\N	\N	\N	\N	85883	85883	85884
19646	27683	2	applied	\N	\N	\N	\N	85885	85885	85886
19646	27684	3	applied	\N	\N	\N	\N	85887	85887	85888
19646	27685	4	applied	\N	\N	\N	\N	85889	85889	85890
19646	27686	5	applied	\N	\N	\N	\N	85891	85891	85892
19649	27694	0	applied	\N	\N	\N	\N	85946	85946	85947
19649	27695	1	applied	\N	\N	\N	\N	85948	85948	85949
19649	27696	2	applied	\N	\N	\N	\N	85950	85950	85951
19651	27697	0	applied	\N	\N	\N	\N	85952	85952	85953
19651	27698	1	applied	\N	\N	\N	\N	85954	85954	85955
19651	27699	2	applied	\N	\N	\N	\N	85956	85956	85957
19654	27706	0	applied	\N	\N	\N	\N	85974	85974	85975
19654	27707	1	applied	\N	\N	\N	\N	85976	85976	85977
19654	27708	2	applied	\N	\N	\N	\N	85978	85978	85979
19659	27719	0	applied	\N	\N	\N	\N	86007	86007	86008
19659	27720	1	applied	\N	\N	\N	\N	86009	86009	86010
19659	27721	2	applied	\N	\N	\N	\N	86011	86011	86012
19664	27728	0	applied	\N	\N	\N	\N	86032	86032	86033
19664	27729	1	applied	\N	\N	\N	\N	86034	86034	86035
19664	27731	2	applied	\N	\N	\N	\N	86038	86038	86039
19666	27740	0	applied	\N	\N	\N	\N	86062	86062	86063
19666	27741	1	applied	\N	\N	\N	\N	86064	86064	86065
19666	27742	2	applied	\N	\N	\N	\N	86066	86066	86067
19666	27743	3	applied	\N	\N	\N	\N	86068	86068	86069
19666	27744	4	applied	\N	\N	\N	\N	86070	86070	86071
19666	27745	5	applied	\N	\N	\N	\N	86072	86072	86073
19666	27746	6	applied	\N	\N	\N	\N	86074	86074	86075
19666	27747	7	applied	\N	\N	\N	\N	86076	86076	86077
19666	27748	8	applied	\N	\N	\N	\N	86078	86078	86079
19666	27749	9	applied	\N	\N	\N	\N	86080	86080	86081
19671	27750	0	applied	\N	\N	\N	\N	86086	86086	86087
19671	27751	1	applied	\N	\N	\N	\N	86088	86088	86089
19671	27752	2	applied	\N	\N	\N	\N	86090	86090	86091
19671	27753	3	applied	\N	\N	\N	\N	86092	86092	86093
19671	27754	4	applied	\N	\N	\N	\N	86094	86094	86095
19671	27755	5	applied	\N	\N	\N	\N	86096	86096	86097
19671	27756	6	applied	\N	\N	\N	\N	86098	86098	86099
19671	27757	7	applied	\N	\N	\N	\N	86100	86100	86101
19673	27758	0	applied	\N	\N	\N	\N	86109	86109	86110
19673	27759	1	applied	\N	\N	\N	\N	86111	86111	86112
19673	27760	2	applied	\N	\N	\N	\N	86113	86113	86114
19673	27761	3	applied	\N	\N	\N	\N	86115	86115	86116
19673	27762	4	applied	\N	\N	\N	\N	86117	86117	86118
19673	27763	5	applied	\N	\N	\N	\N	86119	86119	86120
19673	27764	6	applied	\N	\N	\N	\N	86121	86121	86122
19673	27765	7	applied	\N	\N	\N	\N	86123	86123	86124
19673	27766	8	applied	\N	\N	\N	\N	86125	86125	86126
19673	27767	9	applied	\N	\N	\N	\N	86127	86127	86128
19673	27768	10	applied	\N	\N	\N	\N	86129	86129	86130
19673	27769	11	applied	\N	\N	\N	\N	86131	86131	86132
19673	27770	12	applied	\N	\N	\N	\N	86133	86133	86134
19673	27771	13	applied	\N	\N	\N	\N	86135	86135	86136
19673	27772	14	applied	\N	\N	\N	\N	86137	86137	86138
19673	27773	15	applied	\N	\N	\N	\N	86139	86139	86140
19673	27774	16	applied	\N	\N	\N	\N	86141	86141	86142
19673	27775	17	applied	\N	\N	\N	\N	86143	86143	86144
19676	27776	0	applied	\N	\N	\N	\N	86148	86148	86149
19676	27777	1	applied	\N	\N	\N	\N	86150	86150	86151
19676	27778	2	applied	\N	\N	\N	\N	86152	86152	86153
19676	27779	3	applied	\N	\N	\N	\N	86154	86154	86155
19676	27780	4	applied	\N	\N	\N	\N	86156	86156	86157
19676	27781	5	applied	\N	\N	\N	\N	86158	86158	86159
19676	27782	6	applied	\N	\N	\N	\N	86160	86160	86161
19676	27783	7	applied	\N	\N	\N	\N	86162	86162	86163
19676	27784	8	applied	\N	\N	\N	\N	86164	86164	86165
19676	27785	9	applied	\N	\N	\N	\N	86166	86166	86167
19676	27786	10	applied	\N	\N	\N	\N	86168	86168	86169
19676	27787	11	applied	\N	\N	\N	\N	86170	86170	86171
19676	27788	12	applied	\N	\N	\N	\N	86172	86172	86173
19676	27789	13	applied	\N	\N	\N	\N	86174	86174	86175
19676	27790	14	applied	\N	\N	\N	\N	86176	86176	86177
19676	27791	15	applied	\N	\N	\N	\N	86178	86178	86179
19676	27792	16	applied	\N	\N	\N	\N	86180	86180	86181
19676	27793	17	applied	\N	\N	\N	\N	86182	86182	86183
19682	27811	0	applied	\N	\N	\N	\N	86232	86232	86233
19682	27812	1	applied	\N	\N	\N	\N	86234	86234	86235
19682	27813	2	applied	\N	\N	\N	\N	86236	86236	86237
19682	27814	3	applied	\N	\N	\N	\N	86238	86238	86239
19682	27815	4	applied	\N	\N	\N	\N	86240	86240	86241
19682	27816	5	applied	\N	\N	\N	\N	86242	86242	86243
19682	27817	6	applied	\N	\N	\N	\N	86244	86244	86245
19682	27809	7	applied	\N	\N	\N	\N	86223	86223	86226
19682	27819	8	applied	\N	\N	\N	\N	86248	86248	86251
19684	27811	0	applied	\N	\N	\N	\N	86232	86232	86233
19684	27812	1	applied	\N	\N	\N	\N	86234	86234	86235
19684	27813	2	applied	\N	\N	\N	\N	86236	86236	86237
19684	27814	3	applied	\N	\N	\N	\N	86238	86238	86239
19684	27815	4	applied	\N	\N	\N	\N	86240	86240	86241
19684	27816	5	applied	\N	\N	\N	\N	86242	86242	86243
19684	27809	6	applied	\N	\N	\N	\N	86223	86223	86226
19684	27819	7	applied	\N	\N	\N	\N	86248	86248	86251
19689	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19689	27817	1	applied	\N	\N	\N	\N	86244	86244	86245
19689	27821	2	applied	\N	\N	\N	\N	86258	86258	86259
19689	27822	3	applied	\N	\N	\N	\N	86260	86260	86261
19689	27823	4	applied	\N	\N	\N	\N	86262	86262	86263
19689	27824	5	applied	\N	\N	\N	\N	86264	86264	86265
19689	27825	6	applied	\N	\N	\N	\N	86266	86266	86267
19689	27826	7	applied	\N	\N	\N	\N	86268	86268	86269
19689	27827	8	applied	\N	\N	\N	\N	86270	86270	86271
19633	27629	12	applied	\N	\N	\N	\N	85724	85724	85725
19633	27630	13	applied	\N	\N	\N	\N	85726	85726	85727
19633	27631	15	applied	\N	\N	\N	\N	85728	85728	85729
19633	27641	16	applied	\N	\N	\N	\N	85754	85754	85755
19633	27642	17	applied	\N	\N	\N	\N	85756	85756	85757
19633	27648	18	applied	\N	\N	\N	\N	85769	85769	85770
19633	27651	19	applied	\N	\N	\N	\N	85775	85775	85776
19633	27654	20	applied	\N	\N	\N	\N	85783	85783	85784
19633	27655	21	applied	\N	\N	\N	\N	85785	85785	85786
19633	27596	22	applied	\N	\N	\N	\N	85596	85596	85597
19633	27597	23	applied	\N	\N	\N	\N	85598	85598	85599
19633	27598	24	applied	\N	\N	\N	\N	85600	85600	85601
19633	27599	25	applied	\N	\N	\N	\N	85602	85602	85603
19633	27607	26	applied	\N	\N	\N	\N	85624	85624	85800
19633	27608	27	applied	\N	\N	\N	\N	85626	85626	85621
19633	27613	28	applied	\N	\N	\N	\N	85689	85689	85801
19633	27614	29	applied	\N	\N	\N	\N	85691	85691	85802
19633	27619	30	applied	\N	\N	\N	\N	85703	85703	85629
19633	27625	31	applied	\N	\N	\N	\N	85715	85715	85803
19633	27626	32	applied	\N	\N	\N	\N	85717	85717	85804
19633	27609	33	applied	\N	\N	\N	\N	85628	85628	85805
19633	27637	34	applied	\N	\N	\N	\N	85740	85740	85694
19633	27638	35	applied	\N	\N	\N	\N	85742	85742	85698
19633	27639	36	applied	\N	\N	\N	\N	85744	85744	85704
19633	27640	37	applied	\N	\N	\N	\N	85746	85746	85806
19633	27644	38	applied	\N	\N	\N	\N	85760	85760	85714
19633	27647	39	applied	\N	\N	\N	\N	85766	85766	85716
19633	27650	40	applied	\N	\N	\N	\N	85773	85773	85718
19633	27652	41	applied	\N	\N	\N	\N	85777	85777	85807
19633	27656	42	applied	\N	\N	\N	\N	85787	85787	85735
19633	27657	43	applied	\N	\N	\N	\N	85789	85789	85808
19633	27600	44	applied	\N	\N	\N	\N	85604	85604	85809
19633	27601	45	applied	\N	\N	\N	\N	85606	85606	85741
19633	27605	46	applied	\N	\N	\N	\N	85620	85620	85810
19633	27606	47	applied	\N	\N	\N	\N	85622	85622	85811
19633	27610	48	applied	\N	\N	\N	\N	85630	85630	85745
19633	27615	49	applied	\N	\N	\N	\N	85693	85693	85812
19633	27616	50	applied	\N	\N	\N	\N	85695	85695	85759
19633	27620	51	applied	\N	\N	\N	\N	85705	85705	85813
19633	27623	52	applied	\N	\N	\N	\N	85711	85711	85814
19633	27624	53	applied	\N	\N	\N	\N	85713	85713	85815
19633	27633	54	applied	\N	\N	\N	\N	85732	85732	85816
19633	27634	55	applied	\N	\N	\N	\N	85734	85734	85767
19633	27635	56	applied	\N	\N	\N	\N	85736	85736	85772
19633	27636	57	applied	\N	\N	\N	\N	85738	85738	85817
19633	27645	58	applied	\N	\N	\N	\N	85762	85762	85818
19633	27646	59	applied	\N	\N	\N	\N	85764	85764	85778
19633	27649	60	applied	\N	\N	\N	\N	85771	85771	85780
19633	27653	61	applied	\N	\N	\N	\N	85779	85779	85819
19633	27658	62	applied	\N	\N	\N	\N	85791	85791	85820
19633	27659	63	applied	\N	\N	\N	\N	85793	85793	85790
19633	27617	64	applied	\N	\N	\N	\N	85697	85697	85821
19633	27627	65	applied	\N	\N	\N	\N	85719	85719	85792
19633	27632	66	applied	\N	\N	\N	\N	85730	85730	85822
19633	27643	67	applied	\N	\N	\N	\N	85758	85758	85794
19633	27660	68	applied	\N	\N	\N	\N	85795	85795	85796
19636	27671	0	applied	\N	\N	\N	\N	85848	85848	85849
19636	27672	1	applied	\N	\N	\N	\N	85850	85850	85851
19636	27673	2	applied	\N	\N	\N	\N	85852	85852	85853
19645	27681	0	applied	\N	\N	\N	\N	85881	85881	85882
19645	27682	1	applied	\N	\N	\N	\N	85883	85883	85884
19645	27683	2	applied	\N	\N	\N	\N	85885	85885	85886
19645	27684	3	applied	\N	\N	\N	\N	85887	85887	85888
19645	27685	4	applied	\N	\N	\N	\N	85889	85889	85890
19645	27686	5	applied	\N	\N	\N	\N	85891	85891	85892
19650	27697	0	applied	\N	\N	\N	\N	85952	85952	85953
19650	27698	1	applied	\N	\N	\N	\N	85954	85954	85955
19650	27699	2	applied	\N	\N	\N	\N	85956	85956	85957
19655	27709	0	applied	\N	\N	\N	\N	85982	85982	85983
19655	27710	1	applied	\N	\N	\N	\N	85984	85984	85985
19655	27711	2	applied	\N	\N	\N	\N	85986	85986	85987
19658	27719	0	applied	\N	\N	\N	\N	86007	86007	86008
19658	27720	1	applied	\N	\N	\N	\N	86009	86009	86010
19658	27721	2	applied	\N	\N	\N	\N	86011	86011	86012
19660	27722	0	applied	\N	\N	\N	\N	86016	86016	86017
19660	27723	1	applied	\N	\N	\N	\N	86018	86018	86019
19660	27724	2	applied	\N	\N	\N	\N	86020	86020	86021
19665	27730	0	applied	\N	\N	\N	\N	86036	86036	86037
19665	27733	1	applied	\N	\N	\N	\N	86046	86046	86047
19665	27734	2	applied	\N	\N	\N	\N	86048	86048	86049
19665	27735	3	applied	\N	\N	\N	\N	86050	86050	86051
19665	27736	4	applied	\N	\N	\N	\N	86052	86052	86053
19665	27737	5	applied	\N	\N	\N	\N	86054	86054	86055
19665	27732	6	applied	\N	\N	\N	\N	86040	86040	86041
19665	27738	7	applied	\N	\N	\N	\N	86056	86056	86057
19665	27739	8	applied	\N	\N	\N	\N	86058	86058	86059
19670	27750	0	applied	\N	\N	\N	\N	86086	86086	86087
19670	27751	1	applied	\N	\N	\N	\N	86088	86088	86089
19670	27752	2	applied	\N	\N	\N	\N	86090	86090	86091
19670	27753	3	applied	\N	\N	\N	\N	86092	86092	86093
19670	27754	4	applied	\N	\N	\N	\N	86094	86094	86095
19670	27755	5	applied	\N	\N	\N	\N	86096	86096	86097
19670	27756	6	applied	\N	\N	\N	\N	86098	86098	86099
19670	27757	7	applied	\N	\N	\N	\N	86100	86100	86101
19677	27776	0	applied	\N	\N	\N	\N	86148	86148	86149
19677	27777	1	applied	\N	\N	\N	\N	86150	86150	86151
19677	27778	2	applied	\N	\N	\N	\N	86152	86152	86153
19677	27779	3	applied	\N	\N	\N	\N	86154	86154	86155
19677	27780	4	applied	\N	\N	\N	\N	86156	86156	86157
19677	27781	5	applied	\N	\N	\N	\N	86158	86158	86159
19677	27782	6	applied	\N	\N	\N	\N	86160	86160	86161
19677	27783	7	applied	\N	\N	\N	\N	86162	86162	86163
19677	27784	8	applied	\N	\N	\N	\N	86164	86164	86165
19677	27785	9	applied	\N	\N	\N	\N	86166	86166	86167
19677	27786	10	applied	\N	\N	\N	\N	86168	86168	86169
19677	27787	11	applied	\N	\N	\N	\N	86170	86170	86171
19677	27788	12	applied	\N	\N	\N	\N	86172	86172	86173
19677	27789	13	applied	\N	\N	\N	\N	86174	86174	86175
19677	27790	14	applied	\N	\N	\N	\N	86176	86176	86177
19677	27791	15	applied	\N	\N	\N	\N	86178	86178	86179
19677	27792	16	applied	\N	\N	\N	\N	86180	86180	86181
19677	27793	17	applied	\N	\N	\N	\N	86182	86182	86183
19679	27802	0	applied	\N	\N	\N	\N	86209	86209	86210
19679	27803	1	applied	\N	\N	\N	\N	86211	86211	86212
19679	27804	2	applied	\N	\N	\N	\N	86213	86213	86214
19679	27805	3	applied	\N	\N	\N	\N	86215	86215	86216
19679	27806	4	applied	\N	\N	\N	\N	86217	86217	86218
19679	27807	5	applied	\N	\N	\N	\N	86219	86219	86220
19679	27808	6	applied	\N	\N	\N	\N	86221	86221	86222
19679	27809	7	applied	\N	\N	\N	\N	86223	86223	86224
19643	27676	2	applied	\N	\N	\N	\N	85868	85868	85869
19643	27677	3	applied	\N	\N	\N	\N	85870	85870	85871
19643	27678	4	applied	\N	\N	\N	\N	85872	85872	85873
19643	27679	5	applied	\N	\N	\N	\N	85874	85874	85875
19643	27680	6	applied	\N	\N	\N	\N	85876	85876	85877
19648	27687	0	applied	\N	\N	\N	\N	85930	85930	85931
19648	27688	1	applied	\N	\N	\N	\N	85932	85932	85933
19648	27689	2	applied	\N	\N	\N	\N	85934	85934	85935
19648	27690	3	applied	\N	\N	\N	\N	85936	85936	85937
19648	27691	4	applied	\N	\N	\N	\N	85938	85938	85939
19648	27692	5	applied	\N	\N	\N	\N	85940	85940	85941
19648	27693	6	applied	\N	\N	\N	\N	85942	85942	85943
19653	27700	0	applied	\N	\N	\N	\N	85960	85960	85961
19653	27701	1	applied	\N	\N	\N	\N	85962	85962	85963
19653	27702	2	applied	\N	\N	\N	\N	85964	85964	85965
19653	27703	3	applied	\N	\N	\N	\N	85966	85966	85967
19653	27704	4	applied	\N	\N	\N	\N	85968	85968	85969
19653	27705	5	applied	\N	\N	\N	\N	85970	85970	85971
19656	27709	0	applied	\N	\N	\N	\N	85982	85982	85983
19656	27710	1	applied	\N	\N	\N	\N	85984	85984	85985
19656	27711	2	applied	\N	\N	\N	\N	85986	85986	85987
19661	27725	0	applied	\N	\N	\N	\N	86024	86024	86025
19661	27726	1	applied	\N	\N	\N	\N	86026	86026	86027
19661	27727	2	applied	\N	\N	\N	\N	86028	86028	86029
19663	27728	0	applied	\N	\N	\N	\N	86032	86032	86033
19663	27729	1	applied	\N	\N	\N	\N	86034	86034	86035
19663	27731	2	applied	\N	\N	\N	\N	86038	86038	86039
19668	27740	0	applied	\N	\N	\N	\N	86062	86062	86063
19668	27741	1	applied	\N	\N	\N	\N	86064	86064	86065
19668	27742	2	applied	\N	\N	\N	\N	86066	86066	86067
19668	27743	3	applied	\N	\N	\N	\N	86068	86068	86069
19668	27744	4	applied	\N	\N	\N	\N	86070	86070	86071
19668	27745	5	applied	\N	\N	\N	\N	86072	86072	86073
19668	27746	6	applied	\N	\N	\N	\N	86074	86074	86075
19668	27747	7	applied	\N	\N	\N	\N	86076	86076	86077
19668	27748	8	applied	\N	\N	\N	\N	86078	86078	86079
19668	27749	9	applied	\N	\N	\N	\N	86080	86080	86081
19672	27750	0	applied	\N	\N	\N	\N	86086	86086	86087
19672	27751	1	applied	\N	\N	\N	\N	86088	86088	86089
19672	27752	2	applied	\N	\N	\N	\N	86090	86090	86091
19672	27753	3	applied	\N	\N	\N	\N	86092	86092	86093
19672	27756	4	applied	\N	\N	\N	\N	86098	86098	86099
19675	27776	0	applied	\N	\N	\N	\N	86148	86148	86149
19675	27777	1	applied	\N	\N	\N	\N	86150	86150	86151
19675	27778	2	applied	\N	\N	\N	\N	86152	86152	86153
19675	27779	3	applied	\N	\N	\N	\N	86154	86154	86155
19675	27780	4	applied	\N	\N	\N	\N	86156	86156	86157
19675	27781	5	applied	\N	\N	\N	\N	86158	86158	86159
19675	27782	6	applied	\N	\N	\N	\N	86160	86160	86161
19675	27783	7	applied	\N	\N	\N	\N	86162	86162	86163
19675	27784	8	applied	\N	\N	\N	\N	86164	86164	86165
19675	27785	9	applied	\N	\N	\N	\N	86166	86166	86167
19675	27786	10	applied	\N	\N	\N	\N	86168	86168	86169
19675	27787	11	applied	\N	\N	\N	\N	86170	86170	86171
19675	27788	12	applied	\N	\N	\N	\N	86172	86172	86173
19675	27789	13	applied	\N	\N	\N	\N	86174	86174	86175
19675	27790	14	applied	\N	\N	\N	\N	86176	86176	86177
19675	27791	15	applied	\N	\N	\N	\N	86178	86178	86179
19675	27792	16	applied	\N	\N	\N	\N	86180	86180	86181
19675	27793	17	applied	\N	\N	\N	\N	86182	86182	86183
19680	27802	0	applied	\N	\N	\N	\N	86209	86209	86210
19680	27803	1	applied	\N	\N	\N	\N	86211	86211	86212
19680	27804	2	applied	\N	\N	\N	\N	86213	86213	86214
19680	27805	3	applied	\N	\N	\N	\N	86215	86215	86216
19680	27806	4	applied	\N	\N	\N	\N	86217	86217	86218
19680	27807	5	applied	\N	\N	\N	\N	86219	86219	86220
19680	27808	6	applied	\N	\N	\N	\N	86221	86221	86222
19680	27810	7	applied	\N	\N	\N	\N	86225	86225	86230
19687	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19687	27817	1	applied	\N	\N	\N	\N	86244	86244	86245
19687	27821	2	applied	\N	\N	\N	\N	86258	86258	86259
19687	27822	3	applied	\N	\N	\N	\N	86260	86260	86261
19687	27823	4	applied	\N	\N	\N	\N	86262	86262	86263
19687	27824	5	applied	\N	\N	\N	\N	86264	86264	86265
19687	27825	6	applied	\N	\N	\N	\N	86266	86266	86267
19687	27827	7	applied	\N	\N	\N	\N	86270	86270	86271
19687	27818	8	applied	\N	\N	\N	\N	86246	86246	86272
19688	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19688	27817	1	applied	\N	\N	\N	\N	86244	86244	86245
19688	27821	2	applied	\N	\N	\N	\N	86258	86258	86259
19688	27822	3	applied	\N	\N	\N	\N	86260	86260	86261
19688	27823	4	applied	\N	\N	\N	\N	86262	86262	86263
19688	27824	5	applied	\N	\N	\N	\N	86264	86264	86265
19688	27825	6	applied	\N	\N	\N	\N	86266	86266	86267
19688	27827	7	applied	\N	\N	\N	\N	86270	86270	86271
19688	27818	8	applied	\N	\N	\N	\N	86246	86246	86272
19695	27836	0	applied	\N	\N	\N	\N	86391	86391	86392
19695	27837	1	applied	\N	\N	\N	\N	86393	86393	86394
19695	27838	2	applied	\N	\N	\N	\N	86395	86395	86396
19695	27839	3	applied	\N	\N	\N	\N	86397	86397	86398
19695	27840	4	applied	\N	\N	\N	\N	86399	86399	86400
19695	27841	5	applied	\N	\N	\N	\N	86401	86401	86402
19695	27842	6	applied	\N	\N	\N	\N	86403	86403	86404
19695	27843	7	applied	\N	\N	\N	\N	86405	86405	86406
19695	27844	8	applied	\N	\N	\N	\N	86407	86407	86408
19698	27862	0	applied	\N	\N	\N	\N	86449	86449	86450
19698	27863	1	applied	\N	\N	\N	\N	86451	86451	86452
19698	27864	2	applied	\N	\N	\N	\N	86453	86453	86454
19698	27865	3	applied	\N	\N	\N	\N	86455	86455	86456
19698	27866	4	applied	\N	\N	\N	\N	86457	86457	86458
19698	27867	5	applied	\N	\N	\N	\N	86459	86459	86460
19698	27868	6	applied	\N	\N	\N	\N	86461	86461	86462
19698	27869	7	applied	\N	\N	\N	\N	86463	86463	86464
19698	27870	8	applied	\N	\N	\N	\N	86465	86465	86466
19698	27871	9	applied	\N	\N	\N	\N	86467	86467	86468
19698	27872	10	applied	\N	\N	\N	\N	86469	86469	86470
19698	27873	11	applied	\N	\N	\N	\N	86471	86471	86472
19698	27874	12	applied	\N	\N	\N	\N	86473	86473	86474
19698	27875	13	applied	\N	\N	\N	\N	86475	86475	86476
19698	27876	14	applied	\N	\N	\N	\N	86477	86477	86478
19698	27877	15	applied	\N	\N	\N	\N	86479	86479	86480
19698	27878	16	applied	\N	\N	\N	\N	86481	86481	86482
19698	27879	17	applied	\N	\N	\N	\N	86483	86483	86484
19701	27883	0	applied	\N	\N	\N	\N	86495	86495	86496
19701	27884	1	applied	\N	\N	\N	\N	86497	86497	86498
19701	27885	2	applied	\N	\N	\N	\N	86499	86499	86500
19710	27905	0	applied	\N	\N	\N	\N	86547	86547	86548
19710	27906	1	applied	\N	\N	\N	\N	86549	86549	86550
19710	27907	2	applied	\N	\N	\N	\N	86551	86551	86552
19717	27920	0	applied	\N	\N	\N	\N	86629	86629	86630
19647	27631	18	applied	\N	\N	\N	\N	85728	85728	85729
19647	27641	19	applied	\N	\N	\N	\N	85754	85754	85755
19647	27642	20	applied	\N	\N	\N	\N	85756	85756	85757
19647	27648	21	applied	\N	\N	\N	\N	85769	85769	85770
19647	27651	22	applied	\N	\N	\N	\N	85775	85775	85776
19647	27654	23	applied	\N	\N	\N	\N	85783	85783	85784
19647	27655	24	applied	\N	\N	\N	\N	85785	85785	85786
19647	27661	25	applied	\N	\N	\N	\N	85825	85825	85826
19647	27664	26	applied	\N	\N	\N	\N	85833	85833	85834
19647	27665	27	applied	\N	\N	\N	\N	85835	85835	85836
19647	27671	28	applied	\N	\N	\N	\N	85848	85848	85849
19647	27674	29	applied	\N	\N	\N	\N	85864	85864	85865
19647	27675	30	applied	\N	\N	\N	\N	85866	85866	85867
19647	27681	31	applied	\N	\N	\N	\N	85881	85881	85882
19647	27682	33	applied	\N	\N	\N	\N	85883	85883	85884
19647	27581	34	applied	\N	\N	\N	\N	85562	85562	85563
19647	27582	35	applied	\N	\N	\N	\N	85564	85564	85565
19647	27583	36	applied	\N	\N	\N	\N	85566	85566	85567
19647	27588	37	applied	\N	\N	\N	\N	85577	85577	85571
19647	27590	38	applied	\N	\N	\N	\N	85581	85581	85578
19647	27597	39	applied	\N	\N	\N	\N	85598	85598	85897
19647	27584	40	applied	\N	\N	\N	\N	85568	85568	85898
19647	27598	41	applied	\N	\N	\N	\N	85600	85600	85586
19647	27599	42	applied	\N	\N	\N	\N	85602	85602	85899
19647	27607	43	applied	\N	\N	\N	\N	85624	85624	85900
19647	27608	44	applied	\N	\N	\N	\N	85626	85626	85901
19647	27613	45	applied	\N	\N	\N	\N	85689	85689	85902
19647	27614	46	applied	\N	\N	\N	\N	85691	85691	85607
19647	27619	47	applied	\N	\N	\N	\N	85703	85703	85903
19647	27625	48	applied	\N	\N	\N	\N	85715	85715	85904
19647	27626	49	applied	\N	\N	\N	\N	85717	85717	85905
19647	27591	50	applied	\N	\N	\N	\N	85583	85583	85629
19647	27637	51	applied	\N	\N	\N	\N	85740	85740	85803
19647	27638	52	applied	\N	\N	\N	\N	85742	85742	85804
19647	27639	53	applied	\N	\N	\N	\N	85744	85744	85906
19647	27640	54	applied	\N	\N	\N	\N	85746	85746	85696
19647	27644	55	applied	\N	\N	\N	\N	85760	85760	85907
19647	27647	56	applied	\N	\N	\N	\N	85766	85766	85706
19647	27592	57	applied	\N	\N	\N	\N	85585	85585	85712
19647	27596	58	applied	\N	\N	\N	\N	85596	85596	85714
19647	27650	59	applied	\N	\N	\N	\N	85773	85773	85716
19647	27652	60	applied	\N	\N	\N	\N	85777	85777	85718
19647	27656	61	applied	\N	\N	\N	\N	85787	85787	85807
19647	27657	62	applied	\N	\N	\N	\N	85789	85789	85735
19647	27663	63	applied	\N	\N	\N	\N	85829	85829	85808
19647	27668	64	applied	\N	\N	\N	\N	85841	85841	85908
19647	27585	65	applied	\N	\N	\N	\N	85570	85570	85741
19647	27589	66	applied	\N	\N	\N	\N	85579	85579	85909
19647	27609	67	applied	\N	\N	\N	\N	85628	85628	85810
19647	27670	68	applied	\N	\N	\N	\N	85845	85845	85910
19647	27672	69	applied	\N	\N	\N	\N	85850	85850	85812
19647	27677	70	applied	\N	\N	\N	\N	85870	85870	85911
19647	27678	71	applied	\N	\N	\N	\N	85872	85872	85814
19647	27683	72	applied	\N	\N	\N	\N	85885	85885	85765
19647	27684	73	applied	\N	\N	\N	\N	85887	85887	85767
19647	27600	74	applied	\N	\N	\N	\N	85604	85604	85772
19647	27601	75	applied	\N	\N	\N	\N	85606	85606	85817
19647	27605	76	applied	\N	\N	\N	\N	85620	85620	85818
19647	27606	77	applied	\N	\N	\N	\N	85622	85622	85778
19647	27610	78	applied	\N	\N	\N	\N	85630	85630	85780
19647	27615	79	applied	\N	\N	\N	\N	85693	85693	85819
19647	27616	80	applied	\N	\N	\N	\N	85695	85695	85820
19647	27620	81	applied	\N	\N	\N	\N	85705	85705	85790
19647	27623	82	applied	\N	\N	\N	\N	85711	85711	85792
19647	27624	83	applied	\N	\N	\N	\N	85713	85713	85794
19647	27633	84	applied	\N	\N	\N	\N	85732	85732	85912
19647	27634	85	applied	\N	\N	\N	\N	85734	85734	85913
19647	27635	86	applied	\N	\N	\N	\N	85736	85736	85830
19647	27636	87	applied	\N	\N	\N	\N	85738	85738	85914
19647	27645	88	applied	\N	\N	\N	\N	85762	85762	85915
19647	27646	89	applied	\N	\N	\N	\N	85764	85764	85842
19647	27649	90	applied	\N	\N	\N	\N	85771	85771	85844
19647	27653	91	applied	\N	\N	\N	\N	85779	85779	85916
19647	27658	92	applied	\N	\N	\N	\N	85791	85791	85917
19647	27659	93	applied	\N	\N	\N	\N	85793	85793	85851
19647	27662	94	applied	\N	\N	\N	\N	85827	85827	85853
19647	27667	95	applied	\N	\N	\N	\N	85839	85839	85918
19647	27669	96	applied	\N	\N	\N	\N	85843	85843	85871
19647	27673	97	applied	\N	\N	\N	\N	85852	85852	85919
19647	27679	98	applied	\N	\N	\N	\N	85874	85874	85920
19647	27680	99	applied	\N	\N	\N	\N	85876	85876	85921
19647	27685	100	applied	\N	\N	\N	\N	85889	85889	85922
19647	27686	101	applied	\N	\N	\N	\N	85891	85891	85886
19647	27617	102	applied	\N	\N	\N	\N	85697	85697	85923
19647	27627	103	applied	\N	\N	\N	\N	85719	85719	85924
19647	27632	104	applied	\N	\N	\N	\N	85730	85730	85888
19647	27643	105	applied	\N	\N	\N	\N	85758	85758	85925
19647	27660	106	applied	\N	\N	\N	\N	85795	85795	85890
19647	27666	107	applied	\N	\N	\N	\N	85837	85837	85926
19647	27676	108	applied	\N	\N	\N	\N	85868	85868	85892
19652	27700	0	applied	\N	\N	\N	\N	85960	85960	85961
19652	27701	1	applied	\N	\N	\N	\N	85962	85962	85963
19652	27702	2	applied	\N	\N	\N	\N	85964	85964	85965
19652	27703	3	applied	\N	\N	\N	\N	85966	85966	85967
19652	27704	4	applied	\N	\N	\N	\N	85968	85968	85969
19652	27705	5	applied	\N	\N	\N	\N	85970	85970	85971
19657	27712	0	applied	\N	\N	\N	\N	85992	85992	85993
19657	27713	1	applied	\N	\N	\N	\N	85994	85994	85995
19657	27714	2	applied	\N	\N	\N	\N	85996	85996	85997
19657	27715	3	applied	\N	\N	\N	\N	85998	85998	33908
19657	27716	4	applied	\N	\N	\N	\N	85999	85999	86000
19657	27717	5	applied	\N	\N	\N	\N	86001	86001	86002
19657	27718	6	applied	\N	\N	\N	\N	86003	86003	86004
19662	27728	0	applied	\N	\N	\N	\N	86032	86032	86033
19662	27729	1	applied	\N	\N	\N	\N	86034	86034	86035
19662	27730	2	applied	\N	\N	\N	\N	86036	86036	86037
19662	27731	3	applied	\N	\N	\N	\N	86038	86038	86039
19662	27732	4	applied	\N	\N	\N	\N	86040	86040	86041
19667	27740	0	applied	\N	\N	\N	\N	86062	86062	86063
19667	27741	1	applied	\N	\N	\N	\N	86064	86064	86065
19667	27742	2	applied	\N	\N	\N	\N	86066	86066	86067
19667	27743	3	applied	\N	\N	\N	\N	86068	86068	86069
19667	27744	4	applied	\N	\N	\N	\N	86070	86070	86071
19667	27745	5	applied	\N	\N	\N	\N	86072	86072	86073
19667	27746	6	applied	\N	\N	\N	\N	86074	86074	86075
19667	27747	7	applied	\N	\N	\N	\N	86076	86076	86077
19667	27748	8	applied	\N	\N	\N	\N	86078	86078	86079
19667	27749	9	applied	\N	\N	\N	\N	86080	86080	86081
19669	27750	0	applied	\N	\N	\N	\N	86086	86086	86087
19669	27751	1	applied	\N	\N	\N	\N	86088	86088	86089
19669	27752	2	applied	\N	\N	\N	\N	86090	86090	86091
19669	27753	3	applied	\N	\N	\N	\N	86092	86092	86093
19669	27754	4	applied	\N	\N	\N	\N	86094	86094	86095
19669	27755	5	applied	\N	\N	\N	\N	86096	86096	86097
19669	27756	6	applied	\N	\N	\N	\N	86098	86098	86099
19669	27757	7	applied	\N	\N	\N	\N	86100	86100	86101
19674	27758	0	applied	\N	\N	\N	\N	86109	86109	86110
19674	27759	1	applied	\N	\N	\N	\N	86111	86111	86112
19674	27760	2	applied	\N	\N	\N	\N	86113	86113	86114
19674	27761	3	applied	\N	\N	\N	\N	86115	86115	86116
19674	27762	4	applied	\N	\N	\N	\N	86117	86117	86118
19674	27763	5	applied	\N	\N	\N	\N	86119	86119	86120
19674	27764	6	applied	\N	\N	\N	\N	86121	86121	86122
19674	27765	7	applied	\N	\N	\N	\N	86123	86123	86124
19674	27766	8	applied	\N	\N	\N	\N	86125	86125	86126
19674	27767	9	applied	\N	\N	\N	\N	86127	86127	86128
19674	27768	10	applied	\N	\N	\N	\N	86129	86129	86130
19674	27769	11	applied	\N	\N	\N	\N	86131	86131	86132
19674	27770	12	applied	\N	\N	\N	\N	86133	86133	86134
19674	27771	13	applied	\N	\N	\N	\N	86135	86135	86136
19674	27772	14	applied	\N	\N	\N	\N	86137	86137	86138
19674	27773	15	applied	\N	\N	\N	\N	86139	86139	86140
19674	27774	16	applied	\N	\N	\N	\N	86141	86141	86142
19674	27775	17	applied	\N	\N	\N	\N	86143	86143	86144
19678	27794	0	applied	\N	\N	\N	\N	86190	86190	86191
19678	27795	1	applied	\N	\N	\N	\N	86192	86192	86193
19678	27796	2	applied	\N	\N	\N	\N	86194	86194	86195
19678	27797	3	applied	\N	\N	\N	\N	86196	86196	86197
19678	27798	4	applied	\N	\N	\N	\N	86198	86198	86199
19678	27799	5	applied	\N	\N	\N	\N	86200	86200	86201
19678	27800	7	applied	\N	\N	\N	\N	86203	86203	86204
19678	27801	8	applied	\N	\N	\N	\N	86205	86205	86206
19683	27811	0	applied	\N	\N	\N	\N	86232	86232	86233
19683	27812	1	applied	\N	\N	\N	\N	86234	86234	86235
19683	27813	2	applied	\N	\N	\N	\N	86236	86236	86237
19683	27814	3	applied	\N	\N	\N	\N	86238	86238	86239
19683	27815	4	applied	\N	\N	\N	\N	86240	86240	86241
19683	27816	5	applied	\N	\N	\N	\N	86242	86242	86243
19683	27817	6	applied	\N	\N	\N	\N	86244	86244	86245
19683	27818	7	applied	\N	\N	\N	\N	86246	86246	86247
19683	27819	8	applied	\N	\N	\N	\N	86248	86248	86249
19685	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19685	27817	1	applied	\N	\N	\N	\N	86244	86244	86245
19685	27821	2	applied	\N	\N	\N	\N	86258	86258	86259
19685	27822	3	applied	\N	\N	\N	\N	86260	86260	86261
19685	27823	4	applied	\N	\N	\N	\N	86262	86262	86263
19685	27824	5	applied	\N	\N	\N	\N	86264	86264	86265
19685	27825	6	applied	\N	\N	\N	\N	86266	86266	86267
19685	27826	7	applied	\N	\N	\N	\N	86268	86268	86269
19685	27827	8	applied	\N	\N	\N	\N	86270	86270	86271
19685	27818	9	applied	\N	\N	\N	\N	86246	86246	86272
19692	27828	0	applied	\N	\N	\N	\N	86280	86280	86281
19692	27829	1	applied	\N	\N	\N	\N	86282	86282	86283
19692	27830	2	applied	\N	\N	\N	\N	86284	86284	86285
19692	27831	3	applied	\N	\N	\N	\N	86286	86286	86287
19692	27832	4	applied	\N	\N	\N	\N	86288	86288	86289
19692	27833	5	applied	\N	\N	\N	\N	86290	86290	86291
19692	27834	6	applied	\N	\N	\N	\N	86292	86292	86293
19692	27835	7	applied	\N	\N	\N	\N	86294	86294	86295
19699	27880	0	applied	\N	\N	\N	\N	86487	86487	86488
19699	27881	1	applied	\N	\N	\N	\N	86489	86489	86490
19699	27882	2	applied	\N	\N	\N	\N	86491	86491	86492
19702	27728	0	applied	\N	\N	\N	\N	86032	86032	86033
19702	27729	1	applied	\N	\N	\N	\N	86034	86034	86035
19702	27730	2	applied	\N	\N	\N	\N	86036	86036	86037
19702	27733	3	applied	\N	\N	\N	\N	86046	86046	86047
19702	27641	4	applied	\N	\N	\N	\N	85754	85754	85755
19702	27642	5	applied	\N	\N	\N	\N	85756	85756	85757
19702	27648	6	applied	\N	\N	\N	\N	85769	85769	85770
19702	27651	7	applied	\N	\N	\N	\N	85775	85775	85776
19702	27654	8	applied	\N	\N	\N	\N	85783	85783	85784
19702	27655	9	applied	\N	\N	\N	\N	85785	85785	85786
19702	27661	10	applied	\N	\N	\N	\N	85825	85825	85826
19702	27664	11	applied	\N	\N	\N	\N	85833	85833	85834
19702	27665	12	applied	\N	\N	\N	\N	85835	85835	85836
19702	27734	13	applied	\N	\N	\N	\N	86048	86048	86049
19702	27671	14	applied	\N	\N	\N	\N	85848	85848	85849
19702	27674	15	applied	\N	\N	\N	\N	85864	85864	85865
19702	27675	16	applied	\N	\N	\N	\N	85866	85866	85867
19702	27681	17	applied	\N	\N	\N	\N	85881	85881	85882
19702	27682	18	applied	\N	\N	\N	\N	85883	85883	85884
19702	27687	19	applied	\N	\N	\N	\N	85930	85930	85931
19702	27735	20	applied	\N	\N	\N	\N	86050	86050	86051
19702	27736	21	applied	\N	\N	\N	\N	86052	86052	86053
19702	27737	22	applied	\N	\N	\N	\N	86054	86054	86055
19702	27740	23	applied	\N	\N	\N	\N	86062	86062	86063
19702	27743	24	applied	\N	\N	\N	\N	86068	86068	86069
19702	27744	25	applied	\N	\N	\N	\N	86070	86070	86071
19702	27745	26	applied	\N	\N	\N	\N	86072	86072	86073
19702	27746	27	applied	\N	\N	\N	\N	86074	86074	86075
19702	27747	28	applied	\N	\N	\N	\N	86076	86076	86077
19702	27750	29	applied	\N	\N	\N	\N	86086	86086	86087
19702	27751	30	applied	\N	\N	\N	\N	86088	86088	86089
19702	27752	31	applied	\N	\N	\N	\N	86090	86090	86091
19702	27753	32	applied	\N	\N	\N	\N	86092	86092	86093
19702	27754	33	applied	\N	\N	\N	\N	86094	86094	86095
19702	27755	34	applied	\N	\N	\N	\N	86096	86096	86097
19702	27760	35	applied	\N	\N	\N	\N	86113	86113	86114
19702	27761	36	applied	\N	\N	\N	\N	86115	86115	86116
19702	27762	37	applied	\N	\N	\N	\N	86117	86117	86118
19702	27763	38	applied	\N	\N	\N	\N	86119	86119	86120
19702	27764	39	applied	\N	\N	\N	\N	86121	86121	86122
19702	27765	40	applied	\N	\N	\N	\N	86123	86123	86124
19702	27766	41	applied	\N	\N	\N	\N	86125	86125	86126
19702	27767	42	applied	\N	\N	\N	\N	86127	86127	86128
19702	27768	43	applied	\N	\N	\N	\N	86129	86129	86130
19702	27769	44	applied	\N	\N	\N	\N	86131	86131	86132
19702	27770	45	applied	\N	\N	\N	\N	86133	86133	86134
19702	27771	46	applied	\N	\N	\N	\N	86135	86135	86136
19702	27776	47	applied	\N	\N	\N	\N	86148	86148	86149
19702	27777	48	applied	\N	\N	\N	\N	86150	86150	86151
19702	27778	49	applied	\N	\N	\N	\N	86152	86152	86153
19702	27779	50	applied	\N	\N	\N	\N	86154	86154	86155
19702	27780	51	applied	\N	\N	\N	\N	86156	86156	86157
19702	27781	52	applied	\N	\N	\N	\N	86158	86158	86159
19702	27784	53	applied	\N	\N	\N	\N	86164	86164	86165
19702	27785	54	applied	\N	\N	\N	\N	86166	86166	86167
19702	27786	55	applied	\N	\N	\N	\N	86168	86168	86169
19702	27787	56	applied	\N	\N	\N	\N	86170	86170	86171
19702	27788	57	applied	\N	\N	\N	\N	86172	86172	86173
19679	27810	8	applied	\N	\N	\N	\N	86225	86225	86226
19681	27811	0	applied	\N	\N	\N	\N	86232	86232	86233
19681	27812	1	applied	\N	\N	\N	\N	86234	86234	86235
19681	27813	2	applied	\N	\N	\N	\N	86236	86236	86237
19681	27814	3	applied	\N	\N	\N	\N	86238	86238	86239
19681	27815	4	applied	\N	\N	\N	\N	86240	86240	86241
19681	27816	5	applied	\N	\N	\N	\N	86242	86242	86243
19681	27817	6	applied	\N	\N	\N	\N	86244	86244	86245
19681	27809	7	applied	\N	\N	\N	\N	86223	86223	86226
19681	27818	8	applied	\N	\N	\N	\N	86246	86246	86247
19681	27819	9	applied	\N	\N	\N	\N	86248	86248	86249
19686	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19686	27817	1	applied	\N	\N	\N	\N	86244	86244	86245
19686	27821	2	applied	\N	\N	\N	\N	86258	86258	86259
19686	27822	3	applied	\N	\N	\N	\N	86260	86260	86261
19686	27823	4	applied	\N	\N	\N	\N	86262	86262	86263
19686	27824	5	applied	\N	\N	\N	\N	86264	86264	86265
19686	27825	6	applied	\N	\N	\N	\N	86266	86266	86267
19686	27826	7	applied	\N	\N	\N	\N	86268	86268	86269
19686	27827	8	applied	\N	\N	\N	\N	86270	86270	86271
19686	27818	9	applied	\N	\N	\N	\N	86246	86246	86272
19690	27820	0	applied	\N	\N	\N	\N	86256	86256	86257
19690	27821	1	applied	\N	\N	\N	\N	86258	86258	86259
19690	27822	2	applied	\N	\N	\N	\N	86260	86260	86261
19690	27823	3	applied	\N	\N	\N	\N	86262	86262	86263
19690	27824	4	applied	\N	\N	\N	\N	86264	86264	86265
19690	27825	5	applied	\N	\N	\N	\N	86266	86266	86267
19690	27827	6	applied	\N	\N	\N	\N	86270	86270	86272
19693	27828	0	applied	\N	\N	\N	\N	86280	86280	86281
19693	27829	1	applied	\N	\N	\N	\N	86282	86282	86283
19693	27830	2	applied	\N	\N	\N	\N	86284	86284	86285
19693	27831	3	applied	\N	\N	\N	\N	86286	86286	86287
19693	27832	4	applied	\N	\N	\N	\N	86288	86288	86289
19693	27833	5	applied	\N	\N	\N	\N	86290	86290	86291
19693	27834	6	applied	\N	\N	\N	\N	86292	86292	86293
19693	27835	7	applied	\N	\N	\N	\N	86294	86294	86295
19694	27687	0	applied	\N	\N	\N	\N	85930	85930	85931
19694	27728	1	applied	\N	\N	\N	\N	86301	86301	86033
19694	27729	2	applied	\N	\N	\N	\N	86302	86302	86035
19694	27730	3	applied	\N	\N	\N	\N	86303	86303	86037
19694	27733	4	applied	\N	\N	\N	\N	86304	86304	86047
19694	27734	5	applied	\N	\N	\N	\N	86305	86305	86049
19694	27735	6	applied	\N	\N	\N	\N	86306	86306	86051
19694	27736	7	applied	\N	\N	\N	\N	86307	86307	86053
19694	27737	8	applied	\N	\N	\N	\N	86308	86308	86055
19694	27740	9	applied	\N	\N	\N	\N	86309	86309	86063
19694	27743	10	applied	\N	\N	\N	\N	86310	86310	86069
19694	27744	11	applied	\N	\N	\N	\N	86311	86311	86071
19694	27745	12	applied	\N	\N	\N	\N	86312	86312	86073
19694	27746	13	applied	\N	\N	\N	\N	86313	86313	86075
19694	27747	14	applied	\N	\N	\N	\N	86314	86314	86077
19694	27750	15	applied	\N	\N	\N	\N	86315	86315	86087
19694	27751	16	applied	\N	\N	\N	\N	86316	86316	86089
19694	27752	17	applied	\N	\N	\N	\N	86317	86317	86091
19694	27753	18	applied	\N	\N	\N	\N	86318	86318	86093
19694	27754	19	applied	\N	\N	\N	\N	86319	86319	86095
19694	27755	20	applied	\N	\N	\N	\N	86320	86320	86097
19694	27760	21	applied	\N	\N	\N	\N	86321	86321	86114
19694	27761	22	applied	\N	\N	\N	\N	86322	86322	86116
19694	27762	23	applied	\N	\N	\N	\N	86323	86323	86118
19694	27763	24	applied	\N	\N	\N	\N	86324	86324	86120
19694	27764	25	applied	\N	\N	\N	\N	86325	86325	86122
19694	27765	26	applied	\N	\N	\N	\N	86326	86326	86124
19694	27766	27	applied	\N	\N	\N	\N	86327	86327	86126
19694	27767	28	applied	\N	\N	\N	\N	86328	86328	86128
19694	27768	29	applied	\N	\N	\N	\N	86329	86329	86130
19694	27769	30	applied	\N	\N	\N	\N	86330	86330	86132
19694	27770	31	applied	\N	\N	\N	\N	86331	86331	86134
19694	27771	32	applied	\N	\N	\N	\N	86332	86332	86136
19694	27776	33	applied	\N	\N	\N	\N	86333	86333	86149
19694	27777	34	applied	\N	\N	\N	\N	86334	86334	86151
19694	27778	35	applied	\N	\N	\N	\N	86335	86335	86153
19694	27779	36	applied	\N	\N	\N	\N	86336	86336	86155
19694	27780	37	applied	\N	\N	\N	\N	86337	86337	86157
19694	27781	38	applied	\N	\N	\N	\N	86338	86338	86159
19694	27784	39	applied	\N	\N	\N	\N	86339	86339	86165
19694	27785	40	applied	\N	\N	\N	\N	86340	86340	86167
19694	27786	41	applied	\N	\N	\N	\N	86341	86341	86169
19694	27787	42	applied	\N	\N	\N	\N	86342	86342	86171
19694	27788	43	applied	\N	\N	\N	\N	86343	86343	86173
19694	27789	44	applied	\N	\N	\N	\N	86344	86344	86175
19694	27795	45	applied	\N	\N	\N	\N	86345	86345	86193
19694	27796	46	applied	\N	\N	\N	\N	86346	86346	86195
19694	27797	47	applied	\N	\N	\N	\N	86347	86347	86197
19694	27798	48	applied	\N	\N	\N	\N	86348	86348	86199
19694	27799	50	applied	\N	\N	\N	\N	86350	86350	86201
19694	27802	51	applied	\N	\N	\N	\N	86351	86351	86210
19694	27803	52	applied	\N	\N	\N	\N	86352	86352	86212
19694	27804	53	applied	\N	\N	\N	\N	86353	86353	86214
19694	27805	54	applied	\N	\N	\N	\N	86354	86354	86216
19694	27806	55	applied	\N	\N	\N	\N	86355	86355	86218
19694	27807	56	applied	\N	\N	\N	\N	86356	86356	86220
19694	27811	57	applied	\N	\N	\N	\N	86357	86357	86233
19694	27813	58	applied	\N	\N	\N	\N	86358	86358	86237
19694	27814	59	applied	\N	\N	\N	\N	86359	86359	86239
19694	27815	60	applied	\N	\N	\N	\N	86360	86360	86241
19694	27816	61	applied	\N	\N	\N	\N	86361	86361	86243
19694	27817	62	applied	\N	\N	\N	\N	86362	86362	86245
19694	27821	63	applied	\N	\N	\N	\N	86363	86363	86259
19694	27822	64	applied	\N	\N	\N	\N	86364	86364	86261
19694	27823	65	applied	\N	\N	\N	\N	86365	86365	86263
19694	27824	66	applied	\N	\N	\N	\N	86366	86366	86265
19694	27825	67	applied	\N	\N	\N	\N	86367	86367	86267
19694	27826	68	applied	\N	\N	\N	\N	86368	86368	86269
19694	27828	69	applied	\N	\N	\N	\N	86369	86369	86281
19694	27829	70	applied	\N	\N	\N	\N	86370	86370	86283
19694	27688	71	applied	\N	\N	\N	\N	85932	85932	85933
19694	27694	72	applied	\N	\N	\N	\N	85946	85946	85947
19694	27697	73	applied	\N	\N	\N	\N	85952	85952	85953
19694	27700	74	applied	\N	\N	\N	\N	85960	85960	85961
19694	27701	75	applied	\N	\N	\N	\N	85962	85962	85963
19694	27706	76	applied	\N	\N	\N	\N	85974	85974	85975
19694	27709	77	applied	\N	\N	\N	\N	85982	85982	85983
19694	27712	78	applied	\N	\N	\N	\N	85992	85992	85993
19694	27713	79	applied	\N	\N	\N	\N	85994	85994	85995
19694	27719	80	applied	\N	\N	\N	\N	86007	86007	86008
19694	27722	81	applied	\N	\N	\N	\N	86016	86016	86017
19694	27725	82	applied	\N	\N	\N	\N	86024	86024	86025
19694	27731	83	applied	\N	\N	\N	\N	86038	86038	86039
19694	27741	84	applied	\N	\N	\N	\N	86064	86064	86065
19689	27818	9	applied	\N	\N	\N	\N	86246	86246	86272
19691	27828	0	applied	\N	\N	\N	\N	86280	86280	86281
19691	27829	1	applied	\N	\N	\N	\N	86282	86282	86283
19691	27830	2	applied	\N	\N	\N	\N	86284	86284	86285
19691	27831	3	applied	\N	\N	\N	\N	86286	86286	86287
19691	27832	4	applied	\N	\N	\N	\N	86288	86288	86289
19691	27833	5	applied	\N	\N	\N	\N	86290	86290	86291
19691	27834	6	applied	\N	\N	\N	\N	86292	86292	86293
19691	27835	7	applied	\N	\N	\N	\N	86294	86294	86295
19696	27836	0	applied	\N	\N	\N	\N	86391	86391	86392
19696	27837	1	applied	\N	\N	\N	\N	86393	86393	86394
19696	27838	2	applied	\N	\N	\N	\N	86395	86395	86396
19696	27839	3	applied	\N	\N	\N	\N	86397	86397	86398
19696	27840	4	applied	\N	\N	\N	\N	86399	86399	86400
19696	27841	5	applied	\N	\N	\N	\N	86401	86401	86402
19696	27842	6	applied	\N	\N	\N	\N	86403	86403	86404
19696	27843	7	applied	\N	\N	\N	\N	86405	86405	86406
19696	27844	8	applied	\N	\N	\N	\N	86407	86407	86408
19706	27900	0	applied	\N	\N	\N	\N	86537	86537	86538
19706	27901	1	applied	\N	\N	\N	\N	86502	86502	86505
19706	27902	2	applied	\N	\N	\N	\N	86504	86504	86503
19706	27903	3	applied	\N	\N	\N	\N	86539	86539	86540
19706	27904	4	applied	\N	\N	\N	\N	86541	86541	86542
19713	27908	0	applied	\N	\N	\N	\N	86560	86560	86561
19713	27909	1	applied	\N	\N	\N	\N	86562	86562	86563
19718	27923	0	applied	\N	\N	\N	\N	86637	86637	86638
19718	27924	1	applied	\N	\N	\N	\N	86639	86639	86640
19718	27925	2	applied	\N	\N	\N	\N	86641	86641	86642
19723	27728	0	applied	\N	\N	\N	\N	86568	86568	86033
19723	27729	1	applied	\N	\N	\N	\N	86569	86569	86035
19723	27730	2	applied	\N	\N	\N	\N	86570	86570	86037
19723	27733	3	applied	\N	\N	\N	\N	86571	86571	86047
19723	27734	4	applied	\N	\N	\N	\N	86572	86572	86049
19723	27735	5	applied	\N	\N	\N	\N	86573	86573	86051
19723	27736	6	applied	\N	\N	\N	\N	86574	86574	86053
19723	27737	7	applied	\N	\N	\N	\N	86575	86575	86055
19723	27740	8	applied	\N	\N	\N	\N	86576	86576	86063
19723	27743	9	applied	\N	\N	\N	\N	86577	86577	86069
19723	27744	10	applied	\N	\N	\N	\N	86578	86578	86071
19723	27745	11	applied	\N	\N	\N	\N	86579	86579	86073
19723	27746	12	applied	\N	\N	\N	\N	86580	86580	86075
19723	27747	13	applied	\N	\N	\N	\N	86581	86581	86077
19723	27750	14	applied	\N	\N	\N	\N	86582	86582	86087
19723	27751	15	applied	\N	\N	\N	\N	86583	86583	86089
19723	27752	16	applied	\N	\N	\N	\N	86584	86584	86091
19723	27753	17	applied	\N	\N	\N	\N	86585	86585	86093
19723	27754	18	applied	\N	\N	\N	\N	86586	86586	86095
19723	27755	19	applied	\N	\N	\N	\N	86587	86587	86097
19723	27760	20	applied	\N	\N	\N	\N	86588	86588	86114
19723	27761	21	applied	\N	\N	\N	\N	86589	86589	86116
19723	27762	22	applied	\N	\N	\N	\N	86590	86590	86118
19723	27763	23	applied	\N	\N	\N	\N	86591	86591	86120
19723	27764	24	applied	\N	\N	\N	\N	86592	86592	86122
19723	27765	25	applied	\N	\N	\N	\N	86593	86593	86124
19723	27766	26	applied	\N	\N	\N	\N	86594	86594	86126
19723	27767	27	applied	\N	\N	\N	\N	86595	86595	86128
19723	27768	28	applied	\N	\N	\N	\N	86596	86596	86130
19723	27769	29	applied	\N	\N	\N	\N	86597	86597	86132
19723	27770	30	applied	\N	\N	\N	\N	86598	86598	86134
19723	27771	31	applied	\N	\N	\N	\N	86599	86599	86136
19723	27776	32	applied	\N	\N	\N	\N	86600	86600	86149
19723	27777	33	applied	\N	\N	\N	\N	86601	86601	86151
19723	27778	34	applied	\N	\N	\N	\N	86602	86602	86153
19723	27779	35	applied	\N	\N	\N	\N	86603	86603	86155
19723	27780	36	applied	\N	\N	\N	\N	86604	86604	86157
19723	27781	37	applied	\N	\N	\N	\N	86605	86605	86159
19723	27784	38	applied	\N	\N	\N	\N	86668	86668	86165
19723	27785	39	applied	\N	\N	\N	\N	86669	86669	86167
19723	27786	40	applied	\N	\N	\N	\N	86670	86670	86169
19723	27787	41	applied	\N	\N	\N	\N	86671	86671	86171
19723	27788	42	applied	\N	\N	\N	\N	86672	86672	86173
19723	27789	43	applied	\N	\N	\N	\N	86673	86673	86175
19723	27795	44	applied	\N	\N	\N	\N	86674	86674	86193
19723	27796	45	applied	\N	\N	\N	\N	86675	86675	86195
19723	27797	46	applied	\N	\N	\N	\N	86676	86676	86197
19723	27798	47	applied	\N	\N	\N	\N	86677	86677	86199
19723	27799	48	applied	\N	\N	\N	\N	86678	86678	86201
19723	27802	49	applied	\N	\N	\N	\N	86679	86679	86210
19723	27803	50	applied	\N	\N	\N	\N	86680	86680	86212
19723	27804	51	applied	\N	\N	\N	\N	86681	86681	86214
19723	27805	52	applied	\N	\N	\N	\N	86682	86682	86216
19723	27806	53	applied	\N	\N	\N	\N	86683	86683	86218
19723	27807	54	applied	\N	\N	\N	\N	86684	86684	86220
19723	27811	55	applied	\N	\N	\N	\N	86685	86685	86233
19723	27813	56	applied	\N	\N	\N	\N	86686	86686	86237
19723	27814	57	applied	\N	\N	\N	\N	86687	86687	86239
19723	27815	58	applied	\N	\N	\N	\N	86688	86688	86241
19723	27816	59	applied	\N	\N	\N	\N	86689	86689	86243
19723	27817	60	applied	\N	\N	\N	\N	86690	86690	86245
19723	27821	61	applied	\N	\N	\N	\N	86691	86691	86259
19723	27822	62	applied	\N	\N	\N	\N	86692	86692	86261
19723	27823	63	applied	\N	\N	\N	\N	86693	86693	86263
19723	27824	64	applied	\N	\N	\N	\N	86694	86694	86265
19723	27825	65	applied	\N	\N	\N	\N	86695	86695	86267
19723	27826	66	applied	\N	\N	\N	\N	86696	86696	86269
19723	27828	67	applied	\N	\N	\N	\N	86697	86697	86281
19723	27829	68	applied	\N	\N	\N	\N	86698	86698	86283
19723	27831	69	applied	\N	\N	\N	\N	86699	86699	86287
19723	27832	70	applied	\N	\N	\N	\N	86700	86700	86289
19723	27833	71	applied	\N	\N	\N	\N	86701	86701	86291
19723	27836	72	applied	\N	\N	\N	\N	86702	86702	86392
19723	27838	73	applied	\N	\N	\N	\N	86703	86703	86396
19723	27839	74	applied	\N	\N	\N	\N	86704	86704	86398
19723	27840	75	applied	\N	\N	\N	\N	86705	86705	86400
19723	27841	76	applied	\N	\N	\N	\N	86706	86706	86402
19723	27842	77	applied	\N	\N	\N	\N	86707	86707	86404
19723	27845	78	applied	\N	\N	\N	\N	86708	86708	86414
19723	27848	79	applied	\N	\N	\N	\N	86709	86709	86420
19723	27849	80	applied	\N	\N	\N	\N	86710	86710	86422
19723	27850	81	applied	\N	\N	\N	\N	86711	86711	86424
19723	27851	82	applied	\N	\N	\N	\N	86712	86712	86426
19723	27852	83	applied	\N	\N	\N	\N	86713	86713	86428
19723	27853	84	applied	\N	\N	\N	\N	86714	86714	86430
19723	27854	85	applied	\N	\N	\N	\N	86715	86715	86432
19723	27855	86	applied	\N	\N	\N	\N	86716	86716	86434
19723	27856	87	applied	\N	\N	\N	\N	86717	86717	86436
19723	27857	88	applied	\N	\N	\N	\N	86718	86718	86438
19723	27862	89	applied	\N	\N	\N	\N	86719	86719	86450
19723	27863	90	applied	\N	\N	\N	\N	86720	86720	86452
19723	27864	91	applied	\N	\N	\N	\N	86721	86721	86454
19694	27742	85	applied	\N	\N	\N	\N	86066	86066	86067
19694	27758	86	applied	\N	\N	\N	\N	86109	86109	86110
19694	27759	87	applied	\N	\N	\N	\N	86111	86111	86112
19694	27782	88	applied	\N	\N	\N	\N	86160	86160	86161
19694	27783	89	applied	\N	\N	\N	\N	86162	86162	86163
19694	27794	90	applied	\N	\N	\N	\N	86190	86190	86191
19694	27808	91	applied	\N	\N	\N	\N	86221	86221	86222
19694	27812	92	applied	\N	\N	\N	\N	86234	86234	86235
19694	27820	93	applied	\N	\N	\N	\N	86256	86256	86257
19694	27830	94	applied	\N	\N	\N	\N	86284	86284	86285
19694	27689	95	applied	\N	\N	\N	\N	85934	85934	85935
19694	27690	96	applied	\N	\N	\N	\N	85936	85936	85937
19694	27715	97	applied	\N	\N	\N	\N	85998	85998	33908
19694	27691	98	applied	\N	\N	\N	\N	85938	85938	85939
19694	27692	99	applied	\N	\N	\N	\N	85940	85940	85941
19694	27695	100	applied	\N	\N	\N	\N	85948	85948	86371
19694	27698	101	applied	\N	\N	\N	\N	85954	85954	86372
19694	27702	102	applied	\N	\N	\N	\N	85964	85964	86373
19694	27704	103	applied	\N	\N	\N	\N	85968	85968	85951
19694	27707	104	applied	\N	\N	\N	\N	85976	85976	85955
19694	27711	105	applied	\N	\N	\N	\N	85986	85986	86374
19694	27714	106	applied	\N	\N	\N	\N	85996	85996	86375
19694	27716	107	applied	\N	\N	\N	\N	85999	85999	86376
19694	27721	108	applied	\N	\N	\N	\N	86011	86011	85967
19694	27724	109	applied	\N	\N	\N	\N	86020	86020	85969
19694	27726	110	applied	\N	\N	\N	\N	86026	86026	86377
19694	27732	111	applied	\N	\N	\N	\N	86040	86040	86378
19694	27738	112	applied	\N	\N	\N	\N	86056	86056	86379
19694	27749	113	applied	\N	\N	\N	\N	86080	86080	85979
19694	27757	114	applied	\N	\N	\N	\N	86100	86100	86380
19694	27774	115	applied	\N	\N	\N	\N	86141	86141	86381
19694	27775	116	applied	\N	\N	\N	\N	86143	86143	86382
19694	27792	117	applied	\N	\N	\N	\N	86180	86180	86383
19694	27793	118	applied	\N	\N	\N	\N	86182	86182	86384
19694	27800	119	applied	\N	\N	\N	\N	86203	86203	86002
19694	27809	120	applied	\N	\N	\N	\N	86223	86223	86385
19694	27818	121	applied	\N	\N	\N	\N	86246	86246	86386
19694	27835	122	applied	\N	\N	\N	\N	86294	86294	86010
19694	27693	123	applied	\N	\N	\N	\N	85942	85942	86387
19694	27696	124	applied	\N	\N	\N	\N	85950	85950	86388
19694	27699	125	applied	\N	\N	\N	\N	85956	85956	86027
19697	27845	0	applied	\N	\N	\N	\N	86413	86413	86414
19697	27846	1	applied	\N	\N	\N	\N	86415	86415	86416
19697	27847	2	applied	\N	\N	\N	\N	86417	86417	86418
19697	27848	3	applied	\N	\N	\N	\N	86419	86419	86420
19697	27849	4	applied	\N	\N	\N	\N	86421	86421	86422
19697	27850	5	applied	\N	\N	\N	\N	86423	86423	86424
19697	27851	6	applied	\N	\N	\N	\N	86425	86425	86426
19697	27852	7	applied	\N	\N	\N	\N	86427	86427	86428
19697	27853	8	applied	\N	\N	\N	\N	86429	86429	86430
19697	27854	9	applied	\N	\N	\N	\N	86431	86431	86432
19697	27855	10	applied	\N	\N	\N	\N	86433	86433	86434
19697	27856	11	applied	\N	\N	\N	\N	86435	86435	86436
19697	27857	12	applied	\N	\N	\N	\N	86437	86437	86438
19697	27858	13	applied	\N	\N	\N	\N	86439	86439	86440
19697	27859	14	applied	\N	\N	\N	\N	86441	86441	86442
19697	27860	15	applied	\N	\N	\N	\N	86443	86443	86444
19697	27861	16	applied	\N	\N	\N	\N	86445	86445	86446
19700	27883	0	applied	\N	\N	\N	\N	86495	86495	86496
19700	27884	1	applied	\N	\N	\N	\N	86497	86497	86498
19700	27885	2	applied	\N	\N	\N	\N	86499	86499	86500
19703	27883	0	applied	\N	\N	\N	\N	86495	86495	86496
19703	27884	1	applied	\N	\N	\N	\N	86497	86497	86498
19703	27885	2	applied	\N	\N	\N	\N	86499	86499	86500
19705	27894	0	applied	\N	\N	\N	\N	86523	86523	86524
19705	27895	1	applied	\N	\N	\N	\N	86525	86525	86526
19705	27896	2	applied	\N	\N	\N	\N	86527	86527	86528
19705	27897	3	applied	\N	\N	\N	\N	86529	86529	86530
19705	27898	4	applied	\N	\N	\N	\N	86531	86531	86532
19705	27899	5	applied	\N	\N	\N	\N	86533	86533	86534
19708	27900	0	applied	\N	\N	\N	\N	86537	86537	86538
19708	27901	1	applied	\N	\N	\N	\N	86502	86502	86505
19708	27902	2	applied	\N	\N	\N	\N	86504	86504	86503
19708	27903	3	applied	\N	\N	\N	\N	86539	86539	86540
19708	27904	4	applied	\N	\N	\N	\N	86541	86541	86542
19712	27905	0	applied	\N	\N	\N	\N	86547	86547	86548
19712	27906	1	applied	\N	\N	\N	\N	86549	86549	86550
19712	27907	2	applied	\N	\N	\N	\N	86551	86551	86552
19715	27359	0	applied	\N	\N	1000000000	\N	84907	84907	84908
19715	27728	1	applied	\N	\N	\N	\N	86568	86568	86033
19715	27729	2	applied	\N	\N	\N	\N	86569	86569	86035
19715	27730	3	applied	\N	\N	\N	\N	86570	86570	86037
19715	27733	4	applied	\N	\N	\N	\N	86571	86571	86047
19715	27356	5	applied	\N	\N	\N	\N	84897	84897	84898
19715	27734	6	applied	\N	\N	\N	\N	86572	86572	86049
19715	27360	7	applied	\N	\N	\N	\N	84909	84909	84910
19715	27364	8	applied	\N	\N	\N	\N	84925	84925	84926
19715	27367	9	applied	\N	\N	\N	\N	84932	84932	84933
19715	27368	10	applied	\N	\N	\N	\N	84934	84934	84935
19715	27369	11	applied	\N	\N	\N	\N	84936	84936	84937
19715	27377	12	applied	\N	\N	\N	\N	84953	84953	84954
19715	27380	13	applied	\N	\N	\N	\N	84963	84963	84964
19715	27383	14	applied	\N	\N	\N	\N	84971	84971	84972
19715	27387	15	applied	\N	\N	\N	\N	84986	84986	84987
19715	27388	16	applied	\N	\N	\N	\N	84988	84988	84989
19715	27393	17	applied	\N	\N	\N	\N	85005	85005	85006
19715	27397	18	applied	\N	\N	\N	\N	85021	85021	85022
19715	27735	19	applied	\N	\N	\N	\N	86573	86573	86051
19715	27736	20	applied	\N	\N	\N	\N	86574	86574	86053
19715	27737	21	applied	\N	\N	\N	\N	86575	86575	86055
19715	27740	22	applied	\N	\N	\N	\N	86576	86576	86063
19715	27743	23	applied	\N	\N	\N	\N	86577	86577	86069
19715	27744	24	applied	\N	\N	\N	\N	86578	86578	86071
19715	27745	25	applied	\N	\N	\N	\N	86579	86579	86073
19715	27746	26	applied	\N	\N	\N	\N	86580	86580	86075
19715	27747	27	applied	\N	\N	\N	\N	86581	86581	86077
19715	27750	28	applied	\N	\N	\N	\N	86582	86582	86087
19715	27751	29	applied	\N	\N	\N	\N	86583	86583	86089
19715	27752	30	applied	\N	\N	\N	\N	86584	86584	86091
19715	27753	31	applied	\N	\N	\N	\N	86585	86585	86093
19715	27754	32	applied	\N	\N	\N	\N	86586	86586	86095
19715	27755	33	applied	\N	\N	\N	\N	86587	86587	86097
19715	27760	34	applied	\N	\N	\N	\N	86588	86588	86114
19715	27761	35	applied	\N	\N	\N	\N	86589	86589	86116
19715	27762	36	applied	\N	\N	\N	\N	86590	86590	86118
19715	27763	37	applied	\N	\N	\N	\N	86591	86591	86120
19715	27764	38	applied	\N	\N	\N	\N	86592	86592	86122
19715	27765	39	applied	\N	\N	\N	\N	86593	86593	86124
19715	27766	40	applied	\N	\N	\N	\N	86594	86594	86126
19715	27767	41	applied	\N	\N	\N	\N	86595	86595	86128
19702	27789	58	applied	\N	\N	\N	\N	86174	86174	86175
19702	27795	59	applied	\N	\N	\N	\N	86192	86192	86193
19702	27796	60	applied	\N	\N	\N	\N	86194	86194	86195
19702	27797	61	applied	\N	\N	\N	\N	86196	86196	86197
19702	27798	62	applied	\N	\N	\N	\N	86198	86198	86199
19702	27799	63	applied	\N	\N	\N	\N	86200	86200	86201
19702	27802	64	applied	\N	\N	\N	\N	86209	86209	86210
19702	27803	65	applied	\N	\N	\N	\N	86211	86211	86212
19702	27804	66	applied	\N	\N	\N	\N	86213	86213	86214
19702	27805	67	applied	\N	\N	\N	\N	86215	86215	86216
19702	27806	68	applied	\N	\N	\N	\N	86217	86217	86218
19702	27807	69	applied	\N	\N	\N	\N	86219	86219	86220
19702	27811	70	applied	\N	\N	\N	\N	86232	86232	86233
19702	27813	71	applied	\N	\N	\N	\N	86236	86236	86237
19702	27814	72	applied	\N	\N	\N	\N	86238	86238	86239
19702	27815	73	applied	\N	\N	\N	\N	86240	86240	86241
19702	27816	74	applied	\N	\N	\N	\N	86242	86242	86243
19702	27817	75	applied	\N	\N	\N	\N	86244	86244	86245
19702	27821	76	applied	\N	\N	\N	\N	86258	86258	86259
19702	27822	77	applied	\N	\N	\N	\N	86260	86260	86261
19702	27823	78	applied	\N	\N	\N	\N	86262	86262	86263
19702	27824	79	applied	\N	\N	\N	\N	86264	86264	86265
19702	27825	80	applied	\N	\N	\N	\N	86266	86266	86267
19702	27826	82	applied	\N	\N	\N	\N	86268	86268	86269
19702	27828	83	applied	\N	\N	\N	\N	86280	86280	86281
19702	27829	84	applied	\N	\N	\N	\N	86282	86282	86283
19702	27831	85	applied	\N	\N	\N	\N	86286	86286	86287
19702	27832	86	applied	\N	\N	\N	\N	86288	86288	86289
19702	27833	87	applied	\N	\N	\N	\N	86290	86290	86291
19702	27836	88	applied	\N	\N	\N	\N	86391	86391	86392
19702	27838	89	applied	\N	\N	\N	\N	86395	86395	86396
19702	27839	90	applied	\N	\N	\N	\N	86397	86397	86398
19702	27840	91	applied	\N	\N	\N	\N	86399	86399	86400
19702	27841	92	applied	\N	\N	\N	\N	86401	86401	86402
19702	27842	93	applied	\N	\N	\N	\N	86403	86403	86404
19702	27845	94	applied	\N	\N	\N	\N	86413	86413	86414
19702	27848	95	applied	\N	\N	\N	\N	86419	86419	86420
19702	27849	96	applied	\N	\N	\N	\N	86421	86421	86422
19702	27850	97	applied	\N	\N	\N	\N	86423	86423	86424
19702	27851	98	applied	\N	\N	\N	\N	86425	86425	86426
19702	27852	99	applied	\N	\N	\N	\N	86427	86427	86428
19702	27853	100	applied	\N	\N	\N	\N	86429	86429	86430
19702	27854	101	applied	\N	\N	\N	\N	86431	86431	86432
19702	27855	102	applied	\N	\N	\N	\N	86433	86433	86434
19702	27856	103	applied	\N	\N	\N	\N	86435	86435	86436
19702	27857	104	applied	\N	\N	\N	\N	86437	86437	86438
19702	27862	105	applied	\N	\N	\N	\N	86449	86449	86450
19702	27863	106	applied	\N	\N	\N	\N	86451	86451	86452
19702	27864	107	applied	\N	\N	\N	\N	86453	86453	86454
19702	27865	108	applied	\N	\N	\N	\N	86455	86455	86456
19702	27866	109	applied	\N	\N	\N	\N	86457	86457	86458
19702	27869	110	applied	\N	\N	\N	\N	86463	86463	86464
19702	27870	111	applied	\N	\N	\N	\N	86465	86465	86466
19702	27871	112	applied	\N	\N	\N	\N	86467	86467	86468
19702	27872	113	applied	\N	\N	\N	\N	86469	86469	86470
19702	27873	114	applied	\N	\N	\N	\N	86471	86471	86472
19702	27874	115	applied	\N	\N	\N	\N	86473	86473	86474
19702	27875	116	applied	\N	\N	\N	\N	86475	86475	86476
19702	27886	117	applied	\N	\N	\N	\N	86502	86502	86503
19702	27887	118	applied	\N	\N	\N	\N	86504	86504	86505
19702	27688	119	applied	\N	\N	\N	\N	85932	85932	85933
19702	27694	120	applied	\N	\N	\N	\N	85946	85946	85947
19702	27697	121	applied	\N	\N	\N	\N	85952	85952	85953
19702	27700	122	applied	\N	\N	\N	\N	85960	85960	85961
19702	27701	123	applied	\N	\N	\N	\N	85962	85962	85963
19702	27706	124	applied	\N	\N	\N	\N	85974	85974	85975
19702	27709	125	applied	\N	\N	\N	\N	85982	85982	85983
19704	27888	0	applied	\N	\N	\N	\N	86510	86510	86511
19704	27889	1	applied	\N	\N	\N	\N	86512	86512	86513
19704	27890	2	applied	\N	\N	\N	\N	86514	86514	86515
19704	27891	3	applied	\N	\N	\N	\N	86516	86516	86517
19704	27892	4	applied	\N	\N	\N	\N	86518	86518	86519
19704	27893	5	applied	\N	\N	\N	\N	86520	86520	86521
19707	27900	0	applied	\N	\N	\N	\N	86537	86537	86538
19707	27901	1	applied	\N	\N	\N	\N	86502	86502	86505
19707	27902	2	applied	\N	\N	\N	\N	86504	86504	86503
19707	27903	3	applied	\N	\N	\N	\N	86539	86539	86540
19707	27904	4	applied	\N	\N	\N	\N	86541	86541	86542
19709	27900	0	applied	\N	\N	\N	\N	86537	86537	86538
19709	27901	1	applied	\N	\N	\N	\N	86502	86502	86505
19709	27902	2	applied	\N	\N	\N	\N	86504	86504	86503
19709	27903	3	applied	\N	\N	\N	\N	86539	86539	86540
19709	27904	4	applied	\N	\N	\N	\N	86541	86541	86542
19711	27905	0	applied	\N	\N	\N	\N	86547	86547	86548
19711	27906	1	applied	\N	\N	\N	\N	86549	86549	86550
19711	27907	2	applied	\N	\N	\N	\N	86551	86551	86552
19714	27908	0	applied	\N	\N	\N	\N	86560	86560	86561
19714	27910	1	applied	\N	\N	\N	\N	86565	86565	86566
19714	27909	2	applied	\N	\N	\N	\N	86562	86562	86567
19716	27911	0	applied	\N	\N	\N	\N	86609	86609	86610
19716	27912	1	applied	\N	\N	\N	\N	86611	86611	86612
19716	27913	2	applied	\N	\N	\N	\N	86613	86613	86614
19716	27914	3	applied	\N	\N	\N	\N	86615	86615	86616
19716	27915	4	applied	\N	\N	\N	\N	86617	86617	86618
19716	27916	5	applied	\N	\N	\N	\N	86619	86619	86620
19716	27917	6	applied	\N	\N	\N	\N	86621	86621	86622
19716	27918	7	applied	\N	\N	\N	\N	86623	86623	86624
19716	27919	8	applied	\N	\N	\N	\N	86625	86625	86626
19719	27926	0	applied	\N	\N	\N	\N	86645	86645	86646
19719	27927	1	applied	\N	\N	\N	\N	86647	86647	86648
19719	27928	2	applied	\N	\N	\N	\N	86649	86649	86650
19719	27929	3	applied	\N	\N	\N	\N	86651	86651	86652
19721	27932	0	applied	\N	\N	\N	\N	86662	86662	86663
19721	27933	1	applied	\N	\N	\N	\N	86664	86664	86665
19721	27934	2	applied	\N	\N	\N	\N	86666	86666	86667
19728	27935	0	applied	\N	\N	\N	\N	86733	86733	86734
19728	27936	1	applied	\N	\N	\N	\N	86735	86735	86736
19728	27937	2	applied	\N	\N	\N	\N	86737	86737	86738
19728	27938	3	applied	\N	\N	\N	\N	86739	86739	86740
19728	27939	4	applied	\N	\N	\N	\N	86741	86741	86742
19728	27940	5	applied	\N	\N	\N	\N	86743	86743	86744
19732	27944	0	applied	\N	\N	\N	\N	86761	86761	86762
19732	27945	1	applied	\N	\N	\N	\N	86763	86763	86764
19732	27946	2	applied	\N	\N	\N	\N	86765	86765	86766
19736	27954	0	applied	\N	\N	\N	\N	86785	86785	86786
19736	27955	1	applied	\N	\N	\N	\N	86787	86787	86788
19737	27954	0	applied	\N	\N	\N	\N	86785	86785	86786
19737	27955	1	applied	\N	\N	\N	\N	86787	86787	86788
19739	27956	0	applied	\N	\N	\N	\N	86829	86829	86830
19739	27957	1	applied	\N	\N	\N	\N	86831	86831	86832
19715	27768	42	applied	\N	\N	\N	\N	86596	86596	86130
19715	27769	43	applied	\N	\N	\N	\N	86597	86597	86132
19715	27770	44	applied	\N	\N	\N	\N	86598	86598	86134
19715	27771	45	applied	\N	\N	\N	\N	86599	86599	86136
19715	27776	46	applied	\N	\N	\N	\N	86600	86600	86149
19715	27777	47	applied	\N	\N	\N	\N	86601	86601	86151
19715	27778	48	applied	\N	\N	\N	\N	86602	86602	86153
19715	27779	49	applied	\N	\N	\N	\N	86603	86603	86155
19715	27780	50	applied	\N	\N	\N	\N	86604	86604	86157
19715	27781	51	applied	\N	\N	\N	\N	86605	86605	86159
19715	27400	52	applied	\N	\N	\N	\N	85028	85028	85029
19715	27403	53	applied	\N	\N	\N	\N	85035	85035	85036
19715	27407	54	applied	\N	\N	\N	\N	85049	85049	85050
19715	27410	55	applied	\N	\N	\N	\N	85059	85059	85060
19715	27413	56	applied	\N	\N	\N	\N	85065	85065	85066
19715	27416	57	applied	\N	\N	\N	\N	85075	85075	85076
19715	27420	58	applied	\N	\N	\N	\N	85085	85085	85086
19715	27423	59	applied	\N	\N	\N	\N	85093	85093	85094
19715	27424	60	applied	\N	\N	\N	\N	85095	85095	85096
19715	27430	61	applied	\N	\N	\N	\N	85109	85109	85110
19715	27433	62	applied	\N	\N	\N	\N	85120	85120	85121
19715	27436	63	applied	\N	\N	\N	\N	85140	85140	85141
19715	27440	64	applied	\N	\N	\N	\N	85152	85152	85153
19715	27443	65	applied	\N	\N	\N	\N	85159	85159	85160
19715	27444	66	applied	\N	\N	\N	\N	85161	85161	85162
19715	27445	67	applied	\N	\N	\N	\N	85163	85163	85164
19715	27453	68	applied	\N	\N	\N	\N	85188	85188	85189
19715	27456	69	applied	\N	\N	\N	\N	85196	85196	85197
19715	27457	70	applied	\N	\N	\N	\N	85198	85198	85199
19715	27463	71	applied	\N	\N	\N	\N	85215	85215	85216
19715	27464	72	applied	\N	\N	\N	\N	85217	85217	85218
19715	27469	73	applied	\N	\N	\N	\N	85228	85228	85229
19715	27473	74	applied	\N	\N	\N	\N	85257	85257	85258
19715	27476	75	applied	\N	\N	\N	\N	85265	85265	85266
19715	27478	76	applied	\N	\N	\N	\N	85271	85271	85272
19715	27482	77	applied	\N	\N	\N	\N	85281	85281	85282
19715	27486	78	applied	\N	\N	\N	\N	85289	85289	85290
19715	27489	79	applied	\N	\N	\N	\N	85297	85297	85298
19715	27492	80	applied	\N	\N	\N	\N	85305	85305	85306
19715	27496	81	applied	\N	\N	\N	\N	85318	85318	85319
19715	27499	82	applied	\N	\N	\N	\N	85342	85342	85343
19715	27501	83	applied	\N	\N	\N	\N	85352	85352	85353
19715	27504	84	applied	\N	\N	\N	\N	85359	85359	85360
19715	27508	85	applied	\N	\N	\N	\N	85369	85369	85370
19715	27509	86	applied	\N	\N	\N	\N	85371	85371	85372
19715	27512	87	applied	\N	\N	\N	\N	85378	85378	85379
19715	27520	88	applied	\N	\N	\N	\N	85400	85400	85401
19715	27523	89	applied	\N	\N	\N	\N	85410	85410	85411
19715	27527	90	applied	\N	\N	\N	\N	85423	85423	85424
19715	27530	91	applied	\N	\N	\N	\N	85436	85436	85437
19715	27533	92	applied	\N	\N	\N	\N	85446	85446	85447
19715	27536	93	applied	\N	\N	\N	\N	85453	85453	85454
19715	27540	94	applied	\N	\N	\N	\N	85461	85461	85462
19715	27541	95	applied	\N	\N	\N	\N	85463	85463	85464
19715	27542	96	applied	\N	\N	\N	\N	85465	85465	85466
19715	27550	97	applied	\N	\N	\N	\N	85483	85483	85484
19715	27553	98	applied	\N	\N	\N	\N	85493	85493	85494
19715	27554	99	applied	\N	\N	\N	\N	85495	85495	85496
19715	27560	100	applied	\N	\N	\N	\N	85511	85511	85512
19715	27563	101	applied	\N	\N	\N	\N	85517	85517	85518
19715	27566	102	applied	\N	\N	\N	\N	85525	85525	85526
19715	27569	103	applied	\N	\N	\N	\N	85534	85534	85535
19715	27570	104	applied	\N	\N	\N	\N	85536	85536	85537
19715	27576	105	applied	\N	\N	\N	\N	85550	85550	85551
19715	27579	106	applied	\N	\N	\N	\N	85558	85558	85559
19715	27580	107	applied	\N	\N	\N	\N	85560	85560	85561
19715	27586	108	applied	\N	\N	\N	\N	85573	85573	85574
19715	27587	110	applied	\N	\N	\N	\N	85575	85575	85576
19715	27593	111	applied	\N	\N	\N	\N	85590	85590	85591
19715	27594	112	applied	\N	\N	\N	\N	85592	85592	85593
19715	27595	113	applied	\N	\N	\N	\N	85594	85594	85595
19715	27602	114	applied	\N	\N	\N	\N	85613	85613	85614
19715	27603	115	applied	\N	\N	\N	\N	85615	85615	85616
19715	27604	116	applied	\N	\N	\N	\N	85617	85617	85618
19715	27611	117	applied	\N	\N	\N	\N	85685	85685	85686
19715	27612	118	applied	\N	\N	\N	\N	85687	85687	85688
19715	27618	119	applied	\N	\N	\N	\N	85701	85701	85702
19715	27621	120	applied	\N	\N	\N	\N	85707	85707	85708
19715	27622	121	applied	\N	\N	\N	\N	85709	85709	85710
19715	27628	122	applied	\N	\N	\N	\N	85722	85722	85723
19715	27629	123	applied	\N	\N	\N	\N	85724	85724	85725
19715	27630	124	applied	\N	\N	\N	\N	85726	85726	85727
19715	27631	125	applied	\N	\N	\N	\N	85728	85728	85729
19720	27926	0	applied	\N	\N	\N	\N	86645	86645	86646
19720	27927	1	applied	\N	\N	\N	\N	86647	86647	86648
19720	27930	2	applied	\N	\N	\N	\N	86655	86655	86656
19720	27931	3	applied	\N	\N	\N	\N	86657	86657	86658
19720	27928	4	applied	\N	\N	\N	\N	86649	86649	86659
19720	27929	5	applied	\N	\N	\N	\N	86651	86651	86660
19724	27923	0	applied	\N	\N	\N	\N	86637	86637	86638
19724	27926	1	applied	\N	\N	\N	\N	86645	86645	86646
19724	27927	2	applied	\N	\N	\N	\N	86647	86647	86648
19724	27932	3	applied	\N	\N	\N	\N	86662	86662	86663
19724	27924	4	applied	\N	\N	\N	\N	86639	86639	86640
19724	27930	5	applied	\N	\N	\N	\N	86655	86655	86727
19724	27931	6	applied	\N	\N	\N	\N	86657	86657	86728
19724	27933	7	applied	\N	\N	\N	\N	86664	86664	86650
19724	27925	8	applied	\N	\N	\N	\N	86641	86641	86652
19724	27928	9	applied	\N	\N	\N	\N	86649	86649	86729
19724	27929	10	applied	\N	\N	\N	\N	86651	86651	86665
19724	27934	11	applied	\N	\N	\N	\N	86666	86666	86667
19726	27935	0	applied	\N	\N	\N	\N	86733	86733	86734
19726	27936	1	applied	\N	\N	\N	\N	86735	86735	86736
19726	27937	2	applied	\N	\N	\N	\N	86737	86737	86738
19726	27938	3	applied	\N	\N	\N	\N	86739	86739	86740
19726	27939	4	applied	\N	\N	\N	\N	86741	86741	86742
19726	27940	5	applied	\N	\N	\N	\N	86743	86743	86744
19733	27947	0	applied	\N	\N	\N	\N	86769	86769	86770
19733	27948	1	applied	\N	\N	\N	\N	86771	86771	86772
19733	27949	2	applied	\N	\N	\N	\N	86773	86773	86774
19733	27950	3	applied	\N	\N	\N	\N	86775	86775	86776
19733	27951	4	applied	\N	\N	\N	\N	86777	86777	86778
19733	27952	5	applied	\N	\N	\N	\N	86779	86779	86780
19740	27956	0	applied	\N	\N	\N	\N	86829	86829	86830
19740	27957	1	applied	\N	\N	\N	\N	86831	86831	86832
19740	27958	2	applied	\N	\N	\N	\N	86833	86833	86834
19746	27983	0	applied	\N	\N	\N	\N	86893	86893	86894
19746	27984	1	applied	\N	\N	\N	\N	86895	86895	86896
19746	27985	2	applied	\N	\N	\N	\N	86897	86897	86898
19765	28018	0	applied	\N	\N	\N	\N	87001	87001	87002
19717	27921	1	applied	\N	\N	\N	\N	86631	86631	86632
19717	27922	2	applied	\N	\N	\N	\N	86633	86633	86634
19722	27932	0	applied	\N	\N	\N	\N	86662	86662	86663
19722	27933	1	applied	\N	\N	\N	\N	86664	86664	86665
19722	27934	2	applied	\N	\N	\N	\N	86666	86666	86667
19725	27932	0	applied	\N	\N	\N	\N	86662	86662	86663
19725	27934	1	applied	\N	\N	\N	\N	86666	86666	86731
19727	27935	0	applied	\N	\N	\N	\N	86733	86733	86734
19727	27936	1	applied	\N	\N	\N	\N	86735	86735	86736
19727	27937	2	applied	\N	\N	\N	\N	86737	86737	86738
19727	27938	3	applied	\N	\N	\N	\N	86739	86739	86740
19729	27941	0	applied	\N	\N	\N	\N	86751	86751	86752
19729	27942	1	applied	\N	\N	\N	\N	86753	86753	86754
19731	27944	0	applied	\N	\N	\N	\N	86761	86761	86762
19731	27945	1	applied	\N	\N	\N	\N	86763	86763	86764
19731	27946	2	applied	\N	\N	\N	\N	86765	86765	86766
19734	27953	0	applied	\N	\N	\N	\N	86783	86783	86784
19734	27954	1	applied	\N	\N	\N	\N	86785	86785	86786
19734	27955	2	applied	\N	\N	\N	\N	86787	86787	86788
19738	27837	0	applied	\N	\N	\N	\N	86393	86393	86394
19738	27846	1	applied	\N	\N	\N	\N	86415	86415	86416
19738	27847	2	applied	\N	\N	\N	\N	86417	86417	86418
19738	27867	3	applied	\N	\N	\N	\N	86459	86459	86460
19738	27868	4	applied	\N	\N	\N	\N	86461	86461	86462
19738	27880	5	applied	\N	\N	\N	\N	86487	86487	86488
19738	27883	6	applied	\N	\N	\N	\N	86495	86495	86496
19738	27888	7	applied	\N	\N	\N	\N	86510	86510	86511
19738	27889	8	applied	\N	\N	\N	\N	86512	86512	86513
19738	27894	9	applied	\N	\N	\N	\N	86523	86523	86524
19738	27895	10	applied	\N	\N	\N	\N	86525	86525	86526
19738	27900	11	applied	\N	\N	\N	\N	86537	86537	86538
19738	27905	12	applied	\N	\N	\N	\N	86547	86547	86548
19738	27908	13	applied	\N	\N	\N	\N	86560	86560	86561
19738	27911	14	applied	\N	\N	\N	\N	86609	86609	86610
19738	27912	15	applied	\N	\N	\N	\N	86611	86611	86612
19738	27913	16	applied	\N	\N	\N	\N	86613	86613	86614
19738	27920	17	applied	\N	\N	\N	\N	86629	86629	86630
19738	27923	18	applied	\N	\N	\N	\N	86637	86637	86638
19738	27926	19	applied	\N	\N	\N	\N	86645	86645	86646
19738	27927	20	applied	\N	\N	\N	\N	86647	86647	86648
19738	27932	21	applied	\N	\N	\N	\N	86662	86662	86663
19738	27935	22	applied	\N	\N	\N	\N	86733	86733	86734
19738	27936	23	applied	\N	\N	\N	\N	86735	86735	86736
19738	27941	24	applied	\N	\N	\N	\N	86751	86751	86752
19738	27944	25	applied	\N	\N	\N	\N	86761	86761	86762
19738	27947	26	applied	\N	\N	\N	\N	86769	86769	86770
19738	27948	27	applied	\N	\N	\N	\N	86771	86771	86772
19738	27953	28	applied	\N	\N	\N	\N	86783	86783	86784
19738	27703	29	applied	\N	\N	\N	\N	85966	85966	86029
19738	27844	30	applied	\N	\N	\N	\N	86407	86407	86041
19738	27858	31	applied	\N	\N	\N	\N	86439	86439	86057
19738	27859	32	applied	\N	\N	\N	\N	86441	86441	86791
19738	27877	33	applied	\N	\N	\N	\N	86479	86479	86792
19738	27705	34	applied	\N	\N	\N	\N	85970	85970	86793
19738	27708	35	applied	\N	\N	\N	\N	85978	85978	86794
19738	27710	36	applied	\N	\N	\N	\N	85984	85984	86101
19738	27879	37	applied	\N	\N	\N	\N	86483	86483	86795
19738	27881	38	applied	\N	\N	\N	\N	86489	86489	86796
19738	27885	39	applied	\N	\N	\N	\N	86499	86499	86140
19738	27890	40	applied	\N	\N	\N	\N	86514	86514	86142
19738	27893	41	applied	\N	\N	\N	\N	86520	86520	86144
19738	27896	42	applied	\N	\N	\N	\N	86527	86527	86797
19738	27899	43	applied	\N	\N	\N	\N	86533	86533	86798
19738	27903	44	applied	\N	\N	\N	\N	86539	86539	86179
19738	27906	45	applied	\N	\N	\N	\N	86549	86549	86181
19738	27717	46	applied	\N	\N	\N	\N	86001	86001	86799
19738	27718	47	applied	\N	\N	\N	\N	86003	86003	86800
19738	27720	48	applied	\N	\N	\N	\N	86009	86009	86224
19738	27723	50	applied	\N	\N	\N	\N	86018	86018	86226
19738	27727	51	applied	\N	\N	\N	\N	86028	86028	86251
19738	27739	52	applied	\N	\N	\N	\N	86058	86058	86271
19738	27748	53	applied	\N	\N	\N	\N	86078	86078	86802
19738	27756	54	applied	\N	\N	\N	\N	86098	86098	86803
19738	27772	55	applied	\N	\N	\N	\N	86137	86137	86804
19738	27773	56	applied	\N	\N	\N	\N	86139	86139	86408
19738	27790	57	applied	\N	\N	\N	\N	86176	86176	86805
19738	27791	58	applied	\N	\N	\N	\N	86178	86178	86806
19738	27801	59	applied	\N	\N	\N	\N	86205	86205	86807
19738	27810	60	applied	\N	\N	\N	\N	86225	86225	86808
19738	27819	61	applied	\N	\N	\N	\N	86248	86248	86480
19738	27827	62	applied	\N	\N	\N	\N	86270	86270	86482
19738	27834	63	applied	\N	\N	\N	\N	86292	86292	86809
19738	27843	64	applied	\N	\N	\N	\N	86405	86405	86810
19738	27860	65	applied	\N	\N	\N	\N	86443	86443	86811
19738	27861	66	applied	\N	\N	\N	\N	86445	86445	86500
19738	27876	67	applied	\N	\N	\N	\N	86477	86477	86812
19738	27878	68	applied	\N	\N	\N	\N	86481	86481	86813
19738	27882	69	applied	\N	\N	\N	\N	86491	86491	86814
19738	27884	70	applied	\N	\N	\N	\N	86497	86497	86528
19738	27891	71	applied	\N	\N	\N	\N	86516	86516	86530
19738	27892	72	applied	\N	\N	\N	\N	86518	86518	86532
19738	27897	73	applied	\N	\N	\N	\N	86529	86529	86815
19738	27898	74	applied	\N	\N	\N	\N	86531	86531	86816
19738	27904	75	applied	\N	\N	\N	\N	86541	86541	86550
19738	27907	76	applied	\N	\N	\N	\N	86551	86551	86552
19738	27910	77	applied	\N	\N	\N	\N	86565	86565	86566
19738	27915	78	applied	\N	\N	\N	\N	86617	86617	86817
19738	27916	79	applied	\N	\N	\N	\N	86619	86619	86818
19738	27921	80	applied	\N	\N	\N	\N	86631	86631	86819
19738	27925	81	applied	\N	\N	\N	\N	86641	86641	86624
19738	27928	82	applied	\N	\N	\N	\N	86649	86649	86820
19738	27929	83	applied	\N	\N	\N	\N	86651	86651	86821
19738	27909	84	applied	\N	\N	\N	\N	86562	86562	86822
19738	27917	85	applied	\N	\N	\N	\N	86621	86621	86823
19738	27918	86	applied	\N	\N	\N	\N	86623	86623	86642
19738	27919	87	applied	\N	\N	\N	\N	86625	86625	86656
19738	27922	88	applied	\N	\N	\N	\N	86633	86633	86658
19738	27924	89	applied	\N	\N	\N	\N	86639	86639	86652
19738	27930	90	applied	\N	\N	\N	\N	86655	86655	86824
19738	27931	91	applied	\N	\N	\N	\N	86657	86657	86660
19738	27933	92	applied	\N	\N	\N	\N	86664	86664	86665
19738	27939	93	applied	\N	\N	\N	\N	86741	86741	86825
19738	27940	94	applied	\N	\N	\N	\N	86743	86743	86826
19749	27908	0	applied	\N	\N	\N	\N	86560	86560	86561
19749	27911	1	applied	\N	\N	\N	\N	86609	86609	86610
19749	27912	2	applied	\N	\N	\N	\N	86611	86611	86612
19749	27913	3	applied	\N	\N	\N	\N	86613	86613	86614
19749	27920	4	applied	\N	\N	\N	\N	86629	86629	86630
19749	27914	5	applied	\N	\N	\N	\N	86615	86615	86616
19749	27923	6	applied	\N	\N	\N	\N	86637	86637	86638
19723	27865	92	applied	\N	\N	\N	\N	86722	86722	86456
19723	27866	93	applied	\N	\N	\N	\N	86723	86723	86458
19723	27869	94	applied	\N	\N	\N	\N	86724	86724	86464
19723	27715	95	applied	\N	\N	\N	\N	85998	85998	33908
19730	27941	0	applied	\N	\N	\N	\N	86751	86751	86752
19730	27939	1	applied	\N	\N	\N	\N	86741	86741	86742
19730	27940	2	applied	\N	\N	\N	\N	86743	86743	86744
19730	27943	3	applied	\N	\N	\N	\N	86757	86757	86758
19730	27942	4	applied	\N	\N	\N	\N	86753	86753	86759
19735	27953	0	applied	\N	\N	\N	\N	86783	86783	86784
19735	27954	1	applied	\N	\N	\N	\N	86785	86785	86786
19735	27955	2	applied	\N	\N	\N	\N	86787	86787	86788
19741	27959	0	applied	\N	\N	\N	\N	86838	86838	86839
19741	27960	1	applied	\N	\N	\N	\N	86840	86840	86841
19741	27961	2	applied	\N	\N	\N	\N	86842	86842	86843
19743	27962	0	applied	\N	\N	\N	\N	86846	86846	86847
19743	27963	1	applied	\N	\N	\N	\N	86848	86848	86849
19747	27986	0	applied	\N	\N	\N	\N	86901	86901	86902
19747	27987	1	applied	\N	\N	\N	\N	86903	86903	86904
19747	27988	2	applied	\N	\N	\N	\N	86905	86905	86906
19754	27995	0	applied	\N	\N	\N	\N	86948	86948	86949
19754	27996	1	applied	\N	\N	\N	\N	86950	86950	86951
19754	27997	2	applied	\N	\N	\N	\N	86952	86952	86953
19756	27998	0	applied	\N	\N	\N	\N	86956	86956	86957
19756	27999	1	applied	\N	\N	\N	\N	86958	86958	86959
19756	28000	2	applied	\N	\N	\N	\N	86960	86960	86961
19759	28001	0	applied	\N	\N	\N	\N	86964	86964	86965
19759	28002	1	applied	\N	\N	\N	\N	86966	86966	86967
19759	28003	2	applied	\N	\N	\N	\N	86968	86968	86969
19761	28006	0	applied	\N	\N	\N	\N	86975	86975	86976
19761	28007	1	applied	\N	\N	\N	\N	86977	86977	86978
19761	28008	2	applied	\N	\N	\N	\N	86979	86979	86980
19761	28009	3	applied	\N	\N	\N	\N	86981	86981	86982
19761	28010	4	applied	\N	\N	\N	\N	86983	86983	86984
19761	28011	5	applied	\N	\N	\N	\N	86985	86985	86986
19770	28028	0	applied	\N	\N	\N	\N	87051	87051	87052
19770	28029	1	applied	\N	\N	\N	\N	87053	87053	87054
19770	28030	2	applied	\N	\N	\N	\N	87055	87055	87056
19779	28056	0	applied	\N	\N	\N	\N	87121	87121	87122
19779	28057	1	applied	\N	\N	\N	\N	87123	87123	87124
19779	28058	2	applied	\N	\N	\N	\N	87125	87125	87126
19779	28059	3	applied	\N	\N	\N	\N	87127	87127	87128
19779	28060	4	applied	\N	\N	\N	\N	87129	87129	87130
19779	28061	5	applied	\N	\N	\N	\N	87131	87131	87132
19779	28062	6	applied	\N	\N	\N	\N	87133	87133	87134
19787	28082	0	applied	\N	\N	\N	\N	87182	87182	87183
19787	28083	1	applied	\N	\N	\N	\N	87184	87184	87185
19787	28084	2	applied	\N	\N	\N	\N	87186	87186	87187
19787	28085	3	applied	\N	\N	1000000000	\N	87188	87188	87189
19787	28086	4	applied	\N	\N	\N	\N	87190	87190	87191
19787	28087	5	applied	\N	\N	\N	\N	87192	87192	87193
19787	28088	6	applied	\N	\N	\N	\N	87194	87194	87195
19789	28093	0	applied	\N	\N	\N	\N	87210	87210	87211
19789	28094	1	applied	\N	\N	\N	\N	87212	87212	87213
19789	28095	2	applied	\N	\N	\N	\N	87214	87214	87215
19795	28103	0	applied	\N	\N	\N	\N	87238	87238	87239
19795	28104	1	applied	\N	\N	\N	\N	87240	87240	87241
19795	28105	2	applied	\N	\N	\N	\N	87244	87244	87245
19799	28109	0	applied	\N	\N	\N	\N	87258	87258	87259
19799	28110	1	applied	\N	\N	\N	\N	87260	87260	87261
19799	28111	2	applied	\N	\N	\N	\N	87262	87262	87263
19799	28112	3	applied	\N	\N	\N	\N	87264	87264	87265
19799	28113	4	applied	\N	\N	\N	\N	87266	87266	87267
19799	28114	5	applied	\N	\N	\N	\N	87268	87268	87269
19799	28115	6	applied	\N	\N	\N	\N	87270	87270	87271
19799	28116	7	applied	\N	\N	\N	\N	87272	87272	87273
19801	28109	0	applied	\N	\N	\N	\N	87258	87258	87259
19801	28110	1	applied	\N	\N	\N	\N	87260	87260	87261
19801	28111	2	applied	\N	\N	\N	\N	87262	87262	87263
19801	28112	3	applied	\N	\N	\N	\N	87264	87264	87265
19801	28113	4	applied	\N	\N	\N	\N	87266	87266	87267
19801	28114	5	applied	\N	\N	\N	\N	87268	87268	87269
19801	28115	6	applied	\N	\N	\N	\N	87270	87270	87271
19801	28116	7	applied	\N	\N	\N	\N	87272	87272	87273
19808	28138	0	applied	\N	\N	\N	\N	87332	87332	87333
19808	28139	1	applied	\N	\N	\N	\N	87334	87334	87335
19808	28140	2	applied	\N	\N	\N	\N	87336	87336	87337
19814	28144	0	applied	\N	\N	\N	\N	87353	87353	87354
19814	28145	1	applied	\N	\N	\N	\N	87355	87355	87356
19815	28146	0	applied	\N	\N	\N	\N	87361	87361	87362
19815	28147	1	applied	\N	\N	\N	\N	87363	87363	87364
19815	28148	2	applied	\N	\N	\N	\N	87365	87365	87366
19815	28149	3	applied	\N	\N	\N	\N	87367	87367	87368
19815	28150	4	applied	\N	\N	\N	\N	87369	87369	87370
19815	28151	5	applied	\N	\N	\N	\N	87371	87371	87372
19815	28152	6	applied	\N	\N	\N	\N	87373	87373	87374
19819	28160	0	applied	\N	\N	\N	\N	87395	87395	87396
19819	28161	1	applied	\N	\N	\N	\N	87397	87397	87398
19819	28162	2	applied	\N	\N	\N	\N	87399	87399	87400
19819	28163	3	applied	\N	\N	\N	\N	87401	87401	87402
19824	28177	0	applied	\N	\N	\N	\N	87436	87436	87437
19824	28178	1	applied	\N	\N	\N	\N	87438	87438	87439
19824	28179	2	applied	\N	\N	\N	\N	87440	87440	87441
19830	28182	0	applied	\N	\N	\N	\N	87452	87452	87453
19830	28183	1	applied	\N	\N	\N	\N	87454	87454	87455
19830	28184	2	applied	\N	\N	\N	\N	87456	87456	87457
19833	28188	0	applied	\N	\N	\N	\N	87475	87475	87476
19833	28189	1	applied	\N	\N	\N	\N	87477	87477	87478
19833	28190	2	applied	\N	\N	\N	\N	87479	87479	87480
19843	28208	0	applied	\N	\N	\N	\N	87530	87530	87531
19843	28209	1	applied	\N	\N	\N	\N	87532	87532	87533
19843	28210	2	applied	\N	\N	\N	\N	87534	87534	87535
19847	28109	0	applied	\N	\N	\N	\N	87553	87553	87259
19847	28110	1	applied	\N	\N	\N	\N	87554	87554	87261
19847	28111	2	applied	\N	\N	\N	\N	87555	87555	87263
19847	28112	3	applied	\N	\N	\N	\N	87556	87556	87265
19847	27728	4	applied	\N	\N	\N	\N	86568	86568	86033
19847	27729	5	applied	\N	\N	\N	\N	86569	86569	86035
19847	27730	6	applied	\N	\N	\N	\N	86570	86570	86037
19847	27733	7	applied	\N	\N	\N	\N	86571	86571	86047
19847	27734	8	applied	\N	\N	\N	\N	86572	86572	86049
19847	27735	9	applied	\N	\N	\N	\N	86573	86573	86051
19847	27736	10	applied	\N	\N	\N	\N	86574	86574	86053
19847	27737	11	applied	\N	\N	\N	\N	86575	86575	86055
19847	27740	12	applied	\N	\N	\N	\N	86576	86576	86063
19847	27743	13	applied	\N	\N	\N	\N	86577	86577	86069
19847	27744	14	applied	\N	\N	\N	\N	86578	86578	86071
19847	27745	15	applied	\N	\N	\N	\N	86579	86579	86073
19847	27746	16	applied	\N	\N	\N	\N	86580	86580	86075
19847	27747	17	applied	\N	\N	\N	\N	86581	86581	86077
19739	27958	2	applied	\N	\N	\N	\N	86833	86833	86834
19742	27959	0	applied	\N	\N	\N	\N	86838	86838	86839
19742	27960	1	applied	\N	\N	\N	\N	86840	86840	86841
19742	27961	2	applied	\N	\N	\N	\N	86842	86842	86843
19744	27964	0	applied	\N	\N	\N	\N	86851	86851	86852
19744	27965	1	applied	\N	\N	\N	\N	86853	86853	86854
19744	27966	2	applied	\N	\N	\N	\N	86855	86855	86856
19744	27967	3	applied	\N	\N	\N	\N	86857	86857	86858
19744	27968	4	applied	\N	\N	\N	\N	86859	86859	86860
19744	27969	5	applied	\N	\N	\N	\N	86861	86861	86862
19744	27970	6	applied	\N	\N	\N	\N	86863	86863	86864
19745	27971	0	applied	\N	\N	\N	\N	86867	86867	86868
19745	27972	1	applied	\N	\N	\N	\N	86869	86869	86870
19745	27973	2	applied	\N	\N	\N	\N	86871	86871	86872
19745	27974	3	applied	\N	\N	\N	\N	86873	86873	86874
19745	27975	4	applied	\N	\N	\N	\N	86875	86875	86876
19745	27976	5	applied	\N	\N	\N	\N	86877	86877	86878
19745	27977	6	applied	\N	\N	\N	\N	86879	86879	86880
19745	27978	7	applied	\N	\N	\N	\N	86881	86881	86882
19745	27979	8	applied	\N	\N	\N	\N	86883	86883	86884
19745	27980	9	applied	\N	\N	\N	\N	86885	86885	86886
19745	27981	10	applied	\N	\N	\N	\N	86887	86887	86888
19745	27982	11	applied	\N	\N	\N	\N	86889	86889	86890
19748	27986	0	applied	\N	\N	\N	\N	86901	86901	86902
19748	27987	1	applied	\N	\N	\N	\N	86903	86903	86904
19748	27988	2	applied	\N	\N	\N	\N	86905	86905	86906
19750	27989	0	applied	\N	\N	\N	\N	86911	86911	86912
19750	27991	1	applied	\N	\N	\N	\N	86936	86936	86939
19750	27990	2	applied	\N	\N	\N	\N	86925	86925	86937
19753	27992	0	applied	\N	\N	\N	\N	86941	86941	86942
19753	27993	1	applied	\N	\N	\N	\N	86943	86943	86944
19753	27994	2	applied	\N	\N	\N	\N	86945	86945	86946
19755	27996	0	applied	\N	\N	\N	\N	86950	86950	86951
19755	27997	1	applied	\N	\N	\N	\N	86952	86952	86953
19762	28012	0	applied	\N	\N	\N	\N	86988	86988	86989
19762	28013	1	applied	\N	\N	\N	\N	86990	86990	86991
19762	28014	2	applied	\N	\N	\N	\N	86992	86992	86993
19764	28015	0	applied	\N	\N	\N	\N	86994	86994	86995
19764	28016	1	applied	\N	\N	\N	\N	86996	86996	86997
19764	28017	2	applied	\N	\N	\N	\N	86998	86998	86999
19771	28031	0	applied	\N	\N	\N	\N	87061	87061	87062
19771	28032	1	applied	\N	\N	\N	\N	87063	87063	87064
19771	28033	2	applied	\N	\N	\N	\N	87065	87065	87066
19774	28047	0	applied	\N	\N	\N	\N	87099	87099	87100
19774	28048	1	applied	\N	\N	\N	\N	87101	87101	87102
19774	28049	2	applied	\N	\N	\N	\N	87103	87103	87104
19784	28072	0	applied	\N	\N	\N	\N	87157	87157	87158
19784	28073	1	applied	\N	\N	\N	\N	87159	87159	87160
19784	28074	2	applied	\N	\N	\N	\N	87161	87161	87162
19790	28096	0	applied	\N	\N	\N	\N	87218	87218	87219
19790	28097	1	applied	\N	\N	\N	\N	87220	87220	87221
19790	28098	2	applied	\N	\N	\N	\N	87222	87222	87223
19792	28099	0	applied	\N	\N	\N	\N	87228	87228	87229
19792	28100	1	applied	\N	\N	\N	\N	87230	87230	87231
19792	28101	2	applied	\N	\N	\N	\N	87232	87232	87233
19792	28102	3	applied	\N	\N	\N	\N	87234	87234	87235
19809	28138	0	applied	\N	\N	\N	\N	87332	87332	87333
19809	28139	1	applied	\N	\N	\N	\N	87334	87334	87335
19809	28140	2	applied	\N	\N	\N	\N	87336	87336	87337
19817	28158	0	applied	\N	\N	\N	\N	87387	87387	87388
19817	28159	1	applied	\N	\N	\N	\N	87389	87389	87390
19820	28164	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	87404	87404	\N
19820	28165	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	87405	87405	\N
19820	28166	3	applied	\N	\N	\N	\N	87407	87407	87408
19820	28167	4	applied	\N	\N	\N	\N	87409	87409	87410
19820	28168	5	applied	\N	\N	\N	\N	87411	87411	87412
19820	28169	6	applied	\N	\N	\N	\N	87413	87413	87414
19822	28170	0	applied	\N	\N	\N	\N	87419	87419	87420
19822	28171	1	applied	\N	\N	\N	\N	87421	87421	87422
19825	28180	0	applied	\N	\N	\N	\N	87444	87444	87445
19825	28181	1	applied	\N	\N	\N	\N	87446	87446	87447
19827	28182	0	applied	\N	\N	\N	\N	87452	87452	87453
19827	28183	1	applied	\N	\N	\N	\N	87454	87454	87455
19827	28184	2	applied	\N	\N	\N	\N	87456	87456	87457
19836	28195	0	applied	\N	\N	\N	\N	87494	87494	87495
19836	28196	1	applied	\N	\N	\N	\N	87496	87496	87497
19836	28197	2	applied	\N	\N	\N	\N	87498	87498	87499
19841	28204	0	applied	\N	\N	\N	\N	87518	87518	87519
19841	28205	1	applied	\N	\N	\N	\N	87520	87520	87521
19841	28206	2	applied	\N	\N	\N	\N	87522	87522	87523
19841	28207	3	applied	\N	\N	\N	\N	87524	87524	87525
19844	28208	0	applied	\N	\N	\N	\N	87530	87530	87531
19844	28209	1	applied	\N	\N	\N	\N	87532	87532	87533
19844	28210	2	applied	\N	\N	\N	\N	87534	87534	87535
19850	28221	0	applied	\N	\N	\N	\N	87565	87565	87566
19850	28222	1	applied	\N	\N	\N	\N	87567	87567	87568
19850	28223	2	applied	\N	\N	\N	\N	87569	87569	87570
19850	28224	3	applied	\N	\N	1000000000	\N	87571	87571	87572
19850	28225	4	applied	\N	\N	\N	\N	87573	87573	87574
19850	28226	5	applied	\N	\N	\N	\N	87575	87575	87576
19853	28227	0	applied	\N	\N	\N	\N	87581	87581	87582
19853	28228	1	applied	\N	\N	\N	\N	87583	87583	75393
19853	28232	2	applied	\N	\N	\N	\N	87592	87592	87589
19853	28229	3	applied	\N	\N	\N	\N	87584	87584	87585
19853	28230	4	applied	\N	\N	\N	\N	87586	87586	87593
19853	28231	5	applied	\N	\N	\N	\N	87588	87588	87594
19856	28233	0	applied	\N	\N	\N	\N	87601	87601	87602
19856	28234	1	applied	\N	\N	\N	\N	87603	87603	87604
19856	28235	2	applied	\N	\N	\N	\N	87605	87605	87606
19856	28236	3	applied	\N	\N	1000000000	\N	87607	87607	87608
19856	28237	4	applied	\N	\N	\N	\N	87609	87609	87610
19856	28238	5	applied	\N	\N	\N	\N	87611	87611	87612
19862	28248	0	applied	\N	\N	\N	\N	87638	87638	87639
19862	28249	1	applied	\N	\N	\N	\N	87640	87640	87641
19862	28250	2	applied	\N	\N	\N	\N	87642	87642	87643
19862	28251	4	applied	\N	\N	\N	\N	87645	87645	87646
19862	28252	5	applied	\N	\N	\N	\N	87647	87647	87648
19867	28260	0	applied	\N	\N	\N	\N	87676	87676	87677
19867	28261	1	applied	\N	\N	\N	\N	87678	87678	87679
19867	28262	2	applied	\N	\N	\N	\N	87680	87680	87681
19867	28263	3	applied	\N	\N	\N	\N	87682	87682	87683
19867	28264	4	applied	\N	\N	\N	\N	87684	87684	87685
19867	28265	5	applied	\N	\N	\N	\N	87686	87686	87687
19867	28266	6	applied	\N	\N	\N	\N	87688	87688	87689
19867	28267	7	applied	\N	\N	\N	\N	87690	87690	87691
19867	28268	8	applied	\N	\N	\N	\N	87692	87692	87693
19867	28269	9	applied	\N	\N	\N	\N	87694	87694	87695
19867	28270	10	applied	\N	\N	\N	\N	87696	87696	87697
19749	27926	7	applied	\N	\N	\N	\N	86645	86645	86646
19749	27927	8	applied	\N	\N	\N	\N	86647	86647	86648
19749	27932	9	applied	\N	\N	\N	\N	86662	86662	86663
19749	27935	10	applied	\N	\N	\N	\N	86733	86733	86734
19749	27936	11	applied	\N	\N	\N	\N	86735	86735	86736
19749	27941	12	applied	\N	\N	\N	\N	86751	86751	86752
19749	27944	13	applied	\N	\N	\N	\N	86761	86761	86762
19749	27947	14	applied	\N	\N	\N	\N	86769	86769	86770
19749	27948	15	applied	\N	\N	\N	\N	86771	86771	86772
19749	27953	16	applied	\N	\N	\N	\N	86783	86783	86784
19749	27956	17	applied	\N	\N	\N	\N	86829	86829	86830
19749	27959	18	applied	\N	\N	\N	\N	86838	86838	86839
19749	27962	19	applied	\N	\N	\N	\N	86846	86846	86847
19749	27964	20	applied	\N	\N	\N	\N	86851	86851	86852
19749	27965	21	applied	\N	\N	\N	\N	86853	86853	86854
19749	27971	22	applied	\N	\N	\N	\N	86867	86867	86868
19749	27972	23	applied	\N	\N	\N	\N	86869	86869	86870
19749	27973	24	applied	\N	\N	\N	\N	86871	86871	86872
19749	27974	25	applied	\N	\N	\N	\N	86873	86873	86874
19749	27983	26	applied	\N	\N	\N	\N	86893	86893	86894
19749	27986	27	applied	\N	\N	\N	\N	86901	86901	86902
19749	27989	28	applied	\N	\N	\N	\N	86911	86911	86912
19749	27910	29	applied	\N	\N	\N	\N	86565	86565	86566
19749	27915	30	applied	\N	\N	\N	\N	86617	86617	86817
19749	27916	31	applied	\N	\N	\N	\N	86619	86619	86818
19749	27921	32	applied	\N	\N	\N	\N	86631	86631	86819
19749	27925	33	applied	\N	\N	\N	\N	86641	86641	86624
19749	27928	34	applied	\N	\N	\N	\N	86649	86649	86820
19749	27929	35	applied	\N	\N	\N	\N	86651	86651	86821
19749	27909	36	applied	\N	\N	\N	\N	86562	86562	86822
19749	27917	37	applied	\N	\N	\N	\N	86621	86621	86823
19749	27918	38	applied	\N	\N	\N	\N	86623	86623	86642
19749	27919	39	applied	\N	\N	\N	\N	86625	86625	86656
19749	27922	40	applied	\N	\N	\N	\N	86633	86633	86658
19749	27924	41	applied	\N	\N	\N	\N	86639	86639	86652
19749	27930	42	applied	\N	\N	\N	\N	86655	86655	86824
19749	27931	43	applied	\N	\N	\N	\N	86657	86657	86660
19749	27933	44	applied	\N	\N	\N	\N	86664	86664	86665
19749	27939	45	applied	\N	\N	\N	\N	86741	86741	86825
19749	27940	46	applied	\N	\N	\N	\N	86743	86743	86826
19749	27943	47	applied	\N	\N	\N	\N	86757	86757	86738
19749	27946	48	applied	\N	\N	\N	\N	86765	86765	86913
19749	27949	49	applied	\N	\N	\N	\N	86773	86773	86914
19749	27950	50	applied	\N	\N	\N	\N	86775	86775	86754
19749	27954	51	applied	\N	\N	\N	\N	86785	86785	86915
19749	27957	52	applied	\N	\N	\N	\N	86831	86831	86916
19749	27960	53	applied	\N	\N	\N	\N	86840	86840	86759
19749	27966	54	applied	\N	\N	\N	\N	86855	86855	86917
19749	27969	55	applied	\N	\N	\N	\N	86861	86861	86918
19749	27970	56	applied	\N	\N	\N	\N	86863	86863	86919
19749	27975	57	applied	\N	\N	\N	\N	86875	86875	86920
19749	27980	58	applied	\N	\N	\N	\N	86885	86885	86921
19749	27981	59	applied	\N	\N	\N	\N	86887	86887	86778
19749	27982	60	applied	\N	\N	\N	\N	86889	86889	86922
19749	27984	61	applied	\N	\N	\N	\N	86895	86895	86923
19749	27987	62	applied	\N	\N	\N	\N	86903	86903	86924
19749	27990	63	applied	\N	\N	\N	\N	86925	86925	86788
19749	27934	64	applied	\N	\N	\N	\N	86666	86666	86926
19749	27937	65	applied	\N	\N	\N	\N	86737	86737	86927
19749	27938	66	applied	\N	\N	\N	\N	86739	86739	86928
19749	27942	67	applied	\N	\N	\N	\N	86753	86753	86929
19749	27945	68	applied	\N	\N	\N	\N	86763	86763	86856
19749	27951	69	applied	\N	\N	\N	\N	86777	86777	86858
19749	27952	70	applied	\N	\N	\N	\N	86779	86779	86860
19749	27955	71	applied	\N	\N	\N	\N	86787	86787	86930
19749	27958	72	applied	\N	\N	\N	\N	86833	86833	86876
19749	27961	73	applied	\N	\N	\N	\N	86842	86842	86878
19749	27963	74	applied	\N	\N	\N	\N	86848	86848	86880
19749	27967	75	applied	\N	\N	\N	\N	86857	86857	86882
19749	27968	76	applied	\N	\N	\N	\N	86859	86859	86884
19749	27976	77	applied	\N	\N	\N	\N	86877	86877	86931
19749	27977	78	applied	\N	\N	\N	\N	86879	86879	86890
19749	27978	79	applied	\N	\N	\N	\N	86881	86881	86932
19749	27979	80	applied	\N	\N	\N	\N	86883	86883	86933
19749	27985	81	applied	\N	\N	\N	\N	86897	86897	86934
19749	27988	82	applied	\N	\N	\N	\N	86905	86905	86935
19749	27991	83	applied	\N	\N	\N	\N	86936	86936	86937
19751	27992	0	applied	\N	\N	\N	\N	86941	86941	86942
19751	27993	1	applied	\N	\N	\N	\N	86943	86943	86944
19751	27994	2	applied	\N	\N	\N	\N	86945	86945	86946
19758	28001	0	applied	\N	\N	\N	\N	86964	86964	86965
19758	28002	1	applied	\N	\N	\N	\N	86966	86966	86967
19758	28003	2	applied	\N	\N	\N	\N	86968	86968	86969
19760	28004	0	applied	\N	\N	\N	\N	86971	86971	86972
19760	28005	1	applied	\N	\N	\N	\N	86973	86973	86974
19766	28020	0	applied	\N	\N	1000000000	\N	87005	87005	87006
19766	28023	1	applied	\N	\N	1000000000	\N	87011	87011	87012
19766	28024	2	applied	\N	\N	\N	\N	87013	87013	87014
19766	28025	3	applied	\N	\N	\N	\N	87015	87015	87016
19766	28026	4	applied	\N	\N	\N	\N	87017	87017	87018
19766	28027	5	applied	\N	\N	\N	\N	87019	87019	87020
19768	27935	0	applied	\N	\N	\N	\N	86733	86733	86734
19768	27936	1	applied	\N	\N	\N	\N	86735	86735	86736
19768	27941	2	applied	\N	\N	\N	\N	86751	86751	86752
19768	27944	3	applied	\N	\N	\N	\N	86761	86761	86762
19768	27947	4	applied	\N	\N	\N	\N	86769	86769	86770
19768	27948	5	applied	\N	\N	\N	\N	86771	86771	86772
19768	27953	6	applied	\N	\N	\N	\N	86783	86783	86784
19768	27956	7	applied	\N	\N	\N	\N	86829	86829	86830
19768	27959	8	applied	\N	\N	\N	\N	86838	86838	86839
19768	27962	9	applied	\N	\N	\N	\N	86846	86846	86847
19768	27964	10	applied	\N	\N	\N	\N	86851	86851	86852
19768	27965	11	applied	\N	\N	\N	\N	86853	86853	86854
19768	27971	12	applied	\N	\N	\N	\N	86867	86867	86868
19768	27972	13	applied	\N	\N	\N	\N	86869	86869	86870
19768	27973	14	applied	\N	\N	\N	\N	86871	86871	86872
19768	27974	15	applied	\N	\N	\N	\N	86873	86873	86874
19768	27983	16	applied	\N	\N	\N	\N	86893	86893	86894
19768	27986	17	applied	\N	\N	\N	\N	86901	86901	86902
19768	27989	18	applied	\N	\N	\N	\N	86911	86911	86912
19768	27992	19	applied	\N	\N	\N	\N	86941	86941	86942
19768	27995	20	applied	\N	\N	\N	\N	86948	86948	86949
19768	27998	21	applied	\N	\N	\N	\N	86956	86956	86957
19768	28001	22	applied	\N	\N	\N	\N	86964	86964	86965
19768	28004	23	applied	\N	\N	\N	\N	86971	86971	86972
19768	28006	24	applied	\N	\N	\N	\N	86975	86975	86976
19768	28007	25	applied	\N	\N	\N	\N	86977	86977	86978
19768	28012	26	applied	\N	\N	\N	\N	86988	86988	86989
19768	28015	27	applied	\N	\N	\N	\N	86994	86994	86995
19765	28019	1	applied	\N	\N	\N	\N	87003	87003	87004
19765	28020	2	applied	\N	\N	1000000000	\N	87005	87005	87006
19765	28021	3	applied	\N	\N	\N	\N	87007	87007	87008
19765	28022	4	applied	\N	\N	\N	\N	87009	87009	87010
19765	28023	5	applied	\N	\N	1000000000	\N	87011	87011	87012
19765	28024	6	applied	\N	\N	\N	\N	87013	87013	87014
19765	28025	7	applied	\N	\N	\N	\N	87015	87015	87016
19765	28026	8	applied	\N	\N	\N	\N	87017	87017	87018
19765	28027	9	applied	\N	\N	\N	\N	87019	87019	87020
19767	28018	0	applied	\N	\N	\N	\N	87001	87001	87002
19767	28019	1	applied	\N	\N	\N	\N	87003	87003	87004
19767	28020	2	applied	\N	\N	1000000000	\N	87005	87005	87006
19767	28021	3	applied	\N	\N	\N	\N	87007	87007	87008
19767	28022	4	applied	\N	\N	\N	\N	87009	87009	87010
19767	28023	5	applied	\N	\N	1000000000	\N	87011	87011	87012
19767	28024	6	applied	\N	\N	\N	\N	87013	87013	87014
19767	28025	7	applied	\N	\N	\N	\N	87015	87015	87016
19767	28026	8	applied	\N	\N	\N	\N	87017	87017	87018
19767	28027	9	applied	\N	\N	\N	\N	87019	87019	87020
19769	28028	0	applied	\N	\N	\N	\N	87051	87051	87052
19769	28029	1	applied	\N	\N	\N	\N	87053	87053	87054
19769	28030	2	applied	\N	\N	\N	\N	87055	87055	87056
19772	28034	0	applied	\N	\N	\N	\N	87069	87069	87070
19772	28035	1	applied	\N	\N	\N	\N	87071	87071	87072
19772	28036	2	applied	\N	\N	\N	\N	87073	87073	87074
19772	28037	3	applied	\N	\N	\N	\N	87075	87075	87076
19772	28038	4	applied	\N	\N	\N	\N	87077	87077	87078
19772	28039	5	applied	\N	\N	\N	\N	87079	87079	87080
19775	28050	0	applied	\N	\N	\N	\N	87107	87107	87108
19775	28051	1	applied	\N	\N	\N	\N	87109	87109	87110
19775	28052	2	applied	\N	\N	\N	\N	87111	87111	87112
19777	28053	0	applied	\N	\N	\N	\N	87113	87113	87114
19777	28054	1	applied	\N	\N	\N	\N	87115	87115	87116
19777	28055	2	applied	\N	\N	\N	\N	87117	87117	87118
19780	28056	0	applied	\N	\N	\N	\N	87121	87121	87122
19780	28057	1	applied	\N	\N	\N	\N	87123	87123	87124
19780	28058	2	applied	\N	\N	\N	\N	87125	87125	87126
19780	28059	3	applied	\N	\N	\N	\N	87127	87127	87128
19780	28060	4	applied	\N	\N	\N	\N	87129	87129	87130
19780	28061	5	applied	\N	\N	\N	\N	87131	87131	87132
19780	28062	6	applied	\N	\N	\N	\N	87133	87133	87134
19785	28075	0	applied	\N	\N	\N	\N	87165	87165	87166
19785	28076	1	applied	\N	\N	\N	\N	87167	87167	87168
19785	28077	2	applied	\N	\N	\N	\N	87169	87169	87170
19785	28078	3	applied	\N	\N	\N	\N	87171	87171	87172
19785	28079	4	applied	\N	\N	\N	\N	87173	87173	87174
19785	28080	5	applied	\N	\N	\N	\N	87175	87175	87176
19785	28081	7	applied	\N	\N	\N	\N	87178	87178	87179
19788	28089	0	applied	\N	\N	\N	\N	87200	87200	87201
19788	28090	1	applied	\N	\N	\N	\N	87202	87202	87203
19788	28091	2	applied	\N	\N	\N	\N	87204	87204	87205
19788	28092	3	applied	\N	\N	\N	\N	87206	87206	87207
19793	28103	0	applied	\N	\N	\N	\N	87238	87238	87239
19793	28104	1	applied	\N	\N	\N	\N	87240	87240	87241
19796	28103	0	applied	\N	\N	\N	\N	87238	87238	87239
19796	28104	1	applied	\N	\N	\N	\N	87240	87240	87241
19796	28105	2	applied	\N	\N	\N	\N	87244	87244	87245
19797	28106	0	applied	\N	\N	\N	\N	87250	87250	87251
19797	28107	1	applied	\N	\N	\N	\N	87252	87252	87253
19797	28108	2	applied	\N	\N	\N	\N	87254	87254	87255
19802	28117	0	applied	\N	\N	\N	\N	87280	87280	87281
19802	28118	1	applied	\N	\N	\N	\N	87282	87282	87283
19802	28119	2	applied	\N	\N	\N	\N	87284	87284	87285
19802	28120	3	applied	\N	\N	\N	\N	87286	87286	87287
19803	28121	0	applied	\N	\N	\N	\N	87290	87290	87291
19803	28122	1	applied	\N	\N	\N	\N	87292	87292	87293
19803	28123	2	applied	\N	\N	\N	\N	87294	87294	87295
19803	28124	3	applied	\N	\N	\N	\N	87296	87296	87297
19803	28125	4	applied	\N	\N	\N	\N	87298	87298	87299
19803	28126	5	applied	\N	\N	\N	\N	87300	87300	87301
19803	28127	6	applied	\N	\N	\N	\N	87302	87302	87303
19803	28128	7	applied	\N	\N	\N	\N	87304	87304	87305
19803	28129	8	applied	\N	\N	\N	\N	87306	87306	87307
19803	28130	9	applied	\N	\N	\N	\N	87308	87308	87309
19805	28131	0	applied	\N	\N	\N	\N	87314	87314	87315
19805	28132	1	applied	\N	\N	\N	\N	87316	87316	87317
19805	28133	2	applied	\N	\N	\N	\N	87318	87318	87319
19810	28138	0	applied	\N	\N	\N	\N	87332	87332	87333
19810	28139	1	applied	\N	\N	\N	\N	87334	87334	87335
19810	28140	2	applied	\N	\N	\N	\N	87336	87336	87337
19818	28158	0	applied	\N	\N	\N	\N	87387	87387	87388
19818	28159	1	applied	\N	\N	\N	\N	87389	87389	87390
19823	28172	0	applied	\N	\N	\N	\N	87424	87424	87425
19823	28173	1	applied	\N	\N	\N	\N	87426	87426	87427
19823	28174	2	applied	\N	\N	\N	\N	87428	87428	87429
19823	28175	3	applied	\N	\N	\N	\N	87430	87430	87431
19823	28176	4	applied	\N	\N	\N	\N	87432	87432	87433
19828	28182	0	applied	\N	\N	\N	\N	87452	87452	87453
19828	28183	1	applied	\N	\N	\N	\N	87454	87454	87455
19828	28184	2	applied	\N	\N	\N	\N	87456	87456	87457
19831	28182	0	applied	\N	\N	\N	\N	87452	87452	87453
19831	28183	1	applied	\N	\N	\N	\N	87454	87454	87455
19831	28184	2	applied	\N	\N	\N	\N	87456	87456	87457
19832	28185	0	applied	\N	\N	\N	\N	87468	87468	87469
19832	28186	1	applied	\N	\N	\N	\N	87470	87470	87471
19832	28187	2	applied	\N	\N	\N	\N	87472	87472	87473
19834	28188	0	applied	\N	\N	\N	\N	87475	87475	87476
19834	28189	1	applied	\N	\N	\N	\N	87477	87477	87478
19834	28190	2	applied	\N	\N	\N	\N	87479	87479	87480
19837	28198	0	applied	\N	\N	\N	\N	87502	87502	87503
19837	28199	1	applied	\N	\N	\N	\N	87504	87504	87505
19837	28200	2	applied	\N	\N	\N	\N	87506	87506	87507
19839	28201	0	applied	\N	\N	\N	\N	87510	87510	87511
19839	28202	1	applied	\N	\N	\N	\N	87512	87512	87513
19839	28203	2	applied	\N	\N	\N	\N	87514	87514	87515
19845	28208	0	applied	\N	\N	\N	\N	87530	87530	87531
19845	28209	1	applied	\N	\N	\N	\N	87532	87532	87533
19845	28210	2	applied	\N	\N	\N	\N	87534	87534	87535
19846	28211	0	applied	\N	\N	\N	\N	87538	87538	87539
19846	28212	1	applied	\N	\N	\N	\N	87540	87540	87541
19846	28213	2	applied	\N	\N	\N	\N	87542	87542	87543
19846	28214	3	applied	\N	\N	\N	\N	87544	87544	87545
19846	28215	4	applied	\N	\N	\N	\N	87546	87546	87547
19846	28216	5	applied	\N	\N	\N	\N	87548	87548	87549
19846	28217	6	applied	\N	\N	\N	\N	87550	87550	87551
19848	28218	0	applied	\N	\N	\N	\N	87559	87559	87560
19848	28219	1	applied	\N	\N	\N	\N	87561	87561	87562
19848	28220	2	applied	\N	\N	\N	\N	87563	87563	87564
19854	28227	0	applied	\N	\N	\N	\N	87581	87581	87582
19768	28018	28	applied	\N	\N	\N	\N	87001	87001	87002
19768	28020	29	applied	\N	\N	1000000000	\N	87005	87005	87006
19768	27937	30	applied	\N	\N	\N	\N	86737	86737	86738
19768	28022	31	applied	\N	\N	\N	\N	87009	87009	87026
19768	27938	32	applied	\N	\N	\N	\N	86739	86739	86914
19768	28023	33	applied	\N	\N	1000000000	\N	87011	87011	87012
19768	28024	34	applied	\N	\N	\N	\N	87013	87013	87014
19768	28025	35	applied	\N	\N	\N	\N	87015	87015	87016
19768	28026	36	applied	\N	\N	\N	\N	87017	87017	87018
19768	27939	37	applied	\N	\N	\N	\N	86741	86741	86754
19768	27940	38	applied	\N	\N	\N	\N	86743	86743	86915
19768	27943	39	applied	\N	\N	\N	\N	86757	86757	86916
19768	27946	40	applied	\N	\N	\N	\N	86765	86765	86759
19768	27949	41	applied	\N	\N	\N	\N	86773	86773	86917
19768	27950	42	applied	\N	\N	\N	\N	86775	86775	86918
19768	27954	43	applied	\N	\N	\N	\N	86785	86785	86919
19768	27957	44	applied	\N	\N	\N	\N	86831	86831	86920
19768	27960	45	applied	\N	\N	\N	\N	86840	86840	86921
19768	27966	46	applied	\N	\N	\N	\N	86855	86855	86778
19768	27942	47	applied	\N	\N	\N	\N	86753	86753	86780
19768	27945	48	applied	\N	\N	\N	\N	86763	86763	86924
19768	27951	49	applied	\N	\N	\N	\N	86777	86777	87027
19768	27952	50	applied	\N	\N	\N	\N	86779	86779	87028
19768	28027	51	applied	\N	\N	\N	\N	87019	87019	87020
19768	27969	52	applied	\N	\N	\N	\N	86861	86861	86927
19768	27970	53	applied	\N	\N	\N	\N	86863	86863	87029
19768	27975	54	applied	\N	\N	\N	\N	86875	86875	86843
19768	27980	55	applied	\N	\N	\N	\N	86885	86885	86929
19768	27981	56	applied	\N	\N	\N	\N	86887	86887	87030
19768	27982	57	applied	\N	\N	\N	\N	86889	86889	87031
19768	27984	58	applied	\N	\N	\N	\N	86895	86895	86858
19768	27987	59	applied	\N	\N	\N	\N	86903	86903	87032
19768	27990	60	applied	\N	\N	\N	\N	86925	86925	87033
19768	27955	61	applied	\N	\N	\N	\N	86787	86787	86864
19768	27994	62	applied	\N	\N	\N	\N	86945	86945	86876
19768	27997	63	applied	\N	\N	\N	\N	86952	86952	87034
19768	27999	64	applied	\N	\N	\N	\N	86958	86958	87035
19768	28002	65	applied	\N	\N	\N	\N	86966	86966	86880
19768	28005	66	applied	\N	\N	\N	\N	86973	86973	87036
19768	28008	67	applied	\N	\N	\N	\N	86979	86979	87037
19768	28009	68	applied	\N	\N	\N	\N	86981	86981	86884
19768	28014	69	applied	\N	\N	\N	\N	86992	86992	86886
19768	28017	70	applied	\N	\N	\N	\N	86998	86998	86888
19768	28019	71	applied	\N	\N	\N	\N	87003	87003	86890
19768	27958	72	applied	\N	\N	\N	\N	86833	86833	86932
19768	27961	73	applied	\N	\N	\N	\N	86842	86842	86933
19768	27963	74	applied	\N	\N	\N	\N	86848	86848	86934
19768	27967	75	applied	\N	\N	\N	\N	86857	86857	86935
19768	27968	76	applied	\N	\N	\N	\N	86859	86859	86937
19768	27976	77	applied	\N	\N	\N	\N	86877	86877	86944
19768	27977	78	applied	\N	\N	\N	\N	86879	86879	87038
19768	27978	79	applied	\N	\N	\N	\N	86881	86881	87039
19768	27979	80	applied	\N	\N	\N	\N	86883	86883	86959
19768	27985	81	applied	\N	\N	\N	\N	86897	86897	86961
19768	27988	82	applied	\N	\N	\N	\N	86905	86905	87040
19768	27991	83	applied	\N	\N	\N	\N	86936	86936	87041
19768	27993	84	applied	\N	\N	\N	\N	86943	86943	86980
19768	27996	85	applied	\N	\N	\N	\N	86950	86950	87042
19768	28000	87	applied	\N	\N	\N	\N	86960	86960	87044
19768	28003	88	applied	\N	\N	\N	\N	86968	86968	87045
19768	28010	89	applied	\N	\N	\N	\N	86983	86983	87046
19768	28011	90	applied	\N	\N	\N	\N	86985	86985	87047
19768	28013	91	applied	\N	\N	\N	\N	86990	86990	86999
19768	28016	92	applied	\N	\N	\N	\N	86996	86996	87048
19768	28021	93	applied	\N	\N	\N	\N	87007	87007	87010
19773	28040	0	applied	\N	\N	\N	\N	87083	87083	87084
19773	28041	1	applied	\N	\N	\N	\N	87085	87085	87086
19773	28042	2	applied	\N	\N	\N	\N	87087	87087	87088
19773	28043	3	applied	\N	\N	\N	\N	87089	87089	87090
19773	28044	4	applied	\N	\N	\N	\N	87091	87091	87092
19773	28045	5	applied	\N	\N	\N	\N	87093	87093	87094
19773	28046	6	applied	\N	\N	\N	\N	87095	87095	87096
19776	28050	0	applied	\N	\N	\N	\N	87107	87107	87108
19776	28051	1	applied	\N	\N	\N	\N	87109	87109	87110
19776	28052	2	applied	\N	\N	\N	\N	87111	87111	87112
19778	28056	0	applied	\N	\N	\N	\N	87121	87121	87122
19778	28057	1	applied	\N	\N	\N	\N	87123	87123	87124
19778	28058	2	applied	\N	\N	\N	\N	87125	87125	87126
19778	28059	3	applied	\N	\N	\N	\N	87127	87127	87128
19778	28060	4	applied	\N	\N	\N	\N	87129	87129	87130
19778	28061	5	applied	\N	\N	\N	\N	87131	87131	87132
19778	28062	6	applied	\N	\N	\N	\N	87133	87133	87134
19781	28063	0	applied	\N	\N	\N	\N	87138	87138	87139
19781	28064	1	applied	\N	\N	\N	\N	87140	87140	87141
19781	28065	2	applied	\N	\N	\N	\N	87142	87142	87143
19781	28066	3	applied	\N	\N	\N	\N	87144	87144	87145
19781	28067	4	applied	\N	\N	\N	\N	87146	87146	87147
19781	28068	5	applied	\N	\N	\N	\N	87148	87148	87149
19781	28069	6	applied	\N	\N	\N	\N	87150	87150	87151
19781	28070	7	applied	\N	\N	\N	\N	87152	87152	87153
19781	28071	8	applied	\N	\N	\N	\N	87154	87154	87155
19783	28072	0	applied	\N	\N	\N	\N	87157	87157	87158
19783	28073	1	applied	\N	\N	\N	\N	87159	87159	87160
19783	28074	2	applied	\N	\N	\N	\N	87161	87161	87162
19786	28082	0	applied	\N	\N	\N	\N	87182	87182	87183
19786	28083	1	applied	\N	\N	\N	\N	87184	87184	87185
19786	28084	2	applied	\N	\N	\N	\N	87186	87186	87187
19786	28085	3	applied	\N	\N	1000000000	\N	87188	87188	87189
19786	28086	4	applied	\N	\N	\N	\N	87190	87190	87191
19786	28087	5	applied	\N	\N	\N	\N	87192	87192	87193
19786	28088	6	applied	\N	\N	\N	\N	87194	87194	87195
19791	28096	0	applied	\N	\N	\N	\N	87218	87218	87219
19791	28097	1	applied	\N	\N	\N	\N	87220	87220	87221
19791	28098	2	applied	\N	\N	\N	\N	87222	87222	87223
19794	28103	0	applied	\N	\N	\N	\N	87238	87238	87239
19794	28104	1	applied	\N	\N	\N	\N	87240	87240	87241
19794	28105	2	applied	\N	\N	\N	\N	87244	87244	87245
19798	28109	0	applied	\N	\N	\N	\N	87258	87258	87259
19798	28110	1	applied	\N	\N	\N	\N	87260	87260	87261
19798	28111	2	applied	\N	\N	\N	\N	87262	87262	87263
19798	28112	3	applied	\N	\N	\N	\N	87264	87264	87265
19798	28113	4	applied	\N	\N	\N	\N	87266	87266	87267
19798	28114	5	applied	\N	\N	\N	\N	87268	87268	87269
19798	28115	6	applied	\N	\N	\N	\N	87270	87270	87271
19798	28116	7	applied	\N	\N	\N	\N	87272	87272	87273
19800	28109	0	applied	\N	\N	\N	\N	87258	87258	87259
19800	28110	1	applied	\N	\N	\N	\N	87260	87260	87261
19800	28111	2	applied	\N	\N	\N	\N	87262	87262	87263
19800	28112	3	applied	\N	\N	\N	\N	87264	87264	87265
19800	28113	4	applied	\N	\N	\N	\N	87266	87266	87267
19800	28114	5	applied	\N	\N	\N	\N	87268	87268	87269
19800	28115	6	applied	\N	\N	\N	\N	87270	87270	87271
19800	28116	7	applied	\N	\N	\N	\N	87272	87272	87273
19804	28121	0	applied	\N	\N	\N	\N	87290	87290	87291
19804	28122	1	applied	\N	\N	\N	\N	87292	87292	87293
19804	28123	2	applied	\N	\N	\N	\N	87294	87294	87295
19804	28124	3	applied	\N	\N	\N	\N	87296	87296	87297
19804	28125	4	applied	\N	\N	\N	\N	87298	87298	87299
19804	28126	5	applied	\N	\N	\N	\N	87300	87300	87301
19804	28127	6	applied	\N	\N	\N	\N	87302	87302	87303
19804	28128	7	applied	\N	\N	\N	\N	87304	87304	87305
19804	28129	8	applied	\N	\N	\N	\N	87306	87306	87307
19804	28130	9	applied	\N	\N	\N	\N	87308	87308	87309
19806	28134	0	applied	\N	\N	\N	\N	87322	87322	87323
19806	28135	1	applied	\N	\N	\N	\N	87324	87324	87325
19806	28136	2	applied	\N	\N	\N	\N	87326	87326	87327
19806	28137	3	applied	\N	\N	\N	\N	87328	87328	87329
19807	28138	0	applied	\N	\N	\N	\N	87332	87332	87333
19807	28139	1	applied	\N	\N	\N	\N	87334	87334	87335
19807	28140	2	applied	\N	\N	\N	\N	87336	87336	87337
19811	28141	0	applied	\N	\N	\N	\N	87343	87343	87344
19812	28142	0	applied	\N	\N	\N	\N	87347	87347	87348
19812	28143	1	applied	\N	\N	\N	\N	87349	87349	87350
19813	28144	0	applied	\N	\N	\N	\N	87353	87353	87354
19813	28145	1	applied	\N	\N	\N	\N	87355	87355	87356
19816	28153	0	applied	\N	\N	\N	\N	87376	87376	87377
19816	28154	1	applied	\N	\N	\N	\N	87378	87378	87379
19816	28155	2	applied	\N	\N	\N	\N	87380	87380	87381
19816	28156	3	applied	\N	\N	\N	\N	87382	87382	87383
19816	28157	4	applied	\N	\N	\N	\N	87384	87384	87385
19821	28109	0	applied	\N	\N	\N	\N	87258	87258	87259
19821	28110	1	applied	\N	\N	\N	\N	87260	87260	87261
19821	28111	2	applied	\N	\N	\N	\N	87262	87262	87263
19821	28112	3	applied	\N	\N	\N	\N	87264	87264	87265
19821	28085	4	applied	\N	\N	1000000000	\N	87188	87188	87189
19826	28180	0	applied	\N	\N	\N	\N	87444	87444	87445
19826	28181	1	applied	\N	\N	\N	\N	87446	87446	87447
19829	28182	0	applied	\N	\N	\N	\N	87452	87452	87453
19829	28183	1	applied	\N	\N	\N	\N	87454	87454	87455
19829	28184	2	applied	\N	\N	\N	\N	87456	87456	87457
19835	28191	0	applied	\N	\N	\N	\N	87484	87484	87485
19835	28192	1	applied	\N	\N	\N	\N	87486	87486	87487
19835	28193	2	applied	\N	\N	\N	\N	87488	87488	87489
19835	28194	3	applied	\N	\N	\N	\N	87490	87490	87491
19838	28198	0	applied	\N	\N	\N	\N	87502	87502	87503
19838	28199	1	applied	\N	\N	\N	\N	87504	87504	87505
19838	28200	2	applied	\N	\N	\N	\N	87506	87506	87507
19840	28204	0	applied	\N	\N	\N	\N	87518	87518	87519
19840	28205	1	applied	\N	\N	\N	\N	87520	87520	87521
19840	28206	2	applied	\N	\N	\N	\N	87522	87522	87523
19840	28207	3	applied	\N	\N	\N	\N	87524	87524	87525
19842	28208	0	applied	\N	\N	\N	\N	87530	87530	87531
19842	28209	1	applied	\N	\N	\N	\N	87532	87532	87533
19842	28210	2	applied	\N	\N	\N	\N	87534	87534	87535
19851	28227	0	applied	\N	\N	\N	\N	87581	87581	87582
19851	28228	1	applied	\N	\N	\N	\N	87583	87583	75393
19851	28229	2	applied	\N	\N	\N	\N	87584	87584	87585
19851	28230	3	applied	\N	\N	\N	\N	87586	87586	87587
19851	28231	4	applied	\N	\N	\N	\N	87588	87588	87589
19857	28233	0	applied	\N	\N	\N	\N	87601	87601	87602
19857	28234	1	applied	\N	\N	\N	\N	87603	87603	87604
19857	28235	2	applied	\N	\N	\N	\N	87605	87605	87606
19857	28236	3	applied	\N	\N	1000000000	\N	87607	87607	87608
19857	28237	4	applied	\N	\N	\N	\N	87609	87609	87610
19857	28238	5	applied	\N	\N	\N	\N	87611	87611	87612
19860	28248	0	applied	\N	\N	\N	\N	87638	87638	87639
19860	28249	1	applied	\N	\N	\N	\N	87640	87640	87641
19860	28250	2	applied	\N	\N	\N	\N	87642	87642	87643
19860	28251	4	applied	\N	\N	\N	\N	87645	87645	87646
19860	28252	5	applied	\N	\N	\N	\N	87647	87647	87648
19864	28253	0	applied	\N	\N	\N	\N	87658	87658	87659
19864	28254	1	applied	\N	\N	\N	\N	87660	87660	87661
19864	28255	2	applied	\N	\N	\N	\N	87662	87662	87663
19871	28280	0	applied	\N	\N	\N	\N	87720	87720	87721
19871	28281	1	applied	\N	\N	\N	\N	87722	87722	87723
19871	28282	2	applied	\N	\N	\N	\N	87724	87724	87725
19872	28283	0	applied	\N	\N	\N	\N	87731	87731	87732
19872	28284	1	applied	\N	\N	\N	\N	87733	87733	87734
19872	28285	2	applied	\N	\N	\N	\N	87735	87735	87736
19875	28239	0	applied	\N	\N	\N	\N	87617	87617	28166
19875	28257	1	applied	\N	\N	\N	\N	87667	87667	87668
19875	28262	2	applied	\N	\N	\N	\N	87680	87680	87681
19875	28228	3	applied	\N	\N	\N	\N	87583	87583	75393
19875	28245	4	applied	\N	\N	\N	\N	87630	87630	87631
19875	28246	5	applied	\N	\N	\N	\N	87632	87632	87633
19875	28249	6	applied	\N	\N	\N	\N	87640	87640	87641
19875	28290	7	applied	\N	\N	\N	\N	87751	87751	87677
19875	28291	8	applied	\N	\N	\N	\N	87752	87752	87679
19875	28220	9	applied	\N	\N	\N	\N	87563	87563	87564
19875	28224	10	applied	\N	\N	1000000000	\N	87571	87571	87572
19875	28236	11	applied	\N	\N	1000000000	\N	87607	87607	87608
19875	28225	12	applied	\N	\N	\N	\N	87573	87573	87574
19875	28229	13	applied	\N	\N	\N	\N	87584	87584	87585
19875	28237	14	applied	\N	\N	\N	\N	87609	87609	87610
19875	28238	15	applied	\N	\N	\N	\N	87611	87611	87612
19886	28314	0	applied	\N	\N	\N	\N	87824	87824	87825
19886	28316	1	applied	\N	\N	\N	\N	87830	87830	87831
19886	28315	2	applied	\N	\N	\N	\N	87826	87826	87832
19891	28327	0	applied	\N	\N	\N	\N	87857	87857	87858
19891	28328	1	applied	\N	\N	\N	\N	87859	87859	87860
19891	28329	2	applied	\N	\N	\N	\N	87861	87861	87862
19891	28330	3	applied	\N	\N	\N	\N	87863	87863	87864
19891	28331	4	applied	\N	\N	\N	\N	87865	87865	87866
19891	28332	5	applied	\N	\N	\N	\N	87867	87867	87868
19891	28333	6	applied	\N	\N	\N	\N	87869	87869	87870
19891	28334	7	applied	\N	\N	\N	\N	87871	87871	87872
19891	28335	8	applied	\N	\N	\N	\N	87873	87873	87874
19891	28336	9	applied	\N	\N	\N	\N	87875	87875	87876
19891	28337	10	applied	\N	\N	\N	\N	87877	87877	87878
19894	28338	0	applied	\N	\N	\N	\N	87883	87883	87884
19894	28339	1	applied	\N	\N	\N	\N	87885	87885	87886
19894	28340	2	applied	\N	\N	\N	\N	87887	87887	87888
19894	28341	3	applied	\N	\N	\N	\N	87889	87889	87890
19897	28342	0	applied	\N	\N	\N	\N	87901	87901	87902
19897	28343	1	applied	\N	\N	\N	\N	87903	87903	87904
19897	28344	2	applied	\N	\N	1000000000	\N	87905	87905	87906
19897	28345	3	applied	\N	\N	\N	\N	87907	87907	87908
19900	28342	0	applied	\N	\N	\N	\N	87901	87901	87902
19847	27750	18	applied	\N	\N	\N	\N	86582	86582	86087
19847	27751	19	applied	\N	\N	\N	\N	86583	86583	86089
19847	27752	20	applied	\N	\N	\N	\N	86584	86584	86091
19847	27753	21	applied	\N	\N	\N	\N	86585	86585	86093
19847	27754	22	applied	\N	\N	\N	\N	86586	86586	86095
19847	27755	23	applied	\N	\N	\N	\N	86587	86587	86097
19847	27760	24	applied	\N	\N	\N	\N	86588	86588	86114
19849	28221	0	applied	\N	\N	\N	\N	87565	87565	87566
19849	28222	1	applied	\N	\N	\N	\N	87567	87567	87568
19849	28223	2	applied	\N	\N	\N	\N	87569	87569	87570
19849	28224	3	applied	\N	\N	1000000000	\N	87571	87571	87572
19849	28225	4	applied	\N	\N	\N	\N	87573	87573	87574
19849	28226	5	applied	\N	\N	\N	\N	87575	87575	87576
19852	28227	0	applied	\N	\N	\N	\N	87581	87581	87582
19852	28228	1	applied	\N	\N	\N	\N	87583	87583	75393
19852	28232	2	applied	\N	\N	\N	\N	87592	87592	87589
19852	28229	3	applied	\N	\N	\N	\N	87584	87584	87585
19852	28230	4	applied	\N	\N	\N	\N	87586	87586	87593
19852	28231	5	applied	\N	\N	\N	\N	87588	87588	87594
19858	28239	0	applied	\N	\N	\N	\N	87617	87617	28166
19858	28240	1	applied	\N	\N	\N	\N	87618	87618	87619
19858	28241	2	applied	\N	\N	\N	\N	87620	87620	87621
19858	28242	3	applied	\N	\N	\N	\N	87622	87622	87623
19861	28248	0	applied	\N	\N	\N	\N	87638	87638	87639
19861	28249	1	applied	\N	\N	\N	\N	87640	87640	87641
19861	28250	2	applied	\N	\N	\N	\N	87642	87642	87643
19861	28251	4	applied	\N	\N	\N	\N	87645	87645	87646
19861	28252	5	applied	\N	\N	\N	\N	87647	87647	87648
19865	28256	0	applied	\N	\N	\N	\N	87665	87665	87666
19865	28257	1	applied	\N	\N	\N	\N	87667	87667	87668
19865	28258	2	applied	\N	\N	\N	\N	87669	87669	87670
19865	28259	3	applied	\N	\N	\N	\N	87671	87671	87672
19866	28260	0	applied	\N	\N	\N	\N	87676	87676	87677
19866	28261	1	applied	\N	\N	\N	\N	87678	87678	87679
19866	28262	2	applied	\N	\N	\N	\N	87680	87680	87681
19866	28263	3	applied	\N	\N	\N	\N	87682	87682	87683
19866	28264	4	applied	\N	\N	\N	\N	87684	87684	87685
19866	28265	5	applied	\N	\N	\N	\N	87686	87686	87687
19866	28266	6	applied	\N	\N	\N	\N	87688	87688	87689
19866	28267	7	applied	\N	\N	\N	\N	87690	87690	87691
19866	28268	8	applied	\N	\N	\N	\N	87692	87692	87693
19866	28269	9	applied	\N	\N	\N	\N	87694	87694	87695
19866	28270	10	applied	\N	\N	\N	\N	87696	87696	87697
19866	28271	11	applied	\N	\N	\N	\N	87698	87698	87699
19866	28272	12	applied	\N	\N	\N	\N	87700	87700	87701
19866	28273	13	applied	\N	\N	\N	\N	87702	87702	87703
19866	28274	14	applied	\N	\N	\N	\N	87704	87704	87705
19866	28275	15	applied	\N	\N	\N	\N	87706	87706	87707
19866	28276	16	applied	\N	\N	\N	\N	87708	87708	87709
19866	28277	17	applied	\N	\N	\N	\N	87710	87710	87711
19866	28278	18	applied	\N	\N	\N	\N	87712	87712	87713
19866	28279	19	applied	\N	\N	\N	\N	87714	87714	87715
19876	28286	0	applied	\N	\N	\N	\N	87741	87741	87742
19876	28287	1	applied	\N	\N	\N	\N	87743	87743	87744
19876	28288	2	applied	\N	\N	\N	\N	87745	87745	87746
19876	28289	3	applied	\N	\N	\N	\N	87747	87747	87748
19877	28292	0	applied	\N	\N	\N	\N	87756	87756	87757
19877	28293	1	applied	\N	\N	\N	\N	87758	87758	87759
19880	28239	0	applied	\N	\N	\N	\N	87617	87617	28166
19880	28109	1	applied	\N	\N	\N	\N	87258	87258	87259
19880	28110	2	applied	\N	\N	\N	\N	87260	87260	87261
19880	28111	3	applied	\N	\N	\N	\N	87262	87262	87263
19880	28112	4	applied	\N	\N	\N	\N	87264	87264	87265
19880	28228	5	applied	\N	\N	\N	\N	87583	87583	75393
19880	28245	6	applied	\N	\N	\N	\N	87786	87786	87631
19880	28020	7	applied	\N	\N	1000000000	\N	87005	87005	87006
19880	28022	8	applied	\N	\N	\N	\N	87009	87009	86919
19880	28246	9	applied	\N	\N	\N	\N	87787	87787	87633
19880	28249	10	applied	\N	\N	\N	\N	87788	87788	87641
19880	28290	11	applied	\N	\N	\N	\N	87789	87789	87677
19880	28291	12	applied	\N	\N	\N	\N	87790	87790	87679
19880	28220	13	applied	\N	\N	\N	\N	87563	87563	87564
19880	28023	14	applied	\N	\N	1000000000	\N	87011	87011	87012
19880	28024	15	applied	\N	\N	\N	\N	87013	87013	87014
19880	28025	16	applied	\N	\N	\N	\N	87015	87015	87016
19880	28026	17	applied	\N	\N	\N	\N	87017	87017	87018
19880	28225	18	applied	\N	\N	\N	\N	87573	87573	87574
19880	28229	19	applied	\N	\N	\N	\N	87584	87584	87585
19880	28039	20	applied	\N	\N	\N	\N	87079	87079	86774
19880	28042	21	applied	\N	\N	\N	\N	87087	87087	86920
19880	28058	22	applied	\N	\N	\N	\N	87125	87125	86776
19880	28237	23	applied	\N	\N	\N	\N	87609	87609	87610
19880	28238	24	applied	\N	\N	\N	\N	87611	87611	87612
19880	28027	25	applied	\N	\N	\N	\N	87019	87019	87020
19880	28085	26	applied	\N	\N	1000000000	\N	87188	87188	87189
19880	28224	27	applied	\N	\N	1000000000	\N	87571	87571	87572
19880	28236	28	applied	\N	\N	1000000000	\N	87607	87607	87608
19880	28071	29	applied	\N	\N	\N	\N	87154	87154	86921
19880	28077	30	applied	\N	\N	\N	\N	87169	87169	87791
19880	28090	31	applied	\N	\N	\N	\N	87202	87202	86778
19880	28102	32	applied	\N	\N	\N	\N	87234	87234	87792
19880	28115	33	applied	\N	\N	\N	\N	87270	87270	86922
19880	28126	34	applied	\N	\N	\N	\N	87300	87300	86780
19880	28132	35	applied	\N	\N	\N	\N	87316	87316	86923
19880	28139	36	applied	\N	\N	\N	\N	87334	87334	86786
19880	28150	37	applied	\N	\N	\N	\N	87369	87369	86924
19880	28155	38	applied	\N	\N	\N	\N	87380	87380	87793
19880	28163	39	applied	\N	\N	\N	\N	87401	87401	86788
19880	28175	40	applied	\N	\N	\N	\N	87430	87430	87027
19880	28183	41	applied	\N	\N	\N	\N	87454	87454	86832
19880	28194	42	applied	\N	\N	\N	\N	87490	87490	86926
19880	28205	43	applied	\N	\N	\N	\N	87520	87520	87028
19880	28217	44	applied	\N	\N	\N	\N	87550	87550	86834
19880	28230	45	applied	\N	\N	\N	\N	87586	87586	86927
19880	28252	46	applied	\N	\N	\N	\N	87647	87647	86841
19880	28268	47	applied	\N	\N	\N	\N	87692	87692	87029
19880	28270	48	applied	\N	\N	\N	\N	87696	87696	86928
19880	28288	49	applied	\N	\N	\N	\N	87745	87745	86843
19880	28299	50	applied	\N	\N	\N	\N	87774	87774	87794
19883	28304	0	applied	\N	\N	\N	\N	87797	87797	87798
19883	28306	1	applied	\N	\N	\N	\N	87801	87801	87806
19887	28314	0	applied	\N	\N	\N	\N	87824	87824	87825
19887	28316	1	applied	\N	\N	\N	\N	87830	87830	87831
19887	28315	2	applied	\N	\N	\N	\N	87826	87826	87832
19888	28317	0	applied	\N	\N	\N	\N	87834	87834	87835
19888	28318	1	applied	\N	\N	\N	\N	87836	87836	87837
19888	28319	2	applied	\N	\N	\N	\N	87838	87838	87839
19895	28338	0	applied	\N	\N	\N	\N	87883	87883	87884
19895	28339	1	applied	\N	\N	\N	\N	87885	87885	87886
19854	28228	1	applied	\N	\N	\N	\N	87583	87583	75393
19854	28232	2	applied	\N	\N	\N	\N	87592	87592	87589
19854	28229	3	applied	\N	\N	\N	\N	87584	87584	87585
19854	28230	4	applied	\N	\N	\N	\N	87586	87586	87593
19854	28231	5	applied	\N	\N	\N	\N	87588	87588	87594
19859	28243	0	applied	\N	\N	\N	\N	87626	87626	87627
19859	28244	1	applied	\N	\N	\N	\N	87628	87628	87629
19859	28245	2	applied	\N	\N	\N	\N	87630	87630	87631
19859	28246	3	applied	\N	\N	\N	\N	87632	87632	87633
19859	28247	4	applied	\N	\N	\N	\N	87634	87634	87635
19863	28248	0	applied	\N	\N	\N	\N	87638	87638	87639
19863	28249	1	applied	\N	\N	\N	\N	87640	87640	87641
19863	28250	2	applied	\N	\N	\N	\N	87642	87642	87643
19863	28251	4	applied	\N	\N	\N	\N	87645	87645	87646
19863	28252	5	applied	\N	\N	\N	\N	87647	87647	87648
19868	28260	0	applied	\N	\N	\N	\N	87676	87676	87677
19868	28261	1	applied	\N	\N	\N	\N	87678	87678	87679
19868	28262	2	applied	\N	\N	\N	\N	87680	87680	87681
19868	28263	3	applied	\N	\N	\N	\N	87682	87682	87683
19868	28264	4	applied	\N	\N	\N	\N	87684	87684	87685
19868	28265	5	applied	\N	\N	\N	\N	87686	87686	87687
19868	28266	6	applied	\N	\N	\N	\N	87688	87688	87689
19868	28267	7	applied	\N	\N	\N	\N	87690	87690	87691
19868	28268	8	applied	\N	\N	\N	\N	87692	87692	87693
19868	28269	9	applied	\N	\N	\N	\N	87694	87694	87695
19868	28270	10	applied	\N	\N	\N	\N	87696	87696	87697
19868	28271	11	applied	\N	\N	\N	\N	87698	87698	87699
19868	28272	12	applied	\N	\N	\N	\N	87700	87700	87701
19868	28273	13	applied	\N	\N	\N	\N	87702	87702	87703
19868	28274	14	applied	\N	\N	\N	\N	87704	87704	87705
19868	28275	15	applied	\N	\N	\N	\N	87706	87706	87707
19868	28276	16	applied	\N	\N	\N	\N	87708	87708	87709
19868	28277	17	applied	\N	\N	\N	\N	87710	87710	87711
19868	28278	18	applied	\N	\N	\N	\N	87712	87712	87713
19868	28279	19	applied	\N	\N	\N	\N	87714	87714	87715
19870	28280	0	applied	\N	\N	\N	\N	87720	87720	87721
19870	28281	1	applied	\N	\N	\N	\N	87722	87722	87723
19870	28282	2	applied	\N	\N	\N	\N	87724	87724	87725
19874	28286	0	applied	\N	\N	\N	\N	87741	87741	87742
19874	28287	1	applied	\N	\N	\N	\N	87743	87743	87744
19874	28288	2	applied	\N	\N	\N	\N	87745	87745	87746
19874	28289	3	applied	\N	\N	\N	\N	87747	87747	87748
19879	28297	0	applied	\N	\N	\N	\N	87770	87770	87771
19879	28298	1	applied	\N	\N	\N	\N	87772	87772	87773
19879	28299	2	applied	\N	\N	\N	\N	87774	87774	87775
19879	28300	3	applied	\N	\N	\N	\N	87776	87776	87777
19879	28301	4	applied	\N	\N	\N	\N	87778	87778	87779
19879	28302	5	applied	\N	\N	\N	\N	87780	87780	87781
19879	28303	6	applied	\N	\N	\N	\N	87782	87782	87783
19885	28314	0	applied	\N	\N	\N	\N	87824	87824	87825
19885	28315	1	applied	\N	\N	\N	\N	87826	87826	87827
19890	28327	0	applied	\N	\N	\N	\N	87857	87857	87858
19890	28328	1	applied	\N	\N	\N	\N	87859	87859	87860
19890	28329	2	applied	\N	\N	\N	\N	87861	87861	87862
19890	28330	3	applied	\N	\N	\N	\N	87863	87863	87864
19890	28331	4	applied	\N	\N	\N	\N	87865	87865	87866
19890	28332	5	applied	\N	\N	\N	\N	87867	87867	87868
19890	28333	6	applied	\N	\N	\N	\N	87869	87869	87870
19890	28334	7	applied	\N	\N	\N	\N	87871	87871	87872
19890	28335	8	applied	\N	\N	\N	\N	87873	87873	87874
19890	28336	9	applied	\N	\N	\N	\N	87875	87875	87876
19890	28337	10	applied	\N	\N	\N	\N	87877	87877	87878
19893	28338	0	applied	\N	\N	\N	\N	87883	87883	87884
19893	28339	1	applied	\N	\N	\N	\N	87885	87885	87886
19893	28340	2	applied	\N	\N	\N	\N	87887	87887	87888
19893	28341	3	applied	\N	\N	\N	\N	87889	87889	87890
19901	28346	0	applied	\N	\N	\N	\N	87915	87915	87916
19901	28347	1	applied	\N	\N	\N	\N	87917	87917	87918
19901	28348	2	applied	\N	\N	\N	\N	87919	87919	87920
19901	28349	3	applied	\N	\N	\N	\N	87921	87921	87922
19901	28350	4	applied	\N	\N	\N	\N	87923	87923	87924
19901	28351	5	applied	\N	\N	\N	\N	87925	87925	87926
19901	28352	6	applied	\N	\N	\N	\N	87927	87927	87928
19904	28353	0	applied	\N	\N	\N	\N	87931	87931	87932
19904	28354	1	applied	\N	\N	\N	\N	87933	87933	87934
19904	28355	2	applied	\N	\N	\N	\N	87935	87935	87936
19907	28356	0	applied	\N	\N	\N	\N	87941	87941	87942
19907	28357	1	applied	\N	\N	\N	\N	87943	87943	87944
19907	28358	2	applied	\N	\N	\N	\N	87945	87945	87946
19907	28359	3	applied	\N	\N	\N	\N	87947	87947	87948
19907	28360	4	applied	\N	\N	\N	\N	87949	87949	87950
19907	28361	5	applied	\N	\N	\N	\N	87951	87951	87952
19907	28362	6	applied	\N	\N	\N	\N	87953	87953	87954
19907	28363	7	applied	\N	\N	\N	\N	87955	87955	87956
19907	28364	8	applied	\N	\N	\N	\N	87957	87957	87958
19907	28365	9	applied	\N	\N	\N	\N	87959	87959	87960
19909	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19909	28367	1	applied	\N	\N	\N	\N	87966	87966	87967
19909	28368	2	applied	\N	\N	\N	\N	87968	87968	87969
19909	28369	3	applied	\N	\N	\N	\N	87970	87970	87971
19913	28376	0	applied	\N	\N	\N	\N	87992	87992	87993
19913	28377	1	applied	\N	\N	\N	\N	87994	87994	87995
19913	28378	2	applied	\N	\N	\N	\N	87996	87996	87997
19913	28379	3	applied	\N	\N	\N	\N	87998	87998	87999
19915	28380	0	applied	\N	\N	\N	\N	88003	88003	88004
19915	28381	1	applied	\N	\N	\N	\N	88005	88005	88006
19915	28382	2	applied	\N	\N	\N	\N	88007	88007	88008
19918	28393	0	applied	\N	\N	\N	\N	88032	88032	88033
19918	28394	1	applied	\N	\N	\N	\N	88034	88034	88035
19918	28395	2	applied	\N	\N	\N	\N	88036	88036	88037
19918	28396	3	applied	\N	\N	\N	\N	88038	88038	88039
19918	28397	4	applied	\N	\N	\N	\N	88040	88040	88041
19918	28398	5	applied	\N	\N	\N	\N	88042	88042	88043
19918	28399	6	applied	\N	\N	\N	\N	88044	88044	88045
19921	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19921	28370	1	applied	\N	\N	\N	\N	87977	87977	87978
19921	28371	2	applied	\N	\N	\N	\N	87979	87979	87980
19921	28376	3	applied	\N	\N	\N	\N	87992	87992	87993
19921	28404	4	applied	\N	\N	\N	\N	88058	88058	88059
19921	28383	5	applied	\N	\N	\N	\N	88009	88009	88010
19921	28328	6	applied	\N	\N	\N	\N	87859	87859	87860
19921	28329	7	applied	\N	\N	\N	\N	87861	87861	87862
19921	28330	8	applied	\N	\N	\N	\N	87863	87863	87864
19921	28389	9	applied	\N	\N	\N	\N	88023	88023	88024
19921	28390	10	applied	\N	\N	\N	\N	88025	88025	88026
19921	28393	11	applied	\N	\N	\N	\N	88032	88032	88033
19921	28332	12	applied	\N	\N	\N	\N	87867	87867	87868
19921	28339	13	applied	\N	\N	\N	\N	87885	87885	87886
19921	28344	14	applied	\N	\N	1000000000	\N	88060	88060	87906
19925	28406	0	applied	\N	\N	\N	\N	88069	88069	88070
19867	28271	11	applied	\N	\N	\N	\N	87698	87698	87699
19867	28272	12	applied	\N	\N	\N	\N	87700	87700	87701
19867	28273	13	applied	\N	\N	\N	\N	87702	87702	87703
19867	28274	14	applied	\N	\N	\N	\N	87704	87704	87705
19867	28275	15	applied	\N	\N	\N	\N	87706	87706	87707
19867	28276	16	applied	\N	\N	\N	\N	87708	87708	87709
19867	28277	17	applied	\N	\N	\N	\N	87710	87710	87711
19867	28278	18	applied	\N	\N	\N	\N	87712	87712	87713
19867	28279	19	applied	\N	\N	\N	\N	87714	87714	87715
19869	28280	0	applied	\N	\N	\N	\N	87720	87720	87721
19869	28281	1	applied	\N	\N	\N	\N	87722	87722	87723
19869	28282	2	applied	\N	\N	\N	\N	87724	87724	87725
19873	28283	0	applied	\N	\N	\N	\N	87731	87731	87732
19873	28285	1	applied	\N	\N	\N	\N	87735	87735	87738
19878	28294	0	applied	\N	\N	\N	\N	87762	87762	87763
19878	28295	1	applied	\N	\N	\N	\N	87764	87764	87765
19878	28296	2	applied	\N	\N	\N	\N	87766	87766	87767
19881	28304	0	applied	\N	\N	\N	\N	87797	87797	87798
19881	28305	1	applied	\N	\N	\N	\N	87799	87799	87800
19881	28306	2	applied	\N	\N	\N	\N	87801	87801	87802
19882	28304	0	applied	\N	\N	\N	\N	87797	87797	87798
19882	28305	1	applied	\N	\N	\N	\N	87799	87799	87800
19882	28306	2	applied	\N	\N	\N	\N	87801	87801	87802
19884	28307	0	applied	\N	\N	\N	\N	87808	87808	87809
19884	28308	1	applied	\N	\N	\N	\N	87810	87810	87811
19884	28309	2	applied	\N	\N	\N	\N	87812	87812	87813
19884	28310	3	applied	\N	\N	\N	\N	87814	87814	87815
19884	28311	4	applied	\N	\N	\N	\N	87816	87816	87817
19884	28312	5	applied	\N	\N	\N	\N	87818	87818	87819
19884	28313	6	applied	\N	\N	\N	\N	87820	87820	87821
19889	28320	0	applied	\N	\N	\N	\N	87841	87841	87842
19889	28321	1	applied	\N	\N	\N	\N	87843	87843	87844
19889	28322	2	applied	\N	\N	\N	\N	87845	87845	87846
19889	28323	3	applied	\N	\N	\N	\N	87847	87847	87848
19889	28324	4	applied	\N	\N	\N	\N	87849	87849	87850
19889	28325	5	applied	\N	\N	\N	\N	87851	87851	87852
19889	28326	6	applied	\N	\N	\N	\N	87853	87853	87854
19892	28338	0	applied	\N	\N	\N	\N	87883	87883	87884
19892	28339	1	applied	\N	\N	\N	\N	87885	87885	87886
19892	28340	2	applied	\N	\N	\N	\N	87887	87887	87888
19892	28341	3	applied	\N	\N	\N	\N	87889	87889	87890
19896	28338	0	applied	\N	\N	\N	\N	87883	87883	87884
19896	28339	1	applied	\N	\N	\N	\N	87885	87885	87886
19896	28340	2	applied	\N	\N	\N	\N	87887	87887	87888
19896	28341	3	applied	\N	\N	\N	\N	87889	87889	87890
19899	28342	0	applied	\N	\N	\N	\N	87901	87901	87902
19899	28343	1	applied	\N	\N	\N	\N	87903	87903	87904
19899	28344	2	applied	\N	\N	1000000000	\N	87905	87905	87906
19899	28345	3	applied	\N	\N	\N	\N	87907	87907	87908
19903	28353	0	applied	\N	\N	\N	\N	87931	87931	87932
19903	28354	1	applied	\N	\N	\N	\N	87933	87933	87934
19903	28355	2	applied	\N	\N	\N	\N	87935	87935	87936
19906	28356	0	applied	\N	\N	\N	\N	87941	87941	87942
19906	28357	1	applied	\N	\N	\N	\N	87943	87943	87944
19906	28358	2	applied	\N	\N	\N	\N	87945	87945	87946
19906	28359	3	applied	\N	\N	\N	\N	87947	87947	87948
19906	28360	4	applied	\N	\N	\N	\N	87949	87949	87950
19906	28361	5	applied	\N	\N	\N	\N	87951	87951	87952
19906	28362	6	applied	\N	\N	\N	\N	87953	87953	87954
19906	28363	7	applied	\N	\N	\N	\N	87955	87955	87956
19906	28364	8	applied	\N	\N	\N	\N	87957	87957	87958
19906	28365	9	applied	\N	\N	\N	\N	87959	87959	87960
19908	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19908	28367	1	applied	\N	\N	\N	\N	87966	87966	87967
19908	28368	2	applied	\N	\N	\N	\N	87968	87968	87969
19908	28369	3	applied	\N	\N	\N	\N	87970	87970	87971
19917	28388	0	applied	\N	\N	\N	\N	88021	88021	88022
19917	28389	1	applied	\N	\N	\N	\N	88023	88023	88024
19917	28390	2	applied	\N	\N	\N	\N	88025	88025	88026
19917	28391	3	applied	\N	\N	\N	\N	88027	88027	88028
19917	28392	4	applied	\N	\N	\N	\N	88029	88029	88030
19920	28400	0	applied	\N	\N	\N	\N	88048	88048	88049
19920	28401	1	applied	\N	\N	\N	\N	88050	88050	88051
19920	28402	2	applied	\N	\N	\N	\N	88052	88052	88053
19920	28403	3	applied	\N	\N	\N	\N	88054	88054	88055
19932	28413	0	applied	\N	\N	\N	\N	88085	88085	88086
19932	28416	1	applied	\N	\N	\N	\N	88095	88095	88096
19932	28417	2	applied	\N	\N	\N	\N	88097	88097	88098
19932	28414	3	applied	\N	\N	\N	\N	88087	88087	88099
19932	28418	4	applied	\N	\N	\N	\N	88100	88100	88101
19934	28419	0	applied	\N	\N	\N	\N	88106	88106	88107
19934	28420	1	applied	\N	\N	\N	\N	88108	88108	88109
19934	28421	2	applied	\N	\N	\N	\N	88110	88110	88111
19934	28422	3	applied	\N	\N	\N	\N	88112	88112	88113
19936	28423	0	applied	\N	\N	\N	\N	88118	88118	88119
19936	28424	1	applied	\N	\N	\N	\N	88120	88120	88121
19938	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19938	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19938	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19942	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19942	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19942	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19944	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19944	28239	1	applied	\N	\N	\N	\N	87617	87617	28166
19944	28109	2	applied	\N	\N	\N	\N	87258	87258	87259
19944	28110	3	applied	\N	\N	\N	\N	87260	87260	87261
19944	28111	4	applied	\N	\N	\N	\N	87262	87262	87263
19944	28112	5	applied	\N	\N	\N	\N	87264	87264	87265
19944	28370	6	applied	\N	\N	\N	\N	87977	87977	87978
19944	28371	7	applied	\N	\N	\N	\N	87979	87979	87980
19944	28376	8	applied	\N	\N	\N	\N	87992	87992	87993
19944	28404	9	applied	\N	\N	\N	\N	88058	88058	88059
19944	28383	10	applied	\N	\N	\N	\N	88009	88009	88010
19944	28328	11	applied	\N	\N	\N	\N	88143	88143	87860
19944	28329	12	applied	\N	\N	\N	\N	88144	88144	87862
19944	27992	13	applied	\N	\N	\N	\N	86941	86941	86942
19944	28330	14	applied	\N	\N	\N	\N	88145	88145	87864
19944	27995	15	applied	\N	\N	\N	\N	86948	86948	86949
19944	27998	16	applied	\N	\N	\N	\N	86956	86956	86957
19944	28001	17	applied	\N	\N	\N	\N	86964	86964	86965
19944	28004	18	applied	\N	\N	\N	\N	86971	86971	86972
19944	28389	19	applied	\N	\N	\N	\N	88023	88023	88024
19944	28390	20	applied	\N	\N	\N	\N	88025	88025	88026
19944	28393	21	applied	\N	\N	\N	\N	88032	88032	88033
19944	28006	22	applied	\N	\N	\N	\N	86975	86975	86976
19944	28007	23	applied	\N	\N	\N	\N	86977	86977	86978
19944	28012	24	applied	\N	\N	\N	\N	86988	86988	86989
19944	28015	25	applied	\N	\N	\N	\N	86994	86994	86995
19944	28018	26	applied	\N	\N	\N	\N	87001	87001	87002
19944	28028	27	applied	\N	\N	\N	\N	87051	87051	87052
19895	28340	2	applied	\N	\N	\N	\N	87887	87887	87888
19895	28341	3	applied	\N	\N	\N	\N	87889	87889	87890
19898	28342	0	applied	\N	\N	\N	\N	87901	87901	87902
19898	28343	1	applied	\N	\N	\N	\N	87903	87903	87904
19898	28344	2	applied	\N	\N	1000000000	\N	87905	87905	87906
19898	28345	3	applied	\N	\N	\N	\N	87907	87907	87908
19905	28356	0	applied	\N	\N	\N	\N	87941	87941	87942
19905	28357	1	applied	\N	\N	\N	\N	87943	87943	87944
19905	28358	2	applied	\N	\N	\N	\N	87945	87945	87946
19905	28359	3	applied	\N	\N	\N	\N	87947	87947	87948
19905	28360	4	applied	\N	\N	\N	\N	87949	87949	87950
19905	28361	5	applied	\N	\N	\N	\N	87951	87951	87952
19905	28362	6	applied	\N	\N	\N	\N	87953	87953	87954
19905	28363	7	applied	\N	\N	\N	\N	87955	87955	87956
19905	28364	8	applied	\N	\N	\N	\N	87957	87957	87958
19905	28365	9	applied	\N	\N	\N	\N	87959	87959	87960
19912	28370	0	applied	\N	\N	\N	\N	87977	87977	87978
19912	28371	1	applied	\N	\N	\N	\N	87979	87979	87980
19912	28372	2	applied	\N	\N	\N	\N	87981	87981	87982
19912	28373	3	applied	\N	\N	\N	\N	87983	87983	87984
19912	28374	4	applied	\N	\N	\N	\N	87985	87985	87986
19912	28375	5	applied	\N	\N	\N	\N	87987	87987	87988
19914	28376	0	applied	\N	\N	\N	\N	87992	87992	87993
19914	28377	1	applied	\N	\N	\N	\N	87994	87994	87995
19914	28378	2	applied	\N	\N	\N	\N	87996	87996	87997
19914	28379	3	applied	\N	\N	\N	\N	87998	87998	87999
19922	28400	0	applied	\N	\N	\N	\N	88048	88048	88049
19922	28401	1	applied	\N	\N	\N	\N	88050	88050	88051
19922	28402	2	applied	\N	\N	\N	\N	88052	88052	88053
19922	28403	3	applied	\N	\N	\N	\N	88054	88054	88055
19924	28405	0	applied	\N	\N	\N	\N	88064	88064	88065
19929	28415	0	applied	\N	\N	\N	\N	88089	88089	88093
19931	28413	0	applied	\N	\N	\N	\N	88085	88085	88086
19931	28416	1	applied	\N	\N	\N	\N	88095	88095	88096
19931	28417	2	applied	\N	\N	\N	\N	88097	88097	88098
19931	28414	3	applied	\N	\N	\N	\N	88087	88087	88099
19931	28418	4	applied	\N	\N	\N	\N	88100	88100	88101
19933	28419	0	applied	\N	\N	\N	\N	88106	88106	88107
19933	28420	1	applied	\N	\N	\N	\N	88108	88108	88109
19933	28421	2	applied	\N	\N	\N	\N	88110	88110	88111
19933	28422	3	applied	\N	\N	\N	\N	88112	88112	88113
19935	28423	0	applied	\N	\N	\N	\N	88118	88118	88119
19935	28424	1	applied	\N	\N	\N	\N	88120	88120	88121
19941	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19941	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19941	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19945	28428	0	applied	\N	\N	\N	\N	88195	88195	88196
19945	28429	1	applied	\N	\N	\N	\N	88197	88197	88198
19945	28430	2	applied	\N	\N	\N	\N	88199	88199	88200
19945	28431	3	applied	\N	\N	\N	\N	88201	88201	88202
19945	28432	4	applied	\N	\N	\N	\N	88203	88203	88204
19945	28433	5	applied	\N	\N	\N	\N	88205	88205	88206
19945	28434	6	applied	\N	\N	\N	\N	88207	88207	88208
19951	28460	0	applied	\N	\N	\N	\N	88265	88265	88266
19951	28461	1	applied	\N	\N	\N	\N	88267	88267	88268
19951	28462	2	applied	\N	\N	\N	\N	88269	88269	88270
19957	28489	0	applied	\N	\N	\N	\N	88339	88339	88340
19957	28490	1	applied	\N	\N	\N	\N	88341	88341	88342
19957	28491	2	applied	\N	\N	\N	\N	88343	88343	88344
19957	28492	3	applied	\N	\N	\N	\N	88345	88345	88346
19959	28493	0	applied	\N	\N	\N	\N	88366	88366	88367
19959	28494	1	applied	\N	\N	\N	\N	88368	88368	88369
19959	28495	2	applied	\N	\N	\N	\N	88370	88370	88371
19964	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19964	28370	1	applied	\N	\N	\N	\N	87977	87977	87978
19964	28371	2	applied	\N	\N	\N	\N	87979	87979	87980
19964	28376	3	applied	\N	\N	\N	\N	87992	87992	87993
19964	28404	4	applied	\N	\N	\N	\N	88058	88058	88059
19964	28383	5	applied	\N	\N	\N	\N	88009	88009	88010
19964	28328	6	applied	\N	\N	\N	\N	87859	87859	87860
19964	28329	7	applied	\N	\N	\N	\N	87861	87861	87862
19964	28330	8	applied	\N	\N	\N	\N	87863	87863	87864
19964	28447	9	applied	\N	\N	\N	\N	88236	88236	88237
19969	28519	0	applied	\N	\N	\N	\N	88437	88437	88438
19969	28520	1	applied	\N	\N	\N	\N	88439	88439	88440
19969	28521	2	applied	\N	\N	\N	\N	88441	88441	88442
19972	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19972	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19972	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19972	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19972	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19972	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19972	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19975	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19975	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19975	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19975	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19975	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19975	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19975	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19979	28529	0	applied	\N	\N	\N	\N	88470	88470	88471
19979	28530	1	applied	\N	\N	\N	\N	88472	88472	88473
19979	28531	2	applied	\N	\N	\N	\N	88474	88474	88475
19979	28532	3	applied	\N	\N	\N	\N	88476	88476	88477
19979	28533	4	applied	\N	\N	\N	\N	88478	88478	88479
19979	28534	5	applied	\N	\N	\N	\N	88480	88480	88481
19979	28535	6	applied	\N	\N	\N	\N	88482	88482	88483
19979	28536	7	applied	\N	\N	\N	\N	88484	88484	88485
19979	28537	8	applied	\N	\N	\N	\N	88486	88486	88487
19981	28544	0	applied	\N	\N	\N	\N	88504	88504	88505
19981	28545	1	applied	\N	\N	1000000000	\N	88506	88506	88507
19981	28546	2	applied	\N	\N	\N	\N	88508	88508	88509
19981	28547	3	applied	\N	\N	\N	\N	88510	88510	88511
19981	28548	4	applied	\N	\N	\N	\N	88512	88512	88513
19981	28549	5	applied	\N	\N	\N	\N	88514	88514	88515
19990	28562	0	applied	\N	\N	\N	\N	88552	88552	88553
19990	28563	1	applied	\N	\N	\N	\N	88554	88554	88555
19990	28564	2	applied	\N	\N	\N	\N	88556	88556	88557
19991	28565	0	applied	\N	\N	\N	\N	88560	88560	88561
19991	28566	1	applied	\N	\N	\N	\N	88562	88562	88563
19991	28567	2	applied	\N	\N	\N	\N	88564	88564	88565
19991	28568	3	applied	\N	\N	\N	\N	88566	88566	88567
19991	28569	4	applied	\N	\N	\N	\N	88568	88568	88569
19991	28570	5	applied	\N	\N	\N	\N	88570	88570	88539
19991	28571	6	applied	\N	\N	\N	\N	88571	88571	88572
19991	28572	7	applied	\N	\N	\N	\N	88573	88573	88574
19991	28573	8	applied	\N	\N	\N	\N	88575	88575	88576
19991	28574	9	applied	\N	\N	\N	\N	88577	88577	88578
19991	28575	10	applied	\N	\N	\N	\N	88579	88579	88580
19900	28343	1	applied	\N	\N	\N	\N	87903	87903	87904
19900	28344	2	applied	\N	\N	1000000000	\N	87905	87905	87906
19900	28345	3	applied	\N	\N	\N	\N	87907	87907	87908
19902	28346	0	applied	\N	\N	\N	\N	87915	87915	87916
19902	28347	1	applied	\N	\N	\N	\N	87917	87917	87918
19902	28348	2	applied	\N	\N	\N	\N	87919	87919	87920
19902	28349	3	applied	\N	\N	\N	\N	87921	87921	87922
19902	28350	4	applied	\N	\N	\N	\N	87923	87923	87924
19902	28351	5	applied	\N	\N	\N	\N	87925	87925	87926
19902	28352	6	applied	\N	\N	\N	\N	87927	87927	87928
19910	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19910	28367	1	applied	\N	\N	\N	\N	87966	87966	87967
19910	28368	2	applied	\N	\N	\N	\N	87968	87968	87969
19910	28369	3	applied	\N	\N	\N	\N	87970	87970	87971
19911	28370	0	applied	\N	\N	\N	\N	87977	87977	87978
19911	28371	1	applied	\N	\N	\N	\N	87979	87979	87980
19911	28372	2	applied	\N	\N	\N	\N	87981	87981	87982
19911	28373	3	applied	\N	\N	\N	\N	87983	87983	87984
19911	28374	4	applied	\N	\N	\N	\N	87985	87985	87986
19911	28375	5	applied	\N	\N	\N	\N	87987	87987	87988
19916	28383	0	applied	\N	\N	\N	\N	88009	88009	88010
19916	28384	1	applied	\N	\N	\N	\N	88011	88011	88012
19916	28385	2	applied	\N	\N	\N	\N	88013	88013	88014
19916	28386	3	applied	\N	\N	\N	\N	88015	88015	88016
19916	28387	4	applied	\N	\N	\N	\N	88017	88017	88018
19919	28393	0	applied	\N	\N	\N	\N	88032	88032	88033
19919	28394	1	applied	\N	\N	\N	\N	88034	88034	88035
19919	28395	2	applied	\N	\N	\N	\N	88036	88036	88037
19919	28396	3	applied	\N	\N	\N	\N	88038	88038	88039
19919	28397	4	applied	\N	\N	\N	\N	88040	88040	88041
19919	28398	5	applied	\N	\N	\N	\N	88042	88042	88043
19919	28399	6	applied	\N	\N	\N	\N	88044	88044	88045
19923	28405	0	applied	\N	\N	\N	\N	88064	88064	88065
19926	28406	0	applied	\N	\N	\N	\N	88069	88069	88070
19926	28407	1	applied	\N	\N	\N	\N	88071	88071	88072
19926	28408	2	applied	\N	\N	\N	\N	88073	88073	88074
19928	28413	0	applied	\N	\N	\N	\N	88085	88085	88086
19928	28414	1	applied	\N	\N	\N	\N	88087	88087	88088
19928	28415	2	applied	\N	\N	\N	\N	88089	88089	88090
19930	28413	0	applied	\N	\N	\N	\N	88085	88085	88086
19930	28416	1	applied	\N	\N	\N	\N	88095	88095	88096
19930	28417	2	applied	\N	\N	\N	\N	88097	88097	88098
19930	28414	3	applied	\N	\N	\N	\N	88087	88087	88099
19930	28418	4	applied	\N	\N	\N	\N	88100	88100	88101
19940	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19940	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19940	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19947	28438	0	applied	\N	\N	\N	\N	88217	88217	88218
19947	28439	1	applied	\N	\N	\N	\N	88219	88219	88220
19947	28440	2	applied	\N	\N	\N	\N	88221	88221	88222
19947	28441	3	applied	\N	\N	\N	\N	88223	88223	88224
19947	28442	4	applied	\N	\N	\N	\N	88225	88225	88226
19947	28443	5	applied	\N	\N	\N	\N	88227	88227	88228
19947	28444	6	applied	\N	\N	\N	\N	88229	88229	88230
19948	28445	0	applied	\N	\N	\N	\N	88232	88232	88233
19948	28446	1	applied	\N	\N	\N	\N	88234	88234	88235
19948	28447	2	applied	\N	\N	\N	\N	88236	88236	88237
19948	28448	3	applied	\N	\N	\N	\N	88238	88238	88239
19948	28449	4	applied	\N	\N	\N	\N	88240	88240	88241
19948	28450	5	applied	\N	\N	\N	\N	88242	88242	88243
19948	28451	6	applied	\N	\N	\N	\N	88244	88244	88245
19948	28452	7	applied	\N	\N	\N	\N	88246	88246	88247
19948	28453	8	applied	\N	\N	\N	\N	88248	88248	88249
19948	28454	9	applied	\N	\N	\N	\N	88250	88250	88251
19948	28455	10	applied	\N	\N	\N	\N	88252	88252	88253
19948	28456	11	applied	\N	\N	\N	\N	88254	88254	88255
19948	28457	12	applied	\N	\N	\N	\N	88256	88256	88257
19948	28458	13	applied	\N	\N	\N	\N	88258	88258	88259
19948	28459	14	applied	\N	\N	\N	\N	88260	88260	88261
19950	28460	0	applied	\N	\N	\N	\N	88265	88265	88266
19950	28461	1	applied	\N	\N	\N	\N	88267	88267	88268
19950	28462	2	applied	\N	\N	\N	\N	88269	88269	88270
19953	28463	0	applied	\N	\N	\N	\N	88275	88275	88276
19953	28464	1	applied	\N	\N	\N	\N	88277	88277	88278
19953	28465	2	applied	\N	\N	\N	\N	88279	88279	88280
19953	28466	3	applied	\N	\N	\N	\N	88281	88281	88282
19953	28467	4	applied	\N	\N	\N	\N	88283	88283	88284
19953	28468	5	applied	\N	\N	\N	\N	88285	88285	88286
19953	28469	6	applied	\N	\N	\N	\N	88287	88287	88288
19953	28470	7	applied	\N	\N	\N	\N	88289	88289	88290
19953	28471	8	applied	\N	\N	\N	\N	88291	88291	88292
19953	28472	9	applied	\N	\N	\N	\N	88293	88293	88294
19954	28473	0	applied	\N	\N	\N	\N	88296	88296	88297
19954	28474	1	applied	\N	\N	\N	\N	88298	88298	88299
19954	28475	2	applied	\N	\N	\N	\N	88300	88300	88301
19954	28476	3	applied	\N	\N	\N	\N	88302	88302	88303
19954	28477	4	applied	\N	\N	\N	\N	88304	88304	88305
19954	28478	5	applied	\N	\N	\N	\N	88306	88306	88307
19954	28479	6	applied	\N	\N	\N	\N	88308	88308	88309
19954	28480	7	applied	\N	\N	\N	\N	88310	88310	88311
19954	28481	8	applied	\N	\N	\N	\N	88312	88312	88313
19954	28482	9	applied	\N	\N	\N	\N	88314	88314	88315
19954	28483	10	applied	\N	\N	\N	\N	88316	88316	88317
19954	28484	11	applied	\N	\N	\N	\N	88318	88318	88319
19954	28485	12	applied	\N	\N	\N	\N	88320	88320	88321
19956	28486	0	applied	\N	\N	\N	\N	88326	88326	88327
19956	28477	1	applied	\N	\N	\N	\N	88304	88304	88328
19956	28478	2	applied	\N	\N	\N	\N	88306	88306	88329
19956	28479	3	applied	\N	\N	\N	\N	88308	88308	88330
19956	28480	4	applied	\N	\N	\N	\N	88310	88310	88331
19956	28481	5	applied	\N	\N	\N	\N	88312	88312	88332
19956	28487	6	applied	\N	\N	\N	\N	88333	88333	88317
19956	28482	7	applied	\N	\N	\N	\N	88314	88314	88319
19956	28483	8	applied	\N	\N	\N	\N	88316	88316	88334
19956	28484	9	applied	\N	\N	\N	\N	88318	88318	88335
19956	28488	10	applied	\N	\N	\N	\N	88336	88336	88337
19966	28502	0	applied	\N	\N	\N	\N	88396	88396	88397
19966	28503	1	applied	\N	\N	\N	\N	88398	88398	88399
19966	28504	2	applied	\N	\N	\N	\N	88400	88400	88401
19966	28505	3	applied	\N	\N	\N	\N	88402	88402	88403
19971	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19971	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19971	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19971	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19971	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19971	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19971	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19978	28529	0	applied	\N	\N	\N	\N	88470	88470	88471
19978	28530	1	applied	\N	\N	\N	\N	88472	88472	88473
19978	28531	2	applied	\N	\N	\N	\N	88474	88474	88475
19925	28407	1	applied	\N	\N	\N	\N	88071	88071	88072
19925	28408	2	applied	\N	\N	\N	\N	88073	88073	88074
19927	28409	0	applied	\N	\N	\N	\N	88077	88077	88078
19927	28410	1	applied	\N	\N	\N	\N	88079	88079	88080
19927	28411	2	applied	\N	\N	\N	\N	88081	88081	88082
19927	28412	3	applied	\N	\N	\N	\N	88083	88083	88084
19937	28423	0	applied	\N	\N	\N	\N	88118	88118	88119
19937	28424	1	applied	\N	\N	\N	\N	88120	88120	88121
19939	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19939	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19939	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19943	28425	0	applied	\N	\N	\N	\N	88128	88128	88129
19943	28426	1	applied	\N	\N	\N	\N	88130	88130	88131
19943	28427	2	applied	\N	\N	\N	\N	88132	88132	88133
19946	28435	0	applied	\N	\N	\N	\N	88211	88211	88212
19946	28436	1	applied	\N	\N	\N	\N	88213	88213	88214
19946	28437	2	applied	\N	\N	\N	\N	88215	88215	88216
19958	28366	0	applied	\N	\N	\N	\N	87964	87964	87965
19958	28239	1	applied	\N	\N	\N	\N	87617	87617	28166
19958	28109	2	applied	\N	\N	\N	\N	87258	87258	87259
19958	28110	3	applied	\N	\N	\N	\N	87260	87260	87261
19958	28111	4	applied	\N	\N	\N	\N	87262	87262	87263
19958	28112	5	applied	\N	\N	\N	\N	87264	87264	87265
19958	28370	6	applied	\N	\N	\N	\N	87977	87977	87978
19958	28371	7	applied	\N	\N	\N	\N	87979	87979	87980
19958	28376	8	applied	\N	\N	\N	\N	87992	87992	87993
19958	28404	9	applied	\N	\N	\N	\N	88058	88058	88059
19958	28383	10	applied	\N	\N	\N	\N	88009	88009	88010
19958	28328	11	applied	\N	\N	\N	\N	87859	87859	87860
19958	28329	12	applied	\N	\N	\N	\N	87861	87861	87862
19958	28330	13	applied	\N	\N	\N	\N	87863	87863	87864
19958	28447	14	applied	\N	\N	\N	\N	88236	88236	88237
19958	28448	15	applied	\N	\N	\N	\N	88238	88238	88239
19958	28389	16	applied	\N	\N	\N	\N	88023	88023	88024
19958	28390	17	applied	\N	\N	\N	\N	88025	88025	88026
19958	28393	18	applied	\N	\N	\N	\N	88032	88032	88033
19958	28450	19	applied	\N	\N	\N	\N	88242	88242	88243
19958	28451	20	applied	\N	\N	\N	\N	88244	88244	88245
19958	28228	21	applied	\N	\N	\N	\N	87583	87583	75393
19958	28063	23	applied	\N	\N	\N	\N	87138	87138	87139
19958	28064	24	applied	\N	\N	\N	\N	87140	87140	87141
19958	28065	25	applied	\N	\N	\N	\N	87142	87142	87143
19958	28072	26	applied	\N	\N	\N	\N	87157	87157	87158
19958	28075	27	applied	\N	\N	\N	\N	87165	87165	87166
19958	28076	28	applied	\N	\N	\N	\N	87167	87167	87168
19958	28082	29	applied	\N	\N	\N	\N	87182	87182	87183
19958	28083	30	applied	\N	\N	\N	\N	87184	87184	87185
19958	28089	31	applied	\N	\N	\N	\N	87200	87200	87201
19958	28093	32	applied	\N	\N	\N	\N	87210	87210	87211
19958	28096	33	applied	\N	\N	\N	\N	87218	87218	87219
19958	28099	34	applied	\N	\N	\N	\N	87228	87228	87229
19958	28103	35	applied	\N	\N	\N	\N	87238	87238	87239
19958	28106	36	applied	\N	\N	\N	\N	87250	87250	87251
19958	28113	37	applied	\N	\N	\N	\N	87266	87266	87267
19958	28117	38	applied	\N	\N	\N	\N	87280	87280	87281
19958	28118	39	applied	\N	\N	\N	\N	87282	87282	87283
19958	28121	40	applied	\N	\N	\N	\N	87290	87290	87291
19958	28122	41	applied	\N	\N	\N	\N	87292	87292	87293
19958	28123	42	applied	\N	\N	\N	\N	87294	87294	87295
19958	28124	43	applied	\N	\N	\N	\N	87296	87296	87297
19958	28131	44	applied	\N	\N	\N	\N	87314	87314	87315
19958	28134	45	applied	\N	\N	\N	\N	87322	87322	87323
19958	28135	46	applied	\N	\N	\N	\N	87324	87324	87325
19958	28138	47	applied	\N	\N	\N	\N	87332	87332	87333
19958	28141	48	applied	\N	\N	\N	\N	87343	87343	87344
19958	28142	49	applied	\N	\N	\N	\N	87347	87347	87348
19958	28452	50	applied	\N	\N	\N	\N	88246	88246	88247
19958	28332	51	applied	\N	\N	\N	\N	87867	87867	87868
19958	28144	52	applied	\N	\N	\N	\N	87353	87353	87354
19958	28146	53	applied	\N	\N	\N	\N	87361	87361	87362
19958	28147	54	applied	\N	\N	\N	\N	87363	87363	87364
19958	28148	55	applied	\N	\N	\N	\N	87365	87365	87366
19958	28153	56	applied	\N	\N	\N	\N	87376	87376	87377
19958	28154	57	applied	\N	\N	\N	\N	87378	87378	87379
19958	28158	58	applied	\N	\N	\N	\N	87387	87387	87388
19958	28161	59	applied	\N	\N	\N	\N	87397	87397	87398
19958	28166	60	applied	\N	\N	\N	\N	87407	87407	87408
19958	28167	61	applied	\N	\N	\N	\N	87409	87409	87410
19958	28170	62	applied	\N	\N	\N	\N	87419	87419	87420
19958	28172	63	applied	\N	\N	\N	\N	87424	87424	87425
19958	28177	64	applied	\N	\N	\N	\N	87436	87436	87437
19958	28180	65	applied	\N	\N	\N	\N	87444	87444	87445
19958	28185	66	applied	\N	\N	\N	\N	87468	87468	88148
19958	28188	67	applied	\N	\N	\N	\N	87475	87475	88149
19958	28191	68	applied	\N	\N	\N	\N	87484	87484	88150
19958	28195	69	applied	\N	\N	\N	\N	87494	87494	88151
19958	28198	70	applied	\N	\N	\N	\N	87502	87502	88152
19958	28201	71	applied	\N	\N	\N	\N	87510	87510	88153
19958	28204	72	applied	\N	\N	\N	\N	87518	87518	88154
19958	28208	73	applied	\N	\N	\N	\N	87530	87530	88155
19958	28211	74	applied	\N	\N	\N	\N	87538	87538	88156
19958	28212	75	applied	\N	\N	\N	\N	87540	87540	88157
19958	28218	76	applied	\N	\N	\N	\N	87559	87559	88158
19958	28221	77	applied	\N	\N	\N	\N	87565	87565	88159
19958	28227	78	applied	\N	\N	\N	\N	87581	87581	88160
19958	28233	79	applied	\N	\N	\N	\N	87601	87601	88161
19958	28240	80	applied	\N	\N	\N	\N	87618	87618	88162
19958	28243	81	applied	\N	\N	\N	\N	87626	87626	88163
19958	28248	82	applied	\N	\N	\N	\N	87638	87638	88164
19958	28253	83	applied	\N	\N	\N	\N	87658	87658	88165
19958	28256	84	applied	\N	\N	\N	\N	87665	87665	88166
19958	28263	85	applied	\N	\N	\N	\N	87682	87682	88167
19958	28264	86	applied	\N	\N	\N	\N	87684	87684	88168
19958	28265	87	applied	\N	\N	\N	\N	87686	87686	88169
19958	28266	88	applied	\N	\N	\N	\N	87688	87688	88170
19958	28267	89	applied	\N	\N	\N	\N	87690	87690	88171
19958	28280	90	applied	\N	\N	\N	\N	87720	87720	88172
19958	28283	91	applied	\N	\N	\N	\N	87731	87731	88173
19958	28286	92	applied	\N	\N	\N	\N	87741	87741	88174
19958	28292	93	applied	\N	\N	\N	\N	87756	87756	88175
19958	28294	94	applied	\N	\N	\N	\N	87762	87762	88176
19958	28297	95	applied	\N	\N	\N	\N	87770	87770	88177
19958	28298	96	applied	\N	\N	\N	\N	87772	87772	88178
19958	28304	97	applied	\N	\N	\N	\N	87797	87797	88179
19958	28307	98	applied	\N	\N	\N	\N	87808	87808	88180
19958	28308	99	applied	\N	\N	\N	\N	87810	87810	88181
19958	28314	100	applied	\N	\N	\N	\N	87824	87824	88182
19958	28317	101	applied	\N	\N	\N	\N	87834	87834	88183
19958	28320	102	applied	\N	\N	\N	\N	87841	87841	88184
19958	28321	103	applied	\N	\N	\N	\N	87843	87843	88185
19944	28031	28	applied	\N	\N	\N	\N	87061	87061	87062
19944	28228	29	applied	\N	\N	\N	\N	87583	87583	75393
19944	28034	30	applied	\N	\N	\N	\N	87069	87069	87070
19944	28040	31	applied	\N	\N	\N	\N	87083	87083	87084
19944	28041	32	applied	\N	\N	\N	\N	87085	87085	87086
19944	28047	33	applied	\N	\N	\N	\N	87099	87099	87100
19944	28050	34	applied	\N	\N	\N	\N	87107	87107	87108
19944	28053	36	applied	\N	\N	\N	\N	87113	87113	87114
19944	28056	37	applied	\N	\N	\N	\N	87121	87121	87122
19944	28057	38	applied	\N	\N	\N	\N	87123	87123	87124
19944	28063	39	applied	\N	\N	\N	\N	87138	87138	87139
19944	28064	40	applied	\N	\N	\N	\N	87140	87140	87141
19944	28065	41	applied	\N	\N	\N	\N	87142	87142	87143
19944	28072	42	applied	\N	\N	\N	\N	87157	87157	87158
19944	28075	43	applied	\N	\N	\N	\N	87165	87165	87166
19944	28076	44	applied	\N	\N	\N	\N	87167	87167	87168
19944	28082	45	applied	\N	\N	\N	\N	87182	87182	87183
19944	28083	46	applied	\N	\N	\N	\N	87184	87184	87185
19944	28089	47	applied	\N	\N	\N	\N	87200	87200	87201
19944	28093	48	applied	\N	\N	\N	\N	87210	87210	87211
19944	28096	49	applied	\N	\N	\N	\N	87218	87218	87219
19944	28099	50	applied	\N	\N	\N	\N	87228	87228	87229
19944	28103	51	applied	\N	\N	\N	\N	87238	87238	87239
19944	28106	52	applied	\N	\N	\N	\N	87250	87250	87251
19944	28113	53	applied	\N	\N	\N	\N	87266	87266	87267
19944	28117	54	applied	\N	\N	\N	\N	87280	87280	87281
19944	28118	55	applied	\N	\N	\N	\N	87282	87282	87283
19944	28121	56	applied	\N	\N	\N	\N	87290	87290	87291
19944	28122	57	applied	\N	\N	\N	\N	87292	87292	87293
19944	28123	58	applied	\N	\N	\N	\N	87294	87294	87295
19944	28124	59	applied	\N	\N	\N	\N	87296	87296	87297
19944	28131	60	applied	\N	\N	\N	\N	87314	87314	87315
19944	28134	61	applied	\N	\N	\N	\N	87322	87322	87323
19944	28135	62	applied	\N	\N	\N	\N	87324	87324	87325
19944	28138	63	applied	\N	\N	\N	\N	87332	87332	87333
19944	28141	64	applied	\N	\N	\N	\N	87343	87343	87344
19944	28142	65	applied	\N	\N	\N	\N	87347	87347	87348
19944	28332	66	applied	\N	\N	\N	\N	88147	88147	87868
19944	28144	67	applied	\N	\N	\N	\N	87353	87353	87354
19944	28146	68	applied	\N	\N	\N	\N	87361	87361	87362
19944	28147	69	applied	\N	\N	\N	\N	87363	87363	87364
19944	28148	70	applied	\N	\N	\N	\N	87365	87365	87366
19944	28153	71	applied	\N	\N	\N	\N	87376	87376	87377
19944	28154	72	applied	\N	\N	\N	\N	87378	87378	87379
19944	28158	73	applied	\N	\N	\N	\N	87387	87387	87388
19944	28161	74	applied	\N	\N	\N	\N	87397	87397	87398
19944	28166	75	applied	\N	\N	\N	\N	87407	87407	87408
19944	28167	76	applied	\N	\N	\N	\N	87409	87409	87410
19944	28170	77	applied	\N	\N	\N	\N	87419	87419	87420
19944	28172	78	applied	\N	\N	\N	\N	87424	87424	87425
19944	28177	79	applied	\N	\N	\N	\N	87436	87436	87437
19944	28180	80	applied	\N	\N	\N	\N	87444	87444	87445
19944	28185	81	applied	\N	\N	\N	\N	87468	87468	88148
19944	28188	82	applied	\N	\N	\N	\N	87475	87475	88149
19944	28191	83	applied	\N	\N	\N	\N	87484	87484	88150
19944	28195	84	applied	\N	\N	\N	\N	87494	87494	88151
19944	28198	85	applied	\N	\N	\N	\N	87502	87502	88152
19944	28201	86	applied	\N	\N	\N	\N	87510	87510	88153
19944	28204	87	applied	\N	\N	\N	\N	87518	87518	88154
19944	28208	88	applied	\N	\N	\N	\N	87530	87530	88155
19944	28211	89	applied	\N	\N	\N	\N	87538	87538	88156
19944	28212	90	applied	\N	\N	\N	\N	87540	87540	88157
19944	28218	91	applied	\N	\N	\N	\N	87559	87559	88158
19944	28221	92	applied	\N	\N	\N	\N	87565	87565	88159
19944	28227	93	applied	\N	\N	\N	\N	87581	87581	88160
19944	28233	94	applied	\N	\N	\N	\N	87601	87601	88161
19944	28240	95	applied	\N	\N	\N	\N	87618	87618	88162
19944	28243	96	applied	\N	\N	\N	\N	87626	87626	88163
19944	28248	97	applied	\N	\N	\N	\N	87638	87638	88164
19944	28253	98	applied	\N	\N	\N	\N	87658	87658	88165
19944	28256	99	applied	\N	\N	\N	\N	87665	87665	88166
19944	28263	100	applied	\N	\N	\N	\N	87682	87682	88167
19944	28264	101	applied	\N	\N	\N	\N	87684	87684	88168
19944	28265	102	applied	\N	\N	\N	\N	87686	87686	88169
19944	28266	103	applied	\N	\N	\N	\N	87688	87688	88170
19944	28267	104	applied	\N	\N	\N	\N	87690	87690	88171
19944	28280	105	applied	\N	\N	\N	\N	87720	87720	88172
19944	28283	106	applied	\N	\N	\N	\N	87731	87731	88173
19944	28286	107	applied	\N	\N	\N	\N	87741	87741	88174
19944	28292	108	applied	\N	\N	\N	\N	87756	87756	88175
19944	28294	109	applied	\N	\N	\N	\N	87762	87762	88176
19944	28297	110	applied	\N	\N	\N	\N	87770	87770	88177
19944	28298	111	applied	\N	\N	\N	\N	87772	87772	88178
19944	28304	112	applied	\N	\N	\N	\N	87797	87797	88179
19944	28307	113	applied	\N	\N	\N	\N	87808	87808	88180
19944	28308	114	applied	\N	\N	\N	\N	87810	87810	88181
19944	28314	115	applied	\N	\N	\N	\N	87824	87824	88182
19944	28317	116	applied	\N	\N	\N	\N	87834	87834	88183
19944	28320	117	applied	\N	\N	\N	\N	87841	87841	88184
19944	28321	118	applied	\N	\N	\N	\N	87843	87843	88185
19944	28327	119	applied	\N	\N	\N	\N	87857	87857	88186
19944	28331	120	applied	\N	\N	\N	\N	87865	87865	88187
19944	28338	121	applied	\N	\N	\N	\N	87883	87883	88188
19944	28342	122	applied	\N	\N	\N	\N	87901	87901	88189
19944	28346	123	applied	\N	\N	\N	\N	87915	87915	88190
19944	28347	124	applied	\N	\N	\N	\N	87917	87917	88191
19944	28353	125	applied	\N	\N	\N	\N	87931	87931	88192
19949	28445	0	applied	\N	\N	\N	\N	88232	88232	88233
19949	28446	1	applied	\N	\N	\N	\N	88234	88234	88235
19949	28447	2	applied	\N	\N	\N	\N	88236	88236	88237
19949	28448	3	applied	\N	\N	\N	\N	88238	88238	88239
19949	28449	4	applied	\N	\N	\N	\N	88240	88240	88241
19949	28450	5	applied	\N	\N	\N	\N	88242	88242	88243
19949	28451	6	applied	\N	\N	\N	\N	88244	88244	88245
19949	28452	7	applied	\N	\N	\N	\N	88246	88246	88247
19949	28453	8	applied	\N	\N	\N	\N	88248	88248	88249
19949	28454	9	applied	\N	\N	\N	\N	88250	88250	88251
19949	28455	10	applied	\N	\N	\N	\N	88252	88252	88253
19949	28456	11	applied	\N	\N	\N	\N	88254	88254	88255
19949	28457	12	applied	\N	\N	\N	\N	88256	88256	88257
19949	28458	13	applied	\N	\N	\N	\N	88258	88258	88259
19949	28459	14	applied	\N	\N	\N	\N	88260	88260	88261
19952	28460	0	applied	\N	\N	\N	\N	88265	88265	88266
19952	28461	1	applied	\N	\N	\N	\N	88267	88267	88268
19952	28462	2	applied	\N	\N	\N	\N	88269	88269	88270
19955	28473	0	applied	\N	\N	\N	\N	88296	88296	88297
19955	28474	1	applied	\N	\N	\N	\N	88298	88298	88299
19955	28475	2	applied	\N	\N	\N	\N	88300	88300	88301
19955	28476	3	applied	\N	\N	\N	\N	88302	88302	88303
19955	28485	4	applied	\N	\N	\N	\N	88320	88320	88324
19958	28327	104	applied	\N	\N	\N	\N	87857	87857	88186
19958	28331	105	applied	\N	\N	\N	\N	87865	87865	88187
19958	28338	106	applied	\N	\N	\N	\N	87883	87883	88188
19958	28342	107	applied	\N	\N	\N	\N	87901	87901	88189
19958	28346	108	applied	\N	\N	\N	\N	87915	87915	88190
19958	28347	109	applied	\N	\N	\N	\N	87917	87917	88191
19958	28353	110	applied	\N	\N	\N	\N	87931	87931	88192
19958	28356	111	applied	\N	\N	\N	\N	87941	87941	88349
19958	28357	112	applied	\N	\N	\N	\N	87943	87943	88350
19958	28358	113	applied	\N	\N	\N	\N	87945	87945	88351
19958	28367	114	applied	\N	\N	\N	\N	87966	87966	88352
19958	28372	115	applied	\N	\N	\N	\N	87981	87981	88353
19958	28377	116	applied	\N	\N	\N	\N	87994	87994	88354
19958	28380	117	applied	\N	\N	\N	\N	88003	88003	88355
19958	28384	118	applied	\N	\N	\N	\N	88011	88011	88356
19958	28388	119	applied	\N	\N	\N	\N	88021	88021	88357
19958	28394	120	applied	\N	\N	\N	\N	88034	88034	88358
19958	28395	121	applied	\N	\N	\N	\N	88036	88036	88359
19958	28400	122	applied	\N	\N	\N	\N	88048	88048	88360
19958	28406	123	applied	\N	\N	\N	\N	88069	88069	88361
19958	28409	124	applied	\N	\N	\N	\N	88077	88077	88362
19958	28413	125	applied	\N	\N	\N	\N	88085	88085	88363
19961	28496	0	applied	\N	\N	\N	\N	88374	88374	88375
19961	28497	1	applied	\N	\N	\N	\N	88376	88376	88377
19961	28498	2	applied	\N	\N	\N	\N	88378	88378	88379
19963	28499	0	applied	\N	\N	\N	\N	88384	88384	88385
19963	28500	1	applied	\N	\N	\N	\N	88386	88386	88387
19963	28501	2	applied	\N	\N	\N	\N	88388	88388	88389
19965	28502	0	applied	\N	\N	\N	\N	88396	88396	88397
19965	28503	1	applied	\N	\N	\N	\N	88398	88398	88399
19965	28504	2	applied	\N	\N	\N	\N	88400	88400	88401
19965	28505	3	applied	\N	\N	\N	\N	88402	88402	88403
19968	28512	0	applied	\N	\N	\N	\N	88421	88421	88422
19968	28513	1	applied	\N	\N	\N	\N	88423	88423	88424
19968	28514	2	applied	\N	\N	\N	\N	88425	88425	88426
19968	28515	3	applied	\N	\N	\N	\N	88427	88427	88428
19968	28516	4	applied	\N	\N	\N	\N	88429	88429	88430
19968	28517	5	applied	\N	\N	\N	\N	88431	88431	88432
19968	28518	6	applied	\N	\N	\N	\N	88433	88433	88434
19974	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19974	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19974	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19974	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19974	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19974	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19974	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19980	28538	0	applied	\N	\N	\N	\N	88491	88491	88492
19980	28539	1	applied	\N	\N	\N	\N	88493	88493	88494
19980	28540	2	applied	\N	\N	\N	\N	88495	88495	88496
19980	28541	3	applied	\N	\N	\N	\N	88497	88497	88498
19980	28542	4	applied	\N	\N	\N	\N	88499	88499	88500
19980	28543	5	applied	\N	\N	\N	\N	88501	88501	88502
19983	28550	0	applied	\N	\N	\N	\N	88518	88518	88519
19983	28551	1	applied	\N	\N	\N	\N	88520	88520	12588
19983	28552	2	applied	\N	\N	\N	\N	88521	88521	88522
19987	28557	0	applied	\N	\N	\N	\N	88537	88537	88538
19987	28558	1	applied	\N	\N	\N	\N	88539	88539	88540
19987	28559	2	applied	\N	\N	\N	\N	88541	88541	88542
19987	28560	3	applied	\N	\N	\N	\N	88543	88543	88544
19987	28561	4	applied	\N	\N	\N	\N	88545	88545	88546
19989	28557	0	applied	\N	\N	\N	\N	88537	88537	88538
19989	28558	1	applied	\N	\N	\N	\N	88539	88539	88540
19989	28559	2	applied	\N	\N	\N	\N	88541	88541	88542
19989	28560	3	applied	\N	\N	\N	\N	88543	88543	88544
19989	28561	4	applied	\N	\N	\N	\N	88545	88545	88546
19995	28577	0	applied	\N	\N	\N	\N	88587	88587	88588
19995	28578	1	applied	\N	\N	\N	\N	88589	88589	88590
19995	28579	2	applied	\N	\N	\N	\N	88591	88591	88592
20001	28585	0	applied	\N	\N	\N	\N	88613	88613	88614
20001	28586	1	applied	\N	\N	\N	\N	88615	88615	88616
20001	28587	2	applied	\N	\N	\N	\N	88617	88617	88618
20001	28588	3	applied	\N	\N	\N	\N	88619	88619	88620
20001	28589	4	applied	\N	\N	\N	\N	88621	88621	88622
20014	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20014	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20014	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20017	28619	0	applied	\N	\N	\N	\N	88748	88748	88749
20017	28620	1	applied	\N	\N	\N	\N	88750	88750	88751
20017	28621	2	applied	\N	\N	\N	\N	88752	88752	88753
20017	28622	3	applied	\N	\N	\N	\N	88754	88754	88755
20019	28623	0	applied	\N	\N	\N	\N	88758	88758	88759
20019	28624	1	applied	\N	\N	1000000000	\N	88760	88760	88761
20019	28625	2	applied	\N	\N	\N	\N	88762	88762	88763
20019	28626	3	applied	\N	\N	\N	\N	88764	88764	88765
20022	28631	0	applied	\N	\N	\N	\N	88779	88779	88780
20022	28632	1	applied	\N	\N	\N	\N	88781	88781	88782
20022	28633	2	applied	\N	\N	1000000000	\N	88783	88783	88784
20022	28634	3	applied	\N	\N	\N	\N	88785	88785	88786
20022	28635	4	applied	\N	\N	\N	\N	88787	88787	88788
20022	28636	5	applied	\N	\N	\N	\N	88789	88789	88790
20022	28637	6	applied	\N	\N	\N	\N	88791	88791	88792
20022	28638	7	applied	\N	\N	\N	\N	88793	88793	88794
20022	28639	8	applied	\N	\N	1000000000	\N	88795	88795	88796
20022	28640	9	applied	\N	\N	1000000000	\N	88797	88797	88798
20031	28659	0	applied	\N	\N	\N	\N	88842	88842	88843
20031	28660	1	applied	\N	\N	\N	\N	88844	88844	88845
20031	28661	2	applied	\N	\N	\N	\N	88846	88846	88847
20031	28662	3	applied	\N	\N	1000000000	\N	88848	88848	88849
20034	28670	0	applied	\N	\N	\N	\N	88870	88870	88871
20034	28671	1	applied	\N	\N	\N	\N	88872	88872	88873
20034	28672	2	applied	\N	\N	\N	\N	88874	88874	88875
20038	28673	0	applied	\N	\N	\N	\N	88878	88878	88059
20038	28674	1	applied	\N	\N	\N	\N	88879	88879	88880
20038	28675	2	applied	\N	\N	\N	\N	88881	88881	88882
20038	28676	3	applied	\N	\N	\N	\N	88883	88883	88884
20038	28677	4	applied	\N	\N	\N	\N	88885	88885	88886
20043	28684	0	applied	\N	\N	\N	\N	88908	88908	88909
20043	28685	1	applied	\N	\N	\N	\N	88910	88910	88911
20043	28686	2	applied	\N	\N	\N	\N	88912	88912	47675
20043	28687	3	applied	\N	\N	\N	\N	88913	88913	88914
20052	28702	0	applied	\N	\N	\N	\N	88955	88955	88956
20052	28703	1	applied	\N	\N	\N	\N	88957	88957	88958
20052	28704	2	applied	\N	\N	\N	\N	88959	88959	88960
20052	28705	3	applied	\N	\N	\N	\N	88961	88961	88962
20052	28706	4	applied	\N	\N	\N	\N	88963	88963	88964
20052	28707	5	applied	\N	\N	\N	\N	88965	88965	88966
20052	28708	6	applied	\N	\N	\N	\N	88967	88967	88968
20052	28709	7	applied	\N	\N	\N	\N	88969	88969	88970
20052	28710	8	applied	\N	\N	\N	\N	88971	88971	88972
19960	28496	0	applied	\N	\N	\N	\N	88374	88374	88375
19960	28497	1	applied	\N	\N	\N	\N	88376	88376	88377
19960	28498	2	applied	\N	\N	\N	\N	88378	88378	88379
19962	28499	0	applied	\N	\N	\N	\N	88384	88384	88385
19962	28500	1	applied	\N	\N	\N	\N	88386	88386	88387
19962	28501	2	applied	\N	\N	\N	\N	88388	88388	88389
19967	28506	0	applied	\N	\N	\N	\N	88407	88407	88408
19967	28507	1	applied	\N	\N	\N	\N	88409	88409	88410
19967	28508	2	applied	\N	\N	\N	\N	88411	88411	88412
19967	28509	3	applied	\N	\N	\N	\N	88413	88413	88414
19967	28510	4	applied	\N	\N	\N	\N	88415	88415	88416
19967	28511	5	applied	\N	\N	\N	\N	88417	88417	88418
19970	28519	0	applied	\N	\N	\N	\N	88437	88437	88438
19970	28520	1	applied	\N	\N	\N	\N	88439	88439	88440
19970	28521	2	applied	\N	\N	\N	\N	88441	88441	88442
19973	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19973	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19973	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19973	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19973	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19973	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19973	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19976	28522	0	applied	\N	\N	\N	\N	88447	88447	88448
19976	28523	1	applied	\N	\N	\N	\N	88449	88449	88450
19976	28524	2	applied	\N	\N	\N	\N	88451	88451	88452
19976	28525	3	applied	\N	\N	\N	\N	88453	88453	88454
19976	28526	4	applied	\N	\N	\N	\N	88455	88455	88456
19976	28527	5	applied	\N	\N	\N	\N	88457	88457	88458
19976	28528	6	applied	\N	\N	\N	\N	88459	88459	88460
19982	28550	0	applied	\N	\N	\N	\N	88518	88518	88519
19982	28551	1	applied	\N	\N	\N	\N	88520	88520	12588
19982	28552	2	applied	\N	\N	\N	\N	88521	88521	88522
19984	28553	0	applied	\N	\N	\N	\N	88525	88525	88526
19984	28550	1	applied	\N	\N	\N	\N	88518	88518	88519
19984	28551	2	applied	\N	\N	\N	\N	88520	88520	12588
19984	28552	3	applied	\N	\N	\N	\N	88521	88521	88522
19986	28554	0	applied	\N	\N	\N	\N	88528	88528	88529
19986	28555	1	applied	\N	\N	\N	\N	88530	88530	88531
19986	28556	2	applied	\N	\N	\N	\N	88532	88532	88533
19992	28565	0	applied	\N	\N	\N	\N	88560	88560	88561
19992	28566	1	applied	\N	\N	\N	\N	88562	88562	88563
19992	28567	2	applied	\N	\N	\N	\N	88564	88564	88565
19992	28568	3	applied	\N	\N	\N	\N	88566	88566	88567
19992	28569	4	applied	\N	\N	\N	\N	88568	88568	88569
19992	28570	5	applied	\N	\N	\N	\N	88570	88570	88539
19992	28571	6	applied	\N	\N	\N	\N	88571	88571	88572
19992	28575	7	applied	\N	\N	\N	\N	88579	88579	88585
19992	28576	8	applied	\N	\N	\N	\N	88581	88581	88578
19994	28577	0	applied	\N	\N	\N	\N	88587	88587	88588
19994	28578	1	applied	\N	\N	\N	\N	88589	88589	88590
19994	28579	2	applied	\N	\N	\N	\N	88591	88591	88592
20003	28590	0	applied	\N	\N	\N	\N	88670	88670	88671
20003	28591	1	applied	\N	\N	\N	\N	88672	88672	88673
20003	28592	2	applied	\N	\N	\N	\N	88674	88674	88675
20003	28593	3	applied	\N	\N	\N	\N	88676	88676	88677
20003	28594	4	applied	\N	\N	\N	\N	88678	88678	88679
20005	28595	0	applied	\N	\N	\N	\N	88683	88683	88684
20005	28596	1	applied	\N	\N	\N	\N	88685	88685	88686
20005	28597	2	applied	\N	\N	\N	\N	88687	88687	88688
20005	28598	3	applied	\N	\N	\N	\N	88689	88689	88690
20005	28599	4	applied	\N	\N	\N	\N	88691	88691	88692
20008	28595	0	applied	\N	\N	\N	\N	88683	88683	88684
20008	28596	1	applied	\N	\N	\N	\N	88685	88685	88686
20008	28597	2	applied	\N	\N	\N	\N	88687	88687	88688
20008	28598	3	applied	\N	\N	\N	\N	88689	88689	88690
20008	28599	4	applied	\N	\N	\N	\N	88691	88691	88692
20010	28610	0	applied	\N	\N	\N	\N	88721	88721	88722
20010	28611	1	applied	\N	\N	\N	\N	88723	88723	88724
20010	28612	2	applied	\N	\N	\N	\N	88725	88725	88726
20010	28613	3	applied	\N	\N	\N	\N	88727	88727	88728
20010	28614	4	applied	\N	\N	\N	\N	88729	88729	88730
20010	28615	5	applied	\N	\N	\N	\N	88731	88731	88732
20013	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20013	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20013	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20016	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20016	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20016	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20021	28627	0	applied	\N	\N	\N	\N	88769	88769	88770
20021	28628	1	applied	\N	\N	1000000000	\N	88771	88771	88772
20021	28629	2	applied	\N	\N	\N	\N	88773	88773	88774
20021	28630	3	applied	\N	\N	\N	\N	88775	88775	88776
20024	28650	0	applied	\N	\N	\N	\N	88820	88820	88821
20024	28651	1	applied	\N	\N	\N	\N	88822	88822	88823
20024	28652	2	applied	\N	\N	\N	\N	88824	88824	88825
20024	28653	3	applied	\N	\N	\N	\N	88826	88826	88827
20027	28654	0	applied	\N	\N	\N	\N	88830	88830	88831
20027	28655	1	applied	\N	\N	\N	\N	88832	88832	88833
20027	28656	2	applied	\N	\N	\N	\N	88834	88834	88835
20027	28657	3	applied	\N	\N	\N	\N	88836	88836	88837
20027	28658	4	applied	\N	\N	\N	\N	88838	88838	88839
20033	28667	0	applied	\N	\N	\N	\N	88862	88862	88863
20033	28668	1	applied	\N	\N	\N	\N	88864	88864	88865
20033	28669	2	applied	\N	\N	\N	\N	88866	88866	88867
20041	28678	0	applied	\N	\N	\N	\N	88890	88890	88891
20041	28679	1	applied	\N	\N	\N	\N	88892	88892	88893
20041	28680	2	applied	\N	\N	\N	\N	88894	88894	88895
20042	28681	0	applied	\N	\N	\N	\N	88900	88900	88901
20042	28682	1	applied	\N	\N	\N	\N	88902	88902	88903
20042	28683	2	applied	\N	\N	\N	\N	88904	88904	88905
20050	28695	0	applied	\N	\N	\N	\N	88938	88938	88939
20050	28696	1	applied	\N	\N	\N	\N	88940	88940	88941
20050	28697	2	applied	\N	\N	\N	\N	88942	88942	88943
20054	28736	0	applied	\N	\N	\N	\N	89028	89028	89029
20054	28737	1	applied	\N	\N	\N	\N	89030	89030	89031
20054	28738	2	applied	\N	\N	\N	\N	89032	89032	89033
20054	28739	3	applied	\N	\N	\N	\N	89034	89034	89035
20059	28743	0	applied	\N	\N	\N	\N	89044	89044	89045
20059	28744	1	applied	\N	\N	\N	\N	89046	89046	89047
20059	28745	2	applied	\N	\N	\N	\N	89048	89048	89049
20063	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20063	28776	1	applied	\N	\N	\N	\N	89111	89111	89112
20063	28777	2	applied	\N	\N	\N	\N	89113	89113	89114
20070	28778	0	applied	\N	\N	\N	\N	89159	89159	89160
20070	28779	1	applied	\N	\N	\N	\N	89161	89161	89162
20070	28780	2	applied	\N	\N	\N	\N	89163	89163	89164
20070	28781	3	applied	\N	\N	\N	\N	89165	89165	89166
20072	28782	0	applied	\N	\N	\N	\N	89171	89171	89172
20072	28783	1	applied	\N	\N	\N	\N	89173	89173	89174
20072	28784	2	applied	\N	\N	\N	\N	89175	89175	89176
19978	28532	3	applied	\N	\N	\N	\N	88476	88476	88477
19978	28533	4	applied	\N	\N	\N	\N	88478	88478	88479
19978	28534	5	applied	\N	\N	\N	\N	88480	88480	88481
19978	28535	6	applied	\N	\N	\N	\N	88482	88482	88483
19978	28536	7	applied	\N	\N	\N	\N	88484	88484	88485
19978	28537	8	applied	\N	\N	\N	\N	88486	88486	88487
19985	28554	0	applied	\N	\N	\N	\N	88528	88528	88529
19985	28555	1	applied	\N	\N	\N	\N	88530	88530	88531
19985	28556	2	applied	\N	\N	\N	\N	88532	88532	88533
19988	28557	0	applied	\N	\N	\N	\N	88537	88537	88538
19988	28558	1	applied	\N	\N	\N	\N	88539	88539	88540
19988	28559	2	applied	\N	\N	\N	\N	88541	88541	88542
19988	28560	3	applied	\N	\N	\N	\N	88543	88543	88544
19988	28561	4	applied	\N	\N	\N	\N	88545	88545	88546
19997	28580	0	applied	\N	\N	\N	\N	88600	88600	88601
19997	28581	1	applied	\N	\N	\N	\N	88602	88602	88603
19997	28582	2	applied	\N	\N	\N	\N	88604	88604	88605
19997	28583	3	applied	\N	\N	\N	\N	88606	88606	88607
19997	28584	4	applied	\N	\N	\N	\N	88608	88608	88609
19999	28585	0	applied	\N	\N	\N	\N	88613	88613	88614
19999	28586	1	applied	\N	\N	\N	\N	88615	88615	88616
19999	28587	2	applied	\N	\N	\N	\N	88617	88617	88618
19999	28588	3	applied	\N	\N	\N	\N	88619	88619	88620
19999	28589	4	applied	\N	\N	\N	\N	88621	88621	88622
20006	28595	0	applied	\N	\N	\N	\N	88683	88683	88684
20006	28596	1	applied	\N	\N	\N	\N	88685	88685	88686
20006	28597	2	applied	\N	\N	\N	\N	88687	88687	88688
20006	28598	3	applied	\N	\N	\N	\N	88689	88689	88690
20006	28599	4	applied	\N	\N	\N	\N	88691	88691	88692
20011	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20011	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20011	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20015	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20015	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20015	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20018	28619	0	applied	\N	\N	\N	\N	88748	88748	88749
20018	28620	1	applied	\N	\N	\N	\N	88750	88750	88751
20018	28621	2	applied	\N	\N	\N	\N	88752	88752	88753
20018	28622	3	applied	\N	\N	\N	\N	88754	88754	88755
20020	28623	0	applied	\N	\N	\N	\N	88758	88758	88759
20020	28624	1	applied	\N	\N	1000000000	\N	88760	88760	88761
20020	28625	2	applied	\N	\N	\N	\N	88762	88762	88763
20020	28626	3	applied	\N	\N	\N	\N	88764	88764	88765
20026	28654	0	applied	\N	\N	\N	\N	88830	88830	88831
20026	28655	1	applied	\N	\N	\N	\N	88832	88832	88833
20026	28656	2	applied	\N	\N	\N	\N	88834	88834	88835
20026	28657	3	applied	\N	\N	\N	\N	88836	88836	88837
20026	28658	4	applied	\N	\N	\N	\N	88838	88838	88839
20032	28663	0	applied	\N	\N	\N	\N	88852	88852	88853
20032	28664	1	applied	\N	\N	\N	\N	88854	88854	88855
20032	28665	2	applied	\N	\N	\N	\N	88856	88856	88857
20032	28666	3	applied	\N	\N	\N	\N	88858	88858	88859
20035	28670	0	applied	\N	\N	\N	\N	88870	88870	88871
20035	28671	1	applied	\N	\N	\N	\N	88872	88872	88873
20035	28672	2	applied	\N	\N	\N	\N	88874	88874	88875
20044	28684	0	applied	\N	\N	\N	\N	88908	88908	88909
20044	28685	1	applied	\N	\N	\N	\N	88910	88910	88911
20044	28686	2	applied	\N	\N	\N	\N	88912	88912	47675
20044	28687	3	applied	\N	\N	\N	\N	88913	88913	88914
20046	28688	0	applied	\N	\N	\N	\N	88920	88920	88921
20046	28689	1	applied	\N	\N	\N	\N	88922	88922	88923
20046	28690	2	applied	\N	\N	\N	\N	88924	88924	88925
20046	28691	3	applied	\N	\N	\N	\N	88926	88926	88927
20046	28692	4	applied	\N	\N	\N	\N	88928	88928	88929
20046	28693	5	applied	\N	\N	\N	\N	88930	88930	88931
20046	28694	6	applied	\N	\N	\N	\N	88932	88932	88933
20048	28695	0	applied	\N	\N	\N	\N	88938	88938	88939
20048	28696	1	applied	\N	\N	\N	\N	88940	88940	88941
20048	28697	2	applied	\N	\N	\N	\N	88942	88942	88943
20053	28733	0	applied	\N	\N	\N	\N	89020	89020	89021
20053	28734	1	applied	\N	\N	\N	\N	89022	89022	89023
20053	28735	2	applied	\N	\N	\N	\N	89024	89024	89025
20065	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20065	28776	1	applied	\N	\N	\N	\N	89111	89111	89112
20067	28673	0	applied	\N	\N	\N	\N	88878	88878	88059
20067	28675	1	applied	\N	\N	\N	\N	88881	88881	88882
20067	28659	2	applied	\N	\N	\N	\N	88842	88842	88843
20067	28703	3	applied	\N	\N	\N	\N	88957	88957	88958
20067	28704	4	applied	\N	\N	\N	\N	88959	88959	88960
20067	28705	5	applied	\N	\N	\N	\N	88961	88961	88962
20067	28706	6	applied	\N	\N	\N	\N	88963	88963	88964
20067	28707	7	applied	\N	\N	\N	\N	88965	88965	88966
20067	28708	8	applied	\N	\N	\N	\N	88967	88967	88968
20067	28709	9	applied	\N	\N	\N	\N	88969	88969	88970
20067	28710	10	applied	\N	\N	\N	\N	88971	88971	88972
20067	28711	11	applied	\N	\N	\N	\N	88973	88973	88974
20067	28712	12	applied	\N	\N	\N	\N	88975	88975	88976
20067	28713	13	applied	\N	\N	\N	\N	88977	88977	88978
20067	28714	14	applied	\N	\N	\N	\N	88979	88979	88980
20067	28715	15	applied	\N	\N	\N	\N	88981	88981	88982
20067	28716	16	applied	\N	\N	\N	\N	88984	88984	88985
20067	28717	17	applied	\N	\N	\N	\N	88986	88986	88987
20067	28718	18	applied	\N	\N	\N	\N	88988	88988	88989
20067	28719	19	applied	\N	\N	\N	\N	88990	88990	88991
20067	28720	20	applied	\N	\N	\N	\N	88992	88992	88993
20067	28721	21	applied	\N	\N	\N	\N	88994	88994	88995
20067	28722	22	applied	\N	\N	\N	\N	88996	88996	88997
20067	28723	23	applied	\N	\N	\N	\N	88998	88998	88999
20067	28724	24	applied	\N	\N	\N	\N	89000	89000	89001
20067	28725	25	applied	\N	\N	\N	\N	89002	89002	89003
20067	28726	26	applied	\N	\N	\N	\N	89004	89004	89005
20067	28727	27	applied	\N	\N	\N	\N	89006	89006	89007
20067	28728	28	applied	\N	\N	\N	\N	89008	89008	89009
20067	28729	29	applied	\N	\N	\N	\N	89010	89010	89011
20067	28730	30	applied	\N	\N	\N	\N	89012	89012	89013
20067	28660	31	applied	\N	\N	\N	\N	88844	88844	88845
20067	28763	32	applied	\N	\N	\N	\N	89085	89085	89086
20067	28766	33	applied	\N	\N	\N	\N	89091	89091	89092
20067	28767	34	applied	\N	\N	\N	\N	89093	89093	89094
20067	28686	35	applied	\N	\N	\N	\N	88912	88912	47675
20067	28741	36	applied	\N	\N	\N	\N	89039	89039	85183
20067	28757	37	applied	\N	\N	\N	\N	89073	89073	13857
20067	28769	38	applied	\N	\N	\N	\N	89097	89097	89098
20067	28665	39	applied	\N	\N	\N	\N	88856	88856	89121
20067	28668	40	applied	\N	\N	\N	\N	88864	88864	89122
20067	28671	41	applied	\N	\N	\N	\N	88872	88872	88855
20067	28676	42	applied	\N	\N	\N	\N	88883	88883	88857
20067	28679	43	applied	\N	\N	\N	\N	88892	88892	89123
20067	28682	44	applied	\N	\N	\N	\N	88902	88902	89124
20067	28661	45	applied	\N	\N	\N	\N	88846	88846	89125
19991	28576	11	applied	\N	\N	\N	\N	88581	88581	88582
19993	28577	0	applied	\N	\N	\N	\N	88587	88587	88588
19993	28578	1	applied	\N	\N	\N	\N	88589	88589	88590
19993	28579	2	applied	\N	\N	\N	\N	88591	88591	88592
19996	28577	0	applied	\N	\N	\N	\N	88587	88587	88588
19996	28578	1	applied	\N	\N	\N	\N	88589	88589	88590
19996	28579	2	applied	\N	\N	\N	\N	88591	88591	88592
19998	28580	0	applied	\N	\N	\N	\N	88600	88600	88601
19998	28581	1	applied	\N	\N	\N	\N	88602	88602	88603
19998	28582	2	applied	\N	\N	\N	\N	88604	88604	88605
19998	28583	3	applied	\N	\N	\N	\N	88606	88606	88607
19998	28584	4	applied	\N	\N	\N	\N	88608	88608	88609
20000	28565	0	applied	\N	\N	\N	\N	88560	88560	88561
20000	28580	1	applied	\N	\N	\N	\N	88600	88600	88601
20000	28581	2	applied	\N	\N	\N	\N	88624	88624	88603
20000	28473	3	applied	\N	\N	\N	\N	88296	88296	88297
20000	28545	4	applied	\N	\N	1000000000	\N	88625	88625	88507
20000	28558	5	applied	\N	\N	\N	\N	88626	88626	88627
20000	28474	6	applied	\N	\N	\N	\N	88298	88298	88299
20000	28475	7	applied	\N	\N	\N	\N	88300	88300	88301
20000	28476	8	applied	\N	\N	\N	\N	88302	88302	88303
20000	28486	9	applied	\N	\N	\N	\N	88326	88326	88327
20000	28489	10	applied	\N	\N	\N	\N	88339	88339	88340
20000	28493	11	applied	\N	\N	\N	\N	88366	88366	88367
20000	28496	12	applied	\N	\N	\N	\N	88374	88374	88375
20000	28499	13	applied	\N	\N	\N	\N	88384	88384	88385
20000	28502	14	applied	\N	\N	\N	\N	88396	88396	88397
20000	28506	15	applied	\N	\N	\N	\N	88407	88407	88408
20000	28507	16	applied	\N	\N	\N	\N	88409	88409	88410
20000	28512	17	applied	\N	\N	\N	\N	88421	88421	88422
20000	28513	18	applied	\N	\N	\N	\N	88423	88423	88424
20000	28519	19	applied	\N	\N	\N	\N	88437	88437	88438
20000	28522	20	applied	\N	\N	\N	\N	88447	88447	88448
20000	28523	21	applied	\N	\N	\N	\N	88449	88449	88450
20000	28529	22	applied	\N	\N	\N	\N	88470	88470	88471
20000	28530	23	applied	\N	\N	\N	\N	88472	88472	88473
20000	28531	24	applied	\N	\N	\N	\N	88474	88474	88475
20000	28538	25	applied	\N	\N	\N	\N	88491	88491	88492
20000	28539	26	applied	\N	\N	\N	\N	88493	88493	88494
20000	28544	27	applied	\N	\N	\N	\N	88504	88504	88505
20000	28553	28	applied	\N	\N	\N	\N	88525	88525	88526
20000	28557	29	applied	\N	\N	\N	\N	88537	88537	88538
20000	28562	30	applied	\N	\N	\N	\N	88552	88552	88553
20000	28566	31	applied	\N	\N	\N	\N	88562	88562	88563
20000	28567	32	applied	\N	\N	\N	\N	88564	88564	88565
20000	28568	33	applied	\N	\N	\N	\N	88566	88566	88567
20000	28577	34	applied	\N	\N	\N	\N	88587	88587	88588
20000	28582	35	applied	\N	\N	\N	\N	88604	88604	88605
20000	28586	36	applied	\N	\N	\N	\N	88615	88615	88616
20000	28551	37	applied	\N	\N	\N	\N	88520	88520	12588
20000	28477	38	applied	\N	\N	\N	\N	88304	88304	88305
20000	28547	39	applied	\N	\N	\N	\N	88510	88510	88511
20000	28478	40	applied	\N	\N	\N	\N	88306	88306	88307
20000	28479	41	applied	\N	\N	\N	\N	88308	88308	88309
20000	28480	42	applied	\N	\N	\N	\N	88310	88310	88311
20000	28481	43	applied	\N	\N	\N	\N	88312	88312	88313
20000	28487	44	applied	\N	\N	\N	\N	88333	88333	88628
20000	28490	45	applied	\N	\N	\N	\N	88341	88341	88319
20000	28494	46	applied	\N	\N	\N	\N	88368	88368	88629
20000	28482	47	applied	\N	\N	\N	\N	88314	88314	88630
20000	28483	48	applied	\N	\N	\N	\N	88316	88316	88631
20000	28484	49	applied	\N	\N	\N	\N	88318	88318	88342
20000	28485	50	applied	\N	\N	\N	\N	88320	88320	88344
20000	28491	51	applied	\N	\N	\N	\N	88343	88343	88632
20000	28505	52	applied	\N	\N	\N	\N	88402	88402	88346
20000	28514	53	applied	\N	\N	\N	\N	88425	88425	88633
20000	28525	54	applied	\N	\N	\N	\N	88453	88453	88634
20000	28532	55	applied	\N	\N	\N	\N	88476	88476	88369
20000	28548	56	applied	\N	\N	\N	\N	88512	88512	88635
20000	28488	57	applied	\N	\N	\N	\N	88336	88336	88636
20000	28492	58	applied	\N	\N	\N	\N	88345	88345	88637
20000	28495	59	applied	\N	\N	\N	\N	88370	88370	88379
20000	28497	60	applied	\N	\N	\N	\N	88376	88376	88638
20000	28501	61	applied	\N	\N	\N	\N	88388	88388	88639
20000	28504	62	applied	\N	\N	\N	\N	88400	88400	88640
20000	28508	63	applied	\N	\N	\N	\N	88411	88411	88399
20000	28509	64	applied	\N	\N	\N	\N	88413	88413	88401
20000	28516	65	applied	\N	\N	\N	\N	88429	88429	88641
20000	28517	66	applied	\N	\N	\N	\N	88431	88431	88642
20000	28521	67	applied	\N	\N	\N	\N	88441	88441	88643
20000	28524	68	applied	\N	\N	\N	\N	88451	88451	88416
20000	28528	69	applied	\N	\N	\N	\N	88459	88459	88644
20000	28535	70	applied	\N	\N	\N	\N	88482	88482	88426
20000	28536	71	applied	\N	\N	\N	\N	88484	88484	88645
20000	28537	72	applied	\N	\N	\N	\N	88486	88486	88646
20000	28540	73	applied	\N	\N	\N	\N	88495	88495	88647
20000	28543	74	applied	\N	\N	\N	\N	88501	88501	88648
20000	28549	75	applied	\N	\N	\N	\N	88514	88514	88434
20000	28552	76	applied	\N	\N	\N	\N	88521	88521	88649
20000	28554	77	applied	\N	\N	\N	\N	88528	88528	88650
20000	28559	79	applied	\N	\N	\N	\N	88541	88541	88652
20000	28563	80	applied	\N	\N	\N	\N	88554	88554	88454
20000	28572	81	applied	\N	\N	\N	\N	88573	88573	88653
20000	28573	82	applied	\N	\N	\N	\N	88575	88575	88654
20000	28574	83	applied	\N	\N	\N	\N	88577	88577	88458
20000	28579	84	applied	\N	\N	\N	\N	88591	88591	88460
20000	28584	85	applied	\N	\N	\N	\N	88608	88608	88655
20000	28588	86	applied	\N	\N	\N	\N	88619	88619	88479
20000	28561	87	applied	\N	\N	\N	\N	88545	88545	88656
20000	28569	88	applied	\N	\N	\N	\N	88568	88568	88657
20000	28498	89	applied	\N	\N	\N	\N	88378	88378	88483
20000	28500	90	applied	\N	\N	\N	\N	88386	88386	88658
20000	28503	91	applied	\N	\N	\N	\N	88398	88398	88496
20000	28510	92	applied	\N	\N	\N	\N	88415	88415	88498
20000	28511	93	applied	\N	\N	\N	\N	88417	88417	88500
20000	28515	94	applied	\N	\N	\N	\N	88427	88427	88659
20000	28518	95	applied	\N	\N	\N	\N	88433	88433	88513
20000	28520	96	applied	\N	\N	\N	\N	88439	88439	88660
20000	28526	97	applied	\N	\N	\N	\N	88455	88455	88661
20000	28527	98	applied	\N	\N	\N	\N	88457	88457	88529
20000	28533	99	applied	\N	\N	\N	\N	88478	88478	88533
20000	28534	100	applied	\N	\N	\N	\N	88480	88480	88662
20000	28541	101	applied	\N	\N	\N	\N	88497	88497	88546
20000	28542	102	applied	\N	\N	\N	\N	88499	88499	88663
20000	28546	103	applied	\N	\N	\N	\N	88508	88508	88569
20000	28550	104	applied	\N	\N	\N	\N	88518	88518	88572
20000	28556	105	applied	\N	\N	\N	\N	88532	88532	88585
20000	28560	106	applied	\N	\N	\N	\N	88543	88543	88578
20000	28564	107	applied	\N	\N	\N	\N	88556	88556	88580
20000	28571	108	applied	\N	\N	\N	\N	88571	88571	88582
20000	28575	109	applied	\N	\N	\N	\N	88579	88579	88590
20000	28576	110	applied	\N	\N	\N	\N	88581	88581	88664
20000	28578	111	applied	\N	\N	\N	\N	88589	88589	88665
20000	28583	112	applied	\N	\N	\N	\N	88606	88606	88666
20002	28590	0	applied	\N	\N	\N	\N	88670	88670	88671
20002	28591	1	applied	\N	\N	\N	\N	88672	88672	88673
20002	28592	2	applied	\N	\N	\N	\N	88674	88674	88675
20002	28593	3	applied	\N	\N	\N	\N	88676	88676	88677
20002	28594	4	applied	\N	\N	\N	\N	88678	88678	88679
20004	28595	0	applied	\N	\N	\N	\N	88683	88683	88684
20004	28596	1	applied	\N	\N	\N	\N	88685	88685	88686
20004	28597	2	applied	\N	\N	\N	\N	88687	88687	88688
20004	28598	3	applied	\N	\N	\N	\N	88689	88689	88690
20004	28599	4	applied	\N	\N	\N	\N	88691	88691	88692
20007	28595	0	applied	\N	\N	\N	\N	88683	88683	88684
20007	28596	1	applied	\N	\N	\N	\N	88685	88685	88686
20007	28598	2	applied	\N	\N	\N	\N	88689	88689	88690
20007	28599	3	applied	\N	\N	\N	\N	88691	88691	88692
20009	28600	0	applied	\N	\N	\N	\N	88699	88699	88700
20009	28597	1	applied	\N	\N	\N	\N	88687	88687	88688
20009	28601	2	applied	\N	\N	\N	\N	88701	88701	88702
20009	28602	3	applied	\N	\N	\N	\N	88703	88703	88704
20009	28603	4	applied	\N	\N	\N	\N	88705	88705	88706
20009	28604	5	applied	\N	\N	\N	\N	88707	88707	88708
20009	28605	6	applied	\N	\N	\N	\N	88709	88709	88710
20009	28606	7	applied	\N	\N	\N	\N	88711	88711	88712
20009	28607	8	applied	\N	\N	\N	\N	88713	88713	88714
20009	28608	9	applied	\N	\N	\N	\N	88715	88715	88716
20009	28609	10	applied	\N	\N	\N	\N	88717	88717	88718
20012	28616	0	applied	\N	\N	\N	\N	88734	88734	88735
20012	28617	1	applied	\N	\N	\N	\N	88736	88736	88737
20012	28618	2	applied	\N	\N	\N	\N	88738	88738	88739
20023	28641	0	applied	\N	\N	\N	\N	88801	88801	88802
20023	28642	1	applied	\N	\N	\N	\N	88803	88803	88804
20023	28643	2	applied	\N	\N	\N	\N	88805	88805	88806
20023	28644	3	applied	\N	\N	\N	\N	88807	88807	88808
20023	28645	4	applied	\N	\N	\N	\N	88809	88809	88810
20023	28646	5	applied	\N	\N	\N	\N	88811	88811	88812
20023	28647	6	applied	\N	\N	\N	\N	88813	88813	88814
20023	28648	7	applied	\N	\N	\N	\N	88815	88815	88816
20023	28649	8	applied	\N	\N	\N	\N	88817	88817	88818
20036	28670	0	applied	\N	\N	\N	\N	88870	88870	88871
20036	28671	1	applied	\N	\N	\N	\N	88872	88872	88873
20036	28672	2	applied	\N	\N	\N	\N	88874	88874	88875
20037	28673	0	applied	\N	\N	\N	\N	88878	88878	88059
20037	28674	1	applied	\N	\N	\N	\N	88879	88879	88880
20037	28675	2	applied	\N	\N	\N	\N	88881	88881	88882
20037	28676	3	applied	\N	\N	\N	\N	88883	88883	88884
20037	28677	4	applied	\N	\N	\N	\N	88885	88885	88886
20040	28678	0	applied	\N	\N	\N	\N	88890	88890	88891
20040	28679	1	applied	\N	\N	\N	\N	88892	88892	88893
20040	28680	2	applied	\N	\N	\N	\N	88894	88894	88895
20045	28684	0	applied	\N	\N	\N	\N	88908	88908	88909
20045	28685	1	applied	\N	\N	\N	\N	88910	88910	88911
20045	28686	2	applied	\N	\N	\N	\N	88912	88912	47675
20045	28687	3	applied	\N	\N	\N	\N	88913	88913	88914
20049	28695	0	applied	\N	\N	\N	\N	88938	88938	88939
20049	28696	1	applied	\N	\N	\N	\N	88940	88940	88941
20049	28697	2	applied	\N	\N	\N	\N	88942	88942	88943
20051	28698	0	applied	\N	\N	\N	\N	88947	88947	88948
20051	28699	1	applied	\N	\N	\N	\N	88949	88949	88950
20051	28700	2	applied	\N	\N	\N	\N	88951	88951	88952
20051	28701	3	applied	\N	\N	\N	\N	88953	88953	88954
20056	28740	0	applied	\N	\N	\N	\N	89037	89037	89038
20056	28741	1	applied	\N	\N	\N	\N	89039	89039	88861
20056	28742	2	applied	\N	\N	\N	\N	89040	89040	89041
20058	28743	0	applied	\N	\N	\N	\N	89044	89044	89045
20058	28744	1	applied	\N	\N	\N	\N	89046	89046	89047
20058	28745	2	applied	\N	\N	\N	\N	89048	89048	89049
20062	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20062	28776	1	applied	\N	\N	\N	\N	89111	89111	89112
20062	28777	2	applied	\N	\N	\N	\N	89113	89113	89114
20066	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20066	28776	1	applied	\N	\N	\N	\N	89111	89111	89112
20066	28777	2	applied	\N	\N	\N	\N	89113	89113	89114
20068	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20068	28777	1	applied	\N	\N	\N	\N	89113	89113	89155
20069	28778	0	applied	\N	\N	\N	\N	89159	89159	89160
20069	28779	1	applied	\N	\N	\N	\N	89161	89161	89162
20069	28780	2	applied	\N	\N	\N	\N	89163	89163	89164
20069	28781	3	applied	\N	\N	\N	\N	89165	89165	89166
20071	28782	0	applied	\N	\N	\N	\N	89171	89171	89172
20071	28783	1	applied	\N	\N	\N	\N	89173	89173	89174
20071	28784	2	applied	\N	\N	\N	\N	89175	89175	89176
20071	28785	3	applied	\N	\N	\N	\N	89177	89177	89178
20078	28792	0	applied	\N	\N	\N	\N	89201	89201	89202
20078	28793	1	applied	\N	\N	\N	\N	89203	89203	89204
20078	28794	2	applied	\N	\N	\N	\N	89205	89205	89206
20081	28800	0	applied	\N	\N	\N	\N	89221	89221	89222
20081	28801	1	applied	\N	\N	\N	\N	89223	89223	89224
20081	28802	2	applied	\N	\N	\N	\N	89225	89225	89226
20081	28803	3	applied	\N	\N	\N	\N	89227	89227	89228
20081	28804	4	applied	\N	\N	\N	\N	89229	89229	89230
20081	28805	5	applied	\N	\N	\N	\N	89231	89231	89232
20081	28806	6	applied	\N	\N	\N	\N	89233	89233	89234
20083	28814	0	applied	\N	\N	\N	\N	89256	89256	89256
20083	28815	1	applied	\N	\N	1000000000	\N	89257	89257	89258
20083	28816	2	applied	\N	\N	\N	\N	89259	89259	89260
20083	28817	3	applied	\N	\N	\N	\N	89261	89261	89262
20083	28818	4	applied	\N	\N	\N	\N	89263	89263	89264
20083	28819	5	applied	\N	\N	\N	\N	89265	89265	89266
20083	28820	6	applied	\N	\N	\N	\N	89267	89267	89268
20083	28821	7	applied	\N	\N	\N	\N	89269	89269	89270
20088	28861	0	applied	\N	\N	\N	\N	89359	89359	89257
20088	28862	1	applied	\N	\N	\N	\N	89360	89360	89361
20088	28863	2	applied	\N	\N	\N	\N	89362	89362	89363
20088	28864	3	applied	\N	\N	\N	\N	89364	89364	89365
20088	28865	4	applied	\N	\N	\N	\N	89366	89366	89367
20088	28866	5	applied	\N	\N	\N	\N	89368	89368	89369
20088	28867	6	applied	\N	\N	\N	\N	89370	89370	89371
20088	28868	7	applied	\N	\N	\N	\N	89372	89372	89373
20088	28869	8	applied	\N	\N	\N	\N	89374	89374	89375
20088	28870	9	applied	\N	\N	\N	\N	89376	89376	89377
20088	28871	10	applied	\N	\N	\N	\N	89378	89378	89379
20088	28872	11	applied	\N	\N	\N	\N	89380	89380	89381
20088	28873	12	applied	\N	\N	\N	\N	89382	89382	89383
20093	28906	0	applied	\N	\N	\N	\N	32796	32796	89455
20093	28907	1	applied	\N	\N	\N	\N	89456	89456	89457
20093	28908	2	applied	\N	\N	\N	\N	89458	89458	89459
20093	28909	3	applied	\N	\N	\N	\N	89460	89460	89461
20052	28711	9	applied	\N	\N	\N	\N	88973	88973	88974
20052	28712	10	applied	\N	\N	\N	\N	88975	88975	88976
20052	28713	11	applied	\N	\N	\N	\N	88977	88977	88978
20052	28714	12	applied	\N	\N	\N	\N	88979	88979	88980
20052	28715	13	applied	\N	\N	\N	\N	88981	88981	88982
20052	28716	15	applied	\N	\N	\N	\N	88984	88984	88985
20052	28717	16	applied	\N	\N	\N	\N	88986	88986	88987
20052	28718	17	applied	\N	\N	\N	\N	88988	88988	88989
20052	28719	18	applied	\N	\N	\N	\N	88990	88990	88991
20052	28720	19	applied	\N	\N	\N	\N	88992	88992	88993
20052	28721	20	applied	\N	\N	\N	\N	88994	88994	88995
20052	28722	21	applied	\N	\N	\N	\N	88996	88996	88997
20052	28723	22	applied	\N	\N	\N	\N	88998	88998	88999
20052	28724	23	applied	\N	\N	\N	\N	89000	89000	89001
20052	28725	24	applied	\N	\N	\N	\N	89002	89002	89003
20052	28726	25	applied	\N	\N	\N	\N	89004	89004	89005
20052	28727	26	applied	\N	\N	\N	\N	89006	89006	89007
20052	28728	27	applied	\N	\N	\N	\N	89008	89008	89009
20052	28729	28	applied	\N	\N	\N	\N	89010	89010	89011
20052	28730	29	applied	\N	\N	\N	\N	89012	89012	89013
20052	28731	30	applied	\N	\N	\N	\N	89014	89014	89015
20052	28732	31	applied	\N	\N	\N	\N	89016	89016	89017
20055	28703	0	applied	\N	\N	\N	\N	88957	88957	88958
20055	28704	1	applied	\N	\N	\N	\N	88959	88959	88960
20055	28705	2	applied	\N	\N	\N	\N	88961	88961	88962
20055	28706	3	applied	\N	\N	\N	\N	88963	88963	88964
20055	28707	4	applied	\N	\N	\N	\N	88965	88965	88966
20055	28708	5	applied	\N	\N	\N	\N	88967	88967	88968
20055	28709	6	applied	\N	\N	\N	\N	88969	88969	88970
20055	28710	7	applied	\N	\N	\N	\N	88971	88971	88972
20055	28711	8	applied	\N	\N	\N	\N	88973	88973	88974
20055	28712	9	applied	\N	\N	\N	\N	88975	88975	88976
20055	28713	10	applied	\N	\N	\N	\N	88977	88977	88978
20055	28714	11	applied	\N	\N	\N	\N	88979	88979	88980
20055	28715	12	applied	\N	\N	\N	\N	88981	88981	88982
20055	28716	13	applied	\N	\N	\N	\N	88984	88984	88985
20055	28717	14	applied	\N	\N	\N	\N	88986	88986	88987
20055	28718	15	applied	\N	\N	\N	\N	88988	88988	88989
20055	28719	16	applied	\N	\N	\N	\N	88990	88990	88991
20055	28720	17	applied	\N	\N	\N	\N	88992	88992	88993
20055	28721	18	applied	\N	\N	\N	\N	88994	88994	88995
20055	28722	19	applied	\N	\N	\N	\N	88996	88996	88997
20055	28723	20	applied	\N	\N	\N	\N	88998	88998	88999
20055	28724	21	applied	\N	\N	\N	\N	89000	89000	89001
20055	28725	22	applied	\N	\N	\N	\N	89002	89002	89003
20055	28726	23	applied	\N	\N	\N	\N	89004	89004	89005
20055	28727	24	applied	\N	\N	\N	\N	89006	89006	89007
20055	28728	25	applied	\N	\N	\N	\N	89008	89008	89009
20055	28729	26	applied	\N	\N	\N	\N	89010	89010	89011
20055	28730	27	applied	\N	\N	\N	\N	89012	89012	89013
20057	28703	0	applied	\N	\N	\N	\N	88957	88957	88958
20057	28704	1	applied	\N	\N	\N	\N	88959	88959	88960
20057	28705	2	applied	\N	\N	\N	\N	88961	88961	88962
20057	28706	3	applied	\N	\N	\N	\N	88963	88963	88964
20057	28707	4	applied	\N	\N	\N	\N	88965	88965	88966
20057	28708	5	applied	\N	\N	\N	\N	88967	88967	88968
20057	28709	6	applied	\N	\N	\N	\N	88969	88969	88970
20057	28710	7	applied	\N	\N	\N	\N	88971	88971	88972
20057	28711	8	applied	\N	\N	\N	\N	88973	88973	88974
20057	28712	9	applied	\N	\N	\N	\N	88975	88975	88976
20057	28713	10	applied	\N	\N	\N	\N	88977	88977	88978
20057	28714	11	applied	\N	\N	\N	\N	88979	88979	88980
20057	28715	12	applied	\N	\N	\N	\N	88981	88981	88982
20057	28716	13	applied	\N	\N	\N	\N	88984	88984	88985
20057	28717	14	applied	\N	\N	\N	\N	88986	88986	88987
20057	28718	15	applied	\N	\N	\N	\N	88988	88988	88989
20057	28719	16	applied	\N	\N	\N	\N	88990	88990	88991
20057	28720	17	applied	\N	\N	\N	\N	88992	88992	88993
20057	28721	18	applied	\N	\N	\N	\N	88994	88994	88995
20057	28722	19	applied	\N	\N	\N	\N	88996	88996	88997
20057	28723	20	applied	\N	\N	\N	\N	88998	88998	88999
20057	28724	21	applied	\N	\N	\N	\N	89000	89000	89001
20057	28725	22	applied	\N	\N	\N	\N	89002	89002	89003
20057	28726	23	applied	\N	\N	\N	\N	89004	89004	89005
20057	28727	24	applied	\N	\N	\N	\N	89006	89006	89007
20057	28728	25	applied	\N	\N	\N	\N	89008	89008	89009
20057	28729	26	applied	\N	\N	\N	\N	89010	89010	89011
20057	28730	27	applied	\N	\N	\N	\N	89012	89012	89013
20060	28746	0	applied	\N	\N	\N	\N	89051	89051	89052
20060	28747	1	applied	\N	\N	\N	\N	89053	89053	89054
20060	28748	2	applied	\N	\N	\N	\N	89055	89055	89056
20060	28749	3	applied	\N	\N	\N	\N	89057	89057	89058
20060	28750	4	applied	\N	\N	\N	\N	89059	89059	89060
20060	28751	5	applied	\N	\N	\N	\N	89061	89061	89062
20060	28752	6	applied	\N	\N	\N	\N	89063	89063	89064
20060	28753	7	applied	\N	\N	\N	\N	89065	89065	89066
20060	28754	8	applied	\N	\N	\N	\N	89067	89067	89068
20060	28755	9	applied	\N	\N	\N	\N	89069	89069	89070
20060	28756	10	applied	\N	\N	\N	\N	89071	89071	89072
20060	28757	11	applied	\N	\N	\N	\N	89073	89073	13857
20060	28758	12	applied	\N	\N	\N	\N	89074	89074	89075
20060	28759	13	applied	\N	\N	\N	\N	89076	89076	89077
20061	28760	0	applied	\N	\N	\N	\N	89079	89079	89080
20061	28761	1	applied	\N	\N	\N	\N	89081	89081	89082
20061	28762	2	applied	\N	\N	\N	\N	89083	89083	89084
20061	28763	3	applied	\N	\N	\N	\N	89085	89085	89086
20061	28764	4	applied	\N	\N	\N	\N	89087	89087	89088
20061	28765	5	applied	\N	\N	\N	\N	89089	89089	89090
20061	28766	6	applied	\N	\N	\N	\N	89091	89091	89092
20061	28767	7	applied	\N	\N	\N	\N	89093	89093	89094
20061	28768	8	applied	\N	\N	\N	\N	89095	89095	89096
20061	28769	9	applied	\N	\N	\N	\N	89097	89097	89098
20061	28770	10	applied	\N	\N	\N	\N	89099	89099	89100
20061	28771	11	applied	\N	\N	\N	\N	89101	89101	89102
20061	28772	12	applied	\N	\N	\N	\N	89103	89103	89104
20061	28773	13	applied	\N	\N	\N	\N	89105	89105	88861
20061	28774	14	applied	\N	\N	\N	\N	89106	89106	89107
20064	28775	0	applied	\N	\N	\N	\N	89109	89109	89110
20064	28776	1	applied	\N	\N	\N	\N	89111	89111	89112
20064	28777	2	applied	\N	\N	\N	\N	89113	89113	89114
20073	28782	0	applied	\N	\N	\N	\N	89171	89171	89172
20073	28783	1	applied	\N	\N	\N	\N	89173	89173	89174
20073	28784	2	applied	\N	\N	\N	\N	89175	89175	89176
20073	28785	3	applied	\N	\N	\N	\N	89177	89177	89178
20077	28789	0	applied	\N	\N	\N	\N	89191	89191	89192
20077	28790	1	applied	\N	\N	\N	\N	89193	89193	89194
20077	28791	2	applied	\N	\N	\N	\N	89195	89195	89196
20079	28795	0	applied	\N	\N	\N	\N	89209	89209	89210
20079	28796	1	applied	\N	\N	\N	\N	89211	89211	89212
20079	28797	2	applied	\N	\N	\N	\N	89213	89213	89214
20067	28664	46	applied	\N	\N	\N	\N	88854	88854	89126
20067	28669	47	applied	\N	\N	\N	\N	88866	88866	88884
20067	28662	48	applied	\N	\N	1000000000	\N	88848	88848	88849
20067	28773	49	applied	\N	\N	\N	\N	89105	89105	85183
20067	28666	50	applied	\N	\N	\N	\N	88858	88858	88886
20067	28677	51	applied	\N	\N	\N	\N	88885	88885	89127
20067	28774	52	applied	\N	\N	\N	\N	89106	89106	89107
20067	28672	53	applied	\N	\N	\N	\N	88874	88874	89128
20067	28680	54	applied	\N	\N	\N	\N	88894	88894	88903
20067	28687	55	applied	\N	\N	\N	\N	88913	88913	89129
20067	28690	56	applied	\N	\N	\N	\N	88924	88924	89130
20067	28691	57	applied	\N	\N	\N	\N	88926	88926	88911
20067	28697	58	applied	\N	\N	\N	\N	88942	88942	88914
20067	28700	59	applied	\N	\N	\N	\N	88951	88951	88925
20067	28732	60	applied	\N	\N	\N	\N	89016	89016	88927
20067	28735	61	applied	\N	\N	\N	\N	89024	89024	89131
20067	28739	62	applied	\N	\N	\N	\N	89034	89034	89132
20067	28742	63	applied	\N	\N	\N	\N	89040	89040	88931
20067	28744	64	applied	\N	\N	\N	\N	89046	89046	89133
20067	28750	65	applied	\N	\N	\N	\N	89059	89059	88941
20067	28755	66	applied	\N	\N	\N	\N	89069	89069	88943
20067	28756	67	applied	\N	\N	\N	\N	89071	89071	89134
20067	28758	68	applied	\N	\N	\N	\N	89074	89074	89135
20067	28770	69	applied	\N	\N	\N	\N	89099	89099	88954
20067	28771	70	applied	\N	\N	\N	\N	89101	89101	89136
20067	28772	71	applied	\N	\N	\N	\N	89103	89103	89137
20067	28777	72	applied	\N	\N	\N	\N	89113	89113	89138
20067	28683	73	applied	\N	\N	\N	\N	88904	88904	89139
20067	28685	74	applied	\N	\N	\N	\N	88910	88910	89140
20067	28692	75	applied	\N	\N	\N	\N	88928	88928	89141
20067	28693	76	applied	\N	\N	\N	\N	88930	88930	89041
20067	28696	77	applied	\N	\N	\N	\N	88940	88940	89142
20067	28699	78	applied	\N	\N	\N	\N	88949	88949	89143
20067	28731	80	applied	\N	\N	\N	\N	89014	89014	89145
20067	28734	81	applied	\N	\N	\N	\N	89022	89022	89146
20067	28738	82	applied	\N	\N	\N	\N	89032	89032	89147
20067	28745	83	applied	\N	\N	\N	\N	89048	89048	89148
20067	28751	84	applied	\N	\N	\N	\N	89061	89061	89070
20067	28752	85	applied	\N	\N	\N	\N	89063	89063	89149
20067	28753	86	applied	\N	\N	\N	\N	89065	89065	89150
20067	28754	87	applied	\N	\N	\N	\N	89067	89067	89151
20067	28764	88	applied	\N	\N	\N	\N	89087	89087	89152
20067	28765	89	applied	\N	\N	\N	\N	89089	89089	89153
20067	28768	90	applied	\N	\N	\N	\N	89095	89095	89102
20067	28776	91	applied	\N	\N	\N	\N	89111	89111	89154
20067	28694	92	applied	\N	\N	\N	\N	88932	88932	89155
20067	28701	93	applied	\N	\N	\N	\N	88953	88953	89112
20067	28737	94	applied	\N	\N	\N	\N	89030	89030	89156
20067	28759	95	applied	\N	\N	\N	\N	89076	89076	89114
20074	28782	0	applied	\N	\N	\N	\N	89171	89171	89172
20074	28783	1	applied	\N	\N	\N	\N	89173	89173	89174
20074	28784	2	applied	\N	\N	\N	\N	89175	89175	89176
20074	28785	3	applied	\N	\N	\N	\N	89177	89177	89178
20075	28786	0	applied	\N	\N	\N	\N	89184	89184	89185
20075	28787	1	applied	\N	\N	\N	\N	89186	89186	89187
20075	28788	2	applied	\N	\N	\N	\N	89188	89188	89189
20080	28800	0	applied	\N	\N	\N	\N	89221	89221	89222
20080	28801	1	applied	\N	\N	\N	\N	89223	89223	89224
20080	28802	2	applied	\N	\N	\N	\N	89225	89225	89226
20080	28803	3	applied	\N	\N	\N	\N	89227	89227	89228
20080	28804	4	applied	\N	\N	\N	\N	89229	89229	89230
20080	28805	5	applied	\N	\N	\N	\N	89231	89231	89232
20080	28806	6	applied	\N	\N	\N	\N	89233	89233	89234
20082	28807	0	applied	\N	\N	\N	\N	89239	89239	89240
20082	28808	1	applied	\N	\N	\N	\N	89241	89241	89242
20082	28809	2	applied	\N	\N	\N	\N	89243	89243	89244
20082	28810	3	applied	\N	\N	\N	\N	89245	89245	89246
20082	28811	4	applied	\N	\N	\N	\N	89247	89247	89248
20082	28812	5	applied	\N	\N	1000000000	\N	89249	89249	89250
20082	28813	7	applied	\N	\N	\N	\N	89252	89252	89253
20087	28834	0	applied	\N	\N	\N	\N	89304	89304	89304
20087	28822	1	applied	\N	\N	\N	\N	89278	89278	89279
20087	28823	2	applied	\N	\N	\N	\N	89280	89280	89281
20087	28824	3	applied	\N	\N	\N	\N	89282	89282	89283
20087	28825	4	applied	\N	\N	\N	\N	89284	89284	89285
20087	28835	5	applied	\N	\N	\N	\N	89305	89305	89306
20087	28836	6	applied	\N	\N	\N	\N	89307	89307	89308
20087	28826	7	applied	\N	\N	\N	\N	89286	89286	89287
20087	28827	8	applied	\N	\N	\N	\N	89288	89288	89289
20087	28828	9	applied	\N	\N	\N	\N	89290	89290	89291
20087	28829	10	applied	\N	\N	\N	\N	89292	89292	89293
20087	28830	11	applied	\N	\N	\N	\N	89294	89294	89295
20087	28831	12	applied	\N	\N	\N	\N	89296	89296	89297
20087	28837	13	applied	\N	\N	\N	\N	89309	89309	89310
20087	28838	14	applied	\N	\N	\N	\N	89311	89311	89312
20087	28839	15	applied	\N	\N	\N	\N	89313	89313	89314
20087	28840	16	applied	\N	\N	\N	\N	89315	89315	89316
20087	28841	17	applied	\N	\N	\N	\N	89317	89317	89318
20087	28842	18	applied	\N	\N	\N	\N	89319	89319	89320
20087	28843	19	applied	\N	\N	\N	\N	89321	89321	89322
20087	28844	20	applied	\N	\N	\N	\N	89323	89323	89324
20087	28845	21	applied	\N	\N	\N	\N	89325	89325	89326
20087	28846	22	applied	\N	\N	\N	\N	89327	89327	89328
20087	28847	23	applied	\N	\N	\N	\N	89329	89329	89330
20087	28848	24	applied	\N	\N	\N	\N	89331	89331	89332
20087	28849	25	applied	\N	\N	\N	\N	89333	89333	89334
20087	28850	26	applied	\N	\N	\N	\N	89335	89335	89336
20087	28851	27	applied	\N	\N	\N	\N	89337	89337	89338
20087	28852	28	applied	\N	\N	\N	\N	89339	89339	89340
20087	28853	29	applied	\N	\N	\N	\N	89341	89341	89342
20087	28854	30	applied	\N	\N	\N	\N	89343	89343	89344
20087	28832	31	applied	\N	\N	\N	\N	89298	89298	89299
20087	28855	32	applied	\N	\N	\N	\N	89345	89345	89346
20087	28856	33	applied	\N	\N	\N	\N	89347	89347	89348
20087	28857	34	applied	\N	\N	1000000000	\N	89349	89349	89350
20087	28858	35	applied	\N	\N	\N	\N	89351	89351	89352
20087	28833	36	applied	\N	\N	\N	\N	89300	89300	89353
20087	28859	37	applied	\N	\N	\N	\N	89354	89354	89355
20087	28860	38	applied	\N	\N	\N	\N	89356	89356	89357
20090	28874	0	applied	\N	\N	\N	\N	89385	89385	89386
20090	28879	1	applied	\N	\N	\N	\N	89395	89395	89396
20090	28885	2	applied	\N	\N	\N	\N	89407	89407	89408
20090	28886	3	applied	\N	\N	\N	\N	89409	89409	89410
20092	28887	0	applied	\N	\N	\N	\N	89415	89415	89416
20092	28888	1	applied	\N	\N	\N	\N	89417	89417	89418
20092	28889	2	applied	\N	\N	\N	\N	89419	89419	89420
20092	28890	3	applied	\N	\N	\N	\N	89421	89421	89422
20092	28891	4	applied	\N	\N	\N	\N	89423	89423	89424
20092	28892	5	applied	\N	\N	\N	\N	89425	89425	89426
20072	28785	3	applied	\N	\N	\N	\N	89177	89177	89178
20076	28789	0	applied	\N	\N	\N	\N	89191	89191	89192
20076	28790	1	applied	\N	\N	\N	\N	89193	89193	89194
20076	28791	2	applied	\N	\N	\N	\N	89195	89195	89196
20084	28814	0	applied	\N	\N	\N	\N	89256	89256	89256
20084	28815	1	applied	\N	\N	1000000000	\N	89257	89257	89258
20084	28816	2	applied	\N	\N	\N	\N	89259	89259	89260
20084	28817	3	applied	\N	\N	\N	\N	89261	89261	89262
20084	28818	4	applied	\N	\N	\N	\N	89263	89263	89264
20084	28819	5	applied	\N	\N	\N	\N	89265	89265	89266
20084	28820	6	applied	\N	\N	\N	\N	89267	89267	89268
20084	28821	7	applied	\N	\N	\N	\N	89269	89269	89270
20091	28887	0	applied	\N	\N	\N	\N	89415	89415	89416
20091	28888	1	applied	\N	\N	\N	\N	89417	89417	89418
20091	28889	2	applied	\N	\N	\N	\N	89419	89419	89420
20091	28890	3	applied	\N	\N	\N	\N	89421	89421	89422
20091	28891	4	applied	\N	\N	\N	\N	89423	89423	89424
20091	28892	5	applied	\N	\N	\N	\N	89425	89425	89426
20091	28893	6	applied	\N	\N	\N	\N	89427	89427	89428
20091	28894	7	applied	\N	\N	\N	\N	89429	89429	89430
20091	28895	8	applied	\N	\N	\N	\N	89431	89431	89432
20091	28896	9	applied	\N	\N	\N	\N	89433	89433	89434
20091	28897	10	applied	\N	\N	\N	\N	89435	89435	89436
20091	28898	11	applied	\N	\N	\N	\N	89437	89437	89438
20091	28899	12	applied	\N	\N	\N	\N	89439	89439	89440
20091	28900	13	applied	\N	\N	\N	\N	89441	89441	89442
20091	28901	14	applied	\N	\N	\N	\N	89443	89443	89444
20091	28902	15	applied	\N	\N	\N	\N	89445	89445	89446
20091	28903	16	applied	\N	\N	\N	\N	89447	89447	89448
20091	28904	17	applied	\N	\N	\N	\N	89449	89449	89450
20091	28905	18	applied	\N	\N	\N	\N	89451	89451	89452
20094	28814	0	applied	\N	\N	\N	\N	89256	89256	89256
20094	28834	1	applied	\N	\N	\N	\N	89304	89304	89304
20094	28817	2	applied	\N	\N	\N	\N	89261	89261	89262
20094	28818	3	applied	\N	\N	\N	\N	89263	89263	89264
20094	28822	4	applied	\N	\N	\N	\N	89278	89278	89279
20094	28823	5	applied	\N	\N	\N	\N	89280	89280	89281
20094	28826	6	applied	\N	\N	\N	\N	89286	89286	89287
20094	28827	7	applied	\N	\N	\N	\N	89288	89288	89289
20094	28828	8	applied	\N	\N	\N	\N	89290	89290	89291
20094	28829	9	applied	\N	\N	\N	\N	89292	89292	89293
20094	28830	10	applied	\N	\N	\N	\N	89294	89294	89295
20094	28831	11	applied	\N	\N	\N	\N	89296	89296	89297
20094	28837	12	applied	\N	\N	\N	\N	89309	89309	89310
20094	28838	13	applied	\N	\N	\N	\N	89311	89311	89312
20094	28839	14	applied	\N	\N	\N	\N	89313	89313	89314
20094	28840	15	applied	\N	\N	\N	\N	89315	89315	89316
20094	28841	16	applied	\N	\N	\N	\N	89317	89317	89318
20096	28923	0	applied	\N	\N	\N	\N	89491	89491	89492
20096	28924	1	applied	\N	\N	\N	\N	89493	89493	89494
20096	28925	3	applied	\N	\N	\N	\N	89496	89496	89497
20100	28930	0	applied	\N	\N	\N	\N	89515	89515	89516
20100	28931	1	applied	\N	\N	\N	\N	89517	89517	89518
20100	28932	2	applied	\N	\N	\N	\N	89519	89519	89520
20100	28933	3	applied	\N	\N	\N	\N	89521	89521	89522
20100	28934	4	applied	\N	\N	\N	\N	89523	89523	89524
20100	28935	5	applied	\N	\N	\N	\N	89525	89525	89526
20100	28936	6	applied	\N	\N	\N	\N	89527	89527	89528
20100	28937	7	applied	\N	\N	\N	\N	89529	89529	89530
20100	28938	8	applied	\N	\N	\N	\N	89531	89531	89532
20100	28939	9	applied	\N	\N	\N	\N	89533	89533	89534
20100	28940	10	applied	\N	\N	\N	\N	89535	89535	89536
20100	28941	11	applied	\N	\N	\N	\N	89537	89537	89538
20106	28953	0	applied	\N	\N	\N	\N	89568	89568	89569
20106	28954	1	applied	\N	\N	\N	\N	89570	89570	89571
20106	28955	2	applied	\N	\N	\N	\N	89572	89572	89573
20106	28956	3	applied	\N	\N	\N	\N	89574	89574	89575
20106	28957	4	applied	\N	\N	\N	\N	89576	89576	89577
20106	28958	5	applied	\N	\N	\N	\N	89578	89578	89579
20106	28959	6	applied	\N	\N	\N	\N	89580	89580	89581
20106	28960	7	applied	\N	\N	\N	\N	89582	89582	89583
20106	28961	8	applied	\N	\N	\N	\N	89584	89584	89585
20109	28966	0	applied	\N	\N	\N	\N	89602	89602	89603
20109	28967	1	applied	\N	\N	\N	\N	89604	89604	89605
20114	28983	0	applied	\N	\N	\N	\N	89642	89642	89643
20114	28984	1	applied	\N	\N	\N	\N	89644	89644	89645
20114	28985	2	applied	\N	\N	\N	\N	89646	89646	89647
20114	28986	3	applied	\N	\N	\N	\N	89648	89648	89649
20114	28987	4	applied	\N	\N	\N	\N	89650	89650	89651
20114	28988	5	applied	\N	\N	\N	\N	89652	89652	89653
20114	28989	6	applied	\N	\N	\N	\N	89654	89654	89655
20121	28990	0	applied	\N	\N	\N	\N	89660	89660	89661
20121	29001	1	applied	\N	\N	\N	\N	89688	89688	89689
20121	29002	2	applied	\N	\N	\N	\N	89690	89690	89691
20121	29003	3	applied	\N	\N	\N	\N	89692	89692	89693
20121	29004	4	applied	\N	\N	\N	\N	89694	89694	89695
20121	29005	5	applied	\N	\N	\N	\N	89696	89696	89697
20121	29006	6	applied	\N	\N	\N	\N	89698	89698	89699
20124	29015	0	applied	\N	\N	\N	\N	89723	89723	89724
20124	29016	1	applied	\N	\N	\N	\N	89725	89725	89726
20124	29017	2	applied	\N	\N	\N	\N	89727	89727	89728
20124	29018	3	applied	\N	\N	\N	\N	89729	89729	89730
20124	29019	4	applied	\N	\N	\N	\N	89731	89731	89732
20124	29020	5	applied	\N	\N	\N	\N	89733	89733	89734
20127	29021	0	applied	\N	\N	\N	\N	89737	89737	89738
20127	29022	1	applied	\N	\N	\N	\N	89739	89739	89740
20127	29023	2	applied	\N	\N	\N	\N	89741	89741	89742
20127	29024	3	applied	\N	\N	\N	\N	89743	89743	89744
20127	29025	4	applied	\N	\N	\N	\N	89745	89745	89746
20127	29026	5	applied	\N	\N	\N	\N	34900	34900	89747
20127	29029	6	applied	\N	\N	\N	\N	89757	89757	89758
20127	29030	7	applied	\N	\N	\N	\N	89759	89759	89760
20127	29031	8	applied	\N	\N	\N	\N	89761	89761	89751
20127	29027	9	applied	\N	\N	\N	\N	89748	89748	89762
20127	29028	10	applied	\N	\N	\N	\N	89750	89750	89763
20129	29032	0	applied	\N	\N	\N	\N	89766	89766	89767
20129	29033	1	applied	\N	\N	\N	\N	89768	89768	89769
20129	29034	2	applied	\N	\N	\N	\N	89770	89770	89762
20129	29029	3	applied	\N	\N	\N	\N	89757	89757	89771
20129	29030	4	applied	\N	\N	\N	\N	89759	89759	89772
20129	29031	5	applied	\N	\N	\N	\N	89761	89761	89773
20129	29035	6	applied	\N	\N	\N	\N	89774	89774	89775
20138	29054	0	applied	\N	\N	\N	\N	89827	89827	89828
20138	29055	1	applied	\N	\N	\N	\N	89829	89829	89830
20138	29056	2	applied	\N	\N	\N	\N	89831	89831	89832
20149	29072	0	applied	\N	\N	\N	\N	89909	89909	89910
20149	29073	1	applied	\N	\N	\N	\N	89911	89911	89912
20149	29074	2	applied	\N	\N	\N	\N	89913	89913	89914
20157	29094	0	applied	\N	\N	\N	\N	89965	89965	89966
20157	29095	1	applied	\N	\N	\N	\N	89967	89967	89968
20079	28798	3	applied	\N	\N	\N	\N	89215	89215	89216
20079	28799	4	applied	\N	\N	\N	\N	89217	89217	89218
20085	28814	0	applied	\N	\N	\N	\N	89256	89256	89256
20085	28815	1	applied	\N	\N	1000000000	\N	89257	89257	89258
20085	28816	2	applied	\N	\N	\N	\N	89259	89259	89260
20085	28817	3	applied	\N	\N	\N	\N	89261	89261	89262
20085	28818	4	applied	\N	\N	\N	\N	89263	89263	89264
20085	28819	5	applied	\N	\N	\N	\N	89265	89265	89266
20085	28820	6	applied	\N	\N	\N	\N	89267	89267	89268
20085	28821	7	applied	\N	\N	\N	\N	89269	89269	89270
20086	28822	0	applied	\N	\N	\N	\N	89278	89278	89279
20086	28823	1	applied	\N	\N	\N	\N	89280	89280	89281
20086	28824	2	applied	\N	\N	\N	\N	89282	89282	89283
20086	28825	3	applied	\N	\N	\N	\N	89284	89284	89285
20086	28826	4	applied	\N	\N	\N	\N	89286	89286	89287
20086	28827	5	applied	\N	\N	\N	\N	89288	89288	89289
20086	28828	6	applied	\N	\N	\N	\N	89290	89290	89291
20086	28829	7	applied	\N	\N	\N	\N	89292	89292	89293
20086	28830	8	applied	\N	\N	\N	\N	89294	89294	89295
20086	28831	9	applied	\N	\N	\N	\N	89296	89296	89297
20086	28832	10	applied	\N	\N	\N	\N	89298	89298	89299
20086	28833	11	applied	\N	\N	\N	\N	89300	89300	89301
20089	28874	0	applied	\N	\N	\N	\N	89385	89385	89386
20089	28875	1	applied	\N	\N	\N	\N	89387	89387	89388
20089	28876	2	applied	\N	\N	\N	\N	89389	89389	89390
20089	28877	3	applied	\N	\N	\N	\N	89391	89391	89392
20089	28878	4	applied	\N	\N	\N	\N	89393	89393	89394
20089	28879	5	applied	\N	\N	\N	\N	89395	89395	89396
20089	28880	6	applied	\N	\N	\N	\N	89397	89397	89398
20089	28881	7	applied	\N	\N	\N	\N	89399	89399	89400
20089	28882	8	applied	\N	\N	\N	\N	89401	89401	89402
20089	28883	9	applied	\N	\N	\N	\N	89403	89403	89404
20089	28884	10	applied	\N	\N	\N	\N	89405	89405	89406
20089	28885	11	applied	\N	\N	\N	\N	89407	89407	89408
20089	28886	12	applied	\N	\N	\N	\N	89409	89409	89410
20095	28906	0	applied	\N	\N	\N	\N	32796	32796	89455
20095	28907	1	applied	\N	\N	\N	\N	89456	89456	89457
20095	28908	2	applied	\N	\N	\N	\N	89458	89458	89459
20095	28909	3	applied	\N	\N	\N	\N	89460	89460	89461
20095	28910	4	applied	\N	\N	\N	\N	89462	89462	89463
20095	28911	5	applied	\N	\N	\N	\N	89464	89464	89465
20095	28912	6	applied	\N	\N	\N	\N	89466	89466	89467
20095	28913	7	applied	\N	\N	\N	\N	89468	89468	89469
20095	28914	8	applied	\N	\N	\N	\N	89470	89470	89471
20095	28915	9	applied	\N	\N	\N	\N	89472	89472	89473
20095	28916	10	applied	\N	\N	\N	\N	89474	89474	89475
20095	28917	11	applied	\N	\N	\N	\N	89476	89476	89477
20095	28918	12	applied	\N	\N	\N	\N	89478	89478	89479
20095	28919	13	applied	\N	\N	\N	\N	89480	89480	89481
20095	28920	14	applied	\N	\N	\N	\N	89482	89482	89483
20095	28921	15	applied	\N	\N	\N	\N	89484	89484	89485
20095	28922	16	applied	\N	\N	\N	\N	89486	89486	89487
20097	28923	0	applied	\N	\N	\N	\N	89491	89491	89492
20097	28926	1	applied	\N	\N	\N	\N	89500	89500	89501
20097	28927	3	applied	\N	\N	\N	\N	89503	89503	89504
20097	28924	4	applied	\N	\N	\N	\N	89493	89493	89505
20097	28928	5	applied	\N	\N	\N	\N	89506	89506	89497
20097	28925	6	applied	\N	\N	\N	\N	89496	89496	89507
20097	28929	7	applied	\N	\N	\N	\N	89508	89508	89509
20103	28953	0	applied	\N	\N	\N	\N	89568	89568	89569
20103	28954	1	applied	\N	\N	\N	\N	89570	89570	89571
20103	28955	2	applied	\N	\N	\N	\N	89572	89572	89573
20103	28956	3	applied	\N	\N	\N	\N	89574	89574	89575
20103	28957	4	applied	\N	\N	\N	\N	89576	89576	89577
20103	28958	5	applied	\N	\N	\N	\N	89578	89578	89579
20103	28959	6	applied	\N	\N	\N	\N	89580	89580	89581
20103	28960	7	applied	\N	\N	\N	\N	89582	89582	89583
20103	28961	8	applied	\N	\N	\N	\N	89584	89584	89585
20107	28962	0	applied	\N	\N	\N	\N	32509	32509	89592
20107	28963	1	applied	\N	\N	\N	\N	89593	89593	89594
20107	28964	2	applied	\N	\N	\N	\N	89595	89595	89596
20107	28965	3	applied	\N	\N	\N	\N	89597	89597	89598
20112	28977	0	applied	\N	\N	\N	\N	89627	89627	89628
20112	28978	1	applied	\N	\N	\N	\N	89629	89629	89630
20119	28998	0	applied	\N	\N	\N	\N	89680	89680	89681
20119	28999	1	applied	\N	\N	\N	\N	89682	89682	89683
20119	29000	2	applied	\N	\N	\N	\N	89684	89684	89685
20122	29007	0	applied	\N	\N	\N	\N	89703	89703	89704
20122	29008	1	applied	\N	\N	\N	\N	89705	89705	89706
20122	29009	2	applied	\N	\N	\N	\N	89707	89707	89708
20122	29010	3	applied	\N	\N	\N	\N	89709	89709	89710
20122	29011	4	applied	\N	\N	\N	\N	89711	89711	89712
20122	29012	5	applied	\N	\N	\N	\N	89713	89713	89714
20122	29013	6	applied	\N	\N	\N	\N	89715	89715	89716
20122	29014	7	applied	\N	\N	\N	\N	89717	89717	89718
20125	29021	0	applied	\N	\N	\N	\N	89737	89737	89738
20125	29022	1	applied	\N	\N	\N	\N	89739	89739	89740
20125	29023	2	applied	\N	\N	\N	\N	89741	89741	89742
20125	29024	3	applied	\N	\N	\N	\N	89743	89743	89744
20125	29025	4	applied	\N	\N	\N	\N	89745	89745	89746
20125	29026	5	applied	\N	\N	\N	\N	34900	34900	89747
20125	29027	6	applied	\N	\N	\N	\N	89748	89748	89749
20125	29028	7	applied	\N	\N	\N	\N	89750	89750	89751
20132	29036	0	applied	\N	\N	\N	\N	89782	89782	89783
20132	29037	1	applied	\N	\N	\N	\N	89784	89784	89785
20132	29038	2	applied	\N	\N	\N	\N	89786	89786	89787
20132	29039	3	applied	\N	\N	\N	\N	89788	89788	89789
20132	29040	4	applied	\N	\N	\N	\N	89790	89790	89791
20132	29041	5	applied	\N	\N	\N	\N	89792	89792	89793
20134	29042	0	applied	\N	\N	\N	\N	89798	89798	89799
20134	29043	1	applied	\N	\N	\N	\N	32444	32444	89800
20134	29044	2	applied	\N	\N	\N	\N	89801	89801	89802
20134	29045	3	applied	\N	\N	\N	\N	89803	89803	89804
20134	29046	4	applied	\N	\N	\N	\N	89805	89805	89806
20134	29047	5	applied	\N	\N	\N	\N	89807	89807	89808
20134	29048	6	applied	\N	\N	\N	\N	89809	89809	89810
20134	29049	7	applied	\N	\N	\N	\N	89811	89811	89812
20134	29050	8	applied	\N	\N	\N	\N	89813	89813	89814
20134	29051	9	applied	\N	\N	\N	\N	89815	89815	89816
20139	29054	0	applied	\N	\N	\N	\N	89827	89827	89828
20139	29055	1	applied	\N	\N	\N	\N	89829	89829	89830
20139	29056	2	applied	\N	\N	\N	\N	89831	89831	89832
20143	29062	0	applied	\N	\N	\N	\N	89850	89850	89851
20143	29063	1	applied	\N	\N	\N	\N	89852	89852	89853
20143	29064	2	applied	\N	\N	\N	\N	89854	89854	89855
20143	29065	3	applied	\N	\N	\N	\N	89856	89856	86464
20143	29066	4	applied	\N	\N	\N	\N	89857	89857	89858
20143	29067	5	applied	\N	\N	\N	\N	89859	89859	89860
20147	29057	0	applied	\N	\N	\N	\N	89839	89839	89840
20147	29058	1	applied	\N	\N	\N	\N	89841	89841	89842
20092	28893	6	applied	\N	\N	\N	\N	89427	89427	89428
20092	28894	7	applied	\N	\N	\N	\N	89429	89429	89430
20092	28895	8	applied	\N	\N	\N	\N	89431	89431	89432
20092	28896	9	applied	\N	\N	\N	\N	89433	89433	89434
20092	28897	10	applied	\N	\N	\N	\N	89435	89435	89436
20092	28898	11	applied	\N	\N	\N	\N	89437	89437	89438
20092	28899	12	applied	\N	\N	\N	\N	89439	89439	89440
20092	28900	13	applied	\N	\N	\N	\N	89441	89441	89442
20092	28901	14	applied	\N	\N	\N	\N	89443	89443	89444
20092	28902	15	applied	\N	\N	\N	\N	89445	89445	89446
20092	28903	16	applied	\N	\N	\N	\N	89447	89447	89448
20092	28904	17	applied	\N	\N	\N	\N	89449	89449	89450
20092	28905	18	applied	\N	\N	\N	\N	89451	89451	89452
20098	28923	0	applied	\N	\N	\N	\N	89491	89491	89492
20098	28926	1	applied	\N	\N	\N	\N	89500	89500	89501
20098	28927	3	applied	\N	\N	\N	\N	89503	89503	89504
20098	28924	4	applied	\N	\N	\N	\N	89493	89493	89505
20098	28928	5	applied	\N	\N	\N	\N	89506	89506	89497
20098	28925	6	applied	\N	\N	\N	\N	89496	89496	89507
20098	28929	7	applied	\N	\N	\N	\N	89508	89508	89509
20101	28942	0	applied	\N	\N	\N	\N	89543	89543	28166
20101	28943	1	applied	\N	\N	\N	\N	89544	89544	89545
20101	28944	2	applied	\N	\N	\N	\N	89546	89546	89547
20101	28945	3	applied	\N	\N	\N	\N	89548	89548	89549
20101	28946	4	applied	\N	\N	\N	\N	89550	89550	89551
20101	28947	5	applied	\N	\N	\N	\N	89552	89552	89553
20101	28948	6	applied	\N	\N	\N	\N	89554	89554	89555
20101	28949	7	applied	\N	\N	\N	\N	89556	89556	89557
20101	28950	8	applied	\N	\N	\N	\N	89558	89558	89559
20101	28951	9	applied	\N	\N	\N	\N	89560	89560	89561
20101	28952	10	applied	\N	\N	\N	\N	89562	89562	89563
20104	28953	0	applied	\N	\N	\N	\N	89568	89568	89569
20104	28954	1	applied	\N	\N	\N	\N	89570	89570	89571
20104	28955	2	applied	\N	\N	\N	\N	89572	89572	89573
20104	28956	3	applied	\N	\N	\N	\N	89574	89574	89575
20104	28957	4	applied	\N	\N	\N	\N	89576	89576	89577
20104	28958	5	applied	\N	\N	\N	\N	89578	89578	89579
20104	28959	6	applied	\N	\N	\N	\N	89580	89580	89581
20104	28960	7	applied	\N	\N	\N	\N	89582	89582	89583
20104	28961	8	applied	\N	\N	\N	\N	89584	89584	89585
20108	28962	0	applied	\N	\N	\N	\N	32509	32509	89592
20108	28963	1	applied	\N	\N	\N	\N	89593	89593	89594
20108	28964	2	applied	\N	\N	\N	\N	89595	89595	89596
20108	28965	3	applied	\N	\N	\N	\N	89597	89597	89598
20110	28968	0	applied	\N	\N	\N	\N	89607	89607	89608
20110	28969	1	applied	\N	\N	\N	\N	89609	89609	89610
20113	28979	0	applied	\N	\N	\N	\N	89632	89632	89633
20113	28980	1	applied	\N	\N	\N	\N	89634	89634	89635
20113	28981	2	applied	\N	\N	\N	\N	89636	89636	89637
20113	28982	3	applied	\N	\N	\N	\N	89638	89638	89639
20116	28970	0	applied	\N	\N	\N	\N	89612	89612	89613
20116	28971	1	applied	\N	\N	\N	\N	89614	89614	89615
20116	28972	2	applied	\N	\N	\N	\N	89616	89616	89617
20116	28990	3	applied	\N	\N	\N	\N	89660	89660	89661
20116	28983	4	applied	\N	\N	\N	\N	89642	89642	89643
20120	28990	0	applied	\N	\N	\N	\N	89660	89660	89661
20120	29001	1	applied	\N	\N	\N	\N	89688	89688	89689
20120	29002	2	applied	\N	\N	\N	\N	89690	89690	89691
20120	29003	3	applied	\N	\N	\N	\N	89692	89692	89693
20120	29004	4	applied	\N	\N	\N	\N	89694	89694	89695
20120	29005	5	applied	\N	\N	\N	\N	89696	89696	89697
20120	29006	6	applied	\N	\N	\N	\N	89698	89698	89699
20126	29021	0	applied	\N	\N	\N	\N	89737	89737	89738
20126	29022	1	applied	\N	\N	\N	\N	89739	89739	89740
20126	29023	2	applied	\N	\N	\N	\N	89741	89741	89742
20126	29024	3	applied	\N	\N	\N	\N	89743	89743	89744
20126	29025	4	applied	\N	\N	\N	\N	89745	89745	89746
20126	29026	5	applied	\N	\N	\N	\N	34900	34900	89747
20126	29029	6	applied	\N	\N	\N	\N	89757	89757	89758
20126	29030	7	applied	\N	\N	\N	\N	89759	89759	89760
20126	29031	8	applied	\N	\N	\N	\N	89761	89761	89751
20126	29027	9	applied	\N	\N	\N	\N	89748	89748	89762
20126	29028	10	applied	\N	\N	\N	\N	89750	89750	89763
20130	29032	0	applied	\N	\N	\N	\N	89766	89766	89767
20130	29033	1	applied	\N	\N	\N	\N	89768	89768	89769
20130	29034	2	applied	\N	\N	\N	\N	89770	89770	89762
20130	29029	3	applied	\N	\N	\N	\N	89757	89757	89771
20130	29030	4	applied	\N	\N	\N	\N	89759	89759	89772
20130	29031	5	applied	\N	\N	\N	\N	89761	89761	89773
20130	29035	6	applied	\N	\N	\N	\N	89774	89774	89775
20133	29036	0	applied	\N	\N	\N	\N	89782	89782	89783
20133	29037	1	applied	\N	\N	\N	\N	89784	89784	89785
20133	29038	2	applied	\N	\N	\N	\N	89786	89786	89787
20133	29039	3	applied	\N	\N	\N	\N	89788	89788	89789
20133	29040	4	applied	\N	\N	\N	\N	89790	89790	89791
20133	29041	5	applied	\N	\N	\N	\N	89792	89792	89793
20135	29042	0	applied	\N	\N	\N	\N	89798	89798	89799
20135	29043	1	applied	\N	\N	\N	\N	32444	32444	89800
20135	29044	2	applied	\N	\N	\N	\N	89801	89801	89802
20135	29045	3	applied	\N	\N	\N	\N	89803	89803	89804
20135	29046	4	applied	\N	\N	\N	\N	89805	89805	89806
20135	29047	5	applied	\N	\N	\N	\N	89807	89807	89808
20135	29048	6	applied	\N	\N	\N	\N	89809	89809	89810
20135	29049	7	applied	\N	\N	\N	\N	89811	89811	89812
20135	29050	8	applied	\N	\N	\N	\N	89813	89813	89814
20135	29051	9	applied	\N	\N	\N	\N	89815	89815	89816
20137	29052	0	applied	\N	\N	\N	\N	89822	89822	89823
20137	29053	1	applied	\N	\N	\N	\N	89824	89824	89825
20140	29054	0	applied	\N	\N	\N	\N	89827	89827	89828
20140	29055	1	applied	\N	\N	\N	\N	89829	89829	89830
20140	29056	2	applied	\N	\N	\N	\N	89831	89831	89832
20141	29054	0	applied	\N	\N	\N	\N	89827	89827	89828
20141	29055	1	applied	\N	\N	\N	\N	89829	89829	89830
20141	29056	2	applied	\N	\N	\N	\N	89831	89831	89832
20144	29062	0	applied	\N	\N	\N	\N	89850	89850	89851
20144	29064	1	applied	\N	\N	\N	\N	89854	89854	89855
20144	29065	2	applied	\N	\N	\N	\N	89856	89856	86464
20144	29066	3	applied	\N	\N	\N	\N	89857	89857	89858
20144	29067	4	applied	\N	\N	\N	\N	89859	89859	89860
20148	29069	0	applied	\N	\N	\N	\N	89901	89901	89902
20148	29070	1	applied	\N	\N	\N	\N	89903	89903	89904
20148	29071	2	applied	\N	\N	\N	\N	89905	89905	89906
20153	29082	0	applied	\N	\N	\N	\N	89934	89934	89935
20153	29083	1	applied	\N	\N	\N	\N	89936	89936	89937
20153	29084	2	applied	\N	\N	\N	\N	89938	89938	89939
20153	29085	3	applied	\N	\N	\N	\N	89940	89940	89941
20153	29086	4	applied	\N	\N	\N	\N	89942	89942	89943
20153	29087	5	applied	\N	\N	\N	\N	89944	89944	89945
20156	29091	0	applied	\N	\N	\N	\N	89955	89955	89956
20156	29092	1	applied	\N	\N	\N	\N	89957	89957	89958
20093	28910	4	applied	\N	\N	\N	\N	89462	89462	89463
20093	28911	5	applied	\N	\N	\N	\N	89464	89464	89465
20093	28912	6	applied	\N	\N	\N	\N	89466	89466	89467
20093	28913	7	applied	\N	\N	\N	\N	89468	89468	89469
20093	28914	8	applied	\N	\N	\N	\N	89470	89470	89471
20093	28915	9	applied	\N	\N	\N	\N	89472	89472	89473
20093	28916	10	applied	\N	\N	\N	\N	89474	89474	89475
20093	28917	11	applied	\N	\N	\N	\N	89476	89476	89477
20093	28918	12	applied	\N	\N	\N	\N	89478	89478	89479
20093	28919	13	applied	\N	\N	\N	\N	89480	89480	89481
20093	28920	14	applied	\N	\N	\N	\N	89482	89482	89483
20093	28921	15	applied	\N	\N	\N	\N	89484	89484	89485
20093	28922	16	applied	\N	\N	\N	\N	89486	89486	89487
20099	28930	0	applied	\N	\N	\N	\N	89515	89515	89516
20099	28931	1	applied	\N	\N	\N	\N	89517	89517	89518
20099	28932	2	applied	\N	\N	\N	\N	89519	89519	89520
20099	28933	3	applied	\N	\N	\N	\N	89521	89521	89522
20099	28934	4	applied	\N	\N	\N	\N	89523	89523	89524
20099	28935	5	applied	\N	\N	\N	\N	89525	89525	89526
20099	28936	6	applied	\N	\N	\N	\N	89527	89527	89528
20099	28937	7	applied	\N	\N	\N	\N	89529	89529	89530
20099	28938	8	applied	\N	\N	\N	\N	89531	89531	89532
20099	28939	9	applied	\N	\N	\N	\N	89533	89533	89534
20099	28940	10	applied	\N	\N	\N	\N	89535	89535	89536
20099	28941	11	applied	\N	\N	\N	\N	89537	89537	89538
20102	28942	0	applied	\N	\N	\N	\N	89543	89543	28166
20102	28943	1	applied	\N	\N	\N	\N	89544	89544	89545
20102	28944	2	applied	\N	\N	\N	\N	89546	89546	89547
20102	28945	3	applied	\N	\N	\N	\N	89548	89548	89549
20102	28946	4	applied	\N	\N	\N	\N	89550	89550	89551
20102	28947	5	applied	\N	\N	\N	\N	89552	89552	89553
20102	28948	6	applied	\N	\N	\N	\N	89554	89554	89555
20102	28949	7	applied	\N	\N	\N	\N	89556	89556	89557
20102	28950	8	applied	\N	\N	\N	\N	89558	89558	89559
20102	28951	9	applied	\N	\N	\N	\N	89560	89560	89561
20102	28952	10	applied	\N	\N	\N	\N	89562	89562	89563
20105	28953	0	applied	\N	\N	\N	\N	89568	89568	89569
20105	28954	1	applied	\N	\N	\N	\N	89570	89570	89571
20105	28955	2	applied	\N	\N	\N	\N	89572	89572	89573
20105	28956	3	applied	\N	\N	\N	\N	89574	89574	89575
20105	28957	4	applied	\N	\N	\N	\N	89576	89576	89577
20105	28958	5	applied	\N	\N	\N	\N	89578	89578	89579
20105	28959	6	applied	\N	\N	\N	\N	89580	89580	89581
20105	28960	7	applied	\N	\N	\N	\N	89582	89582	89583
20105	28961	8	applied	\N	\N	\N	\N	89584	89584	89585
20111	28970	0	applied	\N	\N	\N	\N	89612	89612	89613
20111	28971	1	applied	\N	\N	\N	\N	89614	89614	89615
20111	28972	2	applied	\N	\N	\N	\N	89616	89616	89617
20111	28973	3	applied	\N	\N	\N	\N	89618	89618	89619
20111	28974	4	applied	\N	\N	\N	\N	89620	89620	89621
20111	28975	5	applied	\N	\N	\N	\N	89622	89622	89623
20111	28976	6	applied	\N	\N	\N	\N	89624	89624	89625
20117	28983	0	applied	\N	\N	\N	\N	89642	89642	89643
20117	28984	1	applied	\N	\N	\N	\N	89644	89644	89645
20117	28985	2	applied	\N	\N	\N	\N	89646	89646	89647
20117	28986	3	applied	\N	\N	\N	\N	89648	89648	89649
20117	28987	4	applied	\N	\N	\N	\N	89650	89650	89651
20117	28988	5	applied	\N	\N	\N	\N	89652	89652	89653
20117	28989	6	applied	\N	\N	\N	\N	89654	89654	89655
20118	28991	0	applied	\N	\N	\N	\N	89664	89664	89665
20118	28992	1	applied	\N	\N	\N	\N	89666	89666	89667
20118	28993	2	applied	\N	\N	\N	\N	89668	89668	89669
20118	28994	3	applied	\N	\N	\N	\N	89670	89670	89671
20118	28995	4	applied	\N	\N	\N	\N	89672	89672	89673
20118	28996	5	applied	\N	\N	\N	\N	89674	89674	89675
20118	28997	6	applied	\N	\N	\N	\N	89676	89676	89677
20123	29007	0	applied	\N	\N	\N	\N	89703	89703	89704
20123	29008	1	applied	\N	\N	\N	\N	89705	89705	89706
20123	29009	2	applied	\N	\N	\N	\N	89707	89707	89708
20123	29010	3	applied	\N	\N	\N	\N	89709	89709	89710
20123	29011	4	applied	\N	\N	\N	\N	89711	89711	89712
20123	29012	5	applied	\N	\N	\N	\N	89713	89713	89714
20123	29013	6	applied	\N	\N	\N	\N	89715	89715	89716
20123	29014	7	applied	\N	\N	\N	\N	89717	89717	89718
20128	29032	0	applied	\N	\N	\N	\N	89766	89766	89767
20128	29033	1	applied	\N	\N	\N	\N	89768	89768	89769
20128	29034	2	applied	\N	\N	\N	\N	89770	89770	89762
20128	29029	3	applied	\N	\N	\N	\N	89757	89757	89771
20128	29030	4	applied	\N	\N	\N	\N	89759	89759	89772
20128	29031	5	applied	\N	\N	\N	\N	89761	89761	89773
20128	29035	6	applied	\N	\N	\N	\N	89774	89774	89775
20131	29032	0	applied	\N	\N	\N	\N	89766	89766	89767
20131	29033	1	applied	\N	\N	\N	\N	89768	89768	89769
20131	29034	2	applied	\N	\N	\N	\N	89770	89770	89762
20131	29029	3	applied	\N	\N	\N	\N	89757	89757	89771
20131	29030	4	applied	\N	\N	\N	\N	89759	89759	89772
20131	29031	5	applied	\N	\N	\N	\N	89761	89761	89773
20131	29035	6	applied	\N	\N	\N	\N	89774	89774	89775
20136	29042	0	applied	\N	\N	\N	\N	89798	89798	89799
20136	29043	1	applied	\N	\N	\N	\N	32444	32444	89800
20136	29044	2	applied	\N	\N	\N	\N	89801	89801	89802
20136	29045	3	applied	\N	\N	\N	\N	89803	89803	89804
20136	29046	4	applied	\N	\N	\N	\N	89805	89805	89806
20136	29047	5	applied	\N	\N	\N	\N	89807	89807	89808
20136	29048	6	applied	\N	\N	\N	\N	89809	89809	89810
20136	29049	7	applied	\N	\N	\N	\N	89811	89811	89812
20136	29050	8	applied	\N	\N	\N	\N	89813	89813	89814
20136	29051	9	applied	\N	\N	\N	\N	89815	89815	89816
20142	29057	0	applied	\N	\N	\N	\N	89839	89839	89840
20142	29058	1	applied	\N	\N	\N	\N	89841	89841	89842
20142	29059	2	applied	\N	\N	\N	\N	89843	89843	89844
20142	29060	3	applied	\N	\N	\N	\N	89845	89845	89846
20142	29061	4	applied	\N	\N	\N	\N	89847	89847	89848
20145	29062	0	applied	\N	\N	\N	\N	89850	89850	89851
20145	29064	1	applied	\N	\N	\N	\N	89854	89854	89855
20145	29065	2	applied	\N	\N	\N	\N	89856	89856	86464
20145	29066	3	applied	\N	\N	\N	\N	89857	89857	89858
20145	29067	4	applied	\N	\N	\N	\N	89859	89859	89860
20146	29062	0	applied	\N	\N	\N	\N	89850	89850	89851
20146	29064	1	applied	\N	\N	\N	\N	89854	89854	89855
20146	29065	2	applied	\N	\N	\N	\N	89856	89856	86464
20146	29066	3	applied	\N	\N	\N	\N	89857	89857	89858
20146	29067	4	applied	\N	\N	\N	\N	89859	89859	89860
20151	29075	0	applied	\N	\N	\N	\N	89916	89916	89917
20151	29076	1	applied	\N	\N	\N	\N	89918	89918	89919
20151	29077	2	applied	\N	\N	\N	\N	89920	89920	89921
20154	29088	0	applied	\N	\N	\N	\N	89947	89947	89948
20154	29089	1	applied	\N	\N	\N	\N	89949	89949	89950
20154	29090	2	applied	\N	\N	\N	\N	89951	89951	89952
20160	29115	0	applied	\N	\N	\N	\N	90012	90012	90013
20147	29062	2	applied	\N	\N	\N	\N	89850	89850	89851
20147	29063	3	applied	\N	\N	\N	\N	89852	89852	89853
20147	29015	4	applied	\N	\N	\N	\N	89723	89723	89866
20147	29016	5	applied	\N	\N	\N	\N	89725	89725	89867
20147	29007	6	applied	\N	\N	\N	\N	89703	89703	89726
20147	29021	7	applied	\N	\N	\N	\N	89737	89737	89738
20147	28970	8	applied	\N	\N	\N	\N	89612	89612	89613
20147	28971	9	applied	\N	\N	\N	\N	89614	89614	89615
20147	28972	10	applied	\N	\N	\N	\N	89616	89616	89617
20147	28990	11	applied	\N	\N	\N	\N	89660	89660	89661
20147	28983	12	applied	\N	\N	\N	\N	89642	89642	89643
20147	29017	13	applied	\N	\N	\N	\N	89868	89868	89728
20147	29018	14	applied	\N	\N	\N	\N	89869	89869	89730
20147	28973	15	applied	\N	\N	\N	\N	89618	89618	89619
20147	28977	16	applied	\N	\N	\N	\N	89627	89627	89628
20147	28984	17	applied	\N	\N	\N	\N	89644	89644	89645
20147	28985	18	applied	\N	\N	\N	\N	89646	89646	89647
20147	29019	19	applied	\N	\N	\N	\N	89870	89870	89732
20147	29020	20	applied	\N	\N	\N	\N	89871	89871	89734
20147	29068	21	applied	\N	\N	\N	\N	89872	89872	89873
20147	29065	22	applied	\N	\N	\N	\N	89856	89856	86464
20147	28992	23	applied	\N	\N	\N	\N	89666	89666	89667
20147	28979	24	applied	\N	\N	\N	\N	89632	89632	89633
20147	28986	25	applied	\N	\N	\N	\N	89648	89648	89649
20147	28991	26	applied	\N	\N	\N	\N	89664	89664	89665
20147	28998	27	applied	\N	\N	\N	\N	89680	89680	89681
20147	29001	28	applied	\N	\N	\N	\N	89688	89688	89689
20147	29002	29	applied	\N	\N	\N	\N	89690	89690	89691
20147	29008	30	applied	\N	\N	\N	\N	89705	89705	89706
20147	29009	31	applied	\N	\N	\N	\N	89707	89707	89708
20147	29022	32	applied	\N	\N	\N	\N	89739	89739	89740
20147	29023	33	applied	\N	\N	\N	\N	89741	89741	89742
20147	29024	34	applied	\N	\N	\N	\N	89743	89743	89744
20147	29032	35	applied	\N	\N	\N	\N	89766	89766	89767
20147	29036	36	applied	\N	\N	\N	\N	89782	89782	89783
20147	29042	37	applied	\N	\N	\N	\N	89798	89798	89799
20147	29044	38	applied	\N	\N	\N	\N	89801	89801	89802
20147	29045	39	applied	\N	\N	\N	\N	89803	89803	89804
20147	29052	40	applied	\N	\N	\N	\N	89822	89822	89823
20147	29054	41	applied	\N	\N	\N	\N	89827	89827	89828
20147	29059	42	applied	\N	\N	\N	\N	89843	89843	89844
20147	29064	43	applied	\N	\N	\N	\N	89854	89854	89855
20147	29033	44	applied	\N	\N	\N	\N	89768	89768	89769
20147	29037	45	applied	\N	\N	\N	\N	89784	89784	89785
20147	29038	46	applied	\N	\N	\N	\N	89786	89786	89787
20147	29039	47	applied	\N	\N	\N	\N	89788	89788	89789
20147	28974	48	applied	\N	\N	\N	\N	89620	89620	89621
20147	28993	49	applied	\N	\N	\N	\N	89668	89668	89669
20147	28994	50	applied	\N	\N	\N	\N	89670	89670	89671
20147	28995	51	applied	\N	\N	\N	\N	89672	89672	89673
20147	29012	52	applied	\N	\N	\N	\N	89713	89713	89714
20147	29026	53	applied	\N	\N	\N	\N	34900	34900	89747
20147	28975	54	applied	\N	\N	\N	\N	89622	89622	89623
20147	28978	55	applied	\N	\N	\N	\N	89629	89629	89874
20147	28980	56	applied	\N	\N	\N	\N	89634	89634	89875
20147	28988	57	applied	\N	\N	\N	\N	89652	89652	89637
20147	28997	58	applied	\N	\N	\N	\N	89676	89676	89651
20147	28976	59	applied	\N	\N	\N	\N	89624	89624	89876
20147	28987	60	applied	\N	\N	\N	\N	89650	89650	89877
20147	28981	61	applied	\N	\N	\N	\N	89636	89636	89878
20147	28982	62	applied	\N	\N	\N	\N	89638	89638	89879
20147	28989	63	applied	\N	\N	\N	\N	89654	89654	89880
20147	28996	64	applied	\N	\N	\N	\N	89674	89674	89677
20147	28999	65	applied	\N	\N	\N	\N	89682	89682	89683
20147	29000	66	applied	\N	\N	\N	\N	89684	89684	89685
20147	29003	67	applied	\N	\N	\N	\N	89692	89692	89693
20147	29004	69	applied	\N	\N	\N	\N	89694	89694	89695
20147	29013	70	applied	\N	\N	\N	\N	89715	89715	89882
20147	29014	71	applied	\N	\N	\N	\N	89717	89717	89710
20147	29025	72	applied	\N	\N	\N	\N	89745	89745	89883
20147	29027	73	applied	\N	\N	\N	\N	89748	89748	89884
20147	29028	74	applied	\N	\N	\N	\N	89750	89750	89885
20147	29034	75	applied	\N	\N	\N	\N	89770	89770	89886
20147	29041	76	applied	\N	\N	\N	\N	89792	89792	89760
20147	29049	77	applied	\N	\N	\N	\N	89811	89811	89887
20147	29050	78	applied	\N	\N	\N	\N	89813	89813	89888
20147	29051	79	applied	\N	\N	\N	\N	89815	89815	89772
20147	29055	80	applied	\N	\N	\N	\N	89829	89829	89889
20147	29060	81	applied	\N	\N	\N	\N	89845	89845	89791
20147	29067	82	applied	\N	\N	\N	\N	89859	89859	89793
20147	29005	83	applied	\N	\N	\N	\N	89696	89696	89806
20147	29006	84	applied	\N	\N	\N	\N	89698	89698	89808
20147	29010	85	applied	\N	\N	\N	\N	89709	89709	89810
20147	29011	86	applied	\N	\N	\N	\N	89711	89711	89890
20147	29029	87	applied	\N	\N	\N	\N	89757	89757	89891
20147	29030	88	applied	\N	\N	\N	\N	89759	89759	89814
20147	29031	89	applied	\N	\N	\N	\N	89761	89761	89892
20147	29035	90	applied	\N	\N	\N	\N	89774	89774	89893
20147	29040	91	applied	\N	\N	\N	\N	89790	89790	89894
20147	29046	92	applied	\N	\N	\N	\N	89805	89805	89830
20147	29047	93	applied	\N	\N	\N	\N	89807	89807	89832
20147	29048	94	applied	\N	\N	\N	\N	89809	89809	89895
20147	29053	95	applied	\N	\N	\N	\N	89824	89824	89896
20147	29056	96	applied	\N	\N	\N	\N	89831	89831	89897
20147	29061	97	applied	\N	\N	\N	\N	89847	89847	89898
20147	29066	98	applied	\N	\N	\N	\N	89857	89857	89860
20150	29072	0	applied	\N	\N	\N	\N	89909	89909	89910
20150	29073	1	applied	\N	\N	\N	\N	89911	89911	89912
20150	29074	2	applied	\N	\N	\N	\N	89913	89913	89914
20152	29078	0	applied	\N	\N	\N	\N	89924	89924	89925
20152	29079	1	applied	\N	\N	\N	\N	89926	89926	89927
20152	29080	2	applied	\N	\N	\N	\N	89928	89928	89929
20152	29081	3	applied	\N	\N	\N	\N	89930	89930	89931
20155	29091	0	applied	\N	\N	\N	\N	89955	89955	89956
20155	29092	1	applied	\N	\N	\N	\N	89957	89957	89958
20155	29093	2	applied	\N	\N	\N	\N	89959	89959	89960
20158	29094	0	applied	\N	\N	\N	\N	89965	89965	89966
20158	29095	1	applied	\N	\N	\N	\N	89967	89967	89968
20158	29096	2	applied	\N	\N	\N	\N	89969	89969	89970
20158	29097	3	applied	\N	\N	\N	\N	89971	89971	89972
20158	29098	4	applied	\N	\N	\N	\N	89973	89973	89974
20158	29099	5	applied	\N	\N	\N	\N	89975	89975	89976
20163	29124	0	applied	\N	\N	\N	\N	90045	90045	90046
20163	29125	1	applied	\N	\N	\N	\N	90047	90047	90048
20163	29126	2	applied	\N	\N	\N	\N	90049	90049	90050
20163	29127	3	applied	\N	\N	\N	\N	90051	90051	90052
20163	29128	4	applied	\N	\N	\N	\N	90053	90053	90054
20163	29129	5	applied	\N	\N	\N	\N	90055	90055	90056
20163	29130	6	applied	\N	\N	\N	\N	10287	10287	90057
20163	29131	7	applied	\N	\N	\N	\N	90058	90058	90059
20156	29093	2	applied	\N	\N	\N	\N	89959	89959	89960
20159	29100	0	applied	\N	\N	\N	\N	89980	89980	89981
20159	29101	1	applied	\N	\N	\N	\N	89982	89982	89983
20159	29102	2	applied	\N	\N	\N	\N	89984	89984	89985
20159	29103	3	applied	\N	\N	\N	\N	89986	89986	89987
20159	29104	4	applied	\N	\N	\N	\N	89988	89988	89989
20159	29105	5	applied	\N	\N	\N	\N	89990	89990	89991
20159	29106	6	applied	\N	\N	\N	\N	89992	89992	89993
20159	29107	7	applied	\N	\N	\N	\N	89994	89994	89995
20159	29108	8	applied	\N	\N	\N	\N	89996	89996	89997
20159	29109	9	applied	\N	\N	\N	\N	89998	89998	89999
20159	29110	10	applied	\N	\N	\N	\N	90000	90000	90001
20159	29111	11	applied	\N	\N	\N	\N	90002	90002	90003
20159	29112	12	applied	\N	\N	\N	\N	90004	90004	90005
20159	29113	13	applied	\N	\N	\N	\N	90006	90006	90007
20159	29114	14	applied	\N	\N	\N	\N	90008	90008	90009
20164	29124	0	applied	\N	\N	\N	\N	90045	90045	90046
20164	29125	1	applied	\N	\N	\N	\N	90047	90047	90048
20164	29126	2	applied	\N	\N	\N	\N	90049	90049	90050
20164	29127	3	applied	\N	\N	\N	\N	90051	90051	90052
20164	29128	4	applied	\N	\N	\N	\N	90053	90053	90054
20164	29129	5	applied	\N	\N	\N	\N	90055	90055	90056
20164	29130	6	applied	\N	\N	\N	\N	10287	10287	90057
20164	29131	7	applied	\N	\N	\N	\N	90058	90058	90059
20164	29132	8	applied	\N	\N	\N	\N	90060	90060	90061
20164	29133	9	applied	\N	\N	\N	\N	90062	90062	90063
20164	29134	10	applied	\N	\N	\N	\N	90064	90064	90065
20164	29135	11	applied	\N	\N	\N	\N	90066	90066	90067
20164	29136	12	applied	\N	\N	\N	\N	90068	90068	90069
20167	29163	0	applied	\N	\N	\N	\N	90128	90128	90129
20167	29164	1	applied	\N	\N	\N	\N	90130	90130	90131
20167	29165	2	applied	\N	\N	\N	\N	90132	90132	90133
20167	29166	3	applied	\N	\N	\N	\N	90134	90134	90135
20167	29167	4	applied	\N	\N	\N	\N	90136	90136	90137
20167	29168	5	applied	\N	\N	\N	\N	90138	90138	90139
20172	29188	0	applied	\N	\N	\N	\N	90186	90186	90187
20172	29189	1	applied	\N	\N	\N	\N	90188	90188	90189
20175	29198	0	applied	\N	\N	\N	\N	90212	90212	90213
20175	29199	1	applied	\N	\N	\N	\N	90214	90214	90215
20175	29200	2	applied	\N	\N	\N	\N	90216	90216	90217
20175	29201	3	applied	\N	\N	\N	\N	90218	90218	90219
20175	29202	4	applied	\N	\N	\N	\N	90220	90220	90221
20178	29213	0	applied	\N	\N	\N	\N	90248	90248	90249
20178	29214	1	applied	\N	\N	\N	\N	90250	90250	90251
20178	29215	2	applied	\N	\N	\N	\N	90252	90252	90253
20178	29216	3	applied	\N	\N	\N	\N	90254	90254	90255
20180	29217	0	applied	\N	\N	\N	\N	90260	90260	90261
20180	29218	1	applied	\N	\N	\N	\N	90262	90262	90263
20180	29219	2	applied	\N	\N	\N	\N	90264	90264	90265
20184	29230	0	applied	\N	\N	\N	\N	90352	90352	90353
20184	29231	1	applied	\N	\N	\N	\N	90354	90354	90355
20184	29232	2	applied	\N	\N	\N	\N	90356	90356	90357
20187	29243	0	applied	\N	\N	\N	\N	90434	90434	90435
20187	29244	1	applied	\N	\N	\N	\N	90436	90436	90437
20187	29245	2	applied	\N	\N	\N	\N	90438	90438	90439
20193	29263	0	applied	\N	\N	\N	\N	90483	90483	90484
20193	29264	1	applied	\N	\N	\N	\N	90485	90485	90486
20193	29265	2	applied	\N	\N	\N	\N	90487	90487	90488
20193	29266	3	applied	\N	\N	\N	\N	90489	90489	90490
20193	29267	4	applied	\N	\N	\N	\N	90491	90491	90492
20196	29268	0	applied	\N	\N	\N	\N	90494	90494	90495
20196	29269	1	applied	\N	\N	\N	\N	90496	90496	90497
20196	29270	2	applied	\N	\N	\N	\N	90498	90498	90499
20196	29271	3	applied	\N	\N	\N	\N	90500	90500	90501
20196	29272	4	applied	\N	\N	\N	\N	90502	90502	90503
20196	29273	5	applied	\N	\N	\N	\N	90504	90504	90505
20198	29274	0	applied	\N	\N	\N	\N	90512	90512	90513
20198	29275	1	applied	\N	\N	\N	\N	90514	90514	90515
20198	29276	2	applied	\N	\N	\N	\N	90516	90516	90517
20198	29277	3	applied	\N	\N	\N	\N	90518	90518	90519
20200	29286	0	applied	\N	\N	\N	\N	90540	90540	90541
20200	29287	1	applied	\N	\N	\N	\N	90542	90542	90543
20200	29288	2	applied	\N	\N	\N	\N	90544	90544	90545
20205	29292	0	applied	\N	\N	\N	\N	90556	90556	90557
20205	29293	1	applied	\N	\N	\N	\N	90558	90558	90559
20205	29294	2	applied	\N	\N	\N	\N	90560	90560	90561
20207	29295	0	applied	\N	\N	\N	\N	90594	90594	90595
20207	29296	1	applied	\N	\N	\N	\N	90596	90596	90597
20207	29297	2	applied	\N	\N	\N	\N	90598	90598	90599
20210	29298	0	applied	\N	\N	\N	\N	90602	90602	90603
20210	29299	1	applied	\N	\N	\N	\N	90604	90604	90605
20210	29300	2	applied	\N	\N	\N	\N	90606	90606	90607
20215	29312	0	applied	\N	\N	\N	\N	90641	90641	90642
20215	29313	1	applied	\N	\N	\N	\N	90643	90643	90644
20215	29314	2	applied	\N	\N	\N	\N	90645	90645	90646
20215	29315	3	applied	\N	\N	\N	\N	90647	90647	90648
20215	29316	4	applied	\N	\N	\N	\N	90649	90649	90650
20215	29317	5	applied	\N	\N	\N	\N	90651	90651	90652
20215	29318	6	applied	\N	\N	\N	\N	90653	90653	90654
20218	29312	0	applied	\N	\N	\N	\N	90641	90641	90642
20218	29313	1	applied	\N	\N	\N	\N	90643	90643	90644
20218	29314	2	applied	\N	\N	\N	\N	90645	90645	90646
20218	29315	3	applied	\N	\N	\N	\N	90647	90647	90648
20218	29316	4	applied	\N	\N	\N	\N	90649	90649	90650
20218	29317	5	applied	\N	\N	\N	\N	90651	90651	90652
20218	29318	6	applied	\N	\N	\N	\N	90653	90653	90654
20223	29319	0	applied	\N	\N	\N	\N	90665	90665	90666
20223	29320	1	applied	\N	\N	\N	\N	90667	90667	90668
20223	29321	2	applied	\N	\N	\N	\N	90669	90669	90670
20223	29322	3	applied	\N	\N	\N	\N	90671	90671	90672
20223	29323	4	applied	\N	\N	\N	\N	90673	90673	90674
20223	29324	5	applied	\N	\N	\N	\N	90675	90675	90654
20223	29315	6	applied	\N	\N	\N	\N	90647	90647	90676
20223	29318	7	applied	\N	\N	\N	\N	90653	90653	90677
20223	29325	8	applied	\N	\N	\N	\N	90678	90678	90679
20223	29326	9	applied	\N	\N	\N	\N	90680	90680	90681
20224	29327	0	applied	\N	\N	\N	\N	90689	90689	90690
20224	29328	1	applied	\N	\N	\N	\N	90691	90691	90692
20224	29329	2	applied	\N	\N	\N	\N	90693	90693	90694
20227	29330	0	applied	\N	\N	\N	\N	90698	90698	90699
20227	29331	1	applied	\N	\N	\N	\N	90700	90700	90701
20227	29332	2	applied	\N	\N	\N	\N	90702	90702	90703
20227	29333	3	applied	\N	\N	\N	\N	90704	90704	90705
20227	29334	4	applied	\N	\N	\N	\N	90706	90706	90707
20227	29335	5	applied	\N	\N	\N	\N	90708	90708	90709
20229	29336	0	applied	\N	\N	\N	\N	90714	90714	90715
20229	29337	1	applied	\N	\N	\N	\N	90716	90716	90717
20229	29338	2	applied	\N	\N	\N	\N	90718	90718	90719
20229	29339	3	applied	\N	\N	\N	\N	90720	90720	90721
20235	29349	0	applied	\N	\N	\N	\N	90745	90745	90746
20157	29096	2	applied	\N	\N	\N	\N	89969	89969	89970
20157	29097	3	applied	\N	\N	\N	\N	89971	89971	89972
20157	29098	4	applied	\N	\N	\N	\N	89973	89973	89974
20157	29099	5	applied	\N	\N	\N	\N	89975	89975	89976
20161	29115	0	applied	\N	\N	\N	\N	90012	90012	90013
20161	29116	1	applied	\N	\N	\N	\N	90014	90014	90015
20161	29117	2	applied	\N	\N	\N	\N	90016	90016	90017
20161	29118	3	applied	\N	\N	\N	\N	90018	90018	90019
20161	29119	4	applied	\N	\N	\N	\N	90020	90020	90021
20161	29120	5	applied	\N	\N	\N	\N	90022	90022	90023
20161	29121	6	applied	\N	\N	\N	\N	90024	90024	90025
20161	29122	7	applied	\N	\N	\N	\N	90026	90026	90027
20161	29123	8	applied	\N	\N	\N	\N	90028	90028	90029
20168	29169	0	applied	\N	\N	\N	\N	90143	90143	90144
20168	29170	1	applied	\N	\N	\N	\N	90145	90145	90146
20168	29171	2	applied	\N	\N	\N	\N	90147	90147	90148
20168	29172	3	applied	\N	\N	\N	\N	90149	90149	90150
20168	29173	4	applied	\N	\N	\N	\N	29193	29193	90151
20168	29174	5	applied	\N	\N	\N	\N	90152	90152	90153
20168	29175	6	applied	\N	\N	\N	\N	90154	90154	90155
20168	29176	7	applied	\N	\N	\N	\N	90156	90156	90157
20168	29177	8	applied	\N	\N	\N	\N	90158	90158	90159
20173	29190	0	applied	\N	\N	\N	\N	90192	90192	90193
20173	29191	1	applied	\N	\N	\N	\N	90194	90194	90195
20173	29192	2	applied	\N	\N	\N	\N	90196	90196	90197
20181	28874	0	applied	\N	\N	\N	\N	89385	89385	89386
20181	29057	1	applied	\N	\N	\N	\N	90268	90268	89840
20181	29058	2	applied	\N	\N	\N	\N	90269	90269	89842
20181	29015	3	applied	\N	\N	\N	\N	89723	89723	89866
20181	28366	4	applied	\N	\N	\N	\N	90270	90270	87965
20181	28239	5	applied	\N	\N	\N	\N	87617	87617	28166
20181	29007	6	applied	\N	\N	\N	\N	89703	89703	89724
20181	28370	7	applied	\N	\N	\N	\N	90271	90271	87978
20181	28970	8	applied	\N	\N	\N	\N	90272	90272	89613
20181	28971	9	applied	\N	\N	\N	\N	90273	90273	89615
20181	28972	10	applied	\N	\N	\N	\N	90274	90274	89617
20181	28990	11	applied	\N	\N	\N	\N	90275	90275	89661
20181	28887	12	applied	\N	\N	\N	\N	89415	89415	89416
20181	28383	13	applied	\N	\N	\N	\N	88009	88009	88010
20181	28581	14	applied	\N	\N	\N	\N	88624	88624	90276
20181	29100	15	applied	\N	\N	\N	\N	90277	90277	89981
20181	28942	16	applied	\N	\N	\N	\N	90033	90033	28166
20181	28943	17	applied	\N	\N	\N	\N	90278	90278	89545
20181	28801	18	applied	\N	\N	\N	\N	89223	89223	89224
20181	29017	19	applied	\N	\N	\N	\N	90279	90279	89728
20181	29018	20	applied	\N	\N	\N	\N	90280	90280	89730
20181	29163	21	applied	\N	\N	\N	\N	90128	90128	90129
20181	27728	22	applied	\N	\N	\N	\N	86032	86032	86033
20181	28889	23	applied	\N	\N	\N	\N	89419	89419	89420
20181	28890	24	applied	\N	\N	\N	\N	89421	89421	89422
20181	28891	25	applied	\N	\N	\N	\N	89423	89423	89424
20181	28892	26	applied	\N	\N	\N	\N	89425	89425	89426
20181	28545	27	applied	\N	\N	1000000000	\N	90281	90281	88507
20181	28944	28	applied	\N	\N	\N	\N	90282	90282	89547
20181	28945	29	applied	\N	\N	\N	\N	90283	90283	89549
20181	28946	30	applied	\N	\N	\N	\N	90284	90284	89551
20181	28953	31	applied	\N	\N	\N	\N	90285	90285	89569
20181	28793	32	applied	\N	\N	\N	\N	89203	89203	89204
20181	28802	33	applied	\N	\N	\N	\N	89225	89225	89226
20181	28807	34	applied	\N	\N	\N	\N	89239	89239	89240
20181	28808	35	applied	\N	\N	\N	\N	89241	89241	89242
20181	28809	36	applied	\N	\N	\N	\N	89243	89243	89244
20181	28824	37	applied	\N	\N	1000000000	\N	89282	89282	90039
20181	28447	38	applied	\N	\N	\N	\N	88236	88236	88237
20181	28448	39	applied	\N	\N	\N	\N	88238	88238	88239
20181	28389	40	applied	\N	\N	\N	\N	88023	88023	88024
20181	28390	41	applied	\N	\N	\N	\N	88025	88025	88026
20181	29019	42	applied	\N	\N	\N	\N	90286	90286	89732
20181	27706	43	applied	\N	\N	\N	\N	85974	85974	85975
20181	27709	44	applied	\N	\N	\N	\N	85982	85982	85983
20181	28450	45	applied	\N	\N	\N	\N	88242	88242	88243
20181	28451	46	applied	\N	\N	\N	\N	88244	88244	88245
20181	28817	47	applied	\N	\N	\N	\N	90287	90287	89262
20181	28818	48	applied	\N	\N	\N	\N	90288	90288	89264
20181	28822	49	applied	\N	\N	\N	\N	90289	90289	89279
20181	28823	50	applied	\N	\N	\N	\N	90290	90290	89281
20181	28228	51	applied	\N	\N	\N	\N	88603	88603	88624
20181	28826	52	applied	\N	\N	\N	\N	90291	90291	89287
20181	28827	53	applied	\N	\N	\N	\N	90292	90292	89289
20181	28452	54	applied	\N	\N	\N	\N	88246	88246	88247
20181	28703	55	applied	\N	\N	\N	\N	90293	90293	88958
20181	28704	56	applied	\N	\N	\N	\N	90294	90294	88960
20181	29165	57	applied	\N	\N	\N	\N	90132	90132	90133
20181	29120	58	applied	\N	\N	\N	\N	90295	90295	90023
20181	27707	59	applied	\N	\N	\N	\N	85976	85976	85977
20181	28245	60	applied	\N	\N	\N	\N	90296	90296	87631
20181	28766	61	applied	\N	\N	\N	\N	89091	89091	89092
20181	28767	62	applied	\N	\N	\N	\N	89093	89093	89094
20181	29191	63	applied	\N	\N	\N	\N	90297	90297	90195
20181	29194	64	applied	\N	\N	\N	\N	90298	90298	90203
20181	29195	65	applied	\N	\N	\N	\N	90299	90299	90205
20181	28020	66	applied	\N	\N	1000000000	\N	87005	87005	87006
20181	28547	67	applied	\N	\N	\N	\N	88510	88510	88511
20181	27715	68	applied	\N	\N	\N	\N	85998	85998	33908
20181	28857	69	applied	\N	\N	1000000000	\N	90300	90300	89350
20181	28769	70	applied	\N	\N	\N	\N	89097	89097	89098
20181	28022	71	applied	\N	\N	\N	\N	87009	87009	86379
20181	28993	72	applied	\N	\N	\N	\N	90301	90301	89669
20181	27711	73	applied	\N	\N	\N	\N	85986	85986	85979
20181	27714	74	applied	\N	\N	\N	\N	85996	85996	86380
20181	28246	75	applied	\N	\N	\N	\N	90302	90302	87633
20181	28249	76	applied	\N	\N	\N	\N	90303	90303	87641
20181	28290	77	applied	\N	\N	\N	\N	90304	90304	87677
20181	28261	78	applied	\N	\N	\N	\N	90305	90305	87679
20181	28220	79	applied	\N	\N	\N	\N	90306	90306	87564
20181	28023	80	applied	\N	\N	1000000000	\N	87011	87011	87012
20181	28024	81	applied	\N	\N	\N	\N	87013	87013	87014
20181	28994	82	applied	\N	\N	\N	\N	90307	90307	89671
20181	28995	83	applied	\N	\N	\N	\N	90308	90308	89673
20181	28225	84	applied	\N	\N	\N	\N	90309	90309	87574
20181	28229	85	applied	\N	\N	\N	\N	90310	90310	87585
20181	28039	86	applied	\N	\N	\N	\N	87079	87079	85985
20181	28042	87	applied	\N	\N	\N	\N	87087	87087	86381
20181	28058	88	applied	\N	\N	\N	\N	87125	87125	85987
20181	27716	89	applied	\N	\N	\N	\N	85999	85999	85997
20181	27721	90	applied	\N	\N	\N	\N	86011	86011	86000
20181	28237	91	applied	\N	\N	\N	\N	90311	90311	87610
20181	28238	92	applied	\N	\N	\N	\N	90312	90312	87612
20181	27724	93	applied	\N	\N	\N	\N	86020	86020	90313
20160	29116	1	applied	\N	\N	\N	\N	90014	90014	90015
20160	29117	2	applied	\N	\N	\N	\N	90016	90016	90017
20160	29118	3	applied	\N	\N	\N	\N	90018	90018	90019
20160	29119	4	applied	\N	\N	\N	\N	90020	90020	90021
20160	29120	5	applied	\N	\N	\N	\N	90022	90022	90023
20160	29121	6	applied	\N	\N	\N	\N	90024	90024	90025
20160	29122	7	applied	\N	\N	\N	\N	90026	90026	90027
20160	29123	8	applied	\N	\N	\N	\N	90028	90028	90029
20162	28930	0	applied	\N	\N	\N	\N	89515	89515	89516
20162	28874	1	applied	\N	\N	\N	\N	89385	89385	89386
20162	29057	2	applied	\N	\N	\N	\N	89839	89839	89840
20162	29058	3	applied	\N	\N	\N	\N	89841	89841	89842
20162	29062	4	applied	\N	\N	\N	\N	89850	89850	89851
20162	29063	5	applied	\N	\N	\N	\N	89852	89852	89853
20162	29015	6	applied	\N	\N	\N	\N	89723	89723	89866
20162	29016	7	applied	\N	\N	\N	\N	89725	89725	89867
20162	29007	8	applied	\N	\N	\N	\N	89703	89703	89726
20162	29021	9	applied	\N	\N	\N	\N	89737	89737	89738
20162	28814	10	applied	\N	\N	\N	\N	89256	89256	89256
20162	28970	11	applied	\N	\N	\N	\N	89612	89612	89613
20162	28971	12	applied	\N	\N	\N	\N	89614	89614	89615
20162	28972	13	applied	\N	\N	\N	\N	89616	89616	89617
20162	28990	14	applied	\N	\N	\N	\N	89660	89660	89661
20162	28887	15	applied	\N	\N	\N	\N	89415	89415	89416
20162	28983	16	applied	\N	\N	\N	\N	89642	89642	89643
20162	29100	17	applied	\N	\N	\N	\N	89980	89980	89981
20162	28942	18	applied	\N	\N	\N	\N	90033	90033	28166
20162	28943	19	applied	\N	\N	\N	\N	89544	89544	89545
20162	28801	20	applied	\N	\N	\N	\N	89223	89223	89224
20162	29115	21	applied	\N	\N	\N	\N	90034	90034	90013
20162	29116	22	applied	\N	\N	\N	\N	90035	90035	90015
20162	29017	23	applied	\N	\N	\N	\N	89868	89868	89728
20162	29018	24	applied	\N	\N	\N	\N	89869	89869	89730
20162	28984	25	applied	\N	\N	\N	\N	89644	89644	89645
20162	28985	26	applied	\N	\N	\N	\N	89646	89646	89647
20162	28889	27	applied	\N	\N	\N	\N	89419	89419	89420
20162	28890	28	applied	\N	\N	\N	\N	89421	89421	89422
20162	28891	29	applied	\N	\N	\N	\N	89423	89423	89424
20162	28892	30	applied	\N	\N	\N	\N	89425	89425	89426
20162	28893	31	applied	\N	\N	\N	\N	89427	89427	89428
20162	28906	32	applied	\N	\N	\N	\N	32796	32796	89455
20162	28944	33	applied	\N	\N	\N	\N	89546	89546	89547
20162	28945	34	applied	\N	\N	\N	\N	89548	89548	89549
20162	28946	35	applied	\N	\N	\N	\N	89550	89550	89551
20162	28953	36	applied	\N	\N	\N	\N	89568	89568	89569
20162	29117	37	applied	\N	\N	\N	\N	90036	90036	90017
20162	29118	38	applied	\N	\N	\N	\N	90037	90037	90019
20162	28834	39	applied	\N	\N	\N	\N	90038	90038	90038
20162	28793	40	applied	\N	\N	\N	\N	89203	89203	89204
20162	28802	41	applied	\N	\N	\N	\N	89225	89225	89226
20162	28807	42	applied	\N	\N	\N	\N	89239	89239	89304
20162	28808	43	applied	\N	\N	\N	\N	89241	89241	89242
20162	28809	44	applied	\N	\N	\N	\N	89243	89243	89244
20162	28824	45	applied	\N	\N	1000000000	\N	89282	89282	90039
20162	28795	46	applied	\N	\N	\N	\N	89209	89209	89210
20162	28800	47	applied	\N	\N	\N	\N	89221	89221	89222
20162	29019	48	applied	\N	\N	\N	\N	89870	89870	89732
20162	29020	49	applied	\N	\N	\N	\N	89871	89871	89734
20162	29068	50	applied	\N	\N	\N	\N	89872	89872	89873
20162	29065	51	applied	\N	\N	\N	\N	89856	89856	86464
20162	28817	52	applied	\N	\N	\N	\N	89261	89261	89262
20162	28818	53	applied	\N	\N	\N	\N	89263	89263	89264
20162	28822	54	applied	\N	\N	\N	\N	89278	89278	89279
20162	28823	55	applied	\N	\N	\N	\N	89280	89280	89281
20162	28992	56	applied	\N	\N	\N	\N	89666	89666	89667
20162	28826	57	applied	\N	\N	\N	\N	89286	89286	89287
20162	28827	58	applied	\N	\N	\N	\N	89288	89288	89289
20162	28828	59	applied	\N	\N	\N	\N	89290	89290	89291
20162	28829	60	applied	\N	\N	\N	\N	89292	89292	89293
20162	28830	61	applied	\N	\N	\N	\N	89294	89294	89295
20162	28831	62	applied	\N	\N	\N	\N	89296	89296	89297
20162	28837	63	applied	\N	\N	\N	\N	89309	89309	89310
20162	28838	64	applied	\N	\N	\N	\N	89311	89311	89312
20162	28839	65	applied	\N	\N	\N	\N	89313	89313	89314
20162	28840	66	applied	\N	\N	\N	\N	89315	89315	89316
20162	28841	67	applied	\N	\N	\N	\N	89317	89317	89318
20162	28842	68	applied	\N	\N	\N	\N	89319	89319	89320
20162	28843	69	applied	\N	\N	\N	\N	89321	89321	89322
20162	28844	70	applied	\N	\N	\N	\N	89323	89323	89324
20162	28845	71	applied	\N	\N	\N	\N	89325	89325	89326
20162	28846	72	applied	\N	\N	\N	\N	89327	89327	89328
20162	28847	73	applied	\N	\N	\N	\N	89329	89329	89330
20162	28848	74	applied	\N	\N	\N	\N	89331	89331	89332
20162	28849	75	applied	\N	\N	\N	\N	89333	89333	89334
20162	28850	76	applied	\N	\N	\N	\N	89335	89335	89336
20162	28851	77	applied	\N	\N	\N	\N	89337	89337	89338
20162	28852	78	applied	\N	\N	\N	\N	89339	89339	89340
20162	28853	79	applied	\N	\N	\N	\N	89341	89341	89342
20162	28854	80	applied	\N	\N	\N	\N	89343	89343	89344
20162	28862	81	applied	\N	\N	\N	\N	89360	89360	89361
20162	28863	82	applied	\N	\N	\N	\N	89362	89362	89363
20162	28864	83	applied	\N	\N	\N	\N	89364	89364	89365
20162	28865	84	applied	\N	\N	\N	\N	89366	89366	89367
20162	28866	85	applied	\N	\N	\N	\N	89368	89368	89369
20162	28867	86	applied	\N	\N	\N	\N	89370	89370	89371
20162	28868	87	applied	\N	\N	\N	\N	89372	89372	89373
20162	28869	88	applied	\N	\N	\N	\N	89374	89374	89375
20162	28870	89	applied	\N	\N	\N	\N	89376	89376	89377
20162	28875	90	applied	\N	\N	\N	\N	89387	89387	89388
20162	28876	91	applied	\N	\N	\N	\N	89389	89389	89390
20162	28877	92	applied	\N	\N	\N	\N	89391	89391	89392
20162	28878	93	applied	\N	\N	\N	\N	89393	89393	89394
20162	28880	94	applied	\N	\N	\N	\N	89397	89397	89398
20162	28881	95	applied	\N	\N	\N	\N	89399	89399	89400
20162	28882	96	applied	\N	\N	\N	\N	89401	89401	89402
20162	28883	97	applied	\N	\N	\N	\N	89403	89403	89404
20162	28884	98	applied	\N	\N	\N	\N	89405	89405	89406
20162	28894	99	applied	\N	\N	\N	\N	89429	89429	89430
20162	28895	100	applied	\N	\N	\N	\N	89431	89431	89432
20162	28896	101	applied	\N	\N	\N	\N	89433	89433	89434
20162	28897	102	applied	\N	\N	\N	\N	89435	89435	89436
20162	28898	103	applied	\N	\N	\N	\N	89437	89437	89438
20162	28899	104	applied	\N	\N	\N	\N	89439	89439	89440
20162	28900	105	applied	\N	\N	\N	\N	89441	89441	89442
20162	28901	106	applied	\N	\N	\N	\N	89443	89443	89444
20162	28902	107	applied	\N	\N	\N	\N	89445	89445	89446
20162	28907	108	applied	\N	\N	\N	\N	89456	89456	89457
20162	28908	110	applied	\N	\N	\N	\N	89458	89458	89459
20162	28909	111	applied	\N	\N	\N	\N	89460	89460	89461
20162	28910	112	applied	\N	\N	\N	\N	89462	89462	89463
20162	28911	113	applied	\N	\N	\N	\N	89464	89464	89465
20162	28912	114	applied	\N	\N	\N	\N	89466	89466	89467
20162	28913	115	applied	\N	\N	\N	\N	89468	89468	89469
20162	28914	116	applied	\N	\N	\N	\N	89470	89470	89471
20162	28915	117	applied	\N	\N	\N	\N	89472	89472	89473
20162	28918	118	applied	\N	\N	\N	\N	89478	89478	89479
20162	28931	119	applied	\N	\N	\N	\N	89517	89517	89543
20162	28804	120	applied	\N	\N	\N	\N	89229	89229	89230
20162	28815	121	applied	\N	\N	\N	\N	89257	89257	89283
20162	28955	122	applied	\N	\N	\N	\N	89572	89572	89573
20162	28956	123	applied	\N	\N	\N	\N	89574	89574	89575
20162	28957	124	applied	\N	\N	\N	\N	89576	89576	89577
20165	29137	0	applied	\N	\N	\N	\N	90074	90074	90075
20165	29138	1	applied	\N	\N	\N	\N	90076	90076	90077
20165	29139	2	applied	\N	\N	\N	\N	90078	90078	90079
20165	29140	3	applied	\N	\N	\N	\N	90080	90080	90081
20165	29141	4	applied	\N	\N	\N	\N	90082	90082	90083
20165	29142	5	applied	\N	\N	\N	\N	90084	90084	90085
20165	29143	6	applied	\N	\N	\N	\N	90086	90086	90087
20165	29144	7	applied	\N	\N	\N	\N	90088	90088	90089
20165	29145	8	applied	\N	\N	\N	\N	90090	90090	90091
20165	29146	9	applied	\N	\N	\N	\N	90092	90092	90093
20165	29147	10	applied	\N	\N	\N	\N	90094	90094	90095
20165	29148	11	applied	\N	\N	\N	\N	90096	90096	90097
20165	29149	12	applied	\N	\N	\N	\N	90098	90098	90099
20165	29150	13	applied	\N	\N	\N	\N	90100	90100	90101
20165	29151	14	applied	\N	\N	\N	\N	90102	90102	90103
20165	29152	15	applied	\N	\N	\N	\N	90104	90104	90105
20165	29153	16	applied	\N	\N	\N	\N	90106	90106	90107
20165	29154	17	applied	\N	\N	\N	\N	90108	90108	90109
20165	29155	18	applied	\N	\N	\N	\N	90110	90110	90111
20165	29156	19	applied	\N	\N	\N	\N	90112	90112	90113
20165	29157	20	applied	\N	\N	\N	\N	90114	90114	90115
20165	29158	21	applied	\N	\N	\N	\N	90116	90116	90117
20165	29159	22	applied	\N	\N	\N	\N	90118	90118	90119
20165	29160	23	applied	\N	\N	\N	\N	90120	90120	90121
20165	29161	24	applied	\N	\N	\N	\N	90122	90122	90123
20165	29162	25	applied	\N	\N	\N	\N	90124	90124	90125
20170	29178	0	applied	\N	\N	\N	\N	90164	90164	90165
20170	29179	1	applied	\N	\N	\N	\N	90166	90166	90167
20170	29180	2	applied	\N	\N	\N	\N	90168	90168	90169
20170	29181	3	applied	\N	\N	\N	\N	90170	90170	90171
20170	29182	4	applied	\N	\N	\N	\N	90172	90172	90173
20170	29183	5	applied	\N	\N	1000000000	\N	90174	90174	90175
20176	29198	0	applied	\N	\N	\N	\N	90212	90212	90213
20176	29199	1	applied	\N	\N	\N	\N	90214	90214	90215
20176	29200	2	applied	\N	\N	\N	\N	90216	90216	90217
20176	29201	3	applied	\N	\N	\N	\N	90218	90218	90219
20176	29202	4	applied	\N	\N	\N	\N	90220	90220	90221
20179	29213	0	applied	\N	\N	\N	\N	90248	90248	90249
20179	29214	1	applied	\N	\N	\N	\N	90250	90250	90251
20179	29215	2	applied	\N	\N	\N	\N	90252	90252	90253
20179	29216	3	applied	\N	\N	\N	\N	90254	90254	90255
20182	29137	0	applied	\N	\N	\N	\N	90074	90074	90075
20182	29138	1	applied	\N	\N	\N	\N	90076	90076	90077
20182	29139	2	applied	\N	\N	\N	\N	90078	90078	90079
20182	29140	3	applied	\N	\N	\N	\N	90080	90080	90081
20182	29141	4	applied	\N	\N	\N	\N	90082	90082	90083
20182	29142	5	applied	\N	\N	\N	\N	90084	90084	90085
20182	29143	6	applied	\N	\N	\N	\N	90086	90086	90087
20182	29144	7	applied	\N	\N	\N	\N	90088	90088	90089
20182	29145	8	applied	\N	\N	\N	\N	90090	90090	90091
20182	29146	9	applied	\N	\N	\N	\N	90092	90092	90093
20182	29147	10	applied	\N	\N	\N	\N	90094	90094	90095
20182	29148	11	applied	\N	\N	\N	\N	90096	90096	90097
20182	29149	12	applied	\N	\N	\N	\N	90098	90098	90099
20182	29163	13	applied	\N	\N	\N	\N	90128	90128	90129
20182	29169	14	applied	\N	\N	\N	\N	90143	90143	90144
20182	29170	15	applied	\N	\N	\N	\N	90145	90145	90146
20182	29178	16	applied	\N	\N	\N	\N	90164	90164	90165
20182	29190	17	applied	\N	\N	\N	\N	90192	90192	90193
20182	29033	18	applied	\N	\N	\N	\N	89768	89768	89769
20182	29037	19	applied	\N	\N	\N	\N	89784	89784	89785
20182	29038	20	applied	\N	\N	\N	\N	89786	89786	89787
20182	29039	21	applied	\N	\N	\N	\N	89788	89788	89789
20182	29165	22	applied	\N	\N	\N	\N	90132	90132	90133
20182	29173	23	applied	\N	\N	\N	\N	29193	29193	90151
20182	29120	24	applied	\N	\N	\N	\N	90022	90022	90023
20182	29105	25	applied	\N	\N	\N	\N	89990	89990	89991
20182	28819	26	applied	\N	\N	\N	\N	89265	89265	90318
20182	28779	27	applied	\N	\N	\N	\N	89161	89161	89162
20182	28780	28	applied	\N	\N	\N	\N	89163	89163	90319
20182	28783	29	applied	\N	\N	\N	\N	89173	89173	90320
20182	28812	30	applied	\N	\N	1000000000	\N	89249	89249	89250
20182	29106	31	applied	\N	\N	\N	\N	89992	89992	89993
20182	28781	32	applied	\N	\N	\N	\N	89165	89165	90321
20182	28784	33	applied	\N	\N	\N	\N	89175	89175	90322
20182	29191	34	applied	\N	\N	\N	\N	90323	90323	90195
20182	29194	35	applied	\N	\N	\N	\N	90324	90324	90203
20182	29195	36	applied	\N	\N	\N	\N	90325	90325	90205
20182	28857	37	applied	\N	\N	1000000000	\N	89349	89349	89350
20182	29183	38	applied	\N	\N	1000000000	\N	90174	90174	90175
20182	28993	39	applied	\N	\N	\N	\N	90326	90326	89669
20182	29134	40	applied	\N	\N	\N	\N	90064	90064	90065
20182	29135	41	applied	\N	\N	\N	\N	90066	90066	90067
20182	28858	42	applied	\N	\N	\N	\N	89351	89351	90327
20185	28930	0	applied	\N	\N	\N	\N	89515	89515	89516
20185	28874	1	applied	\N	\N	\N	\N	89385	89385	89386
20185	29057	2	applied	\N	\N	\N	\N	90268	90268	89840
20185	29058	3	applied	\N	\N	\N	\N	90269	90269	89842
20185	29062	4	applied	\N	\N	\N	\N	90358	90358	89851
20185	29063	5	applied	\N	\N	\N	\N	90359	90359	89853
20185	29015	6	applied	\N	\N	\N	\N	89723	89723	89866
20185	29016	7	applied	\N	\N	\N	\N	89725	89725	89867
20185	29007	8	applied	\N	\N	\N	\N	89703	89703	89726
20185	29021	9	applied	\N	\N	\N	\N	89737	89737	89738
20185	28565	10	applied	\N	\N	\N	\N	90360	90360	88561
20185	28580	11	applied	\N	\N	\N	\N	90361	90361	88601
20185	28585	12	applied	\N	\N	\N	\N	90362	90362	88614
20185	28595	13	applied	\N	\N	\N	\N	90363	90363	88684
20185	29137	14	applied	\N	\N	\N	\N	90364	90364	90075
20185	29138	15	applied	\N	\N	\N	\N	90365	90365	90077
20185	29139	16	applied	\N	\N	\N	\N	90366	90366	90079
20185	29140	17	applied	\N	\N	\N	\N	90367	90367	90081
20185	29141	18	applied	\N	\N	\N	\N	90368	90368	90083
20185	29142	19	applied	\N	\N	\N	\N	90369	90369	90085
20185	29143	20	applied	\N	\N	\N	\N	90370	90370	90087
20185	29144	21	applied	\N	\N	\N	\N	90371	90371	90089
20185	29145	22	applied	\N	\N	\N	\N	90372	90372	90091
20163	29132	8	applied	\N	\N	\N	\N	90060	90060	90061
20163	29133	9	applied	\N	\N	\N	\N	90062	90062	90063
20163	29134	10	applied	\N	\N	\N	\N	90064	90064	90065
20163	29135	11	applied	\N	\N	\N	\N	90066	90066	90067
20163	29136	12	applied	\N	\N	\N	\N	90068	90068	90069
20166	29163	0	applied	\N	\N	\N	\N	90128	90128	90129
20166	29164	1	applied	\N	\N	\N	\N	90130	90130	90131
20166	29165	2	applied	\N	\N	\N	\N	90132	90132	90133
20166	29166	3	applied	\N	\N	\N	\N	90134	90134	90135
20166	29167	4	applied	\N	\N	\N	\N	90136	90136	90137
20166	29168	5	applied	\N	\N	\N	\N	90138	90138	90139
20169	29169	0	applied	\N	\N	\N	\N	90143	90143	90144
20169	29170	1	applied	\N	\N	\N	\N	90145	90145	90146
20169	29171	2	applied	\N	\N	\N	\N	90147	90147	90148
20169	29172	3	applied	\N	\N	\N	\N	90149	90149	90150
20169	29173	4	applied	\N	\N	\N	\N	29193	29193	90151
20169	29174	5	applied	\N	\N	\N	\N	90152	90152	90153
20169	29175	6	applied	\N	\N	\N	\N	90154	90154	90155
20169	29176	7	applied	\N	\N	\N	\N	90156	90156	90157
20169	29177	8	applied	\N	\N	\N	\N	90158	90158	90159
20171	29184	0	applied	\N	\N	\N	\N	90177	90177	90178
20171	29185	1	applied	\N	\N	\N	\N	90179	90179	90180
20171	29186	2	applied	\N	\N	\N	\N	90181	90181	90182
20171	29187	3	applied	\N	\N	1000000000	\N	90183	90183	90184
20174	29193	0	applied	\N	\N	\N	\N	90200	90200	90201
20174	29194	1	applied	\N	\N	\N	\N	90202	90202	90203
20174	29195	2	applied	\N	\N	\N	\N	90204	90204	90205
20174	29196	3	applied	\N	\N	\N	\N	90206	90206	90207
20174	29197	4	applied	\N	\N	\N	\N	90208	90208	90209
20177	29203	0	applied	\N	\N	\N	\N	90226	90226	90227
20177	29204	1	applied	\N	\N	\N	\N	90228	90228	90229
20177	29205	2	applied	\N	\N	\N	\N	90230	90230	90231
20177	29206	3	applied	\N	\N	\N	\N	90232	90232	90233
20177	29207	4	applied	\N	\N	\N	\N	90234	90234	90235
20177	29208	5	applied	\N	\N	\N	\N	90236	90236	90237
20177	29209	6	applied	\N	\N	\N	\N	90238	90238	90239
20177	29210	7	applied	\N	\N	\N	\N	90240	90240	90241
20177	29211	8	applied	\N	\N	\N	\N	90242	90242	90243
20177	29212	9	applied	\N	\N	\N	\N	90244	90244	90245
20189	29243	0	applied	\N	\N	\N	\N	90434	90434	90435
20189	29244	1	applied	\N	\N	\N	\N	90436	90436	90437
20189	29245	2	applied	\N	\N	\N	\N	90438	90438	90439
20192	29259	0	applied	\N	\N	\N	\N	90474	90474	90475
20192	29260	1	applied	\N	\N	\N	\N	90476	90476	90477
20192	29261	2	applied	\N	\N	\N	\N	90478	90478	90479
20192	29262	3	applied	\N	\N	\N	\N	90480	90480	90481
20195	29268	0	applied	\N	\N	\N	\N	90494	90494	90495
20195	29269	1	applied	\N	\N	\N	\N	90496	90496	90497
20195	29270	2	applied	\N	\N	\N	\N	90498	90498	90499
20195	29271	3	applied	\N	\N	\N	\N	90500	90500	90501
20195	29272	4	applied	\N	\N	\N	\N	90502	90502	90503
20195	29273	5	applied	\N	\N	\N	\N	90504	90504	90505
20197	29274	0	applied	\N	\N	\N	\N	90512	90512	90513
20197	29275	1	applied	\N	\N	\N	\N	90514	90514	90515
20197	29276	2	applied	\N	\N	\N	\N	90516	90516	90517
20197	29277	3	applied	\N	\N	\N	\N	90518	90518	90519
20202	29289	0	applied	\N	\N	\N	\N	90548	90548	90549
20202	29290	1	applied	\N	\N	\N	\N	90550	90550	90551
20202	29291	2	applied	\N	\N	\N	\N	90552	90552	90553
20204	29292	0	applied	\N	\N	\N	\N	90556	90556	90557
20204	29293	1	applied	\N	\N	\N	\N	90558	90558	90559
20204	29294	2	applied	\N	\N	\N	\N	90560	90560	90561
20209	29298	0	applied	\N	\N	\N	\N	90602	90602	90603
20209	29299	1	applied	\N	\N	\N	\N	90604	90604	90605
20209	29300	2	applied	\N	\N	\N	\N	90606	90606	90607
20212	29295	0	applied	\N	\N	\N	\N	90594	90594	90595
20212	29298	1	applied	\N	\N	\N	\N	90602	90602	90603
20212	29296	2	applied	\N	\N	\N	\N	90596	90596	90597
20212	29299	3	applied	\N	\N	\N	\N	90604	90604	90611
20212	29300	4	applied	\N	\N	\N	\N	90606	90606	90612
20212	29297	5	applied	\N	\N	\N	\N	90598	90598	90607
20214	29309	0	applied	\N	\N	\N	\N	90633	90633	90634
20214	29310	1	applied	\N	\N	\N	\N	90635	90635	90636
20214	29311	2	applied	\N	\N	\N	\N	90637	90637	90638
20219	29312	0	applied	\N	\N	\N	\N	90641	90641	90642
20219	29313	1	applied	\N	\N	\N	\N	90643	90643	90644
20219	29314	2	applied	\N	\N	\N	\N	90645	90645	90646
20219	29315	3	applied	\N	\N	\N	\N	90647	90647	90648
20219	29316	4	applied	\N	\N	\N	\N	90649	90649	90650
20219	29317	5	applied	\N	\N	\N	\N	90651	90651	90652
20219	29318	6	applied	\N	\N	\N	\N	90653	90653	90654
20222	29319	0	applied	\N	\N	\N	\N	90665	90665	90666
20222	29320	1	applied	\N	\N	\N	\N	90667	90667	90668
20222	29321	2	applied	\N	\N	\N	\N	90669	90669	90670
20222	29322	3	applied	\N	\N	\N	\N	90671	90671	90672
20222	29323	4	applied	\N	\N	\N	\N	90673	90673	90674
20222	29324	5	applied	\N	\N	\N	\N	90675	90675	90654
20222	29315	6	applied	\N	\N	\N	\N	90647	90647	90676
20222	29318	7	applied	\N	\N	\N	\N	90653	90653	90677
20222	29325	8	applied	\N	\N	\N	\N	90678	90678	90679
20222	29326	9	applied	\N	\N	\N	\N	90680	90680	90681
20226	29327	0	applied	\N	\N	\N	\N	90689	90689	90690
20226	29328	1	applied	\N	\N	\N	\N	90691	90691	90692
20226	29329	2	applied	\N	\N	\N	\N	90693	90693	90694
20234	29349	0	applied	\N	\N	\N	\N	90745	90745	90746
20234	29350	1	applied	\N	\N	\N	\N	90747	90747	90748
20234	29351	2	applied	\N	\N	\N	\N	90749	90749	90750
20234	29352	3	applied	\N	\N	\N	\N	90751	90751	90752
20237	29354	0	applied	\N	\N	\N	\N	90780	90780	90781
20237	29355	1	applied	\N	\N	\N	\N	90782	90782	90783
20237	29356	2	applied	\N	\N	\N	\N	90784	90784	90785
20240	29360	0	applied	\N	\N	\N	\N	90796	90796	90797
20240	29361	1	applied	\N	\N	\N	\N	90798	90798	90799
20240	29362	2	applied	\N	\N	\N	\N	90800	90800	90801
20240	29363	3	applied	\N	\N	\N	\N	90802	90802	90803
20242	29364	0	applied	\N	\N	\N	\N	90809	90809	90810
20242	29365	1	applied	\N	\N	\N	\N	90811	90811	90812
20242	29366	2	applied	\N	\N	\N	\N	90813	90813	90814
20242	29367	3	applied	\N	\N	\N	\N	90815	90815	90816
20242	29368	4	applied	\N	\N	\N	\N	90817	90817	90818
20242	29369	5	applied	\N	\N	\N	\N	90819	90819	90820
20242	29370	6	applied	\N	\N	\N	\N	90821	90821	90822
20245	29382	0	applied	\N	\N	\N	\N	90847	90847	90848
20245	29383	1	applied	\N	\N	\N	\N	90849	90849	90850
20245	29384	2	applied	\N	\N	\N	\N	90851	90851	90852
20245	29385	3	applied	\N	\N	\N	\N	90853	90853	90854
20245	29386	4	applied	\N	\N	\N	\N	90855	90855	90856
20245	29387	5	applied	\N	\N	\N	\N	90857	90857	90858
20252	29410	0	applied	\N	\N	\N	\N	90915	90915	90916
20252	29411	1	applied	\N	\N	\N	\N	90917	90917	90918
20181	27726	94	applied	\N	\N	\N	\N	86026	86026	90314
20181	27732	95	applied	\N	\N	\N	\N	86040	86040	86004
20181	29123	96	applied	\N	\N	\N	\N	90028	90028	90315
20181	28071	97	applied	\N	\N	\N	\N	87154	87154	86386
20181	28077	98	applied	\N	\N	\N	\N	87169	87169	90316
20183	29220	0	applied	\N	\N	\N	\N	90330	90330	90331
20183	29221	1	applied	\N	\N	\N	\N	90332	90332	90333
20183	29222	2	applied	\N	\N	\N	\N	90334	90334	90335
20183	29223	3	applied	\N	\N	\N	\N	90336	90336	90337
20183	29224	4	applied	\N	\N	\N	\N	90338	90338	90339
20183	29225	5	applied	\N	\N	\N	\N	90340	90340	90341
20183	29226	6	applied	\N	\N	\N	\N	90342	90342	90343
20183	29227	7	applied	\N	\N	\N	\N	90344	90344	90345
20183	29228	8	applied	\N	\N	\N	\N	90346	90346	90347
20183	29229	9	applied	\N	\N	\N	\N	90348	90348	90349
20186	29233	0	applied	\N	\N	\N	\N	90412	90412	90413
20186	29234	1	applied	\N	\N	\N	\N	90414	90414	90415
20186	29235	2	applied	\N	\N	\N	\N	90416	90416	90417
20186	29236	3	applied	\N	\N	\N	\N	90418	90418	90419
20186	29237	4	applied	\N	\N	\N	\N	90420	90420	90421
20186	29238	5	applied	\N	\N	\N	\N	90422	90422	90423
20186	29239	6	applied	\N	\N	\N	\N	90424	90424	90425
20186	29240	7	applied	\N	\N	\N	\N	90426	90426	90427
20186	29241	8	applied	\N	\N	\N	\N	90428	90428	90429
20186	29242	9	applied	\N	\N	\N	\N	90430	90430	90431
20191	29250	0	applied	\N	\N	\N	\N	90454	90454	90455
20191	29251	1	applied	\N	\N	\N	\N	90456	90456	90457
20191	29252	2	applied	\N	\N	\N	\N	90458	90458	90459
20191	29253	3	applied	\N	\N	\N	\N	90460	90460	90461
20191	29254	4	applied	\N	\N	\N	\N	90462	90462	90463
20191	29255	5	applied	\N	\N	\N	\N	90464	90464	90465
20191	29256	6	applied	\N	\N	\N	\N	90466	90466	90467
20191	29257	7	applied	\N	\N	\N	\N	90468	90468	90469
20191	29258	8	applied	\N	\N	\N	\N	90470	90470	90471
20194	29268	0	applied	\N	\N	\N	\N	90494	90494	90495
20194	29269	1	applied	\N	\N	\N	\N	90496	90496	90497
20194	29270	2	applied	\N	\N	\N	\N	90498	90498	90499
20194	29271	3	applied	\N	\N	\N	\N	90500	90500	90501
20194	29272	4	applied	\N	\N	\N	\N	90502	90502	90503
20194	29273	5	applied	\N	\N	\N	\N	90504	90504	90505
20199	29278	0	applied	\N	\N	\N	\N	90523	90523	90524
20199	29279	1	applied	\N	\N	\N	\N	90525	90525	90526
20199	29280	2	applied	\N	\N	\N	\N	90527	90527	90528
20199	29281	3	applied	\N	\N	\N	\N	90529	90529	90530
20199	29282	4	applied	\N	\N	\N	\N	90531	90531	90532
20199	29283	5	applied	\N	\N	\N	\N	90533	90533	90534
20199	29284	6	applied	\N	\N	\N	\N	90535	90535	90536
20199	29285	7	applied	\N	\N	\N	\N	90537	90537	90538
20208	29298	0	applied	\N	\N	\N	\N	90602	90602	90603
20208	29299	1	applied	\N	\N	\N	\N	90604	90604	90605
20208	29300	2	applied	\N	\N	\N	\N	90606	90606	90607
20217	29312	0	applied	\N	\N	\N	\N	90641	90641	90642
20217	29313	1	applied	\N	\N	\N	\N	90643	90643	90644
20217	29314	2	applied	\N	\N	\N	\N	90645	90645	90646
20217	29316	3	applied	\N	\N	\N	\N	90649	90649	90658
20217	29317	4	applied	\N	\N	\N	\N	90651	90651	90659
20221	29319	0	applied	\N	\N	\N	\N	90665	90665	90666
20221	29320	1	applied	\N	\N	\N	\N	90667	90667	90668
20221	29321	2	applied	\N	\N	\N	\N	90669	90669	90670
20221	29322	3	applied	\N	\N	\N	\N	90671	90671	90672
20221	29323	4	applied	\N	\N	\N	\N	90673	90673	90674
20221	29324	5	applied	\N	\N	\N	\N	90675	90675	90654
20221	29315	6	applied	\N	\N	\N	\N	90647	90647	90676
20221	29318	7	applied	\N	\N	\N	\N	90653	90653	90677
20221	29325	8	applied	\N	\N	\N	\N	90678	90678	90679
20221	29326	9	applied	\N	\N	\N	\N	90680	90680	90681
20231	29340	0	applied	\N	\N	\N	\N	90724	90724	90725
20231	29341	1	applied	\N	\N	\N	\N	90726	90726	90727
20231	29342	2	applied	\N	\N	\N	\N	90728	90728	90729
20233	29349	0	applied	\N	\N	\N	\N	90745	90745	90746
20233	29350	1	applied	\N	\N	\N	\N	90747	90747	90748
20233	29351	2	applied	\N	\N	\N	\N	90749	90749	90750
20233	29352	3	applied	\N	\N	\N	\N	90751	90751	90752
20236	29301	0	applied	\N	\N	\N	\N	90615	90615	90616
20236	29344	1	applied	\N	\N	\N	\N	90734	90734	90735
20236	29345	2	applied	\N	\N	\N	\N	90736	90736	90737
20236	29346	3	applied	\N	\N	\N	\N	90738	90738	90739
20236	29302	4	applied	\N	\N	\N	\N	90617	90617	90618
20236	29309	5	applied	\N	\N	\N	\N	90633	90633	90634
20236	29312	6	applied	\N	\N	\N	\N	90641	90641	90642
20236	29353	7	applied	\N	\N	\N	\N	90758	90758	90759
20236	29313	8	applied	\N	\N	\N	\N	90643	90643	90644
20236	29319	9	applied	\N	\N	\N	\N	90665	90665	90666
20236	29320	10	applied	\N	\N	\N	\N	90667	90667	90668
20236	29321	11	applied	\N	\N	\N	\N	90669	90669	90670
20236	29327	12	applied	\N	\N	\N	\N	90689	90689	90690
20236	29330	13	applied	\N	\N	\N	\N	90698	90698	90699
20236	29331	14	applied	\N	\N	\N	\N	90700	90700	90701
20236	29336	15	applied	\N	\N	\N	\N	90714	90714	90715
20236	29340	16	applied	\N	\N	\N	\N	90724	90724	90725
20236	29343	17	applied	\N	\N	\N	\N	90732	90732	90733
20236	29349	18	applied	\N	\N	\N	\N	90745	90745	90746
20236	29303	19	applied	\N	\N	\N	\N	90619	90619	90620
20236	29304	20	applied	\N	\N	\N	\N	90621	90621	90622
20236	29305	21	applied	\N	\N	\N	\N	90623	90623	90624
20236	29306	22	applied	\N	\N	\N	\N	90625	90625	90626
20236	29311	23	applied	\N	\N	\N	\N	90637	90637	90630
20236	29315	24	applied	\N	\N	\N	\N	90647	90647	90760
20236	29307	25	applied	\N	\N	\N	\N	90627	90627	90761
20236	29314	26	applied	\N	\N	\N	\N	90645	90645	90638
20236	29328	27	applied	\N	\N	\N	\N	90691	90691	90646
20236	29339	28	applied	\N	\N	\N	\N	90720	90720	90762
20236	29352	29	applied	\N	\N	\N	\N	90751	90751	90658
20236	29318	30	applied	\N	\N	\N	\N	90653	90653	90650
20236	29325	31	applied	\N	\N	\N	\N	90678	90678	90674
20236	29326	32	applied	\N	\N	\N	\N	90680	90680	90763
20236	29329	33	applied	\N	\N	\N	\N	90693	90693	90764
20236	29334	34	applied	\N	\N	\N	\N	90706	90706	90765
20236	29335	35	applied	\N	\N	\N	\N	90708	90708	90766
20236	29337	36	applied	\N	\N	\N	\N	90716	90716	90692
20236	29341	38	applied	\N	\N	\N	\N	90726	90726	90694
20236	29347	39	applied	\N	\N	\N	\N	90740	90740	90768
20236	29350	40	applied	\N	\N	\N	\N	90747	90747	90769
20236	29308	41	applied	\N	\N	\N	\N	90629	90629	90770
20236	29310	42	applied	\N	\N	\N	\N	90635	90635	90709
20236	29316	43	applied	\N	\N	\N	\N	90649	90649	90771
20236	29317	44	applied	\N	\N	\N	\N	90651	90651	90772
20236	29322	45	applied	\N	\N	\N	\N	90671	90671	90721
20236	29323	46	applied	\N	\N	\N	\N	90673	90673	90773
20236	29324	47	applied	\N	\N	\N	\N	90675	90675	90774
20185	29146	23	applied	\N	\N	\N	\N	90373	90373	90093
20185	29147	24	applied	\N	\N	\N	\N	90374	90374	90095
20185	28814	25	applied	\N	\N	\N	\N	89256	89256	89256
20185	28970	26	applied	\N	\N	\N	\N	90375	90375	89613
20185	28971	27	applied	\N	\N	\N	\N	90376	90376	89615
20185	28972	28	applied	\N	\N	\N	\N	90377	90377	89617
20185	28990	29	applied	\N	\N	\N	\N	90378	90378	89661
20185	28887	30	applied	\N	\N	\N	\N	89415	89415	89416
20185	28581	31	applied	\N	\N	\N	\N	88624	88624	88603
20185	28983	32	applied	\N	\N	\N	\N	89642	89642	89643
20185	29100	33	applied	\N	\N	\N	\N	90277	90277	89981
20185	28942	34	applied	\N	\N	\N	\N	90033	90033	28166
20185	28943	36	applied	\N	\N	\N	\N	90278	90278	89545
20185	28675	37	applied	\N	\N	\N	\N	88881	88881	88882
20185	28801	38	applied	\N	\N	\N	\N	89223	89223	89224
20185	29115	39	applied	\N	\N	\N	\N	90034	90034	90013
20185	29116	40	applied	\N	\N	\N	\N	90035	90035	90015
20185	29017	41	applied	\N	\N	\N	\N	90279	90279	89728
20185	29018	42	applied	\N	\N	\N	\N	90280	90280	89730
20185	29163	43	applied	\N	\N	\N	\N	90128	90128	90129
20185	28984	44	applied	\N	\N	\N	\N	89644	89644	89645
20185	28985	45	applied	\N	\N	\N	\N	89646	89646	89647
20185	28889	46	applied	\N	\N	\N	\N	89419	89419	89420
20185	28890	47	applied	\N	\N	\N	\N	89421	89421	89422
20185	28891	48	applied	\N	\N	\N	\N	89423	89423	89424
20185	28892	49	applied	\N	\N	\N	\N	89425	89425	89426
20185	28893	50	applied	\N	\N	\N	\N	89427	89427	89428
20185	28906	51	applied	\N	\N	\N	\N	32796	32796	89455
20185	28591	52	applied	\N	\N	\N	\N	90380	90380	88673
20185	28545	53	applied	\N	\N	1000000000	\N	90281	90281	88507
20185	28558	54	applied	\N	\N	\N	\N	90381	90381	88627
20185	28944	55	applied	\N	\N	\N	\N	90282	90282	89547
20185	28945	56	applied	\N	\N	\N	\N	90283	90283	89549
20185	28946	57	applied	\N	\N	\N	\N	90284	90284	89551
20185	28953	58	applied	\N	\N	\N	\N	90285	90285	89569
20185	29117	59	applied	\N	\N	\N	\N	90036	90036	90017
20185	29118	60	applied	\N	\N	\N	\N	90037	90037	90019
20185	28834	61	applied	\N	\N	\N	\N	90038	90038	90038
20185	28793	62	applied	\N	\N	\N	\N	89203	89203	89204
20185	29170	63	applied	\N	\N	\N	\N	90145	90145	90146
20185	29178	64	applied	\N	\N	\N	\N	90164	90164	90165
20185	29190	65	applied	\N	\N	\N	\N	90192	90192	90193
20185	28802	66	applied	\N	\N	\N	\N	89225	89225	89226
20185	28807	67	applied	\N	\N	\N	\N	89239	89239	89304
20185	28808	68	applied	\N	\N	\N	\N	89241	89241	89242
20185	28809	69	applied	\N	\N	\N	\N	89243	89243	89244
20185	28824	70	applied	\N	\N	1000000000	\N	89282	89282	90039
20185	28795	71	applied	\N	\N	\N	\N	89209	89209	89210
20185	28800	72	applied	\N	\N	\N	\N	89221	89221	89222
20185	28447	73	applied	\N	\N	\N	\N	88236	88236	88237
20185	28448	74	applied	\N	\N	\N	\N	88238	88238	88239
20185	29019	75	applied	\N	\N	\N	\N	90286	90286	89732
20185	28356	76	applied	\N	\N	\N	\N	87941	87941	88349
20185	28357	77	applied	\N	\N	\N	\N	87943	87943	88350
20185	28358	78	applied	\N	\N	\N	\N	87945	87945	88351
20185	28367	79	applied	\N	\N	\N	\N	87966	87966	88352
20185	28372	80	applied	\N	\N	\N	\N	87981	87981	88353
20185	28377	81	applied	\N	\N	\N	\N	87994	87994	88354
20185	28380	82	applied	\N	\N	\N	\N	88003	88003	88355
20185	28384	83	applied	\N	\N	\N	\N	88011	88011	88356
20185	28388	84	applied	\N	\N	\N	\N	88021	88021	88357
20185	28450	85	applied	\N	\N	\N	\N	88242	88242	88243
20185	28451	86	applied	\N	\N	\N	\N	88244	88244	88245
20185	28817	87	applied	\N	\N	\N	\N	90287	90287	89262
20185	28818	88	applied	\N	\N	\N	\N	90288	90288	89264
20185	28822	89	applied	\N	\N	\N	\N	90289	90289	89279
20185	28823	90	applied	\N	\N	\N	\N	90290	90290	89281
20185	28592	91	applied	\N	\N	\N	\N	90382	90382	88675
20185	28596	92	applied	\N	\N	\N	\N	90383	90383	88686
20185	28992	93	applied	\N	\N	\N	\N	89666	89666	89667
20185	28394	94	applied	\N	\N	\N	\N	88034	88034	88358
20185	28395	95	applied	\N	\N	\N	\N	88036	88036	88359
20185	28400	96	applied	\N	\N	\N	\N	88048	88048	88360
20185	28406	97	applied	\N	\N	\N	\N	88069	88069	88361
20185	28409	98	applied	\N	\N	\N	\N	88077	88077	88362
20185	28826	99	applied	\N	\N	\N	\N	90291	90291	89287
20185	28827	100	applied	\N	\N	\N	\N	90292	90292	89289
20185	28828	101	applied	\N	\N	\N	\N	90384	90384	89291
20185	28829	102	applied	\N	\N	\N	\N	90385	90385	89293
20185	28830	103	applied	\N	\N	\N	\N	90386	90386	89295
20185	28831	104	applied	\N	\N	\N	\N	90387	90387	89297
20185	28837	105	applied	\N	\N	\N	\N	90388	90388	89310
20185	28838	106	applied	\N	\N	\N	\N	90389	90389	89312
20185	28839	107	applied	\N	\N	\N	\N	90390	90390	89314
20185	28840	108	applied	\N	\N	\N	\N	90391	90391	89316
20185	28841	109	applied	\N	\N	\N	\N	90392	90392	89318
20185	28842	110	applied	\N	\N	\N	\N	90393	90393	89320
20185	28843	111	applied	\N	\N	\N	\N	90394	90394	89322
20185	28844	112	applied	\N	\N	\N	\N	90395	90395	89324
20185	28845	113	applied	\N	\N	\N	\N	90396	90396	89326
20185	28846	114	applied	\N	\N	\N	\N	90397	90397	89328
20185	28847	115	applied	\N	\N	\N	\N	90398	90398	89330
20185	28848	116	applied	\N	\N	\N	\N	90399	90399	89332
20185	28849	117	applied	\N	\N	\N	\N	90400	90400	89334
20185	28850	118	applied	\N	\N	\N	\N	90401	90401	89336
20185	28851	119	applied	\N	\N	\N	\N	90402	90402	89338
20185	28852	120	applied	\N	\N	\N	\N	90403	90403	89340
20185	28853	121	applied	\N	\N	\N	\N	90404	90404	89342
20185	28854	122	applied	\N	\N	\N	\N	90405	90405	89344
20185	28862	123	applied	\N	\N	\N	\N	90406	90406	89361
20185	28863	124	applied	\N	\N	\N	\N	90407	90407	89363
20188	29243	0	applied	\N	\N	\N	\N	90434	90434	90435
20188	29244	1	applied	\N	\N	\N	\N	90436	90436	90437
20188	29245	2	applied	\N	\N	\N	\N	90438	90438	90439
20190	29246	0	applied	\N	\N	\N	\N	90445	90445	90446
20190	29247	1	applied	\N	\N	\N	\N	90447	90447	90448
20190	29248	2	applied	\N	\N	\N	\N	90449	90449	90450
20190	29249	3	applied	\N	\N	\N	\N	90451	90451	90452
20201	29286	0	applied	\N	\N	\N	\N	90540	90540	90541
20201	29287	1	applied	\N	\N	\N	\N	90542	90542	90543
20201	29288	2	applied	\N	\N	\N	\N	90544	90544	90545
20203	29292	0	applied	\N	\N	\N	\N	90556	90556	90557
20203	29293	1	applied	\N	\N	\N	\N	90558	90558	90559
20203	29294	2	applied	\N	\N	\N	\N	90560	90560	90561
20206	29220	0	applied	\N	\N	\N	\N	90330	90330	90331
20206	29269	1	applied	\N	\N	\N	\N	90496	90496	90497
20206	29270	2	applied	\N	\N	\N	\N	90498	90498	90499
20206	29275	3	applied	\N	\N	\N	\N	90514	90514	90515
20206	29278	4	applied	\N	\N	\N	\N	90523	90523	90524
20206	29221	5	applied	\N	\N	\N	\N	90332	90332	90333
20206	29222	6	applied	\N	\N	\N	\N	90334	90334	90335
20206	29230	7	applied	\N	\N	\N	\N	90352	90352	90353
20206	29233	8	applied	\N	\N	\N	\N	90412	90412	90413
20206	29234	9	applied	\N	\N	\N	\N	90414	90414	90415
20206	29235	10	applied	\N	\N	\N	\N	90416	90416	90417
20206	29243	11	applied	\N	\N	\N	\N	90434	90434	90435
20206	29246	12	applied	\N	\N	\N	\N	90445	90445	90446
20206	29250	13	applied	\N	\N	\N	\N	90454	90454	90455
20206	29251	14	applied	\N	\N	\N	\N	90456	90456	90457
20206	29252	15	applied	\N	\N	\N	\N	90458	90458	90459
20206	29259	16	applied	\N	\N	\N	\N	90474	90474	90475
20206	29263	17	applied	\N	\N	\N	\N	90483	90483	90484
20206	29264	18	applied	\N	\N	\N	\N	90485	90485	90486
20206	29268	19	applied	\N	\N	\N	\N	90494	90494	90495
20206	29274	20	applied	\N	\N	\N	\N	90512	90512	90513
20206	29279	21	applied	\N	\N	\N	\N	90525	90525	90526
20206	29280	22	applied	\N	\N	\N	\N	90527	90527	90528
20206	29286	23	applied	\N	\N	\N	\N	90540	90540	90541
20206	29289	24	applied	\N	\N	\N	\N	90548	90548	90549
20206	29292	25	applied	\N	\N	\N	\N	90556	90556	90557
20206	29223	26	applied	\N	\N	\N	\N	90336	90336	90337
20206	29224	27	applied	\N	\N	\N	\N	90338	90338	90339
20206	29225	28	applied	\N	\N	\N	\N	90340	90340	90341
20206	29226	29	applied	\N	\N	\N	\N	90342	90342	90343
20206	29227	30	applied	\N	\N	\N	\N	90344	90344	90345
20206	29242	31	applied	\N	\N	\N	\N	90430	90430	90566
20206	29248	32	applied	\N	\N	\N	\N	90449	90449	90347
20206	29261	33	applied	\N	\N	\N	\N	90478	90478	90567
20206	29271	34	applied	\N	\N	\N	\N	90500	90500	90349
20206	29228	35	applied	\N	\N	\N	\N	90346	90346	90355
20206	29229	36	applied	\N	\N	\N	\N	90348	90348	90568
20206	29231	37	applied	\N	\N	\N	\N	90354	90354	90569
20206	29236	38	applied	\N	\N	\N	\N	90418	90418	90570
20206	29237	39	applied	\N	\N	\N	\N	90420	90420	90571
20206	29238	40	applied	\N	\N	\N	\N	90422	90422	90572
20206	29244	41	applied	\N	\N	\N	\N	90436	90436	90425
20206	29247	42	applied	\N	\N	\N	\N	90447	90447	90573
20206	29253	43	applied	\N	\N	\N	\N	90460	90460	90574
20206	29257	44	applied	\N	\N	\N	\N	90468	90468	90429
20206	29258	45	applied	\N	\N	\N	\N	90470	90470	90575
20206	29262	46	applied	\N	\N	\N	\N	90480	90480	90576
20206	29265	47	applied	\N	\N	\N	\N	90487	90487	90439
20206	29266	48	applied	\N	\N	\N	\N	90489	90489	90448
20206	29272	49	applied	\N	\N	\N	\N	90502	90502	90577
20206	29276	50	applied	\N	\N	\N	\N	90516	90516	90452
20206	29281	51	applied	\N	\N	\N	\N	90529	90529	90461
20206	29282	52	applied	\N	\N	\N	\N	90531	90531	90578
20206	29287	53	applied	\N	\N	\N	\N	90542	90542	90579
20206	29291	54	applied	\N	\N	\N	\N	90552	90552	90465
20206	29232	55	applied	\N	\N	\N	\N	90356	90356	90467
20206	29239	56	applied	\N	\N	\N	\N	90424	90424	90580
20206	29240	57	applied	\N	\N	\N	\N	90426	90426	90581
20206	29241	58	applied	\N	\N	\N	\N	90428	90428	90582
20206	29245	59	applied	\N	\N	\N	\N	90438	90438	90488
20206	29249	60	applied	\N	\N	\N	\N	90451	90451	90583
20206	29254	61	applied	\N	\N	\N	\N	90462	90462	90501
20206	29255	62	applied	\N	\N	\N	\N	90464	90464	90584
20206	29256	63	applied	\N	\N	\N	\N	90466	90466	90585
20206	29260	64	applied	\N	\N	\N	\N	90476	90476	90586
20206	29267	65	applied	\N	\N	\N	\N	90491	90491	90530
20206	29273	66	applied	\N	\N	\N	\N	90504	90504	90587
20206	29277	67	applied	\N	\N	\N	\N	90518	90518	90588
20206	29283	68	applied	\N	\N	\N	\N	90533	90533	90538
20206	29284	69	applied	\N	\N	\N	\N	90535	90535	90589
20206	29288	70	applied	\N	\N	\N	\N	90544	90544	90590
20206	29290	71	applied	\N	\N	\N	\N	90550	90550	90591
20206	29293	72	applied	\N	\N	\N	\N	90558	90558	90592
20206	29285	73	applied	\N	\N	\N	\N	90537	90537	90559
20206	29294	74	applied	\N	\N	\N	\N	90560	90560	90561
20211	29298	0	applied	\N	\N	\N	\N	90602	90602	90603
20211	29299	1	applied	\N	\N	\N	\N	90604	90604	90605
20211	29300	2	applied	\N	\N	\N	\N	90606	90606	90607
20213	29301	0	applied	\N	\N	\N	\N	90615	90615	90616
20213	29302	1	applied	\N	\N	\N	\N	90617	90617	90618
20213	29303	2	applied	\N	\N	\N	\N	90619	90619	90620
20213	29304	3	applied	\N	\N	\N	\N	90621	90621	90622
20213	29305	4	applied	\N	\N	\N	\N	90623	90623	90624
20213	29306	5	applied	\N	\N	\N	\N	90625	90625	90626
20213	29307	6	applied	\N	\N	\N	\N	90627	90627	90628
20213	29308	7	applied	\N	\N	\N	\N	90629	90629	90630
20216	29312	0	applied	\N	\N	\N	\N	90641	90641	90642
20216	29313	1	applied	\N	\N	\N	\N	90643	90643	90644
20216	29314	2	applied	\N	\N	\N	\N	90645	90645	90646
20216	29315	3	applied	\N	\N	\N	\N	90647	90647	90648
20216	29316	4	applied	\N	\N	\N	\N	90649	90649	90650
20216	29317	5	applied	\N	\N	\N	\N	90651	90651	90652
20216	29318	6	applied	\N	\N	\N	\N	90653	90653	90654
20220	29319	0	applied	\N	\N	\N	\N	90665	90665	90666
20220	29320	1	applied	\N	\N	\N	\N	90667	90667	90668
20220	29321	2	applied	\N	\N	\N	\N	90669	90669	90670
20220	29322	3	applied	\N	\N	\N	\N	90671	90671	90672
20220	29323	4	applied	\N	\N	\N	\N	90673	90673	90674
20220	29324	5	applied	\N	\N	\N	\N	90675	90675	90654
20220	29315	6	applied	\N	\N	\N	\N	90647	90647	90676
20220	29318	7	applied	\N	\N	\N	\N	90653	90653	90677
20220	29325	8	applied	\N	\N	\N	\N	90678	90678	90679
20220	29326	9	applied	\N	\N	\N	\N	90680	90680	90681
20225	29327	0	applied	\N	\N	\N	\N	90689	90689	90690
20225	29328	1	applied	\N	\N	\N	\N	90691	90691	90692
20225	29329	2	applied	\N	\N	\N	\N	90693	90693	90694
20228	29330	0	applied	\N	\N	\N	\N	90698	90698	90699
20228	29331	1	applied	\N	\N	\N	\N	90700	90700	90701
20228	29332	2	applied	\N	\N	\N	\N	90702	90702	90703
20228	29333	3	applied	\N	\N	\N	\N	90704	90704	90705
20228	29334	4	applied	\N	\N	\N	\N	90706	90706	90707
20228	29335	5	applied	\N	\N	\N	\N	90708	90708	90709
20230	29340	0	applied	\N	\N	\N	\N	90724	90724	90725
20230	29341	1	applied	\N	\N	\N	\N	90726	90726	90727
20230	29342	2	applied	\N	\N	\N	\N	90728	90728	90729
20232	29343	0	applied	\N	\N	\N	\N	90732	90732	90733
20232	29344	1	applied	\N	\N	\N	\N	90734	90734	90735
20232	29345	2	applied	\N	\N	\N	\N	90736	90736	90737
20232	29346	3	applied	\N	\N	\N	\N	90738	90738	90739
20232	29347	4	applied	\N	\N	\N	\N	90740	90740	90741
20232	29348	5	applied	\N	\N	\N	\N	90742	90742	90743
20243	29371	0	applied	\N	\N	\N	\N	90824	90824	90825
20243	29372	1	applied	\N	\N	\N	\N	90826	90826	90827
20243	29373	2	applied	\N	\N	\N	\N	90828	90828	90829
20248	29395	0	applied	\N	\N	\N	\N	90877	90877	90878
20235	29350	1	applied	\N	\N	\N	\N	90747	90747	90748
20235	29351	2	applied	\N	\N	\N	\N	90749	90749	90750
20235	29352	3	applied	\N	\N	\N	\N	90751	90751	90752
20238	29357	0	applied	\N	\N	\N	\N	90788	90788	90789
20238	29358	1	applied	\N	\N	\N	\N	90790	90790	90791
20238	29359	2	applied	\N	\N	\N	\N	90792	90792	90793
20241	29360	0	applied	\N	\N	\N	\N	90796	90796	90797
20241	29361	1	applied	\N	\N	\N	\N	90798	90798	90799
20241	29362	2	applied	\N	\N	\N	\N	90800	90800	90801
20241	29363	3	applied	\N	\N	\N	\N	90802	90802	90803
20246	29388	0	applied	\N	\N	\N	\N	90861	90861	90862
20246	29389	1	applied	\N	\N	\N	\N	90863	90863	90864
20246	29390	2	applied	\N	\N	\N	\N	90865	90865	90866
20246	29391	3	applied	\N	\N	\N	\N	90867	90867	90868
20246	29392	4	applied	\N	\N	\N	\N	90869	90869	90870
20246	29393	5	applied	\N	\N	\N	\N	90871	90871	90872
20246	29394	6	applied	\N	\N	\N	\N	90873	90873	90874
20247	29395	0	applied	\N	\N	\N	\N	90877	90877	90878
20247	29396	1	applied	\N	\N	\N	\N	90879	90879	90880
20247	29397	2	applied	\N	\N	\N	\N	90881	90881	90882
20247	29398	3	applied	\N	\N	\N	\N	90883	90883	90884
20247	29399	4	applied	\N	\N	\N	\N	90885	90885	90886
20247	29400	5	applied	\N	\N	\N	\N	90887	90887	90888
20247	29401	6	applied	\N	\N	\N	\N	90889	90889	90890
20247	29402	7	applied	\N	\N	\N	\N	90891	90891	90892
20247	29403	9	applied	\N	\N	\N	\N	90894	90894	90895
20249	29404	0	applied	\N	\N	\N	\N	90901	90901	90902
20249	29405	1	applied	\N	\N	\N	\N	90903	90903	90904
20249	29406	2	applied	\N	\N	\N	\N	90905	90905	90906
20253	29417	0	applied	\N	\N	\N	\N	90933	90933	90934
20253	29418	1	applied	\N	\N	\N	\N	90935	90935	90936
20253	29419	2	applied	\N	\N	\N	\N	90937	90937	90938
20253	29420	3	applied	\N	\N	\N	\N	90939	90939	90940
20253	29421	4	applied	\N	\N	\N	\N	90941	90941	90942
20253	29422	5	applied	\N	\N	\N	\N	90943	90943	90944
20253	29423	6	applied	\N	\N	\N	\N	90945	90945	90946
20253	29424	7	applied	\N	\N	\N	\N	90947	90947	90948
20253	29425	8	applied	\N	\N	\N	\N	90949	90949	90950
20253	29426	9	applied	\N	\N	\N	\N	90951	90951	90952
20253	29427	10	applied	\N	\N	\N	\N	90953	90953	90954
20253	29428	11	applied	\N	\N	\N	\N	90955	90955	90956
20253	29429	12	applied	\N	\N	\N	\N	90957	90957	90958
20255	29430	0	applied	\N	\N	\N	\N	90962	90962	90963
20255	29431	1	applied	\N	\N	\N	\N	90964	90964	90965
20255	29432	2	applied	\N	\N	\N	\N	90966	90966	90967
20257	29430	0	applied	\N	\N	\N	\N	90962	90962	90963
20257	29431	1	applied	\N	\N	\N	\N	90964	90964	90965
20257	29432	2	applied	\N	\N	\N	\N	90966	90966	90967
20258	29433	0	applied	\N	\N	\N	\N	90972	90972	90973
20258	29434	1	applied	\N	\N	\N	\N	90974	90974	90975
20258	29435	2	applied	\N	\N	\N	\N	90976	90976	90977
20258	29436	3	applied	\N	\N	\N	\N	90978	90978	90979
20258	29437	4	applied	\N	\N	\N	\N	90980	90980	90981
20258	29438	5	applied	\N	\N	\N	\N	90982	90982	90983
20258	29439	6	applied	\N	\N	\N	\N	90984	90984	90985
20261	29443	0	applied	\N	\N	\N	\N	90996	90996	90997
20261	29446	1	applied	\N	\N	\N	\N	91004	91004	91005
20261	29444	2	applied	\N	\N	\N	\N	90998	90998	91006
20261	29445	3	applied	\N	\N	\N	\N	91000	91000	91007
20270	29459	0	applied	\N	\N	\N	\N	91045	91045	91046
20270	29460	1	applied	\N	\N	\N	\N	91047	91047	91048
20270	29461	2	applied	\N	\N	\N	\N	91049	91049	91050
20270	29462	3	applied	\N	\N	\N	\N	91051	91051	91052
20270	29463	4	applied	\N	\N	\N	\N	91053	91053	91054
20275	29471	0	applied	\N	\N	\N	\N	91078	91078	91079
20275	29472	1	applied	\N	\N	\N	\N	91080	91080	91081
20275	29473	2	applied	\N	\N	\N	\N	91082	91082	91083
20275	29474	3	applied	\N	\N	\N	\N	91084	91084	91085
20275	29475	4	applied	\N	\N	\N	\N	91086	91086	91087
20275	29476	5	applied	\N	\N	\N	\N	91088	91088	91089
20275	29477	6	applied	\N	\N	\N	\N	91090	91090	91091
20280	29484	0	applied	\N	\N	\N	\N	91120	91120	91121
20280	29485	1	applied	\N	\N	\N	\N	91122	91122	91123
20280	29486	2	applied	\N	\N	\N	\N	91124	91124	91125
20280	29487	3	applied	\N	\N	\N	\N	91126	91126	91127
20284	29491	0	applied	\N	\N	\N	\N	91145	91145	91146
20284	29492	1	applied	\N	\N	\N	\N	91147	91147	91148
20284	29493	2	applied	\N	\N	\N	\N	91149	91149	91150
20284	29494	4	applied	\N	\N	\N	\N	91152	91152	91153
20284	29495	5	applied	\N	\N	\N	\N	91154	91154	91155
20284	29496	6	applied	\N	\N	\N	\N	91156	91156	91157
20290	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20290	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20290	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20290	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20290	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20290	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20290	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20293	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20293	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20293	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20293	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20293	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20293	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20293	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20299	29523	0	applied	\N	\N	\N	\N	91237	91237	91238
20299	29524	1	applied	\N	\N	\N	\N	91239	91239	91240
20299	29525	2	applied	\N	\N	\N	\N	91241	91241	91242
20301	29533	0	applied	\N	\N	\N	\N	91262	91262	91263
20301	29534	1	applied	\N	\N	\N	\N	91264	91264	91265
20301	29535	2	applied	\N	\N	\N	\N	91266	91266	91267
20309	29556	0	applied	\N	\N	\N	\N	91318	91318	91319
20309	29557	1	applied	\N	\N	\N	\N	91320	91320	91321
20309	29558	2	applied	\N	\N	\N	\N	91322	91322	91323
20312	29566	0	applied	\N	\N	\N	\N	91342	91342	91343
20312	29567	1	applied	\N	\N	\N	\N	91344	91344	91345
20312	29568	2	applied	\N	\N	\N	\N	91346	91346	91347
20314	29569	0	applied	\N	\N	\N	\N	91353	91353	91354
20314	29570	1	applied	\N	\N	\N	\N	91355	91355	91356
20314	29571	2	applied	\N	\N	\N	\N	91357	91357	91358
20317	29572	0	applied	\N	\N	\N	\N	91361	91361	91362
20317	29573	1	applied	\N	\N	\N	\N	91363	91363	91364
20317	29574	2	applied	\N	\N	\N	\N	91365	91365	91366
20317	29575	3	applied	\N	\N	\N	\N	91367	91367	91368
20319	29572	0	applied	\N	\N	\N	\N	91361	91361	91362
20319	29576	1	applied	\N	\N	\N	\N	91374	91374	91375
20319	29577	2	applied	\N	\N	\N	\N	91376	91376	91377
20319	29578	3	applied	\N	\N	\N	\N	91378	91378	91379
20319	29575	4	applied	\N	\N	\N	\N	91367	91367	91368
20319	29583	5	applied	\N	\N	\N	\N	91390	91390	91383
20236	29332	48	applied	\N	\N	\N	\N	90702	90702	90775
20236	29333	49	applied	\N	\N	\N	\N	90704	90704	90741
20236	29338	50	applied	\N	\N	\N	\N	90718	90718	90743
20236	29342	51	applied	\N	\N	\N	\N	90728	90728	90776
20236	29348	52	applied	\N	\N	\N	\N	90742	90742	90777
20236	29351	53	applied	\N	\N	\N	\N	90749	90749	90752
20239	29360	0	applied	\N	\N	\N	\N	90796	90796	90797
20239	29361	1	applied	\N	\N	\N	\N	90798	90798	90799
20239	29362	2	applied	\N	\N	\N	\N	90800	90800	90801
20239	29363	3	applied	\N	\N	\N	\N	90802	90802	90803
20244	29374	0	applied	\N	\N	\N	\N	90831	90831	90759
20244	29375	1	applied	\N	\N	\N	\N	90832	90832	90833
20244	29376	2	applied	\N	\N	\N	\N	90834	90834	90835
20244	29377	3	applied	\N	\N	\N	\N	90836	90836	90837
20244	29378	4	applied	\N	\N	\N	\N	90838	90838	90839
20244	29379	5	applied	\N	\N	\N	\N	90840	90840	90841
20244	29380	6	applied	\N	\N	\N	\N	90842	90842	90843
20244	29381	7	applied	\N	\N	\N	\N	90844	90844	90845
20251	29410	0	applied	\N	\N	\N	\N	90915	90915	90916
20251	29411	1	applied	\N	\N	\N	\N	90917	90917	90918
20251	29412	2	applied	\N	\N	\N	\N	90919	90919	90920
20251	29413	3	applied	\N	\N	\N	\N	90921	90921	90922
20251	29414	4	applied	\N	\N	\N	\N	90923	90923	90924
20251	29415	5	applied	\N	\N	\N	\N	90925	90925	90926
20251	29416	6	applied	\N	\N	\N	\N	90927	90927	90928
20256	29430	0	applied	\N	\N	\N	\N	90962	90962	90963
20256	29432	1	applied	\N	\N	\N	\N	90966	90966	90968
20263	29443	0	applied	\N	\N	\N	\N	90996	90996	90997
20263	29446	1	applied	\N	\N	\N	\N	91004	91004	91005
20263	29444	2	applied	\N	\N	\N	\N	90998	90998	91006
20263	29445	3	applied	\N	\N	\N	\N	91000	91000	91007
20264	29447	0	applied	\N	\N	\N	\N	91012	91012	91013
20264	29448	1	applied	\N	\N	\N	\N	91014	91014	91015
20264	29446	2	applied	\N	\N	\N	\N	91004	91004	91007
20264	29449	3	applied	\N	\N	\N	\N	91016	91016	91017
20264	29450	4	applied	\N	\N	\N	\N	91018	91018	91019
20264	29451	5	applied	\N	\N	\N	\N	91020	91020	91021
20264	29452	6	applied	\N	\N	\N	\N	91022	91022	91023
20267	29453	0	applied	\N	\N	\N	\N	91027	91027	91028
20267	29454	1	applied	\N	\N	\N	\N	91029	91029	91030
20267	29455	2	applied	\N	\N	\N	\N	91031	91031	91032
20269	29456	0	applied	\N	\N	\N	\N	91035	91035	91036
20269	29457	1	applied	\N	\N	\N	\N	91037	91037	91038
20269	29458	2	applied	\N	\N	\N	\N	91039	91039	91040
20272	29459	0	applied	\N	\N	\N	\N	91045	91045	91046
20272	29460	1	applied	\N	\N	\N	\N	91047	91047	91048
20272	29461	2	applied	\N	\N	\N	\N	91049	91049	91050
20272	29462	3	applied	\N	\N	\N	\N	91051	91051	91052
20272	29463	4	applied	\N	\N	\N	\N	91053	91053	91054
20274	29464	0	applied	\N	\N	\N	\N	91062	91062	91063
20274	29465	1	applied	\N	\N	\N	\N	91064	91064	91065
20274	29466	2	applied	\N	\N	\N	\N	91066	91066	91067
20274	29467	3	applied	\N	\N	\N	\N	91068	91068	91069
20274	29468	4	applied	\N	\N	\N	\N	91070	91070	91071
20274	29469	5	applied	\N	\N	\N	\N	91072	91072	91073
20274	29470	6	applied	\N	\N	\N	\N	91074	91074	91075
20277	29478	0	applied	\N	\N	\N	\N	91094	91094	91095
20277	29479	1	applied	\N	\N	\N	\N	91096	91096	91097
20277	29480	2	applied	\N	\N	\N	\N	91098	91098	91099
20277	29481	3	applied	\N	\N	\N	\N	91100	91100	91101
20277	29482	4	applied	\N	\N	\N	\N	91102	91102	91103
20277	29483	5	applied	\N	\N	\N	\N	91104	91104	91105
20278	28930	0	applied	\N	\N	\N	\N	89515	89515	89516
20278	28874	1	applied	\N	\N	\N	\N	89385	89385	89386
20278	29057	2	applied	\N	\N	\N	\N	90268	90268	89840
20278	29058	3	applied	\N	\N	\N	\N	90269	90269	89842
20278	29062	4	applied	\N	\N	\N	\N	90358	90358	89851
20278	29063	5	applied	\N	\N	\N	\N	90359	90359	89853
20278	29015	6	applied	\N	\N	\N	\N	89723	89723	89866
20278	28366	7	applied	\N	\N	\N	\N	87964	87964	87965
20278	28239	8	applied	\N	\N	\N	\N	87617	87617	28166
20278	29016	9	applied	\N	\N	\N	\N	89725	89725	89867
20278	29007	10	applied	\N	\N	\N	\N	89703	89703	89726
20278	29021	11	applied	\N	\N	\N	\N	89737	89737	89738
20278	28565	12	applied	\N	\N	\N	\N	90360	90360	88561
20278	28580	13	applied	\N	\N	\N	\N	90361	90361	88601
20278	28585	14	applied	\N	\N	\N	\N	90362	90362	88614
20278	28595	15	applied	\N	\N	\N	\N	90363	90363	88684
20278	28109	16	applied	\N	\N	\N	\N	87258	87258	87259
20278	28110	17	applied	\N	\N	\N	\N	87260	87260	87261
20278	28111	18	applied	\N	\N	\N	\N	87262	87262	87263
20278	28112	19	applied	\N	\N	\N	\N	87264	87264	87265
20278	28370	20	applied	\N	\N	\N	\N	87977	87977	87978
20278	28371	21	applied	\N	\N	\N	\N	87979	87979	87980
20278	28376	22	applied	\N	\N	\N	\N	87992	87992	87993
20278	28404	23	applied	\N	\N	\N	\N	88058	88058	88059
20278	29137	24	applied	\N	\N	\N	\N	90364	90364	90075
20278	29138	25	applied	\N	\N	\N	\N	90365	90365	90077
20278	29139	26	applied	\N	\N	\N	\N	90366	90366	90079
20278	29140	27	applied	\N	\N	\N	\N	90367	90367	90081
20278	29141	28	applied	\N	\N	\N	\N	90368	90368	90083
20278	29142	29	applied	\N	\N	\N	\N	90369	90369	90085
20278	29143	30	applied	\N	\N	\N	\N	90370	90370	90087
20278	29144	31	applied	\N	\N	\N	\N	90371	90371	90089
20278	29145	32	applied	\N	\N	\N	\N	90372	90372	90091
20278	29146	33	applied	\N	\N	\N	\N	90373	90373	90093
20278	29147	34	applied	\N	\N	\N	\N	90374	90374	90095
20278	28814	35	applied	\N	\N	\N	\N	89256	89256	89256
20278	28970	36	applied	\N	\N	\N	\N	89612	89612	89613
20278	28971	37	applied	\N	\N	\N	\N	89614	89614	89615
20278	28972	38	applied	\N	\N	\N	\N	89616	89616	89617
20278	28990	39	applied	\N	\N	\N	\N	89660	89660	89661
20278	28887	40	applied	\N	\N	\N	\N	89415	89415	89416
20278	28383	41	applied	\N	\N	\N	\N	88009	88009	88010
20278	28581	42	applied	\N	\N	\N	\N	88624	88624	90276
20278	28983	43	applied	\N	\N	\N	\N	89642	89642	89643
20278	28028	44	applied	\N	\N	\N	\N	87051	87051	87052
20278	29100	45	applied	\N	\N	\N	\N	90277	90277	89981
20278	28942	46	applied	\N	\N	\N	\N	90033	90033	28166
20278	28943	47	applied	\N	\N	\N	\N	90278	90278	89545
20278	28675	48	applied	\N	\N	\N	\N	88881	88881	88882
20278	28801	49	applied	\N	\N	\N	\N	89223	89223	89224
20278	29344	50	applied	\N	\N	\N	\N	90734	90734	90735
20278	29345	51	applied	\N	\N	\N	\N	90736	90736	90737
20278	29346	52	applied	\N	\N	\N	\N	90738	90738	90739
20278	29115	53	applied	\N	\N	\N	\N	90034	90034	90013
20278	29116	54	applied	\N	\N	\N	\N	90035	90035	90015
20278	29017	55	applied	\N	\N	\N	\N	91108	91108	89728
20278	29018	56	applied	\N	\N	\N	\N	91109	91109	89730
20278	29163	57	applied	\N	\N	\N	\N	90128	90128	90129
20248	29396	1	applied	\N	\N	\N	\N	90879	90879	90880
20248	29397	2	applied	\N	\N	\N	\N	90881	90881	90882
20248	29398	3	applied	\N	\N	\N	\N	90883	90883	90884
20248	29399	4	applied	\N	\N	\N	\N	90885	90885	90886
20248	29400	5	applied	\N	\N	\N	\N	90887	90887	90888
20248	29401	6	applied	\N	\N	\N	\N	90889	90889	90890
20248	29402	7	applied	\N	\N	\N	\N	90891	90891	90892
20248	29403	9	applied	\N	\N	\N	\N	90894	90894	90895
20250	29407	0	applied	\N	\N	\N	\N	90909	90909	90910
20250	29408	1	applied	\N	\N	\N	\N	90911	90911	90912
20250	29409	2	applied	\N	\N	\N	\N	90913	90913	90914
20254	29417	0	applied	\N	\N	\N	\N	90933	90933	90934
20254	29418	1	applied	\N	\N	\N	\N	90935	90935	90936
20254	29419	2	applied	\N	\N	\N	\N	90937	90937	90938
20254	29420	3	applied	\N	\N	\N	\N	90939	90939	90940
20254	29421	4	applied	\N	\N	\N	\N	90941	90941	90942
20254	29422	5	applied	\N	\N	\N	\N	90943	90943	90944
20254	29423	6	applied	\N	\N	\N	\N	90945	90945	90946
20254	29424	7	applied	\N	\N	\N	\N	90947	90947	90948
20254	29425	8	applied	\N	\N	\N	\N	90949	90949	90950
20254	29426	9	applied	\N	\N	\N	\N	90951	90951	90952
20254	29427	10	applied	\N	\N	\N	\N	90953	90953	90954
20254	29428	11	applied	\N	\N	\N	\N	90955	90955	90956
20254	29429	12	applied	\N	\N	\N	\N	90957	90957	90958
20259	29440	0	applied	\N	\N	\N	\N	90988	90988	90989
20259	29441	1	applied	\N	\N	\N	\N	90990	90990	90991
20259	29442	2	applied	\N	\N	\N	\N	90992	90992	90993
20262	29443	0	applied	\N	\N	\N	\N	90996	90996	90997
20262	29446	1	applied	\N	\N	\N	\N	91004	91004	91005
20262	29444	2	applied	\N	\N	\N	\N	90998	90998	91006
20262	29445	3	applied	\N	\N	\N	\N	91000	91000	91007
20266	29453	0	applied	\N	\N	\N	\N	91027	91027	91028
20266	29454	1	applied	\N	\N	\N	\N	91029	91029	91030
20266	29455	2	applied	\N	\N	\N	\N	91031	91031	91032
20268	29456	0	applied	\N	\N	\N	\N	91035	91035	91036
20268	29457	1	applied	\N	\N	\N	\N	91037	91037	91038
20268	29458	2	applied	\N	\N	\N	\N	91039	91039	91040
20271	29459	0	applied	\N	\N	\N	\N	91045	91045	91046
20271	29461	1	applied	\N	\N	\N	\N	91049	91049	91057
20271	29463	2	applied	\N	\N	\N	\N	91053	91053	91058
20273	29464	0	applied	\N	\N	\N	\N	91062	91062	91063
20273	29465	1	applied	\N	\N	\N	\N	91064	91064	91065
20273	29466	2	applied	\N	\N	\N	\N	91066	91066	91067
20273	29467	3	applied	\N	\N	\N	\N	91068	91068	91069
20273	29468	4	applied	\N	\N	\N	\N	91070	91070	91071
20273	29469	5	applied	\N	\N	\N	\N	91072	91072	91073
20273	29470	6	applied	\N	\N	\N	\N	91074	91074	91075
20276	29478	0	applied	\N	\N	\N	\N	91094	91094	91095
20276	29479	1	applied	\N	\N	\N	\N	91096	91096	91097
20276	29480	2	applied	\N	\N	\N	\N	91098	91098	91099
20276	29481	3	applied	\N	\N	\N	\N	91100	91100	91101
20276	29482	4	applied	\N	\N	\N	\N	91102	91102	91103
20276	29483	5	applied	\N	\N	\N	\N	91104	91104	91105
20281	29487	0	applied	\N	\N	\N	\N	91126	91126	91131
20282	29484	0	applied	\N	\N	\N	\N	91120	91120	91121
20282	29488	1	applied	\N	\N	\N	\N	91133	91133	91134
20282	29485	2	applied	\N	\N	\N	\N	91122	91122	91135
20282	29489	3	applied	\N	\N	\N	\N	91136	91136	91137
20282	29486	4	applied	\N	\N	\N	\N	91124	91124	91138
20282	29490	5	applied	\N	\N	\N	\N	91139	91139	91140
20285	29491	0	applied	\N	\N	\N	\N	91145	91145	91146
20285	29492	1	applied	\N	\N	\N	\N	91147	91147	91148
20285	29493	2	applied	\N	\N	\N	\N	91149	91149	91150
20285	29494	4	applied	\N	\N	\N	\N	91152	91152	91153
20285	29495	5	applied	\N	\N	\N	\N	91154	91154	91155
20285	29496	6	applied	\N	\N	\N	\N	91156	91156	91157
20287	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20287	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20287	29499	2	applied	\N	\N	\N	\N	91170	91170	91171
20287	29500	3	applied	\N	\N	\N	\N	91172	91172	91173
20287	29501	4	applied	\N	\N	\N	\N	91174	91174	91175
20296	29507	0	applied	\N	\N	\N	\N	91202	91202	91203
20296	29508	1	applied	\N	\N	\N	\N	91204	91204	91205
20296	29509	2	applied	\N	\N	\N	\N	91206	91206	91207
20296	29510	3	applied	\N	\N	\N	\N	91208	91208	91209
20296	29511	4	applied	\N	\N	\N	\N	91210	91210	91211
20296	29512	5	applied	\N	\N	\N	\N	91212	91212	91213
20296	29513	6	applied	\N	\N	\N	\N	91214	91214	91215
20296	29514	7	applied	\N	\N	\N	\N	91216	91216	91217
20296	29515	8	applied	\N	\N	\N	\N	91218	91218	91219
20302	29536	0	applied	\N	\N	\N	\N	91270	91270	91271
20302	29537	1	applied	\N	\N	\N	\N	91272	91272	91273
20302	29538	2	applied	\N	\N	\N	\N	91274	91274	91275
20304	29539	0	applied	\N	\N	\N	\N	91278	91278	91279
20304	29540	1	applied	\N	\N	\N	\N	91280	91280	91281
20304	29541	2	applied	\N	\N	\N	\N	91282	91282	91283
20304	29542	3	applied	\N	\N	\N	\N	91284	91284	91285
20307	29553	0	applied	\N	\N	\N	\N	91310	91310	91311
20307	29554	1	applied	\N	\N	\N	\N	91312	91312	91313
20307	29555	2	applied	\N	\N	\N	\N	91314	91314	91315
20310	29559	0	applied	\N	\N	\N	\N	91326	91326	91327
20310	29560	1	applied	\N	\N	\N	\N	91328	91328	91329
20310	29561	2	applied	\N	\N	\N	\N	91330	91330	91331
20310	29562	3	applied	\N	\N	\N	\N	91332	91332	91333
20310	29563	4	applied	\N	\N	\N	\N	91334	91334	91335
20310	29564	5	applied	\N	\N	\N	\N	91336	91336	91337
20310	29565	6	applied	\N	\N	\N	\N	91338	91338	91339
20313	29566	0	applied	\N	\N	\N	\N	91342	91342	91343
20313	29568	1	applied	\N	\N	\N	\N	91346	91346	91350
20323	29600	0	applied	\N	\N	\N	\N	91438	91438	91439
20323	29601	1	applied	\N	\N	\N	\N	91440	91440	91441
20323	29602	2	applied	\N	\N	\N	\N	91442	91442	91443
20323	29603	3	applied	\N	\N	\N	\N	91444	91444	91445
20327	29604	0	applied	\N	\N	\N	\N	91454	91454	91455
20327	29605	1	applied	\N	\N	\N	\N	91456	91456	91457
20327	29606	2	applied	\N	\N	\N	\N	91458	91458	91459
20327	29607	3	applied	\N	\N	\N	\N	91460	91460	91461
20327	29608	4	applied	\N	\N	\N	\N	91462	91462	91463
20329	29360	0	applied	\N	\N	\N	\N	90796	90796	90797
20329	29344	1	applied	\N	\N	\N	\N	90734	90734	90735
20329	29345	2	applied	\N	\N	\N	\N	90736	90736	90737
20329	29346	3	applied	\N	\N	\N	\N	90738	90738	90739
20329	29336	4	applied	\N	\N	\N	\N	90714	90714	90715
20329	29353	5	applied	\N	\N	\N	\N	90758	90758	90759
20329	29340	6	applied	\N	\N	\N	\N	90724	90724	90725
20329	29343	7	applied	\N	\N	\N	\N	90732	90732	90733
20329	29365	8	applied	\N	\N	\N	\N	90811	90811	90812
20329	29366	9	applied	\N	\N	\N	\N	90813	90813	90814
20329	29367	10	applied	\N	\N	\N	\N	90815	90815	90816
20329	29349	11	applied	\N	\N	\N	\N	90745	90745	90746
20252	29412	2	applied	\N	\N	\N	\N	90919	90919	90920
20252	29413	3	applied	\N	\N	\N	\N	90921	90921	90922
20252	29414	4	applied	\N	\N	\N	\N	90923	90923	90924
20252	29415	5	applied	\N	\N	\N	\N	90925	90925	90926
20252	29416	6	applied	\N	\N	\N	\N	90927	90927	90928
20260	29443	0	applied	\N	\N	\N	\N	90996	90996	90997
20260	29444	1	applied	\N	\N	\N	\N	90998	90998	90999
20260	29445	2	applied	\N	\N	\N	\N	91000	91000	91001
20265	29447	0	applied	\N	\N	\N	\N	91012	91012	91013
20265	29448	1	applied	\N	\N	\N	\N	91014	91014	91015
20265	29446	2	applied	\N	\N	\N	\N	91004	91004	91007
20265	29449	3	applied	\N	\N	\N	\N	91016	91016	91017
20265	29450	4	applied	\N	\N	\N	\N	91018	91018	91019
20265	29451	5	applied	\N	\N	\N	\N	91020	91020	91021
20265	29452	6	applied	\N	\N	\N	\N	91022	91022	91023
20279	29484	0	applied	\N	\N	\N	\N	91120	91120	91121
20279	29485	1	applied	\N	\N	\N	\N	91122	91122	91123
20279	29486	2	applied	\N	\N	\N	\N	91124	91124	91125
20279	29487	3	applied	\N	\N	\N	\N	91126	91126	91127
20289	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20289	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20289	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20289	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20289	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20289	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20289	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20292	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20292	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20292	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20292	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20292	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20292	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20292	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20295	29504	0	applied	\N	\N	\N	\N	91192	91192	91193
20295	29505	1	applied	\N	\N	\N	\N	91194	91194	91195
20295	29506	2	applied	\N	\N	\N	\N	91196	91196	91197
20298	29523	0	applied	\N	\N	\N	\N	91237	91237	91238
20298	29524	1	applied	\N	\N	\N	\N	91239	91239	91240
20298	29525	2	applied	\N	\N	\N	\N	91241	91241	91242
20306	29546	0	applied	\N	\N	\N	\N	91296	91296	91297
20306	29547	1	applied	\N	\N	\N	\N	91298	91298	91299
20306	29548	2	applied	\N	\N	\N	\N	91300	91300	91301
20306	29549	3	applied	\N	\N	\N	\N	91302	91302	91303
20306	29550	4	applied	\N	\N	\N	\N	91304	91304	91305
20306	29551	5	applied	\N	\N	\N	\N	91306	91306	91307
20306	29552	6	applied	\N	\N	\N	\N	91308	91308	91309
20311	29566	0	applied	\N	\N	\N	\N	91342	91342	91343
20311	29567	1	applied	\N	\N	\N	\N	91344	91344	91345
20311	29568	2	applied	\N	\N	\N	\N	91346	91346	91347
20316	29573	0	applied	\N	\N	\N	\N	91363	91363	91364
20316	29574	1	applied	\N	\N	\N	\N	91365	91365	91366
20321	29594	0	applied	\N	\N	\N	\N	91424	91424	91425
20321	29595	1	applied	\N	\N	\N	\N	91426	91426	91427
20321	29596	2	applied	\N	\N	\N	\N	91428	91428	91429
20321	29597	3	applied	\N	\N	\N	\N	91430	91430	91431
20321	29598	4	applied	\N	\N	\N	\N	91432	91432	91433
20321	29599	5	applied	\N	\N	\N	\N	91434	91434	91435
20325	29600	0	applied	\N	\N	\N	\N	91438	91438	91439
20325	29601	1	applied	\N	\N	\N	\N	91440	91440	91441
20325	29602	2	applied	\N	\N	\N	\N	91442	91442	91443
20325	29603	3	applied	\N	\N	\N	\N	91444	91444	91445
20330	29609	0	applied	\N	\N	\N	\N	91489	91489	91490
20330	29610	1	applied	\N	\N	\N	\N	91491	91491	91492
20330	29611	2	applied	\N	\N	\N	\N	91493	91493	91494
20330	29612	3	applied	\N	\N	\N	\N	91495	91495	91496
20336	29626	0	applied	\N	\N	\N	\N	91530	91530	91531
20336	29627	1	applied	\N	\N	\N	\N	91532	91532	91533
20336	29628	2	applied	\N	\N	\N	\N	91534	91534	91535
20336	29629	3	applied	\N	\N	\N	\N	91536	91536	91537
20336	29630	4	applied	\N	\N	\N	\N	91538	91538	91539
20336	29631	5	applied	\N	\N	\N	\N	91540	91540	91541
20338	29636	0	applied	\N	\N	\N	\N	91554	91554	91555
20338	29637	1	applied	\N	\N	\N	\N	91556	91556	91557
20338	29638	2	applied	\N	\N	\N	\N	91558	91558	91559
20338	29639	3	applied	\N	\N	\N	\N	91560	91560	91561
20338	29640	4	applied	\N	\N	\N	\N	91562	91562	91563
20338	29641	5	applied	\N	\N	\N	\N	91564	91564	91565
20341	29604	0	applied	\N	\N	\N	\N	91454	91454	91455
20341	29605	1	applied	\N	\N	\N	\N	91456	91456	91457
20341	29609	2	applied	\N	\N	\N	\N	91489	91489	91490
20341	29613	3	applied	\N	\N	\N	\N	91501	91501	91502
20341	29616	4	applied	\N	\N	\N	\N	91509	91509	91510
20341	29619	5	applied	\N	\N	\N	\N	91515	91515	91516
20341	29620	6	applied	\N	\N	\N	\N	91517	91517	91518
20341	29626	7	applied	\N	\N	\N	\N	91530	91530	91531
20341	29627	8	applied	\N	\N	\N	\N	91532	91532	91533
20341	29632	9	applied	\N	\N	\N	\N	91544	91544	91545
20341	29636	10	applied	\N	\N	\N	\N	91554	91554	91555
20341	29606	11	applied	\N	\N	\N	\N	91458	91458	91459
20341	29607	12	applied	\N	\N	\N	\N	91460	91460	91461
20341	29608	13	applied	\N	\N	\N	\N	91462	91462	91463
20341	29610	14	applied	\N	\N	\N	\N	91491	91491	91492
20341	29614	15	applied	\N	\N	\N	\N	91503	91503	91570
20341	29618	16	applied	\N	\N	\N	\N	91513	91513	91496
20341	29622	17	applied	\N	\N	\N	\N	91521	91521	91504
20341	29623	18	applied	\N	\N	\N	\N	91523	91523	91571
20341	29628	19	applied	\N	\N	\N	\N	91534	91534	91572
20341	29630	20	applied	\N	\N	\N	\N	91538	91538	91512
20341	29633	21	applied	\N	\N	\N	\N	91546	91546	91514
20341	29638	22	applied	\N	\N	\N	\N	91558	91558	91573
20341	29611	23	applied	\N	\N	\N	\N	91493	91493	91524
20341	29612	24	applied	\N	\N	\N	\N	91495	91495	91574
20341	29621	25	applied	\N	\N	\N	\N	91519	91519	91575
20341	29635	26	applied	\N	\N	\N	\N	91550	91550	91526
20341	29639	27	applied	\N	\N	\N	\N	91560	91560	91561
20341	29640	28	applied	\N	\N	\N	\N	91562	91562	91563
20341	29641	29	applied	\N	\N	\N	\N	91564	91564	91565
20341	29615	30	applied	\N	\N	\N	\N	91505	91505	91528
20341	29617	31	applied	\N	\N	\N	\N	91511	91511	91576
20341	29624	32	applied	\N	\N	\N	\N	91525	91525	91577
20341	29625	33	applied	\N	\N	\N	\N	91527	91527	91578
20341	29629	34	applied	\N	\N	\N	\N	91536	91536	91547
20341	29631	35	applied	\N	\N	\N	\N	91540	91540	91549
20341	29634	36	applied	\N	\N	\N	\N	91548	91548	91579
20341	29637	37	applied	\N	\N	\N	\N	91556	91556	91559
20343	29642	0	applied	\N	\N	\N	\N	91582	91582	91583
20343	29643	1	applied	\N	\N	\N	\N	91584	91584	91585
20343	29644	2	applied	\N	\N	\N	\N	91586	91586	91587
20343	29645	3	applied	\N	\N	\N	\N	91588	91588	91589
20343	29646	4	applied	\N	\N	\N	\N	91590	91590	91591
20278	28328	58	applied	\N	\N	\N	\N	87859	87859	87860
20278	28329	59	applied	\N	\N	\N	\N	87861	87861	87862
20278	29353	60	applied	\N	\N	\N	\N	90758	90758	90759
20278	28031	61	applied	\N	\N	\N	\N	87061	87061	87062
20278	29269	62	applied	\N	\N	\N	\N	91110	91110	90497
20278	29270	63	applied	\N	\N	\N	\N	91111	91111	90499
20278	29275	64	applied	\N	\N	\N	\N	91112	91112	90515
20278	29278	65	applied	\N	\N	\N	\N	91113	91113	90524
20278	28984	66	applied	\N	\N	\N	\N	89644	89644	89645
20278	28985	67	applied	\N	\N	\N	\N	89646	89646	89647
20278	28889	68	applied	\N	\N	\N	\N	89419	89419	89420
20278	28890	69	applied	\N	\N	\N	\N	89421	89421	89422
20278	28891	70	applied	\N	\N	\N	\N	89423	89423	89424
20278	28892	71	applied	\N	\N	\N	\N	89425	89425	89426
20278	28893	72	applied	\N	\N	\N	\N	89427	89427	89428
20278	28906	74	applied	\N	\N	\N	\N	32796	32796	89455
20278	28330	75	applied	\N	\N	\N	\N	87863	87863	87864
20278	28591	76	applied	\N	\N	\N	\N	90380	90380	88673
20278	28545	77	applied	\N	\N	1000000000	\N	90281	90281	88507
20278	28558	78	applied	\N	\N	\N	\N	90381	90381	88627
20278	29360	79	applied	\N	\N	\N	\N	91115	91115	90797
20278	28944	80	applied	\N	\N	\N	\N	90282	90282	89547
20278	28945	81	applied	\N	\N	\N	\N	90283	90283	89549
20278	28946	82	applied	\N	\N	\N	\N	90284	90284	89551
20278	28953	83	applied	\N	\N	\N	\N	90285	90285	89569
20278	29117	84	applied	\N	\N	\N	\N	90036	90036	90017
20278	29118	85	applied	\N	\N	\N	\N	90037	90037	90019
20278	28834	86	applied	\N	\N	\N	\N	90038	90038	90038
20278	28793	87	applied	\N	\N	\N	\N	89203	89203	89204
20278	29170	88	applied	\N	\N	\N	\N	90145	90145	90146
20278	29178	89	applied	\N	\N	\N	\N	90164	90164	90165
20278	29190	90	applied	\N	\N	\N	\N	90192	90192	90193
20278	28802	91	applied	\N	\N	\N	\N	89225	89225	89226
20278	28807	92	applied	\N	\N	\N	\N	89239	89239	89304
20278	28808	93	applied	\N	\N	\N	\N	89241	89241	89242
20278	28809	94	applied	\N	\N	\N	\N	89243	89243	89244
20278	28824	95	applied	\N	\N	1000000000	\N	89282	89282	90039
20278	28795	96	applied	\N	\N	\N	\N	89209	89209	89210
20278	28800	97	applied	\N	\N	\N	\N	89221	89221	89222
20278	28447	98	applied	\N	\N	\N	\N	88236	88236	88237
20278	28448	99	applied	\N	\N	\N	\N	88238	88238	88239
20278	28389	100	applied	\N	\N	\N	\N	88023	88023	88024
20278	28390	101	applied	\N	\N	\N	\N	88025	88025	88026
20278	28393	102	applied	\N	\N	\N	\N	88032	88032	88033
20278	29365	103	applied	\N	\N	\N	\N	91116	91116	90812
20278	29019	104	applied	\N	\N	\N	\N	91117	91117	89732
20278	28450	105	applied	\N	\N	\N	\N	88242	88242	88243
20278	28451	106	applied	\N	\N	\N	\N	88244	88244	88245
20278	28817	107	applied	\N	\N	\N	\N	90287	90287	89262
20278	28818	108	applied	\N	\N	\N	\N	90288	90288	89264
20278	28822	109	applied	\N	\N	\N	\N	90289	90289	89279
20278	28823	110	applied	\N	\N	\N	\N	90290	90290	89281
20278	28228	111	applied	\N	\N	\N	\N	88603	88603	90380
20278	28592	112	applied	\N	\N	\N	\N	90382	90382	88675
20278	28596	113	applied	\N	\N	\N	\N	90383	90383	88686
20278	28992	114	applied	\N	\N	\N	\N	89666	89666	89667
20278	28826	115	applied	\N	\N	\N	\N	90291	90291	89287
20278	28827	116	applied	\N	\N	\N	\N	90292	90292	89289
20278	28828	117	applied	\N	\N	\N	\N	90384	90384	89291
20278	28829	118	applied	\N	\N	\N	\N	90385	90385	89293
20278	28830	119	applied	\N	\N	\N	\N	90386	90386	89295
20278	28831	120	applied	\N	\N	\N	\N	90387	90387	89297
20278	28837	121	applied	\N	\N	\N	\N	90388	90388	89310
20278	28838	122	applied	\N	\N	\N	\N	90389	90389	89312
20278	28839	123	applied	\N	\N	\N	\N	90390	90390	89314
20278	28840	124	applied	\N	\N	\N	\N	90391	90391	89316
20278	28841	125	applied	\N	\N	\N	\N	90392	90392	89318
20283	29484	0	applied	\N	\N	\N	\N	91120	91120	91121
20283	29488	1	applied	\N	\N	\N	\N	91133	91133	91134
20283	29485	2	applied	\N	\N	\N	\N	91122	91122	91135
20283	29489	3	applied	\N	\N	\N	\N	91136	91136	91137
20283	29486	4	applied	\N	\N	\N	\N	91124	91124	91138
20283	29490	5	applied	\N	\N	\N	\N	91139	91139	91140
20286	29491	0	applied	\N	\N	\N	\N	91145	91145	91146
20286	29492	1	applied	\N	\N	\N	\N	91147	91147	91148
20286	29493	2	applied	\N	\N	\N	\N	91149	91149	91150
20286	29494	4	applied	\N	\N	\N	\N	91152	91152	91153
20286	29495	5	applied	\N	\N	\N	\N	91154	91154	91155
20286	29496	6	applied	\N	\N	\N	\N	91156	91156	91157
20288	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20288	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20288	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20288	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20288	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20288	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20288	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20291	29497	0	applied	\N	\N	\N	\N	91166	91166	91167
20291	29498	1	applied	\N	\N	\N	\N	91168	91168	91169
20291	29502	2	applied	\N	\N	\N	\N	91177	91177	91178
20291	29499	3	applied	\N	\N	\N	\N	91170	91170	91179
20291	29500	4	applied	\N	\N	\N	\N	91172	91172	91180
20291	29503	5	applied	\N	\N	\N	\N	91181	91181	91182
20291	29501	6	applied	\N	\N	\N	\N	91174	91174	91183
20294	29504	0	applied	\N	\N	\N	\N	91192	91192	91193
20294	29505	1	applied	\N	\N	\N	\N	91194	91194	91195
20294	29506	2	applied	\N	\N	\N	\N	91196	91196	91197
20297	29516	0	applied	\N	\N	\N	\N	91221	91221	91222
20297	29517	1	applied	\N	\N	\N	\N	91223	91223	91224
20297	29518	2	applied	\N	\N	\N	\N	91225	91225	91226
20297	29519	3	applied	\N	\N	\N	\N	91227	91227	91228
20297	29520	4	applied	\N	\N	\N	\N	91229	91229	91230
20297	29521	5	applied	\N	\N	\N	\N	91231	91231	91232
20297	29522	6	applied	\N	\N	\N	\N	91233	91233	91234
20300	29526	0	applied	\N	\N	\N	\N	91247	91247	91248
20300	29527	1	applied	\N	\N	\N	\N	91249	91249	91250
20300	29528	2	applied	\N	\N	\N	\N	91251	91251	91252
20300	29529	3	applied	\N	\N	\N	\N	91253	91253	91254
20300	29530	4	applied	\N	\N	\N	\N	91255	91255	91256
20300	29531	5	applied	\N	\N	\N	\N	91257	91257	91258
20300	29532	6	applied	\N	\N	\N	\N	91259	91259	91260
20303	29536	0	applied	\N	\N	\N	\N	91270	91270	91271
20303	29537	1	applied	\N	\N	\N	\N	91272	91272	91273
20303	29538	2	applied	\N	\N	\N	\N	91274	91274	91275
20305	29543	0	applied	\N	\N	\N	\N	91288	91288	91289
20305	29544	1	applied	\N	\N	\N	\N	91290	91290	91291
20305	29545	2	applied	\N	\N	\N	\N	91292	91292	91293
20308	29553	0	applied	\N	\N	\N	\N	91310	91310	91311
20308	29554	1	applied	\N	\N	\N	\N	91312	91312	91313
20308	29555	2	applied	\N	\N	\N	\N	91314	91314	91315
20315	29572	0	applied	\N	\N	\N	\N	91361	91361	91362
20315	29573	1	applied	\N	\N	\N	\N	91363	91363	91364
20315	29574	2	applied	\N	\N	\N	\N	91365	91365	91366
20315	29575	3	applied	\N	\N	\N	\N	91367	91367	91368
20318	29572	0	applied	\N	\N	\N	\N	91361	91361	91362
20318	29576	1	applied	\N	\N	\N	\N	91374	91374	91375
20318	29577	2	applied	\N	\N	\N	\N	91376	91376	91377
20318	29578	3	applied	\N	\N	\N	\N	91378	91378	91379
20318	29579	4	applied	\N	\N	\N	\N	91380	91380	91381
20318	29580	5	applied	\N	\N	\N	\N	91382	91382	91383
20318	29581	6	applied	\N	\N	\N	\N	91384	91384	91385
20318	29582	7	applied	\N	\N	\N	\N	91386	91386	91387
20320	29586	0	applied	\N	\N	\N	\N	91402	91402	91403
20320	29587	2	applied	\N	\N	\N	\N	91405	91405	91406
20320	29588	3	applied	\N	\N	\N	\N	91407	91407	91408
20320	29575	4	applied	\N	\N	\N	\N	91367	91367	91397
20320	29583	5	applied	\N	\N	\N	\N	91390	91390	91409
20320	29584	6	applied	\N	\N	\N	\N	91391	91391	91410
20320	29585	7	applied	\N	\N	\N	\N	91393	91393	91411
20320	29589	8	applied	\N	\N	\N	\N	91412	91412	91413
20320	29590	9	applied	\N	\N	\N	\N	91414	91414	91415
20320	29591	10	applied	\N	\N	\N	\N	91416	91416	91417
20320	29592	11	applied	\N	\N	\N	\N	91418	91418	91419
20320	29593	12	applied	\N	\N	\N	\N	91420	91420	91421
20324	29600	0	applied	\N	\N	\N	\N	91438	91438	91439
20324	29601	1	applied	\N	\N	\N	\N	91440	91440	91441
20324	29602	2	applied	\N	\N	\N	\N	91442	91442	91443
20324	29603	3	applied	\N	\N	\N	\N	91444	91444	91445
20328	29604	0	applied	\N	\N	\N	\N	91454	91454	91455
20328	29605	1	applied	\N	\N	\N	\N	91456	91456	91457
20328	29606	2	applied	\N	\N	\N	\N	91458	91458	91459
20328	29607	3	applied	\N	\N	\N	\N	91460	91460	91461
20328	29608	4	applied	\N	\N	\N	\N	91462	91462	91463
20332	29613	0	applied	\N	\N	\N	\N	91501	91501	91502
20332	29614	1	applied	\N	\N	\N	\N	91503	91503	91504
20332	29615	2	applied	\N	\N	\N	\N	91505	91505	91506
20335	29626	0	applied	\N	\N	\N	\N	91530	91530	91531
20335	29627	1	applied	\N	\N	\N	\N	91532	91532	91533
20335	29628	2	applied	\N	\N	\N	\N	91534	91534	91535
20335	29629	3	applied	\N	\N	\N	\N	91536	91536	91537
20335	29630	4	applied	\N	\N	\N	\N	91538	91538	91539
20335	29631	5	applied	\N	\N	\N	\N	91540	91540	91541
20342	29642	0	applied	\N	\N	\N	\N	91582	91582	91583
20342	29643	1	applied	\N	\N	\N	\N	91584	91584	91585
20342	29644	2	applied	\N	\N	\N	\N	91586	91586	91587
20342	29645	3	applied	\N	\N	\N	\N	91588	91588	91589
20342	29646	4	applied	\N	\N	\N	\N	91590	91590	91591
20345	29653	0	applied	\N	\N	\N	\N	91609	91609	91610
20345	29654	1	applied	\N	\N	\N	\N	91611	91611	91612
20345	29655	2	applied	\N	\N	\N	\N	91613	91613	91614
20348	29665	0	applied	\N	\N	\N	\N	91638	91638	91639
20348	29666	1	applied	\N	\N	\N	\N	91640	91640	91641
20348	29667	2	applied	\N	\N	\N	\N	91642	91642	91643
20351	29668	0	applied	\N	\N	\N	\N	91646	91646	91647
20351	29669	1	applied	\N	\N	\N	\N	91648	91648	91649
20351	29670	2	applied	\N	\N	\N	\N	91650	91650	91651
20357	29676	0	applied	\N	\N	\N	\N	91680	91680	91681
20357	29677	1	applied	\N	\N	\N	\N	91682	91682	91683
20357	29678	2	applied	\N	\N	\N	\N	91684	91684	91685
20362	29692	0	applied	\N	\N	\N	\N	91739	91739	91740
20362	29693	1	applied	\N	\N	\N	\N	91741	91741	91742
20362	29694	2	applied	\N	\N	\N	\N	91743	91743	91744
20362	29695	3	applied	\N	\N	\N	\N	91745	91745	91746
20362	29696	4	applied	\N	\N	\N	\N	91747	91747	91748
20362	29697	5	applied	\N	\N	\N	\N	91749	91749	91750
20367	29704	0	applied	\N	\N	\N	\N	206	206	91770
20367	29705	1	applied	\N	\N	\N	\N	91771	91771	91772
20367	29706	2	applied	\N	\N	\N	\N	91773	91773	91774
20370	29713	0	applied	\N	\N	\N	\N	91789	91789	91790
20370	29714	1	applied	\N	\N	\N	\N	91791	91791	91792
20370	29729	2	applied	\N	\N	\N	\N	91822	91822	91823
20370	29715	3	applied	\N	\N	\N	\N	91793	91793	91794
20370	29716	4	applied	\N	\N	\N	\N	91795	91795	91796
20370	29717	5	applied	\N	\N	\N	\N	91797	91797	91798
20370	29718	6	applied	\N	\N	\N	\N	91799	91799	91800
20370	29719	7	applied	\N	\N	\N	\N	91801	91801	91802
20370	29720	8	applied	\N	\N	\N	\N	91803	91803	91804
20370	29721	9	applied	\N	\N	\N	\N	91805	91805	91806
20370	29722	10	applied	\N	\N	\N	\N	91807	91807	91808
20370	29723	11	applied	\N	\N	\N	\N	91809	91809	91810
20370	29724	12	applied	\N	\N	\N	\N	91811	91811	91812
20370	29725	13	applied	\N	\N	\N	\N	91813	91813	91814
20370	29726	14	applied	\N	\N	\N	\N	91815	91815	91816
20370	29727	15	applied	\N	\N	\N	\N	91817	91817	91818
20370	29728	16	applied	\N	\N	\N	\N	91819	91819	91820
20372	29730	0	applied	\N	\N	\N	\N	91828	91828	91829
20372	29731	1	applied	\N	\N	\N	\N	91830	91830	206
20372	29732	2	applied	\N	\N	\N	\N	91831	91831	91832
20372	29733	3	applied	\N	\N	\N	\N	91833	91833	91834
20375	29737	0	applied	\N	\N	\N	\N	91844	91844	91845
20375	29738	1	applied	\N	\N	\N	\N	91846	91846	91847
20375	29739	2	applied	\N	\N	\N	\N	91848	91848	91849
20377	29737	0	applied	\N	\N	\N	\N	91844	91844	91845
20377	29738	1	applied	\N	\N	\N	\N	91846	91846	91847
20377	29739	2	applied	\N	\N	\N	\N	91848	91848	91849
20379	29740	0	applied	\N	\N	\N	\N	91854	91854	91855
20379	29741	1	applied	\N	\N	\N	\N	91856	91856	91857
20379	29743	2	applied	\N	\N	\N	\N	91880	91880	91893
20379	29742	3	applied	\N	\N	\N	\N	91870	91870	91881
20379	29744	4	applied	\N	\N	\N	\N	91882	91882	91883
20379	29745	5	applied	\N	\N	\N	\N	91889	91889	91890
20382	29749	0	applied	\N	\N	\N	\N	91902	91902	91903
20382	29750	1	applied	\N	\N	\N	\N	91904	91904	91905
20382	29751	2	applied	\N	\N	\N	\N	91906	91906	91907
20384	29754	0	applied	\N	\N	\N	\N	91915	91915	91916
20384	29755	1	applied	\N	\N	\N	\N	91917	91917	91918
20384	29756	2	applied	\N	\N	\N	\N	91919	91919	91920
20386	29758	0	applied	\N	\N	\N	\N	91931	91931	91932
20386	29759	1	applied	\N	\N	\N	\N	91933	91933	91934
20386	29760	2	applied	\N	\N	\N	\N	91935	91935	91936
20389	29761	0	applied	\N	\N	\N	\N	91941	91941	91942
20389	29762	1	applied	\N	\N	\N	\N	91943	91943	91944
20389	29763	2	applied	\N	\N	\N	\N	91945	91945	91946
20389	29764	3	applied	\N	\N	\N	\N	91947	91947	91948
20389	29765	4	applied	\N	\N	\N	\N	91949	91949	91950
20389	29766	5	applied	\N	\N	\N	\N	91951	91951	91952
20389	29767	6	applied	\N	\N	\N	\N	91953	91953	91954
20389	29768	7	applied	\N	\N	\N	\N	91955	91955	91956
20389	29769	8	applied	\N	\N	\N	\N	91957	91957	91958
20395	29782	0	applied	\N	\N	\N	\N	91990	91990	91991
20319	29584	6	applied	\N	\N	\N	\N	91391	91391	91392
20319	29585	7	applied	\N	\N	\N	\N	91393	91393	91394
20319	29579	8	applied	\N	\N	\N	\N	91380	91380	91395
20319	29580	9	applied	\N	\N	\N	\N	91382	91382	91396
20319	29581	10	applied	\N	\N	\N	\N	91384	91384	91397
20319	29582	12	applied	\N	\N	\N	\N	91386	91386	91399
20322	29600	0	applied	\N	\N	\N	\N	91438	91438	91439
20322	29601	1	applied	\N	\N	\N	\N	91440	91440	91441
20322	29602	2	applied	\N	\N	\N	\N	91442	91442	91443
20322	29603	3	applied	\N	\N	\N	\N	91444	91444	91445
20326	29600	0	applied	\N	\N	\N	\N	91438	91438	91439
20326	29601	1	applied	\N	\N	\N	\N	91440	91440	91441
20326	29602	2	applied	\N	\N	\N	\N	91442	91442	91443
20326	29603	3	applied	\N	\N	\N	\N	91444	91444	91445
20333	29616	0	applied	\N	\N	\N	\N	91509	91509	91510
20333	29617	1	applied	\N	\N	\N	\N	91511	91511	91512
20333	29618	2	applied	\N	\N	\N	\N	91513	91513	91514
20339	29636	0	applied	\N	\N	\N	\N	91554	91554	91555
20339	29637	1	applied	\N	\N	\N	\N	91556	91556	91557
20339	29638	2	applied	\N	\N	\N	\N	91558	91558	91559
20339	29639	3	applied	\N	\N	\N	\N	91560	91560	91561
20339	29640	4	applied	\N	\N	\N	\N	91562	91562	91563
20339	29641	5	applied	\N	\N	\N	\N	91564	91564	91565
20349	29668	0	applied	\N	\N	\N	\N	91646	91646	91647
20349	29669	1	applied	\N	\N	\N	\N	91648	91648	91649
20349	29670	2	applied	\N	\N	\N	\N	91650	91650	91651
20352	29668	0	applied	\N	\N	\N	\N	91646	91646	91647
20352	29669	1	applied	\N	\N	\N	\N	91648	91648	91649
20352	29670	2	applied	\N	\N	\N	\N	91650	91650	91651
20356	29673	0	applied	\N	\N	\N	\N	91666	91666	91667
20356	29674	2	applied	\N	\N	\N	\N	91669	91669	91670
20356	29675	3	applied	\N	\N	\N	\N	91671	91671	91672
20361	29688	0	applied	\N	\N	\N	\N	91729	91729	91730
20361	29689	1	applied	\N	\N	\N	\N	91731	91731	91732
20361	29690	2	applied	\N	\N	\N	\N	91733	91733	91734
20361	29691	3	applied	\N	\N	\N	\N	91735	91735	91736
20366	29701	0	applied	\N	\N	\N	\N	91760	91760	91761
20366	29702	1	applied	\N	\N	\N	\N	91762	91762	91763
20366	29703	2	applied	\N	\N	\N	\N	91764	91764	91765
20373	29734	0	applied	\N	\N	\N	\N	91836	91836	91837
20373	29735	1	applied	\N	\N	\N	\N	91838	91838	91839
20373	29736	2	applied	\N	\N	\N	\N	91840	91840	91841
20378	29688	0	applied	\N	\N	\N	\N	91729	91729	91730
20378	29731	1	applied	\N	\N	\N	\N	91853	91853	91325
20378	29692	2	applied	\N	\N	\N	\N	91739	91739	91740
20378	29698	3	applied	\N	\N	\N	\N	91754	91754	91755
20378	29701	4	applied	\N	\N	\N	\N	91760	91760	91761
20378	29705	5	applied	\N	\N	\N	\N	91771	91771	91772
20378	29707	6	applied	\N	\N	\N	\N	91777	91777	91778
20378	29708	7	applied	\N	\N	\N	\N	91779	91779	91780
20378	29713	8	applied	\N	\N	\N	\N	91789	91789	91790
20378	29730	9	applied	\N	\N	\N	\N	91828	91828	91829
20378	29734	10	applied	\N	\N	\N	\N	91836	91836	91837
20378	29737	11	applied	\N	\N	\N	\N	91844	91844	91845
20378	29740	12	applied	\N	\N	\N	\N	91854	91854	91855
20378	29741	13	applied	\N	\N	\N	\N	91856	91856	91857
20378	29689	14	applied	\N	\N	\N	\N	91731	91731	91732
20378	29693	15	applied	\N	\N	\N	\N	91741	91741	91742
20378	29694	16	applied	\N	\N	\N	\N	91743	91743	91744
20378	29695	17	applied	\N	\N	\N	\N	91745	91745	91746
20378	29704	18	applied	\N	\N	\N	\N	206	206	91830
20378	29715	19	applied	\N	\N	\N	\N	91858	91858	91794
20378	29690	20	applied	\N	\N	\N	\N	91733	91733	91734
20378	29716	21	applied	\N	\N	\N	\N	91859	91859	91796
20378	29717	22	applied	\N	\N	\N	\N	91860	91860	91798
20378	29691	23	applied	\N	\N	\N	\N	91735	91735	91736
20378	29696	24	applied	\N	\N	\N	\N	91747	91747	91748
20378	29700	25	applied	\N	\N	\N	\N	91758	91758	91861
20378	29703	26	applied	\N	\N	\N	\N	91764	91764	91862
20378	29706	27	applied	\N	\N	\N	\N	91773	91773	91763
20378	29711	28	applied	\N	\N	\N	\N	91785	91785	91765
20378	29712	29	applied	\N	\N	\N	\N	91787	91787	91774
20378	29729	30	applied	\N	\N	\N	\N	91822	91822	91863
20378	29697	31	applied	\N	\N	\N	\N	91749	91749	91864
20378	29699	32	applied	\N	\N	\N	\N	91756	91756	91786
20378	29702	33	applied	\N	\N	\N	\N	91762	91762	91865
20378	29709	34	applied	\N	\N	\N	\N	91781	91781	91866
20378	29710	35	applied	\N	\N	\N	\N	91783	91783	91867
20378	29714	36	applied	\N	\N	\N	\N	91791	91791	91823
20378	29732	37	applied	\N	\N	\N	\N	91831	91831	91832
20378	29736	38	applied	\N	\N	\N	\N	91840	91840	91868
20378	29738	39	applied	\N	\N	\N	\N	91846	91846	91869
20378	29742	40	applied	\N	\N	\N	\N	91870	91870	91839
20378	29733	41	applied	\N	\N	\N	\N	91833	91833	91871
20378	29735	42	applied	\N	\N	\N	\N	91838	91838	91872
20378	29718	43	applied	\N	\N	\N	\N	91873	91873	91800
20378	29719	44	applied	\N	\N	\N	\N	91874	91874	91802
20378	29720	45	applied	\N	\N	\N	\N	91875	91875	91804
20378	29721	46	applied	\N	\N	\N	\N	91876	91876	91806
20378	29722	47	applied	\N	\N	\N	\N	91877	91877	91808
20378	29723	48	applied	\N	\N	\N	\N	91878	91878	91810
20378	29739	49	applied	\N	\N	\N	\N	91848	91848	91879
20378	29743	50	applied	\N	\N	\N	\N	91880	91880	91881
20378	29744	51	applied	\N	\N	\N	\N	91882	91882	91883
20378	29724	52	applied	\N	\N	\N	\N	91884	91884	91812
20378	29725	53	applied	\N	\N	\N	\N	91885	91885	91814
20378	29726	54	applied	\N	\N	\N	\N	91886	91886	91816
20378	29727	55	applied	\N	\N	\N	\N	91887	91887	91818
20378	29728	56	applied	\N	\N	\N	\N	91888	91888	91820
20378	29745	57	applied	\N	\N	\N	\N	91889	91889	91890
20380	29746	0	applied	\N	\N	\N	\N	91896	91896	91897
20380	29747	1	applied	\N	\N	\N	\N	91898	91898	91899
20380	29748	2	applied	\N	\N	\N	\N	91900	91900	91901
20385	29731	0	applied	\N	\N	\N	\N	91853	91853	88549
20385	29689	1	applied	\N	\N	\N	\N	91923	91923	91732
20385	29693	2	applied	\N	\N	\N	\N	91924	91924	91742
20385	29694	3	applied	\N	\N	\N	\N	91925	91925	91744
20385	29695	4	applied	\N	\N	\N	\N	91926	91926	91746
20385	29587	5	applied	\N	\N	\N	\N	91466	91466	91406
20385	29715	6	applied	\N	\N	\N	\N	91858	91858	91794
20385	29716	7	applied	\N	\N	\N	\N	91859	91859	91796
20385	29717	8	applied	\N	\N	\N	\N	91860	91860	91798
20385	29590	9	applied	\N	\N	\N	\N	91475	91475	91415
20385	29591	10	applied	\N	\N	\N	\N	91476	91476	91417
20385	29592	11	applied	\N	\N	\N	\N	91477	91477	91419
20385	29593	12	applied	\N	\N	\N	\N	91478	91478	91421
20385	29718	13	applied	\N	\N	\N	\N	91873	91873	91800
20385	29719	14	applied	\N	\N	\N	\N	91874	91874	91802
20385	29720	15	applied	\N	\N	\N	\N	91875	91875	91804
20385	29721	16	applied	\N	\N	\N	\N	91876	91876	91806
20329	29354	12	applied	\N	\N	\N	\N	90780	90780	90781
20329	29357	13	applied	\N	\N	\N	\N	90788	90788	90789
20329	29361	14	applied	\N	\N	\N	\N	90798	90798	90799
20329	29364	15	applied	\N	\N	\N	\N	90809	90809	90810
20329	29371	16	applied	\N	\N	\N	\N	90824	90824	90825
20329	29375	17	applied	\N	\N	\N	\N	90832	90832	90833
20329	29376	18	applied	\N	\N	\N	\N	90834	90834	90835
20329	29382	19	applied	\N	\N	\N	\N	90847	90847	90848
20329	29383	20	applied	\N	\N	\N	\N	90849	90849	90850
20329	29388	21	applied	\N	\N	\N	\N	90861	90861	90862
20329	29389	22	applied	\N	\N	\N	\N	90863	90863	90864
20329	29395	23	applied	\N	\N	\N	\N	90877	90877	90878
20329	29396	24	applied	\N	\N	\N	\N	90879	90879	90880
20329	29397	25	applied	\N	\N	\N	\N	90881	90881	90882
20329	29404	26	applied	\N	\N	\N	\N	90901	90901	90902
20329	29407	27	applied	\N	\N	\N	\N	90909	90909	90910
20329	29410	28	applied	\N	\N	\N	\N	90915	90915	90916
20329	29411	29	applied	\N	\N	\N	\N	90917	90917	90918
20329	29417	30	applied	\N	\N	\N	\N	90933	90933	90934
20329	29418	31	applied	\N	\N	\N	\N	90935	90935	90936
20329	29419	32	applied	\N	\N	\N	\N	90937	90937	90938
20329	29420	33	applied	\N	\N	\N	\N	90939	90939	90940
20329	29430	34	applied	\N	\N	\N	\N	90962	90962	90963
20329	29433	35	applied	\N	\N	\N	\N	90972	90972	90973
20329	29434	36	applied	\N	\N	\N	\N	90974	90974	90975
20329	29440	37	applied	\N	\N	\N	\N	90988	90988	90989
20329	29443	38	applied	\N	\N	\N	\N	90996	90996	90997
20329	29447	39	applied	\N	\N	\N	\N	91012	91012	91013
20329	29448	40	applied	\N	\N	\N	\N	91014	91014	91015
20329	29453	41	applied	\N	\N	\N	\N	91027	91027	91028
20329	29456	42	applied	\N	\N	\N	\N	91035	91035	91036
20329	29459	43	applied	\N	\N	\N	\N	91045	91045	91046
20329	29464	44	applied	\N	\N	\N	\N	91062	91062	91063
20329	29465	45	applied	\N	\N	\N	\N	91064	91064	91065
20329	29471	46	applied	\N	\N	\N	\N	91078	91078	91079
20329	29472	47	applied	\N	\N	\N	\N	91080	91080	91081
20329	29478	48	applied	\N	\N	\N	\N	91094	91094	91095
20329	29479	49	applied	\N	\N	\N	\N	91096	91096	91097
20329	29484	50	applied	\N	\N	\N	\N	91120	91120	91121
20329	29488	51	applied	\N	\N	\N	\N	91133	91133	91134
20329	29491	52	applied	\N	\N	\N	\N	91145	91145	91146
20329	29492	53	applied	\N	\N	\N	\N	91147	91147	91148
20329	29497	54	applied	\N	\N	\N	\N	91166	91166	91167
20329	29498	55	applied	\N	\N	\N	\N	91168	91168	91169
20329	29504	56	applied	\N	\N	\N	\N	91192	91192	91193
20329	29507	57	applied	\N	\N	\N	\N	91202	91202	91203
20329	29508	58	applied	\N	\N	\N	\N	91204	91204	91205
20329	29509	59	applied	\N	\N	\N	\N	91206	91206	91207
20329	29516	60	applied	\N	\N	\N	\N	91221	91221	91222
20329	29517	61	applied	\N	\N	\N	\N	91223	91223	91224
20329	29523	62	applied	\N	\N	\N	\N	91237	91237	91238
20329	29526	63	applied	\N	\N	\N	\N	91247	91247	91248
20329	29527	64	applied	\N	\N	\N	\N	91249	91249	91250
20329	29533	65	applied	\N	\N	\N	\N	91262	91262	91263
20329	29536	66	applied	\N	\N	\N	\N	91270	91270	91271
20329	29539	67	applied	\N	\N	\N	\N	91278	91278	91279
20329	29543	68	applied	\N	\N	\N	\N	91288	91288	91289
20329	29546	69	applied	\N	\N	\N	\N	91296	91296	91297
20329	29547	70	applied	\N	\N	\N	\N	91298	91298	91299
20329	29553	71	applied	\N	\N	\N	\N	91310	91310	91311
20329	29556	72	applied	\N	\N	\N	\N	91318	91318	91319
20329	29559	73	applied	\N	\N	\N	\N	91326	91326	91327
20329	29560	74	applied	\N	\N	\N	\N	91328	91328	91329
20329	29566	75	applied	\N	\N	\N	\N	91342	91342	91343
20329	29569	76	applied	\N	\N	\N	\N	91353	91353	91354
20329	29572	77	applied	\N	\N	\N	\N	91361	91361	91362
20329	29576	78	applied	\N	\N	\N	\N	91374	91374	91375
20329	29577	79	applied	\N	\N	\N	\N	91376	91376	91377
20329	29578	80	applied	\N	\N	\N	\N	91378	91378	91379
20329	29586	81	applied	\N	\N	\N	\N	91402	91402	91403
20329	29594	82	applied	\N	\N	\N	\N	91424	91424	91425
20329	29595	83	applied	\N	\N	\N	\N	91426	91426	91427
20329	29600	84	applied	\N	\N	\N	\N	91438	91438	91439
20329	29604	85	applied	\N	\N	\N	\N	91454	91454	91455
20329	29605	86	applied	\N	\N	\N	\N	91456	91456	91457
20329	29587	87	applied	\N	\N	\N	\N	91466	91466	91406
20329	29337	88	applied	\N	\N	\N	\N	90716	90716	90717
20329	29341	89	applied	\N	\N	\N	\N	90726	90726	90721
20329	29347	91	applied	\N	\N	\N	\N	90740	90740	90727
20329	29350	92	applied	\N	\N	\N	\N	90747	90747	90775
20329	29356	93	applied	\N	\N	\N	\N	90784	90784	91468
20329	29358	94	applied	\N	\N	\N	\N	90790	90790	90776
20329	29338	95	applied	\N	\N	\N	\N	90718	90718	90777
20329	29342	96	applied	\N	\N	\N	\N	90728	90728	90752
20329	29348	97	applied	\N	\N	\N	\N	90742	90742	90783
20329	29351	98	applied	\N	\N	\N	\N	90749	90749	91469
20329	29355	99	applied	\N	\N	\N	\N	90782	90782	91470
20329	29359	100	applied	\N	\N	\N	\N	90792	90792	90791
20329	29362	101	applied	\N	\N	\N	\N	90800	90800	90793
20329	29339	102	applied	\N	\N	\N	\N	90720	90720	91471
20329	29352	103	applied	\N	\N	\N	\N	90751	90751	90801
20329	29369	104	applied	\N	\N	\N	\N	90819	90819	91472
20329	29378	105	applied	\N	\N	\N	\N	90838	90838	91473
20329	29390	106	applied	\N	\N	\N	\N	90865	90865	90803
20329	29400	107	applied	\N	\N	\N	\N	90887	90887	91474
20329	29590	108	applied	\N	\N	\N	\N	91475	91475	91415
20329	29591	109	applied	\N	\N	\N	\N	91476	91476	91417
20329	29592	110	applied	\N	\N	\N	\N	91477	91477	91419
20329	29593	111	applied	\N	\N	\N	\N	91478	91478	91421
20329	29370	112	applied	\N	\N	\N	\N	90821	90821	90818
20329	29372	113	applied	\N	\N	\N	\N	90826	90826	91479
20329	29379	114	applied	\N	\N	\N	\N	90840	90840	91480
20329	29380	115	applied	\N	\N	\N	\N	90842	90842	91481
20329	29384	116	applied	\N	\N	\N	\N	90851	90851	90829
20329	29386	117	applied	\N	\N	\N	\N	90855	90855	91482
20329	29391	118	applied	\N	\N	\N	\N	90867	90867	90839
20329	29392	119	applied	\N	\N	\N	\N	90869	90869	90841
20329	29398	120	applied	\N	\N	\N	\N	90883	90883	90843
20329	29401	121	applied	\N	\N	\N	\N	90889	90889	91483
20329	29403	122	applied	\N	\N	\N	\N	90894	90894	91484
20329	29406	123	applied	\N	\N	\N	\N	90905	90905	91485
20329	29408	124	applied	\N	\N	\N	\N	90911	90911	90854
20329	29414	125	applied	\N	\N	\N	\N	90923	90923	90856
20331	29609	0	applied	\N	\N	\N	\N	91489	91489	91490
20331	29610	1	applied	\N	\N	\N	\N	91491	91491	91492
20331	29611	2	applied	\N	\N	\N	\N	91493	91493	91494
20331	29612	3	applied	\N	\N	\N	\N	91495	91495	91496
20334	29619	0	applied	\N	\N	\N	\N	91515	91515	91516
20334	29620	1	applied	\N	\N	\N	\N	91517	91517	91518
20334	29621	2	applied	\N	\N	\N	\N	91519	91519	91520
20334	29622	3	applied	\N	\N	\N	\N	91521	91521	91522
20334	29623	4	applied	\N	\N	\N	\N	91523	91523	91524
20334	29624	5	applied	\N	\N	\N	\N	91525	91525	91526
20334	29625	6	applied	\N	\N	\N	\N	91527	91527	91528
20337	29632	0	applied	\N	\N	\N	\N	91544	91544	91545
20337	29633	1	applied	\N	\N	\N	\N	91546	91546	91547
20337	29634	2	applied	\N	\N	\N	\N	91548	91548	91549
20337	29635	3	applied	\N	\N	\N	\N	91550	91550	91551
20340	29636	0	applied	\N	\N	\N	\N	91554	91554	91555
20340	29637	1	applied	\N	\N	\N	\N	91556	91556	91557
20340	29638	2	applied	\N	\N	\N	\N	91558	91558	91559
20340	29639	3	applied	\N	\N	\N	\N	91560	91560	91561
20340	29640	4	applied	\N	\N	\N	\N	91562	91562	91563
20340	29641	5	applied	\N	\N	\N	\N	91564	91564	91565
20344	29647	0	applied	\N	\N	\N	\N	91596	91596	91597
20344	29648	1	applied	\N	\N	\N	\N	91598	91598	91599
20344	29649	2	applied	\N	\N	\N	\N	91600	91600	91601
20344	29650	3	applied	\N	\N	\N	\N	91602	91602	91603
20344	29651	4	applied	\N	\N	\N	\N	91604	91604	91605
20344	29652	5	applied	\N	\N	\N	\N	91606	91606	91607
20347	29656	0	applied	\N	\N	\N	\N	91619	91619	91620
20347	29657	1	applied	\N	\N	\N	\N	91621	91621	91622
20347	29658	2	applied	\N	\N	\N	\N	91623	91623	91624
20347	29659	3	applied	\N	\N	\N	\N	91625	91625	91626
20347	29660	4	applied	\N	\N	\N	\N	91627	91627	91628
20347	29661	5	applied	\N	\N	\N	\N	91629	91629	91630
20347	29662	6	applied	\N	\N	\N	\N	91631	91631	91632
20347	29663	7	applied	\N	\N	\N	\N	91633	91633	91634
20347	29664	8	applied	\N	\N	\N	\N	91635	91635	91636
20350	29668	0	applied	\N	\N	\N	\N	91646	91646	91647
20350	29669	1	applied	\N	\N	\N	\N	91648	91648	91649
20350	29670	2	applied	\N	\N	\N	\N	91650	91650	91651
20353	29668	0	applied	\N	\N	\N	\N	91646	91646	91647
20353	29669	1	applied	\N	\N	\N	\N	91648	91648	91649
20353	29670	2	applied	\N	\N	\N	\N	91650	91650	91651
20354	29671	0	applied	\N	\N	\N	\N	91660	91660	91661
20354	29672	1	applied	\N	\N	\N	\N	91662	91662	91663
20359	29642	0	applied	\N	\N	\N	\N	91582	91582	91583
20359	29643	1	applied	\N	\N	\N	\N	91584	91584	91585
20359	29647	2	applied	\N	\N	\N	\N	91596	91596	91597
20359	29648	3	applied	\N	\N	\N	\N	91598	91598	91599
20359	29653	4	applied	\N	\N	\N	\N	91609	91609	91610
20359	29656	5	applied	\N	\N	\N	\N	91619	91619	91620
20359	29657	6	applied	\N	\N	\N	\N	91621	91621	91622
20359	29658	7	applied	\N	\N	\N	\N	91623	91623	91624
20359	29665	8	applied	\N	\N	\N	\N	91638	91638	91639
20359	29668	9	applied	\N	\N	\N	\N	91646	91646	91647
20359	29671	10	applied	\N	\N	\N	\N	91660	91660	91661
20359	29673	11	applied	\N	\N	\N	\N	91666	91666	91667
20359	29676	12	applied	\N	\N	\N	\N	91680	91680	91681
20359	29679	13	applied	\N	\N	\N	\N	91687	91687	91688
20359	29680	14	applied	\N	\N	\N	\N	91689	91689	91690
20359	29685	15	applied	\N	\N	\N	\N	91700	91700	91701
20359	29644	16	applied	\N	\N	\N	\N	91586	91586	91587
20359	29649	17	applied	\N	\N	\N	\N	91600	91600	91702
20359	29652	18	applied	\N	\N	\N	\N	91606	91606	91703
20359	29654	19	applied	\N	\N	\N	\N	91611	91611	91603
20359	29660	20	applied	\N	\N	\N	\N	91627	91627	91704
20359	29661	21	applied	\N	\N	\N	\N	91629	91629	91705
20359	29662	22	applied	\N	\N	\N	\N	91631	91631	91706
20359	29666	23	applied	\N	\N	\N	\N	91640	91640	91626
20359	29670	24	applied	\N	\N	\N	\N	91650	91650	91628
20359	29675	25	applied	\N	\N	\N	\N	91671	91671	91630
20359	29677	26	applied	\N	\N	\N	\N	91682	91682	91632
20359	29682	27	applied	\N	\N	\N	\N	91693	91693	91707
20359	29683	28	applied	\N	\N	\N	\N	91695	91695	91708
20359	29686	29	applied	\N	\N	\N	\N	91709	91709	91643
20359	29645	30	applied	\N	\N	\N	\N	91588	91588	91649
20359	29646	31	applied	\N	\N	\N	\N	91590	91590	91710
20359	29650	32	applied	\N	\N	\N	\N	91602	91602	91711
20359	29651	33	applied	\N	\N	\N	\N	91604	91604	91712
20359	29655	34	applied	\N	\N	\N	\N	91613	91613	91713
20359	29659	35	applied	\N	\N	\N	\N	91625	91625	91672
20359	29663	36	applied	\N	\N	\N	\N	91633	91633	91714
20359	29664	37	applied	\N	\N	\N	\N	91635	91635	91715
20359	29667	38	applied	\N	\N	\N	\N	91642	91642	91716
20359	29669	39	applied	\N	\N	\N	\N	91648	91648	91717
20359	29672	40	applied	\N	\N	\N	\N	91662	91662	91694
20359	29674	41	applied	\N	\N	\N	\N	91669	91669	91718
20359	29678	42	applied	\N	\N	\N	\N	91684	91684	91719
20359	29681	43	applied	\N	\N	\N	\N	91691	91691	91720
20359	29684	44	applied	\N	\N	\N	\N	91697	91697	91721
20359	29687	45	applied	\N	\N	\N	\N	91722	91722	91723
20364	29698	0	applied	\N	\N	\N	\N	91754	91754	91755
20364	29699	1	applied	\N	\N	\N	\N	91756	91756	91757
20364	29700	2	applied	\N	\N	\N	\N	91758	91758	91759
20369	29713	0	applied	\N	\N	\N	\N	91789	91789	91790
20369	29714	1	applied	\N	\N	\N	\N	91791	91791	91792
20369	29715	2	applied	\N	\N	\N	\N	91793	91793	91794
20369	29716	3	applied	\N	\N	\N	\N	91795	91795	91796
20369	29717	4	applied	\N	\N	\N	\N	91797	91797	91798
20369	29718	5	applied	\N	\N	\N	\N	91799	91799	91800
20369	29719	6	applied	\N	\N	\N	\N	91801	91801	91802
20369	29720	7	applied	\N	\N	\N	\N	91803	91803	91804
20369	29721	8	applied	\N	\N	\N	\N	91805	91805	91806
20369	29722	9	applied	\N	\N	\N	\N	91807	91807	91808
20369	29723	10	applied	\N	\N	\N	\N	91809	91809	91810
20369	29724	11	applied	\N	\N	\N	\N	91811	91811	91812
20369	29725	12	applied	\N	\N	\N	\N	91813	91813	91814
20369	29726	13	applied	\N	\N	\N	\N	91815	91815	91816
20369	29727	14	applied	\N	\N	\N	\N	91817	91817	91818
20369	29728	15	applied	\N	\N	\N	\N	91819	91819	91820
20374	29737	0	applied	\N	\N	\N	\N	91844	91844	91845
20374	29738	1	applied	\N	\N	\N	\N	91846	91846	91847
20374	29739	2	applied	\N	\N	\N	\N	91848	91848	91849
20376	29737	0	applied	\N	\N	\N	\N	91844	91844	91845
20376	29738	1	applied	\N	\N	\N	\N	91846	91846	91847
20376	29739	2	applied	\N	\N	\N	\N	91848	91848	91849
20381	29749	0	applied	\N	\N	\N	\N	91902	91902	91903
20381	29750	1	applied	\N	\N	\N	\N	91904	91904	91905
20381	29751	2	applied	\N	\N	\N	\N	91906	91906	91907
20383	29752	0	applied	\N	\N	\N	\N	91909	91909	91910
20383	29753	1	applied	\N	\N	\N	\N	91911	91911	91912
20392	29773	0	applied	\N	\N	\N	\N	91968	91968	91969
20392	29774	1	applied	\N	\N	\N	\N	91970	91970	91971
20392	29775	2	applied	\N	\N	\N	\N	91972	91972	91973
20392	29776	3	applied	\N	\N	\N	\N	91974	91974	91975
20392	29777	4	applied	\N	\N	\N	\N	91976	91976	91977
20392	29778	5	applied	\N	\N	\N	\N	91978	91978	91979
20392	29779	6	applied	\N	\N	\N	\N	91980	91980	91981
20346	29653	0	applied	\N	\N	\N	\N	91609	91609	91610
20346	29654	1	applied	\N	\N	\N	\N	91611	91611	91612
20346	29655	2	applied	\N	\N	\N	\N	91613	91613	91614
20355	29673	0	applied	\N	\N	\N	\N	91666	91666	91667
20355	29674	2	applied	\N	\N	\N	\N	91669	91669	91670
20355	29675	3	applied	\N	\N	\N	\N	91671	91671	91672
20358	29679	0	applied	\N	\N	\N	\N	91687	91687	91688
20358	29680	1	applied	\N	\N	\N	\N	91689	91689	91690
20358	29681	2	applied	\N	\N	\N	\N	91691	91691	91692
20358	29682	3	applied	\N	\N	\N	\N	91693	91693	91694
20358	29683	4	applied	\N	\N	\N	\N	91695	91695	91696
20358	29684	5	applied	\N	\N	\N	\N	91697	91697	91698
20360	29685	0	applied	\N	\N	\N	\N	91700	91700	91701
20360	29687	1	applied	\N	\N	\N	\N	91722	91722	91726
20360	29686	2	applied	\N	\N	\N	\N	91709	91709	91723
20363	29692	0	applied	\N	\N	\N	\N	91739	91739	91740
20363	29693	1	applied	\N	\N	\N	\N	91741	91741	91742
20363	29694	2	applied	\N	\N	\N	\N	91743	91743	91744
20363	29695	3	applied	\N	\N	\N	\N	91745	91745	91746
20363	29696	4	applied	\N	\N	\N	\N	91747	91747	91748
20363	29697	5	applied	\N	\N	\N	\N	91749	91749	91750
20365	29701	0	applied	\N	\N	\N	\N	91760	91760	91761
20365	29702	1	applied	\N	\N	\N	\N	91762	91762	91763
20365	29703	2	applied	\N	\N	\N	\N	91764	91764	91765
20368	29707	0	applied	\N	\N	\N	\N	91777	91777	91778
20368	29708	1	applied	\N	\N	\N	\N	91779	91779	91780
20368	29709	2	applied	\N	\N	\N	\N	91781	91781	91782
20368	29710	3	applied	\N	\N	\N	\N	91783	91783	91784
20368	29711	4	applied	\N	\N	\N	\N	91785	91785	91786
20368	29712	5	applied	\N	\N	\N	\N	91787	91787	91788
20371	29713	0	applied	\N	\N	\N	\N	91789	91789	91790
20371	29714	1	applied	\N	\N	\N	\N	91791	91791	91792
20371	29729	2	applied	\N	\N	\N	\N	91822	91822	91823
20371	29715	3	applied	\N	\N	\N	\N	91793	91793	91794
20371	29716	4	applied	\N	\N	\N	\N	91795	91795	91796
20371	29717	5	applied	\N	\N	\N	\N	91797	91797	91798
20371	29718	6	applied	\N	\N	\N	\N	91799	91799	91800
20371	29719	7	applied	\N	\N	\N	\N	91801	91801	91802
20371	29720	8	applied	\N	\N	\N	\N	91803	91803	91804
20371	29721	9	applied	\N	\N	\N	\N	91805	91805	91806
20371	29722	10	applied	\N	\N	\N	\N	91807	91807	91808
20371	29723	11	applied	\N	\N	\N	\N	91809	91809	91810
20371	29724	12	applied	\N	\N	\N	\N	91811	91811	91812
20371	29725	13	applied	\N	\N	\N	\N	91813	91813	91814
20371	29726	14	applied	\N	\N	\N	\N	91815	91815	91816
20371	29727	15	applied	\N	\N	\N	\N	91817	91817	91818
20371	29728	16	applied	\N	\N	\N	\N	91819	91819	91820
20387	29758	0	applied	\N	\N	\N	\N	91931	91931	91932
20387	29759	1	applied	\N	\N	\N	\N	91933	91933	91934
20387	29760	2	applied	\N	\N	\N	\N	91935	91935	91936
20396	29782	0	applied	\N	\N	\N	\N	91990	91990	91991
20396	29783	1	applied	\N	\N	\N	\N	91992	91992	91993
20396	29784	2	applied	\N	\N	\N	\N	91994	91994	91995
20400	29787	0	applied	\N	\N	\N	\N	92045	92045	92046
20400	29788	1	applied	\N	\N	\N	\N	92047	92047	92048
20400	29789	2	applied	\N	\N	\N	\N	92049	92049	92050
20409	29814	0	applied	\N	\N	\N	\N	92119	92119	92120
20409	29819	1	applied	\N	\N	\N	\N	92131	92131	92132
20409	29815	2	applied	\N	\N	\N	\N	92121	92121	92122
20409	29816	3	applied	\N	\N	\N	\N	92123	92123	92124
20409	29817	4	applied	\N	\N	\N	\N	92125	92125	92126
20409	29818	5	applied	\N	\N	\N	\N	92127	92127	92133
20413	29820	0	applied	\N	\N	\N	\N	92138	92138	92139
20413	29825	1	applied	\N	\N	\N	\N	92150	92150	92151
20413	29826	2	applied	\N	\N	\N	\N	92152	92152	92153
20413	29821	3	applied	\N	\N	\N	\N	92140	92140	92141
20413	29819	4	applied	\N	\N	\N	\N	92131	92131	92133
20413	29822	5	applied	\N	\N	\N	\N	92142	92142	92143
20413	29823	6	applied	\N	\N	\N	\N	92144	92144	92145
20413	29827	7	applied	\N	\N	\N	\N	92154	92154	92155
20413	29824	8	applied	\N	\N	\N	\N	92146	92146	92156
20413	29828	9	applied	\N	\N	\N	\N	92157	92157	92158
20413	29829	10	applied	\N	\N	\N	\N	92159	92159	92160
20413	29830	11	applied	\N	\N	1000000000	\N	92161	92161	92162
20413	29831	12	applied	\N	\N	1000000000	\N	92163	92163	92164
20413	29832	13	applied	\N	\N	1000000000	\N	92165	92165	92166
20413	29833	14	applied	\N	\N	\N	\N	92167	92167	92168
20413	29834	15	applied	\N	\N	\N	\N	92169	92169	92170
20420	29840	0	applied	\N	\N	\N	\N	92192	92192	92193
20420	29841	1	applied	\N	\N	\N	\N	92194	92194	92195
20420	29842	2	applied	\N	\N	\N	\N	92196	92196	92197
20420	29843	3	applied	\N	\N	\N	\N	92198	92198	92199
20420	29844	4	applied	\N	\N	\N	\N	92200	92200	92201
20420	29845	5	applied	\N	\N	\N	\N	92202	92202	92203
20422	29846	0	applied	\N	\N	\N	\N	92208	92208	92209
20422	29847	1	applied	\N	\N	\N	\N	92210	92210	92211
20422	29848	2	applied	\N	\N	\N	\N	92212	92212	92213
20425	29852	0	applied	\N	\N	\N	\N	92223	92223	92224
20425	29853	1	applied	\N	\N	\N	\N	92225	92225	92226
20425	29854	3	applied	\N	\N	\N	\N	92228	92228	92229
20427	29852	0	applied	\N	\N	\N	\N	92223	92223	92224
20427	29853	1	applied	\N	\N	\N	\N	92225	92225	92226
20427	29854	3	applied	\N	\N	\N	\N	92228	92228	92229
20429	29855	0	applied	\N	\N	\N	\N	92240	92240	92241
20431	29856	0	applied	\N	\N	\N	\N	92244	92244	92245
20431	29857	1	applied	\N	\N	\N	\N	92246	92246	92247
20431	29855	2	applied	\N	\N	\N	\N	92240	92240	92241
20431	29858	3	applied	\N	\N	\N	\N	92248	92248	92249
20431	29859	4	applied	\N	\N	\N	\N	92250	92250	92251
20431	29860	5	applied	\N	\N	\N	\N	92252	92252	92253
20431	29861	6	applied	\N	\N	\N	\N	92254	92254	92255
20431	29862	7	applied	\N	\N	\N	\N	92256	92256	92257
20434	29863	0	applied	\N	\N	\N	\N	92260	92260	92261
20434	29864	1	applied	\N	\N	\N	\N	92262	92262	92263
20434	29865	2	applied	\N	\N	\N	\N	92264	92264	92265
20434	29866	3	applied	\N	\N	\N	\N	92266	92266	92267
20434	29868	4	applied	\N	\N	\N	\N	92270	92270	92271
20436	29869	0	applied	\N	\N	\N	\N	92277	92277	92278
20436	29870	1	applied	\N	\N	\N	\N	92279	92279	92280
20436	29878	2	applied	\N	\N	\N	\N	92296	92296	92297
20436	29867	3	applied	\N	\N	\N	\N	92268	92268	92269
20436	29871	4	applied	\N	\N	\N	\N	92281	92281	92282
20436	29872	5	applied	\N	\N	\N	\N	92283	92283	92284
20436	29873	6	applied	\N	\N	\N	\N	92285	92285	92286
20436	29874	7	applied	\N	\N	\N	\N	92287	92287	92298
20436	29875	8	applied	\N	\N	\N	\N	92289	92289	92290
20436	29876	9	applied	\N	\N	\N	\N	92291	92291	92292
20436	29877	10	applied	\N	\N	\N	\N	92293	92293	92294
20438	29869	0	applied	\N	\N	\N	\N	92277	92277	92278
20385	29722	17	applied	\N	\N	\N	\N	91877	91877	91808
20385	29723	18	applied	\N	\N	\N	\N	91878	91878	91810
20385	29639	19	applied	\N	\N	\N	\N	91560	91560	91561
20385	29640	20	applied	\N	\N	\N	\N	91562	91562	91563
20385	29641	21	applied	\N	\N	\N	\N	91564	91564	91565
20385	29757	22	applied	\N	\N	\N	\N	91927	91927	91928
20385	29724	23	applied	\N	\N	\N	\N	91884	91884	91812
20385	29725	24	applied	\N	\N	\N	\N	91885	91885	91814
20385	29726	25	applied	\N	\N	\N	\N	91886	91886	91816
20385	29727	26	applied	\N	\N	\N	\N	91887	91887	91818
20385	29728	27	applied	\N	\N	\N	\N	91888	91888	91820
20390	29770	0	applied	\N	\N	\N	\N	91960	91960	91961
20390	29771	1	applied	\N	\N	\N	\N	91962	91962	91963
20390	29772	2	applied	\N	\N	\N	\N	91964	91964	91965
20391	29773	0	applied	\N	\N	\N	\N	91968	91968	91969
20391	29774	1	applied	\N	\N	\N	\N	91970	91970	91971
20391	29775	2	applied	\N	\N	\N	\N	91972	91972	91973
20391	29776	3	applied	\N	\N	\N	\N	91974	91974	91975
20391	29777	4	applied	\N	\N	\N	\N	91976	91976	91977
20391	29778	5	applied	\N	\N	\N	\N	91978	91978	91979
20391	29779	6	applied	\N	\N	\N	\N	91980	91980	91981
20391	29780	7	applied	\N	\N	\N	\N	91982	91982	91983
20391	29781	8	applied	\N	\N	\N	\N	91984	91984	91985
20393	29782	0	applied	\N	\N	\N	\N	91990	91990	91991
20393	29783	1	applied	\N	\N	\N	\N	91992	91992	91993
20393	29784	2	applied	\N	\N	\N	\N	91994	91994	91995
20398	29785	0	applied	\N	\N	\N	\N	92003	92003	92004
20398	29786	1	applied	\N	\N	\N	\N	92005	92005	92006
20401	29787	0	applied	\N	\N	\N	\N	92045	92045	92046
20401	29788	1	applied	\N	\N	\N	\N	92047	92047	92048
20401	29789	2	applied	\N	\N	\N	\N	92049	92049	92050
20403	29790	0	applied	\N	\N	\N	\N	92052	92052	92053
20403	29791	1	applied	\N	\N	\N	\N	92064	92064	92065
20403	29792	2	applied	\N	\N	\N	\N	92066	92066	92067
20404	29793	0	applied	\N	\N	\N	\N	92069	92069	92070
20404	29794	1	applied	\N	\N	\N	\N	92071	92071	92072
20404	29795	2	applied	\N	\N	\N	\N	92073	92073	92074
20404	29796	3	applied	\N	\N	\N	\N	92075	92075	92076
20404	29797	4	applied	\N	\N	\N	\N	92077	92077	92078
20404	29798	5	applied	\N	\N	\N	\N	92079	92079	92080
20404	29799	6	applied	\N	\N	\N	\N	92081	92081	92082
20404	29800	7	applied	\N	\N	\N	\N	92083	92083	92084
20404	29801	8	applied	\N	\N	\N	\N	92085	92085	92086
20404	29802	9	applied	\N	\N	\N	\N	92087	92087	92088
20404	29803	10	applied	\N	\N	\N	\N	92089	92089	92090
20404	29804	11	applied	\N	\N	\N	\N	92091	92091	92092
20406	29805	0	applied	\N	\N	\N	\N	92097	92097	92098
20406	29806	1	applied	\N	\N	\N	\N	92099	92099	92100
20406	29807	2	applied	\N	\N	\N	\N	92101	92101	92102
20410	29814	0	applied	\N	\N	\N	\N	92119	92119	92120
20410	29819	1	applied	\N	\N	\N	\N	92131	92131	92132
20410	29815	2	applied	\N	\N	\N	\N	92121	92121	92122
20410	29816	3	applied	\N	\N	\N	\N	92123	92123	92124
20410	29817	4	applied	\N	\N	\N	\N	92125	92125	92126
20410	29818	5	applied	\N	\N	\N	\N	92127	92127	92133
20416	29835	0	applied	\N	\N	\N	\N	92177	92177	92178
20416	29836	1	applied	\N	\N	\N	\N	92179	92179	92180
20416	29837	2	applied	\N	\N	1000000000	\N	92181	92181	92182
20416	29838	3	applied	\N	\N	\N	\N	92183	92183	92184
20416	29839	4	applied	\N	\N	1000000000	\N	92185	92185	92186
20421	29840	0	applied	\N	\N	\N	\N	92192	92192	92193
20421	29841	1	applied	\N	\N	\N	\N	92194	92194	92195
20421	29842	2	applied	\N	\N	\N	\N	92196	92196	92197
20421	29843	3	applied	\N	\N	\N	\N	92198	92198	92199
20421	29844	4	applied	\N	\N	\N	\N	92200	92200	92201
20421	29845	5	applied	\N	\N	\N	\N	92202	92202	92203
20423	29849	0	applied	\N	\N	\N	\N	92215	92215	92216
20423	29850	1	applied	\N	\N	\N	\N	92217	92217	92218
20423	29851	2	applied	\N	\N	\N	\N	92219	92219	92220
20426	29852	0	applied	\N	\N	\N	\N	92223	92223	92224
20426	29853	1	applied	\N	\N	\N	\N	92225	92225	92226
20426	29854	3	applied	\N	\N	\N	\N	92228	92228	92229
20432	29863	0	applied	\N	\N	\N	\N	92260	92260	92261
20432	29864	1	applied	\N	\N	\N	\N	92262	92262	92263
20432	29865	2	applied	\N	\N	\N	\N	92264	92264	92265
20432	29866	3	applied	\N	\N	\N	\N	92266	92266	92267
20432	29867	4	applied	\N	\N	\N	\N	92268	92268	92269
20432	29868	5	applied	\N	\N	\N	\N	92270	92270	92271
20437	29869	0	applied	\N	\N	\N	\N	92277	92277	92278
20437	29870	1	applied	\N	\N	\N	\N	92279	92279	92280
20437	29878	2	applied	\N	\N	\N	\N	92296	92296	92297
20437	29867	3	applied	\N	\N	\N	\N	92268	92268	92269
20437	29871	4	applied	\N	\N	\N	\N	92281	92281	92282
20437	29872	5	applied	\N	\N	\N	\N	92283	92283	92284
20437	29873	6	applied	\N	\N	\N	\N	92285	92285	92286
20437	29874	7	applied	\N	\N	\N	\N	92287	92287	92298
20437	29875	8	applied	\N	\N	\N	\N	92289	92289	92290
20437	29876	9	applied	\N	\N	\N	\N	92291	92291	92292
20437	29877	10	applied	\N	\N	\N	\N	92293	92293	92294
20443	29885	0	applied	\N	\N	\N	\N	92321	92321	92322
20443	29886	1	applied	\N	\N	\N	\N	92323	92323	92324
20448	29891	0	applied	\N	\N	\N	\N	92340	92340	92341
20448	29892	1	applied	\N	\N	\N	\N	92342	92342	92343
20448	29893	2	applied	\N	\N	\N	\N	92344	92344	92345
20452	29897	0	applied	\N	\N	\N	\N	92359	92359	92360
20452	29898	1	applied	\N	\N	1000000000	\N	92361	92361	92362
20452	29899	2	applied	\N	\N	\N	\N	92363	92363	83176
20452	29900	3	applied	\N	\N	\N	\N	92364	92364	92365
20452	29901	4	applied	\N	\N	\N	\N	92366	92366	92367
20452	29902	5	applied	\N	\N	\N	\N	92368	92368	92369
20456	29903	0	applied	\N	\N	\N	\N	92376	92376	92377
20456	29904	1	applied	\N	\N	\N	\N	92378	92378	92379
20456	29905	2	applied	\N	\N	\N	\N	92380	92380	92381
20459	29906	0	applied	\N	\N	\N	\N	92382	92382	92383
20459	29907	1	applied	\N	\N	\N	\N	92384	92384	92385
20459	29908	2	applied	\N	\N	\N	\N	92386	92386	92387
20465	29915	0	applied	\N	\N	\N	\N	92412	92412	92413
20465	29916	1	applied	\N	\N	\N	\N	92414	92414	92415
20465	29917	2	applied	\N	\N	\N	\N	92418	92418	92419
20470	29927	0	applied	\N	\N	\N	\N	92490	92490	92491
20470	29928	1	applied	\N	\N	\N	\N	92492	92492	92493
20470	29929	2	applied	\N	\N	\N	\N	92494	92494	92495
20473	29933	0	applied	\N	\N	\N	\N	92505	92505	92506
20473	29934	1	applied	\N	\N	\N	\N	92507	92507	92508
20473	29935	2	applied	\N	\N	\N	\N	92509	92509	92510
20473	29936	3	applied	\N	\N	\N	\N	92511	92511	92512
20478	29898	0	applied	\N	\N	1000000000	\N	92361	92361	92362
20478	29746	1	applied	\N	\N	\N	\N	91896	91896	91897
20478	29749	2	applied	\N	\N	\N	\N	91902	91902	91903
20392	29780	7	applied	\N	\N	\N	\N	91982	91982	91983
20392	29781	8	applied	\N	\N	\N	\N	91984	91984	91985
20394	29782	0	applied	\N	\N	\N	\N	91990	91990	91991
20397	29782	0	applied	\N	\N	\N	\N	91990	91990	91991
20397	29783	1	applied	\N	\N	\N	\N	91992	91992	91993
20397	29784	2	applied	\N	\N	\N	\N	91994	91994	91995
20405	29793	0	applied	\N	\N	\N	\N	92069	92069	92070
20405	29794	1	applied	\N	\N	\N	\N	92071	92071	92072
20405	29795	2	applied	\N	\N	\N	\N	92073	92073	92074
20405	29796	3	applied	\N	\N	\N	\N	92075	92075	92076
20405	29797	4	applied	\N	\N	\N	\N	92077	92077	92078
20405	29798	5	applied	\N	\N	\N	\N	92079	92079	92080
20405	29799	6	applied	\N	\N	\N	\N	92081	92081	92082
20405	29800	7	applied	\N	\N	\N	\N	92083	92083	92084
20405	29801	8	applied	\N	\N	\N	\N	92085	92085	92086
20405	29802	9	applied	\N	\N	\N	\N	92087	92087	92088
20405	29803	10	applied	\N	\N	\N	\N	92089	92089	92090
20405	29804	11	applied	\N	\N	\N	\N	92091	92091	92092
20407	29808	0	applied	\N	\N	\N	\N	92105	92105	92106
20407	29809	1	applied	\N	\N	\N	\N	92107	92107	92108
20407	29810	2	applied	\N	\N	\N	\N	92109	92109	92110
20407	29811	3	applied	\N	\N	\N	\N	92111	92111	92112
20407	29812	4	applied	\N	\N	\N	\N	92113	92113	92114
20407	29813	5	applied	\N	\N	\N	\N	92115	92115	92116
20411	29814	0	applied	\N	\N	\N	\N	92119	92119	92120
20411	29819	1	applied	\N	\N	\N	\N	92131	92131	92132
20411	29815	2	applied	\N	\N	\N	\N	92121	92121	92122
20411	29816	3	applied	\N	\N	\N	\N	92123	92123	92124
20411	29817	4	applied	\N	\N	\N	\N	92125	92125	92126
20411	29818	5	applied	\N	\N	\N	\N	92127	92127	92133
20414	29825	0	applied	\N	\N	\N	\N	92150	92150	92151
20414	29826	1	applied	\N	\N	\N	\N	92152	92152	92153
20414	29828	2	applied	\N	\N	\N	\N	92157	92157	92172
20414	29829	3	applied	\N	\N	\N	\N	92159	92159	92173
20414	29827	4	applied	\N	\N	\N	\N	92154	92154	92160
20414	29830	5	applied	\N	\N	1000000000	\N	92161	92161	92162
20414	29831	6	applied	\N	\N	1000000000	\N	92163	92163	92164
20414	29832	7	applied	\N	\N	1000000000	\N	92165	92165	92166
20414	29833	8	applied	\N	\N	\N	\N	92167	92167	92168
20414	29834	9	applied	\N	\N	\N	\N	92169	92169	92170
20417	29835	0	applied	\N	\N	\N	\N	92177	92177	92178
20417	29836	1	applied	\N	\N	\N	\N	92179	92179	92180
20417	29837	2	applied	\N	\N	1000000000	\N	92181	92181	92182
20417	29838	3	applied	\N	\N	\N	\N	92183	92183	92184
20417	29839	4	applied	\N	\N	1000000000	\N	92185	92185	92186
20419	29840	0	applied	\N	\N	\N	\N	92192	92192	92193
20419	29841	1	applied	\N	\N	\N	\N	92194	92194	92195
20419	29842	2	applied	\N	\N	\N	\N	92196	92196	92197
20419	29843	3	applied	\N	\N	\N	\N	92198	92198	92199
20419	29844	4	applied	\N	\N	\N	\N	92200	92200	92201
20419	29845	5	applied	\N	\N	\N	\N	92202	92202	92203
20430	29856	0	applied	\N	\N	\N	\N	92244	92244	92245
20430	29857	1	applied	\N	\N	\N	\N	92246	92246	92247
20430	29855	2	applied	\N	\N	\N	\N	92240	92240	92241
20430	29858	3	applied	\N	\N	\N	\N	92248	92248	92249
20430	29859	4	applied	\N	\N	\N	\N	92250	92250	92251
20430	29860	5	applied	\N	\N	\N	\N	92252	92252	92253
20430	29861	6	applied	\N	\N	\N	\N	92254	92254	92255
20430	29862	7	applied	\N	\N	\N	\N	92256	92256	92257
20433	29863	0	applied	\N	\N	\N	\N	92260	92260	92261
20433	29864	1	applied	\N	\N	\N	\N	92262	92262	92263
20433	29865	2	applied	\N	\N	\N	\N	92264	92264	92265
20433	29866	3	applied	\N	\N	\N	\N	92266	92266	92267
20433	29867	4	applied	\N	\N	\N	\N	92268	92268	92269
20433	29868	5	applied	\N	\N	\N	\N	92270	92270	92271
20439	29879	0	applied	\N	\N	\N	\N	92303	92303	92304
20439	29880	1	applied	\N	\N	\N	\N	92305	92305	92306
20439	29881	2	applied	\N	\N	\N	\N	92307	92307	92308
20444	29885	0	applied	\N	\N	\N	\N	92321	92321	92322
20444	29886	1	applied	\N	\N	\N	\N	92323	92323	92324
20449	29891	0	applied	\N	\N	\N	\N	92340	92340	92341
20449	29892	1	applied	\N	\N	\N	\N	92342	92342	92343
20449	29893	2	applied	\N	\N	\N	\N	92344	92344	92345
20453	29897	0	applied	\N	\N	\N	\N	92359	92359	92360
20453	29898	1	applied	\N	\N	1000000000	\N	92361	92361	92362
20453	29899	2	applied	\N	\N	\N	\N	92363	92363	83176
20453	29900	3	applied	\N	\N	\N	\N	92364	92364	92365
20453	29901	4	applied	\N	\N	\N	\N	92366	92366	92367
20453	29902	5	applied	\N	\N	\N	\N	92368	92368	92369
20457	29906	0	applied	\N	\N	\N	\N	92382	92382	92383
20457	29907	1	applied	\N	\N	\N	\N	92384	92384	92385
20457	29908	2	applied	\N	\N	\N	\N	92386	92386	92387
20460	29906	0	applied	\N	\N	\N	\N	92382	92382	92383
20460	29907	1	applied	\N	\N	\N	\N	92384	92384	92385
20461	29909	0	applied	\N	\N	\N	\N	92395	92395	92396
20461	29910	1	applied	\N	\N	\N	\N	92397	92397	92398
20461	29911	2	applied	\N	\N	\N	\N	92399	92399	92400
20466	29918	0	applied	\N	\N	\N	\N	92421	92421	24815
20466	29919	1	applied	\N	\N	\N	\N	92422	92422	92423
20466	29920	2	applied	\N	\N	\N	\N	92424	92424	92425
20466	29917	3	applied	\N	\N	\N	\N	92418	92418	92426
20466	29921	4	applied	\N	\N	\N	\N	92427	92427	92428
20468	29923	0	applied	\N	\N	\N	\N	92479	92479	92480
20468	29924	1	applied	\N	\N	\N	\N	92481	92481	92482
20468	29925	2	applied	\N	\N	\N	\N	92483	92483	92484
20468	29926	3	applied	\N	\N	\N	\N	92485	92485	92486
20475	29938	0	applied	\N	\N	\N	\N	92521	92521	92522
20475	29937	1	applied	\N	\N	\N	\N	92517	92517	92518
20476	29939	0	applied	\N	\N	\N	\N	92524	92524	92525
20476	29940	1	applied	\N	\N	\N	\N	92526	92526	34803
20476	29941	2	applied	\N	\N	\N	\N	92527	92527	92528
20476	29942	3	applied	\N	\N	\N	\N	92529	92529	92530
20482	29969	0	applied	\N	\N	\N	\N	92623	92623	92624
20482	29970	1	applied	\N	\N	\N	\N	92625	92625	92626
20487	29976	0	applied	\N	\N	\N	\N	92650	92650	92651
20487	29977	1	applied	\N	\N	\N	\N	92652	92652	92653
20487	29978	2	applied	\N	\N	\N	\N	92654	92654	92655
20487	29979	3	applied	\N	\N	\N	\N	92656	92656	92657
20487	29980	4	applied	\N	\N	\N	\N	92658	92658	92659
20487	29981	5	applied	\N	\N	\N	\N	92660	92660	92661
20495	30001	0	applied	\N	\N	\N	\N	92713	92713	92714
20495	30002	1	applied	\N	\N	\N	\N	92715	92715	92716
20500	30003	0	applied	\N	\N	\N	\N	92722	92722	92723
20500	30004	1	applied	\N	\N	\N	\N	92724	92724	92725
20500	30005	2	applied	\N	\N	\N	\N	92726	92726	92727
20500	30006	3	applied	\N	\N	\N	\N	92728	92728	92729
20505	30010	0	applied	\N	\N	\N	\N	92740	92740	92741
20505	30011	1	applied	\N	\N	\N	\N	92742	92742	92743
20505	30012	2	applied	\N	\N	\N	\N	92744	92744	92745
20395	29783	1	applied	\N	\N	\N	\N	91992	91992	91993
20395	29784	2	applied	\N	\N	\N	\N	91994	91994	91995
20399	29731	0	applied	\N	\N	\N	\N	91853	91853	88549
20399	29609	1	applied	\N	\N	\N	\N	91489	91489	91490
20399	29613	2	applied	\N	\N	\N	\N	91501	91501	91502
20399	29616	3	applied	\N	\N	\N	\N	91509	91509	91510
20399	29619	4	applied	\N	\N	\N	\N	91515	91515	91516
20399	29620	5	applied	\N	\N	\N	\N	91517	91517	91518
20399	29626	6	applied	\N	\N	\N	\N	91530	91530	91531
20399	29627	7	applied	\N	\N	\N	\N	91532	91532	91533
20399	29632	8	applied	\N	\N	\N	\N	91544	91544	91545
20399	29636	9	applied	\N	\N	\N	\N	91554	91554	91555
20399	29642	10	applied	\N	\N	\N	\N	91582	91582	91583
20399	29643	11	applied	\N	\N	\N	\N	91584	91584	91585
20399	29647	12	applied	\N	\N	\N	\N	91596	91596	91597
20399	29648	13	applied	\N	\N	\N	\N	91598	91598	91599
20399	29653	14	applied	\N	\N	\N	\N	91609	91609	91610
20399	29656	15	applied	\N	\N	\N	\N	91619	91619	91620
20399	29657	16	applied	\N	\N	\N	\N	91621	91621	91622
20399	29658	17	applied	\N	\N	\N	\N	91623	91623	91624
20399	29665	18	applied	\N	\N	\N	\N	91638	91638	91639
20399	29668	19	applied	\N	\N	\N	\N	91646	91646	91647
20399	29671	20	applied	\N	\N	\N	\N	91660	91660	91661
20399	29673	21	applied	\N	\N	\N	\N	91666	91666	91667
20399	29676	22	applied	\N	\N	\N	\N	91680	91680	91681
20399	29679	23	applied	\N	\N	\N	\N	91687	91687	91688
20399	29680	24	applied	\N	\N	\N	\N	91689	91689	91690
20399	29685	25	applied	\N	\N	\N	\N	91700	91700	91701
20399	29688	26	applied	\N	\N	\N	\N	91729	91729	91730
20399	29692	27	applied	\N	\N	\N	\N	91739	91739	91740
20399	29698	28	applied	\N	\N	\N	\N	91754	91754	91755
20399	29701	29	applied	\N	\N	\N	\N	91760	91760	91761
20399	29705	30	applied	\N	\N	\N	\N	91771	91771	91772
20399	29707	31	applied	\N	\N	\N	\N	91777	91777	91778
20399	29708	32	applied	\N	\N	\N	\N	91779	91779	91780
20399	29713	33	applied	\N	\N	\N	\N	91789	91789	91790
20399	29730	34	applied	\N	\N	\N	\N	91828	91828	91829
20399	29734	35	applied	\N	\N	\N	\N	91836	91836	91837
20399	29737	36	applied	\N	\N	\N	\N	91844	91844	91845
20399	29740	37	applied	\N	\N	\N	\N	91854	91854	91855
20399	29741	38	applied	\N	\N	\N	\N	91856	91856	91857
20399	29746	39	applied	\N	\N	\N	\N	91896	91896	91897
20399	29749	40	applied	\N	\N	\N	\N	91902	91902	91903
20399	29752	41	applied	\N	\N	\N	\N	91909	91909	91910
20399	29754	42	applied	\N	\N	\N	\N	91915	91915	91916
20399	29758	43	applied	\N	\N	\N	\N	91931	91931	91932
20399	29761	44	applied	\N	\N	\N	\N	91941	91941	91942
20399	29762	45	applied	\N	\N	\N	\N	91943	91943	91944
20399	29763	46	applied	\N	\N	\N	\N	91945	91945	91946
20399	29770	47	applied	\N	\N	\N	\N	91960	91960	91961
20399	29773	48	applied	\N	\N	\N	\N	91968	91968	91969
20399	29774	49	applied	\N	\N	\N	\N	91970	91970	91971
20399	29775	50	applied	\N	\N	\N	\N	91972	91972	91973
20399	29782	51	applied	\N	\N	\N	\N	91990	91990	91991
20399	29689	52	applied	\N	\N	\N	\N	91923	91923	91732
20399	29693	53	applied	\N	\N	\N	\N	91924	91924	91742
20399	29694	54	applied	\N	\N	\N	\N	91925	91925	91744
20399	29695	55	applied	\N	\N	\N	\N	91926	91926	91746
20399	29415	56	applied	\N	\N	\N	\N	90925	90925	92009
20399	29421	57	applied	\N	\N	\N	\N	90941	90941	90866
20399	29715	58	applied	\N	\N	\N	\N	91858	91858	91794
20399	29423	59	applied	\N	\N	\N	\N	90945	90945	90868
20399	29424	60	applied	\N	\N	\N	\N	90947	90947	90870
20399	29425	61	applied	\N	\N	\N	\N	90949	90949	92010
20399	29431	62	applied	\N	\N	\N	\N	90964	90964	92011
20399	29716	63	applied	\N	\N	\N	\N	91859	91859	91796
20399	29717	64	applied	\N	\N	\N	\N	91860	91860	91798
20399	29438	65	applied	\N	\N	\N	\N	90982	90982	90874
20399	29439	66	applied	\N	\N	\N	\N	90984	90984	90884
20399	29442	67	applied	\N	\N	\N	\N	90992	90992	92012
20399	29446	68	applied	\N	\N	\N	\N	91004	91004	90888
20399	29449	69	applied	\N	\N	\N	\N	91016	91016	90890
20399	29450	70	applied	\N	\N	\N	\N	91018	91018	92013
20399	29455	71	applied	\N	\N	\N	\N	91031	91031	92014
20399	29458	72	applied	\N	\N	\N	\N	91039	91039	92015
20399	29460	73	applied	\N	\N	\N	\N	91047	91047	90904
20399	29462	74	applied	\N	\N	\N	\N	91051	91051	90906
20399	29467	75	applied	\N	\N	\N	\N	91068	91068	90912
20399	29468	76	applied	\N	\N	\N	\N	91070	91070	92016
20399	29475	77	applied	\N	\N	\N	\N	91086	91086	92017
20399	29476	78	applied	\N	\N	\N	\N	91088	91088	90920
20399	29718	79	applied	\N	\N	\N	\N	91873	91873	91800
20399	29719	80	applied	\N	\N	\N	\N	91874	91874	91802
20399	29720	81	applied	\N	\N	\N	\N	91875	91875	91804
20399	29721	82	applied	\N	\N	\N	\N	91876	91876	91806
20399	29722	83	applied	\N	\N	\N	\N	91877	91877	91808
20399	29723	84	applied	\N	\N	\N	\N	91878	91878	91810
20399	29482	85	applied	\N	\N	\N	\N	91102	91102	92018
20399	29483	86	applied	\N	\N	\N	\N	91104	91104	92019
20399	29486	87	applied	\N	\N	\N	\N	91124	91124	92020
20399	29490	88	applied	\N	\N	\N	\N	91139	91139	90928
20399	29493	91	applied	\N	\N	\N	\N	91149	91149	90942
20399	29494	92	applied	\N	\N	\N	\N	91152	91152	92024
20399	29502	93	applied	\N	\N	\N	\N	91177	91177	92025
20399	29503	94	applied	\N	\N	\N	\N	91181	91181	92026
20399	29505	95	applied	\N	\N	\N	\N	91194	91194	92027
20399	29511	96	applied	\N	\N	\N	\N	91210	91210	90952
20399	29512	97	applied	\N	\N	\N	\N	91212	91212	92028
20399	29513	98	applied	\N	\N	\N	\N	91214	91214	92029
20399	29519	99	applied	\N	\N	\N	\N	91227	91227	90956
20399	29520	100	applied	\N	\N	\N	\N	91229	91229	92030
20399	29525	101	applied	\N	\N	\N	\N	91241	91241	92031
20399	29529	102	applied	\N	\N	\N	\N	91253	91253	90968
20399	29530	103	applied	\N	\N	\N	\N	91255	91255	90967
20399	29535	104	applied	\N	\N	\N	\N	91266	91266	92032
20399	29538	105	applied	\N	\N	\N	\N	91274	91274	90979
20399	29542	106	applied	\N	\N	\N	\N	91284	91284	92033
20399	29544	107	applied	\N	\N	\N	\N	91290	91290	92034
20399	29550	108	applied	\N	\N	\N	\N	91304	91304	92035
20399	29551	109	applied	\N	\N	\N	\N	91306	91306	92036
20399	29554	110	applied	\N	\N	\N	\N	91312	91312	90991
20399	29363	111	applied	\N	\N	\N	\N	90802	90802	92037
20399	29368	112	applied	\N	\N	\N	\N	90817	90817	91001
20399	29373	113	applied	\N	\N	\N	\N	90828	90828	92038
20399	29377	114	applied	\N	\N	\N	\N	90836	90836	91019
20399	29381	115	applied	\N	\N	\N	\N	90844	90844	91021
20399	29385	116	applied	\N	\N	\N	\N	90853	90853	91023
20399	29387	117	applied	\N	\N	\N	\N	90857	90857	91032
20399	29393	118	applied	\N	\N	\N	\N	90871	90871	91038
20399	29394	119	applied	\N	\N	\N	\N	90873	90873	92039
20399	29399	120	applied	\N	\N	\N	\N	90885	90885	92040
20399	29402	121	applied	\N	\N	\N	\N	90891	90891	91052
20399	29405	122	applied	\N	\N	\N	\N	90903	90903	91054
20399	29409	123	applied	\N	\N	\N	\N	90913	90913	91069
20399	29412	124	applied	\N	\N	\N	\N	90919	90919	92041
20399	29413	125	applied	\N	\N	\N	\N	90921	90921	92042
20402	29740	0	applied	\N	\N	\N	\N	91854	91854	91855
20402	29741	1	applied	\N	\N	\N	\N	91856	91856	91857
20402	29746	2	applied	\N	\N	\N	\N	91896	91896	91897
20402	29749	3	applied	\N	\N	\N	\N	91902	91902	91903
20402	29752	4	applied	\N	\N	\N	\N	91909	91909	91910
20402	29754	5	applied	\N	\N	\N	\N	91915	91915	91916
20402	29758	6	applied	\N	\N	\N	\N	91931	91931	91932
20402	29761	7	applied	\N	\N	\N	\N	91941	91941	91942
20402	29762	8	applied	\N	\N	\N	\N	91943	91943	91944
20402	29763	9	applied	\N	\N	\N	\N	91945	91945	91946
20402	29770	10	applied	\N	\N	\N	\N	91960	91960	91961
20402	29773	11	applied	\N	\N	\N	\N	91968	91968	91969
20402	29774	12	applied	\N	\N	\N	\N	91970	91970	91971
20402	29775	13	applied	\N	\N	\N	\N	91972	91972	91973
20402	29782	14	applied	\N	\N	\N	\N	91990	91990	91991
20402	29785	15	applied	\N	\N	\N	\N	92003	92003	92004
20402	29787	16	applied	\N	\N	\N	\N	92045	92045	92046
20402	29790	17	applied	\N	\N	\N	\N	92052	92052	92053
20402	29742	18	applied	\N	\N	\N	\N	91870	91870	91879
20402	29745	19	applied	\N	\N	\N	\N	91889	91889	92054
20402	29748	20	applied	\N	\N	\N	\N	91900	91900	92055
20402	29750	21	applied	\N	\N	\N	\N	91904	91904	91883
20402	29753	22	applied	\N	\N	\N	\N	91911	91911	91890
20402	29756	23	applied	\N	\N	\N	\N	91919	91919	92056
20402	29759	24	applied	\N	\N	\N	\N	91933	91933	92057
20402	29764	25	applied	\N	\N	\N	\N	91947	91947	92058
20402	29768	26	applied	\N	\N	\N	\N	91955	91955	92059
20402	29769	27	applied	\N	\N	\N	\N	91957	91957	91907
20402	29772	28	applied	\N	\N	\N	\N	91964	91964	91912
20402	29776	29	applied	\N	\N	\N	\N	91974	91974	92060
20402	29780	30	applied	\N	\N	\N	\N	91982	91982	92061
20408	29814	0	applied	\N	\N	\N	\N	92119	92119	92120
20408	29815	1	applied	\N	\N	\N	\N	92121	92121	92122
20408	29816	2	applied	\N	\N	\N	\N	92123	92123	92124
20408	29817	3	applied	\N	\N	\N	\N	92125	92125	92126
20408	29818	4	applied	\N	\N	\N	\N	92127	92127	92128
20412	29820	0	applied	\N	\N	\N	\N	92138	92138	92139
20412	29821	1	applied	\N	\N	\N	\N	92140	92140	92141
20412	29819	2	applied	\N	\N	\N	\N	92131	92131	92133
20412	29822	3	applied	\N	\N	\N	\N	92142	92142	92143
20412	29823	4	applied	\N	\N	\N	\N	92144	92144	92145
20412	29824	5	applied	\N	\N	\N	\N	92146	92146	92147
20415	29825	0	applied	\N	\N	\N	\N	92150	92150	92151
20415	29826	1	applied	\N	\N	\N	\N	92152	92152	92153
20415	29828	2	applied	\N	\N	\N	\N	92157	92157	92172
20415	29829	3	applied	\N	\N	\N	\N	92159	92159	92173
20415	29827	4	applied	\N	\N	\N	\N	92154	92154	92160
20415	29830	5	applied	\N	\N	1000000000	\N	92161	92161	92162
20415	29831	6	applied	\N	\N	1000000000	\N	92163	92163	92164
20415	29832	7	applied	\N	\N	1000000000	\N	92165	92165	92166
20415	29833	8	applied	\N	\N	\N	\N	92167	92167	92168
20415	29834	9	applied	\N	\N	\N	\N	92169	92169	92170
20418	29835	0	applied	\N	\N	\N	\N	92177	92177	92178
20418	29836	1	applied	\N	\N	\N	\N	92179	92179	92180
20418	29837	2	applied	\N	\N	1000000000	\N	92181	92181	92182
20418	29838	3	applied	\N	\N	\N	\N	92183	92183	92184
20418	29839	4	applied	\N	\N	1000000000	\N	92185	92185	92186
20424	29852	0	applied	\N	\N	\N	\N	92223	92223	92224
20424	29853	1	applied	\N	\N	\N	\N	92225	92225	92226
20424	29854	3	applied	\N	\N	\N	\N	92228	92228	92229
20428	29852	0	applied	\N	\N	\N	\N	92223	92223	92224
20428	29853	1	applied	\N	\N	\N	\N	92225	92225	92226
20428	29854	3	applied	\N	\N	\N	\N	92228	92228	92229
20435	29869	0	applied	\N	\N	\N	\N	92277	92277	92278
20435	29870	1	applied	\N	\N	\N	\N	92279	92279	92280
20435	29867	2	applied	\N	\N	\N	\N	92268	92268	92269
20435	29871	3	applied	\N	\N	\N	\N	92281	92281	92282
20435	29872	4	applied	\N	\N	\N	\N	92283	92283	92284
20435	29873	5	applied	\N	\N	\N	\N	92285	92285	92286
20435	29874	6	applied	\N	\N	\N	\N	92287	92287	92288
20435	29875	7	applied	\N	\N	\N	\N	92289	92289	92290
20435	29876	8	applied	\N	\N	\N	\N	92291	92291	92292
20435	29877	9	applied	\N	\N	\N	\N	92293	92293	92294
20440	29879	0	applied	\N	\N	\N	\N	92303	92303	92304
20440	29880	1	applied	\N	\N	\N	\N	92305	92305	92306
20440	29881	2	applied	\N	\N	\N	\N	92307	92307	92308
20445	29885	0	applied	\N	\N	\N	\N	92321	92321	92322
20445	29886	1	applied	\N	\N	\N	\N	92323	92323	92324
20446	29887	0	applied	\N	\N	\N	\N	92330	92330	92331
20446	29888	1	applied	\N	\N	\N	\N	92332	92332	92333
20446	29889	2	applied	\N	\N	\N	\N	92334	92334	92335
20446	29890	3	applied	\N	\N	\N	\N	92336	92336	92337
20450	29891	0	applied	\N	\N	\N	\N	92340	92340	92341
20450	29892	1	applied	\N	\N	\N	\N	92342	92342	92343
20450	29893	2	applied	\N	\N	\N	\N	92344	92344	92345
20454	29897	0	applied	\N	\N	\N	\N	92359	92359	92360
20454	29898	1	applied	\N	\N	1000000000	\N	92361	92361	92362
20454	29899	2	applied	\N	\N	\N	\N	92363	92363	83176
20454	29900	3	applied	\N	\N	\N	\N	92364	92364	92365
20454	29901	4	applied	\N	\N	\N	\N	92366	92366	92367
20454	29902	5	applied	\N	\N	\N	\N	92368	92368	92369
20458	29906	0	applied	\N	\N	\N	\N	92382	92382	92383
20458	29907	1	applied	\N	\N	\N	\N	92384	92384	92385
20458	29908	2	applied	\N	\N	\N	\N	92386	92386	92387
20462	29912	0	applied	\N	\N	\N	\N	92403	92403	92404
20462	29913	1	applied	\N	\N	\N	\N	92405	92405	92406
20462	29914	2	applied	\N	\N	\N	\N	92407	92407	92408
20464	29915	0	applied	\N	\N	\N	\N	92412	92412	92413
20464	29916	1	applied	\N	\N	\N	\N	92414	92414	92415
20467	29898	0	applied	\N	\N	1000000000	\N	92361	92361	92362
20467	29782	1	applied	\N	\N	\N	\N	91990	91990	91991
20467	29785	2	applied	\N	\N	\N	\N	92003	92003	92004
20467	29787	3	applied	\N	\N	\N	\N	92045	92045	92046
20467	29790	4	applied	\N	\N	\N	\N	92052	92052	92053
20467	29793	5	applied	\N	\N	\N	\N	92069	92069	92070
20467	29794	6	applied	\N	\N	\N	\N	92071	92071	92072
20467	29795	7	applied	\N	\N	\N	\N	92073	92073	92074
20467	29796	8	applied	\N	\N	\N	\N	92075	92075	92076
20467	29805	9	applied	\N	\N	\N	\N	92097	92097	92098
20467	29808	10	applied	\N	\N	\N	\N	92105	92105	92106
20467	29809	11	applied	\N	\N	\N	\N	92107	92107	92108
20467	29814	12	applied	\N	\N	\N	\N	92119	92119	92120
20467	29820	13	applied	\N	\N	\N	\N	92138	92138	92139
20438	29870	1	applied	\N	\N	\N	\N	92279	92279	92280
20438	29878	2	applied	\N	\N	\N	\N	92296	92296	92297
20438	29871	3	applied	\N	\N	\N	\N	92281	92281	92282
20438	29872	4	applied	\N	\N	\N	\N	92283	92283	92284
20438	29873	5	applied	\N	\N	\N	\N	92285	92285	92286
20438	29874	6	applied	\N	\N	\N	\N	92287	92287	92298
20438	29875	7	applied	\N	\N	\N	\N	92289	92289	92290
20438	29876	8	applied	\N	\N	\N	\N	92291	92291	92292
20438	29877	9	applied	\N	\N	\N	\N	92293	92293	92294
20441	29879	0	applied	\N	\N	\N	\N	92303	92303	92304
20441	29880	1	applied	\N	\N	\N	\N	92305	92305	92306
20442	29882	0	applied	\N	\N	\N	\N	92314	92314	92315
20442	29883	1	applied	\N	\N	\N	\N	92316	92316	92317
20442	29884	2	applied	\N	\N	\N	\N	92318	92318	92319
20447	29891	0	applied	\N	\N	\N	\N	92340	92340	92341
20447	29892	1	applied	\N	\N	\N	\N	92342	92342	92343
20447	29893	2	applied	\N	\N	\N	\N	92344	92344	92345
20451	29894	0	applied	\N	\N	\N	\N	92352	92352	92353
20451	29895	1	applied	\N	\N	\N	\N	92354	92354	92355
20451	29896	2	applied	\N	\N	\N	\N	92356	92356	92357
20455	29897	0	applied	\N	\N	\N	\N	92359	92359	92360
20455	29898	1	applied	\N	\N	1000000000	\N	92361	92361	92362
20455	29899	2	applied	\N	\N	\N	\N	92363	92363	83176
20455	29900	3	applied	\N	\N	\N	\N	92364	92364	92365
20455	29901	4	applied	\N	\N	\N	\N	92366	92366	92367
20455	29902	5	applied	\N	\N	\N	\N	92368	92368	92369
20463	29912	0	applied	\N	\N	\N	\N	92403	92403	92404
20463	29913	1	applied	\N	\N	\N	\N	92405	92405	92406
20463	29914	2	applied	\N	\N	\N	\N	92407	92407	92408
20472	29933	0	applied	\N	\N	\N	\N	92505	92505	92506
20472	29934	1	applied	\N	\N	\N	\N	92507	92507	92508
20472	29935	2	applied	\N	\N	\N	\N	92509	92509	92510
20472	29936	3	applied	\N	\N	\N	\N	92511	92511	92512
20474	29937	0	applied	\N	\N	\N	\N	92517	92517	92518
20479	29943	0	applied	\N	\N	\N	\N	92568	92568	92569
20479	29944	1	applied	\N	\N	\N	\N	92570	92570	92571
20479	29945	2	applied	\N	\N	\N	\N	92572	92572	92573
20479	29946	3	applied	\N	\N	\N	\N	92574	92574	92575
20479	29947	4	applied	\N	\N	\N	\N	92576	92576	92577
20479	29948	5	applied	\N	\N	\N	\N	92578	92578	92579
20479	29949	6	applied	\N	\N	\N	\N	92580	92580	92581
20479	29950	7	applied	\N	\N	\N	\N	92582	92582	92583
20479	29951	8	applied	\N	\N	\N	\N	92584	92584	92585
20479	29952	9	applied	\N	\N	\N	\N	92586	92586	92587
20479	29953	10	applied	\N	\N	\N	\N	92588	92588	92589
20479	29954	11	applied	\N	\N	\N	\N	92590	92590	92591
20479	29955	12	applied	\N	\N	1000000000	\N	92592	92592	92593
20479	29956	13	applied	\N	\N	\N	\N	92594	92594	92595
20479	29957	14	applied	\N	\N	\N	\N	92596	92596	92597
20479	29958	15	applied	\N	\N	\N	\N	92598	92598	92599
20479	29959	16	applied	\N	\N	\N	\N	92600	92600	92601
20479	29960	17	applied	\N	\N	\N	\N	92602	92602	92603
20479	29961	18	applied	\N	\N	\N	\N	92604	92604	92605
20479	29962	19	applied	\N	\N	\N	\N	92606	92606	92607
20479	29963	20	applied	\N	\N	\N	\N	92608	92608	92609
20479	29964	21	applied	\N	\N	\N	\N	92610	92610	92611
20479	29965	22	applied	\N	\N	\N	\N	92612	92612	92613
20479	29966	23	applied	\N	\N	\N	\N	92614	92614	92615
20479	29967	24	applied	\N	\N	\N	\N	92616	92616	92617
20479	29968	25	applied	\N	\N	\N	\N	92618	92618	92619
20483	29971	0	applied	\N	\N	\N	\N	92629	92629	92630
20483	29972	1	applied	\N	\N	\N	\N	92631	92631	92632
20483	29973	2	applied	\N	\N	\N	\N	92633	92633	92634
20483	29974	3	applied	\N	\N	\N	\N	92635	92635	92636
20483	29975	4	applied	\N	\N	\N	\N	92637	92637	92638
20486	29943	0	applied	\N	\N	\N	\N	92568	92568	92569
20486	29944	1	applied	\N	\N	\N	\N	92570	92570	92571
20486	29945	2	applied	\N	\N	\N	\N	92572	92572	92573
20486	29946	3	applied	\N	\N	\N	\N	92574	92574	92575
20486	29947	4	applied	\N	\N	\N	\N	92576	92576	92577
20486	29948	5	applied	\N	\N	\N	\N	92578	92578	92579
20486	29949	6	applied	\N	\N	\N	\N	92580	92580	92581
20486	29950	7	applied	\N	\N	\N	\N	92582	92582	92583
20486	29951	8	applied	\N	\N	\N	\N	92584	92584	92585
20486	29952	9	applied	\N	\N	\N	\N	92586	92586	92587
20486	29953	10	applied	\N	\N	\N	\N	92588	92588	92589
20486	29969	11	applied	\N	\N	\N	\N	92623	92623	92624
20486	29954	12	applied	\N	\N	\N	\N	92590	92590	92591
20486	29955	13	applied	\N	\N	1000000000	\N	92592	92592	92593
20486	29956	14	applied	\N	\N	\N	\N	92594	92594	92595
20486	29957	15	applied	\N	\N	\N	\N	92596	92596	92597
20486	29958	16	applied	\N	\N	\N	\N	92598	92598	92599
20486	29959	17	applied	\N	\N	\N	\N	92600	92600	92601
20486	29960	18	applied	\N	\N	\N	\N	92602	92602	92603
20486	29961	19	applied	\N	\N	\N	\N	92604	92604	92605
20486	29962	20	applied	\N	\N	\N	\N	92606	92606	92607
20486	29974	21	applied	\N	\N	\N	\N	92635	92635	92645
20486	29963	22	applied	\N	\N	\N	\N	92608	92608	92646
20486	29964	23	applied	\N	\N	\N	\N	92610	92610	92647
20486	29973	24	applied	\N	\N	\N	\N	92633	92633	92615
20486	29965	25	applied	\N	\N	\N	\N	92612	92612	92617
20486	29966	26	applied	\N	\N	\N	\N	92614	92614	92619
20486	29967	27	applied	\N	\N	\N	\N	92616	92616	92626
20486	29968	28	applied	\N	\N	\N	\N	92618	92618	92648
20486	29970	29	applied	\N	\N	\N	\N	92625	92625	92636
20488	29976	0	applied	\N	\N	\N	\N	92650	92650	92651
20488	29977	1	applied	\N	\N	\N	\N	92652	92652	92653
20488	29978	2	applied	\N	\N	\N	\N	92654	92654	92655
20488	29979	3	applied	\N	\N	\N	\N	92656	92656	92657
20488	29980	4	applied	\N	\N	\N	\N	92658	92658	92659
20488	29981	5	applied	\N	\N	\N	\N	92660	92660	92661
20491	29982	0	applied	\N	\N	\N	\N	92666	92666	92667
20491	29983	1	applied	\N	\N	\N	\N	92668	92668	92669
20491	29984	2	applied	\N	\N	\N	\N	92670	92670	92671
20494	29998	0	applied	\N	\N	\N	\N	92705	92705	92706
20494	29999	1	applied	\N	\N	\N	\N	92707	92707	92708
20494	30000	2	applied	\N	\N	\N	\N	92709	92709	92710
20497	30002	0	applied	\N	\N	\N	\N	92715	92715	92716
20498	30001	0	applied	\N	\N	\N	\N	92713	92713	92714
20498	30002	1	applied	\N	\N	\N	\N	92715	92715	92716
20503	30010	0	applied	\N	\N	\N	\N	92740	92740	92741
20503	30011	1	applied	\N	\N	\N	\N	92742	92742	92743
20503	30012	2	applied	\N	\N	\N	\N	92744	92744	92745
20508	29943	0	applied	\N	\N	\N	\N	92758	92758	92569
20508	29944	1	applied	\N	\N	\N	\N	92759	92759	92571
20508	29945	2	applied	\N	\N	\N	\N	92760	92760	92573
20508	29946	3	applied	\N	\N	\N	\N	92761	92761	92575
20508	29898	4	applied	\N	\N	1000000000	\N	92361	92361	92362
20508	29731	5	applied	\N	\N	\N	\N	91853	91853	91325
20467	29825	14	applied	\N	\N	\N	\N	92150	92150	92151
20467	29826	15	applied	\N	\N	\N	\N	92152	92152	92153
20467	29835	16	applied	\N	\N	\N	\N	92177	92177	92178
20467	29840	17	applied	\N	\N	\N	\N	92192	92192	92193
20467	29841	18	applied	\N	\N	\N	\N	92194	92194	92195
20467	29846	19	applied	\N	\N	\N	\N	92208	92208	92209
20467	29849	20	applied	\N	\N	\N	\N	92215	92215	92216
20467	29852	21	applied	\N	\N	\N	\N	92223	92223	92224
20467	29856	22	applied	\N	\N	\N	\N	92244	92244	92245
20467	29857	23	applied	\N	\N	\N	\N	92246	92246	92247
20467	29863	24	applied	\N	\N	\N	\N	92260	92260	92261
20467	29869	25	applied	\N	\N	\N	\N	92277	92277	92278
20467	29879	26	applied	\N	\N	\N	\N	92303	92303	92304
20467	29882	27	applied	\N	\N	\N	\N	92314	92314	92315
20467	29885	28	applied	\N	\N	\N	\N	92321	92321	92322
20467	29887	29	applied	\N	\N	\N	\N	92330	92330	92331
20467	29891	30	applied	\N	\N	\N	\N	92340	92340	92341
20467	29894	31	applied	\N	\N	\N	\N	92352	92352	92353
20467	29897	32	applied	\N	\N	\N	\N	92359	92359	92360
20467	29903	33	applied	\N	\N	\N	\N	92376	92376	92377
20467	29906	34	applied	\N	\N	\N	\N	92382	92382	92383
20467	29909	35	applied	\N	\N	\N	\N	92395	92395	92396
20467	29912	36	applied	\N	\N	\N	\N	92403	92403	92404
20467	29915	37	applied	\N	\N	\N	\N	92412	92412	92413
20467	29864	38	applied	\N	\N	\N	\N	92262	92262	92263
20467	29899	39	applied	\N	\N	\N	\N	92431	92431	83176
20467	29815	40	applied	\N	\N	\N	\N	92121	92121	92432
20467	29866	41	applied	\N	\N	\N	\N	92266	92266	92267
20467	29827	42	applied	\N	\N	\N	\N	92154	92154	92433
20467	29847	43	applied	\N	\N	\N	\N	92210	92210	92434
20467	29859	44	applied	\N	\N	\N	\N	92250	92250	91993
20467	29870	45	applied	\N	\N	\N	\N	92279	92279	92435
20467	29888	46	applied	\N	\N	\N	\N	92332	92332	91995
20467	29783	47	applied	\N	\N	\N	\N	91992	91992	92436
20467	29784	48	applied	\N	\N	\N	\N	91994	91994	92437
20467	29786	49	applied	\N	\N	\N	\N	92005	92005	92050
20467	29788	50	applied	\N	\N	\N	\N	92047	92047	92065
20467	29791	51	applied	\N	\N	\N	\N	92064	92064	92438
20467	29797	52	applied	\N	\N	\N	\N	92077	92077	92439
20467	29830	53	applied	\N	\N	1000000000	\N	92161	92161	92162
20467	29831	54	applied	\N	\N	1000000000	\N	92163	92163	92164
20467	29832	55	applied	\N	\N	1000000000	\N	92165	92165	92166
20467	29837	56	applied	\N	\N	1000000000	\N	92181	92181	92182
20467	29839	57	applied	\N	\N	1000000000	\N	92185	92185	92186
20467	29867	58	applied	\N	\N	\N	\N	92268	92268	92269
20467	29871	59	applied	\N	\N	\N	\N	92281	92281	92282
20467	29872	60	applied	\N	\N	\N	\N	92283	92283	92284
20467	29873	61	applied	\N	\N	\N	\N	92285	92285	92286
20467	29875	62	applied	\N	\N	\N	\N	92289	92289	92290
20467	29876	63	applied	\N	\N	\N	\N	92291	92291	92292
20467	29799	64	applied	\N	\N	\N	\N	92081	92081	92440
20467	29902	65	applied	\N	\N	\N	\N	92368	92368	92441
20467	29911	66	applied	\N	\N	\N	\N	92399	92399	92080
20467	29789	67	applied	\N	\N	\N	\N	92049	92049	92442
20467	29800	68	applied	\N	\N	\N	\N	92083	92083	92443
20467	29801	69	applied	\N	\N	\N	\N	92085	92085	92444
20467	29806	70	applied	\N	\N	\N	\N	92099	92099	92088
20467	29816	71	applied	\N	\N	\N	\N	92123	92123	92124
20467	29817	72	applied	\N	\N	\N	\N	92125	92125	92126
20467	29821	73	applied	\N	\N	\N	\N	92140	92140	92141
20467	29922	74	applied	\N	\N	\N	\N	92445	92445	92241
20467	29812	75	applied	\N	\N	\N	\N	92113	92113	92446
20467	29813	76	applied	\N	\N	\N	\N	92115	92115	92447
20467	29819	77	applied	\N	\N	\N	\N	92131	92131	92092
20467	29824	78	applied	\N	\N	\N	\N	92146	92146	92100
20467	29828	79	applied	\N	\N	\N	\N	92157	92157	92448
20467	29829	80	applied	\N	\N	\N	\N	92159	92159	92449
20467	29836	81	applied	\N	\N	\N	\N	92179	92179	92110
20467	29842	82	applied	\N	\N	\N	\N	92196	92196	92450
20467	29845	83	applied	\N	\N	\N	\N	92202	92202	92451
20467	29848	84	applied	\N	\N	\N	\N	92212	92212	92452
20467	29851	85	applied	\N	\N	\N	\N	92219	92219	92453
20467	29854	86	applied	\N	\N	\N	\N	92228	92228	92128
20467	29861	87	applied	\N	\N	\N	\N	92254	92254	92133
20467	29862	88	applied	\N	\N	\N	\N	92256	92256	92454
20467	29865	89	applied	\N	\N	\N	\N	92264	92264	92155
20467	29878	90	applied	\N	\N	\N	\N	92296	92296	92156
20467	29881	91	applied	\N	\N	\N	\N	92307	92307	92158
20467	29883	92	applied	\N	\N	\N	\N	92316	92316	92160
20467	29886	93	applied	\N	\N	\N	\N	92323	92323	92455
20467	29890	94	applied	\N	\N	\N	\N	92336	92336	92456
20467	29892	95	applied	\N	\N	\N	\N	92342	92342	92170
20467	29895	96	applied	\N	\N	\N	\N	92354	92354	92180
20467	29900	97	applied	\N	\N	\N	\N	92364	92364	92457
20467	29905	98	applied	\N	\N	\N	\N	92380	92380	92458
20467	29908	99	applied	\N	\N	\N	\N	92386	92386	92459
20467	29910	101	applied	\N	\N	\N	\N	92397	92397	92199
20467	29913	102	applied	\N	\N	\N	\N	92405	92405	92461
20467	29917	103	applied	\N	\N	\N	\N	92418	92418	92462
20467	29921	104	applied	\N	\N	\N	\N	92427	92427	92211
20467	29877	105	applied	\N	\N	\N	\N	92293	92293	92294
20467	29792	106	applied	\N	\N	\N	\N	92066	92066	92463
20467	29798	107	applied	\N	\N	\N	\N	92079	92079	92464
20467	29802	108	applied	\N	\N	\N	\N	92087	92087	92465
20467	29803	109	applied	\N	\N	\N	\N	92089	92089	92229
20467	29804	110	applied	\N	\N	\N	\N	92091	92091	92249
20467	29807	111	applied	\N	\N	\N	\N	92101	92101	92466
20467	29810	112	applied	\N	\N	\N	\N	92109	92109	92255
20467	29811	113	applied	\N	\N	\N	\N	92111	92111	92467
20467	29818	114	applied	\N	\N	\N	\N	92127	92127	92468
20467	29823	115	applied	\N	\N	\N	\N	92144	92144	92469
20467	29833	116	applied	\N	\N	\N	\N	92167	92167	92470
20467	29834	117	applied	\N	\N	\N	\N	92169	92169	92471
20467	29838	118	applied	\N	\N	\N	\N	92183	92183	92308
20467	29843	119	applied	\N	\N	\N	\N	92198	92198	92472
20467	29844	120	applied	\N	\N	\N	\N	92200	92200	92473
20467	29850	121	applied	\N	\N	\N	\N	92217	92217	92474
20467	29853	122	applied	\N	\N	\N	\N	92225	92225	92475
20467	29858	123	applied	\N	\N	\N	\N	92248	92248	92343
20467	29860	124	applied	\N	\N	\N	\N	92252	92252	92345
20467	29868	125	applied	\N	\N	\N	\N	92270	92270	92476
20469	29923	0	applied	\N	\N	\N	\N	92479	92479	92480
20469	29924	1	applied	\N	\N	\N	\N	92481	92481	92482
20469	29925	2	applied	\N	\N	\N	\N	92483	92483	92484
20469	29926	3	applied	\N	\N	\N	\N	92485	92485	92486
20471	29930	0	applied	\N	\N	\N	\N	92498	92498	92499
20471	29931	1	applied	\N	\N	\N	\N	92500	92500	92501
20471	29932	2	applied	\N	\N	\N	\N	92502	92502	92503
20477	29939	0	applied	\N	\N	\N	\N	92524	92524	92525
20477	29940	1	applied	\N	\N	\N	\N	92526	92526	34803
20477	29941	2	applied	\N	\N	\N	\N	92527	92527	92528
20477	29942	3	applied	\N	\N	\N	\N	92529	92529	92530
20485	29971	0	applied	\N	\N	\N	\N	92629	92629	92630
20485	29972	1	applied	\N	\N	\N	\N	92631	92631	92632
20485	29973	2	applied	\N	\N	\N	\N	92633	92633	92634
20485	29974	3	applied	\N	\N	\N	\N	92635	92635	92636
20485	29975	4	applied	\N	\N	\N	\N	92637	92637	92638
20490	29982	0	applied	\N	\N	\N	\N	92666	92666	92667
20490	29983	1	applied	\N	\N	\N	\N	92668	92668	92669
20490	29984	2	applied	\N	\N	\N	\N	92670	92670	92671
20493	29994	0	applied	\N	\N	\N	\N	92695	92695	92696
20493	29995	1	applied	\N	\N	\N	\N	92697	92697	92698
20493	29996	2	applied	\N	\N	\N	\N	92699	92699	92700
20493	29997	3	applied	\N	\N	\N	\N	92701	92701	92702
20496	30001	0	applied	\N	\N	\N	\N	92713	92713	92714
20496	30002	1	applied	\N	\N	\N	\N	92715	92715	92716
20501	30003	0	applied	\N	\N	\N	\N	92722	92722	92723
20501	30004	1	applied	\N	\N	\N	\N	92724	92724	92725
20501	30005	2	applied	\N	\N	\N	\N	92726	92726	92727
20501	30006	3	applied	\N	\N	\N	\N	92728	92728	92729
20502	30007	0	applied	\N	\N	\N	\N	92734	92734	92735
20502	30008	1	applied	\N	\N	\N	\N	92736	92736	92737
20502	30009	2	applied	\N	\N	\N	\N	92738	92738	92739
20507	30013	0	applied	\N	\N	\N	\N	92748	92748	92749
20507	30014	1	applied	\N	\N	\N	\N	92750	92750	92751
20507	30015	2	applied	\N	\N	\N	\N	92752	92752	92753
20507	30016	3	applied	\N	\N	\N	\N	92754	92754	92755
20511	30018	0	applied	\N	\N	\N	\N	92771	92771	92772
20511	30019	1	applied	\N	\N	\N	\N	92773	92773	92774
20519	30045	0	applied	\N	\N	\N	\N	92839	92839	92840
20519	30046	1	applied	\N	\N	\N	\N	92841	92841	92842
20519	30049	2	applied	\N	\N	\N	\N	92848	92848	92849
20519	30050	3	applied	\N	\N	\N	\N	92850	92850	92851
20519	30047	4	applied	\N	\N	\N	\N	92843	92843	92852
20519	30048	5	applied	\N	\N	\N	\N	92845	92845	92853
20523	30051	0	applied	\N	\N	\N	\N	92858	92858	92859
20523	30052	1	applied	\N	\N	\N	\N	92860	92860	92861
20523	30053	2	applied	\N	\N	\N	\N	92862	92862	92863
20523	30054	3	applied	\N	\N	\N	\N	92864	92864	92865
20529	30080	0	applied	\N	\N	\N	\N	92923	92923	92924
20529	30081	1	applied	\N	\N	\N	\N	92925	92925	92926
20529	30082	2	applied	\N	\N	\N	\N	92927	92927	92928
20529	30083	3	applied	\N	\N	\N	\N	92929	92929	92930
20530	30084	0	applied	\N	\N	\N	\N	92933	92933	92934
20530	30085	1	applied	\N	\N	\N	\N	92935	92935	92936
20530	30086	2	applied	\N	\N	\N	\N	92937	92937	92938
20534	30087	0	applied	\N	\N	\N	\N	92942	92942	92943
20534	30088	1	applied	\N	\N	\N	\N	92944	92944	92945
20534	30089	2	applied	\N	\N	\N	\N	92946	92946	92947
20534	30090	3	applied	\N	\N	\N	\N	92948	92948	92949
20534	30091	4	applied	\N	\N	\N	\N	92950	92950	92951
20540	30101	0	applied	\N	\N	\N	\N	92985	92985	92986
20540	30102	1	applied	\N	\N	\N	\N	92987	92987	92988
20540	30103	2	applied	\N	\N	\N	\N	92989	92989	92990
20540	30104	3	applied	\N	\N	\N	\N	92991	92991	92992
20540	30105	4	applied	\N	\N	\N	\N	92993	92993	92994
20541	30106	0	applied	\N	\N	\N	\N	92995	92995	92996
20541	30107	1	applied	\N	\N	\N	\N	92997	92997	92998
20553	30134	0	applied	\N	\N	\N	\N	93064	93064	93065
20553	30135	1	applied	\N	\N	\N	\N	93066	93066	93067
20553	30136	2	applied	\N	\N	\N	\N	93068	93068	93069
20557	30137	0	applied	\N	\N	\N	\N	93076	93076	93077
20557	30138	1	applied	\N	\N	\N	\N	93078	93078	93079
20557	30140	2	applied	\N	\N	\N	\N	93082	93082	93087
20558	30141	0	applied	\N	\N	\N	\N	93089	93089	93090
20558	30142	1	applied	\N	\N	\N	\N	93091	93091	93092
20558	30143	2	applied	\N	\N	\N	\N	93093	93093	93094
20558	30144	3	applied	\N	\N	\N	\N	93095	93095	93096
20558	30145	4	applied	\N	\N	\N	\N	93097	93097	93098
20558	30146	5	applied	\N	\N	\N	\N	93099	93099	93100
20558	30147	6	applied	\N	\N	\N	\N	93101	93101	93102
20558	30148	7	applied	\N	\N	\N	\N	93103	93103	93104
20558	30149	8	applied	\N	\N	\N	\N	93105	93105	93106
20558	30150	9	applied	\N	\N	\N	\N	93107	93107	93108
20558	30151	10	applied	\N	\N	\N	\N	93109	93109	93110
20558	30152	11	applied	\N	\N	\N	\N	93111	93111	93112
20558	30153	12	applied	\N	\N	\N	\N	93113	93113	93114
20558	30154	13	applied	\N	\N	\N	\N	93115	93115	93116
20563	30156	0	applied	\N	\N	\N	\N	93141	93141	93142
20563	30157	1	applied	\N	\N	\N	\N	93143	93143	93144
20563	30158	2	applied	\N	\N	\N	\N	93145	93145	93146
20568	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20568	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20568	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20568	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20568	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20568	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20568	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20568	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20572	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20572	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20572	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20572	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20572	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20572	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20572	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20572	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20478	29752	3	applied	\N	\N	\N	\N	91909	91909	91910
20478	29754	4	applied	\N	\N	\N	\N	91915	91915	91916
20478	29758	5	applied	\N	\N	\N	\N	91931	91931	91932
20478	29761	6	applied	\N	\N	\N	\N	91941	91941	91942
20478	29762	7	applied	\N	\N	\N	\N	91943	91943	91944
20478	29763	8	applied	\N	\N	\N	\N	91945	91945	91946
20478	29770	9	applied	\N	\N	\N	\N	91960	91960	91961
20478	29773	10	applied	\N	\N	\N	\N	91968	91968	91969
20478	29774	11	applied	\N	\N	\N	\N	91970	91970	91971
20478	29775	12	applied	\N	\N	\N	\N	91972	91972	91973
20478	29782	13	applied	\N	\N	\N	\N	91990	91990	91991
20478	29785	14	applied	\N	\N	\N	\N	92003	92003	92004
20478	29787	15	applied	\N	\N	\N	\N	92045	92045	92046
20478	29790	16	applied	\N	\N	\N	\N	92052	92052	92053
20478	29793	17	applied	\N	\N	\N	\N	92069	92069	92070
20478	29794	18	applied	\N	\N	\N	\N	92071	92071	92072
20478	29795	19	applied	\N	\N	\N	\N	92073	92073	92074
20478	29796	20	applied	\N	\N	\N	\N	92075	92075	92076
20478	29805	21	applied	\N	\N	\N	\N	92097	92097	92098
20478	29940	22	applied	\N	\N	\N	\N	92526	92526	34803
20478	29808	23	applied	\N	\N	\N	\N	92105	92105	92106
20478	29809	24	applied	\N	\N	\N	\N	92107	92107	92108
20478	29814	25	applied	\N	\N	\N	\N	92119	92119	92120
20478	29820	26	applied	\N	\N	\N	\N	92138	92138	92139
20478	29825	27	applied	\N	\N	\N	\N	92150	92150	92151
20478	29826	28	applied	\N	\N	\N	\N	92152	92152	92153
20478	29835	29	applied	\N	\N	\N	\N	92177	92177	92178
20478	29840	30	applied	\N	\N	\N	\N	92192	92192	92193
20478	29841	31	applied	\N	\N	\N	\N	92194	92194	92195
20478	29846	32	applied	\N	\N	\N	\N	92208	92208	92209
20478	29849	33	applied	\N	\N	\N	\N	92215	92215	92216
20478	29852	34	applied	\N	\N	\N	\N	92223	92223	92224
20478	29856	35	applied	\N	\N	\N	\N	92244	92244	92245
20478	29857	36	applied	\N	\N	\N	\N	92246	92246	92247
20478	29863	37	applied	\N	\N	\N	\N	92260	92260	92261
20478	29869	38	applied	\N	\N	\N	\N	92277	92277	92278
20478	29879	39	applied	\N	\N	\N	\N	92303	92303	92304
20478	29882	40	applied	\N	\N	\N	\N	92314	92314	92315
20478	29885	41	applied	\N	\N	\N	\N	92321	92321	92322
20478	29887	42	applied	\N	\N	\N	\N	92330	92330	92331
20478	29891	43	applied	\N	\N	\N	\N	92340	92340	92341
20478	29894	44	applied	\N	\N	\N	\N	92352	92352	92353
20478	29897	45	applied	\N	\N	\N	\N	92359	92359	92360
20478	29903	46	applied	\N	\N	\N	\N	92376	92376	92377
20478	29906	47	applied	\N	\N	\N	\N	92382	92382	92383
20478	29909	48	applied	\N	\N	\N	\N	92395	92395	92396
20478	29912	49	applied	\N	\N	\N	\N	92403	92403	92404
20478	29915	50	applied	\N	\N	\N	\N	92412	92412	92413
20478	29919	51	applied	\N	\N	\N	\N	92422	92422	92423
20478	29923	52	applied	\N	\N	\N	\N	92479	92479	92480
20478	29927	53	applied	\N	\N	\N	\N	92490	92490	92491
20478	29930	54	applied	\N	\N	\N	\N	92498	92498	92499
20478	29933	55	applied	\N	\N	\N	\N	92505	92505	92506
20478	29938	56	applied	\N	\N	\N	\N	92521	92521	92522
20478	29864	57	applied	\N	\N	\N	\N	92535	92535	92263
20478	29899	58	applied	\N	\N	\N	\N	92431	92431	83176
20478	29815	59	applied	\N	\N	\N	\N	92536	92536	92432
20478	29866	60	applied	\N	\N	\N	\N	92537	92537	92267
20478	29827	61	applied	\N	\N	\N	\N	92154	92154	92538
20478	29847	62	applied	\N	\N	\N	\N	92210	92210	92056
20478	29859	63	applied	\N	\N	\N	\N	92250	92250	91899
20478	29870	64	applied	\N	\N	\N	\N	92279	92279	92057
20478	29888	65	applied	\N	\N	\N	\N	92332	92332	91901
20478	29747	67	applied	\N	\N	\N	\N	91898	91898	92059
20478	29751	68	applied	\N	\N	\N	\N	91906	91906	92540
20478	29755	69	applied	\N	\N	\N	\N	91917	91917	92060
20478	29748	70	applied	\N	\N	\N	\N	91900	91900	92061
20478	29750	71	applied	\N	\N	\N	\N	91904	91904	92541
20478	29830	72	applied	\N	\N	1000000000	\N	92161	92161	92162
20478	29831	73	applied	\N	\N	1000000000	\N	92163	92163	92164
20478	29832	74	applied	\N	\N	1000000000	\N	92165	92165	92166
20478	29837	75	applied	\N	\N	1000000000	\N	92181	92181	92182
20478	29839	76	applied	\N	\N	1000000000	\N	92185	92185	92186
20478	29867	77	applied	\N	\N	\N	\N	92542	92542	92269
20478	29871	78	applied	\N	\N	\N	\N	92543	92543	92282
20478	29872	79	applied	\N	\N	\N	\N	92544	92544	92284
20478	29873	80	applied	\N	\N	\N	\N	92545	92545	92286
20478	29875	81	applied	\N	\N	\N	\N	92546	92546	92290
20478	29876	82	applied	\N	\N	\N	\N	92547	92547	92292
20478	29760	83	applied	\N	\N	\N	\N	91935	91935	92548
20478	29765	84	applied	\N	\N	\N	\N	91949	91949	91948
20478	29766	85	applied	\N	\N	\N	\N	91951	91951	91950
20478	29767	86	applied	\N	\N	\N	\N	91953	91953	91952
20478	29771	87	applied	\N	\N	\N	\N	91962	91962	91954
20478	29777	88	applied	\N	\N	\N	\N	91976	91976	92549
20478	29778	89	applied	\N	\N	\N	\N	91978	91978	92550
20478	29779	90	applied	\N	\N	\N	\N	91980	91980	91965
20478	29783	91	applied	\N	\N	\N	\N	91992	91992	92551
20478	29902	92	applied	\N	\N	\N	\N	92368	92368	92552
20478	29911	93	applied	\N	\N	\N	\N	92399	92399	91977
20478	29924	94	applied	\N	\N	\N	\N	92481	92481	92553
20478	29936	95	applied	\N	\N	\N	\N	92511	92511	92554
20478	29789	96	applied	\N	\N	\N	\N	92049	92049	92555
20478	29753	97	applied	\N	\N	\N	\N	91911	91911	92556
20478	29756	98	applied	\N	\N	\N	\N	91919	91919	92557
20478	29759	99	applied	\N	\N	\N	\N	91933	91933	92433
20478	29764	100	applied	\N	\N	\N	\N	91947	91947	91993
20478	29768	101	applied	\N	\N	\N	\N	91955	91955	91995
20478	29769	102	applied	\N	\N	\N	\N	91957	91957	92006
20478	29772	103	applied	\N	\N	\N	\N	91964	91964	92048
20478	29776	104	applied	\N	\N	\N	\N	91974	91974	92558
20478	29780	105	applied	\N	\N	\N	\N	91982	91982	92559
20478	29781	106	applied	\N	\N	\N	\N	91984	91984	92560
20478	29784	107	applied	\N	\N	\N	\N	91994	91994	92067
20478	29786	108	applied	\N	\N	\N	\N	92005	92005	92078
20478	29788	109	applied	\N	\N	\N	\N	92047	92047	92441
20478	29791	110	applied	\N	\N	\N	\N	92064	92064	92561
20478	29797	111	applied	\N	\N	\N	\N	92077	92077	92442
20478	29799	112	applied	\N	\N	\N	\N	92081	92081	92443
20478	29800	113	applied	\N	\N	\N	\N	92083	92083	92444
20478	29801	114	applied	\N	\N	\N	\N	92085	92085	92088
20478	29806	115	applied	\N	\N	\N	\N	92099	92099	92446
20478	29816	116	applied	\N	\N	\N	\N	92562	92562	92124
20478	29817	117	applied	\N	\N	\N	\N	92563	92563	92126
20478	29821	118	applied	\N	\N	\N	\N	92564	92564	92141
20478	29922	119	applied	\N	\N	\N	\N	92565	92565	92241
20478	29812	120	applied	\N	\N	\N	\N	92113	92113	92447
20478	29813	121	applied	\N	\N	\N	\N	92115	92115	92092
20478	29819	122	applied	\N	\N	\N	\N	92131	92131	92100
20478	29824	123	applied	\N	\N	\N	\N	92146	92146	92448
20478	29828	124	applied	\N	\N	\N	\N	92157	92157	92449
20478	29829	125	applied	\N	\N	\N	\N	92159	92159	92110
20481	29969	0	applied	\N	\N	\N	\N	92623	92623	92624
20481	29970	1	applied	\N	\N	\N	\N	92625	92625	92626
20484	29971	0	applied	\N	\N	\N	\N	92629	92629	92630
20484	29972	1	applied	\N	\N	\N	\N	92631	92631	92632
20484	29973	2	applied	\N	\N	\N	\N	92633	92633	92634
20484	29974	3	applied	\N	\N	\N	\N	92635	92635	92636
20484	29975	4	applied	\N	\N	\N	\N	92637	92637	92638
20489	29978	0	applied	\N	\N	\N	\N	92654	92654	92655
20489	29979	1	applied	\N	\N	\N	\N	92656	92656	92657
20489	29980	2	applied	\N	\N	\N	\N	92658	92658	92659
20489	29981	3	applied	\N	\N	\N	\N	92660	92660	92661
20492	29985	0	applied	\N	\N	\N	\N	92676	92676	92677
20492	29986	1	applied	\N	\N	\N	\N	92678	92678	92679
20492	29987	2	applied	\N	\N	\N	\N	92680	92680	92681
20492	29988	3	applied	\N	\N	\N	\N	92682	92682	92683
20492	29989	4	applied	\N	\N	\N	\N	92684	92684	92685
20492	29990	5	applied	\N	\N	\N	\N	92686	92686	92687
20492	29991	6	applied	\N	\N	\N	\N	92688	92688	92689
20492	29992	7	applied	\N	\N	\N	\N	92690	92690	92691
20492	29993	8	applied	\N	\N	\N	\N	92692	92692	92693
20499	30003	0	applied	\N	\N	\N	\N	92722	92722	92723
20499	30004	1	applied	\N	\N	\N	\N	92724	92724	92725
20499	30005	2	applied	\N	\N	\N	\N	92726	92726	92727
20499	30006	3	applied	\N	\N	\N	\N	92728	92728	92729
20509	30015	0	applied	\N	\N	\N	\N	92752	92752	92766
20509	30016	1	applied	\N	\N	\N	\N	92754	92754	92767
20513	30020	0	applied	\N	\N	\N	\N	92778	92778	92779
20513	30022	1	applied	\N	\N	\N	\N	92783	92783	92784
20513	30021	2	applied	\N	\N	\N	\N	92780	92780	92785
20517	30023	0	applied	\N	\N	\N	\N	92786	92786	92787
20517	30024	1	applied	\N	\N	\N	\N	92788	92788	92789
20517	30025	2	applied	\N	\N	\N	\N	92790	92790	92791
20517	30026	3	applied	\N	\N	\N	\N	92792	92792	92793
20517	30027	4	applied	\N	\N	\N	\N	92794	92794	92795
20517	30028	5	applied	\N	\N	\N	\N	92796	92796	92797
20517	30029	6	applied	\N	\N	\N	\N	92798	92798	92799
20517	30030	7	applied	\N	\N	\N	\N	92800	92800	92801
20517	30031	8	applied	\N	\N	\N	\N	92802	92802	92803
20517	30032	9	applied	\N	\N	\N	\N	92804	92804	92805
20517	30033	10	applied	\N	\N	\N	\N	92806	92806	92807
20517	30034	12	applied	\N	\N	\N	\N	92809	92809	92810
20517	30035	13	applied	\N	\N	\N	\N	92811	92811	92812
20517	30036	14	applied	\N	\N	\N	\N	92813	92813	92814
20517	30037	15	applied	\N	\N	\N	\N	92815	92815	92816
20517	30038	16	applied	\N	\N	\N	\N	92817	92817	92818
20517	30039	17	applied	\N	\N	\N	\N	92819	92819	92820
20517	30040	18	applied	\N	\N	\N	\N	92821	92821	92822
20517	30041	19	applied	\N	\N	\N	\N	92823	92823	92824
20517	30042	20	applied	\N	\N	\N	\N	92825	92825	92826
20517	30043	21	applied	\N	\N	\N	\N	92827	92827	92828
20517	30044	22	applied	\N	\N	1000000000	\N	92829	92829	92830
20518	30045	0	applied	\N	\N	\N	\N	92839	92839	92840
20518	30046	1	applied	\N	\N	\N	\N	92841	92841	92842
20518	30047	2	applied	\N	\N	\N	\N	92843	92843	92844
20518	30048	3	applied	\N	\N	\N	\N	92845	92845	92846
20522	30051	0	applied	\N	\N	\N	\N	92858	92858	92859
20522	30052	1	applied	\N	\N	\N	\N	92860	92860	92861
20522	30053	2	applied	\N	\N	\N	\N	92862	92862	92863
20522	30054	3	applied	\N	\N	\N	\N	92864	92864	92865
20528	30080	0	applied	\N	\N	\N	\N	92923	92923	92924
20528	30081	1	applied	\N	\N	\N	\N	92925	92925	92926
20528	30082	2	applied	\N	\N	\N	\N	92927	92927	92928
20528	30083	3	applied	\N	\N	\N	\N	92929	92929	92930
20533	30087	0	applied	\N	\N	\N	\N	92942	92942	92943
20533	30088	1	applied	\N	\N	\N	\N	92944	92944	92945
20533	30089	2	applied	\N	\N	\N	\N	92946	92946	92947
20533	30090	3	applied	\N	\N	\N	\N	92948	92948	92949
20533	30091	4	applied	\N	\N	\N	\N	92950	92950	92951
20538	30092	0	applied	\N	\N	\N	\N	92964	92964	92965
20538	30093	1	applied	\N	\N	\N	\N	92966	92966	92967
20538	30094	2	applied	\N	\N	\N	\N	92968	92968	92969
20538	30095	3	applied	\N	\N	\N	\N	92970	92970	92971
20538	30096	4	applied	\N	\N	\N	\N	92972	92972	92973
20538	30097	5	applied	\N	\N	\N	\N	92974	92974	92975
20539	30098	0	applied	\N	\N	\N	\N	92977	92977	92978
20539	30099	1	applied	\N	\N	\N	\N	92979	92979	92980
20539	30100	2	applied	\N	\N	\N	\N	92981	92981	92982
20546	30124	0	applied	\N	\N	\N	\N	93036	93036	93037
20546	30125	1	applied	\N	\N	\N	\N	93038	93038	93039
20546	30126	2	applied	\N	\N	\N	\N	93040	93040	93041
20547	30124	0	applied	\N	\N	\N	\N	93036	93036	93037
20547	30125	1	applied	\N	\N	\N	\N	93038	93038	93039
20547	30126	2	applied	\N	\N	\N	\N	93040	93040	93041
20551	30127	0	applied	\N	\N	\N	\N	93049	93049	93050
20551	30128	1	applied	\N	\N	\N	\N	93051	93051	93052
20551	30129	2	applied	\N	\N	\N	\N	93053	93053	93054
20551	30130	3	applied	\N	\N	\N	\N	93055	93055	93056
20551	30131	4	applied	\N	\N	\N	\N	93057	93057	93058
20551	30132	5	applied	\N	\N	\N	\N	93059	93059	93060
20551	30133	6	applied	\N	\N	\N	\N	93061	93061	93062
20552	30134	0	applied	\N	\N	\N	\N	93064	93064	93065
20552	30135	1	applied	\N	\N	\N	\N	93066	93066	93067
20552	30136	2	applied	\N	\N	\N	\N	93068	93068	93069
20556	30137	0	applied	\N	\N	\N	\N	93076	93076	93077
20556	30138	1	applied	\N	\N	\N	\N	93078	93078	93079
20556	30139	2	applied	\N	\N	\N	\N	93080	93080	93081
20556	30140	3	applied	\N	\N	\N	\N	93082	93082	93083
20562	30157	0	applied	\N	\N	\N	\N	93143	93143	93144
20562	30158	1	applied	\N	\N	\N	\N	93145	93145	93146
20567	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20567	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20567	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20567	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20567	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20567	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20567	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20567	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20571	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20571	30162	1	applied	\N	\N	\N	\N	93161	93161	93162
20571	30163	2	applied	\N	\N	\N	\N	93163	93163	93164
20571	30164	3	applied	\N	\N	\N	\N	93165	93165	93166
20571	30165	4	applied	\N	\N	\N	\N	93167	93167	93168
20571	30166	5	applied	\N	\N	\N	\N	93169	93169	93170
20508	29971	6	applied	\N	\N	\N	\N	92629	92629	92762
20508	29569	7	applied	\N	\N	\N	\N	91353	91353	91354
20508	29572	8	applied	\N	\N	\N	\N	91361	91361	91362
20508	29576	9	applied	\N	\N	\N	\N	91374	91374	91375
20508	29577	10	applied	\N	\N	\N	\N	91376	91376	91377
20508	29578	11	applied	\N	\N	\N	\N	91378	91378	91379
20508	29586	12	applied	\N	\N	\N	\N	91402	91402	91403
20508	29594	13	applied	\N	\N	\N	\N	91424	91424	91425
20508	29595	14	applied	\N	\N	\N	\N	91426	91426	91427
20508	29600	15	applied	\N	\N	\N	\N	91438	91438	91439
20508	29604	16	applied	\N	\N	\N	\N	91454	91454	91455
20508	29605	17	applied	\N	\N	\N	\N	91456	91456	91457
20508	29609	18	applied	\N	\N	\N	\N	91489	91489	91490
20508	29940	19	applied	\N	\N	\N	\N	92526	92526	92762
20508	29949	21	applied	\N	\N	\N	\N	92580	92580	92630
20508	29613	22	applied	\N	\N	\N	\N	91501	91501	91502
20508	29616	23	applied	\N	\N	\N	\N	91509	91509	91510
20508	29619	24	applied	\N	\N	\N	\N	91515	91515	91516
20508	29620	25	applied	\N	\N	\N	\N	91517	91517	91518
20508	29626	26	applied	\N	\N	\N	\N	91530	91530	91531
20508	29627	27	applied	\N	\N	\N	\N	91532	91532	91533
20508	29632	28	applied	\N	\N	\N	\N	91544	91544	91545
20508	29636	29	applied	\N	\N	\N	\N	91554	91554	91555
20508	29642	30	applied	\N	\N	\N	\N	91582	91582	91583
20508	29643	31	applied	\N	\N	\N	\N	91584	91584	91585
20508	29647	32	applied	\N	\N	\N	\N	91596	91596	91597
20508	29648	33	applied	\N	\N	\N	\N	91598	91598	91599
20508	29653	34	applied	\N	\N	\N	\N	91609	91609	91610
20508	29656	35	applied	\N	\N	\N	\N	91619	91619	91620
20508	29657	36	applied	\N	\N	\N	\N	91621	91621	91622
20508	29658	37	applied	\N	\N	\N	\N	91623	91623	91624
20508	29665	38	applied	\N	\N	\N	\N	91638	91638	91639
20508	29668	39	applied	\N	\N	\N	\N	91646	91646	91647
20508	29671	40	applied	\N	\N	\N	\N	91660	91660	91661
20508	29673	41	applied	\N	\N	\N	\N	91666	91666	91667
20508	29676	42	applied	\N	\N	\N	\N	91680	91680	91681
20508	29679	43	applied	\N	\N	\N	\N	91687	91687	91688
20508	29680	44	applied	\N	\N	\N	\N	91689	91689	91690
20508	29685	45	applied	\N	\N	\N	\N	91700	91700	91701
20508	29688	46	applied	\N	\N	\N	\N	91729	91729	91730
20508	29692	47	applied	\N	\N	\N	\N	91739	91739	91740
20508	29698	48	applied	\N	\N	\N	\N	91754	91754	91755
20508	29701	49	applied	\N	\N	\N	\N	91760	91760	91761
20508	29705	50	applied	\N	\N	\N	\N	91771	91771	91772
20508	29707	51	applied	\N	\N	\N	\N	91777	91777	91778
20508	29708	52	applied	\N	\N	\N	\N	91779	91779	91780
20508	29713	53	applied	\N	\N	\N	\N	91789	91789	91790
20508	29730	54	applied	\N	\N	\N	\N	91828	91828	91829
20508	29734	55	applied	\N	\N	\N	\N	91836	91836	91837
20508	29737	56	applied	\N	\N	\N	\N	91844	91844	91845
20508	29740	57	applied	\N	\N	\N	\N	91854	91854	91855
20508	29741	58	applied	\N	\N	\N	\N	91856	91856	91857
20508	29746	59	applied	\N	\N	\N	\N	91896	91896	91897
20508	29749	60	applied	\N	\N	\N	\N	91902	91902	91903
20508	29752	61	applied	\N	\N	\N	\N	91909	91909	91910
20508	29754	62	applied	\N	\N	\N	\N	91915	91915	91916
20508	29758	63	applied	\N	\N	\N	\N	91931	91931	91932
20508	29761	64	applied	\N	\N	\N	\N	91941	91941	91942
20508	29762	65	applied	\N	\N	\N	\N	91943	91943	91944
20508	29763	66	applied	\N	\N	\N	\N	91945	91945	91946
20508	29770	67	applied	\N	\N	\N	\N	91960	91960	91961
20508	29773	68	applied	\N	\N	\N	\N	91968	91968	91969
20508	29774	69	applied	\N	\N	\N	\N	91970	91970	91971
20508	29775	70	applied	\N	\N	\N	\N	91972	91972	91973
20508	29782	71	applied	\N	\N	\N	\N	91990	91990	91991
20508	29785	72	applied	\N	\N	\N	\N	92003	92003	92004
20508	29787	73	applied	\N	\N	\N	\N	92045	92045	92046
20508	29790	74	applied	\N	\N	\N	\N	92052	92052	92053
20508	29793	75	applied	\N	\N	\N	\N	92069	92069	92070
20508	29794	76	applied	\N	\N	\N	\N	92071	92071	92072
20508	29795	77	applied	\N	\N	\N	\N	92073	92073	92074
20508	29796	78	applied	\N	\N	\N	\N	92075	92075	92076
20508	29805	79	applied	\N	\N	\N	\N	92097	92097	92098
20508	29808	80	applied	\N	\N	\N	\N	92105	92105	92106
20508	29809	81	applied	\N	\N	\N	\N	92107	92107	92108
20508	29814	82	applied	\N	\N	\N	\N	92119	92119	92120
20508	29820	83	applied	\N	\N	\N	\N	92138	92138	92139
20508	29825	84	applied	\N	\N	\N	\N	92150	92150	92151
20508	29826	85	applied	\N	\N	\N	\N	92152	92152	92153
20508	29835	86	applied	\N	\N	\N	\N	92177	92177	92178
20508	29840	87	applied	\N	\N	\N	\N	92192	92192	92193
20508	29841	88	applied	\N	\N	\N	\N	92194	92194	92195
20508	29846	89	applied	\N	\N	\N	\N	92208	92208	92209
20508	29849	90	applied	\N	\N	\N	\N	92215	92215	92216
20508	29852	91	applied	\N	\N	\N	\N	92223	92223	92224
20508	29856	92	applied	\N	\N	\N	\N	92244	92244	92245
20508	29857	93	applied	\N	\N	\N	\N	92246	92246	92247
20508	29863	94	applied	\N	\N	\N	\N	92260	92260	92261
20508	29869	95	applied	\N	\N	\N	\N	92277	92277	92278
20508	29879	96	applied	\N	\N	\N	\N	92303	92303	92304
20508	29882	97	applied	\N	\N	\N	\N	92314	92314	92315
20508	29885	98	applied	\N	\N	\N	\N	92321	92321	92322
20508	29887	99	applied	\N	\N	\N	\N	92330	92330	92331
20508	29891	100	applied	\N	\N	\N	\N	92340	92340	92341
20508	29894	101	applied	\N	\N	\N	\N	92352	92352	92353
20508	29897	102	applied	\N	\N	\N	\N	92359	92359	92360
20508	29903	103	applied	\N	\N	\N	\N	92376	92376	92377
20508	29906	104	applied	\N	\N	\N	\N	92382	92382	92383
20508	29909	105	applied	\N	\N	\N	\N	92395	92395	92396
20508	29912	106	applied	\N	\N	\N	\N	92403	92403	92404
20508	29915	107	applied	\N	\N	\N	\N	92412	92412	92413
20508	29919	108	applied	\N	\N	\N	\N	92422	92422	92423
20508	29923	109	applied	\N	\N	\N	\N	92479	92479	92480
20508	29927	110	applied	\N	\N	\N	\N	92490	92490	92491
20508	29930	111	applied	\N	\N	\N	\N	92498	92498	92499
20508	29933	112	applied	\N	\N	\N	\N	92505	92505	92506
20508	29938	113	applied	\N	\N	\N	\N	92521	92521	92522
20508	29939	114	applied	\N	\N	\N	\N	92524	92524	92525
20508	29947	115	applied	\N	\N	\N	\N	92576	92576	92577
20508	29948	116	applied	\N	\N	\N	\N	92578	92578	92579
20508	29950	117	applied	\N	\N	\N	\N	92582	92582	92583
20508	29951	118	applied	\N	\N	\N	\N	92584	92584	92585
20508	29952	119	applied	\N	\N	\N	\N	92586	92586	92587
20508	29953	120	applied	\N	\N	\N	\N	92588	92588	92589
20508	29969	121	applied	\N	\N	\N	\N	92623	92623	92624
20508	29972	122	applied	\N	\N	\N	\N	92631	92631	92632
20508	29976	123	applied	\N	\N	\N	\N	92650	92650	92651
20508	29977	124	applied	\N	\N	\N	\N	92652	92652	92653
20508	29982	125	applied	\N	\N	\N	\N	92666	92666	92667
20510	30017	0	applied	\N	\N	\N	\N	92769	92769	92770
20510	30018	1	applied	\N	\N	\N	\N	92771	92771	92772
20510	30019	2	applied	\N	\N	\N	\N	92773	92773	92774
20512	30020	0	applied	\N	\N	\N	\N	92778	92778	92779
20512	30021	1	applied	\N	\N	\N	\N	92780	92780	92781
20516	30023	0	applied	\N	\N	\N	\N	92786	92786	92787
20516	30024	1	applied	\N	\N	\N	\N	92788	92788	92789
20516	30025	2	applied	\N	\N	\N	\N	92790	92790	92791
20516	30026	3	applied	\N	\N	\N	\N	92792	92792	92793
20516	30027	4	applied	\N	\N	\N	\N	92794	92794	92795
20516	30028	5	applied	\N	\N	\N	\N	92796	92796	92797
20516	30029	6	applied	\N	\N	\N	\N	92798	92798	92799
20516	30030	7	applied	\N	\N	\N	\N	92800	92800	92801
20516	30031	8	applied	\N	\N	\N	\N	92802	92802	92803
20516	30032	9	applied	\N	\N	\N	\N	92804	92804	92805
20516	30033	10	applied	\N	\N	\N	\N	92806	92806	92807
20516	30034	12	applied	\N	\N	\N	\N	92809	92809	92810
20516	30035	13	applied	\N	\N	\N	\N	92811	92811	92812
20516	30036	14	applied	\N	\N	\N	\N	92813	92813	92814
20516	30037	15	applied	\N	\N	\N	\N	92815	92815	92816
20516	30038	16	applied	\N	\N	\N	\N	92817	92817	92818
20516	30039	17	applied	\N	\N	\N	\N	92819	92819	92820
20516	30040	18	applied	\N	\N	\N	\N	92821	92821	92822
20516	30041	19	applied	\N	\N	\N	\N	92823	92823	92824
20516	30042	20	applied	\N	\N	\N	\N	92825	92825	92826
20516	30043	21	applied	\N	\N	\N	\N	92827	92827	92828
20516	30044	22	applied	\N	\N	1000000000	\N	92829	92829	92830
20521	30045	0	applied	\N	\N	\N	\N	92839	92839	92840
20521	30046	1	applied	\N	\N	\N	\N	92841	92841	92842
20521	30049	2	applied	\N	\N	\N	\N	92848	92848	92849
20521	30050	3	applied	\N	\N	\N	\N	92850	92850	92851
20521	30047	4	applied	\N	\N	\N	\N	92843	92843	92852
20521	30048	5	applied	\N	\N	\N	\N	92845	92845	92853
20526	30068	0	applied	\N	\N	\N	\N	92896	92896	92897
20526	30069	1	applied	\N	\N	\N	\N	92898	92898	92899
20526	30070	2	applied	\N	\N	\N	\N	92900	92900	92901
20526	30071	3	applied	\N	\N	\N	\N	92902	92902	92903
20526	30072	4	applied	\N	\N	\N	\N	92904	92904	92905
20526	30073	5	applied	\N	\N	\N	\N	92906	92906	92907
20526	30074	6	applied	\N	\N	\N	\N	92908	92908	92909
20526	30075	7	applied	\N	\N	\N	\N	92910	92910	92911
20527	30076	0	applied	\N	\N	\N	\N	92913	92913	92914
20527	30077	1	applied	\N	\N	\N	\N	92915	92915	92916
20527	30078	2	applied	\N	\N	\N	\N	92917	92917	92918
20527	30079	3	applied	\N	\N	\N	\N	92919	92919	92920
20532	30087	0	applied	\N	\N	\N	\N	92942	92942	92943
20532	30088	1	applied	\N	\N	\N	\N	92944	92944	92945
20532	30089	2	applied	\N	\N	\N	\N	92946	92946	92947
20532	30090	3	applied	\N	\N	\N	\N	92948	92948	92949
20532	30091	4	applied	\N	\N	\N	\N	92950	92950	92951
20537	30092	0	applied	\N	\N	\N	\N	92964	92964	92965
20537	30093	1	applied	\N	\N	\N	\N	92966	92966	92967
20537	30094	2	applied	\N	\N	\N	\N	92968	92968	92969
20537	30095	3	applied	\N	\N	\N	\N	92970	92970	92971
20537	30096	4	applied	\N	\N	\N	\N	92972	92972	92973
20537	30097	5	applied	\N	\N	\N	\N	92974	92974	92975
20545	30124	0	applied	\N	\N	\N	\N	93036	93036	93037
20545	30125	1	applied	\N	\N	\N	\N	93038	93038	93039
20545	30126	2	applied	\N	\N	\N	\N	93040	93040	93041
20555	30137	0	applied	\N	\N	\N	\N	93076	93076	93077
20555	30138	1	applied	\N	\N	\N	\N	93078	93078	93079
20555	30139	2	applied	\N	\N	\N	\N	93080	93080	93081
20555	30140	3	applied	\N	\N	\N	\N	93082	93082	93083
20560	30141	0	applied	\N	\N	\N	\N	93089	93089	93090
20560	30142	1	applied	\N	\N	\N	\N	93091	93091	93092
20560	30143	2	applied	\N	\N	\N	\N	93093	93093	93094
20560	30144	3	applied	\N	\N	\N	\N	93095	93095	93096
20560	30145	4	applied	\N	\N	\N	\N	93097	93097	93098
20560	30146	5	applied	\N	\N	\N	\N	93099	93099	93100
20560	30147	6	applied	\N	\N	\N	\N	93101	93101	93102
20560	30148	7	applied	\N	\N	\N	\N	93103	93103	93104
20560	30149	8	applied	\N	\N	\N	\N	93105	93105	93106
20560	30150	9	applied	\N	\N	\N	\N	93107	93107	93108
20560	30151	10	applied	\N	\N	\N	\N	93109	93109	93110
20560	30152	11	applied	\N	\N	\N	\N	93111	93111	93112
20560	30153	12	applied	\N	\N	\N	\N	93113	93113	93114
20560	30154	13	applied	\N	\N	\N	\N	93115	93115	93116
20561	30156	0	applied	\N	\N	\N	\N	93141	93141	93142
20561	30157	1	applied	\N	\N	\N	\N	93143	93143	93144
20561	30158	2	applied	\N	\N	\N	\N	93145	93145	93146
20566	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20566	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20566	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20566	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20566	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20566	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20566	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20566	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20570	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20570	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20570	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20570	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20570	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20570	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20570	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20570	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20514	30020	0	applied	\N	\N	\N	\N	92778	92778	92779
20514	30022	1	applied	\N	\N	\N	\N	92783	92783	92784
20514	30021	2	applied	\N	\N	\N	\N	92780	92780	92785
20515	30023	0	applied	\N	\N	\N	\N	92786	92786	92787
20515	30024	1	applied	\N	\N	\N	\N	92788	92788	92789
20515	30025	2	applied	\N	\N	\N	\N	92790	92790	92791
20515	30026	3	applied	\N	\N	\N	\N	92792	92792	92793
20515	30027	4	applied	\N	\N	\N	\N	92794	92794	92795
20515	30028	5	applied	\N	\N	\N	\N	92796	92796	92797
20515	30029	6	applied	\N	\N	\N	\N	92798	92798	92799
20515	30030	7	applied	\N	\N	\N	\N	92800	92800	92801
20515	30031	8	applied	\N	\N	\N	\N	92802	92802	92803
20515	30032	9	applied	\N	\N	\N	\N	92804	92804	92805
20515	30033	10	applied	\N	\N	\N	\N	92806	92806	92807
20515	30034	12	applied	\N	\N	\N	\N	92809	92809	92810
20515	30035	13	applied	\N	\N	\N	\N	92811	92811	92812
20515	30036	14	applied	\N	\N	\N	\N	92813	92813	92814
20515	30037	15	applied	\N	\N	\N	\N	92815	92815	92816
20515	30038	16	applied	\N	\N	\N	\N	92817	92817	92818
20515	30039	17	applied	\N	\N	\N	\N	92819	92819	92820
20515	30040	18	applied	\N	\N	\N	\N	92821	92821	92822
20515	30041	19	applied	\N	\N	\N	\N	92823	92823	92824
20515	30042	20	applied	\N	\N	\N	\N	92825	92825	92826
20515	30043	21	applied	\N	\N	\N	\N	92827	92827	92828
20515	30044	22	applied	\N	\N	1000000000	\N	92829	92829	92830
20520	30045	0	applied	\N	\N	\N	\N	92839	92839	92840
20520	30046	1	applied	\N	\N	\N	\N	92841	92841	92842
20520	30049	2	applied	\N	\N	\N	\N	92848	92848	92849
20520	30050	3	applied	\N	\N	\N	\N	92850	92850	92851
20520	30047	4	applied	\N	\N	\N	\N	92843	92843	92852
20520	30048	5	applied	\N	\N	\N	\N	92845	92845	92853
20524	30051	0	applied	\N	\N	\N	\N	92858	92858	92859
20524	30052	1	applied	\N	\N	\N	\N	92860	92860	92861
20524	30053	2	applied	\N	\N	\N	\N	92862	92862	92863
20524	30054	3	applied	\N	\N	\N	\N	92864	92864	92865
20525	30055	0	applied	\N	\N	\N	\N	92869	92869	92870
20525	30056	1	applied	\N	\N	\N	\N	92871	92871	92872
20525	30057	2	applied	\N	\N	\N	\N	92873	92873	92874
20525	30058	3	applied	\N	\N	\N	\N	92875	92875	92876
20525	30059	4	applied	\N	\N	\N	\N	92877	92877	92878
20525	30060	5	applied	\N	\N	\N	\N	92879	92879	92880
20525	30061	6	applied	\N	\N	\N	\N	92881	92881	92882
20525	30062	7	applied	\N	\N	\N	\N	92883	92883	92884
20525	30063	8	applied	\N	\N	\N	\N	92885	92885	92886
20525	30064	9	applied	\N	\N	\N	\N	92887	92887	92888
20525	30065	10	applied	\N	\N	\N	\N	92889	92889	92890
20525	30066	11	applied	\N	\N	\N	\N	92891	92891	92892
20525	30067	12	applied	\N	\N	\N	\N	92893	92893	92894
20531	30084	0	applied	\N	\N	\N	\N	92933	92933	92934
20531	30085	1	applied	\N	\N	\N	\N	92935	92935	92936
20531	30086	2	applied	\N	\N	\N	\N	92937	92937	92938
20535	30087	0	applied	\N	\N	\N	\N	92942	92942	92943
20535	30088	1	applied	\N	\N	\N	\N	92944	92944	92945
20535	30089	2	applied	\N	\N	\N	\N	92946	92946	92947
20535	30090	3	applied	\N	\N	\N	\N	92948	92948	92949
20535	30091	4	applied	\N	\N	\N	\N	92950	92950	92951
20536	29943	0	applied	\N	\N	\N	\N	92958	92958	92569
20536	29944	1	applied	\N	\N	\N	\N	92959	92959	92571
20536	29945	2	applied	\N	\N	\N	\N	92960	92960	92573
20536	29946	3	applied	\N	\N	\N	\N	92961	92961	92575
20536	30076	4	applied	\N	\N	\N	\N	92913	92913	92914
20536	30080	5	applied	\N	\N	\N	\N	92923	92923	92924
20536	30087	6	applied	\N	\N	\N	\N	92942	92942	92943
20536	30088	7	applied	\N	\N	\N	\N	92944	92944	92945
20536	29898	8	applied	\N	\N	1000000000	\N	92361	92361	92362
20536	30056	9	applied	\N	\N	\N	\N	92871	92871	92872
20536	29785	10	applied	\N	\N	\N	\N	92003	92003	92004
20536	29787	11	applied	\N	\N	\N	\N	92045	92045	92046
20536	29790	12	applied	\N	\N	\N	\N	92052	92052	92053
20536	29793	13	applied	\N	\N	\N	\N	92069	92069	92070
20536	29971	14	applied	\N	\N	\N	\N	92629	92629	92762
20536	29794	15	applied	\N	\N	\N	\N	92071	92071	92072
20536	29795	16	applied	\N	\N	\N	\N	92073	92073	92074
20536	29796	17	applied	\N	\N	\N	\N	92075	92075	92076
20536	29805	18	applied	\N	\N	\N	\N	92097	92097	92098
20536	29940	19	applied	\N	\N	\N	\N	92526	92526	92762
20536	29949	20	applied	\N	\N	\N	\N	92580	92580	92630
20542	30108	0	applied	\N	\N	\N	\N	93001	93001	93002
20542	30109	1	applied	\N	\N	\N	\N	93003	93003	93004
20542	30110	2	applied	\N	\N	1000000000	\N	93005	93005	93006
20542	30111	3	applied	\N	\N	\N	\N	93007	93007	93008
20543	30112	0	applied	\N	\N	\N	\N	93011	93011	93012
20543	30113	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20543	30114	2	applied	\N	\N	\N	\N	93014	93014	93015
20543	30115	3	applied	\N	\N	\N	\N	93016	93016	93017
20543	30116	4	applied	\N	\N	\N	\N	93018	93018	93019
20543	30117	5	applied	\N	\N	\N	\N	93020	93020	93021
20543	30118	6	applied	\N	\N	\N	\N	93022	93022	93023
20543	30119	7	applied	\N	\N	\N	\N	93024	93024	93025
20543	30120	8	applied	\N	\N	\N	\N	93026	93026	93027
20544	30121	0	applied	\N	\N	\N	\N	93029	93029	93030
20544	30122	1	applied	\N	\N	\N	\N	93031	93031	93032
20544	30123	2	applied	\N	\N	\N	\N	93033	93033	93034
20554	30134	0	applied	\N	\N	\N	\N	93064	93064	93065
20554	30135	1	applied	\N	\N	\N	\N	93066	93066	93067
20554	30136	2	applied	\N	\N	\N	\N	93068	93068	93069
20559	29943	0	applied	\N	\N	\N	\N	92758	92758	92569
20559	29944	1	applied	\N	\N	\N	\N	92759	92759	92571
20559	29945	2	applied	\N	\N	\N	\N	92760	92760	92573
20559	29946	3	applied	\N	\N	\N	\N	92761	92761	92575
20559	30076	4	applied	\N	\N	\N	\N	92913	92913	92914
20559	30080	5	applied	\N	\N	\N	\N	92923	92923	92924
20559	30087	6	applied	\N	\N	\N	\N	92942	92942	92943
20559	30088	7	applied	\N	\N	\N	\N	92944	92944	92945
20559	30113	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20559	29898	9	applied	\N	\N	1000000000	\N	92361	92361	92362
20559	30056	10	applied	\N	\N	\N	\N	92871	92871	92872
20559	29971	11	applied	\N	\N	\N	\N	92629	92629	92762
20559	30142	12	applied	\N	\N	\N	\N	93119	93119	93092
20559	30143	13	applied	\N	\N	\N	\N	93120	93120	93094
20559	30144	15	applied	\N	\N	\N	\N	93122	93122	93096
20559	30145	16	applied	\N	\N	\N	\N	93123	93123	93098
20559	30146	17	applied	\N	\N	\N	\N	93124	93124	93100
20559	29940	18	applied	\N	\N	\N	\N	92526	92526	92762
20559	29949	19	applied	\N	\N	\N	\N	92580	92580	92630
20559	30061	20	applied	\N	\N	\N	\N	92881	92881	92882
20559	30068	21	applied	\N	\N	\N	\N	92896	92896	92897
20559	30155	22	applied	\N	\N	\N	\N	93125	93125	93126
20559	30147	23	applied	\N	\N	\N	\N	93127	93127	93102
20559	30148	24	applied	\N	\N	\N	\N	93128	93128	93104
20559	30149	25	applied	\N	\N	\N	\N	93129	93129	93106
20559	30150	26	applied	\N	\N	\N	\N	93130	93130	93108
20559	30110	27	applied	\N	\N	1000000000	\N	93005	93005	93006
20559	29864	28	applied	\N	\N	\N	\N	92535	92535	92263
20559	29899	29	applied	\N	\N	\N	\N	92431	92431	83176
20559	29815	30	applied	\N	\N	\N	\N	92536	92536	92432
20559	29866	31	applied	\N	\N	\N	\N	92537	92537	92267
20559	29830	32	applied	\N	\N	1000000000	\N	92161	92161	92162
20559	29831	33	applied	\N	\N	1000000000	\N	92163	92163	92164
20559	29832	34	applied	\N	\N	1000000000	\N	92165	92165	92166
20559	29837	35	applied	\N	\N	1000000000	\N	92181	92181	92182
20559	29839	36	applied	\N	\N	1000000000	\N	92185	92185	92186
20559	29955	37	applied	\N	\N	1000000000	\N	92592	92592	92593
20559	30030	38	applied	\N	\N	\N	\N	92800	92800	92801
20559	30063	39	applied	\N	\N	\N	\N	92885	92885	92886
20559	30064	40	applied	\N	\N	\N	\N	92887	92887	92888
20559	30065	41	applied	\N	\N	\N	\N	92889	92889	92890
20559	29867	42	applied	\N	\N	\N	\N	92542	92542	92269
20559	29871	43	applied	\N	\N	\N	\N	92543	92543	92282
20559	29872	44	applied	\N	\N	\N	\N	92544	92544	92284
20559	29873	45	applied	\N	\N	\N	\N	92545	92545	92286
20559	29875	46	applied	\N	\N	\N	\N	92546	92546	92290
20559	29876	47	applied	\N	\N	\N	\N	92547	92547	92292
20559	30066	48	applied	\N	\N	\N	\N	92891	92891	92892
20559	30072	49	applied	\N	\N	\N	\N	92904	92904	92905
20559	30073	50	applied	\N	\N	\N	\N	92906	92906	92907
20559	30074	51	applied	\N	\N	\N	\N	92908	92908	92909
20559	29816	52	applied	\N	\N	\N	\N	92562	92562	92124
20559	29817	53	applied	\N	\N	\N	\N	92563	92563	92126
20559	29821	54	applied	\N	\N	\N	\N	92564	92564	92141
20559	29922	55	applied	\N	\N	\N	\N	92565	92565	92241
20559	30041	56	applied	\N	\N	\N	\N	92823	92823	92824
20559	30042	57	applied	\N	\N	\N	\N	92825	92825	92826
20559	30043	58	applied	\N	\N	\N	\N	92827	92827	92828
20559	30044	59	applied	\N	\N	1000000000	\N	92829	92829	92830
20559	30067	60	applied	\N	\N	\N	\N	92893	92893	92894
20559	29877	61	applied	\N	\N	\N	\N	93131	93131	92294
20565	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20565	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20565	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20565	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20565	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20565	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20565	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20565	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20569	30159	0	applied	\N	\N	\N	\N	93155	93155	93156
20569	30160	1	applied	\N	\N	\N	\N	93157	93157	93158
20569	30161	2	applied	\N	\N	\N	\N	93159	93159	93160
20569	30162	3	applied	\N	\N	\N	\N	93161	93161	93162
20569	30163	4	applied	\N	\N	\N	\N	93163	93163	93164
20569	30164	5	applied	\N	\N	\N	\N	93165	93165	93166
20569	30165	6	applied	\N	\N	\N	\N	93167	93167	93168
20569	30166	7	applied	\N	\N	\N	\N	93169	93169	93170
20573	30076	0	applied	\N	\N	\N	\N	92913	92913	92914
20573	30080	1	applied	\N	\N	\N	\N	92923	92923	92924
20573	30087	2	applied	\N	\N	\N	\N	92942	92942	92943
20573	30088	3	applied	\N	\N	\N	\N	92944	92944	92945
20573	30113	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20573	30056	5	applied	\N	\N	\N	\N	92871	92871	92872
20573	29971	6	applied	\N	\N	\N	\N	92629	92629	92630
20573	30159	7	applied	\N	\N	\N	\N	93184	93184	93156
20573	30142	8	applied	\N	\N	\N	\N	93185	93185	93092
20573	30143	9	applied	\N	\N	\N	\N	93186	93186	93094
20573	30144	10	applied	\N	\N	\N	\N	93187	93187	93096
20573	30145	11	applied	\N	\N	\N	\N	93188	93188	93098
20573	30146	12	applied	\N	\N	\N	\N	93189	93189	93100
20573	30057	13	applied	\N	\N	\N	\N	92873	92873	92874
20573	30058	14	applied	\N	\N	\N	\N	92875	92875	92876
20573	30059	15	applied	\N	\N	\N	\N	92877	92877	92878
20573	30060	16	applied	\N	\N	\N	\N	92879	92879	92880
20573	30061	17	applied	\N	\N	\N	\N	92881	92881	92882
20573	30068	18	applied	\N	\N	\N	\N	92896	92896	92897
20573	30155	19	applied	\N	\N	\N	\N	93125	93125	93126
20573	30147	20	applied	\N	\N	\N	\N	93190	93190	93102
20573	30148	21	applied	\N	\N	\N	\N	93191	93191	93104
20573	30149	22	applied	\N	\N	\N	\N	93192	93192	93106
20573	30150	23	applied	\N	\N	\N	\N	93193	93193	93108
20573	29972	24	applied	\N	\N	\N	\N	92631	92631	92632
20573	29976	25	applied	\N	\N	\N	\N	92650	92650	92651
20573	29977	26	applied	\N	\N	\N	\N	92652	92652	92653
20573	29982	27	applied	\N	\N	\N	\N	92666	92666	92667
20573	29985	28	applied	\N	\N	\N	\N	92676	92676	92677
20573	29986	29	applied	\N	\N	\N	\N	92678	92678	92679
20573	29987	30	applied	\N	\N	\N	\N	92680	92680	92681
20573	29994	31	applied	\N	\N	\N	\N	92695	92695	92696
20573	29998	32	applied	\N	\N	\N	\N	92705	92705	92706
20573	30001	33	applied	\N	\N	\N	\N	92713	92713	92714
20573	30003	34	applied	\N	\N	\N	\N	92722	92722	92723
20573	30007	35	applied	\N	\N	\N	\N	92734	92734	92735
20573	30010	36	applied	\N	\N	\N	\N	92740	92740	92741
20573	30013	37	applied	\N	\N	\N	\N	92748	92748	92749
20573	30017	38	applied	\N	\N	\N	\N	92769	92769	92770
20573	30020	39	applied	\N	\N	\N	\N	92778	92778	92779
20573	30023	40	applied	\N	\N	\N	\N	92786	92786	92787
20573	30024	41	applied	\N	\N	\N	\N	92788	92788	92789
20573	30025	42	applied	\N	\N	\N	\N	92790	92790	92791
20573	30026	43	applied	\N	\N	\N	\N	92792	92792	92793
20573	30027	44	applied	\N	\N	\N	\N	92794	92794	92795
20573	30045	45	applied	\N	\N	\N	\N	92839	92839	92840
20573	30046	46	applied	\N	\N	\N	\N	92841	92841	92842
20573	30051	47	applied	\N	\N	\N	\N	92858	92858	92859
20573	30055	48	applied	\N	\N	\N	\N	92869	92869	92870
20573	30069	49	applied	\N	\N	\N	\N	92898	92898	92899
20573	30077	50	applied	\N	\N	\N	\N	92915	92915	92916
20573	30084	51	applied	\N	\N	\N	\N	92933	92933	92934
20573	30089	52	applied	\N	\N	\N	\N	92946	92946	92947
20573	30092	53	applied	\N	\N	\N	\N	92964	92964	92965
20573	30093	54	applied	\N	\N	\N	\N	92966	92966	92967
20573	30098	55	applied	\N	\N	\N	\N	92977	92977	92978
20573	30101	56	applied	\N	\N	\N	\N	92985	92985	92986
20573	30106	57	applied	\N	\N	\N	\N	92995	92995	92996
20573	30108	58	applied	\N	\N	\N	\N	93001	93001	93002
20573	30114	59	applied	\N	\N	\N	\N	93014	93014	93015
20573	30115	60	applied	\N	\N	\N	\N	93016	93016	93017
20573	30121	61	applied	\N	\N	\N	\N	93029	93029	93030
20573	30124	62	applied	\N	\N	\N	\N	93036	93036	93037
20573	30127	63	applied	\N	\N	\N	\N	93049	93049	93050
20573	30128	64	applied	\N	\N	\N	\N	93051	93051	93052
20573	30134	65	applied	\N	\N	\N	\N	93064	93064	93065
20573	30137	66	applied	\N	\N	\N	\N	93076	93076	93077
20573	30141	67	applied	\N	\N	\N	\N	93089	93089	93090
20573	30151	68	applied	\N	\N	\N	\N	93109	93109	93110
20573	30156	69	applied	\N	\N	\N	\N	93141	93141	93142
20573	30160	70	applied	\N	\N	\N	\N	93157	93157	93158
20573	30161	71	applied	\N	\N	\N	\N	93159	93159	93160
20573	30110	72	applied	\N	\N	1000000000	\N	93005	93005	93006
20573	30030	73	applied	\N	\N	\N	\N	92800	92800	92801
20573	29983	74	applied	\N	\N	\N	\N	92668	92668	93194
20573	29997	75	applied	\N	\N	\N	\N	92701	92701	92638
20573	30004	76	applied	\N	\N	\N	\N	92724	92724	93195
20573	30014	77	applied	\N	\N	\N	\N	92750	92750	92655
20573	30028	78	applied	\N	\N	\N	\N	92796	92796	93196
20573	30029	79	applied	\N	\N	\N	\N	92798	92798	92657
20573	30063	80	applied	\N	\N	\N	\N	92885	92885	92886
20573	30064	81	applied	\N	\N	\N	\N	92887	92887	92888
20573	30065	82	applied	\N	\N	\N	\N	92889	92889	92890
20573	30066	83	applied	\N	\N	\N	\N	92891	92891	92892
20573	30072	84	applied	\N	\N	\N	\N	92904	92904	92905
20573	30073	85	applied	\N	\N	\N	\N	92906	92906	92907
20573	30074	86	applied	\N	\N	\N	\N	92908	92908	92909
20573	29975	87	applied	\N	\N	\N	\N	92637	92637	93197
20573	29978	88	applied	\N	\N	\N	\N	92654	92654	93198
20573	29979	90	applied	\N	\N	\N	\N	92656	92656	92661
20573	29991	91	applied	\N	\N	\N	\N	92688	92688	93200
20573	29980	92	applied	\N	\N	\N	\N	92658	92658	93201
20573	29981	93	applied	\N	\N	\N	\N	92660	92660	93202
20573	29984	94	applied	\N	\N	\N	\N	92670	92670	93203
20573	29988	95	applied	\N	\N	\N	\N	92682	92682	93204
20573	29989	96	applied	\N	\N	\N	\N	92684	92684	92691
20573	29990	97	applied	\N	\N	\N	\N	92686	92686	93205
20573	29995	98	applied	\N	\N	\N	\N	92697	92697	93206
20574	30167	0	applied	\N	\N	\N	\N	93209	93209	93210
20574	30168	1	applied	\N	\N	\N	\N	93211	93211	93212
20574	30169	2	applied	\N	\N	\N	\N	93213	93213	93214
20574	30170	3	applied	\N	\N	\N	\N	93215	93215	47675
20575	30171	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	93218	93218	\N
20575	30172	1	applied	\N	\N	\N	\N	93219	93219	93220
20575	30173	2	applied	\N	\N	\N	\N	93221	93221	93222
20575	30174	3	applied	\N	\N	\N	\N	93223	93223	93224
20576	30171	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	93218	93218	\N
20576	30172	1	applied	\N	\N	\N	\N	93219	93219	93220
20576	30173	2	applied	\N	\N	\N	\N	93221	93221	93222
20576	30174	3	applied	\N	\N	\N	\N	93223	93223	93224
20577	30175	0	applied	\N	\N	\N	\N	93228	93228	93229
20577	30176	1	applied	\N	\N	\N	\N	93230	93230	93231
20577	30177	2	applied	\N	\N	\N	\N	93232	93232	93233
20578	30175	0	applied	\N	\N	\N	\N	93228	93228	93229
20578	30176	1	applied	\N	\N	\N	\N	93230	93230	93231
20578	30177	2	applied	\N	\N	\N	\N	93232	93232	93233
20579	29943	0	applied	\N	\N	\N	\N	92758	92758	92569
20579	29944	1	applied	\N	\N	\N	\N	92759	92759	92571
20579	29945	2	applied	\N	\N	\N	\N	92760	92760	92573
20579	29946	3	applied	\N	\N	\N	\N	92761	92761	92575
20579	30076	4	applied	\N	\N	\N	\N	92913	92913	92914
20579	30080	5	applied	\N	\N	\N	\N	92923	92923	92924
20579	30087	6	applied	\N	\N	\N	\N	92942	92942	92943
20579	30088	7	applied	\N	\N	\N	\N	92944	92944	92945
20579	29939	8	applied	\N	\N	\N	\N	92524	92524	92525
20579	30113	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20579	29947	10	applied	\N	\N	\N	\N	92576	92576	92577
20579	29948	11	applied	\N	\N	\N	\N	92578	92578	92579
20579	30056	12	applied	\N	\N	\N	\N	92871	92871	92872
20579	29971	13	applied	\N	\N	\N	\N	92629	92629	92762
20579	30159	14	applied	\N	\N	\N	\N	93184	93184	93156
20579	30142	15	applied	\N	\N	\N	\N	93238	93238	93092
20579	30143	16	applied	\N	\N	\N	\N	93239	93239	93094
20579	30144	17	applied	\N	\N	\N	\N	93240	93240	93096
20579	30145	18	applied	\N	\N	\N	\N	93241	93241	93098
20579	30146	19	applied	\N	\N	\N	\N	93242	93242	93100
20579	29949	20	applied	\N	\N	\N	\N	92580	92580	92630
20579	29950	21	applied	\N	\N	\N	\N	92582	92582	92583
20579	29951	22	applied	\N	\N	\N	\N	92584	92584	92585
20579	29952	23	applied	\N	\N	\N	\N	92586	92586	92587
20579	29953	24	applied	\N	\N	\N	\N	92588	92588	92589
20579	29969	25	applied	\N	\N	\N	\N	92623	92623	92624
20579	30061	26	applied	\N	\N	\N	\N	92881	92881	92882
20579	30068	27	applied	\N	\N	\N	\N	92896	92896	92897
20579	30155	28	applied	\N	\N	\N	\N	93125	93125	93126
20579	30147	29	applied	\N	\N	\N	\N	93243	93243	93102
20579	30148	30	applied	\N	\N	\N	\N	93244	93244	93104
20579	30149	31	applied	\N	\N	\N	\N	93245	93245	93106
20579	30150	32	applied	\N	\N	\N	\N	93246	93246	93108
20579	29972	33	applied	\N	\N	\N	\N	92631	92631	92632
20579	29976	34	applied	\N	\N	\N	\N	92650	92650	92651
20579	29977	35	applied	\N	\N	\N	\N	92652	92652	92653
20579	29982	36	applied	\N	\N	\N	\N	92666	92666	92667
20579	29985	37	applied	\N	\N	\N	\N	92676	92676	92677
20579	29986	38	applied	\N	\N	\N	\N	92678	92678	92679
20579	29987	39	applied	\N	\N	\N	\N	92680	92680	92681
20579	29994	40	applied	\N	\N	\N	\N	92695	92695	92696
20579	29998	41	applied	\N	\N	\N	\N	92705	92705	92706
20579	30001	42	applied	\N	\N	\N	\N	92713	92713	92714
20579	30003	43	applied	\N	\N	\N	\N	92722	92722	92723
20579	30007	44	applied	\N	\N	\N	\N	92734	92734	92735
20579	30010	45	applied	\N	\N	\N	\N	92740	92740	92741
20579	30013	46	applied	\N	\N	\N	\N	92748	92748	92749
20579	30017	47	applied	\N	\N	\N	\N	92769	92769	92770
20579	30020	48	applied	\N	\N	\N	\N	92778	92778	92779
20579	30023	49	applied	\N	\N	\N	\N	92786	92786	92787
20579	30024	50	applied	\N	\N	\N	\N	92788	92788	92789
20579	30025	51	applied	\N	\N	\N	\N	92790	92790	92791
20579	30026	52	applied	\N	\N	\N	\N	92792	92792	92793
20579	30027	53	applied	\N	\N	\N	\N	92794	92794	92795
20579	30045	54	applied	\N	\N	\N	\N	92839	92839	92840
20579	30046	55	applied	\N	\N	\N	\N	92841	92841	92842
20579	30051	56	applied	\N	\N	\N	\N	92858	92858	92859
20579	30055	57	applied	\N	\N	\N	\N	92869	92869	92870
20579	30069	58	applied	\N	\N	\N	\N	92898	92898	92899
20579	30077	59	applied	\N	\N	\N	\N	92915	92915	92916
20579	30084	60	applied	\N	\N	\N	\N	92933	92933	92934
20579	30089	61	applied	\N	\N	\N	\N	92946	92946	92947
20579	30092	62	applied	\N	\N	\N	\N	92964	92964	92965
20579	30093	63	applied	\N	\N	\N	\N	92966	92966	92967
20579	30098	64	applied	\N	\N	\N	\N	92977	92977	92978
20579	30101	65	applied	\N	\N	\N	\N	92985	92985	92986
20579	30106	67	applied	\N	\N	\N	\N	92995	92995	92996
20579	30108	68	applied	\N	\N	\N	\N	93001	93001	93002
20579	30114	69	applied	\N	\N	\N	\N	93014	93014	93015
20579	30115	70	applied	\N	\N	\N	\N	93016	93016	93017
20579	30121	71	applied	\N	\N	\N	\N	93029	93029	93030
20579	30124	72	applied	\N	\N	\N	\N	93036	93036	93037
20579	30127	73	applied	\N	\N	\N	\N	93049	93049	93050
20579	30128	74	applied	\N	\N	\N	\N	93051	93051	93052
20579	30134	75	applied	\N	\N	\N	\N	93064	93064	93065
20579	30137	76	applied	\N	\N	\N	\N	93076	93076	93077
20579	30141	77	applied	\N	\N	\N	\N	93089	93089	93090
20579	30151	78	applied	\N	\N	\N	\N	93109	93109	93110
20579	30156	79	applied	\N	\N	\N	\N	93141	93141	93142
20579	30160	80	applied	\N	\N	\N	\N	93157	93157	93158
20579	30161	81	applied	\N	\N	\N	\N	93159	93159	93160
20579	30167	82	applied	\N	\N	\N	\N	93209	93209	93210
20579	30172	83	applied	\N	\N	\N	\N	93219	93219	93220
20579	30175	84	applied	\N	\N	\N	\N	93228	93228	93229
20579	29954	85	applied	\N	\N	\N	\N	92590	92590	93248
20579	30110	86	applied	\N	\N	1000000000	\N	93005	93005	93006
20579	29836	87	applied	\N	\N	\N	\N	92179	92179	92112
20579	29842	88	applied	\N	\N	\N	\N	92196	92196	92114
20579	29955	89	applied	\N	\N	1000000000	\N	92592	92592	92593
20579	30030	90	applied	\N	\N	\N	\N	92800	92800	92801
20579	30063	91	applied	\N	\N	\N	\N	92885	92885	92886
20579	30064	92	applied	\N	\N	\N	\N	92887	92887	92888
20579	30065	93	applied	\N	\N	\N	\N	92889	92889	92890
20579	29962	94	applied	\N	\N	\N	\N	92606	92606	92452
20579	29974	95	applied	\N	\N	\N	\N	92635	92635	92116
20579	29983	96	applied	\N	\N	\N	\N	92668	92668	92453
20579	29997	97	applied	\N	\N	\N	\N	92701	92701	92132
20579	30004	98	applied	\N	\N	\N	\N	92724	92724	92128
20579	30014	99	applied	\N	\N	\N	\N	92750	92750	93249
20579	30028	100	applied	\N	\N	\N	\N	92796	92796	92133
20585	30186	0	applied	\N	\N	\N	\N	93274	93274	93275
20585	30187	1	applied	\N	\N	\N	\N	93276	93276	93277
20585	30188	2	applied	\N	\N	\N	\N	93278	93278	93279
20585	30189	3	applied	\N	\N	\N	\N	93280	93280	93281
20585	30190	4	applied	\N	\N	\N	\N	93282	93282	93283
20585	30191	5	applied	\N	\N	\N	\N	93284	93284	93285
20585	30192	6	applied	\N	\N	\N	\N	93286	93286	93287
20585	30193	7	applied	\N	\N	\N	\N	93288	93288	93289
20585	30194	8	applied	\N	\N	\N	\N	93290	93290	93291
20585	30184	9	applied	\N	\N	\N	\N	93267	93267	93292
20589	30195	0	applied	\N	\N	\N	\N	93298	93298	93299
20589	30196	1	applied	\N	\N	\N	\N	93300	93300	93301
20589	30197	2	applied	\N	\N	\N	\N	93302	93302	93303
20589	30198	3	applied	\N	\N	\N	\N	93304	93304	93305
20594	30202	0	applied	\N	\N	\N	\N	93322	93322	93323
20594	30204	1	applied	\N	\N	\N	\N	93326	93326	93327
20594	30206	2	applied	\N	\N	\N	\N	93330	93330	93335
20594	30207	3	applied	\N	\N	\N	\N	93332	93332	93329
20600	30221	0	applied	\N	\N	\N	\N	93398	93398	93399
20600	30222	1	applied	\N	\N	\N	\N	93400	93400	93401
20600	30223	2	applied	\N	\N	\N	\N	93402	93402	93403
20605	30225	0	applied	\N	\N	\N	\N	93410	93410	93411
20611	30232	0	applied	\N	\N	\N	\N	93436	93436	93437
20611	30233	1	applied	\N	\N	\N	\N	93438	93438	93439
20611	30234	2	applied	\N	\N	\N	\N	93440	93440	93441
20611	30235	3	applied	\N	\N	\N	\N	93442	93442	93443
20611	30236	4	applied	\N	\N	\N	\N	93444	93444	93445
20611	30237	5	applied	\N	\N	\N	\N	93446	93446	93447
20611	30238	6	applied	\N	\N	\N	\N	93448	93448	93449
20611	30239	7	applied	\N	\N	\N	\N	93450	93450	93451
20611	30240	8	applied	\N	\N	\N	\N	93452	93452	93453
20611	30241	9	applied	\N	\N	\N	\N	93454	93454	93455
20612	30242	0	applied	\N	\N	\N	\N	93460	93460	93461
20612	30243	1	applied	\N	\N	\N	\N	93462	93462	93463
20612	30244	2	applied	\N	\N	\N	\N	93464	93464	93465
20618	30258	0	applied	\N	\N	\N	\N	93498	93498	93499
20618	30259	1	applied	\N	\N	\N	\N	93500	93500	93501
20618	30260	2	applied	\N	\N	\N	\N	93502	93502	93503
20618	30261	3	applied	\N	\N	\N	\N	93504	93504	93504
20618	30262	4	applied	\N	\N	\N	\N	93505	93505	93506
20618	30263	5	applied	\N	\N	\N	\N	93507	93507	93508
20618	30264	6	applied	\N	\N	\N	\N	93509	93509	93510
20619	30265	0	applied	\N	\N	1000000000	\N	93512	93512	93513
20619	30266	1	applied	\N	\N	1000000000	\N	93514	93514	93515
20619	30267	2	applied	\N	\N	\N	\N	93516	93516	93517
20619	30268	3	applied	\N	\N	\N	\N	93518	93518	93519
20619	30269	4	applied	\N	\N	\N	\N	93520	93520	93521
20635	30347	0	applied	\N	\N	\N	\N	93725	93725	93726
20635	30348	1	applied	\N	\N	\N	\N	93727	93727	93728
20635	30349	2	applied	\N	\N	\N	\N	93729	93729	93730
20636	30350	0	applied	\N	\N	\N	\N	93735	93735	93736
20636	30351	1	applied	\N	\N	\N	\N	93737	93737	93738
20643	30371	0	applied	\N	\N	\N	\N	93789	93789	93790
20643	30372	1	applied	\N	\N	\N	\N	93791	93791	93792
20643	30373	2	applied	\N	\N	\N	\N	93793	93793	93794
20648	30374	0	applied	\N	\N	\N	\N	93817	93817	93818
20648	30375	1	applied	\N	\N	\N	\N	93819	93819	93820
20648	30376	2	applied	\N	\N	\N	\N	93821	93821	93822
20648	30377	3	applied	\N	\N	\N	\N	93823	93823	93824
20657	30385	0	applied	\N	\N	\N	\N	93858	93858	93859
20657	30386	1	applied	\N	\N	\N	\N	93860	93860	93861
20657	30387	2	applied	\N	\N	\N	\N	93862	93862	93863
20657	30388	3	applied	\N	\N	\N	\N	93864	93864	93865
20662	30391	0	applied	\N	\N	\N	\N	93876	93876	93878
20669	30407	0	applied	\N	\N	\N	\N	93917	93917	93918
20669	30408	1	applied	\N	\N	\N	\N	93919	93919	93920
20669	30409	2	applied	\N	\N	\N	\N	93921	93921	93922
20675	30416	0	applied	\N	\N	\N	\N	93947	93947	93948
20675	30417	1	applied	\N	\N	\N	\N	93949	93949	93950
20675	30418	2	applied	\N	\N	\N	\N	93951	93951	93952
20675	30419	3	applied	\N	\N	\N	\N	93953	93953	93954
20675	30420	4	applied	\N	\N	\N	\N	93955	93955	93956
20675	30421	5	applied	\N	\N	\N	\N	93957	93957	93958
20675	30422	6	applied	\N	\N	\N	\N	93959	93959	93960
20675	30423	7	applied	\N	\N	\N	\N	93961	93961	93962
20675	30424	8	applied	\N	\N	\N	\N	93963	93963	93964
20680	30394	0	applied	\N	\N	\N	\N	93885	93885	93886
20680	30395	1	applied	\N	\N	\N	\N	93887	93887	93888
20680	30396	2	applied	\N	\N	\N	\N	93889	93889	93890
20680	30397	3	applied	\N	\N	\N	\N	93891	93891	93892
20680	30407	4	applied	\N	\N	\N	\N	93917	93917	93918
20680	30410	5	applied	\N	\N	\N	\N	93927	93927	93928
20680	30413	6	applied	\N	\N	\N	\N	93938	93938	93939
20680	30416	7	applied	\N	\N	\N	\N	93947	93947	93948
20580	30175	0	applied	\N	\N	\N	\N	93228	93228	93229
20580	30176	1	applied	\N	\N	\N	\N	93230	93230	93231
20580	30177	2	applied	\N	\N	\N	\N	93232	93232	93233
20586	30186	0	applied	\N	\N	\N	\N	93274	93274	93275
20586	30187	1	applied	\N	\N	\N	\N	93276	93276	93277
20586	30188	2	applied	\N	\N	\N	\N	93278	93278	93279
20586	30189	3	applied	\N	\N	\N	\N	93280	93280	93281
20586	30190	4	applied	\N	\N	\N	\N	93282	93282	93283
20586	30191	5	applied	\N	\N	\N	\N	93284	93284	93285
20586	30192	6	applied	\N	\N	\N	\N	93286	93286	93287
20586	30193	7	applied	\N	\N	\N	\N	93288	93288	93289
20586	30194	8	applied	\N	\N	\N	\N	93290	93290	93291
20586	30184	9	applied	\N	\N	\N	\N	93267	93267	93292
20590	30195	0	applied	\N	\N	\N	\N	93298	93298	93299
20590	30197	1	applied	\N	\N	\N	\N	93302	93302	93303
20590	30198	2	applied	\N	\N	\N	\N	93304	93304	93305
20591	30199	0	applied	\N	\N	\N	\N	93312	93312	93313
20591	30200	1	applied	\N	\N	\N	\N	93314	93314	93315
20591	30201	2	applied	\N	\N	\N	\N	93316	93316	93317
20595	30202	0	applied	\N	\N	\N	\N	93322	93322	93323
20595	30203	1	applied	\N	\N	\N	\N	93324	93324	93325
20595	30204	2	applied	\N	\N	\N	\N	93326	93326	93327
20595	30205	3	applied	\N	\N	\N	\N	93328	93328	93329
20595	30206	4	applied	\N	\N	\N	\N	93330	93330	93331
20595	30207	5	applied	\N	\N	\N	\N	93332	93332	93333
20596	30076	0	applied	\N	\N	\N	\N	92913	92913	92914
20596	30080	1	applied	\N	\N	\N	\N	92923	92923	92924
20596	30087	2	applied	\N	\N	\N	\N	92942	92942	92943
20596	30088	3	applied	\N	\N	\N	\N	92944	92944	92945
20596	30202	4	applied	\N	\N	\N	\N	93322	93322	93323
20596	30178	5	applied	\N	\N	\N	\N	93255	93255	93256
20596	30113	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20596	30159	7	applied	\N	\N	\N	\N	93184	93184	93156
20596	30203	8	applied	\N	\N	\N	\N	93324	93324	93325
20596	30187	9	applied	\N	\N	\N	\N	93276	93276	93277
20596	30188	10	applied	\N	\N	\N	\N	93278	93278	93279
20596	30189	11	applied	\N	\N	\N	\N	93280	93280	93281
20596	30190	12	applied	\N	\N	\N	\N	93282	93282	93283
20596	30068	13	applied	\N	\N	\N	\N	92896	92896	92897
20596	30142	14	applied	\N	\N	\N	\N	93185	93185	93092
20596	30143	15	applied	\N	\N	\N	\N	93186	93186	93094
20596	30144	16	applied	\N	\N	\N	\N	93187	93187	93096
20596	30145	17	applied	\N	\N	\N	\N	93188	93188	93098
20596	30146	18	applied	\N	\N	\N	\N	93189	93189	93100
20596	30208	19	applied	\N	\N	\N	\N	93339	93339	93340
20596	30209	20	applied	\N	\N	\N	\N	93341	93341	93342
20596	30191	21	applied	\N	\N	\N	\N	93284	93284	93285
20596	30192	22	applied	\N	\N	\N	\N	93286	93286	93287
20596	30193	23	applied	\N	\N	\N	\N	93288	93288	93289
20596	30210	24	applied	\N	\N	\N	\N	93343	93343	93344
20596	30211	25	applied	\N	\N	\N	\N	93345	93345	93346
20596	30069	26	applied	\N	\N	\N	\N	92898	92898	92899
20596	30077	27	applied	\N	\N	\N	\N	92915	92915	92916
20596	30084	28	applied	\N	\N	\N	\N	92933	92933	92934
20596	30089	29	applied	\N	\N	\N	\N	92946	92946	92947
20596	30092	30	applied	\N	\N	\N	\N	92964	92964	92965
20596	30093	31	applied	\N	\N	\N	\N	92966	92966	92967
20596	30098	32	applied	\N	\N	\N	\N	92977	92977	92978
20596	30101	33	applied	\N	\N	\N	\N	92985	92985	92986
20596	30106	34	applied	\N	\N	\N	\N	92995	92995	92996
20596	30108	35	applied	\N	\N	\N	\N	93001	93001	93002
20596	30114	36	applied	\N	\N	\N	\N	93014	93014	93015
20596	30115	37	applied	\N	\N	\N	\N	93016	93016	93017
20596	30121	38	applied	\N	\N	\N	\N	93029	93029	93030
20596	30124	39	applied	\N	\N	\N	\N	93036	93036	93037
20596	30127	40	applied	\N	\N	\N	\N	93049	93049	93050
20596	30128	41	applied	\N	\N	\N	\N	93051	93051	93052
20596	30102	42	applied	\N	\N	\N	\N	92987	92987	92988
20596	30147	43	applied	\N	\N	\N	\N	93190	93190	93102
20596	30148	44	applied	\N	\N	\N	\N	93191	93191	93104
20596	30149	45	applied	\N	\N	\N	\N	93192	93192	93106
20596	30150	46	applied	\N	\N	\N	\N	93193	93193	93108
20596	30070	47	applied	\N	\N	\N	\N	92900	92900	92901
20596	30112	48	applied	\N	\N	\N	\N	93011	93011	93012
20596	30134	49	applied	\N	\N	\N	\N	93064	93064	93065
20596	30137	50	applied	\N	\N	\N	\N	93076	93076	93077
20596	30141	51	applied	\N	\N	\N	\N	93089	93089	93090
20596	30151	52	applied	\N	\N	\N	\N	93109	93109	93110
20596	30156	53	applied	\N	\N	\N	\N	93141	93141	93142
20596	30160	54	applied	\N	\N	\N	\N	93157	93157	93158
20596	30161	55	applied	\N	\N	\N	\N	93159	93159	93160
20596	30167	56	applied	\N	\N	\N	\N	93209	93209	93210
20596	30172	57	applied	\N	\N	\N	\N	93219	93219	93220
20596	30175	58	applied	\N	\N	\N	\N	93228	93228	93229
20596	30179	59	applied	\N	\N	\N	\N	93257	93257	93258
20596	30180	60	applied	\N	\N	\N	\N	93259	93259	93260
20596	30186	61	applied	\N	\N	\N	\N	93274	93274	93275
20596	30195	62	applied	\N	\N	\N	\N	93298	93298	93299
20596	30199	63	applied	\N	\N	\N	\N	93312	93312	93313
20596	30204	64	applied	\N	\N	\N	\N	93326	93326	93327
20596	30212	65	applied	\N	\N	\N	\N	93347	93347	93348
20596	30071	66	applied	\N	\N	\N	\N	92902	92902	92903
20596	30110	67	applied	\N	\N	1000000000	\N	93005	93005	93006
20596	30072	68	applied	\N	\N	\N	\N	92904	92904	92905
20596	30073	69	applied	\N	\N	\N	\N	92906	92906	92907
20596	30074	70	applied	\N	\N	\N	\N	92908	92908	92909
20596	30079	71	applied	\N	\N	\N	\N	92919	92919	93349
20596	30081	72	applied	\N	\N	\N	\N	92925	92925	93350
20596	30075	73	applied	\N	\N	\N	\N	92910	92910	93351
20596	30078	74	applied	\N	\N	\N	\N	92917	92917	92926
20596	30082	75	applied	\N	\N	\N	\N	92927	92927	92928
20596	30094	76	applied	\N	\N	\N	\N	92968	92968	93352
20596	30105	77	applied	\N	\N	\N	\N	92993	92993	93353
20596	30117	78	applied	\N	\N	\N	\N	93020	93020	92930
20596	30129	79	applied	\N	\N	\N	\N	93053	93053	93354
20596	30140	80	applied	\N	\N	\N	\N	93082	93082	93355
20596	30162	81	applied	\N	\N	\N	\N	93161	93161	92936
20596	30173	82	applied	\N	\N	\N	\N	93221	93221	93356
20596	30181	83	applied	\N	\N	\N	\N	93261	93261	92938
20596	30206	84	applied	\N	\N	\N	\N	93330	93330	93357
20596	30170	86	applied	\N	\N	\N	\N	93215	93215	47675
20596	30086	87	applied	\N	\N	\N	\N	92937	92937	93359
20596	30090	88	applied	\N	\N	\N	\N	92948	92948	92951
20596	30096	89	applied	\N	\N	\N	\N	92972	92972	93360
20596	30097	90	applied	\N	\N	\N	\N	92974	92974	92971
20596	30100	91	applied	\N	\N	\N	\N	92981	92981	92973
20596	30103	92	applied	\N	\N	\N	\N	92989	92989	92975
20596	30107	93	applied	\N	\N	\N	\N	92997	92997	93361
20596	30111	94	applied	\N	\N	\N	\N	93007	93007	93362
20581	30175	0	applied	\N	\N	\N	\N	93228	93228	93229
20581	30176	1	applied	\N	\N	\N	\N	93230	93230	93231
20581	30177	2	applied	\N	\N	\N	\N	93232	93232	93233
20582	30178	0	applied	\N	\N	\N	\N	93255	93255	93256
20582	30179	1	applied	\N	\N	\N	\N	93257	93257	93258
20582	30180	2	applied	\N	\N	\N	\N	93259	93259	93260
20582	30181	3	applied	\N	\N	\N	\N	93261	93261	93262
20582	30182	4	applied	\N	\N	\N	\N	93263	93263	93264
20582	30183	5	applied	\N	\N	\N	\N	93265	93265	93266
20582	30184	6	applied	\N	\N	\N	\N	93267	93267	93268
20582	30185	7	applied	\N	\N	\N	\N	93269	93269	93270
20587	30195	0	applied	\N	\N	\N	\N	93298	93298	93299
20587	30196	1	applied	\N	\N	\N	\N	93300	93300	93301
20587	30197	2	applied	\N	\N	\N	\N	93302	93302	93303
20587	30198	3	applied	\N	\N	\N	\N	93304	93304	93305
20592	30199	0	applied	\N	\N	\N	\N	93312	93312	93313
20592	30200	1	applied	\N	\N	\N	\N	93314	93314	93315
20592	30201	2	applied	\N	\N	\N	\N	93316	93316	93317
20597	30212	0	applied	\N	\N	\N	\N	93347	93347	93348
20597	30213	1	applied	\N	\N	\N	\N	93377	93377	93378
20603	30224	0	applied	\N	\N	\N	\N	93408	93408	93409
20603	30225	1	applied	\N	\N	\N	\N	93410	93410	93411
20607	30224	0	applied	\N	\N	\N	\N	93408	93408	93409
20607	30225	1	applied	\N	\N	\N	\N	93410	93410	93411
20608	29943	0	applied	\N	\N	\N	\N	92758	92758	92569
20608	29944	1	applied	\N	\N	\N	\N	92759	92759	92571
20608	29945	2	applied	\N	\N	\N	\N	92760	92760	92573
20608	29946	3	applied	\N	\N	\N	\N	92761	92761	92575
20608	30076	4	applied	\N	\N	\N	\N	92913	92913	92914
20608	30080	5	applied	\N	\N	\N	\N	92923	92923	92924
20608	30087	6	applied	\N	\N	\N	\N	92942	92942	92943
20608	30088	7	applied	\N	\N	\N	\N	92944	92944	92945
20608	30202	8	applied	\N	\N	\N	\N	93322	93322	93323
20608	30178	9	applied	\N	\N	\N	\N	93417	93417	93256
20608	30113	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20608	29898	11	applied	\N	\N	1000000000	\N	92361	92361	92362
20608	30203	12	applied	\N	\N	\N	\N	93324	93324	93325
20608	30187	13	applied	\N	\N	\N	\N	93276	93276	93277
20608	30188	14	applied	\N	\N	\N	\N	93418	93418	93279
20608	30189	15	applied	\N	\N	\N	\N	93419	93419	93281
20608	30190	16	applied	\N	\N	\N	\N	93420	93420	93283
20608	30056	17	applied	\N	\N	\N	\N	92871	92871	92872
20608	29971	18	applied	\N	\N	\N	\N	92629	92629	92762
20608	30159	19	applied	\N	\N	\N	\N	93184	93184	93156
20608	30142	20	applied	\N	\N	\N	\N	93238	93238	93092
20608	30143	21	applied	\N	\N	\N	\N	93239	93239	93094
20608	30144	22	applied	\N	\N	\N	\N	93240	93240	93096
20614	30245	0	applied	\N	\N	\N	\N	93468	93468	93469
20614	30246	1	applied	\N	\N	\N	\N	93470	93470	93471
20614	30247	2	applied	\N	\N	\N	\N	93472	93472	93473
20621	30270	0	applied	\N	\N	\N	\N	93524	93524	93525
20621	30271	1	applied	\N	\N	\N	\N	93526	93526	93526
20621	30272	2	applied	\N	\N	1000000000	\N	93527	93527	93528
20621	30273	3	applied	\N	\N	1000000000	\N	93529	93529	93530
20621	30274	4	applied	\N	\N	1000000000	\N	93531	93531	93532
20622	30275	0	applied	\N	\N	\N	\N	93534	93534	93535
20622	30276	1	applied	\N	\N	\N	\N	93536	93536	93537
20622	30277	2	applied	\N	\N	\N	\N	93538	93538	93539
20622	30278	3	applied	\N	\N	\N	\N	93540	93540	93541
20622	30279	4	applied	\N	\N	\N	\N	93542	93542	93542
20622	30280	5	applied	\N	\N	\N	\N	93543	93543	93544
20622	30281	6	applied	\N	\N	\N	\N	93545	93545	93546
20633	30336	0	applied	\N	\N	\N	\N	93700	93700	93701
20633	30337	1	applied	\N	\N	\N	\N	93702	93702	93703
20633	30338	2	applied	\N	\N	\N	\N	93704	93704	93705
20633	30339	3	applied	\N	\N	\N	\N	93706	93706	93707
20633	30340	4	applied	\N	\N	\N	\N	93708	93708	93709
20633	30341	5	applied	\N	\N	\N	\N	93710	93710	93711
20633	30342	6	applied	\N	\N	\N	\N	93712	93712	93713
20633	30343	7	applied	\N	\N	\N	\N	93714	93714	93715
20633	30344	8	applied	\N	\N	\N	\N	93716	93716	93717
20633	30345	9	applied	\N	\N	\N	\N	93718	93718	93719
20633	30346	10	applied	\N	\N	\N	\N	93720	93720	93721
20638	30352	0	applied	\N	\N	\N	\N	93741	93741	93742
20638	30353	1	applied	\N	\N	\N	\N	93743	93743	93744
20638	30354	2	applied	\N	\N	\N	\N	93745	93745	93746
20638	30355	3	applied	\N	\N	\N	\N	93747	93747	93748
20639	30356	0	applied	\N	\N	\N	\N	93753	93753	93754
20639	30357	1	applied	\N	\N	\N	\N	93755	93755	93756
20639	30358	2	applied	\N	\N	\N	\N	93757	93757	93758
20645	30371	0	applied	\N	\N	\N	\N	93789	93789	93790
20645	30372	1	applied	\N	\N	\N	\N	93791	93791	93792
20645	30373	2	applied	\N	\N	\N	\N	93793	93793	93794
20655	30382	0	applied	\N	\N	\N	\N	93848	93848	93849
20655	30383	1	applied	\N	\N	\N	\N	93850	93850	93851
20655	30384	2	applied	\N	\N	\N	\N	93852	93852	93853
20659	30385	0	applied	\N	\N	\N	\N	93858	93858	93859
20659	30386	1	applied	\N	\N	\N	\N	93860	93860	93861
20659	30387	2	applied	\N	\N	\N	\N	93862	93862	93863
20659	30388	3	applied	\N	\N	\N	\N	93864	93864	93865
20660	30389	0	applied	\N	\N	\N	\N	93872	93872	93873
20660	30390	1	applied	\N	\N	\N	\N	93874	93874	93875
20660	30391	2	applied	\N	\N	\N	\N	93876	93876	93877
20664	30392	0	applied	\N	\N	\N	\N	93880	93880	93881
20664	30393	1	applied	\N	\N	\N	\N	93882	93882	93883
20666	30394	0	applied	\N	\N	\N	\N	93885	93885	93886
20666	30395	1	applied	\N	\N	\N	\N	93887	93887	93888
20666	30396	2	applied	\N	\N	\N	\N	93889	93889	93890
20666	30397	3	applied	\N	\N	\N	\N	93891	93891	93892
20666	30398	4	applied	\N	\N	\N	\N	93893	93893	93894
20666	30399	5	applied	\N	\N	\N	\N	93895	93895	93896
20666	30400	6	applied	\N	\N	\N	\N	93897	93897	93898
20666	30401	7	applied	\N	\N	\N	\N	93899	93899	93900
20666	30402	8	applied	\N	\N	\N	\N	93901	93901	93902
20666	30403	9	applied	\N	\N	\N	\N	93903	93903	93904
20666	30404	10	applied	\N	\N	\N	\N	93905	93905	93906
20666	30405	11	applied	\N	\N	\N	\N	93907	93907	93908
20666	30406	12	applied	\N	\N	\N	\N	93909	93909	93910
20671	30410	0	applied	\N	\N	\N	\N	93927	93927	93928
20671	30411	2	applied	\N	\N	\N	\N	93930	93930	93931
20671	30412	3	applied	\N	\N	\N	\N	93932	93932	93933
20672	30413	0	applied	\N	\N	\N	\N	93938	93938	93939
20672	30414	1	applied	\N	\N	\N	\N	93940	93940	93941
20672	30415	2	applied	\N	\N	\N	\N	93942	93942	93943
20677	30416	0	applied	\N	\N	\N	\N	93947	93947	93948
20677	30417	1	applied	\N	\N	\N	\N	93949	93949	93950
20677	30418	2	applied	\N	\N	\N	\N	93951	93951	93952
20677	30419	3	applied	\N	\N	\N	\N	93953	93953	93954
20677	30420	4	applied	\N	\N	\N	\N	93955	93955	93956
20583	30178	0	applied	\N	\N	\N	\N	93255	93255	93256
20583	30179	1	applied	\N	\N	\N	\N	93257	93257	93258
20583	30180	2	applied	\N	\N	\N	\N	93259	93259	93260
20583	30181	3	applied	\N	\N	\N	\N	93261	93261	93262
20583	30182	4	applied	\N	\N	\N	\N	93263	93263	93264
20583	30183	5	applied	\N	\N	\N	\N	93265	93265	93266
20583	30185	6	applied	\N	\N	\N	\N	93269	93269	93272
20584	30186	0	applied	\N	\N	\N	\N	93274	93274	93275
20584	30187	1	applied	\N	\N	\N	\N	93276	93276	93277
20584	30188	2	applied	\N	\N	\N	\N	93278	93278	93279
20584	30189	3	applied	\N	\N	\N	\N	93280	93280	93281
20584	30190	4	applied	\N	\N	\N	\N	93282	93282	93283
20584	30191	5	applied	\N	\N	\N	\N	93284	93284	93285
20584	30192	6	applied	\N	\N	\N	\N	93286	93286	93287
20584	30193	7	applied	\N	\N	\N	\N	93288	93288	93289
20584	30194	8	applied	\N	\N	\N	\N	93290	93290	93291
20584	30184	9	applied	\N	\N	\N	\N	93267	93267	93292
20588	30195	0	applied	\N	\N	\N	\N	93298	93298	93299
20588	30196	1	applied	\N	\N	\N	\N	93300	93300	93301
20588	30197	2	applied	\N	\N	\N	\N	93302	93302	93303
20588	30198	3	applied	\N	\N	\N	\N	93304	93304	93305
20593	30202	0	applied	\N	\N	\N	\N	93322	93322	93323
20593	30203	1	applied	\N	\N	\N	\N	93324	93324	93325
20593	30204	2	applied	\N	\N	\N	\N	93326	93326	93327
20593	30205	3	applied	\N	\N	\N	\N	93328	93328	93329
20593	30206	4	applied	\N	\N	\N	\N	93330	93330	93331
20593	30207	5	applied	\N	\N	\N	\N	93332	93332	93333
20598	30214	0	applied	\N	\N	\N	\N	93381	93381	93382
20598	30215	1	applied	\N	\N	\N	\N	93383	93383	93384
20598	30216	2	applied	\N	\N	\N	\N	93385	93385	93386
20599	30217	0	applied	\N	\N	\N	\N	93389	93389	93390
20599	30218	1	applied	\N	\N	\N	\N	93391	93391	93392
20599	30219	2	applied	\N	\N	\N	\N	93393	93393	93394
20599	30220	3	applied	\N	\N	\N	\N	93395	93395	93396
20604	30224	0	applied	\N	\N	\N	\N	93408	93408	93409
20604	30225	1	applied	\N	\N	\N	\N	93410	93410	93411
20609	30226	0	applied	\N	\N	\N	\N	93423	93423	93424
20609	30227	1	applied	\N	\N	\N	\N	93425	93425	93426
20609	30228	2	applied	\N	\N	\N	\N	93427	93427	93428
20609	30229	3	applied	\N	\N	\N	\N	93429	93429	93430
20609	30230	4	applied	\N	\N	\N	\N	93431	93431	93432
20609	30231	5	applied	\N	\N	\N	\N	93433	93433	93434
20610	30232	0	applied	\N	\N	\N	\N	93436	93436	93437
20610	30233	1	applied	\N	\N	\N	\N	93438	93438	93439
20610	30234	2	applied	\N	\N	\N	\N	93440	93440	93441
20610	30235	3	applied	\N	\N	\N	\N	93442	93442	93443
20610	30236	4	applied	\N	\N	\N	\N	93444	93444	93445
20610	30237	5	applied	\N	\N	\N	\N	93446	93446	93447
20610	30238	6	applied	\N	\N	\N	\N	93448	93448	93449
20610	30239	7	applied	\N	\N	\N	\N	93450	93450	93451
20610	30240	8	applied	\N	\N	\N	\N	93452	93452	93453
20610	30241	9	applied	\N	\N	\N	\N	93454	93454	93455
20615	30245	0	applied	\N	\N	\N	\N	93468	93468	93469
20615	30246	1	applied	\N	\N	\N	\N	93470	93470	93471
20615	30247	2	applied	\N	\N	\N	\N	93472	93472	93473
20616	30248	0	applied	\N	\N	\N	\N	93476	93476	93477
20616	30249	1	applied	\N	\N	\N	\N	93478	93478	93479
20616	30250	2	applied	\N	\N	\N	\N	93480	93480	93481
20616	30251	3	applied	\N	\N	\N	\N	93482	93482	93482
20616	30252	4	applied	\N	\N	\N	\N	93483	93483	93484
20617	30253	0	applied	\N	\N	\N	\N	93487	93487	93488
20617	30254	1	applied	\N	\N	\N	\N	93489	93489	93490
20617	30255	2	applied	\N	\N	\N	\N	93491	93491	93491
20617	30256	3	applied	\N	\N	\N	\N	93492	93492	93493
20617	30257	4	applied	\N	\N	\N	\N	93494	93494	93495
20623	30202	0	applied	\N	\N	\N	\N	93322	93322	93323
20623	30203	1	applied	\N	\N	\N	\N	93324	93324	93325
20623	30275	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	93548	93548	\N
20623	30208	3	applied	\N	\N	\N	\N	93339	93339	93340
20623	30209	4	applied	\N	\N	\N	\N	93341	93341	93342
20623	30211	5	applied	\N	\N	\N	\N	93345	93345	93346
20623	30204	6	applied	\N	\N	\N	\N	93326	93326	93327
20623	30212	7	applied	\N	\N	\N	\N	93347	93347	93348
20623	30214	8	applied	\N	\N	\N	\N	93381	93381	93382
20623	30217	9	applied	\N	\N	\N	\N	93389	93389	93390
20623	30221	10	applied	\N	\N	\N	\N	93398	93398	93399
20623	30224	11	applied	\N	\N	\N	\N	93408	93408	93409
20623	30226	12	applied	\N	\N	\N	\N	93423	93423	93424
20623	30227	13	applied	\N	\N	\N	\N	93425	93425	93426
20623	30232	14	applied	\N	\N	\N	\N	93436	93436	93437
20623	30233	15	applied	\N	\N	\N	\N	93438	93438	93439
20623	30234	16	applied	\N	\N	\N	\N	93440	93440	93441
20623	30242	17	applied	\N	\N	\N	\N	93460	93460	93461
20623	30245	18	applied	\N	\N	\N	\N	93468	93468	93469
20623	30248	19	applied	\N	\N	\N	\N	93476	93476	93477
20623	30253	20	applied	\N	\N	\N	\N	93487	93487	93488
20623	30254	21	applied	\N	\N	\N	\N	93489	93489	93490
20623	30258	22	applied	\N	\N	\N	\N	93498	93498	93499
20623	30265	23	applied	\N	\N	1000000000	\N	93512	93512	93513
20623	30266	24	applied	\N	\N	1000000000	\N	93514	93514	93515
20623	30267	25	applied	\N	\N	\N	\N	93516	93516	93517
20623	30205	26	applied	\N	\N	\N	\N	93328	93328	93329
20623	30215	28	applied	\N	\N	\N	\N	93383	93383	93333
20623	30251	29	applied	\N	\N	\N	\N	93482	93482	93482
20623	30255	30	applied	\N	\N	\N	\N	93491	93491	93491
20623	30261	31	applied	\N	\N	\N	\N	93504	93504	93504
20623	30271	32	applied	\N	\N	\N	\N	93526	93526	93526
20623	30279	33	applied	\N	\N	\N	\N	93542	93542	93542
20623	30272	34	applied	\N	\N	1000000000	\N	93527	93527	93528
20623	30273	35	applied	\N	\N	1000000000	\N	93529	93529	93530
20623	30274	36	applied	\N	\N	1000000000	\N	93531	93531	93532
20623	30206	37	applied	\N	\N	\N	\N	93330	93330	93550
20623	30219	38	applied	\N	\N	\N	\N	93393	93393	93378
20623	30229	39	applied	\N	\N	\N	\N	93429	93429	93551
20623	30235	40	applied	\N	\N	\N	\N	93442	93442	93552
20623	30249	41	applied	\N	\N	\N	\N	93478	93478	93384
20623	30264	42	applied	\N	\N	\N	\N	93509	93509	93553
20623	30278	43	applied	\N	\N	\N	\N	93540	93540	93386
20623	30220	44	applied	\N	\N	\N	\N	93395	93395	93394
20623	30223	45	applied	\N	\N	\N	\N	93402	93402	93396
20623	30228	46	applied	\N	\N	\N	\N	93427	93427	93554
20623	30236	47	applied	\N	\N	\N	\N	93444	93444	93555
20623	30237	48	applied	\N	\N	\N	\N	93446	93446	93556
20623	30241	49	applied	\N	\N	\N	\N	93454	93454	93557
20623	30244	50	applied	\N	\N	\N	\N	93464	93464	93434
20623	30247	51	applied	\N	\N	\N	\N	93472	93472	93558
20623	30252	52	applied	\N	\N	\N	\N	93483	93483	93559
20623	30256	53	applied	\N	\N	\N	\N	93492	93492	93449
20623	30257	54	applied	\N	\N	\N	\N	93494	93494	93560
20596	30118	95	applied	\N	\N	\N	\N	93022	93022	93363
20596	30120	96	applied	\N	\N	\N	\N	93026	93026	93364
20596	30122	97	applied	\N	\N	\N	\N	93031	93031	92992
20596	30126	98	applied	\N	\N	\N	\N	93040	93040	93365
20596	30132	99	applied	\N	\N	\N	\N	93059	93059	93366
20596	30133	100	applied	\N	\N	\N	\N	93061	93061	93004
20596	30136	101	applied	\N	\N	\N	\N	93068	93068	93008
20596	30139	102	applied	\N	\N	\N	\N	93080	93080	93367
20596	30153	103	applied	\N	\N	\N	\N	93113	93113	93021
20596	30154	104	applied	\N	\N	\N	\N	93115	93115	93023
20596	30158	105	applied	\N	\N	\N	\N	93145	93145	93368
20596	30163	106	applied	\N	\N	\N	\N	93163	93163	93369
20596	30083	107	applied	\N	\N	\N	\N	92929	92929	93032
20596	30085	108	applied	\N	\N	\N	\N	92935	92935	93034
20596	30091	109	applied	\N	\N	\N	\N	92950	92950	93039
20596	30095	110	applied	\N	\N	\N	\N	92970	92970	93054
20596	30099	111	applied	\N	\N	\N	\N	92979	92979	93056
20596	30104	112	applied	\N	\N	\N	\N	92991	92991	93058
20596	30109	113	applied	\N	\N	\N	\N	93003	93003	93370
20596	30116	114	applied	\N	\N	\N	\N	93018	93018	93371
20596	30119	115	applied	\N	\N	\N	\N	93024	93024	93069
20596	30123	116	applied	\N	\N	\N	\N	93033	93033	93079
20596	30125	117	applied	\N	\N	\N	\N	93038	93038	93083
20596	30130	118	applied	\N	\N	\N	\N	93055	93055	93112
20596	30131	119	applied	\N	\N	\N	\N	93057	93057	93372
20596	30135	120	applied	\N	\N	\N	\N	93066	93066	93373
20596	30138	121	applied	\N	\N	\N	\N	93078	93078	93146
20596	30152	122	applied	\N	\N	\N	\N	93111	93111	93164
20596	30157	123	applied	\N	\N	\N	\N	93143	93143	93166
20596	30164	124	applied	\N	\N	\N	\N	93165	93165	93168
20596	30165	125	applied	\N	\N	\N	\N	93167	93167	93374
20601	30221	0	applied	\N	\N	\N	\N	93398	93398	93399
20601	30222	1	applied	\N	\N	\N	\N	93400	93400	93401
20601	30223	2	applied	\N	\N	\N	\N	93402	93402	93403
20602	30224	0	applied	\N	\N	\N	\N	93408	93408	93409
20602	30225	1	applied	\N	\N	\N	\N	93410	93410	93411
20606	30224	0	applied	\N	\N	\N	\N	93408	93408	93409
20606	30225	1	applied	\N	\N	\N	\N	93410	93410	93411
20613	30242	0	applied	\N	\N	\N	\N	93460	93460	93461
20613	30243	1	applied	\N	\N	\N	\N	93462	93462	93463
20613	30244	2	applied	\N	\N	\N	\N	93464	93464	93465
20620	30202	0	applied	\N	\N	\N	\N	93322	93322	93323
20620	30178	1	applied	\N	\N	\N	\N	93255	93255	93256
20620	30113	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20620	30203	3	applied	\N	\N	\N	\N	93324	93324	93325
20620	30187	4	applied	\N	\N	\N	\N	93276	93276	93277
20620	30188	5	applied	\N	\N	\N	\N	93278	93278	93279
20620	30189	6	applied	\N	\N	\N	\N	93280	93280	93281
20620	30190	7	applied	\N	\N	\N	\N	93282	93282	93283
20620	30208	8	applied	\N	\N	\N	\N	93339	93339	93340
20620	30209	9	applied	\N	\N	\N	\N	93341	93341	93342
20620	30191	10	applied	\N	\N	\N	\N	93284	93284	93285
20620	30192	11	applied	\N	\N	\N	\N	93286	93286	93287
20620	30193	12	applied	\N	\N	\N	\N	93288	93288	93289
20620	30210	13	applied	\N	\N	\N	\N	93343	93343	93344
20620	30211	14	applied	\N	\N	\N	\N	93345	93345	93346
20620	30110	15	applied	\N	\N	1000000000	\N	93005	93005	93006
20620	30265	16	applied	\N	\N	1000000000	\N	93512	93512	93513
20620	30266	17	applied	\N	\N	1000000000	\N	93514	93514	93515
20620	30267	18	applied	\N	\N	\N	\N	93516	93516	93517
20620	30251	19	applied	\N	\N	\N	\N	93482	93482	93482
20620	30255	20	applied	\N	\N	\N	\N	93491	93491	93491
20620	30261	21	applied	\N	\N	\N	\N	93504	93504	93504
20620	30170	22	applied	\N	\N	\N	\N	93215	93215	47675
20625	30275	0	applied	\N	\N	\N	\N	93534	93534	93535
20625	30276	1	applied	\N	\N	\N	\N	93536	93536	93537
20625	30277	2	applied	\N	\N	\N	\N	93538	93538	93539
20625	30278	3	applied	\N	\N	\N	\N	93540	93540	93541
20625	30279	4	applied	\N	\N	\N	\N	93542	93542	93542
20625	30280	5	applied	\N	\N	\N	\N	93543	93543	93544
20625	30281	6	applied	\N	\N	\N	\N	93545	93545	93546
20626	30282	0	applied	\N	\N	\N	\N	93581	93581	93582
20626	30283	1	applied	\N	\N	\N	\N	93583	93583	93583
20626	30284	2	applied	\N	\N	\N	\N	93584	93584	93585
20626	30285	3	applied	\N	\N	\N	\N	93586	93586	93587
20626	30286	4	applied	\N	\N	\N	\N	93588	93588	93589
20626	30287	5	applied	\N	\N	\N	\N	93590	93590	93591
20627	30288	0	applied	\N	\N	\N	\N	93594	93594	93595
20627	30289	1	applied	\N	\N	\N	\N	93596	93596	93597
20627	30290	2	applied	\N	\N	\N	\N	93598	93598	93599
20627	30291	3	applied	\N	\N	\N	\N	93600	93600	93601
20627	30292	4	applied	\N	\N	\N	\N	93602	93602	93603
20628	30293	0	applied	\N	\N	\N	\N	93605	93605	93606
20628	30294	1	applied	\N	\N	\N	\N	93607	93607	93608
20628	30295	2	applied	\N	\N	\N	\N	93609	93609	93610
20628	30296	3	applied	\N	\N	\N	\N	93611	93611	93612
20628	30297	4	applied	\N	\N	\N	\N	93613	93613	93614
20628	30298	5	applied	\N	\N	\N	\N	93615	93615	93616
20628	30299	6	applied	\N	\N	\N	\N	93617	93617	93618
20628	30300	7	applied	\N	\N	\N	\N	93619	93619	93620
20628	30301	8	applied	\N	\N	\N	\N	93621	93621	93622
20628	30302	9	applied	\N	\N	\N	\N	93623	93623	93624
20628	30303	10	applied	\N	\N	\N	\N	93625	93625	93626
20628	30304	11	applied	\N	\N	\N	\N	93627	93627	93628
20629	30305	0	applied	\N	\N	\N	\N	93631	93631	93632
20629	30306	1	applied	\N	\N	\N	\N	93633	93633	93634
20629	30307	2	applied	\N	\N	\N	\N	93635	93635	93636
20629	30308	3	applied	\N	\N	\N	\N	93637	93637	93638
20629	30309	4	applied	\N	\N	1000000000	\N	93639	93639	93640
20629	30310	5	applied	\N	\N	\N	\N	93641	93641	93642
20629	30311	6	applied	\N	\N	\N	\N	93643	93643	93644
20630	30312	0	applied	\N	\N	\N	\N	93647	93647	93648
20630	30313	1	applied	\N	\N	\N	\N	93649	93649	93650
20630	30314	2	applied	\N	\N	\N	\N	93651	93651	93652
20630	30315	3	applied	\N	\N	\N	\N	93653	93653	93654
20630	30316	4	applied	\N	\N	\N	\N	93655	93655	93656
20630	30317	5	applied	\N	\N	\N	\N	93657	93657	93658
20630	30318	6	applied	\N	\N	\N	\N	93659	93659	93660
20630	30319	7	applied	\N	\N	\N	\N	93661	93661	93662
20630	30320	8	applied	\N	\N	\N	\N	93663	93663	93664
20630	30321	10	applied	\N	\N	\N	\N	93666	93666	93667
20630	30322	11	applied	\N	\N	\N	\N	93668	93668	93669
20630	30323	12	applied	\N	\N	\N	\N	93670	93670	93671
20631	30324	0	applied	\N	\N	\N	\N	93674	93674	93675
20631	30325	1	applied	\N	\N	\N	\N	93676	93676	93677
20631	30326	2	applied	\N	\N	\N	\N	93678	93678	93679
20631	30327	3	applied	\N	\N	\N	\N	93680	93680	93681
20631	30328	4	applied	\N	\N	\N	\N	93682	93682	93683
20631	30329	5	applied	\N	\N	\N	\N	93684	93684	93685
20623	30259	55	applied	\N	\N	\N	\N	93500	93500	93561
20623	30269	56	applied	\N	\N	\N	\N	93520	93520	93463
20623	30280	57	applied	\N	\N	\N	\N	93543	93543	93465
20623	30281	58	applied	\N	\N	\N	\N	93545	93545	93562
20623	30207	59	applied	\N	\N	\N	\N	93332	93332	93473
20623	30213	60	applied	\N	\N	\N	\N	93377	93377	93563
20623	30216	61	applied	\N	\N	\N	\N	93385	93385	93564
20623	30218	62	applied	\N	\N	\N	\N	93391	93391	93484
20623	30222	63	applied	\N	\N	\N	\N	93400	93400	93565
20623	30225	64	applied	\N	\N	\N	\N	93410	93410	93566
20623	30230	65	applied	\N	\N	\N	\N	93431	93431	93495
20623	30231	66	applied	\N	\N	\N	\N	93433	93433	93567
20623	30238	67	applied	\N	\N	\N	\N	93448	93448	93568
20623	30239	68	applied	\N	\N	\N	\N	93450	93450	93569
20623	30240	69	applied	\N	\N	\N	\N	93452	93452	93570
20623	30243	70	applied	\N	\N	\N	\N	93462	93462	93510
20623	30246	71	applied	\N	\N	\N	\N	93470	93470	93519
20623	30250	72	applied	\N	\N	\N	\N	93480	93480	93571
20623	30260	73	applied	\N	\N	\N	\N	93502	93502	93572
20623	30262	74	applied	\N	\N	\N	\N	93505	93505	93573
20623	30263	75	applied	\N	\N	\N	\N	93507	93507	93574
20623	30268	76	applied	\N	\N	\N	\N	93518	93518	93541
20623	30270	77	applied	\N	\N	\N	\N	93524	93524	93575
20623	30276	78	applied	\N	\N	\N	\N	93536	93536	93576
20623	30277	79	applied	\N	\N	\N	\N	93538	93538	93546
20634	30347	0	applied	\N	\N	\N	\N	93725	93725	93726
20634	30348	1	applied	\N	\N	\N	\N	93727	93727	93728
20634	30349	2	applied	\N	\N	\N	\N	93729	93729	93730
20640	30359	0	applied	\N	\N	\N	\N	93761	93761	93762
20640	30360	1	applied	\N	\N	\N	\N	93763	93763	93764
20640	30361	2	applied	\N	\N	\N	\N	93765	93765	93766
20641	30362	0	applied	\N	\N	\N	\N	93767	93767	93768
20641	30363	1	applied	\N	\N	\N	\N	93769	93769	93770
20641	30364	2	applied	\N	\N	\N	\N	93771	93771	93772
20641	30365	3	applied	\N	\N	\N	\N	93773	93773	93774
20641	30366	4	applied	\N	\N	\N	\N	93775	93775	93776
20641	30367	5	applied	\N	\N	\N	\N	93777	93777	93778
20642	30368	0	applied	\N	\N	\N	\N	93781	93781	93782
20642	30369	1	applied	\N	\N	\N	\N	93783	93783	93784
20642	30370	2	applied	\N	\N	\N	\N	93785	93785	93786
20646	30324	0	applied	\N	\N	\N	\N	93674	93674	93675
20646	30312	1	applied	\N	\N	\N	\N	93647	93647	93648
20646	30313	2	applied	\N	\N	\N	\N	93649	93649	93650
20646	30314	3	applied	\N	\N	\N	\N	93651	93651	93652
20646	30336	4	applied	\N	\N	\N	\N	93700	93700	93701
20646	30337	5	applied	\N	\N	\N	\N	93702	93702	93703
20646	30338	6	applied	\N	\N	\N	\N	93704	93704	93705
20646	30315	7	applied	\N	\N	\N	\N	93653	93653	93654
20646	30202	8	applied	\N	\N	\N	\N	93322	93322	93323
20646	30203	9	applied	\N	\N	\N	\N	93324	93324	93325
20646	30325	10	applied	\N	\N	\N	\N	93676	93676	93677
20646	30275	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	93548	93548	\N
20646	30326	12	applied	\N	\N	\N	\N	93678	93678	93679
20646	30340	13	applied	\N	\N	\N	\N	93708	93708	93709
20646	30341	14	applied	\N	\N	\N	\N	93710	93710	93711
20646	30342	15	applied	\N	\N	\N	\N	93712	93712	93713
20646	30343	16	applied	\N	\N	\N	\N	93714	93714	93715
20646	30195	17	applied	\N	\N	\N	\N	93298	93298	93299
20646	30199	18	applied	\N	\N	\N	\N	93312	93312	93313
20646	30208	19	applied	\N	\N	\N	\N	93339	93339	93340
20646	30209	20	applied	\N	\N	\N	\N	93341	93341	93342
20646	30329	21	applied	\N	\N	\N	\N	93684	93684	93685
20646	30330	22	applied	\N	\N	\N	\N	93686	93686	93687
20646	30331	23	applied	\N	\N	\N	\N	93688	93688	93689
20646	30211	24	applied	\N	\N	\N	\N	93345	93345	93346
20646	30204	25	applied	\N	\N	\N	\N	93326	93326	93327
20646	30212	26	applied	\N	\N	\N	\N	93347	93347	93348
20646	30214	27	applied	\N	\N	\N	\N	93381	93381	93382
20646	30217	28	applied	\N	\N	\N	\N	93389	93389	93390
20646	30221	29	applied	\N	\N	\N	\N	93398	93398	93399
20646	30224	30	applied	\N	\N	\N	\N	93408	93408	93409
20646	30226	31	applied	\N	\N	\N	\N	93423	93423	93424
20646	30227	32	applied	\N	\N	\N	\N	93425	93425	93426
20646	30232	33	applied	\N	\N	\N	\N	93436	93436	93437
20646	30233	34	applied	\N	\N	\N	\N	93438	93438	93439
20646	30234	35	applied	\N	\N	\N	\N	93440	93440	93441
20646	30242	36	applied	\N	\N	\N	\N	93460	93460	93461
20646	30245	37	applied	\N	\N	\N	\N	93468	93468	93469
20646	30248	39	applied	\N	\N	\N	\N	93476	93476	93477
20646	30253	40	applied	\N	\N	\N	\N	93487	93487	93488
20646	30254	41	applied	\N	\N	\N	\N	93489	93489	93490
20646	30258	42	applied	\N	\N	\N	\N	93498	93498	93499
20646	30282	43	applied	\N	\N	\N	\N	93581	93581	93582
20646	30288	44	applied	\N	\N	\N	\N	93594	93594	93595
20646	30293	45	applied	\N	\N	\N	\N	93605	93605	93606
20646	30294	46	applied	\N	\N	\N	\N	93607	93607	93608
20646	30295	47	applied	\N	\N	\N	\N	93609	93609	93610
20646	30305	48	applied	\N	\N	\N	\N	93631	93631	93632
20646	30306	49	applied	\N	\N	\N	\N	93633	93633	93634
20646	30316	50	applied	\N	\N	\N	\N	93655	93655	93656
20646	30317	51	applied	\N	\N	\N	\N	93657	93657	93658
20646	30327	52	applied	\N	\N	\N	\N	93680	93680	93681
20646	30328	53	applied	\N	\N	\N	\N	93682	93682	93683
20646	30339	54	applied	\N	\N	\N	\N	93706	93706	93707
20646	30347	55	applied	\N	\N	\N	\N	93725	93725	93726
20646	30350	56	applied	\N	\N	\N	\N	93735	93735	93736
20646	30352	57	applied	\N	\N	\N	\N	93741	93741	93742
20646	30356	58	applied	\N	\N	\N	\N	93753	93753	93754
20646	30359	59	applied	\N	\N	\N	\N	93761	93761	93762
20646	30362	60	applied	\N	\N	\N	\N	93767	93767	93768
20646	30363	61	applied	\N	\N	\N	\N	93769	93769	93770
20646	30368	62	applied	\N	\N	\N	\N	93781	93781	93782
20646	30371	63	applied	\N	\N	\N	\N	93789	93789	93790
20646	30265	64	applied	\N	\N	1000000000	\N	93512	93512	93513
20646	30266	65	applied	\N	\N	1000000000	\N	93514	93514	93515
20646	30267	66	applied	\N	\N	\N	\N	93516	93516	93517
20646	30251	67	applied	\N	\N	\N	\N	93482	93482	93482
20646	30255	68	applied	\N	\N	\N	\N	93491	93491	93491
20646	30197	69	applied	\N	\N	\N	\N	93302	93302	93303
20646	30261	70	applied	\N	\N	\N	\N	93504	93504	93504
20646	30271	71	applied	\N	\N	\N	\N	93526	93526	93526
20646	30291	72	applied	\N	\N	\N	\N	93600	93600	93601
20646	30296	73	applied	\N	\N	\N	\N	93611	93611	93612
20646	30279	74	applied	\N	\N	\N	\N	93542	93542	93542
20646	30283	75	applied	\N	\N	\N	\N	93583	93583	93583
20646	30300	76	applied	\N	\N	\N	\N	93619	93619	93620
20646	30301	77	applied	\N	\N	\N	\N	93621	93621	93622
20646	30272	78	applied	\N	\N	1000000000	\N	93527	93527	93528
20646	30273	79	applied	\N	\N	1000000000	\N	93529	93529	93530
20631	30330	6	applied	\N	\N	\N	\N	93686	93686	93687
20631	30331	7	applied	\N	\N	\N	\N	93688	93688	93689
20631	30332	8	applied	\N	\N	\N	\N	93690	93690	93691
20631	30333	9	applied	\N	\N	\N	\N	93692	93692	93693
20631	30334	10	applied	\N	\N	\N	\N	93694	93694	93695
20631	30335	11	applied	\N	\N	\N	\N	93696	93696	93697
20632	30336	0	applied	\N	\N	\N	\N	93700	93700	93701
20632	30337	1	applied	\N	\N	\N	\N	93702	93702	93703
20632	30338	2	applied	\N	\N	\N	\N	93704	93704	93705
20632	30339	3	applied	\N	\N	\N	\N	93706	93706	93707
20632	30340	4	applied	\N	\N	\N	\N	93708	93708	93709
20632	30341	5	applied	\N	\N	\N	\N	93710	93710	93711
20632	30342	6	applied	\N	\N	\N	\N	93712	93712	93713
20632	30343	7	applied	\N	\N	\N	\N	93714	93714	93715
20632	30344	8	applied	\N	\N	\N	\N	93716	93716	93717
20632	30345	9	applied	\N	\N	\N	\N	93718	93718	93719
20632	30346	10	applied	\N	\N	\N	\N	93720	93720	93721
20637	30352	0	applied	\N	\N	\N	\N	93741	93741	93742
20637	30353	1	applied	\N	\N	\N	\N	93743	93743	93744
20637	30354	2	applied	\N	\N	\N	\N	93745	93745	93746
20637	30355	3	applied	\N	\N	\N	\N	93747	93747	93748
20644	30371	0	applied	\N	\N	\N	\N	93789	93789	93790
20644	30372	1	applied	\N	\N	\N	\N	93791	93791	93792
20644	30373	2	applied	\N	\N	\N	\N	93793	93793	93794
20649	30374	0	applied	\N	\N	\N	\N	93817	93817	93818
20649	30375	1	applied	\N	\N	\N	\N	93819	93819	93820
20649	30376	2	applied	\N	\N	\N	\N	93821	93821	93822
20649	30377	3	applied	\N	\N	\N	\N	93823	93823	93824
20653	30379	0	applied	\N	\N	\N	\N	93842	93842	93843
20653	30380	1	applied	\N	\N	\N	\N	93844	93844	93845
20653	30381	2	applied	\N	\N	\N	\N	93846	93846	93847
20654	30382	0	applied	\N	\N	\N	\N	93848	93848	93849
20654	30383	1	applied	\N	\N	\N	\N	93850	93850	93851
20654	30384	2	applied	\N	\N	\N	\N	93852	93852	93853
20658	30385	0	applied	\N	\N	\N	\N	93858	93858	93859
20658	30386	1	applied	\N	\N	\N	\N	93860	93860	93861
20658	30387	2	applied	\N	\N	\N	\N	93862	93862	93863
20658	30388	3	applied	\N	\N	\N	\N	93864	93864	93865
20663	30392	0	applied	\N	\N	\N	\N	93880	93880	93881
20663	30393	1	applied	\N	\N	\N	\N	93882	93882	93883
20665	30394	0	applied	\N	\N	\N	\N	93885	93885	93886
20665	30395	1	applied	\N	\N	\N	\N	93887	93887	93888
20665	30396	2	applied	\N	\N	\N	\N	93889	93889	93890
20665	30397	3	applied	\N	\N	\N	\N	93891	93891	93892
20665	30398	4	applied	\N	\N	\N	\N	93893	93893	93894
20665	30399	5	applied	\N	\N	\N	\N	93895	93895	93896
20665	30400	6	applied	\N	\N	\N	\N	93897	93897	93898
20665	30401	7	applied	\N	\N	\N	\N	93899	93899	93900
20665	30402	8	applied	\N	\N	\N	\N	93901	93901	93902
20665	30403	9	applied	\N	\N	\N	\N	93903	93903	93904
20665	30404	10	applied	\N	\N	\N	\N	93905	93905	93906
20665	30405	11	applied	\N	\N	\N	\N	93907	93907	93908
20665	30406	12	applied	\N	\N	\N	\N	93909	93909	93910
20670	30410	0	applied	\N	\N	\N	\N	93927	93927	93928
20670	30411	2	applied	\N	\N	\N	\N	93930	93930	93931
20670	30412	3	applied	\N	\N	\N	\N	93932	93932	93933
20676	30416	0	applied	\N	\N	\N	\N	93947	93947	93948
20676	30417	1	applied	\N	\N	\N	\N	93949	93949	93950
20676	30418	2	applied	\N	\N	\N	\N	93951	93951	93952
20676	30419	3	applied	\N	\N	\N	\N	93953	93953	93954
20676	30420	4	applied	\N	\N	\N	\N	93955	93955	93956
20676	30421	5	applied	\N	\N	\N	\N	93957	93957	93958
20676	30422	6	applied	\N	\N	\N	\N	93959	93959	93960
20676	30423	7	applied	\N	\N	\N	\N	93961	93961	93962
20676	30424	8	applied	\N	\N	\N	\N	93963	93963	93964
20681	30428	0	applied	\N	\N	\N	\N	93998	93998	93999
20681	30429	1	applied	\N	\N	\N	\N	94000	94000	94001
20681	30430	2	applied	\N	\N	\N	\N	94002	94002	94003
20686	30434	0	applied	\N	\N	\N	\N	94054	94054	94055
20686	30435	1	applied	\N	\N	\N	\N	94056	94056	94057
20686	30436	2	applied	\N	\N	\N	\N	94058	94058	94059
20692	30444	0	applied	\N	\N	\N	\N	94077	94077	94078
20692	30445	1	applied	\N	\N	\N	\N	94079	94079	94080
20692	30446	2	applied	\N	\N	\N	\N	94083	94083	94084
20693	30447	0	applied	\N	\N	\N	\N	94088	94088	94089
20693	30448	1	applied	\N	\N	\N	\N	94090	94090	94091
20693	30449	2	applied	\N	\N	\N	\N	94092	94092	94093
20693	30450	3	applied	\N	\N	\N	\N	94094	94094	94095
20693	30451	4	applied	\N	\N	\N	\N	94096	94096	94097
20693	30452	5	applied	\N	\N	\N	\N	94098	94098	94099
20693	30453	6	applied	\N	\N	\N	\N	94100	94100	94101
20693	30454	7	applied	\N	\N	\N	\N	94102	94102	94103
20697	30455	0	applied	\N	\N	\N	\N	94118	94118	94109
20697	30456	1	applied	\N	\N	\N	\N	94119	94119	94111
20697	30457	2	applied	\N	\N	\N	\N	94120	94120	94113
20697	30458	3	applied	\N	\N	\N	\N	94121	94121	94122
20697	30459	4	applied	\N	\N	1000000000	\N	94123	94123	94124
20697	30460	5	applied	\N	\N	\N	\N	94125	94125	94126
20698	30461	0	applied	\N	\N	\N	\N	94130	94130	94131
20698	30462	1	applied	\N	\N	\N	\N	94132	94132	94133
20699	30463	0	applied	\N	\N	\N	\N	94136	94136	94137
20699	30464	1	applied	\N	\N	\N	\N	94138	94138	94139
20699	30465	2	applied	\N	\N	\N	\N	94140	94140	94141
20699	30466	3	applied	\N	\N	\N	\N	94142	94142	94143
20699	30467	4	applied	\N	\N	\N	\N	94144	94144	94145
20699	30468	5	applied	\N	\N	\N	\N	94146	94146	94147
20699	30469	6	applied	\N	\N	\N	\N	94148	94148	94149
20699	30470	7	applied	\N	\N	\N	\N	94150	94150	94151
20703	30471	0	applied	\N	\N	\N	\N	94158	94158	94159
20703	30472	1	applied	\N	\N	\N	\N	94160	94160	94161
20703	30473	2	applied	\N	\N	\N	\N	94162	94162	94163
20714	30488	0	applied	\N	\N	\N	\N	94204	94204	94205
20714	30489	1	applied	\N	\N	\N	\N	94206	94206	94207
20714	30490	2	applied	\N	\N	\N	\N	94208	94208	94209
20718	30491	0	applied	\N	\N	\N	\N	94244	94244	94245
20718	30492	1	applied	\N	\N	\N	\N	94246	94246	94247
20718	30493	2	applied	\N	\N	\N	\N	94248	94248	94249
20724	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20724	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20724	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20724	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20724	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20724	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20724	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20724	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20724	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20724	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20729	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20729	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20729	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20646	30274	80	applied	\N	\N	1000000000	\N	93531	93531	93532
20646	30198	81	applied	\N	\N	\N	\N	93304	93304	93305
20646	30200	82	applied	\N	\N	\N	\N	93314	93314	93315
20646	30205	83	applied	\N	\N	\N	\N	93328	93328	93335
20646	30215	84	applied	\N	\N	\N	\N	93383	93383	93331
20646	30206	85	applied	\N	\N	\N	\N	93330	93330	93802
20646	30201	86	applied	\N	\N	\N	\N	93316	93316	93550
20646	30219	87	applied	\N	\N	\N	\N	93393	93393	93378
20646	30229	88	applied	\N	\N	\N	\N	93429	93429	93551
20646	30235	89	applied	\N	\N	\N	\N	93442	93442	93552
20646	30249	90	applied	\N	\N	\N	\N	93478	93478	93384
20646	30264	91	applied	\N	\N	\N	\N	93509	93509	93553
20646	30278	92	applied	\N	\N	\N	\N	93540	93540	93386
20646	30289	93	applied	\N	\N	\N	\N	93596	93596	93803
20646	30309	94	applied	\N	\N	1000000000	\N	93639	93639	93640
20646	30323	95	applied	\N	\N	\N	\N	93670	93670	93671
20646	30304	96	applied	\N	\N	\N	\N	93627	93627	93392
20646	30322	97	applied	\N	\N	\N	\N	93668	93668	93394
20646	30345	98	applied	\N	\N	\N	\N	93718	93718	93804
20646	30354	99	applied	\N	\N	\N	\N	93745	93745	93805
20646	30367	100	applied	\N	\N	\N	\N	93777	93777	93396
20646	30220	101	applied	\N	\N	\N	\N	93395	93395	93554
20646	30223	102	applied	\N	\N	\N	\N	93402	93402	93555
20646	30228	103	applied	\N	\N	\N	\N	93427	93427	93556
20646	30236	104	applied	\N	\N	\N	\N	93444	93444	93557
20646	30237	105	applied	\N	\N	\N	\N	93446	93446	93434
20646	30241	106	applied	\N	\N	\N	\N	93454	93454	93558
20646	30244	107	applied	\N	\N	\N	\N	93464	93464	93559
20646	30247	108	applied	\N	\N	\N	\N	93472	93472	93449
20646	30252	109	applied	\N	\N	\N	\N	93483	93483	93560
20646	30256	110	applied	\N	\N	\N	\N	93492	93492	93561
20646	30257	111	applied	\N	\N	\N	\N	93494	93494	93463
20646	30259	112	applied	\N	\N	\N	\N	93500	93500	93465
20646	30269	113	applied	\N	\N	\N	\N	93520	93520	93562
20646	30280	114	applied	\N	\N	\N	\N	93543	93543	93479
20646	30281	115	applied	\N	\N	\N	\N	93545	93545	93564
20646	30285	116	applied	\N	\N	\N	\N	93586	93586	93806
20646	30286	117	applied	\N	\N	\N	\N	93588	93588	93566
20646	30290	118	applied	\N	\N	\N	\N	93598	93598	93807
20646	30302	119	applied	\N	\N	\N	\N	93623	93623	93568
20646	30303	120	applied	\N	\N	\N	\N	93625	93625	93506
20646	30310	121	applied	\N	\N	\N	\N	93641	93641	93510
20646	30311	122	applied	\N	\N	\N	\N	93643	93643	93808
20651	30324	0	applied	\N	\N	\N	\N	93674	93674	93675
20651	30312	1	applied	\N	\N	\N	\N	93647	93647	93648
20651	30313	2	applied	\N	\N	\N	\N	93649	93649	93650
20651	30314	3	applied	\N	\N	\N	\N	93651	93651	93652
20651	30336	4	applied	\N	\N	\N	\N	93700	93700	93701
20651	30337	5	applied	\N	\N	\N	\N	93702	93702	93703
20651	30338	6	applied	\N	\N	\N	\N	93704	93704	93705
20651	30315	7	applied	\N	\N	\N	\N	93653	93653	93654
20651	30076	8	applied	\N	\N	\N	\N	92913	92913	92914
20651	30080	9	applied	\N	\N	\N	\N	92923	92923	92924
20651	30087	10	applied	\N	\N	\N	\N	92942	92942	92943
20651	30088	11	applied	\N	\N	\N	\N	92944	92944	92945
20651	30202	12	applied	\N	\N	\N	\N	93322	93322	93323
20651	30178	13	applied	\N	\N	\N	\N	93417	93417	93256
20651	30113	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20651	29982	15	applied	\N	\N	\N	\N	92666	92666	92667
20651	30159	16	applied	\N	\N	\N	\N	93184	93184	93156
20651	30203	17	applied	\N	\N	\N	\N	93324	93324	93325
20651	30325	18	applied	\N	\N	\N	\N	93829	93829	93830
20651	30326	19	applied	\N	\N	\N	\N	93831	93831	93679
20651	30187	20	applied	\N	\N	\N	\N	93276	93276	93277
20651	30188	21	applied	\N	\N	\N	\N	93418	93418	93279
20651	30189	22	applied	\N	\N	\N	\N	93419	93419	93281
20651	30190	23	applied	\N	\N	\N	\N	93420	93420	93283
20651	30340	24	applied	\N	\N	\N	\N	93832	93832	93709
20651	30341	25	applied	\N	\N	\N	\N	93833	93833	93711
20651	30342	26	applied	\N	\N	\N	\N	93834	93834	93713
20651	30343	27	applied	\N	\N	\N	\N	93835	93835	93715
20651	29985	28	applied	\N	\N	\N	\N	92676	92676	92677
20651	29986	29	applied	\N	\N	\N	\N	92678	92678	92679
20651	29987	30	applied	\N	\N	\N	\N	92680	92680	92681
20651	30056	31	applied	\N	\N	\N	\N	92871	92871	92872
20651	29994	32	applied	\N	\N	\N	\N	92695	92695	92696
20651	29998	33	applied	\N	\N	\N	\N	92705	92705	92706
20651	30142	34	applied	\N	\N	\N	\N	93185	93185	93092
20651	30143	35	applied	\N	\N	\N	\N	93186	93186	93094
20651	30144	36	applied	\N	\N	\N	\N	93187	93187	93096
20651	30145	37	applied	\N	\N	\N	\N	93188	93188	93098
20651	30146	38	applied	\N	\N	\N	\N	93189	93189	93100
20651	30001	39	applied	\N	\N	\N	\N	92713	92713	92714
20651	30208	40	applied	\N	\N	\N	\N	93339	93339	93340
20651	30209	41	applied	\N	\N	\N	\N	93341	93341	93342
20651	30057	42	applied	\N	\N	\N	\N	92873	92873	92874
20651	30058	43	applied	\N	\N	\N	\N	92875	92875	92876
20651	30059	44	applied	\N	\N	\N	\N	92877	92877	92878
20651	30060	45	applied	\N	\N	\N	\N	92879	92879	92880
20651	30191	46	applied	\N	\N	\N	\N	93284	93284	93285
20651	30192	47	applied	\N	\N	\N	\N	93286	93286	93287
20651	30193	48	applied	\N	\N	\N	\N	93288	93288	93289
20651	30210	49	applied	\N	\N	\N	\N	93343	93343	93344
20651	30061	50	applied	\N	\N	\N	\N	92881	92881	92882
20651	30068	51	applied	\N	\N	\N	\N	92896	92896	92897
20651	30155	52	applied	\N	\N	\N	\N	93125	93125	93126
20651	30329	53	applied	\N	\N	\N	\N	93836	93836	93685
20651	30330	54	applied	\N	\N	\N	\N	93837	93837	93687
20651	30331	55	applied	\N	\N	\N	\N	93838	93838	93689
20651	30211	56	applied	\N	\N	\N	\N	93345	93345	93346
20651	30003	57	applied	\N	\N	\N	\N	92722	92722	92723
20651	30007	58	applied	\N	\N	\N	\N	92734	92734	92735
20651	30010	59	applied	\N	\N	\N	\N	92740	92740	92741
20651	30013	60	applied	\N	\N	\N	\N	92748	92748	92749
20651	30017	61	applied	\N	\N	\N	\N	92769	92769	92770
20651	30020	62	applied	\N	\N	\N	\N	92778	92778	92779
20651	30023	63	applied	\N	\N	\N	\N	92786	92786	92787
20651	30024	64	applied	\N	\N	\N	\N	92788	92788	92789
20651	30025	65	applied	\N	\N	\N	\N	92790	92790	92791
20651	30026	66	applied	\N	\N	\N	\N	92792	92792	92793
20651	30027	67	applied	\N	\N	\N	\N	92794	92794	92795
20651	30045	68	applied	\N	\N	\N	\N	92839	92839	92840
20651	30046	69	applied	\N	\N	\N	\N	92841	92841	92842
20651	30051	70	applied	\N	\N	\N	\N	92858	92858	92859
20651	30055	71	applied	\N	\N	\N	\N	92869	92869	92870
20651	30069	72	applied	\N	\N	\N	\N	92898	92898	92899
20651	30077	73	applied	\N	\N	\N	\N	92915	92915	92916
20651	30084	75	applied	\N	\N	\N	\N	92933	92933	92934
20651	30089	76	applied	\N	\N	\N	\N	92946	92946	92947
20651	30092	77	applied	\N	\N	\N	\N	92964	92964	92965
20651	30093	78	applied	\N	\N	\N	\N	92966	92966	92967
20651	30098	79	applied	\N	\N	\N	\N	92977	92977	92978
20651	30101	80	applied	\N	\N	\N	\N	92985	92985	92986
20651	30106	81	applied	\N	\N	\N	\N	92995	92995	92996
20651	30108	82	applied	\N	\N	\N	\N	93001	93001	93002
20651	30114	83	applied	\N	\N	\N	\N	93014	93014	93015
20651	30115	84	applied	\N	\N	\N	\N	93016	93016	93017
20651	30121	85	applied	\N	\N	\N	\N	93029	93029	93030
20651	30124	86	applied	\N	\N	\N	\N	93036	93036	93037
20651	30127	87	applied	\N	\N	\N	\N	93049	93049	93050
20651	30128	88	applied	\N	\N	\N	\N	93051	93051	93052
20651	30147	89	applied	\N	\N	\N	\N	93190	93190	93102
20651	30148	90	applied	\N	\N	\N	\N	93191	93191	93104
20651	30149	91	applied	\N	\N	\N	\N	93192	93192	93106
20651	30150	92	applied	\N	\N	\N	\N	93193	93193	93108
20651	30070	93	applied	\N	\N	\N	\N	92900	92900	92901
20651	30378	94	applied	\N	\N	\N	\N	93011	93011	93012
20651	30134	95	applied	\N	\N	\N	\N	93064	93064	93065
20651	30137	96	applied	\N	\N	\N	\N	93076	93076	93077
20651	30141	97	applied	\N	\N	\N	\N	93089	93089	93090
20651	30151	98	applied	\N	\N	\N	\N	93109	93109	93110
20651	30156	99	applied	\N	\N	\N	\N	93141	93141	93142
20651	30160	100	applied	\N	\N	\N	\N	93157	93157	93158
20651	30161	101	applied	\N	\N	\N	\N	93159	93159	93160
20651	30167	102	applied	\N	\N	\N	\N	93209	93209	93210
20651	30172	103	applied	\N	\N	\N	\N	93219	93219	93220
20651	30175	104	applied	\N	\N	\N	\N	93228	93228	93229
20651	30179	105	applied	\N	\N	\N	\N	93257	93257	93258
20651	30180	106	applied	\N	\N	\N	\N	93259	93259	93260
20651	30186	107	applied	\N	\N	\N	\N	93274	93274	93275
20651	30195	108	applied	\N	\N	\N	\N	93298	93298	93299
20651	30199	109	applied	\N	\N	\N	\N	93312	93312	93313
20651	30204	110	applied	\N	\N	\N	\N	93326	93326	93327
20651	30212	111	applied	\N	\N	\N	\N	93347	93347	93348
20651	30214	112	applied	\N	\N	\N	\N	93381	93381	93382
20651	30217	113	applied	\N	\N	\N	\N	93389	93389	93390
20651	30221	114	applied	\N	\N	\N	\N	93398	93398	93399
20651	30224	115	applied	\N	\N	\N	\N	93408	93408	93409
20651	30226	116	applied	\N	\N	\N	\N	93423	93423	93424
20651	30227	117	applied	\N	\N	\N	\N	93425	93425	93426
20651	30232	118	applied	\N	\N	\N	\N	93436	93436	93437
20651	30233	119	applied	\N	\N	\N	\N	93438	93438	93439
20651	30234	120	applied	\N	\N	\N	\N	93440	93440	93441
20651	30242	121	applied	\N	\N	\N	\N	93460	93460	93461
20651	30245	122	applied	\N	\N	\N	\N	93468	93468	93469
20651	30248	123	applied	\N	\N	\N	\N	93476	93476	93477
20651	30253	124	applied	\N	\N	\N	\N	93487	93487	93488
20651	30254	125	applied	\N	\N	\N	\N	93489	93489	93490
20656	30385	0	applied	\N	\N	\N	\N	93858	93858	93859
20656	30386	1	applied	\N	\N	\N	\N	93860	93860	93861
20656	30387	2	applied	\N	\N	\N	\N	93862	93862	93863
20656	30388	3	applied	\N	\N	\N	\N	93864	93864	93865
20661	30389	0	applied	\N	\N	\N	\N	93872	93872	93873
20661	30390	1	applied	\N	\N	\N	\N	93874	93874	93875
20661	30391	2	applied	\N	\N	\N	\N	93876	93876	93877
20667	30394	0	applied	\N	\N	\N	\N	93885	93885	93886
20667	30395	1	applied	\N	\N	\N	\N	93887	93887	93888
20667	30396	2	applied	\N	\N	\N	\N	93889	93889	93890
20667	30397	3	applied	\N	\N	\N	\N	93891	93891	93892
20667	30398	4	applied	\N	\N	\N	\N	93893	93893	93894
20667	30399	5	applied	\N	\N	\N	\N	93895	93895	93896
20667	30400	6	applied	\N	\N	\N	\N	93897	93897	93898
20667	30401	7	applied	\N	\N	\N	\N	93899	93899	93900
20667	30402	8	applied	\N	\N	\N	\N	93901	93901	93902
20667	30403	9	applied	\N	\N	\N	\N	93903	93903	93904
20667	30404	10	applied	\N	\N	\N	\N	93905	93905	93906
20667	30405	11	applied	\N	\N	\N	\N	93907	93907	93908
20667	30406	12	applied	\N	\N	\N	\N	93909	93909	93910
20668	30407	0	applied	\N	\N	\N	\N	93917	93917	93918
20668	30408	1	applied	\N	\N	\N	\N	93919	93919	93920
20668	30409	2	applied	\N	\N	\N	\N	93921	93921	93922
20673	30413	0	applied	\N	\N	\N	\N	93938	93938	93939
20673	30414	1	applied	\N	\N	\N	\N	93940	93940	93941
20673	30415	2	applied	\N	\N	\N	\N	93942	93942	93943
20674	30416	0	applied	\N	\N	\N	\N	93947	93947	93948
20674	30417	1	applied	\N	\N	\N	\N	93949	93949	93950
20674	30418	2	applied	\N	\N	\N	\N	93951	93951	93952
20674	30419	3	applied	\N	\N	\N	\N	93953	93953	93954
20674	30420	4	applied	\N	\N	\N	\N	93955	93955	93956
20674	30421	5	applied	\N	\N	\N	\N	93957	93957	93958
20674	30422	6	applied	\N	\N	\N	\N	93959	93959	93960
20674	30423	7	applied	\N	\N	\N	\N	93961	93961	93962
20674	30424	8	applied	\N	\N	\N	\N	93963	93963	93964
20679	30425	0	applied	\N	\N	\N	\N	93973	93973	93974
20679	30426	1	applied	\N	\N	\N	\N	93975	93975	93976
20679	30427	2	applied	\N	\N	\N	\N	93977	93977	93978
20683	30324	0	applied	\N	\N	\N	\N	93674	93674	93675
20683	30312	1	applied	\N	\N	\N	\N	93647	93647	93648
20683	30313	2	applied	\N	\N	\N	\N	93649	93649	93650
20683	30314	3	applied	\N	\N	\N	\N	93651	93651	93652
20683	30336	4	applied	\N	\N	\N	\N	93700	93700	93701
20683	30337	5	applied	\N	\N	\N	\N	93702	93702	93703
20683	30338	6	applied	\N	\N	\N	\N	93704	93704	93705
20683	30315	7	applied	\N	\N	\N	\N	93653	93653	93654
20683	30325	8	applied	\N	\N	\N	\N	93676	93676	93677
20683	30326	9	applied	\N	\N	\N	\N	93678	93678	93679
20683	30340	10	applied	\N	\N	\N	\N	93708	93708	93709
20683	30341	11	applied	\N	\N	\N	\N	93710	93710	93711
20683	30342	12	applied	\N	\N	\N	\N	93712	93712	93713
20683	30343	13	applied	\N	\N	\N	\N	93714	93714	93715
20683	30282	14	applied	\N	\N	\N	\N	93581	93581	93582
20683	30288	15	applied	\N	\N	\N	\N	93594	93594	93595
20683	30293	16	applied	\N	\N	\N	\N	93605	93605	93606
20683	30294	17	applied	\N	\N	\N	\N	93607	93607	93608
20683	30329	18	applied	\N	\N	\N	\N	93684	93684	93685
20683	30330	19	applied	\N	\N	\N	\N	93686	93686	93687
20683	30331	20	applied	\N	\N	\N	\N	93688	93688	93689
20683	30295	21	applied	\N	\N	\N	\N	93609	93609	93610
20683	30305	22	applied	\N	\N	\N	\N	93631	93631	93632
20683	30306	23	applied	\N	\N	\N	\N	93633	93633	93634
20683	30316	24	applied	\N	\N	\N	\N	93655	93655	93656
20683	30317	25	applied	\N	\N	\N	\N	93657	93657	93658
20683	30327	26	applied	\N	\N	\N	\N	93680	93680	93681
20683	30328	27	applied	\N	\N	\N	\N	93682	93682	93683
20683	30339	28	applied	\N	\N	\N	\N	93706	93706	93707
20683	30347	29	applied	\N	\N	\N	\N	93725	93725	93726
20683	30350	30	applied	\N	\N	\N	\N	93735	93735	93736
20683	30352	31	applied	\N	\N	\N	\N	93741	93741	93742
20683	30356	32	applied	\N	\N	\N	\N	93753	93753	93754
20677	30421	5	applied	\N	\N	\N	\N	93957	93957	93958
20677	30422	6	applied	\N	\N	\N	\N	93959	93959	93960
20677	30423	7	applied	\N	\N	\N	\N	93961	93961	93962
20677	30424	8	applied	\N	\N	\N	\N	93963	93963	93964
20678	30425	0	applied	\N	\N	\N	\N	93973	93973	93974
20678	30426	1	applied	\N	\N	\N	\N	93975	93975	93976
20678	30427	2	applied	\N	\N	\N	\N	93977	93977	93978
20682	30428	0	applied	\N	\N	\N	\N	93998	93998	93999
20682	30429	1	applied	\N	\N	\N	\N	94000	94000	94001
20682	30430	2	applied	\N	\N	\N	\N	94002	94002	94003
20687	30434	0	applied	\N	\N	\N	\N	94054	94054	94055
20687	30435	1	applied	\N	\N	\N	\N	94056	94056	94057
20687	30436	2	applied	\N	\N	\N	\N	94058	94058	94059
20688	30437	0	applied	\N	\N	\N	\N	94062	94062	94063
20688	30438	1	applied	\N	\N	\N	\N	94064	94064	94065
20688	30439	2	applied	\N	\N	\N	\N	94066	94066	94067
20688	30440	3	applied	\N	\N	\N	\N	94068	94068	94069
20694	30447	0	applied	\N	\N	\N	\N	94088	94088	94089
20694	30448	1	applied	\N	\N	\N	\N	94090	94090	94091
20694	30449	2	applied	\N	\N	\N	\N	94092	94092	94093
20694	30450	3	applied	\N	\N	\N	\N	94094	94094	94095
20694	30451	4	applied	\N	\N	\N	\N	94096	94096	94097
20694	30452	5	applied	\N	\N	\N	\N	94098	94098	94099
20694	30453	6	applied	\N	\N	\N	\N	94100	94100	94101
20694	30454	7	applied	\N	\N	\N	\N	94102	94102	94103
20700	30463	0	applied	\N	\N	\N	\N	94136	94136	94137
20700	30464	1	applied	\N	\N	\N	\N	94138	94138	94139
20700	30465	2	applied	\N	\N	\N	\N	94140	94140	94141
20700	30466	3	applied	\N	\N	\N	\N	94142	94142	94143
20700	30467	4	applied	\N	\N	\N	\N	94144	94144	94145
20700	30468	5	applied	\N	\N	\N	\N	94146	94146	94147
20700	30469	6	applied	\N	\N	\N	\N	94148	94148	94149
20700	30470	7	applied	\N	\N	\N	\N	94150	94150	94151
20704	30471	0	applied	\N	\N	\N	\N	94158	94158	94159
20704	30472	1	applied	\N	\N	\N	\N	94160	94160	94161
20704	30473	2	applied	\N	\N	\N	\N	94162	94162	94163
20705	30474	0	applied	\N	\N	\N	\N	94166	94166	94167
20705	30475	1	applied	\N	\N	\N	\N	94168	94168	94169
20705	30476	2	applied	\N	\N	\N	\N	94170	94170	94171
20705	30477	3	applied	\N	\N	\N	\N	94172	94172	94173
20705	30478	4	applied	\N	\N	\N	\N	94174	94174	94175
20705	30479	5	applied	\N	\N	\N	\N	94176	94176	94177
20705	30480	6	applied	\N	\N	\N	\N	94178	94178	94179
20705	30481	7	applied	\N	\N	\N	\N	94180	94180	94181
20706	30482	0	applied	\N	\N	\N	\N	94184	94184	94185
20706	30483	1	applied	\N	\N	\N	\N	94186	94186	94187
20710	30484	0	applied	\N	\N	\N	\N	94192	94192	94193
20710	30485	1	applied	\N	\N	\N	\N	94194	94194	94195
20710	30486	2	applied	\N	\N	\N	\N	94196	94196	94197
20710	30487	3	applied	\N	\N	\N	\N	94198	94198	94199
20715	30488	0	applied	\N	\N	\N	\N	94204	94204	94205
20715	30489	1	applied	\N	\N	\N	\N	94206	94206	94207
20715	30490	2	applied	\N	\N	\N	\N	94208	94208	94209
20720	30494	0	applied	\N	\N	\N	\N	94252	94252	94253
20720	30495	1	applied	\N	\N	\N	\N	94254	94254	94255
20725	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20725	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20725	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20725	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20725	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20725	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20725	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20725	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20725	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20725	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20731	30506	0	applied	\N	\N	\N	\N	94315	94315	94316
20731	30507	1	applied	\N	\N	\N	\N	94317	94317	94318
20731	30508	2	applied	\N	\N	\N	\N	94319	94319	94320
20731	30509	3	applied	\N	\N	\N	\N	94321	94321	47675
20731	30510	4	applied	\N	\N	\N	\N	94322	94322	94323
20731	30511	5	applied	\N	\N	\N	\N	94324	94324	94325
20731	30512	6	applied	\N	\N	\N	\N	94326	94326	94327
20731	30513	7	applied	\N	\N	\N	\N	94328	94328	94329
20731	30514	8	applied	\N	\N	\N	\N	94330	94330	94331
20731	30515	9	applied	\N	\N	\N	\N	94332	94332	94333
20732	30516	0	applied	\N	\N	\N	\N	94337	94337	94338
20732	30517	1	applied	\N	\N	\N	\N	94339	94339	94340
20732	30518	2	applied	\N	\N	\N	\N	94341	94341	94342
20732	30519	3	applied	\N	\N	\N	\N	94343	94343	94344
20732	30520	4	applied	\N	\N	\N	\N	94345	94345	94346
20732	30521	5	applied	\N	\N	\N	\N	94347	94347	94348
20732	30522	6	applied	\N	\N	\N	\N	94349	94349	94350
20737	30526	0	applied	\N	\N	\N	\N	94364	94364	94365
20737	30527	1	applied	\N	\N	\N	\N	94366	94366	94367
20737	30528	2	applied	\N	\N	\N	\N	94368	94368	94369
20743	30550	0	applied	\N	\N	\N	\N	94421	94421	94422
20743	30551	1	applied	\N	\N	\N	\N	94423	94423	94424
20743	30552	2	applied	\N	\N	\N	\N	94425	94425	94426
20743	30553	3	applied	\N	\N	\N	\N	94427	94427	94428
20743	30554	4	applied	\N	\N	\N	\N	94429	94429	94430
20743	30555	5	applied	\N	\N	\N	\N	94431	94431	94432
20746	30561	0	applied	\N	\N	\N	\N	94446	94446	94447
20746	30562	1	applied	\N	\N	\N	\N	94448	94448	94449
20746	30563	2	applied	\N	\N	\N	\N	94450	94450	94451
20746	30564	3	applied	\N	\N	\N	\N	94452	94452	94453
20746	30565	4	applied	\N	\N	\N	\N	94454	94454	94455
20746	30566	5	applied	\N	\N	\N	\N	94456	94456	94457
20746	30567	6	applied	\N	\N	\N	\N	94458	94458	94459
20752	30582	0	applied	\N	\N	\N	\N	94497	94497	94498
20752	30583	1	applied	\N	\N	\N	\N	94499	94499	94500
20752	30584	2	applied	\N	\N	\N	\N	94501	94501	94502
20752	30585	3	applied	\N	\N	1000000000	\N	94503	94503	94504
20752	30586	4	applied	\N	\N	\N	\N	94505	94505	94506
20762	30447	0	applied	\N	\N	\N	\N	94107	94107	94089
20762	30455	1	applied	\N	\N	\N	\N	94108	94108	94109
20762	30456	2	applied	\N	\N	\N	\N	94110	94110	94111
20762	30457	3	applied	\N	\N	\N	\N	94112	94112	94113
20762	30588	4	applied	\N	\N	\N	\N	94513	94513	94514
20762	30535	5	applied	\N	\N	\N	\N	94566	94566	94386
20762	30536	6	applied	\N	\N	\N	\N	94567	94567	94388
20762	30574	7	applied	\N	\N	\N	\N	94568	94568	94481
20762	30589	8	applied	\N	\N	\N	\N	94515	94515	94516
20762	30590	9	applied	\N	\N	\N	\N	94517	94517	94518
20762	30595	10	applied	\N	\N	\N	\N	94531	94531	94532
20762	30596	11	applied	\N	\N	\N	\N	94533	94533	94534
20762	30575	12	applied	\N	\N	\N	\N	94569	94569	94483
20762	30576	13	applied	\N	\N	\N	\N	94570	94570	94485
20762	30577	14	applied	\N	\N	\N	\N	94571	94571	94487
20762	30537	15	applied	\N	\N	\N	\N	94572	94572	94390
20762	30538	16	applied	\N	\N	\N	\N	94573	94573	94392
20680	30417	8	applied	\N	\N	\N	\N	93949	93949	93950
20680	30418	9	applied	\N	\N	\N	\N	93951	93951	93952
20680	30398	10	applied	\N	\N	\N	\N	93893	93893	93894
20680	30399	11	applied	\N	\N	\N	\N	93895	93895	93896
20680	30400	12	applied	\N	\N	\N	\N	93897	93897	93898
20680	30401	13	applied	\N	\N	\N	\N	93899	93899	93900
20680	30409	14	applied	\N	\N	\N	\N	93921	93921	93983
20680	30421	15	applied	\N	\N	\N	\N	93957	93957	93902
20680	30402	16	applied	\N	\N	\N	\N	93901	93901	93984
20680	30408	17	applied	\N	\N	\N	\N	93919	93919	93985
20680	30412	18	applied	\N	\N	\N	\N	93932	93932	93906
20680	30414	19	applied	\N	\N	\N	\N	93940	93940	93986
20680	30419	20	applied	\N	\N	\N	\N	93953	93953	93987
20680	30420	22	applied	\N	\N	\N	\N	93955	93955	93910
20680	30427	23	applied	\N	\N	\N	\N	93977	93977	93920
20680	30403	24	applied	\N	\N	\N	\N	93903	93903	93989
20680	30404	25	applied	\N	\N	\N	\N	93905	93905	93933
20680	30405	26	applied	\N	\N	\N	\N	93907	93907	93990
20680	30406	27	applied	\N	\N	\N	\N	93909	93909	93991
20680	30411	28	applied	\N	\N	\N	\N	93930	93930	93956
20680	30415	29	applied	\N	\N	\N	\N	93942	93942	93992
20680	30422	30	applied	\N	\N	\N	\N	93959	93959	93993
20680	30423	31	applied	\N	\N	\N	\N	93961	93961	93994
20680	30424	32	applied	\N	\N	\N	\N	93963	93963	93995
20685	30431	0	applied	\N	\N	\N	\N	94046	94046	94047
20685	30432	1	applied	\N	\N	\N	\N	94048	94048	94049
20685	30433	2	applied	\N	\N	\N	\N	94050	94050	94051
20691	30444	0	applied	\N	\N	\N	\N	94077	94077	94078
20691	30445	1	applied	\N	\N	\N	\N	94079	94079	94080
20691	30446	2	applied	\N	\N	\N	\N	94083	94083	94084
20696	30455	0	applied	\N	\N	\N	\N	94118	94118	94109
20696	30456	1	applied	\N	\N	\N	\N	94119	94119	94111
20696	30457	2	applied	\N	\N	\N	\N	94120	94120	94113
20696	30458	3	applied	\N	\N	\N	\N	94121	94121	94122
20696	30459	4	applied	\N	\N	1000000000	\N	94123	94123	94124
20696	30460	5	applied	\N	\N	\N	\N	94125	94125	94126
20702	30463	0	applied	\N	\N	\N	\N	94136	94136	94137
20702	30464	1	applied	\N	\N	\N	\N	94138	94138	94139
20702	30465	2	applied	\N	\N	\N	\N	94140	94140	94141
20702	30466	3	applied	\N	\N	\N	\N	94142	94142	94143
20702	30467	4	applied	\N	\N	\N	\N	94144	94144	94145
20702	30468	5	applied	\N	\N	\N	\N	94146	94146	94147
20702	30469	6	applied	\N	\N	\N	\N	94148	94148	94149
20702	30470	7	applied	\N	\N	\N	\N	94150	94150	94151
20712	30484	0	applied	\N	\N	\N	\N	94192	94192	94193
20712	30485	1	applied	\N	\N	\N	\N	94194	94194	94195
20712	30486	2	applied	\N	\N	\N	\N	94196	94196	94197
20712	30487	3	applied	\N	\N	\N	\N	94198	94198	94199
20713	30488	0	applied	\N	\N	\N	\N	94204	94204	94205
20713	30489	1	applied	\N	\N	\N	\N	94206	94206	94207
20713	30490	2	applied	\N	\N	\N	\N	94208	94208	94209
20717	30491	0	applied	\N	\N	\N	\N	94244	94244	94245
20717	30492	1	applied	\N	\N	\N	\N	94246	94246	94247
20717	30493	2	applied	\N	\N	\N	\N	94248	94248	94249
20727	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20727	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20727	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20727	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20727	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20727	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20727	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20727	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20727	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20727	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20728	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20728	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20728	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20728	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20728	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20728	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20728	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20728	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20728	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20728	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20734	30523	0	applied	\N	\N	\N	\N	94352	94352	94353
20734	30524	1	applied	\N	\N	\N	\N	94354	94354	94355
20734	30525	2	applied	\N	\N	\N	\N	94356	94356	94357
20740	30533	0	applied	\N	\N	\N	\N	94381	94381	94382
20740	30534	1	applied	\N	\N	\N	\N	94383	94383	94384
20740	30535	2	applied	\N	\N	\N	\N	94385	94385	94386
20740	30536	3	applied	\N	\N	\N	\N	94387	94387	94388
20740	30537	4	applied	\N	\N	\N	\N	94389	94389	94390
20740	30538	5	applied	\N	\N	\N	\N	94391	94391	94392
20740	30539	6	applied	\N	\N	\N	\N	94393	94393	94394
20740	30540	7	applied	\N	\N	\N	\N	94395	94395	94396
20740	30541	8	applied	\N	\N	\N	\N	94397	94397	94398
20740	30542	9	applied	\N	\N	\N	\N	94399	94399	94400
20741	30543	0	applied	\N	\N	\N	\N	94403	94403	94404
20741	30544	1	applied	\N	\N	\N	\N	94405	94405	94406
20741	30545	2	applied	\N	\N	\N	\N	94407	94407	94408
20741	30546	3	applied	\N	\N	\N	\N	94409	94409	94410
20741	30547	4	applied	\N	\N	\N	\N	94411	94411	94412
20741	30548	5	applied	\N	\N	\N	\N	94413	94413	94414
20741	30549	6	applied	\N	\N	\N	\N	94415	94415	94416
20749	30568	0	applied	\N	\N	\N	\N	94462	94462	94463
20749	30569	1	applied	\N	\N	\N	\N	94464	94464	94465
20749	30570	2	applied	\N	\N	\N	\N	94466	94466	94467
20749	30571	3	applied	\N	\N	\N	\N	94468	94468	94469
20749	30572	4	applied	\N	\N	\N	\N	94470	94470	94471
20749	30573	5	applied	\N	\N	\N	\N	94472	94472	94473
20754	30582	0	applied	\N	\N	\N	\N	94497	94497	94498
20754	30583	1	applied	\N	\N	\N	\N	94499	94499	94500
20754	30584	2	applied	\N	\N	\N	\N	94501	94501	94502
20754	30585	3	applied	\N	\N	1000000000	\N	94503	94503	94504
20754	30586	4	applied	\N	\N	\N	\N	94505	94505	94506
20755	30587	0	applied	\N	\N	\N	\N	94511	94511	94512
20755	30588	1	applied	\N	\N	\N	\N	94513	94513	94514
20755	30589	2	applied	\N	\N	\N	\N	94515	94515	94516
20755	30590	3	applied	\N	\N	\N	\N	94517	94517	94518
20755	30591	4	applied	\N	\N	\N	\N	94519	94519	94520
20755	30592	5	applied	\N	\N	\N	\N	94521	94521	94522
20760	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20760	30594	1	applied	\N	\N	\N	\N	94529	94529	94530
20760	30516	2	applied	\N	\N	\N	\N	94337	94337	94338
20760	30517	3	applied	\N	\N	\N	\N	94339	94339	94340
20760	30523	4	applied	\N	\N	\N	\N	94352	94352	94353
20760	30588	5	applied	\N	\N	\N	\N	94513	94513	94514
20760	30535	6	applied	\N	\N	\N	\N	94385	94385	94386
20760	30536	7	applied	\N	\N	\N	\N	94387	94387	94388
20683	30359	33	applied	\N	\N	\N	\N	93761	93761	93762
20683	30362	34	applied	\N	\N	\N	\N	93767	93767	93768
20683	30363	35	applied	\N	\N	\N	\N	93769	93769	93770
20683	30368	36	applied	\N	\N	\N	\N	93781	93781	93782
20683	30371	37	applied	\N	\N	\N	\N	93789	93789	93790
20683	30374	38	applied	\N	\N	\N	\N	93817	93817	93818
20683	30379	39	applied	\N	\N	\N	\N	93842	93842	93843
20683	30382	40	applied	\N	\N	\N	\N	93848	93848	93849
20683	30385	41	applied	\N	\N	\N	\N	93858	93858	93859
20683	30389	42	applied	\N	\N	\N	\N	93872	93872	93873
20683	30392	43	applied	\N	\N	\N	\N	93880	93880	93881
20683	30394	44	applied	\N	\N	\N	\N	93885	93885	93886
20683	30395	45	applied	\N	\N	\N	\N	93887	93887	93888
20683	30396	46	applied	\N	\N	\N	\N	93889	93889	93890
20683	30397	47	applied	\N	\N	\N	\N	93891	93891	93892
20683	30407	48	applied	\N	\N	\N	\N	93917	93917	93918
20683	30410	49	applied	\N	\N	\N	\N	93927	93927	93928
20683	30413	50	applied	\N	\N	\N	\N	93938	93938	93939
20683	30416	51	applied	\N	\N	\N	\N	93947	93947	93948
20683	30417	52	applied	\N	\N	\N	\N	93949	93949	93950
20683	30418	53	applied	\N	\N	\N	\N	93951	93951	93952
20683	30289	54	applied	\N	\N	\N	\N	93596	93596	94006
20683	30283	55	applied	\N	\N	\N	\N	93583	93583	93583
20683	30291	56	applied	\N	\N	\N	\N	93600	93600	93601
20683	30296	57	applied	\N	\N	\N	\N	93611	93611	93612
20683	30284	58	applied	\N	\N	\N	\N	93584	93584	94007
20683	30300	59	applied	\N	\N	\N	\N	93619	93619	93620
20683	30301	60	applied	\N	\N	\N	\N	93621	93621	93622
20683	30285	61	applied	\N	\N	\N	\N	93586	93586	94008
20683	30286	62	applied	\N	\N	\N	\N	93588	93588	94009
20683	30290	63	applied	\N	\N	\N	\N	93598	93598	94010
20683	30287	64	applied	\N	\N	\N	\N	93590	93590	93599
20683	30292	65	applied	\N	\N	\N	\N	93602	93602	93603
20683	30297	66	applied	\N	\N	\N	\N	93613	93613	93614
20683	30298	67	applied	\N	\N	\N	\N	93615	93615	93616
20683	30299	68	applied	\N	\N	\N	\N	93617	93617	93618
20683	30307	69	applied	\N	\N	\N	\N	93635	93635	94011
20683	30308	70	applied	\N	\N	\N	\N	93637	93637	94012
20683	30318	71	applied	\N	\N	\N	\N	93659	93659	93626
20683	30319	72	applied	\N	\N	\N	\N	93661	93661	94013
20683	30333	74	applied	\N	\N	\N	\N	93692	93692	94015
20683	30334	75	applied	\N	\N	\N	\N	93694	93694	94016
20683	30346	76	applied	\N	\N	\N	\N	93720	93720	93642
20683	30348	77	applied	\N	\N	\N	\N	93727	93727	94017
20683	30351	78	applied	\N	\N	\N	\N	93737	93737	94018
20683	30353	79	applied	\N	\N	\N	\N	93743	93743	94019
20683	30358	80	applied	\N	\N	\N	\N	93757	93757	94020
20683	30361	81	applied	\N	\N	\N	\N	93765	93765	93664
20683	30365	82	applied	\N	\N	\N	\N	93773	93773	94021
20683	30366	83	applied	\N	\N	\N	\N	93775	93775	93669
20683	30369	84	applied	\N	\N	\N	\N	93783	93783	94022
20683	30373	85	applied	\N	\N	\N	\N	93793	93793	94023
20683	30376	86	applied	\N	\N	\N	\N	93821	93821	94024
20683	30381	87	applied	\N	\N	\N	\N	93846	93846	94025
20683	30384	88	applied	\N	\N	\N	\N	93852	93852	93697
20683	30387	89	applied	\N	\N	\N	\N	93862	93862	94026
20683	30391	90	applied	\N	\N	\N	\N	93876	93876	93719
20683	30393	91	applied	\N	\N	\N	\N	93882	93882	93721
20683	30398	92	applied	\N	\N	\N	\N	93893	93893	93728
20683	30399	93	applied	\N	\N	\N	\N	93895	93895	94027
20683	30400	94	applied	\N	\N	\N	\N	93897	93897	94028
20683	30302	95	applied	\N	\N	\N	\N	93623	93623	93744
20683	30303	96	applied	\N	\N	\N	\N	93625	93625	94029
20683	30402	97	applied	\N	\N	\N	\N	93901	93901	94030
20683	30408	98	applied	\N	\N	\N	\N	93919	93919	93756
20683	30412	99	applied	\N	\N	\N	\N	93932	93932	93758
20683	30414	100	applied	\N	\N	\N	\N	93940	93940	94031
20683	30419	101	applied	\N	\N	\N	\N	93953	93953	94032
20683	30420	102	applied	\N	\N	\N	\N	93955	93955	94033
20683	30427	103	applied	\N	\N	\N	\N	93977	93977	93772
20683	30309	104	applied	\N	\N	1000000000	\N	93639	93639	93640
20683	30323	105	applied	\N	\N	\N	\N	93670	93670	93671
20683	30310	106	applied	\N	\N	\N	\N	93641	93641	94034
20683	30311	107	applied	\N	\N	\N	\N	93643	93643	94035
20683	30320	108	applied	\N	\N	\N	\N	93663	93663	94036
20683	30321	109	applied	\N	\N	\N	\N	93666	93666	94037
20683	30332	110	applied	\N	\N	\N	\N	93690	93690	93794
20683	30335	111	applied	\N	\N	\N	\N	93696	93696	93822
20683	30344	112	applied	\N	\N	\N	\N	93716	93716	93824
20683	30349	113	applied	\N	\N	\N	\N	93729	93729	93845
20683	30355	114	applied	\N	\N	\N	\N	93747	93747	94038
20683	30357	115	applied	\N	\N	\N	\N	93755	93755	94039
20683	30360	116	applied	\N	\N	\N	\N	93763	93763	94040
20683	30364	117	applied	\N	\N	\N	\N	93771	93771	93863
20683	30370	118	applied	\N	\N	\N	\N	93785	93785	93878
20683	30372	119	applied	\N	\N	\N	\N	93791	93791	93877
20683	30377	120	applied	\N	\N	\N	\N	93823	93823	94041
20683	30380	121	applied	\N	\N	\N	\N	93844	93844	93896
20683	30383	122	applied	\N	\N	\N	\N	93850	93850	93900
20683	30386	123	applied	\N	\N	\N	\N	93860	93860	94042
20683	30390	124	applied	\N	\N	\N	\N	93874	93874	93985
20683	30403	125	applied	\N	\N	\N	\N	93903	93903	94043
20684	30431	0	applied	\N	\N	\N	\N	94046	94046	94047
20684	30432	1	applied	\N	\N	\N	\N	94048	94048	94049
20684	30433	2	applied	\N	\N	\N	\N	94050	94050	94051
20689	30441	0	applied	\N	\N	\N	\N	94071	94071	94072
20689	30442	1	applied	\N	\N	\N	\N	94073	94073	94074
20689	30443	2	applied	\N	\N	\N	\N	94075	94075	94076
20690	30444	0	applied	\N	\N	\N	\N	94077	94077	94078
20690	30445	1	applied	\N	\N	\N	\N	94079	94079	94080
20695	30447	0	applied	\N	\N	\N	\N	94107	94107	94089
20695	30455	1	applied	\N	\N	\N	\N	94108	94108	94109
20695	30456	2	applied	\N	\N	\N	\N	94110	94110	94111
20695	30457	3	applied	\N	\N	\N	\N	94112	94112	94113
20695	30324	4	applied	\N	\N	\N	\N	93674	93674	93675
20695	30312	5	applied	\N	\N	\N	\N	93647	93647	93648
20695	30313	6	applied	\N	\N	\N	\N	93649	93649	93650
20695	30314	7	applied	\N	\N	\N	\N	93651	93651	93652
20695	30336	8	applied	\N	\N	\N	\N	93700	93700	93701
20695	30337	9	applied	\N	\N	\N	\N	93702	93702	93703
20695	30338	10	applied	\N	\N	\N	\N	93704	93704	93705
20695	30315	11	applied	\N	\N	\N	\N	93653	93653	93654
20695	30076	12	applied	\N	\N	\N	\N	92913	92913	92914
20695	30080	13	applied	\N	\N	\N	\N	92923	92923	92924
20695	30087	14	applied	\N	\N	\N	\N	92942	92942	92943
20695	30088	15	applied	\N	\N	\N	\N	92944	92944	92945
20695	30202	16	applied	\N	\N	\N	\N	93322	93322	93323
20695	30178	17	applied	\N	\N	\N	\N	93417	93417	93256
20695	30113	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20695	30159	19	applied	\N	\N	\N	\N	93184	93184	93156
20695	30203	20	applied	\N	\N	\N	\N	93324	93324	93325
20695	30325	21	applied	\N	\N	\N	\N	93676	93676	93830
20695	30326	22	applied	\N	\N	\N	\N	93678	93678	93679
20695	30187	23	applied	\N	\N	\N	\N	93276	93276	93277
20695	30188	24	applied	\N	\N	\N	\N	93418	93418	93279
20695	30189	25	applied	\N	\N	\N	\N	93419	93419	93281
20695	30190	26	applied	\N	\N	\N	\N	93420	93420	93283
20695	30340	28	applied	\N	\N	\N	\N	93832	93832	93709
20701	30463	0	applied	\N	\N	\N	\N	94136	94136	94137
20701	30464	1	applied	\N	\N	\N	\N	94138	94138	94139
20701	30465	2	applied	\N	\N	\N	\N	94140	94140	94141
20701	30466	3	applied	\N	\N	\N	\N	94142	94142	94143
20701	30467	4	applied	\N	\N	\N	\N	94144	94144	94145
20701	30468	5	applied	\N	\N	\N	\N	94146	94146	94147
20701	30469	6	applied	\N	\N	\N	\N	94148	94148	94149
20701	30470	7	applied	\N	\N	\N	\N	94150	94150	94151
20707	30482	0	applied	\N	\N	\N	\N	94184	94184	94185
20707	30483	1	applied	\N	\N	\N	\N	94186	94186	94187
20711	30484	0	applied	\N	\N	\N	\N	94192	94192	94193
20711	30485	1	applied	\N	\N	\N	\N	94194	94194	94195
20711	30486	2	applied	\N	\N	\N	\N	94196	94196	94197
20711	30487	3	applied	\N	\N	\N	\N	94198	94198	94199
20716	30447	0	applied	\N	\N	\N	\N	94212	94212	94089
20716	30455	1	applied	\N	\N	\N	\N	94213	94213	94109
20716	30456	2	applied	\N	\N	\N	\N	94214	94214	94111
20716	30457	3	applied	\N	\N	\N	\N	94215	94215	94113
20716	30324	4	applied	\N	\N	\N	\N	93674	93674	93675
20716	30312	5	applied	\N	\N	\N	\N	93647	93647	93648
20716	30313	6	applied	\N	\N	\N	\N	93649	93649	93650
20716	30314	7	applied	\N	\N	\N	\N	93651	93651	93652
20716	30336	8	applied	\N	\N	\N	\N	93700	93700	93701
20716	30337	9	applied	\N	\N	\N	\N	93702	93702	93703
20716	30338	10	applied	\N	\N	\N	\N	93704	93704	93705
20716	30315	11	applied	\N	\N	\N	\N	93653	93653	93654
20716	30202	12	applied	\N	\N	\N	\N	94216	94216	93323
20716	30178	13	applied	\N	\N	\N	\N	93417	93417	93256
20716	30113	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	93013	93013	\N
20716	30159	15	applied	\N	\N	\N	\N	93184	93184	93156
20716	30203	16	applied	\N	\N	\N	\N	94217	94217	93325
20716	30325	17	applied	\N	\N	\N	\N	94218	94218	94219
20716	30326	18	applied	\N	\N	\N	\N	94220	94220	93679
20716	30187	19	applied	\N	\N	\N	\N	93276	93276	93277
20716	30188	20	applied	\N	\N	\N	\N	93418	93418	93279
20716	30189	21	applied	\N	\N	\N	\N	93419	93419	93281
20716	30190	22	applied	\N	\N	\N	\N	93420	93420	93283
20716	30340	23	applied	\N	\N	\N	\N	94221	94221	93709
20716	30341	24	applied	\N	\N	\N	\N	94222	94222	93711
20716	30342	25	applied	\N	\N	\N	\N	94223	94223	93713
20716	30343	26	applied	\N	\N	\N	\N	94224	94224	93715
20716	30142	27	applied	\N	\N	\N	\N	94225	94225	93092
20716	30143	28	applied	\N	\N	\N	\N	94226	94226	93094
20716	30144	29	applied	\N	\N	\N	\N	94227	94227	93096
20716	30145	30	applied	\N	\N	\N	\N	94228	94228	93098
20716	30146	31	applied	\N	\N	\N	\N	94229	94229	93100
20716	30208	32	applied	\N	\N	\N	\N	94230	94230	93340
20716	30209	33	applied	\N	\N	\N	\N	94231	94231	93342
20716	30191	34	applied	\N	\N	\N	\N	93284	93284	93285
20716	30192	35	applied	\N	\N	\N	\N	93286	93286	93287
20716	30193	36	applied	\N	\N	\N	\N	93288	93288	93289
20716	30210	37	applied	\N	\N	\N	\N	93343	93343	93344
20716	30061	38	applied	\N	\N	\N	\N	92881	92881	92882
20716	30068	39	applied	\N	\N	\N	\N	92896	92896	92897
20716	30155	40	applied	\N	\N	\N	\N	93125	93125	93126
20716	30329	41	applied	\N	\N	\N	\N	94232	94232	93685
20716	30330	42	applied	\N	\N	\N	\N	94233	94233	93687
20716	30331	43	applied	\N	\N	\N	\N	94234	94234	93689
20716	29808	44	applied	\N	\N	\N	\N	92105	92105	92106
20716	29809	45	applied	\N	\N	\N	\N	92107	92107	92108
20716	29814	46	applied	\N	\N	\N	\N	92119	92119	92120
20716	29820	47	applied	\N	\N	\N	\N	92138	92138	92139
20716	29825	48	applied	\N	\N	\N	\N	92150	92150	92151
20716	29826	49	applied	\N	\N	\N	\N	92152	92152	92153
20716	29835	50	applied	\N	\N	\N	\N	92177	92177	92178
20716	29840	51	applied	\N	\N	\N	\N	92192	92192	92193
20716	30147	52	applied	\N	\N	\N	\N	94235	94235	93102
20716	30148	53	applied	\N	\N	\N	\N	94236	94236	93104
20716	30149	54	applied	\N	\N	\N	\N	94237	94237	93106
20716	30150	55	applied	\N	\N	\N	\N	94238	94238	93108
20716	29841	56	applied	\N	\N	\N	\N	92194	92194	92195
20716	29846	57	applied	\N	\N	\N	\N	92208	92208	92209
20716	29849	58	applied	\N	\N	\N	\N	92215	92215	92216
20716	29852	59	applied	\N	\N	\N	\N	92223	92223	92224
20716	29856	60	applied	\N	\N	\N	\N	92244	92244	92245
20716	29857	61	applied	\N	\N	\N	\N	92246	92246	92247
20716	29863	62	applied	\N	\N	\N	\N	92260	92260	92261
20716	29869	63	applied	\N	\N	\N	\N	92277	92277	92278
20716	29879	64	applied	\N	\N	\N	\N	92303	92303	92304
20716	29882	65	applied	\N	\N	\N	\N	92314	92314	92315
20716	29885	68	applied	\N	\N	\N	\N	92321	92321	92322
20716	29887	69	applied	\N	\N	\N	\N	92330	92330	92331
20716	29891	70	applied	\N	\N	\N	\N	92340	92340	92341
20716	29894	71	applied	\N	\N	\N	\N	92352	92352	92353
20716	29897	72	applied	\N	\N	\N	\N	92359	92359	92360
20716	29903	73	applied	\N	\N	\N	\N	92376	92376	92377
20716	29906	74	applied	\N	\N	\N	\N	92382	92382	92383
20716	29909	75	applied	\N	\N	\N	\N	92395	92395	92396
20716	29912	76	applied	\N	\N	\N	\N	92403	92403	92404
20716	29915	77	applied	\N	\N	\N	\N	92412	92412	92413
20716	29919	78	applied	\N	\N	\N	\N	92422	92422	92423
20721	30447	0	applied	\N	\N	\N	\N	94088	94088	94089
20721	30455	1	applied	\N	\N	\N	\N	94118	94118	94109
20721	30456	2	applied	\N	\N	\N	\N	94119	94119	94111
20721	30457	3	applied	\N	\N	\N	\N	94120	94120	94113
20721	30347	4	applied	\N	\N	\N	\N	93725	93725	93726
20721	30350	5	applied	\N	\N	\N	\N	93735	93735	93736
20721	30352	6	applied	\N	\N	\N	\N	93741	93741	93742
20721	30356	7	applied	\N	\N	\N	\N	93753	93753	93754
20721	30359	8	applied	\N	\N	\N	\N	93761	93761	93762
20721	30362	9	applied	\N	\N	\N	\N	93767	93767	93768
20721	30363	10	applied	\N	\N	\N	\N	93769	93769	93770
20721	30368	11	applied	\N	\N	\N	\N	93781	93781	93782
20721	30371	12	applied	\N	\N	\N	\N	93789	93789	93790
20721	30374	13	applied	\N	\N	\N	\N	93817	93817	93818
20721	30379	14	applied	\N	\N	\N	\N	93842	93842	93843
20721	30382	15	applied	\N	\N	\N	\N	93848	93848	93849
20721	30385	16	applied	\N	\N	\N	\N	93858	93858	93859
20721	30389	17	applied	\N	\N	\N	\N	93872	93872	93873
20721	30392	18	applied	\N	\N	\N	\N	93880	93880	93881
20721	30394	19	applied	\N	\N	\N	\N	93885	93885	93886
20721	30395	20	applied	\N	\N	\N	\N	93887	93887	93888
20721	30396	21	applied	\N	\N	\N	\N	93889	93889	93890
20721	30397	22	applied	\N	\N	\N	\N	93891	93891	93892
20721	30407	23	applied	\N	\N	\N	\N	93917	93917	93918
20721	30410	24	applied	\N	\N	\N	\N	93927	93927	93928
20721	30413	25	applied	\N	\N	\N	\N	93938	93938	93939
20721	30416	26	applied	\N	\N	\N	\N	93947	93947	93948
20721	30417	27	applied	\N	\N	\N	\N	93949	93949	93950
20721	30418	28	applied	\N	\N	\N	\N	93951	93951	93952
20721	30425	29	applied	\N	\N	\N	\N	93973	93973	93974
20721	30428	30	applied	\N	\N	\N	\N	93998	93998	93999
20721	30431	31	applied	\N	\N	\N	\N	94046	94046	94047
20721	30434	32	applied	\N	\N	\N	\N	94054	94054	94055
20721	30437	33	applied	\N	\N	\N	\N	94062	94062	94063
20721	30441	34	applied	\N	\N	\N	\N	94071	94071	94072
20721	30444	35	applied	\N	\N	\N	\N	94077	94077	94078
20721	30448	36	applied	\N	\N	\N	\N	94090	94090	94091
20721	30449	37	applied	\N	\N	\N	\N	94092	94092	94093
20721	30458	38	applied	\N	\N	\N	\N	94121	94121	94122
20721	30463	39	applied	\N	\N	\N	\N	94136	94136	94137
20721	30464	40	applied	\N	\N	\N	\N	94138	94138	94139
20721	30465	41	applied	\N	\N	\N	\N	94140	94140	94141
20721	30471	42	applied	\N	\N	\N	\N	94158	94158	94159
20721	30474	43	applied	\N	\N	\N	\N	94166	94166	94167
20721	30475	44	applied	\N	\N	\N	\N	94168	94168	94169
20721	30482	45	applied	\N	\N	\N	\N	94184	94184	94185
20721	30484	46	applied	\N	\N	\N	\N	94192	94192	94193
20721	30488	47	applied	\N	\N	\N	\N	94204	94204	94205
20721	30491	48	applied	\N	\N	\N	\N	94244	94244	94245
20721	30348	49	applied	\N	\N	\N	\N	93727	93727	93728
20721	30459	50	applied	\N	\N	1000000000	\N	94123	94123	94124
20721	30476	51	applied	\N	\N	\N	\N	94170	94170	94171
20721	30351	52	applied	\N	\N	\N	\N	93737	93737	94027
20721	30353	53	applied	\N	\N	\N	\N	93743	93743	94028
20721	30354	54	applied	\N	\N	\N	\N	93745	93745	93738
20721	30367	55	applied	\N	\N	\N	\N	93777	93777	94258
20721	30375	56	applied	\N	\N	\N	\N	93819	93819	93744
20721	30349	57	applied	\N	\N	\N	\N	93729	93729	94029
20721	30358	58	applied	\N	\N	\N	\N	93757	93757	94030
20721	30355	59	applied	\N	\N	\N	\N	93747	93747	94259
20721	30357	60	applied	\N	\N	\N	\N	93755	93755	94031
20721	30360	61	applied	\N	\N	\N	\N	93763	93763	93766
20721	30364	62	applied	\N	\N	\N	\N	93771	93771	93772
20721	30370	63	applied	\N	\N	\N	\N	93785	93785	94034
20721	30372	64	applied	\N	\N	\N	\N	93791	93791	94035
20721	30377	65	applied	\N	\N	\N	\N	93823	93823	94036
20721	30380	66	applied	\N	\N	\N	\N	93844	93844	94037
20721	30383	67	applied	\N	\N	\N	\N	93850	93850	93794
20721	30386	68	applied	\N	\N	\N	\N	93860	93860	93822
20721	30390	69	applied	\N	\N	\N	\N	93874	93874	93824
20721	30361	70	applied	\N	\N	\N	\N	93765	93765	94260
20721	30365	71	applied	\N	\N	\N	\N	93773	93773	94261
20721	30366	72	applied	\N	\N	\N	\N	93775	93775	94038
20721	30369	73	applied	\N	\N	\N	\N	93783	93783	93851
20721	30373	74	applied	\N	\N	\N	\N	93793	93793	93853
20721	30376	75	applied	\N	\N	\N	\N	93821	93821	94040
20721	30381	76	applied	\N	\N	\N	\N	93846	93846	94262
20721	30384	77	applied	\N	\N	\N	\N	93852	93852	93865
20721	30387	78	applied	\N	\N	\N	\N	93862	93862	93878
20721	30391	79	applied	\N	\N	\N	\N	93876	93876	94263
20721	30393	80	applied	\N	\N	\N	\N	93882	93882	94264
20721	30398	81	applied	\N	\N	\N	\N	93893	93893	94041
20721	30399	82	applied	\N	\N	\N	\N	93895	93895	94265
20721	30400	83	applied	\N	\N	\N	\N	93897	93897	94266
20721	30388	84	applied	\N	\N	\N	\N	93864	93864	93898
20721	30401	85	applied	\N	\N	\N	\N	93899	93899	93900
20721	30409	86	applied	\N	\N	\N	\N	93921	93921	93983
20721	30421	87	applied	\N	\N	\N	\N	93957	93957	93902
20721	30429	88	applied	\N	\N	\N	\N	94000	94000	94042
20721	30439	89	applied	\N	\N	\N	\N	94066	94066	93984
20721	30402	90	applied	\N	\N	\N	\N	93901	93901	93985
20721	30408	91	applied	\N	\N	\N	\N	93919	93919	93906
20721	30412	92	applied	\N	\N	\N	\N	93932	93932	93986
20721	30414	93	applied	\N	\N	\N	\N	93940	93940	93987
20721	30419	94	applied	\N	\N	\N	\N	93953	93953	93910
20721	30420	96	applied	\N	\N	\N	\N	93955	93955	93920
20721	30427	97	applied	\N	\N	\N	\N	93977	93977	94268
20721	30430	98	applied	\N	\N	\N	\N	94002	94002	93931
20721	30433	99	applied	\N	\N	\N	\N	94050	94050	93933
20721	30435	100	applied	\N	\N	\N	\N	94056	94056	93941
20721	30440	101	applied	\N	\N	\N	\N	94068	94068	94269
20721	30442	102	applied	\N	\N	\N	\N	94073	94073	93991
20721	30446	103	applied	\N	\N	\N	\N	94083	94083	94270
20721	30403	104	applied	\N	\N	\N	\N	93903	93903	94271
20721	30404	105	applied	\N	\N	\N	\N	93905	93905	94272
20721	30405	106	applied	\N	\N	\N	\N	93907	93907	94273
20721	30406	107	applied	\N	\N	\N	\N	93909	93909	94274
20721	30411	108	applied	\N	\N	\N	\N	93930	93930	94275
20721	30415	109	applied	\N	\N	\N	\N	93942	93942	94276
20721	30422	110	applied	\N	\N	\N	\N	93959	93959	94277
20721	30423	111	applied	\N	\N	\N	\N	93961	93961	94051
20721	30424	112	applied	\N	\N	\N	\N	93963	93963	94278
20721	30426	113	applied	\N	\N	\N	\N	93975	93975	94279
20721	30432	114	applied	\N	\N	\N	\N	94048	94048	94067
20721	30436	115	applied	\N	\N	\N	\N	94058	94058	94280
20721	30438	116	applied	\N	\N	\N	\N	94064	94064	94281
20721	30443	117	applied	\N	\N	\N	\N	94075	94075	94282
20721	30445	118	applied	\N	\N	\N	\N	94079	94079	94084
20721	30450	119	applied	\N	\N	\N	\N	94094	94094	94095
20721	30451	120	applied	\N	\N	\N	\N	94096	94096	94097
20721	30461	121	applied	\N	\N	\N	\N	94130	94130	94101
20721	30467	122	applied	\N	\N	\N	\N	94144	94144	94283
20721	30452	123	applied	\N	\N	\N	\N	94098	94098	94126
20721	30466	124	applied	\N	\N	\N	\N	94142	94142	94284
20721	30479	125	applied	\N	\N	\N	\N	94176	94176	94285
20726	30496	0	applied	\N	\N	\N	\N	94288	94288	94289
20726	30497	1	applied	\N	\N	\N	\N	94290	94290	94291
20726	30498	2	applied	\N	\N	\N	\N	94292	94292	94293
20726	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20726	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20726	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20726	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20726	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20726	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20726	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20733	30523	0	applied	\N	\N	\N	\N	94352	94352	94353
20733	30524	1	applied	\N	\N	\N	\N	94354	94354	94355
20733	30525	2	applied	\N	\N	\N	\N	94356	94356	94357
20738	30529	0	applied	\N	\N	\N	\N	94372	94372	94373
20729	30499	3	applied	\N	\N	\N	\N	94294	94294	94295
20729	30500	4	applied	\N	\N	\N	\N	94296	94296	94297
20729	30501	5	applied	\N	\N	\N	\N	94298	94298	94299
20729	30502	6	applied	\N	\N	\N	\N	94300	94300	94301
20729	30503	7	applied	\N	\N	\N	\N	94302	94302	94303
20729	30504	8	applied	\N	\N	\N	\N	94304	94304	94305
20729	30505	9	applied	\N	\N	\N	\N	94306	94306	94307
20730	30506	0	applied	\N	\N	\N	\N	94315	94315	94316
20730	30507	1	applied	\N	\N	\N	\N	94317	94317	94318
20730	30508	2	applied	\N	\N	\N	\N	94319	94319	94320
20730	30509	3	applied	\N	\N	\N	\N	94321	94321	47675
20730	30510	4	applied	\N	\N	\N	\N	94322	94322	94323
20730	30511	5	applied	\N	\N	\N	\N	94324	94324	94325
20730	30512	6	applied	\N	\N	\N	\N	94326	94326	94327
20730	30513	7	applied	\N	\N	\N	\N	94328	94328	94329
20730	30514	8	applied	\N	\N	\N	\N	94330	94330	94331
20730	30515	9	applied	\N	\N	\N	\N	94332	94332	94333
20735	30516	0	applied	\N	\N	\N	\N	94337	94337	94338
20735	30517	1	applied	\N	\N	\N	\N	94339	94339	94340
20735	30523	2	applied	\N	\N	\N	\N	94352	94352	94353
20735	30521	3	applied	\N	\N	\N	\N	94347	94347	94362
20736	30526	0	applied	\N	\N	\N	\N	94364	94364	94365
20736	30527	1	applied	\N	\N	\N	\N	94366	94366	94367
20736	30528	2	applied	\N	\N	\N	\N	94368	94368	94369
20742	30543	0	applied	\N	\N	\N	\N	94403	94403	94404
20742	30544	1	applied	\N	\N	\N	\N	94405	94405	94406
20742	30545	2	applied	\N	\N	\N	\N	94407	94407	94408
20742	30546	3	applied	\N	\N	\N	\N	94409	94409	94410
20742	30547	4	applied	\N	\N	\N	\N	94411	94411	94412
20742	30548	5	applied	\N	\N	\N	\N	94413	94413	94414
20742	30549	6	applied	\N	\N	\N	\N	94415	94415	94416
20747	30561	0	applied	\N	\N	\N	\N	94446	94446	94447
20747	30562	1	applied	\N	\N	\N	\N	94448	94448	94449
20747	30563	2	applied	\N	\N	\N	\N	94450	94450	94451
20747	30564	3	applied	\N	\N	\N	\N	94452	94452	94453
20747	30565	4	applied	\N	\N	\N	\N	94454	94454	94455
20747	30566	5	applied	\N	\N	\N	\N	94456	94456	94457
20747	30567	6	applied	\N	\N	\N	\N	94458	94458	94459
20748	30568	0	applied	\N	\N	\N	\N	94462	94462	94463
20748	30569	1	applied	\N	\N	\N	\N	94464	94464	94465
20748	30570	2	applied	\N	\N	\N	\N	94466	94466	94467
20748	30571	3	applied	\N	\N	\N	\N	94468	94468	94469
20748	30572	4	applied	\N	\N	\N	\N	94470	94470	94471
20748	30573	5	applied	\N	\N	\N	\N	94472	94472	94473
20753	30582	0	applied	\N	\N	\N	\N	94497	94497	94498
20753	30583	1	applied	\N	\N	\N	\N	94499	94499	94500
20753	30584	2	applied	\N	\N	\N	\N	94501	94501	94502
20753	30585	3	applied	\N	\N	1000000000	\N	94503	94503	94504
20753	30586	4	applied	\N	\N	\N	\N	94505	94505	94506
20763	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20763	30594	1	applied	\N	\N	\N	\N	94529	94529	94530
20763	30588	2	applied	\N	\N	\N	\N	94513	94513	94514
20763	30535	3	applied	\N	\N	\N	\N	94385	94385	94386
20763	30536	4	applied	\N	\N	\N	\N	94387	94387	94388
20763	30574	5	applied	\N	\N	\N	\N	94480	94480	94481
20763	30589	6	applied	\N	\N	\N	\N	94515	94515	94516
20763	30590	7	applied	\N	\N	\N	\N	94517	94517	94518
20763	30595	8	applied	\N	\N	\N	\N	94531	94531	94532
20763	30596	9	applied	\N	\N	\N	\N	94533	94533	94534
20763	30575	10	applied	\N	\N	\N	\N	94482	94482	94483
20763	30576	11	applied	\N	\N	\N	\N	94484	94484	94485
20763	30577	12	applied	\N	\N	\N	\N	94486	94486	94487
20763	30537	13	applied	\N	\N	\N	\N	94389	94389	94390
20763	30538	15	applied	\N	\N	\N	\N	94391	94391	94392
20763	30543	16	applied	\N	\N	\N	\N	94403	94403	94404
20763	30544	17	applied	\N	\N	\N	\N	94405	94405	94406
20763	30546	18	applied	\N	\N	\N	\N	94409	94409	94410
20763	30550	19	applied	\N	\N	\N	\N	94421	94421	94422
20763	30551	20	applied	\N	\N	\N	\N	94423	94423	94424
20763	30552	21	applied	\N	\N	\N	\N	94425	94425	94426
20763	30556	22	applied	\N	\N	\N	\N	94435	94435	94436
20763	30557	23	applied	\N	\N	\N	\N	94437	94437	94438
20763	30561	24	applied	\N	\N	\N	\N	94446	94446	94447
20763	30562	25	applied	\N	\N	\N	\N	94448	94448	94449
20763	30578	26	applied	\N	\N	\N	\N	94488	94488	94489
20763	30597	27	applied	\N	\N	\N	\N	94535	94535	94536
20763	30601	28	applied	\N	\N	\N	\N	94543	94543	94544
20763	30602	29	applied	\N	\N	\N	\N	94545	94545	94546
20763	30603	30	applied	\N	\N	\N	\N	94547	94547	94548
20763	30564	31	applied	\N	\N	\N	\N	94452	94452	94453
20763	30568	32	applied	\N	\N	\N	\N	94462	94462	94463
20763	30570	33	applied	\N	\N	\N	\N	94466	94466	94467
20763	30571	34	applied	\N	\N	\N	\N	94468	94468	94469
20763	30604	35	applied	\N	\N	\N	\N	94549	94549	94550
20763	30509	36	applied	\N	\N	\N	\N	94321	94321	47675
20763	30585	37	applied	\N	\N	1000000000	\N	94503	94503	94504
20767	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20767	30594	1	applied	\N	\N	\N	\N	94529	94529	94530
20767	30595	2	applied	\N	\N	\N	\N	94531	94531	94532
20767	30596	3	applied	\N	\N	\N	\N	94533	94533	94534
20767	30598	4	applied	\N	\N	\N	\N	94537	94537	94538
20767	30599	5	applied	\N	\N	\N	\N	94539	94539	94540
20767	30597	6	applied	\N	\N	\N	\N	94535	94535	94536
20767	30601	7	applied	\N	\N	\N	\N	94543	94543	94544
20767	30602	8	applied	\N	\N	\N	\N	94545	94545	94546
20767	30603	9	applied	\N	\N	\N	\N	94547	94547	94548
20767	30605	10	applied	\N	\N	\N	\N	94553	94553	94556
20767	30606	11	applied	\N	\N	\N	\N	94557	94557	94558
20767	30607	12	applied	\N	\N	\N	\N	94559	94559	94560
20767	30608	13	applied	\N	\N	\N	\N	94561	94561	94562
20773	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20773	30617	1	applied	\N	\N	\N	\N	94630	94630	94631
20773	30618	2	applied	\N	\N	\N	\N	94632	94632	94633
20773	30619	3	applied	\N	\N	\N	\N	94634	94634	94635
20773	30620	4	applied	\N	\N	\N	\N	94636	94636	94637
20773	30621	5	applied	\N	\N	\N	\N	94638	94638	94639
20773	30622	6	applied	\N	\N	\N	\N	94640	94640	94641
20773	30623	7	applied	\N	\N	\N	\N	94642	94642	94643
20773	30624	8	applied	\N	\N	\N	\N	94644	94644	94645
20773	30625	9	applied	\N	\N	\N	\N	94646	94646	94647
20773	30626	10	applied	\N	\N	\N	\N	94648	94648	94649
20773	30627	11	applied	\N	\N	\N	\N	94650	94650	94651
20778	30634	0	applied	\N	\N	\N	\N	94672	94672	94673
20778	30635	1	applied	\N	\N	\N	\N	94674	94674	94675
20778	30636	2	applied	\N	\N	\N	\N	94676	94676	94677
20778	30637	3	applied	\N	\N	\N	\N	94678	94678	94679
20778	30638	4	applied	\N	\N	\N	\N	94680	94680	94681
20779	30639	0	applied	\N	\N	\N	\N	94685	94685	94686
20779	30640	1	applied	\N	\N	\N	\N	94687	94687	94688
20738	30530	1	applied	\N	\N	\N	\N	94374	94374	94375
20738	30531	2	applied	\N	\N	\N	\N	94376	94376	94377
20738	30532	3	applied	\N	\N	\N	\N	94378	94378	94379
20739	30533	0	applied	\N	\N	\N	\N	94381	94381	94382
20739	30534	1	applied	\N	\N	\N	\N	94383	94383	94384
20739	30535	2	applied	\N	\N	\N	\N	94385	94385	94386
20739	30536	3	applied	\N	\N	\N	\N	94387	94387	94388
20739	30537	4	applied	\N	\N	\N	\N	94389	94389	94390
20739	30538	5	applied	\N	\N	\N	\N	94391	94391	94392
20739	30539	6	applied	\N	\N	\N	\N	94393	94393	94394
20739	30540	7	applied	\N	\N	\N	\N	94395	94395	94396
20739	30541	8	applied	\N	\N	\N	\N	94397	94397	94398
20739	30542	9	applied	\N	\N	\N	\N	94399	94399	94400
20744	30550	0	applied	\N	\N	\N	\N	94421	94421	94422
20744	30551	1	applied	\N	\N	\N	\N	94423	94423	94424
20744	30552	2	applied	\N	\N	\N	\N	94425	94425	94426
20744	30553	3	applied	\N	\N	\N	\N	94427	94427	94428
20744	30554	4	applied	\N	\N	\N	\N	94429	94429	94430
20744	30555	5	applied	\N	\N	\N	\N	94431	94431	94432
20745	30556	0	applied	\N	\N	\N	\N	94435	94435	94436
20745	30557	1	applied	\N	\N	\N	\N	94437	94437	94438
20745	30558	2	applied	\N	\N	\N	\N	94439	94439	94440
20745	30559	3	applied	\N	\N	\N	\N	94441	94441	94442
20745	30560	4	applied	\N	\N	\N	\N	94443	94443	94444
20750	30568	0	applied	\N	\N	\N	\N	94462	94462	94463
20750	30569	1	applied	\N	\N	\N	\N	94464	94464	94465
20750	30570	2	applied	\N	\N	\N	\N	94466	94466	94467
20750	30571	3	applied	\N	\N	\N	\N	94468	94468	94469
20750	30572	4	applied	\N	\N	\N	\N	94470	94470	94471
20750	30573	5	applied	\N	\N	\N	\N	94472	94472	94473
20751	30574	0	applied	\N	\N	\N	\N	94480	94480	94481
20751	30575	1	applied	\N	\N	\N	\N	94482	94482	94483
20751	30576	2	applied	\N	\N	\N	\N	94484	94484	94485
20751	30577	3	applied	\N	\N	\N	\N	94486	94486	94487
20751	30578	4	applied	\N	\N	\N	\N	94488	94488	94489
20751	30579	5	applied	\N	\N	\N	\N	94490	94490	94491
20751	30580	6	applied	\N	\N	\N	\N	94492	94492	94493
20751	30581	7	applied	\N	\N	\N	\N	94494	94494	94495
20756	30587	0	applied	\N	\N	\N	\N	94511	94511	94512
20756	30588	1	applied	\N	\N	\N	\N	94513	94513	94514
20756	30589	2	applied	\N	\N	\N	\N	94515	94515	94516
20756	30590	3	applied	\N	\N	\N	\N	94517	94517	94518
20756	30591	4	applied	\N	\N	\N	\N	94519	94519	94520
20756	30592	5	applied	\N	\N	\N	\N	94521	94521	94522
20761	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20761	30594	1	applied	\N	\N	\N	\N	94529	94529	94530
20761	30595	2	applied	\N	\N	\N	\N	94531	94531	94532
20761	30596	3	applied	\N	\N	\N	\N	94533	94533	94534
20761	30598	4	applied	\N	\N	\N	\N	94537	94537	94538
20761	30599	5	applied	\N	\N	\N	\N	94539	94539	94540
20761	30597	6	applied	\N	\N	\N	\N	94535	94535	94536
20761	30601	7	applied	\N	\N	\N	\N	94543	94543	94544
20761	30602	8	applied	\N	\N	\N	\N	94545	94545	94546
20761	30603	9	applied	\N	\N	\N	\N	94547	94547	94548
20761	30605	10	applied	\N	\N	\N	\N	94553	94553	94556
20761	30606	11	applied	\N	\N	\N	\N	94557	94557	94558
20761	30607	12	applied	\N	\N	\N	\N	94559	94559	94560
20761	30608	13	applied	\N	\N	\N	\N	94561	94561	94562
20765	30594	0	applied	\N	\N	\N	\N	94529	94529	94530
20765	30603	1	applied	\N	\N	\N	\N	94547	94547	94548
20765	30609	2	applied	\N	\N	\N	\N	94607	94607	94608
20765	30610	3	applied	\N	\N	\N	\N	94609	94609	94610
20765	30611	4	applied	\N	\N	\N	\N	94611	94611	94612
20765	30600	5	applied	\N	\N	\N	\N	94541	94541	94542
20765	30612	6	applied	\N	\N	\N	\N	94613	94613	94614
20770	30614	0	applied	\N	\N	\N	\N	94622	94622	94623
20770	30615	1	applied	\N	\N	\N	\N	94624	94624	94625
20771	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20771	30617	1	applied	\N	\N	\N	\N	94630	94630	94631
20771	30618	2	applied	\N	\N	\N	\N	94632	94632	94633
20771	30619	3	applied	\N	\N	\N	\N	94634	94634	94635
20771	30620	4	applied	\N	\N	\N	\N	94636	94636	94637
20771	30621	5	applied	\N	\N	\N	\N	94638	94638	94639
20771	30622	6	applied	\N	\N	\N	\N	94640	94640	94641
20771	30623	7	applied	\N	\N	\N	\N	94642	94642	94643
20771	30624	8	applied	\N	\N	\N	\N	94644	94644	94645
20771	30625	9	applied	\N	\N	\N	\N	94646	94646	94647
20771	30626	10	applied	\N	\N	\N	\N	94648	94648	94649
20771	30627	11	applied	\N	\N	\N	\N	94650	94650	94651
20775	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20775	30623	1	applied	\N	\N	\N	\N	94642	94642	94643
20775	30624	2	applied	\N	\N	\N	\N	94644	94644	94645
20775	30625	3	applied	\N	\N	\N	\N	94646	94646	94647
20775	30626	4	applied	\N	\N	\N	\N	94648	94648	94649
20775	30627	5	applied	\N	\N	\N	\N	94650	94650	94651
20783	30651	0	applied	\N	\N	\N	\N	94715	94715	94716
20783	30652	1	applied	\N	\N	\N	\N	94717	94717	94718
20783	30653	2	applied	\N	\N	\N	\N	94719	94719	94720
20783	30654	3	applied	\N	\N	\N	\N	94721	94721	94722
20783	30655	4	applied	\N	\N	\N	\N	94723	94723	94724
20783	30656	5	applied	\N	\N	\N	\N	94725	94725	94726
20788	30657	0	applied	\N	\N	\N	\N	94734	94734	94735
20794	30672	0	applied	\N	\N	\N	\N	94774	94774	94775
20794	30673	1	applied	\N	\N	\N	\N	94776	94776	94777
20794	30674	2	applied	\N	\N	\N	\N	94778	94778	94779
20794	30675	3	applied	\N	\N	\N	\N	94780	94780	94781
20794	30676	4	applied	\N	\N	\N	\N	94782	94782	94783
20794	30677	5	applied	\N	\N	\N	\N	94784	94784	94785
20795	30678	0	applied	\N	\N	\N	\N	94788	94788	94789
20795	30679	1	applied	\N	\N	\N	\N	94790	94790	94791
20795	30680	2	applied	\N	\N	\N	\N	94792	94792	94793
20795	30681	3	applied	\N	\N	\N	\N	94794	94794	94795
20795	30682	4	applied	\N	\N	\N	\N	94796	94796	94797
20795	30683	5	applied	\N	\N	\N	\N	94798	94798	94799
20795	30684	6	applied	\N	\N	\N	\N	94800	94800	94801
20800	30688	0	applied	\N	\N	\N	\N	94814	94814	94815
20800	30689	1	applied	\N	\N	\N	\N	94816	94816	94817
20800	30690	2	applied	\N	\N	\N	\N	94818	94818	94819
20801	30691	0	applied	\N	\N	\N	\N	94822	94822	94823
20801	30692	1	applied	\N	\N	\N	\N	94824	94824	94825
20802	30693	0	applied	\N	\N	\N	\N	94827	94827	94828
20802	30694	1	applied	\N	\N	\N	\N	94829	94829	94830
20802	30695	2	applied	\N	\N	\N	\N	94831	94831	94832
20802	30696	3	applied	\N	\N	\N	\N	94833	94833	94834
20802	30697	4	applied	\N	\N	\N	\N	94835	94835	94836
20802	30698	5	applied	\N	\N	\N	\N	94837	94837	94838
20802	30699	6	applied	\N	\N	\N	\N	94839	94839	94840
20803	30700	0	applied	\N	\N	\N	\N	94843	94843	94844
20803	30701	1	applied	\N	\N	\N	\N	94845	94845	94846
20808	30712	0	applied	\N	\N	\N	\N	94876	94876	94877
20760	30574	8	applied	\N	\N	\N	\N	94480	94480	94481
20760	30589	9	applied	\N	\N	\N	\N	94515	94515	94516
20760	30590	10	applied	\N	\N	\N	\N	94517	94517	94518
20760	30595	11	applied	\N	\N	\N	\N	94531	94531	94532
20760	30596	12	applied	\N	\N	\N	\N	94533	94533	94534
20760	30575	13	applied	\N	\N	\N	\N	94482	94482	94483
20760	30576	14	applied	\N	\N	\N	\N	94484	94484	94485
20760	30577	15	applied	\N	\N	\N	\N	94486	94486	94487
20760	30537	16	applied	\N	\N	\N	\N	94389	94389	94390
20760	30538	17	applied	\N	\N	\N	\N	94391	94391	94392
20760	30543	18	applied	\N	\N	\N	\N	94403	94403	94404
20760	30544	19	applied	\N	\N	\N	\N	94405	94405	94406
20760	30546	20	applied	\N	\N	\N	\N	94409	94409	94410
20760	30550	21	applied	\N	\N	\N	\N	94421	94421	94422
20760	30551	22	applied	\N	\N	\N	\N	94423	94423	94424
20760	30552	23	applied	\N	\N	\N	\N	94425	94425	94426
20760	30556	24	applied	\N	\N	\N	\N	94435	94435	94436
20760	30557	25	applied	\N	\N	\N	\N	94437	94437	94438
20760	30561	26	applied	\N	\N	\N	\N	94446	94446	94447
20760	30562	27	applied	\N	\N	\N	\N	94448	94448	94449
20760	30578	28	applied	\N	\N	\N	\N	94488	94488	94489
20760	30526	29	applied	\N	\N	\N	\N	94364	94364	94365
20760	30529	30	applied	\N	\N	\N	\N	94372	94372	94373
20760	30533	31	applied	\N	\N	\N	\N	94381	94381	94382
20760	30534	32	applied	\N	\N	\N	\N	94383	94383	94384
20760	30545	33	applied	\N	\N	\N	\N	94407	94407	94408
20760	30553	34	applied	\N	\N	\N	\N	94427	94427	94428
20760	30558	35	applied	\N	\N	\N	\N	94439	94439	94440
20760	30563	36	applied	\N	\N	\N	\N	94450	94450	94451
20760	30569	37	applied	\N	\N	\N	\N	94464	94464	94465
20760	30597	38	applied	\N	\N	\N	\N	94535	94535	94536
20760	30579	39	applied	\N	\N	\N	\N	94490	94490	94491
20760	30582	40	applied	\N	\N	\N	\N	94497	94497	94498
20760	30587	41	applied	\N	\N	\N	\N	94511	94511	94512
20760	30598	42	applied	\N	\N	\N	\N	94537	94537	94538
20760	30599	43	applied	\N	\N	\N	\N	94539	94539	94540
20760	30600	44	applied	\N	\N	\N	\N	94541	94541	94542
20760	30601	45	applied	\N	\N	\N	\N	94543	94543	94544
20760	30602	46	applied	\N	\N	\N	\N	94545	94545	94546
20760	30603	47	applied	\N	\N	\N	\N	94547	94547	94548
20760	30564	48	applied	\N	\N	\N	\N	94452	94452	94453
20760	30568	49	applied	\N	\N	\N	\N	94462	94462	94463
20760	30570	50	applied	\N	\N	\N	\N	94466	94466	94467
20760	30571	51	applied	\N	\N	\N	\N	94468	94468	94469
20760	30604	52	applied	\N	\N	\N	\N	94549	94549	94550
20760	30521	53	applied	\N	\N	\N	\N	94347	94347	94362
20760	30531	54	applied	\N	\N	\N	\N	94376	94376	94551
20760	30549	55	applied	\N	\N	\N	\N	94415	94415	94342
20760	30566	56	applied	\N	\N	\N	\N	94456	94456	94552
20760	30585	57	applied	\N	\N	1000000000	\N	94503	94503	94504
20760	30586	58	applied	\N	\N	\N	\N	94505	94505	94344
20760	30605	59	applied	\N	\N	\N	\N	94553	94553	94554
20764	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20764	30595	1	applied	\N	\N	\N	\N	94531	94531	94532
20764	30596	2	applied	\N	\N	\N	\N	94533	94533	94534
20764	30598	3	applied	\N	\N	\N	\N	94537	94537	94538
20764	30599	4	applied	\N	\N	\N	\N	94539	94539	94540
20764	30597	5	applied	\N	\N	\N	\N	94535	94535	94536
20764	30601	6	applied	\N	\N	\N	\N	94543	94543	94544
20764	30602	7	applied	\N	\N	\N	\N	94545	94545	94546
20764	30605	8	applied	\N	\N	\N	\N	94553	94553	94556
20764	30606	9	applied	\N	\N	\N	\N	94557	94557	94558
20764	30607	10	applied	\N	\N	\N	\N	94559	94559	94560
20764	30608	11	applied	\N	\N	\N	\N	94561	94561	94562
20768	30609	0	applied	\N	\N	\N	\N	94607	94607	94608
20768	30610	1	applied	\N	\N	\N	\N	94609	94609	94610
20768	30611	2	applied	\N	\N	\N	\N	94611	94611	94612
20768	30600	3	applied	\N	\N	\N	\N	94541	94541	94542
20768	30612	4	applied	\N	\N	\N	\N	94613	94613	94614
20769	30613	0	applied	\N	\N	\N	\N	94620	94620	94621
20769	30614	1	applied	\N	\N	\N	\N	94622	94622	94623
20769	30615	2	applied	\N	\N	\N	\N	94624	94624	94625
20774	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20774	30617	1	applied	\N	\N	\N	\N	94630	94630	94631
20774	30618	2	applied	\N	\N	\N	\N	94632	94632	94633
20774	30619	3	applied	\N	\N	\N	\N	94634	94634	94635
20774	30620	4	applied	\N	\N	\N	\N	94636	94636	94637
20774	30621	5	applied	\N	\N	\N	\N	94638	94638	94639
20774	30622	6	applied	\N	\N	\N	\N	94640	94640	94641
20774	30623	7	applied	\N	\N	\N	\N	94642	94642	94643
20774	30624	8	applied	\N	\N	\N	\N	94644	94644	94645
20774	30625	9	applied	\N	\N	\N	\N	94646	94646	94647
20774	30626	10	applied	\N	\N	\N	\N	94648	94648	94649
20774	30627	11	applied	\N	\N	\N	\N	94650	94650	94651
20782	30651	0	applied	\N	\N	\N	\N	94715	94715	94716
20782	30652	1	applied	\N	\N	\N	\N	94717	94717	94718
20782	30653	2	applied	\N	\N	\N	\N	94719	94719	94720
20782	30654	3	applied	\N	\N	\N	\N	94721	94721	94722
20782	30655	4	applied	\N	\N	\N	\N	94723	94723	94724
20782	30656	5	applied	\N	\N	\N	\N	94725	94725	94726
20786	30447	0	applied	\N	\N	\N	\N	94107	94107	94089
20786	30455	1	applied	\N	\N	\N	\N	94108	94108	94109
20786	30456	2	applied	\N	\N	\N	\N	94110	94110	94111
20786	30457	3	applied	\N	\N	\N	\N	94112	94112	94113
20786	30593	4	applied	\N	\N	\N	\N	94527	94527	94528
20786	30594	5	applied	\N	\N	\N	\N	94529	94529	94530
20786	30616	6	applied	\N	\N	\N	\N	94628	94628	94629
20786	30652	7	applied	\N	\N	\N	\N	94717	94717	94718
20786	30588	8	applied	\N	\N	\N	\N	94513	94513	94514
20786	30535	9	applied	\N	\N	\N	\N	94566	94566	94386
20786	30536	10	applied	\N	\N	\N	\N	94567	94567	94388
20786	30574	11	applied	\N	\N	\N	\N	94568	94568	94481
20786	30589	12	applied	\N	\N	\N	\N	94515	94515	94516
20786	30590	13	applied	\N	\N	\N	\N	94517	94517	94518
20786	30595	14	applied	\N	\N	\N	\N	94531	94531	94532
20786	30596	15	applied	\N	\N	\N	\N	94533	94533	94534
20786	30575	16	applied	\N	\N	\N	\N	94569	94569	94483
20786	30576	17	applied	\N	\N	\N	\N	94570	94570	94485
20786	30577	18	applied	\N	\N	\N	\N	94571	94571	94487
20786	30537	19	applied	\N	\N	\N	\N	94572	94572	94390
20786	30538	20	applied	\N	\N	\N	\N	94573	94573	94392
20786	30543	21	applied	\N	\N	\N	\N	94574	94574	94404
20786	30544	22	applied	\N	\N	\N	\N	94575	94575	94406
20786	30374	23	applied	\N	\N	\N	\N	93817	93817	93818
20786	30379	24	applied	\N	\N	\N	\N	93842	93842	93843
20786	30546	25	applied	\N	\N	\N	\N	94576	94576	94410
20786	30550	26	applied	\N	\N	\N	\N	94577	94577	94422
20786	30551	27	applied	\N	\N	\N	\N	94578	94578	94424
20786	30552	28	applied	\N	\N	\N	\N	94579	94579	94426
20786	30556	29	applied	\N	\N	\N	\N	94580	94580	94436
20762	30543	17	applied	\N	\N	\N	\N	94574	94574	94404
20762	30544	18	applied	\N	\N	\N	\N	94575	94575	94406
20762	30546	19	applied	\N	\N	\N	\N	94576	94576	94410
20762	30550	20	applied	\N	\N	\N	\N	94577	94577	94422
20762	30551	21	applied	\N	\N	\N	\N	94578	94578	94424
20762	30552	22	applied	\N	\N	\N	\N	94579	94579	94426
20762	30556	23	applied	\N	\N	\N	\N	94580	94580	94436
20762	30557	24	applied	\N	\N	\N	\N	94581	94581	94438
20762	30561	25	applied	\N	\N	\N	\N	94582	94582	94447
20762	30562	26	applied	\N	\N	\N	\N	94583	94583	94449
20762	30578	27	applied	\N	\N	\N	\N	94584	94584	94489
20762	30425	28	applied	\N	\N	\N	\N	93973	93973	93974
20762	30428	29	applied	\N	\N	\N	\N	93998	93998	93999
20762	30431	30	applied	\N	\N	\N	\N	94046	94046	94047
20762	30434	31	applied	\N	\N	\N	\N	94054	94054	94055
20762	30437	32	applied	\N	\N	\N	\N	94062	94062	94063
20762	30441	33	applied	\N	\N	\N	\N	94071	94071	94072
20762	30444	34	applied	\N	\N	\N	\N	94077	94077	94078
20762	30448	35	applied	\N	\N	\N	\N	94090	94090	94091
20762	30449	36	applied	\N	\N	\N	\N	94092	94092	94093
20762	30458	37	applied	\N	\N	\N	\N	94121	94121	94122
20762	30597	38	applied	\N	\N	\N	\N	94535	94535	94536
20762	30601	39	applied	\N	\N	\N	\N	94543	94543	94544
20762	30564	40	applied	\N	\N	\N	\N	94585	94585	94453
20762	30568	41	applied	\N	\N	\N	\N	94586	94586	94463
20762	30570	42	applied	\N	\N	\N	\N	94587	94587	94467
20762	30571	43	applied	\N	\N	\N	\N	94588	94588	94469
20762	30604	44	applied	\N	\N	\N	\N	94589	94589	94550
20762	30463	45	applied	\N	\N	\N	\N	94136	94136	94137
20762	30464	46	applied	\N	\N	\N	\N	94138	94138	94139
20762	30465	47	applied	\N	\N	\N	\N	94140	94140	94141
20762	30471	48	applied	\N	\N	\N	\N	94158	94158	94159
20762	30474	49	applied	\N	\N	\N	\N	94166	94166	94167
20762	30475	50	applied	\N	\N	\N	\N	94168	94168	94169
20762	30482	51	applied	\N	\N	\N	\N	94184	94184	94185
20762	30484	52	applied	\N	\N	\N	\N	94192	94192	94193
20762	30488	53	applied	\N	\N	\N	\N	94204	94204	94205
20762	30491	54	applied	\N	\N	\N	\N	94244	94244	94245
20762	30494	55	applied	\N	\N	\N	\N	94252	94252	94253
20762	30496	56	applied	\N	\N	\N	\N	94288	94288	94289
20762	30497	57	applied	\N	\N	\N	\N	94290	94290	94291
20762	30498	58	applied	\N	\N	\N	\N	94292	94292	94293
20762	30506	59	applied	\N	\N	\N	\N	94315	94315	94316
20762	30507	60	applied	\N	\N	\N	\N	94317	94317	94318
20762	30508	61	applied	\N	\N	\N	\N	94319	94319	94320
20762	30516	62	applied	\N	\N	\N	\N	94337	94337	94338
20762	30517	63	applied	\N	\N	\N	\N	94339	94339	94340
20762	30523	64	applied	\N	\N	\N	\N	94352	94352	94353
20762	30526	65	applied	\N	\N	\N	\N	94364	94364	94365
20762	30529	66	applied	\N	\N	\N	\N	94372	94372	94373
20762	30533	67	applied	\N	\N	\N	\N	94381	94381	94382
20762	30534	68	applied	\N	\N	\N	\N	94383	94383	94384
20762	30545	69	applied	\N	\N	\N	\N	94407	94407	94408
20762	30553	70	applied	\N	\N	\N	\N	94427	94427	94428
20762	30558	71	applied	\N	\N	\N	\N	94439	94439	94440
20762	30563	72	applied	\N	\N	\N	\N	94450	94450	94451
20762	30569	74	applied	\N	\N	\N	\N	94464	94464	94465
20762	30579	75	applied	\N	\N	\N	\N	94490	94490	94491
20762	30582	76	applied	\N	\N	\N	\N	94497	94497	94498
20762	30587	77	applied	\N	\N	\N	\N	94511	94511	94512
20762	30598	78	applied	\N	\N	\N	\N	94537	94537	94538
20762	30599	79	applied	\N	\N	\N	\N	94539	94539	94540
20762	30509	80	applied	\N	\N	\N	\N	94321	94321	47675
20762	30459	81	applied	\N	\N	1000000000	\N	94123	94123	94124
20762	30476	82	applied	\N	\N	\N	\N	94170	94170	94171
20762	30430	83	applied	\N	\N	\N	\N	94002	94002	93908
20762	30433	84	applied	\N	\N	\N	\N	94050	94050	94591
20762	30435	85	applied	\N	\N	\N	\N	94056	94056	94592
20762	30585	86	applied	\N	\N	1000000000	\N	94503	94503	94504
20762	30440	87	applied	\N	\N	\N	\N	94068	94068	93922
20762	30442	88	applied	\N	\N	\N	\N	94073	94073	93989
20762	30446	89	applied	\N	\N	\N	\N	94083	94083	94593
20762	30404	90	applied	\N	\N	\N	\N	93905	93905	93941
20762	30405	91	applied	\N	\N	\N	\N	93907	93907	93943
20762	30406	92	applied	\N	\N	\N	\N	93909	93909	94270
20762	30411	93	applied	\N	\N	\N	\N	93930	93930	94271
20762	30415	94	applied	\N	\N	\N	\N	93942	93942	94272
20762	30422	95	applied	\N	\N	\N	\N	93959	93959	94273
20762	30423	96	applied	\N	\N	\N	\N	93961	93961	94274
20762	30424	97	applied	\N	\N	\N	\N	93963	93963	94275
20762	30426	98	applied	\N	\N	\N	\N	93975	93975	94276
20762	30432	99	applied	\N	\N	\N	\N	94048	94048	94277
20762	30436	100	applied	\N	\N	\N	\N	94058	94058	94051
20762	30438	101	applied	\N	\N	\N	\N	94064	94064	94278
20762	30443	102	applied	\N	\N	\N	\N	94075	94075	94279
20762	30445	103	applied	\N	\N	\N	\N	94079	94079	94067
20762	30450	104	applied	\N	\N	\N	\N	94094	94094	94280
20762	30451	105	applied	\N	\N	\N	\N	94096	94096	94281
20762	30461	106	applied	\N	\N	\N	\N	94130	94130	94282
20762	30467	107	applied	\N	\N	\N	\N	94144	94144	94084
20762	30453	108	applied	\N	\N	\N	\N	94100	94100	94594
20762	30454	109	applied	\N	\N	\N	\N	94102	94102	94595
20762	30460	110	applied	\N	\N	\N	\N	94125	94125	94097
20762	30462	111	applied	\N	\N	\N	\N	94132	94132	94596
20762	30468	112	applied	\N	\N	\N	\N	94146	94146	94103
20762	30469	113	applied	\N	\N	\N	\N	94148	94148	94126
20762	30470	114	applied	\N	\N	\N	\N	94150	94150	94285
20762	30472	115	applied	\N	\N	\N	\N	94160	94160	94597
20762	30304	116	applied	\N	\N	\N	\N	93627	93627	94133
20762	30322	117	applied	\N	\N	\N	\N	93668	93668	94143
20762	30345	118	applied	\N	\N	\N	\N	93718	93718	94598
20766	30609	0	applied	\N	\N	\N	\N	94607	94607	94608
20766	30610	1	applied	\N	\N	\N	\N	94609	94609	94610
20766	30611	2	applied	\N	\N	\N	\N	94611	94611	94612
20766	30600	3	applied	\N	\N	\N	\N	94541	94541	94542
20766	30612	4	applied	\N	\N	\N	\N	94613	94613	94614
20772	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20772	30617	1	applied	\N	\N	\N	\N	94630	94630	94631
20772	30618	2	applied	\N	\N	\N	\N	94632	94632	94633
20772	30619	3	applied	\N	\N	\N	\N	94634	94634	94635
20772	30620	4	applied	\N	\N	\N	\N	94636	94636	94637
20772	30621	5	applied	\N	\N	\N	\N	94638	94638	94639
20772	30622	6	applied	\N	\N	\N	\N	94640	94640	94641
20772	30623	7	applied	\N	\N	\N	\N	94642	94642	94643
20772	30624	8	applied	\N	\N	\N	\N	94644	94644	94645
20772	30625	9	applied	\N	\N	\N	\N	94646	94646	94647
20772	30626	10	applied	\N	\N	\N	\N	94648	94648	94649
20772	30627	11	applied	\N	\N	\N	\N	94650	94650	94651
20776	30628	0	applied	\N	\N	\N	\N	94658	94658	94659
20776	30629	1	applied	\N	\N	\N	\N	94660	94660	94661
20776	30630	2	applied	\N	\N	\N	\N	94662	94662	94663
20776	30631	3	applied	\N	\N	\N	\N	94664	94664	94665
20776	30632	4	applied	\N	\N	\N	\N	94666	94666	94667
20777	30633	0	applied	\N	\N	\N	\N	94670	94670	94671
20777	30634	1	applied	\N	\N	\N	\N	94672	94672	94673
20777	30635	2	applied	\N	\N	\N	\N	94674	94674	94675
20777	30636	3	applied	\N	\N	\N	\N	94676	94676	94677
20777	30637	4	applied	\N	\N	\N	\N	94678	94678	94679
20777	30638	5	applied	\N	\N	\N	\N	94680	94680	94681
20789	30659	0	applied	\N	\N	\N	\N	94742	94742	94743
20789	30660	1	applied	\N	\N	\N	\N	94744	94744	94745
20789	30661	2	applied	\N	\N	\N	\N	94746	94746	94747
20789	30662	3	applied	\N	\N	\N	\N	94748	94748	94749
20789	30658	4	applied	\N	\N	\N	\N	94736	94736	94737
20790	30663	0	applied	\N	\N	\N	\N	94752	94752	94753
20790	30664	1	applied	\N	\N	\N	\N	94754	94754	94755
20790	30665	2	applied	\N	\N	\N	\N	94756	94756	94757
20796	30678	0	applied	\N	\N	\N	\N	94788	94788	94789
20796	30679	1	applied	\N	\N	\N	\N	94790	94790	94791
20796	30680	2	applied	\N	\N	\N	\N	94792	94792	94793
20796	30681	3	applied	\N	\N	\N	\N	94794	94794	94795
20796	30682	4	applied	\N	\N	\N	\N	94796	94796	94797
20796	30683	5	applied	\N	\N	\N	\N	94798	94798	94799
20804	30700	0	applied	\N	\N	\N	\N	94843	94843	94844
20804	30701	1	applied	\N	\N	\N	\N	94845	94845	94846
20810	30714	0	applied	\N	\N	\N	\N	94882	94882	94883
20810	30715	1	applied	\N	\N	\N	\N	94884	94884	94885
20815	30719	0	applied	\N	\N	\N	\N	94900	94900	94901
20815	30720	1	applied	\N	\N	\N	\N	94902	94902	94903
20818	30593	0	applied	\N	\N	\N	\N	94527	94527	94528
20818	30594	1	applied	\N	\N	\N	\N	94529	94529	94530
20818	30616	2	applied	\N	\N	\N	\N	94628	94628	94629
20818	30702	3	applied	\N	\N	\N	\N	94908	94908	94852
20818	30703	4	applied	\N	\N	\N	\N	94909	94909	94854
20818	30704	5	applied	\N	\N	\N	\N	94910	94910	94856
20818	30705	6	applied	\N	\N	\N	\N	94911	94911	94858
20818	30706	7	applied	\N	\N	\N	\N	94912	94912	94912
20818	30652	8	applied	\N	\N	\N	\N	94717	94717	94718
20818	30641	9	applied	\N	\N	\N	\N	94691	94691	94692
20818	30651	10	applied	\N	\N	\N	\N	94715	94715	94716
20818	30659	11	applied	\N	\N	\N	\N	94742	94742	94743
20818	30588	12	applied	\N	\N	\N	\N	94513	94513	94514
20818	30535	13	applied	\N	\N	\N	\N	94385	94385	94386
20818	30536	14	applied	\N	\N	\N	\N	94387	94387	94388
20818	30574	15	applied	\N	\N	\N	\N	94480	94480	94481
20818	30589	16	applied	\N	\N	\N	\N	94515	94515	94516
20818	30590	17	applied	\N	\N	\N	\N	94517	94517	94518
20818	30595	18	applied	\N	\N	\N	\N	94531	94531	94532
20818	30596	19	applied	\N	\N	\N	\N	94533	94533	94534
20818	30575	20	applied	\N	\N	\N	\N	94482	94482	94483
20818	30576	21	applied	\N	\N	\N	\N	94484	94484	94485
20818	30577	22	applied	\N	\N	\N	\N	94486	94486	94487
20818	30537	23	applied	\N	\N	\N	\N	94389	94389	94390
20818	30538	24	applied	\N	\N	\N	\N	94391	94391	94392
20818	30543	25	applied	\N	\N	\N	\N	94403	94403	94404
20818	30544	26	applied	\N	\N	\N	\N	94405	94405	94406
20818	30546	27	applied	\N	\N	\N	\N	94409	94409	94410
20818	30550	28	applied	\N	\N	\N	\N	94421	94421	94422
20818	30551	29	applied	\N	\N	\N	\N	94423	94423	94424
20818	30552	30	applied	\N	\N	\N	\N	94425	94425	94426
20818	30556	31	applied	\N	\N	\N	\N	94435	94435	94436
20818	30557	32	applied	\N	\N	\N	\N	94437	94437	94438
20818	30561	33	applied	\N	\N	\N	\N	94446	94446	94447
20818	30562	34	applied	\N	\N	\N	\N	94448	94448	94449
20818	30578	35	applied	\N	\N	\N	\N	94488	94488	94489
20818	30526	36	applied	\N	\N	\N	\N	94364	94364	94365
20818	30529	37	applied	\N	\N	\N	\N	94372	94372	94373
20818	30533	38	applied	\N	\N	\N	\N	94381	94381	94382
20818	30534	39	applied	\N	\N	\N	\N	94383	94383	94384
20818	30545	40	applied	\N	\N	\N	\N	94407	94407	94408
20818	30673	41	applied	\N	\N	\N	\N	94913	94913	94777
20818	30674	42	applied	\N	\N	\N	\N	94914	94914	94779
20818	30675	43	applied	\N	\N	\N	\N	94915	94915	94781
20818	30676	44	applied	\N	\N	\N	\N	94916	94916	94783
20818	30679	45	applied	\N	\N	\N	\N	94917	94917	94791
20818	30553	46	applied	\N	\N	\N	\N	94427	94427	94428
20818	30558	47	applied	\N	\N	\N	\N	94439	94439	94440
20818	30563	48	applied	\N	\N	\N	\N	94450	94450	94451
20818	30569	49	applied	\N	\N	\N	\N	94464	94464	94465
20818	30597	50	applied	\N	\N	\N	\N	94535	94535	94536
20818	30579	51	applied	\N	\N	\N	\N	94490	94490	94491
20818	30582	52	applied	\N	\N	\N	\N	94497	94497	94498
20818	30587	53	applied	\N	\N	\N	\N	94511	94511	94512
20818	30598	54	applied	\N	\N	\N	\N	94537	94537	94538
20818	30599	55	applied	\N	\N	\N	\N	94539	94539	94540
20818	30600	56	applied	\N	\N	\N	\N	94541	94541	94542
20818	30601	57	applied	\N	\N	\N	\N	94543	94543	94544
20818	30602	58	applied	\N	\N	\N	\N	94545	94545	94546
20818	30603	59	applied	\N	\N	\N	\N	94547	94547	94548
20818	30609	60	applied	\N	\N	\N	\N	94607	94607	94608
20818	30610	61	applied	\N	\N	\N	\N	94609	94609	94610
20818	30611	62	applied	\N	\N	\N	\N	94611	94611	94612
20818	30721	63	applied	\N	\N	\N	\N	94918	94918	94745
20818	30722	64	applied	\N	\N	\N	\N	94919	94919	94755
20818	30618	65	applied	\N	\N	\N	\N	94920	94920	94633
20818	30619	66	applied	\N	\N	\N	\N	94921	94921	94635
20818	30620	67	applied	\N	\N	\N	\N	94922	94922	94637
20818	30621	68	applied	\N	\N	\N	\N	94923	94923	94639
20818	30622	69	applied	\N	\N	\N	\N	94924	94924	94641
20818	30628	70	applied	\N	\N	\N	\N	94925	94925	94659
20818	30630	71	applied	\N	\N	\N	\N	94926	94926	94663
20818	30631	72	applied	\N	\N	\N	\N	94927	94927	94665
20818	30633	73	applied	\N	\N	\N	\N	94928	94928	94671
20818	30660	74	applied	\N	\N	\N	\N	94929	94929	94930
20818	30664	75	applied	\N	\N	\N	\N	94931	94931	94932
20818	30680	76	applied	\N	\N	\N	\N	94933	94933	94793
20818	30681	77	applied	\N	\N	\N	\N	94934	94934	94795
20818	30614	78	applied	\N	\N	\N	\N	94622	94622	94623
20818	30623	79	applied	\N	\N	\N	\N	94642	94642	94643
20818	30624	80	applied	\N	\N	\N	\N	94644	94644	94645
20818	30629	81	applied	\N	\N	\N	\N	94660	94660	94661
20818	30634	82	applied	\N	\N	\N	\N	94672	94672	94673
20818	30635	83	applied	\N	\N	\N	\N	94674	94674	94675
20818	30639	84	applied	\N	\N	\N	\N	94685	94685	94686
20818	30642	85	applied	\N	\N	\N	\N	94693	94693	94694
20818	30643	86	applied	\N	\N	\N	\N	94695	94695	94696
20818	30644	87	applied	\N	\N	\N	\N	94697	94697	94698
20818	30649	88	applied	\N	\N	\N	\N	94709	94709	94710
20818	30653	89	applied	\N	\N	\N	\N	94719	94719	94720
20780	30641	0	applied	\N	\N	\N	\N	94691	94691	94692
20780	30642	1	applied	\N	\N	\N	\N	94693	94693	94694
20780	30643	2	applied	\N	\N	\N	\N	94695	94695	94696
20780	30644	3	applied	\N	\N	\N	\N	94697	94697	94698
20780	30645	4	applied	\N	\N	\N	\N	94699	94699	94700
20780	30646	5	applied	\N	\N	\N	\N	94701	94701	94702
20780	30647	6	applied	\N	\N	\N	\N	94703	94703	94704
20780	30648	7	applied	\N	\N	\N	\N	94705	94705	94706
20781	30649	0	applied	\N	\N	\N	\N	94709	94709	94710
20781	30650	1	applied	\N	\N	\N	\N	94711	94711	94712
20785	30651	0	applied	\N	\N	\N	\N	94715	94715	94716
20785	30652	1	applied	\N	\N	\N	\N	94717	94717	94718
20785	30653	2	applied	\N	\N	\N	\N	94719	94719	94720
20785	30654	3	applied	\N	\N	\N	\N	94721	94721	94722
20785	30655	4	applied	\N	\N	\N	\N	94723	94723	94724
20785	30656	5	applied	\N	\N	\N	\N	94725	94725	94726
20791	30666	0	applied	\N	\N	\N	\N	94759	94759	94760
20791	30667	1	applied	\N	\N	\N	\N	94761	94761	94762
20791	30668	2	applied	\N	\N	\N	\N	94763	94763	94764
20791	30669	3	applied	\N	\N	\N	\N	94765	94765	94766
20797	30685	0	applied	\N	\N	\N	\N	94805	94805	94806
20798	30686	0	applied	\N	\N	\N	\N	94809	94809	94810
20798	30687	1	applied	\N	\N	\N	\N	94811	94811	94812
20805	30702	0	applied	\N	\N	\N	\N	94851	94851	94852
20805	30703	1	applied	\N	\N	\N	\N	94853	94853	94854
20805	30704	2	applied	\N	\N	\N	\N	94855	94855	94856
20805	30705	3	applied	\N	\N	\N	\N	94857	94857	94858
20805	30706	4	applied	\N	\N	\N	\N	94859	94859	94859
20805	30707	5	applied	\N	\N	\N	\N	94860	94860	94861
20805	30708	6	applied	\N	\N	\N	\N	94862	94862	94863
20806	30709	0	applied	\N	\N	\N	\N	94866	94866	94867
20806	30710	1	applied	\N	\N	\N	\N	94868	94868	94869
20811	30714	0	applied	\N	\N	\N	\N	94882	94882	94883
20811	30715	1	applied	\N	\N	\N	\N	94884	94884	94885
20816	30719	0	applied	\N	\N	\N	\N	94900	94900	94901
20816	30720	1	applied	\N	\N	\N	\N	94902	94902	94903
20824	30728	0	applied	\N	\N	\N	\N	94954	94954	94955
20824	30729	1	applied	\N	\N	\N	\N	94956	94956	94957
20824	30727	2	applied	\N	\N	\N	\N	94951	94951	94958
20831	30734	0	applied	\N	\N	\N	\N	94973	94973	94974
20831	30735	1	applied	\N	\N	\N	\N	94975	94975	94976
20831	30736	2	applied	\N	\N	\N	\N	94977	94977	94978
20835	30741	0	applied	\N	\N	\N	\N	94996	94996	94997
20835	30742	1	applied	\N	\N	\N	\N	94998	94998	94999
20841	30748	0	applied	\N	\N	\N	\N	95023	95023	95024
20841	30749	1	applied	\N	\N	\N	\N	95025	95025	95026
20841	30750	2	applied	\N	\N	\N	\N	95027	95027	95028
20843	30751	0	applied	\N	\N	\N	\N	95034	95034	95035
20843	30752	1	applied	\N	\N	\N	\N	95036	95036	95037
20848	30744	0	applied	\N	\N	\N	\N	95054	95054	95013
20848	30745	1	applied	\N	\N	\N	\N	95055	95055	95015
20848	30748	2	applied	\N	\N	\N	\N	95056	95056	95024
20848	30758	3	applied	\N	\N	\N	\N	95057	95057	95058
20851	30763	0	applied	\N	\N	\N	\N	95071	95071	95072
20851	30764	2	applied	\N	\N	\N	\N	95074	95074	95075
20851	30765	3	applied	\N	\N	\N	\N	95076	95076	95077
20857	30780	0	applied	\N	\N	\N	\N	95116	95116	95117
20857	30781	1	applied	\N	\N	\N	\N	95118	95118	95119
20857	30782	2	applied	\N	\N	\N	\N	95120	95120	95121
20857	30783	3	applied	\N	\N	\N	\N	95122	95122	95123
20863	30807	0	applied	\N	\N	\N	\N	95180	95180	95181
20863	30808	1	applied	\N	\N	\N	\N	95182	95182	95183
20863	30809	2	applied	\N	\N	\N	\N	95184	95184	95185
20863	30810	3	applied	\N	\N	\N	\N	95186	95186	95187
20863	30811	4	applied	\N	\N	\N	\N	95188	95188	95189
20865	30817	0	applied	\N	\N	\N	\N	95206	95206	95207
20865	30818	1	applied	\N	\N	\N	\N	95208	95208	95209
20870	30819	0	applied	\N	\N	\N	\N	95235	95235	95236
20870	30820	1	applied	\N	\N	\N	\N	95237	95237	95238
20870	30821	2	applied	\N	\N	\N	\N	95239	95239	95240
20872	30826	0	applied	\N	\N	\N	\N	95256	95256	95257
20872	30827	1	applied	\N	\N	\N	\N	95258	95258	95259
20875	30831	0	applied	\N	\N	\N	\N	95270	95270	95271
20875	30832	1	applied	\N	\N	\N	\N	95272	95272	95273
20875	30833	2	applied	\N	\N	\N	\N	95274	95274	95275
20875	30834	3	applied	\N	\N	\N	\N	95276	95276	95277
20880	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20880	30780	1	applied	\N	\N	\N	\N	95116	95116	95117
20880	30786	2	applied	\N	\N	\N	\N	95133	95133	95134
20880	30787	3	applied	\N	\N	\N	\N	95135	95135	95136
20880	30807	4	applied	\N	\N	\N	\N	95180	95180	95181
20880	30758	5	applied	\N	\N	\N	\N	95061	95061	95058
20880	30751	6	applied	\N	\N	\N	\N	95034	95034	95035
20880	30753	7	applied	\N	\N	\N	\N	95039	95039	95040
20880	30755	8	applied	\N	\N	\N	\N	95046	95046	95047
20880	30759	9	applied	\N	\N	\N	\N	95062	95062	95063
20880	30760	10	applied	\N	\N	\N	\N	95064	95064	95065
20880	30763	11	applied	\N	\N	\N	\N	95071	95071	95072
20880	30766	12	applied	\N	\N	\N	\N	95083	95083	95084
20880	30767	13	applied	\N	\N	\N	\N	95085	95085	95086
20880	30805	14	applied	\N	\N	\N	\N	95175	95175	95175
20880	30771	15	applied	\N	\N	\N	\N	95095	95095	95096
20880	30772	16	applied	\N	\N	\N	\N	95097	95097	95098
20880	30773	17	applied	\N	\N	\N	\N	95099	95099	95100
20880	30774	18	applied	\N	\N	\N	\N	95101	95101	95102
20880	30781	19	applied	\N	\N	\N	\N	95118	95118	95119
20880	30784	20	applied	\N	\N	\N	\N	95129	95129	95130
20880	30788	22	applied	\N	\N	\N	\N	95137	95137	95138
20880	30789	23	applied	\N	\N	\N	\N	95139	95139	95140
20880	30790	24	applied	\N	\N	\N	\N	95141	95141	95142
20880	30791	25	applied	\N	\N	\N	\N	95143	95143	95144
20880	30801	26	applied	\N	\N	\N	\N	95165	95165	95166
20880	30804	27	applied	\N	\N	\N	\N	95173	95173	95174
20880	30808	28	applied	\N	\N	\N	\N	95182	95182	95183
20880	30809	29	applied	\N	\N	\N	\N	95184	95184	95185
20880	30812	30	applied	\N	\N	\N	\N	95194	95194	95195
20880	30813	31	applied	\N	\N	\N	\N	95196	95196	95197
20880	30817	32	applied	\N	\N	\N	\N	95206	95206	95207
20880	30819	33	applied	\N	\N	\N	\N	95235	95235	95236
20880	30822	34	applied	\N	\N	\N	\N	95247	95247	95248
20880	30823	35	applied	\N	\N	\N	\N	95249	95249	95250
20880	30826	36	applied	\N	\N	\N	\N	95256	95256	95257
20880	30828	37	applied	\N	\N	\N	\N	95262	95262	95263
20880	30831	38	applied	\N	\N	\N	\N	95270	95270	95271
20880	30832	39	applied	\N	\N	\N	\N	95272	95272	95273
20880	30835	40	applied	\N	\N	\N	\N	95290	95290	95291
20880	30838	41	applied	\N	\N	\N	\N	95298	95298	95299
20880	30752	42	applied	\N	\N	\N	\N	95036	95036	95037
20880	30756	43	applied	\N	\N	\N	\N	95048	95048	95049
20880	30764	44	applied	\N	\N	\N	\N	95074	95074	95044
20786	30557	30	applied	\N	\N	\N	\N	94581	94581	94438
20786	30561	31	applied	\N	\N	\N	\N	94582	94582	94447
20786	30562	32	applied	\N	\N	\N	\N	94583	94583	94449
20786	30578	33	applied	\N	\N	\N	\N	94584	94584	94489
20786	30597	34	applied	\N	\N	\N	\N	94535	94535	94536
20786	30382	35	applied	\N	\N	\N	\N	93848	93848	93849
20786	30601	36	applied	\N	\N	\N	\N	94543	94543	94544
20786	30602	37	applied	\N	\N	\N	\N	94545	94545	94546
20787	30657	0	applied	\N	\N	\N	\N	94734	94734	94735
20787	30658	1	applied	\N	\N	\N	\N	94736	94736	94737
20792	30666	0	applied	\N	\N	\N	\N	94759	94759	94760
20792	30667	1	applied	\N	\N	\N	\N	94761	94761	94762
20792	30668	2	applied	\N	\N	\N	\N	94763	94763	94764
20792	30669	3	applied	\N	\N	\N	\N	94765	94765	94766
20793	30670	0	applied	\N	\N	\N	\N	94769	94769	94770
20793	30671	1	applied	\N	\N	\N	\N	94771	94771	94772
20807	30709	0	applied	\N	\N	\N	\N	94866	94866	94867
20807	30711	1	applied	\N	\N	\N	\N	94872	94872	94873
20807	30710	2	applied	\N	\N	\N	\N	94868	94868	94874
20812	30714	0	applied	\N	\N	\N	\N	94882	94882	94883
20812	30715	1	applied	\N	\N	\N	\N	94884	94884	94885
20817	30719	0	applied	\N	\N	\N	\N	94900	94900	94901
20817	30720	1	applied	\N	\N	\N	\N	94902	94902	94903
20822	30725	0	applied	\N	\N	\N	\N	94945	94945	94946
20822	30726	1	applied	\N	\N	\N	\N	94947	94947	94948
20826	30728	0	applied	\N	\N	\N	\N	94954	94954	94955
20826	30729	1	applied	\N	\N	\N	\N	94956	94956	94957
20826	30727	2	applied	\N	\N	\N	\N	94951	94951	94958
20828	30732	0	applied	\N	\N	\N	\N	94968	94968	94969
20828	30733	1	applied	\N	\N	\N	\N	94970	94970	94971
20829	30734	0	applied	\N	\N	\N	\N	94973	94973	94974
20829	30735	1	applied	\N	\N	\N	\N	94975	94975	94976
20829	30736	2	applied	\N	\N	\N	\N	94977	94977	94978
20832	30734	0	applied	\N	\N	\N	\N	94973	94973	94974
20832	30735	1	applied	\N	\N	\N	\N	94975	94975	94976
20832	30736	2	applied	\N	\N	\N	\N	94977	94977	94978
20833	30737	0	applied	\N	\N	\N	\N	94985	94985	94986
20833	30738	1	applied	\N	\N	\N	\N	94987	94987	94988
20833	30739	2	applied	\N	\N	\N	\N	94989	94989	94989
20837	30741	0	applied	\N	\N	\N	\N	94996	94996	94997
20837	30742	1	applied	\N	\N	\N	\N	94998	94998	94999
20839	30743	0	applied	\N	\N	\N	\N	95010	95010	95011
20839	30744	1	applied	\N	\N	\N	\N	95012	95012	95013
20839	30745	2	applied	\N	\N	\N	\N	95014	95014	95015
20839	30746	3	applied	\N	\N	\N	\N	95016	95016	95017
20839	30747	4	applied	\N	\N	\N	\N	95018	95018	95019
20842	30748	0	applied	\N	\N	\N	\N	95023	95023	95024
20842	30749	1	applied	\N	\N	\N	\N	95025	95025	95026
20842	30750	2	applied	\N	\N	\N	\N	95027	95027	95028
20844	30753	0	applied	\N	\N	\N	\N	95039	95039	95040
20860	30801	0	applied	\N	\N	\N	\N	95165	95165	95166
20860	30802	1	applied	\N	\N	\N	\N	95167	95167	95168
20860	30803	2	applied	\N	\N	\N	\N	95169	95169	95170
20866	30817	0	applied	\N	\N	\N	\N	95206	95206	95207
20866	30818	1	applied	\N	\N	\N	\N	95208	95208	95209
20868	30819	0	applied	\N	\N	\N	\N	95235	95235	95236
20868	30820	1	applied	\N	\N	\N	\N	95237	95237	95238
20868	30821	2	applied	\N	\N	\N	\N	95239	95239	95240
20873	30826	0	applied	\N	\N	\N	\N	95256	95256	95257
20873	30827	1	applied	\N	\N	\N	\N	95258	95258	95259
20876	30831	0	applied	\N	\N	\N	\N	95270	95270	95271
20876	30832	1	applied	\N	\N	\N	\N	95272	95272	95273
20876	30833	2	applied	\N	\N	\N	\N	95274	95274	95275
20876	30834	3	applied	\N	\N	\N	\N	95276	95276	95277
20883	30841	0	applied	\N	\N	\N	\N	95327	95327	95328
20883	30842	1	applied	\N	\N	\N	\N	95329	95329	93688
20883	30843	2	applied	\N	\N	\N	\N	95330	95330	95331
20883	30844	3	applied	\N	\N	\N	\N	95332	95332	95333
20887	30845	0	applied	\N	\N	\N	\N	95339	95339	95340
20887	30846	1	applied	\N	\N	\N	\N	95341	95341	95342
20894	30851	0	applied	\N	\N	\N	\N	95361	95361	95362
20894	30852	1	applied	\N	\N	\N	\N	95363	95363	95364
20894	30853	2	applied	\N	\N	\N	\N	95365	95365	95366
20896	30856	0	applied	\N	\N	\N	\N	95377	95377	95378
20896	30857	1	applied	\N	\N	\N	\N	95379	95379	95380
20902	30861	0	applied	\N	\N	\N	\N	95391	95391	95392
20902	30862	1	applied	\N	\N	\N	\N	95393	95393	95394
20905	30865	0	applied	\N	\N	\N	\N	95406	95406	95407
20905	30866	1	applied	\N	\N	\N	\N	95408	95408	95409
20905	30867	2	applied	\N	\N	\N	\N	95410	95410	95411
20905	30868	3	applied	\N	\N	\N	\N	95412	95412	95413
20905	30869	4	applied	\N	\N	\N	\N	95414	95414	95415
20911	30886	0	applied	\N	\N	\N	\N	95458	95458	95459
20911	30887	1	applied	\N	\N	\N	\N	95460	95460	95461
20914	30888	0	applied	\N	\N	1000000000	\N	95470	95470	95471
20914	30889	1	applied	\N	\N	\N	\N	95472	95472	95473
20914	30890	2	applied	\N	\N	\N	\N	95474	95474	95475
20914	30891	3	applied	\N	\N	\N	\N	95476	95476	95477
20916	30892	0	applied	\N	\N	\N	\N	95481	95481	95482
20916	30893	1	applied	\N	\N	\N	\N	95483	95483	95484
20916	30894	2	applied	\N	\N	\N	\N	95485	95485	95486
20916	30895	3	applied	\N	\N	\N	\N	95487	95487	95488
20916	30896	4	applied	\N	\N	\N	\N	95489	95489	95490
20918	30897	0	applied	\N	\N	\N	\N	95495	95495	95496
20918	30898	1	applied	\N	\N	\N	\N	95497	95497	95498
20923	30905	0	applied	\N	\N	\N	\N	95516	95516	95517
20923	30906	1	applied	\N	\N	\N	\N	95518	95518	95519
20923	30907	2	applied	\N	\N	\N	\N	95520	95520	95521
20928	30918	0	applied	\N	\N	\N	\N	95546	95546	95547
20928	30919	1	applied	\N	\N	\N	\N	95548	95548	95549
20928	30920	2	applied	\N	\N	\N	\N	95550	95550	95551
20937	30933	0	applied	\N	\N	\N	\N	95583	95583	95584
20937	30934	1	applied	\N	\N	\N	\N	95585	95585	95586
20937	30935	2	applied	\N	\N	\N	\N	95587	95587	95588
20937	30936	3	applied	\N	\N	\N	\N	95589	95589	95590
20937	30937	4	applied	\N	\N	\N	\N	95591	95591	95592
20937	30938	5	applied	\N	\N	\N	\N	95593	95593	95594
20937	30939	6	applied	\N	\N	\N	\N	95595	95595	95596
20937	30940	7	applied	\N	\N	\N	\N	95597	95597	95598
20937	30941	8	applied	\N	\N	\N	\N	95599	95599	95600
20938	30942	0	applied	\N	\N	1000000000	\N	95607	95607	95608
20938	30943	1	applied	\N	\N	\N	\N	95609	95609	95610
20938	30944	2	applied	\N	\N	\N	\N	95611	95611	95612
20941	30955	0	applied	\N	\N	\N	\N	95636	95636	95637
20941	30956	1	applied	\N	\N	\N	\N	95638	95638	95639
20944	30967	0	applied	\N	\N	\N	\N	95664	95664	95665
20944	30968	1	applied	\N	\N	\N	\N	95666	95666	95667
20944	30969	2	applied	\N	\N	\N	\N	95668	95668	95669
20944	30970	3	applied	\N	\N	\N	\N	95670	95670	95671
20808	30711	1	applied	\N	\N	\N	\N	94872	94872	94874
20808	30713	2	applied	\N	\N	\N	\N	94878	94878	94879
20809	30714	0	applied	\N	\N	\N	\N	94882	94882	94883
20809	30715	1	applied	\N	\N	\N	\N	94884	94884	94885
20813	30716	0	applied	\N	\N	\N	\N	94893	94893	94894
20813	30717	1	applied	\N	\N	\N	\N	94895	94895	94896
20813	30718	2	applied	\N	\N	\N	\N	94897	94897	94898
20814	30719	0	applied	\N	\N	\N	\N	94900	94900	94901
20814	30720	1	applied	\N	\N	\N	\N	94902	94902	94903
20823	30727	0	applied	\N	\N	\N	\N	94951	94951	94952
20827	30730	0	applied	\N	\N	\N	\N	94962	94962	94963
20827	30731	1	applied	\N	\N	\N	\N	94964	94964	94965
20830	30734	0	applied	\N	\N	\N	\N	94973	94973	94974
20830	30735	1	applied	\N	\N	\N	\N	94975	94975	94976
20830	30736	2	applied	\N	\N	\N	\N	94977	94977	94978
20834	30737	0	applied	\N	\N	\N	\N	94985	94985	94986
20834	30738	1	applied	\N	\N	\N	\N	94987	94987	94988
20834	30739	2	applied	\N	\N	\N	\N	94989	94989	94989
20834	30740	3	applied	\N	\N	\N	\N	94992	94992	94993
20836	30616	0	applied	\N	\N	\N	\N	94628	94628	94629
20836	30702	1	applied	\N	\N	\N	\N	94908	94908	94852
20836	30703	2	applied	\N	\N	\N	\N	94909	94909	94854
20836	30704	3	applied	\N	\N	\N	\N	94910	94910	94856
20836	30705	4	applied	\N	\N	\N	\N	94911	94911	94858
20836	30706	5	applied	\N	\N	\N	\N	94912	94912	94912
20836	30652	6	applied	\N	\N	\N	\N	94717	94717	94718
20836	30737	7	applied	\N	\N	\N	\N	95002	95002	94986
20836	30641	8	applied	\N	\N	\N	\N	94691	94691	94692
20836	30651	9	applied	\N	\N	\N	\N	94715	94715	94716
20836	30659	10	applied	\N	\N	\N	\N	94742	94742	94743
20836	30609	11	applied	\N	\N	\N	\N	94607	94607	94608
20836	30610	12	applied	\N	\N	\N	\N	94609	94609	94610
20836	30611	13	applied	\N	\N	\N	\N	94611	94611	94612
20836	30721	14	applied	\N	\N	\N	\N	94918	94918	94745
20836	30722	15	applied	\N	\N	\N	\N	94919	94919	94755
20836	30618	16	applied	\N	\N	\N	\N	94920	94920	94633
20836	30619	17	applied	\N	\N	\N	\N	94921	94921	94635
20836	30620	18	applied	\N	\N	\N	\N	94922	94922	94637
20836	30621	19	applied	\N	\N	\N	\N	94923	94923	94639
20836	30622	20	applied	\N	\N	\N	\N	94924	94924	94641
20836	30628	21	applied	\N	\N	\N	\N	94925	94925	94659
20836	30673	22	applied	\N	\N	\N	\N	94913	94913	94777
20836	30674	23	applied	\N	\N	\N	\N	94914	94914	94779
20836	30675	24	applied	\N	\N	\N	\N	94915	94915	94781
20836	30676	25	applied	\N	\N	\N	\N	94916	94916	94783
20836	30679	26	applied	\N	\N	\N	\N	94917	94917	94791
20836	30630	27	applied	\N	\N	\N	\N	94926	94926	94663
20836	30631	28	applied	\N	\N	\N	\N	94927	94927	94665
20836	30633	29	applied	\N	\N	\N	\N	94928	94928	94936
20836	30660	30	applied	\N	\N	\N	\N	94929	94929	94930
20836	30664	31	applied	\N	\N	\N	\N	94931	94931	94932
20836	30680	32	applied	\N	\N	\N	\N	94933	94933	94793
20836	30681	33	applied	\N	\N	\N	\N	94934	94934	94795
20836	30662	34	applied	\N	\N	\N	\N	94748	94748	94749
20836	30666	35	applied	\N	\N	\N	\N	94759	94759	94760
20836	30739	36	applied	\N	\N	\N	\N	94989	94989	94989
20840	30748	0	applied	\N	\N	\N	\N	95023	95023	95024
20840	30749	1	applied	\N	\N	\N	\N	95025	95025	95026
20840	30750	2	applied	\N	\N	\N	\N	95027	95027	95028
20845	30753	0	applied	\N	\N	\N	\N	95039	95039	95040
20845	30754	1	applied	\N	\N	\N	\N	95043	95043	95044
20849	30758	0	applied	\N	\N	\N	\N	95061	95061	95058
20849	30759	1	applied	\N	\N	\N	\N	95062	95062	95063
20849	30760	2	applied	\N	\N	\N	\N	95064	95064	95065
20849	30761	3	applied	\N	\N	\N	\N	95066	95066	95067
20849	30762	4	applied	\N	\N	\N	\N	95068	95068	95069
20852	30766	0	applied	\N	\N	\N	\N	95083	95083	95084
20852	30767	1	applied	\N	\N	\N	\N	95085	95085	95086
20852	30768	2	applied	\N	\N	\N	\N	95087	95087	95088
20852	30769	3	applied	\N	\N	\N	\N	95089	95089	95090
20853	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20853	30771	1	applied	\N	\N	\N	\N	95095	95095	95096
20853	30772	2	applied	\N	\N	\N	\N	95097	95097	95098
20853	30773	3	applied	\N	\N	\N	\N	95099	95099	95100
20853	30774	4	applied	\N	\N	\N	\N	95101	95101	95102
20853	30775	5	applied	\N	\N	\N	\N	95103	95103	95104
20853	30776	6	applied	\N	\N	\N	\N	95105	95105	95106
20853	30777	7	applied	\N	\N	\N	\N	95107	95107	95108
20853	30778	8	applied	\N	\N	\N	\N	95109	95109	95110
20853	30779	9	applied	\N	\N	\N	\N	95111	95111	95112
20855	30780	0	applied	\N	\N	\N	\N	95116	95116	95117
20855	30781	1	applied	\N	\N	\N	\N	95118	95118	95119
20855	30782	2	applied	\N	\N	\N	\N	95120	95120	95121
20855	30783	3	applied	\N	\N	\N	\N	95122	95122	95123
20861	30804	0	applied	\N	\N	\N	\N	95173	95173	95174
20861	30805	1	applied	\N	\N	\N	\N	95175	95175	95175
20861	30806	2	applied	\N	\N	\N	\N	95176	95176	95177
20864	30812	0	applied	\N	\N	\N	\N	95194	95194	95195
20864	30813	1	applied	\N	\N	\N	\N	95196	95196	95197
20864	30814	2	applied	\N	\N	\N	\N	95198	95198	95199
20864	30815	3	applied	\N	\N	\N	\N	95200	95200	95201
20864	30816	4	applied	\N	\N	\N	\N	95202	95202	95203
20869	30819	0	applied	\N	\N	\N	\N	95235	95235	95236
20869	30820	1	applied	\N	\N	\N	\N	95237	95237	95238
20869	30821	2	applied	\N	\N	\N	\N	95239	95239	95240
20871	30822	0	applied	\N	\N	\N	\N	95247	95247	95248
20871	30823	1	applied	\N	\N	\N	\N	95249	95249	95250
20871	30824	2	applied	\N	\N	\N	\N	95251	95251	95252
20871	30825	3	applied	\N	\N	\N	\N	95253	95253	95254
20878	30835	0	applied	\N	\N	\N	\N	95290	95290	95291
20878	30836	1	applied	\N	\N	\N	\N	95292	95292	95293
20878	30837	2	applied	\N	\N	\N	\N	95294	95294	95295
20899	30861	0	applied	\N	\N	\N	\N	95391	95391	95392
20899	30862	1	applied	\N	\N	\N	\N	95393	95393	95394
20903	30861	0	applied	\N	\N	\N	\N	95391	95391	95392
20903	30862	1	applied	\N	\N	\N	\N	95393	95393	95394
20906	30865	0	applied	\N	\N	\N	\N	95406	95406	95407
20906	30866	1	applied	\N	\N	\N	\N	95408	95408	95409
20906	30867	2	applied	\N	\N	\N	\N	95410	95410	95411
20906	30868	3	applied	\N	\N	\N	\N	95412	95412	95413
20906	30869	4	applied	\N	\N	\N	\N	95414	95414	95415
20908	30870	0	applied	\N	\N	\N	\N	95420	95420	95421
20908	30871	1	applied	\N	\N	\N	\N	95422	95422	95423
20912	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20912	30780	1	applied	\N	\N	\N	\N	95116	95116	95117
20912	30786	2	applied	\N	\N	\N	\N	95133	95133	95134
20912	30787	3	applied	\N	\N	\N	\N	95135	95135	95136
20912	30807	4	applied	\N	\N	\N	\N	95180	95180	95181
20912	30728	5	applied	\N	\N	\N	\N	94954	94954	94955
20912	30737	6	applied	\N	\N	\N	\N	94985	94985	94986
20818	30657	90	applied	\N	\N	\N	\N	94734	94734	94735
20818	30661	91	applied	\N	\N	\N	\N	94746	94746	94747
20818	30663	92	applied	\N	\N	\N	\N	94752	94752	94753
20818	30667	93	applied	\N	\N	\N	\N	94761	94761	94762
20818	30670	94	applied	\N	\N	\N	\N	94769	94769	94770
20818	30672	95	applied	\N	\N	\N	\N	94774	94774	94775
20818	30678	96	applied	\N	\N	\N	\N	94788	94788	94789
20818	30685	98	applied	\N	\N	\N	\N	94805	94805	94806
20818	30686	99	applied	\N	\N	\N	\N	94809	94809	94810
20818	30688	100	applied	\N	\N	\N	\N	94814	94814	94815
20818	30691	101	applied	\N	\N	\N	\N	94822	94822	94823
20818	30693	102	applied	\N	\N	\N	\N	94827	94827	94828
20818	30694	103	applied	\N	\N	\N	\N	94829	94829	94830
20818	30695	104	applied	\N	\N	\N	\N	94831	94831	94832
20818	30700	105	applied	\N	\N	\N	\N	94843	94843	94844
20818	30707	106	applied	\N	\N	\N	\N	94860	94860	94861
20818	30709	107	applied	\N	\N	\N	\N	94866	94866	94867
20818	30712	108	applied	\N	\N	\N	\N	94876	94876	94877
20818	30714	109	applied	\N	\N	\N	\N	94882	94882	94883
20818	30716	110	applied	\N	\N	\N	\N	94893	94893	94894
20818	30719	111	applied	\N	\N	\N	\N	94900	94900	94901
20818	30564	112	applied	\N	\N	\N	\N	94452	94452	94453
20818	30568	113	applied	\N	\N	\N	\N	94462	94462	94463
20818	30570	114	applied	\N	\N	\N	\N	94466	94466	94467
20818	30571	115	applied	\N	\N	\N	\N	94468	94468	94469
20818	30604	116	applied	\N	\N	\N	\N	94549	94549	94936
20818	30662	117	applied	\N	\N	\N	\N	94748	94748	94749
20818	30666	118	applied	\N	\N	\N	\N	94759	94759	94760
20818	30531	119	applied	\N	\N	\N	\N	94376	94376	94551
20818	30549	120	applied	\N	\N	\N	\N	94415	94415	94342
20818	30566	121	applied	\N	\N	\N	\N	94456	94456	94552
20818	30585	122	applied	\N	\N	1000000000	\N	94503	94503	94504
20818	30586	123	applied	\N	\N	\N	\N	94505	94505	94344
20818	30605	124	applied	\N	\N	\N	\N	94553	94553	94554
20818	30627	125	applied	\N	\N	\N	\N	94650	94650	94346
20820	30723	0	applied	\N	\N	\N	\N	94940	94940	94941
20820	30724	1	applied	\N	\N	\N	\N	94942	94942	94943
20821	30725	0	applied	\N	\N	\N	\N	94945	94945	94946
20821	30726	1	applied	\N	\N	\N	\N	94947	94947	94948
20825	30728	0	applied	\N	\N	\N	\N	94954	94954	94955
20825	30727	1	applied	\N	\N	\N	\N	94951	94951	94952
20838	30743	0	applied	\N	\N	\N	\N	95010	95010	95011
20838	30744	1	applied	\N	\N	\N	\N	95012	95012	95013
20838	30745	2	applied	\N	\N	\N	\N	95014	95014	95015
20838	30746	3	applied	\N	\N	\N	\N	95016	95016	95017
20838	30747	4	applied	\N	\N	\N	\N	95018	95018	95019
20846	30753	0	applied	\N	\N	\N	\N	95039	95039	95040
20846	30754	1	applied	\N	\N	\N	\N	95043	95043	95044
20847	30755	0	applied	\N	\N	\N	\N	95046	95046	95047
20847	30756	1	applied	\N	\N	\N	\N	95048	95048	95049
20847	30754	2	applied	\N	\N	\N	\N	95043	95043	95050
20847	30757	3	applied	\N	\N	\N	\N	95051	95051	95052
20850	30763	0	applied	\N	\N	\N	\N	95071	95071	95072
20850	30764	2	applied	\N	\N	\N	\N	95074	95074	95075
20850	30765	3	applied	\N	\N	\N	\N	95076	95076	95077
20854	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20854	30771	1	applied	\N	\N	\N	\N	95095	95095	95096
20854	30772	2	applied	\N	\N	\N	\N	95097	95097	95098
20854	30773	3	applied	\N	\N	\N	\N	95099	95099	95100
20854	30774	4	applied	\N	\N	\N	\N	95101	95101	95102
20854	30775	5	applied	\N	\N	\N	\N	95103	95103	95104
20854	30776	6	applied	\N	\N	\N	\N	95105	95105	95106
20854	30777	7	applied	\N	\N	\N	\N	95107	95107	95108
20854	30778	8	applied	\N	\N	\N	\N	95109	95109	95110
20854	30779	9	applied	\N	\N	\N	\N	95111	95111	95112
20856	30780	0	applied	\N	\N	\N	\N	95116	95116	95117
20856	30781	1	applied	\N	\N	\N	\N	95118	95118	95119
20856	30782	2	applied	\N	\N	\N	\N	95120	95120	95121
20856	30783	3	applied	\N	\N	\N	\N	95122	95122	95123
20858	30784	0	applied	\N	\N	\N	\N	95129	95129	95130
20858	30785	1	applied	\N	\N	\N	\N	95131	95131	95132
20859	30786	0	applied	\N	\N	\N	\N	95133	95133	95134
20859	30787	1	applied	\N	\N	\N	\N	95135	95135	95136
20859	30788	2	applied	\N	\N	\N	\N	95137	95137	95138
20859	30789	3	applied	\N	\N	\N	\N	95139	95139	95140
20859	30790	4	applied	\N	\N	\N	\N	95141	95141	95142
20859	30791	5	applied	\N	\N	\N	\N	95143	95143	95144
20859	30792	6	applied	\N	\N	\N	\N	95145	95145	95146
20859	30793	7	applied	\N	\N	\N	\N	95147	95147	95148
20859	30794	8	applied	\N	\N	\N	\N	95149	95149	95150
20859	30795	9	applied	\N	\N	\N	\N	95151	95151	95152
20859	30796	10	applied	\N	\N	\N	\N	95153	95153	95154
20859	30797	11	applied	\N	\N	\N	\N	95155	95155	95156
20859	30798	12	applied	\N	\N	\N	\N	95157	95157	95158
20859	30799	13	applied	\N	\N	\N	\N	95159	95159	95160
20859	30800	14	applied	\N	\N	\N	\N	95161	95161	95162
20862	30807	0	applied	\N	\N	\N	\N	95180	95180	95181
20862	30808	1	applied	\N	\N	\N	\N	95182	95182	95183
20862	30809	2	applied	\N	\N	\N	\N	95184	95184	95185
20862	30810	3	applied	\N	\N	\N	\N	95186	95186	95187
20862	30811	4	applied	\N	\N	\N	\N	95188	95188	95189
20867	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20867	30780	1	applied	\N	\N	\N	\N	95116	95116	95117
20867	30786	2	applied	\N	\N	\N	\N	95133	95133	95134
20867	30787	3	applied	\N	\N	\N	\N	95135	95135	95136
20867	30807	4	applied	\N	\N	\N	\N	95180	95180	95181
20867	30737	5	applied	\N	\N	\N	\N	94985	94985	94986
20867	30744	6	applied	\N	\N	\N	\N	95012	95012	95013
20867	30745	7	applied	\N	\N	\N	\N	95014	95014	95015
20867	30748	8	applied	\N	\N	\N	\N	95023	95023	95024
20867	30758	9	applied	\N	\N	\N	\N	95061	95061	95058
20867	30712	10	applied	\N	\N	\N	\N	94876	94876	94877
20867	30714	11	applied	\N	\N	\N	\N	94882	94882	94883
20867	30716	12	applied	\N	\N	\N	\N	94893	94893	94894
20867	30719	13	applied	\N	\N	\N	\N	94900	94900	94901
20867	30723	14	applied	\N	\N	\N	\N	94940	94940	94941
20867	30725	15	applied	\N	\N	\N	\N	94945	94945	94946
20867	30728	16	applied	\N	\N	\N	\N	94954	94954	94955
20867	30730	17	applied	\N	\N	\N	\N	94962	94962	94963
20867	30732	18	applied	\N	\N	\N	\N	94968	94968	94969
20867	30734	19	applied	\N	\N	\N	\N	94973	94973	94974
20867	30738	20	applied	\N	\N	\N	\N	94987	94987	94988
20867	30741	21	applied	\N	\N	\N	\N	94996	94996	94997
20867	30743	22	applied	\N	\N	\N	\N	95010	95010	95011
20867	30749	23	applied	\N	\N	\N	\N	95025	95025	95026
20867	30751	24	applied	\N	\N	\N	\N	95034	95034	95035
20867	30753	25	applied	\N	\N	\N	\N	95039	95039	95040
20867	30755	26	applied	\N	\N	\N	\N	95046	95046	95047
20867	30759	27	applied	\N	\N	\N	\N	95062	95062	95063
20867	30760	28	applied	\N	\N	\N	\N	95064	95064	95065
20867	30763	29	applied	\N	\N	\N	\N	95071	95071	95072
20867	30766	30	applied	\N	\N	\N	\N	95083	95083	95084
20867	30767	31	applied	\N	\N	\N	\N	95085	95085	95086
20867	30805	32	applied	\N	\N	\N	\N	95175	95175	95175
20867	30771	33	applied	\N	\N	\N	\N	95095	95095	95096
20867	30772	34	applied	\N	\N	\N	\N	95097	95097	95098
20867	30773	35	applied	\N	\N	\N	\N	95099	95099	95100
20867	30774	36	applied	\N	\N	\N	\N	95101	95101	95102
20867	30781	37	applied	\N	\N	\N	\N	95118	95118	95119
20867	30784	38	applied	\N	\N	\N	\N	95129	95129	95130
20867	30788	39	applied	\N	\N	\N	\N	95137	95137	95138
20867	30789	40	applied	\N	\N	\N	\N	95139	95139	95140
20867	30790	41	applied	\N	\N	\N	\N	95141	95141	95142
20867	30791	42	applied	\N	\N	\N	\N	95143	95143	95144
20867	30801	43	applied	\N	\N	\N	\N	95165	95165	95166
20867	30804	44	applied	\N	\N	\N	\N	95173	95173	95174
20867	30808	45	applied	\N	\N	\N	\N	95182	95182	95183
20867	30809	46	applied	\N	\N	\N	\N	95184	95184	95185
20867	30812	47	applied	\N	\N	\N	\N	95194	95194	95195
20867	30813	48	applied	\N	\N	\N	\N	95196	95196	95197
20867	30817	49	applied	\N	\N	\N	\N	95206	95206	95207
20867	30739	50	applied	\N	\N	\N	\N	94989	94989	94989
20867	30717	51	applied	\N	\N	\N	\N	94895	94895	94873
20867	30711	52	applied	\N	\N	\N	\N	94872	94872	95213
20867	30793	53	applied	\N	\N	\N	\N	95147	95147	95148
20867	30794	54	applied	\N	\N	\N	\N	95149	95149	95150
20867	30713	55	applied	\N	\N	\N	\N	94878	94878	95214
20867	30715	56	applied	\N	\N	\N	\N	94884	94884	94896
20867	30795	57	applied	\N	\N	\N	\N	95151	95151	95152
20867	30796	58	applied	\N	\N	\N	\N	95153	95153	95154
20867	30727	59	applied	\N	\N	\N	\N	94951	94951	95215
20867	30736	60	applied	\N	\N	\N	\N	94977	94977	94898
20867	30747	61	applied	\N	\N	\N	\N	95018	95018	95216
20867	30756	62	applied	\N	\N	\N	\N	95048	95048	94903
20867	30764	63	applied	\N	\N	\N	\N	95074	95074	95217
20867	30775	64	applied	\N	\N	\N	\N	95103	95103	94943
20867	30782	65	applied	\N	\N	\N	\N	95120	95120	95218
20867	30792	66	applied	\N	\N	\N	\N	95145	95145	94948
20867	30803	67	applied	\N	\N	\N	\N	95169	95169	94952
20867	30718	68	applied	\N	\N	\N	\N	94897	94897	94958
20867	30720	69	applied	\N	\N	\N	\N	94902	94902	94965
20867	30724	70	applied	\N	\N	\N	\N	94942	94942	94971
20867	30726	71	applied	\N	\N	\N	\N	94947	94947	94976
20867	30729	72	applied	\N	\N	\N	\N	94956	94956	95219
20867	30816	73	applied	\N	\N	\N	\N	95202	95202	94993
20867	30731	74	applied	\N	\N	\N	\N	94964	94964	94999
20867	30733	75	applied	\N	\N	\N	\N	94970	94970	95017
20867	30735	76	applied	\N	\N	\N	\N	94975	94975	95220
20867	30740	77	applied	\N	\N	\N	\N	94992	94992	95221
20867	30742	78	applied	\N	\N	\N	\N	94998	94998	95049
20867	30746	79	applied	\N	\N	\N	\N	95016	95016	95050
20867	30750	80	applied	\N	\N	\N	\N	95027	95027	95052
20867	30752	81	applied	\N	\N	\N	\N	95036	95036	95067
20867	30754	82	applied	\N	\N	\N	\N	95043	95043	95069
20867	30757	83	applied	\N	\N	\N	\N	95051	95051	95222
20867	30761	84	applied	\N	\N	\N	\N	95066	95066	95223
20867	30762	85	applied	\N	\N	\N	\N	95068	95068	95224
20867	30765	86	applied	\N	\N	\N	\N	95076	95076	95104
20867	30768	88	applied	\N	\N	\N	\N	95087	95087	95106
20867	30769	89	applied	\N	\N	\N	\N	95089	95089	95108
20867	30776	90	applied	\N	\N	\N	\N	95105	95105	95110
20867	30777	91	applied	\N	\N	\N	\N	95107	95107	95112
20867	30778	92	applied	\N	\N	\N	\N	95109	95109	95226
20867	30779	93	applied	\N	\N	\N	\N	95111	95111	95227
20867	30783	94	applied	\N	\N	\N	\N	95122	95122	95146
20867	30785	95	applied	\N	\N	\N	\N	95131	95131	95156
20867	30797	96	applied	\N	\N	\N	\N	95155	95155	95158
20867	30798	97	applied	\N	\N	\N	\N	95157	95157	95160
20867	30799	98	applied	\N	\N	\N	\N	95159	95159	95162
20867	30800	99	applied	\N	\N	\N	\N	95161	95161	95168
20867	30802	100	applied	\N	\N	\N	\N	95167	95167	95228
20867	30806	101	applied	\N	\N	\N	\N	95176	95176	95229
20867	30810	102	applied	\N	\N	\N	\N	95186	95186	95230
20867	30811	103	applied	\N	\N	\N	\N	95188	95188	95231
20867	30814	104	applied	\N	\N	\N	\N	95198	95198	95232
20867	30815	105	applied	\N	\N	\N	\N	95200	95200	95203
20867	30818	106	applied	\N	\N	\N	\N	95208	95208	95209
20874	30828	0	applied	\N	\N	\N	\N	95262	95262	95263
20874	30829	1	applied	\N	\N	\N	\N	95264	95264	95265
20874	30830	2	applied	\N	\N	\N	\N	95266	95266	95267
20877	30770	0	applied	\N	\N	\N	\N	95093	95093	95094
20877	30780	1	applied	\N	\N	\N	\N	95116	95116	95117
20877	30786	2	applied	\N	\N	\N	\N	95133	95133	95134
20877	30787	3	applied	\N	\N	\N	\N	95135	95135	95136
20877	30807	4	applied	\N	\N	\N	\N	95180	95180	95181
20877	30737	5	applied	\N	\N	\N	\N	94985	94985	94986
20877	30744	6	applied	\N	\N	\N	\N	95012	95012	95013
20877	30745	7	applied	\N	\N	\N	\N	95014	95014	95015
20877	30748	8	applied	\N	\N	\N	\N	95023	95023	95024
20877	30758	9	applied	\N	\N	\N	\N	95061	95061	95058
20877	30734	10	applied	\N	\N	\N	\N	94973	94973	94974
20877	30738	11	applied	\N	\N	\N	\N	94987	94987	94988
20877	30741	12	applied	\N	\N	\N	\N	94996	94996	94997
20877	30743	13	applied	\N	\N	\N	\N	95010	95010	95011
20877	30749	14	applied	\N	\N	\N	\N	95025	95025	95026
20877	30751	15	applied	\N	\N	\N	\N	95034	95034	95035
20877	30753	16	applied	\N	\N	\N	\N	95039	95039	95040
20877	30755	17	applied	\N	\N	\N	\N	95046	95046	95047
20877	30759	18	applied	\N	\N	\N	\N	95062	95062	95063
20877	30760	19	applied	\N	\N	\N	\N	95064	95064	95065
20877	30763	20	applied	\N	\N	\N	\N	95071	95071	95072
20877	30766	21	applied	\N	\N	\N	\N	95083	95083	95084
20877	30767	22	applied	\N	\N	\N	\N	95085	95085	95086
20877	30805	23	applied	\N	\N	\N	\N	95175	95175	95175
20877	30771	24	applied	\N	\N	\N	\N	95095	95095	95096
20877	30772	25	applied	\N	\N	\N	\N	95097	95097	95098
20877	30773	26	applied	\N	\N	\N	\N	95099	95099	95100
20877	30774	27	applied	\N	\N	\N	\N	95101	95101	95102
20877	30781	28	applied	\N	\N	\N	\N	95118	95118	95119
20877	30784	29	applied	\N	\N	\N	\N	95129	95129	95130
20877	30788	30	applied	\N	\N	\N	\N	95137	95137	95138
20877	30789	31	applied	\N	\N	\N	\N	95139	95139	95140
20877	30790	32	applied	\N	\N	\N	\N	95141	95141	95142
20877	30791	33	applied	\N	\N	\N	\N	95143	95143	95144
20877	30801	34	applied	\N	\N	\N	\N	95165	95165	95166
20877	30804	35	applied	\N	\N	\N	\N	95173	95173	95174
20877	30808	36	applied	\N	\N	\N	\N	95182	95182	95183
20877	30809	37	applied	\N	\N	\N	\N	95184	95184	95185
20877	30812	38	applied	\N	\N	\N	\N	95194	95194	95195
20877	30813	39	applied	\N	\N	\N	\N	95196	95196	95197
20877	30817	40	applied	\N	\N	\N	\N	95206	95206	95207
20877	30819	41	applied	\N	\N	\N	\N	95235	95235	95236
20877	30822	42	applied	\N	\N	\N	\N	95247	95247	95248
20877	30823	43	applied	\N	\N	\N	\N	95249	95249	95250
20877	30826	44	applied	\N	\N	\N	\N	95256	95256	95257
20877	30828	45	applied	\N	\N	\N	\N	95262	95262	95263
20877	30831	46	applied	\N	\N	\N	\N	95270	95270	95271
20877	30832	47	applied	\N	\N	\N	\N	95272	95272	95273
20877	30739	49	applied	\N	\N	\N	\N	94989	94989	94989
20877	30735	50	applied	\N	\N	\N	\N	94975	94975	94976
20877	30740	51	applied	\N	\N	\N	\N	94992	94992	95219
20877	30736	52	applied	\N	\N	\N	\N	94977	94977	94993
20877	30747	53	applied	\N	\N	\N	\N	95018	95018	95281
20877	30756	54	applied	\N	\N	\N	\N	95048	95048	94999
20877	30764	55	applied	\N	\N	\N	\N	95074	95074	95282
20877	30775	56	applied	\N	\N	\N	\N	95103	95103	95017
20877	30782	57	applied	\N	\N	\N	\N	95120	95120	95019
20877	30792	58	applied	\N	\N	\N	\N	95145	95145	95220
20877	30793	59	applied	\N	\N	\N	\N	95147	95147	95148
20877	30794	60	applied	\N	\N	\N	\N	95149	95149	95150
20877	30795	61	applied	\N	\N	\N	\N	95151	95151	95152
20877	30796	62	applied	\N	\N	\N	\N	95153	95153	95154
20877	30803	63	applied	\N	\N	\N	\N	95169	95169	95028
20877	30742	64	applied	\N	\N	\N	\N	94998	94998	95037
20877	30746	65	applied	\N	\N	\N	\N	95016	95016	95044
20877	30816	66	applied	\N	\N	\N	\N	95202	95202	95050
20877	30820	67	applied	\N	\N	\N	\N	95237	95237	95283
20877	30829	68	applied	\N	\N	\N	\N	95264	95264	95052
20877	30750	69	applied	\N	\N	\N	\N	95027	95027	95067
20877	30752	70	applied	\N	\N	\N	\N	95036	95036	95069
20877	30754	71	applied	\N	\N	\N	\N	95043	95043	95222
20877	30757	72	applied	\N	\N	\N	\N	95051	95051	95223
20877	30761	73	applied	\N	\N	\N	\N	95066	95066	95224
20877	30762	74	applied	\N	\N	\N	\N	95068	95068	95104
20877	30765	75	applied	\N	\N	\N	\N	95076	95076	95106
20877	30768	76	applied	\N	\N	\N	\N	95087	95087	95108
20877	30769	77	applied	\N	\N	\N	\N	95089	95089	95110
20877	30776	78	applied	\N	\N	\N	\N	95105	95105	95112
20877	30777	79	applied	\N	\N	\N	\N	95107	95107	95226
20877	30778	80	applied	\N	\N	\N	\N	95109	95109	95227
20877	30779	81	applied	\N	\N	\N	\N	95111	95111	95146
20877	30783	82	applied	\N	\N	\N	\N	95122	95122	95156
20877	30785	83	applied	\N	\N	\N	\N	95131	95131	95158
20877	30797	84	applied	\N	\N	\N	\N	95155	95155	95160
20877	30798	85	applied	\N	\N	\N	\N	95157	95157	95162
20877	30799	86	applied	\N	\N	\N	\N	95159	95159	95168
20877	30800	87	applied	\N	\N	\N	\N	95161	95161	95228
20877	30802	88	applied	\N	\N	\N	\N	95167	95167	95229
20877	30806	89	applied	\N	\N	\N	\N	95176	95176	95230
20877	30810	90	applied	\N	\N	\N	\N	95186	95186	95231
20877	30811	91	applied	\N	\N	\N	\N	95188	95188	95232
20877	30814	92	applied	\N	\N	\N	\N	95198	95198	95203
20877	30815	93	applied	\N	\N	\N	\N	95200	95200	95209
20877	30818	94	applied	\N	\N	\N	\N	95208	95208	95284
20877	30821	95	applied	\N	\N	\N	\N	95239	95239	95285
20877	30824	96	applied	\N	\N	\N	\N	95251	95251	95286
20877	30825	97	applied	\N	\N	\N	\N	95253	95253	95287
20877	30827	98	applied	\N	\N	\N	\N	95258	95258	95265
20877	30830	99	applied	\N	\N	\N	\N	95266	95266	95267
20877	30833	100	applied	\N	\N	\N	\N	95274	95274	95275
20877	30834	101	applied	\N	\N	\N	\N	95276	95276	95277
20879	30838	0	applied	\N	\N	\N	\N	95298	95298	95299
20879	30839	1	applied	\N	\N	\N	\N	95300	95300	95301
20881	30840	0	applied	\N	\N	\N	\N	95323	95323	95324
20884	30841	0	applied	\N	\N	\N	\N	95327	95327	95328
20884	30842	1	applied	\N	\N	\N	\N	95329	95329	93688
20884	30843	2	applied	\N	\N	\N	\N	95330	95330	95331
20884	30844	3	applied	\N	\N	\N	\N	95332	95332	95333
20888	30847	0	applied	\N	\N	\N	\N	95346	95346	95347
20888	30848	1	applied	\N	\N	\N	\N	95348	95348	95349
20892	30849	0	applied	\N	\N	\N	\N	95356	95356	95357
20892	30850	1	applied	\N	\N	\N	\N	95358	95358	95359
20897	30858	0	applied	\N	\N	\N	\N	95382	95382	95383
20897	30859	1	applied	\N	\N	\N	\N	95384	95384	95385
20897	30860	2	applied	\N	\N	\N	\N	95386	95386	95387
20900	30861	0	applied	\N	\N	\N	\N	95391	95391	95392
20900	30862	1	applied	\N	\N	\N	\N	95393	95393	95394
20909	30872	0	applied	\N	\N	\N	\N	95426	95426	95427
20909	30873	1	applied	\N	\N	\N	\N	95428	95428	95429
20909	30874	2	applied	\N	\N	\N	\N	95430	95430	95431
20909	30875	3	applied	\N	\N	\N	\N	95432	95432	95433
20909	30876	4	applied	\N	\N	\N	\N	95434	95434	95435
20909	30877	5	applied	\N	\N	\N	\N	95436	95436	95437
20909	30878	6	applied	\N	\N	\N	\N	95438	95438	95439
20910	30879	0	applied	\N	\N	\N	\N	95442	95442	95443
20910	30880	1	applied	\N	\N	\N	\N	95444	95444	95445
20910	30881	2	applied	\N	\N	\N	\N	95446	95446	95447
20910	30882	3	applied	\N	\N	\N	\N	95448	95448	95449
20910	30883	4	applied	\N	\N	\N	\N	95450	95450	95451
20910	30884	5	applied	\N	\N	\N	\N	95452	95452	95453
20910	30885	6	applied	\N	\N	\N	\N	95454	95454	95455
20922	30903	0	applied	\N	\N	\N	\N	95510	95510	95511
20922	30904	1	applied	\N	\N	\N	\N	95512	95512	95513
20924	30908	0	applied	\N	\N	\N	\N	95524	95524	95525
20924	30909	1	applied	\N	\N	\N	\N	95526	95526	95527
20924	30910	2	applied	\N	\N	\N	\N	95528	95528	95529
20924	30911	3	applied	\N	\N	\N	\N	95530	95530	95531
20924	30912	4	applied	\N	\N	\N	\N	95532	95532	95533
20927	30916	0	applied	\N	\N	\N	\N	95542	95542	95543
20927	30917	1	applied	\N	\N	\N	\N	95544	95544	95545
20929	30921	0	applied	\N	\N	\N	\N	95554	95554	95555
20929	30922	1	applied	\N	\N	\N	\N	95556	95556	95557
20930	30923	0	applied	\N	\N	\N	\N	95559	95559	95560
20930	30924	1	applied	\N	\N	\N	\N	95561	95561	95562
20930	30925	2	applied	\N	\N	\N	\N	95563	95563	95564
20930	30926	3	applied	\N	\N	\N	\N	95565	95565	47675
20930	30927	4	applied	\N	\N	\N	\N	95566	95566	95567
20930	30928	5	applied	\N	\N	\N	\N	95568	95568	95569
20930	30929	7	applied	\N	\N	\N	\N	95571	95571	95572
20930	30930	8	applied	\N	\N	\N	\N	95573	95573	95574
20932	30931	0	applied	\N	\N	\N	\N	95577	95577	95578
20932	30932	1	applied	\N	\N	\N	\N	95579	95579	95580
20935	30933	0	applied	\N	\N	\N	\N	95583	95583	95584
20935	30934	1	applied	\N	\N	\N	\N	95585	95585	95586
20935	30935	2	applied	\N	\N	\N	\N	95587	95587	95588
20935	30936	3	applied	\N	\N	\N	\N	95589	95589	95590
20935	30937	4	applied	\N	\N	\N	\N	95591	95591	95592
20935	30938	5	applied	\N	\N	\N	\N	95593	95593	95594
20935	30939	6	applied	\N	\N	\N	\N	95595	95595	95596
20935	30940	7	applied	\N	\N	\N	\N	95597	95597	95598
20880	30775	45	applied	\N	\N	\N	\N	95103	95103	95050
20880	30782	46	applied	\N	\N	\N	\N	95120	95120	95283
20880	30792	47	applied	\N	\N	\N	\N	95145	95145	95052
20880	30793	48	applied	\N	\N	\N	\N	95147	95147	95148
20880	30794	49	applied	\N	\N	\N	\N	95149	95149	95150
20880	30795	50	applied	\N	\N	\N	\N	95151	95151	95152
20880	30796	51	applied	\N	\N	\N	\N	95153	95153	95154
20880	30803	52	applied	\N	\N	\N	\N	95169	95169	95305
20880	30754	53	applied	\N	\N	\N	\N	95043	95043	95306
20880	30757	54	applied	\N	\N	\N	\N	95051	95051	95075
20880	30761	55	applied	\N	\N	\N	\N	95066	95066	95077
20880	30762	56	applied	\N	\N	\N	\N	95068	95068	95088
20880	30765	57	applied	\N	\N	\N	\N	95076	95076	95090
20880	30816	58	applied	\N	\N	\N	\N	95202	95202	95104
20880	30820	59	applied	\N	\N	\N	\N	95237	95237	95307
20880	30829	60	applied	\N	\N	\N	\N	95264	95264	95106
20880	30837	61	applied	\N	\N	\N	\N	95294	95294	95308
20880	30768	62	applied	\N	\N	\N	\N	95087	95087	95309
20880	30769	63	applied	\N	\N	\N	\N	95089	95089	95310
20880	30776	64	applied	\N	\N	\N	\N	95105	95105	95121
20880	30777	65	applied	\N	\N	\N	\N	95107	95107	95123
20880	30778	66	applied	\N	\N	\N	\N	95109	95109	95132
20880	30779	67	applied	\N	\N	\N	\N	95111	95111	95311
20880	30783	68	applied	\N	\N	\N	\N	95122	95122	95312
20880	30785	69	applied	\N	\N	\N	\N	95131	95131	95313
20880	30797	70	applied	\N	\N	\N	\N	95155	95155	95314
20880	30798	71	applied	\N	\N	\N	\N	95157	95157	95315
20880	30799	72	applied	\N	\N	\N	\N	95159	95159	95170
20880	30800	73	applied	\N	\N	\N	\N	95161	95161	95177
20880	30802	74	applied	\N	\N	\N	\N	95167	95167	95187
20880	30806	75	applied	\N	\N	\N	\N	95176	95176	95189
20880	30810	76	applied	\N	\N	\N	\N	95186	95186	95199
20880	30811	77	applied	\N	\N	\N	\N	95188	95188	95201
20880	30814	78	applied	\N	\N	\N	\N	95198	95198	95316
20880	30815	79	applied	\N	\N	\N	\N	95200	95200	95238
20880	30818	80	applied	\N	\N	\N	\N	95208	95208	95240
20880	30821	81	applied	\N	\N	\N	\N	95239	95239	95252
20880	30824	82	applied	\N	\N	\N	\N	95251	95251	95254
20880	30825	83	applied	\N	\N	\N	\N	95253	95253	95259
20880	30827	84	applied	\N	\N	\N	\N	95258	95258	95317
20880	30830	85	applied	\N	\N	\N	\N	95266	95266	95318
20880	30833	86	applied	\N	\N	\N	\N	95274	95274	95319
20880	30834	87	applied	\N	\N	\N	\N	95276	95276	95320
20880	30836	88	applied	\N	\N	\N	\N	95292	95292	95295
20880	30839	89	applied	\N	\N	\N	\N	95300	95300	95301
20882	30841	0	applied	\N	\N	\N	\N	95327	95327	95328
20882	30842	1	applied	\N	\N	\N	\N	95329	95329	93688
20882	30843	2	applied	\N	\N	\N	\N	95330	95330	95331
20882	30844	3	applied	\N	\N	\N	\N	95332	95332	95333
20886	30845	0	applied	\N	\N	\N	\N	95339	95339	95340
20886	30846	1	applied	\N	\N	\N	\N	95341	95341	95342
20889	30847	0	applied	\N	\N	\N	\N	95346	95346	95347
20889	30848	1	applied	\N	\N	\N	\N	95348	95348	95349
20891	30847	0	applied	\N	\N	\N	\N	95346	95346	95347
20891	30848	1	applied	\N	\N	\N	\N	95348	95348	95349
20893	30851	0	applied	\N	\N	\N	\N	95361	95361	95362
20893	30852	1	applied	\N	\N	\N	\N	95363	95363	95364
20893	30853	2	applied	\N	\N	\N	\N	95365	95365	95366
20895	30854	0	applied	\N	\N	\N	\N	95371	95371	95372
20895	30855	1	applied	\N	\N	\N	\N	95373	95373	95374
20898	30858	0	applied	\N	\N	\N	\N	95382	95382	95383
20898	30859	1	applied	\N	\N	\N	\N	95384	95384	95385
20898	30860	2	applied	\N	\N	\N	\N	95386	95386	95387
20901	30861	0	applied	\N	\N	\N	\N	95391	95391	95392
20901	30862	1	applied	\N	\N	\N	\N	95393	95393	95394
20904	30863	0	applied	\N	\N	\N	\N	95401	95401	95402
20904	30864	1	applied	\N	\N	\N	\N	95403	95403	95404
20907	30865	0	applied	\N	\N	\N	\N	95406	95406	95407
20907	30866	1	applied	\N	\N	\N	\N	95408	95408	95409
20907	30867	2	applied	\N	\N	\N	\N	95410	95410	95411
20907	30868	3	applied	\N	\N	\N	\N	95412	95412	95413
20907	30869	4	applied	\N	\N	\N	\N	95414	95414	95415
20913	30888	0	applied	\N	\N	1000000000	\N	95470	95470	95471
20913	30889	1	applied	\N	\N	\N	\N	95472	95472	95473
20913	30890	2	applied	\N	\N	\N	\N	95474	95474	95475
20913	30891	3	applied	\N	\N	\N	\N	95476	95476	95477
20920	30899	0	applied	\N	\N	\N	\N	95500	95500	95501
20920	30900	1	applied	\N	\N	\N	\N	95502	95502	95503
20920	30901	2	applied	\N	\N	\N	\N	95504	95504	95505
20920	30902	3	applied	\N	\N	\N	\N	95506	95506	95507
20925	30913	0	applied	\N	\N	\N	\N	95535	95535	95536
20925	30914	1	applied	\N	\N	\N	\N	95537	95537	95538
20925	30915	2	applied	\N	\N	\N	\N	95539	95539	95540
20931	30923	0	applied	\N	\N	\N	\N	95559	95559	95560
20931	30924	1	applied	\N	\N	\N	\N	95561	95561	95562
20931	30925	2	applied	\N	\N	\N	\N	95563	95563	95564
20931	30926	3	applied	\N	\N	\N	\N	95565	95565	47675
20931	30927	4	applied	\N	\N	\N	\N	95566	95566	95567
20931	30928	5	applied	\N	\N	\N	\N	95568	95568	95569
20931	30929	7	applied	\N	\N	\N	\N	95571	95571	95572
20931	30930	8	applied	\N	\N	\N	\N	95573	95573	95574
20933	30931	0	applied	\N	\N	\N	\N	95577	95577	95578
20933	30932	1	applied	\N	\N	\N	\N	95579	95579	95580
20936	30933	0	applied	\N	\N	\N	\N	95583	95583	95584
20936	30934	1	applied	\N	\N	\N	\N	95585	95585	95586
20936	30935	2	applied	\N	\N	\N	\N	95587	95587	95588
20936	30936	3	applied	\N	\N	\N	\N	95589	95589	95590
20936	30937	4	applied	\N	\N	\N	\N	95591	95591	95592
20936	30938	5	applied	\N	\N	\N	\N	95593	95593	95594
20936	30939	6	applied	\N	\N	\N	\N	95595	95595	95596
20936	30940	7	applied	\N	\N	\N	\N	95597	95597	95598
20936	30941	8	applied	\N	\N	\N	\N	95599	95599	95600
20940	30951	0	applied	\N	\N	\N	\N	95628	95628	47675
20940	30952	1	applied	\N	\N	1000000000	\N	95629	95629	95630
20940	30953	2	applied	\N	\N	\N	\N	95631	95631	95632
20940	30954	3	applied	\N	\N	\N	\N	95633	95633	95634
20943	30962	0	applied	\N	\N	\N	\N	95653	95653	95654
20943	30963	1	applied	\N	\N	\N	\N	5821	5821	95655
20943	30964	2	applied	\N	\N	\N	\N	95656	95656	95657
20943	30965	3	applied	\N	\N	\N	\N	95658	95658	95659
20943	30966	4	applied	\N	\N	\N	\N	95660	95660	95661
20947	30971	0	applied	\N	\N	\N	\N	95674	95674	95675
20947	30972	1	applied	\N	\N	\N	\N	95676	95676	95677
20947	30973	2	applied	\N	\N	\N	\N	95678	95678	95679
20947	30974	3	applied	\N	\N	\N	\N	95680	95680	95681
20947	30975	4	applied	\N	\N	\N	\N	95682	95682	95683
20947	30976	5	applied	\N	\N	\N	\N	95684	95684	95685
20947	30977	6	applied	\N	\N	\N	\N	95686	95686	95687
20951	30983	0	applied	\N	\N	\N	\N	95708	95708	95709
20912	30744	7	applied	\N	\N	\N	\N	95012	95012	95013
20912	30745	8	applied	\N	\N	\N	\N	95014	95014	95015
20912	30748	9	applied	\N	\N	\N	\N	95023	95023	95024
20912	30758	10	applied	\N	\N	\N	\N	95061	95061	95058
20912	30730	11	applied	\N	\N	\N	\N	94962	94962	94963
20912	30732	12	applied	\N	\N	\N	\N	94968	94968	94969
20912	30734	13	applied	\N	\N	\N	\N	94973	94973	94974
20912	30738	14	applied	\N	\N	\N	\N	94987	94987	94988
20912	30741	15	applied	\N	\N	\N	\N	94996	94996	94997
20912	30743	16	applied	\N	\N	\N	\N	95010	95010	95011
20912	30749	17	applied	\N	\N	\N	\N	95025	95025	95026
20912	30751	18	applied	\N	\N	\N	\N	95034	95034	95035
20912	30753	19	applied	\N	\N	\N	\N	95039	95039	95040
20912	30755	20	applied	\N	\N	\N	\N	95046	95046	95047
20912	30759	21	applied	\N	\N	\N	\N	95062	95062	95063
20912	30760	22	applied	\N	\N	\N	\N	95064	95064	95065
20912	30763	23	applied	\N	\N	\N	\N	95071	95071	95072
20912	30766	24	applied	\N	\N	\N	\N	95083	95083	95084
20912	30767	25	applied	\N	\N	\N	\N	95085	95085	95086
20912	30842	26	applied	\N	\N	\N	\N	95329	95329	93688
20912	30805	27	applied	\N	\N	\N	\N	95175	95175	95175
20912	30771	28	applied	\N	\N	\N	\N	95095	95095	95096
20912	30772	29	applied	\N	\N	\N	\N	95097	95097	95098
20912	30773	30	applied	\N	\N	\N	\N	95099	95099	95100
20912	30774	31	applied	\N	\N	\N	\N	95101	95101	95102
20912	30781	32	applied	\N	\N	\N	\N	95118	95118	95119
20912	30784	33	applied	\N	\N	\N	\N	95129	95129	95130
20912	30788	34	applied	\N	\N	\N	\N	95137	95137	95138
20912	30789	35	applied	\N	\N	\N	\N	95139	95139	95140
20912	30790	36	applied	\N	\N	\N	\N	95141	95141	95142
20912	30791	37	applied	\N	\N	\N	\N	95143	95143	95144
20912	30801	38	applied	\N	\N	\N	\N	95165	95165	95166
20912	30804	39	applied	\N	\N	\N	\N	95173	95173	95174
20912	30808	40	applied	\N	\N	\N	\N	95182	95182	95183
20912	30809	41	applied	\N	\N	\N	\N	95184	95184	95185
20912	30812	42	applied	\N	\N	\N	\N	95194	95194	95195
20912	30813	43	applied	\N	\N	\N	\N	95196	95196	95197
20912	30817	44	applied	\N	\N	\N	\N	95206	95206	95207
20912	30819	45	applied	\N	\N	\N	\N	95235	95235	95236
20912	30822	46	applied	\N	\N	\N	\N	95247	95247	95248
20912	30823	47	applied	\N	\N	\N	\N	95249	95249	95250
20912	30826	48	applied	\N	\N	\N	\N	95256	95256	95257
20912	30828	49	applied	\N	\N	\N	\N	95262	95262	95263
20912	30831	50	applied	\N	\N	\N	\N	95270	95270	95271
20912	30832	51	applied	\N	\N	\N	\N	95272	95272	95273
20912	30835	52	applied	\N	\N	\N	\N	95290	95290	95291
20912	30838	53	applied	\N	\N	\N	\N	95298	95298	95299
20912	30840	54	applied	\N	\N	\N	\N	95323	95323	95324
20912	30841	55	applied	\N	\N	\N	\N	95327	95327	95328
20912	30845	56	applied	\N	\N	\N	\N	95339	95339	95340
20912	30847	57	applied	\N	\N	\N	\N	95346	95346	95347
20912	30849	58	applied	\N	\N	\N	\N	95356	95356	95357
20912	30851	59	applied	\N	\N	\N	\N	95361	95361	95362
20912	30854	60	applied	\N	\N	\N	\N	95371	95371	95372
20912	30856	62	applied	\N	\N	\N	\N	95377	95377	95378
20912	30858	63	applied	\N	\N	\N	\N	95382	95382	95383
20912	30861	64	applied	\N	\N	\N	\N	95391	95391	95392
20912	30863	65	applied	\N	\N	\N	\N	95401	95401	95402
20912	30865	66	applied	\N	\N	\N	\N	95406	95406	95407
20912	30866	67	applied	\N	\N	\N	\N	95408	95408	95409
20912	30870	68	applied	\N	\N	\N	\N	95420	95420	95421
20912	30872	69	applied	\N	\N	\N	\N	95426	95426	95427
20912	30873	70	applied	\N	\N	\N	\N	95428	95428	95429
20912	30874	71	applied	\N	\N	\N	\N	95430	95430	95431
20912	30879	72	applied	\N	\N	\N	\N	95442	95442	95443
20912	30880	73	applied	\N	\N	\N	\N	95444	95444	95445
20912	30881	74	applied	\N	\N	\N	\N	95446	95446	95447
20912	30886	75	applied	\N	\N	\N	\N	95458	95458	95459
20912	30739	76	applied	\N	\N	\N	\N	94989	94989	94989
20912	30793	77	applied	\N	\N	\N	\N	95147	95147	95148
20912	30794	78	applied	\N	\N	\N	\N	95149	95149	95150
20912	30729	79	applied	\N	\N	\N	\N	94956	94956	94957
20912	30795	80	applied	\N	\N	\N	\N	95151	95151	95152
20912	30796	81	applied	\N	\N	\N	\N	95153	95153	95154
20912	30727	82	applied	\N	\N	\N	\N	94951	94951	94958
20912	30736	83	applied	\N	\N	\N	\N	94977	94977	95465
20912	30747	84	applied	\N	\N	\N	\N	95018	95018	94965
20912	30756	85	applied	\N	\N	\N	\N	95048	95048	95466
20912	30764	86	applied	\N	\N	\N	\N	95074	95074	94971
20912	30775	87	applied	\N	\N	\N	\N	95103	95103	95467
20912	30782	88	applied	\N	\N	\N	\N	95120	95120	94976
20912	30792	89	applied	\N	\N	\N	\N	95145	95145	94978
20912	30803	90	applied	\N	\N	\N	\N	95169	95169	95219
20912	30816	91	applied	\N	\N	\N	\N	95202	95202	94993
20912	30820	92	applied	\N	\N	\N	\N	95237	95237	95281
20912	30829	93	applied	\N	\N	\N	\N	95264	95264	94999
20912	30837	94	applied	\N	\N	\N	\N	95294	95294	95282
20912	30844	95	applied	\N	\N	\N	\N	95332	95332	95017
20912	30853	96	applied	\N	\N	\N	\N	95365	95365	95019
20912	30860	97	applied	\N	\N	\N	\N	95386	95386	95220
20912	30868	98	applied	\N	\N	\N	\N	95412	95412	95028
20912	30876	99	applied	\N	\N	\N	\N	95434	95434	95221
20912	30883	100	applied	\N	\N	\N	\N	95450	95450	95037
20912	30731	101	applied	\N	\N	\N	\N	94964	94964	95044
20912	30733	102	applied	\N	\N	\N	\N	94970	94970	95283
20912	30735	103	applied	\N	\N	\N	\N	94975	94975	95305
20912	30740	104	applied	\N	\N	\N	\N	94992	94992	95306
20912	30742	105	applied	\N	\N	\N	\N	94998	94998	95075
20912	30746	106	applied	\N	\N	\N	\N	95016	95016	95077
20912	30750	107	applied	\N	\N	\N	\N	95027	95027	95088
20912	30752	108	applied	\N	\N	\N	\N	95036	95036	95090
20912	30754	109	applied	\N	\N	\N	\N	95043	95043	95307
20912	30757	110	applied	\N	\N	\N	\N	95051	95051	95308
20912	30761	111	applied	\N	\N	\N	\N	95066	95066	95309
20912	30762	112	applied	\N	\N	\N	\N	95068	95068	95310
20912	30765	113	applied	\N	\N	\N	\N	95076	95076	95121
20912	30768	114	applied	\N	\N	\N	\N	95087	95087	95123
20912	30769	115	applied	\N	\N	\N	\N	95089	95089	95132
20912	30776	116	applied	\N	\N	\N	\N	95105	95105	95311
20912	30777	117	applied	\N	\N	\N	\N	95107	95107	95312
20912	30778	118	applied	\N	\N	\N	\N	95109	95109	95313
20912	30779	119	applied	\N	\N	\N	\N	95111	95111	95314
20912	30783	120	applied	\N	\N	\N	\N	95122	95122	95315
20912	30785	121	applied	\N	\N	\N	\N	95131	95131	95170
20912	30797	122	applied	\N	\N	\N	\N	95155	95155	95177
20912	30798	123	applied	\N	\N	\N	\N	95157	95157	95187
20912	30799	124	applied	\N	\N	\N	\N	95159	95159	95189
20912	30800	125	applied	\N	\N	\N	\N	95161	95161	95199
20915	30888	0	applied	\N	\N	1000000000	\N	95470	95470	95471
20915	30889	1	applied	\N	\N	\N	\N	95472	95472	95473
20915	30890	2	applied	\N	\N	\N	\N	95474	95474	95475
20915	30891	3	applied	\N	\N	\N	\N	95476	95476	95477
20917	30892	0	applied	\N	\N	\N	\N	95481	95481	95482
20917	30893	1	applied	\N	\N	\N	\N	95483	95483	95484
20917	30894	2	applied	\N	\N	\N	\N	95485	95485	95486
20917	30895	3	applied	\N	\N	\N	\N	95487	95487	95488
20917	30896	4	applied	\N	\N	\N	\N	95489	95489	95490
20919	30897	0	applied	\N	\N	\N	\N	95495	95495	95496
20919	30898	1	applied	\N	\N	\N	\N	95497	95497	95498
20921	30903	0	applied	\N	\N	\N	\N	95510	95510	95511
20921	30904	1	applied	\N	\N	\N	\N	95512	95512	95513
20926	30916	0	applied	\N	\N	\N	\N	95542	95542	95543
20926	30917	1	applied	\N	\N	\N	\N	95544	95544	95545
20934	30933	0	applied	\N	\N	\N	\N	95583	95583	95584
20934	30934	1	applied	\N	\N	\N	\N	95585	95585	95586
20934	30935	2	applied	\N	\N	\N	\N	95587	95587	95588
20934	30936	3	applied	\N	\N	\N	\N	95589	95589	95590
20934	30937	4	applied	\N	\N	\N	\N	95591	95591	95592
20934	30938	5	applied	\N	\N	\N	\N	95593	95593	95594
20934	30939	6	applied	\N	\N	\N	\N	95595	95595	95596
20934	30940	7	applied	\N	\N	\N	\N	95597	95597	95598
20934	30941	8	applied	\N	\N	\N	\N	95599	95599	95600
20939	30945	0	applied	\N	\N	\N	\N	95615	95615	95616
20939	30946	1	applied	\N	\N	\N	\N	95617	95617	95618
20939	30947	2	applied	\N	\N	\N	\N	95619	95619	95620
20939	30948	3	applied	\N	\N	\N	\N	95621	95621	95622
20939	30949	4	applied	\N	\N	\N	\N	95623	95623	95624
20939	30950	5	applied	\N	\N	\N	\N	95625	95625	95626
20945	30971	0	applied	\N	\N	\N	\N	95674	95674	95675
20945	30972	1	applied	\N	\N	\N	\N	95676	95676	95677
20945	30973	2	applied	\N	\N	\N	\N	95678	95678	95679
20945	30974	3	applied	\N	\N	\N	\N	95680	95680	95681
20945	30975	4	applied	\N	\N	\N	\N	95682	95682	95683
20945	30976	5	applied	\N	\N	\N	\N	95684	95684	95685
20945	30977	6	applied	\N	\N	\N	\N	95686	95686	95687
20950	30981	0	applied	\N	\N	\N	\N	95701	95701	95702
20950	30982	1	applied	\N	\N	\N	\N	95703	95703	95704
20952	30985	0	applied	\N	\N	\N	\N	95714	95714	95715
20952	30986	1	applied	\N	\N	\N	\N	95716	95716	95717
20960	30999	0	applied	\N	\N	\N	\N	95753	95753	95754
20960	31000	1	applied	\N	\N	\N	\N	95755	95755	95756
20960	31001	2	applied	\N	\N	\N	\N	95757	95757	95758
20962	31002	0	applied	\N	\N	\N	\N	95765	95765	95766
20962	31003	1	applied	\N	\N	\N	\N	95767	95767	95768
20962	31004	2	applied	\N	\N	\N	\N	95769	95769	95770
20962	31005	3	applied	\N	\N	\N	\N	95771	95771	95772
20965	31009	0	applied	\N	\N	\N	\N	95784	95784	95785
20965	31010	1	applied	\N	\N	\N	\N	95786	95786	95787
20965	31011	2	applied	\N	\N	\N	\N	95788	95788	95789
20965	31012	3	applied	\N	\N	\N	\N	95790	95790	95791
20965	31013	4	applied	\N	\N	\N	\N	95792	95792	95793
20968	31014	0	applied	\N	\N	\N	\N	95796	95796	95797
20968	31015	1	applied	\N	\N	\N	\N	95798	95798	95799
20979	31032	0	applied	\N	\N	\N	\N	95861	95861	95862
20979	31033	1	applied	\N	\N	\N	\N	95863	95863	95864
20985	31038	0	applied	\N	\N	\N	\N	95878	95878	95879
20985	31039	1	applied	\N	\N	\N	\N	95880	95880	95881
20985	31040	2	applied	\N	\N	\N	\N	95882	95882	95883
20988	31041	0	applied	\N	\N	\N	\N	95884	95884	95885
20988	31042	1	applied	\N	\N	\N	\N	95886	95886	95887
20990	31043	0	applied	\N	\N	\N	\N	95892	95892	95893
20990	31044	1	applied	\N	\N	\N	\N	95894	95894	95895
20995	31048	0	applied	\N	\N	\N	\N	95906	95906	95907
20995	31049	1	applied	\N	\N	\N	\N	95908	95908	95909
20995	31050	2	applied	\N	\N	\N	\N	95912	95912	95913
20995	31051	3	applied	\N	\N	\N	\N	95914	95914	95915
20997	31052	0	applied	\N	\N	\N	\N	95918	95918	95919
20997	31053	1	applied	\N	\N	\N	\N	95920	95920	95921
20997	31054	2	applied	\N	\N	\N	\N	95922	95922	95923
20997	31055	3	applied	\N	\N	\N	\N	95924	95924	95925
20997	31056	4	applied	\N	\N	\N	\N	95926	95926	95927
20997	31057	5	applied	\N	\N	\N	\N	95928	95928	95929
20997	31058	6	applied	\N	\N	\N	\N	95930	95930	95931
20997	31059	7	applied	\N	\N	\N	\N	95932	95932	95933
20997	31060	8	applied	\N	\N	\N	\N	95934	95934	95935
20997	31061	9	applied	\N	\N	\N	\N	95936	95936	95937
20997	31062	10	applied	\N	\N	\N	\N	95938	95938	95939
20997	31063	11	applied	\N	\N	\N	\N	95940	95940	95941
20997	31064	12	applied	\N	\N	\N	\N	95942	95942	95943
21000	30942	0	applied	\N	\N	1000000000	\N	95607	95607	95608
21000	30933	1	applied	\N	\N	\N	\N	95583	95583	95584
21000	30934	2	applied	\N	\N	\N	\N	95585	95585	95586
21000	30952	3	applied	\N	\N	1000000000	\N	95629	95629	95630
21000	30999	4	applied	\N	\N	\N	\N	95779	95779	95754
21000	30935	5	applied	\N	\N	\N	\N	95587	95587	95588
21000	30936	6	applied	\N	\N	\N	\N	95589	95589	95590
21000	31008	7	applied	\N	\N	\N	\N	95780	95780	95781
21000	30905	8	applied	\N	\N	\N	\N	95516	95516	95517
21000	30906	9	applied	\N	\N	\N	\N	95518	95518	95519
21000	30908	10	applied	\N	\N	\N	\N	95524	95524	95525
21000	30909	11	applied	\N	\N	\N	\N	95526	95526	95527
21000	30914	12	applied	\N	\N	\N	\N	95537	95537	95538
21000	30926	13	applied	\N	\N	\N	\N	95565	95565	47675
21000	30946	14	applied	\N	\N	\N	\N	95617	95617	95618
21000	31052	15	applied	\N	\N	\N	\N	95918	95918	95919
21000	31053	16	applied	\N	\N	\N	\N	95920	95920	95921
21000	31054	17	applied	\N	\N	\N	\N	95922	95922	95923
21000	31055	18	applied	\N	\N	\N	\N	95924	95924	95925
21000	30910	19	applied	\N	\N	\N	\N	95528	95528	95529
21000	30913	20	applied	\N	\N	\N	\N	95535	95535	95536
21000	30916	21	applied	\N	\N	\N	\N	95542	95542	95543
21000	30918	22	applied	\N	\N	\N	\N	95546	95546	95547
21000	30921	23	applied	\N	\N	\N	\N	95554	95554	95555
21000	30923	24	applied	\N	\N	\N	\N	95559	95559	95560
21000	30924	25	applied	\N	\N	\N	\N	95561	95561	95562
21000	30925	26	applied	\N	\N	\N	\N	95563	95563	95564
21000	30931	27	applied	\N	\N	\N	\N	95577	95577	95578
21000	30937	28	applied	\N	\N	\N	\N	95591	95591	95592
21000	30938	29	applied	\N	\N	\N	\N	95593	95593	95594
21000	30943	30	applied	\N	\N	\N	\N	95609	95609	95610
21000	30945	31	applied	\N	\N	\N	\N	95615	95615	95616
21000	30947	32	applied	\N	\N	\N	\N	95619	95619	95620
21000	30953	33	applied	\N	\N	\N	\N	95631	95631	95632
21000	30955	34	applied	\N	\N	\N	\N	95636	95636	95637
21000	30959	35	applied	\N	\N	\N	\N	95646	95646	95647
21000	30964	37	applied	\N	\N	\N	\N	95656	95656	95657
21000	30967	38	applied	\N	\N	\N	\N	95664	95664	95665
21000	30968	39	applied	\N	\N	\N	\N	95666	95666	95667
21000	30971	40	applied	\N	\N	\N	\N	95674	95674	95675
20935	30941	8	applied	\N	\N	\N	\N	95599	95599	95600
20942	30957	0	applied	\N	\N	\N	\N	95642	95642	95643
20942	30958	1	applied	\N	\N	\N	\N	95644	95644	95645
20942	30959	2	applied	\N	\N	\N	\N	95646	95646	95647
20942	30960	3	applied	\N	\N	\N	\N	95648	95648	95649
20942	30961	4	applied	\N	\N	\N	\N	95650	95650	95651
20946	30971	0	applied	\N	\N	\N	\N	95674	95674	95675
20946	30972	1	applied	\N	\N	\N	\N	95676	95676	95677
20946	30973	2	applied	\N	\N	\N	\N	95678	95678	95679
20946	30974	3	applied	\N	\N	\N	\N	95680	95680	95681
20946	30975	4	applied	\N	\N	\N	\N	95682	95682	95683
20946	30976	5	applied	\N	\N	\N	\N	95684	95684	95685
20946	30977	6	applied	\N	\N	\N	\N	95686	95686	95687
20948	30978	0	applied	\N	\N	\N	\N	95694	95694	95695
20948	30979	1	applied	\N	\N	\N	\N	95696	95696	95697
20948	30980	2	applied	\N	\N	\N	\N	95698	95698	95699
20953	30985	0	applied	\N	\N	\N	\N	95714	95714	95715
20953	30986	1	applied	\N	\N	\N	\N	95716	95716	95717
20955	30990	0	applied	\N	\N	\N	\N	95729	95729	95730
20955	30991	1	applied	\N	\N	\N	\N	95731	95731	95732
20958	30999	0	applied	\N	\N	\N	\N	95753	95753	95754
20958	31000	1	applied	\N	\N	\N	\N	95755	95755	95756
20958	31001	2	applied	\N	\N	\N	\N	95757	95757	95758
20961	30999	0	applied	\N	\N	\N	\N	95753	95753	95754
20961	31000	1	applied	\N	\N	\N	\N	95755	95755	95756
20961	31001	2	applied	\N	\N	\N	\N	95757	95757	95758
20967	31014	0	applied	\N	\N	\N	\N	95796	95796	95797
20967	31015	1	applied	\N	\N	\N	\N	95798	95798	95799
20972	30942	0	applied	\N	\N	1000000000	\N	95607	95607	95608
20972	30933	1	applied	\N	\N	\N	\N	95816	95816	95584
20972	30770	2	applied	\N	\N	\N	\N	95817	95817	95094
20972	30934	3	applied	\N	\N	\N	\N	95818	95818	95586
20981	31034	0	applied	\N	\N	\N	\N	95866	95866	95867
20981	31035	1	applied	\N	\N	\N	\N	95868	95868	95869
20982	31034	0	applied	\N	\N	\N	\N	95866	95866	95867
20982	31035	1	applied	\N	\N	\N	\N	95868	95868	95869
20987	31041	0	applied	\N	\N	\N	\N	95884	95884	95885
20987	31042	1	applied	\N	\N	\N	\N	95886	95886	95887
20989	31043	0	applied	\N	\N	\N	\N	95892	95892	95893
20989	31044	1	applied	\N	\N	\N	\N	95894	95894	95895
20994	31048	0	applied	\N	\N	\N	\N	95906	95906	95907
20994	31049	1	applied	\N	\N	\N	\N	95908	95908	95909
20994	31050	2	applied	\N	\N	\N	\N	95912	95912	95913
20994	31051	3	applied	\N	\N	\N	\N	95914	95914	95915
20999	31052	0	applied	\N	\N	\N	\N	95918	95918	95919
20999	31053	1	applied	\N	\N	\N	\N	95920	95920	95921
20999	31054	2	applied	\N	\N	\N	\N	95922	95922	95923
20999	31055	3	applied	\N	\N	\N	\N	95924	95924	95925
20999	31056	4	applied	\N	\N	\N	\N	95926	95926	95927
20999	31057	5	applied	\N	\N	\N	\N	95928	95928	95929
20999	31058	6	applied	\N	\N	\N	\N	95930	95930	95931
20999	31059	7	applied	\N	\N	\N	\N	95932	95932	95933
20999	31060	8	applied	\N	\N	\N	\N	95934	95934	95935
20999	31061	9	applied	\N	\N	\N	\N	95936	95936	95937
20999	31062	10	applied	\N	\N	\N	\N	95938	95938	95939
20999	31063	11	applied	\N	\N	\N	\N	95940	95940	95941
20999	31064	12	applied	\N	\N	\N	\N	95942	95942	95943
21001	31065	0	applied	\N	\N	\N	\N	95973	95973	95974
21001	31066	1	applied	\N	\N	\N	\N	95975	95975	95976
21001	31067	2	applied	\N	\N	\N	\N	95977	95977	95978
21001	31068	3	applied	\N	\N	\N	\N	95979	95979	95980
21001	31069	4	applied	\N	\N	\N	\N	95981	95981	95982
21004	31070	0	applied	\N	\N	\N	\N	95985	95985	95986
21004	31071	1	applied	\N	\N	\N	\N	95987	95987	95988
21006	31070	0	applied	\N	\N	\N	\N	95985	95985	95986
21006	31071	1	applied	\N	\N	\N	\N	95987	95987	95988
21010	31077	0	applied	\N	\N	\N	\N	96008	96008	96009
21010	31078	1	applied	\N	\N	\N	\N	96010	96010	96011
21012	31079	0	applied	\N	\N	\N	\N	96034	96034	96035
21012	31080	1	applied	\N	\N	\N	\N	96036	96036	96037
21012	31081	2	applied	\N	\N	\N	\N	96038	96038	96039
21015	31089	0	applied	\N	\N	\N	\N	96060	96060	96061
21015	31090	1	applied	\N	\N	\N	\N	96062	96062	96063
21015	31091	2	applied	\N	\N	\N	\N	96064	96064	96065
21015	31092	3	applied	\N	\N	\N	\N	96066	96066	96067
21015	31093	4	applied	\N	\N	\N	\N	96068	96068	96069
21018	31094	0	applied	\N	\N	\N	\N	96072	96072	96073
21018	31095	1	applied	\N	\N	\N	\N	96074	96074	96075
21021	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21021	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21021	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21021	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21021	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21021	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21025	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21025	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21025	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21025	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21025	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21025	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21027	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21027	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21027	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21027	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21027	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21027	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21029	31102	0	applied	\N	\N	\N	\N	96099	96099	96100
21029	31103	1	applied	\N	\N	\N	\N	96101	96101	96102
21040	31110	0	applied	\N	\N	\N	\N	96129	96129	96130
21040	31111	1	applied	\N	\N	\N	\N	96131	96131	96132
21040	31112	2	applied	\N	\N	\N	\N	96133	96133	96134
21042	31110	0	applied	\N	\N	\N	\N	96129	96129	96130
21042	31111	1	applied	\N	\N	\N	\N	96131	96131	96132
21042	31112	2	applied	\N	\N	\N	\N	96133	96133	96134
21047	31120	0	applied	\N	\N	\N	\N	96160	96160	96161
21047	31121	1	applied	\N	\N	\N	\N	96162	96162	96163
21047	31122	2	applied	\N	\N	\N	\N	96164	96164	96165
21053	31123	0	applied	\N	\N	\N	\N	96170	96170	96171
21053	31124	1	applied	\N	\N	\N	\N	96172	96172	96173
21054	31125	0	applied	\N	\N	\N	\N	96177	96177	96178
21054	31126	1	applied	\N	\N	\N	\N	96179	96179	96180
21054	31127	2	applied	\N	\N	\N	\N	96181	96181	96182
21054	31128	3	applied	\N	\N	\N	\N	96183	96183	96184
21056	31129	0	applied	\N	\N	\N	\N	96188	96188	96189
21056	31130	1	applied	\N	\N	\N	\N	96190	96190	96191
21059	31133	0	applied	\N	\N	\N	\N	96198	96198	96199
21059	31134	1	applied	\N	\N	\N	\N	96200	96200	96201
21059	31135	2	applied	\N	\N	\N	\N	96202	96202	96203
21059	31136	3	applied	\N	\N	\N	\N	96204	96204	96205
21059	31137	4	applied	\N	\N	\N	\N	96206	96206	96207
20949	30981	0	applied	\N	\N	\N	\N	95701	95701	95702
20949	30982	1	applied	\N	\N	\N	\N	95703	95703	95704
20954	30987	0	applied	\N	\N	\N	\N	95721	95721	95722
20954	30988	1	applied	\N	\N	\N	\N	95723	95723	95724
20954	30989	2	applied	\N	\N	\N	\N	95725	95725	95726
20956	30990	0	applied	\N	\N	\N	\N	95729	95729	95730
20956	30991	1	applied	\N	\N	\N	\N	95731	95731	95732
20957	30992	0	applied	\N	\N	\N	\N	95737	95737	95738
20957	30993	1	applied	\N	\N	\N	\N	95739	95739	95740
20957	30994	2	applied	\N	\N	\N	\N	95741	95741	95742
20957	30995	3	applied	\N	\N	\N	\N	95743	95743	95744
20957	30996	4	applied	\N	\N	\N	\N	95745	95745	95746
20957	30997	5	applied	\N	\N	\N	\N	95747	95747	95748
20957	30998	6	applied	\N	\N	\N	\N	95749	95749	95750
20964	30942	0	applied	\N	\N	1000000000	\N	95607	95607	95608
20964	30933	1	applied	\N	\N	\N	\N	95583	95583	95584
20964	30934	2	applied	\N	\N	\N	\N	95585	95585	95586
20964	30952	3	applied	\N	\N	1000000000	\N	95629	95629	95630
20964	30999	4	applied	\N	\N	\N	\N	95779	95779	95754
20964	30935	5	applied	\N	\N	\N	\N	95587	95587	95588
20964	30936	6	applied	\N	\N	\N	\N	95589	95589	95590
20964	31008	7	applied	\N	\N	\N	\N	95780	95780	95781
20964	30888	8	applied	\N	\N	1000000000	\N	95470	95470	95471
20964	30946	9	applied	\N	\N	\N	\N	95617	95617	95618
20964	30900	10	applied	\N	\N	\N	\N	95502	95502	95503
20964	30906	11	applied	\N	\N	\N	\N	95518	95518	95519
20964	30908	12	applied	\N	\N	\N	\N	95524	95524	95525
20964	30909	13	applied	\N	\N	\N	\N	95526	95526	95527
20964	30914	14	applied	\N	\N	\N	\N	95537	95537	95538
20964	30894	15	applied	\N	\N	\N	\N	95485	95485	95486
20966	31014	0	applied	\N	\N	\N	\N	95796	95796	95797
20966	31015	1	applied	\N	\N	\N	\N	95798	95798	95799
20970	31014	0	applied	\N	\N	\N	\N	95796	95796	95797
20970	31015	1	applied	\N	\N	\N	\N	95798	95798	95799
20971	31016	0	applied	\N	\N	\N	\N	95810	95810	95811
20971	31017	1	applied	\N	\N	\N	\N	95812	95812	95813
20975	31026	0	applied	\N	\N	\N	\N	95841	95841	95842
20975	31027	1	applied	\N	\N	\N	\N	95843	95843	95844
20975	31028	2	applied	\N	\N	\N	\N	95845	95845	95846
20976	31026	0	applied	\N	\N	\N	\N	95841	95841	95842
20976	31027	1	applied	\N	\N	\N	\N	95843	95843	95844
20976	31028	2	applied	\N	\N	\N	\N	95845	95845	95846
20984	31036	0	applied	\N	\N	\N	\N	95872	95872	95873
20984	31037	1	applied	\N	\N	\N	\N	95874	95874	95875
20986	31041	0	applied	\N	\N	\N	\N	95884	95884	95885
20986	31042	1	applied	\N	\N	\N	\N	95886	95886	95887
20993	31048	0	applied	\N	\N	\N	\N	95906	95906	95907
20993	31049	1	applied	\N	\N	\N	\N	95908	95908	95909
20996	31048	0	applied	\N	\N	\N	\N	95906	95906	95907
20996	31049	1	applied	\N	\N	\N	\N	95908	95908	95909
20996	31050	2	applied	\N	\N	\N	\N	95912	95912	95913
20996	31051	3	applied	\N	\N	\N	\N	95914	95914	95915
20998	31052	0	applied	\N	\N	\N	\N	95918	95918	95919
20998	31053	1	applied	\N	\N	\N	\N	95920	95920	95921
20998	31054	2	applied	\N	\N	\N	\N	95922	95922	95923
20998	31055	3	applied	\N	\N	\N	\N	95924	95924	95925
20998	31056	4	applied	\N	\N	\N	\N	95926	95926	95927
20998	31057	5	applied	\N	\N	\N	\N	95928	95928	95929
20998	31058	6	applied	\N	\N	\N	\N	95930	95930	95931
20998	31059	7	applied	\N	\N	\N	\N	95932	95932	95933
20998	31060	8	applied	\N	\N	\N	\N	95934	95934	95935
20998	31061	9	applied	\N	\N	\N	\N	95936	95936	95937
20998	31062	10	applied	\N	\N	\N	\N	95938	95938	95939
20998	31063	11	applied	\N	\N	\N	\N	95940	95940	95941
20998	31064	12	applied	\N	\N	\N	\N	95942	95942	95943
21003	31070	0	applied	\N	\N	\N	\N	95985	95985	95986
21003	31071	1	applied	\N	\N	\N	\N	95987	95987	95988
21008	31072	0	applied	\N	\N	\N	\N	95995	95995	95996
21008	31073	1	applied	\N	\N	\N	\N	95997	95997	95998
21008	31074	2	applied	\N	\N	\N	\N	95999	95999	96000
21008	31075	3	applied	\N	\N	\N	\N	96001	96001	96002
21008	31076	4	applied	\N	\N	\N	\N	96003	96003	96004
21011	30942	0	applied	\N	\N	1000000000	\N	95607	95607	95608
21011	30593	1	applied	\N	\N	\N	\N	94527	94527	94528
21011	30594	2	applied	\N	\N	\N	\N	94529	94529	94530
21011	30616	3	applied	\N	\N	\N	\N	94628	94628	94629
21011	30933	4	applied	\N	\N	\N	\N	96014	96014	95584
21011	30702	5	applied	\N	\N	\N	\N	94908	94908	94852
21011	30770	6	applied	\N	\N	\N	\N	96015	96015	95094
21011	30934	7	applied	\N	\N	\N	\N	96016	96016	95586
21011	30952	8	applied	\N	\N	1000000000	\N	95629	95629	95630
21011	30999	9	applied	\N	\N	\N	\N	95779	95779	95754
21011	30780	10	applied	\N	\N	\N	\N	96017	96017	95117
21011	30703	11	applied	\N	\N	\N	\N	94909	94909	94854
21011	30704	12	applied	\N	\N	\N	\N	94910	94910	94856
21011	30705	13	applied	\N	\N	\N	\N	94911	94911	94858
21011	30706	14	applied	\N	\N	\N	\N	94912	94912	94912
21011	30935	15	applied	\N	\N	\N	\N	96018	96018	95588
21011	30936	16	applied	\N	\N	\N	\N	96019	96019	95590
21011	31008	17	applied	\N	\N	\N	\N	96020	96020	95781
21011	30786	18	applied	\N	\N	\N	\N	96021	96021	95134
21011	30787	19	applied	\N	\N	\N	\N	96022	96022	95136
21011	30807	20	applied	\N	\N	\N	\N	96023	96023	95181
21011	30652	21	applied	\N	\N	\N	\N	94717	94717	94718
21011	30737	22	applied	\N	\N	\N	\N	96024	96024	94986
21011	30744	23	applied	\N	\N	\N	\N	96025	96025	95013
21011	30641	24	applied	\N	\N	\N	\N	94691	94691	94692
21011	30651	25	applied	\N	\N	\N	\N	94715	94715	94716
21011	30659	26	applied	\N	\N	\N	\N	94742	94742	94743
21011	30888	27	applied	\N	\N	1000000000	\N	95470	95470	95471
21011	30588	28	applied	\N	\N	\N	\N	94513	94513	94514
21011	30535	29	applied	\N	\N	\N	\N	94566	94566	94386
21011	30536	30	applied	\N	\N	\N	\N	94567	94567	94388
21011	30574	31	applied	\N	\N	\N	\N	94480	94480	94481
21011	30589	32	applied	\N	\N	\N	\N	94515	94515	94516
21011	30590	33	applied	\N	\N	\N	\N	94517	94517	94518
21011	30595	34	applied	\N	\N	\N	\N	94531	94531	94532
21011	30596	35	applied	\N	\N	\N	\N	94533	94533	94534
21011	30745	36	applied	\N	\N	\N	\N	96026	96026	95015
21011	30748	37	applied	\N	\N	\N	\N	96027	96027	95024
21011	30758	38	applied	\N	\N	\N	\N	96028	96028	96029
21011	30575	39	applied	\N	\N	\N	\N	94482	94482	94483
21011	30576	40	applied	\N	\N	\N	\N	94484	94484	94485
21011	30577	41	applied	\N	\N	\N	\N	94486	94486	94487
21011	30537	42	applied	\N	\N	\N	\N	94572	94572	94390
21011	30538	43	applied	\N	\N	\N	\N	94573	94573	94392
21011	30543	44	applied	\N	\N	\N	\N	94574	94574	94404
21011	30544	45	applied	\N	\N	\N	\N	94575	94575	94406
21011	30494	46	applied	\N	\N	\N	\N	94252	94252	94253
20951	30984	1	applied	\N	\N	\N	\N	95710	95710	95711
20959	30999	0	applied	\N	\N	\N	\N	95753	95753	95754
20959	31000	1	applied	\N	\N	\N	\N	95755	95755	95756
20959	31001	2	applied	\N	\N	\N	\N	95757	95757	95758
20963	31006	0	applied	\N	\N	\N	\N	95775	95775	95776
20963	31007	1	applied	\N	\N	\N	\N	95777	95777	95778
20969	31014	0	applied	\N	\N	\N	\N	95796	95796	95797
20969	31015	1	applied	\N	\N	\N	\N	95798	95798	95799
20973	31018	0	applied	\N	\N	\N	\N	95821	95821	95822
20973	31019	1	applied	\N	\N	\N	\N	95823	95823	95824
20973	31020	2	applied	\N	\N	\N	\N	95825	95825	95826
20973	31021	3	applied	\N	\N	\N	\N	95827	95827	95828
20973	31022	4	applied	\N	\N	\N	\N	95829	95829	95830
20973	31023	5	applied	\N	\N	\N	\N	95831	95831	95832
20974	31024	0	applied	\N	\N	\N	\N	95835	95835	95836
20974	31025	1	applied	\N	\N	\N	\N	95837	95837	95838
20977	31029	0	applied	\N	\N	\N	\N	95851	95851	95852
20977	31030	1	applied	\N	\N	\N	\N	95853	95853	95854
20977	31031	2	applied	\N	\N	\N	\N	95855	95855	95856
20978	31029	0	applied	\N	\N	\N	\N	95851	95851	95852
20978	31030	1	applied	\N	\N	\N	\N	95853	95853	95854
20978	31031	2	applied	\N	\N	\N	\N	95855	95855	95856
20980	31034	0	applied	\N	\N	\N	\N	95866	95866	95867
20980	31035	1	applied	\N	\N	\N	\N	95868	95868	95869
20983	31036	0	applied	\N	\N	\N	\N	95872	95872	95873
20983	31037	1	applied	\N	\N	\N	\N	95874	95874	95875
20991	31043	0	applied	\N	\N	\N	\N	95892	95892	95893
20991	31044	1	applied	\N	\N	\N	\N	95894	95894	95895
20992	31045	0	applied	\N	\N	\N	\N	95899	95899	95900
20992	31046	1	applied	\N	\N	\N	\N	95901	95901	95902
20992	31047	2	applied	\N	\N	\N	\N	95903	95903	95904
21007	31072	0	applied	\N	\N	\N	\N	95995	95995	95996
21007	31073	1	applied	\N	\N	\N	\N	95997	95997	95998
21007	31074	2	applied	\N	\N	\N	\N	95999	95999	96000
21007	31075	3	applied	\N	\N	\N	\N	96001	96001	96002
21007	31076	4	applied	\N	\N	\N	\N	96003	96003	96004
21019	31094	0	applied	\N	\N	\N	\N	96072	96072	96073
21019	31095	1	applied	\N	\N	\N	\N	96074	96074	96075
21023	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21023	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21023	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21023	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21023	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21023	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21026	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21026	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21026	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21026	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21026	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21026	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21030	31102	0	applied	\N	\N	\N	\N	96099	96099	96100
21030	31103	1	applied	\N	\N	\N	\N	96101	96101	96102
21033	31102	0	applied	\N	\N	\N	\N	96099	96099	96100
21033	31104	1	applied	\N	\N	\N	\N	96106	96106	96107
21033	31103	2	applied	\N	\N	\N	\N	96101	96101	96102
21033	31106	3	applied	\N	\N	\N	\N	96110	96110	96114
21039	31109	0	applied	\N	\N	\N	\N	96125	96125	96126
21044	31118	0	applied	\N	\N	\N	\N	96152	96152	96153
21044	31119	1	applied	\N	\N	\N	\N	96154	96154	96155
21051	31123	0	applied	\N	\N	\N	\N	96170	96170	96171
21051	31124	1	applied	\N	\N	\N	\N	96172	96172	96173
21060	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21060	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21060	31140	2	applied	\N	\N	\N	\N	96214	96214	96215
21060	31141	3	applied	\N	\N	\N	\N	96216	96216	96217
21062	31147	0	applied	\N	\N	\N	\N	96246	96246	96247
21062	31142	1	applied	\N	\N	\N	\N	96220	96220	96221
21062	31143	2	applied	\N	\N	\N	\N	96222	96222	96223
21062	31144	3	applied	\N	\N	\N	\N	96224	96224	96225
21062	31145	4	applied	\N	\N	\N	\N	96226	96226	96227
21062	31148	5	applied	\N	\N	\N	\N	96248	96248	96249
21064	31147	0	applied	\N	\N	\N	\N	96246	96246	96247
21064	31142	1	applied	\N	\N	\N	\N	96220	96220	96221
21064	31143	2	applied	\N	\N	\N	\N	96222	96222	96223
21064	31144	3	applied	\N	\N	\N	\N	96224	96224	96225
21064	31145	4	applied	\N	\N	\N	\N	96226	96226	96227
21064	31148	5	applied	\N	\N	\N	\N	96248	96248	96249
21069	31149	0	applied	\N	\N	\N	\N	96260	96260	96261
21069	31151	1	applied	\N	\N	\N	\N	96266	96266	96267
21069	31150	2	applied	\N	\N	\N	\N	96262	96262	96268
21073	31161	0	applied	\N	\N	\N	\N	96296	96296	96297
21073	31162	1	applied	\N	\N	\N	\N	96298	96298	96299
21077	31163	0	applied	\N	\N	\N	\N	96303	96303	96304
21077	31164	1	applied	\N	\N	\N	\N	96305	96305	96306
21082	31170	0	applied	\N	\N	\N	\N	96322	96322	96323
21082	31171	1	applied	\N	\N	\N	\N	96324	96324	96325
21087	31177	0	applied	\N	\N	\N	\N	96347	96347	96348
21087	31178	1	applied	\N	\N	\N	\N	96349	96349	96350
21089	31177	0	applied	\N	\N	\N	\N	96347	96347	96348
21089	31178	1	applied	\N	\N	\N	\N	96349	96349	96350
21091	31179	0	applied	\N	\N	\N	\N	96355	96355	96356
21091	31180	1	applied	\N	\N	\N	\N	96357	96357	96358
21091	31181	2	applied	\N	\N	\N	\N	96359	96359	96360
21091	31182	3	applied	\N	\N	\N	\N	96361	96361	96362
21091	31183	4	applied	\N	\N	\N	\N	96363	96363	96364
21095	31184	0	applied	\N	\N	\N	\N	96369	96369	96370
21095	31185	1	applied	\N	\N	\N	\N	96371	96371	96372
21095	31186	2	applied	\N	\N	\N	\N	96373	96373	96374
21095	31187	3	applied	\N	\N	\N	\N	96375	96375	96376
21098	31188	0	applied	\N	\N	\N	\N	96384	96384	96385
21098	31189	1	applied	\N	\N	\N	\N	96386	96386	96387
21098	31190	2	applied	\N	\N	\N	\N	96388	96388	96389
21102	31191	0	applied	\N	\N	\N	\N	96394	96394	96395
21105	31194	0	applied	\N	\N	\N	\N	96405	96405	96406
21105	31195	1	applied	\N	\N	\N	\N	96407	96407	96408
21105	31196	2	applied	\N	\N	\N	\N	96409	96409	96410
21107	31194	0	applied	\N	\N	\N	\N	96405	96405	96406
21107	31197	1	applied	\N	\N	\N	\N	96411	96411	96412
21107	31195	2	applied	\N	\N	\N	\N	96407	96407	96408
21107	31196	3	applied	\N	\N	\N	\N	96409	96409	96410
21107	31198	4	applied	\N	\N	\N	\N	96414	96414	96415
21114	31202	0	applied	\N	\N	\N	\N	96430	96430	96431
21114	31203	1	applied	\N	\N	\N	\N	96432	96432	96433
21114	31204	2	applied	\N	\N	\N	\N	96434	96434	96435
21119	31212	0	applied	\N	\N	\N	\N	96460	96460	96461
21119	31213	1	applied	\N	\N	\N	\N	96462	96462	96463
21119	31214	2	applied	\N	\N	\N	\N	96464	96464	96465
21119	31215	3	applied	\N	\N	\N	\N	96466	96466	96467
21121	31216	0	applied	\N	\N	\N	\N	96470	96470	96471
21121	31217	1	applied	\N	\N	\N	\N	96472	96472	96473
21000	30972	41	applied	\N	\N	\N	\N	95676	95676	95677
21000	30973	42	applied	\N	\N	\N	\N	95678	95678	95679
21000	30978	43	applied	\N	\N	\N	\N	95694	95694	95695
21000	30981	44	applied	\N	\N	\N	\N	95701	95701	95702
21000	30983	45	applied	\N	\N	\N	\N	95708	95708	95709
21000	30985	46	applied	\N	\N	\N	\N	95714	95714	95715
21000	30987	47	applied	\N	\N	\N	\N	95721	95721	95722
21000	30990	48	applied	\N	\N	\N	\N	95729	95729	95730
21000	30992	49	applied	\N	\N	\N	\N	95737	95737	95738
21000	31018	50	applied	\N	\N	\N	\N	95821	95821	95822
21000	31019	51	applied	\N	\N	\N	\N	95823	95823	95824
21000	31020	52	applied	\N	\N	\N	\N	95825	95825	95826
21000	31021	53	applied	\N	\N	\N	\N	95827	95827	95828
21000	31026	54	applied	\N	\N	\N	\N	95841	95841	95842
21000	30993	55	applied	\N	\N	\N	\N	95739	95739	95740
21000	30994	56	applied	\N	\N	\N	\N	95741	95741	95742
21000	31000	57	applied	\N	\N	\N	\N	95755	95755	95756
21000	31002	58	applied	\N	\N	\N	\N	95765	95765	95766
21000	31003	59	applied	\N	\N	\N	\N	95767	95767	95768
21000	31006	60	applied	\N	\N	\N	\N	95775	95775	95776
21000	31009	61	applied	\N	\N	\N	\N	95784	95784	95785
21000	31010	62	applied	\N	\N	\N	\N	95786	95786	95787
21000	31014	63	applied	\N	\N	\N	\N	95796	95796	95797
21000	31016	64	applied	\N	\N	\N	\N	95810	95810	95811
21000	31024	65	applied	\N	\N	\N	\N	95835	95835	95836
21000	31027	66	applied	\N	\N	\N	\N	95843	95843	95844
21000	31029	67	applied	\N	\N	\N	\N	95851	95851	95852
21000	31032	68	applied	\N	\N	\N	\N	95861	95861	95862
21000	31034	69	applied	\N	\N	\N	\N	95866	95866	95867
21000	31036	70	applied	\N	\N	\N	\N	95872	95872	95873
21000	31038	71	applied	\N	\N	\N	\N	95878	95878	95879
21000	31041	72	applied	\N	\N	\N	\N	95884	95884	95885
21000	31043	73	applied	\N	\N	\N	\N	95892	95892	95893
21000	31045	74	applied	\N	\N	\N	\N	95899	95899	95900
21000	31048	75	applied	\N	\N	\N	\N	95906	95906	95907
21000	31049	76	applied	\N	\N	\N	\N	95908	95908	95909
21000	31056	77	applied	\N	\N	\N	\N	95926	95926	95927
21000	31057	78	applied	\N	\N	\N	\N	95928	95928	95929
21000	31058	79	applied	\N	\N	\N	\N	95930	95930	95931
21000	31059	80	applied	\N	\N	\N	\N	95932	95932	95933
21000	30912	81	applied	\N	\N	\N	\N	95532	95532	95949
21000	30919	82	applied	\N	\N	\N	\N	95548	95548	95521
21000	30930	83	applied	\N	\N	\N	\N	95573	95573	95950
21000	30941	84	applied	\N	\N	\N	\N	95599	95599	95531
21000	30950	85	applied	\N	\N	\N	\N	95625	95625	95533
21000	30965	86	applied	\N	\N	\N	\N	95658	95658	95951
21000	30975	87	applied	\N	\N	\N	\N	95682	95682	95540
21000	30979	88	applied	\N	\N	\N	\N	95696	95696	95952
21000	30988	89	applied	\N	\N	\N	\N	95723	95723	95545
21000	30995	90	applied	\N	\N	\N	\N	95743	95743	95549
21000	31004	91	applied	\N	\N	\N	\N	95769	95769	95953
21000	30907	92	applied	\N	\N	\N	\N	95520	95520	95954
21000	30911	93	applied	\N	\N	\N	\N	95530	95530	95955
21000	30915	94	applied	\N	\N	\N	\N	95539	95539	95956
21000	30917	95	applied	\N	\N	\N	\N	95544	95544	95957
21000	30920	96	applied	\N	\N	\N	\N	95550	95550	95574
21000	30922	97	applied	\N	\N	\N	\N	95556	95556	95580
21000	30927	98	applied	\N	\N	\N	\N	95566	95566	95596
21000	30928	99	applied	\N	\N	\N	\N	95568	95568	95598
21000	30929	100	applied	\N	\N	\N	\N	95571	95571	95958
21000	31013	101	applied	\N	\N	\N	\N	95792	95792	95612
21000	31022	102	applied	\N	\N	\N	\N	95829	95829	95959
21000	31030	103	applied	\N	\N	\N	\N	95853	95853	95622
21000	31040	104	applied	\N	\N	\N	\N	95882	95882	95960
21000	31047	105	applied	\N	\N	\N	\N	95903	95903	95624
21000	31064	106	applied	\N	\N	\N	\N	95942	95942	95626
21000	30932	107	applied	\N	\N	\N	\N	95579	95579	95634
21000	30939	108	applied	\N	\N	\N	\N	95595	95595	95639
21000	30940	109	applied	\N	\N	\N	\N	95597	95597	95651
21000	30944	110	applied	\N	\N	\N	\N	95611	95611	95961
21000	30948	111	applied	\N	\N	\N	\N	95621	95621	95962
21000	30949	112	applied	\N	\N	\N	\N	95623	95623	95963
21000	30954	113	applied	\N	\N	\N	\N	95633	95633	95964
21000	30956	114	applied	\N	\N	\N	\N	95638	95638	95683
21000	30961	115	applied	\N	\N	\N	\N	95650	95650	95685
21000	30966	116	applied	\N	\N	\N	\N	95660	95660	95687
21000	30969	117	applied	\N	\N	\N	\N	95668	95668	95965
21000	30970	118	applied	\N	\N	\N	\N	95670	95670	95966
21000	30974	119	applied	\N	\N	\N	\N	95680	95680	95967
21000	30976	120	applied	\N	\N	\N	\N	95684	95684	95968
21000	30977	121	applied	\N	\N	\N	\N	95686	95686	95724
21000	30980	122	applied	\N	\N	\N	\N	95698	95698	95726
21000	30982	123	applied	\N	\N	\N	\N	95703	95703	95732
21000	30984	124	applied	\N	\N	\N	\N	95710	95710	95969
21000	30986	125	applied	\N	\N	\N	\N	95716	95716	95970
21002	31065	0	applied	\N	\N	\N	\N	95973	95973	95974
21002	31066	1	applied	\N	\N	\N	\N	95975	95975	95976
21002	31067	2	applied	\N	\N	\N	\N	95977	95977	95978
21002	31068	3	applied	\N	\N	\N	\N	95979	95979	95980
21002	31069	4	applied	\N	\N	\N	\N	95981	95981	95982
21005	31070	0	applied	\N	\N	\N	\N	95985	95985	95986
21005	31071	1	applied	\N	\N	\N	\N	95987	95987	95988
21009	31072	0	applied	\N	\N	\N	\N	95995	95995	95996
21009	31073	1	applied	\N	\N	\N	\N	95997	95997	95998
21009	31074	2	applied	\N	\N	\N	\N	95999	95999	96000
21013	31079	0	applied	\N	\N	\N	\N	96034	96034	96035
21013	31080	1	applied	\N	\N	\N	\N	96036	96036	96037
21013	31081	2	applied	\N	\N	\N	\N	96038	96038	96039
21016	31089	0	applied	\N	\N	\N	\N	96060	96060	96061
21016	31090	1	applied	\N	\N	\N	\N	96062	96062	96063
21016	31091	2	applied	\N	\N	\N	\N	96064	96064	96065
21016	31092	3	applied	\N	\N	\N	\N	96066	96066	96067
21016	31093	4	applied	\N	\N	\N	\N	96068	96068	96069
21022	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21022	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21022	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21022	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21022	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21022	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21028	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21028	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21028	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21028	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21028	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21028	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21032	31104	0	applied	\N	\N	\N	\N	96106	96106	96107
21032	31105	1	applied	\N	\N	\N	\N	96108	96108	96109
21032	31106	2	applied	\N	\N	\N	\N	96110	96110	96111
21034	31107	0	applied	\N	\N	\N	\N	96116	96116	96117
21034	31108	1	applied	\N	\N	\N	\N	96118	96118	96119
21011	30496	47	applied	\N	\N	\N	\N	94288	94288	94289
21011	30497	48	applied	\N	\N	\N	\N	94290	94290	94291
21011	30498	49	applied	\N	\N	\N	\N	94292	94292	94293
21011	30946	50	applied	\N	\N	\N	\N	96030	96030	95618
21011	30900	51	applied	\N	\N	\N	\N	95502	95502	95503
21011	30906	52	applied	\N	\N	\N	\N	95518	95518	95519
21011	30908	53	applied	\N	\N	\N	\N	95524	95524	95525
21011	30909	54	applied	\N	\N	\N	\N	95526	95526	95527
21011	30914	55	applied	\N	\N	\N	\N	95537	95537	95538
21011	30506	56	applied	\N	\N	\N	\N	94315	94315	94316
21011	31052	57	applied	\N	\N	\N	\N	95918	95918	95919
21011	31053	58	applied	\N	\N	\N	\N	95920	95920	95921
21011	31054	59	applied	\N	\N	\N	\N	95922	95922	95923
21011	31055	60	applied	\N	\N	\N	\N	95924	95924	95925
21011	30546	61	applied	\N	\N	\N	\N	94576	94576	94410
21011	30550	62	applied	\N	\N	\N	\N	94577	94577	94422
21011	30551	63	applied	\N	\N	\N	\N	94578	94578	94424
21011	30552	64	applied	\N	\N	\N	\N	94579	94579	94426
21011	30556	65	applied	\N	\N	\N	\N	94580	94580	94436
21011	30557	66	applied	\N	\N	\N	\N	94581	94581	94438
21011	30561	67	applied	\N	\N	\N	\N	94582	94582	94447
21011	30562	68	applied	\N	\N	\N	\N	94583	94583	94449
21011	30507	69	applied	\N	\N	\N	\N	94317	94317	94318
21011	30508	70	applied	\N	\N	\N	\N	94319	94319	94320
21011	30516	71	applied	\N	\N	\N	\N	94337	94337	94338
21011	30517	72	applied	\N	\N	\N	\N	94339	94339	94340
21011	30523	73	applied	\N	\N	\N	\N	94352	94352	94353
21011	30842	74	applied	\N	\N	\N	\N	95329	95329	93688
21011	30578	75	applied	\N	\N	\N	\N	94488	94488	94489
21011	30526	76	applied	\N	\N	\N	\N	94364	94364	94365
21011	30529	77	applied	\N	\N	\N	\N	94372	94372	94373
21011	30533	78	applied	\N	\N	\N	\N	94381	94381	94382
21011	30534	79	applied	\N	\N	\N	\N	94383	94383	94384
21011	30545	80	applied	\N	\N	\N	\N	94407	94407	94408
21011	30673	81	applied	\N	\N	\N	\N	94913	94913	94777
21011	30674	82	applied	\N	\N	\N	\N	94914	94914	94779
21011	30675	83	applied	\N	\N	\N	\N	94915	94915	94781
21011	30676	84	applied	\N	\N	\N	\N	94916	94916	94783
21011	30679	85	applied	\N	\N	\N	\N	94917	94917	94791
21011	30553	86	applied	\N	\N	\N	\N	94427	94427	94428
21011	30558	87	applied	\N	\N	\N	\N	94439	94439	94440
21011	30563	88	applied	\N	\N	\N	\N	94450	94450	94451
21011	30569	89	applied	\N	\N	\N	\N	94464	94464	94465
21011	30597	90	applied	\N	\N	\N	\N	94535	94535	94536
21011	30579	91	applied	\N	\N	\N	\N	94490	94490	94491
21011	30582	92	applied	\N	\N	\N	\N	94497	94497	94498
21011	30587	93	applied	\N	\N	\N	\N	94511	94511	94512
21011	30598	94	applied	\N	\N	\N	\N	94537	94537	94538
21011	30599	96	applied	\N	\N	\N	\N	94539	94539	94540
21011	30600	97	applied	\N	\N	\N	\N	94541	94541	94542
21011	30805	98	applied	\N	\N	\N	\N	95175	95175	95175
21011	30601	99	applied	\N	\N	\N	\N	94543	94543	94544
21011	30602	100	applied	\N	\N	\N	\N	94545	94545	94546
21011	30603	101	applied	\N	\N	\N	\N	94547	94547	94548
21011	30609	102	applied	\N	\N	\N	\N	94607	94607	94608
21011	30610	103	applied	\N	\N	\N	\N	94609	94609	94610
21011	30611	104	applied	\N	\N	\N	\N	94611	94611	94612
21011	30721	105	applied	\N	\N	\N	\N	94918	94918	94745
21011	30722	106	applied	\N	\N	\N	\N	94919	94919	94755
21011	30618	107	applied	\N	\N	\N	\N	94920	94920	94633
21011	30619	108	applied	\N	\N	\N	\N	94921	94921	94635
21011	30620	109	applied	\N	\N	\N	\N	94922	94922	94637
21011	30621	110	applied	\N	\N	\N	\N	94923	94923	94639
21011	30622	111	applied	\N	\N	\N	\N	94924	94924	94641
21011	30628	112	applied	\N	\N	\N	\N	94925	94925	94659
21011	30630	113	applied	\N	\N	\N	\N	94926	94926	94663
21011	30631	114	applied	\N	\N	\N	\N	94927	94927	94665
21011	30633	115	applied	\N	\N	\N	\N	94928	94928	94671
21011	30660	116	applied	\N	\N	\N	\N	94929	94929	94930
21011	30664	117	applied	\N	\N	\N	\N	94931	94931	94932
21011	30680	118	applied	\N	\N	\N	\N	94933	94933	94793
21011	30681	119	applied	\N	\N	\N	\N	94934	94934	94795
21011	30614	120	applied	\N	\N	\N	\N	94622	94622	94623
21011	30623	121	applied	\N	\N	\N	\N	94642	94642	94643
21011	30624	122	applied	\N	\N	\N	\N	94644	94644	94645
21011	30629	123	applied	\N	\N	\N	\N	94660	94660	94661
21011	30634	124	applied	\N	\N	\N	\N	94672	94672	94673
21011	30635	125	applied	\N	\N	\N	\N	94674	94674	94675
21014	31082	0	applied	\N	\N	\N	\N	96044	96044	96045
21014	31083	1	applied	\N	\N	\N	\N	96046	96046	96047
21014	31084	2	applied	\N	\N	\N	\N	96048	96048	96049
21014	31085	3	applied	\N	\N	\N	\N	96050	96050	96051
21014	31086	4	applied	\N	\N	\N	\N	96052	96052	96053
21014	31087	5	applied	\N	\N	\N	\N	96054	96054	96055
21014	31088	6	applied	\N	\N	\N	\N	96056	96056	96057
21020	31094	0	applied	\N	\N	\N	\N	96072	96072	96073
21020	31095	1	applied	\N	\N	\N	\N	96074	96074	96075
21024	31096	0	applied	\N	\N	\N	\N	96081	96081	96082
21024	31097	1	applied	\N	\N	\N	\N	96083	96083	96084
21024	31098	2	applied	\N	\N	\N	\N	96085	96085	96086
21024	31099	3	applied	\N	\N	\N	\N	96087	96087	96088
21024	31100	4	applied	\N	\N	\N	\N	96089	96089	96090
21024	31101	5	applied	\N	\N	\N	\N	96091	96091	96092
21031	31104	0	applied	\N	\N	\N	\N	96106	96106	96107
21031	31105	1	applied	\N	\N	\N	\N	96108	96108	96109
21031	31106	2	applied	\N	\N	\N	\N	96110	96110	96111
21035	31107	0	applied	\N	\N	\N	\N	96116	96116	96117
21035	31108	1	applied	\N	\N	\N	\N	96118	96118	96119
21038	31107	0	applied	\N	\N	\N	\N	96116	96116	96117
21038	31108	1	applied	\N	\N	\N	\N	96118	96118	96119
21045	31118	0	applied	\N	\N	\N	\N	96152	96152	96153
21045	31119	1	applied	\N	\N	\N	\N	96154	96154	96155
21049	31120	0	applied	\N	\N	\N	\N	96160	96160	96161
21049	31121	1	applied	\N	\N	\N	\N	96162	96162	96163
21049	31122	2	applied	\N	\N	\N	\N	96164	96164	96165
21052	31123	0	applied	\N	\N	\N	\N	96170	96170	96171
21052	31124	1	applied	\N	\N	\N	\N	96172	96172	96173
21058	31131	0	applied	\N	\N	\N	\N	96192	96192	96193
21058	31132	1	applied	\N	\N	\N	\N	96194	96194	96195
21061	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21061	30942	1	applied	\N	\N	1000000000	\N	95607	95607	95608
21061	30933	2	applied	\N	\N	\N	\N	95583	95583	95584
21061	30934	3	applied	\N	\N	\N	\N	95585	95585	95586
21061	30952	4	applied	\N	\N	1000000000	\N	95629	95629	95630
21061	30999	5	applied	\N	\N	\N	\N	95779	95779	95754
21061	30935	6	applied	\N	\N	\N	\N	95587	95587	95588
21061	30936	7	applied	\N	\N	\N	\N	95589	95589	95590
21061	31008	8	applied	\N	\N	\N	\N	95780	95780	95781
21061	31139	9	applied	\N	\N	\N	\N	96212	96212	96213
21041	31110	0	applied	\N	\N	\N	\N	96129	96129	96130
21041	31111	1	applied	\N	\N	\N	\N	96131	96131	96132
21041	31112	2	applied	\N	\N	\N	\N	96133	96133	96134
21043	31113	0	applied	\N	\N	\N	\N	96140	96140	96141
21043	31114	1	applied	\N	\N	\N	\N	96142	96142	96143
21043	31115	2	applied	\N	\N	\N	\N	96144	96144	96145
21043	31116	3	applied	\N	\N	\N	\N	96146	96146	96147
21043	31117	4	applied	\N	\N	\N	\N	96148	96148	96149
21046	31118	0	applied	\N	\N	\N	\N	96152	96152	96153
21046	31119	1	applied	\N	\N	\N	\N	96154	96154	96155
21048	31120	0	applied	\N	\N	\N	\N	96160	96160	96161
21048	31121	1	applied	\N	\N	\N	\N	96162	96162	96163
21048	31122	2	applied	\N	\N	\N	\N	96164	96164	96165
21050	31123	0	applied	\N	\N	\N	\N	96170	96170	96171
21050	31124	1	applied	\N	\N	\N	\N	96172	96172	96173
21055	31125	0	applied	\N	\N	\N	\N	96177	96177	96178
21055	31126	1	applied	\N	\N	\N	\N	96179	96179	96180
21055	31127	2	applied	\N	\N	\N	\N	96181	96181	96182
21055	31128	3	applied	\N	\N	\N	\N	96183	96183	96184
21057	31129	0	applied	\N	\N	\N	\N	96188	96188	96189
21057	31130	1	applied	\N	\N	\N	\N	96190	96190	96191
21065	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21065	30942	1	applied	\N	\N	1000000000	\N	95607	95607	95608
21065	30933	2	applied	\N	\N	\N	\N	95816	95816	95584
21065	30934	3	applied	\N	\N	\N	\N	95818	95818	95586
21065	30952	4	applied	\N	\N	1000000000	\N	95629	95629	95630
21065	30999	5	applied	\N	\N	\N	\N	95779	95779	95754
21065	30935	6	applied	\N	\N	\N	\N	96254	96254	95588
21065	30936	7	applied	\N	\N	\N	\N	96255	96255	95590
21065	31008	8	applied	\N	\N	\N	\N	96256	96256	95781
21065	31139	9	applied	\N	\N	\N	\N	96212	96212	96213
21065	30888	10	applied	\N	\N	1000000000	\N	95470	95470	95471
21065	31084	11	applied	\N	\N	\N	\N	96048	96048	96049
21065	31085	12	applied	\N	\N	\N	\N	96050	96050	96051
21065	31142	13	applied	\N	\N	\N	\N	96220	96220	96221
21065	31143	14	applied	\N	\N	\N	\N	96222	96222	96223
21065	31144	15	applied	\N	\N	\N	\N	96224	96224	96225
21065	31145	16	applied	\N	\N	\N	\N	96226	96226	96227
21065	31086	17	applied	\N	\N	\N	\N	96052	96052	96053
21065	31146	18	applied	\N	\N	\N	\N	96228	96228	96229
21065	30946	19	applied	\N	\N	\N	\N	95617	95617	95618
21065	30900	20	applied	\N	\N	\N	\N	95502	95502	95503
21065	30906	21	applied	\N	\N	\N	\N	95518	95518	95519
21065	30908	22	applied	\N	\N	\N	\N	95524	95524	95525
21065	30909	23	applied	\N	\N	\N	\N	95526	95526	95527
21065	30914	24	applied	\N	\N	\N	\N	95537	95537	95538
21065	31052	25	applied	\N	\N	\N	\N	95918	95918	95919
21065	31053	26	applied	\N	\N	\N	\N	95920	95920	95921
21065	31054	27	applied	\N	\N	\N	\N	95922	95922	95923
21065	31055	28	applied	\N	\N	\N	\N	95924	95924	95925
21065	30842	29	applied	\N	\N	\N	\N	95329	95329	93688
21065	30840	30	applied	\N	\N	\N	\N	95323	95323	95324
21065	30841	31	applied	\N	\N	\N	\N	95327	95327	95328
21065	30845	32	applied	\N	\N	\N	\N	95339	95339	95340
21065	30847	33	applied	\N	\N	\N	\N	95346	95346	95347
21065	30849	34	applied	\N	\N	\N	\N	95356	95356	95357
21065	30851	35	applied	\N	\N	\N	\N	95361	95361	95362
21065	30854	36	applied	\N	\N	\N	\N	95371	95371	95372
21065	30856	37	applied	\N	\N	\N	\N	95377	95377	95378
21065	30858	38	applied	\N	\N	\N	\N	95382	95382	95383
21065	30861	39	applied	\N	\N	\N	\N	95391	95391	95392
21065	30863	40	applied	\N	\N	\N	\N	95401	95401	95402
21065	30865	41	applied	\N	\N	\N	\N	95406	95406	95407
21065	30866	42	applied	\N	\N	\N	\N	95408	95408	95409
21065	30870	43	applied	\N	\N	\N	\N	95420	95420	95421
21065	30872	44	applied	\N	\N	\N	\N	95426	95426	95427
21065	30873	45	applied	\N	\N	\N	\N	95428	95428	95429
21065	30874	46	applied	\N	\N	\N	\N	95430	95430	95431
21065	30879	47	applied	\N	\N	\N	\N	95442	95442	95443
21065	30880	48	applied	\N	\N	\N	\N	95444	95444	95445
21065	30881	49	applied	\N	\N	\N	\N	95446	95446	95447
21065	30886	50	applied	\N	\N	\N	\N	95458	95458	95459
21065	30889	51	applied	\N	\N	\N	\N	95472	95472	95473
21065	30892	52	applied	\N	\N	\N	\N	95481	95481	95482
21065	30893	53	applied	\N	\N	\N	\N	95483	95483	95484
21065	30897	54	applied	\N	\N	\N	\N	95495	95495	95496
21065	30899	55	applied	\N	\N	\N	\N	95500	95500	95501
21065	30903	56	applied	\N	\N	\N	\N	95510	95510	95511
21065	30905	58	applied	\N	\N	\N	\N	95516	95516	95517
21065	30910	59	applied	\N	\N	\N	\N	95528	95528	95529
21065	30913	60	applied	\N	\N	\N	\N	95535	95535	95536
21065	30916	61	applied	\N	\N	\N	\N	95542	95542	95543
21065	30918	62	applied	\N	\N	\N	\N	95546	95546	95547
21065	30921	63	applied	\N	\N	\N	\N	95554	95554	95555
21065	30923	64	applied	\N	\N	\N	\N	95559	95559	95560
21065	30924	65	applied	\N	\N	\N	\N	95561	95561	95562
21065	30925	66	applied	\N	\N	\N	\N	95563	95563	95564
21065	30931	67	applied	\N	\N	\N	\N	95577	95577	95578
21065	30937	68	applied	\N	\N	\N	\N	95591	95591	95592
21065	30938	69	applied	\N	\N	\N	\N	95593	95593	95594
21065	30943	70	applied	\N	\N	\N	\N	95609	95609	95610
21065	30945	71	applied	\N	\N	\N	\N	95615	95615	95616
21065	30947	72	applied	\N	\N	\N	\N	95619	95619	95620
21065	30953	73	applied	\N	\N	\N	\N	95631	95631	95632
21065	30955	74	applied	\N	\N	\N	\N	95636	95636	95637
21065	30959	75	applied	\N	\N	\N	\N	95646	95646	95647
21065	30964	76	applied	\N	\N	\N	\N	95656	95656	95657
21065	30967	77	applied	\N	\N	\N	\N	95664	95664	95665
21065	30968	78	applied	\N	\N	\N	\N	95666	95666	95667
21065	30971	79	applied	\N	\N	\N	\N	95674	95674	95675
21065	30972	80	applied	\N	\N	\N	\N	95676	95676	95677
21065	30973	81	applied	\N	\N	\N	\N	95678	95678	95679
21065	30978	82	applied	\N	\N	\N	\N	95694	95694	95695
21065	30981	83	applied	\N	\N	\N	\N	95701	95701	95702
21065	30983	84	applied	\N	\N	\N	\N	95708	95708	95709
21065	30985	85	applied	\N	\N	\N	\N	95714	95714	95715
21065	30987	86	applied	\N	\N	\N	\N	95721	95721	95722
21065	30990	87	applied	\N	\N	\N	\N	95729	95729	95730
21065	30992	88	applied	\N	\N	\N	\N	95737	95737	95738
21065	31018	89	applied	\N	\N	\N	\N	95821	95821	95822
21065	31019	90	applied	\N	\N	\N	\N	95823	95823	95824
21065	31020	91	applied	\N	\N	\N	\N	95825	95825	95826
21065	31021	92	applied	\N	\N	\N	\N	95827	95827	95828
21065	31026	93	applied	\N	\N	\N	\N	95841	95841	95842
21065	30894	94	applied	\N	\N	\N	\N	95485	95485	95486
21065	30993	95	applied	\N	\N	\N	\N	95739	95739	95740
21065	30994	96	applied	\N	\N	\N	\N	95741	95741	95742
21065	31000	97	applied	\N	\N	\N	\N	95755	95755	95756
21065	31002	98	applied	\N	\N	\N	\N	95765	95765	95766
21061	30888	10	applied	\N	\N	1000000000	\N	95470	95470	95471
21061	31084	11	applied	\N	\N	\N	\N	96048	96048	96049
21061	31085	12	applied	\N	\N	\N	\N	96050	96050	96051
21061	31142	13	applied	\N	\N	\N	\N	96220	96220	96221
21061	31143	14	applied	\N	\N	\N	\N	96222	96222	96223
21061	31144	15	applied	\N	\N	\N	\N	96224	96224	96225
21061	31145	16	applied	\N	\N	\N	\N	96226	96226	96227
21061	31086	17	applied	\N	\N	\N	\N	96052	96052	96053
21061	31146	18	applied	\N	\N	\N	\N	96228	96228	96229
21061	30946	19	applied	\N	\N	\N	\N	95617	95617	95618
21061	30900	20	applied	\N	\N	\N	\N	95502	95502	95503
21061	30906	21	applied	\N	\N	\N	\N	95518	95518	95519
21061	30908	22	applied	\N	\N	\N	\N	95524	95524	95525
21061	30909	23	applied	\N	\N	\N	\N	95526	95526	95527
21061	30914	24	applied	\N	\N	\N	\N	95537	95537	95538
21061	31052	25	applied	\N	\N	\N	\N	95918	95918	95919
21061	31053	26	applied	\N	\N	\N	\N	95920	95920	95921
21061	31054	27	applied	\N	\N	\N	\N	95922	95922	95923
21061	31055	28	applied	\N	\N	\N	\N	95924	95924	95925
21061	31018	29	applied	\N	\N	\N	\N	95821	95821	95822
21061	31019	30	applied	\N	\N	\N	\N	95823	95823	95824
21061	31020	31	applied	\N	\N	\N	\N	95825	95825	95826
21061	31021	32	applied	\N	\N	\N	\N	95827	95827	95828
21061	31026	33	applied	\N	\N	\N	\N	95841	95841	95842
21061	30894	34	applied	\N	\N	\N	\N	95485	95485	95486
21061	30868	35	applied	\N	\N	\N	\N	95412	95412	96230
21061	30876	36	applied	\N	\N	\N	\N	95434	95434	95404
21061	30883	37	applied	\N	\N	\N	\N	95450	95450	96231
21061	30890	38	applied	\N	\N	\N	\N	95474	95474	95411
21061	30902	39	applied	\N	\N	\N	\N	95506	95506	95413
21061	30912	40	applied	\N	\N	\N	\N	95532	95532	96232
21061	30919	41	applied	\N	\N	\N	\N	95548	95548	95415
21061	30930	42	applied	\N	\N	\N	\N	95573	95573	96233
21061	30941	43	applied	\N	\N	\N	\N	95599	95599	95423
21061	30950	44	applied	\N	\N	\N	\N	95625	95625	96234
21061	30965	45	applied	\N	\N	\N	\N	95658	95658	95433
21061	30975	46	applied	\N	\N	\N	\N	95682	95682	95435
21061	30979	47	applied	\N	\N	\N	\N	95696	95696	96235
21061	30988	48	applied	\N	\N	\N	\N	95723	95723	95437
21061	30995	49	applied	\N	\N	\N	\N	95743	95743	96236
21061	31004	50	applied	\N	\N	\N	\N	95769	95769	95439
21061	31013	51	applied	\N	\N	\N	\N	95792	95792	96237
21061	31022	52	applied	\N	\N	\N	\N	95829	95829	95449
21061	31030	53	applied	\N	\N	\N	\N	95853	95853	95451
21061	31040	54	applied	\N	\N	\N	\N	95882	95882	96238
21061	31047	55	applied	\N	\N	\N	\N	95903	95903	95453
21061	31064	56	applied	\N	\N	\N	\N	95942	95942	96239
21061	31069	57	applied	\N	\N	\N	\N	95981	95981	95455
21061	31074	58	applied	\N	\N	\N	\N	95999	95999	96240
21061	31081	59	applied	\N	\N	\N	\N	96038	96038	95461
21061	31093	60	applied	\N	\N	\N	\N	96068	96068	95475
21061	31100	61	applied	\N	\N	\N	\N	96089	96089	96241
21061	31105	62	applied	\N	\N	\N	\N	96108	96108	95477
21061	31117	63	applied	\N	\N	\N	\N	96148	96148	96242
21061	31122	64	applied	\N	\N	\N	\N	96164	96164	95488
21061	31128	65	applied	\N	\N	\N	\N	96183	96183	96243
21061	31136	66	applied	\N	\N	\N	\N	96204	96204	95490
21066	31149	0	applied	\N	\N	\N	\N	96260	96260	96261
21066	31150	1	applied	\N	\N	\N	\N	96262	96262	96263
21071	31158	0	applied	\N	\N	\N	\N	96287	96287	96288
21071	31159	1	applied	\N	\N	\N	\N	96289	96289	96290
21071	31160	2	applied	\N	\N	\N	\N	96291	96291	96292
21074	31161	0	applied	\N	\N	\N	\N	96296	96296	96297
21074	31162	1	applied	\N	\N	\N	\N	96298	96298	96299
21076	31161	0	applied	\N	\N	\N	\N	96296	96296	96297
21076	31162	1	applied	\N	\N	\N	\N	96298	96298	96299
21078	31165	0	applied	\N	\N	\N	\N	96307	96307	96308
21078	31166	1	applied	\N	\N	\N	\N	96309	96309	96310
21078	31167	2	applied	\N	\N	\N	\N	96311	96311	96312
21080	31168	0	applied	\N	\N	\N	\N	96317	96317	96318
21080	31169	1	applied	\N	\N	\N	\N	96319	96319	96320
21083	31172	0	applied	\N	\N	\N	\N	96328	96328	96329
21083	31173	1	applied	\N	\N	\N	\N	96330	96330	96331
21083	31174	2	applied	\N	\N	\N	\N	96332	96332	96333
21083	31175	3	applied	\N	\N	\N	\N	96334	96334	96335
21083	31176	5	applied	\N	\N	\N	\N	96337	96337	96338
21090	31177	0	applied	\N	\N	\N	\N	96347	96347	96348
21090	31178	1	applied	\N	\N	\N	\N	96349	96349	96350
21092	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21092	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21092	31142	2	applied	\N	\N	\N	\N	96220	96220	96221
21092	31143	3	applied	\N	\N	\N	\N	96222	96222	96223
21092	31144	4	applied	\N	\N	\N	\N	96224	96224	96225
21092	31145	5	applied	\N	\N	\N	\N	96226	96226	96227
21096	31184	0	applied	\N	\N	\N	\N	96369	96369	96370
21096	31185	1	applied	\N	\N	\N	\N	96371	96371	96372
21096	31186	2	applied	\N	\N	\N	\N	96373	96373	96374
21096	31187	3	applied	\N	\N	\N	\N	96375	96375	96376
21097	31184	0	applied	\N	\N	\N	\N	96369	96369	96370
21097	31185	1	applied	\N	\N	\N	\N	96371	96371	96372
21097	31186	2	applied	\N	\N	\N	\N	96373	96373	96374
21097	31187	3	applied	\N	\N	\N	\N	96375	96375	96376
21099	31188	0	applied	\N	\N	\N	\N	96384	96384	96385
21099	31189	1	applied	\N	\N	\N	\N	96386	96386	96387
21099	31190	2	applied	\N	\N	\N	\N	96388	96388	96389
21103	31192	0	applied	\N	\N	\N	\N	96399	96399	96400
21103	31193	1	applied	\N	\N	\N	\N	96401	96401	96402
21110	31201	0	applied	\N	\N	\N	\N	96426	96426	96427
21112	31202	0	applied	\N	\N	\N	\N	96430	96430	96431
21112	31203	1	applied	\N	\N	\N	\N	96432	96432	96433
21112	31204	2	applied	\N	\N	\N	\N	96434	96434	96435
21133	31231	0	applied	\N	\N	\N	\N	96516	96516	96517
21133	31232	1	applied	\N	\N	\N	\N	96518	96518	96519
21133	31233	2	applied	\N	\N	\N	\N	96520	96520	96521
21134	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21134	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21134	31236	2	applied	\N	\N	\N	\N	96532	96532	96533
21134	31237	3	applied	\N	\N	\N	\N	96534	96534	96535
21140	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21140	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21140	31238	2	applied	\N	\N	\N	\N	96542	96542	96543
21140	31239	3	applied	\N	\N	\N	\N	96544	96544	96545
21140	31236	4	applied	\N	\N	\N	\N	96532	96532	96546
21140	31237	5	applied	\N	\N	\N	\N	96534	96534	96547
21140	31240	6	applied	\N	\N	\N	\N	96548	96548	96549
21145	31247	0	applied	\N	\N	\N	\N	96569	96569	96570
21145	31248	1	applied	\N	\N	\N	\N	96571	96571	96572
21145	31249	2	applied	\N	\N	\N	\N	96573	96573	96574
21146	31250	0	applied	\N	\N	\N	\N	96577	96577	96578
21146	31251	1	applied	\N	\N	\N	\N	96579	96579	96580
21063	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21063	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21063	31140	2	applied	\N	\N	\N	\N	96214	96214	96215
21063	31147	3	applied	\N	\N	\N	\N	96246	96246	96247
21063	31142	4	applied	\N	\N	\N	\N	96220	96220	96221
21063	31143	5	applied	\N	\N	\N	\N	96222	96222	96223
21063	31144	6	applied	\N	\N	\N	\N	96224	96224	96225
21063	31145	7	applied	\N	\N	\N	\N	96226	96226	96227
21063	31141	8	applied	\N	\N	\N	\N	96216	96216	96217
21063	31148	9	applied	\N	\N	\N	\N	96248	96248	96249
21067	31149	0	applied	\N	\N	\N	\N	96260	96260	96261
21067	31151	1	applied	\N	\N	\N	\N	96266	96266	96267
21067	31150	2	applied	\N	\N	\N	\N	96262	96262	96268
21079	31165	0	applied	\N	\N	\N	\N	96307	96307	96308
21079	31166	1	applied	\N	\N	\N	\N	96309	96309	96310
21079	31167	2	applied	\N	\N	\N	\N	96311	96311	96312
21081	31168	0	applied	\N	\N	\N	\N	96317	96317	96318
21081	31169	1	applied	\N	\N	\N	\N	96319	96319	96320
21084	31172	0	applied	\N	\N	\N	\N	96328	96328	96329
21084	31173	1	applied	\N	\N	\N	\N	96330	96330	96331
21084	31174	2	applied	\N	\N	\N	\N	96332	96332	96333
21084	31175	3	applied	\N	\N	\N	\N	96334	96334	96335
21084	31176	5	applied	\N	\N	\N	\N	96337	96337	96338
21093	31184	0	applied	\N	\N	\N	\N	96369	96369	96370
21093	31185	1	applied	\N	\N	\N	\N	96371	96371	96372
21093	31186	2	applied	\N	\N	\N	\N	96373	96373	96374
21093	31187	3	applied	\N	\N	\N	\N	96375	96375	96376
21100	31188	0	applied	\N	\N	\N	\N	96384	96384	96385
21100	31189	1	applied	\N	\N	\N	\N	96386	96386	96387
21100	31190	2	applied	\N	\N	\N	\N	96388	96388	96389
21101	31191	0	applied	\N	\N	\N	\N	96394	96394	96395
21106	31192	0	applied	\N	\N	\N	\N	96399	96399	96400
21106	31194	1	applied	\N	\N	\N	\N	96405	96405	96406
21106	31197	2	applied	\N	\N	\N	\N	96411	96411	96412
21106	31195	3	applied	\N	\N	\N	\N	96407	96407	96413
21106	31193	4	applied	\N	\N	\N	\N	96401	96401	96408
21106	31196	5	applied	\N	\N	\N	\N	96409	96409	96410
21106	31198	6	applied	\N	\N	\N	\N	96414	96414	96415
21108	31197	0	applied	\N	\N	\N	\N	96411	96411	96412
21108	31199	1	applied	\N	\N	\N	\N	96419	96419	96420
21108	31198	2	applied	\N	\N	\N	\N	96414	96414	96415
21108	31200	3	applied	\N	\N	\N	\N	96421	96421	96422
21111	31201	0	applied	\N	\N	\N	\N	96426	96426	96427
21115	31205	0	applied	\N	\N	\N	\N	96441	96441	96442
21115	31206	1	applied	\N	\N	\N	\N	96443	96443	96444
21117	31207	0	applied	\N	\N	\N	\N	96447	96447	96448
21117	31208	1	applied	\N	\N	\N	\N	96449	96449	96450
21120	31216	0	applied	\N	\N	\N	\N	96470	96470	96471
21120	31217	1	applied	\N	\N	\N	\N	96472	96472	96473
21120	31218	2	applied	\N	\N	\N	\N	96474	96474	96475
21123	31225	0	applied	\N	\N	\N	\N	96494	96494	96495
21123	31226	1	applied	\N	\N	\N	\N	96496	96496	96497
21125	31225	0	applied	\N	\N	\N	\N	96494	96494	96495
21125	31226	1	applied	\N	\N	\N	\N	96496	96496	96497
21130	31231	0	applied	\N	\N	\N	\N	96516	96516	96517
21130	31232	1	applied	\N	\N	\N	\N	96518	96518	96519
21130	31233	2	applied	\N	\N	\N	\N	96520	96520	96521
21135	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21135	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21135	31236	2	applied	\N	\N	\N	\N	96532	96532	96533
21135	31237	3	applied	\N	\N	\N	\N	96534	96534	96535
21137	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21137	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21139	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21139	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21139	31236	2	applied	\N	\N	\N	\N	96532	96532	96533
21139	31237	3	applied	\N	\N	\N	\N	96534	96534	96535
21141	31241	0	applied	\N	\N	\N	\N	96551	96551	96552
21141	31242	1	applied	\N	\N	\N	\N	96553	96553	96554
21150	31260	0	applied	\N	\N	\N	\N	96601	96601	96602
21150	31262	1	applied	\N	\N	\N	\N	96605	96605	96606
21150	31263	2	applied	\N	\N	\N	\N	96607	96607	96608
21150	31261	3	applied	\N	\N	\N	\N	96603	96603	96604
21150	31264	4	applied	\N	\N	\N	\N	96609	96609	96610
21150	31265	5	applied	\N	\N	\N	\N	96611	96611	96612
21152	31271	0	applied	\N	\N	\N	\N	96627	96627	96628
21152	31272	1	applied	\N	\N	\N	\N	96629	96629	96630
21155	31273	0	applied	\N	\N	\N	\N	96634	96634	96635
21155	31274	1	applied	\N	\N	\N	\N	96636	96636	96637
21157	31275	0	applied	\N	\N	\N	\N	96640	96640	96641
21157	31276	1	applied	\N	\N	\N	\N	96642	96642	96643
21160	31285	0	applied	\N	\N	\N	\N	96665	96665	96666
21160	31286	1	applied	\N	\N	\N	\N	96667	96667	96668
21165	31289	0	applied	\N	\N	\N	\N	96679	96679	96680
21165	31290	1	applied	\N	\N	\N	\N	96681	96681	96682
21167	31293	0	applied	\N	\N	\N	\N	96692	96692	96693
21167	31294	1	applied	\N	\N	\N	\N	96694	96694	96695
21171	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21171	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21171	31250	2	applied	\N	\N	\N	\N	96577	96577	96578
21171	31142	3	applied	\N	\N	\N	\N	96220	96220	96221
21171	31143	4	applied	\N	\N	\N	\N	96222	96222	96223
21171	31144	5	applied	\N	\N	\N	\N	96224	96224	96225
21171	31145	6	applied	\N	\N	\N	\N	96226	96226	96227
21171	31268	7	applied	\N	\N	\N	\N	96620	96620	92096
21173	31295	0	applied	\N	\N	\N	\N	96702	96702	96703
21173	31296	1	applied	\N	\N	\N	\N	96704	96704	96705
21178	31297	0	applied	\N	\N	\N	\N	96713	96713	96714
21178	31298	1	applied	\N	\N	\N	\N	96715	96715	96716
21178	31299	2	applied	\N	\N	\N	\N	96717	96717	96718
21178	31300	3	applied	\N	\N	\N	\N	96719	96719	96720
21178	31301	4	applied	\N	\N	\N	\N	96721	96721	96722
21180	31302	0	applied	\N	\N	\N	\N	96726	96726	96727
21180	31303	1	applied	\N	\N	\N	\N	96728	96728	96729
21188	31250	0	applied	\N	\N	\N	\N	96577	96577	96578
21188	31077	1	applied	\N	\N	\N	\N	96008	96008	96009
21188	31079	2	applied	\N	\N	\N	\N	96034	96034	96035
21188	31082	3	applied	\N	\N	\N	\N	96044	96044	96045
21188	31083	4	applied	\N	\N	\N	\N	96046	96046	96047
21188	31089	5	applied	\N	\N	\N	\N	96060	96060	96061
21188	31090	6	applied	\N	\N	\N	\N	96062	96062	96063
21188	31094	7	applied	\N	\N	\N	\N	96072	96072	96073
21188	31096	8	applied	\N	\N	\N	\N	96081	96081	96082
21188	31097	9	applied	\N	\N	\N	\N	96083	96083	96084
21188	31098	10	applied	\N	\N	\N	\N	96085	96085	96086
21188	31102	11	applied	\N	\N	\N	\N	96099	96099	96100
21188	31104	12	applied	\N	\N	\N	\N	96106	96106	96107
21188	31107	13	applied	\N	\N	\N	\N	96116	96116	96117
21188	31109	14	applied	\N	\N	\N	\N	96125	96125	96126
21188	31110	15	applied	\N	\N	\N	\N	96129	96129	96130
21065	31003	99	applied	\N	\N	\N	\N	95767	95767	95768
21065	31006	100	applied	\N	\N	\N	\N	95775	95775	95776
21065	31009	101	applied	\N	\N	\N	\N	95784	95784	95785
21065	31010	102	applied	\N	\N	\N	\N	95786	95786	95787
21065	31014	103	applied	\N	\N	\N	\N	95796	95796	95797
21065	31016	104	applied	\N	\N	\N	\N	95810	95810	95811
21065	31024	105	applied	\N	\N	\N	\N	95835	95835	95836
21065	31027	106	applied	\N	\N	\N	\N	95843	95843	95844
21065	31029	107	applied	\N	\N	\N	\N	95851	95851	95852
21065	31032	108	applied	\N	\N	\N	\N	95861	95861	95862
21065	31034	109	applied	\N	\N	\N	\N	95866	95866	95867
21065	31036	110	applied	\N	\N	\N	\N	95872	95872	95873
21065	31038	111	applied	\N	\N	\N	\N	95878	95878	95879
21065	31041	112	applied	\N	\N	\N	\N	95884	95884	95885
21065	31043	113	applied	\N	\N	\N	\N	95892	95892	95893
21065	31045	114	applied	\N	\N	\N	\N	95899	95899	95900
21065	31048	115	applied	\N	\N	\N	\N	95906	95906	95907
21065	31049	116	applied	\N	\N	\N	\N	95908	95908	95909
21065	31056	117	applied	\N	\N	\N	\N	95926	95926	95927
21065	31057	118	applied	\N	\N	\N	\N	95928	95928	95929
21065	31058	119	applied	\N	\N	\N	\N	95930	95930	95931
21065	31059	120	applied	\N	\N	\N	\N	95932	95932	95933
21065	31065	121	applied	\N	\N	\N	\N	95973	95973	95974
21065	31066	122	applied	\N	\N	\N	\N	95975	95975	95976
21065	31070	123	applied	\N	\N	\N	\N	95985	95985	95986
21065	31072	124	applied	\N	\N	\N	\N	95995	95995	95996
21065	31073	125	applied	\N	\N	\N	\N	95997	95997	95998
21068	31149	0	applied	\N	\N	\N	\N	96260	96260	96261
21068	31151	1	applied	\N	\N	\N	\N	96266	96266	96267
21068	31150	2	applied	\N	\N	\N	\N	96262	96262	96268
21070	31152	0	applied	\N	\N	\N	\N	96273	96273	96274
21070	31153	1	applied	\N	\N	\N	\N	96275	96275	96276
21070	31154	2	applied	\N	\N	\N	\N	96277	96277	96278
21070	31155	3	applied	\N	\N	\N	\N	96279	96279	96280
21070	31156	4	applied	\N	\N	\N	\N	96281	96281	96282
21070	31157	5	applied	\N	\N	\N	\N	96283	96283	96284
21072	31158	0	applied	\N	\N	\N	\N	96287	96287	96288
21072	31159	1	applied	\N	\N	\N	\N	96289	96289	96290
21072	31160	2	applied	\N	\N	\N	\N	96291	96291	96292
21075	31161	0	applied	\N	\N	\N	\N	96296	96296	96297
21075	31162	1	applied	\N	\N	\N	\N	96298	96298	96299
21085	31172	0	applied	\N	\N	\N	\N	96328	96328	96329
21085	31173	1	applied	\N	\N	\N	\N	96330	96330	96331
21085	31174	2	applied	\N	\N	\N	\N	96332	96332	96333
21085	31175	3	applied	\N	\N	\N	\N	96334	96334	96335
21085	31176	5	applied	\N	\N	\N	\N	96337	96337	96338
21086	31177	0	applied	\N	\N	\N	\N	96347	96347	96348
21086	31178	1	applied	\N	\N	\N	\N	96349	96349	96350
21088	31177	0	applied	\N	\N	\N	\N	96347	96347	96348
21088	31178	1	applied	\N	\N	\N	\N	96349	96349	96350
21094	31184	0	applied	\N	\N	\N	\N	96369	96369	96370
21094	31185	1	applied	\N	\N	\N	\N	96371	96371	96372
21094	31186	2	applied	\N	\N	\N	\N	96373	96373	96374
21094	31187	3	applied	\N	\N	\N	\N	96375	96375	96376
21104	31194	0	applied	\N	\N	\N	\N	96405	96405	96406
21104	31195	1	applied	\N	\N	\N	\N	96407	96407	96408
21104	31196	2	applied	\N	\N	\N	\N	96409	96409	96410
21109	31197	0	applied	\N	\N	\N	\N	96411	96411	96412
21109	31199	1	applied	\N	\N	\N	\N	96419	96419	96420
21109	31198	2	applied	\N	\N	\N	\N	96414	96414	96415
21109	31200	3	applied	\N	\N	\N	\N	96421	96421	96422
21113	31202	0	applied	\N	\N	\N	\N	96430	96430	96431
21113	31203	1	applied	\N	\N	\N	\N	96432	96432	96433
21113	31204	2	applied	\N	\N	\N	\N	96434	96434	96435
21116	31205	0	applied	\N	\N	\N	\N	96441	96441	96442
21116	31206	1	applied	\N	\N	\N	\N	96443	96443	96444
21118	31209	0	applied	\N	\N	\N	\N	96453	96453	96454
21118	31210	1	applied	\N	\N	\N	\N	96455	96455	96456
21118	31211	2	applied	\N	\N	\N	\N	96457	96457	96458
21124	31227	0	applied	\N	\N	\N	\N	96500	96500	96501
21124	31225	1	applied	\N	\N	\N	\N	96494	96494	96495
21124	31226	2	applied	\N	\N	\N	\N	96496	96496	96497
21126	31227	0	applied	\N	\N	\N	\N	96500	96500	96501
21126	31228	1	applied	\N	\N	\N	\N	96506	96506	96507
21128	31229	0	applied	\N	\N	\N	\N	96508	96508	96509
21128	31230	1	applied	\N	\N	\N	\N	96510	96510	96511
21131	31231	0	applied	\N	\N	\N	\N	96516	96516	96517
21131	31232	1	applied	\N	\N	\N	\N	96518	96518	96519
21131	31233	2	applied	\N	\N	\N	\N	96520	96520	96521
21142	31241	0	applied	\N	\N	\N	\N	96551	96551	96552
21142	31242	1	applied	\N	\N	\N	\N	96553	96553	96554
21144	31243	0	applied	\N	\N	\N	\N	96559	96559	96560
21144	31244	1	applied	\N	\N	\N	\N	96561	96561	96562
21144	31245	2	applied	\N	\N	\N	\N	96563	96563	96564
21144	31246	3	applied	\N	\N	\N	\N	96565	96565	96566
21148	31260	0	applied	\N	\N	\N	\N	96601	96601	96602
21148	31261	1	applied	\N	\N	\N	\N	96603	96603	96604
21153	31271	0	applied	\N	\N	\N	\N	96627	96627	96628
21153	31272	1	applied	\N	\N	\N	\N	96629	96629	96630
21161	31285	0	applied	\N	\N	\N	\N	96665	96665	96666
21161	31286	1	applied	\N	\N	\N	\N	96667	96667	96668
21168	31293	0	applied	\N	\N	\N	\N	96692	96692	96693
21168	31294	1	applied	\N	\N	\N	\N	96694	96694	96695
21169	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21169	30942	1	applied	\N	\N	1000000000	\N	95607	95607	95608
21169	30933	2	applied	\N	\N	\N	\N	95816	95816	95584
21169	30934	3	applied	\N	\N	\N	\N	95818	95818	95586
21169	30952	4	applied	\N	\N	1000000000	\N	95629	95629	95630
21169	30999	5	applied	\N	\N	\N	\N	95779	95779	95754
21169	30935	6	applied	\N	\N	\N	\N	96254	96254	95588
21169	30936	7	applied	\N	\N	\N	\N	96255	96255	95590
21169	31008	8	applied	\N	\N	\N	\N	96256	96256	95781
21169	31139	9	applied	\N	\N	\N	\N	96212	96212	96213
21169	31250	10	applied	\N	\N	\N	\N	96577	96577	96578
21169	30888	11	applied	\N	\N	1000000000	\N	95470	95470	95471
21169	31084	12	applied	\N	\N	\N	\N	96048	96048	96049
21169	31085	13	applied	\N	\N	\N	\N	96050	96050	96051
21169	30835	14	applied	\N	\N	\N	\N	95290	95290	95291
21169	31142	15	applied	\N	\N	\N	\N	96220	96220	96221
21169	31143	16	applied	\N	\N	\N	\N	96222	96222	96223
21169	31144	17	applied	\N	\N	\N	\N	96224	96224	96225
21169	31145	18	applied	\N	\N	\N	\N	96226	96226	96227
21169	31086	19	applied	\N	\N	\N	\N	96052	96052	96053
21169	31146	20	applied	\N	\N	\N	\N	96228	96228	96229
21169	30838	21	applied	\N	\N	\N	\N	95298	95298	95299
21169	30946	22	applied	\N	\N	\N	\N	95617	95617	95618
21169	30900	23	applied	\N	\N	\N	\N	95502	95502	95503
21169	30906	24	applied	\N	\N	\N	\N	95518	95518	95519
21169	30908	25	applied	\N	\N	\N	\N	95524	95524	95525
21121	31218	2	applied	\N	\N	\N	\N	96474	96474	96475
21122	31219	0	applied	\N	\N	\N	\N	96480	96480	96481
21122	31220	1	applied	\N	\N	\N	\N	96482	96482	96483
21122	31221	2	applied	\N	\N	\N	\N	96484	96484	96485
21122	31222	3	applied	\N	\N	\N	\N	96486	96486	96487
21122	31223	4	applied	\N	\N	\N	\N	96488	96488	96489
21122	31224	5	applied	\N	\N	\N	\N	96490	96490	96491
21127	31227	0	applied	\N	\N	\N	\N	96500	96500	96501
21127	31228	1	applied	\N	\N	\N	\N	96506	96506	96507
21129	31229	0	applied	\N	\N	\N	\N	96508	96508	96509
21129	31230	1	applied	\N	\N	\N	\N	96510	96510	96511
21132	31231	0	applied	\N	\N	\N	\N	96516	96516	96517
21132	31232	1	applied	\N	\N	\N	\N	96518	96518	96519
21132	31233	2	applied	\N	\N	\N	\N	96520	96520	96521
21138	31234	0	applied	\N	\N	\N	\N	96528	96528	96529
21138	31235	1	applied	\N	\N	\N	\N	96530	96530	96531
21138	31236	2	applied	\N	\N	\N	\N	96532	96532	96533
21138	31237	3	applied	\N	\N	\N	\N	96534	96534	96535
21143	31241	0	applied	\N	\N	\N	\N	96551	96551	96552
21143	31242	1	applied	\N	\N	\N	\N	96553	96553	96554
21151	31266	0	applied	\N	\N	\N	\N	96616	96616	96617
21151	31267	1	applied	\N	\N	\N	\N	96618	96618	96619
21151	31268	2	applied	\N	\N	\N	\N	96620	96620	92096
21151	31269	3	applied	\N	\N	\N	\N	96621	96621	96622
21151	31270	4	applied	\N	\N	\N	\N	96623	96623	96624
21158	31277	0	applied	\N	\N	\N	\N	96645	96645	96646
21158	31278	1	applied	\N	\N	\N	\N	96647	96647	96648
21162	31285	0	applied	\N	\N	\N	\N	96665	96665	96666
21162	31286	1	applied	\N	\N	\N	\N	96667	96667	96668
21163	31287	0	applied	\N	\N	\N	\N	96673	96673	96674
21163	31288	1	applied	\N	\N	\N	\N	96675	96675	96676
21175	31295	0	applied	\N	\N	\N	\N	96702	96702	96703
21175	31296	1	applied	\N	\N	\N	\N	96704	96704	96705
21177	31297	0	applied	\N	\N	\N	\N	96713	96713	96714
21177	31298	1	applied	\N	\N	\N	\N	96715	96715	96716
21177	31299	2	applied	\N	\N	\N	\N	96717	96717	96718
21177	31300	3	applied	\N	\N	\N	\N	96719	96719	96720
21177	31301	4	applied	\N	\N	\N	\N	96721	96721	96722
21181	31304	0	applied	\N	\N	\N	\N	96732	96732	96733
21181	31305	1	applied	\N	\N	\N	\N	96734	96734	96735
21181	31306	2	applied	\N	\N	\N	\N	96736	96736	96737
21181	31307	3	applied	\N	\N	\N	\N	96738	96738	96739
21184	31310	0	applied	\N	\N	\N	\N	96747	96747	96748
21184	31311	1	applied	\N	\N	\N	\N	96749	96749	96750
21184	31312	2	applied	\N	\N	\N	\N	96751	96751	96752
21184	31313	3	applied	\N	\N	\N	\N	96753	96753	96754
21184	31314	4	applied	\N	\N	\N	\N	96755	96755	96756
21184	31315	5	applied	\N	\N	\N	\N	96757	96757	96758
21187	31316	0	applied	\N	\N	\N	\N	96762	96762	96763
21187	31317	1	applied	\N	\N	\N	\N	96764	96764	96765
21189	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21189	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21189	31250	2	applied	\N	\N	\N	\N	96577	96577	96578
21189	31084	3	applied	\N	\N	\N	\N	96048	96048	96049
21189	31085	4	applied	\N	\N	\N	\N	96050	96050	96051
21189	31142	5	applied	\N	\N	\N	\N	96220	96220	96221
21189	31143	6	applied	\N	\N	\N	\N	96222	96222	96223
21189	31144	7	applied	\N	\N	\N	\N	96224	96224	96225
21189	31145	8	applied	\N	\N	\N	\N	96226	96226	96227
21189	31086	9	applied	\N	\N	\N	\N	96052	96052	96053
21189	31146	10	applied	\N	\N	\N	\N	96228	96228	96229
21189	31043	11	applied	\N	\N	\N	\N	95892	95892	95893
21189	31052	12	applied	\N	\N	\N	\N	95918	95918	95919
21189	31053	13	applied	\N	\N	\N	\N	95920	95920	95921
21189	31054	14	applied	\N	\N	\N	\N	95922	95922	95923
21189	31055	15	applied	\N	\N	\N	\N	95924	95924	95925
21189	31045	16	applied	\N	\N	\N	\N	95899	95899	95900
21189	31048	17	applied	\N	\N	\N	\N	95906	95906	95907
21189	31049	18	applied	\N	\N	\N	\N	95908	95908	95909
21189	31056	19	applied	\N	\N	\N	\N	95926	95926	95927
21189	31057	20	applied	\N	\N	\N	\N	95928	95928	95929
21189	31058	21	applied	\N	\N	\N	\N	95930	95930	95931
21189	31059	22	applied	\N	\N	\N	\N	95932	95932	95933
21189	31065	23	applied	\N	\N	\N	\N	95973	95973	95974
21189	31066	24	applied	\N	\N	\N	\N	95975	95975	95976
21189	31070	25	applied	\N	\N	\N	\N	95985	95985	95986
21189	31072	26	applied	\N	\N	\N	\N	95995	95995	95996
21189	31073	27	applied	\N	\N	\N	\N	95997	95997	95998
21189	31077	28	applied	\N	\N	\N	\N	96008	96008	96009
21189	31079	29	applied	\N	\N	\N	\N	96034	96034	96035
21189	31082	30	applied	\N	\N	\N	\N	96044	96044	96045
21189	31083	31	applied	\N	\N	\N	\N	96046	96046	96047
21189	31089	32	applied	\N	\N	\N	\N	96060	96060	96061
21189	31090	33	applied	\N	\N	\N	\N	96062	96062	96063
21189	31094	34	applied	\N	\N	\N	\N	96072	96072	96073
21189	31096	35	applied	\N	\N	\N	\N	96081	96081	96082
21189	31097	36	applied	\N	\N	\N	\N	96083	96083	96084
21189	31098	37	applied	\N	\N	\N	\N	96085	96085	96086
21189	31102	38	applied	\N	\N	\N	\N	96099	96099	96100
21189	31104	39	applied	\N	\N	\N	\N	96106	96106	96107
21189	31107	40	applied	\N	\N	\N	\N	96116	96116	96117
21189	31109	41	applied	\N	\N	\N	\N	96125	96125	96126
21189	31110	42	applied	\N	\N	\N	\N	96129	96129	96130
21189	31113	43	applied	\N	\N	\N	\N	96140	96140	96141
21189	31114	44	applied	\N	\N	\N	\N	96142	96142	96143
21189	31118	45	applied	\N	\N	\N	\N	96152	96152	96153
21189	31120	46	applied	\N	\N	\N	\N	96160	96160	96161
21189	31123	47	applied	\N	\N	\N	\N	96170	96170	96171
21189	31125	48	applied	\N	\N	\N	\N	96177	96177	96178
21189	31126	49	applied	\N	\N	\N	\N	96179	96179	96180
21189	31129	50	applied	\N	\N	\N	\N	96188	96188	96189
21189	31131	51	applied	\N	\N	\N	\N	96192	96192	96193
21189	31133	52	applied	\N	\N	\N	\N	96198	96198	96199
21189	31134	53	applied	\N	\N	\N	\N	96200	96200	96201
21189	31140	54	applied	\N	\N	\N	\N	96214	96214	96215
21189	31147	55	applied	\N	\N	\N	\N	96246	96246	96247
21189	31149	56	applied	\N	\N	\N	\N	96260	96260	96261
21189	31152	57	applied	\N	\N	\N	\N	96273	96273	96274
21189	31153	58	applied	\N	\N	\N	\N	96275	96275	96276
21189	31154	59	applied	\N	\N	\N	\N	96277	96277	96278
21189	31158	60	applied	\N	\N	\N	\N	96287	96287	96288
21189	31161	61	applied	\N	\N	\N	\N	96296	96296	96297
21189	31163	62	applied	\N	\N	\N	\N	96303	96303	96304
21189	31165	63	applied	\N	\N	\N	\N	96307	96307	96308
21189	31168	64	applied	\N	\N	\N	\N	96317	96317	96318
21189	31170	65	applied	\N	\N	\N	\N	96322	96322	96323
21189	31172	66	applied	\N	\N	\N	\N	96328	96328	96329
21189	31173	67	applied	\N	\N	\N	\N	96330	96330	96331
21189	31177	68	applied	\N	\N	\N	\N	96347	96347	96348
21189	31179	69	applied	\N	\N	\N	\N	96355	96355	96356
21146	31252	3	applied	\N	\N	\N	\N	96582	96582	96583
21146	31253	4	applied	\N	\N	\N	\N	96584	96584	96585
21146	31254	5	applied	\N	\N	\N	\N	96586	96586	96587
21146	31255	6	applied	\N	\N	\N	\N	96588	96588	96589
21146	31256	7	applied	\N	\N	\N	\N	96590	96590	96591
21146	31257	8	applied	\N	\N	\N	\N	96592	96592	96593
21146	31258	9	applied	\N	\N	\N	\N	96594	96594	96595
21146	31259	10	applied	\N	\N	\N	\N	96596	96596	96597
21149	31260	0	applied	\N	\N	\N	\N	96601	96601	96602
21149	31262	1	applied	\N	\N	\N	\N	96605	96605	96606
21149	31263	2	applied	\N	\N	\N	\N	96607	96607	96608
21149	31261	3	applied	\N	\N	\N	\N	96603	96603	96604
21149	31264	4	applied	\N	\N	\N	\N	96609	96609	96610
21149	31265	5	applied	\N	\N	\N	\N	96611	96611	96612
21154	31273	0	applied	\N	\N	\N	\N	96634	96634	96635
21154	31274	1	applied	\N	\N	\N	\N	96636	96636	96637
21156	31275	0	applied	\N	\N	\N	\N	96640	96640	96641
21156	31276	1	applied	\N	\N	\N	\N	96642	96642	96643
21159	31279	0	applied	\N	\N	\N	\N	96651	96651	96652
21159	31280	1	applied	\N	\N	\N	\N	96653	96653	96654
21159	31281	2	applied	\N	\N	\N	\N	96655	96655	96656
21159	31282	3	applied	\N	\N	\N	\N	96657	96657	96658
21159	31283	4	applied	\N	\N	\N	\N	96659	96659	96660
21159	31284	5	applied	\N	\N	\N	\N	96661	96661	96662
21164	31289	0	applied	\N	\N	\N	\N	96679	96679	96680
21164	31290	1	applied	\N	\N	\N	\N	96681	96681	96682
21166	31291	0	applied	\N	\N	\N	\N	96687	96687	96688
21166	31292	1	applied	\N	\N	\N	\N	96689	96689	96690
21170	31295	0	applied	\N	\N	\N	\N	96702	96702	96703
21170	31296	1	applied	\N	\N	\N	\N	96704	96704	96705
21179	31302	0	applied	\N	\N	\N	\N	96726	96726	96727
21179	31303	1	applied	\N	\N	\N	\N	96728	96728	96729
21182	31308	0	applied	\N	\N	\N	\N	96741	96741	96742
21182	31309	1	applied	\N	\N	\N	\N	96743	96743	96744
21185	31310	0	applied	\N	\N	\N	\N	96747	96747	96748
21185	31311	1	applied	\N	\N	\N	\N	96749	96749	96750
21185	31312	2	applied	\N	\N	\N	\N	96751	96751	96752
21185	31313	3	applied	\N	\N	\N	\N	96753	96753	96754
21185	31314	4	applied	\N	\N	\N	\N	96755	96755	96756
21185	31315	5	applied	\N	\N	\N	\N	96757	96757	96758
21190	31318	0	applied	\N	\N	\N	\N	96769	96769	96770
21190	31319	1	applied	\N	\N	\N	\N	96776	96776	96777
21190	31320	2	applied	\N	\N	\N	\N	96778	96778	96779
21190	31321	3	applied	\N	\N	\N	\N	96780	96780	96781
21190	31322	4	applied	\N	\N	\N	\N	96782	96782	96783
21190	31323	5	applied	\N	\N	\N	\N	96784	96784	96785
21190	31324	6	applied	\N	\N	\N	\N	96786	96786	96787
21190	31325	7	applied	\N	\N	\N	\N	96788	96788	96789
21192	31326	0	applied	\N	\N	\N	\N	96794	96794	96795
21192	31327	1	applied	\N	\N	\N	\N	96796	96796	96797
21192	31328	2	applied	\N	\N	\N	\N	96798	96798	96799
21197	31331	0	applied	\N	\N	\N	\N	96807	96807	96808
21197	31332	2	applied	\N	\N	\N	\N	96810	96810	96811
21203	31345	0	applied	\N	\N	\N	\N	96846	96846	96847
21203	31346	1	applied	\N	\N	\N	\N	96848	96848	96849
21203	31347	2	applied	\N	\N	\N	\N	96850	96850	96851
21203	31348	3	applied	\N	\N	\N	\N	96852	96852	96853
21203	31349	4	applied	\N	\N	\N	\N	96854	96854	96855
21203	31350	5	applied	\N	\N	\N	\N	96856	96856	96857
21209	31355	0	applied	\N	\N	\N	\N	96875	96875	96876
21209	31356	1	applied	\N	\N	\N	\N	96877	96877	96878
21211	31359	0	applied	\N	\N	\N	\N	96888	96888	96889
21211	31360	1	applied	\N	\N	\N	\N	96890	96890	96891
21218	31365	0	applied	\N	\N	\N	\N	96908	96908	96909
21218	31366	1	applied	\N	\N	\N	\N	96910	96910	96911
21218	31367	2	applied	\N	\N	\N	\N	96912	96912	96913
21218	31368	3	applied	\N	\N	\N	\N	96914	96914	96915
21221	31369	0	applied	\N	\N	\N	\N	96919	96919	96920
21221	31370	1	applied	\N	\N	\N	\N	96921	96921	96922
21221	31371	2	applied	\N	\N	\N	\N	96923	96923	96924
21221	31372	3	applied	\N	\N	\N	\N	96925	96925	96926
21221	31373	4	applied	\N	\N	\N	\N	96927	96927	96928
21221	31374	5	applied	\N	\N	\N	\N	96929	96929	96930
21224	31377	0	applied	\N	\N	\N	\N	96937	96937	96938
21224	31378	1	applied	\N	\N	\N	\N	96939	96939	96940
21226	31381	0	applied	\N	\N	\N	\N	96949	96949	96950
21226	31382	1	applied	\N	\N	\N	\N	96951	96951	96952
21226	31383	2	applied	\N	\N	\N	\N	96953	96953	96954
21226	31384	3	applied	\N	\N	\N	\N	96955	96955	96956
21234	31396	0	applied	\N	\N	\N	\N	96994	96994	96995
21234	31397	1	applied	\N	\N	\N	\N	96996	96996	96997
21236	31398	0	applied	\N	\N	\N	\N	97002	97002	97003
21236	31399	1	applied	\N	\N	\N	\N	97004	97004	97005
21241	31410	0	applied	\N	\N	\N	\N	97037	97037	97038
21241	31411	2	applied	\N	\N	\N	\N	97040	97040	97041
21246	31412	0	applied	\N	\N	\N	\N	97050	97050	97051
21246	31413	1	applied	\N	\N	\N	\N	97052	97052	97053
21248	31416	0	applied	\N	\N	\N	\N	97059	97059	97060
21248	31417	1	applied	\N	\N	\N	\N	97061	97061	97062
21248	31418	2	applied	\N	\N	\N	\N	97063	97063	97064
21248	31419	3	applied	\N	\N	\N	\N	97065	97065	97066
21248	31420	4	applied	\N	\N	\N	\N	97067	97067	97068
21248	31421	5	applied	\N	\N	\N	\N	97069	97069	97070
21255	31431	0	applied	\N	\N	\N	\N	97101	97101	97102
21255	31432	1	applied	\N	\N	\N	\N	97103	97103	97104
21257	31433	0	applied	\N	\N	\N	\N	97107	97107	97108
21257	31434	1	applied	\N	\N	\N	\N	97109	97109	97110
21260	31439	0	applied	\N	\N	\N	\N	97123	97123	97124
21260	31440	1	applied	\N	\N	\N	\N	97125	97125	97126
21261	31441	0	applied	\N	\N	\N	\N	97129	97129	97130
21261	31442	1	applied	\N	\N	\N	\N	97131	97131	97132
21261	31443	2	applied	\N	\N	\N	\N	97133	97133	97134
21261	31444	3	applied	\N	\N	\N	\N	97135	97135	97136
21261	31445	4	applied	\N	\N	\N	\N	97137	97137	97138
21261	31446	5	applied	\N	\N	\N	\N	97139	97139	97140
21261	31447	6	applied	\N	\N	\N	\N	97141	97141	97142
21261	31448	7	applied	\N	\N	\N	\N	97143	97143	97144
21273	31464	0	applied	\N	\N	\N	\N	97188	97188	97189
21273	31465	1	applied	\N	\N	\N	\N	97190	97190	97191
21282	31497	0	applied	\N	\N	\N	\N	97280	97280	97281
21282	31498	1	applied	\N	\N	\N	\N	97282	97282	97283
21282	31499	2	applied	\N	\N	\N	\N	97284	97284	97285
21282	31500	3	applied	\N	\N	\N	\N	97286	97286	97287
21282	31501	4	applied	\N	\N	\N	\N	97288	97288	97289
21282	31502	6	applied	\N	\N	\N	\N	97291	97291	97292
21287	31513	0	applied	\N	\N	\N	\N	97324	97324	97325
21287	31514	1	applied	\N	\N	\N	\N	97326	97326	97327
21287	31515	2	applied	\N	\N	\N	\N	97328	97328	97329
21290	31520	0	applied	\N	\N	\N	\N	97342	97342	97343
21290	31521	1	applied	\N	\N	\N	\N	97344	97344	97345
21169	30909	26	applied	\N	\N	\N	\N	95526	95526	95527
21169	30914	27	applied	\N	\N	\N	\N	95537	95537	95538
21169	31052	28	applied	\N	\N	\N	\N	95918	95918	95919
21169	31053	29	applied	\N	\N	\N	\N	95920	95920	95921
21169	31054	30	applied	\N	\N	\N	\N	95922	95922	95923
21169	31055	31	applied	\N	\N	\N	\N	95924	95924	95925
21169	30842	32	applied	\N	\N	\N	\N	95329	95329	93688
21169	30840	33	applied	\N	\N	\N	\N	95323	95323	95324
21169	30841	34	applied	\N	\N	\N	\N	95327	95327	95328
21169	30845	35	applied	\N	\N	\N	\N	95339	95339	95340
21169	30847	36	applied	\N	\N	\N	\N	95346	95346	95347
21169	30849	37	applied	\N	\N	\N	\N	95356	95356	95357
21169	30851	38	applied	\N	\N	\N	\N	95361	95361	95362
21169	30854	39	applied	\N	\N	\N	\N	95371	95371	95372
21169	30856	40	applied	\N	\N	\N	\N	95377	95377	95378
21169	30858	41	applied	\N	\N	\N	\N	95382	95382	95383
21169	30861	42	applied	\N	\N	\N	\N	95391	95391	95392
21169	30863	43	applied	\N	\N	\N	\N	95401	95401	95402
21169	30865	44	applied	\N	\N	\N	\N	95406	95406	95407
21169	30866	45	applied	\N	\N	\N	\N	95408	95408	95409
21169	30870	46	applied	\N	\N	\N	\N	95420	95420	95421
21169	30872	47	applied	\N	\N	\N	\N	95426	95426	95427
21169	30873	48	applied	\N	\N	\N	\N	95428	95428	95429
21169	30874	49	applied	\N	\N	\N	\N	95430	95430	95431
21169	30879	50	applied	\N	\N	\N	\N	95442	95442	95443
21169	30880	51	applied	\N	\N	\N	\N	95444	95444	95445
21169	30881	52	applied	\N	\N	\N	\N	95446	95446	95447
21169	30886	53	applied	\N	\N	\N	\N	95458	95458	95459
21169	30889	54	applied	\N	\N	\N	\N	95472	95472	95473
21169	30892	55	applied	\N	\N	\N	\N	95481	95481	95482
21169	30893	56	applied	\N	\N	\N	\N	95483	95483	95484
21169	30897	57	applied	\N	\N	\N	\N	95495	95495	95496
21169	30899	58	applied	\N	\N	\N	\N	95500	95500	95501
21169	30903	59	applied	\N	\N	\N	\N	95510	95510	95511
21169	30905	60	applied	\N	\N	\N	\N	95516	95516	95517
21169	30910	61	applied	\N	\N	\N	\N	95528	95528	95529
21169	30913	62	applied	\N	\N	\N	\N	95535	95535	95536
21169	30916	63	applied	\N	\N	\N	\N	95542	95542	95543
21169	30918	64	applied	\N	\N	\N	\N	95546	95546	95547
21169	30921	65	applied	\N	\N	\N	\N	95554	95554	95555
21169	30923	66	applied	\N	\N	\N	\N	95559	95559	95560
21169	30924	67	applied	\N	\N	\N	\N	95561	95561	95562
21169	30925	68	applied	\N	\N	\N	\N	95563	95563	95564
21169	30931	69	applied	\N	\N	\N	\N	95577	95577	95578
21169	30937	70	applied	\N	\N	\N	\N	95591	95591	95592
21169	30938	71	applied	\N	\N	\N	\N	95593	95593	95594
21169	30943	73	applied	\N	\N	\N	\N	95609	95609	95610
21169	30945	74	applied	\N	\N	\N	\N	95615	95615	95616
21169	30947	75	applied	\N	\N	\N	\N	95619	95619	95620
21169	30953	76	applied	\N	\N	\N	\N	95631	95631	95632
21169	30955	77	applied	\N	\N	\N	\N	95636	95636	95637
21169	30959	78	applied	\N	\N	\N	\N	95646	95646	95647
21169	30964	79	applied	\N	\N	\N	\N	95656	95656	95657
21169	30967	80	applied	\N	\N	\N	\N	95664	95664	95665
21169	30968	81	applied	\N	\N	\N	\N	95666	95666	95667
21169	30971	82	applied	\N	\N	\N	\N	95674	95674	95675
21169	30972	83	applied	\N	\N	\N	\N	95676	95676	95677
21169	30973	84	applied	\N	\N	\N	\N	95678	95678	95679
21169	30978	85	applied	\N	\N	\N	\N	95694	95694	95695
21169	30981	86	applied	\N	\N	\N	\N	95701	95701	95702
21169	30983	87	applied	\N	\N	\N	\N	95708	95708	95709
21169	30985	88	applied	\N	\N	\N	\N	95714	95714	95715
21169	30987	89	applied	\N	\N	\N	\N	95721	95721	95722
21169	30990	90	applied	\N	\N	\N	\N	95729	95729	95730
21169	30992	91	applied	\N	\N	\N	\N	95737	95737	95738
21169	31018	92	applied	\N	\N	\N	\N	95821	95821	95822
21169	31019	93	applied	\N	\N	\N	\N	95823	95823	95824
21169	31020	94	applied	\N	\N	\N	\N	95825	95825	95826
21169	31021	95	applied	\N	\N	\N	\N	95827	95827	95828
21169	31026	96	applied	\N	\N	\N	\N	95841	95841	95842
21169	30894	97	applied	\N	\N	\N	\N	95485	95485	95486
21169	30993	98	applied	\N	\N	\N	\N	95739	95739	95740
21169	30994	99	applied	\N	\N	\N	\N	95741	95741	95742
21169	31000	100	applied	\N	\N	\N	\N	95755	95755	95756
21169	31002	101	applied	\N	\N	\N	\N	95765	95765	95766
21169	31003	102	applied	\N	\N	\N	\N	95767	95767	95768
21169	31006	103	applied	\N	\N	\N	\N	95775	95775	95776
21169	31009	104	applied	\N	\N	\N	\N	95784	95784	95785
21169	31010	105	applied	\N	\N	\N	\N	95786	95786	95787
21169	31014	106	applied	\N	\N	\N	\N	95796	95796	95797
21169	31016	107	applied	\N	\N	\N	\N	95810	95810	95811
21169	31024	108	applied	\N	\N	\N	\N	95835	95835	95836
21169	31027	109	applied	\N	\N	\N	\N	95843	95843	95844
21169	31029	110	applied	\N	\N	\N	\N	95851	95851	95852
21169	31032	111	applied	\N	\N	\N	\N	95861	95861	95862
21169	31034	112	applied	\N	\N	\N	\N	95866	95866	95867
21169	31036	113	applied	\N	\N	\N	\N	95872	95872	95873
21169	31038	114	applied	\N	\N	\N	\N	95878	95878	95879
21169	31041	115	applied	\N	\N	\N	\N	95884	95884	95885
21169	31043	116	applied	\N	\N	\N	\N	95892	95892	95893
21169	31045	117	applied	\N	\N	\N	\N	95899	95899	95900
21169	31048	118	applied	\N	\N	\N	\N	95906	95906	95907
21169	31049	119	applied	\N	\N	\N	\N	95908	95908	95909
21169	31056	120	applied	\N	\N	\N	\N	95926	95926	95927
21169	31057	121	applied	\N	\N	\N	\N	95928	95928	95929
21169	31058	122	applied	\N	\N	\N	\N	95930	95930	95931
21169	31059	123	applied	\N	\N	\N	\N	95932	95932	95933
21169	31065	124	applied	\N	\N	\N	\N	95973	95973	95974
21169	31066	125	applied	\N	\N	\N	\N	95975	95975	95976
21172	31295	0	applied	\N	\N	\N	\N	96702	96702	96703
21172	31296	1	applied	\N	\N	\N	\N	96704	96704	96705
21174	31295	0	applied	\N	\N	\N	\N	96702	96702	96703
21174	31296	1	applied	\N	\N	\N	\N	96704	96704	96705
21176	31297	0	applied	\N	\N	\N	\N	96713	96713	96714
21176	31298	1	applied	\N	\N	\N	\N	96715	96715	96716
21176	31299	2	applied	\N	\N	\N	\N	96717	96717	96718
21176	31300	3	applied	\N	\N	\N	\N	96719	96719	96720
21176	31301	4	applied	\N	\N	\N	\N	96721	96721	96722
21183	31308	0	applied	\N	\N	\N	\N	96741	96741	96742
21183	31309	1	applied	\N	\N	\N	\N	96743	96743	96744
21186	31316	0	applied	\N	\N	\N	\N	96762	96762	96763
21186	31317	1	applied	\N	\N	\N	\N	96764	96764	96765
21191	31318	0	applied	\N	\N	\N	\N	96769	96769	96770
21191	31319	1	applied	\N	\N	\N	\N	96776	96776	96777
21191	31320	2	applied	\N	\N	\N	\N	96778	96778	96779
21191	31321	3	applied	\N	\N	\N	\N	96780	96780	96781
21191	31322	4	applied	\N	\N	\N	\N	96782	96782	96783
21191	31323	5	applied	\N	\N	\N	\N	96784	96784	96785
21191	31324	6	applied	\N	\N	\N	\N	96786	96786	96787
21191	31325	7	applied	\N	\N	\N	\N	96788	96788	96789
21188	31113	16	applied	\N	\N	\N	\N	96140	96140	96141
21188	31114	17	applied	\N	\N	\N	\N	96142	96142	96143
21188	31118	18	applied	\N	\N	\N	\N	96152	96152	96153
21188	31120	19	applied	\N	\N	\N	\N	96160	96160	96161
21188	31123	20	applied	\N	\N	\N	\N	96170	96170	96171
21188	31125	21	applied	\N	\N	\N	\N	96177	96177	96178
21188	31126	22	applied	\N	\N	\N	\N	96179	96179	96180
21188	31129	23	applied	\N	\N	\N	\N	96188	96188	96189
21188	31131	24	applied	\N	\N	\N	\N	96192	96192	96193
21188	31133	25	applied	\N	\N	\N	\N	96198	96198	96199
21188	31134	26	applied	\N	\N	\N	\N	96200	96200	96201
21188	31140	27	applied	\N	\N	\N	\N	96214	96214	96215
21188	31147	28	applied	\N	\N	\N	\N	96246	96246	96247
21188	31149	29	applied	\N	\N	\N	\N	96260	96260	96261
21188	31152	30	applied	\N	\N	\N	\N	96273	96273	96274
21188	31153	31	applied	\N	\N	\N	\N	96275	96275	96276
21188	31154	32	applied	\N	\N	\N	\N	96277	96277	96278
21188	31158	33	applied	\N	\N	\N	\N	96287	96287	96288
21188	31161	34	applied	\N	\N	\N	\N	96296	96296	96297
21188	31163	35	applied	\N	\N	\N	\N	96303	96303	96304
21188	31165	36	applied	\N	\N	\N	\N	96307	96307	96308
21188	31168	37	applied	\N	\N	\N	\N	96317	96317	96318
21188	31170	38	applied	\N	\N	\N	\N	96322	96322	96323
21188	31172	39	applied	\N	\N	\N	\N	96328	96328	96329
21188	31173	40	applied	\N	\N	\N	\N	96330	96330	96331
21188	31177	41	applied	\N	\N	\N	\N	96347	96347	96348
21188	31179	42	applied	\N	\N	\N	\N	96355	96355	96356
21188	31180	43	applied	\N	\N	\N	\N	96357	96357	96358
21188	31184	44	applied	\N	\N	\N	\N	96369	96369	96370
21188	31185	45	applied	\N	\N	\N	\N	96371	96371	96372
21188	31188	46	applied	\N	\N	\N	\N	96384	96384	96385
21188	31191	47	applied	\N	\N	\N	\N	96394	96394	96395
21188	31192	48	applied	\N	\N	\N	\N	96399	96399	96400
21188	31194	49	applied	\N	\N	\N	\N	96405	96405	96406
21188	31197	50	applied	\N	\N	\N	\N	96411	96411	96412
21188	31199	51	applied	\N	\N	\N	\N	96419	96419	96420
21188	31201	52	applied	\N	\N	\N	\N	96426	96426	96427
21188	31202	53	applied	\N	\N	\N	\N	96430	96430	96431
21188	31205	54	applied	\N	\N	\N	\N	96441	96441	96442
21188	31207	55	applied	\N	\N	\N	\N	96447	96447	96448
21188	31209	56	applied	\N	\N	\N	\N	96453	96453	96454
21188	31212	58	applied	\N	\N	\N	\N	96460	96460	96461
21188	31213	59	applied	\N	\N	\N	\N	96462	96462	96463
21188	31216	60	applied	\N	\N	\N	\N	96470	96470	96471
21188	31219	61	applied	\N	\N	\N	\N	96480	96480	96481
21188	31220	62	applied	\N	\N	\N	\N	96482	96482	96483
21188	31221	63	applied	\N	\N	\N	\N	96484	96484	96485
21188	31227	64	applied	\N	\N	\N	\N	96500	96500	96501
21188	31229	65	applied	\N	\N	\N	\N	96508	96508	96509
21188	31231	66	applied	\N	\N	\N	\N	96516	96516	96517
21188	31234	67	applied	\N	\N	\N	\N	96528	96528	96529
21188	31235	68	applied	\N	\N	\N	\N	96530	96530	96531
21188	31238	69	applied	\N	\N	\N	\N	96542	96542	96543
21188	31241	70	applied	\N	\N	\N	\N	96551	96551	96552
21188	31243	71	applied	\N	\N	\N	\N	96559	96559	96560
21188	31244	72	applied	\N	\N	\N	\N	96561	96561	96562
21188	31247	73	applied	\N	\N	\N	\N	96569	96569	96570
21188	31251	74	applied	\N	\N	\N	\N	96579	96579	96580
21188	31252	75	applied	\N	\N	\N	\N	96582	96582	96583
21188	31253	76	applied	\N	\N	\N	\N	96584	96584	96585
21188	31254	77	applied	\N	\N	\N	\N	96586	96586	96587
21188	31260	78	applied	\N	\N	\N	\N	96601	96601	96602
21188	31262	79	applied	\N	\N	\N	\N	96605	96605	96606
21188	31263	80	applied	\N	\N	\N	\N	96607	96607	96608
21188	31266	81	applied	\N	\N	\N	\N	96616	96616	96617
21188	31267	82	applied	\N	\N	\N	\N	96618	96618	96619
21188	31271	83	applied	\N	\N	\N	\N	96627	96627	96628
21188	31273	84	applied	\N	\N	\N	\N	96634	96634	96635
21188	31275	85	applied	\N	\N	\N	\N	96640	96640	96641
21188	31277	86	applied	\N	\N	\N	\N	96645	96645	96646
21188	31279	87	applied	\N	\N	\N	\N	96651	96651	96652
21188	31280	88	applied	\N	\N	\N	\N	96653	96653	96654
21188	31281	89	applied	\N	\N	\N	\N	96655	96655	96656
21188	31285	90	applied	\N	\N	\N	\N	96665	96665	96666
21188	31287	91	applied	\N	\N	\N	\N	96673	96673	96674
21188	31289	92	applied	\N	\N	\N	\N	96679	96679	96680
21188	31291	93	applied	\N	\N	\N	\N	96687	96687	96688
21188	31293	94	applied	\N	\N	\N	\N	96692	96692	96693
21188	31295	95	applied	\N	\N	\N	\N	96702	96702	96703
21188	31297	96	applied	\N	\N	\N	\N	96713	96713	96714
21188	31298	97	applied	\N	\N	\N	\N	96715	96715	96716
21188	31299	98	applied	\N	\N	\N	\N	96717	96717	96718
21188	31302	99	applied	\N	\N	\N	\N	96726	96726	96727
21188	31304	100	applied	\N	\N	\N	\N	96732	96732	96733
21188	31305	101	applied	\N	\N	\N	\N	96734	96734	96735
21188	31308	102	applied	\N	\N	\N	\N	96741	96741	96742
21188	31310	103	applied	\N	\N	\N	\N	96747	96747	96748
21188	31311	104	applied	\N	\N	\N	\N	96749	96749	96750
21188	31312	105	applied	\N	\N	\N	\N	96751	96751	96752
21188	31316	106	applied	\N	\N	\N	\N	96762	96762	96763
21188	31318	107	applied	\N	\N	\N	\N	96769	96769	96770
21193	31326	0	applied	\N	\N	\N	\N	96794	96794	96795
21193	31327	1	applied	\N	\N	\N	\N	96796	96796	96797
21193	31328	2	applied	\N	\N	\N	\N	96798	96798	96799
21195	31331	0	applied	\N	\N	\N	\N	96807	96807	96808
21195	31332	2	applied	\N	\N	\N	\N	96810	96810	96811
21200	31342	0	applied	\N	\N	\N	\N	96838	96838	29193
21205	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21205	30942	1	applied	\N	\N	1000000000	\N	95607	95607	95608
21205	30933	2	applied	\N	\N	\N	\N	95816	95816	95584
21205	30934	3	applied	\N	\N	\N	\N	95818	95818	95586
21205	30952	4	applied	\N	\N	1000000000	\N	95629	95629	95630
21205	30999	5	applied	\N	\N	\N	\N	95779	95779	95754
21205	30935	6	applied	\N	\N	\N	\N	96254	96254	95588
21205	30936	7	applied	\N	\N	\N	\N	96255	96255	95590
21205	31008	8	applied	\N	\N	\N	\N	96256	96256	95781
21205	31139	9	applied	\N	\N	\N	\N	96212	96212	96213
21205	30819	10	applied	\N	\N	\N	\N	95235	95235	95236
21205	31250	11	applied	\N	\N	\N	\N	96577	96577	96578
21205	30888	12	applied	\N	\N	1000000000	\N	95470	95470	95471
21205	31084	13	applied	\N	\N	\N	\N	96048	96048	96049
21205	31085	14	applied	\N	\N	\N	\N	96050	96050	96051
21205	31142	15	applied	\N	\N	\N	\N	96220	96220	96221
21205	31143	16	applied	\N	\N	\N	\N	96222	96222	96223
21205	31144	17	applied	\N	\N	\N	\N	96224	96224	96225
21205	31145	18	applied	\N	\N	\N	\N	96226	96226	96227
21205	31086	19	applied	\N	\N	\N	\N	96052	96052	96053
21205	31146	20	applied	\N	\N	\N	\N	96228	96228	96229
21205	30946	21	applied	\N	\N	\N	\N	95617	95617	95618
21189	31180	70	applied	\N	\N	\N	\N	96357	96357	96358
21189	31184	71	applied	\N	\N	\N	\N	96369	96369	96370
21189	31185	72	applied	\N	\N	\N	\N	96371	96371	96372
21189	31188	73	applied	\N	\N	\N	\N	96384	96384	96385
21189	31191	74	applied	\N	\N	\N	\N	96394	96394	96395
21189	31192	75	applied	\N	\N	\N	\N	96399	96399	96400
21189	31194	77	applied	\N	\N	\N	\N	96405	96405	96406
21189	31197	78	applied	\N	\N	\N	\N	96411	96411	96412
21189	31199	79	applied	\N	\N	\N	\N	96419	96419	96420
21189	31201	80	applied	\N	\N	\N	\N	96426	96426	96427
21189	31202	81	applied	\N	\N	\N	\N	96430	96430	96431
21189	31205	82	applied	\N	\N	\N	\N	96441	96441	96442
21189	31207	83	applied	\N	\N	\N	\N	96447	96447	96448
21189	31209	84	applied	\N	\N	\N	\N	96453	96453	96454
21189	31212	85	applied	\N	\N	\N	\N	96460	96460	96461
21189	31213	86	applied	\N	\N	\N	\N	96462	96462	96463
21189	31216	87	applied	\N	\N	\N	\N	96470	96470	96471
21189	31219	88	applied	\N	\N	\N	\N	96480	96480	96481
21189	31220	89	applied	\N	\N	\N	\N	96482	96482	96483
21189	31221	90	applied	\N	\N	\N	\N	96484	96484	96485
21189	31227	91	applied	\N	\N	\N	\N	96500	96500	96501
21189	31229	92	applied	\N	\N	\N	\N	96508	96508	96509
21189	31231	93	applied	\N	\N	\N	\N	96516	96516	96517
21189	31234	94	applied	\N	\N	\N	\N	96528	96528	96529
21189	31235	95	applied	\N	\N	\N	\N	96530	96530	96531
21189	31238	96	applied	\N	\N	\N	\N	96542	96542	96543
21189	31241	97	applied	\N	\N	\N	\N	96551	96551	96552
21189	31243	98	applied	\N	\N	\N	\N	96559	96559	96560
21189	31244	99	applied	\N	\N	\N	\N	96561	96561	96562
21189	31247	100	applied	\N	\N	\N	\N	96569	96569	96570
21189	31251	101	applied	\N	\N	\N	\N	96579	96579	96580
21189	31252	102	applied	\N	\N	\N	\N	96582	96582	96583
21189	31253	103	applied	\N	\N	\N	\N	96584	96584	96585
21189	31254	104	applied	\N	\N	\N	\N	96586	96586	96587
21189	31260	105	applied	\N	\N	\N	\N	96601	96601	96602
21189	31262	106	applied	\N	\N	\N	\N	96605	96605	96606
21189	31263	107	applied	\N	\N	\N	\N	96607	96607	96608
21189	31266	108	applied	\N	\N	\N	\N	96616	96616	96617
21189	31267	109	applied	\N	\N	\N	\N	96618	96618	96619
21189	31271	110	applied	\N	\N	\N	\N	96627	96627	96628
21189	31273	111	applied	\N	\N	\N	\N	96634	96634	96635
21189	31275	112	applied	\N	\N	\N	\N	96640	96640	96641
21189	31277	113	applied	\N	\N	\N	\N	96645	96645	96646
21189	31279	114	applied	\N	\N	\N	\N	96651	96651	96652
21189	31280	115	applied	\N	\N	\N	\N	96653	96653	96654
21189	31281	116	applied	\N	\N	\N	\N	96655	96655	96656
21189	31285	117	applied	\N	\N	\N	\N	96665	96665	96666
21189	31287	118	applied	\N	\N	\N	\N	96673	96673	96674
21189	31289	119	applied	\N	\N	\N	\N	96679	96679	96680
21189	31291	120	applied	\N	\N	\N	\N	96687	96687	96688
21189	31293	121	applied	\N	\N	\N	\N	96692	96692	96693
21189	31295	122	applied	\N	\N	\N	\N	96702	96702	96703
21189	31297	123	applied	\N	\N	\N	\N	96713	96713	96714
21189	31298	124	applied	\N	\N	\N	\N	96715	96715	96716
21189	31299	125	applied	\N	\N	\N	\N	96717	96717	96718
21194	31329	0	applied	\N	\N	\N	\N	96802	96802	96803
21194	31330	1	applied	\N	\N	\N	\N	96804	96804	96805
21196	31331	0	applied	\N	\N	\N	\N	96807	96807	96808
21196	31332	2	applied	\N	\N	\N	\N	96810	96810	96811
21199	31335	0	applied	\N	\N	\N	\N	96824	96824	96825
21199	31336	1	applied	\N	\N	\N	\N	96826	96826	96827
21199	31337	2	applied	\N	\N	\N	\N	96828	96828	96829
21199	31338	3	applied	\N	\N	\N	\N	96830	96830	96831
21199	31339	4	applied	\N	\N	\N	\N	96832	96832	96833
21199	31340	5	applied	\N	\N	\N	\N	96834	96834	96835
21199	31341	6	applied	\N	\N	\N	\N	96836	96836	96837
21199	31342	7	applied	\N	\N	\N	\N	96838	96838	29193
21199	31343	8	applied	\N	\N	\N	\N	96839	96839	96840
21199	31344	9	applied	\N	\N	\N	\N	96841	96841	96842
21201	31342	0	applied	\N	\N	\N	\N	96838	96838	29193
21202	31345	0	applied	\N	\N	\N	\N	96846	96846	96847
21202	31346	1	applied	\N	\N	\N	\N	96848	96848	96849
21202	31347	2	applied	\N	\N	\N	\N	96850	96850	96851
21202	31348	3	applied	\N	\N	\N	\N	96852	96852	96853
21202	31349	4	applied	\N	\N	\N	\N	96854	96854	96855
21202	31350	5	applied	\N	\N	\N	\N	96856	96856	96857
21204	31351	0	applied	\N	\N	\N	\N	96862	96862	96863
21204	31352	1	applied	\N	\N	\N	\N	96864	96864	96865
21206	31317	0	applied	\N	\N	\N	\N	96764	96764	96765
21206	31342	1	applied	\N	\N	\N	\N	96838	96838	29193
21208	31355	0	applied	\N	\N	\N	\N	96875	96875	96876
21208	31356	1	applied	\N	\N	\N	\N	96877	96877	96878
21223	31377	0	applied	\N	\N	\N	\N	96937	96937	96938
21223	31378	1	applied	\N	\N	\N	\N	96939	96939	96940
21225	31379	0	applied	\N	\N	\N	\N	96943	96943	96944
21225	31380	1	applied	\N	\N	\N	\N	96945	96945	96946
21229	31385	0	applied	\N	\N	\N	\N	96959	96959	96960
21229	31386	1	applied	\N	\N	\N	\N	96961	96961	96962
21229	31387	2	applied	\N	\N	\N	\N	96963	96963	96964
21229	31388	3	applied	\N	\N	\N	\N	96965	96965	96966
21231	31390	0	applied	\N	\N	\N	\N	96976	96976	96977
21231	31391	1	applied	\N	\N	\N	\N	96978	96978	96979
21231	31392	2	applied	\N	\N	\N	\N	96980	96980	96981
21231	31393	3	applied	\N	\N	\N	\N	96982	96982	96983
21240	31410	0	applied	\N	\N	\N	\N	97037	97037	97038
21240	31411	2	applied	\N	\N	\N	\N	97040	97040	97041
21243	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21243	31139	1	applied	\N	\N	\N	\N	96212	96212	96213
21243	31400	2	applied	\N	\N	\N	\N	97008	97008	97009
21243	31250	3	applied	\N	\N	\N	\N	96577	96577	96578
21243	31401	4	applied	\N	\N	\N	\N	97010	97010	97011
21243	31402	5	applied	\N	\N	\N	\N	97012	97012	97013
21243	31142	6	applied	\N	\N	\N	\N	96220	96220	96221
21243	31143	7	applied	\N	\N	\N	\N	96222	96222	96223
21243	31144	8	applied	\N	\N	\N	\N	96224	96224	96225
21243	31145	9	applied	\N	\N	\N	\N	96226	96226	96227
21243	31403	10	applied	\N	\N	\N	\N	97014	97014	97015
21243	31268	11	applied	\N	\N	\N	\N	96620	96620	92096
21243	31317	12	applied	\N	\N	\N	\N	96764	96764	96765
21243	31342	13	applied	\N	\N	\N	\N	96838	96838	29193
21243	31404	14	applied	\N	\N	\N	\N	97016	97016	97017
21243	31405	15	applied	\N	\N	\N	\N	97018	97018	97019
21243	31406	16	applied	\N	\N	\N	\N	97020	97020	97021
21243	31407	17	applied	\N	\N	\N	\N	97022	97022	97023
21245	31412	0	applied	\N	\N	\N	\N	97050	97050	97051
21245	31413	1	applied	\N	\N	\N	\N	97052	97052	97053
21247	31414	0	applied	\N	\N	\N	\N	97055	97055	97056
21247	31415	1	applied	\N	\N	\N	\N	97057	97057	97058
21251	31422	0	applied	\N	\N	\N	\N	97072	97072	97073
21251	31423	1	applied	\N	\N	\N	\N	97074	97074	97075
21198	31333	0	applied	\N	\N	\N	\N	96820	96820	96821
21198	31334	1	applied	\N	\N	\N	\N	96822	96822	96823
21210	31357	0	applied	\N	\N	\N	\N	96882	96882	96883
21210	31358	1	applied	\N	\N	\N	\N	96884	96884	96885
21213	31359	0	applied	\N	\N	\N	\N	96888	96888	96889
21213	31360	1	applied	\N	\N	\N	\N	96890	96890	96891
21215	31361	0	applied	\N	\N	\N	\N	96897	96897	96898
21215	31362	1	applied	\N	\N	\N	\N	96899	96899	96900
21222	31375	0	applied	\N	\N	\N	\N	96933	96933	96934
21222	31376	1	applied	\N	\N	\N	\N	96935	96935	96936
21228	31385	0	applied	\N	\N	\N	\N	96959	96959	96960
21228	31386	1	applied	\N	\N	\N	\N	96961	96961	96962
21228	31387	2	applied	\N	\N	\N	\N	96963	96963	96964
21228	31388	3	applied	\N	\N	\N	\N	96965	96965	96966
21230	31389	0	applied	\N	\N	\N	\N	96972	96972	96973
21233	31394	0	applied	\N	\N	\N	\N	96986	96986	96987
21233	31395	1	applied	\N	\N	\N	\N	96988	96988	96989
21235	31396	0	applied	\N	\N	\N	\N	96994	96994	96995
21235	31397	1	applied	\N	\N	\N	\N	96996	96996	96997
21238	31400	0	applied	\N	\N	\N	\N	97008	97008	97009
21238	31401	1	applied	\N	\N	\N	\N	97010	97010	97011
21238	31402	2	applied	\N	\N	\N	\N	97012	97012	97013
21238	31408	3	applied	\N	\N	\N	\N	97026	97026	97027
21238	31403	4	applied	\N	\N	\N	\N	97014	97014	97015
21238	31409	5	applied	\N	\N	\N	\N	97028	97028	97029
21238	31404	6	applied	\N	\N	\N	\N	97030	97030	97017
21238	31405	7	applied	\N	\N	\N	\N	97031	97031	97019
21238	31406	8	applied	\N	\N	\N	\N	97032	97032	97021
21238	31407	9	applied	\N	\N	\N	\N	97033	97033	97023
21250	31422	0	applied	\N	\N	\N	\N	97072	97072	97073
21250	31423	1	applied	\N	\N	\N	\N	97074	97074	97075
21250	31424	2	applied	\N	\N	\N	\N	97076	97076	97077
21250	31425	3	applied	\N	\N	\N	\N	97078	97078	97079
21250	31426	4	applied	\N	\N	\N	\N	97080	97080	97081
21250	31427	5	applied	\N	\N	\N	\N	97082	97082	97083
21250	31428	6	applied	\N	\N	\N	\N	97084	97084	97085
21250	31429	7	applied	\N	\N	\N	\N	97086	97086	97087
21254	31430	0	applied	\N	\N	\N	\N	97096	97096	97097
21256	31431	0	applied	\N	\N	\N	\N	97101	97101	97102
21256	31432	1	applied	\N	\N	\N	\N	97103	97103	97104
21263	31441	0	applied	\N	\N	\N	\N	97129	97129	97130
21263	31442	1	applied	\N	\N	\N	\N	97131	97131	97132
21263	31443	2	applied	\N	\N	\N	\N	97133	97133	97134
21263	31444	3	applied	\N	\N	\N	\N	97135	97135	97136
21263	31445	4	applied	\N	\N	\N	\N	97137	97137	97138
21263	31446	5	applied	\N	\N	\N	\N	97139	97139	97140
21263	31447	6	applied	\N	\N	\N	\N	97141	97141	97142
21263	31448	7	applied	\N	\N	\N	\N	97143	97143	97144
21265	31449	0	applied	\N	\N	\N	\N	97147	97147	97148
21265	31450	1	applied	\N	\N	\N	\N	97149	97149	97150
21265	31451	2	applied	\N	\N	\N	\N	97151	97151	97152
21265	31452	3	applied	\N	\N	\N	\N	97153	97153	97154
21267	31449	0	applied	\N	\N	\N	\N	97147	97147	97148
21267	31450	1	applied	\N	\N	\N	\N	97149	97149	97150
21267	31451	2	applied	\N	\N	\N	\N	97151	97151	97152
21267	31452	3	applied	\N	\N	\N	\N	97153	97153	97154
21278	31493	0	applied	\N	\N	\N	\N	97252	97252	97253
21278	31494	1	applied	\N	\N	\N	\N	97254	97254	97255
21278	31495	2	applied	\N	\N	\N	\N	97256	97256	97257
21278	31496	3	applied	\N	\N	\N	\N	97258	97258	97259
21286	31510	0	applied	\N	\N	\N	\N	97316	97316	97317
21286	31511	1	applied	\N	\N	\N	\N	97318	97318	97319
21286	31512	2	applied	\N	\N	\N	\N	97320	97320	97321
21289	31516	0	applied	\N	\N	\N	\N	97331	97331	97332
21289	31517	1	applied	\N	\N	\N	\N	97333	97333	97334
21289	31518	2	applied	\N	\N	\N	\N	97335	97335	97336
21289	31519	3	applied	\N	\N	\N	\N	97337	97337	97338
21291	31520	0	applied	\N	\N	\N	\N	97342	97342	97343
21291	31521	1	applied	\N	\N	\N	\N	97344	97344	97345
21291	31522	2	applied	\N	\N	\N	\N	97346	97346	97347
21291	31523	3	applied	\N	\N	\N	\N	97348	97348	97349
21291	31524	4	applied	\N	\N	\N	\N	97350	97350	97351
21291	31525	5	applied	\N	\N	\N	\N	97352	97352	97353
21299	31536	0	applied	\N	\N	\N	\N	97385	97385	97386
21299	31537	1	applied	\N	\N	\N	\N	97387	97387	97388
21299	31538	2	applied	\N	\N	\N	\N	97389	97389	97390
21300	31539	0	applied	\N	\N	\N	\N	97394	97394	97395
21300	31540	1	applied	\N	\N	\N	\N	97396	97396	97397
21300	31541	2	applied	\N	\N	\N	\N	97398	97398	97399
21300	31542	3	applied	\N	\N	\N	\N	97400	97400	97401
21305	31543	0	applied	\N	\N	\N	\N	97409	97409	97410
21305	31544	1	applied	\N	\N	\N	\N	97411	97411	97412
21305	31545	2	applied	\N	\N	\N	\N	97413	97413	97414
21307	31546	0	applied	\N	\N	\N	\N	97421	97421	97422
21307	31547	1	applied	\N	\N	\N	\N	97423	97423	97424
21307	31548	2	applied	\N	\N	\N	\N	97425	97425	97426
21311	31546	0	applied	\N	\N	\N	\N	97421	97421	97422
21311	31547	1	applied	\N	\N	\N	\N	97423	97423	97424
21311	31548	2	applied	\N	\N	\N	\N	97425	97425	97426
21316	31555	0	applied	\N	\N	\N	\N	97454	97454	97455
21316	31556	1	applied	\N	\N	\N	\N	97456	97456	97457
21316	31557	2	applied	\N	\N	\N	\N	97458	97458	97459
21317	31558	0	applied	\N	\N	\N	\N	97462	97462	97463
21317	31559	1	applied	\N	\N	\N	\N	97464	97464	97465
21317	31560	2	applied	\N	\N	\N	\N	97466	97466	97467
21317	31561	3	applied	\N	\N	\N	\N	97468	97468	97469
21317	31562	4	applied	\N	\N	\N	\N	97470	97470	97471
21317	31563	5	applied	\N	\N	\N	\N	97472	97472	97473
21317	31564	6	applied	\N	\N	\N	\N	97474	97474	97475
21317	31565	7	applied	\N	\N	\N	\N	97476	97476	97477
21317	31566	8	applied	\N	\N	\N	\N	97478	97478	97479
21317	31567	9	applied	\N	\N	\N	\N	97480	97480	97481
21317	31568	10	applied	\N	\N	\N	\N	97482	97482	97483
21317	31569	11	applied	\N	\N	\N	\N	97484	97484	97485
21317	31570	12	applied	\N	\N	\N	\N	97486	97486	97487
21319	31558	0	applied	\N	\N	\N	\N	97462	97462	97463
21319	31559	1	applied	\N	\N	\N	\N	97464	97464	97465
21319	31560	2	applied	\N	\N	\N	\N	97466	97466	97467
21319	31561	3	applied	\N	\N	\N	\N	97468	97468	97469
21319	31562	4	applied	\N	\N	\N	\N	97470	97470	97471
21319	31563	5	applied	\N	\N	\N	\N	97472	97472	97473
21319	31564	6	applied	\N	\N	\N	\N	97474	97474	97475
21319	31565	7	applied	\N	\N	\N	\N	97476	97476	97477
21319	31566	8	applied	\N	\N	\N	\N	97478	97478	97479
21319	31567	9	applied	\N	\N	\N	\N	97480	97480	97481
21319	31568	10	applied	\N	\N	\N	\N	97482	97482	97483
21319	31569	11	applied	\N	\N	\N	\N	97484	97484	97485
21319	31570	12	applied	\N	\N	\N	\N	97486	97486	97487
21324	31582	0	applied	\N	\N	\N	\N	97517	97517	97518
21324	31583	1	applied	\N	\N	\N	\N	97519	97519	97520
21205	30900	22	applied	\N	\N	\N	\N	95502	95502	95503
21205	30906	23	applied	\N	\N	\N	\N	95518	95518	95519
21205	30908	24	applied	\N	\N	\N	\N	95524	95524	95525
21205	30909	25	applied	\N	\N	\N	\N	95526	95526	95527
21205	30914	26	applied	\N	\N	\N	\N	95537	95537	95538
21205	31052	27	applied	\N	\N	\N	\N	95918	95918	95919
21205	31053	28	applied	\N	\N	\N	\N	95920	95920	95921
21205	31054	29	applied	\N	\N	\N	\N	95922	95922	95923
21205	31055	30	applied	\N	\N	\N	\N	95924	95924	95925
21205	30842	31	applied	\N	\N	\N	\N	95329	95329	93688
21205	31018	32	applied	\N	\N	\N	\N	95821	95821	95822
21205	31019	33	applied	\N	\N	\N	\N	95823	95823	95824
21205	31020	34	applied	\N	\N	\N	\N	95825	95825	95826
21205	31021	35	applied	\N	\N	\N	\N	95827	95827	95828
21205	31026	36	applied	\N	\N	\N	\N	95841	95841	95842
21205	30894	37	applied	\N	\N	\N	\N	95485	95485	95486
21205	30822	38	applied	\N	\N	\N	\N	95247	95247	95248
21205	30823	39	applied	\N	\N	\N	\N	95249	95249	95250
21205	30826	40	applied	\N	\N	\N	\N	95256	95256	95257
21205	30828	41	applied	\N	\N	\N	\N	95262	95262	95263
21205	30831	42	applied	\N	\N	\N	\N	95270	95270	95271
21205	30832	43	applied	\N	\N	\N	\N	95272	95272	95273
21205	30835	44	applied	\N	\N	\N	\N	95290	95290	95291
21205	30838	45	applied	\N	\N	\N	\N	95298	95298	95299
21205	30840	46	applied	\N	\N	\N	\N	95323	95323	95324
21205	30841	47	applied	\N	\N	\N	\N	95327	95327	95328
21205	30845	48	applied	\N	\N	\N	\N	95339	95339	95340
21205	30847	49	applied	\N	\N	\N	\N	95346	95346	95347
21205	30849	50	applied	\N	\N	\N	\N	95356	95356	95357
21205	30851	51	applied	\N	\N	\N	\N	95361	95361	95362
21205	30854	52	applied	\N	\N	\N	\N	95371	95371	95372
21205	30856	53	applied	\N	\N	\N	\N	95377	95377	95378
21205	30858	54	applied	\N	\N	\N	\N	95382	95382	95383
21205	30861	55	applied	\N	\N	\N	\N	95391	95391	95392
21205	30863	56	applied	\N	\N	\N	\N	95401	95401	95402
21205	30865	57	applied	\N	\N	\N	\N	95406	95406	95407
21205	30866	58	applied	\N	\N	\N	\N	95408	95408	95409
21205	30870	59	applied	\N	\N	\N	\N	95420	95420	95421
21205	30872	60	applied	\N	\N	\N	\N	95426	95426	95427
21205	30873	61	applied	\N	\N	\N	\N	95428	95428	95429
21205	30874	62	applied	\N	\N	\N	\N	95430	95430	95431
21205	30879	63	applied	\N	\N	\N	\N	95442	95442	95443
21205	30880	64	applied	\N	\N	\N	\N	95444	95444	95445
21205	30881	65	applied	\N	\N	\N	\N	95446	95446	95447
21205	30886	66	applied	\N	\N	\N	\N	95458	95458	95459
21205	30889	67	applied	\N	\N	\N	\N	95472	95472	95473
21205	30892	68	applied	\N	\N	\N	\N	95481	95481	95482
21205	30893	69	applied	\N	\N	\N	\N	95483	95483	95484
21205	30897	70	applied	\N	\N	\N	\N	95495	95495	95496
21205	30899	71	applied	\N	\N	\N	\N	95500	95500	95501
21205	30903	72	applied	\N	\N	\N	\N	95510	95510	95511
21205	30905	73	applied	\N	\N	\N	\N	95516	95516	95517
21205	30910	74	applied	\N	\N	\N	\N	95528	95528	95529
21205	30913	75	applied	\N	\N	\N	\N	95535	95535	95536
21205	30916	76	applied	\N	\N	\N	\N	95542	95542	95543
21205	30918	77	applied	\N	\N	\N	\N	95546	95546	95547
21205	30921	78	applied	\N	\N	\N	\N	95554	95554	95555
21205	30923	79	applied	\N	\N	\N	\N	95559	95559	95560
21205	30924	80	applied	\N	\N	\N	\N	95561	95561	95562
21205	30925	81	applied	\N	\N	\N	\N	95563	95563	95564
21205	30931	82	applied	\N	\N	\N	\N	95577	95577	95578
21205	30937	83	applied	\N	\N	\N	\N	95591	95591	95592
21205	30938	84	applied	\N	\N	\N	\N	95593	95593	95594
21205	30943	85	applied	\N	\N	\N	\N	95609	95609	95610
21205	30945	86	applied	\N	\N	\N	\N	95615	95615	95616
21205	30947	87	applied	\N	\N	\N	\N	95619	95619	95620
21205	30953	88	applied	\N	\N	\N	\N	95631	95631	95632
21205	30955	89	applied	\N	\N	\N	\N	95636	95636	95637
21205	30959	90	applied	\N	\N	\N	\N	95646	95646	95647
21205	30964	91	applied	\N	\N	\N	\N	95656	95656	95657
21205	30967	92	applied	\N	\N	\N	\N	95664	95664	95665
21205	30968	93	applied	\N	\N	\N	\N	95666	95666	95667
21205	30971	94	applied	\N	\N	\N	\N	95674	95674	95675
21205	30972	95	applied	\N	\N	\N	\N	95676	95676	95677
21205	30973	96	applied	\N	\N	\N	\N	95678	95678	95679
21205	30978	97	applied	\N	\N	\N	\N	95694	95694	95695
21205	30981	98	applied	\N	\N	\N	\N	95701	95701	95702
21205	30983	99	applied	\N	\N	\N	\N	95708	95708	95709
21205	30985	100	applied	\N	\N	\N	\N	95714	95714	95715
21205	30987	101	applied	\N	\N	\N	\N	95721	95721	95722
21205	30990	102	applied	\N	\N	\N	\N	95729	95729	95730
21205	30992	103	applied	\N	\N	\N	\N	95737	95737	95738
21205	30993	104	applied	\N	\N	\N	\N	95739	95739	95740
21205	30994	105	applied	\N	\N	\N	\N	95741	95741	95742
21205	31000	107	applied	\N	\N	\N	\N	95755	95755	95756
21205	31002	108	applied	\N	\N	\N	\N	95765	95765	95766
21205	31003	109	applied	\N	\N	\N	\N	95767	95767	95768
21205	31006	110	applied	\N	\N	\N	\N	95775	95775	95776
21205	31009	111	applied	\N	\N	\N	\N	95784	95784	95785
21205	31010	112	applied	\N	\N	\N	\N	95786	95786	95787
21205	31014	113	applied	\N	\N	\N	\N	95796	95796	95797
21205	31016	114	applied	\N	\N	\N	\N	95810	95810	95811
21205	31024	115	applied	\N	\N	\N	\N	95835	95835	95836
21205	31027	116	applied	\N	\N	\N	\N	95843	95843	95844
21205	31029	117	applied	\N	\N	\N	\N	95851	95851	95852
21205	31032	118	applied	\N	\N	\N	\N	95861	95861	95862
21205	31034	119	applied	\N	\N	\N	\N	95866	95866	95867
21205	31036	120	applied	\N	\N	\N	\N	95872	95872	95873
21205	31038	121	applied	\N	\N	\N	\N	95878	95878	95879
21205	31041	122	applied	\N	\N	\N	\N	95884	95884	95885
21205	31043	123	applied	\N	\N	\N	\N	95892	95892	95893
21205	31045	124	applied	\N	\N	\N	\N	95899	95899	95900
21205	31048	125	applied	\N	\N	\N	\N	95906	95906	95907
21207	31353	0	applied	\N	\N	\N	\N	96870	96870	96871
21207	31354	1	applied	\N	\N	\N	\N	96872	96872	96873
21212	31359	0	applied	\N	\N	\N	\N	96888	96888	96889
21212	31360	1	applied	\N	\N	\N	\N	96890	96890	96891
21214	31361	0	applied	\N	\N	\N	\N	96897	96897	96898
21214	31362	1	applied	\N	\N	\N	\N	96899	96899	96900
21216	31363	0	applied	\N	\N	\N	\N	96903	96903	96904
21216	31364	1	applied	\N	\N	\N	\N	96905	96905	96906
21219	31365	0	applied	\N	\N	\N	\N	96908	96908	96909
21219	31366	1	applied	\N	\N	\N	\N	96910	96910	96911
21227	31385	0	applied	\N	\N	\N	\N	96959	96959	96960
21227	31386	1	applied	\N	\N	\N	\N	96961	96961	96962
21227	31387	2	applied	\N	\N	\N	\N	96963	96963	96964
21227	31388	3	applied	\N	\N	\N	\N	96965	96965	96966
21232	31394	0	applied	\N	\N	\N	\N	96986	96986	96987
21232	31395	1	applied	\N	\N	\N	\N	96988	96988	96989
21237	31400	0	applied	\N	\N	\N	\N	97008	97008	97009
21237	31401	1	applied	\N	\N	\N	\N	97010	97010	97011
21237	31402	2	applied	\N	\N	\N	\N	97012	97012	97013
21237	31403	3	applied	\N	\N	\N	\N	97014	97014	97015
21237	31317	4	applied	\N	\N	\N	\N	96764	96764	96765
21237	31342	5	applied	\N	\N	\N	\N	96838	96838	29193
21237	31404	6	applied	\N	\N	\N	\N	97016	97016	97017
21237	31405	7	applied	\N	\N	\N	\N	97018	97018	97019
21237	31406	8	applied	\N	\N	\N	\N	97020	97020	97021
21237	31407	9	applied	\N	\N	\N	\N	97022	97022	97023
21239	31400	0	applied	\N	\N	\N	\N	97008	97008	97009
21239	31401	1	applied	\N	\N	\N	\N	97010	97010	97011
21239	31402	2	applied	\N	\N	\N	\N	97012	97012	97013
21239	31408	3	applied	\N	\N	\N	\N	97026	97026	97027
21239	31403	4	applied	\N	\N	\N	\N	97014	97014	97015
21239	31409	5	applied	\N	\N	\N	\N	97028	97028	97029
21239	31404	6	applied	\N	\N	\N	\N	97030	97030	97017
21239	31405	7	applied	\N	\N	\N	\N	97031	97031	97019
21239	31406	8	applied	\N	\N	\N	\N	97032	97032	97021
21239	31407	9	applied	\N	\N	\N	\N	97033	97033	97023
21242	31410	0	applied	\N	\N	\N	\N	97037	97037	97038
21242	31411	2	applied	\N	\N	\N	\N	97040	97040	97041
21244	31412	0	applied	\N	\N	\N	\N	97050	97050	97051
21244	31413	1	applied	\N	\N	\N	\N	97052	97052	97053
21249	31422	0	applied	\N	\N	\N	\N	97072	97072	97073
21249	31423	1	applied	\N	\N	\N	\N	97074	97074	97075
21249	31424	2	applied	\N	\N	\N	\N	97076	97076	97077
21249	31425	3	applied	\N	\N	\N	\N	97078	97078	97079
21249	31426	4	applied	\N	\N	\N	\N	97080	97080	97081
21249	31427	5	applied	\N	\N	\N	\N	97082	97082	97083
21249	31428	6	applied	\N	\N	\N	\N	97084	97084	97085
21249	31429	7	applied	\N	\N	\N	\N	97086	97086	97087
21252	31422	0	applied	\N	\N	\N	\N	97072	97072	97073
21252	31423	1	applied	\N	\N	\N	\N	97074	97074	97075
21252	31424	2	applied	\N	\N	\N	\N	97076	97076	97077
21252	31425	3	applied	\N	\N	\N	\N	97078	97078	97079
21252	31426	4	applied	\N	\N	\N	\N	97080	97080	97081
21252	31427	5	applied	\N	\N	\N	\N	97082	97082	97083
21252	31428	6	applied	\N	\N	\N	\N	97084	97084	97085
21252	31429	7	applied	\N	\N	\N	\N	97086	97086	97087
21253	31430	0	applied	\N	\N	\N	\N	97096	97096	97097
21258	31435	0	applied	\N	\N	\N	\N	97112	97112	97113
21258	31436	1	applied	\N	\N	\N	\N	97114	97114	97115
21262	31441	0	applied	\N	\N	\N	\N	97129	97129	97130
21262	31442	1	applied	\N	\N	\N	\N	97131	97131	97132
21262	31443	2	applied	\N	\N	\N	\N	97133	97133	97134
21262	31444	3	applied	\N	\N	\N	\N	97135	97135	97136
21262	31445	4	applied	\N	\N	\N	\N	97137	97137	97138
21262	31446	5	applied	\N	\N	\N	\N	97139	97139	97140
21262	31447	6	applied	\N	\N	\N	\N	97141	97141	97142
21262	31448	7	applied	\N	\N	\N	\N	97143	97143	97144
21264	31449	0	applied	\N	\N	\N	\N	97147	97147	97148
21264	31450	1	applied	\N	\N	\N	\N	97149	97149	97150
21264	31451	2	applied	\N	\N	\N	\N	97151	97151	97152
21264	31452	3	applied	\N	\N	\N	\N	97153	97153	97154
21266	31449	0	applied	\N	\N	\N	\N	97147	97147	97148
21266	31450	1	applied	\N	\N	\N	\N	97149	97149	97150
21266	31451	2	applied	\N	\N	\N	\N	97151	97151	97152
21266	31452	3	applied	\N	\N	\N	\N	97153	97153	97154
21270	31454	0	applied	\N	\N	\N	\N	97164	97164	97165
21271	31455	0	applied	\N	\N	\N	\N	97168	97168	97169
21271	31456	1	applied	\N	\N	\N	\N	97170	97170	97171
21271	31457	2	applied	\N	\N	\N	\N	97172	97172	97173
21271	31458	3	applied	\N	\N	\N	\N	97174	97174	97175
21271	31459	4	applied	\N	\N	\N	\N	97176	97176	97177
21271	31460	5	applied	\N	\N	\N	\N	97178	97178	97179
21271	31461	6	applied	\N	\N	1000000000	\N	97180	97180	97181
21271	31462	7	applied	\N	\N	1000000000	\N	97182	97182	97183
21271	31463	8	applied	\N	\N	1000000000	\N	97184	97184	97185
21274	31474	0	applied	\N	\N	\N	\N	97211	97211	97212
21274	31475	1	applied	\N	\N	\N	\N	97213	97213	97214
21274	31476	2	applied	\N	\N	\N	\N	97215	97215	97216
21274	31477	3	applied	\N	\N	\N	\N	97217	97217	97218
21274	31478	4	applied	\N	\N	1000000000	\N	97219	97219	97220
21274	31466	5	applied	\N	\N	1000000000	\N	97192	97192	97193
21274	31479	6	applied	\N	\N	1000000000	\N	97221	97221	97222
21274	31480	7	applied	\N	\N	1000000000	\N	97223	97223	97224
21274	31481	8	applied	\N	\N	\N	\N	97225	97225	97226
21274	31482	9	applied	\N	\N	1000000000	\N	97227	97227	97228
21274	31467	10	applied	\N	\N	\N	\N	97194	97194	97229
21274	31483	11	applied	\N	\N	\N	\N	97230	97230	97231
21274	31484	12	applied	\N	\N	\N	\N	97232	97232	97233
21274	31468	13	applied	\N	\N	1000000000	\N	97196	97196	97197
21274	31469	14	applied	\N	\N	1000000000	\N	97198	97198	97199
21274	31470	15	applied	\N	\N	\N	\N	97200	97200	97201
21274	31471	16	applied	\N	\N	\N	\N	97202	97202	97203
21274	31472	17	applied	\N	\N	1000000000	\N	97204	97204	97205
21274	31473	18	applied	\N	\N	1000000000	\N	97206	97206	97207
21274	31485	19	applied	\N	\N	1000000000	\N	97234	97234	97235
21274	31486	20	applied	\N	\N	1000000000	\N	97236	97236	97237
21274	31487	21	applied	\N	\N	\N	\N	97238	97238	97239
21274	31488	22	applied	\N	\N	1000000000	\N	97240	97240	97241
21274	31489	23	applied	\N	\N	\N	\N	97242	97242	97243
21274	31490	24	applied	\N	\N	\N	\N	97244	97244	97245
21274	31491	25	applied	\N	\N	\N	\N	97246	97246	97247
21274	31492	26	applied	\N	\N	\N	\N	97248	97248	97249
21277	31416	0	applied	\N	\N	\N	\N	97059	97059	97060
21277	31464	1	applied	\N	\N	\N	\N	97261	97261	97189
21277	31422	2	applied	\N	\N	\N	\N	97262	97262	97073
21277	31417	3	applied	\N	\N	\N	\N	97061	97061	97062
21277	31423	4	applied	\N	\N	\N	\N	97263	97263	97075
21277	31424	5	applied	\N	\N	\N	\N	97264	97264	97077
21277	31425	6	applied	\N	\N	\N	\N	97265	97265	97079
21277	31419	7	applied	\N	\N	\N	\N	97065	97065	97066
21277	31420	8	applied	\N	\N	\N	\N	97067	97067	97068
21277	31477	9	applied	\N	\N	\N	\N	97217	97217	97266
21277	31478	10	applied	\N	\N	1000000000	\N	97219	97219	97220
21277	31479	11	applied	\N	\N	1000000000	\N	97221	97221	97222
21277	31480	12	applied	\N	\N	1000000000	\N	97223	97223	97224
21277	31481	13	applied	\N	\N	\N	\N	97225	97225	97226
21277	31482	14	applied	\N	\N	1000000000	\N	97227	97227	97228
21277	31461	15	applied	\N	\N	1000000000	\N	97180	97180	97181
21277	31462	16	applied	\N	\N	1000000000	\N	97182	97182	97183
21277	31463	17	applied	\N	\N	1000000000	\N	97184	97184	97185
21277	31466	18	applied	\N	\N	1000000000	\N	97192	97192	97193
21277	31468	19	applied	\N	\N	1000000000	\N	97196	97196	97197
21277	31469	20	applied	\N	\N	1000000000	\N	97198	97198	97199
21277	31470	21	applied	\N	\N	\N	\N	97200	97200	97201
21251	31424	2	applied	\N	\N	\N	\N	97076	97076	97077
21251	31425	3	applied	\N	\N	\N	\N	97078	97078	97079
21251	31426	4	applied	\N	\N	\N	\N	97080	97080	97081
21251	31427	5	applied	\N	\N	\N	\N	97082	97082	97083
21251	31428	6	applied	\N	\N	\N	\N	97084	97084	97085
21251	31429	7	applied	\N	\N	\N	\N	97086	97086	97087
21259	31437	0	applied	\N	\N	\N	\N	97117	97117	97118
21259	31438	1	applied	\N	\N	\N	\N	97119	97119	97120
21268	31449	0	applied	\N	\N	\N	\N	97147	97147	97148
21268	31450	1	applied	\N	\N	\N	\N	97149	97149	97150
21268	31451	2	applied	\N	\N	\N	\N	97151	97151	97152
21268	31452	3	applied	\N	\N	\N	\N	97153	97153	97154
21269	31453	0	applied	\N	\N	\N	\N	97162	97162	97163
21269	31454	1	applied	\N	\N	\N	\N	97164	97164	97165
21272	31464	0	applied	\N	\N	\N	\N	97188	97188	97189
21272	31465	1	applied	\N	\N	\N	\N	97190	97190	97191
21272	31466	2	applied	\N	\N	1000000000	\N	97192	97192	97193
21272	31467	3	applied	\N	\N	\N	\N	97194	97194	97195
21272	31468	4	applied	\N	\N	1000000000	\N	97196	97196	97197
21272	31469	5	applied	\N	\N	1000000000	\N	97198	97198	97199
21272	31470	6	applied	\N	\N	\N	\N	97200	97200	97201
21272	31471	7	applied	\N	\N	\N	\N	97202	97202	97203
21272	31472	8	applied	\N	\N	1000000000	\N	97204	97204	97205
21272	31473	9	applied	\N	\N	1000000000	\N	97206	97206	97207
21275	31493	0	applied	\N	\N	\N	\N	97252	97252	97253
21275	31494	1	applied	\N	\N	\N	\N	97254	97254	97255
21275	31495	2	applied	\N	\N	\N	\N	97256	97256	97257
21275	31496	3	applied	\N	\N	\N	\N	97258	97258	97259
21284	31503	0	applied	\N	\N	\N	\N	97298	97298	97299
21284	31504	1	applied	\N	\N	\N	\N	97300	97300	97301
21284	31505	2	applied	\N	\N	\N	\N	97302	97302	97303
21294	31530	0	applied	\N	\N	\N	\N	97368	97368	97369
21294	31531	1	applied	\N	\N	\N	\N	97370	97370	97371
21294	31532	2	applied	\N	\N	\N	\N	97372	97372	97373
21294	31533	3	applied	\N	\N	\N	\N	97374	97374	97375
21294	31534	4	applied	\N	\N	\N	\N	97376	97376	97377
21294	31535	5	applied	\N	\N	\N	\N	97378	97378	97379
21301	31539	0	applied	\N	\N	\N	\N	97394	97394	97395
21301	31540	1	applied	\N	\N	\N	\N	97396	97396	97397
21301	31541	2	applied	\N	\N	\N	\N	97398	97398	97399
21301	31542	3	applied	\N	\N	\N	\N	97400	97400	97401
21303	31543	0	applied	\N	\N	\N	\N	97409	97409	97410
21303	31544	1	applied	\N	\N	\N	\N	97411	97411	97412
21303	31545	2	applied	\N	\N	\N	\N	97413	97413	97414
21308	31547	0	applied	\N	\N	\N	\N	97423	97423	97424
21310	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21310	30942	1	applied	\N	\N	1000000000	\N	95607	95607	95608
21310	30933	2	applied	\N	\N	\N	\N	95583	95583	95584
21310	30934	3	applied	\N	\N	\N	\N	95585	95585	95586
21310	30952	4	applied	\N	\N	1000000000	\N	95629	95629	95630
21310	30999	5	applied	\N	\N	\N	\N	95779	95779	95754
21310	30935	6	applied	\N	\N	\N	\N	95587	95587	95588
21310	30936	7	applied	\N	\N	\N	\N	95589	95589	95590
21310	31008	8	applied	\N	\N	\N	\N	95780	95780	95781
21310	31416	9	applied	\N	\N	\N	\N	97059	97059	97060
21310	31139	10	applied	\N	\N	\N	\N	96212	96212	96213
21310	31400	11	applied	\N	\N	\N	\N	97008	97008	97009
21310	31250	12	applied	\N	\N	\N	\N	96577	96577	96578
21310	31422	13	applied	\N	\N	\N	\N	97262	97262	97073
21310	31417	14	applied	\N	\N	\N	\N	97061	97061	97062
21310	31401	15	applied	\N	\N	\N	\N	97010	97010	97011
21310	31423	16	applied	\N	\N	\N	\N	97263	97263	97075
21310	31424	17	applied	\N	\N	\N	\N	97264	97264	97077
21310	31425	18	applied	\N	\N	\N	\N	97265	97265	97079
21310	31084	19	applied	\N	\N	\N	\N	96048	96048	96049
21310	31085	20	applied	\N	\N	\N	\N	96050	96050	96051
21310	31402	21	applied	\N	\N	\N	\N	97012	97012	97013
21310	30899	22	applied	\N	\N	\N	\N	95500	95500	95501
21310	31142	23	applied	\N	\N	\N	\N	96220	96220	96221
21310	31143	24	applied	\N	\N	\N	\N	96222	96222	96223
21310	31144	25	applied	\N	\N	\N	\N	96224	96224	96225
21310	31145	26	applied	\N	\N	\N	\N	96226	96226	96227
21310	30926	27	applied	\N	\N	\N	\N	95565	95565	47675
21310	31086	28	applied	\N	\N	\N	\N	96052	96052	96053
21310	31146	29	applied	\N	\N	\N	\N	96228	96228	96229
21310	30946	30	applied	\N	\N	\N	\N	95617	95617	95618
21310	30900	31	applied	\N	\N	\N	\N	95502	95502	95503
21310	30906	32	applied	\N	\N	\N	\N	95518	95518	95519
21310	30908	33	applied	\N	\N	\N	\N	95524	95524	95525
21310	30909	34	applied	\N	\N	\N	\N	95526	95526	95527
21310	30914	35	applied	\N	\N	\N	\N	95537	95537	95538
21310	31419	36	applied	\N	\N	\N	\N	97065	97065	97066
21310	31420	37	applied	\N	\N	\N	\N	97067	97067	97068
21310	30903	38	applied	\N	\N	\N	\N	95510	95510	95511
21310	30905	39	applied	\N	\N	\N	\N	95516	95516	95517
21310	31052	40	applied	\N	\N	\N	\N	95918	95918	95919
21310	31053	41	applied	\N	\N	\N	\N	95920	95920	95921
21310	31054	42	applied	\N	\N	\N	\N	95922	95922	95923
21310	31055	43	applied	\N	\N	\N	\N	95924	95924	95925
21310	30910	44	applied	\N	\N	\N	\N	95528	95528	95529
21310	30913	45	applied	\N	\N	\N	\N	95535	95535	95536
21310	30916	47	applied	\N	\N	\N	\N	95542	95542	95543
21310	30918	48	applied	\N	\N	\N	\N	95546	95546	95547
21310	30921	49	applied	\N	\N	\N	\N	95554	95554	95555
21310	30923	50	applied	\N	\N	\N	\N	95559	95559	95560
21310	30924	51	applied	\N	\N	\N	\N	95561	95561	95562
21310	30925	52	applied	\N	\N	\N	\N	95563	95563	95564
21310	30931	53	applied	\N	\N	\N	\N	95577	95577	95578
21310	30937	54	applied	\N	\N	\N	\N	95591	95591	95592
21310	30938	55	applied	\N	\N	\N	\N	95593	95593	95594
21310	30943	56	applied	\N	\N	\N	\N	95609	95609	95610
21310	30945	57	applied	\N	\N	\N	\N	95615	95615	95616
21310	30947	58	applied	\N	\N	\N	\N	95619	95619	95620
21310	30953	59	applied	\N	\N	\N	\N	95631	95631	95632
21310	30955	60	applied	\N	\N	\N	\N	95636	95636	95637
21310	30959	61	applied	\N	\N	\N	\N	95646	95646	95647
21310	30964	62	applied	\N	\N	\N	\N	95656	95656	95657
21310	30967	63	applied	\N	\N	\N	\N	95664	95664	95665
21310	30968	64	applied	\N	\N	\N	\N	95666	95666	95667
21310	30971	65	applied	\N	\N	\N	\N	95674	95674	95675
21310	30972	66	applied	\N	\N	\N	\N	95676	95676	95677
21310	30973	67	applied	\N	\N	\N	\N	95678	95678	95679
21310	30978	68	applied	\N	\N	\N	\N	95694	95694	95695
21310	30981	69	applied	\N	\N	\N	\N	95701	95701	95702
21310	30983	70	applied	\N	\N	\N	\N	95708	95708	95709
21310	30985	71	applied	\N	\N	\N	\N	95714	95714	95715
21310	30987	72	applied	\N	\N	\N	\N	95721	95721	95722
21310	30990	73	applied	\N	\N	\N	\N	95729	95729	95730
21310	30992	74	applied	\N	\N	\N	\N	95737	95737	95738
21277	31471	22	applied	\N	\N	\N	\N	97202	97202	97203
21277	31472	23	applied	\N	\N	1000000000	\N	97204	97204	97205
21277	31473	24	applied	\N	\N	1000000000	\N	97206	97206	97207
21277	31485	25	applied	\N	\N	1000000000	\N	97234	97234	97235
21277	31486	26	applied	\N	\N	1000000000	\N	97236	97236	97237
21277	31487	27	applied	\N	\N	\N	\N	97238	97238	97239
21277	31488	28	applied	\N	\N	1000000000	\N	97240	97240	97241
21277	31489	29	applied	\N	\N	\N	\N	97242	97242	97267
21277	31490	30	applied	\N	\N	\N	\N	97244	97244	97245
21277	31495	31	applied	\N	\N	\N	\N	97256	97256	96163
21280	31464	0	applied	\N	\N	\N	\N	97188	97188	97189
21280	31441	1	applied	\N	\N	\N	\N	97129	97129	97130
21280	31442	2	applied	\N	\N	\N	\N	97131	97131	97132
21280	31443	3	applied	\N	\N	\N	\N	97133	97133	97134
21280	31444	4	applied	\N	\N	\N	\N	97135	97135	97136
21280	31449	5	applied	\N	\N	\N	\N	97147	97147	97148
21280	31450	6	applied	\N	\N	\N	\N	97149	97149	97150
21280	31453	7	applied	\N	\N	\N	\N	97162	97162	97163
21280	31455	8	applied	\N	\N	\N	\N	97168	97168	97169
21280	31456	9	applied	\N	\N	\N	\N	97170	97170	97171
21280	31457	10	applied	\N	\N	\N	\N	97172	97172	97173
21280	31465	11	applied	\N	\N	\N	\N	97190	97190	97191
21280	31474	12	applied	\N	\N	\N	\N	97211	97211	97212
21280	31475	13	applied	\N	\N	\N	\N	97213	97213	97214
21280	31476	14	applied	\N	\N	\N	\N	97215	97215	97216
21280	31493	15	applied	\N	\N	\N	\N	97252	97252	97253
21280	31458	16	applied	\N	\N	\N	\N	97174	97174	97271
21280	31477	17	applied	\N	\N	\N	\N	97217	97217	97140
21280	31478	18	applied	\N	\N	1000000000	\N	97219	97219	97220
21280	31445	19	applied	\N	\N	\N	\N	97137	97137	97142
21280	31479	20	applied	\N	\N	1000000000	\N	97221	97221	97222
21280	31480	21	applied	\N	\N	1000000000	\N	97223	97223	97224
21280	31481	22	applied	\N	\N	\N	\N	97225	97225	97226
21280	31482	23	applied	\N	\N	1000000000	\N	97227	97227	97228
21280	31446	24	applied	\N	\N	\N	\N	97139	97139	97144
21280	31484	25	applied	\N	\N	\N	\N	97232	97232	97272
21280	31496	26	applied	\N	\N	\N	\N	97258	97258	97152
21280	31461	27	applied	\N	\N	1000000000	\N	97180	97180	97181
21280	31462	28	applied	\N	\N	1000000000	\N	97182	97182	97183
21280	31463	29	applied	\N	\N	1000000000	\N	97184	97184	97185
21280	31466	30	applied	\N	\N	1000000000	\N	97192	97192	97193
21280	31447	31	applied	\N	\N	\N	\N	97141	97141	97154
21280	31448	32	applied	\N	\N	\N	\N	97143	97143	97165
21280	31451	33	applied	\N	\N	\N	\N	97151	97151	97273
21280	31452	34	applied	\N	\N	\N	\N	97153	97153	97274
21280	31454	35	applied	\N	\N	\N	\N	97164	97164	97275
21280	31459	36	applied	\N	\N	\N	\N	97176	97176	97218
21280	31460	37	applied	\N	\N	\N	\N	97178	97178	97229
21280	31467	38	applied	\N	\N	\N	\N	97194	97194	97231
21280	31483	39	applied	\N	\N	\N	\N	97230	97230	97276
21280	31468	40	applied	\N	\N	1000000000	\N	97196	97196	97197
21280	31469	41	applied	\N	\N	1000000000	\N	97198	97198	97199
21280	31470	42	applied	\N	\N	\N	\N	97200	97200	97201
21280	31471	43	applied	\N	\N	\N	\N	97202	97202	97203
21280	31472	44	applied	\N	\N	1000000000	\N	97204	97204	97205
21280	31473	45	applied	\N	\N	1000000000	\N	97206	97206	97207
21280	31485	46	applied	\N	\N	1000000000	\N	97234	97234	97235
21280	31486	47	applied	\N	\N	1000000000	\N	97236	97236	97237
21280	31487	48	applied	\N	\N	\N	\N	97238	97238	97239
21280	31488	49	applied	\N	\N	1000000000	\N	97240	97240	97241
21280	31489	50	applied	\N	\N	\N	\N	97242	97242	97277
21280	31490	51	applied	\N	\N	\N	\N	97244	97244	97245
21280	31495	52	applied	\N	\N	\N	\N	97256	97256	97249
21280	31491	53	applied	\N	\N	\N	\N	97246	97246	97255
21280	31492	54	applied	\N	\N	\N	\N	97248	97248	97278
21280	31494	55	applied	\N	\N	\N	\N	97254	97254	97259
21283	31497	0	applied	\N	\N	\N	\N	97280	97280	97281
21283	31498	1	applied	\N	\N	\N	\N	97282	97282	97283
21283	31499	2	applied	\N	\N	\N	\N	97284	97284	97285
21283	31500	3	applied	\N	\N	\N	\N	97286	97286	97287
21283	31501	4	applied	\N	\N	\N	\N	97288	97288	97289
21283	31502	6	applied	\N	\N	\N	\N	97291	97291	97292
21285	31506	0	applied	\N	\N	\N	\N	97306	97306	97307
21285	31507	1	applied	\N	\N	\N	\N	97308	97308	97309
21285	31508	2	applied	\N	\N	\N	\N	97310	97310	97311
21285	31509	3	applied	\N	\N	\N	\N	97312	97312	97313
21288	31516	0	applied	\N	\N	\N	\N	97331	97331	97332
21288	31517	1	applied	\N	\N	\N	\N	97333	97333	97334
21288	31518	2	applied	\N	\N	\N	\N	97335	97335	97336
21288	31519	3	applied	\N	\N	\N	\N	97337	97337	97338
21293	31526	0	applied	\N	\N	\N	\N	97357	97357	97358
21293	31527	1	applied	\N	\N	\N	\N	97359	97359	97360
21293	31528	2	applied	\N	\N	\N	\N	97361	97361	97362
21293	31529	3	applied	\N	\N	\N	\N	97363	97363	97364
21296	31530	0	applied	\N	\N	\N	\N	97368	97368	97369
21296	31531	1	applied	\N	\N	\N	\N	97370	97370	97371
21296	31532	2	applied	\N	\N	\N	\N	97372	97372	97373
21296	31533	3	applied	\N	\N	\N	\N	97374	97374	97375
21296	31534	4	applied	\N	\N	\N	\N	97376	97376	97377
21296	31535	5	applied	\N	\N	\N	\N	97378	97378	97379
21298	31536	0	applied	\N	\N	\N	\N	97385	97385	97386
21298	31537	1	applied	\N	\N	\N	\N	97387	97387	97388
21298	31538	2	applied	\N	\N	\N	\N	97389	97389	97390
21302	31138	0	applied	\N	\N	\N	\N	96210	96210	96211
21302	31416	1	applied	\N	\N	\N	\N	97059	97059	97060
21302	31464	2	applied	\N	\N	\N	\N	97261	97261	97189
21302	31109	3	applied	\N	\N	\N	\N	96125	96125	96126
21302	31139	4	applied	\N	\N	\N	\N	96212	96212	96213
21302	31400	5	applied	\N	\N	\N	\N	97008	97008	97009
21302	31250	6	applied	\N	\N	\N	\N	96577	96577	96578
21302	31422	7	applied	\N	\N	\N	\N	97262	97262	97073
21302	31417	8	applied	\N	\N	\N	\N	97061	97061	97062
21302	31401	9	applied	\N	\N	\N	\N	97010	97010	97011
21302	31423	10	applied	\N	\N	\N	\N	97263	97263	97075
21302	31424	11	applied	\N	\N	\N	\N	97264	97264	97077
21302	31425	12	applied	\N	\N	\N	\N	97265	97265	97079
21302	31402	13	applied	\N	\N	\N	\N	97012	97012	97013
21302	31142	14	applied	\N	\N	\N	\N	96220	96220	96221
21302	31143	15	applied	\N	\N	\N	\N	96222	96222	96223
21302	31144	16	applied	\N	\N	\N	\N	96224	96224	96225
21302	31145	17	applied	\N	\N	\N	\N	96226	96226	96227
21302	31419	18	applied	\N	\N	\N	\N	97065	97065	97066
21302	31420	19	applied	\N	\N	\N	\N	97067	97067	97068
21302	31110	20	applied	\N	\N	\N	\N	96129	96129	96130
21302	31113	21	applied	\N	\N	\N	\N	96140	96140	96141
21302	31114	22	applied	\N	\N	\N	\N	96142	96142	96143
21302	31118	23	applied	\N	\N	\N	\N	96152	96152	96153
21290	31522	2	applied	\N	\N	\N	\N	97346	97346	97347
21290	31523	3	applied	\N	\N	\N	\N	97348	97348	97349
21290	31524	4	applied	\N	\N	\N	\N	97350	97350	97351
21290	31525	5	applied	\N	\N	\N	\N	97352	97352	97353
21292	31526	0	applied	\N	\N	\N	\N	97357	97357	97358
21292	31527	1	applied	\N	\N	\N	\N	97359	97359	97360
21292	31528	2	applied	\N	\N	\N	\N	97361	97361	97362
21292	31529	3	applied	\N	\N	\N	\N	97363	97363	97364
21295	31530	0	applied	\N	\N	\N	\N	97368	97368	97369
21295	31531	1	applied	\N	\N	\N	\N	97370	97370	97371
21295	31532	2	applied	\N	\N	\N	\N	97372	97372	97373
21295	31533	3	applied	\N	\N	\N	\N	97374	97374	97375
21295	31534	4	applied	\N	\N	\N	\N	97376	97376	97377
21295	31535	5	applied	\N	\N	\N	\N	97378	97378	97379
21297	31536	0	applied	\N	\N	\N	\N	97385	97385	97386
21297	31537	1	applied	\N	\N	\N	\N	97387	97387	97388
21297	31538	2	applied	\N	\N	\N	\N	97389	97389	97390
21304	31543	0	applied	\N	\N	\N	\N	97409	97409	97410
21304	31544	1	applied	\N	\N	\N	\N	97411	97411	97412
21304	31545	2	applied	\N	\N	\N	\N	97413	97413	97414
21309	31546	0	applied	\N	\N	\N	\N	97421	97421	97422
21309	31547	1	applied	\N	\N	\N	\N	97423	97423	97424
21309	31548	2	applied	\N	\N	\N	\N	97425	97425	97426
21312	31546	0	applied	\N	\N	\N	\N	97421	97421	97422
21312	31547	1	applied	\N	\N	\N	\N	97423	97423	97424
21312	31548	2	applied	\N	\N	\N	\N	97425	97425	97426
21320	31571	0	applied	\N	\N	\N	\N	97489	97489	97490
21320	31572	1	applied	\N	\N	\N	\N	97491	97491	29193
21320	31573	2	applied	\N	\N	\N	\N	97492	97492	97493
21320	31574	3	applied	\N	\N	\N	\N	97494	97494	97495
21323	31579	0	applied	\N	\N	\N	\N	97507	97507	97508
21323	31580	1	applied	\N	\N	\N	\N	97509	97509	97510
21323	31581	2	applied	\N	\N	\N	\N	97511	97511	97512
21325	31586	0	applied	\N	\N	\N	\N	97526	97526	97527
21325	31587	2	applied	\N	\N	\N	\N	97529	97529	97530
21325	31588	3	applied	\N	\N	\N	\N	97531	97531	97532
21328	31589	0	applied	\N	\N	\N	\N	97535	97535	97536
21328	31590	1	applied	\N	\N	\N	\N	97537	97537	97538
21328	31591	2	applied	\N	\N	\N	\N	97539	97539	97540
21332	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21332	31593	1	applied	\N	\N	\N	\N	97550	97550	97551
21332	31594	2	applied	\N	\N	\N	\N	97552	97552	97553
21332	31595	3	applied	\N	\N	\N	\N	97554	97554	97555
21332	31596	4	applied	\N	\N	\N	\N	97556	97556	97557
21334	31597	0	applied	\N	\N	\N	\N	97563	97563	97564
21334	31598	1	applied	\N	\N	\N	\N	97565	97565	97566
21336	31599	0	applied	\N	\N	\N	\N	97569	97569	97570
21336	31600	1	applied	\N	\N	\N	\N	97571	97571	97572
21336	31601	2	applied	\N	\N	\N	\N	97573	97573	97574
21343	31610	0	applied	\N	\N	\N	\N	97600	97600	97601
21343	31611	1	applied	\N	\N	\N	\N	97602	97602	97603
21343	31612	2	applied	\N	\N	\N	\N	97604	97604	97605
21343	31613	3	applied	\N	\N	\N	\N	97606	97606	97607
21343	31614	4	applied	\N	\N	\N	\N	97608	97608	97609
21343	31615	5	applied	\N	\N	\N	\N	97610	97610	97611
21346	31610	0	applied	\N	\N	\N	\N	97600	97600	97601
21346	31611	1	applied	\N	\N	\N	\N	97602	97602	97603
21346	31612	2	applied	\N	\N	\N	\N	97604	97604	97605
21346	31613	3	applied	\N	\N	\N	\N	97606	97606	97607
21346	31614	4	applied	\N	\N	\N	\N	97608	97608	97609
21346	31615	5	applied	\N	\N	\N	\N	97610	97610	97611
21348	31616	0	applied	\N	\N	\N	\N	97617	97617	97618
21348	31617	1	applied	\N	\N	\N	\N	97619	97619	97620
21348	31618	2	applied	\N	\N	\N	\N	97621	97621	97622
21348	31619	3	applied	\N	\N	\N	\N	97623	97623	97624
21348	31620	4	applied	\N	\N	\N	\N	97625	97625	97626
21348	31621	5	applied	\N	\N	\N	\N	97627	97627	97628
21348	31622	6	applied	\N	\N	\N	\N	97629	97629	97630
21348	31623	7	applied	\N	\N	1000000000	\N	97631	97631	97632
21348	31624	8	applied	\N	\N	\N	\N	97633	97633	97634
21348	31625	9	applied	\N	\N	\N	\N	97635	97635	97636
21348	31626	10	applied	\N	\N	\N	\N	97637	97637	97638
21348	31627	11	applied	\N	\N	\N	\N	97639	97639	97640
21353	31638	0	applied	\N	\N	\N	\N	97667	97667	97668
21353	31639	1	applied	\N	\N	\N	\N	97669	97669	97670
21353	31640	2	applied	\N	\N	\N	\N	97671	97671	97672
21353	31641	3	applied	\N	\N	\N	\N	97673	97673	97674
21360	31659	0	applied	\N	\N	\N	\N	97719	97719	97720
21360	31660	1	applied	\N	\N	\N	\N	97721	97721	97722
21360	31661	2	applied	\N	\N	\N	\N	97723	97723	97724
21360	31662	3	applied	\N	\N	\N	\N	97725	97725	97726
21360	31663	4	applied	\N	\N	\N	\N	97727	97727	97728
21360	31664	5	applied	\N	\N	\N	\N	97729	97729	97730
21360	31665	6	applied	\N	\N	\N	\N	97731	97731	97732
21360	31666	7	applied	\N	\N	\N	\N	97733	97733	97734
21360	31667	8	applied	\N	\N	\N	\N	97735	97735	97736
21360	31668	9	applied	\N	\N	\N	\N	97737	97737	97738
21360	31669	10	applied	\N	\N	\N	\N	97739	97739	97740
21360	31670	11	applied	\N	\N	\N	\N	97741	97741	97742
21360	31671	12	applied	\N	\N	\N	\N	97743	97743	97744
21360	31672	13	applied	\N	\N	\N	\N	97745	97745	97746
21360	31673	14	applied	\N	\N	\N	\N	97747	97747	97748
21360	31674	15	applied	\N	\N	\N	\N	97749	97749	97750
21360	31675	16	applied	\N	\N	\N	\N	97751	97751	97752
21360	31676	17	applied	\N	\N	\N	\N	97753	97753	97754
21360	31677	18	applied	\N	\N	\N	\N	97755	97755	97756
21369	31684	0	applied	\N	\N	\N	\N	97787	97787	97788
21369	31685	1	applied	\N	\N	\N	\N	97789	97789	97790
21369	31686	2	applied	\N	\N	\N	\N	97791	97791	97792
21369	31687	3	applied	\N	\N	\N	\N	97793	97793	97794
21380	31698	0	applied	\N	\N	\N	\N	97824	97824	97825
21380	31699	1	applied	\N	\N	\N	\N	97826	97826	97827
21380	31700	2	applied	\N	\N	\N	\N	97828	97828	97829
21380	31701	3	applied	\N	\N	\N	\N	97830	97830	97671
21386	31715	0	applied	\N	\N	\N	\N	97863	97863	97864
21386	31716	1	applied	\N	\N	\N	\N	97865	97865	97866
21386	31717	2	applied	\N	\N	\N	\N	97867	97867	97868
21392	31602	0	applied	\N	\N	\N	\N	97579	97579	97580
21392	31603	1	applied	\N	\N	\N	\N	97581	97581	97582
21392	31616	2	applied	\N	\N	\N	\N	97617	97617	97618
21392	31599	3	applied	\N	\N	\N	\N	97569	97569	97570
21392	31719	4	applied	\N	\N	1000000000	\N	97874	97874	97875
21392	31604	5	applied	\N	\N	\N	\N	97583	97583	97584
21392	31607	6	applied	\N	\N	\N	\N	97591	97591	97592
21392	31610	7	applied	\N	\N	\N	\N	97600	97600	97601
21392	31611	8	applied	\N	\N	\N	\N	97602	97602	97603
21392	31617	9	applied	\N	\N	\N	\N	97619	97619	97620
21392	31618	10	applied	\N	\N	\N	\N	97621	97621	97622
21392	31619	11	applied	\N	\N	\N	\N	97623	97623	97624
21302	31120	24	applied	\N	\N	\N	\N	96160	96160	96161
21302	31123	25	applied	\N	\N	\N	\N	96170	96170	96171
21302	31125	26	applied	\N	\N	\N	\N	96177	96177	96178
21302	31126	27	applied	\N	\N	\N	\N	96179	96179	96180
21302	31129	28	applied	\N	\N	\N	\N	96188	96188	96189
21302	31131	29	applied	\N	\N	\N	\N	96192	96192	96193
21302	31133	30	applied	\N	\N	\N	\N	96198	96198	96199
21302	31134	31	applied	\N	\N	\N	\N	96200	96200	96201
21302	31140	32	applied	\N	\N	\N	\N	96214	96214	96215
21302	31147	33	applied	\N	\N	\N	\N	96246	96246	96247
21302	31149	34	applied	\N	\N	\N	\N	96260	96260	96261
21302	31152	35	applied	\N	\N	\N	\N	96273	96273	96274
21302	31153	36	applied	\N	\N	\N	\N	96275	96275	96276
21302	31154	37	applied	\N	\N	\N	\N	96277	96277	96278
21302	31158	38	applied	\N	\N	\N	\N	96287	96287	96288
21302	31161	39	applied	\N	\N	\N	\N	96296	96296	96297
21302	31163	40	applied	\N	\N	\N	\N	96303	96303	96304
21302	31165	41	applied	\N	\N	\N	\N	96307	96307	96308
21302	31168	42	applied	\N	\N	\N	\N	96317	96317	96318
21302	31170	43	applied	\N	\N	\N	\N	96322	96322	96323
21302	31172	44	applied	\N	\N	\N	\N	96328	96328	96329
21302	31173	45	applied	\N	\N	\N	\N	96330	96330	96331
21302	31177	46	applied	\N	\N	\N	\N	96347	96347	96348
21302	31179	47	applied	\N	\N	\N	\N	96355	96355	96356
21302	31180	48	applied	\N	\N	\N	\N	96357	96357	96358
21302	31184	49	applied	\N	\N	\N	\N	96369	96369	96370
21302	31185	50	applied	\N	\N	\N	\N	96371	96371	96372
21302	31188	51	applied	\N	\N	\N	\N	96384	96384	96385
21302	31191	52	applied	\N	\N	\N	\N	96394	96394	96395
21302	31192	53	applied	\N	\N	\N	\N	96399	96399	96400
21302	31194	54	applied	\N	\N	\N	\N	96405	96405	96406
21302	31197	55	applied	\N	\N	\N	\N	96411	96411	96412
21302	31199	56	applied	\N	\N	\N	\N	96419	96419	96420
21302	31201	57	applied	\N	\N	\N	\N	96426	96426	96427
21302	31202	58	applied	\N	\N	\N	\N	96430	96430	96431
21302	31205	59	applied	\N	\N	\N	\N	96441	96441	96442
21302	31207	60	applied	\N	\N	\N	\N	96447	96447	96448
21302	31209	61	applied	\N	\N	\N	\N	96453	96453	96454
21302	31212	62	applied	\N	\N	\N	\N	96460	96460	96461
21302	31213	63	applied	\N	\N	\N	\N	96462	96462	96463
21302	31216	64	applied	\N	\N	\N	\N	96470	96470	96471
21302	31219	65	applied	\N	\N	\N	\N	96480	96480	96481
21302	31220	66	applied	\N	\N	\N	\N	96482	96482	96483
21302	31221	67	applied	\N	\N	\N	\N	96484	96484	96485
21302	31227	68	applied	\N	\N	\N	\N	96500	96500	96501
21302	31229	69	applied	\N	\N	\N	\N	96508	96508	96509
21302	31231	70	applied	\N	\N	\N	\N	96516	96516	96517
21302	31234	71	applied	\N	\N	\N	\N	96528	96528	96529
21302	31235	72	applied	\N	\N	\N	\N	96530	96530	96531
21302	31238	73	applied	\N	\N	\N	\N	96542	96542	96543
21302	31241	74	applied	\N	\N	\N	\N	96551	96551	96552
21302	31243	75	applied	\N	\N	\N	\N	96559	96559	96560
21302	31244	76	applied	\N	\N	\N	\N	96561	96561	96562
21302	31247	77	applied	\N	\N	\N	\N	96569	96569	96570
21302	31251	78	applied	\N	\N	\N	\N	96579	96579	96580
21302	31252	79	applied	\N	\N	\N	\N	96582	96582	96583
21302	31253	80	applied	\N	\N	\N	\N	96584	96584	96585
21302	31254	81	applied	\N	\N	\N	\N	96586	96586	96587
21302	31260	82	applied	\N	\N	\N	\N	96601	96601	96602
21302	31262	83	applied	\N	\N	\N	\N	96605	96605	96606
21302	31263	84	applied	\N	\N	\N	\N	96607	96607	96608
21302	31266	85	applied	\N	\N	\N	\N	96616	96616	96617
21302	31267	86	applied	\N	\N	\N	\N	96618	96618	96619
21302	31271	87	applied	\N	\N	\N	\N	96627	96627	96628
21302	31273	88	applied	\N	\N	\N	\N	96634	96634	96635
21302	31275	89	applied	\N	\N	\N	\N	96640	96640	96641
21302	31277	90	applied	\N	\N	\N	\N	96645	96645	96646
21302	31279	91	applied	\N	\N	\N	\N	96651	96651	96652
21302	31280	92	applied	\N	\N	\N	\N	96653	96653	96654
21302	31281	93	applied	\N	\N	\N	\N	96655	96655	96656
21302	31285	94	applied	\N	\N	\N	\N	96665	96665	96666
21302	31287	95	applied	\N	\N	\N	\N	96673	96673	96674
21302	31289	96	applied	\N	\N	\N	\N	96679	96679	96680
21302	31291	97	applied	\N	\N	\N	\N	96687	96687	96688
21302	31293	98	applied	\N	\N	\N	\N	96692	96692	96693
21302	31295	99	applied	\N	\N	\N	\N	96702	96702	96703
21302	31297	100	applied	\N	\N	\N	\N	96713	96713	96714
21302	31298	101	applied	\N	\N	\N	\N	96715	96715	96716
21302	31299	102	applied	\N	\N	\N	\N	96717	96717	96718
21302	31302	103	applied	\N	\N	\N	\N	96726	96726	96727
21302	31304	104	applied	\N	\N	\N	\N	96732	96732	96733
21302	31305	105	applied	\N	\N	\N	\N	96734	96734	96735
21302	31308	107	applied	\N	\N	\N	\N	96741	96741	96742
21302	31310	108	applied	\N	\N	\N	\N	96747	96747	96748
21302	31311	109	applied	\N	\N	\N	\N	96749	96749	96750
21302	31312	110	applied	\N	\N	\N	\N	96751	96751	96752
21302	31316	111	applied	\N	\N	\N	\N	96762	96762	96763
21302	31318	112	applied	\N	\N	\N	\N	96769	96769	96770
21302	31319	113	applied	\N	\N	\N	\N	96776	96776	96777
21302	31320	114	applied	\N	\N	\N	\N	96778	96778	96779
21302	31321	115	applied	\N	\N	\N	\N	96780	96780	96781
21302	31326	116	applied	\N	\N	\N	\N	96794	96794	96795
21302	31329	117	applied	\N	\N	\N	\N	96802	96802	96803
21302	31331	118	applied	\N	\N	\N	\N	96807	96807	96808
21302	31333	119	applied	\N	\N	\N	\N	96820	96820	96821
21302	31335	120	applied	\N	\N	\N	\N	96824	96824	96825
21302	31336	121	applied	\N	\N	\N	\N	96826	96826	96827
21302	31337	122	applied	\N	\N	\N	\N	96828	96828	96829
21302	31345	123	applied	\N	\N	\N	\N	96846	96846	96847
21302	31346	124	applied	\N	\N	\N	\N	96848	96848	96849
21302	31347	125	applied	\N	\N	\N	\N	96850	96850	96851
21306	31546	0	applied	\N	\N	\N	\N	97421	97421	97422
21306	31547	1	applied	\N	\N	\N	\N	97423	97423	97424
21306	31548	2	applied	\N	\N	\N	\N	97425	97425	97426
21313	31549	0	applied	\N	\N	\N	\N	97436	97436	97437
21313	31550	1	applied	\N	\N	\N	\N	97438	97438	97439
21315	31551	0	applied	\N	\N	\N	\N	97442	97442	97443
21315	31552	1	applied	\N	\N	\N	\N	97444	97444	97445
21315	31553	2	applied	\N	\N	\N	\N	97446	97446	97447
21315	31554	3	applied	\N	\N	\N	\N	97448	97448	97449
21321	31575	0	applied	\N	\N	\N	\N	97498	97498	97499
21321	31576	1	applied	\N	\N	\N	\N	97500	97500	97501
21321	31577	2	applied	\N	\N	\N	\N	97502	97502	97503
21321	31578	3	applied	\N	\N	\N	\N	97504	97504	97505
21326	31586	0	applied	\N	\N	\N	\N	97526	97526	97527
21326	31587	2	applied	\N	\N	\N	\N	97529	97529	97530
21326	31588	3	applied	\N	\N	\N	\N	97531	97531	97532
21335	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21335	31593	1	applied	\N	\N	\N	\N	97550	97550	97551
21335	31597	2	applied	\N	\N	\N	\N	97563	97563	97564
21310	31018	75	applied	\N	\N	\N	\N	95821	95821	95822
21310	31019	76	applied	\N	\N	\N	\N	95823	95823	95824
21310	31020	77	applied	\N	\N	\N	\N	95825	95825	95826
21310	31021	78	applied	\N	\N	\N	\N	95827	95827	95828
21310	31026	79	applied	\N	\N	\N	\N	95841	95841	95842
21310	30993	80	applied	\N	\N	\N	\N	95739	95739	95740
21310	30994	81	applied	\N	\N	\N	\N	95741	95741	95742
21310	31000	82	applied	\N	\N	\N	\N	95755	95755	95756
21310	31002	83	applied	\N	\N	\N	\N	95765	95765	95766
21310	31003	84	applied	\N	\N	\N	\N	95767	95767	95768
21310	31006	85	applied	\N	\N	\N	\N	95775	95775	95776
21310	31403	86	applied	\N	\N	\N	\N	97014	97014	97015
21310	31009	87	applied	\N	\N	\N	\N	95784	95784	95785
21310	31010	88	applied	\N	\N	\N	\N	95786	95786	95787
21310	31014	89	applied	\N	\N	\N	\N	95796	95796	95797
21310	31016	90	applied	\N	\N	\N	\N	95810	95810	95811
21310	31024	91	applied	\N	\N	\N	\N	95835	95835	95836
21310	31027	92	applied	\N	\N	\N	\N	95843	95843	95844
21310	31029	93	applied	\N	\N	\N	\N	95851	95851	95852
21310	31032	94	applied	\N	\N	\N	\N	95861	95861	95862
21310	31034	95	applied	\N	\N	\N	\N	95866	95866	95867
21310	31036	96	applied	\N	\N	\N	\N	95872	95872	95873
21310	31038	97	applied	\N	\N	\N	\N	95878	95878	95879
21310	31041	98	applied	\N	\N	\N	\N	95884	95884	95885
21310	31043	99	applied	\N	\N	\N	\N	95892	95892	95893
21310	31045	100	applied	\N	\N	\N	\N	95899	95899	95900
21310	31048	101	applied	\N	\N	\N	\N	95906	95906	95907
21310	31049	102	applied	\N	\N	\N	\N	95908	95908	95909
21310	31056	103	applied	\N	\N	\N	\N	95926	95926	95927
21310	31057	104	applied	\N	\N	\N	\N	95928	95928	95929
21310	31058	105	applied	\N	\N	\N	\N	95930	95930	95931
21310	31059	106	applied	\N	\N	\N	\N	95932	95932	95933
21310	31065	107	applied	\N	\N	\N	\N	95973	95973	95974
21310	31066	108	applied	\N	\N	\N	\N	95975	95975	95976
21310	31070	109	applied	\N	\N	\N	\N	95985	95985	95986
21310	31072	110	applied	\N	\N	\N	\N	95995	95995	95996
21310	31073	111	applied	\N	\N	\N	\N	95997	95997	95998
21310	31077	112	applied	\N	\N	\N	\N	96008	96008	96009
21310	31079	113	applied	\N	\N	\N	\N	96034	96034	96035
21310	31082	114	applied	\N	\N	\N	\N	96044	96044	96045
21310	31083	115	applied	\N	\N	\N	\N	96046	96046	96047
21310	31089	116	applied	\N	\N	\N	\N	96060	96060	96061
21310	31090	117	applied	\N	\N	\N	\N	96062	96062	96063
21310	31094	118	applied	\N	\N	\N	\N	96072	96072	96073
21310	31096	119	applied	\N	\N	\N	\N	96081	96081	96082
21310	31097	120	applied	\N	\N	\N	\N	96083	96083	96084
21310	31098	121	applied	\N	\N	\N	\N	96085	96085	96086
21310	31102	122	applied	\N	\N	\N	\N	96099	96099	96100
21310	31104	123	applied	\N	\N	\N	\N	96106	96106	96107
21310	31107	124	applied	\N	\N	\N	\N	96116	96116	96117
21310	31109	125	applied	\N	\N	\N	\N	96125	96125	96126
21314	31551	0	applied	\N	\N	\N	\N	97442	97442	97443
21314	31552	1	applied	\N	\N	\N	\N	97444	97444	97445
21314	31553	2	applied	\N	\N	\N	\N	97446	97446	97447
21314	31554	3	applied	\N	\N	\N	\N	97448	97448	97449
21318	31558	0	applied	\N	\N	\N	\N	97462	97462	97463
21318	31559	1	applied	\N	\N	\N	\N	97464	97464	97465
21318	31560	2	applied	\N	\N	\N	\N	97466	97466	97467
21318	31561	3	applied	\N	\N	\N	\N	97468	97468	97469
21318	31562	4	applied	\N	\N	\N	\N	97470	97470	97471
21318	31563	5	applied	\N	\N	\N	\N	97472	97472	97473
21318	31564	6	applied	\N	\N	\N	\N	97474	97474	97475
21318	31565	7	applied	\N	\N	\N	\N	97476	97476	97477
21318	31566	8	applied	\N	\N	\N	\N	97478	97478	97479
21318	31567	9	applied	\N	\N	\N	\N	97480	97480	97481
21318	31568	10	applied	\N	\N	\N	\N	97482	97482	97483
21318	31569	11	applied	\N	\N	\N	\N	97484	97484	97485
21318	31570	12	applied	\N	\N	\N	\N	97486	97486	97487
21322	31579	0	applied	\N	\N	\N	\N	97507	97507	97508
21322	31580	1	applied	\N	\N	\N	\N	97509	97509	97510
21322	31581	2	applied	\N	\N	\N	\N	97511	97511	97512
21327	31589	0	applied	\N	\N	\N	\N	97535	97535	97536
21327	31590	1	applied	\N	\N	\N	\N	97537	97537	97538
21327	31591	2	applied	\N	\N	\N	\N	97539	97539	97540
21330	31590	0	applied	\N	\N	\N	\N	97537	97537	97538
21330	31591	1	applied	\N	\N	\N	\N	97539	97539	97540
21331	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21331	31593	1	applied	\N	\N	\N	\N	97550	97550	97551
21331	31594	2	applied	\N	\N	\N	\N	97552	97552	97553
21331	31595	3	applied	\N	\N	\N	\N	97554	97554	97555
21331	31596	4	applied	\N	\N	\N	\N	97556	97556	97557
21333	31594	0	applied	\N	\N	\N	\N	97552	97552	97553
21333	31595	1	applied	\N	\N	\N	\N	97554	97554	97555
21333	31596	2	applied	\N	\N	\N	\N	97556	97556	97557
21339	31599	0	applied	\N	\N	\N	\N	97569	97569	97570
21339	31600	1	applied	\N	\N	\N	\N	97571	97571	97572
21339	31601	2	applied	\N	\N	\N	\N	97573	97573	97574
21340	31602	0	applied	\N	\N	\N	\N	97579	97579	97580
21340	31603	1	applied	\N	\N	\N	\N	97581	97581	97582
21340	31604	2	applied	\N	\N	\N	\N	97583	97583	97584
21340	31605	3	applied	\N	\N	\N	\N	97585	97585	97586
21340	31606	4	applied	\N	\N	\N	\N	97587	97587	97588
21350	31628	0	applied	\N	\N	\N	\N	97642	97642	97643
21350	31629	1	applied	\N	\N	\N	\N	97644	97644	97645
21350	31630	2	applied	\N	\N	\N	\N	97646	97646	97647
21350	31631	3	applied	\N	\N	\N	\N	97648	97648	97649
21355	31642	0	applied	\N	\N	\N	\N	97677	97677	97678
21355	31643	1	applied	\N	\N	\N	\N	97679	97679	97680
21355	31644	2	applied	\N	\N	\N	\N	97681	97681	97682
21355	31645	3	applied	\N	\N	\N	\N	97683	97683	97684
21359	31659	0	applied	\N	\N	\N	\N	97719	97719	97720
21359	31660	1	applied	\N	\N	\N	\N	97721	97721	97722
21359	31661	2	applied	\N	\N	\N	\N	97723	97723	97724
21359	31662	3	applied	\N	\N	\N	\N	97725	97725	97726
21359	31663	4	applied	\N	\N	\N	\N	97727	97727	97728
21359	31664	5	applied	\N	\N	\N	\N	97729	97729	97730
21359	31665	6	applied	\N	\N	\N	\N	97731	97731	97732
21359	31666	7	applied	\N	\N	\N	\N	97733	97733	97734
21359	31667	8	applied	\N	\N	\N	\N	97735	97735	97736
21359	31668	9	applied	\N	\N	\N	\N	97737	97737	97738
21359	31669	10	applied	\N	\N	\N	\N	97739	97739	97740
21359	31670	11	applied	\N	\N	\N	\N	97741	97741	97742
21359	31671	12	applied	\N	\N	\N	\N	97743	97743	97744
21359	31672	13	applied	\N	\N	\N	\N	97745	97745	97746
21359	31673	14	applied	\N	\N	\N	\N	97747	97747	97748
21359	31674	15	applied	\N	\N	\N	\N	97749	97749	97750
21359	31675	16	applied	\N	\N	\N	\N	97751	97751	97752
21359	31676	17	applied	\N	\N	\N	\N	97753	97753	97754
21359	31677	18	applied	\N	\N	\N	\N	97755	97755	97756
21362	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21324	31584	2	applied	\N	\N	\N	\N	97521	97521	97522
21324	31585	3	applied	\N	\N	\N	\N	97523	97523	97524
21329	31589	0	applied	\N	\N	\N	\N	97535	97535	97536
21329	31590	1	applied	\N	\N	\N	\N	97537	97537	97538
21329	31591	2	applied	\N	\N	\N	\N	97539	97539	97540
21338	31599	0	applied	\N	\N	\N	\N	97569	97569	97570
21338	31600	1	applied	\N	\N	\N	\N	97571	97571	97572
21338	31601	2	applied	\N	\N	\N	\N	97573	97573	97574
21342	31607	0	applied	\N	\N	\N	\N	97591	97591	97592
21342	31608	1	applied	\N	\N	\N	\N	97593	97593	97594
21342	31609	2	applied	\N	\N	\N	\N	97595	97595	97596
21345	31610	0	applied	\N	\N	\N	\N	97600	97600	97601
21345	31611	1	applied	\N	\N	\N	\N	97602	97602	97603
21345	31612	2	applied	\N	\N	\N	\N	97604	97604	97605
21345	31613	3	applied	\N	\N	\N	\N	97606	97606	97607
21345	31614	4	applied	\N	\N	\N	\N	97608	97608	97609
21345	31615	5	applied	\N	\N	\N	\N	97610	97610	97611
21349	31628	0	applied	\N	\N	\N	\N	97642	97642	97643
21349	31629	1	applied	\N	\N	\N	\N	97644	97644	97645
21349	31630	2	applied	\N	\N	\N	\N	97646	97646	97647
21349	31631	3	applied	\N	\N	\N	\N	97648	97648	97649
21352	31632	0	applied	\N	\N	\N	\N	97654	97654	97655
21352	31633	1	applied	\N	\N	\N	\N	97656	97656	97657
21352	31634	2	applied	\N	\N	\N	\N	97658	97658	97659
21352	31635	3	applied	\N	\N	\N	\N	97660	97660	97661
21352	31636	4	applied	\N	\N	\N	\N	97662	97662	97663
21352	31637	5	applied	\N	\N	\N	\N	97664	97664	97665
21354	31642	0	applied	\N	\N	\N	\N	97677	97677	97678
21354	31643	1	applied	\N	\N	\N	\N	97679	97679	97680
21354	31644	2	applied	\N	\N	\N	\N	97681	97681	97682
21354	31645	3	applied	\N	\N	\N	\N	97683	97683	97684
21357	31649	0	applied	\N	\N	\N	\N	97695	97695	97696
21357	31650	1	applied	\N	\N	\N	\N	97697	97697	97698
21357	31651	2	applied	\N	\N	\N	\N	97699	97699	97700
21357	31652	3	applied	\N	\N	\N	\N	97701	97701	97702
21357	31653	4	applied	\N	\N	\N	\N	97703	97703	97704
21357	31654	5	applied	\N	\N	\N	\N	97705	97705	97706
21357	31655	6	applied	\N	\N	\N	\N	97707	97707	97708
21357	31656	7	applied	\N	\N	\N	\N	97709	97709	97710
21357	31657	8	applied	\N	\N	\N	\N	97711	97711	97712
21357	31658	9	applied	\N	\N	\N	\N	97713	97713	97714
21358	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21358	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21358	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21358	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21358	31572	4	applied	\N	\N	\N	\N	97491	97491	29193
21358	31623	5	applied	\N	\N	1000000000	\N	97631	97631	97632
21358	31640	6	applied	\N	\N	\N	\N	97671	97671	97672
21361	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21361	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21361	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21361	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21361	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21361	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21368	31684	0	applied	\N	\N	\N	\N	97787	97787	97788
21368	31685	1	applied	\N	\N	\N	\N	97789	97789	97790
21368	31686	2	applied	\N	\N	\N	\N	97791	97791	97792
21368	31687	3	applied	\N	\N	\N	\N	97793	97793	97794
21370	31688	0	applied	\N	\N	\N	\N	97796	97796	97797
21370	31689	1	applied	\N	\N	\N	\N	97798	97798	97799
21370	31690	2	applied	\N	\N	\N	\N	97800	97800	97801
21370	31691	3	applied	\N	\N	\N	\N	97802	97802	97803
21370	31692	4	applied	\N	\N	\N	\N	97804	97804	97805
21370	31693	5	applied	\N	\N	\N	\N	97806	97806	97807
21372	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21372	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21372	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21372	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21375	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21375	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21375	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21375	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21382	31708	0	applied	\N	\N	\N	\N	97845	97845	97846
21382	31709	1	applied	\N	\N	\N	\N	97847	97847	97848
21382	31710	2	applied	\N	\N	\N	\N	97849	97849	97850
21382	31711	3	applied	\N	\N	\N	\N	97851	97851	97852
21382	31712	4	applied	\N	\N	\N	\N	97853	97853	97854
21382	31713	5	applied	\N	\N	\N	\N	97855	97855	97856
21382	31714	6	applied	\N	\N	\N	\N	97857	97857	97858
21384	31715	0	applied	\N	\N	\N	\N	97863	97863	97864
21384	31716	1	applied	\N	\N	\N	\N	97865	97865	97866
21384	31717	2	applied	\N	\N	\N	\N	97867	97867	97868
21391	31725	0	applied	\N	\N	\N	\N	97890	97890	97891
21391	31726	1	applied	\N	\N	\N	\N	97892	97892	97893
21391	31727	2	applied	\N	\N	\N	\N	97894	97894	97895
21393	31728	0	applied	\N	\N	\N	\N	97947	97947	97948
21393	31729	1	applied	\N	\N	\N	\N	97949	97949	97950
21393	31730	2	applied	\N	\N	\N	\N	97951	97951	97952
21393	31731	3	applied	\N	\N	\N	\N	97953	97953	97954
21401	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21401	31736	1	applied	\N	\N	\N	\N	97974	97974	97975
21401	31737	2	applied	\N	\N	\N	\N	97976	97976	97977
21401	31738	3	applied	\N	\N	\N	\N	97978	97978	97979
21401	31739	4	applied	\N	\N	\N	\N	97980	97980	97981
21401	31740	5	applied	\N	\N	\N	\N	97982	97982	97983
21401	31741	6	applied	\N	\N	\N	\N	97984	97984	97985
21401	31742	7	applied	\N	\N	\N	\N	97986	97986	97987
21401	31743	8	applied	\N	\N	\N	\N	97988	97988	97989
21401	31744	9	applied	\N	\N	\N	\N	97990	97990	97991
21401	31745	10	applied	\N	\N	\N	\N	97992	97992	97993
21405	31753	0	applied	\N	\N	\N	\N	98018	98018	98019
21405	31754	1	applied	\N	\N	\N	\N	98020	98020	98021
21405	31755	2	applied	\N	\N	\N	\N	98022	98022	98023
21405	31756	3	applied	\N	\N	\N	\N	98024	98024	98025
21410	31757	0	applied	\N	\N	\N	\N	98029	98029	98030
21410	31758	1	applied	\N	\N	\N	\N	98031	98031	98032
21410	31760	2	applied	\N	\N	\N	\N	98035	98035	98036
21411	31592	0	applied	\N	\N	\N	\N	98044	98044	97549
21411	31602	1	applied	\N	\N	\N	\N	98045	98045	97580
21411	31603	2	applied	\N	\N	\N	\N	98046	98046	97582
21411	31616	3	applied	\N	\N	\N	\N	98047	98047	97618
21411	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21411	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21411	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21411	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21411	31416	8	applied	\N	\N	\N	\N	97059	97059	97060
21411	31400	9	applied	\N	\N	\N	\N	97008	97008	97009
21411	31422	10	applied	\N	\N	\N	\N	98052	98052	97073
21411	31417	11	applied	\N	\N	\N	\N	97061	97061	97062
21411	31401	12	applied	\N	\N	\N	\N	97010	97010	97011
21335	31598	3	applied	\N	\N	\N	\N	97565	97565	97566
21337	31599	0	applied	\N	\N	\N	\N	97569	97569	97570
21337	31600	1	applied	\N	\N	\N	\N	97571	97571	97572
21337	31601	2	applied	\N	\N	\N	\N	97573	97573	97574
21341	31607	0	applied	\N	\N	\N	\N	97591	97591	97592
21341	31608	1	applied	\N	\N	\N	\N	97593	97593	97594
21341	31609	2	applied	\N	\N	\N	\N	97595	97595	97596
21344	31610	0	applied	\N	\N	\N	\N	97600	97600	97601
21344	31611	1	applied	\N	\N	\N	\N	97602	97602	97603
21344	31612	2	applied	\N	\N	\N	\N	97604	97604	97605
21344	31613	3	applied	\N	\N	\N	\N	97606	97606	97607
21344	31614	4	applied	\N	\N	\N	\N	97608	97608	97609
21344	31615	5	applied	\N	\N	\N	\N	97610	97610	97611
21351	31632	0	applied	\N	\N	\N	\N	97654	97654	97655
21351	31633	1	applied	\N	\N	\N	\N	97656	97656	97657
21351	31634	2	applied	\N	\N	\N	\N	97658	97658	97659
21351	31635	3	applied	\N	\N	\N	\N	97660	97660	97661
21351	31636	4	applied	\N	\N	\N	\N	97662	97662	97663
21351	31637	5	applied	\N	\N	\N	\N	97664	97664	97665
21356	31646	0	applied	\N	\N	\N	\N	97687	97687	97688
21356	31647	1	applied	\N	\N	\N	\N	97689	97689	97690
21356	31648	2	applied	\N	\N	\N	\N	97691	97691	97692
21363	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21363	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21363	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21363	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21363	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21363	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21365	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21365	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21365	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21365	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21365	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21365	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21367	31684	0	applied	\N	\N	\N	\N	97787	97787	97788
21367	31685	1	applied	\N	\N	\N	\N	97789	97789	97790
21367	31686	2	applied	\N	\N	\N	\N	97791	97791	97792
21367	31687	3	applied	\N	\N	\N	\N	97793	97793	97794
21374	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21374	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21374	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21374	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21377	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21377	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21377	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21377	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21381	31702	0	applied	\N	\N	\N	\N	97832	97832	97833
21381	31703	1	applied	\N	\N	\N	\N	97834	97834	97835
21381	31704	2	applied	\N	\N	\N	\N	97836	97836	97837
21381	31705	3	applied	\N	\N	\N	\N	97838	97838	97839
21381	31706	4	applied	\N	\N	\N	\N	97840	97840	97841
21381	31707	5	applied	\N	\N	\N	\N	97842	97842	97843
21388	31718	0	applied	\N	\N	\N	\N	97872	97872	97873
21388	31719	1	applied	\N	\N	1000000000	\N	97874	97874	97875
21388	31720	2	applied	\N	\N	\N	\N	97876	97876	97877
21388	31721	3	applied	\N	\N	\N	\N	97878	97878	97879
21390	31722	0	applied	\N	\N	\N	\N	97882	97882	97883
21390	31723	1	applied	\N	\N	\N	\N	97884	97884	97885
21390	31724	2	applied	\N	\N	\N	\N	97886	97886	97887
21400	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21400	31736	1	applied	\N	\N	\N	\N	97974	97974	97975
21400	31737	2	applied	\N	\N	\N	\N	97976	97976	97977
21400	31738	3	applied	\N	\N	\N	\N	97978	97978	97979
21400	31739	4	applied	\N	\N	\N	\N	97980	97980	97981
21400	31740	5	applied	\N	\N	\N	\N	97982	97982	97983
21400	31741	6	applied	\N	\N	\N	\N	97984	97984	97985
21400	31742	7	applied	\N	\N	\N	\N	97986	97986	97987
21400	31743	8	applied	\N	\N	\N	\N	97988	97988	97989
21400	31744	9	applied	\N	\N	\N	\N	97990	97990	97991
21400	31745	10	applied	\N	\N	\N	\N	97992	97992	97993
21404	31746	0	applied	\N	\N	\N	\N	98001	98001	98002
21404	31747	1	applied	\N	\N	\N	\N	98003	98003	98004
21404	31748	2	applied	\N	\N	\N	\N	98005	98005	98006
21404	31749	3	applied	\N	\N	\N	\N	98007	98007	98008
21404	31750	4	applied	\N	\N	\N	\N	98009	98009	98010
21404	31751	5	applied	\N	\N	\N	\N	98011	98011	98012
21404	31752	6	applied	\N	\N	\N	\N	98013	98013	98014
21407	31753	0	applied	\N	\N	\N	\N	98018	98018	98019
21407	31754	1	applied	\N	\N	\N	\N	98020	98020	98021
21407	31755	2	applied	\N	\N	\N	\N	98022	98022	98023
21407	31756	3	applied	\N	\N	\N	\N	98024	98024	98025
21409	31757	0	applied	\N	\N	\N	\N	98029	98029	98030
21409	31758	1	applied	\N	\N	\N	\N	98031	98031	98032
21409	31759	2	applied	\N	\N	\N	\N	98033	98033	98034
21409	31760	3	applied	\N	\N	\N	\N	98035	98035	98036
21409	31761	4	applied	\N	\N	\N	\N	98037	98037	98038
21414	31762	0	applied	\N	\N	\N	\N	98059	98059	98060
21414	31763	1	applied	\N	\N	\N	\N	98061	98061	98062
21414	31764	2	applied	\N	\N	\N	\N	98063	98063	98064
21416	31765	0	applied	\N	\N	\N	\N	98068	98068	98069
21416	31766	1	applied	\N	\N	\N	\N	98070	98070	98071
21416	31767	2	applied	\N	\N	\N	\N	98072	98072	98073
21416	31768	3	applied	\N	\N	\N	\N	98074	98074	98075
21416	31769	4	applied	\N	\N	\N	\N	98076	98076	98077
21416	31770	5	applied	\N	\N	\N	\N	98078	98078	98079
21416	31771	6	applied	\N	\N	\N	\N	98080	98080	98081
21416	31772	7	applied	\N	\N	\N	\N	98082	98082	98083
21416	31773	9	applied	\N	\N	\N	\N	98085	98085	98086
21416	31774	10	applied	\N	\N	\N	\N	98087	98087	98088
21416	31775	11	applied	\N	\N	\N	\N	98089	98089	98090
21420	31779	0	applied	\N	\N	\N	\N	98107	98107	98108
21420	31780	1	applied	\N	\N	\N	\N	98109	98109	98110
21420	31781	2	applied	\N	\N	\N	\N	98111	98111	98112
21425	31788	0	applied	\N	\N	\N	\N	98133	98133	98134
21425	31789	1	applied	\N	\N	\N	\N	98135	98135	98136
21425	31790	2	applied	\N	\N	\N	\N	98137	98137	98138
21425	31791	3	applied	\N	\N	\N	\N	98139	98139	98140
21428	31798	0	applied	\N	\N	\N	\N	98156	98156	98157
21428	31799	1	applied	\N	\N	\N	\N	98158	98158	98159
21428	31800	2	applied	\N	\N	\N	\N	98160	98160	98161
21428	31801	3	applied	\N	\N	\N	\N	98162	98162	98163
21428	31802	4	applied	\N	\N	\N	\N	98164	98164	98165
21428	31803	5	applied	\N	\N	\N	\N	98166	98166	98167
21428	31804	6	applied	\N	\N	\N	\N	98168	98168	98169
21428	31805	7	applied	\N	\N	\N	\N	98170	98170	98171
21428	31806	8	applied	\N	\N	\N	\N	98172	98172	98173
21428	31807	9	applied	\N	\N	\N	\N	98174	98174	98175
21431	31808	0	applied	\N	\N	\N	\N	98180	98180	98181
21431	31809	1	applied	\N	\N	\N	\N	98182	98182	98183
21431	31810	2	applied	\N	\N	\N	\N	98184	98184	98185
21362	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21362	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21362	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21362	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21362	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21364	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21364	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21364	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21364	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21364	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21364	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21366	31678	0	applied	\N	\N	\N	\N	97760	97760	97761
21366	31679	1	applied	\N	\N	\N	\N	97762	97762	97763
21366	31680	2	applied	\N	\N	\N	\N	97764	97764	97765
21366	31681	3	applied	\N	\N	\N	\N	97766	97766	97767
21366	31682	5	applied	\N	\N	\N	\N	97769	97769	97770
21366	31683	6	applied	\N	\N	\N	\N	97771	97771	97772
21371	31688	0	applied	\N	\N	\N	\N	97796	97796	97797
21371	31689	1	applied	\N	\N	\N	\N	97798	97798	97799
21371	31690	2	applied	\N	\N	\N	\N	97800	97800	97801
21371	31691	3	applied	\N	\N	\N	\N	97802	97802	97803
21371	31692	4	applied	\N	\N	\N	\N	97804	97804	97805
21371	31693	5	applied	\N	\N	\N	\N	97806	97806	97807
21373	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21373	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21373	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21373	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21376	31694	0	applied	\N	\N	\N	\N	97810	97810	97811
21376	31695	1	applied	\N	\N	\N	\N	97812	97812	97813
21376	31696	2	applied	\N	\N	\N	\N	97814	97814	97815
21376	31697	3	applied	\N	\N	\N	\N	97816	97816	97817
21383	31708	0	applied	\N	\N	\N	\N	97845	97845	97846
21383	31709	1	applied	\N	\N	\N	\N	97847	97847	97848
21383	31710	2	applied	\N	\N	\N	\N	97849	97849	97850
21383	31711	3	applied	\N	\N	\N	\N	97851	97851	97852
21383	31712	4	applied	\N	\N	\N	\N	97853	97853	97854
21383	31713	5	applied	\N	\N	\N	\N	97855	97855	97856
21383	31714	6	applied	\N	\N	\N	\N	97857	97857	97858
21385	31715	0	applied	\N	\N	\N	\N	97863	97863	97864
21385	31716	1	applied	\N	\N	\N	\N	97865	97865	97866
21385	31717	2	applied	\N	\N	\N	\N	97867	97867	97868
21387	31715	0	applied	\N	\N	\N	\N	97863	97863	97864
21387	31716	1	applied	\N	\N	\N	\N	97865	97865	97866
21387	31717	2	applied	\N	\N	\N	\N	97867	97867	97868
21389	31718	0	applied	\N	\N	\N	\N	97872	97872	97873
21389	31719	1	applied	\N	\N	1000000000	\N	97874	97874	97875
21389	31720	2	applied	\N	\N	\N	\N	97876	97876	97877
21389	31721	3	applied	\N	\N	\N	\N	97878	97878	97879
21394	31728	0	applied	\N	\N	\N	\N	97947	97947	97948
21394	31729	1	applied	\N	\N	\N	\N	97949	97949	97950
21394	31730	2	applied	\N	\N	\N	\N	97951	97951	97952
21394	31731	3	applied	\N	\N	\N	\N	97953	97953	97954
21396	31732	0	applied	\N	\N	\N	\N	97959	97959	97960
21396	31733	1	applied	\N	\N	\N	\N	97961	97961	97962
21396	31734	2	applied	\N	\N	\N	\N	97963	97963	97964
21398	31732	0	applied	\N	\N	\N	\N	97959	97959	97960
21398	31734	1	applied	\N	\N	\N	\N	97963	97963	97969
21402	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21402	31736	1	applied	\N	\N	\N	\N	97974	97974	97975
21402	31737	2	applied	\N	\N	\N	\N	97976	97976	97977
21402	31738	3	applied	\N	\N	\N	\N	97978	97978	97979
21402	31739	4	applied	\N	\N	\N	\N	97980	97980	97981
21402	31740	5	applied	\N	\N	\N	\N	97982	97982	97983
21402	31741	6	applied	\N	\N	\N	\N	97984	97984	97985
21402	31742	7	applied	\N	\N	\N	\N	97986	97986	97987
21402	31743	8	applied	\N	\N	\N	\N	97988	97988	97989
21402	31744	9	applied	\N	\N	\N	\N	97990	97990	97991
21402	31745	10	applied	\N	\N	\N	\N	97992	97992	97993
21403	31746	0	applied	\N	\N	\N	\N	98001	98001	98002
21403	31747	1	applied	\N	\N	\N	\N	98003	98003	98004
21403	31748	2	applied	\N	\N	\N	\N	98005	98005	98006
21403	31749	3	applied	\N	\N	\N	\N	98007	98007	98008
21403	31750	4	applied	\N	\N	\N	\N	98009	98009	98010
21403	31751	5	applied	\N	\N	\N	\N	98011	98011	98012
21403	31752	6	applied	\N	\N	\N	\N	98013	98013	98014
21406	31753	0	applied	\N	\N	\N	\N	98018	98018	98019
21406	31754	1	applied	\N	\N	\N	\N	98020	98020	98021
21406	31755	2	applied	\N	\N	\N	\N	98022	98022	98023
21406	31756	3	applied	\N	\N	\N	\N	98024	98024	98025
21412	31762	0	applied	\N	\N	\N	\N	98059	98059	98060
21412	31763	1	applied	\N	\N	\N	\N	98061	98061	98062
21412	31764	2	applied	\N	\N	\N	\N	98063	98063	98064
21419	31776	0	applied	\N	\N	\N	\N	98096	98096	98097
21419	31777	1	applied	\N	\N	\N	\N	98101	98101	98102
21419	31778	2	applied	\N	\N	\N	\N	98103	98103	98104
21422	31782	0	applied	\N	\N	\N	\N	98115	98115	98116
21422	31783	1	applied	\N	\N	\N	\N	98117	98117	98118
21422	31784	2	applied	\N	\N	\N	\N	98119	98119	98120
21434	31814	0	applied	\N	\N	\N	\N	98198	98198	98199
21434	31815	1	applied	\N	\N	\N	\N	98200	98200	98201
21434	31816	2	applied	\N	\N	\N	\N	98202	98202	98203
21434	31817	3	applied	\N	\N	\N	\N	98204	98204	98205
21434	31818	4	applied	\N	\N	\N	\N	98206	98206	98207
21434	31819	5	applied	\N	\N	\N	\N	98208	98208	98209
21439	31831	0	applied	\N	\N	\N	\N	98239	98239	98240
21439	31832	1	applied	\N	\N	\N	\N	98241	98241	98242
21439	31833	2	applied	\N	\N	\N	\N	98243	98243	98244
21439	31834	3	applied	\N	\N	\N	\N	98245	98245	98246
21439	31835	4	applied	\N	\N	\N	\N	98247	98247	98248
21445	31856	0	applied	\N	\N	\N	\N	98295	98295	98296
21445	31857	1	applied	\N	\N	\N	\N	98297	98297	98298
21445	31858	2	applied	\N	\N	\N	\N	98299	98299	98300
21448	31866	0	applied	\N	\N	\N	\N	98319	98319	98320
21448	31867	1	applied	\N	\N	\N	\N	98321	98321	98322
21448	31868	2	applied	\N	\N	\N	\N	98323	98323	98324
21448	31869	3	applied	\N	\N	\N	\N	98325	98325	98326
21457	31887	0	applied	\N	\N	\N	\N	98393	98393	98394
21457	31888	1	applied	\N	\N	\N	\N	98395	98395	98396
21457	31889	2	applied	\N	\N	\N	\N	98397	98397	98398
21457	31890	3	applied	\N	\N	\N	\N	98399	98399	98400
21457	31891	4	applied	\N	\N	\N	\N	98401	98401	98402
21457	31892	5	applied	\N	\N	\N	\N	98403	98403	98404
21457	31893	6	applied	\N	\N	\N	\N	98405	98405	98406
21464	31904	0	applied	\N	\N	\N	\N	98435	98435	98436
21464	31905	1	applied	\N	\N	\N	\N	98437	98437	98438
21464	31906	2	applied	\N	\N	\N	\N	98439	98439	98440
21467	31907	0	applied	\N	\N	\N	\N	98443	98443	98444
21467	31908	1	applied	\N	\N	\N	\N	98445	98445	98446
21467	31909	2	applied	\N	\N	\N	\N	98447	98447	98448
21467	31910	3	applied	\N	\N	\N	\N	98449	98449	98450
21392	31628	12	applied	\N	\N	\N	\N	97642	97642	97643
21392	31632	13	applied	\N	\N	\N	\N	97654	97654	97655
21392	31633	14	applied	\N	\N	\N	\N	97656	97656	97657
21392	31638	15	applied	\N	\N	\N	\N	97667	97667	97668
21392	31642	16	applied	\N	\N	\N	\N	97677	97677	97678
21392	31646	17	applied	\N	\N	\N	\N	97687	97687	97688
21392	31649	18	applied	\N	\N	\N	\N	97695	97695	97696
21392	31650	19	applied	\N	\N	\N	\N	97697	97697	97698
21392	31651	20	applied	\N	\N	\N	\N	97699	97699	97700
21392	31659	21	applied	\N	\N	\N	\N	97719	97719	97720
21392	31660	22	applied	\N	\N	\N	\N	97721	97721	97722
21392	31661	23	applied	\N	\N	\N	\N	97723	97723	97724
21392	31662	24	applied	\N	\N	\N	\N	97725	97725	97726
21392	31663	25	applied	\N	\N	\N	\N	97727	97727	97728
21392	31664	26	applied	\N	\N	\N	\N	97729	97729	97730
21392	31678	27	applied	\N	\N	\N	\N	97760	97760	97761
21392	31679	28	applied	\N	\N	\N	\N	97762	97762	97763
21392	31684	29	applied	\N	\N	\N	\N	97787	97787	97788
21392	31688	30	applied	\N	\N	\N	\N	97796	97796	97797
21392	31689	31	applied	\N	\N	\N	\N	97798	97798	97799
21392	31694	32	applied	\N	\N	\N	\N	97810	97810	97811
21392	31698	33	applied	\N	\N	\N	\N	97824	97824	97825
21392	31702	34	applied	\N	\N	\N	\N	97832	97832	97833
21392	31703	35	applied	\N	\N	\N	\N	97834	97834	97835
21392	31708	36	applied	\N	\N	\N	\N	97845	97845	97846
21392	31709	37	applied	\N	\N	\N	\N	97847	97847	97848
21392	31715	38	applied	\N	\N	\N	\N	97863	97863	97864
21392	31718	39	applied	\N	\N	\N	\N	97872	97872	97873
21392	31722	40	applied	\N	\N	\N	\N	97882	97882	97883
21392	31725	41	applied	\N	\N	\N	\N	97890	97890	97891
21392	31608	42	applied	\N	\N	\N	\N	97593	97593	97897
21392	31597	43	applied	\N	\N	\N	\N	97563	97563	97898
21392	31623	44	applied	\N	\N	1000000000	\N	97631	97631	97632
21392	31640	45	applied	\N	\N	\N	\N	97671	97671	97672
21392	31598	46	applied	\N	\N	\N	\N	97565	97565	97899
21392	31600	47	applied	\N	\N	\N	\N	97571	97571	97900
21392	31601	48	applied	\N	\N	\N	\N	97573	97573	97901
21392	31605	49	applied	\N	\N	\N	\N	97585	97585	97902
21392	31609	50	applied	\N	\N	\N	\N	97595	97595	97903
21392	31612	51	applied	\N	\N	\N	\N	97604	97604	97904
21392	31614	52	applied	\N	\N	\N	\N	97608	97608	97905
21392	31620	53	applied	\N	\N	\N	\N	97625	97625	97906
21392	31621	54	applied	\N	\N	\N	\N	97627	97627	97611
21392	31622	55	applied	\N	\N	\N	\N	97629	97629	97626
21392	31631	56	applied	\N	\N	\N	\N	97648	97648	97628
21392	31606	57	applied	\N	\N	\N	\N	97587	97587	97907
21392	31613	58	applied	\N	\N	\N	\N	97606	97606	97908
21392	31615	59	applied	\N	\N	\N	\N	97610	97610	97909
21392	31624	60	applied	\N	\N	\N	\N	97633	97633	97910
21392	31625	61	applied	\N	\N	\N	\N	97635	97635	97640
21392	31626	62	applied	\N	\N	\N	\N	97637	97637	97911
21392	31630	63	applied	\N	\N	\N	\N	97646	97646	97912
21392	31634	64	applied	\N	\N	\N	\N	97658	97658	97649
21392	31635	65	applied	\N	\N	\N	\N	97660	97660	97659
21392	31641	66	applied	\N	\N	\N	\N	97673	97673	97661
21392	31644	67	applied	\N	\N	\N	\N	97681	97681	97913
21392	31647	68	applied	\N	\N	\N	\N	97689	97689	97914
21392	31652	69	applied	\N	\N	\N	\N	97701	97701	97665
21392	31656	70	applied	\N	\N	\N	\N	97709	97709	97915
21392	31657	71	applied	\N	\N	\N	\N	97711	97711	97916
21392	31636	72	applied	\N	\N	\N	\N	97662	97662	97917
21392	31637	73	applied	\N	\N	\N	\N	97664	97664	97918
21392	31639	74	applied	\N	\N	\N	\N	97669	97669	97690
21392	31645	75	applied	\N	\N	\N	\N	97683	97683	97692
21392	31648	76	applied	\N	\N	\N	\N	97691	97691	97919
21392	31653	77	applied	\N	\N	\N	\N	97703	97703	97920
21392	31654	78	applied	\N	\N	\N	\N	97705	97705	97921
21392	31655	79	applied	\N	\N	\N	\N	97707	97707	97922
21392	31665	80	applied	\N	\N	\N	\N	97731	97731	97712
21392	31668	81	applied	\N	\N	\N	\N	97737	97737	97923
21392	31669	82	applied	\N	\N	\N	\N	97739	97739	97736
21392	31670	83	applied	\N	\N	\N	\N	97741	97741	97738
21392	31671	84	applied	\N	\N	\N	\N	97743	97743	97740
21392	31672	85	applied	\N	\N	\N	\N	97745	97745	97742
21392	31681	86	applied	\N	\N	\N	\N	97766	97766	97744
21392	31682	87	applied	\N	\N	\N	\N	97769	97769	97746
21392	31687	88	applied	\N	\N	\N	\N	97793	97793	97924
21392	31690	89	applied	\N	\N	\N	\N	97800	97800	97752
21392	31691	90	applied	\N	\N	\N	\N	97802	97802	97925
21392	31695	91	applied	\N	\N	\N	\N	97812	97812	97765
21392	31699	92	applied	\N	\N	\N	\N	97826	97826	97767
21392	31706	93	applied	\N	\N	\N	\N	97840	97840	97770
21392	31707	94	applied	\N	\N	\N	\N	97842	97842	97790
21392	31710	95	applied	\N	\N	\N	\N	97849	97849	97926
21392	31711	96	applied	\N	\N	\N	\N	97851	97851	97927
21392	31717	97	applied	\N	\N	\N	\N	97867	97867	97928
21392	31721	98	applied	\N	\N	\N	\N	97878	97878	97929
21392	31724	99	applied	\N	\N	\N	\N	97886	97886	97807
21392	31727	100	applied	\N	\N	\N	\N	97894	97894	97813
21392	31673	101	applied	\N	\N	\N	\N	97747	97747	97815
21392	31674	102	applied	\N	\N	\N	\N	97749	97749	97930
21392	31675	103	applied	\N	\N	\N	\N	97751	97751	97827
21392	31676	104	applied	\N	\N	\N	\N	97753	97753	97829
21392	31677	105	applied	\N	\N	\N	\N	97755	97755	97837
21392	31680	106	applied	\N	\N	\N	\N	97764	97764	97839
21392	31683	107	applied	\N	\N	\N	\N	97771	97771	97931
21392	31686	108	applied	\N	\N	\N	\N	97791	97791	97932
21392	31627	109	applied	\N	\N	\N	\N	97639	97639	97933
21392	31629	110	applied	\N	\N	\N	\N	97644	97644	97843
21392	31643	112	applied	\N	\N	\N	\N	97679	97679	97935
21392	31658	113	applied	\N	\N	\N	\N	97713	97713	97936
21392	31666	114	applied	\N	\N	\N	\N	97733	97733	97850
21392	31667	115	applied	\N	\N	\N	\N	97735	97735	97937
21392	31685	116	applied	\N	\N	\N	\N	97789	97789	97938
21392	31697	117	applied	\N	\N	\N	\N	97816	97816	97852
21392	31712	118	applied	\N	\N	\N	\N	97853	97853	97854
21392	31720	119	applied	\N	\N	\N	\N	97876	97876	97939
21392	31692	120	applied	\N	\N	\N	\N	97804	97804	97940
21392	31693	121	applied	\N	\N	\N	\N	97806	97806	97941
21392	31696	122	applied	\N	\N	\N	\N	97814	97814	97942
21392	31700	123	applied	\N	\N	\N	\N	97828	97828	97868
21392	31704	124	applied	\N	\N	\N	\N	97836	97836	97943
21395	31728	0	applied	\N	\N	\N	\N	97947	97947	97948
21395	31729	1	applied	\N	\N	\N	\N	97949	97949	97950
21395	31730	2	applied	\N	\N	\N	\N	97951	97951	97952
21395	31731	3	applied	\N	\N	\N	\N	97953	97953	97954
21397	31719	0	applied	\N	\N	1000000000	\N	97874	97874	97875
21397	31701	1	applied	\N	\N	\N	\N	97830	97830	97671
21399	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21399	31736	1	applied	\N	\N	\N	\N	97974	97974	97975
21399	31737	2	applied	\N	\N	\N	\N	97976	97976	97977
21399	31738	3	applied	\N	\N	\N	\N	97978	97978	97979
21399	31739	4	applied	\N	\N	\N	\N	97980	97980	97981
21399	31740	5	applied	\N	\N	\N	\N	97982	97982	97983
21399	31741	6	applied	\N	\N	\N	\N	97984	97984	97985
21399	31742	7	applied	\N	\N	\N	\N	97986	97986	97987
21399	31743	8	applied	\N	\N	\N	\N	97988	97988	97989
21399	31744	9	applied	\N	\N	\N	\N	97990	97990	97991
21399	31745	10	applied	\N	\N	\N	\N	97992	97992	97993
21408	31757	0	applied	\N	\N	\N	\N	98029	98029	98030
21408	31758	1	applied	\N	\N	\N	\N	98031	98031	98032
21408	31759	2	applied	\N	\N	\N	\N	98033	98033	98034
21408	31760	3	applied	\N	\N	\N	\N	98035	98035	98036
21408	31761	4	applied	\N	\N	\N	\N	98037	98037	98038
21413	31762	0	applied	\N	\N	\N	\N	98059	98059	98060
21413	31763	1	applied	\N	\N	\N	\N	98061	98061	98062
21413	31764	2	applied	\N	\N	\N	\N	98063	98063	98064
21415	31765	0	applied	\N	\N	\N	\N	98068	98068	98069
21415	31766	1	applied	\N	\N	\N	\N	98070	98070	98071
21415	31767	2	applied	\N	\N	\N	\N	98072	98072	98073
21415	31768	3	applied	\N	\N	\N	\N	98074	98074	98075
21415	31769	4	applied	\N	\N	\N	\N	98076	98076	98077
21415	31770	5	applied	\N	\N	\N	\N	98078	98078	98079
21415	31771	6	applied	\N	\N	\N	\N	98080	98080	98081
21415	31772	7	applied	\N	\N	\N	\N	98082	98082	98083
21415	31773	9	applied	\N	\N	\N	\N	98085	98085	98086
21415	31774	10	applied	\N	\N	\N	\N	98087	98087	98088
21415	31775	11	applied	\N	\N	\N	\N	98089	98089	98090
21418	31765	0	applied	\N	\N	\N	\N	98068	98068	98069
21418	31766	1	applied	\N	\N	\N	\N	98070	98070	98071
21418	31767	2	applied	\N	\N	\N	\N	98072	98072	98073
21418	31768	3	applied	\N	\N	\N	\N	98074	98074	98075
21418	31769	4	applied	\N	\N	\N	\N	98076	98076	98077
21418	31770	5	applied	\N	\N	\N	\N	98078	98078	98079
21418	31771	6	applied	\N	\N	\N	\N	98080	98080	98081
21418	31772	7	applied	\N	\N	\N	\N	98082	98082	98083
21418	31773	9	applied	\N	\N	\N	\N	98085	98085	98086
21418	31774	10	applied	\N	\N	\N	\N	98087	98087	98088
21418	31775	11	applied	\N	\N	\N	\N	98089	98089	98090
21424	31785	0	applied	\N	\N	\N	\N	98124	98124	98125
21424	31786	1	applied	\N	\N	\N	\N	98126	98126	98127
21424	31787	2	applied	\N	\N	\N	\N	98128	98128	98129
21427	31792	0	applied	\N	\N	\N	\N	98144	98144	98145
21427	31793	1	applied	\N	\N	\N	\N	98146	98146	98147
21427	31794	2	applied	\N	\N	\N	\N	98148	98148	98149
21427	31795	3	applied	\N	\N	\N	\N	98150	98150	98151
21427	31796	4	applied	\N	\N	\N	\N	98152	98152	98153
21427	31797	5	applied	\N	\N	\N	\N	98154	98154	98155
21430	31808	0	applied	\N	\N	\N	\N	98180	98180	98181
21430	31809	1	applied	\N	\N	\N	\N	98182	98182	98183
21430	31810	2	applied	\N	\N	\N	\N	98184	98184	98185
21435	31814	0	applied	\N	\N	\N	\N	98198	98198	98199
21435	31815	1	applied	\N	\N	\N	\N	98200	98200	98201
21435	31816	2	applied	\N	\N	\N	\N	98202	98202	98203
21435	31817	3	applied	\N	\N	\N	\N	98204	98204	98205
21435	31818	4	applied	\N	\N	\N	\N	98206	98206	98207
21435	31819	5	applied	\N	\N	\N	\N	98208	98208	98209
21437	31784	0	applied	\N	\N	\N	\N	98119	98119	98120
21440	31836	0	applied	\N	\N	\N	\N	98249	98249	98250
21440	31837	1	applied	\N	\N	\N	\N	98251	98251	98252
21440	31838	2	applied	\N	\N	\N	\N	98253	98253	98254
21440	31839	3	applied	\N	\N	\N	\N	98255	98255	98256
21440	31840	4	applied	\N	\N	\N	\N	98257	98257	98258
21440	31841	5	applied	\N	\N	\N	\N	98259	98259	98260
21446	31856	0	applied	\N	\N	\N	\N	98295	98295	98296
21446	31857	1	applied	\N	\N	\N	\N	98297	98297	98298
21446	31858	2	applied	\N	\N	\N	\N	98299	98299	98300
21453	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21453	31746	1	applied	\N	\N	\N	\N	98001	98001	98002
21453	31757	2	applied	\N	\N	\N	\N	98029	98029	98030
21453	31758	3	applied	\N	\N	\N	\N	98031	98031	98032
21453	31765	4	applied	\N	\N	\N	\N	98068	98068	98069
21453	31766	5	applied	\N	\N	\N	\N	98070	98070	98071
21453	31871	6	applied	\N	\N	\N	\N	98337	98337	98320
21453	31831	7	applied	\N	\N	\N	\N	98357	98357	98330
21453	31832	8	applied	\N	\N	\N	\N	98358	98358	98242
21453	31838	9	applied	\N	\N	\N	\N	98359	98359	98254
21453	31842	10	applied	\N	\N	\N	\N	98360	98360	98264
21453	31843	11	applied	\N	\N	\N	\N	98361	98361	98266
21453	31851	12	applied	\N	\N	\N	\N	98362	98362	98284
21453	31852	13	applied	\N	\N	\N	\N	98363	98363	98286
21453	31866	14	applied	\N	\N	\N	\N	98364	98364	98320
21453	31784	15	applied	\N	\N	\N	\N	98119	98119	98120
21453	31830	16	applied	\N	\N	\N	\N	98235	98235	98236
21453	31835	17	applied	\N	\N	\N	\N	98247	98247	98248
21454	31881	0	applied	\N	\N	\N	\N	98367	98367	98368
21454	31882	1	applied	\N	\N	\N	\N	98369	98369	98370
21454	31883	2	applied	\N	\N	\N	\N	98371	98371	98372
21458	31894	0	applied	\N	\N	\N	\N	98409	98409	98410
21458	31895	1	applied	\N	\N	\N	\N	98411	98411	98412
21458	31896	2	applied	\N	\N	\N	\N	98413	98413	98414
21458	31897	3	applied	\N	\N	\N	\N	98415	98415	98416
21458	31898	4	applied	\N	\N	\N	\N	98417	98417	98418
21458	31899	5	applied	\N	\N	\N	\N	98419	98419	98420
21458	31900	6	applied	\N	\N	\N	\N	98421	98421	98422
21460	31901	0	applied	\N	\N	\N	\N	98425	98425	98426
21460	31902	1	applied	\N	\N	\N	\N	98427	98427	98428
21460	31903	2	applied	\N	\N	\N	\N	98429	98429	98430
21463	31904	0	applied	\N	\N	\N	\N	98435	98435	98436
21463	31905	1	applied	\N	\N	\N	\N	98437	98437	98438
21463	31906	2	applied	\N	\N	\N	\N	98439	98439	98440
21465	31907	0	applied	\N	\N	\N	\N	98443	98443	98444
21465	31908	1	applied	\N	\N	\N	\N	98445	98445	98446
21465	31909	2	applied	\N	\N	\N	\N	98447	98447	98448
21465	31910	3	applied	\N	\N	\N	\N	98449	98449	98450
21465	31911	4	applied	\N	\N	\N	\N	98451	98451	98452
21465	31912	5	applied	\N	\N	\N	\N	98453	98453	98454
21465	31913	6	applied	\N	\N	\N	\N	98455	98455	98456
21465	31914	7	applied	\N	\N	\N	\N	98457	98457	98458
21465	31915	8	applied	\N	\N	\N	\N	98459	98459	98460
21465	31916	9	applied	\N	\N	\N	\N	98461	98461	98462
21476	31920	0	applied	\N	\N	\N	\N	98482	98482	98483
21476	31921	1	applied	\N	\N	\N	\N	98484	98484	98485
21476	31922	2	applied	\N	\N	\N	\N	98486	98486	98487
21476	31923	3	applied	\N	\N	\N	\N	98488	98488	98489
21476	31924	4	applied	\N	\N	\N	\N	98490	98490	98491
21476	31925	5	applied	\N	\N	\N	\N	98492	98492	98493
21476	31926	6	applied	\N	\N	\N	\N	98494	98494	98495
21476	31927	7	applied	\N	\N	\N	\N	98496	98496	98497
21411	31719	13	applied	\N	\N	1000000000	\N	97874	97874	97875
21411	31423	14	applied	\N	\N	\N	\N	98053	98053	97075
21411	31424	15	applied	\N	\N	\N	\N	98054	98054	97077
21411	31425	16	applied	\N	\N	\N	\N	98055	98055	97079
21411	31402	17	applied	\N	\N	\N	\N	97012	97012	97013
21411	31049	18	applied	\N	\N	\N	\N	95908	95908	95909
21411	31419	19	applied	\N	\N	\N	\N	97065	97065	97066
21411	31420	20	applied	\N	\N	\N	\N	97067	97067	97068
21411	31056	21	applied	\N	\N	\N	\N	95926	95926	95927
21411	31057	22	applied	\N	\N	\N	\N	95928	95928	95929
21411	31058	23	applied	\N	\N	\N	\N	95930	95930	95931
21411	31059	24	applied	\N	\N	\N	\N	95932	95932	95933
21411	31065	25	applied	\N	\N	\N	\N	95973	95973	95974
21411	31066	26	applied	\N	\N	\N	\N	95975	95975	95976
21411	31070	27	applied	\N	\N	\N	\N	95985	95985	95986
21411	31072	28	applied	\N	\N	\N	\N	95995	95995	95996
21411	31073	29	applied	\N	\N	\N	\N	95997	95997	95998
21411	31077	30	applied	\N	\N	\N	\N	96008	96008	96009
21411	31079	31	applied	\N	\N	\N	\N	96034	96034	96035
21411	31082	32	applied	\N	\N	\N	\N	96044	96044	96045
21411	31083	33	applied	\N	\N	\N	\N	96046	96046	96047
21411	31089	34	applied	\N	\N	\N	\N	96060	96060	96061
21411	31090	35	applied	\N	\N	\N	\N	96062	96062	96063
21411	31094	36	applied	\N	\N	\N	\N	96072	96072	96073
21411	31096	37	applied	\N	\N	\N	\N	96081	96081	96082
21411	31097	38	applied	\N	\N	\N	\N	96083	96083	96084
21411	31098	39	applied	\N	\N	\N	\N	96085	96085	96086
21411	31102	40	applied	\N	\N	\N	\N	96099	96099	96100
21411	31104	41	applied	\N	\N	\N	\N	96106	96106	96107
21411	31107	42	applied	\N	\N	\N	\N	96116	96116	96117
21411	31109	43	applied	\N	\N	\N	\N	96125	96125	96126
21411	31110	44	applied	\N	\N	\N	\N	96129	96129	96130
21411	31113	45	applied	\N	\N	\N	\N	96140	96140	96141
21411	31114	46	applied	\N	\N	\N	\N	96142	96142	96143
21411	31118	47	applied	\N	\N	\N	\N	96152	96152	96153
21411	31120	48	applied	\N	\N	\N	\N	96160	96160	96161
21411	31123	49	applied	\N	\N	\N	\N	96170	96170	96171
21411	31125	50	applied	\N	\N	\N	\N	96177	96177	96178
21411	31126	51	applied	\N	\N	\N	\N	96179	96179	96180
21411	31129	52	applied	\N	\N	\N	\N	96188	96188	96189
21411	31131	53	applied	\N	\N	\N	\N	96192	96192	96193
21411	31133	54	applied	\N	\N	\N	\N	96198	96198	96199
21411	31134	55	applied	\N	\N	\N	\N	96200	96200	96201
21411	31140	56	applied	\N	\N	\N	\N	96214	96214	96215
21411	31147	57	applied	\N	\N	\N	\N	96246	96246	96247
21411	31149	58	applied	\N	\N	\N	\N	96260	96260	96261
21411	31152	59	applied	\N	\N	\N	\N	96273	96273	96274
21411	31153	60	applied	\N	\N	\N	\N	96275	96275	96276
21411	31154	61	applied	\N	\N	\N	\N	96277	96277	96278
21411	31158	62	applied	\N	\N	\N	\N	96287	96287	96288
21411	31161	63	applied	\N	\N	\N	\N	96296	96296	96297
21411	31163	64	applied	\N	\N	\N	\N	96303	96303	96304
21411	31165	65	applied	\N	\N	\N	\N	96307	96307	96308
21411	31168	66	applied	\N	\N	\N	\N	96317	96317	96318
21411	31170	67	applied	\N	\N	\N	\N	96322	96322	96323
21411	31172	68	applied	\N	\N	\N	\N	96328	96328	96329
21411	31173	69	applied	\N	\N	\N	\N	96330	96330	96331
21411	31177	70	applied	\N	\N	\N	\N	96347	96347	96348
21411	31179	71	applied	\N	\N	\N	\N	96355	96355	96356
21411	31180	72	applied	\N	\N	\N	\N	96357	96357	96358
21411	31184	73	applied	\N	\N	\N	\N	96369	96369	96370
21411	31185	74	applied	\N	\N	\N	\N	96371	96371	96372
21411	31188	75	applied	\N	\N	\N	\N	96384	96384	96385
21411	31191	76	applied	\N	\N	\N	\N	96394	96394	96395
21411	31192	77	applied	\N	\N	\N	\N	96399	96399	96400
21411	31194	78	applied	\N	\N	\N	\N	96405	96405	96406
21411	31197	79	applied	\N	\N	\N	\N	96411	96411	96412
21411	31199	80	applied	\N	\N	\N	\N	96419	96419	96420
21411	31201	81	applied	\N	\N	\N	\N	96426	96426	96427
21411	31202	82	applied	\N	\N	\N	\N	96430	96430	96431
21411	31205	83	applied	\N	\N	\N	\N	96441	96441	96442
21411	31207	84	applied	\N	\N	\N	\N	96447	96447	96448
21411	31209	85	applied	\N	\N	\N	\N	96453	96453	96454
21411	31212	86	applied	\N	\N	\N	\N	96460	96460	96461
21411	31213	87	applied	\N	\N	\N	\N	96462	96462	96463
21411	31216	88	applied	\N	\N	\N	\N	96470	96470	96471
21411	31219	89	applied	\N	\N	\N	\N	96480	96480	96481
21411	31220	90	applied	\N	\N	\N	\N	96482	96482	96483
21411	31221	91	applied	\N	\N	\N	\N	96484	96484	96485
21411	31227	92	applied	\N	\N	\N	\N	96500	96500	96501
21411	31229	93	applied	\N	\N	\N	\N	96508	96508	96509
21411	31231	94	applied	\N	\N	\N	\N	96516	96516	96517
21411	31234	95	applied	\N	\N	\N	\N	96528	96528	96529
21411	31235	96	applied	\N	\N	\N	\N	96530	96530	96531
21411	31238	97	applied	\N	\N	\N	\N	96542	96542	96543
21411	31241	98	applied	\N	\N	\N	\N	96551	96551	96552
21411	31243	99	applied	\N	\N	\N	\N	96559	96559	96560
21411	31244	100	applied	\N	\N	\N	\N	96561	96561	96562
21411	31247	101	applied	\N	\N	\N	\N	96569	96569	96570
21411	31251	102	applied	\N	\N	\N	\N	96579	96579	96580
21411	31252	103	applied	\N	\N	\N	\N	96582	96582	96583
21411	31253	104	applied	\N	\N	\N	\N	96584	96584	96585
21411	31254	105	applied	\N	\N	\N	\N	96586	96586	96587
21411	31260	107	applied	\N	\N	\N	\N	96601	96601	96602
21411	31262	108	applied	\N	\N	\N	\N	96605	96605	96606
21411	31263	109	applied	\N	\N	\N	\N	96607	96607	96608
21411	31266	110	applied	\N	\N	\N	\N	96616	96616	96617
21411	31267	111	applied	\N	\N	\N	\N	96618	96618	96619
21411	31271	112	applied	\N	\N	\N	\N	96627	96627	96628
21411	31273	113	applied	\N	\N	\N	\N	96634	96634	96635
21411	31275	114	applied	\N	\N	\N	\N	96640	96640	96641
21411	31277	115	applied	\N	\N	\N	\N	96645	96645	96646
21411	31279	116	applied	\N	\N	\N	\N	96651	96651	96652
21411	31280	117	applied	\N	\N	\N	\N	96653	96653	96654
21411	31281	118	applied	\N	\N	\N	\N	96655	96655	96656
21411	31285	119	applied	\N	\N	\N	\N	96665	96665	96666
21411	31287	120	applied	\N	\N	\N	\N	96673	96673	96674
21411	31289	121	applied	\N	\N	\N	\N	96679	96679	96680
21411	31291	122	applied	\N	\N	\N	\N	96687	96687	96688
21417	31765	0	applied	\N	\N	\N	\N	98068	98068	98069
21417	31766	1	applied	\N	\N	\N	\N	98070	98070	98071
21417	31767	2	applied	\N	\N	\N	\N	98072	98072	98073
21417	31768	3	applied	\N	\N	\N	\N	98074	98074	98075
21417	31776	4	applied	\N	\N	\N	\N	98096	98096	98097
21417	31769	5	applied	\N	\N	\N	\N	98076	98076	98077
21417	31770	6	applied	\N	\N	\N	\N	98078	98078	98079
21417	31771	7	applied	\N	\N	\N	\N	98080	98080	98081
21417	31772	9	applied	\N	\N	\N	\N	98082	98082	98083
21417	31773	10	applied	\N	\N	\N	\N	98085	98085	98086
21417	31774	11	applied	\N	\N	\N	\N	98087	98087	98088
21417	31775	12	applied	\N	\N	\N	\N	98089	98089	98090
21421	31782	0	applied	\N	\N	\N	\N	98115	98115	98116
21421	31783	1	applied	\N	\N	\N	\N	98117	98117	98118
21421	31784	2	applied	\N	\N	\N	\N	98119	98119	98120
21423	31785	0	applied	\N	\N	\N	\N	98124	98124	98125
21423	31786	1	applied	\N	\N	\N	\N	98126	98126	98127
21423	31787	2	applied	\N	\N	\N	\N	98128	98128	98129
21426	31788	0	applied	\N	\N	\N	\N	98133	98133	98134
21426	31789	1	applied	\N	\N	\N	\N	98135	98135	98136
21426	31790	2	applied	\N	\N	\N	\N	98137	98137	98138
21426	31791	3	applied	\N	\N	\N	\N	98139	98139	98140
21429	31798	0	applied	\N	\N	\N	\N	98156	98156	98157
21429	31799	1	applied	\N	\N	\N	\N	98158	98158	98159
21429	31800	2	applied	\N	\N	\N	\N	98160	98160	98161
21429	31801	3	applied	\N	\N	\N	\N	98162	98162	98163
21429	31802	4	applied	\N	\N	\N	\N	98164	98164	98165
21429	31803	5	applied	\N	\N	\N	\N	98166	98166	98167
21429	31804	6	applied	\N	\N	\N	\N	98168	98168	98169
21429	31805	7	applied	\N	\N	\N	\N	98170	98170	98171
21429	31806	8	applied	\N	\N	\N	\N	98172	98172	98173
21429	31807	9	applied	\N	\N	\N	\N	98174	98174	98175
21432	31808	0	applied	\N	\N	\N	\N	98180	98180	98181
21432	31809	1	applied	\N	\N	\N	\N	98182	98182	98183
21432	31810	2	applied	\N	\N	\N	\N	98184	98184	98185
21433	31811	0	applied	\N	\N	\N	\N	98192	98192	98193
21433	31812	1	applied	\N	\N	\N	\N	98194	98194	98195
21433	31813	2	applied	\N	\N	\N	\N	98196	98196	98197
21436	31820	0	applied	\N	\N	\N	\N	98212	98212	98213
21436	31821	1	applied	\N	\N	\N	\N	98214	98214	98215
21436	31822	2	applied	\N	\N	\N	\N	98216	98216	98217
21436	31823	3	applied	\N	\N	\N	\N	98218	98218	98219
21436	31824	4	applied	\N	\N	\N	\N	98220	98220	98221
21436	31825	5	applied	\N	\N	\N	\N	98222	98222	98223
21436	31826	6	applied	\N	\N	\N	\N	98224	98224	98225
21444	31850	0	applied	\N	\N	\N	\N	98281	98281	98282
21444	31851	1	applied	\N	\N	\N	\N	98283	98283	98284
21444	31852	2	applied	\N	\N	\N	\N	98285	98285	98286
21444	31853	3	applied	\N	\N	\N	\N	98287	98287	98288
21444	31854	4	applied	\N	\N	\N	\N	98289	98289	98290
21444	31855	5	applied	\N	\N	\N	\N	98291	98291	98292
21447	31859	0	applied	\N	\N	\N	\N	98302	98302	98303
21447	31860	1	applied	\N	\N	\N	\N	98304	98304	98305
21447	31861	2	applied	\N	\N	\N	\N	98306	98306	98307
21447	31862	3	applied	\N	\N	\N	\N	98308	98308	98309
21447	31863	4	applied	\N	\N	\N	\N	98310	98310	98311
21447	31864	6	applied	\N	\N	\N	\N	98313	98313	98314
21447	31865	7	applied	\N	\N	\N	\N	98315	98315	98316
21450	31871	0	applied	\N	\N	\N	\N	98337	98337	98320
21450	31831	1	applied	\N	\N	\N	\N	98239	98239	98330
21450	31832	2	applied	\N	\N	\N	\N	98241	98241	98242
21450	31838	3	applied	\N	\N	\N	\N	98253	98253	98254
21450	31842	4	applied	\N	\N	\N	\N	98263	98263	98264
21450	31843	5	applied	\N	\N	\N	\N	98265	98265	98266
21450	31851	6	applied	\N	\N	\N	\N	98283	98283	98284
21450	31852	7	applied	\N	\N	\N	\N	98285	98285	98286
21450	31866	8	applied	\N	\N	\N	\N	98319	98319	98320
21450	31830	9	applied	\N	\N	\N	\N	98235	98235	98236
21450	31835	10	applied	\N	\N	\N	\N	98247	98247	98248
21452	31878	0	applied	\N	\N	\N	\N	98350	98350	98351
21452	31879	1	applied	\N	\N	\N	\N	98352	98352	98353
21452	31880	2	applied	\N	\N	\N	\N	98354	98354	98355
21456	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21456	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21456	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21456	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21456	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21456	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21456	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21456	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21456	31765	8	applied	\N	\N	\N	\N	98383	98383	98069
21456	31766	9	applied	\N	\N	\N	\N	98384	98384	98071
21456	31719	10	applied	\N	\N	1000000000	\N	97874	97874	97875
21456	31871	11	applied	\N	\N	\N	\N	98337	98337	98320
21456	31831	12	applied	\N	\N	\N	\N	98357	98357	98330
21456	31832	13	applied	\N	\N	\N	\N	98358	98358	98242
21456	31838	14	applied	\N	\N	\N	\N	98359	98359	98254
21456	31842	15	applied	\N	\N	\N	\N	98360	98360	98264
21456	31843	16	applied	\N	\N	\N	\N	98361	98361	98266
21456	31851	17	applied	\N	\N	\N	\N	98362	98362	98284
21456	31852	18	applied	\N	\N	\N	\N	98363	98363	98286
21456	31866	19	applied	\N	\N	\N	\N	98364	98364	98320
21456	31572	20	applied	\N	\N	\N	\N	97491	97491	29193
21456	31501	21	applied	\N	\N	\N	\N	97288	97288	96173
21456	31623	22	applied	\N	\N	1000000000	\N	97631	97631	97632
21456	31640	23	applied	\N	\N	\N	\N	97671	97671	97672
21456	31502	24	applied	\N	\N	\N	\N	97291	97291	96184
21456	31504	25	applied	\N	\N	\N	\N	97300	97300	98385
21456	31509	26	applied	\N	\N	\N	\N	97312	97312	96203
21456	31511	27	applied	\N	\N	\N	\N	97318	97318	96207
21456	31514	28	applied	\N	\N	\N	\N	97326	97326	98386
21456	31519	29	applied	\N	\N	\N	\N	97337	97337	96267
21456	31523	30	applied	\N	\N	\N	\N	97348	97348	96280
21456	31524	31	applied	\N	\N	\N	\N	97350	97350	98387
21456	31528	32	applied	\N	\N	\N	\N	97361	97361	98388
21456	31532	33	applied	\N	\N	\N	\N	97372	97372	96299
21456	31533	34	applied	\N	\N	\N	\N	97374	97374	96310
21456	31538	35	applied	\N	\N	\N	\N	97389	97389	98389
21456	31541	36	applied	\N	\N	\N	\N	97398	97398	96325
21456	31545	37	applied	\N	\N	\N	\N	97413	97413	96335
21456	31547	38	applied	\N	\N	\N	\N	97423	97423	98390
21456	31549	39	applied	\N	\N	\N	\N	97436	97436	96360
21456	31784	40	applied	\N	\N	\N	\N	98119	98119	98120
21456	31554	41	applied	\N	\N	\N	\N	97448	97448	96364
21459	31901	0	applied	\N	\N	\N	\N	98425	98425	98426
21459	31902	1	applied	\N	\N	\N	\N	98427	98427	98428
21459	31903	2	applied	\N	\N	\N	\N	98429	98429	98430
21462	31904	0	applied	\N	\N	\N	\N	98435	98435	98436
21462	31905	1	applied	\N	\N	\N	\N	98437	98437	98438
21462	31906	2	applied	\N	\N	\N	\N	98439	98439	98440
21471	31917	0	applied	\N	\N	\N	\N	98469	98469	98470
21471	31918	1	applied	\N	\N	\N	\N	98471	98471	98472
21471	31919	2	applied	\N	\N	\N	\N	98473	98473	98474
21478	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21478	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21478	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21478	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21482	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21482	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21482	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21438	31827	0	applied	\N	\N	\N	\N	98229	98229	98230
21438	31828	1	applied	\N	\N	\N	\N	98231	98231	98232
21438	31829	2	applied	\N	\N	\N	\N	98233	98233	98234
21438	31830	3	applied	\N	\N	\N	\N	98235	98235	98236
21441	31836	0	applied	\N	\N	\N	\N	98249	98249	98250
21441	31837	1	applied	\N	\N	\N	\N	98251	98251	98252
21441	31838	2	applied	\N	\N	\N	\N	98253	98253	98254
21441	31839	3	applied	\N	\N	\N	\N	98255	98255	98256
21441	31840	4	applied	\N	\N	\N	\N	98257	98257	98258
21441	31841	5	applied	\N	\N	\N	\N	98259	98259	98260
21443	31842	0	applied	\N	\N	\N	\N	98263	98263	98264
21443	31843	1	applied	\N	\N	\N	\N	98265	98265	98266
21443	31844	2	applied	\N	\N	\N	\N	98267	98267	98268
21443	31845	3	applied	\N	\N	\N	\N	98269	98269	98270
21443	31846	4	applied	\N	\N	\N	\N	98271	98271	98272
21443	31847	5	applied	\N	\N	\N	\N	98273	98273	98274
21443	31848	6	applied	\N	\N	\N	\N	98275	98275	98276
21443	31849	7	applied	\N	\N	\N	\N	98277	98277	98278
21449	31870	0	applied	\N	\N	\N	\N	98328	98328	98329
21449	31871	1	applied	\N	\N	\N	\N	98330	98330	98320
21449	31872	2	applied	\N	\N	\N	\N	98331	98331	98332
21449	31873	3	applied	\N	\N	\N	\N	98333	98333	98334
21451	31874	0	applied	\N	\N	\N	\N	98340	98340	98341
21451	31875	1	applied	\N	\N	\N	\N	98342	98342	98343
21451	31876	2	applied	\N	\N	\N	\N	98344	98344	98345
21451	31877	3	applied	\N	\N	\N	\N	98346	98346	98347
21455	31884	0	applied	\N	\N	\N	\N	98375	98375	98376
21455	31885	1	applied	\N	\N	\N	\N	98377	98377	98378
21455	31886	2	applied	\N	\N	\N	\N	98379	98379	98380
21461	31904	0	applied	\N	\N	\N	\N	98435	98435	98436
21461	31905	1	applied	\N	\N	\N	\N	98437	98437	98438
21461	31906	2	applied	\N	\N	\N	\N	98439	98439	98440
21466	31907	0	applied	\N	\N	\N	\N	98443	98443	98444
21466	31908	1	applied	\N	\N	\N	\N	98445	98445	98446
21466	31909	2	applied	\N	\N	\N	\N	98447	98447	98448
21466	31910	3	applied	\N	\N	\N	\N	98449	98449	98450
21466	31911	4	applied	\N	\N	\N	\N	98451	98451	98452
21466	31912	5	applied	\N	\N	\N	\N	98453	98453	98454
21466	31913	6	applied	\N	\N	\N	\N	98455	98455	98456
21466	31914	7	applied	\N	\N	\N	\N	98457	98457	98458
21466	31915	8	applied	\N	\N	\N	\N	98459	98459	98460
21466	31916	9	applied	\N	\N	\N	\N	98461	98461	98462
21468	31907	0	applied	\N	\N	\N	\N	98443	98443	98444
21468	31908	1	applied	\N	\N	\N	\N	98445	98445	98446
21468	31909	2	applied	\N	\N	\N	\N	98447	98447	98448
21468	31910	3	applied	\N	\N	\N	\N	98449	98449	98450
21468	31911	4	applied	\N	\N	\N	\N	98451	98451	98452
21468	31912	5	applied	\N	\N	\N	\N	98453	98453	98454
21468	31913	6	applied	\N	\N	\N	\N	98455	98455	98456
21468	31914	7	applied	\N	\N	\N	\N	98457	98457	98458
21468	31915	8	applied	\N	\N	\N	\N	98459	98459	98460
21468	31916	9	applied	\N	\N	\N	\N	98461	98461	98462
21470	31917	0	applied	\N	\N	\N	\N	98469	98469	98470
21470	31918	1	applied	\N	\N	\N	\N	98471	98471	98472
21470	31919	2	applied	\N	\N	\N	\N	98473	98473	98474
21472	31917	0	applied	\N	\N	\N	\N	98469	98469	98470
21472	31918	1	applied	\N	\N	\N	\N	98471	98471	98472
21472	31919	2	applied	\N	\N	\N	\N	98473	98473	98474
21477	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21477	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21477	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21477	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21480	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21480	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21480	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21480	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21481	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21481	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21481	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21481	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21486	31943	0	applied	\N	\N	\N	\N	98537	98537	98538
21486	31944	1	applied	\N	\N	\N	\N	98539	98539	98540
21486	31945	2	applied	\N	\N	\N	\N	98541	98541	98542
21488	31946	0	applied	\N	\N	\N	\N	98545	98545	98546
21488	31947	1	applied	\N	\N	\N	\N	98547	98547	98548
21488	31948	2	applied	\N	\N	\N	\N	98549	98549	98550
21491	31955	0	applied	\N	\N	\N	\N	98568	98568	98569
21493	31950	0	applied	\N	\N	\N	\N	98555	98555	47675
21495	31957	0	applied	\N	\N	\N	\N	98579	98579	98580
21495	31956	1	applied	\N	\N	\N	\N	98572	98572	98573
21495	31958	2	applied	\N	\N	\N	\N	98581	98581	98582
21498	31964	0	applied	\N	\N	\N	\N	98597	98597	98598
21498	31965	1	applied	\N	\N	\N	\N	98599	98599	98600
21501	31968	0	applied	\N	\N	\N	\N	98607	98607	98608
21501	31969	1	applied	\N	\N	\N	\N	98609	98609	98610
21503	31970	0	applied	\N	\N	\N	\N	98617	98617	98618
21503	31971	1	applied	\N	\N	\N	\N	98619	98619	98620
21503	31972	2	applied	\N	\N	\N	\N	98621	98621	98622
21503	31973	3	applied	\N	\N	\N	\N	98623	98623	98624
21508	31982	0	applied	\N	\N	\N	\N	98648	98648	98649
21508	31983	1	applied	\N	\N	\N	\N	98650	98650	98651
21508	31984	2	applied	\N	\N	\N	\N	98652	98652	98653
21508	31985	3	applied	\N	\N	\N	\N	98654	98654	98655
21514	32006	0	applied	\N	\N	\N	\N	98705	98705	98706
21514	32007	1	applied	\N	\N	\N	\N	98707	98707	98708
21514	32008	2	applied	\N	\N	\N	\N	98709	98709	98710
21515	31592	0	applied	\N	\N	\N	\N	98044	98044	97549
21515	31602	1	applied	\N	\N	\N	\N	98045	98045	97580
21515	31603	2	applied	\N	\N	\N	\N	98046	98046	97582
21515	31616	3	applied	\N	\N	\N	\N	98047	98047	97618
21515	31138	4	applied	\N	\N	\N	\N	96210	96210	98713
21515	30942	5	applied	\N	\N	1000000000	\N	95607	95607	95608
21515	30952	6	applied	\N	\N	1000000000	\N	95629	95629	95630
21515	30999	7	applied	\N	\N	\N	\N	95779	95779	95754
21515	31735	8	applied	\N	\N	\N	\N	98048	98048	97973
21515	31746	9	applied	\N	\N	\N	\N	98049	98049	98002
21515	31757	10	applied	\N	\N	\N	\N	98050	98050	98030
21515	31758	11	applied	\N	\N	\N	\N	98051	98051	98032
21515	31765	12	applied	\N	\N	\N	\N	98383	98383	98069
21515	31766	13	applied	\N	\N	\N	\N	98384	98384	98071
21515	31416	14	applied	\N	\N	\N	\N	97059	97059	97060
21515	31139	15	applied	\N	\N	\N	\N	96212	96212	98714
21515	31400	16	applied	\N	\N	\N	\N	97008	97008	97009
21515	31250	17	applied	\N	\N	\N	\N	96577	96577	96578
21515	31950	18	applied	\N	\N	\N	\N	98555	98555	47675
21515	31422	19	applied	\N	\N	\N	\N	97262	97262	97073
21515	31960	20	applied	\N	\N	\N	\N	98587	98587	47675
21515	31417	21	applied	\N	\N	\N	\N	97061	97061	97062
21515	31401	22	applied	\N	\N	\N	\N	97010	97010	97011
21467	31911	4	applied	\N	\N	\N	\N	98451	98451	98452
21467	31912	5	applied	\N	\N	\N	\N	98453	98453	98454
21467	31913	6	applied	\N	\N	\N	\N	98455	98455	98456
21467	31914	7	applied	\N	\N	\N	\N	98457	98457	98458
21467	31915	8	applied	\N	\N	\N	\N	98459	98459	98460
21467	31916	9	applied	\N	\N	\N	\N	98461	98461	98462
21469	31917	0	applied	\N	\N	\N	\N	98469	98469	98470
21469	31918	1	applied	\N	\N	\N	\N	98471	98471	98472
21469	31919	2	applied	\N	\N	\N	\N	98473	98473	98474
21484	31934	0	applied	\N	\N	\N	\N	98518	98518	98519
21484	31935	1	applied	\N	\N	\N	\N	98520	98520	98521
21487	31946	0	applied	\N	\N	\N	\N	98545	98545	98546
21487	31947	1	applied	\N	\N	\N	\N	98547	98547	98548
21487	31948	2	applied	\N	\N	\N	\N	98549	98549	98550
21494	31955	0	applied	\N	\N	\N	\N	98568	98568	98569
21494	31956	1	applied	\N	\N	\N	\N	98572	98572	98573
21499	31966	0	applied	\N	\N	\N	\N	98602	98602	98603
21499	31967	1	applied	\N	\N	\N	\N	98604	98604	98605
21504	31974	0	applied	\N	\N	\N	\N	98627	98627	98628
21504	31975	1	applied	\N	\N	\N	\N	98629	98629	98630
21505	31976	0	applied	\N	\N	\N	\N	98632	98632	98633
21505	31977	1	applied	\N	\N	\N	\N	98634	98634	98635
21505	31978	2	applied	\N	\N	\N	\N	98636	98636	98637
21505	31979	3	applied	\N	\N	\N	\N	98638	98638	98639
21505	31980	4	applied	\N	\N	\N	\N	98640	98640	98641
21505	31981	5	applied	\N	\N	\N	\N	98642	98642	98643
21507	31982	0	applied	\N	\N	\N	\N	98648	98648	98649
21507	31983	1	applied	\N	\N	\N	\N	98650	98650	98651
21507	31984	2	applied	\N	\N	\N	\N	98652	98652	98653
21507	31985	3	applied	\N	\N	\N	\N	98654	98654	98655
21510	31989	0	applied	\N	\N	\N	\N	98665	98665	98666
21510	31990	1	applied	\N	\N	\N	\N	98667	98667	98668
21510	31991	2	applied	\N	\N	\N	\N	98669	98669	98670
21510	31992	3	applied	\N	\N	\N	\N	98671	98671	98672
21510	31993	4	applied	\N	\N	\N	\N	98673	98673	98674
21510	31994	5	applied	\N	\N	\N	\N	98675	98675	98676
21510	31995	6	applied	\N	\N	\N	\N	98677	98677	98678
21513	32002	0	applied	\N	\N	\N	\N	98694	98694	98695
21513	32003	1	applied	\N	\N	\N	\N	98696	98696	98697
21513	32004	2	applied	\N	\N	\N	\N	98698	98698	98699
21513	32005	3	applied	\N	\N	\N	\N	98700	98700	98701
21516	32009	0	applied	\N	\N	\N	\N	98733	98733	98734
21516	32010	1	applied	\N	\N	\N	\N	98735	98735	98736
21516	32011	2	applied	\N	\N	\N	\N	98737	98737	98738
21518	31592	0	applied	\N	\N	\N	\N	98044	98044	97549
21518	31602	1	applied	\N	\N	\N	\N	98045	98045	97580
21518	31603	2	applied	\N	\N	\N	\N	98046	98046	97582
21518	31616	3	applied	\N	\N	\N	\N	98047	98047	97618
21518	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21518	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21518	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21518	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21518	31765	8	applied	\N	\N	\N	\N	98383	98383	98069
21518	31766	9	applied	\N	\N	\N	\N	98384	98384	98071
21518	31950	10	applied	\N	\N	\N	\N	98555	98555	47675
21518	31960	11	applied	\N	\N	\N	\N	98587	98587	47675
21518	31719	12	applied	\N	\N	1000000000	\N	97874	97874	97875
21518	31871	13	applied	\N	\N	\N	\N	98337	98337	98320
21518	31110	14	applied	\N	\N	\N	\N	96129	96129	96130
21518	31113	15	applied	\N	\N	\N	\N	96140	96140	96141
21518	31114	16	applied	\N	\N	\N	\N	96142	96142	96143
21518	31118	17	applied	\N	\N	\N	\N	96152	96152	96153
21518	31831	18	applied	\N	\N	\N	\N	98357	98357	98330
21518	31832	19	applied	\N	\N	\N	\N	98358	98358	98242
21518	31838	20	applied	\N	\N	\N	\N	98359	98359	98254
21518	31842	21	applied	\N	\N	\N	\N	98360	98360	98264
21518	31843	22	applied	\N	\N	\N	\N	98361	98361	98266
21518	31851	23	applied	\N	\N	\N	\N	98362	98362	98284
21518	31852	24	applied	\N	\N	\N	\N	98363	98363	98286
21518	31866	25	applied	\N	\N	\N	\N	98364	98364	98320
21518	31120	26	applied	\N	\N	\N	\N	96160	96160	96161
21518	31123	27	applied	\N	\N	\N	\N	96170	96170	96171
21518	31125	28	applied	\N	\N	\N	\N	96177	96177	96178
21518	31126	29	applied	\N	\N	\N	\N	96179	96179	96180
21518	31129	30	applied	\N	\N	\N	\N	96188	96188	96189
21518	31131	31	applied	\N	\N	\N	\N	96192	96192	96193
21518	31133	32	applied	\N	\N	\N	\N	96198	96198	96199
21518	31134	33	applied	\N	\N	\N	\N	96200	96200	96201
21518	31140	34	applied	\N	\N	\N	\N	96214	96214	96215
21518	31147	35	applied	\N	\N	\N	\N	96246	96246	96247
21518	31149	36	applied	\N	\N	\N	\N	96260	96260	96261
21518	31152	37	applied	\N	\N	\N	\N	96273	96273	96274
21518	31153	38	applied	\N	\N	\N	\N	96275	96275	96276
21518	31154	39	applied	\N	\N	\N	\N	96277	96277	96278
21518	31158	40	applied	\N	\N	\N	\N	96287	96287	96288
21518	31161	41	applied	\N	\N	\N	\N	96296	96296	96297
21518	31163	42	applied	\N	\N	\N	\N	96303	96303	96304
21518	31165	43	applied	\N	\N	\N	\N	96307	96307	96308
21518	31168	44	applied	\N	\N	\N	\N	96317	96317	96318
21518	31170	45	applied	\N	\N	\N	\N	96322	96322	96323
21518	31172	47	applied	\N	\N	\N	\N	96328	96328	96329
21518	31173	48	applied	\N	\N	\N	\N	96330	96330	96331
21518	31177	49	applied	\N	\N	\N	\N	96347	96347	96348
21518	31179	50	applied	\N	\N	\N	\N	96355	96355	96356
21518	31180	51	applied	\N	\N	\N	\N	96357	96357	96358
21518	31184	52	applied	\N	\N	\N	\N	96369	96369	96370
21518	31185	53	applied	\N	\N	\N	\N	96371	96371	96372
21518	31188	54	applied	\N	\N	\N	\N	96384	96384	96385
21518	31191	55	applied	\N	\N	\N	\N	96394	96394	96395
21518	31192	56	applied	\N	\N	\N	\N	96399	96399	96400
21518	31194	57	applied	\N	\N	\N	\N	96405	96405	96406
21518	31197	58	applied	\N	\N	\N	\N	96411	96411	96412
21518	31199	59	applied	\N	\N	\N	\N	96419	96419	96420
21518	31201	60	applied	\N	\N	\N	\N	96426	96426	96427
21518	31202	61	applied	\N	\N	\N	\N	96430	96430	96431
21518	31205	62	applied	\N	\N	\N	\N	96441	96441	96442
21518	31207	63	applied	\N	\N	\N	\N	96447	96447	96448
21518	31209	64	applied	\N	\N	\N	\N	96453	96453	96454
21518	31212	65	applied	\N	\N	\N	\N	96460	96460	96461
21518	31213	66	applied	\N	\N	\N	\N	96462	96462	96463
21518	31216	67	applied	\N	\N	\N	\N	96470	96470	96471
21518	31219	68	applied	\N	\N	\N	\N	96480	96480	96481
21518	31220	69	applied	\N	\N	\N	\N	96482	96482	96483
21518	31221	70	applied	\N	\N	\N	\N	96484	96484	96485
21518	31227	71	applied	\N	\N	\N	\N	96500	96500	96501
21518	31229	72	applied	\N	\N	\N	\N	96508	96508	96509
21518	31231	73	applied	\N	\N	\N	\N	96516	96516	96517
21518	31234	74	applied	\N	\N	\N	\N	96528	96528	96529
21518	31235	75	applied	\N	\N	\N	\N	96530	96530	96531
21518	31238	76	applied	\N	\N	\N	\N	96542	96542	96543
21476	31928	8	applied	\N	\N	\N	\N	98498	98498	98499
21476	31929	9	applied	\N	\N	\N	\N	98500	98500	98501
21479	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21479	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21479	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21479	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21483	31930	0	applied	\N	\N	\N	\N	98503	98503	98504
21483	31931	1	applied	\N	\N	\N	\N	98505	98505	98506
21483	31932	2	applied	\N	\N	\N	\N	98507	98507	98508
21483	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21485	31936	0	applied	\N	\N	\N	\N	98522	98522	98523
21485	31937	1	applied	\N	\N	\N	\N	98524	98524	98525
21485	31938	2	applied	\N	\N	\N	\N	98526	98526	98527
21485	31939	3	applied	\N	\N	\N	\N	98528	98528	98529
21485	31940	4	applied	\N	\N	\N	\N	98530	98530	98531
21485	31941	5	applied	\N	\N	\N	\N	98532	98532	98533
21485	31942	6	applied	\N	\N	\N	\N	98534	98534	98535
21490	31953	0	applied	\N	\N	\N	\N	98562	98562	98563
21490	31954	1	applied	\N	\N	\N	\N	98564	98564	98565
21497	31959	0	applied	\N	\N	\N	\N	98585	98585	98586
21497	31960	1	applied	\N	\N	\N	\N	98587	98587	47675
21497	31961	2	applied	\N	\N	\N	\N	98588	98588	98589
21497	31962	3	applied	\N	\N	\N	\N	98590	98590	98591
21497	31963	4	applied	\N	\N	\N	\N	98592	98592	98593
21500	31968	0	applied	\N	\N	\N	\N	98607	98607	98608
21500	31969	1	applied	\N	\N	\N	\N	98609	98609	98610
21502	31968	0	applied	\N	\N	\N	\N	98607	98607	98608
21502	31969	1	applied	\N	\N	\N	\N	98609	98609	98610
21506	31976	0	applied	\N	\N	\N	\N	98632	98632	98633
21506	31977	1	applied	\N	\N	\N	\N	98634	98634	98635
21506	31978	2	applied	\N	\N	\N	\N	98636	98636	98637
21506	31979	3	applied	\N	\N	\N	\N	98638	98638	98639
21506	31980	4	applied	\N	\N	\N	\N	98640	98640	98641
21506	31981	5	applied	\N	\N	\N	\N	98642	98642	98643
21511	31996	0	applied	\N	\N	\N	\N	98681	98681	98682
21511	31997	1	applied	\N	\N	\N	\N	98683	98683	98684
21511	31998	2	applied	\N	\N	\N	\N	98685	98685	98686
21511	31999	3	applied	\N	\N	\N	\N	98687	98687	98688
21511	32000	4	applied	\N	\N	\N	\N	98689	98689	98690
21511	32001	5	applied	\N	\N	\N	\N	98691	98691	98692
21517	32012	0	applied	\N	\N	\N	\N	98741	98741	98742
21517	32013	1	applied	\N	\N	\N	\N	98743	98743	98744
21517	32014	2	applied	\N	\N	\N	\N	98745	98745	98746
21521	32019	0	applied	\N	\N	\N	\N	98762	98762	98763
21521	32020	1	applied	\N	\N	\N	\N	98764	98764	98765
21521	32021	2	applied	\N	\N	\N	\N	98766	98766	98767
21524	32019	0	applied	\N	\N	\N	\N	98762	98762	98763
21524	32020	1	applied	\N	\N	\N	\N	98764	98764	98765
21524	32021	2	applied	\N	\N	\N	\N	98766	98766	98767
21525	32022	0	applied	\N	\N	\N	\N	98773	98773	98774
21525	32023	1	applied	\N	\N	\N	\N	98775	98775	98776
21525	32024	2	applied	\N	\N	\N	\N	98777	98777	98778
21528	32031	0	applied	\N	\N	\N	\N	98797	98797	98798
21528	32032	1	applied	\N	\N	\N	\N	98799	98799	98800
21530	32031	0	applied	\N	\N	\N	\N	98797	98797	98798
21530	32032	1	applied	\N	\N	\N	\N	98799	98799	98800
21530	32033	2	applied	\N	\N	\N	\N	98803	98803	98804
21532	32034	0	applied	\N	\N	\N	\N	98806	98806	98807
21532	32035	1	applied	\N	\N	\N	\N	98808	98808	98809
21532	32036	2	applied	\N	\N	\N	\N	98810	98810	98811
21541	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21541	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21541	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21541	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21541	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21541	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21541	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21541	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21541	31765	8	applied	\N	\N	\N	\N	98383	98383	98069
21541	31766	9	applied	\N	\N	\N	\N	98384	98384	98071
21541	31416	10	applied	\N	\N	\N	\N	97059	97059	97060
21541	31464	11	applied	\N	\N	\N	\N	97261	97261	97189
21541	31266	12	applied	\N	\N	\N	\N	96616	96616	96617
21541	31400	13	applied	\N	\N	\N	\N	97008	97008	97009
21541	31950	14	applied	\N	\N	\N	\N	98555	98555	47675
21541	31422	15	applied	\N	\N	\N	\N	97262	97262	97073
21541	31960	16	applied	\N	\N	\N	\N	98587	98587	47675
21541	31417	17	applied	\N	\N	\N	\N	97061	97061	97062
21541	31401	18	applied	\N	\N	\N	\N	97010	97010	97011
21541	31719	19	applied	\N	\N	1000000000	\N	97874	97874	97875
21541	31423	20	applied	\N	\N	\N	\N	97263	97263	97075
21541	31424	21	applied	\N	\N	\N	\N	97264	97264	97077
21541	31425	22	applied	\N	\N	\N	\N	97265	97265	97079
21541	31402	23	applied	\N	\N	\N	\N	97012	97012	97013
21541	31419	24	applied	\N	\N	\N	\N	97065	97065	97066
21541	31420	25	applied	\N	\N	\N	\N	97067	97067	97068
21541	31871	26	applied	\N	\N	\N	\N	98337	98337	98320
21541	31831	27	applied	\N	\N	\N	\N	98357	98357	98330
21541	31832	28	applied	\N	\N	\N	\N	98358	98358	98242
21541	31838	29	applied	\N	\N	\N	\N	98359	98359	98254
21541	31842	30	applied	\N	\N	\N	\N	98360	98360	98264
21541	31843	31	applied	\N	\N	\N	\N	98361	98361	98266
21541	31851	32	applied	\N	\N	\N	\N	98362	98362	98284
21541	31852	33	applied	\N	\N	\N	\N	98363	98363	98286
21541	31866	34	applied	\N	\N	\N	\N	98364	98364	98320
21541	31403	35	applied	\N	\N	\N	\N	97014	97014	97015
21541	31268	36	applied	\N	\N	\N	\N	96620	96620	92096
21541	31317	37	applied	\N	\N	\N	\N	96764	96764	96765
21541	31269	38	applied	\N	\N	\N	\N	96621	96621	96622
21541	31572	39	applied	\N	\N	\N	\N	97491	97491	29193
21541	31458	40	applied	\N	\N	\N	\N	97174	97174	98835
21541	31342	41	applied	\N	\N	\N	\N	96838	96838	29193
21541	31477	42	applied	\N	\N	\N	\N	97217	97217	96630
21541	31478	43	applied	\N	\N	1000000000	\N	97219	97219	97220
21541	31479	44	applied	\N	\N	1000000000	\N	97221	97221	97222
21541	31480	45	applied	\N	\N	1000000000	\N	97223	97223	97224
21541	31481	46	applied	\N	\N	\N	\N	97225	97225	97226
21541	31482	47	applied	\N	\N	1000000000	\N	97227	97227	97228
21541	31623	48	applied	\N	\N	1000000000	\N	97631	97631	97632
21541	31640	49	applied	\N	\N	\N	\N	97671	97671	97672
21541	31784	50	applied	\N	\N	\N	\N	98119	98119	98120
21541	31484	51	applied	\N	\N	\N	\N	97232	97232	98836
21541	31496	52	applied	\N	\N	\N	\N	97258	97258	96637
21541	31507	53	applied	\N	\N	\N	\N	97308	97308	98837
21541	31517	54	applied	\N	\N	\N	\N	97333	97333	96643
21541	31527	55	applied	\N	\N	\N	\N	97359	97359	98838
21541	31540	56	applied	\N	\N	\N	\N	97396	97396	96648
21541	31830	57	applied	\N	\N	\N	\N	98235	98235	98236
21541	31404	58	applied	\N	\N	\N	\N	98839	98839	97017
21482	31933	3	applied	\N	\N	\N	\N	98509	98509	98510
21489	31949	0	applied	\N	\N	\N	\N	98553	98553	98554
21489	31950	1	applied	\N	\N	\N	\N	98555	98555	47675
21489	31951	2	applied	\N	\N	\N	\N	98556	98556	98557
21489	31952	3	applied	\N	\N	\N	\N	98558	98558	98559
21492	31955	0	applied	\N	\N	\N	\N	98568	98568	98569
21492	31956	1	applied	\N	\N	\N	\N	98572	98572	98573
21496	31959	0	applied	\N	\N	\N	\N	98585	98585	98586
21496	31960	1	applied	\N	\N	\N	\N	98587	98587	47675
21496	31961	2	applied	\N	\N	\N	\N	98588	98588	98589
21496	31962	3	applied	\N	\N	\N	\N	98590	98590	98591
21496	31963	4	applied	\N	\N	\N	\N	98592	98592	98593
21509	31986	0	applied	\N	\N	\N	\N	98658	98658	98659
21509	31987	1	applied	\N	\N	\N	\N	98660	98660	98661
21509	31988	2	applied	\N	\N	\N	\N	98662	98662	98663
21512	32002	0	applied	\N	\N	\N	\N	98694	98694	98695
21512	32003	1	applied	\N	\N	\N	\N	98696	98696	98697
21512	32004	2	applied	\N	\N	\N	\N	98698	98698	98699
21512	32005	3	applied	\N	\N	\N	\N	98700	98700	98701
21523	32019	0	applied	\N	\N	\N	\N	98762	98762	98763
21523	32021	1	applied	\N	\N	\N	\N	98766	98766	98769
21529	32031	0	applied	\N	\N	\N	\N	98797	98797	98798
21529	32032	1	applied	\N	\N	\N	\N	98799	98799	98800
21529	32033	2	applied	\N	\N	\N	\N	98803	98803	98804
21533	32034	0	applied	\N	\N	\N	\N	98806	98806	98807
21533	32035	1	applied	\N	\N	\N	\N	98808	98808	98809
21533	32036	2	applied	\N	\N	\N	\N	98810	98810	98811
21538	31950	0	applied	\N	\N	\N	\N	98555	98555	47675
21542	32040	0	applied	\N	\N	\N	\N	98869	98869	98870
21542	32041	1	applied	\N	\N	\N	\N	98871	98871	98872
21542	32042	2	applied	\N	\N	\N	\N	98873	98873	98874
21542	32038	3	applied	\N	\N	\N	\N	98825	98825	98828
21542	32043	4	applied	\N	\N	\N	\N	98875	98875	98876
21542	32044	5	applied	\N	\N	\N	\N	98877	98877	98878
21542	32045	6	applied	\N	\N	\N	\N	98879	98879	98880
21542	32046	7	applied	\N	\N	\N	\N	98881	98881	98882
21542	32047	8	applied	\N	\N	\N	\N	98883	98883	98884
21542	32048	9	applied	\N	\N	\N	\N	98885	98885	98886
21544	32040	0	applied	\N	\N	\N	\N	98869	98869	98870
21544	32041	1	applied	\N	\N	\N	\N	98871	98871	98872
21544	32042	2	applied	\N	\N	\N	\N	98873	98873	98874
21544	32043	3	applied	\N	\N	\N	\N	98875	98875	98876
21544	32044	4	applied	\N	\N	\N	\N	98877	98877	98878
21544	32045	5	applied	\N	\N	\N	\N	98879	98879	98880
21544	32046	6	applied	\N	\N	\N	\N	98881	98881	98882
21544	32047	7	applied	\N	\N	\N	\N	98883	98883	98884
21544	32048	8	applied	\N	\N	\N	\N	98885	98885	98886
21550	32054	0	applied	\N	\N	\N	\N	98912	98912	98913
21550	32055	1	applied	\N	\N	\N	\N	98914	98914	98915
21550	32056	2	applied	\N	\N	\N	\N	98916	98916	98917
21556	32062	0	applied	\N	\N	\N	\N	98947	98947	98948
21556	32063	1	applied	\N	\N	\N	\N	98949	98949	98950
21556	32064	2	applied	\N	\N	\N	\N	98951	98951	98952
21558	32065	0	applied	\N	\N	\N	\N	98957	98957	98958
21558	32066	1	applied	\N	\N	\N	\N	98959	98959	98960
21558	32067	2	applied	\N	\N	\N	\N	98961	98961	98962
21563	32071	0	applied	\N	\N	\N	\N	98974	98974	98975
21563	32072	1	applied	\N	\N	\N	\N	98976	98976	98977
21567	32077	0	applied	\N	\N	\N	\N	98996	98996	98997
21567	32078	1	applied	\N	\N	\N	\N	98998	98998	98999
21569	32077	0	applied	\N	\N	\N	\N	98996	98996	98997
21569	32078	1	applied	\N	\N	\N	\N	98998	98998	98999
21569	32079	2	applied	\N	\N	\N	\N	99001	99001	99002
21571	32078	0	applied	\N	\N	\N	\N	98998	98998	98999
21571	32079	1	applied	\N	\N	\N	\N	99001	99001	99002
21577	32086	0	applied	\N	\N	\N	\N	99026	99026	99027
21577	32087	1	applied	\N	\N	\N	\N	99028	99028	99029
21577	32088	2	applied	\N	\N	\N	\N	99030	99030	99031
21578	32089	0	applied	\N	\N	\N	\N	99034	99034	99035
21580	32083	0	applied	\N	\N	\N	\N	99016	99016	99017
21580	32086	1	applied	\N	\N	\N	\N	99026	99026	99027
21580	32084	2	applied	\N	\N	\N	\N	99018	99018	99019
21580	32085	3	applied	\N	\N	\N	\N	99020	99020	99021
21580	32087	4	applied	\N	\N	\N	\N	99028	99028	99029
21580	32088	5	applied	\N	\N	\N	\N	99030	99030	99031
21580	32090	6	applied	\N	\N	\N	\N	99037	99037	99038
21580	32091	7	applied	\N	\N	\N	\N	99039	99039	99040
21583	32093	0	applied	\N	\N	\N	\N	99048	99048	99049
21583	32094	1	applied	\N	\N	\N	\N	99050	99050	99051
21583	32090	2	applied	\N	\N	\N	\N	99037	99037	99038
21583	32095	3	applied	\N	\N	\N	\N	99052	99052	12588
21583	32096	4	applied	\N	\N	\N	\N	99053	99053	99054
21583	32097	5	applied	\N	\N	\N	\N	99055	99055	99056
21583	32098	6	applied	\N	\N	\N	\N	99057	99057	99058
21583	32091	7	applied	\N	\N	\N	\N	99039	99039	99059
21583	32099	8	applied	\N	\N	\N	\N	99060	99060	99061
21583	32100	9	applied	\N	\N	\N	\N	99062	99062	99063
21583	32101	10	applied	\N	\N	\N	\N	99064	99064	99065
21588	32108	0	applied	\N	\N	\N	\N	99086	99086	99087
21588	32109	1	applied	\N	\N	\N	\N	99088	99088	99089
21588	32110	2	applied	\N	\N	\N	\N	99090	99090	99091
21590	32111	0	applied	\N	\N	\N	\N	99096	99096	99097
21590	32112	1	applied	\N	\N	\N	\N	99098	99098	99099
21590	32113	2	applied	\N	\N	\N	\N	99100	99100	99101
21590	32114	3	applied	\N	\N	\N	\N	99102	99102	99103
21590	32115	5	applied	\N	\N	\N	\N	99105	99105	99106
21590	32116	6	applied	\N	\N	\N	\N	99107	99107	99108
21590	32117	7	applied	\N	\N	\N	\N	99109	99109	47675
21595	32118	0	applied	\N	\N	\N	\N	99122	99122	99123
21595	32119	1	applied	\N	\N	\N	\N	99124	99124	99125
21595	32120	2	applied	\N	\N	\N	\N	99126	99126	99127
21595	32121	3	applied	\N	\N	\N	\N	99128	99128	99129
21595	32122	4	applied	\N	\N	\N	\N	99130	99130	99131
21595	32123	5	applied	\N	\N	\N	\N	99132	99132	99133
21601	32127	0	applied	\N	\N	\N	\N	99147	99147	99148
21601	32128	1	applied	\N	\N	\N	\N	99149	99149	99150
21601	32129	2	applied	\N	\N	\N	\N	99151	99151	99152
21603	32130	0	applied	\N	\N	\N	\N	99159	99159	99160
21603	32131	1	applied	\N	\N	\N	\N	99161	99161	99162
21609	32133	0	applied	\N	\N	\N	\N	99172	99172	99173
21609	32134	1	applied	\N	\N	\N	\N	99175	99175	99176
21609	32135	2	applied	\N	\N	\N	\N	99177	99177	99178
21612	32139	0	applied	\N	\N	\N	\N	99189	99189	99190
21612	32140	1	applied	\N	\N	\N	\N	99191	99191	99192
21612	32141	2	applied	\N	\N	\N	\N	99193	99193	99194
21618	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21618	31746	1	applied	\N	\N	\N	\N	98001	98001	98002
21618	31757	2	applied	\N	\N	\N	\N	98029	98029	98030
21618	31758	3	applied	\N	\N	\N	\N	98031	98031	98032
21618	31765	4	applied	\N	\N	\N	\N	98068	98068	98069
21515	31719	23	applied	\N	\N	1000000000	\N	97874	97874	97875
21515	31423	24	applied	\N	\N	\N	\N	97263	97263	97075
21515	31424	25	applied	\N	\N	\N	\N	97264	97264	97077
21515	31425	26	applied	\N	\N	\N	\N	97265	97265	97079
21515	31084	27	applied	\N	\N	\N	\N	96048	96048	96049
21515	31085	28	applied	\N	\N	\N	\N	96050	96050	96051
21515	31402	29	applied	\N	\N	\N	\N	97012	97012	97013
21515	31142	30	applied	\N	\N	\N	\N	98715	98715	96221
21515	31143	31	applied	\N	\N	\N	\N	98716	98716	96223
21515	31144	32	applied	\N	\N	\N	\N	98717	98717	96225
21515	31145	33	applied	\N	\N	\N	\N	98718	98718	96227
21515	31086	34	applied	\N	\N	\N	\N	96052	96052	96053
21515	31146	35	applied	\N	\N	\N	\N	96228	96228	96229
21515	30946	36	applied	\N	\N	\N	\N	95617	95617	95618
21515	31419	37	applied	\N	\N	\N	\N	97065	97065	97066
21515	31420	38	applied	\N	\N	\N	\N	97067	97067	97068
21515	31052	39	applied	\N	\N	\N	\N	95918	95918	95919
21515	31053	40	applied	\N	\N	\N	\N	95920	95920	95921
21515	31054	41	applied	\N	\N	\N	\N	95922	95922	95923
21515	31055	42	applied	\N	\N	\N	\N	95924	95924	95925
21515	31871	43	applied	\N	\N	\N	\N	98337	98337	98320
21515	31018	44	applied	\N	\N	\N	\N	95821	95821	95822
21515	31019	45	applied	\N	\N	\N	\N	95823	95823	95824
21515	31020	46	applied	\N	\N	\N	\N	95825	95825	95826
21515	31021	47	applied	\N	\N	\N	\N	95827	95827	95828
21515	31026	48	applied	\N	\N	\N	\N	95841	95841	95842
21515	31831	49	applied	\N	\N	\N	\N	98357	98357	98330
21515	31832	50	applied	\N	\N	\N	\N	98358	98358	98242
21515	31838	51	applied	\N	\N	\N	\N	98359	98359	98254
21515	31842	52	applied	\N	\N	\N	\N	98360	98360	98264
21515	31843	53	applied	\N	\N	\N	\N	98361	98361	98266
21515	31851	54	applied	\N	\N	\N	\N	98362	98362	98284
21515	31852	55	applied	\N	\N	\N	\N	98363	98363	98286
21515	31866	56	applied	\N	\N	\N	\N	98364	98364	98320
21515	31403	57	applied	\N	\N	\N	\N	97014	97014	97015
21515	31268	58	applied	\N	\N	\N	\N	96620	96620	92096
21515	31317	59	applied	\N	\N	\N	\N	96764	96764	96765
21515	31342	60	applied	\N	\N	\N	\N	96838	96838	29193
21515	31477	61	applied	\N	\N	\N	\N	97217	97217	95959
21515	31478	62	applied	\N	\N	1000000000	\N	97219	97219	97220
21515	31479	63	applied	\N	\N	1000000000	\N	97221	97221	97222
21515	31480	64	applied	\N	\N	1000000000	\N	97223	97223	97224
21515	31481	65	applied	\N	\N	\N	\N	97225	97225	97226
21515	31482	66	applied	\N	\N	1000000000	\N	97227	97227	97228
21515	31623	67	applied	\N	\N	1000000000	\N	97631	97631	97632
21515	31640	68	applied	\N	\N	\N	\N	97671	97671	97672
21515	31784	69	applied	\N	\N	\N	\N	98119	98119	98120
21515	31830	70	applied	\N	\N	\N	\N	98235	98235	98236
21515	31404	71	applied	\N	\N	\N	\N	97016	97016	97017
21515	31405	72	applied	\N	\N	\N	\N	97018	97018	97019
21515	31406	73	applied	\N	\N	\N	\N	97020	97020	97021
21515	31407	74	applied	\N	\N	\N	\N	97022	97022	97023
21515	31461	75	applied	\N	\N	1000000000	\N	97180	97180	97181
21515	31462	76	applied	\N	\N	1000000000	\N	97182	97182	97183
21515	31463	77	applied	\N	\N	1000000000	\N	97184	97184	97185
21515	31466	78	applied	\N	\N	1000000000	\N	97192	97192	97193
21515	31835	79	applied	\N	\N	\N	\N	98247	98247	98248
21515	31468	80	applied	\N	\N	1000000000	\N	97196	97196	97197
21515	31469	81	applied	\N	\N	1000000000	\N	97198	97198	97199
21515	31470	82	applied	\N	\N	\N	\N	97200	97200	97201
21515	31471	83	applied	\N	\N	\N	\N	97202	97202	97203
21515	31472	84	applied	\N	\N	1000000000	\N	97204	97204	97205
21515	31473	85	applied	\N	\N	1000000000	\N	97206	97206	97207
21515	31485	86	applied	\N	\N	1000000000	\N	97234	97234	97235
21515	31486	87	applied	\N	\N	1000000000	\N	97236	97236	97237
21515	31487	88	applied	\N	\N	\N	\N	97238	97238	97239
21515	31488	89	applied	\N	\N	1000000000	\N	97240	97240	97241
21515	31489	90	applied	\N	\N	\N	\N	97242	97242	95624
21515	31490	91	applied	\N	\N	\N	\N	97244	97244	97245
21515	31495	92	applied	\N	\N	\N	\N	97256	97256	95634
21515	31501	93	applied	\N	\N	\N	\N	97288	97288	98719
21515	31502	94	applied	\N	\N	\N	\N	97291	97291	95961
21515	31504	95	applied	\N	\N	\N	\N	97300	97300	95669
21515	31509	96	applied	\N	\N	\N	\N	97312	97312	95964
21515	31511	97	applied	\N	\N	\N	\N	97318	97318	98720
21515	31514	98	applied	\N	\N	\N	\N	97326	97326	95687
21515	31519	99	applied	\N	\N	\N	\N	97337	97337	95699
21515	31523	100	applied	\N	\N	\N	\N	97348	97348	95967
21515	31524	101	applied	\N	\N	\N	\N	97350	97350	95717
21515	31528	102	applied	\N	\N	\N	\N	97361	97361	95726
21515	31532	103	applied	\N	\N	\N	\N	97372	97372	95744
21515	31533	104	applied	\N	\N	\N	\N	97374	97374	95970
21515	31538	105	applied	\N	\N	\N	\N	97389	97389	95750
21515	31541	106	applied	\N	\N	\N	\N	97398	97398	95770
21515	31545	107	applied	\N	\N	\N	\N	97413	97413	98721
21515	31547	109	applied	\N	\N	\N	\N	97423	97423	95789
21515	31549	110	applied	\N	\N	\N	\N	97436	97436	95793
21515	31554	111	applied	\N	\N	\N	\N	97448	97448	98723
21515	31556	112	applied	\N	\N	\N	\N	97456	97456	98724
21515	31563	113	applied	\N	\N	\N	\N	97472	97472	95838
21515	31566	114	applied	\N	\N	\N	\N	97478	97478	95854
21515	31567	115	applied	\N	\N	\N	\N	97480	97480	98725
21515	31568	116	applied	\N	\N	\N	\N	97482	97482	95869
21515	31571	117	applied	\N	\N	\N	\N	97489	97489	98726
21515	31578	118	applied	\N	\N	\N	\N	97504	97504	98727
21515	31580	119	applied	\N	\N	\N	\N	97509	97509	95895
21515	31585	120	applied	\N	\N	\N	\N	97523	97523	95904
21515	31588	121	applied	\N	\N	\N	\N	97531	97531	98728
21515	31591	122	applied	\N	\N	\N	\N	97539	97539	95935
21515	31595	123	applied	\N	\N	\N	\N	97554	97554	98729
21515	31597	124	applied	\N	\N	\N	\N	97563	97563	95941
21515	31601	125	applied	\N	\N	\N	\N	97573	97573	95978
21519	32012	0	applied	\N	\N	\N	\N	98741	98741	98742
21519	32013	1	applied	\N	\N	\N	\N	98743	98743	98744
21519	32014	2	applied	\N	\N	\N	\N	98745	98745	98746
21522	32019	0	applied	\N	\N	\N	\N	98762	98762	98763
21522	32020	1	applied	\N	\N	\N	\N	98764	98764	98765
21522	32021	2	applied	\N	\N	\N	\N	98766	98766	98767
21526	31960	0	applied	\N	\N	\N	\N	98587	98587	47675
21535	32034	0	applied	\N	\N	\N	\N	98806	98806	98807
21535	32035	1	applied	\N	\N	\N	\N	98808	98808	98809
21535	32036	2	applied	\N	\N	\N	\N	98810	98810	98811
21537	32037	0	applied	\N	\N	\N	\N	98823	98823	98824
21537	32038	1	applied	\N	\N	\N	\N	98825	98825	98826
21537	32039	2	applied	\N	\N	\N	\N	98827	98827	98828
21539	32037	0	applied	\N	\N	\N	\N	98823	98823	98824
21539	32038	1	applied	\N	\N	\N	\N	98825	98825	98826
21539	32039	2	applied	\N	\N	\N	\N	98827	98827	98828
21518	31241	77	applied	\N	\N	\N	\N	96551	96551	96552
21518	31243	78	applied	\N	\N	\N	\N	96559	96559	96560
21518	31244	79	applied	\N	\N	\N	\N	96561	96561	96562
21518	31247	80	applied	\N	\N	\N	\N	96569	96569	96570
21518	31251	81	applied	\N	\N	\N	\N	96579	96579	96580
21518	31252	82	applied	\N	\N	\N	\N	96582	96582	96583
21518	31253	83	applied	\N	\N	\N	\N	96584	96584	96585
21518	31254	84	applied	\N	\N	\N	\N	96586	96586	96587
21518	31260	85	applied	\N	\N	\N	\N	96601	96601	96602
21518	31262	86	applied	\N	\N	\N	\N	96605	96605	96606
21518	31263	87	applied	\N	\N	\N	\N	96607	96607	96608
21518	31266	88	applied	\N	\N	\N	\N	96616	96616	96617
21518	31267	89	applied	\N	\N	\N	\N	96618	96618	96619
21518	31271	90	applied	\N	\N	\N	\N	96627	96627	96628
21518	31273	91	applied	\N	\N	\N	\N	96634	96634	96635
21518	31275	92	applied	\N	\N	\N	\N	96640	96640	96641
21518	31277	93	applied	\N	\N	\N	\N	96645	96645	96646
21518	31279	94	applied	\N	\N	\N	\N	96651	96651	96652
21518	31280	95	applied	\N	\N	\N	\N	96653	96653	96654
21518	31281	96	applied	\N	\N	\N	\N	96655	96655	96656
21518	31285	97	applied	\N	\N	\N	\N	96665	96665	96666
21518	31287	98	applied	\N	\N	\N	\N	96673	96673	96674
21518	31289	99	applied	\N	\N	\N	\N	96679	96679	96680
21518	31291	100	applied	\N	\N	\N	\N	96687	96687	96688
21518	31293	101	applied	\N	\N	\N	\N	96692	96692	96693
21518	31295	102	applied	\N	\N	\N	\N	96702	96702	96703
21518	31297	103	applied	\N	\N	\N	\N	96713	96713	96714
21518	31298	104	applied	\N	\N	\N	\N	96715	96715	96716
21518	31299	105	applied	\N	\N	\N	\N	96717	96717	96718
21518	31302	106	applied	\N	\N	\N	\N	96726	96726	96727
21518	31304	107	applied	\N	\N	\N	\N	96732	96732	96733
21518	31305	108	applied	\N	\N	\N	\N	96734	96734	96735
21518	31308	109	applied	\N	\N	\N	\N	96741	96741	96742
21518	31310	110	applied	\N	\N	\N	\N	96747	96747	96748
21518	31311	111	applied	\N	\N	\N	\N	96749	96749	96750
21518	31312	112	applied	\N	\N	\N	\N	96751	96751	96752
21518	31316	113	applied	\N	\N	\N	\N	96762	96762	96763
21518	31318	114	applied	\N	\N	\N	\N	96769	96769	96770
21518	31319	115	applied	\N	\N	\N	\N	96776	96776	96777
21518	31320	116	applied	\N	\N	\N	\N	96778	96778	96779
21518	31321	117	applied	\N	\N	\N	\N	96780	96780	96781
21518	31326	118	applied	\N	\N	\N	\N	96794	96794	96795
21518	31329	119	applied	\N	\N	\N	\N	96802	96802	96803
21518	31331	120	applied	\N	\N	\N	\N	96807	96807	96808
21518	31333	121	applied	\N	\N	\N	\N	96820	96820	96821
21518	31335	122	applied	\N	\N	\N	\N	96824	96824	96825
21518	31336	123	applied	\N	\N	\N	\N	96826	96826	96827
21518	31337	124	applied	\N	\N	\N	\N	96828	96828	96829
21518	31345	125	applied	\N	\N	\N	\N	96846	96846	96847
21520	32015	0	applied	\N	\N	\N	\N	98753	98753	98754
21520	32016	1	applied	\N	\N	\N	\N	98755	98755	98756
21520	32017	2	applied	\N	\N	\N	\N	98757	98757	98758
21520	32018	3	applied	\N	\N	\N	\N	98759	98759	98760
21527	32025	0	applied	\N	\N	\N	\N	98783	98783	98784
21527	32026	1	applied	\N	\N	\N	\N	98785	98785	98786
21527	32027	2	applied	\N	\N	\N	\N	98787	98787	98788
21527	32028	3	applied	\N	\N	\N	\N	98789	98789	98790
21527	32029	4	applied	\N	\N	\N	\N	98791	98791	98792
21527	32030	5	applied	\N	\N	\N	\N	98793	98793	98794
21534	32034	0	applied	\N	\N	\N	\N	98806	98806	98807
21534	32035	1	applied	\N	\N	\N	\N	98808	98808	98809
21534	32036	2	applied	\N	\N	\N	\N	98810	98810	98811
21536	32034	0	applied	\N	\N	\N	\N	98806	98806	98807
21536	32035	1	applied	\N	\N	\N	\N	98808	98808	98809
21536	32036	2	applied	\N	\N	\N	\N	98810	98810	98811
21540	32037	0	applied	\N	\N	\N	\N	98823	98823	98824
21540	32039	1	applied	\N	\N	\N	\N	98827	98827	98833
21545	32049	0	applied	\N	\N	\N	\N	98892	98892	98893
21545	32050	1	applied	\N	\N	\N	\N	98894	98894	98895
21545	32051	2	applied	\N	\N	\N	\N	98896	98896	98897
21551	32057	0	applied	\N	\N	\N	\N	98919	98919	98920
21551	32058	1	applied	\N	\N	\N	\N	98921	98921	98922
21557	32062	0	applied	\N	\N	\N	\N	98947	98947	98948
21557	32063	1	applied	\N	\N	\N	\N	98949	98949	98950
21557	32064	2	applied	\N	\N	\N	\N	98951	98951	98952
21561	32071	0	applied	\N	\N	\N	\N	98974	98974	98975
21561	32072	1	applied	\N	\N	\N	\N	98976	98976	98977
21561	32073	2	applied	\N	\N	\N	\N	98978	98978	98979
21572	32080	0	applied	\N	\N	\N	\N	99007	99007	99008
21572	32081	1	applied	\N	\N	\N	\N	99009	99009	99010
21572	32079	2	applied	\N	\N	\N	\N	99001	99001	99011
21572	32082	3	applied	\N	\N	\N	\N	99012	99012	99013
21574	32077	0	applied	\N	\N	\N	\N	98996	98996	98997
21574	32080	1	applied	\N	\N	\N	\N	99007	99007	99008
21574	32078	2	applied	\N	\N	\N	\N	98998	98998	98999
21574	32081	3	applied	\N	\N	\N	\N	99009	99009	99010
21574	32079	4	applied	\N	\N	\N	\N	99001	99001	99011
21574	32082	5	applied	\N	\N	\N	\N	99012	99012	99013
21579	32089	0	applied	\N	\N	\N	\N	99034	99034	99035
21579	32090	1	applied	\N	\N	\N	\N	99037	99037	99038
21579	32091	2	applied	\N	\N	\N	\N	99039	99039	99040
21581	32092	0	applied	\N	\N	\N	\N	99044	99044	99045
21586	32105	0	applied	\N	\N	\N	\N	99078	99078	99079
21586	32106	1	applied	\N	\N	\N	\N	99080	99080	99081
21586	32107	2	applied	\N	\N	\N	\N	99082	99082	99083
21592	32111	0	applied	\N	\N	\N	\N	99096	99096	99097
21592	32112	1	applied	\N	\N	\N	\N	99098	99098	99099
21592	32113	2	applied	\N	\N	\N	\N	99100	99100	99101
21592	32114	3	applied	\N	\N	\N	\N	99102	99102	99103
21592	32115	5	applied	\N	\N	\N	\N	99105	99105	99106
21592	32116	6	applied	\N	\N	\N	\N	99107	99107	99108
21592	32117	7	applied	\N	\N	\N	\N	99109	99109	47675
21597	32124	0	applied	\N	\N	\N	\N	99139	99139	99140
21597	32125	1	applied	\N	\N	\N	\N	99141	99141	99142
21597	32126	2	applied	\N	\N	\N	\N	99143	99143	99144
21599	32127	0	applied	\N	\N	\N	\N	99147	99147	99148
21599	32128	1	applied	\N	\N	\N	\N	99149	99149	99150
21599	32129	2	applied	\N	\N	\N	\N	99151	99151	99152
21602	32127	0	applied	\N	\N	\N	\N	99147	99147	99148
21602	32128	1	applied	\N	\N	\N	\N	99149	99149	99150
21602	32129	2	applied	\N	\N	\N	\N	99151	99151	99152
21604	32130	0	applied	\N	\N	\N	\N	99159	99159	99160
21604	32132	1	applied	\N	\N	\N	\N	99163	99163	99164
21604	32131	2	applied	\N	\N	\N	\N	99161	99161	99165
21610	32136	0	applied	\N	\N	\N	\N	99181	99181	99182
21610	32134	1	applied	\N	\N	\N	\N	99175	99175	99176
21610	32137	2	applied	\N	\N	\N	\N	99183	99183	99184
21610	32135	3	applied	\N	\N	\N	\N	99177	99177	99185
21610	32138	4	applied	\N	\N	\N	\N	99186	99186	99187
21617	32145	0	applied	\N	\N	\N	\N	99206	99206	99207
21541	31405	59	applied	\N	\N	\N	\N	98840	98840	97019
21541	31406	60	applied	\N	\N	\N	\N	98841	98841	97021
21541	31407	61	applied	\N	\N	\N	\N	98842	98842	97023
21541	31461	62	applied	\N	\N	1000000000	\N	97180	97180	97181
21541	31462	63	applied	\N	\N	1000000000	\N	97182	97182	97183
21541	31463	64	applied	\N	\N	1000000000	\N	97184	97184	97185
21541	31466	65	applied	\N	\N	1000000000	\N	97192	97192	97193
21541	31835	66	applied	\N	\N	\N	\N	98247	98247	98248
21541	31270	67	applied	\N	\N	\N	\N	96623	96623	96658
21541	31468	68	applied	\N	\N	1000000000	\N	97196	97196	97197
21541	31469	69	applied	\N	\N	1000000000	\N	97198	97198	97199
21541	31470	70	applied	\N	\N	\N	\N	97200	97200	97201
21541	31471	71	applied	\N	\N	\N	\N	97202	97202	97203
21541	31472	72	applied	\N	\N	1000000000	\N	97204	97204	97205
21541	31473	73	applied	\N	\N	1000000000	\N	97206	97206	97207
21541	31485	74	applied	\N	\N	1000000000	\N	97234	97234	97235
21541	31486	75	applied	\N	\N	1000000000	\N	97236	97236	97237
21541	31550	76	applied	\N	\N	\N	\N	97438	97438	98843
21541	31562	77	applied	\N	\N	\N	\N	97470	97470	96660
21541	31574	78	applied	\N	\N	\N	\N	97494	97494	98844
21541	31583	79	applied	\N	\N	\N	\N	97519	97519	96662
21541	31596	80	applied	\N	\N	\N	\N	97556	97556	98845
21541	31608	81	applied	\N	\N	\N	\N	97593	97593	96668
21541	31487	82	applied	\N	\N	\N	\N	97238	97238	97239
21541	31488	83	applied	\N	\N	1000000000	\N	97240	97240	97241
21541	31489	84	applied	\N	\N	\N	\N	97242	97242	98846
21541	31490	85	applied	\N	\N	\N	\N	97244	97244	97245
21541	31495	86	applied	\N	\N	\N	\N	97256	97256	96690
21541	31501	87	applied	\N	\N	\N	\N	97288	97288	98847
21541	31502	88	applied	\N	\N	\N	\N	97291	97291	96720
21541	31504	89	applied	\N	\N	\N	\N	97300	97300	98848
21541	31509	90	applied	\N	\N	\N	\N	97312	97312	96737
21541	31511	91	applied	\N	\N	\N	\N	97318	97318	98849
21541	31514	92	applied	\N	\N	\N	\N	97326	97326	96754
21541	31519	93	applied	\N	\N	\N	\N	97337	97337	98850
21541	31523	94	applied	\N	\N	\N	\N	97348	97348	96783
21541	31524	95	applied	\N	\N	\N	\N	97350	97350	98851
21541	31528	96	applied	\N	\N	\N	\N	97361	97361	96789
21541	31532	97	applied	\N	\N	\N	\N	97372	97372	98852
21541	31533	98	applied	\N	\N	\N	\N	97374	97374	96811
21541	31538	99	applied	\N	\N	\N	\N	97389	97389	98853
21541	31541	100	applied	\N	\N	\N	\N	97398	97398	96840
21541	31545	101	applied	\N	\N	\N	\N	97413	97413	98854
21541	31547	102	applied	\N	\N	\N	\N	97423	97423	96855
21541	31549	103	applied	\N	\N	\N	\N	97436	97436	98855
21541	31554	104	applied	\N	\N	\N	\N	97448	97448	96873
21541	31556	105	applied	\N	\N	\N	\N	97456	97456	98856
21541	31563	106	applied	\N	\N	\N	\N	97472	97472	96891
21541	31566	107	applied	\N	\N	\N	\N	97478	97478	98857
21541	31567	109	applied	\N	\N	\N	\N	97480	97480	96913
21541	31568	110	applied	\N	\N	\N	\N	97482	97482	98859
21541	31571	111	applied	\N	\N	\N	\N	97489	97489	96928
21541	31578	112	applied	\N	\N	\N	\N	97504	97504	98860
21541	31580	113	applied	\N	\N	\N	\N	97509	97509	96940
21541	31585	114	applied	\N	\N	\N	\N	97523	97523	98861
21541	31588	115	applied	\N	\N	\N	\N	97531	97531	96956
21541	31591	116	applied	\N	\N	\N	\N	97539	97539	98862
21541	31595	117	applied	\N	\N	\N	\N	97554	97554	96981
21541	31597	118	applied	\N	\N	\N	\N	97563	97563	98863
21541	31601	119	applied	\N	\N	\N	\N	97573	97573	96997
21541	31605	120	applied	\N	\N	\N	\N	97585	97585	98864
21541	31609	121	applied	\N	\N	\N	\N	97595	97595	97041
21541	31612	122	applied	\N	\N	\N	\N	97604	97604	98865
21541	31614	123	applied	\N	\N	\N	\N	97608	97608	97070
21541	31620	124	applied	\N	\N	\N	\N	97625	97625	98866
21541	31621	125	applied	\N	\N	\N	\N	97627	97627	97104
21543	32038	0	applied	\N	\N	\N	\N	98825	98825	98828
21543	32043	1	applied	\N	\N	\N	\N	98875	98875	98876
21543	32044	2	applied	\N	\N	\N	\N	98877	98877	98878
21543	32045	3	applied	\N	\N	\N	\N	98879	98879	98880
21543	32046	4	applied	\N	\N	\N	\N	98881	98881	98882
21543	32047	5	applied	\N	\N	\N	\N	98883	98883	98884
21543	32048	6	applied	\N	\N	\N	\N	98885	98885	98886
21552	32057	0	applied	\N	\N	\N	\N	98919	98919	98920
21552	32058	1	applied	\N	\N	\N	\N	98921	98921	98922
21559	32065	0	applied	\N	\N	\N	\N	98957	98957	98958
21559	32066	1	applied	\N	\N	\N	\N	98959	98959	98960
21559	32067	2	applied	\N	\N	\N	\N	98961	98961	98962
21564	32074	0	applied	\N	\N	\N	\N	98984	98984	98985
21564	32073	1	applied	\N	\N	\N	\N	98978	98978	98979
21564	32075	2	applied	\N	\N	\N	\N	98986	98986	98987
21564	32076	3	applied	\N	\N	\N	\N	98988	98988	98989
21566	32074	0	applied	\N	\N	\N	\N	98984	98984	98985
21566	32073	1	applied	\N	\N	\N	\N	98978	98978	98979
21566	32075	2	applied	\N	\N	\N	\N	98986	98986	98987
21566	32076	3	applied	\N	\N	\N	\N	98988	98988	98989
21568	32077	0	applied	\N	\N	\N	\N	98996	98996	98997
21568	32078	1	applied	\N	\N	\N	\N	98998	98998	98999
21568	32079	2	applied	\N	\N	\N	\N	99001	99001	99002
21570	32077	0	applied	\N	\N	\N	\N	98996	98996	98997
21570	32078	1	applied	\N	\N	\N	\N	98998	98998	98999
21570	32079	2	applied	\N	\N	\N	\N	99001	99001	99002
21575	32086	0	applied	\N	\N	\N	\N	99026	99026	99027
21575	32087	1	applied	\N	\N	\N	\N	99028	99028	99029
21575	32088	2	applied	\N	\N	\N	\N	99030	99030	99031
21582	32093	0	applied	\N	\N	\N	\N	99048	99048	99049
21582	32094	1	applied	\N	\N	\N	\N	99050	99050	99051
21582	32090	2	applied	\N	\N	\N	\N	99037	99037	99038
21582	32095	3	applied	\N	\N	\N	\N	99052	99052	12588
21582	32096	4	applied	\N	\N	\N	\N	99053	99053	99054
21582	32097	5	applied	\N	\N	\N	\N	99055	99055	99056
21582	32098	6	applied	\N	\N	\N	\N	99057	99057	99058
21582	32091	7	applied	\N	\N	\N	\N	99039	99039	99059
21582	32099	8	applied	\N	\N	\N	\N	99060	99060	99061
21582	32100	9	applied	\N	\N	\N	\N	99062	99062	99063
21582	32101	10	applied	\N	\N	\N	\N	99064	99064	99065
21584	32102	0	applied	\N	\N	\N	\N	99069	99069	99070
21584	32103	1	applied	\N	\N	\N	\N	99071	99071	99072
21584	32104	2	applied	\N	\N	\N	\N	99073	99073	99074
21591	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21591	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21591	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21591	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21591	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21591	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21591	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21591	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21591	31765	8	applied	\N	\N	\N	\N	98383	98383	98069
21546	32040	0	applied	\N	\N	\N	\N	98869	98869	98870
21546	32041	1	applied	\N	\N	\N	\N	98871	98871	98872
21546	32042	2	applied	\N	\N	\N	\N	98873	98873	98874
21548	32049	0	applied	\N	\N	\N	\N	98892	98892	98893
21548	32051	1	applied	\N	\N	\N	\N	98896	98896	98904
21549	32052	0	applied	\N	\N	\N	\N	98906	98906	98907
21549	32053	1	applied	\N	\N	\N	\N	98908	98908	98909
21553	32057	0	applied	\N	\N	\N	\N	98919	98919	98920
21553	32058	1	applied	\N	\N	\N	\N	98921	98921	98922
21554	31735	0	applied	\N	\N	\N	\N	97972	97972	97973
21554	31746	1	applied	\N	\N	\N	\N	98001	98001	98002
21554	31757	2	applied	\N	\N	\N	\N	98029	98029	98030
21554	31758	3	applied	\N	\N	\N	\N	98031	98031	98032
21554	31765	4	applied	\N	\N	\N	\N	98068	98068	98069
21554	31766	5	applied	\N	\N	\N	\N	98070	98070	98071
21554	31694	6	applied	\N	\N	\N	\N	97810	97810	97811
21554	31698	7	applied	\N	\N	\N	\N	97824	97824	97825
21554	31950	8	applied	\N	\N	\N	\N	98555	98555	47675
21554	31960	9	applied	\N	\N	\N	\N	98587	98587	47675
21554	31719	10	applied	\N	\N	1000000000	\N	97874	97874	97875
21554	31702	11	applied	\N	\N	\N	\N	97832	97832	97833
21554	31703	12	applied	\N	\N	\N	\N	97834	97834	97835
21554	31708	13	applied	\N	\N	\N	\N	97845	97845	97846
21554	31709	14	applied	\N	\N	\N	\N	97847	97847	97848
21554	31715	15	applied	\N	\N	\N	\N	97863	97863	97864
21554	31718	16	applied	\N	\N	\N	\N	97872	97872	97873
21554	31722	17	applied	\N	\N	\N	\N	97882	97882	97883
21554	31725	18	applied	\N	\N	\N	\N	97890	97890	97891
21554	31728	19	applied	\N	\N	\N	\N	97947	97947	97948
21554	31732	20	applied	\N	\N	\N	\N	97959	97959	97960
21554	31736	21	applied	\N	\N	\N	\N	97974	97974	97975
21554	31871	22	applied	\N	\N	\N	\N	98337	98337	98320
21554	31737	23	applied	\N	\N	\N	\N	97976	97976	97977
21554	31738	24	applied	\N	\N	\N	\N	97978	97978	97979
21554	31747	25	applied	\N	\N	\N	\N	98003	98003	98004
21554	31748	26	applied	\N	\N	\N	\N	98005	98005	98006
21554	31753	27	applied	\N	\N	\N	\N	98018	98018	98019
21554	31831	28	applied	\N	\N	\N	\N	98928	98928	98330
21554	31832	29	applied	\N	\N	\N	\N	98929	98929	98242
21554	31838	30	applied	\N	\N	\N	\N	98930	98930	98254
21554	31842	31	applied	\N	\N	\N	\N	98931	98931	98264
21554	31843	32	applied	\N	\N	\N	\N	98932	98932	98266
21554	31851	33	applied	\N	\N	\N	\N	98933	98933	98284
21554	31852	34	applied	\N	\N	\N	\N	98934	98934	98286
21554	31866	35	applied	\N	\N	\N	\N	98935	98935	98320
21554	31759	36	applied	\N	\N	\N	\N	98033	98033	98034
21554	31762	37	applied	\N	\N	\N	\N	98059	98059	98060
21554	31767	38	applied	\N	\N	\N	\N	98072	98072	98073
21554	31768	39	applied	\N	\N	\N	\N	98074	98074	98075
21554	31776	40	applied	\N	\N	\N	\N	98096	98096	98097
21554	31779	41	applied	\N	\N	\N	\N	98107	98107	98108
21554	31782	42	applied	\N	\N	\N	\N	98115	98115	98116
21554	31785	43	applied	\N	\N	\N	\N	98124	98124	98125
21554	31788	44	applied	\N	\N	\N	\N	98133	98133	98134
21554	31792	45	applied	\N	\N	\N	\N	98144	98144	98145
21554	31793	46	applied	\N	\N	\N	\N	98146	98146	98147
21554	31798	47	applied	\N	\N	\N	\N	98156	98156	98157
21554	31799	48	applied	\N	\N	\N	\N	98158	98158	98159
21554	31800	49	applied	\N	\N	\N	\N	98160	98160	98161
21554	31808	50	applied	\N	\N	\N	\N	98180	98180	98181
21554	31811	51	applied	\N	\N	\N	\N	98192	98192	98193
21554	31814	52	applied	\N	\N	\N	\N	98198	98198	98199
21554	31815	53	applied	\N	\N	\N	\N	98200	98200	98201
21554	31820	54	applied	\N	\N	\N	\N	98212	98212	98213
21554	31821	55	applied	\N	\N	\N	\N	98214	98214	98215
21554	31827	56	applied	\N	\N	\N	\N	98229	98229	98230
21554	31836	57	applied	\N	\N	\N	\N	98249	98249	98250
21554	31837	58	applied	\N	\N	\N	\N	98251	98251	98252
21554	31844	59	applied	\N	\N	\N	\N	98267	98267	98268
21554	31845	60	applied	\N	\N	\N	\N	98269	98269	98270
21554	31850	61	applied	\N	\N	\N	\N	98281	98281	98282
21554	31856	62	applied	\N	\N	\N	\N	98295	98295	98296
21554	31859	63	applied	\N	\N	\N	\N	98302	98302	98303
21554	31860	64	applied	\N	\N	\N	\N	98304	98304	98305
21554	31867	65	applied	\N	\N	\N	\N	98321	98321	98322
21554	31870	66	applied	\N	\N	\N	\N	98328	98328	98329
21554	31874	67	applied	\N	\N	\N	\N	98340	98340	98341
21554	31878	68	applied	\N	\N	\N	\N	98350	98350	98351
21554	31881	69	applied	\N	\N	\N	\N	98367	98367	98368
21554	31884	70	applied	\N	\N	\N	\N	98375	98375	98376
21554	31887	71	applied	\N	\N	\N	\N	98393	98393	98394
21554	31888	72	applied	\N	\N	\N	\N	98395	98395	98396
21554	31894	73	applied	\N	\N	\N	\N	98409	98409	98410
21554	31895	74	applied	\N	\N	\N	\N	98411	98411	98412
21554	31901	75	applied	\N	\N	\N	\N	98425	98425	98426
21554	31904	76	applied	\N	\N	\N	\N	98435	98435	98436
21554	31907	77	applied	\N	\N	\N	\N	98443	98443	98444
21554	31908	78	applied	\N	\N	\N	\N	98445	98445	98446
21554	31909	79	applied	\N	\N	\N	\N	98447	98447	98448
21554	31917	80	applied	\N	\N	\N	\N	98469	98469	98470
21554	31920	81	applied	\N	\N	\N	\N	98482	98482	98483
21554	31921	82	applied	\N	\N	\N	\N	98484	98484	98485
21554	31922	83	applied	\N	\N	\N	\N	98486	98486	98487
21554	31930	84	applied	\N	\N	\N	\N	98503	98503	98504
21554	31934	85	applied	\N	\N	\N	\N	98518	98518	98519
21554	31936	86	applied	\N	\N	\N	\N	98522	98522	98523
21554	31937	87	applied	\N	\N	\N	\N	98524	98524	98525
21554	31943	88	applied	\N	\N	\N	\N	98537	98537	98538
21554	31946	89	applied	\N	\N	\N	\N	98545	98545	98546
21554	31949	90	applied	\N	\N	\N	\N	98553	98553	98554
21554	31953	91	applied	\N	\N	\N	\N	98562	98562	98563
21554	31955	92	applied	\N	\N	\N	\N	98568	98568	98569
21554	31957	93	applied	\N	\N	\N	\N	98579	98579	98580
21554	31959	94	applied	\N	\N	\N	\N	98585	98585	98586
21554	31961	95	applied	\N	\N	\N	\N	98588	98588	98589
21554	31964	96	applied	\N	\N	\N	\N	98597	98597	98598
21554	31966	97	applied	\N	\N	\N	\N	98602	98602	98603
21554	31968	98	applied	\N	\N	\N	\N	98607	98607	98608
21554	31970	99	applied	\N	\N	\N	\N	98617	98617	98618
21554	31971	100	applied	\N	\N	\N	\N	98619	98619	98620
21554	31974	101	applied	\N	\N	\N	\N	98627	98627	98628
21554	31976	102	applied	\N	\N	\N	\N	98632	98632	98633
21554	31977	103	applied	\N	\N	\N	\N	98634	98634	98635
21554	31978	104	applied	\N	\N	\N	\N	98636	98636	98637
21554	31982	105	applied	\N	\N	\N	\N	98648	98648	98649
21554	31986	106	applied	\N	\N	\N	\N	98658	98658	98659
21554	31989	107	applied	\N	\N	\N	\N	98665	98665	98666
21554	31990	108	applied	\N	\N	\N	\N	98667	98667	98668
21554	31996	110	applied	\N	\N	\N	\N	98681	98681	98682
21554	31997	111	applied	\N	\N	\N	\N	98683	98683	98684
21554	32002	112	applied	\N	\N	\N	\N	98694	98694	98695
21554	32006	113	applied	\N	\N	\N	\N	98705	98705	98706
21554	32009	114	applied	\N	\N	\N	\N	98733	98733	98734
21554	32012	115	applied	\N	\N	\N	\N	98741	98741	98742
21554	32015	116	applied	\N	\N	\N	\N	98753	98753	98754
21554	32019	117	applied	\N	\N	\N	\N	98762	98762	98763
21554	32022	118	applied	\N	\N	\N	\N	98773	98773	98774
21554	32025	119	applied	\N	\N	\N	\N	98783	98783	98784
21554	32026	120	applied	\N	\N	\N	\N	98785	98785	98786
21554	32031	121	applied	\N	\N	\N	\N	98797	98797	98798
21554	32034	122	applied	\N	\N	\N	\N	98806	98806	98807
21554	32037	123	applied	\N	\N	\N	\N	98823	98823	98824
21554	32040	124	applied	\N	\N	\N	\N	98869	98869	98870
21554	32041	125	applied	\N	\N	\N	\N	98871	98871	98872
21555	32059	0	applied	\N	\N	\N	\N	98939	98939	98940
21555	32060	1	applied	\N	\N	\N	\N	98941	98941	98942
21555	32061	2	applied	\N	\N	\N	\N	98943	98943	98944
21560	32068	0	applied	\N	\N	\N	\N	98966	98966	98967
21560	32069	1	applied	\N	\N	\N	\N	98968	98968	98969
21560	32070	2	applied	\N	\N	\N	\N	98970	98970	98971
21562	32071	0	applied	\N	\N	\N	\N	98974	98974	98975
21562	32072	1	applied	\N	\N	\N	\N	98976	98976	98977
21562	32073	2	applied	\N	\N	\N	\N	98978	98978	98979
21565	32074	0	applied	\N	\N	\N	\N	98984	98984	98985
21565	32073	1	applied	\N	\N	\N	\N	98978	98978	98979
21565	32075	2	applied	\N	\N	\N	\N	98986	98986	98987
21565	32076	3	applied	\N	\N	\N	\N	98988	98988	98989
21573	32083	0	applied	\N	\N	\N	\N	99016	99016	99017
21573	32084	1	applied	\N	\N	\N	\N	99018	99018	99019
21573	32085	2	applied	\N	\N	\N	\N	99020	99020	99021
21576	32086	0	applied	\N	\N	\N	\N	99026	99026	99027
21576	32087	1	applied	\N	\N	\N	\N	99028	99028	99029
21576	32088	2	applied	\N	\N	\N	\N	99030	99030	99031
21585	32102	0	applied	\N	\N	\N	\N	99069	99069	99070
21585	32103	1	applied	\N	\N	\N	\N	99071	99071	99072
21585	32104	2	applied	\N	\N	\N	\N	99073	99073	99074
21587	32108	0	applied	\N	\N	\N	\N	99086	99086	99087
21587	32109	1	applied	\N	\N	\N	\N	99088	99088	99089
21587	32110	2	applied	\N	\N	\N	\N	99090	99090	99091
21589	32108	0	applied	\N	\N	\N	\N	99086	99086	99087
21589	32109	1	applied	\N	\N	\N	\N	99088	99088	99089
21589	32110	2	applied	\N	\N	\N	\N	99090	99090	99091
21594	32095	0	applied	\N	\N	\N	\N	99052	99052	12588
21594	32117	1	applied	\N	\N	\N	\N	99109	99109	47675
21596	32118	0	applied	\N	\N	\N	\N	99122	99122	99123
21596	32119	1	applied	\N	\N	\N	\N	99124	99124	99125
21596	32120	2	applied	\N	\N	\N	\N	99126	99126	99127
21596	32121	3	applied	\N	\N	\N	\N	99128	99128	99129
21596	32122	4	applied	\N	\N	\N	\N	99130	99130	99131
21596	32123	5	applied	\N	\N	\N	\N	99132	99132	99133
21598	32124	0	applied	\N	\N	\N	\N	99139	99139	99140
21598	32125	1	applied	\N	\N	\N	\N	99141	99141	99142
21598	32126	2	applied	\N	\N	\N	\N	99143	99143	99144
21600	32127	0	applied	\N	\N	\N	\N	99147	99147	99148
21600	32128	1	applied	\N	\N	\N	\N	99149	99149	99150
21600	32129	2	applied	\N	\N	\N	\N	99151	99151	99152
21607	32130	0	applied	\N	\N	\N	\N	99159	99159	99160
21607	32132	1	applied	\N	\N	\N	\N	99163	99163	99164
21607	32131	2	applied	\N	\N	\N	\N	99161	99161	99165
21611	32139	0	applied	\N	\N	\N	\N	99189	99189	99190
21611	32140	1	applied	\N	\N	\N	\N	99191	99191	99192
21611	32141	2	applied	\N	\N	\N	\N	99193	99193	99194
21614	32142	0	applied	\N	\N	\N	\N	99196	99196	99197
21614	32143	1	applied	\N	\N	\N	\N	99198	99198	99199
21614	32144	2	applied	\N	\N	\N	\N	99200	99200	99201
21616	32145	0	applied	\N	\N	\N	\N	99206	99206	99207
21616	32146	1	applied	\N	\N	\N	\N	99208	99208	99209
21616	32147	2	applied	\N	\N	\N	\N	99210	99210	99211
21623	32148	0	applied	\N	\N	\N	\N	99218	99218	99219
21623	32149	1	applied	\N	\N	\N	\N	99220	99220	99221
21623	32150	2	applied	\N	\N	\N	\N	99222	99222	99223
21623	32151	3	applied	\N	\N	\N	\N	99224	99224	99225
21629	32157	0	applied	\N	\N	\N	\N	99299	99299	99300
21629	32158	1	applied	\N	\N	\N	\N	99301	99301	99302
21629	32156	2	applied	\N	\N	\N	\N	99294	99294	99296
21629	32159	3	applied	\N	\N	\N	\N	99303	99303	99304
21629	32160	4	applied	\N	\N	1000000000	\N	99305	99305	99306
21629	32161	5	applied	\N	\N	\N	\N	99307	99307	99308
21629	32162	6	applied	\N	\N	\N	\N	99309	99309	99310
21629	32163	7	applied	\N	\N	\N	\N	99311	99311	99312
21632	32167	0	applied	\N	\N	\N	\N	99322	99322	99323
21632	32168	1	applied	\N	\N	\N	\N	99324	99324	99325
21632	32169	2	applied	\N	\N	\N	\N	99326	99326	99327
21636	32171	0	applied	\N	\N	\N	\N	99338	99338	99339
21636	32172	1	applied	\N	\N	\N	\N	99340	99340	99341
21636	32173	2	applied	\N	\N	\N	\N	99342	99342	99343
21636	32174	3	applied	\N	\N	\N	\N	99344	99344	99345
21636	32176	4	applied	\N	\N	\N	\N	99350	99350	99351
21636	32175	5	applied	\N	\N	\N	\N	99346	99346	99352
21638	32177	0	applied	\N	\N	\N	\N	99355	99355	99356
21638	32176	1	applied	\N	\N	\N	\N	99350	99350	99351
21638	32178	2	applied	\N	\N	\N	\N	99357	99357	99358
21638	32175	3	applied	\N	\N	\N	\N	99346	99346	99359
21640	32180	0	applied	\N	\N	\N	\N	99364	99364	99365
21640	32179	1	applied	\N	\N	\N	\N	99361	99361	99362
21640	32181	2	applied	\N	\N	\N	\N	99366	99366	99367
21640	32182	3	applied	\N	\N	\N	\N	99368	99368	99369
21642	32183	0	applied	\N	\N	\N	\N	99371	99371	99372
21642	32184	1	applied	\N	\N	\N	\N	99373	99373	99374
21642	32185	2	applied	\N	\N	\N	\N	99375	99375	99376
21653	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21653	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21653	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21653	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21653	31735	4	applied	\N	\N	\N	\N	99438	99438	97973
21653	31746	5	applied	\N	\N	\N	\N	99439	99439	98002
21653	31757	6	applied	\N	\N	\N	\N	99440	99440	98030
21653	31758	7	applied	\N	\N	\N	\N	99441	99441	98032
21653	31765	8	applied	\N	\N	\N	\N	99442	99442	98069
21653	31766	9	applied	\N	\N	\N	\N	99443	99443	98071
21653	31464	10	applied	\N	\N	\N	\N	97188	97188	97189
21653	31950	11	applied	\N	\N	\N	\N	98555	98555	47675
21653	31433	12	applied	\N	\N	\N	\N	97107	97107	97108
21653	31960	13	applied	\N	\N	\N	\N	98587	98587	47675
21653	32167	14	applied	\N	\N	\N	\N	99444	99444	99323
21653	31719	15	applied	\N	\N	1000000000	\N	97874	97874	97875
21653	31435	16	applied	\N	\N	\N	\N	97112	97112	97113
21653	32196	17	applied	\N	\N	\N	\N	99407	99407	99445
21653	32197	18	applied	\N	\N	\N	\N	99409	99409	99446
21591	31766	9	applied	\N	\N	\N	\N	98384	98384	98071
21591	31950	10	applied	\N	\N	\N	\N	98555	98555	47675
21591	31960	11	applied	\N	\N	\N	\N	98587	98587	47675
21591	31719	12	applied	\N	\N	1000000000	\N	97874	97874	97875
21591	31871	13	applied	\N	\N	\N	\N	98337	98337	98320
21591	31831	14	applied	\N	\N	\N	\N	98357	98357	98330
21591	31832	15	applied	\N	\N	\N	\N	98358	98358	98242
21591	31838	16	applied	\N	\N	\N	\N	98359	98359	98254
21591	31842	17	applied	\N	\N	\N	\N	98360	98360	98264
21591	31843	18	applied	\N	\N	\N	\N	98361	98361	98266
21591	31851	19	applied	\N	\N	\N	\N	98362	98362	98284
21591	31852	20	applied	\N	\N	\N	\N	98363	98363	98286
21591	31866	21	applied	\N	\N	\N	\N	98364	98364	98320
21591	31351	22	applied	\N	\N	\N	\N	96862	96862	96863
21591	31353	23	applied	\N	\N	\N	\N	96870	96870	96871
21591	31355	24	applied	\N	\N	\N	\N	96875	96875	96876
21591	31357	25	applied	\N	\N	\N	\N	96882	96882	96883
21591	31359	26	applied	\N	\N	\N	\N	96888	96888	96889
21591	31361	27	applied	\N	\N	\N	\N	96897	96897	96898
21591	31363	28	applied	\N	\N	\N	\N	96903	96903	96904
21591	31365	29	applied	\N	\N	\N	\N	96908	96908	96909
21591	31366	30	applied	\N	\N	\N	\N	96910	96910	96911
21591	31369	31	applied	\N	\N	\N	\N	96919	96919	96920
21591	31370	32	applied	\N	\N	\N	\N	96921	96921	96922
21591	31371	33	applied	\N	\N	\N	\N	96923	96923	96924
21591	31375	34	applied	\N	\N	\N	\N	96933	96933	96934
21591	31377	35	applied	\N	\N	\N	\N	96937	96937	96938
21591	31379	36	applied	\N	\N	\N	\N	96943	96943	96944
21591	31381	37	applied	\N	\N	\N	\N	96949	96949	96950
21591	31382	38	applied	\N	\N	\N	\N	96951	96951	96952
21591	31385	39	applied	\N	\N	\N	\N	96959	96959	96960
21591	31386	40	applied	\N	\N	\N	\N	96961	96961	96962
21591	31389	41	applied	\N	\N	\N	\N	96972	96972	96973
21591	31390	42	applied	\N	\N	\N	\N	96976	96976	96977
21591	31391	43	applied	\N	\N	\N	\N	96978	96978	96979
21591	31394	44	applied	\N	\N	\N	\N	96986	96986	96987
21591	31396	45	applied	\N	\N	\N	\N	96994	96994	96995
21591	31398	46	applied	\N	\N	\N	\N	97002	97002	97003
21591	31408	47	applied	\N	\N	\N	\N	97026	97026	97027
21591	31410	48	applied	\N	\N	\N	\N	97037	97037	97038
21591	31412	49	applied	\N	\N	\N	\N	97050	97050	97051
21591	31414	50	applied	\N	\N	\N	\N	97055	97055	97056
21591	31418	51	applied	\N	\N	\N	\N	97063	97063	97064
21591	31426	52	applied	\N	\N	\N	\N	97080	97080	97081
21591	31427	53	applied	\N	\N	\N	\N	97082	97082	97083
21591	31430	54	applied	\N	\N	\N	\N	97096	97096	97097
21591	31431	55	applied	\N	\N	\N	\N	97101	97101	97102
21591	31433	56	applied	\N	\N	\N	\N	97107	97107	97108
21591	31435	57	applied	\N	\N	\N	\N	97112	97112	97113
21591	31437	58	applied	\N	\N	\N	\N	97117	97117	97118
21591	31439	59	applied	\N	\N	\N	\N	97123	97123	97124
21591	31441	60	applied	\N	\N	\N	\N	97129	97129	97130
21591	31442	61	applied	\N	\N	\N	\N	97131	97131	97132
21591	31443	62	applied	\N	\N	\N	\N	97133	97133	97134
21591	31444	63	applied	\N	\N	\N	\N	97135	97135	97136
21591	31449	64	applied	\N	\N	\N	\N	97147	97147	97148
21591	31450	65	applied	\N	\N	\N	\N	97149	97149	97150
21591	31453	66	applied	\N	\N	\N	\N	97162	97162	97163
21591	31455	67	applied	\N	\N	\N	\N	97168	97168	97169
21591	31456	68	applied	\N	\N	\N	\N	97170	97170	97171
21591	31457	69	applied	\N	\N	\N	\N	97172	97172	97173
21591	31465	70	applied	\N	\N	\N	\N	97190	97190	97191
21591	31474	71	applied	\N	\N	\N	\N	97211	97211	97212
21591	31475	72	applied	\N	\N	\N	\N	97213	97213	97214
21591	31476	73	applied	\N	\N	\N	\N	97215	97215	97216
21591	31493	74	applied	\N	\N	\N	\N	97252	97252	97253
21591	31497	75	applied	\N	\N	\N	\N	97280	97280	97281
21591	31498	76	applied	\N	\N	\N	\N	97282	97282	97283
21591	31503	77	applied	\N	\N	\N	\N	97298	97298	97299
21591	31506	78	applied	\N	\N	\N	\N	97306	97306	97307
21591	31510	79	applied	\N	\N	\N	\N	97316	97316	97317
21591	31513	80	applied	\N	\N	\N	\N	97324	97324	97325
21591	31516	81	applied	\N	\N	\N	\N	97331	97331	97332
21591	31520	82	applied	\N	\N	\N	\N	97342	97342	97343
21591	31521	83	applied	\N	\N	\N	\N	97344	97344	97345
21591	31526	84	applied	\N	\N	\N	\N	97357	97357	97358
21591	31530	85	applied	\N	\N	\N	\N	97368	97368	97369
21591	31531	86	applied	\N	\N	\N	\N	97370	97370	97371
21591	31536	87	applied	\N	\N	\N	\N	97385	97385	97386
21591	31539	88	applied	\N	\N	\N	\N	97394	97394	97395
21591	31543	89	applied	\N	\N	\N	\N	97409	97409	97410
21591	31546	90	applied	\N	\N	\N	\N	97421	97421	97422
21591	31551	91	applied	\N	\N	\N	\N	97442	97442	97443
21591	31552	92	applied	\N	\N	\N	\N	97444	97444	97445
21591	31555	93	applied	\N	\N	\N	\N	97454	97454	97455
21591	31558	94	applied	\N	\N	\N	\N	97462	97462	97463
21591	31559	95	applied	\N	\N	\N	\N	97464	97464	97465
21591	31560	96	applied	\N	\N	\N	\N	97466	97466	97467
21591	31561	97	applied	\N	\N	\N	\N	97468	97468	97469
21591	31575	98	applied	\N	\N	\N	\N	97498	97498	97499
21591	31576	99	applied	\N	\N	\N	\N	97500	97500	97501
21591	31579	100	applied	\N	\N	\N	\N	97507	97507	97508
21591	31582	101	applied	\N	\N	\N	\N	97517	97517	97518
21591	31586	102	applied	\N	\N	\N	\N	97526	97526	97527
21591	31589	103	applied	\N	\N	\N	\N	97535	97535	97536
21591	31593	104	applied	\N	\N	\N	\N	97550	97550	97551
21591	31599	105	applied	\N	\N	\N	\N	97569	97569	97570
21591	31604	107	applied	\N	\N	\N	\N	97583	97583	97584
21591	31607	108	applied	\N	\N	\N	\N	97591	97591	97592
21591	31610	109	applied	\N	\N	\N	\N	97600	97600	97601
21591	31611	110	applied	\N	\N	\N	\N	97602	97602	97603
21591	31617	111	applied	\N	\N	\N	\N	97619	97619	97620
21591	31618	112	applied	\N	\N	\N	\N	97621	97621	97622
21591	31619	113	applied	\N	\N	\N	\N	97623	97623	97624
21591	31628	114	applied	\N	\N	\N	\N	97642	97642	97643
21591	31632	115	applied	\N	\N	\N	\N	97654	97654	97655
21591	31633	116	applied	\N	\N	\N	\N	97656	97656	97657
21591	31638	117	applied	\N	\N	\N	\N	97667	97667	97668
21591	31642	118	applied	\N	\N	\N	\N	97677	97677	97678
21591	31646	119	applied	\N	\N	\N	\N	97687	97687	97688
21591	31649	120	applied	\N	\N	\N	\N	97695	97695	97696
21591	31650	121	applied	\N	\N	\N	\N	97697	97697	97698
21591	31651	122	applied	\N	\N	\N	\N	97699	97699	97700
21591	31659	123	applied	\N	\N	\N	\N	97719	97719	97720
21591	31660	124	applied	\N	\N	\N	\N	97721	97721	97722
21591	31661	125	applied	\N	\N	\N	\N	97723	97723	97724
21593	32118	0	applied	\N	\N	\N	\N	99122	99122	99123
21593	32119	1	applied	\N	\N	\N	\N	99124	99124	99125
21593	32120	2	applied	\N	\N	\N	\N	99126	99126	99127
21593	32121	3	applied	\N	\N	\N	\N	99128	99128	99129
21593	32122	4	applied	\N	\N	\N	\N	99130	99130	99131
21593	32123	5	applied	\N	\N	\N	\N	99132	99132	99133
21605	32130	0	applied	\N	\N	\N	\N	99159	99159	99160
21605	32132	1	applied	\N	\N	\N	\N	99163	99163	99164
21605	32131	2	applied	\N	\N	\N	\N	99161	99161	99165
21608	32133	0	applied	\N	\N	\N	\N	99172	99172	99173
21613	32142	0	applied	\N	\N	\N	\N	99196	99196	99197
21613	32143	1	applied	\N	\N	\N	\N	99198	99198	99199
21613	32144	2	applied	\N	\N	\N	\N	99200	99200	99201
21615	32145	0	applied	\N	\N	\N	\N	99206	99206	99207
21615	32146	1	applied	\N	\N	\N	\N	99208	99208	99209
21615	32147	2	applied	\N	\N	\N	\N	99210	99210	99211
21622	32148	0	applied	\N	\N	\N	\N	99218	99218	99219
21622	32149	1	applied	\N	\N	\N	\N	99220	99220	99221
21622	32150	2	applied	\N	\N	\N	\N	99222	99222	99223
21622	32151	3	applied	\N	\N	\N	\N	99224	99224	99225
21622	32152	4	applied	\N	\N	\N	\N	99228	99228	99229
21622	32153	5	applied	\N	\N	\N	\N	99230	99230	99231
21625	32148	0	applied	\N	\N	\N	\N	99218	99218	99219
21625	32149	1	applied	\N	\N	\N	\N	99220	99220	99221
21625	32150	2	applied	\N	\N	\N	\N	99222	99222	99223
21625	32151	3	applied	\N	\N	\N	\N	99224	99224	99225
21625	32152	4	applied	\N	\N	\N	\N	99228	99228	99229
21625	32153	5	applied	\N	\N	\N	\N	99230	99230	99231
21628	32154	0	applied	\N	\N	\N	\N	99289	99289	99290
21628	32156	1	applied	\N	\N	\N	\N	99294	99294	99295
21628	32155	2	applied	\N	\N	\N	\N	99291	99291	99296
21631	32167	0	applied	\N	\N	\N	\N	99322	99322	99323
21631	32168	1	applied	\N	\N	\N	\N	99324	99324	99325
21631	32169	2	applied	\N	\N	\N	\N	99326	99326	99327
21635	32171	0	applied	\N	\N	\N	\N	99338	99338	99339
21635	32172	1	applied	\N	\N	\N	\N	99340	99340	99341
21635	32173	2	applied	\N	\N	\N	\N	99342	99342	99343
21635	32174	3	applied	\N	\N	\N	\N	99344	99344	99345
21635	32175	4	applied	\N	\N	\N	\N	99346	99346	99347
21637	32171	0	applied	\N	\N	\N	\N	99338	99338	99339
21637	32172	1	applied	\N	\N	\N	\N	99340	99340	99341
21637	32173	2	applied	\N	\N	\N	\N	99342	99342	99343
21637	32174	3	applied	\N	\N	\N	\N	99344	99344	99345
21643	32186	0	applied	\N	\N	\N	\N	99381	99381	99382
21643	32187	1	applied	\N	\N	\N	\N	99383	99383	99384
21643	32188	2	applied	\N	\N	\N	\N	99385	99385	99386
21645	32191	0	applied	\N	\N	\N	\N	99394	99394	99395
21645	32189	1	applied	\N	\N	\N	\N	99387	99387	99396
21645	32192	2	applied	\N	\N	\N	\N	99397	99397	99398
21645	32190	3	applied	\N	\N	\N	\N	99390	99390	99399
21645	32193	4	applied	\N	\N	\N	\N	99400	99400	99401
21648	32202	0	applied	\N	\N	\N	\N	99422	99422	99423
21648	32203	1	applied	\N	\N	\N	\N	99424	99424	99425
21648	32204	2	applied	\N	\N	\N	\N	99426	99426	99427
21657	32217	0	applied	\N	\N	\N	\N	99480	99480	99481
21657	32218	1	applied	\N	\N	\N	\N	99482	99482	47675
21657	32219	2	applied	\N	\N	\N	\N	99483	99483	99484
21657	32220	3	applied	\N	\N	\N	\N	99485	99485	99486
21660	32228	0	applied	\N	\N	\N	\N	99505	99505	99506
21660	32229	1	applied	\N	\N	\N	\N	99507	99507	99508
21662	32228	0	applied	\N	\N	\N	\N	99505	99505	99506
21662	32230	1	applied	\N	\N	\N	\N	99511	99511	99512
21662	32229	2	applied	\N	\N	\N	\N	99507	99507	99513
21665	32235	0	applied	\N	\N	\N	\N	99525	99525	99526
21665	32236	1	applied	\N	\N	\N	\N	99529	99529	99530
21665	32237	2	applied	\N	\N	\N	\N	99531	99531	99532
21669	32238	0	applied	\N	\N	\N	\N	99538	99538	47675
21669	32239	1	applied	\N	\N	\N	\N	99539	99539	99540
21669	32236	2	applied	\N	\N	\N	\N	99529	99529	99530
21669	32241	3	applied	\N	\N	\N	\N	99546	99546	99547
21669	32237	4	applied	\N	\N	\N	\N	99531	99531	99548
21669	32240	5	applied	\N	\N	\N	\N	99542	99542	99549
21671	32242	0	applied	\N	\N	\N	\N	99553	99553	99554
21671	32243	1	applied	\N	\N	\N	\N	99555	99555	99556
21671	32244	2	applied	\N	\N	\N	\N	99557	99557	99558
21671	32245	3	applied	\N	\N	\N	\N	99559	99559	99560
21671	32246	4	applied	\N	\N	\N	\N	99561	99561	99562
21671	32247	5	applied	\N	\N	\N	\N	99563	99563	99564
21678	32258	0	applied	\N	\N	\N	\N	99594	99594	99595
21678	32259	1	applied	\N	\N	\N	\N	99596	99596	99597
21678	32260	2	applied	\N	\N	\N	\N	99598	99598	99599
21682	32264	0	applied	\N	\N	\N	\N	99650	99650	99690
21682	32265	1	applied	\N	\N	\N	\N	99691	99691	99692
21682	32266	2	applied	\N	\N	\N	\N	99693	99693	99694
21683	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21683	32268	1	applied	\N	\N	\N	\N	99699	99699	99700
21683	32269	2	applied	\N	\N	\N	\N	99701	99701	99702
21683	32270	3	applied	\N	\N	\N	\N	99703	99703	99704
21686	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21694	32290	0	applied	\N	\N	\N	\N	99762	99762	99763
21694	32291	1	applied	\N	\N	\N	\N	99764	99764	99765
21694	32292	2	applied	\N	\N	\N	\N	99766	99766	99767
21694	32293	3	applied	\N	\N	\N	\N	99768	99768	99769
21694	32294	4	applied	\N	\N	\N	\N	99770	99770	99771
21694	32295	5	applied	\N	\N	\N	\N	99772	99772	99773
21704	32317	0	applied	\N	\N	\N	\N	99831	99831	99832
21704	32318	1	applied	\N	\N	\N	\N	99833	99833	99834
21707	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21707	32321	1	applied	\N	\N	\N	\N	99843	99843	99844
21707	32322	2	applied	\N	\N	\N	\N	99845	99845	99846
21707	32323	3	applied	\N	\N	\N	\N	99847	99847	99848
21707	32319	4	applied	\N	\N	\N	\N	99837	99837	99853
21707	32325	5	applied	\N	\N	\N	\N	99854	99854	99855
21707	32326	6	applied	\N	\N	\N	\N	99856	99856	99857
21707	32324	7	applied	\N	\N	\N	\N	99849	99849	99858
21710	32330	0	applied	\N	\N	\N	\N	99867	99867	99868
21710	32331	1	applied	\N	\N	\N	\N	99869	99869	99870
21710	32332	2	applied	\N	\N	\N	\N	99871	99871	99872
21710	32333	3	applied	\N	\N	\N	\N	99873	99873	99874
21710	32334	4	applied	\N	\N	\N	\N	99875	99875	99876
21714	32338	0	applied	\N	\N	\N	\N	99892	99892	99893
21714	32339	1	applied	\N	\N	\N	\N	99894	99894	99895
21714	32340	2	applied	\N	\N	\N	\N	99896	99896	99897
21714	32341	3	applied	\N	\N	\N	\N	99898	99898	99899
21714	32342	4	applied	\N	\N	\N	\N	99900	99900	99901
21714	32343	5	applied	\N	\N	\N	\N	99902	99902	99903
21717	32344	0	applied	\N	\N	\N	\N	99907	99907	99908
21717	32345	1	applied	\N	\N	\N	\N	99909	99909	99910
21717	32346	2	applied	\N	\N	\N	\N	99911	99911	99912
21717	32347	3	applied	\N	\N	\N	\N	99913	99913	99914
21717	32348	4	applied	\N	\N	\N	\N	99915	99915	99916
21717	32349	5	applied	\N	\N	\N	\N	99917	99917	99918
21717	32350	6	applied	\N	\N	\N	\N	99919	99919	99920
21717	32351	7	applied	\N	\N	\N	\N	99921	99921	99922
21617	32146	1	applied	\N	\N	\N	\N	99208	99208	99209
21617	32147	2	applied	\N	\N	\N	\N	99210	99210	99211
21621	32148	0	applied	\N	\N	\N	\N	99218	99218	99219
21621	32149	1	applied	\N	\N	\N	\N	99220	99220	99221
21621	32150	2	applied	\N	\N	\N	\N	99222	99222	99223
21621	32151	3	applied	\N	\N	\N	\N	99224	99224	99225
21630	32164	0	applied	\N	\N	\N	\N	99314	99314	99315
21630	32165	1	applied	\N	\N	\N	\N	99316	99316	99317
21630	32166	2	applied	\N	\N	\N	\N	99318	99318	99319
21633	32167	0	applied	\N	\N	\N	\N	99322	99322	99323
21633	32168	1	applied	\N	\N	\N	\N	99324	99324	99325
21633	32170	2	applied	\N	\N	\N	\N	99332	99332	99333
21633	32169	3	applied	\N	\N	\N	\N	99326	99326	99334
21647	32194	0	applied	\N	\N	\N	\N	99403	99403	99404
21647	32195	1	applied	\N	\N	\N	\N	99405	99405	99406
21647	32196	2	applied	\N	\N	\N	\N	99407	99407	99408
21647	32197	3	applied	\N	\N	\N	\N	99409	99409	99410
21647	32198	5	applied	\N	\N	\N	\N	99412	99412	99413
21647	32199	6	applied	\N	\N	\N	\N	99414	99414	99415
21647	32200	7	applied	\N	\N	\N	\N	99416	99416	99417
21647	32201	8	applied	\N	\N	\N	\N	99418	99418	99419
21650	32202	0	applied	\N	\N	\N	\N	99422	99422	99423
21650	32203	1	applied	\N	\N	\N	\N	99424	99424	99425
21650	32204	2	applied	\N	\N	\N	\N	99426	99426	99427
21652	32202	0	applied	\N	\N	\N	\N	99422	99422	99423
21652	32203	1	applied	\N	\N	\N	\N	99424	99424	99425
21652	32204	2	applied	\N	\N	\N	\N	99426	99426	99427
21654	32205	0	applied	\N	\N	\N	\N	99453	99453	99454
21654	32206	1	applied	\N	\N	\N	\N	99455	99455	99456
21654	32207	2	applied	\N	\N	\N	\N	99457	99457	99458
21654	32208	3	applied	\N	\N	\N	\N	99459	99459	99460
21654	32209	4	applied	\N	\N	\N	\N	99461	99461	99462
21654	32210	5	applied	\N	\N	\N	\N	99463	99463	99464
21654	32211	6	applied	\N	\N	\N	\N	99465	99465	99466
21654	32212	7	applied	\N	\N	\N	\N	99467	99467	99468
21654	32213	8	applied	\N	\N	\N	\N	99469	99469	99470
21659	32225	0	applied	\N	\N	\N	\N	99497	99497	99498
21659	32226	1	applied	\N	\N	\N	\N	99499	99499	99500
21659	32227	2	applied	\N	\N	\N	\N	99501	99501	99502
21664	32235	0	applied	\N	\N	\N	\N	99525	99525	99526
21666	31592	0	applied	\N	\N	\N	\N	97548	97548	97549
21666	31602	1	applied	\N	\N	\N	\N	97579	97579	97580
21666	31603	2	applied	\N	\N	\N	\N	97581	97581	97582
21666	31616	3	applied	\N	\N	\N	\N	97617	97617	97618
21666	31735	4	applied	\N	\N	\N	\N	98048	98048	97973
21666	31746	5	applied	\N	\N	\N	\N	98049	98049	98002
21666	31757	6	applied	\N	\N	\N	\N	98050	98050	98030
21666	31758	7	applied	\N	\N	\N	\N	98051	98051	98032
21666	31765	8	applied	\N	\N	\N	\N	98383	98383	98069
21666	31766	9	applied	\N	\N	\N	\N	98384	98384	98071
21666	31416	10	applied	\N	\N	\N	\N	97059	97059	97060
21666	31464	11	applied	\N	\N	\N	\N	97261	97261	97189
21666	31277	12	applied	\N	\N	\N	\N	96645	96645	96646
21666	31400	13	applied	\N	\N	\N	\N	97008	97008	97009
21666	31950	14	applied	\N	\N	\N	\N	98555	98555	47675
21666	31422	15	applied	\N	\N	\N	\N	97262	97262	97073
21666	31960	16	applied	\N	\N	\N	\N	98587	98587	47675
21666	31417	17	applied	\N	\N	\N	\N	97061	97061	97062
21666	31401	18	applied	\N	\N	\N	\N	97010	97010	97011
21666	32167	19	applied	\N	\N	\N	\N	99444	99444	99323
21666	31719	20	applied	\N	\N	1000000000	\N	97874	97874	97875
21666	31279	21	applied	\N	\N	\N	\N	96651	96651	96652
21666	32221	22	applied	\N	\N	\N	\N	99488	99488	47675
21666	31423	23	applied	\N	\N	\N	\N	97263	97263	97075
21666	31424	24	applied	\N	\N	\N	\N	97264	97264	97077
21666	31425	25	applied	\N	\N	\N	\N	97265	97265	97079
21666	31402	26	applied	\N	\N	\N	\N	97012	97012	97013
21666	32218	27	applied	\N	\N	\N	\N	99482	99482	47675
21666	32196	28	applied	\N	\N	\N	\N	99407	99407	99445
21666	32232	29	applied	\N	\N	1000000000	\N	99534	99534	99518
21666	32197	30	applied	\N	\N	\N	\N	99409	99409	99446
21666	31419	31	applied	\N	\N	\N	\N	97065	97065	97066
21666	31420	32	applied	\N	\N	\N	\N	97067	97067	97068
21666	31280	33	applied	\N	\N	\N	\N	96653	96653	96654
21666	31281	34	applied	\N	\N	\N	\N	96655	96655	96656
21666	31285	35	applied	\N	\N	\N	\N	96665	96665	96666
21666	31287	36	applied	\N	\N	\N	\N	96673	96673	96674
21666	31871	37	applied	\N	\N	\N	\N	98337	98337	98320
21666	31289	38	applied	\N	\N	\N	\N	96679	96679	96680
21666	31291	39	applied	\N	\N	\N	\N	96687	96687	96688
21666	32172	40	applied	\N	\N	\N	\N	99447	99447	99341
21666	32173	41	applied	\N	\N	\N	\N	99448	99448	99343
21666	32174	42	applied	\N	\N	\N	\N	99449	99449	99345
21666	31293	43	applied	\N	\N	\N	\N	96692	96692	96693
21666	31295	44	applied	\N	\N	\N	\N	96702	96702	96703
21666	31297	45	applied	\N	\N	\N	\N	96713	96713	96714
21666	31298	46	applied	\N	\N	\N	\N	96715	96715	96716
21666	31299	47	applied	\N	\N	\N	\N	96717	96717	96718
21666	31302	48	applied	\N	\N	\N	\N	96726	96726	96727
21666	31304	49	applied	\N	\N	\N	\N	96732	96732	96733
21666	31305	50	applied	\N	\N	\N	\N	96734	96734	96735
21666	31308	51	applied	\N	\N	\N	\N	96741	96741	96742
21666	31310	52	applied	\N	\N	\N	\N	96747	96747	96748
21666	31311	53	applied	\N	\N	\N	\N	96749	96749	96750
21666	31312	54	applied	\N	\N	\N	\N	96751	96751	96752
21666	31316	55	applied	\N	\N	\N	\N	96762	96762	96763
21666	31318	56	applied	\N	\N	\N	\N	96769	96769	96770
21666	31319	57	applied	\N	\N	\N	\N	96776	96776	96777
21666	31320	58	applied	\N	\N	\N	\N	96778	96778	96779
21666	31321	59	applied	\N	\N	\N	\N	96780	96780	96781
21666	31326	60	applied	\N	\N	\N	\N	96794	96794	96795
21666	31329	61	applied	\N	\N	\N	\N	96802	96802	96803
21666	31331	62	applied	\N	\N	\N	\N	96807	96807	96808
21666	31831	63	applied	\N	\N	\N	\N	98357	98357	98330
21666	31832	64	applied	\N	\N	\N	\N	98358	98358	98242
21666	31838	65	applied	\N	\N	\N	\N	98359	98359	98254
21666	31842	66	applied	\N	\N	\N	\N	98360	98360	98264
21666	31843	67	applied	\N	\N	\N	\N	98361	98361	98266
21666	31851	68	applied	\N	\N	\N	\N	98362	98362	98284
21666	31852	69	applied	\N	\N	\N	\N	98363	98363	98286
21666	31866	70	applied	\N	\N	\N	\N	98364	98364	98320
21666	31333	71	applied	\N	\N	\N	\N	96820	96820	96821
21666	31335	72	applied	\N	\N	\N	\N	96824	96824	96825
21666	31336	73	applied	\N	\N	\N	\N	96826	96826	96827
21666	31337	74	applied	\N	\N	\N	\N	96828	96828	96829
21666	31345	75	applied	\N	\N	\N	\N	96846	96846	96847
21666	31346	76	applied	\N	\N	\N	\N	96848	96848	96849
21666	31347	77	applied	\N	\N	\N	\N	96850	96850	96851
21666	31403	78	applied	\N	\N	\N	\N	97014	97014	97015
21618	31766	5	applied	\N	\N	\N	\N	98070	98070	98071
21618	31950	6	applied	\N	\N	\N	\N	98555	98555	47675
21618	31960	7	applied	\N	\N	\N	\N	98587	98587	47675
21618	31719	8	applied	\N	\N	1000000000	\N	97874	97874	97875
21618	31632	9	applied	\N	\N	\N	\N	97654	97654	97655
21618	31871	10	applied	\N	\N	\N	\N	98337	98337	98320
21618	31633	11	applied	\N	\N	\N	\N	97656	97656	97657
21618	31638	12	applied	\N	\N	\N	\N	97667	97667	97668
21618	31642	13	applied	\N	\N	\N	\N	97677	97677	97678
21618	31646	14	applied	\N	\N	\N	\N	97687	97687	97688
21618	31649	15	applied	\N	\N	\N	\N	97695	97695	97696
21618	31650	16	applied	\N	\N	\N	\N	97697	97697	97698
21618	31651	17	applied	\N	\N	\N	\N	97699	97699	97700
21618	31659	18	applied	\N	\N	\N	\N	97719	97719	97720
21618	31660	19	applied	\N	\N	\N	\N	97721	97721	97722
21618	31661	20	applied	\N	\N	\N	\N	97723	97723	97724
21618	31662	21	applied	\N	\N	\N	\N	97725	97725	97726
21618	31663	22	applied	\N	\N	\N	\N	97727	97727	97728
21618	31664	23	applied	\N	\N	\N	\N	97729	97729	97730
21618	31678	24	applied	\N	\N	\N	\N	97760	97760	97761
21618	31679	25	applied	\N	\N	\N	\N	97762	97762	97763
21618	31684	26	applied	\N	\N	\N	\N	97787	97787	97788
21618	31688	27	applied	\N	\N	\N	\N	97796	97796	97797
21618	31689	28	applied	\N	\N	\N	\N	97798	97798	97799
21618	31694	29	applied	\N	\N	\N	\N	97810	97810	97811
21618	31698	30	applied	\N	\N	\N	\N	97824	97824	97825
21618	31702	31	applied	\N	\N	\N	\N	97832	97832	97833
21618	31703	32	applied	\N	\N	\N	\N	97834	97834	97835
21618	31708	33	applied	\N	\N	\N	\N	97845	97845	97846
21618	31709	34	applied	\N	\N	\N	\N	97847	97847	97848
21618	31715	35	applied	\N	\N	\N	\N	97863	97863	97864
21618	31718	36	applied	\N	\N	\N	\N	97872	97872	97873
21618	31722	37	applied	\N	\N	\N	\N	97882	97882	97883
21618	31725	38	applied	\N	\N	\N	\N	97890	97890	97891
21618	31728	39	applied	\N	\N	\N	\N	97947	97947	97948
21618	31732	40	applied	\N	\N	\N	\N	97959	97959	97960
21618	31736	41	applied	\N	\N	\N	\N	97974	97974	97975
21618	31737	42	applied	\N	\N	\N	\N	97976	97976	97977
21618	31738	43	applied	\N	\N	\N	\N	97978	97978	97979
21618	31747	44	applied	\N	\N	\N	\N	98003	98003	98004
21618	31748	45	applied	\N	\N	\N	\N	98005	98005	98006
21618	31753	46	applied	\N	\N	\N	\N	98018	98018	98019
21618	31831	47	applied	\N	\N	\N	\N	98928	98928	98330
21618	31832	48	applied	\N	\N	\N	\N	98929	98929	98242
21618	31838	49	applied	\N	\N	\N	\N	98930	98930	98254
21618	31842	50	applied	\N	\N	\N	\N	98931	98931	98264
21618	31843	51	applied	\N	\N	\N	\N	98932	98932	98266
21618	31851	52	applied	\N	\N	\N	\N	98933	98933	98284
21618	31852	53	applied	\N	\N	\N	\N	98934	98934	98286
21618	31866	54	applied	\N	\N	\N	\N	98935	98935	98320
21618	31759	55	applied	\N	\N	\N	\N	98033	98033	98034
21618	31762	56	applied	\N	\N	\N	\N	98059	98059	98060
21618	31767	57	applied	\N	\N	\N	\N	98072	98072	98073
21618	31768	58	applied	\N	\N	\N	\N	98074	98074	98075
21618	31776	59	applied	\N	\N	\N	\N	98096	98096	98097
21618	31779	60	applied	\N	\N	\N	\N	98107	98107	98108
21618	31782	61	applied	\N	\N	\N	\N	98115	98115	98116
21618	31785	63	applied	\N	\N	\N	\N	98124	98124	98125
21618	31788	64	applied	\N	\N	\N	\N	98133	98133	98134
21618	31792	65	applied	\N	\N	\N	\N	98144	98144	98145
21618	31793	66	applied	\N	\N	\N	\N	98146	98146	98147
21618	31798	67	applied	\N	\N	\N	\N	98156	98156	98157
21618	31799	68	applied	\N	\N	\N	\N	98158	98158	98159
21618	31800	69	applied	\N	\N	\N	\N	98160	98160	98161
21618	31808	70	applied	\N	\N	\N	\N	98180	98180	98181
21618	31811	71	applied	\N	\N	\N	\N	98192	98192	98193
21618	31814	72	applied	\N	\N	\N	\N	98198	98198	98199
21618	31815	73	applied	\N	\N	\N	\N	98200	98200	98201
21618	31820	74	applied	\N	\N	\N	\N	98212	98212	98213
21618	31821	75	applied	\N	\N	\N	\N	98214	98214	98215
21618	31827	76	applied	\N	\N	\N	\N	98229	98229	98230
21618	31836	77	applied	\N	\N	\N	\N	98249	98249	98250
21618	31837	78	applied	\N	\N	\N	\N	98251	98251	98252
21618	31844	79	applied	\N	\N	\N	\N	98267	98267	98268
21618	31845	80	applied	\N	\N	\N	\N	98269	98269	98270
21618	31850	81	applied	\N	\N	\N	\N	98281	98281	98282
21618	31856	82	applied	\N	\N	\N	\N	98295	98295	98296
21618	31859	83	applied	\N	\N	\N	\N	98302	98302	98303
21618	31860	84	applied	\N	\N	\N	\N	98304	98304	98305
21618	31867	85	applied	\N	\N	\N	\N	98321	98321	98322
21618	31870	86	applied	\N	\N	\N	\N	98328	98328	98329
21618	31874	87	applied	\N	\N	\N	\N	98340	98340	98341
21618	31878	88	applied	\N	\N	\N	\N	98350	98350	98351
21618	31881	89	applied	\N	\N	\N	\N	98367	98367	98368
21618	31884	90	applied	\N	\N	\N	\N	98375	98375	98376
21618	31887	91	applied	\N	\N	\N	\N	98393	98393	98394
21618	31888	92	applied	\N	\N	\N	\N	98395	98395	98396
21618	31894	93	applied	\N	\N	\N	\N	98409	98409	98410
21618	31895	94	applied	\N	\N	\N	\N	98411	98411	98412
21618	31901	95	applied	\N	\N	\N	\N	98425	98425	98426
21618	31904	96	applied	\N	\N	\N	\N	98435	98435	98436
21618	31907	97	applied	\N	\N	\N	\N	98443	98443	98444
21618	31908	98	applied	\N	\N	\N	\N	98445	98445	98446
21618	31909	99	applied	\N	\N	\N	\N	98447	98447	98448
21618	31917	100	applied	\N	\N	\N	\N	98469	98469	98470
21618	31920	101	applied	\N	\N	\N	\N	98482	98482	98483
21618	31921	102	applied	\N	\N	\N	\N	98484	98484	98485
21618	31922	103	applied	\N	\N	\N	\N	98486	98486	98487
21618	31930	104	applied	\N	\N	\N	\N	98503	98503	98504
21618	31934	105	applied	\N	\N	\N	\N	98518	98518	98519
21618	31936	106	applied	\N	\N	\N	\N	98522	98522	98523
21618	31937	107	applied	\N	\N	\N	\N	98524	98524	98525
21618	31943	108	applied	\N	\N	\N	\N	98537	98537	98538
21618	31946	109	applied	\N	\N	\N	\N	98545	98545	98546
21618	31949	110	applied	\N	\N	\N	\N	98553	98553	98554
21618	31953	111	applied	\N	\N	\N	\N	98562	98562	98563
21618	31955	112	applied	\N	\N	\N	\N	98568	98568	98569
21618	31957	113	applied	\N	\N	\N	\N	98579	98579	98580
21618	31959	114	applied	\N	\N	\N	\N	98585	98585	98586
21618	31961	115	applied	\N	\N	\N	\N	98588	98588	98589
21618	31964	116	applied	\N	\N	\N	\N	98597	98597	98598
21618	31966	117	applied	\N	\N	\N	\N	98602	98602	98603
21618	31968	118	applied	\N	\N	\N	\N	98607	98607	98608
21618	31970	119	applied	\N	\N	\N	\N	98617	98617	98618
21618	31971	120	applied	\N	\N	\N	\N	98619	98619	98620
21618	31974	121	applied	\N	\N	\N	\N	98627	98627	98628
21618	31976	122	applied	\N	\N	\N	\N	98632	98632	98633
21618	31977	123	applied	\N	\N	\N	\N	98634	98634	98635
21618	31978	124	applied	\N	\N	\N	\N	98636	98636	98637
21618	31982	125	applied	\N	\N	\N	\N	98648	98648	98649
21624	32148	0	applied	\N	\N	\N	\N	99218	99218	99219
21624	32149	1	applied	\N	\N	\N	\N	99220	99220	99221
21624	32150	2	applied	\N	\N	\N	\N	99222	99222	99223
21624	32151	3	applied	\N	\N	\N	\N	99224	99224	99225
21624	32152	4	applied	\N	\N	\N	\N	99228	99228	99229
21624	32153	5	applied	\N	\N	\N	\N	99230	99230	99231
21626	31964	0	applied	\N	\N	\N	\N	98597	98597	98598
21626	31966	1	applied	\N	\N	\N	\N	98602	98602	98603
21626	31968	2	applied	\N	\N	\N	\N	98607	98607	98608
21626	31970	3	applied	\N	\N	\N	\N	98617	98617	98618
21626	31971	4	applied	\N	\N	\N	\N	98619	98619	98620
21626	31974	5	applied	\N	\N	\N	\N	98627	98627	98628
21626	31976	6	applied	\N	\N	\N	\N	98632	98632	98633
21626	31977	7	applied	\N	\N	\N	\N	98634	98634	98635
21626	31978	8	applied	\N	\N	\N	\N	98636	98636	98637
21626	31982	9	applied	\N	\N	\N	\N	98648	98648	98649
21626	31986	10	applied	\N	\N	\N	\N	98658	98658	98659
21626	31989	11	applied	\N	\N	\N	\N	98665	98665	98666
21626	31990	12	applied	\N	\N	\N	\N	98667	98667	98668
21626	31996	13	applied	\N	\N	\N	\N	98681	98681	98682
21626	31997	14	applied	\N	\N	\N	\N	98683	98683	98684
21626	32002	15	applied	\N	\N	\N	\N	98694	98694	98695
21626	32006	16	applied	\N	\N	\N	\N	98705	98705	98706
21626	32009	17	applied	\N	\N	\N	\N	98733	98733	98734
21626	32012	18	applied	\N	\N	\N	\N	98741	98741	98742
21626	32015	19	applied	\N	\N	\N	\N	98753	98753	98754
21626	32019	20	applied	\N	\N	\N	\N	98762	98762	98763
21626	32022	21	applied	\N	\N	\N	\N	98773	98773	98774
21626	32025	22	applied	\N	\N	\N	\N	98783	98783	98784
21626	32026	23	applied	\N	\N	\N	\N	98785	98785	98786
21626	32031	24	applied	\N	\N	\N	\N	98797	98797	98798
21626	32034	25	applied	\N	\N	\N	\N	98806	98806	98807
21626	32037	26	applied	\N	\N	\N	\N	98823	98823	98824
21626	32040	27	applied	\N	\N	\N	\N	98869	98869	98870
21626	32041	28	applied	\N	\N	\N	\N	98871	98871	98872
21626	32042	29	applied	\N	\N	\N	\N	98873	98873	98874
21626	32049	30	applied	\N	\N	\N	\N	98892	98892	98893
21626	32059	31	applied	\N	\N	\N	\N	98939	98939	98940
21626	32062	32	applied	\N	\N	\N	\N	98947	98947	98948
21626	32065	33	applied	\N	\N	\N	\N	98957	98957	98958
21626	32068	34	applied	\N	\N	\N	\N	98966	98966	98967
21626	32071	35	applied	\N	\N	\N	\N	98974	98974	98975
21626	32074	36	applied	\N	\N	\N	\N	98984	98984	98985
21626	32077	37	applied	\N	\N	\N	\N	98996	98996	98997
21626	32080	38	applied	\N	\N	\N	\N	99007	99007	99008
21626	32083	39	applied	\N	\N	\N	\N	99016	99016	99017
21626	32086	40	applied	\N	\N	\N	\N	99026	99026	99027
21626	32089	41	applied	\N	\N	\N	\N	99034	99034	99035
21626	32092	42	applied	\N	\N	\N	\N	99044	99044	99045
21626	32093	43	applied	\N	\N	\N	\N	99048	99048	99236
21626	32094	44	applied	\N	\N	\N	\N	99050	99050	99237
21626	32102	45	applied	\N	\N	\N	\N	99069	99069	99238
21626	32105	46	applied	\N	\N	\N	\N	99078	99078	99239
21626	32108	47	applied	\N	\N	\N	\N	99086	99086	99240
21626	32111	48	applied	\N	\N	\N	\N	99096	99096	99241
21626	32112	49	applied	\N	\N	\N	\N	99098	99098	99242
21626	32118	50	applied	\N	\N	\N	\N	99122	99122	99243
21626	32119	51	applied	\N	\N	\N	\N	99124	99124	99244
21626	32124	52	applied	\N	\N	\N	\N	99139	99139	99245
21626	32127	53	applied	\N	\N	\N	\N	99147	99147	99246
21626	32130	54	applied	\N	\N	\N	\N	99159	99159	99247
21626	32133	55	applied	\N	\N	\N	\N	99172	99172	99248
21626	32136	56	applied	\N	\N	\N	\N	99181	99181	99249
21626	32139	57	applied	\N	\N	\N	\N	99189	99189	99250
21626	32142	58	applied	\N	\N	\N	\N	99196	99196	99251
21626	32145	59	applied	\N	\N	\N	\N	99206	99206	99252
21626	32148	60	applied	\N	\N	\N	\N	99218	99218	99253
21626	31965	61	applied	\N	\N	\N	\N	98599	98599	98600
21626	31967	62	applied	\N	\N	\N	\N	98604	98604	98605
21626	31969	63	applied	\N	\N	\N	\N	98609	98609	98610
21626	31972	64	applied	\N	\N	\N	\N	98621	98621	98622
21626	31973	65	applied	\N	\N	\N	\N	98623	98623	98624
21626	31983	66	applied	\N	\N	\N	\N	98650	98650	99254
21626	31987	67	applied	\N	\N	\N	\N	98660	98660	99255
21626	31992	68	applied	\N	\N	\N	\N	98671	98671	98639
21626	31993	69	applied	\N	\N	\N	\N	98673	98673	99256
21626	31998	70	applied	\N	\N	\N	\N	98685	98685	99257
21626	31975	71	applied	\N	\N	\N	\N	98629	98629	99258
21626	32000	72	applied	\N	\N	\N	\N	98689	98689	99259
21626	32003	73	applied	\N	\N	\N	\N	98696	98696	98653
21626	32008	74	applied	\N	\N	\N	\N	98709	98709	99260
21626	32010	75	applied	\N	\N	\N	\N	98735	98735	99261
21626	32013	76	applied	\N	\N	\N	\N	98743	98743	98663
21626	32016	77	applied	\N	\N	\N	\N	98755	98755	99262
21626	32020	78	applied	\N	\N	\N	\N	98764	98764	99263
21626	32024	79	applied	\N	\N	\N	\N	98777	98777	99264
21626	32029	80	applied	\N	\N	\N	\N	98791	98791	98676
21626	32030	81	applied	\N	\N	\N	\N	98793	98793	99265
21626	32033	82	applied	\N	\N	\N	\N	98803	98803	99266
21626	32036	83	applied	\N	\N	\N	\N	98810	98810	99267
21626	32039	84	applied	\N	\N	\N	\N	98827	98827	98688
21626	32043	85	applied	\N	\N	\N	\N	98875	98875	98690
21626	32044	86	applied	\N	\N	\N	\N	98877	98877	99268
21626	32045	87	applied	\N	\N	\N	\N	98879	98879	99269
21626	32051	88	applied	\N	\N	\N	\N	98896	98896	99270
21626	32052	89	applied	\N	\N	\N	\N	98906	98906	98699
21626	32054	90	applied	\N	\N	\N	\N	98912	98912	99271
21626	32055	91	applied	\N	\N	\N	\N	98914	98914	98708
21626	32057	92	applied	\N	\N	\N	\N	98919	98919	98710
21626	32061	93	applied	\N	\N	\N	\N	98943	98943	98736
21626	32064	94	applied	\N	\N	\N	\N	98951	98951	99272
21626	32066	95	applied	\N	\N	\N	\N	98959	98959	99273
21626	32095	96	applied	\N	\N	\N	\N	99052	99052	12588
21626	32117	97	applied	\N	\N	\N	\N	99109	99109	47675
21626	32069	98	applied	\N	\N	\N	\N	98968	98968	99274
21626	32073	99	applied	\N	\N	\N	\N	98978	98978	98746
21626	32075	100	applied	\N	\N	\N	\N	98986	98986	98756
21626	32079	101	applied	\N	\N	\N	\N	99001	99001	99275
21626	32082	102	applied	\N	\N	\N	\N	99012	99012	98760
21626	32084	103	applied	\N	\N	\N	\N	99018	99018	98765
21626	32088	104	applied	\N	\N	\N	\N	99030	99030	99276
21626	31985	105	applied	\N	\N	\N	\N	98654	98654	98767
21626	31994	106	applied	\N	\N	\N	\N	98675	98675	99277
21626	32005	108	applied	\N	\N	\N	\N	98700	98700	99279
21626	32018	109	applied	\N	\N	\N	\N	98759	98759	98776
21626	31979	110	applied	\N	\N	\N	\N	98638	98638	99280
21626	31980	111	applied	\N	\N	\N	\N	98640	98640	99281
21626	31981	112	applied	\N	\N	\N	\N	98642	98642	99282
21626	31984	113	applied	\N	\N	\N	\N	98652	98652	98794
21626	31988	114	applied	\N	\N	\N	\N	98662	98662	98800
21626	31991	115	applied	\N	\N	\N	\N	98669	98669	99283
21626	31995	116	applied	\N	\N	\N	\N	98677	98677	99284
21626	31999	117	applied	\N	\N	\N	\N	98687	98687	98833
21626	32001	118	applied	\N	\N	\N	\N	98691	98691	98828
21626	32004	119	applied	\N	\N	\N	\N	98698	98698	99285
21626	32007	120	applied	\N	\N	\N	\N	98707	98707	98880
21626	32011	121	applied	\N	\N	\N	\N	98737	98737	98882
21626	32014	122	applied	\N	\N	\N	\N	98745	98745	98884
21626	32017	123	applied	\N	\N	\N	\N	98757	98757	98886
21626	32021	124	applied	\N	\N	\N	\N	98766	98766	98895
21626	32023	125	applied	\N	\N	\N	\N	98775	98775	99286
21627	32154	0	applied	\N	\N	\N	\N	99289	99289	99290
21627	32155	1	applied	\N	\N	\N	\N	99291	99291	99292
21634	32167	0	applied	\N	\N	\N	\N	99322	99322	99323
21634	32168	1	applied	\N	\N	\N	\N	99324	99324	99325
21634	32170	2	applied	\N	\N	\N	\N	99332	99332	99333
21634	32169	3	applied	\N	\N	\N	\N	99326	99326	99334
21639	32177	0	applied	\N	\N	\N	\N	99355	99355	99356
21639	32176	1	applied	\N	\N	\N	\N	99350	99350	99351
21639	32178	2	applied	\N	\N	\N	\N	99357	99357	99358
21639	32175	3	applied	\N	\N	\N	\N	99346	99346	99359
21639	32179	4	applied	\N	\N	\N	\N	99361	99361	99362
21641	32183	0	applied	\N	\N	\N	\N	99371	99371	99372
21641	32184	1	applied	\N	\N	\N	\N	99373	99373	99374
21641	32185	2	applied	\N	\N	\N	\N	99375	99375	99376
21644	32186	0	applied	\N	\N	\N	\N	99381	99381	99382
21644	32189	1	applied	\N	\N	\N	\N	99387	99387	99388
21644	32187	2	applied	\N	\N	\N	\N	99383	99383	99389
21644	32190	3	applied	\N	\N	\N	\N	99390	99390	99391
21644	32188	4	applied	\N	\N	\N	\N	99385	99385	99392
21646	32194	0	applied	\N	\N	\N	\N	99403	99403	99404
21646	32195	1	applied	\N	\N	\N	\N	99405	99405	99406
21646	32196	2	applied	\N	\N	\N	\N	99407	99407	99408
21646	32197	3	applied	\N	\N	\N	\N	99409	99409	99410
21646	32198	5	applied	\N	\N	\N	\N	99412	99412	99413
21646	32199	6	applied	\N	\N	\N	\N	99414	99414	99415
21646	32200	7	applied	\N	\N	\N	\N	99416	99416	99417
21646	32201	8	applied	\N	\N	\N	\N	99418	99418	99419
21649	32202	0	applied	\N	\N	\N	\N	99422	99422	99423
21649	32203	1	applied	\N	\N	\N	\N	99424	99424	99425
21649	32204	2	applied	\N	\N	\N	\N	99426	99426	99427
21651	32202	0	applied	\N	\N	\N	\N	99422	99422	99423
21651	32203	1	applied	\N	\N	\N	\N	99424	99424	99425
21651	32204	2	applied	\N	\N	\N	\N	99426	99426	99427
21655	32205	0	applied	\N	\N	\N	\N	99453	99453	99454
21655	32206	1	applied	\N	\N	\N	\N	99455	99455	99456
21655	32207	2	applied	\N	\N	\N	\N	99457	99457	99458
21655	32208	3	applied	\N	\N	\N	\N	99459	99459	99460
21655	32209	4	applied	\N	\N	\N	\N	99461	99461	99462
21655	32210	5	applied	\N	\N	\N	\N	99463	99463	99464
21655	32211	6	applied	\N	\N	\N	\N	99465	99465	99466
21655	32212	7	applied	\N	\N	\N	\N	99467	99467	99468
21655	32213	8	applied	\N	\N	\N	\N	99469	99469	99470
21658	32221	0	applied	\N	\N	\N	\N	99488	99488	47675
21658	32222	1	applied	\N	\N	\N	\N	99489	99489	99490
21658	32223	2	applied	\N	\N	\N	\N	99491	99491	99492
21658	32224	3	applied	\N	\N	\N	\N	99493	99493	99494
21661	32228	0	applied	\N	\N	\N	\N	99505	99505	99506
21661	32230	1	applied	\N	\N	\N	\N	99511	99511	99512
21661	32229	2	applied	\N	\N	\N	\N	99507	99507	99513
21667	32238	0	applied	\N	\N	\N	\N	99538	99538	47675
21667	32239	1	applied	\N	\N	\N	\N	99539	99539	99540
21667	32237	2	applied	\N	\N	\N	\N	99531	99531	99541
21667	32240	3	applied	\N	\N	\N	\N	99542	99542	99543
21670	32238	0	applied	\N	\N	\N	\N	99538	99538	47675
21670	32239	1	applied	\N	\N	\N	\N	99539	99539	99540
21670	32236	2	applied	\N	\N	\N	\N	99529	99529	99530
21670	32241	3	applied	\N	\N	\N	\N	99546	99546	99547
21670	32237	4	applied	\N	\N	\N	\N	99531	99531	99548
21670	32240	5	applied	\N	\N	\N	\N	99542	99542	99549
21674	32251	0	applied	\N	\N	\N	\N	99575	99575	99576
21674	32252	1	applied	\N	\N	\N	\N	99577	99577	99578
21674	32253	2	applied	\N	\N	\N	\N	99579	99579	99580
21679	32261	0	applied	\N	\N	\N	\N	99602	99602	99603
21679	32262	1	applied	\N	\N	\N	\N	99604	99604	99605
21679	32263	2	applied	\N	\N	\N	\N	99606	99606	99607
21684	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21684	32268	1	applied	\N	\N	\N	\N	99699	99699	99700
21684	32269	2	applied	\N	\N	\N	\N	99701	99701	99702
21684	32270	3	applied	\N	\N	\N	\N	99703	99703	99704
21687	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21695	32290	0	applied	\N	\N	\N	\N	99762	99762	99763
21695	32291	1	applied	\N	\N	\N	\N	99764	99764	99765
21695	32292	2	applied	\N	\N	\N	\N	99766	99766	99767
21695	32293	3	applied	\N	\N	\N	\N	99768	99768	99769
21697	32296	0	applied	\N	\N	\N	\N	99778	99778	99779
21697	32294	1	applied	\N	\N	\N	\N	99770	99770	99771
21697	32295	2	applied	\N	\N	\N	\N	99772	99772	99773
21697	32297	3	applied	\N	\N	\N	\N	99780	99780	99781
21697	32298	4	applied	\N	\N	\N	\N	99782	99782	99783
21699	32299	0	applied	\N	\N	\N	\N	99785	99785	99786
21699	32300	1	applied	\N	\N	\N	\N	99787	99787	99788
21699	32301	2	applied	\N	\N	\N	\N	99789	99789	99790
21701	32299	0	applied	\N	\N	\N	\N	99785	99785	99786
21701	32300	1	applied	\N	\N	\N	\N	99787	99787	99788
21701	32301	2	applied	\N	\N	\N	\N	99789	99789	99790
21712	32335	0	applied	\N	\N	\N	\N	99881	99881	99882
21712	32336	1	applied	\N	\N	\N	\N	99883	99883	99884
21712	32337	2	applied	\N	\N	\N	\N	99885	99885	99886
21715	32338	0	applied	\N	\N	\N	\N	99892	99892	99893
21715	32339	1	applied	\N	\N	\N	\N	99894	99894	99895
21715	32340	2	applied	\N	\N	\N	\N	99896	99896	99897
21715	32341	3	applied	\N	\N	\N	\N	99898	99898	99899
21715	32342	4	applied	\N	\N	\N	\N	99900	99900	99901
21715	32343	5	applied	\N	\N	\N	\N	99902	99902	99903
21718	32356	0	applied	\N	\N	\N	\N	99932	99932	99933
21718	32357	1	applied	\N	\N	\N	\N	99934	99934	99935
21718	32358	2	applied	\N	\N	\N	\N	99936	99936	99937
21721	32362	0	applied	\N	\N	\N	\N	99948	99948	99949
21721	32363	1	applied	\N	\N	\N	\N	99950	99950	99951
21721	32364	2	applied	\N	\N	\N	\N	99952	99952	99953
21723	32365	0	applied	\N	\N	\N	\N	99958	99958	99959
21723	32366	1	applied	\N	\N	\N	\N	99960	99960	99961
21723	32367	2	applied	\N	\N	\N	\N	99962	99962	99963
21725	32368	0	applied	\N	\N	\N	\N	99967	99967	99968
21725	32369	1	applied	\N	\N	\N	\N	99969	99969	99970
21735	32372	0	applied	\N	\N	\N	\N	100048	100048	100070
21735	32373	1	applied	\N	\N	\N	\N	100071	100071	100072
21735	32374	2	applied	\N	\N	\N	\N	100073	100073	100074
21735	32375	3	applied	\N	\N	\N	\N	100075	100075	100076
21653	31871	19	applied	\N	\N	\N	\N	98337	98337	98320
21653	31437	20	applied	\N	\N	\N	\N	97117	97117	97118
21653	31439	21	applied	\N	\N	\N	\N	97123	97123	97124
21653	31441	22	applied	\N	\N	\N	\N	97129	97129	97130
21653	31442	23	applied	\N	\N	\N	\N	97131	97131	97132
21653	31443	24	applied	\N	\N	\N	\N	97133	97133	97134
21653	31444	25	applied	\N	\N	\N	\N	97135	97135	97136
21653	31449	26	applied	\N	\N	\N	\N	97147	97147	97148
21653	31450	27	applied	\N	\N	\N	\N	97149	97149	97150
21653	31453	28	applied	\N	\N	\N	\N	97162	97162	97163
21653	31455	29	applied	\N	\N	\N	\N	97168	97168	97169
21653	31456	30	applied	\N	\N	\N	\N	97170	97170	97171
21653	31457	31	applied	\N	\N	\N	\N	97172	97172	97173
21653	31465	32	applied	\N	\N	\N	\N	97190	97190	97191
21653	31474	33	applied	\N	\N	\N	\N	97211	97211	97212
21653	31475	34	applied	\N	\N	\N	\N	97213	97213	97214
21653	31476	35	applied	\N	\N	\N	\N	97215	97215	97216
21653	31493	36	applied	\N	\N	\N	\N	97252	97252	97253
21653	31497	37	applied	\N	\N	\N	\N	97280	97280	97281
21653	31498	38	applied	\N	\N	\N	\N	97282	97282	97283
21653	31503	39	applied	\N	\N	\N	\N	97298	97298	97299
21653	31506	40	applied	\N	\N	\N	\N	97306	97306	97307
21653	31510	41	applied	\N	\N	\N	\N	97316	97316	97317
21653	32172	42	applied	\N	\N	\N	\N	99447	99447	99341
21653	32173	43	applied	\N	\N	\N	\N	99448	99448	99343
21653	32174	44	applied	\N	\N	\N	\N	99449	99449	99345
21653	31831	45	applied	\N	\N	\N	\N	98357	98357	98330
21653	31832	46	applied	\N	\N	\N	\N	98358	98358	98242
21653	31838	47	applied	\N	\N	\N	\N	98359	98359	98254
21653	31842	48	applied	\N	\N	\N	\N	98360	98360	98264
21653	31843	49	applied	\N	\N	\N	\N	98361	98361	98266
21653	31851	50	applied	\N	\N	\N	\N	98362	98362	98284
21653	31852	51	applied	\N	\N	\N	\N	98363	98363	98286
21653	31866	52	applied	\N	\N	\N	\N	98364	98364	98320
21653	31513	53	applied	\N	\N	\N	\N	97324	97324	97325
21653	31516	54	applied	\N	\N	\N	\N	97331	97331	97332
21653	31520	55	applied	\N	\N	\N	\N	97342	97342	97343
21653	31521	56	applied	\N	\N	\N	\N	97344	97344	97345
21653	31526	57	applied	\N	\N	\N	\N	97357	97357	97358
21653	31530	58	applied	\N	\N	\N	\N	97368	97368	97369
21653	31531	59	applied	\N	\N	\N	\N	97370	97370	97371
21653	31536	60	applied	\N	\N	\N	\N	97385	97385	97386
21653	31539	61	applied	\N	\N	\N	\N	97394	97394	97395
21653	31543	62	applied	\N	\N	\N	\N	97409	97409	97410
21653	31546	63	applied	\N	\N	\N	\N	97421	97421	97422
21653	31551	64	applied	\N	\N	\N	\N	97442	97442	97443
21653	31552	65	applied	\N	\N	\N	\N	97444	97444	97445
21653	31555	66	applied	\N	\N	\N	\N	97454	97454	97455
21653	31558	67	applied	\N	\N	\N	\N	97462	97462	97463
21653	31559	68	applied	\N	\N	\N	\N	97464	97464	97465
21653	31560	69	applied	\N	\N	\N	\N	97466	97466	97467
21653	31561	70	applied	\N	\N	\N	\N	97468	97468	97469
21653	31575	71	applied	\N	\N	\N	\N	97498	97498	97499
21653	31576	72	applied	\N	\N	\N	\N	97500	97500	97501
21653	31579	73	applied	\N	\N	\N	\N	97507	97507	97508
21653	31582	74	applied	\N	\N	\N	\N	97517	97517	97518
21653	31586	75	applied	\N	\N	\N	\N	97526	97526	97527
21653	31589	76	applied	\N	\N	\N	\N	97535	97535	97536
21653	31593	77	applied	\N	\N	\N	\N	97550	97550	97551
21653	31599	78	applied	\N	\N	\N	\N	97569	97569	97570
21653	31604	79	applied	\N	\N	\N	\N	97583	97583	97584
21653	31607	80	applied	\N	\N	\N	\N	97591	97591	97592
21653	31610	81	applied	\N	\N	\N	\N	97600	97600	97601
21653	31611	82	applied	\N	\N	\N	\N	97602	97602	97603
21653	31617	83	applied	\N	\N	\N	\N	97619	97619	97620
21653	31618	84	applied	\N	\N	\N	\N	97621	97621	97622
21653	31619	85	applied	\N	\N	\N	\N	97623	97623	97624
21653	31628	86	applied	\N	\N	\N	\N	97642	97642	97643
21653	31632	87	applied	\N	\N	\N	\N	97654	97654	97655
21653	31633	88	applied	\N	\N	\N	\N	97656	97656	97657
21653	31638	89	applied	\N	\N	\N	\N	97667	97667	97668
21653	31642	90	applied	\N	\N	\N	\N	97677	97677	97678
21653	31646	92	applied	\N	\N	\N	\N	97687	97687	97688
21653	31649	93	applied	\N	\N	\N	\N	97695	97695	97696
21653	31650	94	applied	\N	\N	\N	\N	97697	97697	97698
21653	31651	95	applied	\N	\N	\N	\N	97699	97699	97700
21653	31659	96	applied	\N	\N	\N	\N	97719	97719	97720
21653	31660	97	applied	\N	\N	\N	\N	97721	97721	97722
21653	31661	98	applied	\N	\N	\N	\N	97723	97723	97724
21653	31662	99	applied	\N	\N	\N	\N	97725	97725	97726
21653	31663	100	applied	\N	\N	\N	\N	97727	97727	97728
21653	31664	101	applied	\N	\N	\N	\N	97729	97729	97730
21653	31678	102	applied	\N	\N	\N	\N	97760	97760	97761
21653	31679	103	applied	\N	\N	\N	\N	97762	97762	97763
21653	31684	104	applied	\N	\N	\N	\N	97787	97787	97788
21653	31688	105	applied	\N	\N	\N	\N	97796	97796	97797
21653	31689	106	applied	\N	\N	\N	\N	97798	97798	97799
21653	31694	107	applied	\N	\N	\N	\N	97810	97810	97811
21653	31698	108	applied	\N	\N	\N	\N	97824	97824	97825
21653	31702	109	applied	\N	\N	\N	\N	97832	97832	97833
21653	31703	110	applied	\N	\N	\N	\N	97834	97834	97835
21653	31708	111	applied	\N	\N	\N	\N	97845	97845	97846
21653	31709	112	applied	\N	\N	\N	\N	97847	97847	97848
21653	31715	113	applied	\N	\N	\N	\N	97863	97863	97864
21653	31718	114	applied	\N	\N	\N	\N	97872	97872	97873
21653	31722	115	applied	\N	\N	\N	\N	97882	97882	97883
21653	31725	116	applied	\N	\N	\N	\N	97890	97890	97891
21653	31728	117	applied	\N	\N	\N	\N	97947	97947	97948
21653	31732	118	applied	\N	\N	\N	\N	97959	97959	97960
21653	31736	119	applied	\N	\N	\N	\N	97974	97974	97975
21653	31737	120	applied	\N	\N	\N	\N	97976	97976	97977
21653	31738	121	applied	\N	\N	\N	\N	97978	97978	97979
21653	31747	122	applied	\N	\N	\N	\N	98003	98003	98004
21653	31748	123	applied	\N	\N	\N	\N	98005	98005	98006
21653	31753	124	applied	\N	\N	\N	\N	98018	98018	98019
21653	31759	125	applied	\N	\N	\N	\N	98033	98033	98034
21656	32214	0	applied	\N	\N	\N	\N	99474	99474	99475
21656	32215	1	applied	\N	\N	\N	\N	99476	99476	99477
21656	32216	2	applied	\N	\N	\N	\N	99478	99478	99479
21663	32231	0	applied	\N	\N	\N	\N	99515	99515	99516
21663	32232	1	applied	\N	\N	1000000000	\N	99517	99517	99518
21663	32233	2	applied	\N	\N	\N	\N	99519	99519	99520
21663	32234	3	applied	\N	\N	\N	\N	99521	99521	99522
21668	32238	0	applied	\N	\N	\N	\N	99538	99538	47675
21668	32239	1	applied	\N	\N	\N	\N	99539	99539	99540
21668	32236	2	applied	\N	\N	\N	\N	99529	99529	99530
21668	32241	3	applied	\N	\N	\N	\N	99546	99546	99547
21668	32237	4	applied	\N	\N	\N	\N	99531	99531	99548
21668	32240	5	applied	\N	\N	\N	\N	99542	99542	99549
21675	32251	0	applied	\N	\N	\N	\N	99575	99575	99576
21666	31351	79	applied	\N	\N	\N	\N	96862	96862	96863
21666	31353	80	applied	\N	\N	\N	\N	96870	96870	96871
21666	31355	81	applied	\N	\N	\N	\N	96875	96875	96876
21666	31357	82	applied	\N	\N	\N	\N	96882	96882	96883
21666	31359	83	applied	\N	\N	\N	\N	96888	96888	96889
21666	31361	84	applied	\N	\N	\N	\N	96897	96897	96898
21666	31363	85	applied	\N	\N	\N	\N	96903	96903	96904
21666	31365	86	applied	\N	\N	\N	\N	96908	96908	96909
21666	31366	87	applied	\N	\N	\N	\N	96910	96910	96911
21666	31369	88	applied	\N	\N	\N	\N	96919	96919	96920
21666	31370	90	applied	\N	\N	\N	\N	96921	96921	96922
21666	31371	91	applied	\N	\N	\N	\N	96923	96923	96924
21666	31375	92	applied	\N	\N	\N	\N	96933	96933	96934
21666	31377	93	applied	\N	\N	\N	\N	96937	96937	96938
21666	31379	94	applied	\N	\N	\N	\N	96943	96943	96944
21666	31381	95	applied	\N	\N	\N	\N	96949	96949	96950
21666	31382	96	applied	\N	\N	\N	\N	96951	96951	96952
21666	31385	97	applied	\N	\N	\N	\N	96959	96959	96960
21666	31386	98	applied	\N	\N	\N	\N	96961	96961	96962
21666	31389	99	applied	\N	\N	\N	\N	96972	96972	96973
21666	31390	100	applied	\N	\N	\N	\N	96976	96976	96977
21666	31391	101	applied	\N	\N	\N	\N	96978	96978	96979
21666	31394	102	applied	\N	\N	\N	\N	96986	96986	96987
21666	31396	103	applied	\N	\N	\N	\N	96994	96994	96995
21666	31398	104	applied	\N	\N	\N	\N	97002	97002	97003
21666	31408	105	applied	\N	\N	\N	\N	97026	97026	97027
21666	31410	106	applied	\N	\N	\N	\N	97037	97037	97038
21666	31412	107	applied	\N	\N	\N	\N	97050	97050	97051
21666	31414	108	applied	\N	\N	\N	\N	97055	97055	97056
21666	31418	109	applied	\N	\N	\N	\N	97063	97063	97064
21666	31426	110	applied	\N	\N	\N	\N	97080	97080	97081
21666	31427	111	applied	\N	\N	\N	\N	97082	97082	97083
21666	31430	112	applied	\N	\N	\N	\N	97096	97096	97097
21666	31431	113	applied	\N	\N	\N	\N	97101	97101	97102
21666	31433	114	applied	\N	\N	\N	\N	97107	97107	97108
21666	31435	115	applied	\N	\N	\N	\N	97112	97112	97113
21666	31437	116	applied	\N	\N	\N	\N	97117	97117	97118
21666	31439	117	applied	\N	\N	\N	\N	97123	97123	97124
21666	31441	118	applied	\N	\N	\N	\N	97129	97129	97130
21666	31442	119	applied	\N	\N	\N	\N	97131	97131	97132
21666	31443	120	applied	\N	\N	\N	\N	97133	97133	97134
21666	31444	121	applied	\N	\N	\N	\N	97135	97135	97136
21666	31449	122	applied	\N	\N	\N	\N	97147	97147	97148
21666	31450	123	applied	\N	\N	\N	\N	97149	97149	97150
21666	31453	124	applied	\N	\N	\N	\N	97162	97162	97163
21666	31455	125	applied	\N	\N	\N	\N	97168	97168	97169
21673	32248	0	applied	\N	\N	\N	\N	99567	99567	99568
21673	32249	1	applied	\N	\N	\N	\N	99569	99569	99570
21673	32250	2	applied	\N	\N	\N	\N	99571	99571	99572
21681	32089	0	applied	\N	\N	\N	\N	99034	99034	99035
21681	32167	1	applied	\N	\N	\N	\N	99322	99322	99323
21681	32254	2	applied	\N	\N	\N	\N	99584	99584	99585
21681	32221	3	applied	\N	\N	\N	\N	99488	99488	47675
21681	32092	4	applied	\N	\N	\N	\N	99044	99044	99045
21681	32218	5	applied	\N	\N	\N	\N	99482	99482	47675
21681	32196	6	applied	\N	\N	\N	\N	99407	99407	99610
21681	32232	7	applied	\N	\N	1000000000	\N	99517	99517	99518
21681	32197	8	applied	\N	\N	\N	\N	99409	99409	99612
21681	32093	9	applied	\N	\N	\N	\N	99048	99048	99236
21681	32094	10	applied	\N	\N	\N	\N	99050	99050	99237
21681	32102	11	applied	\N	\N	\N	\N	99069	99069	99238
21681	32105	12	applied	\N	\N	\N	\N	99078	99078	99239
21681	32108	13	applied	\N	\N	\N	\N	99086	99086	99240
21681	32111	14	applied	\N	\N	\N	\N	99096	99096	99241
21681	32112	15	applied	\N	\N	\N	\N	99098	99098	99242
21681	32118	16	applied	\N	\N	\N	\N	99122	99122	99243
21681	32119	17	applied	\N	\N	\N	\N	99124	99124	99244
21681	32124	18	applied	\N	\N	\N	\N	99139	99139	99245
21681	32127	19	applied	\N	\N	\N	\N	99147	99147	99246
21681	32130	20	applied	\N	\N	\N	\N	99159	99159	99247
21681	32133	21	applied	\N	\N	\N	\N	99172	99172	99248
21681	32136	22	applied	\N	\N	\N	\N	99181	99181	99249
21681	32139	23	applied	\N	\N	\N	\N	99189	99189	99250
21681	32142	24	applied	\N	\N	\N	\N	99196	99196	99251
21681	32145	25	applied	\N	\N	\N	\N	99206	99206	99252
21681	32148	26	applied	\N	\N	\N	\N	99218	99218	99253
21681	32149	27	applied	\N	\N	\N	\N	99220	99220	99616
21681	32154	28	applied	\N	\N	\N	\N	99289	99289	99617
21681	32157	29	applied	\N	\N	\N	\N	99299	99299	99618
21681	32158	30	applied	\N	\N	\N	\N	99301	99301	99619
21681	32164	31	applied	\N	\N	\N	\N	99314	99314	99620
21681	32168	32	applied	\N	\N	\N	\N	99324	99324	99621
21681	32171	33	applied	\N	\N	\N	\N	99338	99338	99622
21681	32177	34	applied	\N	\N	\N	\N	99355	99355	99623
21681	32180	35	applied	\N	\N	\N	\N	99364	99364	99624
21681	32183	36	applied	\N	\N	\N	\N	99371	99371	99625
21681	32186	37	applied	\N	\N	\N	\N	99381	99381	99626
21681	32191	38	applied	\N	\N	\N	\N	99394	99394	99627
21681	32194	39	applied	\N	\N	\N	\N	99403	99403	99628
21681	32195	41	applied	\N	\N	\N	\N	99405	99405	99630
21681	32202	42	applied	\N	\N	\N	\N	99422	99422	99631
21681	32205	43	applied	\N	\N	\N	\N	99453	99453	99632
21681	32206	44	applied	\N	\N	\N	\N	99455	99455	99633
21681	32207	45	applied	\N	\N	\N	\N	99457	99457	99634
21681	32214	46	applied	\N	\N	\N	\N	99474	99474	99635
21681	32217	47	applied	\N	\N	\N	\N	99480	99480	99636
21681	32222	48	applied	\N	\N	\N	\N	99489	99489	99637
21681	32225	49	applied	\N	\N	\N	\N	99497	99497	99638
21681	32228	50	applied	\N	\N	\N	\N	99505	99505	99639
21681	32231	51	applied	\N	\N	\N	\N	99515	99515	99640
21681	32235	52	applied	\N	\N	\N	\N	99525	99525	99641
21681	32239	53	applied	\N	\N	\N	\N	99539	99539	99642
21681	32242	54	applied	\N	\N	\N	\N	99553	99553	99643
21681	32243	55	applied	\N	\N	\N	\N	99555	99555	99644
21681	32248	56	applied	\N	\N	\N	\N	99567	99567	99645
21681	32251	57	applied	\N	\N	\N	\N	99575	99575	99646
21681	32255	58	applied	\N	\N	\N	\N	99586	99586	99647
21681	32258	59	applied	\N	\N	\N	\N	99594	99594	99648
21681	32261	60	applied	\N	\N	\N	\N	99602	99602	99649
21681	32264	61	applied	\N	\N	\N	\N	99650	99650	99651
21681	32172	62	applied	\N	\N	\N	\N	99613	99613	99341
21681	32173	63	applied	\N	\N	\N	\N	99614	99614	99343
21681	32174	64	applied	\N	\N	\N	\N	99410	99410	99345
21681	32099	65	applied	\N	\N	\N	\N	99060	99060	99652
21681	32100	66	applied	\N	\N	\N	\N	99062	99062	99056
21681	32101	67	applied	\N	\N	\N	\N	99064	99064	99653
21681	32103	68	applied	\N	\N	\N	\N	99071	99071	99654
21681	32106	69	applied	\N	\N	\N	\N	99080	99080	99655
21681	32109	70	applied	\N	\N	\N	\N	99088	99088	99656
21681	32115	71	applied	\N	\N	\N	\N	99105	99105	99657
21675	32252	1	applied	\N	\N	\N	\N	99577	99577	99578
21675	32253	2	applied	\N	\N	\N	\N	99579	99579	99580
21677	32254	0	applied	\N	\N	\N	\N	99584	99584	99585
21677	32255	1	applied	\N	\N	\N	\N	99586	99586	99587
21677	32256	2	applied	\N	\N	\N	\N	99588	99588	99589
21677	32257	3	applied	\N	\N	\N	\N	99590	99590	99591
21680	31950	0	applied	\N	\N	\N	\N	98555	98555	47675
21680	31960	1	applied	\N	\N	\N	\N	98587	98587	47675
21680	32167	2	applied	\N	\N	\N	\N	99322	99322	99323
21680	32254	3	applied	\N	\N	\N	\N	99584	99584	99585
21680	32221	4	applied	\N	\N	\N	\N	99488	99488	47675
21680	32218	5	applied	\N	\N	\N	\N	99482	99482	47675
21680	32196	6	applied	\N	\N	\N	\N	99407	99407	99610
21680	32232	7	applied	\N	\N	1000000000	\N	99611	99611	99518
21680	32197	8	applied	\N	\N	\N	\N	99409	99409	99612
21680	32172	9	applied	\N	\N	\N	\N	99613	99613	99341
21680	32173	10	applied	\N	\N	\N	\N	99614	99614	99343
21680	32174	11	applied	\N	\N	\N	\N	99410	99410	99345
21680	32095	12	applied	\N	\N	\N	\N	99052	99052	12588
21680	32117	13	applied	\N	\N	\N	\N	99109	99109	47675
21689	32271	0	applied	\N	\N	\N	\N	99710	99710	99711
21689	32274	1	applied	\N	\N	\N	\N	99718	99718	99719
21689	32275	2	applied	\N	\N	\N	\N	99720	99720	99721
21689	32273	3	applied	\N	\N	\N	\N	99715	99715	99722
21689	32272	4	applied	\N	\N	\N	\N	99712	99712	99716
21691	32276	0	applied	\N	\N	\N	\N	99724	99724	99725
21691	32277	1	applied	\N	\N	\N	\N	99726	99726	99727
21691	32278	2	applied	\N	\N	\N	\N	99728	99728	99729
21691	32279	3	applied	\N	\N	\N	\N	99730	99730	99731
21691	32280	4	applied	\N	\N	\N	\N	99732	99732	99733
21691	32281	5	applied	\N	\N	\N	\N	99734	99734	99735
21691	32282	6	applied	\N	\N	\N	\N	99736	99736	99737
21691	32283	7	applied	\N	\N	\N	\N	99738	99738	99739
21691	32284	8	applied	\N	\N	\N	\N	99740	99740	99741
21691	32285	10	applied	\N	\N	\N	\N	99743	99743	99744
21691	32286	11	applied	\N	\N	\N	\N	99745	99745	99746
21700	32299	0	applied	\N	\N	\N	\N	99785	99785	99786
21700	32300	1	applied	\N	\N	\N	\N	99787	99787	99788
21702	32302	0	applied	\N	\N	\N	\N	99799	99799	99800
21702	32303	1	applied	\N	\N	\N	\N	99801	99801	99802
21702	32304	2	applied	\N	\N	\N	\N	99803	99803	99804
21703	32305	0	applied	\N	\N	\N	\N	99806	99806	99807
21703	32306	1	applied	\N	\N	\N	\N	99808	99808	99809
21703	32307	2	applied	\N	\N	\N	\N	99810	99810	99811
21703	32308	3	applied	\N	\N	\N	\N	99812	99812	99813
21703	32309	4	applied	\N	\N	\N	\N	99814	99814	99815
21703	32310	5	applied	\N	\N	\N	\N	99816	99816	99817
21703	32311	6	applied	\N	\N	\N	\N	99818	99818	99819
21703	32312	7	applied	\N	\N	\N	\N	99820	99820	99821
21703	32313	8	applied	\N	\N	\N	\N	99822	99822	99823
21703	32314	9	applied	\N	\N	\N	\N	99824	99824	99825
21703	32315	10	applied	\N	\N	\N	\N	99826	99826	99827
21703	32316	11	applied	\N	\N	\N	\N	99828	99828	99829
21705	32317	0	applied	\N	\N	\N	\N	99831	99831	99832
21705	32319	1	applied	\N	\N	\N	\N	99837	99837	99838
21705	32318	2	applied	\N	\N	\N	\N	99833	99833	99839
21708	32327	0	applied	\N	\N	\N	\N	99860	99860	99861
21708	32328	1	applied	\N	\N	\N	\N	99862	99862	99863
21708	32329	2	applied	\N	\N	\N	\N	99864	99864	99865
21726	32368	0	applied	\N	\N	\N	\N	99967	99967	99968
21726	32369	1	applied	\N	\N	\N	\N	99969	99969	99970
21736	32372	0	applied	\N	\N	\N	\N	100048	100048	100070
21736	32373	1	applied	\N	\N	\N	\N	100071	100071	100072
21736	32374	2	applied	\N	\N	\N	\N	100073	100073	100074
21736	32375	3	applied	\N	\N	\N	\N	100075	100075	100076
21736	32376	4	applied	\N	\N	\N	\N	100077	100077	100078
21736	32377	5	applied	\N	\N	\N	\N	100079	100079	100080
21736	32378	6	applied	\N	\N	\N	\N	100081	100081	100082
21736	32379	7	applied	\N	\N	\N	\N	100083	100083	100084
21736	32380	8	applied	\N	\N	\N	\N	100085	100085	100086
21739	32381	0	applied	\N	\N	\N	\N	100103	100103	100104
21739	32382	1	applied	\N	\N	\N	\N	100105	100105	100106
21739	32383	2	applied	\N	\N	\N	\N	100107	100107	100108
21739	32384	3	applied	\N	\N	\N	\N	100109	100109	100110
21739	32385	4	applied	\N	\N	\N	\N	100111	100111	100112
21739	32386	5	applied	\N	\N	\N	\N	100113	100113	100114
21741	32381	0	applied	\N	\N	\N	\N	100103	100103	100104
21741	32382	1	applied	\N	\N	\N	\N	100105	100105	100106
21741	32383	2	applied	\N	\N	\N	\N	100107	100107	100108
21741	32384	3	applied	\N	\N	\N	\N	100109	100109	100110
21741	32385	4	applied	\N	\N	\N	\N	100111	100111	100112
21741	32386	5	applied	\N	\N	\N	\N	100113	100113	100114
21750	32396	0	applied	\N	\N	\N	\N	100148	100148	100149
21750	32397	1	applied	\N	\N	\N	\N	100150	100150	100151
21750	32398	2	applied	\N	\N	\N	\N	100152	100152	100153
21754	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21754	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21754	32274	2	applied	\N	\N	\N	\N	99718	99718	99719
21754	32275	3	applied	\N	\N	\N	\N	99720	99720	99721
21754	32276	4	applied	\N	\N	\N	\N	99724	99724	99725
21754	32277	5	applied	\N	\N	\N	\N	99726	99726	99727
21754	32373	6	applied	\N	\N	\N	\N	100071	100071	100072
21756	32402	0	applied	\N	\N	\N	\N	100204	100204	100205
21756	32403	1	applied	\N	\N	\N	\N	100206	100206	100207
21756	32404	2	applied	\N	\N	\N	\N	100208	100208	100209
21763	32414	0	applied	\N	\N	\N	\N	100246	100246	100247
21763	32413	1	applied	\N	\N	\N	\N	100241	100241	100242
21763	32415	2	applied	\N	\N	\N	\N	100248	100248	100249
21763	32416	3	applied	\N	\N	\N	\N	100250	100250	100251
21768	32420	0	applied	\N	\N	\N	\N	100264	100264	100265
21768	32421	1	applied	\N	\N	\N	\N	100266	100266	100267
21768	32422	2	applied	\N	\N	\N	\N	100268	100268	100269
21768	32423	3	applied	\N	\N	\N	\N	100270	100270	100271
21768	32424	4	applied	\N	\N	\N	\N	100272	100272	100273
21768	32425	5	applied	\N	\N	\N	\N	100274	100274	100275
21770	32426	0	applied	\N	\N	\N	\N	100282	100282	100283
21770	32427	1	applied	\N	\N	\N	\N	100284	100284	100285
21770	32428	2	applied	\N	\N	\N	\N	100286	100286	100287
21773	32429	0	applied	\N	\N	\N	\N	100292	100292	100293
21773	32430	1	applied	\N	\N	\N	\N	100294	100294	100295
21773	32431	2	applied	\N	\N	\N	\N	100296	100296	100297
21681	32116	72	applied	\N	\N	\N	\N	99107	99107	99658
21681	32120	73	applied	\N	\N	\N	\N	99126	99126	99659
21681	32121	74	applied	\N	\N	\N	\N	99128	99128	99074
21681	32095	75	applied	\N	\N	\N	\N	99052	99052	12588
21681	32117	76	applied	\N	\N	\N	\N	99109	99109	47675
21681	32096	77	applied	\N	\N	\N	\N	99053	99053	99660
21681	32097	78	applied	\N	\N	\N	\N	99055	99055	99661
21681	32098	79	applied	\N	\N	\N	\N	99057	99057	99662
21681	32104	80	applied	\N	\N	\N	\N	99073	99073	99663
21681	32107	81	applied	\N	\N	\N	\N	99082	99082	99664
21681	32110	82	applied	\N	\N	\N	\N	99090	99090	99106
21681	32113	83	applied	\N	\N	\N	\N	99100	99100	99665
21681	32114	84	applied	\N	\N	\N	\N	99102	99102	99129
21681	32122	85	applied	\N	\N	\N	\N	99130	99130	99131
21681	32123	86	applied	\N	\N	\N	\N	99132	99132	99133
21681	32125	87	applied	\N	\N	\N	\N	99141	99141	99142
21681	32129	88	applied	\N	\N	\N	\N	99151	99151	99666
21681	32131	89	applied	\N	\N	\N	\N	99161	99161	99667
21681	32134	90	applied	\N	\N	\N	\N	99175	99175	99150
21681	32137	91	applied	\N	\N	\N	\N	99183	99183	99152
21681	32141	92	applied	\N	\N	\N	\N	99193	99193	99162
21681	32143	93	applied	\N	\N	\N	\N	99198	99198	99668
21681	32147	94	applied	\N	\N	\N	\N	99210	99210	99669
21681	32150	95	applied	\N	\N	\N	\N	99222	99222	99670
21681	32151	96	applied	\N	\N	\N	\N	99224	99224	99178
21681	32155	97	applied	\N	\N	\N	\N	99291	99291	99185
21681	32159	98	applied	\N	\N	\N	\N	99303	99303	99671
21681	32160	99	applied	\N	\N	1000000000	\N	99305	99305	99306
21681	32126	100	applied	\N	\N	\N	\N	99143	99143	99672
21681	32128	101	applied	\N	\N	\N	\N	99149	99149	99194
21681	32132	102	applied	\N	\N	\N	\N	99163	99163	99673
21681	32135	103	applied	\N	\N	\N	\N	99177	99177	99674
21681	32138	104	applied	\N	\N	\N	\N	99186	99186	99675
21681	32140	105	applied	\N	\N	\N	\N	99191	99191	99223
21681	32144	106	applied	\N	\N	\N	\N	99200	99200	99676
21681	32146	107	applied	\N	\N	\N	\N	99208	99208	99677
21681	32152	108	applied	\N	\N	\N	\N	99228	99228	99678
21681	32153	109	applied	\N	\N	\N	\N	99230	99230	99679
21681	32156	110	applied	\N	\N	\N	\N	99294	99294	99304
21681	32161	111	applied	\N	\N	\N	\N	99307	99307	99308
21681	32166	112	applied	\N	\N	\N	\N	99318	99318	99680
21681	32169	113	applied	\N	\N	\N	\N	99326	99326	99681
21681	32175	114	applied	\N	\N	\N	\N	99346	99346	99312
21681	32179	115	applied	\N	\N	\N	\N	99361	99361	99682
21681	32162	116	applied	\N	\N	\N	\N	99309	99309	99319
21681	32163	117	applied	\N	\N	\N	\N	99311	99311	99333
21681	32165	118	applied	\N	\N	\N	\N	99316	99316	99683
21681	32170	119	applied	\N	\N	\N	\N	99332	99332	99684
21681	32176	120	applied	\N	\N	\N	\N	99350	99350	99685
21681	32178	121	applied	\N	\N	\N	\N	99357	99357	99362
21681	32181	122	applied	\N	\N	\N	\N	99366	99366	99367
21681	32185	123	applied	\N	\N	\N	\N	99375	99375	99686
21681	32189	124	applied	\N	\N	\N	\N	99387	99387	99687
21681	32190	125	applied	\N	\N	\N	\N	99390	99390	99384
21685	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21685	32268	1	applied	\N	\N	\N	\N	99699	99699	99700
21685	32269	2	applied	\N	\N	\N	\N	99701	99701	99702
21685	32270	3	applied	\N	\N	\N	\N	99703	99703	99704
21688	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21688	32268	1	applied	\N	\N	\N	\N	99699	99699	99700
21688	32271	2	applied	\N	\N	\N	\N	99710	99710	99711
21688	32269	3	applied	\N	\N	\N	\N	99701	99701	99702
21688	32272	4	applied	\N	\N	\N	\N	99712	99712	99713
21688	32270	5	applied	\N	\N	\N	\N	99703	99703	99714
21688	32273	6	applied	\N	\N	\N	\N	99715	99715	99716
21690	32276	0	applied	\N	\N	\N	\N	99724	99724	99725
21690	32277	1	applied	\N	\N	\N	\N	99726	99726	99727
21690	32278	2	applied	\N	\N	\N	\N	99728	99728	99729
21690	32279	3	applied	\N	\N	\N	\N	99730	99730	99731
21690	32280	4	applied	\N	\N	\N	\N	99732	99732	99733
21690	32281	5	applied	\N	\N	\N	\N	99734	99734	99735
21690	32282	6	applied	\N	\N	\N	\N	99736	99736	99737
21690	32283	7	applied	\N	\N	\N	\N	99738	99738	99739
21690	32284	8	applied	\N	\N	\N	\N	99740	99740	99741
21690	32285	10	applied	\N	\N	\N	\N	99743	99743	99744
21690	32286	11	applied	\N	\N	\N	\N	99745	99745	99746
21692	32276	0	applied	\N	\N	\N	\N	99724	99724	99725
21692	32277	1	applied	\N	\N	\N	\N	99726	99726	99727
21692	32278	2	applied	\N	\N	\N	\N	99728	99728	99729
21692	32279	3	applied	\N	\N	\N	\N	99730	99730	99731
21692	32280	4	applied	\N	\N	\N	\N	99732	99732	99733
21692	32281	5	applied	\N	\N	\N	\N	99734	99734	99735
21692	32282	6	applied	\N	\N	\N	\N	99736	99736	99737
21692	32283	7	applied	\N	\N	\N	\N	99738	99738	99739
21692	32284	8	applied	\N	\N	\N	\N	99740	99740	99741
21692	32285	10	applied	\N	\N	\N	\N	99743	99743	99744
21692	32286	11	applied	\N	\N	\N	\N	99745	99745	99746
21693	32287	0	applied	\N	\N	\N	\N	99755	99755	99756
21693	32288	1	applied	\N	\N	\N	\N	99757	99757	99758
21693	32289	2	applied	\N	\N	\N	\N	99759	99759	99760
21696	32290	0	applied	\N	\N	\N	\N	99762	99762	99763
21696	32291	1	applied	\N	\N	\N	\N	99764	99764	99765
21696	32292	2	applied	\N	\N	\N	\N	99766	99766	99767
21696	32293	3	applied	\N	\N	\N	\N	99768	99768	99769
21696	32294	4	applied	\N	\N	\N	\N	99770	99770	99771
21696	32295	5	applied	\N	\N	\N	\N	99772	99772	99773
21698	32299	0	applied	\N	\N	\N	\N	99785	99785	99786
21698	32300	1	applied	\N	\N	\N	\N	99787	99787	99788
21698	32301	2	applied	\N	\N	\N	\N	99789	99789	99790
21706	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21706	32321	1	applied	\N	\N	\N	\N	99843	99843	99844
21706	32322	2	applied	\N	\N	\N	\N	99845	99845	99846
21706	32323	3	applied	\N	\N	\N	\N	99847	99847	99848
21706	32324	4	applied	\N	\N	\N	\N	99849	99849	99850
21709	32330	0	applied	\N	\N	\N	\N	99867	99867	99868
21709	32331	1	applied	\N	\N	\N	\N	99869	99869	99870
21709	32332	2	applied	\N	\N	\N	\N	99871	99871	99872
21709	32333	3	applied	\N	\N	\N	\N	99873	99873	99874
21709	32334	4	applied	\N	\N	\N	\N	99875	99875	99876
21711	32330	0	applied	\N	\N	\N	\N	99867	99867	99868
21711	32331	1	applied	\N	\N	\N	\N	99869	99869	99870
21711	32334	2	applied	\N	\N	\N	\N	99875	99875	99880
21713	32335	0	applied	\N	\N	\N	\N	99881	99881	99882
21713	32337	1	applied	\N	\N	\N	\N	99885	99885	99889
21716	32338	0	applied	\N	\N	\N	\N	99892	99892	99893
21716	32339	1	applied	\N	\N	\N	\N	99894	99894	99895
21716	32340	2	applied	\N	\N	\N	\N	99896	99896	99897
21716	32341	3	applied	\N	\N	\N	\N	99898	99898	99899
21716	32342	4	applied	\N	\N	\N	\N	99900	99900	99901
21716	32343	5	applied	\N	\N	\N	\N	99902	99902	99903
21719	32359	0	applied	\N	\N	\N	\N	99940	99940	99941
21719	32360	1	applied	\N	\N	\N	\N	99942	99942	99943
21719	32361	2	applied	\N	\N	\N	\N	99944	99944	99945
21724	32365	0	applied	\N	\N	\N	\N	99958	99958	99959
21724	32366	1	applied	\N	\N	\N	\N	99960	99960	99961
21724	32367	2	applied	\N	\N	\N	\N	99962	99962	99963
21727	32368	0	applied	\N	\N	\N	\N	99967	99967	99968
21727	32369	1	applied	\N	\N	\N	\N	99969	99969	99970
21728	32370	0	applied	\N	\N	\N	\N	99976	99976	99977
21728	32371	1	applied	\N	\N	\N	\N	99978	99978	99979
21742	32387	0	applied	\N	\N	\N	\N	100121	100121	100122
21742	32388	1	applied	\N	\N	\N	\N	100123	100123	100124
21742	32389	2	applied	\N	\N	\N	\N	100125	100125	100126
21745	32387	0	applied	\N	\N	\N	\N	100121	100121	100122
21745	32388	1	applied	\N	\N	\N	\N	100123	100123	100124
21745	32389	2	applied	\N	\N	\N	\N	100125	100125	100126
21746	32390	0	applied	\N	\N	\N	\N	100134	100134	100135
21746	32391	1	applied	\N	\N	\N	\N	100136	100136	100137
21746	32392	2	applied	\N	\N	\N	\N	100138	100138	100139
21751	32399	0	applied	\N	\N	\N	\N	100156	100156	100157
21751	32400	1	applied	\N	\N	\N	\N	100158	100158	100159
21751	32401	2	applied	\N	\N	\N	\N	100160	100160	100161
21753	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21753	32302	1	applied	\N	\N	\N	\N	99799	99799	99800
21753	32305	2	applied	\N	\N	\N	\N	99806	99806	99807
21753	32306	3	applied	\N	\N	\N	\N	99808	99808	99809
21753	32307	4	applied	\N	\N	\N	\N	99810	99810	99811
21753	32308	5	applied	\N	\N	\N	\N	99812	99812	99813
21753	32317	6	applied	\N	\N	\N	\N	99831	99831	99832
21753	32321	7	applied	\N	\N	\N	\N	99843	99843	99844
21753	32322	8	applied	\N	\N	\N	\N	99845	99845	99846
21753	32327	9	applied	\N	\N	\N	\N	99860	99860	99861
21753	32330	10	applied	\N	\N	\N	\N	99867	99867	99868
21753	32331	11	applied	\N	\N	\N	\N	99869	99869	99870
21753	32335	12	applied	\N	\N	\N	\N	99881	99881	99882
21753	32338	13	applied	\N	\N	\N	\N	99892	99892	99893
21753	32339	14	applied	\N	\N	\N	\N	99894	99894	99895
21753	32344	15	applied	\N	\N	\N	\N	99907	99907	99908
21753	32345	16	applied	\N	\N	\N	\N	99909	99909	99910
21753	32346	17	applied	\N	\N	\N	\N	99911	99911	99912
21753	32347	18	applied	\N	\N	\N	\N	99913	99913	99914
21753	32356	19	applied	\N	\N	\N	\N	99932	99932	99933
21753	32359	20	applied	\N	\N	\N	\N	99940	99940	99941
21753	32362	21	applied	\N	\N	\N	\N	99948	99948	99949
21753	32365	22	applied	\N	\N	\N	\N	99958	99958	99959
21753	32381	23	applied	\N	\N	\N	\N	100103	100103	100104
21753	32382	24	applied	\N	\N	\N	\N	100105	100105	100106
21753	32387	25	applied	\N	\N	\N	\N	100121	100121	100122
21753	32390	26	applied	\N	\N	\N	\N	100134	100134	100135
21753	32393	27	applied	\N	\N	\N	\N	100140	100140	100141
21753	32396	28	applied	\N	\N	\N	\N	100148	100148	100149
21753	32399	29	applied	\N	\N	\N	\N	100156	100156	100157
21753	32303	30	applied	\N	\N	\N	\N	99801	99801	99802
21753	32373	31	applied	\N	\N	\N	\N	100071	100071	100072
21753	32313	32	applied	\N	\N	\N	\N	99822	99822	100051
21753	32314	33	applied	\N	\N	\N	\N	99824	99824	99817
21753	32315	34	applied	\N	\N	\N	\N	99826	99826	100054
21753	32316	35	applied	\N	\N	\N	\N	99828	99828	100166
21753	32318	36	applied	\N	\N	\N	\N	99833	99833	100056
21753	32323	37	applied	\N	\N	\N	\N	99847	99847	100167
21753	32324	38	applied	\N	\N	\N	\N	99849	99849	100058
21753	32329	39	applied	\N	\N	\N	\N	99864	99864	99838
21753	32334	40	applied	\N	\N	\N	\N	99875	99875	99839
21753	32337	41	applied	\N	\N	\N	\N	99885	99885	99853
21753	32341	42	applied	\N	\N	\N	\N	99898	99898	100061
21753	32342	43	applied	\N	\N	\N	\N	99900	99900	100168
21753	32349	44	applied	\N	\N	\N	\N	99917	99917	99863
21753	32350	45	applied	\N	\N	\N	\N	99919	99919	99865
21753	32351	46	applied	\N	\N	\N	\N	99921	99921	99880
21753	32354	47	applied	\N	\N	\N	\N	99927	99927	100169
21753	32357	48	applied	\N	\N	\N	\N	99934	99934	99884
21753	32361	49	applied	\N	\N	\N	\N	99944	99944	99886
21753	32363	50	applied	\N	\N	\N	\N	99950	99950	100170
21753	32367	51	applied	\N	\N	\N	\N	99962	99962	100171
21753	32368	52	applied	\N	\N	\N	\N	99967	99967	100172
21753	32370	53	applied	\N	\N	\N	\N	99976	99976	99916
21753	32372	54	applied	\N	\N	\N	\N	100048	100048	99918
21753	32374	55	applied	\N	\N	\N	\N	100073	100073	99920
21753	32375	56	applied	\N	\N	\N	\N	100075	100075	99922
21753	32376	57	applied	\N	\N	\N	\N	100077	100077	100173
21753	32383	58	applied	\N	\N	\N	\N	100107	100107	100174
21753	32384	59	applied	\N	\N	\N	\N	100109	100109	99930
21753	32388	60	applied	\N	\N	\N	\N	100123	100123	99935
21753	32391	61	applied	\N	\N	\N	\N	100136	100136	100175
21753	32394	62	applied	\N	\N	\N	\N	100142	100142	100176
21753	32398	63	applied	\N	\N	\N	\N	100152	100152	100177
21753	32400	64	applied	\N	\N	\N	\N	100158	100158	99953
21753	32304	65	applied	\N	\N	\N	\N	99803	99803	99961
21753	32309	66	applied	\N	\N	\N	\N	99814	99814	100178
21753	32310	67	applied	\N	\N	\N	\N	99816	99816	100179
21753	32311	68	applied	\N	\N	\N	\N	99818	99818	99968
21753	32312	69	applied	\N	\N	\N	\N	99820	99820	99970
21753	32319	70	applied	\N	\N	\N	\N	99837	99837	100180
21753	32325	71	applied	\N	\N	\N	\N	99854	99854	100181
21753	32326	72	applied	\N	\N	\N	\N	99856	99856	100182
21753	32328	73	applied	\N	\N	\N	\N	99862	99862	100070
21753	32332	74	applied	\N	\N	\N	\N	99871	99871	100183
21753	32333	75	applied	\N	\N	\N	\N	99873	99873	100184
21753	32336	76	applied	\N	\N	\N	\N	99883	99883	100076
21753	32340	77	applied	\N	\N	\N	\N	99896	99896	100185
21753	32343	78	applied	\N	\N	\N	\N	99902	99902	100186
21753	32348	79	applied	\N	\N	\N	\N	99915	99915	100187
21753	32352	80	applied	\N	\N	\N	\N	99923	99923	100188
21753	32353	81	applied	\N	\N	\N	\N	99925	99925	100189
21753	32355	82	applied	\N	\N	\N	\N	99929	99929	100190
21753	32358	83	applied	\N	\N	\N	\N	99936	99936	100108
21753	32360	84	applied	\N	\N	\N	\N	99942	99942	100191
21753	32364	85	applied	\N	\N	\N	\N	99952	99952	100192
21753	32366	86	applied	\N	\N	\N	\N	99960	99960	100193
21753	32369	87	applied	\N	\N	\N	\N	99969	99969	100194
21753	32371	88	applied	\N	\N	\N	\N	99978	99978	100124
21753	32377	89	applied	\N	\N	\N	\N	100079	100079	100126
21753	32378	90	applied	\N	\N	\N	\N	100081	100081	100195
21753	32379	91	applied	\N	\N	\N	\N	100083	100083	100196
21753	32380	92	applied	\N	\N	\N	\N	100085	100085	100197
21753	32385	93	applied	\N	\N	\N	\N	100111	100111	100143
21753	32386	94	applied	\N	\N	\N	\N	100113	100113	100145
21753	32389	95	applied	\N	\N	\N	\N	100125	100125	100151
21753	32392	96	applied	\N	\N	\N	\N	100138	100138	100198
21717	32352	8	applied	\N	\N	\N	\N	99923	99923	99924
21717	32353	9	applied	\N	\N	\N	\N	99925	99925	99926
21717	32354	10	applied	\N	\N	\N	\N	99927	99927	99928
21717	32355	11	applied	\N	\N	\N	\N	99929	99929	99930
21720	32362	0	applied	\N	\N	\N	\N	99948	99948	99949
21720	32363	1	applied	\N	\N	\N	\N	99950	99950	99951
21720	32364	2	applied	\N	\N	\N	\N	99952	99952	99953
21722	32365	0	applied	\N	\N	\N	\N	99958	99958	99959
21722	32366	1	applied	\N	\N	\N	\N	99960	99960	99961
21722	32367	2	applied	\N	\N	\N	\N	99962	99962	99963
21733	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21733	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21733	32268	2	applied	\N	\N	\N	\N	99699	99699	99985
21733	32271	3	applied	\N	\N	\N	\N	99710	99710	99986
21733	32278	4	applied	\N	\N	\N	\N	99728	99728	99987
21733	32274	5	applied	\N	\N	\N	\N	99718	99718	99719
21733	32279	6	applied	\N	\N	\N	\N	99730	99730	99988
21733	32280	7	applied	\N	\N	\N	\N	99732	99732	99989
21733	32287	8	applied	\N	\N	\N	\N	99755	99755	99990
21733	32290	9	applied	\N	\N	\N	\N	99762	99762	99991
21733	32291	10	applied	\N	\N	\N	\N	99764	99764	99992
21733	32296	11	applied	\N	\N	\N	\N	99778	99778	99993
21733	32299	12	applied	\N	\N	\N	\N	99785	99785	99994
21733	32302	13	applied	\N	\N	\N	\N	99799	99799	99995
21733	32305	14	applied	\N	\N	\N	\N	99806	99806	99996
21733	32306	15	applied	\N	\N	\N	\N	99808	99808	99997
21733	32307	16	applied	\N	\N	\N	\N	99810	99810	99998
21733	32308	17	applied	\N	\N	\N	\N	99812	99812	99999
21733	32317	18	applied	\N	\N	\N	\N	99831	99831	100000
21733	32321	19	applied	\N	\N	\N	\N	99843	99843	100001
21733	32322	20	applied	\N	\N	\N	\N	99845	99845	100002
21733	32327	21	applied	\N	\N	\N	\N	99860	99860	100003
21733	32330	22	applied	\N	\N	\N	\N	99867	99867	100004
21733	32331	23	applied	\N	\N	\N	\N	99869	99869	100005
21733	32335	24	applied	\N	\N	\N	\N	99881	99881	100006
21733	32338	25	applied	\N	\N	\N	\N	99892	99892	100007
21733	32339	26	applied	\N	\N	\N	\N	99894	99894	100008
21733	32344	27	applied	\N	\N	\N	\N	99907	99907	100009
21733	32345	28	applied	\N	\N	\N	\N	99909	99909	100010
21733	32346	29	applied	\N	\N	\N	\N	99911	99911	100011
21733	32347	30	applied	\N	\N	\N	\N	99913	99913	100012
21733	32356	31	applied	\N	\N	\N	\N	99932	99932	100013
21733	32359	32	applied	\N	\N	\N	\N	99940	99940	100014
21733	32362	33	applied	\N	\N	\N	\N	99948	99948	100015
21733	32365	34	applied	\N	\N	\N	\N	99958	99958	100016
21733	32275	35	applied	\N	\N	\N	\N	99720	99720	99721
21733	32276	36	applied	\N	\N	\N	\N	99724	99724	99725
21733	32277	37	applied	\N	\N	\N	\N	99726	99726	99727
21733	32193	38	applied	\N	\N	\N	\N	99400	99400	99389
21733	32200	39	applied	\N	\N	\N	\N	99416	99416	99391
21733	32201	41	applied	\N	\N	\N	\N	99418	99418	100018
21733	32203	42	applied	\N	\N	\N	\N	99424	99424	100019
21733	32211	43	applied	\N	\N	\N	\N	99465	99465	99413
21733	32212	44	applied	\N	\N	\N	\N	99467	99467	100020
21733	32213	45	applied	\N	\N	\N	\N	99469	99469	100021
21733	32216	46	applied	\N	\N	\N	\N	99478	99478	100022
21733	32220	47	applied	\N	\N	\N	\N	99485	99485	100023
21733	32224	48	applied	\N	\N	\N	\N	99493	99493	99460
21733	32226	49	applied	\N	\N	\N	\N	99499	99499	100024
21733	32230	50	applied	\N	\N	\N	\N	99511	99511	100025
21733	32234	51	applied	\N	\N	\N	\N	99521	99521	100026
21733	32236	52	applied	\N	\N	\N	\N	99529	99529	100027
21733	32241	53	applied	\N	\N	\N	\N	99546	99546	99477
21733	32246	54	applied	\N	\N	\N	\N	99561	99561	99479
21733	32247	55	applied	\N	\N	\N	\N	99563	99563	100028
21733	32249	56	applied	\N	\N	\N	\N	99569	99569	100029
21733	32253	57	applied	\N	\N	\N	\N	99579	99579	100030
21733	32257	58	applied	\N	\N	\N	\N	99590	99590	100031
21733	32260	59	applied	\N	\N	\N	\N	99598	99598	99502
21733	32262	60	applied	\N	\N	\N	\N	99604	99604	99512
21733	32266	61	applied	\N	\N	\N	\N	99693	99693	100032
21733	32270	62	applied	\N	\N	\N	\N	99703	99703	100033
21733	32273	63	applied	\N	\N	\N	\N	99715	99715	99541
21733	32284	64	applied	\N	\N	\N	\N	99740	99740	99532
21733	32285	65	applied	\N	\N	\N	\N	99743	99743	99548
21733	32286	66	applied	\N	\N	\N	\N	99745	99745	100034
21733	32289	67	applied	\N	\N	\N	\N	99759	99759	99560
21733	32292	68	applied	\N	\N	\N	\N	99766	99766	99562
21733	32293	69	applied	\N	\N	\N	\N	99768	99768	99564
21733	32298	70	applied	\N	\N	\N	\N	99782	99782	99570
21733	32300	71	applied	\N	\N	\N	\N	99787	99787	100035
21733	32303	72	applied	\N	\N	\N	\N	99801	99801	100036
21733	32313	73	applied	\N	\N	\N	\N	99822	99822	99589
21733	32314	74	applied	\N	\N	\N	\N	99824	99824	99591
21733	32315	75	applied	\N	\N	\N	\N	99826	99826	100037
21733	32316	76	applied	\N	\N	\N	\N	99828	99828	100038
21733	32318	77	applied	\N	\N	\N	\N	99833	99833	100039
21733	32323	78	applied	\N	\N	\N	\N	99847	99847	99692
21733	32324	79	applied	\N	\N	\N	\N	99849	99849	99694
21733	32329	80	applied	\N	\N	\N	\N	99864	99864	100040
21733	32334	81	applied	\N	\N	\N	\N	99875	99875	100041
21733	32337	82	applied	\N	\N	\N	\N	99885	99885	100042
21733	32341	83	applied	\N	\N	\N	\N	99898	99898	99735
21733	32342	84	applied	\N	\N	\N	\N	99900	99900	100043
21733	32349	85	applied	\N	\N	\N	\N	99917	99917	100044
21733	32350	86	applied	\N	\N	\N	\N	99919	99919	100045
21733	32351	87	applied	\N	\N	\N	\N	99921	99921	100046
21733	32354	88	applied	\N	\N	\N	\N	99927	99927	99758
21733	32357	89	applied	\N	\N	\N	\N	99934	99934	99760
21733	32361	90	applied	\N	\N	\N	\N	99944	99944	99767
21733	32363	91	applied	\N	\N	\N	\N	99950	99950	99769
21733	32367	92	applied	\N	\N	\N	\N	99962	99962	100047
21733	32368	93	applied	\N	\N	\N	\N	99967	99967	99781
21733	32370	94	applied	\N	\N	\N	\N	99976	99976	99783
21733	32372	95	applied	\N	\N	\N	\N	100048	100048	99788
21733	32182	96	applied	\N	\N	\N	\N	99368	99368	99790
21733	32184	97	applied	\N	\N	\N	\N	99373	99373	100049
21733	32187	98	applied	\N	\N	\N	\N	99383	99383	100050
21733	32188	99	applied	\N	\N	\N	\N	99385	99385	100051
21733	32192	100	applied	\N	\N	\N	\N	99397	99397	100052
21733	32198	101	applied	\N	\N	\N	\N	99412	99412	100053
21733	32199	102	applied	\N	\N	\N	\N	99414	99414	100054
21733	32204	103	applied	\N	\N	\N	\N	99426	99426	100055
21733	32208	104	applied	\N	\N	\N	\N	99459	99459	99823
21733	32209	105	applied	\N	\N	\N	\N	99461	99461	100056
21733	32210	106	applied	\N	\N	\N	\N	99463	99463	100057
21733	32215	107	applied	\N	\N	\N	\N	99476	99476	99827
21733	32219	108	applied	\N	\N	\N	\N	99483	99483	100058
21733	32223	109	applied	\N	\N	\N	\N	99491	99491	100059
21733	32227	110	applied	\N	\N	\N	\N	99501	99501	99834
21733	32229	111	applied	\N	\N	\N	\N	99507	99507	99839
21733	32233	112	applied	\N	\N	\N	\N	99519	99519	100060
21733	32237	113	applied	\N	\N	\N	\N	99531	99531	99850
21733	32240	114	applied	\N	\N	\N	\N	99542	99542	100061
21733	32244	115	applied	\N	\N	\N	\N	99557	99557	100062
21733	32245	116	applied	\N	\N	\N	\N	99559	99559	99858
21733	32250	117	applied	\N	\N	\N	\N	99571	99571	99863
21733	32252	118	applied	\N	\N	\N	\N	99577	99577	100063
21733	32256	119	applied	\N	\N	\N	\N	99588	99588	100064
21733	32259	120	applied	\N	\N	\N	\N	99596	99596	99880
21733	32263	121	applied	\N	\N	\N	\N	99606	99606	100065
21733	32265	122	applied	\N	\N	\N	\N	99691	99691	99876
21733	32269	123	applied	\N	\N	\N	\N	99701	99701	99884
21733	32272	124	applied	\N	\N	\N	\N	99712	99712	100066
21733	32281	125	applied	\N	\N	\N	\N	99734	99734	100067
21734	32372	0	applied	\N	\N	\N	\N	100048	100048	100070
21734	32373	1	applied	\N	\N	\N	\N	100071	100071	100072
21734	32374	2	applied	\N	\N	\N	\N	100073	100073	100074
21734	32375	3	applied	\N	\N	\N	\N	100075	100075	100076
21734	32376	4	applied	\N	\N	\N	\N	100077	100077	100078
21734	32377	5	applied	\N	\N	\N	\N	100079	100079	100080
21734	32378	6	applied	\N	\N	\N	\N	100081	100081	100082
21734	32379	7	applied	\N	\N	\N	\N	100083	100083	100084
21734	32380	8	applied	\N	\N	\N	\N	100085	100085	100086
21738	32381	0	applied	\N	\N	\N	\N	100103	100103	100104
21738	32382	1	applied	\N	\N	\N	\N	100105	100105	100106
21738	32383	2	applied	\N	\N	\N	\N	100107	100107	100108
21738	32384	3	applied	\N	\N	\N	\N	100109	100109	100110
21738	32385	4	applied	\N	\N	\N	\N	100111	100111	100112
21738	32386	5	applied	\N	\N	\N	\N	100113	100113	100114
21740	32381	0	applied	\N	\N	\N	\N	100103	100103	100104
21740	32382	1	applied	\N	\N	\N	\N	100105	100105	100106
21740	32383	2	applied	\N	\N	\N	\N	100107	100107	100108
21740	32384	3	applied	\N	\N	\N	\N	100109	100109	100110
21740	32385	4	applied	\N	\N	\N	\N	100111	100111	100112
21740	32386	5	applied	\N	\N	\N	\N	100113	100113	100114
21743	32387	0	applied	\N	\N	\N	\N	100121	100121	100122
21743	32388	1	applied	\N	\N	\N	\N	100123	100123	100124
21743	32389	2	applied	\N	\N	\N	\N	100125	100125	100126
21747	32393	0	applied	\N	\N	\N	\N	100140	100140	100141
21747	32394	1	applied	\N	\N	\N	\N	100142	100142	100143
21747	32395	2	applied	\N	\N	\N	\N	100144	100144	100145
21749	32396	0	applied	\N	\N	\N	\N	100148	100148	100149
21749	32397	1	applied	\N	\N	\N	\N	100150	100150	100151
21749	32398	2	applied	\N	\N	\N	\N	100152	100152	100153
21752	32399	0	applied	\N	\N	\N	\N	100156	100156	100157
21752	32400	1	applied	\N	\N	\N	\N	100158	100158	100159
21752	32401	2	applied	\N	\N	\N	\N	100160	100160	100161
21755	32402	0	applied	\N	\N	\N	\N	100204	100204	100205
21755	32403	1	applied	\N	\N	\N	\N	100206	100206	100207
21755	32404	2	applied	\N	\N	\N	\N	100208	100208	100209
21760	32411	0	applied	\N	\N	\N	\N	100235	100235	100236
21760	32412	1	applied	\N	\N	\N	\N	100237	100237	100238
21762	32411	0	applied	\N	\N	\N	\N	100235	100235	100236
21762	32412	1	applied	\N	\N	\N	\N	100237	100237	100238
21762	32413	2	applied	\N	\N	\N	\N	100241	100241	100242
21767	32420	0	applied	\N	\N	\N	\N	100264	100264	100265
21767	32421	1	applied	\N	\N	\N	\N	100266	100266	100267
21767	32422	2	applied	\N	\N	\N	\N	100268	100268	100269
21767	32423	3	applied	\N	\N	\N	\N	100270	100270	100271
21767	32424	4	applied	\N	\N	\N	\N	100272	100272	100273
21767	32425	5	applied	\N	\N	\N	\N	100274	100274	100275
21735	32376	4	applied	\N	\N	\N	\N	100077	100077	100078
21735	32377	5	applied	\N	\N	\N	\N	100079	100079	100080
21735	32378	6	applied	\N	\N	\N	\N	100081	100081	100082
21735	32379	7	applied	\N	\N	\N	\N	100083	100083	100084
21735	32380	8	applied	\N	\N	\N	\N	100085	100085	100086
21737	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21737	32267	1	applied	\N	\N	\N	\N	100091	100091	99698
21737	31986	2	applied	\N	\N	\N	\N	98658	98658	98659
21737	32167	3	applied	\N	\N	\N	\N	100092	100092	99323
21737	32254	4	applied	\N	\N	\N	\N	99584	99584	99585
21737	32221	5	applied	\N	\N	\N	\N	99488	99488	47675
21737	32218	6	applied	\N	\N	\N	\N	99482	99482	47675
21737	31989	7	applied	\N	\N	\N	\N	98665	98665	98666
21737	31990	8	applied	\N	\N	\N	\N	98667	98667	98668
21737	32196	9	applied	\N	\N	\N	\N	99407	99407	100093
21737	32232	10	applied	\N	\N	1000000000	\N	100094	100094	99518
21737	31996	11	applied	\N	\N	\N	\N	98681	98681	98682
21737	31997	12	applied	\N	\N	\N	\N	98683	98683	98684
21737	32002	13	applied	\N	\N	\N	\N	98694	98694	98695
21737	32006	14	applied	\N	\N	\N	\N	98705	98705	98706
21737	32009	15	applied	\N	\N	\N	\N	98733	98733	98734
21737	32197	16	applied	\N	\N	\N	\N	99409	99409	100095
21737	32012	17	applied	\N	\N	\N	\N	98741	98741	98742
21737	32172	18	applied	\N	\N	\N	\N	100096	100096	99341
21737	32173	19	applied	\N	\N	\N	\N	100097	100097	99343
21737	32174	20	applied	\N	\N	\N	\N	100098	100098	99345
21737	32274	21	applied	\N	\N	\N	\N	99718	99718	99719
21737	32015	22	applied	\N	\N	\N	\N	98753	98753	98754
21737	32019	23	applied	\N	\N	\N	\N	98762	98762	98763
21737	32022	24	applied	\N	\N	\N	\N	98773	98773	98774
21737	32025	25	applied	\N	\N	\N	\N	98783	98783	98784
21737	32026	26	applied	\N	\N	\N	\N	98785	98785	98786
21737	32031	27	applied	\N	\N	\N	\N	98797	98797	98798
21737	32034	28	applied	\N	\N	\N	\N	98806	98806	98807
21737	32037	29	applied	\N	\N	\N	\N	98823	98823	98824
21737	32040	30	applied	\N	\N	\N	\N	98869	98869	98870
21737	32041	31	applied	\N	\N	\N	\N	98871	98871	98872
21737	32042	32	applied	\N	\N	\N	\N	98873	98873	98874
21737	32049	33	applied	\N	\N	\N	\N	98892	98892	98893
21737	32059	34	applied	\N	\N	\N	\N	98939	98939	98940
21737	32062	35	applied	\N	\N	\N	\N	98947	98947	98948
21737	32065	36	applied	\N	\N	\N	\N	98957	98957	98958
21737	32068	37	applied	\N	\N	\N	\N	98966	98966	98967
21737	32071	38	applied	\N	\N	\N	\N	98974	98974	98975
21737	32074	39	applied	\N	\N	\N	\N	98984	98984	98985
21737	32077	40	applied	\N	\N	\N	\N	98996	98996	98997
21737	32080	41	applied	\N	\N	\N	\N	99007	99007	99008
21737	32083	42	applied	\N	\N	\N	\N	99016	99016	99017
21737	32086	43	applied	\N	\N	\N	\N	99026	99026	99027
21737	32089	44	applied	\N	\N	\N	\N	99034	99034	99035
21737	32092	45	applied	\N	\N	\N	\N	99044	99044	99045
21737	32093	46	applied	\N	\N	\N	\N	99048	99048	99236
21737	32094	47	applied	\N	\N	\N	\N	99050	99050	99237
21737	32102	48	applied	\N	\N	\N	\N	99069	99069	99238
21737	32105	49	applied	\N	\N	\N	\N	99078	99078	99239
21737	32108	50	applied	\N	\N	\N	\N	99086	99086	99240
21737	32111	51	applied	\N	\N	\N	\N	99096	99096	99241
21737	32112	52	applied	\N	\N	\N	\N	99098	99098	99242
21737	32118	53	applied	\N	\N	\N	\N	99122	99122	99243
21737	32119	54	applied	\N	\N	\N	\N	99124	99124	99244
21737	32124	55	applied	\N	\N	\N	\N	99139	99139	99245
21737	32127	56	applied	\N	\N	\N	\N	99147	99147	99246
21737	32130	57	applied	\N	\N	\N	\N	99159	99159	99247
21737	32133	58	applied	\N	\N	\N	\N	99172	99172	99248
21737	32136	59	applied	\N	\N	\N	\N	99181	99181	99249
21737	32139	60	applied	\N	\N	\N	\N	99189	99189	99250
21737	32142	61	applied	\N	\N	\N	\N	99196	99196	99251
21737	32145	63	applied	\N	\N	\N	\N	99206	99206	99252
21737	32148	64	applied	\N	\N	\N	\N	99218	99218	99253
21737	32149	65	applied	\N	\N	\N	\N	99220	99220	99616
21737	32154	66	applied	\N	\N	\N	\N	99289	99289	99617
21737	32157	67	applied	\N	\N	\N	\N	99299	99299	99618
21737	32158	68	applied	\N	\N	\N	\N	99301	99301	99619
21737	32164	69	applied	\N	\N	\N	\N	99314	99314	99620
21737	32168	70	applied	\N	\N	\N	\N	99324	99324	99621
21737	32171	71	applied	\N	\N	\N	\N	99338	99338	99622
21737	32177	72	applied	\N	\N	\N	\N	99355	99355	99623
21737	32180	73	applied	\N	\N	\N	\N	99364	99364	99624
21737	32183	74	applied	\N	\N	\N	\N	99371	99371	99625
21737	32186	75	applied	\N	\N	\N	\N	99381	99381	99626
21737	32191	76	applied	\N	\N	\N	\N	99394	99394	99627
21737	32194	77	applied	\N	\N	\N	\N	99403	99403	99628
21737	32195	78	applied	\N	\N	\N	\N	99405	99405	99630
21737	32202	79	applied	\N	\N	\N	\N	99422	99422	99631
21737	32205	80	applied	\N	\N	\N	\N	99453	99453	99632
21737	32206	81	applied	\N	\N	\N	\N	99455	99455	99633
21737	32207	82	applied	\N	\N	\N	\N	99457	99457	99634
21737	32214	83	applied	\N	\N	\N	\N	99474	99474	99635
21737	32217	84	applied	\N	\N	\N	\N	99480	99480	99636
21737	32222	85	applied	\N	\N	\N	\N	99489	99489	99637
21737	32225	86	applied	\N	\N	\N	\N	99497	99497	99638
21737	32228	87	applied	\N	\N	\N	\N	99505	99505	99639
21737	32231	88	applied	\N	\N	\N	\N	99515	99515	99640
21737	32235	89	applied	\N	\N	\N	\N	99525	99525	99641
21737	32239	90	applied	\N	\N	\N	\N	99539	99539	99642
21737	32242	91	applied	\N	\N	\N	\N	99553	99553	99643
21737	32243	92	applied	\N	\N	\N	\N	99555	99555	99644
21737	32248	93	applied	\N	\N	\N	\N	99567	99567	99645
21737	32251	94	applied	\N	\N	\N	\N	99575	99575	99646
21737	32255	95	applied	\N	\N	\N	\N	99586	99586	99647
21737	32258	96	applied	\N	\N	\N	\N	99594	99594	99648
21737	32261	97	applied	\N	\N	\N	\N	99602	99602	99649
21737	32264	98	applied	\N	\N	\N	\N	99650	99650	99651
21737	32268	99	applied	\N	\N	\N	\N	99699	99699	99985
21737	32271	100	applied	\N	\N	\N	\N	99710	99710	99986
21737	32278	101	applied	\N	\N	\N	\N	99728	99728	99987
21737	32279	102	applied	\N	\N	\N	\N	99730	99730	99988
21737	32280	103	applied	\N	\N	\N	\N	99732	99732	99989
21737	32287	104	applied	\N	\N	\N	\N	99755	99755	99990
21737	32290	105	applied	\N	\N	\N	\N	99762	99762	99991
21737	32291	106	applied	\N	\N	\N	\N	99764	99764	99992
21737	32296	107	applied	\N	\N	\N	\N	99778	99778	99993
21737	32299	108	applied	\N	\N	\N	\N	99785	99785	99994
21737	32302	109	applied	\N	\N	\N	\N	99799	99799	99995
21737	32305	110	applied	\N	\N	\N	\N	99806	99806	99996
21737	32306	111	applied	\N	\N	\N	\N	99808	99808	99997
21737	32307	112	applied	\N	\N	\N	\N	99810	99810	99998
21737	32308	113	applied	\N	\N	\N	\N	99812	99812	99999
21737	32317	114	applied	\N	\N	\N	\N	99831	99831	100000
21737	32321	115	applied	\N	\N	\N	\N	99843	99843	100001
21737	32322	116	applied	\N	\N	\N	\N	99845	99845	100002
21737	32327	117	applied	\N	\N	\N	\N	99860	99860	100003
21737	32330	118	applied	\N	\N	\N	\N	99867	99867	100004
21737	32331	119	applied	\N	\N	\N	\N	99869	99869	100005
21737	32335	120	applied	\N	\N	\N	\N	99881	99881	100006
21737	32338	121	applied	\N	\N	\N	\N	99892	99892	100007
21737	32339	122	applied	\N	\N	\N	\N	99894	99894	100008
21737	32344	123	applied	\N	\N	\N	\N	99907	99907	100009
21737	32345	124	applied	\N	\N	\N	\N	99909	99909	100010
21737	32346	125	applied	\N	\N	\N	\N	99911	99911	100011
21744	32387	0	applied	\N	\N	\N	\N	100121	100121	100122
21744	32388	1	applied	\N	\N	\N	\N	100123	100123	100124
21744	32389	2	applied	\N	\N	\N	\N	100125	100125	100126
21748	32393	0	applied	\N	\N	\N	\N	100140	100140	100141
21748	32394	1	applied	\N	\N	\N	\N	100142	100142	100143
21748	32395	2	applied	\N	\N	\N	\N	100144	100144	100145
21758	32408	0	applied	\N	\N	\N	\N	100221	100221	100222
21758	32409	1	applied	\N	\N	\N	\N	100223	100223	100224
21758	32410	2	applied	\N	\N	\N	\N	100225	100225	100226
21761	32411	0	applied	\N	\N	\N	\N	100235	100235	100236
21761	32412	1	applied	\N	\N	\N	\N	100237	100237	100238
21761	32413	2	applied	\N	\N	\N	\N	100241	100241	100242
21765	32417	0	applied	\N	\N	\N	\N	100254	100254	100255
21765	32418	1	applied	\N	\N	\N	\N	100256	100256	100257
21765	32419	2	applied	\N	\N	\N	\N	100258	100258	100259
21772	32429	0	applied	\N	\N	\N	\N	100292	100292	100293
21772	32430	1	applied	\N	\N	\N	\N	100294	100294	100295
21772	32431	2	applied	\N	\N	\N	\N	100296	100296	100297
21774	32432	0	applied	\N	\N	\N	\N	100299	100299	100300
21774	32433	1	applied	\N	\N	\N	\N	100301	100301	100302
21774	32434	2	applied	\N	\N	\N	\N	100303	100303	100304
21775	32435	0	applied	\N	\N	\N	\N	100307	100307	100308
21775	32436	1	applied	\N	\N	\N	\N	100309	100309	100310
21775	32437	2	applied	\N	\N	\N	\N	100311	100311	100312
21775	32438	3	applied	\N	\N	\N	\N	100313	100313	100314
21775	32439	4	applied	\N	\N	\N	\N	100315	100315	100316
21775	32440	5	applied	\N	\N	\N	\N	100317	100317	100318
21775	32441	6	applied	\N	\N	\N	\N	100319	100319	100320
21775	32442	7	applied	\N	\N	\N	\N	100321	100321	100322
21775	32443	8	applied	\N	\N	\N	\N	100323	100323	100324
21753	32395	97	applied	\N	\N	\N	\N	100144	100144	100199
21753	32397	98	applied	\N	\N	\N	\N	100150	100150	100159
21753	32401	99	applied	\N	\N	\N	\N	100160	100160	100161
21757	32405	0	applied	\N	\N	\N	\N	100213	100213	100214
21757	32406	1	applied	\N	\N	\N	\N	100215	100215	100216
21757	32407	2	applied	\N	\N	\N	\N	100217	100217	100218
21759	32402	0	applied	\N	\N	\N	\N	100204	100204	100205
21759	32405	1	applied	\N	\N	\N	\N	100213	100213	100214
21759	32408	2	applied	\N	\N	\N	\N	100221	100221	100222
21759	32403	3	applied	\N	\N	\N	\N	100206	100206	100207
21759	32406	4	applied	\N	\N	\N	\N	100215	100215	100229
21759	32410	5	applied	\N	\N	\N	\N	100225	100225	100230
21759	32404	6	applied	\N	\N	\N	\N	100208	100208	100231
21759	32407	7	applied	\N	\N	\N	\N	100217	100217	100232
21759	32409	8	applied	\N	\N	\N	\N	100223	100223	100226
21766	32417	0	applied	\N	\N	\N	\N	100254	100254	100255
21766	32418	1	applied	\N	\N	\N	\N	100256	100256	100257
21766	32419	2	applied	\N	\N	\N	\N	100258	100258	100259
21769	32420	0	applied	\N	\N	\N	\N	100264	100264	100265
21769	32421	1	applied	\N	\N	\N	\N	100266	100266	100267
21769	32422	2	applied	\N	\N	\N	\N	100268	100268	100269
21769	32423	3	applied	\N	\N	\N	\N	100270	100270	100271
21769	32424	4	applied	\N	\N	\N	\N	100272	100272	100273
21769	32425	5	applied	\N	\N	\N	\N	100274	100274	100275
21771	32426	0	applied	\N	\N	\N	\N	100282	100282	100283
21771	32427	1	applied	\N	\N	\N	\N	100284	100284	100285
21771	32428	2	applied	\N	\N	\N	\N	100286	100286	100287
21776	32381	0	applied	\N	\N	\N	\N	100103	100103	100327
21776	32382	1	applied	\N	\N	\N	\N	100105	100105	100328
21776	32387	2	applied	\N	\N	\N	\N	100121	100121	100329
21776	32390	3	applied	\N	\N	\N	\N	100134	100134	100330
21776	32393	4	applied	\N	\N	\N	\N	100140	100140	100331
21776	32396	5	applied	\N	\N	\N	\N	100148	100148	100332
21776	32399	6	applied	\N	\N	\N	\N	100156	100156	100333
21776	32402	7	applied	\N	\N	\N	\N	100204	100204	100334
21776	32405	8	applied	\N	\N	\N	\N	100213	100213	100335
21776	32408	9	applied	\N	\N	\N	\N	100221	100221	100336
21776	32411	10	applied	\N	\N	\N	\N	100235	100235	100337
21776	32414	11	applied	\N	\N	\N	\N	100246	100246	100338
21776	32417	12	applied	\N	\N	\N	\N	100254	100254	100339
21776	32420	13	applied	\N	\N	\N	\N	100264	100264	100340
21776	32421	14	applied	\N	\N	\N	\N	100266	100266	100341
21776	32426	15	applied	\N	\N	\N	\N	100282	100282	100342
21776	32429	16	applied	\N	\N	\N	\N	100292	100292	100343
21776	32432	17	applied	\N	\N	\N	\N	100299	100299	100344
21776	32435	18	applied	\N	\N	\N	\N	100307	100307	100345
21776	32436	19	applied	\N	\N	\N	\N	100309	100309	100346
21776	32437	20	applied	\N	\N	\N	\N	100311	100311	100347
21776	32444	21	applied	\N	\N	\N	\N	100348	100348	100349
21776	32282	22	applied	\N	\N	\N	\N	99736	99736	100170
21776	32283	23	applied	\N	\N	\N	\N	99738	99738	99899
21776	32373	24	applied	\N	\N	\N	\N	100071	100071	100072
21776	32374	25	applied	\N	\N	\N	\N	100073	100073	99901
21776	32375	26	applied	\N	\N	\N	\N	100075	100075	100350
21776	32376	27	applied	\N	\N	\N	\N	100077	100077	100351
21776	32383	28	applied	\N	\N	\N	\N	100107	100107	100352
21776	32288	29	applied	\N	\N	\N	\N	99757	99757	100353
21776	32294	30	applied	\N	\N	\N	\N	99770	99770	99922
21776	32295	31	applied	\N	\N	\N	\N	99772	99772	99924
21776	32297	32	applied	\N	\N	\N	\N	99780	99780	99926
21776	32301	33	applied	\N	\N	\N	\N	99789	99789	100174
21776	32384	34	applied	\N	\N	\N	\N	100109	100109	99930
21776	32388	35	applied	\N	\N	\N	\N	100123	100123	99935
21776	32391	36	applied	\N	\N	\N	\N	100136	100136	100175
21776	32394	37	applied	\N	\N	\N	\N	100142	100142	100176
21776	32398	38	applied	\N	\N	\N	\N	100152	100152	100177
21776	32400	39	applied	\N	\N	\N	\N	100158	100158	99953
21776	32404	41	applied	\N	\N	\N	\N	100208	100208	100355
21776	32407	42	applied	\N	\N	\N	\N	100217	100217	100179
21776	32409	43	applied	\N	\N	\N	\N	100223	100223	100356
21776	32412	44	applied	\N	\N	\N	\N	100237	100237	100180
21776	32415	45	applied	\N	\N	\N	\N	100248	100248	99979
21776	32418	46	applied	\N	\N	\N	\N	100256	100256	100070
21776	32422	47	applied	\N	\N	\N	\N	100268	100268	100074
21776	32425	48	applied	\N	\N	\N	\N	100274	100274	100076
21776	32427	49	applied	\N	\N	\N	\N	100284	100284	100078
21776	32430	50	applied	\N	\N	\N	\N	100294	100294	100187
21776	32433	51	applied	\N	\N	\N	\N	100301	100301	100084
21776	32304	52	applied	\N	\N	\N	\N	99803	99803	100086
21776	32309	53	applied	\N	\N	\N	\N	99814	99814	100357
21776	32310	54	applied	\N	\N	\N	\N	99816	99816	100358
21776	32311	55	applied	\N	\N	\N	\N	99818	99818	100110
21776	32312	56	applied	\N	\N	\N	\N	99820	99820	100112
21776	32319	57	applied	\N	\N	\N	\N	99837	99837	100114
21776	32325	58	applied	\N	\N	\N	\N	99854	99854	100359
21776	32326	59	applied	\N	\N	\N	\N	99856	99856	100360
21776	32328	60	applied	\N	\N	\N	\N	99862	99862	100361
21776	32332	61	applied	\N	\N	\N	\N	99871	99871	100137
21776	32333	62	applied	\N	\N	\N	\N	99873	99873	100139
21776	32336	63	applied	\N	\N	\N	\N	99883	99883	100362
21776	32340	64	applied	\N	\N	\N	\N	99896	99896	100363
21776	32441	65	applied	\N	\N	\N	\N	100319	100319	100151
21776	32442	66	applied	\N	\N	\N	\N	100321	100321	100153
21776	32443	67	applied	\N	\N	\N	\N	100323	100323	100159
21776	32445	68	applied	\N	\N	\N	\N	100364	100364	100365
21776	32343	69	applied	\N	\N	\N	\N	99902	99902	100366
21777	32444	0	applied	\N	\N	\N	\N	100348	100348	100369
21777	32446	1	applied	\N	\N	\N	\N	100370	100370	100371
21777	32445	2	applied	\N	\N	\N	\N	100364	100364	100372
21777	32447	3	applied	\N	\N	\N	\N	100373	100373	100374
21777	32448	4	applied	\N	\N	\N	\N	100375	100375	100376
21777	32449	5	applied	\N	\N	\N	\N	100377	100377	100378
21779	32450	0	applied	\N	\N	\N	\N	100380	100380	100381
21779	32451	1	applied	\N	\N	\N	\N	100382	100382	100383
21779	32452	2	applied	\N	\N	\N	\N	100384	100384	100385
21780	32453	0	applied	\N	\N	\N	\N	100386	100386	100387
21780	32454	1	applied	\N	\N	\N	\N	100388	100388	100389
21780	32455	2	applied	\N	\N	\N	\N	100390	100390	100391
21781	32453	0	applied	\N	\N	\N	\N	100386	100386	100387
21781	32454	1	applied	\N	\N	\N	\N	100388	100388	100389
21781	32455	2	applied	\N	\N	\N	\N	100390	100390	100391
21783	32453	0	applied	\N	\N	\N	\N	100386	100386	100387
21783	32454	1	applied	\N	\N	\N	\N	100388	100388	100389
21783	32455	2	applied	\N	\N	\N	\N	100390	100390	100391
21784	32453	0	applied	\N	\N	\N	\N	100386	100386	100387
21784	32455	1	applied	\N	\N	\N	\N	100390	100390	100397
21785	32453	0	applied	\N	\N	\N	\N	100386	100386	100387
21785	32454	1	applied	\N	\N	\N	\N	100388	100388	100389
21785	32455	2	applied	\N	\N	\N	\N	100390	100390	100391
21786	32456	0	applied	\N	\N	\N	\N	100400	100400	100401
21786	32454	1	applied	\N	\N	\N	\N	100388	100388	100391
21786	32457	3	applied	\N	\N	\N	\N	100403	100403	100404
21789	32461	0	applied	\N	\N	\N	\N	100417	100417	100418
21789	32462	1	applied	\N	\N	\N	\N	100419	100419	100420
21789	32463	2	applied	\N	\N	\N	\N	100421	100421	100422
21789	32464	3	applied	\N	\N	\N	\N	100423	100423	100424
21789	32465	4	applied	\N	\N	\N	\N	100425	100425	100426
21789	32466	5	applied	\N	\N	\N	\N	100427	100427	100428
21789	32467	6	applied	\N	\N	\N	\N	100429	100429	100430
21789	32468	7	applied	\N	\N	\N	\N	100431	100431	100432
21794	32476	0	applied	\N	\N	\N	\N	100484	100484	100485
21794	32477	1	applied	\N	\N	\N	\N	100486	100486	100487
21794	32478	2	applied	\N	\N	\N	\N	100488	100488	100489
21794	32479	3	applied	\N	\N	\N	\N	100490	100490	100491
21794	32480	4	applied	\N	\N	\N	\N	100492	100492	100493
21794	32481	5	applied	\N	\N	\N	\N	100494	100494	100495
21796	32365	0	applied	\N	\N	\N	\N	99958	99958	99959
21796	32381	1	applied	\N	\N	\N	\N	100103	100103	100104
21796	32382	2	applied	\N	\N	\N	\N	100105	100105	100106
21796	32387	3	applied	\N	\N	\N	\N	100121	100121	100122
21796	32390	4	applied	\N	\N	\N	\N	100134	100134	100135
21796	32393	5	applied	\N	\N	\N	\N	100140	100140	100141
21796	32396	6	applied	\N	\N	\N	\N	100148	100148	100149
21796	32399	7	applied	\N	\N	\N	\N	100156	100156	100157
21796	32402	8	applied	\N	\N	\N	\N	100204	100204	100205
21796	32405	9	applied	\N	\N	\N	\N	100213	100213	100214
21796	32408	10	applied	\N	\N	\N	\N	100221	100221	100222
21796	32411	11	applied	\N	\N	\N	\N	100235	100235	100236
21796	32414	12	applied	\N	\N	\N	\N	100246	100246	100247
21796	32417	14	applied	\N	\N	\N	\N	100254	100254	100255
21796	32420	15	applied	\N	\N	\N	\N	100264	100264	100265
21796	32421	16	applied	\N	\N	\N	\N	100266	100266	100267
21796	32426	17	applied	\N	\N	\N	\N	100282	100282	100283
21796	32429	18	applied	\N	\N	\N	\N	100292	100292	100293
21796	32432	19	applied	\N	\N	\N	\N	100299	100299	100300
21796	32435	20	applied	\N	\N	\N	\N	100307	100307	100308
21796	32436	21	applied	\N	\N	\N	\N	100309	100309	100310
21796	32437	22	applied	\N	\N	\N	\N	100311	100311	100312
21796	32444	23	applied	\N	\N	\N	\N	100348	100348	100369
21796	32446	24	applied	\N	\N	\N	\N	100370	100370	100371
21796	32450	25	applied	\N	\N	\N	\N	100380	100380	100381
21796	32453	26	applied	\N	\N	\N	\N	100386	100386	100387
21796	32456	27	applied	\N	\N	\N	\N	100400	100400	100401
21796	32458	28	applied	\N	\N	\N	\N	100407	100407	100408
21796	32461	29	applied	\N	\N	\N	\N	100417	100417	100418
21796	32462	30	applied	\N	\N	\N	\N	100419	100419	100420
21796	32469	31	applied	\N	\N	\N	\N	100436	100436	100437
21796	32476	32	applied	\N	\N	\N	\N	100484	100484	100485
21796	32477	33	applied	\N	\N	\N	\N	100486	100486	100487
21796	32482	34	applied	\N	\N	\N	\N	100498	100498	100499
21796	32366	35	applied	\N	\N	\N	\N	99960	99960	99961
21796	32373	36	applied	\N	\N	\N	\N	100071	100071	100072
21796	32470	37	applied	\N	\N	\N	\N	100438	100438	100439
21796	32471	38	applied	\N	\N	\N	\N	100440	100440	100441
21796	32472	39	applied	\N	\N	\N	\N	100442	100442	100443
21796	32474	40	applied	\N	\N	\N	\N	100446	100446	100447
21796	32367	41	applied	\N	\N	\N	\N	99962	99962	99963
21796	32368	42	applied	\N	\N	\N	\N	99967	99967	99968
21796	32370	43	applied	\N	\N	\N	\N	99976	99976	100503
21796	32372	44	applied	\N	\N	\N	\N	100048	100048	100181
21796	32374	45	applied	\N	\N	\N	\N	100073	100073	100504
21796	32375	46	applied	\N	\N	\N	\N	100075	100075	100183
21796	32376	47	applied	\N	\N	\N	\N	100077	100077	100505
21796	32383	48	applied	\N	\N	\N	\N	100107	100107	100185
21796	32384	49	applied	\N	\N	\N	\N	100109	100109	100080
21796	32388	50	applied	\N	\N	\N	\N	100123	100123	100188
21796	32391	51	applied	\N	\N	\N	\N	100136	100136	100086
21796	32394	52	applied	\N	\N	\N	\N	100142	100142	100108
21796	32398	53	applied	\N	\N	\N	\N	100152	100152	100110
21796	32400	54	applied	\N	\N	\N	\N	100158	100158	100193
21796	32404	55	applied	\N	\N	\N	\N	100208	100208	100359
21796	32407	56	applied	\N	\N	\N	\N	100217	100217	100126
21796	32409	57	applied	\N	\N	\N	\N	100223	100223	100137
21796	32412	58	applied	\N	\N	\N	\N	100237	100237	100197
21796	32415	59	applied	\N	\N	\N	\N	100248	100248	100363
21796	32418	60	applied	\N	\N	\N	\N	100256	100256	100151
21796	32422	61	applied	\N	\N	\N	\N	100268	100268	100153
21796	32425	62	applied	\N	\N	\N	\N	100274	100274	100159
21796	32427	63	applied	\N	\N	\N	\N	100284	100284	100365
21796	32430	64	applied	\N	\N	\N	\N	100294	100294	100229
21796	32433	65	applied	\N	\N	\N	\N	100301	100301	100216
21796	32441	66	applied	\N	\N	\N	\N	100319	100319	100218
21796	32442	67	applied	\N	\N	\N	\N	100321	100321	100224
21796	32443	68	applied	\N	\N	\N	\N	100323	100323	100451
21796	32445	69	applied	\N	\N	\N	\N	100364	100364	100452
21796	32447	70	applied	\N	\N	\N	\N	100373	100373	100453
21796	32451	71	applied	\N	\N	\N	\N	100382	100382	100251
21796	32455	72	applied	\N	\N	\N	\N	100390	100390	100257
21796	32460	73	applied	\N	\N	\N	\N	100411	100411	100506
21796	32463	74	applied	\N	\N	\N	\N	100421	100421	100507
21796	32467	75	applied	\N	\N	\N	\N	100429	100429	100273
21796	32468	76	applied	\N	\N	\N	\N	100431	100431	100275
21796	32475	77	applied	\N	\N	\N	\N	100448	100448	100285
21796	32480	78	applied	\N	\N	\N	\N	100492	100492	100508
21796	32481	79	applied	\N	\N	\N	\N	100494	100494	100460
21796	32483	80	applied	\N	\N	\N	\N	100509	100509	100510
21796	32369	81	applied	\N	\N	\N	\N	99969	99969	100511
21796	32371	82	applied	\N	\N	\N	\N	99978	99978	100462
21796	32377	83	applied	\N	\N	\N	\N	100079	100079	100512
21796	32378	84	applied	\N	\N	\N	\N	100081	100081	100513
21796	32379	85	applied	\N	\N	\N	\N	100083	100083	100463
21796	32380	86	applied	\N	\N	\N	\N	100085	100085	100320
21796	32385	87	applied	\N	\N	\N	\N	100111	100111	100514
21796	32386	88	applied	\N	\N	\N	\N	100113	100113	100465
21796	32389	89	applied	\N	\N	\N	\N	100125	100125	100324
21796	32392	90	applied	\N	\N	\N	\N	100138	100138	100515
21796	32395	91	applied	\N	\N	\N	\N	100144	100144	100467
21796	32397	92	applied	\N	\N	\N	\N	100150	100150	100374
21796	32401	93	applied	\N	\N	\N	\N	100160	100160	100376
21796	32403	94	applied	\N	\N	\N	\N	100206	100206	100378
21796	32406	95	applied	\N	\N	\N	\N	100215	100215	100516
21796	32410	96	applied	\N	\N	\N	\N	100225	100225	100517
21796	32413	97	applied	\N	\N	\N	\N	100241	100241	100469
21796	32416	98	applied	\N	\N	\N	\N	100250	100250	100397
21796	32419	99	applied	\N	\N	\N	\N	100258	100258	100391
21796	32423	100	applied	\N	\N	\N	\N	100270	100270	100404
21796	32424	101	applied	\N	\N	\N	\N	100272	100272	100410
21796	32428	102	applied	\N	\N	\N	\N	100286	100286	100518
21796	32431	103	applied	\N	\N	\N	\N	100296	100296	100519
21796	32434	104	applied	\N	\N	\N	\N	100303	100303	100422
21787	32458	0	applied	\N	\N	\N	\N	100407	100407	100408
21787	32459	1	applied	\N	\N	\N	\N	100409	100409	100410
21787	32460	2	applied	\N	\N	\N	\N	100411	100411	100412
21792	32408	0	applied	\N	\N	\N	\N	100221	100221	100222
21792	32411	1	applied	\N	\N	\N	\N	100235	100235	100236
21792	32414	2	applied	\N	\N	\N	\N	100246	100246	100247
21792	32417	3	applied	\N	\N	\N	\N	100254	100254	100255
21792	32420	4	applied	\N	\N	\N	\N	100264	100264	100265
21792	32421	5	applied	\N	\N	\N	\N	100266	100266	100267
21792	32426	6	applied	\N	\N	\N	\N	100282	100282	100283
21792	32429	7	applied	\N	\N	\N	\N	100292	100292	100293
21792	32432	8	applied	\N	\N	\N	\N	100299	100299	100300
21792	32435	9	applied	\N	\N	\N	\N	100307	100307	100308
21792	32436	10	applied	\N	\N	\N	\N	100309	100309	100310
21792	32437	11	applied	\N	\N	\N	\N	100311	100311	100312
21792	32444	12	applied	\N	\N	\N	\N	100348	100348	100369
21792	32446	13	applied	\N	\N	\N	\N	100370	100370	100371
21792	32450	14	applied	\N	\N	\N	\N	100380	100380	100381
21792	32453	15	applied	\N	\N	\N	\N	100386	100386	100387
21792	32456	16	applied	\N	\N	\N	\N	100400	100400	100401
21792	32458	17	applied	\N	\N	\N	\N	100407	100407	100408
21792	32461	18	applied	\N	\N	\N	\N	100417	100417	100418
21792	32462	19	applied	\N	\N	\N	\N	100419	100419	100420
21792	32469	20	applied	\N	\N	\N	\N	100436	100436	100437
21792	32409	21	applied	\N	\N	\N	\N	100223	100223	100224
21792	32412	22	applied	\N	\N	\N	\N	100237	100237	100451
21792	32415	23	applied	\N	\N	\N	\N	100248	100248	100452
21792	32418	24	applied	\N	\N	\N	\N	100256	100256	100453
21792	32422	25	applied	\N	\N	\N	\N	100268	100268	100251
21792	32470	26	applied	\N	\N	\N	\N	100438	100438	100439
21792	32471	27	applied	\N	\N	\N	\N	100440	100440	100441
21792	32472	28	applied	\N	\N	\N	\N	100442	100442	100443
21792	32474	29	applied	\N	\N	\N	\N	100446	100446	100447
21792	32410	30	applied	\N	\N	\N	\N	100225	100225	100454
21792	32413	31	applied	\N	\N	\N	\N	100241	100241	100455
21792	32425	32	applied	\N	\N	\N	\N	100274	100274	100456
21792	32427	33	applied	\N	\N	\N	\N	100284	100284	100271
21792	32430	34	applied	\N	\N	\N	\N	100294	100294	100457
21792	32433	35	applied	\N	\N	\N	\N	100301	100301	100458
21792	32416	36	applied	\N	\N	\N	\N	100250	100250	100285
21792	32419	37	applied	\N	\N	\N	\N	100258	100258	100287
21792	32423	38	applied	\N	\N	\N	\N	100270	100270	100459
21792	32424	39	applied	\N	\N	\N	\N	100272	100272	100460
21792	32428	40	applied	\N	\N	\N	\N	100286	100286	100461
21792	32431	41	applied	\N	\N	\N	\N	100296	100296	100302
21792	32441	42	applied	\N	\N	\N	\N	100319	100319	100462
21792	32442	43	applied	\N	\N	\N	\N	100321	100321	100316
21792	32443	44	applied	\N	\N	\N	\N	100323	100323	100463
21792	32445	45	applied	\N	\N	\N	\N	100364	100364	100464
21792	32447	46	applied	\N	\N	\N	\N	100373	100373	100465
21792	32451	47	applied	\N	\N	\N	\N	100382	100382	100466
21792	32455	48	applied	\N	\N	\N	\N	100390	100390	100467
21792	32460	49	applied	\N	\N	\N	\N	100411	100411	100468
21792	32463	50	applied	\N	\N	\N	\N	100421	100421	100378
21792	32467	51	applied	\N	\N	\N	\N	100429	100429	100383
21792	32468	52	applied	\N	\N	\N	\N	100431	100431	100469
21792	32475	53	applied	\N	\N	\N	\N	100448	100448	100470
21792	32434	54	applied	\N	\N	\N	\N	100303	100303	100471
21792	32438	55	applied	\N	\N	\N	\N	100313	100313	100472
21792	32439	56	applied	\N	\N	\N	\N	100315	100315	100473
21792	32440	57	applied	\N	\N	\N	\N	100317	100317	100412
21792	32448	58	applied	\N	\N	\N	\N	100375	100375	100474
21792	32449	59	applied	\N	\N	\N	\N	100377	100377	100475
21792	32452	60	applied	\N	\N	\N	\N	100384	100384	100476
21792	32454	61	applied	\N	\N	\N	\N	100388	100388	100477
21792	32457	62	applied	\N	\N	\N	\N	100403	100403	100478
21792	32459	63	applied	\N	\N	\N	\N	100409	100409	100430
21792	32464	64	applied	\N	\N	\N	\N	100423	100423	100479
21792	32465	65	applied	\N	\N	\N	\N	100425	100425	100480
21792	32466	66	applied	\N	\N	\N	\N	100427	100427	100481
21792	32473	67	applied	\N	\N	\N	\N	100444	100444	100449
21797	32482	0	applied	\N	\N	\N	\N	100498	100498	100499
21797	32485	1	applied	\N	\N	\N	\N	100533	100533	100534
21797	32484	2	applied	\N	\N	\N	\N	100529	100529	100535
21797	32483	3	applied	\N	\N	\N	\N	100509	100509	100530
21797	32486	4	applied	\N	\N	\N	\N	100536	100536	100537
21797	32487	5	applied	\N	\N	\N	\N	100538	100538	100539
21801	32488	0	applied	\N	\N	\N	\N	100546	100546	100547
21801	32489	1	applied	\N	\N	\N	\N	100548	100548	100549
21801	32490	2	applied	\N	\N	\N	\N	100550	100550	100551
21806	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21806	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21806	32254	2	applied	\N	\N	\N	\N	99584	99584	99585
21806	32274	3	applied	\N	\N	\N	\N	100571	100571	99719
21806	32275	4	applied	\N	\N	\N	\N	100572	100572	99721
21806	32276	5	applied	\N	\N	\N	\N	100573	100573	99725
21806	32277	6	applied	\N	\N	\N	\N	100574	100574	99727
21806	32373	7	applied	\N	\N	\N	\N	100071	100071	100072
21806	32470	8	applied	\N	\N	\N	\N	100438	100438	100439
21806	32471	9	applied	\N	\N	\N	\N	100440	100440	100441
21806	32472	10	applied	\N	\N	\N	\N	100442	100442	100443
21806	32474	11	applied	\N	\N	\N	\N	100446	100446	100447
21808	32497	0	applied	\N	\N	\N	\N	100576	100576	100577
21808	32498	1	applied	\N	\N	\N	\N	100578	100578	100579
21808	32499	2	applied	\N	\N	\N	\N	100580	100580	100581
21808	32500	3	applied	\N	\N	\N	\N	100582	100582	100583
21808	32501	4	applied	\N	\N	\N	\N	100584	100584	100585
21808	32502	5	applied	\N	\N	\N	\N	100586	100586	100587
21810	32506	0	applied	\N	\N	\N	\N	100599	100599	100600
21810	32507	1	applied	\N	\N	\N	\N	100601	100601	100602
21810	32508	2	applied	\N	\N	\N	\N	100603	100603	100604
21812	32506	0	applied	\N	\N	\N	\N	100599	100599	100600
21812	32507	1	applied	\N	\N	\N	\N	100601	100601	100602
21812	32508	2	applied	\N	\N	\N	\N	100603	100603	100604
21820	32527	0	applied	\N	\N	\N	\N	100650	100650	100651
21820	32528	1	applied	\N	\N	\N	\N	100652	100652	100653
21820	32529	2	applied	\N	\N	\N	\N	100654	100654	100655
21820	32530	3	applied	\N	\N	\N	\N	100656	100656	100657
21820	32531	4	applied	\N	\N	\N	\N	100658	100658	100659
21820	32532	5	applied	\N	\N	\N	\N	100660	100660	100661
21827	32551	0	applied	\N	\N	\N	\N	100705	100705	100706
21827	32552	1	applied	\N	\N	\N	\N	100707	100707	100708
21827	32553	2	applied	\N	\N	\N	\N	100709	100709	100710
21827	32554	3	applied	\N	\N	\N	\N	100711	100711	100712
21827	32555	4	applied	\N	\N	\N	\N	100713	100713	100714
21827	32556	5	applied	\N	\N	\N	\N	100715	100715	100716
21829	32559	0	applied	\N	\N	\N	\N	100727	100727	100728
21829	32560	1	applied	\N	\N	\N	\N	100729	100729	100730
21829	32561	2	applied	\N	\N	\N	\N	100731	100731	100732
21829	32562	3	applied	\N	\N	\N	\N	100733	100733	100734
21788	32458	0	applied	\N	\N	\N	\N	100407	100407	100408
21788	32459	1	applied	\N	\N	\N	\N	100409	100409	100410
21788	32460	2	applied	\N	\N	\N	\N	100411	100411	100412
21790	32461	0	applied	\N	\N	\N	\N	100417	100417	100418
21790	32462	1	applied	\N	\N	\N	\N	100419	100419	100420
21790	32463	2	applied	\N	\N	\N	\N	100421	100421	100422
21790	32464	3	applied	\N	\N	\N	\N	100423	100423	100424
21790	32465	4	applied	\N	\N	\N	\N	100425	100425	100426
21790	32466	5	applied	\N	\N	\N	\N	100427	100427	100428
21790	32467	6	applied	\N	\N	\N	\N	100429	100429	100430
21790	32468	7	applied	\N	\N	\N	\N	100431	100431	100432
21795	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21795	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21795	32254	2	applied	\N	\N	\N	\N	99584	99584	99585
21795	32221	3	applied	\N	\N	\N	\N	99488	99488	47675
21795	32218	4	applied	\N	\N	\N	\N	99482	99482	47675
21795	32196	5	applied	\N	\N	\N	\N	99407	99407	99610
21795	32232	6	applied	\N	\N	1000000000	\N	99517	99517	99518
21795	32197	7	applied	\N	\N	\N	\N	99409	99409	99612
21795	32171	8	applied	\N	\N	\N	\N	99338	99338	99339
21795	32177	9	applied	\N	\N	\N	\N	99355	99355	99356
21795	32180	10	applied	\N	\N	\N	\N	99364	99364	99365
21795	32183	11	applied	\N	\N	\N	\N	99371	99371	99372
21795	32186	12	applied	\N	\N	\N	\N	99381	99381	99382
21795	32191	13	applied	\N	\N	\N	\N	99394	99394	99395
21795	32194	14	applied	\N	\N	\N	\N	99403	99403	99404
21795	32195	15	applied	\N	\N	\N	\N	99405	99405	99406
21795	32202	16	applied	\N	\N	\N	\N	99422	99422	99423
21795	32205	17	applied	\N	\N	\N	\N	99453	99453	99454
21795	32206	18	applied	\N	\N	\N	\N	99455	99455	99456
21795	32207	19	applied	\N	\N	\N	\N	99457	99457	99458
21795	32214	20	applied	\N	\N	\N	\N	99474	99474	99475
21795	32217	21	applied	\N	\N	\N	\N	99480	99480	99481
21795	32222	22	applied	\N	\N	\N	\N	99489	99489	99490
21795	32225	23	applied	\N	\N	\N	\N	99497	99497	99498
21795	32228	24	applied	\N	\N	\N	\N	99505	99505	99506
21795	32231	25	applied	\N	\N	\N	\N	99515	99515	99516
21795	32235	26	applied	\N	\N	\N	\N	99525	99525	99526
21795	32239	27	applied	\N	\N	\N	\N	99539	99539	99540
21795	32242	28	applied	\N	\N	\N	\N	99553	99553	99554
21795	32243	29	applied	\N	\N	\N	\N	99555	99555	99556
21795	32248	30	applied	\N	\N	\N	\N	99567	99567	99568
21795	32251	31	applied	\N	\N	\N	\N	99575	99575	99576
21795	32255	32	applied	\N	\N	\N	\N	99586	99586	99587
21795	32258	33	applied	\N	\N	\N	\N	99594	99594	99595
21795	32261	34	applied	\N	\N	\N	\N	99602	99602	99603
21795	32264	35	applied	\N	\N	\N	\N	99650	99650	99690
21795	32268	36	applied	\N	\N	\N	\N	99699	99699	99700
21795	32271	37	applied	\N	\N	\N	\N	99710	99710	99711
21795	32172	38	applied	\N	\N	\N	\N	99613	99613	99341
21795	32173	40	applied	\N	\N	\N	\N	99614	99614	99343
21795	32174	41	applied	\N	\N	\N	\N	99410	99410	99345
21795	32278	42	applied	\N	\N	\N	\N	99728	99728	99729
21795	32274	43	applied	\N	\N	\N	\N	99718	99718	99719
21795	32279	44	applied	\N	\N	\N	\N	99730	99730	99731
21795	32280	45	applied	\N	\N	\N	\N	99732	99732	99733
21795	32287	46	applied	\N	\N	\N	\N	99755	99755	99756
21795	32290	47	applied	\N	\N	\N	\N	99762	99762	99763
21795	32291	48	applied	\N	\N	\N	\N	99764	99764	99765
21795	32296	49	applied	\N	\N	\N	\N	99778	99778	99779
21795	32299	50	applied	\N	\N	\N	\N	99785	99785	99786
21795	32302	51	applied	\N	\N	\N	\N	99799	99799	99800
21795	32305	52	applied	\N	\N	\N	\N	99806	99806	99807
21795	32306	53	applied	\N	\N	\N	\N	99808	99808	99809
21795	32307	54	applied	\N	\N	\N	\N	99810	99810	99811
21795	32308	55	applied	\N	\N	\N	\N	99812	99812	99813
21795	32317	56	applied	\N	\N	\N	\N	99831	99831	99832
21795	32321	57	applied	\N	\N	\N	\N	99843	99843	99844
21795	32322	58	applied	\N	\N	\N	\N	99845	99845	99846
21795	32327	59	applied	\N	\N	\N	\N	99860	99860	99861
21795	32330	60	applied	\N	\N	\N	\N	99867	99867	99868
21795	32331	61	applied	\N	\N	\N	\N	99869	99869	99870
21795	32335	62	applied	\N	\N	\N	\N	99881	99881	99882
21795	32338	63	applied	\N	\N	\N	\N	99892	99892	99893
21795	32339	64	applied	\N	\N	\N	\N	99894	99894	99895
21795	32344	65	applied	\N	\N	\N	\N	99907	99907	99908
21795	32345	66	applied	\N	\N	\N	\N	99909	99909	99910
21795	32346	67	applied	\N	\N	\N	\N	99911	99911	99912
21795	32347	68	applied	\N	\N	\N	\N	99913	99913	99914
21795	32356	69	applied	\N	\N	\N	\N	99932	99932	99933
21795	32359	70	applied	\N	\N	\N	\N	99940	99940	99941
21795	32362	71	applied	\N	\N	\N	\N	99948	99948	99949
21795	32365	72	applied	\N	\N	\N	\N	99958	99958	99959
21795	32381	73	applied	\N	\N	\N	\N	100103	100103	100104
21795	32382	74	applied	\N	\N	\N	\N	100105	100105	100106
21795	32387	75	applied	\N	\N	\N	\N	100121	100121	100122
21795	32390	76	applied	\N	\N	\N	\N	100134	100134	100135
21795	32393	77	applied	\N	\N	\N	\N	100140	100140	100141
21795	32396	78	applied	\N	\N	\N	\N	100148	100148	100149
21795	32399	79	applied	\N	\N	\N	\N	100156	100156	100157
21795	32402	80	applied	\N	\N	\N	\N	100204	100204	100205
21795	32405	81	applied	\N	\N	\N	\N	100213	100213	100214
21795	32408	82	applied	\N	\N	\N	\N	100221	100221	100222
21795	32411	83	applied	\N	\N	\N	\N	100235	100235	100236
21795	32414	84	applied	\N	\N	\N	\N	100246	100246	100247
21795	32417	85	applied	\N	\N	\N	\N	100254	100254	100255
21795	32420	86	applied	\N	\N	\N	\N	100264	100264	100265
21795	32421	87	applied	\N	\N	\N	\N	100266	100266	100267
21795	32426	88	applied	\N	\N	\N	\N	100282	100282	100283
21795	32429	89	applied	\N	\N	\N	\N	100292	100292	100293
21795	32432	90	applied	\N	\N	\N	\N	100299	100299	100300
21795	32435	91	applied	\N	\N	\N	\N	100307	100307	100308
21795	32436	92	applied	\N	\N	\N	\N	100309	100309	100310
21795	32437	93	applied	\N	\N	\N	\N	100311	100311	100312
21795	32444	94	applied	\N	\N	\N	\N	100348	100348	100369
21795	32446	95	applied	\N	\N	\N	\N	100370	100370	100371
21795	32450	96	applied	\N	\N	\N	\N	100380	100380	100381
21795	32453	97	applied	\N	\N	\N	\N	100386	100386	100387
21795	32456	98	applied	\N	\N	\N	\N	100400	100400	100401
21795	32458	99	applied	\N	\N	\N	\N	100407	100407	100408
21795	32461	100	applied	\N	\N	\N	\N	100417	100417	100418
21795	32462	101	applied	\N	\N	\N	\N	100419	100419	100420
21795	32469	102	applied	\N	\N	\N	\N	100436	100436	100437
21795	32476	103	applied	\N	\N	\N	\N	100484	100484	100485
21795	32477	104	applied	\N	\N	\N	\N	100486	100486	100487
21795	32482	105	applied	\N	\N	\N	\N	100498	100498	100499
21795	32275	106	applied	\N	\N	\N	\N	99720	99720	99721
21795	32276	107	applied	\N	\N	\N	\N	99724	99724	99725
21795	32277	108	applied	\N	\N	\N	\N	99726	99726	99727
21791	32469	0	applied	\N	\N	\N	\N	100436	100436	100437
21791	32470	1	applied	\N	\N	\N	\N	100438	100438	100439
21791	32471	2	applied	\N	\N	\N	\N	100440	100440	100441
21791	32472	3	applied	\N	\N	\N	\N	100442	100442	100443
21791	32473	4	applied	\N	\N	\N	\N	100444	100444	100445
21791	32474	5	applied	\N	\N	\N	\N	100446	100446	100447
21791	32475	6	applied	\N	\N	\N	\N	100448	100448	100449
21793	32469	0	applied	\N	\N	\N	\N	100436	100436	100437
21793	32470	1	applied	\N	\N	\N	\N	100438	100438	100439
21793	32471	2	applied	\N	\N	\N	\N	100440	100440	100441
21793	32472	3	applied	\N	\N	\N	\N	100442	100442	100443
21793	32473	4	applied	\N	\N	\N	\N	100444	100444	100445
21793	32474	5	applied	\N	\N	\N	\N	100446	100446	100447
21793	32475	6	applied	\N	\N	\N	\N	100448	100448	100449
21799	32482	0	applied	\N	\N	\N	\N	100498	100498	100499
21799	32485	1	applied	\N	\N	\N	\N	100533	100533	100534
21799	32484	2	applied	\N	\N	\N	\N	100529	100529	100535
21799	32483	3	applied	\N	\N	\N	\N	100509	100509	100530
21799	32486	4	applied	\N	\N	\N	\N	100536	100536	100537
21799	32487	5	applied	\N	\N	\N	\N	100538	100538	100539
21803	32491	0	applied	\N	\N	\N	\N	100552	100552	100553
21803	32492	1	applied	\N	\N	\N	\N	100554	100554	100555
21803	32493	2	applied	\N	\N	\N	\N	100556	100556	100557
21803	32494	3	applied	\N	\N	\N	\N	100558	100558	100559
21803	32495	4	applied	\N	\N	\N	\N	100560	100560	100561
21803	32496	5	applied	\N	\N	\N	\N	100562	100562	100563
21809	32503	0	applied	\N	\N	\N	\N	100591	100591	100592
21809	32504	1	applied	\N	\N	\N	\N	100593	100593	100594
21809	32505	2	applied	\N	\N	\N	\N	100595	100595	100596
21811	32506	0	applied	\N	\N	\N	\N	100599	100599	100600
21811	32507	1	applied	\N	\N	\N	\N	100601	100601	100602
21811	32508	2	applied	\N	\N	\N	\N	100603	100603	100604
21814	32509	0	applied	\N	\N	\N	\N	100609	100609	100610
21814	32510	1	applied	\N	\N	\N	\N	100611	100611	100612
21814	32511	2	applied	\N	\N	\N	\N	100613	100613	100614
21814	32512	3	applied	\N	\N	\N	\N	100615	100615	100616
21814	32513	4	applied	\N	\N	\N	\N	100617	100617	100618
21814	32514	5	applied	\N	\N	\N	\N	100619	100619	100620
21816	32515	0	applied	\N	\N	\N	\N	100623	100623	100624
21816	32516	1	applied	\N	\N	\N	\N	100625	100625	100626
21816	32517	2	applied	\N	\N	\N	\N	100627	100627	100628
21816	32518	3	applied	\N	\N	\N	\N	100629	100629	100630
21816	32519	4	applied	\N	\N	\N	\N	100631	100631	100632
21816	32520	5	applied	\N	\N	\N	\N	100633	100633	100634
21819	32527	0	applied	\N	\N	\N	\N	100650	100650	100651
21819	32528	1	applied	\N	\N	\N	\N	100652	100652	100653
21819	32529	2	applied	\N	\N	\N	\N	100654	100654	100655
21819	32530	3	applied	\N	\N	\N	\N	100656	100656	100657
21819	32531	4	applied	\N	\N	\N	\N	100658	100658	100659
21819	32532	5	applied	\N	\N	\N	\N	100660	100660	100661
21822	32533	0	applied	\N	\N	\N	\N	100665	100665	100666
21822	32534	1	applied	\N	\N	\N	\N	100667	100667	100668
21822	32535	2	applied	\N	\N	\N	\N	100669	100669	100670
21822	32536	3	applied	\N	\N	\N	\N	100671	100671	100672
21822	32537	4	applied	\N	\N	\N	\N	100673	100673	100674
21822	32538	5	applied	\N	\N	\N	\N	100675	100675	100676
21822	32539	6	applied	\N	\N	\N	\N	100677	100677	100678
21822	32540	7	applied	\N	\N	\N	\N	100679	100679	100680
21822	32541	8	applied	\N	\N	\N	\N	100681	100681	100682
21822	32542	9	applied	\N	\N	\N	\N	100683	100683	100684
21822	32543	10	applied	\N	\N	\N	\N	100685	100685	100686
21822	32544	11	applied	\N	\N	\N	\N	100687	100687	100688
21825	32551	0	applied	\N	\N	\N	\N	100705	100705	100706
21825	32552	1	applied	\N	\N	\N	\N	100707	100707	100708
21825	32553	2	applied	\N	\N	\N	\N	100709	100709	100710
21825	32554	3	applied	\N	\N	\N	\N	100711	100711	100712
21825	32555	4	applied	\N	\N	\N	\N	100713	100713	100714
21825	32556	5	applied	\N	\N	\N	\N	100715	100715	100716
21833	32572	0	applied	\N	\N	\N	\N	100758	100758	100759
21833	32573	1	applied	\N	\N	\N	\N	100760	100760	100761
21835	32574	0	applied	\N	\N	\N	\N	100765	100765	100766
21835	32575	1	applied	\N	\N	\N	\N	100767	100767	100768
21835	32576	2	applied	\N	\N	\N	\N	100769	100769	100770
21835	32577	3	applied	\N	\N	\N	\N	100771	100771	100772
21835	32578	4	applied	\N	\N	\N	\N	100773	100773	100774
21835	32579	5	applied	\N	\N	\N	\N	100775	100775	100776
21841	32586	0	applied	\N	\N	\N	\N	100800	100800	100801
21841	32587	1	applied	\N	\N	\N	\N	100802	100802	100803
21841	32588	2	applied	\N	\N	\N	\N	100804	100804	100805
21845	32592	0	applied	\N	\N	\N	\N	100817	100817	100818
21845	32593	1	applied	\N	\N	\N	\N	100819	100819	100820
21845	32594	2	applied	\N	\N	\N	\N	100821	100821	100822
21845	32595	3	applied	\N	\N	\N	\N	100823	100823	100824
21845	32596	4	applied	\N	\N	\N	\N	100825	100825	100826
21845	32597	5	applied	\N	\N	\N	\N	100827	100827	100828
21847	32598	0	applied	\N	\N	\N	\N	100835	100835	100836
21847	32599	1	applied	\N	\N	\N	\N	100837	100837	100838
21847	32600	2	applied	\N	\N	\N	\N	100839	100839	100840
21847	32601	3	applied	\N	\N	\N	\N	100841	100841	100842
21847	32602	4	applied	\N	\N	\N	\N	100843	100843	100844
21847	32603	5	applied	\N	\N	\N	\N	100845	100845	100846
21847	32604	6	applied	\N	\N	\N	\N	100847	100847	100848
21847	32605	7	applied	\N	\N	\N	\N	100849	100849	100850
21847	32606	8	applied	\N	\N	\N	\N	100851	100851	100852
21849	32598	0	applied	\N	\N	\N	\N	100835	100835	100836
21849	32599	1	applied	\N	\N	\N	\N	100837	100837	100838
21849	32600	2	applied	\N	\N	\N	\N	100839	100839	100840
21849	32601	3	applied	\N	\N	\N	\N	100841	100841	100842
21849	32602	4	applied	\N	\N	\N	\N	100843	100843	100844
21849	32603	5	applied	\N	\N	\N	\N	100845	100845	100846
21849	32604	6	applied	\N	\N	\N	\N	100847	100847	100848
21849	32605	7	applied	\N	\N	\N	\N	100849	100849	100850
21849	32606	8	applied	\N	\N	\N	\N	100851	100851	100852
21861	32628	0	applied	\N	\N	\N	\N	100913	100913	100914
21861	32629	1	applied	\N	\N	\N	\N	100915	100915	100916
21861	32630	2	applied	\N	\N	\N	\N	100917	100917	100918
21866	32639	0	applied	\N	\N	\N	\N	100939	100939	100946
21870	32267	0	applied	\N	\N	\N	\N	99697	99697	99698
21870	32167	1	applied	\N	\N	\N	\N	99322	99322	99323
21870	32254	2	applied	\N	\N	\N	\N	99584	99584	99585
21870	32221	3	applied	\N	\N	\N	\N	99488	99488	47675
21870	32025	4	applied	\N	\N	\N	\N	98783	98783	98784
21870	32218	5	applied	\N	\N	\N	\N	99482	99482	47675
21870	32196	6	applied	\N	\N	\N	\N	99407	99407	99610
21870	32232	7	applied	\N	\N	1000000000	\N	99517	99517	99518
21870	32026	8	applied	\N	\N	\N	\N	98785	98785	98786
21870	32031	9	applied	\N	\N	\N	\N	98797	98797	98798
21870	32197	10	applied	\N	\N	\N	\N	99409	99409	99612
21870	32034	11	applied	\N	\N	\N	\N	98806	98806	98807
21870	32037	13	applied	\N	\N	\N	\N	98823	98823	98824
21795	32176	109	applied	\N	\N	\N	\N	99350	99350	99351
21795	32178	110	applied	\N	\N	\N	\N	99357	99357	99358
21795	32373	111	applied	\N	\N	\N	\N	100071	100071	100072
21795	32470	112	applied	\N	\N	\N	\N	100438	100438	100439
21795	32471	113	applied	\N	\N	\N	\N	100440	100440	100441
21795	32472	114	applied	\N	\N	\N	\N	100442	100442	100443
21795	32175	115	applied	\N	\N	\N	\N	99346	99346	99359
21795	32179	116	applied	\N	\N	\N	\N	99361	99361	99362
21795	32474	117	applied	\N	\N	\N	\N	100446	100446	100447
21795	32181	118	applied	\N	\N	\N	\N	99366	99366	99367
21795	32185	119	applied	\N	\N	\N	\N	99375	99375	99686
21795	32189	120	applied	\N	\N	\N	\N	99387	99387	99687
21795	32190	121	applied	\N	\N	\N	\N	99390	99390	99384
21795	32193	122	applied	\N	\N	\N	\N	99400	99400	99389
21795	32200	123	applied	\N	\N	\N	\N	99416	99416	99391
21795	32201	124	applied	\N	\N	\N	\N	99418	99418	100018
21795	32203	125	applied	\N	\N	\N	\N	99424	99424	100019
21798	32482	0	applied	\N	\N	\N	\N	100498	100498	100499
21798	32485	1	applied	\N	\N	\N	\N	100533	100533	100534
21798	32484	2	applied	\N	\N	\N	\N	100529	100529	100535
21798	32483	3	applied	\N	\N	\N	\N	100509	100509	100530
21798	32486	4	applied	\N	\N	\N	\N	100536	100536	100537
21798	32487	5	applied	\N	\N	\N	\N	100538	100538	100539
21802	32491	0	applied	\N	\N	\N	\N	100552	100552	100553
21802	32492	1	applied	\N	\N	\N	\N	100554	100554	100555
21802	32493	2	applied	\N	\N	\N	\N	100556	100556	100557
21802	32494	3	applied	\N	\N	\N	\N	100558	100558	100559
21802	32495	4	applied	\N	\N	\N	\N	100560	100560	100561
21802	32496	5	applied	\N	\N	\N	\N	100562	100562	100563
21805	32491	0	applied	\N	\N	\N	\N	100552	100552	100553
21805	32492	1	applied	\N	\N	\N	\N	100554	100554	100555
21805	32493	2	applied	\N	\N	\N	\N	100556	100556	100557
21805	32494	3	applied	\N	\N	\N	\N	100558	100558	100559
21805	32495	4	applied	\N	\N	\N	\N	100560	100560	100561
21805	32496	5	applied	\N	\N	\N	\N	100562	100562	100563
21813	32509	0	applied	\N	\N	\N	\N	100609	100609	100610
21813	32510	1	applied	\N	\N	\N	\N	100611	100611	100612
21813	32511	2	applied	\N	\N	\N	\N	100613	100613	100614
21813	32512	3	applied	\N	\N	\N	\N	100615	100615	100616
21813	32513	4	applied	\N	\N	\N	\N	100617	100617	100618
21813	32514	5	applied	\N	\N	\N	\N	100619	100619	100620
21818	32521	0	applied	\N	\N	\N	\N	100637	100637	100638
21818	32522	1	applied	\N	\N	\N	\N	100639	100639	100640
21818	32523	2	applied	\N	\N	\N	\N	100641	100641	100642
21818	32524	3	applied	\N	\N	\N	\N	100643	100643	100644
21818	32525	4	applied	\N	\N	\N	\N	100645	100645	100646
21818	32526	5	applied	\N	\N	\N	\N	100647	100647	100648
21824	32545	0	applied	\N	\N	\N	\N	100692	100692	100693
21824	32546	1	applied	\N	\N	\N	\N	100694	100694	100695
21824	32547	2	applied	\N	\N	\N	\N	100696	100696	100697
21824	32548	3	applied	\N	\N	\N	\N	100698	100698	100699
21824	32549	4	applied	\N	\N	\N	\N	100700	100700	100701
21824	32550	5	applied	\N	\N	\N	\N	100702	100702	100703
21832	32572	0	applied	\N	\N	\N	\N	100758	100758	100759
21832	32573	1	applied	\N	\N	\N	\N	100760	100760	100761
21834	32572	0	applied	\N	\N	\N	\N	100758	100758	100759
21834	32573	1	applied	\N	\N	\N	\N	100760	100760	100761
21837	32580	0	applied	\N	\N	\N	\N	100779	100779	100780
21837	32581	1	applied	\N	\N	\N	\N	100787	100787	100788
21837	32582	2	applied	\N	\N	\N	\N	100789	100789	100790
21840	32586	0	applied	\N	\N	\N	\N	100800	100800	100801
21840	32587	1	applied	\N	\N	\N	\N	100802	100802	100803
21840	32588	2	applied	\N	\N	\N	\N	100804	100804	100805
21844	32592	0	applied	\N	\N	\N	\N	100817	100817	100818
21844	32593	1	applied	\N	\N	\N	\N	100819	100819	100820
21844	32594	2	applied	\N	\N	\N	\N	100821	100821	100822
21844	32595	3	applied	\N	\N	\N	\N	100823	100823	100824
21844	32596	4	applied	\N	\N	\N	\N	100825	100825	100826
21844	32597	5	applied	\N	\N	\N	\N	100827	100827	100828
21846	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21846	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21846	32254	2	applied	\N	\N	\N	\N	99584	99584	99585
21846	32221	3	applied	\N	\N	\N	\N	99488	99488	47675
21846	32218	4	applied	\N	\N	\N	\N	99482	99482	47675
21846	32232	5	applied	\N	\N	1000000000	\N	99534	99534	99518
21846	31762	6	applied	\N	\N	\N	\N	98059	98059	98060
21846	31767	7	applied	\N	\N	\N	\N	98072	98072	98073
21846	31768	8	applied	\N	\N	\N	\N	98074	98074	98075
21846	31776	9	applied	\N	\N	\N	\N	98096	98096	98097
21846	31779	10	applied	\N	\N	\N	\N	98107	98107	98108
21846	31782	11	applied	\N	\N	\N	\N	98115	98115	98116
21846	31785	12	applied	\N	\N	\N	\N	98124	98124	98125
21846	31788	13	applied	\N	\N	\N	\N	98133	98133	98134
21846	31792	14	applied	\N	\N	\N	\N	98144	98144	98145
21846	31793	15	applied	\N	\N	\N	\N	98146	98146	98147
21846	32274	16	applied	\N	\N	\N	\N	99718	99718	99719
21846	31798	17	applied	\N	\N	\N	\N	98156	98156	98157
21846	31799	18	applied	\N	\N	\N	\N	98158	98158	98159
21846	31800	19	applied	\N	\N	\N	\N	98160	98160	98161
21846	31808	20	applied	\N	\N	\N	\N	98180	98180	98181
21846	31811	21	applied	\N	\N	\N	\N	98192	98192	98193
21846	31814	22	applied	\N	\N	\N	\N	98198	98198	98199
21846	31815	23	applied	\N	\N	\N	\N	98200	98200	98201
21846	31820	24	applied	\N	\N	\N	\N	98212	98212	98213
21846	31821	25	applied	\N	\N	\N	\N	98214	98214	98215
21846	31827	26	applied	\N	\N	\N	\N	98229	98229	98230
21846	31836	27	applied	\N	\N	\N	\N	98249	98249	98250
21846	31837	28	applied	\N	\N	\N	\N	98251	98251	98252
21846	31844	29	applied	\N	\N	\N	\N	98267	98267	98268
21846	31845	30	applied	\N	\N	\N	\N	98269	98269	98270
21846	31850	31	applied	\N	\N	\N	\N	98281	98281	98282
21846	31856	32	applied	\N	\N	\N	\N	98295	98295	98296
21846	31859	33	applied	\N	\N	\N	\N	98302	98302	98303
21846	31860	34	applied	\N	\N	\N	\N	98304	98304	98305
21846	31867	35	applied	\N	\N	\N	\N	98321	98321	98322
21846	31870	36	applied	\N	\N	\N	\N	98328	98328	98329
21846	31874	37	applied	\N	\N	\N	\N	98340	98340	98341
21846	31878	38	applied	\N	\N	\N	\N	98350	98350	98351
21846	31881	39	applied	\N	\N	\N	\N	98367	98367	98368
21846	32275	40	applied	\N	\N	\N	\N	99720	99720	99721
21846	32276	41	applied	\N	\N	\N	\N	99724	99724	99725
21846	32277	42	applied	\N	\N	\N	\N	99726	99726	99727
21846	31884	43	applied	\N	\N	\N	\N	98375	98375	98376
21846	31887	44	applied	\N	\N	\N	\N	98393	98393	98394
21846	31888	45	applied	\N	\N	\N	\N	98395	98395	98396
21846	31894	46	applied	\N	\N	\N	\N	98409	98409	98410
21846	31895	47	applied	\N	\N	\N	\N	98411	98411	98412
21846	31901	48	applied	\N	\N	\N	\N	98425	98425	98426
21846	31904	49	applied	\N	\N	\N	\N	98435	98435	98436
21796	32438	105	applied	\N	\N	\N	\N	100313	100313	100424
21796	32439	106	applied	\N	\N	\N	\N	100315	100315	100426
21796	32440	107	applied	\N	\N	\N	\N	100317	100317	100428
21796	32448	108	applied	\N	\N	\N	\N	100375	100375	100520
21796	32449	109	applied	\N	\N	\N	\N	100377	100377	100521
21796	32452	110	applied	\N	\N	\N	\N	100384	100384	100432
21796	32454	111	applied	\N	\N	\N	\N	100388	100388	100445
21796	32457	112	applied	\N	\N	\N	\N	100403	100403	100522
21796	32459	113	applied	\N	\N	\N	\N	100409	100409	100523
21796	32464	114	applied	\N	\N	\N	\N	100423	100423	100524
21796	32465	115	applied	\N	\N	\N	\N	100425	100425	100525
21796	32466	116	applied	\N	\N	\N	\N	100427	100427	100493
21796	32473	117	applied	\N	\N	\N	\N	100444	100444	100526
21796	32478	118	applied	\N	\N	\N	\N	100488	100488	100527
21796	32479	119	applied	\N	\N	\N	\N	100490	100490	100528
21796	32484	120	applied	\N	\N	\N	\N	100529	100529	100530
21804	32491	0	applied	\N	\N	\N	\N	100552	100552	100553
21804	32492	1	applied	\N	\N	\N	\N	100554	100554	100555
21804	32493	2	applied	\N	\N	\N	\N	100556	100556	100557
21804	32494	3	applied	\N	\N	\N	\N	100558	100558	100559
21804	32495	4	applied	\N	\N	\N	\N	100560	100560	100561
21804	32496	5	applied	\N	\N	\N	\N	100562	100562	100563
21807	32497	0	applied	\N	\N	\N	\N	100576	100576	100577
21807	32498	1	applied	\N	\N	\N	\N	100578	100578	100579
21807	32499	2	applied	\N	\N	\N	\N	100580	100580	100581
21807	32500	3	applied	\N	\N	\N	\N	100582	100582	100583
21807	32501	4	applied	\N	\N	\N	\N	100584	100584	100585
21807	32502	5	applied	\N	\N	\N	\N	100586	100586	100587
21817	32515	0	applied	\N	\N	\N	\N	100623	100623	100624
21817	32516	1	applied	\N	\N	\N	\N	100625	100625	100626
21817	32517	2	applied	\N	\N	\N	\N	100627	100627	100628
21817	32518	3	applied	\N	\N	\N	\N	100629	100629	100630
21817	32519	4	applied	\N	\N	\N	\N	100631	100631	100632
21817	32520	5	applied	\N	\N	\N	\N	100633	100633	100634
21823	32533	0	applied	\N	\N	\N	\N	100665	100665	100666
21823	32534	1	applied	\N	\N	\N	\N	100667	100667	100668
21823	32535	2	applied	\N	\N	\N	\N	100669	100669	100670
21823	32536	3	applied	\N	\N	\N	\N	100671	100671	100672
21823	32537	4	applied	\N	\N	\N	\N	100673	100673	100674
21823	32538	5	applied	\N	\N	\N	\N	100675	100675	100676
21823	32539	6	applied	\N	\N	\N	\N	100677	100677	100678
21823	32540	7	applied	\N	\N	\N	\N	100679	100679	100680
21823	32541	8	applied	\N	\N	\N	\N	100681	100681	100682
21823	32542	9	applied	\N	\N	\N	\N	100683	100683	100684
21823	32543	10	applied	\N	\N	\N	\N	100685	100685	100686
21823	32544	11	applied	\N	\N	\N	\N	100687	100687	100688
21826	32551	0	applied	\N	\N	\N	\N	100705	100705	100706
21826	32552	1	applied	\N	\N	\N	\N	100707	100707	100708
21826	32553	2	applied	\N	\N	\N	\N	100709	100709	100710
21826	32554	3	applied	\N	\N	\N	\N	100711	100711	100712
21826	32555	4	applied	\N	\N	\N	\N	100713	100713	100714
21826	32556	5	applied	\N	\N	\N	\N	100715	100715	100716
21828	32557	0	applied	\N	\N	\N	\N	100721	100721	100722
21828	32558	1	applied	\N	\N	\N	\N	100723	100723	100724
21831	32563	0	applied	\N	\N	\N	\N	100739	100739	100740
21831	32564	1	applied	\N	\N	\N	\N	100741	100741	100742
21831	32565	2	applied	\N	\N	\N	\N	100743	100743	100744
21831	32566	3	applied	\N	\N	\N	\N	100745	100745	100746
21831	32567	4	applied	\N	\N	\N	\N	100747	100747	100748
21831	32568	5	applied	\N	\N	\N	\N	100749	100749	100750
21831	32569	6	applied	\N	\N	\N	\N	100751	100751	100752
21831	32570	7	applied	\N	\N	\N	\N	100753	100753	100754
21831	32571	8	applied	\N	\N	\N	\N	100755	100755	100756
21836	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21836	32296	1	applied	\N	\N	\N	\N	99778	99778	99779
21836	32299	2	applied	\N	\N	\N	\N	99785	99785	99786
21836	32302	3	applied	\N	\N	\N	\N	99799	99799	99800
21836	32305	4	applied	\N	\N	\N	\N	99806	99806	99807
21836	32306	5	applied	\N	\N	\N	\N	99808	99808	99809
21836	32307	6	applied	\N	\N	\N	\N	99810	99810	99811
21836	32308	7	applied	\N	\N	\N	\N	99812	99812	99813
21836	32317	8	applied	\N	\N	\N	\N	99831	99831	99832
21836	32321	9	applied	\N	\N	\N	\N	99843	99843	99844
21836	32322	10	applied	\N	\N	\N	\N	99845	99845	99846
21836	32327	11	applied	\N	\N	\N	\N	99860	99860	99861
21836	32330	12	applied	\N	\N	\N	\N	99867	99867	99868
21836	32331	13	applied	\N	\N	\N	\N	99869	99869	99870
21836	32335	14	applied	\N	\N	\N	\N	99881	99881	99882
21836	32338	15	applied	\N	\N	\N	\N	99892	99892	99893
21836	32339	16	applied	\N	\N	\N	\N	99894	99894	99895
21836	32344	17	applied	\N	\N	\N	\N	99907	99907	99908
21836	32345	18	applied	\N	\N	\N	\N	99909	99909	99910
21836	32346	19	applied	\N	\N	\N	\N	99911	99911	99912
21836	32347	20	applied	\N	\N	\N	\N	99913	99913	99914
21836	32356	21	applied	\N	\N	\N	\N	99932	99932	99933
21836	32359	22	applied	\N	\N	\N	\N	99940	99940	99941
21836	32362	23	applied	\N	\N	\N	\N	99948	99948	99949
21836	32365	24	applied	\N	\N	\N	\N	99958	99958	99959
21836	32381	25	applied	\N	\N	\N	\N	100103	100103	100104
21836	32382	26	applied	\N	\N	\N	\N	100105	100105	100106
21836	32387	27	applied	\N	\N	\N	\N	100121	100121	100122
21836	32390	28	applied	\N	\N	\N	\N	100134	100134	100135
21836	32393	29	applied	\N	\N	\N	\N	100140	100140	100141
21836	32396	30	applied	\N	\N	\N	\N	100148	100148	100149
21836	32399	31	applied	\N	\N	\N	\N	100156	100156	100157
21836	32402	32	applied	\N	\N	\N	\N	100204	100204	100205
21836	32405	33	applied	\N	\N	\N	\N	100213	100213	100214
21836	32408	34	applied	\N	\N	\N	\N	100221	100221	100222
21836	32411	35	applied	\N	\N	\N	\N	100235	100235	100236
21836	32414	36	applied	\N	\N	\N	\N	100246	100246	100247
21836	32417	37	applied	\N	\N	\N	\N	100254	100254	100255
21836	32420	38	applied	\N	\N	\N	\N	100264	100264	100265
21836	32421	39	applied	\N	\N	\N	\N	100266	100266	100267
21836	32426	40	applied	\N	\N	\N	\N	100282	100282	100283
21836	32429	41	applied	\N	\N	\N	\N	100292	100292	100293
21836	32432	42	applied	\N	\N	\N	\N	100299	100299	100300
21836	32435	43	applied	\N	\N	\N	\N	100307	100307	100308
21836	32436	44	applied	\N	\N	\N	\N	100309	100309	100310
21836	32437	45	applied	\N	\N	\N	\N	100311	100311	100312
21836	32444	46	applied	\N	\N	\N	\N	100348	100348	100369
21836	32446	47	applied	\N	\N	\N	\N	100370	100370	100371
21836	32450	48	applied	\N	\N	\N	\N	100380	100380	100381
21836	32453	49	applied	\N	\N	\N	\N	100386	100386	100387
21836	32456	50	applied	\N	\N	\N	\N	100400	100400	100401
21836	32458	51	applied	\N	\N	\N	\N	100407	100407	100408
21836	32461	52	applied	\N	\N	\N	\N	100417	100417	100418
21836	32462	53	applied	\N	\N	\N	\N	100419	100419	100420
21836	32469	54	applied	\N	\N	\N	\N	100436	100436	100437
21836	32476	55	applied	\N	\N	\N	\N	100484	100484	100485
21836	32477	56	applied	\N	\N	\N	\N	100486	100486	100487
21829	32557	4	applied	\N	\N	\N	\N	100721	100721	100735
21829	32558	5	applied	\N	\N	\N	\N	100723	100723	100736
21839	32586	0	applied	\N	\N	\N	\N	100800	100800	100801
21839	32587	1	applied	\N	\N	\N	\N	100802	100802	100803
21839	32588	2	applied	\N	\N	\N	\N	100804	100804	100805
21843	32589	0	applied	\N	\N	\N	\N	100811	100811	100812
21843	32590	1	applied	\N	\N	\N	\N	100813	100813	100814
21843	32591	2	applied	\N	\N	\N	\N	100815	100815	100816
21848	32598	0	applied	\N	\N	\N	\N	100835	100835	100836
21848	32599	1	applied	\N	\N	\N	\N	100837	100837	100838
21848	32600	2	applied	\N	\N	\N	\N	100839	100839	100840
21848	32601	3	applied	\N	\N	\N	\N	100841	100841	100842
21848	32602	4	applied	\N	\N	\N	\N	100843	100843	100844
21848	32603	5	applied	\N	\N	\N	\N	100845	100845	100846
21848	32604	6	applied	\N	\N	\N	\N	100847	100847	100848
21848	32605	7	applied	\N	\N	\N	\N	100849	100849	100850
21848	32606	8	applied	\N	\N	\N	\N	100851	100851	100852
21850	32607	0	applied	\N	\N	\N	\N	100857	100857	100858
21850	32608	1	applied	\N	\N	\N	\N	100859	100859	100860
21850	32609	2	applied	\N	\N	\N	\N	100861	100861	100862
21853	32613	0	applied	\N	\N	\N	\N	100870	100870	100871
21853	32614	1	applied	\N	\N	\N	\N	100872	100872	100873
21853	32615	2	applied	\N	\N	\N	\N	100874	100874	100875
21853	32616	3	applied	\N	\N	\N	\N	100876	100876	100877
21853	32617	4	applied	\N	\N	\N	\N	100878	100878	100879
21853	32618	5	applied	\N	\N	\N	\N	100880	100880	100881
21853	32619	6	applied	\N	\N	\N	\N	100882	100882	100883
21853	32620	7	applied	\N	\N	\N	\N	100884	100884	100885
21853	32621	8	applied	\N	\N	\N	\N	100886	100886	100887
21856	32613	0	applied	\N	\N	\N	\N	100870	100870	100871
21856	32614	1	applied	\N	\N	\N	\N	100872	100872	100873
21856	32615	2	applied	\N	\N	\N	\N	100874	100874	100875
21856	32616	3	applied	\N	\N	\N	\N	100876	100876	100877
21856	32617	4	applied	\N	\N	\N	\N	100878	100878	100879
21856	32618	5	applied	\N	\N	\N	\N	100880	100880	100881
21856	32619	6	applied	\N	\N	\N	\N	100882	100882	100883
21856	32620	7	applied	\N	\N	\N	\N	100884	100884	100885
21856	32621	8	applied	\N	\N	\N	\N	100886	100886	100887
21858	32622	0	applied	\N	\N	\N	\N	100894	100894	100895
21858	32623	1	applied	\N	\N	\N	\N	100896	100896	100897
21858	32624	2	applied	\N	\N	\N	\N	100898	100898	100899
21862	32631	0	applied	\N	\N	\N	\N	100919	100919	100920
21862	32632	1	applied	\N	\N	\N	\N	100921	100921	100922
21862	32633	2	applied	\N	\N	\N	\N	100923	100923	100924
21877	32646	0	applied	\N	\N	\N	\N	101004	101004	101005
21877	32647	1	applied	\N	\N	\N	\N	101006	101006	101007
21877	32648	2	applied	\N	\N	\N	\N	101008	101008	101009
21880	32652	0	applied	\N	\N	\N	\N	101018	101018	101019
21880	32653	1	applied	\N	\N	\N	\N	101020	101020	101021
21880	32654	2	applied	\N	\N	\N	\N	101022	101022	101023
21880	32655	3	applied	\N	\N	\N	\N	101024	101024	101025
21880	32656	4	applied	\N	\N	\N	\N	101026	101026	101027
21880	32657	5	applied	\N	\N	\N	\N	101028	101028	101029
21882	32658	0	applied	\N	\N	\N	\N	101030	101030	101031
21882	32659	1	applied	\N	\N	\N	\N	101032	101032	101033
21882	32660	2	applied	\N	\N	\N	\N	101034	101034	101035
21882	32661	3	applied	\N	\N	\N	\N	101036	101036	101037
21882	32662	4	applied	\N	\N	\N	\N	101038	101038	101039
21882	32663	5	applied	\N	\N	\N	\N	101040	101040	101041
21887	32673	0	applied	\N	\N	\N	\N	101070	101070	101071
21887	32674	1	applied	\N	\N	\N	\N	101072	101072	101073
21887	32675	2	applied	\N	\N	\N	\N	101074	101074	101075
21892	32681	0	applied	\N	\N	\N	\N	101089	101089	101090
21892	32679	1	applied	\N	\N	\N	\N	101084	101084	101085
21892	32680	2	applied	\N	\N	\N	\N	101086	101086	101087
21896	32685	0	applied	\N	\N	\N	\N	101103	101103	101104
21896	32686	1	applied	\N	\N	\N	\N	101105	101105	101106
21896	32687	2	applied	\N	\N	\N	\N	101107	101107	101108
21901	32694	0	applied	\N	\N	\N	\N	101124	101124	101125
21901	32695	1	applied	\N	\N	\N	\N	101126	101126	101127
21901	32696	2	applied	\N	\N	\N	\N	101128	101128	101129
21903	32697	0	applied	\N	\N	\N	\N	101135	101135	101136
21903	32698	1	applied	\N	\N	\N	\N	101137	101137	101138
21903	32699	2	applied	\N	\N	\N	\N	101139	101139	101140
21905	32476	0	applied	\N	\N	\N	\N	100484	100484	100485
21905	32477	1	applied	\N	\N	\N	\N	100486	100486	100487
21905	32482	2	applied	\N	\N	\N	\N	100498	100498	100499
21905	32485	4	applied	\N	\N	\N	\N	100533	100533	100534
21905	32488	5	applied	\N	\N	\N	\N	100546	100546	100547
21905	32491	6	applied	\N	\N	\N	\N	100552	100552	100553
21905	32492	7	applied	\N	\N	\N	\N	100554	100554	100555
21905	32497	8	applied	\N	\N	\N	\N	100576	100576	100577
21905	32498	9	applied	\N	\N	\N	\N	100578	100578	100579
21905	32503	10	applied	\N	\N	\N	\N	100591	100591	100592
21905	32506	11	applied	\N	\N	\N	\N	100599	100599	100600
21905	32509	12	applied	\N	\N	\N	\N	100609	100609	100610
21905	32510	13	applied	\N	\N	\N	\N	100611	100611	100612
21905	32515	14	applied	\N	\N	\N	\N	100623	100623	100624
21905	32516	15	applied	\N	\N	\N	\N	100625	100625	100626
21905	32521	16	applied	\N	\N	\N	\N	100637	100637	100638
21905	32522	17	applied	\N	\N	\N	\N	100639	100639	100640
21905	32527	18	applied	\N	\N	\N	\N	100650	100650	100651
21905	32528	19	applied	\N	\N	\N	\N	100652	100652	100653
21905	32533	20	applied	\N	\N	\N	\N	100665	100665	100666
21905	32534	21	applied	\N	\N	\N	\N	100667	100667	100668
21905	32535	22	applied	\N	\N	\N	\N	100669	100669	100670
21905	32536	23	applied	\N	\N	\N	\N	100671	100671	100672
21905	32545	24	applied	\N	\N	\N	\N	100692	100692	100693
21905	32546	25	applied	\N	\N	\N	\N	100694	100694	100695
21905	32551	26	applied	\N	\N	\N	\N	100705	100705	100706
21905	32552	27	applied	\N	\N	\N	\N	100707	100707	100708
21905	32559	28	applied	\N	\N	\N	\N	100727	100727	100728
21905	32560	29	applied	\N	\N	\N	\N	100729	100729	100730
21905	32563	30	applied	\N	\N	\N	\N	100739	100739	100740
21905	32564	31	applied	\N	\N	\N	\N	100741	100741	100742
21905	32565	32	applied	\N	\N	\N	\N	100743	100743	100744
21905	32572	33	applied	\N	\N	\N	\N	100758	100758	100759
21905	32574	34	applied	\N	\N	\N	\N	100765	100765	100766
21905	32575	35	applied	\N	\N	\N	\N	100767	100767	100768
21905	32580	36	applied	\N	\N	\N	\N	100779	100779	100780
21905	32583	37	applied	\N	\N	\N	\N	100792	100792	100793
21905	32586	38	applied	\N	\N	\N	\N	100800	100800	100801
21905	32589	39	applied	\N	\N	\N	\N	100811	100811	100812
21905	32592	40	applied	\N	\N	\N	\N	100817	100817	100818
21905	32593	41	applied	\N	\N	\N	\N	100819	100819	100820
21905	32598	42	applied	\N	\N	\N	\N	100835	100835	100836
21905	32599	43	applied	\N	\N	\N	\N	100837	100837	100838
21905	32600	44	applied	\N	\N	\N	\N	100839	100839	100840
21905	32607	45	applied	\N	\N	\N	\N	100857	100857	100858
21905	32610	46	applied	\N	\N	\N	\N	100864	100864	100865
21836	32482	57	applied	\N	\N	\N	\N	100498	100498	100499
21836	32485	58	applied	\N	\N	\N	\N	100533	100533	100534
21836	32488	59	applied	\N	\N	\N	\N	100546	100546	100547
21836	32491	60	applied	\N	\N	\N	\N	100552	100552	100553
21836	32492	61	applied	\N	\N	\N	\N	100554	100554	100555
21836	32497	62	applied	\N	\N	\N	\N	100576	100576	100577
21836	32498	63	applied	\N	\N	\N	\N	100578	100578	100579
21836	32503	64	applied	\N	\N	\N	\N	100591	100591	100592
21836	32506	65	applied	\N	\N	\N	\N	100599	100599	100600
21836	32509	66	applied	\N	\N	\N	\N	100609	100609	100610
21836	32510	67	applied	\N	\N	\N	\N	100611	100611	100612
21836	32515	68	applied	\N	\N	\N	\N	100623	100623	100624
21836	32516	69	applied	\N	\N	\N	\N	100625	100625	100626
21836	32521	70	applied	\N	\N	\N	\N	100637	100637	100638
21836	32522	71	applied	\N	\N	\N	\N	100639	100639	100640
21836	32527	72	applied	\N	\N	\N	\N	100650	100650	100651
21836	32528	73	applied	\N	\N	\N	\N	100652	100652	100653
21836	32533	74	applied	\N	\N	\N	\N	100665	100665	100666
21836	32534	75	applied	\N	\N	\N	\N	100667	100667	100668
21836	32535	76	applied	\N	\N	\N	\N	100669	100669	100670
21836	32536	77	applied	\N	\N	\N	\N	100671	100671	100672
21836	32545	78	applied	\N	\N	\N	\N	100692	100692	100693
21836	32546	79	applied	\N	\N	\N	\N	100694	100694	100695
21836	32551	80	applied	\N	\N	\N	\N	100705	100705	100706
21836	32552	81	applied	\N	\N	\N	\N	100707	100707	100708
21836	32559	82	applied	\N	\N	\N	\N	100727	100727	100728
21836	32560	83	applied	\N	\N	\N	\N	100729	100729	100730
21836	32563	84	applied	\N	\N	\N	\N	100739	100739	100740
21836	32564	85	applied	\N	\N	\N	\N	100741	100741	100742
21836	32565	86	applied	\N	\N	\N	\N	100743	100743	100744
21836	32572	87	applied	\N	\N	\N	\N	100758	100758	100759
21836	32574	88	applied	\N	\N	\N	\N	100765	100765	100766
21836	32575	89	applied	\N	\N	\N	\N	100767	100767	100768
21836	32580	90	applied	\N	\N	\N	\N	100779	100779	100780
21836	32373	91	applied	\N	\N	\N	\N	100071	100071	100072
21836	32470	92	applied	\N	\N	\N	\N	100438	100438	100439
21836	32471	93	applied	\N	\N	\N	\N	100440	100440	100441
21836	32472	94	applied	\N	\N	\N	\N	100442	100442	100443
21836	32474	95	applied	\N	\N	\N	\N	100446	100446	100447
21836	32294	96	applied	\N	\N	\N	\N	99770	99770	99771
21836	32295	97	applied	\N	\N	\N	\N	99772	99772	99773
21836	32297	98	applied	\N	\N	\N	\N	99780	99780	99781
21836	32301	99	applied	\N	\N	\N	\N	99789	99789	100781
21836	32298	100	applied	\N	\N	\N	\N	99782	99782	100782
21836	32300	101	applied	\N	\N	\N	\N	99787	99787	99790
21836	32303	102	applied	\N	\N	\N	\N	99801	99801	99802
21836	32313	103	applied	\N	\N	\N	\N	99822	99822	100051
21836	32314	104	applied	\N	\N	\N	\N	99824	99824	99817
21836	32315	105	applied	\N	\N	\N	\N	99826	99826	100054
21836	32316	106	applied	\N	\N	\N	\N	99828	99828	100166
21836	32318	107	applied	\N	\N	\N	\N	99833	99833	100056
21836	32323	108	applied	\N	\N	\N	\N	99847	99847	100167
21836	32324	109	applied	\N	\N	\N	\N	99849	99849	100058
21836	32329	110	applied	\N	\N	\N	\N	99864	99864	99838
21836	32334	111	applied	\N	\N	\N	\N	99875	99875	99839
21836	32337	113	applied	\N	\N	\N	\N	99885	99885	99853
21836	32341	114	applied	\N	\N	\N	\N	99898	99898	100061
21836	32342	115	applied	\N	\N	\N	\N	99900	99900	100168
21836	32349	116	applied	\N	\N	\N	\N	99917	99917	99863
21836	32350	117	applied	\N	\N	\N	\N	99919	99919	99865
21836	32351	118	applied	\N	\N	\N	\N	99921	99921	99880
21838	32583	0	applied	\N	\N	\N	\N	100792	100792	100793
21838	32584	1	applied	\N	\N	\N	\N	100794	100794	100795
21838	32585	2	applied	\N	\N	\N	\N	100796	100796	100797
21842	32586	0	applied	\N	\N	\N	\N	100800	100800	100801
21842	32587	1	applied	\N	\N	\N	\N	100802	100802	100803
21842	32588	2	applied	\N	\N	\N	\N	100804	100804	100805
21852	32610	0	applied	\N	\N	\N	\N	100864	100864	100865
21852	32611	1	applied	\N	\N	\N	\N	100866	100866	100867
21852	32612	2	applied	\N	\N	\N	\N	100868	100868	100869
21855	32613	0	applied	\N	\N	\N	\N	100870	100870	100871
21855	32614	1	applied	\N	\N	\N	\N	100872	100872	100873
21855	32615	2	applied	\N	\N	\N	\N	100874	100874	100875
21855	32616	3	applied	\N	\N	\N	\N	100876	100876	100877
21855	32617	4	applied	\N	\N	\N	\N	100878	100878	100879
21855	32618	5	applied	\N	\N	\N	\N	100880	100880	100881
21855	32619	6	applied	\N	\N	\N	\N	100882	100882	100883
21855	32620	7	applied	\N	\N	\N	\N	100884	100884	100885
21855	32621	8	applied	\N	\N	\N	\N	100886	100886	100887
21857	32622	0	applied	\N	\N	\N	\N	100894	100894	100895
21857	32623	1	applied	\N	\N	\N	\N	100896	100896	100897
21857	32624	2	applied	\N	\N	\N	\N	100898	100898	100899
21859	32622	0	applied	\N	\N	\N	\N	100894	100894	100895
21859	32623	1	applied	\N	\N	\N	\N	100896	100896	100897
21859	32624	2	applied	\N	\N	\N	\N	100898	100898	100899
21864	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21864	32638	1	applied	\N	\N	\N	\N	100937	100937	100938
21864	32639	2	applied	\N	\N	\N	\N	100939	100939	100940
21867	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21867	32638	1	applied	\N	\N	\N	\N	100937	100937	100938
21867	32639	2	applied	\N	\N	\N	\N	100939	100939	100940
21871	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21871	32287	1	applied	\N	\N	\N	\N	99755	99755	99990
21871	32290	2	applied	\N	\N	\N	\N	99762	99762	99991
21871	32291	3	applied	\N	\N	\N	\N	99764	99764	99992
21871	32296	4	applied	\N	\N	\N	\N	99778	99778	99993
21871	32299	5	applied	\N	\N	\N	\N	99785	99785	99994
21871	32302	6	applied	\N	\N	\N	\N	99799	99799	99995
21871	32305	7	applied	\N	\N	\N	\N	99806	99806	99996
21871	32306	8	applied	\N	\N	\N	\N	99808	99808	99997
21871	32307	9	applied	\N	\N	\N	\N	99810	99810	99998
21871	32308	10	applied	\N	\N	\N	\N	99812	99812	99999
21871	32317	13	applied	\N	\N	\N	\N	99831	99831	100000
21871	32321	14	applied	\N	\N	\N	\N	99843	99843	100001
21871	32322	15	applied	\N	\N	\N	\N	99845	99845	100002
21871	32327	16	applied	\N	\N	\N	\N	99860	99860	100003
21871	32330	17	applied	\N	\N	\N	\N	99867	99867	100004
21871	32331	18	applied	\N	\N	\N	\N	99869	99869	100005
21871	32335	19	applied	\N	\N	\N	\N	99881	99881	100006
21871	32338	20	applied	\N	\N	\N	\N	99892	99892	100007
21871	32339	21	applied	\N	\N	\N	\N	99894	99894	100008
21871	32344	22	applied	\N	\N	\N	\N	99907	99907	100009
21871	32345	23	applied	\N	\N	\N	\N	99909	99909	100010
21871	32346	24	applied	\N	\N	\N	\N	99911	99911	100011
21871	32347	25	applied	\N	\N	\N	\N	99913	99913	100012
21871	32356	26	applied	\N	\N	\N	\N	99932	99932	100013
21871	32359	27	applied	\N	\N	\N	\N	99940	99940	100014
21871	32362	28	applied	\N	\N	\N	\N	99948	99948	100015
21871	32365	29	applied	\N	\N	\N	\N	99958	99958	100016
21871	32381	30	applied	\N	\N	\N	\N	100103	100103	100327
21846	31907	50	applied	\N	\N	\N	\N	98443	98443	98444
21846	31908	51	applied	\N	\N	\N	\N	98445	98445	98446
21846	31909	52	applied	\N	\N	\N	\N	98447	98447	98448
21846	31917	53	applied	\N	\N	\N	\N	98469	98469	98470
21846	31920	54	applied	\N	\N	\N	\N	98482	98482	98483
21846	31921	55	applied	\N	\N	\N	\N	98484	98484	98485
21846	31922	56	applied	\N	\N	\N	\N	98486	98486	98487
21846	31930	57	applied	\N	\N	\N	\N	98503	98503	98504
21846	31934	58	applied	\N	\N	\N	\N	98518	98518	98519
21846	31936	59	applied	\N	\N	\N	\N	98522	98522	98523
21846	31937	60	applied	\N	\N	\N	\N	98524	98524	98525
21846	31943	61	applied	\N	\N	\N	\N	98537	98537	98538
21846	31946	62	applied	\N	\N	\N	\N	98545	98545	98546
21846	31949	63	applied	\N	\N	\N	\N	98553	98553	98554
21846	31953	64	applied	\N	\N	\N	\N	98562	98562	98563
21846	31955	65	applied	\N	\N	\N	\N	98568	98568	98569
21846	31957	66	applied	\N	\N	\N	\N	98579	98579	98580
21846	31959	67	applied	\N	\N	\N	\N	98585	98585	98586
21846	31961	68	applied	\N	\N	\N	\N	98588	98588	98589
21846	31964	69	applied	\N	\N	\N	\N	98597	98597	98598
21846	31966	70	applied	\N	\N	\N	\N	98602	98602	98603
21846	31968	71	applied	\N	\N	\N	\N	98607	98607	98608
21846	31970	72	applied	\N	\N	\N	\N	98617	98617	98618
21846	31971	73	applied	\N	\N	\N	\N	98619	98619	98620
21846	31974	74	applied	\N	\N	\N	\N	98627	98627	98628
21846	31976	75	applied	\N	\N	\N	\N	98632	98632	98633
21846	31977	76	applied	\N	\N	\N	\N	98634	98634	98635
21846	31978	77	applied	\N	\N	\N	\N	98636	98636	98637
21846	31982	78	applied	\N	\N	\N	\N	98648	98648	98649
21846	31986	79	applied	\N	\N	\N	\N	98658	98658	98659
21846	31989	80	applied	\N	\N	\N	\N	98665	98665	98666
21846	31990	81	applied	\N	\N	\N	\N	98667	98667	98668
21846	31996	82	applied	\N	\N	\N	\N	98681	98681	98682
21846	31997	83	applied	\N	\N	\N	\N	98683	98683	98684
21846	32002	84	applied	\N	\N	\N	\N	98694	98694	98695
21846	32006	85	applied	\N	\N	\N	\N	98705	98705	98706
21846	32009	86	applied	\N	\N	\N	\N	98733	98733	98734
21846	32012	87	applied	\N	\N	\N	\N	98741	98741	98742
21846	32015	88	applied	\N	\N	\N	\N	98753	98753	98754
21846	32019	89	applied	\N	\N	\N	\N	98762	98762	98763
21846	32022	90	applied	\N	\N	\N	\N	98773	98773	98774
21846	32025	92	applied	\N	\N	\N	\N	98783	98783	98784
21846	32026	93	applied	\N	\N	\N	\N	98785	98785	98786
21846	32031	94	applied	\N	\N	\N	\N	98797	98797	98798
21846	32034	95	applied	\N	\N	\N	\N	98806	98806	98807
21846	32037	96	applied	\N	\N	\N	\N	98823	98823	98824
21846	32040	97	applied	\N	\N	\N	\N	98869	98869	98870
21846	32041	98	applied	\N	\N	\N	\N	98871	98871	98872
21846	32042	99	applied	\N	\N	\N	\N	98873	98873	98874
21846	32049	100	applied	\N	\N	\N	\N	98892	98892	98893
21846	32059	101	applied	\N	\N	\N	\N	98939	98939	98940
21846	32062	102	applied	\N	\N	\N	\N	98947	98947	98948
21846	32065	103	applied	\N	\N	\N	\N	98957	98957	98958
21846	32068	104	applied	\N	\N	\N	\N	98966	98966	98967
21846	32071	105	applied	\N	\N	\N	\N	98974	98974	98975
21846	32074	106	applied	\N	\N	\N	\N	98984	98984	98985
21846	32077	107	applied	\N	\N	\N	\N	98996	98996	98997
21846	32080	108	applied	\N	\N	\N	\N	99007	99007	99008
21846	32083	109	applied	\N	\N	\N	\N	99016	99016	99017
21846	32086	110	applied	\N	\N	\N	\N	99026	99026	99027
21846	32089	111	applied	\N	\N	\N	\N	99034	99034	99035
21846	32092	112	applied	\N	\N	\N	\N	99044	99044	99045
21846	32093	113	applied	\N	\N	\N	\N	99048	99048	99236
21846	32094	114	applied	\N	\N	\N	\N	99050	99050	99237
21846	32102	115	applied	\N	\N	\N	\N	99069	99069	99238
21846	32105	116	applied	\N	\N	\N	\N	99078	99078	99239
21846	32108	117	applied	\N	\N	\N	\N	99086	99086	99240
21846	32111	118	applied	\N	\N	\N	\N	99096	99096	99241
21846	32112	119	applied	\N	\N	\N	\N	99098	99098	99242
21846	32118	120	applied	\N	\N	\N	\N	99122	99122	99243
21846	32119	121	applied	\N	\N	\N	\N	99124	99124	99244
21846	32124	122	applied	\N	\N	\N	\N	99139	99139	99245
21846	32127	123	applied	\N	\N	\N	\N	99147	99147	99246
21846	32130	124	applied	\N	\N	\N	\N	99159	99159	99247
21846	32133	125	applied	\N	\N	\N	\N	99172	99172	99248
21851	32607	0	applied	\N	\N	\N	\N	100857	100857	100858
21851	32608	1	applied	\N	\N	\N	\N	100859	100859	100860
21851	32609	2	applied	\N	\N	\N	\N	100861	100861	100862
21854	32613	0	applied	\N	\N	\N	\N	100870	100870	100871
21854	32614	1	applied	\N	\N	\N	\N	100872	100872	100873
21854	32615	2	applied	\N	\N	\N	\N	100874	100874	100875
21854	32616	3	applied	\N	\N	\N	\N	100876	100876	100877
21854	32617	4	applied	\N	\N	\N	\N	100878	100878	100879
21854	32618	5	applied	\N	\N	\N	\N	100880	100880	100881
21854	32619	6	applied	\N	\N	\N	\N	100882	100882	100883
21854	32620	7	applied	\N	\N	\N	\N	100884	100884	100885
21854	32621	8	applied	\N	\N	\N	\N	100886	100886	100887
21860	32625	0	applied	\N	\N	\N	\N	100906	100906	100907
21860	32626	1	applied	\N	\N	\N	\N	100908	100908	100909
21860	32627	2	applied	\N	\N	\N	\N	100910	100910	100911
21863	32634	0	applied	\N	\N	\N	\N	100927	100927	100928
21863	32635	1	applied	\N	\N	\N	\N	100929	100929	100930
21863	32636	2	applied	\N	\N	\N	\N	100931	100931	100932
21865	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21865	32638	1	applied	\N	\N	\N	\N	100937	100937	100938
21865	32639	2	applied	\N	\N	\N	\N	100939	100939	100940
21868	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21868	32638	1	applied	\N	\N	\N	\N	100937	100937	100938
21868	32639	2	applied	\N	\N	\N	\N	100939	100939	100940
21873	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21873	32640	1	applied	\N	\N	\N	\N	100984	100984	100985
21873	32641	2	applied	\N	\N	\N	\N	100986	100986	100987
21873	32638	3	applied	\N	\N	\N	\N	100937	100937	100940
21873	32642	4	applied	\N	\N	\N	\N	100988	100988	100989
21873	32643	5	applied	\N	\N	\N	\N	100990	100990	100991
21873	32644	6	applied	\N	\N	\N	\N	100992	100992	100993
21873	32645	7	applied	\N	\N	\N	\N	100994	100994	100995
21875	32628	0	applied	\N	\N	\N	\N	100913	100913	100914
21875	32631	1	applied	\N	\N	\N	\N	100919	100919	100920
21875	32634	2	applied	\N	\N	\N	\N	100927	100927	100928
21875	32637	3	applied	\N	\N	\N	\N	100935	100935	100936
21875	32640	4	applied	\N	\N	\N	\N	100984	100984	100985
21875	32641	5	applied	\N	\N	\N	\N	100986	100986	100987
21875	32629	6	applied	\N	\N	\N	\N	100915	100915	100916
21875	32632	7	applied	\N	\N	\N	\N	100921	100921	100997
21875	32630	8	applied	\N	\N	\N	\N	100917	100917	100922
21875	32636	9	applied	\N	\N	\N	\N	100931	100931	100998
21875	32638	10	applied	\N	\N	\N	\N	100937	100937	100999
21875	32642	11	applied	\N	\N	\N	\N	100988	100988	100946
21875	32643	12	applied	\N	\N	\N	\N	100990	100990	100940
21870	32172	14	applied	\N	\N	\N	\N	99613	99613	99341
21870	32173	15	applied	\N	\N	\N	\N	99614	99614	99343
21870	32174	16	applied	\N	\N	\N	\N	99410	99410	99345
21870	32274	17	applied	\N	\N	\N	\N	99718	99718	99719
21870	32040	18	applied	\N	\N	\N	\N	98869	98869	98870
21870	32041	19	applied	\N	\N	\N	\N	98871	98871	98872
21870	32042	20	applied	\N	\N	\N	\N	98873	98873	98874
21870	32049	21	applied	\N	\N	\N	\N	98892	98892	98893
21870	32059	22	applied	\N	\N	\N	\N	98939	98939	98940
21870	32062	23	applied	\N	\N	\N	\N	98947	98947	98948
21870	32065	24	applied	\N	\N	\N	\N	98957	98957	98958
21870	32068	25	applied	\N	\N	\N	\N	98966	98966	98967
21870	32071	26	applied	\N	\N	\N	\N	98974	98974	98975
21870	32074	27	applied	\N	\N	\N	\N	98984	98984	98985
21870	32077	28	applied	\N	\N	\N	\N	98996	98996	98997
21870	32080	29	applied	\N	\N	\N	\N	99007	99007	99008
21870	32083	30	applied	\N	\N	\N	\N	99016	99016	99017
21870	32086	31	applied	\N	\N	\N	\N	99026	99026	99027
21870	32089	32	applied	\N	\N	\N	\N	99034	99034	99035
21870	32092	33	applied	\N	\N	\N	\N	99044	99044	99045
21870	32093	34	applied	\N	\N	\N	\N	99048	99048	99236
21870	32094	35	applied	\N	\N	\N	\N	99050	99050	99237
21870	32102	36	applied	\N	\N	\N	\N	99069	99069	99238
21870	32105	37	applied	\N	\N	\N	\N	99078	99078	99239
21870	32108	38	applied	\N	\N	\N	\N	99086	99086	99240
21870	32111	39	applied	\N	\N	\N	\N	99096	99096	99241
21870	32112	40	applied	\N	\N	\N	\N	99098	99098	99242
21870	32118	41	applied	\N	\N	\N	\N	99122	99122	99243
21870	32119	42	applied	\N	\N	\N	\N	99124	99124	99244
21870	32124	43	applied	\N	\N	\N	\N	99139	99139	99245
21870	32127	44	applied	\N	\N	\N	\N	99147	99147	99246
21870	32130	45	applied	\N	\N	\N	\N	99159	99159	99247
21870	32133	46	applied	\N	\N	\N	\N	99172	99172	99248
21870	32136	47	applied	\N	\N	\N	\N	99181	99181	99249
21870	32139	48	applied	\N	\N	\N	\N	99189	99189	99250
21870	32142	49	applied	\N	\N	\N	\N	99196	99196	99251
21870	32145	50	applied	\N	\N	\N	\N	99206	99206	99252
21870	32148	51	applied	\N	\N	\N	\N	99218	99218	99253
21870	32149	52	applied	\N	\N	\N	\N	99220	99220	99616
21870	32154	53	applied	\N	\N	\N	\N	99289	99289	99617
21870	32157	54	applied	\N	\N	\N	\N	99299	99299	99618
21870	32158	55	applied	\N	\N	\N	\N	99301	99301	99619
21870	32164	56	applied	\N	\N	\N	\N	99314	99314	99620
21870	32168	57	applied	\N	\N	\N	\N	99324	99324	99621
21870	32171	58	applied	\N	\N	\N	\N	99338	99338	99622
21870	32177	59	applied	\N	\N	\N	\N	99355	99355	99623
21870	32180	60	applied	\N	\N	\N	\N	99364	99364	99624
21870	32183	61	applied	\N	\N	\N	\N	99371	99371	99625
21870	32186	62	applied	\N	\N	\N	\N	99381	99381	99626
21870	32191	63	applied	\N	\N	\N	\N	99394	99394	99627
21870	32194	64	applied	\N	\N	\N	\N	99403	99403	99628
21870	32195	65	applied	\N	\N	\N	\N	99405	99405	99630
21870	32202	66	applied	\N	\N	\N	\N	99422	99422	99631
21870	32205	67	applied	\N	\N	\N	\N	99453	99453	99632
21870	32206	68	applied	\N	\N	\N	\N	99455	99455	99633
21870	32207	69	applied	\N	\N	\N	\N	99457	99457	99634
21870	32214	70	applied	\N	\N	\N	\N	99474	99474	99635
21870	32217	71	applied	\N	\N	\N	\N	99480	99480	99636
21870	32222	72	applied	\N	\N	\N	\N	99489	99489	99637
21870	32225	73	applied	\N	\N	\N	\N	99497	99497	99638
21870	32228	74	applied	\N	\N	\N	\N	99505	99505	99639
21870	32231	75	applied	\N	\N	\N	\N	99515	99515	99640
21870	32235	76	applied	\N	\N	\N	\N	99525	99525	99641
21870	32239	77	applied	\N	\N	\N	\N	99539	99539	99642
21870	32242	78	applied	\N	\N	\N	\N	99553	99553	99643
21870	32243	79	applied	\N	\N	\N	\N	99555	99555	99644
21870	32248	80	applied	\N	\N	\N	\N	99567	99567	99645
21870	32251	81	applied	\N	\N	\N	\N	99575	99575	99646
21870	32255	82	applied	\N	\N	\N	\N	99586	99586	99647
21870	32258	83	applied	\N	\N	\N	\N	99594	99594	99648
21870	32261	84	applied	\N	\N	\N	\N	99602	99602	99649
21870	32264	85	applied	\N	\N	\N	\N	99650	99650	99651
21870	32268	86	applied	\N	\N	\N	\N	99699	99699	99985
21870	32271	87	applied	\N	\N	\N	\N	99710	99710	99986
21870	32278	88	applied	\N	\N	\N	\N	99728	99728	99987
21870	32279	89	applied	\N	\N	\N	\N	99730	99730	99988
21870	32280	90	applied	\N	\N	\N	\N	99732	99732	99989
21870	32275	91	applied	\N	\N	\N	\N	99720	99720	99721
21870	32276	92	applied	\N	\N	\N	\N	99724	99724	99725
21870	32277	93	applied	\N	\N	\N	\N	99726	99726	99727
21870	32027	94	applied	\N	\N	\N	\N	98787	98787	98788
21870	32028	95	applied	\N	\N	\N	\N	98789	98789	98790
21870	32032	96	applied	\N	\N	\N	\N	98799	98799	100952
21870	32035	97	applied	\N	\N	\N	\N	98808	98808	100953
21870	32038	98	applied	\N	\N	\N	\N	98825	98825	98804
21870	32029	99	applied	\N	\N	\N	\N	98791	98791	100954
21870	32030	100	applied	\N	\N	\N	\N	98793	98793	99284
21870	32033	101	applied	\N	\N	\N	\N	98803	98803	100955
21870	32036	102	applied	\N	\N	\N	\N	98810	98810	98826
21870	32046	103	applied	\N	\N	\N	\N	98881	98881	100956
21870	32047	104	applied	\N	\N	\N	\N	98883	98883	98878
21870	32048	105	applied	\N	\N	\N	\N	98885	98885	100957
21870	32050	106	applied	\N	\N	\N	\N	98894	98894	100958
21870	32053	107	applied	\N	\N	\N	\N	98908	98908	100959
21870	32056	108	applied	\N	\N	\N	\N	98916	98916	100960
21870	32058	109	applied	\N	\N	\N	\N	98921	98921	100961
21870	32060	110	applied	\N	\N	\N	\N	98941	98941	98907
21870	32063	111	applied	\N	\N	\N	\N	98949	98949	98909
21870	32039	112	applied	\N	\N	\N	\N	98827	98827	98913
21870	32043	113	applied	\N	\N	\N	\N	98875	98875	98915
21870	32044	114	applied	\N	\N	\N	\N	98877	98877	100962
21870	32045	115	applied	\N	\N	\N	\N	98879	98879	100963
21870	32051	116	applied	\N	\N	\N	\N	98896	98896	100964
21870	32052	117	applied	\N	\N	\N	\N	98906	98906	98922
21870	32054	118	applied	\N	\N	\N	\N	98912	98912	100965
21870	32055	119	applied	\N	\N	\N	\N	98914	98914	100966
21870	32057	120	applied	\N	\N	\N	\N	98919	98919	100967
21870	32061	121	applied	\N	\N	\N	\N	98943	98943	98950
21870	32064	122	applied	\N	\N	\N	\N	98951	98951	98952
21874	32637	0	applied	\N	\N	\N	\N	100935	100935	100936
21874	32640	1	applied	\N	\N	\N	\N	100984	100984	100985
21874	32641	2	applied	\N	\N	\N	\N	100986	100986	100987
21874	32638	3	applied	\N	\N	\N	\N	100937	100937	100940
21874	32642	4	applied	\N	\N	\N	\N	100988	100988	100989
21874	32643	5	applied	\N	\N	\N	\N	100990	100990	100991
21874	32644	6	applied	\N	\N	\N	\N	100992	100992	100993
21874	32645	7	applied	\N	\N	\N	\N	100994	100994	100995
21876	32646	0	applied	\N	\N	\N	\N	101004	101004	101005
21876	32647	1	applied	\N	\N	\N	\N	101006	101006	101007
21876	32648	2	applied	\N	\N	\N	\N	101008	101008	101009
21871	32382	31	applied	\N	\N	\N	\N	100105	100105	100328
21871	32387	32	applied	\N	\N	\N	\N	100121	100121	100329
21871	32390	33	applied	\N	\N	\N	\N	100134	100134	100330
21879	32652	0	applied	\N	\N	\N	\N	101018	101018	101019
21879	32653	1	applied	\N	\N	\N	\N	101020	101020	101021
21879	32654	2	applied	\N	\N	\N	\N	101022	101022	101023
21879	32655	3	applied	\N	\N	\N	\N	101024	101024	101025
21879	32656	4	applied	\N	\N	\N	\N	101026	101026	101027
21879	32657	5	applied	\N	\N	\N	\N	101028	101028	101029
21891	32679	0	applied	\N	\N	\N	\N	101084	101084	101085
21891	32680	1	applied	\N	\N	\N	\N	101086	101086	101087
21894	32681	0	applied	\N	\N	\N	\N	101089	101089	101090
21894	32679	1	applied	\N	\N	\N	\N	101084	101084	101085
21894	32680	2	applied	\N	\N	\N	\N	101086	101086	101087
21898	32688	0	applied	\N	\N	\N	\N	101109	101109	101110
21898	32689	1	applied	\N	\N	\N	\N	101111	101111	101112
21898	32690	2	applied	\N	\N	\N	\N	101113	101113	101114
21898	32691	3	applied	\N	\N	\N	\N	101115	101115	101116
21898	32692	4	applied	\N	\N	\N	\N	101117	101117	101118
21898	32693	5	applied	\N	\N	\N	\N	101119	101119	101120
21920	32731	0	applied	\N	\N	\N	\N	101257	101257	101258
21920	32732	1	applied	\N	\N	\N	\N	101259	101259	101260
21920	32733	2	applied	\N	\N	\N	\N	101261	101261	101262
21920	32734	3	applied	\N	\N	\N	\N	101263	101263	101264
21920	32735	4	applied	\N	\N	\N	\N	101265	101265	101266
21920	32736	5	applied	\N	\N	\N	\N	101267	101267	101268
21926	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21926	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21926	32763	2	applied	\N	\N	\N	\N	101324	101324	101325
21930	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21930	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21930	32763	2	applied	\N	\N	\N	\N	101324	101324	101325
21933	32769	0	applied	\N	\N	\N	\N	101343	101343	101344
21933	32770	1	applied	\N	\N	\N	\N	101345	101345	101346
21938	32771	0	applied	\N	\N	\N	\N	101351	101351	101352
21938	32772	1	applied	\N	\N	\N	\N	101353	101353	101354
21938	32773	2	applied	\N	\N	\N	\N	101355	101355	101356
21939	32771	0	applied	\N	\N	\N	\N	101351	101351	101352
21939	32772	1	applied	\N	\N	\N	\N	101353	101353	101354
21939	32773	2	applied	\N	\N	\N	\N	101355	101355	101356
21941	32774	0	applied	\N	\N	\N	\N	101359	101359	101360
21941	32775	1	applied	\N	\N	\N	\N	101361	101361	101362
21941	32776	2	applied	\N	\N	\N	\N	101363	101363	101364
21944	32784	0	applied	\N	\N	\N	\N	101382	101382	101383
21944	32785	1	applied	\N	\N	\N	\N	101384	101384	101385
21944	32786	2	applied	\N	\N	\N	\N	101386	101386	101387
21947	32787	0	applied	\N	\N	\N	\N	101390	101390	101391
21947	32788	1	applied	\N	\N	\N	\N	101392	101392	101393
21947	32789	2	applied	\N	\N	\N	\N	101394	101394	101395
21951	32793	0	applied	\N	\N	\N	\N	101408	101408	101409
21951	32794	1	applied	\N	\N	\N	\N	101410	101410	101411
21951	32795	2	applied	\N	\N	\N	\N	101412	101412	101413
21951	32796	3	applied	\N	\N	\N	\N	101414	101414	101415
21951	32797	4	applied	\N	\N	\N	\N	101416	101416	101417
21951	32798	5	applied	\N	\N	\N	\N	101418	101418	101419
21951	32799	6	applied	\N	\N	\N	\N	101420	101420	101421
21951	32800	7	applied	\N	\N	\N	\N	101422	101422	101423
21951	32801	8	applied	\N	\N	\N	\N	101424	101424	101425
21957	32814	0	applied	\N	\N	\N	\N	101457	101457	101458
21957	32815	1	applied	\N	\N	\N	\N	101459	101459	101460
21957	32816	2	applied	\N	\N	\N	\N	101461	101461	101462
21957	32817	3	applied	\N	\N	\N	\N	101463	101463	101464
21957	32818	4	applied	\N	\N	\N	\N	101465	101465	101466
21957	32819	5	applied	\N	\N	\N	\N	101467	101467	101468
21957	32820	6	applied	\N	\N	\N	\N	101469	101469	101470
21957	32821	7	applied	\N	\N	\N	\N	101471	101471	101472
21957	32822	8	applied	\N	\N	\N	\N	101473	101473	101474
21959	32814	0	applied	\N	\N	\N	\N	101457	101457	101458
21959	32815	1	applied	\N	\N	\N	\N	101459	101459	101460
21959	32816	2	applied	\N	\N	\N	\N	101461	101461	101462
21959	32817	3	applied	\N	\N	\N	\N	101463	101463	101464
21959	32818	4	applied	\N	\N	\N	\N	101465	101465	101466
21959	32819	5	applied	\N	\N	\N	\N	101467	101467	101468
21959	32820	6	applied	\N	\N	\N	\N	101469	101469	101470
21959	32821	7	applied	\N	\N	\N	\N	101471	101471	101472
21959	32822	8	applied	\N	\N	\N	\N	101473	101473	101474
21961	32823	0	applied	\N	\N	\N	\N	101483	101483	101484
21961	32824	1	applied	\N	\N	\N	\N	101485	101485	101486
21961	32825	2	applied	\N	\N	\N	\N	101487	101487	101488
21972	32829	0	applied	\N	\N	\N	\N	101513	101513	101514
21972	32830	1	applied	\N	\N	\N	\N	101515	101515	101516
21972	32831	2	applied	\N	\N	\N	\N	101517	101517	101518
21972	32832	3	applied	\N	\N	\N	\N	101519	101519	101520
21972	32833	4	applied	\N	\N	\N	\N	101521	101521	101522
21972	32834	5	applied	\N	\N	\N	\N	101523	101523	101524
21979	32835	0	applied	\N	\N	\N	\N	101530	101530	101531
21979	32836	1	applied	\N	\N	\N	\N	101532	101532	101533
21979	32837	2	applied	\N	\N	\N	\N	101534	101534	101535
21980	32835	0	applied	\N	\N	\N	\N	101530	101530	101531
21980	32836	1	applied	\N	\N	\N	\N	101532	101532	101533
21980	32837	2	applied	\N	\N	\N	\N	101534	101534	101535
21985	32847	0	applied	\N	\N	\N	\N	101567	101567	101568
21985	32848	1	applied	\N	\N	\N	\N	101569	101569	101570
21985	32849	2	applied	\N	\N	\N	\N	101571	101571	101572
21991	32861	0	applied	\N	\N	\N	\N	101605	101605	101606
21991	32862	1	applied	\N	\N	\N	\N	101607	101607	101608
21991	32863	2	applied	\N	\N	\N	\N	101609	101609	101610
21995	32870	0	applied	\N	\N	\N	\N	101629	101629	101630
21995	32871	1	applied	\N	\N	\N	\N	101631	101631	101632
21995	32872	2	applied	\N	\N	\N	\N	101633	101633	101634
21998	32876	0	applied	\N	\N	\N	\N	101645	101645	101646
21998	32877	1	applied	\N	\N	\N	\N	101647	101647	101648
21998	32878	2	applied	\N	\N	\N	\N	101649	101649	101650
22000	32879	0	applied	\N	\N	\N	\N	101694	101694	101695
22000	32880	1	applied	\N	\N	\N	\N	101696	101696	101697
22000	32881	2	applied	\N	\N	\N	\N	101698	101698	101699
22005	32888	0	applied	\N	\N	\N	\N	101718	101718	101719
22005	32889	1	applied	\N	\N	\N	\N	101720	101720	101721
22005	32890	2	applied	\N	\N	\N	\N	101722	101722	101723
22005	32891	3	applied	\N	\N	\N	\N	101724	101724	101725
22005	29757	4	applied	\N	\N	\N	\N	101726	101726	91928
22005	32892	5	applied	\N	\N	\N	\N	101727	101727	101728
22005	32893	6	applied	\N	\N	\N	\N	101729	101729	101730
22007	32894	0	applied	\N	\N	\N	\N	101733	101733	101734
22007	32895	1	applied	\N	\N	\N	\N	101735	101735	101736
22007	32896	2	applied	\N	\N	\N	\N	101737	101737	101738
22010	32897	0	applied	\N	\N	\N	\N	101744	101744	101745
22010	32899	2	applied	\N	\N	\N	\N	101748	101748	101752
22014	32903	0	applied	\N	\N	\N	\N	101761	101761	101762
22014	32904	1	applied	\N	\N	\N	\N	101763	101763	101764
21875	32633	13	applied	\N	\N	\N	\N	100923	100923	101000
21875	32635	14	applied	\N	\N	\N	\N	100929	100929	101001
21875	32639	15	applied	\N	\N	\N	\N	100939	100939	100991
21875	32644	16	applied	\N	\N	\N	\N	100992	100992	100993
21875	32645	17	applied	\N	\N	\N	\N	100994	100994	100995
21883	32664	0	applied	\N	\N	\N	\N	101044	101044	101045
21883	32665	1	applied	\N	\N	\N	\N	101046	101046	101047
21883	32666	2	applied	\N	\N	\N	\N	101048	101048	101049
21885	32667	0	applied	\N	\N	\N	\N	101054	101054	101055
21885	32668	1	applied	\N	\N	\N	\N	101056	101056	101057
21885	32669	2	applied	\N	\N	\N	\N	101058	101058	101059
21888	32676	0	applied	\N	\N	\N	\N	101078	101078	101079
21888	32677	1	applied	\N	\N	\N	\N	101080	101080	101081
21888	32678	2	applied	\N	\N	\N	\N	101082	101082	101083
21897	32685	0	applied	\N	\N	\N	\N	101103	101103	101104
21897	32686	1	applied	\N	\N	\N	\N	101105	101105	101106
21897	32687	2	applied	\N	\N	\N	\N	101107	101107	101108
21899	32688	0	applied	\N	\N	\N	\N	101109	101109	101110
21899	32689	1	applied	\N	\N	\N	\N	101111	101111	101112
21899	32690	2	applied	\N	\N	\N	\N	101113	101113	101114
21899	32691	3	applied	\N	\N	\N	\N	101115	101115	101116
21899	32692	4	applied	\N	\N	\N	\N	101117	101117	101118
21899	32693	5	applied	\N	\N	\N	\N	101119	101119	101120
21904	32697	0	applied	\N	\N	\N	\N	101135	101135	101136
21904	32698	1	applied	\N	\N	\N	\N	101137	101137	101138
21904	32699	2	applied	\N	\N	\N	\N	101139	101139	101140
21906	32700	0	applied	\N	\N	\N	\N	101178	101178	101179
21906	32701	1	applied	\N	\N	\N	\N	101180	101180	101181
21906	32702	2	applied	\N	\N	\N	\N	101182	101182	101183
21911	32712	0	applied	\N	\N	\N	\N	101210	101210	101211
21911	32713	1	applied	\N	\N	\N	\N	101212	101212	101213
21911	32714	2	applied	\N	\N	\N	\N	101214	101214	101215
21913	32715	0	applied	\N	\N	\N	\N	101217	101217	101218
21913	32716	1	applied	\N	\N	\N	\N	101219	101219	101220
21913	32717	2	applied	\N	\N	\N	\N	101221	101221	101222
21918	32725	0	applied	\N	\N	\N	\N	101244	101244	101245
21918	32726	1	applied	\N	\N	\N	\N	101246	101246	101247
21918	32727	2	applied	\N	\N	\N	\N	101248	101248	101249
21918	32728	3	applied	\N	\N	\N	\N	101250	101250	101251
21918	32729	4	applied	\N	\N	\N	\N	101252	101252	101253
21918	32730	5	applied	\N	\N	\N	\N	101254	101254	101255
21921	32733	0	applied	\N	\N	\N	\N	101261	101261	101262
21921	32734	1	applied	\N	\N	\N	\N	101263	101263	101264
21921	32735	2	applied	\N	\N	\N	\N	101265	101265	101266
21921	32736	3	applied	\N	\N	\N	\N	101267	101267	101268
21925	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21925	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21925	32763	2	applied	\N	\N	\N	\N	101324	101324	101325
21928	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21928	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21928	32763	2	applied	\N	\N	\N	\N	101324	101324	101325
21945	32787	0	applied	\N	\N	\N	\N	101390	101390	101391
21945	32788	1	applied	\N	\N	\N	\N	101392	101392	101393
21945	32789	2	applied	\N	\N	\N	\N	101394	101394	101395
21950	32793	0	applied	\N	\N	\N	\N	101408	101408	101409
21950	32794	1	applied	\N	\N	\N	\N	101410	101410	101411
21950	32795	2	applied	\N	\N	\N	\N	101412	101412	101413
21950	32796	3	applied	\N	\N	\N	\N	101414	101414	101415
21950	32797	4	applied	\N	\N	\N	\N	101416	101416	101417
21950	32798	5	applied	\N	\N	\N	\N	101418	101418	101419
21950	32799	6	applied	\N	\N	\N	\N	101420	101420	101421
21950	32800	7	applied	\N	\N	\N	\N	101422	101422	101423
21950	32801	8	applied	\N	\N	\N	\N	101424	101424	101425
21953	32808	0	applied	\N	\N	\N	\N	101443	101443	101444
21953	32809	1	applied	\N	\N	\N	\N	101445	101445	101446
21953	32810	2	applied	\N	\N	\N	\N	101447	101447	101448
21953	32811	3	applied	\N	\N	\N	\N	101449	101449	101450
21953	32812	4	applied	\N	\N	\N	\N	101451	101451	101452
21953	32813	5	applied	\N	\N	\N	\N	101453	101453	101454
21956	32814	0	applied	\N	\N	\N	\N	101457	101457	101458
21956	32815	1	applied	\N	\N	\N	\N	101459	101459	101460
21956	32816	2	applied	\N	\N	\N	\N	101461	101461	101462
21956	32817	3	applied	\N	\N	\N	\N	101463	101463	101464
21956	32818	4	applied	\N	\N	\N	\N	101465	101465	101466
21956	32819	5	applied	\N	\N	\N	\N	101467	101467	101468
21956	32820	6	applied	\N	\N	\N	\N	101469	101469	101470
21956	32821	7	applied	\N	\N	\N	\N	101471	101471	101472
21956	32822	8	applied	\N	\N	\N	\N	101473	101473	101474
21958	32814	0	applied	\N	\N	\N	\N	101457	101457	101458
21958	32815	1	applied	\N	\N	\N	\N	101459	101459	101460
21958	32816	2	applied	\N	\N	\N	\N	101461	101461	101462
21958	32817	3	applied	\N	\N	\N	\N	101463	101463	101464
21958	32818	4	applied	\N	\N	\N	\N	101465	101465	101466
21958	32819	5	applied	\N	\N	\N	\N	101467	101467	101468
21958	32820	6	applied	\N	\N	\N	\N	101469	101469	101470
21958	32821	7	applied	\N	\N	\N	\N	101471	101471	101472
21958	32822	8	applied	\N	\N	\N	\N	101473	101473	101474
21964	32826	0	applied	\N	\N	\N	\N	101493	101493	101494
21964	32827	1	applied	\N	\N	\N	\N	101495	101495	101496
21964	32828	2	applied	\N	\N	\N	\N	101497	101497	101498
21965	32826	0	applied	\N	\N	\N	\N	101493	101493	101494
21965	32827	1	applied	\N	\N	\N	\N	101495	101495	101496
21965	32828	2	applied	\N	\N	\N	\N	101497	101497	101498
21968	32823	0	applied	\N	\N	\N	\N	101483	101483	101484
21968	32826	1	applied	\N	\N	\N	\N	101493	101493	101494
21968	32824	2	applied	\N	\N	\N	\N	101485	101485	101486
21968	32828	3	applied	\N	\N	\N	\N	101497	101497	101509
21968	32825	4	applied	\N	\N	\N	\N	101487	101487	101510
21968	32827	5	applied	\N	\N	\N	\N	101495	101495	101498
21974	32829	0	applied	\N	\N	\N	\N	101513	101513	101514
21974	32830	1	applied	\N	\N	\N	\N	101515	101515	101516
21974	32831	2	applied	\N	\N	\N	\N	101517	101517	101518
21974	32832	3	applied	\N	\N	\N	\N	101519	101519	101520
21974	32833	4	applied	\N	\N	\N	\N	101521	101521	101522
21974	32834	5	applied	\N	\N	\N	\N	101523	101523	101524
21976	32829	0	applied	\N	\N	\N	\N	101513	101513	101514
21976	32830	1	applied	\N	\N	\N	\N	101515	101515	101516
21976	32831	2	applied	\N	\N	\N	\N	101517	101517	101518
21976	32832	3	applied	\N	\N	\N	\N	101519	101519	101520
21976	32833	4	applied	\N	\N	\N	\N	101521	101521	101522
21976	32834	5	applied	\N	\N	\N	\N	101523	101523	101524
21978	32835	0	applied	\N	\N	\N	\N	101530	101530	101531
21978	32836	1	applied	\N	\N	\N	\N	101532	101532	101533
21978	32837	2	applied	\N	\N	\N	\N	101534	101534	101535
21987	32850	0	applied	\N	\N	\N	\N	101577	101577	101578
21987	32851	1	applied	\N	\N	\N	\N	101579	101579	101580
21987	32852	2	applied	\N	\N	\N	\N	101581	101581	101582
21990	32861	0	applied	\N	\N	\N	\N	101605	101605	101606
21990	32862	1	applied	\N	\N	\N	\N	101607	101607	101608
21990	32863	2	applied	\N	\N	\N	\N	101609	101609	101610
21878	32649	0	applied	\N	\N	\N	\N	101012	101012	101013
21878	32650	1	applied	\N	\N	\N	\N	101014	101014	101015
21878	32651	2	applied	\N	\N	\N	\N	101016	101016	101017
21884	32664	0	applied	\N	\N	\N	\N	101044	101044	101045
21884	32665	1	applied	\N	\N	\N	\N	101046	101046	101047
21884	32666	2	applied	\N	\N	\N	\N	101048	101048	101049
21886	32670	0	applied	\N	\N	\N	\N	101062	101062	101063
21886	32671	1	applied	\N	\N	\N	\N	101064	101064	101065
21886	32672	2	applied	\N	\N	\N	\N	101066	101066	101067
21889	32676	0	applied	\N	\N	\N	\N	101078	101078	101079
21889	32677	1	applied	\N	\N	\N	\N	101080	101080	101081
21889	32678	2	applied	\N	\N	\N	\N	101082	101082	101083
21893	32681	0	applied	\N	\N	\N	\N	101089	101089	101090
21893	32679	1	applied	\N	\N	\N	\N	101084	101084	101085
21893	32680	2	applied	\N	\N	\N	\N	101086	101086	101087
21895	32681	0	applied	\N	\N	\N	\N	101089	101089	101090
21895	32682	1	applied	\N	\N	\N	\N	101095	101095	101096
21895	32683	2	applied	\N	\N	\N	\N	101097	101097	101098
21895	32684	3	applied	\N	\N	\N	\N	101099	101099	101100
21900	32694	0	applied	\N	\N	\N	\N	101124	101124	101125
21900	32695	1	applied	\N	\N	\N	\N	101126	101126	101127
21900	32696	2	applied	\N	\N	\N	\N	101128	101128	101129
21902	32694	0	applied	\N	\N	\N	\N	101124	101124	101125
21902	32695	1	applied	\N	\N	\N	\N	101126	101126	101127
21902	32696	2	applied	\N	\N	\N	\N	101128	101128	101129
21907	32703	0	applied	\N	\N	\N	\N	101186	101186	101187
21907	32704	1	applied	\N	\N	\N	\N	101188	101188	101189
21907	32705	2	applied	\N	\N	\N	\N	101190	101190	101191
21907	32706	3	applied	\N	\N	\N	\N	101192	101192	101193
21907	32707	4	applied	\N	\N	\N	\N	101194	101194	101195
21907	32708	5	applied	\N	\N	\N	\N	101196	101196	101197
21909	32703	0	applied	\N	\N	\N	\N	101186	101186	101187
21909	32704	1	applied	\N	\N	\N	\N	101188	101188	101189
21909	32705	2	applied	\N	\N	\N	\N	101190	101190	101191
21909	32706	3	applied	\N	\N	\N	\N	101192	101192	101193
21909	32707	4	applied	\N	\N	\N	\N	101194	101194	101195
21909	32708	5	applied	\N	\N	\N	\N	101196	101196	101197
21914	32718	0	applied	\N	\N	\N	\N	101224	101224	101225
21916	32719	0	applied	\N	\N	\N	\N	101227	101227	101228
21916	32720	1	applied	\N	\N	\N	\N	101229	101229	101230
21916	32721	3	applied	\N	\N	\N	\N	101232	101232	101233
21916	32722	4	applied	\N	\N	\N	\N	101234	101234	101235
21916	32723	5	applied	\N	\N	\N	\N	101236	101236	101237
21916	32724	6	applied	\N	\N	\N	\N	101238	101238	101239
21919	32731	0	applied	\N	\N	\N	\N	101257	101257	101258
21919	32732	1	applied	\N	\N	\N	\N	101259	101259	101260
21919	32733	2	applied	\N	\N	\N	\N	101261	101261	101262
21919	32734	3	applied	\N	\N	\N	\N	101263	101263	101264
21919	32735	4	applied	\N	\N	\N	\N	101265	101265	101266
21919	32736	5	applied	\N	\N	\N	\N	101267	101267	101268
21923	32737	0	applied	\N	\N	\N	\N	101270	101270	101271
21923	32738	1	applied	\N	\N	\N	\N	101272	101272	101273
21923	32739	2	applied	\N	\N	\N	\N	101274	101274	101275
21923	32740	3	applied	\N	\N	\N	\N	101276	101276	101277
21923	32741	4	applied	\N	\N	\N	\N	101278	101278	101279
21923	32742	5	applied	\N	\N	\N	\N	101280	101280	101281
21923	32743	6	applied	\N	\N	\N	\N	101282	101282	101283
21923	32744	7	applied	\N	\N	\N	\N	101284	101284	101285
21923	32745	8	applied	\N	\N	\N	\N	101286	101286	101287
21923	32746	9	applied	\N	\N	\N	\N	101288	101288	101289
21923	32747	10	applied	\N	\N	\N	\N	101290	101290	101291
21923	32748	11	applied	\N	\N	\N	\N	101292	101292	101293
21923	32749	12	applied	\N	\N	\N	\N	101294	101294	101295
21923	32750	13	applied	\N	\N	\N	\N	101296	101296	101297
21923	32751	14	applied	\N	\N	\N	\N	101298	101298	101299
21923	32752	15	applied	\N	\N	\N	\N	101300	101300	101301
21923	32753	16	applied	\N	\N	\N	\N	101302	101302	101303
21923	32754	17	applied	\N	\N	\N	\N	101304	101304	101305
21923	32755	18	applied	\N	\N	\N	\N	101306	101306	101307
21923	32756	19	applied	\N	\N	\N	\N	101308	101308	101309
21923	32757	20	applied	\N	\N	\N	\N	101310	101310	101311
21929	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21929	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21932	32769	0	applied	\N	\N	\N	\N	101343	101343	101344
21932	32770	1	applied	\N	\N	\N	\N	101345	101345	101346
21937	32771	0	applied	\N	\N	\N	\N	101351	101351	101352
21937	32772	1	applied	\N	\N	\N	\N	101353	101353	101354
21937	32773	2	applied	\N	\N	\N	\N	101355	101355	101356
21943	32777	0	applied	\N	\N	\N	\N	101367	101367	101368
21943	32778	1	applied	\N	\N	\N	\N	101369	101369	101370
21943	32779	2	applied	\N	\N	\N	\N	101371	101371	101371
21943	32780	3	applied	\N	\N	\N	\N	101372	101372	101373
21943	32781	4	applied	\N	\N	\N	\N	101374	101374	101375
21943	32782	5	applied	\N	\N	\N	\N	101376	101376	101377
21943	32783	6	applied	\N	\N	\N	\N	101378	101378	101379
21946	32787	0	applied	\N	\N	\N	\N	101390	101390	101391
21946	32788	1	applied	\N	\N	\N	\N	101392	101392	101393
21946	32789	2	applied	\N	\N	\N	\N	101394	101394	101395
21952	32802	0	applied	\N	\N	\N	\N	101429	101429	101430
21952	32803	1	applied	\N	\N	\N	\N	101431	101431	101432
21952	32804	2	applied	\N	\N	\N	\N	101433	101433	101434
21952	32805	3	applied	\N	\N	\N	\N	101435	101435	101436
21952	32806	4	applied	\N	\N	\N	\N	101437	101437	101438
21952	32807	5	applied	\N	\N	\N	\N	101439	101439	101440
21960	32823	0	applied	\N	\N	\N	\N	101483	101483	101484
21960	32824	1	applied	\N	\N	\N	\N	101485	101485	101486
21960	32825	2	applied	\N	\N	\N	\N	101487	101487	101488
21963	32826	0	applied	\N	\N	\N	\N	101493	101493	101494
21963	32827	1	applied	\N	\N	\N	\N	101495	101495	101496
21963	32828	2	applied	\N	\N	\N	\N	101497	101497	101498
21967	32721	0	applied	\N	\N	\N	\N	101232	101232	101233
21967	32779	1	applied	\N	\N	\N	\N	101371	101371	101371
21977	32835	0	applied	\N	\N	\N	\N	101530	101530	101531
21977	32836	1	applied	\N	\N	\N	\N	101532	101532	101533
21977	32837	2	applied	\N	\N	\N	\N	101534	101534	101535
21982	32835	0	applied	\N	\N	\N	\N	101530	101530	101531
21982	32836	1	applied	\N	\N	\N	\N	101532	101532	101533
21982	32837	2	applied	\N	\N	\N	\N	101534	101534	101535
21984	32844	0	applied	\N	\N	\N	\N	101559	101559	101560
21984	32845	1	applied	\N	\N	\N	\N	101561	101561	101562
21984	32846	2	applied	\N	\N	\N	\N	101563	101563	101564
21986	32847	0	applied	\N	\N	\N	\N	101567	101567	101568
21986	32848	1	applied	\N	\N	\N	\N	101569	101569	101570
21986	32849	2	applied	\N	\N	\N	\N	101571	101571	101572
21989	32855	0	applied	\N	\N	\N	\N	101591	101591	101592
21989	32856	1	applied	\N	\N	\N	\N	101593	101593	101594
21989	32857	2	applied	\N	\N	\N	\N	101595	101595	101596
21989	32858	3	applied	\N	\N	\N	\N	101597	101597	101598
21989	32859	4	applied	\N	\N	\N	\N	101599	101599	101600
21989	32860	5	applied	\N	\N	\N	\N	101601	101601	101602
21905	32613	47	applied	\N	\N	\N	\N	100870	100870	100871
21905	32614	48	applied	\N	\N	\N	\N	100872	100872	100873
21905	32615	49	applied	\N	\N	\N	\N	100874	100874	100875
21905	32622	50	applied	\N	\N	\N	\N	100894	100894	100895
21905	32625	51	applied	\N	\N	\N	\N	100906	100906	100907
21905	32628	52	applied	\N	\N	\N	\N	100913	100913	100914
21905	32631	53	applied	\N	\N	\N	\N	100919	100919	100920
21905	32634	54	applied	\N	\N	\N	\N	100927	100927	100928
21905	32637	55	applied	\N	\N	\N	\N	100935	100935	100936
21905	32640	56	applied	\N	\N	\N	\N	100984	100984	100985
21905	32641	57	applied	\N	\N	\N	\N	100986	100986	100987
21905	32646	58	applied	\N	\N	\N	\N	101004	101004	101005
21905	32649	59	applied	\N	\N	\N	\N	101012	101012	101013
21905	32652	60	applied	\N	\N	\N	\N	101018	101018	101019
21905	32653	61	applied	\N	\N	\N	\N	101020	101020	101021
21905	32658	62	applied	\N	\N	\N	\N	101030	101030	101031
21905	32659	63	applied	\N	\N	\N	\N	101032	101032	101033
21905	32664	64	applied	\N	\N	\N	\N	101044	101044	101045
21905	32667	65	applied	\N	\N	\N	\N	101054	101054	101055
21905	32670	66	applied	\N	\N	\N	\N	101062	101062	101063
21905	32673	67	applied	\N	\N	\N	\N	101070	101070	101071
21905	32676	68	applied	\N	\N	\N	\N	101078	101078	101079
21905	32681	69	applied	\N	\N	\N	\N	101089	101089	101090
21905	32682	70	applied	\N	\N	\N	\N	101095	101095	101096
21905	32685	71	applied	\N	\N	\N	\N	101103	101103	101104
21905	32688	72	applied	\N	\N	\N	\N	101109	101109	101110
21905	32689	73	applied	\N	\N	\N	\N	101111	101111	101112
21905	32694	74	applied	\N	\N	\N	\N	101124	101124	101125
21905	32697	75	applied	\N	\N	\N	\N	101135	101135	101136
21905	32478	76	applied	\N	\N	\N	\N	100488	100488	100489
21905	32479	77	applied	\N	\N	\N	\N	100490	100490	100491
21905	32480	78	applied	\N	\N	\N	\N	100492	100492	100493
21905	32481	79	applied	\N	\N	\N	\N	100494	100494	100495
21905	32484	80	applied	\N	\N	\N	\N	100529	100529	100535
21905	32483	81	applied	\N	\N	\N	\N	100509	100509	100530
21905	32486	82	applied	\N	\N	\N	\N	100536	100536	100537
21905	32490	83	applied	\N	\N	\N	\N	100550	100550	101144
21905	32495	84	applied	\N	\N	\N	\N	100560	100560	101145
21905	32496	85	applied	\N	\N	\N	\N	100562	100562	100557
21905	32499	86	applied	\N	\N	\N	\N	100580	100580	101146
21905	32502	87	applied	\N	\N	\N	\N	100586	100586	101147
21905	32505	88	applied	\N	\N	\N	\N	100595	100595	101148
21905	32507	89	applied	\N	\N	\N	\N	100601	100601	101149
21905	32513	90	applied	\N	\N	\N	\N	100617	100617	100585
21905	32514	91	applied	\N	\N	\N	\N	100619	100619	100587
21905	32517	92	applied	\N	\N	\N	\N	100627	100627	101150
21905	32518	93	applied	\N	\N	\N	\N	100629	100629	101151
21905	32523	94	applied	\N	\N	\N	\N	100641	100641	101152
21905	32526	95	applied	\N	\N	\N	\N	100647	100647	100614
21905	32531	96	applied	\N	\N	\N	\N	100658	100658	101153
21905	32532	97	applied	\N	\N	\N	\N	100660	100660	101154
21905	32541	98	applied	\N	\N	\N	\N	100681	100681	101155
21905	32542	99	applied	\N	\N	\N	\N	100683	100683	101156
21905	32543	100	applied	\N	\N	\N	\N	100685	100685	101157
21905	32544	101	applied	\N	\N	\N	\N	100687	100687	100634
21905	32549	102	applied	\N	\N	\N	\N	100700	100700	100642
21905	32550	103	applied	\N	\N	\N	\N	100702	100702	101158
21905	32553	104	applied	\N	\N	\N	\N	100709	100709	101159
21905	32554	105	applied	\N	\N	\N	\N	100711	100711	100655
21905	32557	106	applied	\N	\N	\N	\N	100721	100721	101160
21905	32558	107	applied	\N	\N	\N	\N	100723	100723	101161
21905	32569	108	applied	\N	\N	\N	\N	100751	100751	101162
21905	32570	109	applied	\N	\N	\N	\N	100753	100753	100676
21905	32571	110	applied	\N	\N	\N	\N	100755	100755	101163
21905	32578	111	applied	\N	\N	\N	\N	100773	100773	101164
21905	32579	112	applied	\N	\N	\N	\N	100775	100775	101165
21905	32581	113	applied	\N	\N	\N	\N	100787	100787	101166
21905	32585	114	applied	\N	\N	\N	\N	100796	100796	101167
21905	32587	115	applied	\N	\N	\N	\N	100802	100802	100697
21905	32591	116	applied	\N	\N	\N	\N	100815	100815	101168
21905	32594	117	applied	\N	\N	\N	\N	100821	100821	101169
21905	32596	118	applied	\N	\N	\N	\N	100825	100825	101170
21905	32603	119	applied	\N	\N	\N	\N	100845	100845	101171
21905	32604	120	applied	\N	\N	\N	\N	100847	100847	101172
21905	32605	121	applied	\N	\N	\N	\N	100849	100849	100716
21905	32609	122	applied	\N	\N	\N	\N	100861	100861	100722
21905	32612	123	applied	\N	\N	\N	\N	100868	100868	100724
21905	32617	124	applied	\N	\N	\N	\N	100878	100878	101173
21905	32487	125	applied	\N	\N	\N	\N	100538	100538	101174
21908	32703	0	applied	\N	\N	\N	\N	101186	101186	101187
21908	32704	1	applied	\N	\N	\N	\N	101188	101188	101189
21908	32705	2	applied	\N	\N	\N	\N	101190	101190	101191
21908	32706	3	applied	\N	\N	\N	\N	101192	101192	101193
21908	32707	4	applied	\N	\N	\N	\N	101194	101194	101195
21908	32708	5	applied	\N	\N	\N	\N	101196	101196	101197
21910	32709	0	applied	\N	\N	\N	\N	101202	101202	101203
21910	32710	1	applied	\N	\N	\N	\N	101204	101204	101205
21910	32711	2	applied	\N	\N	\N	\N	101206	101206	101207
21915	32719	0	applied	\N	\N	\N	\N	101227	101227	101228
21915	32720	1	applied	\N	\N	\N	\N	101229	101229	101230
21915	32721	3	applied	\N	\N	\N	\N	101232	101232	101233
21915	32722	4	applied	\N	\N	\N	\N	101234	101234	101235
21915	32723	5	applied	\N	\N	\N	\N	101236	101236	101237
21915	32724	6	applied	\N	\N	\N	\N	101238	101238	101239
21917	32721	0	applied	\N	\N	\N	\N	101232	101232	101233
21917	32722	1	applied	\N	\N	\N	\N	101234	101234	101235
21924	32758	0	applied	\N	\N	\N	\N	101314	101314	101315
21924	32759	1	applied	\N	\N	\N	\N	101316	101316	101317
21924	32760	2	applied	\N	\N	\N	\N	101318	101318	101319
21927	32761	0	applied	\N	\N	\N	\N	101320	101320	101321
21927	32762	1	applied	\N	\N	\N	\N	101322	101322	101323
21927	32763	2	applied	\N	\N	\N	\N	101324	101324	101325
21931	32764	0	applied	\N	\N	\N	\N	101331	101331	101332
21931	32765	1	applied	\N	\N	\N	\N	101333	101333	101334
21931	32766	2	applied	\N	\N	\N	\N	101335	101335	101336
21931	32767	3	applied	\N	\N	\N	\N	101337	101337	101338
21931	32768	4	applied	\N	\N	\N	\N	101339	101339	101340
21934	32769	0	applied	\N	\N	\N	\N	101343	101343	101344
21934	32770	1	applied	\N	\N	\N	\N	101345	101345	101346
21936	32771	0	applied	\N	\N	\N	\N	101351	101351	101352
21936	32772	1	applied	\N	\N	\N	\N	101353	101353	101354
21936	32773	2	applied	\N	\N	\N	\N	101355	101355	101356
21940	32771	0	applied	\N	\N	\N	\N	101351	101351	101352
21940	32772	1	applied	\N	\N	\N	\N	101353	101353	101354
21940	32773	2	applied	\N	\N	\N	\N	101355	101355	101356
21942	32774	0	applied	\N	\N	\N	\N	101359	101359	101360
21942	32775	1	applied	\N	\N	\N	\N	101361	101361	101362
21942	32776	2	applied	\N	\N	\N	\N	101363	101363	101364
21949	32790	0	applied	\N	\N	\N	\N	101401	101401	101402
21949	32791	1	applied	\N	\N	\N	\N	101403	101403	101404
21949	32792	2	applied	\N	\N	\N	\N	101405	101405	101406
21955	32814	0	applied	\N	\N	\N	\N	101457	101457	101458
21955	32815	1	applied	\N	\N	\N	\N	101459	101459	101460
21955	32816	2	applied	\N	\N	\N	\N	101461	101461	101462
21955	32817	3	applied	\N	\N	\N	\N	101463	101463	101464
21955	32818	4	applied	\N	\N	\N	\N	101465	101465	101466
21955	32819	5	applied	\N	\N	\N	\N	101467	101467	101468
21955	32820	6	applied	\N	\N	\N	\N	101469	101469	101470
21955	32821	7	applied	\N	\N	\N	\N	101471	101471	101472
21955	32822	8	applied	\N	\N	\N	\N	101473	101473	101474
21962	32826	0	applied	\N	\N	\N	\N	101493	101493	101494
21962	32827	1	applied	\N	\N	\N	\N	101495	101495	101496
21962	32828	2	applied	\N	\N	\N	\N	101497	101497	101498
21966	32826	0	applied	\N	\N	\N	\N	101493	101493	101494
21966	32827	1	applied	\N	\N	\N	\N	101495	101495	101496
21966	32828	2	applied	\N	\N	\N	\N	101497	101497	101498
21973	32829	0	applied	\N	\N	\N	\N	101513	101513	101514
21973	32830	1	applied	\N	\N	\N	\N	101515	101515	101516
21973	32833	2	applied	\N	\N	\N	\N	101521	101521	101525
21973	32834	3	applied	\N	\N	\N	\N	101523	101523	101526
21975	32829	0	applied	\N	\N	\N	\N	101513	101513	101514
21975	32830	1	applied	\N	\N	\N	\N	101515	101515	101516
21975	32831	2	applied	\N	\N	\N	\N	101517	101517	101518
21975	32832	3	applied	\N	\N	\N	\N	101519	101519	101520
21975	32833	4	applied	\N	\N	\N	\N	101521	101521	101522
21975	32834	5	applied	\N	\N	\N	\N	101523	101523	101524
21981	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
21981	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
21981	32074	2	applied	\N	\N	\N	\N	98984	98984	98985
21981	32167	3	applied	\N	\N	\N	\N	99322	99322	99323
21981	32254	4	applied	\N	\N	\N	\N	99584	99584	99585
21981	32221	5	applied	\N	\N	\N	\N	99488	99488	47675
21981	32218	6	applied	\N	\N	\N	\N	99482	99482	47675
21981	32077	7	applied	\N	\N	\N	\N	98996	98996	98997
21981	32196	8	applied	\N	\N	\N	\N	99407	99407	99610
21981	32232	9	applied	\N	\N	1000000000	\N	99517	99517	99518
21981	32080	10	applied	\N	\N	\N	\N	99007	99007	99008
21981	32083	11	applied	\N	\N	\N	\N	99016	99016	99017
21981	32086	12	applied	\N	\N	\N	\N	99026	99026	99027
21981	32089	13	applied	\N	\N	\N	\N	99034	99034	99035
21981	32092	14	applied	\N	\N	\N	\N	99044	99044	99045
21981	32197	15	applied	\N	\N	\N	\N	99409	99409	99612
21981	32093	16	applied	\N	\N	\N	\N	99048	99048	99236
21981	32094	17	applied	\N	\N	\N	\N	99050	99050	99237
21981	32102	18	applied	\N	\N	\N	\N	99069	99069	99238
21981	32105	19	applied	\N	\N	\N	\N	99078	99078	99239
21981	32108	20	applied	\N	\N	\N	\N	99086	99086	99240
21981	32111	21	applied	\N	\N	\N	\N	99096	99096	99241
21981	32112	22	applied	\N	\N	\N	\N	99098	99098	99242
21981	32118	23	applied	\N	\N	\N	\N	99122	99122	99243
21981	32119	24	applied	\N	\N	\N	\N	99124	99124	99244
21981	32124	25	applied	\N	\N	\N	\N	99139	99139	99245
21981	32127	26	applied	\N	\N	\N	\N	99147	99147	99246
21981	32130	27	applied	\N	\N	\N	\N	99159	99159	99247
21981	32133	28	applied	\N	\N	\N	\N	99172	99172	99248
21981	32136	29	applied	\N	\N	\N	\N	99181	99181	99249
21981	32139	30	applied	\N	\N	\N	\N	99189	99189	99250
21981	32142	31	applied	\N	\N	\N	\N	99196	99196	99251
21981	32145	32	applied	\N	\N	\N	\N	99206	99206	99252
21981	32148	33	applied	\N	\N	\N	\N	99218	99218	99253
21981	32149	34	applied	\N	\N	\N	\N	99220	99220	99616
21981	32154	35	applied	\N	\N	\N	\N	99289	99289	99617
21981	32157	36	applied	\N	\N	\N	\N	99299	99299	99618
21981	32158	37	applied	\N	\N	\N	\N	99301	99301	99619
21981	32164	38	applied	\N	\N	\N	\N	99314	99314	99620
21981	32168	39	applied	\N	\N	\N	\N	99324	99324	99621
21981	32171	40	applied	\N	\N	\N	\N	99338	99338	99622
21981	32177	41	applied	\N	\N	\N	\N	99355	99355	99623
21981	32180	42	applied	\N	\N	\N	\N	99364	99364	99624
21981	32183	43	applied	\N	\N	\N	\N	99371	99371	99625
21981	32186	44	applied	\N	\N	\N	\N	99381	99381	99626
21981	32191	45	applied	\N	\N	\N	\N	99394	99394	99627
21981	32194	46	applied	\N	\N	\N	\N	99403	99403	99628
21981	32195	47	applied	\N	\N	\N	\N	99405	99405	99630
21981	32202	48	applied	\N	\N	\N	\N	99422	99422	99631
21981	32205	49	applied	\N	\N	\N	\N	99453	99453	99632
21981	32206	50	applied	\N	\N	\N	\N	99455	99455	99633
21981	32207	51	applied	\N	\N	\N	\N	99457	99457	99634
21981	32214	52	applied	\N	\N	\N	\N	99474	99474	99635
21981	32217	53	applied	\N	\N	\N	\N	99480	99480	99636
21981	32222	54	applied	\N	\N	\N	\N	99489	99489	99637
21981	32225	55	applied	\N	\N	\N	\N	99497	99497	99638
21981	32228	56	applied	\N	\N	\N	\N	99505	99505	99639
21981	32231	57	applied	\N	\N	\N	\N	99515	99515	99640
21981	32235	58	applied	\N	\N	\N	\N	99525	99525	99641
21981	32239	59	applied	\N	\N	\N	\N	99539	99539	99642
21981	32242	60	applied	\N	\N	\N	\N	99553	99553	99643
21981	32243	61	applied	\N	\N	\N	\N	99555	99555	99644
21981	32248	62	applied	\N	\N	\N	\N	99567	99567	99645
21981	32251	63	applied	\N	\N	\N	\N	99575	99575	99646
21981	32255	65	applied	\N	\N	\N	\N	99586	99586	99647
21981	32258	66	applied	\N	\N	\N	\N	99594	99594	99648
21981	32261	67	applied	\N	\N	\N	\N	99602	99602	99649
21981	32264	68	applied	\N	\N	\N	\N	99650	99650	99651
21981	32268	69	applied	\N	\N	\N	\N	99699	99699	99985
21981	32271	70	applied	\N	\N	\N	\N	99710	99710	99986
21981	32172	71	applied	\N	\N	\N	\N	99613	99613	99341
21981	32173	72	applied	\N	\N	\N	\N	99614	99614	99343
21981	32174	73	applied	\N	\N	\N	\N	99410	99410	99345
21981	32278	74	applied	\N	\N	\N	\N	99728	99728	99987
21981	32274	75	applied	\N	\N	\N	\N	99718	99718	99719
21981	32279	76	applied	\N	\N	\N	\N	99730	99730	99988
21981	32280	77	applied	\N	\N	\N	\N	99732	99732	99989
21981	32287	78	applied	\N	\N	\N	\N	99755	99755	99990
21981	32290	79	applied	\N	\N	\N	\N	99762	99762	99991
21981	32291	80	applied	\N	\N	\N	\N	99764	99764	99992
21981	32296	81	applied	\N	\N	\N	\N	99778	99778	99993
21981	32299	82	applied	\N	\N	\N	\N	99785	99785	99994
21981	32302	83	applied	\N	\N	\N	\N	99799	99799	99995
21981	32305	84	applied	\N	\N	\N	\N	99806	99806	99996
21981	32306	85	applied	\N	\N	\N	\N	99808	99808	99997
21981	32307	86	applied	\N	\N	\N	\N	99810	99810	99998
21981	32308	87	applied	\N	\N	\N	\N	99812	99812	99999
21981	32317	88	applied	\N	\N	\N	\N	99831	99831	100000
21981	32321	89	applied	\N	\N	\N	\N	99843	99843	100001
21981	32322	90	applied	\N	\N	\N	\N	99845	99845	100002
21981	32327	91	applied	\N	\N	\N	\N	99860	99860	100003
21981	32330	92	applied	\N	\N	\N	\N	99867	99867	100004
21981	32331	93	applied	\N	\N	\N	\N	99869	99869	100005
21981	32335	94	applied	\N	\N	\N	\N	99881	99881	100006
21981	32338	95	applied	\N	\N	\N	\N	99892	99892	100007
21981	32339	96	applied	\N	\N	\N	\N	99894	99894	100008
21981	32344	97	applied	\N	\N	\N	\N	99907	99907	100009
21981	32345	98	applied	\N	\N	\N	\N	99909	99909	100010
21981	32346	99	applied	\N	\N	\N	\N	99911	99911	100011
21981	32347	100	applied	\N	\N	\N	\N	99913	99913	100012
21981	32356	101	applied	\N	\N	\N	\N	99932	99932	100013
21981	32359	102	applied	\N	\N	\N	\N	99940	99940	100014
21981	32362	103	applied	\N	\N	\N	\N	99948	99948	100015
21981	32365	104	applied	\N	\N	\N	\N	99958	99958	100016
21981	32381	105	applied	\N	\N	\N	\N	100103	100103	100327
21981	32382	106	applied	\N	\N	\N	\N	100105	100105	100328
21981	32387	107	applied	\N	\N	\N	\N	100121	100121	100329
21981	32390	108	applied	\N	\N	\N	\N	100134	100134	100330
21981	32393	109	applied	\N	\N	\N	\N	100140	100140	100331
21981	32396	110	applied	\N	\N	\N	\N	100148	100148	100332
21981	32399	111	applied	\N	\N	\N	\N	100156	100156	100333
21981	32402	112	applied	\N	\N	\N	\N	100204	100204	100334
21981	32405	113	applied	\N	\N	\N	\N	100213	100213	100335
21981	32408	114	applied	\N	\N	\N	\N	100221	100221	100336
21981	32411	115	applied	\N	\N	\N	\N	100235	100235	100337
21981	32414	116	applied	\N	\N	\N	\N	100246	100246	100338
21981	32417	117	applied	\N	\N	\N	\N	100254	100254	100339
21981	32420	118	applied	\N	\N	\N	\N	100264	100264	100340
21981	32421	119	applied	\N	\N	\N	\N	100266	100266	100341
21981	32426	120	applied	\N	\N	\N	\N	100282	100282	100342
21981	32429	121	applied	\N	\N	\N	\N	100292	100292	100343
21981	32432	122	applied	\N	\N	\N	\N	100299	100299	100344
21981	32435	123	applied	\N	\N	\N	\N	100307	100307	100345
21981	32436	124	applied	\N	\N	\N	\N	100309	100309	100346
21981	32437	125	applied	\N	\N	\N	\N	100311	100311	100347
21983	32838	0	applied	\N	\N	\N	\N	101545	101545	101546
21983	32839	1	applied	\N	\N	\N	\N	101547	101547	101548
21983	32840	2	applied	\N	\N	\N	\N	101549	101549	101550
21983	32841	3	applied	\N	\N	\N	\N	101551	101551	101552
21983	32842	4	applied	\N	\N	\N	\N	101553	101553	101554
21983	32843	5	applied	\N	\N	\N	\N	101555	101555	101556
21988	32853	0	applied	\N	\N	\N	\N	101585	101585	101586
21988	32854	1	applied	\N	\N	\N	\N	101587	101587	101588
21992	32861	0	applied	\N	\N	\N	\N	101605	101605	101606
21992	32862	1	applied	\N	\N	\N	\N	101607	101607	101608
21992	32863	2	applied	\N	\N	\N	\N	101609	101609	101610
21993	32861	0	applied	\N	\N	\N	\N	101605	101605	101606
21993	32862	1	applied	\N	\N	\N	\N	101607	101607	101608
21993	32863	2	applied	\N	\N	\N	\N	101609	101609	101610
21996	32873	0	applied	\N	\N	\N	\N	101637	101637	101638
21996	32874	1	applied	\N	\N	\N	\N	101639	101639	101640
21996	32875	2	applied	\N	\N	\N	\N	101641	101641	101642
22001	32879	0	applied	\N	\N	\N	\N	101694	101694	101695
22001	32880	1	applied	\N	\N	\N	\N	101696	101696	101697
22001	32881	2	applied	\N	\N	\N	\N	101698	101698	101699
22012	32900	0	applied	\N	\N	\N	\N	101755	101755	101756
22012	32901	1	applied	\N	\N	\N	\N	101757	101757	101758
22012	32902	2	applied	\N	\N	\N	\N	101759	101759	101760
22015	32903	0	applied	\N	\N	\N	\N	101761	101761	101762
22015	32905	1	applied	\N	\N	\N	\N	101766	101766	101767
22015	32904	2	applied	\N	\N	\N	\N	101763	101763	101768
22017	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22017	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22017	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22017	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22020	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22020	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22020	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22020	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22025	32912	0	applied	\N	\N	\N	\N	101792	101792	101793
22028	32918	0	applied	\N	\N	\N	\N	101807	101807	101808
22028	32919	1	applied	\N	\N	\N	\N	101809	101809	101810
22028	32920	2	applied	\N	\N	\N	\N	101811	101811	101812
22031	32923	0	applied	\N	\N	\N	\N	101820	101820	101821
22031	32924	1	applied	\N	\N	\N	\N	101822	101822	101823
22031	32925	2	applied	\N	\N	\N	\N	101824	101824	101825
22031	32930	3	applied	\N	\N	\N	\N	101836	101836	101837
22031	32926	4	applied	\N	\N	\N	\N	101826	101826	101827
22031	32931	5	applied	\N	\N	\N	\N	101838	101838	101839
22031	32932	6	applied	\N	\N	\N	\N	101840	101840	101841
22031	32927	7	applied	\N	\N	\N	\N	101828	101828	101829
22031	32928	8	applied	\N	\N	\N	\N	101830	101830	101831
22031	32929	9	applied	\N	\N	\N	\N	101832	101832	101833
22031	32933	10	applied	\N	\N	\N	\N	101842	101842	101843
22031	32934	11	applied	\N	\N	\N	\N	101844	101844	101845
22031	32935	12	applied	\N	\N	\N	\N	101846	101846	101847
22031	32936	13	applied	\N	\N	\N	\N	101848	101848	101849
22033	32937	0	applied	\N	\N	\N	\N	101852	101852	101853
22033	32939	1	applied	\N	\N	\N	\N	101857	101857	101858
22033	32938	2	applied	\N	\N	\N	\N	101854	101854	101859
22035	32940	0	applied	\N	\N	\N	\N	101861	101861	101862
22035	32941	1	applied	\N	\N	\N	\N	101863	101863	101864
22035	32942	2	applied	\N	\N	\N	\N	101865	101865	101866
22035	32943	3	applied	\N	\N	\N	\N	101867	101867	101868
22040	32959	0	applied	\N	\N	\N	\N	101930	101930	101931
22040	32960	1	applied	\N	\N	\N	\N	101932	101932	101933
22040	32961	2	applied	\N	\N	\N	\N	101934	101934	101935
22040	32962	3	applied	\N	\N	\N	\N	101936	101936	101937
22046	32983	0	applied	\N	\N	\N	\N	101988	101988	101989
22046	32984	1	applied	\N	\N	\N	\N	101990	101990	101991
22046	32985	2	applied	\N	\N	\N	\N	101992	101992	101993
22052	32986	0	applied	\N	\N	\N	\N	101994	101994	101995
22052	32987	1	applied	\N	\N	\N	\N	101996	101996	101997
22052	32988	2	applied	\N	\N	\N	\N	101998	101998	101999
22052	32989	3	applied	\N	\N	\N	\N	102000	102000	102001
22055	32993	0	applied	\N	\N	\N	\N	102013	102013	102014
22055	32994	1	applied	\N	\N	\N	\N	102015	102015	102016
22055	32995	2	applied	\N	\N	\N	\N	102017	102017	102018
22057	32996	0	applied	\N	\N	\N	\N	102023	102023	102024
22057	32997	1	applied	\N	\N	\N	\N	102025	102025	102026
22057	32998	2	applied	\N	\N	\N	\N	102027	102027	102028
22057	32999	3	applied	\N	\N	\N	\N	102029	102029	102030
22062	33013	0	applied	\N	\N	\N	\N	102066	102066	102067
22062	33014	1	applied	\N	\N	\N	\N	102068	102068	102069
22062	33015	2	applied	\N	\N	\N	\N	102070	102070	102071
22067	33019	0	applied	\N	\N	\N	\N	102080	102080	102081
22067	33020	1	applied	\N	\N	\N	\N	102082	102082	102083
22067	33022	2	applied	\N	\N	\N	\N	102086	102086	102090
22074	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22074	33034	1	applied	\N	\N	\N	\N	102122	102122	102123
22074	33035	2	applied	\N	\N	\N	\N	102124	102124	102125
22074	33036	3	applied	\N	\N	\N	\N	102126	102126	102127
22074	33037	4	applied	\N	\N	\N	\N	102128	102128	102129
21994	32864	0	applied	\N	\N	\N	\N	101616	101616	101617
21994	32865	1	applied	\N	\N	\N	\N	101618	101618	101619
21994	32866	2	applied	\N	\N	\N	\N	101620	101620	101621
21994	32867	3	applied	\N	\N	\N	\N	101622	101622	101623
21994	32868	4	applied	\N	\N	\N	\N	101624	101624	101625
21994	32869	5	applied	\N	\N	\N	\N	101626	101626	101627
22002	32879	0	applied	\N	\N	\N	\N	101694	101694	101695
22002	32880	1	applied	\N	\N	\N	\N	101696	101696	101697
22002	32881	2	applied	\N	\N	\N	\N	101698	101698	101699
22003	32882	0	applied	\N	\N	\N	\N	101704	101704	101705
22003	32883	1	applied	\N	\N	\N	\N	101706	101706	101707
22003	32884	2	applied	\N	\N	\N	\N	101708	101708	101709
22006	32894	0	applied	\N	\N	\N	\N	101733	101733	101734
22006	32895	1	applied	\N	\N	\N	\N	101735	101735	101736
22006	32896	2	applied	\N	\N	\N	\N	101737	101737	101738
22008	32894	0	applied	\N	\N	\N	\N	101733	101733	101734
22008	32895	1	applied	\N	\N	\N	\N	101735	101735	101736
22008	32896	2	applied	\N	\N	\N	\N	101737	101737	101738
22013	32900	0	applied	\N	\N	\N	\N	101755	101755	101756
22013	32901	1	applied	\N	\N	\N	\N	101757	101757	101758
22013	32902	2	applied	\N	\N	\N	\N	101759	101759	101760
22021	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22021	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22021	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22021	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22026	32915	0	applied	\N	\N	\N	\N	101801	101801	101802
22026	32916	1	applied	\N	\N	\N	\N	101803	101803	101804
22026	32917	2	applied	\N	\N	\N	\N	101805	101805	101806
22038	32953	0	applied	\N	\N	\N	\N	101917	101917	101918
22038	32954	1	applied	\N	\N	\N	\N	101919	101919	101920
22038	32955	2	applied	\N	\N	\N	\N	101921	101921	101922
22038	32956	3	applied	\N	\N	\N	\N	101923	101923	101924
22041	32963	0	applied	\N	\N	\N	\N	101940	101940	101941
22041	32964	1	applied	\N	\N	\N	\N	101942	101942	101943
22041	32965	2	applied	\N	\N	\N	\N	101944	101944	101945
22041	32966	3	applied	\N	\N	\N	\N	101946	101946	101947
22043	32967	0	applied	\N	\N	\N	\N	101952	101952	101953
22043	32968	1	applied	\N	\N	\N	\N	101954	101954	101955
22044	32969	0	applied	\N	\N	\N	\N	101958	101958	101959
22044	32970	1	applied	\N	\N	\N	\N	101960	101960	101961
22044	32971	2	applied	\N	\N	\N	\N	101962	101962	101963
22044	32972	3	applied	\N	\N	\N	\N	101964	101964	101965
22044	32973	4	applied	\N	\N	\N	\N	101966	101966	101967
22044	32974	5	applied	\N	\N	\N	\N	101968	101968	101969
22044	32975	6	applied	\N	\N	\N	\N	101970	101970	101971
22044	32976	7	applied	\N	\N	\N	\N	101972	101972	101973
22044	32977	8	applied	\N	\N	\N	\N	101974	101974	101975
22044	32978	9	applied	\N	\N	\N	\N	101976	101976	101977
22044	32979	10	applied	\N	\N	\N	\N	101978	101978	101979
22044	32980	11	applied	\N	\N	\N	\N	101980	101980	101981
22044	32981	12	applied	\N	\N	\N	\N	101982	101982	101983
22044	32982	13	applied	\N	\N	\N	\N	101984	101984	101985
22047	32983	0	applied	\N	\N	\N	\N	101988	101988	101989
22047	32984	1	applied	\N	\N	\N	\N	101990	101990	101991
22047	32985	2	applied	\N	\N	\N	\N	101992	101992	101993
22053	32990	0	applied	\N	\N	\N	\N	102005	102005	102006
22053	32991	1	applied	\N	\N	\N	\N	102007	102007	102008
22053	32992	2	applied	\N	\N	\N	\N	102009	102009	102010
22063	33013	0	applied	\N	\N	\N	\N	102066	102066	102067
22063	33014	1	applied	\N	\N	\N	\N	102068	102068	102069
22063	33015	2	applied	\N	\N	\N	\N	102070	102070	102071
22065	33016	0	applied	\N	\N	\N	\N	102072	102072	102073
22065	33017	1	applied	\N	\N	\N	\N	102074	102074	102075
22065	33018	2	applied	\N	\N	\N	\N	102076	102076	102077
22070	33029	0	applied	\N	\N	\N	\N	102108	102108	102109
22070	33030	1	applied	\N	\N	\N	\N	102110	102110	102111
22070	33031	2	applied	\N	\N	\N	\N	102112	102112	102113
22070	33032	3	applied	\N	\N	\N	\N	102114	102114	102115
22072	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22072	33034	1	applied	\N	\N	\N	\N	102122	102122	102123
22072	33035	2	applied	\N	\N	\N	\N	102124	102124	102125
22072	33036	3	applied	\N	\N	\N	\N	102126	102126	102127
22072	33037	4	applied	\N	\N	\N	\N	102128	102128	102129
22072	33038	5	applied	\N	\N	\N	\N	102130	102130	102131
22075	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22075	33034	1	applied	\N	\N	\N	\N	102122	102122	102123
22075	33035	2	applied	\N	\N	\N	\N	102124	102124	102125
22075	33036	3	applied	\N	\N	\N	\N	102126	102126	102127
22075	33037	4	applied	\N	\N	\N	\N	102128	102128	102129
22075	33038	5	applied	\N	\N	\N	\N	102130	102130	102131
22079	33046	0	applied	\N	\N	\N	\N	102155	102155	102156
22079	33047	1	applied	\N	\N	\N	\N	102157	102157	102158
22084	33055	0	applied	\N	\N	\N	\N	102179	102179	102180
22084	33059	1	applied	\N	\N	\N	\N	102215	102215	102216
22084	33057	2	applied	\N	\N	\N	\N	102199	102199	102221
22084	33058	3	applied	\N	\N	\N	\N	102212	102212	102222
22084	33060	4	applied	\N	\N	\N	\N	102217	102217	102223
22084	33061	5	applied	\N	\N	\N	\N	102224	102224	102225
22084	33056	6	applied	\N	\N	\N	\N	102191	102191	102226
22086	33059	0	applied	\N	\N	\N	\N	102215	102215	102216
22086	33060	1	applied	\N	\N	\N	\N	102217	102217	102229
22086	33061	2	applied	\N	\N	\N	\N	102224	102224	102226
22088	33062	0	applied	\N	\N	\N	\N	102234	102234	102235
22088	33063	1	applied	\N	\N	\N	\N	102236	102236	102237
22088	33064	2	applied	\N	\N	\N	\N	102238	102238	102239
22096	33087	0	applied	\N	\N	\N	\N	102300	102300	102301
22096	33088	1	applied	\N	\N	\N	\N	102302	102302	102303
22096	33089	2	applied	\N	\N	\N	\N	102304	102304	102305
22096	33090	3	applied	\N	\N	\N	\N	102306	102306	102307
22101	33101	0	applied	\N	\N	\N	\N	102337	102337	102338
22101	33102	1	applied	\N	\N	\N	\N	102339	102339	102340
22101	33103	2	applied	\N	\N	\N	\N	102341	102341	102342
22105	33124	0	applied	\N	\N	\N	\N	102387	102387	102388
22105	33125	1	applied	\N	\N	\N	\N	102389	102389	102390
22105	33126	2	applied	\N	\N	\N	\N	102391	102391	102392
22105	33127	3	applied	\N	\N	\N	\N	102393	102393	102394
22112	33139	0	applied	\N	\N	\N	\N	102429	102429	102429
22112	33062	1	applied	\N	\N	\N	\N	102234	102234	102235
22112	33065	2	applied	\N	\N	\N	\N	102243	102243	102244
22112	33069	3	applied	\N	\N	\N	\N	102254	102254	102255
22112	33070	4	applied	\N	\N	\N	\N	102256	102256	102257
22112	33071	5	applied	\N	\N	\N	\N	102258	102258	102259
22112	33081	6	applied	\N	\N	\N	\N	102282	102282	102283
22112	33084	7	applied	\N	\N	\N	\N	102292	102292	102293
22112	33087	8	applied	\N	\N	\N	\N	102300	102300	102301
22112	33091	9	applied	\N	\N	\N	\N	102310	102310	102311
22112	33094	10	applied	\N	\N	\N	\N	102318	102318	102319
22112	33095	11	applied	\N	\N	\N	\N	102320	102320	102321
22112	33125	12	applied	\N	\N	\N	\N	102389	102389	102390
22112	33129	13	applied	\N	\N	\N	\N	102401	102401	102402
21997	32876	0	applied	\N	\N	\N	\N	101645	101645	101646
21997	32877	1	applied	\N	\N	\N	\N	101647	101647	101648
21997	32878	2	applied	\N	\N	\N	\N	101649	101649	101650
21999	32700	0	applied	\N	\N	\N	\N	101178	101178	101179
21999	32703	1	applied	\N	\N	\N	\N	101186	101186	101187
21999	32704	2	applied	\N	\N	\N	\N	101188	101188	101189
21999	32709	4	applied	\N	\N	\N	\N	101202	101202	101203
21999	32712	5	applied	\N	\N	\N	\N	101210	101210	101211
21999	32715	6	applied	\N	\N	\N	\N	101217	101217	101218
21999	32719	7	applied	\N	\N	\N	\N	101227	101227	101228
21999	32720	8	applied	\N	\N	\N	\N	101229	101229	101230
21999	32725	9	applied	\N	\N	\N	\N	101244	101244	101245
21999	32726	10	applied	\N	\N	\N	\N	101246	101246	101247
21999	32731	11	applied	\N	\N	\N	\N	101257	101257	101258
21999	32732	12	applied	\N	\N	\N	\N	101259	101259	101260
21999	32737	13	applied	\N	\N	\N	\N	101270	101270	101271
21999	32738	14	applied	\N	\N	\N	\N	101272	101272	101273
21999	32739	15	applied	\N	\N	\N	\N	101274	101274	101275
21999	32740	16	applied	\N	\N	\N	\N	101276	101276	101277
21999	32741	17	applied	\N	\N	\N	\N	101278	101278	101279
21999	32742	18	applied	\N	\N	\N	\N	101280	101280	101281
21999	32743	19	applied	\N	\N	\N	\N	101282	101282	101283
21999	32758	20	applied	\N	\N	\N	\N	101314	101314	101315
21999	32761	21	applied	\N	\N	\N	\N	101320	101320	101321
21999	32764	22	applied	\N	\N	\N	\N	101331	101331	101332
21999	32765	23	applied	\N	\N	\N	\N	101333	101333	101334
21999	32769	24	applied	\N	\N	\N	\N	101343	101343	101344
21999	32771	25	applied	\N	\N	\N	\N	101351	101351	101352
21999	32774	26	applied	\N	\N	\N	\N	101359	101359	101360
21999	32777	27	applied	\N	\N	\N	\N	101367	101367	101368
21999	32778	28	applied	\N	\N	\N	\N	101369	101369	101370
21999	32784	29	applied	\N	\N	\N	\N	101382	101382	101383
21999	32787	30	applied	\N	\N	\N	\N	101390	101390	101391
21999	32790	31	applied	\N	\N	\N	\N	101401	101401	101402
21999	32793	32	applied	\N	\N	\N	\N	101408	101408	101409
21999	32794	33	applied	\N	\N	\N	\N	101410	101410	101411
21999	32795	34	applied	\N	\N	\N	\N	101412	101412	101413
21999	32802	35	applied	\N	\N	\N	\N	101429	101429	101430
21999	32803	36	applied	\N	\N	\N	\N	101431	101431	101432
21999	32808	37	applied	\N	\N	\N	\N	101443	101443	101444
21999	32809	38	applied	\N	\N	\N	\N	101445	101445	101446
21999	32814	39	applied	\N	\N	\N	\N	101457	101457	101458
21999	32815	40	applied	\N	\N	\N	\N	101459	101459	101460
21999	32816	41	applied	\N	\N	\N	\N	101461	101461	101462
21999	32823	42	applied	\N	\N	\N	\N	101483	101483	101484
21999	32826	43	applied	\N	\N	\N	\N	101493	101493	101494
21999	32829	44	applied	\N	\N	\N	\N	101513	101513	101514
21999	32830	45	applied	\N	\N	\N	\N	101515	101515	101516
21999	32835	46	applied	\N	\N	\N	\N	101530	101530	101531
21999	32838	47	applied	\N	\N	\N	\N	101545	101545	101546
21999	32839	48	applied	\N	\N	\N	\N	101547	101547	101548
21999	32844	49	applied	\N	\N	\N	\N	101559	101559	101560
21999	32847	50	applied	\N	\N	\N	\N	101567	101567	101568
21999	32850	51	applied	\N	\N	\N	\N	101577	101577	101578
21999	32853	52	applied	\N	\N	\N	\N	101585	101585	101586
21999	32855	53	applied	\N	\N	\N	\N	101591	101591	101592
21999	32856	54	applied	\N	\N	\N	\N	101593	101593	101594
21999	32861	55	applied	\N	\N	\N	\N	101605	101605	101606
21999	32864	56	applied	\N	\N	\N	\N	101616	101616	101617
21999	32865	57	applied	\N	\N	\N	\N	101618	101618	101619
21999	32870	58	applied	\N	\N	\N	\N	101629	101629	101630
21999	32873	59	applied	\N	\N	\N	\N	101637	101637	101638
21999	32876	60	applied	\N	\N	\N	\N	101645	101645	101646
21999	32721	61	applied	\N	\N	\N	\N	101232	101232	101233
21999	32779	62	applied	\N	\N	\N	\N	101371	101371	101371
21999	32489	63	applied	\N	\N	\N	\N	100548	100548	101656
21999	32493	64	applied	\N	\N	\N	\N	100556	100556	101657
21999	32494	65	applied	\N	\N	\N	\N	100558	100558	101658
21999	32500	66	applied	\N	\N	\N	\N	100582	100582	100752
21999	32501	67	applied	\N	\N	\N	\N	100584	100584	101659
21999	32504	68	applied	\N	\N	\N	\N	100593	100593	101660
21999	32508	69	applied	\N	\N	\N	\N	100603	100603	100756
21999	32511	70	applied	\N	\N	\N	\N	100613	100613	100761
21999	32512	71	applied	\N	\N	\N	\N	100615	100615	100770
21999	32519	72	applied	\N	\N	\N	\N	100631	100631	100772
21999	32520	73	applied	\N	\N	\N	\N	100633	100633	101661
21999	32524	74	applied	\N	\N	\N	\N	100643	100643	101662
21999	32525	75	applied	\N	\N	\N	\N	100645	100645	100776
21999	32529	76	applied	\N	\N	\N	\N	100654	100654	101663
21999	32530	77	applied	\N	\N	\N	\N	100656	100656	101664
21999	32537	78	applied	\N	\N	\N	\N	100673	100673	101665
21999	32538	79	applied	\N	\N	\N	\N	100675	100675	101666
21999	32539	80	applied	\N	\N	\N	\N	100677	100677	100797
21999	32540	81	applied	\N	\N	\N	\N	100679	100679	101667
21999	32547	82	applied	\N	\N	\N	\N	100696	100696	101668
21999	32548	83	applied	\N	\N	\N	\N	100698	100698	101669
21999	32555	84	applied	\N	\N	\N	\N	100713	100713	101670
21999	32556	85	applied	\N	\N	\N	\N	100715	100715	100816
21999	32561	86	applied	\N	\N	\N	\N	100731	100731	101671
21999	32562	87	applied	\N	\N	\N	\N	100733	100733	101672
21999	32566	88	applied	\N	\N	\N	\N	100745	100745	101673
21999	32567	89	applied	\N	\N	\N	\N	100747	100747	100826
21999	32568	90	applied	\N	\N	\N	\N	100749	100749	100828
21999	32573	91	applied	\N	\N	\N	\N	100760	100760	100842
21999	32576	92	applied	\N	\N	\N	\N	100769	100769	100844
21999	32577	93	applied	\N	\N	\N	\N	100771	100771	101674
21999	32582	94	applied	\N	\N	\N	\N	100789	100789	101675
21999	32584	95	applied	\N	\N	\N	\N	100794	100794	100848
21999	32588	96	applied	\N	\N	\N	\N	100804	100804	101676
21999	32590	97	applied	\N	\N	\N	\N	100813	100813	101677
21999	32595	98	applied	\N	\N	\N	\N	100823	100823	101678
21999	32597	99	applied	\N	\N	\N	\N	100827	100827	101679
21999	32601	100	applied	\N	\N	\N	\N	100841	100841	100862
21999	32602	101	applied	\N	\N	\N	\N	100843	100843	100867
21999	32606	102	applied	\N	\N	\N	\N	100851	100851	101680
21999	32608	103	applied	\N	\N	\N	\N	100859	100859	101681
21999	32611	104	applied	\N	\N	\N	\N	100866	100866	101682
21999	32616	105	applied	\N	\N	\N	\N	100876	100876	100879
21999	32618	106	applied	\N	\N	\N	\N	100880	100880	100881
21999	32619	107	applied	\N	\N	\N	\N	100882	100882	100883
21999	32623	108	applied	\N	\N	\N	\N	100896	100896	101683
21999	32626	109	applied	\N	\N	\N	\N	100908	100908	101684
21999	32630	110	applied	\N	\N	\N	\N	100917	100917	100887
21999	32633	111	applied	\N	\N	\N	\N	100923	100923	100897
21999	32635	112	applied	\N	\N	\N	\N	100929	100929	101685
21999	32639	113	applied	\N	\N	\N	\N	100939	100939	101686
21999	32644	114	applied	\N	\N	\N	\N	100992	100992	101687
21999	32645	115	applied	\N	\N	\N	\N	100994	100994	100911
21999	32647	116	applied	\N	\N	\N	\N	101006	101006	101688
21999	32651	117	applied	\N	\N	\N	\N	101016	101016	101689
21999	32656	118	applied	\N	\N	\N	\N	101026	101026	100997
21999	32657	119	applied	\N	\N	\N	\N	101028	101028	100922
21999	32660	120	applied	\N	\N	\N	\N	101034	101034	100924
21999	32661	121	applied	\N	\N	\N	\N	101036	101036	100930
21999	32665	122	applied	\N	\N	\N	\N	101046	101046	100999
21999	32669	123	applied	\N	\N	\N	\N	101058	101058	101690
21999	32671	124	applied	\N	\N	\N	\N	101064	101064	100938
21999	32675	125	applied	\N	\N	\N	\N	101074	101074	100940
22004	32885	0	applied	\N	\N	\N	\N	101712	101712	101713
22004	32886	1	applied	\N	\N	\N	\N	101714	101714	101715
22004	32887	2	applied	\N	\N	\N	\N	101716	101716	101717
22009	32897	0	applied	\N	\N	\N	\N	101744	101744	101745
22009	32898	2	applied	\N	\N	\N	\N	101746	101746	101747
22009	32899	3	applied	\N	\N	\N	\N	101748	101748	101749
22011	32897	0	applied	\N	\N	\N	\N	101744	101744	101745
22011	32898	2	applied	\N	\N	\N	\N	101746	101746	101747
22011	32899	3	applied	\N	\N	\N	\N	101748	101748	101749
22018	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22018	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22018	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22018	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22022	32909	0	applied	\N	\N	\N	\N	101784	101784	101785
22022	32910	1	applied	\N	\N	\N	\N	101786	101786	101787
22022	32911	2	applied	\N	\N	\N	\N	101788	101788	101789
22024	32912	0	applied	\N	\N	\N	\N	101792	101792	101793
22024	32913	1	applied	\N	\N	\N	\N	101794	101794	101795
22024	32914	2	applied	\N	\N	\N	\N	101796	101796	101797
22029	32921	0	applied	\N	\N	\N	\N	101815	101815	101816
22029	32922	1	applied	\N	\N	\N	\N	101817	101817	101818
22032	32937	0	applied	\N	\N	\N	\N	101852	101852	101853
22032	32938	1	applied	\N	\N	\N	\N	101854	101854	101855
22034	32937	0	applied	\N	\N	\N	\N	101852	101852	101853
22034	32939	1	applied	\N	\N	\N	\N	101857	101857	101858
22034	32938	2	applied	\N	\N	\N	\N	101854	101854	101859
22039	32957	0	applied	\N	\N	\N	\N	101926	101926	101927
22039	32958	1	applied	\N	\N	\N	\N	101928	101928	101929
22042	32963	0	applied	\N	\N	\N	\N	101940	101940	101941
22042	32964	1	applied	\N	\N	\N	\N	101942	101942	101943
22042	32965	2	applied	\N	\N	\N	\N	101944	101944	101945
22042	32966	3	applied	\N	\N	\N	\N	101946	101946	101947
22045	32969	0	applied	\N	\N	\N	\N	101958	101958	101959
22045	32970	1	applied	\N	\N	\N	\N	101960	101960	101961
22045	32971	2	applied	\N	\N	\N	\N	101962	101962	101963
22045	32972	3	applied	\N	\N	\N	\N	101964	101964	101965
22045	32973	4	applied	\N	\N	\N	\N	101966	101966	101967
22045	32974	5	applied	\N	\N	\N	\N	101968	101968	101969
22045	32975	6	applied	\N	\N	\N	\N	101970	101970	101971
22045	32976	7	applied	\N	\N	\N	\N	101972	101972	101973
22045	32977	8	applied	\N	\N	\N	\N	101974	101974	101975
22045	32978	9	applied	\N	\N	\N	\N	101976	101976	101977
22045	32979	10	applied	\N	\N	\N	\N	101978	101978	101979
22045	32980	11	applied	\N	\N	\N	\N	101980	101980	101981
22045	32981	12	applied	\N	\N	\N	\N	101982	101982	101983
22045	32982	13	applied	\N	\N	\N	\N	101984	101984	101985
22049	32986	0	applied	\N	\N	\N	\N	101994	101994	101995
22049	32987	1	applied	\N	\N	\N	\N	101996	101996	101997
22049	32988	2	applied	\N	\N	\N	\N	101998	101998	101999
22049	32989	3	applied	\N	\N	\N	\N	102000	102000	102001
22058	33000	0	applied	\N	\N	\N	\N	102033	102033	102034
22058	33001	1	applied	\N	\N	\N	\N	102035	102035	102036
22058	33002	2	applied	\N	\N	\N	\N	102037	102037	102038
22060	33000	0	applied	\N	\N	\N	\N	102033	102033	102034
22060	33001	1	applied	\N	\N	\N	\N	102035	102035	102036
22060	33002	2	applied	\N	\N	\N	\N	102037	102037	102038
22061	33003	0	applied	\N	\N	\N	\N	102045	102045	102046
22061	33004	1	applied	\N	\N	\N	\N	102047	102047	102048
22061	33005	2	applied	\N	\N	\N	\N	102049	102049	102050
22061	33006	3	applied	\N	\N	\N	\N	102051	102051	102052
22061	33007	4	applied	\N	\N	\N	\N	102053	102053	102054
22061	33008	5	applied	\N	\N	\N	\N	102055	102055	102056
22061	33009	6	applied	\N	\N	\N	\N	102057	102057	102058
22061	33010	7	applied	\N	\N	\N	\N	102059	102059	102060
22061	33011	8	applied	\N	\N	\N	\N	102061	102061	102062
22061	33012	9	applied	\N	\N	\N	\N	102063	102063	102064
22068	33023	0	applied	\N	\N	\N	\N	102092	102092	102093
22068	33024	1	applied	\N	\N	\N	\N	102094	102094	102095
22068	33025	2	applied	\N	\N	\N	\N	102096	102096	102097
22068	33026	3	applied	\N	\N	\N	\N	102098	102098	102099
22068	33027	4	applied	\N	\N	\N	\N	102100	102100	102101
22068	33028	5	applied	\N	\N	\N	\N	102102	102102	102103
22076	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22076	33034	1	applied	\N	\N	\N	\N	102122	102122	102123
22076	33035	2	applied	\N	\N	\N	\N	102124	102124	102125
22076	33036	3	applied	\N	\N	\N	\N	102126	102126	102127
22076	33037	4	applied	\N	\N	\N	\N	102128	102128	102129
22076	33038	5	applied	\N	\N	\N	\N	102130	102130	102131
22077	33039	0	applied	\N	\N	\N	\N	102140	102140	102141
22077	33040	1	applied	\N	\N	\N	\N	102142	102142	102143
22077	33041	2	applied	\N	\N	\N	\N	102144	102144	102145
22077	33042	3	applied	\N	\N	\N	\N	102146	102146	102147
22077	33043	4	applied	\N	\N	\N	\N	102148	102148	102149
22077	33044	5	applied	\N	\N	\N	\N	102150	102150	102151
22082	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22082	32990	1	applied	\N	\N	\N	\N	102005	102005	102006
22082	32993	2	applied	\N	\N	\N	\N	102013	102013	102014
22082	32996	3	applied	\N	\N	\N	\N	102023	102023	102024
22082	33000	4	applied	\N	\N	\N	\N	102033	102033	102034
22082	33003	5	applied	\N	\N	\N	\N	102045	102045	102046
22082	33004	6	applied	\N	\N	\N	\N	102047	102047	102048
22082	33035	7	applied	\N	\N	\N	\N	102124	102124	102125
22082	33036	8	applied	\N	\N	\N	\N	102126	102126	102127
22082	33054	9	applied	\N	\N	\N	\N	102177	102177	102178
22082	33005	10	applied	\N	\N	\N	\N	102049	102049	102050
22082	33013	11	applied	\N	\N	\N	\N	102066	102066	102067
22082	33016	12	applied	\N	\N	\N	\N	102072	102072	102073
22082	33019	13	applied	\N	\N	\N	\N	102080	102080	102081
22082	33023	14	applied	\N	\N	\N	\N	102092	102092	102093
22082	33024	15	applied	\N	\N	\N	\N	102094	102094	102095
22082	33029	16	applied	\N	\N	\N	\N	102108	102108	102109
22082	33034	17	applied	\N	\N	\N	\N	102122	102122	102123
22082	33039	18	applied	\N	\N	\N	\N	102140	102140	102141
22082	33040	19	applied	\N	\N	\N	\N	102142	102142	102143
22082	33045	20	applied	\N	\N	\N	\N	102153	102153	102154
22082	33048	21	applied	\N	\N	\N	\N	102162	102162	102163
22082	33051	22	applied	\N	\N	\N	\N	102169	102169	102170
22082	33055	23	applied	\N	\N	\N	\N	102179	102179	102180
22082	32991	24	applied	\N	\N	\N	\N	102007	102007	102008
22082	32994	25	applied	\N	\N	\N	\N	102015	102015	102181
22082	32992	26	applied	\N	\N	\N	\N	102009	102009	102016
22082	32995	27	applied	\N	\N	\N	\N	102017	102017	102018
22016	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22016	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22016	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22016	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22019	32906	0	applied	\N	\N	\N	\N	101769	101769	101770
22019	32907	1	applied	\N	\N	\N	\N	101771	101771	101772
22019	32905	2	applied	\N	\N	\N	\N	101766	101766	101773
22019	32908	3	applied	\N	\N	\N	\N	101774	101774	101775
22023	32909	0	applied	\N	\N	\N	\N	101784	101784	101785
22023	32910	1	applied	\N	\N	\N	\N	101786	101786	101787
22023	32911	2	applied	\N	\N	\N	\N	101788	101788	101789
22027	32918	0	applied	\N	\N	\N	\N	101807	101807	101808
22027	32919	1	applied	\N	\N	\N	\N	101809	101809	101810
22027	32920	2	applied	\N	\N	\N	\N	101811	101811	101812
22030	32923	0	applied	\N	\N	\N	\N	101820	101820	101821
22030	32924	1	applied	\N	\N	\N	\N	101822	101822	101823
22030	32925	2	applied	\N	\N	\N	\N	101824	101824	101825
22030	32926	3	applied	\N	\N	\N	\N	101826	101826	101827
22030	32927	4	applied	\N	\N	\N	\N	101828	101828	101829
22030	32928	5	applied	\N	\N	\N	\N	101830	101830	101831
22030	32929	6	applied	\N	\N	\N	\N	101832	101832	101833
22036	32320	0	applied	\N	\N	1000000000	\N	99841	99841	99842
22036	32267	1	applied	\N	\N	\N	\N	99697	99697	99698
22036	32149	2	applied	\N	\N	\N	\N	99220	99220	99616
22036	32154	3	applied	\N	\N	\N	\N	99289	99289	99617
22036	32157	4	applied	\N	\N	\N	\N	99299	99299	99618
22036	32158	5	applied	\N	\N	\N	\N	99301	99301	99619
22036	32164	6	applied	\N	\N	\N	\N	99314	99314	99620
22036	32167	7	applied	\N	\N	\N	\N	99322	99322	99323
22036	32254	8	applied	\N	\N	\N	\N	99584	99584	99585
22036	32221	9	applied	\N	\N	\N	\N	99488	99488	47675
22036	32923	10	applied	\N	\N	\N	\N	101870	101870	101821
22036	32924	11	applied	\N	\N	\N	\N	101871	101871	101823
22036	32925	12	applied	\N	\N	\N	\N	101872	101872	101825
22036	32218	13	applied	\N	\N	\N	\N	99482	99482	47675
22036	32196	14	applied	\N	\N	\N	\N	99407	99407	99610
22036	32232	15	applied	\N	\N	1000000000	\N	99611	99611	99518
22036	32168	16	applied	\N	\N	\N	\N	99324	99324	99621
22036	32197	17	applied	\N	\N	\N	\N	99409	99409	99612
22036	32171	18	applied	\N	\N	\N	\N	99338	99338	99622
22036	32177	19	applied	\N	\N	\N	\N	99355	99355	99623
22036	32180	20	applied	\N	\N	\N	\N	99364	99364	99624
22036	32183	21	applied	\N	\N	\N	\N	99371	99371	99625
22036	32186	22	applied	\N	\N	\N	\N	99381	99381	99626
22036	32191	23	applied	\N	\N	\N	\N	99394	99394	99627
22036	32194	24	applied	\N	\N	\N	\N	99403	99403	99628
22036	32195	25	applied	\N	\N	\N	\N	99405	99405	99630
22036	32202	26	applied	\N	\N	\N	\N	99422	99422	99631
22036	32205	27	applied	\N	\N	\N	\N	99453	99453	99632
22036	32206	28	applied	\N	\N	\N	\N	99455	99455	99633
22036	32207	29	applied	\N	\N	\N	\N	99457	99457	99634
22036	32214	30	applied	\N	\N	\N	\N	99474	99474	99635
22036	32217	31	applied	\N	\N	\N	\N	99480	99480	99636
22036	32222	32	applied	\N	\N	\N	\N	99489	99489	99637
22036	32225	33	applied	\N	\N	\N	\N	99497	99497	99638
22036	32228	34	applied	\N	\N	\N	\N	99505	99505	99639
22036	32231	35	applied	\N	\N	\N	\N	99515	99515	99640
22036	32235	36	applied	\N	\N	\N	\N	99525	99525	99641
22036	32239	37	applied	\N	\N	\N	\N	99539	99539	99642
22036	32242	38	applied	\N	\N	\N	\N	99553	99553	99643
22036	32243	39	applied	\N	\N	\N	\N	99555	99555	99644
22036	32248	40	applied	\N	\N	\N	\N	99567	99567	99645
22036	32251	41	applied	\N	\N	\N	\N	99575	99575	99646
22036	32255	42	applied	\N	\N	\N	\N	99586	99586	99647
22036	32258	43	applied	\N	\N	\N	\N	99594	99594	99648
22036	32261	44	applied	\N	\N	\N	\N	99602	99602	99649
22036	32264	45	applied	\N	\N	\N	\N	99650	99650	99651
22036	32268	46	applied	\N	\N	\N	\N	99699	99699	99985
22036	32271	47	applied	\N	\N	\N	\N	99710	99710	99986
22036	32172	48	applied	\N	\N	\N	\N	99613	99613	99341
22036	32173	49	applied	\N	\N	\N	\N	99614	99614	99343
22036	32174	50	applied	\N	\N	\N	\N	99410	99410	99345
22036	32278	51	applied	\N	\N	\N	\N	99728	99728	99987
22036	32274	52	applied	\N	\N	\N	\N	99718	99718	99719
22036	32279	53	applied	\N	\N	\N	\N	99730	99730	99988
22036	32280	54	applied	\N	\N	\N	\N	99732	99732	99989
22036	32926	55	applied	\N	\N	\N	\N	101873	101873	101827
22036	32287	56	applied	\N	\N	\N	\N	99755	99755	99990
22036	32290	57	applied	\N	\N	\N	\N	99762	99762	99991
22036	32291	58	applied	\N	\N	\N	\N	99764	99764	99992
22036	32296	59	applied	\N	\N	\N	\N	99778	99778	99993
22036	32299	60	applied	\N	\N	\N	\N	99785	99785	99994
22036	32302	61	applied	\N	\N	\N	\N	99799	99799	99995
22036	32305	62	applied	\N	\N	\N	\N	99806	99806	99996
22036	32306	63	applied	\N	\N	\N	\N	99808	99808	99997
22036	32307	64	applied	\N	\N	\N	\N	99810	99810	99998
22036	32308	65	applied	\N	\N	\N	\N	99812	99812	99999
22036	32317	66	applied	\N	\N	\N	\N	99831	99831	100000
22036	32321	67	applied	\N	\N	\N	\N	99843	99843	100001
22036	32322	68	applied	\N	\N	\N	\N	99845	99845	100002
22036	32327	69	applied	\N	\N	\N	\N	99860	99860	100003
22036	32330	70	applied	\N	\N	\N	\N	99867	99867	100004
22036	32331	71	applied	\N	\N	\N	\N	99869	99869	100005
22036	32335	72	applied	\N	\N	\N	\N	99881	99881	100006
22036	32338	73	applied	\N	\N	\N	\N	99892	99892	100007
22036	32339	74	applied	\N	\N	\N	\N	99894	99894	100008
22036	32344	75	applied	\N	\N	\N	\N	99907	99907	100009
22036	32345	76	applied	\N	\N	\N	\N	99909	99909	100010
22036	32346	77	applied	\N	\N	\N	\N	99911	99911	100011
22036	32347	78	applied	\N	\N	\N	\N	99913	99913	100012
22036	32356	79	applied	\N	\N	\N	\N	99932	99932	100013
22036	32359	80	applied	\N	\N	\N	\N	99940	99940	100014
22036	32362	81	applied	\N	\N	\N	\N	99948	99948	100015
22036	32365	82	applied	\N	\N	\N	\N	99958	99958	100016
22036	32381	83	applied	\N	\N	\N	\N	100103	100103	100327
22036	32382	84	applied	\N	\N	\N	\N	100105	100105	100328
22036	32387	85	applied	\N	\N	\N	\N	100121	100121	100329
22036	32390	86	applied	\N	\N	\N	\N	100134	100134	100330
22036	32393	87	applied	\N	\N	\N	\N	100140	100140	100331
22036	32396	88	applied	\N	\N	\N	\N	100148	100148	100332
22036	32399	89	applied	\N	\N	\N	\N	100156	100156	100333
22036	32402	90	applied	\N	\N	\N	\N	100204	100204	100334
22036	32405	91	applied	\N	\N	\N	\N	100213	100213	100335
22036	32408	92	applied	\N	\N	\N	\N	100221	100221	100336
22036	32411	93	applied	\N	\N	\N	\N	100235	100235	100337
22036	32414	94	applied	\N	\N	\N	\N	100246	100246	100338
22036	32417	95	applied	\N	\N	\N	\N	100254	100254	100339
22036	32420	96	applied	\N	\N	\N	\N	100264	100264	100340
22036	32421	97	applied	\N	\N	\N	\N	100266	100266	100341
22036	32426	98	applied	\N	\N	\N	\N	100282	100282	100342
22036	32429	99	applied	\N	\N	\N	\N	100292	100292	100343
22036	32432	100	applied	\N	\N	\N	\N	100299	100299	100344
22036	32435	101	applied	\N	\N	\N	\N	100307	100307	100345
22036	32436	102	applied	\N	\N	\N	\N	100309	100309	100346
22036	32437	103	applied	\N	\N	\N	\N	100311	100311	100347
22036	32444	104	applied	\N	\N	\N	\N	100348	100348	100349
22036	32446	105	applied	\N	\N	\N	\N	100370	100370	101874
22036	32450	106	applied	\N	\N	\N	\N	100380	100380	101875
22036	32453	108	applied	\N	\N	\N	\N	100386	100386	101877
22036	32456	109	applied	\N	\N	\N	\N	100400	100400	101878
22036	32458	110	applied	\N	\N	\N	\N	100407	100407	101879
22036	32461	111	applied	\N	\N	\N	\N	100417	100417	101880
22036	32462	112	applied	\N	\N	\N	\N	100419	100419	101881
22036	32469	113	applied	\N	\N	\N	\N	100436	100436	101882
22036	32476	114	applied	\N	\N	\N	\N	100484	100484	101883
22036	32477	115	applied	\N	\N	\N	\N	100486	100486	101884
22036	32482	116	applied	\N	\N	\N	\N	100498	100498	101885
22036	32485	117	applied	\N	\N	\N	\N	100533	100533	101886
22036	32488	118	applied	\N	\N	\N	\N	100546	100546	101887
22036	32491	119	applied	\N	\N	\N	\N	100552	100552	101888
22036	32492	120	applied	\N	\N	\N	\N	100554	100554	101889
22036	32497	121	applied	\N	\N	\N	\N	100576	100576	101890
22036	32498	122	applied	\N	\N	\N	\N	100578	100578	101891
22036	32503	123	applied	\N	\N	\N	\N	100591	100591	101892
22036	32506	124	applied	\N	\N	\N	\N	100599	100599	101893
22036	32509	125	applied	\N	\N	\N	\N	100609	100609	101894
22037	32944	0	applied	\N	\N	\N	\N	101897	101897	101898
22037	32945	1	applied	\N	\N	\N	\N	101899	101899	101900
22037	32946	2	applied	\N	\N	\N	\N	101901	101901	101902
22037	32947	3	applied	\N	\N	\N	\N	101903	101903	101904
22037	32948	4	applied	\N	\N	\N	\N	101905	101905	101906
22037	32949	5	applied	\N	\N	\N	\N	101907	101907	101908
22037	32950	6	applied	\N	\N	\N	\N	101909	101909	101910
22037	32951	7	applied	\N	\N	\N	\N	101911	101911	101912
22037	32952	8	applied	\N	\N	\N	\N	101913	101913	101914
22048	32983	0	applied	\N	\N	\N	\N	101988	101988	101989
22048	32984	1	applied	\N	\N	\N	\N	101990	101990	101991
22048	32985	2	applied	\N	\N	\N	\N	101992	101992	101993
22054	32993	0	applied	\N	\N	\N	\N	102013	102013	102014
22054	32994	1	applied	\N	\N	\N	\N	102015	102015	102016
22054	32995	2	applied	\N	\N	\N	\N	102017	102017	102018
22059	33000	0	applied	\N	\N	\N	\N	102033	102033	102034
22059	33001	1	applied	\N	\N	\N	\N	102035	102035	102036
22059	33002	2	applied	\N	\N	\N	\N	102037	102037	102038
22064	33013	0	applied	\N	\N	\N	\N	102066	102066	102067
22064	33014	1	applied	\N	\N	\N	\N	102068	102068	102069
22064	33015	2	applied	\N	\N	\N	\N	102070	102070	102071
22066	33019	0	applied	\N	\N	\N	\N	102080	102080	102081
22066	33020	1	applied	\N	\N	\N	\N	102082	102082	102083
22066	33021	2	applied	\N	\N	\N	\N	102084	102084	102085
22066	33022	3	applied	\N	\N	\N	\N	102086	102086	102087
22069	33023	0	applied	\N	\N	\N	\N	102092	102092	102093
22069	33024	1	applied	\N	\N	\N	\N	102094	102094	102095
22069	33025	2	applied	\N	\N	\N	\N	102096	102096	102097
22069	33026	3	applied	\N	\N	\N	\N	102098	102098	102099
22069	33027	4	applied	\N	\N	\N	\N	102100	102100	102101
22069	33028	5	applied	\N	\N	\N	\N	102102	102102	102103
22071	32923	0	applied	\N	\N	\N	\N	101870	101870	101821
22071	32924	1	applied	\N	\N	\N	\N	101871	101871	101823
22071	32925	2	applied	\N	\N	\N	\N	101872	101872	101825
22071	32926	3	applied	\N	\N	\N	\N	101873	101873	101827
22071	32721	4	applied	\N	\N	\N	\N	101232	101232	101233
22071	32779	5	applied	\N	\N	\N	\N	101371	101371	101371
22071	32470	6	applied	\N	\N	\N	\N	100438	100438	100439
22071	32471	7	applied	\N	\N	\N	\N	100440	100440	100441
22071	32472	8	applied	\N	\N	\N	\N	100442	100442	100443
22071	32474	9	applied	\N	\N	\N	\N	100446	100446	100447
22071	29757	10	applied	\N	\N	\N	\N	102117	102117	91928
22073	33033	0	applied	\N	\N	\N	\N	102120	102120	102121
22073	33034	1	applied	\N	\N	\N	\N	102122	102122	102123
22073	33035	2	applied	\N	\N	\N	\N	102124	102124	102125
22073	33036	3	applied	\N	\N	\N	\N	102126	102126	102127
22073	33037	4	applied	\N	\N	\N	\N	102128	102128	102129
22073	33038	5	applied	\N	\N	\N	\N	102130	102130	102131
22078	33045	0	applied	\N	\N	\N	\N	102153	102153	102154
22078	33046	1	applied	\N	\N	\N	\N	102155	102155	102156
22078	33047	2	applied	\N	\N	\N	\N	102157	102157	102158
22080	33045	0	applied	\N	\N	\N	\N	102153	102153	102154
22080	33048	1	applied	\N	\N	\N	\N	102162	102162	102163
22080	33049	2	applied	\N	\N	\N	\N	102164	102164	102165
22080	33050	3	applied	\N	\N	\N	\N	102166	102166	102167
22083	33055	0	applied	\N	\N	\N	\N	102179	102179	102180
22083	33059	1	applied	\N	\N	\N	\N	102215	102215	102216
22083	33058	2	applied	\N	\N	\N	\N	102212	102212	102211
22083	33060	3	applied	\N	\N	\N	\N	102217	102217	102213
22083	33056	4	applied	\N	\N	\N	\N	102191	102191	102218
22085	33055	0	applied	\N	\N	\N	\N	102179	102179	102180
22085	33059	1	applied	\N	\N	\N	\N	102215	102215	102216
22085	33057	2	applied	\N	\N	\N	\N	102199	102199	102221
22085	33058	3	applied	\N	\N	\N	\N	102212	102212	102222
22085	33060	4	applied	\N	\N	\N	\N	102217	102217	102223
22085	33061	5	applied	\N	\N	\N	\N	102224	102224	102225
22085	33056	6	applied	\N	\N	\N	\N	102191	102191	102226
22087	33055	0	applied	\N	\N	\N	\N	102179	102179	102180
22087	33059	1	applied	\N	\N	\N	\N	102215	102215	102216
22087	33057	2	applied	\N	\N	\N	\N	102199	102199	102221
22087	33058	3	applied	\N	\N	\N	\N	102212	102212	102222
22087	33060	4	applied	\N	\N	\N	\N	102217	102217	102223
22087	33061	5	applied	\N	\N	\N	\N	102224	102224	102225
22087	33056	6	applied	\N	\N	\N	\N	102191	102191	102226
22089	33062	0	applied	\N	\N	\N	\N	102234	102234	102235
22089	33063	1	applied	\N	\N	\N	\N	102236	102236	102237
22089	33064	2	applied	\N	\N	\N	\N	102238	102238	102239
22095	33084	0	applied	\N	\N	\N	\N	102292	102292	102293
22095	33085	1	applied	\N	\N	\N	\N	102294	102294	102295
22095	33086	2	applied	\N	\N	\N	\N	102296	102296	102297
22098	33094	0	applied	\N	\N	\N	\N	102318	102318	102319
22098	33095	1	applied	\N	\N	\N	\N	102320	102320	102321
22098	33096	2	applied	\N	\N	\N	\N	102322	102322	102323
22098	33097	3	applied	\N	\N	\N	\N	102324	102324	102325
22098	33098	4	applied	\N	\N	\N	\N	102326	102326	102327
22098	33099	5	applied	\N	\N	\N	\N	102328	102328	102329
22098	33100	6	applied	\N	\N	\N	\N	102330	102330	102331
22103	33107	0	applied	\N	\N	\N	\N	102349	102349	102350
22103	33108	1	applied	\N	\N	\N	\N	102351	102351	102352
22103	33109	2	applied	\N	\N	\N	\N	102353	102353	102354
22103	33110	3	applied	\N	\N	\N	\N	102355	102355	102356
22103	33111	4	applied	\N	\N	\N	\N	102357	102357	102358
22103	33112	5	applied	\N	\N	\N	\N	102359	102359	102360
22074	33038	5	applied	\N	\N	\N	\N	102130	102130	102131
22081	33051	0	applied	\N	\N	\N	\N	102169	102169	102170
22081	33052	1	applied	\N	\N	\N	\N	102171	102171	102172
22081	33053	2	applied	\N	\N	\N	\N	102173	102173	102174
22090	33065	0	applied	\N	\N	\N	\N	102243	102243	102244
22090	33066	1	applied	\N	\N	\N	\N	102245	102245	102246
22093	33081	0	applied	\N	\N	\N	\N	102282	102282	102283
22093	33082	1	applied	\N	\N	\N	\N	102284	102284	102285
22093	33083	2	applied	\N	\N	\N	\N	102286	102286	102287
22099	33094	0	applied	\N	\N	\N	\N	102318	102318	102319
22099	33095	1	applied	\N	\N	\N	\N	102320	102320	102321
22099	33096	2	applied	\N	\N	\N	\N	102322	102322	102323
22099	33097	3	applied	\N	\N	\N	\N	102324	102324	102325
22099	33098	4	applied	\N	\N	\N	\N	102326	102326	102327
22099	33099	5	applied	\N	\N	\N	\N	102328	102328	102329
22099	33100	6	applied	\N	\N	\N	\N	102330	102330	102331
22104	33117	0	applied	\N	\N	\N	\N	102371	102371	102372
22104	33118	1	applied	\N	\N	\N	\N	102373	102373	102374
22104	33119	2	applied	\N	\N	\N	\N	102375	102375	102376
22104	33120	3	applied	\N	\N	\N	\N	102377	102377	102378
22104	33121	4	applied	\N	\N	\N	\N	102379	102379	102380
22104	33122	5	applied	\N	\N	\N	\N	102381	102381	102382
22104	33123	6	applied	\N	\N	\N	\N	102383	102383	102384
22107	33128	0	applied	\N	\N	\N	\N	102399	102399	102400
22107	33129	1	applied	\N	\N	\N	\N	102401	102401	102402
22107	33130	2	applied	\N	\N	\N	\N	102403	102403	102404
22107	33131	3	applied	\N	\N	\N	\N	102405	102405	102406
22107	33132	4	applied	\N	\N	\N	\N	102407	102407	102408
22107	33133	5	applied	\N	\N	\N	\N	102409	102409	102410
22107	33134	6	applied	\N	\N	\N	\N	102411	102411	102412
22107	33135	7	applied	\N	\N	\N	\N	102413	102413	102414
22116	33148	0	applied	\N	\N	\N	\N	102470	102470	102471
22116	33147	1	applied	\N	\N	\N	\N	102465	102465	102466
22116	33149	2	applied	\N	\N	\N	\N	102472	102472	102473
22116	33150	3	applied	\N	\N	\N	\N	102474	102474	102475
22116	33151	4	applied	\N	\N	\N	\N	102476	102476	102477
22119	33162	0	applied	\N	\N	\N	\N	102501	102501	102502
22119	33163	1	applied	\N	\N	\N	\N	102503	102503	102504
22119	33164	2	applied	\N	\N	\N	\N	102505	102505	102506
22119	33165	3	applied	\N	\N	\N	\N	102507	102507	102508
22119	33166	4	applied	\N	\N	\N	\N	102509	102509	102510
22119	33167	5	applied	\N	\N	\N	\N	102511	102511	102512
22119	33168	6	applied	\N	\N	\N	\N	102513	102513	102514
22125	33177	0	applied	\N	\N	\N	\N	102537	102537	102538
22125	33178	1	applied	\N	\N	\N	\N	102539	102539	102540
22125	33179	2	applied	\N	\N	\N	\N	102541	102541	102542
22126	33180	0	applied	\N	\N	\N	\N	102549	102549	102550
22126	33181	1	applied	\N	\N	\N	\N	102551	102551	102552
22126	33182	2	applied	\N	\N	\N	\N	102553	102553	102554
22126	33183	3	applied	\N	\N	\N	\N	102555	102555	102556
22129	33190	0	applied	\N	\N	\N	\N	102573	102573	102574
22129	33191	1	applied	\N	\N	\N	\N	102575	102575	102576
22129	33192	2	applied	\N	\N	\N	\N	102577	102577	102578
22129	33193	3	applied	\N	\N	\N	\N	102579	102579	102580
22129	33194	4	applied	\N	\N	\N	\N	102581	102581	102582
22129	33195	5	applied	\N	\N	\N	\N	102583	102583	102584
22129	33196	6	applied	\N	\N	\N	\N	102585	102585	102586
22132	33197	0	applied	\N	\N	\N	\N	102589	102589	102590
22132	33198	1	applied	\N	\N	\N	\N	102591	102591	102592
22132	33199	2	applied	\N	\N	\N	\N	102593	102593	102594
22132	33200	3	applied	\N	\N	\N	\N	102595	102595	102596
22132	33201	4	applied	\N	\N	\N	\N	102597	102597	102598
22132	33202	5	applied	\N	\N	\N	\N	102599	102599	102600
22135	33203	0	applied	\N	\N	\N	\N	102606	102606	102607
22135	33204	1	applied	\N	\N	\N	\N	102608	102608	102609
22135	33205	2	applied	\N	\N	\N	\N	102610	102610	102611
22135	33206	3	applied	\N	\N	\N	\N	102612	102612	102613
22137	33207	0	applied	\N	\N	\N	\N	102616	102616	102617
22137	33208	1	applied	\N	\N	\N	\N	102618	102618	102619
22137	33209	2	applied	\N	\N	\N	\N	102620	102620	102621
22137	33210	3	applied	\N	\N	\N	\N	102622	102622	102623
22137	33211	4	applied	\N	\N	\N	\N	102624	102624	102625
22137	33212	5	applied	\N	\N	\N	\N	102626	102626	102627
22137	33213	6	applied	\N	\N	\N	\N	102628	102628	102629
22137	33214	7	applied	\N	\N	\N	\N	102630	102630	102631
22137	33215	8	applied	\N	\N	\N	\N	102632	102632	102633
22137	33216	9	applied	\N	\N	\N	\N	102634	102634	102635
22141	33226	0	applied	\N	\N	\N	\N	102659	102659	102660
22141	33227	1	applied	\N	\N	\N	\N	102661	102661	102662
22141	33228	2	applied	\N	\N	\N	\N	102663	102663	102664
22141	33229	3	applied	\N	\N	\N	\N	102665	102665	102666
22141	33230	4	applied	\N	\N	\N	\N	102667	102667	102667
22141	33231	5	applied	\N	\N	\N	\N	102668	102668	102669
22141	33232	6	applied	\N	\N	\N	\N	102670	102670	102671
22141	33233	7	applied	\N	\N	\N	\N	102672	102672	102673
22141	33234	8	applied	\N	\N	\N	\N	102674	102674	102675
22141	33235	9	applied	\N	\N	\N	\N	102676	102676	102677
22141	33236	10	applied	\N	\N	\N	\N	102678	102678	102679
22147	33241	0	applied	\N	\N	\N	\N	102702	102702	102703
22147	33242	1	applied	\N	\N	\N	\N	102704	102704	102705
22147	33243	2	applied	\N	\N	\N	\N	102706	102706	102707
22150	33254	0	applied	\N	\N	\N	\N	102732	102732	102733
22150	33255	1	applied	\N	\N	\N	\N	102734	102734	102735
22150	33256	2	applied	\N	\N	\N	\N	102736	102736	102737
22154	33257	0	applied	\N	\N	\N	\N	102741	102741	102742
22154	33258	1	applied	\N	\N	\N	\N	102743	102743	102744
22154	33259	2	applied	\N	\N	\N	\N	102745	102745	102746
22154	33260	3	applied	\N	\N	\N	\N	102747	102747	102748
22154	33261	4	applied	\N	\N	\N	\N	102749	102749	102750
22154	33262	5	applied	\N	\N	\N	\N	102751	102751	102752
22154	33263	6	applied	\N	\N	\N	\N	102753	102753	102754
22154	33264	7	applied	\N	\N	\N	\N	102755	102755	102756
22154	33265	8	applied	\N	\N	\N	\N	102757	102757	102758
22154	33266	9	applied	\N	\N	\N	\N	102759	102759	102760
22160	33269	0	applied	\N	\N	\N	\N	102776	102776	102777
22160	33270	1	applied	\N	\N	\N	\N	102778	102778	102779
22160	33271	2	applied	\N	\N	\N	\N	102780	102780	102781
22160	33272	3	applied	\N	\N	\N	\N	102782	102782	102783
22160	33273	4	applied	\N	\N	1000000000	\N	102784	102784	102785
22162	33274	0	applied	\N	\N	\N	\N	102789	102789	102790
22162	33275	1	applied	\N	\N	\N	\N	102791	102791	102792
22162	33276	2	applied	\N	\N	\N	\N	102793	102793	102794
22166	33280	0	applied	\N	\N	\N	\N	102811	102811	102812
22166	33281	1	applied	\N	\N	\N	\N	102813	102813	102814
22166	33282	2	applied	\N	\N	\N	\N	102815	102815	102816
22166	33283	3	applied	\N	\N	\N	\N	102817	102817	102818
22166	33284	4	applied	\N	\N	\N	\N	102819	102819	102820
22171	33299	0	applied	\N	\N	\N	\N	102855	102855	102856
22171	33300	1	applied	\N	\N	\N	\N	102857	102857	102858
22171	33301	2	applied	\N	\N	\N	\N	102859	102859	102860
22082	32997	28	applied	\N	\N	\N	\N	102025	102025	102026
22082	32998	29	applied	\N	\N	\N	\N	102027	102027	102028
22082	33006	30	applied	\N	\N	\N	\N	102051	102051	102182
22082	33022	31	applied	\N	\N	\N	\N	102086	102086	102183
22082	33001	32	applied	\N	\N	\N	\N	102035	102035	102184
22082	33007	33	applied	\N	\N	\N	\N	102053	102053	102185
22082	33008	34	applied	\N	\N	\N	\N	102055	102055	102038
22082	33009	35	applied	\N	\N	\N	\N	102057	102057	102186
22082	33015	36	applied	\N	\N	\N	\N	102070	102070	102187
22082	33017	37	applied	\N	\N	\N	\N	102074	102074	102188
22082	33021	38	applied	\N	\N	\N	\N	102084	102084	102189
22082	33032	39	applied	\N	\N	\N	\N	102114	102114	102190
22082	33042	40	applied	\N	\N	\N	\N	102146	102146	102060
22082	33056	41	applied	\N	\N	\N	\N	102191	102191	102192
22082	32999	42	applied	\N	\N	\N	\N	102029	102029	102193
22082	33027	43	applied	\N	\N	\N	\N	102100	102100	102064
22082	33028	44	applied	\N	\N	\N	\N	102102	102102	102194
22082	33030	45	applied	\N	\N	\N	\N	102110	102110	102195
22082	33038	46	applied	\N	\N	\N	\N	102130	102130	102196
22082	33043	47	applied	\N	\N	\N	\N	102148	102148	102197
22082	33044	48	applied	\N	\N	\N	\N	102150	102150	102077
22082	33046	49	applied	\N	\N	\N	\N	102155	102155	102198
22082	33049	50	applied	\N	\N	\N	\N	102164	102164	102090
22082	33052	51	applied	\N	\N	\N	\N	102171	102171	102087
22082	33057	52	applied	\N	\N	\N	\N	102199	102199	102200
22082	33002	53	applied	\N	\N	\N	\N	102037	102037	102201
22082	33010	54	applied	\N	\N	\N	\N	102059	102059	102101
22082	33011	55	applied	\N	\N	\N	\N	102061	102061	102202
22082	33012	56	applied	\N	\N	\N	\N	102063	102063	102203
22082	33014	57	applied	\N	\N	\N	\N	102068	102068	102204
22082	33018	58	applied	\N	\N	\N	\N	102076	102076	102205
22082	33020	59	applied	\N	\N	\N	\N	102082	102082	102206
22082	33025	60	applied	\N	\N	\N	\N	102096	102096	102207
22082	33026	61	applied	\N	\N	\N	\N	102098	102098	102151
22082	33031	62	applied	\N	\N	\N	\N	102112	102112	102208
22082	33037	63	applied	\N	\N	\N	\N	102128	102128	102209
22082	33041	64	applied	\N	\N	\N	\N	102144	102144	102210
22082	33047	65	applied	\N	\N	\N	\N	102157	102157	102172
22082	33050	66	applied	\N	\N	\N	\N	102166	102166	102174
22082	33053	67	applied	\N	\N	\N	\N	102173	102173	102211
22082	33058	68	applied	\N	\N	\N	\N	102212	102212	102213
22091	33067	0	applied	\N	\N	\N	\N	102249	102249	102250
22091	33068	1	applied	\N	\N	\N	\N	102251	102251	102252
22092	33065	0	applied	\N	\N	\N	\N	102243	102243	102244
22092	33069	1	applied	\N	\N	\N	\N	102254	102254	102255
22092	33070	2	applied	\N	\N	\N	\N	102256	102256	102257
22092	33071	3	applied	\N	\N	\N	\N	102258	102258	102259
22092	33072	4	applied	\N	\N	\N	\N	102260	102260	102261
22092	33073	5	applied	\N	\N	\N	\N	102262	102262	102263
22092	33074	6	applied	\N	\N	\N	\N	102264	102264	102265
22092	33075	7	applied	\N	\N	\N	\N	102266	102266	102267
22092	33076	8	applied	\N	\N	\N	\N	102268	102268	102269
22092	33077	10	applied	\N	\N	\N	\N	102271	102271	102272
22092	33078	11	applied	\N	\N	\N	\N	102273	102273	102274
22092	33079	12	applied	\N	\N	\N	\N	102275	102275	102276
22092	33066	13	applied	\N	\N	\N	\N	102245	102245	102277
22092	33080	14	applied	\N	\N	\N	\N	102278	102278	102279
22094	33081	0	applied	\N	\N	\N	\N	102282	102282	102283
22094	33082	1	applied	\N	\N	\N	\N	102284	102284	102285
22094	33083	2	applied	\N	\N	\N	\N	102286	102286	102287
22097	33091	0	applied	\N	\N	\N	\N	102310	102310	102311
22097	33092	1	applied	\N	\N	\N	\N	102312	102312	102313
22097	33093	2	applied	\N	\N	\N	\N	102314	102314	102315
22100	33094	0	applied	\N	\N	\N	\N	102318	102318	102319
22100	33095	1	applied	\N	\N	\N	\N	102320	102320	102321
22100	33096	2	applied	\N	\N	\N	\N	102322	102322	102323
22100	33097	3	applied	\N	\N	\N	\N	102324	102324	102325
22100	33098	4	applied	\N	\N	\N	\N	102326	102326	102327
22100	33099	5	applied	\N	\N	\N	\N	102328	102328	102329
22100	33100	6	applied	\N	\N	\N	\N	102330	102330	102331
22102	33104	0	applied	\N	\N	\N	\N	102343	102343	102344
22102	33105	1	applied	\N	\N	\N	\N	102345	102345	102346
22102	33106	2	applied	\N	\N	\N	\N	102347	102347	102348
22108	33136	0	applied	\N	\N	\N	\N	102417	102417	102418
22108	33137	1	applied	\N	\N	\N	\N	102419	102419	102420
22108	33138	2	applied	\N	\N	\N	\N	102421	102421	102422
22110	33136	0	applied	\N	\N	\N	\N	102417	102417	102418
22110	33137	1	applied	\N	\N	\N	\N	102419	102419	102420
22110	33138	2	applied	\N	\N	\N	\N	102421	102421	102422
22118	33162	0	applied	\N	\N	\N	\N	102501	102501	102502
22118	33163	1	applied	\N	\N	\N	\N	102503	102503	102504
22118	33164	2	applied	\N	\N	\N	\N	102505	102505	102506
22118	33165	3	applied	\N	\N	\N	\N	102507	102507	102508
22118	33166	4	applied	\N	\N	\N	\N	102509	102509	102510
22118	33167	5	applied	\N	\N	\N	\N	102511	102511	102512
22118	33168	6	applied	\N	\N	\N	\N	102513	102513	102514
22123	33177	0	applied	\N	\N	\N	\N	102537	102537	102538
22123	33178	1	applied	\N	\N	\N	\N	102539	102539	102540
22123	33179	2	applied	\N	\N	\N	\N	102541	102541	102542
22131	33197	0	applied	\N	\N	\N	\N	102589	102589	102590
22131	33198	1	applied	\N	\N	\N	\N	102591	102591	102592
22131	33199	2	applied	\N	\N	\N	\N	102593	102593	102594
22131	33200	3	applied	\N	\N	\N	\N	102595	102595	102596
22131	33201	4	applied	\N	\N	\N	\N	102597	102597	102598
22131	33202	5	applied	\N	\N	\N	\N	102599	102599	102600
22139	33223	0	applied	\N	\N	\N	\N	102652	102652	102653
22139	33224	1	applied	\N	\N	\N	\N	102654	102654	102655
22139	33225	2	applied	\N	\N	\N	\N	102656	102656	102657
22142	33226	0	applied	\N	\N	\N	\N	102659	102659	102660
22142	33229	1	applied	\N	\N	\N	\N	102665	102665	102666
22142	33231	2	applied	\N	\N	\N	\N	102668	102668	102669
22142	33234	3	applied	\N	\N	\N	\N	102674	102674	102684
22145	33227	0	applied	\N	\N	\N	\N	102661	102661	102662
22145	33228	1	applied	\N	\N	\N	\N	102663	102663	102664
22145	33230	2	applied	\N	\N	\N	\N	102667	102667	102667
22145	33235	3	applied	\N	\N	\N	\N	102676	102676	102686
22145	33236	4	applied	\N	\N	\N	\N	102678	102678	102687
22145	33232	5	applied	\N	\N	\N	\N	102670	102670	102688
22145	33233	6	applied	\N	\N	\N	\N	102672	102672	102679
22146	33237	0	applied	\N	\N	\N	\N	102692	102692	102693
22146	33238	1	applied	\N	\N	\N	\N	102694	102694	102695
22146	33239	2	applied	\N	\N	\N	\N	102696	102696	102697
22146	33240	3	applied	\N	\N	\N	\N	102698	102698	102699
22149	33251	0	applied	\N	\N	\N	\N	102724	102724	102725
22149	33252	1	applied	\N	\N	\N	\N	102726	102726	102727
22149	33253	2	applied	\N	\N	\N	\N	102728	102728	102729
22152	33257	0	applied	\N	\N	\N	\N	102741	102741	102742
22152	33258	1	applied	\N	\N	\N	\N	102743	102743	102744
22152	33259	2	applied	\N	\N	\N	\N	102745	102745	102746
22152	33260	3	applied	\N	\N	\N	\N	102747	102747	102748
22103	33113	6	applied	\N	\N	\N	\N	102361	102361	102362
22103	33114	7	applied	\N	\N	\N	\N	102363	102363	102364
22103	33115	8	applied	\N	\N	\N	\N	102365	102365	102366
22103	33116	9	applied	\N	\N	\N	\N	102367	102367	102368
22106	33124	0	applied	\N	\N	\N	\N	102387	102387	102388
22106	33125	1	applied	\N	\N	\N	\N	102389	102389	102390
22106	33126	2	applied	\N	\N	\N	\N	102391	102391	102392
22106	33127	3	applied	\N	\N	\N	\N	102393	102393	102394
22109	33136	0	applied	\N	\N	\N	\N	102417	102417	102418
22109	33137	1	applied	\N	\N	\N	\N	102419	102419	102420
22109	33138	2	applied	\N	\N	\N	\N	102421	102421	102422
22111	33139	0	applied	\N	\N	\N	\N	102429	102429	102429
22111	33140	1	applied	\N	\N	\N	\N	102430	102430	102431
22111	33141	2	applied	\N	\N	\N	\N	102432	102432	102433
22111	33142	3	applied	\N	\N	\N	\N	102434	102434	102435
22111	33143	4	applied	\N	\N	\N	\N	102436	102436	102437
22113	33144	0	applied	\N	\N	\N	\N	102457	102457	102458
22113	33145	1	applied	\N	\N	\N	\N	102459	102459	102460
22113	33146	2	applied	\N	\N	\N	\N	102461	102461	102462
22115	33147	0	applied	\N	\N	\N	\N	102465	102465	102466
22115	33144	1	applied	\N	\N	\N	\N	102457	102457	102458
22115	33145	2	applied	\N	\N	\N	\N	102459	102459	102460
22115	33146	3	applied	\N	\N	\N	\N	102461	102461	102462
22121	33169	0	applied	\N	\N	\N	\N	102517	102517	102518
22121	33170	1	applied	\N	\N	1000000000	\N	102519	102519	102520
22121	33171	2	applied	\N	\N	\N	\N	102521	102521	102522
22121	33172	3	applied	\N	\N	\N	\N	102523	102523	102524
22121	33173	4	applied	\N	\N	\N	\N	102525	102525	102526
22124	33177	0	applied	\N	\N	\N	\N	102537	102537	102538
22124	33178	1	applied	\N	\N	\N	\N	102539	102539	102540
22124	33179	2	applied	\N	\N	\N	\N	102541	102541	102542
22128	33187	0	applied	\N	\N	\N	\N	102565	102565	102566
22128	33188	1	applied	\N	\N	\N	\N	102567	102567	102568
22128	33189	2	applied	\N	\N	\N	\N	102569	102569	102570
22134	33203	0	applied	\N	\N	\N	\N	102606	102606	102607
22134	33204	1	applied	\N	\N	\N	\N	102608	102608	102609
22134	33205	2	applied	\N	\N	\N	\N	102610	102610	102611
22134	33206	3	applied	\N	\N	\N	\N	102612	102612	102613
22140	33226	0	applied	\N	\N	\N	\N	102659	102659	102660
22140	33227	1	applied	\N	\N	\N	\N	102661	102661	102662
22140	33228	2	applied	\N	\N	\N	\N	102663	102663	102664
22140	33229	3	applied	\N	\N	\N	\N	102665	102665	102666
22140	33230	4	applied	\N	\N	\N	\N	102667	102667	102667
22140	33231	5	applied	\N	\N	\N	\N	102668	102668	102669
22140	33232	6	applied	\N	\N	\N	\N	102670	102670	102671
22140	33233	7	applied	\N	\N	\N	\N	102672	102672	102673
22140	33234	8	applied	\N	\N	\N	\N	102674	102674	102675
22140	33235	9	applied	\N	\N	\N	\N	102676	102676	102677
22140	33236	10	applied	\N	\N	\N	\N	102678	102678	102679
22143	33227	0	applied	\N	\N	\N	\N	102661	102661	102662
22143	33228	1	applied	\N	\N	\N	\N	102663	102663	102664
22143	33230	2	applied	\N	\N	\N	\N	102667	102667	102667
22143	33235	3	applied	\N	\N	\N	\N	102676	102676	102686
22143	33236	4	applied	\N	\N	\N	\N	102678	102678	102687
22143	33232	5	applied	\N	\N	\N	\N	102670	102670	102688
22143	33233	6	applied	\N	\N	\N	\N	102672	102672	102679
22153	33257	0	applied	\N	\N	\N	\N	102741	102741	102742
22153	33258	1	applied	\N	\N	\N	\N	102743	102743	102744
22153	33259	2	applied	\N	\N	\N	\N	102745	102745	102746
22153	33260	3	applied	\N	\N	\N	\N	102747	102747	102748
22153	33261	4	applied	\N	\N	\N	\N	102749	102749	102750
22153	33262	5	applied	\N	\N	\N	\N	102751	102751	102752
22153	33263	6	applied	\N	\N	\N	\N	102753	102753	102754
22153	33264	7	applied	\N	\N	\N	\N	102755	102755	102756
22153	33265	8	applied	\N	\N	\N	\N	102757	102757	102758
22153	33266	9	applied	\N	\N	\N	\N	102759	102759	102760
22157	33257	0	applied	\N	\N	\N	\N	102741	102741	102742
22157	33258	1	applied	\N	\N	\N	\N	102743	102743	102744
22157	33259	2	applied	\N	\N	\N	\N	102745	102745	102746
22157	33260	3	applied	\N	\N	\N	\N	102747	102747	102748
22157	33261	4	applied	\N	\N	\N	\N	102749	102749	102750
22157	33262	5	applied	\N	\N	\N	\N	102751	102751	102752
22157	33263	6	applied	\N	\N	\N	\N	102753	102753	102754
22157	33264	7	applied	\N	\N	\N	\N	102755	102755	102756
22157	33265	8	applied	\N	\N	\N	\N	102757	102757	102758
22157	33266	9	applied	\N	\N	\N	\N	102759	102759	102760
22159	33269	0	applied	\N	\N	\N	\N	102776	102776	102777
22159	33270	1	applied	\N	\N	\N	\N	102778	102778	102779
22159	33271	2	applied	\N	\N	\N	\N	102780	102780	102781
22159	33272	3	applied	\N	\N	\N	\N	102782	102782	102783
22159	33273	4	applied	\N	\N	1000000000	\N	102784	102784	102785
22161	33274	0	applied	\N	\N	\N	\N	102789	102789	102790
22161	33275	1	applied	\N	\N	\N	\N	102791	102791	102792
22161	33276	2	applied	\N	\N	\N	\N	102793	102793	102794
22164	33277	0	applied	\N	\N	\N	\N	102798	102798	102799
22164	33278	1	applied	\N	\N	\N	\N	102801	102801	102803
22164	33279	2	applied	\N	\N	\N	\N	102804	102804	102805
22170	33291	0	applied	\N	\N	\N	\N	102839	102839	102840
22170	33292	1	applied	\N	\N	\N	\N	102841	102841	102842
22170	33293	2	applied	\N	\N	\N	\N	102843	102843	102844
22170	33294	3	applied	\N	\N	\N	\N	102845	102845	102846
22170	33295	4	applied	\N	\N	\N	\N	102847	102847	102848
22170	33296	5	applied	\N	\N	\N	\N	102849	102849	102850
22170	33297	6	applied	\N	\N	\N	\N	102851	102851	102784
22170	33298	7	applied	\N	\N	\N	\N	102852	102852	102853
22173	33306	0	applied	\N	\N	\N	\N	102872	102872	102873
22173	33307	1	applied	\N	\N	\N	\N	102874	102874	102875
22173	33308	2	applied	\N	\N	\N	\N	102876	102876	102877
22179	33326	0	applied	\N	\N	\N	\N	102922	102922	102923
22179	33327	1	applied	\N	\N	\N	\N	102924	102924	102925
22179	33328	2	applied	\N	\N	\N	\N	102926	102926	102927
22179	33329	3	applied	\N	\N	\N	\N	102928	102928	102929
22179	33330	4	applied	\N	\N	\N	\N	102930	102930	102931
22179	33331	5	applied	\N	\N	\N	\N	102932	102932	102933
22181	33335	0	applied	\N	\N	\N	\N	102945	102945	102946
22181	33336	1	applied	\N	\N	\N	\N	102947	102947	102948
22181	33337	2	applied	\N	\N	\N	\N	102949	102949	102950
22181	33338	3	applied	\N	\N	\N	\N	102951	102951	102952
22184	33280	0	applied	\N	\N	\N	\N	102969	102969	102812
22184	33285	1	applied	\N	\N	\N	\N	102970	102970	102827
22184	33286	2	applied	\N	\N	\N	\N	102971	102971	102829
22184	33291	3	applied	\N	\N	\N	\N	102972	102972	102840
22184	33139	4	applied	\N	\N	\N	\N	102429	102429	102429
22184	33292	5	applied	\N	\N	\N	\N	102973	102973	102842
22184	33293	7	applied	\N	\N	\N	\N	102975	102975	102844
22184	33294	8	applied	\N	\N	\N	\N	102976	102976	102846
22184	33295	9	applied	\N	\N	\N	\N	102977	102977	102848
22184	33033	10	applied	\N	\N	\N	\N	102978	102978	102121
22184	33188	11	applied	\N	\N	\N	\N	102567	102567	102979
22112	33140	14	applied	\N	\N	\N	\N	102430	102430	102431
22112	33101	15	applied	\N	\N	\N	\N	102337	102337	102338
22112	33104	16	applied	\N	\N	\N	\N	102343	102343	102344
22112	33107	17	applied	\N	\N	\N	\N	102349	102349	102350
22112	33108	18	applied	\N	\N	\N	\N	102351	102351	102352
22112	33109	19	applied	\N	\N	\N	\N	102353	102353	102354
22112	33117	20	applied	\N	\N	\N	\N	102371	102371	102372
22112	33118	21	applied	\N	\N	\N	\N	102373	102373	102374
22112	33124	22	applied	\N	\N	\N	\N	102387	102387	102388
22112	33128	23	applied	\N	\N	\N	\N	102399	102399	102400
22112	33130	24	applied	\N	\N	\N	\N	102403	102403	102404
22112	33136	25	applied	\N	\N	\N	\N	102417	102417	102418
22112	33141	26	applied	\N	\N	\N	\N	102432	102432	102433
22112	33063	27	applied	\N	\N	\N	\N	102236	102236	102237
22112	33064	28	applied	\N	\N	\N	\N	102238	102238	102239
22112	33067	29	applied	\N	\N	\N	\N	102249	102249	102250
22112	33068	30	applied	\N	\N	\N	\N	102251	102251	102252
22112	33072	31	applied	\N	\N	\N	\N	102260	102260	102261
22112	33073	32	applied	\N	\N	\N	\N	102262	102262	102263
22112	33074	33	applied	\N	\N	\N	\N	102264	102264	102265
22112	33075	34	applied	\N	\N	\N	\N	102266	102266	102267
22112	33076	35	applied	\N	\N	\N	\N	102268	102268	102269
22112	33077	36	applied	\N	\N	\N	\N	102271	102271	102272
22112	33078	37	applied	\N	\N	\N	\N	102273	102273	102274
22112	33079	38	applied	\N	\N	\N	\N	102275	102275	102276
22112	33082	39	applied	\N	\N	\N	\N	102284	102284	102279
22112	33085	40	applied	\N	\N	\N	\N	102294	102294	102285
22112	33088	41	applied	\N	\N	\N	\N	102302	102302	102440
22112	33066	42	applied	\N	\N	\N	\N	102245	102245	102287
22112	33080	43	applied	\N	\N	\N	\N	102278	102278	102441
22112	33090	44	applied	\N	\N	\N	\N	102306	102306	102295
22112	33097	46	applied	\N	\N	\N	\N	102324	102324	102443
22112	33111	47	applied	\N	\N	\N	\N	102357	102357	102444
22112	33121	48	applied	\N	\N	\N	\N	102379	102379	102297
22112	33135	49	applied	\N	\N	\N	\N	102413	102413	102445
22112	33083	50	applied	\N	\N	\N	\N	102286	102286	102446
22112	33086	51	applied	\N	\N	\N	\N	102296	102296	102447
22112	33089	52	applied	\N	\N	\N	\N	102304	102304	102448
22112	33092	53	applied	\N	\N	\N	\N	102312	102312	102449
22112	33096	54	applied	\N	\N	\N	\N	102322	102322	102450
22112	33098	55	applied	\N	\N	\N	\N	102326	102326	102451
22112	33103	56	applied	\N	\N	\N	\N	102341	102341	102331
22112	33106	57	applied	\N	\N	\N	\N	102347	102347	102452
22112	33110	58	applied	\N	\N	\N	\N	102355	102355	102453
22112	33112	59	applied	\N	\N	\N	\N	102359	102359	102454
22114	33147	0	applied	\N	\N	\N	\N	102465	102465	102466
22114	33144	1	applied	\N	\N	\N	\N	102457	102457	102458
22114	33145	2	applied	\N	\N	\N	\N	102459	102459	102460
22114	33146	3	applied	\N	\N	\N	\N	102461	102461	102462
22117	33152	0	applied	\N	\N	\N	\N	102479	102479	102480
22117	33153	1	applied	\N	\N	\N	\N	102481	102481	102482
22117	33154	2	applied	\N	\N	\N	\N	102483	102483	102484
22117	33155	3	applied	\N	\N	\N	\N	102485	102485	102486
22117	33156	4	applied	\N	\N	\N	\N	102487	102487	102488
22117	33157	5	applied	\N	\N	\N	\N	102489	102489	102490
22117	33158	6	applied	\N	\N	\N	\N	102491	102491	102492
22117	33159	7	applied	\N	\N	\N	\N	102493	102493	102494
22117	33160	8	applied	\N	\N	\N	\N	102495	102495	102496
22117	33161	9	applied	\N	\N	\N	\N	102497	102497	102498
22120	33162	0	applied	\N	\N	\N	\N	102501	102501	102502
22120	33163	1	applied	\N	\N	\N	\N	102503	102503	102504
22120	33164	2	applied	\N	\N	\N	\N	102505	102505	102506
22120	33165	3	applied	\N	\N	\N	\N	102507	102507	102508
22120	33166	4	applied	\N	\N	\N	\N	102509	102509	102510
22120	33167	5	applied	\N	\N	\N	\N	102511	102511	102512
22120	33168	6	applied	\N	\N	\N	\N	102513	102513	102514
22122	33174	0	applied	\N	\N	\N	\N	102529	102529	102530
22122	33175	1	applied	\N	\N	\N	\N	102531	102531	102532
22122	33176	2	applied	\N	\N	\N	\N	102533	102533	102534
22127	33184	0	applied	\N	\N	\N	\N	102559	102559	102560
22127	33185	1	applied	\N	\N	\N	\N	102561	102561	102562
22127	33186	2	applied	\N	\N	\N	\N	102563	102563	102564
22130	33197	0	applied	\N	\N	\N	\N	102589	102589	102590
22130	33198	1	applied	\N	\N	\N	\N	102591	102591	102592
22130	33199	2	applied	\N	\N	\N	\N	102593	102593	102594
22130	33200	3	applied	\N	\N	\N	\N	102595	102595	102596
22130	33201	4	applied	\N	\N	\N	\N	102597	102597	102598
22130	33202	5	applied	\N	\N	\N	\N	102599	102599	102600
22136	33203	0	applied	\N	\N	\N	\N	102606	102606	102607
22136	33204	1	applied	\N	\N	\N	\N	102608	102608	102609
22136	33205	2	applied	\N	\N	\N	\N	102610	102610	102611
22136	33206	3	applied	\N	\N	\N	\N	102612	102612	102613
22138	33217	0	applied	\N	\N	\N	\N	102638	102638	102639
22138	33218	1	applied	\N	\N	\N	\N	102640	102640	102641
22138	33219	2	applied	\N	\N	\N	\N	102642	102642	102643
22138	33220	3	applied	\N	\N	\N	\N	102644	102644	102645
22138	33221	4	applied	\N	\N	\N	\N	102646	102646	102647
22138	33222	5	applied	\N	\N	\N	\N	102648	102648	102649
22144	33227	0	applied	\N	\N	\N	\N	102661	102661	102662
22144	33228	1	applied	\N	\N	\N	\N	102663	102663	102664
22144	33230	2	applied	\N	\N	\N	\N	102667	102667	102667
22144	33235	3	applied	\N	\N	\N	\N	102676	102676	102686
22144	33236	4	applied	\N	\N	\N	\N	102678	102678	102687
22144	33232	5	applied	\N	\N	\N	\N	102670	102670	102688
22144	33233	6	applied	\N	\N	\N	\N	102672	102672	102679
22148	33244	0	applied	\N	\N	\N	\N	102708	102708	102709
22148	33245	1	applied	\N	\N	\N	\N	102710	102710	102711
22148	33246	2	applied	\N	\N	\N	\N	102712	102712	102713
22148	33247	3	applied	\N	\N	\N	\N	102714	102714	102715
22148	33248	4	applied	\N	\N	\N	\N	102716	102716	102717
22148	33249	5	applied	\N	\N	\N	\N	102718	102718	102719
22148	33250	6	applied	\N	\N	\N	\N	102720	102720	102721
22167	33280	0	applied	\N	\N	\N	\N	102811	102811	102812
22167	33281	1	applied	\N	\N	\N	\N	102813	102813	102814
22167	33282	2	applied	\N	\N	\N	\N	102815	102815	102816
22167	33283	3	applied	\N	\N	\N	\N	102817	102817	102818
22167	33284	4	applied	\N	\N	\N	\N	102819	102819	102820
22169	33285	0	applied	\N	\N	\N	\N	102826	102826	102827
22169	33286	1	applied	\N	\N	\N	\N	102828	102828	102829
22169	33287	2	applied	\N	\N	\N	\N	102830	102830	102831
22169	33288	3	applied	\N	\N	\N	\N	102832	102832	102784
22169	33289	4	applied	\N	\N	\N	\N	102833	102833	102834
22169	33290	5	applied	\N	\N	\N	\N	102835	102835	102836
22175	33309	0	applied	\N	\N	\N	\N	102880	102880	102881
22175	33310	1	applied	\N	\N	\N	\N	102882	102882	102883
22175	33311	2	applied	\N	\N	\N	\N	102884	102884	102885
22175	33312	3	applied	\N	\N	\N	\N	102886	102886	102887
22175	33313	4	applied	\N	\N	\N	\N	102888	102888	102889
22175	33314	5	applied	\N	\N	\N	\N	102890	102890	102891
22175	33315	6	applied	\N	\N	\N	\N	102892	102892	102893
22152	33261	4	applied	\N	\N	\N	\N	102749	102749	102750
22152	33262	5	applied	\N	\N	\N	\N	102751	102751	102752
22152	33263	6	applied	\N	\N	\N	\N	102753	102753	102754
22152	33264	7	applied	\N	\N	\N	\N	102755	102755	102756
22152	33265	8	applied	\N	\N	\N	\N	102757	102757	102758
22152	33266	9	applied	\N	\N	\N	\N	102759	102759	102760
22155	33257	0	applied	\N	\N	\N	\N	102741	102741	102742
22155	33258	1	applied	\N	\N	\N	\N	102743	102743	102744
22155	33259	2	applied	\N	\N	\N	\N	102745	102745	102746
22155	33260	3	applied	\N	\N	\N	\N	102747	102747	102748
22155	33261	4	applied	\N	\N	\N	\N	102749	102749	102750
22155	33262	5	applied	\N	\N	\N	\N	102751	102751	102752
22155	33263	6	applied	\N	\N	\N	\N	102753	102753	102754
22155	33264	7	applied	\N	\N	\N	\N	102755	102755	102756
22155	33265	8	applied	\N	\N	\N	\N	102757	102757	102758
22155	33266	9	applied	\N	\N	\N	\N	102759	102759	102760
22158	33267	0	applied	\N	\N	\N	\N	102770	102770	102771
22158	33268	1	applied	\N	\N	\N	\N	102772	102772	102773
22163	33267	0	applied	\N	\N	\N	\N	102770	102770	102771
22163	33269	1	applied	\N	\N	\N	\N	102776	102776	102777
22163	33274	2	applied	\N	\N	\N	\N	102789	102789	102790
22163	33277	3	applied	\N	\N	\N	\N	102798	102798	102799
22163	33270	4	applied	\N	\N	\N	\N	102778	102778	102800
22163	33268	5	applied	\N	\N	\N	\N	102772	102772	102779
22163	33271	6	applied	\N	\N	\N	\N	102780	102780	102781
22163	33272	7	applied	\N	\N	\N	\N	102782	102782	102783
22163	33275	8	applied	\N	\N	\N	\N	102791	102791	102792
22163	33278	9	applied	\N	\N	\N	\N	102801	102801	102802
22163	33273	10	applied	\N	\N	1000000000	\N	102784	102784	102785
22163	33276	11	applied	\N	\N	\N	\N	102793	102793	102803
22163	33279	12	applied	\N	\N	\N	\N	102804	102804	102805
22165	33277	0	applied	\N	\N	\N	\N	102798	102798	102799
22165	33278	1	applied	\N	\N	\N	\N	102801	102801	102803
22165	33279	2	applied	\N	\N	\N	\N	102804	102804	102805
22168	33280	0	applied	\N	\N	\N	\N	102811	102811	102812
22168	33281	1	applied	\N	\N	\N	\N	102813	102813	102814
22168	33282	2	applied	\N	\N	\N	\N	102815	102815	102816
22168	33283	3	applied	\N	\N	\N	\N	102817	102817	102818
22168	33284	4	applied	\N	\N	\N	\N	102819	102819	102820
22172	33302	0	applied	\N	\N	\N	\N	102862	102862	102863
22172	33303	1	applied	\N	\N	\N	\N	102864	102864	102865
22172	33304	2	applied	\N	\N	\N	\N	102866	102866	102867
22172	33305	3	applied	\N	\N	\N	\N	102868	102868	102869
22178	33326	0	applied	\N	\N	\N	\N	102922	102922	102923
22178	33327	1	applied	\N	\N	\N	\N	102924	102924	102925
22178	33328	2	applied	\N	\N	\N	\N	102926	102926	102927
22178	33329	3	applied	\N	\N	\N	\N	102928	102928	102929
22178	33330	4	applied	\N	\N	\N	\N	102930	102930	102931
22178	33331	5	applied	\N	\N	\N	\N	102932	102932	102933
22186	33352	0	applied	\N	\N	\N	\N	103002	103002	103003
22186	33353	1	applied	\N	\N	\N	\N	103004	103004	103005
22186	33354	2	applied	\N	\N	\N	\N	103006	103006	103007
22191	33369	0	applied	\N	\N	\N	\N	103044	103044	103045
22191	33370	1	applied	\N	\N	\N	\N	103046	103046	103047
22191	33371	2	applied	\N	\N	\N	\N	103048	103048	103049
22191	33372	3	applied	\N	\N	\N	\N	103050	103050	103051
22194	33380	0	applied	\N	\N	\N	\N	103071	103071	103072
22194	33381	1	applied	\N	\N	\N	\N	103073	103073	103074
22194	33382	2	applied	\N	\N	\N	\N	103075	103075	103076
22194	33383	3	applied	\N	\N	\N	\N	103077	103077	103078
22199	33241	0	applied	\N	\N	\N	\N	102702	102702	102703
22199	33244	1	applied	\N	\N	\N	\N	102708	102708	102709
22199	33245	2	applied	\N	\N	\N	\N	102710	102710	102711
22199	33251	3	applied	\N	\N	\N	\N	102724	102724	102725
22199	33254	4	applied	\N	\N	\N	\N	102732	102732	102733
22199	33257	5	applied	\N	\N	\N	\N	102741	102741	102742
22199	33258	7	applied	\N	\N	\N	\N	102743	102743	102744
22199	33259	8	applied	\N	\N	\N	\N	102745	102745	102746
22199	33267	9	applied	\N	\N	\N	\N	102770	102770	102771
22199	33269	10	applied	\N	\N	\N	\N	102776	102776	102777
22199	33274	11	applied	\N	\N	\N	\N	102789	102789	102790
22199	33277	12	applied	\N	\N	\N	\N	102798	102798	102799
22199	33281	13	applied	\N	\N	\N	\N	102813	102813	102814
22199	33287	14	applied	\N	\N	\N	\N	102830	102830	102831
22199	33296	15	applied	\N	\N	\N	\N	102849	102849	102850
22199	33299	16	applied	\N	\N	\N	\N	102855	102855	102856
22199	33302	17	applied	\N	\N	\N	\N	102862	102862	102863
22199	33306	18	applied	\N	\N	\N	\N	102872	102872	102873
22199	33309	19	applied	\N	\N	\N	\N	102880	102880	102881
22199	33310	20	applied	\N	\N	\N	\N	102882	102882	102883
22199	33316	21	applied	\N	\N	\N	\N	102898	102898	102899
22199	33319	22	applied	\N	\N	\N	\N	102906	102906	102907
22199	33320	23	applied	\N	\N	\N	\N	102908	102908	102909
22199	33326	24	applied	\N	\N	\N	\N	102922	102922	102923
22199	33327	25	applied	\N	\N	\N	\N	102924	102924	102925
22199	33332	26	applied	\N	\N	\N	\N	102937	102937	102938
22199	33335	27	applied	\N	\N	\N	\N	102945	102945	102946
22199	33339	28	applied	\N	\N	\N	\N	102954	102954	102955
22199	33340	29	applied	\N	\N	\N	\N	102956	102956	102957
22199	33345	30	applied	\N	\N	\N	\N	102985	102985	102986
22199	33346	31	applied	\N	\N	\N	\N	102987	102987	102988
22199	33352	32	applied	\N	\N	\N	\N	103002	103002	103003
22199	33355	33	applied	\N	\N	\N	\N	103010	103010	103011
22199	33360	34	applied	\N	\N	\N	\N	103021	103021	103022
22199	33363	35	applied	\N	\N	\N	\N	103028	103028	103029
22199	33366	36	applied	\N	\N	\N	\N	103036	103036	103037
22199	33369	37	applied	\N	\N	\N	\N	103044	103044	103045
22199	33373	38	applied	\N	\N	\N	\N	103055	103055	103056
22199	33374	39	applied	\N	\N	\N	\N	103057	103057	103058
22199	33380	40	applied	\N	\N	\N	\N	103071	103071	103072
22199	33385	41	applied	\N	\N	\N	\N	103084	103084	103085
22199	33386	42	applied	\N	\N	\N	\N	103086	103086	103087
22199	33397	43	applied	\N	\N	\N	\N	103110	103110	103111
22199	33387	44	applied	\N	\N	\N	\N	103088	103088	96834
22199	33388	45	applied	\N	\N	\N	\N	103112	103112	96834
22199	33389	46	applied	\N	\N	\N	\N	103090	103090	103090
22199	33356	47	applied	\N	\N	\N	\N	103012	103012	103013
22199	33230	48	applied	\N	\N	\N	\N	102667	102667	102667
22199	32895	49	applied	\N	\N	\N	\N	101735	101735	101736
22199	32896	50	applied	\N	\N	\N	\N	101737	101737	101738
22199	32927	51	applied	\N	\N	\N	\N	101828	101828	103113
22199	32898	52	applied	\N	\N	\N	\N	101746	101746	101752
22199	32902	53	applied	\N	\N	\N	\N	101759	101759	101749
22199	32941	54	applied	\N	\N	\N	\N	101863	101863	103114
22199	32956	55	applied	\N	\N	\N	\N	101923	101923	103115
22199	32964	56	applied	\N	\N	\N	\N	101942	101942	101758
22199	32974	57	applied	\N	\N	\N	\N	101968	101968	103116
22199	32987	58	applied	\N	\N	\N	\N	101996	101996	101760
22199	32998	59	applied	\N	\N	\N	\N	102027	102027	103117
22199	33006	60	applied	\N	\N	\N	\N	102051	102051	101767
22174	33309	0	applied	\N	\N	\N	\N	102880	102880	102881
22174	33310	1	applied	\N	\N	\N	\N	102882	102882	102883
22174	33311	2	applied	\N	\N	\N	\N	102884	102884	102885
22174	33312	3	applied	\N	\N	\N	\N	102886	102886	102887
22174	33313	4	applied	\N	\N	\N	\N	102888	102888	102889
22174	33314	5	applied	\N	\N	\N	\N	102890	102890	102891
22174	33315	6	applied	\N	\N	\N	\N	102892	102892	102893
22176	33316	0	applied	\N	\N	\N	\N	102898	102898	102899
22176	33317	1	applied	\N	\N	\N	\N	102900	102900	102901
22176	33318	2	applied	\N	\N	\N	\N	102902	102902	102903
22182	33339	0	applied	\N	\N	\N	\N	102954	102954	102955
22182	33340	1	applied	\N	\N	\N	\N	102956	102956	102957
22182	33341	2	applied	\N	\N	\N	\N	102958	102958	102959
22182	33342	3	applied	\N	\N	\N	\N	102960	102960	102961
22182	33343	4	applied	\N	\N	\N	\N	102962	102962	102963
22182	33344	5	applied	\N	\N	\N	\N	102964	102964	102965
22187	33355	0	applied	\N	\N	\N	\N	103010	103010	103011
22187	33356	1	applied	\N	\N	\N	\N	103012	103012	103013
22187	33357	2	applied	\N	\N	\N	\N	103014	103014	103015
22187	33358	3	applied	\N	\N	\N	\N	103016	103016	103017
22187	33359	4	applied	\N	\N	\N	\N	103018	103018	103019
22190	33366	0	applied	\N	\N	\N	\N	103036	103036	103037
22190	33367	1	applied	\N	\N	\N	\N	103038	103038	103039
22190	33368	2	applied	\N	\N	\N	\N	103040	103040	103041
22200	33397	0	applied	\N	\N	\N	\N	103110	103110	103111
22200	33398	1	applied	\N	\N	\N	\N	103154	103154	103155
22200	33399	2	applied	\N	\N	\N	\N	103156	103156	103157
22200	33400	3	applied	\N	\N	\N	\N	103158	103158	103159
22200	33401	4	applied	\N	\N	\N	\N	103160	103160	103161
22200	33402	5	applied	\N	\N	\N	\N	103162	103162	103163
22205	33410	0	applied	\N	\N	\N	\N	103187	103187	103188
22205	33411	1	applied	\N	\N	\N	\N	103189	103189	103190
22205	33412	2	applied	\N	\N	\N	\N	103191	103191	103192
22205	33413	3	applied	\N	\N	1000000000	\N	103193	103193	103194
22214	33437	0	applied	\N	\N	\N	\N	103275	103275	103276
22214	33438	1	applied	\N	\N	\N	\N	103277	103277	103278
22214	33439	2	applied	\N	\N	\N	\N	103279	103279	103280
22214	33440	3	applied	\N	\N	\N	\N	103281	103281	103282
22214	33441	4	applied	\N	\N	\N	\N	103283	103283	103284
22214	33442	5	applied	\N	\N	\N	\N	103285	103285	103286
22214	33443	6	applied	\N	\N	\N	\N	103287	103287	103288
22214	33444	7	applied	\N	\N	\N	\N	103289	103289	103290
22214	33445	8	applied	\N	\N	\N	\N	103291	103291	103292
22217	33449	0	applied	\N	\N	\N	\N	103303	103303	103304
22217	33450	1	applied	\N	\N	\N	\N	103305	103305	103306
22217	33451	2	applied	\N	\N	\N	\N	103307	103307	103308
22217	33452	3	applied	\N	\N	\N	\N	103309	103309	103310
22217	33453	4	applied	\N	\N	\N	\N	103311	103311	103312
22217	33454	5	applied	\N	\N	\N	\N	103313	103313	103314
22217	33455	6	applied	\N	\N	\N	\N	103315	103315	103316
22217	33456	7	applied	\N	\N	\N	\N	103317	103317	103318
22225	33466	0	applied	\N	\N	\N	\N	103342	103342	103343
22225	33468	1	applied	\N	\N	\N	\N	103348	103348	103349
22225	33467	2	applied	\N	\N	\N	\N	103344	103344	103350
22228	33469	0	applied	\N	\N	\N	\N	103356	103356	103357
22228	33468	1	applied	\N	\N	\N	\N	103348	103348	103350
22228	33470	2	applied	\N	\N	\N	\N	103358	103358	103359
22228	33471	3	applied	\N	\N	\N	\N	103360	103360	103361
22228	33472	4	applied	\N	\N	\N	\N	103362	103362	103363
22231	33462	0	applied	\N	\N	\N	\N	103333	103333	102178
22231	33403	1	applied	\N	\N	\N	\N	103168	103168	103169
22231	33406	2	applied	\N	\N	\N	\N	103176	103176	103177
22231	33410	3	applied	\N	\N	\N	\N	103187	103187	103188
22231	33414	4	applied	\N	\N	\N	\N	103197	103197	103198
22231	33417	5	applied	\N	\N	\N	\N	103204	103204	103205
22231	33421	6	applied	\N	\N	\N	\N	103237	103237	103238
22231	33422	7	applied	\N	\N	\N	\N	103239	103239	103240
22231	33423	8	applied	\N	\N	\N	\N	103241	103241	103242
22231	33431	9	applied	\N	\N	\N	\N	103261	103261	103262
22231	33432	10	applied	\N	\N	\N	\N	103263	103263	103264
22231	33437	11	applied	\N	\N	\N	\N	103275	103275	103276
22231	33438	12	applied	\N	\N	\N	\N	103277	103277	103278
22231	33439	13	applied	\N	\N	\N	\N	103279	103279	103280
22231	33446	14	applied	\N	\N	\N	\N	103297	103297	103298
22231	33449	15	applied	\N	\N	\N	\N	103303	103303	103304
22231	33463	16	applied	\N	\N	\N	\N	103334	103334	103335
22231	33466	17	applied	\N	\N	\N	\N	103342	103342	103343
22231	33404	18	applied	\N	\N	\N	\N	103170	103170	103171
22231	33407	19	applied	\N	\N	\N	\N	103178	103178	103369
22231	33412	20	applied	\N	\N	\N	\N	103191	103191	103370
22231	33415	21	applied	\N	\N	\N	\N	103199	103199	103371
22231	33418	22	applied	\N	\N	\N	\N	103206	103206	103181
22231	33425	23	applied	\N	\N	\N	\N	103245	103245	103372
22231	33426	24	applied	\N	\N	\N	\N	103247	103247	103190
22231	33409	25	applied	\N	\N	\N	\N	103182	103182	103373
22231	33420	26	applied	\N	\N	\N	\N	103210	103210	103192
22231	33427	27	applied	\N	\N	\N	\N	103249	103249	103374
22231	33430	28	applied	\N	\N	\N	\N	103255	103255	103375
22231	33435	29	applied	\N	\N	\N	\N	103269	103269	103202
22231	33436	30	applied	\N	\N	\N	\N	103271	103271	103207
22231	33442	31	applied	\N	\N	\N	\N	103285	103285	103376
22231	33443	32	applied	\N	\N	\N	\N	103287	103287	103211
22231	33444	33	applied	\N	\N	\N	\N	103289	103289	103377
22231	33448	34	applied	\N	\N	\N	\N	103301	103301	103378
22231	33453	35	applied	\N	\N	\N	\N	103311	103311	103379
22231	33445	36	applied	\N	\N	\N	\N	103291	103291	103248
22231	33451	37	applied	\N	\N	\N	\N	103307	103307	103250
22231	33458	38	applied	\N	\N	\N	\N	103323	103323	103380
22231	33470	39	applied	\N	\N	\N	\N	103358	103358	103381
22231	33455	40	applied	\N	\N	\N	\N	103315	103315	103382
22231	33456	41	applied	\N	\N	\N	\N	103317	103317	103254
22231	33459	42	applied	\N	\N	\N	\N	103325	103325	103256
22231	33460	43	applied	\N	\N	\N	\N	103327	103327	103383
22231	33464	44	applied	\N	\N	\N	\N	103336	103336	103384
22231	33468	45	applied	\N	\N	\N	\N	103348	103348	103268
22231	33471	46	applied	\N	\N	\N	\N	103360	103360	103270
22231	33413	48	applied	\N	\N	1000000000	\N	103193	103193	103194
22231	33405	49	applied	\N	\N	\N	\N	103172	103172	103386
22231	33408	50	applied	\N	\N	\N	\N	103180	103180	103387
22231	33411	51	applied	\N	\N	\N	\N	103189	103189	103388
22231	33416	52	applied	\N	\N	\N	\N	103201	103201	103288
22231	33419	53	applied	\N	\N	\N	\N	103208	103208	103292
22231	33424	54	applied	\N	\N	\N	\N	103243	103243	103300
22231	33428	55	applied	\N	\N	\N	\N	103251	103251	103389
22231	33429	56	applied	\N	\N	\N	\N	103253	103253	103308
22231	33433	57	applied	\N	\N	\N	\N	103265	103265	103310
22231	33434	58	applied	\N	\N	\N	\N	103267	103267	103390
22231	33440	59	applied	\N	\N	\N	\N	103281	103281	103391
22231	33441	60	applied	\N	\N	\N	\N	103283	103283	103318
22177	33319	0	applied	\N	\N	\N	\N	102906	102906	102907
22177	33320	1	applied	\N	\N	\N	\N	102908	102908	102909
22177	33321	2	applied	\N	\N	\N	\N	102910	102910	102911
22177	33322	3	applied	\N	\N	\N	\N	102912	102912	102913
22177	33323	4	applied	\N	\N	\N	\N	102914	102914	102915
22177	33324	5	applied	\N	\N	\N	\N	102916	102916	102917
22177	33325	6	applied	\N	\N	\N	\N	102918	102918	102919
22180	33332	0	applied	\N	\N	\N	\N	102937	102937	102938
22180	33333	1	applied	\N	\N	\N	\N	102939	102939	102940
22180	33334	2	applied	\N	\N	\N	\N	102941	102941	102942
22183	33339	0	applied	\N	\N	\N	\N	102954	102954	102955
22183	33340	1	applied	\N	\N	\N	\N	102956	102956	102957
22183	33341	2	applied	\N	\N	\N	\N	102958	102958	102959
22183	33342	3	applied	\N	\N	\N	\N	102960	102960	102961
22183	33343	4	applied	\N	\N	\N	\N	102962	102962	102963
22183	33344	5	applied	\N	\N	\N	\N	102964	102964	102965
22185	33345	0	applied	\N	\N	\N	\N	102985	102985	102986
22185	33346	1	applied	\N	\N	\N	\N	102987	102987	102988
22185	33347	3	applied	\N	\N	\N	\N	102990	102990	102991
22185	33348	4	applied	\N	\N	\N	\N	102992	102992	102993
22185	33349	5	applied	\N	\N	\N	\N	102994	102994	102995
22185	33350	6	applied	\N	\N	\N	\N	102996	102996	102997
22185	33351	7	applied	\N	\N	\N	\N	102998	102998	102999
22188	33360	0	applied	\N	\N	\N	\N	103021	103021	103022
22188	33361	1	applied	\N	\N	\N	\N	103023	103023	103024
22188	33362	2	applied	\N	\N	\N	\N	103025	103025	103026
22193	33373	0	applied	\N	\N	\N	\N	103055	103055	103056
22193	33374	1	applied	\N	\N	\N	\N	103057	103057	103058
22193	33375	2	applied	\N	\N	\N	\N	103059	103059	103060
22193	33376	3	applied	\N	\N	\N	\N	103061	103061	103062
22193	33377	4	applied	\N	\N	\N	\N	103063	103063	103064
22193	33378	5	applied	\N	\N	\N	\N	103065	103065	103066
22193	33379	6	applied	\N	\N	\N	\N	103067	103067	103068
22196	33384	0	applied	\N	\N	\N	\N	103083	103083	103083
22196	33385	1	applied	\N	\N	\N	\N	103084	103084	103085
22196	33386	2	applied	\N	\N	\N	\N	103086	103086	103087
22196	33387	3	applied	\N	\N	\N	\N	103088	103088	96834
22196	33388	4	applied	\N	\N	\N	\N	103089	103089	96834
22196	33389	5	applied	\N	\N	\N	\N	103090	103090	103090
22196	33390	6	applied	\N	\N	\N	\N	103091	103091	103092
22196	33391	7	applied	\N	\N	\N	\N	103093	103093	103094
22196	33392	8	applied	\N	\N	\N	\N	103095	103095	103096
22196	33393	9	applied	\N	\N	\N	\N	103097	103097	103098
22198	33394	0	applied	\N	\N	\N	\N	103101	103101	103102
22198	33395	1	applied	\N	\N	\N	\N	103103	103103	103104
22198	33396	2	applied	\N	\N	\N	\N	103105	103105	103106
22201	33397	0	applied	\N	\N	\N	\N	103110	103110	103111
22201	33398	1	applied	\N	\N	\N	\N	103154	103154	103155
22201	33399	2	applied	\N	\N	\N	\N	103156	103156	103157
22201	33400	3	applied	\N	\N	\N	\N	103158	103158	103159
22201	33401	4	applied	\N	\N	\N	\N	103160	103160	103161
22201	33402	5	applied	\N	\N	\N	\N	103162	103162	103163
22203	33406	0	applied	\N	\N	\N	\N	103176	103176	103177
22203	33407	1	applied	\N	\N	\N	\N	103178	103178	103179
22203	33408	2	applied	\N	\N	\N	\N	103180	103180	103181
22203	33409	3	applied	\N	\N	\N	\N	103182	103182	103183
22208	33398	0	applied	\N	\N	\N	\N	103154	103154	103155
22208	33403	1	applied	\N	\N	\N	\N	103168	103168	103169
22208	33406	2	applied	\N	\N	\N	\N	103176	103176	103177
22208	33410	3	applied	\N	\N	\N	\N	103187	103187	103188
22208	33414	4	applied	\N	\N	\N	\N	103197	103197	103198
22208	33417	5	applied	\N	\N	\N	\N	103204	103204	103205
22208	32982	7	applied	\N	\N	\N	\N	101984	101984	101967
22208	32984	8	applied	\N	\N	\N	\N	101990	101990	103215
22208	32988	9	applied	\N	\N	\N	\N	101998	101998	103216
22208	32991	10	applied	\N	\N	\N	\N	102007	102007	101973
22208	32994	11	applied	\N	\N	\N	\N	102015	102015	103217
22208	32997	12	applied	\N	\N	\N	\N	102025	102025	103218
22208	33409	13	applied	\N	\N	\N	\N	103182	103182	103219
22208	33001	14	applied	\N	\N	\N	\N	102035	102035	103220
22208	33007	15	applied	\N	\N	\N	\N	102053	102053	101979
22208	33008	16	applied	\N	\N	\N	\N	102055	102055	101981
22208	33009	17	applied	\N	\N	\N	\N	102057	102057	101983
22208	33015	18	applied	\N	\N	\N	\N	102070	102070	101985
22208	33017	19	applied	\N	\N	\N	\N	102074	102074	101991
22208	33021	20	applied	\N	\N	\N	\N	102084	102084	103221
22208	33420	21	applied	\N	\N	\N	\N	103210	103210	101993
22208	33413	22	applied	\N	\N	1000000000	\N	103193	103193	103194
22208	33027	23	applied	\N	\N	\N	\N	102100	102100	103222
22208	33028	24	applied	\N	\N	\N	\N	102102	102102	103223
22208	33030	25	applied	\N	\N	\N	\N	102110	102110	102001
22208	33038	26	applied	\N	\N	\N	\N	102130	102130	102008
22208	33043	27	applied	\N	\N	\N	\N	102148	102148	102181
22208	33044	28	applied	\N	\N	\N	\N	102150	102150	103224
22208	33046	29	applied	\N	\N	\N	\N	102155	102155	103225
22208	33049	30	applied	\N	\N	\N	\N	102164	102164	102018
22208	33052	31	applied	\N	\N	\N	\N	102171	102171	102026
22208	33057	32	applied	\N	\N	\N	\N	102199	102199	102182
22208	33061	33	applied	\N	\N	\N	\N	102224	102224	102030
22208	33063	34	applied	\N	\N	\N	\N	102236	102236	102036
22208	33067	35	applied	\N	\N	\N	\N	102249	102249	103226
22208	33076	36	applied	\N	\N	\N	\N	102268	102268	102052
22208	33077	37	applied	\N	\N	\N	\N	102271	102271	102054
22208	33078	38	applied	\N	\N	\N	\N	102273	102273	102056
22208	33079	39	applied	\N	\N	\N	\N	102275	102275	102058
22208	33082	40	applied	\N	\N	\N	\N	102284	102284	102190
22208	33085	41	applied	\N	\N	\N	\N	102294	102294	102192
22208	33088	42	applied	\N	\N	\N	\N	102302	102302	102062
22208	33093	43	applied	\N	\N	\N	\N	102314	102314	103227
22208	33099	44	applied	\N	\N	\N	\N	102328	102328	103228
22208	33100	45	applied	\N	\N	\N	\N	102330	102330	102069
22208	33102	46	applied	\N	\N	\N	\N	102339	102339	102071
22208	33105	47	applied	\N	\N	\N	\N	102345	102345	102075
22208	33114	48	applied	\N	\N	\N	\N	102363	102363	103229
22208	33115	49	applied	\N	\N	\N	\N	102365	102365	103230
22208	33116	50	applied	\N	\N	\N	\N	102367	102367	102083
22208	33119	51	applied	\N	\N	\N	\N	102375	102375	102085
22208	33120	52	applied	\N	\N	\N	\N	102377	102377	103231
22208	33127	53	applied	\N	\N	\N	\N	102393	102393	102097
22208	33131	54	applied	\N	\N	\N	\N	102405	102405	102201
22208	33132	55	applied	\N	\N	\N	\N	102407	102407	103232
22208	33137	56	applied	\N	\N	\N	\N	102419	102419	103233
22208	33143	57	applied	\N	\N	\N	\N	102436	102436	102202
22208	33144	58	applied	\N	\N	\N	\N	102457	102457	103234
22208	33151	59	applied	\N	\N	\N	\N	102476	102476	102113
22208	33157	60	applied	\N	\N	\N	\N	102489	102489	102204
22211	33431	0	applied	\N	\N	\N	\N	103261	103261	103262
22211	33432	1	applied	\N	\N	\N	\N	103263	103263	103264
22211	33433	2	applied	\N	\N	\N	\N	103265	103265	103266
22211	33434	3	applied	\N	\N	\N	\N	103267	103267	103268
22184	32923	12	applied	\N	\N	\N	\N	101820	101820	101821
22184	32924	13	applied	\N	\N	\N	\N	101822	101822	101823
22184	32925	14	applied	\N	\N	\N	\N	101824	101824	101825
22184	32894	15	applied	\N	\N	\N	\N	101733	101733	101734
22184	33125	16	applied	\N	\N	\N	\N	102389	102389	102390
22184	33129	17	applied	\N	\N	\N	\N	102401	102401	102402
22184	33140	18	applied	\N	\N	\N	\N	102430	102430	102431
22184	33148	19	applied	\N	\N	\N	\N	102470	102470	102471
22184	33163	20	applied	\N	\N	\N	\N	102503	102503	102504
22184	33170	21	applied	\N	\N	1000000000	\N	102519	102519	102520
22184	32897	22	applied	\N	\N	\N	\N	101744	101744	101745
22184	32900	23	applied	\N	\N	\N	\N	101755	101755	101756
22184	32903	24	applied	\N	\N	\N	\N	101761	101761	101762
22184	32906	25	applied	\N	\N	\N	\N	101769	101769	101770
22184	32909	26	applied	\N	\N	\N	\N	101784	101784	101785
22184	32912	27	applied	\N	\N	\N	\N	101792	101792	101793
22184	32915	28	applied	\N	\N	\N	\N	101801	101801	101802
22184	32918	29	applied	\N	\N	\N	\N	101807	101807	101808
22184	32921	30	applied	\N	\N	\N	\N	101815	101815	101816
22184	32930	31	applied	\N	\N	\N	\N	101836	101836	101837
22184	33035	32	applied	\N	\N	\N	\N	102980	102980	102125
22184	33036	33	applied	\N	\N	\N	\N	102981	102981	102127
22184	33054	34	applied	\N	\N	\N	\N	102982	102982	102178
22184	32926	35	applied	\N	\N	\N	\N	101826	101826	101827
22184	32931	36	applied	\N	\N	\N	\N	101838	101838	101839
22184	32932	37	applied	\N	\N	\N	\N	101840	101840	101841
22184	32937	38	applied	\N	\N	\N	\N	101852	101852	101853
22184	32940	39	applied	\N	\N	\N	\N	101861	101861	101862
22184	32944	40	applied	\N	\N	\N	\N	101897	101897	101898
22184	32945	41	applied	\N	\N	\N	\N	101899	101899	101900
22184	32946	42	applied	\N	\N	\N	\N	101901	101901	101902
22184	32953	43	applied	\N	\N	\N	\N	101917	101917	101918
22184	32957	44	applied	\N	\N	\N	\N	101926	101926	101927
22184	32959	45	applied	\N	\N	\N	\N	101930	101930	101931
22184	32963	46	applied	\N	\N	\N	\N	101940	101940	101941
22184	32967	47	applied	\N	\N	\N	\N	101952	101952	101953
22184	32969	48	applied	\N	\N	\N	\N	101958	101958	101959
22184	32970	49	applied	\N	\N	\N	\N	101960	101960	101961
22184	32971	50	applied	\N	\N	\N	\N	101962	101962	101963
22184	32972	51	applied	\N	\N	\N	\N	101964	101964	101965
22184	32983	52	applied	\N	\N	\N	\N	101988	101988	101989
22184	32986	53	applied	\N	\N	\N	\N	101994	101994	101995
22184	32990	54	applied	\N	\N	\N	\N	102005	102005	102006
22184	32993	55	applied	\N	\N	\N	\N	102013	102013	102014
22184	32996	56	applied	\N	\N	\N	\N	102023	102023	102024
22184	33000	57	applied	\N	\N	\N	\N	102033	102033	102034
22184	33003	58	applied	\N	\N	\N	\N	102045	102045	102046
22184	33004	59	applied	\N	\N	\N	\N	102047	102047	102048
22184	33005	60	applied	\N	\N	\N	\N	102049	102049	102050
22184	33013	61	applied	\N	\N	\N	\N	102066	102066	102067
22184	33016	62	applied	\N	\N	\N	\N	102072	102072	102073
22184	33019	63	applied	\N	\N	\N	\N	102080	102080	102081
22184	33023	64	applied	\N	\N	\N	\N	102092	102092	102093
22184	33024	65	applied	\N	\N	\N	\N	102094	102094	102095
22184	33029	66	applied	\N	\N	\N	\N	102108	102108	102109
22184	33034	67	applied	\N	\N	\N	\N	102122	102122	102123
22184	33039	68	applied	\N	\N	\N	\N	102140	102140	102141
22184	33040	69	applied	\N	\N	\N	\N	102142	102142	102143
22184	33045	70	applied	\N	\N	\N	\N	102153	102153	102154
22184	33048	71	applied	\N	\N	\N	\N	102162	102162	102163
22184	33051	72	applied	\N	\N	\N	\N	102169	102169	102170
22184	33055	73	applied	\N	\N	\N	\N	102179	102179	102180
22184	33059	74	applied	\N	\N	\N	\N	102215	102215	102216
22184	33062	75	applied	\N	\N	\N	\N	102234	102234	102235
22184	33065	76	applied	\N	\N	\N	\N	102243	102243	102244
22184	33069	77	applied	\N	\N	\N	\N	102254	102254	102255
22184	33070	78	applied	\N	\N	\N	\N	102256	102256	102257
22184	33071	79	applied	\N	\N	\N	\N	102258	102258	102259
22184	33081	80	applied	\N	\N	\N	\N	102282	102282	102283
22184	33084	81	applied	\N	\N	\N	\N	102292	102292	102293
22184	33087	82	applied	\N	\N	\N	\N	102300	102300	102301
22184	33091	83	applied	\N	\N	\N	\N	102310	102310	102311
22184	33094	84	applied	\N	\N	\N	\N	102318	102318	102319
22184	33095	85	applied	\N	\N	\N	\N	102320	102320	102321
22184	33101	86	applied	\N	\N	\N	\N	102337	102337	102338
22184	33104	87	applied	\N	\N	\N	\N	102343	102343	102344
22184	33107	88	applied	\N	\N	\N	\N	102349	102349	102350
22184	33108	89	applied	\N	\N	\N	\N	102351	102351	102352
22184	33109	90	applied	\N	\N	\N	\N	102353	102353	102354
22184	33117	91	applied	\N	\N	\N	\N	102371	102371	102372
22184	33118	92	applied	\N	\N	\N	\N	102373	102373	102374
22184	33124	93	applied	\N	\N	\N	\N	102387	102387	102388
22184	33128	94	applied	\N	\N	\N	\N	102399	102399	102400
22184	33130	95	applied	\N	\N	\N	\N	102403	102403	102404
22184	33136	96	applied	\N	\N	\N	\N	102417	102417	102418
22184	33141	97	applied	\N	\N	\N	\N	102432	102432	102433
22184	33147	98	applied	\N	\N	\N	\N	102465	102465	102466
22184	33149	99	applied	\N	\N	\N	\N	102472	102472	102473
22184	33152	100	applied	\N	\N	\N	\N	102479	102479	102480
22184	33153	101	applied	\N	\N	\N	\N	102481	102481	102482
22184	33154	102	applied	\N	\N	\N	\N	102483	102483	102484
22184	33162	103	applied	\N	\N	\N	\N	102501	102501	102502
22184	33164	104	applied	\N	\N	\N	\N	102505	102505	102506
22184	33169	105	applied	\N	\N	\N	\N	102517	102517	102518
22184	33174	106	applied	\N	\N	\N	\N	102529	102529	102530
22184	33177	107	applied	\N	\N	\N	\N	102537	102537	102538
22184	33180	108	applied	\N	\N	\N	\N	102549	102549	102550
22184	33184	109	applied	\N	\N	\N	\N	102559	102559	102560
22184	33187	110	applied	\N	\N	\N	\N	102565	102565	102566
22184	33190	111	applied	\N	\N	\N	\N	102573	102573	102574
22184	33191	112	applied	\N	\N	\N	\N	102575	102575	102576
22184	33197	113	applied	\N	\N	\N	\N	102589	102589	102590
22184	33198	114	applied	\N	\N	\N	\N	102591	102591	102592
22184	33203	115	applied	\N	\N	\N	\N	102606	102606	102607
22184	33207	116	applied	\N	\N	\N	\N	102616	102616	102617
22184	33208	117	applied	\N	\N	\N	\N	102618	102618	102619
22184	33209	118	applied	\N	\N	\N	\N	102620	102620	102621
22184	33217	119	applied	\N	\N	\N	\N	102638	102638	102639
22184	33218	120	applied	\N	\N	\N	\N	102640	102640	102641
22184	33223	121	applied	\N	\N	\N	\N	102652	102652	102653
22184	33226	122	applied	\N	\N	\N	\N	102659	102659	102660
22184	33227	123	applied	\N	\N	\N	\N	102661	102661	102662
22184	33228	124	applied	\N	\N	\N	\N	102663	102663	102664
22184	33237	125	applied	\N	\N	\N	\N	102692	102692	102693
22189	33363	0	applied	\N	\N	\N	\N	103028	103028	103029
22189	33364	1	applied	\N	\N	\N	\N	103030	103030	103031
22189	33365	2	applied	\N	\N	\N	\N	103032	103032	103033
22192	33369	0	applied	\N	\N	\N	\N	103044	103044	103045
22192	33370	1	applied	\N	\N	\N	\N	103046	103046	103047
22192	33371	2	applied	\N	\N	\N	\N	103048	103048	103049
22192	33372	3	applied	\N	\N	\N	\N	103050	103050	103051
22195	33380	0	applied	\N	\N	\N	\N	103071	103071	103072
22195	33381	1	applied	\N	\N	\N	\N	103073	103073	103074
22195	33382	2	applied	\N	\N	\N	\N	103075	103075	103076
22195	33383	3	applied	\N	\N	\N	\N	103077	103077	103078
22202	33403	0	applied	\N	\N	\N	\N	103168	103168	103169
22202	33404	1	applied	\N	\N	\N	\N	103170	103170	103171
22202	33405	2	applied	\N	\N	\N	\N	103172	103172	103173
22207	33417	0	applied	\N	\N	\N	\N	103204	103204	103205
22207	33418	1	applied	\N	\N	\N	\N	103206	103206	103207
22207	33419	2	applied	\N	\N	\N	\N	103208	103208	103209
22207	33420	3	applied	\N	\N	\N	\N	103210	103210	103211
22210	33421	0	applied	\N	\N	\N	\N	103237	103237	103238
22210	33422	1	applied	\N	\N	\N	\N	103239	103239	103240
22210	33423	2	applied	\N	\N	\N	\N	103241	103241	103242
22210	33424	3	applied	\N	\N	\N	\N	103243	103243	103244
22210	33425	4	applied	\N	\N	\N	\N	103245	103245	103246
22210	33426	5	applied	\N	\N	\N	\N	103247	103247	103248
22210	33427	6	applied	\N	\N	\N	\N	103249	103249	103250
22210	33428	7	applied	\N	\N	\N	\N	103251	103251	103252
22210	33429	8	applied	\N	\N	\N	\N	103253	103253	103254
22210	33430	9	applied	\N	\N	\N	\N	103255	103255	103256
22221	33457	0	applied	\N	\N	\N	\N	103321	103321	103322
22221	33458	1	applied	\N	\N	\N	\N	103323	103323	103324
22221	33459	2	applied	\N	\N	\N	\N	103325	103325	103326
22221	33460	3	applied	\N	\N	\N	\N	103327	103327	103328
22221	33461	4	applied	\N	\N	\N	\N	103329	103329	103330
22224	33466	0	applied	\N	\N	\N	\N	103342	103342	103343
22224	33468	1	applied	\N	\N	\N	\N	103348	103348	103349
22224	33467	2	applied	\N	\N	\N	\N	103344	103344	103350
22227	33466	0	applied	\N	\N	\N	\N	103342	103342	103343
22227	33468	1	applied	\N	\N	\N	\N	103348	103348	103349
22227	33467	2	applied	\N	\N	\N	\N	103344	103344	103350
22235	33485	0	applied	\N	\N	\N	\N	103424	103424	103425
22235	33486	1	applied	\N	\N	\N	\N	103426	103426	103427
22235	33487	2	applied	\N	\N	\N	\N	103428	103428	103429
22235	33488	3	applied	\N	\N	\N	\N	103430	103430	103431
22235	33489	4	applied	\N	\N	\N	\N	103432	103432	103433
22235	33490	5	applied	\N	\N	\N	\N	103434	103434	103435
22235	33491	6	applied	\N	\N	\N	\N	103436	103436	103437
22235	33492	7	applied	\N	\N	\N	\N	103438	103438	103439
22237	33485	0	applied	\N	\N	\N	\N	103424	103424	103425
22237	33486	1	applied	\N	\N	\N	\N	103426	103426	103427
22237	33487	2	applied	\N	\N	\N	\N	103428	103428	103429
22237	33488	3	applied	\N	\N	\N	\N	103430	103430	103431
22237	33489	4	applied	\N	\N	\N	\N	103432	103432	103433
22237	33490	5	applied	\N	\N	\N	\N	103434	103434	103435
22237	33491	6	applied	\N	\N	\N	\N	103436	103436	103437
22237	33492	7	applied	\N	\N	\N	\N	103438	103438	103439
22240	33496	0	applied	\N	\N	\N	\N	103453	103453	103454
22240	33497	1	applied	\N	\N	\N	\N	103455	103455	103456
22240	33498	2	applied	\N	\N	\N	\N	103457	103457	103458
22240	33499	3	applied	\N	\N	\N	\N	103459	103459	103460
22240	33500	4	applied	\N	\N	\N	\N	103461	103461	103462
22240	33501	5	applied	\N	\N	\N	\N	103463	103463	103464
22240	33502	6	applied	\N	\N	\N	\N	103465	103465	103466
22242	33496	0	applied	\N	\N	\N	\N	103479	103479	103454
22242	33498	1	applied	\N	\N	\N	\N	103480	103480	103458
22242	33499	2	applied	\N	\N	\N	\N	103481	103481	103460
22242	33500	3	applied	\N	\N	\N	\N	103482	103482	103462
22244	33506	0	applied	\N	\N	\N	\N	103485	103485	103486
22244	33507	1	applied	\N	\N	\N	\N	103487	103487	103488
22244	33508	2	applied	\N	\N	\N	\N	103489	103489	103490
22244	33509	3	applied	\N	\N	\N	\N	103491	103491	103492
22244	33510	4	applied	\N	\N	\N	\N	103493	103493	103494
22244	33511	5	applied	\N	\N	\N	\N	103495	103495	103496
22244	33512	6	applied	\N	\N	\N	\N	103497	103497	103498
22244	33513	7	applied	\N	\N	\N	\N	103499	103499	103500
22246	33496	0	applied	\N	\N	\N	\N	103479	103479	103454
22246	33506	1	applied	\N	\N	\N	\N	103485	103485	103486
22246	33507	2	applied	\N	\N	\N	\N	103487	103487	103488
22246	33508	3	applied	\N	\N	\N	\N	103489	103489	103490
22246	33498	4	applied	\N	\N	\N	\N	103480	103480	103458
22246	33510	5	applied	\N	\N	\N	\N	103493	103493	103494
22246	33511	6	applied	\N	\N	\N	\N	103495	103495	103496
22246	33499	7	applied	\N	\N	\N	\N	103481	103481	103460
22246	33500	8	applied	\N	\N	\N	\N	103482	103482	103462
22253	33524	0	applied	\N	\N	\N	\N	103530	103530	103531
22253	33525	1	applied	\N	\N	\N	\N	103532	103532	103533
22253	33526	2	applied	\N	\N	\N	\N	103534	103534	103535
22253	33527	3	applied	\N	\N	\N	\N	103536	103536	103537
22253	33528	4	applied	\N	\N	\N	\N	103538	103538	103539
22253	33529	5	applied	\N	\N	\N	\N	103540	103540	103541
22253	33530	6	applied	\N	\N	\N	\N	103542	103542	103543
22256	33534	0	applied	\N	\N	\N	\N	103555	103555	103556
22256	33535	1	applied	\N	\N	\N	\N	103557	103557	103558
22256	33536	2	applied	\N	\N	\N	\N	103559	103559	103560
22258	33537	0	applied	\N	\N	\N	\N	103564	103564	103565
22258	33538	1	applied	\N	\N	\N	\N	103566	103566	103567
22258	33539	2	applied	\N	\N	\N	\N	103568	103568	103569
22258	33540	3	applied	\N	\N	\N	\N	103570	103570	103571
22260	33541	0	applied	\N	\N	\N	\N	103575	103575	103576
22260	33542	1	applied	\N	\N	\N	\N	103577	103577	103578
22260	33543	2	applied	\N	\N	\N	\N	103579	103579	103580
22263	33544	0	applied	\N	\N	\N	\N	103584	103584	103585
22263	33545	1	applied	\N	\N	\N	\N	103586	103586	103587
22263	33546	2	applied	\N	\N	\N	\N	103588	103588	103589
22266	33552	0	applied	\N	\N	\N	\N	103604	103604	103605
22266	33553	1	applied	\N	\N	\N	\N	103606	103606	103607
22266	33554	2	applied	\N	\N	\N	\N	103608	103608	103609
22266	33555	3	applied	\N	\N	\N	\N	103610	103610	103611
22266	33556	4	applied	\N	\N	\N	\N	103612	103612	103613
22266	33557	5	applied	\N	\N	\N	\N	103614	103614	103615
22266	33558	6	applied	\N	\N	\N	\N	103616	103616	103617
22266	33559	7	applied	\N	\N	\N	\N	103618	103618	103619
22266	33560	8	applied	\N	\N	\N	\N	103620	103620	103621
22266	33561	9	applied	\N	\N	\N	\N	103622	103622	103623
22266	33562	10	applied	\N	\N	\N	\N	103624	103624	103625
22268	33566	0	applied	\N	\N	\N	\N	103638	103638	103639
22268	33567	1	applied	\N	\N	\N	\N	103640	103640	103641
22268	33568	2	applied	\N	\N	\N	\N	103642	103642	103643
22274	33588	0	applied	\N	\N	\N	\N	103690	103690	103691
22274	33589	1	applied	\N	\N	\N	\N	103692	103692	103693
22274	33590	2	applied	\N	\N	\N	\N	103694	103694	103695
22276	33597	0	applied	\N	\N	\N	\N	103712	103712	103713
22276	33598	1	applied	\N	\N	\N	\N	103714	103714	103715
22276	33599	2	applied	\N	\N	\N	\N	103716	103716	103717
22281	33603	0	applied	\N	\N	\N	\N	103726	103726	103727
22281	33604	1	applied	\N	\N	\N	\N	103728	103728	103729
22285	33610	0	applied	\N	\N	\N	\N	103764	103764	103765
22199	33022	61	applied	\N	\N	\N	\N	102086	102086	101764
22199	33377	62	applied	\N	\N	\N	\N	103063	103063	103064
22199	33384	63	applied	\N	\N	\N	\N	103083	103083	103083
22199	32905	64	applied	\N	\N	\N	\N	101766	101766	101768
22199	32908	65	applied	\N	\N	\N	\N	101774	101774	103118
22199	33032	66	applied	\N	\N	\N	\N	102114	102114	101773
22199	33042	67	applied	\N	\N	\N	\N	102146	102146	103119
22199	33273	68	applied	\N	\N	1000000000	\N	102784	102784	102785
22199	33056	69	applied	\N	\N	\N	\N	102191	102191	101775
22199	33066	70	applied	\N	\N	\N	\N	102245	102245	103120
22199	33080	71	applied	\N	\N	\N	\N	102278	102278	103121
22199	32899	72	applied	\N	\N	\N	\N	101748	101748	101789
22199	32901	73	applied	\N	\N	\N	\N	101757	101757	101795
22199	32904	74	applied	\N	\N	\N	\N	101763	101763	103122
22199	32907	75	applied	\N	\N	\N	\N	101771	101771	103123
22199	32910	76	applied	\N	\N	\N	\N	101786	101786	103124
22199	32913	77	applied	\N	\N	\N	\N	101794	101794	101812
22199	32911	78	applied	\N	\N	\N	\N	101788	101788	103125
22199	32914	79	applied	\N	\N	\N	\N	101796	101796	101829
22199	32916	80	applied	\N	\N	\N	\N	101803	101803	103126
22199	33090	81	applied	\N	\N	\N	\N	102306	102306	101831
22199	33097	82	applied	\N	\N	\N	\N	102324	102324	103127
22199	33111	83	applied	\N	\N	\N	\N	102357	102357	103128
22199	33121	84	applied	\N	\N	\N	\N	102379	102379	101833
22199	33135	85	applied	\N	\N	\N	\N	102413	102413	103129
22199	33146	86	applied	\N	\N	\N	\N	102461	102461	101843
22199	33155	87	applied	\N	\N	\N	\N	102485	102485	103130
22199	33173	88	applied	\N	\N	\N	\N	102525	102525	101845
22199	33182	89	applied	\N	\N	\N	\N	102553	102553	103131
22199	33192	90	applied	\N	\N	\N	\N	102577	102577	101847
22199	33206	91	applied	\N	\N	\N	\N	102612	102612	103132
22199	33210	92	applied	\N	\N	\N	\N	102622	102622	101849
22199	33229	93	applied	\N	\N	\N	\N	102665	102665	103133
22199	33239	94	applied	\N	\N	\N	\N	102696	102696	101858
22199	33246	95	applied	\N	\N	\N	\N	102712	102712	101855
22199	33261	96	applied	\N	\N	\N	\N	102749	102749	103134
22199	33271	97	applied	\N	\N	\N	\N	102780	102780	101859
22199	33284	98	applied	\N	\N	\N	\N	102819	102819	101864
22199	33305	99	applied	\N	\N	\N	\N	102868	102868	103135
22199	33313	100	applied	\N	\N	\N	\N	102888	102888	103136
22199	33324	101	applied	\N	\N	\N	\N	102916	102916	101866
22199	33338	102	applied	\N	\N	\N	\N	102951	102951	103137
22199	33347	103	applied	\N	\N	\N	\N	102990	102990	101868
22199	33357	104	applied	\N	\N	\N	\N	103014	103014	103138
22199	33372	105	applied	\N	\N	\N	\N	103050	103050	101904
22199	33383	106	applied	\N	\N	\N	\N	103077	103077	103139
22199	33395	107	applied	\N	\N	\N	\N	103103	103103	103140
22199	32920	108	applied	\N	\N	\N	\N	101811	101811	103141
22199	32933	109	applied	\N	\N	\N	\N	101842	101842	103142
22199	32934	110	applied	\N	\N	\N	\N	101844	101844	103143
22199	32935	111	applied	\N	\N	\N	\N	101846	101846	101912
22199	32936	112	applied	\N	\N	\N	\N	101848	101848	103144
22199	32939	113	applied	\N	\N	\N	\N	101857	101857	103145
22199	32943	114	applied	\N	\N	\N	\N	101867	101867	103146
22199	32947	115	applied	\N	\N	\N	\N	101903	101903	101922
22199	32949	116	applied	\N	\N	\N	\N	101907	101907	103147
22199	32950	117	applied	\N	\N	\N	\N	101909	101909	101929
22199	32954	118	applied	\N	\N	\N	\N	101919	101919	101933
22199	32960	119	applied	\N	\N	\N	\N	101932	101932	101935
22199	32961	120	applied	\N	\N	\N	\N	101934	101934	103148
22199	32966	121	applied	\N	\N	\N	\N	101946	101946	101943
22199	32973	122	applied	\N	\N	\N	\N	101966	101966	103149
22199	32975	123	applied	\N	\N	\N	\N	101970	101970	103150
22199	32980	124	applied	\N	\N	\N	\N	101980	101980	103151
22199	32981	125	applied	\N	\N	\N	\N	101982	101982	101955
22204	33406	0	applied	\N	\N	\N	\N	103176	103176	103177
22204	33407	1	applied	\N	\N	\N	\N	103178	103178	103179
22204	33408	2	applied	\N	\N	\N	\N	103180	103180	103181
22204	33409	3	applied	\N	\N	\N	\N	103182	103182	103183
22206	33414	0	applied	\N	\N	\N	\N	103197	103197	103198
22206	33415	1	applied	\N	\N	\N	\N	103199	103199	103200
22206	33416	2	applied	\N	\N	\N	\N	103201	103201	103202
22209	33421	0	applied	\N	\N	\N	\N	103237	103237	103238
22209	33422	1	applied	\N	\N	\N	\N	103239	103239	103240
22209	33423	2	applied	\N	\N	\N	\N	103241	103241	103242
22209	33424	3	applied	\N	\N	\N	\N	103243	103243	103244
22209	33425	4	applied	\N	\N	\N	\N	103245	103245	103246
22209	33426	5	applied	\N	\N	\N	\N	103247	103247	103248
22209	33427	6	applied	\N	\N	\N	\N	103249	103249	103250
22209	33428	7	applied	\N	\N	\N	\N	103251	103251	103252
22209	33429	8	applied	\N	\N	\N	\N	103253	103253	103254
22209	33430	9	applied	\N	\N	\N	\N	103255	103255	103256
22213	33437	0	applied	\N	\N	\N	\N	103275	103275	103276
22213	33438	1	applied	\N	\N	\N	\N	103277	103277	103278
22213	33439	2	applied	\N	\N	\N	\N	103279	103279	103280
22213	33440	3	applied	\N	\N	\N	\N	103281	103281	103282
22213	33441	4	applied	\N	\N	\N	\N	103283	103283	103284
22213	33442	5	applied	\N	\N	\N	\N	103285	103285	103286
22213	33443	6	applied	\N	\N	\N	\N	103287	103287	103288
22213	33444	7	applied	\N	\N	\N	\N	103289	103289	103290
22213	33445	8	applied	\N	\N	\N	\N	103291	103291	103292
22215	33446	0	applied	\N	\N	\N	\N	103297	103297	103298
22215	33447	1	applied	\N	\N	\N	\N	103299	103299	103300
22215	33448	2	applied	\N	\N	\N	\N	103301	103301	103302
22223	33466	0	applied	\N	\N	\N	\N	103342	103342	103343
22223	33467	1	applied	\N	\N	\N	\N	103344	103344	103345
22226	33466	0	applied	\N	\N	\N	\N	103342	103342	103343
22226	33467	1	applied	\N	\N	\N	\N	103344	103344	103345
22230	33469	0	applied	\N	\N	\N	\N	103356	103356	103357
22230	33468	1	applied	\N	\N	\N	\N	103348	103348	103350
22230	33470	2	applied	\N	\N	\N	\N	103358	103358	103359
22230	33472	3	applied	\N	\N	\N	\N	103362	103362	103367
22234	33479	0	applied	\N	\N	\N	\N	103411	103411	103412
22234	33480	1	applied	\N	\N	\N	\N	103413	103413	103414
22234	33481	2	applied	\N	\N	\N	\N	103415	103415	103416
22234	33482	3	applied	\N	\N	\N	\N	103417	103417	103418
22234	33483	4	applied	\N	\N	\N	\N	103419	103419	103420
22234	33484	5	applied	\N	\N	\N	\N	103421	103421	47675
22239	33496	0	applied	\N	\N	\N	\N	103453	103453	103454
22239	33497	1	applied	\N	\N	\N	\N	103455	103455	103456
22239	33498	2	applied	\N	\N	\N	\N	103457	103457	103458
22239	33499	3	applied	\N	\N	\N	\N	103459	103459	103460
22239	33500	4	applied	\N	\N	\N	\N	103461	103461	103462
22239	33501	5	applied	\N	\N	\N	\N	103463	103463	103464
22239	33502	6	applied	\N	\N	\N	\N	103465	103465	103466
22241	33503	0	applied	\N	\N	\N	\N	103471	103471	103472
22241	33504	1	applied	\N	\N	\N	\N	103473	103473	103474
22241	33505	2	applied	\N	\N	\N	\N	103475	103475	103476
22243	33496	0	applied	\N	\N	\N	\N	103479	103479	103454
22243	33498	1	applied	\N	\N	\N	\N	103480	103480	103458
22211	33435	4	applied	\N	\N	\N	\N	103269	103269	103270
22211	33436	5	applied	\N	\N	\N	\N	103271	103271	103272
22212	33437	0	applied	\N	\N	\N	\N	103275	103275	103276
22212	33438	1	applied	\N	\N	\N	\N	103277	103277	103278
22212	33439	2	applied	\N	\N	\N	\N	103279	103279	103280
22212	33440	3	applied	\N	\N	\N	\N	103281	103281	103282
22212	33441	4	applied	\N	\N	\N	\N	103283	103283	103284
22212	33442	5	applied	\N	\N	\N	\N	103285	103285	103286
22212	33443	6	applied	\N	\N	\N	\N	103287	103287	103288
22212	33444	7	applied	\N	\N	\N	\N	103289	103289	103290
22212	33445	8	applied	\N	\N	\N	\N	103291	103291	103292
22222	33462	0	applied	\N	\N	\N	\N	103333	103333	102178
22222	33463	1	applied	\N	\N	\N	\N	103334	103334	103335
22222	33464	2	applied	\N	\N	\N	\N	103336	103336	103337
22222	33465	3	applied	\N	\N	\N	\N	103338	103338	103339
22229	33469	0	applied	\N	\N	\N	\N	103356	103356	103357
22229	33468	1	applied	\N	\N	\N	\N	103348	103348	103350
22229	33470	2	applied	\N	\N	\N	\N	103358	103358	103359
22229	33471	3	applied	\N	\N	\N	\N	103360	103360	103361
22229	33472	4	applied	\N	\N	\N	\N	103362	103362	103363
22232	33469	0	applied	\N	\N	\N	\N	103356	103356	103357
22232	33468	1	applied	\N	\N	\N	\N	103348	103348	103350
22232	33470	2	applied	\N	\N	\N	\N	103358	103358	103359
22232	33471	3	applied	\N	\N	\N	\N	103360	103360	103361
22232	33472	4	applied	\N	\N	\N	\N	103362	103362	103363
22233	33473	0	applied	\N	\N	\N	\N	103399	103399	103400
22233	33474	1	applied	\N	\N	\N	\N	103401	103401	103402
22233	33475	2	applied	\N	\N	\N	\N	103403	103403	103404
22233	33476	3	applied	\N	\N	\N	\N	103405	103405	103406
22233	33477	4	applied	\N	\N	\N	\N	103407	103407	103408
22233	33478	5	applied	\N	\N	\N	\N	103409	103409	103410
22238	33493	0	applied	\N	\N	\N	\N	103445	103445	103446
22238	33494	1	applied	\N	\N	\N	\N	103447	103447	103448
22238	33495	2	applied	\N	\N	\N	\N	103449	103449	103450
22245	33496	0	applied	\N	\N	\N	\N	103479	103479	103454
22245	33506	1	applied	\N	\N	\N	\N	103485	103485	103486
22245	33507	2	applied	\N	\N	\N	\N	103487	103487	103488
22245	33508	3	applied	\N	\N	\N	\N	103489	103489	103490
22245	33498	4	applied	\N	\N	\N	\N	103480	103480	103458
22245	33510	5	applied	\N	\N	\N	\N	103493	103493	103494
22245	33511	6	applied	\N	\N	\N	\N	103495	103495	103496
22245	33499	7	applied	\N	\N	\N	\N	103481	103481	103460
22245	33500	8	applied	\N	\N	\N	\N	103482	103482	103462
22247	33514	0	applied	\N	\N	\N	\N	103504	103504	103505
22247	33515	1	applied	\N	\N	\N	\N	103506	103506	103507
22247	33516	2	applied	\N	\N	\N	\N	103508	103508	103509
22247	33517	3	applied	\N	\N	\N	\N	103510	103510	103511
22252	33524	0	applied	\N	\N	\N	\N	103530	103530	103531
22252	33525	1	applied	\N	\N	\N	\N	103532	103532	103533
22252	33526	2	applied	\N	\N	\N	\N	103534	103534	103535
22252	33527	3	applied	\N	\N	\N	\N	103536	103536	103537
22252	33528	4	applied	\N	\N	\N	\N	103538	103538	103539
22252	33529	5	applied	\N	\N	\N	\N	103540	103540	103541
22252	33530	6	applied	\N	\N	\N	\N	103542	103542	103543
22257	33537	0	applied	\N	\N	\N	\N	103564	103564	103565
22257	33538	1	applied	\N	\N	\N	\N	103566	103566	103567
22257	33539	2	applied	\N	\N	\N	\N	103568	103568	103569
22257	33540	3	applied	\N	\N	\N	\N	103570	103570	103571
22259	33537	0	applied	\N	\N	\N	\N	103564	103564	103565
22259	33538	1	applied	\N	\N	\N	\N	103566	103566	103567
22259	33539	2	applied	\N	\N	\N	\N	103568	103568	103569
22259	33540	3	applied	\N	\N	\N	\N	103570	103570	103571
22272	33580	0	applied	\N	\N	\N	\N	103672	103672	103673
22272	33581	1	applied	\N	\N	\N	\N	103674	103674	103675
22272	33582	2	applied	\N	\N	\N	\N	103676	103676	103677
22272	33583	3	applied	\N	\N	\N	\N	103678	103678	103679
22272	33584	4	applied	\N	\N	\N	\N	103680	103680	103681
22272	33585	5	applied	\N	\N	\N	\N	103682	103682	103683
22272	33586	6	applied	\N	\N	\N	\N	103684	103684	103685
22272	33587	7	applied	\N	\N	\N	\N	103686	103686	103687
22275	33591	0	applied	\N	\N	\N	\N	103698	103698	103699
22275	33592	1	applied	\N	\N	\N	\N	103700	103700	103701
22275	33593	2	applied	\N	\N	\N	\N	103702	103702	103703
22275	33594	3	applied	\N	\N	\N	\N	103704	103704	103705
22275	33595	4	applied	\N	\N	\N	\N	103706	103706	103707
22275	33596	5	applied	\N	\N	\N	\N	103708	103708	103709
22282	33605	0	applied	\N	\N	\N	\N	103734	103734	103735
22282	33606	1	applied	\N	\N	\N	\N	103736	103736	103737
22282	33607	2	applied	\N	\N	\N	\N	103738	103738	103739
22282	33608	3	applied	\N	\N	\N	\N	103740	103740	103741
22284	33280	0	applied	\N	\N	\N	\N	102969	102969	102812
22284	33285	1	applied	\N	\N	\N	\N	102970	102970	102827
22284	33286	2	applied	\N	\N	\N	\N	102971	102971	102829
22284	33291	3	applied	\N	\N	\N	\N	102972	102972	102840
22284	33139	4	applied	\N	\N	\N	\N	102429	102429	102429
22284	33292	5	applied	\N	\N	\N	\N	103745	103745	102842
22284	33293	6	applied	\N	\N	\N	\N	103746	103746	102844
22284	33294	7	applied	\N	\N	\N	\N	103747	103747	102846
22284	33295	8	applied	\N	\N	\N	\N	103748	103748	102848
22284	33496	9	applied	\N	\N	\N	\N	103479	103479	103454
22284	33485	10	applied	\N	\N	\N	\N	103424	103424	103425
22284	32515	11	applied	\N	\N	\N	\N	100623	100623	100624
22284	33506	12	applied	\N	\N	\N	\N	103485	103485	103486
22284	33507	13	applied	\N	\N	\N	\N	103487	103487	103488
22284	33033	14	applied	\N	\N	\N	\N	103749	103749	102121
22284	33508	15	applied	\N	\N	\N	\N	103489	103489	103490
22284	33487	16	applied	\N	\N	\N	\N	103428	103428	103429
22284	33188	17	applied	\N	\N	\N	\N	102567	102567	102979
22284	32923	18	applied	\N	\N	\N	\N	101820	101820	101821
22284	32924	19	applied	\N	\N	\N	\N	101822	101822	101823
22284	32925	20	applied	\N	\N	\N	\N	101824	101824	101825
22284	33498	21	applied	\N	\N	\N	\N	103480	103480	103458
22284	33488	22	applied	\N	\N	\N	\N	103430	103430	103431
22284	33125	23	applied	\N	\N	\N	\N	103750	103750	102390
22284	33129	24	applied	\N	\N	\N	\N	103751	103751	102402
22284	33140	25	applied	\N	\N	\N	\N	103752	103752	102431
22284	33148	26	applied	\N	\N	\N	\N	103753	103753	102471
22284	33510	27	applied	\N	\N	\N	\N	103493	103493	103494
22284	33511	28	applied	\N	\N	\N	\N	103495	103495	103496
22284	33499	29	applied	\N	\N	\N	\N	103481	103481	103460
22284	33500	30	applied	\N	\N	\N	\N	103482	103482	103462
22284	33163	31	applied	\N	\N	\N	\N	103754	103754	102504
22284	33170	32	applied	\N	\N	1000000000	\N	103755	103755	102520
22284	32516	33	applied	\N	\N	\N	\N	100625	100625	100626
22284	32521	34	applied	\N	\N	\N	\N	100637	100637	100638
22284	32522	35	applied	\N	\N	\N	\N	100639	100639	100640
22284	32527	36	applied	\N	\N	\N	\N	100650	100650	100651
22284	32528	37	applied	\N	\N	\N	\N	100652	100652	100653
22284	32533	38	applied	\N	\N	\N	\N	100665	100665	100666
22284	32534	39	applied	\N	\N	\N	\N	100667	100667	100668
22231	33447	61	applied	\N	\N	\N	\N	103299	103299	103322
22231	33450	62	applied	\N	\N	\N	\N	103305	103305	103326
22231	33452	63	applied	\N	\N	\N	\N	103309	103309	103392
22231	33454	64	applied	\N	\N	\N	\N	103313	103313	103393
22231	33457	65	applied	\N	\N	\N	\N	103321	103321	103394
22231	33461	66	applied	\N	\N	\N	\N	103329	103329	103349
22231	33465	67	applied	\N	\N	\N	\N	103338	103338	103350
22231	33467	68	applied	\N	\N	\N	\N	103344	103344	103361
22231	33472	69	applied	\N	\N	\N	\N	103362	103362	103363
22236	33485	0	applied	\N	\N	\N	\N	103424	103424	103425
22236	33486	1	applied	\N	\N	\N	\N	103426	103426	103427
22236	33487	2	applied	\N	\N	\N	\N	103428	103428	103429
22236	33488	3	applied	\N	\N	\N	\N	103430	103430	103431
22236	33489	4	applied	\N	\N	\N	\N	103432	103432	103433
22236	33490	5	applied	\N	\N	\N	\N	103434	103434	103435
22236	33491	6	applied	\N	\N	\N	\N	103436	103436	103437
22236	33492	7	applied	\N	\N	\N	\N	103438	103438	103439
22251	33518	0	applied	\N	\N	\N	\N	103516	103516	103517
22251	33519	1	applied	\N	\N	\N	\N	103518	103518	103519
22251	33520	2	applied	\N	\N	\N	\N	103520	103520	103521
22251	33521	3	applied	\N	\N	\N	\N	103522	103522	103523
22251	33522	4	applied	\N	\N	\N	\N	103524	103524	103525
22251	33523	5	applied	\N	\N	\N	\N	103526	103526	103527
22254	33531	0	applied	\N	\N	\N	\N	103547	103547	103548
22254	33532	1	applied	\N	\N	\N	\N	103549	103549	103550
22254	33533	2	applied	\N	\N	\N	\N	103551	103551	103552
22261	33541	0	applied	\N	\N	\N	\N	103575	103575	103576
22261	33542	1	applied	\N	\N	\N	\N	103577	103577	103578
22269	33566	0	applied	\N	\N	\N	\N	103638	103638	103639
22269	33567	1	applied	\N	\N	\N	\N	103640	103640	103641
22269	33568	2	applied	\N	\N	\N	\N	103642	103642	103643
22271	33577	0	applied	\N	\N	\N	\N	103664	103664	103665
22271	33578	1	applied	\N	\N	\N	\N	103666	103666	103667
22271	33579	2	applied	\N	\N	\N	\N	103668	103668	103669
22277	33597	0	applied	\N	\N	\N	\N	103712	103712	103713
22277	33598	1	applied	\N	\N	\N	\N	103714	103714	103715
22277	33599	2	applied	\N	\N	\N	\N	103716	103716	103717
22286	33613	0	applied	\N	\N	\N	\N	103772	103772	103773
22286	33614	1	applied	\N	\N	\N	\N	103774	103774	103775
22286	33615	2	applied	\N	\N	\N	\N	103776	103776	103777
22293	33623	0	applied	\N	\N	\N	\N	103810	103810	103811
22293	33624	1	applied	\N	\N	\N	\N	103812	103812	103813
22293	33625	2	applied	\N	\N	\N	\N	103814	103814	103815
22293	33626	3	applied	\N	\N	\N	\N	103816	103816	103817
22293	33627	4	applied	\N	\N	\N	\N	103818	103818	103819
22293	33628	5	applied	\N	\N	\N	\N	103820	103820	103821
22293	33629	6	applied	\N	\N	\N	\N	103822	103822	103823
22296	33462	0	applied	\N	\N	\N	\N	103333	103333	102178
22296	33496	1	applied	\N	\N	\N	\N	103453	103453	103454
22296	33485	2	applied	\N	\N	\N	\N	103424	103424	103425
22296	33302	3	applied	\N	\N	\N	\N	102862	102862	102863
22296	33506	4	applied	\N	\N	\N	\N	103485	103485	103486
22296	33507	5	applied	\N	\N	\N	\N	103487	103487	103488
22296	33508	6	applied	\N	\N	\N	\N	103489	103489	103490
22296	33487	7	applied	\N	\N	\N	\N	103428	103428	103429
22296	33306	8	applied	\N	\N	\N	\N	102872	102872	102873
22296	33309	9	applied	\N	\N	\N	\N	102880	102880	102881
22296	33310	10	applied	\N	\N	\N	\N	102882	102882	102883
22296	33316	11	applied	\N	\N	\N	\N	102898	102898	102899
22296	33498	12	applied	\N	\N	\N	\N	103457	103457	103458
22296	33488	13	applied	\N	\N	\N	\N	103430	103430	103431
22296	33319	14	applied	\N	\N	\N	\N	102906	102906	102907
22296	33320	15	applied	\N	\N	\N	\N	102908	102908	102909
22296	33326	16	applied	\N	\N	\N	\N	102922	102922	102923
22296	33327	17	applied	\N	\N	\N	\N	102924	102924	102925
22296	33332	18	applied	\N	\N	\N	\N	102937	102937	102938
22296	33335	19	applied	\N	\N	\N	\N	102945	102945	102946
22296	33339	20	applied	\N	\N	\N	\N	102954	102954	102955
22296	33340	21	applied	\N	\N	\N	\N	102956	102956	102957
22296	33345	22	applied	\N	\N	\N	\N	102985	102985	102986
22296	33346	23	applied	\N	\N	\N	\N	102987	102987	102988
22296	33352	24	applied	\N	\N	\N	\N	103002	103002	103003
22296	33510	25	applied	\N	\N	\N	\N	103493	103493	103494
22296	33511	26	applied	\N	\N	\N	\N	103495	103495	103496
22296	33499	27	applied	\N	\N	\N	\N	103459	103459	103460
22296	33500	28	applied	\N	\N	\N	\N	103461	103461	103462
22296	33355	29	applied	\N	\N	\N	\N	103010	103010	103011
22296	33360	30	applied	\N	\N	\N	\N	103021	103021	103022
22296	33363	31	applied	\N	\N	\N	\N	103028	103028	103029
22296	33366	32	applied	\N	\N	\N	\N	103036	103036	103037
22296	33369	33	applied	\N	\N	\N	\N	103044	103044	103045
22296	33373	34	applied	\N	\N	\N	\N	103055	103055	103056
22296	33374	35	applied	\N	\N	\N	\N	103057	103057	103058
22296	33380	36	applied	\N	\N	\N	\N	103071	103071	103072
22296	33385	37	applied	\N	\N	\N	\N	103084	103084	103085
22296	33386	38	applied	\N	\N	\N	\N	103086	103086	103087
22296	33397	39	applied	\N	\N	\N	\N	103110	103110	103111
22296	33398	40	applied	\N	\N	\N	\N	103154	103154	103155
22296	33403	41	applied	\N	\N	\N	\N	103168	103168	103169
22296	33406	42	applied	\N	\N	\N	\N	103176	103176	103177
22296	33410	43	applied	\N	\N	\N	\N	103187	103187	103188
22296	33414	44	applied	\N	\N	\N	\N	103197	103197	103198
22296	33417	45	applied	\N	\N	\N	\N	103204	103204	103205
22296	33421	46	applied	\N	\N	\N	\N	103237	103237	103238
22296	33422	47	applied	\N	\N	\N	\N	103239	103239	103240
22296	33423	48	applied	\N	\N	\N	\N	103241	103241	103242
22296	33431	49	applied	\N	\N	\N	\N	103261	103261	103262
22296	33432	50	applied	\N	\N	\N	\N	103263	103263	103264
22296	33437	51	applied	\N	\N	\N	\N	103275	103275	103276
22296	33438	52	applied	\N	\N	\N	\N	103277	103277	103278
22296	33439	53	applied	\N	\N	\N	\N	103279	103279	103280
22296	33446	54	applied	\N	\N	\N	\N	103297	103297	103298
22296	33449	55	applied	\N	\N	\N	\N	103303	103303	103304
22296	33463	56	applied	\N	\N	\N	\N	103334	103334	103335
22296	33466	57	applied	\N	\N	\N	\N	103342	103342	103343
22296	33469	58	applied	\N	\N	\N	\N	103356	103356	103357
22296	33473	59	applied	\N	\N	\N	\N	103399	103399	103400
22296	33474	60	applied	\N	\N	\N	\N	103401	103401	103402
22296	33479	61	applied	\N	\N	\N	\N	103411	103411	103412
22296	33480	62	applied	\N	\N	\N	\N	103413	103413	103414
22296	33486	64	applied	\N	\N	\N	\N	103426	103426	103427
22296	33493	65	applied	\N	\N	\N	\N	103445	103445	103446
22296	33497	66	applied	\N	\N	\N	\N	103455	103455	103456
22296	33503	67	applied	\N	\N	\N	\N	103471	103471	103472
22296	33509	68	applied	\N	\N	\N	\N	103491	103491	103492
22296	33514	69	applied	\N	\N	\N	\N	103504	103504	103505
22296	33518	70	applied	\N	\N	\N	\N	103516	103516	103517
22296	33519	71	applied	\N	\N	\N	\N	103518	103518	103519
22296	33524	72	applied	\N	\N	\N	\N	103530	103530	103531
22296	33525	73	applied	\N	\N	\N	\N	103532	103532	103533
22243	33499	2	applied	\N	\N	\N	\N	103481	103481	103460
22243	33500	3	applied	\N	\N	\N	\N	103482	103482	103462
22248	33514	0	applied	\N	\N	\N	\N	103504	103504	103505
22248	33515	1	applied	\N	\N	\N	\N	103506	103506	103507
22248	33516	2	applied	\N	\N	\N	\N	103508	103508	103509
22248	33517	3	applied	\N	\N	\N	\N	103510	103510	103511
22250	33518	0	applied	\N	\N	\N	\N	103516	103516	103517
22250	33519	1	applied	\N	\N	\N	\N	103518	103518	103519
22250	33520	2	applied	\N	\N	\N	\N	103520	103520	103521
22250	33521	3	applied	\N	\N	\N	\N	103522	103522	103523
22250	33522	4	applied	\N	\N	\N	\N	103524	103524	103525
22250	33523	5	applied	\N	\N	\N	\N	103526	103526	103527
22255	33534	0	applied	\N	\N	\N	\N	103555	103555	103556
22255	33535	1	applied	\N	\N	\N	\N	103557	103557	103558
22255	33536	2	applied	\N	\N	\N	\N	103559	103559	103560
22262	33544	0	applied	\N	\N	\N	\N	103584	103584	103585
22262	33545	1	applied	\N	\N	\N	\N	103586	103586	103587
22262	33546	2	applied	\N	\N	\N	\N	103588	103588	103589
22264	33547	0	applied	\N	\N	\N	\N	103593	103593	103594
22264	33548	1	applied	\N	\N	\N	\N	103595	103595	103596
22264	33549	2	applied	\N	\N	\N	\N	103597	103597	103598
22264	33550	3	applied	\N	\N	\N	\N	103599	103599	103600
22264	33551	4	applied	\N	\N	\N	\N	103601	103601	103602
22265	33552	0	applied	\N	\N	\N	\N	103604	103604	103605
22265	33553	1	applied	\N	\N	\N	\N	103606	103606	103607
22265	33554	2	applied	\N	\N	\N	\N	103608	103608	103609
22265	33555	3	applied	\N	\N	\N	\N	103610	103610	103611
22265	33556	4	applied	\N	\N	\N	\N	103612	103612	103613
22265	33557	5	applied	\N	\N	\N	\N	103614	103614	103615
22265	33558	6	applied	\N	\N	\N	\N	103616	103616	103617
22265	33559	7	applied	\N	\N	\N	\N	103618	103618	103619
22265	33560	8	applied	\N	\N	\N	\N	103620	103620	103621
22265	33561	9	applied	\N	\N	\N	\N	103622	103622	103623
22265	33562	10	applied	\N	\N	\N	\N	103624	103624	103625
22267	33563	0	applied	\N	\N	\N	\N	103630	103630	103631
22267	33564	1	applied	\N	\N	\N	\N	103632	103632	103633
22267	33565	2	applied	\N	\N	\N	\N	103634	103634	103635
22270	33569	0	applied	\N	\N	\N	\N	103646	103646	103647
22270	33570	1	applied	\N	\N	\N	\N	103648	103648	103649
22270	33571	2	applied	\N	\N	\N	\N	103650	103650	103651
22270	33572	3	applied	\N	\N	\N	\N	103652	103652	103653
22270	33573	4	applied	\N	\N	\N	\N	103654	103654	103655
22270	33574	5	applied	\N	\N	\N	\N	103656	103656	103657
22270	33575	6	applied	\N	\N	\N	\N	103658	103658	103659
22270	33576	7	applied	\N	\N	\N	\N	103660	103660	103661
22273	33588	0	applied	\N	\N	\N	\N	103690	103690	103691
22273	33589	1	applied	\N	\N	\N	\N	103692	103692	103693
22273	33590	2	applied	\N	\N	\N	\N	103694	103694	103695
22278	33600	0	applied	\N	\N	\N	\N	103720	103720	103721
22278	33601	1	applied	\N	\N	\N	\N	103722	103722	103723
22278	33602	2	applied	\N	\N	\N	\N	103724	103724	103725
22280	33603	0	applied	\N	\N	\N	\N	103726	103726	103727
22280	33604	1	applied	\N	\N	\N	\N	103728	103728	103729
22283	33605	0	applied	\N	\N	\N	\N	103734	103734	103735
22283	33606	1	applied	\N	\N	\N	\N	103736	103736	103737
22283	33607	2	applied	\N	\N	\N	\N	103738	103738	103739
22283	33608	3	applied	\N	\N	\N	\N	103740	103740	103741
22288	33613	0	applied	\N	\N	\N	\N	103772	103772	103773
22288	33614	1	applied	\N	\N	\N	\N	103774	103774	103775
22288	33615	2	applied	\N	\N	\N	\N	103776	103776	103777
22290	33616	0	applied	\N	\N	\N	\N	103784	103784	103785
22290	33617	1	applied	\N	\N	\N	\N	103786	103786	103787
22290	33618	2	applied	\N	\N	\N	\N	103788	103788	103789
22290	33619	4	applied	\N	\N	\N	\N	103791	103791	103792
22290	33620	5	applied	\N	\N	\N	\N	103793	103793	103794
22290	33621	6	applied	\N	\N	\N	\N	103795	103795	103796
22290	33622	7	applied	\N	\N	\N	\N	103797	103797	103798
22295	33630	0	applied	\N	\N	\N	\N	103825	103825	103826
22295	33631	1	applied	\N	\N	\N	\N	103827	103827	103828
22295	33634	2	applied	\N	\N	\N	\N	103833	103833	103839
22295	33635	3	applied	\N	\N	\N	\N	103835	103835	103840
22300	33653	0	applied	\N	\N	\N	\N	103893	103893	103894
22300	33654	1	applied	\N	\N	\N	\N	103895	103895	103896
22300	33655	2	applied	\N	\N	\N	\N	103897	103897	103898
22302	33656	0	applied	\N	\N	\N	\N	103901	103901	103902
22302	33657	1	applied	\N	\N	\N	\N	103903	103903	103904
22302	33658	2	applied	\N	\N	\N	\N	103905	103905	103906
22305	33670	0	applied	\N	\N	\N	\N	103932	103932	103933
22305	33671	1	applied	\N	\N	\N	\N	103934	103934	103935
22305	33672	2	applied	\N	\N	\N	\N	103936	103936	103937
22307	33670	0	applied	\N	\N	\N	\N	103932	103932	103933
22307	33671	1	applied	\N	\N	\N	\N	103934	103934	103935
22307	33672	2	applied	\N	\N	\N	\N	103936	103936	103937
22309	33662	0	applied	\N	\N	\N	\N	103915	103915	103916
22309	33569	1	applied	\N	\N	\N	\N	103646	103646	103647
22309	33570	2	applied	\N	\N	\N	\N	103648	103648	103649
22309	33577	3	applied	\N	\N	\N	\N	103664	103664	103665
22309	33580	4	applied	\N	\N	\N	\N	103672	103672	103673
22309	33581	5	applied	\N	\N	\N	\N	103674	103674	103675
22309	33588	6	applied	\N	\N	\N	\N	103690	103690	103691
22309	33591	7	applied	\N	\N	\N	\N	103698	103698	103699
22309	33592	8	applied	\N	\N	\N	\N	103700	103700	103701
22309	33597	9	applied	\N	\N	\N	\N	103712	103712	103713
22309	33600	10	applied	\N	\N	\N	\N	103720	103720	103721
22309	33605	11	applied	\N	\N	\N	\N	103734	103734	103735
22309	33610	12	applied	\N	\N	\N	\N	103764	103764	103765
22309	33613	13	applied	\N	\N	\N	\N	103772	103772	103773
22309	33616	14	applied	\N	\N	\N	\N	103784	103784	103785
22309	33617	15	applied	\N	\N	\N	\N	103786	103786	103787
22309	33623	16	applied	\N	\N	\N	\N	103810	103810	103811
22309	33624	17	applied	\N	\N	\N	\N	103812	103812	103813
22309	33630	18	applied	\N	\N	\N	\N	103825	103825	103826
22309	33631	19	applied	\N	\N	\N	\N	103827	103827	103828
22309	33636	20	applied	\N	\N	\N	\N	103854	103854	103855
22309	33639	21	applied	\N	\N	\N	\N	103864	103864	103945
22309	33640	22	applied	\N	\N	\N	\N	103866	103866	103946
22309	33641	23	applied	\N	\N	\N	\N	103868	103868	103947
22309	33642	24	applied	\N	\N	\N	\N	103870	103870	103948
22309	33653	25	applied	\N	\N	\N	\N	103893	103893	103949
22309	33656	26	applied	\N	\N	\N	\N	103901	103901	103950
22309	33659	27	applied	\N	\N	\N	\N	103909	103909	103951
22309	33660	28	applied	\N	\N	\N	\N	103911	103911	103952
22309	33661	29	applied	\N	\N	\N	\N	103913	103913	103953
22309	33670	30	applied	\N	\N	\N	\N	103932	103932	103954
22309	33571	31	applied	\N	\N	\N	\N	103650	103650	103651
22309	33572	32	applied	\N	\N	\N	\N	103652	103652	103653
22309	33573	33	applied	\N	\N	\N	\N	103654	103654	103655
22309	33574	34	applied	\N	\N	\N	\N	103656	103656	103657
22309	33578	35	applied	\N	\N	\N	\N	103666	103666	103955
22309	33582	36	applied	\N	\N	\N	\N	103676	103676	103956
22284	32535	40	applied	\N	\N	\N	\N	100669	100669	100670
22284	32536	41	applied	\N	\N	\N	\N	100671	100671	100672
22284	33035	42	applied	\N	\N	\N	\N	103756	103756	102125
22284	33036	43	applied	\N	\N	\N	\N	103757	103757	102127
22284	33054	44	applied	\N	\N	\N	\N	103758	103758	102178
22284	32545	46	applied	\N	\N	\N	\N	100692	100692	100693
22284	32546	47	applied	\N	\N	\N	\N	100694	100694	100695
22284	32551	48	applied	\N	\N	\N	\N	100705	100705	100706
22284	32552	49	applied	\N	\N	\N	\N	100707	100707	100708
22284	32559	50	applied	\N	\N	\N	\N	100727	100727	100728
22284	32560	51	applied	\N	\N	\N	\N	100729	100729	100730
22284	32563	52	applied	\N	\N	\N	\N	100739	100739	100740
22284	32564	53	applied	\N	\N	\N	\N	100741	100741	100742
22284	32565	54	applied	\N	\N	\N	\N	100743	100743	100744
22284	32572	55	applied	\N	\N	\N	\N	100758	100758	100759
22284	32574	56	applied	\N	\N	\N	\N	100765	100765	100766
22284	32575	57	applied	\N	\N	\N	\N	100767	100767	100768
22284	32580	58	applied	\N	\N	\N	\N	100779	100779	100780
22284	32926	59	applied	\N	\N	\N	\N	101826	101826	101827
22284	33609	60	applied	\N	\N	\N	\N	103760	103760	103761
22284	32583	61	applied	\N	\N	\N	\N	100792	100792	100793
22284	32586	62	applied	\N	\N	\N	\N	100800	100800	100801
22284	32589	63	applied	\N	\N	\N	\N	100811	100811	100812
22284	32592	64	applied	\N	\N	\N	\N	100817	100817	100818
22284	32593	65	applied	\N	\N	\N	\N	100819	100819	100820
22284	32598	66	applied	\N	\N	\N	\N	100835	100835	100836
22284	32599	67	applied	\N	\N	\N	\N	100837	100837	100838
22284	32600	68	applied	\N	\N	\N	\N	100839	100839	100840
22284	32607	69	applied	\N	\N	\N	\N	100857	100857	100858
22284	32610	70	applied	\N	\N	\N	\N	100864	100864	100865
22284	32613	71	applied	\N	\N	\N	\N	100870	100870	100871
22284	32614	72	applied	\N	\N	\N	\N	100872	100872	100873
22284	32615	73	applied	\N	\N	\N	\N	100874	100874	100875
22284	32622	74	applied	\N	\N	\N	\N	100894	100894	100895
22284	32625	75	applied	\N	\N	\N	\N	100906	100906	100907
22284	32628	76	applied	\N	\N	\N	\N	100913	100913	100914
22284	32631	77	applied	\N	\N	\N	\N	100919	100919	100920
22284	32634	78	applied	\N	\N	\N	\N	100927	100927	100928
22284	32637	79	applied	\N	\N	\N	\N	100935	100935	100936
22284	32640	80	applied	\N	\N	\N	\N	100984	100984	100985
22284	32641	81	applied	\N	\N	\N	\N	100986	100986	100987
22284	32646	82	applied	\N	\N	\N	\N	101004	101004	101005
22284	32649	83	applied	\N	\N	\N	\N	101012	101012	101013
22284	32652	84	applied	\N	\N	\N	\N	101018	101018	101019
22284	32653	85	applied	\N	\N	\N	\N	101020	101020	101021
22284	32658	86	applied	\N	\N	\N	\N	101030	101030	101031
22284	32659	87	applied	\N	\N	\N	\N	101032	101032	101033
22284	32664	88	applied	\N	\N	\N	\N	101044	101044	101045
22284	32667	89	applied	\N	\N	\N	\N	101054	101054	101055
22284	32670	90	applied	\N	\N	\N	\N	101062	101062	101063
22284	32673	91	applied	\N	\N	\N	\N	101070	101070	101071
22284	32676	92	applied	\N	\N	\N	\N	101078	101078	101079
22284	32681	93	applied	\N	\N	\N	\N	101089	101089	101090
22284	32682	94	applied	\N	\N	\N	\N	101095	101095	101096
22284	32685	95	applied	\N	\N	\N	\N	101103	101103	101104
22284	32688	96	applied	\N	\N	\N	\N	101109	101109	101110
22284	32689	97	applied	\N	\N	\N	\N	101111	101111	101112
22284	32694	98	applied	\N	\N	\N	\N	101124	101124	101125
22284	32697	99	applied	\N	\N	\N	\N	101135	101135	101136
22284	32700	100	applied	\N	\N	\N	\N	101178	101178	101179
22284	32703	101	applied	\N	\N	\N	\N	101186	101186	101187
22284	32704	102	applied	\N	\N	\N	\N	101188	101188	101189
22284	32709	103	applied	\N	\N	\N	\N	101202	101202	101203
22284	32712	104	applied	\N	\N	\N	\N	101210	101210	101211
22284	32715	105	applied	\N	\N	\N	\N	101217	101217	101218
22284	32719	106	applied	\N	\N	\N	\N	101227	101227	101228
22284	32720	107	applied	\N	\N	\N	\N	101229	101229	101230
22284	32725	108	applied	\N	\N	\N	\N	101244	101244	101245
22284	32726	109	applied	\N	\N	\N	\N	101246	101246	101247
22284	32731	110	applied	\N	\N	\N	\N	101257	101257	101258
22284	32732	111	applied	\N	\N	\N	\N	101259	101259	101260
22284	32737	112	applied	\N	\N	\N	\N	101270	101270	101271
22284	32738	113	applied	\N	\N	\N	\N	101272	101272	101273
22284	32739	114	applied	\N	\N	\N	\N	101274	101274	101275
22284	32740	115	applied	\N	\N	\N	\N	101276	101276	101277
22284	32741	116	applied	\N	\N	\N	\N	101278	101278	101279
22284	32742	117	applied	\N	\N	\N	\N	101280	101280	101281
22284	32743	118	applied	\N	\N	\N	\N	101282	101282	101283
22284	32758	119	applied	\N	\N	\N	\N	101314	101314	101315
22284	32761	120	applied	\N	\N	\N	\N	101320	101320	101321
22284	32764	121	applied	\N	\N	\N	\N	101331	101331	101332
22284	32765	122	applied	\N	\N	\N	\N	101333	101333	101334
22284	32769	123	applied	\N	\N	\N	\N	101343	101343	101344
22284	32771	124	applied	\N	\N	\N	\N	101351	101351	101352
22284	32774	125	applied	\N	\N	\N	\N	101359	101359	101360
22287	33613	0	applied	\N	\N	\N	\N	103772	103772	103773
22287	33614	1	applied	\N	\N	\N	\N	103774	103774	103775
22287	33615	2	applied	\N	\N	\N	\N	103776	103776	103777
22289	33616	0	applied	\N	\N	\N	\N	103784	103784	103785
22289	33617	1	applied	\N	\N	\N	\N	103786	103786	103787
22289	33618	2	applied	\N	\N	\N	\N	103788	103788	103789
22289	33619	4	applied	\N	\N	\N	\N	103791	103791	103792
22289	33620	5	applied	\N	\N	\N	\N	103793	103793	103794
22289	33621	6	applied	\N	\N	\N	\N	103795	103795	103796
22289	33622	7	applied	\N	\N	\N	\N	103797	103797	103798
22294	33630	0	applied	\N	\N	\N	\N	103825	103825	103826
22294	33631	1	applied	\N	\N	\N	\N	103827	103827	103828
22294	33632	2	applied	\N	\N	\N	\N	103829	103829	103830
22294	33633	3	applied	\N	\N	\N	\N	103831	103831	103832
22294	33634	4	applied	\N	\N	\N	\N	103833	103833	103834
22294	33635	5	applied	\N	\N	\N	\N	103835	103835	103836
22299	33639	0	applied	\N	\N	\N	\N	103864	103864	103865
22299	33640	1	applied	\N	\N	\N	\N	103866	103866	103867
22299	33641	2	applied	\N	\N	\N	\N	103868	103868	103869
22299	33642	3	applied	\N	\N	\N	\N	103870	103870	103871
22299	33643	4	applied	\N	\N	\N	\N	103872	103872	103873
22299	33644	5	applied	\N	\N	\N	\N	103874	103874	103875
22299	33645	6	applied	\N	\N	\N	\N	103876	103876	103877
22299	33646	7	applied	\N	\N	\N	\N	103878	103878	103879
22299	33647	8	applied	\N	\N	\N	\N	103880	103880	103881
22299	33648	9	applied	\N	\N	\N	\N	103882	103882	103883
22299	33649	10	applied	\N	\N	\N	\N	103884	103884	103885
22299	33650	11	applied	\N	\N	\N	\N	103886	103886	103887
22299	33651	12	applied	\N	\N	\N	\N	103888	103888	103889
22299	33652	13	applied	\N	\N	\N	\N	103890	103890	103891
22311	33677	0	applied	\N	\N	\N	\N	104008	104008	104009
22311	33678	1	applied	\N	\N	\N	\N	104010	104010	104011
22311	33679	2	applied	\N	\N	\N	\N	104012	104012	104013
22316	33687	0	applied	\N	\N	\N	\N	104036	104036	104037
22316	33688	1	applied	\N	\N	\N	\N	104038	104038	104039
22285	33611	1	applied	\N	\N	\N	\N	103766	103766	103767
22285	33612	2	applied	\N	\N	\N	\N	103768	103768	103769
22291	33616	0	applied	\N	\N	\N	\N	103784	103784	103785
22291	33617	1	applied	\N	\N	\N	\N	103786	103786	103787
22291	33618	2	applied	\N	\N	\N	\N	103788	103788	103789
22291	33619	4	applied	\N	\N	\N	\N	103791	103791	103792
22291	33620	5	applied	\N	\N	\N	\N	103793	103793	103794
22291	33621	6	applied	\N	\N	\N	\N	103795	103795	103796
22291	33622	7	applied	\N	\N	\N	\N	103797	103797	103798
22297	33636	0	applied	\N	\N	\N	\N	103854	103854	103855
22297	33637	1	applied	\N	\N	\N	\N	103856	103856	103857
22297	33638	2	applied	\N	\N	\N	\N	103858	103858	103859
22306	33670	0	applied	\N	\N	\N	\N	103932	103932	103933
22306	33671	1	applied	\N	\N	\N	\N	103934	103934	103935
22306	33672	2	applied	\N	\N	\N	\N	103936	103936	103937
22310	33673	0	applied	\N	\N	\N	\N	103999	103999	104000
22310	33674	1	applied	\N	\N	\N	\N	104001	104001	104002
22310	33675	2	applied	\N	\N	\N	\N	104003	104003	104004
22310	33676	3	applied	\N	\N	\N	\N	104005	104005	104006
22321	33707	0	applied	\N	\N	\N	\N	104081	104081	104082
22321	33708	1	applied	\N	\N	\N	\N	104083	104083	104084
22321	33709	2	applied	\N	\N	\N	\N	104085	104085	104086
22321	33710	3	applied	\N	\N	\N	\N	104087	104087	104088
22321	33711	4	applied	\N	\N	\N	\N	104089	104089	104090
22321	33712	5	applied	\N	\N	\N	\N	104091	104091	104092
22321	33713	6	applied	\N	\N	\N	\N	104093	104093	104094
22321	33714	8	applied	\N	\N	\N	\N	104096	104096	104097
22321	33715	9	applied	\N	\N	\N	\N	104098	104098	104099
22321	33716	10	applied	\N	\N	\N	\N	104100	104100	104101
22321	33717	11	applied	\N	\N	\N	\N	104102	104102	104103
22325	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22325	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22325	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22325	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22325	33722	4	applied	\N	\N	\N	\N	104119	104119	104120
22325	33723	5	applied	\N	\N	\N	\N	104121	104121	104122
22325	33724	6	applied	\N	\N	\N	\N	104123	104123	104124
22327	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22327	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22327	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22327	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22327	33722	4	applied	\N	\N	\N	\N	104119	104119	104120
22327	33723	5	applied	\N	\N	\N	\N	104121	104121	104122
22327	33724	6	applied	\N	\N	\N	\N	104123	104123	104124
22332	33729	0	applied	\N	\N	\N	\N	104153	104153	104154
22332	33730	1	applied	\N	\N	\N	\N	104155	104155	104156
22332	33731	2	applied	\N	\N	\N	\N	104157	104157	104158
22332	33732	3	applied	\N	\N	\N	\N	104159	104159	104148
22332	33733	4	applied	\N	\N	\N	\N	104160	104160	104149
22332	33734	5	applied	\N	\N	\N	\N	104161	104161	104162
22332	33735	6	applied	\N	\N	\N	\N	104163	104163	104164
22335	33745	0	applied	\N	\N	\N	\N	104193	104193	104194
22335	33746	1	applied	\N	\N	\N	\N	104195	104195	104196
22335	33747	2	applied	\N	\N	\N	\N	104197	104197	104198
22335	33748	3	applied	\N	\N	\N	\N	104199	104199	104200
22335	33749	4	applied	\N	\N	\N	\N	104201	104201	104202
22335	33750	5	applied	\N	\N	\N	\N	104203	104203	104204
22335	33751	6	applied	\N	\N	\N	\N	104205	104205	104206
22343	33772	0	applied	\N	\N	\N	\N	104256	104256	104257
22343	33773	1	applied	\N	\N	\N	\N	104258	104258	104259
22343	33774	2	applied	\N	\N	\N	\N	104260	104260	104261
22343	33775	3	applied	\N	\N	\N	\N	104262	104262	104263
22343	33769	4	applied	\N	\N	\N	\N	104246	104246	104264
22343	33770	5	applied	\N	\N	\N	\N	104248	104248	104265
22343	33771	6	applied	\N	\N	\N	\N	104250	104250	104266
22345	33778	0	applied	\N	\N	\N	\N	104274	104274	104275
22345	33779	1	applied	\N	\N	\N	\N	104276	104276	104277
22345	33776	2	applied	\N	\N	\N	\N	104268	104268	104278
22345	33777	3	applied	\N	\N	\N	\N	104270	104270	104279
22345	33780	4	applied	\N	\N	\N	\N	104280	104280	104281
22357	33794	0	applied	\N	\N	\N	\N	104347	104347	104348
22357	33795	1	applied	\N	\N	\N	\N	104349	104349	104350
22357	33796	2	applied	\N	\N	\N	\N	104351	104351	104352
22364	33813	0	applied	\N	\N	\N	\N	104404	104404	104405
22364	33814	1	applied	\N	\N	\N	\N	104406	104406	104407
22364	33815	2	applied	\N	\N	\N	\N	104408	104408	104409
22364	33816	3	applied	\N	\N	\N	\N	104410	104410	104411
22366	33817	0	applied	\N	\N	\N	\N	104416	104416	104417
22366	33818	1	applied	\N	\N	\N	\N	104418	104418	104419
22366	33819	2	applied	\N	\N	\N	\N	104420	104420	104421
22371	33827	0	applied	\N	\N	\N	\N	104444	104444	104445
22374	33838	0	applied	\N	\N	\N	\N	104472	104472	104473
22374	33839	1	applied	\N	\N	\N	\N	104474	104474	104475
22374	33840	2	applied	\N	\N	\N	\N	104476	104476	104477
22377	33848	0	applied	\N	\N	\N	\N	104496	104496	104497
22377	33849	1	applied	\N	\N	\N	\N	104498	104498	104499
22377	33850	2	applied	\N	\N	\N	\N	104500	104500	104501
22377	33851	3	applied	\N	\N	\N	\N	104502	104502	104503
22377	33852	4	applied	\N	\N	\N	\N	104504	104504	104505
22377	33853	5	applied	\N	\N	\N	\N	104506	104506	104507
22380	33858	0	applied	\N	\N	\N	\N	104519	104519	104520
22380	33859	1	applied	\N	\N	\N	\N	104521	104521	104522
22380	33860	2	applied	\N	\N	\N	\N	104523	104523	104524
22382	33862	0	applied	\N	\N	\N	\N	104531	104531	104532
22384	33869	0	applied	\N	\N	\N	\N	104551	104551	104552
22384	33870	1	applied	\N	\N	\N	\N	104553	104553	104554
22384	33871	2	applied	\N	\N	\N	\N	104555	104555	104556
22387	33872	0	applied	\N	\N	\N	\N	104559	104559	104560
22387	33873	1	applied	\N	\N	\N	\N	104561	104561	104562
22387	33874	2	applied	\N	\N	\N	\N	104563	104563	104564
22391	33875	0	applied	\N	\N	\N	\N	104606	104606	104607
22391	33876	1	applied	\N	\N	\N	\N	104608	104608	104609
22391	33877	2	applied	\N	\N	\N	\N	104610	104610	104611
22403	33898	0	applied	\N	\N	\N	\N	104670	104670	104671
22403	33899	1	applied	\N	\N	\N	\N	104672	104672	104673
22403	33900	2	applied	\N	\N	\N	\N	104674	104674	104675
22403	33901	3	applied	\N	\N	\N	\N	104676	104676	104677
22403	33902	4	applied	\N	\N	\N	\N	104678	104678	104679
22403	33903	5	applied	\N	\N	\N	\N	104680	104680	104681
22403	33904	6	applied	\N	\N	\N	\N	104682	104682	104683
22405	33905	0	applied	\N	\N	\N	\N	104701	104701	104702
22405	33906	1	applied	\N	\N	\N	\N	104703	104703	104704
22407	33907	0	applied	\N	\N	\N	\N	104707	104707	104708
22407	33908	1	applied	\N	\N	\N	\N	104709	104709	104710
22419	33930	0	applied	\N	\N	\N	\N	104773	104773	104774
22419	33931	1	applied	\N	\N	\N	\N	104775	104775	104776
22422	33932	0	applied	\N	\N	\N	\N	104781	104781	104782
22422	33933	1	applied	\N	\N	\N	\N	104783	104783	104784
22422	33934	2	applied	\N	\N	\N	\N	104785	104785	104786
22422	33935	3	applied	\N	\N	\N	\N	104787	104787	104788
22296	33531	74	applied	\N	\N	\N	\N	103547	103547	103548
22296	33534	75	applied	\N	\N	\N	\N	103555	103555	103556
22296	33537	76	applied	\N	\N	\N	\N	103564	103564	103565
22296	33541	77	applied	\N	\N	\N	\N	103575	103575	103576
22296	33544	78	applied	\N	\N	\N	\N	103584	103584	103585
22296	33547	79	applied	\N	\N	\N	\N	103593	103593	103594
22296	33552	80	applied	\N	\N	\N	\N	103604	103604	103605
22296	33553	81	applied	\N	\N	\N	\N	103606	103606	103607
22296	33554	82	applied	\N	\N	\N	\N	103608	103608	103609
22296	33563	83	applied	\N	\N	\N	\N	103630	103630	103631
22296	33566	84	applied	\N	\N	\N	\N	103638	103638	103639
22296	33569	85	applied	\N	\N	\N	\N	103646	103646	103647
22296	33570	86	applied	\N	\N	\N	\N	103648	103648	103649
22296	33577	87	applied	\N	\N	\N	\N	103664	103664	103665
22296	33580	88	applied	\N	\N	\N	\N	103672	103672	103673
22296	33581	89	applied	\N	\N	\N	\N	103674	103674	103675
22296	33588	90	applied	\N	\N	\N	\N	103690	103690	103691
22296	33609	91	applied	\N	\N	\N	\N	103760	103760	103761
22296	33591	92	applied	\N	\N	\N	\N	103698	103698	103699
22296	33592	93	applied	\N	\N	\N	\N	103700	103700	103701
22296	33597	94	applied	\N	\N	\N	\N	103712	103712	103713
22296	33600	95	applied	\N	\N	\N	\N	103720	103720	103721
22296	33605	96	applied	\N	\N	\N	\N	103734	103734	103735
22296	33610	97	applied	\N	\N	\N	\N	103764	103764	103765
22296	33613	98	applied	\N	\N	\N	\N	103772	103772	103773
22296	33616	99	applied	\N	\N	\N	\N	103784	103784	103785
22296	33617	100	applied	\N	\N	\N	\N	103786	103786	103787
22296	33623	101	applied	\N	\N	\N	\N	103810	103810	103811
22296	33624	102	applied	\N	\N	\N	\N	103812	103812	103813
22296	33630	103	applied	\N	\N	\N	\N	103825	103825	103826
22296	33631	104	applied	\N	\N	\N	\N	103827	103827	103828
22296	33387	105	applied	\N	\N	\N	\N	103088	103088	96834
22296	33388	106	applied	\N	\N	\N	\N	103089	103089	96834
22296	33389	107	applied	\N	\N	\N	\N	103090	103090	103090
22296	33303	108	applied	\N	\N	\N	\N	102864	102864	102865
22296	33356	109	applied	\N	\N	\N	\N	103012	103012	103013
22296	33304	110	applied	\N	\N	\N	\N	102866	102866	102867
22296	33307	111	applied	\N	\N	\N	\N	102874	102874	103843
22296	33305	112	applied	\N	\N	\N	\N	102868	102868	102875
22296	33313	113	applied	\N	\N	\N	\N	102888	102888	103844
22296	33377	114	applied	\N	\N	\N	\N	103063	103063	103064
22296	33384	115	applied	\N	\N	\N	\N	103083	103083	103083
22296	33308	116	applied	\N	\N	\N	\N	102876	102876	103845
22296	33311	117	applied	\N	\N	\N	\N	102884	102884	103846
22296	33312	118	applied	\N	\N	\N	\N	102886	102886	102889
22296	33317	119	applied	\N	\N	\N	\N	102900	102900	103847
22296	33321	120	applied	\N	\N	\N	\N	102910	102910	103848
22296	33323	121	applied	\N	\N	\N	\N	102914	102914	102903
22296	33324	122	applied	\N	\N	\N	\N	102916	102916	103849
22296	33338	123	applied	\N	\N	\N	\N	102951	102951	103850
22296	33347	124	applied	\N	\N	\N	\N	102990	102990	102911
22296	33357	125	applied	\N	\N	\N	\N	103014	103014	103851
22298	33636	0	applied	\N	\N	\N	\N	103854	103854	103855
22298	33637	1	applied	\N	\N	\N	\N	103856	103856	103857
22298	33638	2	applied	\N	\N	\N	\N	103858	103858	103859
22301	33653	0	applied	\N	\N	\N	\N	103893	103893	103894
22301	33654	1	applied	\N	\N	\N	\N	103895	103895	103896
22301	33655	2	applied	\N	\N	\N	\N	103897	103897	103898
22303	33656	0	applied	\N	\N	\N	\N	103901	103901	103902
22303	33657	1	applied	\N	\N	\N	\N	103903	103903	103904
22303	33658	2	applied	\N	\N	\N	\N	103905	103905	103906
22304	33659	0	applied	\N	\N	\N	\N	103909	103909	103910
22304	33660	1	applied	\N	\N	\N	\N	103911	103911	103912
22304	33661	2	applied	\N	\N	\N	\N	103913	103913	103914
22304	33662	3	applied	\N	\N	\N	\N	103915	103915	103916
22304	33663	4	applied	\N	\N	\N	\N	103917	103917	103918
22304	33664	5	applied	\N	\N	\N	\N	103919	103919	103920
22304	33665	6	applied	\N	\N	\N	\N	103921	103921	103922
22304	33666	7	applied	\N	\N	\N	\N	103923	103923	103924
22304	33667	8	applied	\N	\N	\N	\N	103925	103925	103926
22304	33668	9	applied	\N	\N	\N	\N	103927	103927	103928
22304	33669	10	applied	\N	\N	\N	\N	103929	103929	103930
22308	33670	0	applied	\N	\N	\N	\N	103932	103932	103933
22308	33671	1	applied	\N	\N	\N	\N	103934	103934	103935
22308	33672	2	applied	\N	\N	\N	\N	103936	103936	103937
22313	33683	0	applied	\N	\N	\N	\N	104024	104024	104025
22313	33684	1	applied	\N	\N	\N	\N	104026	104026	104027
22313	33685	2	applied	\N	\N	\N	\N	104028	104028	104029
22313	33686	3	applied	\N	\N	\N	\N	104030	104030	104031
22318	33695	0	applied	\N	\N	\N	\N	104055	104055	104056
22318	33696	1	applied	\N	\N	\N	\N	104057	104057	104058
22318	33697	2	applied	\N	\N	\N	\N	104059	104059	104060
22318	33698	3	applied	\N	\N	\N	\N	104061	104061	104062
22318	33699	4	applied	\N	\N	\N	\N	104063	104063	104064
22318	33700	5	applied	\N	\N	\N	\N	104065	104065	104066
22318	33701	6	applied	\N	\N	\N	\N	104067	104067	104068
22318	33702	7	applied	\N	\N	\N	\N	104069	104069	104070
22318	33703	8	applied	\N	\N	\N	\N	104071	104071	104072
22318	33704	9	applied	\N	\N	\N	\N	104073	104073	104074
22318	33705	10	applied	\N	\N	\N	\N	104075	104075	104076
22318	33706	11	applied	\N	\N	\N	\N	104077	104077	104078
22319	33707	0	applied	\N	\N	\N	\N	104081	104081	104082
22319	33708	1	applied	\N	\N	\N	\N	104083	104083	104084
22319	33709	2	applied	\N	\N	\N	\N	104085	104085	104086
22319	33710	3	applied	\N	\N	\N	\N	104087	104087	104088
22319	33711	4	applied	\N	\N	\N	\N	104089	104089	104090
22319	33712	5	applied	\N	\N	\N	\N	104091	104091	104092
22319	33713	6	applied	\N	\N	\N	\N	104093	104093	104094
22319	33714	8	applied	\N	\N	\N	\N	104096	104096	104097
22319	33715	9	applied	\N	\N	\N	\N	104098	104098	104099
22319	33716	10	applied	\N	\N	\N	\N	104100	104100	104101
22319	33717	11	applied	\N	\N	\N	\N	104102	104102	104103
22324	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22324	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22324	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22324	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22324	33722	4	applied	\N	\N	\N	\N	104119	104119	104120
22324	33723	5	applied	\N	\N	\N	\N	104121	104121	104122
22324	33724	6	applied	\N	\N	\N	\N	104123	104123	104124
22326	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22326	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22326	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22326	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22326	33722	4	applied	\N	\N	\N	\N	104119	104119	104120
22326	33723	5	applied	\N	\N	\N	\N	104121	104121	104122
22326	33724	6	applied	\N	\N	\N	\N	104123	104123	104124
22330	33725	0	applied	\N	\N	\N	\N	104136	104136	104137
22330	33726	1	applied	\N	\N	\N	\N	104138	104138	104139
22330	33722	2	applied	\N	\N	\N	\N	104119	104119	104145
22330	33723	3	applied	\N	\N	\N	\N	104121	104121	104146
22309	33583	37	applied	\N	\N	\N	\N	103678	103678	103669
22309	33575	38	applied	\N	\N	\N	\N	103658	103658	103659
22309	33586	39	applied	\N	\N	\N	\N	103684	103684	103685
22309	33576	40	applied	\N	\N	\N	\N	103660	103660	103957
22309	33587	41	applied	\N	\N	\N	\N	103686	103686	103677
22309	33594	42	applied	\N	\N	\N	\N	103704	103704	103958
22309	33606	43	applied	\N	\N	\N	\N	103736	103736	103679
22309	33621	44	applied	\N	\N	\N	\N	103795	103795	103959
22309	33629	45	applied	\N	\N	\N	\N	103822	103822	103960
22309	33643	46	applied	\N	\N	\N	\N	103872	103872	103681
22309	33644	47	applied	\N	\N	\N	\N	103874	103874	103961
22309	33667	48	applied	\N	\N	\N	\N	103925	103925	103962
22309	33590	49	applied	\N	\N	\N	\N	103694	103694	103687
22309	33595	50	applied	\N	\N	\N	\N	103706	103706	103963
22309	33596	51	applied	\N	\N	\N	\N	103708	103708	103964
22309	33599	52	applied	\N	\N	\N	\N	103716	103716	103965
22309	33601	53	applied	\N	\N	\N	\N	103722	103722	103703
22309	33603	54	applied	\N	\N	\N	\N	103726	103726	103966
22309	33607	55	applied	\N	\N	\N	\N	103738	103738	103967
22309	33612	56	applied	\N	\N	\N	\N	103768	103768	103968
22309	33615	57	applied	\N	\N	\N	\N	103776	103776	103715
22309	33618	58	applied	\N	\N	\N	\N	103788	103788	103717
22309	33619	59	applied	\N	\N	\N	\N	103791	103791	103723
22309	33627	60	applied	\N	\N	\N	\N	103818	103818	103969
22309	33628	61	applied	\N	\N	\N	\N	103820	103820	103970
22309	33632	62	applied	\N	\N	\N	\N	103829	103829	103971
22309	33633	63	applied	\N	\N	\N	\N	103831	103831	103729
22309	33637	64	applied	\N	\N	\N	\N	103856	103856	103972
22309	33645	65	applied	\N	\N	\N	\N	103876	103876	103973
22309	33646	66	applied	\N	\N	\N	\N	103878	103878	103741
22309	33647	67	applied	\N	\N	\N	\N	103880	103880	103974
22309	33648	68	applied	\N	\N	\N	\N	103882	103882	103975
22309	33654	69	applied	\N	\N	\N	\N	103895	103895	103976
22309	33657	70	applied	\N	\N	\N	\N	103903	103903	103775
22309	33664	72	applied	\N	\N	\N	\N	103919	103919	103777
22309	33668	73	applied	\N	\N	\N	\N	103927	103927	103789
22309	33669	74	applied	\N	\N	\N	\N	103929	103929	103792
22309	33671	75	applied	\N	\N	\N	\N	103934	103934	103978
22309	33579	76	applied	\N	\N	\N	\N	103668	103668	103979
22309	33584	77	applied	\N	\N	\N	\N	103680	103680	103980
22309	33585	78	applied	\N	\N	\N	\N	103682	103682	103981
22309	33589	79	applied	\N	\N	\N	\N	103692	103692	103982
22309	33593	80	applied	\N	\N	\N	\N	103702	103702	103821
22309	33598	81	applied	\N	\N	\N	\N	103714	103714	103830
22309	33602	82	applied	\N	\N	\N	\N	103724	103724	103983
22309	33604	83	applied	\N	\N	\N	\N	103728	103728	103984
22309	33608	84	applied	\N	\N	\N	\N	103740	103740	103985
22309	33611	85	applied	\N	\N	\N	\N	103766	103766	103986
22309	33614	86	applied	\N	\N	\N	\N	103774	103774	103875
22309	33620	87	applied	\N	\N	\N	\N	103793	103793	103987
22309	33622	88	applied	\N	\N	\N	\N	103797	103797	103881
22309	33625	89	applied	\N	\N	\N	\N	103814	103814	103988
22309	33626	90	applied	\N	\N	\N	\N	103816	103816	103989
22309	33634	91	applied	\N	\N	\N	\N	103833	103833	103990
22309	33635	92	applied	\N	\N	\N	\N	103835	103835	103991
22309	33638	93	applied	\N	\N	\N	\N	103858	103858	103992
22309	33649	94	applied	\N	\N	\N	\N	103884	103884	103993
22309	33650	95	applied	\N	\N	\N	\N	103886	103886	103904
22309	33651	96	applied	\N	\N	\N	\N	103888	103888	103906
22309	33652	97	applied	\N	\N	\N	\N	103890	103890	103918
22309	33655	98	applied	\N	\N	\N	\N	103897	103897	103994
22309	33658	99	applied	\N	\N	\N	\N	103905	103905	103995
22309	33663	100	applied	\N	\N	\N	\N	103917	103917	103926
22309	33665	101	applied	\N	\N	\N	\N	103921	103921	103996
22309	33666	102	applied	\N	\N	\N	\N	103923	103923	103935
22309	33672	103	applied	\N	\N	\N	\N	103936	103936	103937
22312	33680	0	applied	\N	\N	\N	\N	104016	104016	104017
22312	33681	1	applied	\N	\N	\N	\N	104018	104018	104019
22312	33682	2	applied	\N	\N	\N	\N	104020	104020	104021
22314	33683	0	applied	\N	\N	\N	\N	104024	104024	104025
22314	33684	1	applied	\N	\N	\N	\N	104026	104026	104027
22314	33685	2	applied	\N	\N	\N	\N	104028	104028	104029
22314	33686	3	applied	\N	\N	\N	\N	104030	104030	104031
22317	33687	0	applied	\N	\N	\N	\N	104036	104036	104037
22317	33688	1	applied	\N	\N	\N	\N	104038	104038	104039
22317	33689	2	applied	\N	\N	\N	\N	104040	104040	104041
22317	33690	3	applied	\N	\N	\N	\N	104042	104042	104043
22317	33691	4	applied	\N	\N	\N	\N	104044	104044	104045
22317	33692	5	applied	\N	\N	\N	\N	104046	104046	104047
22317	33693	6	applied	\N	\N	\N	\N	104048	104048	104049
22317	33694	7	applied	\N	\N	\N	\N	104050	104050	104051
22320	33707	0	applied	\N	\N	\N	\N	104081	104081	104082
22320	33708	1	applied	\N	\N	\N	\N	104083	104083	104084
22320	33709	2	applied	\N	\N	\N	\N	104085	104085	104086
22320	33710	3	applied	\N	\N	\N	\N	104087	104087	104088
22320	33711	4	applied	\N	\N	\N	\N	104089	104089	104090
22320	33712	5	applied	\N	\N	\N	\N	104091	104091	104092
22320	33713	6	applied	\N	\N	\N	\N	104093	104093	104094
22320	33714	8	applied	\N	\N	\N	\N	104096	104096	104097
22320	33715	9	applied	\N	\N	\N	\N	104098	104098	104099
22320	33716	10	applied	\N	\N	\N	\N	104100	104100	104101
22320	33717	11	applied	\N	\N	\N	\N	104102	104102	104103
22323	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22323	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22323	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22323	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22323	33724	4	applied	\N	\N	\N	\N	104123	104123	104124
22329	33725	0	applied	\N	\N	\N	\N	104136	104136	104137
22329	33726	1	applied	\N	\N	\N	\N	104138	104138	104139
22329	33727	2	applied	\N	\N	\N	\N	104140	104140	104120
22331	33722	0	applied	\N	\N	\N	\N	104119	104119	104122
22331	33723	1	applied	\N	\N	\N	\N	104121	104121	104151
22334	33739	0	applied	\N	\N	\N	\N	104178	104178	104179
22334	33740	1	applied	\N	\N	\N	\N	104180	104180	104181
22334	33728	2	applied	\N	\N	\N	\N	104147	104147	104182
22334	33741	3	applied	\N	\N	\N	\N	104183	104183	104184
22334	33742	4	applied	\N	\N	\N	\N	104185	104185	104172
22334	33736	5	applied	\N	\N	\N	\N	104167	104167	104174
22334	33737	6	applied	\N	\N	\N	\N	104169	104169	104186
22334	33738	7	applied	\N	\N	\N	\N	104171	104171	104187
22334	33743	8	applied	\N	\N	\N	\N	104188	104188	104189
22334	33744	9	applied	\N	\N	\N	\N	104190	104190	104191
22337	33752	0	applied	\N	\N	\N	\N	104208	104208	104209
22337	33753	1	applied	\N	\N	\N	\N	104210	104210	104211
22337	33754	2	applied	\N	\N	\N	\N	104212	104212	104213
22339	33758	0	applied	\N	\N	\N	\N	104222	104222	104223
22339	33759	1	applied	\N	\N	\N	\N	104224	104224	104225
22339	33760	2	applied	\N	\N	\N	\N	104226	104226	104227
22339	33761	3	applied	\N	\N	\N	\N	104228	104228	104229
22340	33762	0	applied	\N	\N	\N	\N	104232	104232	104233
22316	33689	2	applied	\N	\N	\N	\N	104040	104040	104041
22316	33690	3	applied	\N	\N	\N	\N	104042	104042	104043
22316	33691	4	applied	\N	\N	\N	\N	104044	104044	104045
22316	33692	5	applied	\N	\N	\N	\N	104046	104046	104047
22316	33693	6	applied	\N	\N	\N	\N	104048	104048	104049
22316	33694	7	applied	\N	\N	\N	\N	104050	104050	104051
22322	33718	0	applied	\N	\N	\N	\N	104111	104111	104112
22322	33719	1	applied	\N	\N	\N	\N	104113	104113	104114
22322	33720	2	applied	\N	\N	\N	\N	104115	104115	104116
22322	33721	3	applied	\N	\N	\N	\N	104117	104117	104118
22322	33722	4	applied	\N	\N	\N	\N	104119	104119	104120
22322	33723	5	applied	\N	\N	\N	\N	104121	104121	104122
22322	33724	6	applied	\N	\N	\N	\N	104123	104123	104124
22328	33725	0	applied	\N	\N	\N	\N	104136	104136	104137
22328	33726	1	applied	\N	\N	\N	\N	104138	104138	104139
22328	33727	2	applied	\N	\N	\N	\N	104140	104140	104120
22333	33729	0	applied	\N	\N	\N	\N	104153	104153	104154
22333	33730	1	applied	\N	\N	\N	\N	104155	104155	104156
22333	33731	2	applied	\N	\N	\N	\N	104157	104157	104158
22333	33728	3	applied	\N	\N	\N	\N	104147	104147	104149
22333	33732	4	applied	\N	\N	\N	\N	104159	104159	104162
22333	33736	5	applied	\N	\N	\N	\N	104167	104167	104168
22333	33737	6	applied	\N	\N	\N	\N	104169	104169	104170
22333	33738	7	applied	\N	\N	\N	\N	104171	104171	104172
22333	33733	8	applied	\N	\N	\N	\N	104160	104160	104173
22333	33734	9	applied	\N	\N	\N	\N	104161	104161	104174
22333	33735	10	applied	\N	\N	\N	\N	104163	104163	104175
22336	33752	0	applied	\N	\N	\N	\N	104208	104208	104209
22336	33753	1	applied	\N	\N	\N	\N	104210	104210	104211
22336	33754	2	applied	\N	\N	\N	\N	104212	104212	104213
22347	33781	0	applied	\N	\N	\N	\N	104284	104284	104285
22347	33782	1	applied	\N	\N	\N	\N	104286	104286	104287
22347	33783	2	applied	\N	\N	\N	\N	104288	104288	104289
22347	33784	3	applied	\N	\N	\N	\N	104290	104290	104291
22351	33787	0	applied	\N	\N	\N	\N	104329	104329	104330
22351	33788	1	applied	\N	\N	\N	\N	104331	104331	104332
22351	33789	2	applied	\N	\N	\N	\N	104333	104333	104334
22353	33790	0	applied	\N	\N	\N	\N	104335	104335	104336
22353	33791	1	applied	\N	\N	\N	\N	104337	104337	104338
22353	33792	2	applied	\N	\N	\N	\N	104339	104339	104340
22353	33793	3	applied	\N	\N	\N	\N	104341	104341	104342
22360	33800	0	applied	\N	\N	\N	\N	104368	104368	104369
22360	33801	1	applied	\N	\N	\N	\N	104370	104370	104371
22360	33802	3	applied	\N	\N	\N	\N	104373	104373	104374
22360	33803	4	applied	\N	\N	\N	\N	104375	104375	104376
22368	33820	0	applied	\N	\N	\N	\N	104424	104424	104425
22368	33821	1	applied	\N	\N	\N	\N	104426	104426	104427
22368	33822	2	applied	\N	\N	\N	\N	104428	104428	104429
22368	33823	3	applied	\N	\N	\N	\N	104430	104430	104431
22368	33824	4	applied	\N	\N	\N	\N	104432	104432	104433
22368	33825	5	applied	\N	\N	\N	\N	104434	104434	104435
22368	33826	6	applied	\N	\N	\N	\N	104436	104436	104437
22372	33828	0	applied	\N	\N	\N	\N	104448	104448	104449
22372	33829	1	applied	\N	\N	\N	\N	104450	104450	104451
22372	33830	2	applied	\N	\N	\N	\N	104452	104452	104453
22378	33854	0	applied	\N	\N	\N	\N	104510	104510	104511
22378	33855	1	applied	\N	\N	\N	\N	104512	104512	104513
22378	33856	2	applied	\N	\N	\N	\N	104514	104514	104515
22378	33857	3	applied	\N	\N	\N	\N	104516	104516	104517
22383	33865	0	applied	\N	\N	\N	\N	104541	104541	104542
22383	33866	1	applied	\N	\N	\N	\N	104543	104543	104544
22383	33867	2	applied	\N	\N	\N	\N	104545	104545	104546
22383	33868	3	applied	\N	\N	\N	\N	104547	104547	104548
22390	33875	0	applied	\N	\N	\N	\N	104606	104606	104607
22390	33876	1	applied	\N	\N	\N	\N	104608	104608	104609
22390	33877	2	applied	\N	\N	\N	\N	104610	104610	104611
22392	33878	0	applied	\N	\N	\N	\N	104617	104617	104618
22392	33879	1	applied	\N	\N	\N	\N	104619	104619	104620
22392	33880	2	applied	\N	\N	\N	\N	104621	104621	104622
22392	33881	3	applied	\N	\N	\N	\N	104623	104623	104624
22394	33882	0	applied	\N	\N	\N	\N	104628	104628	104629
22394	33883	1	applied	\N	\N	\N	\N	104630	104630	104631
22394	33884	2	applied	\N	\N	\N	\N	104632	104632	104633
22397	33892	0	applied	\N	\N	\N	\N	104653	104653	104654
22397	33893	1	applied	\N	\N	\N	\N	104655	104655	104656
22397	33894	2	applied	\N	\N	\N	\N	104657	104657	104658
22397	33895	3	applied	\N	\N	\N	\N	104659	104659	104660
22397	33896	4	applied	\N	\N	\N	\N	104661	104661	104662
22397	33897	5	applied	\N	\N	\N	\N	104663	104663	104664
22400	33892	0	applied	\N	\N	\N	\N	104653	104653	104654
22400	33893	1	applied	\N	\N	\N	\N	104655	104655	104656
22400	33894	2	applied	\N	\N	\N	\N	104657	104657	104658
22400	33895	3	applied	\N	\N	\N	\N	104659	104659	104660
22400	33896	4	applied	\N	\N	\N	\N	104661	104661	104662
22400	33897	5	applied	\N	\N	\N	\N	104663	104663	104664
22401	33892	0	applied	\N	\N	\N	\N	104653	104653	104654
22401	33893	1	applied	\N	\N	\N	\N	104655	104655	104656
22401	33894	2	applied	\N	\N	\N	\N	104657	104657	104658
22401	33895	3	applied	\N	\N	\N	\N	104659	104659	104660
22401	33896	4	applied	\N	\N	\N	\N	104661	104661	104662
22401	33897	5	applied	\N	\N	\N	\N	104663	104663	104664
22409	33907	0	applied	\N	\N	\N	\N	104707	104707	104708
22409	33909	1	applied	\N	\N	\N	\N	104712	104712	104713
22409	33908	2	applied	\N	\N	\N	\N	104709	104709	104714
22410	33907	0	applied	\N	\N	\N	\N	104707	104707	104708
22410	33909	1	applied	\N	\N	\N	\N	104712	104712	104713
22410	33908	2	applied	\N	\N	\N	\N	104709	104709	104714
22411	33910	0	applied	\N	\N	\N	\N	104718	104718	104719
22411	33911	1	applied	\N	\N	\N	\N	104720	104720	104721
22411	33912	2	applied	\N	\N	\N	\N	104722	104722	104723
22411	33913	3	applied	\N	\N	\N	\N	104724	104724	104725
22411	33914	4	applied	\N	\N	\N	\N	104726	104726	104727
22411	33915	5	applied	\N	\N	\N	\N	104728	104728	104729
22411	33916	6	applied	\N	\N	\N	\N	104730	104730	104731
22411	33917	7	applied	\N	\N	\N	\N	104732	104732	104733
22411	33918	8	applied	\N	\N	\N	\N	104734	104734	104735
22411	33919	9	applied	\N	\N	\N	\N	104736	104736	104737
22413	33920	0	applied	\N	\N	\N	\N	104742	104742	104743
22413	33921	1	applied	\N	\N	\N	\N	104744	104744	104745
22413	33922	2	applied	\N	\N	\N	\N	104746	104746	104747
22413	33923	3	applied	\N	\N	\N	\N	104748	104748	104749
22416	33927	0	applied	\N	\N	\N	\N	104758	104758	104759
22416	33929	1	applied	\N	\N	\N	\N	104763	104763	104764
22416	33928	2	applied	\N	\N	\N	\N	104760	104760	104765
22418	33910	0	applied	\N	\N	\N	\N	104718	104718	104719
22418	33911	1	applied	\N	\N	\N	\N	104720	104720	104721
22418	33912	2	applied	\N	\N	\N	\N	104722	104722	104723
22418	33920	3	applied	\N	\N	\N	\N	104742	104742	104743
22418	33924	4	applied	\N	\N	\N	\N	104751	104751	104752
22418	33927	5	applied	\N	\N	\N	\N	104758	104758	104759
22330	33728	4	applied	\N	\N	\N	\N	104147	104147	104148
22330	33727	5	applied	\N	\N	\N	\N	104140	104140	104149
22338	33755	0	applied	\N	\N	\N	\N	104216	104216	104217
22338	33756	1	applied	\N	\N	\N	\N	104218	104218	104219
22338	33757	2	applied	\N	\N	\N	\N	104220	104220	104221
22341	33762	0	applied	\N	\N	\N	\N	104232	104232	104233
22341	33763	1	applied	\N	\N	\N	\N	104234	104234	104235
22341	33764	2	applied	\N	\N	\N	\N	104236	104236	104237
22341	33765	3	applied	\N	\N	\N	\N	104238	104238	104239
22341	33766	4	applied	\N	\N	\N	\N	104240	104240	104241
22341	33767	5	applied	\N	\N	\N	\N	104242	104242	104243
22341	33768	6	applied	\N	\N	\N	\N	104244	104244	104245
22341	33769	7	applied	\N	\N	\N	\N	104246	104246	104247
22341	33770	8	applied	\N	\N	\N	\N	104248	104248	104249
22341	33771	9	applied	\N	\N	\N	\N	104250	104250	104251
22344	33772	0	applied	\N	\N	\N	\N	104256	104256	104257
22344	33773	1	applied	\N	\N	\N	\N	104258	104258	104259
22344	33774	2	applied	\N	\N	\N	\N	104260	104260	104261
22344	33775	3	applied	\N	\N	\N	\N	104262	104262	104263
22344	33769	4	applied	\N	\N	\N	\N	104246	104246	104264
22344	33770	5	applied	\N	\N	\N	\N	104248	104248	104265
22344	33771	6	applied	\N	\N	\N	\N	104250	104250	104266
22344	33776	7	applied	\N	\N	\N	\N	104268	104268	104269
22344	33777	8	applied	\N	\N	\N	\N	104270	104270	104271
22346	33781	0	applied	\N	\N	\N	\N	104284	104284	104285
22346	33782	1	applied	\N	\N	\N	\N	104286	104286	104287
22346	33783	2	applied	\N	\N	\N	\N	104288	104288	104289
22346	33784	3	applied	\N	\N	\N	\N	104290	104290	104291
22348	33781	0	applied	\N	\N	\N	\N	104284	104284	104285
22348	33782	1	applied	\N	\N	\N	\N	104286	104286	104287
22348	33783	2	applied	\N	\N	\N	\N	104288	104288	104289
22348	33784	3	applied	\N	\N	\N	\N	104290	104290	104291
22350	33725	0	applied	\N	\N	\N	\N	104136	104136	104137
22350	33729	1	applied	\N	\N	\N	\N	104153	104153	104154
22350	33730	2	applied	\N	\N	\N	\N	104155	104155	104156
22350	33731	3	applied	\N	\N	\N	\N	104157	104157	104158
22350	33739	4	applied	\N	\N	\N	\N	104178	104178	104179
22350	33740	5	applied	\N	\N	\N	\N	104180	104180	104181
22350	33745	6	applied	\N	\N	\N	\N	104193	104193	104194
22350	33746	7	applied	\N	\N	\N	\N	104195	104195	104196
22350	33752	8	applied	\N	\N	\N	\N	104208	104208	104209
22350	33755	9	applied	\N	\N	\N	\N	104216	104216	104217
22350	33758	10	applied	\N	\N	\N	\N	104222	104222	104223
22350	33762	11	applied	\N	\N	\N	\N	104232	104232	104233
22350	33763	12	applied	\N	\N	\N	\N	104234	104234	104235
22350	33764	13	applied	\N	\N	\N	\N	104236	104236	104237
22350	33772	14	applied	\N	\N	\N	\N	104256	104256	104257
22350	33773	15	applied	\N	\N	\N	\N	104258	104258	104259
22350	33778	16	applied	\N	\N	\N	\N	104274	104274	104275
22350	33781	17	applied	\N	\N	\N	\N	104284	104284	104285
22350	33785	18	applied	\N	\N	\N	\N	104298	104298	104299
22350	33726	19	applied	\N	\N	\N	\N	104138	104138	104139
22350	33732	20	applied	\N	\N	\N	\N	104159	104159	104304
22350	33722	21	applied	\N	\N	\N	\N	104119	104119	104305
22350	33723	22	applied	\N	\N	\N	\N	104121	104121	104306
22350	33728	23	applied	\N	\N	\N	\N	104147	104147	104307
22350	33736	24	applied	\N	\N	\N	\N	104167	104167	104164
22350	33737	25	applied	\N	\N	\N	\N	104169	104169	104182
22350	33738	26	applied	\N	\N	\N	\N	104171	104171	104308
22350	33743	27	applied	\N	\N	\N	\N	104188	104188	104309
22350	33744	28	applied	\N	\N	\N	\N	104190	104190	104175
22350	33747	29	applied	\N	\N	\N	\N	104197	104197	104310
22350	33748	30	applied	\N	\N	\N	\N	104199	104199	104311
22350	33754	31	applied	\N	\N	\N	\N	104212	104212	104312
22350	33756	32	applied	\N	\N	\N	\N	104218	104218	104313
22350	33759	33	applied	\N	\N	\N	\N	104224	104224	104314
22350	33727	34	applied	\N	\N	\N	\N	104140	104140	104200
22350	33733	35	applied	\N	\N	\N	\N	104160	104160	104202
22350	33749	36	applied	\N	\N	\N	\N	104201	104201	104315
22350	33760	37	applied	\N	\N	\N	\N	104226	104226	104204
22350	33766	38	applied	\N	\N	\N	\N	104240	104240	104316
22350	33783	39	applied	\N	\N	\N	\N	104288	104288	104206
22350	33769	40	applied	\N	\N	\N	\N	104246	104246	104317
22350	33770	41	applied	\N	\N	\N	\N	104248	104248	104318
22350	33771	42	applied	\N	\N	\N	\N	104250	104250	104319
22350	33776	43	applied	\N	\N	\N	\N	104268	104268	104320
22350	33777	44	applied	\N	\N	\N	\N	104270	104270	104321
22350	33780	45	applied	\N	\N	\N	\N	104280	104280	104239
22350	33784	46	applied	\N	\N	\N	\N	104290	104290	104243
22350	33734	47	applied	\N	\N	\N	\N	104161	104161	104245
22350	33735	48	applied	\N	\N	\N	\N	104163	104163	104261
22350	33741	49	applied	\N	\N	\N	\N	104183	104183	104263
22350	33742	50	applied	\N	\N	\N	\N	104185	104185	104249
22350	33750	51	applied	\N	\N	\N	\N	104203	104203	104322
22350	33751	52	applied	\N	\N	\N	\N	104205	104205	104265
22350	33753	53	applied	\N	\N	\N	\N	104210	104210	104323
22350	33757	54	applied	\N	\N	\N	\N	104220	104220	104324
22350	33761	55	applied	\N	\N	\N	\N	104228	104228	104269
22350	33765	56	applied	\N	\N	\N	\N	104238	104238	104278
22350	33767	57	applied	\N	\N	\N	\N	104242	104242	104325
22350	33768	58	applied	\N	\N	\N	\N	104244	104244	104326
22350	33774	59	applied	\N	\N	\N	\N	104260	104260	104281
22350	33775	60	applied	\N	\N	\N	\N	104262	104262	104287
22350	33779	61	applied	\N	\N	\N	\N	104276	104276	104327
22350	33782	62	applied	\N	\N	\N	\N	104286	104286	104291
22350	33786	63	applied	\N	\N	\N	\N	104300	104300	104301
22355	33794	0	applied	\N	\N	\N	\N	104347	104347	104348
22355	33795	1	applied	\N	\N	\N	\N	104349	104349	104350
22355	33796	2	applied	\N	\N	\N	\N	104351	104351	104352
22358	33794	0	applied	\N	\N	\N	\N	104347	104347	104348
22358	33795	1	applied	\N	\N	\N	\N	104349	104349	104350
22358	33796	2	applied	\N	\N	\N	\N	104351	104351	104352
22359	33797	0	applied	\N	\N	\N	\N	104360	104360	104361
22359	33798	1	applied	\N	\N	\N	\N	104362	104362	104363
22359	33799	2	applied	\N	\N	\N	\N	104364	104364	104365
22362	33800	0	applied	\N	\N	\N	\N	104368	104368	104369
22362	33801	1	applied	\N	\N	\N	\N	104370	104370	104371
22362	33802	3	applied	\N	\N	\N	\N	104373	104373	104374
22362	33803	4	applied	\N	\N	\N	\N	104375	104375	104376
22365	33813	0	applied	\N	\N	\N	\N	104404	104404	104405
22365	33814	1	applied	\N	\N	\N	\N	104406	104406	104407
22365	33815	2	applied	\N	\N	\N	\N	104408	104408	104409
22365	33816	3	applied	\N	\N	\N	\N	104410	104410	104411
22367	33820	0	applied	\N	\N	\N	\N	104424	104424	104425
22367	33821	1	applied	\N	\N	\N	\N	104426	104426	104427
22367	33822	2	applied	\N	\N	\N	\N	104428	104428	104429
22367	33823	3	applied	\N	\N	\N	\N	104430	104430	104431
22367	33824	4	applied	\N	\N	\N	\N	104432	104432	104433
22367	33825	5	applied	\N	\N	\N	\N	104434	104434	104435
22367	33826	6	applied	\N	\N	\N	\N	104436	104436	104437
22340	33763	1	applied	\N	\N	\N	\N	104234	104234	104235
22340	33764	2	applied	\N	\N	\N	\N	104236	104236	104237
22340	33765	3	applied	\N	\N	\N	\N	104238	104238	104239
22340	33766	4	applied	\N	\N	\N	\N	104240	104240	104241
22340	33767	5	applied	\N	\N	\N	\N	104242	104242	104243
22340	33768	6	applied	\N	\N	\N	\N	104244	104244	104245
22340	33769	7	applied	\N	\N	\N	\N	104246	104246	104247
22340	33770	8	applied	\N	\N	\N	\N	104248	104248	104249
22340	33771	9	applied	\N	\N	\N	\N	104250	104250	104251
22342	33762	0	applied	\N	\N	\N	\N	104232	104232	104233
22342	33763	1	applied	\N	\N	\N	\N	104234	104234	104235
22342	33764	2	applied	\N	\N	\N	\N	104236	104236	104237
22342	33765	3	applied	\N	\N	\N	\N	104238	104238	104239
22342	33766	4	applied	\N	\N	\N	\N	104240	104240	104241
22342	33767	5	applied	\N	\N	\N	\N	104242	104242	104243
22342	33768	6	applied	\N	\N	\N	\N	104244	104244	104245
22349	33785	0	applied	\N	\N	\N	\N	104298	104298	104299
22349	33786	1	applied	\N	\N	\N	\N	104300	104300	104301
22354	33662	0	applied	\N	\N	\N	\N	103915	103915	103916
22354	33689	1	applied	\N	\N	\N	\N	104040	104040	104041
22354	33697	2	applied	\N	\N	\N	\N	104059	104059	104060
22354	33698	3	applied	\N	\N	\N	\N	104061	104061	104062
22354	33690	4	applied	\N	\N	\N	\N	104042	104042	104043
22354	33701	5	applied	\N	\N	\N	\N	104067	104067	104068
22354	33703	6	applied	\N	\N	\N	\N	104071	104071	104072
22354	33704	7	applied	\N	\N	\N	\N	104073	104073	104074
22354	33712	8	applied	\N	\N	\N	\N	104091	104091	104092
22354	33724	9	applied	\N	\N	\N	\N	104123	104123	104124
22356	33794	0	applied	\N	\N	\N	\N	104347	104347	104348
22356	33795	1	applied	\N	\N	\N	\N	104349	104349	104350
22356	33796	2	applied	\N	\N	\N	\N	104351	104351	104352
22361	33800	0	applied	\N	\N	\N	\N	104368	104368	104369
22361	33801	1	applied	\N	\N	\N	\N	104370	104370	104371
22361	33802	3	applied	\N	\N	\N	\N	104373	104373	104374
22361	33803	4	applied	\N	\N	\N	\N	104375	104375	104376
22363	33804	0	applied	\N	\N	\N	\N	104385	104385	104386
22363	33805	1	applied	\N	\N	\N	\N	104387	104387	104388
22363	33806	2	applied	\N	\N	\N	\N	104389	104389	104390
22363	33807	3	applied	\N	\N	\N	\N	104391	104391	104392
22363	33808	4	applied	\N	\N	\N	\N	104393	104393	104394
22363	33809	5	applied	\N	\N	\N	\N	104395	104395	104396
22363	33810	6	applied	\N	\N	\N	\N	104397	104397	104398
22363	33811	7	applied	\N	\N	\N	\N	104399	104399	104400
22363	33812	8	applied	\N	\N	\N	\N	104401	104401	104402
22369	33820	0	applied	\N	\N	\N	\N	104424	104424	104425
22369	33821	1	applied	\N	\N	\N	\N	104426	104426	104427
22369	33822	2	applied	\N	\N	\N	\N	104428	104428	104429
22369	33823	3	applied	\N	\N	\N	\N	104430	104430	104431
22369	33824	4	applied	\N	\N	\N	\N	104432	104432	104433
22369	33825	5	applied	\N	\N	\N	\N	104434	104434	104435
22369	33826	6	applied	\N	\N	\N	\N	104436	104436	104437
22373	33831	0	applied	\N	\N	\N	\N	104456	104456	104457
22373	33832	1	applied	\N	\N	\N	\N	104458	104458	104459
22373	33833	2	applied	\N	\N	\N	\N	104460	104460	104461
22373	33834	3	applied	\N	\N	\N	\N	104462	104462	104463
22373	33835	4	applied	\N	\N	\N	\N	104464	104464	104465
22373	33836	5	applied	\N	\N	\N	\N	104466	104466	104467
22373	33837	6	applied	\N	\N	\N	\N	104468	104468	104469
22376	33841	0	applied	\N	\N	\N	\N	104478	104478	104479
22376	33842	1	applied	\N	\N	\N	\N	104480	104480	104481
22376	33843	2	applied	\N	\N	\N	\N	104482	104482	104483
22376	33844	3	applied	\N	\N	\N	\N	104484	104484	104485
22376	33845	4	applied	\N	\N	\N	\N	104486	104486	104487
22376	33846	5	applied	\N	\N	\N	\N	104488	104488	104489
22376	33847	6	applied	\N	\N	\N	\N	104490	104490	104491
22379	33858	0	applied	\N	\N	\N	\N	104519	104519	104520
22379	33859	1	applied	\N	\N	\N	\N	104521	104521	104522
22379	33860	2	applied	\N	\N	\N	\N	104523	104523	104524
22381	33861	0	applied	\N	\N	\N	\N	104529	104529	104530
22381	33862	1	applied	\N	\N	\N	\N	104531	104531	104532
22381	33863	2	applied	\N	\N	\N	\N	104533	104533	104534
22381	33864	3	applied	\N	\N	\N	\N	104535	104535	104536
22386	33872	0	applied	\N	\N	\N	\N	104559	104559	104560
22386	33873	1	applied	\N	\N	\N	\N	104561	104561	104562
22386	33874	2	applied	\N	\N	\N	\N	104563	104563	104564
22388	33794	0	applied	\N	\N	\N	\N	104347	104347	104348
22388	33797	1	applied	\N	\N	\N	\N	104360	104360	104361
22388	33800	2	applied	\N	\N	\N	\N	104368	104368	104369
22388	33804	3	applied	\N	\N	\N	\N	104385	104385	104386
22388	33805	4	applied	\N	\N	\N	\N	104387	104387	104388
22388	33806	5	applied	\N	\N	\N	\N	104389	104389	104390
22388	33813	6	applied	\N	\N	\N	\N	104404	104404	104405
22388	33817	7	applied	\N	\N	\N	\N	104416	104416	104417
22388	33820	8	applied	\N	\N	\N	\N	104424	104424	104425
22388	33821	9	applied	\N	\N	\N	\N	104426	104426	104427
22388	33827	10	applied	\N	\N	\N	\N	104444	104444	104445
22388	33828	11	applied	\N	\N	\N	\N	104448	104448	104449
22388	33831	13	applied	\N	\N	\N	\N	104456	104456	104457
22388	33832	14	applied	\N	\N	\N	\N	104458	104458	104459
22388	33838	15	applied	\N	\N	\N	\N	104472	104472	104473
22388	33841	16	applied	\N	\N	\N	\N	104478	104478	104479
22388	33842	17	applied	\N	\N	\N	\N	104480	104480	104481
22388	33848	18	applied	\N	\N	\N	\N	104496	104496	104497
22388	33849	19	applied	\N	\N	\N	\N	104498	104498	104499
22388	33854	20	applied	\N	\N	\N	\N	104510	104510	104511
22388	33858	21	applied	\N	\N	\N	\N	104519	104519	104520
22388	33861	22	applied	\N	\N	\N	\N	104529	104529	104530
22388	33865	23	applied	\N	\N	\N	\N	104541	104541	104542
22388	33869	24	applied	\N	\N	\N	\N	104551	104551	104552
22388	33872	25	applied	\N	\N	\N	\N	104559	104559	104560
22388	33795	26	applied	\N	\N	\N	\N	104349	104349	104350
22388	33862	27	applied	\N	\N	\N	\N	104531	104531	104532
22388	33798	28	applied	\N	\N	\N	\N	104362	104362	104571
22388	33801	29	applied	\N	\N	\N	\N	104370	104370	104572
22388	33807	30	applied	\N	\N	\N	\N	104391	104391	104573
22388	33808	31	applied	\N	\N	\N	\N	104393	104393	104574
22388	33802	32	applied	\N	\N	\N	\N	104373	104373	104376
22388	33809	33	applied	\N	\N	\N	\N	104395	104395	104392
22388	33815	34	applied	\N	\N	\N	\N	104408	104408	104394
22388	33816	35	applied	\N	\N	\N	\N	104410	104410	104575
22388	33819	36	applied	\N	\N	\N	\N	104420	104420	104576
22388	33822	37	applied	\N	\N	\N	\N	104428	104428	104400
22388	33823	38	applied	\N	\N	\N	\N	104430	104430	104577
22388	33834	39	applied	\N	\N	\N	\N	104462	104462	104402
22388	33824	40	applied	\N	\N	\N	\N	104432	104432	104578
22388	33830	41	applied	\N	\N	\N	\N	104452	104452	104411
22388	33835	42	applied	\N	\N	\N	\N	104464	104464	104579
22388	33836	43	applied	\N	\N	\N	\N	104466	104466	104580
22388	33796	44	applied	\N	\N	\N	\N	104351	104351	104429
22388	33799	45	applied	\N	\N	\N	\N	104364	104364	104581
22370	33820	0	applied	\N	\N	\N	\N	104424	104424	104425
22370	33821	1	applied	\N	\N	\N	\N	104426	104426	104427
22370	33822	2	applied	\N	\N	\N	\N	104428	104428	104429
22370	33823	3	applied	\N	\N	\N	\N	104430	104430	104431
22370	33824	4	applied	\N	\N	\N	\N	104432	104432	104433
22370	33825	5	applied	\N	\N	\N	\N	104434	104434	104435
22370	33826	6	applied	\N	\N	\N	\N	104436	104436	104437
22375	33841	0	applied	\N	\N	\N	\N	104478	104478	104479
22375	33842	1	applied	\N	\N	\N	\N	104480	104480	104481
22375	33843	2	applied	\N	\N	\N	\N	104482	104482	104483
22375	33844	3	applied	\N	\N	\N	\N	104484	104484	104485
22375	33845	4	applied	\N	\N	\N	\N	104486	104486	104487
22375	33846	5	applied	\N	\N	\N	\N	104488	104488	104489
22375	33847	6	applied	\N	\N	\N	\N	104490	104490	104491
22385	33872	0	applied	\N	\N	\N	\N	104559	104559	104560
22385	33873	1	applied	\N	\N	\N	\N	104561	104561	104562
22385	33874	2	applied	\N	\N	\N	\N	104563	104563	104564
22389	33875	0	applied	\N	\N	\N	\N	104606	104606	104607
22389	33876	1	applied	\N	\N	\N	\N	104608	104608	104609
22389	33877	2	applied	\N	\N	\N	\N	104610	104610	104611
22396	33888	0	applied	\N	\N	\N	\N	104644	104644	104645
22396	33889	1	applied	\N	\N	\N	\N	104646	104646	104647
22396	33890	2	applied	\N	\N	\N	\N	104648	104648	104649
22396	33891	3	applied	\N	\N	\N	\N	104650	104650	104651
22406	33905	0	applied	\N	\N	\N	\N	104701	104701	104702
22406	33906	1	applied	\N	\N	\N	\N	104703	104703	104704
22408	33907	0	applied	\N	\N	\N	\N	104707	104707	104708
22408	33909	1	applied	\N	\N	\N	\N	104712	104712	104713
22408	33908	2	applied	\N	\N	\N	\N	104709	104709	104714
22415	33927	0	applied	\N	\N	\N	\N	104758	104758	104759
22415	33928	1	applied	\N	\N	\N	\N	104760	104760	104761
22417	33927	0	applied	\N	\N	\N	\N	104758	104758	104759
22417	33929	1	applied	\N	\N	\N	\N	104763	104763	104764
22417	33928	2	applied	\N	\N	\N	\N	104760	104760	104765
22420	33930	0	applied	\N	\N	\N	\N	104773	104773	104774
22420	33931	1	applied	\N	\N	\N	\N	104775	104775	104776
22423	33932	0	applied	\N	\N	\N	\N	104781	104781	104782
22423	33933	1	applied	\N	\N	\N	\N	104783	104783	104784
22423	33934	2	applied	\N	\N	\N	\N	104785	104785	104786
22423	33935	3	applied	\N	\N	\N	\N	104787	104787	104788
22423	33936	4	applied	\N	\N	\N	\N	104789	104789	104790
22423	33937	5	applied	\N	\N	\N	\N	104791	104791	104792
22423	33938	6	applied	\N	\N	\N	\N	104793	104793	104794
22424	33932	0	applied	\N	\N	\N	\N	104781	104781	104782
22424	33933	1	applied	\N	\N	\N	\N	104783	104783	104784
22424	33934	2	applied	\N	\N	\N	\N	104785	104785	104786
22424	33935	3	applied	\N	\N	\N	\N	104787	104787	104788
22424	33936	4	applied	\N	\N	\N	\N	104789	104789	104790
22424	33937	5	applied	\N	\N	\N	\N	104791	104791	104792
22424	33938	6	applied	\N	\N	\N	\N	104793	104793	104794
22429	33946	0	applied	\N	\N	\N	\N	104817	104817	104818
22429	33947	1	applied	\N	\N	\N	\N	104819	104819	104820
22429	33948	2	applied	\N	\N	\N	\N	104821	104821	104822
22431	33952	0	applied	\N	\N	\N	\N	104834	104834	104835
22431	33953	1	applied	\N	\N	\N	\N	104836	104836	104837
22431	33954	2	applied	\N	\N	\N	\N	104838	104838	104839
22431	33955	3	applied	\N	\N	\N	\N	104840	104840	104841
22438	33963	0	applied	\N	\N	\N	\N	104973	104973	104974
22438	33964	1	applied	\N	\N	\N	\N	104975	104975	104976
22438	33965	2	applied	\N	\N	\N	\N	104977	104977	104978
22438	33966	3	applied	\N	\N	\N	\N	104979	104979	104980
22438	33967	4	applied	\N	\N	\N	\N	104981	104981	104982
22438	33968	5	applied	\N	\N	\N	\N	104983	104983	104984
22438	33969	6	applied	\N	\N	\N	\N	104985	104985	104986
22438	33970	7	applied	\N	\N	\N	\N	104987	104987	104988
22443	33971	0	applied	\N	\N	\N	\N	105023	105023	105024
22443	33972	1	applied	\N	\N	\N	\N	105025	105025	105026
22443	33973	2	applied	\N	\N	\N	\N	105029	105029	105030
22450	33981	0	applied	\N	\N	\N	\N	105054	105054	105055
22450	33982	1	applied	\N	\N	\N	\N	105056	105056	105057
22450	33983	2	applied	\N	\N	\N	\N	105058	105058	105059
22452	33990	0	applied	\N	\N	\N	\N	105076	105076	105077
22452	33991	1	applied	\N	\N	\N	\N	105078	105078	105079
22452	33992	2	applied	\N	\N	\N	\N	105080	105080	105081
22459	33996	0	applied	\N	\N	\N	\N	105096	105096	105097
22459	33997	1	applied	\N	\N	\N	\N	105098	105098	105099
22459	33998	2	applied	\N	\N	\N	\N	105100	105100	105101
22463	34006	0	applied	\N	\N	\N	\N	105124	105124	105125
22463	34007	1	applied	\N	\N	\N	\N	105126	105126	105127
22463	34008	2	applied	\N	\N	\N	\N	105128	105128	105129
22466	34009	0	applied	\N	\N	\N	\N	105131	105131	105132
22466	34010	1	applied	\N	\N	\N	\N	105133	105133	105134
22466	34011	2	applied	\N	\N	\N	\N	105135	105135	105136
22466	34012	3	applied	\N	\N	\N	\N	105137	105137	105138
22470	34013	0	applied	\N	\N	\N	\N	105165	105165	105166
22470	34014	1	applied	\N	\N	\N	\N	105167	105167	105168
22470	34015	2	applied	\N	\N	\N	\N	105170	105170	105171
22472	34016	0	applied	\N	\N	\N	\N	105173	105173	105174
22472	34017	1	applied	\N	\N	\N	\N	105175	105175	105176
22472	34018	2	applied	\N	\N	\N	\N	105177	105177	105178
22472	34019	3	applied	\N	\N	\N	\N	105179	105179	105180
22472	34020	4	applied	\N	\N	\N	\N	105181	105181	105182
22472	34021	5	applied	\N	\N	\N	\N	105183	105183	105184
22472	34022	6	applied	\N	\N	\N	\N	105185	105185	105186
22476	34036	0	applied	\N	\N	\N	\N	105218	105218	105219
22476	34037	1	applied	\N	\N	\N	\N	105220	105220	105221
22476	34038	2	applied	\N	\N	\N	\N	105222	105222	105223
22476	34039	3	applied	\N	\N	\N	\N	105224	105224	105225
22476	34040	4	applied	\N	\N	\N	\N	105226	105226	105227
22476	34041	5	applied	\N	\N	\N	\N	105228	105228	105229
22478	34042	0	applied	\N	\N	\N	\N	105234	105234	105235
22478	34043	1	applied	\N	\N	\N	\N	105236	105236	105237
22478	34044	2	applied	\N	\N	\N	\N	105238	105238	105239
22478	34045	3	applied	\N	\N	\N	\N	105240	105240	105241
22478	34046	4	applied	\N	\N	\N	\N	105242	105242	105243
22478	34047	5	applied	\N	\N	\N	\N	105244	105244	105245
22478	34048	6	applied	\N	\N	\N	\N	105246	105246	105247
22478	34050	7	applied	\N	\N	\N	\N	105251	105251	105252
22478	34049	8	applied	\N	\N	\N	\N	105248	105248	105253
22480	34051	0	applied	\N	\N	\N	\N	105257	105257	105258
22480	34052	1	applied	\N	\N	\N	\N	105259	105259	105260
22480	34053	2	applied	\N	\N	\N	\N	105261	105261	105262
22480	34054	3	applied	\N	\N	\N	\N	105263	105263	105264
22480	34055	4	applied	\N	\N	\N	\N	105265	105265	105266
22480	34056	5	applied	\N	\N	\N	\N	105267	105267	105268
22480	34057	6	applied	\N	\N	\N	\N	105269	105269	105270
22480	34058	7	applied	\N	\N	\N	\N	105271	105271	105272
22490	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22490	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22490	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22388	33803	46	applied	\N	\N	\N	\N	104375	104375	104433
22388	33810	47	applied	\N	\N	\N	\N	104397	104397	104435
22388	33811	48	applied	\N	\N	\N	\N	104399	104399	104437
22388	33812	49	applied	\N	\N	\N	\N	104401	104401	104451
22388	33814	50	applied	\N	\N	\N	\N	104406	104406	104582
22388	33818	51	applied	\N	\N	\N	\N	104418	104418	104583
22388	33840	52	applied	\N	\N	\N	\N	104476	104476	104584
22388	33843	53	applied	\N	\N	\N	\N	104482	104482	104585
22388	33844	54	applied	\N	\N	\N	\N	104484	104484	104586
22388	33855	55	applied	\N	\N	\N	\N	104512	104512	104467
22388	33866	56	applied	\N	\N	\N	\N	104543	104543	104587
22388	33825	57	applied	\N	\N	\N	\N	104434	104434	104588
22388	33826	58	applied	\N	\N	\N	\N	104436	104436	104589
22388	33829	59	applied	\N	\N	\N	\N	104450	104450	104477
22388	33833	60	applied	\N	\N	\N	\N	104460	104460	104590
22388	33845	61	applied	\N	\N	\N	\N	104486	104486	104591
22388	33850	62	applied	\N	\N	\N	\N	104500	104500	104592
22388	33853	63	applied	\N	\N	\N	\N	104506	104506	104491
22388	33856	64	applied	\N	\N	\N	\N	104514	104514	104501
22388	33860	65	applied	\N	\N	\N	\N	104523	104523	104593
22388	33864	66	applied	\N	\N	\N	\N	104535	104535	104594
22388	33868	67	applied	\N	\N	\N	\N	104547	104547	104595
22388	33871	68	applied	\N	\N	\N	\N	104555	104555	104596
22388	33873	69	applied	\N	\N	\N	\N	104561	104561	104522
22388	33837	70	applied	\N	\N	\N	\N	104468	104468	104597
22388	33839	71	applied	\N	\N	\N	\N	104474	104474	104598
22388	33846	72	applied	\N	\N	\N	\N	104488	104488	104599
22388	33847	73	applied	\N	\N	\N	\N	104490	104490	104536
22388	33851	74	applied	\N	\N	\N	\N	104502	104502	104600
22388	33852	75	applied	\N	\N	\N	\N	104504	104504	104601
22388	33857	76	applied	\N	\N	\N	\N	104516	104516	104548
22388	33859	77	applied	\N	\N	\N	\N	104521	104521	104554
22388	33863	78	applied	\N	\N	\N	\N	104533	104533	104602
22388	33867	79	applied	\N	\N	\N	\N	104545	104545	104603
22388	33870	80	applied	\N	\N	\N	\N	104553	104553	104562
22388	33874	81	applied	\N	\N	\N	\N	104563	104563	104564
22393	33878	0	applied	\N	\N	\N	\N	104617	104617	104618
22393	33879	1	applied	\N	\N	\N	\N	104619	104619	104620
22393	33880	2	applied	\N	\N	\N	\N	104621	104621	104622
22393	33881	3	applied	\N	\N	\N	\N	104623	104623	104624
22395	33885	0	applied	\N	\N	\N	\N	104636	104636	104637
22395	33886	1	applied	\N	\N	\N	\N	104638	104638	104639
22395	33887	2	applied	\N	\N	\N	\N	104640	104640	104641
22398	33892	0	applied	\N	\N	\N	\N	104653	104653	104654
22398	33893	1	applied	\N	\N	\N	\N	104655	104655	104656
22398	33894	2	applied	\N	\N	\N	\N	104657	104657	104658
22398	33895	3	applied	\N	\N	\N	\N	104659	104659	104660
22398	33896	4	applied	\N	\N	\N	\N	104661	104661	104662
22398	33897	5	applied	\N	\N	\N	\N	104663	104663	104664
22402	33898	0	applied	\N	\N	\N	\N	104670	104670	104671
22402	33899	1	applied	\N	\N	\N	\N	104672	104672	104673
22402	33900	2	applied	\N	\N	\N	\N	104674	104674	104675
22402	33901	3	applied	\N	\N	\N	\N	104676	104676	104677
22402	33902	4	applied	\N	\N	\N	\N	104678	104678	104679
22402	33903	5	applied	\N	\N	\N	\N	104680	104680	104681
22402	33904	6	applied	\N	\N	\N	\N	104682	104682	104683
22404	33875	0	applied	\N	\N	\N	\N	104606	104606	104607
22404	33878	1	applied	\N	\N	\N	\N	104617	104617	104618
22404	33882	2	applied	\N	\N	\N	\N	104628	104628	104629
22404	33885	3	applied	\N	\N	\N	\N	104636	104636	104637
22404	33888	4	applied	\N	\N	\N	\N	104644	104644	104645
22404	33892	5	applied	\N	\N	\N	\N	104653	104653	104654
22404	33893	6	applied	\N	\N	\N	\N	104655	104655	104656
22404	33898	7	applied	\N	\N	\N	\N	104670	104670	104671
22404	33879	8	applied	\N	\N	\N	\N	104619	104619	104688
22404	33876	9	applied	\N	\N	\N	\N	104608	104608	104689
22404	33880	10	applied	\N	\N	\N	\N	104621	104621	104690
22404	33877	11	applied	\N	\N	\N	\N	104610	104610	104622
22404	33881	12	applied	\N	\N	\N	\N	104623	104623	104624
22404	33883	13	applied	\N	\N	\N	\N	104630	104630	104631
22404	33886	14	applied	\N	\N	\N	\N	104638	104638	104691
22404	33890	15	applied	\N	\N	\N	\N	104648	104648	104692
22404	33894	16	applied	\N	\N	\N	\N	104657	104657	104693
22404	33895	17	applied	\N	\N	\N	\N	104659	104659	104641
22404	33900	18	applied	\N	\N	\N	\N	104674	104674	104694
22404	33884	19	applied	\N	\N	\N	\N	104632	104632	104649
22404	33887	20	applied	\N	\N	\N	\N	104640	104640	104658
22404	33889	21	applied	\N	\N	\N	\N	104646	104646	104695
22404	33896	22	applied	\N	\N	\N	\N	104661	104661	104696
22404	33891	23	applied	\N	\N	\N	\N	104650	104650	104697
22404	33897	24	applied	\N	\N	\N	\N	104663	104663	104675
22404	33902	25	applied	\N	\N	\N	\N	104678	104678	104698
22412	33910	0	applied	\N	\N	\N	\N	104718	104718	104719
22412	33911	1	applied	\N	\N	\N	\N	104720	104720	104721
22412	33912	2	applied	\N	\N	\N	\N	104722	104722	104723
22412	33913	3	applied	\N	\N	\N	\N	104724	104724	104725
22412	33914	4	applied	\N	\N	\N	\N	104726	104726	104727
22412	33915	5	applied	\N	\N	\N	\N	104728	104728	104729
22412	33916	6	applied	\N	\N	\N	\N	104730	104730	104731
22412	33917	7	applied	\N	\N	\N	\N	104732	104732	104733
22412	33918	8	applied	\N	\N	\N	\N	104734	104734	104735
22412	33919	9	applied	\N	\N	\N	\N	104736	104736	104737
22414	33924	0	applied	\N	\N	\N	\N	104751	104751	104752
22414	33925	1	applied	\N	\N	\N	\N	104753	104753	104754
22414	33926	2	applied	\N	\N	\N	\N	104755	104755	104756
22421	33932	0	applied	\N	\N	\N	\N	104781	104781	104782
22421	33933	1	applied	\N	\N	\N	\N	104783	104783	104784
22421	33934	2	applied	\N	\N	\N	\N	104785	104785	104786
22421	33935	3	applied	\N	\N	\N	\N	104787	104787	104788
22421	33936	4	applied	\N	\N	\N	\N	104789	104789	104790
22421	33937	5	applied	\N	\N	\N	\N	104791	104791	104792
22421	33938	6	applied	\N	\N	\N	\N	104793	104793	104794
22428	33946	0	applied	\N	\N	\N	\N	104817	104817	104818
22428	33947	1	applied	\N	\N	\N	\N	104819	104819	104820
22428	33948	2	applied	\N	\N	\N	\N	104821	104821	104822
22430	33949	0	applied	\N	\N	\N	\N	104826	104826	104827
22430	33950	1	applied	\N	\N	\N	\N	104828	104828	104829
22430	33951	2	applied	\N	\N	\N	\N	104830	104830	104831
22433	33956	0	applied	\N	\N	\N	\N	104844	104844	104845
22433	33957	1	applied	\N	\N	\N	\N	104846	104846	104847
22433	33958	2	applied	\N	\N	\N	\N	104848	104848	104849
22433	33959	3	applied	\N	\N	\N	\N	104850	104850	104851
22446	33977	0	applied	\N	\N	\N	\N	105042	105042	105043
22446	33978	1	applied	\N	\N	\N	\N	105044	105044	105045
22446	33979	2	applied	\N	\N	\N	\N	105046	105046	105047
22446	33980	3	applied	\N	\N	\N	\N	105048	105048	105049
22448	33981	0	applied	\N	\N	\N	\N	105054	105054	105055
22448	33982	1	applied	\N	\N	\N	\N	105056	105056	105057
22448	33983	2	applied	\N	\N	\N	\N	105058	105058	105059
22455	33993	0	applied	\N	\N	\N	\N	105088	105088	105089
22418	33913	6	applied	\N	\N	\N	\N	104724	104724	104768
22418	33909	7	applied	\N	\N	\N	\N	104712	104712	104725
22418	33923	8	applied	\N	\N	\N	\N	104748	104748	104769
22418	33914	9	applied	\N	\N	\N	\N	104726	104726	104770
22418	33917	10	applied	\N	\N	\N	\N	104732	104732	104731
22418	33918	11	applied	\N	\N	\N	\N	104734	104734	104733
22418	33919	12	applied	\N	\N	\N	\N	104736	104736	104735
22418	33922	13	applied	\N	\N	\N	\N	104746	104746	104737
22418	33925	14	applied	\N	\N	\N	\N	104753	104753	104771
22418	33928	15	applied	\N	\N	\N	\N	104760	104760	104749
22432	33956	0	applied	\N	\N	\N	\N	104844	104844	104845
22432	33957	1	applied	\N	\N	\N	\N	104846	104846	104847
22432	33958	2	applied	\N	\N	\N	\N	104848	104848	104849
22432	33959	3	applied	\N	\N	\N	\N	104850	104850	104851
22436	33960	0	applied	\N	\N	\N	\N	104859	104859	104860
22436	33961	1	applied	\N	\N	\N	\N	104861	104861	104862
22436	33962	2	applied	\N	\N	\N	\N	104863	104863	104864
22439	33963	0	applied	\N	\N	\N	\N	104973	104973	104974
22439	33964	1	applied	\N	\N	\N	\N	104975	104975	104976
22439	33965	2	applied	\N	\N	\N	\N	104977	104977	104978
22439	33966	3	applied	\N	\N	\N	\N	104979	104979	104980
22439	33967	4	applied	\N	\N	\N	\N	104981	104981	104982
22439	33968	5	applied	\N	\N	\N	\N	104983	104983	104984
22439	33969	6	applied	\N	\N	\N	\N	104985	104985	104986
22439	33970	7	applied	\N	\N	\N	\N	104987	104987	104988
22441	33971	0	applied	\N	\N	\N	\N	105023	105023	105024
22441	33972	1	applied	\N	\N	\N	\N	105025	105025	105026
22445	33974	0	applied	\N	\N	\N	\N	105034	105034	105035
22445	33975	1	applied	\N	\N	\N	\N	105036	105036	105037
22445	33976	2	applied	\N	\N	\N	\N	105038	105038	105039
22453	33990	0	applied	\N	\N	\N	\N	105076	105076	105077
22453	33991	1	applied	\N	\N	\N	\N	105078	105078	105079
22453	33992	2	applied	\N	\N	\N	\N	105080	105080	105081
22457	33993	0	applied	\N	\N	\N	\N	105088	105088	105089
22457	33991	1	applied	\N	\N	\N	\N	105078	105078	105081
22457	33994	2	applied	\N	\N	\N	\N	105090	105090	105091
22457	33995	3	applied	\N	\N	\N	\N	105092	105092	105093
22461	33999	0	applied	\N	\N	\N	\N	105104	105104	105105
22461	34002	1	applied	\N	\N	\N	\N	105112	105112	105113
22461	34000	2	applied	\N	\N	\N	\N	105106	105106	105114
22461	34001	3	applied	\N	\N	\N	\N	105108	105108	105115
22464	34006	0	applied	\N	\N	\N	\N	105124	105124	105125
22464	34007	1	applied	\N	\N	\N	\N	105126	105126	105127
22464	34008	2	applied	\N	\N	\N	\N	105128	105128	105129
22468	34013	0	applied	\N	\N	\N	\N	105165	105165	105166
22468	34014	1	applied	\N	\N	\N	\N	105167	105167	105168
22485	34077	0	applied	\N	\N	\N	\N	105315	105315	105316
22485	34078	1	applied	\N	\N	\N	\N	105317	105317	105318
22485	34079	2	applied	\N	\N	\N	\N	105319	105319	105320
22485	34080	3	applied	\N	\N	\N	\N	105321	105321	105322
22485	34081	4	applied	\N	\N	\N	\N	105323	105323	105324
22485	34082	5	applied	\N	\N	\N	\N	105325	105325	105326
22485	34083	6	applied	\N	\N	\N	\N	105327	105327	105328
22485	34084	7	applied	\N	\N	\N	\N	105329	105329	105330
22485	34086	8	applied	\N	\N	\N	\N	105336	105336	105337
22485	34085	9	applied	\N	\N	\N	\N	105331	105331	105338
22488	34105	0	applied	\N	\N	\N	\N	105378	105378	105379
22488	34106	1	applied	\N	\N	\N	\N	105380	105380	105381
22488	34107	2	applied	\N	\N	\N	\N	105382	105382	105383
22488	34108	3	applied	\N	\N	\N	\N	105384	105384	105385
22488	34109	4	applied	\N	\N	\N	\N	105386	105386	105387
22488	34110	5	applied	\N	\N	\N	\N	105388	105388	105389
22488	34111	6	applied	\N	\N	\N	\N	105390	105390	105391
22488	34112	7	applied	\N	\N	\N	\N	105392	105392	105393
22488	34113	8	applied	\N	\N	\N	\N	105394	105394	105395
22491	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22491	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22491	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22491	34117	3	applied	\N	\N	\N	\N	105403	105403	105404
22491	34118	4	applied	\N	\N	\N	\N	105405	105405	105406
22491	34119	5	applied	\N	\N	\N	\N	105407	105407	105408
22491	34120	6	applied	\N	\N	\N	\N	105409	105409	105410
22491	34121	7	applied	\N	\N	\N	\N	105411	105411	105412
22497	34122	0	applied	\N	\N	\N	\N	105424	105424	105425
22497	34123	1	applied	\N	\N	\N	\N	105426	105426	105427
22497	34124	2	applied	\N	\N	\N	\N	105428	105428	105429
22497	34125	3	applied	\N	\N	\N	\N	105430	105430	105431
22502	34153	0	applied	\N	\N	\N	\N	105496	105496	105497
22502	34154	1	applied	\N	\N	\N	\N	105498	105498	105499
22502	34155	2	applied	\N	\N	\N	\N	105500	105500	105501
22502	34156	3	applied	\N	\N	\N	\N	105502	105502	105503
22502	34157	4	applied	\N	\N	\N	\N	105504	105504	105505
22502	34158	5	applied	\N	\N	\N	\N	105506	105506	105507
22502	34159	6	applied	\N	\N	\N	\N	105508	105508	105509
22502	34160	7	applied	\N	\N	\N	\N	105510	105510	105511
22502	34161	8	applied	\N	\N	\N	\N	105512	105512	105513
22504	34162	0	applied	\N	\N	\N	\N	105517	105517	105518
22504	34163	1	applied	\N	\N	\N	\N	105519	105519	105520
22504	34164	2	applied	\N	\N	\N	\N	105521	105521	105522
22504	34165	3	applied	\N	\N	\N	\N	105523	105523	105524
22504	34166	4	applied	\N	\N	\N	\N	105525	105525	105526
22504	34167	5	applied	\N	\N	\N	\N	105527	105527	105528
22504	34168	6	applied	\N	\N	\N	\N	105529	105529	105530
22504	34169	7	applied	\N	\N	\N	\N	105531	105531	105532
22504	34170	8	applied	\N	\N	\N	\N	105533	105533	105534
22504	34171	9	applied	\N	\N	\N	\N	105535	105535	105536
22504	34172	10	applied	\N	\N	\N	\N	105537	105537	105538
22504	34173	11	applied	\N	\N	\N	\N	105539	105539	105540
22504	34174	12	applied	\N	\N	\N	\N	105541	105541	105542
22504	34175	13	applied	\N	\N	\N	\N	105543	105543	105544
22504	34176	14	applied	\N	\N	\N	\N	105545	105545	105546
22504	34177	15	applied	\N	\N	\N	\N	105547	105547	105548
22504	34178	16	applied	\N	\N	\N	\N	105549	105549	105550
22509	34182	0	applied	\N	\N	\N	\N	105566	105566	105567
22509	34190	1	applied	\N	\N	\N	\N	105586	105586	105587
22509	34183	2	applied	\N	\N	\N	\N	105568	105568	105569
22509	34184	3	applied	\N	\N	\N	\N	105570	105570	105571
22509	34185	4	applied	\N	\N	\N	\N	105572	105572	105573
22509	34186	5	applied	\N	\N	\N	\N	105574	105574	105575
22509	34187	6	applied	\N	\N	\N	\N	105576	105576	105577
22509	34191	7	applied	\N	\N	\N	\N	105588	105588	105589
22509	34192	8	applied	\N	\N	\N	\N	105590	105590	105591
22509	34193	9	applied	\N	\N	\N	\N	105592	105592	105593
22509	34194	10	applied	\N	\N	\N	\N	105594	105594	105595
22509	34195	11	applied	\N	\N	\N	\N	105596	105596	105597
22509	34196	12	applied	\N	\N	\N	\N	105598	105598	105599
22509	34188	13	applied	\N	\N	\N	\N	105578	105578	105579
22509	34179	14	applied	\N	\N	\N	\N	105553	105553	105580
22509	34197	15	applied	\N	\N	\N	\N	105600	105600	105601
22509	34198	16	applied	\N	\N	\N	\N	105602	105602	105583
22422	33936	4	applied	\N	\N	\N	\N	104789	104789	104790
22426	33939	0	applied	\N	\N	\N	\N	104801	104801	104802
22426	33940	1	applied	\N	\N	\N	\N	104803	104803	104804
22426	33941	2	applied	\N	\N	\N	\N	104805	104805	104806
22426	33942	3	applied	\N	\N	\N	\N	104807	104807	104808
22426	33943	4	applied	\N	\N	\N	\N	104809	104809	104810
22426	33944	5	applied	\N	\N	\N	\N	104811	104811	104812
22426	33945	6	applied	\N	\N	\N	\N	104813	104813	104814
22434	33956	0	applied	\N	\N	\N	\N	104844	104844	104845
22434	33957	1	applied	\N	\N	\N	\N	104846	104846	104847
22434	33958	2	applied	\N	\N	\N	\N	104848	104848	104849
22434	33959	3	applied	\N	\N	\N	\N	104850	104850	104851
22435	33787	0	applied	\N	\N	\N	\N	104329	104329	104330
22435	33790	1	applied	\N	\N	\N	\N	104335	104335	104336
22435	33794	2	applied	\N	\N	\N	\N	104347	104347	104348
22435	33797	3	applied	\N	\N	\N	\N	104360	104360	104361
22435	33800	4	applied	\N	\N	\N	\N	104368	104368	104369
22435	33804	5	applied	\N	\N	\N	\N	104385	104385	104386
22435	33805	6	applied	\N	\N	\N	\N	104387	104387	104388
22435	33806	7	applied	\N	\N	\N	\N	104389	104389	104390
22435	33813	8	applied	\N	\N	\N	\N	104404	104404	104405
22435	33817	9	applied	\N	\N	\N	\N	104416	104416	104417
22435	33820	10	applied	\N	\N	\N	\N	104424	104424	104425
22435	33821	11	applied	\N	\N	\N	\N	104426	104426	104427
22437	33689	0	applied	\N	\N	\N	\N	104040	104040	104041
22437	33697	1	applied	\N	\N	\N	\N	104059	104059	104060
22437	33698	2	applied	\N	\N	\N	\N	104061	104061	104062
22437	33673	3	applied	\N	\N	\N	\N	103999	103999	104867
22437	33677	4	applied	\N	\N	\N	\N	104008	104008	104868
22437	33680	5	applied	\N	\N	\N	\N	104016	104016	104869
22437	33683	6	applied	\N	\N	\N	\N	104024	104024	104870
22437	33687	7	applied	\N	\N	\N	\N	104036	104036	104871
22437	33688	8	applied	\N	\N	\N	\N	104038	104038	104872
22437	33695	9	applied	\N	\N	\N	\N	104055	104055	104873
22437	33696	10	applied	\N	\N	\N	\N	104057	104057	104874
22437	33707	11	applied	\N	\N	\N	\N	104081	104081	104875
22437	33708	12	applied	\N	\N	\N	\N	104083	104083	104876
22437	33709	13	applied	\N	\N	\N	\N	104085	104085	104877
22437	33718	14	applied	\N	\N	\N	\N	104111	104111	104878
22437	33719	15	applied	\N	\N	\N	\N	104113	104113	104879
22437	33725	16	applied	\N	\N	\N	\N	104136	104136	104880
22437	33729	17	applied	\N	\N	\N	\N	104153	104153	104881
22437	33730	18	applied	\N	\N	\N	\N	104155	104155	104882
22437	33731	19	applied	\N	\N	\N	\N	104157	104157	104883
22437	33739	20	applied	\N	\N	\N	\N	104178	104178	104884
22437	33740	21	applied	\N	\N	\N	\N	104180	104180	104885
22437	33745	22	applied	\N	\N	\N	\N	104193	104193	104886
22437	33746	23	applied	\N	\N	\N	\N	104195	104195	104887
22437	33752	24	applied	\N	\N	\N	\N	104208	104208	104888
22437	33755	25	applied	\N	\N	\N	\N	104216	104216	104889
22437	33758	26	applied	\N	\N	\N	\N	104222	104222	104890
22437	33762	27	applied	\N	\N	\N	\N	104232	104232	104891
22437	33763	28	applied	\N	\N	\N	\N	104234	104234	104892
22437	33764	29	applied	\N	\N	\N	\N	104236	104236	104893
22437	33772	30	applied	\N	\N	\N	\N	104256	104256	104894
22437	33773	31	applied	\N	\N	\N	\N	104258	104258	104895
22437	33778	32	applied	\N	\N	\N	\N	104274	104274	104896
22437	33781	33	applied	\N	\N	\N	\N	104284	104284	104897
22437	33785	34	applied	\N	\N	\N	\N	104298	104298	104898
22437	33787	35	applied	\N	\N	\N	\N	104329	104329	104899
22437	33790	36	applied	\N	\N	\N	\N	104335	104335	104900
22437	33794	37	applied	\N	\N	\N	\N	104347	104347	104901
22437	33797	38	applied	\N	\N	\N	\N	104360	104360	104902
22437	33800	39	applied	\N	\N	\N	\N	104368	104368	104903
22437	33804	40	applied	\N	\N	\N	\N	104385	104385	104904
22437	33805	41	applied	\N	\N	\N	\N	104387	104387	104905
22437	33806	42	applied	\N	\N	\N	\N	104389	104389	104906
22437	33813	43	applied	\N	\N	\N	\N	104404	104404	104907
22437	33817	44	applied	\N	\N	\N	\N	104416	104416	104908
22437	33820	45	applied	\N	\N	\N	\N	104424	104424	104909
22437	33821	46	applied	\N	\N	\N	\N	104426	104426	104910
22437	33827	47	applied	\N	\N	\N	\N	104444	104444	104911
22437	33828	48	applied	\N	\N	\N	\N	104448	104448	104912
22437	33831	49	applied	\N	\N	\N	\N	104456	104456	104913
22437	33832	50	applied	\N	\N	\N	\N	104458	104458	104914
22437	33838	51	applied	\N	\N	\N	\N	104472	104472	104915
22437	33841	52	applied	\N	\N	\N	\N	104478	104478	104916
22437	33842	53	applied	\N	\N	\N	\N	104480	104480	104917
22437	33848	54	applied	\N	\N	\N	\N	104496	104496	104918
22437	33849	55	applied	\N	\N	\N	\N	104498	104498	104919
22437	33854	56	applied	\N	\N	\N	\N	104510	104510	104920
22437	33858	57	applied	\N	\N	\N	\N	104519	104519	104921
22437	33861	58	applied	\N	\N	\N	\N	104529	104529	104922
22437	33865	59	applied	\N	\N	\N	\N	104541	104541	104923
22437	33869	60	applied	\N	\N	\N	\N	104551	104551	104924
22437	33872	61	applied	\N	\N	\N	\N	104559	104559	104925
22437	33875	62	applied	\N	\N	\N	\N	104606	104606	104926
22437	33878	63	applied	\N	\N	\N	\N	104617	104617	104927
22437	33882	64	applied	\N	\N	\N	\N	104628	104628	104928
22437	33885	65	applied	\N	\N	\N	\N	104636	104636	104929
22437	33888	66	applied	\N	\N	\N	\N	104644	104644	104930
22437	33892	67	applied	\N	\N	\N	\N	104653	104653	104931
22437	33893	68	applied	\N	\N	\N	\N	104655	104655	104932
22437	33898	69	applied	\N	\N	\N	\N	104670	104670	104933
22437	33899	70	applied	\N	\N	\N	\N	104672	104672	104934
22437	33905	71	applied	\N	\N	\N	\N	104701	104701	104935
22437	33907	72	applied	\N	\N	\N	\N	104707	104707	104936
22437	33910	73	applied	\N	\N	\N	\N	104718	104718	104937
22437	33911	74	applied	\N	\N	\N	\N	104720	104720	104938
22437	33912	75	applied	\N	\N	\N	\N	104722	104722	104939
22437	33920	76	applied	\N	\N	\N	\N	104742	104742	104940
22437	33924	77	applied	\N	\N	\N	\N	104751	104751	104941
22437	33927	78	applied	\N	\N	\N	\N	104758	104758	104942
22437	33930	79	applied	\N	\N	\N	\N	104773	104773	104943
22437	33932	80	applied	\N	\N	\N	\N	104781	104781	104944
22437	33933	81	applied	\N	\N	\N	\N	104783	104783	104945
22437	33939	82	applied	\N	\N	\N	\N	104801	104801	104946
22437	33940	83	applied	\N	\N	\N	\N	104803	104803	104947
22437	33946	84	applied	\N	\N	\N	\N	104817	104817	104948
22437	33949	85	applied	\N	\N	\N	\N	104826	104826	104949
22437	33952	86	applied	\N	\N	\N	\N	104834	104834	104950
22437	33956	87	applied	\N	\N	\N	\N	104844	104844	104951
22437	33960	88	applied	\N	\N	\N	\N	104859	104859	104952
22437	33862	89	applied	\N	\N	\N	\N	104531	104531	104532
22437	33674	90	applied	\N	\N	\N	\N	104001	104001	104002
22437	33690	91	applied	\N	\N	\N	\N	104042	104042	104043
22437	33675	92	applied	\N	\N	\N	\N	104003	104003	104004
22437	33701	94	applied	\N	\N	\N	\N	104067	104067	104068
22437	33679	95	applied	\N	\N	\N	\N	104012	104012	104954
22437	33682	96	applied	\N	\N	\N	\N	104020	104020	104955
22437	33685	97	applied	\N	\N	\N	\N	104028	104028	104019
22437	33691	98	applied	\N	\N	\N	\N	104044	104044	104021
22437	33692	99	applied	\N	\N	\N	\N	104046	104046	104956
22437	33686	100	applied	\N	\N	\N	\N	104030	104030	104957
22437	33700	101	applied	\N	\N	\N	\N	104065	104065	104029
22437	33714	102	applied	\N	\N	\N	\N	104096	104096	104031
22437	33702	103	applied	\N	\N	\N	\N	104069	104069	104045
22437	33676	104	applied	\N	\N	\N	\N	104005	104005	104958
22437	33678	105	applied	\N	\N	\N	\N	104010	104010	104959
22437	33681	106	applied	\N	\N	\N	\N	104018	104018	104960
22437	33684	107	applied	\N	\N	\N	\N	104026	104026	104961
22437	33703	108	applied	\N	\N	\N	\N	104071	104071	104072
22437	33704	109	applied	\N	\N	\N	\N	104073	104073	104074
22437	33712	110	applied	\N	\N	\N	\N	104091	104091	104092
22437	33705	111	applied	\N	\N	\N	\N	104075	104075	104962
22437	33710	112	applied	\N	\N	\N	\N	104087	104087	104963
22437	33711	113	applied	\N	\N	\N	\N	104089	104089	104964
22437	33713	114	applied	\N	\N	\N	\N	104093	104093	104965
22437	33722	115	applied	\N	\N	\N	\N	104119	104119	104966
22437	33723	116	applied	\N	\N	\N	\N	104121	104121	104967
22437	33728	117	applied	\N	\N	\N	\N	104147	104147	104968
22437	33736	118	applied	\N	\N	\N	\N	104167	104167	104101
22437	33737	119	applied	\N	\N	\N	\N	104169	104169	104969
22437	33738	120	applied	\N	\N	\N	\N	104171	104171	104118
22437	33743	121	applied	\N	\N	\N	\N	104188	104188	104120
22437	33744	122	applied	\N	\N	\N	\N	104190	104190	104122
22437	33747	123	applied	\N	\N	\N	\N	104197	104197	104151
22437	33748	124	applied	\N	\N	\N	\N	104199	104199	104149
22437	33754	125	applied	\N	\N	\N	\N	104212	104212	104970
22440	33875	0	applied	\N	\N	\N	\N	104606	104606	104607
22440	33878	1	applied	\N	\N	\N	\N	104617	104617	104618
22440	33882	2	applied	\N	\N	\N	\N	104628	104628	104629
22440	33885	3	applied	\N	\N	\N	\N	104636	104636	104637
22440	33888	4	applied	\N	\N	\N	\N	104644	104644	104645
22440	33892	5	applied	\N	\N	\N	\N	104653	104653	104654
22440	33893	6	applied	\N	\N	\N	\N	104655	104655	104656
22440	33898	7	applied	\N	\N	\N	\N	104670	104670	104671
22440	33899	8	applied	\N	\N	\N	\N	104672	104672	104673
22440	33905	9	applied	\N	\N	\N	\N	104701	104701	104702
22440	33907	10	applied	\N	\N	\N	\N	104707	104707	104708
22440	33910	11	applied	\N	\N	\N	\N	104718	104718	104719
22440	33911	12	applied	\N	\N	\N	\N	104720	104720	104721
22440	33912	13	applied	\N	\N	\N	\N	104722	104722	104723
22440	33920	14	applied	\N	\N	\N	\N	104742	104742	104743
22440	33924	15	applied	\N	\N	\N	\N	104751	104751	104752
22440	33927	16	applied	\N	\N	\N	\N	104758	104758	104759
22440	33930	17	applied	\N	\N	\N	\N	104773	104773	104774
22440	33932	18	applied	\N	\N	\N	\N	104781	104781	104782
22440	33933	19	applied	\N	\N	\N	\N	104783	104783	104784
22440	33939	21	applied	\N	\N	\N	\N	104801	104801	104802
22440	33940	22	applied	\N	\N	\N	\N	104803	104803	104804
22440	33946	23	applied	\N	\N	\N	\N	104817	104817	104818
22440	33949	24	applied	\N	\N	\N	\N	104826	104826	104827
22440	33952	25	applied	\N	\N	\N	\N	104834	104834	104835
22440	33956	26	applied	\N	\N	\N	\N	104844	104844	104845
22440	33960	27	applied	\N	\N	\N	\N	104859	104859	104860
22440	33963	28	applied	\N	\N	\N	\N	104973	104973	104974
22440	33964	29	applied	\N	\N	\N	\N	104975	104975	104976
22440	33879	30	applied	\N	\N	\N	\N	104619	104619	104688
22440	33876	31	applied	\N	\N	\N	\N	104608	104608	104689
22440	33880	32	applied	\N	\N	\N	\N	104621	104621	104690
22440	33877	33	applied	\N	\N	\N	\N	104610	104610	104622
22440	33881	34	applied	\N	\N	\N	\N	104623	104623	104624
22440	33883	35	applied	\N	\N	\N	\N	104630	104630	104631
22440	33886	36	applied	\N	\N	\N	\N	104638	104638	104691
22440	33890	37	applied	\N	\N	\N	\N	104648	104648	104692
22440	33894	38	applied	\N	\N	\N	\N	104657	104657	104693
22440	33895	39	applied	\N	\N	\N	\N	104659	104659	104641
22440	33900	40	applied	\N	\N	\N	\N	104674	104674	104694
22440	33904	41	applied	\N	\N	\N	\N	104682	104682	104993
22440	33906	42	applied	\N	\N	\N	\N	104703	104703	104651
22440	33909	43	applied	\N	\N	\N	\N	104712	104712	104658
22440	33884	44	applied	\N	\N	\N	\N	104632	104632	104695
22440	33887	45	applied	\N	\N	\N	\N	104640	104640	104696
22440	33889	46	applied	\N	\N	\N	\N	104646	104646	104994
22440	33896	47	applied	\N	\N	\N	\N	104661	104661	104995
22440	33914	48	applied	\N	\N	\N	\N	104726	104726	104679
22440	33915	49	applied	\N	\N	\N	\N	104728	104728	104996
22440	33916	50	applied	\N	\N	\N	\N	104730	104730	104997
22440	33921	51	applied	\N	\N	\N	\N	104744	104744	104998
22440	33926	52	applied	\N	\N	\N	\N	104755	104755	104999
22440	33929	53	applied	\N	\N	\N	\N	104763	104763	104710
22440	33931	54	applied	\N	\N	\N	\N	104775	104775	104714
22440	33891	55	applied	\N	\N	\N	\N	104650	104650	104725
22440	33901	56	applied	\N	\N	\N	\N	104676	104676	104769
22440	33913	57	applied	\N	\N	\N	\N	104724	104724	104727
22440	33923	58	applied	\N	\N	\N	\N	104748	104748	104770
22440	33935	59	applied	\N	\N	\N	\N	104787	104787	104729
22440	33941	60	applied	\N	\N	\N	\N	104805	104805	105000
22440	33954	61	applied	\N	\N	\N	\N	104838	104838	104731
22440	33966	62	applied	\N	\N	\N	\N	104979	104979	105001
22440	33958	63	applied	\N	\N	\N	\N	104848	104848	104849
22440	33965	64	applied	\N	\N	\N	\N	104977	104977	104978
22440	33937	65	applied	\N	\N	\N	\N	104791	104791	104733
22440	33938	66	applied	\N	\N	\N	\N	104793	104793	105002
22440	33942	67	applied	\N	\N	\N	\N	104807	104807	105003
22440	33943	68	applied	\N	\N	\N	\N	104809	104809	104737
22440	33948	69	applied	\N	\N	\N	\N	104821	104821	104745
22440	33951	70	applied	\N	\N	\N	\N	104830	104830	105004
22440	33955	71	applied	\N	\N	\N	\N	104840	104840	104749
22440	33957	72	applied	\N	\N	\N	\N	104846	104846	105005
22440	33962	73	applied	\N	\N	\N	\N	104863	104863	105006
22440	33967	74	applied	\N	\N	\N	\N	104981	104981	105007
22440	33968	75	applied	\N	\N	\N	\N	104983	104983	104761
22440	33897	76	applied	\N	\N	\N	\N	104663	104663	105008
22440	33902	77	applied	\N	\N	\N	\N	104678	104678	105009
22440	33903	78	applied	\N	\N	\N	\N	104680	104680	105010
22440	33908	79	applied	\N	\N	\N	\N	104709	104709	105011
22440	33917	80	applied	\N	\N	\N	\N	104732	104732	104794
22440	33918	81	applied	\N	\N	\N	\N	104734	104734	104808
22440	33919	82	applied	\N	\N	\N	\N	104736	104736	105012
22440	33922	83	applied	\N	\N	\N	\N	104746	104746	105013
22440	33925	84	applied	\N	\N	\N	\N	104753	104753	105014
22440	33928	85	applied	\N	\N	\N	\N	104760	104760	105015
22440	33934	86	applied	\N	\N	\N	\N	104785	104785	105016
22440	33936	87	applied	\N	\N	\N	\N	104789	104789	104831
22440	33944	88	applied	\N	\N	\N	\N	104811	104811	104837
22440	33945	89	applied	\N	\N	\N	\N	104813	104813	104841
22440	33947	90	applied	\N	\N	\N	\N	104819	104819	105017
22440	33950	91	applied	\N	\N	\N	\N	104828	104828	105018
22440	33953	92	applied	\N	\N	\N	\N	104836	104836	105019
22440	33959	93	applied	\N	\N	\N	\N	104850	104850	105020
22440	33961	94	applied	\N	\N	\N	\N	104861	104861	104984
22440	33969	95	applied	\N	\N	\N	\N	104985	104985	104986
22440	33970	96	applied	\N	\N	\N	\N	104987	104987	104988
22442	33971	0	applied	\N	\N	\N	\N	105023	105023	105024
22442	33972	1	applied	\N	\N	\N	\N	105025	105025	105026
22442	33973	2	applied	\N	\N	\N	\N	105029	105029	105030
22444	33974	0	applied	\N	\N	\N	\N	105034	105034	105035
22444	33975	1	applied	\N	\N	\N	\N	105036	105036	105037
22444	33976	2	applied	\N	\N	\N	\N	105038	105038	105039
22447	33977	0	applied	\N	\N	\N	\N	105042	105042	105043
22447	33978	1	applied	\N	\N	\N	\N	105044	105044	105045
22447	33979	2	applied	\N	\N	\N	\N	105046	105046	105047
22447	33980	3	applied	\N	\N	\N	\N	105048	105048	105049
22449	33981	0	applied	\N	\N	\N	\N	105054	105054	105055
22449	33982	1	applied	\N	\N	\N	\N	105056	105056	105057
22449	33983	2	applied	\N	\N	\N	\N	105058	105058	105059
22451	33984	0	applied	\N	\N	\N	\N	105062	105062	105063
22451	33985	1	applied	\N	\N	\N	\N	105064	105064	105065
22451	33986	2	applied	\N	\N	\N	\N	105066	105066	105067
22451	33987	3	applied	\N	\N	\N	\N	105068	105068	105069
22451	33988	4	applied	\N	\N	\N	\N	105070	105070	105071
22451	33989	5	applied	\N	\N	\N	\N	105072	105072	105073
22454	33990	0	applied	\N	\N	\N	\N	105076	105076	105077
22454	33992	1	applied	\N	\N	\N	\N	105080	105080	105086
22456	33993	0	applied	\N	\N	\N	\N	105088	105088	105089
22456	33991	1	applied	\N	\N	\N	\N	105078	105078	105081
22456	33994	2	applied	\N	\N	\N	\N	105090	105090	105091
22456	33995	3	applied	\N	\N	\N	\N	105092	105092	105093
22458	33996	0	applied	\N	\N	\N	\N	105096	105096	105097
22458	33997	1	applied	\N	\N	\N	\N	105098	105098	105099
22458	33998	2	applied	\N	\N	\N	\N	105100	105100	105101
22460	33999	0	applied	\N	\N	\N	\N	105104	105104	105105
22460	34000	1	applied	\N	\N	\N	\N	105106	105106	105107
22460	34001	2	applied	\N	\N	\N	\N	105108	105108	105109
22465	34009	0	applied	\N	\N	\N	\N	105131	105131	105132
22465	34010	1	applied	\N	\N	\N	\N	105133	105133	105134
22465	34011	2	applied	\N	\N	\N	\N	105135	105135	105136
22465	34012	3	applied	\N	\N	\N	\N	105137	105137	105138
22469	34013	0	applied	\N	\N	\N	\N	105165	105165	105166
22469	34014	1	applied	\N	\N	\N	\N	105167	105167	105168
22469	34015	2	applied	\N	\N	\N	\N	105170	105170	105171
22475	34036	0	applied	\N	\N	\N	\N	105218	105218	105219
22475	34037	1	applied	\N	\N	\N	\N	105220	105220	105221
22475	34038	2	applied	\N	\N	\N	\N	105222	105222	105223
22475	34039	3	applied	\N	\N	\N	\N	105224	105224	105225
22475	34040	4	applied	\N	\N	\N	\N	105226	105226	105227
22475	34041	5	applied	\N	\N	\N	\N	105228	105228	105229
22477	34042	0	applied	\N	\N	\N	\N	105234	105234	105235
22477	34043	1	applied	\N	\N	\N	\N	105236	105236	105237
22477	34044	2	applied	\N	\N	\N	\N	105238	105238	105239
22477	34045	3	applied	\N	\N	\N	\N	105240	105240	105241
22477	34046	4	applied	\N	\N	\N	\N	105242	105242	105243
22477	34047	5	applied	\N	\N	\N	\N	105244	105244	105245
22477	34048	6	applied	\N	\N	\N	\N	105246	105246	105247
22477	34049	7	applied	\N	\N	\N	\N	105248	105248	105249
22482	34059	0	applied	\N	\N	\N	\N	105276	105276	105277
22482	34060	1	applied	\N	\N	\N	\N	105278	105278	105279
22482	34061	2	applied	\N	\N	\N	\N	105280	105280	105281
22482	34062	3	applied	\N	\N	\N	\N	105282	105282	105283
22482	34063	4	applied	\N	\N	\N	\N	105284	105284	105285
22482	34064	5	applied	\N	\N	\N	\N	105286	105286	105287
22482	34065	6	applied	\N	\N	\N	\N	105288	105288	105289
22482	34066	7	applied	\N	\N	\N	\N	105290	105290	105291
22482	34067	8	applied	\N	\N	\N	\N	105292	105292	105293
22482	34068	9	applied	\N	\N	\N	\N	105294	105294	105295
22482	34069	10	applied	\N	\N	\N	\N	105296	105296	105297
22482	34070	11	applied	\N	\N	\N	\N	105298	105298	105299
22482	34071	13	applied	\N	\N	\N	\N	105301	105301	105302
22482	34072	14	applied	\N	\N	\N	\N	105303	105303	105304
22482	34073	15	applied	\N	\N	\N	\N	105305	105305	105306
22482	34074	16	applied	\N	\N	\N	\N	105307	105307	105308
22482	34075	17	applied	\N	\N	\N	\N	105309	105309	105310
22482	34076	18	applied	\N	\N	\N	\N	105311	105311	105312
22484	34077	0	applied	\N	\N	\N	\N	105315	105315	105316
22484	34078	1	applied	\N	\N	\N	\N	105317	105317	105318
22484	34079	2	applied	\N	\N	\N	\N	105319	105319	105320
22484	34080	3	applied	\N	\N	\N	\N	105321	105321	105322
22484	34081	4	applied	\N	\N	\N	\N	105323	105323	105324
22484	34082	5	applied	\N	\N	\N	\N	105325	105325	105326
22484	34083	6	applied	\N	\N	\N	\N	105327	105327	105328
22484	34084	7	applied	\N	\N	\N	\N	105329	105329	105330
22484	34085	8	applied	\N	\N	\N	\N	105331	105331	105332
22487	34087	0	applied	\N	\N	\N	\N	105340	105340	105341
22487	34088	1	applied	\N	\N	\N	\N	105342	105342	105343
22487	34089	2	applied	\N	\N	\N	\N	105344	105344	105345
22487	34090	3	applied	\N	\N	\N	\N	105346	105346	105347
22487	34091	4	applied	\N	\N	\N	\N	105348	105348	105349
22487	34092	5	applied	\N	\N	\N	\N	105350	105350	105351
22487	34093	6	applied	\N	\N	\N	\N	105352	105352	105353
22487	34094	7	applied	\N	\N	\N	\N	105354	105354	105355
22487	34095	8	applied	\N	\N	\N	\N	105356	105356	105357
22487	34096	9	applied	\N	\N	\N	\N	105358	105358	105359
22487	34097	10	applied	\N	\N	\N	\N	105360	105360	105361
22487	34098	11	applied	\N	\N	\N	\N	105362	105362	105363
22487	34099	12	applied	\N	\N	\N	\N	105364	105364	105365
22487	34100	13	applied	\N	\N	\N	\N	105366	105366	105367
22487	34101	14	applied	\N	\N	\N	\N	105368	105368	105369
22487	34102	15	applied	\N	\N	\N	\N	105370	105370	105371
22487	34103	16	applied	\N	\N	\N	\N	105372	105372	105373
22487	34104	17	applied	\N	\N	\N	\N	105374	105374	105375
22493	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22493	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22493	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22493	34117	3	applied	\N	\N	\N	\N	105403	105403	105404
22493	34118	4	applied	\N	\N	\N	\N	105405	105405	105406
22493	34119	5	applied	\N	\N	\N	\N	105407	105407	105408
22493	34120	6	applied	\N	\N	\N	\N	105409	105409	105410
22493	34121	7	applied	\N	\N	\N	\N	105411	105411	105412
22496	34122	0	applied	\N	\N	\N	\N	105424	105424	105425
22496	34123	1	applied	\N	\N	\N	\N	105426	105426	105427
22496	34125	2	applied	\N	\N	\N	\N	105430	105430	105434
22510	34200	0	applied	\N	\N	\N	\N	105609	105609	105610
22510	34201	1	applied	\N	\N	\N	\N	105611	105611	105612
22510	34202	2	applied	\N	\N	\N	\N	105613	105613	105614
22510	34203	3	applied	\N	\N	\N	\N	105615	105615	105616
22512	34204	0	applied	\N	\N	\N	\N	105621	105621	105622
22512	34205	1	applied	\N	\N	\N	\N	105623	105623	105624
22512	34206	2	applied	\N	\N	\N	\N	105625	105625	105626
22455	33991	1	applied	\N	\N	\N	\N	105078	105078	105081
22455	33994	2	applied	\N	\N	\N	\N	105090	105090	105091
22455	33995	3	applied	\N	\N	\N	\N	105092	105092	105093
22462	34003	0	applied	\N	\N	\N	\N	105116	105116	105117
22462	34004	1	applied	\N	\N	\N	\N	105118	105118	105119
22462	34005	2	applied	\N	\N	\N	\N	105120	105120	105121
22467	33662	0	applied	\N	\N	\N	\N	103915	103915	103916
22467	33636	1	applied	\N	\N	\N	\N	103854	103854	103855
22467	33639	2	applied	\N	\N	\N	\N	103864	103864	103945
22467	33640	3	applied	\N	\N	\N	\N	103866	103866	103946
22467	33641	4	applied	\N	\N	\N	\N	103868	103868	103947
22467	33642	5	applied	\N	\N	\N	\N	103870	103870	103948
22467	33653	6	applied	\N	\N	\N	\N	103893	103893	103949
22467	33656	7	applied	\N	\N	\N	\N	103901	103901	103950
22467	33659	8	applied	\N	\N	\N	\N	103909	103909	103951
22467	33660	9	applied	\N	\N	\N	\N	103911	103911	103952
22467	33661	10	applied	\N	\N	\N	\N	103913	103913	103953
22467	33689	11	applied	\N	\N	\N	\N	104040	104040	104041
22467	33670	12	applied	\N	\N	\N	\N	103932	103932	103954
22467	33697	13	applied	\N	\N	\N	\N	104059	104059	104060
22467	33698	14	applied	\N	\N	\N	\N	104061	104061	104062
22467	33673	15	applied	\N	\N	\N	\N	103999	103999	104867
22467	33677	16	applied	\N	\N	\N	\N	104008	104008	104868
22467	33680	17	applied	\N	\N	\N	\N	104016	104016	104869
22467	33683	18	applied	\N	\N	\N	\N	104024	104024	104870
22467	33687	19	applied	\N	\N	\N	\N	104036	104036	104871
22467	33688	20	applied	\N	\N	\N	\N	104038	104038	104872
22467	33695	21	applied	\N	\N	\N	\N	104055	104055	104873
22467	33696	22	applied	\N	\N	\N	\N	104057	104057	104874
22467	33707	23	applied	\N	\N	\N	\N	104081	104081	104875
22467	33708	24	applied	\N	\N	\N	\N	104083	104083	104876
22467	33709	25	applied	\N	\N	\N	\N	104085	104085	104877
22467	33718	26	applied	\N	\N	\N	\N	104111	104111	104878
22467	33719	27	applied	\N	\N	\N	\N	104113	104113	104879
22467	33725	28	applied	\N	\N	\N	\N	104136	104136	104880
22467	33729	29	applied	\N	\N	\N	\N	104153	104153	104881
22467	33730	30	applied	\N	\N	\N	\N	104155	104155	104882
22467	33731	31	applied	\N	\N	\N	\N	104157	104157	104883
22467	33739	32	applied	\N	\N	\N	\N	104178	104178	104884
22467	33740	33	applied	\N	\N	\N	\N	104180	104180	104885
22467	33745	34	applied	\N	\N	\N	\N	104193	104193	104886
22467	33746	35	applied	\N	\N	\N	\N	104195	104195	104887
22467	33752	36	applied	\N	\N	\N	\N	104208	104208	104888
22467	33755	37	applied	\N	\N	\N	\N	104216	104216	104889
22467	33758	38	applied	\N	\N	\N	\N	104222	104222	104890
22467	33762	39	applied	\N	\N	\N	\N	104232	104232	104891
22467	33763	40	applied	\N	\N	\N	\N	104234	104234	104892
22467	33764	41	applied	\N	\N	\N	\N	104236	104236	104893
22467	33772	42	applied	\N	\N	\N	\N	104256	104256	104894
22467	33773	43	applied	\N	\N	\N	\N	104258	104258	104895
22467	33778	44	applied	\N	\N	\N	\N	104274	104274	104896
22467	33781	45	applied	\N	\N	\N	\N	104284	104284	104897
22467	33785	46	applied	\N	\N	\N	\N	104298	104298	104898
22467	33787	47	applied	\N	\N	\N	\N	104329	104329	104899
22467	33790	48	applied	\N	\N	\N	\N	104335	104335	104900
22467	33794	49	applied	\N	\N	\N	\N	104347	104347	104901
22467	33797	50	applied	\N	\N	\N	\N	104360	104360	104902
22467	33800	51	applied	\N	\N	\N	\N	104368	104368	104903
22467	33804	52	applied	\N	\N	\N	\N	104385	104385	104904
22467	33805	53	applied	\N	\N	\N	\N	104387	104387	104905
22467	33806	54	applied	\N	\N	\N	\N	104389	104389	104906
22467	33813	55	applied	\N	\N	\N	\N	104404	104404	104907
22467	33817	56	applied	\N	\N	\N	\N	104416	104416	104908
22467	33820	57	applied	\N	\N	\N	\N	104424	104424	104909
22467	33821	58	applied	\N	\N	\N	\N	104426	104426	104910
22467	33827	59	applied	\N	\N	\N	\N	104444	104444	104911
22467	33828	60	applied	\N	\N	\N	\N	104448	104448	104912
22467	33831	61	applied	\N	\N	\N	\N	104456	104456	104913
22467	33832	62	applied	\N	\N	\N	\N	104458	104458	104914
22467	33838	64	applied	\N	\N	\N	\N	104472	104472	104915
22467	33841	65	applied	\N	\N	\N	\N	104478	104478	104916
22467	33842	66	applied	\N	\N	\N	\N	104480	104480	104917
22467	33848	67	applied	\N	\N	\N	\N	104496	104496	104918
22467	33849	68	applied	\N	\N	\N	\N	104498	104498	104919
22467	33854	69	applied	\N	\N	\N	\N	104510	104510	104920
22467	33858	70	applied	\N	\N	\N	\N	104519	104519	104921
22467	33861	71	applied	\N	\N	\N	\N	104529	104529	104922
22467	33865	72	applied	\N	\N	\N	\N	104541	104541	104923
22467	33869	73	applied	\N	\N	\N	\N	104551	104551	104924
22467	33872	74	applied	\N	\N	\N	\N	104559	104559	104925
22467	33875	75	applied	\N	\N	\N	\N	104606	104606	104926
22467	33878	76	applied	\N	\N	\N	\N	104617	104617	104927
22467	33882	77	applied	\N	\N	\N	\N	104628	104628	104928
22467	33885	78	applied	\N	\N	\N	\N	104636	104636	104929
22467	33888	79	applied	\N	\N	\N	\N	104644	104644	104930
22467	33892	80	applied	\N	\N	\N	\N	104653	104653	104931
22467	33893	81	applied	\N	\N	\N	\N	104655	104655	104932
22467	33898	82	applied	\N	\N	\N	\N	104670	104670	104933
22467	33899	83	applied	\N	\N	\N	\N	104672	104672	104934
22467	33905	84	applied	\N	\N	\N	\N	104701	104701	104935
22467	33907	85	applied	\N	\N	\N	\N	104707	104707	104936
22467	33910	86	applied	\N	\N	\N	\N	104718	104718	104937
22467	33911	87	applied	\N	\N	\N	\N	104720	104720	104938
22467	33912	88	applied	\N	\N	\N	\N	104722	104722	104939
22467	33920	89	applied	\N	\N	\N	\N	104742	104742	104940
22467	33924	90	applied	\N	\N	\N	\N	104751	104751	104941
22467	33927	91	applied	\N	\N	\N	\N	104758	104758	104942
22467	33930	92	applied	\N	\N	\N	\N	104773	104773	104943
22467	33932	93	applied	\N	\N	\N	\N	104781	104781	104944
22467	33933	94	applied	\N	\N	\N	\N	104783	104783	104945
22467	33939	95	applied	\N	\N	\N	\N	104801	104801	104946
22467	33940	96	applied	\N	\N	\N	\N	104803	104803	104947
22467	33946	97	applied	\N	\N	\N	\N	104817	104817	104948
22467	33949	98	applied	\N	\N	\N	\N	104826	104826	104949
22467	33952	99	applied	\N	\N	\N	\N	104834	104834	104950
22467	33956	100	applied	\N	\N	\N	\N	104844	104844	104951
22467	33960	101	applied	\N	\N	\N	\N	104859	104859	104952
22467	33963	102	applied	\N	\N	\N	\N	104973	104973	105144
22467	33964	103	applied	\N	\N	\N	\N	104975	104975	105145
22467	33971	104	applied	\N	\N	\N	\N	105023	105023	105146
22467	33974	105	applied	\N	\N	\N	\N	105034	105034	105147
22467	33977	106	applied	\N	\N	\N	\N	105042	105042	105148
22467	33981	107	applied	\N	\N	\N	\N	105054	105054	105149
22467	33984	108	applied	\N	\N	\N	\N	105062	105062	105150
22467	33985	109	applied	\N	\N	\N	\N	105064	105064	105151
22467	33990	110	applied	\N	\N	\N	\N	105076	105076	105152
22467	33993	111	applied	\N	\N	\N	\N	105088	105088	105153
22467	33996	112	applied	\N	\N	\N	\N	105096	105096	105154
22467	33999	113	applied	\N	\N	\N	\N	105104	105104	105155
22467	34003	114	applied	\N	\N	\N	\N	105116	105116	105156
22467	34006	115	applied	\N	\N	\N	\N	105124	105124	105157
22467	34009	116	applied	\N	\N	\N	\N	105131	105131	105158
22467	33862	117	applied	\N	\N	\N	\N	105159	105159	104532
22467	33690	118	applied	\N	\N	\N	\N	104042	104042	104043
22467	33372	119	applied	\N	\N	\N	\N	103050	103050	102913
22467	33383	120	applied	\N	\N	\N	\N	103077	103077	105160
22467	33395	121	applied	\N	\N	\N	\N	103103	103103	105161
22467	33409	122	applied	\N	\N	\N	\N	103182	103182	102915
22467	33420	123	applied	\N	\N	\N	\N	103210	103210	102917
22467	33427	124	applied	\N	\N	\N	\N	103249	103249	105162
22467	33703	125	applied	\N	\N	\N	\N	104071	104071	104072
22471	34016	0	applied	\N	\N	\N	\N	105173	105173	105174
22471	34017	1	applied	\N	\N	\N	\N	105175	105175	105176
22471	34018	2	applied	\N	\N	\N	\N	105177	105177	105178
22471	34019	3	applied	\N	\N	\N	\N	105179	105179	105180
22471	34020	4	applied	\N	\N	\N	\N	105181	105181	105182
22471	34021	5	applied	\N	\N	\N	\N	105183	105183	105184
22471	34022	6	applied	\N	\N	\N	\N	105185	105185	105186
22474	34023	0	applied	\N	\N	\N	\N	105190	105190	105191
22474	34024	1	applied	\N	\N	\N	\N	105192	105192	105193
22474	34025	2	applied	\N	\N	\N	\N	105194	105194	105195
22474	34026	3	applied	\N	\N	\N	\N	105196	105196	105197
22474	34027	4	applied	\N	\N	\N	\N	105198	105198	105199
22474	34028	5	applied	\N	\N	\N	\N	105200	105200	105201
22474	34029	6	applied	\N	\N	\N	\N	105202	105202	105203
22474	34030	7	applied	\N	\N	\N	\N	105204	105204	105205
22474	34031	8	applied	\N	\N	\N	\N	105206	105206	105207
22474	34032	9	applied	\N	\N	\N	\N	105208	105208	105209
22474	34033	10	applied	\N	\N	\N	\N	105210	105210	105211
22474	34034	11	applied	\N	\N	\N	\N	105212	105212	105213
22474	34035	12	applied	\N	\N	\N	\N	105214	105214	105215
22479	34042	0	applied	\N	\N	\N	\N	105234	105234	105235
22479	34043	1	applied	\N	\N	\N	\N	105236	105236	105237
22479	34044	2	applied	\N	\N	\N	\N	105238	105238	105239
22479	34045	3	applied	\N	\N	\N	\N	105240	105240	105241
22479	34046	4	applied	\N	\N	\N	\N	105242	105242	105243
22479	34047	5	applied	\N	\N	\N	\N	105244	105244	105245
22479	34048	6	applied	\N	\N	\N	\N	105246	105246	105247
22479	34050	7	applied	\N	\N	\N	\N	105251	105251	105252
22479	34049	8	applied	\N	\N	\N	\N	105248	105248	105253
22481	34051	0	applied	\N	\N	\N	\N	105257	105257	105258
22481	34052	1	applied	\N	\N	\N	\N	105259	105259	105260
22481	34053	2	applied	\N	\N	\N	\N	105261	105261	105262
22481	34054	3	applied	\N	\N	\N	\N	105263	105263	105264
22481	34055	4	applied	\N	\N	\N	\N	105265	105265	105266
22481	34056	5	applied	\N	\N	\N	\N	105267	105267	105268
22481	34057	6	applied	\N	\N	\N	\N	105269	105269	105270
22481	34058	7	applied	\N	\N	\N	\N	105271	105271	105272
22486	34087	0	applied	\N	\N	\N	\N	105340	105340	105341
22486	34088	1	applied	\N	\N	\N	\N	105342	105342	105343
22486	34089	2	applied	\N	\N	\N	\N	105344	105344	105345
22486	34090	3	applied	\N	\N	\N	\N	105346	105346	105347
22486	34091	4	applied	\N	\N	\N	\N	105348	105348	105349
22486	34092	5	applied	\N	\N	\N	\N	105350	105350	105351
22486	34093	6	applied	\N	\N	\N	\N	105352	105352	105353
22486	34094	7	applied	\N	\N	\N	\N	105354	105354	105355
22486	34095	8	applied	\N	\N	\N	\N	105356	105356	105357
22486	34096	9	applied	\N	\N	\N	\N	105358	105358	105359
22486	34097	10	applied	\N	\N	\N	\N	105360	105360	105361
22486	34098	11	applied	\N	\N	\N	\N	105362	105362	105363
22486	34099	12	applied	\N	\N	\N	\N	105364	105364	105365
22486	34100	13	applied	\N	\N	\N	\N	105366	105366	105367
22486	34101	14	applied	\N	\N	\N	\N	105368	105368	105369
22486	34102	15	applied	\N	\N	\N	\N	105370	105370	105371
22486	34103	16	applied	\N	\N	\N	\N	105372	105372	105373
22486	34104	17	applied	\N	\N	\N	\N	105374	105374	105375
22489	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22489	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22489	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22489	34117	3	applied	\N	\N	\N	\N	105403	105403	105404
22489	34118	4	applied	\N	\N	\N	\N	105405	105405	105406
22489	34119	5	applied	\N	\N	\N	\N	105407	105407	105408
22489	34120	6	applied	\N	\N	\N	\N	105409	105409	105410
22489	34121	7	applied	\N	\N	\N	\N	105411	105411	105412
22492	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22492	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22492	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22492	34117	3	applied	\N	\N	\N	\N	105403	105403	105404
22492	34118	4	applied	\N	\N	\N	\N	105405	105405	105406
22492	34119	5	applied	\N	\N	\N	\N	105407	105407	105408
22492	34120	6	applied	\N	\N	\N	\N	105409	105409	105410
22492	34121	7	applied	\N	\N	\N	\N	105411	105411	105412
22495	34122	0	applied	\N	\N	\N	\N	105424	105424	105425
22495	34123	1	applied	\N	\N	\N	\N	105426	105426	105427
22495	34124	2	applied	\N	\N	\N	\N	105428	105428	105429
22495	34125	3	applied	\N	\N	\N	\N	105430	105430	105431
22498	34117	0	applied	\N	\N	\N	\N	105403	105403	105438
22498	34119	1	applied	\N	\N	\N	\N	105407	105407	105412
22498	34124	2	applied	\N	\N	\N	\N	105428	105428	105429
22505	34162	0	applied	\N	\N	\N	\N	105517	105517	105518
22505	34163	1	applied	\N	\N	\N	\N	105519	105519	105520
22505	34164	2	applied	\N	\N	\N	\N	105521	105521	105522
22505	34165	3	applied	\N	\N	\N	\N	105523	105523	105524
22505	34166	4	applied	\N	\N	\N	\N	105525	105525	105526
22505	34167	5	applied	\N	\N	\N	\N	105527	105527	105528
22505	34168	6	applied	\N	\N	\N	\N	105529	105529	105530
22505	34169	7	applied	\N	\N	\N	\N	105531	105531	105532
22505	34170	8	applied	\N	\N	\N	\N	105533	105533	105534
22505	34171	9	applied	\N	\N	\N	\N	105535	105535	105536
22505	34172	10	applied	\N	\N	\N	\N	105537	105537	105538
22505	34173	11	applied	\N	\N	\N	\N	105539	105539	105540
22505	34174	12	applied	\N	\N	\N	\N	105541	105541	105542
22505	34175	13	applied	\N	\N	\N	\N	105543	105543	105544
22505	34176	14	applied	\N	\N	\N	\N	105545	105545	105546
22505	34179	15	applied	\N	\N	\N	\N	105553	105553	105554
22505	34177	16	applied	\N	\N	\N	\N	105547	105547	105555
22505	34180	17	applied	\N	\N	\N	\N	105556	105556	105557
22505	34178	18	applied	\N	\N	\N	\N	105549	105549	105558
22507	34181	0	applied	\N	\N	\N	\N	105560	105560	105561
22507	34182	2	applied	\N	\N	\N	\N	105566	105566	105567
22507	34183	3	applied	\N	\N	\N	\N	105568	105568	105569
22507	34184	4	applied	\N	\N	\N	\N	105570	105570	105571
22507	34185	5	applied	\N	\N	\N	\N	105572	105572	105573
22507	34186	6	applied	\N	\N	\N	\N	105574	105574	105575
22507	34187	7	applied	\N	\N	\N	\N	105576	105576	105577
22507	34188	8	applied	\N	\N	\N	\N	105578	105578	105579
22507	34179	9	applied	\N	\N	\N	\N	105553	105553	105580
22507	34180	10	applied	\N	\N	\N	\N	105556	105556	105581
22507	34189	11	applied	\N	\N	\N	\N	105582	105582	105583
22514	34207	0	applied	\N	\N	\N	\N	105629	105629	105630
22490	34118	3	applied	\N	\N	\N	\N	105405	105405	105415
22490	34120	4	applied	\N	\N	\N	\N	105409	105409	105416
22490	34121	5	applied	\N	\N	\N	\N	105411	105411	105417
22494	34114	0	applied	\N	\N	\N	\N	105397	105397	105398
22494	34115	1	applied	\N	\N	\N	\N	105399	105399	105400
22494	34116	2	applied	\N	\N	\N	\N	105401	105401	105402
22494	34117	3	applied	\N	\N	\N	\N	105403	105403	105404
22494	34118	4	applied	\N	\N	\N	\N	105405	105405	105406
22494	34119	5	applied	\N	\N	\N	\N	105407	105407	105408
22494	34120	6	applied	\N	\N	\N	\N	105409	105409	105410
22494	34121	7	applied	\N	\N	\N	\N	105411	105411	105412
22499	34126	0	applied	\N	\N	\N	\N	105440	105440	105441
22499	34127	1	applied	\N	\N	\N	\N	105442	105442	105443
22499	34128	2	applied	\N	\N	\N	\N	105444	105444	105445
22499	34129	3	applied	\N	\N	\N	\N	105446	105446	105447
22499	34130	4	applied	\N	\N	\N	\N	105448	105448	105449
22499	34131	5	applied	\N	\N	\N	\N	105450	105450	105451
22499	34132	6	applied	\N	\N	\N	\N	105452	105452	105453
22499	34133	7	applied	\N	\N	\N	\N	105454	105454	105455
22499	34134	8	applied	\N	\N	\N	\N	105456	105456	105457
22499	34135	9	applied	\N	\N	\N	\N	105458	105458	105459
22499	34136	10	applied	\N	\N	\N	\N	105460	105460	105461
22499	34137	11	applied	\N	\N	\N	\N	105462	105462	105463
22499	34138	12	applied	\N	\N	\N	\N	105464	105464	105465
22499	34139	13	applied	\N	\N	\N	\N	105466	105466	105467
22499	34140	14	applied	\N	\N	\N	\N	105468	105468	105469
22499	34141	15	applied	\N	\N	\N	\N	105470	105470	105471
22499	34142	16	applied	\N	\N	\N	\N	105472	105472	105473
22499	34143	17	applied	\N	\N	\N	\N	105474	105474	105475
22499	34144	18	applied	\N	\N	\N	\N	105476	105476	105477
22499	34145	19	applied	\N	\N	\N	\N	105478	105478	105479
22499	34146	20	applied	\N	\N	\N	\N	105480	105480	105481
22499	34147	21	applied	\N	\N	\N	\N	105482	105482	105483
22499	34148	22	applied	\N	\N	\N	\N	105484	105484	105485
22499	34124	23	applied	\N	\N	\N	\N	105428	105428	105486
22499	34149	24	applied	\N	\N	\N	\N	105487	105487	105488
22499	34150	25	applied	\N	\N	\N	\N	105489	105489	105490
22499	34151	26	applied	\N	\N	\N	\N	105491	105491	105492
22499	34152	27	applied	\N	\N	\N	\N	105493	105493	105494
22501	34153	0	applied	\N	\N	\N	\N	105496	105496	105497
22501	34154	1	applied	\N	\N	\N	\N	105498	105498	105499
22501	34155	2	applied	\N	\N	\N	\N	105500	105500	105501
22501	34156	3	applied	\N	\N	\N	\N	105502	105502	105503
22501	34157	4	applied	\N	\N	\N	\N	105504	105504	105505
22501	34158	5	applied	\N	\N	\N	\N	105506	105506	105507
22501	34159	6	applied	\N	\N	\N	\N	105508	105508	105509
22501	34160	7	applied	\N	\N	\N	\N	105510	105510	105511
22501	34161	8	applied	\N	\N	\N	\N	105512	105512	105513
22506	34181	0	applied	\N	\N	\N	\N	105560	105560	105561
22508	34182	0	applied	\N	\N	\N	\N	105566	105566	105567
22508	34190	1	applied	\N	\N	\N	\N	105586	105586	105587
22508	34183	2	applied	\N	\N	\N	\N	105568	105568	105569
22508	34184	3	applied	\N	\N	\N	\N	105570	105570	105571
22508	34185	4	applied	\N	\N	\N	\N	105572	105572	105573
22508	34186	5	applied	\N	\N	\N	\N	105574	105574	105575
22508	34187	6	applied	\N	\N	\N	\N	105576	105576	105577
22508	34191	7	applied	\N	\N	\N	\N	105588	105588	105589
22508	34192	8	applied	\N	\N	\N	\N	105590	105590	105591
22508	34193	9	applied	\N	\N	\N	\N	105592	105592	105593
22508	34194	10	applied	\N	\N	\N	\N	105594	105594	105595
22508	34195	11	applied	\N	\N	\N	\N	105596	105596	105597
22508	34196	12	applied	\N	\N	\N	\N	105598	105598	105599
22508	34188	13	applied	\N	\N	\N	\N	105578	105578	105579
22508	34179	14	applied	\N	\N	\N	\N	105553	105553	105580
22508	34197	15	applied	\N	\N	\N	\N	105600	105600	105601
22508	34198	16	applied	\N	\N	\N	\N	105602	105602	105583
22508	34180	17	applied	\N	\N	\N	\N	105556	105556	105603
22508	34189	18	applied	\N	\N	\N	\N	105582	105582	105604
22508	34199	19	applied	\N	\N	\N	\N	105605	105605	105606
22511	34200	0	applied	\N	\N	\N	\N	105609	105609	105610
22511	34201	1	applied	\N	\N	\N	\N	105611	105611	105612
22511	34202	2	applied	\N	\N	\N	\N	105613	105613	105614
22511	34203	3	applied	\N	\N	\N	\N	105615	105615	105616
22516	34207	0	applied	\N	\N	\N	\N	105629	105629	105630
22516	34208	1	applied	\N	\N	\N	\N	105631	105631	105632
22516	34209	2	applied	\N	\N	\N	\N	105633	105633	105634
22516	34210	3	applied	\N	\N	\N	\N	105635	105635	105636
22518	34217	0	applied	\N	\N	\N	\N	105656	105656	105657
22518	34218	1	applied	\N	\N	\N	\N	105658	105658	105659
22518	34219	2	applied	\N	\N	\N	\N	105660	105660	105661
22518	34220	3	applied	\N	\N	\N	\N	105662	105662	105663
22518	34221	4	applied	\N	\N	\N	\N	105664	105664	105665
22518	34222	5	applied	\N	\N	\N	\N	105666	105666	105667
22518	34223	6	applied	\N	\N	\N	\N	105668	105668	105669
22518	34224	7	applied	\N	\N	\N	\N	105670	105670	105671
22518	34225	8	applied	\N	\N	\N	\N	105672	105672	105673
22525	34260	0	applied	\N	\N	\N	\N	105754	105754	105755
22525	34261	1	applied	\N	\N	\N	\N	105756	105756	105757
22525	34262	2	applied	\N	\N	\N	\N	105758	105758	105759
22525	34263	3	applied	\N	\N	\N	\N	105760	105760	105761
22533	34283	0	applied	\N	\N	\N	\N	105816	105816	105817
22533	34284	1	applied	\N	\N	\N	\N	105818	105818	105819
22533	34285	2	applied	\N	\N	\N	\N	105820	105820	105821
22533	34286	3	applied	\N	\N	\N	\N	105822	105822	105823
22533	34287	4	applied	\N	\N	\N	\N	105824	105824	105825
22533	34288	5	applied	\N	\N	\N	\N	105826	105826	105827
22533	34289	6	applied	\N	\N	\N	\N	105828	105828	105829
22533	34290	7	applied	\N	\N	\N	\N	105830	105830	105831
22533	34291	8	applied	\N	\N	\N	\N	105832	105832	105833
22533	34292	9	applied	\N	\N	\N	\N	105834	105834	105835
22533	34293	10	applied	\N	\N	\N	\N	105836	105836	105837
22533	34294	11	applied	\N	\N	\N	\N	105838	105838	105839
22533	34295	12	applied	\N	\N	\N	\N	105840	105840	105841
22536	34304	0	applied	\N	\N	\N	\N	105862	105862	105863
22536	34305	1	applied	\N	\N	\N	\N	105864	105864	105865
22536	34306	2	applied	\N	\N	\N	\N	105866	105866	105867
22539	34319	0	applied	\N	\N	\N	\N	105899	105899	105900
22539	34320	1	applied	\N	\N	\N	\N	105901	105901	105902
22539	34321	2	applied	\N	\N	\N	\N	105903	105903	105904
22541	34322	0	applied	\N	\N	\N	\N	105907	105907	105908
22556	34358	0	applied	\N	\N	\N	\N	105993	105993	105994
22556	34359	1	applied	\N	\N	\N	\N	105995	105995	105996
22556	34360	2	applied	\N	\N	\N	\N	105997	105997	105998
22556	34361	3	applied	\N	\N	\N	\N	105999	105999	106000
22558	34362	0	applied	\N	\N	\N	\N	106005	106005	106006
22558	34363	1	applied	\N	\N	\N	\N	106007	106007	106008
22558	34364	2	applied	\N	\N	\N	\N	106009	106009	106010
22563	34373	0	applied	\N	\N	\N	\N	106032	106032	106033
22563	34374	1	applied	\N	\N	\N	\N	106034	106034	106035
22563	34375	3	applied	\N	\N	\N	\N	106037	106037	106038
22509	34180	17	applied	\N	\N	\N	\N	105556	105556	105603
22509	34189	18	applied	\N	\N	\N	\N	105582	105582	105604
22509	34199	19	applied	\N	\N	\N	\N	105605	105605	105606
22521	34235	0	applied	\N	\N	\N	\N	105697	105697	105698
22521	34236	1	applied	\N	\N	\N	\N	105699	105699	105700
22521	34237	2	applied	\N	\N	\N	\N	105701	105701	105702
22521	34238	3	applied	\N	\N	\N	\N	105703	105703	105704
22521	34239	4	applied	\N	\N	\N	\N	105705	105705	105706
22521	34240	5	applied	\N	\N	\N	\N	105707	105707	105708
22521	34241	6	applied	\N	\N	\N	\N	105709	105709	105710
22521	34242	7	applied	\N	\N	\N	\N	105711	105711	105712
22521	34243	8	applied	\N	\N	\N	\N	105713	105713	105714
22521	34244	9	applied	\N	\N	\N	\N	105715	105715	105716
22521	34245	10	applied	\N	\N	\N	\N	105717	105717	105718
22521	34246	11	applied	\N	\N	\N	\N	105719	105719	105720
22521	34247	12	applied	\N	\N	\N	\N	105721	105721	105722
22523	34248	0	applied	\N	\N	\N	\N	105726	105726	105727
22523	34249	1	applied	\N	\N	\N	\N	105728	105728	105729
22523	34250	2	applied	\N	\N	\N	\N	105730	105730	105731
22523	34251	3	applied	\N	\N	\N	\N	105732	105732	105733
22523	34252	4	applied	\N	\N	\N	\N	105734	105734	105735
22523	34253	5	applied	\N	\N	\N	\N	105736	105736	105737
22523	34254	6	applied	\N	\N	\N	\N	105738	105738	105739
22523	34255	7	applied	\N	\N	\N	\N	105740	105740	105741
22523	34256	8	applied	\N	\N	\N	\N	105742	105742	105743
22528	34264	0	applied	\N	\N	\N	\N	105764	105764	105765
22528	34265	1	applied	\N	\N	\N	\N	105766	105766	105767
22528	34267	2	applied	\N	\N	\N	\N	105770	105770	105778
22528	34269	3	applied	\N	\N	\N	\N	105774	105774	105779
22534	34296	0	applied	\N	\N	\N	\N	105844	105844	105845
22534	34297	1	applied	\N	\N	\N	\N	105846	105846	105847
22534	34298	2	applied	\N	\N	\N	\N	105848	105848	105849
22534	34299	3	applied	\N	\N	\N	\N	105850	105850	105851
22534	34300	4	applied	\N	\N	\N	\N	105852	105852	105853
22534	34301	5	applied	\N	\N	\N	\N	105854	105854	105855
22534	34302	6	applied	\N	\N	\N	\N	105856	105856	105857
22534	34303	7	applied	\N	\N	\N	\N	105858	105858	105859
22537	34307	0	applied	\N	\N	\N	\N	105871	105871	105872
22537	34308	1	applied	\N	\N	\N	\N	105873	105873	105874
22537	34309	2	applied	\N	\N	\N	\N	105875	105875	105876
22537	34310	3	applied	\N	\N	\N	\N	105877	105877	105878
22537	34311	4	applied	\N	\N	\N	\N	105879	105879	105880
22537	34312	5	applied	\N	\N	\N	\N	105881	105881	105882
22537	34313	6	applied	\N	\N	\N	\N	105883	105883	105884
22537	34314	7	applied	\N	\N	\N	\N	105885	105885	105886
22537	34315	8	applied	\N	\N	\N	\N	105887	105887	105888
22537	34316	9	applied	\N	\N	\N	\N	105889	105889	105890
22537	34317	10	applied	\N	\N	\N	\N	105891	105891	105892
22537	34318	11	applied	\N	\N	\N	\N	105893	105893	105894
22547	34329	0	applied	\N	\N	\N	\N	105927	105927	105928
22547	34330	1	applied	\N	\N	\N	\N	105929	105929	105930
22547	34331	2	applied	\N	\N	\N	\N	105931	105931	105932
22547	34332	3	applied	\N	\N	\N	\N	105933	105933	105934
22547	34333	4	applied	\N	\N	\N	\N	105935	105935	105936
22547	34334	5	applied	\N	\N	\N	\N	105937	105937	105938
22547	34335	6	applied	\N	\N	\N	\N	105939	105939	105940
22547	34336	7	applied	\N	\N	\N	\N	105941	105941	105942
22547	34337	8	applied	\N	\N	\N	\N	105943	105943	105944
22547	34338	9	applied	\N	\N	\N	\N	105945	105945	105946
22547	34339	10	applied	\N	\N	\N	\N	105947	105947	105948
22547	34340	11	applied	\N	\N	\N	\N	105949	105949	105950
22547	34341	12	applied	\N	\N	\N	\N	105951	105951	105952
22549	34342	0	applied	\N	\N	\N	\N	105955	105955	105956
22549	34343	1	applied	\N	\N	\N	\N	105957	105957	105958
22549	34344	2	applied	\N	\N	\N	\N	105959	105959	105960
22552	34349	0	applied	\N	\N	\N	\N	105972	105972	105973
22552	34350	1	applied	\N	\N	\N	\N	105974	105974	105975
22552	34351	2	applied	\N	\N	\N	\N	105976	105976	105977
22552	34352	3	applied	\N	\N	\N	\N	105978	105978	105979
22552	34353	4	applied	\N	\N	\N	\N	105980	105980	105981
22552	34354	5	applied	\N	\N	\N	\N	105982	105982	105983
22554	34355	0	applied	\N	\N	\N	\N	105987	105987	105988
22554	34356	1	applied	\N	\N	\N	\N	105989	105989	105990
22554	34357	2	applied	\N	\N	\N	\N	105991	105991	105992
22559	34362	0	applied	\N	\N	\N	\N	106005	106005	106006
22559	34363	1	applied	\N	\N	\N	\N	106007	106007	106008
22559	34364	2	applied	\N	\N	\N	\N	106009	106009	106010
22561	34365	0	applied	\N	\N	\N	\N	106015	106015	106016
22561	34366	1	applied	\N	\N	\N	\N	106017	106017	106018
22561	34367	2	applied	\N	\N	\N	\N	106019	106019	106020
22561	34368	3	applied	\N	\N	1000000000	\N	106021	106021	106022
22561	34369	4	applied	\N	\N	\N	\N	106023	106023	106024
22561	34370	5	applied	\N	\N	\N	\N	106025	106025	106026
22561	34371	6	applied	\N	\N	\N	\N	106027	106027	106028
22561	34372	7	applied	\N	\N	\N	\N	106029	106029	106030
22571	34394	0	applied	\N	\N	\N	\N	106084	106084	106085
22571	34395	1	applied	\N	\N	\N	\N	106086	106086	106087
22571	34396	2	applied	\N	\N	\N	\N	106088	106088	106089
22573	34397	0	applied	\N	\N	1000000000	\N	106096	106096	106097
22573	34398	1	applied	\N	\N	\N	\N	106098	106098	106099
22573	34399	2	applied	\N	\N	\N	\N	106100	106100	106101
22573	34400	3	applied	\N	\N	\N	\N	106102	106102	106103
22573	34401	4	applied	\N	\N	\N	\N	106104	106104	106105
22573	34402	5	applied	\N	\N	\N	\N	106106	106106	106107
22573	34403	6	applied	\N	\N	\N	\N	10287	10287	106108
22573	34404	7	applied	\N	\N	\N	\N	106109	106109	106110
22573	34405	8	applied	\N	\N	\N	\N	106111	106111	106112
22573	34406	9	applied	\N	\N	\N	\N	106113	106113	106114
22576	34397	0	applied	\N	\N	1000000000	\N	106096	106096	106097
22576	34398	1	applied	\N	\N	\N	\N	106098	106098	106099
22576	34399	2	applied	\N	\N	\N	\N	106100	106100	106101
22576	34400	3	applied	\N	\N	\N	\N	106102	106102	106103
22576	34401	4	applied	\N	\N	\N	\N	106104	106104	106105
22576	34407	5	applied	\N	\N	\N	\N	106119	106119	106120
22576	34410	6	applied	\N	\N	\N	\N	106127	106127	106128
22576	34411	7	applied	\N	\N	\N	\N	106129	106129	106130
22576	34402	8	applied	\N	\N	\N	\N	106106	106106	106107
22576	34403	9	applied	\N	\N	\N	\N	10287	10287	106108
22576	34405	10	applied	\N	\N	\N	\N	106111	106111	106131
22576	34409	11	applied	\N	\N	\N	\N	106123	106123	106132
22576	34412	12	applied	\N	\N	\N	\N	106133	106133	106134
22576	34413	13	applied	\N	\N	\N	\N	106135	106135	106136
22576	34406	14	applied	\N	\N	\N	\N	106113	106113	106114
22576	34414	15	applied	\N	\N	\N	\N	106137	106137	106138
22576	34415	16	applied	\N	\N	\N	\N	106139	106139	106140
22578	34410	0	applied	\N	\N	\N	\N	106127	106127	106128
22578	34411	1	applied	\N	\N	\N	\N	106129	106129	106130
22578	34416	2	applied	\N	\N	\N	\N	106143	106143	106144
22578	34412	3	applied	\N	\N	\N	\N	106133	106133	106138
22514	34208	1	applied	\N	\N	\N	\N	105631	105631	105632
22514	34209	2	applied	\N	\N	\N	\N	105633	105633	105634
22514	34210	3	applied	\N	\N	\N	\N	105635	105635	105636
22519	34226	0	applied	\N	\N	\N	\N	105676	105676	105677
22519	34227	1	applied	\N	\N	\N	\N	105678	105678	105679
22519	34228	2	applied	\N	\N	\N	\N	105680	105680	105681
22519	34229	3	applied	\N	\N	\N	\N	105682	105682	105683
22519	34230	4	applied	\N	\N	\N	\N	105684	105684	105685
22519	34231	5	applied	\N	\N	\N	\N	105686	105686	105687
22519	34232	6	applied	\N	\N	\N	\N	105688	105688	105689
22519	34233	7	applied	\N	\N	\N	\N	105690	105690	105691
22519	34234	8	applied	\N	\N	\N	\N	105692	105692	105693
22522	34235	0	applied	\N	\N	\N	\N	105697	105697	105698
22522	34236	1	applied	\N	\N	\N	\N	105699	105699	105700
22522	34237	2	applied	\N	\N	\N	\N	105701	105701	105702
22522	34238	3	applied	\N	\N	\N	\N	105703	105703	105704
22522	34239	4	applied	\N	\N	\N	\N	105705	105705	105706
22522	34240	5	applied	\N	\N	\N	\N	105707	105707	105708
22522	34241	6	applied	\N	\N	\N	\N	105709	105709	105710
22522	34242	7	applied	\N	\N	\N	\N	105711	105711	105712
22522	34243	8	applied	\N	\N	\N	\N	105713	105713	105714
22522	34244	9	applied	\N	\N	\N	\N	105715	105715	105716
22522	34245	10	applied	\N	\N	\N	\N	105717	105717	105718
22522	34246	11	applied	\N	\N	\N	\N	105719	105719	105720
22522	34247	12	applied	\N	\N	\N	\N	105721	105721	105722
22524	34257	0	applied	\N	\N	\N	\N	105746	105746	105747
22524	34258	1	applied	\N	\N	\N	\N	105748	105748	105749
22524	34259	2	applied	\N	\N	\N	\N	105750	105750	105751
22529	34270	0	applied	\N	\N	\N	\N	105781	105781	105782
22529	34271	1	applied	\N	\N	\N	\N	105783	105783	105784
22529	34272	2	applied	\N	\N	\N	\N	105785	105785	105773
22529	34266	3	applied	\N	\N	\N	\N	105768	105768	105786
22529	34273	4	applied	\N	\N	\N	\N	105787	105787	105788
22529	34274	5	applied	\N	\N	\N	\N	105789	105789	105790
22529	34268	6	applied	\N	\N	\N	\N	105772	105772	105791
22529	34275	7	applied	\N	\N	\N	\N	105792	105792	105793
22529	34276	8	applied	\N	\N	\N	\N	105794	105794	105795
22531	34270	0	applied	\N	\N	\N	\N	105781	105781	105782
22531	34271	1	applied	\N	\N	\N	\N	105783	105783	105784
22531	34272	2	applied	\N	\N	\N	\N	105785	105785	105773
22531	34266	3	applied	\N	\N	\N	\N	105768	105768	105786
22531	34273	4	applied	\N	\N	\N	\N	105787	105787	105788
22531	34274	5	applied	\N	\N	\N	\N	105789	105789	105790
22531	34268	6	applied	\N	\N	\N	\N	105772	105772	105791
22531	34275	7	applied	\N	\N	\N	\N	105792	105792	105793
22531	34276	8	applied	\N	\N	\N	\N	105794	105794	105795
22535	34304	0	applied	\N	\N	\N	\N	105862	105862	105863
22535	34305	1	applied	\N	\N	\N	\N	105864	105864	105865
22535	34306	2	applied	\N	\N	\N	\N	105866	105866	105867
22538	34307	0	applied	\N	\N	\N	\N	105871	105871	105872
22538	34308	1	applied	\N	\N	\N	\N	105873	105873	105874
22538	34309	2	applied	\N	\N	\N	\N	105875	105875	105876
22538	34310	3	applied	\N	\N	\N	\N	105877	105877	105878
22538	34311	4	applied	\N	\N	\N	\N	105879	105879	105880
22538	34312	5	applied	\N	\N	\N	\N	105881	105881	105882
22538	34313	6	applied	\N	\N	\N	\N	105883	105883	105884
22538	34314	7	applied	\N	\N	\N	\N	105885	105885	105886
22538	34315	8	applied	\N	\N	\N	\N	105887	105887	105888
22538	34316	9	applied	\N	\N	\N	\N	105889	105889	105890
22538	34317	10	applied	\N	\N	\N	\N	105891	105891	105892
22538	34318	11	applied	\N	\N	\N	\N	105893	105893	105894
22540	34319	0	applied	\N	\N	\N	\N	105899	105899	105900
22540	34320	1	applied	\N	\N	\N	\N	105901	105901	105902
22540	34321	2	applied	\N	\N	\N	\N	105903	105903	105904
22542	34322	0	applied	\N	\N	\N	\N	105907	105907	105908
22542	34323	1	applied	\N	\N	\N	\N	105910	105910	105911
22542	34324	2	applied	\N	\N	\N	\N	105912	105912	105913
22544	34322	0	applied	\N	\N	\N	\N	105907	105907	105908
22544	34323	1	applied	\N	\N	\N	\N	105910	105910	105911
22550	34345	0	applied	\N	\N	\N	\N	105962	105962	105963
22550	34346	1	applied	\N	\N	\N	\N	105964	105964	105965
22550	34347	2	applied	\N	\N	\N	\N	105966	105966	105967
22550	34348	3	applied	\N	\N	\N	\N	105968	105968	105969
22555	34358	0	applied	\N	\N	\N	\N	105993	105993	105994
22555	34359	1	applied	\N	\N	\N	\N	105995	105995	105996
22555	34360	2	applied	\N	\N	\N	\N	105997	105997	105998
22555	34361	3	applied	\N	\N	\N	\N	105999	105999	106000
22557	34362	0	applied	\N	\N	\N	\N	106005	106005	106006
22557	34363	1	applied	\N	\N	\N	\N	106007	106007	106008
22557	34364	2	applied	\N	\N	\N	\N	106009	106009	106010
22562	34373	0	applied	\N	\N	\N	\N	106032	106032	106033
22562	34374	1	applied	\N	\N	\N	\N	106034	106034	106035
22562	34375	3	applied	\N	\N	\N	\N	106037	106037	106038
22564	34376	0	applied	\N	\N	\N	\N	106040	106040	106041
22564	34377	1	applied	\N	\N	\N	\N	106042	106042	106043
22564	34378	2	applied	\N	\N	\N	\N	106044	106044	106045
22567	34379	0	applied	\N	\N	\N	\N	106049	106049	106050
22567	34380	1	applied	\N	\N	\N	\N	106051	106051	106052
22567	34381	2	applied	\N	\N	\N	\N	106053	106053	106054
22567	34382	3	applied	\N	\N	\N	\N	106055	106055	106056
22567	34383	4	applied	\N	\N	\N	\N	106057	106057	106058
22567	34384	5	applied	\N	\N	\N	\N	106059	106059	106060
22567	34385	6	applied	\N	\N	\N	\N	106061	106061	106062
22567	34386	7	applied	\N	\N	\N	\N	106063	106063	106064
22567	34387	8	applied	\N	\N	\N	\N	106065	106065	106066
22567	34388	9	applied	\N	\N	\N	\N	106067	106067	106068
22567	34389	10	applied	\N	\N	\N	\N	106069	106069	106070
22567	34390	11	applied	\N	\N	\N	\N	106071	106071	106072
22569	34391	0	applied	\N	\N	\N	\N	106077	106077	106078
22569	34392	1	applied	\N	\N	\N	\N	106079	106079	106080
22569	34393	2	applied	\N	\N	\N	\N	106081	106081	106082
22572	34394	0	applied	\N	\N	\N	\N	106084	106084	106085
22572	34395	1	applied	\N	\N	\N	\N	106086	106086	106087
22572	34396	2	applied	\N	\N	\N	\N	106088	106088	106089
22574	34397	0	applied	\N	\N	1000000000	\N	106096	106096	106097
22574	34398	1	applied	\N	\N	\N	\N	106098	106098	106099
22574	34399	2	applied	\N	\N	\N	\N	106100	106100	106101
22574	34400	3	applied	\N	\N	\N	\N	106102	106102	106103
22574	34401	4	applied	\N	\N	\N	\N	106104	106104	106105
22574	34402	5	applied	\N	\N	\N	\N	106106	106106	106107
22574	34403	6	applied	\N	\N	\N	\N	10287	10287	106108
22574	34404	7	applied	\N	\N	\N	\N	106109	106109	106110
22574	34405	8	applied	\N	\N	\N	\N	106111	106111	106112
22574	34406	9	applied	\N	\N	\N	\N	106113	106113	106114
22579	34421	0	applied	\N	\N	\N	\N	106159	106159	106160
22579	34422	1	applied	\N	\N	\N	\N	106161	106161	106162
22579	34423	2	applied	\N	\N	\N	\N	106163	106163	106164
22579	34424	3	applied	\N	\N	\N	\N	106165	106165	106166
22579	34425	4	applied	\N	\N	\N	\N	106167	106167	106168
22581	34426	0	applied	\N	\N	\N	\N	106181	106181	106172
22515	34207	0	applied	\N	\N	\N	\N	105629	105629	105630
22515	34208	1	applied	\N	\N	\N	\N	105631	105631	105632
22515	34209	2	applied	\N	\N	\N	\N	105633	105633	105634
22515	34210	3	applied	\N	\N	\N	\N	105635	105635	105636
22517	34211	0	applied	\N	\N	\N	\N	105642	105642	105643
22517	34212	1	applied	\N	\N	\N	\N	105644	105644	105645
22517	34213	2	applied	\N	\N	\N	\N	105646	105646	105647
22517	34214	3	applied	\N	\N	\N	\N	105648	105648	105649
22517	34215	4	applied	\N	\N	\N	\N	105650	105650	105651
22517	34216	5	applied	\N	\N	\N	\N	105652	105652	105653
22520	34226	0	applied	\N	\N	\N	\N	105676	105676	105677
22520	34227	1	applied	\N	\N	\N	\N	105678	105678	105679
22520	34228	2	applied	\N	\N	\N	\N	105680	105680	105681
22520	34229	3	applied	\N	\N	\N	\N	105682	105682	105683
22520	34230	4	applied	\N	\N	\N	\N	105684	105684	105685
22520	34231	5	applied	\N	\N	\N	\N	105686	105686	105687
22520	34232	6	applied	\N	\N	\N	\N	105688	105688	105689
22520	34233	7	applied	\N	\N	\N	\N	105690	105690	105691
22520	34234	8	applied	\N	\N	\N	\N	105692	105692	105693
22527	34264	0	applied	\N	\N	\N	\N	105764	105764	105765
22527	34265	1	applied	\N	\N	\N	\N	105766	105766	105767
22527	34266	2	applied	\N	\N	\N	\N	105768	105768	105769
22527	34267	3	applied	\N	\N	\N	\N	105770	105770	105771
22527	34268	4	applied	\N	\N	\N	\N	105772	105772	105773
22527	34269	5	applied	\N	\N	\N	\N	105774	105774	105775
22530	34270	0	applied	\N	\N	\N	\N	105781	105781	105782
22530	34271	1	applied	\N	\N	\N	\N	105783	105783	105784
22530	34272	2	applied	\N	\N	\N	\N	105785	105785	105773
22530	34266	3	applied	\N	\N	\N	\N	105768	105768	105786
22530	34273	4	applied	\N	\N	\N	\N	105787	105787	105788
22530	34274	5	applied	\N	\N	\N	\N	105789	105789	105790
22530	34268	6	applied	\N	\N	\N	\N	105772	105772	105791
22532	34277	0	applied	\N	\N	\N	\N	105801	105801	105802
22532	34278	1	applied	\N	\N	\N	\N	105803	105803	105804
22532	34279	2	applied	\N	\N	\N	\N	105805	105805	105806
22532	34280	4	applied	\N	\N	\N	\N	105808	105808	105809
22532	34281	5	applied	\N	\N	\N	\N	105810	105810	105811
22532	34282	6	applied	\N	\N	\N	\N	105812	105812	105813
22543	34322	0	applied	\N	\N	\N	\N	105907	105907	105908
22543	34323	1	applied	\N	\N	\N	\N	105910	105910	105911
22543	34324	2	applied	\N	\N	\N	\N	105912	105912	105913
22545	34325	0	applied	\N	\N	\N	\N	105916	105916	105917
22545	34326	1	applied	\N	\N	\N	\N	105918	105918	105919
22545	34324	2	applied	\N	\N	\N	\N	105912	105912	105920
22545	34327	3	applied	\N	\N	\N	\N	105921	105921	105922
22545	34328	4	applied	\N	\N	\N	\N	105923	105923	105924
22548	34329	0	applied	\N	\N	\N	\N	105927	105927	105928
22548	34330	1	applied	\N	\N	\N	\N	105929	105929	105930
22548	34331	2	applied	\N	\N	\N	\N	105931	105931	105932
22548	34332	3	applied	\N	\N	\N	\N	105933	105933	105934
22548	34333	4	applied	\N	\N	\N	\N	105935	105935	105936
22548	34334	5	applied	\N	\N	\N	\N	105937	105937	105938
22548	34335	6	applied	\N	\N	\N	\N	105939	105939	105940
22548	34336	7	applied	\N	\N	\N	\N	105941	105941	105942
22548	34337	8	applied	\N	\N	\N	\N	105943	105943	105944
22548	34338	9	applied	\N	\N	\N	\N	105945	105945	105946
22548	34339	10	applied	\N	\N	\N	\N	105947	105947	105948
22548	34340	11	applied	\N	\N	\N	\N	105949	105949	105950
22548	34341	12	applied	\N	\N	\N	\N	105951	105951	105952
22551	34349	0	applied	\N	\N	\N	\N	105972	105972	105973
22551	34350	1	applied	\N	\N	\N	\N	105974	105974	105975
22551	34351	2	applied	\N	\N	\N	\N	105976	105976	105977
22551	34352	3	applied	\N	\N	\N	\N	105978	105978	105979
22551	34353	4	applied	\N	\N	\N	\N	105980	105980	105981
22551	34354	5	applied	\N	\N	\N	\N	105982	105982	105983
22560	34362	0	applied	\N	\N	\N	\N	106005	106005	106006
22560	34363	1	applied	\N	\N	\N	\N	106007	106007	106008
22560	34364	2	applied	\N	\N	\N	\N	106009	106009	106010
22565	34376	0	applied	\N	\N	\N	\N	106040	106040	106041
22565	34377	1	applied	\N	\N	\N	\N	106042	106042	106043
22565	34378	2	applied	\N	\N	\N	\N	106044	106044	106045
22568	34379	0	applied	\N	\N	\N	\N	106049	106049	106050
22568	34380	1	applied	\N	\N	\N	\N	106051	106051	106052
22568	34381	2	applied	\N	\N	\N	\N	106053	106053	106054
22568	34382	3	applied	\N	\N	\N	\N	106055	106055	106056
22568	34383	4	applied	\N	\N	\N	\N	106057	106057	106058
22568	34384	5	applied	\N	\N	\N	\N	106059	106059	106060
22568	34385	6	applied	\N	\N	\N	\N	106061	106061	106062
22568	34386	7	applied	\N	\N	\N	\N	106063	106063	106064
22568	34387	8	applied	\N	\N	\N	\N	106065	106065	106066
22568	34388	9	applied	\N	\N	\N	\N	106067	106067	106068
22568	34389	10	applied	\N	\N	\N	\N	106069	106069	106070
22568	34390	11	applied	\N	\N	\N	\N	106071	106071	106072
22570	34394	0	applied	\N	\N	\N	\N	106084	106084	106085
22570	34395	1	applied	\N	\N	\N	\N	106086	106086	106087
22570	34396	2	applied	\N	\N	\N	\N	106088	106088	106089
22577	34410	0	applied	\N	\N	\N	\N	106127	106127	106128
22577	34411	1	applied	\N	\N	\N	\N	106129	106129	106130
22577	34416	2	applied	\N	\N	\N	\N	106143	106143	106144
22577	34412	3	applied	\N	\N	\N	\N	106133	106133	106138
22577	34413	4	applied	\N	\N	\N	\N	106135	106135	106145
22577	34417	5	applied	\N	\N	\N	\N	106146	106146	106147
22577	34414	6	applied	\N	\N	\N	\N	106137	106137	106148
22577	34418	7	applied	\N	\N	\N	\N	106149	106149	106150
22577	34419	8	applied	\N	\N	\N	\N	106151	106151	106152
22577	34420	9	applied	\N	\N	\N	\N	106153	106153	106154
22577	34415	10	applied	\N	\N	\N	\N	106139	106139	106140
22582	34430	0	applied	\N	\N	\N	\N	106185	106185	106186
22582	34431	1	applied	\N	\N	\N	\N	106187	106187	106188
22582	34432	2	applied	\N	\N	\N	\N	106189	106189	106190
22582	34433	3	applied	\N	\N	\N	\N	106191	106191	106192
22582	34434	4	applied	\N	\N	\N	\N	106193	106193	106194
22582	34435	5	applied	\N	\N	\N	\N	106195	106195	106196
22584	34436	0	applied	\N	\N	\N	\N	106199	106199	106200
22584	34437	1	applied	\N	\N	\N	\N	106201	106201	106202
22584	34438	2	applied	\N	\N	\N	\N	106203	106203	106204
22584	34439	3	applied	\N	\N	\N	\N	106205	106205	106206
22584	34440	4	applied	\N	\N	\N	\N	106207	106207	106208
22584	34441	5	applied	\N	\N	\N	\N	106209	106209	106210
22584	34442	6	applied	\N	\N	\N	\N	106211	106211	106212
22584	34443	7	applied	\N	\N	\N	\N	106213	106213	106214
22584	34444	8	applied	\N	\N	\N	\N	106215	106215	106216
22587	34445	0	applied	\N	\N	\N	\N	106222	106222	106223
22587	34446	1	applied	\N	\N	\N	\N	106224	106224	106225
22587	34447	2	applied	\N	\N	\N	\N	106226	106226	106227
22587	34448	3	applied	\N	\N	\N	\N	106228	106228	106229
22597	34475	0	applied	\N	\N	\N	\N	106297	106297	106298
22597	34476	1	applied	\N	\N	\N	\N	106300	106300	106301
22597	34477	2	applied	\N	\N	\N	\N	106302	106302	106303
22605	34503	0	applied	\N	\N	\N	\N	106371	106371	106372
22566	34376	0	applied	\N	\N	\N	\N	106040	106040	106041
22566	34377	1	applied	\N	\N	\N	\N	106042	106042	106043
22566	34378	2	applied	\N	\N	\N	\N	106044	106044	106045
22575	34407	0	applied	\N	\N	\N	\N	106119	106119	106120
22575	34408	1	applied	\N	\N	\N	\N	106121	106121	106122
22575	34409	2	applied	\N	\N	\N	\N	106123	106123	106124
22580	34426	0	applied	\N	\N	\N	\N	106171	106171	106172
22580	34427	1	applied	\N	\N	\N	\N	106173	106173	106174
22580	34428	2	applied	\N	\N	\N	\N	106175	106175	106176
22580	34429	3	applied	\N	\N	\N	\N	106177	106177	106178
22585	34436	0	applied	\N	\N	\N	\N	106199	106199	106200
22585	34437	1	applied	\N	\N	\N	\N	106201	106201	106202
22585	34438	2	applied	\N	\N	\N	\N	106203	106203	106204
22585	34439	3	applied	\N	\N	\N	\N	106205	106205	106206
22585	34440	4	applied	\N	\N	\N	\N	106207	106207	106208
22585	34441	5	applied	\N	\N	\N	\N	106209	106209	106210
22585	34442	6	applied	\N	\N	\N	\N	106211	106211	106212
22585	34443	7	applied	\N	\N	\N	\N	106213	106213	106214
22585	34444	8	applied	\N	\N	\N	\N	106215	106215	106216
22593	34472	0	applied	\N	\N	\N	\N	106288	106288	106289
22593	34471	1	applied	\N	\N	\N	\N	106283	106283	106283
22593	34473	2	applied	\N	\N	\N	\N	106290	106290	106291
22593	34474	3	applied	\N	\N	\N	\N	106292	106292	106293
22598	34478	0	applied	\N	\N	\N	\N	106308	106308	106309
22598	34479	1	applied	\N	\N	\N	\N	106310	106310	106311
22598	34480	2	applied	\N	\N	\N	\N	106312	106312	106313
22598	34481	3	applied	\N	\N	\N	\N	106314	106314	106315
22598	34482	4	applied	\N	\N	\N	\N	106316	106316	106317
22598	34483	5	applied	\N	\N	\N	\N	106318	106318	106319
22598	34484	6	applied	\N	\N	\N	\N	106320	106320	106321
22598	34485	7	applied	\N	\N	\N	\N	106322	106322	106323
22598	34486	8	applied	\N	\N	\N	\N	106324	106324	106325
22598	34487	9	applied	\N	\N	\N	\N	106326	106326	106327
22598	34488	10	applied	\N	\N	\N	\N	106328	106328	106329
22598	34489	11	applied	\N	\N	\N	\N	106330	106330	106331
22598	34490	12	applied	\N	\N	\N	\N	106332	106332	106333
22598	34491	13	applied	\N	\N	\N	\N	106334	106334	106335
22598	34492	14	applied	\N	\N	\N	\N	106336	106336	106337
22603	34497	0	applied	\N	\N	\N	\N	106356	106356	106357
22603	34498	1	applied	\N	\N	\N	\N	106358	106358	106359
22603	34499	2	applied	\N	\N	\N	\N	106360	106360	106361
22603	34500	3	applied	\N	\N	\N	\N	106362	106362	106363
22603	34501	4	applied	\N	\N	\N	\N	106364	106364	106365
22603	34502	5	applied	\N	\N	\N	\N	106366	106366	106367
22606	34503	0	applied	\N	\N	\N	\N	106371	106371	106372
22606	34504	1	applied	\N	\N	\N	\N	106373	106373	106374
22617	34521	0	applied	\N	\N	\N	\N	106427	106427	106428
22617	34522	1	applied	\N	\N	\N	\N	106429	106429	106430
22617	34523	2	applied	\N	\N	\N	\N	106431	106431	106432
22617	34524	3	applied	\N	\N	\N	\N	106433	106433	106434
22626	34532	0	applied	\N	\N	\N	\N	106458	106458	106459
22626	34534	1	applied	\N	\N	\N	\N	106462	106462	106468
22626	34535	2	applied	\N	\N	\N	\N	106464	106464	106469
22640	34559	0	applied	\N	\N	\N	\N	106532	106532	106533
22640	34560	1	applied	\N	\N	\N	\N	106534	106534	106535
22640	34561	2	applied	\N	\N	\N	\N	106536	106536	106537
22647	34565	0	applied	\N	\N	\N	\N	106550	106550	106551
22647	34566	1	applied	\N	\N	\N	\N	106552	106552	106553
22647	34567	2	applied	\N	\N	\N	\N	106554	106554	106555
22647	34568	3	applied	\N	\N	\N	\N	106556	106556	106557
22647	34569	4	applied	\N	\N	\N	\N	106558	106558	106559
22647	34570	5	applied	\N	\N	\N	\N	106560	106560	106561
22647	34571	6	applied	\N	\N	\N	\N	106562	106562	106563
22649	34572	0	applied	\N	\N	\N	\N	106570	106570	106571
22649	34573	1	applied	\N	\N	\N	\N	106572	106572	106573
22649	34574	2	applied	\N	\N	\N	\N	106574	106574	106575
22654	34578	0	applied	\N	\N	\N	\N	106587	106587	106588
22654	34580	1	applied	\N	\N	\N	\N	106591	106591	13857
22654	34581	2	applied	\N	\N	\N	\N	106592	106592	106596
22660	34585	0	applied	\N	\N	\N	\N	106610	106610	106611
22660	34586	1	applied	\N	\N	\N	\N	106612	106612	106613
22660	34587	2	applied	\N	\N	\N	\N	106614	106614	106615
22660	34588	3	applied	\N	\N	\N	\N	106616	106616	106617
22660	34589	4	applied	\N	\N	\N	\N	106618	106618	106619
22660	34590	5	applied	\N	\N	\N	\N	106620	106620	106621
22660	34591	6	applied	\N	\N	\N	\N	106622	106622	106623
22661	34592	0	applied	\N	\N	\N	\N	106626	106626	106627
22661	34593	1	applied	\N	\N	\N	\N	106628	106628	106629
22661	34594	2	applied	\N	\N	\N	\N	106630	106630	106631
22661	34595	3	applied	\N	\N	\N	\N	106632	106632	106633
22661	34596	4	applied	\N	\N	\N	\N	106634	106634	106635
22661	34597	5	applied	\N	\N	\N	\N	106636	106636	106637
22661	34598	6	applied	\N	\N	\N	\N	106638	106638	106639
22661	34599	7	applied	\N	\N	\N	\N	106640	106640	106641
22661	34600	8	applied	\N	\N	\N	\N	106642	106642	106643
22661	34601	9	applied	\N	\N	\N	\N	106644	106644	106645
22678	34638	0	applied	\N	\N	\N	\N	106740	106740	106741
22678	34639	1	applied	\N	\N	\N	\N	106742	106742	106743
22678	34640	2	applied	\N	\N	\N	\N	106744	106744	106745
22680	34641	0	applied	\N	\N	\N	\N	106750	106750	106751
22680	34642	1	applied	\N	\N	\N	\N	106752	106752	106753
22680	34643	2	applied	\N	\N	\N	\N	106754	106754	106755
22687	34654	0	applied	\N	\N	\N	\N	106784	106784	106785
22687	34655	1	applied	\N	\N	\N	\N	106786	106786	106787
22687	34656	2	applied	\N	\N	\N	\N	106788	106788	106789
22687	34657	3	applied	\N	\N	\N	\N	106790	106790	106791
22690	34660	0	applied	\N	\N	\N	\N	106801	106801	106802
22690	34661	1	applied	\N	\N	\N	\N	106803	106803	106804
22690	34662	2	applied	\N	\N	\N	\N	106805	106805	106806
22690	34663	3	applied	\N	\N	\N	\N	106807	106807	106808
22690	34664	4	applied	\N	\N	\N	\N	106809	106809	106810
22690	34665	5	applied	\N	\N	\N	\N	106811	106811	106812
22690	34666	6	applied	\N	\N	\N	\N	106813	106813	106814
22690	34667	7	applied	\N	\N	\N	\N	106815	106815	106816
22692	34668	0	applied	\N	\N	\N	\N	106820	106820	106821
22692	34669	1	applied	\N	\N	\N	\N	106822	106822	106823
22692	34670	2	applied	\N	\N	\N	\N	106824	106824	106825
22695	34671	0	applied	\N	\N	\N	\N	106828	106828	106829
22695	34672	1	applied	\N	\N	\N	\N	106830	106830	106831
22695	34673	2	applied	\N	\N	\N	\N	106832	106832	106833
22695	34674	3	applied	\N	\N	\N	\N	106834	106834	106835
22695	34675	4	applied	\N	\N	\N	\N	106836	106836	106837
22695	34676	5	applied	\N	\N	\N	\N	106838	106838	106839
22698	34686	0	applied	\N	\N	\N	\N	106863	106863	106864
22698	34687	1	applied	\N	\N	\N	\N	106865	106865	106866
22698	34688	2	applied	\N	\N	\N	\N	106867	106867	106868
22698	34689	3	applied	\N	\N	\N	\N	106869	106869	106870
22701	34686	0	applied	\N	\N	\N	\N	106863	106863	106864
22701	34687	1	applied	\N	\N	\N	\N	106865	106865	106866
22701	34688	2	applied	\N	\N	\N	\N	106867	106867	106868
22578	34413	4	applied	\N	\N	\N	\N	106135	106135	106145
22578	34417	5	applied	\N	\N	\N	\N	106146	106146	106147
22578	34414	6	applied	\N	\N	\N	\N	106137	106137	106148
22578	34418	7	applied	\N	\N	\N	\N	106149	106149	106150
22578	34419	8	applied	\N	\N	\N	\N	106151	106151	106152
22578	34420	9	applied	\N	\N	\N	\N	106153	106153	106154
22578	34415	10	applied	\N	\N	\N	\N	106139	106139	106140
22583	34436	0	applied	\N	\N	\N	\N	106199	106199	106200
22583	34437	1	applied	\N	\N	\N	\N	106201	106201	106202
22583	34438	2	applied	\N	\N	\N	\N	106203	106203	106204
22583	34439	3	applied	\N	\N	\N	\N	106205	106205	106206
22583	34440	4	applied	\N	\N	\N	\N	106207	106207	106208
22583	34441	5	applied	\N	\N	\N	\N	106209	106209	106210
22583	34442	6	applied	\N	\N	\N	\N	106211	106211	106212
22583	34443	7	applied	\N	\N	\N	\N	106213	106213	106214
22583	34444	8	applied	\N	\N	\N	\N	106215	106215	106216
22591	34455	0	applied	\N	\N	\N	\N	106249	106249	106250
22591	34456	1	applied	\N	\N	\N	\N	106251	106251	106252
22591	34457	2	applied	\N	\N	\N	\N	106253	106253	106254
22591	34458	3	applied	\N	\N	\N	\N	106255	106255	106256
22591	34459	4	applied	\N	\N	\N	\N	106257	106257	106258
22591	34460	5	applied	\N	\N	\N	\N	106259	106259	106260
22591	34461	6	applied	\N	\N	\N	\N	106261	106261	106262
22591	34462	7	applied	\N	\N	\N	\N	106263	106263	106264
22591	34463	8	applied	\N	\N	\N	\N	106265	106265	106266
22591	34464	9	applied	\N	\N	\N	\N	106267	106267	106268
22591	34465	10	applied	\N	\N	\N	\N	106269	106269	106270
22591	34466	11	applied	\N	\N	\N	\N	106271	106271	106272
22591	34467	12	applied	\N	\N	\N	\N	106273	106273	106274
22591	34468	13	applied	\N	\N	\N	\N	106275	106275	106276
22591	34469	14	applied	\N	\N	\N	\N	106277	106277	106278
22591	34470	15	applied	\N	\N	\N	\N	106279	106279	106280
22594	34472	0	applied	\N	\N	\N	\N	106288	106288	106289
22594	34471	1	applied	\N	\N	\N	\N	106283	106283	106283
22594	34473	2	applied	\N	\N	\N	\N	106290	106290	106291
22594	34474	3	applied	\N	\N	\N	\N	106292	106292	106293
22599	34478	0	applied	\N	\N	\N	\N	106308	106308	106309
22599	34479	1	applied	\N	\N	\N	\N	106310	106310	106311
22599	34480	2	applied	\N	\N	\N	\N	106312	106312	106313
22599	34481	3	applied	\N	\N	\N	\N	106314	106314	106315
22599	34482	4	applied	\N	\N	\N	\N	106316	106316	106317
22599	34483	5	applied	\N	\N	\N	\N	106318	106318	106319
22599	34484	6	applied	\N	\N	\N	\N	106320	106320	106321
22599	34485	7	applied	\N	\N	\N	\N	106322	106322	106323
22599	34486	8	applied	\N	\N	\N	\N	106324	106324	106325
22599	34487	9	applied	\N	\N	\N	\N	106326	106326	106327
22599	34488	10	applied	\N	\N	\N	\N	106328	106328	106329
22599	34489	11	applied	\N	\N	\N	\N	106330	106330	106331
22599	34490	12	applied	\N	\N	\N	\N	106332	106332	106333
22599	34491	13	applied	\N	\N	\N	\N	106334	106334	106335
22599	34492	14	applied	\N	\N	\N	\N	106336	106336	106337
22601	34493	0	applied	\N	\N	\N	\N	106346	106346	106347
22601	34494	1	applied	\N	\N	\N	\N	106348	106348	106349
22601	34495	2	applied	\N	\N	\N	\N	106350	106350	106351
22601	34496	3	applied	\N	\N	\N	\N	106352	106352	106353
22611	34515	0	applied	\N	\N	\N	\N	106401	106401	106402
22611	34516	1	applied	\N	\N	\N	\N	106403	106403	106404
22613	34518	0	applied	\N	\N	\N	\N	106415	106415	106416
22613	34519	1	applied	\N	\N	\N	\N	106417	106417	106399
22613	34512	2	applied	\N	\N	\N	\N	106394	106394	106418
22613	34513	3	applied	\N	\N	\N	\N	106396	106396	106419
22613	34514	4	applied	\N	\N	\N	\N	106398	106398	106420
22613	34517	5	applied	\N	\N	\N	\N	106408	106408	106421
22613	34520	6	applied	\N	\N	\N	\N	106422	106422	106423
22615	34521	0	applied	\N	\N	\N	\N	106427	106427	106428
22615	34522	1	applied	\N	\N	\N	\N	106429	106429	106430
22615	34523	2	applied	\N	\N	\N	\N	106431	106431	106432
22615	34524	3	applied	\N	\N	\N	\N	106433	106433	106434
22618	34521	0	applied	\N	\N	\N	\N	106427	106427	106428
22618	34522	1	applied	\N	\N	\N	\N	106429	106429	106430
22618	34524	2	applied	\N	\N	\N	\N	106433	106433	106437
22620	34525	0	applied	\N	\N	\N	\N	106442	106442	106443
22620	34526	1	applied	\N	\N	\N	\N	106444	106444	106445
22620	34527	2	applied	\N	\N	\N	\N	106446	106446	106447
22622	34528	0	applied	\N	\N	\N	\N	106450	106450	106451
22622	34529	1	applied	\N	\N	\N	\N	106452	106452	89257
22622	34530	2	applied	\N	\N	\N	\N	106453	106453	106454
22622	34531	3	applied	\N	\N	\N	\N	106455	106455	106456
22627	34536	0	applied	\N	\N	\N	\N	106471	106471	106472
22627	34537	1	applied	\N	\N	\N	\N	106473	106473	106474
22627	34538	2	applied	\N	\N	\N	\N	106475	106475	106476
22627	34539	3	applied	\N	\N	\N	\N	106477	106477	106478
22627	34540	4	applied	\N	\N	\N	\N	106479	106479	106480
22627	34541	5	applied	\N	\N	\N	\N	106481	106481	106482
22629	34542	0	applied	\N	\N	\N	\N	106485	106485	106486
22629	34543	1	applied	\N	\N	\N	\N	106487	106487	106488
22629	34544	2	applied	\N	\N	\N	\N	106489	106489	106490
22632	34545	0	applied	\N	\N	\N	\N	106493	106493	106494
22632	34546	1	applied	\N	\N	\N	\N	106495	106495	106496
22632	34547	2	applied	\N	\N	\N	\N	106497	106497	106498
22632	34548	3	applied	\N	\N	\N	\N	106499	106499	106500
22634	34549	0	applied	\N	\N	\N	\N	106507	106507	106508
22634	34550	1	applied	\N	\N	\N	\N	106509	106509	106510
22634	34551	2	applied	\N	\N	\N	\N	106511	106511	106512
22634	34552	3	applied	\N	\N	\N	\N	106513	106513	106514
22634	34553	4	applied	\N	\N	\N	\N	106515	106515	106516
22634	34554	5	applied	\N	\N	\N	\N	106517	106517	106518
22636	34549	0	applied	\N	\N	\N	\N	106507	106507	106508
22636	34550	1	applied	\N	\N	\N	\N	106509	106509	106510
22636	34551	2	applied	\N	\N	\N	\N	106511	106511	106512
22636	34552	3	applied	\N	\N	\N	\N	106513	106513	106514
22636	34553	4	applied	\N	\N	\N	\N	106515	106515	106516
22636	34554	5	applied	\N	\N	\N	\N	106517	106517	106518
22638	34555	0	applied	\N	\N	\N	\N	106522	106522	106523
22638	34556	1	applied	\N	\N	\N	\N	106524	106524	106525
22638	34557	2	applied	\N	\N	\N	\N	106526	106526	106527
22638	34558	3	applied	\N	\N	\N	\N	106528	106528	106529
22641	34559	0	applied	\N	\N	\N	\N	106532	106532	106533
22641	34560	1	applied	\N	\N	\N	\N	106534	106534	106535
22641	34561	2	applied	\N	\N	\N	\N	106536	106536	106537
22643	34562	0	applied	\N	\N	\N	\N	106540	106540	106541
22643	34563	1	applied	\N	\N	\N	\N	106542	106542	106543
22643	34564	2	applied	\N	\N	\N	\N	106544	106544	106545
22645	34562	0	applied	\N	\N	\N	\N	106540	106540	106541
22645	34564	1	applied	\N	\N	\N	\N	106544	106544	106548
22656	34582	0	applied	\N	\N	\N	\N	106599	106599	106600
22656	34583	1	applied	\N	\N	\N	\N	106601	106601	106602
22656	34584	2	applied	\N	\N	\N	\N	106603	106603	106604
22659	34582	0	applied	\N	\N	\N	\N	106599	106599	106600
22659	34583	1	applied	\N	\N	\N	\N	106601	106601	106602
22581	33971	1	applied	\N	\N	\N	\N	105023	105023	105024
22581	33974	2	applied	\N	\N	\N	\N	105034	105034	105035
22581	33977	3	applied	\N	\N	\N	\N	105042	105042	105043
22581	33981	4	applied	\N	\N	\N	\N	105054	105054	105055
22581	33984	5	applied	\N	\N	\N	\N	105062	105062	105063
22581	33985	6	applied	\N	\N	\N	\N	105064	105064	105065
22581	33990	7	applied	\N	\N	\N	\N	105076	105076	105077
22581	33993	8	applied	\N	\N	\N	\N	105088	105088	105089
22581	33996	9	applied	\N	\N	\N	\N	105096	105096	105097
22581	33999	10	applied	\N	\N	\N	\N	105104	105104	105105
22581	34003	11	applied	\N	\N	\N	\N	105116	105116	105117
22581	34006	12	applied	\N	\N	\N	\N	105124	105124	105125
22581	34009	13	applied	\N	\N	\N	\N	105131	105131	105132
22581	34013	14	applied	\N	\N	\N	\N	105165	105165	105166
22581	34236	15	applied	\N	\N	\N	\N	105699	105699	105700
22581	34237	16	applied	\N	\N	\N	\N	105701	105701	105702
22581	34238	17	applied	\N	\N	\N	\N	105703	105703	105704
22581	34239	18	applied	\N	\N	\N	\N	105705	105705	105706
22581	34016	19	applied	\N	\N	\N	\N	105173	105173	105174
22581	34017	20	applied	\N	\N	\N	\N	105175	105175	105176
22581	34037	21	applied	\N	\N	\N	\N	105220	105220	105221
22581	34038	22	applied	\N	\N	\N	\N	105222	105222	105223
22581	34039	23	applied	\N	\N	\N	\N	105224	105224	105225
22581	34043	24	applied	\N	\N	\N	\N	105236	105236	105237
22581	34044	25	applied	\N	\N	\N	\N	105238	105238	105239
22581	34045	26	applied	\N	\N	\N	\N	105240	105240	105241
22581	34046	27	applied	\N	\N	\N	\N	105242	105242	105243
22581	34047	28	applied	\N	\N	\N	\N	105244	105244	105245
22581	34048	29	applied	\N	\N	\N	\N	105246	105246	105247
22581	34052	30	applied	\N	\N	\N	\N	105259	105259	105260
22581	34053	31	applied	\N	\N	\N	\N	105261	105261	105262
22581	34054	32	applied	\N	\N	\N	\N	105263	105263	105264
22581	34055	33	applied	\N	\N	\N	\N	105265	105265	105266
22581	34056	34	applied	\N	\N	\N	\N	105267	105267	105268
22581	34059	35	applied	\N	\N	\N	\N	105276	105276	105277
22581	34060	36	applied	\N	\N	\N	\N	105278	105278	105279
22581	34061	37	applied	\N	\N	\N	\N	105280	105280	105281
22581	34063	38	applied	\N	\N	\N	\N	105284	105284	105285
22581	34064	39	applied	\N	\N	\N	\N	105286	105286	105287
22581	34065	40	applied	\N	\N	\N	\N	105288	105288	105289
22581	34066	41	applied	\N	\N	\N	\N	105290	105290	105291
22581	34067	42	applied	\N	\N	\N	\N	105292	105292	105293
22581	34068	43	applied	\N	\N	\N	\N	105294	105294	105295
22581	34069	44	applied	\N	\N	\N	\N	105296	105296	105297
22581	34070	45	applied	\N	\N	\N	\N	105298	105298	105299
22581	34071	46	applied	\N	\N	\N	\N	105301	105301	105302
22581	34078	47	applied	\N	\N	\N	\N	105317	105317	105318
22581	34079	48	applied	\N	\N	\N	\N	105319	105319	105320
22581	34080	50	applied	\N	\N	\N	\N	105321	105321	105322
22581	34081	51	applied	\N	\N	\N	\N	105323	105323	105324
22581	34082	52	applied	\N	\N	\N	\N	105325	105325	105326
22581	34083	53	applied	\N	\N	\N	\N	105327	105327	105328
22581	34088	54	applied	\N	\N	\N	\N	105342	105342	105343
22581	34089	55	applied	\N	\N	\N	\N	105344	105344	105345
22581	34090	56	applied	\N	\N	\N	\N	105346	105346	105347
22581	34091	57	applied	\N	\N	\N	\N	105348	105348	105349
22581	34093	58	applied	\N	\N	\N	\N	105352	105352	105353
22581	34094	59	applied	\N	\N	\N	\N	105354	105354	105355
22581	34095	60	applied	\N	\N	\N	\N	105356	105356	105357
22581	34096	61	applied	\N	\N	\N	\N	105358	105358	105359
22581	34097	62	applied	\N	\N	\N	\N	105360	105360	105361
22581	34098	63	applied	\N	\N	\N	\N	105362	105362	105363
22581	34099	64	applied	\N	\N	\N	\N	105364	105364	105365
22581	34100	65	applied	\N	\N	\N	\N	105366	105366	105367
22581	34106	66	applied	\N	\N	\N	\N	105380	105380	105381
22581	34107	67	applied	\N	\N	\N	\N	105382	105382	105383
22581	34108	68	applied	\N	\N	\N	\N	105384	105384	105385
22581	34109	69	applied	\N	\N	\N	\N	105386	105386	105387
22581	34110	70	applied	\N	\N	\N	\N	105388	105388	105389
22581	34111	71	applied	\N	\N	\N	\N	105390	105390	105391
22581	34116	72	applied	\N	\N	\N	\N	105401	105401	105402
22581	34123	73	applied	\N	\N	\N	\N	105426	105426	105427
22581	34126	74	applied	\N	\N	\N	\N	105440	105440	105441
22581	34130	75	applied	\N	\N	\N	\N	105448	105448	105449
22581	34131	76	applied	\N	\N	\N	\N	105450	105450	105451
22581	34132	77	applied	\N	\N	\N	\N	105452	105452	105453
22581	34133	78	applied	\N	\N	\N	\N	105454	105454	105455
22581	34134	79	applied	\N	\N	\N	\N	105456	105456	105457
22581	34135	80	applied	\N	\N	\N	\N	105458	105458	105459
22581	34136	81	applied	\N	\N	\N	\N	105460	105460	105461
22581	34137	82	applied	\N	\N	\N	\N	105462	105462	105463
22581	34138	83	applied	\N	\N	\N	\N	105464	105464	105465
22581	34139	84	applied	\N	\N	\N	\N	105466	105466	105467
22581	34140	85	applied	\N	\N	\N	\N	105468	105468	105469
22581	34141	86	applied	\N	\N	\N	\N	105470	105470	105471
22581	34142	87	applied	\N	\N	\N	\N	105472	105472	105473
22581	34143	88	applied	\N	\N	\N	\N	105474	105474	105475
22581	34144	89	applied	\N	\N	\N	\N	105476	105476	105477
22581	34145	90	applied	\N	\N	\N	\N	105478	105478	105479
22581	34146	91	applied	\N	\N	\N	\N	105480	105480	105481
22581	34154	92	applied	\N	\N	\N	\N	105498	105498	105499
22581	34155	93	applied	\N	\N	\N	\N	105500	105500	105501
22581	34156	94	applied	\N	\N	\N	\N	105502	105502	105503
22581	34157	95	applied	\N	\N	\N	\N	105504	105504	105505
22581	34158	96	applied	\N	\N	\N	\N	105506	105506	105507
22581	34159	97	applied	\N	\N	\N	\N	105508	105508	105509
22581	34164	98	applied	\N	\N	\N	\N	105521	105521	105522
22581	34023	99	applied	\N	\N	\N	\N	105190	105190	105191
22581	34024	100	applied	\N	\N	\N	\N	105192	105192	105193
22581	34025	101	applied	\N	\N	\N	\N	105194	105194	105195
22581	34026	102	applied	\N	\N	\N	\N	105196	105196	105197
22581	34036	103	applied	\N	\N	\N	\N	105218	105218	105219
22581	34042	104	applied	\N	\N	\N	\N	105234	105234	105235
22581	34051	105	applied	\N	\N	\N	\N	105257	105257	105258
22581	34062	106	applied	\N	\N	\N	\N	105282	105282	105283
22581	34072	107	applied	\N	\N	\N	\N	105303	105303	105304
22581	34077	108	applied	\N	\N	\N	\N	105315	105315	105316
22581	34087	109	applied	\N	\N	\N	\N	105340	105340	105341
22581	34092	110	applied	\N	\N	\N	\N	105350	105350	105351
22581	34105	111	applied	\N	\N	\N	\N	105378	105378	105379
22581	34114	112	applied	\N	\N	\N	\N	105397	105397	105398
22581	34115	113	applied	\N	\N	\N	\N	105399	105399	105400
22581	34122	114	applied	\N	\N	\N	\N	105424	105424	105425
22581	34127	115	applied	\N	\N	\N	\N	105442	105442	105443
22581	34128	116	applied	\N	\N	\N	\N	105444	105444	105445
22581	34129	117	applied	\N	\N	\N	\N	105446	105446	105447
22581	34153	118	applied	\N	\N	\N	\N	105496	105496	105497
22581	34162	119	applied	\N	\N	\N	\N	105517	105517	105518
22581	34163	120	applied	\N	\N	\N	\N	105519	105519	105520
22581	34182	121	applied	\N	\N	\N	\N	105566	105566	105567
22581	34190	122	applied	\N	\N	\N	\N	105586	105586	105587
22581	34200	123	applied	\N	\N	\N	\N	105609	105609	105610
22581	34204	124	applied	\N	\N	\N	\N	105621	105621	105622
22581	34207	125	applied	\N	\N	\N	\N	105629	105629	105630
22586	34445	0	applied	\N	\N	\N	\N	106222	106222	106223
22586	34446	1	applied	\N	\N	\N	\N	106224	106224	106225
22586	34447	2	applied	\N	\N	\N	\N	106226	106226	106227
22586	34448	3	applied	\N	\N	\N	\N	106228	106228	106229
22588	34449	0	applied	\N	\N	\N	\N	106233	106233	106234
22588	34450	1	applied	\N	\N	\N	\N	106235	106235	106236
22588	34451	2	applied	\N	\N	\N	\N	106237	106237	106238
22589	34452	0	applied	\N	\N	\N	\N	106241	106241	106242
22589	34453	1	applied	\N	\N	\N	\N	106243	106243	106244
22589	34454	2	applied	\N	\N	\N	\N	106245	106245	106246
22592	34426	0	applied	\N	\N	\N	\N	106181	106181	106172
22592	34283	1	applied	\N	\N	\N	\N	105816	105816	105817
22592	34471	2	applied	\N	\N	\N	\N	106283	106283	106283
22592	34284	3	applied	\N	\N	\N	\N	105818	105818	105819
22592	34285	4	applied	\N	\N	\N	\N	105820	105820	105821
22592	34286	5	applied	\N	\N	\N	\N	105822	105822	105823
22592	34289	6	applied	\N	\N	\N	\N	105828	105828	105829
22592	34290	7	applied	\N	\N	\N	\N	105830	105830	105831
22592	34296	8	applied	\N	\N	\N	\N	105844	105844	105845
22592	34307	9	applied	\N	\N	\N	\N	105871	105871	105872
22592	34311	10	applied	\N	\N	\N	\N	105879	105879	105880
22592	34368	11	applied	\N	\N	1000000000	\N	106021	106021	106022
22592	34383	12	applied	\N	\N	\N	\N	106057	106057	106058
22592	34406	13	applied	\N	\N	\N	\N	106113	106113	106114
22592	34386	15	applied	\N	\N	\N	\N	106063	106063	106064
22592	34387	16	applied	\N	\N	\N	\N	106065	106065	106066
22595	34472	0	applied	\N	\N	\N	\N	106288	106288	106289
22595	34471	1	applied	\N	\N	\N	\N	106283	106283	106283
22595	34475	2	applied	\N	\N	\N	\N	106297	106297	106298
22595	34473	3	applied	\N	\N	\N	\N	106290	106290	106291
22595	34474	4	applied	\N	\N	\N	\N	106292	106292	106293
22596	34475	0	applied	\N	\N	\N	\N	106297	106297	106298
22596	34476	1	applied	\N	\N	\N	\N	106300	106300	106301
22596	34477	2	applied	\N	\N	\N	\N	106302	106302	106303
22600	34478	0	applied	\N	\N	\N	\N	106308	106308	106309
22600	34479	1	applied	\N	\N	\N	\N	106310	106310	106311
22600	34480	2	applied	\N	\N	\N	\N	106312	106312	106313
22600	34481	3	applied	\N	\N	\N	\N	106314	106314	106315
22600	34482	4	applied	\N	\N	\N	\N	106316	106316	106317
22600	34483	5	applied	\N	\N	\N	\N	106318	106318	106319
22600	34484	6	applied	\N	\N	\N	\N	106320	106320	106321
22600	34486	7	applied	\N	\N	\N	\N	106324	106324	106341
22600	34487	8	applied	\N	\N	\N	\N	106326	106326	106342
22600	34488	9	applied	\N	\N	\N	\N	106328	106328	106343
22600	34489	10	applied	\N	\N	\N	\N	106330	106330	106344
22602	34497	0	applied	\N	\N	\N	\N	106356	106356	106357
22602	34498	1	applied	\N	\N	\N	\N	106358	106358	106359
22602	34499	2	applied	\N	\N	\N	\N	106360	106360	106361
22602	34500	3	applied	\N	\N	\N	\N	106362	106362	106363
22602	34501	4	applied	\N	\N	\N	\N	106364	106364	106365
22602	34502	5	applied	\N	\N	\N	\N	106366	106366	106367
22604	34503	0	applied	\N	\N	\N	\N	106371	106371	106372
22604	34504	1	applied	\N	\N	\N	\N	106373	106373	106374
22607	34505	0	applied	\N	\N	\N	\N	106379	106379	106380
22607	34506	1	applied	\N	\N	\N	\N	106381	106381	106382
22607	34507	2	applied	\N	\N	\N	\N	106383	106383	106384
22607	34508	3	applied	\N	\N	\N	\N	106385	106385	106386
22607	34509	4	applied	\N	\N	\N	\N	106387	106387	106388
22607	34510	5	applied	\N	\N	\N	\N	106389	106389	106390
22607	34511	6	applied	\N	\N	\N	\N	106391	106391	106392
22609	34515	0	applied	\N	\N	\N	\N	106401	106401	106402
22609	34516	1	applied	\N	\N	\N	\N	106403	106403	106404
22609	34512	2	applied	\N	\N	\N	\N	106394	106394	106405
22609	34513	3	applied	\N	\N	\N	\N	106396	106396	106406
22609	34514	4	applied	\N	\N	\N	\N	106398	106398	106407
22609	34517	5	applied	\N	\N	\N	\N	106408	106408	106409
22612	34515	0	applied	\N	\N	\N	\N	106401	106401	106402
22612	34516	1	applied	\N	\N	\N	\N	106403	106403	106404
22612	34512	2	applied	\N	\N	\N	\N	106394	106394	106405
22612	34513	3	applied	\N	\N	\N	\N	106396	106396	106406
22612	34514	4	applied	\N	\N	\N	\N	106398	106398	106407
22612	34517	5	applied	\N	\N	\N	\N	106408	106408	106409
22614	34518	0	applied	\N	\N	\N	\N	106415	106415	106416
22614	34519	1	applied	\N	\N	\N	\N	106417	106417	106399
22614	34512	2	applied	\N	\N	\N	\N	106394	106394	106418
22614	34513	3	applied	\N	\N	\N	\N	106396	106396	106419
22614	34514	4	applied	\N	\N	\N	\N	106398	106398	106420
22614	34517	5	applied	\N	\N	\N	\N	106408	106408	106421
22614	34520	6	applied	\N	\N	\N	\N	106422	106422	106423
22623	34532	0	applied	\N	\N	\N	\N	106458	106458	106459
22623	34533	1	applied	\N	\N	\N	\N	106460	106460	106461
22623	34534	2	applied	\N	\N	\N	\N	106462	106462	106463
22623	34535	3	applied	\N	\N	\N	\N	106464	106464	106465
22625	34532	0	applied	\N	\N	\N	\N	106458	106458	106459
22625	34533	1	applied	\N	\N	\N	\N	106460	106460	106461
22625	34534	2	applied	\N	\N	\N	\N	106462	106462	106463
22625	34535	3	applied	\N	\N	\N	\N	106464	106464	106465
22628	34536	0	applied	\N	\N	\N	\N	106471	106471	106472
22628	34537	1	applied	\N	\N	\N	\N	106473	106473	106474
22628	34538	2	applied	\N	\N	\N	\N	106475	106475	106476
22628	34539	3	applied	\N	\N	\N	\N	106477	106477	106478
22628	34540	4	applied	\N	\N	\N	\N	106479	106479	106480
22628	34541	5	applied	\N	\N	\N	\N	106481	106481	106482
22630	34545	0	applied	\N	\N	\N	\N	106493	106493	106494
22630	34546	1	applied	\N	\N	\N	\N	106495	106495	106496
22630	34547	2	applied	\N	\N	\N	\N	106497	106497	106498
22630	34548	3	applied	\N	\N	\N	\N	106499	106499	106500
22633	34545	0	applied	\N	\N	\N	\N	106493	106493	106494
22633	34546	1	applied	\N	\N	\N	\N	106495	106495	106496
22633	34547	2	applied	\N	\N	\N	\N	106497	106497	106498
22633	34548	3	applied	\N	\N	\N	\N	106499	106499	106500
22639	34555	0	applied	\N	\N	\N	\N	106522	106522	106523
22639	34556	1	applied	\N	\N	\N	\N	106524	106524	106525
22639	34557	2	applied	\N	\N	\N	\N	106526	106526	106527
22639	34558	3	applied	\N	\N	\N	\N	106528	106528	106529
22644	34562	0	applied	\N	\N	\N	\N	106540	106540	106541
22644	34563	1	applied	\N	\N	\N	\N	106542	106542	106543
22644	34564	2	applied	\N	\N	\N	\N	106544	106544	106545
22648	34565	0	applied	\N	\N	\N	\N	106550	106550	106551
22648	34566	1	applied	\N	\N	\N	\N	106552	106552	106553
22648	34567	2	applied	\N	\N	\N	\N	106554	106554	106555
22648	34568	3	applied	\N	\N	\N	\N	106556	106556	106557
22648	34569	4	applied	\N	\N	\N	\N	106558	106558	106559
22648	34570	5	applied	\N	\N	\N	\N	106560	106560	106561
22648	34571	6	applied	\N	\N	\N	\N	106562	106562	106563
22650	34575	0	applied	\N	\N	\N	\N	106577	106577	106578
22605	34504	1	applied	\N	\N	\N	\N	106373	106373	106374
22608	34505	0	applied	\N	\N	\N	\N	106379	106379	106380
22608	34506	1	applied	\N	\N	\N	\N	106381	106381	106382
22608	34507	2	applied	\N	\N	\N	\N	106383	106383	106384
22608	34508	3	applied	\N	\N	\N	\N	106385	106385	106386
22608	34509	4	applied	\N	\N	\N	\N	106387	106387	106388
22608	34510	5	applied	\N	\N	\N	\N	106389	106389	106390
22608	34511	6	applied	\N	\N	\N	\N	106391	106391	106392
22608	34512	7	applied	\N	\N	\N	\N	106394	106394	106395
22608	34513	8	applied	\N	\N	\N	\N	106396	106396	106397
22608	34514	9	applied	\N	\N	\N	\N	106398	106398	106399
22610	34515	0	applied	\N	\N	\N	\N	106401	106401	106402
22610	34516	1	applied	\N	\N	\N	\N	106403	106403	106404
22616	34522	0	applied	\N	\N	\N	\N	106429	106429	106430
22616	34524	1	applied	\N	\N	\N	\N	106433	106433	106437
22619	34521	0	applied	\N	\N	\N	\N	106427	106427	106428
22619	34522	1	applied	\N	\N	\N	\N	106429	106429	106430
22619	34523	2	applied	\N	\N	\N	\N	106431	106431	106432
22619	34524	3	applied	\N	\N	\N	\N	106433	106433	106434
22621	34521	0	applied	\N	\N	\N	\N	106427	106427	106428
22621	34525	1	applied	\N	\N	\N	\N	106442	106442	106443
22621	34523	2	applied	\N	\N	\N	\N	106431	106431	106434
22621	34526	3	applied	\N	\N	\N	\N	106444	106444	106445
22621	34527	4	applied	\N	\N	\N	\N	106446	106446	106447
22624	34532	0	applied	\N	\N	\N	\N	106458	106458	106459
22624	34533	1	applied	\N	\N	\N	\N	106460	106460	106461
22624	34534	2	applied	\N	\N	\N	\N	106462	106462	106463
22624	34535	3	applied	\N	\N	\N	\N	106464	106464	106465
22631	34545	0	applied	\N	\N	\N	\N	106493	106493	106494
22631	34546	1	applied	\N	\N	\N	\N	106495	106495	106496
22631	34547	2	applied	\N	\N	\N	\N	106497	106497	106498
22631	34548	3	applied	\N	\N	\N	\N	106499	106499	106500
22635	34549	0	applied	\N	\N	\N	\N	106507	106507	106508
22635	34550	1	applied	\N	\N	\N	\N	106509	106509	106510
22635	34551	2	applied	\N	\N	\N	\N	106511	106511	106512
22635	34552	3	applied	\N	\N	\N	\N	106513	106513	106514
22635	34553	4	applied	\N	\N	\N	\N	106515	106515	106516
22635	34554	5	applied	\N	\N	\N	\N	106517	106517	106518
22637	34555	0	applied	\N	\N	\N	\N	106522	106522	106523
22637	34556	1	applied	\N	\N	\N	\N	106524	106524	106525
22637	34557	2	applied	\N	\N	\N	\N	106526	106526	106527
22637	34558	3	applied	\N	\N	\N	\N	106528	106528	106529
22642	34562	0	applied	\N	\N	\N	\N	106540	106540	106541
22642	34563	1	applied	\N	\N	\N	\N	106542	106542	106543
22642	34564	2	applied	\N	\N	\N	\N	106544	106544	106545
22646	34565	0	applied	\N	\N	\N	\N	106550	106550	106551
22646	34566	1	applied	\N	\N	\N	\N	106552	106552	106553
22646	34567	2	applied	\N	\N	\N	\N	106554	106554	106555
22646	34568	3	applied	\N	\N	\N	\N	106556	106556	106557
22646	34569	4	applied	\N	\N	\N	\N	106558	106558	106559
22646	34570	5	applied	\N	\N	\N	\N	106560	106560	106561
22646	34571	6	applied	\N	\N	\N	\N	106562	106562	106563
22651	34575	0	applied	\N	\N	\N	\N	106577	106577	106578
22651	34576	1	applied	\N	\N	\N	\N	106579	106579	106580
22651	34577	2	applied	\N	\N	\N	\N	106581	106581	106582
22653	34578	0	applied	\N	\N	\N	\N	106587	106587	106588
22653	34579	1	applied	\N	\N	\N	\N	106589	106589	106590
22653	34580	2	applied	\N	\N	\N	\N	106591	106591	13857
22653	34581	3	applied	\N	\N	\N	\N	106592	106592	106593
22655	34578	0	applied	\N	\N	\N	\N	106587	106587	106588
22655	34579	1	applied	\N	\N	\N	\N	106589	106589	106590
22655	34580	2	applied	\N	\N	\N	\N	106591	106591	13857
22655	34581	3	applied	\N	\N	\N	\N	106592	106592	106593
22658	34582	0	applied	\N	\N	\N	\N	106599	106599	106600
22658	34583	1	applied	\N	\N	\N	\N	106601	106601	106602
22658	34584	2	applied	\N	\N	\N	\N	106603	106603	106604
22663	34602	0	applied	\N	\N	\N	\N	106648	106648	106649
22663	34603	1	applied	\N	\N	\N	\N	106650	106650	106651
22663	34604	2	applied	\N	\N	\N	\N	106652	106652	106653
22663	34605	3	applied	\N	\N	\N	\N	106654	106654	106655
22663	34606	4	applied	\N	\N	\N	\N	106656	106656	106657
22663	34607	5	applied	\N	\N	\N	\N	106658	106658	106659
22663	34608	6	applied	\N	\N	\N	\N	106660	106660	106661
22663	34609	7	applied	\N	\N	\N	\N	106662	106662	106663
22663	34610	8	applied	\N	\N	\N	\N	106664	106664	106665
22668	34611	0	applied	\N	\N	\N	\N	106667	106667	106668
22668	34612	1	applied	\N	\N	\N	\N	106669	106669	106670
22668	34613	2	applied	\N	\N	\N	\N	106671	106671	106672
22668	34614	3	applied	\N	\N	\N	\N	106673	106673	106674
22670	34615	0	applied	\N	\N	\N	\N	106679	106679	106680
22670	34616	1	applied	\N	\N	\N	\N	106681	106681	106682
22670	34617	2	applied	\N	\N	\N	\N	106683	106683	106684
22673	34625	0	applied	\N	\N	\N	\N	106704	106704	106705
22673	34626	1	applied	\N	\N	\N	\N	106706	106706	106707
22673	34627	2	applied	\N	\N	\N	\N	106708	106708	106709
22675	34631	0	applied	\N	\N	\N	\N	106722	106722	106723
22675	34632	1	applied	\N	\N	\N	\N	106724	106724	106725
22675	34633	2	applied	\N	\N	\N	\N	106726	106726	106727
22675	34634	3	applied	\N	\N	\N	\N	106728	106728	106729
22685	34651	0	applied	\N	\N	\N	\N	106774	106774	106775
22685	34652	1	applied	\N	\N	\N	\N	106776	106776	106777
22685	34653	2	applied	\N	\N	\N	\N	106778	106778	106779
22689	34658	0	applied	\N	\N	\N	\N	106797	106797	106798
22689	34659	1	applied	\N	\N	\N	\N	106799	106799	106800
22694	34671	0	applied	\N	\N	\N	\N	106828	106828	106829
22694	34672	1	applied	\N	\N	\N	\N	106830	106830	106831
22694	34673	2	applied	\N	\N	\N	\N	106832	106832	106833
22694	34674	3	applied	\N	\N	\N	\N	106834	106834	106835
22694	34675	4	applied	\N	\N	\N	\N	106836	106836	106837
22694	34676	5	applied	\N	\N	\N	\N	106838	106838	106839
22697	34686	0	applied	\N	\N	\N	\N	106863	106863	106864
22697	34687	1	applied	\N	\N	\N	\N	106865	106865	106866
22697	34688	2	applied	\N	\N	\N	\N	106867	106867	106868
22697	34689	3	applied	\N	\N	\N	\N	106869	106869	106870
22700	34686	0	applied	\N	\N	\N	\N	106863	106863	106864
22700	34687	1	applied	\N	\N	\N	\N	106865	106865	106866
22700	34688	2	applied	\N	\N	\N	\N	106867	106867	106868
22700	34689	3	applied	\N	\N	\N	\N	106869	106869	106870
22704	34696	0	applied	\N	\N	\N	\N	106894	106894	106895
22704	34697	1	applied	\N	\N	\N	\N	106896	106896	106897
22704	34698	2	applied	\N	\N	\N	\N	106898	106898	106899
22704	34699	3	applied	\N	\N	\N	\N	106900	106900	106901
22704	34700	4	applied	\N	\N	\N	\N	106902	106902	106903
22704	34701	5	applied	\N	\N	\N	\N	106904	106904	106905
22704	34702	6	applied	\N	\N	\N	\N	106906	106906	106907
22707	34703	0	applied	\N	\N	\N	\N	106911	106911	106912
22707	34704	1	applied	\N	\N	\N	\N	106913	106913	106914
22709	34705	0	applied	\N	\N	\N	\N	106920	106920	106921
22709	34706	1	applied	\N	\N	\N	\N	106922	106922	106923
22709	34707	2	applied	\N	\N	\N	\N	106924	106924	106925
22650	34576	1	applied	\N	\N	\N	\N	106579	106579	106580
22650	34577	2	applied	\N	\N	\N	\N	106581	106581	106582
22652	34575	0	applied	\N	\N	\N	\N	106577	106577	106578
22652	34576	1	applied	\N	\N	\N	\N	106579	106579	106580
22652	34577	2	applied	\N	\N	\N	\N	106581	106581	106582
22657	34582	0	applied	\N	\N	\N	\N	106599	106599	106600
22657	34583	1	applied	\N	\N	\N	\N	106601	106601	106602
22657	34584	2	applied	\N	\N	\N	\N	106603	106603	106604
22662	34592	0	applied	\N	\N	\N	\N	106626	106626	106627
22662	34593	1	applied	\N	\N	\N	\N	106628	106628	106629
22662	34594	2	applied	\N	\N	\N	\N	106630	106630	106631
22662	34595	3	applied	\N	\N	\N	\N	106632	106632	106633
22662	34596	4	applied	\N	\N	\N	\N	106634	106634	106635
22662	34597	5	applied	\N	\N	\N	\N	106636	106636	106637
22662	34598	6	applied	\N	\N	\N	\N	106638	106638	106639
22662	34599	7	applied	\N	\N	\N	\N	106640	106640	106641
22662	34600	8	applied	\N	\N	\N	\N	106642	106642	106643
22662	34601	9	applied	\N	\N	\N	\N	106644	106644	106645
22667	34611	0	applied	\N	\N	\N	\N	106667	106667	106668
22667	34612	1	applied	\N	\N	\N	\N	106669	106669	106670
22667	34613	2	applied	\N	\N	\N	\N	106671	106671	106672
22667	34614	3	applied	\N	\N	\N	\N	106673	106673	106674
22669	34615	0	applied	\N	\N	\N	\N	106679	106679	106680
22669	34616	1	applied	\N	\N	\N	\N	106681	106681	106682
22669	34617	2	applied	\N	\N	\N	\N	106683	106683	106684
22672	34625	0	applied	\N	\N	\N	\N	106704	106704	106705
22672	34626	1	applied	\N	\N	\N	\N	106706	106706	106707
22672	34627	2	applied	\N	\N	\N	\N	106708	106708	106709
22674	34628	0	applied	\N	\N	\N	\N	106714	106714	106715
22674	34629	1	applied	\N	\N	\N	\N	106716	106716	106717
22674	34630	2	applied	\N	\N	\N	\N	106718	106718	106719
22677	34635	0	applied	\N	\N	\N	\N	106732	106732	106733
22677	34636	1	applied	\N	\N	\N	\N	106734	106734	106735
22677	34637	2	applied	\N	\N	\N	\N	106736	106736	106737
22679	34638	0	applied	\N	\N	\N	\N	106740	106740	106741
22679	34639	1	applied	\N	\N	\N	\N	106742	106742	106743
22679	34640	2	applied	\N	\N	\N	\N	106744	106744	106745
22682	34644	0	applied	\N	\N	\N	\N	106757	106757	106758
22682	34645	1	applied	\N	\N	\N	\N	106759	106759	106760
22682	34646	2	applied	\N	\N	\N	\N	106761	106761	106762
22682	34647	3	applied	\N	\N	\N	\N	106763	106763	106764
22682	34648	4	applied	\N	\N	\N	\N	106765	106765	106766
22682	34649	5	applied	\N	\N	\N	\N	106767	106767	106768
22682	34650	6	applied	\N	\N	\N	\N	106769	106769	106770
22684	34651	0	applied	\N	\N	\N	\N	106774	106774	106775
22684	34652	1	applied	\N	\N	\N	\N	106776	106776	106777
22684	34653	2	applied	\N	\N	\N	\N	106778	106778	106779
22686	34654	0	applied	\N	\N	\N	\N	106784	106784	106785
22686	34655	1	applied	\N	\N	\N	\N	106786	106786	106787
22686	34656	2	applied	\N	\N	\N	\N	106788	106788	106789
22686	34657	3	applied	\N	\N	\N	\N	106790	106790	106791
22706	34703	0	applied	\N	\N	\N	\N	106911	106911	106912
22706	34704	1	applied	\N	\N	\N	\N	106913	106913	106914
22708	34703	0	applied	\N	\N	\N	\N	106911	106911	106912
22708	34704	1	applied	\N	\N	\N	\N	106913	106913	106914
22711	34710	0	applied	\N	\N	\N	\N	106932	106932	106933
22711	34711	1	applied	\N	\N	\N	\N	106934	106934	106935
22711	34712	2	applied	\N	\N	\N	\N	106936	106936	106937
22711	34713	3	applied	\N	\N	\N	\N	106938	106938	106939
22711	34714	4	applied	\N	\N	\N	\N	106940	106940	106941
22711	34715	5	applied	\N	\N	\N	\N	106942	106942	106943
22713	34710	0	applied	\N	\N	\N	\N	106932	106932	106933
22713	34711	1	applied	\N	\N	\N	\N	106934	106934	106935
22713	34712	2	applied	\N	\N	\N	\N	106936	106936	106937
22713	34713	3	applied	\N	\N	\N	\N	106938	106938	106939
22713	34714	4	applied	\N	\N	\N	\N	106940	106940	106941
22713	34715	5	applied	\N	\N	\N	\N	106942	106942	106943
22716	34722	0	applied	\N	\N	\N	\N	106961	106961	106962
22716	34723	1	applied	\N	\N	\N	\N	106963	106963	106964
22716	34724	2	applied	\N	\N	\N	\N	106965	106965	106966
22723	34729	0	applied	\N	\N	\N	\N	106983	106983	106984
22723	34728	1	applied	\N	\N	\N	\N	106979	106979	106980
22723	34730	2	applied	\N	\N	\N	\N	106985	106985	106986
22723	34731	3	applied	\N	\N	\N	\N	106987	106987	106988
22726	34734	0	applied	\N	\N	\N	\N	106997	106997	106998
22726	34735	1	applied	\N	\N	\N	\N	106999	106999	107000
22726	34736	2	applied	\N	\N	\N	\N	107001	107001	107002
22726	34737	3	applied	\N	\N	\N	\N	107003	107003	107004
22731	34744	0	applied	\N	\N	\N	\N	107022	107022	107023
22731	34745	1	applied	\N	\N	\N	\N	107024	107024	107025
22731	34746	2	applied	\N	\N	\N	\N	107026	107026	107027
22737	34753	0	applied	\N	\N	\N	\N	107042	107042	107043
22737	34754	1	applied	\N	\N	\N	\N	107044	107044	107045
22737	34755	2	applied	\N	\N	\N	\N	107046	107046	107047
22737	34756	3	applied	\N	\N	\N	\N	107048	107048	107049
22737	34757	4	applied	\N	\N	\N	\N	107050	107050	107051
22737	34758	5	applied	\N	\N	\N	\N	107052	107052	107053
22737	34759	6	applied	\N	\N	\N	\N	107054	107054	107055
22737	34760	7	applied	\N	\N	\N	\N	107056	107056	107057
22737	34761	8	applied	\N	\N	\N	\N	107058	107058	107059
22737	34762	9	applied	\N	\N	\N	\N	107060	107060	107061
22737	34763	10	applied	\N	\N	\N	\N	107062	107062	107063
22737	34764	11	applied	\N	\N	\N	\N	107064	107064	107065
22737	34765	12	applied	\N	\N	\N	\N	107066	107066	107067
22737	34766	13	applied	\N	\N	\N	\N	107068	107068	107069
22740	34773	0	applied	\N	\N	\N	\N	107087	107087	107088
22740	34774	1	applied	\N	\N	\N	\N	107089	107089	107090
22740	34775	2	applied	\N	\N	\N	\N	107091	107091	79379
22740	34776	3	applied	\N	\N	\N	\N	107092	107092	107093
22742	34781	0	applied	\N	\N	\N	\N	107107	107107	107108
22742	34782	1	applied	\N	\N	\N	\N	107109	107109	107110
22742	34783	2	applied	\N	\N	\N	\N	107111	107111	107112
22742	34784	3	applied	\N	\N	\N	\N	107113	107113	107114
22742	34785	4	applied	\N	\N	\N	\N	107115	107115	107116
22742	34786	5	applied	\N	\N	\N	\N	107117	107117	107118
22745	34794	0	applied	\N	\N	\N	\N	107140	107140	107141
22745	34795	1	applied	\N	\N	\N	\N	107142	107142	107143
22745	34792	2	applied	\N	\N	\N	\N	107132	107132	107144
22745	34793	3	applied	\N	\N	\N	\N	107134	107134	107145
22745	34796	4	applied	\N	\N	\N	\N	107146	107146	107147
22751	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22751	34803	1	applied	\N	\N	\N	\N	107163	107163	107169
22754	34471	0	applied	\N	\N	\N	\N	106283	106283	106283
22754	34654	1	applied	\N	\N	\N	\N	107174	107174	106785
22754	34660	2	applied	\N	\N	\N	\N	107175	107175	106802
22754	34661	3	applied	\N	\N	\N	\N	107176	107176	106804
22754	34236	4	applied	\N	\N	\N	\N	105699	105699	105700
22754	34237	5	applied	\N	\N	\N	\N	105701	105701	105702
22754	34238	6	applied	\N	\N	\N	\N	105703	105703	105704
22754	34239	7	applied	\N	\N	\N	\N	105705	105705	105706
22671	34618	0	applied	\N	\N	\N	\N	106689	106689	106690
22671	34619	1	applied	\N	\N	\N	\N	106691	106691	106692
22671	34620	2	applied	\N	\N	\N	\N	106693	106693	106694
22671	34621	3	applied	\N	\N	\N	\N	106695	106695	106696
22671	34622	4	applied	\N	\N	\N	\N	106697	106697	106698
22671	34623	5	applied	\N	\N	\N	\N	106699	106699	106700
22671	34624	6	applied	\N	\N	\N	\N	106701	106701	106702
22676	34635	0	applied	\N	\N	\N	\N	106732	106732	106733
22676	34636	1	applied	\N	\N	\N	\N	106734	106734	106735
22676	34637	2	applied	\N	\N	\N	\N	106736	106736	106737
22681	34644	0	applied	\N	\N	\N	\N	106757	106757	106758
22681	34645	1	applied	\N	\N	\N	\N	106759	106759	106760
22681	34646	2	applied	\N	\N	\N	\N	106761	106761	106762
22681	34647	3	applied	\N	\N	\N	\N	106763	106763	106764
22681	34648	4	applied	\N	\N	\N	\N	106765	106765	106766
22681	34649	5	applied	\N	\N	\N	\N	106767	106767	106768
22681	34650	6	applied	\N	\N	\N	\N	106769	106769	106770
22688	34654	0	applied	\N	\N	\N	\N	106784	106784	106785
22688	34655	1	applied	\N	\N	\N	\N	106786	106786	106787
22688	34656	2	applied	\N	\N	\N	\N	106788	106788	106789
22688	34657	3	applied	\N	\N	\N	\N	106790	106790	106791
22691	34660	0	applied	\N	\N	\N	\N	106801	106801	106802
22691	34661	1	applied	\N	\N	\N	\N	106803	106803	106804
22691	34662	2	applied	\N	\N	\N	\N	106805	106805	106806
22691	34663	3	applied	\N	\N	\N	\N	106807	106807	106808
22691	34664	4	applied	\N	\N	\N	\N	106809	106809	106810
22691	34665	5	applied	\N	\N	\N	\N	106811	106811	106812
22691	34666	6	applied	\N	\N	\N	\N	106813	106813	106814
22691	34667	7	applied	\N	\N	\N	\N	106815	106815	106816
22693	34671	0	applied	\N	\N	\N	\N	106828	106828	106829
22693	34672	1	applied	\N	\N	\N	\N	106830	106830	106831
22693	34673	2	applied	\N	\N	\N	\N	106832	106832	106833
22693	34674	3	applied	\N	\N	\N	\N	106834	106834	106835
22693	34675	4	applied	\N	\N	\N	\N	106836	106836	106837
22693	34676	5	applied	\N	\N	\N	\N	106838	106838	106839
22696	34677	0	applied	\N	\N	\N	\N	106844	106844	106845
22696	34678	1	applied	\N	\N	\N	\N	106846	106846	106847
22696	34679	2	applied	\N	\N	\N	\N	106848	106848	106849
22696	34680	3	applied	\N	\N	\N	\N	106850	106850	106851
22696	34681	4	applied	\N	\N	\N	\N	106852	106852	106853
22696	34682	5	applied	\N	\N	\N	\N	106854	106854	106855
22696	34683	6	applied	\N	\N	\N	\N	106856	106856	106857
22696	34684	7	applied	\N	\N	\N	\N	106858	106858	106859
22696	34685	8	applied	\N	\N	\N	\N	106860	106860	106861
22699	34686	0	applied	\N	\N	\N	\N	106863	106863	106864
22699	34687	1	applied	\N	\N	\N	\N	106865	106865	106866
22699	34688	2	applied	\N	\N	\N	\N	106867	106867	106868
22699	34689	3	applied	\N	\N	\N	\N	106869	106869	106870
22703	34690	0	applied	\N	\N	\N	\N	106878	106878	106879
22703	34691	1	applied	\N	\N	\N	\N	106880	106880	106881
22703	34692	2	applied	\N	\N	\N	\N	106882	106882	106883
22703	34693	3	applied	\N	\N	\N	\N	106884	106884	106885
22703	34694	4	applied	\N	\N	\N	\N	106886	106886	106887
22703	34695	5	applied	\N	\N	\N	\N	106888	106888	106889
22710	34705	0	applied	\N	\N	\N	\N	106920	106920	106921
22710	34706	1	applied	\N	\N	\N	\N	106922	106922	106923
22710	34707	2	applied	\N	\N	\N	\N	106924	106924	106925
22710	34708	3	applied	\N	\N	\N	\N	106926	106926	106927
22710	34709	4	applied	\N	\N	\N	\N	106928	106928	106929
22718	34725	0	applied	\N	\N	\N	\N	106970	106970	106971
22718	34726	1	applied	\N	\N	\N	\N	106972	106972	106973
22722	34727	0	applied	\N	\N	\N	\N	106977	106977	106978
22725	34734	0	applied	\N	\N	\N	\N	106997	106997	106998
22725	34735	1	applied	\N	\N	\N	\N	106999	106999	107000
22725	34736	2	applied	\N	\N	\N	\N	107001	107001	107002
22725	34737	3	applied	\N	\N	\N	\N	107003	107003	107004
22728	34738	0	applied	\N	\N	\N	\N	107007	107007	107008
22728	34739	1	applied	\N	\N	\N	\N	107009	107009	107010
22733	34750	0	applied	\N	\N	\N	\N	107036	107036	107037
22733	34751	1	applied	\N	\N	\N	\N	107038	107038	107039
22733	34752	2	applied	\N	\N	\N	\N	107040	107040	107041
22736	34753	0	applied	\N	\N	\N	\N	107042	107042	107043
22736	34754	1	applied	\N	\N	\N	\N	107044	107044	107045
22736	34755	2	applied	\N	\N	\N	\N	107046	107046	107047
22736	34756	3	applied	\N	\N	\N	\N	107048	107048	107049
22736	34757	4	applied	\N	\N	\N	\N	107050	107050	107051
22736	34758	5	applied	\N	\N	\N	\N	107052	107052	107053
22736	34759	6	applied	\N	\N	\N	\N	107054	107054	107055
22736	34760	7	applied	\N	\N	\N	\N	107056	107056	107057
22736	34761	8	applied	\N	\N	\N	\N	107058	107058	107059
22736	34762	9	applied	\N	\N	\N	\N	107060	107060	107061
22736	34763	10	applied	\N	\N	\N	\N	107062	107062	107063
22736	34764	11	applied	\N	\N	\N	\N	107064	107064	107065
22736	34765	12	applied	\N	\N	\N	\N	107066	107066	107067
22736	34766	13	applied	\N	\N	\N	\N	107068	107068	107069
22739	34773	0	applied	\N	\N	\N	\N	107087	107087	107088
22739	34774	1	applied	\N	\N	\N	\N	107089	107089	107090
22739	34775	2	applied	\N	\N	\N	\N	107091	107091	79379
22739	34776	3	applied	\N	\N	\N	\N	107092	107092	107093
22741	34777	0	applied	\N	\N	\N	\N	107097	107097	107098
22741	34778	1	applied	\N	\N	\N	\N	107099	107099	107100
22741	34779	2	applied	\N	\N	\N	\N	107101	107101	107102
22741	34780	3	applied	\N	\N	\N	\N	107103	107103	107104
22747	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22747	34802	1	applied	\N	\N	\N	\N	107161	107161	107162
22747	34803	2	applied	\N	\N	\N	\N	107163	107163	107164
22750	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22750	34803	1	applied	\N	\N	\N	\N	107163	107163	107169
22756	34804	0	applied	\N	\N	\N	\N	107183	107183	107184
22756	34805	1	applied	\N	\N	\N	\N	107185	107185	107186
22756	34806	2	applied	\N	\N	\N	\N	107187	107187	107188
22756	34807	3	applied	\N	\N	\N	\N	107189	107189	107190
22756	34808	4	applied	\N	\N	\N	\N	107191	107191	107192
22756	34809	5	applied	\N	\N	\N	\N	107193	107193	107194
22756	34810	6	applied	\N	\N	\N	\N	107195	107195	107196
22756	34811	7	applied	\N	\N	\N	\N	107197	107197	107198
22756	34812	8	applied	\N	\N	\N	\N	107199	107199	107200
22756	34813	9	applied	\N	\N	\N	\N	107201	107201	107202
22758	34817	0	applied	\N	\N	\N	\N	107214	107214	107215
22758	34818	1	applied	\N	\N	\N	\N	107216	107216	107217
22758	34819	2	applied	\N	\N	\N	\N	107218	107218	107219
22761	34824	0	applied	\N	\N	\N	\N	107232	107232	107233
22761	34825	1	applied	\N	\N	\N	\N	107234	107234	107235
22761	34828	2	applied	\N	\N	\N	\N	107241	107241	107249
22761	34829	3	applied	\N	\N	\N	\N	107243	107243	107250
22763	34830	0	applied	\N	\N	\N	\N	107254	107254	107255
22763	34831	1	applied	\N	\N	\N	\N	107256	107256	107242
22763	34826	2	applied	\N	\N	\N	\N	107236	107236	107257
22763	34827	3	applied	\N	\N	\N	\N	107238	107238	107258
22763	34832	4	applied	\N	\N	\N	\N	107259	107259	107260
22701	34689	3	applied	\N	\N	\N	\N	106869	106869	106870
22702	34690	0	applied	\N	\N	\N	\N	106878	106878	106879
22702	34691	1	applied	\N	\N	\N	\N	106880	106880	106881
22702	34692	2	applied	\N	\N	\N	\N	106882	106882	106883
22702	34693	3	applied	\N	\N	\N	\N	106884	106884	106885
22702	34694	4	applied	\N	\N	\N	\N	106886	106886	106887
22702	34695	5	applied	\N	\N	\N	\N	106888	106888	106889
22705	34696	0	applied	\N	\N	\N	\N	106894	106894	106895
22705	34697	1	applied	\N	\N	\N	\N	106896	106896	106897
22705	34698	2	applied	\N	\N	\N	\N	106898	106898	106899
22705	34699	3	applied	\N	\N	\N	\N	106900	106900	106901
22705	34700	4	applied	\N	\N	\N	\N	106902	106902	106903
22705	34701	5	applied	\N	\N	\N	\N	106904	106904	106905
22705	34702	6	applied	\N	\N	\N	\N	106906	106906	106907
22715	34720	0	applied	\N	\N	\N	\N	106956	106956	106957
22715	34721	1	applied	\N	\N	\N	\N	106958	106958	106959
22720	34725	0	applied	\N	\N	\N	\N	106970	106970	106971
22720	34726	1	applied	\N	\N	\N	\N	106972	106972	106973
22724	34732	0	applied	\N	\N	\N	\N	106991	106991	106992
22724	34733	1	applied	\N	\N	\N	\N	106993	106993	106994
22727	34734	0	applied	\N	\N	\N	\N	106997	106997	106998
22727	34735	1	applied	\N	\N	\N	\N	106999	106999	107000
22727	34736	2	applied	\N	\N	\N	\N	107001	107001	107002
22727	34737	3	applied	\N	\N	\N	\N	107003	107003	107004
22730	34740	0	applied	\N	\N	\N	\N	107013	107013	107014
22730	34741	1	applied	\N	\N	\N	\N	107015	107015	107016
22730	34742	2	applied	\N	\N	\N	\N	107017	107017	107018
22730	34743	3	applied	\N	\N	\N	\N	107019	107019	107020
22738	34767	0	applied	\N	\N	\N	\N	107073	107073	107074
22738	34768	1	applied	\N	\N	\N	\N	107075	107075	107076
22738	34769	2	applied	\N	\N	\N	\N	107077	107077	107078
22738	34770	3	applied	\N	\N	\N	\N	107079	107079	107080
22738	34771	4	applied	\N	\N	\N	\N	107081	107081	107082
22738	34772	5	applied	\N	\N	\N	\N	107083	107083	107084
22744	34787	0	applied	\N	\N	\N	\N	107121	107121	107122
22744	34788	1	applied	\N	\N	\N	\N	107123	107123	107124
22744	34792	2	applied	\N	\N	\N	\N	107132	107132	107133
22744	34793	3	applied	\N	\N	\N	\N	107134	107134	107128
22744	34789	4	applied	\N	\N	\N	\N	107125	107125	107135
22744	34790	5	applied	\N	\N	\N	\N	107127	107127	107136
22744	34791	6	applied	\N	\N	\N	\N	107129	107129	107137
22746	34797	0	applied	\N	\N	\N	\N	107150	107150	107151
22746	34798	1	applied	\N	\N	\N	\N	107152	107152	107153
22746	34799	2	applied	\N	\N	\N	\N	107154	107154	107155
22746	34800	3	applied	\N	\N	\N	\N	107156	107156	107157
22749	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22749	34802	1	applied	\N	\N	\N	\N	107161	107161	107162
22749	34803	2	applied	\N	\N	\N	\N	107163	107163	107164
22753	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22753	34803	1	applied	\N	\N	\N	\N	107163	107163	107169
22755	34804	0	applied	\N	\N	\N	\N	107183	107183	107184
22755	34805	1	applied	\N	\N	\N	\N	107185	107185	107186
22755	34806	2	applied	\N	\N	\N	\N	107187	107187	107188
22755	34807	3	applied	\N	\N	\N	\N	107189	107189	107190
22755	34808	4	applied	\N	\N	\N	\N	107191	107191	107192
22755	34809	5	applied	\N	\N	\N	\N	107193	107193	107194
22755	34810	6	applied	\N	\N	\N	\N	107195	107195	107196
22755	34811	7	applied	\N	\N	\N	\N	107197	107197	107198
22755	34812	8	applied	\N	\N	\N	\N	107199	107199	107200
22755	34813	9	applied	\N	\N	\N	\N	107201	107201	107202
22765	34830	0	applied	\N	\N	\N	\N	107254	107254	107255
22765	34831	1	applied	\N	\N	\N	\N	107256	107256	107242
22765	34826	2	applied	\N	\N	\N	\N	107236	107236	107257
22765	34827	3	applied	\N	\N	\N	\N	107238	107238	107258
22765	34832	4	applied	\N	\N	\N	\N	107259	107259	107260
22767	34836	0	applied	\N	\N	\N	\N	107271	107271	107272
22767	34837	1	applied	\N	\N	\N	\N	107273	107273	107274
22776	34873	0	applied	\N	\N	\N	\N	107357	107357	107358
22776	34874	1	applied	\N	\N	\N	\N	107359	107359	107360
22776	34875	2	applied	\N	\N	\N	\N	107361	107361	107362
22779	34883	0	applied	\N	\N	\N	\N	107382	107382	107383
22779	34884	1	applied	\N	\N	\N	\N	107384	107384	107385
22779	34885	2	applied	\N	\N	\N	\N	107386	107386	107387
22782	34890	0	applied	\N	\N	\N	\N	107402	107402	107403
22782	34891	1	applied	\N	\N	\N	\N	107404	107404	107405
22782	34892	2	applied	\N	\N	\N	\N	107406	107406	107407
22782	34893	3	applied	\N	\N	\N	\N	107408	107408	107409
22782	34894	4	applied	\N	\N	\N	\N	107410	107410	107411
22782	34895	5	applied	\N	\N	\N	\N	107412	107412	107413
22782	34896	6	applied	\N	\N	\N	\N	107414	107414	107415
22784	34890	0	applied	\N	\N	\N	\N	107402	107402	107403
22784	34891	1	applied	\N	\N	\N	\N	107404	107404	107405
22784	34892	2	applied	\N	\N	\N	\N	107406	107406	107407
22784	34893	3	applied	\N	\N	\N	\N	107408	107408	107409
22784	34894	4	applied	\N	\N	\N	\N	107410	107410	107411
22784	34895	5	applied	\N	\N	\N	\N	107412	107412	107413
22784	34896	6	applied	\N	\N	\N	\N	107414	107414	107415
22787	34900	0	applied	\N	\N	\N	\N	107429	107429	107430
22787	34901	1	applied	\N	\N	\N	\N	107431	107431	107432
22787	34902	2	applied	\N	\N	\N	\N	107433	107433	107434
22787	34903	3	applied	\N	\N	\N	\N	107435	107435	107436
22789	34904	0	applied	\N	\N	\N	\N	107438	107438	107439
22789	34905	1	applied	\N	\N	\N	\N	107440	107440	107441
22789	34906	2	applied	\N	\N	\N	\N	107442	107442	107443
22789	34907	3	applied	\N	\N	\N	\N	107444	107444	107445
22789	34908	4	applied	\N	\N	\N	\N	107446	107446	107447
22789	34909	5	applied	\N	\N	\N	\N	107448	107448	107449
22789	34910	6	applied	\N	\N	\N	\N	107450	107450	107451
22789	34911	7	applied	\N	\N	\N	\N	107452	107452	107453
22792	34930	0	applied	\N	\N	\N	\N	107497	107497	107498
22792	34931	1	applied	\N	\N	\N	\N	107499	107499	107500
22792	34932	2	applied	\N	\N	\N	\N	107501	107501	107502
22799	34939	0	applied	\N	\N	\N	\N	107525	107525	107526
22799	34940	1	applied	\N	\N	\N	\N	107527	107527	107528
22799	34941	2	applied	\N	\N	\N	\N	107529	107529	107530
22799	34942	3	applied	\N	\N	\N	\N	107531	107531	107532
22804	34943	0	applied	\N	\N	\N	\N	107539	107539	107540
22804	34944	1	applied	\N	\N	\N	\N	107541	107541	107542
22804	34945	2	applied	\N	\N	\N	\N	107543	107543	107544
22808	34953	0	applied	\N	\N	\N	\N	107570	107570	107571
22808	34954	1	applied	\N	\N	\N	\N	107572	107572	107573
22808	34955	2	applied	\N	\N	\N	\N	107574	107574	107575
22817	34965	0	applied	\N	\N	\N	\N	107609	107609	107610
22817	34966	1	applied	\N	\N	\N	\N	107611	107611	107612
22817	34967	2	applied	\N	\N	\N	\N	107613	107613	107614
22817	34968	3	applied	\N	\N	\N	\N	107615	107615	107616
22817	34969	4	applied	\N	\N	\N	\N	107617	107617	107618
22820	34977	0	applied	\N	\N	\N	\N	107638	107638	107639
22820	34978	1	applied	\N	\N	\N	\N	107640	107640	107641
22820	34979	2	applied	\N	\N	\N	\N	107642	107642	107643
22709	34708	3	applied	\N	\N	\N	\N	106926	106926	106927
22709	34709	4	applied	\N	\N	\N	\N	106928	106928	106929
22712	34710	0	applied	\N	\N	\N	\N	106932	106932	106933
22712	34711	1	applied	\N	\N	\N	\N	106934	106934	106935
22712	34712	2	applied	\N	\N	\N	\N	106936	106936	106937
22712	34713	3	applied	\N	\N	\N	\N	106938	106938	106939
22712	34714	4	applied	\N	\N	\N	\N	106940	106940	106941
22712	34715	5	applied	\N	\N	\N	\N	106942	106942	106943
22714	34716	0	applied	\N	\N	\N	\N	106946	106946	106947
22714	34717	1	applied	\N	\N	\N	\N	106948	106948	106949
22714	34718	2	applied	\N	\N	\N	\N	106950	106950	106951
22714	34719	3	applied	\N	\N	\N	\N	106952	106952	106953
22717	34722	0	applied	\N	\N	\N	\N	106961	106961	106962
22717	34723	1	applied	\N	\N	\N	\N	106963	106963	106964
22717	34724	2	applied	\N	\N	\N	\N	106965	106965	106966
22719	34725	0	applied	\N	\N	\N	\N	106970	106970	106971
22719	34726	1	applied	\N	\N	\N	\N	106972	106972	106973
22721	34727	0	applied	\N	\N	\N	\N	106977	106977	106978
22721	34728	1	applied	\N	\N	\N	\N	106979	106979	106980
22729	34738	0	applied	\N	\N	\N	\N	107007	107007	107008
22729	34739	1	applied	\N	\N	\N	\N	107009	107009	107010
22732	34747	0	applied	\N	\N	\N	\N	107030	107030	107031
22732	34748	1	applied	\N	\N	\N	\N	107032	107032	107033
22732	34749	2	applied	\N	\N	\N	\N	107034	107034	107035
22743	34787	0	applied	\N	\N	\N	\N	107121	107121	107122
22743	34788	1	applied	\N	\N	\N	\N	107123	107123	107124
22743	34789	2	applied	\N	\N	\N	\N	107125	107125	107126
22743	34790	3	applied	\N	\N	\N	\N	107127	107127	107128
22743	34791	4	applied	\N	\N	\N	\N	107129	107129	107130
22748	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22748	34802	1	applied	\N	\N	\N	\N	107161	107161	107162
22748	34803	2	applied	\N	\N	\N	\N	107163	107163	107164
22752	34801	0	applied	\N	\N	\N	\N	107159	107159	107160
22752	34802	1	applied	\N	\N	\N	\N	107161	107161	107162
22752	34803	2	applied	\N	\N	\N	\N	107163	107163	107164
22757	34814	0	applied	\N	\N	\N	\N	107207	107207	107208
22757	34815	1	applied	\N	\N	\N	\N	107209	107209	107210
22757	34816	2	applied	\N	\N	\N	\N	107211	107211	107212
22760	34824	0	applied	\N	\N	\N	\N	107232	107232	107233
22760	34825	1	applied	\N	\N	\N	\N	107234	107234	107235
22760	34826	2	applied	\N	\N	\N	\N	107236	107236	107237
22760	34827	3	applied	\N	\N	\N	\N	107238	107238	107239
22760	34828	5	applied	\N	\N	\N	\N	107241	107241	107242
22760	34829	6	applied	\N	\N	\N	\N	107243	107243	107244
22786	34900	0	applied	\N	\N	\N	\N	107429	107429	107430
22786	34901	1	applied	\N	\N	\N	\N	107431	107431	107432
22786	34902	2	applied	\N	\N	\N	\N	107433	107433	107434
22786	34903	3	applied	\N	\N	\N	\N	107435	107435	107436
22797	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22797	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22797	34935	2	applied	\N	\N	\N	\N	107507	107507	107508
22797	34936	3	applied	\N	\N	\N	\N	107509	107509	107510
22797	34937	4	applied	\N	\N	\N	\N	107511	107511	107512
22797	34938	5	applied	\N	\N	\N	\N	107513	107513	107514
22803	34943	0	applied	\N	\N	\N	\N	107539	107539	107540
22803	34944	1	applied	\N	\N	\N	\N	107541	107541	107542
22803	34945	2	applied	\N	\N	\N	\N	107543	107543	107544
22805	34946	0	applied	\N	\N	\N	\N	107549	107549	107550
22805	34947	1	applied	\N	\N	\N	\N	107551	107551	107552
22805	34948	2	applied	\N	\N	\N	\N	107553	107553	107554
22807	34946	0	applied	\N	\N	\N	\N	107549	107549	107550
22807	34949	1	applied	\N	\N	\N	\N	107559	107559	107560
22807	34950	2	applied	\N	\N	\N	\N	107561	107561	107562
22807	34947	3	applied	\N	\N	\N	\N	107551	107551	107563
22807	34951	4	applied	\N	\N	\N	\N	107564	107564	107565
22807	34952	5	applied	\N	\N	\N	\N	107566	107566	107567
22810	34959	0	applied	\N	\N	\N	\N	107586	107586	107587
22810	34960	1	applied	\N	\N	\N	\N	107588	107588	107589
22810	34961	2	applied	\N	\N	\N	\N	107590	107590	107591
22815	34962	0	applied	\N	\N	\N	\N	107597	107597	107598
22815	34963	1	applied	\N	\N	\N	\N	107599	107599	107600
22815	34964	2	applied	\N	\N	\N	\N	107601	107601	107602
22819	34970	0	applied	\N	\N	\N	\N	107623	107623	107624
22819	34971	1	applied	\N	\N	\N	\N	107625	107625	107626
22819	34972	2	applied	\N	\N	\N	\N	107627	107627	107628
22819	34973	3	applied	\N	\N	\N	\N	107629	107629	107630
22819	34974	4	applied	\N	\N	\N	\N	107631	107631	107632
22819	34975	5	applied	\N	\N	\N	\N	107633	107633	107634
22819	34976	6	applied	\N	\N	\N	\N	107635	107635	107636
22822	34984	0	applied	\N	\N	\N	\N	107655	107655	107656
22822	34985	1	applied	\N	\N	\N	\N	107657	107657	107658
22822	34986	2	applied	\N	\N	\N	\N	107659	107659	107660
22827	34997	0	applied	\N	\N	\N	\N	107689	107689	107690
22827	34998	1	applied	\N	\N	\N	\N	107691	107691	107692
22827	34999	2	applied	\N	\N	\N	\N	107693	107693	107694
22829	35000	0	applied	\N	\N	\N	\N	107697	107697	107698
22829	35001	1	applied	\N	\N	\N	\N	107699	107699	107420
22829	35002	2	applied	\N	\N	\N	\N	107700	107700	107701
22829	35003	3	applied	\N	\N	\N	\N	107702	107702	107703
22832	35004	0	applied	\N	\N	\N	\N	107707	107707	107708
22832	35005	1	applied	\N	\N	\N	\N	107709	107709	107710
22832	35006	2	applied	\N	\N	\N	\N	107711	107711	107712
22832	35007	3	applied	\N	\N	\N	\N	107713	107713	107714
22834	35008	0	applied	\N	\N	\N	\N	107716	107716	107717
22834	35009	1	applied	\N	\N	\N	\N	107718	107718	107719
22834	35010	2	applied	\N	\N	\N	\N	107720	107720	107721
22836	35011	0	applied	\N	\N	\N	\N	107730	107730	107731
22836	35012	1	applied	\N	\N	\N	\N	107732	107732	107733
22847	35032	0	applied	\N	\N	\N	\N	107784	107784	107785
22847	35033	1	applied	\N	\N	\N	\N	107786	107786	107787
22847	35034	2	applied	\N	\N	\N	\N	107788	107788	107789
22849	35035	0	applied	\N	\N	\N	\N	107792	107792	107793
22849	35036	1	applied	\N	\N	\N	\N	107794	107794	107795
22849	35037	2	applied	\N	\N	\N	\N	107796	107796	107797
22858	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
22858	35044	1	applied	\N	\N	\N	\N	107824	107824	107825
22858	35045	2	applied	\N	\N	\N	\N	107826	107826	107827
22858	35041	3	applied	\N	\N	\N	\N	107812	107812	107828
22858	35046	4	applied	\N	\N	\N	\N	107829	107829	107830
22863	35047	0	applied	\N	\N	\N	\N	107835	107835	107836
22863	35048	1	applied	\N	\N	\N	\N	107837	107837	107838
22863	35049	2	applied	\N	\N	\N	\N	107839	107839	107420
22863	35050	3	applied	\N	\N	\N	\N	107840	107840	107841
22864	35051	0	applied	\N	\N	\N	\N	107846	107846	107847
22864	35052	1	applied	\N	\N	\N	\N	107848	107848	107849
22864	35053	2	applied	\N	\N	\N	\N	107850	107850	107851
22864	35054	3	applied	\N	\N	1000000000	\N	107852	107852	107853
22864	35055	4	applied	\N	\N	\N	\N	107854	107854	107855
22869	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22754	34529	8	applied	\N	\N	\N	\N	107177	107177	89257
22754	34037	9	applied	\N	\N	\N	\N	105220	105220	105221
22754	34038	10	applied	\N	\N	\N	\N	105222	105222	105223
22754	34039	11	applied	\N	\N	\N	\N	105224	105224	105225
22754	34043	12	applied	\N	\N	\N	\N	105236	105236	105237
22754	34044	13	applied	\N	\N	\N	\N	105238	105238	105239
22754	34045	14	applied	\N	\N	\N	\N	105240	105240	105241
22754	34046	15	applied	\N	\N	\N	\N	105242	105242	105243
22754	34047	16	applied	\N	\N	\N	\N	105244	105244	105245
22754	34048	17	applied	\N	\N	\N	\N	105246	105246	105247
22754	34052	18	applied	\N	\N	\N	\N	105259	105259	105260
22754	34053	19	applied	\N	\N	\N	\N	105261	105261	105262
22754	34054	20	applied	\N	\N	\N	\N	105263	105263	105264
22754	34055	21	applied	\N	\N	\N	\N	105265	105265	105266
22754	34056	22	applied	\N	\N	\N	\N	105267	105267	105268
22754	34059	23	applied	\N	\N	\N	\N	105276	105276	105277
22754	34060	24	applied	\N	\N	\N	\N	105278	105278	105279
22754	34061	25	applied	\N	\N	\N	\N	105280	105280	105281
22754	34063	26	applied	\N	\N	\N	\N	105284	105284	105285
22754	34064	27	applied	\N	\N	\N	\N	105286	105286	105287
22754	34065	28	applied	\N	\N	\N	\N	105288	105288	105289
22754	34066	29	applied	\N	\N	\N	\N	105290	105290	105291
22754	34067	30	applied	\N	\N	\N	\N	105292	105292	105293
22754	34068	31	applied	\N	\N	\N	\N	105294	105294	105295
22754	34069	32	applied	\N	\N	\N	\N	105296	105296	105297
22754	34070	33	applied	\N	\N	\N	\N	105298	105298	105299
22754	34071	34	applied	\N	\N	\N	\N	105301	105301	105302
22754	34078	35	applied	\N	\N	\N	\N	105317	105317	105318
22754	34079	36	applied	\N	\N	\N	\N	105319	105319	105320
22754	34080	37	applied	\N	\N	\N	\N	105321	105321	105322
22754	34081	38	applied	\N	\N	\N	\N	105323	105323	105324
22754	34082	39	applied	\N	\N	\N	\N	105325	105325	105326
22754	34083	40	applied	\N	\N	\N	\N	105327	105327	105328
22754	34088	41	applied	\N	\N	\N	\N	105342	105342	105343
22754	34089	42	applied	\N	\N	\N	\N	105344	105344	105345
22754	34090	43	applied	\N	\N	\N	\N	105346	105346	105347
22754	34091	44	applied	\N	\N	\N	\N	105348	105348	105349
22754	34093	45	applied	\N	\N	\N	\N	105352	105352	105353
22754	34094	46	applied	\N	\N	\N	\N	105354	105354	105355
22754	34095	47	applied	\N	\N	\N	\N	105356	105356	105357
22754	34096	48	applied	\N	\N	\N	\N	105358	105358	105359
22754	34097	49	applied	\N	\N	\N	\N	105360	105360	105361
22754	34098	50	applied	\N	\N	\N	\N	105362	105362	105363
22754	34099	51	applied	\N	\N	\N	\N	105364	105364	105365
22754	34100	52	applied	\N	\N	\N	\N	105366	105366	105367
22754	34106	53	applied	\N	\N	\N	\N	105380	105380	105381
22754	34482	54	applied	\N	\N	\N	\N	106316	106316	107178
22754	34664	55	applied	\N	\N	\N	\N	107179	107179	106810
22754	34107	56	applied	\N	\N	\N	\N	105382	105382	105383
22754	34108	57	applied	\N	\N	\N	\N	105384	105384	105385
22754	34109	58	applied	\N	\N	\N	\N	105386	105386	105387
22754	34110	59	applied	\N	\N	\N	\N	105388	105388	105389
22754	34111	60	applied	\N	\N	\N	\N	105390	105390	105391
22754	34116	61	applied	\N	\N	\N	\N	105401	105401	105402
22754	34123	62	applied	\N	\N	\N	\N	105426	105426	105427
22754	34126	63	applied	\N	\N	\N	\N	105440	105440	105441
22754	34130	64	applied	\N	\N	\N	\N	105448	105448	105449
22754	34131	65	applied	\N	\N	\N	\N	105450	105450	105451
22754	34132	66	applied	\N	\N	\N	\N	105452	105452	105453
22754	34133	67	applied	\N	\N	\N	\N	105454	105454	105455
22754	34134	68	applied	\N	\N	\N	\N	105456	105456	105457
22754	34135	69	applied	\N	\N	\N	\N	105458	105458	105459
22754	34136	70	applied	\N	\N	\N	\N	105460	105460	105461
22754	34137	71	applied	\N	\N	\N	\N	105462	105462	105463
22754	34138	72	applied	\N	\N	\N	\N	105464	105464	105465
22754	34139	73	applied	\N	\N	\N	\N	105466	105466	105467
22754	34140	74	applied	\N	\N	\N	\N	105468	105468	105469
22754	34141	75	applied	\N	\N	\N	\N	105470	105470	105471
22754	34142	76	applied	\N	\N	\N	\N	105472	105472	105473
22754	34143	77	applied	\N	\N	\N	\N	105474	105474	105475
22754	34144	78	applied	\N	\N	\N	\N	105476	105476	105477
22754	34145	79	applied	\N	\N	\N	\N	105478	105478	105479
22754	34146	80	applied	\N	\N	\N	\N	105480	105480	105481
22754	34154	82	applied	\N	\N	\N	\N	105498	105498	105499
22754	34155	83	applied	\N	\N	\N	\N	105500	105500	105501
22754	34156	84	applied	\N	\N	\N	\N	105502	105502	105503
22754	34157	85	applied	\N	\N	\N	\N	105504	105504	105505
22754	34158	86	applied	\N	\N	\N	\N	105506	105506	105507
22754	34159	87	applied	\N	\N	\N	\N	105508	105508	105509
22754	34164	88	applied	\N	\N	\N	\N	105521	105521	105522
22754	34165	89	applied	\N	\N	\N	\N	105523	105523	105524
22754	34166	90	applied	\N	\N	\N	\N	105525	105525	105526
22754	34167	91	applied	\N	\N	\N	\N	105527	105527	105528
22754	34168	92	applied	\N	\N	\N	\N	105529	105529	105530
22754	34169	93	applied	\N	\N	\N	\N	105531	105531	105532
22754	34170	94	applied	\N	\N	\N	\N	105533	105533	105534
22754	34171	95	applied	\N	\N	\N	\N	105535	105535	105536
22754	34172	96	applied	\N	\N	\N	\N	105537	105537	105538
22754	34173	97	applied	\N	\N	\N	\N	105539	105539	105540
22754	34174	98	applied	\N	\N	\N	\N	105541	105541	105542
22754	34175	99	applied	\N	\N	\N	\N	105543	105543	105544
22754	34181	100	applied	\N	\N	\N	\N	105560	105560	105561
22754	34183	101	applied	\N	\N	\N	\N	105568	105568	105569
22754	34184	102	applied	\N	\N	\N	\N	105570	105570	105571
22754	34185	103	applied	\N	\N	\N	\N	105572	105572	105573
22754	34186	104	applied	\N	\N	\N	\N	105574	105574	105575
22754	34187	105	applied	\N	\N	\N	\N	105576	105576	105577
22754	34191	106	applied	\N	\N	\N	\N	105588	105588	105589
22754	34192	107	applied	\N	\N	\N	\N	105590	105590	105591
22754	34193	108	applied	\N	\N	\N	\N	105592	105592	105593
22754	34194	109	applied	\N	\N	\N	\N	105594	105594	105595
22754	34195	110	applied	\N	\N	\N	\N	105596	105596	105597
22754	34196	111	applied	\N	\N	\N	\N	105598	105598	105599
22754	34201	112	applied	\N	\N	\N	\N	105611	105611	105612
22754	34212	113	applied	\N	\N	\N	\N	105644	105644	105645
22754	34213	114	applied	\N	\N	\N	\N	105646	105646	105647
22754	34214	115	applied	\N	\N	\N	\N	105648	105648	105649
22754	34215	116	applied	\N	\N	\N	\N	105650	105650	105651
22754	34218	117	applied	\N	\N	\N	\N	105658	105658	105659
22754	34219	118	applied	\N	\N	\N	\N	105660	105660	105661
22754	34220	119	applied	\N	\N	\N	\N	105662	105662	105663
22754	34221	120	applied	\N	\N	\N	\N	105664	105664	105665
22759	34820	0	applied	\N	\N	\N	\N	107222	107222	107223
22759	34821	1	applied	\N	\N	\N	\N	107224	107224	107225
22759	34822	2	applied	\N	\N	\N	\N	107226	107226	107227
22759	34823	3	applied	\N	\N	\N	\N	107228	107228	107229
22764	34830	0	applied	\N	\N	\N	\N	107254	107254	107255
22764	34831	1	applied	\N	\N	\N	\N	107256	107256	107242
22764	34826	2	applied	\N	\N	\N	\N	107236	107236	107257
22764	34827	3	applied	\N	\N	\N	\N	107238	107238	107258
22764	34832	4	applied	\N	\N	\N	\N	107259	107259	107260
22766	34833	0	applied	\N	\N	\N	\N	107263	107263	107264
22766	34834	1	applied	\N	\N	\N	\N	107265	107265	107266
22766	34835	2	applied	\N	\N	\N	\N	107267	107267	107268
22769	34838	0	applied	\N	\N	\N	\N	107276	107276	107277
22769	34839	1	applied	\N	\N	\N	\N	107278	107278	107279
22769	34840	2	applied	\N	\N	\N	\N	107280	107280	107281
22769	34841	3	applied	\N	\N	\N	\N	107282	107282	107283
22771	34846	0	applied	\N	\N	\N	\N	107297	107297	107298
22771	34847	1	applied	\N	\N	\N	\N	107299	107299	107300
22771	34848	2	applied	\N	\N	\N	\N	107301	107301	107302
22771	34849	3	applied	\N	\N	\N	\N	107303	107303	107304
22771	34850	4	applied	\N	\N	\N	\N	107305	107305	107306
22771	34851	5	applied	\N	\N	\N	\N	107307	107307	107308
22773	34852	0	applied	\N	\N	\N	\N	107311	107311	107312
22773	34853	1	applied	\N	\N	\N	\N	107313	107313	107314
22773	34854	2	applied	\N	\N	\N	\N	107315	107315	107316
22773	34855	3	applied	\N	\N	\N	\N	107317	107317	107318
22773	34856	4	applied	\N	\N	\N	\N	107319	107319	107320
22773	34857	5	applied	\N	\N	\N	\N	107321	107321	107322
22773	34858	6	applied	\N	\N	\N	\N	107323	107323	107324
22773	34859	7	applied	\N	\N	\N	\N	107325	107325	107326
22773	34860	8	applied	\N	\N	\N	\N	107327	107327	107328
22773	34861	9	applied	\N	\N	\N	\N	107329	107329	107330
22773	34862	10	applied	\N	\N	\N	\N	107331	107331	107331
22773	34863	11	applied	\N	\N	\N	\N	107332	107332	107333
22773	34864	12	applied	\N	\N	\N	\N	107334	107334	107335
22773	34865	13	applied	\N	\N	\N	\N	107336	107336	107337
22773	34866	14	applied	\N	\N	\N	\N	107338	107338	107339
22773	34867	15	applied	\N	\N	\N	\N	107340	107340	107341
22773	34868	16	applied	\N	\N	\N	\N	107342	107342	107343
22773	34869	17	applied	\N	\N	\N	\N	107344	107344	107345
22773	34870	18	applied	\N	\N	\N	\N	107346	107346	107347
22773	34871	19	applied	\N	\N	\N	\N	107348	107348	107349
22773	34872	20	applied	\N	\N	\N	\N	107350	107350	107351
22775	34873	0	applied	\N	\N	\N	\N	107357	107357	107358
22775	34874	1	applied	\N	\N	\N	\N	107359	107359	107360
22775	34875	2	applied	\N	\N	\N	\N	107361	107361	107362
22778	34880	0	applied	\N	\N	\N	\N	107375	107375	107376
22778	34881	1	applied	\N	\N	\N	\N	107377	107377	107378
22778	34882	2	applied	\N	\N	\N	\N	107379	107379	107380
22781	34886	0	applied	\N	\N	\N	\N	107390	107390	107391
22781	34887	1	applied	\N	\N	\N	\N	107392	107392	107393
22781	34888	2	applied	\N	\N	\N	\N	107394	107394	107395
22781	34889	3	applied	\N	\N	\N	\N	107396	107396	107397
22785	34897	0	applied	\N	\N	\N	\N	107421	107421	107422
22785	34898	1	applied	\N	\N	\N	\N	107423	107423	107424
22785	34899	2	applied	\N	\N	\N	\N	107425	107425	107426
22788	34901	0	applied	\N	\N	\N	\N	107431	107431	107432
22788	34902	1	applied	\N	\N	\N	\N	107433	107433	107434
22788	34903	2	applied	\N	\N	\N	\N	107435	107435	107436
22791	34919	0	applied	\N	\N	\N	\N	107472	107472	107473
22791	34920	2	applied	\N	\N	\N	\N	107475	107475	107476
22791	34921	3	applied	\N	\N	\N	\N	107477	107477	107478
22791	34922	4	applied	\N	\N	\N	\N	107479	107479	107480
22791	34923	5	applied	\N	\N	\N	\N	107481	107481	107482
22791	34924	6	applied	\N	\N	\N	\N	107483	107483	107484
22791	34925	7	applied	\N	\N	\N	\N	107485	107485	107486
22791	34926	8	applied	\N	\N	\N	\N	107487	107487	107488
22791	34927	9	applied	\N	\N	\N	\N	107489	107489	107490
22791	34928	10	applied	\N	\N	\N	\N	107491	107491	107492
22791	34929	11	applied	\N	\N	\N	\N	107493	107493	107494
22794	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22794	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22794	34935	2	applied	\N	\N	\N	\N	107507	107507	107508
22794	34936	3	applied	\N	\N	\N	\N	107509	107509	107510
22794	34937	4	applied	\N	\N	\N	\N	107511	107511	107512
22794	34938	5	applied	\N	\N	\N	\N	107513	107513	107514
22796	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22796	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22798	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22798	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22798	34935	2	applied	\N	\N	\N	\N	107507	107507	107508
22798	34936	3	applied	\N	\N	\N	\N	107509	107509	107510
22798	34937	4	applied	\N	\N	\N	\N	107511	107511	107512
22798	34938	5	applied	\N	\N	\N	\N	107513	107513	107514
22801	34939	0	applied	\N	\N	\N	\N	107525	107525	107526
22801	34940	1	applied	\N	\N	\N	\N	107527	107527	107528
22801	34941	2	applied	\N	\N	\N	\N	107529	107529	107530
22801	34942	3	applied	\N	\N	\N	\N	107531	107531	107532
22802	34943	0	applied	\N	\N	\N	\N	107539	107539	107540
22802	34944	1	applied	\N	\N	\N	\N	107541	107541	107542
22802	34945	2	applied	\N	\N	\N	\N	107543	107543	107544
22809	34956	0	applied	\N	\N	\N	\N	107578	107578	107579
22809	34957	1	applied	\N	\N	\N	\N	107580	107580	107581
22809	34958	2	applied	\N	\N	\N	\N	107582	107582	107583
22812	34959	0	applied	\N	\N	\N	\N	107586	107586	107587
22812	34960	1	applied	\N	\N	\N	\N	107588	107588	107589
22812	34961	2	applied	\N	\N	\N	\N	107590	107590	107591
22814	34962	0	applied	\N	\N	\N	\N	107597	107597	107598
22814	34963	1	applied	\N	\N	\N	\N	107599	107599	107600
22814	34964	2	applied	\N	\N	\N	\N	107601	107601	107602
22821	34980	0	applied	\N	\N	\N	\N	107645	107645	107646
22821	34981	1	applied	\N	\N	\N	\N	107647	107647	107648
22821	34982	2	applied	\N	\N	\N	\N	107649	107649	107650
22821	34983	3	applied	\N	\N	\N	\N	107651	107651	107652
22826	34987	0	applied	\N	\N	\N	\N	107664	107664	107665
22826	34988	1	applied	\N	\N	\N	\N	107666	107666	107667
22826	34989	2	applied	\N	\N	\N	\N	107668	107668	107669
22826	34991	3	applied	\N	\N	\N	\N	107672	107672	107685
22826	34992	4	applied	\N	\N	\N	\N	107674	107674	107686
22826	34993	5	applied	\N	\N	\N	\N	107676	107676	107687
22826	34996	6	applied	\N	\N	\N	\N	107682	107682	107675
22831	35004	0	applied	\N	\N	\N	\N	107707	107707	107708
22831	35005	1	applied	\N	\N	\N	\N	107709	107709	107710
22831	35006	2	applied	\N	\N	\N	\N	107711	107711	107712
22831	35007	3	applied	\N	\N	\N	\N	107713	107713	107714
22833	35008	0	applied	\N	\N	\N	\N	107716	107716	107717
22833	35009	1	applied	\N	\N	\N	\N	107718	107718	107719
22833	35010	2	applied	\N	\N	\N	\N	107720	107720	107721
22838	35014	0	applied	\N	\N	\N	\N	107739	107739	107740
22838	35015	1	applied	\N	\N	\N	\N	107741	107741	107742
22838	35016	2	applied	\N	\N	\N	\N	107743	107743	107744
22838	35017	3	applied	\N	\N	\N	\N	107745	107745	107746
22838	35018	4	applied	\N	\N	\N	\N	107747	107747	107748
22838	35019	5	applied	\N	\N	\N	\N	107749	107749	107750
22838	35020	6	applied	\N	\N	\N	\N	107751	107751	107752
22844	35024	0	applied	\N	\N	\N	\N	107762	107762	107763
22844	35025	1	applied	\N	\N	\N	\N	107764	107764	107765
22844	35026	2	applied	\N	\N	\N	\N	107766	107766	107767
22768	34838	0	applied	\N	\N	\N	\N	107276	107276	107277
22768	34839	1	applied	\N	\N	\N	\N	107278	107278	107279
22768	34840	2	applied	\N	\N	\N	\N	107280	107280	107281
22768	34841	3	applied	\N	\N	\N	\N	107282	107282	107283
22770	34842	0	applied	\N	\N	\N	\N	107287	107287	107288
22770	34843	1	applied	\N	\N	\N	\N	107289	107289	107290
22770	34844	2	applied	\N	\N	\N	\N	107291	107291	107292
22770	34845	3	applied	\N	\N	\N	\N	107293	107293	107294
22772	34852	0	applied	\N	\N	\N	\N	107311	107311	107312
22772	34853	1	applied	\N	\N	\N	\N	107313	107313	107314
22772	34854	2	applied	\N	\N	\N	\N	107315	107315	107316
22772	34855	3	applied	\N	\N	\N	\N	107317	107317	107318
22772	34856	4	applied	\N	\N	\N	\N	107319	107319	107320
22772	34857	5	applied	\N	\N	\N	\N	107321	107321	107322
22772	34858	6	applied	\N	\N	\N	\N	107323	107323	107324
22772	34859	7	applied	\N	\N	\N	\N	107325	107325	107326
22772	34860	8	applied	\N	\N	\N	\N	107327	107327	107328
22772	34861	9	applied	\N	\N	\N	\N	107329	107329	107330
22772	34862	10	applied	\N	\N	\N	\N	107331	107331	107331
22772	34863	11	applied	\N	\N	\N	\N	107332	107332	107333
22772	34864	12	applied	\N	\N	\N	\N	107334	107334	107335
22772	34865	13	applied	\N	\N	\N	\N	107336	107336	107337
22772	34866	14	applied	\N	\N	\N	\N	107338	107338	107339
22772	34867	15	applied	\N	\N	\N	\N	107340	107340	107341
22772	34868	16	applied	\N	\N	\N	\N	107342	107342	107343
22772	34869	17	applied	\N	\N	\N	\N	107344	107344	107345
22772	34870	18	applied	\N	\N	\N	\N	107346	107346	107347
22772	34871	19	applied	\N	\N	\N	\N	107348	107348	107349
22772	34872	20	applied	\N	\N	\N	\N	107350	107350	107351
22774	34852	0	applied	\N	\N	\N	\N	107311	107311	107312
22774	34853	1	applied	\N	\N	\N	\N	107313	107313	107314
22774	34854	2	applied	\N	\N	\N	\N	107315	107315	107316
22774	34855	3	applied	\N	\N	\N	\N	107317	107317	107318
22774	34856	4	applied	\N	\N	\N	\N	107319	107319	107320
22774	34857	5	applied	\N	\N	\N	\N	107321	107321	107322
22774	34858	6	applied	\N	\N	\N	\N	107323	107323	107324
22774	34859	7	applied	\N	\N	\N	\N	107325	107325	107326
22774	34860	8	applied	\N	\N	\N	\N	107327	107327	107328
22774	34861	9	applied	\N	\N	\N	\N	107329	107329	107330
22774	34862	10	applied	\N	\N	\N	\N	107331	107331	107331
22774	34863	11	applied	\N	\N	\N	\N	107332	107332	107333
22774	34864	12	applied	\N	\N	\N	\N	107334	107334	107335
22774	34865	13	applied	\N	\N	\N	\N	107336	107336	107337
22774	34866	14	applied	\N	\N	\N	\N	107338	107338	107339
22774	34867	15	applied	\N	\N	\N	\N	107340	107340	107341
22774	34868	16	applied	\N	\N	\N	\N	107342	107342	107343
22774	34869	17	applied	\N	\N	\N	\N	107344	107344	107345
22774	34870	18	applied	\N	\N	\N	\N	107346	107346	107347
22774	34871	19	applied	\N	\N	\N	\N	107348	107348	107349
22774	34872	20	applied	\N	\N	\N	\N	107350	107350	107351
22777	34876	0	applied	\N	\N	\N	\N	107365	107365	107366
22777	34877	1	applied	\N	\N	\N	\N	107367	107367	107368
22777	34878	2	applied	\N	\N	\N	\N	107369	107369	107370
22777	34879	3	applied	\N	\N	\N	\N	107371	107371	107372
22780	34886	0	applied	\N	\N	\N	\N	107390	107390	107391
22780	34887	1	applied	\N	\N	\N	\N	107392	107392	107393
22780	34888	2	applied	\N	\N	\N	\N	107394	107394	107395
22780	34889	3	applied	\N	\N	\N	\N	107396	107396	107397
22783	34890	0	applied	\N	\N	\N	\N	107402	107402	107403
22783	34891	1	applied	\N	\N	\N	\N	107404	107404	107405
22783	34892	2	applied	\N	\N	\N	\N	107406	107406	107407
22783	34893	3	applied	\N	\N	\N	\N	107408	107408	107409
22783	34894	4	applied	\N	\N	\N	\N	107410	107410	107411
22783	34895	5	applied	\N	\N	\N	\N	107412	107412	107413
22783	34896	6	applied	\N	\N	\N	\N	107414	107414	107415
22790	34912	0	applied	\N	\N	\N	\N	107456	107456	107457
22790	34913	1	applied	\N	\N	\N	\N	107458	107458	107459
22790	34914	2	applied	\N	\N	\N	\N	107460	107460	107461
22790	34915	3	applied	\N	\N	\N	\N	107462	107462	107463
22790	34916	4	applied	\N	\N	\N	\N	107464	107464	107465
22790	34917	5	applied	\N	\N	\N	\N	107466	107466	107467
22790	34918	6	applied	\N	\N	\N	\N	107468	107468	107469
22793	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22793	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22793	34935	2	applied	\N	\N	\N	\N	107507	107507	107508
22793	34936	3	applied	\N	\N	\N	\N	107509	107509	107510
22793	34937	4	applied	\N	\N	\N	\N	107511	107511	107512
22793	34938	5	applied	\N	\N	\N	\N	107513	107513	107514
22795	34933	0	applied	\N	\N	\N	\N	107503	107503	107504
22795	34934	1	applied	\N	\N	\N	\N	107505	107505	107506
22795	34935	2	applied	\N	\N	\N	\N	107507	107507	107508
22795	34936	3	applied	\N	\N	\N	\N	107509	107509	107510
22795	34937	4	applied	\N	\N	\N	\N	107511	107511	107512
22795	34938	5	applied	\N	\N	\N	\N	107513	107513	107514
22800	34939	0	applied	\N	\N	\N	\N	107525	107525	107526
22800	34940	1	applied	\N	\N	\N	\N	107527	107527	107528
22800	34941	2	applied	\N	\N	\N	\N	107529	107529	107530
22800	34942	3	applied	\N	\N	\N	\N	107531	107531	107532
22806	34948	0	applied	\N	\N	\N	\N	107553	107553	107557
22811	34959	0	applied	\N	\N	\N	\N	107586	107586	107587
22811	34960	1	applied	\N	\N	\N	\N	107588	107588	107589
22811	34961	2	applied	\N	\N	\N	\N	107590	107590	107591
22813	34962	0	applied	\N	\N	\N	\N	107597	107597	107598
22813	34963	1	applied	\N	\N	\N	\N	107599	107599	107600
22813	34964	2	applied	\N	\N	\N	\N	107601	107601	107602
22816	34963	0	applied	\N	\N	\N	\N	107599	107599	107600
22816	34964	1	applied	\N	\N	\N	\N	107601	107601	107602
22818	34965	0	applied	\N	\N	\N	\N	107609	107609	107610
22818	34966	1	applied	\N	\N	\N	\N	107611	107611	107612
22818	34967	2	applied	\N	\N	\N	\N	107613	107613	107614
22818	34968	3	applied	\N	\N	\N	\N	107615	107615	107616
22818	34969	4	applied	\N	\N	\N	\N	107617	107617	107618
22823	34930	0	applied	\N	\N	\N	\N	107497	107497	107498
22828	34997	0	applied	\N	\N	\N	\N	107689	107689	107690
22828	34998	1	applied	\N	\N	\N	\N	107691	107691	107692
22828	34999	2	applied	\N	\N	\N	\N	107693	107693	107694
22837	35011	0	applied	\N	\N	\N	\N	107730	107730	107731
22837	35012	1	applied	\N	\N	\N	\N	107732	107732	107733
22837	35013	2	applied	\N	\N	\N	\N	107735	107735	107736
22840	35021	0	applied	\N	\N	\N	\N	107755	107755	107756
22840	35022	1	applied	\N	\N	\N	\N	107757	107757	107758
22840	35023	2	applied	\N	\N	\N	\N	107759	107759	107760
22848	35035	0	applied	\N	\N	\N	\N	107792	107792	107793
22848	35036	1	applied	\N	\N	\N	\N	107794	107794	107795
22848	35037	2	applied	\N	\N	\N	\N	107796	107796	107797
22851	35035	0	applied	\N	\N	\N	\N	107792	107792	107793
22851	35036	1	applied	\N	\N	\N	\N	107794	107794	107795
22851	35037	2	applied	\N	\N	\N	\N	107796	107796	107797
22855	35038	0	applied	\N	\N	\N	\N	107806	107806	107807
22855	35039	1	applied	\N	\N	\N	\N	107808	107808	107809
22825	34987	0	applied	\N	\N	\N	\N	107664	107664	107665
22825	34988	1	applied	\N	\N	\N	\N	107666	107666	107667
22825	34989	2	applied	\N	\N	\N	\N	107668	107668	107669
22825	34990	3	applied	\N	\N	\N	\N	107670	107670	107671
22825	34991	4	applied	\N	\N	\N	\N	107672	107672	107673
22825	34992	5	applied	\N	\N	\N	\N	107674	107674	107675
22825	34993	6	applied	\N	\N	\N	\N	107676	107676	107677
22825	34994	7	applied	\N	\N	\N	\N	107678	107678	107679
22825	34995	8	applied	\N	\N	\N	\N	107680	107680	107681
22825	34996	9	applied	\N	\N	\N	\N	107682	107682	107683
22830	35000	0	applied	\N	\N	\N	\N	107697	107697	107698
22830	35001	1	applied	\N	\N	\N	\N	107699	107699	107420
22830	35002	2	applied	\N	\N	\N	\N	107700	107700	107701
22830	35003	3	applied	\N	\N	\N	\N	107702	107702	107703
22835	35008	0	applied	\N	\N	\N	\N	107716	107716	107717
22835	35009	1	applied	\N	\N	\N	\N	107718	107718	107719
22835	35010	2	applied	\N	\N	\N	\N	107720	107720	107721
22839	35021	0	applied	\N	\N	\N	\N	107755	107755	107756
22839	35022	1	applied	\N	\N	\N	\N	107757	107757	107758
22839	35023	2	applied	\N	\N	\N	\N	107759	107759	107760
22845	35027	0	applied	\N	\N	1000000000	\N	107770	107770	107771
22845	35028	1	applied	\N	\N	\N	\N	107772	107772	107773
22845	35029	2	applied	\N	\N	\N	\N	107774	107774	107775
22845	35030	3	applied	\N	\N	\N	\N	107776	107776	107777
22850	35035	0	applied	\N	\N	\N	\N	107792	107792	107793
22850	35036	1	applied	\N	\N	\N	\N	107794	107794	107795
22850	35037	2	applied	\N	\N	\N	\N	107796	107796	107797
22853	35013	0	applied	\N	\N	\N	\N	107735	107735	107736
22854	35038	0	applied	\N	\N	\N	\N	107806	107806	107807
22854	35039	1	applied	\N	\N	\N	\N	107808	107808	107809
22854	35040	2	applied	\N	\N	\N	\N	107810	107810	107811
22854	35041	3	applied	\N	\N	\N	\N	107812	107812	107813
22854	35042	4	applied	\N	\N	\N	\N	107814	107814	107815
22856	35038	0	applied	\N	\N	\N	\N	107806	107806	107807
22856	35039	1	applied	\N	\N	\N	\N	107808	107808	107809
22856	35040	2	applied	\N	\N	\N	\N	107810	107810	107811
22856	35042	3	applied	\N	\N	\N	\N	107814	107814	107820
22859	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
22859	35044	1	applied	\N	\N	\N	\N	107824	107824	107825
22859	35045	2	applied	\N	\N	\N	\N	107826	107826	107827
22859	35041	3	applied	\N	\N	\N	\N	107812	107812	107828
22859	35046	4	applied	\N	\N	\N	\N	107829	107829	107830
22867	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22867	35057	1	applied	\N	\N	\N	\N	107861	107861	107862
22867	35058	2	applied	\N	\N	1000000000	\N	107863	107863	107864
22867	35059	3	applied	\N	\N	\N	\N	107865	107865	107866
22870	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22870	35060	1	applied	\N	\N	\N	\N	107871	107871	107872
22870	35057	2	applied	\N	\N	\N	\N	107861	107861	107862
22870	35058	3	applied	\N	\N	1000000000	\N	107863	107863	107864
22870	35059	4	applied	\N	\N	\N	\N	107865	107865	107866
22871	35060	0	applied	\N	\N	\N	\N	107871	107871	107872
22871	35061	1	applied	\N	\N	\N	\N	107874	107874	107875
22871	35062	2	applied	\N	\N	\N	\N	107876	107876	107877
22874	35071	0	applied	\N	\N	\N	\N	107897	107897	107898
22874	35072	1	applied	\N	\N	\N	\N	107899	107899	107900
22874	35073	2	applied	\N	\N	\N	\N	107901	107901	107902
22874	35074	3	applied	\N	\N	\N	\N	107903	107903	107904
22874	35075	4	applied	\N	\N	\N	\N	107905	107905	107906
22874	35076	5	applied	\N	\N	\N	\N	107907	107907	107908
22879	35077	0	applied	\N	\N	\N	\N	107912	107912	107913
22879	35078	1	applied	\N	\N	\N	\N	107914	107914	107915
22879	35079	2	applied	\N	\N	\N	\N	107916	107916	107917
22879	35080	3	applied	\N	\N	\N	\N	107918	107918	107919
22881	35081	0	applied	\N	\N	\N	\N	107928	107928	107929
22881	35082	1	applied	\N	\N	\N	\N	107930	107930	107931
22884	35090	0	applied	\N	\N	\N	\N	107951	107951	107952
22884	35091	1	applied	\N	\N	\N	\N	107953	107953	107954
22884	35092	3	applied	\N	\N	\N	\N	107956	107956	107957
22884	35093	4	applied	\N	\N	\N	\N	107958	107958	107959
22884	35094	5	applied	\N	\N	\N	\N	107960	107960	107961
22884	35095	6	applied	\N	\N	\N	\N	107962	107962	107963
22891	35103	0	applied	\N	\N	\N	\N	108009	108009	108010
22891	35104	1	applied	\N	\N	\N	\N	108011	108011	108012
22891	35105	2	applied	\N	\N	\N	\N	108013	108013	108014
22893	35103	0	applied	\N	\N	\N	\N	108009	108009	108010
22893	35105	1	applied	\N	\N	\N	\N	108013	108013	108017
22896	35109	0	applied	\N	\N	\N	\N	108029	108029	108030
22896	35110	1	applied	\N	\N	\N	\N	108031	108031	108032
22896	35111	2	applied	\N	\N	\N	\N	108033	108033	108034
22896	35112	3	applied	\N	\N	\N	\N	108035	108035	108036
22898	35113	0	applied	\N	\N	\N	\N	108039	108039	108040
22898	35114	1	applied	\N	\N	\N	\N	108041	108041	108042
22898	35115	2	applied	\N	\N	\N	\N	108043	108043	108044
22901	35116	0	applied	\N	\N	\N	\N	108048	108048	108049
22901	35117	1	applied	\N	\N	\N	\N	108050	108050	108051
22901	35118	2	applied	\N	\N	\N	\N	108052	108052	108053
22905	35123	0	applied	\N	\N	\N	\N	108079	108079	108080
22905	35124	1	applied	\N	\N	\N	\N	108081	108081	108082
22905	35125	2	applied	\N	\N	\N	\N	108083	108083	108084
22908	35126	0	applied	\N	\N	\N	\N	108087	108087	108088
22908	35127	1	applied	\N	\N	\N	\N	108089	108089	108090
22908	35128	2	applied	\N	\N	\N	\N	108091	108091	108092
22908	35129	3	applied	\N	\N	\N	\N	108093	108093	108094
22908	35133	4	applied	\N	\N	\N	\N	108101	108101	108119
22908	35134	5	applied	\N	\N	\N	\N	108103	108103	108098
22908	35135	6	applied	\N	\N	\N	\N	108105	108105	108102
22908	35136	7	applied	\N	\N	\N	\N	108107	108107	108104
22908	35137	8	applied	\N	\N	\N	\N	108109	108109	108110
22908	35138	9	applied	\N	\N	\N	\N	108111	108111	108112
22908	35139	10	applied	\N	\N	\N	\N	108113	108113	108114
22908	35140	11	applied	\N	\N	\N	\N	108115	108115	108116
22913	35147	0	applied	\N	\N	\N	\N	108137	108137	108138
22913	35148	1	applied	\N	\N	\N	\N	108139	108139	108140
22913	35149	2	applied	\N	\N	\N	\N	108141	108141	108142
22913	35150	3	applied	\N	\N	\N	\N	108143	108143	108144
22913	35151	4	applied	\N	\N	\N	\N	108145	108145	108146
22913	35152	5	applied	\N	\N	\N	\N	108147	108147	108148
22913	35153	6	applied	\N	\N	\N	\N	108149	108149	108150
22913	35154	7	applied	\N	\N	\N	\N	108151	108151	108152
22913	35155	8	applied	\N	\N	\N	\N	108153	108153	108154
22913	35156	9	applied	\N	\N	\N	\N	108155	108155	108156
22918	35165	0	applied	\N	\N	\N	\N	108181	108181	108182
22918	35166	1	applied	\N	\N	\N	\N	106113	106113	108183
22918	35167	2	applied	\N	\N	\N	\N	108184	108184	108185
22918	35168	3	applied	\N	\N	\N	\N	108186	108186	108187
22920	35169	0	applied	\N	\N	\N	\N	108190	108190	108191
22920	35171	1	applied	\N	\N	\N	\N	108200	108200	108205
22920	35170	2	applied	\N	\N	\N	\N	108202	108202	106140
22846	35027	0	applied	\N	\N	1000000000	\N	107770	107770	107771
22846	35028	1	applied	\N	\N	\N	\N	107772	107772	107773
22846	35029	2	applied	\N	\N	\N	\N	107774	107774	107775
22846	35031	3	applied	\N	\N	\N	\N	107779	107779	107780
22846	35030	4	applied	\N	\N	\N	\N	107776	107776	107781
22857	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
22857	35044	1	applied	\N	\N	\N	\N	107824	107824	107825
22857	35045	2	applied	\N	\N	\N	\N	107826	107826	107827
22857	35041	3	applied	\N	\N	\N	\N	107812	107812	107828
22857	35046	4	applied	\N	\N	\N	\N	107829	107829	107830
22862	35047	0	applied	\N	\N	\N	\N	107835	107835	107836
22862	35048	1	applied	\N	\N	\N	\N	107837	107837	107838
22862	35049	2	applied	\N	\N	\N	\N	107839	107839	107420
22862	35050	3	applied	\N	\N	\N	\N	107840	107840	107841
22866	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22866	35057	1	applied	\N	\N	\N	\N	107861	107861	107862
22866	35058	2	applied	\N	\N	1000000000	\N	107863	107863	107864
22866	35059	3	applied	\N	\N	\N	\N	107865	107865	107866
22868	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22868	35057	1	applied	\N	\N	\N	\N	107861	107861	107862
22868	35058	2	applied	\N	\N	1000000000	\N	107863	107863	107864
22868	35059	3	applied	\N	\N	\N	\N	107865	107865	107866
22888	35099	0	applied	\N	\N	\N	\N	107975	107975	107976
22888	35100	1	applied	\N	\N	\N	\N	107977	107977	107978
22888	35101	2	applied	\N	\N	\N	\N	107979	107979	107980
22888	35102	3	applied	\N	\N	\N	\N	107981	107981	107982
22890	35056	0	applied	\N	\N	\N	\N	107859	107859	107860
22890	35060	1	applied	\N	\N	\N	\N	107871	107871	107872
22890	35063	2	applied	\N	\N	\N	\N	107878	107878	107879
22890	35066	3	applied	\N	\N	\N	\N	107886	107886	107887
22890	35071	4	applied	\N	\N	\N	\N	107897	107897	107898
22890	35072	5	applied	\N	\N	\N	\N	107899	107899	107900
22890	35077	6	applied	\N	\N	\N	\N	107912	107912	107913
22890	35081	7	applied	\N	\N	\N	\N	107928	107928	107929
22890	35083	8	applied	\N	\N	\N	\N	107934	107934	107987
22890	35086	9	applied	\N	\N	\N	\N	107941	107941	107988
22890	35090	10	applied	\N	\N	\N	\N	107951	107951	107989
22890	35091	11	applied	\N	\N	\N	\N	107953	107953	107990
22890	35096	12	applied	\N	\N	\N	\N	107969	107969	107991
22890	35099	13	applied	\N	\N	\N	\N	107975	107975	107992
22890	35057	14	applied	\N	\N	\N	\N	107861	107861	107862
22890	35061	15	applied	\N	\N	\N	\N	107874	107874	107993
22890	35058	16	applied	\N	\N	1000000000	\N	107863	107863	107864
22890	35067	17	applied	\N	\N	1000000000	\N	107888	107888	107889
22890	35059	18	applied	\N	\N	\N	\N	107865	107865	107875
22890	35065	19	applied	\N	\N	\N	\N	107882	107882	107994
22890	35068	20	applied	\N	\N	\N	\N	107890	107890	107995
22890	35073	21	applied	\N	\N	\N	\N	107901	107901	107996
22890	35075	22	applied	\N	\N	\N	\N	107905	107905	107893
22890	35079	23	applied	\N	\N	\N	\N	107916	107916	107997
22890	35082	24	applied	\N	\N	\N	\N	107930	107930	107904
22890	35084	25	applied	\N	\N	\N	\N	107936	107936	107906
22890	35087	26	applied	\N	\N	\N	\N	107943	107943	107915
22890	35094	27	applied	\N	\N	\N	\N	107960	107960	107917
22890	35070	28	applied	\N	\N	\N	\N	107894	107894	107998
22890	35078	29	applied	\N	\N	\N	\N	107914	107914	107919
22890	35088	30	applied	\N	\N	\N	\N	107945	107945	107999
22890	35100	31	applied	\N	\N	\N	\N	107977	107977	108000
22890	35062	32	applied	\N	\N	\N	\N	107876	107876	108001
22890	35064	33	applied	\N	\N	\N	\N	107880	107880	107937
22890	35069	34	applied	\N	\N	\N	\N	107892	107892	107939
22890	35074	35	applied	\N	\N	\N	\N	107903	107903	108002
22890	35095	36	applied	\N	\N	\N	\N	107962	107962	108003
22890	35097	37	applied	\N	\N	\N	\N	107971	107971	107957
22890	35101	38	applied	\N	\N	\N	\N	107979	107979	108004
22890	35076	39	applied	\N	\N	\N	\N	107907	107907	107961
22890	35080	40	applied	\N	\N	\N	\N	107918	107918	108005
22890	35085	41	applied	\N	\N	\N	\N	107938	107938	108006
22890	35089	42	applied	\N	\N	\N	\N	107947	107947	107972
22890	35092	43	applied	\N	\N	\N	\N	107956	107956	107974
22890	35093	44	applied	\N	\N	\N	\N	107958	107958	108007
22890	35098	45	applied	\N	\N	\N	\N	107973	107973	107980
22890	35102	46	applied	\N	\N	\N	\N	107981	107981	107982
22892	35103	0	applied	\N	\N	\N	\N	108009	108009	108010
22892	35104	1	applied	\N	\N	\N	\N	108011	108011	108012
22892	35105	2	applied	\N	\N	\N	\N	108013	108013	108014
22897	35109	0	applied	\N	\N	\N	\N	108029	108029	108030
22897	35110	1	applied	\N	\N	\N	\N	108031	108031	108032
22897	35111	2	applied	\N	\N	\N	\N	108033	108033	108034
22897	35112	3	applied	\N	\N	\N	\N	108035	108035	108036
22899	35113	0	applied	\N	\N	\N	\N	108039	108039	108040
22899	35114	1	applied	\N	\N	\N	\N	108041	108041	108042
22899	35115	2	applied	\N	\N	\N	\N	108043	108043	108044
22902	35116	0	applied	\N	\N	\N	\N	108048	108048	108049
22902	35117	1	applied	\N	\N	\N	\N	108050	108050	108051
22902	35118	2	applied	\N	\N	\N	\N	108052	108052	108053
22909	35141	0	applied	\N	\N	\N	\N	108121	108121	108122
22909	35142	1	applied	\N	\N	\N	\N	108123	108123	108124
22909	35143	2	applied	\N	\N	\N	\N	108125	108125	108126
22911	35144	0	applied	\N	\N	\N	\N	108130	108130	108131
22911	35145	1	applied	\N	\N	\N	\N	108132	108132	108133
22911	35146	2	applied	\N	\N	\N	\N	108134	108134	108135
22914	35157	0	applied	\N	\N	\N	\N	108158	108158	108159
22914	35158	1	applied	\N	\N	\N	\N	108160	108160	108161
22914	35159	2	applied	\N	\N	\N	\N	108162	108162	108163
22914	35160	3	applied	\N	\N	\N	\N	108164	108164	108165
22919	35144	0	applied	\N	\N	\N	\N	108130	108130	108131
22919	35147	1	applied	\N	\N	\N	\N	108137	108137	108138
22919	35148	2	applied	\N	\N	\N	\N	108139	108139	108140
22919	35149	3	applied	\N	\N	\N	\N	108141	108141	108142
22919	35157	4	applied	\N	\N	\N	\N	108158	108158	108159
22919	35161	5	applied	\N	\N	\N	\N	108168	108168	108169
22919	35165	6	applied	\N	\N	\N	\N	108181	108181	108182
22919	35169	7	applied	\N	\N	\N	\N	108190	108190	108191
22919	35166	8	applied	\N	\N	\N	\N	106113	106113	108172
22919	35145	9	applied	\N	\N	\N	\N	108132	108132	108133
22919	35170	10	applied	\N	\N	\N	\N	108192	108192	106140
22919	35150	11	applied	\N	\N	\N	\N	108143	108143	108193
22919	35158	12	applied	\N	\N	\N	\N	108160	108160	108135
22919	35151	13	applied	\N	\N	\N	\N	108145	108145	108194
22919	35146	14	applied	\N	\N	\N	\N	108134	108134	108195
22919	35152	15	applied	\N	\N	\N	\N	108147	108147	108196
22919	35153	16	applied	\N	\N	\N	\N	108149	108149	108197
22919	35154	17	applied	\N	\N	\N	\N	108151	108151	108198
22919	35160	18	applied	\N	\N	\N	\N	108164	108164	108154
22919	35162	19	applied	\N	\N	\N	\N	108170	108170	108199
22919	35167	20	applied	\N	\N	\N	\N	108184	108184	108161
22919	35171	21	applied	\N	\N	\N	\N	108200	108200	108201
22919	35163	22	applied	\N	\N	\N	\N	106057	106057	108202
22855	35040	2	applied	\N	\N	\N	\N	107810	107810	107811
22855	35041	3	applied	\N	\N	\N	\N	107812	107812	107813
22855	35042	4	applied	\N	\N	\N	\N	107814	107814	107815
22860	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
22860	35044	1	applied	\N	\N	\N	\N	107824	107824	107825
22860	35045	2	applied	\N	\N	\N	\N	107826	107826	107827
22860	35041	3	applied	\N	\N	\N	\N	107812	107812	107828
22861	35047	0	applied	\N	\N	\N	\N	107835	107835	107836
22861	35048	1	applied	\N	\N	\N	\N	107837	107837	107838
22861	35049	2	applied	\N	\N	\N	\N	107839	107839	107420
22861	35050	3	applied	\N	\N	\N	\N	107840	107840	107841
22865	35051	0	applied	\N	\N	\N	\N	107846	107846	107847
22865	35052	1	applied	\N	\N	\N	\N	107848	107848	107849
22865	35053	2	applied	\N	\N	\N	\N	107850	107850	107851
22865	35054	3	applied	\N	\N	1000000000	\N	107852	107852	107853
22865	35055	4	applied	\N	\N	\N	\N	107854	107854	107855
22872	35063	0	applied	\N	\N	\N	\N	107878	107878	107879
22872	35064	1	applied	\N	\N	\N	\N	107880	107880	107881
22872	35065	2	applied	\N	\N	\N	\N	107882	107882	107883
22875	35071	0	applied	\N	\N	\N	\N	107897	107897	107898
22875	35072	1	applied	\N	\N	\N	\N	107899	107899	107900
22875	35073	2	applied	\N	\N	\N	\N	107901	107901	107902
22875	35074	3	applied	\N	\N	\N	\N	107903	107903	107904
22875	35075	4	applied	\N	\N	\N	\N	107905	107905	107906
22875	35076	5	applied	\N	\N	\N	\N	107907	107907	107908
22877	35077	0	applied	\N	\N	\N	\N	107912	107912	107913
22877	35078	1	applied	\N	\N	\N	\N	107914	107914	107915
22877	35079	2	applied	\N	\N	\N	\N	107916	107916	107917
22877	35080	3	applied	\N	\N	\N	\N	107918	107918	107919
22882	35083	0	applied	\N	\N	\N	\N	107934	107934	107935
22882	35084	1	applied	\N	\N	\N	\N	107936	107936	107937
22882	35085	2	applied	\N	\N	\N	\N	107938	107938	107939
22885	35090	0	applied	\N	\N	\N	\N	107951	107951	107952
22885	35091	1	applied	\N	\N	\N	\N	107953	107953	107954
22885	35092	3	applied	\N	\N	\N	\N	107956	107956	107957
22885	35093	4	applied	\N	\N	\N	\N	107958	107958	107959
22885	35094	5	applied	\N	\N	\N	\N	107960	107960	107961
22885	35095	6	applied	\N	\N	\N	\N	107962	107962	107963
22887	35099	0	applied	\N	\N	\N	\N	107975	107975	107976
22887	35100	1	applied	\N	\N	\N	\N	107977	107977	107978
22887	35101	2	applied	\N	\N	\N	\N	107979	107979	107980
22887	35102	3	applied	\N	\N	\N	\N	107981	107981	107982
22889	35099	0	applied	\N	\N	\N	\N	107975	107975	107976
22889	35100	1	applied	\N	\N	\N	\N	107977	107977	107978
22889	35101	2	applied	\N	\N	\N	\N	107979	107979	107980
22889	35102	3	applied	\N	\N	\N	\N	107981	107981	107982
22894	35106	0	applied	\N	\N	\N	\N	108019	108019	108020
22894	35107	1	applied	\N	\N	\N	\N	108021	108021	108022
22894	35108	2	applied	\N	\N	\N	\N	108023	108023	108024
22903	35104	0	applied	\N	\N	\N	\N	108011	108011	108012
22903	35112	1	applied	\N	\N	\N	\N	108035	108035	108059
22903	35119	2	applied	\N	\N	\N	\N	108060	108060	108014
22903	35108	3	applied	\N	\N	\N	\N	108023	108023	108061
22903	35110	4	applied	\N	\N	\N	\N	108031	108031	108062
22903	35114	6	applied	\N	\N	\N	\N	108041	108041	108064
22903	35117	7	applied	\N	\N	\N	\N	108050	108050	108065
22903	35120	8	applied	\N	\N	\N	\N	108066	108066	108067
22906	35123	0	applied	\N	\N	\N	\N	108079	108079	108080
22906	35124	1	applied	\N	\N	\N	\N	108081	108081	108082
22906	35125	2	applied	\N	\N	\N	\N	108083	108083	108084
22916	35163	0	applied	\N	\N	\N	\N	106057	106057	108172
22916	35164	1	applied	\N	\N	\N	\N	108173	108173	108177
22923	35173	0	applied	\N	\N	\N	\N	108213	108213	108214
22923	35175	1	applied	\N	\N	\N	\N	108217	108217	108223
22923	35176	2	applied	\N	\N	\N	\N	108219	108219	108224
22925	35173	0	applied	\N	\N	\N	\N	108213	108213	108214
22925	35174	1	applied	\N	\N	\N	\N	108215	108215	108216
22925	35175	2	applied	\N	\N	\N	\N	108217	108217	108218
22925	35176	3	applied	\N	\N	\N	\N	108219	108219	108220
22927	35177	0	applied	\N	\N	\N	\N	108232	108232	108233
22927	35178	1	applied	\N	\N	\N	\N	108234	108234	108235
22927	35179	2	applied	\N	\N	\N	\N	108236	108236	108237
22930	35180	0	applied	\N	\N	\N	\N	108256	108256	108257
22930	35181	1	applied	\N	\N	\N	\N	108258	108258	108259
22930	35182	2	applied	\N	\N	\N	\N	108260	108260	108261
22931	35180	0	applied	\N	\N	\N	\N	108256	108256	108257
22937	35183	0	applied	\N	\N	\N	\N	108273	108273	108274
22937	35184	1	applied	\N	\N	\N	\N	108275	108275	108276
22937	35185	2	applied	\N	\N	\N	\N	108277	108277	108278
22937	35186	3	applied	\N	\N	\N	\N	108279	108279	108280
22940	35190	0	applied	\N	\N	\N	\N	108296	108296	108297
22940	35191	1	applied	\N	\N	\N	\N	108298	108298	108299
22940	35192	2	applied	\N	\N	\N	\N	108300	108300	108301
22945	35193	0	applied	\N	\N	\N	\N	108326	108326	108327
22945	35194	1	applied	\N	\N	\N	\N	108328	108328	108329
22945	35201	2	applied	\N	\N	\N	\N	108345	108345	108346
22945	35202	3	applied	\N	\N	\N	\N	108347	108347	108348
22945	35203	4	applied	\N	\N	\N	\N	108349	108349	108350
22945	35204	5	applied	\N	\N	\N	\N	108351	108351	108352
22945	35205	6	applied	\N	\N	\N	\N	108353	108353	108354
22945	35206	7	applied	\N	\N	\N	\N	108355	108355	108356
22945	35207	8	applied	\N	\N	\N	\N	108357	108357	108358
22945	35208	9	applied	\N	\N	\N	\N	108359	108359	108360
22945	35209	10	applied	\N	\N	\N	\N	108361	108361	108362
22945	35210	11	applied	\N	\N	\N	\N	108363	108363	108364
22945	35211	12	applied	\N	\N	\N	\N	108365	108365	108366
22945	35212	13	applied	\N	\N	\N	\N	108367	108367	108368
22945	35213	14	applied	\N	\N	\N	\N	108369	108369	108370
22945	35214	15	applied	\N	\N	\N	\N	108371	108371	108372
22948	35215	0	applied	\N	\N	\N	\N	108375	108375	108376
22948	35216	1	applied	\N	\N	\N	\N	108377	108377	108378
22948	35217	2	applied	\N	\N	\N	\N	108379	108379	108380
22954	35226	0	applied	\N	\N	\N	\N	108407	108407	108408
22954	35227	1	applied	\N	\N	\N	\N	108425	108425	108428
22954	35228	2	applied	\N	\N	\N	\N	108429	108429	108430
22958	35251	0	applied	\N	\N	\N	\N	108489	108489	108490
22958	35252	1	applied	\N	\N	\N	\N	108491	108491	108492
22958	35253	2	applied	\N	\N	\N	\N	108493	108493	108494
22958	35254	3	applied	\N	\N	\N	\N	108495	108495	108496
22960	35251	0	applied	\N	\N	\N	\N	108489	108489	108490
22960	35252	1	applied	\N	\N	\N	\N	108491	108491	108492
22960	35253	2	applied	\N	\N	\N	\N	108493	108493	108494
22960	35254	3	applied	\N	\N	\N	\N	108495	108495	108496
22962	35255	0	applied	\N	\N	\N	\N	108501	108501	108502
22962	35256	1	applied	\N	\N	\N	\N	108503	108503	108504
22962	35257	2	applied	\N	\N	\N	\N	108505	108505	108506
22964	35255	0	applied	\N	\N	\N	\N	108501	108501	108502
22964	35256	1	applied	\N	\N	\N	\N	108503	108503	108504
22964	35257	2	applied	\N	\N	\N	\N	108505	108505	108506
22869	35057	1	applied	\N	\N	\N	\N	107861	107861	107862
22869	35058	2	applied	\N	\N	1000000000	\N	107863	107863	107864
22869	35059	3	applied	\N	\N	\N	\N	107865	107865	107866
22873	35066	0	applied	\N	\N	\N	\N	107886	107886	107887
22873	35067	1	applied	\N	\N	1000000000	\N	107888	107888	107889
22873	35068	2	applied	\N	\N	\N	\N	107890	107890	107891
22873	35069	3	applied	\N	\N	\N	\N	107892	107892	107893
22873	35070	4	applied	\N	\N	\N	\N	107894	107894	107895
22876	35077	0	applied	\N	\N	\N	\N	107912	107912	107913
22876	35078	1	applied	\N	\N	\N	\N	107914	107914	107915
22876	35079	2	applied	\N	\N	\N	\N	107916	107916	107917
22876	35080	3	applied	\N	\N	\N	\N	107918	107918	107919
22878	35077	0	applied	\N	\N	\N	\N	107912	107912	107913
22878	35078	1	applied	\N	\N	\N	\N	107914	107914	107915
22878	35079	2	applied	\N	\N	\N	\N	107916	107916	107917
22878	35080	3	applied	\N	\N	\N	\N	107918	107918	107919
22880	35077	0	applied	\N	\N	\N	\N	107912	107912	107913
22880	35078	1	applied	\N	\N	\N	\N	107914	107914	107915
22880	35079	2	applied	\N	\N	\N	\N	107916	107916	107917
22880	35080	3	applied	\N	\N	\N	\N	107918	107918	107919
22883	35086	0	applied	\N	\N	\N	\N	107941	107941	107942
22883	35087	1	applied	\N	\N	\N	\N	107943	107943	107944
22883	35088	2	applied	\N	\N	\N	\N	107945	107945	107946
22883	35089	3	applied	\N	\N	\N	\N	107947	107947	107948
22886	35096	0	applied	\N	\N	\N	\N	107969	107969	107970
22886	35097	1	applied	\N	\N	\N	\N	107971	107971	107972
22886	35098	2	applied	\N	\N	\N	\N	107973	107973	107974
22895	35106	0	applied	\N	\N	\N	\N	108019	108019	108020
22895	35107	1	applied	\N	\N	\N	\N	108021	108021	108022
22895	35108	2	applied	\N	\N	\N	\N	108023	108023	108024
22900	35116	0	applied	\N	\N	\N	\N	108048	108048	108049
22900	35117	1	applied	\N	\N	\N	\N	108050	108050	108051
22900	35118	2	applied	\N	\N	\N	\N	108052	108052	108053
22904	35121	0	applied	\N	\N	\N	\N	108072	108072	108073
22904	35120	1	applied	\N	\N	\N	\N	108066	108066	108074
22904	35119	2	applied	\N	\N	\N	\N	108060	108060	108075
22904	35122	3	applied	\N	\N	\N	\N	108076	108076	108077
22907	35126	0	applied	\N	\N	\N	\N	108087	108087	108088
22907	35127	1	applied	\N	\N	\N	\N	108089	108089	108090
22907	35128	2	applied	\N	\N	\N	\N	108091	108091	108092
22907	35129	3	applied	\N	\N	\N	\N	108093	108093	108094
22907	35130	4	applied	\N	\N	\N	\N	108095	108095	108096
22907	35131	5	applied	\N	\N	\N	\N	108097	108097	108098
22907	35132	6	applied	\N	\N	\N	\N	108099	108099	108100
22907	35133	7	applied	\N	\N	\N	\N	108101	108101	108102
22907	35134	8	applied	\N	\N	\N	\N	108103	108103	108104
22907	35135	9	applied	\N	\N	\N	\N	108105	108105	108106
22907	35136	10	applied	\N	\N	\N	\N	108107	108107	108108
22907	35137	11	applied	\N	\N	\N	\N	108109	108109	108110
22907	35138	12	applied	\N	\N	\N	\N	108111	108111	108112
22907	35139	13	applied	\N	\N	\N	\N	108113	108113	108114
22907	35140	14	applied	\N	\N	\N	\N	108115	108115	108116
22910	35141	0	applied	\N	\N	\N	\N	108121	108121	108122
22910	35142	1	applied	\N	\N	\N	\N	108123	108123	108124
22910	35143	2	applied	\N	\N	\N	\N	108125	108125	108126
22912	35144	0	applied	\N	\N	\N	\N	108130	108130	108131
22912	35145	1	applied	\N	\N	\N	\N	108132	108132	108133
22912	35146	2	applied	\N	\N	\N	\N	108134	108134	108135
22915	35161	0	applied	\N	\N	\N	\N	108168	108168	108169
22915	35162	1	applied	\N	\N	\N	\N	108170	108170	108171
22915	35163	2	applied	\N	\N	\N	\N	106057	106057	108172
22915	35164	3	applied	\N	\N	\N	\N	108173	108173	108174
22917	35161	0	applied	\N	\N	\N	\N	108168	108168	108169
22917	35162	1	applied	\N	\N	\N	\N	108170	108170	108171
22917	35163	2	applied	\N	\N	\N	\N	106057	106057	108172
22917	35164	3	applied	\N	\N	\N	\N	108173	108173	108174
22928	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
22928	35027	1	applied	\N	\N	1000000000	\N	107770	107770	107771
22928	35039	2	applied	\N	\N	\N	\N	107808	107808	107809
22928	35166	3	applied	\N	\N	\N	\N	106113	106113	108172
22928	35058	4	applied	\N	\N	1000000000	\N	107863	107863	107864
22928	35129	5	applied	\N	\N	\N	\N	108238	108238	108094
22928	35067	6	applied	\N	\N	1000000000	\N	107888	107888	107889
22928	35170	7	applied	\N	\N	\N	\N	108192	108192	106140
22928	35001	8	applied	\N	\N	\N	\N	107699	107699	107420
22928	34935	9	applied	\N	\N	\N	\N	107507	107507	107508
22928	34936	10	applied	\N	\N	\N	\N	107509	107509	107510
22928	35049	11	applied	\N	\N	\N	\N	107839	107839	107420
22928	34937	12	applied	\N	\N	\N	\N	107511	107511	107512
22928	34938	13	applied	\N	\N	\N	\N	107513	107513	107514
22928	35163	14	applied	\N	\N	\N	\N	106057	106057	108202
22928	35054	15	applied	\N	\N	1000000000	\N	107852	107852	107853
22928	35137	16	applied	\N	\N	\N	\N	108239	108239	108110
22928	35138	17	applied	\N	\N	\N	\N	108240	108240	108112
22928	35139	18	applied	\N	\N	\N	\N	108241	108241	108114
22928	35140	19	applied	\N	\N	\N	\N	108242	108242	108116
22935	35183	0	applied	\N	\N	\N	\N	108273	108273	108274
22935	35184	1	applied	\N	\N	\N	\N	108275	108275	108276
22935	35185	2	applied	\N	\N	\N	\N	108277	108277	108278
22935	35186	3	applied	\N	\N	\N	\N	108279	108279	108280
22944	35193	0	applied	\N	\N	\N	\N	108326	108326	108327
22944	35194	1	applied	\N	\N	\N	\N	108328	108328	108329
22944	35201	2	applied	\N	\N	\N	\N	108345	108345	108346
22944	35202	3	applied	\N	\N	\N	\N	108347	108347	108348
22944	35203	4	applied	\N	\N	\N	\N	108349	108349	108350
22944	35204	5	applied	\N	\N	\N	\N	108351	108351	108352
22944	35205	6	applied	\N	\N	\N	\N	108353	108353	108354
22944	35206	7	applied	\N	\N	\N	\N	108355	108355	108356
22944	35207	8	applied	\N	\N	\N	\N	108357	108357	108358
22944	35208	9	applied	\N	\N	\N	\N	108359	108359	108360
22944	35209	10	applied	\N	\N	\N	\N	108361	108361	108362
22944	35210	11	applied	\N	\N	\N	\N	108363	108363	108364
22944	35211	12	applied	\N	\N	\N	\N	108365	108365	108366
22944	35212	13	applied	\N	\N	\N	\N	108367	108367	108368
22944	35213	14	applied	\N	\N	\N	\N	108369	108369	108370
22944	35214	15	applied	\N	\N	\N	\N	108371	108371	108372
22947	35215	0	applied	\N	\N	\N	\N	108375	108375	108376
22947	35216	1	applied	\N	\N	\N	\N	108377	108377	108378
22947	35217	2	applied	\N	\N	\N	\N	108379	108379	108380
22950	34890	0	applied	\N	\N	\N	\N	107402	107402	107403
22950	35043	1	applied	\N	\N	1000000000	\N	107822	107822	107823
22950	34654	2	applied	\N	\N	\N	\N	106784	106784	106785
22950	34660	3	applied	\N	\N	\N	\N	106801	106801	106802
22950	34661	4	applied	\N	\N	\N	\N	106803	106803	106804
22950	35027	5	applied	\N	\N	1000000000	\N	107770	107770	107771
22950	35039	6	applied	\N	\N	\N	\N	107808	107808	107809
22950	34618	7	applied	\N	\N	\N	\N	106689	106689	106690
22950	34619	8	applied	\N	\N	\N	\N	106691	106691	106692
22950	34625	9	applied	\N	\N	\N	\N	106704	106704	106705
22919	35155	23	applied	\N	\N	\N	\N	108153	108153	108165
22919	35156	24	applied	\N	\N	\N	\N	108155	108155	108177
22919	35159	25	applied	\N	\N	\N	\N	108162	108162	108203
22919	35164	26	applied	\N	\N	\N	\N	108173	108173	108204
22919	35168	27	applied	\N	\N	\N	\N	108186	108186	108205
22919	35172	28	applied	\N	\N	\N	\N	108206	108206	108207
22921	35169	0	applied	\N	\N	\N	\N	108190	108190	108191
22921	35171	1	applied	\N	\N	\N	\N	108200	108200	108205
22921	35170	2	applied	\N	\N	\N	\N	108202	108202	106140
22921	35172	3	applied	\N	\N	\N	\N	108206	108206	108207
22934	35183	0	applied	\N	\N	\N	\N	108273	108273	108274
22934	35184	1	applied	\N	\N	\N	\N	108275	108275	108276
22934	35185	2	applied	\N	\N	\N	\N	108277	108277	108278
22934	35186	3	applied	\N	\N	\N	\N	108279	108279	108280
22938	35187	0	applied	\N	\N	\N	\N	108289	108289	108290
22938	35188	1	applied	\N	\N	\N	\N	108291	108291	108292
22938	35189	2	applied	\N	\N	\N	\N	108293	108293	108294
22941	35096	0	applied	\N	\N	\N	\N	107969	107969	107970
22941	35099	1	applied	\N	\N	\N	\N	107975	107975	107976
22941	35103	2	applied	\N	\N	\N	\N	108009	108009	108010
22941	35106	3	applied	\N	\N	\N	\N	108019	108019	108020
22941	35109	4	applied	\N	\N	\N	\N	108029	108029	108030
22941	35113	5	applied	\N	\N	\N	\N	108039	108039	108040
22941	35116	6	applied	\N	\N	\N	\N	108048	108048	108049
22941	35121	7	applied	\N	\N	\N	\N	108072	108072	108073
22941	35123	8	applied	\N	\N	\N	\N	108079	108079	108080
22941	35126	9	applied	\N	\N	\N	\N	108087	108087	108088
22941	35127	10	applied	\N	\N	\N	\N	108089	108089	108090
22941	35128	11	applied	\N	\N	\N	\N	108091	108091	108092
22941	35141	12	applied	\N	\N	\N	\N	108121	108121	108122
22941	35144	13	applied	\N	\N	\N	\N	108130	108130	108131
22941	35147	14	applied	\N	\N	\N	\N	108137	108137	108138
22941	35148	15	applied	\N	\N	\N	\N	108139	108139	108140
22941	35149	16	applied	\N	\N	\N	\N	108141	108141	108142
22941	35157	17	applied	\N	\N	\N	\N	108158	108158	108159
22941	35161	18	applied	\N	\N	\N	\N	108168	108168	108169
22941	35165	19	applied	\N	\N	\N	\N	108181	108181	108182
22941	35169	20	applied	\N	\N	\N	\N	108190	108190	108191
22941	35173	21	applied	\N	\N	\N	\N	108213	108213	108214
22941	35177	22	applied	\N	\N	\N	\N	108232	108232	108233
22941	35180	23	applied	\N	\N	\N	\N	108256	108256	108257
22941	35183	24	applied	\N	\N	\N	\N	108273	108273	108274
22941	35187	25	applied	\N	\N	\N	\N	108289	108289	108290
22941	35190	26	applied	\N	\N	\N	\N	108296	108296	108297
22941	35166	27	applied	\N	\N	\N	\N	106113	106113	108172
22941	35129	28	applied	\N	\N	\N	\N	108093	108093	108094
22941	35170	29	applied	\N	\N	\N	\N	108192	108192	106140
22941	35100	30	applied	\N	\N	\N	\N	107977	107977	108006
22941	35112	31	applied	\N	\N	\N	\N	108035	108035	108302
22941	35119	32	applied	\N	\N	\N	\N	108060	108060	107972
22941	35133	33	applied	\N	\N	\N	\N	108101	108101	108303
22941	35150	34	applied	\N	\N	\N	\N	108143	108143	107974
22941	35158	35	applied	\N	\N	\N	\N	108160	108160	107978
22941	35176	36	applied	\N	\N	\N	\N	108219	108219	108007
22941	35185	37	applied	\N	\N	\N	\N	108277	108277	108304
22941	35163	38	applied	\N	\N	\N	\N	106057	106057	108202
22941	35097	39	applied	\N	\N	\N	\N	107971	107971	107982
22941	35101	40	applied	\N	\N	\N	\N	107979	107979	108012
22941	35104	41	applied	\N	\N	\N	\N	108011	108011	108305
22941	35108	42	applied	\N	\N	\N	\N	108023	108023	108306
22941	35110	43	applied	\N	\N	\N	\N	108031	108031	108307
22941	35114	44	applied	\N	\N	\N	\N	108041	108041	108034
22941	35117	45	applied	\N	\N	\N	\N	108050	108050	108308
22941	35120	46	applied	\N	\N	\N	\N	108066	108066	108044
22941	35125	47	applied	\N	\N	\N	\N	108083	108083	108051
22941	35134	48	applied	\N	\N	\N	\N	108103	108103	108245
22941	35135	49	applied	\N	\N	\N	\N	108105	108105	108075
22941	35136	50	applied	\N	\N	\N	\N	108107	108107	108309
22941	35142	51	applied	\N	\N	\N	\N	108123	108123	108310
22941	35145	52	applied	\N	\N	\N	\N	108132	108132	108096
22941	35151	53	applied	\N	\N	\N	\N	108145	108145	108311
22941	35137	54	applied	\N	\N	\N	\N	108109	108109	108110
22941	35138	55	applied	\N	\N	\N	\N	108111	108111	108112
22941	35139	56	applied	\N	\N	\N	\N	108113	108113	108114
22941	35140	57	applied	\N	\N	\N	\N	108115	108115	108116
22941	35155	58	applied	\N	\N	\N	\N	108153	108153	108312
22941	35156	59	applied	\N	\N	\N	\N	108155	108155	108313
22941	35159	60	applied	\N	\N	\N	\N	108162	108162	108314
22941	35164	61	applied	\N	\N	\N	\N	108173	108173	108315
22941	35168	62	applied	\N	\N	\N	\N	108186	108186	108316
22941	35172	63	applied	\N	\N	\N	\N	108206	108206	108317
22941	35175	64	applied	\N	\N	\N	\N	108217	108217	108135
22941	35178	65	applied	\N	\N	\N	\N	108234	108234	108194
22941	35181	66	applied	\N	\N	\N	\N	108258	108258	108148
22941	35184	67	applied	\N	\N	\N	\N	108275	108275	108197
22941	35188	68	applied	\N	\N	\N	\N	108291	108291	108318
22941	35191	69	applied	\N	\N	\N	\N	108298	108298	108199
22941	35098	70	applied	\N	\N	\N	\N	107973	107973	108161
22941	35102	71	applied	\N	\N	\N	\N	107981	107981	108201
22941	35105	72	applied	\N	\N	\N	\N	108013	108013	108250
22941	35107	73	applied	\N	\N	\N	\N	108021	108021	108251
22941	35111	74	applied	\N	\N	\N	\N	108033	108033	108177
22941	35115	75	applied	\N	\N	\N	\N	108043	108043	108174
22941	35118	76	applied	\N	\N	\N	\N	108052	108052	108185
22941	35122	77	applied	\N	\N	\N	\N	108076	108076	108204
22941	35124	78	applied	\N	\N	\N	\N	108081	108081	108252
22941	35130	79	applied	\N	\N	\N	\N	108095	108095	108253
22941	35131	80	applied	\N	\N	\N	\N	108097	108097	108207
22941	35132	81	applied	\N	\N	\N	\N	108099	108099	108216
22941	35143	82	applied	\N	\N	\N	\N	108125	108125	108224
22941	35146	83	applied	\N	\N	\N	\N	108134	108134	108220
22941	35152	84	applied	\N	\N	\N	\N	108147	108147	108254
22941	35153	85	applied	\N	\N	\N	\N	108149	108149	108319
22941	35154	86	applied	\N	\N	\N	\N	108151	108151	108320
22941	35160	87	applied	\N	\N	\N	\N	108164	108164	108259
22941	35162	88	applied	\N	\N	\N	\N	108170	108170	108261
22941	35167	89	applied	\N	\N	\N	\N	108184	108184	108321
22941	35171	90	applied	\N	\N	\N	\N	108200	108200	108278
22941	35174	91	applied	\N	\N	\N	\N	108215	108215	108280
22941	35179	92	applied	\N	\N	\N	\N	108236	108236	108322
22941	35182	93	applied	\N	\N	\N	\N	108260	108260	108323
22941	35186	94	applied	\N	\N	\N	\N	108279	108279	108324
22941	35189	95	applied	\N	\N	\N	\N	108293	108293	108299
22941	35192	96	applied	\N	\N	\N	\N	108300	108300	108301
22943	35195	0	applied	\N	\N	\N	\N	108330	108330	108331
22943	35196	1	applied	\N	\N	\N	\N	108332	108332	108333
22943	35197	2	applied	\N	\N	\N	\N	108334	108334	108335
22943	35198	3	applied	\N	\N	\N	\N	108336	108336	108337
22943	35199	4	applied	\N	\N	\N	\N	108338	108338	108339
22943	35200	5	applied	\N	\N	\N	\N	108340	108340	108341
22920	35172	3	applied	\N	\N	\N	\N	108206	108206	108207
22922	35173	0	applied	\N	\N	\N	\N	108213	108213	108214
22922	35174	1	applied	\N	\N	\N	\N	108215	108215	108216
22922	35175	2	applied	\N	\N	\N	\N	108217	108217	108218
22922	35176	3	applied	\N	\N	\N	\N	108219	108219	108220
22924	35173	0	applied	\N	\N	\N	\N	108213	108213	108214
22924	35174	1	applied	\N	\N	\N	\N	108215	108215	108216
22924	35175	2	applied	\N	\N	\N	\N	108217	108217	108218
22924	35176	3	applied	\N	\N	\N	\N	108219	108219	108220
22926	35173	0	applied	\N	\N	\N	\N	108213	108213	108214
22926	35174	1	applied	\N	\N	\N	\N	108215	108215	108216
22926	35175	2	applied	\N	\N	\N	\N	108217	108217	108218
22926	35176	3	applied	\N	\N	\N	\N	108219	108219	108220
22929	35116	0	applied	\N	\N	\N	\N	108048	108048	108049
22929	35121	1	applied	\N	\N	\N	\N	108072	108072	108073
22929	35123	2	applied	\N	\N	\N	\N	108079	108079	108080
22929	35126	3	applied	\N	\N	\N	\N	108087	108087	108088
22929	35127	4	applied	\N	\N	\N	\N	108089	108089	108090
22929	35128	5	applied	\N	\N	\N	\N	108091	108091	108092
22929	35141	6	applied	\N	\N	\N	\N	108121	108121	108122
22929	35144	7	applied	\N	\N	\N	\N	108130	108130	108131
22929	35147	8	applied	\N	\N	\N	\N	108137	108137	108138
22929	35148	9	applied	\N	\N	\N	\N	108139	108139	108140
22929	35149	10	applied	\N	\N	\N	\N	108141	108141	108142
22929	35157	11	applied	\N	\N	\N	\N	108158	108158	108159
22929	35161	12	applied	\N	\N	\N	\N	108168	108168	108169
22929	35165	13	applied	\N	\N	\N	\N	108181	108181	108182
22929	35169	14	applied	\N	\N	\N	\N	108190	108190	108191
22929	35173	15	applied	\N	\N	\N	\N	108213	108213	108214
22929	35177	16	applied	\N	\N	\N	\N	108232	108232	108233
22929	35166	17	applied	\N	\N	\N	\N	106113	106113	108172
22929	35129	18	applied	\N	\N	\N	\N	108093	108093	108094
22929	35117	19	applied	\N	\N	\N	\N	108050	108050	108051
22929	35120	20	applied	\N	\N	\N	\N	108066	108066	108245
22929	35170	21	applied	\N	\N	\N	\N	108192	108192	106140
22929	35119	22	applied	\N	\N	\N	\N	108060	108060	108246
22929	35133	23	applied	\N	\N	\N	\N	108101	108101	108074
22929	35150	24	applied	\N	\N	\N	\N	108143	108143	108075
22929	35158	25	applied	\N	\N	\N	\N	108160	108160	108247
22929	35176	26	applied	\N	\N	\N	\N	108219	108219	108077
22929	35125	27	applied	\N	\N	\N	\N	108083	108083	108248
22929	35134	28	applied	\N	\N	\N	\N	108103	108103	108119
22929	35135	29	applied	\N	\N	\N	\N	108105	108105	108098
22929	35136	30	applied	\N	\N	\N	\N	108107	108107	108102
22929	35142	31	applied	\N	\N	\N	\N	108123	108123	108104
22929	35145	32	applied	\N	\N	\N	\N	108132	108132	108106
22929	35151	33	applied	\N	\N	\N	\N	108145	108145	108108
22929	35118	34	applied	\N	\N	\N	\N	108052	108052	108249
22929	35163	35	applied	\N	\N	\N	\N	106057	106057	108202
22929	35137	36	applied	\N	\N	\N	\N	108109	108109	108110
22929	35138	37	applied	\N	\N	\N	\N	108111	108111	108112
22929	35139	38	applied	\N	\N	\N	\N	108113	108113	108114
22929	35140	39	applied	\N	\N	\N	\N	108115	108115	108116
22929	35155	40	applied	\N	\N	\N	\N	108153	108153	108126
22929	35156	41	applied	\N	\N	\N	\N	108155	108155	108133
22929	35159	42	applied	\N	\N	\N	\N	108162	108162	108144
22929	35164	43	applied	\N	\N	\N	\N	108173	108173	108146
22929	35168	44	applied	\N	\N	\N	\N	108186	108186	108196
22929	35172	45	applied	\N	\N	\N	\N	108206	108206	108152
22929	35175	46	applied	\N	\N	\N	\N	108217	108217	108154
22929	35122	47	applied	\N	\N	\N	\N	108076	108076	108199
22929	35124	48	applied	\N	\N	\N	\N	108081	108081	108161
22929	35130	49	applied	\N	\N	\N	\N	108095	108095	108201
22929	35131	50	applied	\N	\N	\N	\N	108097	108097	108250
22929	35132	51	applied	\N	\N	\N	\N	108099	108099	108251
22929	35143	52	applied	\N	\N	\N	\N	108125	108125	108177
22929	35146	53	applied	\N	\N	\N	\N	108134	108134	108174
22929	35152	54	applied	\N	\N	\N	\N	108147	108147	108185
22929	35153	55	applied	\N	\N	\N	\N	108149	108149	108204
22929	35154	56	applied	\N	\N	\N	\N	108151	108151	108252
22929	35160	57	applied	\N	\N	\N	\N	108164	108164	108253
22929	35162	58	applied	\N	\N	\N	\N	108170	108170	108207
22929	35167	59	applied	\N	\N	\N	\N	108184	108184	108216
22929	35171	60	applied	\N	\N	\N	\N	108200	108200	108224
22929	35174	61	applied	\N	\N	\N	\N	108215	108215	108220
22929	35179	62	applied	\N	\N	\N	\N	108236	108236	108254
22933	35180	0	applied	\N	\N	\N	\N	108256	108256	108257
22933	35181	1	applied	\N	\N	\N	\N	108258	108258	108259
22933	35182	2	applied	\N	\N	\N	\N	108260	108260	108261
22936	35183	0	applied	\N	\N	\N	\N	108273	108273	108274
22936	35184	1	applied	\N	\N	\N	\N	108275	108275	108276
22936	35185	2	applied	\N	\N	\N	\N	108277	108277	108278
22936	35186	3	applied	\N	\N	\N	\N	108279	108279	108280
22939	35187	0	applied	\N	\N	\N	\N	108289	108289	108290
22939	35188	1	applied	\N	\N	\N	\N	108291	108291	108292
22939	35189	2	applied	\N	\N	\N	\N	108293	108293	108294
22942	35193	0	applied	\N	\N	\N	\N	108326	108326	108327
22942	35194	1	applied	\N	\N	\N	\N	108328	108328	108329
22942	35195	2	applied	\N	\N	\N	\N	108330	108330	108331
22942	35196	3	applied	\N	\N	\N	\N	108332	108332	108333
22942	35197	4	applied	\N	\N	\N	\N	108334	108334	108335
22942	35198	5	applied	\N	\N	\N	\N	108336	108336	108337
22942	35199	6	applied	\N	\N	\N	\N	108338	108338	108339
22942	35200	7	applied	\N	\N	\N	\N	108340	108340	108341
22952	35218	0	applied	\N	\N	\N	\N	108390	108390	108391
22952	35219	1	applied	\N	\N	\N	\N	108392	108392	108393
22952	35220	2	applied	\N	\N	\N	\N	108394	108394	108395
22952	35221	3	applied	\N	\N	\N	\N	108396	108396	108397
22952	35222	4	applied	\N	\N	\N	\N	108398	108398	108399
22952	35223	5	applied	\N	\N	\N	\N	108400	108400	107420
22952	35224	6	applied	\N	\N	\N	\N	108401	108401	108402
22952	35225	7	applied	\N	\N	\N	\N	108403	108403	108404
22957	35232	0	applied	\N	\N	\N	\N	108450	108450	108451
22957	35233	1	applied	\N	\N	\N	\N	108452	108452	108453
22957	35234	2	applied	\N	\N	1000000000	\N	108454	108454	108455
22957	35235	3	applied	\N	\N	\N	\N	108456	108456	108457
22957	35236	4	applied	\N	\N	\N	\N	108458	108458	108459
22957	35237	5	applied	\N	\N	\N	\N	108460	108460	108461
22957	35238	6	applied	\N	\N	\N	\N	108462	108462	108463
22957	35239	7	applied	\N	\N	\N	\N	108464	108464	108465
22957	35240	8	applied	\N	\N	\N	\N	108466	108466	108467
22957	35241	9	applied	\N	\N	\N	\N	108468	108468	108469
22957	35242	10	applied	\N	\N	\N	\N	108470	108470	108471
22957	35243	11	applied	\N	\N	\N	\N	108472	108472	108473
22957	35244	12	applied	\N	\N	\N	\N	108474	108474	108475
22957	35245	13	applied	\N	\N	\N	\N	108476	108476	108477
22957	35246	14	applied	\N	\N	\N	\N	108478	108478	108479
22957	35247	15	applied	\N	\N	\N	\N	108480	108480	108481
22957	35248	16	applied	\N	\N	\N	\N	108482	108482	108483
22957	35249	17	applied	\N	\N	\N	\N	108484	108484	108485
22946	35215	0	applied	\N	\N	\N	\N	108375	108375	108376
22946	35216	1	applied	\N	\N	\N	\N	108377	108377	108378
22946	35217	2	applied	\N	\N	\N	\N	108379	108379	108380
22949	35215	0	applied	\N	\N	\N	\N	108375	108375	108376
22949	35216	1	applied	\N	\N	\N	\N	108377	108377	108378
22949	35217	2	applied	\N	\N	\N	\N	108379	108379	108380
22955	35229	0	applied	\N	\N	\N	\N	108434	108434	108435
22955	35230	1	applied	\N	\N	\N	\N	108436	108436	108437
22955	35231	2	applied	\N	\N	\N	\N	108438	108438	108439
22959	35251	0	applied	\N	\N	\N	\N	108489	108489	108490
22959	35252	1	applied	\N	\N	\N	\N	108491	108491	108492
22959	35253	2	applied	\N	\N	\N	\N	108493	108493	108494
22959	35254	3	applied	\N	\N	\N	\N	108495	108495	108496
22963	35255	0	applied	\N	\N	\N	\N	108501	108501	108502
22963	35256	1	applied	\N	\N	\N	\N	108503	108503	108504
22963	35257	2	applied	\N	\N	\N	\N	108505	108505	108506
22968	35262	0	applied	\N	\N	\N	\N	108527	108527	108528
22968	35263	1	applied	\N	\N	\N	\N	108529	108529	108530
22968	35264	2	applied	\N	\N	\N	\N	108531	108531	108532
22968	35265	3	applied	\N	\N	\N	\N	108533	108533	108534
22968	35266	4	applied	\N	\N	\N	\N	108535	108535	108536
22968	35267	5	applied	\N	\N	\N	\N	108537	108537	108538
22974	35270	0	applied	\N	\N	\N	\N	108549	108549	108550
22974	35271	1	applied	\N	\N	\N	\N	108551	108551	108552
22974	35272	2	applied	\N	\N	\N	\N	108553	108553	108554
22976	35274	0	applied	\N	\N	\N	\N	108561	108561	108562
22976	35276	1	applied	\N	\N	\N	\N	108565	108565	108569
22979	35277	0	applied	\N	\N	\N	\N	108571	108571	108572
22979	35278	1	applied	\N	\N	\N	\N	108573	108573	108574
22982	35279	0	applied	\N	\N	\N	\N	108632	108632	108633
22982	35280	1	applied	\N	\N	\N	\N	108634	108634	108635
22982	35281	2	applied	\N	\N	\N	\N	108636	108636	108637
22982	35282	3	applied	\N	\N	\N	\N	108638	108638	108639
22982	35283	4	applied	\N	\N	\N	\N	108640	108640	108641
22982	35284	5	applied	\N	\N	\N	\N	108642	108642	108643
22982	35285	6	applied	\N	\N	\N	\N	108644	108644	108645
22982	35286	7	applied	\N	\N	\N	\N	108646	108646	108647
22985	35287	0	applied	\N	\N	\N	\N	108651	108651	108652
22985	35288	1	applied	\N	\N	\N	\N	108653	108653	108654
22985	35289	2	applied	\N	\N	\N	\N	108655	108655	108656
22985	35294	3	applied	\N	\N	\N	\N	108666	108666	108667
22985	35290	4	applied	\N	\N	\N	\N	108657	108657	108658
22985	35295	5	applied	\N	\N	\N	\N	108668	108668	108674
22985	35291	6	applied	\N	\N	\N	\N	108659	108659	108675
22985	35292	7	applied	\N	\N	\N	\N	108661	108661	108676
22985	35293	8	applied	\N	\N	\N	\N	108663	108663	108669
22985	35296	9	applied	\N	\N	\N	\N	108670	108670	108671
22987	35294	0	applied	\N	\N	\N	\N	108666	108666	108667
22987	35297	1	applied	\N	\N	\N	\N	108679	108679	108680
22987	35298	2	applied	\N	\N	\N	\N	108681	108681	108682
22987	35299	3	applied	\N	\N	\N	\N	108683	108683	108684
22987	35300	4	applied	\N	\N	\N	\N	108685	108685	108686
22987	35301	5	applied	\N	\N	\N	\N	108687	108687	108688
22995	35316	0	applied	\N	\N	\N	\N	108730	108730	108731
22995	35317	1	applied	\N	\N	\N	\N	108732	108732	108733
22995	35318	2	applied	\N	\N	\N	\N	108734	108734	108735
22995	35319	3	applied	\N	\N	\N	\N	108736	108736	108737
22995	35320	4	applied	\N	\N	\N	\N	108738	108738	108739
22995	35321	5	applied	\N	\N	\N	\N	108740	108740	108741
22996	35322	0	applied	\N	\N	\N	\N	108744	108744	108745
22996	35323	1	applied	\N	\N	\N	\N	108746	108746	108747
22996	35324	2	applied	\N	\N	\N	\N	108748	108748	108749
22996	35325	3	applied	\N	\N	\N	\N	108750	108750	108751
22996	35326	4	applied	\N	\N	\N	\N	108752	108752	108753
22996	35327	5	applied	\N	\N	\N	\N	108754	108754	108755
22996	35328	6	applied	\N	\N	\N	\N	108756	108756	108757
22996	35329	7	applied	\N	\N	\N	\N	108758	108758	108759
22996	35330	8	applied	\N	\N	\N	\N	108760	108760	108761
22996	35331	9	applied	\N	\N	\N	\N	108762	108762	108763
22996	35332	10	applied	\N	\N	\N	\N	108764	108764	108765
22996	35333	11	applied	\N	\N	\N	\N	108766	108766	108767
22996	35334	12	applied	\N	\N	\N	\N	108768	108768	108769
22996	35335	13	applied	\N	\N	\N	\N	108770	108770	108771
22998	35336	0	applied	\N	\N	\N	\N	108773	108773	108774
22998	35337	1	applied	\N	\N	\N	\N	108775	108775	108776
22998	35338	2	applied	\N	\N	\N	\N	108777	108777	108778
23002	35339	0	applied	\N	\N	\N	\N	108783	108783	108784
23002	35340	1	applied	\N	\N	\N	\N	108785	108785	108786
23002	35341	2	applied	\N	\N	\N	\N	108787	108787	108788
23005	35349	0	applied	\N	\N	\N	\N	108815	108815	108816
23005	35350	1	applied	\N	\N	\N	\N	108817	108817	108818
23005	35351	2	applied	\N	\N	\N	\N	108819	108819	108820
23007	35349	0	applied	\N	\N	\N	\N	108815	108815	108816
23007	35350	1	applied	\N	\N	\N	\N	108817	108817	108818
23007	35351	2	applied	\N	\N	\N	\N	108819	108819	108820
23008	35349	0	applied	\N	\N	\N	\N	108815	108815	108816
23008	35351	1	applied	\N	\N	\N	\N	108819	108819	108826
23011	35352	0	applied	\N	\N	\N	\N	108828	108828	108829
23011	35353	1	applied	\N	\N	\N	\N	108830	108830	108831
23011	35354	2	applied	\N	\N	\N	\N	108832	108832	108818
23011	35355	3	applied	\N	\N	\N	\N	108833	108833	108820
23011	35356	4	applied	\N	\N	\N	\N	108834	108834	108835
23011	35350	5	applied	\N	\N	\N	\N	108817	108817	108836
23011	35357	6	applied	\N	\N	\N	\N	108837	108837	108838
23011	35358	7	applied	\N	\N	\N	\N	108839	108839	108840
23013	35359	0	applied	\N	\N	\N	\N	108848	108848	108849
23013	35360	1	applied	\N	\N	\N	\N	108850	108850	108851
23013	35361	2	applied	\N	\N	\N	\N	108852	108852	108853
23018	35362	0	applied	\N	\N	\N	\N	108857	108857	108858
23018	35363	1	applied	\N	\N	\N	\N	108859	108859	108860
23018	35364	2	applied	\N	\N	\N	\N	108861	108861	108862
23018	35365	3	applied	\N	\N	\N	\N	108863	108863	108864
23018	35366	4	applied	\N	\N	\N	\N	108865	108865	108866
23018	35367	5	applied	\N	\N	\N	\N	108867	108867	108868
23018	35368	6	applied	\N	\N	\N	\N	108869	108869	108870
23018	35369	7	applied	\N	\N	\N	\N	108871	108871	108872
23018	35370	8	applied	\N	\N	\N	\N	108873	108873	108874
23018	35371	9	applied	\N	\N	\N	\N	108875	108875	108876
23018	35372	10	applied	\N	\N	\N	\N	108877	108877	108878
23018	35373	11	applied	\N	\N	\N	\N	108879	108879	108880
23018	35374	12	applied	\N	\N	\N	\N	108881	108881	108882
23022	35375	0	applied	\N	\N	\N	\N	108888	108888	108889
23022	35376	1	applied	\N	\N	\N	\N	108895	108895	108896
23022	35377	2	applied	\N	\N	\N	\N	108897	108897	108898
23025	35375	0	applied	\N	\N	\N	\N	108888	108888	108889
23025	35376	1	applied	\N	\N	\N	\N	108895	108895	108896
23025	35377	2	applied	\N	\N	\N	\N	108897	108897	108898
23027	35375	0	applied	\N	\N	\N	\N	108888	108888	108889
23031	35378	0	applied	\N	\N	\N	\N	108908	108908	108909
23031	35379	1	applied	\N	\N	\N	\N	108910	108910	108911
22950	34628	10	applied	\N	\N	\N	\N	106714	106714	106715
22950	34631	11	applied	\N	\N	\N	\N	106722	106722	106723
22950	34664	12	applied	\N	\N	\N	\N	106809	106809	106810
22950	34635	13	applied	\N	\N	\N	\N	106732	106732	106733
22950	34638	14	applied	\N	\N	\N	\N	106740	106740	106741
22950	34641	15	applied	\N	\N	\N	\N	106750	106750	106751
22950	34644	16	applied	\N	\N	\N	\N	106757	106757	106758
22950	34645	17	applied	\N	\N	\N	\N	106759	106759	106760
22950	34651	18	applied	\N	\N	\N	\N	106774	106774	106775
22950	34655	19	applied	\N	\N	\N	\N	106786	106786	106787
22950	34658	20	applied	\N	\N	\N	\N	106797	106797	106798
22950	34662	21	applied	\N	\N	\N	\N	106805	106805	106806
22950	34663	22	applied	\N	\N	\N	\N	106807	106807	106808
22950	34668	23	applied	\N	\N	\N	\N	106820	106820	106821
22950	34671	24	applied	\N	\N	\N	\N	106828	106828	106829
22950	34677	25	applied	\N	\N	\N	\N	106844	106844	106845
22950	34678	26	applied	\N	\N	\N	\N	106846	106846	106847
22950	34679	27	applied	\N	\N	\N	\N	106848	106848	106849
22950	34680	28	applied	\N	\N	\N	\N	106850	106850	106851
22950	34686	29	applied	\N	\N	\N	\N	106863	106863	106864
22950	34690	30	applied	\N	\N	\N	\N	106878	106878	106879
22950	34696	31	applied	\N	\N	\N	\N	106894	106894	106895
22950	34697	32	applied	\N	\N	\N	\N	106896	106896	106897
22950	34698	33	applied	\N	\N	\N	\N	106898	106898	106899
22950	34703	34	applied	\N	\N	\N	\N	106911	106911	106912
22950	34705	35	applied	\N	\N	\N	\N	106920	106920	106921
22950	34706	36	applied	\N	\N	\N	\N	106922	106922	106923
22950	34710	37	applied	\N	\N	\N	\N	106932	106932	106933
22950	34711	38	applied	\N	\N	\N	\N	106934	106934	106935
22950	34716	39	applied	\N	\N	\N	\N	106946	106946	106947
22950	34717	40	applied	\N	\N	\N	\N	106948	106948	106949
22950	34720	41	applied	\N	\N	\N	\N	106956	106956	106957
22950	34722	42	applied	\N	\N	\N	\N	106961	106961	106962
22950	34725	43	applied	\N	\N	\N	\N	106970	106970	106971
22950	34727	44	applied	\N	\N	\N	\N	106977	106977	106978
22950	34729	45	applied	\N	\N	\N	\N	106983	106983	106984
22950	34732	46	applied	\N	\N	\N	\N	106991	106991	106992
22950	34734	47	applied	\N	\N	\N	\N	106997	106997	106998
22950	34735	49	applied	\N	\N	\N	\N	106999	106999	107000
22950	34738	50	applied	\N	\N	\N	\N	107007	107007	107008
22950	34740	51	applied	\N	\N	\N	\N	107013	107013	107014
22950	34741	52	applied	\N	\N	\N	\N	107015	107015	107016
22950	34744	53	applied	\N	\N	\N	\N	107022	107022	107023
22950	34747	54	applied	\N	\N	\N	\N	107030	107030	107031
22950	34750	55	applied	\N	\N	\N	\N	107036	107036	107037
22950	34753	56	applied	\N	\N	\N	\N	107042	107042	107043
22950	34754	57	applied	\N	\N	\N	\N	107044	107044	107045
22950	34755	58	applied	\N	\N	\N	\N	107046	107046	107047
22950	34756	59	applied	\N	\N	\N	\N	107048	107048	107049
22950	34767	60	applied	\N	\N	\N	\N	107073	107073	107074
22950	34768	61	applied	\N	\N	\N	\N	107075	107075	107076
22950	34773	62	applied	\N	\N	\N	\N	107087	107087	107088
22950	34777	63	applied	\N	\N	\N	\N	107097	107097	107098
22950	34781	64	applied	\N	\N	\N	\N	107107	107107	107108
22950	34782	65	applied	\N	\N	\N	\N	107109	107109	107110
22950	34787	66	applied	\N	\N	\N	\N	107121	107121	107122
22950	34788	67	applied	\N	\N	\N	\N	107123	107123	107124
22950	34794	68	applied	\N	\N	\N	\N	107140	107140	107141
22950	34797	69	applied	\N	\N	\N	\N	107150	107150	107151
22950	34801	70	applied	\N	\N	\N	\N	107159	107159	107160
22950	34804	71	applied	\N	\N	\N	\N	107183	107183	107184
22950	34805	72	applied	\N	\N	\N	\N	107185	107185	107186
22950	34806	73	applied	\N	\N	\N	\N	107187	107187	107188
22950	34814	74	applied	\N	\N	\N	\N	107207	107207	107208
22950	34817	75	applied	\N	\N	\N	\N	107214	107214	107215
22950	34820	76	applied	\N	\N	\N	\N	107222	107222	107223
22950	34824	77	applied	\N	\N	\N	\N	107232	107232	107233
22950	34825	78	applied	\N	\N	\N	\N	107234	107234	107235
22950	34830	79	applied	\N	\N	\N	\N	107254	107254	107255
22950	34833	80	applied	\N	\N	\N	\N	107263	107263	107264
22950	34836	81	applied	\N	\N	\N	\N	107271	107271	107272
22950	34838	82	applied	\N	\N	\N	\N	107276	107276	107277
22950	34842	83	applied	\N	\N	\N	\N	107287	107287	107288
22950	34846	84	applied	\N	\N	\N	\N	107297	107297	107298
22950	34847	85	applied	\N	\N	\N	\N	107299	107299	107300
22950	34852	86	applied	\N	\N	\N	\N	107311	107311	107312
22950	34853	87	applied	\N	\N	\N	\N	107313	107313	107314
22950	34854	88	applied	\N	\N	\N	\N	107315	107315	107316
22950	34855	89	applied	\N	\N	\N	\N	107317	107317	107318
22950	34856	90	applied	\N	\N	\N	\N	107319	107319	107320
22950	34857	91	applied	\N	\N	\N	\N	107321	107321	107322
22950	34873	92	applied	\N	\N	\N	\N	107357	107357	107358
22950	34876	93	applied	\N	\N	\N	\N	107365	107365	107366
22950	34880	94	applied	\N	\N	\N	\N	107375	107375	107376
22950	34883	95	applied	\N	\N	\N	\N	107382	107382	107383
22950	34886	96	applied	\N	\N	\N	\N	107390	107390	107391
22950	34891	97	applied	\N	\N	\N	\N	107404	107404	107405
22950	34892	98	applied	\N	\N	\N	\N	107406	107406	107407
22950	34897	99	applied	\N	\N	\N	\N	107421	107421	107422
22950	34900	100	applied	\N	\N	\N	\N	107429	107429	107430
22950	34904	101	applied	\N	\N	\N	\N	107438	107438	107439
22950	34907	102	applied	\N	\N	\N	\N	107444	107444	107445
22950	34912	103	applied	\N	\N	\N	\N	107456	107456	107457
22950	34913	104	applied	\N	\N	\N	\N	107458	107458	107459
22950	34919	105	applied	\N	\N	\N	\N	107472	107472	107473
22950	34920	106	applied	\N	\N	\N	\N	107475	107475	107476
22950	34930	107	applied	\N	\N	\N	\N	107497	107497	107498
22950	34933	108	applied	\N	\N	\N	\N	107503	107503	107504
22950	34934	109	applied	\N	\N	\N	\N	107505	107505	107506
22950	34939	110	applied	\N	\N	\N	\N	107525	107525	107526
22950	34943	111	applied	\N	\N	\N	\N	107539	107539	107540
22950	34946	112	applied	\N	\N	\N	\N	107549	107549	107550
22950	34949	113	applied	\N	\N	\N	\N	107559	107559	107560
22950	34953	114	applied	\N	\N	\N	\N	107570	107570	107571
22950	34956	115	applied	\N	\N	\N	\N	107578	107578	107579
22950	34959	116	applied	\N	\N	\N	\N	107586	107586	107587
22950	34962	117	applied	\N	\N	\N	\N	107597	107597	107598
22950	34965	118	applied	\N	\N	\N	\N	107609	107609	107610
22950	34970	119	applied	\N	\N	\N	\N	107623	107623	107624
22950	34971	120	applied	\N	\N	\N	\N	107625	107625	107626
22950	34977	121	applied	\N	\N	\N	\N	107638	107638	107639
22950	34980	122	applied	\N	\N	\N	\N	107645	107645	107646
22950	34984	123	applied	\N	\N	\N	\N	107655	107655	107656
22950	34987	124	applied	\N	\N	\N	\N	107664	107664	107665
22950	34988	125	applied	\N	\N	\N	\N	107666	107666	107667
22951	35218	0	applied	\N	\N	\N	\N	108390	108390	108391
22951	35219	1	applied	\N	\N	\N	\N	108392	108392	108393
22951	35220	2	applied	\N	\N	\N	\N	108394	108394	108395
22951	35221	3	applied	\N	\N	\N	\N	108396	108396	108397
22951	35222	4	applied	\N	\N	\N	\N	108398	108398	108399
22951	35223	5	applied	\N	\N	\N	\N	108400	108400	107420
22951	35224	6	applied	\N	\N	\N	\N	108401	108401	108402
22951	35225	7	applied	\N	\N	\N	\N	108403	108403	108404
22953	35177	0	applied	\N	\N	\N	\N	108232	108232	108233
22953	35180	1	applied	\N	\N	\N	\N	108256	108256	108257
22953	35183	2	applied	\N	\N	\N	\N	108273	108273	108274
22953	35187	3	applied	\N	\N	\N	\N	108289	108289	108290
22953	35190	4	applied	\N	\N	\N	\N	108296	108296	108297
22953	35193	5	applied	\N	\N	\N	\N	108326	108326	108327
22953	35194	6	applied	\N	\N	\N	\N	108328	108328	108329
22953	35201	7	applied	\N	\N	\N	\N	108345	108345	108346
22953	35202	8	applied	\N	\N	\N	\N	108347	108347	108348
22953	35203	9	applied	\N	\N	\N	\N	108349	108349	108350
22953	35215	10	applied	\N	\N	\N	\N	108375	108375	108376
22953	35218	11	applied	\N	\N	\N	\N	108390	108390	108391
22953	35219	12	applied	\N	\N	\N	\N	108392	108392	108393
22953	35226	13	applied	\N	\N	\N	\N	108407	108407	108408
22953	35178	15	applied	\N	\N	\N	\N	108234	108234	108235
22953	35181	16	applied	\N	\N	\N	\N	108258	108258	108320
22953	35184	17	applied	\N	\N	\N	\N	108275	108275	108410
22953	35185	18	applied	\N	\N	\N	\N	108277	108277	108261
22953	35223	19	applied	\N	\N	\N	\N	108400	108400	107420
22953	35179	20	applied	\N	\N	\N	\N	108236	108236	108321
22953	35188	21	applied	\N	\N	\N	\N	108291	108291	108411
22953	35191	22	applied	\N	\N	\N	\N	108298	108298	108322
22953	35195	23	applied	\N	\N	\N	\N	108330	108330	108294
22953	35198	24	applied	\N	\N	\N	\N	108336	108336	108337
22953	35199	25	applied	\N	\N	\N	\N	108338	108338	108299
22953	35200	26	applied	\N	\N	\N	\N	108340	108340	108412
22953	35204	27	applied	\N	\N	\N	\N	108351	108351	108301
22953	35222	28	applied	\N	\N	\N	\N	108398	108398	108413
22953	35208	29	applied	\N	\N	\N	\N	108359	108359	108360
22953	35209	30	applied	\N	\N	\N	\N	108361	108361	108362
22953	35210	31	applied	\N	\N	\N	\N	108363	108363	108414
22953	35211	32	applied	\N	\N	\N	\N	108365	108365	108335
22953	35212	33	applied	\N	\N	\N	\N	108367	108367	108339
22953	35216	34	applied	\N	\N	\N	\N	108377	108377	108415
22953	35213	35	applied	\N	\N	\N	\N	108369	108369	108370
22953	35214	36	applied	\N	\N	\N	\N	108371	108371	108372
22953	35182	37	applied	\N	\N	\N	\N	108260	108260	108416
22953	35186	38	applied	\N	\N	\N	\N	108279	108279	108417
22953	35189	39	applied	\N	\N	\N	\N	108293	108293	108418
22953	35192	40	applied	\N	\N	\N	\N	108300	108300	108364
22953	35196	41	applied	\N	\N	\N	\N	108332	108332	108419
22953	35197	42	applied	\N	\N	\N	\N	108334	108334	108420
22953	35205	43	applied	\N	\N	\N	\N	108353	108353	108368
22953	35206	44	applied	\N	\N	\N	\N	108355	108355	108421
22953	35207	45	applied	\N	\N	\N	\N	108357	108357	108422
22953	35217	46	applied	\N	\N	\N	\N	108379	108379	108423
22953	35220	47	applied	\N	\N	\N	\N	108394	108394	108424
22953	35221	48	applied	\N	\N	\N	\N	108396	108396	108399
22953	35227	49	applied	\N	\N	\N	\N	108425	108425	108426
22953	35224	50	applied	\N	\N	\N	\N	108401	108401	108427
22953	35225	51	applied	\N	\N	\N	\N	108403	108403	108428
22953	35228	52	applied	\N	\N	\N	\N	108429	108429	108430
22956	35193	0	applied	\N	\N	\N	\N	108326	108326	108327
22956	35194	1	applied	\N	\N	\N	\N	108328	108328	108329
22956	35201	2	applied	\N	\N	\N	\N	108345	108345	108346
22956	35202	3	applied	\N	\N	\N	\N	108347	108347	108348
22956	35203	4	applied	\N	\N	\N	\N	108349	108349	108350
22956	35215	5	applied	\N	\N	\N	\N	108375	108375	108376
22956	35218	6	applied	\N	\N	\N	\N	108390	108390	108391
22956	35219	7	applied	\N	\N	\N	\N	108392	108392	108393
22956	35226	8	applied	\N	\N	\N	\N	108407	108407	108408
22956	35229	9	applied	\N	\N	\N	\N	108434	108434	108435
22956	35223	10	applied	\N	\N	\N	\N	108400	108400	107420
22956	35195	11	applied	\N	\N	\N	\N	108330	108330	108331
22956	35196	12	applied	\N	\N	\N	\N	108332	108332	108333
22956	35197	13	applied	\N	\N	\N	\N	108334	108334	108335
22956	35198	14	applied	\N	\N	\N	\N	108336	108336	108337
22956	35199	15	applied	\N	\N	\N	\N	108338	108338	108339
22956	35200	16	applied	\N	\N	\N	\N	108340	108340	108341
22956	35204	17	applied	\N	\N	\N	\N	108351	108351	108352
22956	35222	18	applied	\N	\N	\N	\N	108398	108398	108415
22956	35205	19	applied	\N	\N	\N	\N	108353	108353	108416
22956	35206	20	applied	\N	\N	\N	\N	108355	108355	108417
22956	35207	21	applied	\N	\N	\N	\N	108357	108357	108418
22956	35208	23	applied	\N	\N	\N	\N	108359	108359	108360
22956	35209	24	applied	\N	\N	\N	\N	108361	108361	108362
22956	35210	25	applied	\N	\N	\N	\N	108363	108363	108443
22956	35211	26	applied	\N	\N	\N	\N	108365	108365	108420
22956	35212	27	applied	\N	\N	\N	\N	108367	108367	108444
22956	35216	28	applied	\N	\N	\N	\N	108377	108377	108422
22956	35213	29	applied	\N	\N	\N	\N	108369	108369	108370
22956	35214	30	applied	\N	\N	\N	\N	108371	108371	108372
22956	35217	31	applied	\N	\N	\N	\N	108379	108379	108423
22956	35220	32	applied	\N	\N	\N	\N	108394	108394	108424
22956	35221	33	applied	\N	\N	\N	\N	108396	108396	108399
22956	35227	34	applied	\N	\N	\N	\N	108425	108425	108426
22956	35230	35	applied	\N	\N	\N	\N	108436	108436	108445
22956	35224	36	applied	\N	\N	\N	\N	108401	108401	108446
22956	35225	37	applied	\N	\N	\N	\N	108403	108403	108447
22956	35228	38	applied	\N	\N	\N	\N	108429	108429	108437
22956	35231	39	applied	\N	\N	\N	\N	108438	108438	108439
22961	35255	0	applied	\N	\N	\N	\N	108501	108501	108502
22961	35256	1	applied	\N	\N	\N	\N	108503	108503	108504
22961	35257	2	applied	\N	\N	\N	\N	108505	108505	108506
22965	35256	0	applied	\N	\N	\N	\N	108503	108503	108504
22965	35257	1	applied	\N	\N	\N	\N	108505	108505	108506
22970	35268	0	applied	\N	\N	\N	\N	108540	108540	108541
22970	35269	1	applied	\N	\N	\N	\N	108542	108542	108543
22972	35268	0	applied	\N	\N	\N	\N	108540	108540	108541
22972	35269	1	applied	\N	\N	\N	\N	108542	108542	108543
22977	35277	0	applied	\N	\N	\N	\N	108571	108571	108572
22977	35278	1	applied	\N	\N	\N	\N	108573	108573	108574
22980	34939	0	applied	\N	\N	\N	\N	107525	107525	107526
22980	35043	1	applied	\N	\N	1000000000	\N	107822	107822	107823
22980	35234	2	applied	\N	\N	1000000000	\N	108454	108454	108455
22980	34943	3	applied	\N	\N	\N	\N	107539	107539	107540
22980	34946	4	applied	\N	\N	\N	\N	107549	107549	107550
22980	34949	5	applied	\N	\N	\N	\N	107559	107559	107560
22980	34953	6	applied	\N	\N	\N	\N	107570	107570	107571
22980	35027	7	applied	\N	\N	1000000000	\N	107770	107770	107771
22980	35039	8	applied	\N	\N	\N	\N	107808	107808	107809
22980	34956	9	applied	\N	\N	\N	\N	107578	107578	107579
22980	34959	10	applied	\N	\N	\N	\N	107586	107586	107587
22980	34962	11	applied	\N	\N	\N	\N	107597	107597	107598
22980	34965	12	applied	\N	\N	\N	\N	107609	107609	107610
22980	34970	13	applied	\N	\N	\N	\N	107623	107623	107624
22957	35250	18	applied	\N	\N	\N	\N	108486	108486	108487
22966	35258	0	applied	\N	\N	\N	\N	108515	108515	108516
22966	35259	1	applied	\N	\N	\N	\N	108517	108517	108518
22966	35260	2	applied	\N	\N	\N	\N	108519	108519	108520
22966	35261	3	applied	\N	\N	\N	\N	108521	108521	108522
22973	35270	0	applied	\N	\N	\N	\N	108549	108549	108550
22973	35271	1	applied	\N	\N	\N	\N	108551	108551	108552
22973	35272	2	applied	\N	\N	\N	\N	108553	108553	108554
22973	35273	3	applied	\N	\N	\N	\N	108555	108555	108556
22975	35274	0	applied	\N	\N	\N	\N	108561	108561	108562
22975	35275	1	applied	\N	\N	\N	\N	108563	108563	108564
22975	35276	2	applied	\N	\N	\N	\N	108565	108565	108566
22988	35294	0	applied	\N	\N	\N	\N	108666	108666	108667
22988	35299	1	applied	\N	\N	\N	\N	108683	108683	108684
22988	35300	2	applied	\N	\N	\N	\N	108685	108685	108686
22988	35301	3	applied	\N	\N	\N	\N	108687	108687	108688
22991	35305	0	applied	\N	\N	\N	\N	108702	108702	108703
22991	35306	1	applied	\N	\N	\N	\N	108704	108704	108705
22991	35303	2	applied	\N	\N	\N	\N	108693	108693	108696
22991	35307	3	applied	\N	\N	\N	\N	108706	108706	108707
22991	35308	4	applied	\N	\N	\N	\N	108708	108708	108709
22993	35309	0	applied	\N	\N	\N	\N	108713	108713	108714
22993	35310	1	applied	\N	\N	\N	\N	108715	108715	108716
22993	35311	2	applied	\N	\N	\N	\N	108717	108717	108718
22997	35336	0	applied	\N	\N	\N	\N	108773	108773	108774
22997	35337	1	applied	\N	\N	\N	\N	108775	108775	108776
22997	35338	2	applied	\N	\N	\N	\N	108777	108777	108778
23000	35339	0	applied	\N	\N	\N	\N	108783	108783	108784
23000	35340	1	applied	\N	\N	\N	\N	108785	108785	108786
23000	35341	2	applied	\N	\N	\N	\N	108787	108787	108788
23004	35345	0	applied	\N	\N	\N	\N	108805	108805	108806
23004	35346	1	applied	\N	\N	\N	\N	108807	108807	108808
23004	35347	2	applied	\N	\N	\N	\N	108809	108809	108810
23004	35348	3	applied	\N	\N	\N	\N	108811	108811	108812
23006	35349	0	applied	\N	\N	\N	\N	108815	108815	108816
23006	35350	1	applied	\N	\N	\N	\N	108817	108817	108818
23006	35351	2	applied	\N	\N	\N	\N	108819	108819	108820
23009	35352	0	applied	\N	\N	\N	\N	108828	108828	108829
23009	35353	1	applied	\N	\N	\N	\N	108830	108830	108831
23009	35354	2	applied	\N	\N	\N	\N	108832	108832	108818
23009	35355	3	applied	\N	\N	\N	\N	108833	108833	108820
23009	35356	4	applied	\N	\N	\N	\N	108834	108834	108835
23009	35350	5	applied	\N	\N	\N	\N	108817	108817	108836
23009	35357	6	applied	\N	\N	\N	\N	108837	108837	108838
23009	35358	7	applied	\N	\N	\N	\N	108839	108839	108840
23012	35352	0	applied	\N	\N	\N	\N	108828	108828	108829
23012	35353	1	applied	\N	\N	\N	\N	108830	108830	108831
23012	35354	2	applied	\N	\N	\N	\N	108832	108832	108845
23012	35355	3	applied	\N	\N	\N	\N	108833	108833	108846
23012	35356	4	applied	\N	\N	\N	\N	108834	108834	108836
23012	35357	5	applied	\N	\N	\N	\N	108837	108837	108838
23012	35358	6	applied	\N	\N	\N	\N	108839	108839	108840
23026	35375	0	applied	\N	\N	\N	\N	108888	108888	108889
23026	35376	1	applied	\N	\N	\N	\N	108895	108895	108896
23026	35377	2	applied	\N	\N	\N	\N	108897	108897	108898
23029	35378	0	applied	\N	\N	\N	\N	108908	108908	108909
23029	35379	1	applied	\N	\N	\N	\N	108910	108910	108911
23034	35387	0	applied	\N	\N	\N	\N	108932	108932	108933
23034	35388	1	applied	\N	\N	\N	\N	108934	108934	108935
23034	35389	2	applied	\N	\N	\N	\N	108936	108936	108937
23034	35390	3	applied	\N	\N	\N	\N	108938	108938	108939
23034	35391	4	applied	\N	\N	\N	\N	108940	108940	108941
23034	35392	5	applied	\N	\N	\N	\N	108942	108942	108943
23034	35393	6	applied	\N	\N	\N	\N	108944	108944	108945
23034	35394	7	applied	\N	\N	\N	\N	108946	108946	108947
23034	35395	8	applied	\N	\N	\N	\N	108948	108948	108949
23034	35396	9	applied	\N	\N	\N	\N	108950	108950	108951
23037	35397	0	applied	\N	\N	\N	\N	108956	108956	108957
23037	35398	1	applied	\N	\N	\N	\N	108958	108958	108959
23037	35399	2	applied	\N	\N	\N	\N	108960	108960	108961
23037	35400	3	applied	\N	\N	\N	\N	108962	108962	108963
23037	35401	4	applied	\N	\N	\N	\N	108964	108964	108965
23037	35402	5	applied	\N	\N	\N	\N	108966	108966	108967
23037	35403	6	applied	\N	\N	\N	\N	108968	108968	108969
23037	35404	7	applied	\N	\N	\N	\N	108970	108970	108971
23037	35405	8	applied	\N	\N	\N	\N	108972	108972	108973
23037	35406	9	applied	\N	\N	\N	\N	108974	108974	108975
23042	35417	0	applied	\N	\N	\N	\N	109006	109006	109007
23042	35418	1	applied	\N	\N	\N	\N	109008	109008	109009
23042	35419	2	applied	\N	\N	\N	\N	109010	109010	109011
23044	35420	0	applied	\N	\N	\N	\N	109015	109015	109016
23044	35421	1	applied	\N	\N	\N	\N	109017	109017	109018
23044	35422	2	applied	\N	\N	\N	\N	109019	109019	109020
23044	35423	3	applied	\N	\N	\N	\N	109021	109021	109022
23047	35043	0	applied	\N	\N	1000000000	\N	107822	107822	107823
23047	35234	1	applied	\N	\N	1000000000	\N	108454	108454	108455
23047	35166	2	applied	\N	\N	\N	\N	106113	106113	108172
23047	35058	3	applied	\N	\N	1000000000	\N	107863	107863	107864
23047	35129	4	applied	\N	\N	\N	\N	108093	108093	108094
23047	35067	5	applied	\N	\N	1000000000	\N	107888	107888	107889
23047	35170	6	applied	\N	\N	\N	\N	108192	108192	106140
23047	35049	7	applied	\N	\N	\N	\N	107839	107839	107420
23047	35223	8	applied	\N	\N	\N	\N	108400	108400	107420
23047	35198	9	applied	\N	\N	\N	\N	108336	108336	108337
23047	35238	10	applied	\N	\N	\N	\N	108462	108462	108463
23047	35290	11	applied	\N	\N	\N	\N	108657	108657	108658
23047	35208	12	applied	\N	\N	\N	\N	108359	108359	108360
23047	35209	13	applied	\N	\N	\N	\N	108361	108361	108362
23047	35300	14	applied	\N	\N	\N	\N	108685	108685	108686
23047	35213	15	applied	\N	\N	\N	\N	108369	108369	108370
23047	35214	16	applied	\N	\N	\N	\N	108371	108371	108372
23047	35163	17	applied	\N	\N	\N	\N	106057	106057	108202
23047	35054	18	applied	\N	\N	1000000000	\N	107852	107852	107853
23047	35137	19	applied	\N	\N	\N	\N	108109	108109	108110
23047	35138	20	applied	\N	\N	\N	\N	108111	108111	108112
23047	35139	21	applied	\N	\N	\N	\N	108113	108113	108114
23047	35140	22	applied	\N	\N	\N	\N	108115	108115	108116
23049	35427	0	applied	\N	\N	\N	\N	109033	109033	109034
23049	35428	1	applied	\N	\N	\N	\N	109035	109035	109036
23049	35429	2	applied	\N	\N	\N	\N	109037	109037	109038
23049	35430	3	applied	\N	\N	\N	\N	109039	109039	109040
23049	35431	4	applied	\N	\N	\N	\N	109041	109041	109042
23049	35432	5	applied	\N	\N	\N	\N	109043	109043	109044
23049	35433	6	applied	\N	\N	\N	\N	109045	109045	109046
23051	35434	0	applied	\N	\N	\N	\N	109050	109050	109051
23051	35435	1	applied	\N	\N	\N	\N	109052	109052	109053
23051	35436	2	applied	\N	\N	\N	\N	109054	109054	109055
23059	35452	0	applied	\N	\N	\N	\N	109097	109097	109098
23059	35453	1	applied	\N	\N	\N	\N	109099	109099	109100
22967	35258	0	applied	\N	\N	\N	\N	108515	108515	108516
22967	35259	1	applied	\N	\N	\N	\N	108517	108517	108518
22967	35261	2	applied	\N	\N	\N	\N	108521	108521	108525
22969	35268	0	applied	\N	\N	\N	\N	108540	108540	108541
22969	35269	1	applied	\N	\N	\N	\N	108542	108542	108543
22971	35268	0	applied	\N	\N	\N	\N	108540	108540	108541
22971	35269	1	applied	\N	\N	\N	\N	108542	108542	108543
22978	35277	0	applied	\N	\N	\N	\N	108571	108571	108572
22978	35278	1	applied	\N	\N	\N	\N	108573	108573	108574
22981	35279	0	applied	\N	\N	\N	\N	108632	108632	108633
22981	35280	1	applied	\N	\N	\N	\N	108634	108634	108635
22981	35281	2	applied	\N	\N	\N	\N	108636	108636	108637
22981	35282	3	applied	\N	\N	\N	\N	108638	108638	108639
22981	35283	4	applied	\N	\N	\N	\N	108640	108640	108641
22981	35284	5	applied	\N	\N	\N	\N	108642	108642	108643
22981	35285	6	applied	\N	\N	\N	\N	108644	108644	108645
22981	35286	7	applied	\N	\N	\N	\N	108646	108646	108647
22984	35294	0	applied	\N	\N	\N	\N	108666	108666	108667
22984	35295	1	applied	\N	\N	\N	\N	108668	108668	108669
22984	35296	2	applied	\N	\N	\N	\N	108670	108670	108671
22986	35295	0	applied	\N	\N	\N	\N	108668	108668	108669
22986	35296	1	applied	\N	\N	\N	\N	108670	108670	108671
22989	35297	0	applied	\N	\N	\N	\N	108679	108679	108680
22989	35298	1	applied	\N	\N	\N	\N	108681	108681	108682
22989	35302	2	applied	\N	\N	\N	\N	108691	108691	108692
22989	35303	3	applied	\N	\N	\N	\N	108693	108693	108694
22989	35304	4	applied	\N	\N	\N	\N	108695	108695	108696
22992	35305	0	applied	\N	\N	\N	\N	108702	108702	108703
22992	35306	1	applied	\N	\N	\N	\N	108704	108704	108705
22992	35303	2	applied	\N	\N	\N	\N	108693	108693	108696
22992	35307	3	applied	\N	\N	\N	\N	108706	108706	108707
22992	35308	4	applied	\N	\N	\N	\N	108708	108708	108709
22994	35312	0	applied	\N	\N	\N	\N	108721	108721	108722
22994	35313	1	applied	\N	\N	\N	\N	108723	108723	108724
22994	35314	2	applied	\N	\N	\N	\N	108725	108725	108726
22994	35315	3	applied	\N	\N	\N	\N	108727	108727	108728
23001	35339	0	applied	\N	\N	\N	\N	108783	108783	108784
23001	35340	1	applied	\N	\N	\N	\N	108785	108785	108786
23001	35341	2	applied	\N	\N	\N	\N	108787	108787	108788
23010	35352	0	applied	\N	\N	\N	\N	108828	108828	108829
23010	35353	1	applied	\N	\N	\N	\N	108830	108830	108831
23010	35354	2	applied	\N	\N	\N	\N	108832	108832	108818
23010	35355	3	applied	\N	\N	\N	\N	108833	108833	108820
23010	35356	4	applied	\N	\N	\N	\N	108834	108834	108835
23010	35350	5	applied	\N	\N	\N	\N	108817	108817	108836
23010	35357	6	applied	\N	\N	\N	\N	108837	108837	108838
23010	35358	7	applied	\N	\N	\N	\N	108839	108839	108840
23015	35359	0	applied	\N	\N	\N	\N	108848	108848	108849
23017	35362	0	applied	\N	\N	\N	\N	108857	108857	108858
23017	35363	1	applied	\N	\N	\N	\N	108859	108859	108860
23017	35364	2	applied	\N	\N	\N	\N	108861	108861	108862
23017	35365	3	applied	\N	\N	\N	\N	108863	108863	108864
23017	35366	4	applied	\N	\N	\N	\N	108865	108865	108866
23017	35367	5	applied	\N	\N	\N	\N	108867	108867	108868
23017	35368	6	applied	\N	\N	\N	\N	108869	108869	108870
23017	35369	7	applied	\N	\N	\N	\N	108871	108871	108872
23017	35370	8	applied	\N	\N	\N	\N	108873	108873	108874
23017	35371	9	applied	\N	\N	\N	\N	108875	108875	108876
23017	35372	10	applied	\N	\N	\N	\N	108877	108877	108878
23017	35373	11	applied	\N	\N	\N	\N	108879	108879	108880
23017	35374	12	applied	\N	\N	\N	\N	108881	108881	108882
23019	35362	0	applied	\N	\N	\N	\N	108857	108857	108858
23019	35363	1	applied	\N	\N	\N	\N	108859	108859	108860
23019	35364	2	applied	\N	\N	\N	\N	108861	108861	108862
23019	35365	3	applied	\N	\N	\N	\N	108863	108863	108864
23019	35366	4	applied	\N	\N	\N	\N	108865	108865	108866
23019	35367	5	applied	\N	\N	\N	\N	108867	108867	108868
23019	35368	6	applied	\N	\N	\N	\N	108869	108869	108870
23019	35369	7	applied	\N	\N	\N	\N	108871	108871	108872
23019	35370	8	applied	\N	\N	\N	\N	108873	108873	108874
23019	35371	9	applied	\N	\N	\N	\N	108875	108875	108876
23019	35372	10	applied	\N	\N	\N	\N	108877	108877	108878
23019	35373	11	applied	\N	\N	\N	\N	108879	108879	108880
23019	35374	12	applied	\N	\N	\N	\N	108881	108881	108882
23024	35375	0	applied	\N	\N	\N	\N	108888	108888	108889
23024	35376	1	applied	\N	\N	\N	\N	108895	108895	108896
23024	35377	2	applied	\N	\N	\N	\N	108897	108897	108898
23030	35378	0	applied	\N	\N	\N	\N	108908	108908	108909
23030	35379	1	applied	\N	\N	\N	\N	108910	108910	108911
23030	35380	2	applied	\N	\N	\N	\N	108914	108914	108915
23035	35387	0	applied	\N	\N	\N	\N	108932	108932	108933
23035	35388	1	applied	\N	\N	\N	\N	108934	108934	108935
23035	35389	2	applied	\N	\N	\N	\N	108936	108936	108937
23035	35390	3	applied	\N	\N	\N	\N	108938	108938	108939
23035	35391	4	applied	\N	\N	\N	\N	108940	108940	108941
23035	35392	5	applied	\N	\N	\N	\N	108942	108942	108943
23035	35393	6	applied	\N	\N	\N	\N	108944	108944	108945
23035	35394	7	applied	\N	\N	\N	\N	108946	108946	108947
23035	35395	8	applied	\N	\N	\N	\N	108948	108948	108949
23035	35396	9	applied	\N	\N	\N	\N	108950	108950	108951
23038	35407	0	applied	\N	\N	\N	\N	108980	108980	108981
23038	35408	1	applied	\N	\N	\N	\N	108982	108982	108983
23038	35409	2	applied	\N	\N	\N	\N	108984	108984	108985
23038	35410	3	applied	\N	\N	\N	\N	108986	108986	108987
23038	35411	4	applied	\N	\N	\N	\N	108988	108988	108989
23038	35412	5	applied	\N	\N	\N	\N	108990	108990	108991
23038	35413	6	applied	\N	\N	\N	\N	108992	108992	108993
23040	35414	0	applied	\N	\N	\N	\N	108997	108997	108998
23040	35415	1	applied	\N	\N	\N	\N	108999	108999	109000
23040	35416	2	applied	\N	\N	\N	\N	109001	109001	109002
23043	35417	0	applied	\N	\N	\N	\N	109006	109006	109007
23043	35418	1	applied	\N	\N	\N	\N	109008	109008	109009
23043	35419	2	applied	\N	\N	\N	\N	109010	109010	109011
23052	35437	0	applied	\N	\N	\N	\N	109058	109058	109059
23052	35438	1	applied	\N	\N	\N	\N	109060	109060	109061
23060	35452	0	applied	\N	\N	\N	\N	109097	109097	109098
23060	35453	1	applied	\N	\N	\N	\N	109099	109099	109100
23060	35454	2	applied	\N	\N	\N	\N	109101	109101	109102
23060	35455	4	applied	\N	\N	\N	\N	109103	109103	109104
23064	35462	0	applied	\N	\N	\N	\N	109128	109128	109129
23064	35463	1	applied	\N	\N	\N	\N	109130	109130	109131
23064	35464	2	applied	\N	\N	\N	\N	109132	109132	109133
23064	35465	3	applied	\N	\N	\N	\N	109134	109134	109135
23071	35472	0	applied	\N	\N	\N	\N	109156	109156	109157
23071	35473	1	applied	\N	\N	\N	\N	109158	109158	109159
23071	35474	2	applied	\N	\N	\N	\N	109160	109160	109161
23075	35479	0	applied	\N	\N	\N	\N	109174	109174	109175
23075	35480	1	applied	\N	\N	\N	\N	109176	109176	109177
23075	35481	2	applied	\N	\N	\N	\N	109178	109178	109179
23078	35484	0	applied	\N	\N	\N	\N	109188	109188	109189
22980	34971	14	applied	\N	\N	\N	\N	107625	107625	107626
22980	34977	15	applied	\N	\N	\N	\N	107638	107638	107639
22980	34980	16	applied	\N	\N	\N	\N	107645	107645	107646
22980	34984	17	applied	\N	\N	\N	\N	107655	107655	107656
22980	34987	18	applied	\N	\N	\N	\N	107664	107664	107665
22980	34988	19	applied	\N	\N	\N	\N	107666	107666	107667
22980	34989	20	applied	\N	\N	\N	\N	107668	107668	107669
22980	34997	21	applied	\N	\N	\N	\N	107689	107689	107690
22980	35000	22	applied	\N	\N	\N	\N	107697	107697	107698
22980	35004	23	applied	\N	\N	\N	\N	107707	107707	107708
22980	35008	24	applied	\N	\N	\N	\N	107716	107716	107717
22980	35011	25	applied	\N	\N	\N	\N	107730	107730	107731
22980	35014	26	applied	\N	\N	\N	\N	107739	107739	107740
22980	35015	27	applied	\N	\N	\N	\N	107741	107741	107742
22980	35021	28	applied	\N	\N	\N	\N	107755	107755	107756
22980	35024	29	applied	\N	\N	\N	\N	107762	107762	107763
22980	35028	30	applied	\N	\N	\N	\N	107772	107772	107773
22980	35032	31	applied	\N	\N	\N	\N	107784	107784	107785
22980	35035	32	applied	\N	\N	\N	\N	107792	107792	107793
22980	35038	33	applied	\N	\N	\N	\N	107806	107806	107807
22980	35044	34	applied	\N	\N	\N	\N	107824	107824	107825
22980	35047	35	applied	\N	\N	\N	\N	107835	107835	107836
22980	35051	36	applied	\N	\N	\N	\N	107846	107846	107847
22980	35056	37	applied	\N	\N	\N	\N	107859	107859	107860
22980	35060	38	applied	\N	\N	\N	\N	107871	107871	107872
22980	35063	39	applied	\N	\N	\N	\N	107878	107878	107879
22980	35066	40	applied	\N	\N	\N	\N	107886	107886	107887
22980	35071	41	applied	\N	\N	\N	\N	107897	107897	107898
22980	35072	42	applied	\N	\N	\N	\N	107899	107899	107900
22980	35077	43	applied	\N	\N	\N	\N	107912	107912	107913
22980	35081	44	applied	\N	\N	\N	\N	107928	107928	107929
22980	35083	45	applied	\N	\N	\N	\N	107934	107934	107987
22980	35086	46	applied	\N	\N	\N	\N	107941	107941	107988
22980	35090	47	applied	\N	\N	\N	\N	107951	107951	107989
22980	35091	48	applied	\N	\N	\N	\N	107953	107953	107990
22980	35096	49	applied	\N	\N	\N	\N	107969	107969	107991
22980	35099	50	applied	\N	\N	\N	\N	107975	107975	107992
22980	35103	51	applied	\N	\N	\N	\N	108009	108009	108580
22980	35106	52	applied	\N	\N	\N	\N	108019	108019	108581
22980	35109	53	applied	\N	\N	\N	\N	108029	108029	108582
22980	35113	54	applied	\N	\N	\N	\N	108039	108039	108583
22980	35116	55	applied	\N	\N	\N	\N	108048	108048	108584
22980	35121	56	applied	\N	\N	\N	\N	108072	108072	108585
22980	35123	57	applied	\N	\N	\N	\N	108079	108079	108586
22980	35126	58	applied	\N	\N	\N	\N	108087	108087	108587
22980	35127	59	applied	\N	\N	\N	\N	108089	108089	108588
22980	35128	60	applied	\N	\N	\N	\N	108091	108091	108589
22980	35141	61	applied	\N	\N	\N	\N	108121	108121	108590
22980	35144	62	applied	\N	\N	\N	\N	108130	108130	108591
22980	35147	63	applied	\N	\N	\N	\N	108137	108137	108592
22980	35148	64	applied	\N	\N	\N	\N	108139	108139	108593
22980	35149	65	applied	\N	\N	\N	\N	108141	108141	108594
22980	35157	66	applied	\N	\N	\N	\N	108158	108158	108595
22980	35161	67	applied	\N	\N	\N	\N	108168	108168	108596
22980	35165	68	applied	\N	\N	\N	\N	108181	108181	108597
22980	35169	69	applied	\N	\N	\N	\N	108190	108190	108598
22980	35173	70	applied	\N	\N	\N	\N	108213	108213	108599
22980	35177	71	applied	\N	\N	\N	\N	108232	108232	108600
22980	35180	72	applied	\N	\N	\N	\N	108256	108256	108601
22980	35183	73	applied	\N	\N	\N	\N	108273	108273	108602
22980	35187	74	applied	\N	\N	\N	\N	108289	108289	108603
22980	35190	75	applied	\N	\N	\N	\N	108296	108296	108604
22980	35193	76	applied	\N	\N	\N	\N	108326	108326	108605
22980	35194	77	applied	\N	\N	\N	\N	108328	108328	108606
22980	35201	78	applied	\N	\N	\N	\N	108345	108345	108607
22980	35202	79	applied	\N	\N	\N	\N	108347	108347	108608
22980	35203	80	applied	\N	\N	\N	\N	108349	108349	108609
22980	35215	81	applied	\N	\N	\N	\N	108375	108375	108610
22980	35218	82	applied	\N	\N	\N	\N	108390	108390	108611
22980	35219	83	applied	\N	\N	\N	\N	108392	108392	108612
22980	35226	84	applied	\N	\N	\N	\N	108407	108407	108613
22980	35229	85	applied	\N	\N	\N	\N	108434	108434	108614
22980	35232	86	applied	\N	\N	\N	\N	108450	108450	108615
22980	35233	87	applied	\N	\N	\N	\N	108452	108452	108616
22980	35235	88	applied	\N	\N	\N	\N	108456	108456	108617
22980	35236	89	applied	\N	\N	\N	\N	108458	108458	108618
22980	35237	90	applied	\N	\N	\N	\N	108460	108460	108619
22980	35251	91	applied	\N	\N	\N	\N	108489	108489	108620
22980	35255	92	applied	\N	\N	\N	\N	108501	108501	108621
22980	35258	93	applied	\N	\N	\N	\N	108515	108515	108622
22980	35262	94	applied	\N	\N	\N	\N	108527	108527	108623
22980	35263	95	applied	\N	\N	\N	\N	108529	108529	108624
22980	35268	96	applied	\N	\N	\N	\N	108540	108540	108625
22980	35270	97	applied	\N	\N	\N	\N	108549	108549	108626
22980	35274	98	applied	\N	\N	\N	\N	108561	108561	108627
22980	35277	99	applied	\N	\N	\N	\N	108571	108571	108628
22980	35166	100	applied	\N	\N	\N	\N	106113	106113	108172
22980	35058	101	applied	\N	\N	1000000000	\N	107863	107863	107864
22980	35129	103	applied	\N	\N	\N	\N	108093	108093	108094
22980	35067	104	applied	\N	\N	1000000000	\N	107888	107888	107889
22980	35170	105	applied	\N	\N	\N	\N	108192	108192	106140
22980	35001	106	applied	\N	\N	\N	\N	107699	107699	107420
22980	35049	107	applied	\N	\N	\N	\N	107839	107839	107420
22980	35223	108	applied	\N	\N	\N	\N	108400	108400	107420
22980	35198	109	applied	\N	\N	\N	\N	108336	108336	108337
22980	35238	110	applied	\N	\N	\N	\N	108462	108462	108463
22980	35208	111	applied	\N	\N	\N	\N	108359	108359	108360
22980	35209	112	applied	\N	\N	\N	\N	108361	108361	108362
22980	35213	113	applied	\N	\N	\N	\N	108369	108369	108370
22980	35214	114	applied	\N	\N	\N	\N	108371	108371	108372
22980	35163	115	applied	\N	\N	\N	\N	106057	106057	108202
22980	35054	116	applied	\N	\N	1000000000	\N	107852	107852	107853
22980	35137	117	applied	\N	\N	\N	\N	108239	108239	108110
22980	35138	118	applied	\N	\N	\N	\N	108240	108240	108112
22980	35139	119	applied	\N	\N	\N	\N	108241	108241	108114
22980	35140	120	applied	\N	\N	\N	\N	108242	108242	108116
22983	35287	0	applied	\N	\N	\N	\N	108651	108651	108652
22983	35288	1	applied	\N	\N	\N	\N	108653	108653	108654
22983	35289	2	applied	\N	\N	\N	\N	108655	108655	108656
22983	35290	3	applied	\N	\N	\N	\N	108657	108657	108658
22983	35291	4	applied	\N	\N	\N	\N	108659	108659	108660
22983	35292	5	applied	\N	\N	\N	\N	108661	108661	108662
22983	35293	6	applied	\N	\N	\N	\N	108663	108663	108664
22990	35297	0	applied	\N	\N	\N	\N	108679	108679	108680
22990	35298	1	applied	\N	\N	\N	\N	108681	108681	108682
22990	35302	2	applied	\N	\N	\N	\N	108691	108691	108692
22990	35304	3	applied	\N	\N	\N	\N	108695	108695	108699
22999	35339	0	applied	\N	\N	\N	\N	108783	108783	108784
22999	35340	1	applied	\N	\N	\N	\N	108785	108785	108786
22999	35341	2	applied	\N	\N	\N	\N	108787	108787	108788
23003	35342	0	applied	\N	\N	\N	\N	108797	108797	108798
23003	35343	1	applied	\N	\N	\N	\N	108799	108799	108800
23003	35344	2	applied	\N	\N	\N	\N	108801	108801	108802
23014	35359	0	applied	\N	\N	\N	\N	108848	108848	108849
23014	35360	1	applied	\N	\N	\N	\N	108850	108850	108851
23014	35361	2	applied	\N	\N	\N	\N	108852	108852	108853
23020	35234	0	applied	\N	\N	1000000000	\N	108454	108454	108455
23020	35229	1	applied	\N	\N	\N	\N	108434	108434	108435
23020	35232	2	applied	\N	\N	\N	\N	108450	108450	108451
23020	35233	3	applied	\N	\N	\N	\N	108452	108452	108453
23020	35235	4	applied	\N	\N	\N	\N	108456	108456	108457
23020	35236	5	applied	\N	\N	\N	\N	108458	108458	108459
23020	35237	6	applied	\N	\N	\N	\N	108460	108460	108461
23020	35251	7	applied	\N	\N	\N	\N	108489	108489	108490
23020	35255	8	applied	\N	\N	\N	\N	108501	108501	108502
23020	35258	9	applied	\N	\N	\N	\N	108515	108515	108516
23020	35262	10	applied	\N	\N	\N	\N	108527	108527	108528
23020	35263	11	applied	\N	\N	\N	\N	108529	108529	108530
23020	35268	12	applied	\N	\N	\N	\N	108540	108540	108541
23020	35270	13	applied	\N	\N	\N	\N	108549	108549	108550
23020	35274	14	applied	\N	\N	\N	\N	108561	108561	108562
23020	35277	15	applied	\N	\N	\N	\N	108571	108571	108572
23020	35279	16	applied	\N	\N	\N	\N	108632	108632	108633
23020	35280	17	applied	\N	\N	\N	\N	108634	108634	108635
23020	35281	18	applied	\N	\N	\N	\N	108636	108636	108637
23020	35287	19	applied	\N	\N	\N	\N	108651	108651	108652
23020	35288	20	applied	\N	\N	\N	\N	108653	108653	108654
23020	35289	21	applied	\N	\N	\N	\N	108655	108655	108656
23020	35294	22	applied	\N	\N	\N	\N	108666	108666	108667
23020	35297	23	applied	\N	\N	\N	\N	108679	108679	108680
23020	35298	24	applied	\N	\N	\N	\N	108681	108681	108682
23020	35302	25	applied	\N	\N	\N	\N	108691	108691	108692
23020	35305	26	applied	\N	\N	\N	\N	108702	108702	108703
23020	35306	27	applied	\N	\N	\N	\N	108704	108704	108705
23020	35309	28	applied	\N	\N	\N	\N	108713	108713	108714
23020	35312	29	applied	\N	\N	\N	\N	108721	108721	108722
23020	35316	30	applied	\N	\N	\N	\N	108730	108730	108731
23020	35317	31	applied	\N	\N	\N	\N	108732	108732	108733
23020	35322	32	applied	\N	\N	\N	\N	108744	108744	108745
23020	35323	33	applied	\N	\N	\N	\N	108746	108746	108747
23020	35324	34	applied	\N	\N	\N	\N	108748	108748	108749
23020	35325	35	applied	\N	\N	\N	\N	108750	108750	108751
23020	35336	36	applied	\N	\N	\N	\N	108773	108773	108774
23020	35339	37	applied	\N	\N	\N	\N	108783	108783	108784
23020	35342	38	applied	\N	\N	\N	\N	108797	108797	108798
23020	35345	39	applied	\N	\N	\N	\N	108805	108805	108806
23020	35349	40	applied	\N	\N	\N	\N	108815	108815	108816
23020	35352	41	applied	\N	\N	\N	\N	108828	108828	108829
23020	35353	42	applied	\N	\N	\N	\N	108830	108830	108831
23020	35359	43	applied	\N	\N	\N	\N	108848	108848	108849
23020	35362	44	applied	\N	\N	\N	\N	108857	108857	108858
23020	35363	45	applied	\N	\N	\N	\N	108859	108859	108860
23020	35364	46	applied	\N	\N	\N	\N	108861	108861	108862
23020	35365	47	applied	\N	\N	\N	\N	108863	108863	108864
23020	35375	48	applied	\N	\N	\N	\N	108888	108888	108889
23020	35230	49	applied	\N	\N	\N	\N	108436	108436	108437
23020	35238	50	applied	\N	\N	\N	\N	108462	108462	108463
23020	35290	51	applied	\N	\N	\N	\N	108657	108657	108658
23020	35239	52	applied	\N	\N	\N	\N	108464	108464	108890
23020	35240	53	applied	\N	\N	\N	\N	108466	108466	108891
23020	35261	54	applied	\N	\N	\N	\N	108521	108521	108439
23020	35272	55	applied	\N	\N	\N	\N	108553	108553	108465
23020	35284	56	applied	\N	\N	\N	\N	108642	108642	108467
23020	35295	57	applied	\N	\N	\N	\N	108668	108668	108892
23032	35378	0	applied	\N	\N	\N	\N	108908	108908	108909
23032	35379	1	applied	\N	\N	\N	\N	108910	108910	108911
23032	35380	2	applied	\N	\N	\N	\N	108914	108914	108915
23033	35381	0	applied	\N	\N	\N	\N	108918	108918	108919
23033	35382	1	applied	\N	\N	\N	\N	108920	108920	108921
23033	35383	2	applied	\N	\N	\N	\N	108922	108922	108923
23033	35380	3	applied	\N	\N	\N	\N	108914	108914	108924
23033	35384	4	applied	\N	\N	\N	\N	108925	108925	108926
23033	35385	5	applied	\N	\N	\N	\N	108927	108927	108928
23033	35386	6	applied	\N	\N	\N	\N	108929	108929	108930
23041	35414	0	applied	\N	\N	\N	\N	108997	108997	108998
23041	35415	1	applied	\N	\N	\N	\N	108999	108999	109000
23041	35416	2	applied	\N	\N	\N	\N	109001	109001	109002
23046	35424	0	applied	\N	\N	\N	\N	109025	109025	109026
23046	35425	1	applied	\N	\N	\N	\N	109027	109027	109028
23046	35426	2	applied	\N	\N	\N	\N	109029	109029	109030
23054	35439	0	applied	\N	\N	\N	\N	109064	109064	109065
23054	35440	1	applied	\N	\N	\N	\N	109066	109066	109067
23054	35441	2	applied	\N	\N	\N	\N	109068	109068	109069
23054	35442	3	applied	\N	\N	\N	\N	109070	109070	109071
23054	35443	4	applied	\N	\N	\N	\N	109072	109072	109073
23054	35444	5	applied	\N	\N	\N	\N	109074	109074	109075
23054	35445	6	applied	\N	\N	\N	\N	109076	109076	109077
23056	35449	0	applied	\N	\N	\N	\N	109088	109088	109089
23056	35450	1	applied	\N	\N	\N	\N	109090	109090	109091
23056	35451	2	applied	\N	\N	\N	\N	109092	109092	109093
23058	35452	0	applied	\N	\N	\N	\N	109097	109097	109098
23058	35453	1	applied	\N	\N	\N	\N	109099	109099	109100
23058	35454	2	applied	\N	\N	\N	\N	109101	109101	109102
23058	35455	4	applied	\N	\N	\N	\N	109103	109103	109104
23066	35462	0	applied	\N	\N	\N	\N	109128	109128	109129
23066	35463	1	applied	\N	\N	\N	\N	109130	109130	109131
23066	35464	2	applied	\N	\N	\N	\N	109132	109132	109133
23066	35465	3	applied	\N	\N	\N	\N	109134	109134	109135
23072	35475	0	applied	\N	\N	\N	\N	109163	109163	109164
23072	35476	1	applied	\N	\N	\N	\N	109165	109165	109166
23072	35477	2	applied	\N	\N	\N	\N	109167	109167	109168
23072	35478	3	applied	\N	\N	\N	\N	109169	109169	109170
23074	35479	0	applied	\N	\N	\N	\N	109174	109174	109175
23074	35480	1	applied	\N	\N	\N	\N	109176	109176	109177
23074	35481	2	applied	\N	\N	\N	\N	109178	109178	109179
23081	35492	0	applied	\N	\N	\N	\N	109212	109212	109213
23081	35493	1	applied	\N	\N	\N	\N	109214	109214	109215
23081	35494	2	applied	\N	\N	\N	\N	109216	109216	109217
23090	35515	0	applied	\N	\N	\N	\N	109266	109266	109267
23090	35516	1	applied	\N	\N	\N	\N	109268	109268	109269
23090	35517	2	applied	\N	\N	\N	\N	109270	109270	109271
23090	35518	3	applied	\N	\N	\N	\N	109272	109272	109273
23090	35528	4	applied	\N	\N	\N	\N	109314	109314	109315
23090	35523	5	applied	\N	\N	\N	\N	109295	109295	109298
23090	35529	6	applied	\N	\N	\N	\N	109316	109316	109317
23090	35524	7	applied	\N	\N	\N	\N	109305	109305	109318
23090	35525	8	applied	\N	\N	\N	\N	109307	109307	109319
23090	35526	9	applied	\N	\N	\N	\N	109309	109309	109320
23090	35519	10	applied	\N	\N	\N	\N	109284	109284	109303
23031	35380	2	applied	\N	\N	\N	\N	108914	108914	108915
23036	35397	0	applied	\N	\N	\N	\N	108956	108956	108957
23036	35398	1	applied	\N	\N	\N	\N	108958	108958	108959
23036	35399	2	applied	\N	\N	\N	\N	108960	108960	108961
23036	35400	3	applied	\N	\N	\N	\N	108962	108962	108963
23036	35401	4	applied	\N	\N	\N	\N	108964	108964	108965
23036	35402	5	applied	\N	\N	\N	\N	108966	108966	108967
23036	35403	6	applied	\N	\N	\N	\N	108968	108968	108969
23036	35404	7	applied	\N	\N	\N	\N	108970	108970	108971
23036	35405	8	applied	\N	\N	\N	\N	108972	108972	108973
23036	35406	9	applied	\N	\N	\N	\N	108974	108974	108975
23039	35407	0	applied	\N	\N	\N	\N	108980	108980	108981
23039	35408	1	applied	\N	\N	\N	\N	108982	108982	108983
23039	35409	2	applied	\N	\N	\N	\N	108984	108984	108985
23039	35410	3	applied	\N	\N	\N	\N	108986	108986	108987
23039	35411	4	applied	\N	\N	\N	\N	108988	108988	108989
23039	35412	5	applied	\N	\N	\N	\N	108990	108990	108991
23039	35413	6	applied	\N	\N	\N	\N	108992	108992	108993
23045	35420	0	applied	\N	\N	\N	\N	109015	109015	109016
23045	35421	1	applied	\N	\N	\N	\N	109017	109017	109018
23045	35422	2	applied	\N	\N	\N	\N	109019	109019	109020
23045	35423	3	applied	\N	\N	\N	\N	109021	109021	109022
23048	35427	0	applied	\N	\N	\N	\N	109033	109033	109034
23048	35428	1	applied	\N	\N	\N	\N	109035	109035	109036
23048	35429	2	applied	\N	\N	\N	\N	109037	109037	109038
23048	35430	3	applied	\N	\N	\N	\N	109039	109039	109040
23048	35431	4	applied	\N	\N	\N	\N	109041	109041	109042
23048	35432	5	applied	\N	\N	\N	\N	109043	109043	109044
23048	35433	6	applied	\N	\N	\N	\N	109045	109045	109046
23050	35434	0	applied	\N	\N	\N	\N	109050	109050	109051
23050	35435	1	applied	\N	\N	\N	\N	109052	109052	109053
23050	35436	2	applied	\N	\N	\N	\N	109054	109054	109055
23053	35439	0	applied	\N	\N	\N	\N	109064	109064	109065
23053	35440	1	applied	\N	\N	\N	\N	109066	109066	109067
23053	35441	2	applied	\N	\N	\N	\N	109068	109068	109069
23053	35442	3	applied	\N	\N	\N	\N	109070	109070	109071
23053	35443	4	applied	\N	\N	\N	\N	109072	109072	109073
23053	35444	5	applied	\N	\N	\N	\N	109074	109074	109075
23053	35445	6	applied	\N	\N	\N	\N	109076	109076	109077
23055	35446	0	applied	\N	\N	\N	\N	109081	109081	109082
23055	35447	1	applied	\N	\N	\N	\N	109083	109083	109084
23055	35448	2	applied	\N	\N	\N	\N	109085	109085	109086
23062	35456	0	applied	\N	\N	\N	\N	109112	109112	109113
23062	35457	1	applied	\N	\N	\N	\N	109114	109114	109115
23062	35458	2	applied	\N	\N	\N	\N	109116	109116	109117
23062	35459	3	applied	\N	\N	\N	\N	109118	109118	109119
23062	35460	4	applied	\N	\N	\N	\N	109120	109120	109121
23062	35461	5	applied	\N	\N	\N	\N	109122	109122	109123
23065	35462	0	applied	\N	\N	\N	\N	109128	109128	109129
23065	35463	1	applied	\N	\N	\N	\N	109130	109130	109131
23065	35464	2	applied	\N	\N	\N	\N	109132	109132	109133
23065	35465	3	applied	\N	\N	\N	\N	109134	109134	109135
23067	35466	0	applied	\N	\N	\N	\N	109140	109140	109141
23067	35467	1	applied	\N	\N	\N	\N	109142	109142	109143
23067	35468	2	applied	\N	\N	\N	\N	109144	109144	109145
23067	35469	3	applied	\N	\N	\N	\N	109146	109146	109147
23067	35470	4	applied	\N	\N	\N	\N	109148	109148	109149
23067	35471	5	applied	\N	\N	\N	\N	109150	109150	109151
23076	35482	0	applied	\N	\N	\N	\N	109183	109183	109184
23076	35483	1	applied	\N	\N	\N	\N	109185	109185	109186
23079	35484	0	applied	\N	\N	\N	\N	109188	109188	109189
23079	35485	1	applied	\N	\N	\N	\N	109190	109190	109191
23079	35486	2	applied	\N	\N	\N	\N	109192	109192	109193
23079	35487	3	applied	\N	\N	\N	\N	109194	109194	109195
23083	35499	0	applied	\N	\N	\N	\N	109227	109227	109228
23083	35500	1	applied	\N	\N	\N	\N	109229	109229	109230
23083	35501	2	applied	\N	\N	\N	\N	109231	109231	109232
23084	35502	0	applied	\N	\N	\N	\N	109235	109235	109236
23084	35503	1	applied	\N	\N	\N	\N	109237	109237	109238
23084	35504	2	applied	\N	\N	\N	\N	109239	109239	109240
23084	35505	3	applied	\N	\N	\N	\N	109241	109241	109242
23084	35506	4	applied	\N	\N	\N	\N	109243	109243	109244
23084	35507	5	applied	\N	\N	\N	\N	109245	109245	109246
23084	35508	6	applied	\N	\N	\N	\N	109247	109247	109248
23084	35509	7	applied	\N	\N	\N	\N	109249	109249	109250
23084	35510	8	applied	\N	\N	\N	\N	109251	109251	109252
23084	35511	9	applied	\N	\N	\N	\N	109253	109253	109254
23089	35456	0	applied	\N	\N	\N	\N	109112	109112	109113
23089	35457	1	applied	\N	\N	\N	\N	109114	109114	109115
23089	35462	2	applied	\N	\N	\N	\N	109128	109128	109129
23089	35466	3	applied	\N	\N	\N	\N	109140	109140	109141
23089	35467	4	applied	\N	\N	\N	\N	109142	109142	109143
23089	35472	5	applied	\N	\N	\N	\N	109156	109156	109157
23089	35475	6	applied	\N	\N	\N	\N	109163	109163	109164
23089	35479	7	applied	\N	\N	\N	\N	109174	109174	109175
23089	35482	8	applied	\N	\N	\N	\N	109183	109183	109184
23089	35484	9	applied	\N	\N	\N	\N	109188	109188	109189
23089	35489	10	applied	\N	\N	\N	\N	109204	109204	109205
23089	35492	11	applied	\N	\N	\N	\N	109212	109212	109213
23089	35495	12	applied	\N	\N	\N	\N	109218	109218	109219
23089	35499	13	applied	\N	\N	\N	\N	109227	109227	109228
23089	35502	14	applied	\N	\N	\N	\N	109235	109235	109236
23089	35503	15	applied	\N	\N	\N	\N	109237	109237	109238
23089	35504	16	applied	\N	\N	\N	\N	109239	109239	109240
23089	35512	17	applied	\N	\N	\N	\N	109257	109257	109258
23089	35515	18	applied	\N	\N	\N	\N	109266	109266	109267
23089	35516	19	applied	\N	\N	\N	\N	109268	109268	109269
23089	35517	20	applied	\N	\N	\N	\N	109270	109270	109271
23089	35518	21	applied	\N	\N	\N	\N	109272	109272	109273
23089	35458	22	applied	\N	\N	\N	\N	109116	109116	109117
23089	35459	23	applied	\N	\N	\N	\N	109118	109118	109119
23089	35463	24	applied	\N	\N	\N	\N	109130	109130	109274
23089	35460	25	applied	\N	\N	\N	\N	109120	109120	109275
23089	35464	26	applied	\N	\N	\N	\N	109132	109132	109276
23089	35461	27	applied	\N	\N	\N	\N	109122	109122	109133
23089	35465	28	applied	\N	\N	\N	\N	109134	109134	109135
23089	35468	29	applied	\N	\N	\N	\N	109144	109144	109145
23089	35469	30	applied	\N	\N	\N	\N	109146	109146	109147
23089	35473	31	applied	\N	\N	\N	\N	109158	109158	109277
23089	35470	32	applied	\N	\N	\N	\N	109148	109148	109278
23089	35471	33	applied	\N	\N	\N	\N	109150	109150	109159
23089	35474	34	applied	\N	\N	\N	\N	109160	109160	109161
23089	35476	35	applied	\N	\N	\N	\N	109165	109165	109166
23089	35480	36	applied	\N	\N	\N	\N	109176	109176	109170
23089	35487	37	applied	\N	\N	\N	\N	109194	109194	109177
23089	35488	38	applied	\N	\N	\N	\N	109196	109196	109279
23089	35491	39	applied	\N	\N	\N	\N	109208	109208	109191
23089	35493	40	applied	\N	\N	\N	\N	109214	109214	109280
23089	35497	41	applied	\N	\N	\N	\N	109222	109222	109281
23089	35500	42	applied	\N	\N	\N	\N	109229	109229	109207
23059	35454	2	applied	\N	\N	\N	\N	109101	109101	109102
23059	35455	4	applied	\N	\N	\N	\N	109103	109103	109104
23061	35456	0	applied	\N	\N	\N	\N	109112	109112	109113
23061	35457	1	applied	\N	\N	\N	\N	109114	109114	109115
23061	35458	2	applied	\N	\N	\N	\N	109116	109116	109117
23061	35459	3	applied	\N	\N	\N	\N	109118	109118	109119
23061	35460	4	applied	\N	\N	\N	\N	109120	109120	109121
23061	35461	5	applied	\N	\N	\N	\N	109122	109122	109123
23068	35466	0	applied	\N	\N	\N	\N	109140	109140	109141
23068	35467	1	applied	\N	\N	\N	\N	109142	109142	109143
23068	35468	2	applied	\N	\N	\N	\N	109144	109144	109145
23068	35469	3	applied	\N	\N	\N	\N	109146	109146	109147
23068	35470	4	applied	\N	\N	\N	\N	109148	109148	109149
23068	35471	5	applied	\N	\N	\N	\N	109150	109150	109151
23070	35472	0	applied	\N	\N	\N	\N	109156	109156	109157
23070	35473	1	applied	\N	\N	\N	\N	109158	109158	109159
23070	35474	2	applied	\N	\N	\N	\N	109160	109160	109161
23073	35475	0	applied	\N	\N	\N	\N	109163	109163	109164
23073	35476	1	applied	\N	\N	\N	\N	109165	109165	109166
23073	35477	2	applied	\N	\N	\N	\N	109167	109167	109168
23073	35478	3	applied	\N	\N	\N	\N	109169	109169	109170
23077	35484	0	applied	\N	\N	\N	\N	109188	109188	109189
23077	35485	1	applied	\N	\N	\N	\N	109190	109190	109191
23077	35486	2	applied	\N	\N	\N	\N	109192	109192	109193
23077	35487	3	applied	\N	\N	\N	\N	109194	109194	109195
23077	35488	4	applied	\N	\N	\N	\N	109196	109196	109197
23082	35495	0	applied	\N	\N	\N	\N	109218	109218	109219
23082	35496	1	applied	\N	\N	\N	\N	109220	109220	109221
23082	35497	2	applied	\N	\N	\N	\N	109222	109222	109223
23082	35498	3	applied	\N	\N	\N	\N	109224	109224	109225
23085	35512	0	applied	\N	\N	\N	\N	109257	109257	109258
23085	35513	1	applied	\N	\N	\N	\N	109259	109259	109260
23087	35512	0	applied	\N	\N	\N	\N	109257	109257	109258
23087	35513	1	applied	\N	\N	\N	\N	109259	109259	109260
23087	35514	2	applied	\N	\N	\N	\N	109262	109262	109263
23098	35548	0	applied	\N	\N	\N	\N	109371	109371	109372
23098	35549	1	applied	\N	\N	\N	\N	109373	109373	109374
23098	35550	2	applied	\N	\N	\N	\N	109375	109375	109376
23098	35551	3	applied	\N	\N	\N	\N	109377	109377	109378
23098	35552	4	applied	\N	\N	\N	\N	109379	109379	109380
23098	35553	5	applied	\N	\N	\N	\N	109381	109381	109382
23103	35564	0	applied	\N	\N	\N	\N	109410	109410	109411
23103	35565	1	applied	\N	\N	\N	\N	109412	109412	109413
23103	35566	2	applied	\N	\N	\N	\N	109414	109414	109415
23108	35573	0	applied	\N	\N	\N	\N	109432	109432	109433
23108	35574	1	applied	\N	\N	\N	\N	109434	109434	109435
23108	35575	2	applied	\N	\N	\N	\N	109436	109436	109437
23108	35576	3	applied	\N	\N	\N	\N	109438	109438	109439
23110	35577	0	applied	\N	\N	\N	\N	109444	109444	109445
23110	35578	1	applied	\N	\N	\N	\N	109446	109446	109447
23110	35579	2	applied	\N	\N	\N	\N	109448	109448	109449
23120	35601	0	applied	\N	\N	\N	\N	109500	109500	109501
23120	35602	1	applied	\N	\N	\N	\N	109502	109502	109503
23120	35603	2	applied	\N	\N	\N	\N	109504	109504	109505
23120	35604	3	applied	\N	\N	\N	\N	109506	109506	109507
23120	35605	4	applied	\N	\N	\N	\N	109508	109508	109509
23120	35606	5	applied	\N	\N	\N	\N	109510	109510	109511
23123	35610	0	applied	\N	\N	\N	\N	109520	109520	109521
23123	35611	1	applied	\N	\N	\N	\N	109522	109522	109523
23123	35612	2	applied	\N	\N	\N	\N	109524	109524	109525
23126	35621	0	applied	\N	\N	\N	\N	109549	109549	109550
23126	35620	1	applied	\N	\N	\N	\N	109545	109545	109546
23126	35622	2	applied	\N	\N	\N	\N	109551	109551	109552
23129	35623	0	applied	\N	\N	\N	\N	109554	109554	109555
23129	35624	1	applied	\N	\N	\N	\N	109556	109556	109557
23129	35625	2	applied	\N	\N	\N	\N	109558	109558	109559
23129	35626	3	applied	\N	\N	\N	\N	109560	109560	109561
23129	35627	4	applied	\N	\N	\N	\N	109562	109562	109563
23133	35628	0	applied	\N	\N	\N	\N	109604	109604	109605
23133	35629	1	applied	\N	\N	\N	\N	109606	109606	109607
23133	35630	2	applied	\N	\N	\N	\N	109608	109608	109609
23133	35631	3	applied	\N	\N	\N	\N	109610	109610	109611
23133	35632	5	applied	\N	\N	\N	\N	109613	109613	109614
23133	35634	6	applied	\N	\N	\N	\N	109621	109621	109622
23133	35633	7	applied	\N	\N	\N	\N	109615	109615	109623
23133	35635	8	applied	\N	\N	\N	\N	109624	109624	109625
23133	35636	9	applied	\N	\N	\N	\N	109626	109626	109627
23138	35637	0	applied	\N	\N	\N	\N	109665	109665	109666
23138	35638	1	applied	\N	\N	\N	\N	109667	109667	109668
23138	35634	2	applied	\N	\N	\N	\N	109621	109621	109623
23138	35635	3	applied	\N	\N	\N	\N	109624	109624	109625
23138	35639	4	applied	\N	\N	\N	\N	109669	109669	109670
23138	35640	5	applied	\N	\N	\N	\N	109671	109671	109672
23138	35636	6	applied	\N	\N	\N	\N	109626	109626	109673
23138	35641	7	applied	\N	\N	\N	\N	109674	109674	109675
23138	35642	8	applied	\N	\N	\N	\N	109676	109676	109677
23139	35643	0	applied	\N	\N	\N	\N	109681	109681	109682
23139	35644	1	applied	\N	\N	\N	\N	109683	109683	109684
23139	35645	2	applied	\N	\N	\N	\N	109685	109685	109686
23139	35646	3	applied	\N	\N	\N	\N	109687	109687	109688
23139	35647	4	applied	\N	\N	\N	\N	109689	109689	109690
23139	35648	5	applied	\N	\N	\N	\N	109691	109691	109692
23139	35649	6	applied	\N	\N	\N	\N	109693	109693	109694
23144	35653	0	applied	\N	\N	\N	\N	109708	109708	109709
23144	35654	1	applied	\N	\N	\N	\N	109710	109710	109711
23144	35655	2	applied	\N	\N	\N	\N	109712	109712	109713
23144	35656	3	applied	\N	\N	\N	\N	109714	109714	109715
23145	35657	0	applied	\N	\N	\N	\N	109718	109718	109719
23145	35658	1	applied	\N	\N	\N	\N	109720	109720	109721
23145	35659	2	applied	\N	\N	\N	\N	109722	109722	109723
23147	35663	0	applied	\N	\N	\N	\N	109732	109732	109733
23147	35664	1	applied	\N	\N	\N	\N	109734	109734	109735
23147	35665	2	applied	\N	\N	\N	\N	109736	109736	109737
23147	35666	3	applied	\N	\N	\N	\N	109738	109738	109739
23147	35667	4	applied	\N	\N	\N	\N	109740	109740	109741
23147	35668	5	applied	\N	\N	\N	\N	109742	109742	109743
23147	35669	6	applied	\N	\N	\N	\N	109744	109744	109745
23147	35670	7	applied	\N	\N	\N	\N	109746	109746	109747
23147	35671	8	applied	\N	\N	\N	\N	109748	109748	109749
23147	35672	9	applied	\N	\N	\N	\N	109750	109750	109751
23151	35305	0	applied	\N	\N	\N	\N	108702	108702	108703
23151	35306	1	applied	\N	\N	\N	\N	108704	108704	108705
23151	35309	2	applied	\N	\N	\N	\N	108713	108713	108714
23151	35312	3	applied	\N	\N	\N	\N	108721	108721	108722
23151	35316	4	applied	\N	\N	\N	\N	108730	108730	108731
23151	35317	5	applied	\N	\N	\N	\N	108732	108732	108733
23151	35322	6	applied	\N	\N	\N	\N	108744	108744	108745
23151	35323	7	applied	\N	\N	\N	\N	108746	108746	108747
23151	35324	8	applied	\N	\N	\N	\N	108748	108748	108749
23151	35325	9	applied	\N	\N	\N	\N	108750	108750	108751
23078	35486	1	applied	\N	\N	\N	\N	109192	109192	109199
23078	35487	2	applied	\N	\N	\N	\N	109194	109194	109200
23078	35488	3	applied	\N	\N	\N	\N	109196	109196	109201
23080	35489	0	applied	\N	\N	\N	\N	109204	109204	109205
23080	35490	1	applied	\N	\N	\N	\N	109206	109206	109207
23080	35491	2	applied	\N	\N	\N	\N	109208	109208	109209
23086	35512	0	applied	\N	\N	\N	\N	109257	109257	109258
23086	35513	1	applied	\N	\N	\N	\N	109259	109259	109260
23086	35514	2	applied	\N	\N	\N	\N	109262	109262	109263
23088	35512	0	applied	\N	\N	\N	\N	109257	109257	109258
23088	35513	1	applied	\N	\N	\N	\N	109259	109259	109260
23088	35514	2	applied	\N	\N	\N	\N	109262	109262	109263
23091	35532	0	applied	\N	\N	\N	\N	109330	109330	109331
23091	35533	1	applied	\N	\N	\N	\N	109332	109332	109333
23091	35534	2	applied	\N	\N	\N	\N	109334	109334	109335
23094	35538	0	applied	\N	\N	\N	\N	109344	109344	109345
23094	35539	1	applied	\N	\N	\N	\N	109346	109346	109347
23094	35540	2	applied	\N	\N	\N	\N	109348	109348	109349
23094	35541	3	applied	\N	\N	\N	\N	109350	109350	109351
23094	35542	4	applied	\N	\N	\N	\N	109352	109352	109353
23094	35543	5	applied	\N	\N	\N	\N	109354	109354	109355
23094	35544	6	applied	\N	\N	\N	\N	109356	109356	109357
23096	35545	0	applied	\N	\N	\N	\N	109362	109362	109363
23096	35546	1	applied	\N	\N	\N	\N	109364	109364	109365
23096	35547	2	applied	\N	\N	\N	\N	109366	109366	109367
23099	35554	0	applied	\N	\N	\N	\N	109385	109385	109386
23099	35555	1	applied	\N	\N	\N	\N	109387	109387	109388
23099	35556	2	applied	\N	\N	\N	\N	109389	109389	109390
23101	35558	0	applied	\N	\N	\N	\N	109396	109396	109397
23101	35559	1	applied	\N	\N	\N	\N	109398	109398	109399
23101	35557	2	applied	\N	\N	\N	\N	109393	109393	109400
23104	35567	0	applied	\N	\N	\N	\N	109416	109416	109417
23104	35568	1	applied	\N	\N	\N	\N	109418	109418	109419
23104	35569	2	applied	\N	\N	\N	\N	109420	109420	109421
23106	35570	0	applied	\N	\N	\N	\N	109424	109424	109425
23106	35571	1	applied	\N	\N	\N	\N	109426	109426	109427
23106	35572	2	applied	\N	\N	\N	\N	109428	109428	109429
23109	35573	0	applied	\N	\N	\N	\N	109432	109432	109433
23109	35574	1	applied	\N	\N	\N	\N	109434	109434	109435
23109	35575	2	applied	\N	\N	\N	\N	109436	109436	109437
23109	35576	3	applied	\N	\N	\N	\N	109438	109438	109439
23113	35583	0	applied	\N	\N	\N	\N	109460	109460	109461
23113	35584	1	applied	\N	\N	\N	\N	109462	109462	109463
23113	35585	2	applied	\N	\N	\N	\N	109464	109464	109465
23113	35586	3	applied	\N	\N	\N	\N	109466	109466	109467
23116	35597	0	applied	\N	\N	\N	\N	109490	109490	109491
23116	35598	1	applied	\N	\N	\N	\N	109492	109492	109493
23116	35599	2	applied	\N	\N	\N	\N	109494	109494	109495
23116	35600	3	applied	\N	\N	\N	\N	109496	109496	109497
23121	35607	0	applied	\N	\N	\N	\N	109513	109513	109514
23121	35608	1	applied	\N	\N	\N	\N	109515	109515	109516
23121	35609	2	applied	\N	\N	\N	\N	109517	109517	109518
23124	35613	0	applied	\N	\N	\N	\N	109529	109529	109530
23124	35614	1	applied	\N	\N	\N	\N	109531	109531	109532
23124	35615	2	applied	\N	\N	\N	\N	109533	109533	109534
23124	35616	3	applied	\N	\N	\N	\N	109535	109535	109536
23124	35617	4	applied	\N	\N	\N	\N	109537	109537	109538
23124	35618	5	applied	\N	\N	\N	\N	109539	109539	109540
23124	35619	6	applied	\N	\N	\N	\N	109541	109541	109542
23134	35628	0	applied	\N	\N	\N	\N	109604	109604	109605
23134	35629	1	applied	\N	\N	\N	\N	109606	109606	109607
23134	35630	2	applied	\N	\N	\N	\N	109608	109608	109609
23134	35631	3	applied	\N	\N	\N	\N	109610	109610	109611
23134	35632	5	applied	\N	\N	\N	\N	109613	109613	109614
23134	35634	6	applied	\N	\N	\N	\N	109621	109621	109622
23134	35633	7	applied	\N	\N	\N	\N	109615	109615	109623
23134	35635	8	applied	\N	\N	\N	\N	109624	109624	109625
23134	35636	9	applied	\N	\N	\N	\N	109626	109626	109627
23140	35643	0	applied	\N	\N	\N	\N	109681	109681	109682
23140	35644	1	applied	\N	\N	\N	\N	109683	109683	109684
23140	35645	2	applied	\N	\N	\N	\N	109685	109685	109686
23140	35646	3	applied	\N	\N	\N	\N	109687	109687	109688
23140	35647	4	applied	\N	\N	\N	\N	109689	109689	109690
23140	35648	5	applied	\N	\N	\N	\N	109691	109691	109692
23140	35649	6	applied	\N	\N	\N	\N	109693	109693	109694
23146	35660	0	applied	\N	\N	\N	\N	109726	109726	109727
23146	35661	1	applied	\N	\N	\N	\N	109728	109728	109729
23146	35662	2	applied	\N	\N	\N	\N	109730	109730	109731
23148	35673	0	applied	\N	\N	\N	\N	109754	109754	109755
23148	35674	1	applied	\N	\N	\N	\N	109756	109756	109757
23148	35675	2	applied	\N	\N	\N	\N	109758	109758	109759
23153	35676	0	applied	\N	\N	\N	\N	109772	109772	109773
23153	35677	1	applied	\N	\N	\N	\N	109774	109774	109775
23153	35678	2	applied	\N	\N	\N	\N	109776	109776	109777
23153	35679	3	applied	\N	\N	\N	\N	109778	109778	109779
23157	35680	0	applied	\N	\N	\N	\N	109784	109784	109785
23158	35680	0	applied	\N	\N	\N	\N	109784	109784	109785
23158	35682	1	applied	\N	\N	\N	\N	109814	109814	109815
23158	35683	2	applied	\N	\N	\N	\N	109816	109816	109817
23158	35681	3	applied	\N	\N	\N	\N	109786	109786	109787
23158	35684	4	applied	\N	\N	\N	\N	109818	109818	109819
23158	35685	5	applied	\N	\N	\N	\N	109820	109820	109821
23158	35686	6	applied	\N	\N	\N	\N	109822	109822	109823
23165	35694	0	applied	\N	\N	\N	\N	109847	109847	109848
23165	35695	1	applied	\N	\N	\N	\N	109849	109849	109850
23165	35696	2	applied	\N	\N	\N	\N	109851	109851	109852
23165	35697	3	applied	\N	\N	\N	\N	109853	109853	109854
23170	35700	0	applied	\N	\N	\N	\N	109865	109865	109866
23170	35701	1	applied	\N	\N	\N	\N	109867	109867	109868
23170	35702	2	applied	\N	\N	\N	\N	109869	109869	109870
23174	35047	0	applied	\N	\N	\N	\N	107835	107835	107836
23174	35051	1	applied	\N	\N	\N	\N	107846	107846	107847
23174	35056	2	applied	\N	\N	\N	\N	107859	107859	107860
23174	35234	3	applied	\N	\N	1000000000	\N	108454	108454	108455
23174	35060	4	applied	\N	\N	\N	\N	107871	107871	107872
23174	35063	5	applied	\N	\N	\N	\N	107878	107878	107879
23174	35066	6	applied	\N	\N	\N	\N	107886	107886	107887
23174	35071	7	applied	\N	\N	\N	\N	107897	107897	107898
23174	35072	8	applied	\N	\N	\N	\N	107899	107899	107900
23174	35077	9	applied	\N	\N	\N	\N	107912	107912	107913
23174	35081	10	applied	\N	\N	\N	\N	107928	107928	107929
23174	35083	11	applied	\N	\N	\N	\N	107934	107934	107987
23174	35086	12	applied	\N	\N	\N	\N	107941	107941	107988
23174	35090	13	applied	\N	\N	\N	\N	107951	107951	107989
23174	35091	14	applied	\N	\N	\N	\N	107953	107953	107990
23174	35096	15	applied	\N	\N	\N	\N	107969	107969	107991
23174	35099	16	applied	\N	\N	\N	\N	107975	107975	107992
23174	35103	17	applied	\N	\N	\N	\N	108009	108009	108580
23174	35106	18	applied	\N	\N	\N	\N	108019	108019	108581
23174	35109	19	applied	\N	\N	\N	\N	108029	108029	108582
23089	35505	43	applied	\N	\N	\N	\N	109241	109241	109209
23089	35507	44	applied	\N	\N	\N	\N	109245	109245	109215
23089	35508	45	applied	\N	\N	\N	\N	109247	109247	109282
23089	35513	46	applied	\N	\N	\N	\N	109259	109259	109283
23089	35519	47	applied	\N	\N	\N	\N	109284	109284	109285
23089	35520	48	applied	\N	\N	\N	\N	109286	109286	109287
23089	35521	49	applied	\N	\N	\N	\N	109288	109288	109289
23089	35522	50	applied	\N	\N	\N	\N	109290	109290	109291
23089	35477	51	applied	\N	\N	\N	\N	109167	109167	109292
23089	35486	52	applied	\N	\N	\N	\N	109192	109192	109246
23089	35498	53	applied	\N	\N	\N	\N	109224	109224	109293
23089	35506	54	applied	\N	\N	\N	\N	109243	109243	109294
23089	35523	55	applied	\N	\N	\N	\N	109295	109295	109248
23089	35478	56	applied	\N	\N	\N	\N	109169	109169	109250
23089	35481	57	applied	\N	\N	\N	\N	109178	109178	109252
23089	35483	58	applied	\N	\N	\N	\N	109185	109185	109254
23089	35485	59	applied	\N	\N	\N	\N	109190	109190	109296
23089	35490	60	applied	\N	\N	\N	\N	109206	109206	109297
23089	35494	61	applied	\N	\N	\N	\N	109216	109216	109298
23089	35496	62	applied	\N	\N	\N	\N	109220	109220	109299
23089	35501	63	applied	\N	\N	\N	\N	109231	109231	109300
23089	35509	64	applied	\N	\N	\N	\N	109249	109249	109301
23089	35510	65	applied	\N	\N	\N	\N	109251	109251	109302
23089	35511	66	applied	\N	\N	\N	\N	109253	109253	109303
23089	35514	67	applied	\N	\N	\N	\N	109262	109262	109304
23089	35524	68	applied	\N	\N	\N	\N	109305	109305	109306
23089	35525	69	applied	\N	\N	\N	\N	109307	109307	109308
23089	35526	70	applied	\N	\N	\N	\N	109309	109309	109310
23089	35527	71	applied	\N	\N	\N	\N	109311	109311	109312
23092	35535	0	applied	\N	\N	\N	\N	109336	109336	109337
23092	35536	1	applied	\N	\N	\N	\N	109338	109338	109339
23092	35537	2	applied	\N	\N	\N	\N	109340	109340	109341
23095	35538	0	applied	\N	\N	\N	\N	109344	109344	109345
23095	35539	1	applied	\N	\N	\N	\N	109346	109346	109347
23095	35540	2	applied	\N	\N	\N	\N	109348	109348	109349
23095	35541	3	applied	\N	\N	\N	\N	109350	109350	109351
23095	35542	4	applied	\N	\N	\N	\N	109352	109352	109353
23095	35543	5	applied	\N	\N	\N	\N	109354	109354	109355
23095	35544	6	applied	\N	\N	\N	\N	109356	109356	109357
23097	35545	0	applied	\N	\N	\N	\N	109362	109362	109363
23097	35546	1	applied	\N	\N	\N	\N	109364	109364	109365
23097	35547	2	applied	\N	\N	\N	\N	109366	109366	109367
23102	35560	0	applied	\N	\N	\N	\N	109401	109401	109402
23102	35561	1	applied	\N	\N	\N	\N	109403	109403	109404
23102	35562	2	applied	\N	\N	\N	\N	109405	109405	109406
23102	35563	3	applied	\N	\N	\N	\N	109407	109407	109408
23105	35567	0	applied	\N	\N	\N	\N	109416	109416	109417
23105	35568	1	applied	\N	\N	\N	\N	109418	109418	109419
23105	35569	2	applied	\N	\N	\N	\N	109420	109420	109421
23107	35573	0	applied	\N	\N	\N	\N	109432	109432	109433
23107	35574	1	applied	\N	\N	\N	\N	109434	109434	109435
23107	35575	2	applied	\N	\N	\N	\N	109436	109436	109437
23107	35576	3	applied	\N	\N	\N	\N	109438	109438	109439
23111	35577	0	applied	\N	\N	\N	\N	109444	109444	109445
23111	35578	1	applied	\N	\N	\N	\N	109446	109446	109447
23111	35579	2	applied	\N	\N	\N	\N	109448	109448	109449
23117	35598	0	applied	\N	\N	\N	\N	109492	109492	109493
23119	35601	0	applied	\N	\N	\N	\N	109500	109500	109501
23119	35602	1	applied	\N	\N	\N	\N	109502	109502	109503
23119	35603	2	applied	\N	\N	\N	\N	109504	109504	109505
23119	35604	3	applied	\N	\N	\N	\N	109506	109506	109507
23119	35605	4	applied	\N	\N	\N	\N	109508	109508	109509
23119	35606	5	applied	\N	\N	\N	\N	109510	109510	109511
23125	35620	0	applied	\N	\N	\N	\N	109545	109545	109546
23127	35623	0	applied	\N	\N	\N	\N	109554	109554	109555
23127	35624	1	applied	\N	\N	\N	\N	109556	109556	109557
23127	35625	2	applied	\N	\N	\N	\N	109558	109558	109559
23127	35626	3	applied	\N	\N	\N	\N	109560	109560	109561
23127	35627	4	applied	\N	\N	\N	\N	109562	109562	109563
23130	35234	0	applied	\N	\N	1000000000	\N	108454	108454	108455
23130	35166	1	applied	\N	\N	\N	\N	106113	106113	108172
23130	35129	2	applied	\N	\N	\N	\N	108093	108093	108094
23130	35223	3	applied	\N	\N	\N	\N	108400	108400	107420
23130	35170	4	applied	\N	\N	\N	\N	108192	108192	106140
23130	35133	5	applied	\N	\N	\N	\N	108101	108101	108044
23130	35626	6	applied	\N	\N	\N	\N	109568	109568	109561
23130	35598	7	applied	\N	\N	\N	\N	109492	109492	109493
23130	35150	8	applied	\N	\N	\N	\N	108143	108143	109569
23130	35158	9	applied	\N	\N	\N	\N	108160	108160	109570
23130	35198	10	applied	\N	\N	\N	\N	108336	108336	108337
23130	35238	11	applied	\N	\N	\N	\N	108462	108462	108463
23130	35290	12	applied	\N	\N	\N	\N	108657	108657	108658
23130	35176	13	applied	\N	\N	\N	\N	108219	108219	108051
23130	35185	14	applied	\N	\N	\N	\N	108277	108277	109571
23130	35200	15	applied	\N	\N	\N	\N	108340	108340	108053
23130	35204	16	applied	\N	\N	\N	\N	108351	108351	108245
23130	35222	17	applied	\N	\N	\N	\N	108398	108398	108246
23130	35239	18	applied	\N	\N	\N	\N	108464	108464	108074
23130	35240	19	applied	\N	\N	\N	\N	108466	108466	108075
23130	35627	20	applied	\N	\N	\N	\N	109572	109572	109563
23130	35261	21	applied	\N	\N	\N	\N	108521	108521	108247
23130	35272	22	applied	\N	\N	\N	\N	108553	108553	108077
23130	35284	23	applied	\N	\N	\N	\N	108642	108642	108309
23130	35295	24	applied	\N	\N	\N	\N	108668	108668	108082
23130	35303	25	applied	\N	\N	\N	\N	108693	108693	108248
23130	35315	26	applied	\N	\N	\N	\N	108727	108727	108310
23130	35328	27	applied	\N	\N	\N	\N	108756	108756	108084
23130	35329	28	applied	\N	\N	\N	\N	108758	108758	108119
23130	35346	29	applied	\N	\N	\N	\N	108807	108807	108096
23130	35354	30	applied	\N	\N	\N	\N	108832	108832	109573
23130	35367	31	applied	\N	\N	\N	\N	108867	108867	108098
23130	35380	32	applied	\N	\N	\N	\N	108914	108914	108311
23130	35392	33	applied	\N	\N	\N	\N	108942	108942	108100
23130	35125	34	applied	\N	\N	\N	\N	108083	108083	109574
23130	35134	35	applied	\N	\N	\N	\N	108103	108103	109575
23130	35135	36	applied	\N	\N	\N	\N	108105	108105	109576
23130	35136	37	applied	\N	\N	\N	\N	108107	108107	108249
23130	35142	38	applied	\N	\N	\N	\N	108123	108123	108126
23130	35145	39	applied	\N	\N	\N	\N	108132	108132	108133
23130	35151	40	applied	\N	\N	\N	\N	108145	108145	108144
23130	35208	41	applied	\N	\N	\N	\N	108359	108359	108360
23130	35209	42	applied	\N	\N	\N	\N	108361	108361	108362
23130	35300	43	applied	\N	\N	\N	\N	108685	108685	108686
23130	35213	44	applied	\N	\N	\N	\N	108369	108369	108370
23130	35214	45	applied	\N	\N	\N	\N	108371	108371	108372
23130	35163	46	applied	\N	\N	\N	\N	106057	106057	108202
23130	35137	47	applied	\N	\N	\N	\N	108109	108109	108110
23130	35138	48	applied	\N	\N	\N	\N	108111	108111	108112
23130	35139	49	applied	\N	\N	\N	\N	108113	108113	108114
23130	35140	50	applied	\N	\N	\N	\N	108115	108115	108116
23090	35520	11	applied	\N	\N	\N	\N	109286	109286	109321
23090	35521	12	applied	\N	\N	\N	\N	109288	109288	109308
23090	35522	13	applied	\N	\N	\N	\N	109290	109290	109322
23090	35530	14	applied	\N	\N	\N	\N	109323	109323	109324
23090	35527	15	applied	\N	\N	\N	\N	109311	109311	109325
23090	35531	16	applied	\N	\N	\N	\N	109326	109326	109327
23093	35538	0	applied	\N	\N	\N	\N	109344	109344	109345
23093	35539	1	applied	\N	\N	\N	\N	109346	109346	109347
23093	35540	2	applied	\N	\N	\N	\N	109348	109348	109349
23093	35541	3	applied	\N	\N	\N	\N	109350	109350	109351
23093	35542	4	applied	\N	\N	\N	\N	109352	109352	109353
23093	35543	5	applied	\N	\N	\N	\N	109354	109354	109355
23093	35544	6	applied	\N	\N	\N	\N	109356	109356	109357
23100	35557	0	applied	\N	\N	\N	\N	109393	109393	109394
23112	35580	0	applied	\N	\N	\N	\N	109452	109452	109453
23112	35581	1	applied	\N	\N	\N	\N	109454	109454	109455
23112	35582	2	applied	\N	\N	\N	\N	109456	109456	109457
23115	35587	0	applied	\N	\N	\N	\N	109469	109469	109470
23115	35588	1	applied	\N	\N	\N	\N	109471	109471	109472
23115	35589	2	applied	\N	\N	\N	\N	109473	109473	109474
23115	35590	3	applied	\N	\N	\N	\N	109475	109475	109476
23115	35591	4	applied	\N	\N	\N	\N	109477	109477	109478
23115	35592	5	applied	\N	\N	\N	\N	109479	109479	109480
23115	35593	6	applied	\N	\N	\N	\N	109481	109481	109482
23115	35594	7	applied	\N	\N	\N	\N	109483	109483	109484
23115	35595	8	applied	\N	\N	\N	\N	109485	109485	109486
23115	35596	9	applied	\N	\N	\N	\N	109487	109487	109488
23122	35610	0	applied	\N	\N	\N	\N	109520	109520	109521
23122	35611	1	applied	\N	\N	\N	\N	109522	109522	109523
23122	35612	2	applied	\N	\N	\N	\N	109524	109524	109525
23128	35623	0	applied	\N	\N	\N	\N	109554	109554	109555
23128	35624	1	applied	\N	\N	\N	\N	109556	109556	109557
23128	35625	2	applied	\N	\N	\N	\N	109558	109558	109559
23128	35626	3	applied	\N	\N	\N	\N	109560	109560	109561
23128	35627	4	applied	\N	\N	\N	\N	109562	109562	109563
23131	35623	0	applied	\N	\N	\N	\N	109554	109554	109555
23131	35624	1	applied	\N	\N	\N	\N	109556	109556	109557
23131	35625	2	applied	\N	\N	\N	\N	109558	109558	109559
23131	35626	3	applied	\N	\N	\N	\N	109560	109560	109561
23131	35627	4	applied	\N	\N	\N	\N	109562	109562	109563
23132	35628	0	applied	\N	\N	\N	\N	109604	109604	109605
23132	35629	1	applied	\N	\N	\N	\N	109606	109606	109607
23132	35630	2	applied	\N	\N	\N	\N	109608	109608	109609
23132	35631	3	applied	\N	\N	\N	\N	109610	109610	109611
23132	35632	5	applied	\N	\N	\N	\N	109613	109613	109614
23132	35633	6	applied	\N	\N	\N	\N	109615	109615	109616
23136	35558	0	applied	\N	\N	\N	\N	109396	109396	109397
23136	35560	1	applied	\N	\N	\N	\N	109401	109401	109402
23136	35564	2	applied	\N	\N	\N	\N	109410	109410	109411
23136	35567	3	applied	\N	\N	\N	\N	109416	109416	109417
23136	35570	4	applied	\N	\N	\N	\N	109424	109424	109425
23136	35573	5	applied	\N	\N	\N	\N	109432	109432	109433
23136	35577	6	applied	\N	\N	\N	\N	109444	109444	109445
23136	35580	7	applied	\N	\N	\N	\N	109452	109452	109453
23136	35583	8	applied	\N	\N	\N	\N	109460	109460	109461
23136	35587	9	applied	\N	\N	\N	\N	109469	109469	109470
23136	35588	10	applied	\N	\N	\N	\N	109471	109471	109472
23136	35589	11	applied	\N	\N	\N	\N	109473	109473	109474
23136	35597	12	applied	\N	\N	\N	\N	109490	109490	109491
23136	35601	13	applied	\N	\N	\N	\N	109500	109500	109501
23136	35602	14	applied	\N	\N	\N	\N	109502	109502	109503
23136	35607	15	applied	\N	\N	\N	\N	109513	109513	109514
23136	35610	16	applied	\N	\N	\N	\N	109520	109520	109521
23136	35613	17	applied	\N	\N	\N	\N	109529	109529	109530
23136	35614	18	applied	\N	\N	\N	\N	109531	109531	109532
23136	35621	19	applied	\N	\N	\N	\N	109549	109549	109550
23136	35623	20	applied	\N	\N	\N	\N	109554	109554	109555
23136	35628	21	applied	\N	\N	\N	\N	109604	109604	109605
23136	35561	22	applied	\N	\N	\N	\N	109403	109403	109634
23136	35559	23	applied	\N	\N	\N	\N	109398	109398	109394
23136	35562	24	applied	\N	\N	\N	\N	109405	109405	109400
23136	35566	25	applied	\N	\N	\N	\N	109414	109414	109635
23136	35568	26	applied	\N	\N	\N	\N	109418	109418	109636
23136	35626	27	applied	\N	\N	\N	\N	109560	109560	109561
23136	35598	28	applied	\N	\N	\N	\N	109492	109492	109493
23136	35575	29	applied	\N	\N	\N	\N	109436	109436	109637
23136	35585	30	applied	\N	\N	\N	\N	109464	109464	109408
23136	35557	31	applied	\N	\N	\N	\N	109393	109393	109413
23136	35563	32	applied	\N	\N	\N	\N	109407	109407	109638
23136	35565	33	applied	\N	\N	\N	\N	109412	109412	109639
23136	35569	34	applied	\N	\N	\N	\N	109420	109420	109640
23136	35571	35	applied	\N	\N	\N	\N	109426	109426	109429
23136	35574	36	applied	\N	\N	\N	\N	109434	109434	109435
23136	35578	37	applied	\N	\N	\N	\N	109446	109446	109439
23136	35582	38	applied	\N	\N	\N	\N	109456	109456	109447
23136	35584	39	applied	\N	\N	\N	\N	109462	109462	109641
23136	35590	40	applied	\N	\N	\N	\N	109475	109475	109642
23136	35627	41	applied	\N	\N	\N	\N	109562	109562	109563
23136	35631	42	applied	\N	\N	\N	\N	109610	109610	109611
23136	35632	43	applied	\N	\N	\N	\N	109613	109613	109614
23136	35572	44	applied	\N	\N	\N	\N	109428	109428	109643
23136	35593	45	applied	\N	\N	\N	\N	109481	109481	109644
23136	35609	46	applied	\N	\N	\N	\N	109517	109517	109463
23136	35615	47	applied	\N	\N	\N	\N	109533	109533	109465
23136	35595	48	applied	\N	\N	\N	\N	109485	109485	109645
23136	35596	49	applied	\N	\N	\N	\N	109487	109487	109646
23136	35576	50	applied	\N	\N	\N	\N	109438	109438	109647
23136	35579	51	applied	\N	\N	\N	\N	109448	109448	109482
23136	35581	52	applied	\N	\N	\N	\N	109454	109454	109484
23136	35586	53	applied	\N	\N	\N	\N	109466	109466	109648
23136	35591	54	applied	\N	\N	\N	\N	109477	109477	109649
23136	35592	55	applied	\N	\N	\N	\N	109479	109479	109488
23136	35594	56	applied	\N	\N	\N	\N	109483	109483	109495
23136	35599	57	applied	\N	\N	\N	\N	109494	109494	109650
23136	35603	58	applied	\N	\N	\N	\N	109504	109504	109651
23136	35605	59	applied	\N	\N	\N	\N	109508	109508	109652
23136	35611	60	applied	\N	\N	\N	\N	109522	109522	109507
23136	35617	61	applied	\N	\N	\N	\N	109537	109537	109509
23136	35618	62	applied	\N	\N	\N	\N	109539	109539	109653
23136	35620	63	applied	\N	\N	\N	\N	109545	109545	109654
23136	35624	64	applied	\N	\N	\N	\N	109556	109556	109516
23136	35633	65	applied	\N	\N	\N	\N	109615	109615	109655
23136	35600	66	applied	\N	\N	\N	\N	109496	109496	109656
23136	35604	67	applied	\N	\N	\N	\N	109506	109506	109657
23136	35606	68	applied	\N	\N	\N	\N	109510	109510	109658
23136	35608	69	applied	\N	\N	\N	\N	109515	109515	109540
23136	35612	70	applied	\N	\N	\N	\N	109524	109524	109542
23136	35616	71	applied	\N	\N	\N	\N	109535	109535	109659
23136	35619	72	applied	\N	\N	\N	\N	109541	109541	109660
23136	35622	73	applied	\N	\N	\N	\N	109551	109551	109661
23130	35155	51	applied	\N	\N	\N	\N	108153	108153	108146
23130	35156	52	applied	\N	\N	\N	\N	108155	108155	108196
23130	35159	53	applied	\N	\N	\N	\N	108162	108162	108152
23130	35164	54	applied	\N	\N	\N	\N	108173	108173	108154
23130	35168	55	applied	\N	\N	\N	\N	108186	108186	108156
23130	35172	56	applied	\N	\N	\N	\N	108206	108206	108201
23130	35175	57	applied	\N	\N	\N	\N	108217	108217	108165
23130	35178	58	applied	\N	\N	\N	\N	108234	108234	108177
23130	35181	59	applied	\N	\N	\N	\N	108258	108258	108203
23130	35184	60	applied	\N	\N	\N	\N	108275	108275	108204
23130	35188	61	applied	\N	\N	\N	\N	108291	108291	108205
23130	35191	62	applied	\N	\N	\N	\N	108298	108298	108207
23130	35195	63	applied	\N	\N	\N	\N	108330	108330	108223
23130	35199	64	applied	\N	\N	\N	\N	108338	108338	108220
23130	35210	65	applied	\N	\N	\N	\N	108363	108363	108235
23130	35211	66	applied	\N	\N	\N	\N	108365	108365	108320
23130	35212	67	applied	\N	\N	\N	\N	108367	108367	108410
23130	35216	68	applied	\N	\N	\N	\N	108377	108377	108321
23130	35224	69	applied	\N	\N	\N	\N	108401	108401	108411
23130	35225	70	applied	\N	\N	\N	\N	108403	108403	108322
23130	35228	71	applied	\N	\N	\N	\N	108429	108429	108294
23130	35231	72	applied	\N	\N	\N	\N	108438	108438	108299
23130	35406	73	applied	\N	\N	\N	\N	108974	108974	108412
23130	35413	74	applied	\N	\N	\N	\N	108992	108992	108301
23130	35422	75	applied	\N	\N	\N	\N	109019	109019	108413
23130	35433	76	applied	\N	\N	\N	\N	109045	109045	109577
23130	35443	77	applied	\N	\N	\N	\N	109072	109072	108331
23130	35454	78	applied	\N	\N	\N	\N	109101	109101	108414
23130	35464	79	applied	\N	\N	\N	\N	109132	109132	108333
23130	35477	80	applied	\N	\N	\N	\N	109167	109167	109578
23130	35486	81	applied	\N	\N	\N	\N	109192	109192	108335
23130	35498	82	applied	\N	\N	\N	\N	109224	109224	109579
23130	35506	83	applied	\N	\N	\N	\N	109243	109243	109580
23130	35523	84	applied	\N	\N	\N	\N	109295	109295	108339
23130	35529	85	applied	\N	\N	\N	\N	109316	109316	108341
23130	35540	86	applied	\N	\N	\N	\N	109348	109348	108352
23130	35550	87	applied	\N	\N	\N	\N	109375	109375	108415
23130	35561	88	applied	\N	\N	\N	\N	109403	109403	108354
23130	35575	89	applied	\N	\N	\N	\N	109436	109436	108416
23130	35585	90	applied	\N	\N	\N	\N	109464	109464	108356
23130	35593	91	applied	\N	\N	\N	\N	109481	109481	108417
23130	35609	92	applied	\N	\N	\N	\N	109517	109517	108358
23130	35615	93	applied	\N	\N	\N	\N	109533	109533	108418
23130	35246	94	applied	\N	\N	\N	\N	108478	108478	108443
23130	35247	95	applied	\N	\N	\N	\N	108480	108480	108420
23130	35248	96	applied	\N	\N	\N	\N	108482	108482	108444
23130	35249	97	applied	\N	\N	\N	\N	108484	108484	108422
23130	35250	98	applied	\N	\N	\N	\N	108486	108486	108395
23130	35252	99	applied	\N	\N	\N	\N	108491	108491	108399
23130	35257	100	applied	\N	\N	\N	\N	108505	108505	108402
23130	35260	101	applied	\N	\N	\N	\N	108519	108519	108404
23130	35266	102	applied	\N	\N	\N	\N	108535	108535	109581
23130	35267	103	applied	\N	\N	\N	\N	108537	108537	109582
23130	35269	104	applied	\N	\N	\N	\N	108542	108542	108891
23130	35273	105	applied	\N	\N	\N	\N	108555	108555	108467
23130	35275	106	applied	\N	\N	\N	\N	108563	108563	109583
23130	35285	107	applied	\N	\N	\N	\N	108644	108644	108473
23130	35311	108	applied	\N	\N	\N	\N	108717	108717	109584
23130	35314	109	applied	\N	\N	\N	\N	108725	108725	109585
23130	35318	110	applied	\N	\N	\N	\N	108734	108734	109586
23130	35319	111	applied	\N	\N	\N	\N	108736	108736	109587
23130	35326	112	applied	\N	\N	\N	\N	108752	108752	109588
23130	35327	113	applied	\N	\N	\N	\N	108754	108754	109589
23130	35334	114	applied	\N	\N	\N	\N	108768	108768	109590
23130	35335	115	applied	\N	\N	\N	\N	108770	108770	108496
23130	35337	116	applied	\N	\N	\N	\N	108775	108775	109591
23130	35340	117	applied	\N	\N	\N	\N	108785	108785	109592
23130	35343	118	applied	\N	\N	\N	\N	108799	108799	109593
23130	35348	119	applied	\N	\N	\N	\N	108811	108811	109594
23130	35350	120	applied	\N	\N	\N	\N	108817	108817	108534
23130	35357	123	applied	\N	\N	\N	\N	108837	108837	108536
23130	35358	124	applied	\N	\N	\N	\N	108839	108839	108538
23135	35628	0	applied	\N	\N	\N	\N	109604	109604	109605
23135	35629	1	applied	\N	\N	\N	\N	109606	109606	109607
23135	35630	2	applied	\N	\N	\N	\N	109608	109608	109609
23135	35631	3	applied	\N	\N	\N	\N	109610	109610	109611
23135	35632	5	applied	\N	\N	\N	\N	109613	109613	109614
23135	35633	6	applied	\N	\N	\N	\N	109615	109615	109616
23135	35635	7	applied	\N	\N	\N	\N	109624	109624	109631
23141	35643	0	applied	\N	\N	\N	\N	109681	109681	109682
23141	35644	1	applied	\N	\N	\N	\N	109683	109683	109684
23141	35645	2	applied	\N	\N	\N	\N	109685	109685	109686
23141	35646	3	applied	\N	\N	\N	\N	109687	109687	109688
23141	35647	4	applied	\N	\N	\N	\N	109689	109689	109690
23141	35648	5	applied	\N	\N	\N	\N	109691	109691	109692
23141	35649	6	applied	\N	\N	\N	\N	109693	109693	109694
23149	35673	0	applied	\N	\N	\N	\N	109754	109754	109755
23149	35674	1	applied	\N	\N	\N	\N	109756	109756	109757
23149	35675	2	applied	\N	\N	\N	\N	109758	109758	109759
23159	35680	0	applied	\N	\N	\N	\N	109784	109784	109785
23159	35682	1	applied	\N	\N	\N	\N	109814	109814	109815
23159	35683	2	applied	\N	\N	\N	\N	109816	109816	109817
23159	35681	3	applied	\N	\N	\N	\N	109786	109786	109787
23159	35684	4	applied	\N	\N	\N	\N	109818	109818	109819
23159	35685	5	applied	\N	\N	\N	\N	109820	109820	109821
23159	35686	6	applied	\N	\N	\N	\N	109822	109822	109823
23160	35687	0	applied	\N	\N	\N	\N	109827	109827	109828
23160	35688	1	applied	\N	\N	\N	\N	109829	109829	109830
23166	35698	0	applied	\N	\N	\N	\N	109858	109858	109859
23166	35699	1	applied	\N	\N	\N	\N	109860	109860	109861
23171	35700	0	applied	\N	\N	\N	\N	109865	109865	109866
23171	35701	1	applied	\N	\N	\N	\N	109867	109867	109868
23171	35702	2	applied	\N	\N	\N	\N	109869	109869	109870
23176	35705	0	applied	\N	\N	\N	\N	109945	109945	109946
23176	35706	1	applied	\N	\N	\N	\N	109947	109947	109948
23176	35708	2	applied	\N	\N	\N	\N	109953	109953	109954
23176	35707	3	applied	\N	\N	\N	\N	109949	109949	109955
23176	35709	4	applied	\N	\N	\N	\N	109956	109956	109957
23177	35710	0	applied	\N	\N	\N	\N	109959	109959	109960
23177	35708	1	applied	\N	\N	\N	\N	109953	109953	109955
23177	35709	2	applied	\N	\N	\N	\N	109956	109956	109957
23177	35711	3	applied	\N	\N	\N	\N	109961	109961	109962
23180	35714	0	applied	\N	\N	\N	\N	109970	109970	109971
23180	35715	1	applied	\N	\N	\N	\N	109972	109972	109973
23180	35717	2	applied	\N	\N	\N	\N	109989	109989	109990
23180	35718	3	applied	\N	\N	\N	\N	109991	109991	109992
23180	35719	5	applied	\N	\N	\N	\N	109994	109994	109995
23180	35716	6	applied	\N	\N	\N	\N	109980	109980	109996
23180	35720	7	applied	\N	\N	\N	\N	109997	109997	109998
23184	34946	0	applied	\N	\N	\N	\N	107549	107549	107550
23136	35625	74	applied	\N	\N	\N	\N	109558	109558	109662
23136	35634	75	applied	\N	\N	\N	\N	109621	109621	109631
23137	35637	0	applied	\N	\N	\N	\N	109665	109665	109666
23137	35638	1	applied	\N	\N	\N	\N	109667	109667	109668
23137	35634	2	applied	\N	\N	\N	\N	109621	109621	109623
23137	35635	3	applied	\N	\N	\N	\N	109624	109624	109625
23137	35639	4	applied	\N	\N	\N	\N	109669	109669	109670
23137	35640	5	applied	\N	\N	\N	\N	109671	109671	109672
23137	35636	6	applied	\N	\N	\N	\N	109626	109626	109673
23137	35641	7	applied	\N	\N	\N	\N	109674	109674	109675
23137	35642	8	applied	\N	\N	\N	\N	109676	109676	109677
23142	35643	0	applied	\N	\N	\N	\N	109681	109681	109682
23142	35644	1	applied	\N	\N	\N	\N	109683	109683	109684
23142	35645	2	applied	\N	\N	\N	\N	109685	109685	109686
23142	35646	3	applied	\N	\N	\N	\N	109687	109687	109688
23142	35647	4	applied	\N	\N	\N	\N	109689	109689	109690
23142	35648	5	applied	\N	\N	\N	\N	109691	109691	109692
23142	35649	6	applied	\N	\N	\N	\N	109693	109693	109694
23143	35650	0	applied	\N	\N	\N	\N	109701	109701	109702
23143	35651	1	applied	\N	\N	\N	\N	109703	109703	109704
23143	35652	2	applied	\N	\N	\N	\N	109705	109705	109706
23150	35673	0	applied	\N	\N	\N	\N	109754	109754	109755
23150	35674	1	applied	\N	\N	\N	\N	109756	109756	109757
23150	35675	2	applied	\N	\N	\N	\N	109758	109758	109759
23155	35680	0	applied	\N	\N	\N	\N	109784	109784	109785
23155	35681	1	applied	\N	\N	\N	\N	109786	109786	109787
23161	35687	0	applied	\N	\N	\N	\N	109827	109827	109828
23161	35688	1	applied	\N	\N	\N	\N	109829	109829	109830
23162	35689	0	applied	\N	\N	\N	\N	109834	109834	109835
23162	35690	1	applied	\N	\N	\N	\N	109836	109836	109837
23162	35691	2	applied	\N	\N	\N	\N	109838	109838	109839
23162	35692	3	applied	\N	\N	\N	\N	109840	109840	109841
23162	35693	4	applied	\N	\N	\N	\N	109842	109842	109843
23167	35698	0	applied	\N	\N	\N	\N	109858	109858	109859
23167	35699	1	applied	\N	\N	\N	\N	109860	109860	109861
23172	35700	0	applied	\N	\N	\N	\N	109865	109865	109866
23172	35701	1	applied	\N	\N	\N	\N	109867	109867	109868
23172	35702	2	applied	\N	\N	\N	\N	109869	109869	109870
23178	35712	0	applied	\N	\N	\N	\N	109964	109964	109965
23178	35713	1	applied	\N	\N	\N	\N	109966	109966	109967
23179	35564	0	applied	\N	\N	\N	\N	109410	109410	109411
23179	35567	1	applied	\N	\N	\N	\N	109416	109416	109417
23179	35570	2	applied	\N	\N	\N	\N	109424	109424	109425
23179	35573	3	applied	\N	\N	\N	\N	109432	109432	109433
23179	35577	4	applied	\N	\N	\N	\N	109444	109444	109445
23179	35580	5	applied	\N	\N	\N	\N	109452	109452	109453
23179	35583	6	applied	\N	\N	\N	\N	109460	109460	109461
23179	35587	7	applied	\N	\N	\N	\N	109469	109469	109470
23179	35588	8	applied	\N	\N	\N	\N	109471	109471	109472
23179	35589	9	applied	\N	\N	\N	\N	109473	109473	109474
23179	35597	10	applied	\N	\N	\N	\N	109490	109490	109491
23179	35601	11	applied	\N	\N	\N	\N	109500	109500	109501
23179	35602	12	applied	\N	\N	\N	\N	109502	109502	109503
23179	35607	13	applied	\N	\N	\N	\N	109513	109513	109514
23179	35610	14	applied	\N	\N	\N	\N	109520	109520	109521
23179	35613	15	applied	\N	\N	\N	\N	109529	109529	109530
23179	35614	16	applied	\N	\N	\N	\N	109531	109531	109532
23179	35621	17	applied	\N	\N	\N	\N	109549	109549	109550
23179	35623	18	applied	\N	\N	\N	\N	109554	109554	109555
23179	35628	19	applied	\N	\N	\N	\N	109604	109604	109605
23179	35629	20	applied	\N	\N	\N	\N	109606	109606	109607
23179	35637	21	applied	\N	\N	\N	\N	109665	109665	109666
23179	35638	22	applied	\N	\N	\N	\N	109667	109667	109668
23179	35643	23	applied	\N	\N	\N	\N	109681	109681	109682
23179	35644	24	applied	\N	\N	\N	\N	109683	109683	109684
23179	35650	25	applied	\N	\N	\N	\N	109701	109701	109702
23179	35653	26	applied	\N	\N	\N	\N	109708	109708	109709
23179	35657	27	applied	\N	\N	\N	\N	109718	109718	109719
23179	35660	28	applied	\N	\N	\N	\N	109726	109726	109727
23179	35663	29	applied	\N	\N	\N	\N	109732	109732	109733
23179	35664	30	applied	\N	\N	\N	\N	109734	109734	109735
23179	35665	31	applied	\N	\N	\N	\N	109736	109736	109737
23179	35673	32	applied	\N	\N	\N	\N	109754	109754	109755
23179	35676	33	applied	\N	\N	\N	\N	109772	109772	109773
23179	35680	34	applied	\N	\N	\N	\N	109784	109784	109785
23179	35682	35	applied	\N	\N	\N	\N	109814	109814	109815
23179	35683	36	applied	\N	\N	\N	\N	109816	109816	109817
23179	35687	37	applied	\N	\N	\N	\N	109827	109827	109828
23179	35689	38	applied	\N	\N	\N	\N	109834	109834	109835
23179	35690	39	applied	\N	\N	\N	\N	109836	109836	109837
23179	35694	40	applied	\N	\N	\N	\N	109847	109847	109848
23179	35695	41	applied	\N	\N	\N	\N	109849	109849	109850
23179	35698	42	applied	\N	\N	\N	\N	109858	109858	109859
23179	35700	43	applied	\N	\N	\N	\N	109865	109865	109866
23179	35703	44	applied	\N	\N	\N	\N	109877	109877	109878
23179	35705	45	applied	\N	\N	\N	\N	109945	109945	109946
23179	35706	46	applied	\N	\N	\N	\N	109947	109947	109948
23179	35710	47	applied	\N	\N	\N	\N	109959	109959	109960
23179	35712	48	applied	\N	\N	\N	\N	109964	109964	109965
23179	35714	49	applied	\N	\N	\N	\N	109970	109970	109971
23179	35715	50	applied	\N	\N	\N	\N	109972	109972	109973
23179	35565	51	applied	\N	\N	\N	\N	109412	109412	109413
23179	35569	52	applied	\N	\N	\N	\N	109420	109420	109638
23179	35566	53	applied	\N	\N	\N	\N	109414	109414	109974
23179	35568	54	applied	\N	\N	\N	\N	109418	109418	109421
23179	35626	55	applied	\N	\N	\N	\N	109560	109560	109561
23179	35598	56	applied	\N	\N	\N	\N	109492	109492	109493
23179	35571	57	applied	\N	\N	\N	\N	109426	109426	109427
23179	35574	58	applied	\N	\N	\N	\N	109434	109434	109975
23179	35578	59	applied	\N	\N	\N	\N	109446	109446	109437
23179	35575	60	applied	\N	\N	\N	\N	109436	109436	109976
23179	35585	61	applied	\N	\N	\N	\N	109464	109464	109439
23179	35582	62	applied	\N	\N	\N	\N	109456	109456	109447
23179	35584	63	applied	\N	\N	\N	\N	109462	109462	109641
23179	35590	64	applied	\N	\N	\N	\N	109475	109475	109642
23179	35627	65	applied	\N	\N	\N	\N	109562	109562	109563
23179	35631	66	applied	\N	\N	\N	\N	109610	109610	109611
23179	35632	67	applied	\N	\N	\N	\N	109613	109613	109614
23179	35572	68	applied	\N	\N	\N	\N	109428	109428	109643
23179	35593	69	applied	\N	\N	\N	\N	109481	109481	109644
23179	35609	70	applied	\N	\N	\N	\N	109517	109517	109463
23179	35615	71	applied	\N	\N	\N	\N	109533	109533	109465
23179	35630	72	applied	\N	\N	\N	\N	109608	109608	109977
23179	35645	73	applied	\N	\N	\N	\N	109685	109685	109467
23179	35595	74	applied	\N	\N	\N	\N	109485	109485	109476
23179	35596	75	applied	\N	\N	\N	\N	109487	109487	109647
23179	35656	76	applied	\N	\N	\N	\N	109714	109714	109480
23179	35666	77	applied	\N	\N	\N	\N	109738	109738	109482
23179	35679	78	applied	\N	\N	\N	\N	109778	109778	109978
23179	35684	79	applied	\N	\N	\N	\N	109818	109818	109484
23151	35336	10	applied	\N	\N	\N	\N	108773	108773	108774
23151	35339	11	applied	\N	\N	\N	\N	108783	108783	108784
23151	35342	12	applied	\N	\N	\N	\N	108797	108797	108798
23151	35345	13	applied	\N	\N	\N	\N	108805	108805	108806
23151	35349	14	applied	\N	\N	\N	\N	108815	108815	108816
23151	35352	15	applied	\N	\N	\N	\N	108828	108828	108829
23151	35353	16	applied	\N	\N	\N	\N	108830	108830	108831
23151	35359	17	applied	\N	\N	\N	\N	108848	108848	108849
23151	35362	18	applied	\N	\N	\N	\N	108857	108857	108858
23151	35363	19	applied	\N	\N	\N	\N	108859	108859	108860
23151	35364	20	applied	\N	\N	\N	\N	108861	108861	108862
23151	35365	21	applied	\N	\N	\N	\N	108863	108863	108864
23151	35375	22	applied	\N	\N	\N	\N	108888	108888	108889
23151	35378	23	applied	\N	\N	\N	\N	108908	108908	108909
23151	35381	24	applied	\N	\N	\N	\N	108918	108918	108919
23151	35382	25	applied	\N	\N	\N	\N	108920	108920	108921
23151	35387	26	applied	\N	\N	\N	\N	108932	108932	108933
23151	35388	27	applied	\N	\N	\N	\N	108934	108934	108935
23151	35389	28	applied	\N	\N	\N	\N	108936	108936	108937
23151	35397	29	applied	\N	\N	\N	\N	108956	108956	108957
23151	35398	30	applied	\N	\N	\N	\N	108958	108958	108959
23151	35399	31	applied	\N	\N	\N	\N	108960	108960	108961
23151	35407	32	applied	\N	\N	\N	\N	108980	108980	108981
23151	35408	33	applied	\N	\N	\N	\N	108982	108982	108983
23151	35414	34	applied	\N	\N	\N	\N	108997	108997	108998
23151	35417	35	applied	\N	\N	\N	\N	109006	109006	109007
23151	35420	36	applied	\N	\N	\N	\N	109015	109015	109016
23151	35424	37	applied	\N	\N	\N	\N	109025	109025	109026
23151	35427	38	applied	\N	\N	\N	\N	109033	109033	109034
23151	35428	39	applied	\N	\N	\N	\N	109035	109035	109036
23151	35434	40	applied	\N	\N	\N	\N	109050	109050	109051
23151	35439	41	applied	\N	\N	\N	\N	109064	109064	109065
23151	35440	42	applied	\N	\N	\N	\N	109066	109066	109067
23151	35446	43	applied	\N	\N	\N	\N	109081	109081	109082
23151	35449	44	applied	\N	\N	\N	\N	109088	109088	109089
23151	35452	45	applied	\N	\N	\N	\N	109097	109097	109098
23151	35456	46	applied	\N	\N	\N	\N	109112	109112	109113
23151	35457	47	applied	\N	\N	\N	\N	109114	109114	109115
23151	35462	48	applied	\N	\N	\N	\N	109128	109128	109129
23151	35466	49	applied	\N	\N	\N	\N	109140	109140	109141
23151	35467	50	applied	\N	\N	\N	\N	109142	109142	109143
23151	35472	51	applied	\N	\N	\N	\N	109156	109156	109157
23151	35475	52	applied	\N	\N	\N	\N	109163	109163	109164
23151	35479	53	applied	\N	\N	\N	\N	109174	109174	109175
23151	35482	54	applied	\N	\N	\N	\N	109183	109183	109184
23151	35484	55	applied	\N	\N	\N	\N	109188	109188	109189
23151	35489	56	applied	\N	\N	\N	\N	109204	109204	109205
23151	35492	57	applied	\N	\N	\N	\N	109212	109212	109213
23151	35495	58	applied	\N	\N	\N	\N	109218	109218	109219
23151	35499	59	applied	\N	\N	\N	\N	109227	109227	109228
23151	35502	60	applied	\N	\N	\N	\N	109235	109235	109236
23151	35503	61	applied	\N	\N	\N	\N	109237	109237	109238
23151	35504	62	applied	\N	\N	\N	\N	109239	109239	109240
23151	35512	63	applied	\N	\N	\N	\N	109257	109257	109258
23151	35515	64	applied	\N	\N	\N	\N	109266	109266	109267
23151	35516	65	applied	\N	\N	\N	\N	109268	109268	109269
23151	35517	66	applied	\N	\N	\N	\N	109270	109270	109271
23151	35518	67	applied	\N	\N	\N	\N	109272	109272	109273
23151	35528	68	applied	\N	\N	\N	\N	109314	109314	109315
23151	35532	69	applied	\N	\N	\N	\N	109330	109330	109331
23151	35535	70	applied	\N	\N	\N	\N	109336	109336	109337
23151	35538	71	applied	\N	\N	\N	\N	109344	109344	109345
23151	35539	72	applied	\N	\N	\N	\N	109346	109346	109347
23151	35545	73	applied	\N	\N	\N	\N	109362	109362	109363
23151	35548	74	applied	\N	\N	\N	\N	109371	109371	109372
23151	35549	75	applied	\N	\N	\N	\N	109373	109373	109374
23151	35554	76	applied	\N	\N	\N	\N	109385	109385	109386
23151	35558	77	applied	\N	\N	\N	\N	109396	109396	109397
23151	35560	78	applied	\N	\N	\N	\N	109401	109401	109402
23151	35564	79	applied	\N	\N	\N	\N	109410	109410	109411
23151	35567	80	applied	\N	\N	\N	\N	109416	109416	109417
23151	35570	82	applied	\N	\N	\N	\N	109424	109424	109425
23151	35573	83	applied	\N	\N	\N	\N	109432	109432	109433
23151	35577	84	applied	\N	\N	\N	\N	109444	109444	109445
23151	35580	85	applied	\N	\N	\N	\N	109452	109452	109453
23151	35583	86	applied	\N	\N	\N	\N	109460	109460	109461
23151	35587	87	applied	\N	\N	\N	\N	109469	109469	109470
23151	35588	88	applied	\N	\N	\N	\N	109471	109471	109472
23151	35589	89	applied	\N	\N	\N	\N	109473	109473	109474
23151	35597	90	applied	\N	\N	\N	\N	109490	109490	109491
23151	35601	91	applied	\N	\N	\N	\N	109500	109500	109501
23151	35602	92	applied	\N	\N	\N	\N	109502	109502	109503
23151	35607	93	applied	\N	\N	\N	\N	109513	109513	109514
23151	35610	94	applied	\N	\N	\N	\N	109520	109520	109521
23151	35613	95	applied	\N	\N	\N	\N	109529	109529	109530
23151	35614	96	applied	\N	\N	\N	\N	109531	109531	109532
23151	35621	97	applied	\N	\N	\N	\N	109549	109549	109550
23151	35623	98	applied	\N	\N	\N	\N	109554	109554	109555
23151	35628	99	applied	\N	\N	\N	\N	109604	109604	109605
23151	35629	100	applied	\N	\N	\N	\N	109606	109606	109607
23151	35637	101	applied	\N	\N	\N	\N	109665	109665	109666
23151	35638	102	applied	\N	\N	\N	\N	109667	109667	109668
23151	35643	103	applied	\N	\N	\N	\N	109681	109681	109682
23151	35644	104	applied	\N	\N	\N	\N	109683	109683	109684
23151	35650	105	applied	\N	\N	\N	\N	109701	109701	109702
23151	35653	106	applied	\N	\N	\N	\N	109708	109708	109709
23151	35657	107	applied	\N	\N	\N	\N	109718	109718	109719
23151	35660	108	applied	\N	\N	\N	\N	109726	109726	109727
23151	35663	109	applied	\N	\N	\N	\N	109732	109732	109733
23151	35664	110	applied	\N	\N	\N	\N	109734	109734	109735
23151	35665	111	applied	\N	\N	\N	\N	109736	109736	109737
23151	35673	112	applied	\N	\N	\N	\N	109754	109754	109755
23151	35315	113	applied	\N	\N	\N	\N	108727	108727	109765
23151	35328	114	applied	\N	\N	\N	\N	108756	108756	108707
23151	35626	115	applied	\N	\N	\N	\N	109560	109560	109561
23151	35598	116	applied	\N	\N	\N	\N	109492	109492	109493
23151	35329	117	applied	\N	\N	\N	\N	108758	108758	109766
23151	35346	118	applied	\N	\N	\N	\N	108807	108807	108709
23151	35354	119	applied	\N	\N	\N	\N	108832	108832	109767
23151	35367	120	applied	\N	\N	\N	\N	108867	108867	108716
23151	35380	121	applied	\N	\N	\N	\N	108914	108914	109768
23151	35392	122	applied	\N	\N	\N	\N	108942	108942	109769
23151	35627	123	applied	\N	\N	\N	\N	109562	109562	109563
23151	35631	124	applied	\N	\N	\N	\N	109610	109610	109611
23151	35632	125	applied	\N	\N	\N	\N	109613	109613	109614
23152	35676	0	applied	\N	\N	\N	\N	109772	109772	109773
23152	35677	1	applied	\N	\N	\N	\N	109774	109774	109775
23152	35678	2	applied	\N	\N	\N	\N	109776	109776	109777
23152	35679	3	applied	\N	\N	\N	\N	109778	109778	109779
23156	35629	0	applied	\N	\N	\N	\N	109606	109606	109607
23156	35637	1	applied	\N	\N	\N	\N	109665	109665	109666
23156	35638	2	applied	\N	\N	\N	\N	109667	109667	109668
23156	35643	3	applied	\N	\N	\N	\N	109681	109681	109682
23156	35644	4	applied	\N	\N	\N	\N	109683	109683	109684
23156	35650	5	applied	\N	\N	\N	\N	109701	109701	109702
23156	35653	6	applied	\N	\N	\N	\N	109708	109708	109709
23156	35657	7	applied	\N	\N	\N	\N	109718	109718	109719
23156	35660	8	applied	\N	\N	\N	\N	109726	109726	109727
23156	35663	9	applied	\N	\N	\N	\N	109732	109732	109733
23156	35664	10	applied	\N	\N	\N	\N	109734	109734	109735
23156	35665	11	applied	\N	\N	\N	\N	109736	109736	109737
23156	35673	12	applied	\N	\N	\N	\N	109754	109754	109755
23156	35676	13	applied	\N	\N	\N	\N	109772	109772	109773
23156	35630	14	applied	\N	\N	\N	\N	109608	109608	109623
23156	35645	15	applied	\N	\N	\N	\N	109685	109685	109790
23156	35635	16	applied	\N	\N	\N	\N	109624	109624	109791
23156	35639	17	applied	\N	\N	\N	\N	109669	109669	109627
23156	35640	18	applied	\N	\N	\N	\N	109671	109671	109792
23156	35646	19	applied	\N	\N	\N	\N	109687	109687	109673
23156	35647	20	applied	\N	\N	\N	\N	109689	109689	109793
23156	35652	21	applied	\N	\N	\N	\N	109705	109705	109794
23156	35655	22	applied	\N	\N	\N	\N	109712	109712	109677
23156	35658	23	applied	\N	\N	\N	\N	109720	109720	109795
23156	35662	24	applied	\N	\N	\N	\N	109730	109730	109796
23156	35667	25	applied	\N	\N	\N	\N	109740	109740	109797
23156	35668	26	applied	\N	\N	\N	\N	109742	109742	109692
23156	35670	27	applied	\N	\N	\N	\N	109746	109746	109798
23156	35636	28	applied	\N	\N	\N	\N	109626	109626	109799
23156	35641	29	applied	\N	\N	\N	\N	109674	109674	109706
23156	35642	30	applied	\N	\N	\N	\N	109676	109676	109711
23156	35648	32	applied	\N	\N	\N	\N	109691	109691	109715
23156	35649	33	applied	\N	\N	\N	\N	109693	109693	109801
23156	35651	34	applied	\N	\N	\N	\N	109703	109703	109802
23156	35654	35	applied	\N	\N	\N	\N	109710	109710	109803
23156	35659	36	applied	\N	\N	\N	\N	109722	109722	109804
23156	35661	37	applied	\N	\N	\N	\N	109728	109728	109743
23156	35669	38	applied	\N	\N	\N	\N	109744	109744	109745
23156	35671	39	applied	\N	\N	\N	\N	109748	109748	109805
23156	35672	40	applied	\N	\N	\N	\N	109750	109750	109806
23156	35674	41	applied	\N	\N	\N	\N	109756	109756	109807
23156	35678	42	applied	\N	\N	\N	\N	109776	109776	109808
23156	35656	43	applied	\N	\N	\N	\N	109714	109714	109759
23156	35666	44	applied	\N	\N	\N	\N	109738	109738	109809
23156	35679	45	applied	\N	\N	\N	\N	109778	109778	109775
23156	35675	46	applied	\N	\N	\N	\N	109758	109758	109810
23156	35677	47	applied	\N	\N	\N	\N	109774	109774	109779
23163	35689	0	applied	\N	\N	\N	\N	109834	109834	109835
23163	35690	1	applied	\N	\N	\N	\N	109836	109836	109837
23163	35691	2	applied	\N	\N	\N	\N	109838	109838	109839
23163	35692	3	applied	\N	\N	\N	\N	109840	109840	109841
23163	35693	4	applied	\N	\N	\N	\N	109842	109842	109843
23164	35694	0	applied	\N	\N	\N	\N	109847	109847	109848
23164	35695	1	applied	\N	\N	\N	\N	109849	109849	109850
23164	35696	2	applied	\N	\N	\N	\N	109851	109851	109852
23164	35697	3	applied	\N	\N	\N	\N	109853	109853	109854
23168	35698	0	applied	\N	\N	\N	\N	109858	109858	109859
23168	35699	1	applied	\N	\N	\N	\N	109860	109860	109861
23169	35700	0	applied	\N	\N	\N	\N	109865	109865	109866
23169	35701	1	applied	\N	\N	\N	\N	109867	109867	109868
23169	35702	2	applied	\N	\N	\N	\N	109869	109869	109870
23173	35703	0	applied	\N	\N	\N	\N	109877	109877	109878
23173	35704	1	applied	\N	\N	\N	\N	109879	109879	109880
23182	35714	0	applied	\N	\N	\N	\N	109970	109970	109971
23182	35715	1	applied	\N	\N	\N	\N	109972	109972	109973
23182	35717	2	applied	\N	\N	\N	\N	109989	109989	109990
23182	35718	3	applied	\N	\N	\N	\N	109991	109991	109992
23182	35719	5	applied	\N	\N	\N	\N	109994	109994	109995
23182	35721	6	applied	\N	\N	\N	\N	110003	110003	110004
23182	35722	7	applied	\N	\N	\N	\N	110005	110005	110006
23182	35723	8	applied	\N	\N	\N	\N	110007	110007	110008
23182	35724	9	applied	\N	\N	\N	\N	110009	110009	110010
23182	35725	10	applied	\N	\N	\N	\N	110011	110011	110012
23182	35716	11	applied	\N	\N	\N	\N	109980	109980	110013
23182	35720	12	applied	\N	\N	\N	\N	109997	109997	110014
23174	35113	20	applied	\N	\N	\N	\N	108039	108039	108583
23174	35116	21	applied	\N	\N	\N	\N	108048	108048	108584
23174	35121	22	applied	\N	\N	\N	\N	108072	108072	108585
23174	35123	23	applied	\N	\N	\N	\N	108079	108079	108586
23174	35126	24	applied	\N	\N	\N	\N	108087	108087	108587
23174	35127	25	applied	\N	\N	\N	\N	108089	108089	108588
23174	35128	26	applied	\N	\N	\N	\N	108091	108091	108589
23174	35141	27	applied	\N	\N	\N	\N	108121	108121	108590
23174	35144	28	applied	\N	\N	\N	\N	108130	108130	108591
23174	35147	29	applied	\N	\N	\N	\N	108137	108137	108592
23174	35148	30	applied	\N	\N	\N	\N	108139	108139	108593
23174	35149	31	applied	\N	\N	\N	\N	108141	108141	108594
23174	35157	32	applied	\N	\N	\N	\N	108158	108158	108595
23174	35161	33	applied	\N	\N	\N	\N	108168	108168	108596
23174	35165	34	applied	\N	\N	\N	\N	108181	108181	108597
23174	35169	35	applied	\N	\N	\N	\N	108190	108190	108598
23174	35173	36	applied	\N	\N	\N	\N	108213	108213	108599
23174	35177	37	applied	\N	\N	\N	\N	108232	108232	108600
23174	35180	38	applied	\N	\N	\N	\N	108256	108256	108601
23174	35183	39	applied	\N	\N	\N	\N	108273	108273	108602
23174	35187	40	applied	\N	\N	\N	\N	108289	108289	108603
23174	35190	41	applied	\N	\N	\N	\N	108296	108296	108604
23174	35193	42	applied	\N	\N	\N	\N	108326	108326	108605
23174	35194	43	applied	\N	\N	\N	\N	108328	108328	108606
23174	35201	44	applied	\N	\N	\N	\N	108345	108345	108607
23174	35202	45	applied	\N	\N	\N	\N	108347	108347	108608
23174	35203	46	applied	\N	\N	\N	\N	108349	108349	108609
23174	35215	47	applied	\N	\N	\N	\N	108375	108375	108610
23174	35218	48	applied	\N	\N	\N	\N	108390	108390	108611
23174	35219	49	applied	\N	\N	\N	\N	108392	108392	108612
23174	35226	50	applied	\N	\N	\N	\N	108407	108407	108613
23174	35229	51	applied	\N	\N	\N	\N	108434	108434	108614
23174	35232	52	applied	\N	\N	\N	\N	108450	108450	108615
23174	35233	53	applied	\N	\N	\N	\N	108452	108452	108616
23174	35235	54	applied	\N	\N	\N	\N	108456	108456	108617
23174	35236	55	applied	\N	\N	\N	\N	108458	108458	108618
23174	35237	56	applied	\N	\N	\N	\N	108460	108460	108619
23174	35251	57	applied	\N	\N	\N	\N	108489	108489	108620
23174	35255	58	applied	\N	\N	\N	\N	108501	108501	108621
23174	35258	59	applied	\N	\N	\N	\N	108515	108515	108622
23174	35262	60	applied	\N	\N	\N	\N	108527	108527	108623
23174	35263	61	applied	\N	\N	\N	\N	108529	108529	108624
23174	35268	62	applied	\N	\N	\N	\N	108540	108540	108625
23174	35270	63	applied	\N	\N	\N	\N	108549	108549	108626
23174	35274	64	applied	\N	\N	\N	\N	108561	108561	108627
23174	35277	65	applied	\N	\N	\N	\N	108571	108571	108628
23174	35279	66	applied	\N	\N	\N	\N	108632	108632	109883
23174	35280	68	applied	\N	\N	\N	\N	108634	108634	109885
23174	35281	69	applied	\N	\N	\N	\N	108636	108636	109886
23174	35287	70	applied	\N	\N	\N	\N	108651	108651	109887
23174	35288	71	applied	\N	\N	\N	\N	108653	108653	109888
23174	35289	72	applied	\N	\N	\N	\N	108655	108655	109889
23174	35294	73	applied	\N	\N	\N	\N	108666	108666	109890
23174	35297	74	applied	\N	\N	\N	\N	108679	108679	109891
23174	35298	75	applied	\N	\N	\N	\N	108681	108681	109892
23174	35302	76	applied	\N	\N	\N	\N	108691	108691	109893
23174	35305	77	applied	\N	\N	\N	\N	108702	108702	109894
23174	35306	78	applied	\N	\N	\N	\N	108704	108704	109895
23174	35309	79	applied	\N	\N	\N	\N	108713	108713	109896
23174	35312	80	applied	\N	\N	\N	\N	108721	108721	109897
23174	35316	81	applied	\N	\N	\N	\N	108730	108730	109898
23174	35317	82	applied	\N	\N	\N	\N	108732	108732	109899
23174	35322	83	applied	\N	\N	\N	\N	108744	108744	109900
23174	35323	84	applied	\N	\N	\N	\N	108746	108746	109901
23174	35324	85	applied	\N	\N	\N	\N	108748	108748	109902
23174	35325	86	applied	\N	\N	\N	\N	108750	108750	109903
23174	35336	87	applied	\N	\N	\N	\N	108773	108773	109904
23174	35339	88	applied	\N	\N	\N	\N	108783	108783	109905
23174	35342	89	applied	\N	\N	\N	\N	108797	108797	109906
23174	35345	90	applied	\N	\N	\N	\N	108805	108805	109907
23174	35349	91	applied	\N	\N	\N	\N	108815	108815	109908
23174	35352	92	applied	\N	\N	\N	\N	108828	108828	109909
23174	35353	93	applied	\N	\N	\N	\N	108830	108830	109910
23174	35359	94	applied	\N	\N	\N	\N	108848	108848	109911
23174	35362	95	applied	\N	\N	\N	\N	108857	108857	109912
23174	35363	96	applied	\N	\N	\N	\N	108859	108859	109913
23174	35364	97	applied	\N	\N	\N	\N	108861	108861	109914
23174	35365	98	applied	\N	\N	\N	\N	108863	108863	109915
23174	35375	99	applied	\N	\N	\N	\N	108888	108888	109916
23174	35378	100	applied	\N	\N	\N	\N	108908	108908	109917
23174	35381	101	applied	\N	\N	\N	\N	108918	108918	109918
23174	35382	102	applied	\N	\N	\N	\N	108920	108920	109919
23174	35387	103	applied	\N	\N	\N	\N	108932	108932	109920
23174	35388	104	applied	\N	\N	\N	\N	108934	108934	109921
23174	35389	105	applied	\N	\N	\N	\N	108936	108936	109922
23174	35397	106	applied	\N	\N	\N	\N	108956	108956	109923
23174	35398	107	applied	\N	\N	\N	\N	108958	108958	109924
23174	35399	108	applied	\N	\N	\N	\N	108960	108960	109925
23174	35407	109	applied	\N	\N	\N	\N	108980	108980	109926
23174	35408	110	applied	\N	\N	\N	\N	108982	108982	109927
23174	35414	111	applied	\N	\N	\N	\N	108997	108997	109928
23174	35417	112	applied	\N	\N	\N	\N	109006	109006	109929
23174	35420	113	applied	\N	\N	\N	\N	109015	109015	109930
23174	35424	114	applied	\N	\N	\N	\N	109025	109025	109931
23174	35427	115	applied	\N	\N	\N	\N	109033	109033	109932
23174	35428	116	applied	\N	\N	\N	\N	109035	109035	109933
23174	35434	117	applied	\N	\N	\N	\N	109050	109050	109934
23174	35439	118	applied	\N	\N	\N	\N	109064	109064	109935
23174	35440	119	applied	\N	\N	\N	\N	109066	109066	109936
23174	35446	120	applied	\N	\N	\N	\N	109081	109081	109937
23174	35449	121	applied	\N	\N	\N	\N	109088	109088	109938
23174	35452	122	applied	\N	\N	\N	\N	109097	109097	109939
23174	35456	123	applied	\N	\N	\N	\N	109112	109112	109940
23174	35457	124	applied	\N	\N	\N	\N	109114	109114	109941
23174	35462	125	applied	\N	\N	\N	\N	109128	109128	109942
23175	35705	0	applied	\N	\N	\N	\N	109945	109945	109946
23175	35706	1	applied	\N	\N	\N	\N	109947	109947	109948
23175	35707	2	applied	\N	\N	\N	\N	109949	109949	109950
23183	35714	0	applied	\N	\N	\N	\N	109970	109970	109971
23183	35715	1	applied	\N	\N	\N	\N	109972	109972	109973
23183	35717	2	applied	\N	\N	\N	\N	109989	109989	109990
23183	35718	3	applied	\N	\N	\N	\N	109991	109991	109992
23183	35719	5	applied	\N	\N	\N	\N	109994	109994	109995
23183	35721	6	applied	\N	\N	\N	\N	110003	110003	110004
23183	35722	7	applied	\N	\N	\N	\N	110005	110005	110006
23183	35723	8	applied	\N	\N	\N	\N	110007	110007	110008
23183	35724	9	applied	\N	\N	\N	\N	110009	110009	110010
23183	35725	10	applied	\N	\N	\N	\N	110011	110011	110012
23183	35716	11	applied	\N	\N	\N	\N	109980	109980	110013
23183	35720	12	applied	\N	\N	\N	\N	109997	109997	110014
23179	35691	80	applied	\N	\N	\N	\N	109838	109838	109979
23179	35702	81	applied	\N	\N	\N	\N	109869	109869	109648
23179	35707	82	applied	\N	\N	\N	\N	109949	109949	109486
23179	35716	83	applied	\N	\N	\N	\N	109980	109980	109649
23179	35576	84	applied	\N	\N	\N	\N	109438	109438	109488
23179	35579	85	applied	\N	\N	\N	\N	109448	109448	109495
23179	35581	86	applied	\N	\N	\N	\N	109454	109454	109650
23179	35586	87	applied	\N	\N	\N	\N	109466	109466	109651
23179	35591	88	applied	\N	\N	\N	\N	109477	109477	109652
23179	35592	89	applied	\N	\N	\N	\N	109479	109479	109507
23179	35594	90	applied	\N	\N	\N	\N	109483	109483	109509
23179	35599	91	applied	\N	\N	\N	\N	109494	109494	109653
23179	35603	92	applied	\N	\N	\N	\N	109504	109504	109654
23179	35605	93	applied	\N	\N	\N	\N	109508	109508	109516
23179	35611	94	applied	\N	\N	\N	\N	109522	109522	109655
23179	35617	95	applied	\N	\N	\N	\N	109537	109537	109981
23179	35618	96	applied	\N	\N	\N	\N	109539	109539	109525
23179	35620	97	applied	\N	\N	\N	\N	109545	109545	109657
23179	35624	99	applied	\N	\N	\N	\N	109556	109556	109536
23179	35633	100	applied	\N	\N	\N	\N	109615	109615	109538
23179	35635	101	applied	\N	\N	\N	\N	109624	109624	109540
23179	35639	102	applied	\N	\N	\N	\N	109669	109669	109983
23179	35640	103	applied	\N	\N	\N	\N	109671	109671	109984
23179	35646	104	applied	\N	\N	\N	\N	109687	109687	109659
23179	35647	105	applied	\N	\N	\N	\N	109689	109689	109552
23179	35652	106	applied	\N	\N	\N	\N	109705	109705	109557
23179	35655	107	applied	\N	\N	\N	\N	109712	109712	109661
23179	35658	108	applied	\N	\N	\N	\N	109720	109720	109609
23179	35662	109	applied	\N	\N	\N	\N	109730	109730	109616
23179	35667	110	applied	\N	\N	\N	\N	109740	109740	109631
23179	35668	111	applied	\N	\N	\N	\N	109742	109742	109790
23179	35670	112	applied	\N	\N	\N	\N	109746	109746	109791
23179	35675	113	applied	\N	\N	\N	\N	109758	109758	109627
23179	35677	114	applied	\N	\N	\N	\N	109774	109774	109792
23179	35600	115	applied	\N	\N	\N	\N	109496	109496	109985
23179	35604	116	applied	\N	\N	\N	\N	109506	109506	109794
23179	35606	117	applied	\N	\N	\N	\N	109510	109510	109686
23179	35608	118	applied	\N	\N	\N	\N	109515	109515	109796
23179	35612	119	applied	\N	\N	\N	\N	109524	109524	109986
23179	35616	120	applied	\N	\N	\N	\N	109535	109535	109798
23179	35619	121	applied	\N	\N	\N	\N	109541	109541	109799
23179	35622	122	applied	\N	\N	\N	\N	109551	109551	109706
23179	35625	123	applied	\N	\N	\N	\N	109558	109558	109711
23179	35634	124	applied	\N	\N	\N	\N	109621	109621	109715
23179	35636	125	applied	\N	\N	\N	\N	109626	109626	109801
23181	35714	0	applied	\N	\N	\N	\N	109970	109970	109971
23181	35715	1	applied	\N	\N	\N	\N	109972	109972	109973
23181	35717	2	applied	\N	\N	\N	\N	109989	109989	109990
23181	35718	3	applied	\N	\N	\N	\N	109991	109991	109992
23181	35719	5	applied	\N	\N	\N	\N	109994	109994	109995
23181	35721	6	applied	\N	\N	\N	\N	110003	110003	110004
23181	35722	7	applied	\N	\N	\N	\N	110005	110005	110006
23181	35723	8	applied	\N	\N	\N	\N	110007	110007	110008
23181	35724	9	applied	\N	\N	\N	\N	110009	110009	110010
23181	35725	10	applied	\N	\N	\N	\N	110011	110011	110012
23181	35716	11	applied	\N	\N	\N	\N	109980	109980	110013
23181	35720	12	applied	\N	\N	\N	\N	109997	109997	110014
23184	35043	1	applied	\N	\N	1000000000	\N	107822	107822	107823
23184	35234	2	applied	\N	\N	1000000000	\N	108454	108454	108455
23184	34949	3	applied	\N	\N	\N	\N	107559	107559	107560
23184	34953	4	applied	\N	\N	\N	\N	107570	107570	107571
23184	35027	5	applied	\N	\N	1000000000	\N	107770	107770	107771
23184	35039	6	applied	\N	\N	\N	\N	107808	107808	107809
23184	34956	7	applied	\N	\N	\N	\N	107578	107578	107579
23184	34959	8	applied	\N	\N	\N	\N	107586	107586	107587
23184	34962	9	applied	\N	\N	\N	\N	107597	107597	107598
23184	34965	10	applied	\N	\N	\N	\N	107609	107609	107610
23184	34970	11	applied	\N	\N	\N	\N	107623	107623	107624
23184	34971	12	applied	\N	\N	\N	\N	107625	107625	107626
23184	34977	13	applied	\N	\N	\N	\N	107638	107638	107639
23184	34980	14	applied	\N	\N	\N	\N	107645	107645	107646
23184	34984	15	applied	\N	\N	\N	\N	107655	107655	107656
23184	34987	16	applied	\N	\N	\N	\N	107664	107664	107665
23184	34988	17	applied	\N	\N	\N	\N	107666	107666	107667
23184	34989	18	applied	\N	\N	\N	\N	107668	107668	107669
23184	34997	19	applied	\N	\N	\N	\N	107689	107689	107690
23184	35000	20	applied	\N	\N	\N	\N	107697	107697	107698
23184	35004	21	applied	\N	\N	\N	\N	107707	107707	107708
23184	35008	22	applied	\N	\N	\N	\N	107716	107716	107717
23184	35011	23	applied	\N	\N	\N	\N	107730	107730	107731
23184	35014	24	applied	\N	\N	\N	\N	107739	107739	107740
23184	35015	25	applied	\N	\N	\N	\N	107741	107741	107742
23184	35021	26	applied	\N	\N	\N	\N	107755	107755	107756
23184	35024	27	applied	\N	\N	\N	\N	107762	107762	107763
23184	35028	28	applied	\N	\N	\N	\N	107772	107772	107773
23184	35032	29	applied	\N	\N	\N	\N	107784	107784	107785
23184	35035	30	applied	\N	\N	\N	\N	107792	107792	107793
23184	35038	31	applied	\N	\N	\N	\N	107806	107806	107807
23184	35044	32	applied	\N	\N	\N	\N	107824	107824	107825
23184	35047	33	applied	\N	\N	\N	\N	107835	107835	107836
23184	35051	34	applied	\N	\N	\N	\N	107846	107846	107847
23184	35056	35	applied	\N	\N	\N	\N	107859	107859	107860
23184	35060	36	applied	\N	\N	\N	\N	107871	107871	107872
23184	35063	37	applied	\N	\N	\N	\N	107878	107878	107879
23184	35066	38	applied	\N	\N	\N	\N	107886	107886	107887
23184	35071	39	applied	\N	\N	\N	\N	107897	107897	107898
23184	35072	40	applied	\N	\N	\N	\N	107899	107899	107900
23184	35077	41	applied	\N	\N	\N	\N	107912	107912	107913
23184	35081	42	applied	\N	\N	\N	\N	107928	107928	107929
23184	35083	43	applied	\N	\N	\N	\N	107934	107934	107987
23184	35086	44	applied	\N	\N	\N	\N	107941	107941	107988
23184	35090	45	applied	\N	\N	\N	\N	107951	107951	107989
23184	35091	46	applied	\N	\N	\N	\N	107953	107953	107990
23184	35096	47	applied	\N	\N	\N	\N	107969	107969	107991
23184	35099	48	applied	\N	\N	\N	\N	107975	107975	107992
23184	35103	49	applied	\N	\N	\N	\N	108009	108009	108580
23184	35106	50	applied	\N	\N	\N	\N	108019	108019	108581
23184	35109	51	applied	\N	\N	\N	\N	108029	108029	108582
23184	35113	52	applied	\N	\N	\N	\N	108039	108039	108583
23184	35116	53	applied	\N	\N	\N	\N	108048	108048	108584
23184	35121	54	applied	\N	\N	\N	\N	108072	108072	108585
23184	35123	55	applied	\N	\N	\N	\N	108079	108079	108586
23184	35126	56	applied	\N	\N	\N	\N	108087	108087	108587
23184	35127	57	applied	\N	\N	\N	\N	108089	108089	108588
23184	35128	58	applied	\N	\N	\N	\N	108091	108091	108589
23184	35141	59	applied	\N	\N	\N	\N	108121	108121	108590
23184	35144	60	applied	\N	\N	\N	\N	108130	108130	108591
23184	35147	61	applied	\N	\N	\N	\N	108137	108137	108592
23184	35148	62	applied	\N	\N	\N	\N	108139	108139	108593
23184	35149	63	applied	\N	\N	\N	\N	108141	108141	108594
23184	35157	64	applied	\N	\N	\N	\N	108158	108158	108595
23184	35161	65	applied	\N	\N	\N	\N	108168	108168	108596
23184	35165	66	applied	\N	\N	\N	\N	108181	108181	108597
23184	35169	67	applied	\N	\N	\N	\N	108190	108190	108598
23184	35173	68	applied	\N	\N	\N	\N	108213	108213	108599
23184	35177	69	applied	\N	\N	\N	\N	108232	108232	108600
23184	35180	70	applied	\N	\N	\N	\N	108256	108256	108601
23184	35183	71	applied	\N	\N	\N	\N	108273	108273	108602
23184	35187	72	applied	\N	\N	\N	\N	108289	108289	108603
23184	35190	73	applied	\N	\N	\N	\N	108296	108296	108604
23184	35193	74	applied	\N	\N	\N	\N	108326	108326	108605
23184	35194	75	applied	\N	\N	\N	\N	108328	108328	108606
23184	35201	76	applied	\N	\N	\N	\N	108345	108345	108607
23184	35202	77	applied	\N	\N	\N	\N	108347	108347	108608
23184	35203	78	applied	\N	\N	\N	\N	108349	108349	108609
23184	35215	79	applied	\N	\N	\N	\N	108375	108375	108610
23184	35218	80	applied	\N	\N	\N	\N	108390	108390	108611
23184	35219	81	applied	\N	\N	\N	\N	108392	108392	108612
23184	35226	82	applied	\N	\N	\N	\N	108407	108407	108613
23184	35229	83	applied	\N	\N	\N	\N	108434	108434	108614
23184	35232	84	applied	\N	\N	\N	\N	108450	108450	108615
23184	35233	85	applied	\N	\N	\N	\N	108452	108452	108616
23184	35235	86	applied	\N	\N	\N	\N	108456	108456	108617
23184	35236	87	applied	\N	\N	\N	\N	108458	108458	108618
23184	35237	89	applied	\N	\N	\N	\N	108460	108460	108619
23184	35251	90	applied	\N	\N	\N	\N	108489	108489	108620
23184	35255	91	applied	\N	\N	\N	\N	108501	108501	108621
23184	35258	92	applied	\N	\N	\N	\N	108515	108515	108622
23184	35262	93	applied	\N	\N	\N	\N	108527	108527	108623
23184	35263	94	applied	\N	\N	\N	\N	108529	108529	108624
23184	35268	95	applied	\N	\N	\N	\N	108540	108540	108625
23184	35270	96	applied	\N	\N	\N	\N	108549	108549	108626
23184	35274	97	applied	\N	\N	\N	\N	108561	108561	108627
23184	35277	98	applied	\N	\N	\N	\N	108571	108571	108628
23184	35279	99	applied	\N	\N	\N	\N	108632	108632	109883
23184	35280	100	applied	\N	\N	\N	\N	108634	108634	109885
23184	35281	101	applied	\N	\N	\N	\N	108636	108636	109886
23184	35287	102	applied	\N	\N	\N	\N	108651	108651	109887
23184	35288	103	applied	\N	\N	\N	\N	108653	108653	109888
23184	35289	104	applied	\N	\N	\N	\N	108655	108655	109889
23184	35294	105	applied	\N	\N	\N	\N	108666	108666	109890
23184	35297	106	applied	\N	\N	\N	\N	108679	108679	109891
23184	35298	107	applied	\N	\N	\N	\N	108681	108681	109892
23184	35302	108	applied	\N	\N	\N	\N	108691	108691	109893
23184	35305	109	applied	\N	\N	\N	\N	108702	108702	109894
23184	35306	110	applied	\N	\N	\N	\N	108704	108704	109895
23184	35309	111	applied	\N	\N	\N	\N	108713	108713	109896
23184	35312	112	applied	\N	\N	\N	\N	108721	108721	109897
23184	35316	113	applied	\N	\N	\N	\N	108730	108730	109898
23184	35317	114	applied	\N	\N	\N	\N	108732	108732	109899
23184	35322	115	applied	\N	\N	\N	\N	108744	108744	109900
23184	35323	116	applied	\N	\N	\N	\N	108746	108746	109901
23184	35324	117	applied	\N	\N	\N	\N	108748	108748	109902
23184	35325	118	applied	\N	\N	\N	\N	108750	108750	109903
23184	35336	119	applied	\N	\N	\N	\N	108773	108773	109904
23184	35339	120	applied	\N	\N	\N	\N	108783	108783	109905
23184	35342	121	applied	\N	\N	\N	\N	108797	108797	109906
23184	35345	122	applied	\N	\N	\N	\N	108805	108805	109907
23184	35349	123	applied	\N	\N	\N	\N	108815	108815	109908
23184	35352	124	applied	\N	\N	\N	\N	108828	108828	109909
23184	35353	125	applied	\N	\N	\N	\N	108830	108830	109910
23185	35726	0	applied	\N	\N	\N	\N	110025	110025	110026
23185	35721	1	applied	\N	\N	\N	\N	110003	110003	110027
23185	35722	2	applied	\N	\N	\N	\N	110005	110005	110028
23185	35723	3	applied	\N	\N	\N	\N	110007	110007	110029
23185	35724	4	applied	\N	\N	\N	\N	110009	110009	110030
23185	35725	5	applied	\N	\N	\N	\N	110011	110011	110014
23185	35727	6	applied	\N	\N	\N	\N	110031	110031	110032
23186	35728	0	applied	\N	\N	\N	\N	110035	110035	110036
23186	35729	1	applied	\N	\N	\N	\N	110037	110037	110038
23186	35730	2	applied	\N	\N	\N	\N	110039	110039	110040
23186	35731	3	applied	\N	\N	\N	\N	110041	110041	110042
23186	35732	4	applied	\N	\N	\N	\N	110043	110043	110044
23187	35733	0	applied	\N	\N	\N	\N	110046	110046	110047
23187	35734	1	applied	\N	\N	\N	\N	110048	110048	110049
23188	35733	0	applied	\N	\N	\N	\N	110046	110046	110047
23188	35734	1	applied	\N	\N	\N	\N	110048	110048	110049
23189	35735	0	applied	\N	\N	\N	\N	110052	110052	110053
23189	35736	1	applied	\N	\N	\N	\N	110054	110054	110055
23190	35735	0	applied	\N	\N	\N	\N	110052	110052	110053
23190	35736	1	applied	\N	\N	\N	\N	110054	110054	110055
23191	35735	0	applied	\N	\N	\N	\N	110052	110052	110053
23191	35736	1	applied	\N	\N	\N	\N	110054	110054	110055
23192	35737	0	applied	\N	\N	\N	\N	110061	110061	110062
23192	35738	1	applied	\N	\N	\N	\N	110063	110063	110064
23192	35739	2	applied	\N	\N	\N	\N	110065	110065	110066
23193	35737	0	applied	\N	\N	\N	\N	110061	110061	110062
23193	35738	1	applied	\N	\N	\N	\N	110063	110063	110064
23193	35739	2	applied	\N	\N	\N	\N	110065	110065	110066
23194	35737	0	applied	\N	\N	\N	\N	110061	110061	110062
23194	35738	1	applied	\N	\N	\N	\N	110063	110063	110064
23194	35739	2	applied	\N	\N	\N	\N	110065	110065	110066
23195	35737	0	applied	\N	\N	\N	\N	110061	110061	110062
23195	35738	1	applied	\N	\N	\N	\N	110063	110063	110064
23195	35739	2	applied	\N	\N	\N	\N	110065	110065	110066
23196	35737	0	applied	\N	\N	\N	\N	110061	110061	110062
23196	35738	1	applied	\N	\N	\N	\N	110063	110063	110064
23196	35739	2	applied	\N	\N	\N	\N	110065	110065	110066
23197	35739	0	applied	\N	\N	\N	\N	110065	110065	110075
23198	35740	0	applied	\N	\N	\N	\N	110077	110077	110078
23198	35741	1	applied	\N	\N	\N	\N	110079	110079	110080
23199	35742	0	applied	\N	\N	\N	\N	110082	110082	110083
23199	35743	1	applied	\N	\N	\N	\N	110084	110084	110085
23200	35744	0	applied	\N	\N	\N	\N	110087	110087	110088
23200	35745	1	applied	\N	\N	\N	\N	110089	110089	110090
23201	35746	0	applied	\N	\N	\N	\N	110093	110093	110094
23201	35747	1	applied	\N	\N	\N	\N	110095	110095	110096
23201	35748	2	applied	\N	\N	\N	\N	110097	110097	110098
23202	35749	0	applied	\N	\N	\N	\N	110101	110101	110102
23202	35750	1	applied	\N	\N	\N	\N	110103	110103	110104
23202	35751	2	applied	\N	\N	\N	\N	110105	110105	110106
23202	35752	3	applied	\N	\N	\N	\N	110107	110107	110108
23203	35749	0	applied	\N	\N	\N	\N	110101	110101	110102
23203	35750	1	applied	\N	\N	\N	\N	110103	110103	110104
23203	35751	2	applied	\N	\N	\N	\N	110105	110105	110106
23203	35752	3	applied	\N	\N	\N	\N	110107	110107	110108
23204	35749	0	applied	\N	\N	\N	\N	110101	110101	110102
23204	35750	1	applied	\N	\N	\N	\N	110103	110103	110104
23204	35751	2	applied	\N	\N	\N	\N	110105	110105	110106
23204	35752	3	applied	\N	\N	\N	\N	110107	110107	110108
23205	35749	0	applied	\N	\N	\N	\N	110101	110101	110102
23205	35750	1	applied	\N	\N	\N	\N	110103	110103	110104
23205	35751	2	applied	\N	\N	\N	\N	110105	110105	110106
23205	35752	3	applied	\N	\N	\N	\N	110107	110107	110108
23206	35753	0	applied	\N	\N	\N	\N	110114	110114	110115
23206	35754	1	applied	\N	\N	\N	\N	110116	110116	110117
23207	35753	0	applied	\N	\N	\N	\N	110114	110114	110115
23207	35754	1	applied	\N	\N	\N	\N	110116	110116	110117
23208	35753	0	applied	\N	\N	\N	\N	110114	110114	110115
23208	35754	1	applied	\N	\N	\N	\N	110116	110116	110117
23209	35753	0	applied	\N	\N	\N	\N	110114	110114	110115
23209	35754	1	applied	\N	\N	\N	\N	110116	110116	110117
23210	35754	0	applied	\N	\N	\N	\N	110116	110116	110117
23211	35754	0	applied	\N	\N	\N	\N	110116	110116	110117
23212	35755	0	applied	\N	\N	\N	\N	110126	110126	110127
23212	35756	1	applied	\N	\N	\N	\N	110128	110128	110129
23213	35755	0	applied	\N	\N	\N	\N	110126	110126	110127
23213	35756	1	applied	\N	\N	\N	\N	110128	110128	110129
23214	35528	0	applied	\N	\N	\N	\N	109314	109314	109315
23214	35532	1	applied	\N	\N	\N	\N	109330	109330	109331
23214	35535	2	applied	\N	\N	\N	\N	109336	109336	109337
23214	35538	3	applied	\N	\N	\N	\N	109344	109344	109345
23214	35539	4	applied	\N	\N	\N	\N	109346	109346	109347
23214	35545	5	applied	\N	\N	\N	\N	109362	109362	109363
23214	35548	6	applied	\N	\N	\N	\N	109371	109371	109372
23214	35549	7	applied	\N	\N	\N	\N	109373	109373	109374
23214	35554	8	applied	\N	\N	\N	\N	109385	109385	109386
23214	35558	9	applied	\N	\N	\N	\N	109396	109396	109397
23214	35560	10	applied	\N	\N	\N	\N	109401	109401	109402
23214	35564	11	applied	\N	\N	\N	\N	109410	109410	109411
23214	35567	12	applied	\N	\N	\N	\N	109416	109416	109417
23214	35570	13	applied	\N	\N	\N	\N	109424	109424	109425
23214	35573	14	applied	\N	\N	\N	\N	109432	109432	109433
23214	35577	15	applied	\N	\N	\N	\N	109444	109444	109445
23214	35580	16	applied	\N	\N	\N	\N	109452	109452	109453
23214	35583	17	applied	\N	\N	\N	\N	109460	109460	109461
23214	35587	18	applied	\N	\N	\N	\N	109469	109469	109470
23214	35588	19	applied	\N	\N	\N	\N	109471	109471	109472
23214	35589	20	applied	\N	\N	\N	\N	109473	109473	109474
23214	35597	21	applied	\N	\N	\N	\N	109490	109490	109491
23214	35601	22	applied	\N	\N	\N	\N	109500	109500	109501
23214	35602	23	applied	\N	\N	\N	\N	109502	109502	109503
23214	35607	24	applied	\N	\N	\N	\N	109513	109513	109514
23214	35610	25	applied	\N	\N	\N	\N	109520	109520	109521
23214	35613	26	applied	\N	\N	\N	\N	109529	109529	109530
23214	35614	27	applied	\N	\N	\N	\N	109531	109531	109532
23214	35621	28	applied	\N	\N	\N	\N	109549	109549	109550
23214	35623	29	applied	\N	\N	\N	\N	109554	109554	109555
23214	35628	30	applied	\N	\N	\N	\N	109604	109604	109605
23214	35629	31	applied	\N	\N	\N	\N	109606	109606	109607
23214	35637	32	applied	\N	\N	\N	\N	109665	109665	109666
23214	35638	33	applied	\N	\N	\N	\N	109667	109667	109668
23214	35643	34	applied	\N	\N	\N	\N	109681	109681	109682
23214	35644	35	applied	\N	\N	\N	\N	109683	109683	109684
23214	35650	36	applied	\N	\N	\N	\N	109701	109701	109702
23214	35653	37	applied	\N	\N	\N	\N	109708	109708	109709
23214	35657	38	applied	\N	\N	\N	\N	109718	109718	109719
23214	35660	39	applied	\N	\N	\N	\N	109726	109726	109727
23214	35663	40	applied	\N	\N	\N	\N	109732	109732	109733
23214	35664	41	applied	\N	\N	\N	\N	109734	109734	109735
23214	35665	42	applied	\N	\N	\N	\N	109736	109736	109737
23214	35673	43	applied	\N	\N	\N	\N	109754	109754	109755
23214	35676	44	applied	\N	\N	\N	\N	109772	109772	109773
23214	35680	45	applied	\N	\N	\N	\N	109784	109784	109785
23214	35682	46	applied	\N	\N	\N	\N	109814	109814	109815
23214	35683	47	applied	\N	\N	\N	\N	109816	109816	109817
23214	35687	48	applied	\N	\N	\N	\N	109827	109827	109828
23214	35689	49	applied	\N	\N	\N	\N	109834	109834	109835
23214	35690	51	applied	\N	\N	\N	\N	109836	109836	109837
23214	35694	52	applied	\N	\N	\N	\N	109847	109847	109848
23214	35695	53	applied	\N	\N	\N	\N	109849	109849	109850
23214	35698	54	applied	\N	\N	\N	\N	109858	109858	109859
23214	35700	55	applied	\N	\N	\N	\N	109865	109865	109866
23214	35703	56	applied	\N	\N	\N	\N	109877	109877	109878
23214	35705	57	applied	\N	\N	\N	\N	109945	109945	109946
23214	35706	58	applied	\N	\N	\N	\N	109947	109947	109948
23214	35710	59	applied	\N	\N	\N	\N	109959	109959	109960
23214	35712	60	applied	\N	\N	\N	\N	109964	109964	109965
23214	35714	61	applied	\N	\N	\N	\N	109970	109970	109971
23214	35715	62	applied	\N	\N	\N	\N	109972	109972	109973
23214	35717	63	applied	\N	\N	\N	\N	109989	109989	109990
23214	35718	64	applied	\N	\N	\N	\N	109991	109991	109992
23214	35719	65	applied	\N	\N	\N	\N	109994	109994	109995
23214	35726	66	applied	\N	\N	\N	\N	110025	110025	110026
23214	35728	67	applied	\N	\N	\N	\N	110035	110035	110036
23214	35729	68	applied	\N	\N	\N	\N	110037	110037	110038
23214	35733	69	applied	\N	\N	\N	\N	110046	110046	110047
23214	35735	70	applied	\N	\N	\N	\N	110052	110052	110053
23214	35737	71	applied	\N	\N	\N	\N	110061	110061	110062
23214	35740	72	applied	\N	\N	\N	\N	110077	110077	110078
23214	35742	73	applied	\N	\N	\N	\N	110082	110082	110083
23214	35744	74	applied	\N	\N	\N	\N	110087	110087	110088
23214	35746	75	applied	\N	\N	\N	\N	110093	110093	110094
23214	35749	76	applied	\N	\N	\N	\N	110101	110101	110102
23214	35750	77	applied	\N	\N	\N	\N	110103	110103	110104
23214	35753	78	applied	\N	\N	\N	\N	110114	110114	110115
23214	35531	79	applied	\N	\N	\N	\N	109326	109326	109324
23214	35530	80	applied	\N	\N	\N	\N	109323	109323	110133
23214	35529	81	applied	\N	\N	\N	\N	109316	109316	109327
23214	35540	82	applied	\N	\N	\N	\N	109348	109348	110134
23214	35550	83	applied	\N	\N	\N	\N	109375	109375	110135
23214	35561	84	applied	\N	\N	\N	\N	109403	109403	109333
23214	35626	85	applied	\N	\N	\N	\N	109560	109560	109561
23214	35598	86	applied	\N	\N	\N	\N	109492	109492	109493
23214	35533	87	applied	\N	\N	\N	\N	109332	109332	110136
23214	35536	88	applied	\N	\N	\N	\N	109338	109338	110137
23214	35543	89	applied	\N	\N	\N	\N	109354	109354	110138
23214	35544	90	applied	\N	\N	\N	\N	109356	109356	109353
23214	35575	91	applied	\N	\N	\N	\N	109436	109436	110139
23214	35585	92	applied	\N	\N	\N	\N	109464	109464	110140
23214	35627	93	applied	\N	\N	\N	\N	109562	109562	109563
23214	35631	94	applied	\N	\N	\N	\N	109610	109610	109611
23214	35632	95	applied	\N	\N	\N	\N	109613	109613	109614
23214	35534	96	applied	\N	\N	\N	\N	109334	109334	110141
23214	35537	97	applied	\N	\N	\N	\N	109340	109340	109357
23214	35541	98	applied	\N	\N	\N	\N	109350	109350	109365
23214	35542	99	applied	\N	\N	\N	\N	109352	109352	110142
23214	35546	100	applied	\N	\N	\N	\N	109364	109364	109376
23214	35551	101	applied	\N	\N	\N	\N	109377	109377	109378
23214	35552	102	applied	\N	\N	\N	\N	109379	109379	109380
23214	35555	103	applied	\N	\N	\N	\N	109387	109387	110143
23214	35559	104	applied	\N	\N	\N	\N	109398	109398	110144
23214	35562	105	applied	\N	\N	\N	\N	109405	109405	110145
23214	35566	106	applied	\N	\N	\N	\N	109414	109414	109390
23214	35568	107	applied	\N	\N	\N	\N	109418	109418	109399
23214	35572	108	applied	\N	\N	\N	\N	109428	109428	110146
23214	35593	109	applied	\N	\N	\N	\N	109481	109481	109400
23214	35547	110	applied	\N	\N	\N	\N	109366	109366	109406
23214	35553	111	applied	\N	\N	\N	\N	109381	109381	109408
23214	35556	112	applied	\N	\N	\N	\N	109389	109389	109413
23214	35557	113	applied	\N	\N	\N	\N	109393	109393	109638
23214	35563	114	applied	\N	\N	\N	\N	109407	109407	109639
23214	35565	115	applied	\N	\N	\N	\N	109412	109412	109640
23214	35569	116	applied	\N	\N	\N	\N	109420	109420	109429
23214	35571	117	applied	\N	\N	\N	\N	109426	109426	109435
23214	35574	118	applied	\N	\N	\N	\N	109434	109434	109439
23214	35578	119	applied	\N	\N	\N	\N	109446	109446	109447
23214	35582	120	applied	\N	\N	\N	\N	109456	109456	109641
23214	35584	121	applied	\N	\N	\N	\N	109462	109462	109642
23214	35590	122	applied	\N	\N	\N	\N	109475	109475	109644
23214	35609	123	applied	\N	\N	\N	\N	109517	109517	109463
23214	35615	124	applied	\N	\N	\N	\N	109533	109533	109465
23214	35630	125	applied	\N	\N	\N	\N	109608	109608	109977
23219	35758	0	applied	\N	\N	1000000000	\N	110152	110152	110153
23219	35626	1	applied	\N	\N	\N	\N	109560	109560	109561
23219	35627	2	applied	\N	\N	\N	\N	109562	109562	109563
23219	35631	3	applied	\N	\N	\N	\N	109610	109610	109611
23219	35632	4	applied	\N	\N	\N	\N	109613	109613	109614
23225	35767	0	applied	\N	\N	\N	\N	110201	110201	47675
23225	35768	1	applied	\N	\N	\N	\N	110202	110202	110203
23225	35769	2	applied	\N	\N	\N	\N	110204	110204	110205
23225	35770	3	applied	\N	\N	\N	\N	110206	110206	110207
23225	35771	4	applied	\N	\N	\N	\N	110208	110208	110209
23234	35776	0	applied	\N	\N	\N	\N	110231	110231	110232
23235	35777	0	applied	\N	\N	\N	\N	110234	110234	110235
23235	35778	1	applied	\N	\N	\N	\N	110236	110236	110237
23240	35781	0	applied	\N	\N	\N	\N	110250	110250	110251
23240	35782	1	applied	\N	\N	\N	\N	110252	110252	110253
23246	35787	0	applied	\N	\N	\N	\N	110269	110269	110270
23246	35788	1	applied	\N	\N	\N	\N	110271	110271	110272
23246	35789	2	applied	\N	\N	\N	\N	110273	110273	110274
23246	35790	3	applied	\N	\N	\N	\N	110275	110275	110276
23250	35758	0	applied	\N	\N	1000000000	\N	110152	110152	110153
23250	35767	1	applied	\N	\N	\N	\N	110201	110201	47675
23250	35626	2	applied	\N	\N	\N	\N	109560	109560	109561
23250	35598	3	applied	\N	\N	\N	\N	109492	109492	109493
23250	35627	4	applied	\N	\N	\N	\N	109562	109562	109563
23250	35631	5	applied	\N	\N	\N	\N	109610	109610	109611
23250	35632	6	applied	\N	\N	\N	\N	109613	109613	109614
23255	35793	0	applied	\N	\N	\N	\N	110295	110295	110296
23255	35794	1	applied	\N	\N	\N	\N	110297	110297	110298
23260	35799	0	applied	\N	\N	\N	\N	110314	110314	110315
23260	35800	1	applied	\N	\N	\N	\N	110316	110316	110317
23261	35801	0	applied	\N	\N	\N	\N	110322	110322	110323
23261	35802	1	applied	\N	\N	\N	\N	110324	110324	110325
23215	35757	0	applied	\N	\N	\N	\N	110150	110150	110151
23215	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23215	35759	2	applied	\N	\N	\N	\N	110154	110154	110155
23220	35762	0	applied	\N	\N	\N	\N	110167	110167	110168
23220	35763	1	applied	\N	\N	\N	\N	110169	110169	110170
23221	35764	0	applied	\N	\N	\N	\N	110173	110173	47675
23221	35765	1	applied	\N	\N	\N	\N	110174	110174	110175
23221	35766	2	applied	\N	\N	\N	\N	110176	110176	110177
23226	35767	0	applied	\N	\N	\N	\N	110201	110201	47675
23226	35768	1	applied	\N	\N	\N	\N	110202	110202	110203
23226	35769	2	applied	\N	\N	\N	\N	110204	110204	110205
23226	35770	3	applied	\N	\N	\N	\N	110206	110206	110207
23226	35771	4	applied	\N	\N	\N	\N	110208	110208	110209
23230	35772	0	applied	\N	\N	\N	\N	110218	110218	110219
23230	35773	1	applied	\N	\N	\N	\N	110220	110220	110221
23236	35777	0	applied	\N	\N	\N	\N	110234	110234	110235
23236	35778	1	applied	\N	\N	\N	\N	110236	110236	110237
23241	35783	0	applied	\N	\N	\N	\N	110256	110256	110257
23241	35784	1	applied	\N	\N	\N	\N	110258	110258	110259
23247	35787	0	applied	\N	\N	\N	\N	110269	110269	110270
23247	35788	1	applied	\N	\N	\N	\N	110271	110271	110272
23247	35789	2	applied	\N	\N	\N	\N	110273	110273	110274
23247	35790	3	applied	\N	\N	\N	\N	110275	110275	110276
23251	35791	0	applied	\N	\N	\N	\N	110281	110281	110282
23251	35792	1	applied	\N	\N	\N	\N	110283	110283	110284
23256	35795	0	applied	\N	\N	\N	\N	110303	110303	110304
23256	35796	1	applied	\N	\N	\N	\N	110305	110305	110306
23257	35797	0	applied	\N	\N	\N	\N	110308	110308	110309
23257	35798	1	applied	\N	\N	\N	\N	110310	110310	110311
23262	35803	0	applied	\N	\N	\N	\N	110326	110326	110327
23262	35804	1	applied	\N	\N	\N	\N	110328	110328	110329
23263	35805	0	applied	\N	\N	\N	\N	110332	110332	110333
23263	35806	1	applied	\N	\N	\N	\N	110334	110334	110335
23263	35807	2	applied	\N	\N	\N	\N	110336	110336	110337
23267	35808	0	applied	\N	\N	\N	\N	110341	110341	110342
23267	35809	1	applied	\N	\N	\N	\N	110343	110343	110344
23273	35812	0	applied	\N	\N	\N	\N	110360	110360	110361
23273	35813	1	applied	\N	\N	\N	\N	110362	110362	110363
23273	35814	2	applied	\N	\N	\N	\N	110364	110364	110365
23273	35815	3	applied	\N	\N	\N	\N	110366	110366	110367
23273	35816	4	applied	\N	\N	\N	\N	110368	110368	110369
23273	35817	5	applied	\N	\N	\N	\N	110370	110370	110371
23274	35818	0	applied	\N	\N	\N	\N	110375	110375	110376
23274	35819	1	applied	\N	\N	\N	\N	110377	110377	110378
23280	35825	0	applied	\N	\N	\N	\N	110393	110393	110394
23280	35826	1	applied	\N	\N	\N	\N	110395	110395	110396
23286	35831	0	applied	\N	\N	\N	\N	110434	110434	110435
23286	35832	1	applied	\N	\N	\N	\N	110436	110436	110437
23286	35833	2	applied	\N	\N	\N	\N	110438	110438	110439
23286	35834	3	applied	\N	\N	\N	\N	110440	110440	110441
23286	35835	4	applied	\N	\N	\N	\N	110442	110442	110443
23286	35836	5	applied	\N	\N	\N	\N	110444	110444	110445
23287	35837	0	applied	\N	\N	\N	\N	110449	110449	110450
23287	35838	1	applied	\N	\N	\N	\N	110451	110451	110452
23294	35847	0	applied	\N	\N	\N	\N	110504	110504	110505
23294	35848	1	applied	\N	\N	\N	\N	110506	110506	110507
23294	35849	2	applied	\N	\N	\N	\N	110508	110508	110509
23294	35850	3	applied	\N	\N	\N	\N	110510	110510	110511
23300	35859	0	applied	\N	\N	\N	\N	110534	110534	110535
23300	35860	1	applied	\N	\N	\N	\N	110536	110536	110537
23301	35861	0	applied	\N	\N	\N	\N	110538	110538	110539
23301	35862	1	applied	\N	\N	\N	\N	110540	110540	110541
23305	35863	0	applied	\N	\N	\N	\N	110638	110638	110639
23305	35864	1	applied	\N	\N	\N	\N	110640	110640	110641
23312	35767	0	applied	\N	\N	\N	\N	110201	110201	47675
23312	35765	1	applied	\N	\N	\N	\N	110174	110174	110175
23312	35768	2	applied	\N	\N	\N	\N	110202	110202	110203
23312	35769	3	applied	\N	\N	\N	\N	110204	110204	110205
23312	35772	4	applied	\N	\N	\N	\N	110218	110218	110219
23312	35774	5	applied	\N	\N	\N	\N	110225	110225	110226
23312	35777	6	applied	\N	\N	\N	\N	110234	110234	110235
23312	35779	7	applied	\N	\N	\N	\N	110242	110242	110243
23312	35781	8	applied	\N	\N	\N	\N	110250	110250	110251
23312	35783	9	applied	\N	\N	\N	\N	110256	110256	110257
23312	35785	10	applied	\N	\N	\N	\N	110262	110262	110263
23312	35787	11	applied	\N	\N	\N	\N	110269	110269	110270
23312	35788	12	applied	\N	\N	\N	\N	110271	110271	110272
23312	35791	13	applied	\N	\N	\N	\N	110281	110281	110282
23312	35793	14	applied	\N	\N	\N	\N	110295	110295	110296
23312	35795	15	applied	\N	\N	\N	\N	110303	110303	110304
23312	35797	16	applied	\N	\N	\N	\N	110308	110308	110309
23312	35799	17	applied	\N	\N	\N	\N	110314	110314	110315
23312	35801	18	applied	\N	\N	\N	\N	110322	110322	110323
23312	35803	19	applied	\N	\N	\N	\N	110326	110326	110327
23312	35805	20	applied	\N	\N	\N	\N	110332	110332	110333
23312	35808	21	applied	\N	\N	\N	\N	110341	110341	110342
23312	35810	22	applied	\N	\N	\N	\N	110351	110351	110352
23312	35812	23	applied	\N	\N	\N	\N	110360	110360	110361
23312	35813	24	applied	\N	\N	\N	\N	110362	110362	110363
23312	35814	25	applied	\N	\N	\N	\N	110364	110364	110365
23312	35818	26	applied	\N	\N	\N	\N	110375	110375	110376
23312	35820	27	applied	\N	\N	\N	\N	110381	110381	110382
23312	35821	28	applied	\N	\N	\N	\N	110383	110383	110384
23312	35824	29	applied	\N	\N	\N	\N	110390	110390	110391
23312	35825	30	applied	\N	\N	\N	\N	110393	110393	110394
23312	35827	31	applied	\N	\N	\N	\N	110399	110399	110400
23312	35829	32	applied	\N	\N	\N	\N	110407	110407	110408
23312	35831	33	applied	\N	\N	\N	\N	110434	110434	110435
23312	35832	34	applied	\N	\N	\N	\N	110436	110436	110437
23312	35833	35	applied	\N	\N	\N	\N	110438	110438	110439
23312	35837	36	applied	\N	\N	\N	\N	110449	110449	110450
23312	35839	37	applied	\N	\N	\N	\N	110455	110455	110456
23312	35841	38	applied	\N	\N	\N	\N	110488	110488	110489
23312	35842	39	applied	\N	\N	\N	\N	110490	110490	110491
23312	35845	40	applied	\N	\N	\N	\N	110498	110498	110499
23312	35847	41	applied	\N	\N	\N	\N	110504	110504	110505
23312	35848	42	applied	\N	\N	\N	\N	110506	110506	110507
23312	35851	43	applied	\N	\N	\N	\N	110517	110517	110518
23312	35853	44	applied	\N	\N	\N	\N	110521	110521	110522
23312	35854	45	applied	\N	\N	\N	\N	110523	110523	110524
23312	35857	46	applied	\N	\N	\N	\N	110530	110530	110531
23312	35859	47	applied	\N	\N	\N	\N	110534	110534	110535
23312	35861	48	applied	\N	\N	\N	\N	110538	110538	110539
23312	35863	49	applied	\N	\N	\N	\N	110638	110638	110639
23312	35865	50	applied	\N	\N	\N	\N	110646	110646	110647
23312	35867	51	applied	\N	\N	\N	\N	110652	110652	110653
23312	35868	52	applied	\N	\N	\N	\N	110654	110654	110655
23312	35871	53	applied	\N	\N	\N	\N	110662	110662	110663
23312	35873	54	applied	\N	\N	\N	\N	110670	110670	110671
23312	35770	55	applied	\N	\N	\N	\N	110206	110206	110207
23216	35757	0	applied	\N	\N	\N	\N	110150	110150	110151
23216	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23216	35759	2	applied	\N	\N	\N	\N	110154	110154	110155
23217	35760	0	applied	\N	\N	\N	\N	110159	110159	110160
23217	35761	1	applied	\N	\N	\N	\N	110161	110161	110162
23222	35698	0	applied	\N	\N	\N	\N	109858	109858	109859
23222	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23222	35700	2	applied	\N	\N	\N	\N	109865	109865	109866
23222	35703	3	applied	\N	\N	\N	\N	109877	109877	109878
23222	35705	4	applied	\N	\N	\N	\N	109945	109945	109946
23222	35706	5	applied	\N	\N	\N	\N	109947	109947	109948
23222	35710	6	applied	\N	\N	\N	\N	109959	109959	109960
23222	35712	7	applied	\N	\N	\N	\N	109964	109964	109965
23222	35714	8	applied	\N	\N	\N	\N	109970	109970	109971
23222	35715	9	applied	\N	\N	\N	\N	109972	109972	109973
23222	35717	10	applied	\N	\N	\N	\N	109989	109989	109990
23222	35718	11	applied	\N	\N	\N	\N	109991	109991	109992
23222	35719	12	applied	\N	\N	\N	\N	109994	109994	109995
23222	35726	13	applied	\N	\N	\N	\N	110025	110025	110026
23222	35728	14	applied	\N	\N	\N	\N	110035	110035	110036
23222	35729	15	applied	\N	\N	\N	\N	110037	110037	110038
23222	35733	16	applied	\N	\N	\N	\N	110046	110046	110047
23222	35735	17	applied	\N	\N	\N	\N	110052	110052	110053
23222	35737	18	applied	\N	\N	\N	\N	110061	110061	110062
23222	35740	19	applied	\N	\N	\N	\N	110077	110077	110078
23222	35742	20	applied	\N	\N	\N	\N	110082	110082	110083
23222	35744	21	applied	\N	\N	\N	\N	110087	110087	110088
23222	35746	22	applied	\N	\N	\N	\N	110093	110093	110094
23222	35749	23	applied	\N	\N	\N	\N	110101	110101	110102
23222	35750	24	applied	\N	\N	\N	\N	110103	110103	110104
23222	35753	25	applied	\N	\N	\N	\N	110114	110114	110115
23222	35755	26	applied	\N	\N	\N	\N	110126	110126	110127
23222	35757	27	applied	\N	\N	\N	\N	110150	110150	110151
23222	35760	28	applied	\N	\N	\N	\N	110159	110159	110160
23222	35762	29	applied	\N	\N	\N	\N	110167	110167	110168
23222	35702	30	applied	\N	\N	\N	\N	109869	109869	110180
23222	35707	31	applied	\N	\N	\N	\N	109949	109949	110181
23222	35699	33	applied	\N	\N	\N	\N	109860	109860	110183
23222	35701	34	applied	\N	\N	\N	\N	109867	109867	110184
23222	35704	35	applied	\N	\N	\N	\N	109879	109879	109950
23222	35708	36	applied	\N	\N	\N	\N	109953	109953	109955
23222	35709	37	applied	\N	\N	\N	\N	109956	109956	109957
23222	35711	38	applied	\N	\N	\N	\N	109961	109961	109962
23222	35713	39	applied	\N	\N	\N	\N	109966	109966	109967
23222	35721	40	applied	\N	\N	\N	\N	110003	110003	110004
23222	35722	41	applied	\N	\N	\N	\N	110005	110005	110006
23222	35723	42	applied	\N	\N	\N	\N	110007	110007	110008
23222	35724	43	applied	\N	\N	\N	\N	110009	110009	110010
23222	35725	44	applied	\N	\N	\N	\N	110011	110011	110012
23222	35727	45	applied	\N	\N	\N	\N	110031	110031	110185
23222	35731	46	applied	\N	\N	\N	\N	110041	110041	110040
23222	35732	47	applied	\N	\N	\N	\N	110043	110043	110042
23222	35734	48	applied	\N	\N	\N	\N	110048	110048	110044
23222	35736	49	applied	\N	\N	\N	\N	110054	110054	110049
23222	35739	50	applied	\N	\N	\N	\N	110065	110065	110055
23222	35741	51	applied	\N	\N	\N	\N	110079	110079	110075
23222	35743	52	applied	\N	\N	\N	\N	110084	110084	110186
23222	35716	53	applied	\N	\N	\N	\N	109980	109980	110080
23222	35745	54	applied	\N	\N	\N	\N	110089	110089	110085
23222	35748	55	applied	\N	\N	\N	\N	110097	110097	110090
23222	35751	56	applied	\N	\N	\N	\N	110105	110105	110187
23222	35752	57	applied	\N	\N	\N	\N	110107	110107	110188
23222	35754	58	applied	\N	\N	\N	\N	110116	110116	110189
23222	35756	59	applied	\N	\N	\N	\N	110128	110128	110190
23222	35759	60	applied	\N	\N	\N	\N	110154	110154	110191
23222	35761	61	applied	\N	\N	\N	\N	110161	110161	110192
23222	35763	62	applied	\N	\N	\N	\N	110169	110169	110193
23222	35766	63	applied	\N	\N	\N	\N	110176	110176	110194
23222	35720	64	applied	\N	\N	\N	\N	109997	109997	110170
23222	35730	65	applied	\N	\N	\N	\N	110039	110039	110195
23222	35738	66	applied	\N	\N	\N	\N	110063	110063	110196
23222	35747	67	applied	\N	\N	\N	\N	110095	110095	110177
23227	35767	0	applied	\N	\N	\N	\N	110201	110201	47675
23227	35768	1	applied	\N	\N	\N	\N	110202	110202	110203
23227	35769	2	applied	\N	\N	\N	\N	110204	110204	110205
23227	35770	3	applied	\N	\N	\N	\N	110206	110206	110207
23227	35771	4	applied	\N	\N	\N	\N	110208	110208	110209
23231	35772	0	applied	\N	\N	\N	\N	110218	110218	110219
23231	35773	1	applied	\N	\N	\N	\N	110220	110220	110221
23232	35774	0	applied	\N	\N	\N	\N	110225	110225	110226
23232	35775	1	applied	\N	\N	\N	\N	110227	110227	110228
23237	35779	0	applied	\N	\N	\N	\N	110242	110242	110243
23237	35780	1	applied	\N	\N	\N	\N	110244	110244	110245
23242	35783	0	applied	\N	\N	\N	\N	110256	110256	110257
23242	35784	1	applied	\N	\N	\N	\N	110258	110258	110259
23243	35785	0	applied	\N	\N	\N	\N	110262	110262	110263
23243	35786	1	applied	\N	\N	\N	\N	110264	110264	110265
23248	35791	0	applied	\N	\N	\N	\N	110281	110281	110282
23248	35792	1	applied	\N	\N	\N	\N	110283	110283	110284
23252	35791	0	applied	\N	\N	\N	\N	110281	110281	110282
23252	35792	1	applied	\N	\N	\N	\N	110283	110283	110284
23253	35793	0	applied	\N	\N	\N	\N	110295	110295	110296
23253	35794	1	applied	\N	\N	\N	\N	110297	110297	110298
23258	35799	0	applied	\N	\N	\N	\N	110314	110314	110315
23258	35800	1	applied	\N	\N	\N	\N	110316	110316	110317
23264	35805	0	applied	\N	\N	\N	\N	110332	110332	110333
23264	35806	1	applied	\N	\N	\N	\N	110334	110334	110335
23264	35807	2	applied	\N	\N	\N	\N	110336	110336	110337
23268	35808	0	applied	\N	\N	\N	\N	110341	110341	110342
23268	35809	1	applied	\N	\N	\N	\N	110343	110343	110344
23269	35810	0	applied	\N	\N	\N	\N	110351	110351	110352
23269	35811	1	applied	\N	\N	\N	\N	110353	110353	110354
23275	35818	0	applied	\N	\N	\N	\N	110375	110375	110376
23275	35819	1	applied	\N	\N	\N	\N	110377	110377	110378
23281	35827	0	applied	\N	\N	\N	\N	110399	110399	110400
23281	35828	1	applied	\N	\N	\N	\N	110401	110401	110402
23288	35839	0	applied	\N	\N	\N	\N	110455	110455	110456
23288	35840	1	applied	\N	\N	\N	\N	110457	110457	110458
23295	35847	0	applied	\N	\N	\N	\N	110504	110504	110505
23295	35848	1	applied	\N	\N	\N	\N	110506	110506	110507
23295	35849	2	applied	\N	\N	\N	\N	110508	110508	110509
23295	35850	3	applied	\N	\N	\N	\N	110510	110510	110511
23302	35359	0	applied	\N	\N	\N	\N	108848	108848	109911
23302	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23302	35767	2	applied	\N	\N	\N	\N	110201	110201	47675
23302	35362	3	applied	\N	\N	\N	\N	108857	108857	109912
23302	35363	4	applied	\N	\N	\N	\N	108859	108859	109913
23302	35364	5	applied	\N	\N	\N	\N	108861	108861	109914
23302	35365	6	applied	\N	\N	\N	\N	108863	108863	109915
23218	35760	0	applied	\N	\N	\N	\N	110159	110159	110160
23218	35761	1	applied	\N	\N	\N	\N	110161	110161	110162
23228	35456	0	applied	\N	\N	\N	\N	109112	109112	109113
23228	35457	1	applied	\N	\N	\N	\N	109114	109114	109115
23228	35758	2	applied	\N	\N	1000000000	\N	110152	110152	110153
23228	35767	3	applied	\N	\N	\N	\N	110201	110201	47675
23228	35462	4	applied	\N	\N	\N	\N	109128	109128	109129
23228	35466	5	applied	\N	\N	\N	\N	109140	109140	109141
23228	35467	6	applied	\N	\N	\N	\N	109142	109142	109143
23228	35472	7	applied	\N	\N	\N	\N	109156	109156	109157
23228	35475	8	applied	\N	\N	\N	\N	109163	109163	109164
23228	35479	9	applied	\N	\N	\N	\N	109174	109174	109175
23228	35482	10	applied	\N	\N	\N	\N	109183	109183	109184
23228	35484	11	applied	\N	\N	\N	\N	109188	109188	109189
23228	35489	12	applied	\N	\N	\N	\N	109204	109204	109205
23228	35492	13	applied	\N	\N	\N	\N	109212	109212	109213
23228	35495	14	applied	\N	\N	\N	\N	109218	109218	109219
23228	35499	15	applied	\N	\N	\N	\N	109227	109227	109228
23228	35502	16	applied	\N	\N	\N	\N	109235	109235	109236
23228	35503	17	applied	\N	\N	\N	\N	109237	109237	109238
23228	35504	18	applied	\N	\N	\N	\N	109239	109239	109240
23228	35512	19	applied	\N	\N	\N	\N	109257	109257	109258
23228	35515	20	applied	\N	\N	\N	\N	109266	109266	109267
23228	35516	21	applied	\N	\N	\N	\N	109268	109268	109269
23228	35517	22	applied	\N	\N	\N	\N	109270	109270	109271
23228	35518	23	applied	\N	\N	\N	\N	109272	109272	109273
23228	35528	24	applied	\N	\N	\N	\N	109314	109314	109315
23228	35532	25	applied	\N	\N	\N	\N	109330	109330	109331
23228	35535	26	applied	\N	\N	\N	\N	109336	109336	109337
23228	35538	27	applied	\N	\N	\N	\N	109344	109344	109345
23228	35539	28	applied	\N	\N	\N	\N	109346	109346	109347
23228	35545	29	applied	\N	\N	\N	\N	109362	109362	109363
23228	35548	30	applied	\N	\N	\N	\N	109371	109371	109372
23228	35549	31	applied	\N	\N	\N	\N	109373	109373	109374
23228	35554	32	applied	\N	\N	\N	\N	109385	109385	109386
23228	35558	33	applied	\N	\N	\N	\N	109396	109396	109397
23228	35560	34	applied	\N	\N	\N	\N	109401	109401	109402
23228	35564	35	applied	\N	\N	\N	\N	109410	109410	109411
23228	35567	36	applied	\N	\N	\N	\N	109416	109416	109417
23228	35570	37	applied	\N	\N	\N	\N	109424	109424	109425
23228	35573	38	applied	\N	\N	\N	\N	109432	109432	109433
23228	35577	39	applied	\N	\N	\N	\N	109444	109444	109445
23228	35580	40	applied	\N	\N	\N	\N	109452	109452	109453
23228	35583	41	applied	\N	\N	\N	\N	109460	109460	109461
23228	35587	42	applied	\N	\N	\N	\N	109469	109469	109470
23228	35588	43	applied	\N	\N	\N	\N	109471	109471	109472
23228	35589	44	applied	\N	\N	\N	\N	109473	109473	109474
23228	35597	45	applied	\N	\N	\N	\N	109490	109490	109491
23228	35601	46	applied	\N	\N	\N	\N	109500	109500	109501
23228	35602	47	applied	\N	\N	\N	\N	109502	109502	109503
23228	35607	48	applied	\N	\N	\N	\N	109513	109513	109514
23228	35610	49	applied	\N	\N	\N	\N	109520	109520	109521
23228	35613	50	applied	\N	\N	\N	\N	109529	109529	109530
23228	35614	51	applied	\N	\N	\N	\N	109531	109531	109532
23228	35621	52	applied	\N	\N	\N	\N	109549	109549	109550
23228	35623	53	applied	\N	\N	\N	\N	109554	109554	109555
23228	35628	54	applied	\N	\N	\N	\N	109604	109604	109605
23228	35629	55	applied	\N	\N	\N	\N	109606	109606	109607
23228	35637	56	applied	\N	\N	\N	\N	109665	109665	109666
23228	35638	57	applied	\N	\N	\N	\N	109667	109667	109668
23228	35643	58	applied	\N	\N	\N	\N	109681	109681	109682
23228	35644	59	applied	\N	\N	\N	\N	109683	109683	109684
23228	35650	60	applied	\N	\N	\N	\N	109701	109701	109702
23228	35653	61	applied	\N	\N	\N	\N	109708	109708	109709
23228	35657	62	applied	\N	\N	\N	\N	109718	109718	109719
23228	35660	63	applied	\N	\N	\N	\N	109726	109726	109727
23228	35663	64	applied	\N	\N	\N	\N	109732	109732	109733
23228	35664	65	applied	\N	\N	\N	\N	109734	109734	109735
23228	35665	66	applied	\N	\N	\N	\N	109736	109736	109737
23228	35673	67	applied	\N	\N	\N	\N	109754	109754	109755
23228	35676	68	applied	\N	\N	\N	\N	109772	109772	109773
23228	35680	69	applied	\N	\N	\N	\N	109784	109784	109785
23228	35682	70	applied	\N	\N	\N	\N	109814	109814	109815
23228	35683	71	applied	\N	\N	\N	\N	109816	109816	109817
23228	35687	72	applied	\N	\N	\N	\N	109827	109827	109828
23228	35689	73	applied	\N	\N	\N	\N	109834	109834	109835
23228	35690	74	applied	\N	\N	\N	\N	109836	109836	109837
23228	35694	75	applied	\N	\N	\N	\N	109847	109847	109848
23228	35695	76	applied	\N	\N	\N	\N	109849	109849	109850
23228	35698	77	applied	\N	\N	\N	\N	109858	109858	109859
23228	35700	78	applied	\N	\N	\N	\N	109865	109865	109866
23228	35703	79	applied	\N	\N	\N	\N	109877	109877	109878
23228	35705	80	applied	\N	\N	\N	\N	109945	109945	109946
23228	35706	81	applied	\N	\N	\N	\N	109947	109947	109948
23228	35710	82	applied	\N	\N	\N	\N	109959	109959	109960
23228	35712	83	applied	\N	\N	\N	\N	109964	109964	109965
23228	35714	84	applied	\N	\N	\N	\N	109970	109970	109971
23228	35715	85	applied	\N	\N	\N	\N	109972	109972	109973
23228	35717	86	applied	\N	\N	\N	\N	109989	109989	109990
23228	35718	87	applied	\N	\N	\N	\N	109991	109991	109992
23228	35719	88	applied	\N	\N	\N	\N	109994	109994	109995
23228	35726	89	applied	\N	\N	\N	\N	110025	110025	110026
23228	35728	90	applied	\N	\N	\N	\N	110035	110035	110036
23228	35729	91	applied	\N	\N	\N	\N	110037	110037	110038
23228	35733	92	applied	\N	\N	\N	\N	110046	110046	110047
23228	35735	93	applied	\N	\N	\N	\N	110052	110052	110053
23228	35737	94	applied	\N	\N	\N	\N	110061	110061	110062
23228	35740	95	applied	\N	\N	\N	\N	110077	110077	110078
23228	35742	96	applied	\N	\N	\N	\N	110082	110082	110083
23228	35744	97	applied	\N	\N	\N	\N	110087	110087	110088
23228	35746	98	applied	\N	\N	\N	\N	110093	110093	110094
23228	35749	99	applied	\N	\N	\N	\N	110101	110101	110102
23228	35750	100	applied	\N	\N	\N	\N	110103	110103	110104
23228	35753	101	applied	\N	\N	\N	\N	110114	110114	110115
23228	35755	102	applied	\N	\N	\N	\N	110126	110126	110127
23228	35757	103	applied	\N	\N	\N	\N	110150	110150	110151
23228	35760	104	applied	\N	\N	\N	\N	110159	110159	110160
23228	35762	105	applied	\N	\N	\N	\N	110167	110167	110168
23228	35765	106	applied	\N	\N	\N	\N	110174	110174	110175
23228	35768	107	applied	\N	\N	\N	\N	110202	110202	110203
23228	35769	108	applied	\N	\N	\N	\N	110204	110204	110205
23228	35458	109	applied	\N	\N	\N	\N	109116	109116	109117
23228	35459	110	applied	\N	\N	\N	\N	109118	109118	109119
23228	35463	111	applied	\N	\N	\N	\N	109130	109130	109274
23228	35460	112	applied	\N	\N	\N	\N	109120	109120	109275
23228	35626	113	applied	\N	\N	\N	\N	109560	109560	109561
23228	35598	114	applied	\N	\N	\N	\N	109492	109492	109493
23228	35464	115	applied	\N	\N	\N	\N	109132	109132	109276
23228	35461	116	applied	\N	\N	\N	\N	109122	109122	109133
23228	35465	117	applied	\N	\N	\N	\N	109134	109134	109135
23228	35468	118	applied	\N	\N	\N	\N	109144	109144	109145
23228	35469	119	applied	\N	\N	\N	\N	109146	109146	109147
23228	35473	120	applied	\N	\N	\N	\N	109158	109158	109277
23228	35627	121	applied	\N	\N	\N	\N	109562	109562	109563
23228	35631	122	applied	\N	\N	\N	\N	109610	109610	109611
23228	35632	123	applied	\N	\N	\N	\N	109613	109613	109614
23228	35470	125	applied	\N	\N	\N	\N	109148	109148	109278
23233	35774	0	applied	\N	\N	\N	\N	110225	110225	110226
23233	35775	1	applied	\N	\N	\N	\N	110227	110227	110228
23238	35779	0	applied	\N	\N	\N	\N	110242	110242	110243
23238	35780	1	applied	\N	\N	\N	\N	110244	110244	110245
23239	35781	0	applied	\N	\N	\N	\N	110250	110250	110251
23239	35782	1	applied	\N	\N	\N	\N	110252	110252	110253
23244	35758	0	applied	\N	\N	1000000000	\N	110152	110152	110153
23244	35767	1	applied	\N	\N	\N	\N	110201	110201	47675
23244	35626	2	applied	\N	\N	\N	\N	109560	109560	109561
23244	35627	3	applied	\N	\N	\N	\N	109562	109562	109563
23244	35631	4	applied	\N	\N	\N	\N	109610	109610	109611
23244	35632	5	applied	\N	\N	\N	\N	109613	109613	109614
23245	35787	0	applied	\N	\N	\N	\N	110269	110269	110270
23245	35788	1	applied	\N	\N	\N	\N	110271	110271	110272
23245	35789	2	applied	\N	\N	\N	\N	110273	110273	110274
23245	35790	3	applied	\N	\N	\N	\N	110275	110275	110276
23249	35791	0	applied	\N	\N	\N	\N	110281	110281	110282
23249	35792	1	applied	\N	\N	\N	\N	110283	110283	110284
23254	35793	0	applied	\N	\N	\N	\N	110295	110295	110296
23254	35794	1	applied	\N	\N	\N	\N	110297	110297	110298
23259	35799	0	applied	\N	\N	\N	\N	110314	110314	110315
23259	35800	1	applied	\N	\N	\N	\N	110316	110316	110317
23265	35808	0	applied	\N	\N	\N	\N	110341	110341	110342
23265	35809	1	applied	\N	\N	\N	\N	110343	110343	110344
23270	35810	0	applied	\N	\N	\N	\N	110351	110351	110352
23270	35811	1	applied	\N	\N	\N	\N	110353	110353	110354
23276	35818	0	applied	\N	\N	\N	\N	110375	110375	110376
23276	35819	1	applied	\N	\N	\N	\N	110377	110377	110378
23277	35820	0	applied	\N	\N	\N	\N	110381	110381	110382
23277	35821	1	applied	\N	\N	\N	\N	110383	110383	110384
23277	35822	2	applied	\N	\N	\N	\N	110385	110385	110386
23277	35823	3	applied	\N	\N	\N	\N	110387	110387	110388
23282	35827	0	applied	\N	\N	\N	\N	110399	110399	110400
23282	35828	1	applied	\N	\N	\N	\N	110401	110401	110402
23283	35829	0	applied	\N	\N	\N	\N	110407	110407	110408
23283	35830	1	applied	\N	\N	\N	\N	110409	110409	110410
23289	35839	0	applied	\N	\N	\N	\N	110455	110455	110456
23289	35840	1	applied	\N	\N	\N	\N	110457	110457	110458
23296	35851	0	applied	\N	\N	\N	\N	110517	110517	110518
23296	35852	1	applied	\N	\N	\N	\N	110519	110519	110520
23303	35863	0	applied	\N	\N	\N	\N	110638	110638	110639
23303	35864	1	applied	\N	\N	\N	\N	110640	110640	110641
23309	35871	0	applied	\N	\N	\N	\N	110662	110662	110663
23309	35872	1	applied	\N	\N	\N	\N	110664	110664	110665
23316	35879	0	applied	\N	\N	\N	\N	110689	110689	110690
23316	35880	1	applied	\N	\N	\N	\N	110691	110691	110692
23316	35881	2	applied	\N	\N	\N	\N	110693	110693	110694
23316	35882	3	applied	\N	\N	\N	\N	110695	110695	110696
23322	35891	0	applied	\N	\N	\N	\N	110722	110722	110723
23322	35892	1	applied	\N	\N	\N	\N	110724	110724	110725
23323	35893	0	applied	\N	\N	\N	\N	110729	110729	110730
23323	35894	1	applied	\N	\N	\N	\N	110731	110731	110732
23332	35482	0	applied	\N	\N	\N	\N	109183	109183	109184
23332	35484	1	applied	\N	\N	\N	\N	109188	109188	109189
23332	35758	2	applied	\N	\N	1000000000	\N	110152	110152	110153
23332	35767	3	applied	\N	\N	\N	\N	110201	110201	47675
23332	35489	4	applied	\N	\N	\N	\N	109204	109204	109205
23332	35492	5	applied	\N	\N	\N	\N	109212	109212	109213
23332	35495	6	applied	\N	\N	\N	\N	109218	109218	109219
23332	35499	7	applied	\N	\N	\N	\N	109227	109227	109228
23332	35502	8	applied	\N	\N	\N	\N	109235	109235	109236
23332	35503	9	applied	\N	\N	\N	\N	109237	109237	109238
23332	35504	10	applied	\N	\N	\N	\N	109239	109239	109240
23332	35512	11	applied	\N	\N	\N	\N	109257	109257	109258
23332	35515	12	applied	\N	\N	\N	\N	109266	109266	109267
23332	35516	13	applied	\N	\N	\N	\N	109268	109268	109269
23332	35517	14	applied	\N	\N	\N	\N	109270	109270	109271
23332	35518	15	applied	\N	\N	\N	\N	109272	109272	109273
23332	35528	16	applied	\N	\N	\N	\N	109314	109314	109315
23332	35532	17	applied	\N	\N	\N	\N	109330	109330	109331
23332	35535	18	applied	\N	\N	\N	\N	109336	109336	109337
23332	35538	19	applied	\N	\N	\N	\N	109344	109344	109345
23332	35539	20	applied	\N	\N	\N	\N	109346	109346	109347
23332	35545	21	applied	\N	\N	\N	\N	109362	109362	109363
23332	35548	22	applied	\N	\N	\N	\N	109371	109371	109372
23332	35549	23	applied	\N	\N	\N	\N	109373	109373	109374
23332	35554	24	applied	\N	\N	\N	\N	109385	109385	109386
23332	35558	25	applied	\N	\N	\N	\N	109396	109396	109397
23332	35560	26	applied	\N	\N	\N	\N	109401	109401	109402
23332	35564	27	applied	\N	\N	\N	\N	109410	109410	109411
23332	35567	28	applied	\N	\N	\N	\N	109416	109416	109417
23332	35570	29	applied	\N	\N	\N	\N	109424	109424	109425
23332	35573	30	applied	\N	\N	\N	\N	109432	109432	109433
23332	35577	31	applied	\N	\N	\N	\N	109444	109444	109445
23332	35580	32	applied	\N	\N	\N	\N	109452	109452	109453
23332	35583	33	applied	\N	\N	\N	\N	109460	109460	109461
23332	35587	34	applied	\N	\N	\N	\N	109469	109469	109470
23332	35588	35	applied	\N	\N	\N	\N	109471	109471	109472
23332	35589	36	applied	\N	\N	\N	\N	109473	109473	109474
23332	35597	37	applied	\N	\N	\N	\N	109490	109490	109491
23332	35601	38	applied	\N	\N	\N	\N	109500	109500	109501
23332	35602	39	applied	\N	\N	\N	\N	109502	109502	109503
23332	35607	40	applied	\N	\N	\N	\N	109513	109513	109514
23332	35610	41	applied	\N	\N	\N	\N	109520	109520	109521
23332	35613	42	applied	\N	\N	\N	\N	109529	109529	109530
23332	35614	43	applied	\N	\N	\N	\N	109531	109531	109532
23332	35621	44	applied	\N	\N	\N	\N	109549	109549	109550
23332	35623	45	applied	\N	\N	\N	\N	109554	109554	109555
23332	35628	46	applied	\N	\N	\N	\N	109604	109604	109605
23332	35629	47	applied	\N	\N	\N	\N	109606	109606	109607
23332	35637	48	applied	\N	\N	\N	\N	109665	109665	109666
23332	35638	49	applied	\N	\N	\N	\N	109667	109667	109668
23332	35643	50	applied	\N	\N	\N	\N	109681	109681	109682
23332	35644	51	applied	\N	\N	\N	\N	109683	109683	109684
23332	35650	52	applied	\N	\N	\N	\N	109701	109701	109702
23332	35653	53	applied	\N	\N	\N	\N	109708	109708	109709
23332	35657	54	applied	\N	\N	\N	\N	109718	109718	109719
23332	35660	55	applied	\N	\N	\N	\N	109726	109726	109727
23332	35663	56	applied	\N	\N	\N	\N	109732	109732	109733
23332	35664	57	applied	\N	\N	\N	\N	109734	109734	109735
23332	35665	58	applied	\N	\N	\N	\N	109736	109736	109737
23332	35673	59	applied	\N	\N	\N	\N	109754	109754	109755
23266	35808	0	applied	\N	\N	\N	\N	110341	110341	110342
23266	35809	1	applied	\N	\N	\N	\N	110343	110343	110344
23271	35806	0	applied	\N	\N	\N	\N	110334	110334	110335
23272	35812	0	applied	\N	\N	\N	\N	110360	110360	110361
23272	35813	1	applied	\N	\N	\N	\N	110362	110362	110363
23272	35814	2	applied	\N	\N	\N	\N	110364	110364	110365
23272	35815	3	applied	\N	\N	\N	\N	110366	110366	110367
23272	35816	4	applied	\N	\N	\N	\N	110368	110368	110369
23272	35817	5	applied	\N	\N	\N	\N	110370	110370	110371
23278	35824	0	applied	\N	\N	\N	\N	110390	110390	110391
23279	35825	0	applied	\N	\N	\N	\N	110393	110393	110394
23279	35826	1	applied	\N	\N	\N	\N	110395	110395	110396
23284	35755	0	applied	\N	\N	\N	\N	110126	110126	110127
23284	35757	1	applied	\N	\N	\N	\N	110150	110150	110151
23284	35760	2	applied	\N	\N	\N	\N	110159	110159	110160
23284	35762	3	applied	\N	\N	\N	\N	110167	110167	110168
23284	35758	4	applied	\N	\N	1000000000	\N	110152	110152	110153
23284	35767	5	applied	\N	\N	\N	\N	110201	110201	47675
23284	35765	6	applied	\N	\N	\N	\N	110174	110174	110175
23284	35768	7	applied	\N	\N	\N	\N	110202	110202	110203
23284	35769	8	applied	\N	\N	\N	\N	110204	110204	110205
23284	35772	9	applied	\N	\N	\N	\N	110218	110218	110219
23284	35774	10	applied	\N	\N	\N	\N	110225	110225	110226
23284	35777	11	applied	\N	\N	\N	\N	110234	110234	110235
23284	35779	12	applied	\N	\N	\N	\N	110242	110242	110243
23284	35781	13	applied	\N	\N	\N	\N	110250	110250	110251
23284	35783	14	applied	\N	\N	\N	\N	110256	110256	110257
23284	35785	15	applied	\N	\N	\N	\N	110262	110262	110263
23284	35787	16	applied	\N	\N	\N	\N	110269	110269	110270
23284	35788	17	applied	\N	\N	\N	\N	110271	110271	110272
23284	35791	18	applied	\N	\N	\N	\N	110281	110281	110282
23284	35793	19	applied	\N	\N	\N	\N	110295	110295	110296
23284	35795	20	applied	\N	\N	\N	\N	110303	110303	110304
23284	35797	21	applied	\N	\N	\N	\N	110308	110308	110309
23284	35799	22	applied	\N	\N	\N	\N	110314	110314	110315
23284	35801	23	applied	\N	\N	\N	\N	110322	110322	110323
23284	35803	24	applied	\N	\N	\N	\N	110326	110326	110327
23284	35805	25	applied	\N	\N	\N	\N	110332	110332	110333
23284	35808	26	applied	\N	\N	\N	\N	110341	110341	110342
23284	35810	27	applied	\N	\N	\N	\N	110351	110351	110352
23284	35812	28	applied	\N	\N	\N	\N	110360	110360	110361
23284	35813	29	applied	\N	\N	\N	\N	110362	110362	110363
23284	35814	30	applied	\N	\N	\N	\N	110364	110364	110365
23284	35818	31	applied	\N	\N	\N	\N	110375	110375	110376
23284	35820	32	applied	\N	\N	\N	\N	110381	110381	110382
23284	35821	33	applied	\N	\N	\N	\N	110383	110383	110384
23284	35824	34	applied	\N	\N	\N	\N	110390	110390	110391
23284	35825	35	applied	\N	\N	\N	\N	110393	110393	110394
23284	35827	36	applied	\N	\N	\N	\N	110399	110399	110400
23284	35829	37	applied	\N	\N	\N	\N	110407	110407	110408
23284	35806	38	applied	\N	\N	\N	\N	110334	110334	110335
23284	35645	39	applied	\N	\N	\N	\N	109685	109685	109467
23284	35595	40	applied	\N	\N	\N	\N	109485	109485	109476
23284	35596	41	applied	\N	\N	\N	\N	109487	109487	109647
23284	35656	42	applied	\N	\N	\N	\N	109714	109714	109480
23284	35666	43	applied	\N	\N	\N	\N	109738	109738	109482
23284	35679	44	applied	\N	\N	\N	\N	109778	109778	109978
23284	35684	45	applied	\N	\N	\N	\N	109818	109818	109484
23284	35691	46	applied	\N	\N	\N	\N	109838	109838	109979
23284	35702	47	applied	\N	\N	\N	\N	109869	109869	109648
23284	35707	48	applied	\N	\N	\N	\N	109949	109949	109486
23284	35716	49	applied	\N	\N	\N	\N	109980	109980	109649
23284	35720	51	applied	\N	\N	\N	\N	109997	109997	110414
23284	35730	52	applied	\N	\N	\N	\N	110039	110039	109488
23284	35738	53	applied	\N	\N	\N	\N	110063	110063	110415
23284	35747	54	applied	\N	\N	\N	\N	110095	110095	109495
23284	35576	55	applied	\N	\N	\N	\N	109438	109438	109650
23284	35579	56	applied	\N	\N	\N	\N	109448	109448	109651
23284	35581	57	applied	\N	\N	\N	\N	109454	109454	109652
23284	35586	58	applied	\N	\N	\N	\N	109466	109466	109507
23284	35591	59	applied	\N	\N	\N	\N	109477	109477	109509
23284	35592	60	applied	\N	\N	\N	\N	109479	109479	109653
23284	35594	61	applied	\N	\N	\N	\N	109483	109483	109654
23284	35599	62	applied	\N	\N	\N	\N	109494	109494	109516
23284	35603	63	applied	\N	\N	\N	\N	109504	109504	109655
23284	35605	64	applied	\N	\N	\N	\N	109508	109508	109981
23284	35611	65	applied	\N	\N	\N	\N	109522	109522	109525
23284	35617	66	applied	\N	\N	\N	\N	109537	109537	109657
23284	35618	67	applied	\N	\N	\N	\N	109539	109539	109536
23284	35620	68	applied	\N	\N	\N	\N	109545	109545	109538
23284	35624	69	applied	\N	\N	\N	\N	109556	109556	109540
23284	35633	70	applied	\N	\N	\N	\N	109615	109615	109983
23284	35635	71	applied	\N	\N	\N	\N	109624	109624	109984
23284	35639	72	applied	\N	\N	\N	\N	109669	109669	109659
23284	35640	73	applied	\N	\N	\N	\N	109671	109671	109552
23284	35646	74	applied	\N	\N	\N	\N	109687	109687	109557
23284	35647	75	applied	\N	\N	\N	\N	109689	109689	109661
23284	35652	76	applied	\N	\N	\N	\N	109705	109705	109609
23284	35655	77	applied	\N	\N	\N	\N	109712	109712	109616
23284	35658	78	applied	\N	\N	\N	\N	109720	109720	109631
23284	35662	79	applied	\N	\N	\N	\N	109730	109730	109790
23284	35667	80	applied	\N	\N	\N	\N	109740	109740	109791
23284	35668	81	applied	\N	\N	\N	\N	109742	109742	109627
23284	35670	82	applied	\N	\N	\N	\N	109746	109746	109792
23284	35675	83	applied	\N	\N	\N	\N	109758	109758	109673
23284	35677	84	applied	\N	\N	\N	\N	109774	109774	109793
23284	35600	85	applied	\N	\N	\N	\N	109496	109496	110416
23284	35604	86	applied	\N	\N	\N	\N	109506	109506	109795
23284	35606	87	applied	\N	\N	\N	\N	109510	109510	109690
23284	35608	88	applied	\N	\N	\N	\N	109515	109515	109692
23284	35612	89	applied	\N	\N	\N	\N	109524	109524	109694
23284	35616	90	applied	\N	\N	\N	\N	109535	109535	109704
23284	35619	91	applied	\N	\N	\N	\N	109541	109541	110417
23284	35622	92	applied	\N	\N	\N	\N	109551	109551	110418
23284	35625	93	applied	\N	\N	\N	\N	109558	109558	110419
23284	35634	94	applied	\N	\N	\N	\N	109621	109621	110420
23284	35636	95	applied	\N	\N	\N	\N	109626	109626	110421
23284	35641	96	applied	\N	\N	\N	\N	109674	109674	109731
23284	35642	97	applied	\N	\N	\N	\N	109676	109676	109741
23284	35648	98	applied	\N	\N	\N	\N	109691	109691	110422
23284	35649	99	applied	\N	\N	\N	\N	109693	109693	110423
23284	35651	100	applied	\N	\N	\N	\N	109703	109703	110424
23284	35654	101	applied	\N	\N	\N	\N	109710	109710	110425
23284	35659	102	applied	\N	\N	\N	\N	109722	109722	110426
23284	35661	103	applied	\N	\N	\N	\N	109728	109728	109759
23284	35669	104	applied	\N	\N	\N	\N	109744	109744	110427
23284	35671	105	applied	\N	\N	\N	\N	109748	109748	109779
23284	35672	106	applied	\N	\N	\N	\N	109750	109750	109787
23284	35674	107	applied	\N	\N	\N	\N	109756	109756	110428
23284	35678	108	applied	\N	\N	\N	\N	109776	109776	110429
23284	35681	109	applied	\N	\N	\N	\N	109786	109786	110430
23284	35685	110	applied	\N	\N	\N	\N	109820	109820	110431
23285	35831	0	applied	\N	\N	\N	\N	110434	110434	110435
23285	35832	1	applied	\N	\N	\N	\N	110436	110436	110437
23285	35833	2	applied	\N	\N	\N	\N	110438	110438	110439
23285	35834	3	applied	\N	\N	\N	\N	110440	110440	110441
23285	35835	4	applied	\N	\N	\N	\N	110442	110442	110443
23285	35836	5	applied	\N	\N	\N	\N	110444	110444	110445
23290	35676	0	applied	\N	\N	\N	\N	109772	109772	109773
23290	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23290	35767	2	applied	\N	\N	\N	\N	110201	110201	47675
23290	35680	3	applied	\N	\N	\N	\N	109784	109784	109785
23290	35682	4	applied	\N	\N	\N	\N	109814	109814	109815
23290	35683	5	applied	\N	\N	\N	\N	109816	109816	109817
23290	35687	6	applied	\N	\N	\N	\N	109827	109827	109828
23290	35689	7	applied	\N	\N	\N	\N	109834	109834	109835
23290	35690	8	applied	\N	\N	\N	\N	109836	109836	109837
23290	35694	9	applied	\N	\N	\N	\N	109847	109847	109848
23290	35695	10	applied	\N	\N	\N	\N	109849	109849	109850
23290	35698	11	applied	\N	\N	\N	\N	109858	109858	109859
23290	35700	12	applied	\N	\N	\N	\N	109865	109865	109866
23290	35703	13	applied	\N	\N	\N	\N	109877	109877	109878
23290	35705	14	applied	\N	\N	\N	\N	109945	109945	109946
23290	35706	15	applied	\N	\N	\N	\N	109947	109947	109948
23290	35710	16	applied	\N	\N	\N	\N	109959	109959	109960
23290	35712	17	applied	\N	\N	\N	\N	109964	109964	109965
23290	35714	18	applied	\N	\N	\N	\N	109970	109970	109971
23290	35715	19	applied	\N	\N	\N	\N	109972	109972	109973
23290	35717	20	applied	\N	\N	\N	\N	109989	109989	109990
23290	35718	21	applied	\N	\N	\N	\N	109991	109991	109992
23290	35719	22	applied	\N	\N	\N	\N	109994	109994	109995
23290	35726	23	applied	\N	\N	\N	\N	110025	110025	110026
23290	35728	24	applied	\N	\N	\N	\N	110035	110035	110036
23290	35729	25	applied	\N	\N	\N	\N	110037	110037	110038
23290	35733	26	applied	\N	\N	\N	\N	110046	110046	110047
23290	35735	27	applied	\N	\N	\N	\N	110052	110052	110053
23290	35737	28	applied	\N	\N	\N	\N	110061	110061	110062
23290	35740	29	applied	\N	\N	\N	\N	110077	110077	110078
23290	35742	30	applied	\N	\N	\N	\N	110082	110082	110083
23290	35744	31	applied	\N	\N	\N	\N	110087	110087	110088
23290	35746	32	applied	\N	\N	\N	\N	110093	110093	110094
23290	35749	33	applied	\N	\N	\N	\N	110101	110101	110102
23290	35750	34	applied	\N	\N	\N	\N	110103	110103	110104
23290	35753	35	applied	\N	\N	\N	\N	110114	110114	110115
23290	35755	36	applied	\N	\N	\N	\N	110126	110126	110127
23290	35757	37	applied	\N	\N	\N	\N	110150	110150	110151
23290	35760	38	applied	\N	\N	\N	\N	110159	110159	110160
23290	35762	39	applied	\N	\N	\N	\N	110167	110167	110168
23290	35765	40	applied	\N	\N	\N	\N	110174	110174	110175
23290	35768	41	applied	\N	\N	\N	\N	110202	110202	110203
23290	35769	42	applied	\N	\N	\N	\N	110204	110204	110205
23290	35772	43	applied	\N	\N	\N	\N	110218	110218	110219
23290	35774	44	applied	\N	\N	\N	\N	110225	110225	110226
23290	35777	45	applied	\N	\N	\N	\N	110234	110234	110235
23290	35779	46	applied	\N	\N	\N	\N	110242	110242	110243
23290	35781	47	applied	\N	\N	\N	\N	110250	110250	110251
23290	35783	48	applied	\N	\N	\N	\N	110256	110256	110257
23290	35785	49	applied	\N	\N	\N	\N	110262	110262	110263
23290	35787	50	applied	\N	\N	\N	\N	110269	110269	110270
23290	35788	51	applied	\N	\N	\N	\N	110271	110271	110272
23290	35791	52	applied	\N	\N	\N	\N	110281	110281	110282
23290	35793	53	applied	\N	\N	\N	\N	110295	110295	110296
23290	35795	54	applied	\N	\N	\N	\N	110303	110303	110304
23290	35797	55	applied	\N	\N	\N	\N	110308	110308	110309
23290	35799	56	applied	\N	\N	\N	\N	110314	110314	110315
23290	35801	57	applied	\N	\N	\N	\N	110322	110322	110323
23290	35803	58	applied	\N	\N	\N	\N	110326	110326	110327
23290	35805	59	applied	\N	\N	\N	\N	110332	110332	110333
23290	35808	60	applied	\N	\N	\N	\N	110341	110341	110342
23290	35810	61	applied	\N	\N	\N	\N	110351	110351	110352
23290	35812	62	applied	\N	\N	\N	\N	110360	110360	110361
23290	35813	63	applied	\N	\N	\N	\N	110362	110362	110363
23290	35814	64	applied	\N	\N	\N	\N	110364	110364	110365
23290	35818	65	applied	\N	\N	\N	\N	110375	110375	110376
23290	35820	66	applied	\N	\N	\N	\N	110381	110381	110382
23290	35821	67	applied	\N	\N	\N	\N	110383	110383	110384
23290	35824	68	applied	\N	\N	\N	\N	110390	110390	110391
23290	35825	69	applied	\N	\N	\N	\N	110393	110393	110394
23290	35827	70	applied	\N	\N	\N	\N	110399	110399	110400
23290	35829	71	applied	\N	\N	\N	\N	110407	110407	110408
23290	35831	72	applied	\N	\N	\N	\N	110434	110434	110435
23290	35832	73	applied	\N	\N	\N	\N	110436	110436	110437
23290	35833	74	applied	\N	\N	\N	\N	110438	110438	110439
23290	35837	75	applied	\N	\N	\N	\N	110449	110449	110450
23290	35839	76	applied	\N	\N	\N	\N	110455	110455	110456
23290	35806	77	applied	\N	\N	\N	\N	110334	110334	110335
23290	35311	78	applied	\N	\N	\N	\N	108717	108717	108724
23290	35314	79	applied	\N	\N	\N	\N	108725	108725	108726
23290	35318	80	applied	\N	\N	\N	\N	108734	108734	110462
23290	35319	82	applied	\N	\N	\N	\N	108736	108736	110465
23290	35326	83	applied	\N	\N	\N	\N	108752	108752	108739
23290	35327	84	applied	\N	\N	\N	\N	108754	108754	110466
23290	35334	85	applied	\N	\N	\N	\N	108768	108768	110467
23290	35335	86	applied	\N	\N	\N	\N	108770	108770	108757
23290	35337	87	applied	\N	\N	\N	\N	108775	108775	108761
23290	35340	88	applied	\N	\N	\N	\N	108785	108785	110468
23290	35343	89	applied	\N	\N	\N	\N	108799	108799	108767
23290	35348	90	applied	\N	\N	\N	\N	108811	108811	108769
23290	35350	91	applied	\N	\N	\N	\N	108817	108817	108771
23290	35357	92	applied	\N	\N	\N	\N	108837	108837	108776
23290	35358	93	applied	\N	\N	\N	\N	108839	108839	110469
23290	35361	94	applied	\N	\N	\N	\N	108852	108852	110470
23290	35366	95	applied	\N	\N	\N	\N	108865	108865	110471
23290	35368	96	applied	\N	\N	\N	\N	108869	108869	108802
23290	35369	97	applied	\N	\N	\N	\N	108871	108871	108810
23290	35370	98	applied	\N	\N	\N	\N	108873	108873	108812
23290	35376	99	applied	\N	\N	\N	\N	108895	108895	108818
23290	35379	100	applied	\N	\N	\N	\N	108910	108910	108845
23290	35383	101	applied	\N	\N	\N	\N	108922	108922	110472
23290	35384	102	applied	\N	\N	\N	\N	108925	108925	110473
23290	35394	103	applied	\N	\N	\N	\N	108946	108946	110474
23290	35395	104	applied	\N	\N	\N	\N	108948	108948	108851
23290	35396	105	applied	\N	\N	\N	\N	108950	108950	108853
23290	35400	106	applied	\N	\N	\N	\N	108962	108962	108866
23290	35401	107	applied	\N	\N	\N	\N	108964	108964	110475
23290	35402	108	applied	\N	\N	\N	\N	108966	108966	110476
23290	35409	109	applied	\N	\N	\N	\N	108984	108984	110477
23290	35412	110	applied	\N	\N	\N	\N	108990	108990	108876
23290	35416	111	applied	\N	\N	\N	\N	109001	109001	110478
23290	35419	112	applied	\N	\N	\N	\N	109010	109010	108882
23290	35423	113	applied	\N	\N	\N	\N	109021	109021	108896
23290	35426	114	applied	\N	\N	\N	\N	109029	109029	110479
23290	35429	115	applied	\N	\N	\N	\N	109037	109037	108915
23290	35430	116	applied	\N	\N	\N	\N	109039	109039	108924
23290	35436	117	applied	\N	\N	\N	\N	109054	109054	108926
23290	35438	118	applied	\N	\N	\N	\N	109060	109060	110480
23290	35442	119	applied	\N	\N	\N	\N	109070	109070	108939
23290	35444	120	applied	\N	\N	\N	\N	109074	109074	108943
23290	35447	121	applied	\N	\N	\N	\N	109083	109083	110481
23290	35451	122	applied	\N	\N	\N	\N	109092	109092	110482
23290	35453	123	applied	\N	\N	\N	\N	109099	109099	110483
23290	35458	124	applied	\N	\N	\N	\N	109116	109116	110484
23290	35459	125	applied	\N	\N	\N	\N	109118	109118	110485
23291	35841	0	applied	\N	\N	\N	\N	110488	110488	110489
23291	35842	1	applied	\N	\N	\N	\N	110490	110490	110491
23291	35843	2	applied	\N	\N	\N	\N	110492	110492	110493
23291	35844	3	applied	\N	\N	\N	\N	110494	110494	110495
23292	35845	0	applied	\N	\N	\N	\N	110498	110498	110499
23292	35846	1	applied	\N	\N	\N	\N	110500	110500	110501
23293	35847	0	applied	\N	\N	\N	\N	110504	110504	110505
23293	35848	1	applied	\N	\N	\N	\N	110506	110506	110507
23293	35849	2	applied	\N	\N	\N	\N	110508	110508	110509
23293	35850	3	applied	\N	\N	\N	\N	110510	110510	110511
23297	35851	0	applied	\N	\N	\N	\N	110517	110517	110518
23297	35852	1	applied	\N	\N	\N	\N	110519	110519	110520
23298	35853	0	applied	\N	\N	\N	\N	110521	110521	110522
23298	35854	1	applied	\N	\N	\N	\N	110523	110523	110524
23298	35855	2	applied	\N	\N	\N	\N	110525	110525	110526
23298	35856	3	applied	\N	\N	\N	\N	110527	110527	110528
23299	35857	0	applied	\N	\N	\N	\N	110530	110530	110531
23299	35858	1	applied	\N	\N	\N	\N	110532	110532	110533
23304	35863	0	applied	\N	\N	\N	\N	110638	110638	110639
23304	35864	1	applied	\N	\N	\N	\N	110640	110640	110641
23310	35871	0	applied	\N	\N	\N	\N	110662	110662	110663
23310	35872	1	applied	\N	\N	\N	\N	110664	110664	110665
23311	35873	0	applied	\N	\N	\N	\N	110670	110670	110671
23317	35879	0	applied	\N	\N	\N	\N	110689	110689	110690
23317	35880	1	applied	\N	\N	\N	\N	110691	110691	110692
23317	35881	2	applied	\N	\N	\N	\N	110693	110693	110694
23317	35882	3	applied	\N	\N	\N	\N	110695	110695	110696
23318	35883	0	applied	\N	\N	\N	\N	110703	110703	110704
23318	35884	1	applied	\N	\N	\N	\N	110705	110705	110706
23318	35885	2	applied	\N	\N	\N	\N	110707	110707	110708
23318	35886	3	applied	\N	\N	\N	\N	110709	110709	110710
23324	35806	0	applied	\N	\N	\N	\N	110334	110334	110335
23329	35895	0	applied	\N	\N	\N	\N	110735	110735	110736
23329	35896	1	applied	\N	\N	\N	\N	110737	110737	110738
23329	35897	2	applied	\N	\N	\N	\N	110739	110739	110740
23329	35898	3	applied	\N	\N	\N	\N	110741	110741	110742
23334	35901	0	applied	\N	\N	\N	\N	110760	110760	110761
23334	35902	1	applied	\N	\N	\N	\N	110762	110762	110763
23339	35907	0	applied	\N	\N	\N	\N	110778	110778	110779
23339	35908	1	applied	\N	\N	\N	\N	110780	110780	110781
23340	35909	0	applied	\N	\N	\N	\N	110784	110784	110785
23340	35910	1	applied	\N	\N	\N	\N	110786	110786	110787
23340	35911	2	applied	\N	\N	\N	\N	110788	110788	110789
23340	35912	3	applied	\N	\N	\N	\N	110790	110790	110791
23346	35920	0	applied	\N	\N	\N	\N	110814	110814	110815
23352	35923	0	applied	\N	\N	\N	\N	110825	110825	110826
23352	35924	1	applied	\N	\N	\N	\N	110827	110827	110828
23352	35925	2	applied	\N	\N	\N	\N	110829	110829	110830
23352	35926	3	applied	\N	\N	\N	\N	110831	110831	110832
23358	35935	0	applied	\N	\N	\N	\N	110960	110960	110961
23364	35941	0	applied	\N	\N	\N	\N	110983	110983	110984
23364	35942	1	applied	\N	\N	\N	\N	110985	110985	110986
23365	35943	0	applied	\N	\N	\N	\N	110989	110989	110990
23365	35944	1	applied	\N	\N	\N	\N	110991	110991	110992
23365	35945	2	applied	\N	\N	\N	\N	110993	110993	110994
23365	35946	3	applied	\N	\N	\N	\N	110995	110995	110996
23371	35955	0	applied	\N	\N	\N	\N	111026	111026	111027
23371	35956	1	applied	\N	\N	\N	\N	111028	111028	111029
23376	35957	0	applied	\N	\N	\N	\N	111034	111034	111035
23376	35958	1	applied	\N	\N	\N	\N	111036	111036	111037
23377	35959	0	applied	\N	\N	\N	\N	111041	111041	111042
23377	35960	1	applied	\N	\N	\N	\N	111043	111043	111044
23377	35961	2	applied	\N	\N	\N	\N	111045	111045	111046
23377	35962	3	applied	\N	\N	\N	\N	111047	111047	111048
23377	35963	4	applied	\N	\N	\N	\N	111049	111049	111050
23382	35965	0	applied	\N	\N	\N	\N	111057	111057	111058
23382	35966	1	applied	\N	\N	\N	\N	111059	111059	111060
23393	35983	0	applied	\N	\N	\N	\N	111111	111111	111112
23393	35984	1	applied	\N	\N	\N	\N	111113	111113	111114
23393	35985	2	applied	\N	\N	\N	\N	111115	111115	111116
23393	35986	3	applied	\N	\N	\N	\N	111117	111117	111118
23399	35987	0	applied	\N	\N	\N	\N	111196	111196	111197
23399	35988	1	applied	\N	\N	\N	\N	111198	111198	111199
23410	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23410	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23410	35767	2	applied	\N	\N	\N	\N	110201	110201	47675
23410	35680	3	applied	\N	\N	\N	\N	109784	109784	109785
23410	35682	4	applied	\N	\N	\N	\N	109814	109814	109815
23410	35683	5	applied	\N	\N	\N	\N	109816	109816	109817
23410	35687	6	applied	\N	\N	\N	\N	109827	109827	109828
23410	35689	7	applied	\N	\N	\N	\N	109834	109834	109835
23410	35690	8	applied	\N	\N	\N	\N	109836	109836	109837
23410	35694	9	applied	\N	\N	\N	\N	109847	109847	109848
23410	35695	10	applied	\N	\N	\N	\N	109849	109849	109850
23410	35698	11	applied	\N	\N	\N	\N	109858	109858	109859
23410	35700	12	applied	\N	\N	\N	\N	109865	109865	109866
23410	35703	13	applied	\N	\N	\N	\N	109877	109877	109878
23410	35705	14	applied	\N	\N	\N	\N	109945	109945	109946
23410	35706	15	applied	\N	\N	\N	\N	109947	109947	109948
23410	35710	16	applied	\N	\N	\N	\N	109959	109959	109960
23410	35712	17	applied	\N	\N	\N	\N	109964	109964	109965
23410	35714	18	applied	\N	\N	\N	\N	109970	109970	109971
23410	35715	19	applied	\N	\N	\N	\N	109972	109972	109973
23410	35717	20	applied	\N	\N	\N	\N	109989	109989	109990
23410	35718	21	applied	\N	\N	\N	\N	109991	109991	109992
23410	35719	22	applied	\N	\N	\N	\N	109994	109994	109995
23410	35726	23	applied	\N	\N	\N	\N	110025	110025	110026
23410	35728	24	applied	\N	\N	\N	\N	110035	110035	110036
23410	35729	25	applied	\N	\N	\N	\N	110037	110037	110038
23410	35733	26	applied	\N	\N	\N	\N	110046	110046	110047
23410	35735	27	applied	\N	\N	\N	\N	110052	110052	110053
23410	35737	28	applied	\N	\N	\N	\N	110061	110061	110062
23410	35740	29	applied	\N	\N	\N	\N	110077	110077	110078
23410	35742	30	applied	\N	\N	\N	\N	110082	110082	110083
23410	35744	31	applied	\N	\N	\N	\N	110087	110087	110088
23410	35746	32	applied	\N	\N	\N	\N	110093	110093	110094
23410	35749	33	applied	\N	\N	\N	\N	110101	110101	110102
23302	35375	7	applied	\N	\N	\N	\N	108888	108888	109916
23302	35378	8	applied	\N	\N	\N	\N	108908	108908	109917
23302	35381	9	applied	\N	\N	\N	\N	108918	108918	109918
23302	35382	10	applied	\N	\N	\N	\N	108920	108920	109919
23302	35387	11	applied	\N	\N	\N	\N	108932	108932	109920
23302	35388	12	applied	\N	\N	\N	\N	108934	108934	109921
23302	35389	13	applied	\N	\N	\N	\N	108936	108936	109922
23302	35397	14	applied	\N	\N	\N	\N	108956	108956	109923
23302	35398	15	applied	\N	\N	\N	\N	108958	108958	109924
23302	35399	16	applied	\N	\N	\N	\N	108960	108960	109925
23302	35407	17	applied	\N	\N	\N	\N	108980	108980	109926
23302	35408	18	applied	\N	\N	\N	\N	108982	108982	109927
23302	35414	19	applied	\N	\N	\N	\N	108997	108997	109928
23302	35417	20	applied	\N	\N	\N	\N	109006	109006	109929
23302	35420	21	applied	\N	\N	\N	\N	109015	109015	109930
23302	35424	22	applied	\N	\N	\N	\N	109025	109025	109931
23302	35427	23	applied	\N	\N	\N	\N	109033	109033	109932
23302	35428	24	applied	\N	\N	\N	\N	109035	109035	109933
23302	35434	25	applied	\N	\N	\N	\N	109050	109050	109934
23302	35439	26	applied	\N	\N	\N	\N	109064	109064	109935
23302	35440	27	applied	\N	\N	\N	\N	109066	109066	109936
23302	35446	28	applied	\N	\N	\N	\N	109081	109081	109937
23302	35449	29	applied	\N	\N	\N	\N	109088	109088	109938
23302	35452	30	applied	\N	\N	\N	\N	109097	109097	109939
23302	35456	31	applied	\N	\N	\N	\N	109112	109112	109940
23302	35457	32	applied	\N	\N	\N	\N	109114	109114	109941
23302	35462	33	applied	\N	\N	\N	\N	109128	109128	109942
23302	35466	34	applied	\N	\N	\N	\N	109140	109140	110544
23302	35467	35	applied	\N	\N	\N	\N	109142	109142	110545
23302	35472	36	applied	\N	\N	\N	\N	109156	109156	110546
23302	35475	37	applied	\N	\N	\N	\N	109163	109163	110547
23302	35479	38	applied	\N	\N	\N	\N	109174	109174	110548
23302	35482	39	applied	\N	\N	\N	\N	109183	109183	110549
23302	35484	40	applied	\N	\N	\N	\N	109188	109188	110550
23302	35489	41	applied	\N	\N	\N	\N	109204	109204	110551
23302	35492	42	applied	\N	\N	\N	\N	109212	109212	110552
23302	35495	43	applied	\N	\N	\N	\N	109218	109218	110553
23302	35499	44	applied	\N	\N	\N	\N	109227	109227	110554
23302	35502	45	applied	\N	\N	\N	\N	109235	109235	110555
23302	35503	46	applied	\N	\N	\N	\N	109237	109237	110556
23302	35504	47	applied	\N	\N	\N	\N	109239	109239	110557
23302	35512	48	applied	\N	\N	\N	\N	109257	109257	110558
23302	35515	49	applied	\N	\N	\N	\N	109266	109266	110559
23302	35516	50	applied	\N	\N	\N	\N	109268	109268	110560
23302	35517	51	applied	\N	\N	\N	\N	109270	109270	110561
23302	35518	52	applied	\N	\N	\N	\N	109272	109272	110562
23302	35528	53	applied	\N	\N	\N	\N	109314	109314	110563
23302	35532	54	applied	\N	\N	\N	\N	109330	109330	110564
23302	35535	55	applied	\N	\N	\N	\N	109336	109336	110565
23302	35538	56	applied	\N	\N	\N	\N	109344	109344	110566
23302	35539	57	applied	\N	\N	\N	\N	109346	109346	110567
23302	35545	58	applied	\N	\N	\N	\N	109362	109362	110568
23302	35548	59	applied	\N	\N	\N	\N	109371	109371	110569
23302	35549	60	applied	\N	\N	\N	\N	109373	109373	110570
23302	35554	61	applied	\N	\N	\N	\N	109385	109385	110571
23302	35558	62	applied	\N	\N	\N	\N	109396	109396	110572
23302	35560	63	applied	\N	\N	\N	\N	109401	109401	110573
23302	35564	64	applied	\N	\N	\N	\N	109410	109410	110574
23302	35567	65	applied	\N	\N	\N	\N	109416	109416	110575
23302	35570	66	applied	\N	\N	\N	\N	109424	109424	110576
23302	35573	67	applied	\N	\N	\N	\N	109432	109432	110577
23302	35577	68	applied	\N	\N	\N	\N	109444	109444	110578
23302	35580	69	applied	\N	\N	\N	\N	109452	109452	110579
23302	35583	70	applied	\N	\N	\N	\N	109460	109460	110580
23302	35587	71	applied	\N	\N	\N	\N	109469	109469	110581
23302	35588	72	applied	\N	\N	\N	\N	109471	109471	110582
23302	35589	73	applied	\N	\N	\N	\N	109473	109473	110583
23302	35597	74	applied	\N	\N	\N	\N	109490	109490	110584
23302	35601	75	applied	\N	\N	\N	\N	109500	109500	110585
23302	35602	76	applied	\N	\N	\N	\N	109502	109502	110586
23302	35607	77	applied	\N	\N	\N	\N	109513	109513	110587
23302	35610	78	applied	\N	\N	\N	\N	109520	109520	110588
23302	35613	79	applied	\N	\N	\N	\N	109529	109529	110589
23302	35614	80	applied	\N	\N	\N	\N	109531	109531	110590
23302	35621	81	applied	\N	\N	\N	\N	109549	109549	110591
23302	35623	82	applied	\N	\N	\N	\N	109554	109554	110592
23302	35628	83	applied	\N	\N	\N	\N	109604	109604	110593
23302	35629	84	applied	\N	\N	\N	\N	109606	109606	110594
23302	35637	85	applied	\N	\N	\N	\N	109665	109665	110595
23302	35638	86	applied	\N	\N	\N	\N	109667	109667	110596
23302	35643	87	applied	\N	\N	\N	\N	109681	109681	110597
23302	35644	89	applied	\N	\N	\N	\N	109683	109683	110599
23302	35650	90	applied	\N	\N	\N	\N	109701	109701	110600
23302	35653	91	applied	\N	\N	\N	\N	109708	109708	110601
23302	35657	92	applied	\N	\N	\N	\N	109718	109718	110602
23302	35660	93	applied	\N	\N	\N	\N	109726	109726	110603
23302	35663	94	applied	\N	\N	\N	\N	109732	109732	110604
23302	35664	95	applied	\N	\N	\N	\N	109734	109734	110605
23302	35665	96	applied	\N	\N	\N	\N	109736	109736	110606
23302	35673	97	applied	\N	\N	\N	\N	109754	109754	110607
23302	35676	98	applied	\N	\N	\N	\N	109772	109772	110608
23302	35680	99	applied	\N	\N	\N	\N	109784	109784	110609
23302	35682	100	applied	\N	\N	\N	\N	109814	109814	110610
23302	35683	101	applied	\N	\N	\N	\N	109816	109816	110611
23302	35687	102	applied	\N	\N	\N	\N	109827	109827	110612
23302	35689	103	applied	\N	\N	\N	\N	109834	109834	110613
23302	35690	104	applied	\N	\N	\N	\N	109836	109836	110614
23302	35694	105	applied	\N	\N	\N	\N	109847	109847	110615
23302	35695	106	applied	\N	\N	\N	\N	109849	109849	110616
23302	35698	107	applied	\N	\N	\N	\N	109858	109858	110617
23302	35700	108	applied	\N	\N	\N	\N	109865	109865	110618
23302	35703	109	applied	\N	\N	\N	\N	109877	109877	110619
23302	35705	110	applied	\N	\N	\N	\N	109945	109945	110620
23302	35706	111	applied	\N	\N	\N	\N	109947	109947	110621
23302	35710	112	applied	\N	\N	\N	\N	109959	109959	110622
23302	35712	113	applied	\N	\N	\N	\N	109964	109964	110623
23302	35714	114	applied	\N	\N	\N	\N	109970	109970	110624
23302	35715	115	applied	\N	\N	\N	\N	109972	109972	110625
23302	35717	116	applied	\N	\N	\N	\N	109989	109989	110626
23302	35718	117	applied	\N	\N	\N	\N	109991	109991	110627
23302	35719	118	applied	\N	\N	\N	\N	109994	109994	110628
23302	35726	119	applied	\N	\N	\N	\N	110025	110025	110629
23302	35728	120	applied	\N	\N	\N	\N	110035	110035	110630
23302	35729	121	applied	\N	\N	\N	\N	110037	110037	110631
23302	35733	122	applied	\N	\N	\N	\N	110046	110046	110632
23302	35735	123	applied	\N	\N	\N	\N	110052	110052	110633
23302	35737	124	applied	\N	\N	\N	\N	110061	110061	110634
23302	35740	125	applied	\N	\N	\N	\N	110077	110077	110635
23306	35863	0	applied	\N	\N	\N	\N	110638	110638	110639
23306	35864	1	applied	\N	\N	\N	\N	110640	110640	110641
23307	35865	0	applied	\N	\N	\N	\N	110646	110646	110647
23307	35866	1	applied	\N	\N	\N	\N	110648	110648	110649
23308	35867	0	applied	\N	\N	\N	\N	110652	110652	110653
23308	35868	1	applied	\N	\N	\N	\N	110654	110654	110655
23308	35869	2	applied	\N	\N	\N	\N	110656	110656	110657
23308	35870	3	applied	\N	\N	\N	\N	110658	110658	110659
23315	35879	0	applied	\N	\N	\N	\N	110689	110689	110690
23315	35880	1	applied	\N	\N	\N	\N	110691	110691	110692
23315	35881	2	applied	\N	\N	\N	\N	110693	110693	110694
23315	35882	3	applied	\N	\N	\N	\N	110695	110695	110696
23321	35891	0	applied	\N	\N	\N	\N	110722	110722	110723
23321	35892	1	applied	\N	\N	\N	\N	110724	110724	110725
23331	35899	0	applied	\N	\N	\N	\N	110747	110747	110748
23331	35900	1	applied	\N	\N	\N	\N	110749	110749	110750
23336	35903	0	applied	\N	\N	\N	\N	110765	110765	110766
23336	35904	1	applied	\N	\N	\N	\N	110767	110767	110768
23337	35905	0	applied	\N	\N	\N	\N	110772	110772	110773
23337	35906	1	applied	\N	\N	\N	\N	110774	110774	110775
23342	35909	0	applied	\N	\N	\N	\N	110784	110784	110785
23342	35910	1	applied	\N	\N	\N	\N	110786	110786	110787
23342	35911	2	applied	\N	\N	\N	\N	110788	110788	110789
23342	35912	3	applied	\N	\N	\N	\N	110790	110790	110791
23343	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23343	35914	1	applied	\N	\N	\N	\N	110798	110798	110799
23343	35915	2	applied	\N	\N	\N	\N	110800	110800	110801
23343	35916	3	applied	\N	\N	\N	\N	110802	110802	110803
23343	35917	4	applied	\N	\N	\N	\N	110804	110804	110805
23344	35918	0	applied	\N	\N	\N	\N	110808	110808	110809
23344	35919	1	applied	\N	\N	\N	\N	110810	110810	110811
23350	35923	0	applied	\N	\N	\N	\N	110825	110825	110826
23350	35924	1	applied	\N	\N	\N	\N	110827	110827	110828
23350	35925	2	applied	\N	\N	\N	\N	110829	110829	110830
23350	35926	3	applied	\N	\N	\N	\N	110831	110831	110832
23354	35927	0	applied	\N	\N	\N	\N	110937	110937	110938
23354	35928	1	applied	\N	\N	\N	\N	110939	110939	110940
23360	35935	0	applied	\N	\N	\N	\N	110960	110960	110961
23360	35936	2	applied	\N	\N	\N	\N	110966	110966	110967
23361	35937	0	applied	\N	\N	\N	\N	110972	110972	110973
23361	35936	1	applied	\N	\N	\N	\N	110966	110966	110967
23361	35938	2	applied	\N	\N	\N	\N	110974	110974	110975
23369	35951	0	applied	\N	\N	\N	\N	111014	111014	111015
23369	35952	1	applied	\N	\N	\N	\N	111016	111016	111017
23369	35953	2	applied	\N	\N	\N	\N	111018	111018	111019
23369	35954	3	applied	\N	\N	\N	\N	111020	111020	111021
23373	35955	0	applied	\N	\N	\N	\N	111026	111026	111027
23373	35956	1	applied	\N	\N	\N	\N	111028	111028	111029
23374	35957	0	applied	\N	\N	\N	\N	111034	111034	111035
23374	35958	1	applied	\N	\N	\N	\N	111036	111036	111037
23379	35961	0	applied	\N	\N	\N	\N	111045	111045	111046
23379	35964	1	applied	\N	\N	\N	\N	111052	111052	111053
23385	35971	0	applied	\N	\N	\N	\N	111075	111075	111076
23385	35972	1	applied	\N	\N	\N	\N	111077	111077	111078
23392	35983	0	applied	\N	\N	\N	\N	111111	111111	111112
23392	35984	1	applied	\N	\N	\N	\N	111113	111113	111114
23392	35985	2	applied	\N	\N	\N	\N	111115	111115	111116
23392	35986	3	applied	\N	\N	\N	\N	111117	111117	111118
23397	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23397	35841	1	applied	\N	\N	\N	\N	110488	110488	110489
23397	35842	2	applied	\N	\N	\N	\N	110490	110490	110491
23397	35845	3	applied	\N	\N	\N	\N	110498	110498	110499
23397	35847	4	applied	\N	\N	\N	\N	110504	110504	110505
23397	35848	5	applied	\N	\N	\N	\N	110506	110506	110507
23397	35851	6	applied	\N	\N	\N	\N	110517	110517	110518
23397	35853	7	applied	\N	\N	\N	\N	110521	110521	110522
23397	35854	8	applied	\N	\N	\N	\N	110523	110523	110524
23397	35857	9	applied	\N	\N	\N	\N	110530	110530	110531
23397	35859	10	applied	\N	\N	\N	\N	110534	110534	110535
23397	35861	11	applied	\N	\N	\N	\N	110538	110538	110539
23397	35863	12	applied	\N	\N	\N	\N	110638	110638	110639
23397	35865	13	applied	\N	\N	\N	\N	110646	110646	110647
23397	35867	14	applied	\N	\N	\N	\N	110652	110652	110653
23397	35868	15	applied	\N	\N	\N	\N	110654	110654	110655
23397	35871	16	applied	\N	\N	\N	\N	110662	110662	110663
23397	35873	17	applied	\N	\N	\N	\N	110670	110670	110671
23397	35875	18	applied	\N	\N	\N	\N	110679	110679	110680
23397	35876	19	applied	\N	\N	\N	\N	110681	110681	110682
23397	35879	20	applied	\N	\N	\N	\N	110689	110689	110690
23397	35880	21	applied	\N	\N	\N	\N	110691	110691	110692
23397	35883	22	applied	\N	\N	\N	\N	110703	110703	111126
23397	35884	23	applied	\N	\N	\N	\N	110705	110705	111127
23397	35887	24	applied	\N	\N	\N	\N	110712	110712	111128
23397	35889	25	applied	\N	\N	\N	\N	110716	110716	111129
23397	35891	26	applied	\N	\N	\N	\N	110722	110722	111130
23397	35893	27	applied	\N	\N	\N	\N	110729	110729	111131
23397	35895	28	applied	\N	\N	\N	\N	110735	110735	111132
23397	35896	29	applied	\N	\N	\N	\N	110737	110737	111133
23397	35899	30	applied	\N	\N	\N	\N	110747	110747	111134
23397	35901	31	applied	\N	\N	\N	\N	110760	110760	111135
23397	35903	32	applied	\N	\N	\N	\N	110765	110765	111136
23397	35905	33	applied	\N	\N	\N	\N	110772	110772	111137
23397	35907	34	applied	\N	\N	\N	\N	110778	110778	111138
23397	35909	35	applied	\N	\N	\N	\N	110784	110784	111139
23397	35910	36	applied	\N	\N	\N	\N	110786	110786	111140
23397	35914	37	applied	\N	\N	\N	\N	110798	110798	111141
23397	35915	38	applied	\N	\N	\N	\N	110800	110800	111142
23397	35918	39	applied	\N	\N	\N	\N	110808	110808	111143
23397	35921	40	applied	\N	\N	\N	\N	110819	110819	111144
23397	35923	41	applied	\N	\N	\N	\N	110825	110825	111145
23397	35924	42	applied	\N	\N	\N	\N	110827	110827	111146
23397	35927	43	applied	\N	\N	\N	\N	110937	110937	111147
23397	35929	44	applied	\N	\N	\N	\N	110945	110945	111148
23397	35930	45	applied	\N	\N	\N	\N	110947	110947	111149
23397	35933	46	applied	\N	\N	\N	\N	110955	110955	111150
23397	35935	47	applied	\N	\N	\N	\N	110960	110960	111151
23397	35937	48	applied	\N	\N	\N	\N	110972	110972	111152
23397	35939	49	applied	\N	\N	\N	\N	110977	110977	111153
23397	35941	50	applied	\N	\N	\N	\N	110983	110983	111154
23397	35943	51	applied	\N	\N	\N	\N	110989	110989	111155
23397	35944	52	applied	\N	\N	\N	\N	110991	110991	111156
23397	35947	53	applied	\N	\N	\N	\N	111005	111005	111157
23397	35948	54	applied	\N	\N	\N	\N	111007	111007	111158
23397	35951	55	applied	\N	\N	\N	\N	111014	111014	111159
23397	35952	56	applied	\N	\N	\N	\N	111016	111016	111160
23397	35955	57	applied	\N	\N	\N	\N	111026	111026	111161
23397	35957	58	applied	\N	\N	\N	\N	111034	111034	111162
23397	35959	59	applied	\N	\N	\N	\N	111041	111041	111163
23397	35960	60	applied	\N	\N	\N	\N	111043	111043	111164
23397	35961	61	applied	\N	\N	\N	\N	111045	111045	111165
23397	35965	62	applied	\N	\N	\N	\N	111057	111057	111166
23397	35967	63	applied	\N	\N	\N	\N	111065	111065	111167
23312	35771	56	applied	\N	\N	\N	\N	110208	110208	110209
23312	35773	57	applied	\N	\N	\N	\N	110220	110220	110221
23312	35806	58	applied	\N	\N	\N	\N	110334	110334	110335
23312	35775	59	applied	\N	\N	\N	\N	110227	110227	110228
23312	35776	60	applied	\N	\N	\N	\N	110231	110231	110232
23312	35778	61	applied	\N	\N	\N	\N	110236	110236	110237
23312	35780	62	applied	\N	\N	\N	\N	110244	110244	110245
23312	35782	63	applied	\N	\N	\N	\N	110252	110252	110253
23312	35784	64	applied	\N	\N	\N	\N	110258	110258	110259
23312	35786	65	applied	\N	\N	\N	\N	110264	110264	110265
23312	35789	66	applied	\N	\N	\N	\N	110273	110273	110274
23312	35790	67	applied	\N	\N	\N	\N	110275	110275	110276
23312	35792	68	applied	\N	\N	\N	\N	110283	110283	110284
23312	35794	69	applied	\N	\N	\N	\N	110297	110297	110298
23312	35796	70	applied	\N	\N	\N	\N	110305	110305	110306
23312	35798	71	applied	\N	\N	\N	\N	110310	110310	110311
23312	35800	72	applied	\N	\N	\N	\N	110316	110316	110317
23312	35802	73	applied	\N	\N	\N	\N	110324	110324	110325
23312	35804	74	applied	\N	\N	\N	\N	110328	110328	110329
23312	35807	75	applied	\N	\N	\N	\N	110336	110336	110337
23312	35809	76	applied	\N	\N	\N	\N	110343	110343	110344
23312	35811	77	applied	\N	\N	\N	\N	110353	110353	110354
23312	35815	78	applied	\N	\N	\N	\N	110366	110366	110367
23312	35816	79	applied	\N	\N	\N	\N	110368	110368	110369
23312	35817	80	applied	\N	\N	\N	\N	110370	110370	110371
23312	35819	81	applied	\N	\N	\N	\N	110377	110377	110378
23312	35822	82	applied	\N	\N	\N	\N	110385	110385	110386
23312	35823	83	applied	\N	\N	\N	\N	110387	110387	110388
23312	35826	84	applied	\N	\N	\N	\N	110395	110395	110396
23312	35828	85	applied	\N	\N	\N	\N	110401	110401	110402
23312	35830	86	applied	\N	\N	\N	\N	110409	110409	110410
23312	35834	87	applied	\N	\N	\N	\N	110440	110440	110441
23312	35835	88	applied	\N	\N	\N	\N	110442	110442	110443
23312	35836	89	applied	\N	\N	\N	\N	110444	110444	110445
23312	35838	91	applied	\N	\N	\N	\N	110451	110451	110452
23312	35840	92	applied	\N	\N	\N	\N	110457	110457	110458
23312	35843	93	applied	\N	\N	\N	\N	110492	110492	110493
23312	35844	94	applied	\N	\N	\N	\N	110494	110494	110495
23312	35846	95	applied	\N	\N	\N	\N	110500	110500	110501
23312	35849	96	applied	\N	\N	\N	\N	110508	110508	110509
23312	35850	97	applied	\N	\N	\N	\N	110510	110510	110511
23312	35852	98	applied	\N	\N	\N	\N	110519	110519	110520
23312	35855	99	applied	\N	\N	\N	\N	110525	110525	110526
23312	35856	100	applied	\N	\N	\N	\N	110527	110527	110528
23312	35858	101	applied	\N	\N	\N	\N	110532	110532	110533
23312	35860	102	applied	\N	\N	\N	\N	110536	110536	110537
23312	35862	103	applied	\N	\N	\N	\N	110540	110540	110541
23312	35864	104	applied	\N	\N	\N	\N	110640	110640	110641
23312	35866	105	applied	\N	\N	\N	\N	110648	110648	110649
23312	35869	106	applied	\N	\N	\N	\N	110656	110656	110657
23312	35870	107	applied	\N	\N	\N	\N	110658	110658	110659
23312	35872	108	applied	\N	\N	\N	\N	110664	110664	110665
23312	35874	109	applied	\N	\N	\N	\N	110675	110675	110676
23313	35875	0	applied	\N	\N	\N	\N	110679	110679	110680
23313	35876	1	applied	\N	\N	\N	\N	110681	110681	110682
23313	35874	2	applied	\N	\N	\N	\N	110675	110675	110676
23313	35877	3	applied	\N	\N	\N	\N	110683	110683	110684
23313	35878	4	applied	\N	\N	\N	\N	110685	110685	110686
23319	35887	0	applied	\N	\N	\N	\N	110712	110712	110713
23319	35888	1	applied	\N	\N	\N	\N	110714	110714	110715
23320	35889	0	applied	\N	\N	\N	\N	110716	110716	110717
23320	35890	1	applied	\N	\N	\N	\N	110718	110718	110719
23325	35893	0	applied	\N	\N	\N	\N	110729	110729	110730
23325	35894	1	applied	\N	\N	\N	\N	110731	110731	110732
23326	35895	0	applied	\N	\N	\N	\N	110735	110735	110736
23326	35896	1	applied	\N	\N	\N	\N	110737	110737	110738
23326	35897	2	applied	\N	\N	\N	\N	110739	110739	110740
23326	35898	3	applied	\N	\N	\N	\N	110741	110741	110742
23330	35899	0	applied	\N	\N	\N	\N	110747	110747	110748
23330	35900	1	applied	\N	\N	\N	\N	110749	110749	110750
23335	35903	0	applied	\N	\N	\N	\N	110765	110765	110766
23335	35904	1	applied	\N	\N	\N	\N	110767	110767	110768
23341	35909	0	applied	\N	\N	\N	\N	110784	110784	110785
23341	35910	1	applied	\N	\N	\N	\N	110786	110786	110787
23341	35911	2	applied	\N	\N	\N	\N	110788	110788	110789
23341	35912	3	applied	\N	\N	\N	\N	110790	110790	110791
23347	35920	0	applied	\N	\N	\N	\N	110814	110814	110815
23348	35921	0	applied	\N	\N	\N	\N	110819	110819	110820
23348	35922	1	applied	\N	\N	\N	\N	110821	110821	110822
23349	35923	0	applied	\N	\N	\N	\N	110825	110825	110826
23349	35924	1	applied	\N	\N	\N	\N	110827	110827	110828
23349	35925	2	applied	\N	\N	\N	\N	110829	110829	110830
23349	35926	3	applied	\N	\N	\N	\N	110831	110831	110832
23353	35742	0	applied	\N	\N	\N	\N	110082	110082	110839
23353	35913	1	applied	\N	\N	\N	\N	110796	110796	110797
23353	35744	2	applied	\N	\N	\N	\N	110087	110087	110840
23353	35746	3	applied	\N	\N	\N	\N	110093	110093	110841
23353	35749	4	applied	\N	\N	\N	\N	110101	110101	110842
23353	35750	5	applied	\N	\N	\N	\N	110103	110103	110843
23353	35753	6	applied	\N	\N	\N	\N	110114	110114	110844
23353	35755	7	applied	\N	\N	\N	\N	110126	110126	110845
23353	35757	8	applied	\N	\N	\N	\N	110150	110150	110846
23353	35760	9	applied	\N	\N	\N	\N	110159	110159	110847
23353	35762	10	applied	\N	\N	\N	\N	110167	110167	110848
23353	35765	11	applied	\N	\N	\N	\N	110174	110174	110849
23353	35768	12	applied	\N	\N	\N	\N	110202	110202	110850
23353	35769	13	applied	\N	\N	\N	\N	110204	110204	110851
23353	35772	14	applied	\N	\N	\N	\N	110218	110218	110852
23353	35774	15	applied	\N	\N	\N	\N	110225	110225	110853
23353	35777	16	applied	\N	\N	\N	\N	110234	110234	110854
23353	35779	17	applied	\N	\N	\N	\N	110242	110242	110855
23353	35781	18	applied	\N	\N	\N	\N	110250	110250	110856
23353	35783	19	applied	\N	\N	\N	\N	110256	110256	110857
23353	35785	20	applied	\N	\N	\N	\N	110262	110262	110858
23353	35787	21	applied	\N	\N	\N	\N	110269	110269	110859
23353	35788	22	applied	\N	\N	\N	\N	110271	110271	110860
23353	35791	23	applied	\N	\N	\N	\N	110281	110281	110861
23353	35793	24	applied	\N	\N	\N	\N	110295	110295	110862
23353	35795	25	applied	\N	\N	\N	\N	110303	110303	110863
23353	35797	26	applied	\N	\N	\N	\N	110308	110308	110864
23353	35799	27	applied	\N	\N	\N	\N	110314	110314	110865
23353	35801	28	applied	\N	\N	\N	\N	110322	110322	110866
23353	35803	29	applied	\N	\N	\N	\N	110326	110326	110867
23353	35805	30	applied	\N	\N	\N	\N	110332	110332	110868
23353	35808	31	applied	\N	\N	\N	\N	110341	110341	110869
23353	35810	32	applied	\N	\N	\N	\N	110351	110351	110870
23353	35812	33	applied	\N	\N	\N	\N	110360	110360	110871
23353	35813	34	applied	\N	\N	\N	\N	110362	110362	110872
23353	35814	35	applied	\N	\N	\N	\N	110364	110364	110873
23353	35818	36	applied	\N	\N	\N	\N	110375	110375	110874
23332	35676	60	applied	\N	\N	\N	\N	109772	109772	109773
23332	35680	61	applied	\N	\N	\N	\N	109784	109784	109785
23332	35682	62	applied	\N	\N	\N	\N	109814	109814	109815
23332	35683	63	applied	\N	\N	\N	\N	109816	109816	109817
23332	35687	64	applied	\N	\N	\N	\N	109827	109827	109828
23332	35689	65	applied	\N	\N	\N	\N	109834	109834	109835
23332	35690	66	applied	\N	\N	\N	\N	109836	109836	109837
23332	35694	67	applied	\N	\N	\N	\N	109847	109847	109848
23332	35695	68	applied	\N	\N	\N	\N	109849	109849	109850
23332	35698	69	applied	\N	\N	\N	\N	109858	109858	109859
23332	35700	70	applied	\N	\N	\N	\N	109865	109865	109866
23332	35703	71	applied	\N	\N	\N	\N	109877	109877	109878
23332	35705	72	applied	\N	\N	\N	\N	109945	109945	109946
23332	35706	73	applied	\N	\N	\N	\N	109947	109947	109948
23332	35710	74	applied	\N	\N	\N	\N	109959	109959	109960
23332	35712	75	applied	\N	\N	\N	\N	109964	109964	109965
23332	35714	76	applied	\N	\N	\N	\N	109970	109970	109971
23332	35715	77	applied	\N	\N	\N	\N	109972	109972	109973
23332	35717	78	applied	\N	\N	\N	\N	109989	109989	109990
23332	35718	79	applied	\N	\N	\N	\N	109991	109991	109992
23332	35719	80	applied	\N	\N	\N	\N	109994	109994	109995
23332	35726	81	applied	\N	\N	\N	\N	110025	110025	110026
23332	35728	82	applied	\N	\N	\N	\N	110035	110035	110036
23332	35729	83	applied	\N	\N	\N	\N	110037	110037	110038
23332	35733	84	applied	\N	\N	\N	\N	110046	110046	110047
23332	35735	85	applied	\N	\N	\N	\N	110052	110052	110053
23332	35737	87	applied	\N	\N	\N	\N	110061	110061	110062
23332	35740	88	applied	\N	\N	\N	\N	110077	110077	110078
23332	35742	89	applied	\N	\N	\N	\N	110082	110082	110083
23332	35744	90	applied	\N	\N	\N	\N	110087	110087	110088
23332	35746	91	applied	\N	\N	\N	\N	110093	110093	110094
23332	35749	92	applied	\N	\N	\N	\N	110101	110101	110102
23332	35750	93	applied	\N	\N	\N	\N	110103	110103	110104
23332	35753	94	applied	\N	\N	\N	\N	110114	110114	110115
23332	35755	95	applied	\N	\N	\N	\N	110126	110126	110127
23332	35757	96	applied	\N	\N	\N	\N	110150	110150	110151
23332	35760	97	applied	\N	\N	\N	\N	110159	110159	110160
23332	35762	98	applied	\N	\N	\N	\N	110167	110167	110168
23345	35918	0	applied	\N	\N	\N	\N	110808	110808	110809
23345	35919	1	applied	\N	\N	\N	\N	110810	110810	110811
23351	35923	0	applied	\N	\N	\N	\N	110825	110825	110826
23351	35924	1	applied	\N	\N	\N	\N	110827	110827	110828
23351	35925	2	applied	\N	\N	\N	\N	110829	110829	110830
23351	35926	3	applied	\N	\N	\N	\N	110831	110831	110832
23355	35927	0	applied	\N	\N	\N	\N	110937	110937	110938
23355	35928	1	applied	\N	\N	\N	\N	110939	110939	110940
23356	35929	0	applied	\N	\N	\N	\N	110945	110945	110946
23356	35930	1	applied	\N	\N	\N	\N	110947	110947	110948
23356	35931	2	applied	\N	\N	\N	\N	110949	110949	110950
23356	35932	3	applied	\N	\N	\N	\N	110951	110951	110952
23357	35933	0	applied	\N	\N	\N	\N	110955	110955	110956
23357	35934	1	applied	\N	\N	\N	\N	110957	110957	110958
23362	35939	0	applied	\N	\N	\N	\N	110977	110977	110978
23362	35940	1	applied	\N	\N	\N	\N	110979	110979	110980
23363	35941	0	applied	\N	\N	\N	\N	110983	110983	110984
23363	35942	1	applied	\N	\N	\N	\N	110985	110985	110986
23375	35957	0	applied	\N	\N	\N	\N	111034	111034	111035
23375	35958	1	applied	\N	\N	\N	\N	111036	111036	111037
23380	35961	0	applied	\N	\N	\N	\N	111045	111045	111046
23380	35964	1	applied	\N	\N	\N	\N	111052	111052	111053
23381	35965	0	applied	\N	\N	\N	\N	111057	111057	111058
23381	35966	1	applied	\N	\N	\N	\N	111059	111059	111060
23386	35971	0	applied	\N	\N	\N	\N	111075	111075	111076
23386	35972	1	applied	\N	\N	\N	\N	111077	111077	111078
23387	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23387	35758	1	applied	\N	\N	1000000000	\N	110152	110152	110153
23387	35767	2	applied	\N	\N	\N	\N	110201	110201	47675
23387	35806	3	applied	\N	\N	\N	\N	110334	110334	110335
23388	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23390	35973	0	applied	\N	\N	\N	\N	111088	111088	111089
23390	35974	1	applied	\N	\N	\N	\N	111090	111090	111091
23390	35975	2	applied	\N	\N	\N	\N	111092	111092	111093
23390	35976	3	applied	\N	\N	\N	\N	111094	111094	111095
23390	35977	4	applied	\N	\N	\N	\N	111096	111096	111097
23390	35978	5	applied	\N	\N	\N	\N	111098	111098	111099
23390	35979	6	applied	\N	\N	\N	\N	111100	111100	111101
23390	35980	7	applied	\N	\N	\N	\N	111102	111102	111103
23390	35981	8	applied	\N	\N	\N	\N	111104	111104	111105
23390	35982	9	applied	\N	\N	\N	\N	111106	111106	111107
23391	35973	0	applied	\N	\N	\N	\N	111088	111088	111089
23391	35974	1	applied	\N	\N	\N	\N	111090	111090	111091
23391	35975	2	applied	\N	\N	\N	\N	111092	111092	111093
23391	35976	3	applied	\N	\N	\N	\N	111094	111094	111095
23391	35977	4	applied	\N	\N	\N	\N	111096	111096	111097
23391	35978	5	applied	\N	\N	\N	\N	111098	111098	111099
23391	35979	6	applied	\N	\N	\N	\N	111100	111100	111101
23391	35980	7	applied	\N	\N	\N	\N	111102	111102	111103
23391	35981	8	applied	\N	\N	\N	\N	111104	111104	111105
23391	35982	9	applied	\N	\N	\N	\N	111106	111106	111107
23394	35983	0	applied	\N	\N	\N	\N	111111	111111	111112
23394	35984	1	applied	\N	\N	\N	\N	111113	111113	111114
23394	35985	2	applied	\N	\N	\N	\N	111115	111115	111116
23394	35986	3	applied	\N	\N	\N	\N	111117	111117	111118
23396	35983	0	applied	\N	\N	\N	\N	111111	111111	111112
23396	35984	1	applied	\N	\N	\N	\N	111113	111113	111114
23396	35985	2	applied	\N	\N	\N	\N	111115	111115	111116
23396	35986	3	applied	\N	\N	\N	\N	111117	111117	111118
23402	35993	0	applied	\N	\N	\N	\N	111210	111210	111211
23402	35994	1	applied	\N	\N	\N	\N	111212	111212	111213
23406	35997	0	applied	\N	\N	\N	\N	111219	111219	111220
23406	35998	1	applied	\N	\N	\N	\N	111221	111221	111222
23406	35999	2	applied	\N	\N	\N	\N	111223	111223	111224
23406	36000	3	applied	\N	\N	\N	\N	111225	111225	111226
23406	36001	4	applied	\N	\N	\N	\N	111227	111227	111228
23406	36002	5	applied	\N	\N	\N	\N	111229	111229	111230
23406	36003	6	applied	\N	\N	\N	\N	111231	111231	111232
23406	36004	7	applied	\N	\N	\N	\N	111233	111233	111234
23408	36009	0	applied	\N	\N	\N	\N	111250	111250	111251
23408	36010	1	applied	\N	\N	\N	\N	111252	111252	111253
23411	36011	0	applied	\N	\N	\N	\N	111261	111261	111262
23411	36012	1	applied	\N	\N	\N	\N	111263	111263	111264
23415	36015	0	applied	\N	\N	\N	\N	111274	111274	111275
23415	36016	1	applied	\N	\N	\N	\N	111276	111276	111277
23415	36017	2	applied	\N	\N	\N	\N	111278	111278	111279
23415	36018	3	applied	\N	\N	\N	\N	111280	111280	111281
23421	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23421	35989	1	applied	\N	\N	\N	\N	111200	111200	111201
23421	35991	2	applied	\N	\N	\N	\N	111206	111206	111207
23421	35993	3	applied	\N	\N	\N	\N	111210	111210	111211
23421	35995	4	applied	\N	\N	\N	\N	111214	111214	111215
23353	35820	37	applied	\N	\N	\N	\N	110381	110381	110875
23353	35821	38	applied	\N	\N	\N	\N	110383	110383	110876
23353	35824	39	applied	\N	\N	\N	\N	110390	110390	110877
23353	35825	40	applied	\N	\N	\N	\N	110393	110393	110878
23353	35827	41	applied	\N	\N	\N	\N	110399	110399	110879
23353	35829	42	applied	\N	\N	\N	\N	110407	110407	110880
23353	35831	43	applied	\N	\N	\N	\N	110434	110434	110881
23353	35832	44	applied	\N	\N	\N	\N	110436	110436	110882
23353	35833	45	applied	\N	\N	\N	\N	110438	110438	110883
23353	35837	46	applied	\N	\N	\N	\N	110449	110449	110884
23353	35839	47	applied	\N	\N	\N	\N	110455	110455	110885
23353	35841	48	applied	\N	\N	\N	\N	110488	110488	110886
23353	35842	49	applied	\N	\N	\N	\N	110490	110490	110887
23353	35845	50	applied	\N	\N	\N	\N	110498	110498	110888
23353	35847	51	applied	\N	\N	\N	\N	110504	110504	110889
23353	35848	52	applied	\N	\N	\N	\N	110506	110506	110890
23353	35851	53	applied	\N	\N	\N	\N	110517	110517	110891
23353	35853	54	applied	\N	\N	\N	\N	110521	110521	110892
23353	35854	55	applied	\N	\N	\N	\N	110523	110523	110893
23353	35857	56	applied	\N	\N	\N	\N	110530	110530	110894
23353	35859	57	applied	\N	\N	\N	\N	110534	110534	110895
23353	35861	58	applied	\N	\N	\N	\N	110538	110538	110896
23353	35863	59	applied	\N	\N	\N	\N	110638	110638	110897
23353	35865	60	applied	\N	\N	\N	\N	110646	110646	110898
23353	35867	61	applied	\N	\N	\N	\N	110652	110652	110899
23353	35868	62	applied	\N	\N	\N	\N	110654	110654	110900
23353	35871	63	applied	\N	\N	\N	\N	110662	110662	110901
23353	35873	64	applied	\N	\N	\N	\N	110670	110670	110902
23353	35875	65	applied	\N	\N	\N	\N	110679	110679	110903
23353	35876	66	applied	\N	\N	\N	\N	110681	110681	110904
23353	35879	67	applied	\N	\N	\N	\N	110689	110689	110905
23353	35880	68	applied	\N	\N	\N	\N	110691	110691	110906
23353	35883	69	applied	\N	\N	\N	\N	110703	110703	110907
23353	35884	70	applied	\N	\N	\N	\N	110705	110705	110908
23353	35887	71	applied	\N	\N	\N	\N	110712	110712	110909
23353	35889	72	applied	\N	\N	\N	\N	110716	110716	110910
23353	35891	73	applied	\N	\N	\N	\N	110722	110722	110911
23353	35893	74	applied	\N	\N	\N	\N	110729	110729	110912
23353	35895	75	applied	\N	\N	\N	\N	110735	110735	110913
23353	35896	76	applied	\N	\N	\N	\N	110737	110737	110914
23353	35899	77	applied	\N	\N	\N	\N	110747	110747	110915
23353	35901	78	applied	\N	\N	\N	\N	110760	110760	110916
23353	35903	79	applied	\N	\N	\N	\N	110765	110765	110917
23353	35905	80	applied	\N	\N	\N	\N	110772	110772	110918
23353	35907	81	applied	\N	\N	\N	\N	110778	110778	110919
23353	35909	82	applied	\N	\N	\N	\N	110784	110784	110920
23353	35910	83	applied	\N	\N	\N	\N	110786	110786	110921
23353	35914	84	applied	\N	\N	\N	\N	110798	110798	110922
23353	35915	85	applied	\N	\N	\N	\N	110800	110800	110923
23353	35918	86	applied	\N	\N	\N	\N	110808	110808	110924
23353	35921	87	applied	\N	\N	\N	\N	110819	110819	110925
23353	35923	89	applied	\N	\N	\N	\N	110825	110825	110927
23353	35924	90	applied	\N	\N	\N	\N	110827	110827	110928
23353	35166	91	applied	\N	\N	\N	\N	106113	106113	108172
23353	35058	92	applied	\N	\N	1000000000	\N	107863	107863	107864
23353	34950	93	applied	\N	\N	\N	\N	107561	107561	107562
23353	34954	94	applied	\N	\N	\N	\N	107572	107572	110929
23353	35129	95	applied	\N	\N	\N	\N	108093	108093	108094
23353	35067	96	applied	\N	\N	1000000000	\N	107888	107888	107889
23353	34947	97	applied	\N	\N	\N	\N	107551	107551	107567
23353	34951	98	applied	\N	\N	\N	\N	107564	107564	110930
23353	34955	99	applied	\N	\N	\N	\N	107574	107574	110931
23353	35170	100	applied	\N	\N	\N	\N	108192	108192	106140
23353	35001	101	applied	\N	\N	\N	\N	107699	107699	107420
23353	34952	102	applied	\N	\N	\N	\N	107566	107566	107575
23359	35935	0	applied	\N	\N	\N	\N	110960	110960	110961
23359	35936	2	applied	\N	\N	\N	\N	110966	110966	110967
23366	35913	0	applied	\N	\N	\N	\N	110796	110796	110797
23367	35947	0	applied	\N	\N	\N	\N	111005	111005	111006
23367	35948	1	applied	\N	\N	\N	\N	111007	111007	111008
23367	35949	2	applied	\N	\N	\N	\N	111009	111009	111010
23367	35950	3	applied	\N	\N	\N	\N	111011	111011	111012
23368	35951	0	applied	\N	\N	\N	\N	111014	111014	111015
23368	35952	1	applied	\N	\N	\N	\N	111016	111016	111017
23368	35953	2	applied	\N	\N	\N	\N	111018	111018	111019
23368	35954	3	applied	\N	\N	\N	\N	111020	111020	111021
23372	35955	0	applied	\N	\N	\N	\N	111026	111026	111027
23372	35956	1	applied	\N	\N	\N	\N	111028	111028	111029
23378	35959	0	applied	\N	\N	\N	\N	111041	111041	111042
23378	35960	1	applied	\N	\N	\N	\N	111043	111043	111044
23378	35962	2	applied	\N	\N	\N	\N	111047	111047	111048
23378	35963	3	applied	\N	\N	\N	\N	111049	111049	111050
23383	35955	0	applied	\N	\N	\N	\N	111026	111026	111027
23383	35957	1	applied	\N	\N	\N	\N	111034	111034	111035
23383	35959	2	applied	\N	\N	\N	\N	111041	111041	111042
23383	35960	3	applied	\N	\N	\N	\N	111043	111043	111044
23383	35961	4	applied	\N	\N	\N	\N	111045	111045	111046
23383	35965	5	applied	\N	\N	\N	\N	111057	111057	111058
23383	35956	6	applied	\N	\N	\N	\N	111028	111028	111029
23383	35958	7	applied	\N	\N	\N	\N	111036	111036	111037
23383	35962	8	applied	\N	\N	\N	\N	111047	111047	111048
23383	35963	9	applied	\N	\N	\N	\N	111049	111049	111050
23383	35964	10	applied	\N	\N	\N	\N	111052	111052	111053
23383	35966	11	applied	\N	\N	\N	\N	111059	111059	111060
23384	35967	0	applied	\N	\N	\N	\N	111065	111065	111066
23384	35968	1	applied	\N	\N	\N	\N	111067	111067	111068
23384	35969	2	applied	\N	\N	\N	\N	111069	111069	111070
23384	35970	3	applied	\N	\N	\N	\N	111071	111071	111072
23395	35985	0	applied	\N	\N	\N	\N	111115	111115	111116
23395	35986	1	applied	\N	\N	\N	\N	111117	111117	111118
23398	35987	0	applied	\N	\N	\N	\N	111196	111196	111197
23398	35988	1	applied	\N	\N	\N	\N	111198	111198	111199
23403	35995	0	applied	\N	\N	\N	\N	111214	111214	111215
23403	35996	1	applied	\N	\N	\N	\N	111216	111216	111217
23404	35997	0	applied	\N	\N	\N	\N	111219	111219	111220
23404	35998	1	applied	\N	\N	\N	\N	111221	111221	111222
23404	35999	2	applied	\N	\N	\N	\N	111223	111223	111224
23404	36000	3	applied	\N	\N	\N	\N	111225	111225	111226
23404	36001	4	applied	\N	\N	\N	\N	111227	111227	111228
23404	36002	5	applied	\N	\N	\N	\N	111229	111229	111230
23404	36003	6	applied	\N	\N	\N	\N	111231	111231	111232
23404	36004	7	applied	\N	\N	\N	\N	111233	111233	111234
23409	36009	0	applied	\N	\N	\N	\N	111250	111250	111251
23409	36010	1	applied	\N	\N	\N	\N	111252	111252	111253
23413	36015	0	applied	\N	\N	\N	\N	111274	111274	111275
23413	36016	1	applied	\N	\N	\N	\N	111276	111276	111277
23413	36017	2	applied	\N	\N	\N	\N	111278	111278	111279
23413	36018	3	applied	\N	\N	\N	\N	111280	111280	111281
23417	36019	0	applied	\N	\N	\N	\N	111288	111288	111289
23397	35968	64	applied	\N	\N	\N	\N	111067	111067	111168
23397	35971	65	applied	\N	\N	\N	\N	111075	111075	111169
23397	35973	66	applied	\N	\N	\N	\N	111088	111088	111170
23397	35974	67	applied	\N	\N	\N	\N	111090	111090	111171
23397	35975	68	applied	\N	\N	\N	\N	111092	111092	111172
23397	35976	69	applied	\N	\N	\N	\N	111094	111094	111173
23397	35977	70	applied	\N	\N	\N	\N	111096	111096	111174
23397	35983	71	applied	\N	\N	\N	\N	111111	111111	111175
23397	35984	72	applied	\N	\N	\N	\N	111113	111113	111176
23397	35463	73	applied	\N	\N	\N	\N	109130	109130	111177
23397	35470	74	applied	\N	\N	\N	\N	109148	109148	111178
23397	35471	75	applied	\N	\N	\N	\N	109150	109150	108971
23397	35474	76	applied	\N	\N	\N	\N	109160	109160	108975
23397	35476	77	applied	\N	\N	\N	\N	109165	109165	108985
23397	35480	78	applied	\N	\N	\N	\N	109176	109176	111179
23397	35487	79	applied	\N	\N	\N	\N	109194	109194	111180
23397	35488	80	applied	\N	\N	\N	\N	109196	109196	111181
23397	35491	82	applied	\N	\N	\N	\N	109208	109208	111184
23397	35493	83	applied	\N	\N	\N	\N	109214	109214	109009
23397	35497	84	applied	\N	\N	\N	\N	109222	109222	109011
23397	35500	85	applied	\N	\N	\N	\N	109229	109229	109020
23397	35505	86	applied	\N	\N	\N	\N	109241	109241	109022
23397	35507	87	applied	\N	\N	\N	\N	109245	109245	111185
23397	35508	88	applied	\N	\N	\N	\N	109247	109247	111186
23397	35513	89	applied	\N	\N	\N	\N	109259	109259	111187
23397	35519	90	applied	\N	\N	\N	\N	109284	109284	111188
23397	35520	91	applied	\N	\N	\N	\N	109286	109286	109044
23397	35521	92	applied	\N	\N	\N	\N	109288	109288	109053
23397	35522	93	applied	\N	\N	\N	\N	109290	109290	109055
23397	35530	94	applied	\N	\N	\N	\N	109323	109323	111189
23397	35533	95	applied	\N	\N	\N	\N	109332	109332	111190
23397	35536	96	applied	\N	\N	\N	\N	109338	109338	111191
23397	35543	97	applied	\N	\N	\N	\N	109354	109354	111192
23400	35989	0	applied	\N	\N	\N	\N	111200	111200	111201
23400	35990	1	applied	\N	\N	\N	\N	111202	111202	111203
23401	35991	0	applied	\N	\N	\N	\N	111206	111206	111207
23401	35992	1	applied	\N	\N	\N	\N	111208	111208	111209
23405	35997	0	applied	\N	\N	\N	\N	111219	111219	111220
23405	35998	1	applied	\N	\N	\N	\N	111221	111221	111222
23405	35999	2	applied	\N	\N	\N	\N	111223	111223	111224
23405	36000	3	applied	\N	\N	\N	\N	111225	111225	111226
23405	36001	4	applied	\N	\N	\N	\N	111227	111227	111228
23405	36002	5	applied	\N	\N	\N	\N	111229	111229	111230
23405	36003	6	applied	\N	\N	\N	\N	111231	111231	111232
23405	36004	7	applied	\N	\N	\N	\N	111233	111233	111234
23407	36005	0	applied	\N	\N	\N	\N	111240	111240	111241
23407	36006	1	applied	\N	\N	\N	\N	111242	111242	111243
23407	36007	2	applied	\N	\N	\N	\N	111244	111244	111245
23407	36008	3	applied	\N	\N	\N	\N	111246	111246	111247
23414	36015	0	applied	\N	\N	\N	\N	111274	111274	111275
23414	36016	1	applied	\N	\N	\N	\N	111276	111276	111277
23414	36017	2	applied	\N	\N	\N	\N	111278	111278	111279
23414	36018	3	applied	\N	\N	\N	\N	111280	111280	111281
23418	36019	0	applied	\N	\N	\N	\N	111288	111288	111289
23418	36020	1	applied	\N	\N	\N	\N	111290	111290	111291
23420	36024	0	applied	\N	\N	\N	\N	111302	111302	111303
23420	36025	1	applied	\N	\N	\N	\N	111304	111304	111305
23423	36032	0	applied	\N	\N	\N	\N	111321	111321	111322
23431	36036	0	applied	\N	\N	\N	\N	111335	111335	111336
23431	36037	1	applied	\N	\N	\N	\N	111337	111337	111338
23432	36038	0	applied	\N	\N	\N	\N	111344	111344	111345
23432	36039	1	applied	\N	\N	\N	\N	111346	111346	111347
23435	36038	0	applied	\N	\N	\N	\N	111344	111344	111345
23435	36039	1	applied	\N	\N	\N	\N	111346	111346	111347
23439	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23439	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23451	36046	0	applied	\N	\N	\N	\N	111378	111378	111379
23451	36047	1	applied	\N	\N	\N	\N	111380	111380	111381
23454	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23454	35955	1	applied	\N	\N	\N	\N	111026	111026	111027
23454	35957	2	applied	\N	\N	\N	\N	111034	111034	111035
23454	35959	3	applied	\N	\N	\N	\N	111041	111041	111042
23454	35960	4	applied	\N	\N	\N	\N	111043	111043	111044
23454	35961	5	applied	\N	\N	\N	\N	111045	111045	111046
23454	35965	6	applied	\N	\N	\N	\N	111057	111057	111058
23454	35967	7	applied	\N	\N	\N	\N	111065	111065	111066
23454	35968	8	applied	\N	\N	\N	\N	111067	111067	111068
23454	35971	9	applied	\N	\N	\N	\N	111075	111075	111076
23454	35973	10	applied	\N	\N	\N	\N	111088	111088	111089
23454	35974	11	applied	\N	\N	\N	\N	111090	111090	111091
23454	35975	12	applied	\N	\N	\N	\N	111092	111092	111093
23454	35976	13	applied	\N	\N	\N	\N	111094	111094	111095
23454	35977	14	applied	\N	\N	\N	\N	111096	111096	111097
23454	35983	15	applied	\N	\N	\N	\N	111111	111111	111112
23454	35984	16	applied	\N	\N	\N	\N	111113	111113	111114
23454	35987	17	applied	\N	\N	\N	\N	111196	111196	111197
23454	35989	18	applied	\N	\N	\N	\N	111200	111200	111201
23454	35991	19	applied	\N	\N	\N	\N	111206	111206	111207
23454	35993	20	applied	\N	\N	\N	\N	111210	111210	111211
23454	35995	21	applied	\N	\N	\N	\N	111214	111214	111215
23454	35997	22	applied	\N	\N	\N	\N	111219	111219	111220
23454	35998	23	applied	\N	\N	\N	\N	111221	111221	111222
23454	35999	24	applied	\N	\N	\N	\N	111223	111223	111224
23454	36000	25	applied	\N	\N	\N	\N	111225	111225	111226
23454	36005	26	applied	\N	\N	\N	\N	111240	111240	111241
23454	36006	27	applied	\N	\N	\N	\N	111242	111242	111243
23454	36009	28	applied	\N	\N	\N	\N	111250	111250	111251
23454	36011	29	applied	\N	\N	\N	\N	111261	111261	111262
23454	36013	30	applied	\N	\N	\N	\N	111267	111267	111268
23454	36015	31	applied	\N	\N	\N	\N	111274	111274	111275
23454	36016	32	applied	\N	\N	\N	\N	111276	111276	111277
23454	36019	33	applied	\N	\N	\N	\N	111288	111288	111289
23454	36022	34	applied	\N	\N	\N	\N	111297	111297	111298
23454	36024	35	applied	\N	\N	\N	\N	111302	111302	111303
23454	36026	36	applied	\N	\N	\N	\N	111308	111308	111309
23454	36027	37	applied	\N	\N	\N	\N	111310	111310	111311
23454	36028	38	applied	\N	\N	\N	\N	111312	111312	111313
23454	36032	39	applied	\N	\N	\N	\N	111321	111321	111322
23454	36034	40	applied	\N	\N	\N	\N	111329	111329	111330
23454	36036	41	applied	\N	\N	\N	\N	111335	111335	111336
23454	36038	42	applied	\N	\N	\N	\N	111344	111344	111345
23454	36040	43	applied	\N	\N	\N	\N	111352	111352	111353
23454	36042	44	applied	\N	\N	\N	\N	111362	111362	111363
23454	36044	45	applied	\N	\N	\N	\N	111368	111368	111369
23454	36046	46	applied	\N	\N	\N	\N	111378	111378	111379
23454	36048	47	applied	\N	\N	\N	\N	111384	111384	111385
23454	35956	48	applied	\N	\N	\N	\N	111028	111028	111029
23454	35958	49	applied	\N	\N	\N	\N	111036	111036	111037
23454	35962	50	applied	\N	\N	\N	\N	111047	111047	111048
23454	35963	51	applied	\N	\N	\N	\N	111049	111049	111050
23410	35750	34	applied	\N	\N	\N	\N	110103	110103	110104
23410	35753	35	applied	\N	\N	\N	\N	110114	110114	110115
23410	35755	36	applied	\N	\N	\N	\N	110126	110126	110127
23410	35757	37	applied	\N	\N	\N	\N	110150	110150	110151
23410	35760	38	applied	\N	\N	\N	\N	110159	110159	110160
23410	35762	39	applied	\N	\N	\N	\N	110167	110167	110168
23410	35765	40	applied	\N	\N	\N	\N	110174	110174	110175
23410	35768	41	applied	\N	\N	\N	\N	110202	110202	110203
23410	35769	42	applied	\N	\N	\N	\N	110204	110204	110205
23410	35772	43	applied	\N	\N	\N	\N	110218	110218	110219
23410	35774	44	applied	\N	\N	\N	\N	110225	110225	110226
23410	35777	45	applied	\N	\N	\N	\N	110234	110234	110235
23410	35779	46	applied	\N	\N	\N	\N	110242	110242	110243
23410	35781	47	applied	\N	\N	\N	\N	110250	110250	110251
23410	35783	48	applied	\N	\N	\N	\N	110256	110256	110257
23410	35785	49	applied	\N	\N	\N	\N	110262	110262	110263
23410	35787	50	applied	\N	\N	\N	\N	110269	110269	110270
23410	35788	51	applied	\N	\N	\N	\N	110271	110271	110272
23410	35791	52	applied	\N	\N	\N	\N	110281	110281	110282
23410	35793	53	applied	\N	\N	\N	\N	110295	110295	110296
23410	35795	54	applied	\N	\N	\N	\N	110303	110303	110304
23410	35797	55	applied	\N	\N	\N	\N	110308	110308	110309
23410	35799	56	applied	\N	\N	\N	\N	110314	110314	110315
23410	35801	57	applied	\N	\N	\N	\N	110322	110322	110323
23410	35803	58	applied	\N	\N	\N	\N	110326	110326	110327
23410	35805	59	applied	\N	\N	\N	\N	110332	110332	110333
23410	35808	60	applied	\N	\N	\N	\N	110341	110341	110342
23410	35810	61	applied	\N	\N	\N	\N	110351	110351	110352
23410	35812	62	applied	\N	\N	\N	\N	110360	110360	110361
23410	35813	63	applied	\N	\N	\N	\N	110362	110362	110363
23410	35814	64	applied	\N	\N	\N	\N	110364	110364	110365
23410	35818	65	applied	\N	\N	\N	\N	110375	110375	110376
23410	35820	66	applied	\N	\N	\N	\N	110381	110381	110382
23410	35821	67	applied	\N	\N	\N	\N	110383	110383	110384
23410	35824	68	applied	\N	\N	\N	\N	110390	110390	110391
23410	35825	69	applied	\N	\N	\N	\N	110393	110393	110394
23410	35827	70	applied	\N	\N	\N	\N	110399	110399	110400
23410	35829	71	applied	\N	\N	\N	\N	110407	110407	110408
23410	35831	72	applied	\N	\N	\N	\N	110434	110434	110435
23410	35832	73	applied	\N	\N	\N	\N	110436	110436	110437
23410	35833	74	applied	\N	\N	\N	\N	110438	110438	110439
23410	35837	75	applied	\N	\N	\N	\N	110449	110449	110450
23410	35839	76	applied	\N	\N	\N	\N	110455	110455	110456
23410	35841	77	applied	\N	\N	\N	\N	110488	110488	110489
23410	35842	78	applied	\N	\N	\N	\N	110490	110490	110491
23410	35845	79	applied	\N	\N	\N	\N	110498	110498	110499
23410	35847	80	applied	\N	\N	\N	\N	110504	110504	110505
23410	35848	81	applied	\N	\N	\N	\N	110506	110506	110507
23410	35851	82	applied	\N	\N	\N	\N	110517	110517	110518
23410	35853	83	applied	\N	\N	\N	\N	110521	110521	110522
23410	35854	84	applied	\N	\N	\N	\N	110523	110523	110524
23410	35857	85	applied	\N	\N	\N	\N	110530	110530	110531
23410	35859	86	applied	\N	\N	\N	\N	110534	110534	110535
23410	35861	87	applied	\N	\N	\N	\N	110538	110538	110539
23410	35863	88	applied	\N	\N	\N	\N	110638	110638	110639
23410	35865	89	applied	\N	\N	\N	\N	110646	110646	110647
23410	35867	90	applied	\N	\N	\N	\N	110652	110652	110653
23410	35868	91	applied	\N	\N	\N	\N	110654	110654	110655
23410	35871	92	applied	\N	\N	\N	\N	110662	110662	110663
23410	35873	93	applied	\N	\N	\N	\N	110670	110670	110671
23410	35875	94	applied	\N	\N	\N	\N	110679	110679	110680
23410	35876	95	applied	\N	\N	\N	\N	110681	110681	110682
23410	35879	96	applied	\N	\N	\N	\N	110689	110689	110690
23410	35880	97	applied	\N	\N	\N	\N	110691	110691	110692
23410	35883	98	applied	\N	\N	\N	\N	110703	110703	111126
23410	35884	99	applied	\N	\N	\N	\N	110705	110705	111127
23410	35887	100	applied	\N	\N	\N	\N	110712	110712	111128
23410	35889	101	applied	\N	\N	\N	\N	110716	110716	111129
23410	35891	102	applied	\N	\N	\N	\N	110722	110722	111130
23410	35893	103	applied	\N	\N	\N	\N	110729	110729	111131
23410	35895	104	applied	\N	\N	\N	\N	110735	110735	111132
23410	35896	105	applied	\N	\N	\N	\N	110737	110737	111133
23410	35899	106	applied	\N	\N	\N	\N	110747	110747	111134
23410	35901	107	applied	\N	\N	\N	\N	110760	110760	111135
23410	35903	108	applied	\N	\N	\N	\N	110765	110765	111136
23410	35905	110	applied	\N	\N	\N	\N	110772	110772	111137
23410	35907	111	applied	\N	\N	\N	\N	110778	110778	111138
23410	35909	112	applied	\N	\N	\N	\N	110784	110784	111139
23410	35910	113	applied	\N	\N	\N	\N	110786	110786	111140
23410	35914	114	applied	\N	\N	\N	\N	110798	110798	111141
23410	35915	115	applied	\N	\N	\N	\N	110800	110800	111142
23410	35918	116	applied	\N	\N	\N	\N	110808	110808	111143
23410	35921	117	applied	\N	\N	\N	\N	110819	110819	111144
23410	35923	118	applied	\N	\N	\N	\N	110825	110825	111145
23410	35924	119	applied	\N	\N	\N	\N	110827	110827	111146
23410	35927	120	applied	\N	\N	\N	\N	110937	110937	111147
23410	35929	121	applied	\N	\N	\N	\N	110945	110945	111148
23410	35930	122	applied	\N	\N	\N	\N	110947	110947	111149
23410	35933	123	applied	\N	\N	\N	\N	110955	110955	111150
23410	35935	124	applied	\N	\N	\N	\N	110960	110960	111151
23410	35937	125	applied	\N	\N	\N	\N	110972	110972	111152
23412	36013	0	applied	\N	\N	\N	\N	111267	111267	111268
23412	36014	2	applied	\N	\N	\N	\N	111270	111270	111271
23416	35987	0	applied	\N	\N	\N	\N	111196	111196	111197
23416	35989	1	applied	\N	\N	\N	\N	111200	111200	111201
23416	35991	2	applied	\N	\N	\N	\N	111206	111206	111207
23416	35993	3	applied	\N	\N	\N	\N	111210	111210	111211
23416	35995	4	applied	\N	\N	\N	\N	111214	111214	111215
23416	35997	5	applied	\N	\N	\N	\N	111219	111219	111220
23416	35998	6	applied	\N	\N	\N	\N	111221	111221	111222
23416	35999	7	applied	\N	\N	\N	\N	111223	111223	111224
23416	36000	8	applied	\N	\N	\N	\N	111225	111225	111226
23416	36005	9	applied	\N	\N	\N	\N	111240	111240	111241
23416	36006	10	applied	\N	\N	\N	\N	111242	111242	111243
23416	36009	11	applied	\N	\N	\N	\N	111250	111250	111251
23416	36011	12	applied	\N	\N	\N	\N	111261	111261	111262
23416	36013	13	applied	\N	\N	\N	\N	111267	111267	111268
23416	36015	14	applied	\N	\N	\N	\N	111274	111274	111275
23416	36016	15	applied	\N	\N	\N	\N	111276	111276	111277
23416	35988	16	applied	\N	\N	\N	\N	111198	111198	111199
23416	35990	17	applied	\N	\N	\N	\N	111202	111202	111203
23416	35992	18	applied	\N	\N	\N	\N	111208	111208	111209
23416	35994	19	applied	\N	\N	\N	\N	111212	111212	111213
23416	35996	20	applied	\N	\N	\N	\N	111216	111216	111217
23416	36001	21	applied	\N	\N	\N	\N	111227	111227	111228
23416	36002	22	applied	\N	\N	\N	\N	111229	111229	111230
23416	36003	23	applied	\N	\N	\N	\N	111231	111231	111232
23416	36004	24	applied	\N	\N	\N	\N	111233	111233	111234
23416	36007	25	applied	\N	\N	\N	\N	111244	111244	111245
23416	36008	26	applied	\N	\N	\N	\N	111246	111246	111247
23416	36010	27	applied	\N	\N	\N	\N	111252	111252	111253
23416	36012	28	applied	\N	\N	\N	\N	111263	111263	111264
23416	36014	29	applied	\N	\N	\N	\N	111270	111270	111271
23416	36017	30	applied	\N	\N	\N	\N	111278	111278	111279
23416	36018	31	applied	\N	\N	\N	\N	111280	111280	111281
23419	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23419	36022	1	applied	\N	\N	\N	\N	111297	111297	111298
23419	36023	2	applied	\N	\N	\N	\N	111299	111299	111300
23422	36026	0	applied	\N	\N	\N	\N	111308	111308	111309
23422	36027	1	applied	\N	\N	\N	\N	111310	111310	111311
23422	36028	2	applied	\N	\N	\N	\N	111312	111312	111313
23422	36029	3	applied	\N	\N	\N	\N	111314	111314	111315
23422	36030	4	applied	\N	\N	\N	\N	111316	111316	111317
23422	36031	5	applied	\N	\N	\N	\N	111318	111318	111319
23425	36032	0	applied	\N	\N	\N	\N	111321	111321	111322
23425	36033	1	applied	\N	\N	\N	\N	111325	111325	111326
23429	36036	0	applied	\N	\N	\N	\N	111335	111335	111336
23429	36037	1	applied	\N	\N	\N	\N	111337	111337	111338
23434	36038	0	applied	\N	\N	\N	\N	111344	111344	111345
23434	36039	1	applied	\N	\N	\N	\N	111346	111346	111347
23436	36038	0	applied	\N	\N	\N	\N	111344	111344	111345
23436	36039	1	applied	\N	\N	\N	\N	111346	111346	111347
23437	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23437	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23441	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23441	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23444	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23444	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23448	36042	0	applied	\N	\N	\N	\N	111362	111362	111363
23448	36043	1	applied	\N	\N	\N	\N	111364	111364	111365
23452	36048	0	applied	\N	\N	\N	\N	111384	111384	111385
23452	36049	1	applied	\N	\N	\N	\N	111386	111386	111387
23457	36053	0	applied	\N	\N	\N	\N	111402	111402	111403
23457	36054	1	applied	\N	\N	\N	\N	111404	111404	111405
23457	36055	2	applied	\N	\N	\N	\N	111406	111406	111407
23465	36071	0	applied	\N	\N	\N	\N	111504	111504	111505
23465	36072	1	applied	\N	\N	\N	\N	111506	111506	111507
23465	36073	2	applied	\N	\N	\N	\N	111508	111508	111509
23465	36074	3	applied	\N	\N	\N	\N	111510	111510	111511
23468	36075	0	applied	\N	\N	\N	\N	111514	111514	111515
23468	36076	1	applied	\N	\N	\N	\N	111516	111516	111517
23468	36077	2	applied	\N	\N	\N	\N	111518	111518	111519
23470	36081	0	applied	\N	\N	\N	\N	111531	111531	111532
23470	36082	1	applied	\N	\N	\N	\N	111533	111533	111534
23470	36083	2	applied	\N	\N	\N	\N	111535	111535	111536
23470	36084	3	applied	\N	\N	\N	\N	111537	111537	111538
23475	36088	0	applied	\N	\N	\N	\N	111552	111552	111553
23475	36089	1	applied	\N	\N	\N	\N	111554	111554	111555
23475	36090	2	applied	\N	\N	\N	\N	111556	111556	111557
23484	36107	0	applied	\N	\N	\N	\N	111604	111604	111605
23484	36108	1	applied	\N	\N	\N	\N	111606	111606	111607
23484	36109	2	applied	\N	\N	\N	\N	111608	111608	111609
23484	36110	3	applied	\N	\N	\N	\N	111610	111610	111611
23484	36111	4	applied	\N	\N	\N	\N	111612	111612	111613
23484	36112	5	applied	\N	\N	\N	\N	111614	111614	111615
23491	36117	0	applied	\N	\N	\N	\N	111629	111629	111630
23491	36118	1	applied	\N	\N	\N	\N	111631	111631	111632
23491	36119	2	applied	\N	\N	\N	\N	111633	111633	111634
23493	36120	0	applied	\N	\N	\N	\N	111640	111640	111641
23493	36121	1	applied	\N	\N	\N	\N	111642	111642	111643
23493	36122	2	applied	\N	\N	\N	\N	111644	111644	111645
23493	36123	3	applied	\N	\N	\N	\N	111646	111646	111647
23493	36124	4	applied	\N	\N	\N	\N	111648	111648	111649
23493	36125	5	applied	\N	\N	\N	\N	111650	111650	111651
23496	36126	0	applied	\N	\N	\N	\N	111656	111656	111657
23496	36127	1	applied	\N	\N	\N	\N	111658	111658	111659
23496	36128	2	applied	\N	\N	\N	\N	111660	111660	111661
23496	36129	3	applied	\N	\N	\N	\N	111662	111662	111663
23501	36130	0	applied	\N	\N	\N	\N	111678	111678	111679
23501	36131	1	applied	\N	\N	\N	\N	111680	111680	111681
23501	36132	2	applied	\N	\N	\N	\N	111682	111682	111683
23504	36140	0	applied	\N	\N	\N	\N	111701	111701	111702
23504	36141	1	applied	\N	\N	\N	\N	111703	111703	111704
23504	36142	2	applied	\N	\N	\N	\N	111705	111705	111706
23508	36143	0	applied	\N	\N	\N	\N	111711	111711	111712
23508	36144	1	applied	\N	\N	\N	\N	111713	111713	111714
23508	36145	2	applied	\N	\N	\N	\N	111715	111715	111716
23511	36146	0	applied	\N	\N	\N	\N	111721	111721	111722
23511	36147	1	applied	\N	\N	\N	\N	111723	111723	111724
23511	36148	2	applied	\N	\N	\N	\N	111725	111725	111726
23511	36149	3	applied	\N	\N	\N	\N	111727	111727	111728
23517	36155	0	applied	\N	\N	\N	\N	111751	111751	111752
23517	36154	1	applied	\N	\N	\N	\N	111743	111743	111753
23517	36152	2	applied	\N	\N	\N	\N	111739	111739	111744
23517	36156	3	applied	\N	\N	\N	\N	111754	111754	111755
23517	36157	4	applied	\N	\N	\N	\N	111756	111756	111757
23520	36158	0	applied	\N	\N	\N	\N	111761	111761	111762
23520	36154	1	applied	\N	\N	\N	\N	111743	111743	111753
23520	36152	2	applied	\N	\N	\N	\N	111739	111739	111744
23520	36156	3	applied	\N	\N	\N	\N	111754	111754	111755
23520	36159	4	applied	\N	\N	\N	\N	111763	111763	111764
23520	36157	5	applied	\N	\N	\N	\N	111756	111756	111765
23520	36160	6	applied	\N	\N	\N	\N	111766	111766	111767
23520	36161	7	applied	\N	\N	\N	\N	111768	111768	111769
23524	36172	0	applied	\N	\N	\N	\N	111798	111798	111799
23524	36173	1	applied	\N	\N	\N	\N	111800	111800	111801
23524	36174	2	applied	\N	\N	\N	\N	111802	111802	111803
23532	36196	0	applied	\N	\N	\N	\N	111856	111856	111857
23532	36197	1	applied	\N	\N	\N	\N	111858	111858	111859
23532	36198	2	applied	\N	\N	\N	\N	111860	111860	111861
23532	36199	3	applied	\N	\N	\N	\N	111862	111862	111863
23534	36200	0	applied	\N	\N	\N	\N	111867	111867	111868
23534	36201	1	applied	\N	\N	\N	\N	111869	111869	111870
23534	36202	2	applied	\N	\N	\N	\N	111871	111871	111872
23536	36205	0	applied	\N	\N	\N	\N	111881	111881	111882
23536	36203	1	applied	\N	\N	\N	\N	111875	111875	111876
23536	36204	2	applied	\N	\N	\N	\N	111877	111877	111878
23536	36206	3	applied	\N	\N	\N	\N	111883	111883	111884
23536	36207	4	applied	\N	\N	\N	\N	111885	111885	111886
23536	36208	5	applied	\N	\N	\N	\N	111887	111887	111888
23536	36209	6	applied	\N	\N	\N	\N	111889	111889	111890
23536	36210	7	applied	\N	\N	\N	\N	111891	111891	111892
23536	36211	8	applied	\N	\N	\N	\N	111893	111893	111894
23537	36212	0	applied	\N	\N	\N	\N	111897	111897	111898
23537	36213	1	applied	\N	\N	\N	\N	111899	111899	111900
23537	36214	2	applied	\N	\N	\N	\N	111901	111901	111902
23537	36215	3	applied	\N	\N	\N	\N	111903	111903	111904
23537	36216	4	applied	\N	\N	\N	\N	111905	111905	111906
23537	36217	5	applied	\N	\N	\N	\N	111907	111907	111908
23537	36218	6	applied	\N	\N	\N	\N	111909	111909	111910
23417	36020	1	applied	\N	\N	\N	\N	111290	111290	111291
23427	36034	0	applied	\N	\N	\N	\N	111329	111329	111330
23427	36035	1	applied	\N	\N	\N	\N	111331	111331	111332
23430	36036	0	applied	\N	\N	\N	\N	111335	111335	111336
23430	36037	1	applied	\N	\N	\N	\N	111337	111337	111338
23442	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23442	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23450	36026	0	applied	\N	\N	\N	\N	111308	111308	111309
23450	36027	1	applied	\N	\N	\N	\N	111310	111310	111311
23450	36028	3	applied	\N	\N	\N	\N	111312	111312	111313
23450	36032	4	applied	\N	\N	\N	\N	111321	111321	111322
23450	36034	5	applied	\N	\N	\N	\N	111329	111329	111330
23450	36036	6	applied	\N	\N	\N	\N	111335	111335	111336
23450	36038	7	applied	\N	\N	\N	\N	111344	111344	111345
23450	36040	8	applied	\N	\N	\N	\N	111352	111352	111353
23450	36042	9	applied	\N	\N	\N	\N	111362	111362	111363
23450	36044	10	applied	\N	\N	\N	\N	111368	111368	111369
23453	36048	0	applied	\N	\N	\N	\N	111384	111384	111385
23453	36049	1	applied	\N	\N	\N	\N	111386	111386	111387
23455	36050	0	applied	\N	\N	\N	\N	111394	111394	111395
23455	36051	1	applied	\N	\N	\N	\N	111396	111396	111397
23455	36052	2	applied	\N	\N	\N	\N	111398	111398	111399
23458	36053	0	applied	\N	\N	\N	\N	111402	111402	111403
23458	36054	1	applied	\N	\N	\N	\N	111404	111404	111405
23458	36055	2	applied	\N	\N	\N	\N	111406	111406	111407
23461	36053	0	applied	\N	\N	\N	\N	111402	111402	111403
23461	36054	1	applied	\N	\N	\N	\N	111404	111404	111405
23461	36055	2	applied	\N	\N	\N	\N	111406	111406	111407
23462	35939	0	applied	\N	\N	\N	\N	110977	110977	111153
23462	35941	1	applied	\N	\N	\N	\N	110983	110983	111154
23462	35943	2	applied	\N	\N	\N	\N	110989	110989	111155
23462	35944	3	applied	\N	\N	\N	\N	110991	110991	111156
23462	35947	4	applied	\N	\N	\N	\N	111005	111005	111157
23462	35948	5	applied	\N	\N	\N	\N	111007	111007	111158
23462	35951	6	applied	\N	\N	\N	\N	111014	111014	111159
23462	35952	7	applied	\N	\N	\N	\N	111016	111016	111160
23462	35955	8	applied	\N	\N	\N	\N	111026	111026	111161
23462	35957	9	applied	\N	\N	\N	\N	111034	111034	111162
23462	35959	10	applied	\N	\N	\N	\N	111041	111041	111163
23462	35960	11	applied	\N	\N	\N	\N	111043	111043	111164
23462	35961	12	applied	\N	\N	\N	\N	111045	111045	111165
23462	35965	13	applied	\N	\N	\N	\N	111057	111057	111166
23462	35967	14	applied	\N	\N	\N	\N	111065	111065	111167
23462	35968	15	applied	\N	\N	\N	\N	111067	111067	111168
23462	35971	16	applied	\N	\N	\N	\N	111075	111075	111169
23462	35973	17	applied	\N	\N	\N	\N	111088	111088	111170
23462	35974	18	applied	\N	\N	\N	\N	111090	111090	111171
23462	35975	19	applied	\N	\N	\N	\N	111092	111092	111172
23462	35976	20	applied	\N	\N	\N	\N	111094	111094	111173
23462	35977	21	applied	\N	\N	\N	\N	111096	111096	111174
23462	35983	22	applied	\N	\N	\N	\N	111111	111111	111175
23462	35984	23	applied	\N	\N	\N	\N	111113	111113	111176
23462	35987	24	applied	\N	\N	\N	\N	111196	111196	111415
23462	35989	25	applied	\N	\N	\N	\N	111200	111200	111416
23462	35991	26	applied	\N	\N	\N	\N	111206	111206	111417
23462	35993	27	applied	\N	\N	\N	\N	111210	111210	111418
23462	35995	28	applied	\N	\N	\N	\N	111214	111214	111419
23462	35997	29	applied	\N	\N	\N	\N	111219	111219	111420
23462	35998	30	applied	\N	\N	\N	\N	111221	111221	111421
23462	35999	31	applied	\N	\N	\N	\N	111223	111223	111422
23462	36000	32	applied	\N	\N	\N	\N	111225	111225	111423
23462	36005	33	applied	\N	\N	\N	\N	111240	111240	111424
23462	36006	34	applied	\N	\N	\N	\N	111242	111242	111425
23462	36009	35	applied	\N	\N	\N	\N	111250	111250	111426
23462	36011	36	applied	\N	\N	\N	\N	111261	111261	111427
23462	36013	37	applied	\N	\N	\N	\N	111267	111267	111428
23462	36015	38	applied	\N	\N	\N	\N	111274	111274	111429
23462	36016	39	applied	\N	\N	\N	\N	111276	111276	111430
23462	36019	40	applied	\N	\N	\N	\N	111288	111288	111431
23462	36022	41	applied	\N	\N	\N	\N	111297	111297	111432
23462	36024	42	applied	\N	\N	\N	\N	111302	111302	111433
23462	36026	43	applied	\N	\N	\N	\N	111308	111308	111434
23462	36027	44	applied	\N	\N	\N	\N	111310	111310	111435
23462	36028	45	applied	\N	\N	\N	\N	111312	111312	111436
23462	36032	46	applied	\N	\N	\N	\N	111321	111321	111437
23462	36034	47	applied	\N	\N	\N	\N	111329	111329	111438
23462	36036	48	applied	\N	\N	\N	\N	111335	111335	111439
23462	36038	49	applied	\N	\N	\N	\N	111344	111344	111440
23462	36040	50	applied	\N	\N	\N	\N	111352	111352	111441
23462	36042	51	applied	\N	\N	\N	\N	111362	111362	111442
23462	36044	52	applied	\N	\N	\N	\N	111368	111368	111443
23462	36046	53	applied	\N	\N	\N	\N	111378	111378	111444
23462	36048	54	applied	\N	\N	\N	\N	111384	111384	111445
23462	36050	55	applied	\N	\N	\N	\N	111394	111394	111446
23462	36053	56	applied	\N	\N	\N	\N	111402	111402	111447
23462	36051	57	applied	\N	\N	\N	\N	111396	111396	111448
23462	36054	58	applied	\N	\N	\N	\N	111404	111404	109819
23462	35681	59	applied	\N	\N	\N	\N	109786	109786	109821
23462	35684	60	applied	\N	\N	\N	\N	109818	109818	111449
23462	35691	61	applied	\N	\N	\N	\N	109838	109838	110429
23462	35702	62	applied	\N	\N	\N	\N	109869	109869	109823
23462	35685	63	applied	\N	\N	\N	\N	109820	109820	109830
23462	35707	64	applied	\N	\N	\N	\N	109949	109949	109839
23462	35806	65	applied	\N	\N	\N	\N	110334	110334	110335
23462	36021	66	applied	\N	\N	\N	\N	111295	111295	111296
23462	35686	67	applied	\N	\N	\N	\N	109822	109822	109841
23462	35688	68	applied	\N	\N	\N	\N	109829	109829	109843
23462	35716	69	applied	\N	\N	\N	\N	109980	109980	111450
23462	35692	70	applied	\N	\N	\N	\N	109840	109840	111451
23462	35693	71	applied	\N	\N	\N	\N	109842	109842	110180
23462	35696	72	applied	\N	\N	\N	\N	109851	109851	111452
23462	35697	73	applied	\N	\N	\N	\N	109853	109853	109870
23462	35699	74	applied	\N	\N	\N	\N	109860	109860	109880
23462	35701	75	applied	\N	\N	\N	\N	109867	109867	109954
23462	35704	76	applied	\N	\N	\N	\N	109879	109879	111453
23462	35708	77	applied	\N	\N	\N	\N	109953	109953	111454
23462	35709	78	applied	\N	\N	\N	\N	109956	109956	111455
23462	35711	79	applied	\N	\N	\N	\N	109961	109961	109998
23462	35713	80	applied	\N	\N	\N	\N	109966	109966	110027
23462	35721	81	applied	\N	\N	\N	\N	110003	110003	110028
23462	35722	82	applied	\N	\N	\N	\N	110005	110005	110029
23462	35723	83	applied	\N	\N	\N	\N	110007	110007	110030
23462	35724	84	applied	\N	\N	\N	\N	110009	110009	110014
23462	35725	85	applied	\N	\N	\N	\N	110011	110011	110032
23462	35727	86	applied	\N	\N	\N	\N	110031	110031	111456
23462	35731	87	applied	\N	\N	\N	\N	110041	110041	111457
23462	35732	88	applied	\N	\N	\N	\N	110043	110043	111458
23462	35734	89	applied	\N	\N	\N	\N	110048	110048	111459
23462	35736	90	applied	\N	\N	\N	\N	110054	110054	111460
23462	35739	91	applied	\N	\N	\N	\N	110065	110065	111461
23421	35997	5	applied	\N	\N	\N	\N	111219	111219	111220
23421	35998	6	applied	\N	\N	\N	\N	111221	111221	111222
23421	35999	7	applied	\N	\N	\N	\N	111223	111223	111224
23421	36000	8	applied	\N	\N	\N	\N	111225	111225	111226
23421	36005	9	applied	\N	\N	\N	\N	111240	111240	111241
23421	36006	10	applied	\N	\N	\N	\N	111242	111242	111243
23421	36009	11	applied	\N	\N	\N	\N	111250	111250	111251
23421	36011	12	applied	\N	\N	\N	\N	111261	111261	111262
23421	36013	13	applied	\N	\N	\N	\N	111267	111267	111268
23421	36015	14	applied	\N	\N	\N	\N	111274	111274	111275
23421	36016	15	applied	\N	\N	\N	\N	111276	111276	111277
23421	36019	16	applied	\N	\N	\N	\N	111288	111288	111289
23421	36022	17	applied	\N	\N	\N	\N	111297	111297	111298
23421	36024	18	applied	\N	\N	\N	\N	111302	111302	111303
23421	35990	19	applied	\N	\N	\N	\N	111202	111202	111203
23421	35992	20	applied	\N	\N	\N	\N	111208	111208	111209
23421	35994	21	applied	\N	\N	\N	\N	111212	111212	111213
23421	35996	22	applied	\N	\N	\N	\N	111216	111216	111217
23421	36001	23	applied	\N	\N	\N	\N	111227	111227	111228
23421	36002	24	applied	\N	\N	\N	\N	111229	111229	111230
23421	36003	25	applied	\N	\N	\N	\N	111231	111231	111232
23421	36004	26	applied	\N	\N	\N	\N	111233	111233	111234
23421	36007	27	applied	\N	\N	\N	\N	111244	111244	111245
23421	36008	28	applied	\N	\N	\N	\N	111246	111246	111247
23421	36010	29	applied	\N	\N	\N	\N	111252	111252	111253
23421	36012	30	applied	\N	\N	\N	\N	111263	111263	111264
23421	36014	31	applied	\N	\N	\N	\N	111270	111270	111271
23421	36017	32	applied	\N	\N	\N	\N	111278	111278	111279
23421	36018	33	applied	\N	\N	\N	\N	111280	111280	111281
23421	36020	34	applied	\N	\N	\N	\N	111290	111290	111291
23421	36023	35	applied	\N	\N	\N	\N	111299	111299	111300
23421	36025	36	applied	\N	\N	\N	\N	111304	111304	111305
23424	36026	0	applied	\N	\N	\N	\N	111308	111308	111309
23424	36027	1	applied	\N	\N	\N	\N	111310	111310	111311
23424	36028	2	applied	\N	\N	\N	\N	111312	111312	111313
23424	36032	3	applied	\N	\N	\N	\N	111321	111321	111322
23424	36029	4	applied	\N	\N	\N	\N	111314	111314	111315
23424	36030	5	applied	\N	\N	\N	\N	111316	111316	111317
23424	36031	6	applied	\N	\N	\N	\N	111318	111318	111319
23424	36033	7	applied	\N	\N	\N	\N	111325	111325	111326
23426	36032	0	applied	\N	\N	\N	\N	111321	111321	111322
23426	36033	1	applied	\N	\N	\N	\N	111325	111325	111326
23428	36036	0	applied	\N	\N	\N	\N	111335	111335	111336
23428	36037	1	applied	\N	\N	\N	\N	111337	111337	111338
23433	36038	0	applied	\N	\N	\N	\N	111344	111344	111345
23433	36039	1	applied	\N	\N	\N	\N	111346	111346	111347
23440	36040	0	applied	\N	\N	\N	\N	111352	111352	111353
23440	36041	1	applied	\N	\N	\N	\N	111354	111354	111355
23447	36042	0	applied	\N	\N	\N	\N	111362	111362	111363
23447	36043	1	applied	\N	\N	\N	\N	111364	111364	111365
23449	36044	0	applied	\N	\N	\N	\N	111368	111368	111369
23449	36045	1	applied	\N	\N	\N	\N	111370	111370	111371
23456	36053	0	applied	\N	\N	\N	\N	111402	111402	111403
23456	36054	1	applied	\N	\N	\N	\N	111404	111404	111405
23456	36055	2	applied	\N	\N	\N	\N	111406	111406	111407
23467	36075	0	applied	\N	\N	\N	\N	111514	111514	111515
23467	36076	1	applied	\N	\N	\N	\N	111516	111516	111517
23467	36077	2	applied	\N	\N	\N	\N	111518	111518	111519
23469	36078	0	applied	\N	\N	\N	\N	111523	111523	111524
23469	36079	1	applied	\N	\N	\N	\N	111525	111525	111526
23469	36080	2	applied	\N	\N	\N	\N	111527	111527	111528
23474	36088	0	applied	\N	\N	\N	\N	111552	111552	111553
23474	36089	1	applied	\N	\N	\N	\N	111554	111554	111555
23474	36090	2	applied	\N	\N	\N	\N	111556	111556	111557
23479	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23481	36101	0	applied	\N	\N	\N	\N	111587	111587	111588
23481	36102	1	applied	\N	\N	\N	\N	111589	111589	111590
23481	36103	2	applied	\N	\N	\N	\N	111591	111591	111592
23485	36107	0	applied	\N	\N	\N	\N	111604	111604	111605
23485	36108	1	applied	\N	\N	\N	\N	111606	111606	111607
23485	36109	2	applied	\N	\N	\N	\N	111608	111608	111609
23485	36110	3	applied	\N	\N	\N	\N	111610	111610	111611
23485	36111	4	applied	\N	\N	\N	\N	111612	111612	111613
23485	36112	5	applied	\N	\N	\N	\N	111614	111614	111615
23487	36113	0	applied	\N	\N	\N	\N	111620	111620	111621
23487	36114	1	applied	\N	\N	\N	\N	111622	111622	111623
23487	36115	2	applied	\N	\N	\N	\N	111624	111624	111625
23487	36116	3	applied	\N	\N	\N	\N	111626	111626	111627
23492	36117	0	applied	\N	\N	\N	\N	111629	111629	111630
23492	36118	1	applied	\N	\N	\N	\N	111631	111631	111632
23492	36119	2	applied	\N	\N	\N	\N	111633	111633	111634
23494	36120	0	applied	\N	\N	\N	\N	111640	111640	111641
23494	36121	1	applied	\N	\N	\N	\N	111642	111642	111643
23494	36122	2	applied	\N	\N	\N	\N	111644	111644	111645
23494	36123	3	applied	\N	\N	\N	\N	111646	111646	111647
23494	36124	4	applied	\N	\N	\N	\N	111648	111648	111649
23494	36125	5	applied	\N	\N	\N	\N	111650	111650	111651
23497	36126	0	applied	\N	\N	\N	\N	111656	111656	111657
23497	36127	1	applied	\N	\N	\N	\N	111658	111658	111659
23497	36128	2	applied	\N	\N	\N	\N	111660	111660	111661
23497	36129	3	applied	\N	\N	\N	\N	111662	111662	111663
23502	36133	0	applied	\N	\N	\N	\N	111684	111684	111685
23502	36134	1	applied	\N	\N	\N	\N	111686	111686	111687
23502	36135	2	applied	\N	\N	\N	\N	111688	111688	111689
23502	36136	3	applied	\N	\N	\N	\N	111690	111690	111691
23502	36137	4	applied	\N	\N	\N	\N	111692	111692	111693
23502	36138	5	applied	\N	\N	\N	\N	111694	111694	111695
23502	36139	6	applied	\N	\N	\N	\N	111696	111696	111697
23505	36140	0	applied	\N	\N	\N	\N	111701	111701	111702
23505	36141	1	applied	\N	\N	\N	\N	111703	111703	111704
23505	36142	2	applied	\N	\N	\N	\N	111705	111705	111706
23509	36143	0	applied	\N	\N	\N	\N	111711	111711	111712
23509	36144	1	applied	\N	\N	\N	\N	111713	111713	111714
23509	36145	2	applied	\N	\N	\N	\N	111715	111715	111716
23513	36150	0	applied	\N	\N	\N	\N	111734	111734	111735
23518	36155	0	applied	\N	\N	\N	\N	111751	111751	111752
23538	36212	0	applied	\N	\N	\N	\N	111897	111897	111898
23538	36213	1	applied	\N	\N	\N	\N	111899	111899	111900
23538	36214	2	applied	\N	\N	\N	\N	111901	111901	111902
23538	36215	3	applied	\N	\N	\N	\N	111903	111903	111904
23538	36216	4	applied	\N	\N	\N	\N	111905	111905	111906
23538	36217	5	applied	\N	\N	\N	\N	111907	111907	111908
23538	36218	6	applied	\N	\N	\N	\N	111909	111909	111910
23538	36219	7	applied	\N	\N	\N	\N	111911	111911	111912
23538	36220	8	applied	\N	\N	\N	\N	111913	111913	111914
23538	36221	9	applied	\N	\N	\N	\N	111915	111915	111916
23540	36222	0	applied	\N	\N	\N	\N	111920	111920	111921
23540	36223	1	applied	\N	\N	\N	\N	111922	111922	111923
23540	36224	2	applied	\N	\N	\N	\N	111924	111924	111925
23542	36222	0	applied	\N	\N	\N	\N	111920	111920	111921
23454	35964	52	applied	\N	\N	\N	\N	111052	111052	111053
23454	35966	53	applied	\N	\N	\N	\N	111059	111059	111060
23454	35969	54	applied	\N	\N	\N	\N	111069	111069	111070
23454	35970	55	applied	\N	\N	\N	\N	111071	111071	111072
23454	35972	56	applied	\N	\N	\N	\N	111077	111077	111078
23454	35978	57	applied	\N	\N	\N	\N	111098	111098	111099
23454	35979	58	applied	\N	\N	\N	\N	111100	111100	111101
23454	35980	59	applied	\N	\N	\N	\N	111102	111102	111103
23454	35981	60	applied	\N	\N	\N	\N	111104	111104	111105
23454	35982	61	applied	\N	\N	\N	\N	111106	111106	111107
23454	35985	62	applied	\N	\N	\N	\N	111115	111115	111116
23454	35986	63	applied	\N	\N	\N	\N	111117	111117	111118
23454	35988	64	applied	\N	\N	\N	\N	111198	111198	111199
23454	35990	65	applied	\N	\N	\N	\N	111202	111202	111203
23454	35992	66	applied	\N	\N	\N	\N	111208	111208	111209
23454	35994	67	applied	\N	\N	\N	\N	111212	111212	111213
23454	35996	68	applied	\N	\N	\N	\N	111216	111216	111217
23454	36001	69	applied	\N	\N	\N	\N	111227	111227	111228
23454	36002	70	applied	\N	\N	\N	\N	111229	111229	111230
23454	36003	71	applied	\N	\N	\N	\N	111231	111231	111232
23454	36004	72	applied	\N	\N	\N	\N	111233	111233	111234
23454	36007	73	applied	\N	\N	\N	\N	111244	111244	111245
23454	36008	74	applied	\N	\N	\N	\N	111246	111246	111247
23454	36010	75	applied	\N	\N	\N	\N	111252	111252	111253
23454	36012	76	applied	\N	\N	\N	\N	111263	111263	111264
23454	36014	77	applied	\N	\N	\N	\N	111270	111270	111271
23454	36017	78	applied	\N	\N	\N	\N	111278	111278	111279
23454	36018	79	applied	\N	\N	\N	\N	111280	111280	111281
23454	36020	80	applied	\N	\N	\N	\N	111290	111290	111291
23454	36023	81	applied	\N	\N	\N	\N	111299	111299	111300
23454	36025	82	applied	\N	\N	\N	\N	111304	111304	111305
23454	36029	83	applied	\N	\N	\N	\N	111314	111314	111315
23454	36030	84	applied	\N	\N	\N	\N	111316	111316	111317
23454	36031	85	applied	\N	\N	\N	\N	111318	111318	111319
23454	36033	86	applied	\N	\N	\N	\N	111325	111325	111326
23454	36035	87	applied	\N	\N	\N	\N	111331	111331	111332
23454	36037	88	applied	\N	\N	\N	\N	111337	111337	111338
23454	36039	89	applied	\N	\N	\N	\N	111346	111346	111347
23454	36041	90	applied	\N	\N	\N	\N	111354	111354	111355
23454	36043	91	applied	\N	\N	\N	\N	111364	111364	111365
23454	36045	92	applied	\N	\N	\N	\N	111370	111370	111371
23454	36047	93	applied	\N	\N	\N	\N	111380	111380	111381
23454	36049	94	applied	\N	\N	\N	\N	111386	111386	111387
23459	36053	0	applied	\N	\N	\N	\N	111402	111402	111403
23459	36054	1	applied	\N	\N	\N	\N	111404	111404	111405
23459	36055	2	applied	\N	\N	\N	\N	111406	111406	111407
23464	36065	0	applied	\N	\N	\N	\N	111490	111490	111491
23464	36066	1	applied	\N	\N	\N	\N	111492	111492	111493
23464	36067	2	applied	\N	\N	\N	\N	111494	111494	111495
23464	36068	3	applied	\N	\N	\N	\N	111496	111496	111497
23464	36069	4	applied	\N	\N	\N	\N	111498	111498	111499
23464	36070	5	applied	\N	\N	\N	\N	111500	111500	111501
23472	36081	0	applied	\N	\N	\N	\N	111531	111531	111532
23472	36082	1	applied	\N	\N	\N	\N	111533	111533	111534
23472	36083	2	applied	\N	\N	\N	\N	111535	111535	111536
23472	36084	3	applied	\N	\N	\N	\N	111537	111537	111538
23473	36085	0	applied	\N	\N	\N	\N	111544	111544	111545
23473	36086	1	applied	\N	\N	\N	\N	111546	111546	111547
23473	36087	2	applied	\N	\N	\N	\N	111548	111548	111549
23477	36088	0	applied	\N	\N	\N	\N	111552	111552	111553
23477	36089	1	applied	\N	\N	\N	\N	111554	111554	111555
23477	36090	2	applied	\N	\N	\N	\N	111556	111556	111557
23480	36091	0	applied	\N	\N	\N	\N	111565	111565	111566
23480	36092	1	applied	\N	\N	\N	\N	111567	111567	111568
23480	36093	2	applied	\N	\N	\N	\N	111569	111569	111570
23480	36094	3	applied	\N	\N	\N	\N	111571	111571	111572
23480	36095	4	applied	\N	\N	\N	\N	111573	111573	111574
23480	36096	5	applied	\N	\N	\N	\N	111575	111575	111576
23480	36097	6	applied	\N	\N	\N	\N	111577	111577	111578
23480	36098	7	applied	\N	\N	\N	\N	111579	111579	111580
23480	36099	8	applied	\N	\N	\N	\N	111581	111581	111582
23480	36100	9	applied	\N	\N	\N	\N	111583	111583	111584
23483	36104	0	applied	\N	\N	\N	\N	111594	111594	111595
23483	36105	1	applied	\N	\N	\N	\N	111596	111596	111597
23483	36106	2	applied	\N	\N	\N	\N	111598	111598	111599
23499	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23499	36051	1	applied	\N	\N	\N	\N	111396	111396	111671
23499	36054	2	applied	\N	\N	\N	\N	111404	111404	109950
23499	36061	3	applied	\N	\N	\N	\N	111480	111480	109954
23499	36062	4	applied	\N	\N	\N	\N	111482	111482	111672
23499	36064	5	applied	\N	\N	\N	\N	111486	111486	109957
23499	36069	6	applied	\N	\N	\N	\N	111498	111498	111454
23499	36070	7	applied	\N	\N	\N	\N	111500	111500	111673
23499	36073	8	applied	\N	\N	\N	\N	111508	111508	109967
23499	36076	9	applied	\N	\N	\N	\N	111516	111516	109998
23499	36080	10	applied	\N	\N	\N	\N	111527	111527	111674
23499	36083	11	applied	\N	\N	\N	\N	111535	111535	110006
23499	36086	12	applied	\N	\N	\N	\N	111546	111546	110028
23499	36089	13	applied	\N	\N	\N	\N	111554	111554	111675
23499	36097	14	applied	\N	\N	\N	\N	111577	111577	110010
23499	36098	15	applied	\N	\N	\N	\N	111579	111579	110030
23499	36100	16	applied	\N	\N	\N	\N	111583	111583	110013
23506	36140	0	applied	\N	\N	\N	\N	111701	111701	111702
23506	36141	1	applied	\N	\N	\N	\N	111703	111703	111704
23506	36142	2	applied	\N	\N	\N	\N	111705	111705	111706
23512	36146	0	applied	\N	\N	\N	\N	111721	111721	111722
23512	36147	1	applied	\N	\N	\N	\N	111723	111723	111724
23512	36148	2	applied	\N	\N	\N	\N	111725	111725	111726
23512	36149	3	applied	\N	\N	\N	\N	111727	111727	111728
23514	36151	0	applied	\N	\N	\N	\N	111737	111737	111738
23514	36152	1	applied	\N	\N	\N	\N	111739	111739	111740
23514	36153	2	applied	\N	\N	\N	\N	111741	111741	111742
23514	36154	3	applied	\N	\N	\N	\N	111743	111743	111744
23516	36151	0	applied	\N	\N	\N	\N	111737	111737	111738
23516	36153	1	applied	\N	\N	\N	\N	111741	111741	111749
23521	36162	0	applied	\N	\N	\N	\N	111772	111772	111773
23521	36163	1	applied	\N	\N	\N	\N	111774	111774	111775
23521	36164	2	applied	\N	\N	\N	\N	111776	111776	111777
23521	36165	3	applied	\N	\N	\N	\N	111778	111778	111779
23521	36166	4	applied	\N	\N	\N	\N	111780	111780	111781
23521	36167	5	applied	\N	\N	\N	\N	111782	111782	111783
23521	36168	6	applied	\N	\N	\N	\N	111784	111784	111785
23521	36169	7	applied	\N	\N	\N	\N	111786	111786	111787
23521	36170	8	applied	\N	\N	\N	\N	111788	111788	111789
23521	36171	9	applied	\N	\N	\N	\N	111790	111790	111791
23523	36021	0	applied	\N	\N	\N	\N	111295	111295	111296
23523	35927	1	applied	\N	\N	\N	\N	110937	110937	110938
23523	35929	2	applied	\N	\N	\N	\N	110945	110945	110946
23523	35930	3	applied	\N	\N	\N	\N	110947	110947	110948
23523	35933	4	applied	\N	\N	\N	\N	110955	110955	110956
23462	35741	92	applied	\N	\N	\N	\N	110079	110079	111462
23462	35743	93	applied	\N	\N	\N	\N	110084	110084	111463
23462	35745	94	applied	\N	\N	\N	\N	110089	110089	110096
23462	35748	95	applied	\N	\N	\N	\N	110097	110097	110098
23462	35751	96	applied	\N	\N	\N	\N	110105	110105	110106
23462	35752	97	applied	\N	\N	\N	\N	110107	110107	110108
23462	35754	98	applied	\N	\N	\N	\N	110116	110116	110117
23462	35756	99	applied	\N	\N	\N	\N	110128	110128	110129
23462	35759	100	applied	\N	\N	\N	\N	110154	110154	110155
23462	35761	101	applied	\N	\N	\N	\N	110161	110161	110162
23462	35763	102	applied	\N	\N	\N	\N	110169	110169	110170
23462	35766	103	applied	\N	\N	\N	\N	110176	110176	110177
23462	35770	104	applied	\N	\N	\N	\N	110206	110206	110207
23462	35771	105	applied	\N	\N	\N	\N	110208	110208	110209
23462	35773	106	applied	\N	\N	\N	\N	110220	110220	110221
23462	35775	107	applied	\N	\N	\N	\N	110227	110227	110228
23462	35776	110	applied	\N	\N	\N	\N	110231	110231	110232
23462	35778	111	applied	\N	\N	\N	\N	110236	110236	110237
23462	35780	112	applied	\N	\N	\N	\N	110244	110244	110245
23462	35782	113	applied	\N	\N	\N	\N	110252	110252	110253
23463	36056	0	applied	\N	\N	\N	\N	111470	111470	111471
23463	36057	1	applied	\N	\N	\N	\N	111472	111472	111473
23463	36058	2	applied	\N	\N	\N	\N	111474	111474	111475
23463	36059	3	applied	\N	\N	\N	\N	111476	111476	111477
23463	36060	4	applied	\N	\N	\N	\N	111478	111478	111479
23463	36061	5	applied	\N	\N	\N	\N	111480	111480	111481
23463	36062	6	applied	\N	\N	\N	\N	111482	111482	111483
23463	36063	7	applied	\N	\N	\N	\N	111484	111484	111485
23463	36064	8	applied	\N	\N	\N	\N	111486	111486	111487
23466	36071	0	applied	\N	\N	\N	\N	111504	111504	111505
23466	36072	1	applied	\N	\N	\N	\N	111506	111506	111507
23466	36073	2	applied	\N	\N	\N	\N	111508	111508	111509
23466	36074	3	applied	\N	\N	\N	\N	111510	111510	111511
23471	36081	0	applied	\N	\N	\N	\N	111531	111531	111532
23471	36082	1	applied	\N	\N	\N	\N	111533	111533	111534
23471	36083	2	applied	\N	\N	\N	\N	111535	111535	111536
23471	36084	3	applied	\N	\N	\N	\N	111537	111537	111538
23476	36088	0	applied	\N	\N	\N	\N	111552	111552	111553
23476	36089	1	applied	\N	\N	\N	\N	111554	111554	111555
23476	36090	2	applied	\N	\N	\N	\N	111556	111556	111557
23482	36104	0	applied	\N	\N	\N	\N	111594	111594	111595
23482	36105	1	applied	\N	\N	\N	\N	111596	111596	111597
23482	36106	2	applied	\N	\N	\N	\N	111598	111598	111599
23490	36117	0	applied	\N	\N	\N	\N	111629	111629	111630
23490	36118	1	applied	\N	\N	\N	\N	111631	111631	111632
23490	36119	2	applied	\N	\N	\N	\N	111633	111633	111634
23495	36126	0	applied	\N	\N	\N	\N	111656	111656	111657
23495	36127	1	applied	\N	\N	\N	\N	111658	111658	111659
23495	36128	2	applied	\N	\N	\N	\N	111660	111660	111661
23495	36129	3	applied	\N	\N	\N	\N	111662	111662	111663
23498	36126	0	applied	\N	\N	\N	\N	111656	111656	111657
23498	36127	1	applied	\N	\N	\N	\N	111658	111658	111659
23498	36128	2	applied	\N	\N	\N	\N	111660	111660	111661
23498	36129	3	applied	\N	\N	\N	\N	111662	111662	111663
23503	36133	0	applied	\N	\N	\N	\N	111684	111684	111685
23503	36134	1	applied	\N	\N	\N	\N	111686	111686	111687
23503	36135	2	applied	\N	\N	\N	\N	111688	111688	111689
23503	36136	3	applied	\N	\N	\N	\N	111690	111690	111691
23503	36137	4	applied	\N	\N	\N	\N	111692	111692	111693
23503	36138	5	applied	\N	\N	\N	\N	111694	111694	111695
23503	36139	6	applied	\N	\N	\N	\N	111696	111696	111697
23507	36140	0	applied	\N	\N	\N	\N	111701	111701	111702
23507	36141	1	applied	\N	\N	\N	\N	111703	111703	111704
23507	36142	2	applied	\N	\N	\N	\N	111705	111705	111706
23510	36146	0	applied	\N	\N	\N	\N	111721	111721	111722
23510	36147	1	applied	\N	\N	\N	\N	111723	111723	111724
23510	36148	2	applied	\N	\N	\N	\N	111725	111725	111726
23510	36149	3	applied	\N	\N	\N	\N	111727	111727	111728
23515	36151	0	applied	\N	\N	\N	\N	111737	111737	111738
23515	36152	1	applied	\N	\N	\N	\N	111739	111739	111740
23515	36153	2	applied	\N	\N	\N	\N	111741	111741	111742
23515	36154	3	applied	\N	\N	\N	\N	111743	111743	111744
23519	36158	0	applied	\N	\N	\N	\N	111761	111761	111762
23519	36154	1	applied	\N	\N	\N	\N	111743	111743	111753
23519	36152	2	applied	\N	\N	\N	\N	111739	111739	111744
23519	36156	3	applied	\N	\N	\N	\N	111754	111754	111755
23519	36159	4	applied	\N	\N	\N	\N	111763	111763	111764
23519	36157	5	applied	\N	\N	\N	\N	111756	111756	111765
23519	36160	6	applied	\N	\N	\N	\N	111766	111766	111767
23519	36161	7	applied	\N	\N	\N	\N	111768	111768	111769
23522	36162	0	applied	\N	\N	\N	\N	111772	111772	111773
23522	36163	1	applied	\N	\N	\N	\N	111774	111774	111775
23522	36164	2	applied	\N	\N	\N	\N	111776	111776	111777
23522	36165	3	applied	\N	\N	\N	\N	111778	111778	111779
23522	36166	4	applied	\N	\N	\N	\N	111780	111780	111781
23522	36167	5	applied	\N	\N	\N	\N	111782	111782	111783
23522	36168	6	applied	\N	\N	\N	\N	111784	111784	111785
23522	36169	7	applied	\N	\N	\N	\N	111786	111786	111787
23522	36170	8	applied	\N	\N	\N	\N	111788	111788	111789
23522	36171	9	applied	\N	\N	\N	\N	111790	111790	111791
23529	36178	0	applied	\N	\N	\N	\N	111813	111813	111814
23529	36179	1	applied	\N	\N	\N	\N	111815	111815	111816
23529	36180	2	applied	\N	\N	\N	\N	111817	111817	111818
23529	36181	3	applied	\N	\N	\N	\N	111819	111819	111820
23529	36182	4	applied	\N	\N	\N	\N	111821	111821	111822
23529	36183	5	applied	\N	\N	\N	\N	111823	111823	111824
23529	36184	6	applied	\N	\N	\N	\N	111825	111825	111826
23529	36185	7	applied	\N	\N	\N	\N	111827	111827	111828
23529	36186	8	applied	\N	\N	\N	\N	111829	111829	111830
23529	36187	9	applied	\N	\N	\N	\N	111831	111831	111832
23529	36188	10	applied	\N	\N	\N	\N	111833	111833	111834
23529	36189	11	applied	\N	\N	\N	\N	111835	111835	111836
23529	36190	12	applied	\N	\N	\N	\N	111837	111837	111838
23529	36191	13	applied	\N	\N	\N	\N	111839	111839	111840
23529	36192	14	applied	\N	\N	\N	\N	111841	111841	111842
23531	36196	0	applied	\N	\N	\N	\N	111856	111856	111857
23531	36197	1	applied	\N	\N	\N	\N	111858	111858	111859
23531	36198	2	applied	\N	\N	\N	\N	111860	111860	111861
23531	36199	3	applied	\N	\N	\N	\N	111862	111862	111863
23533	36200	0	applied	\N	\N	\N	\N	111867	111867	111868
23533	36201	1	applied	\N	\N	\N	\N	111869	111869	111870
23533	36202	2	applied	\N	\N	\N	\N	111871	111871	111872
23543	36225	0	applied	\N	\N	\N	\N	111932	111932	111933
23543	36226	1	applied	\N	\N	\N	\N	111934	111934	111935
23543	36227	2	applied	\N	\N	\N	\N	111936	111936	111937
23551	36238	0	applied	\N	\N	\N	\N	111964	111964	111965
23551	36239	1	applied	\N	\N	\N	\N	111966	111966	111967
23551	36240	2	applied	\N	\N	\N	\N	111968	111968	111969
23551	36241	3	applied	\N	\N	\N	\N	111970	111970	111971
23551	36242	4	applied	\N	\N	\N	\N	111972	111972	111973
23523	35935	5	applied	\N	\N	\N	\N	110960	110960	110961
23523	35937	6	applied	\N	\N	\N	\N	110972	110972	110973
23523	35939	7	applied	\N	\N	\N	\N	110977	110977	110978
23523	35941	8	applied	\N	\N	\N	\N	110983	110983	110984
23523	35943	9	applied	\N	\N	\N	\N	110989	110989	110990
23523	35944	10	applied	\N	\N	\N	\N	110991	110991	110992
23523	35947	11	applied	\N	\N	\N	\N	111005	111005	111006
23523	35948	12	applied	\N	\N	\N	\N	111007	111007	111008
23523	35951	13	applied	\N	\N	\N	\N	111014	111014	111015
23523	35952	14	applied	\N	\N	\N	\N	111016	111016	111017
23523	35955	16	applied	\N	\N	\N	\N	111026	111026	111027
23523	35957	17	applied	\N	\N	\N	\N	111034	111034	111035
23523	35959	18	applied	\N	\N	\N	\N	111041	111041	111042
23523	35960	19	applied	\N	\N	\N	\N	111043	111043	111044
23523	35961	20	applied	\N	\N	\N	\N	111045	111045	111046
23523	35965	21	applied	\N	\N	\N	\N	111057	111057	111058
23523	35967	22	applied	\N	\N	\N	\N	111065	111065	111066
23523	35968	23	applied	\N	\N	\N	\N	111067	111067	111068
23523	35971	24	applied	\N	\N	\N	\N	111075	111075	111076
23523	35973	25	applied	\N	\N	\N	\N	111088	111088	111089
23523	35974	26	applied	\N	\N	\N	\N	111090	111090	111091
23523	35975	27	applied	\N	\N	\N	\N	111092	111092	111093
23523	35976	28	applied	\N	\N	\N	\N	111094	111094	111095
23523	35977	29	applied	\N	\N	\N	\N	111096	111096	111097
23523	35983	30	applied	\N	\N	\N	\N	111111	111111	111112
23523	35984	31	applied	\N	\N	\N	\N	111113	111113	111114
23523	35987	32	applied	\N	\N	\N	\N	111196	111196	111197
23523	35989	33	applied	\N	\N	\N	\N	111200	111200	111201
23523	35991	34	applied	\N	\N	\N	\N	111206	111206	111207
23523	35993	35	applied	\N	\N	\N	\N	111210	111210	111211
23523	35995	36	applied	\N	\N	\N	\N	111214	111214	111215
23523	35997	37	applied	\N	\N	\N	\N	111219	111219	111220
23523	35998	38	applied	\N	\N	\N	\N	111221	111221	111222
23523	35999	39	applied	\N	\N	\N	\N	111223	111223	111224
23523	36000	40	applied	\N	\N	\N	\N	111225	111225	111226
23523	36005	41	applied	\N	\N	\N	\N	111240	111240	111241
23523	36006	42	applied	\N	\N	\N	\N	111242	111242	111243
23523	36009	43	applied	\N	\N	\N	\N	111250	111250	111251
23523	36011	44	applied	\N	\N	\N	\N	111261	111261	111262
23523	36013	45	applied	\N	\N	\N	\N	111267	111267	111268
23523	36015	46	applied	\N	\N	\N	\N	111274	111274	111275
23523	36016	47	applied	\N	\N	\N	\N	111276	111276	111277
23523	36019	48	applied	\N	\N	\N	\N	111288	111288	111289
23523	36022	49	applied	\N	\N	\N	\N	111297	111297	111298
23523	36024	50	applied	\N	\N	\N	\N	111302	111302	111303
23523	36026	51	applied	\N	\N	\N	\N	111308	111308	111309
23523	36027	52	applied	\N	\N	\N	\N	111310	111310	111311
23523	36028	53	applied	\N	\N	\N	\N	111312	111312	111313
23523	36032	54	applied	\N	\N	\N	\N	111321	111321	111322
23523	36034	55	applied	\N	\N	\N	\N	111329	111329	111330
23523	36036	56	applied	\N	\N	\N	\N	111335	111335	111336
23523	36038	57	applied	\N	\N	\N	\N	111344	111344	111345
23523	36040	58	applied	\N	\N	\N	\N	111352	111352	111353
23523	36042	59	applied	\N	\N	\N	\N	111362	111362	111363
23523	36044	60	applied	\N	\N	\N	\N	111368	111368	111369
23523	36046	61	applied	\N	\N	\N	\N	111378	111378	111379
23525	36175	0	applied	\N	\N	\N	\N	111806	111806	111807
23525	36176	1	applied	\N	\N	\N	\N	111808	111808	111809
23525	36177	2	applied	\N	\N	\N	\N	111810	111810	111811
23528	36178	0	applied	\N	\N	\N	\N	111813	111813	111814
23528	36179	1	applied	\N	\N	\N	\N	111815	111815	111816
23528	36180	2	applied	\N	\N	\N	\N	111817	111817	111818
23528	36181	3	applied	\N	\N	\N	\N	111819	111819	111820
23528	36182	4	applied	\N	\N	\N	\N	111821	111821	111822
23528	36183	5	applied	\N	\N	\N	\N	111823	111823	111824
23528	36184	6	applied	\N	\N	\N	\N	111825	111825	111826
23528	36185	7	applied	\N	\N	\N	\N	111827	111827	111828
23528	36186	8	applied	\N	\N	\N	\N	111829	111829	111830
23528	36187	9	applied	\N	\N	\N	\N	111831	111831	111832
23528	36188	10	applied	\N	\N	\N	\N	111833	111833	111834
23528	36189	11	applied	\N	\N	\N	\N	111835	111835	111836
23528	36190	12	applied	\N	\N	\N	\N	111837	111837	111838
23528	36191	13	applied	\N	\N	\N	\N	111839	111839	111840
23528	36192	14	applied	\N	\N	\N	\N	111841	111841	111842
23530	36193	0	applied	\N	\N	\N	\N	111848	111848	111849
23530	36194	1	applied	\N	\N	\N	\N	111850	111850	111851
23530	36195	2	applied	\N	\N	\N	\N	111852	111852	111853
23535	36181	0	applied	\N	\N	\N	\N	111819	111819	111820
23535	36182	1	applied	\N	\N	\N	\N	111821	111821	111822
23535	36183	2	applied	\N	\N	\N	\N	111823	111823	111824
23535	36184	3	applied	\N	\N	\N	\N	111825	111825	111826
23535	36185	4	applied	\N	\N	\N	\N	111827	111827	111828
23535	36203	5	applied	\N	\N	\N	\N	111875	111875	111876
23535	36204	6	applied	\N	\N	\N	\N	111877	111877	111878
23541	36222	0	applied	\N	\N	\N	\N	111920	111920	111921
23541	36223	1	applied	\N	\N	\N	\N	111922	111922	111923
23541	36224	2	applied	\N	\N	\N	\N	111924	111924	111925
23545	36231	0	applied	\N	\N	\N	\N	111947	111947	111948
23545	36232	1	applied	\N	\N	\N	\N	111949	111949	111950
23545	36233	2	applied	\N	\N	\N	\N	111951	111951	111952
23545	36234	3	applied	\N	\N	\N	\N	111953	111953	111954
23548	36235	0	applied	\N	\N	\N	\N	111956	111956	111957
23548	36236	1	applied	\N	\N	\N	\N	111958	111958	111959
23548	36237	2	applied	\N	\N	\N	\N	111960	111960	111961
23555	36245	0	applied	\N	\N	\N	\N	111982	111982	111983
23555	36246	1	applied	\N	\N	\N	\N	111984	111984	111985
23555	36247	2	applied	\N	\N	\N	\N	111986	111986	111987
23555	36248	3	applied	\N	\N	\N	\N	111988	111988	111989
23555	36249	4	applied	\N	\N	\N	\N	111990	111990	111991
23555	36250	5	applied	\N	\N	\N	\N	111992	111992	111993
23557	36251	0	applied	\N	\N	\N	\N	112000	112000	112001
23557	36252	1	applied	\N	\N	\N	\N	112002	112002	112003
23557	36253	2	applied	\N	\N	\N	\N	112004	112004	112005
23557	36254	3	applied	\N	\N	\N	\N	112006	112006	112007
23557	36255	4	applied	\N	\N	\N	\N	112008	112008	112009
23557	36256	5	applied	\N	\N	\N	\N	112010	112010	112011
23562	36263	0	applied	\N	\N	\N	\N	112032	112032	112033
23562	36264	1	applied	\N	\N	\N	\N	112034	112034	112035
23562	36265	2	applied	\N	\N	\N	\N	112036	112036	112037
23562	36266	3	applied	\N	\N	\N	\N	112038	112038	112039
23564	36267	0	applied	\N	\N	\N	\N	112043	112043	112044
23564	36268	1	applied	\N	\N	\N	\N	112045	112045	112046
23564	36269	2	applied	\N	\N	\N	\N	112047	112047	112048
23564	36270	3	applied	\N	\N	\N	\N	112049	112049	112050
23580	36291	0	applied	\N	\N	\N	\N	112111	112111	112112
23580	36292	1	applied	\N	\N	\N	\N	112113	112113	112114
23580	36293	2	applied	\N	\N	\N	\N	112115	112115	112116
23580	36294	3	applied	\N	\N	\N	\N	112117	112117	112118
23582	36298	0	applied	\N	\N	\N	\N	112130	112130	112131
23582	36299	1	applied	\N	\N	\N	\N	112132	112132	112133
23537	36219	7	applied	\N	\N	\N	\N	111911	111911	111912
23537	36220	8	applied	\N	\N	\N	\N	111913	111913	111914
23537	36221	9	applied	\N	\N	\N	\N	111915	111915	111916
23539	36222	0	applied	\N	\N	\N	\N	111920	111920	111921
23539	36223	1	applied	\N	\N	\N	\N	111922	111922	111923
23539	36224	2	applied	\N	\N	\N	\N	111924	111924	111925
23544	36228	0	applied	\N	\N	\N	\N	111939	111939	111940
23544	36229	1	applied	\N	\N	\N	\N	111941	111941	111942
23544	36230	2	applied	\N	\N	\N	\N	111943	111943	111944
23547	36235	0	applied	\N	\N	\N	\N	111956	111956	111957
23547	36236	1	applied	\N	\N	\N	\N	111958	111958	111959
23547	36237	2	applied	\N	\N	\N	\N	111960	111960	111961
23549	36238	0	applied	\N	\N	\N	\N	111964	111964	111965
23549	36239	1	applied	\N	\N	\N	\N	111966	111966	111967
23549	36240	2	applied	\N	\N	\N	\N	111968	111968	111969
23549	36241	3	applied	\N	\N	\N	\N	111970	111970	111971
23549	36242	4	applied	\N	\N	\N	\N	111972	111972	111973
23549	36243	5	applied	\N	\N	\N	\N	111974	111974	111975
23549	36244	6	applied	\N	\N	\N	\N	111976	111976	111977
23554	36245	0	applied	\N	\N	\N	\N	111982	111982	111983
23554	36246	1	applied	\N	\N	\N	\N	111984	111984	111985
23554	36247	2	applied	\N	\N	\N	\N	111986	111986	111987
23554	36248	3	applied	\N	\N	\N	\N	111988	111988	111989
23554	36249	4	applied	\N	\N	\N	\N	111990	111990	111991
23554	36250	5	applied	\N	\N	\N	\N	111992	111992	111993
23556	36251	0	applied	\N	\N	\N	\N	112000	112000	112001
23556	36252	1	applied	\N	\N	\N	\N	112002	112002	112003
23556	36253	2	applied	\N	\N	\N	\N	112004	112004	112005
23556	36254	3	applied	\N	\N	\N	\N	112006	112006	112007
23556	36255	4	applied	\N	\N	\N	\N	112008	112008	112009
23556	36256	5	applied	\N	\N	\N	\N	112010	112010	112011
23569	36277	0	applied	\N	\N	\N	\N	112072	112072	112073
23569	36278	1	applied	\N	\N	\N	\N	112074	112074	112075
23569	36279	2	applied	\N	\N	\N	\N	112076	112076	112077
23569	36280	3	applied	\N	\N	\N	\N	112078	112078	112079
23571	36281	0	applied	\N	\N	\N	\N	112080	112080	112081
23571	36282	1	applied	\N	\N	\N	\N	112082	112082	112083
23571	36283	2	applied	\N	\N	\N	\N	112084	112084	112085
23576	36284	0	applied	\N	\N	\N	\N	112090	112090	112091
23576	36285	1	applied	\N	\N	\N	\N	112092	112092	112093
23576	36286	2	applied	\N	\N	\N	\N	112094	112094	112095
23576	36287	3	applied	\N	\N	\N	\N	112096	112096	112097
23583	36298	0	applied	\N	\N	\N	\N	112130	112130	112131
23583	36299	1	applied	\N	\N	\N	\N	112132	112132	112133
23583	36300	2	applied	\N	\N	\N	\N	112134	112134	112135
23583	36301	3	applied	\N	\N	\N	\N	112136	112136	112137
23587	36302	0	applied	\N	\N	\N	\N	112143	112143	112144
23587	36303	1	applied	\N	\N	\N	\N	112145	112145	112146
23587	36304	2	applied	\N	\N	\N	\N	112147	112147	112148
23589	36308	0	applied	\N	\N	\N	\N	112159	112159	112160
23589	36309	1	applied	\N	\N	\N	\N	112161	112161	112162
23589	36310	2	applied	\N	\N	\N	\N	112163	112163	112164
23589	36311	3	applied	\N	\N	\N	\N	112165	112165	112166
23592	36312	0	applied	\N	\N	\N	\N	112169	112169	112170
23592	36313	1	applied	\N	\N	\N	\N	112171	112171	112172
23592	36314	2	applied	\N	\N	\N	\N	112173	112173	112174
23592	36315	3	applied	\N	\N	\N	\N	112175	112175	112176
23592	36316	4	applied	\N	\N	\N	\N	112177	112177	112178
23592	36317	5	applied	\N	\N	\N	\N	112179	112179	112180
23595	36305	0	applied	\N	\N	\N	\N	112152	112152	112153
23595	36308	1	applied	\N	\N	\N	\N	112159	112159	112160
23595	36312	2	applied	\N	\N	\N	\N	112169	112169	112170
23595	36313	3	applied	\N	\N	\N	\N	112171	112171	112172
23595	36306	4	applied	\N	\N	\N	\N	112154	112154	112155
23595	36309	5	applied	\N	\N	\N	\N	112161	112161	112187
23595	36307	6	applied	\N	\N	\N	\N	112156	112156	112162
23595	36310	7	applied	\N	\N	\N	\N	112163	112163	112164
23595	36315	8	applied	\N	\N	\N	\N	112175	112175	112188
23595	36316	9	applied	\N	\N	\N	\N	112177	112177	112189
23595	36311	10	applied	\N	\N	\N	\N	112165	112165	112190
23595	36314	11	applied	\N	\N	\N	\N	112173	112173	112178
23595	36317	12	applied	\N	\N	\N	\N	112179	112179	112180
23596	36318	0	applied	\N	\N	\N	\N	112192	112192	112193
23596	36319	1	applied	\N	\N	\N	\N	112194	112194	112195
23596	36320	2	applied	\N	\N	\N	\N	112196	112196	112197
23596	36321	3	applied	\N	\N	\N	\N	112198	112198	112199
23596	36322	4	applied	\N	\N	\N	\N	112200	112200	112201
23596	36323	5	applied	\N	\N	\N	\N	112202	112202	112203
23596	36324	6	applied	\N	\N	\N	\N	112204	112204	112205
23607	36267	0	applied	\N	\N	\N	\N	112280	112280	112044
23607	36327	1	applied	\N	\N	\N	\N	112281	112281	112230
23607	36328	2	applied	\N	\N	\N	\N	112282	112282	112232
23607	36329	3	applied	\N	\N	\N	\N	112283	112283	112234
23607	36330	4	applied	\N	\N	\N	\N	112284	112284	112236
23607	36331	5	applied	\N	\N	\N	\N	112285	112285	112238
23607	36332	6	applied	\N	\N	\N	\N	112286	112286	112286
23610	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23610	36346	1	applied	\N	\N	\N	\N	112273	112273	112274
23610	36345	2	applied	\N	\N	\N	\N	112269	112269	112275
23613	36350	0	applied	\N	\N	\N	\N	112300	112300	112301
23613	36351	1	applied	\N	\N	\N	\N	112302	112302	112303
23613	36352	2	applied	\N	\N	\N	\N	112304	112304	112305
23613	36353	3	applied	\N	\N	\N	\N	112306	112306	112307
23613	36354	4	applied	\N	\N	\N	\N	112308	112308	112309
23613	36355	5	applied	\N	\N	\N	\N	112310	112310	112311
23613	36356	6	applied	\N	\N	\N	\N	112312	112312	112313
23613	36357	7	applied	\N	\N	\N	\N	112314	112314	112315
23613	36358	8	applied	\N	\N	\N	\N	112316	112316	112317
23613	36359	9	applied	\N	\N	\N	\N	112318	112318	112319
23615	36360	0	applied	\N	\N	\N	\N	112324	112324	112325
23615	36361	1	applied	\N	\N	\N	\N	112326	112326	112327
23615	36362	2	applied	\N	\N	\N	\N	112328	112328	112329
23615	36363	3	applied	\N	\N	\N	\N	112330	112330	112331
23615	36364	4	applied	\N	\N	\N	\N	112332	112332	112333
23615	36365	5	applied	\N	\N	\N	\N	112334	112334	112335
23622	36373	0	applied	\N	\N	\N	\N	112356	112356	112357
23622	36374	1	applied	\N	\N	\N	\N	112358	112358	112359
23622	36375	2	applied	\N	\N	\N	\N	112360	112360	112361
23622	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23622	36377	4	applied	\N	\N	\N	\N	112363	112363	112364
23622	36378	5	applied	\N	\N	\N	\N	112365	112365	112366
23622	36379	6	applied	\N	\N	\N	\N	112367	112367	112368
23622	36380	7	applied	\N	\N	\N	\N	112369	112369	112370
23627	36390	0	applied	\N	\N	\N	\N	112418	112418	112419
23627	36391	1	applied	\N	\N	\N	\N	112420	112420	112421
23627	36392	2	applied	\N	\N	\N	\N	112422	112422	112423
23627	36393	3	applied	\N	\N	\N	\N	112424	112424	112425
23627	36394	4	applied	\N	\N	\N	\N	112426	112426	112427
23627	36395	5	applied	\N	\N	\N	\N	112428	112428	112429
23542	36223	1	applied	\N	\N	\N	\N	111922	111922	111923
23546	36235	0	applied	\N	\N	\N	\N	111956	111956	111957
23546	36236	1	applied	\N	\N	\N	\N	111958	111958	111959
23546	36237	2	applied	\N	\N	\N	\N	111960	111960	111961
23552	36238	0	applied	\N	\N	\N	\N	111964	111964	111965
23552	36239	1	applied	\N	\N	\N	\N	111966	111966	111967
23552	36240	2	applied	\N	\N	\N	\N	111968	111968	111969
23552	36241	3	applied	\N	\N	\N	\N	111970	111970	111971
23552	36242	4	applied	\N	\N	\N	\N	111972	111972	111973
23552	36243	5	applied	\N	\N	\N	\N	111974	111974	111975
23552	36244	6	applied	\N	\N	\N	\N	111976	111976	111977
23553	36245	0	applied	\N	\N	\N	\N	111982	111982	111983
23553	36246	1	applied	\N	\N	\N	\N	111984	111984	111985
23553	36247	2	applied	\N	\N	\N	\N	111986	111986	111987
23553	36248	3	applied	\N	\N	\N	\N	111988	111988	111989
23553	36249	4	applied	\N	\N	\N	\N	111990	111990	111991
23553	36250	5	applied	\N	\N	\N	\N	111992	111992	111993
23559	36251	0	applied	\N	\N	\N	\N	112000	112000	112001
23559	36252	1	applied	\N	\N	\N	\N	112002	112002	112003
23559	36253	2	applied	\N	\N	\N	\N	112004	112004	112005
23559	36254	3	applied	\N	\N	\N	\N	112006	112006	112007
23559	36255	4	applied	\N	\N	\N	\N	112008	112008	112009
23559	36256	5	applied	\N	\N	\N	\N	112010	112010	112011
23560	36257	0	applied	\N	\N	\N	\N	112018	112018	112019
23560	36258	1	applied	\N	\N	\N	\N	112020	112020	112021
23560	36259	2	applied	\N	\N	\N	\N	112022	112022	112023
23560	36260	3	applied	\N	\N	\N	\N	112024	112024	112025
23560	36261	4	applied	\N	\N	\N	\N	112026	112026	112027
23560	36262	5	applied	\N	\N	\N	\N	112028	112028	112029
23567	36271	0	applied	\N	\N	\N	\N	112056	112056	112057
23567	36272	1	applied	\N	\N	\N	\N	112058	112058	112059
23567	36273	2	applied	\N	\N	\N	\N	112060	112060	112061
23567	36274	3	applied	\N	\N	\N	\N	112062	112062	112063
23567	36275	4	applied	\N	\N	\N	\N	112064	112064	112065
23567	36276	5	applied	\N	\N	\N	\N	112066	112066	112067
23572	36281	0	applied	\N	\N	\N	\N	112080	112080	112081
23572	36282	1	applied	\N	\N	\N	\N	112082	112082	112083
23572	36283	2	applied	\N	\N	\N	\N	112084	112084	112085
23574	36284	0	applied	\N	\N	\N	\N	112090	112090	112091
23574	36285	1	applied	\N	\N	\N	\N	112092	112092	112093
23574	36286	2	applied	\N	\N	\N	\N	112094	112094	112095
23574	36287	3	applied	\N	\N	\N	\N	112096	112096	112097
23577	36284	0	applied	\N	\N	\N	\N	112090	112090	112091
23577	36286	1	applied	\N	\N	\N	\N	112094	112094	112101
23577	36287	2	applied	\N	\N	\N	\N	112096	112096	112093
23578	36288	0	applied	\N	\N	\N	\N	112104	112104	112105
23578	36289	1	applied	\N	\N	\N	\N	112106	112106	112107
23578	36290	2	applied	\N	\N	\N	\N	112108	112108	112109
23584	36298	0	applied	\N	\N	\N	\N	112130	112130	112131
23584	36299	1	applied	\N	\N	\N	\N	112132	112132	112133
23584	36300	2	applied	\N	\N	\N	\N	112134	112134	112135
23584	36301	3	applied	\N	\N	\N	\N	112136	112136	112137
23590	36308	0	applied	\N	\N	\N	\N	112159	112159	112160
23590	36309	1	applied	\N	\N	\N	\N	112161	112161	112162
23590	36310	2	applied	\N	\N	\N	\N	112163	112163	112164
23590	36311	3	applied	\N	\N	\N	\N	112165	112165	112166
23593	36312	0	applied	\N	\N	\N	\N	112169	112169	112170
23593	36313	1	applied	\N	\N	\N	\N	112171	112171	112172
23593	36314	2	applied	\N	\N	\N	\N	112173	112173	112174
23593	36315	3	applied	\N	\N	\N	\N	112175	112175	112176
23593	36316	4	applied	\N	\N	\N	\N	112177	112177	112178
23593	36317	5	applied	\N	\N	\N	\N	112179	112179	112180
23597	36325	0	applied	\N	\N	\N	\N	112208	112208	112209
23597	36326	1	applied	\N	\N	\N	\N	112210	112210	112211
23604	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23604	36345	1	applied	\N	\N	\N	\N	112269	112269	112270
23608	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23608	36346	1	applied	\N	\N	\N	\N	112273	112273	112274
23608	36345	2	applied	\N	\N	\N	\N	112269	112269	112275
23616	36360	0	applied	\N	\N	\N	\N	112324	112324	112325
23616	36361	1	applied	\N	\N	\N	\N	112326	112326	112327
23616	36362	2	applied	\N	\N	\N	\N	112328	112328	112329
23616	36363	3	applied	\N	\N	\N	\N	112330	112330	112331
23616	36364	4	applied	\N	\N	\N	\N	112332	112332	112333
23616	36365	5	applied	\N	\N	\N	\N	112334	112334	112335
23620	36369	0	applied	\N	\N	\N	\N	112345	112345	112346
23620	36370	1	applied	\N	\N	\N	\N	112347	112347	112348
23620	36371	2	applied	\N	\N	\N	\N	112349	112349	112350
23620	36372	3	applied	\N	\N	\N	\N	112351	112351	112352
23623	36373	0	applied	\N	\N	\N	\N	112356	112356	112357
23623	36374	1	applied	\N	\N	\N	\N	112358	112358	112359
23623	36375	2	applied	\N	\N	\N	\N	112360	112360	112361
23623	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23623	36377	4	applied	\N	\N	\N	\N	112363	112363	112364
23623	36381	5	applied	\N	\N	\N	\N	112372	112372	112373
23623	36382	6	applied	\N	\N	\N	\N	112374	112374	112370
23623	36383	7	applied	\N	\N	\N	\N	112375	112375	112376
23623	36378	8	applied	\N	\N	\N	\N	112365	112365	112377
23623	36379	9	applied	\N	\N	\N	\N	112367	112367	112378
23623	36380	10	applied	\N	\N	\N	\N	112369	112369	112379
23625	36384	0	applied	\N	\N	\N	\N	112383	112383	112384
23625	36385	1	applied	\N	\N	\N	\N	112385	112385	112386
23625	36381	2	applied	\N	\N	\N	\N	112372	112372	112376
23625	36382	3	applied	\N	\N	\N	\N	112374	112374	112387
23625	36383	4	applied	\N	\N	\N	\N	112375	112375	112379
23625	36386	5	applied	\N	\N	\N	\N	112388	112388	112389
23625	36387	6	applied	\N	\N	\N	\N	112390	112390	112391
23625	36388	7	applied	\N	\N	\N	\N	112392	112392	112393
23625	36389	8	applied	\N	\N	\N	\N	112394	112394	112395
23628	36397	0	applied	\N	\N	\N	\N	112434	112434	112435
23628	36398	1	applied	\N	\N	\N	\N	112436	112436	112437
23628	36399	2	applied	\N	\N	\N	\N	112438	112438	112439
23638	36420	0	applied	\N	\N	\N	\N	112496	112496	112497
23638	36421	1	applied	\N	\N	\N	\N	112498	112498	112499
23638	36422	2	applied	\N	\N	\N	\N	112500	112500	112501
23638	36423	3	applied	\N	\N	\N	\N	112502	112502	112503
23638	36424	4	applied	\N	\N	\N	\N	112504	112504	112505
23638	36425	5	applied	\N	\N	\N	\N	112506	112506	112507
23638	36426	6	applied	\N	\N	\N	\N	112508	112508	112509
23638	36427	7	applied	\N	\N	\N	\N	112510	112510	112511
23638	36428	8	applied	\N	\N	\N	\N	112512	112512	112513
23643	36432	0	applied	\N	\N	\N	\N	112529	112529	112530
23643	36433	1	applied	\N	\N	\N	\N	112531	112531	112532
23643	36434	2	applied	\N	\N	\N	\N	112533	112533	112534
23643	36435	3	applied	\N	\N	\N	\N	112535	112535	112536
23643	36436	4	applied	\N	\N	\N	\N	112537	112537	112538
23643	36437	5	applied	\N	\N	\N	\N	112539	112539	112540
23643	36438	6	applied	\N	\N	\N	\N	112541	112541	112542
23645	36439	0	applied	\N	\N	\N	\N	112546	112546	112547
23551	36243	5	applied	\N	\N	\N	\N	111974	111974	111975
23551	36244	6	applied	\N	\N	\N	\N	111976	111976	111977
23558	36251	0	applied	\N	\N	\N	\N	112000	112000	112001
23558	36252	1	applied	\N	\N	\N	\N	112002	112002	112003
23558	36253	2	applied	\N	\N	\N	\N	112004	112004	112005
23558	36254	3	applied	\N	\N	\N	\N	112006	112006	112007
23558	36255	4	applied	\N	\N	\N	\N	112008	112008	112009
23558	36256	5	applied	\N	\N	\N	\N	112010	112010	112011
23561	36263	0	applied	\N	\N	\N	\N	112032	112032	112033
23561	36264	1	applied	\N	\N	\N	\N	112034	112034	112035
23561	36265	2	applied	\N	\N	\N	\N	112036	112036	112037
23561	36266	3	applied	\N	\N	\N	\N	112038	112038	112039
23563	36267	0	applied	\N	\N	\N	\N	112043	112043	112044
23563	36268	1	applied	\N	\N	\N	\N	112045	112045	112046
23563	36269	2	applied	\N	\N	\N	\N	112047	112047	112048
23563	36270	3	applied	\N	\N	\N	\N	112049	112049	112050
23565	36267	0	applied	\N	\N	\N	\N	112043	112043	112044
23565	36268	1	applied	\N	\N	\N	\N	112045	112045	112046
23565	36269	2	applied	\N	\N	\N	\N	112047	112047	112048
23565	36270	3	applied	\N	\N	\N	\N	112049	112049	112050
23568	36271	0	applied	\N	\N	\N	\N	112056	112056	112057
23568	36272	1	applied	\N	\N	\N	\N	112058	112058	112059
23568	36273	2	applied	\N	\N	\N	\N	112060	112060	112061
23568	36274	3	applied	\N	\N	\N	\N	112062	112062	112063
23568	36275	4	applied	\N	\N	\N	\N	112064	112064	112065
23568	36276	5	applied	\N	\N	\N	\N	112066	112066	112067
23570	36277	0	applied	\N	\N	\N	\N	112072	112072	112073
23570	36278	1	applied	\N	\N	\N	\N	112074	112074	112075
23570	36279	2	applied	\N	\N	\N	\N	112076	112076	112077
23570	36280	3	applied	\N	\N	\N	\N	112078	112078	112079
23573	36281	0	applied	\N	\N	\N	\N	112080	112080	112081
23573	36282	1	applied	\N	\N	\N	\N	112082	112082	112083
23573	36283	2	applied	\N	\N	\N	\N	112084	112084	112085
23575	36284	0	applied	\N	\N	\N	\N	112090	112090	112091
23575	36285	1	applied	\N	\N	\N	\N	112092	112092	112093
23575	36286	2	applied	\N	\N	\N	\N	112094	112094	112095
23575	36287	3	applied	\N	\N	\N	\N	112096	112096	112097
23579	36291	0	applied	\N	\N	\N	\N	112111	112111	112112
23579	36292	1	applied	\N	\N	\N	\N	112113	112113	112114
23579	36293	2	applied	\N	\N	\N	\N	112115	112115	112116
23579	36294	3	applied	\N	\N	\N	\N	112117	112117	112118
23581	36295	0	applied	\N	\N	\N	\N	112123	112123	112124
23581	36296	1	applied	\N	\N	\N	\N	112125	112125	112126
23581	36297	2	applied	\N	\N	\N	\N	112127	112127	112128
23585	36298	0	applied	\N	\N	\N	\N	112130	112130	112131
23585	36299	1	applied	\N	\N	\N	\N	112132	112132	112133
23585	36300	2	applied	\N	\N	\N	\N	112134	112134	112135
23585	36301	3	applied	\N	\N	\N	\N	112136	112136	112137
23588	36305	0	applied	\N	\N	\N	\N	112152	112152	112153
23588	36306	1	applied	\N	\N	\N	\N	112154	112154	112155
23588	36307	2	applied	\N	\N	\N	\N	112156	112156	112157
23594	36312	0	applied	\N	\N	\N	\N	112169	112169	112170
23594	36313	1	applied	\N	\N	\N	\N	112171	112171	112172
23594	36314	2	applied	\N	\N	\N	\N	112173	112173	112174
23594	36315	3	applied	\N	\N	\N	\N	112175	112175	112176
23594	36316	4	applied	\N	\N	\N	\N	112177	112177	112178
23594	36317	5	applied	\N	\N	\N	\N	112179	112179	112180
23598	36295	0	applied	\N	\N	\N	\N	112123	112123	112124
23598	36298	1	applied	\N	\N	\N	\N	112130	112130	112131
23598	36302	2	applied	\N	\N	\N	\N	112143	112143	112144
23598	36305	3	applied	\N	\N	\N	\N	112152	112152	112153
23598	36308	4	applied	\N	\N	\N	\N	112159	112159	112160
23598	36312	5	applied	\N	\N	\N	\N	112169	112169	112170
23598	36313	6	applied	\N	\N	\N	\N	112171	112171	112172
23598	36318	7	applied	\N	\N	\N	\N	112192	112192	112193
23598	36319	8	applied	\N	\N	\N	\N	112194	112194	112195
23598	36325	9	applied	\N	\N	\N	\N	112208	112208	112209
23598	36296	10	applied	\N	\N	\N	\N	112125	112125	112126
23598	36299	11	applied	\N	\N	\N	\N	112132	112132	112213
23598	36297	12	applied	\N	\N	\N	\N	112127	112127	112133
23598	36300	13	applied	\N	\N	\N	\N	112134	112134	112135
23598	36303	14	applied	\N	\N	\N	\N	112145	112145	112214
23598	36306	15	applied	\N	\N	\N	\N	112154	112154	112215
23598	36309	16	applied	\N	\N	\N	\N	112161	112161	112146
23598	36320	17	applied	\N	\N	\N	\N	112196	112196	112216
23598	36301	18	applied	\N	\N	\N	\N	112136	112136	112217
23598	36304	19	applied	\N	\N	\N	\N	112147	112147	112218
23598	36307	20	applied	\N	\N	\N	\N	112156	112156	112219
23598	36310	21	applied	\N	\N	\N	\N	112163	112163	112220
23598	36315	22	applied	\N	\N	\N	\N	112175	112175	112166
23598	36316	23	applied	\N	\N	\N	\N	112177	112177	112221
23598	36323	24	applied	\N	\N	\N	\N	112202	112202	112190
23598	36324	25	applied	\N	\N	\N	\N	112204	112204	112222
23598	36311	26	applied	\N	\N	\N	\N	112165	112165	112223
23598	36314	27	applied	\N	\N	\N	\N	112173	112173	112224
23598	36317	28	applied	\N	\N	\N	\N	112179	112179	112225
23598	36321	29	applied	\N	\N	\N	\N	112198	112198	112226
23598	36322	30	applied	\N	\N	\N	\N	112200	112200	112205
23598	36326	31	applied	\N	\N	\N	\N	112210	112210	112211
23600	36327	0	applied	\N	\N	\N	\N	112229	112229	112230
23600	36328	1	applied	\N	\N	\N	\N	112231	112231	112232
23600	36329	2	applied	\N	\N	\N	\N	112233	112233	112234
23600	36330	3	applied	\N	\N	\N	\N	112235	112235	112236
23600	36331	4	applied	\N	\N	\N	\N	112237	112237	112238
23600	36332	5	applied	\N	\N	\N	\N	112239	112239	112239
23600	36333	6	applied	\N	\N	\N	\N	112240	112240	112241
23600	36334	7	applied	\N	\N	\N	\N	112242	112242	112243
23600	36335	8	applied	\N	\N	\N	\N	112244	112244	112245
23600	36336	9	applied	\N	\N	\N	\N	112246	112246	112247
23600	36337	10	applied	\N	\N	\N	\N	112248	112248	112249
23600	36338	11	applied	\N	\N	\N	\N	112250	112250	112251
23600	36339	12	applied	\N	\N	\N	\N	112252	112252	112253
23600	36340	13	applied	\N	\N	\N	\N	112254	112254	112255
23602	36341	0	applied	\N	\N	\N	\N	112258	112258	112259
23602	36342	1	applied	\N	\N	\N	\N	112260	112260	112261
23602	36343	2	applied	\N	\N	\N	\N	112262	112262	112263
23605	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23605	36346	1	applied	\N	\N	\N	\N	112273	112273	112274
23605	36345	2	applied	\N	\N	\N	\N	112269	112269	112275
23617	36360	0	applied	\N	\N	\N	\N	112324	112324	112325
23617	36361	1	applied	\N	\N	\N	\N	112326	112326	112327
23617	36362	2	applied	\N	\N	\N	\N	112328	112328	112329
23617	36363	3	applied	\N	\N	\N	\N	112330	112330	112331
23617	36364	4	applied	\N	\N	\N	\N	112332	112332	112333
23617	36365	5	applied	\N	\N	\N	\N	112334	112334	112335
23618	36366	0	applied	\N	\N	\N	\N	112339	112339	112340
23618	36367	1	applied	\N	\N	\N	\N	112341	112341	112342
23618	36368	2	applied	\N	\N	\N	\N	112343	112343	112344
23621	36369	0	applied	\N	\N	\N	\N	112345	112345	112346
23621	36370	1	applied	\N	\N	\N	\N	112347	112347	112348
23582	36300	2	applied	\N	\N	\N	\N	112134	112134	112135
23582	36301	3	applied	\N	\N	\N	\N	112136	112136	112137
23586	36302	0	applied	\N	\N	\N	\N	112143	112143	112144
23586	36303	1	applied	\N	\N	\N	\N	112145	112145	112146
23586	36304	2	applied	\N	\N	\N	\N	112147	112147	112148
23591	36312	0	applied	\N	\N	\N	\N	112169	112169	112170
23591	36313	1	applied	\N	\N	\N	\N	112171	112171	112172
23591	36314	2	applied	\N	\N	\N	\N	112173	112173	112174
23591	36315	3	applied	\N	\N	\N	\N	112175	112175	112176
23591	36316	4	applied	\N	\N	\N	\N	112177	112177	112178
23591	36317	5	applied	\N	\N	\N	\N	112179	112179	112180
23599	36325	0	applied	\N	\N	\N	\N	112208	112208	112209
23599	36326	1	applied	\N	\N	\N	\N	112210	112210	112211
23601	36327	0	applied	\N	\N	\N	\N	112229	112229	112230
23601	36328	1	applied	\N	\N	\N	\N	112231	112231	112232
23601	36329	2	applied	\N	\N	\N	\N	112233	112233	112234
23601	36330	3	applied	\N	\N	\N	\N	112235	112235	112236
23601	36331	4	applied	\N	\N	\N	\N	112237	112237	112238
23601	36332	5	applied	\N	\N	\N	\N	112239	112239	112239
23601	36333	6	applied	\N	\N	\N	\N	112240	112240	112241
23601	36334	7	applied	\N	\N	\N	\N	112242	112242	112243
23601	36335	8	applied	\N	\N	\N	\N	112244	112244	112245
23601	36336	9	applied	\N	\N	\N	\N	112246	112246	112247
23601	36337	10	applied	\N	\N	\N	\N	112248	112248	112249
23601	36338	11	applied	\N	\N	\N	\N	112250	112250	112251
23601	36339	12	applied	\N	\N	\N	\N	112252	112252	112253
23601	36340	13	applied	\N	\N	\N	\N	112254	112254	112255
23603	36341	0	applied	\N	\N	\N	\N	112258	112258	112259
23603	36342	1	applied	\N	\N	\N	\N	112260	112260	112261
23603	36343	2	applied	\N	\N	\N	\N	112262	112262	112263
23606	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23606	36346	1	applied	\N	\N	\N	\N	112273	112273	112274
23606	36345	2	applied	\N	\N	\N	\N	112269	112269	112275
23609	36344	0	applied	\N	\N	\N	\N	112267	112267	112268
23609	36346	1	applied	\N	\N	\N	\N	112273	112273	112274
23609	36345	2	applied	\N	\N	\N	\N	112269	112269	112275
23611	36347	0	applied	\N	\N	\N	\N	112292	112292	112293
23611	36348	1	applied	\N	\N	\N	\N	112294	112294	112295
23611	36349	2	applied	\N	\N	\N	\N	112296	112296	112297
23612	36350	0	applied	\N	\N	\N	\N	112300	112300	112301
23612	36351	1	applied	\N	\N	\N	\N	112302	112302	112303
23612	36352	2	applied	\N	\N	\N	\N	112304	112304	112305
23612	36353	3	applied	\N	\N	\N	\N	112306	112306	112307
23612	36354	4	applied	\N	\N	\N	\N	112308	112308	112309
23612	36355	5	applied	\N	\N	\N	\N	112310	112310	112311
23612	36356	6	applied	\N	\N	\N	\N	112312	112312	112313
23612	36357	7	applied	\N	\N	\N	\N	112314	112314	112315
23612	36358	8	applied	\N	\N	\N	\N	112316	112316	112317
23612	36359	9	applied	\N	\N	\N	\N	112318	112318	112319
23619	36366	0	applied	\N	\N	\N	\N	112339	112339	112340
23619	36367	1	applied	\N	\N	\N	\N	112341	112341	112342
23619	36368	2	applied	\N	\N	\N	\N	112343	112343	112344
23632	36407	0	applied	\N	\N	\N	\N	112459	112459	112460
23632	36409	1	applied	\N	\N	\N	\N	112465	112465	112466
23632	36408	2	applied	\N	\N	\N	\N	112461	112461	112467
23634	36410	0	applied	\N	\N	\N	\N	112469	112469	112470
23634	36411	1	applied	\N	\N	\N	\N	112471	112471	112472
23634	36412	2	applied	\N	\N	\N	\N	112473	112473	112474
23649	36445	0	applied	\N	\N	\N	\N	112562	112562	112563
23649	36446	1	applied	\N	\N	\N	\N	112564	112564	112565
23649	36447	2	applied	\N	\N	\N	\N	112566	112566	112567
23649	36448	3	applied	\N	\N	\N	\N	112568	112568	112569
23653	36456	0	applied	\N	\N	\N	\N	112591	112591	112592
23653	36457	1	applied	\N	\N	\N	\N	112593	112593	112594
23653	36458	2	applied	\N	\N	\N	\N	112595	112595	112596
23658	36459	0	applied	\N	\N	\N	\N	112610	112610	112611
23658	36460	1	applied	\N	\N	\N	\N	112612	112612	112613
23658	36461	2	applied	\N	\N	\N	\N	112614	112614	112615
23658	36462	3	applied	\N	\N	\N	\N	112616	112616	112617
23658	36463	4	applied	\N	\N	\N	\N	112618	112618	112619
23658	36464	5	applied	\N	\N	\N	\N	112620	112620	112621
23658	36465	6	applied	\N	\N	\N	\N	112622	112622	112623
23658	36466	7	applied	\N	\N	\N	\N	112624	112624	112625
23658	36467	8	applied	\N	\N	\N	\N	112626	112626	112627
23658	36468	9	applied	\N	\N	\N	\N	112628	112628	112629
23660	36469	0	applied	\N	\N	\N	\N	112633	112633	112634
23660	36470	1	applied	\N	\N	\N	\N	112635	112635	112636
23660	36471	2	applied	\N	\N	\N	\N	112637	112637	112638
23666	36472	0	applied	\N	\N	\N	\N	112646	112646	112647
23666	36473	1	applied	\N	\N	\N	\N	112648	112648	112649
23666	36474	2	applied	\N	\N	\N	\N	112650	112650	112651
23666	36475	3	applied	\N	\N	\N	\N	112652	112652	112653
23667	36476	0	applied	\N	\N	\N	\N	112660	112660	112661
23667	36474	1	applied	\N	\N	\N	\N	112650	112650	112653
23670	36481	0	applied	\N	\N	\N	\N	112674	112674	112675
23670	36482	1	applied	\N	\N	\N	\N	112676	112676	112677
23670	36483	2	applied	\N	\N	\N	\N	112678	112678	112679
23670	36484	3	applied	\N	\N	\N	\N	112680	112680	112681
23670	36485	4	applied	\N	\N	\N	\N	112682	112682	112683
23670	36486	5	applied	\N	\N	\N	\N	112684	112684	112685
23670	36487	6	applied	\N	\N	\N	\N	112686	112686	112687
23677	36488	0	applied	\N	\N	\N	\N	112695	112695	112696
23677	36489	1	applied	\N	\N	\N	\N	112697	112697	112698
23677	36490	2	applied	\N	\N	\N	\N	112699	112699	112700
23681	36495	0	applied	\N	\N	\N	\N	112718	112718	112719
23681	36496	1	applied	\N	\N	\N	\N	112720	112720	112721
23681	36497	2	applied	\N	\N	\N	\N	112722	112722	112723
23681	36498	3	applied	\N	\N	\N	\N	112724	112724	112725
23681	36499	4	applied	\N	\N	\N	\N	112726	112726	112727
23681	36500	5	applied	\N	\N	\N	\N	112728	112728	112729
23681	36501	6	applied	\N	\N	\N	\N	112730	112730	112731
23681	36502	7	applied	\N	\N	\N	\N	112732	112732	112733
23685	36512	0	applied	\N	\N	\N	\N	112758	112758	112759
23685	36513	1	applied	\N	\N	\N	\N	112760	112760	112761
23685	36514	2	applied	\N	\N	\N	\N	112762	112762	112763
23688	36525	0	applied	\N	\N	\N	\N	112786	112786	112787
23688	36526	1	applied	\N	\N	\N	\N	112788	112788	112789
23688	36527	2	applied	\N	\N	\N	\N	112790	112790	112791
23691	36535	0	applied	\N	\N	\N	\N	112807	112807	112808
23691	36536	1	applied	\N	\N	\N	\N	112809	112809	112810
23691	36537	2	applied	\N	\N	\N	\N	112811	112811	112812
23694	36538	0	applied	\N	\N	\N	\N	112815	112815	112816
23694	36539	1	applied	\N	\N	\N	\N	112817	112817	112818
23694	36540	2	applied	\N	\N	\N	\N	112819	112819	112820
23694	36541	3	applied	\N	\N	\N	\N	112821	112821	112822
23694	36542	5	applied	\N	\N	\N	\N	112824	112824	112825
23694	36543	6	applied	\N	\N	\N	\N	112826	112826	112827
23694	36544	7	applied	\N	\N	\N	\N	112828	112828	112829
23698	36545	0	applied	\N	\N	\N	\N	112838	112838	112839
23698	36546	1	applied	\N	\N	\N	\N	112840	112840	112841
23621	36371	2	applied	\N	\N	\N	\N	112349	112349	112350
23621	36372	3	applied	\N	\N	\N	\N	112351	112351	112352
23624	36373	0	applied	\N	\N	\N	\N	112356	112356	112357
23624	36374	1	applied	\N	\N	\N	\N	112358	112358	112359
23624	36375	2	applied	\N	\N	\N	\N	112360	112360	112361
23624	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23624	36377	4	applied	\N	\N	\N	\N	112363	112363	112364
23624	36381	5	applied	\N	\N	\N	\N	112372	112372	112373
23624	36382	6	applied	\N	\N	\N	\N	112374	112374	112370
23624	36383	7	applied	\N	\N	\N	\N	112375	112375	112376
23624	36378	8	applied	\N	\N	\N	\N	112365	112365	112377
23624	36379	9	applied	\N	\N	\N	\N	112367	112367	112378
23624	36380	10	applied	\N	\N	\N	\N	112369	112369	112379
23626	36267	0	applied	\N	\N	\N	\N	112280	112280	112397
23626	36327	1	applied	\N	\N	\N	\N	112229	112229	112230
23626	36328	2	applied	\N	\N	\N	\N	112231	112231	112232
23626	36329	3	applied	\N	\N	\N	\N	112233	112233	112234
23626	36330	4	applied	\N	\N	\N	\N	112235	112235	112236
23626	36331	5	applied	\N	\N	\N	\N	112237	112237	112238
23626	36181	6	applied	\N	\N	\N	\N	112398	112398	111820
23626	36182	7	applied	\N	\N	\N	\N	112399	112399	111822
23626	36183	8	applied	\N	\N	\N	\N	112400	112400	111824
23626	36332	9	applied	\N	\N	\N	\N	112239	112239	112239
23626	36078	10	applied	\N	\N	\N	\N	111523	111523	111524
23626	36081	11	applied	\N	\N	\N	\N	111531	111531	111532
23626	36085	12	applied	\N	\N	\N	\N	111544	111544	111545
23626	36088	13	applied	\N	\N	\N	\N	111552	111552	111553
23626	36091	14	applied	\N	\N	\N	\N	111565	111565	111566
23626	36092	15	applied	\N	\N	\N	\N	111567	111567	111568
23626	36093	16	applied	\N	\N	\N	\N	111569	111569	111570
23626	36101	17	applied	\N	\N	\N	\N	111587	111587	111588
23626	36104	18	applied	\N	\N	\N	\N	111594	111594	111595
23626	36107	19	applied	\N	\N	\N	\N	111604	111604	111605
23626	36108	20	applied	\N	\N	\N	\N	111606	111606	111607
23626	36113	22	applied	\N	\N	\N	\N	111620	111620	111621
23626	36117	23	applied	\N	\N	\N	\N	111629	111629	111630
23626	36120	24	applied	\N	\N	\N	\N	111640	111640	111641
23626	36121	25	applied	\N	\N	\N	\N	111642	111642	111643
23626	36126	26	applied	\N	\N	\N	\N	111656	111656	111657
23626	36130	27	applied	\N	\N	\N	\N	111678	111678	111679
23626	36133	28	applied	\N	\N	\N	\N	111684	111684	111685
23626	36134	29	applied	\N	\N	\N	\N	111686	111686	111687
23626	36140	30	applied	\N	\N	\N	\N	111701	111701	111702
23626	36143	31	applied	\N	\N	\N	\N	111711	111711	111712
23626	36146	32	applied	\N	\N	\N	\N	111721	111721	111722
23626	36151	33	applied	\N	\N	\N	\N	111737	111737	111738
23626	36155	34	applied	\N	\N	\N	\N	111751	111751	111752
23626	36158	35	applied	\N	\N	\N	\N	111761	111761	111762
23626	36162	36	applied	\N	\N	\N	\N	111772	111772	111773
23626	36163	37	applied	\N	\N	\N	\N	111774	111774	111775
23626	36164	38	applied	\N	\N	\N	\N	111776	111776	111777
23626	36172	39	applied	\N	\N	\N	\N	111798	111798	111799
23626	36175	40	applied	\N	\N	\N	\N	111806	111806	111807
23626	36178	41	applied	\N	\N	\N	\N	111813	111813	111814
23626	36179	42	applied	\N	\N	\N	\N	111815	111815	111816
23626	36180	43	applied	\N	\N	\N	\N	111817	111817	111818
23626	36193	44	applied	\N	\N	\N	\N	111848	111848	111849
23626	36196	45	applied	\N	\N	\N	\N	111856	111856	111857
23626	36200	46	applied	\N	\N	\N	\N	111867	111867	111868
23626	36205	47	applied	\N	\N	\N	\N	111881	111881	111882
23626	36206	48	applied	\N	\N	\N	\N	111883	111883	111884
23626	36212	49	applied	\N	\N	\N	\N	111897	111897	111898
23626	36213	50	applied	\N	\N	\N	\N	111899	111899	111900
23626	36184	51	applied	\N	\N	\N	\N	112402	112402	111826
23626	36185	52	applied	\N	\N	\N	\N	112403	112403	111828
23626	36203	53	applied	\N	\N	\N	\N	112404	112404	111876
23626	36204	54	applied	\N	\N	\N	\N	112044	112044	111878
23626	36214	55	applied	\N	\N	\N	\N	111901	111901	111902
23626	36222	56	applied	\N	\N	\N	\N	111920	111920	111921
23626	36225	57	applied	\N	\N	\N	\N	111932	111932	111933
23626	36228	58	applied	\N	\N	\N	\N	111939	111939	111940
23626	36231	59	applied	\N	\N	\N	\N	111947	111947	111948
23626	36235	60	applied	\N	\N	\N	\N	111956	111956	111957
23626	36238	61	applied	\N	\N	\N	\N	111964	111964	111965
23626	36239	62	applied	\N	\N	\N	\N	111966	111966	111967
23626	36245	63	applied	\N	\N	\N	\N	111982	111982	111983
23626	36246	64	applied	\N	\N	\N	\N	111984	111984	111985
23626	36251	65	applied	\N	\N	\N	\N	112000	112000	112001
23626	36257	66	applied	\N	\N	\N	\N	112018	112018	112019
23626	36258	67	applied	\N	\N	\N	\N	112020	112020	112021
23626	36263	68	applied	\N	\N	\N	\N	112032	112032	112033
23626	36268	69	applied	\N	\N	\N	\N	112045	112045	112046
23626	36271	70	applied	\N	\N	\N	\N	112056	112056	112057
23626	36272	71	applied	\N	\N	\N	\N	112058	112058	112059
23626	36277	72	applied	\N	\N	\N	\N	112072	112072	112073
23626	36281	73	applied	\N	\N	\N	\N	112080	112080	112081
23626	36284	74	applied	\N	\N	\N	\N	112090	112090	112091
23626	36288	75	applied	\N	\N	\N	\N	112104	112104	112105
23626	36292	76	applied	\N	\N	\N	\N	112113	112113	112114
23626	36295	77	applied	\N	\N	\N	\N	112123	112123	112124
23626	36298	78	applied	\N	\N	\N	\N	112130	112130	112131
23626	36302	79	applied	\N	\N	\N	\N	112143	112143	112144
23626	36305	80	applied	\N	\N	\N	\N	112152	112152	112153
23626	36308	81	applied	\N	\N	\N	\N	112159	112159	112160
23626	36312	82	applied	\N	\N	\N	\N	112169	112169	112170
23626	36313	83	applied	\N	\N	\N	\N	112171	112171	112172
23626	36318	84	applied	\N	\N	\N	\N	112192	112192	112193
23626	36319	85	applied	\N	\N	\N	\N	112194	112194	112195
23626	36325	86	applied	\N	\N	\N	\N	112208	112208	112209
23626	36333	87	applied	\N	\N	\N	\N	112240	112240	112241
23626	36334	88	applied	\N	\N	\N	\N	112242	112242	112243
23626	36341	89	applied	\N	\N	\N	\N	112258	112258	112259
23626	36344	90	applied	\N	\N	\N	\N	112267	112267	112268
23626	36347	91	applied	\N	\N	\N	\N	112292	112292	112293
23626	36350	92	applied	\N	\N	\N	\N	112300	112300	112301
23626	36351	93	applied	\N	\N	\N	\N	112302	112302	112303
23626	36352	94	applied	\N	\N	\N	\N	112304	112304	112305
23626	36360	95	applied	\N	\N	\N	\N	112324	112324	112325
23626	36361	96	applied	\N	\N	\N	\N	112326	112326	112327
23626	36366	97	applied	\N	\N	\N	\N	112339	112339	112340
23626	36369	98	applied	\N	\N	\N	\N	112345	112345	112346
23626	36373	99	applied	\N	\N	\N	\N	112356	112356	112357
23626	36374	100	applied	\N	\N	\N	\N	112358	112358	112359
23626	36375	101	applied	\N	\N	\N	\N	112360	112360	112361
23626	36384	102	applied	\N	\N	\N	\N	112383	112383	112384
23626	36385	103	applied	\N	\N	\N	\N	112385	112385	112386
23626	36376	104	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23626	36079	105	applied	\N	\N	\N	\N	111525	111525	111526
23626	36082	106	applied	\N	\N	\N	\N	111533	111533	112405
23626	36080	107	applied	\N	\N	\N	\N	111527	111527	111534
23626	36083	108	applied	\N	\N	\N	\N	111535	111535	111536
23626	36086	109	applied	\N	\N	\N	\N	111546	111546	112406
23626	36087	110	applied	\N	\N	\N	\N	111548	111548	112407
23626	36089	111	applied	\N	\N	\N	\N	111554	111554	112408
23626	36097	112	applied	\N	\N	\N	\N	111577	111577	112409
23626	36098	113	applied	\N	\N	\N	\N	111579	111579	111557
23626	36084	114	applied	\N	\N	\N	\N	111537	111537	112410
23626	36096	115	applied	\N	\N	\N	\N	111575	111575	112411
23626	36105	116	applied	\N	\N	\N	\N	111596	111596	111572
23626	36116	117	applied	\N	\N	\N	\N	111626	111626	112412
23626	36090	118	applied	\N	\N	\N	\N	111556	111556	111576
23626	36094	119	applied	\N	\N	\N	\N	111571	111571	112413
23626	36095	120	applied	\N	\N	\N	\N	111573	111573	112414
23626	36099	121	applied	\N	\N	\N	\N	111581	111581	111584
23626	36100	122	applied	\N	\N	\N	\N	111583	111583	111590
23626	36102	123	applied	\N	\N	\N	\N	111589	111589	112415
23626	36106	124	applied	\N	\N	\N	\N	111598	111598	111597
23626	36109	125	applied	\N	\N	\N	\N	111608	111608	111599
23629	36397	0	applied	\N	\N	\N	\N	112434	112434	112435
23629	36398	1	applied	\N	\N	\N	\N	112436	112436	112437
23629	36399	2	applied	\N	\N	\N	\N	112438	112438	112439
23631	36407	0	applied	\N	\N	\N	\N	112459	112459	112460
23631	36408	1	applied	\N	\N	\N	\N	112461	112461	112462
23636	36413	0	applied	\N	\N	\N	\N	112478	112478	112479
23636	36414	1	applied	\N	\N	\N	\N	112480	112480	112481
23636	36415	2	applied	\N	\N	\N	\N	112482	112482	112483
23636	36416	3	applied	\N	\N	\N	\N	112484	112484	112485
23636	36417	4	applied	\N	\N	\N	\N	112486	112486	112487
23636	36418	5	applied	\N	\N	\N	\N	112488	112488	112489
23636	36419	6	applied	\N	\N	\N	\N	112490	112490	112491
23639	36420	0	applied	\N	\N	\N	\N	112496	112496	112497
23639	36421	1	applied	\N	\N	\N	\N	112498	112498	112499
23639	36422	2	applied	\N	\N	\N	\N	112500	112500	112501
23639	36423	3	applied	\N	\N	\N	\N	112502	112502	112503
23639	36424	4	applied	\N	\N	\N	\N	112504	112504	112505
23639	36425	5	applied	\N	\N	\N	\N	112506	112506	112507
23639	36426	6	applied	\N	\N	\N	\N	112508	112508	112509
23639	36427	7	applied	\N	\N	\N	\N	112510	112510	112511
23639	36428	8	applied	\N	\N	\N	\N	112512	112512	112513
23641	36429	0	applied	\N	\N	\N	\N	112519	112519	112520
23641	36430	1	applied	\N	\N	\N	\N	112521	112521	112522
23641	36431	2	applied	\N	\N	\N	\N	112523	112523	112524
23644	36432	0	applied	\N	\N	\N	\N	112529	112529	112530
23644	36433	1	applied	\N	\N	\N	\N	112531	112531	112532
23644	36434	2	applied	\N	\N	\N	\N	112533	112533	112534
23644	36435	3	applied	\N	\N	\N	\N	112535	112535	112536
23644	36436	4	applied	\N	\N	\N	\N	112537	112537	112538
23644	36437	5	applied	\N	\N	\N	\N	112539	112539	112540
23644	36438	6	applied	\N	\N	\N	\N	112541	112541	112542
23646	36439	0	applied	\N	\N	\N	\N	112546	112546	112547
23646	36440	1	applied	\N	\N	\N	\N	112548	112548	112549
23646	36441	2	applied	\N	\N	\N	\N	112550	112550	112551
23648	36445	0	applied	\N	\N	\N	\N	112562	112562	112563
23648	36446	1	applied	\N	\N	\N	\N	112564	112564	112565
23648	36447	2	applied	\N	\N	\N	\N	112566	112566	112567
23648	36448	3	applied	\N	\N	\N	\N	112568	112568	112569
23651	36449	0	applied	\N	\N	\N	\N	112573	112573	112574
23651	36450	1	applied	\N	\N	\N	\N	112575	112575	112576
23651	36451	2	applied	\N	\N	\N	\N	112577	112577	112578
23651	36452	3	applied	\N	\N	\N	\N	112579	112579	112580
23651	36453	5	applied	\N	\N	\N	\N	112582	112582	112583
23651	36454	6	applied	\N	\N	\N	\N	112584	112584	112585
23651	36455	7	applied	\N	\N	\N	\N	112586	112586	112587
23656	36456	0	applied	\N	\N	\N	\N	112591	112591	112592
23656	36457	1	applied	\N	\N	\N	\N	112593	112593	112594
23656	36458	2	applied	\N	\N	\N	\N	112595	112595	112596
23657	36449	0	applied	\N	\N	\N	\N	112604	112604	112574
23657	36450	1	applied	\N	\N	\N	\N	112605	112605	112576
23657	36451	2	applied	\N	\N	\N	\N	112606	112606	112578
23657	36452	3	applied	\N	\N	\N	\N	112607	112607	112580
23657	36376	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23663	36469	0	applied	\N	\N	\N	\N	112633	112633	112634
23663	36471	1	applied	\N	\N	\N	\N	112637	112637	112644
23665	36472	0	applied	\N	\N	\N	\N	112646	112646	112647
23665	36473	1	applied	\N	\N	\N	\N	112648	112648	112649
23665	36475	2	applied	\N	\N	\N	\N	112652	112652	112656
23669	36478	0	applied	\N	\N	\N	\N	112667	112667	112668
23669	36477	1	applied	\N	\N	\N	\N	112664	112664	112665
23669	36479	2	applied	\N	\N	\N	\N	112669	112669	112670
23669	36480	3	applied	\N	\N	\N	\N	112671	112671	112672
23673	36481	0	applied	\N	\N	\N	\N	112674	112674	112675
23673	36482	1	applied	\N	\N	\N	\N	112676	112676	112677
23673	36483	2	applied	\N	\N	\N	\N	112678	112678	112679
23673	36484	3	applied	\N	\N	\N	\N	112680	112680	112681
23673	36485	4	applied	\N	\N	\N	\N	112682	112682	112683
23673	36486	5	applied	\N	\N	\N	\N	112684	112684	112685
23673	36487	6	applied	\N	\N	\N	\N	112686	112686	112687
23676	36488	0	applied	\N	\N	\N	\N	112695	112695	112696
23676	36489	1	applied	\N	\N	\N	\N	112697	112697	112698
23678	36491	0	applied	\N	\N	\N	\N	112706	112706	112707
23678	36492	1	applied	\N	\N	\N	\N	112708	112708	112709
23678	36493	2	applied	\N	\N	\N	\N	112710	112710	112711
23678	36494	3	applied	\N	\N	\N	\N	112712	112712	112713
23690	36532	0	applied	\N	\N	\N	\N	112800	112800	112801
23690	36533	1	applied	\N	\N	\N	\N	112802	112802	112803
23690	36534	2	applied	\N	\N	\N	\N	112804	112804	112805
23693	36538	0	applied	\N	\N	\N	\N	112815	112815	112816
23693	36539	1	applied	\N	\N	\N	\N	112817	112817	112818
23693	36540	2	applied	\N	\N	\N	\N	112819	112819	112820
23693	36541	3	applied	\N	\N	\N	\N	112821	112821	112822
23693	36542	5	applied	\N	\N	\N	\N	112824	112824	112825
23693	36543	6	applied	\N	\N	\N	\N	112826	112826	112827
23693	36544	7	applied	\N	\N	\N	\N	112828	112828	112829
23697	36538	0	applied	\N	\N	\N	\N	112815	112815	112816
23697	36539	1	applied	\N	\N	\N	\N	112817	112817	112818
23697	36540	2	applied	\N	\N	\N	\N	112819	112819	112820
23697	36541	3	applied	\N	\N	\N	\N	112821	112821	112822
23697	36542	5	applied	\N	\N	\N	\N	112824	112824	112825
23697	36543	6	applied	\N	\N	\N	\N	112826	112826	112827
23697	36544	7	applied	\N	\N	\N	\N	112828	112828	112829
23707	36573	0	applied	\N	\N	\N	\N	112914	112914	112915
23707	36574	1	applied	\N	\N	\N	\N	112916	112916	112917
23707	36575	2	applied	\N	\N	\N	\N	112918	112918	112919
23712	36586	0	applied	\N	\N	\N	\N	112947	112947	112948
23712	36587	1	applied	\N	\N	\N	\N	112949	112949	112950
23712	36588	2	applied	\N	\N	\N	\N	112951	112951	112952
23712	36589	3	applied	\N	\N	\N	\N	112953	112953	112954
23716	36590	0	applied	\N	\N	\N	\N	112957	112957	112958
23627	36396	6	applied	\N	\N	\N	\N	112430	112430	112431
23630	36400	0	applied	\N	\N	\N	\N	112444	112444	112445
23630	36401	1	applied	\N	\N	\N	\N	112446	112446	112447
23630	36402	2	applied	\N	\N	\N	\N	112448	112448	112449
23630	36403	3	applied	\N	\N	\N	\N	112450	112450	112451
23630	36404	4	applied	\N	\N	\N	\N	112452	112452	112453
23630	36405	5	applied	\N	\N	\N	\N	112454	112454	112455
23630	36406	6	applied	\N	\N	\N	\N	112456	112456	112457
23633	36407	0	applied	\N	\N	\N	\N	112459	112459	112460
23633	36409	1	applied	\N	\N	\N	\N	112465	112465	112466
23633	36408	2	applied	\N	\N	\N	\N	112461	112461	112467
23635	36410	0	applied	\N	\N	\N	\N	112469	112469	112470
23635	36411	1	applied	\N	\N	\N	\N	112471	112471	112472
23635	36412	2	applied	\N	\N	\N	\N	112473	112473	112474
23637	36413	0	applied	\N	\N	\N	\N	112478	112478	112479
23637	36414	1	applied	\N	\N	\N	\N	112480	112480	112481
23637	36415	2	applied	\N	\N	\N	\N	112482	112482	112483
23637	36416	3	applied	\N	\N	\N	\N	112484	112484	112485
23637	36417	4	applied	\N	\N	\N	\N	112486	112486	112487
23637	36418	5	applied	\N	\N	\N	\N	112488	112488	112489
23637	36419	6	applied	\N	\N	\N	\N	112490	112490	112491
23640	36420	0	applied	\N	\N	\N	\N	112496	112496	112497
23640	36421	1	applied	\N	\N	\N	\N	112498	112498	112499
23640	36422	2	applied	\N	\N	\N	\N	112500	112500	112501
23640	36423	3	applied	\N	\N	\N	\N	112502	112502	112503
23640	36424	4	applied	\N	\N	\N	\N	112504	112504	112505
23640	36425	5	applied	\N	\N	\N	\N	112506	112506	112507
23640	36426	6	applied	\N	\N	\N	\N	112508	112508	112509
23640	36427	7	applied	\N	\N	\N	\N	112510	112510	112511
23640	36428	8	applied	\N	\N	\N	\N	112512	112512	112513
23642	36429	0	applied	\N	\N	\N	\N	112519	112519	112520
23642	36430	1	applied	\N	\N	\N	\N	112521	112521	112522
23642	36431	2	applied	\N	\N	\N	\N	112523	112523	112524
23647	36442	0	applied	\N	\N	\N	\N	112554	112554	112555
23647	36443	1	applied	\N	\N	\N	\N	112556	112556	112557
23647	36444	2	applied	\N	\N	\N	\N	112558	112558	112559
23652	36449	0	applied	\N	\N	\N	\N	112573	112573	112574
23652	36450	1	applied	\N	\N	\N	\N	112575	112575	112576
23652	36451	2	applied	\N	\N	\N	\N	112577	112577	112578
23652	36452	3	applied	\N	\N	\N	\N	112579	112579	112580
23652	36453	5	applied	\N	\N	\N	\N	112582	112582	112583
23652	36454	6	applied	\N	\N	\N	\N	112584	112584	112585
23654	36456	0	applied	\N	\N	\N	\N	112591	112591	112592
23654	36457	1	applied	\N	\N	\N	\N	112593	112593	112594
23654	36458	2	applied	\N	\N	\N	\N	112595	112595	112596
23659	36459	0	applied	\N	\N	\N	\N	112610	112610	112611
23659	36460	1	applied	\N	\N	\N	\N	112612	112612	112613
23659	36461	2	applied	\N	\N	\N	\N	112614	112614	112615
23659	36462	3	applied	\N	\N	\N	\N	112616	112616	112617
23659	36463	4	applied	\N	\N	\N	\N	112618	112618	112619
23659	36464	5	applied	\N	\N	\N	\N	112620	112620	112621
23659	36465	6	applied	\N	\N	\N	\N	112622	112622	112623
23659	36466	7	applied	\N	\N	\N	\N	112624	112624	112625
23659	36467	8	applied	\N	\N	\N	\N	112626	112626	112627
23659	36468	9	applied	\N	\N	\N	\N	112628	112628	112629
23661	36469	0	applied	\N	\N	\N	\N	112633	112633	112634
23661	36470	1	applied	\N	\N	\N	\N	112635	112635	112636
23661	36471	2	applied	\N	\N	\N	\N	112637	112637	112638
23668	36476	0	applied	\N	\N	\N	\N	112660	112660	112661
23668	36474	1	applied	\N	\N	\N	\N	112650	112650	112653
23668	36477	2	applied	\N	\N	\N	\N	112664	112664	112665
23671	36481	0	applied	\N	\N	\N	\N	112674	112674	112675
23671	36482	1	applied	\N	\N	\N	\N	112676	112676	112677
23671	36483	2	applied	\N	\N	\N	\N	112678	112678	112679
23671	36484	3	applied	\N	\N	\N	\N	112680	112680	112681
23671	36485	4	applied	\N	\N	\N	\N	112682	112682	112683
23671	36486	5	applied	\N	\N	\N	\N	112684	112684	112685
23671	36487	6	applied	\N	\N	\N	\N	112686	112686	112687
23674	36481	0	applied	\N	\N	\N	\N	112674	112674	112675
23674	36482	1	applied	\N	\N	\N	\N	112676	112676	112677
23674	36483	2	applied	\N	\N	\N	\N	112678	112678	112679
23674	36484	3	applied	\N	\N	\N	\N	112680	112680	112681
23674	36485	4	applied	\N	\N	\N	\N	112682	112682	112683
23682	36495	0	applied	\N	\N	\N	\N	112718	112718	112719
23682	36496	1	applied	\N	\N	\N	\N	112720	112720	112721
23682	36497	2	applied	\N	\N	\N	\N	112722	112722	112723
23682	36498	3	applied	\N	\N	\N	\N	112724	112724	112725
23682	36499	4	applied	\N	\N	\N	\N	112726	112726	112727
23682	36500	5	applied	\N	\N	\N	\N	112728	112728	112729
23682	36501	6	applied	\N	\N	\N	\N	112730	112730	112731
23682	36502	7	applied	\N	\N	\N	\N	112732	112732	112733
23686	36515	0	applied	\N	\N	\N	\N	112764	112764	112765
23686	36516	1	applied	\N	\N	\N	\N	112766	112766	112767
23686	36517	2	applied	\N	\N	\N	\N	112768	112768	112769
23689	36528	0	applied	\N	\N	\N	\N	112792	112792	112793
23689	36529	1	applied	\N	\N	\N	\N	112794	112794	112795
23689	36530	2	applied	\N	\N	\N	\N	112796	112796	112797
23689	36531	3	applied	\N	\N	\N	\N	112798	112798	112799
23692	36535	0	applied	\N	\N	\N	\N	112807	112807	112808
23692	36536	1	applied	\N	\N	\N	\N	112809	112809	112810
23692	36537	2	applied	\N	\N	\N	\N	112811	112811	112812
23695	36538	0	applied	\N	\N	\N	\N	112815	112815	112816
23695	36539	1	applied	\N	\N	\N	\N	112817	112817	112818
23695	36540	2	applied	\N	\N	\N	\N	112819	112819	112820
23695	36541	3	applied	\N	\N	\N	\N	112821	112821	112822
23695	36542	5	applied	\N	\N	\N	\N	112824	112824	112825
23695	36543	6	applied	\N	\N	\N	\N	112826	112826	112827
23695	36544	7	applied	\N	\N	\N	\N	112828	112828	112829
23699	36545	0	applied	\N	\N	\N	\N	112838	112838	112839
23699	36546	1	applied	\N	\N	\N	\N	112840	112840	112841
23699	36547	2	applied	\N	\N	\N	\N	112842	112842	112843
23699	36549	3	applied	\N	\N	\N	\N	112846	112846	112862
23699	36550	4	applied	\N	\N	\N	\N	112848	112848	112863
23699	36551	5	applied	\N	\N	\N	\N	112850	112850	112864
23699	36552	6	applied	\N	\N	\N	\N	112852	112852	112865
23699	36555	7	applied	\N	\N	1000000000	\N	112858	112858	112859
23701	36556	0	applied	\N	\N	\N	\N	112869	112869	112870
23701	36557	1	applied	\N	\N	\N	\N	112871	112871	112872
23701	36548	2	applied	\N	\N	\N	\N	112844	112844	112853
23701	36558	3	applied	\N	\N	\N	\N	112873	112873	112874
23701	36559	4	applied	\N	\N	\N	\N	112875	112875	112876
23701	36553	5	applied	\N	\N	\N	\N	112854	112854	112877
23701	36554	6	applied	\N	\N	\N	\N	112856	112856	112878
23701	36560	7	applied	\N	\N	\N	\N	112879	112879	112880
23701	36561	8	applied	\N	\N	\N	\N	112881	112881	112882
23701	36562	9	applied	\N	\N	\N	\N	112883	112883	112884
23704	36567	0	applied	\N	\N	\N	\N	112896	112896	112897
23704	36568	1	applied	\N	\N	\N	\N	112898	112898	112899
23704	36569	2	applied	\N	\N	\N	\N	112901	112901	112902
23706	36570	0	applied	\N	\N	\N	\N	112906	112906	112907
23645	36440	1	applied	\N	\N	\N	\N	112548	112548	112549
23645	36441	2	applied	\N	\N	\N	\N	112550	112550	112551
23650	36449	0	applied	\N	\N	\N	\N	112573	112573	112574
23650	36450	1	applied	\N	\N	\N	\N	112575	112575	112576
23650	36451	2	applied	\N	\N	\N	\N	112577	112577	112578
23650	36452	3	applied	\N	\N	\N	\N	112579	112579	112580
23650	36453	5	applied	\N	\N	\N	\N	112582	112582	112583
23650	36454	6	applied	\N	\N	\N	\N	112584	112584	112585
23650	36455	7	applied	\N	\N	\N	\N	112586	112586	112587
23655	36456	0	applied	\N	\N	\N	\N	112591	112591	112592
23655	36457	1	applied	\N	\N	\N	\N	112593	112593	112594
23655	36458	2	applied	\N	\N	\N	\N	112595	112595	112596
23662	36469	0	applied	\N	\N	\N	\N	112633	112633	112634
23662	36470	1	applied	\N	\N	\N	\N	112635	112635	112636
23662	36471	2	applied	\N	\N	\N	\N	112637	112637	112638
23664	36472	0	applied	\N	\N	\N	\N	112646	112646	112647
23664	36473	1	applied	\N	\N	\N	\N	112648	112648	112649
23664	36474	2	applied	\N	\N	\N	\N	112650	112650	112651
23664	36475	3	applied	\N	\N	\N	\N	112652	112652	112653
23672	36481	0	applied	\N	\N	\N	\N	112674	112674	112675
23672	36482	1	applied	\N	\N	\N	\N	112676	112676	112677
23672	36483	2	applied	\N	\N	\N	\N	112678	112678	112679
23672	36484	3	applied	\N	\N	\N	\N	112680	112680	112681
23672	36485	4	applied	\N	\N	\N	\N	112682	112682	112683
23672	36486	5	applied	\N	\N	\N	\N	112684	112684	112685
23672	36487	6	applied	\N	\N	\N	\N	112686	112686	112687
23675	36488	0	applied	\N	\N	\N	\N	112695	112695	112696
23675	36489	1	applied	\N	\N	\N	\N	112697	112697	112698
23675	36490	2	applied	\N	\N	\N	\N	112699	112699	112700
23684	36503	0	applied	\N	\N	\N	\N	112738	112738	112739
23684	36504	1	applied	\N	\N	\N	\N	112740	112740	112741
23684	36505	2	applied	\N	\N	\N	\N	112742	112742	112743
23684	36506	3	applied	\N	\N	\N	\N	112744	112744	112745
23684	36507	4	applied	\N	\N	\N	\N	112746	112746	112747
23684	36508	5	applied	\N	\N	\N	\N	112748	112748	112749
23684	36509	6	applied	\N	\N	\N	\N	112750	112750	112751
23684	36510	7	applied	\N	\N	\N	\N	112752	112752	112753
23684	36511	8	applied	\N	\N	\N	\N	112754	112754	112755
23687	36518	0	applied	\N	\N	\N	\N	112772	112772	112773
23687	36519	1	applied	\N	\N	\N	\N	112774	112774	112775
23687	36520	2	applied	\N	\N	\N	\N	112776	112776	112777
23687	36521	3	applied	\N	\N	\N	\N	112778	112778	112779
23687	36522	4	applied	\N	\N	\N	\N	112780	112780	112781
23687	36523	5	applied	\N	\N	\N	\N	112782	112782	112783
23687	36524	6	applied	\N	\N	\N	\N	112784	112784	112785
23696	36538	0	applied	\N	\N	\N	\N	112815	112815	112816
23696	36539	1	applied	\N	\N	\N	\N	112817	112817	112818
23696	36540	2	applied	\N	\N	\N	\N	112819	112819	112820
23696	36541	3	applied	\N	\N	\N	\N	112821	112821	112822
23696	36542	5	applied	\N	\N	\N	\N	112824	112824	112825
23696	36543	6	applied	\N	\N	\N	\N	112826	112826	112827
23696	36544	7	applied	\N	\N	\N	\N	112828	112828	112829
23702	36563	0	applied	\N	\N	\N	\N	112887	112887	112888
23702	36564	1	applied	\N	\N	\N	\N	112889	112889	112890
23702	36565	2	applied	\N	\N	\N	\N	112891	112891	112892
23702	36566	3	applied	\N	\N	\N	\N	112893	112893	112894
23705	36567	0	applied	\N	\N	\N	\N	112896	112896	112897
23705	36568	1	applied	\N	\N	\N	\N	112898	112898	112899
23705	36569	2	applied	\N	\N	\N	\N	112901	112901	112902
23710	36576	0	applied	\N	\N	\N	\N	112922	112922	112923
23710	36577	1	applied	\N	\N	\N	\N	112924	112924	112925
23710	36578	2	applied	\N	\N	\N	\N	112926	112926	112927
23715	36590	0	applied	\N	\N	\N	\N	112957	112957	112958
23715	36591	1	applied	\N	\N	\N	\N	112959	112959	112960
23715	36592	2	applied	\N	\N	\N	\N	112965	112965	112966
23724	36603	0	applied	\N	\N	\N	\N	112993	112993	112994
23724	36604	1	applied	\N	\N	\N	\N	112995	112995	112996
23724	36605	2	applied	\N	\N	\N	\N	112997	112997	112998
23724	36606	3	applied	\N	\N	\N	\N	112999	112999	113000
23724	36607	4	applied	\N	\N	\N	\N	113001	113001	113002
23724	36608	5	applied	\N	\N	\N	\N	113003	113003	113004
23726	36617	0	applied	\N	\N	\N	\N	113028	113028	113029
23726	36618	1	applied	\N	\N	\N	\N	113030	113030	113031
23726	36619	2	applied	\N	\N	\N	\N	113032	113032	113033
23726	36620	3	applied	\N	\N	\N	\N	113034	113034	113035
23726	36621	4	applied	\N	\N	\N	\N	113036	113036	113037
23726	36622	5	applied	\N	\N	\N	\N	113038	113038	113039
23726	36623	6	applied	\N	\N	\N	\N	113040	113040	113041
23729	36634	0	applied	\N	\N	\N	\N	113068	113068	113069
23729	36635	1	applied	\N	\N	\N	\N	113070	113070	113071
23729	36636	2	applied	\N	\N	\N	\N	113072	113072	113073
23730	36637	0	applied	\N	\N	\N	\N	113075	113075	113076
23730	36638	1	applied	\N	\N	\N	\N	113077	113077	113078
23730	36639	2	applied	\N	\N	\N	\N	113079	113079	113080
23730	36640	3	applied	\N	\N	\N	\N	113081	113081	113082
23730	36641	4	applied	\N	\N	\N	\N	113083	113083	113084
23730	36642	5	applied	\N	\N	\N	\N	113085	113085	113086
23730	36643	6	applied	\N	\N	\N	\N	113087	113087	113088
23730	36644	7	applied	\N	\N	\N	\N	113089	113089	113090
23730	36645	8	applied	\N	\N	\N	\N	113091	113091	113092
23730	36646	9	applied	\N	\N	\N	\N	113093	113093	113094
23733	36449	0	applied	\N	\N	\N	\N	112573	112573	112574
23733	36450	1	applied	\N	\N	\N	\N	112575	112575	112576
23733	36451	2	applied	\N	\N	\N	\N	112577	112577	112578
23733	36452	3	applied	\N	\N	\N	\N	112579	112579	112580
23733	36327	4	applied	\N	\N	\N	\N	112229	112229	112230
23733	36302	5	applied	\N	\N	\N	\N	112143	112143	112144
23733	36328	6	applied	\N	\N	\N	\N	112231	112231	112232
23733	36329	7	applied	\N	\N	\N	\N	112233	112233	112234
23733	36330	8	applied	\N	\N	\N	\N	112235	112235	112236
23733	36331	9	applied	\N	\N	\N	\N	112237	112237	112238
23733	36332	10	applied	\N	\N	\N	\N	112239	112239	112239
23733	36305	11	applied	\N	\N	\N	\N	112152	112152	112153
23733	36308	12	applied	\N	\N	\N	\N	112159	112159	112160
23733	36312	13	applied	\N	\N	\N	\N	112169	112169	112170
23733	36313	14	applied	\N	\N	\N	\N	112171	112171	112172
23733	36318	15	applied	\N	\N	\N	\N	112192	112192	112193
23733	36319	16	applied	\N	\N	\N	\N	112194	112194	112195
23733	36325	17	applied	\N	\N	\N	\N	112208	112208	112209
23733	36333	18	applied	\N	\N	\N	\N	112240	112240	112241
23733	36334	19	applied	\N	\N	\N	\N	112242	112242	112243
23733	36341	20	applied	\N	\N	\N	\N	112258	112258	112259
23733	36344	21	applied	\N	\N	\N	\N	112267	112267	112268
23733	36347	22	applied	\N	\N	\N	\N	112292	112292	112293
23733	36350	23	applied	\N	\N	\N	\N	112300	112300	112301
23733	36351	24	applied	\N	\N	\N	\N	112302	112302	112303
23733	36352	25	applied	\N	\N	\N	\N	112304	112304	112305
23733	36360	26	applied	\N	\N	\N	\N	112324	112324	112325
23733	36361	27	applied	\N	\N	\N	\N	112326	112326	112327
23733	36366	28	applied	\N	\N	\N	\N	112339	112339	112340
23698	36547	2	applied	\N	\N	\N	\N	112842	112842	112843
23698	36548	3	applied	\N	\N	\N	\N	112844	112844	112845
23698	36549	4	applied	\N	\N	\N	\N	112846	112846	112847
23698	36550	5	applied	\N	\N	\N	\N	112848	112848	112849
23698	36551	6	applied	\N	\N	\N	\N	112850	112850	112851
23698	36552	7	applied	\N	\N	\N	\N	112852	112852	112853
23698	36553	8	applied	\N	\N	\N	\N	112854	112854	112855
23698	36554	9	applied	\N	\N	\N	\N	112856	112856	112857
23698	36555	10	applied	\N	\N	1000000000	\N	112858	112858	112859
23703	36567	0	applied	\N	\N	\N	\N	112896	112896	112897
23703	36568	1	applied	\N	\N	\N	\N	112898	112898	112899
23708	36576	0	applied	\N	\N	\N	\N	112922	112922	112923
23708	36577	1	applied	\N	\N	\N	\N	112924	112924	112925
23708	36578	2	applied	\N	\N	\N	\N	112926	112926	112927
23708	36579	3	applied	\N	\N	\N	\N	112928	112928	112929
23713	36590	0	applied	\N	\N	\N	\N	112957	112957	112958
23713	36591	1	applied	\N	\N	\N	\N	112959	112959	112960
23718	36593	0	applied	\N	\N	\N	\N	112969	112969	112970
23718	36594	1	applied	\N	\N	\N	\N	112971	112971	112972
23718	36592	2	applied	\N	\N	\N	\N	112965	112965	112966
23718	36595	3	applied	\N	\N	\N	\N	112973	112973	112974
23718	36596	4	applied	\N	\N	\N	\N	112975	112975	112976
23718	36597	5	applied	\N	\N	\N	\N	112977	112977	112978
23718	36598	6	applied	\N	\N	\N	\N	112979	112979	112980
23718	36599	7	applied	\N	\N	\N	\N	112981	112981	112982
23720	36600	0	applied	\N	\N	\N	\N	112986	112986	112987
23720	36601	1	applied	\N	\N	\N	\N	112988	112988	112989
23720	36602	2	applied	\N	\N	\N	\N	112990	112990	112991
23722	36603	0	applied	\N	\N	\N	\N	112993	112993	112994
23722	36604	1	applied	\N	\N	\N	\N	112995	112995	112996
23722	36605	2	applied	\N	\N	\N	\N	112997	112997	112998
23722	36606	3	applied	\N	\N	\N	\N	112999	112999	113000
23722	36607	4	applied	\N	\N	\N	\N	113001	113001	113002
23722	36608	5	applied	\N	\N	\N	\N	113003	113003	113004
23728	36627	0	applied	\N	\N	\N	\N	113052	113052	113053
23728	36628	1	applied	\N	\N	\N	\N	113054	113054	113055
23728	36629	2	applied	\N	\N	\N	\N	113056	113056	113057
23728	36630	3	applied	\N	\N	\N	\N	113058	113058	113059
23728	36631	4	applied	\N	\N	\N	\N	113060	113060	113061
23728	36632	5	applied	\N	\N	\N	\N	113062	113062	113063
23728	36633	6	applied	\N	\N	\N	\N	113064	113064	113065
23734	36658	0	applied	\N	\N	\N	\N	113156	113156	113157
23734	36659	1	applied	\N	\N	\N	\N	113158	113158	113159
23734	36660	2	applied	\N	\N	\N	\N	113160	113160	113161
23734	36661	3	applied	\N	\N	\N	\N	113162	113162	113163
23734	36662	4	applied	\N	\N	\N	\N	113164	113164	113165
23737	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23737	36661	1	applied	\N	\N	\N	\N	113162	113162	113163
23737	36664	2	applied	\N	\N	\N	\N	113173	113173	113174
23737	36665	3	applied	\N	\N	\N	\N	113175	113175	113176
23737	36662	4	applied	\N	\N	\N	\N	113164	113164	113177
23737	36666	5	applied	\N	\N	\N	\N	113178	113178	113179
23741	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23741	36664	1	applied	\N	\N	\N	\N	113173	113173	113184
23741	36666	2	applied	\N	\N	\N	\N	113178	113178	113185
23741	36665	3	applied	\N	\N	\N	\N	113175	113175	113179
23748	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23748	36647	1	applied	\N	\N	\N	\N	113097	113097	113098
23748	36648	2	applied	\N	\N	\N	\N	113099	113099	113100
23748	36654	3	applied	\N	\N	\N	\N	113111	113111	113112
23748	36658	4	applied	\N	\N	\N	\N	113156	113156	113157
23748	36663	5	applied	\N	\N	\N	\N	113171	113171	113172
23748	36667	6	applied	\N	\N	\N	\N	113191	113191	113192
23748	36669	7	applied	\N	\N	\N	\N	113197	113197	113198
23748	36672	8	applied	\N	\N	\N	\N	113205	113205	113206
23748	36673	9	applied	\N	\N	\N	\N	113207	113207	113208
23748	36674	10	applied	\N	\N	\N	\N	113209	113209	113210
23748	36675	11	applied	\N	\N	\N	\N	113211	113211	113212
23748	36676	12	applied	\N	\N	\N	\N	113213	113213	113214
23748	36677	13	applied	\N	\N	\N	\N	113215	113215	113216
23748	36678	14	applied	\N	\N	\N	\N	113217	113217	113218
23748	36695	15	applied	\N	\N	\N	\N	113253	113253	113254
23748	36696	16	applied	\N	\N	\N	\N	113255	113255	113256
23748	36655	17	applied	\N	\N	\N	\N	113113	113113	113268
23748	36649	18	applied	\N	\N	\N	\N	113101	113101	113269
23748	36650	19	applied	\N	\N	\N	\N	113103	113103	113270
23748	36651	20	applied	\N	\N	\N	\N	113105	113105	113271
23748	36656	21	applied	\N	\N	\N	\N	113115	113115	113108
23748	36659	22	applied	\N	\N	\N	\N	113158	113158	113272
23748	36652	23	applied	\N	\N	\N	\N	113107	113107	113273
23748	36665	24	applied	\N	\N	\N	\N	113175	113175	113118
23748	36681	25	applied	\N	\N	\N	\N	113223	113223	113274
23748	36687	26	applied	\N	\N	\N	\N	113235	113235	113159
23748	36700	27	applied	\N	\N	\N	\N	113263	113263	113275
23748	36662	28	applied	\N	\N	\N	\N	113164	113164	113161
23748	36666	29	applied	\N	\N	\N	\N	113178	113178	113276
23748	36668	30	applied	\N	\N	\N	\N	113193	113193	113277
23748	36657	31	applied	\N	\N	\N	\N	113117	113117	113176
23748	36660	32	applied	\N	\N	\N	\N	113160	113160	113185
23748	36661	33	applied	\N	\N	\N	\N	113162	113162	113194
23748	36664	34	applied	\N	\N	\N	\N	113173	113173	113200
23748	36670	35	applied	\N	\N	\N	\N	113199	113199	113278
23748	36682	36	applied	\N	\N	\N	\N	113225	113225	113222
23748	36683	37	applied	\N	\N	\N	\N	113227	113227	113279
23748	36684	38	applied	\N	\N	\N	\N	113229	113229	113280
23748	36685	39	applied	\N	\N	\N	\N	113231	113231	113281
23748	36686	40	applied	\N	\N	\N	\N	113233	113233	113282
23748	36693	41	applied	\N	\N	\N	\N	113247	113247	113283
23748	36694	42	applied	\N	\N	\N	\N	113249	113249	113284
23748	36698	43	applied	\N	\N	\N	\N	113259	113259	113240
23748	36671	44	applied	\N	\N	\N	\N	113201	113201	113242
23748	36679	45	applied	\N	\N	\N	\N	113219	113219	113244
23748	36680	46	applied	\N	\N	\N	\N	113221	113221	113246
23748	36688	47	applied	\N	\N	\N	\N	113237	113237	113285
23748	36689	48	applied	\N	\N	\N	\N	113239	113239	113286
23748	36690	49	applied	\N	\N	\N	\N	113241	113241	113250
23748	36691	50	applied	\N	\N	\N	\N	113243	113243	113258
23748	36692	51	applied	\N	\N	\N	\N	113245	113245	113287
23748	36697	52	applied	\N	\N	\N	\N	113257	113257	113288
23748	36699	53	applied	\N	\N	\N	\N	113261	113261	113264
23748	36701	54	applied	\N	\N	\N	\N	113265	113265	113266
23751	36702	0	applied	\N	\N	\N	\N	113290	113290	113291
23751	36703	1	applied	\N	\N	\N	\N	113292	113292	113293
23751	36704	2	applied	\N	\N	\N	\N	113294	113294	113295
23754	36705	0	applied	\N	\N	\N	\N	113304	113304	113305
23754	36706	1	applied	\N	\N	\N	\N	113306	113306	113307
23754	36707	2	applied	\N	\N	\N	\N	113308	113308	113309
23759	36658	0	applied	\N	\N	\N	\N	113156	113156	113316
23759	36663	1	applied	\N	\N	\N	\N	113171	113171	113317
23706	36571	1	applied	\N	\N	\N	\N	112908	112908	112909
23706	36572	2	applied	\N	\N	\N	\N	112910	112910	112911
23709	36576	0	applied	\N	\N	\N	\N	112922	112922	112923
23709	36577	1	applied	\N	\N	\N	\N	112924	112924	112925
23709	36578	2	applied	\N	\N	\N	\N	112926	112926	112927
23709	36579	3	applied	\N	\N	\N	\N	112928	112928	112929
23711	36580	0	applied	\N	\N	\N	\N	112934	112934	112935
23711	36581	1	applied	\N	\N	\N	\N	112936	112936	112937
23711	36582	2	applied	\N	\N	\N	\N	112938	112938	112939
23711	36583	3	applied	\N	\N	\N	\N	112940	112940	112941
23711	36584	4	applied	\N	\N	\N	\N	112942	112942	112943
23711	36585	5	applied	\N	\N	\N	\N	112944	112944	112945
23714	36590	0	applied	\N	\N	\N	\N	112957	112957	112958
23714	36591	1	applied	\N	\N	\N	\N	112959	112959	112960
23723	36603	0	applied	\N	\N	\N	\N	112993	112993	112994
23723	36604	1	applied	\N	\N	\N	\N	112995	112995	112996
23723	36605	2	applied	\N	\N	\N	\N	112997	112997	112998
23723	36606	3	applied	\N	\N	\N	\N	112999	112999	113000
23723	36607	4	applied	\N	\N	\N	\N	113001	113001	113002
23723	36608	5	applied	\N	\N	\N	\N	113003	113003	113004
23725	36609	0	applied	\N	\N	\N	\N	113010	113010	113011
23725	36610	1	applied	\N	\N	\N	\N	113012	113012	113013
23725	36611	2	applied	\N	\N	\N	\N	113014	113014	113015
23725	36612	3	applied	\N	\N	\N	\N	113016	113016	113017
23725	36613	4	applied	\N	\N	\N	\N	113018	113018	113019
23725	36614	5	applied	\N	\N	\N	\N	113020	113020	113021
23725	36615	6	applied	\N	\N	\N	\N	113022	113022	113023
23725	36616	7	applied	\N	\N	\N	\N	113024	113024	113025
23732	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23732	36654	1	applied	\N	\N	\N	\N	113111	113111	113112
23732	36655	2	applied	\N	\N	\N	\N	113113	113113	113114
23732	36656	3	applied	\N	\N	\N	\N	113115	113115	113116
23732	36657	4	applied	\N	\N	\N	\N	113117	113117	113118
23735	36658	0	applied	\N	\N	\N	\N	113156	113156	113157
23735	36659	1	applied	\N	\N	\N	\N	113158	113158	113159
23735	36660	2	applied	\N	\N	\N	\N	113160	113160	113161
23735	36661	3	applied	\N	\N	\N	\N	113162	113162	113163
23735	36662	4	applied	\N	\N	\N	\N	113164	113164	113165
23738	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23738	36661	1	applied	\N	\N	\N	\N	113162	113162	113163
23738	36664	2	applied	\N	\N	\N	\N	113173	113173	113174
23738	36665	3	applied	\N	\N	\N	\N	113175	113175	113176
23738	36662	4	applied	\N	\N	\N	\N	113164	113164	113177
23738	36666	5	applied	\N	\N	\N	\N	113178	113178	113179
23744	36669	0	applied	\N	\N	\N	\N	113197	113197	113198
23744	36670	1	applied	\N	\N	\N	\N	113199	113199	113200
23744	36671	2	applied	\N	\N	\N	\N	113201	113201	113202
23752	36702	0	applied	\N	\N	\N	\N	113290	113290	113291
23752	36703	1	applied	\N	\N	\N	\N	113292	113292	113293
23752	36704	2	applied	\N	\N	\N	\N	113294	113294	113295
23755	36705	0	applied	\N	\N	\N	\N	113304	113304	113305
23755	36706	1	applied	\N	\N	\N	\N	113306	113306	113307
23755	36707	2	applied	\N	\N	\N	\N	113308	113308	113309
23760	36712	0	applied	\N	\N	\N	\N	113408	113408	113409
23760	36713	1	applied	\N	\N	\N	\N	113410	113410	113411
23760	36714	2	applied	\N	\N	\N	\N	113412	113412	113413
23760	36715	3	applied	\N	\N	\N	\N	113414	113414	113415
23760	36716	4	applied	\N	\N	\N	\N	113416	113416	113417
23760	36717	5	applied	\N	\N	\N	\N	113418	113418	113419
23765	36718	0	applied	\N	\N	\N	\N	113446	113446	113447
23765	36719	1	applied	\N	\N	\N	\N	113448	113448	113449
23765	36720	2	applied	\N	\N	\N	\N	113450	113450	113451
23765	36721	3	applied	\N	\N	\N	\N	113452	113452	113453
23765	36722	4	applied	\N	\N	\N	\N	113454	113454	113455
23765	36723	5	applied	\N	\N	\N	\N	113456	113456	113457
23765	36724	6	applied	\N	\N	\N	\N	113458	113458	113459
23767	36728	0	applied	\N	\N	\N	\N	113472	113472	113473
23767	36729	2	applied	\N	\N	\N	\N	113475	113475	113476
23767	36730	3	applied	\N	\N	\N	\N	113477	113477	113478
23767	36731	4	applied	\N	\N	\N	\N	113479	113479	113480
23770	36733	0	applied	\N	\N	\N	\N	113485	113485	113486
23770	36734	1	applied	\N	\N	\N	\N	113487	113487	113488
23772	36732	0	applied	\N	\N	\N	\N	113483	113483	113484
23772	36735	1	applied	\N	\N	\N	\N	113493	113493	113494
23772	36736	2	applied	\N	\N	\N	\N	113495	113495	113496
23772	36737	3	applied	\N	\N	\N	\N	113497	113497	113498
23774	36745	0	applied	\N	\N	\N	\N	113521	113521	113522
23774	36746	1	applied	\N	\N	\N	\N	113523	113523	113524
23774	36747	2	applied	\N	\N	\N	\N	113525	113525	113526
23776	36745	0	applied	\N	\N	\N	\N	113521	113521	113522
23776	36746	1	applied	\N	\N	\N	\N	113523	113523	113524
23776	36747	2	applied	\N	\N	\N	\N	113525	113525	113526
23781	36755	0	applied	\N	\N	\N	\N	113549	113549	113550
23781	36756	1	applied	\N	\N	\N	\N	113551	113551	113552
23787	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23787	36761	1	applied	\N	\N	\N	\N	113566	113566	113567
23787	36762	2	applied	\N	\N	\N	\N	113568	113568	113569
23787	36764	3	applied	\N	\N	\N	\N	113574	113574	113575
23790	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23790	36765	1	applied	\N	\N	\N	\N	113583	113583	113584
23790	36766	2	applied	\N	\N	\N	\N	113585	113585	113586
23790	36764	3	applied	\N	\N	\N	\N	113574	113574	113587
23790	36767	4	applied	\N	\N	\N	\N	113588	113588	113589
23793	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23793	36769	1	applied	\N	\N	\N	\N	113596	113596	113597
23793	36770	2	applied	\N	\N	\N	\N	113598	113598	113599
23796	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23796	36771	1	applied	\N	\N	\N	\N	113605	113605	113606
23796	36772	2	applied	\N	\N	\N	\N	113607	113607	113608
23796	36773	3	applied	\N	\N	\N	\N	113609	113609	113610
23803	36781	0	applied	\N	\N	\N	\N	113639	113639	113640
23803	36782	1	applied	\N	\N	\N	\N	113641	113641	113642
23803	36783	2	applied	\N	\N	\N	\N	113643	113643	113644
23805	36784	0	applied	\N	\N	\N	\N	113648	113648	113649
23805	36785	1	applied	\N	\N	\N	\N	113650	113650	113651
23805	36786	2	applied	\N	\N	\N	\N	113652	113652	113653
23805	36787	3	applied	\N	\N	\N	\N	113654	113654	113655
23811	36799	0	applied	\N	\N	\N	\N	113682	113682	113683
23811	36800	1	applied	\N	\N	\N	\N	113684	113684	113685
23811	36801	2	applied	\N	\N	\N	\N	113686	113686	113687
23813	36802	0	applied	\N	\N	\N	\N	113693	113693	113694
23813	36803	1	applied	\N	\N	\N	\N	113695	113695	113696
23813	36804	2	applied	\N	\N	\N	\N	113697	113697	113698
23820	36818	0	applied	\N	\N	\N	\N	113732	113732	113733
23820	36819	1	applied	\N	\N	\N	\N	113734	113734	113735
23820	36820	2	applied	\N	\N	\N	\N	113736	113736	113737
23820	36821	3	applied	\N	\N	\N	\N	113738	113738	113739
23820	36822	4	applied	\N	\N	\N	\N	113740	113740	113741
23820	36823	5	applied	\N	\N	\N	\N	113742	113742	113743
23716	36591	1	applied	\N	\N	\N	\N	112959	112959	112960
23716	36592	2	applied	\N	\N	\N	\N	112965	112965	112966
23717	36593	0	applied	\N	\N	\N	\N	112969	112969	112970
23717	36594	1	applied	\N	\N	\N	\N	112971	112971	112972
23717	36592	2	applied	\N	\N	\N	\N	112965	112965	112966
23717	36595	3	applied	\N	\N	\N	\N	112973	112973	112974
23717	36596	4	applied	\N	\N	\N	\N	112975	112975	112976
23717	36597	5	applied	\N	\N	\N	\N	112977	112977	112978
23717	36598	6	applied	\N	\N	\N	\N	112979	112979	112980
23717	36599	7	applied	\N	\N	\N	\N	112981	112981	112982
23719	36600	0	applied	\N	\N	\N	\N	112986	112986	112987
23719	36601	1	applied	\N	\N	\N	\N	112988	112988	112989
23719	36602	2	applied	\N	\N	\N	\N	112990	112990	112991
23727	36624	0	applied	\N	\N	\N	\N	113044	113044	113045
23727	36625	1	applied	\N	\N	\N	\N	113046	113046	113047
23727	36626	2	applied	\N	\N	\N	\N	113048	113048	113049
23731	36647	0	applied	\N	\N	\N	\N	113097	113097	113098
23731	36648	1	applied	\N	\N	\N	\N	113099	113099	113100
23731	36649	2	applied	\N	\N	\N	\N	113101	113101	113102
23731	36650	3	applied	\N	\N	\N	\N	113103	113103	113104
23731	36651	4	applied	\N	\N	\N	\N	113105	113105	113106
23731	36652	5	applied	\N	\N	\N	\N	113107	113107	113108
23736	36658	0	applied	\N	\N	\N	\N	113156	113156	113157
23736	36659	1	applied	\N	\N	\N	\N	113158	113158	113159
23736	36660	2	applied	\N	\N	\N	\N	113160	113160	113161
23740	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23740	36664	1	applied	\N	\N	\N	\N	113173	113173	113184
23740	36666	2	applied	\N	\N	\N	\N	113178	113178	113185
23740	36665	3	applied	\N	\N	\N	\N	113175	113175	113179
23743	36667	0	applied	\N	\N	\N	\N	113191	113191	113192
23743	36668	1	applied	\N	\N	\N	\N	113193	113193	113194
23747	36695	0	applied	\N	\N	\N	\N	113253	113253	113254
23747	36696	1	applied	\N	\N	\N	\N	113255	113255	113256
23747	36697	2	applied	\N	\N	\N	\N	113257	113257	113258
23747	36698	3	applied	\N	\N	\N	\N	113259	113259	113260
23747	36699	4	applied	\N	\N	\N	\N	113261	113261	113262
23747	36700	5	applied	\N	\N	\N	\N	113263	113263	113264
23747	36701	6	applied	\N	\N	\N	\N	113265	113265	113266
23750	36703	0	applied	\N	\N	\N	\N	113292	113292	113293
23762	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23762	36469	1	applied	\N	\N	\N	\N	112633	112633	112634
23762	36472	2	applied	\N	\N	\N	\N	112646	112646	112647
23762	36476	3	applied	\N	\N	\N	\N	112660	112660	112661
23762	36478	4	applied	\N	\N	\N	\N	112667	112667	112668
23762	36481	5	applied	\N	\N	\N	\N	112674	112674	112675
23762	36482	6	applied	\N	\N	\N	\N	112676	112676	112677
23762	36488	7	applied	\N	\N	\N	\N	112695	112695	112696
23762	36491	8	applied	\N	\N	\N	\N	112706	112706	112707
23762	36495	9	applied	\N	\N	\N	\N	112718	112718	112719
23762	36496	10	applied	\N	\N	\N	\N	112720	112720	112721
23762	36503	11	applied	\N	\N	\N	\N	112738	112738	112739
23762	36504	12	applied	\N	\N	\N	\N	112740	112740	112741
23762	36512	13	applied	\N	\N	\N	\N	112758	112758	112759
23762	36515	14	applied	\N	\N	\N	\N	112764	112764	112765
23762	36518	15	applied	\N	\N	\N	\N	112772	112772	112773
23762	36519	16	applied	\N	\N	\N	\N	112774	112774	112775
23762	36525	17	applied	\N	\N	\N	\N	112786	112786	112787
23762	36528	18	applied	\N	\N	\N	\N	112792	112792	112793
23762	36532	19	applied	\N	\N	\N	\N	112800	112800	112801
23762	36535	20	applied	\N	\N	\N	\N	112807	112807	112808
23762	36538	21	applied	\N	\N	\N	\N	112815	112815	112816
23762	36539	22	applied	\N	\N	\N	\N	112817	112817	112818
23762	36545	23	applied	\N	\N	\N	\N	112838	112838	113120
23762	36546	24	applied	\N	\N	\N	\N	112840	112840	113122
23762	36547	25	applied	\N	\N	\N	\N	112842	112842	113123
23762	36556	26	applied	\N	\N	\N	\N	112869	112869	113124
23762	36557	27	applied	\N	\N	\N	\N	112871	112871	113125
23762	36563	28	applied	\N	\N	\N	\N	112887	112887	113126
23762	36567	29	applied	\N	\N	\N	\N	112896	112896	113127
23762	36570	30	applied	\N	\N	\N	\N	112906	112906	113128
23762	36573	31	applied	\N	\N	\N	\N	112914	112914	113129
23762	36576	32	applied	\N	\N	\N	\N	112922	112922	113130
23762	36580	33	applied	\N	\N	\N	\N	112934	112934	113131
23762	36581	34	applied	\N	\N	\N	\N	112936	112936	113132
23762	36586	35	applied	\N	\N	\N	\N	112947	112947	113133
23762	36590	36	applied	\N	\N	\N	\N	112957	112957	113134
23762	36593	37	applied	\N	\N	\N	\N	112969	112969	113135
23762	36594	38	applied	\N	\N	\N	\N	112971	112971	113136
23762	36600	39	applied	\N	\N	\N	\N	112986	112986	113137
23762	36603	40	applied	\N	\N	\N	\N	112993	112993	113138
23762	36604	41	applied	\N	\N	\N	\N	112995	112995	113139
23762	36609	42	applied	\N	\N	\N	\N	113010	113010	113140
23762	36610	43	applied	\N	\N	\N	\N	113012	113012	113141
23762	36617	44	applied	\N	\N	\N	\N	113028	113028	113142
23762	36618	45	applied	\N	\N	\N	\N	113030	113030	113143
23762	36624	46	applied	\N	\N	\N	\N	113044	113044	113144
23762	36627	47	applied	\N	\N	\N	\N	113052	113052	113145
23762	36628	48	applied	\N	\N	\N	\N	113054	113054	113146
23762	36634	49	applied	\N	\N	\N	\N	113068	113068	113147
23762	36637	50	applied	\N	\N	\N	\N	113075	113075	113148
23762	36638	51	applied	\N	\N	\N	\N	113077	113077	113149
23762	36639	52	applied	\N	\N	\N	\N	113079	113079	113150
23762	36647	53	applied	\N	\N	\N	\N	113097	113097	113151
23762	36648	54	applied	\N	\N	\N	\N	113099	113099	113152
23762	36654	55	applied	\N	\N	\N	\N	113111	113111	113153
23762	36658	56	applied	\N	\N	\N	\N	113156	113156	113316
23762	36663	57	applied	\N	\N	\N	\N	113171	113171	113317
23762	36667	58	applied	\N	\N	\N	\N	113191	113191	113318
23762	36669	59	applied	\N	\N	\N	\N	113197	113197	113319
23762	36672	60	applied	\N	\N	\N	\N	113205	113205	113320
23762	36673	61	applied	\N	\N	\N	\N	113207	113207	113321
23762	36674	62	applied	\N	\N	\N	\N	113209	113209	113322
23762	36675	63	applied	\N	\N	\N	\N	113211	113211	113323
23762	36676	64	applied	\N	\N	\N	\N	113213	113213	113324
23762	36677	65	applied	\N	\N	\N	\N	113215	113215	113325
23762	36678	66	applied	\N	\N	\N	\N	113217	113217	113326
23762	36695	67	applied	\N	\N	\N	\N	113253	113253	113327
23762	36696	68	applied	\N	\N	\N	\N	113255	113255	113328
23762	36702	69	applied	\N	\N	\N	\N	113290	113290	113329
23762	36705	70	applied	\N	\N	\N	\N	113304	113304	113330
23762	36708	71	applied	\N	\N	\N	\N	113348	113348	113422
23762	36712	72	applied	\N	\N	\N	\N	113408	113408	113423
23762	36713	73	applied	\N	\N	\N	\N	113410	113410	113424
23762	36497	74	applied	\N	\N	\N	\N	112722	112722	112723
23762	36498	75	applied	\N	\N	\N	\N	112724	112724	112725
23762	36505	76	applied	\N	\N	\N	\N	112742	112742	112743
23762	36473	77	applied	\N	\N	\N	\N	112648	112648	113396
23762	36485	78	applied	\N	\N	\N	\N	112682	112682	112636
23762	36508	79	applied	\N	\N	\N	\N	112748	112748	112749
23733	36369	29	applied	\N	\N	\N	\N	112345	112345	112346
23733	36373	30	applied	\N	\N	\N	\N	112356	112356	112357
23733	36374	31	applied	\N	\N	\N	\N	112358	112358	112359
23733	36375	32	applied	\N	\N	\N	\N	112360	112360	112361
23733	36384	33	applied	\N	\N	\N	\N	112383	112383	112384
23733	36385	34	applied	\N	\N	\N	\N	112385	112385	112386
23733	36390	35	applied	\N	\N	\N	\N	112418	112418	112419
23733	36391	36	applied	\N	\N	\N	\N	112420	112420	112421
23733	36397	37	applied	\N	\N	\N	\N	112434	112434	112435
23733	36400	38	applied	\N	\N	\N	\N	112444	112444	112445
23733	36401	39	applied	\N	\N	\N	\N	112446	112446	112447
23733	36407	40	applied	\N	\N	\N	\N	112459	112459	112460
23733	36410	41	applied	\N	\N	\N	\N	112469	112469	112470
23733	36413	42	applied	\N	\N	\N	\N	112478	112478	112479
23733	36414	43	applied	\N	\N	\N	\N	112480	112480	112481
23733	36420	44	applied	\N	\N	\N	\N	112496	112496	112497
23733	36421	45	applied	\N	\N	\N	\N	112498	112498	112499
23733	36429	46	applied	\N	\N	\N	\N	112519	112519	112520
23733	36432	47	applied	\N	\N	\N	\N	112529	112529	112530
23733	36433	48	applied	\N	\N	\N	\N	112531	112531	112532
23733	36439	49	applied	\N	\N	\N	\N	112546	112546	112547
23733	36442	50	applied	\N	\N	\N	\N	112554	112554	112555
23733	36445	51	applied	\N	\N	\N	\N	112562	112562	112563
23733	36453	52	applied	\N	\N	\N	\N	112582	112582	112583
23733	36456	53	applied	\N	\N	\N	\N	112591	112591	112592
23733	36459	54	applied	\N	\N	\N	\N	112610	112610	112611
23733	36460	55	applied	\N	\N	\N	\N	112612	112612	112613
23733	36461	56	applied	\N	\N	\N	\N	112614	112614	112615
23733	36469	57	applied	\N	\N	\N	\N	112633	112633	112634
23733	36472	58	applied	\N	\N	\N	\N	112646	112646	112647
23733	36476	59	applied	\N	\N	\N	\N	112660	112660	112661
23733	36478	60	applied	\N	\N	\N	\N	112667	112667	112668
23733	36481	61	applied	\N	\N	\N	\N	112674	112674	112675
23733	36482	62	applied	\N	\N	\N	\N	112676	112676	112677
23733	36488	63	applied	\N	\N	\N	\N	112695	112695	112696
23733	36491	64	applied	\N	\N	\N	\N	112706	112706	112707
23733	36495	65	applied	\N	\N	\N	\N	112718	112718	112719
23733	36496	66	applied	\N	\N	\N	\N	112720	112720	112721
23733	36503	67	applied	\N	\N	\N	\N	112738	112738	112739
23733	36504	68	applied	\N	\N	\N	\N	112740	112740	112741
23733	36512	69	applied	\N	\N	\N	\N	112758	112758	112759
23733	36515	70	applied	\N	\N	\N	\N	112764	112764	112765
23733	36518	71	applied	\N	\N	\N	\N	112772	112772	112773
23733	36519	72	applied	\N	\N	\N	\N	112774	112774	112775
23733	36525	73	applied	\N	\N	\N	\N	112786	112786	112787
23733	36528	74	applied	\N	\N	\N	\N	112792	112792	112793
23733	36532	75	applied	\N	\N	\N	\N	112800	112800	112801
23733	36535	76	applied	\N	\N	\N	\N	112807	112807	112808
23733	36538	77	applied	\N	\N	\N	\N	112815	112815	112816
23733	36539	78	applied	\N	\N	\N	\N	112817	112817	112818
23733	36545	79	applied	\N	\N	\N	\N	112838	112838	113120
23733	36546	81	applied	\N	\N	\N	\N	112840	112840	113122
23733	36547	82	applied	\N	\N	\N	\N	112842	112842	113123
23733	36556	83	applied	\N	\N	\N	\N	112869	112869	113124
23733	36557	84	applied	\N	\N	\N	\N	112871	112871	113125
23733	36563	85	applied	\N	\N	\N	\N	112887	112887	113126
23733	36567	86	applied	\N	\N	\N	\N	112896	112896	113127
23733	36570	87	applied	\N	\N	\N	\N	112906	112906	113128
23733	36573	88	applied	\N	\N	\N	\N	112914	112914	113129
23733	36576	89	applied	\N	\N	\N	\N	112922	112922	113130
23733	36580	90	applied	\N	\N	\N	\N	112934	112934	113131
23733	36581	91	applied	\N	\N	\N	\N	112936	112936	113132
23733	36586	92	applied	\N	\N	\N	\N	112947	112947	113133
23733	36590	93	applied	\N	\N	\N	\N	112957	112957	113134
23733	36593	94	applied	\N	\N	\N	\N	112969	112969	113135
23733	36594	95	applied	\N	\N	\N	\N	112971	112971	113136
23733	36600	96	applied	\N	\N	\N	\N	112986	112986	113137
23733	36603	97	applied	\N	\N	\N	\N	112993	112993	113138
23733	36604	98	applied	\N	\N	\N	\N	112995	112995	113139
23733	36609	99	applied	\N	\N	\N	\N	113010	113010	113140
23733	36610	100	applied	\N	\N	\N	\N	113012	113012	113141
23733	36617	101	applied	\N	\N	\N	\N	113028	113028	113142
23733	36618	102	applied	\N	\N	\N	\N	113030	113030	113143
23733	36624	103	applied	\N	\N	\N	\N	113044	113044	113144
23733	36627	104	applied	\N	\N	\N	\N	113052	113052	113145
23733	36628	105	applied	\N	\N	\N	\N	113054	113054	113146
23733	36634	106	applied	\N	\N	\N	\N	113068	113068	113147
23733	36637	107	applied	\N	\N	\N	\N	113075	113075	113148
23733	36638	108	applied	\N	\N	\N	\N	113077	113077	113149
23733	36639	109	applied	\N	\N	\N	\N	113079	113079	113150
23733	36647	110	applied	\N	\N	\N	\N	113097	113097	113151
23733	36648	111	applied	\N	\N	\N	\N	113099	113099	113152
23733	36654	112	applied	\N	\N	\N	\N	113111	113111	113153
23733	36376	113	failed	Amount_insufficient_to_create_account	\N	\N	\N	112362	112362	\N
23733	36653	114	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23733	36497	115	applied	\N	\N	\N	\N	112722	112722	112723
23733	36498	116	applied	\N	\N	\N	\N	112724	112724	112725
23733	36505	117	applied	\N	\N	\N	\N	112742	112742	112743
23733	36303	118	applied	\N	\N	\N	\N	112145	112145	112146
23733	36304	119	applied	\N	\N	\N	\N	112147	112147	112148
23733	36306	120	applied	\N	\N	\N	\N	112154	112154	112155
23733	36309	121	applied	\N	\N	\N	\N	112161	112161	112187
23733	36320	122	applied	\N	\N	\N	\N	112196	112196	112218
23733	36337	123	applied	\N	\N	\N	\N	112248	112248	112157
23733	36349	124	applied	\N	\N	\N	\N	112296	112296	112162
23733	36508	125	applied	\N	\N	\N	\N	112748	112748	112749
23739	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23739	36664	1	applied	\N	\N	\N	\N	113173	113173	113184
23739	36666	2	applied	\N	\N	\N	\N	113178	113178	113185
23739	36665	3	applied	\N	\N	\N	\N	113175	113175	113179
23742	36663	0	applied	\N	\N	\N	\N	113171	113171	113172
23742	36666	1	applied	\N	\N	\N	\N	113178	113178	113176
23746	36672	0	applied	\N	\N	\N	\N	113205	113205	113206
23746	36673	1	applied	\N	\N	\N	\N	113207	113207	113208
23746	36674	2	applied	\N	\N	\N	\N	113209	113209	113210
23746	36675	3	applied	\N	\N	\N	\N	113211	113211	113212
23746	36676	4	applied	\N	\N	\N	\N	113213	113213	113214
23746	36677	5	applied	\N	\N	\N	\N	113215	113215	113216
23746	36678	6	applied	\N	\N	\N	\N	113217	113217	113218
23746	36679	7	applied	\N	\N	\N	\N	113219	113219	113220
23746	36680	8	applied	\N	\N	\N	\N	113221	113221	113222
23746	36681	9	applied	\N	\N	\N	\N	113223	113223	113224
23746	36682	10	applied	\N	\N	\N	\N	113225	113225	113226
23746	36683	11	applied	\N	\N	\N	\N	113227	113227	113228
23746	36684	12	applied	\N	\N	\N	\N	113229	113229	113230
23746	36685	13	applied	\N	\N	\N	\N	113231	113231	113232
23746	36686	14	applied	\N	\N	\N	\N	113233	113233	113234
23746	36687	15	applied	\N	\N	\N	\N	113235	113235	113236
23746	36688	16	applied	\N	\N	\N	\N	113237	113237	113238
23746	36689	17	applied	\N	\N	\N	\N	113239	113239	113240
23746	36690	18	applied	\N	\N	\N	\N	113241	113241	113242
23746	36691	19	applied	\N	\N	\N	\N	113243	113243	113244
23746	36692	20	applied	\N	\N	\N	\N	113245	113245	113246
23746	36693	21	applied	\N	\N	\N	\N	113247	113247	113248
23746	36694	22	applied	\N	\N	\N	\N	113249	113249	113250
23749	36702	0	applied	\N	\N	\N	\N	113290	113290	113291
23749	36703	1	applied	\N	\N	\N	\N	113292	113292	113293
23749	36704	2	applied	\N	\N	\N	\N	113294	113294	113295
23753	36702	0	applied	\N	\N	\N	\N	113290	113290	113291
23753	36703	1	applied	\N	\N	\N	\N	113292	113292	113293
23753	36704	2	applied	\N	\N	\N	\N	113294	113294	113295
23756	36705	0	applied	\N	\N	\N	\N	113304	113304	113305
23756	36706	1	applied	\N	\N	\N	\N	113306	113306	113307
23756	36707	2	applied	\N	\N	\N	\N	113308	113308	113309
23757	36449	0	applied	\N	\N	\N	\N	112573	112573	112574
23757	36450	1	applied	\N	\N	\N	\N	112575	112575	112576
23757	36451	2	applied	\N	\N	\N	\N	112577	112577	112578
23757	36452	3	applied	\N	\N	\N	\N	112579	112579	112580
23757	36653	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23757	36410	5	applied	\N	\N	\N	\N	112469	112469	112470
23757	36413	6	applied	\N	\N	\N	\N	112478	112478	112479
23757	36414	7	applied	\N	\N	\N	\N	112480	112480	112481
23757	36420	8	applied	\N	\N	\N	\N	112496	112496	112497
23757	36421	9	applied	\N	\N	\N	\N	112498	112498	112499
23757	36429	10	applied	\N	\N	\N	\N	112519	112519	112520
23757	36432	11	applied	\N	\N	\N	\N	112529	112529	112530
23757	36433	12	applied	\N	\N	\N	\N	112531	112531	112532
23757	36439	13	applied	\N	\N	\N	\N	112546	112546	112547
23757	36442	14	applied	\N	\N	\N	\N	112554	112554	112555
23757	36445	15	applied	\N	\N	\N	\N	112562	112562	112563
23757	36453	16	applied	\N	\N	\N	\N	112582	112582	112583
23757	36456	17	applied	\N	\N	\N	\N	112591	112591	112592
23757	36459	18	applied	\N	\N	\N	\N	112610	112610	112611
23757	36460	19	applied	\N	\N	\N	\N	112612	112612	112613
23757	36461	20	applied	\N	\N	\N	\N	112614	112614	112615
23757	36469	21	applied	\N	\N	\N	\N	112633	112633	112634
23757	36472	22	applied	\N	\N	\N	\N	112646	112646	112647
23757	36476	23	applied	\N	\N	\N	\N	112660	112660	112661
23757	36478	24	applied	\N	\N	\N	\N	112667	112667	112668
23757	36481	25	applied	\N	\N	\N	\N	112674	112674	112675
23757	36482	26	applied	\N	\N	\N	\N	112676	112676	112677
23757	36488	27	applied	\N	\N	\N	\N	112695	112695	112696
23757	36491	28	applied	\N	\N	\N	\N	112706	112706	112707
23757	36495	29	applied	\N	\N	\N	\N	112718	112718	112719
23757	36496	30	applied	\N	\N	\N	\N	112720	112720	112721
23757	36503	31	applied	\N	\N	\N	\N	112738	112738	112739
23757	36504	32	applied	\N	\N	\N	\N	112740	112740	112741
23757	36512	33	applied	\N	\N	\N	\N	112758	112758	112759
23757	36515	34	applied	\N	\N	\N	\N	112764	112764	112765
23757	36518	35	applied	\N	\N	\N	\N	112772	112772	112773
23757	36519	36	applied	\N	\N	\N	\N	112774	112774	112775
23757	36525	37	applied	\N	\N	\N	\N	112786	112786	112787
23757	36528	38	applied	\N	\N	\N	\N	112792	112792	112793
23757	36532	39	applied	\N	\N	\N	\N	112800	112800	112801
23757	36535	40	applied	\N	\N	\N	\N	112807	112807	112808
23757	36538	41	applied	\N	\N	\N	\N	112815	112815	112816
23757	36539	42	applied	\N	\N	\N	\N	112817	112817	112818
23757	36545	43	applied	\N	\N	\N	\N	112838	112838	113120
23757	36546	44	applied	\N	\N	\N	\N	112840	112840	113122
23757	36547	45	applied	\N	\N	\N	\N	112842	112842	113123
23757	36556	46	applied	\N	\N	\N	\N	112869	112869	113124
23757	36557	47	applied	\N	\N	\N	\N	112871	112871	113125
23757	36563	48	applied	\N	\N	\N	\N	112887	112887	113126
23757	36567	49	applied	\N	\N	\N	\N	112896	112896	113127
23757	36570	50	applied	\N	\N	\N	\N	112906	112906	113128
23757	36573	51	applied	\N	\N	\N	\N	112914	112914	113129
23757	36576	52	applied	\N	\N	\N	\N	112922	112922	113130
23757	36580	53	applied	\N	\N	\N	\N	112934	112934	113131
23757	36581	54	applied	\N	\N	\N	\N	112936	112936	113132
23757	36586	55	applied	\N	\N	\N	\N	112947	112947	113133
23757	36590	56	applied	\N	\N	\N	\N	112957	112957	113134
23757	36593	57	applied	\N	\N	\N	\N	112969	112969	113135
23757	36594	58	applied	\N	\N	\N	\N	112971	112971	113136
23757	36600	59	applied	\N	\N	\N	\N	112986	112986	113137
23757	36603	61	applied	\N	\N	\N	\N	112993	112993	113138
23757	36604	62	applied	\N	\N	\N	\N	112995	112995	113139
23757	36609	63	applied	\N	\N	\N	\N	113010	113010	113140
23757	36610	64	applied	\N	\N	\N	\N	113012	113012	113141
23757	36617	65	applied	\N	\N	\N	\N	113028	113028	113142
23757	36618	66	applied	\N	\N	\N	\N	113030	113030	113143
23757	36624	67	applied	\N	\N	\N	\N	113044	113044	113144
23757	36627	68	applied	\N	\N	\N	\N	113052	113052	113145
23757	36628	69	applied	\N	\N	\N	\N	113054	113054	113146
23757	36634	70	applied	\N	\N	\N	\N	113068	113068	113147
23757	36637	71	applied	\N	\N	\N	\N	113075	113075	113148
23757	36638	72	applied	\N	\N	\N	\N	113077	113077	113149
23757	36639	73	applied	\N	\N	\N	\N	113079	113079	113150
23757	36647	74	applied	\N	\N	\N	\N	113097	113097	113151
23757	36648	75	applied	\N	\N	\N	\N	113099	113099	113152
23757	36654	76	applied	\N	\N	\N	\N	113111	113111	113153
23757	36658	77	applied	\N	\N	\N	\N	113156	113156	113316
23757	36663	78	applied	\N	\N	\N	\N	113171	113171	113317
23757	36667	79	applied	\N	\N	\N	\N	113191	113191	113318
23757	36669	80	applied	\N	\N	\N	\N	113197	113197	113319
23757	36672	81	applied	\N	\N	\N	\N	113205	113205	113320
23757	36673	82	applied	\N	\N	\N	\N	113207	113207	113321
23757	36674	83	applied	\N	\N	\N	\N	113209	113209	113322
23757	36675	84	applied	\N	\N	\N	\N	113211	113211	113323
23757	36676	85	applied	\N	\N	\N	\N	113213	113213	113324
23757	36677	86	applied	\N	\N	\N	\N	113215	113215	113325
23757	36678	87	applied	\N	\N	\N	\N	113217	113217	113326
23757	36695	88	applied	\N	\N	\N	\N	113253	113253	113327
23757	36696	89	applied	\N	\N	\N	\N	113255	113255	113328
23757	36702	90	applied	\N	\N	\N	\N	113290	113290	113329
23757	36705	91	applied	\N	\N	\N	\N	113304	113304	113330
23757	36497	92	applied	\N	\N	\N	\N	112722	112722	112723
23757	36415	93	applied	\N	\N	\N	\N	112482	112482	112466
23757	36409	94	applied	\N	\N	\N	\N	112465	112465	113331
23757	36498	95	applied	\N	\N	\N	\N	112724	112724	112725
23757	36505	96	applied	\N	\N	\N	\N	112742	112742	112743
23757	36508	97	applied	\N	\N	\N	\N	112748	112748	112749
23757	36412	98	applied	\N	\N	\N	\N	112473	112473	113332
23757	36416	99	applied	\N	\N	\N	\N	112484	112484	113333
23757	36555	100	applied	\N	\N	1000000000	\N	112858	112858	112859
23757	36418	101	applied	\N	\N	\N	\N	112488	112488	113334
23757	36422	102	applied	\N	\N	\N	\N	112500	112500	113335
23757	36423	103	applied	\N	\N	\N	\N	112502	112502	112491
23757	36427	104	applied	\N	\N	\N	\N	112510	112510	112501
23757	36431	105	applied	\N	\N	\N	\N	112523	112523	112503
23757	36437	106	applied	\N	\N	\N	\N	112539	112539	113336
23757	36438	107	applied	\N	\N	\N	\N	112541	112541	112509
23757	36441	108	applied	\N	\N	\N	\N	112550	112550	112511
23757	36562	109	applied	\N	\N	\N	\N	112883	112883	112884
23757	36444	110	applied	\N	\N	\N	\N	112558	112558	112522
23757	36448	111	applied	\N	\N	\N	\N	112568	112568	112524
23757	36454	112	applied	\N	\N	\N	\N	112584	112584	112536
23757	36458	113	applied	\N	\N	\N	\N	112595	112595	113337
23757	36463	114	applied	\N	\N	\N	\N	112618	112618	113338
23757	36464	115	applied	\N	\N	\N	\N	112620	112620	113339
23757	36467	116	applied	\N	\N	\N	\N	112626	112626	113340
23757	36471	117	applied	\N	\N	\N	\N	112637	112637	112557
23757	36475	118	applied	\N	\N	\N	\N	112652	112652	112559
23757	36480	119	applied	\N	\N	\N	\N	112671	112671	112567
23757	36483	120	applied	\N	\N	\N	\N	112678	112678	112569
23757	36484	121	applied	\N	\N	\N	\N	112680	112680	112585
23757	36489	122	applied	\N	\N	\N	\N	112697	112697	113341
23757	36492	123	applied	\N	\N	\N	\N	112708	112708	113342
23757	36499	124	applied	\N	\N	\N	\N	112726	112726	113343
23758	36708	0	applied	\N	\N	\N	\N	113348	113348	113349
23758	36709	1	applied	\N	\N	\N	\N	113350	113350	113351
23758	36710	2	applied	\N	\N	\N	\N	113352	113352	113353
23758	36711	3	applied	\N	\N	\N	\N	113354	113354	113355
23761	36712	0	applied	\N	\N	\N	\N	113408	113408	113409
23761	36713	1	applied	\N	\N	\N	\N	113410	113410	113411
23761	36714	2	applied	\N	\N	\N	\N	113412	113412	113413
23761	36715	3	applied	\N	\N	\N	\N	113414	113414	113415
23761	36716	4	applied	\N	\N	\N	\N	113416	113416	113417
23761	36717	5	applied	\N	\N	\N	\N	113418	113418	113419
23763	36718	0	applied	\N	\N	\N	\N	113446	113446	113447
23763	36719	1	applied	\N	\N	\N	\N	113448	113448	113449
23763	36720	2	applied	\N	\N	\N	\N	113450	113450	113451
23763	36721	3	applied	\N	\N	\N	\N	113452	113452	113453
23763	36722	4	applied	\N	\N	\N	\N	113454	113454	113455
23763	36723	5	applied	\N	\N	\N	\N	113456	113456	113457
23763	36724	6	applied	\N	\N	\N	\N	113458	113458	113459
23775	36745	0	applied	\N	\N	\N	\N	113521	113521	113522
23775	36746	1	applied	\N	\N	\N	\N	113523	113523	113524
23775	36747	2	applied	\N	\N	\N	\N	113525	113525	113526
23777	36748	0	applied	\N	\N	\N	\N	113531	113531	113532
23777	36749	1	applied	\N	\N	\N	\N	113533	113533	113534
23777	36750	2	applied	\N	\N	\N	\N	113535	113535	113536
23782	36757	0	applied	\N	\N	\N	\N	113555	113555	113556
23782	36758	1	applied	\N	\N	\N	\N	113557	113557	113558
23782	36755	2	applied	\N	\N	\N	\N	113549	113549	113550
23782	36759	3	applied	\N	\N	\N	\N	113559	113559	113560
23782	36756	4	applied	\N	\N	\N	\N	113551	113551	113561
23782	36760	5	applied	\N	\N	\N	\N	113562	113562	113563
23784	36761	0	applied	\N	\N	\N	\N	113566	113566	113567
23784	36762	1	applied	\N	\N	\N	\N	113568	113568	113569
23788	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23788	36761	1	applied	\N	\N	\N	\N	113566	113566	113567
23788	36762	2	applied	\N	\N	\N	\N	113568	113568	113569
23788	36764	3	applied	\N	\N	\N	\N	113574	113574	113575
23794	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23794	36769	1	applied	\N	\N	\N	\N	113596	113596	113597
23794	36770	2	applied	\N	\N	\N	\N	113598	113598	113599
23797	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23797	36771	1	applied	\N	\N	\N	\N	113605	113605	113606
23797	36772	2	applied	\N	\N	\N	\N	113607	113607	113608
23797	36773	3	applied	\N	\N	\N	\N	113609	113609	113610
23800	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23800	36771	1	applied	\N	\N	\N	\N	113605	113605	113606
23800	36772	2	applied	\N	\N	\N	\N	113607	113607	113608
23800	36773	3	applied	\N	\N	\N	\N	113609	113609	113610
23801	36774	0	applied	\N	\N	\N	\N	113621	113621	113622
23801	36775	1	applied	\N	\N	\N	\N	113623	113623	113624
23801	36776	2	applied	\N	\N	\N	\N	113625	113625	113626
23801	36777	3	applied	\N	\N	\N	\N	113627	113627	113628
23801	36778	4	applied	\N	\N	\N	\N	113629	113629	113630
23801	36779	5	applied	\N	\N	\N	\N	113631	113631	113632
23801	36780	6	applied	\N	\N	\N	\N	113633	113633	113634
23804	36781	0	applied	\N	\N	\N	\N	113639	113639	113640
23804	36782	1	applied	\N	\N	\N	\N	113641	113641	113642
23804	36783	2	applied	\N	\N	\N	\N	113643	113643	113644
23806	36788	0	applied	\N	\N	\N	\N	113656	113656	113657
23806	36789	1	applied	\N	\N	\N	\N	113658	113658	113659
23806	36790	2	applied	\N	\N	\N	\N	113660	113660	113661
23806	36791	3	applied	\N	\N	\N	\N	113662	113662	113663
23806	36792	4	applied	\N	\N	\N	\N	113664	113664	113665
23806	36793	5	applied	\N	\N	\N	\N	113666	113666	113667
23815	36805	0	applied	\N	\N	\N	\N	113703	113703	113704
23815	36806	1	applied	\N	\N	\N	\N	113705	113705	113706
23815	36807	2	applied	\N	\N	\N	\N	113707	113707	113708
23818	36812	0	applied	\N	\N	\N	\N	113717	113717	113718
23818	36813	1	applied	\N	\N	\N	\N	113719	113719	113720
23818	36814	3	applied	\N	\N	\N	\N	113722	113722	113723
23818	36815	4	applied	\N	\N	\N	\N	113724	113724	113725
23818	36816	5	applied	\N	\N	\N	\N	113726	113726	113727
23818	36817	6	applied	\N	\N	\N	\N	113728	113728	113729
23824	36828	0	applied	\N	\N	\N	\N	113760	113760	113761
23824	36829	1	applied	\N	\N	\N	\N	113762	113762	113763
23824	36830	2	applied	\N	\N	\N	\N	113764	113764	113765
23824	36831	3	applied	\N	\N	\N	\N	113766	113766	113767
23824	36832	4	applied	\N	\N	\N	\N	113768	113768	113769
23824	36827	5	applied	\N	\N	\N	\N	113757	113757	113772
23824	36833	6	applied	\N	\N	\N	\N	113773	113773	113774
23824	36834	7	applied	\N	\N	\N	\N	113775	113775	113776
23826	36835	0	applied	\N	\N	\N	\N	113779	113779	113780
23826	36836	1	applied	\N	\N	\N	\N	113781	113781	113782
23826	36837	2	applied	\N	\N	\N	\N	113783	113783	113784
23832	36841	0	applied	\N	\N	\N	\N	113795	113795	113796
23832	36842	1	applied	\N	\N	\N	\N	113797	113797	113798
23832	36843	2	applied	\N	\N	\N	\N	113799	113799	113800
23832	36844	3	applied	\N	\N	\N	\N	113801	113801	113802
23832	36845	4	applied	\N	\N	\N	\N	113803	113803	113804
23832	36846	5	applied	\N	\N	\N	\N	113805	113805	113806
23832	36847	6	applied	\N	\N	\N	\N	113807	113807	113808
23836	36848	0	applied	\N	\N	\N	\N	113816	113816	113817
23836	36849	1	applied	\N	\N	\N	\N	113818	113818	113819
23836	36850	2	applied	\N	\N	\N	\N	113820	113820	113821
23836	36852	3	applied	\N	\N	\N	\N	113825	113825	113826
23836	36851	4	applied	\N	\N	\N	\N	113822	113822	113827
23836	36853	5	applied	\N	\N	\N	\N	113828	113828	113829
23843	36870	0	applied	\N	\N	\N	\N	113875	113875	113876
23843	36871	1	applied	\N	\N	\N	\N	113877	113877	113878
23843	36872	2	applied	\N	\N	\N	\N	113879	113879	113880
23843	36873	3	applied	\N	\N	\N	\N	113881	113881	113882
23843	36874	4	applied	\N	\N	\N	\N	113883	113883	113884
23759	36667	2	applied	\N	\N	\N	\N	113191	113191	113318
23759	36669	3	applied	\N	\N	\N	\N	113197	113197	113319
23759	36672	4	applied	\N	\N	\N	\N	113205	113205	113320
23759	36673	5	applied	\N	\N	\N	\N	113207	113207	113321
23759	36674	6	applied	\N	\N	\N	\N	113209	113209	113322
23759	36675	7	applied	\N	\N	\N	\N	113211	113211	113323
23759	36676	8	applied	\N	\N	\N	\N	113213	113213	113324
23759	36677	9	applied	\N	\N	\N	\N	113215	113215	113325
23759	36678	10	applied	\N	\N	\N	\N	113217	113217	113326
23759	36695	11	applied	\N	\N	\N	\N	113253	113253	113327
23759	36696	12	applied	\N	\N	\N	\N	113255	113255	113328
23759	36702	13	applied	\N	\N	\N	\N	113290	113290	113329
23759	36705	14	applied	\N	\N	\N	\N	113304	113304	113330
23759	36307	15	applied	\N	\N	\N	\N	112156	112156	112220
23759	36358	16	applied	\N	\N	\N	\N	112316	112316	112188
23759	36370	17	applied	\N	\N	\N	\N	112347	112347	112166
23759	36377	18	applied	\N	\N	\N	\N	112363	112363	112189
23759	36310	19	applied	\N	\N	\N	\N	112163	112163	112174
23759	36315	20	applied	\N	\N	\N	\N	112175	112175	112176
23759	36316	21	applied	\N	\N	\N	\N	112177	112177	112178
23759	36323	22	applied	\N	\N	\N	\N	112202	112202	112223
23759	36324	23	applied	\N	\N	\N	\N	112204	112204	112197
23759	36335	24	applied	\N	\N	\N	\N	112244	112244	113358
23759	36338	25	applied	\N	\N	\N	\N	112250	112250	112225
23759	36339	26	applied	\N	\N	\N	\N	112252	112252	112201
23759	36343	27	applied	\N	\N	\N	\N	112262	112262	112203
23759	36345	28	applied	\N	\N	\N	\N	112269	112269	112205
23759	36353	29	applied	\N	\N	\N	\N	112306	112306	113359
23759	36354	30	applied	\N	\N	\N	\N	112308	112308	113360
23759	36355	31	applied	\N	\N	\N	\N	112310	112310	113361
23759	36363	32	applied	\N	\N	\N	\N	112330	112330	112247
23759	36364	33	applied	\N	\N	\N	\N	112332	112332	113362
23759	36368	34	applied	\N	\N	\N	\N	112343	112343	113363
23759	36372	35	applied	\N	\N	\N	\N	112351	112351	113364
23759	36378	36	applied	\N	\N	\N	\N	112365	112365	112255
23759	36379	37	applied	\N	\N	\N	\N	112367	112367	113365
23759	36380	38	applied	\N	\N	\N	\N	112369	112369	113366
23759	36388	39	applied	\N	\N	\N	\N	112392	112392	113367
23759	36389	40	applied	\N	\N	\N	\N	112394	112394	112274
23759	36392	41	applied	\N	\N	\N	\N	112422	112422	112275
23759	36393	42	applied	\N	\N	\N	\N	112424	112424	113368
23759	36399	43	applied	\N	\N	\N	\N	112438	112438	112297
23759	36403	44	applied	\N	\N	\N	\N	112450	112450	112307
23759	36404	45	applied	\N	\N	\N	\N	112452	112452	112309
23759	36408	46	applied	\N	\N	\N	\N	112461	112461	112311
23759	36411	47	applied	\N	\N	\N	\N	112471	112471	113369
23759	36417	48	applied	\N	\N	\N	\N	112486	112486	113370
23759	36419	49	applied	\N	\N	\N	\N	112490	112490	112315
23759	36424	50	applied	\N	\N	\N	\N	112504	112504	113371
23759	36425	51	applied	\N	\N	\N	\N	112506	112506	112319
23759	36426	52	applied	\N	\N	\N	\N	112508	112508	113372
23759	36430	53	applied	\N	\N	\N	\N	112521	112521	113373
23759	36435	54	applied	\N	\N	\N	\N	112535	112535	113374
23759	36436	55	applied	\N	\N	\N	\N	112537	112537	113375
23759	36440	56	applied	\N	\N	\N	\N	112548	112548	112335
23759	36443	57	applied	\N	\N	\N	\N	112556	112556	113376
23759	36447	58	applied	\N	\N	\N	\N	112566	112566	113377
23759	36396	59	applied	\N	\N	\N	\N	112430	112430	112344
23759	36406	60	applied	\N	\N	\N	\N	112456	112456	112348
23759	36415	61	applied	\N	\N	\N	\N	112482	112482	113378
23759	36311	62	applied	\N	\N	\N	\N	112165	112165	113379
23759	36314	63	applied	\N	\N	\N	\N	112173	112173	113380
23759	36317	64	applied	\N	\N	\N	\N	112179	112179	112368
23759	36321	65	applied	\N	\N	\N	\N	112198	112198	113381
23759	36322	66	applied	\N	\N	\N	\N	112200	112200	113382
23759	36326	67	applied	\N	\N	\N	\N	112210	112210	112378
23759	36336	68	applied	\N	\N	\N	\N	112246	112246	113383
23759	36340	69	applied	\N	\N	\N	\N	112254	112254	113384
23759	36342	70	applied	\N	\N	\N	\N	112260	112260	113385
23759	36346	71	applied	\N	\N	\N	\N	112273	112273	112395
23759	36348	72	applied	\N	\N	\N	\N	112294	112294	113386
23759	36356	73	applied	\N	\N	\N	\N	112312	112312	113387
23759	36357	74	applied	\N	\N	\N	\N	112314	112314	113388
23759	36359	75	applied	\N	\N	\N	\N	112318	112318	113389
23759	36362	76	applied	\N	\N	\N	\N	112328	112328	113390
23759	36365	77	applied	\N	\N	\N	\N	112334	112334	113391
23759	36367	78	applied	\N	\N	\N	\N	112341	112341	112451
23759	36371	79	applied	\N	\N	\N	\N	112349	112349	113392
23759	36381	81	applied	\N	\N	\N	\N	112372	112372	112457
23759	36382	82	applied	\N	\N	\N	\N	112374	112374	112466
23759	36383	83	applied	\N	\N	\N	\N	112375	112375	113331
23759	36386	84	applied	\N	\N	\N	\N	112388	112388	113332
23759	36387	85	applied	\N	\N	\N	\N	112390	112390	113333
23759	36394	86	applied	\N	\N	\N	\N	112426	112426	113334
23759	36395	87	applied	\N	\N	\N	\N	112428	112428	113335
23759	36398	88	applied	\N	\N	\N	\N	112436	112436	112491
23759	36402	89	applied	\N	\N	\N	\N	112448	112448	112501
23759	36405	90	applied	\N	\N	\N	\N	112454	112454	112503
23759	36409	91	applied	\N	\N	\N	\N	112465	112465	113336
23759	36412	92	applied	\N	\N	\N	\N	112473	112473	112509
23759	36416	93	applied	\N	\N	\N	\N	112484	112484	112511
23759	36418	94	applied	\N	\N	\N	\N	112488	112488	112522
23759	36422	95	applied	\N	\N	\N	\N	112500	112500	112524
23759	36423	96	applied	\N	\N	\N	\N	112502	112502	112536
23759	36427	97	applied	\N	\N	\N	\N	112510	112510	113337
23759	36431	98	applied	\N	\N	\N	\N	112523	112523	113338
23759	36437	99	applied	\N	\N	\N	\N	112539	112539	113339
23759	36438	100	applied	\N	\N	\N	\N	112541	112541	113340
23759	36441	101	applied	\N	\N	\N	\N	112550	112550	112557
23759	36444	102	applied	\N	\N	\N	\N	112558	112558	112559
23759	36448	103	applied	\N	\N	\N	\N	112568	112568	112567
23759	36454	104	applied	\N	\N	\N	\N	112584	112584	112569
23759	36458	105	applied	\N	\N	\N	\N	112595	112595	112585
23759	36463	106	applied	\N	\N	\N	\N	112618	112618	113341
23759	36464	107	applied	\N	\N	\N	\N	112620	112620	113342
23759	36467	108	applied	\N	\N	\N	\N	112626	112626	113343
23759	36471	109	applied	\N	\N	\N	\N	112637	112637	113394
23759	36475	110	applied	\N	\N	\N	\N	112652	112652	113395
23759	36480	111	applied	\N	\N	\N	\N	112671	112671	112625
23759	36483	112	applied	\N	\N	\N	\N	112678	112678	112627
23759	36484	113	applied	\N	\N	\N	\N	112680	112680	113396
23759	36489	114	applied	\N	\N	\N	\N	112697	112697	113397
23759	36492	115	applied	\N	\N	\N	\N	112708	112708	113398
23759	36499	116	applied	\N	\N	\N	\N	112726	112726	113399
23759	36500	117	applied	\N	\N	\N	\N	112728	112728	112665
23759	36509	118	applied	\N	\N	\N	\N	112750	112750	113400
23759	36510	119	applied	\N	\N	\N	\N	112752	112752	113401
23759	36514	120	applied	\N	\N	\N	\N	112762	112762	113402
23759	36517	121	applied	\N	\N	\N	\N	112768	112768	112683
23759	36520	122	applied	\N	\N	\N	\N	112776	112776	113403
23759	36521	123	applied	\N	\N	\N	\N	112778	112778	113404
23759	36428	124	applied	\N	\N	\N	\N	112512	112512	112698
23759	36434	125	applied	\N	\N	\N	\N	112533	112533	113405
23766	36718	0	applied	\N	\N	\N	\N	113446	113446	113447
23766	36719	1	applied	\N	\N	\N	\N	113448	113448	113449
23766	36725	2	applied	\N	\N	\N	\N	113464	113464	113465
23766	36726	3	applied	\N	\N	\N	\N	113466	113466	113467
23766	36727	4	applied	\N	\N	\N	\N	113468	113468	113469
23769	36732	0	applied	\N	\N	\N	\N	113483	113483	113484
23769	36733	1	applied	\N	\N	\N	\N	113485	113485	113486
23769	36734	2	applied	\N	\N	\N	\N	113487	113487	113488
23771	36732	0	applied	\N	\N	\N	\N	113483	113483	113484
23771	36735	1	applied	\N	\N	\N	\N	113493	113493	113494
23771	36736	2	applied	\N	\N	\N	\N	113495	113495	113496
23771	36737	3	applied	\N	\N	\N	\N	113497	113497	113498
23780	36751	0	applied	\N	\N	\N	\N	113539	113539	113540
23780	36752	1	applied	\N	\N	\N	\N	113541	113541	113542
23780	36753	2	applied	\N	\N	\N	\N	113543	113543	113544
23780	36754	3	applied	\N	\N	\N	\N	113545	113545	113546
23786	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23786	36761	1	applied	\N	\N	\N	\N	113566	113566	113567
23786	36762	2	applied	\N	\N	\N	\N	113568	113568	113569
23786	36764	3	applied	\N	\N	\N	\N	113574	113574	113575
23789	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23789	36765	1	applied	\N	\N	\N	\N	113583	113583	113584
23789	36766	2	applied	\N	\N	\N	\N	113585	113585	113586
23789	36764	3	applied	\N	\N	\N	\N	113574	113574	113587
23789	36767	4	applied	\N	\N	\N	\N	113588	113588	113589
23792	36769	0	applied	\N	\N	\N	\N	113596	113596	113597
23792	36770	1	applied	\N	\N	\N	\N	113598	113598	113599
23799	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23799	36771	1	applied	\N	\N	\N	\N	113605	113605	113606
23799	36772	2	applied	\N	\N	\N	\N	113607	113607	113608
23799	36773	3	applied	\N	\N	\N	\N	113609	113609	113610
23808	36794	0	applied	\N	\N	1000000000	\N	113670	113670	113671
23808	36795	1	applied	\N	\N	\N	\N	113672	113672	113673
23808	36796	2	applied	\N	\N	\N	\N	113674	113674	113675
23808	36797	3	applied	\N	\N	\N	\N	113676	113676	113677
23808	36798	4	applied	\N	\N	\N	\N	113678	113678	113679
23810	36799	0	applied	\N	\N	\N	\N	113682	113682	113683
23810	36800	1	applied	\N	\N	\N	\N	113684	113684	113685
23810	36801	2	applied	\N	\N	\N	\N	113686	113686	113687
23812	36802	0	applied	\N	\N	\N	\N	113693	113693	113694
23812	36803	1	applied	\N	\N	\N	\N	113695	113695	113696
23812	36804	2	applied	\N	\N	\N	\N	113697	113697	113698
23817	36812	0	applied	\N	\N	\N	\N	113717	113717	113718
23817	36813	1	applied	\N	\N	\N	\N	113719	113719	113720
23817	36814	3	applied	\N	\N	\N	\N	113722	113722	113723
23817	36815	4	applied	\N	\N	\N	\N	113724	113724	113725
23817	36816	5	applied	\N	\N	\N	\N	113726	113726	113727
23817	36817	6	applied	\N	\N	\N	\N	113728	113728	113729
23822	36825	0	applied	\N	\N	\N	\N	113751	113751	113752
23822	36826	1	applied	\N	\N	\N	\N	113753	113753	113754
23822	36827	2	applied	\N	\N	\N	\N	113757	113757	113758
23827	36838	0	applied	\N	\N	\N	\N	113787	113787	113788
23827	36839	1	applied	\N	\N	\N	\N	113789	113789	113790
23827	36840	2	applied	\N	\N	\N	\N	113791	113791	113792
23830	36841	0	applied	\N	\N	\N	\N	113795	113795	113796
23830	36842	1	applied	\N	\N	\N	\N	113797	113797	113798
23830	36843	2	applied	\N	\N	\N	\N	113799	113799	113800
23830	36844	3	applied	\N	\N	\N	\N	113801	113801	113802
23830	36845	4	applied	\N	\N	\N	\N	113803	113803	113804
23830	36846	5	applied	\N	\N	\N	\N	113805	113805	113806
23830	36847	6	applied	\N	\N	\N	\N	113807	113807	113808
23834	36848	0	applied	\N	\N	\N	\N	113816	113816	113817
23834	36849	1	applied	\N	\N	\N	\N	113818	113818	113819
23834	36850	2	applied	\N	\N	\N	\N	113820	113820	113821
23834	36851	3	applied	\N	\N	\N	\N	113822	113822	113823
23837	36852	0	applied	\N	\N	\N	\N	113825	113825	113833
23837	36853	1	applied	\N	\N	\N	\N	113828	113828	113834
23839	36854	0	applied	\N	\N	\N	\N	113836	113836	113837
23839	36855	1	applied	\N	\N	\N	\N	113838	113838	113839
23839	36856	2	applied	\N	\N	\N	\N	113840	113840	113841
23841	36860	0	applied	\N	\N	\N	\N	113851	113851	113852
23841	36861	1	applied	\N	\N	\N	\N	113853	113853	113854
23841	36862	2	applied	\N	\N	\N	\N	113855	113855	113856
23841	36863	3	applied	\N	\N	\N	\N	113857	113857	113858
23841	36864	4	applied	\N	\N	\N	\N	113859	113859	113860
23841	36865	5	applied	\N	\N	\N	\N	113861	113861	113862
23841	36866	6	applied	\N	\N	\N	\N	113863	113863	113864
23844	36877	0	applied	\N	\N	\N	\N	113891	113891	113892
23844	36878	1	applied	\N	\N	\N	\N	113893	113893	113894
23844	36879	2	applied	\N	\N	\N	\N	113895	113895	113896
23847	36794	0	applied	\N	\N	1000000000	\N	113901	113901	113671
23847	36449	1	applied	\N	\N	\N	\N	112573	112573	112574
23847	36450	2	applied	\N	\N	\N	\N	112575	112575	112576
23847	36451	3	applied	\N	\N	\N	\N	112577	112577	112578
23847	36452	4	applied	\N	\N	\N	\N	112579	112579	112580
23847	36021	5	applied	\N	\N	\N	\N	111295	111295	111296
23847	36267	6	applied	\N	\N	\N	\N	112280	112280	112397
23847	36019	7	applied	\N	\N	\N	\N	111288	111288	111289
23847	36327	8	applied	\N	\N	\N	\N	113902	113902	112230
23847	36328	9	applied	\N	\N	\N	\N	113903	113903	112232
23847	36022	10	applied	\N	\N	\N	\N	111297	111297	111298
23847	36024	12	applied	\N	\N	\N	\N	111302	111302	111303
23847	36026	13	applied	\N	\N	\N	\N	111308	111308	111309
23847	36027	14	applied	\N	\N	\N	\N	111310	111310	111311
23847	36028	15	applied	\N	\N	\N	\N	111312	111312	111313
23847	36032	16	applied	\N	\N	\N	\N	111321	111321	111322
23847	36034	17	applied	\N	\N	\N	\N	111329	111329	111330
23847	36036	18	applied	\N	\N	\N	\N	111335	111335	111336
23847	36038	19	applied	\N	\N	\N	\N	111344	111344	111345
23847	36040	20	applied	\N	\N	\N	\N	111352	111352	111353
23847	36042	21	applied	\N	\N	\N	\N	111362	111362	111363
23847	36044	22	applied	\N	\N	\N	\N	111368	111368	111369
23847	36046	23	applied	\N	\N	\N	\N	111378	111378	111379
23847	36048	24	applied	\N	\N	\N	\N	111384	111384	111385
23847	36050	25	applied	\N	\N	\N	\N	111394	111394	111395
23847	36053	26	applied	\N	\N	\N	\N	111402	111402	111403
23847	36056	27	applied	\N	\N	\N	\N	111470	111470	111471
23847	36057	28	applied	\N	\N	\N	\N	111472	111472	111473
23847	36058	29	applied	\N	\N	\N	\N	111474	111474	111475
23847	36065	30	applied	\N	\N	\N	\N	111490	111490	111491
23847	36066	31	applied	\N	\N	\N	\N	111492	111492	111493
23847	36071	32	applied	\N	\N	\N	\N	111504	111504	111505
23847	36329	33	applied	\N	\N	\N	\N	113905	113905	112234
23847	36330	34	applied	\N	\N	\N	\N	113906	113906	112236
23847	36331	35	applied	\N	\N	\N	\N	113907	113907	112238
23847	36181	36	applied	\N	\N	\N	\N	112398	112398	111820
23762	36470	80	applied	\N	\N	\N	\N	112635	112635	113397
23762	36471	81	applied	\N	\N	\N	\N	112637	112637	113398
23762	36493	82	applied	\N	\N	\N	\N	112710	112710	112651
23762	36555	83	applied	\N	\N	1000000000	\N	112858	112858	112859
23762	36474	84	applied	\N	\N	\N	\N	112650	112650	113399
23762	36477	85	applied	\N	\N	\N	\N	112664	112664	113425
23762	36479	86	applied	\N	\N	\N	\N	112669	112669	113426
23762	36486	87	applied	\N	\N	\N	\N	112684	112684	113400
23762	36562	88	applied	\N	\N	\N	\N	112883	112883	112884
23762	36487	89	applied	\N	\N	\N	\N	112686	112686	112672
23762	36490	90	applied	\N	\N	\N	\N	112699	112699	113427
23762	36494	91	applied	\N	\N	\N	\N	112712	112712	113402
23762	36501	92	applied	\N	\N	\N	\N	112730	112730	112681
23762	36502	93	applied	\N	\N	\N	\N	112732	112732	113428
23762	36506	94	applied	\N	\N	\N	\N	112744	112744	113403
23762	36507	95	applied	\N	\N	\N	\N	112746	112746	113429
23762	36513	96	applied	\N	\N	\N	\N	112760	112760	112698
23762	36516	97	applied	\N	\N	\N	\N	112766	112766	112700
23762	36522	98	applied	\N	\N	\N	\N	112780	112780	113430
23762	36523	99	applied	\N	\N	\N	\N	112782	112782	112711
23762	36526	100	applied	\N	\N	\N	\N	112788	112788	112713
23762	36531	101	applied	\N	\N	\N	\N	112798	112798	113431
23762	36534	102	applied	\N	\N	\N	\N	112804	112804	113432
23762	36536	103	applied	\N	\N	\N	\N	112809	112809	112729
23762	36541	104	applied	\N	\N	\N	\N	112821	112821	112731
23762	36542	106	applied	\N	\N	\N	\N	112824	112824	112733
23762	36548	107	applied	\N	\N	\N	\N	112844	112844	112745
23762	36553	108	applied	\N	\N	\N	\N	112854	112854	112747
23762	36554	109	applied	\N	\N	\N	\N	112856	112856	113434
23762	36560	110	applied	\N	\N	\N	\N	112879	112879	113435
23762	36561	111	applied	\N	\N	\N	\N	112881	112881	112753
23762	36564	112	applied	\N	\N	\N	\N	112889	112889	113436
23762	36569	113	applied	\N	\N	\N	\N	112901	112901	113437
23762	36571	114	applied	\N	\N	\N	\N	112908	112908	112763
23762	36574	115	applied	\N	\N	\N	\N	112916	112916	112767
23762	36475	116	applied	\N	\N	\N	\N	112652	112652	112769
23762	36480	117	applied	\N	\N	\N	\N	112671	112671	112777
23762	36483	118	applied	\N	\N	\N	\N	112678	112678	112779
23762	36484	119	applied	\N	\N	\N	\N	112680	112680	113438
23762	36489	120	applied	\N	\N	\N	\N	112697	112697	113439
23762	36492	121	applied	\N	\N	\N	\N	112708	112708	113440
23762	36499	122	applied	\N	\N	\N	\N	112726	112726	113441
23762	36500	123	applied	\N	\N	\N	\N	112728	112728	113442
23762	36509	124	applied	\N	\N	\N	\N	112750	112750	113443
23762	36510	125	applied	\N	\N	\N	\N	112752	112752	112805
23764	36720	0	applied	\N	\N	\N	\N	113450	113450	113451
23764	36721	1	applied	\N	\N	\N	\N	113452	113452	113453
23764	36722	2	applied	\N	\N	\N	\N	113454	113454	113455
23764	36723	3	applied	\N	\N	\N	\N	113456	113456	113457
23764	36724	4	applied	\N	\N	\N	\N	113458	113458	113459
23773	36738	0	applied	\N	\N	\N	\N	113505	113505	113506
23773	36739	1	applied	\N	\N	\N	\N	113507	113507	113508
23773	36740	2	applied	\N	\N	\N	\N	113509	113509	113510
23773	36741	3	applied	\N	\N	\N	\N	113511	113511	113512
23773	36742	4	applied	\N	\N	\N	\N	113513	113513	113514
23773	36743	5	applied	\N	\N	\N	\N	113515	113515	113516
23773	36744	6	applied	\N	\N	\N	\N	113517	113517	113518
23778	36748	0	applied	\N	\N	\N	\N	113531	113531	113532
23778	36749	1	applied	\N	\N	\N	\N	113533	113533	113534
23778	36750	2	applied	\N	\N	\N	\N	113535	113535	113536
23783	36757	0	applied	\N	\N	\N	\N	113555	113555	113556
23783	36758	1	applied	\N	\N	\N	\N	113557	113557	113558
23783	36755	2	applied	\N	\N	\N	\N	113549	113549	113550
23783	36759	3	applied	\N	\N	\N	\N	113559	113559	113560
23783	36756	4	applied	\N	\N	\N	\N	113551	113551	113561
23783	36760	5	applied	\N	\N	\N	\N	113562	113562	113563
23785	36763	0	applied	\N	\N	\N	\N	113572	113572	113573
23785	36761	1	applied	\N	\N	\N	\N	113566	113566	113567
23785	36762	2	applied	\N	\N	\N	\N	113568	113568	113569
23785	36764	3	applied	\N	\N	\N	\N	113574	113574	113575
23791	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23791	36769	1	applied	\N	\N	\N	\N	113596	113596	113597
23791	36770	2	applied	\N	\N	\N	\N	113598	113598	113599
23795	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23795	36769	1	applied	\N	\N	\N	\N	113596	113596	113597
23795	36770	2	applied	\N	\N	\N	\N	113598	113598	113599
23798	36768	0	applied	\N	\N	\N	\N	113594	113594	113595
23798	36771	1	applied	\N	\N	\N	\N	113605	113605	113606
23798	36772	2	applied	\N	\N	\N	\N	113607	113607	113608
23798	36773	3	applied	\N	\N	\N	\N	113609	113609	113610
23802	36774	0	applied	\N	\N	\N	\N	113621	113621	113622
23802	36775	1	applied	\N	\N	\N	\N	113623	113623	113624
23802	36776	2	applied	\N	\N	\N	\N	113625	113625	113626
23802	36777	3	applied	\N	\N	\N	\N	113627	113627	113628
23802	36778	4	applied	\N	\N	\N	\N	113629	113629	113630
23802	36779	5	applied	\N	\N	\N	\N	113631	113631	113632
23802	36780	6	applied	\N	\N	\N	\N	113633	113633	113634
23853	35948	57	applied	\N	\N	\N	\N	111007	111007	111158
23807	36794	0	applied	\N	\N	1000000000	\N	113670	113670	113671
23807	36795	1	applied	\N	\N	\N	\N	113672	113672	113673
23807	36796	2	applied	\N	\N	\N	\N	113674	113674	113675
23807	36797	3	applied	\N	\N	\N	\N	113676	113676	113677
23807	36798	4	applied	\N	\N	\N	\N	113678	113678	113679
23809	36799	0	applied	\N	\N	\N	\N	113682	113682	113683
23809	36800	1	applied	\N	\N	\N	\N	113684	113684	113685
23809	36801	2	applied	\N	\N	\N	\N	113686	113686	113687
23814	36802	0	applied	\N	\N	\N	\N	113693	113693	113694
23814	36803	1	applied	\N	\N	\N	\N	113695	113695	113696
23814	36804	2	applied	\N	\N	\N	\N	113697	113697	113698
23816	36808	0	applied	\N	\N	\N	\N	113709	113709	113710
23816	36809	1	applied	\N	\N	\N	\N	113711	113711	113712
23816	36810	2	applied	\N	\N	\N	\N	113713	113713	113714
23816	36811	3	applied	\N	\N	\N	\N	113715	113715	113716
23819	36818	0	applied	\N	\N	\N	\N	113732	113732	113733
23819	36819	1	applied	\N	\N	\N	\N	113734	113734	113735
23819	36820	2	applied	\N	\N	\N	\N	113736	113736	113737
23819	36821	3	applied	\N	\N	\N	\N	113738	113738	113739
23819	36822	4	applied	\N	\N	\N	\N	113740	113740	113741
23819	36823	5	applied	\N	\N	\N	\N	113742	113742	113743
23819	36824	6	applied	\N	\N	\N	\N	113744	113744	113745
23821	36825	0	applied	\N	\N	\N	\N	113751	113751	113752
23821	36826	1	applied	\N	\N	\N	\N	113753	113753	113754
23825	36828	0	applied	\N	\N	\N	\N	113760	113760	113761
23825	36829	1	applied	\N	\N	\N	\N	113762	113762	113763
23825	36830	2	applied	\N	\N	\N	\N	113764	113764	113765
23825	36831	3	applied	\N	\N	\N	\N	113766	113766	113767
23825	36832	4	applied	\N	\N	\N	\N	113768	113768	113769
23825	36827	5	applied	\N	\N	\N	\N	113757	113757	113772
23825	36833	6	applied	\N	\N	\N	\N	113773	113773	113774
23825	36834	7	applied	\N	\N	\N	\N	113775	113775	113776
23820	36824	6	applied	\N	\N	\N	\N	113744	113744	113745
23823	36828	0	applied	\N	\N	\N	\N	113760	113760	113761
23823	36829	1	applied	\N	\N	\N	\N	113762	113762	113763
23823	36830	2	applied	\N	\N	\N	\N	113764	113764	113765
23823	36831	3	applied	\N	\N	\N	\N	113766	113766	113767
23823	36832	4	applied	\N	\N	\N	\N	113768	113768	113769
23828	36794	0	applied	\N	\N	1000000000	\N	113670	113670	113671
23831	36841	0	applied	\N	\N	\N	\N	113795	113795	113796
23831	36842	1	applied	\N	\N	\N	\N	113797	113797	113798
23831	36843	2	applied	\N	\N	\N	\N	113799	113799	113800
23831	36844	3	applied	\N	\N	\N	\N	113801	113801	113802
23831	36845	4	applied	\N	\N	\N	\N	113803	113803	113804
23831	36846	5	applied	\N	\N	\N	\N	113805	113805	113806
23831	36847	6	applied	\N	\N	\N	\N	113807	113807	113808
23835	36848	0	applied	\N	\N	\N	\N	113816	113816	113817
23835	36849	1	applied	\N	\N	\N	\N	113818	113818	113819
23835	36850	2	applied	\N	\N	\N	\N	113820	113820	113821
23835	36852	3	applied	\N	\N	\N	\N	113825	113825	113826
23835	36851	4	applied	\N	\N	\N	\N	113822	113822	113827
23835	36853	5	applied	\N	\N	\N	\N	113828	113828	113829
23842	36867	0	applied	\N	\N	\N	\N	113867	113867	113868
23842	36868	1	applied	\N	\N	\N	\N	113869	113869	113870
23842	36869	2	applied	\N	\N	\N	\N	113871	113871	113872
23845	36877	0	applied	\N	\N	\N	\N	113891	113891	113892
23845	36878	1	applied	\N	\N	\N	\N	113893	113893	113894
23845	36879	2	applied	\N	\N	\N	\N	113895	113895	113896
23850	36893	0	applied	\N	\N	\N	\N	113941	113941	113942
23850	36894	1	applied	\N	\N	\N	\N	113943	113943	113944
23850	36895	2	applied	\N	\N	\N	\N	113945	113945	113946
23850	36896	3	applied	\N	\N	\N	\N	113947	113947	113948
23853	36794	0	applied	\N	\N	1000000000	\N	113901	113901	113671
23853	36449	1	applied	\N	\N	\N	\N	113960	113960	112574
23853	36450	2	applied	\N	\N	\N	\N	113961	113961	112576
23853	36451	3	applied	\N	\N	\N	\N	113962	113962	112578
23853	36452	4	applied	\N	\N	\N	\N	113963	113963	112580
23853	36021	5	applied	\N	\N	\N	\N	111295	111295	111296
23853	36267	6	applied	\N	\N	\N	\N	112280	112280	112397
23853	35875	7	applied	\N	\N	\N	\N	110679	110679	110680
23853	35876	8	applied	\N	\N	\N	\N	110681	110681	110682
23853	36327	9	applied	\N	\N	\N	\N	113902	113902	112230
23853	35879	10	applied	\N	\N	\N	\N	110689	110689	110690
23853	35913	11	applied	\N	\N	\N	\N	110796	110796	110797
23853	36328	12	applied	\N	\N	\N	\N	113903	113903	112232
23853	36329	13	applied	\N	\N	\N	\N	113905	113905	112234
23853	36330	14	applied	\N	\N	\N	\N	113906	113906	112236
23853	36331	15	applied	\N	\N	\N	\N	113907	113907	112238
23853	36181	16	applied	\N	\N	\N	\N	112398	112398	111820
23853	36182	17	applied	\N	\N	\N	\N	112399	112399	111822
23853	36183	18	applied	\N	\N	\N	\N	112400	112400	111824
23853	36332	19	applied	\N	\N	\N	\N	113908	113908	113908
23853	35880	20	applied	\N	\N	\N	\N	110691	110691	110692
23853	35883	21	applied	\N	\N	\N	\N	110703	110703	111126
23853	36184	22	applied	\N	\N	\N	\N	112402	112402	111826
23853	36185	23	applied	\N	\N	\N	\N	112403	112403	111828
23853	36203	24	applied	\N	\N	\N	\N	112404	112404	111876
23853	36204	25	applied	\N	\N	\N	\N	112044	112044	111878
23853	35884	26	applied	\N	\N	\N	\N	110705	110705	111127
23853	35887	27	applied	\N	\N	\N	\N	110712	110712	111128
23853	35889	28	applied	\N	\N	\N	\N	110716	110716	111129
23853	35891	29	applied	\N	\N	\N	\N	110722	110722	111130
23853	35893	30	applied	\N	\N	\N	\N	110729	110729	111131
23853	35895	31	applied	\N	\N	\N	\N	110735	110735	111132
23853	35896	32	applied	\N	\N	\N	\N	110737	110737	111133
23853	35899	33	applied	\N	\N	\N	\N	110747	110747	111134
23853	35901	34	applied	\N	\N	\N	\N	110760	110760	111135
23853	35903	35	applied	\N	\N	\N	\N	110765	110765	111136
23853	35905	36	applied	\N	\N	\N	\N	110772	110772	111137
23853	35907	37	applied	\N	\N	\N	\N	110778	110778	111138
23853	35909	38	applied	\N	\N	\N	\N	110784	110784	111139
23853	35910	39	applied	\N	\N	\N	\N	110786	110786	111140
23853	35914	40	applied	\N	\N	\N	\N	110798	110798	111141
23853	35915	41	applied	\N	\N	\N	\N	110800	110800	111142
23853	35918	42	applied	\N	\N	\N	\N	110808	110808	111143
23853	35921	43	applied	\N	\N	\N	\N	110819	110819	111144
23853	35923	44	applied	\N	\N	\N	\N	110825	110825	111145
23853	35924	45	applied	\N	\N	\N	\N	110827	110827	111146
23853	35927	46	applied	\N	\N	\N	\N	110937	110937	111147
23853	35929	47	applied	\N	\N	\N	\N	110945	110945	111148
23853	35930	48	applied	\N	\N	\N	\N	110947	110947	111149
23853	35933	49	applied	\N	\N	\N	\N	110955	110955	111150
23853	35935	50	applied	\N	\N	\N	\N	110960	110960	111151
23853	35937	51	applied	\N	\N	\N	\N	110972	110972	111152
23853	35939	52	applied	\N	\N	\N	\N	110977	110977	111153
23853	35941	53	applied	\N	\N	\N	\N	110983	110983	111154
23853	35943	54	applied	\N	\N	\N	\N	110989	110989	111155
23853	35944	55	applied	\N	\N	\N	\N	110991	110991	111156
23853	35947	56	applied	\N	\N	\N	\N	111005	111005	111157
23853	35951	58	applied	\N	\N	\N	\N	111014	111014	111159
23853	35952	59	applied	\N	\N	\N	\N	111016	111016	111160
23853	35955	60	applied	\N	\N	\N	\N	111026	111026	111161
23853	35957	61	applied	\N	\N	\N	\N	111034	111034	111162
23853	35959	62	applied	\N	\N	\N	\N	111041	111041	111163
23853	35960	63	applied	\N	\N	\N	\N	111043	111043	111164
23853	35961	64	applied	\N	\N	\N	\N	111045	111045	111165
23853	35965	65	applied	\N	\N	\N	\N	111057	111057	111166
23853	35967	66	applied	\N	\N	\N	\N	111065	111065	111167
23853	35968	67	applied	\N	\N	\N	\N	111067	111067	111168
23853	35971	68	applied	\N	\N	\N	\N	111075	111075	111169
23853	35973	69	applied	\N	\N	\N	\N	111088	111088	111170
23853	35974	70	applied	\N	\N	\N	\N	111090	111090	111171
23853	35975	71	applied	\N	\N	\N	\N	111092	111092	111172
23853	35976	72	applied	\N	\N	\N	\N	111094	111094	111173
23853	35977	73	applied	\N	\N	\N	\N	111096	111096	111174
23853	35983	74	applied	\N	\N	\N	\N	111111	111111	111175
23853	35984	75	applied	\N	\N	\N	\N	111113	111113	111176
23853	35987	76	applied	\N	\N	\N	\N	111196	111196	111415
23853	35989	77	applied	\N	\N	\N	\N	111200	111200	111416
23853	35991	78	applied	\N	\N	\N	\N	111206	111206	111417
23853	35993	79	applied	\N	\N	\N	\N	111210	111210	111418
23853	35995	80	applied	\N	\N	\N	\N	111214	111214	111419
23853	35997	81	applied	\N	\N	\N	\N	111219	111219	111420
23853	35998	82	applied	\N	\N	\N	\N	111221	111221	111421
23853	35999	83	applied	\N	\N	\N	\N	111223	111223	111422
23853	36000	84	applied	\N	\N	\N	\N	111225	111225	111423
23853	36005	85	applied	\N	\N	\N	\N	111240	111240	111424
23853	36006	86	applied	\N	\N	\N	\N	111242	111242	111425
23853	36009	87	applied	\N	\N	\N	\N	111250	111250	111426
23853	36011	88	applied	\N	\N	\N	\N	111261	111261	111427
23829	36841	0	applied	\N	\N	\N	\N	113795	113795	113796
23829	36842	1	applied	\N	\N	\N	\N	113797	113797	113798
23829	36843	2	applied	\N	\N	\N	\N	113799	113799	113800
23829	36844	3	applied	\N	\N	\N	\N	113801	113801	113802
23829	36845	4	applied	\N	\N	\N	\N	113803	113803	113804
23829	36846	5	applied	\N	\N	\N	\N	113805	113805	113806
23829	36847	6	applied	\N	\N	\N	\N	113807	113807	113808
23833	36841	0	applied	\N	\N	\N	\N	113795	113795	113796
23833	36842	1	applied	\N	\N	\N	\N	113797	113797	113798
23833	36843	2	applied	\N	\N	\N	\N	113799	113799	113800
23833	36844	3	applied	\N	\N	\N	\N	113801	113801	113802
23833	36845	4	applied	\N	\N	\N	\N	113803	113803	113804
23833	36846	5	applied	\N	\N	\N	\N	113805	113805	113806
23833	36847	6	applied	\N	\N	\N	\N	113807	113807	113808
23838	36854	0	applied	\N	\N	\N	\N	113836	113836	113837
23838	36855	1	applied	\N	\N	\N	\N	113838	113838	113839
23838	36856	2	applied	\N	\N	\N	\N	113840	113840	113841
23840	36857	0	applied	\N	\N	\N	\N	113845	113845	113846
23840	36858	1	applied	\N	\N	\N	\N	113847	113847	113848
23840	36859	2	applied	\N	\N	\N	\N	113849	113849	113850
23846	36877	0	applied	\N	\N	\N	\N	113891	113891	113892
23846	36878	1	applied	\N	\N	\N	\N	113893	113893	113894
23846	36879	2	applied	\N	\N	\N	\N	113895	113895	113896
23851	36897	0	applied	\N	\N	\N	\N	113951	113951	113952
23851	36898	1	applied	\N	\N	\N	\N	113953	113953	113954
23851	36899	2	applied	\N	\N	\N	\N	113955	113955	113956
23862	36903	0	applied	\N	\N	\N	\N	113995	113995	113996
23862	36904	1	applied	\N	\N	\N	\N	113997	113997	113998
23862	36910	2	applied	\N	\N	\N	\N	114014	114014	114015
23862	36905	3	applied	\N	\N	\N	\N	113999	113999	114000
23862	36906	4	applied	\N	\N	\N	\N	114001	114001	114002
23862	36907	5	applied	\N	\N	\N	\N	114003	114003	114004
23862	36908	6	applied	\N	\N	\N	\N	114005	114005	114006
23862	36911	7	applied	\N	\N	\N	\N	114016	114016	114017
23862	36909	8	applied	\N	\N	\N	\N	114007	114007	114018
23862	36912	9	applied	\N	\N	\N	\N	114019	114019	114020
23865	36920	0	applied	\N	\N	\N	\N	114039	114039	114040
23865	36921	1	applied	\N	\N	\N	\N	114041	114041	114042
23865	36922	2	applied	\N	\N	\N	\N	114043	114043	114044
23870	36929	0	applied	\N	\N	\N	\N	114063	114063	114064
23870	36930	1	applied	\N	\N	\N	\N	114065	114065	114066
23870	36931	2	applied	\N	\N	\N	\N	114067	114067	114068
23872	36932	0	applied	\N	\N	\N	\N	114072	114072	114073
23872	36933	1	applied	\N	\N	\N	\N	114074	114074	114075
23872	36934	2	applied	\N	\N	\N	\N	114076	114076	114077
23872	36935	3	applied	\N	\N	\N	\N	114078	114078	114079
23872	36936	4	applied	\N	\N	\N	\N	114080	114080	114081
23872	36937	5	applied	\N	\N	\N	\N	114082	114082	114083
23875	36938	0	applied	\N	\N	\N	\N	114088	114088	114089
23875	36939	1	applied	\N	\N	\N	\N	114090	114090	114091
23875	36940	2	applied	\N	\N	\N	\N	114092	114092	114093
23875	36941	3	applied	\N	\N	\N	\N	114094	114094	114095
23875	36942	4	applied	\N	\N	\N	\N	114096	114096	114097
23875	36943	5	applied	\N	\N	\N	\N	114098	114098	114099
23875	36944	6	applied	\N	\N	\N	\N	114100	114100	114101
23875	36945	7	applied	\N	\N	\N	\N	114102	114102	114103
23875	36946	8	applied	\N	\N	\N	\N	114104	114104	114105
23875	36947	9	applied	\N	\N	\N	\N	114106	114106	114107
23877	36794	0	applied	\N	\N	1000000000	\N	113670	113670	113671
23877	36653	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	113110	113110	\N
23877	36603	2	applied	\N	\N	\N	\N	112993	112993	112994
23877	36604	3	applied	\N	\N	\N	\N	112995	112995	112996
23877	36609	4	applied	\N	\N	\N	\N	113010	113010	113011
23877	36610	5	applied	\N	\N	\N	\N	113012	113012	113013
23877	36617	6	applied	\N	\N	\N	\N	113028	113028	113029
23877	36618	7	applied	\N	\N	\N	\N	113030	113030	113031
23877	36624	8	applied	\N	\N	\N	\N	113044	113044	113045
23877	36627	9	applied	\N	\N	\N	\N	113052	113052	113053
23877	36628	10	applied	\N	\N	\N	\N	113054	113054	113055
23877	36634	11	applied	\N	\N	\N	\N	113068	113068	113069
23877	36637	12	applied	\N	\N	\N	\N	113075	113075	113076
23877	36638	13	applied	\N	\N	\N	\N	113077	113077	113078
23877	36639	14	applied	\N	\N	\N	\N	113079	113079	113080
23877	36647	15	applied	\N	\N	\N	\N	113097	113097	113098
23877	36648	16	applied	\N	\N	\N	\N	113099	113099	113100
23877	36654	17	applied	\N	\N	\N	\N	113111	113111	113112
23877	36658	18	applied	\N	\N	\N	\N	113156	113156	113157
23877	36663	19	applied	\N	\N	\N	\N	113171	113171	113172
23877	36667	20	applied	\N	\N	\N	\N	113191	113191	113192
23877	36669	21	applied	\N	\N	\N	\N	113197	113197	113198
23877	36672	22	applied	\N	\N	\N	\N	113205	113205	113206
23877	36673	23	applied	\N	\N	\N	\N	113207	113207	113208
23877	36674	24	applied	\N	\N	\N	\N	113209	113209	113210
23877	36675	25	applied	\N	\N	\N	\N	113211	113211	113212
23877	36676	26	applied	\N	\N	\N	\N	113213	113213	113214
23877	36677	27	applied	\N	\N	\N	\N	113215	113215	113216
23877	36678	28	applied	\N	\N	\N	\N	113217	113217	113218
23877	36695	29	applied	\N	\N	\N	\N	113253	113253	113254
23877	36696	30	applied	\N	\N	\N	\N	113255	113255	113256
23877	36702	31	applied	\N	\N	\N	\N	113290	113290	113291
23877	36705	32	applied	\N	\N	\N	\N	113304	113304	113305
23877	36708	33	applied	\N	\N	\N	\N	113348	113348	113349
23877	36712	34	applied	\N	\N	\N	\N	113408	113408	113409
23877	36713	35	applied	\N	\N	\N	\N	113410	113410	113411
23877	36718	36	applied	\N	\N	\N	\N	113446	113446	113447
23877	36719	37	applied	\N	\N	\N	\N	113448	113448	113449
23877	36725	38	applied	\N	\N	\N	\N	113464	113464	113465
23877	36728	39	applied	\N	\N	\N	\N	113472	113472	113473
23877	36732	41	applied	\N	\N	\N	\N	113483	113483	113484
23877	36735	42	applied	\N	\N	\N	\N	113493	113493	113494
23877	36738	43	applied	\N	\N	\N	\N	113505	113505	113506
23877	36739	44	applied	\N	\N	\N	\N	113507	113507	113508
23877	36745	45	applied	\N	\N	\N	\N	113521	113521	113522
23877	36748	46	applied	\N	\N	\N	\N	113531	113531	113532
23877	36751	47	applied	\N	\N	\N	\N	113539	113539	113540
23877	36757	48	applied	\N	\N	\N	\N	113555	113555	113556
23877	36758	49	applied	\N	\N	\N	\N	113557	113557	113558
23877	36763	50	applied	\N	\N	\N	\N	113572	113572	113573
23877	36765	51	applied	\N	\N	\N	\N	113583	113583	113584
23877	36768	52	applied	\N	\N	\N	\N	113594	113594	113595
23877	36771	53	applied	\N	\N	\N	\N	113605	113605	113606
23877	36774	54	applied	\N	\N	\N	\N	113621	113621	113622
23877	36775	55	applied	\N	\N	\N	\N	113623	113623	113624
23877	36781	56	applied	\N	\N	\N	\N	113639	113639	113640
23877	36784	57	applied	\N	\N	\N	\N	113648	113648	113649
23877	36788	58	applied	\N	\N	\N	\N	113656	113656	113657
23877	36789	59	applied	\N	\N	\N	\N	113658	113658	113659
23877	36795	60	applied	\N	\N	\N	\N	113672	113672	113673
23877	36799	61	applied	\N	\N	\N	\N	113682	113682	113683
23843	36875	5	applied	\N	\N	\N	\N	113885	113885	113886
23843	36876	6	applied	\N	\N	\N	\N	113887	113887	113888
23848	36880	0	applied	\N	\N	\N	\N	113911	113911	113912
23848	36881	1	applied	\N	\N	\N	\N	113913	113913	113914
23848	36882	2	applied	\N	\N	\N	\N	113915	113915	113916
23848	36883	3	applied	\N	\N	\N	\N	113917	113917	113918
23848	36884	4	applied	\N	\N	\N	\N	113919	113919	113920
23848	36885	5	applied	\N	\N	\N	\N	113921	113921	113922
23848	36886	6	applied	\N	\N	\N	\N	113923	113923	113924
23848	36887	7	applied	\N	\N	\N	\N	113925	113925	113926
23848	36888	8	applied	\N	\N	\N	\N	113927	113927	113928
23848	36889	9	applied	\N	\N	\N	\N	113929	113929	113930
23860	36903	0	applied	\N	\N	\N	\N	113995	113995	113996
23860	36904	1	applied	\N	\N	\N	\N	113997	113997	113998
23860	36905	2	applied	\N	\N	\N	\N	113999	113999	114000
23860	36906	3	applied	\N	\N	\N	\N	114001	114001	114002
23860	36907	4	applied	\N	\N	\N	\N	114003	114003	114004
23860	36908	5	applied	\N	\N	\N	\N	114005	114005	114006
23860	36909	6	applied	\N	\N	\N	\N	114007	114007	114008
23867	36920	0	applied	\N	\N	\N	\N	114039	114039	114040
23867	36921	1	applied	\N	\N	\N	\N	114041	114041	114042
23867	36922	2	applied	\N	\N	\N	\N	114043	114043	114044
23876	36932	0	applied	\N	\N	\N	\N	114072	114072	114073
23876	36933	1	applied	\N	\N	\N	\N	114074	114074	114075
23876	36938	2	applied	\N	\N	\N	\N	114088	114088	114089
23876	36939	3	applied	\N	\N	\N	\N	114090	114090	114091
23876	36940	4	applied	\N	\N	\N	\N	114092	114092	114093
23876	36948	5	applied	\N	\N	\N	\N	114110	114110	114111
23876	36934	6	applied	\N	\N	\N	\N	114076	114076	114077
23876	36935	7	applied	\N	\N	\N	\N	114078	114078	114079
23876	36936	8	applied	\N	\N	\N	\N	114080	114080	114081
23876	36944	9	applied	\N	\N	\N	\N	114100	114100	114112
23876	36949	10	applied	\N	\N	\N	\N	114113	114113	114083
23876	36937	11	applied	\N	\N	\N	\N	114082	114082	114095
23876	36941	12	applied	\N	\N	\N	\N	114094	114094	114097
23876	36942	13	applied	\N	\N	\N	\N	114096	114096	114099
23876	36943	14	applied	\N	\N	\N	\N	114098	114098	114114
23876	36950	15	applied	\N	\N	\N	\N	114115	114115	114103
23876	36945	16	applied	\N	\N	\N	\N	114102	114102	114105
23876	36946	17	applied	\N	\N	\N	\N	114104	114104	114107
23876	36947	18	applied	\N	\N	\N	\N	114106	114106	114116
23876	36951	19	applied	\N	\N	\N	\N	114117	114117	114118
23882	36971	0	applied	\N	\N	\N	\N	114184	114184	114185
23882	36972	1	applied	\N	\N	\N	\N	114186	114186	114187
23882	36973	2	applied	\N	\N	\N	\N	114188	114188	114189
23882	36974	3	applied	\N	\N	\N	\N	114190	114190	114191
23882	36975	4	applied	\N	\N	\N	\N	114192	114192	114193
23882	36976	5	applied	\N	\N	\N	\N	114194	114194	114195
23882	36977	6	applied	\N	\N	\N	\N	114196	114196	114197
23885	36981	0	applied	\N	\N	\N	\N	114208	114208	114209
23885	36982	1	applied	\N	\N	\N	\N	114210	114210	114211
23885	36983	2	applied	\N	\N	\N	\N	114212	114212	114213
23885	36984	3	applied	\N	\N	\N	\N	114214	114214	114215
23885	36985	4	applied	\N	\N	\N	\N	114216	114216	114217
23885	36986	5	applied	\N	\N	\N	\N	114218	114218	114219
23885	36987	6	applied	\N	\N	\N	\N	114220	114220	114221
23888	36999	0	applied	\N	\N	\N	\N	114249	114249	114250
23888	37000	2	applied	\N	\N	\N	\N	114252	114252	114253
23888	37001	3	applied	\N	\N	\N	\N	114254	114254	114255
23893	37002	0	applied	\N	\N	\N	\N	114261	114261	114262
23893	37003	1	applied	\N	\N	\N	\N	114263	114263	114264
23893	37004	2	applied	\N	\N	\N	\N	114265	114265	114266
23896	37005	0	applied	\N	\N	\N	\N	114274	114274	114275
23896	37006	1	applied	\N	\N	\N	\N	114276	114276	114277
23896	37007	2	applied	\N	\N	\N	\N	114278	114278	114279
23896	37008	3	applied	\N	\N	\N	\N	114280	114280	114281
23898	37009	0	applied	\N	\N	\N	\N	114285	114285	114286
23898	37010	1	applied	\N	\N	\N	\N	114287	114287	114288
23898	37011	2	applied	\N	\N	\N	\N	114289	114289	114290
23902	37012	0	applied	\N	\N	\N	\N	114293	114293	114294
23902	37013	1	applied	\N	\N	\N	\N	114295	114295	114296
23902	37014	2	applied	\N	\N	\N	\N	114297	114297	114298
23905	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23905	37016	1	applied	\N	\N	\N	\N	114310	114310	114311
23905	37017	2	applied	\N	\N	\N	\N	114312	114312	114313
23905	37018	3	applied	\N	\N	\N	\N	114314	114314	114315
23910	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23910	37016	1	applied	\N	\N	\N	\N	114310	114310	114323
23910	37017	2	applied	\N	\N	\N	\N	114312	114312	114315
23918	37042	0	applied	\N	\N	\N	\N	114480	114480	114481
23918	37043	1	applied	\N	\N	\N	\N	114482	114482	114483
23918	37044	2	applied	\N	\N	\N	\N	114484	114484	114485
23918	37045	3	applied	\N	\N	\N	\N	114486	114486	114487
23918	37046	4	applied	\N	\N	\N	\N	114488	114488	114489
23918	37047	5	applied	\N	\N	\N	\N	114490	114490	114491
23918	37048	6	applied	\N	\N	\N	\N	114492	114492	114493
23918	37049	7	applied	\N	\N	\N	\N	114494	114494	114495
23918	37050	8	applied	\N	\N	\N	\N	114496	114496	114497
23918	37051	9	applied	\N	\N	\N	\N	114498	114498	23829
23918	37052	10	applied	\N	\N	\N	\N	114499	114499	114500
23920	37056	0	applied	\N	\N	\N	\N	114509	114509	114510
23920	37057	1	applied	\N	\N	\N	\N	114511	114511	114512
23920	37058	2	applied	\N	\N	\N	\N	114513	114513	114514
23920	37059	3	applied	\N	\N	\N	\N	114515	114515	114516
23923	37060	0	applied	\N	\N	\N	\N	114518	114518	114519
23923	37061	1	applied	\N	\N	\N	\N	114520	114520	114521
23923	37062	2	applied	\N	\N	\N	\N	114522	114522	114523
23925	37063	0	applied	\N	\N	\N	\N	114530	114530	114531
23925	37064	1	applied	\N	\N	\N	\N	114532	114532	114533
23925	37065	2	applied	\N	\N	\N	\N	114534	114534	114535
23927	37066	0	applied	\N	\N	\N	\N	114538	114538	114539
23927	37067	1	applied	\N	\N	\N	\N	114540	114540	114541
23927	37068	2	applied	\N	\N	\N	\N	114542	114542	114543
23931	37083	0	applied	\N	\N	\N	\N	114582	114582	114583
23931	37084	1	applied	\N	\N	\N	\N	114584	114584	114585
23931	37085	2	applied	\N	\N	\N	\N	114586	114586	114587
23933	37086	0	applied	\N	\N	\N	\N	114589	114589	114590
23933	37087	1	applied	\N	\N	\N	\N	114591	114591	114592
23933	37088	2	applied	\N	\N	\N	\N	114593	114593	114594
23939	37093	0	applied	\N	\N	\N	\N	114610	114610	114611
23939	37090	1	applied	\N	\N	\N	\N	114599	114599	114602
23939	37094	2	applied	\N	\N	\N	\N	114612	114612	114608
23939	37092	3	applied	\N	\N	\N	\N	114603	114603	114613
23939	37095	4	applied	\N	\N	\N	\N	114615	114615	114616
23943	37102	0	applied	\N	\N	\N	\N	114635	114635	114636
23943	37103	1	applied	\N	\N	\N	\N	114637	114637	114638
23943	37104	2	applied	\N	\N	\N	\N	114639	114639	114640
23946	37102	0	applied	\N	\N	\N	\N	114635	114635	114636
23946	37103	1	applied	\N	\N	\N	\N	114637	114637	114638
23946	37104	2	applied	\N	\N	\N	\N	114639	114639	114640
23847	36182	37	applied	\N	\N	\N	\N	112399	112399	111822
23847	36183	38	applied	\N	\N	\N	\N	112400	112400	111824
23847	36332	39	applied	\N	\N	\N	\N	113908	113908	113908
23847	36075	40	applied	\N	\N	\N	\N	111514	111514	111515
23847	36078	41	applied	\N	\N	\N	\N	111523	111523	111524
23847	36081	42	applied	\N	\N	\N	\N	111531	111531	111532
23847	36085	43	applied	\N	\N	\N	\N	111544	111544	111545
23847	36088	44	applied	\N	\N	\N	\N	111552	111552	111553
23847	36091	45	applied	\N	\N	\N	\N	111565	111565	111566
23847	36092	46	applied	\N	\N	\N	\N	111567	111567	111568
23847	36093	47	applied	\N	\N	\N	\N	111569	111569	111570
23847	36101	48	applied	\N	\N	\N	\N	111587	111587	111588
23847	36104	49	applied	\N	\N	\N	\N	111594	111594	111595
23847	36107	50	applied	\N	\N	\N	\N	111604	111604	111605
23847	36108	51	applied	\N	\N	\N	\N	111606	111606	111607
23847	36113	52	applied	\N	\N	\N	\N	111620	111620	111621
23847	36117	53	applied	\N	\N	\N	\N	111629	111629	111630
23847	36120	54	applied	\N	\N	\N	\N	111640	111640	111641
23847	36121	55	applied	\N	\N	\N	\N	111642	111642	111643
23847	36126	56	applied	\N	\N	\N	\N	111656	111656	111657
23847	36130	57	applied	\N	\N	\N	\N	111678	111678	111679
23847	36133	58	applied	\N	\N	\N	\N	111684	111684	111685
23847	36134	59	applied	\N	\N	\N	\N	111686	111686	111687
23847	36140	60	applied	\N	\N	\N	\N	111701	111701	111702
23847	36143	61	applied	\N	\N	\N	\N	111711	111711	111712
23847	36146	62	applied	\N	\N	\N	\N	111721	111721	111722
23847	36151	63	applied	\N	\N	\N	\N	111737	111737	111738
23847	36155	64	applied	\N	\N	\N	\N	111751	111751	111752
23847	36158	65	applied	\N	\N	\N	\N	111761	111761	111762
23847	36162	66	applied	\N	\N	\N	\N	111772	111772	111773
23847	36163	67	applied	\N	\N	\N	\N	111774	111774	111775
23847	36164	68	applied	\N	\N	\N	\N	111776	111776	111777
23847	36172	69	applied	\N	\N	\N	\N	111798	111798	111799
23847	36175	70	applied	\N	\N	\N	\N	111806	111806	111807
23847	36178	71	applied	\N	\N	\N	\N	111813	111813	111814
23847	36179	72	applied	\N	\N	\N	\N	111815	111815	111816
23847	36180	73	applied	\N	\N	\N	\N	111817	111817	111818
23847	36193	74	applied	\N	\N	\N	\N	111848	111848	111849
23847	36196	75	applied	\N	\N	\N	\N	111856	111856	111857
23847	36200	76	applied	\N	\N	\N	\N	111867	111867	111868
23847	36205	77	applied	\N	\N	\N	\N	111881	111881	111882
23847	36206	78	applied	\N	\N	\N	\N	111883	111883	111884
23847	36212	79	applied	\N	\N	\N	\N	111897	111897	111898
23847	36213	80	applied	\N	\N	\N	\N	111899	111899	111900
23847	36184	81	applied	\N	\N	\N	\N	112402	112402	111826
23847	36185	82	applied	\N	\N	\N	\N	112403	112403	111828
23847	36203	83	applied	\N	\N	\N	\N	112404	112404	111876
23847	36204	84	applied	\N	\N	\N	\N	112044	112044	111878
23847	36214	85	applied	\N	\N	\N	\N	111901	111901	111902
23847	36222	86	applied	\N	\N	\N	\N	111920	111920	111921
23847	36225	87	applied	\N	\N	\N	\N	111932	111932	111933
23847	36228	88	applied	\N	\N	\N	\N	111939	111939	111940
23847	36231	89	applied	\N	\N	\N	\N	111947	111947	111948
23847	36235	90	applied	\N	\N	\N	\N	111956	111956	111957
23847	36238	91	applied	\N	\N	\N	\N	111964	111964	111965
23847	36239	92	applied	\N	\N	\N	\N	111966	111966	111967
23847	36245	93	applied	\N	\N	\N	\N	111982	111982	111983
23847	36246	94	applied	\N	\N	\N	\N	111984	111984	111985
23847	36251	95	applied	\N	\N	\N	\N	112000	112000	112001
23847	36257	96	applied	\N	\N	\N	\N	112018	112018	112019
23847	36258	97	applied	\N	\N	\N	\N	112020	112020	112021
23847	36263	98	applied	\N	\N	\N	\N	112032	112032	112033
23847	36268	99	applied	\N	\N	\N	\N	112045	112045	112046
23847	36271	100	applied	\N	\N	\N	\N	112056	112056	112057
23847	36272	101	applied	\N	\N	\N	\N	112058	112058	112059
23847	36277	102	applied	\N	\N	\N	\N	112072	112072	112073
23847	36281	103	applied	\N	\N	\N	\N	112080	112080	112081
23847	36284	104	applied	\N	\N	\N	\N	112090	112090	112091
23847	36288	105	applied	\N	\N	\N	\N	112104	112104	112105
23847	36292	106	applied	\N	\N	\N	\N	112113	112113	112114
23847	36295	107	applied	\N	\N	\N	\N	112123	112123	112124
23847	36298	108	applied	\N	\N	\N	\N	112130	112130	112131
23847	36302	109	applied	\N	\N	\N	\N	112143	112143	112144
23847	36305	110	applied	\N	\N	\N	\N	112152	112152	112153
23847	36308	111	applied	\N	\N	\N	\N	112159	112159	112160
23847	36312	112	applied	\N	\N	\N	\N	112169	112169	112170
23847	36313	113	applied	\N	\N	\N	\N	112171	112171	112172
23847	36318	114	applied	\N	\N	\N	\N	112192	112192	112193
23847	36319	115	applied	\N	\N	\N	\N	112194	112194	112195
23847	36325	116	applied	\N	\N	\N	\N	112208	112208	112209
23847	36333	117	applied	\N	\N	\N	\N	112240	112240	112241
23847	36334	118	applied	\N	\N	\N	\N	112242	112242	112243
23847	36341	119	applied	\N	\N	\N	\N	112258	112258	112259
23847	36344	120	applied	\N	\N	\N	\N	112267	112267	112268
23847	36347	121	applied	\N	\N	\N	\N	112292	112292	112293
23847	36350	122	applied	\N	\N	\N	\N	112300	112300	112301
23847	36351	123	applied	\N	\N	\N	\N	112302	112302	112303
23847	36352	124	applied	\N	\N	\N	\N	112304	112304	112305
23847	36360	125	applied	\N	\N	\N	\N	112324	112324	112325
23849	36890	0	applied	\N	\N	\N	\N	113933	113933	113934
23849	36891	1	applied	\N	\N	\N	\N	113935	113935	113936
23849	36892	2	applied	\N	\N	\N	\N	113937	113937	113938
23852	36897	0	applied	\N	\N	\N	\N	113951	113951	113952
23852	36898	1	applied	\N	\N	\N	\N	113953	113953	113954
23852	36899	2	applied	\N	\N	\N	\N	113955	113955	113956
23854	36900	0	applied	\N	\N	\N	\N	113983	113983	113984
23854	36901	1	applied	\N	\N	\N	\N	113985	113985	113986
23854	36902	2	applied	\N	\N	\N	\N	113987	113987	113988
23859	36903	0	applied	\N	\N	\N	\N	113995	113995	113996
23859	36904	1	applied	\N	\N	\N	\N	113997	113997	113998
23859	36905	2	applied	\N	\N	\N	\N	113999	113999	114000
23859	36906	3	applied	\N	\N	\N	\N	114001	114001	114002
23859	36907	4	applied	\N	\N	\N	\N	114003	114003	114004
23859	36908	5	applied	\N	\N	\N	\N	114005	114005	114006
23859	36909	6	applied	\N	\N	\N	\N	114007	114007	114008
23863	36903	0	applied	\N	\N	\N	\N	113995	113995	113996
23863	36904	1	applied	\N	\N	\N	\N	113997	113997	113998
23863	36910	2	applied	\N	\N	\N	\N	114014	114014	114015
23863	36905	3	applied	\N	\N	\N	\N	113999	113999	114000
23863	36906	4	applied	\N	\N	\N	\N	114001	114001	114002
23863	36907	5	applied	\N	\N	\N	\N	114003	114003	114004
23863	36908	6	applied	\N	\N	\N	\N	114005	114005	114006
23863	36911	7	applied	\N	\N	\N	\N	114016	114016	114017
23863	36909	8	applied	\N	\N	\N	\N	114007	114007	114018
23863	36912	9	applied	\N	\N	\N	\N	114019	114019	114020
23866	36920	0	applied	\N	\N	\N	\N	114039	114039	114040
23866	36921	1	applied	\N	\N	\N	\N	114041	114041	114042
23866	36922	2	applied	\N	\N	\N	\N	114043	114043	114044
23868	36923	0	applied	\N	\N	\N	\N	114049	114049	114050
23868	36924	1	applied	\N	\N	\N	\N	114051	114051	114052
23853	36013	89	applied	\N	\N	\N	\N	111267	111267	111428
23853	36015	90	applied	\N	\N	\N	\N	111274	111274	111429
23853	36016	91	applied	\N	\N	\N	\N	111276	111276	111430
23853	36019	92	applied	\N	\N	\N	\N	111288	111288	111431
23853	36022	93	applied	\N	\N	\N	\N	111297	111297	111432
23853	36024	94	applied	\N	\N	\N	\N	111302	111302	111433
23853	36026	95	applied	\N	\N	\N	\N	111308	111308	111434
23853	36027	96	applied	\N	\N	\N	\N	111310	111310	111435
23853	36028	97	applied	\N	\N	\N	\N	111312	111312	111436
23853	36032	98	applied	\N	\N	\N	\N	111321	111321	111437
23853	36034	99	applied	\N	\N	\N	\N	111329	111329	111438
23853	36036	100	applied	\N	\N	\N	\N	111335	111335	111439
23853	36038	101	applied	\N	\N	\N	\N	111344	111344	111440
23853	36040	102	applied	\N	\N	\N	\N	111352	111352	111441
23853	36042	103	applied	\N	\N	\N	\N	111362	111362	111442
23853	36044	104	applied	\N	\N	\N	\N	111368	111368	111443
23853	36046	105	applied	\N	\N	\N	\N	111378	111378	111444
23853	36048	107	applied	\N	\N	\N	\N	111384	111384	111445
23853	36050	108	applied	\N	\N	\N	\N	111394	111394	111446
23853	36053	109	applied	\N	\N	\N	\N	111402	111402	111447
23853	36056	110	applied	\N	\N	\N	\N	111470	111470	113965
23853	36057	111	applied	\N	\N	\N	\N	111472	111472	113966
23853	36058	112	applied	\N	\N	\N	\N	111474	111474	113967
23853	36065	113	applied	\N	\N	\N	\N	111490	111490	113968
23853	36066	114	applied	\N	\N	\N	\N	111492	111492	113969
23853	36071	115	applied	\N	\N	\N	\N	111504	111504	113970
23853	36075	116	applied	\N	\N	\N	\N	111514	111514	113971
23853	36078	117	applied	\N	\N	\N	\N	111523	111523	113972
23853	36081	118	applied	\N	\N	\N	\N	111531	111531	113973
23853	36085	119	applied	\N	\N	\N	\N	111544	111544	113974
23853	36088	120	applied	\N	\N	\N	\N	111552	111552	113975
23853	36091	121	applied	\N	\N	\N	\N	111565	111565	113976
23853	36092	122	applied	\N	\N	\N	\N	111567	111567	113977
23853	36093	123	applied	\N	\N	\N	\N	111569	111569	113978
23853	36101	124	applied	\N	\N	\N	\N	111587	111587	113979
23853	36104	125	applied	\N	\N	\N	\N	111594	111594	113980
23861	36903	0	applied	\N	\N	\N	\N	113995	113995	113996
23861	36904	1	applied	\N	\N	\N	\N	113997	113997	113998
23861	36905	2	applied	\N	\N	\N	\N	113999	113999	114000
23861	36906	3	applied	\N	\N	\N	\N	114001	114001	114002
23861	36907	4	applied	\N	\N	\N	\N	114003	114003	114004
23861	36908	5	applied	\N	\N	\N	\N	114005	114005	114006
23861	36909	6	applied	\N	\N	\N	\N	114007	114007	114008
23864	36913	0	applied	\N	\N	\N	\N	114023	114023	114024
23864	36914	1	applied	\N	\N	\N	\N	114025	114025	114026
23864	36915	2	applied	\N	\N	\N	\N	114027	114027	114028
23864	36916	3	applied	\N	\N	\N	\N	114029	114029	114030
23864	36917	4	applied	\N	\N	\N	\N	114031	114031	114032
23864	36918	5	applied	\N	\N	\N	\N	114033	114033	114034
23864	36919	6	applied	\N	\N	\N	\N	114035	114035	114036
23869	36929	0	applied	\N	\N	\N	\N	114063	114063	114064
23869	36930	1	applied	\N	\N	\N	\N	114065	114065	114066
23869	36931	2	applied	\N	\N	\N	\N	114067	114067	114068
23879	36948	0	applied	\N	\N	\N	\N	114110	114110	114111
23879	36952	1	applied	\N	\N	\N	\N	114137	114137	114138
23879	36949	2	applied	\N	\N	\N	\N	114113	114113	114139
23879	36950	3	applied	\N	\N	\N	\N	114115	114115	114116
23879	36953	4	applied	\N	\N	\N	\N	114140	114140	114141
23879	36951	5	applied	\N	\N	\N	\N	114117	114117	114142
23879	36954	6	applied	\N	\N	\N	\N	114143	114143	114144
23883	36978	0	applied	\N	\N	\N	\N	114200	114200	114201
23883	36979	1	applied	\N	\N	\N	\N	114202	114202	114203
23883	36980	2	applied	\N	\N	\N	\N	114204	114204	114205
23889	36999	0	applied	\N	\N	\N	\N	114249	114249	114250
23889	37000	2	applied	\N	\N	\N	\N	114252	114252	114253
23889	37001	3	applied	\N	\N	\N	\N	114254	114254	114255
23891	37002	0	applied	\N	\N	\N	\N	114261	114261	114262
23891	37003	1	applied	\N	\N	\N	\N	114263	114263	114264
23891	37004	2	applied	\N	\N	\N	\N	114265	114265	114266
23894	37004	0	applied	\N	\N	\N	\N	114265	114265	114270
23897	37007	0	applied	\N	\N	\N	\N	114278	114278	114283
23899	37012	0	applied	\N	\N	\N	\N	114293	114293	114294
23899	37013	1	applied	\N	\N	\N	\N	114295	114295	114296
23899	37014	2	applied	\N	\N	\N	\N	114297	114297	114298
23907	37018	0	applied	\N	\N	\N	\N	114314	114314	114319
23912	37020	0	applied	\N	\N	\N	\N	114331	114331	114332
23912	37021	1	applied	\N	\N	\N	\N	114333	114333	114334
23912	37022	2	applied	\N	\N	\N	\N	114335	114335	114336
23912	37023	3	applied	\N	\N	\N	\N	114337	114337	114338
23912	37024	4	applied	\N	\N	\N	\N	114339	114339	114340
23912	37025	5	applied	\N	\N	\N	\N	114341	114341	114342
23912	37026	6	applied	\N	\N	\N	\N	114343	114343	114344
23914	37027	0	applied	\N	\N	\N	\N	114348	114348	114349
23914	37028	1	applied	\N	\N	\N	\N	114350	114350	114351
23914	37029	2	applied	\N	\N	\N	\N	114352	114352	114353
23915	37030	0	applied	\N	\N	\N	\N	114356	114356	114357
23915	37031	1	applied	\N	\N	\N	\N	114358	114358	114359
23915	37032	2	applied	\N	\N	\N	\N	114360	114360	114361
23915	37033	3	applied	\N	\N	\N	\N	114362	114362	114363
23915	37034	4	applied	\N	\N	\N	\N	114364	114364	114365
23915	37035	5	applied	\N	\N	\N	\N	114366	114366	114367
23915	37036	6	applied	\N	\N	\N	\N	114368	114368	114369
23915	37037	7	applied	\N	\N	\N	\N	114370	114370	114371
23915	37038	8	applied	\N	\N	\N	\N	114372	114372	114373
23915	37039	9	applied	\N	\N	\N	\N	114374	114374	114375
23915	37040	10	applied	\N	\N	\N	\N	114376	114376	114377
23915	37041	11	applied	\N	\N	\N	\N	114378	114378	114379
23936	37089	0	applied	\N	\N	\N	\N	114597	114597	114598
23936	37090	1	applied	\N	\N	\N	\N	114599	114599	114600
23936	37092	2	applied	\N	\N	\N	\N	114603	114603	114608
23938	37093	0	applied	\N	\N	\N	\N	114610	114610	114611
23938	37090	1	applied	\N	\N	\N	\N	114599	114599	114602
23938	37094	2	applied	\N	\N	\N	\N	114612	114612	114608
23938	37092	3	applied	\N	\N	\N	\N	114603	114603	114613
23938	37095	4	applied	\N	\N	\N	\N	114615	114615	114616
23950	37105	0	applied	\N	\N	\N	\N	114650	114650	114651
23950	37106	1	applied	\N	\N	\N	\N	114652	114652	114653
23950	37107	2	applied	\N	\N	\N	\N	114654	114654	114655
23950	37108	3	applied	\N	\N	\N	\N	114656	114656	114657
23950	37109	4	applied	\N	\N	\N	\N	114658	114658	114659
23950	37110	5	applied	\N	\N	\N	\N	114660	114660	114661
23951	37105	0	applied	\N	\N	\N	\N	114650	114650	114651
23951	37106	1	applied	\N	\N	\N	\N	114652	114652	114653
23951	37111	2	applied	\N	\N	\N	\N	114665	114665	114666
23951	37107	3	applied	\N	\N	\N	\N	114654	114654	114655
23951	37108	4	applied	\N	\N	\N	\N	114656	114656	114657
23951	37112	5	applied	\N	\N	\N	\N	114667	114667	114668
23951	37109	6	applied	\N	\N	\N	\N	114658	114658	114669
23951	37110	7	applied	\N	\N	\N	\N	114660	114660	114670
23951	37113	8	applied	\N	\N	\N	\N	114671	114671	114672
23868	36925	2	applied	\N	\N	\N	\N	114053	114053	114054
23868	36926	3	applied	\N	\N	\N	\N	114055	114055	114056
23868	36927	4	applied	\N	\N	\N	\N	114057	114057	114058
23868	36928	5	applied	\N	\N	\N	\N	114059	114059	114060
23871	36929	0	applied	\N	\N	\N	\N	114063	114063	114064
23871	36930	1	applied	\N	\N	\N	\N	114065	114065	114066
23871	36931	2	applied	\N	\N	\N	\N	114067	114067	114068
23873	36932	0	applied	\N	\N	\N	\N	114072	114072	114073
23873	36933	1	applied	\N	\N	\N	\N	114074	114074	114075
23873	36934	2	applied	\N	\N	\N	\N	114076	114076	114077
23873	36935	3	applied	\N	\N	\N	\N	114078	114078	114079
23873	36936	4	applied	\N	\N	\N	\N	114080	114080	114081
23873	36937	5	applied	\N	\N	\N	\N	114082	114082	114083
23881	36962	0	applied	\N	\N	\N	\N	114165	114165	114166
23881	36963	1	applied	\N	\N	\N	\N	114167	114167	114168
23881	36964	2	applied	\N	\N	\N	\N	114169	114169	114170
23881	36965	3	applied	\N	\N	\N	\N	114171	114171	114172
23881	36966	4	applied	\N	\N	\N	\N	114173	114173	114174
23881	36967	5	applied	\N	\N	\N	\N	114175	114175	114176
23881	36968	6	applied	\N	\N	\N	\N	114177	114177	114178
23881	36969	7	applied	\N	\N	\N	\N	114179	114179	114180
23881	36970	8	applied	\N	\N	\N	\N	114181	114181	114182
23887	36991	0	applied	\N	\N	\N	\N	114231	114231	114232
23887	36992	1	applied	\N	\N	\N	\N	114233	114233	114234
23887	36993	2	applied	\N	\N	\N	\N	114235	114235	114236
23887	36994	3	applied	\N	\N	1000000000	\N	114237	114237	114238
23887	36995	4	applied	\N	\N	\N	\N	114239	114239	114240
23887	36996	5	applied	\N	\N	\N	\N	114241	114241	114242
23887	36997	6	applied	\N	\N	\N	\N	114243	114243	114244
23887	36998	7	applied	\N	\N	\N	\N	114245	114245	114246
23890	36999	0	applied	\N	\N	\N	\N	114249	114249	114250
23890	37000	2	applied	\N	\N	\N	\N	114252	114252	114253
23890	37001	3	applied	\N	\N	\N	\N	114254	114254	114255
23901	37012	0	applied	\N	\N	\N	\N	114293	114293	114294
23901	37013	1	applied	\N	\N	\N	\N	114295	114295	114296
23901	37014	2	applied	\N	\N	\N	\N	114297	114297	114298
23904	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23904	37016	1	applied	\N	\N	\N	\N	114310	114310	114311
23904	37017	2	applied	\N	\N	\N	\N	114312	114312	114313
23904	37018	3	applied	\N	\N	\N	\N	114314	114314	114315
23906	37018	0	applied	\N	\N	\N	\N	114314	114314	114319
23909	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23909	37016	1	applied	\N	\N	\N	\N	114310	114310	114323
23909	37017	2	applied	\N	\N	\N	\N	114312	114312	114315
23911	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23911	37016	1	applied	\N	\N	\N	\N	114310	114310	114323
23911	37019	2	applied	\N	\N	\N	\N	114324	114324	114313
23911	37017	3	applied	\N	\N	\N	\N	114312	114312	114325
23917	37042	0	applied	\N	\N	\N	\N	114480	114480	114481
23917	37043	1	applied	\N	\N	\N	\N	114482	114482	114483
23917	37044	2	applied	\N	\N	\N	\N	114484	114484	114485
23917	37045	3	applied	\N	\N	\N	\N	114486	114486	114487
23917	37046	4	applied	\N	\N	\N	\N	114488	114488	114489
23917	37047	5	applied	\N	\N	\N	\N	114490	114490	114491
23917	37048	6	applied	\N	\N	\N	\N	114492	114492	114493
23917	37049	7	applied	\N	\N	\N	\N	114494	114494	114495
23917	37050	8	applied	\N	\N	\N	\N	114496	114496	114497
23917	37051	9	applied	\N	\N	\N	\N	114498	114498	23829
23917	37052	10	applied	\N	\N	\N	\N	114499	114499	114500
23919	37053	0	applied	\N	\N	\N	\N	114503	114503	114504
23919	37054	1	applied	\N	\N	\N	\N	114505	114505	114506
23919	37055	2	applied	\N	\N	\N	\N	114507	114507	114508
23922	37060	0	applied	\N	\N	\N	\N	114518	114518	114519
23922	37061	1	applied	\N	\N	\N	\N	114520	114520	114521
23922	37062	2	applied	\N	\N	\N	\N	114522	114522	114523
23924	37063	0	applied	\N	\N	\N	\N	114530	114530	114531
23924	37064	1	applied	\N	\N	\N	\N	114532	114532	114533
23924	37065	2	applied	\N	\N	\N	\N	114534	114534	114535
23926	37066	0	applied	\N	\N	\N	\N	114538	114538	114539
23926	37067	1	applied	\N	\N	\N	\N	114540	114540	114541
23926	37068	2	applied	\N	\N	\N	\N	114542	114542	114543
23929	37073	0	applied	\N	\N	\N	\N	114557	114557	114558
23929	37074	1	applied	\N	\N	\N	\N	114559	114559	114560
23929	37075	2	applied	\N	\N	\N	\N	114561	114561	114562
23929	37076	3	applied	\N	\N	\N	\N	114563	114563	114564
23932	37083	0	applied	\N	\N	\N	\N	114582	114582	114583
23932	37084	1	applied	\N	\N	\N	\N	114584	114584	114585
23932	37085	2	applied	\N	\N	\N	\N	114586	114586	114587
23934	37089	0	applied	\N	\N	\N	\N	114597	114597	114598
23934	37090	1	applied	\N	\N	\N	\N	114599	114599	114600
23934	37091	2	applied	\N	\N	\N	\N	114601	114601	114602
23934	37092	3	applied	\N	\N	\N	\N	114603	114603	114604
23940	37093	0	applied	\N	\N	\N	\N	114610	114610	114611
23940	37090	1	applied	\N	\N	\N	\N	114599	114599	114602
23940	37094	2	applied	\N	\N	\N	\N	114612	114612	114608
23940	37092	3	applied	\N	\N	\N	\N	114603	114603	114613
23940	37095	4	applied	\N	\N	\N	\N	114615	114615	114616
23941	37096	0	applied	\N	\N	\N	\N	114621	114621	114622
23941	37097	1	applied	\N	\N	\N	\N	114623	114623	114624
23941	37098	2	applied	\N	\N	\N	\N	114625	114625	114626
23941	37099	3	applied	\N	\N	\N	\N	114627	114627	114628
23941	37100	4	applied	\N	\N	\N	\N	114629	114629	114630
23941	37101	5	applied	\N	\N	\N	\N	114631	114631	114632
23944	37102	0	applied	\N	\N	\N	\N	114635	114635	114636
23944	37103	1	applied	\N	\N	\N	\N	114637	114637	114638
23944	37104	2	applied	\N	\N	\N	\N	114639	114639	114640
23947	37102	0	applied	\N	\N	\N	\N	114635	114635	114636
23947	37103	1	applied	\N	\N	\N	\N	114637	114637	114638
23947	37104	2	applied	\N	\N	\N	\N	114639	114639	114640
23957	37120	0	applied	\N	\N	\N	\N	114696	114696	114697
23957	37121	1	applied	\N	\N	\N	\N	114698	114698	114699
23957	37122	2	applied	\N	\N	\N	\N	114700	114700	114701
23962	37132	0	applied	\N	\N	\N	\N	114727	114727	114728
23962	37133	1	applied	\N	\N	\N	\N	114729	114729	114730
23962	37134	2	applied	\N	\N	\N	\N	114731	114731	114732
23962	37135	3	applied	\N	\N	\N	\N	114733	114733	114734
23962	37136	4	applied	\N	\N	\N	\N	114735	114735	114736
23962	37137	5	applied	\N	\N	\N	\N	114737	114737	114738
23962	37138	6	applied	\N	\N	\N	\N	114739	114739	114740
23967	37146	0	applied	\N	\N	\N	\N	114795	114795	114796
23967	37147	1	applied	\N	\N	\N	\N	114797	114797	114798
23974	37179	0	applied	\N	\N	\N	\N	114873	114873	114874
23974	37180	2	applied	\N	\N	\N	\N	114876	114876	114877
23974	37181	3	applied	\N	\N	\N	\N	114878	114878	114879
23979	37191	0	applied	\N	\N	\N	\N	114907	114907	114908
23979	37192	1	applied	\N	\N	\N	\N	114909	114909	114910
23979	37193	2	applied	\N	\N	\N	\N	114911	114911	114912
23981	37199	0	applied	\N	\N	\N	\N	114926	114926	114927
23981	37200	1	applied	\N	\N	\N	\N	114928	114928	114929
23981	37201	2	applied	\N	\N	\N	\N	114930	114930	114931
23877	36802	62	applied	\N	\N	\N	\N	113693	113693	113694
23877	36805	63	applied	\N	\N	\N	\N	113703	113703	113704
23877	36808	64	applied	\N	\N	\N	\N	113709	113709	113710
23877	36812	65	applied	\N	\N	\N	\N	113717	113717	113718
23877	36813	66	applied	\N	\N	\N	\N	113719	113719	113720
23877	36818	67	applied	\N	\N	\N	\N	113732	113732	113733
23877	36819	68	applied	\N	\N	\N	\N	113734	113734	113735
23877	36825	69	applied	\N	\N	\N	\N	113751	113751	113752
23877	36828	70	applied	\N	\N	\N	\N	113760	113760	113761
23877	36829	71	applied	\N	\N	\N	\N	113762	113762	113763
23877	36835	72	applied	\N	\N	\N	\N	113779	113779	113780
23877	36838	73	applied	\N	\N	\N	\N	113787	113787	113788
23877	36841	74	applied	\N	\N	\N	\N	113795	113795	113796
23877	36842	75	applied	\N	\N	\N	\N	113797	113797	113798
23877	36848	76	applied	\N	\N	\N	\N	113816	113816	113817
23877	36854	77	applied	\N	\N	\N	\N	113836	113836	113837
23877	36857	78	applied	\N	\N	\N	\N	113845	113845	113846
23877	36860	79	applied	\N	\N	\N	\N	113851	113851	113852
23877	36861	80	applied	\N	\N	\N	\N	113853	113853	113854
23877	36867	81	applied	\N	\N	\N	\N	113867	113867	113868
23877	36870	82	applied	\N	\N	\N	\N	113875	113875	113876
23877	36871	83	applied	\N	\N	\N	\N	113877	113877	113878
23877	36877	84	applied	\N	\N	\N	\N	113891	113891	113892
23877	36880	85	applied	\N	\N	\N	\N	113911	113911	113912
23877	36881	86	applied	\N	\N	\N	\N	113913	113913	113914
23877	36882	87	applied	\N	\N	\N	\N	113915	113915	113916
23877	36890	88	applied	\N	\N	\N	\N	113933	113933	113934
23877	36893	89	applied	\N	\N	\N	\N	113941	113941	113942
23877	36897	90	applied	\N	\N	\N	\N	113951	113951	113952
23877	36900	91	applied	\N	\N	\N	\N	113983	113983	113984
23877	36903	92	applied	\N	\N	\N	\N	113995	113995	113996
23877	36904	93	applied	\N	\N	\N	\N	113997	113997	113998
23877	36910	94	applied	\N	\N	\N	\N	114014	114014	114015
23877	36913	95	applied	\N	\N	\N	\N	114023	114023	114024
23877	36914	96	applied	\N	\N	\N	\N	114025	114025	114026
23877	36920	97	applied	\N	\N	\N	\N	114039	114039	114040
23877	36923	98	applied	\N	\N	\N	\N	114049	114049	114050
23877	36924	99	applied	\N	\N	\N	\N	114051	114051	114052
23877	36929	100	applied	\N	\N	\N	\N	114063	114063	114064
23877	36932	101	applied	\N	\N	\N	\N	114072	114072	114073
23877	36933	102	applied	\N	\N	\N	\N	114074	114074	114075
23877	36938	103	applied	\N	\N	\N	\N	114088	114088	114089
23877	36939	104	applied	\N	\N	\N	\N	114090	114090	114091
23877	36940	105	applied	\N	\N	\N	\N	114092	114092	114093
23877	36948	106	applied	\N	\N	\N	\N	114110	114110	114111
23877	36611	107	applied	\N	\N	\N	\N	113014	113014	114121
23877	36614	108	applied	\N	\N	\N	\N	113020	113020	113021
23877	36605	109	applied	\N	\N	\N	\N	112997	112997	114122
23877	36621	110	applied	\N	\N	\N	\N	113036	113036	113000
23877	36632	111	applied	\N	\N	\N	\N	113062	113062	114123
23877	36644	112	applied	\N	\N	\N	\N	113089	113089	114124
23877	36655	113	applied	\N	\N	\N	\N	113113	113113	113002
23877	36665	114	applied	\N	\N	\N	\N	113175	113175	114125
23877	36681	115	applied	\N	\N	\N	\N	113223	113223	114126
23877	36687	116	applied	\N	\N	\N	\N	113235	113235	113004
23877	36700	117	applied	\N	\N	\N	\N	113263	113263	113015
23877	36710	118	applied	\N	\N	\N	\N	113352	113352	114127
23877	36723	119	applied	\N	\N	\N	\N	113456	113456	113017
23877	36731	120	applied	\N	\N	\N	\N	113479	113479	114128
23877	36744	121	applied	\N	\N	\N	\N	113517	113517	114129
23877	36752	122	applied	\N	\N	\N	\N	113541	113541	113019
23877	36761	123	applied	\N	\N	\N	\N	113566	113566	114130
23877	36778	124	applied	\N	\N	\N	\N	113629	113629	114131
23880	36948	0	applied	\N	\N	\N	\N	114110	114110	114111
23880	36952	1	applied	\N	\N	\N	\N	114137	114137	114138
23880	36955	2	applied	\N	\N	\N	\N	114147	114147	114148
23880	36956	3	applied	\N	\N	\N	\N	114149	114149	114150
23880	36949	4	applied	\N	\N	\N	\N	114113	114113	114139
23880	36957	5	applied	\N	\N	\N	\N	114151	114151	114152
23880	36950	6	applied	\N	\N	\N	\N	114115	114115	114153
23880	36953	7	applied	\N	\N	\N	\N	114140	114140	114118
23880	36951	8	applied	\N	\N	\N	\N	114117	114117	114154
23880	36954	9	applied	\N	\N	\N	\N	114143	114143	114155
23880	36958	10	applied	\N	\N	\N	\N	114156	114156	114157
23880	36959	11	applied	\N	\N	\N	\N	114158	114158	114159
23880	36960	12	applied	\N	\N	\N	\N	114160	114160	114161
23880	36961	13	applied	\N	\N	\N	\N	114162	114162	114163
23884	36978	0	applied	\N	\N	\N	\N	114200	114200	114201
23884	36979	1	applied	\N	\N	\N	\N	114202	114202	114203
23884	36980	2	applied	\N	\N	\N	\N	114204	114204	114205
23886	36988	0	applied	\N	\N	\N	\N	114223	114223	114224
23886	36989	1	applied	\N	\N	\N	\N	114225	114225	114226
23886	36990	2	applied	\N	\N	\N	\N	114227	114227	114228
23892	37002	0	applied	\N	\N	\N	\N	114261	114261	114262
23892	37003	1	applied	\N	\N	\N	\N	114263	114263	114264
23892	37004	2	applied	\N	\N	\N	\N	114265	114265	114266
23895	37002	0	applied	\N	\N	\N	\N	114261	114261	114262
23895	37003	1	applied	\N	\N	\N	\N	114263	114263	114264
23895	37004	2	applied	\N	\N	\N	\N	114265	114265	114266
23900	37012	0	applied	\N	\N	\N	\N	114293	114293	114294
23900	37013	1	applied	\N	\N	\N	\N	114295	114295	114296
23900	37014	2	applied	\N	\N	\N	\N	114297	114297	114298
23903	37012	0	applied	\N	\N	\N	\N	114293	114293	114294
23903	37013	1	applied	\N	\N	\N	\N	114295	114295	114296
23903	37014	2	applied	\N	\N	\N	\N	114297	114297	114298
23908	37015	0	applied	\N	\N	\N	\N	114308	114308	114309
23908	37016	1	applied	\N	\N	\N	\N	114310	114310	114323
23908	37019	2	applied	\N	\N	\N	\N	114324	114324	114313
23908	37017	3	applied	\N	\N	\N	\N	114312	114312	114325
23913	37020	0	applied	\N	\N	\N	\N	114331	114331	114332
23913	37021	1	applied	\N	\N	\N	\N	114333	114333	114334
23913	37022	2	applied	\N	\N	\N	\N	114335	114335	114336
23913	37023	3	applied	\N	\N	\N	\N	114337	114337	114338
23913	37024	4	applied	\N	\N	\N	\N	114339	114339	114340
23913	37025	5	applied	\N	\N	\N	\N	114341	114341	114342
23913	37026	6	applied	\N	\N	\N	\N	114343	114343	114344
23916	36794	0	applied	\N	\N	1000000000	\N	113901	113901	113671
23916	36708	1	applied	\N	\N	\N	\N	113348	113348	113422
23916	36712	2	applied	\N	\N	\N	\N	113408	113408	113423
23916	36713	3	applied	\N	\N	\N	\N	113410	113410	113424
23916	36718	4	applied	\N	\N	\N	\N	113446	113446	114381
23916	36719	5	applied	\N	\N	\N	\N	113448	113448	114382
23916	36725	6	applied	\N	\N	\N	\N	113464	113464	114383
23916	36728	7	applied	\N	\N	\N	\N	113472	113472	114384
23916	36732	8	applied	\N	\N	\N	\N	113483	113483	114385
23916	36735	9	applied	\N	\N	\N	\N	113493	113493	114386
23916	36738	10	applied	\N	\N	\N	\N	113505	113505	114387
23916	36739	11	applied	\N	\N	\N	\N	113507	113507	114388
23916	36745	12	applied	\N	\N	\N	\N	113521	113521	114389
23916	36748	13	applied	\N	\N	\N	\N	113531	113531	114390
23916	36751	14	applied	\N	\N	\N	\N	113539	113539	114391
23916	36757	15	applied	\N	\N	\N	\N	113555	113555	114392
23916	36758	16	applied	\N	\N	\N	\N	113557	113557	114393
23916	36763	17	applied	\N	\N	\N	\N	113572	113572	114394
23916	36765	18	applied	\N	\N	\N	\N	113583	113583	114395
23916	36768	19	applied	\N	\N	\N	\N	113594	113594	114396
23916	36771	20	applied	\N	\N	\N	\N	113605	113605	114397
23916	36774	21	applied	\N	\N	\N	\N	113621	113621	114398
23916	36775	22	applied	\N	\N	\N	\N	113623	113623	114399
23916	36781	23	applied	\N	\N	\N	\N	113639	113639	114400
23916	36784	24	applied	\N	\N	\N	\N	113648	113648	114401
23916	36788	25	applied	\N	\N	\N	\N	113656	113656	114402
23916	36789	26	applied	\N	\N	\N	\N	113658	113658	114403
23916	36795	27	applied	\N	\N	\N	\N	113672	113672	114404
23916	36799	28	applied	\N	\N	\N	\N	113682	113682	114405
23916	36802	29	applied	\N	\N	\N	\N	113693	113693	114406
23916	36805	30	applied	\N	\N	\N	\N	113703	113703	114407
23916	36808	31	applied	\N	\N	\N	\N	113709	113709	114408
23916	36812	32	applied	\N	\N	\N	\N	113717	113717	114409
23916	36813	33	applied	\N	\N	\N	\N	113719	113719	114410
23916	36818	34	applied	\N	\N	\N	\N	113732	113732	114411
23916	36819	35	applied	\N	\N	\N	\N	113734	113734	114412
23916	36825	36	applied	\N	\N	\N	\N	113751	113751	114413
23916	36828	37	applied	\N	\N	\N	\N	113760	113760	114414
23916	36829	38	applied	\N	\N	\N	\N	113762	113762	114415
23916	36835	39	applied	\N	\N	\N	\N	113779	113779	114416
23916	36838	40	applied	\N	\N	\N	\N	113787	113787	114417
23916	36841	41	applied	\N	\N	\N	\N	113795	113795	114418
23916	36842	42	applied	\N	\N	\N	\N	113797	113797	114419
23916	36848	43	applied	\N	\N	\N	\N	113816	113816	114420
23916	36854	44	applied	\N	\N	\N	\N	113836	113836	114421
23916	36857	45	applied	\N	\N	\N	\N	113845	113845	114422
23916	36860	46	applied	\N	\N	\N	\N	113851	113851	114423
23916	36861	47	applied	\N	\N	\N	\N	113853	113853	114424
23916	36867	48	applied	\N	\N	\N	\N	113867	113867	114425
23916	36870	49	applied	\N	\N	\N	\N	113875	113875	114426
23916	36871	50	applied	\N	\N	\N	\N	113877	113877	114427
23916	36877	51	applied	\N	\N	\N	\N	113891	113891	114428
23916	36880	52	applied	\N	\N	\N	\N	113911	113911	114429
23916	36881	53	applied	\N	\N	\N	\N	113913	113913	114430
23916	36882	54	applied	\N	\N	\N	\N	113915	113915	114431
23916	36890	55	applied	\N	\N	\N	\N	113933	113933	114432
23916	36893	56	applied	\N	\N	\N	\N	113941	113941	114433
23916	36897	57	applied	\N	\N	\N	\N	113951	113951	114434
23916	36900	58	applied	\N	\N	\N	\N	113983	113983	114435
23916	36903	59	applied	\N	\N	\N	\N	113995	113995	114436
23916	36904	60	applied	\N	\N	\N	\N	113997	113997	114437
23916	36910	61	applied	\N	\N	\N	\N	114014	114014	114438
23916	36913	62	applied	\N	\N	\N	\N	114023	114023	114439
23916	36914	63	applied	\N	\N	\N	\N	114025	114025	114440
23916	36920	64	applied	\N	\N	\N	\N	114039	114039	114441
23916	36923	65	applied	\N	\N	\N	\N	114049	114049	114442
23916	36924	66	applied	\N	\N	\N	\N	114051	114051	114443
23916	36929	67	applied	\N	\N	\N	\N	114063	114063	114444
23916	36932	68	applied	\N	\N	\N	\N	114072	114072	114445
23916	36933	69	applied	\N	\N	\N	\N	114074	114074	114446
23916	36938	70	applied	\N	\N	\N	\N	114088	114088	114447
23916	36939	71	applied	\N	\N	\N	\N	114090	114090	114448
23916	36940	72	applied	\N	\N	\N	\N	114092	114092	114449
23916	36948	73	applied	\N	\N	\N	\N	114110	114110	114450
23916	36952	74	applied	\N	\N	\N	\N	114137	114137	114451
23916	36955	75	applied	\N	\N	\N	\N	114147	114147	114452
23916	36956	76	applied	\N	\N	\N	\N	114149	114149	114453
23916	36962	77	applied	\N	\N	\N	\N	114165	114165	114454
23916	36963	78	applied	\N	\N	\N	\N	114167	114167	114455
23916	36964	79	applied	\N	\N	\N	\N	114169	114169	114456
23916	36971	81	applied	\N	\N	\N	\N	114184	114184	114458
23916	36972	82	applied	\N	\N	\N	\N	114186	114186	114459
23916	36978	83	applied	\N	\N	\N	\N	114200	114200	114460
23916	36981	84	applied	\N	\N	\N	\N	114208	114208	114461
23916	36982	85	applied	\N	\N	\N	\N	114210	114210	114462
23916	36988	86	applied	\N	\N	\N	\N	114223	114223	114463
23916	36991	87	applied	\N	\N	\N	\N	114231	114231	114464
23916	36992	88	applied	\N	\N	\N	\N	114233	114233	114465
23916	36999	89	applied	\N	\N	\N	\N	114249	114249	114466
23916	37002	90	applied	\N	\N	\N	\N	114261	114261	114467
23916	37005	91	applied	\N	\N	\N	\N	114274	114274	114468
23916	37009	92	applied	\N	\N	\N	\N	114285	114285	114469
23916	37012	93	applied	\N	\N	\N	\N	114293	114293	114470
23916	37015	94	applied	\N	\N	\N	\N	114308	114308	114471
23916	37020	95	applied	\N	\N	\N	\N	114331	114331	114472
23916	37021	96	applied	\N	\N	\N	\N	114333	114333	114473
23916	37027	97	applied	\N	\N	\N	\N	114348	114348	114474
23921	37060	0	applied	\N	\N	\N	\N	114518	114518	114519
23921	37061	1	applied	\N	\N	\N	\N	114520	114520	114521
23921	37062	2	applied	\N	\N	\N	\N	114522	114522	114523
23928	37069	0	applied	\N	\N	\N	\N	114548	114548	114549
23928	37070	1	applied	\N	\N	\N	\N	114550	114550	114551
23928	37071	2	applied	\N	\N	\N	\N	114552	114552	114553
23928	37072	3	applied	\N	\N	\N	\N	114554	114554	114555
23930	37073	0	applied	\N	\N	\N	\N	114557	114557	114558
23930	37074	1	applied	\N	\N	\N	\N	114559	114559	114560
23930	37075	2	applied	\N	\N	\N	\N	114561	114561	114562
23930	37077	3	applied	\N	\N	\N	\N	114567	114567	114568
23930	37076	4	applied	\N	\N	\N	\N	114563	114563	114569
23930	37078	5	applied	\N	\N	\N	\N	114570	114570	114571
23930	37079	6	applied	\N	\N	\N	\N	114572	114572	114573
23930	37080	7	applied	\N	\N	\N	\N	114574	114574	114575
23930	37081	8	applied	\N	\N	\N	\N	114576	114576	114577
23930	37082	9	applied	\N	\N	\N	\N	114578	114578	114579
23935	37089	0	applied	\N	\N	\N	\N	114597	114597	114598
23935	37091	1	applied	\N	\N	\N	\N	114601	114601	114606
23937	37093	0	applied	\N	\N	\N	\N	114610	114610	114611
23937	37090	1	applied	\N	\N	\N	\N	114599	114599	114602
23937	37094	2	applied	\N	\N	\N	\N	114612	114612	114608
23937	37092	3	applied	\N	\N	\N	\N	114603	114603	114613
23942	37096	0	applied	\N	\N	\N	\N	114621	114621	114622
23942	37097	1	applied	\N	\N	\N	\N	114623	114623	114624
23942	37098	2	applied	\N	\N	\N	\N	114625	114625	114626
23942	37099	3	applied	\N	\N	\N	\N	114627	114627	114628
23942	37100	4	applied	\N	\N	\N	\N	114629	114629	114630
23942	37101	5	applied	\N	\N	\N	\N	114631	114631	114632
23945	37102	0	applied	\N	\N	\N	\N	114635	114635	114636
23945	37103	1	applied	\N	\N	\N	\N	114637	114637	114638
23945	37104	2	applied	\N	\N	\N	\N	114639	114639	114640
23949	37105	0	applied	\N	\N	\N	\N	114650	114650	114651
23949	37106	1	applied	\N	\N	\N	\N	114652	114652	114653
23949	37107	2	applied	\N	\N	\N	\N	114654	114654	114655
23949	37108	3	applied	\N	\N	\N	\N	114656	114656	114657
23949	37109	4	applied	\N	\N	\N	\N	114658	114658	114659
23949	37110	5	applied	\N	\N	\N	\N	114660	114660	114661
23953	37114	0	applied	\N	\N	\N	\N	114677	114677	114678
23953	37107	1	applied	\N	\N	\N	\N	114654	114654	114668
23953	37108	2	applied	\N	\N	\N	\N	114656	114656	114679
23953	37115	3	applied	\N	\N	\N	\N	114680	114680	114681
23953	37112	4	applied	\N	\N	\N	\N	114667	114667	114682
23953	37116	5	applied	\N	\N	\N	\N	114683	114683	114684
23955	37117	0	applied	\N	\N	\N	\N	114688	114688	114689
23955	37118	1	applied	\N	\N	\N	\N	114690	114690	114691
23955	37119	2	applied	\N	\N	\N	\N	114692	114692	114693
23963	37139	0	applied	\N	\N	\N	\N	114743	114743	114744
23963	37140	1	applied	\N	\N	\N	\N	114745	114745	114746
23963	37141	2	applied	\N	\N	\N	\N	114747	114747	114748
23965	37142	0	applied	\N	\N	\N	\N	114784	114784	114785
23965	37143	1	applied	\N	\N	\N	\N	114786	114786	114787
23965	37144	2	applied	\N	\N	\N	\N	114788	114788	114789
23970	37162	0	applied	\N	\N	\N	\N	114833	114833	114834
23970	37163	1	applied	\N	\N	\N	\N	114835	114835	114836
23970	37164	2	applied	\N	\N	\N	\N	114837	114837	114838
23970	37165	3	applied	\N	\N	\N	\N	114839	114839	114840
23970	37166	4	applied	\N	\N	\N	\N	114841	114841	114842
23970	37167	5	applied	\N	\N	\N	\N	114843	114843	114844
23970	37168	6	applied	\N	\N	\N	\N	114845	114845	114846
23970	37169	7	applied	\N	\N	\N	\N	114847	114847	114848
23970	37161	8	applied	\N	\N	\N	\N	114828	114828	114849
23970	37170	9	applied	\N	\N	\N	\N	114850	114850	114851
23972	37171	0	applied	\N	\N	\N	\N	114855	114855	114856
23972	37172	1	applied	\N	\N	\N	\N	114857	114857	114858
23972	37173	2	applied	\N	\N	\N	\N	114859	114859	114860
23972	37174	3	applied	\N	\N	\N	\N	114861	114861	114862
23972	37175	4	applied	\N	\N	\N	\N	114863	114863	114864
23972	37176	5	applied	\N	\N	\N	\N	114865	114865	114866
23972	37177	6	applied	\N	\N	\N	\N	114867	114867	114868
23972	37178	7	applied	\N	\N	\N	\N	114869	114869	114870
23977	37185	0	applied	\N	\N	\N	\N	114893	114893	114894
23977	37186	1	applied	\N	\N	\N	\N	114895	114895	114896
23977	37187	2	applied	\N	\N	\N	\N	114897	114897	114898
23984	37202	0	applied	\N	\N	\N	\N	114934	114934	114935
23984	37203	1	applied	\N	\N	\N	\N	114936	114936	114937
23984	37204	2	applied	\N	\N	\N	\N	114938	114938	114939
23989	37210	0	applied	\N	\N	\N	\N	114958	114958	114959
23989	37211	1	applied	\N	\N	\N	\N	114960	114960	114961
23989	37212	2	applied	\N	\N	\N	\N	114962	114962	114963
23992	37213	0	applied	\N	\N	\N	\N	114966	114966	114967
23992	37214	1	applied	\N	\N	\N	\N	114968	114968	114969
23992	37215	2	applied	\N	\N	\N	\N	114970	114970	114971
23998	37222	0	applied	\N	\N	\N	\N	115017	115017	115018
23998	37223	1	applied	\N	\N	\N	\N	115019	115019	115020
23998	37224	2	applied	\N	\N	\N	\N	115021	115021	115022
23998	37225	3	applied	\N	\N	\N	\N	115023	115023	115024
23998	37226	4	applied	\N	\N	\N	\N	115025	115025	115026
23998	37227	5	applied	\N	\N	\N	\N	115027	115027	115028
23998	37228	6	applied	\N	\N	\N	\N	115029	115029	115030
23998	37229	7	applied	\N	\N	\N	\N	115031	115031	115032
23998	37230	8	applied	\N	\N	\N	\N	115033	115033	115034
24001	37232	0	applied	\N	\N	\N	\N	115041	115041	115042
24003	37231	0	applied	\N	\N	\N	\N	115039	115039	115040
24003	37232	1	applied	\N	\N	\N	\N	115041	115041	115042
24003	37233	2	applied	\N	\N	\N	\N	115043	115043	115044
24005	37234	0	applied	\N	\N	\N	\N	115048	115048	115049
24005	37235	1	applied	\N	\N	\N	\N	115050	115050	115051
24005	37236	2	applied	\N	\N	\N	\N	115052	115052	115053
24005	37237	3	applied	\N	\N	\N	\N	115054	115054	77733
24005	37238	4	applied	\N	\N	\N	\N	115055	115055	115056
24007	37242	0	applied	\N	\N	\N	\N	115065	115065	115066
24007	37243	1	applied	\N	\N	\N	\N	115067	115067	115068
24012	37250	0	applied	\N	\N	\N	\N	115089	115089	115090
24012	37251	1	applied	\N	\N	\N	\N	115091	115091	115092
24012	37252	2	applied	\N	\N	\N	\N	115093	115093	115094
24014	37253	0	applied	\N	\N	\N	\N	115099	115099	115100
24014	37254	1	applied	\N	\N	\N	\N	115101	115101	115102
24014	37255	2	applied	\N	\N	\N	\N	115103	115103	115104
24019	37262	0	applied	\N	\N	\N	\N	114914	114914	114915
24019	37263	1	applied	\N	\N	\N	\N	115121	115121	115122
24019	37264	2	applied	\N	\N	\N	\N	115123	115123	115124
24019	37265	3	applied	\N	\N	\N	\N	115125	115125	115126
24024	37269	0	applied	\N	\N	\N	\N	115140	115140	115141
24024	37270	1	applied	\N	\N	\N	\N	114916	114916	114917
24024	37271	2	applied	\N	\N	\N	\N	114918	114918	114919
24024	37272	3	applied	\N	\N	\N	\N	114920	114920	114921
24024	37273	4	applied	\N	\N	\N	\N	115142	115142	115143
24024	37274	5	applied	\N	\N	\N	\N	115144	115144	115145
24026	37275	0	applied	\N	\N	\N	\N	114922	114922	114923
24026	37276	1	applied	\N	\N	\N	\N	115150	115150	115151
24026	37277	2	applied	\N	\N	\N	\N	115152	115152	115153
24026	37278	3	applied	\N	\N	\N	\N	115154	115154	115155
24026	37279	4	applied	\N	\N	\N	\N	115156	115156	115157
24026	37280	5	applied	\N	\N	\N	\N	115158	115158	115159
24029	37293	0	applied	\N	\N	\N	\N	115191	115191	115192
24029	37294	1	applied	\N	\N	\N	\N	115193	115193	115194
24029	37295	2	applied	\N	\N	\N	\N	115195	115195	115196
24036	37305	0	applied	\N	\N	\N	\N	115226	115226	115227
24036	37306	1	applied	\N	\N	\N	\N	115228	115228	115229
24036	37307	2	applied	\N	\N	\N	\N	115230	115230	115231
24038	37308	0	applied	\N	\N	\N	\N	115235	115235	115236
24038	37309	1	applied	\N	\N	\N	\N	115237	115237	115238
24045	37316	0	applied	\N	\N	\N	\N	115261	115261	115262
24045	37317	1	applied	\N	\N	\N	\N	115263	115263	115264
24047	37321	0	applied	\N	\N	\N	\N	115276	115276	115277
24047	37322	1	applied	\N	\N	\N	\N	115278	115278	115279
24047	37323	2	applied	\N	\N	\N	\N	115280	115280	115281
24047	37324	3	applied	\N	\N	\N	\N	115282	115282	115283
24047	37325	4	applied	\N	\N	\N	\N	115284	115284	115285
24047	37326	5	applied	\N	\N	\N	\N	115286	115286	115287
24050	37332	0	applied	\N	\N	\N	\N	115301	115301	115302
24050	37333	1	applied	\N	\N	\N	\N	115303	115303	115304
24050	37334	2	applied	\N	\N	\N	\N	115305	115305	115306
24050	37335	3	applied	\N	\N	\N	\N	115307	115307	115308
24057	37340	0	applied	\N	\N	\N	\N	115328	115328	115329
24057	37341	1	applied	\N	\N	\N	\N	115330	115330	115331
24062	37346	0	applied	\N	\N	\N	\N	115347	115347	115348
24062	37347	1	applied	\N	\N	\N	\N	115349	115349	115350
24067	37348	0	applied	\N	\N	\N	\N	115400	115400	115401
24067	37349	1	applied	\N	\N	\N	\N	115402	115402	115403
24067	37350	2	applied	\N	\N	\N	\N	115404	115404	115405
24067	37351	3	applied	\N	\N	\N	\N	115406	115406	115407
24067	37352	4	applied	\N	\N	\N	\N	115408	115408	115409
24067	37353	5	applied	\N	\N	\N	\N	115410	115410	115411
24073	37372	0	applied	\N	\N	\N	\N	115455	115455	115456
24073	37373	1	applied	\N	\N	\N	\N	115457	115457	115458
23952	37105	0	applied	\N	\N	\N	\N	114650	114650	114651
23952	37106	1	applied	\N	\N	\N	\N	114652	114652	114653
23952	37111	2	applied	\N	\N	\N	\N	114665	114665	114666
23952	37109	3	applied	\N	\N	\N	\N	114658	114658	114674
23952	37110	4	applied	\N	\N	\N	\N	114660	114660	114675
23952	37113	5	applied	\N	\N	\N	\N	114671	114671	114657
23954	37114	0	applied	\N	\N	\N	\N	114677	114677	114678
23954	37107	1	applied	\N	\N	\N	\N	114654	114654	114668
23954	37108	2	applied	\N	\N	\N	\N	114656	114656	114679
23954	37115	3	applied	\N	\N	\N	\N	114680	114680	114681
23954	37112	4	applied	\N	\N	\N	\N	114667	114667	114682
23954	37116	5	applied	\N	\N	\N	\N	114683	114683	114684
23956	37117	0	applied	\N	\N	\N	\N	114688	114688	114689
23956	37118	1	applied	\N	\N	\N	\N	114690	114690	114691
23956	37119	2	applied	\N	\N	\N	\N	114692	114692	114693
23959	37121	0	applied	\N	\N	\N	\N	114698	114698	114699
23959	37122	1	applied	\N	\N	\N	\N	114700	114700	114701
23961	37126	0	applied	\N	\N	\N	\N	114713	114713	114714
23961	37127	1	applied	\N	\N	\N	\N	114715	114715	114716
23961	37128	2	applied	\N	\N	\N	\N	114717	114717	114718
23961	37129	3	applied	\N	\N	\N	\N	114719	114719	114720
23961	37130	4	applied	\N	\N	\N	\N	114721	114721	114722
23961	37131	5	applied	\N	\N	\N	\N	114723	114723	114724
23964	36794	0	applied	\N	\N	1000000000	\N	113901	113901	113671
23964	36718	1	applied	\N	\N	\N	\N	113446	113446	114381
23964	36719	2	applied	\N	\N	\N	\N	113448	113448	114382
23964	37134	3	applied	\N	\N	\N	\N	114750	114750	114732
23964	36725	4	applied	\N	\N	\N	\N	113464	113464	114383
23964	36728	5	applied	\N	\N	\N	\N	113472	113472	114384
23964	36732	6	applied	\N	\N	\N	\N	113483	113483	114385
23964	36735	7	applied	\N	\N	\N	\N	113493	113493	114386
23964	36738	8	applied	\N	\N	\N	\N	113505	113505	114387
23964	36739	9	applied	\N	\N	\N	\N	113507	113507	114388
23964	36745	10	applied	\N	\N	\N	\N	113521	113521	114389
23964	36748	11	applied	\N	\N	\N	\N	113531	113531	114390
23964	36751	12	applied	\N	\N	\N	\N	113539	113539	114391
23964	36757	13	applied	\N	\N	\N	\N	113555	113555	114392
23964	36758	14	applied	\N	\N	\N	\N	113557	113557	114393
23964	36763	15	applied	\N	\N	\N	\N	113572	113572	114394
23964	36765	16	applied	\N	\N	\N	\N	113583	113583	114395
23964	36768	17	applied	\N	\N	\N	\N	113594	113594	114396
23964	36771	18	applied	\N	\N	\N	\N	113605	113605	114397
23964	36774	19	applied	\N	\N	\N	\N	113621	113621	114398
23964	36775	20	applied	\N	\N	\N	\N	113623	113623	114399
23964	36781	21	applied	\N	\N	\N	\N	113639	113639	114400
23964	36784	22	applied	\N	\N	\N	\N	113648	113648	114401
23964	36788	23	applied	\N	\N	\N	\N	113656	113656	114402
23964	36789	24	applied	\N	\N	\N	\N	113658	113658	114403
23964	36795	25	applied	\N	\N	\N	\N	113672	113672	114404
23964	36799	26	applied	\N	\N	\N	\N	113682	113682	114405
23964	36802	27	applied	\N	\N	\N	\N	113693	113693	114406
23964	36805	28	applied	\N	\N	\N	\N	113703	113703	114407
23964	36808	29	applied	\N	\N	\N	\N	113709	113709	114408
23964	36812	30	applied	\N	\N	\N	\N	113717	113717	114409
23964	36813	31	applied	\N	\N	\N	\N	113719	113719	114410
23964	36818	32	applied	\N	\N	\N	\N	113732	113732	114411
23964	36819	33	applied	\N	\N	\N	\N	113734	113734	114412
23964	36825	34	applied	\N	\N	\N	\N	113751	113751	114413
23964	36828	35	applied	\N	\N	\N	\N	113760	113760	114414
23964	36829	36	applied	\N	\N	\N	\N	113762	113762	114415
23964	36835	37	applied	\N	\N	\N	\N	113779	113779	114416
23964	36838	38	applied	\N	\N	\N	\N	113787	113787	114417
23964	36841	39	applied	\N	\N	\N	\N	113795	113795	114418
23964	36842	40	applied	\N	\N	\N	\N	113797	113797	114419
23964	36848	41	applied	\N	\N	\N	\N	113816	113816	114420
23964	36854	42	applied	\N	\N	\N	\N	113836	113836	114421
23964	36857	43	applied	\N	\N	\N	\N	113845	113845	114422
23964	36860	44	applied	\N	\N	\N	\N	113851	113851	114423
23964	36861	45	applied	\N	\N	\N	\N	113853	113853	114424
23964	36867	46	applied	\N	\N	\N	\N	113867	113867	114425
23964	36870	47	applied	\N	\N	\N	\N	113875	113875	114426
23964	36871	48	applied	\N	\N	\N	\N	113877	113877	114427
23964	36877	49	applied	\N	\N	\N	\N	113891	113891	114428
23964	36880	50	applied	\N	\N	\N	\N	113911	113911	114429
23964	36881	51	applied	\N	\N	\N	\N	113913	113913	114430
23964	36882	52	applied	\N	\N	\N	\N	113915	113915	114431
23964	36890	53	applied	\N	\N	\N	\N	113933	113933	114432
23964	36893	54	applied	\N	\N	\N	\N	113941	113941	114433
23964	36897	55	applied	\N	\N	\N	\N	113951	113951	114434
23964	36900	56	applied	\N	\N	\N	\N	113983	113983	114435
23964	36903	57	applied	\N	\N	\N	\N	113995	113995	114436
23964	36904	58	applied	\N	\N	\N	\N	113997	113997	114437
23964	36910	59	applied	\N	\N	\N	\N	114014	114014	114438
23964	36913	60	applied	\N	\N	\N	\N	114023	114023	114439
23964	36914	61	applied	\N	\N	\N	\N	114025	114025	114440
23964	36920	62	applied	\N	\N	\N	\N	114039	114039	114441
23964	36923	63	applied	\N	\N	\N	\N	114049	114049	114442
23964	36924	64	applied	\N	\N	\N	\N	114051	114051	114443
23964	36929	65	applied	\N	\N	\N	\N	114063	114063	114444
23964	36932	66	applied	\N	\N	\N	\N	114072	114072	114445
23964	36933	67	applied	\N	\N	\N	\N	114074	114074	114446
23964	36938	68	applied	\N	\N	\N	\N	114088	114088	114447
23964	36939	69	applied	\N	\N	\N	\N	114090	114090	114448
23964	36940	70	applied	\N	\N	\N	\N	114092	114092	114449
23964	36948	71	applied	\N	\N	\N	\N	114110	114110	114450
23964	36952	72	applied	\N	\N	\N	\N	114137	114137	114451
23964	36955	73	applied	\N	\N	\N	\N	114147	114147	114452
23964	36956	74	applied	\N	\N	\N	\N	114149	114149	114453
23964	36962	75	applied	\N	\N	\N	\N	114165	114165	114454
23964	36963	76	applied	\N	\N	\N	\N	114167	114167	114455
23964	36964	77	applied	\N	\N	\N	\N	114169	114169	114456
23964	36971	78	applied	\N	\N	\N	\N	114184	114184	114458
23964	36972	79	applied	\N	\N	\N	\N	114186	114186	114459
23964	36978	80	applied	\N	\N	\N	\N	114200	114200	114460
23964	36981	81	applied	\N	\N	\N	\N	114208	114208	114461
23964	36982	82	applied	\N	\N	\N	\N	114210	114210	114462
23964	36988	83	applied	\N	\N	\N	\N	114223	114223	114463
23964	36991	84	applied	\N	\N	\N	\N	114231	114231	114464
23964	36992	85	applied	\N	\N	\N	\N	114233	114233	114465
23964	36999	86	applied	\N	\N	\N	\N	114249	114249	114466
23964	37002	87	applied	\N	\N	\N	\N	114261	114261	114467
23964	37005	88	applied	\N	\N	\N	\N	114274	114274	114468
23964	37009	89	applied	\N	\N	\N	\N	114285	114285	114469
23964	37012	90	applied	\N	\N	\N	\N	114293	114293	114470
23964	37015	91	applied	\N	\N	\N	\N	114308	114308	114471
23964	37020	92	applied	\N	\N	\N	\N	114331	114331	114472
23964	37021	93	applied	\N	\N	\N	\N	114333	114333	114473
23964	37027	94	applied	\N	\N	\N	\N	114348	114348	114474
23964	37030	95	applied	\N	\N	\N	\N	114356	114356	114751
23964	37031	96	applied	\N	\N	\N	\N	114358	114358	114752
23958	37120	0	applied	\N	\N	\N	\N	114696	114696	114697
23958	37121	1	applied	\N	\N	\N	\N	114698	114698	114699
23958	37122	2	applied	\N	\N	\N	\N	114700	114700	114701
23960	37123	0	applied	\N	\N	\N	\N	114705	114705	114706
23960	37124	1	applied	\N	\N	\N	\N	114707	114707	114708
23960	37125	2	applied	\N	\N	\N	\N	114709	114709	114710
23966	37142	0	applied	\N	\N	\N	\N	114784	114784	114785
23966	37143	1	applied	\N	\N	\N	\N	114786	114786	114787
23966	37144	2	applied	\N	\N	\N	\N	114788	114788	114789
23966	37145	3	applied	\N	\N	\N	\N	114792	114792	114793
23968	37148	0	applied	\N	\N	\N	\N	114801	114801	114802
23968	37149	1	applied	\N	\N	\N	\N	114803	114803	114804
23968	37150	2	applied	\N	\N	\N	\N	114805	114805	114806
23968	37151	3	applied	\N	\N	\N	\N	114807	114807	114808
23968	37152	4	applied	\N	\N	\N	\N	114809	114809	114810
23968	37153	5	applied	\N	\N	\N	\N	114811	114811	114812
23968	37154	6	applied	\N	\N	\N	\N	114813	114813	114814
23968	37155	7	applied	\N	\N	\N	\N	114815	114815	114816
23968	37156	8	applied	\N	\N	\N	\N	114817	114817	114818
23968	37157	9	applied	\N	\N	\N	\N	114819	114819	114820
23968	37158	10	applied	\N	\N	\N	\N	114821	114821	114822
23968	37159	11	applied	\N	\N	\N	\N	114823	114823	114824
23968	37160	12	applied	\N	\N	\N	\N	114825	114825	114826
23971	37162	0	applied	\N	\N	\N	\N	114833	114833	114834
23971	37163	1	applied	\N	\N	\N	\N	114835	114835	114836
23971	37164	2	applied	\N	\N	\N	\N	114837	114837	114838
23971	37165	3	applied	\N	\N	\N	\N	114839	114839	114840
23971	37166	4	applied	\N	\N	\N	\N	114841	114841	114842
23971	37167	5	applied	\N	\N	\N	\N	114843	114843	114844
23971	37168	6	applied	\N	\N	\N	\N	114845	114845	114846
23971	37169	7	applied	\N	\N	\N	\N	114847	114847	114848
23971	37161	8	applied	\N	\N	\N	\N	114828	114828	114849
23971	37170	9	applied	\N	\N	\N	\N	114850	114850	114851
23973	37171	0	applied	\N	\N	\N	\N	114855	114855	114856
23973	37172	1	applied	\N	\N	\N	\N	114857	114857	114858
23973	37173	2	applied	\N	\N	\N	\N	114859	114859	114860
23973	37174	3	applied	\N	\N	\N	\N	114861	114861	114862
23973	37175	4	applied	\N	\N	\N	\N	114863	114863	114864
23973	37176	5	applied	\N	\N	\N	\N	114865	114865	114866
23973	37177	6	applied	\N	\N	\N	\N	114867	114867	114868
23973	37178	7	applied	\N	\N	\N	\N	114869	114869	114870
23975	37182	0	applied	\N	\N	\N	\N	114882	114882	114883
23975	37183	1	applied	\N	\N	\N	\N	114884	114884	114885
23975	37184	2	applied	\N	\N	\N	\N	114886	114886	114887
23980	37134	0	applied	\N	\N	\N	\N	114731	114731	114732
23980	37143	1	applied	\N	\N	\N	\N	114786	114786	114787
23980	37148	2	applied	\N	\N	\N	\N	114801	114801	114802
23980	37150	3	applied	\N	\N	\N	\N	114805	114805	114806
23980	37151	4	applied	\N	\N	\N	\N	114807	114807	114808
23980	37152	5	applied	\N	\N	\N	\N	114809	114809	114810
23980	37153	6	applied	\N	\N	\N	\N	114811	114811	114812
23980	37154	7	applied	\N	\N	\N	\N	114813	114813	114814
23980	37155	8	applied	\N	\N	\N	\N	114815	114815	114816
23980	37156	9	applied	\N	\N	\N	\N	114817	114817	114818
23980	37157	10	applied	\N	\N	\N	\N	114819	114819	114820
23980	37158	11	applied	\N	\N	\N	\N	114821	114821	114822
23980	37159	12	applied	\N	\N	\N	\N	114823	114823	114824
23980	37162	13	applied	\N	\N	\N	\N	114833	114833	114834
23980	37163	14	applied	\N	\N	\N	\N	114835	114835	114836
23980	37164	15	applied	\N	\N	\N	\N	114837	114837	114838
23980	37166	16	applied	\N	\N	\N	\N	114841	114841	114842
23980	37167	17	applied	\N	\N	\N	\N	114843	114843	114844
23980	37168	18	applied	\N	\N	\N	\N	114845	114845	114846
23980	37171	19	applied	\N	\N	\N	\N	114855	114855	114856
23980	37172	20	applied	\N	\N	\N	\N	114857	114857	114858
23980	37173	21	applied	\N	\N	\N	\N	114859	114859	114860
23980	37174	22	applied	\N	\N	\N	\N	114861	114861	114862
23980	37175	23	applied	\N	\N	\N	\N	114863	114863	114864
23980	37194	24	applied	\N	\N	\N	\N	114914	114914	114915
23980	37195	25	applied	\N	\N	\N	\N	114916	114916	114917
23980	37196	26	applied	\N	\N	\N	\N	114918	114918	114919
23980	37197	27	applied	\N	\N	\N	\N	114920	114920	114921
23980	37198	28	applied	\N	\N	\N	\N	114922	114922	114923
23982	37199	0	applied	\N	\N	\N	\N	114926	114926	114927
23987	37208	0	applied	\N	\N	\N	\N	114953	114953	114954
23987	37209	1	applied	\N	\N	\N	\N	114955	114955	114956
23996	37219	0	applied	\N	\N	\N	\N	115008	115008	115009
23996	37220	1	applied	\N	\N	\N	\N	115010	115010	115011
23996	37221	2	applied	\N	\N	\N	\N	115012	115012	115013
23999	37222	0	applied	\N	\N	\N	\N	115017	115017	115018
23999	37223	1	applied	\N	\N	\N	\N	115019	115019	115020
23999	37224	2	applied	\N	\N	\N	\N	115021	115021	115022
23999	37225	3	applied	\N	\N	\N	\N	115023	115023	115024
23999	37226	4	applied	\N	\N	\N	\N	115025	115025	115026
23999	37227	5	applied	\N	\N	\N	\N	115027	115027	115028
23999	37228	6	applied	\N	\N	\N	\N	115029	115029	115030
23999	37229	7	applied	\N	\N	\N	\N	115031	115031	115032
23999	37230	8	applied	\N	\N	\N	\N	115033	115033	115034
24008	37242	0	applied	\N	\N	\N	\N	115065	115065	115066
24008	37243	1	applied	\N	\N	\N	\N	115067	115067	115068
24010	37244	0	applied	\N	\N	\N	\N	115073	115073	115074
24010	37245	1	applied	\N	\N	\N	\N	115075	115075	115076
24010	37246	2	applied	\N	\N	\N	\N	115077	115077	115078
24010	37247	3	applied	\N	\N	\N	\N	115079	115079	115080
24010	37248	4	applied	\N	\N	\N	\N	115081	115081	115082
24010	37249	5	applied	\N	\N	\N	\N	115083	115083	115084
24013	37250	0	applied	\N	\N	\N	\N	115089	115089	115090
24013	37251	1	applied	\N	\N	\N	\N	115091	115091	115092
24013	37252	2	applied	\N	\N	\N	\N	115093	115093	115094
24017	37256	0	applied	\N	\N	\N	\N	115107	115107	115108
24017	37257	1	applied	\N	\N	\N	\N	115109	115109	115110
24017	37258	2	applied	\N	\N	\N	\N	115111	115111	115112
24030	37293	0	applied	\N	\N	\N	\N	115191	115191	115192
24030	37294	1	applied	\N	\N	\N	\N	115193	115193	115194
24030	37295	2	applied	\N	\N	\N	\N	115195	115195	115196
24031	37296	0	applied	\N	\N	\N	\N	115201	115201	115202
24031	37297	1	applied	\N	\N	\N	\N	115203	115203	115204
24031	37298	2	applied	\N	\N	\N	\N	115205	115205	115206
24048	37327	0	applied	\N	\N	\N	\N	115288	115288	115289
24048	37328	1	applied	\N	\N	\N	\N	115290	115290	115291
24048	37329	2	applied	\N	\N	\N	\N	115292	115292	115293
24048	37330	3	applied	\N	\N	\N	\N	115294	115294	115295
24048	37331	4	applied	\N	\N	\N	\N	115296	115296	115297
24051	37332	0	applied	\N	\N	\N	\N	115301	115301	115302
24051	37333	1	applied	\N	\N	\N	\N	115303	115303	115304
24051	37334	2	applied	\N	\N	\N	\N	115305	115305	115306
24051	37335	3	applied	\N	\N	\N	\N	115307	115307	115308
24054	37332	0	applied	\N	\N	\N	\N	115301	115301	115302
24054	37333	1	applied	\N	\N	\N	\N	115303	115303	115304
24054	37334	2	applied	\N	\N	\N	\N	115305	115305	115306
23964	37032	97	applied	\N	\N	\N	\N	114360	114360	114753
23964	37033	98	applied	\N	\N	\N	\N	114362	114362	114754
23964	37042	99	applied	\N	\N	\N	\N	114480	114480	114755
23964	37043	100	applied	\N	\N	\N	\N	114482	114482	114756
23964	37044	101	applied	\N	\N	\N	\N	114484	114484	114757
23964	37053	102	applied	\N	\N	\N	\N	114503	114503	114758
23964	37056	103	applied	\N	\N	\N	\N	114509	114509	114759
23964	37060	104	applied	\N	\N	\N	\N	114518	114518	114760
23964	37063	106	applied	\N	\N	\N	\N	114530	114530	114762
23964	37066	107	applied	\N	\N	\N	\N	114538	114538	114763
23964	37069	108	applied	\N	\N	\N	\N	114548	114548	114764
23964	37073	109	applied	\N	\N	\N	\N	114557	114557	114765
23964	37074	110	applied	\N	\N	\N	\N	114559	114559	114766
23964	37075	111	applied	\N	\N	\N	\N	114561	114561	114767
23964	37083	112	applied	\N	\N	\N	\N	114582	114582	114768
23964	37086	113	applied	\N	\N	\N	\N	114589	114589	114769
23964	37089	114	applied	\N	\N	\N	\N	114597	114597	114770
23964	37093	115	applied	\N	\N	\N	\N	114610	114610	114771
23964	37096	116	applied	\N	\N	\N	\N	114621	114621	114772
23964	37097	117	applied	\N	\N	\N	\N	114623	114623	114773
23964	37102	118	applied	\N	\N	\N	\N	114635	114635	114774
23964	37105	119	applied	\N	\N	\N	\N	114650	114650	114775
23964	37106	120	applied	\N	\N	\N	\N	114652	114652	114776
23964	37111	121	applied	\N	\N	\N	\N	114665	114665	114777
23964	37114	122	applied	\N	\N	\N	\N	114677	114677	114778
23964	37117	123	applied	\N	\N	\N	\N	114688	114688	114779
23964	37120	124	applied	\N	\N	\N	\N	114696	114696	114780
23964	37123	125	applied	\N	\N	\N	\N	114705	114705	114781
23969	37148	0	applied	\N	\N	\N	\N	114801	114801	114802
23969	37149	1	applied	\N	\N	\N	\N	114803	114803	114804
23969	37150	2	applied	\N	\N	\N	\N	114805	114805	114806
23969	37151	3	applied	\N	\N	\N	\N	114807	114807	114808
23969	37152	4	applied	\N	\N	\N	\N	114809	114809	114810
23969	37153	5	applied	\N	\N	\N	\N	114811	114811	114812
23969	37154	6	applied	\N	\N	\N	\N	114813	114813	114814
23969	37155	7	applied	\N	\N	\N	\N	114815	114815	114816
23969	37156	8	applied	\N	\N	\N	\N	114817	114817	114818
23969	37157	9	applied	\N	\N	\N	\N	114819	114819	114820
23969	37158	10	applied	\N	\N	\N	\N	114821	114821	114822
23969	37159	11	applied	\N	\N	\N	\N	114823	114823	114824
23969	37161	12	applied	\N	\N	\N	\N	114828	114828	114829
23969	37160	13	applied	\N	\N	\N	\N	114825	114825	114830
23976	37182	0	applied	\N	\N	\N	\N	114882	114882	114883
23976	37183	1	applied	\N	\N	\N	\N	114884	114884	114885
23976	37184	2	applied	\N	\N	\N	\N	114886	114886	114887
23978	37188	0	applied	\N	\N	\N	\N	114900	114900	114901
23978	37189	1	applied	\N	\N	\N	\N	114902	114902	114903
23978	37190	2	applied	\N	\N	\N	\N	114904	114904	114905
23983	37202	0	applied	\N	\N	\N	\N	114934	114934	114935
23983	37203	1	applied	\N	\N	\N	\N	114936	114936	114937
23983	37204	2	applied	\N	\N	\N	\N	114938	114938	114939
23985	37205	0	applied	\N	\N	\N	\N	114944	114944	114945
23985	37206	1	applied	\N	\N	\N	\N	114946	114946	114947
23985	37207	2	applied	\N	\N	\N	\N	114948	114948	114949
23990	37213	0	applied	\N	\N	\N	\N	114966	114966	114967
23990	37214	1	applied	\N	\N	\N	\N	114968	114968	114969
23990	37215	2	applied	\N	\N	\N	\N	114970	114970	114971
23993	37134	0	applied	\N	\N	\N	\N	114731	114731	114732
23993	37143	1	applied	\N	\N	\N	\N	114786	114786	114787
23993	37148	2	applied	\N	\N	\N	\N	114801	114801	114802
23993	37005	3	applied	\N	\N	\N	\N	114274	114274	114275
23993	37009	4	applied	\N	\N	\N	\N	114285	114285	114286
23993	37150	5	applied	\N	\N	\N	\N	114805	114805	114806
23993	37151	6	applied	\N	\N	\N	\N	114807	114807	114808
23993	37152	7	applied	\N	\N	\N	\N	114809	114809	114810
23993	37012	8	applied	\N	\N	\N	\N	114293	114293	114294
23993	37015	9	applied	\N	\N	\N	\N	114308	114308	114309
23993	37020	10	applied	\N	\N	\N	\N	114331	114331	114332
23993	37021	11	applied	\N	\N	\N	\N	114333	114333	114334
23993	37027	12	applied	\N	\N	\N	\N	114348	114348	114349
23993	37030	13	applied	\N	\N	\N	\N	114356	114356	114357
23993	37031	14	applied	\N	\N	\N	\N	114358	114358	114359
23993	37032	15	applied	\N	\N	\N	\N	114360	114360	114361
23993	37033	16	applied	\N	\N	\N	\N	114362	114362	114363
23993	37042	17	applied	\N	\N	\N	\N	114480	114480	114481
23993	37043	18	applied	\N	\N	\N	\N	114482	114482	114483
23993	37044	19	applied	\N	\N	\N	\N	114484	114484	114485
23993	37053	20	applied	\N	\N	\N	\N	114503	114503	114504
23993	37056	21	applied	\N	\N	\N	\N	114509	114509	114510
23993	37060	22	applied	\N	\N	\N	\N	114518	114518	114519
23993	37063	23	applied	\N	\N	\N	\N	114530	114530	114531
23993	37066	24	applied	\N	\N	\N	\N	114538	114538	114539
23993	37069	25	applied	\N	\N	\N	\N	114548	114548	114549
23993	37073	26	applied	\N	\N	\N	\N	114557	114557	114558
23993	37074	27	applied	\N	\N	\N	\N	114559	114559	114560
23993	37075	28	applied	\N	\N	\N	\N	114561	114561	114562
23993	37083	29	applied	\N	\N	\N	\N	114582	114582	114583
23993	37086	30	applied	\N	\N	\N	\N	114589	114589	114590
23993	37089	31	applied	\N	\N	\N	\N	114597	114597	114598
23993	37093	32	applied	\N	\N	\N	\N	114610	114610	114611
23993	37096	33	applied	\N	\N	\N	\N	114621	114621	114622
23993	37097	34	applied	\N	\N	\N	\N	114623	114623	114624
23993	37102	35	applied	\N	\N	\N	\N	114635	114635	114636
23993	37105	36	applied	\N	\N	\N	\N	114650	114650	114651
23993	37106	37	applied	\N	\N	\N	\N	114652	114652	114653
23993	37111	38	applied	\N	\N	\N	\N	114665	114665	114666
23993	37114	39	applied	\N	\N	\N	\N	114677	114677	114678
23993	37117	40	applied	\N	\N	\N	\N	114688	114688	114689
23993	37120	41	applied	\N	\N	\N	\N	114696	114696	114697
23993	37123	42	applied	\N	\N	\N	\N	114705	114705	114706
23993	37126	43	applied	\N	\N	\N	\N	114713	114713	114714
23993	37127	44	applied	\N	\N	\N	\N	114715	114715	114716
23993	37132	45	applied	\N	\N	\N	\N	114727	114727	114728
23993	37133	46	applied	\N	\N	\N	\N	114729	114729	114730
23993	37139	47	applied	\N	\N	\N	\N	114743	114743	114744
23993	37142	48	applied	\N	\N	\N	\N	114784	114784	114785
23993	37149	49	applied	\N	\N	\N	\N	114803	114803	114804
23993	37165	50	applied	\N	\N	\N	\N	114839	114839	114840
23993	37176	51	applied	\N	\N	\N	\N	114865	114865	114866
23993	37179	52	applied	\N	\N	\N	\N	114873	114873	114874
23993	37182	53	applied	\N	\N	\N	\N	114882	114882	114883
23993	37185	54	applied	\N	\N	\N	\N	114893	114893	114894
23993	37188	55	applied	\N	\N	\N	\N	114900	114900	114901
23993	37191	56	applied	\N	\N	\N	\N	114907	114907	114908
23993	37199	57	applied	\N	\N	\N	\N	114926	114926	114927
23993	37202	58	applied	\N	\N	\N	\N	114934	114934	114935
23993	37205	59	applied	\N	\N	\N	\N	114944	114944	114945
23993	37208	60	applied	\N	\N	\N	\N	114953	114953	114954
23993	37210	61	applied	\N	\N	\N	\N	114958	114958	114959
23993	37213	62	applied	\N	\N	\N	\N	114966	114966	114967
23986	37205	0	applied	\N	\N	\N	\N	114944	114944	114945
23986	37206	1	applied	\N	\N	\N	\N	114946	114946	114947
23986	37207	2	applied	\N	\N	\N	\N	114948	114948	114949
23988	37210	0	applied	\N	\N	\N	\N	114958	114958	114959
23988	37211	1	applied	\N	\N	\N	\N	114960	114960	114961
23988	37212	2	applied	\N	\N	\N	\N	114962	114962	114963
23991	37213	0	applied	\N	\N	\N	\N	114966	114966	114967
23991	37214	1	applied	\N	\N	\N	\N	114968	114968	114969
23991	37215	2	applied	\N	\N	\N	\N	114970	114970	114971
23995	37194	0	applied	\N	\N	\N	\N	114914	114914	114915
24000	37231	0	applied	\N	\N	\N	\N	115039	115039	115040
24000	37232	1	applied	\N	\N	\N	\N	115041	115041	115042
24000	37233	2	applied	\N	\N	\N	\N	115043	115043	115044
24002	37231	0	applied	\N	\N	\N	\N	115039	115039	115040
24002	37232	1	applied	\N	\N	\N	\N	115041	115041	115042
24002	37233	2	applied	\N	\N	\N	\N	115043	115043	115044
24004	37234	0	applied	\N	\N	\N	\N	115048	115048	115049
24004	37235	1	applied	\N	\N	\N	\N	115050	115050	115051
24004	37236	2	applied	\N	\N	\N	\N	115052	115052	115053
24004	37237	3	applied	\N	\N	\N	\N	115054	115054	77733
24004	37238	4	applied	\N	\N	\N	\N	115055	115055	115056
24009	37242	0	applied	\N	\N	\N	\N	115065	115065	115066
24009	37243	1	applied	\N	\N	\N	\N	115067	115067	115068
24011	37244	0	applied	\N	\N	\N	\N	115073	115073	115074
24011	37245	1	applied	\N	\N	\N	\N	115075	115075	115076
24011	37248	2	applied	\N	\N	\N	\N	115081	115081	115086
24011	37249	3	applied	\N	\N	\N	\N	115083	115083	115087
24018	37259	0	applied	\N	\N	\N	\N	115113	115113	115114
24018	37260	1	applied	\N	\N	\N	\N	115115	115115	115116
24018	37261	2	applied	\N	\N	\N	\N	115117	115117	115118
24021	37262	0	applied	\N	\N	\N	\N	114914	114914	114915
24021	37263	1	applied	\N	\N	\N	\N	115121	115121	115122
24021	37264	2	applied	\N	\N	\N	\N	115123	115123	115124
24021	37265	3	applied	\N	\N	\N	\N	115125	115125	115126
24023	37269	0	applied	\N	\N	\N	\N	115140	115140	115141
24023	37270	1	applied	\N	\N	\N	\N	114916	114916	114917
24023	37271	2	applied	\N	\N	\N	\N	114918	114918	114919
24023	37272	3	applied	\N	\N	\N	\N	114920	114920	114921
24023	37273	4	applied	\N	\N	\N	\N	115142	115142	115143
24023	37274	5	applied	\N	\N	\N	\N	115144	115144	115145
24025	37275	0	applied	\N	\N	\N	\N	114922	114922	114923
24025	37276	1	applied	\N	\N	\N	\N	115150	115150	115151
24025	37277	2	applied	\N	\N	\N	\N	115152	115152	115153
24025	37278	3	applied	\N	\N	\N	\N	115154	115154	115155
24025	37279	4	applied	\N	\N	\N	\N	115156	115156	115157
24025	37280	5	applied	\N	\N	\N	\N	115158	115158	115159
24028	37293	0	applied	\N	\N	\N	\N	115191	115191	115192
24028	37294	1	applied	\N	\N	\N	\N	115193	115193	115194
24028	37295	2	applied	\N	\N	\N	\N	115195	115195	115196
24033	37296	0	applied	\N	\N	\N	\N	115201	115201	115202
24033	37297	1	applied	\N	\N	\N	\N	115203	115203	115204
24033	37298	2	applied	\N	\N	\N	\N	115205	115205	115206
24035	37305	0	applied	\N	\N	\N	\N	115226	115226	115227
24035	37306	1	applied	\N	\N	\N	\N	115228	115228	115229
24035	37307	2	applied	\N	\N	\N	\N	115230	115230	115231
24037	37308	0	applied	\N	\N	\N	\N	115235	115235	115236
24037	37309	1	applied	\N	\N	\N	\N	115237	115237	115238
24042	37310	0	applied	\N	\N	\N	\N	115243	115243	115244
24042	37311	1	applied	\N	\N	\N	\N	115245	115245	115246
24042	37312	2	applied	\N	\N	\N	\N	115249	115249	115250
24044	37316	0	applied	\N	\N	\N	\N	115261	115261	115262
24044	37317	1	applied	\N	\N	\N	\N	115263	115263	115264
24046	37318	0	applied	\N	\N	\N	\N	115268	115268	115269
24046	37319	1	applied	\N	\N	\N	\N	115270	115270	115271
24046	37320	2	applied	\N	\N	\N	\N	115272	115272	115273
24053	37332	0	applied	\N	\N	\N	\N	115301	115301	115302
24053	37333	1	applied	\N	\N	\N	\N	115303	115303	115304
24053	37334	2	applied	\N	\N	\N	\N	115305	115305	115306
24053	37335	3	applied	\N	\N	\N	\N	115307	115307	115308
24056	37338	0	applied	\N	\N	\N	\N	115322	115322	115323
24056	37339	1	applied	\N	\N	\N	\N	115324	115324	115325
24059	37342	0	applied	\N	\N	\N	\N	115334	115334	115335
24059	37343	1	applied	\N	\N	\N	\N	115336	115336	115337
24061	37346	0	applied	\N	\N	\N	\N	115347	115347	115348
24061	37347	1	applied	\N	\N	\N	\N	115349	115349	115350
24063	37285	0	applied	\N	\N	\N	\N	115172	115172	115173
24063	37276	1	applied	\N	\N	\N	\N	115150	115150	115151
24063	37216	2	applied	\N	\N	\N	\N	114998	114998	114999
24063	37219	3	applied	\N	\N	\N	\N	115008	115008	115009
24063	37277	4	applied	\N	\N	\N	\N	115152	115152	115153
24063	37281	5	applied	\N	\N	\N	\N	115164	115164	115165
24063	37282	6	applied	\N	\N	\N	\N	115166	115166	115167
24063	37286	7	applied	\N	\N	\N	\N	115174	115174	115175
24063	37287	8	applied	\N	\N	\N	\N	115176	115176	115177
24063	37288	9	applied	\N	\N	\N	\N	115178	115178	115179
24063	37222	10	applied	\N	\N	\N	\N	115017	115017	115018
24063	37223	11	applied	\N	\N	\N	\N	115019	115019	115020
24063	37224	12	applied	\N	\N	\N	\N	115021	115021	115022
24063	37231	13	applied	\N	\N	\N	\N	115039	115039	115040
24063	37234	14	applied	\N	\N	\N	\N	115048	115048	115049
24063	37239	15	applied	\N	\N	\N	\N	115059	115059	115060
24063	37242	16	applied	\N	\N	\N	\N	115065	115065	115066
24063	37244	17	applied	\N	\N	\N	\N	115073	115073	115074
24063	37245	18	applied	\N	\N	\N	\N	115075	115075	115076
24063	37250	19	applied	\N	\N	\N	\N	115089	115089	115090
24063	37253	20	applied	\N	\N	\N	\N	115099	115099	115100
24063	37256	21	applied	\N	\N	\N	\N	115107	115107	115108
24063	37259	22	applied	\N	\N	\N	\N	115113	115113	115114
24063	37263	23	applied	\N	\N	\N	\N	115121	115121	115122
24063	37266	24	applied	\N	\N	\N	\N	115132	115132	115133
24063	37269	25	applied	\N	\N	\N	\N	115140	115140	115141
24063	37278	26	applied	\N	\N	\N	\N	115154	115154	115155
24063	37283	27	applied	\N	\N	\N	\N	115168	115168	115169
24063	37284	28	applied	\N	\N	\N	\N	115170	115170	115171
24063	37293	29	applied	\N	\N	\N	\N	115191	115191	115192
24063	37296	30	applied	\N	\N	\N	\N	115201	115201	115202
24063	37299	31	applied	\N	\N	\N	\N	115213	115213	115214
24063	37300	32	applied	\N	\N	\N	\N	115215	115215	115216
24063	37305	33	applied	\N	\N	\N	\N	115226	115226	115227
24063	37308	34	applied	\N	\N	\N	\N	115235	115235	115236
24063	37310	35	applied	\N	\N	\N	\N	115243	115243	115244
24063	37313	36	applied	\N	\N	\N	\N	115253	115253	115254
24063	37318	37	applied	\N	\N	\N	\N	115268	115268	115269
24063	37321	38	applied	\N	\N	\N	\N	115276	115276	115277
24063	37322	39	applied	\N	\N	\N	\N	115278	115278	115279
24063	37327	40	applied	\N	\N	\N	\N	115288	115288	115289
24063	37328	41	applied	\N	\N	\N	\N	115290	115290	115291
24063	37332	42	applied	\N	\N	\N	\N	115301	115301	115302
24063	37333	43	applied	\N	\N	\N	\N	115303	115303	115304
24063	37336	44	applied	\N	\N	\N	\N	115317	115317	115318
23993	37153	63	applied	\N	\N	\N	\N	114811	114811	114812
23993	37154	64	applied	\N	\N	\N	\N	114813	114813	114814
23993	37155	65	applied	\N	\N	\N	\N	114815	114815	114816
23993	37156	66	applied	\N	\N	\N	\N	114817	114817	114818
23993	37157	67	applied	\N	\N	\N	\N	114819	114819	114820
23993	37158	68	applied	\N	\N	\N	\N	114821	114821	114822
23993	37159	69	applied	\N	\N	\N	\N	114823	114823	114824
23993	37162	70	applied	\N	\N	\N	\N	114833	114833	114834
23993	37163	71	applied	\N	\N	\N	\N	114835	114835	114836
23993	37164	72	applied	\N	\N	\N	\N	114837	114837	114838
23993	37166	73	applied	\N	\N	\N	\N	114841	114841	114842
23993	37167	74	applied	\N	\N	\N	\N	114843	114843	114844
23993	37168	75	applied	\N	\N	\N	\N	114845	114845	114846
23993	37171	76	applied	\N	\N	\N	\N	114855	114855	114856
23993	37172	77	applied	\N	\N	\N	\N	114857	114857	114858
23993	37173	78	applied	\N	\N	\N	\N	114859	114859	114860
23993	37174	79	applied	\N	\N	\N	\N	114861	114861	114862
23993	37175	80	applied	\N	\N	\N	\N	114863	114863	114864
23993	37194	81	applied	\N	\N	\N	\N	114914	114914	114915
23993	37195	82	applied	\N	\N	\N	\N	114916	114916	114917
23993	37196	83	applied	\N	\N	\N	\N	114918	114918	114919
23993	37197	84	applied	\N	\N	\N	\N	114920	114920	114921
23993	37198	85	applied	\N	\N	\N	\N	114922	114922	114923
23993	37006	86	applied	\N	\N	\N	\N	114276	114276	114277
23993	37007	87	applied	\N	\N	\N	\N	114278	114278	114279
23993	37018	88	applied	\N	\N	\N	\N	114314	114314	114976
23993	37024	89	applied	\N	\N	\N	\N	114339	114339	114977
23993	37035	90	applied	\N	\N	\N	\N	114366	114366	114281
23993	37051	91	applied	\N	\N	\N	\N	114498	114498	23829
23993	37011	92	applied	\N	\N	\N	\N	114289	114289	114978
23993	37014	93	applied	\N	\N	\N	\N	114297	114297	114979
23993	37016	94	applied	\N	\N	\N	\N	114310	114310	114980
23993	37019	95	applied	\N	\N	\N	\N	114324	114324	114296
23993	37022	96	applied	\N	\N	\N	\N	114335	114335	114298
23993	37023	97	applied	\N	\N	\N	\N	114337	114337	114311
23993	37028	98	applied	\N	\N	\N	\N	114350	114350	114981
23993	37039	99	applied	\N	\N	\N	\N	114374	114374	114315
23993	37052	100	applied	\N	\N	\N	\N	114499	114499	114982
23993	37057	101	applied	\N	\N	\N	\N	114511	114511	114325
23993	37071	102	applied	\N	\N	\N	\N	114552	114552	114983
23993	37076	103	applied	\N	\N	\N	\N	114563	114563	114336
23993	37091	104	applied	\N	\N	\N	\N	114601	114601	114984
23993	37040	105	applied	\N	\N	\N	\N	114376	114376	114340
23993	37041	106	applied	\N	\N	\N	\N	114378	114378	114985
23993	37045	107	applied	\N	\N	\N	\N	114486	114486	114986
23993	37047	108	applied	\N	\N	\N	\N	114490	114490	114344
23993	37048	109	applied	\N	\N	\N	\N	114492	114492	114351
23993	37054	110	applied	\N	\N	\N	\N	114505	114505	114987
23993	37059	111	applied	\N	\N	\N	\N	114515	114515	114988
23993	37061	112	applied	\N	\N	\N	\N	114520	114520	114365
23993	37065	113	applied	\N	\N	\N	\N	114534	114534	114989
23993	37068	114	applied	\N	\N	\N	\N	114542	114542	114369
23993	37072	115	applied	\N	\N	\N	\N	114554	114554	114990
23993	37077	116	applied	\N	\N	\N	\N	114567	114567	114991
23993	37078	117	applied	\N	\N	\N	\N	114570	114570	114373
23993	37079	119	applied	\N	\N	\N	\N	114572	114572	114375
23993	37084	120	applied	\N	\N	\N	\N	114584	114584	114377
23993	37088	121	applied	\N	\N	\N	\N	114593	114593	114379
23993	37090	122	applied	\N	\N	\N	\N	114599	114599	114487
23993	37094	123	applied	\N	\N	\N	\N	114612	114612	114993
23993	37099	124	applied	\N	\N	\N	\N	114627	114627	114994
23993	37101	125	applied	\N	\N	\N	\N	114631	114631	114995
23994	37216	0	applied	\N	\N	\N	\N	114998	114998	114999
23994	37217	1	applied	\N	\N	\N	\N	115000	115000	115001
23994	37218	2	applied	\N	\N	\N	\N	115002	115002	115003
23997	37219	0	applied	\N	\N	\N	\N	115008	115008	115009
23997	37220	1	applied	\N	\N	\N	\N	115010	115010	115011
23997	37221	2	applied	\N	\N	\N	\N	115012	115012	115013
24006	37239	0	applied	\N	\N	\N	\N	115059	115059	115060
24006	37240	1	applied	\N	\N	\N	\N	115061	115061	115062
24006	37241	2	applied	\N	\N	\N	\N	115063	115063	115064
24020	37262	0	applied	\N	\N	\N	\N	114914	114914	114915
24020	37263	1	applied	\N	\N	\N	\N	115121	115121	115122
24020	37264	2	applied	\N	\N	\N	\N	115123	115123	115124
24020	37265	3	applied	\N	\N	\N	\N	115125	115125	115126
24022	37266	0	applied	\N	\N	\N	\N	115132	115132	115133
24022	37267	1	applied	\N	\N	\N	\N	115134	115134	115135
24022	37268	2	applied	\N	\N	\N	\N	115136	115136	115137
24027	37281	0	applied	\N	\N	\N	\N	115164	115164	115165
24027	37282	1	applied	\N	\N	\N	\N	115166	115166	115167
24027	37283	2	applied	\N	\N	\N	\N	115168	115168	115169
24027	37284	3	applied	\N	\N	\N	\N	115170	115170	115171
24027	37285	4	applied	\N	\N	\N	\N	115172	115172	115173
24027	37286	5	applied	\N	\N	\N	\N	115174	115174	115175
24027	37287	6	applied	\N	\N	\N	\N	115176	115176	115177
24027	37288	7	applied	\N	\N	\N	\N	115178	115178	115179
24027	37289	8	applied	\N	\N	\N	\N	115180	115180	115181
24027	37290	9	applied	\N	\N	\N	\N	115182	115182	115183
24027	37291	10	applied	\N	\N	\N	\N	115184	115184	115185
24027	37292	11	applied	\N	\N	\N	\N	115186	115186	115187
24032	37296	0	applied	\N	\N	\N	\N	115201	115201	115202
24032	37297	1	applied	\N	\N	\N	\N	115203	115203	115204
24032	37298	2	applied	\N	\N	\N	\N	115205	115205	115206
24034	37299	0	applied	\N	\N	\N	\N	115213	115213	115214
24034	37300	1	applied	\N	\N	\N	\N	115215	115215	115216
24034	37301	2	applied	\N	\N	\N	\N	115217	115217	115218
24034	37302	3	applied	\N	\N	\N	\N	115219	115219	115220
24034	37303	4	applied	\N	\N	\N	\N	115221	115221	115222
24034	37304	5	applied	\N	\N	\N	\N	115223	115223	115224
24039	37308	0	applied	\N	\N	\N	\N	115235	115235	115236
24039	37309	1	applied	\N	\N	\N	\N	115237	115237	115238
24041	37310	0	applied	\N	\N	\N	\N	115243	115243	115244
24041	37311	1	applied	\N	\N	\N	\N	115245	115245	115246
24043	37313	0	applied	\N	\N	\N	\N	115253	115253	115254
24043	37314	1	applied	\N	\N	\N	\N	115255	115255	115256
24043	37312	2	applied	\N	\N	\N	\N	115249	115249	115257
24043	37315	3	applied	\N	\N	\N	\N	115258	115258	115259
24049	37327	0	applied	\N	\N	\N	\N	115288	115288	115289
24049	37328	1	applied	\N	\N	\N	\N	115290	115290	115291
24049	37329	2	applied	\N	\N	\N	\N	115292	115292	115293
24049	37330	3	applied	\N	\N	\N	\N	115294	115294	115295
24049	37331	4	applied	\N	\N	\N	\N	115296	115296	115297
24052	37332	0	applied	\N	\N	\N	\N	115301	115301	115302
24052	37333	1	applied	\N	\N	\N	\N	115303	115303	115304
24058	37342	0	applied	\N	\N	\N	\N	115334	115334	115335
24058	37343	1	applied	\N	\N	\N	\N	115336	115336	115337
24069	37364	0	applied	\N	\N	\N	\N	115435	115435	115436
24069	37365	1	applied	\N	\N	\N	\N	115437	115437	115438
24072	37370	0	applied	\N	\N	\N	\N	115449	115449	115450
24072	37371	1	applied	\N	\N	\N	\N	115451	115451	115452
24054	37335	3	applied	\N	\N	\N	\N	115307	115307	115308
24055	37336	0	applied	\N	\N	\N	\N	115317	115317	115318
24055	37334	1	applied	\N	\N	\N	\N	115305	115305	115306
24055	37335	2	applied	\N	\N	\N	\N	115307	115307	115308
24055	37337	3	applied	\N	\N	\N	\N	115319	115319	115320
24060	37344	0	applied	\N	\N	\N	\N	115341	115341	115342
24060	37345	1	applied	\N	\N	\N	\N	115343	115343	115344
24068	37354	0	applied	\N	\N	\N	\N	115413	115413	115414
24068	37355	1	applied	\N	\N	\N	\N	115415	115415	115416
24068	37356	2	applied	\N	\N	\N	\N	115417	115417	115418
24068	37357	3	applied	\N	\N	\N	\N	115419	115419	115420
24068	37358	4	applied	\N	\N	\N	\N	115421	115421	115422
24068	37359	5	applied	\N	\N	\N	\N	115423	115423	115424
24068	37360	6	applied	\N	\N	\N	\N	115425	115425	115426
24068	37361	7	applied	\N	\N	\N	\N	115427	115427	115428
24068	37362	8	applied	\N	\N	\N	\N	115429	115429	115430
24068	37363	9	applied	\N	\N	\N	\N	115431	115431	115432
24071	37370	0	applied	\N	\N	\N	\N	115449	115449	115450
24071	37371	1	applied	\N	\N	\N	\N	115451	115451	115452
24076	37376	0	applied	\N	\N	\N	\N	115469	115469	115470
24076	37377	1	applied	\N	\N	\N	\N	115471	115471	115472
24082	37386	0	applied	\N	\N	\N	\N	115496	115496	115497
24082	37387	1	applied	\N	\N	\N	\N	115498	115498	115499
24084	37392	0	applied	\N	\N	\N	\N	115514	115514	115515
24088	37393	0	applied	\N	\N	\N	\N	115518	115518	115519
24088	37394	1	applied	\N	\N	\N	\N	115521	115521	115522
24088	37395	2	applied	\N	\N	\N	\N	115523	115523	115524
24088	37396	3	applied	\N	\N	\N	\N	115525	115525	115526
24088	37397	4	applied	\N	\N	\N	\N	115527	115527	115528
24088	37398	5	applied	\N	\N	\N	\N	115529	115529	115530
24088	37399	6	applied	\N	\N	\N	\N	115531	115531	115532
24088	37400	7	applied	\N	\N	\N	\N	115533	115533	115534
24095	37411	0	applied	\N	\N	\N	\N	115568	115568	115569
24095	37412	1	applied	\N	\N	\N	\N	115570	115570	115571
24101	37416	0	applied	\N	\N	\N	\N	115587	115587	115588
24101	37417	1	applied	\N	\N	\N	\N	115589	115589	115590
24111	37424	0	applied	\N	\N	\N	\N	115610	115610	115611
24119	37427	0	applied	\N	\N	\N	\N	115621	115621	115622
24119	37428	1	applied	\N	\N	\N	\N	115623	115623	115624
24119	37429	2	applied	\N	\N	\N	\N	115625	115625	115626
24119	37430	3	applied	\N	\N	\N	\N	115627	115627	115628
24119	37431	4	applied	\N	\N	\N	\N	115629	115629	115630
24119	37432	5	applied	\N	\N	\N	\N	115631	115631	115632
24119	37433	6	applied	\N	\N	\N	\N	115633	115633	115634
24119	37434	7	applied	\N	\N	\N	\N	115635	115635	115636
24119	37435	8	applied	\N	\N	\N	\N	115637	115637	115638
24119	37436	9	applied	\N	\N	\N	\N	115639	115639	115640
24121	37437	0	applied	\N	\N	\N	\N	115645	115645	115646
24121	37438	1	applied	\N	\N	\N	\N	115647	115647	115648
24123	37439	0	applied	\N	\N	\N	\N	115650	115650	115651
24123	37440	1	applied	\N	\N	\N	\N	115652	115652	115653
24123	37441	2	applied	\N	\N	\N	\N	115654	115654	115655
24123	37442	3	applied	\N	\N	\N	\N	115656	115656	115657
24126	37445	0	applied	\N	\N	\N	\N	115668	115668	115669
24126	37446	1	applied	\N	\N	\N	\N	115670	115670	115671
24126	37447	2	applied	\N	\N	\N	\N	115672	115672	115673
24126	37448	3	applied	\N	\N	\N	\N	115674	115674	115675
24128	37449	0	applied	\N	\N	\N	\N	115677	115677	115678
24128	37450	1	applied	\N	\N	\N	\N	115679	115679	115680
24131	37453	0	applied	\N	\N	\N	\N	115693	115693	115694
24131	37454	1	applied	\N	\N	\N	\N	115695	115695	115696
24131	37455	2	applied	\N	\N	\N	\N	115697	115697	115698
24131	37456	3	applied	\N	\N	\N	\N	115699	115699	115700
24131	37457	4	applied	\N	\N	\N	\N	115701	115701	115702
24131	37458	5	applied	\N	\N	\N	\N	115703	115703	115704
24131	37459	6	applied	\N	\N	\N	\N	115705	115705	115706
24131	37460	7	applied	\N	\N	\N	\N	115707	115707	115708
24134	37467	0	applied	\N	\N	\N	\N	115724	115724	115725
24134	37468	1	applied	\N	\N	\N	\N	115726	115726	115727
24143	37483	0	applied	\N	\N	\N	\N	115768	115768	115769
24143	37484	1	applied	\N	\N	\N	\N	115770	115770	115771
24143	37481	2	applied	\N	\N	\N	\N	115763	115763	115764
24143	37482	3	applied	\N	\N	\N	\N	115765	115765	115766
24157	37500	0	applied	\N	\N	\N	\N	115929	115929	115930
24157	37501	1	applied	\N	\N	\N	\N	115931	115931	115932
24157	37502	2	applied	\N	\N	\N	\N	115933	115933	115934
24161	37503	0	applied	\N	\N	\N	\N	115941	115941	115942
24161	37504	1	applied	\N	\N	\N	\N	115943	115943	115944
24164	37505	0	applied	\N	\N	\N	\N	115951	115951	115952
24164	37506	1	applied	\N	\N	\N	\N	115953	115953	115954
24164	37507	2	applied	\N	\N	\N	\N	115955	115955	115956
24164	33609	3	applied	\N	\N	\N	\N	115957	115957	103761
24164	37508	4	applied	\N	\N	\N	\N	115958	115958	115959
24164	37509	5	applied	\N	\N	\N	\N	115960	115960	115961
24164	37510	6	applied	\N	\N	\N	\N	115962	115962	115963
24164	37511	7	applied	\N	\N	\N	\N	115964	115964	115965
24166	37512	0	applied	\N	\N	\N	\N	115968	115968	115969
24166	37513	1	applied	\N	\N	\N	\N	115970	115970	115971
24171	37522	0	applied	\N	\N	\N	\N	115993	115993	115994
24171	37523	1	applied	\N	\N	\N	\N	115995	115995	115996
24171	37524	2	applied	\N	\N	\N	\N	115997	115997	115998
24171	37525	3	applied	\N	\N	\N	\N	115999	115999	116000
24171	37526	4	applied	\N	\N	\N	\N	116001	116001	116002
24174	37535	0	applied	\N	\N	\N	\N	116024	116024	116025
24174	37536	1	applied	\N	\N	\N	\N	116026	116026	116027
24176	37535	0	applied	\N	\N	\N	\N	116024	116024	116025
24176	37536	1	applied	\N	\N	\N	\N	116026	116026	116027
24179	37546	0	applied	\N	\N	\N	\N	116052	116052	116053
24186	37555	0	applied	\N	\N	\N	\N	116076	116076	116077
24186	37556	1	applied	\N	\N	\N	\N	116078	116078	116079
24186	37557	2	applied	\N	\N	\N	\N	116080	116080	116081
24191	37558	0	applied	\N	\N	\N	\N	116098	116098	116099
24191	37559	1	applied	\N	\N	\N	\N	116100	116100	116101
24202	37580	0	applied	\N	\N	\N	\N	116160	116160	116161
24202	37581	1	applied	\N	\N	\N	\N	116162	116162	116163
24202	37582	2	applied	\N	\N	\N	\N	116164	116164	116165
24205	37583	0	applied	\N	\N	\N	\N	116169	116169	116170
24205	37584	1	applied	\N	\N	\N	\N	116171	116171	116172
24205	37585	2	applied	\N	\N	\N	\N	116173	116173	116174
24205	37586	3	applied	\N	\N	\N	\N	116175	116175	116176
24205	37587	4	applied	\N	\N	\N	\N	116177	116177	116178
24205	37588	5	applied	\N	\N	\N	\N	116179	116179	116180
24212	37592	0	applied	\N	\N	\N	\N	116197	116197	116198
24212	37593	1	applied	\N	\N	\N	\N	116199	116199	116200
24212	37594	2	applied	\N	\N	\N	\N	116201	116201	116202
24212	37595	3	applied	\N	\N	\N	\N	116203	116203	116204
24212	37596	4	applied	\N	\N	\N	\N	116205	116205	116206
24212	37597	5	applied	\N	\N	\N	\N	116207	116207	116208
24212	37598	6	applied	\N	\N	\N	\N	116209	116209	116210
24219	37608	0	applied	\N	\N	\N	\N	116242	116242	116243
24063	37338	45	applied	\N	\N	\N	\N	115322	115322	115323
24063	37340	46	applied	\N	\N	\N	\N	115328	115328	115329
24063	37342	47	applied	\N	\N	\N	\N	115334	115334	115335
24063	37344	48	applied	\N	\N	\N	\N	115341	115341	115342
24063	37346	49	applied	\N	\N	\N	\N	115347	115347	115348
24063	37237	50	applied	\N	\N	\N	\N	115054	115054	77733
24063	37238	51	applied	\N	\N	\N	\N	115055	115055	115056
24063	37104	52	applied	\N	\N	\N	\N	114639	114639	115352
24063	37109	53	applied	\N	\N	\N	\N	114658	114658	114495
24063	37110	54	applied	\N	\N	\N	\N	114660	114660	115353
24063	37113	55	applied	\N	\N	\N	\N	114671	114671	114500
24063	37115	56	applied	\N	\N	\N	\N	114680	114680	114506
24063	37118	57	applied	\N	\N	\N	\N	114690	114690	115354
24063	37122	58	applied	\N	\N	\N	\N	114700	114700	114512
24063	37124	59	applied	\N	\N	\N	\N	114707	114707	115355
24063	37130	60	applied	\N	\N	\N	\N	114721	114721	115356
24063	37131	61	applied	\N	\N	\N	\N	114723	114723	115357
24063	37137	62	applied	\N	\N	\N	\N	114737	114737	115358
24063	37138	63	applied	\N	\N	\N	\N	114739	114739	114523
24063	37140	64	applied	\N	\N	\N	\N	114745	114745	115359
24063	37144	65	applied	\N	\N	\N	\N	114788	114788	115360
24063	37147	66	applied	\N	\N	\N	\N	114797	114797	115361
24063	37160	67	applied	\N	\N	\N	\N	114825	114825	114541
24063	37169	68	applied	\N	\N	\N	\N	114847	114847	114543
24063	37178	69	applied	\N	\N	\N	\N	114869	114869	115362
24063	37180	70	applied	\N	\N	\N	\N	114876	114876	114553
24063	37183	71	applied	\N	\N	\N	\N	114884	114884	114555
24063	37186	72	applied	\N	\N	\N	\N	114895	114895	114568
24063	37189	73	applied	\N	\N	\N	\N	114902	114902	115363
24063	37193	74	applied	\N	\N	\N	\N	114911	114911	115364
24063	37200	75	applied	\N	\N	\N	\N	114928	114928	115365
24063	37203	76	applied	\N	\N	\N	\N	114936	114936	114575
24063	37207	77	applied	\N	\N	\N	\N	114948	114948	115366
24063	37209	78	applied	\N	\N	\N	\N	114955	114955	115367
24063	37008	79	applied	\N	\N	\N	\N	114280	114280	115368
24063	37010	80	applied	\N	\N	\N	\N	114287	114287	115369
24063	37013	81	applied	\N	\N	\N	\N	114295	114295	115370
24063	37017	82	applied	\N	\N	\N	\N	114312	114312	114594
24063	37025	83	applied	\N	\N	\N	\N	114341	114341	114602
24063	37026	84	applied	\N	\N	\N	\N	114343	114343	114604
24063	37029	85	applied	\N	\N	\N	\N	114352	114352	115371
24063	37034	86	applied	\N	\N	\N	\N	114364	114364	115372
24063	37036	87	applied	\N	\N	\N	\N	114368	114368	115373
24063	37037	88	applied	\N	\N	\N	\N	114370	114370	115374
24063	37038	89	applied	\N	\N	\N	\N	114372	114372	114632
24063	37046	90	applied	\N	\N	\N	\N	114488	114488	114638
24063	37049	91	applied	\N	\N	\N	\N	114494	114494	115375
24063	37050	92	applied	\N	\N	\N	\N	114496	114496	114675
24063	37055	93	applied	\N	\N	\N	\N	114507	114507	115376
24063	37058	94	applied	\N	\N	\N	\N	114513	114513	114661
24063	37062	95	applied	\N	\N	\N	\N	114522	114522	114670
24063	37064	96	applied	\N	\N	\N	\N	114532	114532	115377
24063	37067	97	applied	\N	\N	\N	\N	114540	114540	115378
24063	37070	98	applied	\N	\N	\N	\N	114550	114550	114691
24063	37080	99	applied	\N	\N	\N	\N	114574	114574	114693
24063	37081	100	applied	\N	\N	\N	\N	114576	114576	114699
24063	37082	101	applied	\N	\N	\N	\N	114578	114578	115379
24063	37085	102	applied	\N	\N	\N	\N	114586	114586	115380
24063	37087	103	applied	\N	\N	\N	\N	114591	114591	115381
24063	37092	104	applied	\N	\N	\N	\N	114603	114603	115382
24063	37095	105	applied	\N	\N	\N	\N	114615	114615	114722
24063	37098	106	applied	\N	\N	\N	\N	114625	114625	115383
24063	37100	107	applied	\N	\N	\N	\N	114629	114629	115384
24063	37103	108	applied	\N	\N	\N	\N	114637	114637	115385
24063	37107	109	applied	\N	\N	\N	\N	114654	114654	114740
24063	37108	110	applied	\N	\N	\N	\N	114656	114656	115386
24063	37112	111	applied	\N	\N	\N	\N	114667	114667	115387
24063	37116	112	applied	\N	\N	\N	\N	114683	114683	115388
24063	37119	113	applied	\N	\N	\N	\N	114692	114692	115389
24063	37121	114	applied	\N	\N	\N	\N	114698	114698	114798
24063	37125	115	applied	\N	\N	\N	\N	114709	114709	114829
24063	37128	116	applied	\N	\N	\N	\N	114717	114717	115390
24063	37129	117	applied	\N	\N	\N	\N	114719	114719	115391
24063	37135	119	applied	\N	\N	\N	\N	114733	114733	115393
24063	37136	120	applied	\N	\N	\N	\N	114735	114735	114870
24063	37141	121	applied	\N	\N	\N	\N	114747	114747	115394
24063	37145	122	applied	\N	\N	\N	\N	114792	114792	115395
24063	37146	123	applied	\N	\N	\N	\N	114795	114795	115396
24063	37161	124	applied	\N	\N	\N	\N	114828	114828	114896
24063	37170	125	applied	\N	\N	\N	\N	114850	114850	114898
24066	37348	0	applied	\N	\N	\N	\N	115400	115400	115401
24066	37349	1	applied	\N	\N	\N	\N	115402	115402	115403
24066	37350	2	applied	\N	\N	\N	\N	115404	115404	115405
24066	37351	3	applied	\N	\N	\N	\N	115406	115406	115407
24066	37352	4	applied	\N	\N	\N	\N	115408	115408	115409
24066	37353	5	applied	\N	\N	\N	\N	115410	115410	115411
24070	37366	0	applied	\N	\N	\N	\N	115440	115440	115441
24070	37367	1	applied	\N	\N	\N	\N	115442	115442	115443
24070	37368	2	applied	\N	\N	\N	\N	115444	115444	115445
24070	37369	3	applied	\N	\N	\N	\N	115446	115446	115447
24075	37374	0	applied	\N	\N	\N	\N	115461	115461	115462
24075	37375	1	applied	\N	\N	\N	\N	115463	115463	115464
24077	37378	0	applied	\N	\N	\N	\N	115475	115475	115476
24077	37379	1	applied	\N	\N	\N	\N	115477	115477	115478
24078	37380	0	applied	\N	\N	\N	\N	115480	115480	115481
24078	37381	1	applied	\N	\N	\N	\N	115482	115482	115483
24078	37382	2	applied	\N	\N	\N	\N	115484	115484	115485
24078	37383	3	applied	\N	\N	\N	\N	115486	115486	115487
24078	37384	4	applied	\N	\N	\N	\N	115488	115488	115489
24078	37385	5	applied	\N	\N	\N	\N	115490	115490	115491
24080	37386	0	applied	\N	\N	\N	\N	115496	115496	115497
24080	37387	1	applied	\N	\N	\N	\N	115498	115498	115499
24086	37393	0	applied	\N	\N	\N	\N	115518	115518	115519
24086	37394	1	applied	\N	\N	\N	\N	115521	115521	115522
24086	37395	2	applied	\N	\N	\N	\N	115523	115523	115524
24086	37396	3	applied	\N	\N	\N	\N	115525	115525	115526
24086	37397	4	applied	\N	\N	\N	\N	115527	115527	115528
24086	37398	5	applied	\N	\N	\N	\N	115529	115529	115530
24086	37399	6	applied	\N	\N	\N	\N	115531	115531	115532
24086	37400	7	applied	\N	\N	\N	\N	115533	115533	115534
24090	37401	0	applied	\N	\N	\N	\N	115541	115541	115542
24090	37402	1	applied	\N	\N	\N	\N	115543	115543	115544
24093	37407	0	applied	\N	\N	\N	\N	115558	115558	115559
24093	37408	1	applied	\N	\N	\N	\N	115560	115560	115561
24093	37409	2	applied	\N	\N	\N	\N	115562	115562	115563
24093	37410	3	applied	\N	\N	\N	\N	115564	115564	115565
24098	37413	0	applied	\N	\N	\N	\N	115575	115575	115576
24098	37414	1	applied	\N	\N	\N	\N	115577	115577	115578
24100	37415	0	applied	\N	\N	\N	\N	115583	115583	115584
24105	37418	0	applied	\N	\N	\N	\N	115593	115593	115594
24074	37374	0	applied	\N	\N	\N	\N	115461	115461	115462
24074	37375	1	applied	\N	\N	\N	\N	115463	115463	115464
24085	37393	0	applied	\N	\N	\N	\N	115518	115518	115519
24085	37392	1	applied	\N	\N	\N	\N	115514	115514	115515
24089	37393	0	applied	\N	\N	\N	\N	115518	115518	115519
24089	37394	1	applied	\N	\N	\N	\N	115521	115521	115522
24089	37395	2	applied	\N	\N	\N	\N	115523	115523	115524
24089	37396	3	applied	\N	\N	\N	\N	115525	115525	115526
24089	37397	4	applied	\N	\N	\N	\N	115527	115527	115528
24089	37398	5	applied	\N	\N	\N	\N	115529	115529	115530
24089	37399	6	applied	\N	\N	\N	\N	115531	115531	115532
24089	37400	7	applied	\N	\N	\N	\N	115533	115533	115534
24092	37405	0	applied	\N	\N	\N	\N	115552	115552	115553
24092	37406	1	applied	\N	\N	\N	\N	115554	115554	115555
24096	37411	0	applied	\N	\N	\N	\N	115568	115568	115569
24096	37412	1	applied	\N	\N	\N	\N	115570	115570	115571
24097	37413	0	applied	\N	\N	\N	\N	115575	115575	115576
24097	37414	1	applied	\N	\N	\N	\N	115577	115577	115578
24102	37416	0	applied	\N	\N	\N	\N	115587	115587	115588
24102	37417	1	applied	\N	\N	\N	\N	115589	115589	115590
24104	37418	0	applied	\N	\N	\N	\N	115593	115593	115594
24104	37419	1	applied	\N	\N	\N	\N	115595	115595	115596
24112	37424	0	applied	\N	\N	\N	\N	115610	115610	115611
24117	37426	0	applied	\N	\N	\N	\N	115616	115616	115617
24122	37437	0	applied	\N	\N	\N	\N	115645	115645	115646
24122	37438	1	applied	\N	\N	\N	\N	115647	115647	115648
24124	37439	0	applied	\N	\N	\N	\N	115650	115650	115651
24124	37440	1	applied	\N	\N	\N	\N	115652	115652	115653
24124	37441	2	applied	\N	\N	\N	\N	115654	115654	115655
24124	37442	3	applied	\N	\N	\N	\N	115656	115656	115657
24129	37451	0	applied	\N	\N	\N	\N	115685	115685	115686
24129	37452	1	applied	\N	\N	\N	\N	115687	115687	115688
24132	37453	0	applied	\N	\N	\N	\N	115693	115693	115694
24132	37454	1	applied	\N	\N	\N	\N	115695	115695	115696
24132	37455	2	applied	\N	\N	\N	\N	115697	115697	115698
24132	37456	3	applied	\N	\N	\N	\N	115699	115699	115700
24132	37457	4	applied	\N	\N	\N	\N	115701	115701	115702
24132	37458	5	applied	\N	\N	\N	\N	115703	115703	115704
24132	37459	6	applied	\N	\N	\N	\N	115705	115705	115706
24132	37460	7	applied	\N	\N	\N	\N	115707	115707	115708
24135	37467	0	applied	\N	\N	\N	\N	115724	115724	115725
24135	37468	1	applied	\N	\N	\N	\N	115726	115726	115727
24137	37469	0	applied	\N	\N	\N	\N	115734	115734	115735
24137	37470	1	applied	\N	\N	\N	\N	115736	115736	115737
24139	37473	0	applied	\N	\N	\N	\N	115744	115744	115745
24139	37474	1	applied	\N	\N	\N	\N	115746	115746	115747
24140	37475	0	applied	\N	\N	\N	\N	115750	115750	115751
24140	37476	1	applied	\N	\N	\N	\N	115752	115752	115753
24140	37477	2	applied	\N	\N	\N	\N	115754	115754	115755
24140	37478	3	applied	\N	\N	\N	\N	115756	115756	115757
24140	37479	4	applied	\N	\N	\N	\N	115758	115758	115759
24140	37480	5	applied	\N	\N	\N	\N	115760	115760	115761
24147	37485	0	applied	\N	\N	\N	\N	115884	115884	115885
24147	37486	1	applied	\N	\N	\N	\N	115886	115886	115887
24152	37488	0	applied	\N	\N	\N	\N	115900	115900	115901
24152	37489	1	applied	\N	\N	\N	\N	115902	115902	115903
24152	37490	2	applied	\N	\N	\N	\N	115904	115904	115905
24152	37491	3	applied	\N	\N	\N	\N	115906	115906	115907
24152	37492	4	applied	\N	\N	\N	\N	115908	115908	115909
24154	37493	0	applied	\N	\N	\N	\N	115913	115913	115914
24154	37494	1	applied	\N	\N	\N	\N	115915	115915	115916
24154	37495	2	applied	\N	\N	\N	\N	115917	115917	115918
24158	37500	0	applied	\N	\N	\N	\N	115929	115929	115930
24158	37501	1	applied	\N	\N	\N	\N	115931	115931	115932
24158	37502	2	applied	\N	\N	\N	\N	115933	115933	115934
24159	37503	0	applied	\N	\N	\N	\N	115941	115941	115942
24159	37504	1	applied	\N	\N	\N	\N	115943	115943	115944
24169	37520	0	applied	\N	\N	\N	\N	115987	115987	115988
24169	37521	1	applied	\N	\N	\N	\N	115989	115989	115990
24172	37522	0	applied	\N	\N	\N	\N	115993	115993	115994
24172	37523	1	applied	\N	\N	\N	\N	115995	115995	115996
24172	37524	2	applied	\N	\N	\N	\N	115997	115997	115998
24172	37525	3	applied	\N	\N	\N	\N	115999	115999	116000
24172	37526	4	applied	\N	\N	\N	\N	116001	116001	116002
24175	37535	0	applied	\N	\N	\N	\N	116024	116024	116025
24175	37536	1	applied	\N	\N	\N	\N	116026	116026	116027
24180	37546	0	applied	\N	\N	\N	\N	116052	116052	116053
24180	37547	1	applied	\N	\N	\N	\N	116056	116056	116057
24182	37548	0	applied	\N	\N	\N	\N	116059	116059	116060
24182	37549	1	applied	\N	\N	\N	\N	116061	116061	116062
24182	37550	2	applied	\N	\N	\N	\N	116063	116063	116064
24184	37551	0	applied	\N	\N	\N	\N	116068	116068	116069
24184	37552	1	applied	\N	\N	\N	\N	116070	116070	116071
24187	37194	0	applied	\N	\N	\N	\N	114914	114914	114915
24187	37270	1	applied	\N	\N	\N	\N	114916	114916	114917
24187	37285	2	applied	\N	\N	\N	\N	115172	115172	115173
24187	37271	3	applied	\N	\N	\N	\N	114918	114918	114919
24187	37272	4	applied	\N	\N	\N	\N	114920	114920	114921
24187	37275	5	applied	\N	\N	\N	\N	114922	114922	114923
24187	37276	6	applied	\N	\N	\N	\N	115150	115150	115151
24187	37277	7	applied	\N	\N	\N	\N	115152	115152	115153
24187	37281	8	applied	\N	\N	\N	\N	115164	115164	115165
24187	37282	9	applied	\N	\N	\N	\N	115166	115166	115167
24187	37286	10	applied	\N	\N	\N	\N	115174	115174	115175
24187	37287	11	applied	\N	\N	\N	\N	115176	115176	115177
24187	37288	12	applied	\N	\N	\N	\N	115178	115178	115179
24187	33609	13	applied	\N	\N	\N	\N	115957	115957	103761
24187	37237	14	applied	\N	\N	\N	\N	115054	115054	77733
24187	37530	15	applied	\N	\N	\N	\N	116013	116013	28166
24187	37492	16	applied	\N	\N	\N	\N	115908	115908	116084
24187	37431	17	applied	\N	\N	\N	\N	116085	116085	115630
24187	37495	18	applied	\N	\N	\N	\N	115917	115917	115918
24187	37238	19	applied	\N	\N	\N	\N	115055	115055	115056
24187	37501	20	applied	\N	\N	\N	\N	115931	115931	114937
24187	37434	21	applied	\N	\N	\N	\N	116086	116086	115636
24187	37458	22	applied	\N	\N	\N	\N	116087	116087	115704
24187	37459	23	applied	\N	\N	\N	\N	116088	116088	115706
24187	37463	24	applied	\N	\N	\N	\N	116089	116089	115716
24187	37464	25	applied	\N	\N	\N	\N	116090	116090	115718
24187	37518	26	applied	\N	\N	\N	\N	115981	115981	5488
24187	37511	27	applied	\N	\N	\N	\N	115964	115964	116091
24187	37517	28	applied	\N	\N	\N	\N	115979	115979	116092
24187	37524	29	applied	\N	\N	\N	\N	115997	115997	114939
24187	37534	30	applied	\N	\N	\N	\N	116020	116020	116093
24187	37542	31	applied	\N	\N	\N	\N	116043	116043	116094
24187	37550	32	applied	\N	\N	\N	\N	116063	116063	114947
24187	37557	33	applied	\N	\N	\N	\N	116080	116080	116095
24192	37558	0	applied	\N	\N	\N	\N	116098	116098	116099
24192	37559	1	applied	\N	\N	\N	\N	116100	116100	116101
24195	37560	0	applied	\N	\N	\N	\N	116107	116107	116108
24079	37380	0	applied	\N	\N	\N	\N	115480	115480	115481
24079	37381	1	applied	\N	\N	\N	\N	115482	115482	115483
24079	37382	2	applied	\N	\N	\N	\N	115484	115484	115485
24079	37383	3	applied	\N	\N	\N	\N	115486	115486	115487
24079	37384	4	applied	\N	\N	\N	\N	115488	115488	115489
24079	37385	5	applied	\N	\N	\N	\N	115490	115490	115491
24081	37386	0	applied	\N	\N	\N	\N	115496	115496	115497
24081	37387	1	applied	\N	\N	\N	\N	115498	115498	115499
24083	37388	0	applied	\N	\N	\N	\N	115505	115505	115506
24083	37389	1	applied	\N	\N	\N	\N	115507	115507	115508
24083	37390	2	applied	\N	\N	\N	\N	115509	115509	115510
24083	37391	3	applied	\N	\N	\N	\N	115511	115511	115512
24087	37393	0	applied	\N	\N	\N	\N	115518	115518	115519
24087	37394	1	applied	\N	\N	\N	\N	115521	115521	115522
24087	37395	2	applied	\N	\N	\N	\N	115523	115523	115524
24087	37396	3	applied	\N	\N	\N	\N	115525	115525	115526
24087	37397	4	applied	\N	\N	\N	\N	115527	115527	115528
24087	37398	5	applied	\N	\N	\N	\N	115529	115529	115530
24087	37399	6	applied	\N	\N	\N	\N	115531	115531	115532
24087	37400	7	applied	\N	\N	\N	\N	115533	115533	115534
24091	37403	0	applied	\N	\N	\N	\N	115547	115547	115548
24091	37404	1	applied	\N	\N	\N	\N	115549	115549	115550
24094	37411	0	applied	\N	\N	\N	\N	115568	115568	115569
24094	37412	1	applied	\N	\N	\N	\N	115570	115570	115571
24099	37413	0	applied	\N	\N	\N	\N	115575	115575	115576
24099	37414	1	applied	\N	\N	\N	\N	115577	115577	115578
24103	37416	0	applied	\N	\N	\N	\N	115587	115587	115588
24103	37417	1	applied	\N	\N	\N	\N	115589	115589	115590
24106	37420	0	applied	\N	\N	\N	\N	115599	115599	115600
24106	37421	1	applied	\N	\N	\N	\N	115601	115601	115602
24106	37422	2	applied	\N	\N	\N	\N	115603	115603	115604
24108	37423	0	applied	\N	\N	\N	\N	115606	115606	115607
24115	37426	0	applied	\N	\N	\N	\N	115616	115616	115617
24118	37427	0	applied	\N	\N	\N	\N	115621	115621	115622
24118	37428	1	applied	\N	\N	\N	\N	115623	115623	115624
24118	37429	2	applied	\N	\N	\N	\N	115625	115625	115626
24118	37430	3	applied	\N	\N	\N	\N	115627	115627	115628
24118	37431	4	applied	\N	\N	\N	\N	115629	115629	115630
24118	37432	5	applied	\N	\N	\N	\N	115631	115631	115632
24118	37433	6	applied	\N	\N	\N	\N	115633	115633	115634
24118	37434	7	applied	\N	\N	\N	\N	115635	115635	115636
24118	37435	8	applied	\N	\N	\N	\N	115637	115637	115638
24118	37436	9	applied	\N	\N	\N	\N	115639	115639	115640
24120	37437	0	applied	\N	\N	\N	\N	115645	115645	115646
24120	37438	1	applied	\N	\N	\N	\N	115647	115647	115648
24125	37443	0	applied	\N	\N	\N	\N	115662	115662	115663
24125	37444	1	applied	\N	\N	\N	\N	115664	115664	115665
24133	37461	0	applied	\N	\N	\N	\N	115711	115711	115712
24133	37462	1	applied	\N	\N	\N	\N	115713	115713	115714
24133	37463	2	applied	\N	\N	\N	\N	115715	115715	115716
24133	37464	3	applied	\N	\N	\N	\N	115717	115717	115718
24133	37465	4	applied	\N	\N	\N	\N	115719	115719	115720
24133	37466	5	applied	\N	\N	\N	\N	115721	115721	115722
24142	37483	0	applied	\N	\N	\N	\N	115768	115768	115769
24142	37484	1	applied	\N	\N	\N	\N	115770	115770	115771
24142	37481	2	applied	\N	\N	\N	\N	115763	115763	115764
24142	37482	3	applied	\N	\N	\N	\N	115765	115765	115766
24148	37348	0	applied	\N	\N	\N	\N	115400	115400	115401
24148	37349	1	applied	\N	\N	\N	\N	115402	115402	115403
24148	37350	2	applied	\N	\N	\N	\N	115404	115404	115405
24148	37354	3	applied	\N	\N	\N	\N	115413	115413	115414
24148	37355	4	applied	\N	\N	\N	\N	115415	115415	115416
24148	37356	5	applied	\N	\N	\N	\N	115417	115417	115418
24148	37357	6	applied	\N	\N	\N	\N	115419	115419	115420
24148	37358	7	applied	\N	\N	\N	\N	115421	115421	115422
24148	37364	8	applied	\N	\N	\N	\N	115435	115435	115436
24148	37366	9	applied	\N	\N	\N	\N	115440	115440	115441
24148	37367	10	applied	\N	\N	\N	\N	115442	115442	115443
24148	37370	11	applied	\N	\N	\N	\N	115449	115449	115450
24148	37372	12	applied	\N	\N	\N	\N	115455	115455	115456
24148	37374	13	applied	\N	\N	\N	\N	115461	115461	115462
24148	37376	14	applied	\N	\N	\N	\N	115469	115469	115470
24148	37378	15	applied	\N	\N	\N	\N	115475	115475	115476
24148	37380	16	applied	\N	\N	\N	\N	115480	115480	115481
24148	37381	17	applied	\N	\N	\N	\N	115482	115482	115483
24148	37382	18	applied	\N	\N	\N	\N	115484	115484	115485
24148	37386	19	applied	\N	\N	\N	\N	115496	115496	115497
24148	37388	20	applied	\N	\N	\N	\N	115505	115505	115506
24148	37389	21	applied	\N	\N	\N	\N	115507	115507	115508
24148	37393	22	applied	\N	\N	\N	\N	115518	115518	115519
24148	37394	23	applied	\N	\N	\N	\N	115521	115521	115522
24148	37395	24	applied	\N	\N	\N	\N	115523	115523	115524
24148	37396	25	applied	\N	\N	\N	\N	115525	115525	115526
24148	37401	26	applied	\N	\N	\N	\N	115541	115541	115542
24148	37403	27	applied	\N	\N	\N	\N	115547	115547	115548
24148	37405	28	applied	\N	\N	\N	\N	115552	115552	115553
24148	37407	29	applied	\N	\N	\N	\N	115558	115558	115559
24148	37408	30	applied	\N	\N	\N	\N	115560	115560	115561
24148	37411	31	applied	\N	\N	\N	\N	115568	115568	115569
24148	37413	32	applied	\N	\N	\N	\N	115575	115575	115576
24148	37415	33	applied	\N	\N	\N	\N	115583	115583	115584
24148	37416	34	applied	\N	\N	\N	\N	115587	115587	115588
24148	37418	35	applied	\N	\N	\N	\N	115593	115593	115594
24148	37420	36	applied	\N	\N	\N	\N	115599	115599	115600
24148	37427	37	applied	\N	\N	\N	\N	115621	115621	115622
24148	37428	38	applied	\N	\N	\N	\N	115623	115623	115624
24148	37429	39	applied	\N	\N	\N	\N	115625	115625	115626
24148	37430	40	applied	\N	\N	\N	\N	115627	115627	115628
24148	37437	41	applied	\N	\N	\N	\N	115645	115645	115646
24148	37439	42	applied	\N	\N	\N	\N	115650	115650	115651
24148	37440	43	applied	\N	\N	\N	\N	115652	115652	115653
24148	37443	44	applied	\N	\N	\N	\N	115662	115662	115663
24148	37445	45	applied	\N	\N	\N	\N	115668	115668	115669
24148	37446	46	applied	\N	\N	\N	\N	115670	115670	115671
24148	37449	47	applied	\N	\N	\N	\N	115677	115677	115678
24148	37451	48	applied	\N	\N	\N	\N	115685	115685	115686
24148	37453	49	applied	\N	\N	\N	\N	115693	115693	115694
24148	37454	50	applied	\N	\N	\N	\N	115695	115695	115696
24148	37455	51	applied	\N	\N	\N	\N	115697	115697	115698
24151	37487	0	applied	\N	\N	\N	\N	115894	115894	115895
24156	37500	0	applied	\N	\N	\N	\N	115929	115929	115930
24156	37501	1	applied	\N	\N	\N	\N	115931	115931	115932
24156	37502	2	applied	\N	\N	\N	\N	115933	115933	115934
24160	37503	0	applied	\N	\N	\N	\N	115941	115941	115942
24160	37504	1	applied	\N	\N	\N	\N	115943	115943	115944
24163	37505	0	applied	\N	\N	\N	\N	115951	115951	115952
24163	37506	1	applied	\N	\N	\N	\N	115953	115953	115954
24163	37507	2	applied	\N	\N	\N	\N	115955	115955	115956
24163	33609	3	applied	\N	\N	\N	\N	115957	115957	103761
24163	37508	4	applied	\N	\N	\N	\N	115958	115958	115959
24105	37419	1	applied	\N	\N	\N	\N	115595	115595	115596
24113	37424	0	applied	\N	\N	\N	\N	115610	115610	115611
24114	37425	0	applied	\N	\N	\N	\N	115614	115614	115615
24127	37449	0	applied	\N	\N	\N	\N	115677	115677	115678
24127	37450	1	applied	\N	\N	\N	\N	115679	115679	115680
24130	37451	0	applied	\N	\N	\N	\N	115685	115685	115686
24130	37452	1	applied	\N	\N	\N	\N	115687	115687	115688
24136	37467	0	applied	\N	\N	\N	\N	115724	115724	115725
24136	37468	1	applied	\N	\N	\N	\N	115726	115726	115727
24138	37471	0	applied	\N	\N	\N	\N	115739	115739	115740
24138	37472	1	applied	\N	\N	\N	\N	115741	115741	115742
24138	37469	2	applied	\N	\N	\N	\N	115734	115734	115735
24138	37470	3	applied	\N	\N	\N	\N	115736	115736	115737
24141	37481	0	applied	\N	\N	\N	\N	115763	115763	115764
24141	37482	1	applied	\N	\N	\N	\N	115765	115765	115766
24144	37126	0	applied	\N	\N	\N	\N	114713	114713	115775
24144	37127	1	applied	\N	\N	\N	\N	114715	114715	115776
24144	37143	2	applied	\N	\N	\N	\N	115777	115777	114787
24144	37148	3	applied	\N	\N	\N	\N	115778	115778	114802
24144	37132	4	applied	\N	\N	\N	\N	114727	114727	115779
24144	37133	5	applied	\N	\N	\N	\N	114729	114729	115780
24144	37139	6	applied	\N	\N	\N	\N	114743	114743	115781
24144	37142	7	applied	\N	\N	\N	\N	114784	114784	115782
24144	37149	8	applied	\N	\N	\N	\N	114803	114803	115783
24144	37165	9	applied	\N	\N	\N	\N	114839	114839	115784
24144	37285	10	applied	\N	\N	\N	\N	115172	115172	115173
24144	37176	11	applied	\N	\N	\N	\N	114865	114865	115785
24144	37179	12	applied	\N	\N	\N	\N	114873	114873	115786
24144	37182	13	applied	\N	\N	\N	\N	114882	114882	115787
24144	37185	14	applied	\N	\N	\N	\N	114893	114893	115788
24144	37286	15	applied	\N	\N	\N	\N	115174	115174	115175
24144	37287	16	applied	\N	\N	\N	\N	115176	115176	115177
24144	37288	17	applied	\N	\N	\N	\N	115178	115178	115179
24144	37188	18	applied	\N	\N	\N	\N	114900	114900	115789
24144	37191	19	applied	\N	\N	\N	\N	114907	114907	115790
24144	37199	20	applied	\N	\N	\N	\N	114926	114926	115791
24144	37202	21	applied	\N	\N	\N	\N	114934	114934	115792
24144	37205	22	applied	\N	\N	\N	\N	114944	114944	115793
24144	37208	23	applied	\N	\N	\N	\N	114953	114953	115794
24144	37210	24	applied	\N	\N	\N	\N	114958	114958	115795
24144	37213	25	applied	\N	\N	\N	\N	114966	114966	115796
24144	37216	26	applied	\N	\N	\N	\N	114998	114998	115797
24144	37219	27	applied	\N	\N	\N	\N	115008	115008	115798
24144	37222	28	applied	\N	\N	\N	\N	115017	115017	115799
24144	37223	29	applied	\N	\N	\N	\N	115019	115019	115800
24144	37224	30	applied	\N	\N	\N	\N	115021	115021	115801
24144	37231	31	applied	\N	\N	\N	\N	115039	115039	115802
24144	37234	32	applied	\N	\N	\N	\N	115048	115048	115803
24144	37239	33	applied	\N	\N	\N	\N	115059	115059	115804
24144	37242	34	applied	\N	\N	\N	\N	115065	115065	115805
24144	37150	35	applied	\N	\N	\N	\N	115806	115806	114806
24144	37151	36	applied	\N	\N	\N	\N	115807	115807	114808
24144	37152	37	applied	\N	\N	\N	\N	115808	115808	114810
24144	37244	38	applied	\N	\N	\N	\N	115073	115073	115809
24144	37245	39	applied	\N	\N	\N	\N	115075	115075	115810
24144	37250	40	applied	\N	\N	\N	\N	115089	115089	115811
24144	37253	41	applied	\N	\N	\N	\N	115099	115099	115812
24144	37256	42	applied	\N	\N	\N	\N	115107	115107	115813
24144	37259	43	applied	\N	\N	\N	\N	115113	115113	115814
24144	37263	44	applied	\N	\N	\N	\N	115121	115121	115815
24144	37266	45	applied	\N	\N	\N	\N	115132	115132	115816
24144	37269	46	applied	\N	\N	\N	\N	115140	115140	115817
24144	37278	47	applied	\N	\N	\N	\N	115154	115154	115818
24144	37283	48	applied	\N	\N	\N	\N	115168	115168	115819
24144	37284	49	applied	\N	\N	\N	\N	115170	115170	115820
24144	37293	50	applied	\N	\N	\N	\N	115191	115191	115821
24144	37153	51	applied	\N	\N	\N	\N	115822	115822	114812
24144	37154	52	applied	\N	\N	\N	\N	115823	115823	114814
24144	37155	53	applied	\N	\N	\N	\N	115824	115824	114816
24144	37156	54	applied	\N	\N	\N	\N	115825	115825	114818
24144	37157	55	applied	\N	\N	\N	\N	115826	115826	114820
24144	37158	56	applied	\N	\N	\N	\N	115827	115827	114822
24144	37159	57	applied	\N	\N	\N	\N	115828	115828	114824
24144	37162	58	applied	\N	\N	\N	\N	115829	115829	114834
24144	37163	59	applied	\N	\N	\N	\N	115830	115830	114836
24144	37164	60	applied	\N	\N	\N	\N	115831	115831	114838
24144	37166	61	applied	\N	\N	\N	\N	115832	115832	114842
24144	37167	62	applied	\N	\N	\N	\N	115833	115833	114844
24144	37168	63	applied	\N	\N	\N	\N	115834	115834	114846
24144	37171	64	applied	\N	\N	\N	\N	115835	115835	114856
24144	37172	65	applied	\N	\N	\N	\N	115836	115836	114858
24144	37173	66	applied	\N	\N	\N	\N	115837	115837	114860
24144	37174	67	applied	\N	\N	\N	\N	115838	115838	114862
24144	37175	68	applied	\N	\N	\N	\N	115839	115839	114864
24144	37194	69	applied	\N	\N	\N	\N	115840	115840	114915
24144	37195	70	applied	\N	\N	\N	\N	115841	115841	114917
24144	37196	71	applied	\N	\N	\N	\N	115842	115842	114919
24144	37197	72	applied	\N	\N	\N	\N	115843	115843	114921
24144	37198	73	applied	\N	\N	\N	\N	115844	115844	114923
24144	37276	74	applied	\N	\N	\N	\N	115845	115845	115151
24144	37277	75	applied	\N	\N	\N	\N	115846	115846	115153
24144	37281	76	applied	\N	\N	\N	\N	115847	115847	115165
24144	37282	77	applied	\N	\N	\N	\N	115848	115848	115167
24144	37296	78	applied	\N	\N	\N	\N	115201	115201	115849
24144	37299	79	applied	\N	\N	\N	\N	115213	115213	115850
24144	37300	80	applied	\N	\N	\N	\N	115215	115215	115851
24144	37305	81	applied	\N	\N	\N	\N	115226	115226	115852
24144	37308	82	applied	\N	\N	\N	\N	115235	115235	115853
24144	37310	83	applied	\N	\N	\N	\N	115243	115243	115854
24144	37313	84	applied	\N	\N	\N	\N	115253	115253	115855
24144	37318	85	applied	\N	\N	\N	\N	115268	115268	115856
24144	37321	86	applied	\N	\N	\N	\N	115276	115276	115857
24144	37322	87	applied	\N	\N	\N	\N	115278	115278	115858
24144	37327	88	applied	\N	\N	\N	\N	115288	115288	115859
24144	37328	89	applied	\N	\N	\N	\N	115290	115290	115860
24144	37332	90	applied	\N	\N	\N	\N	115301	115301	115861
24144	37333	91	applied	\N	\N	\N	\N	115303	115303	115862
24144	37336	92	applied	\N	\N	\N	\N	115317	115317	115863
24144	37338	93	applied	\N	\N	\N	\N	115322	115322	115864
24144	37340	94	applied	\N	\N	\N	\N	115328	115328	115865
24144	37342	95	applied	\N	\N	\N	\N	115334	115334	115866
24144	37344	96	applied	\N	\N	\N	\N	115341	115341	115867
24144	37346	97	applied	\N	\N	\N	\N	115347	115347	115868
24144	37348	98	applied	\N	\N	\N	\N	115400	115400	115869
24144	37349	99	applied	\N	\N	\N	\N	115402	115402	115870
24144	37350	100	applied	\N	\N	\N	\N	115404	115404	115871
24144	37354	101	applied	\N	\N	\N	\N	115413	115413	115872
24144	37355	102	applied	\N	\N	\N	\N	115415	115415	115873
24144	37356	103	applied	\N	\N	\N	\N	115417	115417	115874
24144	37357	104	applied	\N	\N	\N	\N	115419	115419	115875
24144	37358	106	applied	\N	\N	\N	\N	115421	115421	115878
24144	37364	107	applied	\N	\N	\N	\N	115435	115435	115879
24144	37366	108	applied	\N	\N	\N	\N	115440	115440	115880
24145	37485	0	applied	\N	\N	\N	\N	115884	115884	115885
24145	37486	1	applied	\N	\N	\N	\N	115886	115886	115887
24150	37487	0	applied	\N	\N	\N	\N	115894	115894	115895
24153	37488	0	applied	\N	\N	\N	\N	115900	115900	115901
24153	37489	1	applied	\N	\N	\N	\N	115902	115902	115903
24153	37490	2	applied	\N	\N	\N	\N	115904	115904	115905
24153	37491	3	applied	\N	\N	\N	\N	115906	115906	115907
24153	37492	4	applied	\N	\N	\N	\N	115908	115908	115909
24155	37496	0	applied	\N	\N	\N	\N	115920	115920	115921
24155	37497	1	applied	\N	\N	\N	\N	115922	115922	115923
24155	37498	2	applied	\N	\N	\N	\N	115924	115924	115925
24155	37499	3	applied	\N	\N	\N	\N	115926	115926	115927
24167	37514	0	applied	\N	\N	\N	\N	115973	115973	115974
24167	37515	1	applied	\N	\N	\N	\N	115975	115975	115976
24167	37516	2	applied	\N	\N	\N	\N	115977	115977	115978
24167	37517	3	applied	\N	\N	\N	\N	115979	115979	115980
24167	37518	4	applied	\N	\N	\N	\N	115981	115981	5488
24167	37519	5	applied	\N	\N	\N	\N	115982	115982	115983
24170	37520	0	applied	\N	\N	\N	\N	115987	115987	115988
24170	37521	1	applied	\N	\N	\N	\N	115989	115989	115990
24177	37537	0	applied	\N	\N	\N	\N	116033	116033	116034
24177	37538	1	applied	\N	\N	\N	\N	116035	116035	116036
24178	37539	0	applied	\N	\N	\N	\N	116037	116037	116038
24178	37540	1	applied	\N	\N	\N	\N	116039	116039	116040
24178	37541	2	applied	\N	\N	\N	\N	116041	116041	116042
24178	37542	3	applied	\N	\N	\N	\N	116043	116043	116044
24178	37543	4	applied	\N	\N	\N	\N	116045	116045	116046
24178	37544	5	applied	\N	\N	\N	\N	116047	116047	116048
24178	37545	6	applied	\N	\N	\N	\N	116049	116049	116050
24181	37546	0	applied	\N	\N	\N	\N	116052	116052	116053
24181	37547	1	applied	\N	\N	\N	\N	116056	116056	116057
24183	37548	0	applied	\N	\N	\N	\N	116059	116059	116060
24183	37549	1	applied	\N	\N	\N	\N	116061	116061	116062
24183	37550	2	applied	\N	\N	\N	\N	116063	116063	116064
24185	37553	0	applied	\N	\N	\N	\N	116072	116072	116073
24185	37554	1	applied	\N	\N	\N	\N	116074	116074	116075
24193	37558	0	applied	\N	\N	\N	\N	116098	116098	116099
24193	37559	1	applied	\N	\N	\N	\N	116100	116100	116101
24196	37563	0	applied	\N	\N	\N	\N	116115	116115	116116
24196	37564	1	applied	\N	\N	\N	\N	116117	116117	116118
24196	37565	2	applied	\N	\N	\N	\N	116119	116119	116120
24196	37566	3	applied	\N	\N	\N	\N	116121	116121	116122
24199	37576	0	applied	\N	\N	\N	\N	116146	116146	116147
24199	37577	1	applied	\N	\N	\N	\N	116148	116148	116149
24199	37578	2	applied	\N	\N	\N	\N	116150	116150	116151
24199	37579	3	applied	\N	\N	\N	\N	116152	116152	116153
24201	37285	0	applied	\N	\N	\N	\N	115172	115172	115173
24201	37276	1	applied	\N	\N	\N	\N	115150	115150	115151
24201	37277	2	applied	\N	\N	\N	\N	115152	115152	115153
24201	37281	3	applied	\N	\N	\N	\N	115164	115164	115165
24201	37282	4	applied	\N	\N	\N	\N	115166	115166	115167
24201	37286	5	applied	\N	\N	\N	\N	115174	115174	115175
24201	37287	6	applied	\N	\N	\N	\N	115176	115176	115177
24201	37288	7	applied	\N	\N	\N	\N	115178	115178	115179
24201	33609	8	applied	\N	\N	\N	\N	115957	115957	103761
24201	37237	9	applied	\N	\N	\N	\N	115054	115054	77733
24201	37530	10	applied	\N	\N	\N	\N	116013	116013	28166
24201	37492	11	applied	\N	\N	\N	\N	115908	115908	115375
24201	37431	12	applied	\N	\N	\N	\N	116085	116085	115630
24201	37495	13	applied	\N	\N	\N	\N	115917	115917	115918
24201	37238	14	applied	\N	\N	\N	\N	115055	115055	115056
24201	37501	15	applied	\N	\N	\N	\N	115931	115931	114674
24201	37434	16	applied	\N	\N	\N	\N	116086	116086	115636
24201	37458	17	applied	\N	\N	\N	\N	116087	116087	115704
24201	37459	18	applied	\N	\N	\N	\N	116088	116088	115706
24201	37463	19	applied	\N	\N	\N	\N	116089	116089	115716
24201	37464	20	applied	\N	\N	\N	\N	116090	116090	115718
24201	37518	21	applied	\N	\N	\N	\N	115981	115981	5488
24201	37511	22	applied	\N	\N	\N	\N	115964	115964	114655
24201	37517	23	applied	\N	\N	\N	\N	115979	115979	114675
24201	37524	24	applied	\N	\N	\N	\N	115997	115997	116157
24201	37534	25	applied	\N	\N	\N	\N	116020	116020	114657
24201	37542	26	applied	\N	\N	\N	\N	116043	116043	115376
24201	37550	27	applied	\N	\N	\N	\N	116063	116063	114659
24201	37557	28	applied	\N	\N	\N	\N	116080	116080	114668
24201	37566	29	applied	\N	\N	\N	\N	116121	116121	114661
24201	37577	30	applied	\N	\N	\N	\N	116148	116148	114669
24208	37589	0	applied	\N	\N	\N	\N	116189	116189	116190
24208	37590	1	applied	\N	\N	\N	\N	116191	116191	116192
24208	37591	2	applied	\N	\N	\N	\N	116193	116193	116194
24211	37592	0	applied	\N	\N	\N	\N	116197	116197	116198
24211	37593	1	applied	\N	\N	\N	\N	116199	116199	116200
24211	37594	2	applied	\N	\N	\N	\N	116201	116201	116202
24211	37595	3	applied	\N	\N	\N	\N	116203	116203	116204
24211	37596	4	applied	\N	\N	\N	\N	116205	116205	116206
24211	37597	5	applied	\N	\N	\N	\N	116207	116207	116208
24211	37598	6	applied	\N	\N	\N	\N	116209	116209	116210
24213	37599	0	applied	\N	\N	\N	\N	116216	116216	116217
24213	37600	1	applied	\N	\N	\N	\N	116218	116218	116219
24213	37601	2	applied	\N	\N	\N	\N	116220	116220	116221
24216	37602	0	applied	\N	\N	\N	\N	116225	116225	116226
24216	37603	1	applied	\N	\N	\N	\N	116227	116227	116228
24216	37604	2	applied	\N	\N	\N	\N	116229	116229	116230
24218	37605	0	applied	\N	\N	\N	\N	116234	116234	116235
24218	37606	1	applied	\N	\N	\N	\N	116236	116236	116237
24218	37607	2	applied	\N	\N	\N	\N	116238	116238	116239
24221	37608	0	applied	\N	\N	\N	\N	116242	116242	116243
24221	37609	1	applied	\N	\N	\N	\N	116244	116244	116245
24221	37610	2	applied	\N	\N	\N	\N	116246	116246	116247
24222	37612	0	applied	\N	\N	\N	\N	116254	116254	116255
24222	37613	1	applied	\N	\N	\N	\N	116256	116256	116257
24222	37611	2	applied	\N	\N	\N	\N	116248	116248	116258
24222	37614	3	applied	\N	\N	\N	\N	116259	116259	116260
24227	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24227	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24227	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24227	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24231	37622	0	applied	\N	\N	\N	\N	116290	116290	116291
24231	37623	1	applied	\N	\N	\N	\N	116292	116292	116293
24231	37624	2	applied	\N	\N	\N	\N	116294	116294	116295
24233	37625	0	applied	\N	\N	\N	\N	116299	116299	116300
24233	37626	1	applied	\N	\N	\N	\N	116301	116301	116302
24233	37627	2	applied	\N	\N	\N	\N	116303	116303	116304
24238	37634	0	applied	\N	\N	\N	\N	116323	116323	116324
24238	37635	1	applied	\N	\N	\N	\N	116325	116325	116326
24238	37636	2	applied	\N	\N	\N	\N	116327	116327	116328
24240	37637	0	applied	\N	\N	\N	\N	116334	116334	116335
24163	37509	5	applied	\N	\N	\N	\N	115960	115960	115961
24163	37510	6	applied	\N	\N	\N	\N	115962	115962	115963
24163	37511	7	applied	\N	\N	\N	\N	115964	115964	115965
24165	37512	0	applied	\N	\N	\N	\N	115968	115968	115969
24165	37513	1	applied	\N	\N	\N	\N	115970	115970	115971
24168	37514	0	applied	\N	\N	\N	\N	115973	115973	115974
24168	37515	1	applied	\N	\N	\N	\N	115975	115975	115976
24168	37516	2	applied	\N	\N	\N	\N	115977	115977	115978
24168	37517	3	applied	\N	\N	\N	\N	115979	115979	115980
24168	37518	4	applied	\N	\N	\N	\N	115981	115981	5488
24168	37519	5	applied	\N	\N	\N	\N	115982	115982	115983
24173	37527	0	applied	\N	\N	\N	\N	116007	116007	116008
24173	37528	1	applied	\N	\N	\N	\N	116009	116009	116010
24173	37529	2	applied	\N	\N	\N	\N	116011	116011	116012
24173	37530	3	applied	\N	\N	\N	\N	116013	116013	28166
24173	37531	4	applied	\N	\N	\N	\N	116014	116014	116015
24173	37532	5	applied	\N	\N	\N	\N	116016	116016	116017
24173	37533	6	applied	\N	\N	\N	\N	116018	116018	116019
24173	37534	7	applied	\N	\N	\N	\N	116020	116020	116021
24189	37558	0	applied	\N	\N	\N	\N	116098	116098	116099
24189	37559	1	applied	\N	\N	\N	\N	116100	116100	116101
24190	37558	0	applied	\N	\N	\N	\N	116098	116098	116099
24190	37559	1	applied	\N	\N	\N	\N	116100	116100	116101
24194	37560	0	applied	\N	\N	\N	\N	116107	116107	116108
24194	37561	1	applied	\N	\N	\N	\N	116109	116109	116110
24194	37562	2	applied	\N	\N	\N	\N	116111	116111	116112
24197	37567	0	applied	\N	\N	\N	\N	116124	116124	116125
24197	37568	1	applied	\N	\N	\N	\N	116126	116126	116127
24197	37569	2	applied	\N	\N	\N	\N	116128	116128	116129
24197	37570	3	applied	\N	\N	\N	\N	116130	116130	116131
24197	37571	4	applied	\N	\N	\N	\N	116132	116132	116133
24197	37572	5	applied	\N	\N	\N	\N	116134	116134	116135
24200	37576	0	applied	\N	\N	\N	\N	116146	116146	116147
24200	37577	1	applied	\N	\N	\N	\N	116148	116148	116149
24200	37578	2	applied	\N	\N	\N	\N	116150	116150	116151
24200	37579	3	applied	\N	\N	\N	\N	116152	116152	116153
24204	37583	0	applied	\N	\N	\N	\N	116169	116169	116170
24204	37584	1	applied	\N	\N	\N	\N	116171	116171	116172
24204	37585	2	applied	\N	\N	\N	\N	116173	116173	116174
24204	37586	3	applied	\N	\N	\N	\N	116175	116175	116176
24204	37587	4	applied	\N	\N	\N	\N	116177	116177	116178
24204	37588	5	applied	\N	\N	\N	\N	116179	116179	116180
24209	37592	0	applied	\N	\N	\N	\N	116197	116197	116198
24209	37593	1	applied	\N	\N	\N	\N	116199	116199	116200
24209	37594	2	applied	\N	\N	\N	\N	116201	116201	116202
24209	37595	3	applied	\N	\N	\N	\N	116203	116203	116204
24209	37596	4	applied	\N	\N	\N	\N	116205	116205	116206
24209	37597	5	applied	\N	\N	\N	\N	116207	116207	116208
24209	37598	6	applied	\N	\N	\N	\N	116209	116209	116210
24214	37599	0	applied	\N	\N	\N	\N	116216	116216	116217
24214	37600	1	applied	\N	\N	\N	\N	116218	116218	116219
24214	37601	2	applied	\N	\N	\N	\N	116220	116220	116221
24223	37615	0	applied	\N	\N	\N	\N	116263	116263	116264
24223	37616	1	applied	\N	\N	\N	\N	116265	116265	116266
24223	37617	2	applied	\N	\N	\N	\N	116267	116267	116268
24225	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24225	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24225	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24225	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24228	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24228	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24228	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24228	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24232	37622	0	applied	\N	\N	\N	\N	116290	116290	116291
24232	37623	1	applied	\N	\N	\N	\N	116292	116292	116293
24232	37624	2	applied	\N	\N	\N	\N	116294	116294	116295
24234	37625	0	applied	\N	\N	\N	\N	116299	116299	116300
24234	37626	1	applied	\N	\N	\N	\N	116301	116301	116302
24234	37627	2	applied	\N	\N	\N	\N	116303	116303	116304
24236	37628	0	applied	\N	\N	\N	\N	116308	116308	116309
24236	37629	1	applied	\N	\N	\N	\N	116310	116310	116311
24236	37630	2	applied	\N	\N	\N	\N	116312	116312	116313
24236	37631	3	applied	\N	\N	\N	\N	116314	116314	116315
24241	37637	0	applied	\N	\N	\N	\N	116334	116334	116335
24241	37638	1	applied	\N	\N	\N	\N	116336	116336	116337
24241	37639	2	applied	\N	\N	\N	\N	116338	116338	116339
24245	37585	0	applied	\N	\N	\N	\N	116173	116173	114679
24245	37595	1	applied	\N	\N	\N	\N	116203	116203	114670
24245	37609	2	applied	\N	\N	\N	\N	116244	116244	114681
24245	37619	3	applied	\N	\N	\N	\N	116275	116275	114672
24245	37630	4	applied	\N	\N	\N	\N	116312	116312	115377
24245	37641	5	applied	\N	\N	\N	\N	116346	116346	114682
24248	37647	0	applied	\N	\N	\N	\N	116361	116361	116362
24248	37648	1	applied	\N	\N	\N	\N	116363	116363	116364
24248	37649	2	applied	\N	\N	\N	\N	116365	116365	116366
24248	37650	3	applied	\N	\N	\N	\N	116367	116367	116368
24248	37651	4	applied	\N	\N	\N	\N	116369	116369	116370
24248	37652	5	applied	\N	\N	\N	\N	116371	116371	116372
24248	37653	6	applied	\N	\N	\N	\N	116373	116373	116374
24248	37654	7	applied	\N	\N	\N	\N	116375	116375	116376
24248	37655	8	applied	\N	\N	\N	\N	116377	116377	116378
24248	37656	9	applied	\N	\N	\N	\N	116379	116379	116380
24248	37657	10	applied	\N	\N	\N	\N	116381	116381	116382
24248	37658	11	applied	\N	\N	\N	\N	116383	116383	116384
24248	37659	12	applied	\N	\N	\N	\N	116385	116385	116386
24251	37660	0	applied	\N	\N	\N	\N	116391	116391	116392
24251	37661	1	applied	\N	\N	\N	\N	116393	116393	116394
24251	37662	2	applied	\N	\N	\N	\N	116395	116395	116396
24251	37663	3	applied	\N	\N	\N	\N	116397	116397	116398
24251	37664	4	applied	\N	\N	\N	\N	116399	116399	116400
24251	37665	5	applied	\N	\N	\N	\N	116401	116401	116402
24251	37666	6	applied	\N	\N	\N	\N	116403	116403	116404
24266	37695	0	applied	\N	\N	1000000000	\N	116477	116477	116478
24266	37697	1	applied	\N	\N	\N	\N	116482	116482	116483
24266	37698	2	applied	\N	\N	\N	\N	116484	116484	116485
24266	37699	3	applied	\N	\N	\N	\N	116486	116486	116487
24266	37700	4	applied	\N	\N	\N	\N	116488	116488	116489
24266	37696	5	applied	\N	\N	\N	\N	116479	116479	116480
24266	37701	6	applied	\N	\N	\N	\N	116490	116490	116491
24266	37702	7	applied	\N	\N	\N	\N	116492	116492	116493
24266	37703	8	applied	\N	\N	\N	\N	116494	116494	116495
24266	37704	9	applied	\N	\N	\N	\N	116496	116496	116497
24266	37705	10	applied	\N	\N	\N	\N	116498	116498	116499
24266	37706	11	applied	\N	\N	\N	\N	116500	116500	116501
24266	37707	12	applied	\N	\N	\N	\N	116502	116502	116503
24266	37708	13	applied	\N	\N	\N	\N	116504	116504	116505
24266	37709	14	applied	\N	\N	\N	\N	116506	116506	116507
24272	37717	0	applied	\N	\N	\N	\N	116533	116533	116534
24272	37718	1	applied	\N	\N	\N	\N	116535	116535	116479
24272	37719	2	applied	\N	\N	\N	\N	116536	116536	116537
24195	37561	1	applied	\N	\N	\N	\N	116109	116109	116110
24195	37562	2	applied	\N	\N	\N	\N	116111	116111	116112
24198	37573	0	applied	\N	\N	\N	\N	116138	116138	116139
24198	37574	1	applied	\N	\N	\N	\N	116140	116140	116141
24198	37575	2	applied	\N	\N	\N	\N	116142	116142	116143
24203	37580	0	applied	\N	\N	\N	\N	116160	116160	116161
24203	37581	1	applied	\N	\N	\N	\N	116162	116162	116163
24203	37582	2	applied	\N	\N	\N	\N	116164	116164	116165
24206	37583	0	applied	\N	\N	\N	\N	116169	116169	116170
24206	37584	1	applied	\N	\N	\N	\N	116171	116171	116172
24206	37585	2	applied	\N	\N	\N	\N	116173	116173	116174
24206	37586	3	applied	\N	\N	\N	\N	116175	116175	116176
24206	37587	4	applied	\N	\N	\N	\N	116177	116177	116178
24206	37588	5	applied	\N	\N	\N	\N	116179	116179	116180
24207	37583	0	applied	\N	\N	\N	\N	116169	116169	116170
24207	37584	1	applied	\N	\N	\N	\N	116171	116171	116172
24207	37585	2	applied	\N	\N	\N	\N	116173	116173	116174
24207	37586	3	applied	\N	\N	\N	\N	116175	116175	116176
24207	37587	4	applied	\N	\N	\N	\N	116177	116177	116178
24207	37588	5	applied	\N	\N	\N	\N	116179	116179	116180
24215	37602	0	applied	\N	\N	\N	\N	116225	116225	116226
24215	37603	1	applied	\N	\N	\N	\N	116227	116227	116228
24215	37604	2	applied	\N	\N	\N	\N	116229	116229	116230
24217	37605	0	applied	\N	\N	\N	\N	116234	116234	116235
24217	37606	1	applied	\N	\N	\N	\N	116236	116236	116237
24217	37607	2	applied	\N	\N	\N	\N	116238	116238	116239
24220	37608	0	applied	\N	\N	\N	\N	116242	116242	116243
24220	37609	1	applied	\N	\N	\N	\N	116244	116244	116245
24220	37610	2	applied	\N	\N	\N	\N	116246	116246	116247
24230	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24230	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24230	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24230	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24235	37628	0	applied	\N	\N	\N	\N	116308	116308	116309
24235	37629	1	applied	\N	\N	\N	\N	116310	116310	116311
24235	37630	2	applied	\N	\N	\N	\N	116312	116312	116313
24235	37631	3	applied	\N	\N	\N	\N	116314	116314	116315
24237	37632	0	applied	\N	\N	\N	\N	116317	116317	116318
24237	37633	1	applied	\N	\N	\N	\N	116319	116319	116320
24244	37640	0	applied	\N	\N	\N	\N	116344	116344	116345
24244	37641	1	applied	\N	\N	\N	\N	116346	116346	116347
24244	37642	2	applied	\N	\N	\N	\N	116348	116348	116349
24244	37643	3	applied	\N	\N	\N	\N	116350	116350	116351
24246	37644	0	applied	\N	\N	\N	\N	116354	116354	116355
24246	37645	1	applied	\N	\N	\N	\N	116356	116356	116357
24246	37646	2	applied	\N	\N	\N	\N	116358	116358	116359
24252	37667	0	applied	\N	\N	\N	\N	116409	116409	116410
24252	37668	1	applied	\N	\N	\N	\N	116411	116411	116412
24252	37669	2	applied	\N	\N	\N	\N	116413	116413	116414
24252	37670	3	applied	\N	\N	\N	\N	116415	116415	116416
24252	37671	4	applied	\N	\N	\N	\N	116417	116417	116418
24252	37672	5	applied	\N	\N	\N	\N	116419	116419	116420
24252	37673	6	applied	\N	\N	\N	\N	116421	116421	116422
24252	37674	7	applied	\N	\N	\N	\N	116423	116423	116424
24257	37675	0	applied	\N	\N	\N	\N	116429	116429	116430
24257	37676	1	applied	\N	\N	\N	\N	116431	116431	116432
24257	37677	2	applied	\N	\N	\N	\N	116433	116433	116434
24257	37678	3	applied	\N	\N	\N	\N	116435	116435	116436
24257	37679	4	applied	\N	\N	\N	\N	116437	116437	116438
24257	37680	5	applied	\N	\N	\N	\N	116439	116439	116440
24257	37681	6	applied	\N	\N	\N	\N	116441	116441	116442
24257	37682	7	applied	\N	\N	\N	\N	116443	116443	116444
24257	37683	8	applied	\N	\N	\N	\N	116445	116445	116446
24257	37684	9	applied	\N	\N	\N	\N	116447	116447	116448
24257	37685	10	applied	\N	\N	\N	\N	116449	116449	116450
24257	37686	11	applied	\N	\N	\N	\N	116451	116451	116452
24257	37687	12	applied	\N	\N	\N	\N	116453	116453	116454
24259	37688	0	applied	\N	\N	\N	\N	116458	116458	116459
24259	37689	1	applied	\N	\N	\N	\N	116460	116460	116461
24259	37690	2	applied	\N	\N	\N	\N	116462	116462	116463
24259	37691	3	applied	\N	\N	\N	\N	116464	116464	116465
24262	37692	0	applied	\N	\N	\N	\N	116469	116469	116470
24262	37693	1	applied	\N	\N	\N	\N	116471	116471	116472
24262	37694	2	applied	\N	\N	\N	\N	116473	116473	116474
24269	37713	0	applied	\N	\N	\N	\N	116520	116520	116521
24269	37714	1	applied	\N	\N	\N	\N	116522	116522	116523
24269	37715	2	applied	\N	\N	\N	\N	116524	116524	116525
24269	37716	3	applied	\N	\N	\N	\N	116526	116526	116527
24284	37729	0	applied	\N	\N	\N	\N	116573	116573	116574
24284	37730	1	applied	\N	\N	\N	\N	116575	116575	116576
24284	37731	2	applied	\N	\N	\N	\N	116577	116577	116578
24288	37732	0	applied	\N	\N	\N	\N	116582	116582	116583
24288	37733	1	applied	\N	\N	\N	\N	116584	116584	116585
24288	37734	2	applied	\N	\N	\N	\N	116586	116586	116587
24290	37735	0	applied	\N	\N	\N	\N	116589	116589	116590
24290	37736	1	applied	\N	\N	\N	\N	116591	116591	116592
24290	37737	2	applied	\N	\N	\N	\N	116593	116593	116594
24290	37738	3	applied	\N	\N	\N	\N	116595	116595	116596
24295	37745	0	applied	\N	\N	\N	\N	116618	116618	116619
24297	37695	0	applied	\N	\N	1000000000	\N	116477	116477	116478
24297	37721	1	applied	\N	\N	\N	\N	116543	116543	116544
24297	37668	2	applied	\N	\N	\N	\N	116411	116411	116412
24297	37669	3	applied	\N	\N	\N	\N	116413	116413	116414
24297	37670	4	applied	\N	\N	\N	\N	116415	116415	116416
24297	37671	5	applied	\N	\N	\N	\N	116417	116417	116418
24297	37672	6	applied	\N	\N	\N	\N	116419	116419	116420
24297	37696	7	applied	\N	\N	\N	\N	116479	116479	116480
24302	37762	0	applied	\N	\N	\N	\N	116661	116661	116662
24302	37763	1	applied	\N	\N	\N	\N	116663	116663	116664
24302	37764	2	applied	\N	\N	\N	\N	116665	116665	116666
24314	37787	0	applied	\N	\N	\N	\N	116730	116730	116731
24314	37788	1	applied	\N	\N	\N	\N	116732	116732	116733
24314	37789	2	applied	\N	\N	\N	\N	116734	116734	116735
24314	37790	3	applied	\N	\N	\N	\N	116736	116736	116737
24314	37791	4	applied	\N	\N	\N	\N	116738	116738	116739
24314	37792	5	applied	\N	\N	\N	\N	116740	116740	116741
24314	37793	6	applied	\N	\N	\N	\N	116742	116742	116743
24317	37797	0	applied	\N	\N	\N	\N	116754	116754	116755
24317	37798	1	applied	\N	\N	\N	\N	116756	116756	116757
24317	37799	2	applied	\N	\N	\N	\N	116758	116758	116759
24317	37800	3	applied	\N	\N	\N	\N	116760	116760	116761
24317	37801	4	applied	\N	\N	\N	\N	116762	116762	116763
24317	37802	5	applied	\N	\N	\N	\N	116764	116764	116765
24317	37803	6	applied	\N	\N	\N	\N	116766	116766	116767
24323	37827	0	applied	\N	\N	\N	\N	116823	116823	116824
24323	37828	1	applied	\N	\N	\N	\N	116825	116825	116826
24323	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	116827	116827	\N
24323	37830	3	applied	\N	\N	\N	\N	116828	116828	116829
24323	37831	4	applied	\N	\N	\N	\N	116830	116830	116831
24219	37609	1	applied	\N	\N	\N	\N	116244	116244	116245
24219	37610	2	applied	\N	\N	\N	\N	116246	116246	116247
24219	37611	3	applied	\N	\N	\N	\N	116248	116248	116249
24224	37615	0	applied	\N	\N	\N	\N	116263	116263	116264
24224	37616	1	applied	\N	\N	\N	\N	116265	116265	116266
24224	37617	2	applied	\N	\N	\N	\N	116267	116267	116268
24226	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24226	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24226	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24226	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24229	37618	0	applied	\N	\N	\N	\N	116273	116273	116274
24229	37619	1	applied	\N	\N	\N	\N	116275	116275	116276
24229	37620	2	applied	\N	\N	\N	\N	116277	116277	116278
24229	37621	3	applied	\N	\N	\N	\N	116279	116279	116280
24239	33609	0	applied	\N	\N	\N	\N	115957	115957	103761
24239	37530	1	applied	\N	\N	\N	\N	116013	116013	28166
24239	37492	2	applied	\N	\N	\N	\N	115908	115908	116330
24239	37431	3	applied	\N	\N	\N	\N	116085	116085	115630
24239	37495	4	applied	\N	\N	\N	\N	115917	115917	115918
24239	37501	5	applied	\N	\N	\N	\N	115931	115931	116331
24239	37434	6	applied	\N	\N	\N	\N	116086	116086	115636
24239	37458	7	applied	\N	\N	\N	\N	116087	116087	115704
24239	37459	8	applied	\N	\N	\N	\N	116088	116088	115706
24239	37463	9	applied	\N	\N	\N	\N	116089	116089	115716
24239	37464	10	applied	\N	\N	\N	\N	116090	116090	115718
24239	37518	11	applied	\N	\N	\N	\N	115981	115981	5488
24239	37562	12	applied	\N	\N	\N	\N	116111	116111	116332
24242	37637	0	applied	\N	\N	\N	\N	116334	116334	116335
24242	37638	1	applied	\N	\N	\N	\N	116336	116336	116337
24242	37639	2	applied	\N	\N	\N	\N	116338	116338	116339
24249	37647	0	applied	\N	\N	\N	\N	116361	116361	116362
24249	37648	1	applied	\N	\N	\N	\N	116363	116363	116364
24249	37649	2	applied	\N	\N	\N	\N	116365	116365	116366
24249	37650	3	applied	\N	\N	\N	\N	116367	116367	116368
24249	37651	4	applied	\N	\N	\N	\N	116369	116369	116370
24249	37652	5	applied	\N	\N	\N	\N	116371	116371	116372
24249	37653	6	applied	\N	\N	\N	\N	116373	116373	116374
24249	37654	7	applied	\N	\N	\N	\N	116375	116375	116376
24249	37655	8	applied	\N	\N	\N	\N	116377	116377	116378
24249	37656	9	applied	\N	\N	\N	\N	116379	116379	116380
24249	37657	10	applied	\N	\N	\N	\N	116381	116381	116382
24249	37658	11	applied	\N	\N	\N	\N	116383	116383	116384
24249	37659	12	applied	\N	\N	\N	\N	116385	116385	116386
24261	37692	0	applied	\N	\N	\N	\N	116469	116469	116470
24261	37693	1	applied	\N	\N	\N	\N	116471	116471	116472
24261	37694	2	applied	\N	\N	\N	\N	116473	116473	116474
24264	37695	0	applied	\N	\N	1000000000	\N	116477	116477	116478
24264	37668	1	applied	\N	\N	\N	\N	116411	116411	116412
24264	37669	2	applied	\N	\N	\N	\N	116413	116413	116414
24264	37670	3	applied	\N	\N	\N	\N	116415	116415	116416
24264	37671	4	applied	\N	\N	\N	\N	116417	116417	116418
24264	37672	5	applied	\N	\N	\N	\N	116419	116419	116420
24264	37696	6	applied	\N	\N	\N	\N	116479	116479	116480
24271	37713	0	applied	\N	\N	\N	\N	116520	116520	116521
24271	37714	1	applied	\N	\N	\N	\N	116522	116522	116523
24271	37715	2	applied	\N	\N	\N	\N	116524	116524	116525
24271	37716	3	applied	\N	\N	\N	\N	116526	116526	116527
24273	37717	0	applied	\N	\N	\N	\N	116533	116533	116534
24273	37718	1	applied	\N	\N	\N	\N	116535	116535	116479
24273	37719	2	applied	\N	\N	\N	\N	116536	116536	116537
24273	37720	3	applied	\N	\N	\N	\N	116538	116538	116539
24275	37721	0	applied	\N	\N	\N	\N	116543	116543	116544
24275	37722	1	applied	\N	\N	\N	\N	116545	116545	116546
24275	37723	2	applied	\N	\N	\N	\N	116547	116547	116548
24275	37724	3	applied	\N	\N	\N	\N	116549	116549	116550
24278	37725	0	applied	\N	\N	\N	\N	116554	116554	116555
24278	37726	1	applied	\N	\N	\N	\N	116556	116556	116557
24278	37727	2	applied	\N	\N	\N	\N	116558	116558	116559
24278	37728	3	applied	\N	\N	\N	\N	116560	116560	116561
24287	37732	0	applied	\N	\N	\N	\N	116582	116582	116583
24287	37733	1	applied	\N	\N	\N	\N	116584	116584	116585
24287	37734	2	applied	\N	\N	\N	\N	116586	116586	116587
24289	37735	0	applied	\N	\N	\N	\N	116589	116589	116590
24289	37736	1	applied	\N	\N	\N	\N	116591	116591	116592
24289	37737	2	applied	\N	\N	\N	\N	116593	116593	116594
24289	37738	3	applied	\N	\N	\N	\N	116595	116595	116596
24291	37735	0	applied	\N	\N	\N	\N	116589	116589	116590
24291	37736	1	applied	\N	\N	\N	\N	116591	116591	116592
24291	37737	2	applied	\N	\N	\N	\N	116593	116593	116594
24291	37738	3	applied	\N	\N	\N	\N	116595	116595	116596
24294	37742	0	applied	\N	\N	\N	\N	116612	116612	116613
24294	37743	1	applied	\N	\N	\N	\N	116614	116614	116615
24294	37744	2	applied	\N	\N	\N	\N	116616	116616	116617
24294	37745	3	applied	\N	\N	\N	\N	116618	116618	116619
24294	37746	4	applied	\N	\N	\N	\N	116620	116620	116621
24294	37747	5	applied	\N	\N	\N	\N	116622	116622	116623
24294	37748	6	applied	\N	\N	\N	\N	116624	116624	116625
24294	37749	7	applied	\N	\N	\N	\N	116626	116626	116627
24294	37750	8	applied	\N	\N	\N	\N	116628	116628	116629
24294	37751	9	applied	\N	\N	\N	\N	116630	116630	116631
24301	37762	0	applied	\N	\N	\N	\N	116661	116661	116662
24301	37763	1	applied	\N	\N	\N	\N	116663	116663	116664
24301	37764	2	applied	\N	\N	\N	\N	116665	116665	116666
24306	37765	0	applied	\N	\N	\N	\N	116671	116671	116672
24306	37766	1	applied	\N	\N	\N	\N	116673	116673	116674
24306	37767	2	applied	\N	\N	\N	\N	116675	116675	116676
24306	37768	4	applied	\N	\N	\N	\N	116678	116678	116679
24306	37769	5	applied	\N	\N	\N	\N	116680	116680	116681
24306	37770	6	applied	\N	\N	\N	\N	116682	116682	116683
24306	37771	7	applied	\N	\N	\N	\N	116684	116684	116685
24311	37775	0	applied	\N	\N	\N	\N	116700	116700	116701
24311	37776	1	applied	\N	\N	\N	\N	116702	116702	116703
24311	37777	2	applied	\N	\N	\N	\N	116704	116704	116705
24313	37778	0	applied	\N	\N	\N	\N	116709	116709	116710
24313	37779	1	applied	\N	\N	\N	\N	116711	116711	116712
24313	37780	2	applied	\N	\N	\N	\N	116713	116713	116714
24313	37781	3	applied	\N	\N	\N	\N	116715	116715	116716
24313	37782	4	applied	\N	\N	\N	\N	116717	116717	116718
24313	37783	5	applied	\N	\N	\N	\N	116719	116719	116720
24313	37784	6	applied	\N	\N	\N	\N	116721	116721	116722
24313	37785	7	applied	\N	\N	\N	\N	116723	116723	116724
24313	37786	8	applied	\N	\N	\N	\N	116725	116725	116726
24316	37794	0	applied	\N	\N	\N	\N	116748	116748	116749
24316	37795	1	applied	\N	\N	\N	\N	116750	116750	116751
24316	37796	2	applied	\N	\N	\N	\N	116752	116752	116753
24324	37827	0	applied	\N	\N	\N	\N	116823	116823	116824
24324	37828	1	applied	\N	\N	\N	\N	116825	116825	116826
24324	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	116827	116827	\N
24324	37830	3	applied	\N	\N	\N	\N	116828	116828	116829
24240	37638	1	applied	\N	\N	\N	\N	116336	116336	116337
24240	37639	2	applied	\N	\N	\N	\N	116338	116338	116339
24243	37637	0	applied	\N	\N	\N	\N	116334	116334	116335
24243	37638	1	applied	\N	\N	\N	\N	116336	116336	116337
24243	37639	2	applied	\N	\N	\N	\N	116338	116338	116339
24247	37644	0	applied	\N	\N	\N	\N	116354	116354	116355
24247	37645	1	applied	\N	\N	\N	\N	116356	116356	116357
24247	37646	2	applied	\N	\N	\N	\N	116358	116358	116359
24250	37660	0	applied	\N	\N	\N	\N	116391	116391	116392
24250	37661	1	applied	\N	\N	\N	\N	116393	116393	116394
24250	37662	2	applied	\N	\N	\N	\N	116395	116395	116396
24250	37663	3	applied	\N	\N	\N	\N	116397	116397	116398
24250	37664	4	applied	\N	\N	\N	\N	116399	116399	116400
24250	37665	5	applied	\N	\N	\N	\N	116401	116401	116402
24250	37666	6	applied	\N	\N	\N	\N	116403	116403	116404
24253	37667	0	applied	\N	\N	\N	\N	116409	116409	116410
24253	37668	1	applied	\N	\N	\N	\N	116411	116411	116412
24253	37669	2	applied	\N	\N	\N	\N	116413	116413	116414
24253	37670	3	applied	\N	\N	\N	\N	116415	116415	116416
24253	37671	4	applied	\N	\N	\N	\N	116417	116417	116418
24253	37672	5	applied	\N	\N	\N	\N	116419	116419	116420
24253	37673	6	applied	\N	\N	\N	\N	116421	116421	116422
24253	37674	7	applied	\N	\N	\N	\N	116423	116423	116424
24258	37675	0	applied	\N	\N	\N	\N	116429	116429	116430
24258	37676	1	applied	\N	\N	\N	\N	116431	116431	116432
24258	37677	2	applied	\N	\N	\N	\N	116433	116433	116434
24258	37678	3	applied	\N	\N	\N	\N	116435	116435	116436
24258	37679	4	applied	\N	\N	\N	\N	116437	116437	116438
24258	37680	5	applied	\N	\N	\N	\N	116439	116439	116440
24258	37681	6	applied	\N	\N	\N	\N	116441	116441	116442
24258	37682	7	applied	\N	\N	\N	\N	116443	116443	116444
24258	37683	8	applied	\N	\N	\N	\N	116445	116445	116446
24258	37684	9	applied	\N	\N	\N	\N	116447	116447	116448
24258	37685	10	applied	\N	\N	\N	\N	116449	116449	116450
24258	37686	11	applied	\N	\N	\N	\N	116451	116451	116452
24258	37687	12	applied	\N	\N	\N	\N	116453	116453	116454
24260	37688	0	applied	\N	\N	\N	\N	116458	116458	116459
24260	37689	1	applied	\N	\N	\N	\N	116460	116460	116461
24260	37690	2	applied	\N	\N	\N	\N	116462	116462	116463
24260	37691	3	applied	\N	\N	\N	\N	116464	116464	116465
24263	37692	0	applied	\N	\N	\N	\N	116469	116469	116470
24263	37693	1	applied	\N	\N	\N	\N	116471	116471	116472
24263	37694	2	applied	\N	\N	\N	\N	116473	116473	116474
24265	37695	0	applied	\N	\N	1000000000	\N	116477	116477	116478
24265	37697	1	applied	\N	\N	\N	\N	116482	116482	116483
24265	37698	2	applied	\N	\N	\N	\N	116484	116484	116485
24265	37699	3	applied	\N	\N	\N	\N	116486	116486	116487
24265	37700	4	applied	\N	\N	\N	\N	116488	116488	116489
24265	37696	5	applied	\N	\N	\N	\N	116479	116479	116480
24265	37701	6	applied	\N	\N	\N	\N	116490	116490	116491
24265	37702	7	applied	\N	\N	\N	\N	116492	116492	116493
24265	37703	8	applied	\N	\N	\N	\N	116494	116494	116495
24265	37704	9	applied	\N	\N	\N	\N	116496	116496	116497
24265	37705	10	applied	\N	\N	\N	\N	116498	116498	116499
24265	37706	11	applied	\N	\N	\N	\N	116500	116500	116501
24265	37707	12	applied	\N	\N	\N	\N	116502	116502	116503
24265	37708	13	applied	\N	\N	\N	\N	116504	116504	116505
24265	37709	14	applied	\N	\N	\N	\N	116506	116506	116507
24267	37710	0	applied	\N	\N	\N	\N	116511	116511	116512
24267	37711	1	applied	\N	\N	\N	\N	116513	116513	116514
24267	37712	2	applied	\N	\N	\N	\N	116515	116515	116516
24270	37713	0	applied	\N	\N	\N	\N	116520	116520	116521
24270	37714	1	applied	\N	\N	\N	\N	116522	116522	116523
24270	37715	2	applied	\N	\N	\N	\N	116524	116524	116525
24270	37716	3	applied	\N	\N	\N	\N	116526	116526	116527
24274	37721	0	applied	\N	\N	\N	\N	116543	116543	116544
24274	37722	1	applied	\N	\N	\N	\N	116545	116545	116546
24274	37723	2	applied	\N	\N	\N	\N	116547	116547	116548
24274	37724	3	applied	\N	\N	\N	\N	116549	116549	116550
24276	37725	0	applied	\N	\N	\N	\N	116554	116554	116555
24276	37726	1	applied	\N	\N	\N	\N	116556	116556	116557
24276	37727	2	applied	\N	\N	\N	\N	116558	116558	116559
24276	37728	3	applied	\N	\N	\N	\N	116560	116560	116561
24279	37725	0	applied	\N	\N	\N	\N	116554	116554	116555
24279	37728	1	applied	\N	\N	\N	\N	116560	116560	116568
24292	37739	0	applied	\N	\N	\N	\N	116602	116602	116603
24292	37740	1	applied	\N	\N	\N	\N	116604	116604	116605
24292	37741	2	applied	\N	\N	\N	\N	116606	116606	116607
24296	37742	0	applied	\N	\N	\N	\N	116612	116612	116613
24296	37743	1	applied	\N	\N	\N	\N	116614	116614	116615
24296	37744	2	applied	\N	\N	\N	\N	116616	116616	116617
24296	37745	3	applied	\N	\N	\N	\N	116618	116618	116619
24296	37746	4	applied	\N	\N	\N	\N	116620	116620	116621
24296	37747	5	applied	\N	\N	\N	\N	116622	116622	116623
24296	37748	6	applied	\N	\N	\N	\N	116624	116624	116625
24296	37749	7	applied	\N	\N	\N	\N	116626	116626	116627
24296	37750	8	applied	\N	\N	\N	\N	116628	116628	116629
24296	37751	9	applied	\N	\N	\N	\N	116630	116630	116631
24298	37752	0	applied	\N	\N	\N	\N	116638	116638	116639
24298	37753	1	applied	\N	\N	\N	\N	116640	116640	116641
24298	37754	2	applied	\N	\N	\N	\N	116642	116642	116643
24298	37755	3	applied	\N	\N	\N	\N	116644	116644	116645
24298	37756	4	applied	\N	\N	\N	\N	116646	116646	116647
24298	37757	5	applied	\N	\N	\N	\N	116648	116648	116649
24303	37762	0	applied	\N	\N	\N	\N	116661	116661	116662
24303	37763	1	applied	\N	\N	\N	\N	116663	116663	116664
24303	37764	2	applied	\N	\N	\N	\N	116665	116665	116666
24307	37765	0	applied	\N	\N	\N	\N	116671	116671	116672
24307	37766	1	applied	\N	\N	\N	\N	116673	116673	116674
24307	37767	2	applied	\N	\N	\N	\N	116675	116675	116676
24307	37768	4	applied	\N	\N	\N	\N	116678	116678	116679
24307	37769	5	applied	\N	\N	\N	\N	116680	116680	116681
24307	37770	6	applied	\N	\N	\N	\N	116682	116682	116683
24307	37771	7	applied	\N	\N	\N	\N	116684	116684	116685
24309	37772	0	applied	\N	\N	\N	\N	116694	116694	116695
24309	37773	1	applied	\N	\N	\N	\N	116696	116696	116697
24309	37774	2	applied	\N	\N	\N	\N	116698	116698	116699
24312	37778	0	applied	\N	\N	\N	\N	116709	116709	116710
24312	37779	1	applied	\N	\N	\N	\N	116711	116711	116712
24312	37780	2	applied	\N	\N	\N	\N	116713	116713	116714
24312	37781	3	applied	\N	\N	\N	\N	116715	116715	116716
24312	37782	4	applied	\N	\N	\N	\N	116717	116717	116718
24312	37783	5	applied	\N	\N	\N	\N	116719	116719	116720
24312	37784	6	applied	\N	\N	\N	\N	116721	116721	116722
24312	37785	7	applied	\N	\N	\N	\N	116723	116723	116724
24312	37786	8	applied	\N	\N	\N	\N	116725	116725	116726
24315	37787	0	applied	\N	\N	\N	\N	116730	116730	116731
24315	37788	1	applied	\N	\N	\N	\N	116732	116732	116733
24315	37789	2	applied	\N	\N	\N	\N	116734	116734	116735
24315	37790	3	applied	\N	\N	\N	\N	116736	116736	116737
24272	37720	3	applied	\N	\N	\N	\N	116538	116538	116539
24277	37725	0	applied	\N	\N	\N	\N	116554	116554	116555
24277	37726	1	applied	\N	\N	\N	\N	116556	116556	116557
24277	37727	2	applied	\N	\N	\N	\N	116558	116558	116559
24277	37728	3	applied	\N	\N	\N	\N	116560	116560	116561
24280	37725	0	applied	\N	\N	\N	\N	116554	116554	116555
24280	37726	1	applied	\N	\N	\N	\N	116556	116556	116557
24280	37727	2	applied	\N	\N	\N	\N	116558	116558	116559
24280	37728	3	applied	\N	\N	\N	\N	116560	116560	116561
24282	37729	0	applied	\N	\N	\N	\N	116573	116573	116574
24282	37730	1	applied	\N	\N	\N	\N	116575	116575	116576
24282	37731	2	applied	\N	\N	\N	\N	116577	116577	116578
24293	37739	0	applied	\N	\N	\N	\N	116602	116602	116603
24293	37740	1	applied	\N	\N	\N	\N	116604	116604	116605
24293	37741	2	applied	\N	\N	\N	\N	116606	116606	116607
24299	37752	0	applied	\N	\N	\N	\N	116638	116638	116639
24299	37753	1	applied	\N	\N	\N	\N	116640	116640	116641
24299	37754	2	applied	\N	\N	\N	\N	116642	116642	116643
24299	37755	3	applied	\N	\N	\N	\N	116644	116644	116645
24299	37756	4	applied	\N	\N	\N	\N	116646	116646	116647
24299	37757	5	applied	\N	\N	\N	\N	116648	116648	116649
24300	37758	0	applied	\N	\N	\N	\N	116651	116651	116652
24300	37759	1	applied	\N	\N	\N	\N	116653	116653	116654
24300	37760	2	applied	\N	\N	\N	\N	116655	116655	116656
24300	37761	3	applied	\N	\N	\N	\N	116657	116657	116658
24304	37762	0	applied	\N	\N	\N	\N	116661	116661	116662
24304	37763	1	applied	\N	\N	\N	\N	116663	116663	116664
24304	37764	2	applied	\N	\N	\N	\N	116665	116665	116666
24305	37765	0	applied	\N	\N	\N	\N	116671	116671	116672
24305	37766	1	applied	\N	\N	\N	\N	116673	116673	116674
24305	37767	2	applied	\N	\N	\N	\N	116675	116675	116676
24305	37768	4	applied	\N	\N	\N	\N	116678	116678	116679
24305	37769	5	applied	\N	\N	\N	\N	116680	116680	116681
24305	37770	6	applied	\N	\N	\N	\N	116682	116682	116683
24305	37771	7	applied	\N	\N	\N	\N	116684	116684	116685
24308	37765	0	applied	\N	\N	\N	\N	116671	116671	116672
24308	37766	1	applied	\N	\N	\N	\N	116673	116673	116674
24308	37767	2	applied	\N	\N	\N	\N	116675	116675	116676
24308	37768	4	applied	\N	\N	\N	\N	116678	116678	116679
24308	37769	5	applied	\N	\N	\N	\N	116680	116680	116681
24308	37770	6	applied	\N	\N	\N	\N	116682	116682	116683
24308	37771	7	applied	\N	\N	\N	\N	116684	116684	116685
24310	37775	0	applied	\N	\N	\N	\N	116700	116700	116701
24310	37776	1	applied	\N	\N	\N	\N	116702	116702	116703
24310	37777	2	applied	\N	\N	\N	\N	116704	116704	116705
24320	37810	0	applied	\N	\N	\N	\N	116784	116784	116785
24320	37811	1	applied	\N	\N	\N	\N	116786	116786	116787
24320	37812	2	applied	\N	\N	\N	\N	116788	116788	116789
24320	37813	3	applied	\N	\N	\N	\N	116790	116790	116791
24320	37814	4	applied	\N	\N	\N	\N	116792	116792	116793
24320	37815	5	applied	\N	\N	\N	\N	116794	116794	116795
24320	37816	6	applied	\N	\N	\N	\N	116796	116796	116797
24320	37817	7	applied	\N	\N	\N	\N	116798	116798	116799
24320	37818	8	applied	\N	\N	\N	\N	116800	116800	116801
24320	37819	9	applied	\N	\N	\N	\N	116802	116802	116803
24320	37820	10	applied	\N	\N	\N	\N	116804	116804	116805
24320	37821	11	applied	\N	\N	\N	\N	116806	116806	116807
24320	37822	12	applied	\N	\N	\N	\N	116808	116808	116809
24322	37827	0	applied	\N	\N	\N	\N	116823	116823	116824
24322	37828	1	applied	\N	\N	\N	\N	116825	116825	116826
24322	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	116827	116827	\N
24322	37830	3	applied	\N	\N	\N	\N	116828	116828	116829
24322	37831	4	applied	\N	\N	\N	\N	116830	116830	116831
24322	37832	5	applied	\N	\N	\N	\N	116832	116832	116833
24322	37833	6	applied	\N	\N	\N	\N	116834	116834	116835
24325	37834	0	applied	\N	\N	\N	\N	116842	116842	116843
24325	37835	1	applied	\N	\N	\N	\N	116844	116844	116845
24325	37836	2	applied	\N	\N	\N	\N	116846	116846	116847
24325	37837	3	applied	\N	\N	\N	\N	116848	116848	116849
24325	37838	4	applied	\N	\N	\N	\N	116850	116850	116851
24325	37839	5	applied	\N	\N	\N	\N	116852	116852	116853
24325	37840	6	applied	\N	\N	\N	\N	116854	116854	116855
24328	37841	0	applied	\N	\N	\N	\N	116857	116857	116858
24328	37842	1	applied	\N	\N	\N	\N	116859	116859	116860
24328	37843	2	applied	\N	\N	\N	\N	116861	116861	116862
24333	37848	0	applied	\N	\N	\N	\N	116876	116876	93344
24333	37849	1	applied	\N	\N	\N	\N	116877	116877	116878
24333	37850	2	applied	\N	\N	\N	\N	116879	116879	116880
24333	37851	3	applied	\N	\N	\N	\N	116881	116881	116882
24333	37852	4	applied	\N	\N	\N	\N	116883	116883	116884
24333	37853	5	applied	\N	\N	\N	\N	116885	116885	116886
24333	37854	6	applied	\N	\N	\N	\N	116887	116887	116888
24333	37855	7	applied	\N	\N	\N	\N	116889	116889	116890
24333	37856	8	applied	\N	\N	\N	\N	116891	116891	116892
24333	37857	9	applied	\N	\N	\N	\N	116893	116893	116894
24333	37858	10	applied	\N	\N	\N	\N	116895	116895	116896
24341	37867	0	applied	\N	\N	\N	\N	116929	116929	116930
24341	37868	1	applied	\N	\N	\N	\N	116931	116931	116932
24341	37869	2	applied	\N	\N	\N	\N	116933	116933	116934
24346	37876	0	applied	\N	\N	\N	\N	116954	116954	116955
24346	37877	1	applied	\N	\N	\N	\N	116956	116956	116957
24346	37878	2	applied	\N	\N	\N	\N	116958	116958	116959
24346	37879	3	applied	\N	\N	\N	\N	116960	116960	116961
24346	37880	4	applied	\N	\N	\N	\N	116962	116962	116963
24346	37881	5	applied	\N	\N	\N	\N	116964	116964	116965
24346	37882	6	applied	\N	\N	\N	\N	116966	116966	116967
24349	37886	0	applied	\N	\N	\N	\N	116977	116977	116978
24349	37887	1	applied	\N	\N	\N	\N	116979	116979	116980
24349	37888	2	applied	\N	\N	\N	\N	116981	116981	116982
24349	37889	3	applied	\N	\N	\N	\N	116983	116983	116984
24349	37890	4	applied	\N	\N	\N	\N	116985	116985	116986
24349	37891	5	applied	\N	\N	\N	\N	116987	116987	116988
24351	37892	0	applied	\N	\N	\N	\N	116993	116993	116994
24351	37893	1	applied	\N	\N	\N	\N	116995	116995	116996
24353	37892	0	applied	\N	\N	\N	\N	116993	116993	116994
24353	37893	1	applied	\N	\N	\N	\N	116995	116995	116996
24358	37899	0	applied	\N	\N	\N	\N	117015	117015	117016
24358	37900	1	applied	\N	\N	\N	\N	117017	117017	117018
24365	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24365	37907	1	applied	\N	\N	\N	\N	117042	117042	117043
24365	37908	2	applied	\N	\N	\N	\N	117044	117044	117045
24365	37909	3	applied	\N	\N	\N	\N	117046	117046	117047
24365	37910	4	applied	\N	\N	\N	\N	117048	117048	117049
24368	37917	0	applied	\N	\N	\N	\N	117065	117065	117066
24368	37918	1	applied	\N	\N	\N	\N	117067	117067	117068
24375	37932	0	applied	\N	\N	\N	\N	117105	117105	117106
24375	37933	1	applied	\N	\N	\N	\N	117107	117107	117108
24375	37934	2	applied	\N	\N	\N	\N	117109	117109	117110
24378	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24315	37791	4	applied	\N	\N	\N	\N	116738	116738	116739
24315	37792	5	applied	\N	\N	\N	\N	116740	116740	116741
24315	37793	6	applied	\N	\N	\N	\N	116742	116742	116743
24318	37804	0	applied	\N	\N	\N	\N	116770	116770	116771
24318	37805	1	applied	\N	\N	\N	\N	116772	116772	116773
24318	37806	2	applied	\N	\N	\N	\N	116774	116774	116775
24318	37807	3	applied	\N	\N	\N	\N	116776	116776	116777
24318	37808	4	applied	\N	\N	\N	\N	116778	116778	116779
24318	37809	5	applied	\N	\N	\N	\N	116780	116780	116781
24319	37810	0	applied	\N	\N	\N	\N	116784	116784	116785
24319	37811	1	applied	\N	\N	\N	\N	116786	116786	116787
24319	37812	2	applied	\N	\N	\N	\N	116788	116788	116789
24319	37813	3	applied	\N	\N	\N	\N	116790	116790	116791
24319	37814	4	applied	\N	\N	\N	\N	116792	116792	116793
24319	37815	5	applied	\N	\N	\N	\N	116794	116794	116795
24319	37816	6	applied	\N	\N	\N	\N	116796	116796	116797
24319	37817	7	applied	\N	\N	\N	\N	116798	116798	116799
24319	37818	8	applied	\N	\N	\N	\N	116800	116800	116801
24319	37819	9	applied	\N	\N	\N	\N	116802	116802	116803
24319	37820	10	applied	\N	\N	\N	\N	116804	116804	116805
24319	37821	11	applied	\N	\N	\N	\N	116806	116806	116807
24319	37822	12	applied	\N	\N	\N	\N	116808	116808	116809
24321	37823	0	applied	\N	\N	\N	\N	116813	116813	116814
24321	37824	1	applied	\N	\N	\N	\N	116815	116815	116816
24321	37825	2	applied	\N	\N	\N	\N	116817	116817	116818
24321	37826	3	applied	\N	\N	\N	\N	116819	116819	116820
24327	37841	0	applied	\N	\N	\N	\N	116857	116857	116858
24327	37842	1	applied	\N	\N	\N	\N	116859	116859	116860
24327	37843	2	applied	\N	\N	\N	\N	116861	116861	116862
24332	37848	0	applied	\N	\N	\N	\N	116876	116876	93344
24332	37849	1	applied	\N	\N	\N	\N	116877	116877	116878
24332	37850	2	applied	\N	\N	\N	\N	116879	116879	116880
24332	37851	3	applied	\N	\N	\N	\N	116881	116881	116882
24332	37852	4	applied	\N	\N	\N	\N	116883	116883	116884
24332	37853	5	applied	\N	\N	\N	\N	116885	116885	116886
24332	37854	6	applied	\N	\N	\N	\N	116887	116887	116888
24332	37855	7	applied	\N	\N	\N	\N	116889	116889	116890
24332	37856	8	applied	\N	\N	\N	\N	116891	116891	116892
24332	37857	9	applied	\N	\N	\N	\N	116893	116893	116894
24332	37858	10	applied	\N	\N	\N	\N	116895	116895	116896
24335	37848	0	applied	\N	\N	\N	\N	116876	116876	93344
24335	37849	1	applied	\N	\N	\N	\N	116877	116877	116878
24335	37850	2	applied	\N	\N	\N	\N	116879	116879	116880
24335	37851	3	applied	\N	\N	\N	\N	116881	116881	116882
24335	37852	4	applied	\N	\N	\N	\N	116883	116883	116884
24335	37853	5	applied	\N	\N	\N	\N	116885	116885	116886
24335	37854	6	applied	\N	\N	\N	\N	116887	116887	116888
24335	37855	7	applied	\N	\N	\N	\N	116889	116889	116890
24335	37856	8	applied	\N	\N	\N	\N	116891	116891	116892
24335	37857	9	applied	\N	\N	\N	\N	116893	116893	116894
24335	37858	10	applied	\N	\N	\N	\N	116895	116895	116896
24336	37859	0	applied	\N	\N	\N	\N	116903	116903	116904
24336	37860	1	applied	\N	\N	\N	\N	116905	116905	116906
24336	37861	2	applied	\N	\N	\N	\N	116907	116907	116908
24338	37862	0	applied	\N	\N	\N	\N	116912	116912	116913
24338	37863	2	applied	\N	\N	\N	\N	116915	116915	116916
24338	37864	3	applied	\N	\N	\N	\N	116917	116917	116918
24343	37870	0	applied	\N	\N	\N	\N	116938	116938	116939
24343	37871	1	applied	\N	\N	\N	\N	116940	116940	116941
24343	37872	2	applied	\N	\N	\N	\N	116942	116942	116943
24355	37894	0	applied	\N	\N	\N	\N	117000	117000	117001
24355	37895	1	applied	\N	\N	\N	\N	117002	117002	117003
24360	37899	0	applied	\N	\N	\N	\N	117015	117015	117016
24360	37900	1	applied	\N	\N	\N	\N	117017	117017	117018
24362	37901	0	applied	\N	\N	\N	\N	117023	117023	117024
24362	37902	1	applied	\N	\N	\N	\N	117025	117025	117026
24367	37917	0	applied	\N	\N	\N	\N	117065	117065	117066
24367	37918	1	applied	\N	\N	\N	\N	117067	117067	117068
24377	37932	0	applied	\N	\N	\N	\N	117105	117105	117106
24377	37933	1	applied	\N	\N	\N	\N	117107	117107	117108
24377	37934	2	applied	\N	\N	\N	\N	117109	117109	117110
24380	37935	0	applied	\N	\N	\N	\N	117123	117123	117124
24382	37939	0	applied	\N	\N	\N	\N	117137	117137	117138
24382	37940	1	applied	\N	\N	\N	\N	117139	117139	117140
24382	37941	2	applied	\N	\N	\N	\N	117141	117141	117142
24382	37942	3	applied	\N	\N	\N	\N	117143	117143	117144
24385	37943	0	applied	\N	\N	\N	\N	117147	117147	117148
24385	37944	1	applied	\N	\N	\N	\N	117149	117149	117150
24385	37945	2	applied	\N	\N	\N	\N	117151	117151	117152
24385	37946	3	applied	\N	\N	\N	\N	117153	117153	117154
24385	37947	4	applied	\N	\N	\N	\N	117155	117155	117156
24385	37948	5	applied	\N	\N	\N	\N	117157	117157	117158
24385	37949	6	applied	\N	\N	\N	\N	117159	117159	117160
24387	37950	0	applied	\N	\N	\N	\N	117164	117164	117165
24387	37951	1	applied	\N	\N	\N	\N	117166	117166	117167
24392	37950	0	applied	\N	\N	\N	\N	117164	117164	117165
24392	37952	1	applied	\N	\N	\N	\N	117172	117172	117173
24392	37954	2	applied	\N	\N	\N	\N	117176	117176	117180
24392	37951	3	applied	\N	\N	\N	\N	117166	117166	117181
24392	37953	4	applied	\N	\N	\N	\N	117174	117174	117177
24400	37959	0	applied	\N	\N	\N	\N	117211	117211	117212
24400	37960	1	applied	\N	\N	\N	\N	117213	117213	117214
24400	37961	2	applied	\N	\N	\N	\N	117215	117215	117216
24403	37967	0	applied	\N	\N	\N	\N	117235	117235	117236
24403	37968	1	applied	\N	\N	\N	\N	117237	117237	117238
24403	37969	2	applied	\N	\N	\N	\N	117239	117239	117240
24406	37970	0	applied	\N	\N	\N	\N	117244	117244	117245
24406	37971	1	applied	\N	\N	\N	\N	117246	117246	117247
24408	37978	0	applied	\N	\N	\N	\N	117264	117264	117265
24408	37979	1	applied	\N	\N	\N	\N	117266	117266	117267
24408	37980	2	applied	\N	\N	\N	\N	117268	117268	117269
24413	37988	0	applied	\N	\N	\N	\N	117290	117290	117291
24413	37989	1	applied	\N	\N	\N	\N	117292	117292	117293
24416	37990	0	applied	\N	\N	\N	\N	117296	117296	117297
24416	37991	1	applied	\N	\N	\N	\N	117298	117298	117299
24418	37999	0	applied	\N	\N	\N	\N	117318	117318	117319
24418	38000	1	applied	\N	\N	\N	\N	117320	117320	117321
24427	38015	0	applied	\N	\N	\N	\N	117386	117386	117387
24427	38016	1	applied	\N	\N	\N	\N	117388	117388	117389
24428	38017	0	applied	\N	\N	\N	\N	117395	117395	117396
24428	38018	1	applied	\N	\N	\N	\N	117397	117397	117398
24428	38019	2	applied	\N	\N	\N	\N	117399	117399	117400
24432	38017	0	applied	\N	\N	\N	\N	117395	117395	117396
24432	38018	1	applied	\N	\N	\N	\N	117397	117397	117398
24432	38019	2	applied	\N	\N	\N	\N	117399	117399	117400
24437	38022	0	applied	\N	\N	\N	\N	117416	117416	117417
24437	38023	1	applied	\N	\N	\N	\N	117418	117418	117419
24437	38024	2	applied	\N	\N	\N	\N	117420	117420	117421
24437	38025	3	applied	\N	\N	\N	\N	117422	117422	117423
24437	38026	4	applied	\N	\N	\N	\N	117424	117424	117425
24323	37832	5	applied	\N	\N	\N	\N	116832	116832	116833
24323	37833	6	applied	\N	\N	\N	\N	116834	116834	116835
24329	37841	0	applied	\N	\N	\N	\N	116857	116857	116858
24329	37842	1	applied	\N	\N	\N	\N	116859	116859	116860
24329	37843	2	applied	\N	\N	\N	\N	116861	116861	116862
24330	37844	0	applied	\N	\N	\N	\N	116866	116866	116867
24330	37845	1	applied	\N	\N	\N	\N	116868	116868	116869
24330	37846	2	applied	\N	\N	\N	\N	116870	116870	116871
24330	37847	3	applied	\N	\N	\N	\N	116872	116872	116873
24334	37848	0	applied	\N	\N	\N	\N	116876	116876	93344
24334	37849	1	applied	\N	\N	\N	\N	116877	116877	116878
24334	37850	2	applied	\N	\N	\N	\N	116879	116879	116880
24334	37851	3	applied	\N	\N	\N	\N	116881	116881	116882
24334	37852	4	applied	\N	\N	\N	\N	116883	116883	116884
24334	37853	5	applied	\N	\N	\N	\N	116885	116885	116886
24334	37854	6	applied	\N	\N	\N	\N	116887	116887	116888
24334	37855	7	applied	\N	\N	\N	\N	116889	116889	116890
24334	37856	8	applied	\N	\N	\N	\N	116891	116891	116892
24334	37857	9	applied	\N	\N	\N	\N	116893	116893	116894
24334	37858	10	applied	\N	\N	\N	\N	116895	116895	116896
24337	37859	0	applied	\N	\N	\N	\N	116903	116903	116904
24337	37860	1	applied	\N	\N	\N	\N	116905	116905	116906
24337	37861	2	applied	\N	\N	\N	\N	116907	116907	116908
24339	37862	0	applied	\N	\N	\N	\N	116912	116912	116913
24339	37863	2	applied	\N	\N	\N	\N	116915	116915	116916
24339	37864	3	applied	\N	\N	\N	\N	116917	116917	116918
24342	37867	0	applied	\N	\N	\N	\N	116929	116929	116930
24342	37868	1	applied	\N	\N	\N	\N	116931	116931	116932
24342	37869	2	applied	\N	\N	\N	\N	116933	116933	116934
24344	37873	0	applied	\N	\N	\N	\N	116946	116946	116947
24344	37874	1	applied	\N	\N	\N	\N	116948	116948	116949
24344	37875	2	applied	\N	\N	\N	\N	116950	116950	116951
24347	37883	0	applied	\N	\N	\N	\N	116969	116969	116970
24347	37884	1	applied	\N	\N	\N	\N	116971	116971	116972
24347	37885	2	applied	\N	\N	\N	\N	116973	116973	116974
24350	37886	0	applied	\N	\N	\N	\N	116977	116977	116978
24350	37887	1	applied	\N	\N	\N	\N	116979	116979	116980
24350	37888	2	applied	\N	\N	\N	\N	116981	116981	116982
24350	37889	3	applied	\N	\N	\N	\N	116983	116983	116984
24350	37890	4	applied	\N	\N	\N	\N	116985	116985	116986
24350	37891	5	applied	\N	\N	\N	\N	116987	116987	116988
24352	37892	0	applied	\N	\N	\N	\N	116993	116993	116994
24352	37893	1	applied	\N	\N	\N	\N	116995	116995	116996
24354	37892	0	applied	\N	\N	\N	\N	116993	116993	116994
24354	37893	1	applied	\N	\N	\N	\N	116995	116995	116996
24356	37896	0	applied	\N	\N	\N	\N	117006	117006	117007
24356	37897	1	applied	\N	\N	\N	\N	117008	117008	117009
24356	37898	2	applied	\N	\N	\N	\N	117010	117010	117011
24363	37903	0	applied	\N	\N	\N	\N	117030	117030	117031
24363	37904	1	applied	\N	\N	\N	\N	117032	117032	117033
24363	37905	2	applied	\N	\N	\N	\N	117034	117034	117035
24366	37911	0	applied	\N	\N	\N	\N	117051	117051	117052
24366	37912	1	applied	\N	\N	\N	\N	117053	117053	117054
24366	37913	2	applied	\N	\N	\N	\N	117055	117055	117056
24366	37914	3	applied	\N	\N	\N	\N	117057	117057	117058
24366	37915	4	applied	\N	\N	\N	\N	117059	117059	117060
24366	37916	5	applied	\N	\N	\N	\N	117061	117061	117062
24369	37919	0	applied	\N	\N	\N	\N	117071	117071	117072
24369	37920	1	applied	\N	\N	\N	\N	117073	117073	117074
24369	37921	2	applied	\N	\N	\N	\N	117075	117075	117076
24369	37922	3	applied	\N	\N	\N	\N	117077	117077	117078
24369	37923	4	applied	\N	\N	\N	\N	117079	117079	117080
24369	37924	5	applied	\N	\N	\N	\N	117081	117081	117082
24369	37925	6	applied	\N	\N	\N	\N	117083	117083	117084
24369	37926	7	applied	\N	\N	\N	\N	117085	117085	117086
24376	37932	0	applied	\N	\N	\N	\N	117105	117105	117106
24376	37933	1	applied	\N	\N	\N	\N	117107	117107	117108
24376	37934	2	applied	\N	\N	\N	\N	117109	117109	117110
24386	37943	0	applied	\N	\N	\N	\N	117147	117147	117148
24386	37944	1	applied	\N	\N	\N	\N	117149	117149	117150
24386	37945	2	applied	\N	\N	\N	\N	117151	117151	117152
24386	37946	3	applied	\N	\N	\N	\N	117153	117153	117154
24386	37947	4	applied	\N	\N	\N	\N	117155	117155	117156
24386	37948	5	applied	\N	\N	\N	\N	117157	117157	117158
24386	37949	6	applied	\N	\N	\N	\N	117159	117159	117160
24389	37950	0	applied	\N	\N	\N	\N	117164	117164	117165
24389	37951	1	applied	\N	\N	\N	\N	117166	117166	117167
24395	37955	0	applied	\N	\N	\N	\N	117185	117185	117186
24395	37956	1	applied	\N	\N	\N	\N	117187	117187	117188
24397	37957	0	applied	\N	\N	\N	\N	117203	117203	117204
24397	37958	1	applied	\N	\N	\N	\N	117205	117205	117206
24399	37959	0	applied	\N	\N	\N	\N	117211	117211	117212
24399	37960	1	applied	\N	\N	\N	\N	117213	117213	117214
24399	37961	2	applied	\N	\N	\N	\N	117215	117215	117216
24402	37965	0	applied	\N	\N	\N	\N	117229	117229	117230
24402	37966	1	applied	\N	\N	\N	\N	117231	117231	117232
24409	37981	0	applied	\N	\N	\N	\N	117270	117270	117271
24414	37990	0	applied	\N	\N	\N	\N	117296	117296	117297
24414	37991	1	applied	\N	\N	\N	\N	117298	117298	117299
24417	37992	0	applied	\N	\N	\N	\N	117303	117303	117304
24417	37993	1	applied	\N	\N	\N	\N	117305	117305	117306
24417	37994	2	applied	\N	\N	\N	\N	117307	117307	117308
24417	37995	3	applied	\N	\N	\N	\N	117309	117309	117310
24417	37996	4	applied	\N	\N	\N	\N	117311	117311	117312
24417	37997	5	applied	\N	\N	\N	\N	117313	117313	117314
24417	37998	6	applied	\N	\N	\N	\N	117315	117315	117316
24422	38001	0	applied	\N	\N	\N	\N	117326	117326	117327
24422	38004	1	applied	\N	\N	\N	\N	117359	117359	117360
24422	38005	2	applied	\N	\N	\N	\N	117361	117361	117362
24422	38003	3	applied	\N	\N	\N	\N	117346	117346	117343
24422	38002	4	applied	\N	\N	\N	\N	117340	117340	117347
24422	38006	5	applied	\N	\N	\N	\N	117363	117363	117364
24422	38007	6	applied	\N	\N	\N	\N	117365	117365	117366
24425	38015	0	applied	\N	\N	\N	\N	117386	117386	117387
24425	38016	1	applied	\N	\N	\N	\N	117388	117388	117389
24430	38017	0	applied	\N	\N	\N	\N	117395	117395	117396
24430	38018	1	applied	\N	\N	\N	\N	117397	117397	117398
24430	38019	2	applied	\N	\N	\N	\N	117399	117399	117400
24436	38022	0	applied	\N	\N	\N	\N	117416	117416	117417
24436	38023	1	applied	\N	\N	\N	\N	117418	117418	117419
24436	38024	2	applied	\N	\N	\N	\N	117420	117420	117421
24436	38025	3	applied	\N	\N	\N	\N	117422	117422	117423
24436	38026	4	applied	\N	\N	\N	\N	117424	117424	117425
24436	38027	5	applied	\N	\N	\N	\N	117426	117426	117427
24436	38028	6	applied	\N	\N	\N	\N	117428	117428	117429
24441	38037	0	applied	\N	\N	\N	\N	117455	117455	117456
24441	38038	1	applied	\N	\N	\N	\N	117457	117457	117458
24443	38035	0	applied	\N	\N	\N	\N	117449	117449	117450
24443	38037	1	applied	\N	\N	\N	\N	117455	117455	117456
24443	38036	2	applied	\N	\N	\N	\N	117451	117451	117452
24324	37831	4	applied	\N	\N	\N	\N	116830	116830	116831
24326	37841	0	applied	\N	\N	\N	\N	116857	116857	116858
24326	37842	1	applied	\N	\N	\N	\N	116859	116859	116860
24326	37843	2	applied	\N	\N	\N	\N	116861	116861	116862
24331	37848	0	applied	\N	\N	\N	\N	116876	116876	93344
24331	37849	1	applied	\N	\N	\N	\N	116877	116877	116878
24331	37850	2	applied	\N	\N	\N	\N	116879	116879	116880
24331	37851	3	applied	\N	\N	\N	\N	116881	116881	116882
24331	37852	4	applied	\N	\N	\N	\N	116883	116883	116884
24331	37853	5	applied	\N	\N	\N	\N	116885	116885	116886
24331	37854	6	applied	\N	\N	\N	\N	116887	116887	116888
24331	37855	7	applied	\N	\N	\N	\N	116889	116889	116890
24331	37856	8	applied	\N	\N	\N	\N	116891	116891	116892
24331	37857	9	applied	\N	\N	\N	\N	116893	116893	116894
24331	37858	10	applied	\N	\N	\N	\N	116895	116895	116896
24340	37865	0	applied	\N	\N	\N	\N	116924	116924	116925
24340	37866	1	applied	\N	\N	\N	\N	116926	116926	116927
24345	37873	0	applied	\N	\N	\N	\N	116946	116946	116947
24345	37874	1	applied	\N	\N	\N	\N	116948	116948	116949
24345	37875	2	applied	\N	\N	\N	\N	116950	116950	116951
24348	37883	0	applied	\N	\N	\N	\N	116969	116969	116970
24348	37884	1	applied	\N	\N	\N	\N	116971	116971	116972
24348	37885	2	applied	\N	\N	\N	\N	116973	116973	116974
24357	37896	0	applied	\N	\N	\N	\N	117006	117006	117007
24357	37897	1	applied	\N	\N	\N	\N	117008	117008	117009
24357	37898	2	applied	\N	\N	\N	\N	117010	117010	117011
24359	37899	0	applied	\N	\N	\N	\N	117015	117015	117016
24359	37900	1	applied	\N	\N	\N	\N	117017	117017	117018
24361	37901	0	applied	\N	\N	\N	\N	117023	117023	117024
24361	37902	1	applied	\N	\N	\N	\N	117025	117025	117026
24364	37903	0	applied	\N	\N	\N	\N	117030	117030	117031
24364	37904	1	applied	\N	\N	\N	\N	117032	117032	117033
24364	37905	2	applied	\N	\N	\N	\N	117034	117034	117035
24370	37919	0	applied	\N	\N	\N	\N	117071	117071	117072
24370	37920	1	applied	\N	\N	\N	\N	117073	117073	117074
24370	37921	2	applied	\N	\N	\N	\N	117075	117075	117076
24370	37922	3	applied	\N	\N	\N	\N	117077	117077	117078
24370	37923	4	applied	\N	\N	\N	\N	117079	117079	117080
24370	37924	5	applied	\N	\N	\N	\N	117081	117081	117082
24370	37925	6	applied	\N	\N	\N	\N	117083	117083	117084
24370	37926	7	applied	\N	\N	\N	\N	117085	117085	117086
24372	37927	0	applied	\N	\N	\N	\N	117092	117092	117093
24372	37928	1	applied	\N	\N	\N	\N	117094	117094	117095
24374	37929	0	applied	\N	\N	\N	\N	117097	117097	117098
24374	37930	1	applied	\N	\N	\N	\N	117099	117099	117100
24374	37931	2	applied	\N	\N	\N	\N	117101	117101	117102
24379	37935	0	applied	\N	\N	\N	\N	117123	117123	117124
24381	37936	0	applied	\N	\N	\N	\N	117129	117129	117130
24381	37937	1	applied	\N	\N	\N	\N	117131	117131	117132
24381	37938	2	applied	\N	\N	\N	\N	117133	117133	117134
24390	37950	0	applied	\N	\N	\N	\N	117164	117164	117165
24390	37951	1	applied	\N	\N	\N	\N	117166	117166	117167
24391	37952	0	applied	\N	\N	\N	\N	117172	117172	117173
24391	37953	1	applied	\N	\N	\N	\N	117174	117174	117175
24391	37954	2	applied	\N	\N	\N	\N	117176	117176	117177
24393	37952	0	applied	\N	\N	\N	\N	117172	117172	117173
24393	37953	1	applied	\N	\N	\N	\N	117174	117174	117175
24393	37954	2	applied	\N	\N	\N	\N	117176	117176	117177
24396	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24396	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24396	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24396	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24396	37896	4	applied	\N	\N	\N	\N	117006	117006	117007
24396	37899	5	applied	\N	\N	\N	\N	117015	117015	117016
24396	37901	6	applied	\N	\N	\N	\N	117023	117023	117024
24396	37903	7	applied	\N	\N	\N	\N	117030	117030	117031
24396	37907	8	applied	\N	\N	\N	\N	117042	117042	117043
24396	37908	9	applied	\N	\N	\N	\N	117044	117044	117045
24396	37912	10	applied	\N	\N	\N	\N	117053	117053	117054
24396	37913	11	applied	\N	\N	\N	\N	117055	117055	117056
24396	37917	12	applied	\N	\N	\N	\N	117065	117065	117066
24396	37920	13	applied	\N	\N	\N	\N	117073	117073	117074
24396	37921	14	applied	\N	\N	\N	\N	117075	117075	117076
24396	37922	15	applied	\N	\N	\N	\N	117077	117077	117078
24396	37927	16	applied	\N	\N	\N	\N	117092	117092	117093
24396	37929	17	applied	\N	\N	\N	\N	117097	117097	117098
24396	37933	18	applied	\N	\N	\N	\N	117107	117107	117108
24396	37935	19	applied	\N	\N	\N	\N	117123	117123	117124
24396	37936	20	applied	\N	\N	\N	\N	117129	117129	117130
24396	37939	21	applied	\N	\N	\N	\N	117137	117137	117138
24396	37940	22	applied	\N	\N	\N	\N	117139	117139	117140
24396	37943	23	applied	\N	\N	\N	\N	117147	117147	117148
24396	37944	24	applied	\N	\N	\N	\N	117149	117149	117150
24396	37945	25	applied	\N	\N	\N	\N	117151	117151	117152
24396	37950	26	applied	\N	\N	\N	\N	117164	117164	117165
24396	37952	27	applied	\N	\N	\N	\N	117172	117172	117173
24396	37955	28	applied	\N	\N	\N	\N	117185	117185	117186
24396	37897	29	applied	\N	\N	\N	\N	117008	117008	117009
24396	37898	30	applied	\N	\N	\N	\N	117010	117010	117011
24396	37900	31	applied	\N	\N	\N	\N	117017	117017	117018
24396	37902	32	applied	\N	\N	\N	\N	117025	117025	117026
24396	37904	33	applied	\N	\N	\N	\N	117032	117032	117033
24396	37905	34	applied	\N	\N	\N	\N	117034	117034	117035
24396	37909	35	applied	\N	\N	\N	\N	117046	117046	117047
24396	37910	36	applied	\N	\N	\N	\N	117048	117048	117049
24396	37914	37	applied	\N	\N	\N	\N	117057	117057	117058
24396	37915	38	applied	\N	\N	\N	\N	117059	117059	117060
24396	37918	39	applied	\N	\N	\N	\N	117067	117067	117117
24396	37923	40	applied	\N	\N	\N	\N	117079	117079	117118
24396	37924	41	applied	\N	\N	\N	\N	117081	117081	117119
24396	37916	42	applied	\N	\N	\N	\N	117061	117061	117082
24396	37925	43	applied	\N	\N	\N	\N	117083	117083	117084
24396	37928	44	applied	\N	\N	\N	\N	117094	117094	117120
24396	37930	45	applied	\N	\N	\N	\N	117099	117099	117121
24396	37934	46	applied	\N	\N	\N	\N	117109	117109	117192
24396	37926	47	applied	\N	\N	\N	\N	117085	117085	117193
24396	37931	48	applied	\N	\N	\N	\N	117101	117101	117110
24396	37937	49	applied	\N	\N	\N	\N	117131	117131	117132
24396	37946	50	applied	\N	\N	\N	\N	117153	117153	117194
24396	37954	51	applied	\N	\N	\N	\N	117176	117176	117195
24396	37938	52	applied	\N	\N	\N	\N	117133	117133	117196
24396	37941	53	applied	\N	\N	\N	\N	117141	117141	117197
24396	37942	54	applied	\N	\N	\N	\N	117143	117143	117198
24396	37947	55	applied	\N	\N	\N	\N	117155	117155	117199
24396	37948	56	applied	\N	\N	\N	\N	117157	117157	117200
24396	37949	57	applied	\N	\N	\N	\N	117159	117159	117180
24396	37951	58	applied	\N	\N	\N	\N	117166	117166	117181
24396	37953	59	applied	\N	\N	\N	\N	117174	117174	117177
24396	37956	60	applied	\N	\N	\N	\N	117187	117187	117188
24398	37957	0	applied	\N	\N	\N	\N	117203	117203	117204
24378	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24378	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24378	37903	3	applied	\N	\N	\N	\N	117030	117030	117031
24378	37907	4	applied	\N	\N	\N	\N	117042	117042	117043
24378	37908	5	applied	\N	\N	\N	\N	117044	117044	117045
24378	37912	6	applied	\N	\N	\N	\N	117053	117053	117054
24378	37913	7	applied	\N	\N	\N	\N	117055	117055	117056
24378	37917	8	applied	\N	\N	\N	\N	117065	117065	117066
24378	37920	9	applied	\N	\N	\N	\N	117073	117073	117074
24378	37921	10	applied	\N	\N	\N	\N	117075	117075	117076
24378	37922	11	applied	\N	\N	\N	\N	117077	117077	117078
24378	37927	12	applied	\N	\N	\N	\N	117092	117092	117093
24378	37929	13	applied	\N	\N	\N	\N	117097	117097	117098
24378	37933	14	applied	\N	\N	\N	\N	117107	117107	117108
24378	37904	15	applied	\N	\N	\N	\N	117032	117032	117033
24378	37905	16	applied	\N	\N	\N	\N	117034	117034	117035
24378	37909	17	applied	\N	\N	\N	\N	117046	117046	117047
24378	37910	18	applied	\N	\N	\N	\N	117048	117048	117049
24378	37914	19	applied	\N	\N	\N	\N	117057	117057	117058
24378	37915	20	applied	\N	\N	\N	\N	117059	117059	117060
24378	37918	21	applied	\N	\N	\N	\N	117067	117067	117117
24378	37923	22	applied	\N	\N	\N	\N	117079	117079	117118
24378	37924	23	applied	\N	\N	\N	\N	117081	117081	117119
24378	37916	24	applied	\N	\N	\N	\N	117061	117061	117082
24378	37925	25	applied	\N	\N	\N	\N	117083	117083	117084
24378	37928	26	applied	\N	\N	\N	\N	117094	117094	117120
24378	37930	27	applied	\N	\N	\N	\N	117099	117099	117121
24378	37926	28	applied	\N	\N	\N	\N	117085	117085	117100
24378	37931	29	applied	\N	\N	\N	\N	117101	117101	117102
24384	37943	0	applied	\N	\N	\N	\N	117147	117147	117148
24384	37944	1	applied	\N	\N	\N	\N	117149	117149	117150
24384	37945	2	applied	\N	\N	\N	\N	117151	117151	117152
24384	37946	3	applied	\N	\N	\N	\N	117153	117153	117154
24384	37947	4	applied	\N	\N	\N	\N	117155	117155	117156
24384	37948	5	applied	\N	\N	\N	\N	117157	117157	117158
24384	37949	6	applied	\N	\N	\N	\N	117159	117159	117160
24388	37950	0	applied	\N	\N	\N	\N	117164	117164	117165
24388	37951	1	applied	\N	\N	\N	\N	117166	117166	117167
24394	37955	0	applied	\N	\N	\N	\N	117185	117185	117186
24394	37956	1	applied	\N	\N	\N	\N	117187	117187	117188
24401	37962	0	applied	\N	\N	\N	\N	117221	117221	117222
24401	37963	1	applied	\N	\N	\N	\N	117223	117223	117224
24401	37964	2	applied	\N	\N	\N	\N	117225	117225	117226
24404	37967	0	applied	\N	\N	\N	\N	117235	117235	117236
24404	37968	1	applied	\N	\N	\N	\N	117237	117237	117238
24404	37969	2	applied	\N	\N	\N	\N	117239	117239	117240
24411	37982	0	applied	\N	\N	\N	\N	117274	117274	117275
24411	37983	1	applied	\N	\N	\N	\N	117278	117278	117279
24411	37984	2	applied	\N	\N	\N	\N	117280	117280	117281
24419	37999	0	applied	\N	\N	\N	\N	117318	117318	117319
24419	38000	1	applied	\N	\N	\N	\N	117320	117320	117321
24421	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24421	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24421	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24421	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24421	37721	4	applied	\N	\N	\N	\N	116543	116543	116544
24421	37848	5	applied	\N	\N	\N	\N	116876	116876	93344
24421	37713	6	applied	\N	\N	\N	\N	116520	116520	116521
24421	37717	7	applied	\N	\N	\N	\N	116533	116533	116534
24421	37718	8	applied	\N	\N	\N	\N	116535	116535	116479
24421	37722	9	applied	\N	\N	\N	\N	116545	116545	116546
24421	37725	10	applied	\N	\N	\N	\N	116554	116554	116555
24421	37729	11	applied	\N	\N	\N	\N	116573	116573	116574
24421	37732	12	applied	\N	\N	\N	\N	116582	116582	116583
24421	37735	13	applied	\N	\N	\N	\N	116589	116589	116590
24421	37739	14	applied	\N	\N	\N	\N	116602	116602	116603
24421	37742	15	applied	\N	\N	\N	\N	116612	116612	116613
24421	37743	16	applied	\N	\N	\N	\N	116614	116614	116615
24421	37744	17	applied	\N	\N	\N	\N	116616	116616	116617
24421	37752	18	applied	\N	\N	\N	\N	116638	116638	116639
24421	37753	19	applied	\N	\N	\N	\N	116640	116640	116641
24421	37758	20	applied	\N	\N	\N	\N	116651	116651	116652
24421	37762	21	applied	\N	\N	\N	\N	116661	116661	116662
24421	37765	22	applied	\N	\N	\N	\N	116671	116671	116672
24421	37766	23	applied	\N	\N	\N	\N	116673	116673	116674
24421	37772	24	applied	\N	\N	\N	\N	116694	116694	116695
24421	37775	25	applied	\N	\N	\N	\N	116700	116700	116701
24421	37778	26	applied	\N	\N	\N	\N	116709	116709	116710
24421	37779	27	applied	\N	\N	\N	\N	116711	116711	116712
24421	37780	28	applied	\N	\N	\N	\N	116713	116713	116714
24421	37787	29	applied	\N	\N	\N	\N	116730	116730	116731
24421	37788	30	applied	\N	\N	\N	\N	116732	116732	116733
24421	37794	31	applied	\N	\N	\N	\N	116748	116748	116749
24421	37797	32	applied	\N	\N	\N	\N	116754	116754	116755
24421	37798	33	applied	\N	\N	\N	\N	116756	116756	116757
24421	37804	34	applied	\N	\N	\N	\N	116770	116770	116771
24421	37805	35	applied	\N	\N	\N	\N	116772	116772	116773
24421	37810	36	applied	\N	\N	\N	\N	116784	116784	116785
24421	37811	37	applied	\N	\N	\N	\N	116786	116786	116787
24421	37812	38	applied	\N	\N	\N	\N	116788	116788	116789
24421	37813	39	applied	\N	\N	\N	\N	116790	116790	116791
24421	37823	40	applied	\N	\N	\N	\N	116813	116813	116814
24421	37827	41	applied	\N	\N	\N	\N	116823	116823	116824
24421	37828	42	applied	\N	\N	\N	\N	116825	116825	116826
24421	37841	43	applied	\N	\N	\N	\N	116857	116857	116858
24421	37844	44	applied	\N	\N	\N	\N	116866	116866	116867
24421	37849	45	applied	\N	\N	\N	\N	116877	116877	116878
24421	37850	46	applied	\N	\N	\N	\N	116879	116879	116880
24421	37851	47	applied	\N	\N	\N	\N	116881	116881	116882
24421	37859	48	applied	\N	\N	\N	\N	116903	116903	116904
24421	37862	49	applied	\N	\N	\N	\N	116912	116912	116913
24421	37865	50	applied	\N	\N	\N	\N	116924	116924	116925
24421	37867	51	applied	\N	\N	\N	\N	116929	116929	116930
24421	37870	52	applied	\N	\N	\N	\N	116938	116938	116939
24421	37873	53	applied	\N	\N	\N	\N	116946	116946	116947
24421	37876	54	applied	\N	\N	\N	\N	116954	116954	116955
24421	37877	55	applied	\N	\N	\N	\N	116956	116956	116957
24421	37883	56	applied	\N	\N	\N	\N	116969	116969	116970
24421	37886	57	applied	\N	\N	\N	\N	116977	116977	116978
24421	37887	58	applied	\N	\N	\N	\N	116979	116979	116980
24421	37892	59	applied	\N	\N	\N	\N	116993	116993	116994
24421	37894	60	applied	\N	\N	\N	\N	117000	117000	117001
24421	37896	61	applied	\N	\N	\N	\N	117006	117006	117007
24421	37899	62	applied	\N	\N	\N	\N	117015	117015	117016
24421	37901	63	applied	\N	\N	\N	\N	117023	117023	117024
24421	37903	64	applied	\N	\N	\N	\N	117030	117030	117031
24421	37907	65	applied	\N	\N	\N	\N	117042	117042	117043
24421	37908	66	applied	\N	\N	\N	\N	117044	117044	117045
24421	37912	67	applied	\N	\N	\N	\N	117053	117053	117054
24421	37913	68	applied	\N	\N	\N	\N	117055	117055	117056
24398	37958	1	applied	\N	\N	\N	\N	117205	117205	117206
24405	37970	0	applied	\N	\N	\N	\N	117244	117244	117245
24405	37971	1	applied	\N	\N	\N	\N	117246	117246	117247
24407	37972	0	applied	\N	\N	\N	\N	117251	117251	117252
24407	37973	1	applied	\N	\N	\N	\N	117253	117253	117254
24407	37974	2	applied	\N	\N	\N	\N	117255	117255	117256
24407	37975	3	applied	\N	\N	\N	\N	117257	117257	117258
24407	37976	4	applied	\N	\N	\N	\N	117259	117259	117260
24407	37977	5	applied	\N	\N	\N	\N	117261	117261	117262
24410	37982	0	applied	\N	\N	\N	\N	117274	117274	117275
24410	37981	1	applied	\N	\N	\N	\N	117270	117270	117271
24412	37985	0	applied	\N	\N	\N	\N	117284	117284	117285
24412	37986	1	applied	\N	\N	\N	\N	117286	117286	117287
24412	37987	2	applied	\N	\N	\N	\N	117288	117288	117289
24415	37990	0	applied	\N	\N	\N	\N	117296	117296	117297
24415	37991	1	applied	\N	\N	\N	\N	117298	117298	117299
24420	37957	0	applied	\N	\N	\N	\N	117203	117203	117204
24420	37959	1	applied	\N	\N	\N	\N	117211	117211	117212
24420	37962	2	applied	\N	\N	\N	\N	117221	117221	117222
24420	37963	3	applied	\N	\N	\N	\N	117223	117223	117224
24420	37965	4	applied	\N	\N	\N	\N	117229	117229	117230
24420	37967	5	applied	\N	\N	\N	\N	117235	117235	117236
24420	37970	6	applied	\N	\N	\N	\N	117244	117244	117245
24420	37972	7	applied	\N	\N	\N	\N	117251	117251	117252
24420	37978	8	applied	\N	\N	\N	\N	117264	117264	117265
24420	37982	9	applied	\N	\N	\N	\N	117274	117274	117275
24420	37983	10	applied	\N	\N	\N	\N	117278	117278	117279
24420	37985	12	applied	\N	\N	\N	\N	117284	117284	117285
24420	37988	13	applied	\N	\N	\N	\N	117290	117290	117291
24420	37990	14	applied	\N	\N	\N	\N	117296	117296	117297
24420	37992	15	applied	\N	\N	\N	\N	117303	117303	117304
24420	37993	16	applied	\N	\N	\N	\N	117305	117305	117306
24420	37994	17	applied	\N	\N	\N	\N	117307	117307	117308
24420	37999	18	applied	\N	\N	\N	\N	117318	117318	117319
24420	38001	19	applied	\N	\N	\N	\N	117326	117326	117327
24420	37974	20	applied	\N	\N	\N	\N	117255	117255	117256
24420	37975	21	applied	\N	\N	\N	\N	117257	117257	117258
24420	37976	22	applied	\N	\N	\N	\N	117259	117259	117260
24420	37977	23	applied	\N	\N	\N	\N	117261	117261	117262
24420	37958	24	applied	\N	\N	\N	\N	117205	117205	117206
24420	37960	25	applied	\N	\N	\N	\N	117213	117213	117214
24420	37964	26	applied	\N	\N	\N	\N	117225	117225	117328
24420	37966	27	applied	\N	\N	\N	\N	117231	117231	117329
24420	37968	28	applied	\N	\N	\N	\N	117237	117237	117330
24420	37971	29	applied	\N	\N	\N	\N	117246	117246	117331
24420	37973	30	applied	\N	\N	\N	\N	117253	117253	117332
24420	37979	31	applied	\N	\N	\N	\N	117266	117266	117333
24420	37981	32	applied	\N	\N	\N	\N	117270	117270	117269
24420	37984	33	applied	\N	\N	\N	\N	117280	117280	117271
24420	37987	34	applied	\N	\N	\N	\N	117288	117288	117281
24420	37989	35	applied	\N	\N	\N	\N	117292	117292	117334
24420	37991	36	applied	\N	\N	\N	\N	117298	117298	117335
24420	37996	37	applied	\N	\N	\N	\N	117311	117311	117336
24420	37997	38	applied	\N	\N	\N	\N	117313	117313	117337
24420	37998	39	applied	\N	\N	\N	\N	117315	117315	117338
24420	38000	40	applied	\N	\N	\N	\N	117320	117320	117339
24420	38002	41	applied	\N	\N	\N	\N	117340	117340	117341
24420	37961	42	applied	\N	\N	\N	\N	117215	117215	117342
24420	37969	43	applied	\N	\N	\N	\N	117239	117239	117321
24420	37980	44	applied	\N	\N	\N	\N	117268	117268	117343
24420	37986	45	applied	\N	\N	\N	\N	117286	117286	117344
24420	37995	46	applied	\N	\N	\N	\N	117309	117309	117345
24420	38003	47	applied	\N	\N	\N	\N	117346	117346	117347
24423	38001	0	applied	\N	\N	\N	\N	117326	117326	117327
24423	38004	1	applied	\N	\N	\N	\N	117359	117359	117360
24423	38005	2	applied	\N	\N	\N	\N	117361	117361	117362
24423	38003	3	applied	\N	\N	\N	\N	117346	117346	117343
24423	38002	4	applied	\N	\N	\N	\N	117340	117340	117347
24423	38006	5	applied	\N	\N	\N	\N	117363	117363	117364
24423	38007	6	applied	\N	\N	\N	\N	117365	117365	117366
24426	38015	0	applied	\N	\N	\N	\N	117386	117386	117387
24426	38016	1	applied	\N	\N	\N	\N	117388	117388	117389
24431	38017	0	applied	\N	\N	\N	\N	117395	117395	117396
24431	38018	1	applied	\N	\N	\N	\N	117397	117397	117398
24431	38019	2	applied	\N	\N	\N	\N	117399	117399	117400
24439	38031	0	applied	\N	\N	\N	\N	117440	117440	117441
24439	38032	1	applied	\N	\N	\N	\N	117442	117442	117443
24439	38033	2	applied	\N	\N	\N	\N	117444	117444	117445
24439	38034	3	applied	\N	\N	\N	\N	117446	117446	117447
24442	38031	0	applied	\N	\N	\N	\N	117440	117440	117441
24442	38032	1	applied	\N	\N	\N	\N	117442	117442	117443
24442	38035	2	applied	\N	\N	\N	\N	117449	117449	117450
24442	38037	3	applied	\N	\N	\N	\N	117455	117455	117456
24442	38033	4	applied	\N	\N	\N	\N	117444	117444	117445
24442	38036	5	applied	\N	\N	\N	\N	117451	117451	117460
24442	38034	6	applied	\N	\N	\N	\N	117446	117446	117452
24442	38038	7	applied	\N	\N	\N	\N	117457	117457	117458
24444	38039	0	applied	\N	\N	\N	\N	117463	117463	117464
24444	38040	1	applied	\N	\N	\N	\N	117465	117465	117466
24446	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24446	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24446	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24446	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24446	38031	4	applied	\N	\N	\N	\N	117440	117440	117441
24446	37974	5	applied	\N	\N	\N	\N	117255	117255	117256
24446	37975	6	applied	\N	\N	\N	\N	117257	117257	117258
24446	37976	7	applied	\N	\N	\N	\N	117259	117259	117260
24446	37977	8	applied	\N	\N	\N	\N	117261	117261	117262
24449	38044	0	applied	\N	\N	\N	\N	117479	117479	117480
24449	38045	1	applied	\N	\N	\N	\N	117481	117481	117482
24449	38046	2	applied	\N	\N	\N	\N	117483	117483	117484
24449	38047	3	applied	\N	\N	\N	\N	117485	117485	117486
24452	38048	0	applied	\N	\N	\N	\N	117492	117492	117493
24452	38049	1	applied	\N	\N	\N	\N	117494	117494	117495
24452	38050	2	applied	\N	\N	\N	\N	117496	117496	117497
24457	38057	0	applied	\N	\N	\N	\N	117518	117518	117519
24457	38058	1	applied	\N	\N	\N	\N	117520	117520	117521
24457	38059	2	applied	\N	\N	\N	\N	117522	117522	117523
24457	38060	3	applied	\N	\N	\N	\N	117524	117524	117525
24465	38073	0	applied	\N	\N	\N	\N	117559	117559	117560
24465	38074	1	applied	\N	\N	\N	\N	117561	117561	117562
24465	38075	2	applied	\N	\N	\N	\N	117563	117563	117564
24465	38076	3	applied	\N	\N	\N	\N	117565	117565	117566
24465	38077	4	applied	\N	\N	\N	\N	117567	117567	117568
24465	38078	5	applied	\N	\N	\N	\N	117569	117569	117570
24465	38079	6	applied	\N	\N	\N	\N	117571	117571	117572
24465	38080	7	applied	\N	\N	\N	\N	117573	117573	117574
24468	38081	0	applied	\N	\N	\N	\N	117577	117577	117578
24468	38082	1	applied	\N	\N	\N	\N	117579	117579	117580
24468	38083	2	applied	\N	\N	\N	\N	117581	117581	117582
24421	37917	69	applied	\N	\N	\N	\N	117065	117065	117066
24421	37920	70	applied	\N	\N	\N	\N	117073	117073	117074
24421	37921	71	applied	\N	\N	\N	\N	117075	117075	117076
24421	37922	72	applied	\N	\N	\N	\N	117077	117077	117078
24421	37927	73	applied	\N	\N	\N	\N	117092	117092	117093
24421	37929	74	applied	\N	\N	\N	\N	117097	117097	117098
24421	37933	75	applied	\N	\N	\N	\N	117107	117107	117108
24421	37935	76	applied	\N	\N	\N	\N	117123	117123	117124
24421	37936	77	applied	\N	\N	\N	\N	117129	117129	117130
24421	37939	78	applied	\N	\N	\N	\N	117137	117137	117138
24421	37940	80	applied	\N	\N	\N	\N	117139	117139	117140
24421	37943	81	applied	\N	\N	\N	\N	117147	117147	117148
24421	37944	82	applied	\N	\N	\N	\N	117149	117149	117150
24421	37945	83	applied	\N	\N	\N	\N	117151	117151	117152
24421	37950	84	applied	\N	\N	\N	\N	117164	117164	117165
24421	37952	85	applied	\N	\N	\N	\N	117172	117172	117173
24421	37955	86	applied	\N	\N	\N	\N	117185	117185	117186
24421	37957	87	applied	\N	\N	\N	\N	117203	117203	117204
24421	37959	88	applied	\N	\N	\N	\N	117211	117211	117212
24421	37962	89	applied	\N	\N	\N	\N	117221	117221	117222
24421	37963	90	applied	\N	\N	\N	\N	117223	117223	117224
24421	37965	91	applied	\N	\N	\N	\N	117229	117229	117230
24421	37967	92	applied	\N	\N	\N	\N	117235	117235	117236
24421	37970	93	applied	\N	\N	\N	\N	117244	117244	117245
24421	37972	94	applied	\N	\N	\N	\N	117251	117251	117252
24421	37978	95	applied	\N	\N	\N	\N	117264	117264	117265
24421	37982	96	applied	\N	\N	\N	\N	117274	117274	117275
24421	37983	97	applied	\N	\N	\N	\N	117278	117278	117279
24421	37985	98	applied	\N	\N	\N	\N	117284	117284	117285
24421	37988	99	applied	\N	\N	\N	\N	117290	117290	117291
24421	37990	100	applied	\N	\N	\N	\N	117296	117296	117297
24421	37992	101	applied	\N	\N	\N	\N	117303	117303	117304
24421	37993	102	applied	\N	\N	\N	\N	117305	117305	117306
24421	37994	103	applied	\N	\N	\N	\N	117307	117307	117308
24421	37999	104	applied	\N	\N	\N	\N	117318	117318	117319
24421	38001	105	applied	\N	\N	\N	\N	117326	117326	117327
24421	37829	106	failed	Amount_insufficient_to_create_account	\N	\N	\N	116827	116827	\N
24421	37974	107	applied	\N	\N	\N	\N	117255	117255	117256
24421	37975	108	applied	\N	\N	\N	\N	117257	117257	117258
24421	37976	109	applied	\N	\N	\N	\N	117259	117259	117260
24421	37977	110	applied	\N	\N	\N	\N	117261	117261	117262
24421	37714	111	applied	\N	\N	\N	\N	116522	116522	116523
24421	37720	112	applied	\N	\N	\N	\N	116538	116538	117351
24421	37723	113	applied	\N	\N	\N	\N	116547	116547	116527
24421	37715	114	applied	\N	\N	\N	\N	116524	116524	117352
24421	37727	115	applied	\N	\N	\N	\N	116558	116558	116537
24421	37730	116	applied	\N	\N	\N	\N	116575	116575	116539
24421	37734	117	applied	\N	\N	\N	\N	116586	116586	116548
24421	37728	118	applied	\N	\N	\N	\N	116560	116560	117353
24421	37737	119	applied	\N	\N	\N	\N	116593	116593	117354
24421	37745	120	applied	\N	\N	\N	\N	116618	116618	116550
24421	37761	121	applied	\N	\N	\N	\N	116657	116657	116568
24421	37770	122	applied	\N	\N	\N	\N	116682	116682	117355
24421	37738	123	applied	\N	\N	\N	\N	116595	116595	117356
24421	37740	124	applied	\N	\N	\N	\N	116604	116604	116561
24421	37748	125	applied	\N	\N	\N	\N	116624	116624	116576
24424	38008	0	applied	\N	\N	\N	\N	117371	117371	117372
24424	38009	1	applied	\N	\N	\N	\N	117373	117373	117374
24424	38010	2	applied	\N	\N	\N	\N	117375	117375	117376
24424	38011	3	applied	\N	\N	\N	\N	117377	117377	117378
24424	38012	4	applied	\N	\N	\N	\N	117379	117379	117380
24424	38013	5	applied	\N	\N	\N	\N	117381	117381	117382
24424	38014	6	applied	\N	\N	\N	\N	117383	117383	117384
24429	38017	0	applied	\N	\N	\N	\N	117395	117395	117396
24429	38018	1	applied	\N	\N	\N	\N	117397	117397	117398
24429	38019	2	applied	\N	\N	\N	\N	117399	117399	117400
24433	38020	0	applied	\N	\N	\N	\N	117409	117409	117410
24433	38021	1	applied	\N	\N	\N	\N	117411	117411	117412
24438	38029	0	applied	\N	\N	\N	\N	117434	117434	117435
24438	38030	1	applied	\N	\N	\N	\N	117436	117436	117437
24447	38041	0	applied	\N	\N	\N	\N	117472	117472	117473
24447	38042	1	applied	\N	\N	\N	\N	117474	117474	117475
24447	38043	2	applied	\N	\N	\N	\N	117476	117476	117477
24451	38044	0	applied	\N	\N	\N	\N	117479	117479	117480
24451	38045	1	applied	\N	\N	\N	\N	117481	117481	117482
24451	38046	2	applied	\N	\N	\N	\N	117483	117483	117484
24451	38047	3	applied	\N	\N	\N	\N	117485	117485	117486
24453	38048	0	applied	\N	\N	\N	\N	117492	117492	117493
24453	38049	1	applied	\N	\N	\N	\N	117494	117494	117495
24453	38050	2	applied	\N	\N	\N	\N	117496	117496	117497
24456	38054	0	applied	\N	\N	\N	\N	117509	117509	117510
24456	38055	1	applied	\N	\N	\N	\N	117511	117511	117512
24456	38056	2	applied	\N	\N	\N	\N	117513	117513	117514
24459	38057	0	applied	\N	\N	\N	\N	117518	117518	117519
24459	38058	1	applied	\N	\N	\N	\N	117520	117520	117521
24459	38059	2	applied	\N	\N	\N	\N	117522	117522	117523
24459	38060	3	applied	\N	\N	\N	\N	117524	117524	117525
24461	38061	0	applied	\N	\N	\N	\N	117530	117530	117531
24461	38062	1	applied	\N	\N	\N	\N	117532	117532	117533
24466	38081	0	applied	\N	\N	\N	\N	117577	117577	117578
24466	38082	1	applied	\N	\N	\N	\N	117579	117579	117580
24466	38083	2	applied	\N	\N	\N	\N	117581	117581	117582
24469	38081	0	applied	\N	\N	\N	\N	117577	117577	117578
24469	38082	1	applied	\N	\N	\N	\N	117579	117579	117580
24471	38084	0	applied	\N	\N	\N	\N	117586	117586	117587
24471	38085	1	applied	\N	\N	\N	\N	117588	117588	117589
24477	38090	0	applied	\N	\N	\N	\N	117608	117608	117609
24477	38091	1	applied	\N	\N	\N	\N	117610	117610	117611
24477	38092	2	applied	\N	\N	\N	\N	117612	117612	117613
24485	38102	0	applied	\N	\N	\N	\N	117638	117638	117639
24485	38103	2	applied	\N	\N	\N	\N	117641	117641	117642
24488	38113	0	applied	\N	\N	\N	\N	117666	117666	117667
24488	38114	1	applied	\N	\N	\N	\N	117668	117668	117669
24488	38115	2	applied	\N	\N	\N	\N	117670	117670	117671
24491	38120	0	applied	\N	\N	\N	\N	117686	117686	117687
24491	38121	1	applied	\N	\N	\N	\N	117688	117688	117689
24493	38123	0	applied	\N	\N	\N	\N	117694	117694	117695
24493	38122	1	applied	\N	\N	\N	\N	117690	117690	117691
24493	38124	2	applied	\N	\N	\N	\N	117696	117696	117697
24496	38125	0	applied	\N	\N	\N	\N	117702	117702	117703
24496	38126	1	applied	\N	\N	\N	\N	117706	117706	117707
24503	38139	0	applied	\N	\N	\N	\N	117745	117745	117746
24503	38140	1	applied	\N	\N	\N	\N	117747	117747	117748
24508	38148	0	applied	\N	\N	\N	\N	117769	117769	117770
24508	38149	1	applied	\N	\N	\N	\N	117771	117771	117772
24511	38148	0	applied	\N	\N	\N	\N	117769	117769	117770
24511	38149	1	applied	\N	\N	\N	\N	117771	117771	117772
24513	38150	0	applied	\N	\N	\N	\N	117779	117779	117780
24513	38151	1	applied	\N	\N	\N	\N	117781	117781	117782
24437	38027	5	applied	\N	\N	\N	\N	117426	117426	117427
24437	38028	6	applied	\N	\N	\N	\N	117428	117428	117429
24440	38035	0	applied	\N	\N	\N	\N	117449	117449	117450
24440	38036	1	applied	\N	\N	\N	\N	117451	117451	117452
24445	38039	0	applied	\N	\N	\N	\N	117463	117463	117464
24445	38040	1	applied	\N	\N	\N	\N	117465	117465	117466
24450	38044	0	applied	\N	\N	\N	\N	117479	117479	117480
24450	38045	1	applied	\N	\N	\N	\N	117481	117481	117482
24450	38046	2	applied	\N	\N	\N	\N	117483	117483	117484
24450	38047	3	applied	\N	\N	\N	\N	117485	117485	117486
24455	38054	0	applied	\N	\N	\N	\N	117509	117509	117510
24455	38055	1	applied	\N	\N	\N	\N	117511	117511	117512
24455	38056	2	applied	\N	\N	\N	\N	117513	117513	117514
24458	38057	0	applied	\N	\N	\N	\N	117518	117518	117519
24458	38058	1	applied	\N	\N	\N	\N	117520	117520	117521
24458	38059	2	applied	\N	\N	\N	\N	117522	117522	117523
24458	38060	3	applied	\N	\N	\N	\N	117524	117524	117525
24460	38061	0	applied	\N	\N	\N	\N	117530	117530	117531
24460	38062	1	applied	\N	\N	\N	\N	117532	117532	117533
24470	38084	0	applied	\N	\N	\N	\N	117586	117586	117587
24470	38085	1	applied	\N	\N	\N	\N	117588	117588	117589
24473	38086	0	applied	\N	\N	\N	\N	117594	117594	117595
24473	38087	1	applied	\N	\N	\N	\N	117596	117596	117597
24479	38093	0	applied	\N	\N	\N	\N	117615	117615	117616
24479	38094	1	applied	\N	\N	\N	\N	117617	117617	117618
24484	38100	0	applied	\N	\N	\N	\N	117632	117632	117633
24484	38101	1	applied	\N	\N	\N	\N	117634	117634	117635
24495	38125	0	applied	\N	\N	\N	\N	117702	117702	117703
24498	38127	0	applied	\N	\N	\N	\N	117709	117709	117710
24498	38128	1	applied	\N	\N	\N	\N	117711	117711	117712
24498	38126	2	applied	\N	\N	\N	\N	117706	117706	117707
24498	38129	3	applied	\N	\N	\N	\N	117713	117713	117714
24498	38130	4	applied	\N	\N	\N	\N	117715	117715	117716
24498	38131	5	applied	\N	\N	\N	\N	117717	117717	117718
24500	38134	0	applied	\N	\N	\N	\N	117726	117726	117727
24500	38135	1	applied	\N	\N	\N	\N	117728	117728	117729
24507	38143	0	applied	\N	\N	\N	\N	117757	117757	117758
24507	38144	1	applied	\N	\N	\N	\N	117759	117759	117760
24507	38145	2	applied	\N	\N	\N	\N	117761	117761	117762
24507	38146	3	applied	\N	\N	\N	\N	117763	117763	117764
24507	38147	4	applied	\N	\N	\N	\N	117765	117765	117766
24512	38150	0	applied	\N	\N	\N	\N	117779	117779	117780
24512	38151	1	applied	\N	\N	\N	\N	117781	117781	117782
24512	38152	2	applied	\N	\N	\N	\N	117783	117783	117784
24512	38153	3	applied	\N	\N	\N	\N	117785	117785	117786
24512	38154	4	applied	\N	\N	\N	\N	117787	117787	117788
24515	38155	0	applied	\N	\N	\N	\N	117795	117795	117796
24515	38156	1	applied	\N	\N	\N	\N	117797	117797	117798
24515	38157	2	applied	\N	\N	\N	\N	117799	117799	117800
24515	38158	3	applied	\N	\N	\N	\N	117801	117801	117802
24515	38159	4	applied	\N	\N	\N	\N	117803	117803	117804
24515	38160	5	applied	\N	\N	\N	\N	117805	117805	117806
24515	38161	6	applied	\N	\N	\N	\N	117807	117807	117808
24521	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24521	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24524	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24524	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24534	38178	0	applied	\N	\N	\N	\N	117925	117925	117926
24534	38179	1	applied	\N	\N	\N	\N	117927	117927	117928
24534	38180	2	applied	\N	\N	\N	\N	117929	117929	117930
24534	38181	3	applied	\N	\N	\N	\N	117931	117931	117932
24539	38182	0	applied	\N	\N	\N	\N	117944	117944	117945
24539	38183	1	applied	\N	\N	\N	\N	117946	117946	117947
24539	38184	2	applied	\N	\N	\N	\N	117948	117948	117949
24539	38185	3	applied	\N	\N	\N	\N	117950	117950	117951
24539	38186	4	applied	\N	\N	\N	\N	117952	117952	117953
24539	38187	5	applied	\N	\N	\N	\N	117954	117954	117955
24542	38191	0	applied	\N	\N	\N	\N	117968	117968	117969
24542	38192	1	applied	\N	\N	\N	\N	117970	117970	117971
24542	38193	2	applied	\N	\N	\N	\N	117972	117972	117973
24542	38194	3	applied	\N	\N	\N	\N	117974	117974	117975
24548	38200	0	applied	\N	\N	\N	\N	117992	117992	117993
24548	38201	1	applied	\N	\N	\N	\N	117994	117994	117995
24555	38204	0	applied	\N	\N	\N	\N	118008	118008	118009
24555	38205	1	applied	\N	\N	\N	\N	118010	118010	118011
24555	38206	2	applied	\N	\N	\N	\N	118012	118012	118013
24555	38207	3	applied	\N	\N	\N	\N	118014	118014	118015
24555	38208	4	applied	\N	\N	\N	\N	118016	118016	118017
24557	37865	0	applied	\N	\N	\N	\N	116924	116924	116925
24557	37867	1	applied	\N	\N	\N	\N	116929	116929	116930
24557	37870	2	applied	\N	\N	\N	\N	116938	116938	116939
24557	37873	3	applied	\N	\N	\N	\N	116946	116946	116947
24557	37876	4	applied	\N	\N	\N	\N	116954	116954	116955
24557	37877	5	applied	\N	\N	\N	\N	116956	116956	116957
24557	37883	6	applied	\N	\N	\N	\N	116969	116969	116970
24557	37886	7	applied	\N	\N	\N	\N	116977	116977	116978
24557	37887	8	applied	\N	\N	\N	\N	116979	116979	116980
24557	37892	9	applied	\N	\N	\N	\N	116993	116993	116994
24557	37894	10	applied	\N	\N	\N	\N	117000	117000	117001
24557	37896	11	applied	\N	\N	\N	\N	117006	117006	117007
24557	37899	12	applied	\N	\N	\N	\N	117015	117015	117016
24557	37901	13	applied	\N	\N	\N	\N	117023	117023	117024
24557	37903	14	applied	\N	\N	\N	\N	117030	117030	117031
24557	37907	15	applied	\N	\N	\N	\N	117042	117042	117043
24557	37908	16	applied	\N	\N	\N	\N	117044	117044	117045
24557	37912	17	applied	\N	\N	\N	\N	117053	117053	117054
24557	37913	18	applied	\N	\N	\N	\N	117055	117055	117056
24557	37917	19	applied	\N	\N	\N	\N	117065	117065	117066
24557	37920	20	applied	\N	\N	\N	\N	117073	117073	117074
24557	37921	21	applied	\N	\N	\N	\N	117075	117075	117076
24557	37922	22	applied	\N	\N	\N	\N	117077	117077	117078
24557	37927	23	applied	\N	\N	\N	\N	117092	117092	117093
24557	37929	24	applied	\N	\N	\N	\N	117097	117097	117098
24557	37933	25	applied	\N	\N	\N	\N	117107	117107	117108
24557	37935	26	applied	\N	\N	\N	\N	117123	117123	117124
24557	37936	27	applied	\N	\N	\N	\N	117129	117129	117130
24557	37939	28	applied	\N	\N	\N	\N	117137	117137	117138
24557	37940	29	applied	\N	\N	\N	\N	117139	117139	117140
24557	37943	30	applied	\N	\N	\N	\N	117147	117147	117148
24557	37944	31	applied	\N	\N	\N	\N	117149	117149	117150
24557	37945	32	applied	\N	\N	\N	\N	117151	117151	117152
24557	37950	33	applied	\N	\N	\N	\N	117164	117164	117165
24557	37952	34	applied	\N	\N	\N	\N	117172	117172	117173
24557	37955	35	applied	\N	\N	\N	\N	117185	117185	117186
24557	37957	36	applied	\N	\N	\N	\N	117203	117203	117204
24557	37959	37	applied	\N	\N	\N	\N	117211	117211	117212
24557	37962	38	applied	\N	\N	\N	\N	117221	117221	117222
24557	37963	39	applied	\N	\N	\N	\N	117223	117223	117224
24557	37965	40	applied	\N	\N	\N	\N	117229	117229	117230
24557	37967	41	applied	\N	\N	\N	\N	117235	117235	117236
24443	38038	3	applied	\N	\N	\N	\N	117457	117457	117458
24448	38044	0	applied	\N	\N	\N	\N	117479	117479	117480
24448	38045	1	applied	\N	\N	\N	\N	117481	117481	117482
24448	38046	2	applied	\N	\N	\N	\N	117483	117483	117484
24448	38047	3	applied	\N	\N	\N	\N	117485	117485	117486
24454	38051	0	applied	\N	\N	\N	\N	117502	117502	117503
24454	38052	1	applied	\N	\N	\N	\N	117504	117504	117505
24454	38053	2	applied	\N	\N	\N	\N	117506	117506	117507
24463	38063	0	applied	\N	\N	\N	\N	117536	117536	117537
24463	38064	1	applied	\N	\N	\N	\N	117538	117538	117539
24463	38065	2	applied	\N	\N	\N	\N	117540	117540	117541
24464	38066	0	applied	\N	\N	\N	\N	117543	117543	117544
24464	38067	1	applied	\N	\N	\N	\N	117545	117545	117546
24464	38068	2	applied	\N	\N	\N	\N	117547	117547	117548
24464	38069	3	applied	\N	\N	\N	\N	117549	117549	117550
24464	38070	4	applied	\N	\N	\N	\N	117551	117551	117552
24464	38071	5	applied	\N	\N	\N	\N	117553	117553	117554
24464	38072	6	applied	\N	\N	\N	\N	117555	117555	117556
24467	38081	0	applied	\N	\N	\N	\N	117577	117577	117578
24467	38082	1	applied	\N	\N	\N	\N	117579	117579	117580
24467	38083	2	applied	\N	\N	\N	\N	117581	117581	117582
24475	38086	0	applied	\N	\N	\N	\N	117594	117594	117595
24475	38087	1	applied	\N	\N	\N	\N	117596	117596	117597
24475	38088	2	applied	\N	\N	\N	\N	117598	117598	117599
24475	38089	3	applied	\N	\N	\N	\N	117600	117600	117601
24478	38093	0	applied	\N	\N	\N	\N	117615	117615	117616
24478	38094	1	applied	\N	\N	\N	\N	117617	117617	117618
24486	38104	0	applied	\N	\N	\N	\N	117646	117646	117647
24486	38105	1	applied	\N	\N	\N	\N	117648	117648	117649
24486	38106	2	applied	\N	\N	\N	\N	117650	117650	117651
24486	38107	3	applied	\N	\N	\N	\N	117652	117652	117653
24486	38108	4	applied	\N	\N	\N	\N	117654	117654	117655
24489	38116	0	applied	\N	\N	\N	\N	117674	117674	117675
24489	38117	1	applied	\N	\N	\N	\N	117676	117676	117677
24489	38118	2	applied	\N	\N	\N	\N	117678	117678	117679
24489	38119	3	applied	\N	\N	\N	\N	117680	117680	117681
24492	38120	0	applied	\N	\N	\N	\N	117686	117686	117687
24492	38121	1	applied	\N	\N	\N	\N	117688	117688	117689
24492	38122	2	applied	\N	\N	\N	\N	117690	117690	117691
24501	38136	0	applied	\N	\N	\N	\N	117730	117730	117731
24501	38137	1	applied	\N	\N	\N	\N	117732	117732	117733
24501	38138	2	applied	\N	\N	\N	\N	117734	117734	117735
24506	38141	0	applied	\N	\N	\N	\N	117751	117751	117752
24506	38142	1	applied	\N	\N	\N	\N	117753	117753	117754
24509	38148	0	applied	\N	\N	\N	\N	117769	117769	117770
24509	38149	1	applied	\N	\N	\N	\N	117771	117771	117772
24519	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24519	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24522	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24522	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24526	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24526	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24532	38171	0	applied	\N	\N	\N	\N	117909	117909	117910
24532	38172	1	applied	\N	\N	\N	\N	117911	117911	117912
24538	38182	0	applied	\N	\N	\N	\N	117944	117944	117945
24538	38183	1	applied	\N	\N	\N	\N	117946	117946	117947
24538	38184	2	applied	\N	\N	\N	\N	117948	117948	117949
24538	38185	3	applied	\N	\N	\N	\N	117950	117950	117951
24538	38186	4	applied	\N	\N	\N	\N	117952	117952	117953
24538	38187	5	applied	\N	\N	\N	\N	117954	117954	117955
24540	38182	0	applied	\N	\N	\N	\N	117944	117944	117945
24540	38183	1	applied	\N	\N	\N	\N	117946	117946	117947
24540	38184	2	applied	\N	\N	\N	\N	117948	117948	117949
24540	38188	3	applied	\N	\N	\N	\N	117959	117959	117960
24540	38185	4	applied	\N	\N	\N	\N	117950	117950	117951
24540	38189	5	applied	\N	\N	\N	\N	117961	117961	117962
24540	38186	6	applied	\N	\N	\N	\N	117952	117952	117963
24540	38187	7	applied	\N	\N	\N	\N	117954	117954	117964
24540	38190	8	applied	\N	\N	\N	\N	117965	117965	117966
24547	38195	0	applied	\N	\N	\N	\N	117981	117981	117982
24547	38196	1	applied	\N	\N	\N	\N	117983	117983	117984
24547	38197	2	applied	\N	\N	\N	\N	117985	117985	117986
24547	38198	3	applied	\N	\N	\N	\N	117987	117987	117988
24547	38199	4	applied	\N	\N	\N	\N	117989	117989	117990
24550	38200	0	applied	\N	\N	\N	\N	117992	117992	117993
24550	38201	1	applied	\N	\N	\N	\N	117994	117994	117995
24554	38202	0	applied	\N	\N	\N	\N	118000	118000	118001
24554	38203	1	applied	\N	\N	\N	\N	118002	118002	118003
24558	38209	0	applied	\N	\N	\N	\N	118024	118024	118025
24558	38210	1	applied	\N	\N	\N	\N	118026	118026	118027
24561	38214	0	applied	\N	\N	\N	\N	118037	118037	118038
24561	38215	1	applied	\N	\N	\N	\N	118040	118040	118041
24563	38218	0	applied	\N	\N	\N	\N	118049	118049	118050
24563	38219	1	applied	\N	\N	\N	\N	118051	118051	118052
24563	38220	2	applied	\N	\N	\N	\N	118053	118053	118054
24566	38223	0	applied	\N	\N	\N	\N	118062	118062	118063
24566	38224	1	applied	\N	\N	\N	\N	118064	118064	118065
24566	38225	2	applied	\N	\N	\N	\N	118066	118066	118067
24566	38226	3	applied	\N	\N	\N	\N	118068	118068	118069
24570	38223	0	applied	\N	\N	\N	\N	118062	118062	118063
24570	38224	1	applied	\N	\N	\N	\N	118064	118064	118065
24570	38225	2	applied	\N	\N	\N	\N	118066	118066	118067
24570	38226	3	applied	\N	\N	\N	\N	118068	118068	118069
24578	38244	0	applied	\N	\N	\N	\N	118121	118121	118122
24578	38245	1	applied	\N	\N	\N	\N	118123	118123	118124
24582	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24582	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24582	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24582	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24582	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24582	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24582	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24593	38276	0	applied	\N	\N	\N	\N	118211	118211	118212
24593	38277	1	applied	\N	\N	\N	\N	118213	118213	118214
24593	38278	2	applied	\N	\N	\N	\N	118215	118215	118216
24593	38279	3	applied	\N	\N	\N	\N	118217	118217	118218
24593	38280	4	applied	\N	\N	\N	\N	118219	118219	118220
24593	38281	5	applied	\N	\N	\N	\N	118221	118221	118222
24593	38282	6	applied	\N	\N	\N	\N	118223	118223	118224
24595	38283	0	applied	\N	\N	\N	\N	118231	118231	118232
24595	38284	1	applied	\N	\N	\N	\N	118233	118233	118234
24597	38285	0	applied	\N	\N	\N	\N	118236	118236	118237
24597	38286	1	applied	\N	\N	\N	\N	118238	118238	118239
24602	38290	0	applied	\N	\N	\N	\N	118254	118254	118255
24602	38291	1	applied	\N	\N	\N	\N	118256	118256	118257
24602	38292	2	applied	\N	\N	\N	\N	118258	118258	118259
24604	38293	0	applied	\N	\N	\N	\N	118264	118264	118265
24604	38294	1	applied	\N	\N	\N	\N	118266	118266	118267
24607	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24607	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24472	38086	0	applied	\N	\N	\N	\N	117594	117594	117595
24472	38087	1	applied	\N	\N	\N	\N	117596	117596	117597
24472	38088	2	applied	\N	\N	\N	\N	117598	117598	117599
24472	38089	3	applied	\N	\N	\N	\N	117600	117600	117601
24476	38086	0	applied	\N	\N	\N	\N	117594	117594	117595
24476	38087	1	applied	\N	\N	\N	\N	117596	117596	117597
24476	38088	2	applied	\N	\N	\N	\N	117598	117598	117599
24476	38089	3	applied	\N	\N	\N	\N	117600	117600	117601
24481	38095	0	applied	\N	\N	\N	\N	117621	117621	117622
24481	38096	1	applied	\N	\N	\N	\N	117623	117623	117624
24481	38097	2	applied	\N	\N	\N	\N	117625	117625	117626
24481	38098	3	applied	\N	\N	\N	\N	117627	117627	117628
24481	38099	4	applied	\N	\N	\N	\N	117629	117629	117630
24487	38109	0	applied	\N	\N	\N	\N	117658	117658	117659
24487	38110	1	applied	\N	\N	\N	\N	117660	117660	117661
24487	38111	2	applied	\N	\N	\N	\N	117662	117662	117663
24487	38112	3	applied	\N	\N	\N	\N	117664	117664	117665
24490	38116	0	applied	\N	\N	\N	\N	117674	117674	117675
24490	38117	1	applied	\N	\N	\N	\N	117676	117676	117677
24490	38118	2	applied	\N	\N	\N	\N	117678	117678	117679
24490	38119	3	applied	\N	\N	\N	\N	117680	117680	117681
24494	38123	0	applied	\N	\N	\N	\N	117694	117694	117695
24494	38122	1	applied	\N	\N	\N	\N	117690	117690	117691
24494	38124	2	applied	\N	\N	\N	\N	117696	117696	117697
24497	38127	0	applied	\N	\N	\N	\N	117709	117709	117710
24497	38128	1	applied	\N	\N	\N	\N	117711	117711	117712
24497	38126	2	applied	\N	\N	\N	\N	117706	117706	117707
24497	38129	3	applied	\N	\N	\N	\N	117713	117713	117714
24497	38130	4	applied	\N	\N	\N	\N	117715	117715	117716
24497	38131	5	applied	\N	\N	\N	\N	117717	117717	117718
24499	38132	0	applied	\N	\N	\N	\N	117721	117721	117722
24499	38133	1	applied	\N	\N	\N	\N	117723	117723	117724
24502	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24502	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24502	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24502	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24502	38073	4	applied	\N	\N	\N	\N	117738	117738	117560
24502	38031	5	applied	\N	\N	\N	\N	117440	117440	117441
24502	37695	6	applied	\N	\N	1000000000	\N	116477	116477	116478
24502	37721	7	applied	\N	\N	\N	\N	116543	116543	116544
24502	37848	8	applied	\N	\N	\N	\N	116876	116876	93344
24502	38074	9	applied	\N	\N	\N	\N	117739	117739	117562
24502	38075	10	applied	\N	\N	\N	\N	117740	117740	117564
24502	38076	11	applied	\N	\N	\N	\N	117741	117741	117566
24502	37512	12	applied	\N	\N	\N	\N	115968	115968	115969
24502	37514	13	applied	\N	\N	\N	\N	115973	115973	115974
24502	37515	14	applied	\N	\N	\N	\N	115975	115975	115976
24502	37520	15	applied	\N	\N	\N	\N	115987	115987	115988
24502	37522	16	applied	\N	\N	\N	\N	115993	115993	115994
24502	37523	17	applied	\N	\N	\N	\N	115995	115995	115996
24502	37668	18	applied	\N	\N	\N	\N	116411	116411	116412
24502	37669	19	applied	\N	\N	\N	\N	116413	116413	116414
24502	37670	20	applied	\N	\N	\N	\N	116415	116415	116416
24502	37671	21	applied	\N	\N	\N	\N	116417	116417	116418
24502	37672	22	applied	\N	\N	\N	\N	116419	116419	116420
24502	37527	23	applied	\N	\N	\N	\N	116007	116007	116008
24502	37528	24	applied	\N	\N	\N	\N	116009	116009	116010
24502	37529	25	applied	\N	\N	\N	\N	116011	116011	116012
24502	37535	26	applied	\N	\N	\N	\N	116024	116024	116025
24502	37537	27	applied	\N	\N	\N	\N	116033	116033	116034
24502	37539	28	applied	\N	\N	\N	\N	116037	116037	116038
24502	37540	29	applied	\N	\N	\N	\N	116039	116039	116040
24502	37541	30	applied	\N	\N	\N	\N	116041	116041	116042
24502	37546	31	applied	\N	\N	\N	\N	116052	116052	116053
24502	37548	32	applied	\N	\N	\N	\N	116059	116059	116060
24502	37551	33	applied	\N	\N	\N	\N	116068	116068	116069
24502	37553	34	applied	\N	\N	\N	\N	116072	116072	116073
24502	37555	35	applied	\N	\N	\N	\N	116076	116076	116077
24502	37558	36	applied	\N	\N	\N	\N	116098	116098	116099
24502	37560	37	applied	\N	\N	\N	\N	116107	116107	116108
24502	37563	38	applied	\N	\N	\N	\N	116115	116115	116116
24502	37567	39	applied	\N	\N	\N	\N	116124	116124	116125
24502	37568	40	applied	\N	\N	\N	\N	116126	116126	116127
24502	37573	41	applied	\N	\N	\N	\N	116138	116138	116139
24502	37576	42	applied	\N	\N	\N	\N	116146	116146	116147
24502	37580	43	applied	\N	\N	\N	\N	116160	116160	116161
24502	37583	44	applied	\N	\N	\N	\N	116169	116169	116170
24502	37584	45	applied	\N	\N	\N	\N	116171	116171	116172
24502	37589	46	applied	\N	\N	\N	\N	116189	116189	116190
24502	37592	47	applied	\N	\N	\N	\N	116197	116197	116198
24502	37593	48	applied	\N	\N	\N	\N	116199	116199	116200
24502	37599	49	applied	\N	\N	\N	\N	116216	116216	116217
24502	37602	50	applied	\N	\N	\N	\N	116225	116225	116226
24502	37605	51	applied	\N	\N	\N	\N	116234	116234	116235
24502	37608	52	applied	\N	\N	\N	\N	116242	116242	116243
24502	37612	53	applied	\N	\N	\N	\N	116254	116254	116255
24502	37615	54	applied	\N	\N	\N	\N	116263	116263	116264
24502	37618	55	applied	\N	\N	\N	\N	116273	116273	116274
24502	37622	56	applied	\N	\N	\N	\N	116290	116290	116291
24502	37625	57	applied	\N	\N	\N	\N	116299	116299	116300
24502	37628	58	applied	\N	\N	\N	\N	116308	116308	116309
24502	37632	59	applied	\N	\N	\N	\N	116317	116317	116318
24502	37634	60	applied	\N	\N	\N	\N	116323	116323	116324
24502	37637	61	applied	\N	\N	\N	\N	116334	116334	116335
24502	37640	62	applied	\N	\N	\N	\N	116344	116344	116345
24502	37644	63	applied	\N	\N	\N	\N	116354	116354	116355
24502	37647	64	applied	\N	\N	\N	\N	116361	116361	116362
24502	37648	65	applied	\N	\N	\N	\N	116363	116363	116364
24502	37649	66	applied	\N	\N	\N	\N	116365	116365	116366
24502	37650	67	applied	\N	\N	\N	\N	116367	116367	116368
24502	37660	68	applied	\N	\N	\N	\N	116391	116391	116392
24502	37661	69	applied	\N	\N	\N	\N	116393	116393	116394
24502	37667	70	applied	\N	\N	\N	\N	116409	116409	116410
24502	37675	71	applied	\N	\N	\N	\N	116429	116429	116430
24502	37676	72	applied	\N	\N	\N	\N	116431	116431	116432
24502	37677	73	applied	\N	\N	\N	\N	116433	116433	116434
24502	37678	74	applied	\N	\N	\N	\N	116435	116435	116436
24502	37688	75	applied	\N	\N	\N	\N	116458	116458	116459
24502	37692	76	applied	\N	\N	\N	\N	116469	116469	116470
24502	37697	77	applied	\N	\N	\N	\N	116482	116482	116483
24502	37698	78	applied	\N	\N	\N	\N	116484	116484	116485
24502	37699	79	applied	\N	\N	\N	\N	116486	116486	116487
24502	37700	80	applied	\N	\N	\N	\N	116488	116488	116489
24502	37710	81	applied	\N	\N	\N	\N	116511	116511	116512
24502	37713	82	applied	\N	\N	\N	\N	116520	116520	116521
24502	37717	83	applied	\N	\N	\N	\N	116533	116533	116534
24502	37722	84	applied	\N	\N	\N	\N	116545	116545	116546
24502	37725	85	applied	\N	\N	\N	\N	116554	116554	116555
24502	37729	86	applied	\N	\N	\N	\N	116573	116573	116574
24502	37732	87	applied	\N	\N	\N	\N	116582	116582	116583
24502	37735	88	applied	\N	\N	\N	\N	116589	116589	116590
24502	37739	89	applied	\N	\N	\N	\N	116602	116602	116603
24502	37742	90	applied	\N	\N	\N	\N	116612	116612	116613
24502	37743	91	applied	\N	\N	\N	\N	116614	116614	116615
24502	37744	92	applied	\N	\N	\N	\N	116616	116616	116617
24502	37752	93	applied	\N	\N	\N	\N	116638	116638	116639
24502	37753	94	applied	\N	\N	\N	\N	116640	116640	116641
24502	37758	95	applied	\N	\N	\N	\N	116651	116651	116652
24502	37762	96	applied	\N	\N	\N	\N	116661	116661	116662
24502	37765	97	applied	\N	\N	\N	\N	116671	116671	116672
24502	37766	98	applied	\N	\N	\N	\N	116673	116673	116674
24502	37772	99	applied	\N	\N	\N	\N	116694	116694	116695
24502	37775	100	applied	\N	\N	\N	\N	116700	116700	116701
24502	37778	101	applied	\N	\N	\N	\N	116709	116709	116710
24502	37779	102	applied	\N	\N	\N	\N	116711	116711	116712
24502	37780	103	applied	\N	\N	\N	\N	116713	116713	116714
24502	37787	104	applied	\N	\N	\N	\N	116730	116730	116731
24502	37788	105	applied	\N	\N	\N	\N	116732	116732	116733
24502	37794	106	applied	\N	\N	\N	\N	116748	116748	116749
24502	37797	107	applied	\N	\N	\N	\N	116754	116754	116755
24502	37798	108	applied	\N	\N	\N	\N	116756	116756	116757
24502	37804	109	applied	\N	\N	\N	\N	116770	116770	116771
24502	37805	110	applied	\N	\N	\N	\N	116772	116772	116773
24502	37810	111	applied	\N	\N	\N	\N	116784	116784	116785
24502	37811	112	applied	\N	\N	\N	\N	116786	116786	116787
24502	37812	113	applied	\N	\N	\N	\N	116788	116788	116789
24502	37813	114	applied	\N	\N	\N	\N	116790	116790	116791
24502	37823	115	applied	\N	\N	\N	\N	116813	116813	116814
24502	37827	116	applied	\N	\N	\N	\N	116823	116823	116824
24502	37828	118	applied	\N	\N	\N	\N	116825	116825	116826
24502	37841	119	applied	\N	\N	\N	\N	116857	116857	116858
24502	37844	120	applied	\N	\N	\N	\N	116866	116866	116867
24502	37849	121	applied	\N	\N	\N	\N	116877	116877	116878
24502	37850	122	applied	\N	\N	\N	\N	116879	116879	116880
24502	37851	123	applied	\N	\N	\N	\N	116881	116881	116882
24502	37859	124	applied	\N	\N	\N	\N	116903	116903	116904
24502	37862	125	applied	\N	\N	\N	\N	116912	116912	116913
24504	38141	0	applied	\N	\N	\N	\N	117751	117751	117752
24504	38142	1	applied	\N	\N	\N	\N	117753	117753	117754
24510	38148	0	applied	\N	\N	\N	\N	117769	117769	117770
24510	38149	1	applied	\N	\N	\N	\N	117771	117771	117772
24514	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24514	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24514	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24514	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24514	38073	4	applied	\N	\N	\N	\N	117559	117559	117560
24514	38031	5	applied	\N	\N	\N	\N	117440	117440	117441
24514	37823	6	applied	\N	\N	\N	\N	116813	116813	116814
24514	37848	7	applied	\N	\N	\N	\N	116876	116876	93344
24514	38074	8	applied	\N	\N	\N	\N	117561	117561	117562
24514	38075	9	applied	\N	\N	\N	\N	117563	117563	117564
24514	38076	10	applied	\N	\N	\N	\N	117565	117565	117566
24514	37827	11	applied	\N	\N	\N	\N	116823	116823	116824
24514	37828	12	applied	\N	\N	\N	\N	116825	116825	116826
24514	37841	13	applied	\N	\N	\N	\N	116857	116857	116858
24514	37844	14	applied	\N	\N	\N	\N	116866	116866	116867
24514	37849	15	applied	\N	\N	\N	\N	116877	116877	116878
24514	37850	16	applied	\N	\N	\N	\N	116879	116879	116880
24514	37851	17	applied	\N	\N	\N	\N	116881	116881	116882
24514	37859	18	applied	\N	\N	\N	\N	116903	116903	116904
24514	37862	19	applied	\N	\N	\N	\N	116912	116912	116913
24514	37865	20	applied	\N	\N	\N	\N	116924	116924	116925
24514	37867	21	applied	\N	\N	\N	\N	116929	116929	116930
24514	37870	22	applied	\N	\N	\N	\N	116938	116938	116939
24514	37873	23	applied	\N	\N	\N	\N	116946	116946	116947
24514	37876	24	applied	\N	\N	\N	\N	116954	116954	116955
24514	37877	25	applied	\N	\N	\N	\N	116956	116956	116957
24514	37883	26	applied	\N	\N	\N	\N	116969	116969	116970
24514	37886	27	applied	\N	\N	\N	\N	116977	116977	116978
24514	37887	28	applied	\N	\N	\N	\N	116979	116979	116980
24514	37892	29	applied	\N	\N	\N	\N	116993	116993	116994
24514	37894	30	applied	\N	\N	\N	\N	117000	117000	117001
24514	37896	31	applied	\N	\N	\N	\N	117006	117006	117007
24514	37899	32	applied	\N	\N	\N	\N	117015	117015	117016
24514	37901	33	applied	\N	\N	\N	\N	117023	117023	117024
24514	37903	34	applied	\N	\N	\N	\N	117030	117030	117031
24514	37907	35	applied	\N	\N	\N	\N	117042	117042	117043
24514	37908	36	applied	\N	\N	\N	\N	117044	117044	117045
24514	37912	37	applied	\N	\N	\N	\N	117053	117053	117054
24514	37913	38	applied	\N	\N	\N	\N	117055	117055	117056
24514	37917	39	applied	\N	\N	\N	\N	117065	117065	117066
24514	37920	40	applied	\N	\N	\N	\N	117073	117073	117074
24514	37921	41	applied	\N	\N	\N	\N	117075	117075	117076
24514	37922	42	applied	\N	\N	\N	\N	117077	117077	117078
24514	37927	43	applied	\N	\N	\N	\N	117092	117092	117093
24514	37929	44	applied	\N	\N	\N	\N	117097	117097	117098
24514	37933	45	applied	\N	\N	\N	\N	117107	117107	117108
24514	37935	46	applied	\N	\N	\N	\N	117123	117123	117124
24514	37936	47	applied	\N	\N	\N	\N	117129	117129	117130
24514	37939	48	applied	\N	\N	\N	\N	117137	117137	117138
24514	37940	49	applied	\N	\N	\N	\N	117139	117139	117140
24514	37943	50	applied	\N	\N	\N	\N	117147	117147	117148
24514	37944	51	applied	\N	\N	\N	\N	117149	117149	117150
24514	37945	52	applied	\N	\N	\N	\N	117151	117151	117152
24514	37950	53	applied	\N	\N	\N	\N	117164	117164	117165
24514	37952	55	applied	\N	\N	\N	\N	117172	117172	117173
24514	37955	56	applied	\N	\N	\N	\N	117185	117185	117186
24514	37957	57	applied	\N	\N	\N	\N	117203	117203	117204
24514	37959	58	applied	\N	\N	\N	\N	117211	117211	117212
24514	37962	59	applied	\N	\N	\N	\N	117221	117221	117222
24514	37963	60	applied	\N	\N	\N	\N	117223	117223	117224
24514	37965	61	applied	\N	\N	\N	\N	117229	117229	117230
24514	37967	62	applied	\N	\N	\N	\N	117235	117235	117236
24514	37970	63	applied	\N	\N	\N	\N	117244	117244	117245
24514	37972	64	applied	\N	\N	\N	\N	117251	117251	117252
24514	37978	65	applied	\N	\N	\N	\N	117264	117264	117265
24514	37982	66	applied	\N	\N	\N	\N	117274	117274	117275
24514	37983	67	applied	\N	\N	\N	\N	117278	117278	117279
24514	37985	68	applied	\N	\N	\N	\N	117284	117284	117285
24514	37988	69	applied	\N	\N	\N	\N	117290	117290	117291
24514	37990	70	applied	\N	\N	\N	\N	117296	117296	117297
24514	37992	71	applied	\N	\N	\N	\N	117303	117303	117304
24514	37993	72	applied	\N	\N	\N	\N	117305	117305	117306
24514	37994	73	applied	\N	\N	\N	\N	117307	117307	117308
24514	37999	74	applied	\N	\N	\N	\N	117318	117318	117319
24514	38001	75	applied	\N	\N	\N	\N	117326	117326	117327
24514	38004	76	applied	\N	\N	\N	\N	117359	117359	117360
24514	38005	77	applied	\N	\N	\N	\N	117361	117361	117362
24514	38008	78	applied	\N	\N	\N	\N	117371	117371	117372
24514	38009	79	applied	\N	\N	\N	\N	117373	117373	117374
24513	38152	2	applied	\N	\N	\N	\N	117783	117783	117784
24513	38153	3	applied	\N	\N	\N	\N	117785	117785	117786
24513	38154	4	applied	\N	\N	\N	\N	117787	117787	117788
24518	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24518	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24525	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24525	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24525	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24525	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24525	38073	4	applied	\N	\N	\N	\N	117559	117559	117560
24525	38031	5	applied	\N	\N	\N	\N	117440	117440	117441
24525	37848	6	applied	\N	\N	\N	\N	116876	116876	93344
24525	38074	7	applied	\N	\N	\N	\N	117561	117561	117562
24525	38075	8	applied	\N	\N	\N	\N	117563	117563	117564
24525	38076	9	applied	\N	\N	\N	\N	117565	117565	117566
24525	37739	10	applied	\N	\N	\N	\N	116602	116602	116603
24525	37742	11	applied	\N	\N	\N	\N	116612	116612	116613
24525	37743	12	applied	\N	\N	\N	\N	116614	116614	116615
24525	37744	13	applied	\N	\N	\N	\N	116616	116616	116617
24525	37752	14	applied	\N	\N	\N	\N	116638	116638	116639
24525	37753	15	applied	\N	\N	\N	\N	116640	116640	116641
24525	37758	16	applied	\N	\N	\N	\N	116651	116651	116652
24525	37762	17	applied	\N	\N	\N	\N	116661	116661	116662
24525	37765	18	applied	\N	\N	\N	\N	116671	116671	116672
24525	37766	19	applied	\N	\N	\N	\N	116673	116673	116674
24525	37772	20	applied	\N	\N	\N	\N	116694	116694	116695
24525	37775	21	applied	\N	\N	\N	\N	116700	116700	116701
24525	37778	22	applied	\N	\N	\N	\N	116709	116709	116710
24525	37779	23	applied	\N	\N	\N	\N	116711	116711	116712
24525	37780	24	applied	\N	\N	\N	\N	116713	116713	116714
24525	37787	25	applied	\N	\N	\N	\N	116730	116730	116731
24525	37788	26	applied	\N	\N	\N	\N	116732	116732	116733
24525	37794	27	applied	\N	\N	\N	\N	116748	116748	116749
24525	37797	28	applied	\N	\N	\N	\N	116754	116754	116755
24525	37798	29	applied	\N	\N	\N	\N	116756	116756	116757
24525	37804	30	applied	\N	\N	\N	\N	116770	116770	116771
24525	37805	31	applied	\N	\N	\N	\N	116772	116772	116773
24525	37810	32	applied	\N	\N	\N	\N	116784	116784	116785
24525	37811	33	applied	\N	\N	\N	\N	116786	116786	116787
24525	37812	34	applied	\N	\N	\N	\N	116788	116788	116789
24525	37813	35	applied	\N	\N	\N	\N	116790	116790	116791
24525	37823	36	applied	\N	\N	\N	\N	116813	116813	116814
24525	37827	37	applied	\N	\N	\N	\N	116823	116823	116824
24525	37828	38	applied	\N	\N	\N	\N	116825	116825	116826
24525	37841	40	applied	\N	\N	\N	\N	116857	116857	116858
24525	37844	41	applied	\N	\N	\N	\N	116866	116866	116867
24525	37849	42	applied	\N	\N	\N	\N	116877	116877	116878
24525	37850	43	applied	\N	\N	\N	\N	116879	116879	116880
24525	37851	44	applied	\N	\N	\N	\N	116881	116881	116882
24525	37859	45	applied	\N	\N	\N	\N	116903	116903	116904
24525	37862	46	applied	\N	\N	\N	\N	116912	116912	116913
24525	37865	47	applied	\N	\N	\N	\N	116924	116924	116925
24525	37867	48	applied	\N	\N	\N	\N	116929	116929	116930
24525	37870	49	applied	\N	\N	\N	\N	116938	116938	116939
24525	37873	50	applied	\N	\N	\N	\N	116946	116946	116947
24525	37876	51	applied	\N	\N	\N	\N	116954	116954	116955
24525	37877	52	applied	\N	\N	\N	\N	116956	116956	116957
24525	37883	53	applied	\N	\N	\N	\N	116969	116969	116970
24525	37886	54	applied	\N	\N	\N	\N	116977	116977	116978
24525	37887	55	applied	\N	\N	\N	\N	116979	116979	116980
24525	37892	56	applied	\N	\N	\N	\N	116993	116993	116994
24525	37894	57	applied	\N	\N	\N	\N	117000	117000	117001
24525	37896	58	applied	\N	\N	\N	\N	117006	117006	117007
24525	37899	59	applied	\N	\N	\N	\N	117015	117015	117016
24525	37901	60	applied	\N	\N	\N	\N	117023	117023	117024
24525	37903	61	applied	\N	\N	\N	\N	117030	117030	117031
24525	37907	62	applied	\N	\N	\N	\N	117042	117042	117043
24525	37908	63	applied	\N	\N	\N	\N	117044	117044	117045
24525	37912	64	applied	\N	\N	\N	\N	117053	117053	117054
24525	37913	65	applied	\N	\N	\N	\N	117055	117055	117056
24525	37917	66	applied	\N	\N	\N	\N	117065	117065	117066
24525	37920	67	applied	\N	\N	\N	\N	117073	117073	117074
24525	37921	68	applied	\N	\N	\N	\N	117075	117075	117076
24525	37922	69	applied	\N	\N	\N	\N	117077	117077	117078
24525	37927	70	applied	\N	\N	\N	\N	117092	117092	117093
24525	37929	71	applied	\N	\N	\N	\N	117097	117097	117098
24525	37933	72	applied	\N	\N	\N	\N	117107	117107	117108
24525	37935	73	applied	\N	\N	\N	\N	117123	117123	117124
24525	37936	74	applied	\N	\N	\N	\N	117129	117129	117130
24525	37939	75	applied	\N	\N	\N	\N	117137	117137	117138
24525	37940	76	applied	\N	\N	\N	\N	117139	117139	117140
24525	37943	77	applied	\N	\N	\N	\N	117147	117147	117148
24525	37944	78	applied	\N	\N	\N	\N	117149	117149	117150
24525	37945	79	applied	\N	\N	\N	\N	117151	117151	117152
24525	37950	80	applied	\N	\N	\N	\N	117164	117164	117165
24525	37952	81	applied	\N	\N	\N	\N	117172	117172	117173
24525	37955	82	applied	\N	\N	\N	\N	117185	117185	117186
24525	37957	83	applied	\N	\N	\N	\N	117203	117203	117204
24525	37959	84	applied	\N	\N	\N	\N	117211	117211	117212
24525	37962	85	applied	\N	\N	\N	\N	117221	117221	117222
24525	37963	86	applied	\N	\N	\N	\N	117223	117223	117224
24525	37965	87	applied	\N	\N	\N	\N	117229	117229	117230
24525	37967	88	applied	\N	\N	\N	\N	117235	117235	117236
24525	37970	89	applied	\N	\N	\N	\N	117244	117244	117245
24525	37972	90	applied	\N	\N	\N	\N	117251	117251	117252
24525	37978	91	applied	\N	\N	\N	\N	117264	117264	117265
24525	37982	92	applied	\N	\N	\N	\N	117274	117274	117275
24525	37983	93	applied	\N	\N	\N	\N	117278	117278	117279
24525	37985	94	applied	\N	\N	\N	\N	117284	117284	117285
24525	37988	95	applied	\N	\N	\N	\N	117290	117290	117291
24525	37990	96	applied	\N	\N	\N	\N	117296	117296	117297
24525	37992	97	applied	\N	\N	\N	\N	117303	117303	117304
24525	37993	98	applied	\N	\N	\N	\N	117305	117305	117306
24525	37994	99	applied	\N	\N	\N	\N	117307	117307	117308
24525	37999	100	applied	\N	\N	\N	\N	117318	117318	117319
24525	38001	101	applied	\N	\N	\N	\N	117326	117326	117327
24525	38004	102	applied	\N	\N	\N	\N	117359	117359	117360
24525	38005	103	applied	\N	\N	\N	\N	117361	117361	117362
24525	38008	104	applied	\N	\N	\N	\N	117371	117371	117372
24525	38009	105	applied	\N	\N	\N	\N	117373	117373	117374
24525	38010	106	applied	\N	\N	\N	\N	117375	117375	117376
24525	38015	107	applied	\N	\N	\N	\N	117386	117386	117387
24525	38017	108	applied	\N	\N	\N	\N	117395	117395	117396
24525	38020	109	applied	\N	\N	\N	\N	117409	117409	117410
24525	38022	110	applied	\N	\N	\N	\N	117416	117416	117417
24525	38023	111	applied	\N	\N	\N	\N	117418	117418	117419
24525	38024	112	applied	\N	\N	\N	\N	117420	117420	117421
24525	38029	113	applied	\N	\N	\N	\N	117434	117434	117435
24525	38032	114	applied	\N	\N	\N	\N	117442	117442	117443
24525	38035	115	applied	\N	\N	\N	\N	117449	117449	117450
24514	38010	80	applied	\N	\N	\N	\N	117375	117375	117376
24514	38015	81	applied	\N	\N	\N	\N	117386	117386	117387
24514	38017	82	applied	\N	\N	\N	\N	117395	117395	117396
24514	38020	83	applied	\N	\N	\N	\N	117409	117409	117410
24514	38022	84	applied	\N	\N	\N	\N	117416	117416	117417
24514	38023	85	applied	\N	\N	\N	\N	117418	117418	117419
24514	38024	86	applied	\N	\N	\N	\N	117420	117420	117421
24514	38029	87	applied	\N	\N	\N	\N	117434	117434	117435
24514	38032	88	applied	\N	\N	\N	\N	117442	117442	117443
24514	38035	89	applied	\N	\N	\N	\N	117449	117449	117450
24514	38037	90	applied	\N	\N	\N	\N	117455	117455	117456
24514	38039	91	applied	\N	\N	\N	\N	117463	117463	117464
24514	38041	92	applied	\N	\N	\N	\N	117472	117472	117473
24514	38044	93	applied	\N	\N	\N	\N	117479	117479	117480
24514	38045	94	applied	\N	\N	\N	\N	117481	117481	117482
24514	38048	95	applied	\N	\N	\N	\N	117492	117492	117493
24514	38051	96	applied	\N	\N	\N	\N	117502	117502	117503
24514	38052	97	applied	\N	\N	\N	\N	117504	117504	117505
24514	38054	98	applied	\N	\N	\N	\N	117509	117509	117510
24514	38057	99	applied	\N	\N	\N	\N	117518	117518	117519
24514	38058	100	applied	\N	\N	\N	\N	117520	117520	117521
24514	38061	101	applied	\N	\N	\N	\N	117530	117530	117531
24514	38063	102	applied	\N	\N	\N	\N	117536	117536	117537
24514	38066	103	applied	\N	\N	\N	\N	117543	117543	117544
24514	38067	104	applied	\N	\N	\N	\N	117545	117545	117546
24514	38068	105	applied	\N	\N	\N	\N	117547	117547	117548
24514	38077	106	applied	\N	\N	\N	\N	117567	117567	117568
24514	38078	107	applied	\N	\N	\N	\N	117569	117569	117570
24514	38081	108	applied	\N	\N	\N	\N	117577	117577	117578
24514	38084	109	applied	\N	\N	\N	\N	117586	117586	117587
24514	38086	110	applied	\N	\N	\N	\N	117594	117594	117595
24514	38087	111	applied	\N	\N	\N	\N	117596	117596	117597
24514	38090	112	applied	\N	\N	\N	\N	117608	117608	117609
24514	38093	113	applied	\N	\N	\N	\N	117615	117615	117616
24514	38095	114	applied	\N	\N	\N	\N	117621	117621	117622
24514	38096	115	applied	\N	\N	\N	\N	117623	117623	117624
24514	38100	116	applied	\N	\N	\N	\N	117632	117632	117633
24514	38102	117	applied	\N	\N	\N	\N	117638	117638	117639
24514	38104	118	applied	\N	\N	\N	\N	117646	117646	117647
24514	38105	119	applied	\N	\N	\N	\N	117648	117648	117649
24514	38109	120	applied	\N	\N	\N	\N	117658	117658	117659
24514	38110	121	applied	\N	\N	\N	\N	117660	117660	117661
24514	38113	122	applied	\N	\N	\N	\N	117666	117666	117667
24514	38116	123	applied	\N	\N	\N	\N	117674	117674	117675
24514	38117	124	applied	\N	\N	\N	\N	117676	117676	117677
24514	38120	125	applied	\N	\N	\N	\N	117686	117686	117687
24516	38155	0	applied	\N	\N	\N	\N	117795	117795	117796
24516	38156	1	applied	\N	\N	\N	\N	117797	117797	117798
24516	38157	2	applied	\N	\N	\N	\N	117799	117799	117800
24516	38158	3	applied	\N	\N	\N	\N	117801	117801	117802
24516	38159	4	applied	\N	\N	\N	\N	117803	117803	117804
24516	38160	5	applied	\N	\N	\N	\N	117805	117805	117806
24516	38161	6	applied	\N	\N	\N	\N	117807	117807	117808
24517	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24517	37911	1	applied	\N	\N	\N	\N	117051	117051	117052
24517	37919	2	applied	\N	\N	\N	\N	117071	117071	117072
24517	37932	3	applied	\N	\N	\N	\N	117105	117105	117106
24517	38073	4	applied	\N	\N	\N	\N	117738	117738	117560
24517	38031	5	applied	\N	\N	\N	\N	117440	117440	117441
24517	37695	6	applied	\N	\N	1000000000	\N	116477	116477	116478
24517	37721	7	applied	\N	\N	\N	\N	116543	116543	116544
24517	37848	8	applied	\N	\N	\N	\N	116876	116876	93344
24517	38074	9	applied	\N	\N	\N	\N	117739	117739	117562
24517	38075	10	applied	\N	\N	\N	\N	117740	117740	117564
24517	38076	11	applied	\N	\N	\N	\N	117741	117741	117566
24517	37668	12	applied	\N	\N	\N	\N	117812	117812	116412
24517	37669	13	applied	\N	\N	\N	\N	117813	117813	116414
24517	37670	14	applied	\N	\N	\N	\N	117814	117814	116416
24517	37671	15	applied	\N	\N	\N	\N	117815	117815	116418
24517	37672	16	applied	\N	\N	\N	\N	117816	117816	116420
24517	37829	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	116827	116827	\N
24517	37696	18	applied	\N	\N	\N	\N	117817	117817	116480
24517	37974	19	applied	\N	\N	\N	\N	117818	117818	117256
24517	37975	20	applied	\N	\N	\N	\N	117819	117819	117258
24517	37976	21	applied	\N	\N	\N	\N	117820	117820	117260
24517	37977	22	applied	\N	\N	\N	\N	117821	117821	117262
24517	37654	23	applied	\N	\N	\N	\N	116375	116375	117822
24517	37664	24	applied	\N	\N	\N	\N	116399	116399	115378
24517	37679	25	applied	\N	\N	\N	\N	116437	116437	114684
24517	37691	26	applied	\N	\N	\N	\N	116464	116464	117823
24517	37708	27	applied	\N	\N	\N	\N	116504	116504	114691
24517	37715	28	applied	\N	\N	\N	\N	116524	116524	117824
24517	37728	29	applied	\N	\N	\N	\N	116560	116560	117825
24520	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24520	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24523	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24523	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24527	38073	0	applied	\N	\N	\N	\N	117559	117559	117560
24527	38074	1	applied	\N	\N	\N	\N	117561	117561	117562
24527	38075	2	applied	\N	\N	\N	\N	117563	117563	117564
24527	38076	3	applied	\N	\N	\N	\N	117565	117565	117566
24527	38037	4	applied	\N	\N	\N	\N	117455	117455	117456
24527	38039	5	applied	\N	\N	\N	\N	117463	117463	117464
24527	38041	6	applied	\N	\N	\N	\N	117472	117472	117473
24527	38044	7	applied	\N	\N	\N	\N	117479	117479	117480
24527	38045	8	applied	\N	\N	\N	\N	117481	117481	117482
24527	38048	9	applied	\N	\N	\N	\N	117492	117492	117493
24527	38043	10	applied	\N	\N	\N	\N	117476	117476	117847
24527	38050	11	applied	\N	\N	\N	\N	117496	117496	117848
24527	38055	12	applied	\N	\N	\N	\N	117511	117511	117458
24527	38064	13	applied	\N	\N	\N	\N	117538	117538	117849
24527	38038	14	applied	\N	\N	\N	\N	117457	117457	117850
24527	38040	15	applied	\N	\N	\N	\N	117465	117465	117477
24527	38042	16	applied	\N	\N	\N	\N	117474	117474	117484
24527	38046	17	applied	\N	\N	\N	\N	117483	117483	117486
24527	38072	18	applied	\N	\N	\N	\N	117555	117555	117851
24527	38082	19	applied	\N	\N	\N	\N	117579	117579	117852
24527	38092	20	applied	\N	\N	\N	\N	117612	117612	117495
24527	38097	21	applied	\N	\N	\N	\N	117625	117625	117497
24527	38106	22	applied	\N	\N	\N	\N	117650	117650	117853
24527	38114	23	applied	\N	\N	\N	\N	117668	117668	117854
24527	38121	24	applied	\N	\N	\N	\N	117688	117688	117507
24527	38131	25	applied	\N	\N	\N	\N	117717	117717	117512
24527	38138	26	applied	\N	\N	\N	\N	117734	117734	117855
24527	38146	27	applied	\N	\N	\N	\N	117763	117763	117856
24527	38152	28	applied	\N	\N	\N	\N	117783	117783	117514
24527	38158	29	applied	\N	\N	\N	\N	117801	117801	117857
24527	38047	30	applied	\N	\N	\N	\N	117485	117485	117858
24527	38049	31	applied	\N	\N	\N	\N	117494	117494	117859
24525	38037	116	applied	\N	\N	\N	\N	117455	117455	117456
24525	38039	117	applied	\N	\N	\N	\N	117463	117463	117464
24525	38041	118	applied	\N	\N	\N	\N	117472	117472	117473
24525	38044	119	applied	\N	\N	\N	\N	117479	117479	117480
24525	38045	120	applied	\N	\N	\N	\N	117481	117481	117482
24525	38048	121	applied	\N	\N	\N	\N	117492	117492	117493
24525	38051	122	applied	\N	\N	\N	\N	117502	117502	117503
24525	38052	123	applied	\N	\N	\N	\N	117504	117504	117505
24525	38054	124	applied	\N	\N	\N	\N	117509	117509	117510
24525	38057	125	applied	\N	\N	\N	\N	117518	117518	117519
24528	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24528	38163	1	applied	\N	\N	\N	\N	117830	117830	117831
24529	38164	0	applied	\N	\N	\N	\N	117889	117889	117890
24529	38165	1	applied	\N	\N	\N	\N	117891	117891	117892
24529	38166	2	applied	\N	\N	\N	\N	117893	117893	117894
24529	38167	3	applied	\N	\N	\N	\N	117895	117895	117896
24529	38168	4	applied	\N	\N	\N	\N	117897	117897	117898
24531	38169	0	applied	\N	\N	\N	\N	117903	117903	117904
24531	38170	1	applied	\N	\N	\N	\N	117905	117905	117906
24535	38162	0	applied	\N	\N	\N	\N	117828	117828	117829
24535	38164	1	applied	\N	\N	\N	\N	117889	117889	117890
24535	38165	2	applied	\N	\N	\N	\N	117891	117891	117892
24535	38169	3	applied	\N	\N	\N	\N	117903	117903	117904
24535	38171	4	applied	\N	\N	\N	\N	117909	117909	117910
24535	38173	5	applied	\N	\N	\N	\N	117913	117913	117914
24535	38174	6	applied	\N	\N	\N	\N	117915	117915	117916
24535	38178	7	applied	\N	\N	\N	\N	117925	117925	117926
24535	38179	8	applied	\N	\N	\N	\N	117927	117927	117928
24535	38163	9	applied	\N	\N	\N	\N	117830	117830	117831
24535	38166	10	applied	\N	\N	\N	\N	117893	117893	117894
24535	38176	11	applied	\N	\N	\N	\N	117919	117919	117935
24535	38167	12	applied	\N	\N	\N	\N	117895	117895	117936
24535	38168	13	applied	\N	\N	\N	\N	117897	117897	117937
24535	38170	14	applied	\N	\N	\N	\N	117905	117905	117938
24535	38172	15	applied	\N	\N	\N	\N	117911	117911	117939
24535	38175	16	applied	\N	\N	\N	\N	117917	117917	117920
24535	38177	17	applied	\N	\N	\N	\N	117921	117921	117922
24535	38180	18	applied	\N	\N	\N	\N	117929	117929	117930
24535	38181	19	applied	\N	\N	\N	\N	117931	117931	117932
24549	38200	0	applied	\N	\N	\N	\N	117992	117992	117993
24549	38201	1	applied	\N	\N	\N	\N	117994	117994	117995
24553	38202	0	applied	\N	\N	\N	\N	118000	118000	118001
24553	38203	1	applied	\N	\N	\N	\N	118002	118002	118003
24556	38204	0	applied	\N	\N	\N	\N	118008	118008	118009
24556	38205	1	applied	\N	\N	\N	\N	118010	118010	118011
24556	38206	2	applied	\N	\N	\N	\N	118012	118012	118013
24556	38207	3	applied	\N	\N	\N	\N	118014	118014	118015
24556	38208	4	applied	\N	\N	\N	\N	118016	118016	118017
24560	38214	0	applied	\N	\N	\N	\N	118037	118037	118038
24565	38221	0	applied	\N	\N	\N	\N	118056	118056	118057
24565	38222	1	applied	\N	\N	\N	\N	118058	118058	118059
24569	38223	0	applied	\N	\N	\N	\N	118062	118062	118063
24569	38224	1	applied	\N	\N	\N	\N	118064	118064	118065
24569	38225	2	applied	\N	\N	\N	\N	118066	118066	118067
24569	38226	3	applied	\N	\N	\N	\N	118068	118068	118069
24573	38230	0	applied	\N	\N	\N	\N	118085	118085	118086
24573	38231	1	applied	\N	\N	\N	\N	118087	118087	118088
24573	38232	2	applied	\N	\N	\N	\N	118089	118089	118090
24573	38233	3	applied	\N	\N	\N	\N	118091	118091	118092
24573	38234	4	applied	\N	\N	\N	\N	118093	118093	118094
24573	38235	5	applied	\N	\N	\N	\N	118095	118095	118096
24573	38236	6	applied	\N	\N	\N	\N	118097	118097	118098
24573	38237	7	applied	\N	\N	\N	\N	118099	118099	118100
24573	38238	8	applied	\N	\N	\N	\N	118101	118101	118102
24581	38256	0	applied	\N	\N	\N	\N	118149	118149	118150
24581	38257	1	applied	\N	\N	\N	\N	118151	118151	118152
24581	38258	2	applied	\N	\N	\N	\N	118153	118153	118154
24581	38259	3	applied	\N	\N	\N	\N	118155	118155	118156
24581	38260	4	applied	\N	\N	\N	\N	118157	118157	118158
24585	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24585	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24585	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24585	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24585	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24585	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24585	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24587	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24587	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24587	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24587	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24587	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24587	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24587	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24592	38276	0	applied	\N	\N	\N	\N	118211	118211	118212
24592	38277	1	applied	\N	\N	\N	\N	118213	118213	118214
24592	38278	2	applied	\N	\N	\N	\N	118215	118215	118216
24592	38279	3	applied	\N	\N	\N	\N	118217	118217	118218
24592	38280	4	applied	\N	\N	\N	\N	118219	118219	118220
24592	38281	5	applied	\N	\N	\N	\N	118221	118221	118222
24592	38282	6	applied	\N	\N	\N	\N	118223	118223	118224
24599	38286	0	applied	\N	\N	\N	\N	118238	118238	118239
24606	38295	0	applied	\N	\N	\N	\N	118270	118270	118271
24606	38296	1	applied	\N	\N	\N	\N	118272	118272	118273
24606	38297	2	applied	\N	\N	\N	\N	118274	118274	118275
24606	38298	3	applied	\N	\N	\N	\N	118276	118276	118277
24606	38299	4	applied	\N	\N	\N	\N	118278	118278	118279
24606	38300	5	applied	\N	\N	\N	\N	118280	118280	118281
24606	38301	6	applied	\N	\N	\N	\N	118282	118282	118283
24611	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24611	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24611	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24615	38305	0	applied	\N	\N	\N	\N	118303	118303	118304
24615	38306	1	applied	\N	\N	\N	\N	118305	118305	118306
24615	38307	2	applied	\N	\N	\N	\N	118307	118307	118308
24621	38328	0	applied	\N	\N	\N	\N	118359	118359	118360
24621	38329	1	applied	\N	\N	\N	\N	118361	118361	118362
24621	38330	2	applied	\N	\N	\N	\N	118363	118363	118364
24626	38328	0	applied	\N	\N	\N	\N	118359	118359	118360
24626	38329	1	applied	\N	\N	\N	\N	118361	118361	118362
24626	38330	2	applied	\N	\N	\N	\N	118363	118363	118364
24628	38335	0	applied	\N	\N	\N	\N	118385	118385	118386
24628	38336	1	applied	\N	\N	\N	\N	118387	118387	118388
24628	38337	2	applied	\N	\N	\N	\N	118389	118389	118390
24628	38338	3	applied	\N	\N	\N	\N	118391	118391	118392
24628	38339	4	applied	\N	\N	\N	\N	118393	118393	118394
24628	38340	5	applied	\N	\N	\N	\N	118395	118395	118396
24628	38341	6	applied	\N	\N	\N	\N	118397	118397	118398
24628	38342	7	applied	\N	\N	\N	\N	118399	118399	118400
24628	38343	8	applied	\N	\N	\N	\N	118401	118401	118402
24628	38344	9	applied	\N	\N	\N	\N	118403	118403	118404
24527	38053	32	applied	\N	\N	\N	\N	117506	117506	117539
24527	38056	33	applied	\N	\N	\N	\N	117513	117513	117541
24527	38059	34	applied	\N	\N	\N	\N	117522	117522	117550
24527	38060	35	applied	\N	\N	\N	\N	117524	117524	117552
24527	38062	36	applied	\N	\N	\N	\N	117532	117532	117554
24527	38065	37	applied	\N	\N	\N	\N	117540	117540	117860
24527	38069	38	applied	\N	\N	\N	\N	117549	117549	117861
24527	38070	39	applied	\N	\N	\N	\N	117551	117551	117862
24527	38071	40	applied	\N	\N	\N	\N	117553	117553	117863
24527	38079	41	applied	\N	\N	\N	\N	117571	117571	117864
24527	38080	42	applied	\N	\N	\N	\N	117573	117573	117865
24527	38083	43	applied	\N	\N	\N	\N	117581	117581	117866
24527	38085	44	applied	\N	\N	\N	\N	117588	117588	117613
24527	38088	45	applied	\N	\N	\N	\N	117598	117598	117618
24527	38089	46	applied	\N	\N	\N	\N	117600	117600	117867
24527	38091	47	applied	\N	\N	\N	\N	117610	117610	117868
24527	38094	48	applied	\N	\N	\N	\N	117617	117617	117869
24527	38098	49	applied	\N	\N	\N	\N	117627	117627	117870
24527	38099	50	applied	\N	\N	\N	\N	117629	117629	117871
24527	38101	51	applied	\N	\N	\N	\N	117634	117634	117872
24527	38103	52	applied	\N	\N	\N	\N	117641	117641	117873
24527	38107	53	applied	\N	\N	\N	\N	117652	117652	117874
24527	38108	54	applied	\N	\N	\N	\N	117654	117654	117669
24527	38111	55	applied	\N	\N	\N	\N	117662	117662	117671
24527	38112	56	applied	\N	\N	\N	\N	117664	117664	117679
24527	38115	57	applied	\N	\N	\N	\N	117670	117670	117681
24527	38118	58	applied	\N	\N	\N	\N	117678	117678	117875
24527	38119	59	applied	\N	\N	\N	\N	117680	117680	117876
24527	38122	60	applied	\N	\N	\N	\N	117690	117690	117877
24527	38124	61	applied	\N	\N	\N	\N	117696	117696	117878
24527	38126	62	applied	\N	\N	\N	\N	117706	117706	117879
24527	38129	63	applied	\N	\N	\N	\N	117713	117713	117880
24527	38130	64	applied	\N	\N	\N	\N	117715	117715	117881
24527	38133	65	applied	\N	\N	\N	\N	117723	117723	117882
24527	38135	66	applied	\N	\N	\N	\N	117728	117728	117735
24527	38137	67	applied	\N	\N	\N	\N	117732	117732	117748
24527	38140	68	applied	\N	\N	\N	\N	117747	117747	117754
24527	38142	69	applied	\N	\N	\N	\N	117753	117753	117762
24527	38145	70	applied	\N	\N	\N	\N	117761	117761	117883
24527	38147	71	applied	\N	\N	\N	\N	117765	117765	117884
24527	38149	72	applied	\N	\N	\N	\N	117771	117771	117885
24527	38153	73	applied	\N	\N	\N	\N	117785	117785	117886
24527	38154	74	applied	\N	\N	\N	\N	117787	117787	117802
24527	38159	75	applied	\N	\N	\N	\N	117803	117803	117804
24527	38160	76	applied	\N	\N	\N	\N	117805	117805	117806
24527	38161	77	applied	\N	\N	\N	\N	117807	117807	117808
24527	38163	78	applied	\N	\N	\N	\N	117830	117830	117831
24533	38173	0	applied	\N	\N	\N	\N	117913	117913	117914
24533	38174	1	applied	\N	\N	\N	\N	117915	117915	117916
24533	38175	2	applied	\N	\N	\N	\N	117917	117917	117918
24533	38176	3	applied	\N	\N	\N	\N	117919	117919	117920
24533	38177	4	applied	\N	\N	\N	\N	117921	117921	117922
24541	38191	0	applied	\N	\N	\N	\N	117968	117968	117969
24541	38192	1	applied	\N	\N	\N	\N	117970	117970	117971
24541	38193	2	applied	\N	\N	\N	\N	117972	117972	117973
24541	38194	3	applied	\N	\N	\N	\N	117974	117974	117975
24551	38200	0	applied	\N	\N	\N	\N	117992	117992	117993
24551	38201	1	applied	\N	\N	\N	\N	117994	117994	117995
24559	38211	0	applied	\N	\N	\N	\N	118030	118030	118031
24559	38212	1	applied	\N	\N	\N	\N	118032	118032	118033
24559	38213	2	applied	\N	\N	\N	\N	118034	118034	118035
24564	38221	0	applied	\N	\N	\N	\N	118056	118056	118057
24564	38222	1	applied	\N	\N	\N	\N	118058	118058	118059
24567	38223	0	applied	\N	\N	\N	\N	118062	118062	118063
24567	38224	1	applied	\N	\N	\N	\N	118064	118064	118065
24567	38225	2	applied	\N	\N	\N	\N	118066	118066	118067
24567	38226	3	applied	\N	\N	\N	\N	118068	118068	118069
24574	38239	0	applied	\N	\N	\N	\N	118105	118105	118106
24574	38240	1	applied	\N	\N	\N	\N	118107	118107	118108
24576	38241	0	applied	\N	\N	\N	\N	118113	118113	118114
24576	38242	1	applied	\N	\N	\N	\N	118115	118115	118116
24576	38243	2	applied	\N	\N	\N	\N	118117	118117	118118
24583	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24583	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24583	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24583	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24583	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24583	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24583	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24588	38268	0	applied	\N	\N	\N	\N	118189	118189	118190
24588	38269	1	applied	\N	\N	\N	\N	118191	118191	118192
24590	38270	0	applied	\N	\N	\N	\N	118195	118195	118196
24590	38271	1	applied	\N	\N	\N	\N	118197	118197	118198
24590	38272	2	applied	\N	\N	\N	\N	118199	118199	118200
24590	38273	3	applied	\N	\N	\N	\N	118201	118201	118202
24590	38274	4	applied	\N	\N	\N	\N	118203	118203	118204
24590	38275	5	applied	\N	\N	\N	\N	118205	118205	118206
24600	38287	0	applied	\N	\N	\N	\N	118244	118244	118245
24600	38288	1	applied	\N	\N	\N	\N	118246	118246	118247
24600	38289	2	applied	\N	\N	\N	\N	118248	118248	118249
24603	38290	0	applied	\N	\N	\N	\N	118254	118254	118255
24603	38291	1	applied	\N	\N	\N	\N	118256	118256	118257
24603	38292	2	applied	\N	\N	\N	\N	118258	118258	118259
24605	38293	0	applied	\N	\N	\N	\N	118264	118264	118265
24605	38294	1	applied	\N	\N	\N	\N	118266	118266	118267
24608	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24608	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24608	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24610	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24610	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24610	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24612	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24612	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24612	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24614	38305	0	applied	\N	\N	\N	\N	118303	118303	118304
24614	38306	1	applied	\N	\N	\N	\N	118305	118305	118306
24614	38307	2	applied	\N	\N	\N	\N	118307	118307	118308
24616	38306	0	applied	\N	\N	\N	\N	118305	118305	118306
24616	38307	1	applied	\N	\N	\N	\N	118307	118307	118308
24618	38308	0	applied	\N	\N	\N	\N	118314	118314	118315
24618	38309	1	applied	\N	\N	\N	\N	118316	118316	118317
24618	38310	2	applied	\N	\N	\N	\N	118318	118318	118319
24618	38311	3	applied	\N	\N	\N	\N	118320	118320	118321
24618	38312	4	applied	\N	\N	\N	\N	118322	118322	118323
24618	38313	5	applied	\N	\N	\N	\N	118324	118324	118325
24618	38314	6	applied	\N	\N	\N	\N	118326	118326	118327
24618	38315	7	applied	\N	\N	\N	\N	118328	118328	118329
24618	38316	8	applied	\N	\N	\N	\N	118330	118330	118331
24618	38317	9	applied	\N	\N	\N	\N	118332	118332	118333
24618	38318	10	applied	\N	\N	\N	\N	118334	118334	118335
24557	37970	42	applied	\N	\N	\N	\N	117244	117244	117245
24557	37972	43	applied	\N	\N	\N	\N	117251	117251	117252
24557	37978	44	applied	\N	\N	\N	\N	117264	117264	117265
24557	37982	45	applied	\N	\N	\N	\N	117274	117274	117275
24557	37983	46	applied	\N	\N	\N	\N	117278	117278	117279
24557	37985	47	applied	\N	\N	\N	\N	117284	117284	117285
24557	37988	48	applied	\N	\N	\N	\N	117290	117290	117291
24557	37990	49	applied	\N	\N	\N	\N	117296	117296	117297
24557	37992	50	applied	\N	\N	\N	\N	117303	117303	117304
24557	37993	51	applied	\N	\N	\N	\N	117305	117305	117306
24557	37994	52	applied	\N	\N	\N	\N	117307	117307	117308
24557	37999	53	applied	\N	\N	\N	\N	117318	117318	117319
24557	38001	54	applied	\N	\N	\N	\N	117326	117326	117327
24557	38004	55	applied	\N	\N	\N	\N	117359	117359	117360
24557	38005	56	applied	\N	\N	\N	\N	117361	117361	117362
24557	38008	57	applied	\N	\N	\N	\N	117371	117371	117372
24557	38009	58	applied	\N	\N	\N	\N	117373	117373	117374
24557	38010	59	applied	\N	\N	\N	\N	117375	117375	117376
24557	38015	60	applied	\N	\N	\N	\N	117386	117386	117387
24557	38017	61	applied	\N	\N	\N	\N	117395	117395	117396
24557	38020	62	applied	\N	\N	\N	\N	117409	117409	117410
24557	38022	63	applied	\N	\N	\N	\N	117416	117416	117417
24557	38023	64	applied	\N	\N	\N	\N	117418	117418	117419
24557	38024	65	applied	\N	\N	\N	\N	117420	117420	117421
24557	38029	66	applied	\N	\N	\N	\N	117434	117434	117435
24557	38032	67	applied	\N	\N	\N	\N	117442	117442	117443
24557	38035	68	applied	\N	\N	\N	\N	117449	117449	117450
24557	38037	69	applied	\N	\N	\N	\N	117455	117455	117456
24557	38039	70	applied	\N	\N	\N	\N	117463	117463	117464
24557	38041	71	applied	\N	\N	\N	\N	117472	117472	117473
24557	38044	72	applied	\N	\N	\N	\N	117479	117479	117480
24557	38045	73	applied	\N	\N	\N	\N	117481	117481	117482
24557	38048	74	applied	\N	\N	\N	\N	117492	117492	117493
24557	38051	75	applied	\N	\N	\N	\N	117502	117502	117503
24557	38052	76	applied	\N	\N	\N	\N	117504	117504	117505
24557	38054	77	applied	\N	\N	\N	\N	117509	117509	117510
24557	38057	78	applied	\N	\N	\N	\N	117518	117518	117519
24557	38058	79	applied	\N	\N	\N	\N	117520	117520	117521
24557	38061	80	applied	\N	\N	\N	\N	117530	117530	117531
24557	38063	81	applied	\N	\N	\N	\N	117536	117536	117537
24557	38066	82	applied	\N	\N	\N	\N	117543	117543	117544
24557	38067	83	applied	\N	\N	\N	\N	117545	117545	117546
24557	38068	84	applied	\N	\N	\N	\N	117547	117547	117548
24557	38077	85	applied	\N	\N	\N	\N	117567	117567	117568
24557	38078	86	applied	\N	\N	\N	\N	117569	117569	117570
24557	38081	87	applied	\N	\N	\N	\N	117577	117577	117578
24557	38084	88	applied	\N	\N	\N	\N	117586	117586	117587
24557	38086	89	applied	\N	\N	\N	\N	117594	117594	117595
24557	38087	90	applied	\N	\N	\N	\N	117596	117596	117597
24557	38090	91	applied	\N	\N	\N	\N	117608	117608	117609
24557	38093	92	applied	\N	\N	\N	\N	117615	117615	117616
24557	38095	93	applied	\N	\N	\N	\N	117621	117621	117622
24557	38096	94	applied	\N	\N	\N	\N	117623	117623	117624
24557	38100	95	applied	\N	\N	\N	\N	117632	117632	117633
24557	38102	96	applied	\N	\N	\N	\N	117638	117638	117639
24557	38104	97	applied	\N	\N	\N	\N	117646	117646	117647
24557	38105	98	applied	\N	\N	\N	\N	117648	117648	117649
24557	38109	99	applied	\N	\N	\N	\N	117658	117658	117659
24557	38110	100	applied	\N	\N	\N	\N	117660	117660	117661
24557	38113	101	applied	\N	\N	\N	\N	117666	117666	117667
24557	38116	102	applied	\N	\N	\N	\N	117674	117674	117675
24557	38117	103	applied	\N	\N	\N	\N	117676	117676	117677
24557	38120	104	applied	\N	\N	\N	\N	117686	117686	117687
24557	38123	105	applied	\N	\N	\N	\N	117694	117694	117695
24557	38125	106	applied	\N	\N	\N	\N	117702	117702	117703
24557	38127	107	applied	\N	\N	\N	\N	117709	117709	117710
24557	38128	108	applied	\N	\N	\N	\N	117711	117711	117712
24557	38132	109	applied	\N	\N	\N	\N	117721	117721	117722
24557	38134	110	applied	\N	\N	\N	\N	117726	117726	117727
24557	38136	111	applied	\N	\N	\N	\N	117730	117730	117731
24557	38139	112	applied	\N	\N	\N	\N	117745	117745	117746
24557	38141	113	applied	\N	\N	\N	\N	117751	117751	117752
24557	38143	114	applied	\N	\N	\N	\N	117757	117757	117758
24557	38144	115	applied	\N	\N	\N	\N	117759	117759	117760
24557	38148	116	applied	\N	\N	\N	\N	117769	117769	117770
24557	38150	118	applied	\N	\N	\N	\N	117779	117779	117780
24557	38151	119	applied	\N	\N	\N	\N	117781	117781	117782
24557	38155	120	applied	\N	\N	\N	\N	117795	117795	117796
24557	38156	121	applied	\N	\N	\N	\N	117797	117797	117798
24557	38157	122	applied	\N	\N	\N	\N	117799	117799	117800
24557	38162	123	applied	\N	\N	\N	\N	117828	117828	117829
24557	38164	124	applied	\N	\N	\N	\N	117889	117889	117890
24557	38165	125	applied	\N	\N	\N	\N	117891	117891	117892
24562	38216	0	applied	\N	\N	\N	\N	118043	118043	118044
24562	38217	1	applied	\N	\N	\N	\N	118045	118045	118046
24568	38223	0	applied	\N	\N	\N	\N	118062	118062	118063
24568	38224	1	applied	\N	\N	\N	\N	118064	118064	118065
24568	38225	2	applied	\N	\N	\N	\N	118066	118066	118067
24568	38226	3	applied	\N	\N	\N	\N	118068	118068	118069
24571	38227	0	applied	\N	\N	\N	\N	118077	118077	118078
24571	38228	1	applied	\N	\N	\N	\N	118079	118079	118080
24571	38229	2	applied	\N	\N	\N	\N	118081	118081	118082
24572	38230	0	applied	\N	\N	\N	\N	118085	118085	118086
24572	38231	1	applied	\N	\N	\N	\N	118087	118087	118088
24572	38232	2	applied	\N	\N	\N	\N	118089	118089	118090
24572	38233	3	applied	\N	\N	\N	\N	118091	118091	118092
24572	38234	4	applied	\N	\N	\N	\N	118093	118093	118094
24572	38235	5	applied	\N	\N	\N	\N	118095	118095	118096
24572	38236	6	applied	\N	\N	\N	\N	118097	118097	118098
24572	38237	7	applied	\N	\N	\N	\N	118099	118099	118100
24572	38238	8	applied	\N	\N	\N	\N	118101	118101	118102
24575	38239	0	applied	\N	\N	\N	\N	118105	118105	118106
24575	38240	1	applied	\N	\N	\N	\N	118107	118107	118108
24577	38241	0	applied	\N	\N	\N	\N	118113	118113	118114
24577	38242	1	applied	\N	\N	\N	\N	118115	118115	118116
24577	38243	2	applied	\N	\N	\N	\N	118117	118117	118118
24579	38246	0	applied	\N	\N	\N	\N	118127	118127	118128
24579	38247	1	applied	\N	\N	\N	\N	118129	118129	118130
24580	38248	0	applied	\N	\N	\N	\N	118132	118132	118133
24580	38249	1	applied	\N	\N	\N	\N	118134	118134	118135
24580	38250	2	applied	\N	\N	\N	\N	118136	118136	118137
24580	38251	3	applied	\N	\N	\N	\N	118138	118138	118139
24580	38252	4	applied	\N	\N	\N	\N	118140	118140	118141
24580	38253	5	applied	\N	\N	\N	\N	118142	118142	118143
24580	38254	6	applied	\N	\N	\N	\N	118144	118144	118145
24580	38255	7	applied	\N	\N	\N	\N	118146	118146	118147
24584	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24584	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24584	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24584	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24584	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24584	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24584	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24586	38261	0	applied	\N	\N	\N	\N	118161	118161	118162
24586	38262	1	applied	\N	\N	\N	\N	118163	118163	118164
24586	38263	2	applied	\N	\N	\N	\N	118165	118165	118166
24586	38264	3	applied	\N	\N	\N	\N	118167	118167	118168
24586	38265	4	applied	\N	\N	\N	\N	118169	118169	118170
24586	38266	6	applied	\N	\N	\N	\N	118172	118172	118173
24586	38267	7	applied	\N	\N	\N	\N	118174	118174	118175
24589	38268	0	applied	\N	\N	\N	\N	118189	118189	118190
24589	38269	1	applied	\N	\N	\N	\N	118191	118191	118192
24594	38276	0	applied	\N	\N	\N	\N	118211	118211	118212
24594	38277	1	applied	\N	\N	\N	\N	118213	118213	118214
24594	38278	2	applied	\N	\N	\N	\N	118215	118215	118216
24594	38279	3	applied	\N	\N	\N	\N	118217	118217	118218
24594	38280	4	applied	\N	\N	\N	\N	118219	118219	118220
24594	38281	5	applied	\N	\N	\N	\N	118221	118221	118222
24594	38282	6	applied	\N	\N	\N	\N	118223	118223	118224
24596	38283	0	applied	\N	\N	\N	\N	118231	118231	118232
24596	38284	1	applied	\N	\N	\N	\N	118233	118233	118234
24598	38285	0	applied	\N	\N	\N	\N	118236	118236	118237
24598	38286	1	applied	\N	\N	\N	\N	118238	118238	118239
24601	38287	0	applied	\N	\N	\N	\N	118244	118244	118245
24601	38288	1	applied	\N	\N	\N	\N	118246	118246	118247
24601	38289	2	applied	\N	\N	\N	\N	118248	118248	118249
24609	38302	0	applied	\N	\N	\N	\N	118286	118286	118287
24609	38303	1	applied	\N	\N	\N	\N	118288	118288	118289
24609	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24623	38328	0	applied	\N	\N	\N	\N	118359	118359	118360
24623	38329	1	applied	\N	\N	\N	\N	118361	118361	118362
24623	38330	2	applied	\N	\N	\N	\N	118363	118363	118364
24630	38345	0	applied	\N	\N	\N	\N	118407	118407	118408
24630	38346	1	applied	\N	\N	\N	\N	118409	118409	118410
24630	38347	2	applied	\N	\N	\N	\N	118411	118411	118412
24635	38354	0	applied	\N	\N	\N	\N	118430	118430	118431
24635	38355	2	applied	\N	\N	\N	\N	118433	118433	118434
24635	38356	3	applied	\N	\N	\N	\N	118435	118435	118436
24635	38357	4	applied	\N	\N	\N	\N	118437	118437	118438
24641	38358	0	applied	\N	\N	\N	\N	118446	118446	118447
24641	38359	1	applied	\N	\N	\N	\N	118448	118448	118449
24641	38360	2	applied	\N	\N	\N	\N	118450	118450	118451
24641	38361	3	applied	\N	\N	\N	\N	118452	118452	118453
24641	38362	4	applied	\N	\N	\N	\N	118454	118454	118455
24641	38363	5	applied	\N	\N	\N	\N	118456	118456	118456
24641	38364	6	applied	\N	\N	\N	\N	118457	118457	118458
24641	38365	7	applied	\N	\N	\N	\N	118459	118459	118460
24646	38366	0	applied	\N	\N	\N	\N	118474	118474	118475
24646	38367	1	applied	\N	\N	\N	\N	118476	118476	118477
24646	38368	2	applied	\N	\N	\N	\N	118478	118478	118479
24646	38369	3	applied	\N	\N	\N	\N	118480	118480	118481
24648	38370	0	applied	\N	\N	\N	\N	118486	118486	118487
24648	38371	1	applied	\N	\N	\N	\N	118488	118488	118489
24648	38372	2	applied	\N	\N	\N	\N	118490	118490	118491
24648	38373	3	applied	\N	\N	\N	\N	118492	118492	118493
24653	38374	0	applied	\N	\N	\N	\N	118499	118499	118500
24653	38375	1	applied	\N	\N	\N	\N	118501	118501	118502
24653	38376	2	applied	\N	\N	\N	\N	118503	118503	118504
24653	38377	3	applied	\N	\N	\N	\N	118505	118505	118506
24662	38396	0	applied	\N	\N	\N	\N	118558	118558	118559
24662	38397	1	applied	\N	\N	\N	\N	118560	118560	118561
24662	38398	2	applied	\N	\N	\N	\N	118562	118562	118563
24662	38399	3	applied	\N	\N	\N	\N	118564	118564	118565
24667	38401	0	applied	\N	\N	\N	\N	118576	118576	118577
24667	38400	1	applied	\N	\N	\N	\N	118572	118572	118573
24672	38405	0	applied	\N	\N	\N	\N	118589	118589	118590
24672	38406	1	applied	\N	\N	\N	\N	118591	118591	118592
24672	38407	2	applied	\N	\N	\N	\N	118593	118593	118594
24672	38408	3	applied	\N	\N	\N	\N	118595	118595	118596
24677	38424	0	applied	\N	\N	\N	\N	118631	118631	118632
24677	38425	1	applied	\N	\N	\N	\N	118633	118633	118634
24677	38426	2	applied	\N	\N	\N	\N	118635	118635	118636
24677	38427	3	applied	\N	\N	\N	\N	118637	118637	118638
24679	38431	0	applied	\N	\N	\N	\N	118649	118649	118650
24679	38432	1	applied	\N	\N	\N	\N	118651	118651	118652
24679	38433	2	applied	\N	\N	\N	\N	118653	118653	118654
24679	38434	3	applied	\N	\N	\N	\N	118655	118655	118656
24679	38435	4	applied	\N	\N	\N	\N	118657	118657	118658
24686	38453	0	applied	\N	\N	\N	\N	118705	118705	118706
24686	38454	1	applied	\N	\N	\N	\N	118707	118707	118708
24686	38455	2	applied	\N	\N	\N	\N	118709	118709	118710
24686	38456	3	applied	\N	\N	\N	\N	118711	118711	118712
24686	38457	4	applied	\N	\N	\N	\N	118713	118713	118714
24686	38458	5	applied	\N	\N	\N	\N	118715	118715	118716
24686	38459	6	applied	\N	\N	\N	\N	118717	118717	118718
24686	38460	7	applied	\N	\N	\N	\N	118719	118719	118720
24686	38461	8	applied	\N	\N	\N	\N	118721	118721	118722
24686	38462	9	applied	\N	\N	\N	\N	118723	118723	118724
24688	38412	0	applied	\N	\N	\N	\N	118606	118606	118607
24688	38414	1	applied	\N	\N	\N	\N	118610	118610	118611
24688	38427	2	applied	\N	\N	\N	\N	118637	118637	118638
24693	38471	0	applied	\N	\N	\N	\N	118748	118748	118749
24693	38472	1	applied	\N	\N	\N	\N	118750	118750	118751
24693	38473	2	applied	\N	\N	\N	\N	118752	118752	118753
24693	38474	3	applied	\N	\N	\N	\N	118754	118754	118755
24693	38475	4	applied	\N	\N	\N	\N	118756	118756	118757
24693	38476	5	applied	\N	\N	\N	\N	118758	118758	118759
24695	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24695	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24695	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24695	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24695	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24699	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24699	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24699	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24699	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24699	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24707	38531	0	applied	\N	\N	\N	\N	118889	118889	118890
24707	38532	1	applied	\N	\N	\N	\N	118891	118891	118892
24707	38533	2	applied	\N	\N	\N	\N	118893	118893	118894
24707	38534	3	applied	\N	\N	\N	\N	118895	118895	118896
24707	38535	4	applied	\N	\N	\N	\N	118897	118897	118898
24707	38536	5	applied	\N	\N	\N	\N	118899	118899	118900
24707	38537	6	applied	\N	\N	\N	\N	118901	118901	118902
24707	38538	7	applied	\N	\N	\N	\N	118903	118903	118904
24707	38539	8	applied	\N	\N	\N	\N	118905	118905	118906
24707	38540	9	applied	\N	\N	\N	\N	118907	118907	118908
24712	38549	0	applied	\N	\N	\N	\N	118934	118934	118935
24712	38550	1	applied	\N	\N	\N	\N	118936	118936	118937
24712	38551	2	applied	\N	\N	\N	\N	118938	118938	118939
24607	38304	2	applied	\N	\N	\N	\N	118290	118290	118291
24613	38305	0	applied	\N	\N	\N	\N	118303	118303	118304
24613	38306	1	applied	\N	\N	\N	\N	118305	118305	118306
24613	38307	2	applied	\N	\N	\N	\N	118307	118307	118308
24617	38308	0	applied	\N	\N	\N	\N	118314	118314	118315
24617	38309	1	applied	\N	\N	\N	\N	118316	118316	118317
24617	38310	2	applied	\N	\N	\N	\N	118318	118318	118319
24617	38311	3	applied	\N	\N	\N	\N	118320	118320	118321
24617	38312	4	applied	\N	\N	\N	\N	118322	118322	118323
24617	38313	5	applied	\N	\N	\N	\N	118324	118324	118325
24617	38314	6	applied	\N	\N	\N	\N	118326	118326	118327
24617	38315	7	applied	\N	\N	\N	\N	118328	118328	118329
24617	38316	8	applied	\N	\N	\N	\N	118330	118330	118331
24617	38317	9	applied	\N	\N	\N	\N	118332	118332	118333
24617	38318	10	applied	\N	\N	\N	\N	118334	118334	118335
24617	38319	11	applied	\N	\N	\N	\N	118336	118336	118337
24617	38320	12	applied	\N	\N	\N	\N	118338	118338	118339
24617	38321	13	applied	\N	\N	\N	\N	118340	118340	118341
24617	38322	14	applied	\N	\N	\N	\N	118342	118342	118343
24617	38323	15	applied	\N	\N	\N	\N	118344	118344	118345
24617	38324	16	applied	\N	\N	\N	\N	118346	118346	118347
24619	38325	0	applied	\N	\N	\N	\N	118351	118351	118352
24619	38326	1	applied	\N	\N	\N	\N	118353	118353	118354
24619	38327	2	applied	\N	\N	\N	\N	118355	118355	118356
24622	38248	0	applied	\N	\N	\N	\N	118367	118367	118133
24622	38073	1	applied	\N	\N	\N	\N	117559	117559	117560
24622	38074	2	applied	\N	\N	\N	\N	117561	117561	117562
24622	38075	3	applied	\N	\N	\N	\N	117563	117563	117564
24622	38076	4	applied	\N	\N	\N	\N	117565	117565	117566
24622	38291	5	applied	\N	\N	\N	\N	118368	118368	118257
24624	38328	0	applied	\N	\N	\N	\N	118359	118359	118360
24624	38329	1	applied	\N	\N	\N	\N	118361	118361	118362
24637	38354	0	applied	\N	\N	\N	\N	118430	118430	118431
24637	38355	2	applied	\N	\N	\N	\N	118433	118433	118434
24637	38356	3	applied	\N	\N	\N	\N	118435	118435	118436
24637	38357	4	applied	\N	\N	\N	\N	118437	118437	118438
24640	38358	0	applied	\N	\N	\N	\N	118446	118446	118447
24640	38359	1	applied	\N	\N	\N	\N	118448	118448	118449
24640	38360	2	applied	\N	\N	\N	\N	118450	118450	118451
24640	38361	3	applied	\N	\N	\N	\N	118452	118452	118453
24640	38362	4	applied	\N	\N	\N	\N	118454	118454	118455
24640	38363	5	applied	\N	\N	\N	\N	118456	118456	118456
24640	38364	6	applied	\N	\N	\N	\N	118457	118457	118458
24640	38365	7	applied	\N	\N	\N	\N	118459	118459	118460
24644	38366	0	applied	\N	\N	\N	\N	118474	118474	118475
24644	38367	1	applied	\N	\N	\N	\N	118476	118476	118477
24644	38368	2	applied	\N	\N	\N	\N	118478	118478	118479
24644	38369	3	applied	\N	\N	\N	\N	118480	118480	118481
24649	38370	0	applied	\N	\N	\N	\N	118486	118486	118487
24649	38371	1	applied	\N	\N	\N	\N	118488	118488	118489
24649	38372	2	applied	\N	\N	\N	\N	118490	118490	118491
24649	38373	3	applied	\N	\N	\N	\N	118492	118492	118493
24651	38374	0	applied	\N	\N	\N	\N	118499	118499	118500
24651	38375	1	applied	\N	\N	\N	\N	118501	118501	118502
24651	38376	2	applied	\N	\N	\N	\N	118503	118503	118504
24651	38377	3	applied	\N	\N	\N	\N	118505	118505	118506
24658	38390	0	applied	\N	\N	\N	\N	118543	118543	118544
24658	38391	1	applied	\N	\N	\N	\N	118545	118545	118546
24658	38392	2	applied	\N	\N	\N	\N	118547	118547	118548
24660	38393	0	applied	\N	\N	\N	\N	118552	118552	118553
24660	38394	1	applied	\N	\N	\N	\N	118554	118554	118555
24660	38395	2	applied	\N	\N	\N	\N	118556	118556	118557
24663	38396	0	applied	\N	\N	\N	\N	118558	118558	118559
24663	38397	1	applied	\N	\N	\N	\N	118560	118560	118561
24663	38398	2	applied	\N	\N	\N	\N	118562	118562	118563
24663	38399	3	applied	\N	\N	\N	\N	118564	118564	118565
24666	38401	0	applied	\N	\N	\N	\N	118576	118576	118577
24666	38400	1	applied	\N	\N	\N	\N	118572	118572	118573
24668	38402	0	applied	\N	\N	\N	\N	118580	118580	118581
24668	38403	1	applied	\N	\N	\N	\N	118582	118582	118583
24668	38404	2	applied	\N	\N	\N	\N	118584	118584	118585
24670	38405	0	applied	\N	\N	\N	\N	118589	118589	118590
24670	38406	1	applied	\N	\N	\N	\N	118591	118591	118592
24670	38407	2	applied	\N	\N	\N	\N	118593	118593	118594
24670	38408	3	applied	\N	\N	\N	\N	118595	118595	118596
24673	38409	0	applied	\N	\N	\N	\N	118600	118600	118601
24673	38410	1	applied	\N	\N	\N	\N	118602	118602	118603
24673	38411	2	applied	\N	\N	\N	\N	118604	118604	118605
24673	38412	3	applied	\N	\N	\N	\N	118606	118606	118607
24673	38413	4	applied	\N	\N	\N	\N	118608	118608	118609
24673	38414	5	applied	\N	\N	\N	\N	118610	118610	118611
24673	38415	6	applied	\N	\N	\N	\N	118612	118612	118613
24673	38416	7	applied	\N	\N	\N	\N	118614	118614	118615
24673	38417	8	applied	\N	\N	\N	\N	118616	118616	118617
24673	38418	9	applied	\N	\N	\N	\N	118618	118618	118619
24673	38419	10	applied	\N	\N	\N	\N	118620	118620	118621
24673	38420	11	applied	\N	\N	\N	\N	118622	118622	118623
24675	38421	0	applied	\N	\N	\N	\N	118625	118625	118626
24675	38422	1	applied	\N	\N	\N	\N	118627	118627	118628
24675	38423	2	applied	\N	\N	\N	\N	118629	118629	118630
24680	38436	0	applied	\N	\N	\N	\N	118661	118661	118662
24680	38437	1	applied	\N	\N	\N	\N	118663	118663	118664
24680	38438	2	applied	\N	\N	\N	\N	118665	118665	118666
24681	38439	0	applied	\N	\N	\N	\N	118669	118669	118670
24681	38440	1	applied	\N	\N	\N	\N	118671	118671	118672
24681	38441	2	applied	\N	\N	\N	\N	118673	118673	118674
24681	38442	3	applied	\N	\N	\N	\N	118675	118675	118676
24681	38443	4	applied	\N	\N	\N	\N	118677	118677	118678
24681	38444	6	applied	\N	\N	\N	\N	118680	118680	118681
24681	38445	7	applied	\N	\N	\N	\N	118682	118682	118683
24681	38446	8	applied	\N	\N	\N	\N	118684	118684	118685
24681	38447	9	applied	\N	\N	\N	\N	118686	118686	118687
24681	38448	10	applied	\N	\N	\N	\N	118688	118688	118689
24681	38449	11	applied	\N	\N	\N	\N	118690	118690	118691
24685	38453	0	applied	\N	\N	\N	\N	118705	118705	118706
24685	38454	1	applied	\N	\N	\N	\N	118707	118707	118708
24685	38455	2	applied	\N	\N	\N	\N	118709	118709	118710
24685	38456	3	applied	\N	\N	\N	\N	118711	118711	118712
24685	38457	4	applied	\N	\N	\N	\N	118713	118713	118714
24685	38458	5	applied	\N	\N	\N	\N	118715	118715	118716
24685	38459	6	applied	\N	\N	\N	\N	118717	118717	118718
24685	38460	7	applied	\N	\N	\N	\N	118719	118719	118720
24685	38461	8	applied	\N	\N	\N	\N	118721	118721	118722
24685	38462	9	applied	\N	\N	\N	\N	118723	118723	118724
24689	38463	0	applied	\N	\N	\N	\N	118728	118728	118729
24689	38464	1	applied	\N	\N	\N	\N	118730	118730	118731
24689	38465	2	applied	\N	\N	\N	\N	118732	118732	118733
24689	38466	3	applied	\N	\N	\N	\N	118734	118734	118735
24692	38471	0	applied	\N	\N	\N	\N	118748	118748	118749
24692	38472	1	applied	\N	\N	\N	\N	118750	118750	118751
24618	38319	11	applied	\N	\N	\N	\N	118336	118336	118337
24618	38320	12	applied	\N	\N	\N	\N	118338	118338	118339
24618	38321	13	applied	\N	\N	\N	\N	118340	118340	118341
24618	38322	14	applied	\N	\N	\N	\N	118342	118342	118343
24618	38323	15	applied	\N	\N	\N	\N	118344	118344	118345
24618	38324	16	applied	\N	\N	\N	\N	118346	118346	118347
24620	38325	0	applied	\N	\N	\N	\N	118351	118351	118352
24620	38326	1	applied	\N	\N	\N	\N	118353	118353	118354
24620	38327	2	applied	\N	\N	\N	\N	118355	118355	118356
24625	38328	0	applied	\N	\N	\N	\N	118359	118359	118360
24625	38329	1	applied	\N	\N	\N	\N	118361	118361	118362
24625	38330	2	applied	\N	\N	\N	\N	118363	118363	118364
24627	38331	0	applied	\N	\N	\N	\N	118375	118375	118376
24627	38332	1	applied	\N	\N	\N	\N	118377	118377	118378
24627	38333	2	applied	\N	\N	\N	\N	118379	118379	118380
24627	38334	3	applied	\N	\N	\N	\N	118381	118381	118382
24629	38345	0	applied	\N	\N	\N	\N	118407	118407	118408
24629	38346	1	applied	\N	\N	\N	\N	118409	118409	118410
24629	38347	2	applied	\N	\N	\N	\N	118411	118411	118412
24632	38345	0	applied	\N	\N	\N	\N	118407	118407	118408
24632	38346	1	applied	\N	\N	\N	\N	118409	118409	118410
24632	38347	2	applied	\N	\N	\N	\N	118411	118411	118412
24634	38354	0	applied	\N	\N	\N	\N	118430	118430	118431
24634	38355	2	applied	\N	\N	\N	\N	118433	118433	118434
24634	38356	3	applied	\N	\N	\N	\N	118435	118435	118436
24634	38357	4	applied	\N	\N	\N	\N	118437	118437	118438
24638	38354	0	applied	\N	\N	\N	\N	118430	118430	118431
24638	38355	2	applied	\N	\N	\N	\N	118433	118433	118434
24638	38356	3	applied	\N	\N	\N	\N	118435	118435	118436
24638	38357	4	applied	\N	\N	\N	\N	118437	118437	118438
24645	38366	0	applied	\N	\N	\N	\N	118474	118474	118475
24645	38367	1	applied	\N	\N	\N	\N	118476	118476	118477
24645	38368	2	applied	\N	\N	\N	\N	118478	118478	118479
24645	38369	3	applied	\N	\N	\N	\N	118480	118480	118481
24647	38370	0	applied	\N	\N	\N	\N	118486	118486	118487
24647	38371	1	applied	\N	\N	\N	\N	118488	118488	118489
24647	38372	2	applied	\N	\N	\N	\N	118490	118490	118491
24647	38373	3	applied	\N	\N	\N	\N	118492	118492	118493
24650	38370	0	applied	\N	\N	\N	\N	118486	118486	118487
24650	38371	1	applied	\N	\N	\N	\N	118488	118488	118489
24650	38372	2	applied	\N	\N	\N	\N	118490	118490	118491
24650	38373	3	applied	\N	\N	\N	\N	118492	118492	118493
24652	38374	0	applied	\N	\N	\N	\N	118499	118499	118500
24652	38375	1	applied	\N	\N	\N	\N	118501	118501	118502
24652	38376	2	applied	\N	\N	\N	\N	118503	118503	118504
24652	38377	3	applied	\N	\N	\N	\N	118505	118505	118506
24656	38387	0	applied	\N	\N	\N	\N	118535	118535	118536
24656	38388	1	applied	\N	\N	\N	\N	118537	118537	118538
24656	38389	2	applied	\N	\N	\N	\N	118539	118539	118540
24659	38390	0	applied	\N	\N	\N	\N	118543	118543	118544
24659	38391	1	applied	\N	\N	\N	\N	118545	118545	118546
24659	38392	2	applied	\N	\N	\N	\N	118547	118547	118548
24661	38396	0	applied	\N	\N	\N	\N	118558	118558	118559
24661	38397	1	applied	\N	\N	\N	\N	118560	118560	118561
24661	38398	2	applied	\N	\N	\N	\N	118562	118562	118563
24661	38399	3	applied	\N	\N	\N	\N	118564	118564	118565
24664	38396	0	applied	\N	\N	\N	\N	118558	118558	118559
24664	38397	1	applied	\N	\N	\N	\N	118560	118560	118561
24664	38398	2	applied	\N	\N	\N	\N	118562	118562	118563
24664	38399	3	applied	\N	\N	\N	\N	118564	118564	118565
24669	38402	0	applied	\N	\N	\N	\N	118580	118580	118581
24669	38403	1	applied	\N	\N	\N	\N	118582	118582	118583
24669	38404	2	applied	\N	\N	\N	\N	118584	118584	118585
24671	38405	0	applied	\N	\N	\N	\N	118589	118589	118590
24671	38406	1	applied	\N	\N	\N	\N	118591	118591	118592
24671	38407	2	applied	\N	\N	\N	\N	118593	118593	118594
24671	38408	3	applied	\N	\N	\N	\N	118595	118595	118596
24676	38424	0	applied	\N	\N	\N	\N	118631	118631	118632
24676	38425	1	applied	\N	\N	\N	\N	118633	118633	118634
24676	38426	2	applied	\N	\N	\N	\N	118635	118635	118636
24676	38427	3	applied	\N	\N	\N	\N	118637	118637	118638
24678	38428	0	applied	\N	\N	\N	\N	118643	118643	118644
24678	38429	1	applied	\N	\N	\N	\N	118645	118645	118646
24678	38430	2	applied	\N	\N	\N	\N	118647	118647	118648
24682	38439	0	applied	\N	\N	\N	\N	118669	118669	118670
24682	38440	1	applied	\N	\N	\N	\N	118671	118671	118672
24682	38441	2	applied	\N	\N	\N	\N	118673	118673	118674
24682	38442	3	applied	\N	\N	\N	\N	118675	118675	118676
24682	38443	4	applied	\N	\N	\N	\N	118677	118677	118678
24682	38444	6	applied	\N	\N	\N	\N	118680	118680	118681
24682	38445	7	applied	\N	\N	\N	\N	118682	118682	118683
24682	38446	8	applied	\N	\N	\N	\N	118684	118684	118685
24682	38447	9	applied	\N	\N	\N	\N	118686	118686	118687
24682	38448	10	applied	\N	\N	\N	\N	118688	118688	118689
24682	38449	11	applied	\N	\N	\N	\N	118690	118690	118691
24687	38463	0	applied	\N	\N	\N	\N	118728	118728	118729
24687	38464	1	applied	\N	\N	\N	\N	118730	118730	118731
24687	38465	2	applied	\N	\N	\N	\N	118732	118732	118733
24687	38466	3	applied	\N	\N	\N	\N	118734	118734	118735
24690	38463	0	applied	\N	\N	\N	\N	118728	118728	118729
24690	38464	1	applied	\N	\N	\N	\N	118730	118730	118731
24690	38465	2	applied	\N	\N	\N	\N	118732	118732	118733
24690	38466	3	applied	\N	\N	\N	\N	118734	118734	118735
24698	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24698	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24698	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24698	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24698	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24701	38490	0	applied	\N	\N	\N	\N	118799	118799	118800
24701	38491	1	applied	\N	\N	\N	\N	118801	118801	118802
24701	38492	2	applied	\N	\N	\N	\N	118803	118803	118804
24701	38493	3	applied	\N	\N	\N	\N	118805	118805	118806
24701	38494	4	applied	\N	\N	\N	\N	118807	118807	118808
24701	38495	5	applied	\N	\N	\N	\N	118809	118809	118810
24701	38496	6	applied	\N	\N	\N	\N	118811	118811	118812
24702	38497	0	applied	\N	\N	\N	\N	118814	118814	118815
24702	38498	1	applied	\N	\N	\N	\N	118816	118816	118817
24702	38499	2	applied	\N	\N	\N	\N	118818	118818	118819
24702	38500	3	applied	\N	\N	\N	\N	118820	118820	118821
24702	38501	4	applied	\N	\N	\N	\N	118822	118822	118823
24702	38502	5	applied	\N	\N	\N	\N	118824	118824	118825
24702	38503	6	applied	\N	\N	\N	\N	118826	118826	118827
24702	38504	7	applied	\N	\N	\N	\N	118828	118828	118829
24702	38505	8	applied	\N	\N	\N	\N	118830	118830	118831
24702	38506	9	applied	\N	\N	\N	\N	118832	118832	118833
24702	38507	10	applied	\N	\N	\N	\N	118834	118834	118835
24702	38508	11	applied	\N	\N	\N	\N	118836	118836	118837
24702	38509	12	applied	\N	\N	\N	\N	118838	118838	118839
24702	38510	13	applied	\N	\N	\N	\N	118840	118840	118841
24702	38511	14	applied	\N	\N	\N	\N	118842	118842	118843
24631	38345	0	applied	\N	\N	\N	\N	118407	118407	118408
24631	38346	1	applied	\N	\N	\N	\N	118409	118409	118410
24631	38347	2	applied	\N	\N	\N	\N	118411	118411	118412
24633	38348	0	applied	\N	\N	\N	\N	118417	118417	118418
24633	38349	1	applied	\N	\N	\N	\N	118419	118419	118420
24633	38350	2	applied	\N	\N	\N	\N	118421	118421	118422
24633	38351	3	applied	\N	\N	\N	\N	118423	118423	118424
24633	38352	4	applied	\N	\N	\N	\N	118425	118425	118426
24633	38353	5	applied	\N	\N	\N	\N	118427	118427	118428
24636	38354	0	applied	\N	\N	\N	\N	118430	118430	118431
24636	38355	2	applied	\N	\N	\N	\N	118433	118433	118434
24636	38356	3	applied	\N	\N	\N	\N	118435	118435	118436
24636	38357	4	applied	\N	\N	\N	\N	118437	118437	118438
24639	38358	0	applied	\N	\N	\N	\N	118446	118446	118447
24639	38359	1	applied	\N	\N	\N	\N	118448	118448	118449
24639	38360	2	applied	\N	\N	\N	\N	118450	118450	118451
24639	38361	3	applied	\N	\N	\N	\N	118452	118452	118453
24639	38362	4	applied	\N	\N	\N	\N	118454	118454	118455
24639	38363	5	applied	\N	\N	\N	\N	118456	118456	118456
24639	38364	6	applied	\N	\N	\N	\N	118457	118457	118458
24639	38365	7	applied	\N	\N	\N	\N	118459	118459	118460
24642	38358	0	applied	\N	\N	\N	\N	118446	118446	118447
24642	38359	1	applied	\N	\N	\N	\N	118448	118448	118449
24642	38360	2	applied	\N	\N	\N	\N	118450	118450	118451
24642	38361	3	applied	\N	\N	\N	\N	118452	118452	118453
24642	38362	4	applied	\N	\N	\N	\N	118454	118454	118455
24642	38363	5	applied	\N	\N	\N	\N	118456	118456	118456
24642	38364	6	applied	\N	\N	\N	\N	118457	118457	118458
24642	38365	7	applied	\N	\N	\N	\N	118459	118459	118460
24643	37906	0	applied	\N	\N	\N	\N	117040	117040	117041
24643	38248	1	applied	\N	\N	\N	\N	118367	118367	118133
24643	38335	2	applied	\N	\N	\N	\N	118469	118469	118386
24643	38348	3	applied	\N	\N	\N	\N	118470	118470	118418
24643	37911	4	applied	\N	\N	\N	\N	117051	117051	117052
24643	37919	5	applied	\N	\N	\N	\N	117071	117071	117072
24643	37932	6	applied	\N	\N	\N	\N	117105	117105	117106
24643	38073	7	applied	\N	\N	\N	\N	117559	117559	117560
24643	38358	8	applied	\N	\N	\N	\N	118446	118446	118447
24643	38359	9	applied	\N	\N	\N	\N	118448	118448	118449
24643	38031	10	applied	\N	\N	\N	\N	117440	117440	117441
24643	38074	11	applied	\N	\N	\N	\N	117561	117561	117562
24643	38075	12	applied	\N	\N	\N	\N	117563	117563	117564
24643	38076	13	applied	\N	\N	\N	\N	117565	117565	117566
24643	38291	14	applied	\N	\N	\N	\N	118368	118368	118257
24643	37901	15	applied	\N	\N	\N	\N	117023	117023	117024
24643	38361	16	applied	\N	\N	\N	\N	118452	118452	118453
24643	38362	17	applied	\N	\N	\N	\N	118454	118454	118455
24643	37903	18	applied	\N	\N	\N	\N	117030	117030	117031
24643	37907	19	applied	\N	\N	\N	\N	117042	117042	117043
24643	37908	20	applied	\N	\N	\N	\N	117044	117044	117045
24643	37912	21	applied	\N	\N	\N	\N	117053	117053	117054
24643	37913	22	applied	\N	\N	\N	\N	117055	117055	117056
24643	37917	23	applied	\N	\N	\N	\N	117065	117065	117066
24643	37920	24	applied	\N	\N	\N	\N	117073	117073	117074
24643	37921	25	applied	\N	\N	\N	\N	117075	117075	117076
24643	37922	26	applied	\N	\N	\N	\N	117077	117077	117078
24643	37927	27	applied	\N	\N	\N	\N	117092	117092	117093
24643	37929	28	applied	\N	\N	\N	\N	117097	117097	117098
24643	37933	29	applied	\N	\N	\N	\N	117107	117107	117108
24643	37935	30	applied	\N	\N	\N	\N	117123	117123	117124
24643	37936	31	applied	\N	\N	\N	\N	117129	117129	117130
24643	37939	32	applied	\N	\N	\N	\N	117137	117137	117138
24643	37940	33	applied	\N	\N	\N	\N	117139	117139	117140
24643	37943	34	applied	\N	\N	\N	\N	117147	117147	117148
24643	37944	35	applied	\N	\N	\N	\N	117149	117149	117150
24643	37945	36	applied	\N	\N	\N	\N	117151	117151	117152
24643	37950	37	applied	\N	\N	\N	\N	117164	117164	117165
24643	37952	38	applied	\N	\N	\N	\N	117172	117172	117173
24643	37955	39	applied	\N	\N	\N	\N	117185	117185	117186
24643	37957	40	applied	\N	\N	\N	\N	117203	117203	117204
24643	37959	41	applied	\N	\N	\N	\N	117211	117211	117212
24643	37962	42	applied	\N	\N	\N	\N	117221	117221	117222
24643	37963	43	applied	\N	\N	\N	\N	117223	117223	117224
24643	37965	44	applied	\N	\N	\N	\N	117229	117229	117230
24643	37967	45	applied	\N	\N	\N	\N	117235	117235	117236
24643	37970	46	applied	\N	\N	\N	\N	117244	117244	117245
24643	37972	47	applied	\N	\N	\N	\N	117251	117251	117252
24643	37978	48	applied	\N	\N	\N	\N	117264	117264	117265
24643	37982	49	applied	\N	\N	\N	\N	117274	117274	117275
24643	37983	50	applied	\N	\N	\N	\N	117278	117278	117279
24643	37985	51	applied	\N	\N	\N	\N	117284	117284	117285
24643	37988	52	applied	\N	\N	\N	\N	117290	117290	117291
24643	37990	53	applied	\N	\N	\N	\N	117296	117296	117297
24643	37992	54	applied	\N	\N	\N	\N	117303	117303	117304
24643	37993	55	applied	\N	\N	\N	\N	117305	117305	117306
24643	37994	56	applied	\N	\N	\N	\N	117307	117307	117308
24643	37999	57	applied	\N	\N	\N	\N	117318	117318	117319
24643	38001	58	applied	\N	\N	\N	\N	117326	117326	117327
24643	38004	59	applied	\N	\N	\N	\N	117359	117359	117360
24643	38005	60	applied	\N	\N	\N	\N	117361	117361	117362
24643	38008	61	applied	\N	\N	\N	\N	117371	117371	117372
24643	38009	62	applied	\N	\N	\N	\N	117373	117373	117374
24643	38010	63	applied	\N	\N	\N	\N	117375	117375	117376
24643	38015	64	applied	\N	\N	\N	\N	117386	117386	117387
24643	38017	66	applied	\N	\N	\N	\N	117395	117395	117396
24643	38020	67	applied	\N	\N	\N	\N	117409	117409	117410
24643	38022	68	applied	\N	\N	\N	\N	117416	117416	117417
24643	38023	69	applied	\N	\N	\N	\N	117418	117418	117419
24643	38024	70	applied	\N	\N	\N	\N	117420	117420	117421
24643	38029	71	applied	\N	\N	\N	\N	117434	117434	117435
24643	38032	72	applied	\N	\N	\N	\N	117442	117442	117443
24643	38035	73	applied	\N	\N	\N	\N	117449	117449	117450
24643	38037	74	applied	\N	\N	\N	\N	117455	117455	117456
24643	38039	75	applied	\N	\N	\N	\N	117463	117463	117464
24643	38041	76	applied	\N	\N	\N	\N	117472	117472	117473
24643	38044	77	applied	\N	\N	\N	\N	117479	117479	117480
24643	38045	78	applied	\N	\N	\N	\N	117481	117481	117482
24643	38048	79	applied	\N	\N	\N	\N	117492	117492	117493
24643	38051	80	applied	\N	\N	\N	\N	117502	117502	117503
24643	38052	81	applied	\N	\N	\N	\N	117504	117504	117505
24643	38054	82	applied	\N	\N	\N	\N	117509	117509	117510
24643	38057	83	applied	\N	\N	\N	\N	117518	117518	117519
24643	38058	84	applied	\N	\N	\N	\N	117520	117520	117521
24643	38061	85	applied	\N	\N	\N	\N	117530	117530	117531
24643	38063	86	applied	\N	\N	\N	\N	117536	117536	117537
24643	38066	87	applied	\N	\N	\N	\N	117543	117543	117544
24643	38067	88	applied	\N	\N	\N	\N	117545	117545	117546
24643	38068	89	applied	\N	\N	\N	\N	117547	117547	117548
24643	38077	90	applied	\N	\N	\N	\N	117567	117567	117568
24643	38078	91	applied	\N	\N	\N	\N	117569	117569	117570
24643	38081	92	applied	\N	\N	\N	\N	117577	117577	117578
24643	38084	93	applied	\N	\N	\N	\N	117586	117586	117587
24643	38086	94	applied	\N	\N	\N	\N	117594	117594	117595
24643	38087	95	applied	\N	\N	\N	\N	117596	117596	117597
24643	38090	96	applied	\N	\N	\N	\N	117608	117608	117609
24643	38093	97	applied	\N	\N	\N	\N	117615	117615	117616
24643	38095	98	applied	\N	\N	\N	\N	117621	117621	117622
24643	38096	99	applied	\N	\N	\N	\N	117623	117623	117624
24643	38100	100	applied	\N	\N	\N	\N	117632	117632	117633
24643	38102	101	applied	\N	\N	\N	\N	117638	117638	117639
24643	38104	102	applied	\N	\N	\N	\N	117646	117646	117647
24643	38105	103	applied	\N	\N	\N	\N	117648	117648	117649
24643	38109	104	applied	\N	\N	\N	\N	117658	117658	117659
24643	38110	105	applied	\N	\N	\N	\N	117660	117660	117661
24643	38113	106	applied	\N	\N	\N	\N	117666	117666	117667
24643	38116	107	applied	\N	\N	\N	\N	117674	117674	117675
24643	38117	108	applied	\N	\N	\N	\N	117676	117676	117677
24643	38120	109	applied	\N	\N	\N	\N	117686	117686	117687
24643	38123	110	applied	\N	\N	\N	\N	117694	117694	117695
24643	38125	111	applied	\N	\N	\N	\N	117702	117702	117703
24643	38127	112	applied	\N	\N	\N	\N	117709	117709	117710
24643	38128	113	applied	\N	\N	\N	\N	117711	117711	117712
24643	38132	114	applied	\N	\N	\N	\N	117721	117721	117722
24643	38134	115	applied	\N	\N	\N	\N	117726	117726	117727
24643	38136	116	applied	\N	\N	\N	\N	117730	117730	117731
24643	38139	117	applied	\N	\N	\N	\N	117745	117745	117746
24643	38141	118	applied	\N	\N	\N	\N	117751	117751	117752
24643	38143	119	applied	\N	\N	\N	\N	117757	117757	117758
24643	38144	120	applied	\N	\N	\N	\N	117759	117759	117760
24643	38148	121	applied	\N	\N	\N	\N	117769	117769	117770
24643	38150	122	applied	\N	\N	\N	\N	117779	117779	117780
24643	38151	123	applied	\N	\N	\N	\N	117781	117781	117782
24643	38155	124	applied	\N	\N	\N	\N	117795	117795	117796
24643	38156	125	applied	\N	\N	\N	\N	117797	117797	117798
24654	38374	0	applied	\N	\N	\N	\N	118499	118499	118500
24654	38375	1	applied	\N	\N	\N	\N	118501	118501	118502
24654	38376	2	applied	\N	\N	\N	\N	118503	118503	118504
24654	38377	3	applied	\N	\N	\N	\N	118505	118505	118506
24655	38378	0	applied	\N	\N	\N	\N	118515	118515	118516
24655	38379	1	applied	\N	\N	\N	\N	118517	118517	118518
24655	38380	2	applied	\N	\N	\N	\N	118519	118519	118520
24655	38381	3	applied	\N	\N	\N	\N	118521	118521	118522
24655	38382	4	applied	\N	\N	\N	\N	118523	118523	118524
24655	38383	5	applied	\N	\N	\N	\N	118525	118525	118526
24655	38384	6	applied	\N	\N	\N	\N	118527	118527	118528
24655	38385	7	applied	\N	\N	\N	\N	118529	118529	118530
24655	38386	8	applied	\N	\N	\N	\N	118531	118531	118532
24657	38387	0	applied	\N	\N	\N	\N	118535	118535	118536
24657	38388	1	applied	\N	\N	\N	\N	118537	118537	118538
24657	38389	2	applied	\N	\N	\N	\N	118539	118539	118540
24665	38400	0	applied	\N	\N	\N	\N	118572	118572	118573
24683	38450	0	applied	\N	\N	\N	\N	118697	118697	118698
24683	38451	1	applied	\N	\N	\N	\N	118699	118699	118700
24683	38452	2	applied	\N	\N	\N	\N	118701	118701	118702
24684	38453	0	applied	\N	\N	\N	\N	118705	118705	118706
24684	38454	1	applied	\N	\N	\N	\N	118707	118707	118708
24684	38455	2	applied	\N	\N	\N	\N	118709	118709	118710
24684	38456	3	applied	\N	\N	\N	\N	118711	118711	118712
24684	38457	4	applied	\N	\N	\N	\N	118713	118713	118714
24684	38458	5	applied	\N	\N	\N	\N	118715	118715	118716
24684	38459	6	applied	\N	\N	\N	\N	118717	118717	118718
24684	38460	7	applied	\N	\N	\N	\N	118719	118719	118720
24684	38461	8	applied	\N	\N	\N	\N	118721	118721	118722
24684	38462	9	applied	\N	\N	\N	\N	118723	118723	118724
24691	38467	0	applied	\N	\N	\N	\N	118740	118740	118741
24691	38468	1	applied	\N	\N	\N	\N	118742	118742	118743
24691	38469	2	applied	\N	\N	\N	\N	118744	118744	118745
24691	38470	3	applied	\N	\N	\N	\N	118746	118746	118747
24696	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24696	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24696	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24696	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24696	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24700	38482	0	applied	\N	\N	\N	\N	118782	118782	118783
24700	38483	1	applied	\N	\N	\N	\N	118784	118784	118785
24700	38484	2	applied	\N	\N	\N	\N	118786	118786	118787
24700	38485	3	applied	\N	\N	\N	\N	118788	118788	118789
24700	38486	4	applied	\N	\N	\N	\N	118790	118790	118791
24700	38487	5	applied	\N	\N	\N	\N	118792	118792	118793
24700	38488	6	applied	\N	\N	\N	\N	118794	118794	118795
24700	38489	7	applied	\N	\N	\N	\N	118796	118796	118797
24703	38497	0	applied	\N	\N	\N	\N	118814	118814	118815
24703	38498	1	applied	\N	\N	\N	\N	118816	118816	118817
24703	38499	2	applied	\N	\N	\N	\N	118818	118818	118819
24703	38500	3	applied	\N	\N	\N	\N	118820	118820	118821
24703	38501	4	applied	\N	\N	\N	\N	118822	118822	118823
24703	38502	5	applied	\N	\N	\N	\N	118824	118824	118825
24703	38503	6	applied	\N	\N	\N	\N	118826	118826	118827
24703	38504	7	applied	\N	\N	\N	\N	118828	118828	118829
24703	38505	8	applied	\N	\N	\N	\N	118830	118830	118831
24703	38506	9	applied	\N	\N	\N	\N	118832	118832	118833
24703	38507	10	applied	\N	\N	\N	\N	118834	118834	118835
24703	38508	11	applied	\N	\N	\N	\N	118836	118836	118837
24703	38509	12	applied	\N	\N	\N	\N	118838	118838	118839
24703	38510	13	applied	\N	\N	\N	\N	118840	118840	118841
24703	38511	14	applied	\N	\N	\N	\N	118842	118842	118843
24703	38512	15	applied	\N	\N	\N	\N	118844	118844	118845
24703	38513	16	applied	\N	\N	\N	\N	118846	118846	118847
24703	38514	17	applied	\N	\N	\N	\N	118848	118848	118849
24703	38515	18	applied	\N	\N	\N	\N	118850	118850	118851
24703	38516	19	applied	\N	\N	\N	\N	118852	118852	118853
24703	38517	20	applied	\N	\N	\N	\N	118854	118854	118855
24703	38518	21	applied	\N	\N	\N	\N	118856	118856	118857
24703	38519	22	applied	\N	\N	\N	\N	118858	118858	118859
24703	38520	23	applied	\N	\N	\N	\N	118860	118860	118861
24703	38521	24	applied	\N	\N	\N	\N	118862	118862	118863
24703	38522	25	applied	\N	\N	\N	\N	118864	118864	118865
24703	38523	26	applied	\N	\N	\N	\N	118866	118866	118867
24710	38541	0	applied	\N	\N	\N	\N	118910	118910	118911
24710	38542	1	applied	\N	\N	\N	\N	118912	118912	118913
24710	38543	2	applied	\N	\N	\N	\N	118914	118914	118915
24710	38544	3	applied	\N	\N	\N	\N	118916	118916	118917
24710	38545	4	applied	\N	\N	\N	\N	118918	118918	118919
24710	38546	5	applied	\N	\N	\N	\N	118920	118920	118921
24710	38547	7	applied	\N	\N	\N	\N	118923	118923	118924
24710	38548	8	applied	\N	\N	\N	\N	118925	118925	118926
24720	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24720	38574	1	applied	\N	\N	\N	\N	118997	118997	118998
24720	38575	2	applied	\N	\N	\N	\N	118999	118999	119000
24720	38576	3	applied	\N	\N	\N	\N	119001	119001	119002
24692	38473	2	applied	\N	\N	\N	\N	118752	118752	118753
24692	38474	3	applied	\N	\N	\N	\N	118754	118754	118755
24692	38475	4	applied	\N	\N	\N	\N	118756	118756	118757
24692	38476	5	applied	\N	\N	\N	\N	118758	118758	118759
24694	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24694	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24694	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24694	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24694	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24697	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24697	38478	1	applied	\N	\N	\N	\N	118766	118766	118767
24697	38479	2	applied	\N	\N	\N	\N	118768	118768	118769
24697	38480	3	applied	\N	\N	\N	\N	118770	118770	118771
24697	38481	4	applied	\N	\N	\N	\N	118772	118772	118773
24704	38497	0	applied	\N	\N	\N	\N	118814	118814	118815
24704	38498	1	applied	\N	\N	\N	\N	118816	118816	118817
24704	38499	2	applied	\N	\N	\N	\N	118818	118818	118819
24704	38500	3	applied	\N	\N	\N	\N	118820	118820	118821
24704	38501	4	applied	\N	\N	\N	\N	118822	118822	118823
24704	38502	5	applied	\N	\N	\N	\N	118824	118824	118825
24704	38503	6	applied	\N	\N	\N	\N	118826	118826	118827
24704	38504	7	applied	\N	\N	\N	\N	118828	118828	118829
24704	38505	8	applied	\N	\N	\N	\N	118830	118830	118831
24704	38506	9	applied	\N	\N	\N	\N	118832	118832	118833
24704	38507	10	applied	\N	\N	\N	\N	118834	118834	118835
24704	38508	11	applied	\N	\N	\N	\N	118836	118836	118837
24704	38509	12	applied	\N	\N	\N	\N	118838	118838	118839
24704	38510	13	applied	\N	\N	\N	\N	118840	118840	118841
24704	38511	14	applied	\N	\N	\N	\N	118842	118842	118843
24704	38512	15	applied	\N	\N	\N	\N	118844	118844	118845
24704	38513	16	applied	\N	\N	\N	\N	118846	118846	118847
24704	38514	17	applied	\N	\N	\N	\N	118848	118848	118849
24704	38515	18	applied	\N	\N	\N	\N	118850	118850	118851
24704	38516	19	applied	\N	\N	\N	\N	118852	118852	118853
24704	38517	20	applied	\N	\N	\N	\N	118854	118854	118855
24704	38518	21	applied	\N	\N	\N	\N	118856	118856	118857
24704	38519	22	applied	\N	\N	\N	\N	118858	118858	118859
24704	38520	23	applied	\N	\N	\N	\N	118860	118860	118861
24704	38521	24	applied	\N	\N	\N	\N	118862	118862	118863
24704	38522	25	applied	\N	\N	\N	\N	118864	118864	118865
24704	38523	26	applied	\N	\N	\N	\N	118866	118866	118867
24708	38541	0	applied	\N	\N	\N	\N	118910	118910	118911
24708	38542	1	applied	\N	\N	\N	\N	118912	118912	118913
24708	38543	2	applied	\N	\N	\N	\N	118914	118914	118915
24708	38544	3	applied	\N	\N	\N	\N	118916	118916	118917
24708	38545	4	applied	\N	\N	\N	\N	118918	118918	118919
24708	38546	5	applied	\N	\N	\N	\N	118920	118920	118921
24708	38547	7	applied	\N	\N	\N	\N	118923	118923	118924
24708	38548	8	applied	\N	\N	\N	\N	118925	118925	118926
24713	38549	0	applied	\N	\N	\N	\N	118934	118934	118935
24713	38550	1	applied	\N	\N	\N	\N	118936	118936	118937
24713	38551	2	applied	\N	\N	\N	\N	118938	118938	118939
24713	38552	3	applied	\N	\N	\N	\N	118940	118940	118941
24713	38553	4	applied	\N	\N	\N	\N	118942	118942	118943
24713	38554	5	applied	\N	\N	\N	\N	118944	118944	118945
24713	38555	6	applied	\N	\N	\N	\N	118946	118946	118947
24716	38563	0	applied	\N	\N	\N	\N	118969	118969	118970
24716	38556	1	applied	\N	\N	\N	\N	118952	118952	118953
24716	38558	2	applied	\N	\N	\N	\N	118956	118956	118957
24716	38559	3	applied	\N	\N	\N	\N	118958	118958	118959
24716	38560	4	applied	\N	\N	\N	\N	118960	118960	118961
24716	38564	5	applied	\N	\N	\N	\N	118971	118971	118972
24716	38565	6	applied	\N	\N	\N	\N	118973	118973	118974
24718	38566	0	applied	\N	\N	\N	\N	118979	118979	118980
24718	38567	1	applied	\N	\N	\N	\N	118981	118981	118982
24718	38568	2	applied	\N	\N	\N	\N	118983	118983	118984
24718	38565	3	applied	\N	\N	\N	\N	118973	118973	118974
24718	38569	4	applied	\N	\N	\N	\N	118985	118985	118986
24718	38570	5	applied	\N	\N	\N	\N	118987	118987	118988
24718	38571	6	applied	\N	\N	\N	\N	118989	118989	118990
24718	38572	7	applied	\N	\N	\N	\N	118991	118991	118992
24721	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24721	38574	1	applied	\N	\N	\N	\N	118997	118997	118998
24721	38575	2	applied	\N	\N	\N	\N	118999	118999	119000
24721	38576	3	applied	\N	\N	\N	\N	119001	119001	119002
24721	38577	4	applied	\N	\N	\N	\N	119003	119003	119004
24721	38578	5	applied	\N	\N	\N	\N	119005	119005	119006
24721	38579	6	applied	\N	\N	\N	\N	119007	119007	119008
24721	38580	7	applied	\N	\N	\N	\N	119009	119009	119010
24723	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24723	38581	1	applied	\N	\N	\N	\N	119016	119016	119017
24723	38582	2	applied	\N	\N	\N	\N	119018	119018	119019
24723	38583	3	applied	\N	\N	\N	\N	119020	119020	119021
24723	38584	4	applied	\N	\N	\N	\N	119022	119022	119023
24723	38574	5	applied	\N	\N	\N	\N	118997	118997	118998
24723	38575	6	applied	\N	\N	\N	\N	118999	118999	119000
24723	38576	7	applied	\N	\N	\N	\N	119001	119001	119002
24723	38577	8	applied	\N	\N	\N	\N	119003	119003	119004
24723	38578	9	applied	\N	\N	\N	\N	119005	119005	119006
24723	38585	10	applied	\N	\N	\N	\N	119024	119024	119025
24723	38586	11	applied	\N	\N	\N	\N	119026	119026	119027
24723	38587	12	applied	\N	\N	\N	\N	119028	119028	119029
24723	38588	13	applied	\N	\N	\N	\N	119030	119030	119031
24723	38589	14	applied	\N	\N	\N	\N	119032	119032	119033
24723	38590	15	applied	\N	\N	\N	\N	119034	119034	119035
24723	38591	16	applied	\N	\N	\N	\N	119036	119036	119037
24723	38592	17	applied	\N	\N	\N	\N	119038	119038	119039
24723	38593	18	applied	\N	\N	\N	\N	119040	119040	119041
24723	38594	19	applied	\N	\N	\N	\N	119042	119042	119043
24723	38595	20	applied	\N	\N	\N	\N	119044	119044	119045
24723	38596	21	applied	\N	\N	\N	\N	119046	119046	119047
24723	38597	22	applied	\N	\N	\N	\N	119048	119048	119049
24723	38598	23	applied	\N	\N	\N	\N	119050	119050	119051
24723	38599	24	applied	\N	\N	\N	\N	119052	119052	119053
24723	38600	25	applied	\N	\N	\N	\N	119054	119054	119055
24723	38601	26	applied	\N	\N	\N	\N	119056	119056	119057
24723	38602	27	applied	\N	\N	\N	\N	119058	119058	119059
24723	38603	28	applied	\N	\N	\N	\N	119060	119060	119061
24723	38604	29	applied	\N	\N	\N	\N	119062	119062	119063
24723	38605	30	applied	\N	\N	\N	\N	119064	119064	119065
24723	38606	31	applied	\N	\N	\N	\N	119066	119066	119067
24723	38607	32	applied	\N	\N	\N	\N	119068	119068	119069
24723	38579	33	applied	\N	\N	\N	\N	119007	119007	119008
24723	38580	34	applied	\N	\N	\N	\N	119009	119009	119010
24723	38608	35	applied	\N	\N	\N	\N	119070	119070	119071
24723	38609	36	applied	\N	\N	\N	\N	119072	119072	119073
24723	38610	37	applied	\N	\N	\N	\N	119074	119074	119075
24723	38611	38	applied	\N	\N	\N	\N	119076	119076	119077
24723	38612	39	applied	\N	\N	\N	\N	119078	119078	119079
24723	38613	40	applied	\N	\N	\N	\N	119080	119080	119081
24702	38512	15	applied	\N	\N	\N	\N	118844	118844	118845
24702	38513	16	applied	\N	\N	\N	\N	118846	118846	118847
24702	38514	17	applied	\N	\N	\N	\N	118848	118848	118849
24702	38515	18	applied	\N	\N	\N	\N	118850	118850	118851
24702	38516	19	applied	\N	\N	\N	\N	118852	118852	118853
24702	38517	20	applied	\N	\N	\N	\N	118854	118854	118855
24702	38518	21	applied	\N	\N	\N	\N	118856	118856	118857
24702	38519	22	applied	\N	\N	\N	\N	118858	118858	118859
24702	38520	23	applied	\N	\N	\N	\N	118860	118860	118861
24702	38521	24	applied	\N	\N	\N	\N	118862	118862	118863
24702	38522	25	applied	\N	\N	\N	\N	118864	118864	118865
24702	38523	26	applied	\N	\N	\N	\N	118866	118866	118867
24705	38497	0	applied	\N	\N	\N	\N	118814	118814	118815
24705	38498	1	applied	\N	\N	\N	\N	118816	118816	118817
24705	38499	2	applied	\N	\N	\N	\N	118818	118818	118819
24705	38500	3	applied	\N	\N	\N	\N	118820	118820	118821
24705	38501	4	applied	\N	\N	\N	\N	118822	118822	118823
24705	38502	5	applied	\N	\N	\N	\N	118824	118824	118825
24705	38503	6	applied	\N	\N	\N	\N	118826	118826	118827
24705	38504	7	applied	\N	\N	\N	\N	118828	118828	118829
24705	38505	8	applied	\N	\N	\N	\N	118830	118830	118831
24705	38506	9	applied	\N	\N	\N	\N	118832	118832	118833
24705	38507	10	applied	\N	\N	\N	\N	118834	118834	118835
24705	38508	11	applied	\N	\N	\N	\N	118836	118836	118837
24705	38509	12	applied	\N	\N	\N	\N	118838	118838	118839
24705	38510	13	applied	\N	\N	\N	\N	118840	118840	118841
24705	38511	14	applied	\N	\N	\N	\N	118842	118842	118843
24705	38512	15	applied	\N	\N	\N	\N	118844	118844	118845
24705	38513	16	applied	\N	\N	\N	\N	118846	118846	118847
24705	38514	17	applied	\N	\N	\N	\N	118848	118848	118849
24705	38515	18	applied	\N	\N	\N	\N	118850	118850	118851
24705	38516	19	applied	\N	\N	\N	\N	118852	118852	118853
24705	38517	20	applied	\N	\N	\N	\N	118854	118854	118855
24705	38518	21	applied	\N	\N	\N	\N	118856	118856	118857
24705	38519	22	applied	\N	\N	\N	\N	118858	118858	118859
24705	38520	23	applied	\N	\N	\N	\N	118860	118860	118861
24705	38521	24	applied	\N	\N	\N	\N	118862	118862	118863
24705	38522	25	applied	\N	\N	\N	\N	118864	118864	118865
24705	38523	26	applied	\N	\N	\N	\N	118866	118866	118867
24706	38524	0	applied	\N	\N	\N	\N	118873	118873	118874
24706	38525	1	applied	\N	\N	\N	\N	118875	118875	118876
24706	38526	2	applied	\N	\N	\N	\N	118877	118877	118878
24706	38527	3	applied	\N	\N	\N	\N	118879	118879	118880
24706	38528	4	applied	\N	\N	\N	\N	118881	118881	118882
24706	38529	5	applied	\N	\N	\N	\N	118883	118883	118884
24706	38530	6	applied	\N	\N	\N	\N	118885	118885	118886
24709	38544	0	applied	\N	\N	\N	\N	118916	118916	118917
24709	38547	1	applied	\N	\N	\N	\N	118923	118923	118924
24709	38548	2	applied	\N	\N	\N	\N	118925	118925	118926
24711	38549	0	applied	\N	\N	\N	\N	118934	118934	118935
24711	38550	1	applied	\N	\N	\N	\N	118936	118936	118937
24711	38551	2	applied	\N	\N	\N	\N	118938	118938	118939
24711	38552	3	applied	\N	\N	\N	\N	118940	118940	118941
24711	38553	4	applied	\N	\N	\N	\N	118942	118942	118943
24711	38554	5	applied	\N	\N	\N	\N	118944	118944	118945
24711	38555	6	applied	\N	\N	\N	\N	118946	118946	118947
24714	38556	0	applied	\N	\N	\N	\N	118952	118952	118953
24714	38557	1	applied	\N	\N	\N	\N	118954	118954	118955
24714	38558	2	applied	\N	\N	\N	\N	118956	118956	118957
24714	38559	3	applied	\N	\N	\N	\N	118958	118958	118959
24714	38560	4	applied	\N	\N	\N	\N	118960	118960	118961
24714	38561	5	applied	\N	\N	\N	\N	118962	118962	118963
24714	38562	6	applied	\N	\N	\N	\N	118964	118964	118965
24724	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24724	38581	1	applied	\N	\N	\N	\N	119016	119016	119017
24724	38582	2	applied	\N	\N	\N	\N	119018	119018	119019
24724	38583	3	applied	\N	\N	\N	\N	119020	119020	119021
24724	38584	4	applied	\N	\N	\N	\N	119022	119022	119023
24724	38574	5	applied	\N	\N	\N	\N	118997	118997	118998
24724	38575	6	applied	\N	\N	\N	\N	118999	118999	119000
24724	38576	7	applied	\N	\N	\N	\N	119001	119001	119002
24724	38577	8	applied	\N	\N	\N	\N	119003	119003	119004
24724	38578	9	applied	\N	\N	\N	\N	119005	119005	119006
24724	38585	10	applied	\N	\N	\N	\N	119024	119024	119025
24724	38586	11	applied	\N	\N	\N	\N	119026	119026	119027
24724	38587	12	applied	\N	\N	\N	\N	119028	119028	119029
24724	38588	13	applied	\N	\N	\N	\N	119030	119030	119031
24724	38589	14	applied	\N	\N	\N	\N	119032	119032	119033
24724	38590	15	applied	\N	\N	\N	\N	119034	119034	119035
24724	38591	16	applied	\N	\N	\N	\N	119036	119036	119037
24724	38592	17	applied	\N	\N	\N	\N	119038	119038	119039
24724	38593	18	applied	\N	\N	\N	\N	119040	119040	119041
24724	38594	19	applied	\N	\N	\N	\N	119042	119042	119043
24724	38595	20	applied	\N	\N	\N	\N	119044	119044	119045
24724	38596	21	applied	\N	\N	\N	\N	119046	119046	119047
24724	38597	22	applied	\N	\N	\N	\N	119048	119048	119049
24724	38598	23	applied	\N	\N	\N	\N	119050	119050	119051
24724	38599	24	applied	\N	\N	\N	\N	119052	119052	119053
24724	38600	25	applied	\N	\N	\N	\N	119054	119054	119055
24724	38601	26	applied	\N	\N	\N	\N	119056	119056	119057
24724	38602	27	applied	\N	\N	\N	\N	119058	119058	119059
24724	38603	28	applied	\N	\N	\N	\N	119060	119060	119061
24724	38604	29	applied	\N	\N	\N	\N	119062	119062	119063
24724	38605	30	applied	\N	\N	\N	\N	119064	119064	119065
24724	38606	31	applied	\N	\N	\N	\N	119066	119066	119067
24724	38607	32	applied	\N	\N	\N	\N	119068	119068	119069
24724	38579	33	applied	\N	\N	\N	\N	119007	119007	119008
24724	38580	34	applied	\N	\N	\N	\N	119009	119009	119010
24724	38608	35	applied	\N	\N	\N	\N	119070	119070	119071
24724	38609	36	applied	\N	\N	\N	\N	119072	119072	119073
24724	38610	37	applied	\N	\N	\N	\N	119074	119074	119075
24724	38611	38	applied	\N	\N	\N	\N	119076	119076	119077
24724	38612	39	applied	\N	\N	\N	\N	119078	119078	119079
24724	38613	40	applied	\N	\N	\N	\N	119080	119080	119081
24724	38614	41	applied	\N	\N	\N	\N	119082	119082	119083
24724	38615	42	applied	\N	\N	\N	\N	119084	119084	119085
24724	38616	43	applied	\N	\N	\N	\N	119086	119086	119087
24726	38617	0	applied	\N	\N	\N	\N	119094	119094	119095
24726	38618	1	applied	\N	\N	\N	\N	119096	119096	119097
24726	38619	2	applied	\N	\N	\N	\N	119098	119098	119099
24726	38620	3	applied	\N	\N	\N	\N	119100	119100	119101
24726	38621	4	applied	\N	\N	\N	\N	119102	119102	119103
24726	38622	5	applied	\N	\N	\N	\N	119104	119104	119105
24726	38623	6	applied	\N	\N	\N	\N	119106	119106	119107
24726	38624	7	applied	\N	\N	\N	\N	119108	119108	119109
24726	38625	8	applied	\N	\N	\N	\N	119110	119110	119111
24726	38626	9	applied	\N	\N	\N	\N	119112	119112	119113
24726	38627	10	applied	\N	\N	\N	\N	119114	119114	119115
24726	38628	11	applied	\N	\N	\N	\N	119116	119116	119117
24726	38629	12	applied	\N	\N	\N	\N	119118	119118	119119
24712	38552	3	applied	\N	\N	\N	\N	118940	118940	118941
24712	38553	4	applied	\N	\N	\N	\N	118942	118942	118943
24712	38554	5	applied	\N	\N	\N	\N	118944	118944	118945
24712	38555	6	applied	\N	\N	\N	\N	118946	118946	118947
24715	38557	0	applied	\N	\N	\N	\N	118954	118954	118955
24715	38561	1	applied	\N	\N	\N	\N	118962	118962	118963
24715	38562	2	applied	\N	\N	\N	\N	118964	118964	118965
24717	38563	0	applied	\N	\N	\N	\N	118969	118969	118970
24717	38556	1	applied	\N	\N	\N	\N	118952	118952	118953
24717	38558	2	applied	\N	\N	\N	\N	118956	118956	118957
24717	38559	3	applied	\N	\N	\N	\N	118958	118958	118959
24717	38560	4	applied	\N	\N	\N	\N	118960	118960	118961
24717	38564	5	applied	\N	\N	\N	\N	118971	118971	118972
24719	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24719	38574	1	applied	\N	\N	\N	\N	118997	118997	118998
24719	38575	2	applied	\N	\N	\N	\N	118999	118999	119000
24719	38576	3	applied	\N	\N	\N	\N	119001	119001	119002
24719	38577	4	applied	\N	\N	\N	\N	119003	119003	119004
24719	38578	5	applied	\N	\N	\N	\N	119005	119005	119006
24719	38579	6	applied	\N	\N	\N	\N	119007	119007	119008
24719	38580	7	applied	\N	\N	\N	\N	119009	119009	119010
24725	38573	0	applied	\N	\N	\N	\N	118995	118995	118996
24725	38581	1	applied	\N	\N	\N	\N	119016	119016	119017
24725	38582	2	applied	\N	\N	\N	\N	119018	119018	119019
24725	38583	3	applied	\N	\N	\N	\N	119020	119020	119021
24725	38584	4	applied	\N	\N	\N	\N	119022	119022	119023
24725	38574	5	applied	\N	\N	\N	\N	118997	118997	118998
24725	38575	6	applied	\N	\N	\N	\N	118999	118999	119000
24725	38576	7	applied	\N	\N	\N	\N	119001	119001	119002
24725	38577	8	applied	\N	\N	\N	\N	119003	119003	119004
24725	38578	9	applied	\N	\N	\N	\N	119005	119005	119006
24725	38585	10	applied	\N	\N	\N	\N	119024	119024	119025
24725	38586	11	applied	\N	\N	\N	\N	119026	119026	119027
24725	38587	12	applied	\N	\N	\N	\N	119028	119028	119029
24725	38588	13	applied	\N	\N	\N	\N	119030	119030	119031
24725	38589	14	applied	\N	\N	\N	\N	119032	119032	119033
24725	38590	15	applied	\N	\N	\N	\N	119034	119034	119035
24725	38591	16	applied	\N	\N	\N	\N	119036	119036	119037
24725	38592	17	applied	\N	\N	\N	\N	119038	119038	119039
24725	38593	18	applied	\N	\N	\N	\N	119040	119040	119041
24725	38594	19	applied	\N	\N	\N	\N	119042	119042	119043
24725	38595	20	applied	\N	\N	\N	\N	119044	119044	119045
24725	38596	21	applied	\N	\N	\N	\N	119046	119046	119047
24725	38597	22	applied	\N	\N	\N	\N	119048	119048	119049
24725	38598	23	applied	\N	\N	\N	\N	119050	119050	119051
24725	38599	24	applied	\N	\N	\N	\N	119052	119052	119053
24725	38600	25	applied	\N	\N	\N	\N	119054	119054	119055
24725	38601	26	applied	\N	\N	\N	\N	119056	119056	119057
24725	38602	27	applied	\N	\N	\N	\N	119058	119058	119059
24725	38603	28	applied	\N	\N	\N	\N	119060	119060	119061
24725	38604	29	applied	\N	\N	\N	\N	119062	119062	119063
24725	38605	30	applied	\N	\N	\N	\N	119064	119064	119065
24725	38606	31	applied	\N	\N	\N	\N	119066	119066	119067
24725	38607	32	applied	\N	\N	\N	\N	119068	119068	119069
24725	38579	33	applied	\N	\N	\N	\N	119007	119007	119008
24725	38580	34	applied	\N	\N	\N	\N	119009	119009	119010
24725	38608	35	applied	\N	\N	\N	\N	119070	119070	119071
24725	38609	36	applied	\N	\N	\N	\N	119072	119072	119073
24725	38610	37	applied	\N	\N	\N	\N	119074	119074	119075
24725	38611	38	applied	\N	\N	\N	\N	119076	119076	119077
24725	38612	39	applied	\N	\N	\N	\N	119078	119078	119079
24725	38613	40	applied	\N	\N	\N	\N	119080	119080	119081
24725	38614	41	applied	\N	\N	\N	\N	119082	119082	119083
24725	38615	42	applied	\N	\N	\N	\N	119084	119084	119085
24725	38616	43	applied	\N	\N	\N	\N	119086	119086	119087
24727	38634	0	applied	\N	\N	\N	\N	119130	119130	119131
24727	38635	1	applied	\N	\N	\N	\N	119132	119132	119133
24727	38636	2	applied	\N	\N	\N	\N	119134	119134	119135
24727	38637	3	applied	\N	\N	\N	\N	119136	119136	119137
24727	38638	4	applied	\N	\N	\N	\N	119138	119138	119139
24727	38639	5	applied	\N	\N	\N	\N	119140	119140	119141
24729	38640	0	applied	\N	\N	\N	\N	119144	119144	119145
24729	38641	1	applied	\N	\N	\N	\N	119146	119146	119147
24729	38642	2	applied	\N	\N	\N	\N	119148	119148	119149
24734	38650	0	applied	\N	\N	\N	\N	119171	119171	119172
24734	38651	1	applied	\N	\N	\N	\N	119173	119173	119174
24734	38652	2	applied	\N	\N	\N	\N	119175	119175	119176
24734	38653	4	applied	\N	\N	\N	\N	119178	119178	119179
24734	38654	5	applied	\N	\N	\N	\N	119180	119180	119181
24734	38655	6	applied	\N	\N	\N	\N	119182	119182	119183
24734	38656	7	applied	\N	\N	\N	\N	119184	119184	119185
24734	38657	8	applied	\N	\N	\N	\N	119186	119186	119187
24736	38650	0	applied	\N	\N	\N	\N	119171	119171	119172
24736	38651	1	applied	\N	\N	\N	\N	119173	119173	119174
24736	38653	2	applied	\N	\N	\N	\N	119178	119178	119179
24736	38654	4	applied	\N	\N	\N	\N	119180	119180	119181
24736	38655	5	applied	\N	\N	\N	\N	119182	119182	119183
24736	38656	6	applied	\N	\N	\N	\N	119184	119184	119185
24736	38657	7	applied	\N	\N	\N	\N	119186	119186	119187
24746	38698	0	applied	\N	\N	\N	\N	119289	119289	119290
24746	38699	1	applied	\N	\N	\N	\N	119291	119291	119292
24746	38700	2	applied	\N	\N	\N	\N	119293	119293	119294
24746	38701	3	applied	\N	\N	\N	\N	119295	119295	119296
24746	38702	4	applied	\N	\N	\N	\N	119297	119297	119298
24746	38703	5	applied	\N	\N	\N	\N	119299	119299	119300
24746	38704	6	applied	\N	\N	\N	\N	119301	119301	119302
24746	38705	7	applied	\N	\N	\N	\N	119303	119303	119304
24749	38710	0	applied	\N	\N	\N	\N	119319	119319	119320
24749	38711	1	applied	\N	\N	\N	\N	119321	119321	119322
24749	38712	2	applied	\N	\N	\N	\N	119323	119323	119324
24749	38713	3	applied	\N	\N	\N	\N	119325	119325	119326
24749	38714	4	applied	\N	\N	\N	\N	119327	119327	119328
24749	38715	5	applied	\N	\N	\N	\N	119329	119329	119330
24749	38716	6	applied	\N	\N	\N	\N	119331	119331	119332
24749	38717	7	applied	\N	\N	\N	\N	119333	119333	119334
24752	38726	0	applied	\N	\N	\N	\N	119355	119355	119356
24752	38727	1	applied	\N	\N	\N	\N	119357	119357	119358
24752	38728	2	applied	\N	\N	\N	\N	119359	119359	119360
24752	38729	3	applied	\N	\N	\N	\N	119361	119361	119362
24754	38730	0	applied	\N	\N	\N	\N	119367	119367	119368
24754	38731	1	applied	\N	\N	\N	\N	119369	119369	119370
24754	38732	2	applied	\N	\N	\N	\N	119371	119371	119372
24758	38730	0	applied	\N	\N	\N	\N	119367	119367	119368
24758	38731	1	applied	\N	\N	\N	\N	119369	119369	119370
24758	38732	2	applied	\N	\N	\N	\N	119371	119371	119372
24761	38733	0	applied	\N	\N	\N	\N	119378	119378	119379
24761	38734	1	applied	\N	\N	\N	\N	119380	119380	119381
24761	38735	2	applied	\N	\N	\N	\N	119382	119382	119383
24761	38736	3	applied	\N	\N	\N	\N	119384	119384	119385
24761	38737	4	applied	\N	\N	\N	\N	119386	119386	119387
24720	38577	4	applied	\N	\N	\N	\N	119003	119003	119004
24720	38578	5	applied	\N	\N	\N	\N	119005	119005	119006
24720	38579	6	applied	\N	\N	\N	\N	119007	119007	119008
24720	38580	7	applied	\N	\N	\N	\N	119009	119009	119010
24732	38643	0	applied	\N	\N	\N	\N	119155	119155	119156
24732	38644	1	applied	\N	\N	\N	\N	119157	119157	119158
24732	38645	2	applied	\N	\N	\N	\N	119159	119159	119160
24732	38646	3	applied	\N	\N	\N	\N	119161	119161	119162
24732	38647	4	applied	\N	\N	\N	\N	119163	119163	119164
24732	38648	5	applied	\N	\N	\N	\N	119165	119165	119166
24732	38649	6	applied	\N	\N	\N	\N	119167	119167	119168
24735	38650	0	applied	\N	\N	\N	\N	119171	119171	119172
24735	38651	1	applied	\N	\N	\N	\N	119173	119173	119174
24735	38653	2	applied	\N	\N	\N	\N	119178	119178	119179
24735	38654	4	applied	\N	\N	\N	\N	119180	119180	119181
24735	38655	5	applied	\N	\N	\N	\N	119182	119182	119183
24735	38656	6	applied	\N	\N	\N	\N	119184	119184	119185
24735	38657	7	applied	\N	\N	\N	\N	119186	119186	119187
24737	38658	0	applied	\N	\N	\N	\N	119194	119194	119195
24737	38652	1	applied	\N	\N	\N	\N	119175	119175	119176
24737	38659	2	applied	\N	\N	\N	\N	119196	119196	119197
24737	38660	3	applied	\N	\N	\N	\N	119198	119198	119199
24737	38661	4	applied	\N	\N	\N	\N	119200	119200	119201
24737	38662	5	applied	\N	\N	\N	\N	119202	119202	119203
24737	38663	6	applied	\N	\N	\N	\N	119204	119204	119205
24737	38664	7	applied	\N	\N	\N	\N	119206	119206	119207
24739	38665	0	applied	\N	\N	\N	\N	119211	119211	119212
24739	38666	1	applied	\N	\N	\N	\N	119213	119213	119214
24739	38667	2	applied	\N	\N	\N	\N	119215	119215	119216
24739	38668	3	applied	\N	\N	\N	\N	119217	119217	119218
24739	38669	4	applied	\N	\N	\N	\N	119219	119219	119220
24739	38670	5	applied	\N	\N	\N	\N	119221	119221	119222
24739	38671	6	applied	\N	\N	\N	\N	119223	119223	119224
24744	38690	0	applied	\N	\N	\N	\N	119269	119269	119270
24744	38691	1	applied	\N	\N	\N	\N	119271	119271	119272
24744	38692	2	applied	\N	\N	\N	\N	119273	119273	119274
24744	38693	3	applied	\N	\N	\N	\N	119275	119275	119276
24744	38694	4	applied	\N	\N	\N	\N	119277	119277	119278
24744	38695	5	applied	\N	\N	\N	\N	119279	119279	119280
24744	38696	6	applied	\N	\N	\N	\N	119281	119281	119282
24744	38697	7	applied	\N	\N	\N	\N	119283	119283	119284
24747	38698	0	applied	\N	\N	\N	\N	119289	119289	119290
24747	38699	1	applied	\N	\N	\N	\N	119291	119291	119292
24747	38700	2	applied	\N	\N	\N	\N	119293	119293	119294
24747	38701	3	applied	\N	\N	\N	\N	119295	119295	119296
24747	38702	4	applied	\N	\N	\N	\N	119297	119297	119298
24747	38703	5	applied	\N	\N	\N	\N	119299	119299	119300
24747	38704	6	applied	\N	\N	\N	\N	119301	119301	119302
24747	38705	7	applied	\N	\N	\N	\N	119303	119303	119304
24753	38726	0	applied	\N	\N	\N	\N	119355	119355	119356
24753	38727	1	applied	\N	\N	\N	\N	119357	119357	119358
24753	38728	2	applied	\N	\N	\N	\N	119359	119359	119360
24753	38729	3	applied	\N	\N	\N	\N	119361	119361	119362
24755	38730	0	applied	\N	\N	\N	\N	119367	119367	119368
24755	38731	1	applied	\N	\N	\N	\N	119369	119369	119370
24755	38732	2	applied	\N	\N	\N	\N	119371	119371	119372
24759	38733	0	applied	\N	\N	\N	\N	119378	119378	119379
24759	38734	1	applied	\N	\N	\N	\N	119380	119380	119381
24759	38735	2	applied	\N	\N	\N	\N	119382	119382	119383
24759	38736	3	applied	\N	\N	\N	\N	119384	119384	119385
24759	38737	4	applied	\N	\N	\N	\N	119386	119386	119387
24759	38738	5	applied	\N	\N	\N	\N	119388	119388	119389
24759	38739	6	applied	\N	\N	\N	\N	119390	119390	119391
24762	38733	0	applied	\N	\N	\N	\N	119378	119378	119379
24762	38734	1	applied	\N	\N	\N	\N	119380	119380	119381
24762	38735	2	applied	\N	\N	\N	\N	119382	119382	119383
24762	38736	3	applied	\N	\N	\N	\N	119384	119384	119385
24762	38737	4	applied	\N	\N	\N	\N	119386	119386	119387
24762	38738	5	applied	\N	\N	\N	\N	119388	119388	119389
24762	38739	6	applied	\N	\N	\N	\N	119390	119390	119391
24765	38750	0	applied	\N	\N	\N	\N	119424	119424	119425
24765	38751	1	applied	\N	\N	\N	\N	119426	119426	119427
24765	38752	2	applied	\N	\N	\N	\N	119428	119428	119429
24765	38753	3	applied	\N	\N	\N	\N	119430	119430	119431
24765	38754	5	applied	\N	\N	\N	\N	119433	119433	119434
24765	38755	6	applied	\N	\N	\N	\N	119435	119435	119436
24765	38756	7	applied	\N	\N	\N	\N	119437	119437	119438
24768	38757	0	applied	\N	\N	\N	\N	119444	119444	119445
24768	38758	1	applied	\N	\N	\N	\N	119446	119446	119447
24769	38760	0	applied	\N	\N	\N	\N	119456	119456	119457
24769	38761	1	applied	\N	\N	\N	\N	119458	119458	119459
24769	38762	2	applied	\N	\N	\N	\N	119460	119460	119461
24775	38770	0	applied	\N	\N	\N	\N	119481	119481	119482
24775	38771	1	applied	\N	\N	\N	\N	119483	119483	119484
24777	38772	0	applied	\N	\N	\N	\N	119487	119487	119488
24777	38773	1	applied	\N	\N	\N	\N	119489	119489	119490
24777	38774	2	applied	\N	\N	\N	\N	119491	119491	119492
24777	38775	3	applied	\N	\N	\N	\N	119493	119493	119494
24780	38782	0	applied	\N	\N	\N	\N	119513	119513	119514
24780	38783	1	applied	\N	\N	\N	\N	119515	119515	119516
24780	38784	2	applied	\N	\N	\N	\N	119517	119517	119518
24780	38785	3	applied	\N	\N	\N	\N	119519	119519	119520
24785	38806	0	applied	\N	\N	\N	\N	119616	119616	119617
24785	38807	1	applied	\N	\N	\N	\N	119618	119618	119619
24785	38808	2	applied	\N	\N	\N	\N	119620	119620	119621
24785	38809	3	applied	\N	\N	\N	\N	119622	119622	119623
24793	38824	0	applied	\N	\N	\N	\N	119659	119659	119672
24793	38825	1	applied	\N	\N	\N	\N	119661	119661	119673
24793	38826	2	applied	\N	\N	\N	\N	119663	119663	119674
24793	38829	3	applied	\N	\N	\N	\N	119669	119669	23829
24795	38830	0	applied	\N	\N	\N	\N	119679	119679	119680
24795	38831	1	applied	\N	\N	\N	\N	119681	119681	119682
24795	38832	2	applied	\N	\N	\N	\N	119683	119683	119684
24795	38833	3	applied	\N	\N	\N	\N	119685	119685	119686
24795	38834	4	applied	\N	\N	\N	\N	119687	119687	119688
24795	38835	5	applied	\N	\N	\N	\N	119689	119689	119690
24795	38836	6	applied	\N	\N	\N	\N	119691	119691	119692
24800	38847	0	applied	\N	\N	1000000000	\N	119722	119722	119723
24800	38848	1	applied	\N	\N	\N	\N	119724	119724	119725
24800	38849	2	applied	\N	\N	\N	\N	119726	119726	119727
24800	38850	3	applied	\N	\N	\N	\N	119728	119728	119729
24803	38859	0	applied	\N	\N	\N	\N	119752	119752	119753
24803	38860	1	applied	\N	\N	\N	\N	119754	119754	119755
24803	38861	2	applied	\N	\N	\N	\N	119756	119756	119757
24803	38862	3	applied	\N	\N	\N	\N	119758	119758	119759
24803	38863	4	applied	\N	\N	\N	\N	119760	119760	119761
24803	38864	5	applied	\N	\N	\N	\N	119762	119762	119763
24805	38865	0	applied	\N	\N	\N	\N	119768	119768	119769
24805	38866	1	applied	\N	\N	\N	\N	119770	119770	119771
24805	38867	2	applied	\N	\N	\N	\N	119772	119772	119773
24723	38614	41	applied	\N	\N	\N	\N	119082	119082	119083
24723	38615	42	applied	\N	\N	\N	\N	119084	119084	119085
24723	38616	43	applied	\N	\N	\N	\N	119086	119086	119087
24728	38640	0	applied	\N	\N	\N	\N	119144	119144	119145
24728	38641	1	applied	\N	\N	\N	\N	119146	119146	119147
24728	38642	2	applied	\N	\N	\N	\N	119148	119148	119149
24738	38658	0	applied	\N	\N	\N	\N	119194	119194	119195
24738	38652	1	applied	\N	\N	\N	\N	119175	119175	119176
24738	38659	2	applied	\N	\N	\N	\N	119196	119196	119197
24738	38660	3	applied	\N	\N	\N	\N	119198	119198	119199
24738	38661	4	applied	\N	\N	\N	\N	119200	119200	119201
24738	38662	5	applied	\N	\N	\N	\N	119202	119202	119203
24738	38663	6	applied	\N	\N	\N	\N	119204	119204	119205
24738	38664	7	applied	\N	\N	\N	\N	119206	119206	119207
24740	38672	0	applied	\N	\N	\N	\N	119227	119227	119228
24740	38673	1	applied	\N	\N	\N	\N	119229	119229	119230
24740	38674	2	applied	\N	\N	\N	\N	119231	119231	119232
24740	38675	3	applied	\N	\N	\N	\N	119233	119233	119234
24740	38676	4	applied	\N	\N	\N	\N	119235	119235	119236
24740	38677	5	applied	\N	\N	\N	\N	119237	119237	119238
24740	38678	6	applied	\N	\N	\N	\N	119239	119239	119240
24740	38679	7	applied	\N	\N	\N	\N	119241	119241	119242
24740	38680	8	applied	\N	\N	\N	\N	119243	119243	119244
24740	38681	9	applied	\N	\N	\N	\N	119245	119245	119246
24740	38682	10	applied	\N	\N	\N	\N	119247	119247	119248
24740	38683	11	applied	\N	\N	\N	\N	119249	119249	119250
24740	38684	12	applied	\N	\N	\N	\N	119251	119251	119252
24740	38685	13	applied	\N	\N	\N	\N	119253	119253	119254
24740	38686	14	applied	\N	\N	\N	\N	119255	119255	119256
24740	38687	15	applied	\N	\N	\N	\N	119257	119257	119258
24740	38688	16	applied	\N	\N	\N	\N	119259	119259	119260
24740	38689	17	applied	\N	\N	\N	\N	119261	119261	119262
24742	38672	0	applied	\N	\N	\N	\N	119227	119227	119228
24742	38673	1	applied	\N	\N	\N	\N	119229	119229	119230
24742	38674	2	applied	\N	\N	\N	\N	119231	119231	119232
24742	38675	3	applied	\N	\N	\N	\N	119233	119233	119234
24742	38676	4	applied	\N	\N	\N	\N	119235	119235	119236
24742	38677	5	applied	\N	\N	\N	\N	119237	119237	119238
24742	38678	6	applied	\N	\N	\N	\N	119239	119239	119240
24742	38679	7	applied	\N	\N	\N	\N	119241	119241	119242
24742	38680	8	applied	\N	\N	\N	\N	119243	119243	119244
24742	38681	9	applied	\N	\N	\N	\N	119245	119245	119246
24742	38682	10	applied	\N	\N	\N	\N	119247	119247	119248
24742	38683	11	applied	\N	\N	\N	\N	119249	119249	119250
24742	38684	12	applied	\N	\N	\N	\N	119251	119251	119252
24742	38685	13	applied	\N	\N	\N	\N	119253	119253	119254
24742	38686	14	applied	\N	\N	\N	\N	119255	119255	119256
24742	38687	15	applied	\N	\N	\N	\N	119257	119257	119258
24742	38688	16	applied	\N	\N	\N	\N	119259	119259	119260
24742	38689	17	applied	\N	\N	\N	\N	119261	119261	119262
24745	38690	0	applied	\N	\N	\N	\N	119269	119269	119270
24745	38691	1	applied	\N	\N	\N	\N	119271	119271	119272
24745	38692	2	applied	\N	\N	\N	\N	119273	119273	119274
24745	38693	3	applied	\N	\N	\N	\N	119275	119275	119276
24745	38694	4	applied	\N	\N	\N	\N	119277	119277	119278
24745	38695	5	applied	\N	\N	\N	\N	119279	119279	119280
24745	38696	6	applied	\N	\N	\N	\N	119281	119281	119282
24745	38697	7	applied	\N	\N	\N	\N	119283	119283	119284
24750	38710	0	applied	\N	\N	\N	\N	119319	119319	119320
24750	38711	1	applied	\N	\N	\N	\N	119321	119321	119322
24750	38712	2	applied	\N	\N	\N	\N	119323	119323	119324
24750	38713	3	applied	\N	\N	\N	\N	119325	119325	119326
24750	38714	4	applied	\N	\N	\N	\N	119327	119327	119328
24750	38715	5	applied	\N	\N	\N	\N	119329	119329	119330
24750	38716	6	applied	\N	\N	\N	\N	119331	119331	119332
24750	38717	7	applied	\N	\N	\N	\N	119333	119333	119334
24756	38730	0	applied	\N	\N	\N	\N	119367	119367	119368
24756	38731	1	applied	\N	\N	\N	\N	119369	119369	119370
24756	38732	2	applied	\N	\N	\N	\N	119371	119371	119372
24763	38740	0	applied	\N	\N	\N	\N	119402	119402	119403
24763	38741	1	applied	\N	\N	\N	\N	119404	119404	119405
24763	38742	2	applied	\N	\N	\N	\N	119406	119406	119407
24763	38743	3	applied	\N	\N	\N	\N	119408	119408	119409
24763	38744	4	applied	\N	\N	\N	\N	119410	119410	119411
24763	38745	5	applied	\N	\N	\N	\N	119412	119412	119413
24763	38746	6	applied	\N	\N	\N	\N	119414	119414	119415
24763	38747	7	applied	\N	\N	\N	\N	119416	119416	119417
24763	38748	8	applied	\N	\N	\N	\N	119418	119418	119419
24763	38749	9	applied	\N	\N	\N	\N	119420	119420	119421
24770	38763	0	applied	\N	\N	\N	\N	119464	119464	119465
24770	38764	1	applied	\N	\N	\N	\N	119466	119466	119467
24770	38765	2	applied	\N	\N	\N	\N	119468	119468	119469
24770	38766	3	applied	\N	\N	\N	\N	119470	119470	119471
24772	38767	0	applied	\N	\N	\N	\N	119475	119475	119476
24772	38768	1	applied	\N	\N	\N	\N	119477	119477	119478
24772	38769	2	applied	\N	\N	\N	\N	119479	119479	119480
24778	38776	0	applied	\N	\N	\N	\N	119498	119498	119499
24778	38777	1	applied	\N	\N	\N	\N	119500	119500	119501
24778	38778	2	applied	\N	\N	\N	\N	119502	119502	119503
24778	38779	3	applied	\N	\N	\N	\N	119504	119504	119505
24778	38780	4	applied	\N	\N	\N	\N	119506	119506	119507
24778	38781	5	applied	\N	\N	\N	\N	119508	119508	119509
24781	38248	0	applied	\N	\N	\N	\N	119522	119522	118133
24781	38335	1	applied	\N	\N	\N	\N	119523	119523	118386
24781	38348	2	applied	\N	\N	\N	\N	119524	119524	118418
24781	38366	3	applied	\N	\N	\N	\N	119525	119525	118475
24781	38374	4	applied	\N	\N	\N	\N	119526	119526	118500
24781	38378	5	applied	\N	\N	\N	\N	119527	119527	118516
24781	38379	6	applied	\N	\N	\N	\N	119528	119528	118518
24781	38477	7	applied	\N	\N	\N	\N	119529	119529	118765
24781	38358	8	applied	\N	\N	\N	\N	118446	118446	118447
24781	38359	9	applied	\N	\N	\N	\N	118448	118448	118449
24781	38291	10	applied	\N	\N	\N	\N	118368	118368	118257
24781	38740	11	applied	\N	\N	\N	\N	119530	119530	119403
24781	38361	12	applied	\N	\N	\N	\N	118452	118452	118453
24781	38362	13	applied	\N	\N	\N	\N	118454	118454	118455
24781	38363	14	applied	\N	\N	\N	\N	118456	118456	118456
24781	38743	15	applied	\N	\N	\N	\N	119531	119531	119409
24781	38744	16	applied	\N	\N	\N	\N	119532	119532	119411
24781	38479	17	applied	\N	\N	\N	\N	119533	119533	118769
24781	38483	18	applied	\N	\N	\N	\N	119534	119534	118785
24781	38484	19	applied	\N	\N	\N	\N	119535	119535	118787
24781	38485	20	applied	\N	\N	\N	\N	119536	119536	118789
24781	38486	21	applied	\N	\N	\N	\N	119537	119537	118791
24781	38487	22	applied	\N	\N	\N	\N	119538	119538	118793
24781	38491	24	applied	\N	\N	\N	\N	119540	119540	118802
24781	38492	25	applied	\N	\N	\N	\N	119541	119541	118804
24781	38493	26	applied	\N	\N	\N	\N	119542	119542	118806
24781	38494	27	applied	\N	\N	\N	\N	119543	119543	118808
24781	38497	28	applied	\N	\N	\N	\N	119544	119544	118815
24726	38630	13	applied	\N	\N	\N	\N	119120	119120	119121
24726	38631	14	applied	\N	\N	\N	\N	119122	119122	119123
24726	38632	15	applied	\N	\N	\N	\N	119124	119124	119125
24726	38633	16	applied	\N	\N	\N	\N	119126	119126	119127
24741	38672	0	applied	\N	\N	\N	\N	119227	119227	119228
24741	38673	1	applied	\N	\N	\N	\N	119229	119229	119230
24741	38674	2	applied	\N	\N	\N	\N	119231	119231	119232
24741	38675	3	applied	\N	\N	\N	\N	119233	119233	119234
24741	38676	4	applied	\N	\N	\N	\N	119235	119235	119236
24741	38677	5	applied	\N	\N	\N	\N	119237	119237	119238
24741	38678	6	applied	\N	\N	\N	\N	119239	119239	119240
24741	38679	7	applied	\N	\N	\N	\N	119241	119241	119242
24741	38680	8	applied	\N	\N	\N	\N	119243	119243	119244
24741	38681	9	applied	\N	\N	\N	\N	119245	119245	119246
24741	38682	10	applied	\N	\N	\N	\N	119247	119247	119248
24741	38683	11	applied	\N	\N	\N	\N	119249	119249	119250
24741	38684	12	applied	\N	\N	\N	\N	119251	119251	119252
24741	38685	13	applied	\N	\N	\N	\N	119253	119253	119254
24741	38686	14	applied	\N	\N	\N	\N	119255	119255	119256
24741	38687	15	applied	\N	\N	\N	\N	119257	119257	119258
24741	38688	16	applied	\N	\N	\N	\N	119259	119259	119260
24741	38689	17	applied	\N	\N	\N	\N	119261	119261	119262
24743	38690	0	applied	\N	\N	\N	\N	119269	119269	119270
24743	38691	1	applied	\N	\N	\N	\N	119271	119271	119272
24743	38692	2	applied	\N	\N	\N	\N	119273	119273	119274
24743	38693	3	applied	\N	\N	\N	\N	119275	119275	119276
24743	38694	4	applied	\N	\N	\N	\N	119277	119277	119278
24743	38695	5	applied	\N	\N	\N	\N	119279	119279	119280
24743	38696	6	applied	\N	\N	\N	\N	119281	119281	119282
24743	38697	7	applied	\N	\N	\N	\N	119283	119283	119284
24748	38706	0	applied	\N	\N	\N	\N	119309	119309	119310
24748	38707	1	applied	\N	\N	\N	\N	119311	119311	119312
24748	38708	2	applied	\N	\N	\N	\N	119313	119313	119314
24748	38709	3	applied	\N	\N	\N	\N	119315	119315	119316
24751	38718	0	applied	\N	\N	\N	\N	119338	119338	119339
24751	38719	1	applied	\N	\N	\N	\N	119340	119340	119341
24751	38720	2	applied	\N	\N	\N	\N	119342	119342	119343
24751	38721	3	applied	\N	\N	\N	\N	119344	119344	119345
24751	38722	4	applied	\N	\N	\N	\N	119346	119346	119347
24751	38723	5	applied	\N	\N	\N	\N	119348	119348	119349
24751	38724	6	applied	\N	\N	\N	\N	119350	119350	119351
24751	38725	7	applied	\N	\N	\N	\N	119352	119352	119353
24757	38730	0	applied	\N	\N	\N	\N	119367	119367	119368
24757	38731	1	applied	\N	\N	\N	\N	119369	119369	119370
24760	38733	0	applied	\N	\N	\N	\N	119378	119378	119379
24760	38734	1	applied	\N	\N	\N	\N	119380	119380	119381
24760	38735	2	applied	\N	\N	\N	\N	119382	119382	119383
24760	38738	3	applied	\N	\N	\N	\N	119388	119388	119394
24760	38739	4	applied	\N	\N	\N	\N	119390	119390	119395
24766	38757	0	applied	\N	\N	\N	\N	119444	119444	119445
24766	38758	1	applied	\N	\N	\N	\N	119446	119446	119447
24766	38759	2	applied	\N	\N	\N	\N	119448	119448	119449
24771	38763	0	applied	\N	\N	\N	\N	119464	119464	119465
24771	38764	1	applied	\N	\N	\N	\N	119466	119466	119467
24771	38765	2	applied	\N	\N	\N	\N	119468	119468	119469
24771	38766	3	applied	\N	\N	\N	\N	119470	119470	119471
24773	38767	0	applied	\N	\N	\N	\N	119475	119475	119476
24773	38768	1	applied	\N	\N	\N	\N	119477	119477	119478
24773	38769	2	applied	\N	\N	\N	\N	119479	119479	119480
24776	38772	0	applied	\N	\N	\N	\N	119487	119487	119488
24776	38773	1	applied	\N	\N	\N	\N	119489	119489	119490
24776	38774	2	applied	\N	\N	\N	\N	119491	119491	119492
24776	38775	3	applied	\N	\N	\N	\N	119493	119493	119494
24779	38776	0	applied	\N	\N	\N	\N	119498	119498	119499
24779	38777	1	applied	\N	\N	\N	\N	119500	119500	119501
24779	38778	2	applied	\N	\N	\N	\N	119502	119502	119503
24779	38779	3	applied	\N	\N	\N	\N	119504	119504	119505
24779	38780	4	applied	\N	\N	\N	\N	119506	119506	119507
24779	38781	5	applied	\N	\N	\N	\N	119508	119508	119509
24784	38789	0	applied	\N	\N	\N	\N	119582	119582	119583
24784	38790	1	applied	\N	\N	\N	\N	119584	119584	119585
24784	38791	2	applied	\N	\N	\N	\N	119586	119586	119587
24784	38792	3	applied	\N	\N	\N	\N	119588	119588	119589
24784	38793	4	applied	\N	\N	\N	\N	119590	119590	119591
24784	38794	5	applied	\N	\N	\N	\N	119592	119592	119593
24784	38795	6	applied	\N	\N	\N	\N	119594	119594	119595
24784	38796	7	applied	\N	\N	\N	\N	119596	119596	12588
24784	38797	8	applied	\N	\N	\N	\N	119597	119597	119598
24784	38798	9	applied	\N	\N	\N	\N	119599	119599	119600
24784	38799	10	applied	\N	\N	\N	\N	119601	119601	119602
24784	38800	11	applied	\N	\N	\N	\N	119603	119603	119604
24784	38801	12	applied	\N	\N	\N	\N	119605	119605	119606
24784	38802	13	applied	\N	\N	\N	\N	119607	119607	119608
24784	38803	14	applied	\N	\N	\N	\N	119609	119609	119610
24784	38804	15	applied	\N	\N	\N	\N	119611	119611	119612
24784	38805	16	applied	\N	\N	\N	\N	119613	119613	119614
24789	38816	0	applied	\N	\N	\N	\N	119640	119640	119641
24789	38817	1	applied	\N	\N	\N	\N	119642	119642	119643
24789	38818	2	applied	\N	\N	\N	\N	119644	119644	119645
24789	38819	3	applied	\N	\N	\N	\N	119646	119646	119647
24799	38844	0	applied	\N	\N	\N	\N	119713	119713	119714
24799	38845	2	applied	\N	\N	\N	\N	119716	119716	119717
24799	38846	3	applied	\N	\N	\N	\N	119718	119718	119719
24809	38871	0	applied	\N	\N	\N	\N	119784	119784	119790
24809	38872	1	applied	\N	\N	\N	\N	119786	119786	119783
24814	38869	0	applied	\N	\N	\N	\N	119780	119780	119781
24814	38873	1	applied	\N	\N	\N	\N	119830	119830	119831
24814	38870	2	applied	\N	\N	\N	\N	119782	119782	119787
24814	38874	3	applied	\N	\N	\N	\N	119832	119832	119833
24814	38875	4	applied	\N	\N	\N	\N	119834	119834	119835
24818	38879	0	applied	\N	\N	\N	\N	119879	119879	119880
24818	38880	1	applied	\N	\N	\N	\N	119881	119881	119882
24818	38881	2	applied	\N	\N	\N	\N	119883	119883	119884
24818	38882	3	applied	\N	\N	\N	\N	119885	119885	119886
24818	38883	4	applied	\N	\N	\N	\N	119887	119887	119888
24821	38887	0	applied	\N	\N	\N	\N	119900	119900	119901
24821	38888	1	applied	\N	\N	\N	\N	119902	119902	119903
24821	38889	2	applied	\N	\N	\N	\N	119904	119904	119905
24821	38890	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	119906	119906	\N
24821	38891	4	applied	\N	\N	\N	\N	119907	119907	119908
24821	38892	5	applied	\N	\N	\N	\N	119909	119909	119910
24821	38893	6	applied	\N	\N	\N	\N	119911	119911	119912
24821	38894	7	applied	\N	\N	\N	\N	119913	119913	119914
24821	38895	8	applied	\N	\N	\N	\N	119915	119915	119916
24821	38896	9	applied	\N	\N	\N	\N	119917	119917	119918
24821	38897	10	applied	\N	\N	\N	\N	119919	119919	119920
24821	38898	11	applied	\N	\N	\N	\N	119921	119921	119922
24821	38899	12	applied	\N	\N	\N	\N	119923	119923	119924
24823	38900	0	applied	\N	\N	\N	\N	119928	119928	119929
24761	38738	5	applied	\N	\N	\N	\N	119388	119388	119389
24761	38739	6	applied	\N	\N	\N	\N	119390	119390	119391
24764	38750	0	applied	\N	\N	\N	\N	119424	119424	119425
24764	38751	1	applied	\N	\N	\N	\N	119426	119426	119427
24764	38752	2	applied	\N	\N	\N	\N	119428	119428	119429
24764	38753	3	applied	\N	\N	\N	\N	119430	119430	119431
24764	38754	5	applied	\N	\N	\N	\N	119433	119433	119434
24764	38755	6	applied	\N	\N	\N	\N	119435	119435	119436
24764	38756	7	applied	\N	\N	\N	\N	119437	119437	119438
24767	38757	0	applied	\N	\N	\N	\N	119444	119444	119445
24767	38758	1	applied	\N	\N	\N	\N	119446	119446	119447
24767	38759	2	applied	\N	\N	\N	\N	119448	119448	119449
24774	38770	0	applied	\N	\N	\N	\N	119481	119481	119482
24774	38771	1	applied	\N	\N	\N	\N	119483	119483	119484
24790	38816	0	applied	\N	\N	\N	\N	119640	119640	119641
24790	38817	1	applied	\N	\N	\N	\N	119642	119642	119643
24790	38818	2	applied	\N	\N	\N	\N	119644	119644	119645
24790	38819	3	applied	\N	\N	\N	\N	119646	119646	119647
24792	38820	0	applied	\N	\N	\N	\N	119651	119651	119652
24792	38821	1	applied	\N	\N	\N	\N	119653	119653	119654
24792	38822	2	applied	\N	\N	\N	\N	119655	119655	119656
24792	38823	3	applied	\N	\N	\N	\N	119657	119657	119658
24792	38824	4	applied	\N	\N	\N	\N	119659	119659	119660
24792	38825	5	applied	\N	\N	\N	\N	119661	119661	119662
24792	38826	6	applied	\N	\N	\N	\N	119663	119663	119664
24792	38827	7	applied	\N	\N	\N	\N	119665	119665	119666
24792	38828	8	applied	\N	\N	\N	\N	119667	119667	119668
24792	38829	9	applied	\N	\N	\N	\N	119669	119669	23829
24794	38820	0	applied	\N	\N	\N	\N	119651	119651	119652
24794	38821	1	applied	\N	\N	\N	\N	119653	119653	119654
24794	38822	2	applied	\N	\N	\N	\N	119655	119655	119656
24794	38823	3	applied	\N	\N	\N	\N	119657	119657	119658
24794	38824	4	applied	\N	\N	\N	\N	119659	119659	119660
24794	38825	5	applied	\N	\N	\N	\N	119661	119661	119662
24794	38826	6	applied	\N	\N	\N	\N	119663	119663	119664
24794	38827	7	applied	\N	\N	\N	\N	119665	119665	119666
24794	38828	8	applied	\N	\N	\N	\N	119667	119667	119668
24794	38829	9	applied	\N	\N	\N	\N	119669	119669	23829
24797	38840	0	applied	\N	\N	\N	\N	119703	119703	119704
24797	38841	1	applied	\N	\N	\N	\N	119705	119705	119706
24797	38842	2	applied	\N	\N	\N	\N	119707	119707	119708
24797	38843	3	applied	\N	\N	\N	\N	119709	119709	119710
24802	38856	0	applied	\N	\N	\N	\N	119744	119744	119745
24802	38857	1	applied	\N	\N	\N	\N	119746	119746	119747
24802	38858	2	applied	\N	\N	\N	\N	119748	119748	119749
24812	38869	0	applied	\N	\N	\N	\N	119780	119780	119781
24812	38873	1	applied	\N	\N	\N	\N	119830	119830	119831
24812	38870	2	applied	\N	\N	\N	\N	119782	119782	119787
24812	38874	3	applied	\N	\N	\N	\N	119832	119832	119833
24812	38875	4	applied	\N	\N	\N	\N	119834	119834	119835
24815	38740	0	applied	\N	\N	\N	\N	119793	119793	119403
24815	38847	1	applied	\N	\N	1000000000	\N	119722	119722	119723
24815	38851	2	applied	\N	\N	\N	\N	119732	119732	119733
24815	38860	3	applied	\N	\N	\N	\N	119754	119754	119755
24815	38861	4	applied	\N	\N	\N	\N	119756	119756	119757
24815	38866	5	applied	\N	\N	\N	\N	119770	119770	119841
24815	38862	6	applied	\N	\N	\N	\N	119758	119758	119771
24815	38690	7	applied	\N	\N	\N	\N	119269	119269	119270
24815	38691	8	applied	\N	\N	\N	\N	119271	119271	119272
24815	38692	9	applied	\N	\N	\N	\N	119273	119273	119274
24815	38693	10	applied	\N	\N	\N	\N	119275	119275	119276
24815	38694	11	applied	\N	\N	\N	\N	119277	119277	119278
24815	38699	12	applied	\N	\N	\N	\N	119291	119291	119292
24815	38700	13	applied	\N	\N	\N	\N	119293	119293	119294
24815	38701	14	applied	\N	\N	\N	\N	119295	119295	119296
24815	38702	15	applied	\N	\N	\N	\N	119297	119297	119298
24815	38711	16	applied	\N	\N	\N	\N	119321	119321	119322
24815	38712	17	applied	\N	\N	\N	\N	119323	119323	119324
24815	38695	18	applied	\N	\N	\N	\N	119279	119279	119280
24815	38698	19	applied	\N	\N	\N	\N	119289	119289	119290
24815	38706	20	applied	\N	\N	\N	\N	119309	119309	119310
24815	38707	21	applied	\N	\N	\N	\N	119311	119311	119312
24815	38710	22	applied	\N	\N	\N	\N	119319	119319	119320
24815	38718	23	applied	\N	\N	\N	\N	119338	119338	119339
24815	38719	24	applied	\N	\N	\N	\N	119340	119340	119341
24815	38720	25	applied	\N	\N	\N	\N	119342	119342	119343
24815	38726	26	applied	\N	\N	\N	\N	119355	119355	119356
24815	38730	27	applied	\N	\N	\N	\N	119367	119367	119368
24815	38733	28	applied	\N	\N	\N	\N	119378	119378	119379
24815	38734	29	applied	\N	\N	\N	\N	119380	119380	119381
24815	38741	30	applied	\N	\N	\N	\N	119404	119404	119405
24815	38742	31	applied	\N	\N	\N	\N	119406	119406	119407
24815	38751	32	applied	\N	\N	\N	\N	119426	119426	119427
24815	38757	33	applied	\N	\N	\N	\N	119444	119444	119445
24815	38743	34	applied	\N	\N	\N	\N	119796	119796	119409
24815	38744	35	applied	\N	\N	\N	\N	119797	119797	119411
24815	38745	36	applied	\N	\N	\N	\N	119798	119798	119413
24815	38750	37	applied	\N	\N	\N	\N	119799	119799	119425
24815	38760	38	applied	\N	\N	\N	\N	119456	119456	119457
24815	38763	39	applied	\N	\N	\N	\N	119464	119464	119465
24815	38767	40	applied	\N	\N	\N	\N	119475	119475	119476
24815	38770	41	applied	\N	\N	\N	\N	119481	119481	119482
24815	38772	42	applied	\N	\N	\N	\N	119487	119487	119488
24815	38776	43	applied	\N	\N	\N	\N	119498	119498	119499
24815	38777	44	applied	\N	\N	\N	\N	119500	119500	119501
24815	38782	45	applied	\N	\N	\N	\N	119513	119513	119514
24815	38786	46	applied	\N	\N	\N	\N	119574	119574	119575
24815	38789	47	applied	\N	\N	\N	\N	119582	119582	119583
24815	38790	48	applied	\N	\N	\N	\N	119584	119584	119585
24815	38791	49	applied	\N	\N	\N	\N	119586	119586	119587
24815	38792	50	applied	\N	\N	\N	\N	119588	119588	119589
24815	38793	51	applied	\N	\N	\N	\N	119590	119590	119591
24815	38806	52	applied	\N	\N	\N	\N	119616	119616	119617
24815	38810	53	applied	\N	\N	\N	\N	119625	119625	119626
24815	38811	54	applied	\N	\N	\N	\N	119627	119627	119628
24815	38816	55	applied	\N	\N	\N	\N	119640	119640	119641
24815	38820	56	applied	\N	\N	\N	\N	119651	119651	119652
24815	38821	57	applied	\N	\N	\N	\N	119653	119653	119654
24815	38822	58	applied	\N	\N	\N	\N	119655	119655	119656
24815	38830	59	applied	\N	\N	\N	\N	119679	119679	119680
24815	38831	60	applied	\N	\N	\N	\N	119681	119681	119682
24815	38837	61	applied	\N	\N	\N	\N	119695	119695	119696
24815	38840	62	applied	\N	\N	\N	\N	119703	119703	119704
24815	38844	63	applied	\N	\N	\N	\N	119713	119713	119714
24815	38848	64	applied	\N	\N	\N	\N	119724	119724	119725
24815	38852	65	applied	\N	\N	\N	\N	119734	119734	119735
24815	38856	66	applied	\N	\N	\N	\N	119744	119744	119745
24815	38859	67	applied	\N	\N	\N	\N	119752	119752	119753
24815	38865	68	applied	\N	\N	\N	\N	119768	119768	119769
24815	38869	69	applied	\N	\N	\N	\N	119780	119780	119781
24781	38501	29	applied	\N	\N	\N	\N	119545	119545	118823
24781	38502	30	applied	\N	\N	\N	\N	119546	119546	118825
24781	38503	31	applied	\N	\N	\N	\N	119547	119547	118827
24781	38504	32	applied	\N	\N	\N	\N	119548	119548	118829
24781	38505	33	applied	\N	\N	\N	\N	119549	119549	118831
24781	38506	34	applied	\N	\N	\N	\N	119550	119550	118833
24781	38507	35	applied	\N	\N	\N	\N	119551	119551	118835
24781	38508	36	applied	\N	\N	\N	\N	119552	119552	118837
24781	38509	37	applied	\N	\N	\N	\N	119553	119553	118839
24781	38510	38	applied	\N	\N	\N	\N	119554	119554	118841
24781	38511	39	applied	\N	\N	\N	\N	119555	119555	118843
24781	38512	40	applied	\N	\N	\N	\N	119556	119556	118845
24781	38513	41	applied	\N	\N	\N	\N	119557	119557	118847
24781	38514	42	applied	\N	\N	\N	\N	119558	119558	118849
24781	38515	43	applied	\N	\N	\N	\N	119559	119559	118851
24781	38516	44	applied	\N	\N	\N	\N	119560	119560	118853
24781	38524	45	applied	\N	\N	\N	\N	119561	119561	118874
24781	38525	46	applied	\N	\N	\N	\N	119562	119562	118876
24781	38527	47	applied	\N	\N	\N	\N	119563	119563	118880
24781	38528	48	applied	\N	\N	\N	\N	119564	119564	118882
24781	38532	49	applied	\N	\N	\N	\N	119565	119565	118892
24781	38533	50	applied	\N	\N	\N	\N	119566	119566	118894
24781	38534	51	applied	\N	\N	\N	\N	119567	119567	118896
24781	38535	52	applied	\N	\N	\N	\N	119568	119568	118898
24781	38536	53	applied	\N	\N	\N	\N	119569	119569	118900
24781	38537	54	applied	\N	\N	\N	\N	119570	119570	118902
24781	38541	55	applied	\N	\N	\N	\N	119571	119571	118911
24782	38786	0	applied	\N	\N	\N	\N	119574	119574	119575
24782	38787	1	applied	\N	\N	\N	\N	119576	119576	119577
24782	38788	2	applied	\N	\N	\N	\N	119578	119578	119579
24786	38810	0	applied	\N	\N	\N	\N	119625	119625	119626
24786	38811	1	applied	\N	\N	\N	\N	119627	119627	119628
24786	38812	2	applied	\N	\N	\N	\N	119629	119629	119630
24786	38813	3	applied	\N	\N	\N	\N	119631	119631	119632
24786	38814	4	applied	\N	\N	\N	\N	119633	119633	119634
24786	38815	5	applied	\N	\N	\N	\N	119635	119635	119636
24796	38837	0	applied	\N	\N	\N	\N	119695	119695	119696
24796	38838	1	applied	\N	\N	\N	\N	119697	119697	119698
24796	38839	2	applied	\N	\N	\N	\N	119699	119699	119700
24798	38840	0	applied	\N	\N	\N	\N	119703	119703	119704
24798	38841	1	applied	\N	\N	\N	\N	119705	119705	119706
24798	38842	2	applied	\N	\N	\N	\N	119707	119707	119708
24798	38843	3	applied	\N	\N	\N	\N	119709	119709	119710
24801	38851	0	applied	\N	\N	\N	\N	119732	119732	119733
24801	38852	1	applied	\N	\N	\N	\N	119734	119734	119735
24801	38853	2	applied	\N	\N	\N	\N	119736	119736	119737
24801	38854	3	applied	\N	\N	\N	\N	119738	119738	119739
24801	38855	4	applied	\N	\N	\N	\N	119740	119740	119741
24804	38859	0	applied	\N	\N	\N	\N	119752	119752	119753
24804	38860	1	applied	\N	\N	\N	\N	119754	119754	119755
24804	38861	2	applied	\N	\N	\N	\N	119756	119756	119757
24804	38862	3	applied	\N	\N	\N	\N	119758	119758	119759
24804	38863	4	applied	\N	\N	\N	\N	119760	119760	119761
24804	38864	5	applied	\N	\N	\N	\N	119762	119762	119763
24806	38865	0	applied	\N	\N	\N	\N	119768	119768	119769
24806	38866	1	applied	\N	\N	\N	\N	119770	119770	119771
24806	38867	2	applied	\N	\N	\N	\N	119772	119772	119773
24806	38868	3	applied	\N	\N	\N	\N	119774	119774	119775
24808	38869	0	applied	\N	\N	\N	\N	119780	119780	119781
24808	38870	1	applied	\N	\N	\N	\N	119782	119782	119783
24808	38871	2	applied	\N	\N	\N	\N	119784	119784	119785
24808	38872	3	applied	\N	\N	\N	\N	119786	119786	119787
24811	38869	0	applied	\N	\N	\N	\N	119780	119780	119781
24811	38870	1	applied	\N	\N	\N	\N	119782	119782	119783
24811	38871	2	applied	\N	\N	\N	\N	119784	119784	119785
24811	38872	3	applied	\N	\N	\N	\N	119786	119786	119787
24813	38869	0	applied	\N	\N	\N	\N	119780	119780	119781
24813	38873	1	applied	\N	\N	\N	\N	119830	119830	119831
24813	38870	2	applied	\N	\N	\N	\N	119782	119782	119787
24813	38874	3	applied	\N	\N	\N	\N	119832	119832	119833
24813	38875	4	applied	\N	\N	\N	\N	119834	119834	119835
24817	38879	0	applied	\N	\N	\N	\N	119879	119879	119880
24817	38880	1	applied	\N	\N	\N	\N	119881	119881	119882
24817	38881	2	applied	\N	\N	\N	\N	119883	119883	119884
24817	38882	3	applied	\N	\N	\N	\N	119885	119885	119886
24817	38883	4	applied	\N	\N	\N	\N	119887	119887	119888
24820	38887	0	applied	\N	\N	\N	\N	119900	119900	119901
24820	38888	1	applied	\N	\N	\N	\N	119902	119902	119903
24820	38889	2	applied	\N	\N	\N	\N	119904	119904	119905
24820	38890	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	119906	119906	\N
24820	38891	4	applied	\N	\N	\N	\N	119907	119907	119908
24820	38892	5	applied	\N	\N	\N	\N	119909	119909	119910
24820	38893	6	applied	\N	\N	\N	\N	119911	119911	119912
24820	38894	7	applied	\N	\N	\N	\N	119913	119913	119914
24820	38895	8	applied	\N	\N	\N	\N	119915	119915	119916
24820	38896	9	applied	\N	\N	\N	\N	119917	119917	119918
24820	38897	10	applied	\N	\N	\N	\N	119919	119919	119920
24820	38898	11	applied	\N	\N	\N	\N	119921	119921	119922
24820	38899	12	applied	\N	\N	\N	\N	119923	119923	119924
24825	38903	0	applied	\N	\N	\N	\N	119937	119937	119938
24825	38904	1	applied	\N	\N	\N	\N	119939	119939	119940
24825	38905	2	applied	\N	\N	\N	\N	119941	119941	119942
24825	38906	3	applied	\N	\N	\N	\N	119943	119943	119944
24825	38907	4	applied	\N	\N	\N	\N	119945	119945	119946
24825	38908	5	applied	\N	\N	\N	\N	119947	119947	119948
24825	38909	6	applied	\N	\N	\N	\N	119949	119949	119950
24825	38910	7	applied	\N	\N	\N	\N	119951	119951	119952
24830	38911	0	applied	\N	\N	\N	\N	119958	119958	119959
24830	38912	1	applied	\N	\N	\N	\N	119960	119960	119961
24830	38913	2	applied	\N	\N	\N	\N	119962	119962	119963
24834	38917	0	applied	\N	\N	\N	\N	119975	119975	119976
24834	38918	1	applied	\N	\N	\N	\N	119977	119977	119978
24834	38919	2	applied	\N	\N	\N	\N	119979	119979	119980
24834	38920	3	applied	\N	\N	\N	\N	119981	119981	119982
24834	38921	4	applied	\N	\N	\N	\N	119983	119983	119984
24834	38922	5	applied	\N	\N	\N	\N	119985	119985	119986
24834	38923	6	applied	\N	\N	\N	\N	119987	119987	119988
24837	38927	0	applied	\N	\N	\N	\N	119997	119997	119998
24837	38928	1	applied	\N	\N	\N	\N	119999	119999	120000
24837	38929	2	applied	\N	\N	\N	\N	120001	120001	120002
24837	38930	3	applied	\N	\N	\N	\N	120003	120003	120004
24837	38931	4	applied	\N	\N	\N	\N	120005	120005	120006
24837	38932	5	applied	\N	\N	\N	\N	120007	120007	120008
24837	38933	6	applied	\N	\N	\N	\N	120009	120009	120010
24837	38934	7	applied	\N	\N	\N	\N	120011	120011	120012
24837	38935	8	applied	\N	\N	\N	\N	120013	120013	120014
24837	38936	10	applied	\N	\N	\N	\N	120016	120016	120017
24840	38937	0	applied	\N	\N	\N	\N	120023	120023	120024
24840	38938	1	applied	\N	\N	\N	\N	120025	120025	120026
24805	38868	3	applied	\N	\N	\N	\N	119774	119774	119775
24807	38865	0	applied	\N	\N	\N	\N	119768	119768	119769
24807	38866	1	applied	\N	\N	\N	\N	119770	119770	119771
24807	38867	2	applied	\N	\N	\N	\N	119772	119772	119773
24810	38477	0	applied	\N	\N	\N	\N	118764	118764	118765
24810	38740	1	applied	\N	\N	\N	\N	119793	119793	119403
24810	38847	2	applied	\N	\N	1000000000	\N	119794	119794	119723
24810	38851	3	applied	\N	\N	\N	\N	119795	119795	119733
24810	38743	4	applied	\N	\N	\N	\N	119796	119796	119409
24810	38744	5	applied	\N	\N	\N	\N	119797	119797	119411
24810	38479	6	applied	\N	\N	\N	\N	118768	118768	118769
24810	38483	7	applied	\N	\N	\N	\N	118784	118784	118785
24810	38484	8	applied	\N	\N	\N	\N	118786	118786	118787
24810	38485	9	applied	\N	\N	\N	\N	118788	118788	118789
24810	38486	10	applied	\N	\N	\N	\N	118790	118790	118791
24810	38487	11	applied	\N	\N	\N	\N	118792	118792	118793
24810	38491	12	applied	\N	\N	\N	\N	118801	118801	118802
24810	38492	13	applied	\N	\N	\N	\N	118803	118803	118804
24810	38493	14	applied	\N	\N	\N	\N	118805	118805	118806
24810	38494	15	applied	\N	\N	\N	\N	118807	118807	118808
24810	38497	16	applied	\N	\N	\N	\N	118814	118814	118815
24810	38501	17	applied	\N	\N	\N	\N	118822	118822	118823
24810	38502	18	applied	\N	\N	\N	\N	118824	118824	118825
24810	38503	19	applied	\N	\N	\N	\N	118826	118826	118827
24810	38504	20	applied	\N	\N	\N	\N	118828	118828	118829
24810	38505	21	applied	\N	\N	\N	\N	118830	118830	118831
24810	38506	22	applied	\N	\N	\N	\N	118832	118832	118833
24810	38507	23	applied	\N	\N	\N	\N	118834	118834	118835
24810	38508	24	applied	\N	\N	\N	\N	118836	118836	118837
24810	38509	25	applied	\N	\N	\N	\N	118838	118838	119732
24810	38510	26	applied	\N	\N	\N	\N	118840	118840	118841
24810	38511	27	applied	\N	\N	\N	\N	118842	118842	118843
24810	38512	28	applied	\N	\N	\N	\N	118844	118844	118845
24810	38513	29	applied	\N	\N	\N	\N	118846	118846	118847
24810	38514	30	applied	\N	\N	\N	\N	118848	118848	118849
24810	38515	31	applied	\N	\N	\N	\N	118850	118850	118851
24810	38516	32	applied	\N	\N	\N	\N	118852	118852	118853
24810	38524	33	applied	\N	\N	\N	\N	118873	118873	118874
24810	38525	34	applied	\N	\N	\N	\N	118875	118875	118876
24810	38527	35	applied	\N	\N	\N	\N	118879	118879	118880
24810	38528	36	applied	\N	\N	\N	\N	118881	118881	118882
24810	38532	37	applied	\N	\N	\N	\N	118891	118891	118892
24810	38533	38	applied	\N	\N	\N	\N	118893	118893	118894
24810	38534	39	applied	\N	\N	\N	\N	118895	118895	118896
24810	38535	40	applied	\N	\N	\N	\N	118897	118897	118898
24810	38536	41	applied	\N	\N	\N	\N	118899	118899	118900
24810	38537	42	applied	\N	\N	\N	\N	118901	118901	118902
24810	38541	43	applied	\N	\N	\N	\N	118910	118910	118911
24810	38542	44	applied	\N	\N	\N	\N	118912	118912	118913
24810	38543	45	applied	\N	\N	\N	\N	118914	118914	118915
24810	38545	46	applied	\N	\N	\N	\N	118918	118918	118919
24810	38546	47	applied	\N	\N	\N	\N	118920	118920	118921
24810	38549	48	applied	\N	\N	\N	\N	118934	118934	118935
24810	38550	49	applied	\N	\N	\N	\N	118936	118936	118937
24810	38552	50	applied	\N	\N	\N	\N	118940	118940	118941
24810	38553	51	applied	\N	\N	\N	\N	118942	118942	118943
24810	38556	52	applied	\N	\N	\N	\N	118952	118952	118953
24810	38558	53	applied	\N	\N	\N	\N	118956	118956	118957
24810	38559	54	applied	\N	\N	\N	\N	118958	118958	118959
24810	38560	55	applied	\N	\N	\N	\N	118960	118960	118961
24810	38568	56	applied	\N	\N	\N	\N	118983	118983	118984
24810	38574	57	applied	\N	\N	\N	\N	118997	118997	118998
24810	38575	58	applied	\N	\N	\N	\N	118999	118999	119000
24810	38576	59	applied	\N	\N	\N	\N	119001	119001	119002
24810	38577	60	applied	\N	\N	\N	\N	119003	119003	119004
24810	38578	61	applied	\N	\N	\N	\N	119005	119005	119006
24810	38745	62	applied	\N	\N	\N	\N	119798	119798	119413
24810	38750	63	applied	\N	\N	\N	\N	119799	119799	119425
24810	38585	64	applied	\N	\N	\N	\N	119024	119024	119025
24810	38586	65	applied	\N	\N	\N	\N	119026	119026	119027
24810	38587	66	applied	\N	\N	\N	\N	119028	119028	119029
24810	38588	67	applied	\N	\N	\N	\N	119030	119030	119031
24810	38589	68	applied	\N	\N	\N	\N	119032	119032	119033
24810	38590	69	applied	\N	\N	\N	\N	119034	119034	119035
24810	38591	70	applied	\N	\N	\N	\N	119036	119036	119037
24810	38592	71	applied	\N	\N	\N	\N	119038	119038	119039
24810	38593	72	applied	\N	\N	\N	\N	119040	119040	119041
24810	38594	73	applied	\N	\N	\N	\N	119042	119042	119043
24810	38595	74	applied	\N	\N	\N	\N	119044	119044	119045
24810	38596	75	applied	\N	\N	\N	\N	119046	119046	119047
24810	38597	76	applied	\N	\N	\N	\N	119048	119048	119049
24810	38598	77	applied	\N	\N	\N	\N	119050	119050	119051
24810	38599	78	applied	\N	\N	\N	\N	119052	119052	119053
24810	38600	79	applied	\N	\N	\N	\N	119054	119054	119055
24810	38601	80	applied	\N	\N	\N	\N	119056	119056	119057
24810	38602	81	applied	\N	\N	\N	\N	119058	119058	119059
24810	38603	82	applied	\N	\N	\N	\N	119060	119060	119061
24810	38604	83	applied	\N	\N	\N	\N	119062	119062	119063
24810	38605	84	applied	\N	\N	\N	\N	119064	119064	119065
24810	38606	85	applied	\N	\N	\N	\N	119066	119066	119067
24810	38607	86	applied	\N	\N	\N	\N	119068	119068	119069
24810	38617	87	applied	\N	\N	\N	\N	119800	119800	119095
24810	38618	88	applied	\N	\N	\N	\N	119801	119801	119097
24810	38619	89	applied	\N	\N	\N	\N	119802	119802	119099
24810	38620	90	applied	\N	\N	\N	\N	119803	119803	119101
24810	38621	91	applied	\N	\N	\N	\N	119804	119804	119103
24810	38622	92	applied	\N	\N	\N	\N	119805	119805	119105
24810	38623	93	applied	\N	\N	\N	\N	119806	119806	119107
24810	38624	94	applied	\N	\N	\N	\N	119807	119807	119109
24810	38625	95	applied	\N	\N	\N	\N	119808	119808	119111
24810	38626	96	applied	\N	\N	\N	\N	119809	119809	119113
24810	38635	97	applied	\N	\N	\N	\N	119810	119810	119133
24810	38636	98	applied	\N	\N	\N	\N	119811	119811	119135
24810	38637	99	applied	\N	\N	\N	\N	119812	119812	119137
24810	38643	100	applied	\N	\N	\N	\N	119813	119813	119156
24810	38645	101	applied	\N	\N	\N	\N	119814	119814	119160
24810	38646	102	applied	\N	\N	\N	\N	119815	119815	119162
24810	38650	103	applied	\N	\N	\N	\N	119816	119816	119172
24810	38651	104	applied	\N	\N	\N	\N	119817	119817	119174
24810	38653	105	applied	\N	\N	\N	\N	119818	119818	119179
24810	38654	106	applied	\N	\N	\N	\N	119819	119819	119181
24810	38655	107	applied	\N	\N	\N	\N	119820	119820	119183
24810	38658	108	applied	\N	\N	\N	\N	119821	119821	119195
24810	38660	109	applied	\N	\N	\N	\N	119822	119822	119199
24810	38661	110	applied	\N	\N	\N	\N	119823	119823	119201
24810	38662	111	applied	\N	\N	\N	\N	119824	119824	119203
24819	38884	0	applied	\N	\N	\N	\N	119892	119892	119893
24819	38885	1	applied	\N	\N	\N	\N	119894	119894	119895
24819	38886	2	applied	\N	\N	\N	\N	119896	119896	119897
24822	38900	0	applied	\N	\N	\N	\N	119928	119928	119929
24815	38696	70	applied	\N	\N	\N	\N	119281	119281	119282
24815	38703	71	applied	\N	\N	\N	\N	119299	119299	119842
24815	38796	72	applied	\N	\N	\N	\N	119596	119596	12588
24815	38704	73	applied	\N	\N	\N	\N	119301	119301	119843
24815	38708	74	applied	\N	\N	\N	\N	119313	119313	119844
24815	38709	75	applied	\N	\N	\N	\N	119315	119315	119845
24815	38716	76	applied	\N	\N	\N	\N	119331	119331	119846
24815	38721	77	applied	\N	\N	\N	\N	119344	119344	119326
24815	38722	78	applied	\N	\N	\N	\N	119346	119346	119847
24815	38717	79	applied	\N	\N	\N	\N	119333	119333	119330
24815	38728	80	applied	\N	\N	\N	\N	119359	119359	119848
24815	38735	81	applied	\N	\N	\N	\N	119382	119382	119849
24815	38754	83	applied	\N	\N	\N	\N	119433	119433	119332
24815	38766	84	applied	\N	\N	\N	\N	119470	119470	119334
24815	38774	85	applied	\N	\N	\N	\N	119491	119491	119851
24815	38785	86	applied	\N	\N	\N	\N	119519	119519	119852
24815	38803	87	applied	\N	\N	\N	\N	119609	119609	119345
24815	38808	88	applied	\N	\N	\N	\N	119620	119620	119853
24815	38817	89	applied	\N	\N	\N	\N	119642	119642	119854
24815	38832	90	applied	\N	\N	\N	\N	119683	119683	119347
24815	38842	91	applied	\N	\N	\N	\N	119707	119707	119855
24815	38854	92	applied	\N	\N	\N	\N	119738	119738	119349
24815	38697	93	applied	\N	\N	\N	\N	119283	119283	119351
24815	38705	94	applied	\N	\N	\N	\N	119303	119303	119353
24815	38713	95	applied	\N	\N	\N	\N	119325	119325	119358
24815	38714	96	applied	\N	\N	\N	\N	119327	119327	119856
24815	38715	97	applied	\N	\N	\N	\N	119329	119329	119362
24815	38723	98	applied	\N	\N	\N	\N	119348	119348	119857
24815	38724	99	applied	\N	\N	\N	\N	119350	119350	119858
24815	38725	100	applied	\N	\N	\N	\N	119352	119352	119383
24815	38727	101	applied	\N	\N	\N	\N	119357	119357	119385
24815	38732	102	applied	\N	\N	\N	\N	119371	119371	119387
24815	38736	103	applied	\N	\N	\N	\N	119384	119384	119395
24815	38737	104	applied	\N	\N	\N	\N	119386	119386	119859
24815	38746	105	applied	\N	\N	\N	\N	119414	119414	119391
24815	38749	106	applied	\N	\N	\N	\N	119420	119420	119415
24815	38752	107	applied	\N	\N	\N	\N	119428	119428	119860
24815	38753	108	applied	\N	\N	\N	\N	119430	119430	119861
24815	38759	109	applied	\N	\N	\N	\N	119448	119448	119419
24815	38761	110	applied	\N	\N	\N	\N	119458	119458	119421
24815	38765	111	applied	\N	\N	\N	\N	119468	119468	119429
24815	38769	112	applied	\N	\N	\N	\N	119479	119479	119431
24815	38771	113	applied	\N	\N	\N	\N	119483	119483	119862
24815	38775	114	applied	\N	\N	\N	\N	119493	119493	119436
24815	38729	115	applied	\N	\N	\N	\N	119361	119361	119438
24815	38731	116	applied	\N	\N	\N	\N	119369	119369	119447
24815	38738	117	applied	\N	\N	\N	\N	119388	119388	119863
24815	38739	118	applied	\N	\N	\N	\N	119390	119390	119864
24815	38747	119	applied	\N	\N	\N	\N	119416	119416	119865
24815	38748	120	applied	\N	\N	\N	\N	119418	119418	119469
24815	38755	121	applied	\N	\N	\N	\N	119435	119435	119866
24815	38756	122	applied	\N	\N	\N	\N	119437	119437	119480
24815	38758	123	applied	\N	\N	\N	\N	119446	119446	119867
24815	38762	124	applied	\N	\N	\N	\N	119460	119460	119492
24815	38764	125	applied	\N	\N	\N	\N	119466	119466	119868
24816	38876	0	applied	\N	\N	\N	\N	119871	119871	119872
24816	38877	1	applied	\N	\N	\N	\N	119873	119873	119874
24816	38878	2	applied	\N	\N	\N	\N	119875	119875	119876
24824	38900	0	applied	\N	\N	\N	\N	119928	119928	119929
24824	38901	1	applied	\N	\N	\N	\N	119930	119930	119931
24824	38902	2	applied	\N	\N	\N	\N	119932	119932	119933
24828	38911	0	applied	\N	\N	\N	\N	119958	119958	119959
24828	38912	1	applied	\N	\N	\N	\N	119960	119960	119961
24828	38913	2	applied	\N	\N	\N	\N	119962	119962	119963
24833	38914	0	applied	\N	\N	\N	\N	119965	119965	119966
24833	38915	1	applied	\N	\N	\N	\N	119967	119967	119968
24833	38916	2	applied	\N	\N	\N	\N	119969	119969	119970
24835	38924	0	applied	\N	\N	\N	\N	119990	119990	119991
24835	38925	1	applied	\N	\N	\N	\N	119992	119992	119993
24835	38926	2	applied	\N	\N	\N	\N	119994	119994	119995
24836	38927	0	applied	\N	\N	\N	\N	119997	119997	119998
24836	38928	1	applied	\N	\N	\N	\N	119999	119999	120000
24836	38929	2	applied	\N	\N	\N	\N	120001	120001	120002
24836	38930	3	applied	\N	\N	\N	\N	120003	120003	120004
24836	38931	4	applied	\N	\N	\N	\N	120005	120005	120006
24836	38932	5	applied	\N	\N	\N	\N	120007	120007	120008
24836	38933	6	applied	\N	\N	\N	\N	120009	120009	120010
24836	38934	7	applied	\N	\N	\N	\N	120011	120011	120012
24836	38935	8	applied	\N	\N	\N	\N	120013	120013	120014
24836	38936	10	applied	\N	\N	\N	\N	120016	120016	120017
24839	38937	0	applied	\N	\N	\N	\N	120023	120023	120024
24839	38938	1	applied	\N	\N	\N	\N	120025	120025	120026
24839	38939	2	applied	\N	\N	\N	\N	120027	120027	120028
24839	38940	3	applied	\N	\N	\N	\N	120029	120029	120030
24839	38941	4	applied	\N	\N	\N	\N	120031	120031	120032
24839	38942	5	applied	\N	\N	\N	\N	120033	120033	120034
24839	38943	6	applied	\N	\N	\N	\N	120035	120035	120036
24843	38944	0	applied	\N	\N	\N	\N	120042	120042	120043
24843	38945	1	applied	\N	\N	\N	\N	120044	120044	120045
24843	38946	2	applied	\N	\N	\N	\N	120046	120046	120047
24848	38950	0	applied	\N	\N	\N	\N	120061	120061	120062
24848	38951	1	applied	\N	\N	\N	\N	120063	120063	120064
24848	38952	2	applied	\N	\N	\N	\N	120065	120065	120066
24848	38953	3	applied	\N	\N	\N	\N	120067	120067	120068
24851	38971	0	applied	\N	\N	\N	\N	120110	120110	120111
24851	38972	1	applied	\N	\N	\N	\N	120112	120112	120113
24851	38973	2	applied	\N	\N	\N	\N	120114	120114	120115
24851	38974	3	applied	\N	\N	\N	\N	120116	120116	120117
24851	38975	4	applied	\N	\N	\N	\N	120118	120118	120119
24851	38976	5	applied	\N	\N	\N	\N	120120	120120	120121
24851	38977	6	applied	\N	\N	\N	\N	120122	120122	120123
24857	38985	0	applied	\N	\N	\N	\N	120144	120144	120145
24857	38986	1	applied	\N	\N	\N	\N	120146	120146	120147
24857	38987	2	applied	\N	\N	\N	\N	120148	120148	120149
24857	38988	3	applied	\N	\N	\N	\N	120150	120150	120151
24857	38989	4	applied	\N	\N	\N	\N	120152	120152	120153
24857	38990	5	applied	\N	\N	\N	\N	120154	120154	120155
24857	38991	6	applied	\N	\N	\N	\N	120156	120156	120157
24858	38992	0	applied	\N	\N	\N	\N	120163	120163	120164
24858	38993	1	applied	\N	\N	\N	\N	120165	120165	120166
24858	38994	2	applied	\N	\N	\N	\N	120167	120167	120168
24861	38995	0	applied	\N	\N	\N	\N	120170	120170	120171
24861	38996	1	applied	\N	\N	\N	\N	120172	120172	120173
24861	38997	2	applied	\N	\N	\N	\N	120174	120174	120175
24861	38998	3	applied	\N	\N	\N	\N	120176	120176	120177
24861	38999	4	applied	\N	\N	\N	\N	120178	120178	120179
24861	39000	5	applied	\N	\N	\N	\N	120180	120180	120181
24861	39001	6	applied	\N	\N	\N	\N	120182	120182	120182
24861	39002	7	applied	\N	\N	\N	\N	120183	120183	120184
24864	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24822	38901	1	applied	\N	\N	\N	\N	119930	119930	119931
24822	38902	2	applied	\N	\N	\N	\N	119932	119932	119933
24827	38903	0	applied	\N	\N	\N	\N	119937	119937	119938
24827	38904	1	applied	\N	\N	\N	\N	119939	119939	119940
24827	38905	2	applied	\N	\N	\N	\N	119941	119941	119942
24827	38906	3	applied	\N	\N	\N	\N	119943	119943	119944
24827	38907	4	applied	\N	\N	\N	\N	119945	119945	119946
24827	38908	5	applied	\N	\N	\N	\N	119947	119947	119948
24827	38909	6	applied	\N	\N	\N	\N	119949	119949	119950
24827	38910	7	applied	\N	\N	\N	\N	119951	119951	119952
24829	38911	0	applied	\N	\N	\N	\N	119958	119958	119959
24829	38912	1	applied	\N	\N	\N	\N	119960	119960	119961
24829	38913	2	applied	\N	\N	\N	\N	119962	119962	119963
24841	38944	0	applied	\N	\N	\N	\N	120042	120042	120043
24841	38945	1	applied	\N	\N	\N	\N	120044	120044	120045
24841	38946	2	applied	\N	\N	\N	\N	120046	120046	120047
24846	38947	0	applied	\N	\N	\N	\N	120053	120053	120054
24846	38949	1	applied	\N	\N	\N	\N	120057	120057	120059
24854	38982	0	applied	\N	\N	\N	\N	120135	120135	120136
24854	38983	1	applied	\N	\N	\N	\N	120137	120137	120138
24854	38984	2	applied	\N	\N	\N	\N	120139	120139	120140
24859	38995	0	applied	\N	\N	\N	\N	120170	120170	120171
24859	38996	1	applied	\N	\N	\N	\N	120172	120172	120173
24859	38997	2	applied	\N	\N	\N	\N	120174	120174	120175
24859	38998	3	applied	\N	\N	\N	\N	120176	120176	120177
24859	38999	4	applied	\N	\N	\N	\N	120178	120178	120179
24859	39000	5	applied	\N	\N	\N	\N	120180	120180	120181
24859	39001	6	applied	\N	\N	\N	\N	120182	120182	120182
24859	39002	7	applied	\N	\N	\N	\N	120183	120183	120184
24862	39003	0	applied	\N	\N	\N	\N	120189	120189	120190
24862	39004	1	applied	\N	\N	\N	\N	120191	120191	120192
24862	39005	2	applied	\N	\N	\N	\N	120193	120193	120194
24862	39006	3	applied	\N	\N	\N	\N	120195	120195	120196
24862	39007	4	applied	\N	\N	\N	\N	120197	120197	120198
24862	39008	5	applied	\N	\N	\N	\N	120199	120199	120200
24862	39009	6	applied	\N	\N	\N	\N	120201	120201	120202
24865	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24865	39016	1	applied	\N	\N	\N	\N	120216	120216	120217
24865	39017	2	applied	\N	\N	\N	\N	120218	120218	120219
24870	39016	0	applied	\N	\N	\N	\N	120216	120216	120217
24873	39035	0	applied	\N	\N	\N	\N	120268	120268	120269
24873	39036	1	applied	\N	\N	\N	\N	120270	120270	120271
24873	39037	2	applied	\N	\N	\N	\N	120272	120272	120273
24873	39038	3	applied	\N	\N	\N	\N	120274	120274	120275
24876	39039	0	applied	\N	\N	\N	\N	120279	120279	120280
24876	39040	1	applied	\N	\N	\N	\N	120281	120281	120282
24876	39041	2	applied	\N	\N	\N	\N	120283	120283	120284
24880	39045	0	applied	\N	\N	\N	\N	120298	120298	120299
24880	39046	1	applied	\N	\N	\N	\N	120300	120300	120301
24880	39047	2	applied	\N	\N	\N	\N	120302	120302	120303
24880	39048	3	applied	\N	\N	\N	\N	120304	120304	120305
24882	39049	0	applied	\N	\N	\N	\N	120310	120310	120311
24882	39050	1	applied	\N	\N	\N	\N	120312	120312	120313
24882	39051	2	applied	\N	\N	\N	\N	120314	120314	120315
24887	39058	0	applied	\N	\N	\N	\N	120335	120335	120336
24887	39059	1	applied	\N	\N	\N	\N	120337	120337	120338
24887	39060	2	applied	\N	\N	\N	\N	120339	120339	120340
24891	39062	0	applied	\N	\N	\N	\N	120348	120348	120349
24891	39063	1	applied	\N	\N	\N	\N	120350	120350	120351
24894	39072	0	applied	\N	\N	\N	\N	120372	120372	120373
24894	39073	1	applied	\N	\N	\N	\N	120374	120374	120375
24894	39074	2	applied	\N	\N	\N	\N	120376	120376	120377
24897	39078	0	applied	\N	\N	\N	\N	120388	120388	120389
24897	39079	1	applied	\N	\N	\N	\N	120390	120390	120391
24897	39080	2	applied	\N	\N	\N	\N	120392	120392	120393
24897	39081	3	applied	\N	\N	\N	\N	120394	120394	120395
24900	39088	0	applied	\N	\N	\N	\N	120411	120411	120412
24900	39089	1	applied	\N	\N	\N	\N	120413	120413	120414
24900	39090	2	applied	\N	\N	\N	\N	120415	120415	120416
24900	39091	3	applied	\N	\N	\N	\N	120417	120417	120418
24902	39092	0	applied	\N	\N	\N	\N	120424	120424	120425
24902	39093	1	applied	\N	\N	\N	\N	120426	120426	120427
24902	39094	2	applied	\N	\N	\N	\N	120428	120428	120429
24902	39095	3	applied	\N	\N	\N	\N	120430	120430	120431
24902	39096	4	applied	\N	\N	\N	\N	120432	120432	120433
24902	39097	5	applied	\N	\N	\N	\N	120434	120434	120435
24907	39101	0	applied	\N	\N	\N	\N	120447	120447	120448
24907	39102	1	applied	\N	\N	\N	\N	120449	120449	120450
24907	39103	2	applied	\N	\N	\N	\N	120451	120451	120452
24907	39104	3	applied	\N	\N	\N	\N	120453	120453	120454
24823	38901	1	applied	\N	\N	\N	\N	119930	119930	119931
24823	38902	2	applied	\N	\N	\N	\N	119932	119932	119933
24826	38903	0	applied	\N	\N	\N	\N	119937	119937	119938
24826	38904	1	applied	\N	\N	\N	\N	119939	119939	119940
24826	38905	2	applied	\N	\N	\N	\N	119941	119941	119942
24826	38906	3	applied	\N	\N	\N	\N	119943	119943	119944
24826	38907	4	applied	\N	\N	\N	\N	119945	119945	119946
24826	38908	5	applied	\N	\N	\N	\N	119947	119947	119948
24826	38909	6	applied	\N	\N	\N	\N	119949	119949	119950
24826	38910	7	applied	\N	\N	\N	\N	119951	119951	119952
24831	38911	0	applied	\N	\N	\N	\N	119958	119958	119959
24831	38913	1	applied	\N	\N	\N	\N	119962	119962	119964
24832	38914	0	applied	\N	\N	\N	\N	119965	119965	119966
24832	38915	1	applied	\N	\N	\N	\N	119967	119967	119968
24832	38916	2	applied	\N	\N	\N	\N	119969	119969	119970
24838	38937	0	applied	\N	\N	\N	\N	120023	120023	120024
24838	38938	1	applied	\N	\N	\N	\N	120025	120025	120026
24838	38939	2	applied	\N	\N	\N	\N	120027	120027	120028
24838	38940	3	applied	\N	\N	\N	\N	120029	120029	120030
24838	38941	4	applied	\N	\N	\N	\N	120031	120031	120032
24838	38942	5	applied	\N	\N	\N	\N	120033	120033	120034
24838	38943	6	applied	\N	\N	\N	\N	120035	120035	120036
24847	38950	0	applied	\N	\N	\N	\N	120061	120061	120062
24847	38951	1	applied	\N	\N	\N	\N	120063	120063	120064
24847	38952	2	applied	\N	\N	\N	\N	120065	120065	120066
24847	38953	3	applied	\N	\N	\N	\N	120067	120067	120068
24850	38964	0	applied	\N	\N	\N	\N	120095	120095	120096
24850	38965	1	applied	\N	\N	\N	\N	120097	120097	120098
24850	38966	2	applied	\N	\N	\N	\N	120099	120099	120100
24850	38967	3	applied	\N	\N	\N	\N	120101	120101	120102
24850	38968	4	applied	\N	\N	\N	\N	120103	120103	120104
24850	38969	5	applied	\N	\N	\N	\N	120105	120105	120106
24850	38970	6	applied	\N	\N	\N	\N	120107	120107	120108
24853	38982	0	applied	\N	\N	\N	\N	120135	120135	120136
24853	38983	1	applied	\N	\N	\N	\N	120137	120137	120138
24853	38984	2	applied	\N	\N	\N	\N	120139	120139	120140
24856	38985	0	applied	\N	\N	\N	\N	120144	120144	120145
24856	38986	1	applied	\N	\N	\N	\N	120146	120146	120147
24856	38987	2	applied	\N	\N	\N	\N	120148	120148	120149
24856	38988	3	applied	\N	\N	\N	\N	120150	120150	120151
24856	38989	4	applied	\N	\N	\N	\N	120152	120152	120153
24856	38990	5	applied	\N	\N	\N	\N	120154	120154	120155
24856	38991	6	applied	\N	\N	\N	\N	120156	120156	120157
24872	39032	0	applied	\N	\N	\N	\N	120261	120261	120262
24872	39033	1	applied	\N	\N	\N	\N	120263	120263	120264
24872	39034	2	applied	\N	\N	\N	\N	120265	120265	120266
24878	39039	0	applied	\N	\N	\N	\N	120279	120279	120280
24878	39040	1	applied	\N	\N	\N	\N	120281	120281	120282
24878	39041	2	applied	\N	\N	\N	\N	120283	120283	120284
24883	39049	0	applied	\N	\N	\N	\N	120310	120310	120311
24883	39050	1	applied	\N	\N	\N	\N	120312	120312	120313
24883	39051	2	applied	\N	\N	\N	\N	120314	120314	120315
24889	39058	0	applied	\N	\N	\N	\N	120335	120335	120336
24889	39059	1	applied	\N	\N	\N	\N	120337	120337	120338
24889	39060	2	applied	\N	\N	\N	\N	120339	120339	120340
24890	39061	0	applied	\N	\N	\N	\N	120346	120346	120347
24890	39062	1	applied	\N	\N	\N	\N	120348	120348	120349
24890	39063	2	applied	\N	\N	\N	\N	120350	120350	120351
24893	39061	0	applied	\N	\N	\N	\N	120346	120346	120347
24893	39064	1	applied	\N	\N	\N	\N	120355	120355	120356
24893	39065	2	applied	\N	\N	\N	\N	120357	120357	120358
24893	39066	3	applied	\N	\N	\N	\N	120359	120359	120360
24893	39067	4	applied	\N	\N	\N	\N	120361	120361	120362
24893	39068	5	applied	\N	\N	\N	\N	120363	120363	120364
24893	39069	6	applied	\N	\N	\N	\N	120365	120365	120365
24893	39070	7	applied	\N	\N	\N	\N	120366	120366	120367
24893	39071	8	applied	\N	\N	\N	\N	120368	120368	120369
24840	38939	2	applied	\N	\N	\N	\N	120027	120027	120028
24840	38940	3	applied	\N	\N	\N	\N	120029	120029	120030
24840	38941	4	applied	\N	\N	\N	\N	120031	120031	120032
24840	38942	5	applied	\N	\N	\N	\N	120033	120033	120034
24840	38943	6	applied	\N	\N	\N	\N	120035	120035	120036
24842	38944	0	applied	\N	\N	\N	\N	120042	120042	120043
24842	38945	1	applied	\N	\N	\N	\N	120044	120044	120045
24842	38946	2	applied	\N	\N	\N	\N	120046	120046	120047
24845	38947	0	applied	\N	\N	\N	\N	120053	120053	120054
24845	38948	1	applied	\N	\N	\N	\N	120055	120055	120056
24845	38949	2	applied	\N	\N	\N	\N	120057	120057	120058
24849	38954	0	applied	\N	\N	\N	\N	120073	120073	120074
24849	38955	1	applied	\N	\N	\N	\N	120075	120075	120076
24849	38956	2	applied	\N	\N	\N	\N	120077	120077	120078
24849	38957	3	applied	\N	\N	\N	\N	120079	120079	120080
24849	38958	4	applied	\N	\N	\N	\N	120081	120081	120082
24849	38959	5	applied	\N	\N	\N	\N	120083	120083	120084
24849	38960	6	applied	\N	\N	\N	\N	120085	120085	120086
24849	38961	7	applied	\N	\N	\N	\N	120087	120087	120088
24849	38962	8	applied	\N	\N	\N	\N	120089	120089	120090
24849	38963	9	applied	\N	\N	\N	\N	120091	120091	120092
24852	38978	0	applied	\N	\N	\N	\N	120126	120126	120127
24852	38979	1	applied	\N	\N	\N	\N	120128	120128	120129
24852	38980	2	applied	\N	\N	\N	\N	120130	120130	120131
24852	38981	3	applied	\N	\N	\N	\N	120132	120132	120133
24855	38985	0	applied	\N	\N	\N	\N	120144	120144	120145
24855	38986	1	applied	\N	\N	\N	\N	120146	120146	120147
24855	38987	2	applied	\N	\N	\N	\N	120148	120148	120149
24855	38988	3	applied	\N	\N	\N	\N	120150	120150	120151
24855	38989	4	applied	\N	\N	\N	\N	120152	120152	120153
24855	38990	5	applied	\N	\N	\N	\N	120154	120154	120155
24855	38991	6	applied	\N	\N	\N	\N	120156	120156	120157
24860	38995	0	applied	\N	\N	\N	\N	120170	120170	120171
24860	38996	1	applied	\N	\N	\N	\N	120172	120172	120173
24860	38997	2	applied	\N	\N	\N	\N	120174	120174	120175
24860	38998	3	applied	\N	\N	\N	\N	120176	120176	120177
24860	38999	4	applied	\N	\N	\N	\N	120178	120178	120179
24860	39000	5	applied	\N	\N	\N	\N	120180	120180	120181
24860	39001	6	applied	\N	\N	\N	\N	120182	120182	120182
24860	39002	7	applied	\N	\N	\N	\N	120183	120183	120184
24863	39010	0	applied	\N	\N	\N	\N	120204	120204	120205
24863	39011	1	applied	\N	\N	\N	\N	120206	120206	120207
24863	39012	2	applied	\N	\N	\N	\N	120208	120208	120208
24863	39013	3	applied	\N	\N	\N	\N	120209	120209	120210
24863	39014	4	applied	\N	\N	\N	\N	120211	120211	120212
24867	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24867	39016	1	applied	\N	\N	\N	\N	120216	120216	120217
24867	39017	2	applied	\N	\N	\N	\N	120218	120218	120219
24868	39016	0	applied	\N	\N	\N	\N	120216	120216	120217
24871	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24871	39018	1	applied	\N	\N	\N	\N	120230	120230	120231
24871	39019	2	applied	\N	\N	1000000000	\N	120232	120232	120233
24871	39020	3	applied	\N	\N	\N	\N	120234	120234	120235
24871	39021	4	applied	\N	\N	\N	\N	120236	120236	120237
24871	39022	5	applied	\N	\N	\N	\N	120238	120238	120239
24871	39023	6	applied	\N	\N	\N	\N	120240	120240	12588
24871	39024	7	applied	\N	\N	\N	\N	120241	120241	120242
24871	39017	8	applied	\N	\N	\N	\N	120218	120218	120243
24871	39025	9	applied	\N	\N	\N	\N	120244	120244	120245
24871	39026	10	applied	\N	\N	\N	\N	120246	120246	120247
24871	39027	11	applied	\N	\N	\N	\N	120248	120248	120249
24871	39028	12	applied	\N	\N	\N	\N	120250	120250	120251
24871	39029	13	applied	\N	\N	\N	\N	120252	120252	120253
24871	39030	14	applied	\N	\N	\N	\N	120254	120254	120255
24871	39031	16	applied	\N	\N	\N	\N	120257	120257	120258
24874	39035	0	applied	\N	\N	\N	\N	120268	120268	120269
24874	39036	1	applied	\N	\N	\N	\N	120270	120270	120271
24874	39037	2	applied	\N	\N	\N	\N	120272	120272	120273
24874	39038	3	applied	\N	\N	\N	\N	120274	120274	120275
24877	39039	0	applied	\N	\N	\N	\N	120279	120279	120280
24877	39040	1	applied	\N	\N	\N	\N	120281	120281	120282
24877	39041	2	applied	\N	\N	\N	\N	120283	120283	120284
24881	39045	0	applied	\N	\N	\N	\N	120298	120298	120299
24881	39046	1	applied	\N	\N	\N	\N	120300	120300	120301
24881	39047	2	applied	\N	\N	\N	\N	120302	120302	120303
24881	39048	3	applied	\N	\N	\N	\N	120304	120304	120305
24885	39052	0	applied	\N	\N	\N	\N	120320	120320	120321
24885	39053	1	applied	\N	\N	\N	\N	120322	120322	120323
24885	39054	2	applied	\N	\N	\N	\N	120324	120324	120325
24888	39058	0	applied	\N	\N	\N	\N	120335	120335	120336
24888	39059	1	applied	\N	\N	\N	\N	120337	120337	120338
24888	39060	2	applied	\N	\N	\N	\N	120339	120339	120340
24892	39061	0	applied	\N	\N	\N	\N	120346	120346	120347
24892	39064	1	applied	\N	\N	\N	\N	120355	120355	120356
24892	39065	2	applied	\N	\N	\N	\N	120357	120357	120358
24892	39066	3	applied	\N	\N	\N	\N	120359	120359	120360
24892	39067	4	applied	\N	\N	\N	\N	120361	120361	120362
24892	39068	5	applied	\N	\N	\N	\N	120363	120363	120364
24892	39069	6	applied	\N	\N	\N	\N	120365	120365	120365
24892	39070	7	applied	\N	\N	\N	\N	120366	120366	120367
24892	39071	8	applied	\N	\N	\N	\N	120368	120368	120369
24895	39072	0	applied	\N	\N	\N	\N	120372	120372	120373
24895	39073	1	applied	\N	\N	\N	\N	120374	120374	120375
24895	39074	2	applied	\N	\N	\N	\N	120376	120376	120377
24898	39082	0	applied	\N	\N	\N	\N	120397	120397	120398
24898	39083	1	applied	\N	\N	\N	\N	120399	120399	120400
24898	39084	2	applied	\N	\N	\N	\N	120401	120401	120402
24898	39085	3	applied	\N	\N	\N	\N	120403	120403	120404
24898	39086	4	applied	\N	\N	\N	\N	120405	120405	120406
24898	39087	5	applied	\N	\N	\N	\N	120407	120407	120408
24903	39092	0	applied	\N	\N	\N	\N	120424	120424	120425
24903	39093	1	applied	\N	\N	\N	\N	120426	120426	120427
24903	39094	2	applied	\N	\N	\N	\N	120428	120428	120429
24903	39095	3	applied	\N	\N	\N	\N	120430	120430	120431
24903	39096	4	applied	\N	\N	\N	\N	120432	120432	120433
24903	39097	5	applied	\N	\N	\N	\N	120434	120434	120435
24905	39098	0	applied	\N	\N	\N	\N	120439	120439	120440
24905	39099	1	applied	\N	\N	\N	\N	120441	120441	120442
24905	39100	2	applied	\N	\N	\N	\N	120443	120443	120444
24908	39101	0	applied	\N	\N	\N	\N	120447	120447	120448
24908	39102	1	applied	\N	\N	\N	\N	120449	120449	120450
24908	39103	2	applied	\N	\N	\N	\N	120451	120451	120452
24908	39104	3	applied	\N	\N	\N	\N	120453	120453	120454
24864	39016	1	applied	\N	\N	\N	\N	120216	120216	120217
24864	39017	2	applied	\N	\N	\N	\N	120218	120218	120219
24866	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24866	39017	1	applied	\N	\N	\N	\N	120218	120218	120224
24869	39015	0	applied	\N	\N	\N	\N	120214	120214	120215
24869	39016	1	applied	\N	\N	\N	\N	120216	120216	120217
24869	39017	2	applied	\N	\N	\N	\N	120218	120218	120219
24875	39039	0	applied	\N	\N	\N	\N	120279	120279	120280
24875	39040	1	applied	\N	\N	\N	\N	120281	120281	120282
24875	39041	2	applied	\N	\N	\N	\N	120283	120283	120284
24879	39042	0	applied	\N	\N	\N	\N	120292	120292	120293
24879	39043	1	applied	\N	\N	\N	\N	120294	120294	120295
24879	39044	2	applied	\N	\N	\N	\N	120296	120296	120297
24884	39052	0	applied	\N	\N	\N	\N	120320	120320	120321
24884	39053	1	applied	\N	\N	\N	\N	120322	120322	120323
24884	39054	2	applied	\N	\N	\N	\N	120324	120324	120325
24886	39055	0	applied	\N	\N	\N	\N	120329	120329	120330
24886	39056	1	applied	\N	\N	\N	\N	120331	120331	120332
24886	39057	2	applied	\N	\N	\N	\N	120333	120333	120334
24896	39075	0	applied	\N	\N	\N	\N	120382	120382	120383
24896	39076	1	applied	\N	\N	\N	\N	120384	120384	120385
24896	39077	2	applied	\N	\N	\N	\N	120386	120386	120387
24899	39088	0	applied	\N	\N	\N	\N	120411	120411	120412
24899	39089	1	applied	\N	\N	\N	\N	120413	120413	120414
24899	39090	2	applied	\N	\N	\N	\N	120415	120415	120416
24899	39091	3	applied	\N	\N	\N	\N	120417	120417	120418
24901	39088	0	applied	\N	\N	\N	\N	120411	120411	120412
24901	39089	1	applied	\N	\N	\N	\N	120413	120413	120414
24901	39090	2	applied	\N	\N	\N	\N	120415	120415	120416
24901	39091	3	applied	\N	\N	\N	\N	120417	120417	120418
24904	39098	0	applied	\N	\N	\N	\N	120439	120439	120440
24904	39099	1	applied	\N	\N	\N	\N	120441	120441	120442
24904	39100	2	applied	\N	\N	\N	\N	120443	120443	120444
24906	39101	0	applied	\N	\N	\N	\N	120447	120447	120448
24906	39102	1	applied	\N	\N	\N	\N	120449	120449	120450
24906	39103	2	applied	\N	\N	\N	\N	120451	120451	120452
24906	39104	3	applied	\N	\N	\N	\N	120453	120453	120454
24909	39105	0	applied	\N	\N	\N	\N	120458	120458	120459
24909	39106	1	applied	\N	\N	\N	\N	120460	120460	120461
24909	39107	2	applied	\N	\N	\N	\N	120462	120462	120463
24910	39105	0	applied	\N	\N	\N	\N	120458	120458	120459
24910	39106	1	applied	\N	\N	\N	\N	120460	120460	120461
24910	39107	2	applied	\N	\N	\N	\N	120462	120462	120463
24911	39105	0	applied	\N	\N	\N	\N	120458	120458	120459
24911	39106	1	applied	\N	\N	\N	\N	120460	120460	120461
24911	39107	2	applied	\N	\N	\N	\N	120462	120462	120463
24912	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24912	39109	1	applied	\N	\N	\N	\N	120469	120469	120470
24912	39110	2	applied	\N	\N	\N	\N	120471	120471	120472
24913	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24913	39109	1	applied	\N	\N	\N	\N	120469	120469	120470
24913	39110	2	applied	\N	\N	\N	\N	120471	120471	120472
24914	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24914	39109	1	applied	\N	\N	\N	\N	120469	120469	120470
24914	39110	2	applied	\N	\N	\N	\N	120471	120471	120472
24915	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24915	39109	1	applied	\N	\N	\N	\N	120469	120469	120470
24915	39110	2	applied	\N	\N	\N	\N	120471	120471	120472
24916	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24916	39109	1	applied	\N	\N	\N	\N	120469	120469	120470
24916	39110	2	applied	\N	\N	\N	\N	120471	120471	120472
24917	39111	0	applied	\N	\N	\N	\N	120476	120476	120477
24917	39112	1	applied	\N	\N	\N	\N	120478	120478	120479
24917	39113	2	applied	\N	\N	\N	\N	120480	120480	120481
24917	39114	4	applied	\N	\N	\N	\N	120483	120483	120484
24918	39111	0	applied	\N	\N	\N	\N	120476	120476	120477
24918	39112	1	applied	\N	\N	\N	\N	120478	120478	120479
24918	39113	2	applied	\N	\N	\N	\N	120480	120480	120481
24918	39114	4	applied	\N	\N	\N	\N	120483	120483	120484
24919	39115	0	applied	\N	\N	\N	\N	120486	120486	120487
24919	39116	1	applied	\N	\N	\N	\N	120488	120488	120489
24919	39117	2	applied	\N	\N	\N	\N	120490	120490	120491
24920	39118	0	applied	\N	\N	\N	\N	120494	120494	120495
24920	39119	1	applied	\N	\N	\N	\N	120496	120496	120497
24920	39120	2	applied	\N	\N	\N	\N	120498	120498	120499
24921	39121	0	applied	\N	\N	\N	\N	120502	120502	120503
24921	39122	1	applied	\N	\N	\N	\N	120504	120504	120505
24921	39123	2	applied	\N	\N	\N	\N	120506	120506	120507
24921	39124	3	applied	\N	\N	\N	\N	120508	120508	120509
24922	39125	0	applied	\N	\N	\N	\N	120511	120511	120512
24922	39126	1	applied	\N	\N	\N	\N	120513	120513	120514
24922	39127	2	applied	\N	\N	\N	\N	120515	120515	120516
24923	39121	0	applied	\N	\N	\N	\N	120502	120502	120503
24923	39125	1	applied	\N	\N	\N	\N	120511	120511	120512
24923	39122	2	applied	\N	\N	\N	\N	120504	120504	120505
24923	39123	3	applied	\N	\N	\N	\N	120506	120506	120507
24923	39126	4	applied	\N	\N	\N	\N	120513	120513	120517
24923	39127	5	applied	\N	\N	\N	\N	120515	120515	120518
24923	39124	6	applied	\N	\N	\N	\N	120508	120508	120516
24924	39126	0	applied	\N	\N	\N	\N	120513	120513	120514
24924	39127	1	applied	\N	\N	\N	\N	120515	120515	120516
24925	39125	0	applied	\N	\N	\N	\N	120511	120511	120512
24925	39128	1	applied	\N	\N	\N	\N	120522	120522	120523
24925	39129	2	applied	\N	\N	\N	\N	120524	120524	120525
24925	39130	3	applied	\N	\N	\N	\N	120526	120526	120527
24925	39131	4	applied	\N	\N	\N	\N	120528	120528	120529
24925	39132	5	applied	\N	\N	\N	\N	120530	120530	120531
24925	39133	6	applied	\N	\N	\N	\N	120532	120532	120533
24926	39125	0	applied	\N	\N	\N	\N	120511	120511	120512
24926	39128	1	applied	\N	\N	\N	\N	120522	120522	120523
24926	39129	2	applied	\N	\N	\N	\N	120524	120524	120525
24926	39130	3	applied	\N	\N	\N	\N	120526	120526	120527
24926	39131	4	applied	\N	\N	\N	\N	120528	120528	120529
24926	39132	5	applied	\N	\N	\N	\N	120530	120530	120531
24926	39133	6	applied	\N	\N	\N	\N	120532	120532	120533
24927	39125	0	applied	\N	\N	\N	\N	120511	120511	120512
24927	39128	1	applied	\N	\N	\N	\N	120522	120522	120523
24927	39129	2	applied	\N	\N	\N	\N	120524	120524	120525
24927	39130	3	applied	\N	\N	\N	\N	120526	120526	120527
24927	39131	4	applied	\N	\N	\N	\N	120528	120528	120529
24927	39132	5	applied	\N	\N	\N	\N	120530	120530	120531
24927	39133	6	applied	\N	\N	\N	\N	120532	120532	120533
24928	39125	0	applied	\N	\N	\N	\N	120511	120511	120512
24928	39128	1	applied	\N	\N	\N	\N	120522	120522	120523
24928	39129	2	applied	\N	\N	\N	\N	120524	120524	120525
24928	39130	3	applied	\N	\N	\N	\N	120526	120526	120527
24928	39131	4	applied	\N	\N	\N	\N	120528	120528	120529
24928	39132	5	applied	\N	\N	\N	\N	120530	120530	120531
24928	39133	6	applied	\N	\N	\N	\N	120532	120532	120533
24929	39130	0	applied	\N	\N	\N	\N	120526	120526	120527
24929	39131	1	applied	\N	\N	\N	\N	120528	120528	120529
24929	39132	2	applied	\N	\N	\N	\N	120530	120530	120531
24929	39133	3	applied	\N	\N	\N	\N	120532	120532	120533
24934	39138	0	applied	\N	\N	\N	\N	120564	120564	120565
24934	39139	1	applied	\N	\N	\N	\N	120566	120566	120567
24934	39140	2	applied	\N	\N	\N	\N	120568	120568	120569
24936	39108	0	applied	\N	\N	\N	\N	120467	120467	120468
24936	39111	1	applied	\N	\N	\N	\N	120476	120476	120477
24936	39115	2	applied	\N	\N	\N	\N	120486	120486	120487
24936	39118	3	applied	\N	\N	\N	\N	120494	120494	120495
24936	39121	4	applied	\N	\N	\N	\N	120502	120502	120503
24936	39125	5	applied	\N	\N	\N	\N	120511	120511	120512
24936	39128	6	applied	\N	\N	\N	\N	120522	120522	120523
24936	39129	7	applied	\N	\N	\N	\N	120524	120524	120525
24936	39134	9	applied	\N	\N	\N	\N	120554	120554	120555
24936	39109	10	applied	\N	\N	\N	\N	120469	120469	120470
24936	39113	11	applied	\N	\N	\N	\N	120480	120480	120574
24936	39110	12	applied	\N	\N	\N	\N	120471	120471	120575
24936	39112	13	applied	\N	\N	\N	\N	120478	120478	120481
24936	39116	14	applied	\N	\N	\N	\N	120488	120488	120576
24936	39114	15	applied	\N	\N	\N	\N	120483	120483	120489
24936	39124	16	applied	\N	\N	\N	\N	120508	120508	120577
24936	39120	17	applied	\N	\N	\N	\N	120498	120498	120491
24936	39122	18	applied	\N	\N	\N	\N	120504	120504	120578
24936	39127	19	applied	\N	\N	\N	\N	120515	120515	120579
24936	39132	20	applied	\N	\N	\N	\N	120530	120530	120580
24936	39133	21	applied	\N	\N	\N	\N	120532	120532	120581
24936	39117	22	applied	\N	\N	\N	\N	120490	120490	120509
24936	39119	23	applied	\N	\N	\N	\N	120496	120496	120514
24936	39123	24	applied	\N	\N	\N	\N	120506	120506	120582
24936	39126	25	applied	\N	\N	\N	\N	120513	120513	120583
24936	39130	26	applied	\N	\N	\N	\N	120526	120526	120584
24936	39131	27	applied	\N	\N	\N	\N	120528	120528	120533
24936	39135	28	applied	\N	\N	\N	\N	120556	120556	120557
24936	39136	29	applied	\N	\N	\N	\N	120558	120558	120559
24936	39137	30	applied	\N	\N	\N	\N	120560	120560	120561
24938	39144	0	applied	\N	\N	\N	\N	120595	120595	120596
24938	39145	1	applied	\N	\N	\N	\N	120597	120597	120598
24938	39146	2	applied	\N	\N	\N	\N	120599	120599	120600
24938	39147	3	applied	\N	\N	\N	\N	120601	120601	120602
24941	39148	0	applied	\N	\N	\N	\N	120604	120604	120605
24941	39149	1	applied	\N	\N	\N	\N	120606	120606	120607
24941	39150	2	applied	\N	\N	\N	\N	120608	120608	120609
24941	39151	3	applied	\N	\N	\N	\N	120610	120610	120611
24941	39152	4	applied	\N	\N	\N	\N	120612	120612	120613
24941	39153	5	applied	\N	\N	\N	\N	120614	120614	120615
24947	39157	0	applied	\N	\N	\N	\N	120627	120627	120628
24947	39158	1	applied	\N	\N	\N	\N	120629	120629	120630
24947	39159	2	applied	\N	\N	\N	\N	120631	120631	120632
24947	39160	3	applied	\N	\N	\N	\N	120633	120633	120634
24958	39171	0	applied	\N	\N	\N	\N	120675	120675	120676
24958	39172	1	applied	\N	\N	\N	\N	120677	120677	120678
24958	39173	2	applied	\N	\N	\N	\N	120679	120679	120680
24963	39174	0	applied	\N	\N	\N	\N	120688	120688	120689
24963	39175	1	applied	\N	\N	\N	\N	120690	120690	120691
24963	39176	2	applied	\N	\N	\N	\N	120692	120692	120693
24963	39177	3	applied	\N	\N	\N	\N	120694	120694	120695
24963	39178	4	applied	\N	\N	\N	\N	120696	120696	120697
24963	39179	5	applied	\N	\N	\N	\N	120698	120698	120699
24963	39180	6	applied	\N	\N	\N	\N	120700	120700	120701
24963	39181	7	applied	\N	\N	\N	\N	120702	120702	120703
24965	39185	0	applied	\N	\N	\N	\N	120714	120714	120715
24965	39186	1	applied	\N	\N	\N	\N	120716	120716	120717
24965	39187	2	applied	\N	\N	\N	\N	120718	120718	120719
24971	39205	0	applied	\N	\N	\N	\N	120769	120769	120770
24971	39207	1	applied	\N	\N	\N	\N	120775	120775	120776
24971	39206	2	applied	\N	\N	\N	\N	120771	120771	120777
24973	39208	0	applied	\N	\N	\N	\N	120781	120781	120782
24973	39209	1	applied	\N	\N	\N	\N	120783	120783	120784
24973	39207	2	applied	\N	\N	\N	\N	120775	120775	120777
24973	39210	3	applied	\N	\N	\N	\N	120785	120785	120786
24973	39211	4	applied	\N	\N	\N	\N	120787	120787	120788
24973	39212	5	applied	\N	\N	\N	\N	120789	120789	120790
24973	39213	6	applied	\N	\N	\N	\N	120791	120791	120792
24973	39214	7	applied	\N	\N	\N	\N	120793	120793	120794
24980	39221	0	applied	\N	\N	\N	\N	120815	120815	120816
24980	39222	1	applied	\N	\N	\N	\N	120817	120817	120818
24980	39223	2	applied	\N	\N	\N	\N	120819	120819	120820
24982	39224	0	applied	\N	\N	\N	\N	120821	120821	120822
24982	39225	1	applied	\N	\N	\N	\N	120823	120823	120824
24982	39226	2	applied	\N	\N	\N	\N	120825	120825	120820
24982	39223	3	applied	\N	\N	\N	\N	120819	120819	120826
24982	39227	4	applied	\N	\N	\N	\N	120827	120827	120828
24987	39228	0	applied	\N	\N	\N	\N	120835	120835	120836
24987	39229	1	applied	\N	\N	\N	\N	120837	120837	120838
24987	39230	2	applied	\N	\N	1000000000	\N	120839	120839	120840
24987	39231	3	applied	\N	\N	\N	\N	120841	120841	120842
24987	39232	4	applied	\N	\N	\N	\N	120843	120843	120844
24987	39233	5	applied	\N	\N	\N	\N	120845	120845	120846
24987	39234	6	applied	\N	\N	\N	\N	120847	120847	120848
24987	39235	7	applied	\N	\N	\N	\N	120849	120849	120850
24987	39236	8	applied	\N	\N	\N	\N	120851	120851	120852
24987	39237	9	applied	\N	\N	\N	\N	120853	120853	120854
24987	39238	10	applied	\N	\N	\N	\N	120855	120855	120856
24997	39253	0	applied	\N	\N	\N	\N	120942	120942	120943
24997	39254	1	applied	\N	\N	\N	\N	120944	120944	120945
24997	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120946	120946	\N
24997	39252	3	applied	\N	\N	\N	\N	120939	120939	120940
24997	39258	4	applied	\N	\N	\N	\N	120952	120952	120953
24997	39256	5	applied	\N	\N	\N	\N	120947	120947	120954
24997	39257	6	applied	\N	\N	\N	\N	120949	120949	120955
25001	39259	0	applied	\N	\N	\N	\N	120958	120958	120959
25001	39260	1	applied	\N	\N	\N	\N	120960	120960	120961
25001	39261	2	applied	\N	\N	\N	\N	120962	120962	120963
25001	39262	3	applied	\N	\N	\N	\N	120964	120964	120965
25001	39263	4	applied	\N	\N	\N	\N	120966	120966	120967
25001	39264	5	applied	\N	\N	\N	\N	120968	120968	120969
25001	39265	6	applied	\N	\N	\N	\N	120970	120970	120971
25001	39266	7	applied	\N	\N	\N	\N	120972	120972	120973
25002	39267	0	applied	\N	\N	\N	\N	120978	120978	120979
25002	39268	1	applied	\N	\N	\N	\N	120980	120980	120981
25002	39269	2	applied	\N	\N	\N	\N	120982	120982	120983
25007	39277	0	applied	\N	\N	\N	\N	121002	121002	121003
25007	39278	1	applied	\N	\N	\N	\N	121004	121004	121005
25007	39279	2	applied	\N	\N	\N	\N	121006	121006	121007
25009	39280	0	applied	\N	\N	\N	\N	121008	121008	121009
25009	39281	1	applied	\N	\N	\N	\N	121010	121010	121011
25013	39289	0	applied	\N	\N	\N	\N	121034	121034	121035
25013	39290	1	applied	\N	\N	\N	\N	121036	121036	121037
24930	38978	0	applied	\N	\N	1000000000	\N	120126	120126	120543
24930	38847	1	applied	\N	\N	\N	\N	119722	119722	119755
24930	38879	2	applied	\N	\N	\N	\N	120544	120544	119880
24930	38851	3	applied	\N	\N	\N	\N	119732	119732	120545
24930	39019	4	applied	\N	\N	1000000000	\N	120232	120232	120233
24930	39045	5	applied	\N	\N	\N	\N	120298	120298	120299
24930	38860	6	applied	\N	\N	\N	\N	119754	119754	120546
24930	38861	7	applied	\N	\N	\N	\N	119756	119756	120547
24930	38866	8	applied	\N	\N	\N	\N	119770	119770	120548
24930	38862	9	applied	\N	\N	\N	\N	119758	119758	120549
24930	38760	10	applied	\N	\N	\N	\N	119456	119456	119457
24930	38763	11	applied	\N	\N	\N	\N	119464	119464	119465
24930	38767	12	applied	\N	\N	\N	\N	119475	119475	119476
24930	38770	13	applied	\N	\N	\N	\N	119481	119481	119482
24930	38772	14	applied	\N	\N	\N	\N	119487	119487	119488
24930	38776	15	applied	\N	\N	\N	\N	119498	119498	119499
24930	38777	16	applied	\N	\N	\N	\N	119500	119500	119501
24930	38782	17	applied	\N	\N	\N	\N	119513	119513	119514
24930	38786	18	applied	\N	\N	\N	\N	119574	119574	119575
24930	38789	19	applied	\N	\N	\N	\N	119582	119582	119583
24930	38790	20	applied	\N	\N	\N	\N	119584	119584	119585
24930	38791	21	applied	\N	\N	\N	\N	119586	119586	119587
24930	38792	22	applied	\N	\N	\N	\N	119588	119588	119589
24930	38793	23	applied	\N	\N	\N	\N	119590	119590	119591
24930	38806	24	applied	\N	\N	\N	\N	119616	119616	119617
24930	38810	25	applied	\N	\N	\N	\N	119625	119625	119626
24930	38811	26	applied	\N	\N	\N	\N	119627	119627	119628
24930	38816	27	applied	\N	\N	\N	\N	119640	119640	119641
24930	38820	28	applied	\N	\N	\N	\N	119651	119651	119652
24930	38821	29	applied	\N	\N	\N	\N	119653	119653	119654
24930	38822	30	applied	\N	\N	\N	\N	119655	119655	119656
24930	38830	31	applied	\N	\N	\N	\N	119679	119679	119680
24930	38831	32	applied	\N	\N	\N	\N	119681	119681	119682
24930	38837	33	applied	\N	\N	\N	\N	119695	119695	119696
24930	38840	34	applied	\N	\N	\N	\N	119703	119703	119704
24930	38844	35	applied	\N	\N	\N	\N	119713	119713	119714
24930	38848	36	applied	\N	\N	\N	\N	119724	119724	119725
24930	38852	37	applied	\N	\N	\N	\N	119734	119734	119735
24930	38856	38	applied	\N	\N	\N	\N	119744	119744	119745
24930	38859	39	applied	\N	\N	\N	\N	119752	119752	119753
24930	38865	40	applied	\N	\N	\N	\N	119768	119768	119769
24930	38869	41	applied	\N	\N	\N	\N	119780	119780	119781
24930	38873	42	applied	\N	\N	\N	\N	119830	119830	119831
24930	38876	43	applied	\N	\N	\N	\N	119871	119871	119872
24930	38880	44	applied	\N	\N	\N	\N	119881	119881	119882
24930	38884	45	applied	\N	\N	\N	\N	119892	119892	119893
24930	38887	46	applied	\N	\N	\N	\N	119900	119900	119901
24930	38888	47	applied	\N	\N	\N	\N	119902	119902	119903
24930	38889	48	applied	\N	\N	\N	\N	119904	119904	119905
24930	38900	49	applied	\N	\N	\N	\N	119928	119928	119929
24930	38903	50	applied	\N	\N	\N	\N	119937	119937	119938
24930	38904	51	applied	\N	\N	\N	\N	119939	119939	119940
24930	38911	52	applied	\N	\N	\N	\N	119958	119958	119959
24930	38914	53	applied	\N	\N	\N	\N	119965	119965	119966
24930	38917	54	applied	\N	\N	\N	\N	119975	119975	119976
24930	38918	55	applied	\N	\N	\N	\N	119977	119977	119978
24930	38924	56	applied	\N	\N	\N	\N	119990	119990	119991
24930	38927	57	applied	\N	\N	\N	\N	119997	119997	119998
24930	38928	58	applied	\N	\N	\N	\N	119999	119999	120000
24930	38929	59	applied	\N	\N	\N	\N	120001	120001	120002
24930	38937	60	applied	\N	\N	\N	\N	120023	120023	120024
24930	38938	61	applied	\N	\N	\N	\N	120025	120025	120026
24930	38944	62	applied	\N	\N	\N	\N	120042	120042	120043
24930	38947	63	applied	\N	\N	\N	\N	120053	120053	120054
24930	38950	64	applied	\N	\N	\N	\N	120061	120061	120062
24930	38954	65	applied	\N	\N	\N	\N	120073	120073	120074
24930	38955	66	applied	\N	\N	\N	\N	120075	120075	120076
24930	38956	67	applied	\N	\N	\N	\N	120077	120077	120078
24930	38964	68	applied	\N	\N	\N	\N	120095	120095	120096
24930	38965	69	applied	\N	\N	\N	\N	120097	120097	120098
24930	38971	70	applied	\N	\N	\N	\N	120110	120110	120111
24930	38972	71	applied	\N	\N	\N	\N	120112	120112	120113
24930	38979	72	applied	\N	\N	\N	\N	120128	120128	120129
24930	38982	73	applied	\N	\N	\N	\N	120135	120135	120136
24930	38985	74	applied	\N	\N	\N	\N	120144	120144	120145
24930	38986	75	applied	\N	\N	\N	\N	120146	120146	120147
24930	38992	76	applied	\N	\N	\N	\N	120163	120163	120164
24930	38995	77	applied	\N	\N	\N	\N	120170	120170	120171
24930	38996	78	applied	\N	\N	\N	\N	120172	120172	120173
24930	39003	79	applied	\N	\N	\N	\N	120189	120189	120190
24930	39004	80	applied	\N	\N	\N	\N	120191	120191	120192
24930	39010	81	applied	\N	\N	\N	\N	120204	120204	120205
24930	39015	82	applied	\N	\N	\N	\N	120214	120214	120215
24930	39018	83	applied	\N	\N	\N	\N	120230	120230	120231
24930	39020	84	applied	\N	\N	\N	\N	120234	120234	120235
24930	39021	85	applied	\N	\N	\N	\N	120236	120236	120237
24930	39032	86	applied	\N	\N	\N	\N	120261	120261	120262
24930	39035	87	applied	\N	\N	\N	\N	120268	120268	120269
24930	39039	88	applied	\N	\N	\N	\N	120279	120279	120280
24930	39042	89	applied	\N	\N	\N	\N	120292	120292	120293
24930	39046	90	applied	\N	\N	\N	\N	120300	120300	120301
24930	39049	91	applied	\N	\N	\N	\N	120310	120310	120311
24930	39052	92	applied	\N	\N	\N	\N	120320	120320	120321
24930	39055	93	applied	\N	\N	\N	\N	120329	120329	120330
24930	39058	94	applied	\N	\N	\N	\N	120335	120335	120336
24930	39061	95	applied	\N	\N	\N	\N	120346	120346	120347
24930	39064	96	applied	\N	\N	\N	\N	120355	120355	120356
24930	39065	97	applied	\N	\N	\N	\N	120357	120357	120358
24930	39072	98	applied	\N	\N	\N	\N	120372	120372	120373
24930	39075	99	applied	\N	\N	\N	\N	120382	120382	120383
24930	39078	100	applied	\N	\N	\N	\N	120388	120388	120389
24930	39082	101	applied	\N	\N	\N	\N	120397	120397	120398
24930	39083	102	applied	\N	\N	\N	\N	120399	120399	120400
24930	39088	103	applied	\N	\N	\N	\N	120411	120411	120412
24930	39092	104	applied	\N	\N	\N	\N	120424	120424	120425
24930	39093	105	applied	\N	\N	\N	\N	120426	120426	120427
24930	39098	106	applied	\N	\N	\N	\N	120439	120439	120440
24930	39101	107	applied	\N	\N	\N	\N	120447	120447	120448
24930	39105	108	applied	\N	\N	\N	\N	120458	120458	120459
24930	39108	109	applied	\N	\N	\N	\N	120467	120467	120468
24930	39111	110	applied	\N	\N	\N	\N	120476	120476	120477
24930	39115	111	applied	\N	\N	\N	\N	120486	120486	120487
24930	39118	112	applied	\N	\N	\N	\N	120494	120494	120495
24930	39121	113	applied	\N	\N	\N	\N	120502	120502	120503
24930	39125	114	applied	\N	\N	\N	\N	120511	120511	120512
24930	39128	115	applied	\N	\N	\N	\N	120522	120522	120523
24930	39129	116	applied	\N	\N	\N	\N	120524	120524	120525
24930	38890	118	failed	Amount_insufficient_to_create_account	\N	\N	\N	119906	119906	\N
24930	38761	119	applied	\N	\N	\N	\N	119458	119458	119459
24930	38796	120	applied	\N	\N	\N	\N	119596	119596	12588
24930	38762	121	applied	\N	\N	\N	\N	119460	119460	119461
24930	38764	122	applied	\N	\N	\N	\N	119466	119466	119467
24930	38768	123	applied	\N	\N	\N	\N	119477	119477	119471
24930	38773	124	applied	\N	\N	\N	\N	119489	119489	119478
24930	38778	125	applied	\N	\N	\N	\N	119502	119502	120551
24945	39154	0	applied	\N	\N	\N	\N	120620	120620	120621
24945	39155	1	applied	\N	\N	\N	\N	120622	120622	120623
24945	39156	2	applied	\N	\N	\N	\N	120624	120624	120625
24948	39158	0	applied	\N	\N	\N	\N	120629	120629	120630
24948	39159	1	applied	\N	\N	\N	\N	120631	120631	120632
24948	39160	2	applied	\N	\N	\N	\N	120633	120633	120634
24954	39164	0	applied	\N	\N	\N	\N	120657	120657	120658
24954	39165	1	applied	\N	\N	\N	\N	120659	120659	120660
24954	39166	2	applied	\N	\N	\N	\N	120661	120661	120662
24956	39167	0	applied	\N	\N	\N	\N	120666	120666	120667
24956	39168	1	applied	\N	\N	\N	\N	120668	120668	120669
24956	39169	2	applied	\N	\N	\N	\N	120670	120670	120671
24956	39170	3	applied	\N	\N	\N	\N	120672	120672	120673
24959	39171	0	applied	\N	\N	\N	\N	120675	120675	120676
24959	39173	1	applied	\N	\N	\N	\N	120679	120679	120682
24966	39188	0	applied	\N	\N	\N	\N	120722	120722	120723
24966	39189	1	applied	\N	\N	\N	\N	120724	120724	120725
24966	39190	2	applied	\N	\N	\N	\N	120726	120726	120727
24966	39191	3	applied	\N	\N	\N	\N	120728	120728	120729
24966	39192	4	applied	\N	\N	\N	\N	120730	120730	120731
24966	39193	5	applied	\N	\N	\N	\N	120732	120732	120733
24966	39194	6	applied	\N	\N	\N	\N	120734	120734	120735
24966	39195	7	applied	\N	\N	\N	\N	120736	120736	120737
24966	39196	8	applied	\N	\N	\N	\N	120738	120738	120739
24966	39197	9	applied	\N	\N	\N	\N	120740	120740	120741
24972	39205	0	applied	\N	\N	\N	\N	120769	120769	120770
24974	39208	0	applied	\N	\N	\N	\N	120781	120781	120782
24974	39209	1	applied	\N	\N	\N	\N	120783	120783	120784
24974	39207	2	applied	\N	\N	\N	\N	120775	120775	120777
24974	39210	3	applied	\N	\N	\N	\N	120785	120785	120786
24974	39211	4	applied	\N	\N	\N	\N	120787	120787	120788
24974	39212	5	applied	\N	\N	\N	\N	120789	120789	120790
24974	39213	6	applied	\N	\N	\N	\N	120791	120791	120792
24974	39214	7	applied	\N	\N	\N	\N	120793	120793	120794
24978	39218	0	applied	\N	\N	\N	\N	120807	120807	120808
24978	39219	1	applied	\N	\N	\N	\N	120809	120809	120810
24978	39220	2	applied	\N	\N	\N	\N	120811	120811	120812
24983	39224	0	applied	\N	\N	\N	\N	120821	120821	120822
24983	39225	1	applied	\N	\N	\N	\N	120823	120823	120824
24983	39226	2	applied	\N	\N	\N	\N	120825	120825	120820
24983	39223	3	applied	\N	\N	\N	\N	120819	120819	120826
24983	39227	4	applied	\N	\N	\N	\N	120827	120827	120828
24988	39230	0	applied	\N	\N	1000000000	\N	120839	120839	120840
24988	39176	1	applied	\N	\N	\N	\N	120692	120692	120693
24988	39072	2	applied	\N	\N	\N	\N	120372	120372	120373
24988	39075	3	applied	\N	\N	\N	\N	120382	120382	120383
24988	39078	4	applied	\N	\N	\N	\N	120388	120388	120389
24988	39082	5	applied	\N	\N	\N	\N	120397	120397	120398
24988	39083	6	applied	\N	\N	\N	\N	120399	120399	120400
24988	39088	7	applied	\N	\N	\N	\N	120411	120411	120412
24988	39092	8	applied	\N	\N	\N	\N	120424	120424	120425
24988	39093	9	applied	\N	\N	\N	\N	120426	120426	120427
24988	39098	10	applied	\N	\N	\N	\N	120439	120439	120440
24988	39101	11	applied	\N	\N	\N	\N	120447	120447	120448
24988	39105	12	applied	\N	\N	\N	\N	120458	120458	120459
24988	39108	13	applied	\N	\N	\N	\N	120467	120467	120468
24988	39111	14	applied	\N	\N	\N	\N	120476	120476	120477
24988	39115	15	applied	\N	\N	\N	\N	120486	120486	120487
24988	39118	16	applied	\N	\N	\N	\N	120494	120494	120495
24988	39121	17	applied	\N	\N	\N	\N	120502	120502	120503
24988	39125	18	applied	\N	\N	\N	\N	120511	120511	120512
24988	39128	19	applied	\N	\N	\N	\N	120522	120522	120523
24988	39129	20	applied	\N	\N	\N	\N	120524	120524	120525
24988	39134	21	applied	\N	\N	\N	\N	120554	120554	120555
24988	39138	22	applied	\N	\N	\N	\N	120564	120564	120565
24988	39141	23	applied	\N	\N	\N	\N	120587	120587	120588
24988	39144	24	applied	\N	\N	\N	\N	120595	120595	120596
24988	39148	25	applied	\N	\N	\N	\N	120604	120604	120605
24988	39149	26	applied	\N	\N	\N	\N	120606	120606	120607
24988	39154	27	applied	\N	\N	\N	\N	120620	120620	120621
24988	39157	28	applied	\N	\N	\N	\N	120627	120627	120628
24988	39161	29	applied	\N	\N	\N	\N	120637	120637	120638
24988	39164	30	applied	\N	\N	\N	\N	120657	120657	120658
24988	39167	31	applied	\N	\N	\N	\N	120666	120666	120667
24988	39171	32	applied	\N	\N	\N	\N	120675	120675	120676
24988	39174	33	applied	\N	\N	\N	\N	120688	120688	120689
24988	39175	34	applied	\N	\N	\N	\N	120690	120690	120691
24988	39182	35	applied	\N	\N	\N	\N	120706	120706	120707
24988	39185	36	applied	\N	\N	\N	\N	120714	120714	120715
24988	39188	37	applied	\N	\N	\N	\N	120722	120722	120723
24988	39189	38	applied	\N	\N	\N	\N	120724	120724	120725
24988	39190	39	applied	\N	\N	\N	\N	120726	120726	120727
24988	39198	40	applied	\N	\N	\N	\N	120744	120744	120745
24988	39201	41	applied	\N	\N	\N	\N	120759	120759	120760
24988	39205	42	applied	\N	\N	\N	\N	120769	120769	120770
24988	39208	43	applied	\N	\N	\N	\N	120781	120781	120782
24988	39209	44	applied	\N	\N	\N	\N	120783	120783	120784
24988	39215	45	applied	\N	\N	\N	\N	120799	120799	120800
24988	39218	46	applied	\N	\N	\N	\N	120807	120807	120808
24988	39221	47	applied	\N	\N	\N	\N	120815	120815	120816
24988	39224	48	applied	\N	\N	\N	\N	120821	120821	120822
24988	39228	49	applied	\N	\N	\N	\N	120835	120835	120836
24988	39229	50	applied	\N	\N	\N	\N	120837	120837	120838
24988	39231	51	applied	\N	\N	\N	\N	120841	120841	120842
24988	39073	52	applied	\N	\N	\N	\N	120374	120374	120375
24988	39076	53	applied	\N	\N	\N	\N	120384	120384	120860
24988	39079	54	applied	\N	\N	\N	\N	120390	120390	120861
24988	39086	55	applied	\N	\N	\N	\N	120405	120405	120862
24988	39087	56	applied	\N	\N	\N	\N	120407	120407	120393
24988	39089	57	applied	\N	\N	\N	\N	120413	120413	120402
24988	39094	58	applied	\N	\N	\N	\N	120428	120428	120863
24988	39095	59	applied	\N	\N	\N	\N	120430	120430	120864
24988	39074	60	applied	\N	\N	\N	\N	120376	120376	120408
24988	39077	61	applied	\N	\N	\N	\N	120386	120386	120865
24988	39080	63	applied	\N	\N	\N	\N	120392	120392	120416
24988	39084	64	applied	\N	\N	\N	\N	120401	120401	120418
24988	39085	65	applied	\N	\N	\N	\N	120403	120403	120867
24988	39081	66	applied	\N	\N	\N	\N	120394	120394	120429
24988	39090	67	applied	\N	\N	\N	\N	120415	120415	120868
24988	39104	68	applied	\N	\N	\N	\N	120453	120453	120869
24988	39113	69	applied	\N	\N	\N	\N	120480	120480	120431
24988	39124	70	applied	\N	\N	\N	\N	120508	120508	120870
24988	39137	71	applied	\N	\N	\N	\N	120560	120560	120433
24988	39147	72	applied	\N	\N	\N	\N	120601	120601	120871
24932	39134	0	applied	\N	\N	\N	\N	120554	120554	120555
24932	39135	1	applied	\N	\N	\N	\N	120556	120556	120557
24932	39136	2	applied	\N	\N	\N	\N	120558	120558	120559
24932	39137	3	applied	\N	\N	\N	\N	120560	120560	120561
24952	39161	0	applied	\N	\N	\N	\N	120637	120637	120638
24952	39162	1	applied	\N	\N	\N	\N	120639	120639	120640
24952	39163	2	applied	\N	\N	\N	\N	120641	120641	120642
24955	39164	0	applied	\N	\N	\N	\N	120657	120657	120658
24955	39165	1	applied	\N	\N	\N	\N	120659	120659	120660
24955	39166	2	applied	\N	\N	\N	\N	120661	120661	120662
24957	39167	0	applied	\N	\N	\N	\N	120666	120666	120667
24957	39168	1	applied	\N	\N	\N	\N	120668	120668	120669
24957	39169	2	applied	\N	\N	\N	\N	120670	120670	120671
24957	39170	3	applied	\N	\N	\N	\N	120672	120672	120673
24960	39171	0	applied	\N	\N	\N	\N	120675	120675	120676
24960	39172	1	applied	\N	\N	\N	\N	120677	120677	120678
24960	39173	2	applied	\N	\N	\N	\N	120679	120679	120680
24967	39198	0	applied	\N	\N	\N	\N	120744	120744	120745
24967	39199	2	applied	\N	\N	\N	\N	120747	120747	120748
24967	39200	3	applied	\N	\N	\N	\N	120749	120749	120750
24969	39201	0	applied	\N	\N	\N	\N	120759	120759	120760
24969	39202	1	applied	\N	\N	\N	\N	120761	120761	120762
24969	39203	2	applied	\N	\N	\N	\N	120763	120763	120764
24969	39204	3	applied	\N	\N	\N	\N	120765	120765	120766
24975	39208	0	applied	\N	\N	\N	\N	120781	120781	120782
24975	39209	1	applied	\N	\N	\N	\N	120783	120783	120784
24975	39207	2	applied	\N	\N	\N	\N	120775	120775	120777
24975	39210	3	applied	\N	\N	\N	\N	120785	120785	120786
24975	39211	4	applied	\N	\N	\N	\N	120787	120787	120788
24975	39212	5	applied	\N	\N	\N	\N	120789	120789	120790
24975	39213	6	applied	\N	\N	\N	\N	120791	120791	120792
24975	39214	7	applied	\N	\N	\N	\N	120793	120793	120794
24976	39215	0	applied	\N	\N	\N	\N	120799	120799	120800
24976	39216	1	applied	\N	\N	\N	\N	120801	120801	120802
24976	39217	2	applied	\N	\N	\N	\N	120803	120803	120804
24984	39224	0	applied	\N	\N	\N	\N	120821	120821	120822
24984	39225	1	applied	\N	\N	\N	\N	120823	120823	120824
24984	39226	2	applied	\N	\N	\N	\N	120825	120825	120820
24984	39223	3	applied	\N	\N	\N	\N	120819	120819	120826
24984	39227	4	applied	\N	\N	\N	\N	120827	120827	120828
24990	39239	0	applied	\N	\N	\N	\N	120897	120897	120898
24990	39240	1	applied	\N	\N	\N	\N	120899	120899	120900
24990	39241	2	applied	\N	\N	\N	\N	120901	120901	120902
24990	39242	3	applied	\N	\N	\N	\N	120903	120903	120904
24990	39243	4	applied	\N	\N	\N	\N	120905	120905	120906
24990	39244	5	applied	\N	\N	\N	\N	120907	120907	120908
24990	39245	6	applied	\N	\N	\N	\N	120909	120909	120910
24990	39246	7	applied	\N	\N	\N	\N	120911	120911	120912
24990	39247	8	applied	\N	\N	\N	\N	120913	120913	120914
24990	39248	9	applied	\N	\N	\N	\N	120915	120915	120916
24995	39228	0	applied	\N	\N	\N	\N	120835	120835	120836
24995	39229	1	applied	\N	\N	\N	\N	120837	120837	120838
24995	39230	2	applied	\N	\N	1000000000	\N	120839	120839	120840
24995	39231	3	applied	\N	\N	\N	\N	120841	120841	120842
24995	39239	4	applied	\N	\N	\N	\N	120897	120897	120898
24995	39240	5	applied	\N	\N	\N	\N	120899	120899	120900
24995	39241	6	applied	\N	\N	\N	\N	120901	120901	120902
24995	39249	7	applied	\N	\N	\N	\N	120919	120919	120920
24995	39232	8	applied	\N	\N	\N	\N	120843	120843	120844
24995	39233	9	applied	\N	\N	\N	\N	120845	120845	120846
24995	39234	10	applied	\N	\N	\N	\N	120847	120847	120848
24995	39242	11	applied	\N	\N	\N	\N	120903	120903	120932
24995	39235	12	applied	\N	\N	\N	\N	120849	120849	120933
24995	39236	13	applied	\N	\N	\N	\N	120851	120851	120934
24995	39237	14	applied	\N	\N	\N	\N	120853	120853	120935
24995	39238	15	applied	\N	\N	\N	\N	120855	120855	120904
24995	39243	16	applied	\N	\N	\N	\N	120905	120905	120906
24995	39244	17	applied	\N	\N	\N	\N	120907	120907	120908
24995	39245	18	applied	\N	\N	\N	\N	120909	120909	120910
24995	39250	19	applied	\N	\N	\N	\N	120921	120921	120936
24995	39246	20	applied	\N	\N	\N	\N	120911	120911	120937
24995	39247	21	applied	\N	\N	\N	\N	120913	120913	120938
24995	39248	22	applied	\N	\N	\N	\N	120915	120915	120922
24995	39251	23	applied	\N	\N	\N	\N	120923	120923	120924
24995	39252	24	applied	\N	\N	\N	\N	120939	120939	120940
25000	39259	0	applied	\N	\N	\N	\N	120958	120958	120959
25000	39260	1	applied	\N	\N	\N	\N	120960	120960	120961
25000	39261	2	applied	\N	\N	\N	\N	120962	120962	120963
25000	39262	3	applied	\N	\N	\N	\N	120964	120964	120965
25000	39263	4	applied	\N	\N	\N	\N	120966	120966	120967
25000	39264	5	applied	\N	\N	\N	\N	120968	120968	120969
25000	39265	6	applied	\N	\N	\N	\N	120970	120970	120971
25006	39270	0	applied	\N	\N	\N	\N	120987	120987	120988
25006	39271	1	applied	\N	\N	\N	\N	120989	120989	120990
25006	39272	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120991	120991	\N
25006	39273	3	applied	\N	\N	1000000000	\N	99842	99842	120992
25006	39274	4	applied	\N	\N	\N	\N	120993	120993	120994
25006	39275	5	applied	\N	\N	1000000000	\N	120995	120995	120996
25006	39276	6	applied	\N	\N	\N	\N	120997	120997	120998
25011	39284	0	applied	\N	\N	\N	\N	121017	121017	121018
25011	39285	1	applied	\N	\N	\N	\N	121019	121019	121020
25012	39286	0	applied	\N	\N	\N	\N	121022	121022	121023
25012	39287	2	applied	\N	\N	\N	\N	121025	121025	121026
25012	39288	3	applied	\N	\N	\N	\N	121027	121027	121028
25016	39291	0	applied	\N	\N	\N	\N	121041	121041	121042
25016	39292	1	applied	\N	\N	\N	\N	121043	121043	121044
25019	39291	0	applied	\N	\N	\N	\N	121041	121041	121042
25019	39293	1	applied	\N	\N	\N	\N	121048	121048	121049
25019	39294	2	applied	\N	\N	\N	\N	121050	121050	121051
25019	39295	3	applied	\N	\N	\N	\N	121052	121052	121053
25019	39296	4	applied	\N	\N	\N	\N	121054	121054	121055
25019	39292	5	applied	\N	\N	\N	\N	121043	121043	121056
25019	39297	6	applied	\N	\N	\N	\N	121057	121057	121058
25019	39298	7	applied	\N	\N	\N	\N	121059	121059	121060
25019	39299	8	applied	\N	\N	\N	\N	121061	121061	121062
25022	39300	0	applied	\N	\N	\N	\N	121067	121067	44452
25022	39301	1	applied	\N	\N	\N	\N	121068	121068	121069
25022	39302	2	applied	\N	\N	\N	\N	121070	121070	121071
25022	39303	3	applied	\N	\N	\N	\N	121072	121072	121073
25024	39304	0	applied	\N	\N	\N	\N	121076	121076	121077
25030	39309	0	applied	\N	\N	\N	\N	121095	121095	121096
25030	39310	1	applied	\N	\N	\N	\N	121097	121097	121098
25030	39311	2	applied	\N	\N	\N	\N	121099	121099	121100
25030	39312	3	applied	\N	\N	\N	\N	121101	121101	121102
25030	39313	4	applied	\N	\N	\N	\N	121103	121103	121104
25031	39314	0	applied	\N	\N	\N	\N	121109	121109	121110
25031	39315	1	applied	\N	\N	\N	\N	121111	121111	121112
25036	39321	0	applied	\N	\N	\N	\N	121131	121131	121132
25036	39322	1	applied	\N	\N	\N	\N	121133	121133	121134
24933	39138	0	applied	\N	\N	\N	\N	120564	120564	120565
24933	39139	1	applied	\N	\N	\N	\N	120566	120566	120567
24933	39140	2	applied	\N	\N	\N	\N	120568	120568	120569
24935	39138	0	applied	\N	\N	\N	\N	120564	120564	120565
24935	39139	1	applied	\N	\N	\N	\N	120566	120566	120567
24935	39140	2	applied	\N	\N	\N	\N	120568	120568	120569
24937	39141	0	applied	\N	\N	\N	\N	120587	120587	120588
24937	39142	1	applied	\N	\N	\N	\N	120589	120589	120590
24937	39143	2	applied	\N	\N	\N	\N	120591	120591	120592
24940	39148	0	applied	\N	\N	\N	\N	120604	120604	120605
24940	39149	1	applied	\N	\N	\N	\N	120606	120606	120607
24940	39150	2	applied	\N	\N	\N	\N	120608	120608	120609
24940	39151	3	applied	\N	\N	\N	\N	120610	120610	120611
24940	39152	4	applied	\N	\N	\N	\N	120612	120612	120613
24940	39153	5	applied	\N	\N	\N	\N	120614	120614	120615
24953	39138	0	applied	\N	\N	\N	\N	120564	120564	120565
24953	39141	1	applied	\N	\N	\N	\N	120587	120587	120588
24953	39144	2	applied	\N	\N	\N	\N	120595	120595	120596
24953	39148	3	applied	\N	\N	\N	\N	120604	120604	120605
24953	39149	4	applied	\N	\N	\N	\N	120606	120606	120607
24953	39154	5	applied	\N	\N	\N	\N	120620	120620	120621
24953	39157	6	applied	\N	\N	\N	\N	120627	120627	120628
24953	39161	7	applied	\N	\N	\N	\N	120637	120637	120638
24953	39147	8	applied	\N	\N	\N	\N	120601	120601	120643
24953	39158	9	applied	\N	\N	\N	\N	120629	120629	120567
24953	39139	10	applied	\N	\N	\N	\N	120566	120566	120644
24953	39143	11	applied	\N	\N	\N	\N	120591	120591	120645
24953	39146	12	applied	\N	\N	\N	\N	120599	120599	120590
24953	39152	13	applied	\N	\N	\N	\N	120612	120612	120592
24953	39153	14	applied	\N	\N	\N	\N	120614	120614	120646
24953	39155	15	applied	\N	\N	\N	\N	120622	120622	120647
24953	39160	16	applied	\N	\N	\N	\N	120633	120633	120602
24953	39163	17	applied	\N	\N	\N	\N	120641	120641	120648
24953	39140	18	applied	\N	\N	\N	\N	120568	120568	120649
24953	39142	19	applied	\N	\N	\N	\N	120589	120589	120613
24953	39145	20	applied	\N	\N	\N	\N	120597	120597	120650
24953	39150	21	applied	\N	\N	\N	\N	120608	120608	120651
24953	39151	22	applied	\N	\N	\N	\N	120610	120610	120652
24953	39156	23	applied	\N	\N	\N	\N	120624	120624	120653
24953	39159	24	applied	\N	\N	\N	\N	120631	120631	120654
24953	39162	25	applied	\N	\N	\N	\N	120639	120639	120642
24961	39171	0	applied	\N	\N	\N	\N	120675	120675	120676
24961	39172	1	applied	\N	\N	\N	\N	120677	120677	120678
24961	39173	2	applied	\N	\N	\N	\N	120679	120679	120680
24962	39174	0	applied	\N	\N	\N	\N	120688	120688	120689
24962	39175	1	applied	\N	\N	\N	\N	120690	120690	120691
24962	39176	2	applied	\N	\N	\N	\N	120692	120692	120693
24962	39177	3	applied	\N	\N	\N	\N	120694	120694	120695
24962	39178	4	applied	\N	\N	\N	\N	120696	120696	120697
24962	39179	5	applied	\N	\N	\N	\N	120698	120698	120699
24962	39180	6	applied	\N	\N	\N	\N	120700	120700	120701
24962	39181	7	applied	\N	\N	\N	\N	120702	120702	120703
24964	39182	0	applied	\N	\N	\N	\N	120706	120706	120707
24964	39183	1	applied	\N	\N	\N	\N	120708	120708	120709
24964	39184	2	applied	\N	\N	\N	\N	120710	120710	120711
24968	39198	0	applied	\N	\N	\N	\N	120744	120744	120745
24968	39199	2	applied	\N	\N	\N	\N	120747	120747	120748
24968	39200	3	applied	\N	\N	\N	\N	120749	120749	120750
24970	39205	0	applied	\N	\N	\N	\N	120769	120769	120770
24970	39206	1	applied	\N	\N	\N	\N	120771	120771	120772
24977	39215	0	applied	\N	\N	\N	\N	120799	120799	120800
24977	39216	1	applied	\N	\N	\N	\N	120801	120801	120802
24977	39217	2	applied	\N	\N	\N	\N	120803	120803	120804
24979	39221	0	applied	\N	\N	\N	\N	120815	120815	120816
24979	39222	1	applied	\N	\N	\N	\N	120817	120817	120818
24979	39223	2	applied	\N	\N	\N	\N	120819	120819	120820
24981	39221	0	applied	\N	\N	\N	\N	120815	120815	120816
24981	39222	1	applied	\N	\N	\N	\N	120817	120817	120818
24985	39224	0	applied	\N	\N	\N	\N	120821	120821	120822
24985	39225	1	applied	\N	\N	\N	\N	120823	120823	120824
24985	39226	2	applied	\N	\N	\N	\N	120825	120825	120820
24986	39228	0	applied	\N	\N	\N	\N	120835	120835	120836
24986	39229	1	applied	\N	\N	\N	\N	120837	120837	120838
24986	39230	2	applied	\N	\N	1000000000	\N	120839	120839	120840
24986	39231	3	applied	\N	\N	\N	\N	120841	120841	120842
24986	39232	4	applied	\N	\N	\N	\N	120843	120843	120844
24986	39233	5	applied	\N	\N	\N	\N	120845	120845	120846
24986	39234	6	applied	\N	\N	\N	\N	120847	120847	120848
24986	39235	7	applied	\N	\N	\N	\N	120849	120849	120850
24986	39236	8	applied	\N	\N	\N	\N	120851	120851	120852
24986	39237	9	applied	\N	\N	\N	\N	120853	120853	120854
24986	39238	10	applied	\N	\N	\N	\N	120855	120855	120856
24992	39249	0	applied	\N	\N	\N	\N	120919	120919	120920
24992	39250	1	applied	\N	\N	\N	\N	120921	120921	120922
24994	38978	0	applied	\N	\N	\N	\N	120126	120126	120545
24994	38879	1	applied	\N	\N	\N	\N	120929	120929	119880
24996	39253	0	applied	\N	\N	\N	\N	120942	120942	120943
24996	39254	1	applied	\N	\N	\N	\N	120944	120944	120945
24996	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120946	120946	\N
24996	39256	3	applied	\N	\N	\N	\N	120947	120947	120948
24996	39257	4	applied	\N	\N	\N	\N	120949	120949	120950
24999	39259	0	applied	\N	\N	\N	\N	120958	120958	120959
24999	39260	1	applied	\N	\N	\N	\N	120960	120960	120961
24999	39261	2	applied	\N	\N	\N	\N	120962	120962	120963
24999	39262	3	applied	\N	\N	\N	\N	120964	120964	120965
24999	39263	4	applied	\N	\N	\N	\N	120966	120966	120967
24999	39264	5	applied	\N	\N	\N	\N	120968	120968	120969
24999	39265	6	applied	\N	\N	\N	\N	120970	120970	120971
24999	39266	7	applied	\N	\N	\N	\N	120972	120972	120973
25004	39267	0	applied	\N	\N	\N	\N	120978	120978	120979
25004	39268	1	applied	\N	\N	\N	\N	120980	120980	120981
25004	39269	2	applied	\N	\N	\N	\N	120982	120982	120983
25008	39277	0	applied	\N	\N	\N	\N	121002	121002	121003
25008	39278	1	applied	\N	\N	\N	\N	121004	121004	121005
25008	39279	2	applied	\N	\N	\N	\N	121006	121006	121007
25015	39291	0	applied	\N	\N	\N	\N	121041	121041	121042
25015	39292	1	applied	\N	\N	\N	\N	121043	121043	121044
25020	39291	0	applied	\N	\N	\N	\N	121041	121041	121042
25020	39293	1	applied	\N	\N	\N	\N	121048	121048	121049
25020	39294	2	applied	\N	\N	\N	\N	121050	121050	121051
25020	39295	3	applied	\N	\N	\N	\N	121052	121052	121053
25020	39296	4	applied	\N	\N	\N	\N	121054	121054	121055
25020	39292	5	applied	\N	\N	\N	\N	121043	121043	121056
25020	39297	6	applied	\N	\N	\N	\N	121057	121057	121058
25020	39298	7	applied	\N	\N	\N	\N	121059	121059	121060
25020	39299	8	applied	\N	\N	\N	\N	121061	121061	121062
25028	39307	0	applied	\N	\N	\N	\N	121089	121089	121090
25028	39308	1	applied	\N	\N	\N	\N	121091	121091	121092
25029	39309	0	applied	\N	\N	\N	\N	121095	121095	121096
24988	39158	73	applied	\N	\N	\N	\N	120629	120629	120435
24988	39169	74	applied	\N	\N	\N	\N	120670	120670	120872
24988	39179	75	applied	\N	\N	\N	\N	120698	120698	120442
24988	39192	76	applied	\N	\N	\N	\N	120730	120730	120873
24988	39203	77	applied	\N	\N	\N	\N	120763	120763	120874
24988	39214	78	applied	\N	\N	\N	\N	120793	120793	120444
24988	39226	79	applied	\N	\N	\N	\N	120825	120825	120875
24988	39234	80	applied	\N	\N	\N	\N	120847	120847	120876
24988	39091	81	applied	\N	\N	\N	\N	120417	120417	120877
24988	39096	82	applied	\N	\N	\N	\N	120432	120432	120454
24988	39097	83	applied	\N	\N	\N	\N	120434	120434	120461
24988	39099	84	applied	\N	\N	\N	\N	120441	120441	120878
24988	39103	85	applied	\N	\N	\N	\N	120451	120451	120879
24988	39106	86	applied	\N	\N	\N	\N	120460	120460	120470
24988	39110	87	applied	\N	\N	\N	\N	120471	120471	120472
24988	39112	88	applied	\N	\N	\N	\N	120478	120478	120479
24988	39116	89	applied	\N	\N	\N	\N	120488	120488	120880
24988	39120	90	applied	\N	\N	\N	\N	120498	120498	120484
24988	39122	91	applied	\N	\N	\N	\N	120504	120504	120489
24988	39127	92	applied	\N	\N	\N	\N	120515	120515	120881
24988	39132	93	applied	\N	\N	\N	\N	120530	120530	120882
24988	39133	94	applied	\N	\N	\N	\N	120532	120532	120497
24988	39136	95	applied	\N	\N	\N	\N	120558	120558	120499
24988	39139	96	applied	\N	\N	\N	\N	120566	120566	120505
24988	39143	97	applied	\N	\N	\N	\N	120591	120591	120883
24988	39146	98	applied	\N	\N	\N	\N	120599	120599	120509
24988	39152	99	applied	\N	\N	\N	\N	120612	120612	120517
24988	39153	100	applied	\N	\N	\N	\N	120614	120614	120518
24988	39155	101	applied	\N	\N	\N	\N	120622	120622	120582
24988	39160	102	applied	\N	\N	\N	\N	120633	120633	120527
24988	39163	103	applied	\N	\N	\N	\N	120641	120641	120884
24988	39165	104	applied	\N	\N	\N	\N	120659	120659	120584
24988	39170	105	applied	\N	\N	\N	\N	120672	120672	120885
24988	39172	106	applied	\N	\N	\N	\N	120677	120677	120886
24988	39180	107	applied	\N	\N	\N	\N	120700	120700	120557
24988	39181	108	applied	\N	\N	\N	\N	120702	120702	120559
24988	39183	109	applied	\N	\N	\N	\N	120708	120708	120643
24988	39187	110	applied	\N	\N	\N	\N	120718	120718	120887
24988	39191	111	applied	\N	\N	\N	\N	120728	120728	120569
24988	39193	112	applied	\N	\N	\N	\N	120732	120732	120888
24988	39194	113	applied	\N	\N	\N	\N	120734	120734	120889
24988	39199	114	applied	\N	\N	\N	\N	120747	120747	120890
24988	39202	115	applied	\N	\N	\N	\N	120761	120761	120598
24988	39206	116	applied	\N	\N	\N	\N	120771	120771	120600
24988	39212	117	applied	\N	\N	\N	\N	120789	120789	120891
24988	39213	118	applied	\N	\N	\N	\N	120791	120791	120609
24988	39217	119	applied	\N	\N	\N	\N	120803	120803	120649
24988	39220	120	applied	\N	\N	\N	\N	120811	120811	120892
24988	39222	121	applied	\N	\N	\N	\N	120817	120817	120893
24988	39225	122	applied	\N	\N	\N	\N	120823	120823	120650
24988	39232	123	applied	\N	\N	\N	\N	120843	120843	120894
24988	39233	124	applied	\N	\N	\N	\N	120845	120845	120625
24988	39235	125	applied	\N	\N	\N	\N	120849	120849	120652
24989	39239	0	applied	\N	\N	\N	\N	120897	120897	120898
24989	39240	1	applied	\N	\N	\N	\N	120899	120899	120900
24989	39241	2	applied	\N	\N	\N	\N	120901	120901	120902
24989	39242	3	applied	\N	\N	\N	\N	120903	120903	120904
24989	39243	4	applied	\N	\N	\N	\N	120905	120905	120906
24989	39244	5	applied	\N	\N	\N	\N	120907	120907	120908
24989	39245	6	applied	\N	\N	\N	\N	120909	120909	120910
24989	39246	7	applied	\N	\N	\N	\N	120911	120911	120912
24989	39247	8	applied	\N	\N	\N	\N	120913	120913	120914
24989	39248	9	applied	\N	\N	\N	\N	120915	120915	120916
24991	39249	0	applied	\N	\N	\N	\N	120919	120919	120920
24991	39250	1	applied	\N	\N	\N	\N	120921	120921	120922
24991	39251	2	applied	\N	\N	\N	\N	120923	120923	120924
24993	39249	0	applied	\N	\N	\N	\N	120919	120919	120920
24993	39250	1	applied	\N	\N	\N	\N	120921	120921	120922
24993	39251	2	applied	\N	\N	\N	\N	120923	120923	120924
24998	39253	0	applied	\N	\N	\N	\N	120942	120942	120943
24998	39254	1	applied	\N	\N	\N	\N	120944	120944	120945
24998	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120946	120946	\N
24998	39256	3	applied	\N	\N	\N	\N	120947	120947	120948
24998	39257	4	applied	\N	\N	\N	\N	120949	120949	120950
25003	39267	0	applied	\N	\N	\N	\N	120978	120978	120979
25003	39268	1	applied	\N	\N	\N	\N	120980	120980	120981
25003	39269	2	applied	\N	\N	\N	\N	120982	120982	120983
25005	39270	0	applied	\N	\N	\N	\N	120987	120987	120988
25005	39271	1	applied	\N	\N	\N	\N	120989	120989	120990
25005	39272	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120991	120991	\N
25005	39273	3	applied	\N	\N	1000000000	\N	99842	99842	120992
25005	39274	4	applied	\N	\N	\N	\N	120993	120993	120994
25005	39275	5	applied	\N	\N	1000000000	\N	120995	120995	120996
25005	39276	6	applied	\N	\N	\N	\N	120997	120997	120998
25010	39282	0	applied	\N	\N	\N	\N	121013	121013	121014
25010	39283	1	applied	\N	\N	\N	\N	121015	121015	121016
25014	39289	0	applied	\N	\N	\N	\N	121034	121034	121035
25014	39290	1	applied	\N	\N	\N	\N	121036	121036	121037
25021	39293	0	applied	\N	\N	\N	\N	121048	121048	121049
25021	39294	1	applied	\N	\N	\N	\N	121050	121050	121051
25021	39295	2	applied	\N	\N	\N	\N	121052	121052	121053
25021	39296	3	applied	\N	\N	\N	\N	121054	121054	121056
25021	39297	4	applied	\N	\N	\N	\N	121057	121057	121058
25021	39298	5	applied	\N	\N	\N	\N	121059	121059	121060
25021	39299	6	applied	\N	\N	\N	\N	121061	121061	121062
25023	39300	0	applied	\N	\N	\N	\N	121067	121067	44452
25023	39301	1	applied	\N	\N	\N	\N	121068	121068	121069
25023	39302	2	applied	\N	\N	\N	\N	121070	121070	121071
25023	39303	3	applied	\N	\N	\N	\N	121072	121072	121073
25027	39305	0	applied	\N	\N	\N	\N	121081	121081	121082
25027	39306	1	applied	\N	\N	\N	\N	121083	121083	121084
25033	39316	0	applied	\N	\N	\N	\N	121116	121116	121117
25033	39317	1	applied	\N	\N	\N	\N	121118	121118	121119
25034	39318	0	applied	\N	\N	\N	\N	121121	121121	121122
25034	39319	1	applied	\N	\N	\N	\N	121123	121123	121124
25034	39320	2	applied	\N	\N	\N	\N	121125	121125	121126
25038	39230	0	applied	\N	\N	1000000000	\N	120839	120839	120840
25038	39176	1	applied	\N	\N	\N	\N	120692	120692	120693
25038	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120946	120946	\N
25038	39272	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	120991	120991	\N
25038	39273	4	applied	\N	\N	1000000000	\N	99842	99842	120992
25038	39275	5	applied	\N	\N	1000000000	\N	120995	120995	120996
25038	39100	6	applied	\N	\N	\N	\N	120443	120443	120873
25038	39102	7	applied	\N	\N	\N	\N	120449	120449	120875
25038	39107	8	applied	\N	\N	\N	\N	120462	120462	120877
25038	39109	9	applied	\N	\N	\N	\N	120469	120469	121139
25038	39114	10	applied	\N	\N	\N	\N	120483	120483	120878
25025	39304	0	applied	\N	\N	\N	\N	121076	121076	121077
25026	39305	0	applied	\N	\N	\N	\N	121081	121081	121082
25026	39306	1	applied	\N	\N	\N	\N	121083	121083	121084
25032	39314	0	applied	\N	\N	\N	\N	121109	121109	121110
25032	39315	1	applied	\N	\N	\N	\N	121111	121111	121112
25037	39321	0	applied	\N	\N	\N	\N	121131	121131	121132
25037	39322	1	applied	\N	\N	\N	\N	121133	121133	121134
25041	39322	0	applied	\N	\N	\N	\N	121133	121133	121134
25050	39344	0	applied	\N	\N	\N	\N	121201	121201	121202
25050	39345	1	applied	\N	\N	\N	\N	121205	121205	121206
25052	39348	0	applied	\N	\N	\N	\N	121212	121212	121213
25052	39349	1	applied	\N	\N	\N	\N	121214	121214	121215
25057	39362	0	applied	\N	\N	\N	\N	121248	121248	121249
25057	39363	1	applied	\N	\N	\N	\N	121250	121250	121251
25057	39364	2	applied	\N	\N	\N	\N	121252	121252	121253
25060	39369	0	applied	\N	\N	\N	\N	121265	121265	121266
25060	39370	1	applied	\N	\N	\N	\N	121267	121267	121268
25060	39371	2	applied	\N	\N	\N	\N	121269	121269	121270
25062	39372	0	applied	\N	\N	\N	\N	121275	121275	121276
25062	39373	1	applied	\N	\N	\N	\N	121277	121277	121278
25062	39374	2	applied	\N	\N	\N	\N	121279	121279	121280
25067	39385	0	applied	\N	\N	\N	\N	121310	121310	121311
25067	39386	1	applied	\N	\N	\N	\N	121312	121312	121313
25067	39387	2	applied	\N	\N	\N	\N	121314	121314	121315
25070	39398	0	applied	\N	\N	\N	\N	121342	121342	121343
25070	39399	1	applied	\N	\N	\N	\N	121344	121344	121345
25070	39400	2	applied	\N	\N	\N	\N	121346	121346	121347
25070	39401	3	applied	\N	\N	\N	\N	121348	121348	121349
25070	39402	4	applied	\N	\N	\N	\N	121350	121350	121351
25070	39403	5	applied	\N	\N	\N	\N	121352	121352	121353
25070	39404	6	applied	\N	\N	\N	\N	121354	121354	121355
25071	39400	0	applied	\N	\N	\N	\N	121346	121346	121347
25071	39401	1	applied	\N	\N	\N	\N	121348	121348	121349
25071	39402	2	applied	\N	\N	\N	\N	121350	121350	121351
25073	39398	0	applied	\N	\N	\N	\N	121342	121342	121343
25073	39399	1	applied	\N	\N	\N	\N	121344	121344	121345
25073	39405	2	applied	\N	\N	\N	\N	121358	121358	121359
25073	39406	3	applied	\N	\N	\N	\N	121360	121360	121361
25073	39403	4	applied	\N	\N	\N	\N	121352	121352	121362
25073	39404	5	applied	\N	\N	\N	\N	121354	121354	121363
25073	39407	6	applied	\N	\N	\N	\N	121364	121364	121365
25085	39431	0	applied	\N	\N	\N	\N	121429	121429	121430
25085	39432	1	applied	\N	\N	\N	\N	121431	121431	121432
25085	39433	2	applied	\N	\N	\N	\N	121433	121433	121434
25085	39434	3	applied	\N	\N	\N	\N	121435	121435	121436
25085	39435	4	applied	\N	\N	\N	\N	121437	121437	121438
25085	39436	5	applied	\N	\N	\N	\N	121439	121439	121440
25085	39437	6	applied	\N	\N	\N	\N	121441	121441	121442
25085	39438	7	applied	\N	\N	\N	\N	121443	121443	121444
25085	39439	8	applied	\N	\N	\N	\N	121445	121445	121446
25085	39440	9	applied	\N	\N	\N	\N	121447	121447	121448
25085	39441	10	applied	\N	\N	\N	\N	121449	121449	121450
25085	39442	11	applied	\N	\N	\N	\N	121451	121451	121452
25085	39443	12	applied	\N	\N	\N	\N	121453	121453	121454
25088	39448	0	applied	\N	\N	\N	\N	121468	121468	121469
25088	39449	1	applied	\N	\N	\N	\N	121470	121470	121471
25088	39450	2	applied	\N	\N	\N	\N	121472	121472	121473
25088	39451	3	applied	\N	\N	\N	\N	121474	121474	121475
25088	39452	4	applied	\N	\N	\N	\N	121476	121476	121477
25088	39453	5	applied	\N	\N	\N	\N	121478	121478	121479
25094	39458	0	applied	\N	\N	\N	\N	121495	121495	121496
25094	39459	1	applied	\N	\N	\N	\N	121497	121497	121498
25094	39460	2	applied	\N	\N	\N	\N	121499	121499	121500
25096	39458	0	applied	\N	\N	\N	\N	121495	121495	121496
25096	39459	1	applied	\N	\N	\N	\N	121497	121497	121498
25096	39460	2	applied	\N	\N	\N	\N	121499	121499	121500
25099	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25099	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25099	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25107	39465	0	applied	\N	\N	\N	\N	121541	121541	121542
25107	39466	1	applied	\N	\N	\N	\N	121543	121543	121544
25107	39467	2	applied	\N	\N	\N	\N	121545	121545	121546
25107	39468	3	applied	\N	\N	\N	\N	121547	121547	121548
25107	39469	4	applied	\N	\N	\N	\N	121549	121549	121550
25107	39470	5	applied	\N	\N	\N	\N	121551	121551	121552
25107	39464	6	applied	\N	\N	\N	\N	121537	121537	121553
25107	39471	7	applied	\N	\N	\N	\N	121554	121554	121555
25107	39472	8	applied	\N	\N	\N	\N	121556	121556	121557
25107	39473	9	applied	\N	\N	\N	\N	121558	121558	121559
25109	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25109	39465	1	applied	\N	\N	\N	\N	121541	121541	121542
25109	39466	2	applied	\N	\N	\N	\N	121543	121543	121544
25109	39467	4	applied	\N	\N	\N	\N	121545	121545	121546
25109	39468	5	applied	\N	\N	\N	\N	121547	121547	121567
25109	39462	6	applied	\N	\N	\N	\N	121509	121509	121568
25109	39469	7	applied	\N	\N	\N	\N	121549	121549	121538
25109	39470	8	applied	\N	\N	\N	\N	121551	121551	121563
25109	39463	9	applied	\N	\N	\N	\N	121511	121511	121552
25109	39464	10	applied	\N	\N	\N	\N	121537	121537	121553
25109	39471	11	applied	\N	\N	\N	\N	121554	121554	121555
25109	39472	12	applied	\N	\N	\N	\N	121556	121556	121557
25109	39473	13	applied	\N	\N	\N	\N	121558	121558	121559
25112	39481	0	applied	\N	\N	\N	\N	121587	121587	121588
25112	39482	1	applied	\N	\N	\N	\N	121589	121589	121590
25112	39483	2	applied	\N	\N	\N	\N	121591	121591	121592
25114	39484	0	applied	\N	\N	\N	\N	121595	121595	121596
25114	39485	1	applied	\N	\N	\N	\N	121597	121597	121598
25114	39486	2	applied	\N	\N	\N	\N	121599	121599	121600
25119	39490	0	applied	\N	\N	\N	\N	121609	121609	121610
25119	39491	1	applied	\N	\N	\N	\N	121611	121611	121612
25119	39492	2	applied	\N	\N	\N	\N	121613	121613	121614
25119	39493	3	applied	\N	\N	\N	\N	121615	121615	121616
25119	39494	4	applied	\N	\N	\N	\N	121617	121617	121618
25119	39495	5	applied	\N	\N	\N	\N	121619	121619	121620
25122	39496	0	applied	\N	\N	\N	\N	121634	121634	121635
25122	39497	1	applied	\N	\N	\N	\N	121636	121636	121637
25122	39498	2	applied	\N	\N	\N	\N	121638	121638	121639
25127	39506	0	applied	\N	\N	\N	\N	121664	121664	121665
25127	39507	1	applied	\N	\N	\N	\N	121666	121666	121667
25127	39508	2	applied	\N	\N	\N	\N	121668	121668	121669
25130	39513	0	applied	\N	\N	\N	\N	121680	121680	121681
25130	39514	1	applied	\N	\N	\N	\N	121682	121682	121683
25130	39515	2	applied	\N	\N	\N	\N	121684	121684	121685
25132	39516	0	applied	\N	\N	\N	\N	121689	121689	121690
25132	39517	1	applied	\N	\N	\N	\N	121691	121691	121692
25132	39518	2	applied	\N	\N	\N	\N	121693	121693	121694
25132	39519	3	applied	\N	\N	\N	\N	121695	121695	121696
25132	39520	4	applied	\N	\N	\N	\N	121697	121697	121698
25132	39521	5	applied	\N	\N	\N	\N	121699	121699	121700
25132	39522	6	applied	\N	\N	\N	\N	121701	121701	121702
25029	39310	1	applied	\N	\N	\N	\N	121097	121097	121098
25029	39311	2	applied	\N	\N	\N	\N	121099	121099	121100
25029	39312	3	applied	\N	\N	\N	\N	121101	121101	121102
25029	39313	4	applied	\N	\N	\N	\N	121103	121103	121104
25035	39318	0	applied	\N	\N	\N	\N	121121	121121	121122
25035	39319	1	applied	\N	\N	\N	\N	121123	121123	121124
25035	39320	2	applied	\N	\N	\N	\N	121125	121125	121126
25039	39321	0	applied	\N	\N	\N	\N	121131	121131	121132
25039	39322	1	applied	\N	\N	\N	\N	121133	121133	121134
25043	39329	0	applied	\N	\N	\N	\N	121163	121163	121164
25043	39330	1	applied	\N	\N	\N	\N	121165	121165	121166
25043	39331	2	applied	\N	\N	1000000000	\N	121167	121167	121168
25043	39332	3	applied	\N	\N	\N	\N	121169	121169	121170
25043	39333	4	applied	\N	\N	\N	\N	121171	121171	121172
25046	39339	0	applied	\N	\N	\N	\N	121187	121187	121188
25048	39341	0	applied	\N	\N	\N	\N	121195	121195	121196
25048	39342	1	applied	\N	\N	\N	\N	121197	121197	121198
25048	39343	2	applied	\N	\N	\N	\N	121199	121199	121200
25056	39354	0	applied	\N	\N	\N	\N	121231	121231	121232
25056	39355	1	applied	\N	\N	\N	\N	121233	121233	121234
25056	39356	2	applied	\N	\N	\N	\N	121235	121235	121236
25056	39357	3	applied	\N	\N	\N	\N	121237	121237	121238
25056	39358	4	applied	\N	\N	\N	\N	121239	121239	121240
25056	39359	5	applied	\N	\N	\N	\N	121241	121241	121242
25056	39360	6	applied	\N	\N	\N	\N	121243	121243	121244
25056	39361	7	applied	\N	\N	\N	\N	121245	121245	121246
25059	39365	0	applied	\N	\N	\N	\N	121254	121254	121255
25059	39366	1	applied	\N	\N	\N	\N	121256	121256	121257
25059	39367	2	applied	\N	\N	\N	\N	121258	121258	121259
25059	39368	3	applied	\N	\N	\N	\N	121260	121260	121261
25061	39369	0	applied	\N	\N	\N	\N	121265	121265	121266
25061	39370	1	applied	\N	\N	\N	\N	121267	121267	121268
25061	39371	2	applied	\N	\N	\N	\N	121269	121269	121270
25063	39372	0	applied	\N	\N	\N	\N	121275	121275	121276
25063	39373	1	applied	\N	\N	\N	\N	121277	121277	121278
25063	39374	2	applied	\N	\N	\N	\N	121279	121279	121280
25066	39382	0	applied	\N	\N	\N	\N	121302	121302	121303
25066	39383	1	applied	\N	\N	\N	\N	121304	121304	121305
25066	39384	2	applied	\N	\N	\N	\N	121306	121306	121307
25069	39395	0	applied	\N	\N	\N	\N	121334	121334	121335
25069	39396	1	applied	\N	\N	\N	\N	121336	121336	121337
25069	39397	2	applied	\N	\N	\N	\N	121338	121338	121339
25074	39408	0	applied	\N	\N	\N	\N	121369	121369	121370
25074	39409	1	applied	\N	\N	\N	\N	121371	121371	121372
25074	39410	2	applied	\N	\N	\N	\N	121373	121373	121374
25076	39411	0	applied	\N	\N	\N	\N	121377	121377	121378
25076	39412	1	applied	\N	\N	\N	\N	121379	121379	121380
25076	39413	2	applied	\N	\N	\N	\N	121381	121381	121382
25076	39414	3	applied	\N	\N	\N	\N	121383	121383	121384
25079	39415	0	applied	\N	\N	\N	\N	121388	121388	121389
25079	39416	1	applied	\N	\N	\N	\N	121390	121390	121391
25079	39417	2	applied	\N	\N	\N	\N	121393	121393	121394
25082	39425	0	applied	\N	\N	\N	\N	121414	121414	121415
25082	39426	1	applied	\N	\N	\N	\N	121416	121416	121417
25082	39427	2	applied	\N	\N	\N	\N	121418	121418	121419
25083	39428	0	applied	\N	\N	\N	\N	121421	121421	121422
25083	39429	1	applied	\N	\N	\N	\N	121423	121423	121424
25083	39430	2	applied	\N	\N	\N	\N	121425	121425	121426
25086	39444	0	applied	\N	\N	\N	\N	121459	121459	121460
25086	39445	1	applied	\N	\N	\N	\N	121461	121461	121462
25086	39446	2	applied	\N	\N	\N	\N	121463	121463	121464
25086	39447	3	applied	\N	\N	\N	\N	121465	121465	121466
25091	39454	0	applied	\N	\N	\N	\N	121484	121484	121485
25091	39457	1	applied	\N	\N	\N	\N	121490	121490	121489
25091	39455	2	applied	\N	\N	\N	\N	121486	121486	121491
25091	39456	3	applied	\N	\N	\N	\N	121488	121488	121492
25093	39454	0	applied	\N	\N	\N	\N	121484	121484	121485
25093	39457	1	applied	\N	\N	\N	\N	121490	121490	121489
25093	39455	2	applied	\N	\N	\N	\N	121486	121486	121491
25093	39456	3	applied	\N	\N	\N	\N	121488	121488	121492
25095	39458	0	applied	\N	\N	\N	\N	121495	121495	121496
25095	39459	1	applied	\N	\N	\N	\N	121497	121497	121498
25095	39460	2	applied	\N	\N	\N	\N	121499	121499	121500
25097	39458	0	applied	\N	\N	\N	\N	121495	121495	121496
25097	39459	1	applied	\N	\N	\N	\N	121497	121497	121498
25097	39460	2	applied	\N	\N	\N	\N	121499	121499	121500
25100	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25100	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25100	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25108	39465	0	applied	\N	\N	\N	\N	121541	121541	121542
25108	39466	1	applied	\N	\N	\N	\N	121543	121543	121544
25108	39467	2	applied	\N	\N	\N	\N	121545	121545	121546
25108	39468	3	applied	\N	\N	\N	\N	121547	121547	121562
25108	39471	4	applied	\N	\N	\N	\N	121554	121554	121563
25108	39472	5	applied	\N	\N	\N	\N	121556	121556	121552
25113	39484	0	applied	\N	\N	\N	\N	121595	121595	121596
25113	39485	1	applied	\N	\N	\N	\N	121597	121597	121598
25113	39486	2	applied	\N	\N	\N	\N	121599	121599	121600
25116	39490	0	applied	\N	\N	\N	\N	121609	121609	121610
25116	39491	1	applied	\N	\N	\N	\N	121611	121611	121612
25116	39492	2	applied	\N	\N	\N	\N	121613	121613	121614
25116	39493	3	applied	\N	\N	\N	\N	121615	121615	121616
25116	39494	4	applied	\N	\N	\N	\N	121617	121617	121618
25116	39495	5	applied	\N	\N	\N	\N	121619	121619	121620
25118	39490	0	applied	\N	\N	\N	\N	121609	121609	121610
25118	39491	1	applied	\N	\N	\N	\N	121611	121611	121612
25118	39492	2	applied	\N	\N	\N	\N	121613	121613	121614
25118	39493	3	applied	\N	\N	\N	\N	121615	121615	121616
25118	39494	4	applied	\N	\N	\N	\N	121617	121617	121618
25118	39495	5	applied	\N	\N	\N	\N	121619	121619	121620
25121	39496	0	applied	\N	\N	\N	\N	121634	121634	121635
25121	39497	1	applied	\N	\N	\N	\N	121636	121636	121637
25121	39498	2	applied	\N	\N	\N	\N	121638	121638	121639
25128	39509	0	applied	\N	\N	\N	\N	121671	121671	121672
25128	39510	1	applied	\N	\N	\N	\N	121673	121673	121674
25128	39511	2	applied	\N	\N	\N	\N	121675	121675	121676
25128	39512	3	applied	\N	\N	\N	\N	121677	121677	121678
25133	39516	0	applied	\N	\N	\N	\N	121689	121689	121690
25133	39517	1	applied	\N	\N	\N	\N	121691	121691	121692
25133	39518	2	applied	\N	\N	\N	\N	121693	121693	121694
25133	39519	3	applied	\N	\N	\N	\N	121695	121695	121696
25133	39520	4	applied	\N	\N	\N	\N	121697	121697	121698
25133	39521	5	applied	\N	\N	\N	\N	121699	121699	121700
25133	39522	6	applied	\N	\N	\N	\N	121701	121701	121702
25135	39516	0	applied	\N	\N	\N	\N	121689	121689	121690
25135	39517	1	applied	\N	\N	\N	\N	121691	121691	121692
25135	39518	2	applied	\N	\N	\N	\N	121693	121693	121694
25135	39519	3	applied	\N	\N	\N	\N	121695	121695	121696
25135	39520	4	applied	\N	\N	\N	\N	121697	121697	121698
25135	39521	5	applied	\N	\N	\N	\N	121699	121699	121700
25038	39117	11	applied	\N	\N	\N	\N	120490	120490	121140
25038	39119	12	applied	\N	\N	\N	\N	120496	120496	120472
25038	39123	13	applied	\N	\N	\N	\N	120506	120506	120481
25038	39126	14	applied	\N	\N	\N	\N	120513	120513	120484
25038	39130	15	applied	\N	\N	\N	\N	120526	120526	120577
25038	39131	16	applied	\N	\N	\N	\N	120528	120528	120882
25038	39135	17	applied	\N	\N	\N	\N	120556	120556	120579
25038	39140	18	applied	\N	\N	\N	\N	120568	120568	120505
25038	39142	19	applied	\N	\N	\N	\N	120589	120589	120507
25038	39145	20	applied	\N	\N	\N	\N	120597	120597	120517
25038	39150	21	applied	\N	\N	\N	\N	120608	120608	120516
25038	39151	22	applied	\N	\N	\N	\N	120610	120610	120527
25038	39156	23	applied	\N	\N	\N	\N	120624	120624	120529
25038	39159	25	applied	\N	\N	\N	\N	120631	120631	120885
25038	39162	26	applied	\N	\N	\N	\N	120639	120639	121142
25038	39166	27	applied	\N	\N	\N	\N	120661	120661	120559
25038	39168	28	applied	\N	\N	\N	\N	120668	120668	120567
25038	39173	29	applied	\N	\N	\N	\N	120679	120679	120569
25038	39177	30	applied	\N	\N	\N	\N	120694	120694	120590
25038	39178	31	applied	\N	\N	\N	\N	120696	120696	120890
25042	39323	0	applied	\N	\N	\N	\N	121149	121149	121150
25042	39324	1	applied	\N	\N	\N	\N	121151	121151	121152
25042	39325	2	applied	\N	\N	\N	\N	121153	121153	121154
25042	39326	3	applied	\N	\N	\N	\N	121155	121155	121156
25042	39327	4	applied	\N	\N	\N	\N	121157	121157	121158
25042	39328	5	applied	\N	\N	\N	\N	121159	121159	121160
25045	39337	0	applied	\N	\N	\N	\N	121181	121181	121182
25045	39338	1	applied	\N	\N	\N	\N	121183	121183	121184
25053	39348	0	applied	\N	\N	\N	\N	121212	121212	121213
25053	39349	1	applied	\N	\N	\N	\N	121214	121214	121215
25055	39350	0	applied	\N	\N	\N	\N	121221	121221	121222
25055	39351	1	applied	\N	\N	\N	\N	121223	121223	121224
25055	39352	2	applied	\N	\N	\N	\N	121225	121225	121226
25055	39353	3	applied	\N	\N	\N	\N	121227	121227	121228
25058	39365	0	applied	\N	\N	\N	\N	121254	121254	121255
25058	39366	1	applied	\N	\N	\N	\N	121256	121256	121257
25058	39367	2	applied	\N	\N	\N	\N	121258	121258	121259
25058	39368	3	applied	\N	\N	\N	\N	121260	121260	121261
25065	39378	0	applied	\N	\N	\N	\N	121292	121292	121293
25065	39379	1	applied	\N	\N	\N	\N	121294	121294	121295
25065	39380	2	applied	\N	\N	\N	\N	121296	121296	121297
25065	39381	3	applied	\N	\N	\N	\N	121298	121298	121299
25068	39388	0	applied	\N	\N	\N	\N	121318	121318	121319
25068	39389	1	applied	\N	\N	\N	\N	121320	121320	121321
25068	39390	2	applied	\N	\N	\N	\N	121322	121322	121323
25068	39391	3	applied	\N	\N	\N	\N	121324	121324	121325
25068	39392	4	applied	\N	\N	\N	\N	121326	121326	121327
25068	39393	5	applied	\N	\N	\N	\N	121328	121328	121329
25068	39394	6	applied	\N	\N	\N	\N	121330	121330	121331
25078	39415	0	applied	\N	\N	\N	\N	121388	121388	121389
25078	39416	1	applied	\N	\N	\N	\N	121390	121390	121391
25090	39454	0	applied	\N	\N	\N	\N	121484	121484	121485
25090	39455	1	applied	\N	\N	\N	\N	121486	121486	121487
25090	39456	2	applied	\N	\N	\N	\N	121488	121488	121489
25101	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25101	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25101	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25103	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25103	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25103	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25105	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25105	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25105	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25110	39474	0	applied	\N	\N	\N	\N	121571	121571	121572
25110	39475	1	applied	\N	\N	\N	\N	121573	121573	121574
25110	39476	2	applied	\N	\N	\N	\N	121575	121575	121576
25115	39487	0	applied	\N	\N	\N	\N	121601	121601	121602
25115	39488	1	applied	\N	\N	\N	\N	121603	121603	121604
25115	39489	2	applied	\N	\N	\N	\N	121605	121605	121606
25123	39496	0	applied	\N	\N	\N	\N	121634	121634	121635
25123	39497	1	applied	\N	\N	\N	\N	121636	121636	121637
25123	39498	2	applied	\N	\N	\N	\N	121638	121638	121639
25125	39499	0	applied	\N	\N	\N	\N	121645	121645	121646
25125	39500	1	applied	\N	\N	\N	\N	121647	121647	121648
25125	39501	2	applied	\N	\N	\N	\N	121649	121649	121650
25125	39502	3	applied	\N	\N	\N	\N	121651	121651	121652
25141	39526	0	applied	\N	\N	\N	\N	121721	121721	121722
25141	39527	1	applied	\N	\N	\N	\N	121723	121723	121724
25141	39528	2	applied	\N	\N	\N	\N	121725	121725	121726
25143	39529	0	applied	\N	\N	\N	\N	121731	121731	121732
25143	39530	1	applied	\N	\N	\N	\N	121733	121733	121734
25143	39531	2	applied	\N	\N	\N	\N	121735	121735	121736
25150	39506	0	applied	\N	\N	\N	\N	121664	121664	121665
25150	39509	1	applied	\N	\N	\N	\N	121671	121671	121672
25150	39513	2	applied	\N	\N	\N	\N	121680	121680	121681
25150	39516	3	applied	\N	\N	\N	\N	121689	121689	121690
25150	39517	4	applied	\N	\N	\N	\N	121691	121691	121692
25150	39523	5	applied	\N	\N	\N	\N	121710	121710	121711
25150	39526	6	applied	\N	\N	\N	\N	121721	121721	121722
25150	39529	7	applied	\N	\N	\N	\N	121731	121731	121732
25150	39532	8	applied	\N	\N	\N	\N	121740	121740	121741
25150	39537	9	applied	\N	\N	\N	\N	121752	121752	121753
25150	39540	10	applied	\N	\N	\N	\N	121762	121762	121763
25150	39543	11	applied	\N	\N	\N	\N	121773	121773	121774
25150	39507	12	applied	\N	\N	\N	\N	121666	121666	121667
25150	39510	13	applied	\N	\N	\N	\N	121673	121673	121783
25150	39534	14	applied	\N	\N	1000000000	\N	121744	121744	121745
25150	39508	15	applied	\N	\N	\N	\N	121668	121668	121674
25150	39515	16	applied	\N	\N	\N	\N	121684	121684	121784
25150	39521	17	applied	\N	\N	\N	\N	121699	121699	121678
25150	39522	18	applied	\N	\N	\N	\N	121701	121701	121785
25150	39525	19	applied	\N	\N	\N	\N	121714	121714	121786
25150	39527	20	applied	\N	\N	\N	\N	121723	121723	121787
25150	39531	21	applied	\N	\N	\N	\N	121735	121735	121694
25150	39533	22	applied	\N	\N	\N	\N	121742	121742	121788
25150	39538	23	applied	\N	\N	\N	\N	121755	121755	121698
25150	39541	24	applied	\N	\N	\N	\N	121764	121764	121700
25150	39544	25	applied	\N	\N	\N	\N	121775	121775	121702
25150	39546	26	applied	\N	\N	\N	\N	121779	121779	23829
25150	39511	27	applied	\N	\N	\N	\N	121675	121675	121713
25150	39514	28	applied	\N	\N	\N	\N	121682	121682	121789
25150	39518	29	applied	\N	\N	\N	\N	121693	121693	121790
25150	39520	30	applied	\N	\N	\N	\N	121697	121697	121791
25150	39524	31	applied	\N	\N	\N	\N	121712	121712	121736
25150	39528	32	applied	\N	\N	\N	\N	121725	121725	121747
25150	39530	33	applied	\N	\N	\N	\N	121733	121733	121749
25150	39536	34	applied	\N	\N	\N	\N	121748	121748	121792
25150	39539	35	applied	\N	\N	\N	\N	121757	121757	121793
25150	39542	36	applied	\N	\N	\N	\N	121766	121766	121794
25150	39512	37	applied	\N	\N	\N	\N	121677	121677	121767
25040	39321	0	applied	\N	\N	\N	\N	121131	121131	121132
25040	39322	1	applied	\N	\N	\N	\N	121133	121133	121134
25044	39334	0	applied	\N	\N	\N	\N	121174	121174	121175
25044	39335	1	applied	\N	\N	\N	\N	121176	121176	121177
25044	39336	2	applied	\N	\N	\N	\N	121178	121178	121179
25047	39339	0	applied	\N	\N	\N	\N	121187	121187	121188
25047	39340	1	applied	\N	\N	\N	\N	121191	121191	121192
25049	39344	0	applied	\N	\N	\N	\N	121201	121201	121202
25051	39346	0	applied	\N	\N	\N	\N	121208	121208	121209
25051	39345	1	applied	\N	\N	\N	\N	121205	121205	121206
25051	39347	2	applied	\N	\N	\N	\N	121210	121210	121211
25054	39348	0	applied	\N	\N	\N	\N	121212	121212	121213
25054	39349	1	applied	\N	\N	\N	\N	121214	121214	121215
25064	39375	0	applied	\N	\N	\N	\N	121284	121284	121285
25064	39376	1	applied	\N	\N	\N	\N	121286	121286	121287
25064	39377	2	applied	\N	\N	\N	\N	121288	121288	121289
25072	39398	0	applied	\N	\N	\N	\N	121342	121342	121343
25072	39399	1	applied	\N	\N	\N	\N	121344	121344	121345
25072	39405	2	applied	\N	\N	\N	\N	121358	121358	121359
25072	39406	3	applied	\N	\N	\N	\N	121360	121360	121361
25072	39403	4	applied	\N	\N	\N	\N	121352	121352	121362
25072	39404	5	applied	\N	\N	\N	\N	121354	121354	121363
25072	39407	6	applied	\N	\N	\N	\N	121364	121364	121365
25075	39408	0	applied	\N	\N	\N	\N	121369	121369	121370
25075	39409	1	applied	\N	\N	\N	\N	121371	121371	121372
25075	39410	2	applied	\N	\N	\N	\N	121373	121373	121374
25077	39411	0	applied	\N	\N	\N	\N	121377	121377	121378
25077	39412	1	applied	\N	\N	\N	\N	121379	121379	121380
25077	39413	2	applied	\N	\N	\N	\N	121381	121381	121382
25077	39414	3	applied	\N	\N	\N	\N	121383	121383	121384
25080	39418	0	applied	\N	\N	\N	\N	121396	121396	121397
25080	39419	1	applied	\N	\N	\N	\N	121398	121398	121399
25080	39420	2	applied	\N	\N	\N	\N	121400	121400	121401
25080	39421	3	applied	\N	\N	\N	\N	121402	121402	121403
25080	39422	4	applied	\N	\N	\N	\N	121404	121404	121405
25080	39417	5	applied	\N	\N	\N	\N	121393	121393	121406
25080	39423	6	applied	\N	\N	\N	\N	121407	121407	121408
25080	39424	7	applied	\N	\N	\N	\N	121409	121409	121410
25081	39418	0	applied	\N	\N	\N	\N	121396	121396	121397
25081	39419	1	applied	\N	\N	\N	\N	121398	121398	121399
25081	39420	2	applied	\N	\N	\N	\N	121400	121400	121401
25081	39421	3	applied	\N	\N	\N	\N	121402	121402	121403
25081	39422	4	applied	\N	\N	\N	\N	121404	121404	121405
25081	39417	5	applied	\N	\N	\N	\N	121393	121393	121406
25081	39423	6	applied	\N	\N	\N	\N	121407	121407	121408
25081	39424	7	applied	\N	\N	\N	\N	121409	121409	121410
25084	39431	0	applied	\N	\N	\N	\N	121429	121429	121430
25084	39432	1	applied	\N	\N	\N	\N	121431	121431	121432
25084	39433	2	applied	\N	\N	\N	\N	121433	121433	121434
25084	39434	3	applied	\N	\N	\N	\N	121435	121435	121436
25084	39435	4	applied	\N	\N	\N	\N	121437	121437	121438
25084	39436	5	applied	\N	\N	\N	\N	121439	121439	121440
25084	39437	6	applied	\N	\N	\N	\N	121441	121441	121442
25084	39438	7	applied	\N	\N	\N	\N	121443	121443	121444
25084	39439	8	applied	\N	\N	\N	\N	121445	121445	121446
25084	39440	9	applied	\N	\N	\N	\N	121447	121447	121448
25084	39441	10	applied	\N	\N	\N	\N	121449	121449	121450
25084	39442	11	applied	\N	\N	\N	\N	121451	121451	121452
25084	39443	12	applied	\N	\N	\N	\N	121453	121453	121454
25087	39448	0	applied	\N	\N	\N	\N	121468	121468	121469
25087	39449	1	applied	\N	\N	\N	\N	121470	121470	121471
25087	39450	2	applied	\N	\N	\N	\N	121472	121472	121473
25087	39451	3	applied	\N	\N	\N	\N	121474	121474	121475
25087	39452	4	applied	\N	\N	\N	\N	121476	121476	121477
25087	39453	5	applied	\N	\N	\N	\N	121478	121478	121479
25089	39448	0	applied	\N	\N	\N	\N	121468	121468	121469
25089	39449	1	applied	\N	\N	\N	\N	121470	121470	121471
25089	39450	2	applied	\N	\N	\N	\N	121472	121472	121473
25089	39451	3	applied	\N	\N	\N	\N	121474	121474	121475
25089	39452	4	applied	\N	\N	\N	\N	121476	121476	121477
25089	39453	5	applied	\N	\N	\N	\N	121478	121478	121479
25092	39454	0	applied	\N	\N	\N	\N	121484	121484	121485
25092	39457	1	applied	\N	\N	\N	\N	121490	121490	121489
25092	39455	2	applied	\N	\N	\N	\N	121486	121486	121491
25092	39456	3	applied	\N	\N	\N	\N	121488	121488	121492
25098	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25098	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25098	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25102	39462	0	applied	\N	\N	\N	\N	121509	121509	121510
25102	39463	1	applied	\N	\N	\N	\N	121511	121511	121512
25104	39415	0	applied	\N	\N	\N	\N	121388	121388	121389
25104	39418	1	applied	\N	\N	\N	\N	121396	121396	121397
25104	39419	2	applied	\N	\N	\N	\N	121398	121398	121399
25104	39425	3	applied	\N	\N	\N	\N	121414	121414	121415
25104	39428	4	applied	\N	\N	\N	\N	121421	121421	121422
25104	39431	5	applied	\N	\N	\N	\N	121429	121429	121430
25104	39432	6	applied	\N	\N	\N	\N	121431	121431	121432
25104	39433	7	applied	\N	\N	\N	\N	121433	121433	121434
25104	39434	8	applied	\N	\N	\N	\N	121435	121435	121436
25104	39444	9	applied	\N	\N	\N	\N	121459	121459	121460
25104	39448	10	applied	\N	\N	\N	\N	121468	121468	121469
25104	39449	11	applied	\N	\N	\N	\N	121470	121470	121471
25104	39454	12	applied	\N	\N	\N	\N	121484	121484	121485
25104	39458	13	applied	\N	\N	\N	\N	121495	121495	121496
25104	39416	14	applied	\N	\N	\N	\N	121390	121390	121391
25104	39420	15	applied	\N	\N	\N	\N	121400	121400	121401
25104	39421	16	applied	\N	\N	\N	\N	121402	121402	121403
25104	39426	17	applied	\N	\N	\N	\N	121416	121416	121522
25104	39429	18	applied	\N	\N	\N	\N	121423	121423	121406
25104	39422	19	applied	\N	\N	\N	\N	121404	121404	121523
25104	39439	20	applied	\N	\N	\N	\N	121445	121445	121524
25104	39446	21	applied	\N	\N	\N	\N	121463	121463	121408
25104	39456	22	applied	\N	\N	\N	\N	121488	121488	121525
25104	39417	23	applied	\N	\N	\N	\N	121393	121393	121526
25104	39423	24	applied	\N	\N	\N	\N	121407	121407	121527
25104	39424	25	applied	\N	\N	\N	\N	121409	121409	121424
25104	39427	26	applied	\N	\N	\N	\N	121418	121418	121426
25104	39430	27	applied	\N	\N	\N	\N	121425	121425	121438
25104	39435	28	applied	\N	\N	\N	\N	121437	121437	121440
25104	39436	29	applied	\N	\N	\N	\N	121439	121439	121442
25104	39437	30	applied	\N	\N	\N	\N	121441	121441	121444
25104	39438	31	applied	\N	\N	\N	\N	121443	121443	121448
25104	39447	32	applied	\N	\N	\N	\N	121465	121465	121528
25104	39451	33	applied	\N	\N	\N	\N	121474	121474	121454
25104	39452	34	applied	\N	\N	\N	\N	121476	121476	121464
25104	39457	35	applied	\N	\N	\N	\N	121490	121490	121466
25104	39460	36	applied	\N	\N	\N	\N	121499	121499	121529
25104	39440	37	applied	\N	\N	\N	\N	121447	121447	121475
25104	39441	38	applied	\N	\N	\N	\N	121449	121449	121530
25104	39442	39	applied	\N	\N	\N	\N	121451	121451	121531
25104	39443	40	applied	\N	\N	\N	\N	121453	121453	121532
25104	39445	41	applied	\N	\N	\N	\N	121461	121461	121489
25104	39450	42	applied	\N	\N	\N	\N	121472	121472	121491
25104	39453	43	applied	\N	\N	\N	\N	121478	121478	121533
25104	39455	44	applied	\N	\N	\N	\N	121486	121486	121534
25104	39459	45	applied	\N	\N	\N	\N	121497	121497	121500
25106	39461	0	applied	\N	\N	\N	\N	121507	121507	121508
25106	39462	1	applied	\N	\N	\N	\N	121509	121509	121510
25106	39463	2	applied	\N	\N	\N	\N	121511	121511	121512
25106	39464	3	applied	\N	\N	\N	\N	121537	121537	121538
25111	39477	0	applied	\N	\N	\N	\N	121578	121578	121579
25111	39478	1	applied	\N	\N	\N	\N	121580	121580	121581
25111	39479	2	applied	\N	\N	\N	\N	121582	121582	121583
25111	39480	3	applied	\N	\N	\N	\N	121584	121584	121585
25117	39490	0	applied	\N	\N	\N	\N	121609	121609	121610
25117	39491	1	applied	\N	\N	\N	\N	121611	121611	121612
25117	39492	2	applied	\N	\N	\N	\N	121613	121613	121614
25117	39493	3	applied	\N	\N	\N	\N	121615	121615	121616
25117	39494	4	applied	\N	\N	\N	\N	121617	121617	121618
25117	39495	5	applied	\N	\N	\N	\N	121619	121619	121620
25120	38978	0	applied	\N	\N	\N	\N	120126	120126	120549
25120	38879	1	applied	\N	\N	\N	\N	120544	120544	119880
25120	38873	2	applied	\N	\N	\N	\N	119830	119830	119831
25120	38876	3	applied	\N	\N	\N	\N	119871	119871	119872
25120	39019	4	applied	\N	\N	1000000000	\N	120232	120232	120233
25120	39045	5	applied	\N	\N	\N	\N	120298	120298	120299
25120	39230	6	applied	\N	\N	1000000000	\N	120839	120839	120840
25120	38880	7	applied	\N	\N	\N	\N	119881	119881	119882
25120	38884	8	applied	\N	\N	\N	\N	119892	119892	119893
25120	38887	9	applied	\N	\N	\N	\N	119900	119900	119901
25120	38888	10	applied	\N	\N	\N	\N	119902	119902	119903
25120	38889	11	applied	\N	\N	\N	\N	119904	119904	119905
25120	38900	12	applied	\N	\N	\N	\N	119928	119928	119929
25120	38903	13	applied	\N	\N	\N	\N	119937	119937	119938
25120	38904	14	applied	\N	\N	\N	\N	119939	119939	119940
25120	38911	15	applied	\N	\N	\N	\N	119958	119958	119959
25120	38914	16	applied	\N	\N	\N	\N	119965	119965	119966
25120	38917	17	applied	\N	\N	\N	\N	119975	119975	119976
25120	38918	18	applied	\N	\N	\N	\N	119977	119977	119978
25120	38924	19	applied	\N	\N	\N	\N	119990	119990	119991
25120	38927	20	applied	\N	\N	\N	\N	119997	119997	119998
25120	38928	21	applied	\N	\N	\N	\N	119999	119999	120000
25120	38929	22	applied	\N	\N	\N	\N	120001	120001	120002
25120	38937	23	applied	\N	\N	\N	\N	120023	120023	120024
25120	38938	24	applied	\N	\N	\N	\N	120025	120025	120026
25120	38944	25	applied	\N	\N	\N	\N	120042	120042	120043
25120	38947	26	applied	\N	\N	\N	\N	120053	120053	120054
25120	38950	27	applied	\N	\N	\N	\N	120061	120061	120062
25120	38954	28	applied	\N	\N	\N	\N	120073	120073	120074
25120	38955	29	applied	\N	\N	\N	\N	120075	120075	120076
25120	38956	30	applied	\N	\N	\N	\N	120077	120077	120078
25120	38964	31	applied	\N	\N	\N	\N	120095	120095	120096
25120	38965	32	applied	\N	\N	\N	\N	120097	120097	120098
25120	38971	33	applied	\N	\N	\N	\N	120110	120110	120111
25120	38972	34	applied	\N	\N	\N	\N	120112	120112	120113
25120	38979	35	applied	\N	\N	\N	\N	120128	120128	120129
25120	38982	36	applied	\N	\N	\N	\N	120135	120135	120136
25120	38985	37	applied	\N	\N	\N	\N	120144	120144	120145
25120	38986	38	applied	\N	\N	\N	\N	120146	120146	120147
25120	38992	39	applied	\N	\N	\N	\N	120163	120163	120164
25120	38995	40	applied	\N	\N	\N	\N	120170	120170	120171
25120	38996	41	applied	\N	\N	\N	\N	120172	120172	120173
25120	39003	42	applied	\N	\N	\N	\N	120189	120189	120190
25120	39004	43	applied	\N	\N	\N	\N	120191	120191	120192
25120	39010	44	applied	\N	\N	\N	\N	120204	120204	120205
25120	39015	45	applied	\N	\N	\N	\N	120214	120214	120215
25120	39018	46	applied	\N	\N	\N	\N	120230	120230	120231
25120	39020	47	applied	\N	\N	\N	\N	120234	120234	120235
25120	39021	48	applied	\N	\N	\N	\N	120236	120236	120237
25120	39032	49	applied	\N	\N	\N	\N	120261	120261	120262
25120	39035	50	applied	\N	\N	\N	\N	120268	120268	120269
25120	39039	51	applied	\N	\N	\N	\N	120279	120279	120280
25120	39042	52	applied	\N	\N	\N	\N	120292	120292	120293
25120	39046	53	applied	\N	\N	\N	\N	120300	120300	120301
25120	39049	54	applied	\N	\N	\N	\N	120310	120310	120311
25120	39052	55	applied	\N	\N	\N	\N	120320	120320	120321
25120	39055	56	applied	\N	\N	\N	\N	120329	120329	120330
25120	39058	57	applied	\N	\N	\N	\N	120335	120335	120336
25120	39061	58	applied	\N	\N	\N	\N	120346	120346	120347
25120	39064	59	applied	\N	\N	\N	\N	120355	120355	120356
25120	39065	60	applied	\N	\N	\N	\N	120357	120357	120358
25120	39072	61	applied	\N	\N	\N	\N	120372	120372	120373
25120	39075	62	applied	\N	\N	\N	\N	120382	120382	120383
25120	39078	63	applied	\N	\N	\N	\N	120388	120388	120389
25120	39082	64	applied	\N	\N	\N	\N	120397	120397	120398
25120	39083	65	applied	\N	\N	\N	\N	120399	120399	120400
25120	39088	66	applied	\N	\N	\N	\N	120411	120411	120412
25120	39092	67	applied	\N	\N	\N	\N	120424	120424	120425
25120	39093	68	applied	\N	\N	\N	\N	120426	120426	120427
25120	39098	69	applied	\N	\N	\N	\N	120439	120439	120440
25120	39101	70	applied	\N	\N	\N	\N	120447	120447	120448
25120	39105	71	applied	\N	\N	\N	\N	120458	120458	120459
25120	39108	72	applied	\N	\N	\N	\N	120467	120467	120468
25120	39111	73	applied	\N	\N	\N	\N	120476	120476	120477
25120	39115	74	applied	\N	\N	\N	\N	120486	120486	120487
25120	39118	75	applied	\N	\N	\N	\N	120494	120494	120495
25120	39121	76	applied	\N	\N	\N	\N	120502	120502	120503
25120	39125	77	applied	\N	\N	\N	\N	120511	120511	120512
25120	39128	78	applied	\N	\N	\N	\N	120522	120522	120523
25120	39129	79	applied	\N	\N	\N	\N	120524	120524	120525
25120	39134	80	applied	\N	\N	\N	\N	120554	120554	120555
25120	39138	81	applied	\N	\N	\N	\N	120564	120564	120565
25120	39141	83	applied	\N	\N	\N	\N	120587	120587	120588
25120	39144	84	applied	\N	\N	\N	\N	120595	120595	120596
25120	39148	85	applied	\N	\N	\N	\N	120604	120604	120605
25120	39149	86	applied	\N	\N	\N	\N	120606	120606	120607
25120	39154	87	applied	\N	\N	\N	\N	120620	120620	120621
25120	39157	88	applied	\N	\N	\N	\N	120627	120627	120628
25120	39161	89	applied	\N	\N	\N	\N	120637	120637	120638
25120	39164	90	applied	\N	\N	\N	\N	120657	120657	120658
25120	39167	91	applied	\N	\N	\N	\N	120666	120666	120667
25120	39171	92	applied	\N	\N	\N	\N	120675	120675	120676
25120	39174	93	applied	\N	\N	\N	\N	120688	120688	120689
25120	39175	94	applied	\N	\N	\N	\N	120690	120690	120691
25120	39182	95	applied	\N	\N	\N	\N	120706	120706	120707
25120	39185	96	applied	\N	\N	\N	\N	120714	120714	120715
25120	39188	97	applied	\N	\N	\N	\N	120722	120722	120723
25120	39189	98	applied	\N	\N	\N	\N	120724	120724	120725
25120	39190	99	applied	\N	\N	\N	\N	120726	120726	120727
25120	39198	100	applied	\N	\N	\N	\N	120744	120744	120745
25120	39201	101	applied	\N	\N	\N	\N	120759	120759	120760
25120	39205	102	applied	\N	\N	\N	\N	120769	120769	120770
25120	39208	103	applied	\N	\N	\N	\N	120781	120781	120782
25120	39209	104	applied	\N	\N	\N	\N	120783	120783	120784
25120	39215	105	applied	\N	\N	\N	\N	120799	120799	120800
25120	39218	106	applied	\N	\N	\N	\N	120807	120807	120808
25120	39221	107	applied	\N	\N	\N	\N	120815	120815	120816
25120	39224	108	applied	\N	\N	\N	\N	120821	120821	120822
25120	39228	109	applied	\N	\N	\N	\N	120835	120835	120836
25120	39229	110	applied	\N	\N	\N	\N	120837	120837	120838
25120	39231	111	applied	\N	\N	\N	\N	120841	120841	120842
25120	39239	112	applied	\N	\N	\N	\N	120897	120897	120898
25120	39240	113	applied	\N	\N	\N	\N	120899	120899	120900
25120	39241	114	applied	\N	\N	\N	\N	120901	120901	120902
25120	39249	115	applied	\N	\N	\N	\N	120919	120919	120920
25120	39253	116	applied	\N	\N	\N	\N	120942	120942	120943
25120	39254	117	applied	\N	\N	\N	\N	120944	120944	120945
25120	39259	118	applied	\N	\N	\N	\N	120958	120958	120959
25120	39260	119	applied	\N	\N	\N	\N	120960	120960	120961
25120	39261	120	applied	\N	\N	\N	\N	120962	120962	120963
25120	39267	121	applied	\N	\N	\N	\N	120978	120978	120979
25120	39270	122	applied	\N	\N	\N	\N	120987	120987	120988
25120	39271	123	applied	\N	\N	\N	\N	120989	120989	120990
25120	39277	124	applied	\N	\N	\N	\N	121002	121002	121003
25124	39499	0	applied	\N	\N	\N	\N	121645	121645	121646
25124	39500	1	applied	\N	\N	\N	\N	121647	121647	121648
25124	39501	2	applied	\N	\N	\N	\N	121649	121649	121650
25124	39502	3	applied	\N	\N	\N	\N	121651	121651	121652
25126	39503	0	applied	\N	\N	\N	\N	121656	121656	121657
25126	39504	1	applied	\N	\N	\N	\N	121658	121658	121659
25126	39505	2	applied	\N	\N	\N	\N	121660	121660	121661
25129	39513	0	applied	\N	\N	\N	\N	121680	121680	121681
25129	39514	1	applied	\N	\N	\N	\N	121682	121682	121683
25129	39515	2	applied	\N	\N	\N	\N	121684	121684	121685
25131	39516	0	applied	\N	\N	\N	\N	121689	121689	121690
25131	39517	1	applied	\N	\N	\N	\N	121691	121691	121692
25131	39518	2	applied	\N	\N	\N	\N	121693	121693	121694
25131	39519	3	applied	\N	\N	\N	\N	121695	121695	121696
25131	39520	4	applied	\N	\N	\N	\N	121697	121697	121698
25131	39521	5	applied	\N	\N	\N	\N	121699	121699	121700
25131	39522	6	applied	\N	\N	\N	\N	121701	121701	121702
25138	39523	0	applied	\N	\N	\N	\N	121710	121710	121711
25138	39524	1	applied	\N	\N	\N	\N	121712	121712	121713
25138	39525	2	applied	\N	\N	\N	\N	121714	121714	121715
25140	39526	0	applied	\N	\N	\N	\N	121721	121721	121722
25140	39527	1	applied	\N	\N	\N	\N	121723	121723	121724
25140	39528	2	applied	\N	\N	\N	\N	121725	121725	121726
25142	39529	0	applied	\N	\N	\N	\N	121731	121731	121732
25142	39530	1	applied	\N	\N	\N	\N	121733	121733	121734
25142	39531	2	applied	\N	\N	\N	\N	121735	121735	121736
25147	39540	0	applied	\N	\N	\N	\N	121762	121762	121763
25147	39541	1	applied	\N	\N	\N	\N	121764	121764	121765
25147	39542	2	applied	\N	\N	\N	\N	121766	121766	121767
25149	39543	0	applied	\N	\N	\N	\N	121773	121773	121774
25149	39544	1	applied	\N	\N	\N	\N	121775	121775	121776
25149	39545	2	applied	\N	\N	\N	\N	121777	121777	121778
25149	39546	3	applied	\N	\N	\N	\N	121779	121779	23829
25149	39547	4	applied	\N	\N	\N	\N	121780	121780	121781
25151	39548	0	applied	\N	\N	\N	\N	121797	121797	121798
25151	39549	1	applied	\N	\N	\N	\N	121799	121799	121800
25151	39550	2	applied	\N	\N	\N	\N	121801	121801	121802
25156	39556	0	applied	\N	\N	\N	\N	97875	97875	121819
25156	39557	1	applied	\N	\N	\N	\N	121820	121820	121821
25156	39558	2	applied	\N	\N	\N	\N	121822	121822	121823
25156	39559	3	applied	\N	\N	\N	\N	121824	121824	121825
25156	39560	4	applied	\N	\N	\N	\N	121826	121826	121827
25156	39561	5	applied	\N	\N	\N	\N	121828	121828	29193
25158	39556	0	applied	\N	\N	\N	\N	97875	97875	121819
25158	39557	1	applied	\N	\N	\N	\N	121820	121820	121821
25158	39558	2	applied	\N	\N	\N	\N	121822	121822	121823
25158	39559	3	applied	\N	\N	\N	\N	121824	121824	121825
25158	39560	4	applied	\N	\N	\N	\N	121826	121826	121827
25158	39561	5	applied	\N	\N	\N	\N	121828	121828	29193
25160	39551	0	applied	\N	\N	\N	\N	121805	121805	121806
25160	39552	1	applied	\N	\N	\N	\N	121810	121810	121811
25160	39557	2	applied	\N	\N	\N	\N	121820	121820	121821
25160	39562	3	applied	\N	\N	\N	\N	121834	121834	121835
25160	39548	5	applied	\N	\N	\N	\N	121797	121797	121798
25160	39556	6	applied	\N	\N	\N	\N	97875	97875	121843
25160	39559	7	applied	\N	\N	\N	\N	121824	121824	121844
25160	39549	8	applied	\N	\N	\N	\N	121799	121799	121845
25160	39550	9	applied	\N	\N	\N	\N	121801	121801	121846
25160	39561	10	applied	\N	\N	\N	\N	121828	121828	29193
25160	39554	11	applied	\N	\N	\N	\N	121813	121813	121847
25160	39560	12	applied	\N	\N	\N	\N	121826	121826	121816
25160	39555	13	applied	\N	\N	\N	\N	121815	121815	121823
25160	39558	14	applied	\N	\N	\N	\N	121822	121822	121827
25167	39572	0	applied	\N	\N	\N	\N	121871	121871	121872
25167	39573	1	applied	\N	\N	\N	\N	121873	121873	121874
25167	39574	2	applied	\N	\N	\N	\N	121875	121875	121876
25167	39575	3	applied	\N	\N	\N	\N	121877	121877	121878
25169	39576	0	applied	\N	\N	\N	\N	121882	121882	121883
25169	39577	1	applied	\N	\N	\N	\N	121884	121884	121885
25169	39578	2	applied	\N	\N	\N	\N	121886	121886	121887
25171	39577	0	applied	\N	\N	\N	\N	121884	121884	121885
25171	39578	1	applied	\N	\N	\N	\N	121886	121886	121887
25174	39586	0	applied	\N	\N	\N	\N	121909	121909	121910
25174	39587	1	applied	\N	\N	\N	\N	121911	121911	121912
25174	39588	2	applied	\N	\N	\N	\N	121913	121913	121914
25179	39602	0	applied	\N	\N	\N	\N	121946	121946	121947
25179	39603	1	applied	\N	\N	\N	\N	121948	121948	121949
25179	39604	2	applied	\N	\N	\N	\N	121950	121950	121951
25184	39605	0	applied	\N	\N	\N	\N	121954	121954	121955
25184	39606	1	applied	\N	\N	\N	\N	121956	121956	121957
25184	39607	2	applied	\N	\N	\N	\N	121958	121958	121959
25184	39613	3	applied	\N	\N	\N	\N	121978	121978	121973
25184	39614	4	applied	\N	\N	\N	\N	121980	121980	121974
25184	39615	5	applied	\N	\N	\N	\N	121982	121982	121975
25184	39608	6	applied	\N	\N	\N	\N	121961	121961	121962
25184	39609	7	applied	\N	\N	\N	\N	121966	121966	121985
25184	39610	8	applied	\N	\N	\N	\N	121968	121968	121979
25184	39611	9	applied	\N	\N	\N	\N	121970	121970	121986
25184	39612	10	applied	\N	\N	\N	\N	121972	121972	121983
25186	39605	0	applied	\N	\N	\N	\N	121954	121954	121955
25186	39606	1	applied	\N	\N	\N	\N	121956	121956	121957
25186	39607	2	applied	\N	\N	\N	\N	121958	121958	121959
25186	39613	3	applied	\N	\N	\N	\N	121978	121978	121973
25186	39614	4	applied	\N	\N	\N	\N	121980	121980	121974
25186	39615	5	applied	\N	\N	\N	\N	121982	121982	121975
25134	39516	0	applied	\N	\N	\N	\N	121689	121689	121690
25134	39517	1	applied	\N	\N	\N	\N	121691	121691	121692
25134	39518	2	applied	\N	\N	\N	\N	121693	121693	121694
25134	39519	3	applied	\N	\N	\N	\N	121695	121695	121696
25134	39520	4	applied	\N	\N	\N	\N	121697	121697	121698
25134	39521	5	applied	\N	\N	\N	\N	121699	121699	121700
25134	39522	6	applied	\N	\N	\N	\N	121701	121701	121702
25136	39523	0	applied	\N	\N	\N	\N	121710	121710	121711
25136	39524	1	applied	\N	\N	\N	\N	121712	121712	121713
25136	39525	2	applied	\N	\N	\N	\N	121714	121714	121715
25145	39537	0	applied	\N	\N	\N	\N	121752	121752	121753
25145	39538	2	applied	\N	\N	\N	\N	121755	121755	121756
25145	39539	3	applied	\N	\N	\N	\N	121757	121757	121758
25148	39540	0	applied	\N	\N	\N	\N	121762	121762	121763
25148	39541	1	applied	\N	\N	\N	\N	121764	121764	121765
25148	39542	2	applied	\N	\N	\N	\N	121766	121766	121767
25152	39551	0	applied	\N	\N	\N	\N	121805	121805	121806
25152	39548	1	applied	\N	\N	\N	\N	121797	121797	121798
25152	39549	2	applied	\N	\N	\N	\N	121799	121799	121800
25152	39550	3	applied	\N	\N	\N	\N	121801	121801	121802
25154	39552	0	applied	\N	\N	\N	\N	121810	121810	121811
25154	39553	1	applied	\N	\N	\N	\N	121812	121812	44452
25154	39554	2	applied	\N	\N	\N	\N	121813	121813	121814
25154	39555	3	applied	\N	\N	\N	\N	121815	121815	121816
25163	39569	0	applied	\N	\N	\N	\N	121861	121861	121862
25163	39570	1	applied	\N	\N	\N	\N	121863	121863	121864
25163	39571	2	applied	\N	\N	\N	\N	121865	121865	121866
25165	39569	0	applied	\N	\N	\N	\N	121861	121861	121862
25165	39570	1	applied	\N	\N	\N	\N	121863	121863	121864
25165	39571	2	applied	\N	\N	\N	\N	121865	121865	121866
25168	39572	0	applied	\N	\N	\N	\N	121871	121871	121872
25168	39573	1	applied	\N	\N	\N	\N	121873	121873	121874
25168	39574	2	applied	\N	\N	\N	\N	121875	121875	121876
25168	39575	3	applied	\N	\N	\N	\N	121877	121877	121878
25172	39576	0	applied	\N	\N	\N	\N	121882	121882	121883
25172	39579	1	applied	\N	\N	\N	\N	121892	121892	121893
25172	39580	2	applied	\N	\N	\N	\N	121894	121894	121895
25172	39581	3	applied	\N	\N	\N	\N	121896	121896	121897
25177	39596	0	applied	\N	\N	\N	\N	121932	121932	121933
25177	39597	1	applied	\N	\N	\N	\N	121934	121934	121935
25177	39598	2	applied	\N	\N	\N	\N	121936	121936	121937
25185	39605	0	applied	\N	\N	\N	\N	121954	121954	121955
25185	39606	1	applied	\N	\N	\N	\N	121956	121956	121957
25185	39607	2	applied	\N	\N	\N	\N	121958	121958	121959
25185	39613	3	applied	\N	\N	\N	\N	121978	121978	121973
25185	39614	4	applied	\N	\N	\N	\N	121980	121980	121974
25185	39615	5	applied	\N	\N	\N	\N	121982	121982	121975
25185	39608	6	applied	\N	\N	\N	\N	121961	121961	121962
25185	39609	7	applied	\N	\N	\N	\N	121966	121966	121985
25185	39610	8	applied	\N	\N	\N	\N	121968	121968	121979
25185	39611	9	applied	\N	\N	\N	\N	121970	121970	121986
25185	39612	10	applied	\N	\N	\N	\N	121972	121972	121983
25191	39622	0	applied	\N	\N	\N	\N	122011	122011	122012
25191	39623	2	applied	\N	\N	\N	\N	122014	122014	122015
25191	39624	3	applied	\N	\N	\N	\N	122016	122016	122017
25191	39625	4	applied	\N	\N	\N	\N	122018	122018	122019
25195	39626	0	applied	\N	\N	\N	\N	122027	122027	122028
25195	39627	1	applied	\N	\N	\N	\N	122029	122029	122030
25195	39628	2	applied	\N	\N	\N	\N	122031	122031	122032
25195	39629	3	applied	\N	\N	\N	\N	122033	122033	122034
25197	39638	0	applied	\N	\N	\N	\N	122057	122057	122058
25197	39639	1	applied	\N	\N	\N	\N	122059	122059	122060
25197	39640	2	applied	\N	\N	\N	\N	122061	122061	122062
25202	39641	0	applied	\N	\N	\N	\N	122095	122095	122096
25202	39642	1	applied	\N	\N	\N	\N	122097	122097	122098
25202	39643	2	applied	\N	\N	\N	\N	122099	122099	122100
25202	39644	3	applied	\N	\N	\N	\N	122101	122101	122102
25202	39645	4	applied	\N	\N	\N	\N	122103	122103	122104
25202	39646	5	applied	\N	\N	\N	\N	122105	122105	122106
25202	39647	6	applied	\N	\N	\N	\N	122107	122107	122108
25206	39651	0	applied	\N	\N	\N	\N	122122	122122	122123
25206	39652	1	applied	\N	\N	\N	\N	122124	122124	122125
25206	39653	2	applied	\N	\N	\N	\N	122126	122126	122127
25206	39654	3	applied	\N	\N	\N	\N	122128	122128	122129
25206	39655	4	applied	\N	\N	\N	\N	122130	122130	122131
25206	39656	5	applied	\N	\N	\N	\N	122132	122132	122133
25206	39657	6	applied	\N	\N	\N	\N	122134	122134	122135
25213	39668	0	applied	\N	\N	\N	\N	122164	122164	122165
25213	39669	1	applied	\N	\N	\N	\N	122166	122166	122167
25213	39670	2	applied	\N	\N	\N	\N	122168	122168	122169
25213	39671	3	applied	\N	\N	\N	\N	122170	122170	122171
25216	39678	0	applied	\N	\N	\N	\N	122189	122189	122190
25216	39679	1	applied	\N	\N	\N	\N	122191	122191	122192
25216	39680	2	applied	\N	\N	\N	\N	122193	122193	122194
25216	39681	3	applied	\N	\N	\N	\N	122195	122195	122196
25216	39682	4	applied	\N	\N	\N	\N	122197	122197	122198
25216	39683	5	applied	\N	\N	\N	\N	122199	122199	122200
25223	39695	0	applied	\N	\N	\N	\N	122232	122232	122233
25223	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25223	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25225	39695	0	applied	\N	\N	\N	\N	122232	122232	122233
25227	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25227	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25227	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25227	39699	3	applied	\N	\N	\N	\N	122246	122246	122247
25227	39700	4	applied	\N	\N	\N	\N	122248	122248	122249
25229	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25229	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25229	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25229	39699	3	applied	\N	\N	\N	\N	122246	122246	122247
25229	39700	4	applied	\N	\N	\N	\N	122248	122248	122249
25231	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25231	39699	1	applied	\N	\N	\N	\N	122246	122246	122247
25231	39700	2	applied	\N	\N	\N	\N	122248	122248	122249
25240	39711	0	applied	\N	\N	\N	\N	122291	122291	122292
25240	39712	1	applied	\N	\N	\N	\N	122293	122293	122294
25240	39713	2	applied	\N	\N	\N	\N	122295	122295	122296
25240	39714	3	applied	\N	\N	\N	\N	122297	122297	122298
25240	39715	4	applied	\N	\N	\N	\N	122299	122299	122300
25240	39716	5	applied	\N	\N	\N	\N	122301	122301	122302
25240	39717	6	applied	\N	\N	\N	\N	122303	122303	122304
25240	39718	7	applied	\N	\N	\N	\N	122305	122305	122306
25243	39626	0	applied	\N	\N	\N	\N	122027	122027	122028
25243	39572	1	applied	\N	\N	\N	\N	121871	121871	121872
25243	39576	2	applied	\N	\N	\N	\N	121882	121882	121883
25243	39579	3	applied	\N	\N	\N	\N	121892	121892	121893
25243	39582	4	applied	\N	\N	\N	\N	121899	121899	121900
25243	39586	5	applied	\N	\N	\N	\N	121909	121909	121910
25243	39589	6	applied	\N	\N	\N	\N	121917	121917	121918
25243	39592	7	applied	\N	\N	\N	\N	121923	121923	121924
25135	39522	6	applied	\N	\N	\N	\N	121701	121701	121702
25137	39523	0	applied	\N	\N	\N	\N	121710	121710	121711
25137	39524	1	applied	\N	\N	\N	\N	121712	121712	121713
25137	39525	2	applied	\N	\N	\N	\N	121714	121714	121715
25139	39526	0	applied	\N	\N	\N	\N	121721	121721	121722
25139	39527	1	applied	\N	\N	\N	\N	121723	121723	121724
25139	39528	2	applied	\N	\N	\N	\N	121725	121725	121726
25144	39532	0	applied	\N	\N	\N	\N	121740	121740	121741
25144	39533	1	applied	\N	\N	\N	\N	121742	121742	121743
25144	39534	2	applied	\N	\N	1000000000	\N	121744	121744	121745
25144	39535	3	applied	\N	\N	\N	\N	121746	121746	121747
25144	39536	4	applied	\N	\N	\N	\N	121748	121748	121749
25146	39540	0	applied	\N	\N	\N	\N	121762	121762	121763
25146	39541	1	applied	\N	\N	\N	\N	121764	121764	121765
25146	39542	2	applied	\N	\N	\N	\N	121766	121766	121767
25162	39565	0	applied	\N	\N	\N	\N	121850	121850	121851
25162	39566	1	applied	\N	\N	\N	\N	121852	121852	44452
25162	39567	2	applied	\N	\N	\N	\N	121853	121853	121854
25162	39568	3	applied	\N	\N	\N	\N	121855	121855	121856
25164	39569	0	applied	\N	\N	\N	\N	121861	121861	121862
25164	39570	1	applied	\N	\N	\N	\N	121863	121863	121864
25164	39571	2	applied	\N	\N	\N	\N	121865	121865	121866
25166	39565	0	applied	\N	\N	\N	\N	121850	121850	121851
25166	39569	1	applied	\N	\N	\N	\N	121861	121861	121862
25166	39563	2	applied	\N	\N	\N	\N	121836	121836	121837
25166	39564	3	applied	\N	\N	\N	\N	121838	121838	121839
25166	39567	4	applied	\N	\N	\N	\N	121853	121853	121854
25166	39571	5	applied	\N	\N	\N	\N	121865	121865	121867
25166	39568	6	applied	\N	\N	\N	\N	121855	121855	121868
25166	39570	7	applied	\N	\N	\N	\N	121863	121863	121866
25173	39582	0	applied	\N	\N	\N	\N	121899	121899	121900
25173	39583	1	applied	\N	\N	\N	\N	121901	121901	121902
25173	39584	2	applied	\N	\N	\N	\N	121903	121903	121904
25173	39585	3	applied	\N	\N	\N	\N	121905	121905	121906
25176	39592	0	applied	\N	\N	\N	\N	121923	121923	121924
25176	39593	1	applied	\N	\N	\N	\N	121925	121925	121926
25176	39594	2	applied	\N	\N	\N	\N	121927	121927	121928
25176	39595	3	applied	\N	\N	\N	\N	121929	121929	121930
25192	39622	0	applied	\N	\N	\N	\N	122011	122011	122012
25192	39623	2	applied	\N	\N	\N	\N	122014	122014	122015
25192	39624	3	applied	\N	\N	\N	\N	122016	122016	122017
25192	39625	4	applied	\N	\N	\N	\N	122018	122018	122019
25194	39626	0	applied	\N	\N	\N	\N	122027	122027	122028
25194	39627	1	applied	\N	\N	\N	\N	122029	122029	122030
25194	39628	2	applied	\N	\N	\N	\N	122031	122031	122032
25194	39629	3	applied	\N	\N	\N	\N	122033	122033	122034
25198	39638	0	applied	\N	\N	\N	\N	122057	122057	122058
25198	39639	1	applied	\N	\N	\N	\N	122059	122059	122060
25198	39640	2	applied	\N	\N	\N	\N	122061	122061	122062
25200	39626	0	applied	\N	\N	\N	\N	122027	122027	122028
25200	39454	1	applied	\N	\N	\N	\N	121484	121484	121485
25200	39458	2	applied	\N	\N	\N	\N	121495	121495	121496
25200	39461	3	applied	\N	\N	\N	\N	121507	121507	121508
25200	39465	4	applied	\N	\N	\N	\N	121541	121541	121542
25200	39466	5	applied	\N	\N	\N	\N	121543	121543	121544
25200	39467	6	applied	\N	\N	\N	\N	121545	121545	121546
25200	39474	7	applied	\N	\N	\N	\N	121571	121571	121572
25200	39477	8	applied	\N	\N	\N	\N	121578	121578	121579
25200	39481	9	applied	\N	\N	\N	\N	121587	121587	121588
25200	39484	10	applied	\N	\N	\N	\N	121595	121595	121596
25200	39490	11	applied	\N	\N	\N	\N	121609	121609	121610
25200	39491	12	applied	\N	\N	\N	\N	121611	121611	121612
25200	39496	13	applied	\N	\N	\N	\N	121634	121634	121635
25200	39499	14	applied	\N	\N	\N	\N	121645	121645	121646
25200	39503	15	applied	\N	\N	\N	\N	121656	121656	121657
25200	39506	16	applied	\N	\N	\N	\N	121664	121664	121665
25200	39509	17	applied	\N	\N	\N	\N	121671	121671	121672
25200	39513	18	applied	\N	\N	\N	\N	121680	121680	121681
25200	39516	19	applied	\N	\N	\N	\N	121689	121689	121690
25200	39517	20	applied	\N	\N	\N	\N	121691	121691	121692
25200	39523	21	applied	\N	\N	\N	\N	121710	121710	121711
25200	39526	22	applied	\N	\N	\N	\N	121721	121721	121722
25200	39529	23	applied	\N	\N	\N	\N	121731	121731	121732
25200	39532	24	applied	\N	\N	\N	\N	121740	121740	121741
25200	39537	25	applied	\N	\N	\N	\N	121752	121752	121753
25200	39540	26	applied	\N	\N	\N	\N	121762	121762	121763
25200	39543	27	applied	\N	\N	\N	\N	121773	121773	121774
25200	39551	28	applied	\N	\N	\N	\N	121805	121805	121806
25200	39552	29	applied	\N	\N	\N	\N	121810	121810	121811
25200	39557	30	applied	\N	\N	\N	\N	121820	121820	121821
25200	39562	31	applied	\N	\N	\N	\N	121834	121834	121835
25200	39565	32	applied	\N	\N	\N	\N	121850	121850	121851
25200	39569	33	applied	\N	\N	\N	\N	121861	121861	121862
25200	39572	34	applied	\N	\N	\N	\N	121871	121871	121872
25200	39576	35	applied	\N	\N	\N	\N	121882	121882	121883
25200	39579	36	applied	\N	\N	\N	\N	121892	121892	121893
25200	39582	37	applied	\N	\N	\N	\N	121899	121899	121900
25200	39586	38	applied	\N	\N	\N	\N	121909	121909	121910
25200	39589	39	applied	\N	\N	\N	\N	121917	121917	121918
25200	39592	40	applied	\N	\N	\N	\N	121923	121923	121924
25200	39596	41	applied	\N	\N	\N	\N	121932	121932	121933
25200	39599	42	applied	\N	\N	\N	\N	121938	121938	121939
25200	39602	43	applied	\N	\N	\N	\N	121946	121946	121947
25200	39605	44	applied	\N	\N	\N	\N	121954	121954	121955
25200	39606	45	applied	\N	\N	\N	\N	121956	121956	121957
25200	39607	46	applied	\N	\N	\N	\N	121958	121958	121959
25200	39616	47	applied	\N	\N	\N	\N	121995	121995	121996
25200	39622	48	applied	\N	\N	\N	\N	122011	122011	122012
25200	39627	49	applied	\N	\N	\N	\N	122029	122029	122030
25200	39630	50	applied	\N	\N	\N	\N	122039	122039	122040
25200	39631	51	applied	\N	\N	\N	\N	122041	122041	122042
25200	39638	52	applied	\N	\N	\N	\N	122057	122057	122058
25200	39457	53	applied	\N	\N	\N	\N	121490	121490	121489
25200	39455	54	applied	\N	\N	\N	\N	121486	121486	121491
25200	39459	55	applied	\N	\N	\N	\N	121497	121497	121533
25200	39534	56	applied	\N	\N	1000000000	\N	121744	121744	121745
25200	39548	57	applied	\N	\N	\N	\N	121797	121797	121798
25200	39556	58	applied	\N	\N	\N	\N	97875	97875	121843
25200	39463	59	applied	\N	\N	\N	\N	121511	121511	121534
25200	39464	60	applied	\N	\N	\N	\N	121537	121537	121500
25200	39471	61	applied	\N	\N	\N	\N	121554	121554	122068
25200	39472	62	applied	\N	\N	\N	\N	121556	121556	121568
25200	39475	63	applied	\N	\N	\N	\N	121573	121573	121548
25200	39479	64	applied	\N	\N	\N	\N	121582	121582	121562
25200	39482	65	applied	\N	\N	\N	\N	121589	121589	121563
25200	39486	66	applied	\N	\N	\N	\N	121599	121599	121552
25200	39489	67	applied	\N	\N	\N	\N	121605	121605	121553
25200	39492	68	applied	\N	\N	\N	\N	121613	121613	121555
25200	39495	69	applied	\N	\N	\N	\N	121619	121619	121557
25150	39519	38	applied	\N	\N	\N	\N	121695	121695	121795
25150	39535	39	applied	\N	\N	\N	\N	121746	121746	121776
25150	39545	40	applied	\N	\N	\N	\N	121777	121777	121778
25150	39547	41	applied	\N	\N	\N	\N	121780	121780	121781
25153	39551	0	applied	\N	\N	\N	\N	121805	121805	121806
25153	39548	1	applied	\N	\N	\N	\N	121797	121797	121798
25153	39549	2	applied	\N	\N	\N	\N	121799	121799	121800
25153	39550	3	applied	\N	\N	\N	\N	121801	121801	121802
25155	39556	0	applied	\N	\N	\N	\N	97875	97875	121819
25155	39557	1	applied	\N	\N	\N	\N	121820	121820	121821
25155	39558	2	applied	\N	\N	\N	\N	121822	121822	121823
25155	39559	3	applied	\N	\N	\N	\N	121824	121824	121825
25155	39560	4	applied	\N	\N	\N	\N	121826	121826	121827
25155	39561	5	applied	\N	\N	\N	\N	121828	121828	29193
25157	39556	0	applied	\N	\N	\N	\N	97875	97875	121819
25157	39557	1	applied	\N	\N	\N	\N	121820	121820	121821
25157	39558	2	applied	\N	\N	\N	\N	121822	121822	121823
25157	39559	3	applied	\N	\N	\N	\N	121824	121824	121825
25157	39560	4	applied	\N	\N	\N	\N	121826	121826	121827
25157	39561	5	applied	\N	\N	\N	\N	121828	121828	29193
25159	39562	0	applied	\N	\N	\N	\N	121834	121834	121835
25159	39563	1	applied	\N	\N	\N	\N	121836	121836	121837
25159	39564	2	applied	\N	\N	\N	\N	121838	121838	121839
25161	39565	0	applied	\N	\N	\N	\N	121850	121850	121851
25161	39566	1	applied	\N	\N	\N	\N	121852	121852	44452
25161	39567	2	applied	\N	\N	\N	\N	121853	121853	121854
25161	39568	3	applied	\N	\N	\N	\N	121855	121855	121856
25170	39576	0	applied	\N	\N	\N	\N	121882	121882	121883
25170	39577	1	applied	\N	\N	\N	\N	121884	121884	121885
25170	39578	2	applied	\N	\N	\N	\N	121886	121886	121887
25175	39589	0	applied	\N	\N	\N	\N	121917	121917	121918
25175	39590	1	applied	\N	\N	\N	\N	121919	121919	121920
25175	39591	2	applied	\N	\N	\N	\N	121921	121921	121922
25178	39599	0	applied	\N	\N	\N	\N	121938	121938	121939
25178	39600	1	applied	\N	\N	\N	\N	121940	121940	121941
25178	39601	2	applied	\N	\N	\N	\N	121942	121942	121943
25183	39586	0	applied	\N	\N	\N	\N	121909	121909	121910
25183	39589	1	applied	\N	\N	\N	\N	121917	121917	121918
25183	39592	2	applied	\N	\N	\N	\N	121923	121923	121924
25183	39596	3	applied	\N	\N	\N	\N	121932	121932	121933
25183	39599	4	applied	\N	\N	\N	\N	121938	121938	121939
25183	39602	5	applied	\N	\N	\N	\N	121946	121946	121947
25183	39605	6	applied	\N	\N	\N	\N	121954	121954	121955
25183	39606	7	applied	\N	\N	\N	\N	121956	121956	121957
25183	39607	8	applied	\N	\N	\N	\N	121958	121958	121959
25183	39587	9	applied	\N	\N	\N	\N	121911	121911	121912
25183	39588	10	applied	\N	\N	\N	\N	121913	121913	121914
25183	39594	11	applied	\N	\N	\N	\N	121927	121927	121960
25183	39608	12	applied	\N	\N	\N	\N	121961	121961	121962
25183	39590	13	applied	\N	\N	\N	\N	121919	121919	121963
25183	39593	14	applied	\N	\N	\N	\N	121925	121925	121964
25183	39598	15	applied	\N	\N	\N	\N	121936	121936	121965
25183	39601	16	applied	\N	\N	\N	\N	121942	121942	121935
25183	39603	17	applied	\N	\N	\N	\N	121948	121948	121937
25183	39609	18	applied	\N	\N	\N	\N	121966	121966	121967
25183	39610	19	applied	\N	\N	\N	\N	121968	121968	121969
25183	39611	20	applied	\N	\N	\N	\N	121970	121970	121971
25183	39612	21	applied	\N	\N	\N	\N	121972	121972	121951
25183	39591	22	applied	\N	\N	\N	\N	121921	121921	121973
25183	39595	23	applied	\N	\N	\N	\N	121929	121929	121974
25183	39597	24	applied	\N	\N	\N	\N	121934	121934	121975
25183	39600	25	applied	\N	\N	\N	\N	121940	121940	121976
25183	39604	26	applied	\N	\N	\N	\N	121950	121950	121977
25183	39613	27	applied	\N	\N	\N	\N	121978	121978	121979
25183	39614	28	applied	\N	\N	\N	\N	121980	121980	121981
25183	39615	29	applied	\N	\N	\N	\N	121982	121982	121983
25187	39605	0	applied	\N	\N	\N	\N	121954	121954	121955
25187	39606	1	applied	\N	\N	\N	\N	121956	121956	121957
25187	39607	2	applied	\N	\N	\N	\N	121958	121958	121959
25187	39613	3	applied	\N	\N	\N	\N	121978	121978	121973
25187	39614	4	applied	\N	\N	\N	\N	121980	121980	121974
25187	39615	5	applied	\N	\N	\N	\N	121982	121982	121975
25187	39608	6	applied	\N	\N	\N	\N	121961	121961	121962
25187	39609	7	applied	\N	\N	\N	\N	121966	121966	121985
25187	39610	8	applied	\N	\N	\N	\N	121968	121968	121979
25187	39611	9	applied	\N	\N	\N	\N	121970	121970	121986
25187	39612	10	applied	\N	\N	\N	\N	121972	121972	121983
25189	39616	0	applied	\N	\N	\N	\N	121995	121995	121996
25189	39617	1	applied	\N	\N	\N	\N	121997	121997	121998
25189	39618	2	applied	\N	\N	\N	\N	121999	121999	122000
25189	39619	3	applied	\N	\N	\N	\N	122001	122001	122002
25189	39620	4	applied	\N	\N	\N	\N	122003	122003	122004
25189	39621	5	applied	\N	\N	\N	\N	122005	122005	122006
25196	39630	0	applied	\N	\N	\N	\N	122039	122039	122040
25196	39631	1	applied	\N	\N	\N	\N	122041	122041	122042
25196	39632	2	applied	\N	\N	\N	\N	122043	122043	122044
25196	39633	3	applied	\N	\N	\N	\N	122045	122045	122046
25196	39634	4	applied	\N	\N	\N	\N	122047	122047	122048
25196	39635	5	applied	\N	\N	\N	\N	122049	122049	122050
25196	39636	6	applied	\N	\N	\N	\N	122051	122051	122052
25196	39637	7	applied	\N	\N	\N	\N	122053	122053	122054
25199	39638	0	applied	\N	\N	\N	\N	122057	122057	122058
25199	39639	1	applied	\N	\N	\N	\N	122059	122059	122060
25199	39640	2	applied	\N	\N	\N	\N	122061	122061	122062
25201	39641	0	applied	\N	\N	\N	\N	122095	122095	122096
25201	39642	1	applied	\N	\N	\N	\N	122097	122097	122098
25201	39643	2	applied	\N	\N	\N	\N	122099	122099	122100
25201	39644	3	applied	\N	\N	\N	\N	122101	122101	122102
25201	39645	4	applied	\N	\N	\N	\N	122103	122103	122104
25201	39646	5	applied	\N	\N	\N	\N	122105	122105	122106
25201	39647	6	applied	\N	\N	\N	\N	122107	122107	122108
25203	39641	0	applied	\N	\N	\N	\N	122095	122095	122096
25203	39642	1	applied	\N	\N	\N	\N	122097	122097	122098
25203	39643	2	applied	\N	\N	\N	\N	122099	122099	122100
25203	39644	3	applied	\N	\N	\N	\N	122101	122101	122102
25203	39645	4	applied	\N	\N	\N	\N	122103	122103	122104
25203	39646	5	applied	\N	\N	\N	\N	122105	122105	122106
25203	39647	6	applied	\N	\N	\N	\N	122107	122107	122108
25209	39665	0	applied	\N	\N	\N	\N	122152	122152	122153
25209	39666	1	applied	\N	\N	\N	\N	122154	122154	122155
25209	39667	2	applied	\N	\N	\N	\N	122156	122156	122157
25211	39665	0	applied	\N	\N	\N	\N	122152	122152	122153
25211	39666	1	applied	\N	\N	\N	\N	122154	122154	122155
25211	39667	2	applied	\N	\N	\N	\N	122156	122156	122157
25215	39675	0	applied	\N	\N	\N	\N	122182	122182	122183
25215	39676	1	applied	\N	\N	\N	\N	122184	122184	122185
25215	39677	2	applied	\N	\N	\N	\N	122186	122186	122187
25218	39684	0	applied	\N	\N	\N	\N	122202	122202	122203
25218	39685	1	applied	\N	\N	\N	\N	122204	122204	122205
25218	39686	2	applied	\N	\N	\N	\N	122206	122206	122207
25186	39608	6	applied	\N	\N	\N	\N	121961	121961	121962
25186	39609	7	applied	\N	\N	\N	\N	121966	121966	121985
25186	39610	8	applied	\N	\N	\N	\N	121968	121968	121979
25186	39611	9	applied	\N	\N	\N	\N	121970	121970	121986
25186	39612	10	applied	\N	\N	\N	\N	121972	121972	121983
25188	39613	0	applied	\N	\N	\N	\N	121978	121978	121973
25188	39614	1	applied	\N	\N	\N	\N	121980	121980	121974
25188	39615	2	applied	\N	\N	\N	\N	121982	121982	121975
25188	39608	3	applied	\N	\N	\N	\N	121961	121961	121962
25188	39609	4	applied	\N	\N	\N	\N	121966	121966	121985
25188	39610	5	applied	\N	\N	\N	\N	121968	121968	121979
25188	39611	6	applied	\N	\N	\N	\N	121970	121970	121986
25188	39612	7	applied	\N	\N	\N	\N	121972	121972	121983
25190	39616	0	applied	\N	\N	\N	\N	121995	121995	121996
25190	39617	1	applied	\N	\N	\N	\N	121997	121997	121998
25190	39618	2	applied	\N	\N	\N	\N	121999	121999	122000
25190	39619	3	applied	\N	\N	\N	\N	122001	122001	122002
25190	39620	4	applied	\N	\N	\N	\N	122003	122003	122004
25190	39621	5	applied	\N	\N	\N	\N	122005	122005	122006
25193	39622	0	applied	\N	\N	\N	\N	122011	122011	122012
25193	39623	2	applied	\N	\N	\N	\N	122014	122014	122015
25193	39624	3	applied	\N	\N	\N	\N	122016	122016	122017
25193	39625	4	applied	\N	\N	\N	\N	122018	122018	122019
25204	39648	0	applied	\N	\N	\N	\N	122114	122114	122115
25204	39649	1	applied	\N	\N	\N	\N	122116	122116	122117
25204	39650	2	applied	\N	\N	\N	\N	122118	122118	122119
25207	39658	0	applied	\N	\N	\N	\N	122138	122138	122139
25207	39659	1	applied	\N	\N	\N	\N	122140	122140	122141
25207	39660	2	applied	\N	\N	\N	\N	122142	122142	122143
25207	39661	3	applied	\N	\N	\N	\N	122144	122144	122144
25207	39662	4	applied	\N	\N	\N	\N	122145	122145	122146
25207	39663	5	applied	\N	\N	\N	\N	122147	122147	122148
25207	39664	6	applied	\N	\N	\N	\N	122149	122149	122150
25219	39688	0	applied	\N	\N	\N	\N	122213	122213	122214
25219	39689	1	applied	\N	\N	\N	\N	122215	122215	122216
25219	39690	2	applied	\N	\N	\N	\N	122217	122217	122218
25221	39691	0	applied	\N	\N	\N	\N	122221	122221	122222
25221	39692	1	applied	\N	\N	\N	\N	122223	122223	122224
25221	39693	2	applied	\N	\N	\N	\N	122225	122225	122226
25221	39694	3	applied	\N	\N	\N	\N	122227	122227	122228
25224	39695	0	applied	\N	\N	\N	\N	122232	122232	122233
25224	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25224	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25228	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25228	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25228	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25228	39699	3	applied	\N	\N	\N	\N	122246	122246	122247
25228	39700	4	applied	\N	\N	\N	\N	122248	122248	122249
25232	39701	0	applied	\N	\N	\N	\N	122261	122261	122262
25232	39702	1	applied	\N	\N	\N	\N	122263	122263	122264
25232	39703	2	applied	\N	\N	\N	\N	122265	122265	122266
25232	39704	3	applied	\N	\N	\N	\N	122267	122267	122268
25232	39705	4	applied	\N	\N	\N	\N	122269	122269	122270
25234	39706	0	applied	\N	\N	\N	\N	122273	122273	122274
25234	39707	1	applied	\N	\N	\N	\N	122275	122275	122276
25234	39708	2	applied	\N	\N	\N	\N	122277	122277	122278
25234	39709	3	applied	\N	\N	\N	\N	122279	122279	122280
25234	39710	4	applied	\N	\N	\N	\N	122281	122281	122282
25236	39706	0	applied	\N	\N	\N	\N	122273	122273	122274
25236	39707	1	applied	\N	\N	\N	\N	122275	122275	122276
25236	39708	2	applied	\N	\N	\N	\N	122277	122277	122278
25236	39709	3	applied	\N	\N	\N	\N	122279	122279	122280
25236	39710	4	applied	\N	\N	\N	\N	122281	122281	122282
25241	39719	0	applied	\N	\N	\N	\N	122309	122309	122310
25241	39720	1	applied	\N	\N	\N	\N	122311	122311	122312
25241	39721	2	applied	\N	\N	\N	\N	122313	122313	122314
25241	39722	3	applied	\N	\N	\N	\N	122315	122315	122316
25248	39733	0	applied	\N	\N	\N	\N	122383	122383	122384
25248	39734	1	applied	\N	\N	\N	\N	122385	122385	122386
25248	39735	2	applied	\N	\N	\N	\N	122387	122387	122388
25251	39749	0	applied	\N	\N	\N	\N	122419	122419	122420
25251	39750	1	applied	\N	\N	\N	\N	122421	122421	122422
25251	39751	2	applied	\N	\N	\N	\N	122423	122423	122424
25252	39752	0	applied	\N	\N	\N	\N	122427	122427	122428
25252	39753	1	applied	\N	\N	\N	\N	122429	122429	122430
25252	39754	2	applied	\N	\N	\N	\N	122431	122431	122432
25252	39755	3	applied	\N	\N	\N	\N	122433	122433	122434
25252	39756	4	applied	\N	\N	\N	\N	122435	122435	122436
25252	39757	5	applied	\N	\N	\N	\N	122437	122437	122438
25252	39758	6	applied	\N	\N	\N	\N	122439	122439	122440
25252	39759	7	applied	\N	\N	\N	\N	122441	122441	122442
25252	39760	8	applied	\N	\N	\N	\N	122443	122443	122444
25252	39761	9	applied	\N	\N	\N	\N	122445	122445	122446
25254	39762	0	applied	\N	\N	\N	\N	122451	122451	122452
25254	39763	1	applied	\N	\N	\N	\N	122453	122453	122454
25254	39764	2	applied	\N	\N	\N	\N	122455	122455	122456
25254	39765	3	applied	\N	\N	\N	\N	122457	122457	122458
25256	39766	0	applied	\N	\N	\N	\N	122461	122461	122462
25256	39767	1	applied	\N	\N	\N	\N	122463	122463	122464
25256	39768	2	applied	\N	\N	\N	\N	122465	122465	122466
25259	39775	0	applied	\N	\N	\N	\N	122483	122483	122484
25259	39776	1	applied	\N	\N	\N	\N	122485	122485	122486
25259	39777	2	applied	\N	\N	\N	\N	122487	122487	122488
25259	39778	3	applied	\N	\N	\N	\N	122489	122489	122490
25267	39798	0	applied	\N	\N	\N	\N	122545	122545	122546
25267	39799	1	applied	\N	\N	\N	\N	122547	122547	122548
25267	39800	2	applied	\N	\N	\N	\N	122549	122549	122550
25267	39801	3	applied	\N	\N	\N	\N	122551	122551	122552
25267	39802	4	applied	\N	\N	\N	\N	122553	122553	122554
25267	39803	5	applied	\N	\N	\N	\N	122555	122555	122556
25272	39811	0	applied	\N	\N	\N	\N	122619	122619	122620
25272	39812	1	applied	\N	\N	\N	\N	122621	122621	122622
25272	39813	2	applied	\N	\N	\N	\N	122623	122623	122624
25275	39821	0	applied	\N	\N	\N	\N	122645	122645	122646
25275	39822	1	applied	\N	\N	\N	\N	122647	122647	122648
25275	39823	2	applied	\N	\N	\N	\N	122649	122649	122650
25275	39824	3	applied	\N	\N	\N	\N	122651	122651	122652
25277	39821	0	applied	\N	\N	\N	\N	122645	122645	122646
25277	39822	1	applied	\N	\N	\N	\N	122647	122647	122648
25277	39823	2	applied	\N	\N	\N	\N	122649	122649	122650
25277	39824	3	applied	\N	\N	\N	\N	122651	122651	122652
25277	39825	4	applied	\N	\N	\N	\N	122654	122654	122655
25277	39826	5	applied	\N	\N	\N	\N	122656	122656	122657
25279	39821	0	applied	\N	\N	\N	\N	122645	122645	122646
25279	39822	1	applied	\N	\N	\N	\N	122647	122647	122648
25279	39823	2	applied	\N	\N	\N	\N	122649	122649	122650
25279	39824	3	applied	\N	\N	\N	\N	122651	122651	122652
25279	39825	4	applied	\N	\N	\N	\N	122654	122654	122655
25279	39826	5	applied	\N	\N	\N	\N	122656	122656	122657
25284	39834	0	applied	\N	\N	\N	\N	122682	122682	122683
25200	39608	70	applied	\N	\N	\N	\N	121961	121961	121962
25200	39460	71	applied	\N	\N	\N	\N	121499	121499	121559
25200	39462	72	applied	\N	\N	\N	\N	121509	121509	122069
25200	39469	73	applied	\N	\N	\N	\N	121549	121549	122070
25200	39470	74	applied	\N	\N	\N	\N	121551	121551	122071
25200	39619	75	applied	\N	\N	\N	\N	122001	122001	122002
25200	39620	76	applied	\N	\N	\N	\N	122003	122003	122004
25200	39623	77	applied	\N	\N	\N	\N	122014	122014	122015
25200	39473	78	applied	\N	\N	\N	\N	121558	121558	122072
25200	39561	79	applied	\N	\N	\N	\N	121828	121828	29193
25200	39636	80	applied	\N	\N	\N	\N	122051	122051	122052
25200	39456	81	applied	\N	\N	\N	\N	121488	121488	121590
25200	39468	82	applied	\N	\N	\N	\N	121547	121547	122073
25200	39480	83	applied	\N	\N	\N	\N	121584	121584	122074
25200	39488	84	applied	\N	\N	\N	\N	121603	121603	121592
25200	39500	85	applied	\N	\N	\N	\N	121647	121647	122075
25200	39546	86	applied	\N	\N	\N	\N	121779	121779	23829
25200	39512	87	applied	\N	\N	\N	\N	121677	121677	122076
25200	39519	88	applied	\N	\N	\N	\N	121695	121695	121598
25200	39535	89	applied	\N	\N	\N	\N	121746	121746	122077
25200	39545	90	applied	\N	\N	\N	\N	121777	121777	121600
25200	39559	91	applied	\N	\N	\N	\N	121824	121824	122078
25200	39574	92	applied	\N	\N	\N	\N	121875	121875	122079
25200	39585	93	applied	\N	\N	\N	\N	121905	121905	121602
25200	39594	94	applied	\N	\N	\N	\N	121927	121927	121604
25200	39612	95	applied	\N	\N	\N	\N	121972	121972	122080
25200	39618	96	applied	\N	\N	\N	\N	121999	121999	121606
25200	39637	97	applied	\N	\N	\N	\N	122053	122053	122081
25200	39498	98	applied	\N	\N	\N	\N	121638	121638	122082
25200	39501	99	applied	\N	\N	\N	\N	121649	121649	121616
25200	39504	100	applied	\N	\N	\N	\N	121658	121658	122083
25200	39507	101	applied	\N	\N	\N	\N	121666	121666	122084
25200	39510	102	applied	\N	\N	\N	\N	121673	121673	122085
25200	39515	103	applied	\N	\N	\N	\N	121684	121684	121637
25200	39521	104	applied	\N	\N	\N	\N	121699	121699	121639
25200	39522	105	applied	\N	\N	\N	\N	121701	121701	122086
25200	39525	106	applied	\N	\N	\N	\N	121714	121714	122087
25200	39527	107	applied	\N	\N	\N	\N	121723	121723	121652
25200	39531	108	applied	\N	\N	\N	\N	121735	121735	121659
25200	39533	109	applied	\N	\N	\N	\N	121742	121742	122088
25200	39538	110	applied	\N	\N	\N	\N	121755	121755	122089
25200	39541	111	applied	\N	\N	\N	\N	121764	121764	122090
25200	39544	112	applied	\N	\N	\N	\N	121775	121775	121669
25200	39550	113	applied	\N	\N	\N	\N	121801	121801	121674
25200	39554	114	applied	\N	\N	\N	\N	121813	121813	121784
25200	39560	115	applied	\N	\N	\N	\N	121826	121826	121678
25200	39564	116	applied	\N	\N	\N	\N	121838	121838	121785
25200	39568	117	applied	\N	\N	\N	\N	121855	121855	121786
25200	39570	118	applied	\N	\N	\N	\N	121863	121863	121787
25200	39575	119	applied	\N	\N	\N	\N	121877	121877	121694
25200	39577	120	applied	\N	\N	\N	\N	121884	121884	121788
25200	39581	121	applied	\N	\N	\N	\N	121896	121896	121698
25200	39583	122	applied	\N	\N	\N	\N	121901	121901	121700
25200	39588	123	applied	\N	\N	\N	\N	121913	121913	121702
25200	39591	124	applied	\N	\N	\N	\N	121921	121921	122091
25200	39595	125	applied	\N	\N	\N	\N	121929	121929	122092
25208	39665	0	applied	\N	\N	\N	\N	122152	122152	122153
25208	39666	1	applied	\N	\N	\N	\N	122154	122154	122155
25208	39667	2	applied	\N	\N	\N	\N	122156	122156	122157
25210	39665	0	applied	\N	\N	\N	\N	122152	122152	122153
25210	39666	1	applied	\N	\N	\N	\N	122154	122154	122155
25210	39667	2	applied	\N	\N	\N	\N	122156	122156	122157
25212	39665	0	applied	\N	\N	\N	\N	122152	122152	122153
25212	39666	1	applied	\N	\N	\N	\N	122154	122154	122155
25212	39667	2	applied	\N	\N	\N	\N	122156	122156	122157
25214	39672	0	applied	\N	\N	\N	\N	122174	122174	122175
25214	39673	1	applied	\N	\N	\N	\N	122176	122176	122177
25214	39674	2	applied	\N	\N	\N	\N	122178	122178	122179
25217	39684	0	applied	\N	\N	\N	\N	122202	122202	122203
25217	39685	1	applied	\N	\N	\N	\N	122204	122204	122205
25217	39686	2	applied	\N	\N	\N	\N	122206	122206	122207
25217	39687	3	applied	\N	\N	\N	\N	122208	122208	122209
25226	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25226	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25226	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25226	39699	3	applied	\N	\N	\N	\N	122246	122246	122247
25226	39700	4	applied	\N	\N	\N	\N	122248	122248	122249
25230	39698	0	applied	\N	\N	\N	\N	122244	122244	122245
25230	39696	1	applied	\N	\N	\N	\N	122234	122234	122235
25230	39697	2	applied	\N	\N	\N	\N	122236	122236	122237
25230	39700	3	applied	\N	\N	\N	\N	122248	122248	122258
25239	39711	0	applied	\N	\N	\N	\N	122291	122291	122292
25239	39712	1	applied	\N	\N	\N	\N	122293	122293	122294
25239	39713	2	applied	\N	\N	\N	\N	122295	122295	122296
25239	39714	3	applied	\N	\N	\N	\N	122297	122297	122298
25239	39715	4	applied	\N	\N	\N	\N	122299	122299	122300
25239	39716	5	applied	\N	\N	\N	\N	122301	122301	122302
25239	39717	6	applied	\N	\N	\N	\N	122303	122303	122304
25239	39718	7	applied	\N	\N	\N	\N	122305	122305	122306
25244	39726	0	applied	\N	\N	\N	\N	122326	122326	122327
25244	39727	1	applied	\N	\N	\N	\N	122364	122364	122365
25244	39728	2	applied	\N	\N	\N	\N	122366	122366	122367
25244	39729	3	applied	\N	\N	\N	\N	122368	122368	122369
25244	39730	4	applied	\N	\N	\N	\N	122370	122370	122371
25244	39731	5	applied	\N	\N	\N	\N	122372	122372	122373
25244	39732	6	applied	\N	\N	\N	\N	122374	122374	122375
25246	39726	0	applied	\N	\N	\N	\N	122326	122326	122327
25246	39727	1	applied	\N	\N	\N	\N	122364	122364	122365
25246	39728	2	applied	\N	\N	\N	\N	122366	122366	122367
25246	39729	3	applied	\N	\N	\N	\N	122368	122368	122369
25246	39730	4	applied	\N	\N	\N	\N	122370	122370	122371
25246	39731	5	applied	\N	\N	\N	\N	122372	122372	122373
25246	39732	6	applied	\N	\N	\N	\N	122374	122374	122375
25249	39736	0	applied	\N	\N	\N	\N	122389	122389	122390
25249	39737	1	applied	\N	\N	\N	\N	122391	122391	122392
25249	39738	2	applied	\N	\N	\N	\N	122393	122393	122394
25249	39739	3	applied	\N	\N	\N	\N	122395	122395	122396
25249	39740	4	applied	\N	\N	\N	\N	122397	122397	122398
25249	39741	5	applied	\N	\N	\N	\N	122399	122399	122400
25253	39752	0	applied	\N	\N	\N	\N	122427	122427	122428
25253	39753	1	applied	\N	\N	\N	\N	122429	122429	122430
25253	39754	2	applied	\N	\N	\N	\N	122431	122431	122432
25253	39755	3	applied	\N	\N	\N	\N	122433	122433	122434
25253	39756	4	applied	\N	\N	\N	\N	122435	122435	122436
25253	39757	5	applied	\N	\N	\N	\N	122437	122437	122438
25253	39758	6	applied	\N	\N	\N	\N	122439	122439	122440
25253	39759	7	applied	\N	\N	\N	\N	122441	122441	122442
25253	39760	8	applied	\N	\N	\N	\N	122443	122443	122444
25253	39761	9	applied	\N	\N	\N	\N	122445	122445	122446
25255	39762	0	applied	\N	\N	\N	\N	122451	122451	122452
25218	39687	3	applied	\N	\N	\N	\N	122208	122208	122209
25220	39688	0	applied	\N	\N	\N	\N	122213	122213	122214
25220	39689	1	applied	\N	\N	\N	\N	122215	122215	122216
25220	39690	2	applied	\N	\N	\N	\N	122217	122217	122218
25222	39691	0	applied	\N	\N	\N	\N	122221	122221	122222
25222	39692	1	applied	\N	\N	\N	\N	122223	122223	122224
25222	39693	2	applied	\N	\N	\N	\N	122225	122225	122226
25222	39694	3	applied	\N	\N	\N	\N	122227	122227	122228
25233	39706	0	applied	\N	\N	\N	\N	122273	122273	122274
25233	39707	1	applied	\N	\N	\N	\N	122275	122275	122276
25233	39708	2	applied	\N	\N	\N	\N	122277	122277	122278
25233	39709	3	applied	\N	\N	\N	\N	122279	122279	122280
25233	39710	4	applied	\N	\N	\N	\N	122281	122281	122282
25235	39706	0	applied	\N	\N	\N	\N	122273	122273	122274
25235	39707	1	applied	\N	\N	\N	\N	122275	122275	122276
25235	39708	2	applied	\N	\N	\N	\N	122277	122277	122278
25235	39709	3	applied	\N	\N	\N	\N	122279	122279	122280
25235	39710	4	applied	\N	\N	\N	\N	122281	122281	122282
25242	39723	0	applied	\N	\N	\N	\N	122318	122318	122319
25242	39724	1	applied	\N	\N	\N	\N	122320	122320	122321
25242	39725	2	applied	\N	\N	\N	\N	122322	122322	122323
25250	39742	0	applied	\N	\N	\N	\N	122403	122403	122404
25250	39743	1	applied	\N	\N	\N	\N	122405	122405	122406
25250	39744	2	applied	\N	\N	\N	\N	122407	122407	122408
25250	39745	3	applied	\N	\N	\N	\N	122409	122409	122410
25250	39746	4	applied	\N	\N	\N	\N	122411	122411	122412
25250	39747	5	applied	\N	\N	\N	\N	122413	122413	122414
25250	39748	6	applied	\N	\N	\N	\N	122415	122415	122416
25258	39772	0	applied	\N	\N	\N	\N	122477	122477	122478
25258	39773	1	applied	\N	\N	\N	\N	122479	122479	122480
25258	39774	2	applied	\N	\N	\N	\N	122481	122481	122482
25260	39775	0	applied	\N	\N	\N	\N	122483	122483	122484
25260	39776	1	applied	\N	\N	\N	\N	122485	122485	122486
25260	39777	2	applied	\N	\N	\N	\N	122487	122487	122488
25260	39778	3	applied	\N	\N	\N	\N	122489	122489	122490
25262	39775	0	applied	\N	\N	\N	\N	122483	122483	122484
25262	39776	1	applied	\N	\N	\N	\N	122485	122485	122486
25262	39777	2	applied	\N	\N	\N	\N	122487	122487	122488
25262	39778	3	applied	\N	\N	\N	\N	122489	122489	122490
25269	39804	0	applied	\N	\N	\N	\N	122558	122558	122559
25269	39805	1	applied	\N	\N	\N	\N	122560	122560	122561
25269	39806	2	applied	\N	\N	\N	\N	122562	122562	122563
25269	39807	3	applied	\N	\N	\N	\N	122564	122564	122565
25269	39808	4	applied	\N	\N	\N	\N	122566	122566	122567
25269	39809	5	applied	\N	\N	\N	\N	122568	122568	122569
25269	39810	6	applied	\N	\N	\N	\N	122570	122570	122571
25271	39701	0	applied	\N	\N	\N	\N	122261	122261	122262
25271	39706	1	applied	\N	\N	\N	\N	122273	122273	122274
25271	39711	2	applied	\N	\N	\N	\N	122291	122291	122292
25271	39712	3	applied	\N	\N	\N	\N	122293	122293	122294
25271	39719	4	applied	\N	\N	\N	\N	122309	122309	122310
25271	39723	5	applied	\N	\N	\N	\N	122318	122318	122319
25271	39726	6	applied	\N	\N	\N	\N	122326	122326	122327
25271	39727	7	applied	\N	\N	\N	\N	122364	122364	122365
25271	39733	8	applied	\N	\N	\N	\N	122383	122383	122384
25271	39736	9	applied	\N	\N	\N	\N	122389	122389	122390
25271	39737	10	applied	\N	\N	\N	\N	122391	122391	122392
25271	39742	11	applied	\N	\N	\N	\N	122403	122403	122404
25271	39743	12	applied	\N	\N	\N	\N	122405	122405	122406
25271	39749	14	applied	\N	\N	\N	\N	122419	122419	122420
25271	39752	15	applied	\N	\N	\N	\N	122427	122427	122428
25271	39753	16	applied	\N	\N	\N	\N	122429	122429	122430
25271	39754	17	applied	\N	\N	\N	\N	122431	122431	122432
25271	39762	18	applied	\N	\N	\N	\N	122451	122451	122452
25271	39766	19	applied	\N	\N	\N	\N	122461	122461	122462
25271	39769	20	applied	\N	\N	\N	\N	122469	122469	122470
25271	39772	21	applied	\N	\N	\N	\N	122477	122477	122478
25271	39775	22	applied	\N	\N	\N	\N	122483	122483	122484
25271	39779	23	applied	\N	\N	\N	\N	122501	122501	122502
25271	39781	24	applied	\N	\N	\N	\N	122507	122507	122508
25271	39782	25	applied	\N	\N	\N	\N	122509	122509	122510
25271	39783	26	applied	\N	\N	\N	\N	122511	122511	122512
25271	39784	27	applied	\N	\N	\N	\N	122513	122513	122514
25271	39785	28	applied	\N	\N	\N	\N	122515	122515	122516
25271	39798	29	applied	\N	\N	\N	\N	122545	122545	122546
25271	39799	30	applied	\N	\N	\N	\N	122547	122547	122548
25271	39804	31	applied	\N	\N	\N	\N	122558	122558	122559
25271	39805	32	applied	\N	\N	\N	\N	122560	122560	122561
25271	39702	33	applied	\N	\N	\N	\N	122263	122263	122264
25271	39703	34	applied	\N	\N	\N	\N	122265	122265	122266
25271	39708	35	applied	\N	\N	\N	\N	122277	122277	122576
25271	39721	36	applied	\N	\N	\N	\N	122313	122313	122268
25271	39704	37	applied	\N	\N	\N	\N	122267	122267	122276
25271	39707	38	applied	\N	\N	\N	\N	122275	122275	122577
25271	39713	39	applied	\N	\N	\N	\N	122295	122295	122280
25271	39714	40	applied	\N	\N	\N	\N	122297	122297	122296
25271	39722	41	applied	\N	\N	\N	\N	122315	122315	122298
25271	39725	42	applied	\N	\N	\N	\N	122322	122322	122578
25271	39709	43	applied	\N	\N	\N	\N	122279	122279	122579
25271	39715	44	applied	\N	\N	\N	\N	122299	122299	122580
25271	39716	45	applied	\N	\N	\N	\N	122301	122301	122581
25271	39720	46	applied	\N	\N	\N	\N	122311	122311	122582
25271	39724	47	applied	\N	\N	\N	\N	122320	122320	122323
25271	39728	48	applied	\N	\N	\N	\N	122366	122366	122367
25271	39746	49	applied	\N	\N	\N	\N	122411	122411	122583
25271	39755	50	applied	\N	\N	\N	\N	122433	122433	122584
25271	39763	51	applied	\N	\N	\N	\N	122453	122453	122369
25271	39778	52	applied	\N	\N	\N	\N	122489	122489	122585
25271	39786	53	applied	\N	\N	\N	\N	122517	122517	122586
25271	39788	54	applied	\N	\N	\N	\N	122521	122521	122371
25271	39806	55	applied	\N	\N	\N	\N	122562	122562	122587
25271	39729	56	applied	\N	\N	\N	\N	122368	122368	122375
25271	39730	57	applied	\N	\N	\N	\N	122370	122370	122588
25271	39735	58	applied	\N	\N	\N	\N	122387	122387	122589
25271	39738	59	applied	\N	\N	\N	\N	122393	122393	122590
25271	39741	60	applied	\N	\N	\N	\N	122399	122399	122398
25271	39744	61	applied	\N	\N	\N	\N	122407	122407	122400
25271	39745	62	applied	\N	\N	\N	\N	122409	122409	122408
25271	39705	63	applied	\N	\N	\N	\N	122269	122269	122270
25271	39751	64	applied	\N	\N	\N	\N	122423	122423	122410
25271	39756	65	applied	\N	\N	\N	\N	122435	122435	122414
25271	39757	66	applied	\N	\N	\N	\N	122437	122437	122591
25271	39758	67	applied	\N	\N	\N	\N	122439	122439	122592
25271	39710	68	applied	\N	\N	\N	\N	122281	122281	122282
25271	39717	69	applied	\N	\N	\N	\N	122303	122303	122304
25271	39765	70	applied	\N	\N	\N	\N	122457	122457	122593
25271	39767	71	applied	\N	\N	\N	\N	122463	122463	122594
25271	39771	72	applied	\N	\N	\N	\N	122473	122473	122595
25271	39774	73	applied	\N	\N	\N	\N	122481	122481	122596
25271	39777	74	applied	\N	\N	\N	\N	122487	122487	122444
25243	39596	8	applied	\N	\N	\N	\N	121932	121932	121933
25243	39599	9	applied	\N	\N	\N	\N	121938	121938	121939
25243	39602	10	applied	\N	\N	\N	\N	121946	121946	121947
25243	39605	11	applied	\N	\N	\N	\N	121954	121954	121955
25243	39606	12	applied	\N	\N	\N	\N	121956	121956	121957
25243	39607	13	applied	\N	\N	\N	\N	121958	121958	121959
25243	39616	14	applied	\N	\N	\N	\N	121995	121995	121996
25243	39622	15	applied	\N	\N	\N	\N	122011	122011	122012
25243	39627	16	applied	\N	\N	\N	\N	122029	122029	122030
25243	39630	17	applied	\N	\N	\N	\N	122039	122039	122040
25243	39631	18	applied	\N	\N	\N	\N	122041	122041	122042
25243	39638	19	applied	\N	\N	\N	\N	122057	122057	122058
25243	39641	20	applied	\N	\N	\N	\N	122095	122095	122096
25243	39642	21	applied	\N	\N	\N	\N	122097	122097	122098
25243	39648	22	applied	\N	\N	\N	\N	122114	122114	122115
25243	39651	23	applied	\N	\N	\N	\N	122122	122122	122123
25243	39652	24	applied	\N	\N	\N	\N	122124	122124	122125
25243	39658	25	applied	\N	\N	\N	\N	122138	122138	122139
25243	39659	26	applied	\N	\N	\N	\N	122140	122140	122141
25243	39665	27	applied	\N	\N	\N	\N	122152	122152	122153
25243	39668	28	applied	\N	\N	\N	\N	122164	122164	122165
25243	39672	29	applied	\N	\N	\N	\N	122174	122174	122175
25243	39675	30	applied	\N	\N	\N	\N	122182	122182	122183
25243	39678	31	applied	\N	\N	\N	\N	122189	122189	122190
25243	39684	32	applied	\N	\N	\N	\N	122202	122202	122203
25243	39688	33	applied	\N	\N	\N	\N	122213	122213	122214
25243	39691	34	applied	\N	\N	\N	\N	122221	122221	122222
25243	39695	35	applied	\N	\N	\N	\N	122232	122232	122233
25243	39698	36	applied	\N	\N	\N	\N	122244	122244	122245
25243	39701	37	applied	\N	\N	\N	\N	122261	122261	122262
25243	39706	38	applied	\N	\N	\N	\N	122273	122273	122274
25243	39711	39	applied	\N	\N	\N	\N	122291	122291	122292
25243	39712	40	applied	\N	\N	\N	\N	122293	122293	122294
25243	39719	41	applied	\N	\N	\N	\N	122309	122309	122310
25243	39723	42	applied	\N	\N	\N	\N	122318	122318	122319
25243	39726	43	applied	\N	\N	\N	\N	122326	122326	122327
25243	39573	44	applied	\N	\N	\N	\N	121873	121873	121874
25243	39702	45	applied	\N	\N	\N	\N	122263	122263	122264
25243	39661	46	applied	\N	\N	\N	\N	122144	122144	122144
25243	39574	47	applied	\N	\N	\N	\N	121875	121875	121876
25243	39575	48	applied	\N	\N	\N	\N	121877	121877	121878
25243	39577	49	applied	\N	\N	\N	\N	121884	121884	121885
25243	39581	50	applied	\N	\N	\N	\N	121896	121896	122328
25243	39583	51	applied	\N	\N	\N	\N	121901	121901	122329
25243	39588	52	applied	\N	\N	\N	\N	121913	121913	121895
25243	39585	53	applied	\N	\N	\N	\N	121905	121905	122330
25243	39594	54	applied	\N	\N	\N	\N	121927	121927	121897
25243	39608	55	applied	\N	\N	\N	\N	121961	121961	121962
25243	39619	56	applied	\N	\N	\N	\N	122001	122001	122002
25243	39620	57	applied	\N	\N	\N	\N	122003	122003	122004
25243	39623	58	applied	\N	\N	\N	\N	122014	122014	122015
25243	39636	59	applied	\N	\N	\N	\N	122051	122051	122052
25243	39682	60	applied	\N	\N	\N	\N	122197	122197	122198
25243	39705	61	applied	\N	\N	\N	\N	122269	122269	122270
25243	39612	62	applied	\N	\N	\N	\N	121972	121972	122331
25243	39618	63	applied	\N	\N	\N	\N	121999	121999	121902
25243	39591	64	applied	\N	\N	\N	\N	121921	121921	122332
25243	39595	65	applied	\N	\N	\N	\N	121929	121929	121906
25243	39597	66	applied	\N	\N	\N	\N	121934	121934	122333
25243	39600	67	applied	\N	\N	\N	\N	121940	121940	122334
25243	39604	68	applied	\N	\N	\N	\N	121950	121950	121960
25243	39613	69	applied	\N	\N	\N	\N	121978	121978	121920
25243	39614	70	applied	\N	\N	\N	\N	121980	121980	121922
25243	39615	71	applied	\N	\N	\N	\N	121982	121982	121964
25243	39617	72	applied	\N	\N	\N	\N	121997	121997	121928
25243	39625	73	applied	\N	\N	\N	\N	122018	122018	121930
25243	39637	74	applied	\N	\N	\N	\N	122053	122053	122335
25243	39644	75	applied	\N	\N	\N	\N	122101	122101	121935
25243	39655	76	applied	\N	\N	\N	\N	122130	122130	122336
25243	39669	77	applied	\N	\N	\N	\N	122166	122166	122337
25243	39680	78	applied	\N	\N	\N	\N	122193	122193	121937
25243	39692	79	applied	\N	\N	\N	\N	122223	122223	122338
25243	39708	80	applied	\N	\N	\N	\N	122277	122277	121941
25243	39721	81	applied	\N	\N	\N	\N	122313	122313	121967
25243	39683	82	applied	\N	\N	\N	\N	122199	122199	122200
25243	39687	83	applied	\N	\N	\N	\N	122208	122208	122209
25243	39578	84	applied	\N	\N	\N	\N	121886	121886	121969
25243	39580	85	applied	\N	\N	\N	\N	121894	121894	121971
25243	39584	86	applied	\N	\N	\N	\N	121903	121903	121973
25243	39587	87	applied	\N	\N	\N	\N	121911	121911	122339
25243	39590	88	applied	\N	\N	\N	\N	121919	121919	121976
25243	39593	89	applied	\N	\N	\N	\N	121925	121925	122340
25243	39598	90	applied	\N	\N	\N	\N	121936	121936	121981
25243	39601	91	applied	\N	\N	\N	\N	121942	121942	122341
25243	39603	92	applied	\N	\N	\N	\N	121948	121948	122342
25243	39609	93	applied	\N	\N	\N	\N	121966	121966	122343
25243	39610	94	applied	\N	\N	\N	\N	121968	121968	122344
25243	39611	95	applied	\N	\N	\N	\N	121970	121970	122345
25243	39710	96	applied	\N	\N	\N	\N	122281	122281	122282
25243	39717	97	applied	\N	\N	\N	\N	122303	122303	122304
25243	39621	98	applied	\N	\N	\N	\N	122005	122005	122034
25243	39624	99	applied	\N	\N	\N	\N	122016	122016	122346
25243	39628	100	applied	\N	\N	\N	\N	122031	122031	122347
25243	39633	101	applied	\N	\N	\N	\N	122045	122045	122348
25243	39634	102	applied	\N	\N	\N	\N	122047	122047	122349
25243	39639	103	applied	\N	\N	\N	\N	122059	122059	122350
25243	39645	104	applied	\N	\N	\N	\N	122103	122103	122100
25243	39647	106	applied	\N	\N	\N	\N	122107	122107	122352
25243	39650	107	applied	\N	\N	\N	\N	122118	122118	122106
25243	39653	108	applied	\N	\N	\N	\N	122126	122126	122108
25243	39654	109	applied	\N	\N	\N	\N	122128	122128	122353
25243	39662	110	applied	\N	\N	\N	\N	122145	122145	122354
25243	39663	111	applied	\N	\N	\N	\N	122147	122147	122355
25243	39667	112	applied	\N	\N	\N	\N	122156	122156	122131
25243	39670	113	applied	\N	\N	\N	\N	122168	122168	122356
25243	39674	114	applied	\N	\N	\N	\N	122178	122178	122143
25243	39676	115	applied	\N	\N	\N	\N	122184	122184	122146
25243	39679	116	applied	\N	\N	\N	\N	122191	122191	122148
25243	39686	117	applied	\N	\N	\N	\N	122206	122206	122357
25243	39690	118	applied	\N	\N	\N	\N	122217	122217	122358
25243	39694	119	applied	\N	\N	\N	\N	122227	122227	122359
25243	39696	120	applied	\N	\N	\N	\N	122234	122234	122360
25243	39700	121	applied	\N	\N	\N	\N	122248	122248	122177
25243	39703	122	applied	\N	\N	\N	\N	122265	122265	122179
25243	39709	123	applied	\N	\N	\N	\N	122279	122279	122185
25243	39715	124	applied	\N	\N	\N	\N	122299	122299	122361
25243	39716	125	applied	\N	\N	\N	\N	122301	122301	122194
25245	39726	0	applied	\N	\N	\N	\N	122326	122326	122327
25245	39727	1	applied	\N	\N	\N	\N	122364	122364	122365
25245	39728	2	applied	\N	\N	\N	\N	122366	122366	122367
25245	39729	3	applied	\N	\N	\N	\N	122368	122368	122369
25245	39730	4	applied	\N	\N	\N	\N	122370	122370	122371
25245	39731	5	applied	\N	\N	\N	\N	122372	122372	122373
25245	39732	6	applied	\N	\N	\N	\N	122374	122374	122375
25247	39726	0	applied	\N	\N	\N	\N	122326	122326	122327
25247	39727	1	applied	\N	\N	\N	\N	122364	122364	122365
25247	39728	2	applied	\N	\N	\N	\N	122366	122366	122367
25247	39729	3	applied	\N	\N	\N	\N	122368	122368	122369
25247	39730	4	applied	\N	\N	\N	\N	122370	122370	122371
25247	39731	5	applied	\N	\N	\N	\N	122372	122372	122373
25247	39732	6	applied	\N	\N	\N	\N	122374	122374	122375
25261	39775	0	applied	\N	\N	\N	\N	122483	122483	122484
25261	39776	1	applied	\N	\N	\N	\N	122485	122485	122486
25261	39777	2	applied	\N	\N	\N	\N	122487	122487	122488
25261	39778	3	applied	\N	\N	\N	\N	122489	122489	122490
25263	39775	0	applied	\N	\N	\N	\N	122483	122483	122484
25263	39776	1	applied	\N	\N	\N	\N	122485	122485	122486
25263	39777	2	applied	\N	\N	\N	\N	122487	122487	122488
25263	39778	3	applied	\N	\N	\N	\N	122489	122489	122490
25266	39781	0	applied	\N	\N	\N	\N	122507	122507	122508
25266	39782	1	applied	\N	\N	\N	\N	122509	122509	122510
25266	39783	2	applied	\N	\N	\N	\N	122511	122511	122512
25266	39784	3	applied	\N	\N	\N	\N	122513	122513	122514
25266	39785	4	applied	\N	\N	\N	\N	122515	122515	122516
25266	39786	5	applied	\N	\N	\N	\N	122517	122517	122518
25266	39787	6	applied	\N	\N	\N	\N	122519	122519	122520
25266	39788	7	applied	\N	\N	\N	\N	122521	122521	122522
25266	39789	8	applied	\N	\N	\N	\N	122523	122523	122524
25266	39790	9	applied	\N	\N	\N	\N	122525	122525	122526
25266	39791	10	applied	\N	\N	\N	\N	122527	122527	122528
25266	39792	11	applied	\N	\N	\N	\N	122529	122529	122530
25266	39793	12	applied	\N	\N	\N	\N	122531	122531	122532
25266	39794	13	applied	\N	\N	\N	\N	122533	122533	122534
25266	39795	14	applied	\N	\N	\N	\N	122535	122535	122536
25266	39796	15	applied	\N	\N	\N	\N	122537	122537	122538
25266	39797	16	applied	\N	\N	\N	\N	122539	122539	122540
25270	39804	0	applied	\N	\N	\N	\N	122558	122558	122559
25270	39805	1	applied	\N	\N	\N	\N	122560	122560	122561
25270	39806	2	applied	\N	\N	\N	\N	122562	122562	122563
25270	39807	3	applied	\N	\N	\N	\N	122564	122564	122565
25270	39808	4	applied	\N	\N	\N	\N	122566	122566	122567
25270	39809	5	applied	\N	\N	\N	\N	122568	122568	122569
25270	39810	6	applied	\N	\N	\N	\N	122570	122570	122571
25274	39817	0	applied	\N	\N	\N	\N	122635	122635	122636
25274	39818	1	applied	\N	\N	\N	\N	122637	122637	122638
25274	39819	2	applied	\N	\N	\N	\N	122639	122639	122640
25274	39820	3	applied	\N	\N	\N	\N	122641	122641	122642
25281	39827	0	applied	\N	\N	\N	\N	122663	122663	122664
25281	39828	1	applied	\N	\N	\N	\N	122665	122665	122666
25281	39829	2	applied	\N	\N	\N	\N	122667	122667	122668
25281	39830	3	applied	\N	\N	\N	\N	122669	122669	122670
25283	39834	0	applied	\N	\N	\N	\N	122682	122682	122683
25283	39835	1	applied	\N	\N	\N	\N	122684	122684	122685
25283	39836	2	applied	\N	\N	\N	\N	122686	122686	122687
25283	39837	3	applied	\N	\N	\N	\N	122688	122688	122689
25283	39838	4	applied	\N	\N	\N	\N	122690	122690	122691
25283	39839	5	applied	\N	\N	\N	\N	122692	122692	122693
25290	39847	0	applied	\N	\N	\N	\N	122717	122717	122718
25290	39848	1	applied	\N	\N	\N	\N	122719	122719	122720
25295	39859	0	applied	\N	\N	\N	\N	122787	122787	122788
25295	39860	1	applied	\N	\N	\N	\N	122789	122789	122790
25295	39861	2	applied	\N	\N	\N	\N	122791	122791	122792
25295	39862	3	applied	\N	\N	\N	\N	122793	122793	122794
25304	39876	0	applied	\N	\N	\N	\N	122834	122834	122835
25304	39877	1	applied	\N	\N	\N	\N	122836	122836	122837
25304	39878	2	applied	\N	\N	\N	\N	122838	122838	122839
25306	39882	0	applied	\N	\N	\N	\N	122849	122849	122850
25306	39883	1	applied	\N	\N	\N	\N	122851	122851	122852
25313	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25313	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25313	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25313	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25313	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25315	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25315	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25315	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25315	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25315	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25317	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25317	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25317	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25317	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25317	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25319	39892	0	applied	\N	\N	\N	\N	122893	122893	122894
25319	39893	1	applied	\N	\N	\N	\N	122895	122895	122896
25319	39894	2	applied	\N	\N	\N	\N	122897	122897	122898
25319	39895	3	applied	\N	\N	\N	\N	122899	122899	122900
25321	39892	0	applied	\N	\N	\N	\N	122893	122893	122894
25321	39894	1	applied	\N	\N	\N	\N	122897	122897	122904
25327	39918	0	applied	\N	\N	1000000000	\N	122958	122958	122959
25327	39919	1	applied	\N	\N	\N	\N	122960	122960	122961
25327	39920	2	applied	\N	\N	\N	\N	122962	122962	122963
25327	39921	3	applied	\N	\N	\N	\N	122964	122964	122965
25329	39918	0	applied	\N	\N	1000000000	\N	122958	122958	122959
25329	39919	1	applied	\N	\N	\N	\N	122960	122960	122961
25329	39920	2	applied	\N	\N	\N	\N	122962	122962	122963
25329	39921	3	applied	\N	\N	\N	\N	122964	122964	122965
25334	39925	0	applied	\N	\N	\N	\N	122981	122981	122982
25334	39929	1	applied	\N	\N	\N	\N	122991	122991	122992
25334	39930	2	applied	\N	\N	\N	\N	122993	122993	122994
25334	39926	3	applied	\N	\N	\N	\N	122983	122983	122984
25334	39927	4	applied	\N	\N	\N	\N	122985	122985	122986
25334	39928	5	applied	\N	\N	\N	\N	122987	122987	122988
25336	39925	0	applied	\N	\N	\N	\N	122981	122981	122982
25336	39929	1	applied	\N	\N	\N	\N	122991	122991	122992
25336	39930	2	applied	\N	\N	\N	\N	122993	122993	122994
25336	39926	3	applied	\N	\N	\N	\N	122983	122983	122984
25336	39927	4	applied	\N	\N	\N	\N	122985	122985	122986
25336	39931	5	applied	\N	\N	\N	\N	122996	122996	122997
25336	39932	6	applied	\N	\N	\N	\N	122998	122998	122999
25336	39928	7	applied	\N	\N	\N	\N	122987	122987	123000
25341	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25341	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25347	39947	0	applied	\N	\N	\N	\N	123044	123044	123045
25347	39945	1	applied	\N	\N	\N	\N	123040	123040	123041
25347	39948	2	applied	\N	\N	\N	\N	123046	123046	123047
25347	39946	3	applied	\N	\N	\N	\N	123042	123042	123043
25347	39949	4	applied	\N	\N	\N	\N	123048	123048	123049
25347	39950	5	applied	\N	\N	\N	\N	123050	123050	123051
25255	39763	1	applied	\N	\N	\N	\N	122453	122453	122454
25255	39764	2	applied	\N	\N	\N	\N	122455	122455	122456
25255	39765	3	applied	\N	\N	\N	\N	122457	122457	122458
25257	39769	0	applied	\N	\N	\N	\N	122469	122469	122470
25257	39770	1	applied	\N	\N	\N	\N	122471	122471	122472
25257	39771	2	applied	\N	\N	\N	\N	122473	122473	122474
25264	39779	0	applied	\N	\N	\N	\N	122501	122501	122502
25264	39780	1	applied	\N	\N	\N	\N	122503	122503	122504
25265	39781	0	applied	\N	\N	\N	\N	122507	122507	122508
25265	39782	1	applied	\N	\N	\N	\N	122509	122509	122510
25265	39783	2	applied	\N	\N	\N	\N	122511	122511	122512
25265	39784	3	applied	\N	\N	\N	\N	122513	122513	122514
25265	39785	4	applied	\N	\N	\N	\N	122515	122515	122516
25265	39786	5	applied	\N	\N	\N	\N	122517	122517	122518
25265	39787	6	applied	\N	\N	\N	\N	122519	122519	122520
25265	39788	7	applied	\N	\N	\N	\N	122521	122521	122522
25265	39789	8	applied	\N	\N	\N	\N	122523	122523	122524
25265	39790	9	applied	\N	\N	\N	\N	122525	122525	122526
25265	39791	10	applied	\N	\N	\N	\N	122527	122527	122528
25265	39792	11	applied	\N	\N	\N	\N	122529	122529	122530
25265	39793	12	applied	\N	\N	\N	\N	122531	122531	122532
25265	39794	13	applied	\N	\N	\N	\N	122533	122533	122534
25265	39795	14	applied	\N	\N	\N	\N	122535	122535	122536
25265	39796	15	applied	\N	\N	\N	\N	122537	122537	122538
25265	39797	16	applied	\N	\N	\N	\N	122539	122539	122540
25268	39804	0	applied	\N	\N	\N	\N	122558	122558	122559
25268	39805	1	applied	\N	\N	\N	\N	122560	122560	122561
25268	39806	2	applied	\N	\N	\N	\N	122562	122562	122563
25268	39807	3	applied	\N	\N	\N	\N	122564	122564	122565
25268	39808	4	applied	\N	\N	\N	\N	122566	122566	122567
25268	39809	5	applied	\N	\N	\N	\N	122568	122568	122569
25268	39810	6	applied	\N	\N	\N	\N	122570	122570	122571
25276	39821	0	applied	\N	\N	\N	\N	122645	122645	122646
25276	39822	1	applied	\N	\N	\N	\N	122647	122647	122648
25276	39823	2	applied	\N	\N	\N	\N	122649	122649	122650
25276	39824	3	applied	\N	\N	\N	\N	122651	122651	122652
25276	39825	4	applied	\N	\N	\N	\N	122654	122654	122655
25276	39826	5	applied	\N	\N	\N	\N	122656	122656	122657
25278	39821	0	applied	\N	\N	\N	\N	122645	122645	122646
25278	39822	1	applied	\N	\N	\N	\N	122647	122647	122648
25278	39823	2	applied	\N	\N	\N	\N	122649	122649	122650
25278	39824	3	applied	\N	\N	\N	\N	122651	122651	122652
25278	39825	4	applied	\N	\N	\N	\N	122654	122654	122655
25278	39826	5	applied	\N	\N	\N	\N	122656	122656	122657
25282	39831	0	applied	\N	\N	\N	\N	122674	122674	122675
25282	39832	1	applied	\N	\N	\N	\N	122676	122676	122677
25282	39833	2	applied	\N	\N	\N	\N	122678	122678	122679
25285	39834	0	applied	\N	\N	\N	\N	122682	122682	122683
25285	39835	1	applied	\N	\N	\N	\N	122684	122684	122685
25285	39836	2	applied	\N	\N	\N	\N	122686	122686	122687
25285	39837	3	applied	\N	\N	\N	\N	122688	122688	122689
25285	39838	4	applied	\N	\N	\N	\N	122690	122690	122691
25285	39839	5	applied	\N	\N	\N	\N	122692	122692	122693
25287	39844	0	applied	\N	\N	\N	\N	122707	122707	122708
25287	39845	1	applied	\N	\N	\N	\N	122709	122709	122710
25287	39846	2	applied	\N	\N	\N	\N	122711	122711	122712
25289	39847	0	applied	\N	\N	\N	\N	122717	122717	122718
25289	39848	1	applied	\N	\N	\N	\N	122719	122719	122720
25291	39727	0	applied	\N	\N	\N	\N	122364	122364	122365
25291	39733	1	applied	\N	\N	\N	\N	122383	122383	122384
25291	39736	2	applied	\N	\N	\N	\N	122389	122389	122390
25291	39737	3	applied	\N	\N	\N	\N	122391	122391	122392
25291	39742	4	applied	\N	\N	\N	\N	122403	122403	122404
25291	39743	5	applied	\N	\N	\N	\N	122405	122405	122406
25291	39749	6	applied	\N	\N	\N	\N	122419	122419	122420
25291	39752	7	applied	\N	\N	\N	\N	122427	122427	122428
25291	39753	8	applied	\N	\N	\N	\N	122429	122429	122430
25291	39754	9	applied	\N	\N	\N	\N	122431	122431	122432
25291	39762	10	applied	\N	\N	\N	\N	122451	122451	122452
25291	39766	11	applied	\N	\N	\N	\N	122461	122461	122462
25291	39769	12	applied	\N	\N	\N	\N	122469	122469	122470
25291	39772	13	applied	\N	\N	\N	\N	122477	122477	122478
25291	39775	14	applied	\N	\N	\N	\N	122483	122483	122484
25291	39779	15	applied	\N	\N	\N	\N	122501	122501	122502
25291	39781	16	applied	\N	\N	\N	\N	122507	122507	122508
25291	39782	17	applied	\N	\N	\N	\N	122509	122509	122510
25291	39783	18	applied	\N	\N	\N	\N	122511	122511	122512
25291	39784	19	applied	\N	\N	\N	\N	122513	122513	122514
25291	39785	20	applied	\N	\N	\N	\N	122515	122515	122516
25291	39798	21	applied	\N	\N	\N	\N	122545	122545	122546
25291	39799	22	applied	\N	\N	\N	\N	122547	122547	122548
25291	39804	23	applied	\N	\N	\N	\N	122558	122558	122559
25291	39805	24	applied	\N	\N	\N	\N	122560	122560	122561
25291	39811	25	applied	\N	\N	\N	\N	122619	122619	122620
25291	39814	26	applied	\N	\N	\N	\N	122627	122627	122628
25291	39817	27	applied	\N	\N	\N	\N	122635	122635	122636
25291	39821	28	applied	\N	\N	\N	\N	122645	122645	122646
25291	39822	29	applied	\N	\N	\N	\N	122647	122647	122648
25291	39827	30	applied	\N	\N	\N	\N	122663	122663	122664
25291	39831	31	applied	\N	\N	\N	\N	122674	122674	122675
25291	39834	32	applied	\N	\N	\N	\N	122682	122682	122683
25291	39835	33	applied	\N	\N	\N	\N	122684	122684	122685
25291	39840	34	applied	\N	\N	\N	\N	122698	122698	122699
25291	39844	35	applied	\N	\N	\N	\N	122707	122707	122708
25291	39720	36	applied	\N	\N	\N	\N	122311	122311	122724
25291	39724	37	applied	\N	\N	\N	\N	122320	122320	122725
25291	39728	38	applied	\N	\N	\N	\N	122366	122366	122207
25291	39746	39	applied	\N	\N	\N	\N	122411	122411	122726
25291	39755	40	applied	\N	\N	\N	\N	122433	122433	122216
25291	39763	41	applied	\N	\N	\N	\N	122453	122453	122727
25291	39778	42	applied	\N	\N	\N	\N	122489	122489	122728
25291	39786	43	applied	\N	\N	\N	\N	122517	122517	122218
25291	39788	44	applied	\N	\N	\N	\N	122521	122521	122224
25291	39806	45	applied	\N	\N	\N	\N	122562	122562	122729
25291	39820	46	applied	\N	\N	\N	\N	122641	122641	122226
25291	39729	47	applied	\N	\N	\N	\N	122368	122368	122228
25291	39730	48	applied	\N	\N	\N	\N	122370	122370	122235
25291	39830	49	applied	\N	\N	\N	\N	122669	122669	122730
25291	39841	50	applied	\N	\N	\N	\N	122700	122700	122237
25291	39735	51	applied	\N	\N	\N	\N	122387	122387	122258
25291	39738	52	applied	\N	\N	\N	\N	122393	122393	122731
25291	39741	53	applied	\N	\N	\N	\N	122399	122399	122576
25291	39744	54	applied	\N	\N	\N	\N	122407	122407	122276
25291	39745	55	applied	\N	\N	\N	\N	122409	122409	122732
25291	39751	56	applied	\N	\N	\N	\N	122423	122423	122296
25291	39756	57	applied	\N	\N	\N	\N	122435	122435	122733
25291	39757	58	applied	\N	\N	\N	\N	122437	122437	122734
25291	39758	59	applied	\N	\N	\N	\N	122439	122439	122735
25291	39765	60	applied	\N	\N	\N	\N	122457	122457	122314
25291	39767	61	applied	\N	\N	\N	\N	122463	122463	122736
25271	39780	75	applied	\N	\N	\N	\N	122503	122503	122454
25271	39792	76	applied	\N	\N	\N	\N	122529	122529	122597
25271	39793	77	applied	\N	\N	\N	\N	122531	122531	122598
25271	39794	78	applied	\N	\N	\N	\N	122533	122533	122599
25271	39795	79	applied	\N	\N	\N	\N	122535	122535	122472
25271	39796	80	applied	\N	\N	\N	\N	122537	122537	122474
25271	39800	81	applied	\N	\N	\N	\N	122549	122549	122600
25271	39802	82	applied	\N	\N	\N	\N	122553	122553	122601
25271	39807	83	applied	\N	\N	\N	\N	122564	122564	122602
25271	39809	84	applied	\N	\N	\N	\N	122568	122568	122603
25271	39731	85	applied	\N	\N	\N	\N	122372	122372	122504
25271	39732	86	applied	\N	\N	\N	\N	122374	122374	122604
25271	39734	87	applied	\N	\N	\N	\N	122385	122385	122522
25271	39739	88	applied	\N	\N	\N	\N	122395	122395	122524
25271	39740	89	applied	\N	\N	\N	\N	122397	122397	122526
25271	39747	90	applied	\N	\N	\N	\N	122413	122413	122528
25271	39748	91	applied	\N	\N	\N	\N	122415	122415	122605
25271	39750	92	applied	\N	\N	\N	\N	122421	122421	122606
25271	39759	93	applied	\N	\N	\N	\N	122441	122441	122532
25271	39760	94	applied	\N	\N	\N	\N	122443	122443	122607
25271	39761	95	applied	\N	\N	\N	\N	122445	122445	122608
25271	39764	96	applied	\N	\N	\N	\N	122455	122455	122536
25271	39768	97	applied	\N	\N	\N	\N	122465	122465	122609
25271	39770	98	applied	\N	\N	\N	\N	122471	122471	122610
25271	39773	99	applied	\N	\N	\N	\N	122479	122479	122611
25271	39776	100	applied	\N	\N	\N	\N	122485	122485	122550
25271	39787	101	applied	\N	\N	\N	\N	122519	122519	122552
25271	39789	102	applied	\N	\N	\N	\N	122523	122523	122612
25271	39790	103	applied	\N	\N	\N	\N	122525	122525	122613
25271	39791	104	applied	\N	\N	\N	\N	122527	122527	122563
25271	39797	105	applied	\N	\N	\N	\N	122539	122539	122614
25271	39801	106	applied	\N	\N	\N	\N	122551	122551	122615
25271	39803	107	applied	\N	\N	\N	\N	122555	122555	122616
25271	39808	108	applied	\N	\N	\N	\N	122566	122566	122569
25271	39810	109	applied	\N	\N	\N	\N	122570	122570	122571
25273	39814	0	applied	\N	\N	\N	\N	122627	122627	122628
25273	39815	1	applied	\N	\N	\N	\N	122629	122629	122630
25273	39816	2	applied	\N	\N	\N	\N	122631	122631	122632
25280	39827	0	applied	\N	\N	\N	\N	122663	122663	122664
25280	39828	1	applied	\N	\N	\N	\N	122665	122665	122666
25280	39829	2	applied	\N	\N	\N	\N	122667	122667	122668
25280	39830	3	applied	\N	\N	\N	\N	122669	122669	122670
25288	39844	0	applied	\N	\N	\N	\N	122707	122707	122708
25288	39845	1	applied	\N	\N	\N	\N	122709	122709	122710
25288	39846	2	applied	\N	\N	\N	\N	122711	122711	122712
25292	39849	0	applied	\N	\N	\N	\N	122762	122762	122763
25292	39850	1	applied	\N	\N	\N	\N	122764	122764	122765
25292	39851	2	applied	\N	\N	\N	\N	122766	122766	122767
25292	39852	3	applied	\N	\N	\N	\N	122768	122768	122769
25297	39863	0	applied	\N	\N	\N	\N	122799	122799	122800
25297	39864	1	applied	\N	\N	\N	\N	122801	122801	122802
25299	39863	0	applied	\N	\N	\N	\N	122799	122799	122800
25299	39864	1	applied	\N	\N	\N	\N	122801	122801	122802
25299	39865	2	applied	\N	\N	\N	\N	122805	122805	122806
25302	39869	0	applied	\N	\N	\N	\N	122816	122816	122817
25302	39870	1	applied	\N	\N	\N	\N	122818	122818	122819
25302	39871	2	applied	\N	\N	\N	\N	122820	122820	122821
25314	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25314	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25314	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25314	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25314	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25325	39905	0	applied	\N	\N	\N	\N	122926	122926	122927
25325	39906	1	applied	\N	\N	\N	\N	122928	122928	122929
25325	39907	2	applied	\N	\N	\N	\N	122930	122930	122931
25325	39908	3	applied	\N	\N	\N	\N	122932	122932	122933
25325	39909	4	applied	\N	\N	\N	\N	122934	122934	122935
25325	39910	5	applied	\N	\N	\N	\N	122936	122936	122937
25325	39911	6	applied	\N	\N	\N	\N	122938	122938	122939
25325	39912	7	applied	\N	\N	\N	\N	122940	122940	122941
25325	39913	8	applied	\N	\N	\N	\N	122942	122942	122943
25325	39914	9	applied	\N	\N	\N	\N	122944	122944	122945
25330	39922	0	applied	\N	\N	\N	\N	122971	122971	122972
25330	39923	1	applied	\N	\N	\N	\N	122973	122973	122974
25330	39924	2	applied	\N	\N	\N	\N	122975	122975	122976
25332	39922	0	applied	\N	\N	\N	\N	122971	122971	122972
25332	39923	1	applied	\N	\N	\N	\N	122973	122973	122974
25332	39924	2	applied	\N	\N	\N	\N	122975	122975	122976
25339	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25339	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25339	39935	2	applied	\N	\N	\N	\N	123007	123007	123008
25345	39944	0	applied	\N	\N	\N	\N	123037	123037	123038
25348	39947	0	applied	\N	\N	\N	\N	123044	123044	123045
25348	39945	1	applied	\N	\N	\N	\N	123040	123040	123041
25348	39948	2	applied	\N	\N	\N	\N	123046	123046	123047
25348	39946	3	applied	\N	\N	\N	\N	123042	123042	123043
25348	39949	4	applied	\N	\N	\N	\N	123048	123048	123049
25348	39950	5	applied	\N	\N	\N	\N	123050	123050	123051
25352	39953	0	applied	\N	\N	\N	\N	123058	123058	123066
25354	39955	0	applied	\N	\N	\N	\N	123069	123069	123070
25354	39951	1	applied	\N	\N	\N	\N	123054	123054	123055
25354	39956	2	applied	\N	\N	\N	\N	123071	123071	123072
25354	39952	3	applied	\N	\N	\N	\N	123056	123056	123059
25354	39957	4	applied	\N	\N	\N	\N	123073	123073	123074
25354	39954	5	applied	\N	\N	\N	\N	123060	123060	123075
25354	39958	6	applied	\N	\N	\N	\N	123076	123076	123077
25364	39980	0	applied	\N	\N	\N	\N	123134	123134	123135
25364	39981	1	applied	\N	\N	\N	\N	123136	123136	123137
25364	39982	2	applied	\N	\N	\N	\N	123138	123138	123139
25364	39983	3	applied	\N	\N	\N	\N	123140	123140	123141
25364	39984	4	applied	\N	\N	\N	\N	123142	123142	123143
25364	39985	5	applied	\N	\N	\N	\N	123144	123144	123145
25371	39994	0	applied	\N	\N	\N	\N	123176	123176	123177
25371	39995	1	applied	\N	\N	\N	\N	123178	123178	123179
25371	39996	2	applied	\N	\N	\N	\N	123180	123180	123181
25373	39997	0	applied	\N	\N	\N	\N	123186	123186	123187
25373	39998	1	applied	\N	\N	\N	\N	123188	123188	123189
25373	39999	2	applied	\N	\N	\N	\N	123190	123190	123191
25378	40005	0	applied	\N	\N	\N	\N	123209	123209	123210
25378	40006	1	applied	\N	\N	\N	\N	123211	123211	123212
25378	40007	2	applied	\N	\N	\N	\N	123213	123213	123214
25382	40008	0	applied	\N	\N	\N	\N	123219	123219	123220
25382	40009	1	applied	\N	\N	\N	\N	123221	123221	123222
25382	40010	2	applied	\N	\N	\N	\N	123223	123223	123224
25384	40011	0	applied	\N	\N	\N	\N	123227	123227	123228
25384	40012	1	applied	\N	\N	\N	\N	123229	123229	123230
25384	40013	2	applied	\N	\N	\N	\N	123231	123231	123232
25384	40014	3	applied	\N	\N	\N	\N	123233	123233	123234
25389	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25389	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25284	39835	1	applied	\N	\N	\N	\N	122684	122684	122685
25284	39836	2	applied	\N	\N	\N	\N	122686	122686	122687
25284	39837	3	applied	\N	\N	\N	\N	122688	122688	122689
25284	39838	4	applied	\N	\N	\N	\N	122690	122690	122691
25284	39839	5	applied	\N	\N	\N	\N	122692	122692	122693
25286	39840	0	applied	\N	\N	\N	\N	122698	122698	122699
25286	39841	1	applied	\N	\N	\N	\N	122700	122700	122701
25286	39842	2	applied	\N	\N	\N	\N	122702	122702	122703
25286	39843	3	applied	\N	\N	\N	\N	122704	122704	122705
25293	39853	0	applied	\N	\N	\N	\N	122771	122771	122772
25293	39854	1	applied	\N	\N	\N	\N	122773	122773	122774
25293	39855	2	applied	\N	\N	\N	\N	122775	122775	122776
25296	39626	0	applied	\N	\N	\N	\N	122027	122027	122028
25296	39702	1	applied	\N	\N	\N	\N	122263	122263	122264
25296	39534	2	applied	\N	\N	1000000000	\N	121744	121744	121745
25296	39548	3	applied	\N	\N	\N	\N	121797	121797	121798
25296	39556	4	applied	\N	\N	\N	\N	97875	97875	121843
25296	39661	5	applied	\N	\N	\N	\N	122144	122144	122144
25296	39608	6	applied	\N	\N	\N	\N	121961	121961	121962
25296	39619	7	applied	\N	\N	\N	\N	122001	122001	122002
25296	39620	8	applied	\N	\N	\N	\N	122003	122003	122004
25296	39623	9	applied	\N	\N	\N	\N	122014	122014	122015
25296	39561	10	applied	\N	\N	\N	\N	121828	121828	29193
25296	39636	11	applied	\N	\N	\N	\N	122051	122051	122052
25296	39682	12	applied	\N	\N	\N	\N	122197	122197	122198
25296	39705	13	applied	\N	\N	\N	\N	122269	122269	122270
25296	39683	14	applied	\N	\N	\N	\N	122199	122199	122200
25296	39687	15	applied	\N	\N	\N	\N	122208	122208	122209
25296	39546	16	applied	\N	\N	\N	\N	121779	121779	23829
25296	39710	17	applied	\N	\N	\N	\N	122281	122281	122282
25298	39863	0	applied	\N	\N	\N	\N	122799	122799	122800
25298	39864	1	applied	\N	\N	\N	\N	122801	122801	122802
25298	39865	2	applied	\N	\N	\N	\N	122805	122805	122806
25300	39866	0	applied	\N	\N	\N	\N	122809	122809	122810
25300	39867	1	applied	\N	\N	\N	\N	122811	122811	122812
25300	39868	2	applied	\N	\N	\N	\N	122813	122813	122814
25305	39879	0	applied	\N	\N	\N	\N	122841	122841	122842
25305	39880	1	applied	\N	\N	\N	\N	122843	122843	122844
25305	39881	2	applied	\N	\N	\N	\N	122845	122845	122846
25316	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25316	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25316	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25316	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25316	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25318	39889	0	applied	\N	\N	\N	\N	122873	122873	122874
25318	39890	1	applied	\N	\N	\N	\N	122875	122875	122876
25318	39887	2	applied	\N	\N	\N	\N	122864	122864	122877
25318	39888	3	applied	\N	\N	\N	\N	122866	122866	122878
25318	39891	4	applied	\N	\N	\N	\N	122879	122879	122880
25320	39892	0	applied	\N	\N	\N	\N	122893	122893	122894
25320	39893	1	applied	\N	\N	\N	\N	122895	122895	122896
25320	39894	2	applied	\N	\N	\N	\N	122897	122897	122898
25320	39895	3	applied	\N	\N	\N	\N	122899	122899	122900
25322	39892	0	applied	\N	\N	\N	\N	122893	122893	122894
25322	39894	1	applied	\N	\N	\N	\N	122897	122897	122904
25323	39896	0	applied	\N	\N	\N	\N	122906	122906	122907
25323	39897	1	applied	\N	\N	\N	\N	122908	122908	122909
25323	39898	2	applied	\N	\N	\N	\N	122910	122910	122911
25323	39899	3	applied	\N	\N	\N	\N	122912	122912	122913
25323	39900	4	applied	\N	\N	\N	\N	122914	122914	122915
25323	39901	5	applied	\N	\N	\N	\N	122916	122916	122917
25323	39902	6	applied	\N	\N	\N	\N	122918	122918	122919
25323	39903	7	applied	\N	\N	\N	\N	122920	122920	122921
25323	39904	8	applied	\N	\N	\N	\N	122922	122922	122923
25326	39915	0	applied	\N	\N	\N	\N	122950	122950	122951
25326	39916	1	applied	\N	\N	\N	\N	122952	122952	122953
25326	39917	2	applied	\N	\N	\N	\N	122954	122954	122955
25328	39918	0	applied	\N	\N	1000000000	\N	122958	122958	122959
25328	39919	1	applied	\N	\N	\N	\N	122960	122960	122961
25328	39920	2	applied	\N	\N	\N	\N	122962	122962	122963
25328	39921	3	applied	\N	\N	\N	\N	122964	122964	122965
25335	39925	0	applied	\N	\N	\N	\N	122981	122981	122982
25335	39929	1	applied	\N	\N	\N	\N	122991	122991	122992
25335	39930	2	applied	\N	\N	\N	\N	122993	122993	122994
25335	39926	3	applied	\N	\N	\N	\N	122983	122983	122984
25335	39927	4	applied	\N	\N	\N	\N	122985	122985	122986
25335	39931	5	applied	\N	\N	\N	\N	122996	122996	122997
25335	39932	6	applied	\N	\N	\N	\N	122998	122998	122999
25335	39928	7	applied	\N	\N	\N	\N	122987	122987	123000
25337	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25337	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25337	39935	2	applied	\N	\N	\N	\N	123007	123007	123008
25340	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25340	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25340	39935	2	applied	\N	\N	\N	\N	123007	123007	123008
25342	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25342	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25342	39935	2	applied	\N	\N	\N	\N	123007	123007	123008
25343	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25343	39934	1	applied	\N	\N	\N	\N	123005	123005	123017
25343	39931	2	applied	\N	\N	\N	\N	122996	122996	123018
25343	39932	3	applied	\N	\N	\N	\N	122998	122998	123006
25343	39935	4	applied	\N	\N	\N	\N	123007	123007	123008
25346	39945	0	applied	\N	\N	\N	\N	123040	123040	123041
25346	39944	1	applied	\N	\N	\N	\N	123037	123037	123038
25346	39946	2	applied	\N	\N	\N	\N	123042	123042	123043
25351	39925	0	applied	\N	\N	\N	\N	122981	122981	122982
25355	39959	0	applied	\N	\N	\N	\N	123079	123079	123080
25355	39960	1	applied	\N	\N	\N	\N	123081	123081	123082
25355	39961	2	applied	\N	\N	\N	\N	123083	123083	123084
25359	39962	0	applied	\N	\N	\N	\N	123090	123090	123091
25359	39963	1	applied	\N	\N	\N	\N	123092	123092	123093
25359	39964	2	applied	\N	\N	\N	\N	123094	123094	123095
25359	39965	3	applied	\N	\N	\N	\N	123096	123096	123097
25360	39966	0	applied	\N	\N	\N	\N	123100	123100	123101
25360	39967	1	applied	\N	\N	\N	\N	123102	123102	123103
25360	39968	2	applied	\N	\N	\N	\N	123104	123104	123105
25360	39969	3	applied	\N	\N	\N	\N	123106	123106	123107
25360	39970	4	applied	\N	\N	\N	\N	123108	123108	123109
25360	39971	5	applied	\N	\N	\N	\N	123110	123110	123111
25360	39972	6	applied	\N	\N	\N	\N	123112	123112	123113
25360	39973	7	applied	\N	\N	\N	\N	123114	123114	123115
25360	39974	8	applied	\N	\N	\N	\N	123116	123116	123117
25360	39975	9	applied	\N	\N	\N	\N	123118	123118	123119
25362	39976	0	applied	\N	\N	\N	\N	123122	123122	123123
25362	39977	1	applied	\N	\N	\N	\N	123124	123124	123125
25362	39978	2	applied	\N	\N	\N	\N	123126	123126	123127
25362	39979	4	applied	\N	\N	\N	\N	123129	123129	123130
25369	39990	0	applied	\N	\N	\N	\N	123166	123166	123167
25291	39771	62	applied	\N	\N	\N	\N	122473	122473	122737
25291	39774	63	applied	\N	\N	\N	\N	122481	122481	122583
25291	39777	64	applied	\N	\N	\N	\N	122487	122487	122585
25291	39780	65	applied	\N	\N	\N	\N	122503	122503	122587
25291	39792	66	applied	\N	\N	\N	\N	122529	122529	122375
25291	39793	67	applied	\N	\N	\N	\N	122531	122531	122588
25291	39794	68	applied	\N	\N	\N	\N	122533	122533	122589
25291	39795	69	applied	\N	\N	\N	\N	122535	122535	122590
25291	39796	70	applied	\N	\N	\N	\N	122537	122537	122398
25291	39800	71	applied	\N	\N	\N	\N	122549	122549	122400
25291	39802	72	applied	\N	\N	\N	\N	122553	122553	122408
25291	39807	73	applied	\N	\N	\N	\N	122564	122564	122410
25291	39809	74	applied	\N	\N	\N	\N	122568	122568	122414
25291	39812	75	applied	\N	\N	\N	\N	122621	122621	122591
25291	39815	76	applied	\N	\N	\N	\N	122629	122629	122592
25291	39819	77	applied	\N	\N	\N	\N	122639	122639	122593
25291	39823	78	applied	\N	\N	\N	\N	122649	122649	122594
25291	39824	79	applied	\N	\N	\N	\N	122651	122651	122595
25291	39829	80	applied	\N	\N	\N	\N	122667	122667	122596
25291	39833	81	applied	\N	\N	\N	\N	122678	122678	122444
25291	39836	82	applied	\N	\N	\N	\N	122686	122686	122454
25291	39839	83	applied	\N	\N	\N	\N	122692	122692	122597
25291	39843	84	applied	\N	\N	\N	\N	122704	122704	122598
25291	39846	85	applied	\N	\N	\N	\N	122711	122711	122599
25291	39848	86	applied	\N	\N	\N	\N	122719	122719	122472
25291	39629	87	applied	\N	\N	\N	\N	122033	122033	122738
25291	39632	88	applied	\N	\N	\N	\N	122043	122043	122739
25291	39635	89	applied	\N	\N	\N	\N	122049	122049	122600
25291	39640	90	applied	\N	\N	\N	\N	122061	122061	122482
25291	39643	91	applied	\N	\N	\N	\N	122099	122099	122486
25291	39646	92	applied	\N	\N	\N	\N	122105	122105	122602
25291	39649	93	applied	\N	\N	\N	\N	122116	122116	122490
25291	39656	94	applied	\N	\N	\N	\N	122132	122132	122740
25291	39657	95	applied	\N	\N	\N	\N	122134	122134	122518
25291	39660	96	applied	\N	\N	\N	\N	122142	122142	122520
25291	39664	97	applied	\N	\N	\N	\N	122149	122149	122741
25291	39666	98	applied	\N	\N	\N	\N	122154	122154	122742
25291	39671	99	applied	\N	\N	\N	\N	122170	122170	122743
25291	39673	100	applied	\N	\N	\N	\N	122176	122176	122744
25291	39677	101	applied	\N	\N	\N	\N	122186	122186	122530
25291	39681	102	applied	\N	\N	\N	\N	122195	122195	122745
25291	39685	103	applied	\N	\N	\N	\N	122204	122204	122746
25291	39689	104	applied	\N	\N	\N	\N	122215	122215	122534
25291	39693	106	applied	\N	\N	\N	\N	122225	122225	122748
25291	39697	107	applied	\N	\N	\N	\N	122236	122236	122749
25291	39699	108	applied	\N	\N	\N	\N	122246	122246	122538
25291	39704	109	applied	\N	\N	\N	\N	122267	122267	122540
25291	39707	110	applied	\N	\N	\N	\N	122275	122275	122750
25291	39713	111	applied	\N	\N	\N	\N	122295	122295	122751
25291	39714	112	applied	\N	\N	\N	\N	122297	122297	122752
25291	39722	113	applied	\N	\N	\N	\N	122315	122315	122554
25291	39725	114	applied	\N	\N	\N	\N	122322	122322	122556
25291	39731	115	applied	\N	\N	\N	\N	122372	122372	122753
25291	39732	116	applied	\N	\N	\N	\N	122374	122374	122565
25291	39734	117	applied	\N	\N	\N	\N	122385	122385	122567
25291	39739	118	applied	\N	\N	\N	\N	122395	122395	122754
25291	39740	119	applied	\N	\N	\N	\N	122397	122397	122755
25291	39747	120	applied	\N	\N	\N	\N	122413	122413	122756
25291	39748	121	applied	\N	\N	\N	\N	122415	122415	122622
25291	39750	122	applied	\N	\N	\N	\N	122421	122421	122624
25291	39759	123	applied	\N	\N	\N	\N	122441	122441	122757
25291	39760	124	applied	\N	\N	\N	\N	122443	122443	122758
25291	39761	125	applied	\N	\N	\N	\N	122445	122445	122759
25294	39856	0	applied	\N	\N	\N	\N	122779	122779	122780
25294	39857	1	applied	\N	\N	\N	\N	122781	122781	122782
25294	39858	2	applied	\N	\N	\N	\N	122783	122783	122784
25301	39869	0	applied	\N	\N	\N	\N	122816	122816	122817
25301	39870	1	applied	\N	\N	\N	\N	122818	122818	122819
25301	39871	2	applied	\N	\N	\N	\N	122820	122820	122821
25303	39872	0	applied	\N	\N	\N	\N	122826	122826	122827
25303	39873	1	applied	\N	\N	\N	\N	122828	122828	122829
25303	39874	2	applied	\N	\N	\N	\N	122830	122830	122831
25303	39875	3	applied	\N	\N	\N	\N	122832	122832	122833
25308	39884	0	applied	\N	\N	\N	\N	122854	122854	122855
25308	39885	1	applied	\N	\N	\N	\N	122856	122856	122857
25308	39886	2	applied	\N	\N	\N	\N	122858	122858	122859
25310	39884	0	applied	\N	\N	\N	\N	122854	122854	122855
25310	39885	1	applied	\N	\N	\N	\N	122856	122856	122857
25310	39886	2	applied	\N	\N	\N	\N	122858	122858	122859
25310	39887	4	applied	\N	\N	\N	\N	122864	122864	122865
25310	39888	5	applied	\N	\N	\N	\N	122866	122866	122867
25324	39905	0	applied	\N	\N	\N	\N	122926	122926	122927
25324	39906	1	applied	\N	\N	\N	\N	122928	122928	122929
25324	39907	2	applied	\N	\N	\N	\N	122930	122930	122931
25324	39908	3	applied	\N	\N	\N	\N	122932	122932	122933
25324	39909	4	applied	\N	\N	\N	\N	122934	122934	122935
25324	39910	5	applied	\N	\N	\N	\N	122936	122936	122937
25324	39911	6	applied	\N	\N	\N	\N	122938	122938	122939
25324	39912	7	applied	\N	\N	\N	\N	122940	122940	122941
25324	39913	8	applied	\N	\N	\N	\N	122942	122942	122943
25324	39914	9	applied	\N	\N	\N	\N	122944	122944	122945
25331	39922	0	applied	\N	\N	\N	\N	122971	122971	122972
25331	39923	1	applied	\N	\N	\N	\N	122973	122973	122974
25331	39924	2	applied	\N	\N	\N	\N	122975	122975	122976
25333	39925	0	applied	\N	\N	\N	\N	122981	122981	122982
25333	39926	1	applied	\N	\N	\N	\N	122983	122983	122984
25333	39927	2	applied	\N	\N	\N	\N	122985	122985	122986
25333	39928	3	applied	\N	\N	\N	\N	122987	122987	122988
25338	39933	0	applied	\N	\N	\N	\N	123003	123003	123004
25338	39934	1	applied	\N	\N	\N	\N	123005	123005	123006
25338	39935	2	applied	\N	\N	\N	\N	123007	123007	123008
25344	39936	0	applied	\N	\N	\N	\N	123020	123020	123021
25344	39937	1	applied	\N	\N	\N	\N	123022	123022	123023
25344	39938	2	applied	\N	\N	\N	\N	123024	123024	123025
25344	39939	3	applied	\N	\N	\N	\N	123026	123026	123027
25344	39940	4	applied	\N	\N	\N	\N	123028	123028	123029
25344	39941	5	applied	\N	\N	\N	\N	123030	123030	123031
25344	39942	6	applied	\N	\N	\N	\N	123032	123032	123033
25344	39943	7	applied	\N	\N	\N	\N	123034	123034	123035
25349	39951	0	applied	\N	\N	\N	\N	123054	123054	123055
25349	39952	1	applied	\N	\N	\N	\N	123056	123056	123057
25349	39953	2	applied	\N	\N	\N	\N	123058	123058	123059
25349	39954	3	applied	\N	\N	\N	\N	123060	123060	123061
25353	39951	0	applied	\N	\N	\N	\N	123054	123054	123055
25353	39952	1	applied	\N	\N	\N	\N	123056	123056	123057
25353	39953	2	applied	\N	\N	\N	\N	123058	123058	123059
25353	39954	3	applied	\N	\N	\N	\N	123060	123060	123061
25356	39959	0	applied	\N	\N	\N	\N	123079	123079	123080
25356	39961	1	applied	\N	\N	\N	\N	123083	123083	123086
25363	39980	0	applied	\N	\N	\N	\N	123134	123134	123135
25350	39951	0	applied	\N	\N	\N	\N	123054	123054	123055
25350	39952	1	applied	\N	\N	\N	\N	123056	123056	123057
25350	39953	2	applied	\N	\N	\N	\N	123058	123058	123059
25350	39954	3	applied	\N	\N	\N	\N	123060	123060	123061
25357	39959	0	applied	\N	\N	\N	\N	123079	123079	123080
25357	39960	1	applied	\N	\N	\N	\N	123081	123081	123082
25357	39961	2	applied	\N	\N	\N	\N	123083	123083	123084
25358	39959	0	applied	\N	\N	\N	\N	123079	123079	123080
25358	39960	1	applied	\N	\N	\N	\N	123081	123081	123082
25358	39961	2	applied	\N	\N	\N	\N	123083	123083	123084
25361	39976	0	applied	\N	\N	\N	\N	123122	123122	123123
25361	39977	1	applied	\N	\N	\N	\N	123124	123124	123125
25361	39978	2	applied	\N	\N	\N	\N	123126	123126	123127
25361	39979	4	applied	\N	\N	\N	\N	123129	123129	123130
25367	39988	0	applied	\N	\N	\N	\N	123156	123156	123157
25367	39986	1	applied	\N	\N	\N	\N	123150	123150	123151
25367	39989	2	applied	\N	\N	\N	\N	123158	123158	123159
25367	39987	3	applied	\N	\N	\N	\N	123152	123152	123160
25368	39988	0	applied	\N	\N	\N	\N	123156	123156	123157
25368	39986	1	applied	\N	\N	\N	\N	123150	123150	123151
25368	39989	2	applied	\N	\N	\N	\N	123158	123158	123159
25368	39987	3	applied	\N	\N	\N	\N	123152	123152	123160
25375	39918	0	applied	\N	\N	1000000000	\N	122958	122958	122959
25375	39925	1	applied	\N	\N	\N	\N	122981	122981	122982
25375	39936	2	applied	\N	\N	\N	\N	123020	123020	123021
25375	39947	3	applied	\N	\N	\N	\N	123044	123044	123045
25375	39955	4	applied	\N	\N	\N	\N	123069	123069	123070
25375	39962	5	applied	\N	\N	\N	\N	123090	123090	123091
25375	39990	6	applied	\N	\N	\N	\N	123166	123166	123167
25375	40000	7	applied	\N	\N	\N	\N	123195	123195	123196
25375	39849	8	applied	\N	\N	\N	\N	122762	122762	122763
25375	39853	9	applied	\N	\N	\N	\N	122771	122771	122772
25375	39856	10	applied	\N	\N	\N	\N	122779	122779	122780
25375	39859	11	applied	\N	\N	\N	\N	122787	122787	122788
25375	39863	12	applied	\N	\N	\N	\N	122799	122799	122800
25380	40005	0	applied	\N	\N	\N	\N	123209	123209	123210
25380	40006	1	applied	\N	\N	\N	\N	123211	123211	123212
25380	40007	2	applied	\N	\N	\N	\N	123213	123213	123214
25387	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25387	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25387	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25392	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25392	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25392	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25399	40028	0	applied	\N	\N	\N	\N	123278	123278	123279
25399	40029	1	applied	\N	\N	\N	\N	123280	123280	123281
25399	40030	2	applied	\N	\N	\N	\N	123282	123282	123283
25399	40031	3	applied	\N	\N	1000000000	\N	123284	123284	123285
25399	40032	4	applied	\N	\N	1000000000	\N	123286	123286	123287
25399	40033	5	applied	\N	\N	\N	\N	123288	123288	123289
25401	40028	0	applied	\N	\N	\N	\N	123278	123278	123279
25401	40029	1	applied	\N	\N	\N	\N	123280	123280	123281
25401	40034	2	applied	\N	\N	\N	\N	123292	123292	123293
25401	40030	3	applied	\N	\N	\N	\N	123282	123282	123294
25401	40031	4	applied	\N	\N	1000000000	\N	123284	123284	123285
25401	40032	5	applied	\N	\N	1000000000	\N	123286	123286	123287
25401	40033	6	applied	\N	\N	\N	\N	123288	123288	123295
25401	40035	7	applied	\N	\N	\N	\N	123296	123296	123297
25406	40041	0	applied	\N	\N	\N	\N	123316	123316	123317
25406	40042	1	applied	\N	\N	\N	\N	123318	123318	123319
25406	40043	2	applied	\N	\N	\N	\N	123320	123320	123321
25406	40044	3	applied	\N	\N	\N	\N	123322	123322	123323
25406	40045	4	applied	\N	\N	\N	\N	123324	123324	123325
25406	40046	5	applied	\N	\N	\N	\N	123326	123326	123327
25406	40047	6	applied	\N	\N	\N	\N	123328	123328	123329
25406	40048	7	applied	\N	\N	\N	\N	123330	123330	123331
25406	40049	8	applied	\N	\N	\N	\N	123332	123332	123333
25406	40050	9	applied	\N	\N	\N	\N	123334	123334	123335
25406	40051	10	applied	\N	\N	\N	\N	123336	123336	123337
25409	40058	0	applied	\N	\N	\N	\N	123356	123356	123357
25409	40059	1	applied	\N	\N	\N	\N	123358	123358	123359
25409	40060	2	applied	\N	\N	\N	\N	123360	123360	123361
25409	40061	3	applied	\N	\N	\N	\N	123362	123362	123363
25412	40058	0	applied	\N	\N	\N	\N	123356	123356	123357
25412	40059	1	applied	\N	\N	\N	\N	123358	123358	123359
25412	40060	2	applied	\N	\N	\N	\N	123360	123360	123361
25412	40061	3	applied	\N	\N	\N	\N	123362	123362	123363
25413	40062	0	applied	\N	\N	\N	\N	123369	123369	123370
25422	40071	0	applied	\N	\N	\N	\N	123403	123403	123404
25422	40072	1	applied	\N	\N	\N	\N	123405	123405	123406
25422	40073	2	applied	\N	\N	\N	\N	123407	123407	123408
25422	40074	3	applied	\N	\N	\N	\N	123409	123409	123410
25424	40075	0	applied	\N	\N	\N	\N	123412	123412	123413
25424	40077	1	applied	\N	\N	\N	\N	123418	123418	123419
25424	40076	2	applied	\N	\N	\N	\N	123414	123414	123420
25427	40087	0	applied	\N	\N	\N	\N	123441	123441	123445
25429	40081	0	applied	\N	\N	\N	\N	123429	123429	123430
25429	40082	1	applied	\N	\N	\N	\N	123431	123431	123432
25429	40083	2	applied	\N	\N	\N	\N	123433	123433	123434
25429	40084	3	applied	\N	\N	\N	\N	123435	123435	123436
25429	40085	4	applied	\N	\N	\N	\N	123437	123437	123438
25429	40086	5	applied	\N	\N	\N	\N	123439	123439	123440
25429	40087	6	applied	\N	\N	\N	\N	123441	123441	123442
25431	40078	0	applied	\N	\N	\N	\N	123421	123421	123422
25431	40081	1	applied	\N	\N	\N	\N	123429	123429	123430
25431	40082	2	applied	\N	\N	\N	\N	123431	123431	123432
25431	40080	3	applied	\N	\N	\N	\N	123425	123425	123452
25431	40085	4	applied	\N	\N	\N	\N	123437	123437	123445
25431	40086	5	applied	\N	\N	\N	\N	123439	123439	123436
25431	40087	6	applied	\N	\N	\N	\N	123441	123441	123453
25438	40098	0	applied	\N	\N	\N	\N	123485	123485	123486
25438	40099	1	applied	\N	\N	\N	\N	123487	123487	123488
25438	40100	2	applied	\N	\N	\N	\N	123489	123489	123490
25440	40098	0	applied	\N	\N	\N	\N	123485	123485	123486
25440	40099	1	applied	\N	\N	\N	\N	123487	123487	123488
25440	40100	2	applied	\N	\N	\N	\N	123489	123489	123490
25444	40101	0	applied	\N	\N	\N	\N	123496	123496	123497
25444	40102	1	applied	\N	\N	\N	\N	123498	123498	123499
25447	40104	0	applied	\N	\N	\N	\N	123504	123504	123505
25447	40105	1	applied	\N	\N	\N	\N	123506	123506	123507
25447	40106	2	applied	\N	\N	\N	\N	123508	123508	123509
25447	40103	3	applied	\N	\N	\N	\N	123500	123500	123510
25447	40107	4	applied	\N	\N	\N	\N	123511	123511	123512
25451	40115	0	applied	\N	\N	\N	\N	123532	123532	123533
25451	40116	1	applied	\N	\N	\N	\N	123534	123534	123535
25451	40118	2	applied	\N	\N	\N	\N	123540	123540	123541
25451	40117	3	applied	\N	\N	\N	\N	123536	123536	123542
25454	40119	0	applied	\N	\N	\N	\N	123544	123544	123545
25454	40120	1	applied	\N	\N	\N	\N	123546	123546	123547
25363	39981	1	applied	\N	\N	\N	\N	123136	123136	123137
25363	39982	2	applied	\N	\N	\N	\N	123138	123138	123139
25363	39983	3	applied	\N	\N	\N	\N	123140	123140	123141
25363	39984	4	applied	\N	\N	\N	\N	123142	123142	123143
25363	39985	5	applied	\N	\N	\N	\N	123144	123144	123145
25365	39986	0	applied	\N	\N	\N	\N	123150	123150	123151
25365	39987	1	applied	\N	\N	\N	\N	123152	123152	123153
25366	39988	0	applied	\N	\N	\N	\N	123156	123156	123157
25366	39986	1	applied	\N	\N	\N	\N	123150	123150	123151
25366	39989	2	applied	\N	\N	\N	\N	123158	123158	123159
25366	39987	3	applied	\N	\N	\N	\N	123152	123152	123160
25370	39994	0	applied	\N	\N	\N	\N	123176	123176	123177
25370	39995	1	applied	\N	\N	\N	\N	123178	123178	123179
25370	39996	2	applied	\N	\N	\N	\N	123180	123180	123181
25372	39997	0	applied	\N	\N	\N	\N	123186	123186	123187
25372	39998	1	applied	\N	\N	\N	\N	123188	123188	123189
25372	39999	2	applied	\N	\N	\N	\N	123190	123190	123191
25377	40005	0	applied	\N	\N	\N	\N	123209	123209	123210
25377	40007	1	applied	\N	\N	\N	\N	123213	123213	123216
25379	40005	0	applied	\N	\N	\N	\N	123209	123209	123210
25379	40006	1	applied	\N	\N	\N	\N	123211	123211	123212
25379	40007	2	applied	\N	\N	\N	\N	123213	123213	123214
25381	40008	0	applied	\N	\N	\N	\N	123219	123219	123220
25381	40009	1	applied	\N	\N	\N	\N	123221	123221	123222
25381	40010	2	applied	\N	\N	\N	\N	123223	123223	123224
25383	40008	0	applied	\N	\N	\N	\N	123219	123219	123220
25383	40009	1	applied	\N	\N	\N	\N	123221	123221	123222
25383	40010	2	applied	\N	\N	\N	\N	123223	123223	123224
25386	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25386	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25386	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25388	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25388	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25388	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25394	40021	0	applied	\N	\N	\N	\N	123257	123257	123258
25394	40022	1	applied	\N	\N	\N	\N	123259	123259	123260
25394	40018	2	applied	\N	\N	\N	\N	123250	123250	123251
25394	40023	3	applied	\N	\N	\N	\N	123261	123261	123262
25394	40024	4	applied	\N	\N	\N	\N	123263	123263	123264
25394	40019	5	applied	\N	\N	\N	\N	123252	123252	123265
25394	40020	6	applied	\N	\N	\N	\N	123254	123254	123266
25396	40021	0	applied	\N	\N	\N	\N	123257	123257	123258
25396	40022	1	applied	\N	\N	\N	\N	123259	123259	123260
25396	40025	2	applied	\N	\N	\N	\N	123269	123269	123270
25396	40023	3	applied	\N	\N	\N	\N	123261	123261	123271
25396	40024	4	applied	\N	\N	\N	\N	123263	123263	123266
25396	40026	5	applied	\N	\N	\N	\N	123272	123272	123273
25396	40027	6	applied	\N	\N	\N	\N	123274	123274	123275
25398	40025	0	applied	\N	\N	\N	\N	123269	123269	123270
25398	40026	1	applied	\N	\N	\N	\N	123272	123272	123273
25398	40027	2	applied	\N	\N	\N	\N	123274	123274	123275
25403	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25403	40037	1	applied	\N	\N	\N	\N	123302	123302	123303
25403	40034	2	applied	\N	\N	\N	\N	123292	123292	123295
25403	40038	3	applied	\N	\N	\N	\N	123304	123304	123305
25403	40039	4	applied	\N	\N	\N	\N	123306	123306	123307
25403	40035	5	applied	\N	\N	\N	\N	123296	123296	123308
25403	40040	6	applied	\N	\N	\N	\N	123309	123309	123310
25405	39918	0	applied	\N	\N	1000000000	\N	122958	122958	122959
25405	39925	1	applied	\N	\N	\N	\N	122981	122981	122982
25405	39936	2	applied	\N	\N	\N	\N	123020	123020	123021
25405	39947	3	applied	\N	\N	\N	\N	123044	123044	123045
25405	39955	4	applied	\N	\N	\N	\N	123069	123069	123070
25405	39962	5	applied	\N	\N	\N	\N	123090	123090	123091
25405	39990	6	applied	\N	\N	\N	\N	123166	123166	123167
25405	40000	7	applied	\N	\N	\N	\N	123195	123195	123196
25405	40036	8	applied	\N	\N	\N	\N	123300	123300	123301
25405	40031	9	applied	\N	\N	1000000000	\N	123284	123284	123285
25405	40032	10	applied	\N	\N	1000000000	\N	123286	123286	123287
25408	40055	0	applied	\N	\N	\N	\N	123348	123348	123349
25408	40056	1	applied	\N	\N	\N	\N	123350	123350	123351
25408	40057	2	applied	\N	\N	\N	\N	123352	123352	123353
25411	40058	0	applied	\N	\N	\N	\N	123356	123356	123357
25411	40059	1	applied	\N	\N	\N	\N	123358	123358	123359
25411	40060	2	applied	\N	\N	\N	\N	123360	123360	123361
25411	40061	3	applied	\N	\N	\N	\N	123362	123362	123363
25415	40062	0	applied	\N	\N	\N	\N	123369	123369	123370
25417	40063	0	applied	\N	\N	\N	\N	123372	123372	123373
25417	40065	1	applied	\N	\N	\N	\N	123378	123378	123379
25417	40066	2	applied	\N	\N	\N	\N	123380	123380	123381
25417	40064	4	applied	\N	\N	\N	\N	123374	123374	123384
25417	40067	5	applied	\N	\N	\N	\N	123385	123385	123386
25419	40068	0	applied	\N	\N	\N	\N	123388	123388	123389
25419	40069	1	applied	\N	\N	\N	\N	123390	123390	123391
25419	40064	2	applied	\N	\N	\N	\N	123374	123374	123392
25419	40067	3	applied	\N	\N	\N	\N	123385	123385	123393
25419	40070	4	applied	\N	\N	\N	\N	123394	123394	123395
25421	40068	0	applied	\N	\N	\N	\N	123388	123388	123389
25421	40069	1	applied	\N	\N	\N	\N	123390	123390	123391
25421	40064	2	applied	\N	\N	\N	\N	123374	123374	123392
25426	40078	0	applied	\N	\N	\N	\N	123421	123421	123422
25426	40081	1	applied	\N	\N	\N	\N	123429	123429	123430
25426	40082	2	applied	\N	\N	\N	\N	123431	123431	123432
25426	40079	3	applied	\N	\N	\N	\N	123423	123423	123424
25426	40080	4	applied	\N	\N	\N	\N	123425	123425	123426
25426	40083	5	applied	\N	\N	\N	\N	123433	123433	123434
25426	40084	6	applied	\N	\N	\N	\N	123435	123435	123436
25426	40085	7	applied	\N	\N	\N	\N	123437	123437	123438
25426	40086	8	applied	\N	\N	\N	\N	123439	123439	123440
25426	40087	9	applied	\N	\N	\N	\N	123441	123441	123442
25433	40091	0	applied	\N	\N	\N	\N	123463	123463	123464
25433	40092	1	applied	\N	\N	\N	\N	123465	123465	123466
25433	40093	2	applied	\N	\N	\N	\N	123467	123467	123468
25433	40094	3	applied	\N	\N	\N	\N	123469	123469	123470
25436	40095	0	applied	\N	\N	\N	\N	123473	123473	123474
25436	40096	1	applied	\N	\N	\N	\N	123475	123475	123476
25436	40097	2	applied	\N	\N	\N	\N	123477	123477	123478
25442	40098	0	applied	\N	\N	\N	\N	123485	123485	123486
25442	40099	1	applied	\N	\N	\N	\N	123487	123487	123488
25442	40100	2	applied	\N	\N	\N	\N	123489	123489	123490
25446	40104	0	applied	\N	\N	\N	\N	123504	123504	123505
25446	40105	1	applied	\N	\N	\N	\N	123506	123506	123507
25446	40106	2	applied	\N	\N	\N	\N	123508	123508	123509
25446	40103	3	applied	\N	\N	\N	\N	123500	123500	123510
25446	40107	4	applied	\N	\N	\N	\N	123511	123511	123512
25455	40119	0	applied	\N	\N	\N	\N	123544	123544	123545
25455	40121	1	applied	\N	\N	\N	\N	123548	123548	123554
25457	40122	0	applied	\N	\N	\N	\N	123556	123556	111296
25457	40123	1	applied	\N	\N	\N	\N	123557	123557	123558
25369	39991	1	applied	\N	\N	\N	\N	123168	123168	123169
25369	39992	2	applied	\N	\N	\N	\N	123170	123170	123171
25369	39993	3	applied	\N	\N	\N	\N	123172	123172	123173
25374	40000	0	applied	\N	\N	\N	\N	123195	123195	123196
25374	40001	1	applied	\N	\N	\N	\N	123197	123197	123198
25374	40002	2	applied	\N	\N	\N	\N	123199	123199	123200
25374	40003	3	applied	\N	\N	\N	\N	123201	123201	123202
25374	40004	4	applied	\N	\N	\N	\N	123203	123203	123204
25376	40005	0	applied	\N	\N	\N	\N	123209	123209	123210
25376	40006	1	applied	\N	\N	\N	\N	123211	123211	123212
25376	40007	2	applied	\N	\N	\N	\N	123213	123213	123214
25390	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25390	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25390	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25391	40015	0	applied	\N	\N	\N	\N	123237	123237	123238
25391	40016	1	applied	\N	\N	\N	\N	123239	123239	123240
25391	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25393	40018	0	applied	\N	\N	\N	\N	123250	123250	123251
25393	40019	1	applied	\N	\N	\N	\N	123252	123252	123253
25393	40020	2	applied	\N	\N	\N	\N	123254	123254	123255
25400	40028	0	applied	\N	\N	\N	\N	123278	123278	123279
25400	40029	1	applied	\N	\N	\N	\N	123280	123280	123281
25400	40034	2	applied	\N	\N	\N	\N	123292	123292	123293
25400	40030	3	applied	\N	\N	\N	\N	123282	123282	123294
25400	40031	4	applied	\N	\N	1000000000	\N	123284	123284	123285
25400	40032	5	applied	\N	\N	1000000000	\N	123286	123286	123287
25400	40033	6	applied	\N	\N	\N	\N	123288	123288	123295
25400	40035	7	applied	\N	\N	\N	\N	123296	123296	123297
25423	40075	0	applied	\N	\N	\N	\N	123412	123412	123413
25423	40076	1	applied	\N	\N	\N	\N	123414	123414	123415
25428	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25428	40041	1	applied	\N	\N	\N	\N	123316	123316	123317
25428	40031	2	applied	\N	\N	1000000000	\N	123284	123284	123285
25428	40032	3	applied	\N	\N	1000000000	\N	123286	123286	123287
25430	40081	0	applied	\N	\N	\N	\N	123429	123429	123430
25430	40082	1	applied	\N	\N	\N	\N	123431	123431	123432
25430	40083	2	applied	\N	\N	\N	\N	123433	123433	123434
25430	40084	3	applied	\N	\N	\N	\N	123435	123435	123436
25430	40085	4	applied	\N	\N	\N	\N	123437	123437	123438
25430	40086	5	applied	\N	\N	\N	\N	123439	123439	123440
25430	40087	6	applied	\N	\N	\N	\N	123441	123441	123442
25432	40088	0	applied	\N	\N	\N	\N	123455	123455	123456
25432	40089	1	applied	\N	\N	\N	\N	123457	123457	123458
25432	40090	2	applied	\N	\N	\N	\N	123459	123459	123460
25435	40095	0	applied	\N	\N	\N	\N	123473	123473	123474
25435	40096	1	applied	\N	\N	\N	\N	123475	123475	123476
25435	40097	2	applied	\N	\N	\N	\N	123477	123477	123478
25439	40098	0	applied	\N	\N	\N	\N	123485	123485	123486
25439	40099	1	applied	\N	\N	\N	\N	123487	123487	123488
25439	40100	2	applied	\N	\N	\N	\N	123489	123489	123490
25441	40098	0	applied	\N	\N	\N	\N	123485	123485	123486
25441	40099	1	applied	\N	\N	\N	\N	123487	123487	123488
25441	40100	2	applied	\N	\N	\N	\N	123489	123489	123490
25443	40101	0	applied	\N	\N	\N	\N	123496	123496	123497
25443	40102	1	applied	\N	\N	\N	\N	123498	123498	123499
25443	40103	2	applied	\N	\N	\N	\N	123500	123500	123501
25448	40104	0	applied	\N	\N	\N	\N	123504	123504	123505
25448	40105	1	applied	\N	\N	\N	\N	123506	123506	123507
25448	40106	2	applied	\N	\N	\N	\N	123508	123508	123509
25448	40103	3	applied	\N	\N	\N	\N	123500	123500	123510
25448	40107	4	applied	\N	\N	\N	\N	123511	123511	123512
25450	40115	0	applied	\N	\N	\N	\N	123532	123532	123533
25450	40116	1	applied	\N	\N	\N	\N	123534	123534	123535
25450	40117	2	applied	\N	\N	\N	\N	123536	123536	123537
25453	40119	0	applied	\N	\N	\N	\N	123544	123544	123545
25453	40120	1	applied	\N	\N	\N	\N	123546	123546	123547
25453	40121	2	applied	\N	\N	\N	\N	123548	123548	123549
25461	40126	0	applied	\N	\N	\N	\N	123568	123568	123569
25461	40127	1	applied	\N	\N	\N	\N	123570	123570	123571
25461	40128	2	applied	\N	\N	\N	\N	123572	123572	123573
25461	40129	3	applied	\N	\N	\N	\N	123574	123574	123575
25466	40139	0	applied	\N	\N	\N	\N	123599	123599	123600
25466	40140	1	applied	\N	\N	\N	\N	123601	123601	123602
25466	40141	2	applied	\N	\N	\N	\N	123603	123603	123604
25466	40142	3	applied	\N	\N	\N	\N	123605	123605	123606
25475	40149	0	applied	\N	\N	\N	\N	123628	123628	123629
25475	40150	2	applied	\N	\N	\N	\N	123631	123631	123632
25475	40151	3	applied	\N	\N	\N	\N	123633	123633	123634
25475	40152	4	applied	\N	\N	\N	\N	123635	123635	123636
25479	40156	0	applied	\N	\N	\N	\N	123656	123656	123657
25479	40157	1	applied	\N	\N	\N	\N	123658	123658	123659
25479	40158	2	applied	\N	\N	\N	\N	123660	123660	123661
25481	40159	0	applied	\N	\N	\N	\N	123664	123664	123665
25481	40160	1	applied	\N	\N	\N	\N	123666	123666	123667
25481	40161	2	applied	\N	\N	\N	\N	123668	123668	123669
25482	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25486	40165	0	applied	\N	\N	\N	\N	123680	123680	123681
25486	40166	1	applied	\N	\N	\N	\N	123682	123682	123683
25486	40167	2	applied	\N	\N	\N	\N	123684	123684	123685
25488	40168	0	applied	\N	\N	\N	\N	123690	123690	123691
25488	40169	1	applied	\N	\N	\N	\N	123692	123692	123693
25488	40170	2	applied	\N	\N	\N	\N	123694	123694	123695
25493	40174	0	applied	\N	\N	\N	\N	123706	123706	123707
25493	40175	1	applied	\N	\N	\N	\N	123708	123708	123709
25493	40176	2	applied	\N	\N	\N	\N	123710	123710	123711
25493	40177	3	applied	\N	\N	\N	\N	123712	123712	123713
25493	40178	4	applied	\N	\N	\N	\N	123714	123714	123715
25493	40179	5	applied	\N	\N	\N	\N	123716	123716	123717
25495	40180	0	applied	\N	\N	\N	\N	123723	123723	123724
25495	40181	1	applied	\N	\N	\N	\N	123725	123725	123726
25495	40182	2	applied	\N	\N	\N	\N	123727	123727	123728
25498	40180	0	applied	\N	\N	\N	\N	123723	123723	123724
25498	40181	1	applied	\N	\N	\N	\N	123725	123725	123726
25498	40182	2	applied	\N	\N	\N	\N	123727	123727	123728
25502	40189	0	applied	\N	\N	\N	\N	123753	123753	123754
25502	40190	1	applied	\N	\N	\N	\N	123755	123755	123756
25502	40191	2	applied	\N	\N	\N	\N	123757	123757	123758
25504	40192	0	applied	\N	\N	\N	\N	123761	123761	123762
25504	40193	1	applied	\N	\N	\N	\N	123763	123763	123764
25504	40194	2	applied	\N	\N	\N	\N	123765	123765	123766
25509	40198	0	applied	\N	\N	\N	\N	123779	123779	123780
25509	40199	1	applied	\N	\N	\N	\N	123781	123781	123782
25509	40200	2	applied	\N	\N	\N	\N	123783	123783	123784
25511	40201	0	applied	\N	\N	\N	\N	123787	123787	123788
25511	40202	1	applied	\N	\N	\N	\N	123789	123789	123790
25511	40203	2	applied	\N	\N	\N	\N	123791	123791	123792
25514	40201	0	applied	\N	\N	\N	\N	123787	123787	123788
25514	40202	1	applied	\N	\N	\N	\N	123789	123789	123790
25514	40203	2	applied	\N	\N	\N	\N	123791	123791	123792
25389	40017	2	applied	\N	\N	\N	\N	123241	123241	123242
25395	40021	0	applied	\N	\N	\N	\N	123257	123257	123258
25395	40022	1	applied	\N	\N	\N	\N	123259	123259	123260
25395	40025	2	applied	\N	\N	\N	\N	123269	123269	123270
25395	40023	3	applied	\N	\N	\N	\N	123261	123261	123271
25395	40024	4	applied	\N	\N	\N	\N	123263	123263	123266
25395	40026	5	applied	\N	\N	\N	\N	123272	123272	123273
25395	40027	6	applied	\N	\N	\N	\N	123274	123274	123275
25402	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25402	40037	1	applied	\N	\N	\N	\N	123302	123302	123303
25402	40034	2	applied	\N	\N	\N	\N	123292	123292	123295
25402	40038	3	applied	\N	\N	\N	\N	123304	123304	123305
25402	40039	4	applied	\N	\N	\N	\N	123306	123306	123307
25402	40035	5	applied	\N	\N	\N	\N	123296	123296	123308
25402	40040	6	applied	\N	\N	\N	\N	123309	123309	123310
25404	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25404	40037	1	applied	\N	\N	\N	\N	123302	123302	123303
25404	40034	2	applied	\N	\N	\N	\N	123292	123292	123295
25404	40038	3	applied	\N	\N	\N	\N	123304	123304	123305
25404	40039	4	applied	\N	\N	\N	\N	123306	123306	123307
25404	40035	5	applied	\N	\N	\N	\N	123296	123296	123308
25404	40040	6	applied	\N	\N	\N	\N	123309	123309	123310
25407	40052	0	applied	\N	\N	\N	\N	123340	123340	123341
25407	40053	1	applied	\N	\N	\N	\N	123342	123342	123343
25407	40054	2	applied	\N	\N	\N	\N	123344	123344	123345
25410	40058	0	applied	\N	\N	\N	\N	123356	123356	123357
25410	40059	1	applied	\N	\N	\N	\N	123358	123358	123359
25410	40060	2	applied	\N	\N	\N	\N	123360	123360	123361
25410	40061	3	applied	\N	\N	\N	\N	123362	123362	123363
25414	40063	0	applied	\N	\N	\N	\N	123372	123372	123373
25414	40062	1	applied	\N	\N	\N	\N	123369	123369	123370
25414	40064	2	applied	\N	\N	\N	\N	123374	123374	123375
25416	40063	0	applied	\N	\N	\N	\N	123372	123372	123373
25416	40065	1	applied	\N	\N	\N	\N	123378	123378	123379
25416	40066	2	applied	\N	\N	\N	\N	123380	123380	123381
25418	40068	0	applied	\N	\N	\N	\N	123388	123388	123389
25418	40069	1	applied	\N	\N	\N	\N	123390	123390	123391
25418	40064	2	applied	\N	\N	\N	\N	123374	123374	123392
25418	40067	3	applied	\N	\N	\N	\N	123385	123385	123393
25418	40070	4	applied	\N	\N	\N	\N	123394	123394	123395
25420	40068	0	applied	\N	\N	\N	\N	123388	123388	123389
25420	40069	1	applied	\N	\N	\N	\N	123390	123390	123391
25420	40064	2	applied	\N	\N	\N	\N	123374	123374	123392
25420	40067	3	applied	\N	\N	\N	\N	123385	123385	123393
25420	40070	4	applied	\N	\N	\N	\N	123394	123394	123395
25425	40078	0	applied	\N	\N	\N	\N	123421	123421	123422
25425	40079	1	applied	\N	\N	\N	\N	123423	123423	123424
25425	40080	2	applied	\N	\N	\N	\N	123425	123425	123426
25434	40095	0	applied	\N	\N	\N	\N	123473	123473	123474
25434	40096	1	applied	\N	\N	\N	\N	123475	123475	123476
25434	40097	2	applied	\N	\N	\N	\N	123477	123477	123478
25445	40101	0	applied	\N	\N	\N	\N	123496	123496	123497
25445	40102	1	applied	\N	\N	\N	\N	123498	123498	123499
25445	40103	2	applied	\N	\N	\N	\N	123500	123500	123501
25449	40108	0	applied	\N	\N	\N	\N	123517	123517	123518
25449	40109	1	applied	\N	\N	\N	\N	123519	123519	123520
25449	40110	2	applied	\N	\N	\N	\N	123521	123521	123522
25449	40111	3	applied	\N	\N	\N	\N	123523	123523	123524
25449	40112	4	applied	\N	\N	\N	\N	123525	123525	111296
25449	40113	5	applied	\N	\N	\N	\N	123526	123526	123527
25449	40114	6	applied	\N	\N	\N	\N	123528	123528	123529
25452	40119	0	applied	\N	\N	\N	\N	123544	123544	123545
25452	40120	1	applied	\N	\N	\N	\N	123546	123546	123547
25452	40121	2	applied	\N	\N	\N	\N	123548	123548	123549
25456	40119	0	applied	\N	\N	\N	\N	123544	123544	123545
25456	40120	1	applied	\N	\N	\N	\N	123546	123546	123547
25456	40121	2	applied	\N	\N	\N	\N	123548	123548	123549
25463	40130	0	applied	\N	\N	\N	\N	123577	123577	123578
25463	40131	1	applied	\N	\N	\N	\N	123579	123579	123580
25463	40132	2	applied	\N	\N	\N	\N	123581	123581	123582
25463	40133	3	applied	\N	\N	\N	\N	123583	123583	123584
25463	40134	4	applied	\N	\N	\N	\N	123585	123585	123586
25463	40135	5	applied	\N	\N	\N	\N	123587	123587	123588
25465	40136	0	applied	\N	\N	\N	\N	123591	123591	123592
25465	40137	1	applied	\N	\N	\N	\N	123593	123593	123594
25465	40138	2	applied	\N	\N	\N	\N	123595	123595	123596
25468	40143	0	applied	\N	\N	\N	\N	123609	123609	123610
25468	40144	1	applied	\N	\N	\N	\N	123611	123611	123612
25468	40145	2	applied	\N	\N	\N	\N	123613	123613	123614
25470	40143	0	applied	\N	\N	\N	\N	123609	123609	123610
25470	40144	1	applied	\N	\N	\N	\N	123611	123611	123612
25470	40145	2	applied	\N	\N	\N	\N	123613	123613	123614
25472	40146	0	applied	\N	\N	\N	\N	123621	123621	123622
25472	40147	1	applied	\N	\N	\N	\N	123623	123623	123624
25472	40148	2	applied	\N	\N	\N	\N	123625	123625	123626
25474	40149	0	applied	\N	\N	\N	\N	123628	123628	123629
25474	40150	2	applied	\N	\N	\N	\N	123631	123631	123632
25474	40151	3	applied	\N	\N	\N	\N	123633	123633	123634
25474	40152	4	applied	\N	\N	\N	\N	123635	123635	123636
25476	40149	0	applied	\N	\N	\N	\N	123628	123628	123629
25476	40150	2	applied	\N	\N	\N	\N	123631	123631	123632
25476	40151	3	applied	\N	\N	\N	\N	123633	123633	123634
25476	40152	4	applied	\N	\N	\N	\N	123635	123635	123636
25483	40159	0	applied	\N	\N	\N	\N	123664	123664	123665
25483	40160	1	applied	\N	\N	\N	\N	123666	123666	123667
25483	40161	2	applied	\N	\N	\N	\N	123668	123668	123669
25490	40171	0	applied	\N	\N	\N	\N	123700	123700	123701
25490	40172	1	applied	\N	\N	\N	\N	123702	123702	123703
25490	40173	2	applied	\N	\N	\N	\N	123704	123704	123705
25497	40180	0	applied	\N	\N	\N	\N	123723	123723	123724
25497	40181	1	applied	\N	\N	\N	\N	123725	123725	123726
25497	40182	2	applied	\N	\N	\N	\N	123727	123727	123728
25501	40186	0	applied	\N	\N	\N	\N	123745	123745	123746
25501	40187	1	applied	\N	\N	\N	\N	123747	123747	123748
25501	40188	2	applied	\N	\N	\N	\N	123749	123749	123750
25506	40195	0	applied	\N	\N	\N	\N	123768	123768	123769
25506	40196	1	applied	\N	\N	\N	\N	123770	123770	123771
25506	40197	2	applied	\N	\N	\N	\N	123772	123772	123773
25508	40198	0	applied	\N	\N	\N	\N	123779	123779	123780
25508	40199	1	applied	\N	\N	\N	\N	123781	123781	123782
25508	40200	2	applied	\N	\N	\N	\N	123783	123783	123784
25510	40201	0	applied	\N	\N	\N	\N	123787	123787	123788
25510	40202	1	applied	\N	\N	\N	\N	123789	123789	123790
25510	40203	2	applied	\N	\N	\N	\N	123791	123791	123792
25513	40201	0	applied	\N	\N	\N	\N	123787	123787	123788
25513	40202	1	applied	\N	\N	\N	\N	123789	123789	123790
25513	40203	2	applied	\N	\N	\N	\N	123791	123791	123792
25517	40204	0	applied	\N	\N	\N	\N	123798	123798	123799
25517	40205	1	applied	\N	\N	\N	\N	123800	123800	123801
25517	40206	2	applied	\N	\N	\N	\N	123802	123802	123803
25454	40121	2	applied	\N	\N	\N	\N	123548	123548	123549
25458	40031	0	applied	\N	\N	1000000000	\N	123284	123284	123285
25458	40032	1	applied	\N	\N	1000000000	\N	123286	123286	123287
25458	40112	2	applied	\N	\N	\N	\N	123564	123564	111296
25458	40122	3	applied	\N	\N	\N	\N	123565	123565	111296
25462	40126	0	applied	\N	\N	\N	\N	123568	123568	123569
25462	40127	1	applied	\N	\N	\N	\N	123570	123570	123571
25462	40128	2	applied	\N	\N	\N	\N	123572	123572	123573
25462	40129	3	applied	\N	\N	\N	\N	123574	123574	123575
25467	40143	0	applied	\N	\N	\N	\N	123609	123609	123610
25467	40144	1	applied	\N	\N	\N	\N	123611	123611	123612
25467	40145	2	applied	\N	\N	\N	\N	123613	123613	123614
25471	40144	0	applied	\N	\N	\N	\N	123611	123611	123612
25471	40145	1	applied	\N	\N	\N	\N	123613	123613	123614
25478	40153	0	applied	\N	\N	\N	\N	123649	123649	123650
25478	40154	1	applied	\N	\N	\N	\N	123651	123651	123652
25478	40155	2	applied	\N	\N	\N	\N	123653	123653	123654
25480	40156	0	applied	\N	\N	\N	\N	123656	123656	123657
25480	40157	1	applied	\N	\N	\N	\N	123658	123658	123659
25480	40158	2	applied	\N	\N	\N	\N	123660	123660	123661
25485	40165	0	applied	\N	\N	\N	\N	123680	123680	123681
25485	40166	1	applied	\N	\N	\N	\N	123682	123682	123683
25485	40167	2	applied	\N	\N	\N	\N	123684	123684	123685
25487	40168	0	applied	\N	\N	\N	\N	123690	123690	123691
25487	40169	1	applied	\N	\N	\N	\N	123692	123692	123693
25487	40170	2	applied	\N	\N	\N	\N	123694	123694	123695
25489	40170	0	applied	\N	\N	\N	\N	123694	123694	123698
25492	40174	0	applied	\N	\N	\N	\N	123706	123706	123707
25492	40175	1	applied	\N	\N	\N	\N	123708	123708	123709
25492	40176	2	applied	\N	\N	\N	\N	123710	123710	123711
25492	40177	3	applied	\N	\N	\N	\N	123712	123712	123713
25492	40178	4	applied	\N	\N	\N	\N	123714	123714	123715
25492	40179	5	applied	\N	\N	\N	\N	123716	123716	123717
25494	40174	0	applied	\N	\N	\N	\N	123706	123706	123707
25494	40175	1	applied	\N	\N	\N	\N	123708	123708	123709
25494	40176	2	applied	\N	\N	\N	\N	123710	123710	123711
25494	40177	3	applied	\N	\N	\N	\N	123712	123712	123713
25494	40178	4	applied	\N	\N	\N	\N	123714	123714	123715
25494	40179	5	applied	\N	\N	\N	\N	123716	123716	123717
25496	40180	0	applied	\N	\N	\N	\N	123723	123723	123724
25496	40181	1	applied	\N	\N	\N	\N	123725	123725	123726
25496	40182	2	applied	\N	\N	\N	\N	123727	123727	123728
25503	40192	0	applied	\N	\N	\N	\N	123761	123761	123762
25503	40193	1	applied	\N	\N	\N	\N	123763	123763	123764
25503	40194	2	applied	\N	\N	\N	\N	123765	123765	123766
25505	40195	0	applied	\N	\N	\N	\N	123768	123768	123769
25505	40196	1	applied	\N	\N	\N	\N	123770	123770	123771
25505	40197	2	applied	\N	\N	\N	\N	123772	123772	123773
25512	40201	0	applied	\N	\N	\N	\N	123787	123787	123788
25512	40202	1	applied	\N	\N	\N	\N	123789	123789	123790
25512	40203	2	applied	\N	\N	\N	\N	123791	123791	123792
25516	40204	0	applied	\N	\N	\N	\N	123798	123798	123799
25516	40205	1	applied	\N	\N	\N	\N	123800	123800	123801
25516	40206	2	applied	\N	\N	\N	\N	123802	123802	123803
25518	40204	0	applied	\N	\N	\N	\N	123798	123798	123799
25518	40205	1	applied	\N	\N	\N	\N	123800	123800	123801
25518	40206	2	applied	\N	\N	\N	\N	123802	123802	123803
25523	40207	0	applied	\N	\N	\N	\N	123810	123810	123811
25523	40210	1	applied	\N	\N	\N	\N	123822	123822	123823
25523	40211	2	applied	\N	\N	\N	\N	123824	123824	123825
25523	40212	3	applied	\N	\N	\N	\N	123826	123826	123827
25523	40208	4	applied	\N	\N	\N	\N	123812	123812	123828
25523	40213	5	applied	\N	\N	\N	\N	123829	123829	123830
25523	40214	6	applied	\N	\N	\N	\N	123831	123831	123832
25527	40215	0	applied	\N	\N	\N	\N	123835	123835	123836
25527	40216	1	applied	\N	\N	\N	\N	123837	123837	123838
25527	40217	2	applied	\N	\N	\N	\N	123839	123839	123840
25530	40218	0	applied	\N	\N	\N	\N	123847	123847	123848
25530	40219	1	applied	\N	\N	\N	\N	123849	123849	123850
25530	40220	2	applied	\N	\N	\N	\N	123851	123851	123852
25530	40221	3	applied	\N	\N	\N	\N	123853	123853	123854
25530	40222	4	applied	\N	\N	\N	\N	123855	123855	123856
25530	40223	5	applied	\N	\N	\N	\N	123857	123857	123858
25530	40224	6	applied	\N	\N	\N	\N	123859	123859	123860
25530	40225	7	applied	\N	\N	\N	\N	123861	123861	123862
25530	40226	8	applied	\N	\N	\N	\N	123863	123863	123864
25533	40230	0	applied	\N	\N	\N	\N	123873	123873	123874
25533	40231	2	applied	\N	\N	\N	\N	123876	123876	123877
25533	40232	3	applied	\N	\N	\N	\N	123878	123878	123879
25535	40236	0	applied	\N	\N	\N	\N	123891	123891	123892
25535	40237	1	applied	\N	\N	\N	\N	123893	123893	123894
25535	40238	2	applied	\N	\N	\N	\N	123895	123895	123896
25545	40258	0	applied	\N	\N	\N	\N	123950	123950	123951
25545	40259	1	applied	\N	\N	\N	\N	123952	123952	123953
25545	40260	2	applied	\N	\N	\N	\N	123954	123954	123955
25550	40273	0	applied	\N	\N	\N	\N	123985	123985	123986
25550	40274	1	applied	\N	\N	\N	\N	123987	123987	123988
25550	40275	2	applied	\N	\N	\N	\N	123989	123989	123990
25555	40279	0	applied	\N	\N	\N	\N	124033	124033	124034
25555	40280	1	applied	\N	\N	\N	\N	124035	124035	124036
25555	40281	2	applied	\N	\N	\N	\N	124037	124037	124038
25555	40282	3	applied	\N	\N	\N	\N	124039	124039	124040
25555	40283	4	applied	\N	\N	\N	\N	124041	124041	124042
25555	40284	5	applied	\N	\N	\N	\N	124043	124043	124044
25557	40285	0	applied	\N	\N	\N	\N	124085	124085	124086
25557	40286	1	applied	\N	\N	\N	\N	124087	124087	124088
25557	40287	2	applied	\N	\N	\N	\N	124089	124089	124090
25560	40294	0	applied	\N	\N	\N	\N	124106	124106	124107
25560	40295	1	applied	\N	\N	\N	\N	124108	124108	124109
25560	40296	2	applied	\N	\N	\N	\N	124110	124110	124111
25562	40294	0	applied	\N	\N	\N	\N	124106	124106	124107
25562	40295	1	applied	\N	\N	\N	\N	124108	124108	124109
25562	40296	2	applied	\N	\N	\N	\N	124110	124110	124111
25564	40294	0	applied	\N	\N	\N	\N	124106	124106	124107
25564	40295	1	applied	\N	\N	\N	\N	124108	124108	124109
25564	40296	2	applied	\N	\N	\N	\N	124110	124110	124111
25567	40297	0	applied	\N	\N	\N	\N	124119	124119	124120
25567	40298	1	applied	\N	\N	\N	\N	124121	124121	124122
25567	40299	2	applied	\N	\N	\N	\N	124123	124123	124124
25567	40300	3	applied	\N	\N	\N	\N	124125	124125	124126
25567	40301	4	applied	\N	\N	\N	\N	124127	124127	124128
25567	40302	5	applied	\N	\N	\N	\N	124129	124129	124130
25567	40303	6	applied	\N	\N	\N	\N	124131	124131	124132
25567	40304	7	applied	\N	\N	\N	\N	124133	124133	124134
25567	40305	8	applied	\N	\N	\N	\N	124135	124135	124136
25570	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25570	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25570	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25574	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25457	40124	2	applied	\N	\N	\N	\N	123559	123559	123560
25457	40125	3	applied	\N	\N	\N	\N	123561	123561	123562
25464	40136	0	applied	\N	\N	\N	\N	123591	123591	123592
25464	40137	1	applied	\N	\N	\N	\N	123593	123593	123594
25464	40138	2	applied	\N	\N	\N	\N	123595	123595	123596
25469	40143	0	applied	\N	\N	\N	\N	123609	123609	123610
25469	40144	1	applied	\N	\N	\N	\N	123611	123611	123612
25469	40145	2	applied	\N	\N	\N	\N	123613	123613	123614
25473	40149	0	applied	\N	\N	\N	\N	123628	123628	123629
25473	40150	2	applied	\N	\N	\N	\N	123631	123631	123632
25473	40151	3	applied	\N	\N	\N	\N	123633	123633	123634
25473	40152	4	applied	\N	\N	\N	\N	123635	123635	123636
25477	40149	0	applied	\N	\N	\N	\N	123628	123628	123629
25477	40150	2	applied	\N	\N	\N	\N	123631	123631	123632
25477	40151	3	applied	\N	\N	\N	\N	123633	123633	123634
25477	40152	4	applied	\N	\N	\N	\N	123635	123635	123636
25484	40162	0	applied	\N	\N	\N	\N	123674	123674	123675
25484	40163	1	applied	\N	\N	\N	\N	123676	123676	123677
25484	40164	2	applied	\N	\N	\N	\N	123678	123678	123679
25499	40180	0	applied	\N	\N	\N	\N	123723	123723	123724
25499	40181	1	applied	\N	\N	\N	\N	123725	123725	123726
25499	40182	2	applied	\N	\N	\N	\N	123727	123727	123728
25500	40183	0	applied	\N	\N	\N	\N	123737	123737	123738
25500	40184	1	applied	\N	\N	\N	\N	123739	123739	123740
25500	40185	2	applied	\N	\N	\N	\N	123741	123741	123742
25507	40195	0	applied	\N	\N	\N	\N	123768	123768	123769
25507	40196	1	applied	\N	\N	\N	\N	123770	123770	123771
25507	40197	2	applied	\N	\N	\N	\N	123772	123772	123773
25521	40207	0	applied	\N	\N	\N	\N	123810	123810	123811
25521	40208	1	applied	\N	\N	\N	\N	123812	123812	123813
25521	40209	2	applied	\N	\N	\N	\N	123814	123814	123815
25522	40209	0	applied	\N	\N	\N	\N	123814	123814	123820
25525	40215	0	applied	\N	\N	\N	\N	123835	123835	123836
25525	40216	1	applied	\N	\N	\N	\N	123837	123837	123838
25525	40217	2	applied	\N	\N	\N	\N	123839	123839	123840
25532	40230	0	applied	\N	\N	\N	\N	123873	123873	123874
25532	40231	2	applied	\N	\N	\N	\N	123876	123876	123877
25532	40232	3	applied	\N	\N	\N	\N	123878	123878	123879
25534	40233	0	applied	\N	\N	\N	\N	123883	123883	123884
25534	40234	1	applied	\N	\N	\N	\N	123885	123885	123886
25534	40235	2	applied	\N	\N	\N	\N	123887	123887	123888
25537	40239	0	applied	\N	\N	\N	\N	123901	123901	123902
25537	40240	1	applied	\N	\N	\N	\N	123903	123903	123904
25537	40241	2	applied	\N	\N	\N	\N	123905	123905	123906
25537	40242	3	applied	\N	\N	\N	\N	123907	123907	123908
25537	40243	4	applied	\N	\N	\N	\N	123909	123909	123910
25537	40244	5	applied	\N	\N	\N	\N	123911	123911	123912
25539	40245	0	applied	\N	\N	\N	\N	123914	123914	123915
25539	40246	1	applied	\N	\N	\N	\N	123916	123916	123917
25542	40151	0	applied	\N	\N	\N	\N	123633	123633	123634
25544	40252	0	applied	\N	\N	\N	\N	123937	123937	123938
25544	40253	1	applied	\N	\N	\N	\N	123939	123939	123940
25544	40254	2	applied	\N	\N	\N	\N	123941	123941	123942
25544	40255	3	applied	\N	\N	\N	\N	123943	123943	123944
25544	40256	4	applied	\N	\N	\N	\N	123945	123945	123946
25544	40257	5	applied	\N	\N	\N	\N	123947	123947	123948
25552	40276	0	applied	\N	\N	\N	\N	124027	124027	124028
25552	40277	1	applied	\N	\N	\N	\N	124029	124029	124030
25552	40278	2	applied	\N	\N	\N	\N	124031	124031	124032
25569	40312	0	applied	\N	\N	\N	\N	124156	124156	124157
25569	40313	1	applied	\N	\N	\N	\N	124158	124158	124159
25569	40314	2	applied	\N	\N	\N	\N	124160	124160	124161
25572	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25572	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25572	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25572	40318	4	applied	\N	\N	\N	\N	124174	124174	124175
25572	40319	5	applied	\N	\N	\N	\N	124176	124176	124177
25572	40320	6	applied	\N	\N	\N	\N	124178	124178	124179
25572	40321	7	applied	\N	\N	\N	\N	124180	124180	124181
25572	40322	8	applied	\N	\N	\N	\N	124182	124182	124183
25572	40323	9	applied	\N	\N	\N	\N	124184	124184	124185
25581	40336	0	applied	\N	\N	\N	\N	124224	124224	124225
25581	40337	1	applied	\N	\N	\N	\N	124226	124226	124227
25581	40338	2	applied	\N	\N	\N	\N	124228	124228	124229
25588	40339	0	applied	\N	\N	\N	\N	124237	124237	124238
25588	40340	1	applied	\N	\N	\N	\N	124239	124239	124240
25588	40341	2	applied	\N	\N	\N	\N	124241	124241	124242
25588	40342	3	applied	\N	\N	\N	\N	124243	124243	124244
25588	40343	4	applied	\N	\N	\N	\N	124245	124245	124246
25588	40344	5	applied	\N	\N	\N	\N	124247	124247	124248
25588	40345	6	applied	\N	\N	\N	\N	124249	124249	124250
25588	40346	7	applied	\N	\N	\N	\N	124251	124251	124252
25588	40347	8	applied	\N	\N	\N	\N	124253	124253	124254
25588	40348	9	applied	\N	\N	\N	\N	124255	124255	124256
25588	40349	10	applied	\N	\N	\N	\N	124257	124257	124258
25588	40350	11	applied	\N	\N	\N	\N	124259	124259	124260
25590	40351	0	applied	\N	\N	\N	\N	124264	124264	124265
25590	40352	1	applied	\N	\N	\N	\N	124266	124266	124267
25590	40353	2	applied	\N	\N	\N	\N	124268	124268	124269
25593	40360	0	applied	\N	\N	\N	\N	124287	124287	124288
25593	40361	1	applied	\N	\N	\N	\N	124289	124289	124290
25602	40372	0	applied	\N	\N	\N	\N	124322	124322	124323
25602	40373	1	applied	\N	\N	\N	\N	124324	124324	124325
25602	40374	2	applied	\N	\N	\N	\N	124326	124326	124327
25602	40375	3	applied	\N	\N	\N	\N	124328	124328	124329
25602	40376	4	applied	\N	\N	\N	\N	124330	124330	124331
25602	40377	5	applied	\N	\N	\N	\N	124332	124332	124333
25614	40396	0	applied	\N	\N	\N	\N	124381	124381	124382
25614	40397	1	applied	\N	\N	\N	\N	124383	124383	124384
25614	40398	2	applied	\N	\N	\N	\N	124385	124385	124386
25621	40409	0	applied	\N	\N	\N	\N	124417	124417	124418
25621	40410	1	applied	\N	\N	\N	\N	124419	124419	124420
25621	40411	2	applied	\N	\N	\N	\N	124421	124421	124422
25621	40412	3	applied	\N	\N	\N	\N	124423	124423	124424
25621	40413	4	applied	\N	\N	\N	\N	124425	124425	124426
25621	40414	5	applied	\N	\N	\N	\N	124427	124427	124428
25624	40417	0	applied	\N	\N	\N	\N	124435	124435	124436
25624	40418	1	applied	\N	\N	\N	\N	124437	124437	124438
25624	40421	2	applied	\N	\N	\N	\N	124444	124444	124445
25624	40422	3	applied	\N	\N	\N	\N	124446	124446	124447
25624	40423	4	applied	\N	\N	\N	\N	124448	124448	124449
25624	40424	5	applied	\N	\N	\N	\N	124450	124450	124451
25624	40419	6	applied	\N	\N	\N	\N	124439	124439	124452
25624	40420	7	applied	\N	\N	\N	\N	124441	124441	124453
25624	40425	8	applied	\N	\N	\N	\N	124454	124454	124455
25624	40426	9	applied	\N	\N	\N	\N	124456	124456	124457
25626	40417	0	applied	\N	\N	\N	\N	124435	124435	124436
25626	40418	1	applied	\N	\N	\N	\N	124437	124437	124438
25626	40421	2	applied	\N	\N	\N	\N	124444	124444	124445
25626	40422	3	applied	\N	\N	\N	\N	124446	124446	124447
25515	40204	0	applied	\N	\N	\N	\N	123798	123798	123799
25515	40205	1	applied	\N	\N	\N	\N	123800	123800	123801
25515	40206	2	applied	\N	\N	\N	\N	123802	123802	123803
25520	40207	0	applied	\N	\N	\N	\N	123810	123810	123811
25520	40208	1	applied	\N	\N	\N	\N	123812	123812	123813
25520	40209	2	applied	\N	\N	\N	\N	123814	123814	123815
25524	40215	0	applied	\N	\N	\N	\N	123835	123835	123836
25524	40216	1	applied	\N	\N	\N	\N	123837	123837	123838
25524	40217	2	applied	\N	\N	\N	\N	123839	123839	123840
25526	40215	0	applied	\N	\N	\N	\N	123835	123835	123836
25526	40216	1	applied	\N	\N	\N	\N	123837	123837	123838
25526	40217	2	applied	\N	\N	\N	\N	123839	123839	123840
25529	40218	0	applied	\N	\N	\N	\N	123847	123847	123848
25529	40219	1	applied	\N	\N	\N	\N	123849	123849	123850
25529	40220	2	applied	\N	\N	\N	\N	123851	123851	123852
25529	40221	3	applied	\N	\N	\N	\N	123853	123853	123854
25529	40222	4	applied	\N	\N	\N	\N	123855	123855	123856
25529	40223	5	applied	\N	\N	\N	\N	123857	123857	123858
25529	40224	6	applied	\N	\N	\N	\N	123859	123859	123860
25529	40225	7	applied	\N	\N	\N	\N	123861	123861	123862
25529	40226	8	applied	\N	\N	\N	\N	123863	123863	123864
25531	40227	0	applied	\N	\N	\N	\N	123867	123867	123868
25531	40228	1	applied	\N	\N	\N	\N	123869	123869	123870
25531	40229	2	applied	\N	\N	\N	\N	123871	123871	123872
25536	40236	0	applied	\N	\N	\N	\N	123891	123891	123892
25536	40237	1	applied	\N	\N	\N	\N	123893	123893	123894
25536	40238	2	applied	\N	\N	\N	\N	123895	123895	123896
25541	40247	0	applied	\N	\N	\N	\N	123922	123922	123923
25541	40248	1	applied	\N	\N	\N	\N	123924	123924	123925
25541	40249	2	applied	\N	\N	\N	\N	123926	123926	123927
25541	40250	3	applied	\N	\N	\N	\N	123928	123928	123929
25541	40251	4	applied	\N	\N	\N	\N	123930	123930	123931
25546	40261	0	applied	\N	\N	\N	\N	123956	123956	123957
25546	40262	1	applied	\N	\N	\N	\N	123958	123958	123959
25546	40263	2	applied	\N	\N	\N	\N	123960	123960	123961
25549	40272	0	applied	\N	\N	\N	\N	123981	123981	123982
25551	40198	0	applied	\N	\N	\N	\N	123779	123779	123780
25551	40201	1	applied	\N	\N	\N	\N	123787	123787	123788
25551	40204	2	applied	\N	\N	\N	\N	123798	123798	123799
25551	40207	3	applied	\N	\N	\N	\N	123810	123810	123811
25551	40210	4	applied	\N	\N	\N	\N	123822	123822	123823
25551	40211	5	applied	\N	\N	\N	\N	123824	123824	123825
25551	40215	6	applied	\N	\N	\N	\N	123835	123835	123836
25551	40218	7	applied	\N	\N	\N	\N	123847	123847	123848
25551	40219	8	applied	\N	\N	\N	\N	123849	123849	123850
25551	40220	9	applied	\N	\N	\N	\N	123851	123851	123852
25551	40227	10	applied	\N	\N	\N	\N	123867	123867	123868
25551	40230	11	applied	\N	\N	\N	\N	123873	123873	123874
25551	40233	12	applied	\N	\N	\N	\N	123883	123883	123884
25551	40236	13	applied	\N	\N	\N	\N	123891	123891	123892
25551	40239	14	applied	\N	\N	\N	\N	123901	123901	123902
25551	40240	15	applied	\N	\N	\N	\N	123903	123903	123904
25551	40245	16	applied	\N	\N	\N	\N	123914	123914	123915
25551	40247	17	applied	\N	\N	\N	\N	123922	123922	123923
25551	40252	18	applied	\N	\N	\N	\N	123937	123937	123938
25551	40253	19	applied	\N	\N	\N	\N	123939	123939	123940
25551	40258	20	applied	\N	\N	\N	\N	123950	123950	123951
25551	40261	21	applied	\N	\N	\N	\N	123956	123956	123957
25551	40264	22	applied	\N	\N	\N	\N	123963	123963	123964
25551	40265	23	applied	\N	\N	\N	\N	123965	123965	123966
25551	40266	24	applied	\N	\N	\N	\N	123967	123967	123968
25551	40273	25	applied	\N	\N	\N	\N	123985	123985	123986
25551	40199	26	applied	\N	\N	\N	\N	123781	123781	123782
25551	40203	27	applied	\N	\N	\N	\N	123791	123791	123993
25551	40205	28	applied	\N	\N	\N	\N	123800	123800	123994
25551	40208	29	applied	\N	\N	\N	\N	123812	123812	123995
25551	40213	30	applied	\N	\N	\N	\N	123829	123829	123803
25551	40216	31	applied	\N	\N	\N	\N	123837	123837	123813
25551	40221	32	applied	\N	\N	\N	\N	123853	123853	123996
25551	40222	33	applied	\N	\N	\N	\N	123855	123855	123997
25551	40223	34	applied	\N	\N	\N	\N	123857	123857	123832
25551	40228	35	applied	\N	\N	\N	\N	123869	123869	123838
25551	40232	36	applied	\N	\N	\N	\N	123878	123878	123998
25551	40234	37	applied	\N	\N	\N	\N	123885	123885	123999
25551	40238	38	applied	\N	\N	\N	\N	123895	123895	124000
25551	40242	39	applied	\N	\N	\N	\N	123907	123907	124001
25551	40243	40	applied	\N	\N	\N	\N	123909	123909	123862
25551	40246	41	applied	\N	\N	\N	\N	123916	123916	124002
25551	40250	42	applied	\N	\N	\N	\N	123928	123928	124003
25551	40251	43	applied	\N	\N	\N	\N	123930	123930	123877
25551	40256	44	applied	\N	\N	\N	\N	123945	123945	123879
25551	40200	45	applied	\N	\N	\N	\N	123783	123783	124004
25551	40202	46	applied	\N	\N	\N	\N	123789	123789	124005
25551	40206	47	applied	\N	\N	\N	\N	123802	123802	124006
25551	40209	48	applied	\N	\N	\N	\N	123814	123814	124007
25551	40212	50	applied	\N	\N	\N	\N	123826	123826	123896
25551	40257	51	applied	\N	\N	\N	\N	123947	123947	124009
25551	40259	52	applied	\N	\N	\N	\N	123952	123952	124010
25551	40262	53	applied	\N	\N	\N	\N	123958	123958	124011
25551	40267	54	applied	\N	\N	\N	\N	123969	123969	124012
25551	40268	55	applied	\N	\N	\N	\N	123971	123971	123925
25551	40272	56	applied	\N	\N	\N	\N	123981	123981	124013
25551	40275	57	applied	\N	\N	\N	\N	123989	123989	124014
25551	40214	58	applied	\N	\N	\N	\N	123831	123831	123931
25551	40217	59	applied	\N	\N	\N	\N	123839	123839	123942
25551	40224	60	applied	\N	\N	\N	\N	123859	123859	123944
25551	40225	61	applied	\N	\N	\N	\N	123861	123861	124015
25551	40226	62	applied	\N	\N	\N	\N	123863	123863	124016
25551	40229	63	applied	\N	\N	\N	\N	123871	123871	123948
25551	40231	64	applied	\N	\N	\N	\N	123876	123876	124017
25551	40235	65	applied	\N	\N	\N	\N	123887	123887	124018
25551	40237	66	applied	\N	\N	\N	\N	123893	123893	124019
25551	40241	67	applied	\N	\N	\N	\N	123905	123905	123959
25551	40244	68	applied	\N	\N	\N	\N	123911	123911	123961
25551	40248	69	applied	\N	\N	\N	\N	123924	123924	124020
25551	40249	70	applied	\N	\N	\N	\N	123926	123926	124021
25551	40254	71	applied	\N	\N	\N	\N	123941	123941	123972
25551	40255	72	applied	\N	\N	\N	\N	123943	123943	123974
25551	40260	73	applied	\N	\N	\N	\N	123954	123954	123976
25551	40263	74	applied	\N	\N	\N	\N	123960	123960	123978
25551	40269	75	applied	\N	\N	\N	\N	123973	123973	124022
25551	40270	76	applied	\N	\N	\N	\N	123975	123975	124023
25551	40271	77	applied	\N	\N	\N	\N	123977	123977	124024
25551	40274	78	applied	\N	\N	\N	\N	123987	123987	123990
25554	40279	0	applied	\N	\N	\N	\N	124033	124033	124034
25554	40280	1	applied	\N	\N	\N	\N	124035	124035	124036
25554	40281	2	applied	\N	\N	\N	\N	124037	124037	124038
25554	40282	3	applied	\N	\N	\N	\N	124039	124039	124040
25554	40283	4	applied	\N	\N	\N	\N	124041	124041	124042
25554	40284	5	applied	\N	\N	\N	\N	124043	124043	124044
25519	40207	0	applied	\N	\N	\N	\N	123810	123810	123811
25519	40208	1	applied	\N	\N	\N	\N	123812	123812	123813
25519	40209	2	applied	\N	\N	\N	\N	123814	123814	123815
25538	40245	0	applied	\N	\N	\N	\N	123914	123914	123915
25538	40246	1	applied	\N	\N	\N	\N	123916	123916	123917
25540	40245	0	applied	\N	\N	\N	\N	123914	123914	123915
25540	40246	1	applied	\N	\N	\N	\N	123916	123916	123917
25543	40151	0	applied	\N	\N	\N	\N	123633	123633	123634
25548	40264	0	applied	\N	\N	\N	\N	123963	123963	123964
25548	40265	1	applied	\N	\N	\N	\N	123965	123965	123966
25548	40266	2	applied	\N	\N	\N	\N	123967	123967	123968
25548	40267	3	applied	\N	\N	\N	\N	123969	123969	123970
25548	40268	4	applied	\N	\N	\N	\N	123971	123971	123972
25548	40269	5	applied	\N	\N	\N	\N	123973	123973	123974
25548	40270	6	applied	\N	\N	\N	\N	123975	123975	123976
25548	40271	7	applied	\N	\N	\N	\N	123977	123977	123978
25558	40288	0	applied	\N	\N	\N	\N	124093	124093	124094
25558	40289	1	applied	\N	\N	\N	\N	124095	124095	124096
25558	40290	2	applied	\N	\N	\N	\N	124097	124097	124098
25558	40291	3	applied	\N	\N	\N	\N	124099	124099	124100
25558	40292	4	applied	\N	\N	\N	\N	124101	124101	124102
25558	40293	5	applied	\N	\N	\N	\N	124103	124103	124104
25561	40294	0	applied	\N	\N	\N	\N	124106	124106	124107
25561	40295	1	applied	\N	\N	\N	\N	124108	124108	124109
25561	40296	2	applied	\N	\N	\N	\N	124110	124110	124111
25565	40297	0	applied	\N	\N	\N	\N	124119	124119	124120
25565	40298	1	applied	\N	\N	\N	\N	124121	124121	124122
25565	40299	2	applied	\N	\N	\N	\N	124123	124123	124124
25565	40300	3	applied	\N	\N	\N	\N	124125	124125	124126
25565	40301	4	applied	\N	\N	\N	\N	124127	124127	124128
25565	40302	5	applied	\N	\N	\N	\N	124129	124129	124130
25565	40303	6	applied	\N	\N	\N	\N	124131	124131	124132
25565	40304	7	applied	\N	\N	\N	\N	124133	124133	124134
25565	40305	8	applied	\N	\N	\N	\N	124135	124135	124136
25571	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25571	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25571	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25587	40339	0	applied	\N	\N	\N	\N	124237	124237	124238
25587	40340	1	applied	\N	\N	\N	\N	124239	124239	124240
25587	40341	2	applied	\N	\N	\N	\N	124241	124241	124242
25587	40342	3	applied	\N	\N	\N	\N	124243	124243	124244
25587	40343	4	applied	\N	\N	\N	\N	124245	124245	124246
25587	40344	5	applied	\N	\N	\N	\N	124247	124247	124248
25587	40345	6	applied	\N	\N	\N	\N	124249	124249	124250
25587	40346	7	applied	\N	\N	\N	\N	124251	124251	124252
25587	40347	8	applied	\N	\N	\N	\N	124253	124253	124254
25587	40348	9	applied	\N	\N	\N	\N	124255	124255	124256
25587	40349	10	applied	\N	\N	\N	\N	124257	124257	124258
25587	40350	11	applied	\N	\N	\N	\N	124259	124259	124260
25589	40351	0	applied	\N	\N	\N	\N	124264	124264	124265
25589	40352	1	applied	\N	\N	\N	\N	124266	124266	124267
25589	40353	2	applied	\N	\N	\N	\N	124268	124268	124269
25594	40360	0	applied	\N	\N	\N	\N	124287	124287	124288
25594	40362	1	applied	\N	\N	\N	\N	124293	124293	124294
25594	40361	2	applied	\N	\N	\N	\N	124289	124289	124295
25596	40363	0	applied	\N	\N	\N	\N	124297	124297	124298
25596	40364	1	applied	\N	\N	\N	\N	124299	124299	124300
25601	40366	0	applied	\N	\N	\N	\N	124307	124307	124308
25601	40367	1	applied	\N	\N	\N	\N	124309	124309	124310
25601	40368	2	applied	\N	\N	\N	\N	124311	124311	124312
25601	40369	3	applied	\N	\N	\N	\N	124313	124313	124314
25601	40370	4	applied	\N	\N	\N	\N	124315	124315	124316
25601	40371	5	applied	\N	\N	\N	\N	124317	124317	124318
25604	40378	0	applied	\N	\N	\N	\N	124335	124335	124336
25604	40379	1	applied	\N	\N	\N	\N	124337	124337	124338
25604	40380	2	applied	\N	\N	\N	\N	124339	124339	124340
25604	40381	3	applied	\N	\N	\N	\N	124341	124341	124342
25604	40382	4	applied	\N	\N	\N	\N	124343	124343	124344
25604	40383	5	applied	\N	\N	\N	\N	124345	124345	124346
25606	40384	0	applied	\N	\N	\N	\N	124349	124349	124350
25606	40385	1	applied	\N	\N	\N	\N	124351	124351	124352
25606	40386	2	applied	\N	\N	\N	\N	124353	124353	124354
25609	40387	0	applied	\N	\N	\N	\N	124356	124356	124357
25609	40388	1	applied	\N	\N	\N	\N	124358	124358	124359
25609	40389	2	applied	\N	\N	\N	\N	124360	124360	124361
25609	40390	3	applied	\N	\N	\N	\N	124362	124362	124363
25609	40391	4	applied	\N	\N	\N	\N	124365	124365	124366
25609	40392	5	applied	\N	\N	\N	\N	124367	124367	124368
25615	40399	0	applied	\N	\N	\N	\N	124389	124389	124390
25615	40400	1	applied	\N	\N	\N	\N	124391	124391	124392
25615	40401	2	applied	\N	\N	\N	\N	124393	124393	124394
25625	40417	0	applied	\N	\N	\N	\N	124435	124435	124436
25625	40418	1	applied	\N	\N	\N	\N	124437	124437	124438
25625	40421	2	applied	\N	\N	\N	\N	124444	124444	124445
25625	40422	3	applied	\N	\N	\N	\N	124446	124446	124447
25625	40423	4	applied	\N	\N	\N	\N	124448	124448	124449
25625	40424	5	applied	\N	\N	\N	\N	124450	124450	124451
25625	40419	6	applied	\N	\N	\N	\N	124439	124439	124452
25625	40420	7	applied	\N	\N	\N	\N	124441	124441	124453
25625	40425	8	applied	\N	\N	\N	\N	124454	124454	124455
25625	40426	9	applied	\N	\N	\N	\N	124456	124456	124457
25627	40417	0	applied	\N	\N	\N	\N	124435	124435	124436
25627	40418	1	applied	\N	\N	\N	\N	124437	124437	124438
25627	40421	2	applied	\N	\N	\N	\N	124444	124444	124445
25627	40422	3	applied	\N	\N	\N	\N	124446	124446	124447
25627	40423	4	applied	\N	\N	\N	\N	124448	124448	124449
25627	40424	5	applied	\N	\N	\N	\N	124450	124450	124451
25627	40419	6	applied	\N	\N	\N	\N	124439	124439	124452
25627	40420	7	applied	\N	\N	\N	\N	124441	124441	124453
25627	40425	8	applied	\N	\N	\N	\N	124454	124454	124455
25627	40426	9	applied	\N	\N	\N	\N	124456	124456	124457
25631	40441	0	applied	\N	\N	\N	\N	124495	124495	124496
25631	40442	1	applied	\N	\N	\N	\N	124497	124497	124498
25631	40443	2	applied	\N	\N	\N	\N	124499	124499	124500
25631	40444	3	applied	\N	\N	\N	\N	124501	124501	124502
25631	40445	4	applied	\N	\N	\N	\N	124503	124503	124504
25631	40446	5	applied	\N	\N	\N	\N	124505	124505	124506
25639	40468	0	applied	\N	\N	\N	\N	124560	124560	124561
25639	40469	1	applied	\N	\N	\N	\N	124562	124562	124563
25639	40470	2	applied	\N	\N	\N	\N	124564	124564	124565
25641	40471	0	applied	\N	\N	\N	\N	124566	124566	124567
25641	40472	1	applied	\N	\N	\N	\N	124568	124568	124569
25641	40473	2	applied	\N	\N	\N	\N	124570	124570	124571
25643	40276	0	applied	\N	\N	\N	\N	124027	124027	124028
25643	40279	1	applied	\N	\N	\N	\N	124033	124033	124034
25643	40280	2	applied	\N	\N	\N	\N	124035	124035	124036
25643	40285	3	applied	\N	\N	\N	\N	124085	124085	124086
25643	40288	4	applied	\N	\N	\N	\N	124093	124093	124094
25643	40289	5	applied	\N	\N	\N	\N	124095	124095	124096
25643	40294	6	applied	\N	\N	\N	\N	124106	124106	124107
25556	40088	0	applied	\N	\N	\N	\N	123455	123455	123456
25556	40091	1	applied	\N	\N	\N	\N	123463	123463	123464
25556	40095	2	applied	\N	\N	\N	\N	123473	123473	123474
25556	40098	3	applied	\N	\N	\N	\N	123485	123485	123486
25556	40101	4	applied	\N	\N	\N	\N	123496	123496	123497
25556	40104	5	applied	\N	\N	\N	\N	123504	123504	123505
25556	40108	6	applied	\N	\N	\N	\N	123517	123517	123518
25556	40109	7	applied	\N	\N	\N	\N	123519	123519	123520
25556	40115	8	applied	\N	\N	\N	\N	123532	123532	123533
25556	40119	9	applied	\N	\N	\N	\N	123544	123544	123545
25556	40123	10	applied	\N	\N	\N	\N	123557	123557	123558
25556	40126	11	applied	\N	\N	\N	\N	123568	123568	123569
25556	40130	12	applied	\N	\N	\N	\N	123577	123577	123578
25556	40131	13	applied	\N	\N	\N	\N	123579	123579	123580
25556	40136	14	applied	\N	\N	\N	\N	123591	123591	123592
25556	40139	15	applied	\N	\N	\N	\N	123599	123599	123600
25556	40143	16	applied	\N	\N	\N	\N	123609	123609	123610
25556	40146	17	applied	\N	\N	\N	\N	123621	123621	123622
25556	40149	18	applied	\N	\N	\N	\N	123628	123628	123629
25556	40153	19	applied	\N	\N	\N	\N	123649	123649	123650
25556	40156	20	applied	\N	\N	\N	\N	123656	123656	123657
25556	40159	21	applied	\N	\N	\N	\N	123664	123664	123665
25556	40162	22	applied	\N	\N	\N	\N	123674	123674	123675
25556	40165	23	applied	\N	\N	\N	\N	123680	123680	123681
25556	40168	24	applied	\N	\N	\N	\N	123690	123690	123691
25556	40171	25	applied	\N	\N	\N	\N	123700	123700	123701
25556	40174	26	applied	\N	\N	\N	\N	123706	123706	123707
25556	40175	27	applied	\N	\N	\N	\N	123708	123708	123709
25556	40180	28	applied	\N	\N	\N	\N	123723	123723	123724
25556	40183	29	applied	\N	\N	\N	\N	123737	123737	123738
25556	40186	30	applied	\N	\N	\N	\N	123745	123745	123746
25556	40189	31	applied	\N	\N	\N	\N	123753	123753	123754
25556	40192	32	applied	\N	\N	\N	\N	123761	123761	123762
25556	40195	33	applied	\N	\N	\N	\N	123768	123768	123769
25556	40198	34	applied	\N	\N	\N	\N	123779	123779	123780
25556	40201	35	applied	\N	\N	\N	\N	123787	123787	123788
25556	40204	36	applied	\N	\N	\N	\N	123798	123798	123799
25556	40207	37	applied	\N	\N	\N	\N	123810	123810	123811
25556	40210	38	applied	\N	\N	\N	\N	123822	123822	123823
25556	40211	39	applied	\N	\N	\N	\N	123824	123824	123825
25556	40215	40	applied	\N	\N	\N	\N	123835	123835	123836
25556	40218	41	applied	\N	\N	\N	\N	123847	123847	123848
25556	40219	42	applied	\N	\N	\N	\N	123849	123849	123850
25556	40220	43	applied	\N	\N	\N	\N	123851	123851	123852
25556	40227	44	applied	\N	\N	\N	\N	123867	123867	123868
25556	40230	45	applied	\N	\N	\N	\N	123873	123873	123874
25556	40233	46	applied	\N	\N	\N	\N	123883	123883	123884
25556	40236	47	applied	\N	\N	\N	\N	123891	123891	123892
25556	40239	48	applied	\N	\N	\N	\N	123901	123901	123902
25556	40240	49	applied	\N	\N	\N	\N	123903	123903	123904
25556	40245	50	applied	\N	\N	\N	\N	123914	123914	123915
25556	40247	51	applied	\N	\N	\N	\N	123922	123922	123923
25556	40252	52	applied	\N	\N	\N	\N	123937	123937	123938
25556	40253	53	applied	\N	\N	\N	\N	123939	123939	123940
25556	40258	54	applied	\N	\N	\N	\N	123950	123950	123951
25556	40261	55	applied	\N	\N	\N	\N	123956	123956	123957
25556	40264	56	applied	\N	\N	\N	\N	123963	123963	123964
25556	40265	57	applied	\N	\N	\N	\N	123965	123965	123966
25556	40266	58	applied	\N	\N	\N	\N	123967	123967	123968
25556	40273	59	applied	\N	\N	\N	\N	123985	123985	123986
25556	40276	60	applied	\N	\N	\N	\N	124027	124027	124028
25556	40279	61	applied	\N	\N	\N	\N	124033	124033	124034
25556	40280	62	applied	\N	\N	\N	\N	124035	124035	124036
25556	40151	63	applied	\N	\N	\N	\N	123633	123633	123634
25556	40089	64	applied	\N	\N	\N	\N	123457	123457	123458
25556	40090	65	applied	\N	\N	\N	\N	123459	123459	123460
25556	40112	66	applied	\N	\N	\N	\N	123525	123525	111296
25556	40122	67	applied	\N	\N	\N	\N	123556	123556	111296
25556	40092	68	applied	\N	\N	\N	\N	123465	123465	123466
25556	40093	69	applied	\N	\N	\N	\N	123467	123467	123468
25556	40096	70	applied	\N	\N	\N	\N	123475	123475	124048
25556	40094	71	applied	\N	\N	\N	\N	123469	123469	123476
25556	40105	72	applied	\N	\N	\N	\N	123506	123506	124049
25556	40116	73	applied	\N	\N	\N	\N	123534	123534	123478
25556	40127	74	applied	\N	\N	\N	\N	123570	123570	124050
25556	40097	75	applied	\N	\N	\N	\N	123477	123477	124051
25556	40099	76	applied	\N	\N	\N	\N	123487	123487	123490
25556	40103	77	applied	\N	\N	\N	\N	123500	123500	124052
25556	40107	78	applied	\N	\N	\N	\N	123511	123511	123507
25556	40110	79	applied	\N	\N	\N	\N	123521	123521	124053
25556	40114	80	applied	\N	\N	\N	\N	123528	123528	124054
25556	40118	81	applied	\N	\N	\N	\N	123540	123540	124055
25556	40120	82	applied	\N	\N	\N	\N	123546	123546	124056
25556	40124	83	applied	\N	\N	\N	\N	123559	123559	124057
25556	40129	84	applied	\N	\N	\N	\N	123574	123574	123524
25556	40132	85	applied	\N	\N	\N	\N	123581	123581	124058
25556	40133	86	applied	\N	\N	\N	\N	123583	123583	124059
25556	40138	87	applied	\N	\N	\N	\N	123595	123595	123535
25556	40140	88	applied	\N	\N	\N	\N	123601	123601	123541
25556	40100	89	applied	\N	\N	\N	\N	123489	123489	123542
25556	40102	90	applied	\N	\N	\N	\N	123498	123498	123554
25556	40106	91	applied	\N	\N	\N	\N	123508	123508	124060
25556	40111	92	applied	\N	\N	\N	\N	123523	123523	124061
25556	40113	93	applied	\N	\N	\N	\N	123526	123526	124062
25556	40117	95	applied	\N	\N	\N	\N	123536	123536	124064
25556	40121	96	applied	\N	\N	\N	\N	123548	123548	123582
25556	40125	97	applied	\N	\N	\N	\N	123561	123561	124065
25556	40128	98	applied	\N	\N	\N	\N	123572	123572	124066
25556	40134	99	applied	\N	\N	\N	\N	123585	123585	124067
25556	40135	100	applied	\N	\N	\N	\N	123587	123587	124068
25556	40137	101	applied	\N	\N	\N	\N	123593	123593	123602
25556	40141	102	applied	\N	\N	\N	\N	123603	123603	123604
25556	40144	103	applied	\N	\N	\N	\N	123611	123611	124069
25556	40147	104	applied	\N	\N	\N	\N	123623	123623	123614
25556	40152	105	applied	\N	\N	\N	\N	123635	123635	123624
25556	40154	106	applied	\N	\N	\N	\N	123651	123651	124070
25556	40157	107	applied	\N	\N	\N	\N	123658	123658	124071
25556	40161	108	applied	\N	\N	\N	\N	123668	123668	124072
25556	40163	109	applied	\N	\N	\N	\N	123676	123676	123654
25556	40166	110	applied	\N	\N	\N	\N	123682	123682	123659
25556	40169	111	applied	\N	\N	\N	\N	123692	123692	124073
25556	40172	112	applied	\N	\N	\N	\N	123702	123702	124074
25556	40177	113	applied	\N	\N	\N	\N	123712	123712	124075
25556	40178	114	applied	\N	\N	\N	\N	123714	123714	123679
25556	40181	115	applied	\N	\N	\N	\N	123725	123725	123683
25556	40184	116	applied	\N	\N	\N	\N	123739	123739	124076
25556	40188	117	applied	\N	\N	\N	\N	123749	123749	124077
25556	40190	118	applied	\N	\N	\N	\N	123755	123755	124078
25556	40194	119	applied	\N	\N	\N	\N	123765	123765	123705
25556	40197	120	applied	\N	\N	\N	\N	123772	123772	124079
25556	40199	121	applied	\N	\N	\N	\N	123781	123781	124080
25556	40203	122	applied	\N	\N	\N	\N	123791	123791	124081
25556	40205	123	applied	\N	\N	\N	\N	123800	123800	124082
25556	40208	124	applied	\N	\N	\N	\N	123812	123812	123728
25556	40213	125	applied	\N	\N	\N	\N	123829	123829	123740
25563	40294	0	applied	\N	\N	\N	\N	124106	124106	124107
25563	40295	1	applied	\N	\N	\N	\N	124108	124108	124109
25563	40296	2	applied	\N	\N	\N	\N	124110	124110	124111
25566	40297	0	applied	\N	\N	\N	\N	124119	124119	124120
25566	40298	1	applied	\N	\N	\N	\N	124121	124121	124122
25566	40299	2	applied	\N	\N	\N	\N	124123	124123	124124
25566	40300	3	applied	\N	\N	\N	\N	124125	124125	124126
25566	40301	4	applied	\N	\N	\N	\N	124127	124127	124128
25566	40302	5	applied	\N	\N	\N	\N	124129	124129	124130
25566	40303	6	applied	\N	\N	\N	\N	124131	124131	124132
25566	40304	7	applied	\N	\N	\N	\N	124133	124133	124134
25566	40305	8	applied	\N	\N	\N	\N	124135	124135	124136
25568	40306	0	applied	\N	\N	\N	\N	124142	124142	124143
25568	40307	1	applied	\N	\N	\N	\N	124144	124144	124145
25568	40308	2	applied	\N	\N	\N	\N	124146	124146	124147
25568	40309	3	applied	\N	\N	\N	\N	124148	124148	124149
25568	40310	4	applied	\N	\N	\N	\N	124150	124150	124151
25568	40311	5	applied	\N	\N	\N	\N	124152	124152	124153
25573	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25573	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25573	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25573	40318	4	applied	\N	\N	\N	\N	124174	124174	124175
25573	40319	5	applied	\N	\N	\N	\N	124176	124176	124177
25573	40320	6	applied	\N	\N	\N	\N	124178	124178	124179
25573	40321	7	applied	\N	\N	\N	\N	124180	124180	124181
25573	40322	8	applied	\N	\N	\N	\N	124182	124182	124183
25573	40323	9	applied	\N	\N	\N	\N	124184	124184	124185
25575	40315	0	applied	\N	\N	\N	\N	124162	124162	124163
25575	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25575	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25575	40318	4	applied	\N	\N	\N	\N	124174	124174	124175
25575	40319	5	applied	\N	\N	\N	\N	124176	124176	124177
25575	40320	6	applied	\N	\N	\N	\N	124178	124178	124179
25575	40321	7	applied	\N	\N	\N	\N	124180	124180	124181
25575	40322	8	applied	\N	\N	\N	\N	124182	124182	124183
25575	40323	9	applied	\N	\N	\N	\N	124184	124184	124185
25576	40324	0	applied	\N	\N	\N	\N	124196	124196	124197
25576	40325	1	applied	\N	\N	\N	\N	124198	124198	124199
25576	40326	2	applied	\N	\N	\N	\N	124200	124200	124201
25576	40318	3	applied	\N	\N	\N	\N	124174	124174	124175
25576	40319	4	applied	\N	\N	\N	\N	124176	124176	124177
25576	40320	5	applied	\N	\N	\N	\N	124178	124178	124179
25576	40321	6	applied	\N	\N	\N	\N	124180	124180	124181
25576	40322	7	applied	\N	\N	\N	\N	124182	124182	124183
25576	40323	8	applied	\N	\N	\N	\N	124184	124184	124185
25576	40327	9	applied	\N	\N	\N	\N	124202	124202	124203
25576	40328	10	applied	\N	\N	\N	\N	124204	124204	124205
25576	40329	11	applied	\N	\N	\N	\N	124206	124206	124207
25576	40330	12	applied	\N	\N	\N	\N	124208	124208	124209
25576	40331	13	applied	\N	\N	\N	\N	124210	124210	124211
25576	40332	14	applied	\N	\N	\N	\N	124212	124212	124213
25578	40333	0	applied	\N	\N	\N	\N	124216	124216	124217
25578	40334	1	applied	\N	\N	\N	\N	124218	124218	124219
25578	40335	2	applied	\N	\N	\N	\N	124220	124220	124221
25583	40336	0	applied	\N	\N	\N	\N	124224	124224	124225
25583	40337	1	applied	\N	\N	\N	\N	124226	124226	124227
25583	40338	2	applied	\N	\N	\N	\N	124228	124228	124229
25592	40356	0	applied	\N	\N	\N	\N	124279	124279	124280
25592	40357	1	applied	\N	\N	\N	\N	124281	124281	124282
25592	40358	2	applied	\N	\N	\N	\N	124283	124283	124284
25592	40359	3	applied	\N	\N	\N	\N	124285	124285	124286
25599	40363	0	applied	\N	\N	\N	\N	124297	124297	124298
25599	40364	1	applied	\N	\N	\N	\N	124299	124299	124300
25599	40365	2	applied	\N	\N	\N	\N	124305	124305	124306
25605	40378	0	applied	\N	\N	\N	\N	124335	124335	124336
25605	40379	1	applied	\N	\N	\N	\N	124337	124337	124338
25605	40380	2	applied	\N	\N	\N	\N	124339	124339	124340
25605	40381	3	applied	\N	\N	\N	\N	124341	124341	124342
25605	40382	4	applied	\N	\N	\N	\N	124343	124343	124344
25605	40383	5	applied	\N	\N	\N	\N	124345	124345	124346
25611	40393	0	applied	\N	\N	\N	\N	124371	124371	124372
25611	40394	1	applied	\N	\N	\N	\N	124373	124373	124374
25611	40391	2	applied	\N	\N	\N	\N	124365	124365	124375
25611	40392	3	applied	\N	\N	\N	\N	124367	124367	124376
25611	40395	4	applied	\N	\N	\N	\N	124377	124377	124378
25616	40399	0	applied	\N	\N	\N	\N	124389	124389	124390
25616	40400	1	applied	\N	\N	\N	\N	124391	124391	124392
25616	40401	2	applied	\N	\N	\N	\N	124393	124393	124394
25618	40399	0	applied	\N	\N	\N	\N	124389	124389	124390
25618	40400	1	applied	\N	\N	\N	\N	124391	124391	124392
25618	40401	2	applied	\N	\N	\N	\N	124393	124393	124394
25623	40417	0	applied	\N	\N	\N	\N	124435	124435	124436
25623	40418	1	applied	\N	\N	\N	\N	124437	124437	124438
25623	40415	2	applied	\N	\N	\N	\N	124430	124430	124431
25623	40419	3	applied	\N	\N	\N	\N	124439	124439	124440
25623	40420	4	applied	\N	\N	\N	\N	124441	124441	124442
25623	40416	5	applied	\N	\N	\N	\N	124432	124432	124443
25628	40427	0	applied	\N	\N	\N	\N	124464	124464	124465
25628	40428	1	applied	\N	\N	\N	\N	124466	124466	124467
25628	40429	2	applied	\N	\N	\N	\N	124468	124468	124469
25628	40430	3	applied	\N	\N	\N	\N	124470	124470	124471
25628	40431	4	applied	\N	\N	\N	\N	124472	124472	124473
25628	40432	5	applied	\N	\N	\N	\N	124474	124474	124475
25635	40453	0	applied	\N	\N	\N	\N	124524	124524	124525
25635	40454	1	applied	\N	\N	\N	\N	124526	124526	124527
25635	40455	2	applied	\N	\N	\N	\N	124528	124528	124529
25635	40456	3	applied	\N	\N	\N	\N	124530	124530	124531
25635	40457	4	applied	\N	\N	\N	\N	124532	124532	124533
25635	40458	5	applied	\N	\N	\N	\N	124534	124534	124535
25635	40459	6	applied	\N	\N	\N	\N	124536	124536	124537
25635	40460	7	applied	\N	\N	\N	\N	124538	124538	124539
25635	40461	8	applied	\N	\N	\N	\N	124540	124540	124541
25635	40462	9	applied	\N	\N	\N	\N	124542	124542	124543
25635	40463	10	applied	\N	\N	\N	\N	124544	124544	124545
25635	40464	11	applied	\N	\N	\N	\N	124546	124546	124547
25637	40465	0	applied	\N	\N	\N	\N	124551	124551	124552
25637	40466	1	applied	\N	\N	\N	\N	124553	124553	124554
25637	40467	2	applied	\N	\N	\N	\N	124555	124555	124556
25644	40474	0	applied	\N	\N	\N	\N	124617	124617	124618
25644	40475	1	applied	\N	\N	\N	\N	124619	124619	124620
25644	40476	2	applied	\N	\N	\N	\N	124621	124621	124622
25644	40477	3	applied	\N	\N	\N	\N	124623	124623	124624
25644	40478	4	applied	\N	\N	\N	\N	124625	124625	124626
25644	40479	5	applied	\N	\N	\N	\N	124627	124627	124628
25647	40486	0	applied	\N	\N	\N	\N	124646	124646	124647
25574	40316	1	applied	\N	\N	\N	\N	124164	124164	124165
25574	40317	2	applied	\N	\N	\N	\N	124166	124166	124167
25574	40318	4	applied	\N	\N	\N	\N	124174	124174	124175
25574	40319	5	applied	\N	\N	\N	\N	124176	124176	124177
25574	40320	6	applied	\N	\N	\N	\N	124178	124178	124179
25574	40321	7	applied	\N	\N	\N	\N	124180	124180	124181
25574	40322	8	applied	\N	\N	\N	\N	124182	124182	124183
25574	40323	9	applied	\N	\N	\N	\N	124184	124184	124185
25577	40333	0	applied	\N	\N	\N	\N	124216	124216	124217
25577	40334	1	applied	\N	\N	\N	\N	124218	124218	124219
25577	40335	2	applied	\N	\N	\N	\N	124220	124220	124221
25579	40333	0	applied	\N	\N	\N	\N	124216	124216	124217
25579	40334	1	applied	\N	\N	\N	\N	124218	124218	124219
25579	40335	2	applied	\N	\N	\N	\N	124220	124220	124221
25586	40151	0	applied	\N	\N	\N	\N	123633	123633	123634
25586	40112	1	applied	\N	\N	\N	\N	124234	124234	111296
25586	40122	2	applied	\N	\N	\N	\N	124235	124235	111296
25591	40354	0	applied	\N	\N	\N	\N	124274	124274	124275
25591	40355	1	applied	\N	\N	\N	\N	124276	124276	124277
25600	40366	0	applied	\N	\N	\N	\N	124307	124307	124308
25600	40367	1	applied	\N	\N	\N	\N	124309	124309	124310
25600	40368	2	applied	\N	\N	\N	\N	124311	124311	124312
25600	40369	3	applied	\N	\N	\N	\N	124313	124313	124314
25600	40370	4	applied	\N	\N	\N	\N	124315	124315	124316
25600	40371	5	applied	\N	\N	\N	\N	124317	124317	124318
25603	40378	0	applied	\N	\N	\N	\N	124335	124335	124336
25603	40379	1	applied	\N	\N	\N	\N	124337	124337	124338
25603	40380	2	applied	\N	\N	\N	\N	124339	124339	124340
25603	40381	3	applied	\N	\N	\N	\N	124341	124341	124342
25603	40382	4	applied	\N	\N	\N	\N	124343	124343	124344
25603	40383	5	applied	\N	\N	\N	\N	124345	124345	124346
25608	40387	0	applied	\N	\N	\N	\N	124356	124356	124357
25608	40388	1	applied	\N	\N	\N	\N	124358	124358	124359
25608	40389	2	applied	\N	\N	\N	\N	124360	124360	124361
25608	40390	3	applied	\N	\N	\N	\N	124362	124362	124363
25610	40393	0	applied	\N	\N	\N	\N	124371	124371	124372
25610	40394	1	applied	\N	\N	\N	\N	124373	124373	124374
25610	40391	2	applied	\N	\N	\N	\N	124365	124365	124375
25610	40392	3	applied	\N	\N	\N	\N	124367	124367	124376
25610	40395	4	applied	\N	\N	\N	\N	124377	124377	124378
25612	40396	0	applied	\N	\N	\N	\N	124381	124381	124382
25612	40397	1	applied	\N	\N	\N	\N	124383	124383	124384
25612	40398	2	applied	\N	\N	\N	\N	124385	124385	124386
25613	40396	0	applied	\N	\N	\N	\N	124381	124381	124382
25613	40397	1	applied	\N	\N	\N	\N	124383	124383	124384
25613	40398	2	applied	\N	\N	\N	\N	124385	124385	124386
25617	40399	0	applied	\N	\N	\N	\N	124389	124389	124390
25617	40400	1	applied	\N	\N	\N	\N	124391	124391	124392
25617	40401	2	applied	\N	\N	\N	\N	124393	124393	124394
25619	40402	0	applied	\N	\N	\N	\N	124401	124401	124402
25619	40403	1	applied	\N	\N	\N	\N	124403	124403	124404
25619	40404	2	applied	\N	\N	\N	\N	124405	124405	124406
25619	40405	3	applied	\N	\N	\N	\N	124407	124407	124408
25619	40406	4	applied	\N	\N	\N	\N	124409	124409	124410
25619	40407	5	applied	\N	\N	\N	\N	124411	124411	124412
25619	40408	6	applied	\N	\N	\N	\N	124413	124413	124414
25622	40415	0	applied	\N	\N	\N	\N	124430	124430	124431
25622	40416	1	applied	\N	\N	\N	\N	124432	124432	124433
25630	40438	0	applied	\N	\N	\N	\N	124489	124489	124490
25630	40439	1	applied	\N	\N	\N	\N	124491	124491	124492
25630	40440	2	applied	\N	\N	\N	\N	124493	124493	124494
25633	40447	0	applied	\N	\N	\N	\N	124511	124511	124512
25633	40448	1	applied	\N	\N	\N	\N	124513	124513	124514
25633	40449	2	applied	\N	\N	\N	\N	124515	124515	124516
25633	40450	3	applied	\N	\N	\N	\N	124517	124517	124518
25633	40451	4	applied	\N	\N	\N	\N	124519	124519	124520
25633	40452	5	applied	\N	\N	\N	\N	124521	124521	124522
25634	40453	0	applied	\N	\N	\N	\N	124524	124524	124525
25634	40454	1	applied	\N	\N	\N	\N	124526	124526	124527
25634	40455	2	applied	\N	\N	\N	\N	124528	124528	124529
25634	40456	3	applied	\N	\N	\N	\N	124530	124530	124531
25634	40457	4	applied	\N	\N	\N	\N	124532	124532	124533
25634	40458	5	applied	\N	\N	\N	\N	124534	124534	124535
25634	40459	6	applied	\N	\N	\N	\N	124536	124536	124537
25634	40460	7	applied	\N	\N	\N	\N	124538	124538	124539
25634	40461	8	applied	\N	\N	\N	\N	124540	124540	124541
25634	40462	9	applied	\N	\N	\N	\N	124542	124542	124543
25634	40463	10	applied	\N	\N	\N	\N	124544	124544	124545
25634	40464	11	applied	\N	\N	\N	\N	124546	124546	124547
25636	40465	0	applied	\N	\N	\N	\N	124551	124551	124552
25636	40466	1	applied	\N	\N	\N	\N	124553	124553	124554
25636	40467	2	applied	\N	\N	\N	\N	124555	124555	124556
25638	40465	0	applied	\N	\N	\N	\N	124551	124551	124552
25638	40466	1	applied	\N	\N	\N	\N	124553	124553	124554
25638	40467	2	applied	\N	\N	\N	\N	124555	124555	124556
25645	40474	0	applied	\N	\N	\N	\N	124617	124617	124618
25645	40475	1	applied	\N	\N	\N	\N	124619	124619	124620
25645	40476	2	applied	\N	\N	\N	\N	124621	124621	124622
25645	40477	3	applied	\N	\N	\N	\N	124623	124623	124624
25645	40478	4	applied	\N	\N	\N	\N	124625	124625	124626
25645	40479	5	applied	\N	\N	\N	\N	124627	124627	124628
25648	40486	0	applied	\N	\N	\N	\N	124646	124646	124647
25648	40487	1	applied	\N	\N	\N	\N	124648	124648	124649
25648	40488	2	applied	\N	\N	\N	\N	124650	124650	124651
25650	40489	0	applied	\N	\N	\N	\N	124654	124654	124655
25650	40490	1	applied	\N	\N	\N	\N	124656	124656	124657
25650	40491	2	applied	\N	\N	1000000000	\N	124658	124658	124659
25650	40492	3	applied	\N	\N	\N	\N	124660	124660	124661
25652	40489	0	applied	\N	\N	\N	\N	124654	124654	124655
25652	40490	1	applied	\N	\N	\N	\N	124656	124656	124657
25652	40491	2	applied	\N	\N	1000000000	\N	124658	124658	124659
25652	40492	3	applied	\N	\N	\N	\N	124660	124660	124661
25661	40523	0	applied	\N	\N	\N	\N	124744	124744	124745
25661	40524	1	applied	\N	\N	\N	\N	124746	124746	124747
25661	40525	2	applied	\N	\N	\N	\N	124748	124748	124749
25661	40526	3	applied	\N	\N	\N	\N	124750	124750	124751
25661	40527	4	applied	\N	\N	\N	\N	124752	124752	124753
25661	40528	5	applied	\N	\N	\N	\N	124754	124754	124755
25668	40535	0	applied	\N	\N	\N	\N	124779	124779	124780
25668	40536	1	applied	\N	\N	\N	\N	124781	124781	124782
25668	40537	2	applied	\N	\N	\N	\N	124783	124783	124784
25670	40538	0	applied	\N	\N	\N	\N	124788	124788	124789
25670	40539	1	applied	\N	\N	\N	\N	124790	124790	124791
25670	40540	2	applied	\N	\N	\N	\N	124792	124792	124793
25675	40544	0	applied	\N	\N	\N	\N	124807	124807	124808
25675	40545	1	applied	\N	\N	\N	\N	124809	124809	124810
25675	40546	2	applied	\N	\N	\N	\N	124811	124811	124812
25680	40547	0	applied	\N	\N	\N	\N	124821	124821	124822
25680	40548	1	applied	\N	\N	\N	\N	124823	124823	124824
25626	40423	4	applied	\N	\N	\N	\N	124448	124448	124449
25626	40424	5	applied	\N	\N	\N	\N	124450	124450	124451
25626	40419	6	applied	\N	\N	\N	\N	124439	124439	124452
25626	40420	7	applied	\N	\N	\N	\N	124441	124441	124453
25626	40425	8	applied	\N	\N	\N	\N	124454	124454	124455
25626	40426	9	applied	\N	\N	\N	\N	124456	124456	124457
25629	40433	0	applied	\N	\N	\N	\N	124478	124478	124479
25629	40434	1	applied	\N	\N	\N	\N	124480	124480	124481
25629	40435	2	applied	\N	\N	\N	\N	124482	124482	124483
25629	40436	3	applied	\N	\N	\N	\N	124484	124484	124485
25629	40437	4	applied	\N	\N	\N	\N	124486	124486	124487
25632	40441	0	applied	\N	\N	\N	\N	124495	124495	124496
25632	40442	1	applied	\N	\N	\N	\N	124497	124497	124498
25632	40443	2	applied	\N	\N	\N	\N	124499	124499	124500
25632	40444	3	applied	\N	\N	\N	\N	124501	124501	124502
25632	40445	4	applied	\N	\N	\N	\N	124503	124503	124504
25632	40446	5	applied	\N	\N	\N	\N	124505	124505	124506
25640	40471	0	applied	\N	\N	\N	\N	124566	124566	124567
25640	40472	1	applied	\N	\N	\N	\N	124568	124568	124569
25640	40473	2	applied	\N	\N	\N	\N	124570	124570	124571
25642	40471	0	applied	\N	\N	\N	\N	124566	124566	124567
25642	40472	1	applied	\N	\N	\N	\N	124568	124568	124569
25642	40473	2	applied	\N	\N	\N	\N	124570	124570	124571
25654	40493	0	applied	\N	\N	\N	\N	124665	124665	124666
25654	40494	1	applied	\N	\N	\N	\N	124669	124669	124670
25657	40498	0	applied	\N	\N	\N	\N	124680	124680	124681
25657	40499	1	applied	\N	\N	\N	\N	124682	124682	124683
25657	40500	3	applied	\N	\N	\N	\N	124685	124685	124686
25657	40501	4	applied	\N	\N	\N	\N	124687	124687	124688
25657	40502	5	applied	\N	\N	\N	\N	124689	124689	124690
25657	40503	6	applied	\N	\N	\N	\N	124691	124691	124692
25659	40504	0	applied	\N	\N	\N	\N	124702	124702	124703
25659	40505	1	applied	\N	\N	\N	\N	124704	124704	124705
25659	40506	2	applied	\N	\N	\N	\N	124706	124706	124707
25659	40507	3	applied	\N	\N	\N	\N	124708	124708	124709
25659	40508	4	applied	\N	\N	\N	\N	124710	124710	124711
25659	40509	5	applied	\N	\N	\N	\N	124712	124712	124713
25659	40510	6	applied	\N	\N	\N	\N	124714	124714	124715
25660	40511	0	applied	\N	\N	\N	\N	124718	124718	124719
25660	40512	1	applied	\N	\N	\N	\N	124720	124720	124721
25660	40513	2	applied	\N	\N	\N	\N	124722	124722	124723
25660	40514	3	applied	\N	\N	\N	\N	124724	124724	124725
25660	40515	4	applied	\N	\N	\N	\N	124726	124726	124727
25660	40516	5	applied	\N	\N	\N	\N	124728	124728	124729
25660	40517	6	applied	\N	\N	\N	\N	124730	124730	124731
25660	40518	7	applied	\N	\N	\N	\N	124732	124732	124733
25660	40519	8	applied	\N	\N	\N	\N	124734	124734	124735
25660	40520	9	applied	\N	\N	\N	\N	124736	124736	124737
25660	40521	10	applied	\N	\N	\N	\N	124738	124738	124739
25660	40522	11	applied	\N	\N	\N	\N	124740	124740	124741
25663	40529	0	applied	\N	\N	\N	\N	124758	124758	124759
25663	40530	1	applied	\N	\N	\N	\N	124760	124760	124761
25665	40532	0	applied	\N	\N	\N	\N	124769	124769	124770
25665	40533	1	applied	\N	\N	\N	\N	124771	124771	124772
25672	40541	0	applied	\N	\N	\N	\N	124796	124796	124797
25672	40542	1	applied	\N	\N	\N	\N	124798	124798	124799
25674	40544	0	applied	\N	\N	\N	\N	124807	124807	124808
25674	40545	1	applied	\N	\N	\N	\N	124809	124809	124810
25674	40546	2	applied	\N	\N	\N	\N	124811	124811	124812
25678	40544	0	applied	\N	\N	\N	\N	124807	124807	124808
25678	40545	1	applied	\N	\N	\N	\N	124809	124809	124819
25678	40543	2	applied	\N	\N	\N	\N	124800	124800	124810
25678	40546	3	applied	\N	\N	\N	\N	124811	124811	124812
25679	40547	0	applied	\N	\N	\N	\N	124821	124821	124822
25679	40548	1	applied	\N	\N	\N	\N	124823	124823	124824
25679	40549	2	applied	\N	\N	\N	\N	124825	124825	124826
25679	40550	3	applied	\N	\N	\N	\N	124827	124827	124828
25679	40551	4	applied	\N	\N	\N	\N	124829	124829	124830
25679	40552	5	applied	\N	\N	\N	\N	124831	124831	124832
25682	40547	0	applied	\N	\N	\N	\N	124821	124821	124822
25682	40548	1	applied	\N	\N	\N	\N	124823	124823	124824
25682	40549	2	applied	\N	\N	\N	\N	124825	124825	124826
25682	40546	3	applied	\N	\N	\N	\N	124811	124811	124812
25682	40553	4	applied	\N	\N	\N	\N	124837	124837	124838
25682	40554	5	applied	\N	\N	\N	\N	124839	124839	124830
25682	40555	6	applied	\N	\N	\N	\N	124840	124840	124841
25682	40550	7	applied	\N	\N	\N	\N	124827	124827	124842
25682	40551	8	applied	\N	\N	\N	\N	124829	124829	124843
25682	40552	9	applied	\N	\N	\N	\N	124831	124831	124844
25683	40547	0	applied	\N	\N	\N	\N	124821	124821	124822
25683	40548	1	applied	\N	\N	\N	\N	124823	124823	124824
25683	40549	2	applied	\N	\N	\N	\N	124825	124825	124826
25683	40546	3	applied	\N	\N	\N	\N	124811	124811	124812
25683	40553	4	applied	\N	\N	\N	\N	124837	124837	124838
25683	40554	5	applied	\N	\N	\N	\N	124839	124839	124830
25683	40555	6	applied	\N	\N	\N	\N	124840	124840	124841
25683	40550	7	applied	\N	\N	\N	\N	124827	124827	124842
25683	40551	8	applied	\N	\N	\N	\N	124829	124829	124843
25683	40552	9	applied	\N	\N	\N	\N	124831	124831	124844
25688	40565	0	applied	\N	\N	\N	\N	124873	124873	124874
25688	40566	1	applied	\N	\N	\N	\N	124875	124875	124876
25696	40036	0	applied	\N	\N	\N	\N	123300	123300	123301
25698	40589	0	applied	\N	\N	\N	\N	124934	124934	124935
25698	40590	2	applied	\N	\N	\N	\N	124937	124937	124938
25698	40591	3	applied	\N	\N	\N	\N	124939	124939	124940
25700	40592	0	applied	\N	\N	\N	\N	124944	124944	124945
25700	40593	1	applied	\N	\N	\N	\N	124946	124946	124947
25700	40594	2	applied	\N	\N	\N	\N	124948	124948	124949
25703	40404	0	applied	\N	\N	\N	\N	124405	124405	124406
25703	40583	1	applied	\N	\N	\N	\N	124915	124915	124962
25712	40608	0	applied	\N	\N	\N	\N	124992	124992	124993
25712	40609	1	applied	\N	\N	\N	\N	124994	124994	124995
25712	40610	2	applied	\N	\N	\N	\N	124996	124996	124997
25712	40611	3	applied	\N	\N	\N	\N	124998	124998	124999
25712	40612	4	applied	\N	\N	\N	\N	125000	125000	125001
25712	40613	5	applied	\N	\N	\N	\N	125002	125002	125003
25714	40608	0	applied	\N	\N	\N	\N	124992	124992	124993
25714	40609	1	applied	\N	\N	\N	\N	124994	124994	124995
25714	40610	2	applied	\N	\N	\N	\N	124996	124996	124997
25714	40611	3	applied	\N	\N	\N	\N	124998	124998	124999
25714	40614	4	applied	\N	\N	\N	\N	125006	125006	125007
25714	40615	5	applied	\N	\N	\N	\N	125008	125008	125009
25714	40616	6	applied	\N	\N	\N	\N	125010	125010	125011
25714	40612	7	applied	\N	\N	\N	\N	125000	125000	125012
25714	40613	8	applied	\N	\N	\N	\N	125002	125002	125013
25721	40626	0	applied	\N	\N	\N	\N	125046	125046	125047
25721	40627	1	applied	\N	\N	\N	\N	125048	125048	125049
25721	40628	2	applied	\N	\N	\N	\N	125050	125050	125051
25724	40635	0	applied	\N	\N	\N	\N	125069	125069	125070
25724	40636	1	applied	\N	\N	\N	\N	125071	125071	125072
25643	40297	7	applied	\N	\N	\N	\N	124119	124119	124120
25643	40298	8	applied	\N	\N	\N	\N	124121	124121	124122
25643	40299	9	applied	\N	\N	\N	\N	124123	124123	124124
25643	40306	10	applied	\N	\N	\N	\N	124142	124142	124143
25643	40307	11	applied	\N	\N	\N	\N	124144	124144	124145
25643	40312	12	applied	\N	\N	\N	\N	124156	124156	124157
25643	40315	13	applied	\N	\N	\N	\N	124162	124162	124163
25643	40316	14	applied	\N	\N	\N	\N	124164	124164	124165
25643	40317	15	applied	\N	\N	\N	\N	124166	124166	124167
25643	40324	16	applied	\N	\N	\N	\N	124196	124196	124197
25643	40325	17	applied	\N	\N	\N	\N	124198	124198	124199
25643	40326	18	applied	\N	\N	\N	\N	124200	124200	124201
25643	40333	19	applied	\N	\N	\N	\N	124216	124216	124217
25643	40336	20	applied	\N	\N	\N	\N	124224	124224	124225
25643	40339	21	applied	\N	\N	\N	\N	124237	124237	124238
25643	40340	22	applied	\N	\N	\N	\N	124239	124239	124240
25643	40341	23	applied	\N	\N	\N	\N	124241	124241	124242
25643	40342	24	applied	\N	\N	\N	\N	124243	124243	124244
25643	40351	25	applied	\N	\N	\N	\N	124264	124264	124265
25643	40354	26	applied	\N	\N	\N	\N	124274	124274	124275
25643	40356	27	applied	\N	\N	\N	\N	124279	124279	124280
25643	40360	28	applied	\N	\N	\N	\N	124287	124287	124288
25643	40363	29	applied	\N	\N	\N	\N	124297	124297	124298
25643	40366	30	applied	\N	\N	\N	\N	124307	124307	124308
25643	40367	31	applied	\N	\N	\N	\N	124309	124309	124310
25643	40372	32	applied	\N	\N	\N	\N	124322	124322	124323
25643	40373	33	applied	\N	\N	\N	\N	124324	124324	124325
25643	40378	34	applied	\N	\N	\N	\N	124335	124335	124336
25643	40379	35	applied	\N	\N	\N	\N	124337	124337	124338
25643	40384	36	applied	\N	\N	\N	\N	124349	124349	124350
25643	40387	37	applied	\N	\N	\N	\N	124356	124356	124357
25643	40388	38	applied	\N	\N	\N	\N	124358	124358	124359
25643	40393	39	applied	\N	\N	\N	\N	124371	124371	124372
25643	40396	40	applied	\N	\N	\N	\N	124381	124381	124382
25643	40399	41	applied	\N	\N	\N	\N	124389	124389	124390
25643	40402	42	applied	\N	\N	\N	\N	124401	124401	124402
25643	40403	43	applied	\N	\N	\N	\N	124403	124403	124404
25643	40409	44	applied	\N	\N	\N	\N	124417	124417	124418
25643	40410	45	applied	\N	\N	\N	\N	124419	124419	124420
25643	40417	46	applied	\N	\N	\N	\N	124435	124435	124436
25643	40418	47	applied	\N	\N	\N	\N	124437	124437	124438
25643	40421	48	applied	\N	\N	\N	\N	124444	124444	124445
25643	40422	49	applied	\N	\N	\N	\N	124446	124446	124447
25643	40427	50	applied	\N	\N	\N	\N	124464	124464	124465
25643	40428	51	applied	\N	\N	\N	\N	124466	124466	124467
25643	40433	52	applied	\N	\N	\N	\N	124478	124478	124479
25643	40434	53	applied	\N	\N	\N	\N	124480	124480	124481
25643	40438	54	applied	\N	\N	\N	\N	124489	124489	124490
25643	40441	55	applied	\N	\N	\N	\N	124495	124495	124496
25643	40442	56	applied	\N	\N	\N	\N	124497	124497	124498
25643	40447	57	applied	\N	\N	\N	\N	124511	124511	124512
25643	40448	58	applied	\N	\N	\N	\N	124513	124513	124514
25643	40453	59	applied	\N	\N	\N	\N	124524	124524	124525
25643	40454	60	applied	\N	\N	\N	\N	124526	124526	124527
25643	40455	61	applied	\N	\N	\N	\N	124528	124528	124529
25643	40456	62	applied	\N	\N	\N	\N	124530	124530	124531
25643	40465	63	applied	\N	\N	\N	\N	124551	124551	124552
25643	40468	64	applied	\N	\N	\N	\N	124560	124560	124561
25643	40471	65	applied	\N	\N	\N	\N	124566	124566	124567
25643	40404	66	applied	\N	\N	\N	\N	124405	124405	124406
25643	40277	67	applied	\N	\N	\N	\N	124029	124029	124030
25643	40282	68	applied	\N	\N	\N	\N	124039	124039	124578
25643	40283	69	applied	\N	\N	\N	\N	124041	124041	124579
25643	40286	70	applied	\N	\N	\N	\N	124087	124087	124580
25643	40290	71	applied	\N	\N	\N	\N	124097	124097	124044
25643	40291	72	applied	\N	\N	\N	\N	124099	124099	124088
25643	40278	73	applied	\N	\N	\N	\N	124031	124031	124090
25643	40281	74	applied	\N	\N	\N	\N	124037	124037	124581
25643	40296	75	applied	\N	\N	\N	\N	124110	124110	124582
25643	40303	76	applied	\N	\N	\N	\N	124131	124131	124102
25643	40304	77	applied	\N	\N	\N	\N	124133	124133	124583
25643	40284	78	applied	\N	\N	\N	\N	124043	124043	124584
25643	40287	79	applied	\N	\N	\N	\N	124089	124089	124111
25643	40292	80	applied	\N	\N	\N	\N	124101	124101	124126
25643	40293	81	applied	\N	\N	\N	\N	124103	124103	124128
25643	40295	82	applied	\N	\N	\N	\N	124108	124108	124130
25643	40300	83	applied	\N	\N	\N	\N	124125	124125	124585
25643	40301	84	applied	\N	\N	\N	\N	124127	124127	124586
25643	40302	85	applied	\N	\N	\N	\N	124129	124129	124134
25643	40310	86	applied	\N	\N	\N	\N	124150	124150	124587
25643	40305	87	applied	\N	\N	\N	\N	124135	124135	124588
25643	40308	88	applied	\N	\N	\N	\N	124146	124146	124589
25643	40309	89	applied	\N	\N	\N	\N	124148	124148	124151
25643	40313	90	applied	\N	\N	\N	\N	124158	124158	124590
25643	40318	91	applied	\N	\N	\N	\N	124174	124174	124591
25643	40319	92	applied	\N	\N	\N	\N	124176	124176	124592
25643	40322	93	applied	\N	\N	\N	\N	124182	124182	124593
25643	40311	94	applied	\N	\N	\N	\N	124152	124152	124594
25643	40314	95	applied	\N	\N	\N	\N	124160	124160	124595
25643	40320	97	applied	\N	\N	\N	\N	124178	124178	124597
25643	40321	98	applied	\N	\N	\N	\N	124180	124180	124183
25643	40323	99	applied	\N	\N	\N	\N	124184	124184	124185
25643	40327	100	applied	\N	\N	\N	\N	124202	124202	124203
25643	40328	101	applied	\N	\N	\N	\N	124204	124204	124205
25643	40329	102	applied	\N	\N	\N	\N	124206	124206	124207
25643	40334	103	applied	\N	\N	\N	\N	124218	124218	124598
25643	40338	104	applied	\N	\N	\N	\N	124228	124228	124599
25643	40345	105	applied	\N	\N	\N	\N	124249	124249	124211
25643	40348	106	applied	\N	\N	\N	\N	124255	124255	124600
25643	40349	107	applied	\N	\N	\N	\N	124257	124257	124601
25643	40350	108	applied	\N	\N	\N	\N	124259	124259	124602
25643	40352	109	applied	\N	\N	\N	\N	124266	124266	124221
25643	40357	110	applied	\N	\N	\N	\N	124281	124281	124603
25643	40359	111	applied	\N	\N	\N	\N	124285	124285	124604
25643	40362	112	applied	\N	\N	\N	\N	124293	124293	124605
25643	40365	113	applied	\N	\N	\N	\N	124305	124305	124246
25643	40369	114	applied	\N	\N	\N	\N	124313	124313	124606
25643	40370	115	applied	\N	\N	\N	\N	124315	124315	124607
25643	40374	116	applied	\N	\N	\N	\N	124326	124326	124608
25643	40377	117	applied	\N	\N	\N	\N	124332	124332	124252
25643	40382	118	applied	\N	\N	\N	\N	124343	124343	124609
25643	40383	119	applied	\N	\N	\N	\N	124345	124345	124610
25643	40386	120	applied	\N	\N	\N	\N	124353	124353	124611
25643	40391	121	applied	\N	\N	\N	\N	124365	124365	124612
25643	40392	122	applied	\N	\N	\N	\N	124367	124367	124613
25646	40480	0	applied	\N	\N	\N	\N	124633	124633	124634
25646	40481	1	applied	\N	\N	\N	\N	124635	124635	124636
25646	40482	2	applied	\N	\N	\N	\N	124637	124637	124638
25646	40483	3	applied	\N	\N	\N	\N	124639	124639	124640
25646	40484	4	applied	\N	\N	\N	\N	124641	124641	124642
25646	40485	5	applied	\N	\N	\N	\N	124643	124643	124644
25653	40493	0	applied	\N	\N	\N	\N	124665	124665	124666
25655	40495	0	applied	\N	\N	\N	\N	124672	124672	124673
25655	40496	1	applied	\N	\N	\N	\N	124674	124674	124675
25655	40497	2	applied	\N	\N	\N	\N	124676	124676	124677
25658	40498	0	applied	\N	\N	\N	\N	124680	124680	124681
25658	40499	1	applied	\N	\N	\N	\N	124682	124682	124683
25658	40500	3	applied	\N	\N	\N	\N	124685	124685	124686
25658	40501	4	applied	\N	\N	\N	\N	124687	124687	124688
25658	40502	5	applied	\N	\N	\N	\N	124689	124689	124690
25658	40503	6	applied	\N	\N	\N	\N	124691	124691	124692
25662	40529	0	applied	\N	\N	\N	\N	124758	124758	124759
25662	40530	1	applied	\N	\N	\N	\N	124760	124760	124761
25662	40531	2	applied	\N	\N	\N	\N	124762	124762	124763
25664	40529	0	applied	\N	\N	\N	\N	124758	124758	124759
25664	40530	1	applied	\N	\N	\N	\N	124760	124760	124761
25664	40531	2	applied	\N	\N	\N	\N	124762	124762	124763
25666	40532	0	applied	\N	\N	\N	\N	124769	124769	124770
25666	40534	1	applied	\N	\N	\N	\N	124775	124775	124776
25666	40533	2	applied	\N	\N	\N	\N	124771	124771	124777
25671	40541	0	applied	\N	\N	\N	\N	124796	124796	124797
25671	40542	1	applied	\N	\N	\N	\N	124798	124798	124799
25671	40543	2	applied	\N	\N	\N	\N	124800	124800	124801
25673	40541	0	applied	\N	\N	\N	\N	124796	124796	124797
25673	40542	1	applied	\N	\N	\N	\N	124798	124798	124799
25673	40543	2	applied	\N	\N	\N	\N	124800	124800	124801
25676	40544	0	applied	\N	\N	\N	\N	124807	124807	124808
25676	40545	1	applied	\N	\N	\N	\N	124809	124809	124810
25684	40556	0	applied	\N	\N	\N	\N	124849	124849	124850
25684	40557	1	applied	\N	\N	\N	\N	124851	124851	124852
25684	40558	2	applied	\N	\N	\N	\N	124853	124853	124854
25689	40567	0	applied	\N	\N	\N	\N	124879	124879	124880
25689	40568	1	applied	\N	\N	\N	\N	124881	124881	124882
25689	40569	2	applied	\N	\N	\N	\N	124883	124883	124884
25697	40589	0	applied	\N	\N	\N	\N	124934	124934	124935
25697	40590	2	applied	\N	\N	\N	\N	124937	124937	124938
25697	40591	3	applied	\N	\N	\N	\N	124939	124939	124940
25699	40592	0	applied	\N	\N	\N	\N	124944	124944	124945
25699	40593	1	applied	\N	\N	\N	\N	124946	124946	124947
25699	40594	2	applied	\N	\N	\N	\N	124948	124948	124949
25701	40592	0	applied	\N	\N	\N	\N	124944	124944	124945
25701	40594	1	applied	\N	\N	\N	\N	124948	124948	124952
25706	40598	0	applied	\N	\N	\N	\N	124966	124966	124967
25706	40599	1	applied	\N	\N	\N	\N	124968	124968	124969
25706	40600	2	applied	\N	\N	\N	\N	124970	124970	124971
25708	40598	0	applied	\N	\N	\N	\N	124966	124966	124967
25708	40599	1	applied	\N	\N	\N	\N	124968	124968	124969
25708	40600	2	applied	\N	\N	\N	\N	124970	124970	124971
25713	40608	0	applied	\N	\N	\N	\N	124992	124992	124993
25713	40609	1	applied	\N	\N	\N	\N	124994	124994	124995
25713	40610	2	applied	\N	\N	\N	\N	124996	124996	124997
25713	40611	3	applied	\N	\N	\N	\N	124998	124998	124999
25713	40614	4	applied	\N	\N	\N	\N	125006	125006	125007
25713	40615	5	applied	\N	\N	\N	\N	125008	125008	125009
25713	40616	6	applied	\N	\N	\N	\N	125010	125010	125011
25713	40612	7	applied	\N	\N	\N	\N	125000	125000	125012
25713	40613	8	applied	\N	\N	\N	\N	125002	125002	125013
25715	40608	0	applied	\N	\N	\N	\N	124992	124992	124993
25715	40609	1	applied	\N	\N	\N	\N	124994	124994	124995
25715	40610	2	applied	\N	\N	\N	\N	124996	124996	124997
25715	40611	3	applied	\N	\N	\N	\N	124998	124998	124999
25715	40614	4	applied	\N	\N	\N	\N	125006	125006	125007
25715	40615	5	applied	\N	\N	\N	\N	125008	125008	125009
25715	40616	6	applied	\N	\N	\N	\N	125010	125010	125011
25715	40612	7	applied	\N	\N	\N	\N	125000	125000	125012
25715	40613	8	applied	\N	\N	\N	\N	125002	125002	125013
25720	40623	0	applied	\N	\N	\N	\N	125038	125038	125039
25720	40624	1	applied	\N	\N	\N	\N	125040	125040	125041
25720	40625	2	applied	\N	\N	\N	\N	125042	125042	125043
25725	40638	0	applied	\N	\N	\N	\N	125077	125077	125078
25725	40639	1	applied	\N	\N	\N	\N	125079	125079	125080
25725	40640	2	applied	\N	\N	\N	\N	125081	125081	125082
25728	40647	0	applied	\N	\N	\N	\N	125097	125097	125098
25728	40648	1	applied	\N	\N	\N	\N	125099	125099	125100
25728	40649	2	applied	\N	\N	\N	\N	125101	125101	125102
25731	40659	0	applied	\N	\N	\N	\N	125125	125125	125126
25731	40660	1	applied	\N	\N	\N	\N	125127	125127	125128
25731	40661	2	applied	\N	\N	\N	\N	125129	125129	125130
25733	40662	0	applied	\N	\N	\N	\N	125132	125132	125133
25733	40663	1	applied	\N	\N	\N	\N	125134	125134	125135
25733	40664	2	applied	\N	\N	\N	\N	125136	125136	125137
25738	40671	0	applied	\N	\N	\N	\N	125158	125158	125159
25738	40672	1	applied	\N	\N	\N	\N	125160	125160	125161
25738	40673	2	applied	\N	\N	\N	\N	125162	125162	125163
25738	40674	3	applied	\N	\N	\N	\N	125164	125164	13107
25738	40675	4	applied	\N	\N	\N	\N	125165	125165	125165
25742	40404	0	applied	\N	\N	\N	\N	124405	124405	124406
25742	40674	1	applied	\N	\N	\N	\N	125164	125164	13107
25742	40675	2	applied	\N	\N	\N	\N	125165	125165	125165
25742	40583	3	applied	\N	\N	\N	\N	124915	124915	124962
25751	40684	0	applied	\N	\N	\N	\N	125207	125207	125208
25751	40685	1	applied	\N	\N	\N	\N	125209	125209	125210
25751	40686	2	applied	\N	\N	\N	\N	125211	125211	120198
25751	40687	3	applied	\N	\N	\N	\N	125212	125212	125213
25763	40697	0	applied	\N	\N	\N	\N	125245	125245	125246
25763	40698	1	applied	\N	\N	\N	\N	125247	125247	125248
25763	40699	2	applied	\N	\N	\N	\N	125249	125249	125250
25764	40700	0	applied	\N	\N	\N	\N	125255	125255	125256
25764	40701	1	applied	\N	\N	\N	\N	125257	125257	125258
25764	40702	2	applied	\N	\N	\N	\N	125259	125259	125260
25773	40709	0	applied	\N	\N	\N	\N	125286	125286	125287
25773	40710	1	applied	\N	\N	\N	\N	125288	125288	125289
25773	40711	2	applied	\N	\N	\N	\N	125290	125290	125291
25778	40721	0	applied	\N	\N	\N	\N	125317	125317	125318
25778	40722	1	applied	\N	\N	\N	\N	125319	125319	125320
25778	40723	2	applied	\N	\N	\N	\N	125321	125321	125322
25780	40724	0	applied	\N	\N	\N	\N	125326	125326	125327
25780	40725	1	applied	\N	\N	\N	\N	125328	125328	125329
25780	40726	2	applied	\N	\N	\N	\N	125330	125330	125331
25783	40733	0	applied	\N	\N	\N	\N	125348	125348	125349
25783	40734	1	applied	\N	\N	\N	\N	125350	125350	125351
25783	40735	2	applied	\N	\N	\N	\N	125352	125352	125353
25783	40736	3	applied	\N	\N	\N	\N	125354	125354	125355
25783	40737	4	applied	\N	\N	\N	\N	125356	125356	125357
25783	40738	5	applied	\N	\N	\N	\N	125358	125358	125359
25790	40742	0	applied	\N	\N	\N	\N	125372	125372	125373
25790	40743	1	applied	\N	\N	\N	\N	125374	125374	125375
25790	40744	2	applied	\N	\N	1000000000	\N	125376	125376	125377
25790	40745	3	applied	\N	\N	\N	\N	125380	125380	125381
25795	40749	0	applied	\N	\N	\N	\N	125395	125395	125396
25647	40487	1	applied	\N	\N	\N	\N	124648	124648	124649
25647	40488	2	applied	\N	\N	\N	\N	124650	124650	124651
25649	40486	0	applied	\N	\N	\N	\N	124646	124646	124647
25649	40487	1	applied	\N	\N	\N	\N	124648	124648	124649
25649	40488	2	applied	\N	\N	\N	\N	124650	124650	124651
25651	40489	0	applied	\N	\N	\N	\N	124654	124654	124655
25651	40491	1	applied	\N	\N	1000000000	\N	124658	124658	124659
25651	40492	2	applied	\N	\N	\N	\N	124660	124660	124663
25656	40498	0	applied	\N	\N	\N	\N	124680	124680	124681
25656	40499	1	applied	\N	\N	\N	\N	124682	124682	124683
25656	40500	3	applied	\N	\N	\N	\N	124685	124685	124686
25656	40501	4	applied	\N	\N	\N	\N	124687	124687	124688
25656	40502	5	applied	\N	\N	\N	\N	124689	124689	124690
25656	40503	6	applied	\N	\N	\N	\N	124691	124691	124692
25667	40535	0	applied	\N	\N	\N	\N	124779	124779	124780
25667	40536	1	applied	\N	\N	\N	\N	124781	124781	124782
25667	40537	2	applied	\N	\N	\N	\N	124783	124783	124784
25669	40535	0	applied	\N	\N	\N	\N	124779	124779	124780
25669	40536	1	applied	\N	\N	\N	\N	124781	124781	124782
25669	40537	2	applied	\N	\N	\N	\N	124783	124783	124784
25677	40544	0	applied	\N	\N	\N	\N	124807	124807	124808
25677	40545	1	applied	\N	\N	\N	\N	124809	124809	124810
25677	40546	2	applied	\N	\N	\N	\N	124811	124811	124812
25681	40547	0	applied	\N	\N	\N	\N	124821	124821	124822
25681	40548	1	applied	\N	\N	\N	\N	124823	124823	124824
25681	40549	2	applied	\N	\N	\N	\N	124825	124825	124826
25681	40546	3	applied	\N	\N	\N	\N	124811	124811	124812
25681	40553	4	applied	\N	\N	\N	\N	124837	124837	124838
25681	40554	5	applied	\N	\N	\N	\N	124839	124839	124830
25681	40555	6	applied	\N	\N	\N	\N	124840	124840	124841
25681	40550	7	applied	\N	\N	\N	\N	124827	124827	124842
25681	40551	8	applied	\N	\N	\N	\N	124829	124829	124843
25681	40552	9	applied	\N	\N	\N	\N	124831	124831	124844
25685	40559	0	applied	\N	\N	\N	\N	124856	124856	124857
25685	40560	1	applied	\N	\N	\N	\N	124858	124858	124859
25685	40561	2	applied	\N	\N	\N	\N	124860	124860	124861
25685	40562	3	applied	\N	\N	\N	\N	124862	124862	124863
25685	40563	4	applied	\N	\N	\N	\N	124864	124864	124865
25685	40564	5	applied	\N	\N	\N	\N	124866	124866	124867
25687	40559	0	applied	\N	\N	\N	\N	124856	124856	124857
25687	40560	1	applied	\N	\N	\N	\N	124858	124858	124859
25687	40561	2	applied	\N	\N	\N	\N	124860	124860	124861
25687	40562	3	applied	\N	\N	\N	\N	124862	124862	124863
25687	40563	4	applied	\N	\N	\N	\N	124864	124864	124865
25687	40564	5	applied	\N	\N	\N	\N	124866	124866	124867
25690	40567	0	applied	\N	\N	\N	\N	124879	124879	124880
25690	40568	1	applied	\N	\N	\N	\N	124881	124881	124882
25690	40569	2	applied	\N	\N	\N	\N	124883	124883	124884
25693	40586	0	applied	\N	\N	\N	\N	124922	124922	124923
25693	40587	1	applied	\N	\N	\N	\N	124924	124924	124925
25693	40588	2	applied	\N	\N	\N	\N	124926	124926	124927
25695	40586	0	applied	\N	\N	\N	\N	124922	124922	124923
25695	40587	1	applied	\N	\N	\N	\N	124924	124924	124925
25695	40588	2	applied	\N	\N	\N	\N	124926	124926	124927
25702	40595	0	applied	\N	\N	\N	\N	124954	124954	124955
25702	40593	1	applied	\N	\N	\N	\N	124946	124946	124949
25702	40596	2	applied	\N	\N	\N	\N	124956	124956	124957
25702	40597	3	applied	\N	\N	\N	\N	124958	124958	124959
25704	40595	0	applied	\N	\N	\N	\N	124954	124954	124955
25704	40593	1	applied	\N	\N	\N	\N	124946	124946	124949
25704	40596	2	applied	\N	\N	\N	\N	124956	124956	124957
25704	40597	3	applied	\N	\N	\N	\N	124958	124958	124959
25707	40598	0	applied	\N	\N	\N	\N	124966	124966	124967
25707	40599	1	applied	\N	\N	\N	\N	124968	124968	124969
25707	40600	2	applied	\N	\N	\N	\N	124970	124970	124971
25709	40601	0	applied	\N	\N	\N	\N	124974	124974	124975
25709	40602	1	applied	\N	\N	\N	\N	124976	124976	124977
25709	40603	2	applied	\N	\N	\N	\N	124978	124978	124979
25709	40604	3	applied	\N	\N	\N	\N	124980	124980	124981
25709	40605	4	applied	\N	\N	\N	\N	124982	124982	124983
25709	40606	5	applied	\N	\N	\N	\N	124984	124984	124985
25709	40607	6	applied	\N	\N	\N	\N	124986	124986	124987
25711	40601	0	applied	\N	\N	\N	\N	124974	124974	124975
25711	40602	1	applied	\N	\N	\N	\N	124976	124976	124977
25711	40603	2	applied	\N	\N	\N	\N	124978	124978	124979
25711	40604	3	applied	\N	\N	\N	\N	124980	124980	124981
25711	40605	4	applied	\N	\N	\N	\N	124982	124982	124983
25711	40606	5	applied	\N	\N	\N	\N	124984	124984	124985
25711	40607	6	applied	\N	\N	\N	\N	124986	124986	124987
25716	40617	0	applied	\N	\N	\N	\N	125019	125019	125020
25716	40618	1	applied	\N	\N	\N	\N	125021	125021	125022
25716	40619	2	applied	\N	\N	\N	\N	125023	125023	125024
25718	40620	0	applied	\N	\N	\N	\N	125029	125029	125030
25718	40621	1	applied	\N	\N	\N	\N	125031	125031	125032
25718	40622	2	applied	\N	\N	\N	\N	125033	125033	125034
25723	40629	0	applied	\N	\N	\N	\N	125054	125054	125055
25723	40630	1	applied	\N	\N	\N	\N	125056	125056	125057
25723	40631	2	applied	\N	\N	\N	\N	125058	125058	125059
25723	40632	3	applied	\N	\N	\N	\N	125060	125060	125061
25723	40633	4	applied	\N	\N	\N	\N	125062	125062	125063
25723	40634	5	applied	\N	\N	\N	\N	125064	125064	125065
25726	40641	0	applied	\N	\N	\N	\N	125083	125083	125084
25726	40642	1	applied	\N	\N	\N	\N	125085	125085	125086
25726	40643	2	applied	\N	\N	\N	\N	125087	125087	125088
25726	40644	3	applied	\N	\N	\N	\N	125089	125089	125090
25726	40645	4	applied	\N	\N	\N	\N	125091	125091	125092
25726	40646	5	applied	\N	\N	\N	\N	125093	125093	125094
25729	40650	0	applied	\N	\N	\N	\N	125105	125105	125106
25729	40651	1	applied	\N	\N	\N	\N	125107	125107	125108
25729	40652	2	applied	\N	\N	\N	\N	125109	125109	125110
25729	40653	3	applied	\N	\N	\N	\N	125111	125111	125112
25729	40654	4	applied	\N	\N	\N	\N	125113	125113	125114
25729	40655	5	applied	\N	\N	\N	\N	125115	125115	125116
25729	40656	6	applied	\N	\N	\N	\N	125117	125117	125118
25729	40657	7	applied	\N	\N	\N	\N	125119	125119	125120
25729	40658	8	applied	\N	\N	\N	\N	125121	125121	125122
25734	40665	0	applied	\N	\N	\N	\N	125140	125140	125141
25734	40666	1	applied	\N	\N	\N	\N	125142	125142	125143
25734	40667	2	applied	\N	\N	\N	\N	125144	125144	125145
25734	40668	3	applied	\N	\N	\N	\N	125146	125146	125147
25734	40669	4	applied	\N	\N	\N	\N	125148	125148	125149
25734	40670	5	applied	\N	\N	\N	\N	125150	125150	125151
25736	40665	0	applied	\N	\N	\N	\N	125140	125140	125141
25736	40666	1	applied	\N	\N	\N	\N	125142	125142	125143
25736	40667	2	applied	\N	\N	\N	\N	125144	125144	125145
25736	40668	3	applied	\N	\N	\N	\N	125146	125146	125147
25736	40669	4	applied	\N	\N	\N	\N	125148	125148	125149
25736	40670	5	applied	\N	\N	\N	\N	125150	125150	125151
25745	40677	0	applied	\N	\N	\N	\N	125181	125181	125182
25745	40678	2	applied	\N	\N	\N	\N	125184	125184	125185
25680	40549	2	applied	\N	\N	\N	\N	124825	124825	124826
25680	40550	3	applied	\N	\N	\N	\N	124827	124827	124828
25680	40551	4	applied	\N	\N	\N	\N	124829	124829	124830
25680	40552	5	applied	\N	\N	\N	\N	124831	124831	124832
25686	40559	0	applied	\N	\N	\N	\N	124856	124856	124857
25686	40560	1	applied	\N	\N	\N	\N	124858	124858	124859
25686	40561	2	applied	\N	\N	\N	\N	124860	124860	124861
25686	40562	3	applied	\N	\N	\N	\N	124862	124862	124863
25686	40563	4	applied	\N	\N	\N	\N	124864	124864	124865
25686	40564	5	applied	\N	\N	\N	\N	124866	124866	124867
25691	40570	0	applied	\N	\N	\N	\N	124887	124887	124888
25691	40571	1	applied	\N	\N	\N	\N	124889	124889	124890
25691	40572	2	applied	\N	\N	\N	\N	124891	124891	124892
25691	40573	3	applied	\N	\N	\N	\N	124893	124893	124894
25691	40574	4	applied	\N	\N	\N	\N	124895	124895	124896
25691	40575	5	applied	\N	\N	\N	\N	124897	124897	124898
25692	40576	0	applied	\N	\N	\N	\N	124901	124901	124902
25692	40577	1	applied	\N	\N	\N	\N	124903	124903	124904
25692	40578	2	applied	\N	\N	\N	\N	124905	124905	124906
25692	40579	3	applied	\N	\N	\N	\N	124907	124907	124908
25692	40580	4	applied	\N	\N	\N	\N	124909	124909	124910
25692	40581	5	applied	\N	\N	\N	\N	124911	124911	124912
25692	40582	6	applied	\N	\N	\N	\N	124913	124913	124914
25692	40583	7	applied	\N	\N	\N	\N	124915	124915	124916
25692	40584	8	applied	\N	\N	\N	\N	124917	124917	124918
25692	40585	9	applied	\N	\N	\N	\N	124919	124919	124920
25694	40586	0	applied	\N	\N	\N	\N	124922	124922	124923
25694	40587	1	applied	\N	\N	\N	\N	124924	124924	124925
25694	40588	2	applied	\N	\N	\N	\N	124926	124926	124927
25705	40598	0	applied	\N	\N	\N	\N	124966	124966	124967
25705	40599	1	applied	\N	\N	\N	\N	124968	124968	124969
25705	40600	2	applied	\N	\N	\N	\N	124970	124970	124971
25710	40601	0	applied	\N	\N	\N	\N	124974	124974	124975
25710	40602	1	applied	\N	\N	\N	\N	124976	124976	124977
25710	40603	2	applied	\N	\N	\N	\N	124978	124978	124979
25710	40604	3	applied	\N	\N	\N	\N	124980	124980	124981
25710	40605	4	applied	\N	\N	\N	\N	124982	124982	124983
25710	40606	5	applied	\N	\N	\N	\N	124984	124984	124985
25710	40607	6	applied	\N	\N	\N	\N	124986	124986	124987
25717	40617	0	applied	\N	\N	\N	\N	125019	125019	125020
25717	40618	1	applied	\N	\N	\N	\N	125021	125021	125022
25717	40619	2	applied	\N	\N	\N	\N	125023	125023	125024
25719	40620	0	applied	\N	\N	\N	\N	125029	125029	125030
25719	40621	1	applied	\N	\N	\N	\N	125031	125031	125032
25719	40622	2	applied	\N	\N	\N	\N	125033	125033	125034
25722	40629	0	applied	\N	\N	\N	\N	125054	125054	125055
25722	40630	1	applied	\N	\N	\N	\N	125056	125056	125057
25722	40631	2	applied	\N	\N	\N	\N	125058	125058	125059
25722	40632	3	applied	\N	\N	\N	\N	125060	125060	125061
25722	40633	4	applied	\N	\N	\N	\N	125062	125062	125063
25722	40634	5	applied	\N	\N	\N	\N	125064	125064	125065
25735	40665	0	applied	\N	\N	\N	\N	125140	125140	125141
25735	40666	1	applied	\N	\N	\N	\N	125142	125142	125143
25735	40667	2	applied	\N	\N	\N	\N	125144	125144	125145
25735	40668	3	applied	\N	\N	\N	\N	125146	125146	125147
25735	40669	4	applied	\N	\N	\N	\N	125148	125148	125149
25735	40670	5	applied	\N	\N	\N	\N	125150	125150	125151
25740	40671	0	applied	\N	\N	\N	\N	125158	125158	125159
25740	40672	1	applied	\N	\N	\N	\N	125160	125160	125161
25740	40673	2	applied	\N	\N	\N	\N	125162	125162	125163
25740	40674	3	applied	\N	\N	\N	\N	125164	125164	13107
25740	40675	4	applied	\N	\N	\N	\N	125165	125165	125165
25744	40677	0	applied	\N	\N	\N	\N	125181	125181	125182
25744	40678	2	applied	\N	\N	\N	\N	125184	125184	125185
25744	40676	3	applied	\N	\N	\N	\N	125176	125176	125186
25746	40404	0	applied	\N	\N	\N	\N	124405	124405	124406
25746	40674	1	applied	\N	\N	\N	\N	125164	125164	13107
25746	40675	2	applied	\N	\N	\N	\N	125165	125165	125165
25746	40583	3	applied	\N	\N	\N	\N	124915	124915	124962
25753	40688	0	applied	\N	\N	\N	\N	125216	125216	125217
25753	40689	1	applied	\N	\N	\N	\N	125218	125218	125219
25753	40690	2	applied	\N	\N	\N	\N	125220	125220	125221
25755	40691	0	applied	\N	\N	\N	\N	125225	125225	125226
25755	40692	1	applied	\N	\N	\N	\N	125227	125227	125228
25755	40693	2	applied	\N	\N	\N	\N	125229	125229	125230
25759	40694	0	applied	\N	\N	\N	\N	125233	125233	125234
25759	40696	1	applied	\N	\N	\N	\N	125237	125237	125241
25759	40695	2	applied	\N	\N	\N	\N	125235	125235	125238
25762	40697	0	applied	\N	\N	\N	\N	125245	125245	125246
25762	40698	1	applied	\N	\N	\N	\N	125247	125247	125248
25762	40699	2	applied	\N	\N	\N	\N	125249	125249	125250
25766	40703	0	applied	\N	\N	\N	\N	125263	125263	125264
25766	40704	1	applied	\N	\N	\N	\N	125265	125265	125266
25766	40705	2	applied	\N	\N	\N	\N	125267	125267	125268
25768	40686	0	applied	\N	\N	\N	\N	125211	125211	120198
25770	40706	0	applied	\N	\N	\N	\N	125277	125277	125278
25770	40707	1	applied	\N	\N	\N	\N	125279	125279	125280
25770	40708	2	applied	\N	\N	\N	\N	125281	125281	125282
25775	40715	0	applied	\N	\N	\N	\N	125302	125302	125303
25775	40716	1	applied	\N	\N	\N	\N	125304	125304	125305
25775	40717	2	applied	\N	\N	\N	\N	125306	125306	125307
25775	40718	3	applied	\N	\N	\N	\N	125308	125308	125309
25775	40719	4	applied	\N	\N	\N	\N	125310	125310	125311
25775	40720	5	applied	\N	\N	\N	\N	125312	125312	125313
25777	40404	0	applied	\N	\N	\N	\N	124405	124405	124406
25777	40674	1	applied	\N	\N	\N	\N	125164	125164	13107
25777	40675	2	applied	\N	\N	\N	\N	125165	125165	125165
25777	40686	3	applied	\N	\N	\N	\N	125211	125211	120198
25777	40583	4	applied	\N	\N	\N	\N	124915	124915	124962
25787	40739	0	applied	\N	\N	\N	\N	125364	125364	125365
25787	40740	1	applied	\N	\N	\N	\N	125366	125366	125367
25787	40741	2	applied	\N	\N	\N	\N	125368	125368	125369
25792	40742	0	applied	\N	\N	\N	\N	125372	125372	125373
25792	40743	1	applied	\N	\N	\N	\N	125374	125374	125375
25792	40744	2	applied	\N	\N	1000000000	\N	125376	125376	125377
25792	40745	3	applied	\N	\N	\N	\N	125380	125380	125381
25800	40766	0	applied	\N	\N	\N	\N	125434	125434	125435
25800	40767	1	applied	\N	\N	\N	\N	125436	125436	125437
25801	40768	0	applied	\N	\N	\N	\N	125446	125446	125447
25801	40769	1	applied	\N	\N	\N	\N	125448	125448	125449
25801	40770	2	applied	\N	\N	\N	\N	125450	125450	125451
25808	40780	0	applied	\N	\N	\N	\N	125478	125478	125479
25808	40781	1	applied	\N	\N	\N	\N	125480	125480	125481
25808	40782	2	applied	\N	\N	\N	\N	125482	125482	125483
25808	40783	3	applied	\N	\N	\N	\N	125484	125484	125485
25811	40784	0	applied	\N	\N	\N	\N	125490	125490	125491
25811	40785	1	applied	\N	\N	\N	\N	125492	125492	125493
25811	40786	2	applied	\N	\N	\N	\N	125494	125494	125495
25816	40793	0	applied	\N	\N	\N	\N	125516	125516	125517
25816	40794	1	applied	\N	\N	\N	\N	125518	125518	125519
25724	40637	2	applied	\N	\N	\N	\N	125073	125073	125074
25727	40647	0	applied	\N	\N	\N	\N	125097	125097	125098
25727	40648	1	applied	\N	\N	\N	\N	125099	125099	125100
25727	40649	2	applied	\N	\N	\N	\N	125101	125101	125102
25730	40659	0	applied	\N	\N	\N	\N	125125	125125	125126
25730	40660	1	applied	\N	\N	\N	\N	125127	125127	125128
25730	40661	2	applied	\N	\N	\N	\N	125129	125129	125130
25732	40659	0	applied	\N	\N	\N	\N	125125	125125	125126
25732	40660	1	applied	\N	\N	\N	\N	125127	125127	125128
25732	40661	2	applied	\N	\N	\N	\N	125129	125129	125130
25737	40671	0	applied	\N	\N	\N	\N	125158	125158	125159
25737	40672	1	applied	\N	\N	\N	\N	125160	125160	125161
25737	40673	2	applied	\N	\N	\N	\N	125162	125162	125163
25737	40674	3	applied	\N	\N	\N	\N	125164	125164	13107
25737	40675	4	applied	\N	\N	\N	\N	125165	125165	125165
25739	40672	0	applied	\N	\N	\N	\N	125160	125160	125161
25739	40674	1	applied	\N	\N	\N	\N	125164	125164	13107
25739	40675	2	applied	\N	\N	\N	\N	125165	125165	125165
25741	40671	0	applied	\N	\N	\N	\N	125158	125158	125159
25741	40672	1	applied	\N	\N	\N	\N	125160	125160	125161
25741	40673	2	applied	\N	\N	\N	\N	125162	125162	125163
25741	40674	3	applied	\N	\N	\N	\N	125164	125164	13107
25741	40675	4	applied	\N	\N	\N	\N	125165	125165	125165
25743	40676	0	applied	\N	\N	\N	\N	125176	125176	125177
25748	40677	0	applied	\N	\N	\N	\N	125181	125181	125182
25748	40679	1	applied	\N	\N	\N	\N	125192	125192	125193
25748	40678	2	applied	\N	\N	\N	\N	125184	125184	125186
25748	40680	3	applied	\N	\N	\N	\N	125194	125194	125195
25748	40681	4	applied	\N	\N	\N	\N	125196	125196	125197
25750	40684	0	applied	\N	\N	\N	\N	125207	125207	125208
25750	40685	1	applied	\N	\N	\N	\N	125209	125209	125210
25750	40686	2	applied	\N	\N	\N	\N	125211	125211	120198
25750	40687	3	applied	\N	\N	\N	\N	125212	125212	125213
25752	40688	0	applied	\N	\N	\N	\N	125216	125216	125217
25752	40689	1	applied	\N	\N	\N	\N	125218	125218	125219
25752	40690	2	applied	\N	\N	\N	\N	125220	125220	125221
25754	40688	0	applied	\N	\N	\N	\N	125216	125216	125217
25754	40689	1	applied	\N	\N	\N	\N	125218	125218	125219
25754	40690	2	applied	\N	\N	\N	\N	125220	125220	125221
25757	40691	0	applied	\N	\N	\N	\N	125225	125225	125226
25757	40694	1	applied	\N	\N	\N	\N	125233	125233	125234
25757	40692	2	applied	\N	\N	\N	\N	125227	125227	125228
25757	40696	3	applied	\N	\N	\N	\N	125237	125237	125240
25757	40693	4	applied	\N	\N	\N	\N	125229	125229	125241
25757	40695	5	applied	\N	\N	\N	\N	125235	125235	125238
25761	40697	0	applied	\N	\N	\N	\N	125245	125245	125246
25761	40698	1	applied	\N	\N	\N	\N	125247	125247	125248
25761	40699	2	applied	\N	\N	\N	\N	125249	125249	125250
25772	40709	0	applied	\N	\N	\N	\N	125286	125286	125287
25772	40710	1	applied	\N	\N	\N	\N	125288	125288	125289
25772	40711	2	applied	\N	\N	\N	\N	125290	125290	125291
25774	40712	0	applied	\N	\N	\N	\N	125294	125294	125295
25774	40713	1	applied	\N	\N	\N	\N	125296	125296	125297
25774	40714	2	applied	\N	\N	\N	\N	125298	125298	125299
25779	40721	0	applied	\N	\N	\N	\N	125317	125317	125318
25779	40722	1	applied	\N	\N	\N	\N	125319	125319	125320
25779	40723	2	applied	\N	\N	\N	\N	125321	125321	125322
25782	40733	0	applied	\N	\N	\N	\N	125348	125348	125349
25782	40734	1	applied	\N	\N	\N	\N	125350	125350	125351
25782	40735	2	applied	\N	\N	\N	\N	125352	125352	125353
25782	40736	3	applied	\N	\N	\N	\N	125354	125354	125355
25782	40737	4	applied	\N	\N	\N	\N	125356	125356	125357
25782	40738	5	applied	\N	\N	\N	\N	125358	125358	125359
25785	40733	0	applied	\N	\N	\N	\N	125348	125348	125349
25785	40734	1	applied	\N	\N	\N	\N	125350	125350	125351
25785	40735	2	applied	\N	\N	\N	\N	125352	125352	125353
25785	40736	3	applied	\N	\N	\N	\N	125354	125354	125355
25785	40737	4	applied	\N	\N	\N	\N	125356	125356	125357
25785	40738	5	applied	\N	\N	\N	\N	125358	125358	125359
25789	40742	0	applied	\N	\N	\N	\N	125372	125372	125373
25789	40743	1	applied	\N	\N	\N	\N	125374	125374	125375
25789	40744	2	applied	\N	\N	1000000000	\N	125376	125376	125377
25789	40745	3	applied	\N	\N	\N	\N	125380	125380	125381
25791	40743	0	applied	\N	\N	\N	\N	125374	125374	125375
25791	40744	1	applied	\N	\N	1000000000	\N	125376	125376	125377
25793	40746	0	applied	\N	\N	\N	\N	125388	125388	125389
25793	40747	1	applied	\N	\N	\N	\N	125390	125390	125391
25793	40745	2	applied	\N	\N	\N	\N	125380	125380	125392
25793	40748	3	applied	\N	\N	\N	\N	125393	125393	125394
25794	40749	0	applied	\N	\N	\N	\N	125395	125395	125396
25794	40750	1	applied	\N	\N	\N	\N	125397	125397	125398
25794	40751	2	applied	\N	\N	\N	\N	125399	125399	125400
25794	40752	3	applied	\N	\N	\N	\N	125401	125401	125402
25794	40753	4	applied	\N	\N	\N	\N	125403	125403	125404
25794	40754	5	applied	\N	\N	\N	\N	125405	125405	125406
25794	40755	6	applied	\N	\N	\N	\N	125407	125407	125408
25794	40756	7	applied	\N	\N	\N	\N	125409	125409	125410
25794	40757	8	applied	\N	\N	\N	\N	125411	125411	125412
25794	40758	9	applied	\N	\N	\N	\N	125413	125413	125414
25794	40759	10	applied	\N	\N	\N	\N	125415	125415	125416
25794	40760	11	applied	\N	\N	\N	\N	125417	125417	125418
25794	40761	12	applied	\N	\N	\N	\N	125419	125419	125420
25794	40762	13	applied	\N	\N	\N	\N	125421	125421	125422
25794	40763	15	applied	\N	\N	\N	\N	125424	125424	125377
25794	40764	16	applied	\N	\N	\N	\N	125425	125425	125426
25794	40765	17	applied	\N	\N	\N	\N	125427	125427	125428
25797	40766	0	applied	\N	\N	\N	\N	125434	125434	125435
25797	40767	1	applied	\N	\N	\N	\N	125436	125436	125437
25799	40766	0	applied	\N	\N	\N	\N	125434	125434	125435
25799	40767	1	applied	\N	\N	\N	\N	125436	125436	125437
25803	40771	0	applied	\N	\N	\N	\N	125452	125452	125453
25803	40772	1	applied	\N	\N	\N	\N	125454	125454	125455
25803	40773	2	applied	\N	\N	\N	\N	125456	125456	125457
25805	40771	0	applied	\N	\N	\N	\N	125452	125452	125453
25805	40772	1	applied	\N	\N	\N	\N	125454	125454	125455
25805	40773	2	applied	\N	\N	\N	\N	125456	125456	125457
25810	40784	0	applied	\N	\N	\N	\N	125490	125490	125491
25810	40785	1	applied	\N	\N	\N	\N	125492	125492	125493
25810	40786	2	applied	\N	\N	\N	\N	125494	125494	125495
25812	40787	0	applied	\N	\N	\N	\N	125500	125500	125501
25812	40788	1	applied	\N	\N	\N	\N	125502	125502	125503
25812	40789	2	applied	\N	\N	\N	\N	125504	125504	125505
25814	40790	0	applied	\N	\N	\N	\N	125508	125508	125509
25814	40791	1	applied	\N	\N	\N	\N	125510	125510	125511
25814	40792	2	applied	\N	\N	\N	\N	125512	125512	125513
25815	40793	0	applied	\N	\N	\N	\N	125516	125516	125517
25815	40794	1	applied	\N	\N	\N	\N	125518	125518	125519
25815	40795	2	applied	\N	\N	\N	\N	125520	125520	125521
25815	40796	3	applied	\N	\N	\N	\N	125522	125522	125523
25745	40676	3	applied	\N	\N	\N	\N	125176	125176	125186
25747	40677	0	applied	\N	\N	\N	\N	125181	125181	125182
25747	40679	1	applied	\N	\N	\N	\N	125192	125192	125193
25747	40678	2	applied	\N	\N	\N	\N	125184	125184	125186
25747	40680	3	applied	\N	\N	\N	\N	125194	125194	125195
25747	40681	4	applied	\N	\N	\N	\N	125196	125196	125197
25749	40682	0	applied	\N	\N	\N	\N	125202	125202	125203
25749	40683	1	applied	\N	\N	\N	\N	125204	125204	125205
25756	40694	0	applied	\N	\N	\N	\N	125233	125233	125234
25756	40695	1	applied	\N	\N	\N	\N	125235	125235	125236
25756	40696	2	applied	\N	\N	\N	\N	125237	125237	125238
25758	40694	0	applied	\N	\N	\N	\N	125233	125233	125234
25758	40695	1	applied	\N	\N	\N	\N	125235	125235	125236
25758	40696	2	applied	\N	\N	\N	\N	125237	125237	125238
25760	40694	0	applied	\N	\N	\N	\N	125233	125233	125234
25760	40695	1	applied	\N	\N	\N	\N	125235	125235	125236
25760	40696	2	applied	\N	\N	\N	\N	125237	125237	125238
25765	40686	0	applied	\N	\N	\N	\N	125211	125211	120198
25767	40703	0	applied	\N	\N	\N	\N	125263	125263	125264
25767	40704	1	applied	\N	\N	\N	\N	125265	125265	125266
25767	40705	2	applied	\N	\N	\N	\N	125267	125267	125268
25769	40703	0	applied	\N	\N	\N	\N	125263	125263	125264
25769	40704	1	applied	\N	\N	\N	\N	125265	125265	125266
25769	40705	2	applied	\N	\N	\N	\N	125267	125267	125268
25771	40700	0	applied	\N	\N	\N	\N	125255	125255	125256
25771	40703	1	applied	\N	\N	\N	\N	125263	125263	125264
25771	40706	2	applied	\N	\N	\N	\N	125277	125277	125278
25771	40701	3	applied	\N	\N	\N	\N	125257	125257	125258
25771	40702	4	applied	\N	\N	\N	\N	125259	125259	125260
25771	40704	5	applied	\N	\N	\N	\N	125265	125265	125266
25771	40708	6	applied	\N	\N	\N	\N	125281	125281	125284
25771	40705	7	applied	\N	\N	\N	\N	125267	125267	125285
25771	40707	8	applied	\N	\N	\N	\N	125279	125279	125282
25776	40715	0	applied	\N	\N	\N	\N	125302	125302	125303
25776	40716	1	applied	\N	\N	\N	\N	125304	125304	125305
25776	40717	2	applied	\N	\N	\N	\N	125306	125306	125307
25776	40718	3	applied	\N	\N	\N	\N	125308	125308	125309
25776	40719	4	applied	\N	\N	\N	\N	125310	125310	125311
25776	40720	5	applied	\N	\N	\N	\N	125312	125312	125313
25781	40727	0	applied	\N	\N	\N	\N	125334	125334	125335
25781	40728	1	applied	\N	\N	\N	\N	125336	125336	125337
25781	40729	2	applied	\N	\N	\N	\N	125338	125338	125339
25781	40730	3	applied	\N	\N	\N	\N	125340	125340	125341
25781	40731	4	applied	\N	\N	\N	\N	125342	125342	125343
25781	40732	5	applied	\N	\N	\N	\N	125344	125344	125345
25784	40733	0	applied	\N	\N	\N	\N	125348	125348	125349
25784	40734	1	applied	\N	\N	\N	\N	125350	125350	125351
25784	40735	2	applied	\N	\N	\N	\N	125352	125352	125353
25784	40736	3	applied	\N	\N	\N	\N	125354	125354	125355
25784	40737	4	applied	\N	\N	\N	\N	125356	125356	125357
25784	40738	5	applied	\N	\N	\N	\N	125358	125358	125359
25786	40739	0	applied	\N	\N	\N	\N	125364	125364	125365
25786	40740	1	applied	\N	\N	\N	\N	125366	125366	125367
25786	40741	2	applied	\N	\N	\N	\N	125368	125368	125369
25788	40742	0	applied	\N	\N	\N	\N	125372	125372	125373
25788	40743	1	applied	\N	\N	\N	\N	125374	125374	125375
25788	40744	2	applied	\N	\N	1000000000	\N	125376	125376	125377
25796	40766	0	applied	\N	\N	\N	\N	125434	125434	125435
25796	40767	1	applied	\N	\N	\N	\N	125436	125436	125437
25819	40793	0	applied	\N	\N	\N	\N	125516	125516	125517
25819	40794	1	applied	\N	\N	\N	\N	125518	125518	125519
25819	40799	2	applied	\N	\N	\N	\N	125533	125533	125534
25819	40800	3	applied	\N	\N	\N	\N	125535	125535	125536
25819	40795	4	applied	\N	\N	\N	\N	125520	125520	125521
25819	40796	5	applied	\N	\N	\N	\N	125522	125522	125523
25819	40801	6	applied	\N	\N	\N	\N	125537	125537	125538
25819	40802	7	applied	\N	\N	\N	\N	125539	125539	125540
25819	40797	8	applied	\N	\N	\N	\N	125524	125524	125541
25819	40798	9	applied	\N	\N	\N	\N	125526	125526	125542
25819	40803	10	applied	\N	\N	\N	\N	125543	125543	125544
25819	40804	11	applied	\N	\N	\N	\N	125545	125545	125546
25827	40826	0	applied	\N	\N	\N	\N	125600	125600	125601
25827	40827	1	applied	\N	\N	\N	\N	125602	125602	125603
25827	40828	2	applied	\N	\N	\N	\N	125604	125604	125605
25832	40839	0	applied	\N	\N	\N	\N	125635	125635	125636
25832	40840	1	applied	\N	\N	\N	\N	125637	125637	125638
25832	40841	2	applied	\N	\N	\N	\N	125639	125639	125640
25832	40842	3	applied	\N	\N	\N	\N	125641	125641	125642
25834	40839	0	applied	\N	\N	\N	\N	125635	125635	125636
25834	40840	1	applied	\N	\N	\N	\N	125637	125637	125638
25834	40841	2	applied	\N	\N	\N	\N	125639	125639	125640
25834	40842	3	applied	\N	\N	\N	\N	125641	125641	125642
25836	40843	0	applied	\N	\N	\N	\N	125650	125650	125651
25836	40844	1	applied	\N	\N	\N	\N	125652	125652	125653
25836	40845	2	applied	\N	\N	\N	\N	125654	125654	125655
25845	40854	0	applied	\N	\N	\N	\N	125682	125682	125683
25845	40855	1	applied	\N	\N	\N	\N	125684	125684	125685
25848	40854	0	applied	\N	\N	\N	\N	125682	125682	125683
25848	40855	1	applied	\N	\N	\N	\N	125684	125684	125685
25850	40862	0	applied	\N	\N	\N	\N	125706	125706	125707
25850	40863	1	applied	\N	\N	\N	\N	125708	125708	125709
25850	40864	2	applied	\N	\N	\N	\N	125710	125710	125711
25850	40865	3	applied	\N	\N	\N	\N	125712	125712	125713
25850	40866	4	applied	\N	\N	\N	\N	125714	125714	125715
25850	40867	5	applied	\N	\N	\N	\N	125716	125716	125716
25850	40868	6	applied	\N	\N	\N	\N	125717	125717	125718
25850	40869	7	applied	\N	\N	\N	\N	125719	125719	125720
25850	40870	8	applied	\N	\N	\N	\N	125721	125721	125722
25850	40871	9	applied	\N	\N	\N	\N	125723	125723	125724
25853	40878	0	applied	\N	\N	\N	\N	125741	125741	125742
25853	40879	1	applied	\N	\N	\N	\N	125743	125743	125744
25853	40880	2	applied	\N	\N	\N	\N	125745	125745	125746
25856	40881	0	applied	\N	\N	\N	\N	125749	125749	125750
25856	40882	1	applied	\N	\N	\N	\N	125751	125751	125752
25856	40883	2	applied	\N	\N	\N	\N	125753	125753	125754
25860	40884	0	applied	\N	\N	\N	\N	125756	125756	125757
25860	40887	1	applied	\N	\N	\N	\N	125764	125764	125765
25860	40888	2	applied	\N	\N	\N	\N	125766	125766	125767
25860	40885	3	applied	\N	\N	\N	\N	125758	125758	125761
25860	40889	4	applied	\N	\N	\N	\N	125768	125768	125769
25860	40890	5	applied	\N	\N	\N	\N	125770	125770	125771
25860	40891	6	applied	\N	\N	\N	\N	125772	125772	125773
25860	40892	7	applied	\N	\N	\N	\N	125774	125774	125775
25862	40884	0	applied	\N	\N	\N	\N	125756	125756	125757
25862	40887	1	applied	\N	\N	\N	\N	125764	125764	125765
25862	40888	2	applied	\N	\N	\N	\N	125766	125766	125767
25862	40885	3	applied	\N	\N	\N	\N	125758	125758	125761
25862	40889	4	applied	\N	\N	\N	\N	125768	125768	125769
25862	40890	5	applied	\N	\N	\N	\N	125770	125770	125771
25862	40891	6	applied	\N	\N	\N	\N	125772	125772	125773
25795	40750	1	applied	\N	\N	\N	\N	125397	125397	125398
25795	40751	2	applied	\N	\N	\N	\N	125399	125399	125400
25795	40752	3	applied	\N	\N	\N	\N	125401	125401	125402
25795	40753	4	applied	\N	\N	\N	\N	125403	125403	125404
25795	40754	5	applied	\N	\N	\N	\N	125405	125405	125406
25795	40755	6	applied	\N	\N	\N	\N	125407	125407	125408
25795	40756	7	applied	\N	\N	\N	\N	125409	125409	125410
25795	40757	8	applied	\N	\N	\N	\N	125411	125411	125412
25795	40758	9	applied	\N	\N	\N	\N	125413	125413	125414
25795	40759	10	applied	\N	\N	\N	\N	125415	125415	125416
25795	40760	11	applied	\N	\N	\N	\N	125417	125417	125418
25795	40761	12	applied	\N	\N	\N	\N	125419	125419	125420
25795	40762	13	applied	\N	\N	\N	\N	125421	125421	125422
25795	40763	15	applied	\N	\N	\N	\N	125424	125424	125377
25795	40764	16	applied	\N	\N	\N	\N	125425	125425	125426
25795	40765	17	applied	\N	\N	\N	\N	125427	125427	125428
25798	40766	0	applied	\N	\N	\N	\N	125434	125434	125435
25798	40767	1	applied	\N	\N	\N	\N	125436	125436	125437
25802	40771	0	applied	\N	\N	\N	\N	125452	125452	125453
25802	40772	1	applied	\N	\N	\N	\N	125454	125454	125455
25802	40773	2	applied	\N	\N	\N	\N	125456	125456	125457
25804	40771	0	applied	\N	\N	\N	\N	125452	125452	125453
25804	40772	1	applied	\N	\N	\N	\N	125454	125454	125455
25804	40773	2	applied	\N	\N	\N	\N	125456	125456	125457
25806	40774	0	applied	\N	\N	\N	\N	125462	125462	125463
25806	40775	1	applied	\N	\N	\N	\N	125464	125464	125465
25806	40776	2	applied	\N	\N	\N	\N	125466	125466	125467
25806	40777	3	applied	\N	\N	\N	\N	125468	125468	125469
25806	40778	4	applied	\N	\N	\N	\N	125470	125470	125471
25806	40779	5	applied	\N	\N	\N	\N	125472	125472	125473
25807	40774	0	applied	\N	\N	\N	\N	125462	125462	125463
25807	40775	1	applied	\N	\N	\N	\N	125464	125464	125465
25807	40776	2	applied	\N	\N	\N	\N	125466	125466	125467
25807	40777	3	applied	\N	\N	\N	\N	125468	125468	125469
25807	40778	4	applied	\N	\N	\N	\N	125470	125470	125471
25807	40779	5	applied	\N	\N	\N	\N	125472	125472	125473
25809	40780	0	applied	\N	\N	\N	\N	125478	125478	125479
25809	40781	1	applied	\N	\N	\N	\N	125480	125480	125481
25809	40782	2	applied	\N	\N	\N	\N	125482	125482	125483
25809	40783	3	applied	\N	\N	\N	\N	125484	125484	125485
25813	40787	0	applied	\N	\N	\N	\N	125500	125500	125501
25813	40788	1	applied	\N	\N	\N	\N	125502	125502	125503
25813	40789	2	applied	\N	\N	\N	\N	125504	125504	125505
25821	40807	0	applied	\N	\N	\N	\N	125554	125554	125555
25821	40808	1	applied	\N	\N	\N	\N	125556	125556	125557
25821	40809	2	applied	\N	\N	\N	\N	125558	125558	125559
25821	40810	3	applied	\N	\N	\N	\N	125560	125560	125561
25821	40811	4	applied	\N	\N	\N	\N	125562	125562	125563
25821	40812	5	applied	\N	\N	\N	\N	125564	125564	125565
25821	40813	6	applied	\N	\N	\N	\N	125566	125566	125567
25824	40814	0	applied	\N	\N	\N	\N	125571	125571	125572
25824	40815	1	applied	\N	\N	\N	\N	125573	125573	125574
25824	40816	2	applied	\N	\N	\N	\N	125575	125575	125576
25824	40817	3	applied	\N	\N	\N	\N	125577	125577	125578
25824	40818	4	applied	\N	\N	\N	\N	125579	125579	125580
25824	40819	5	applied	\N	\N	\N	\N	125581	125581	125582
25824	40820	6	applied	\N	\N	\N	\N	125583	125583	125584
25824	40821	7	applied	\N	\N	\N	\N	125585	125585	125586
25824	40822	8	applied	\N	\N	\N	\N	125587	125587	125588
25826	40823	0	applied	\N	\N	\N	\N	125593	125593	125594
25826	40824	1	applied	\N	\N	\N	\N	125595	125595	125596
25826	40825	2	applied	\N	\N	\N	\N	125597	125597	125598
25829	40829	0	applied	\N	\N	\N	\N	125608	125608	125609
25829	40830	1	applied	\N	\N	\N	\N	125610	125610	125611
25829	40831	2	applied	\N	\N	1000000000	\N	125612	125612	125613
25829	40832	3	applied	\N	\N	\N	\N	125614	125614	125615
25829	40833	4	applied	\N	\N	\N	\N	125616	125616	125617
25829	40834	5	applied	\N	\N	\N	\N	125618	125618	125619
25829	40835	6	applied	\N	\N	\N	\N	125620	125620	125621
25831	40836	0	applied	\N	\N	\N	\N	125625	125625	125626
25831	40837	1	applied	\N	\N	\N	\N	125627	125627	125628
25831	40838	2	applied	\N	\N	\N	\N	125629	125629	125630
25838	40843	0	applied	\N	\N	\N	\N	125650	125650	125651
25838	40844	1	applied	\N	\N	\N	\N	125652	125652	125653
25838	40845	2	applied	\N	\N	\N	\N	125654	125654	125655
25840	40846	0	applied	\N	\N	\N	\N	125662	125662	125663
25840	40847	1	applied	\N	\N	\N	\N	125664	125664	125665
25840	40848	2	applied	\N	\N	\N	\N	125666	125666	125667
25840	40849	3	applied	\N	\N	\N	\N	125668	125668	125669
25847	40854	0	applied	\N	\N	\N	\N	125682	125682	125683
25847	40855	1	applied	\N	\N	\N	\N	125684	125684	125685
25849	40856	0	applied	\N	\N	\N	\N	125692	125692	125693
25849	40857	1	applied	\N	\N	\N	\N	125694	125694	125695
25849	40858	2	applied	\N	\N	\N	\N	125696	125696	125697
25849	40859	3	applied	\N	\N	\N	\N	125698	125698	125699
25849	40860	4	applied	\N	\N	\N	\N	125700	125700	125701
25849	40861	5	applied	\N	\N	\N	\N	125702	125702	125703
25855	40881	0	applied	\N	\N	\N	\N	125749	125749	125750
25855	40882	1	applied	\N	\N	\N	\N	125751	125751	125752
25855	40883	2	applied	\N	\N	\N	\N	125753	125753	125754
25859	40886	0	applied	\N	\N	\N	\N	125760	125760	125762
25866	40896	0	applied	\N	\N	\N	\N	125789	125789	125790
25866	40897	1	applied	\N	\N	\N	\N	125791	125791	125792
25866	40898	2	applied	\N	\N	\N	\N	125831	125831	125832
25866	40899	3	applied	\N	\N	\N	\N	125833	125833	125834
25866	40900	4	applied	\N	\N	\N	\N	125835	125835	125836
25866	40901	5	applied	\N	\N	\N	\N	125837	125837	125838
25871	40902	0	applied	\N	\N	\N	\N	125840	125840	125841
25871	40903	1	applied	\N	\N	\N	\N	125842	125842	125843
25871	40904	2	applied	\N	\N	\N	\N	125844	125844	125845
25873	40905	0	applied	\N	\N	\N	\N	125855	125855	125856
25873	40906	1	applied	\N	\N	\N	\N	125857	125857	125858
25873	40907	2	applied	\N	\N	\N	\N	125859	125859	125860
25873	40908	3	applied	\N	\N	\N	\N	125861	125861	125862
25873	40909	4	applied	\N	\N	\N	\N	125863	125863	125864
25873	40910	5	applied	\N	\N	\N	\N	125865	125865	125866
25880	40917	0	applied	\N	\N	\N	\N	125887	125887	125888
25880	40918	1	applied	\N	\N	\N	\N	125889	125889	125890
25882	40919	0	applied	\N	\N	\N	\N	125894	125894	125895
25882	40920	1	applied	\N	\N	\N	\N	125896	125896	125897
25887	40925	0	applied	\N	\N	\N	\N	125911	125911	125912
25887	40926	1	applied	\N	\N	\N	\N	125913	125913	125914
25887	40927	2	applied	\N	\N	\N	\N	125915	125915	125916
25887	40928	3	applied	\N	\N	\N	\N	125917	125917	125918
25889	40925	0	applied	\N	\N	\N	\N	125911	125911	125912
25889	40926	1	applied	\N	\N	\N	\N	125913	125913	125914
25889	40927	2	applied	\N	\N	\N	\N	125915	125915	125916
25889	40928	3	applied	\N	\N	\N	\N	125917	125917	125918
25894	40933	0	applied	\N	\N	\N	\N	125938	125938	125939
25894	40934	1	applied	\N	\N	\N	\N	125940	125940	125941
25815	40797	4	applied	\N	\N	\N	\N	125524	125524	125525
25815	40798	5	applied	\N	\N	\N	\N	125526	125526	125527
25822	40807	0	applied	\N	\N	\N	\N	125554	125554	125555
25822	40808	1	applied	\N	\N	\N	\N	125556	125556	125557
25822	40809	2	applied	\N	\N	\N	\N	125558	125558	125559
25822	40810	3	applied	\N	\N	\N	\N	125560	125560	125561
25822	40811	4	applied	\N	\N	\N	\N	125562	125562	125563
25822	40812	5	applied	\N	\N	\N	\N	125564	125564	125565
25822	40813	6	applied	\N	\N	\N	\N	125566	125566	125567
25823	40814	0	applied	\N	\N	\N	\N	125571	125571	125572
25823	40815	1	applied	\N	\N	\N	\N	125573	125573	125574
25823	40816	2	applied	\N	\N	\N	\N	125575	125575	125576
25823	40817	3	applied	\N	\N	\N	\N	125577	125577	125578
25823	40818	4	applied	\N	\N	\N	\N	125579	125579	125580
25823	40819	5	applied	\N	\N	\N	\N	125581	125581	125582
25823	40820	6	applied	\N	\N	\N	\N	125583	125583	125584
25823	40821	7	applied	\N	\N	\N	\N	125585	125585	125586
25823	40822	8	applied	\N	\N	\N	\N	125587	125587	125588
25825	40823	0	applied	\N	\N	\N	\N	125593	125593	125594
25825	40824	1	applied	\N	\N	\N	\N	125595	125595	125596
25825	40825	2	applied	\N	\N	\N	\N	125597	125597	125598
25828	40829	0	applied	\N	\N	\N	\N	125608	125608	125609
25828	40830	1	applied	\N	\N	\N	\N	125610	125610	125611
25828	40831	2	applied	\N	\N	1000000000	\N	125612	125612	125613
25828	40832	3	applied	\N	\N	\N	\N	125614	125614	125615
25828	40833	4	applied	\N	\N	\N	\N	125616	125616	125617
25828	40834	5	applied	\N	\N	\N	\N	125618	125618	125619
25828	40835	6	applied	\N	\N	\N	\N	125620	125620	125621
25830	40836	0	applied	\N	\N	\N	\N	125625	125625	125626
25830	40837	1	applied	\N	\N	\N	\N	125627	125627	125628
25830	40838	2	applied	\N	\N	\N	\N	125629	125629	125630
25837	40843	0	applied	\N	\N	\N	\N	125650	125650	125651
25837	40844	1	applied	\N	\N	\N	\N	125652	125652	125653
25837	40845	2	applied	\N	\N	\N	\N	125654	125654	125655
25841	40846	0	applied	\N	\N	\N	\N	125662	125662	125663
25841	40847	1	applied	\N	\N	\N	\N	125664	125664	125665
25841	40848	2	applied	\N	\N	\N	\N	125666	125666	125667
25841	40849	3	applied	\N	\N	\N	\N	125668	125668	125669
25843	40850	0	applied	\N	\N	\N	\N	125673	125673	125674
25843	40851	1	applied	\N	\N	\N	\N	125675	125675	125664
25843	40852	2	applied	\N	\N	\N	\N	125676	125676	125677
25843	40853	3	applied	\N	\N	\N	\N	125678	125678	125679
25846	40854	0	applied	\N	\N	\N	\N	125682	125682	125683
25846	40855	1	applied	\N	\N	\N	\N	125684	125684	125685
25851	40872	0	applied	\N	\N	\N	\N	125727	125727	125728
25851	40873	1	applied	\N	\N	\N	\N	125729	125729	125730
25851	40874	2	applied	\N	\N	\N	\N	125731	125731	125732
25851	40875	3	applied	\N	\N	\N	\N	125733	125733	125734
25851	40876	4	applied	\N	\N	\N	\N	125735	125735	125736
25851	40877	5	applied	\N	\N	\N	\N	125737	125737	125738
25858	40884	0	applied	\N	\N	\N	\N	125756	125756	125757
25858	40885	1	applied	\N	\N	\N	\N	125758	125758	125759
25858	40886	2	applied	\N	\N	\N	\N	125760	125760	125761
25861	40884	0	applied	\N	\N	\N	\N	125756	125756	125757
25861	40887	1	applied	\N	\N	\N	\N	125764	125764	125765
25861	40888	2	applied	\N	\N	\N	\N	125766	125766	125767
25861	40885	3	applied	\N	\N	\N	\N	125758	125758	125761
25861	40889	4	applied	\N	\N	\N	\N	125768	125768	125769
25861	40890	5	applied	\N	\N	\N	\N	125770	125770	125771
25861	40891	6	applied	\N	\N	\N	\N	125772	125772	125773
25861	40892	7	applied	\N	\N	\N	\N	125774	125774	125775
25865	40706	0	applied	\N	\N	\N	\N	125277	125277	125278
25865	40709	1	applied	\N	\N	\N	\N	125286	125286	125287
25865	40712	2	applied	\N	\N	\N	\N	125294	125294	125295
25865	40715	3	applied	\N	\N	\N	\N	125302	125302	125303
25865	40716	4	applied	\N	\N	\N	\N	125304	125304	125305
25865	40721	5	applied	\N	\N	\N	\N	125317	125317	125318
25865	40724	6	applied	\N	\N	\N	\N	125326	125326	125327
25865	40727	7	applied	\N	\N	\N	\N	125334	125334	125335
25865	40728	8	applied	\N	\N	\N	\N	125336	125336	125337
25865	40733	9	applied	\N	\N	\N	\N	125348	125348	125349
25865	40734	10	applied	\N	\N	\N	\N	125350	125350	125351
25865	40739	11	applied	\N	\N	\N	\N	125364	125364	125365
25865	40742	12	applied	\N	\N	\N	\N	125372	125372	125373
25865	40746	13	applied	\N	\N	\N	\N	125388	125388	125389
25865	40749	14	applied	\N	\N	\N	\N	125395	125395	125396
25865	40750	15	applied	\N	\N	\N	\N	125397	125397	125398
25865	40751	16	applied	\N	\N	\N	\N	125399	125399	125400
25865	40752	17	applied	\N	\N	\N	\N	125401	125401	125402
25865	40753	18	applied	\N	\N	\N	\N	125403	125403	125404
25865	40766	19	applied	\N	\N	\N	\N	125434	125434	125435
25865	40768	20	applied	\N	\N	\N	\N	125446	125446	125447
25865	40771	21	applied	\N	\N	\N	\N	125452	125452	125453
25865	40774	22	applied	\N	\N	\N	\N	125462	125462	125463
25865	40775	23	applied	\N	\N	\N	\N	125464	125464	125465
25865	40780	24	applied	\N	\N	\N	\N	125478	125478	125479
25865	40784	25	applied	\N	\N	\N	\N	125490	125490	125491
25865	40787	26	applied	\N	\N	\N	\N	125500	125500	125501
25865	40790	27	applied	\N	\N	\N	\N	125508	125508	125509
25865	40793	28	applied	\N	\N	\N	\N	125516	125516	125517
25865	40794	29	applied	\N	\N	\N	\N	125518	125518	125519
25865	40799	30	applied	\N	\N	\N	\N	125533	125533	125534
25865	40800	31	applied	\N	\N	\N	\N	125535	125535	125536
25865	40805	32	applied	\N	\N	\N	\N	125549	125549	125550
25865	40807	33	applied	\N	\N	\N	\N	125554	125554	125555
25865	40808	34	applied	\N	\N	\N	\N	125556	125556	125557
25865	40814	35	applied	\N	\N	\N	\N	125571	125571	125572
25865	40815	36	applied	\N	\N	\N	\N	125573	125573	125574
25865	40816	37	applied	\N	\N	\N	\N	125575	125575	125576
25865	40823	38	applied	\N	\N	\N	\N	125593	125593	125594
25865	40826	39	applied	\N	\N	\N	\N	125600	125600	125601
25865	40829	40	applied	\N	\N	\N	\N	125608	125608	125609
25865	40830	41	applied	\N	\N	\N	\N	125610	125610	125611
25865	40836	42	applied	\N	\N	\N	\N	125625	125625	125626
25865	40839	43	applied	\N	\N	\N	\N	125635	125635	125636
25865	40843	44	applied	\N	\N	\N	\N	125650	125650	125651
25865	40846	45	applied	\N	\N	\N	\N	125662	125662	125663
25865	40850	46	applied	\N	\N	\N	\N	125673	125673	125674
25865	40854	47	applied	\N	\N	\N	\N	125682	125682	125683
25865	40856	48	applied	\N	\N	\N	\N	125692	125692	125693
25865	40857	49	applied	\N	\N	\N	\N	125694	125694	125695
25865	40862	50	applied	\N	\N	\N	\N	125706	125706	125707
25865	40863	51	applied	\N	\N	\N	\N	125708	125708	125709
25865	40864	52	applied	\N	\N	\N	\N	125710	125710	125711
25865	40872	53	applied	\N	\N	\N	\N	125727	125727	125728
25865	40873	54	applied	\N	\N	\N	\N	125729	125729	125730
25865	40878	55	applied	\N	\N	\N	\N	125741	125741	125742
25865	40881	56	applied	\N	\N	\N	\N	125749	125749	125750
25865	40884	57	applied	\N	\N	\N	\N	125756	125756	125757
25865	40887	58	applied	\N	\N	\N	\N	125764	125764	125765
25816	40795	2	applied	\N	\N	\N	\N	125520	125520	125521
25816	40796	3	applied	\N	\N	\N	\N	125522	125522	125523
25816	40797	4	applied	\N	\N	\N	\N	125524	125524	125525
25816	40798	5	applied	\N	\N	\N	\N	125526	125526	125527
25818	40793	0	applied	\N	\N	\N	\N	125516	125516	125517
25818	40794	1	applied	\N	\N	\N	\N	125518	125518	125519
25818	40799	2	applied	\N	\N	\N	\N	125533	125533	125534
25818	40800	3	applied	\N	\N	\N	\N	125535	125535	125536
25818	40795	4	applied	\N	\N	\N	\N	125520	125520	125521
25818	40796	5	applied	\N	\N	\N	\N	125522	125522	125523
25818	40801	6	applied	\N	\N	\N	\N	125537	125537	125538
25818	40802	7	applied	\N	\N	\N	\N	125539	125539	125540
25818	40797	8	applied	\N	\N	\N	\N	125524	125524	125541
25818	40798	9	applied	\N	\N	\N	\N	125526	125526	125542
25818	40803	10	applied	\N	\N	\N	\N	125543	125543	125544
25818	40804	11	applied	\N	\N	\N	\N	125545	125545	125546
25820	40805	0	applied	\N	\N	\N	\N	125549	125549	125550
25820	40806	1	applied	\N	\N	\N	\N	125551	125551	125552
25833	40839	0	applied	\N	\N	\N	\N	125635	125635	125636
25833	40840	1	applied	\N	\N	\N	\N	125637	125637	125638
25833	40841	2	applied	\N	\N	\N	\N	125639	125639	125640
25833	40842	3	applied	\N	\N	\N	\N	125641	125641	125642
25835	40831	0	applied	\N	\N	1000000000	\N	125612	125612	125613
25835	40744	1	applied	\N	\N	1000000000	\N	125376	125376	125377
25835	40842	2	applied	\N	\N	\N	\N	125641	125641	125642
25835	40755	3	applied	\N	\N	\N	\N	125407	125407	125408
25835	40674	4	applied	\N	\N	\N	\N	125164	125164	13107
25835	40675	5	applied	\N	\N	\N	\N	125165	125165	125165
25835	40686	6	applied	\N	\N	\N	\N	125211	125211	120198
25835	40763	7	applied	\N	\N	\N	\N	125424	125424	125377
25839	40843	0	applied	\N	\N	\N	\N	125650	125650	125651
25839	40844	1	applied	\N	\N	\N	\N	125652	125652	125653
25839	40845	2	applied	\N	\N	\N	\N	125654	125654	125655
25842	40846	0	applied	\N	\N	\N	\N	125662	125662	125663
25842	40847	1	applied	\N	\N	\N	\N	125664	125664	125665
25842	40848	2	applied	\N	\N	\N	\N	125666	125666	125667
25842	40849	3	applied	\N	\N	\N	\N	125668	125668	125669
25844	40850	0	applied	\N	\N	\N	\N	125673	125673	125674
25844	40851	1	applied	\N	\N	\N	\N	125675	125675	125664
25844	40852	2	applied	\N	\N	\N	\N	125676	125676	125677
25844	40853	3	applied	\N	\N	\N	\N	125678	125678	125679
25852	40878	0	applied	\N	\N	\N	\N	125741	125741	125742
25852	40879	1	applied	\N	\N	\N	\N	125743	125743	125744
25852	40880	2	applied	\N	\N	\N	\N	125745	125745	125746
25854	40881	0	applied	\N	\N	\N	\N	125749	125749	125750
25854	40882	1	applied	\N	\N	\N	\N	125751	125751	125752
25854	40883	2	applied	\N	\N	\N	\N	125753	125753	125754
25857	40881	0	applied	\N	\N	\N	\N	125749	125749	125750
25857	40882	1	applied	\N	\N	\N	\N	125751	125751	125752
25857	40883	2	applied	\N	\N	\N	\N	125753	125753	125754
25863	40884	0	applied	\N	\N	\N	\N	125756	125756	125757
25863	40887	1	applied	\N	\N	\N	\N	125764	125764	125765
25863	40888	2	applied	\N	\N	\N	\N	125766	125766	125767
25863	40885	3	applied	\N	\N	\N	\N	125758	125758	125761
25863	40889	4	applied	\N	\N	\N	\N	125768	125768	125769
25863	40890	5	applied	\N	\N	\N	\N	125770	125770	125771
25863	40891	6	applied	\N	\N	\N	\N	125772	125772	125773
25863	40892	7	applied	\N	\N	\N	\N	125774	125774	125775
25868	40902	0	applied	\N	\N	\N	\N	125840	125840	125841
25868	40903	1	applied	\N	\N	\N	\N	125842	125842	125843
25868	40904	2	applied	\N	\N	\N	\N	125844	125844	125845
25872	40903	0	applied	\N	\N	\N	\N	125842	125842	125843
25876	40905	0	applied	\N	\N	\N	\N	125855	125855	125856
25876	40906	1	applied	\N	\N	\N	\N	125857	125857	125858
25876	40907	2	applied	\N	\N	\N	\N	125859	125859	125860
25876	40908	3	applied	\N	\N	\N	\N	125861	125861	125862
25876	40909	4	applied	\N	\N	\N	\N	125863	125863	125864
25876	40910	5	applied	\N	\N	\N	\N	125865	125865	125866
25879	40911	0	applied	\N	\N	\N	\N	125873	125873	125874
25879	40912	1	applied	\N	\N	\N	\N	125875	125875	125876
25879	40913	2	applied	\N	\N	\N	\N	125877	125877	125878
25879	40914	3	applied	\N	\N	\N	\N	125879	125879	125880
25879	40915	4	applied	\N	\N	\N	\N	125881	125881	125882
25879	40916	5	applied	\N	\N	\N	\N	125883	125883	125884
25884	40921	0	applied	\N	\N	\N	\N	125900	125900	125901
25884	40922	1	applied	\N	\N	\N	\N	125902	125902	125903
25886	40923	0	applied	\N	\N	\N	\N	125906	125906	125907
25886	40924	1	applied	\N	\N	\N	\N	125908	125908	125909
25891	40929	0	applied	\N	\N	\N	\N	125925	125925	125926
25891	40930	1	applied	\N	\N	\N	\N	125927	125927	125928
25893	40931	0	applied	\N	\N	\N	\N	125931	125931	125932
25893	40932	1	applied	\N	\N	\N	\N	125933	125933	125934
25895	40935	0	applied	\N	\N	\N	\N	125943	125943	125944
25895	40936	1	applied	\N	\N	\N	\N	125945	125945	125946
25895	40937	2	applied	\N	\N	\N	\N	125947	125947	125948
25895	40938	3	applied	\N	\N	\N	\N	125949	125949	125950
25895	40939	4	applied	\N	\N	\N	\N	125951	125951	125952
25895	40940	5	applied	\N	\N	\N	\N	125953	125953	125954
25895	40941	6	applied	\N	\N	\N	\N	125955	125955	125956
25895	40942	7	applied	\N	\N	\N	\N	125957	125957	125958
25895	40943	8	applied	\N	\N	\N	\N	125959	125959	125960
25895	40944	9	applied	\N	\N	\N	\N	125961	125961	125962
25895	40945	10	applied	\N	\N	\N	\N	125963	125963	125964
25897	40946	0	applied	\N	\N	\N	\N	125971	125971	125972
25897	40947	1	applied	\N	\N	\N	\N	125973	125973	125974
25900	40948	0	applied	\N	\N	1000000000	\N	125977	125977	125978
25900	40949	1	applied	\N	\N	\N	\N	125979	125979	125980
25900	40950	2	applied	\N	\N	\N	\N	125981	125981	125982
25904	40953	0	applied	\N	\N	\N	\N	125995	125995	125996
25904	40954	1	applied	\N	\N	\N	\N	125997	125997	125998
25907	40955	0	applied	\N	\N	\N	\N	126002	126002	126003
25907	40956	1	applied	\N	\N	\N	\N	126004	126004	126005
25907	40957	2	applied	\N	\N	\N	\N	126006	126006	126007
25907	40958	3	applied	\N	\N	\N	\N	126008	126008	126009
25907	40959	4	applied	\N	\N	\N	\N	126010	126010	126011
25907	40960	5	applied	\N	\N	\N	\N	126012	126012	126013
25907	40961	6	applied	\N	\N	\N	\N	126014	126014	126015
25909	40962	0	applied	\N	\N	\N	\N	126021	126021	126022
25909	40963	1	applied	\N	\N	\N	\N	126023	126023	126024
25911	40962	0	applied	\N	\N	\N	\N	126021	126021	126022
25911	40963	1	applied	\N	\N	\N	\N	126023	126023	126024
25918	40970	0	applied	\N	\N	\N	\N	126050	126050	126051
25918	40971	1	applied	\N	\N	\N	\N	126052	126052	126053
25920	40972	0	applied	\N	\N	\N	\N	126056	126056	126057
25920	40973	1	applied	\N	\N	\N	\N	126058	126058	126059
25922	40972	0	applied	\N	\N	\N	\N	126056	126056	126057
25922	40973	1	applied	\N	\N	\N	\N	126058	126058	126059
25925	40976	0	applied	\N	\N	\N	\N	126069	126069	126070
25925	40977	1	applied	\N	\N	\N	\N	126071	126071	126072
25862	40892	7	applied	\N	\N	\N	\N	125774	125774	125775
25864	40893	0	applied	\N	\N	\N	\N	125781	125781	125782
25864	40894	1	applied	\N	\N	\N	\N	125783	125783	125784
25864	40895	2	applied	\N	\N	\N	\N	125785	125785	125786
25867	40902	0	applied	\N	\N	\N	\N	125840	125840	125841
25867	40903	1	applied	\N	\N	\N	\N	125842	125842	125843
25867	40904	2	applied	\N	\N	\N	\N	125844	125844	125845
25869	40902	0	applied	\N	\N	\N	\N	125840	125840	125841
25869	40903	1	applied	\N	\N	\N	\N	125842	125842	125843
25869	40904	2	applied	\N	\N	\N	\N	125844	125844	125845
25874	40905	0	applied	\N	\N	\N	\N	125855	125855	125856
25874	40906	1	applied	\N	\N	\N	\N	125857	125857	125858
25874	40907	2	applied	\N	\N	\N	\N	125859	125859	125860
25874	40908	3	applied	\N	\N	\N	\N	125861	125861	125862
25874	40909	4	applied	\N	\N	\N	\N	125863	125863	125864
25874	40910	5	applied	\N	\N	\N	\N	125865	125865	125866
25877	40905	0	applied	\N	\N	\N	\N	125855	125855	125856
25877	40906	1	applied	\N	\N	\N	\N	125857	125857	125858
25877	40907	2	applied	\N	\N	\N	\N	125859	125859	125860
25877	40908	3	applied	\N	\N	\N	\N	125861	125861	125862
25877	40909	4	applied	\N	\N	\N	\N	125863	125863	125864
25877	40910	5	applied	\N	\N	\N	\N	125865	125865	125866
25878	40911	0	applied	\N	\N	\N	\N	125873	125873	125874
25878	40912	1	applied	\N	\N	\N	\N	125875	125875	125876
25878	40913	2	applied	\N	\N	\N	\N	125877	125877	125878
25878	40914	3	applied	\N	\N	\N	\N	125879	125879	125880
25878	40915	4	applied	\N	\N	\N	\N	125881	125881	125882
25878	40916	5	applied	\N	\N	\N	\N	125883	125883	125884
25883	40919	0	applied	\N	\N	\N	\N	125894	125894	125895
25883	40920	1	applied	\N	\N	\N	\N	125896	125896	125897
25885	40921	0	applied	\N	\N	\N	\N	125900	125900	125901
25885	40922	1	applied	\N	\N	\N	\N	125902	125902	125903
25890	40929	0	applied	\N	\N	\N	\N	125925	125925	125926
25890	40930	1	applied	\N	\N	\N	\N	125927	125927	125928
25892	40931	0	applied	\N	\N	\N	\N	125931	125931	125932
25892	40932	1	applied	\N	\N	\N	\N	125933	125933	125934
25896	40935	0	applied	\N	\N	\N	\N	125943	125943	125944
25896	40936	1	applied	\N	\N	\N	\N	125945	125945	125946
25896	40937	2	applied	\N	\N	\N	\N	125947	125947	125948
25896	40938	3	applied	\N	\N	\N	\N	125949	125949	125950
25896	40939	4	applied	\N	\N	\N	\N	125951	125951	125952
25896	40940	5	applied	\N	\N	\N	\N	125953	125953	125954
25896	40941	6	applied	\N	\N	\N	\N	125955	125955	125956
25896	40942	7	applied	\N	\N	\N	\N	125957	125957	125958
25896	40943	8	applied	\N	\N	\N	\N	125959	125959	125960
25896	40944	9	applied	\N	\N	\N	\N	125961	125961	125962
25896	40945	10	applied	\N	\N	\N	\N	125963	125963	125964
25899	40948	0	applied	\N	\N	1000000000	\N	125977	125977	125978
25899	40949	1	applied	\N	\N	\N	\N	125979	125979	125980
25899	40950	2	applied	\N	\N	\N	\N	125981	125981	125982
25905	40953	0	applied	\N	\N	\N	\N	125995	125995	125996
25905	40954	1	applied	\N	\N	\N	\N	125997	125997	125998
25910	40962	0	applied	\N	\N	\N	\N	126021	126021	126022
25910	40963	1	applied	\N	\N	\N	\N	126023	126023	126024
25912	40964	0	applied	\N	\N	\N	\N	126031	126031	126032
25912	40965	1	applied	\N	\N	\N	\N	126033	126033	126034
25914	40964	0	applied	\N	\N	\N	\N	126031	126031	126032
25917	40970	0	applied	\N	\N	\N	\N	126050	126050	126051
25917	40971	1	applied	\N	\N	\N	\N	126052	126052	126053
25919	40970	0	applied	\N	\N	\N	\N	126050	126050	126051
25919	40971	1	applied	\N	\N	\N	\N	126052	126052	126053
25921	40972	0	applied	\N	\N	\N	\N	126056	126056	126057
25921	40973	1	applied	\N	\N	\N	\N	126058	126058	126059
25923	40972	0	applied	\N	\N	\N	\N	126056	126056	126057
25923	40973	1	applied	\N	\N	\N	\N	126058	126058	126059
25929	40988	0	applied	\N	\N	\N	\N	126097	126097	126098
25929	40989	1	applied	\N	\N	\N	\N	126099	126099	126100
25932	40995	0	applied	\N	\N	\N	\N	126115	126115	126116
25932	40996	1	applied	\N	\N	\N	\N	126117	126117	126118
25932	40997	2	applied	\N	\N	\N	\N	126119	126119	126120
25932	40998	3	applied	\N	\N	\N	\N	126121	126121	126122
25939	41010	0	applied	\N	\N	\N	\N	126154	126154	126155
25939	41011	1	applied	\N	\N	\N	\N	126156	126156	126157
25939	41012	2	applied	\N	\N	\N	\N	126158	126158	126159
25939	41013	3	applied	\N	\N	\N	\N	126160	126160	126161
25939	41014	4	applied	\N	\N	\N	\N	126162	126162	126163
25939	41015	5	applied	\N	\N	\N	\N	126164	126164	126165
25939	41016	6	applied	\N	\N	\N	\N	126166	126166	126167
25939	41017	8	applied	\N	\N	\N	\N	126172	126172	126173
25939	41018	9	applied	\N	\N	\N	\N	126174	126174	126175
25943	41019	0	applied	\N	\N	\N	\N	126184	126184	126185
25946	41019	0	applied	\N	\N	\N	\N	126184	126184	126185
25946	41020	1	applied	\N	\N	\N	\N	126188	126188	126189
25946	41021	2	applied	\N	\N	\N	\N	126190	126190	126191
25946	41022	3	applied	\N	\N	\N	\N	126192	126192	126193
25946	41023	4	applied	\N	\N	\N	\N	126194	126194	126195
25952	41024	0	applied	\N	\N	\N	\N	126200	126200	126201
25952	41025	1	applied	\N	\N	\N	\N	126202	126202	126203
25952	41026	2	applied	\N	\N	\N	\N	126204	126204	126205
25952	41027	3	applied	\N	\N	\N	\N	126206	126206	126207
25954	40992	0	applied	\N	\N	\N	\N	126217	126217	125995
25954	41030	1	applied	\N	\N	\N	\N	126218	126218	126219
25954	40961	2	applied	\N	\N	\N	\N	126014	126014	126015
25957	41033	0	applied	\N	\N	\N	\N	126228	126228	126229
25957	41034	1	applied	\N	\N	\N	\N	126230	126230	126231
25957	41035	2	applied	\N	\N	\N	\N	126232	126232	126233
25957	41036	3	applied	\N	\N	\N	\N	126234	126234	126235
25959	41033	0	applied	\N	\N	\N	\N	126228	126228	126229
25959	41034	1	applied	\N	\N	\N	\N	126230	126230	126231
25959	41035	2	applied	\N	\N	\N	\N	126232	126232	126233
25959	41036	3	applied	\N	\N	\N	\N	126234	126234	126235
25961	41037	0	applied	\N	\N	\N	\N	126241	126241	126242
25961	41038	1	applied	\N	\N	\N	\N	126243	126243	126244
25969	41044	0	applied	\N	\N	\N	\N	126265	126265	126266
25969	41045	1	applied	\N	\N	\N	\N	126267	126267	126268
25969	41046	2	applied	\N	\N	\N	\N	126269	126269	126270
25969	41047	3	applied	\N	\N	\N	\N	126271	126271	126254
25973	41052	0	applied	\N	\N	\N	\N	126289	126289	126290
25973	41053	1	applied	\N	\N	\N	\N	126291	126291	126292
25975	41042	0	applied	\N	\N	1000000000	\N	126254	126254	126255
25978	41058	0	applied	\N	\N	\N	\N	126310	126310	126311
25978	41059	1	applied	\N	\N	\N	\N	126312	126312	126313
25978	41060	2	applied	\N	\N	\N	\N	126314	126314	126315
25978	41061	3	applied	\N	\N	\N	\N	126316	126316	126317
25983	41068	0	applied	\N	\N	\N	\N	126336	126336	126337
25983	41069	1	applied	\N	\N	\N	\N	126338	126338	126339
25986	41076	0	applied	\N	\N	\N	\N	126358	126358	126359
25986	41077	1	applied	\N	\N	\N	\N	126360	126360	126361
25988	41078	0	applied	\N	\N	\N	\N	126363	126363	126364
25865	40888	59	applied	\N	\N	\N	\N	125766	125766	125767
25865	40893	60	applied	\N	\N	\N	\N	125781	125781	125782
25865	40896	61	applied	\N	\N	\N	\N	125789	125789	125790
25865	40897	62	applied	\N	\N	\N	\N	125791	125791	125792
25865	40867	63	applied	\N	\N	\N	\N	125716	125716	125716
25865	40707	64	applied	\N	\N	\N	\N	125279	125279	125280
25865	40710	65	applied	\N	\N	\N	\N	125288	125288	125793
25865	40714	66	applied	\N	\N	\N	\N	125298	125298	125794
25865	40831	67	applied	\N	\N	1000000000	\N	125612	125612	125613
25865	40744	68	applied	\N	\N	1000000000	\N	125376	125376	125377
25865	40842	69	applied	\N	\N	\N	\N	125641	125641	125642
25865	40755	70	applied	\N	\N	\N	\N	125407	125407	125408
25865	40708	71	applied	\N	\N	\N	\N	125281	125281	125795
25865	40711	72	applied	\N	\N	\N	\N	125290	125290	125796
25865	40713	73	applied	\N	\N	\N	\N	125296	125296	125299
25865	40717	74	applied	\N	\N	\N	\N	125306	125306	125307
25865	40718	75	applied	\N	\N	\N	\N	125308	125308	125309
25865	40722	76	applied	\N	\N	\N	\N	125319	125319	125797
25865	40725	77	applied	\N	\N	\N	\N	125328	125328	125798
25865	40729	78	applied	\N	\N	\N	\N	125338	125338	125322
25865	40847	80	applied	\N	\N	\N	\N	125664	125664	125665
25865	40719	81	applied	\N	\N	\N	\N	125310	125310	125800
25865	40720	82	applied	\N	\N	\N	\N	125312	125312	125801
25865	40723	83	applied	\N	\N	\N	\N	125321	125321	125802
25865	40726	84	applied	\N	\N	\N	\N	125330	125330	125339
25865	40730	85	applied	\N	\N	\N	\N	125340	125340	125341
25865	40731	86	applied	\N	\N	\N	\N	125342	125342	125343
25865	40737	87	applied	\N	\N	\N	\N	125356	125356	125803
25865	40738	88	applied	\N	\N	\N	\N	125358	125358	125804
25865	40741	89	applied	\N	\N	\N	\N	125368	125368	125353
25865	40763	90	applied	\N	\N	\N	\N	125424	125424	125377
25865	40745	91	applied	\N	\N	\N	\N	125380	125380	125805
25865	40748	92	applied	\N	\N	\N	\N	125393	125393	125806
25865	40760	93	applied	\N	\N	\N	\N	125417	125417	125807
25865	40761	94	applied	\N	\N	\N	\N	125419	125419	125808
25865	40762	95	applied	\N	\N	\N	\N	125421	125421	125367
25865	40764	96	applied	\N	\N	\N	\N	125425	125425	125369
25865	40765	97	applied	\N	\N	\N	\N	125427	125427	125809
25865	40767	98	applied	\N	\N	\N	\N	125436	125436	125810
25865	40770	99	applied	\N	\N	\N	\N	125450	125450	125391
25865	40772	100	applied	\N	\N	\N	\N	125454	125454	125392
25865	40776	101	applied	\N	\N	\N	\N	125466	125466	125394
25865	40779	102	applied	\N	\N	\N	\N	125472	125472	125811
25865	40783	103	applied	\N	\N	\N	\N	125484	125484	125812
25865	40786	104	applied	\N	\N	\N	\N	125494	125494	125410
25865	40789	105	applied	\N	\N	\N	\N	125504	125504	125813
25865	40791	106	applied	\N	\N	\N	\N	125510	125510	125814
25865	40797	107	applied	\N	\N	\N	\N	125524	125524	125414
25865	40798	108	applied	\N	\N	\N	\N	125526	125526	125815
25865	40803	109	applied	\N	\N	\N	\N	125543	125543	125816
25865	40804	110	applied	\N	\N	\N	\N	125545	125545	125817
25865	40806	111	applied	\N	\N	\N	\N	125551	125551	125818
25865	40809	112	applied	\N	\N	\N	\N	125558	125558	125819
25865	40810	113	applied	\N	\N	\N	\N	125560	125560	125820
25865	40819	114	applied	\N	\N	\N	\N	125581	125581	125821
25865	40820	115	applied	\N	\N	\N	\N	125583	125583	125822
25865	40821	116	applied	\N	\N	\N	\N	125585	125585	125449
25865	40824	117	applied	\N	\N	\N	\N	125595	125595	125451
25865	40828	118	applied	\N	\N	\N	\N	125604	125604	125455
25865	40832	119	applied	\N	\N	\N	\N	125614	125614	125823
25865	40833	120	applied	\N	\N	\N	\N	125616	125616	125824
25865	40837	121	applied	\N	\N	\N	\N	125627	125627	125825
25865	40841	122	applied	\N	\N	\N	\N	125639	125639	125469
25865	40844	123	applied	\N	\N	\N	\N	125652	125652	125826
25865	40848	124	applied	\N	\N	\N	\N	125666	125666	125827
25865	40853	125	applied	\N	\N	\N	\N	125678	125678	125828
25870	40902	0	applied	\N	\N	\N	\N	125840	125840	125841
25870	40903	1	applied	\N	\N	\N	\N	125842	125842	125843
25870	40904	2	applied	\N	\N	\N	\N	125844	125844	125845
25875	40905	0	applied	\N	\N	\N	\N	125855	125855	125856
25875	40906	1	applied	\N	\N	\N	\N	125857	125857	125858
25875	40907	2	applied	\N	\N	\N	\N	125859	125859	125860
25875	40908	3	applied	\N	\N	\N	\N	125861	125861	125862
25875	40909	4	applied	\N	\N	\N	\N	125863	125863	125864
25875	40910	5	applied	\N	\N	\N	\N	125865	125865	125866
25881	40917	0	applied	\N	\N	\N	\N	125887	125887	125888
25881	40918	1	applied	\N	\N	\N	\N	125889	125889	125890
25888	40925	0	applied	\N	\N	\N	\N	125911	125911	125912
25888	40926	1	applied	\N	\N	\N	\N	125913	125913	125914
25888	40927	2	applied	\N	\N	\N	\N	125915	125915	125916
25888	40928	3	applied	\N	\N	\N	\N	125917	125917	125918
25901	40951	0	applied	\N	\N	\N	\N	125989	125989	125990
25901	40952	1	applied	\N	\N	\N	\N	125991	125991	125992
25906	40955	0	applied	\N	\N	\N	\N	126002	126002	126003
25906	40956	1	applied	\N	\N	\N	\N	126004	126004	126005
25906	40957	2	applied	\N	\N	\N	\N	126006	126006	126007
25906	40958	3	applied	\N	\N	\N	\N	126008	126008	126009
25906	40959	4	applied	\N	\N	\N	\N	126010	126010	126011
25906	40960	5	applied	\N	\N	\N	\N	126012	126012	126013
25906	40961	6	applied	\N	\N	\N	\N	126014	126014	126015
25913	40964	0	applied	\N	\N	\N	\N	126031	126031	126032
25913	40965	1	applied	\N	\N	\N	\N	126033	126033	126034
25915	40966	0	applied	\N	\N	\N	\N	126039	126039	126040
25915	40967	1	applied	\N	\N	\N	\N	126041	126041	126042
25915	40968	2	applied	\N	\N	\N	\N	126043	126043	126044
25915	40969	3	applied	\N	\N	\N	\N	126045	126045	126046
25924	40974	0	applied	\N	\N	\N	\N	126063	126063	126064
25924	40975	1	applied	\N	\N	\N	\N	126065	126065	126066
25927	40982	0	applied	\N	\N	\N	\N	126083	126083	126084
25927	40983	1	applied	\N	\N	\N	\N	126085	126085	126086
25935	41001	0	applied	\N	\N	\N	\N	126132	126132	126133
25935	41002	1	applied	\N	\N	\N	\N	126134	126134	126135
25936	41003	0	applied	\N	\N	\N	\N	126136	126136	126137
25936	41004	1	applied	\N	\N	\N	\N	126138	126138	126139
25936	41005	2	applied	\N	\N	\N	\N	126140	126140	126141
25936	41006	3	applied	\N	\N	\N	\N	126142	126142	126143
25936	41007	4	applied	\N	\N	\N	\N	126144	126144	126145
25936	41008	5	applied	\N	\N	\N	\N	126146	126146	126147
25940	41010	0	applied	\N	\N	\N	\N	126154	126154	126155
25940	41011	1	applied	\N	\N	\N	\N	126156	126156	126157
25940	41012	2	applied	\N	\N	\N	\N	126158	126158	126159
25940	41013	3	applied	\N	\N	\N	\N	126160	126160	126161
25940	41014	4	applied	\N	\N	\N	\N	126162	126162	126163
25940	41015	5	applied	\N	\N	\N	\N	126164	126164	126165
25940	41016	6	applied	\N	\N	\N	\N	126166	126166	126167
25940	41017	8	applied	\N	\N	\N	\N	126172	126172	126173
25940	41018	9	applied	\N	\N	\N	\N	126174	126174	126175
25955	41030	0	applied	\N	\N	\N	\N	126218	126218	126219
25955	41031	1	applied	\N	\N	\N	\N	126221	126221	126222
25898	40948	0	applied	\N	\N	1000000000	\N	125977	125977	125978
25898	40949	1	applied	\N	\N	\N	\N	125979	125979	125980
25898	40950	2	applied	\N	\N	\N	\N	125981	125981	125982
25902	40951	0	applied	\N	\N	\N	\N	125989	125989	125990
25902	40952	1	applied	\N	\N	\N	\N	125991	125991	125992
25908	40955	0	applied	\N	\N	\N	\N	126002	126002	126003
25908	40956	1	applied	\N	\N	\N	\N	126004	126004	126005
25908	40957	2	applied	\N	\N	\N	\N	126006	126006	126007
25908	40958	3	applied	\N	\N	\N	\N	126008	126008	126009
25908	40959	4	applied	\N	\N	\N	\N	126010	126010	126011
25908	40960	5	applied	\N	\N	\N	\N	126012	126012	126013
25908	40961	6	applied	\N	\N	\N	\N	126014	126014	126015
25916	40966	0	applied	\N	\N	\N	\N	126039	126039	126040
25916	40967	1	applied	\N	\N	\N	\N	126041	126041	126042
25916	40968	2	applied	\N	\N	\N	\N	126043	126043	126044
25916	40969	3	applied	\N	\N	\N	\N	126045	126045	126046
25926	40982	0	applied	\N	\N	\N	\N	126083	126083	126084
25926	40983	1	applied	\N	\N	\N	\N	126085	126085	126086
25931	40990	0	applied	\N	\N	\N	\N	126104	126104	126105
25931	40991	1	applied	\N	\N	\N	\N	126106	126106	126107
25931	40992	2	applied	\N	\N	\N	\N	126108	126108	126106
25931	40993	3	applied	\N	\N	\N	\N	126109	126109	126110
25931	40994	4	applied	\N	\N	\N	\N	126111	126111	126112
25934	40999	0	applied	\N	\N	\N	\N	126127	126127	126128
25934	41000	1	applied	\N	\N	\N	\N	126129	126129	126130
25937	41009	0	applied	\N	\N	\N	\N	126150	126150	126151
25938	41010	0	applied	\N	\N	\N	\N	126154	126154	126155
25938	41011	1	applied	\N	\N	\N	\N	126156	126156	126157
25938	41012	2	applied	\N	\N	\N	\N	126158	126158	126159
25938	41013	3	applied	\N	\N	\N	\N	126160	126160	126161
25938	41014	4	applied	\N	\N	\N	\N	126162	126162	126163
25938	41015	5	applied	\N	\N	\N	\N	126164	126164	126165
25938	41016	6	applied	\N	\N	\N	\N	126166	126166	126167
25942	41010	0	applied	\N	\N	\N	\N	126154	126154	126155
25942	41011	1	applied	\N	\N	\N	\N	126156	126156	126157
25942	41012	2	applied	\N	\N	\N	\N	126158	126158	126159
25942	41013	3	applied	\N	\N	\N	\N	126160	126160	126161
25942	41014	4	applied	\N	\N	\N	\N	126162	126162	126163
25942	41015	5	applied	\N	\N	\N	\N	126164	126164	126165
25942	41016	6	applied	\N	\N	\N	\N	126166	126166	126167
25942	41017	8	applied	\N	\N	\N	\N	126172	126172	126173
25942	41018	9	applied	\N	\N	\N	\N	126174	126174	126175
25948	41020	0	applied	\N	\N	\N	\N	126188	126188	126189
25948	41021	1	applied	\N	\N	\N	\N	126190	126190	126191
25948	41022	2	applied	\N	\N	\N	\N	126192	126192	126193
25948	41023	3	applied	\N	\N	\N	\N	126194	126194	126195
25956	41030	0	applied	\N	\N	\N	\N	126218	126218	126219
25956	41031	1	applied	\N	\N	\N	\N	126221	126221	126222
25956	41032	2	applied	\N	\N	\N	\N	126223	126223	126224
25964	41039	0	applied	\N	\N	\N	\N	126248	126248	126249
25964	41040	1	applied	\N	\N	\N	\N	126250	126250	126251
25964	41041	2	applied	\N	\N	\N	\N	126252	126252	126253
25964	41042	3	applied	\N	\N	1000000000	\N	126254	126254	126255
25964	41043	4	applied	\N	\N	\N	\N	126256	126256	126257
25968	41044	0	applied	\N	\N	\N	\N	126265	126265	126266
25968	41045	1	applied	\N	\N	\N	\N	126267	126267	126268
25968	41046	2	applied	\N	\N	\N	\N	126269	126269	126270
25968	41047	3	applied	\N	\N	\N	\N	126271	126271	126254
25970	41048	0	applied	\N	\N	\N	\N	126276	126276	126277
25970	41049	1	applied	\N	\N	\N	\N	126278	126278	126279
25972	41050	0	applied	\N	\N	\N	\N	126283	126283	126284
25972	41051	1	applied	\N	\N	\N	\N	126285	126285	126286
25980	41064	0	applied	\N	\N	\N	\N	126325	126325	126326
25980	41065	1	applied	\N	\N	\N	\N	126327	126327	126328
25985	41070	0	applied	\N	\N	\N	\N	126344	126344	126345
25985	41071	1	applied	\N	\N	\N	\N	126346	126346	126347
25985	41072	2	applied	\N	\N	\N	\N	126348	126348	126349
25985	41073	3	applied	\N	\N	\N	\N	126350	126350	126351
25985	41074	4	applied	\N	\N	\N	\N	126352	126352	126353
25985	41075	5	applied	\N	\N	\N	\N	126354	126354	126355
25990	41080	0	applied	\N	\N	\N	\N	126370	126370	126371
25990	41081	1	applied	\N	\N	\N	\N	126372	126372	126373
25995	41086	0	applied	\N	\N	\N	\N	126392	126392	126393
25995	41087	1	applied	\N	\N	\N	\N	126394	126394	126395
25995	41088	2	applied	\N	\N	\N	\N	126396	126396	126397
25995	41089	3	applied	\N	\N	\N	\N	126398	126398	126399
26004	41097	0	applied	\N	\N	\N	\N	126425	126425	126426
26012	41120	0	applied	\N	\N	\N	\N	126480	126480	126481
26012	41121	1	applied	\N	\N	\N	\N	126482	126482	126483
26012	41122	2	applied	\N	\N	\N	\N	126484	126484	126485
26012	41123	3	applied	\N	\N	\N	\N	126486	126486	126487
26014	40351	0	applied	\N	\N	\N	\N	124264	124264	124265
26014	40354	1	applied	\N	\N	\N	\N	124274	124274	124275
26014	40356	2	applied	\N	\N	\N	\N	124279	124279	124280
26014	40948	3	applied	\N	\N	1000000000	\N	125977	125977	125978
26014	40360	4	applied	\N	\N	\N	\N	124287	124287	124288
26014	40992	5	applied	\N	\N	\N	\N	126491	126491	124287
26014	41030	6	applied	\N	\N	\N	\N	126218	126218	126219
26014	40363	7	applied	\N	\N	\N	\N	124297	124297	126492
26014	40366	8	applied	\N	\N	\N	\N	124307	124307	126493
26014	40367	9	applied	\N	\N	\N	\N	124309	124309	126494
26014	40372	10	applied	\N	\N	\N	\N	124322	124322	126495
26014	40373	11	applied	\N	\N	\N	\N	124324	124324	126496
26014	40378	12	applied	\N	\N	\N	\N	124335	124335	126497
26014	40379	13	applied	\N	\N	\N	\N	124337	124337	126498
26014	40384	14	applied	\N	\N	\N	\N	124349	124349	126499
26014	40387	15	applied	\N	\N	\N	\N	124356	124356	126500
26014	40388	16	applied	\N	\N	\N	\N	124358	124358	126501
26014	40393	17	applied	\N	\N	\N	\N	124371	124371	126502
26014	40396	18	applied	\N	\N	\N	\N	124381	124381	126503
26014	40399	19	applied	\N	\N	\N	\N	124389	124389	126504
26014	40402	20	applied	\N	\N	\N	\N	124401	124401	126505
26014	40403	21	applied	\N	\N	\N	\N	124403	124403	126506
26014	40409	22	applied	\N	\N	\N	\N	124417	124417	126507
26014	40410	23	applied	\N	\N	\N	\N	124419	124419	126508
26014	40417	24	applied	\N	\N	\N	\N	124435	124435	126509
26014	40418	25	applied	\N	\N	\N	\N	124437	124437	126510
26014	40421	26	applied	\N	\N	\N	\N	124444	124444	126511
26014	40422	27	applied	\N	\N	\N	\N	124446	124446	126512
26014	40427	28	applied	\N	\N	\N	\N	124464	124464	126513
26014	40428	29	applied	\N	\N	\N	\N	124466	124466	126514
26014	40433	30	applied	\N	\N	\N	\N	124478	124478	126515
26014	40434	31	applied	\N	\N	\N	\N	124480	124480	126516
26014	40438	32	applied	\N	\N	\N	\N	124489	124489	126517
26014	40441	33	applied	\N	\N	\N	\N	124495	124495	126518
26014	40442	34	applied	\N	\N	\N	\N	124497	124497	126519
26014	40447	35	applied	\N	\N	\N	\N	124511	124511	126520
26014	40448	36	applied	\N	\N	\N	\N	124513	124513	126521
26014	40453	37	applied	\N	\N	\N	\N	124524	124524	126522
25925	40978	2	applied	\N	\N	\N	\N	126073	126073	126074
25925	40979	3	applied	\N	\N	\N	\N	126075	126075	126076
25925	40980	4	applied	\N	\N	\N	\N	126077	126077	126078
25925	40981	5	applied	\N	\N	\N	\N	126079	126079	126080
25928	40984	0	applied	\N	\N	\N	\N	126088	126088	126089
25928	40985	1	applied	\N	\N	\N	\N	126090	126090	126091
25928	40986	2	applied	\N	\N	\N	\N	126092	126092	126093
25928	40987	3	applied	\N	\N	\N	\N	126094	126094	126095
25930	40988	0	applied	\N	\N	\N	\N	126097	126097	126098
25930	40989	1	applied	\N	\N	\N	\N	126099	126099	126100
25933	40995	0	applied	\N	\N	\N	\N	126115	126115	126116
25933	40996	1	applied	\N	\N	\N	\N	126117	126117	126118
25933	40997	2	applied	\N	\N	\N	\N	126119	126119	126120
25933	40998	3	applied	\N	\N	\N	\N	126121	126121	126122
25941	41010	0	applied	\N	\N	\N	\N	126154	126154	126155
25941	41011	1	applied	\N	\N	\N	\N	126156	126156	126157
25941	41012	2	applied	\N	\N	\N	\N	126158	126158	126159
25941	41013	3	applied	\N	\N	\N	\N	126160	126160	126161
25941	41014	4	applied	\N	\N	\N	\N	126162	126162	126163
25941	41015	5	applied	\N	\N	\N	\N	126164	126164	126165
25941	41016	6	applied	\N	\N	\N	\N	126166	126166	126167
25941	41017	8	applied	\N	\N	\N	\N	126172	126172	126173
25941	41018	9	applied	\N	\N	\N	\N	126174	126174	126175
25945	41019	0	applied	\N	\N	\N	\N	126184	126184	126185
25945	41020	1	applied	\N	\N	\N	\N	126188	126188	126189
25945	41021	2	applied	\N	\N	\N	\N	126190	126190	126191
25945	41022	3	applied	\N	\N	\N	\N	126192	126192	126193
25945	41023	4	applied	\N	\N	\N	\N	126194	126194	126195
25951	41024	0	applied	\N	\N	\N	\N	126200	126200	126201
25951	41025	1	applied	\N	\N	\N	\N	126202	126202	126203
25951	41026	2	applied	\N	\N	\N	\N	126204	126204	126205
25951	41027	3	applied	\N	\N	\N	\N	126206	126206	126207
25953	41028	0	applied	\N	\N	\N	\N	126211	126211	126212
25953	41029	1	applied	\N	\N	\N	\N	126213	126213	126214
25958	41033	0	applied	\N	\N	\N	\N	126228	126228	126229
25958	41034	1	applied	\N	\N	\N	\N	126230	126230	126231
25958	41035	2	applied	\N	\N	\N	\N	126232	126232	126233
25958	41036	3	applied	\N	\N	\N	\N	126234	126234	126235
25960	41037	0	applied	\N	\N	\N	\N	126241	126241	126242
25960	41038	1	applied	\N	\N	\N	\N	126243	126243	126244
25963	41039	0	applied	\N	\N	\N	\N	126248	126248	126249
25963	41040	1	applied	\N	\N	\N	\N	126250	126250	126251
25963	41041	2	applied	\N	\N	\N	\N	126252	126252	126253
25963	41042	3	applied	\N	\N	1000000000	\N	126254	126254	126255
25963	41043	4	applied	\N	\N	\N	\N	126256	126256	126257
25967	41044	0	applied	\N	\N	\N	\N	126265	126265	126266
25967	41045	1	applied	\N	\N	\N	\N	126267	126267	126268
25967	41046	2	applied	\N	\N	\N	\N	126269	126269	126270
25967	41047	3	applied	\N	\N	\N	\N	126271	126271	126254
25974	41054	0	applied	\N	\N	\N	\N	126294	126294	126295
25974	41055	1	applied	\N	\N	\N	\N	126296	126296	126297
25977	41056	0	applied	\N	\N	\N	\N	126302	126302	126303
25977	41057	1	applied	\N	\N	\N	\N	126304	126304	126305
25979	41062	0	applied	\N	\N	\N	\N	126320	126320	126321
25979	41063	1	applied	\N	\N	\N	\N	126322	126322	126323
25982	41068	0	applied	\N	\N	\N	\N	126336	126336	126337
25982	41069	1	applied	\N	\N	\N	\N	126338	126338	126339
25984	41068	0	applied	\N	\N	\N	\N	126336	126336	126337
25984	41069	1	applied	\N	\N	\N	\N	126338	126338	126339
25987	41078	0	applied	\N	\N	\N	\N	126363	126363	126364
25987	41079	1	applied	\N	\N	\N	\N	126365	126365	126366
25992	41084	0	applied	\N	\N	\N	\N	126384	126384	126385
25992	41085	1	applied	\N	\N	\N	\N	126386	126386	126387
25999	41090	0	applied	\N	\N	\N	\N	126405	126405	126406
25999	41091	1	applied	\N	\N	\N	\N	126407	126407	126408
25999	41092	2	applied	\N	\N	\N	\N	126409	126409	126410
25999	41093	3	applied	\N	\N	\N	\N	126411	126411	126412
25999	41094	4	applied	\N	\N	\N	\N	126413	126413	23829
26001	41090	0	applied	\N	\N	\N	\N	126405	126405	126406
26001	41091	1	applied	\N	\N	\N	\N	126407	126407	126408
26001	41095	2	applied	\N	\N	\N	\N	126415	126415	126416
26001	41092	3	applied	\N	\N	\N	\N	126409	126409	126410
26001	41093	4	applied	\N	\N	\N	\N	126411	126411	126412
26001	41096	5	applied	\N	\N	\N	\N	126417	126417	126418
26001	41094	6	applied	\N	\N	\N	\N	126413	126413	23829
26006	41099	0	applied	\N	\N	\N	\N	126430	126430	126431
26006	41100	1	applied	\N	\N	\N	\N	126432	126432	126433
26006	41101	2	applied	\N	\N	\N	\N	126434	126434	126435
26006	41102	3	applied	\N	\N	\N	\N	126436	126436	126437
26006	41098	4	applied	\N	\N	\N	\N	126428	126428	126438
26006	41103	5	applied	\N	\N	\N	\N	126439	126439	126440
26006	41104	6	applied	\N	\N	\N	\N	126441	126441	126442
26009	41114	0	applied	\N	\N	\N	\N	126466	126466	126467
26009	41115	1	applied	\N	\N	\N	\N	126468	126468	126469
26009	41116	2	applied	\N	\N	\N	\N	126470	126470	126471
26016	41124	0	applied	\N	\N	\N	\N	126612	126612	126613
26016	41125	1	applied	\N	\N	\N	\N	126614	126614	126615
26016	41126	2	applied	\N	\N	\N	\N	126616	126616	126617
26018	41127	0	applied	\N	\N	\N	\N	126619	126619	126620
26018	41128	1	applied	\N	\N	\N	\N	126621	126621	126622
26018	41129	2	applied	\N	\N	\N	\N	126623	126623	126624
26020	41127	0	applied	\N	\N	\N	\N	126619	126619	126620
26020	41128	1	applied	\N	\N	\N	\N	126621	126621	126622
26020	41129	2	applied	\N	\N	\N	\N	126623	126623	126624
26025	41134	0	applied	\N	\N	\N	\N	126642	126642	126643
26025	41135	1	applied	\N	\N	\N	\N	126644	126644	126645
26040	41146	0	applied	\N	\N	\N	\N	126787	126787	126788
26040	41147	1	applied	\N	\N	\N	\N	126789	126789	126790
26051	41179	0	applied	\N	\N	\N	\N	126872	126872	126873
26051	41180	1	applied	\N	\N	\N	\N	126874	126874	126875
26051	41181	2	applied	\N	\N	\N	\N	126876	126876	126877
26051	41182	3	applied	\N	\N	\N	\N	126878	126878	126879
26051	41183	4	applied	\N	\N	\N	\N	126880	126880	126881
26051	41184	5	applied	\N	\N	\N	\N	126882	126882	126883
26051	41185	6	applied	\N	\N	\N	\N	126884	126884	126885
26051	41186	7	applied	\N	\N	\N	\N	126886	126886	126887
26051	41187	8	applied	\N	\N	\N	\N	126888	126888	126889
26051	41188	9	applied	\N	\N	\N	\N	126890	126890	126891
26053	41179	0	applied	\N	\N	\N	\N	126872	126872	126873
26053	41180	1	applied	\N	\N	\N	\N	126874	126874	126875
26053	41181	2	applied	\N	\N	\N	\N	126876	126876	126877
26053	41182	3	applied	\N	\N	\N	\N	126878	126878	126879
26053	41183	4	applied	\N	\N	\N	\N	126880	126880	126881
26053	41184	5	applied	\N	\N	\N	\N	126882	126882	126883
26053	41185	6	applied	\N	\N	\N	\N	126884	126884	126885
26053	41186	7	applied	\N	\N	\N	\N	126886	126886	126887
26053	41189	8	applied	\N	\N	\N	\N	126894	126894	126895
26053	41190	9	applied	\N	\N	\N	\N	126896	126896	126897
26056	41191	0	applied	\N	\N	\N	\N	126901	126901	126902
26056	41192	1	applied	\N	\N	\N	\N	126903	126903	126904
25955	41032	2	applied	\N	\N	\N	\N	126223	126223	126224
25962	41039	0	applied	\N	\N	\N	\N	126248	126248	126249
25962	41040	1	applied	\N	\N	\N	\N	126250	126250	126251
25962	41041	2	applied	\N	\N	\N	\N	126252	126252	126253
25962	41042	3	applied	\N	\N	1000000000	\N	126254	126254	126255
25962	41043	4	applied	\N	\N	\N	\N	126256	126256	126257
25965	41039	0	applied	\N	\N	\N	\N	126248	126248	126249
25965	41040	1	applied	\N	\N	\N	\N	126250	126250	126251
25965	41041	2	applied	\N	\N	\N	\N	126252	126252	126253
25965	41042	3	applied	\N	\N	1000000000	\N	126254	126254	126255
25965	41043	4	applied	\N	\N	\N	\N	126256	126256	126257
25966	41039	0	applied	\N	\N	\N	\N	126248	126248	126249
25966	41040	1	applied	\N	\N	\N	\N	126250	126250	126251
25966	41041	2	applied	\N	\N	\N	\N	126252	126252	126253
25966	41042	3	applied	\N	\N	1000000000	\N	126254	126254	126255
25966	41043	4	applied	\N	\N	\N	\N	126256	126256	126257
25971	41048	0	applied	\N	\N	\N	\N	126276	126276	126277
25971	41049	1	applied	\N	\N	\N	\N	126278	126278	126279
25976	41056	0	applied	\N	\N	\N	\N	126302	126302	126303
25976	41057	1	applied	\N	\N	\N	\N	126304	126304	126305
25981	41066	0	applied	\N	\N	\N	\N	126331	126331	126332
25981	41067	1	applied	\N	\N	\N	\N	126333	126333	126334
25989	41080	0	applied	\N	\N	\N	\N	126370	126370	126371
25989	41081	1	applied	\N	\N	\N	\N	126372	126372	126373
25991	41082	0	applied	\N	\N	\N	\N	126378	126378	126379
25991	41083	1	applied	\N	\N	\N	\N	126380	126380	126381
25994	41086	0	applied	\N	\N	\N	\N	126392	126392	126393
25994	41087	1	applied	\N	\N	\N	\N	126394	126394	126395
25994	41088	2	applied	\N	\N	\N	\N	126396	126396	126397
25994	41089	3	applied	\N	\N	\N	\N	126398	126398	126399
26003	40992	0	applied	\N	\N	\N	\N	126422	126422	125109
26003	41030	1	applied	\N	\N	\N	\N	126218	126218	126219
26003	41042	2	applied	\N	\N	1000000000	\N	126254	126254	126255
26003	41094	3	applied	\N	\N	\N	\N	126413	126413	23829
26008	41108	0	applied	\N	\N	\N	\N	126452	126452	126453
26008	41109	1	applied	\N	\N	\N	\N	126454	126454	126455
26008	41110	2	applied	\N	\N	\N	\N	126456	126456	126457
26008	41111	3	applied	\N	\N	\N	\N	126458	126458	126459
26008	41112	4	applied	\N	\N	\N	\N	126460	126460	126461
26008	41113	5	applied	\N	\N	\N	\N	126462	126462	126463
26011	41117	0	applied	\N	\N	\N	\N	126474	126474	126475
26011	41118	1	applied	\N	\N	\N	\N	126476	126476	126477
26011	41119	2	applied	\N	\N	\N	\N	126478	126478	126479
26013	41120	0	applied	\N	\N	\N	\N	126480	126480	126481
26013	41121	1	applied	\N	\N	\N	\N	126482	126482	126483
26013	41122	2	applied	\N	\N	\N	\N	126484	126484	126485
26013	41123	3	applied	\N	\N	\N	\N	126486	126486	126487
26015	41124	0	applied	\N	\N	\N	\N	126612	126612	126613
26015	41125	1	applied	\N	\N	\N	\N	126614	126614	126615
26015	41126	2	applied	\N	\N	\N	\N	126616	126616	126617
26022	41132	0	applied	\N	\N	\N	\N	126636	126636	126637
26022	41133	1	applied	\N	\N	\N	\N	126638	126638	126639
26024	41134	0	applied	\N	\N	\N	\N	126642	126642	126643
26024	41135	1	applied	\N	\N	\N	\N	126644	126644	126645
26031	41138	0	applied	\N	\N	\N	\N	126656	126656	126657
26031	41139	1	applied	\N	\N	\N	\N	126658	126658	126659
26038	41142	0	applied	\N	\N	\N	\N	126775	126775	126776
26038	41143	1	applied	\N	\N	\N	\N	126777	126777	126778
26038	41144	2	applied	\N	\N	\N	\N	126779	126779	126780
26038	41145	3	applied	\N	\N	\N	\N	126781	126781	126782
26042	41148	0	applied	\N	\N	\N	\N	126793	126793	126794
26042	41149	1	applied	\N	\N	\N	\N	126795	126795	126796
26044	41148	0	applied	\N	\N	\N	\N	126793	126793	126794
26044	41149	1	applied	\N	\N	\N	\N	126795	126795	126796
26047	41156	0	applied	\N	\N	\N	\N	126817	126817	126818
26047	41157	1	applied	\N	\N	\N	\N	126819	126819	126820
26050	41169	0	applied	\N	\N	\N	\N	126849	126849	126850
26050	41170	2	applied	\N	\N	\N	\N	126852	126852	126853
26050	41171	3	applied	\N	\N	\N	\N	126854	126854	126855
26050	41172	4	applied	\N	\N	\N	\N	126856	126856	126857
26050	41173	5	applied	\N	\N	\N	\N	126858	126858	126859
26050	41174	6	applied	\N	\N	\N	\N	126860	126860	126861
26050	41175	7	applied	\N	\N	\N	\N	126862	126862	126863
26050	41176	8	applied	\N	\N	\N	\N	126864	126864	126865
26050	41177	9	applied	\N	\N	\N	\N	126866	126866	126867
26050	41178	10	applied	\N	\N	\N	\N	126868	126868	126869
26057	41191	0	applied	\N	\N	\N	\N	126901	126901	126902
26057	41192	1	applied	\N	\N	\N	\N	126903	126903	126904
26062	41212	0	applied	\N	\N	\N	\N	126974	126974	126975
26062	41213	1	applied	\N	\N	\N	\N	126976	126976	126977
26062	41214	2	applied	\N	\N	\N	\N	126978	126978	126979
26062	41215	3	applied	\N	\N	\N	\N	126980	126980	126981
26066	41231	0	applied	\N	\N	\N	\N	127017	127017	127018
26066	41232	1	applied	\N	\N	\N	\N	127019	127019	127020
26066	41233	2	applied	\N	\N	\N	\N	127021	127021	127022
26066	41234	3	applied	\N	\N	\N	\N	127023	127023	127024
26066	41235	4	applied	\N	\N	\N	\N	127025	127025	127026
26066	41236	5	applied	\N	\N	\N	\N	127027	127027	127028
26066	41237	6	applied	\N	\N	\N	\N	127029	127029	127030
26066	41238	7	applied	\N	\N	\N	\N	127031	127031	127032
26066	41239	8	applied	\N	\N	\N	\N	127033	127033	127034
26074	41258	0	applied	\N	\N	\N	\N	127083	127083	127084
26074	41259	1	applied	\N	\N	\N	\N	127085	127085	127086
26077	41260	0	applied	\N	\N	\N	\N	127088	127088	127089
26077	41261	1	applied	\N	\N	\N	\N	127090	127090	127091
26081	41264	0	applied	\N	\N	\N	\N	127101	127101	127102
26081	41265	2	applied	\N	\N	\N	\N	127104	127104	127105
26083	41264	0	applied	\N	\N	\N	\N	127101	127101	127102
26083	41265	2	applied	\N	\N	\N	\N	127104	127104	127105
26084	41266	0	applied	\N	\N	\N	\N	127116	127116	127117
26084	41267	1	applied	\N	\N	\N	\N	127118	127118	127119
26084	41268	2	applied	\N	\N	\N	\N	127120	127120	127121
26084	41269	3	applied	\N	\N	\N	\N	127122	127122	127123
26084	41270	4	applied	\N	\N	\N	\N	127124	127124	127125
26084	41271	5	applied	\N	\N	\N	\N	127126	127126	127127
26084	41272	6	applied	\N	\N	\N	\N	127128	127128	127129
26084	41273	7	applied	\N	\N	\N	\N	127130	127130	127131
26089	41278	0	applied	\N	\N	\N	\N	127144	127144	127145
26089	41279	1	applied	\N	\N	\N	\N	127146	127146	127147
26091	41280	0	applied	\N	\N	\N	\N	127152	127152	127153
26091	41281	1	applied	\N	\N	\N	\N	127154	127154	127155
26093	41282	0	applied	\N	\N	\N	\N	127160	127160	127161
26093	41283	1	applied	\N	\N	\N	\N	127162	127162	127163
26098	41291	0	applied	\N	\N	\N	\N	127200	127200	127201
26098	41292	1	applied	\N	\N	\N	\N	127202	127202	127203
26101	41298	0	applied	\N	\N	\N	\N	127217	127217	127218
26101	41299	1	applied	\N	\N	\N	\N	127219	127219	127220
26101	41300	2	applied	\N	\N	\N	\N	127221	127221	127222
26101	41301	3	applied	\N	\N	\N	\N	127223	127223	127224
25988	41079	1	applied	\N	\N	\N	\N	126365	126365	126366
25993	41084	0	applied	\N	\N	\N	\N	126384	126384	126385
25993	41085	1	applied	\N	\N	\N	\N	126386	126386	126387
26000	41090	0	applied	\N	\N	\N	\N	126405	126405	126406
26000	41091	1	applied	\N	\N	\N	\N	126407	126407	126408
26000	41095	2	applied	\N	\N	\N	\N	126415	126415	126416
26000	41092	3	applied	\N	\N	\N	\N	126409	126409	126410
26000	41093	4	applied	\N	\N	\N	\N	126411	126411	126412
26000	41096	5	applied	\N	\N	\N	\N	126417	126417	126418
26000	41094	6	applied	\N	\N	\N	\N	126413	126413	23829
26002	40948	0	applied	\N	\N	1000000000	\N	125977	125977	125978
26002	40867	1	applied	\N	\N	\N	\N	125716	125716	125716
26002	40831	2	applied	\N	\N	1000000000	\N	125612	125612	125613
26002	40744	3	applied	\N	\N	1000000000	\N	125376	125376	125377
26002	40842	4	applied	\N	\N	\N	\N	125641	125641	125642
26002	40755	5	applied	\N	\N	\N	\N	125407	125407	125408
26002	40961	6	applied	\N	\N	\N	\N	126014	126014	126015
26002	40847	7	applied	\N	\N	\N	\N	125664	125664	125665
26002	40763	8	applied	\N	\N	\N	\N	125424	125424	125377
26005	41097	0	applied	\N	\N	\N	\N	126425	126425	126426
26005	41098	1	applied	\N	\N	\N	\N	126428	126428	126429
26007	41105	0	applied	\N	\N	\N	\N	126444	126444	126445
26007	41106	1	applied	\N	\N	\N	\N	126446	126446	126447
26007	41107	2	applied	\N	\N	\N	\N	126448	126448	126449
26010	41117	0	applied	\N	\N	\N	\N	126474	126474	126475
26010	41118	1	applied	\N	\N	\N	\N	126476	126476	126477
26010	41119	2	applied	\N	\N	\N	\N	126478	126478	126479
26019	41129	0	applied	\N	\N	\N	\N	126623	126623	126626
26026	41136	0	applied	\N	\N	\N	\N	126650	126650	126651
26026	41137	1	applied	\N	\N	\N	\N	126652	126652	126653
26029	41138	0	applied	\N	\N	\N	\N	126656	126656	126657
26029	41139	1	applied	\N	\N	\N	\N	126658	126658	126659
26037	41142	0	applied	\N	\N	\N	\N	126775	126775	126776
26037	41143	1	applied	\N	\N	\N	\N	126777	126777	126778
26037	41144	2	applied	\N	\N	\N	\N	126779	126779	126780
26037	41145	3	applied	\N	\N	\N	\N	126781	126781	126782
26046	41152	0	applied	\N	\N	\N	\N	126807	126807	126808
26046	41153	1	applied	\N	\N	\N	\N	126809	126809	126810
26046	41154	2	applied	\N	\N	\N	\N	126811	126811	126812
26046	41155	3	applied	\N	\N	\N	\N	126813	126813	126814
26052	41187	0	applied	\N	\N	\N	\N	126888	126888	126889
26052	41188	1	applied	\N	\N	\N	\N	126890	126890	126891
26059	41195	0	applied	\N	\N	\N	\N	126913	126913	126914
26059	41196	1	applied	\N	\N	\N	\N	126915	126915	126916
26059	41197	2	applied	\N	\N	\N	\N	126917	126917	126918
26059	41198	3	applied	\N	\N	\N	\N	126919	126919	126920
26059	41199	4	applied	\N	\N	\N	\N	126921	126921	126922
26059	41200	5	applied	\N	\N	\N	\N	126923	126923	126924
26061	41201	0	applied	\N	\N	\N	\N	126950	126950	126951
26061	41202	1	applied	\N	\N	\N	\N	126952	126952	126953
26061	41203	2	applied	\N	\N	\N	\N	126954	126954	126955
26061	41204	3	applied	\N	\N	\N	\N	126956	126956	126957
26061	41205	4	applied	\N	\N	\N	\N	126958	126958	126959
26061	41206	5	applied	\N	\N	\N	\N	126960	126960	126961
26061	41207	6	applied	\N	\N	\N	\N	126962	126962	126963
26061	41208	7	applied	\N	\N	\N	\N	126964	126964	126965
26061	41209	8	applied	\N	\N	\N	\N	126966	126966	126967
26061	41210	9	applied	\N	\N	\N	\N	126968	126968	126969
26061	41211	10	applied	\N	\N	\N	\N	126970	126970	126971
26069	41246	0	applied	\N	\N	\N	\N	127053	127053	127054
26069	41247	1	applied	\N	\N	\N	\N	127055	127055	127056
26069	41248	2	applied	\N	\N	\N	\N	127057	127057	127058
26069	41249	3	applied	\N	\N	\N	\N	127059	127059	127060
26069	41250	4	applied	\N	\N	\N	\N	127061	127061	127062
26069	41251	5	applied	\N	\N	\N	\N	127063	127063	127064
26069	41252	6	applied	\N	\N	\N	\N	127065	127065	127066
26069	41253	7	applied	\N	\N	\N	\N	127067	127067	127068
26072	41254	0	applied	\N	\N	\N	\N	127072	127072	127073
26072	41255	1	applied	\N	\N	\N	\N	127074	127074	127075
26072	41256	2	applied	\N	\N	\N	\N	127076	127076	127077
26072	41257	3	applied	\N	\N	\N	\N	127078	127078	127079
26078	41262	0	applied	\N	\N	\N	\N	127093	127093	127094
26078	41263	1	applied	\N	\N	\N	\N	127095	127095	127096
26086	41276	0	applied	\N	\N	\N	\N	127139	127139	127140
26086	41277	1	applied	\N	\N	\N	\N	127141	127141	127142
26088	41278	0	applied	\N	\N	\N	\N	127144	127144	127145
26088	41279	1	applied	\N	\N	\N	\N	127146	127146	127147
26095	41286	0	applied	\N	\N	\N	\N	127172	127172	127173
26095	41287	1	applied	\N	\N	\N	\N	127174	127174	127175
26100	41296	0	applied	\N	\N	\N	\N	127212	127212	127213
26100	41297	1	applied	\N	\N	\N	\N	127214	127214	127215
26103	41298	0	applied	\N	\N	\N	\N	127217	127217	127218
26103	41299	1	applied	\N	\N	\N	\N	127219	127219	127220
26103	41300	2	applied	\N	\N	\N	\N	127221	127221	127222
26103	41301	3	applied	\N	\N	\N	\N	127223	127223	127224
26107	40948	0	applied	\N	\N	1000000000	\N	127245	127245	125978
26107	41195	1	applied	\N	\N	\N	\N	127246	127246	126914
26107	41158	2	applied	\N	\N	\N	\N	127247	127247	126826
26107	41161	3	applied	\N	\N	\N	\N	127248	127248	126832
26107	41162	4	applied	\N	\N	\N	\N	127249	127249	126834
26107	41163	5	applied	\N	\N	\N	\N	127250	127250	126836
26107	41169	6	applied	\N	\N	\N	\N	127251	127251	126850
26107	41171	7	applied	\N	\N	\N	\N	127252	127252	126855
26107	41196	8	applied	\N	\N	\N	\N	127253	127253	126916
26107	41197	9	applied	\N	\N	\N	\N	127254	127254	126918
26107	41198	10	applied	\N	\N	\N	\N	127255	127255	126920
26107	41201	11	applied	\N	\N	\N	\N	127256	127256	126951
26107	41203	12	applied	\N	\N	\N	\N	127257	127257	126955
26107	40992	13	applied	\N	\N	\N	\N	127258	127258	123700
26107	41204	14	applied	\N	\N	\N	\N	127259	127259	126957
26107	41205	15	applied	\N	\N	\N	\N	127260	127260	126959
26107	41206	16	applied	\N	\N	\N	\N	127261	127261	126961
26107	41207	17	applied	\N	\N	\N	\N	127262	127262	126963
26107	41208	18	applied	\N	\N	\N	\N	127263	127263	126965
26107	41209	19	applied	\N	\N	\N	\N	127264	127264	126967
26107	41210	20	applied	\N	\N	\N	\N	127265	127265	126969
26107	41288	21	applied	\N	\N	\N	\N	127266	127266	127022
26107	41289	22	applied	\N	\N	\N	\N	127267	127267	127041
26107	41290	23	applied	\N	\N	\N	\N	127268	127268	127045
26107	41219	24	applied	\N	\N	\N	\N	127269	127269	126993
26107	41220	25	applied	\N	\N	\N	\N	127270	127270	126995
26107	41221	26	applied	\N	\N	\N	\N	127271	127271	126997
26107	41222	27	applied	\N	\N	\N	\N	127272	127272	126999
26107	41223	28	applied	\N	\N	\N	\N	127273	127273	127001
26107	41030	29	applied	\N	\N	\N	\N	127274	127274	126219
26107	41172	30	applied	\N	\N	\N	\N	127275	127275	126857
26107	41173	31	applied	\N	\N	\N	\N	127276	127276	126859
26107	41174	32	applied	\N	\N	\N	\N	127277	127277	126861
26107	41175	33	applied	\N	\N	\N	\N	127278	127278	126863
26014	40454	38	applied	\N	\N	\N	\N	124526	124526	126523
26014	40455	39	applied	\N	\N	\N	\N	124528	124528	126524
26014	40456	40	applied	\N	\N	\N	\N	124530	124530	126525
26014	40465	41	applied	\N	\N	\N	\N	124551	124551	126526
26014	40468	42	applied	\N	\N	\N	\N	124560	124560	126527
26014	40471	43	applied	\N	\N	\N	\N	124566	124566	126528
26014	40474	44	applied	\N	\N	\N	\N	124617	124617	126529
26014	40475	45	applied	\N	\N	\N	\N	124619	124619	126530
26014	40480	46	applied	\N	\N	\N	\N	124633	124633	126531
26014	40481	47	applied	\N	\N	\N	\N	124635	124635	126532
26014	40486	48	applied	\N	\N	\N	\N	124646	124646	126533
26014	40489	49	applied	\N	\N	\N	\N	124654	124654	126534
26014	40495	50	applied	\N	\N	\N	\N	124672	124672	126535
26014	40498	51	applied	\N	\N	\N	\N	124680	124680	126536
26014	40499	52	applied	\N	\N	\N	\N	124682	124682	126537
26014	40504	53	applied	\N	\N	\N	\N	124702	124702	126538
26014	40505	54	applied	\N	\N	\N	\N	124704	124704	126539
26014	40511	55	applied	\N	\N	\N	\N	124718	124718	126540
26014	40512	56	applied	\N	\N	\N	\N	124720	124720	126541
26014	40513	57	applied	\N	\N	\N	\N	124722	124722	126542
26014	40514	58	applied	\N	\N	\N	\N	124724	124724	126543
26014	40523	59	applied	\N	\N	\N	\N	124744	124744	126544
26014	40524	60	applied	\N	\N	\N	\N	124746	124746	126545
26014	40529	61	applied	\N	\N	\N	\N	124758	124758	126546
26014	40532	62	applied	\N	\N	\N	\N	124769	124769	126547
26014	40535	63	applied	\N	\N	\N	\N	124779	124779	126548
26014	40538	64	applied	\N	\N	\N	\N	124788	124788	126549
26014	40541	65	applied	\N	\N	\N	\N	124796	124796	126550
26014	40544	66	applied	\N	\N	\N	\N	124807	124807	126551
26014	40547	67	applied	\N	\N	\N	\N	124821	124821	126552
26014	40548	68	applied	\N	\N	\N	\N	124823	124823	126553
26014	40549	69	applied	\N	\N	\N	\N	124825	124825	126554
26014	40556	70	applied	\N	\N	\N	\N	124849	124849	126555
26014	40559	71	applied	\N	\N	\N	\N	124856	124856	126556
26014	40560	72	applied	\N	\N	\N	\N	124858	124858	126557
26014	40565	73	applied	\N	\N	\N	\N	124873	124873	126558
26014	40567	74	applied	\N	\N	\N	\N	124879	124879	126559
26014	40570	75	applied	\N	\N	\N	\N	124887	124887	126560
26014	40571	76	applied	\N	\N	\N	\N	124889	124889	126561
26014	40576	77	applied	\N	\N	\N	\N	124901	124901	126562
26014	40577	78	applied	\N	\N	\N	\N	124903	124903	126563
26014	40578	79	applied	\N	\N	\N	\N	124905	124905	126564
26014	40586	80	applied	\N	\N	\N	\N	124922	124922	126565
26014	40589	81	applied	\N	\N	\N	\N	124934	124934	126566
26014	40592	82	applied	\N	\N	\N	\N	124944	124944	126567
26014	40595	83	applied	\N	\N	\N	\N	124954	124954	126568
26014	40598	84	applied	\N	\N	\N	\N	124966	124966	126569
26014	40601	86	applied	\N	\N	\N	\N	124974	124974	126571
26014	40602	87	applied	\N	\N	\N	\N	124976	124976	126572
26014	40608	88	applied	\N	\N	\N	\N	124992	124992	126573
26014	40609	89	applied	\N	\N	\N	\N	124994	124994	126574
26014	40610	90	applied	\N	\N	\N	\N	124996	124996	126575
26014	40617	91	applied	\N	\N	\N	\N	125019	125019	126576
26014	40620	92	applied	\N	\N	\N	\N	125029	125029	126577
26014	40623	93	applied	\N	\N	\N	\N	125038	125038	126578
26014	40626	94	applied	\N	\N	\N	\N	125046	125046	126579
26014	40629	95	applied	\N	\N	\N	\N	125054	125054	126580
26014	40630	96	applied	\N	\N	\N	\N	125056	125056	126581
26014	40635	97	applied	\N	\N	\N	\N	125069	125069	126582
26014	40638	98	applied	\N	\N	\N	\N	125077	125077	126583
26014	40641	99	applied	\N	\N	\N	\N	125083	125083	126584
26014	40642	100	applied	\N	\N	\N	\N	125085	125085	126585
26014	40647	101	applied	\N	\N	\N	\N	125097	125097	126586
26014	40650	102	applied	\N	\N	\N	\N	125105	125105	126587
26014	40651	103	applied	\N	\N	\N	\N	125107	125107	126588
26014	40652	104	applied	\N	\N	\N	\N	125109	125109	126422
26014	40659	105	applied	\N	\N	\N	\N	125125	125125	126589
26014	40662	106	applied	\N	\N	\N	\N	125132	125132	126590
26014	40665	107	applied	\N	\N	\N	\N	125140	125140	126591
26014	40666	108	applied	\N	\N	\N	\N	125142	125142	126592
26014	40671	109	applied	\N	\N	\N	\N	125158	125158	126593
26014	40677	110	applied	\N	\N	\N	\N	125181	125181	126594
26014	40679	111	applied	\N	\N	\N	\N	125192	125192	126595
26014	40682	112	applied	\N	\N	\N	\N	125202	125202	126596
26014	40684	113	applied	\N	\N	\N	\N	125207	125207	126597
26014	40688	114	applied	\N	\N	\N	\N	125216	125216	126598
26014	40691	115	applied	\N	\N	\N	\N	125225	125225	126599
26014	40694	116	applied	\N	\N	\N	\N	125233	125233	126600
26014	40697	117	applied	\N	\N	\N	\N	125245	125245	126601
26014	40700	118	applied	\N	\N	\N	\N	125255	125255	126602
26014	40703	119	applied	\N	\N	\N	\N	125263	125263	126603
26014	40706	120	applied	\N	\N	\N	\N	125277	125277	126604
26014	40709	121	applied	\N	\N	\N	\N	125286	125286	126605
26014	40712	122	applied	\N	\N	\N	\N	125294	125294	126606
26014	40715	123	applied	\N	\N	\N	\N	125302	125302	126607
26014	40716	124	applied	\N	\N	\N	\N	125304	125304	126608
26014	40721	125	applied	\N	\N	\N	\N	125317	125317	126609
26021	41130	0	applied	\N	\N	\N	\N	126630	126630	126631
26021	41131	1	applied	\N	\N	\N	\N	126632	126632	126633
26023	41132	0	applied	\N	\N	\N	\N	126636	126636	126637
26023	41133	1	applied	\N	\N	\N	\N	126638	126638	126639
26028	41138	0	applied	\N	\N	\N	\N	126656	126656	126657
26028	41139	1	applied	\N	\N	\N	\N	126658	126658	126659
26030	41138	0	applied	\N	\N	\N	\N	126656	126656	126657
26030	41139	1	applied	\N	\N	\N	\N	126658	126658	126659
26033	40948	0	applied	\N	\N	1000000000	\N	125977	125977	125978
26033	40715	1	applied	\N	\N	\N	\N	125302	125302	125303
26033	40992	2	applied	\N	\N	\N	\N	126607	126607	125302
26033	41030	3	applied	\N	\N	\N	\N	126218	126218	126219
26033	40716	4	applied	\N	\N	\N	\N	125304	125304	126608
26033	40721	5	applied	\N	\N	\N	\N	125317	125317	126609
26033	40724	6	applied	\N	\N	\N	\N	125326	125326	126668
26033	40727	7	applied	\N	\N	\N	\N	125334	125334	126669
26033	40728	8	applied	\N	\N	\N	\N	125336	125336	126670
26033	40733	9	applied	\N	\N	\N	\N	125348	125348	126671
26033	40734	10	applied	\N	\N	\N	\N	125350	125350	126672
26033	40739	11	applied	\N	\N	\N	\N	125364	125364	126673
26033	40742	12	applied	\N	\N	\N	\N	125372	125372	126674
26033	40746	13	applied	\N	\N	\N	\N	125388	125388	126675
26033	40749	14	applied	\N	\N	\N	\N	125395	125395	126676
26033	40750	15	applied	\N	\N	\N	\N	125397	125397	126677
26033	40751	16	applied	\N	\N	\N	\N	125399	125399	126678
26033	40752	17	applied	\N	\N	\N	\N	125401	125401	126679
26033	40753	18	applied	\N	\N	\N	\N	125403	125403	126680
26033	40766	19	applied	\N	\N	\N	\N	125434	125434	126681
26033	40768	20	applied	\N	\N	\N	\N	125446	125446	126682
26033	40771	21	applied	\N	\N	\N	\N	125452	125452	126683
26033	40774	22	applied	\N	\N	\N	\N	125462	125462	126684
26033	40775	23	applied	\N	\N	\N	\N	125464	125464	126685
26033	40780	24	applied	\N	\N	\N	\N	125478	125478	126686
26033	40784	25	applied	\N	\N	\N	\N	125490	125490	126687
26033	40787	26	applied	\N	\N	\N	\N	125500	125500	126688
26033	40790	27	applied	\N	\N	\N	\N	125508	125508	126689
26033	40793	28	applied	\N	\N	\N	\N	125516	125516	126690
26033	40794	29	applied	\N	\N	\N	\N	125518	125518	126691
26033	40799	30	applied	\N	\N	\N	\N	125533	125533	126692
26033	40800	31	applied	\N	\N	\N	\N	125535	125535	126693
26033	40805	32	applied	\N	\N	\N	\N	125549	125549	126694
26033	40807	33	applied	\N	\N	\N	\N	125554	125554	126695
26033	40808	34	applied	\N	\N	\N	\N	125556	125556	126696
26033	40814	35	applied	\N	\N	\N	\N	125571	125571	126697
26033	40815	36	applied	\N	\N	\N	\N	125573	125573	126698
26033	40816	37	applied	\N	\N	\N	\N	125575	125575	126699
26033	40823	38	applied	\N	\N	\N	\N	125593	125593	126700
26033	40826	39	applied	\N	\N	\N	\N	125600	125600	126701
26033	40829	40	applied	\N	\N	\N	\N	125608	125608	126702
26033	40830	41	applied	\N	\N	\N	\N	125610	125610	126703
26033	40836	42	applied	\N	\N	\N	\N	125625	125625	126704
26033	40839	43	applied	\N	\N	\N	\N	125635	125635	126705
26033	40843	44	applied	\N	\N	\N	\N	125650	125650	126706
26033	40846	45	applied	\N	\N	\N	\N	125662	125662	126707
26033	40850	46	applied	\N	\N	\N	\N	125673	125673	126708
26033	40854	47	applied	\N	\N	\N	\N	125682	125682	126709
26033	40856	48	applied	\N	\N	\N	\N	125692	125692	126710
26033	40857	49	applied	\N	\N	\N	\N	125694	125694	126711
26033	40862	50	applied	\N	\N	\N	\N	125706	125706	126712
26033	40863	51	applied	\N	\N	\N	\N	125708	125708	126713
26033	40864	52	applied	\N	\N	\N	\N	125710	125710	126714
26033	40872	53	applied	\N	\N	\N	\N	125727	125727	126715
26033	40873	54	applied	\N	\N	\N	\N	125729	125729	126716
26033	40878	55	applied	\N	\N	\N	\N	125741	125741	126717
26033	40881	56	applied	\N	\N	\N	\N	125749	125749	126718
26033	40884	57	applied	\N	\N	\N	\N	125756	125756	126719
26033	40887	58	applied	\N	\N	\N	\N	125764	125764	126720
26033	40888	59	applied	\N	\N	\N	\N	125766	125766	126721
26033	40893	60	applied	\N	\N	\N	\N	125781	125781	126722
26033	40896	61	applied	\N	\N	\N	\N	125789	125789	126723
26033	40897	62	applied	\N	\N	\N	\N	125791	125791	126724
26033	40902	63	applied	\N	\N	\N	\N	125840	125840	126725
26033	40905	65	applied	\N	\N	\N	\N	125855	125855	126727
26033	40906	66	applied	\N	\N	\N	\N	125857	125857	126728
26033	40911	67	applied	\N	\N	\N	\N	125873	125873	126729
26033	40912	68	applied	\N	\N	\N	\N	125875	125875	126730
26033	40913	69	applied	\N	\N	\N	\N	125877	125877	126731
26033	40917	70	applied	\N	\N	\N	\N	125887	125887	126732
26033	40919	71	applied	\N	\N	\N	\N	125894	125894	126733
26033	40921	72	applied	\N	\N	\N	\N	125900	125900	126734
26033	40923	73	applied	\N	\N	\N	\N	125906	125906	126735
26033	40925	74	applied	\N	\N	\N	\N	125911	125911	126736
26033	40926	75	applied	\N	\N	\N	\N	125913	125913	126737
26033	40929	76	applied	\N	\N	\N	\N	125925	125925	126738
26033	40931	77	applied	\N	\N	\N	\N	125931	125931	126739
26033	40933	78	applied	\N	\N	\N	\N	125938	125938	126740
26033	40935	79	applied	\N	\N	\N	\N	125943	125943	126741
26033	40936	80	applied	\N	\N	\N	\N	125945	125945	126742
26033	40937	81	applied	\N	\N	\N	\N	125947	125947	126743
26033	40938	82	applied	\N	\N	\N	\N	125949	125949	126744
26033	40939	83	applied	\N	\N	\N	\N	125951	125951	126745
26033	40946	84	applied	\N	\N	\N	\N	125971	125971	126746
26033	40949	85	applied	\N	\N	\N	\N	125979	125979	126747
26033	40951	86	applied	\N	\N	\N	\N	125989	125989	126748
26033	40953	87	applied	\N	\N	\N	\N	125995	125995	126217
26033	40955	88	applied	\N	\N	\N	\N	126002	126002	126749
26033	40956	89	applied	\N	\N	\N	\N	126004	126004	126750
26033	40957	90	applied	\N	\N	\N	\N	126006	126006	126751
26033	40962	91	applied	\N	\N	\N	\N	126021	126021	126752
26033	40964	92	applied	\N	\N	\N	\N	126031	126031	126753
26033	40966	93	applied	\N	\N	\N	\N	126039	126039	126754
26033	40967	94	applied	\N	\N	\N	\N	126041	126041	126755
26033	40970	95	applied	\N	\N	\N	\N	126050	126050	126756
26033	40972	96	applied	\N	\N	\N	\N	126056	126056	126757
26033	40974	97	applied	\N	\N	\N	\N	126063	126063	126758
26033	40976	98	applied	\N	\N	\N	\N	126069	126069	126759
26033	40977	99	applied	\N	\N	\N	\N	126071	126071	126760
26033	40978	100	applied	\N	\N	\N	\N	126073	126073	126761
26033	40982	101	applied	\N	\N	\N	\N	126083	126083	126762
26033	40984	102	applied	\N	\N	\N	\N	126088	126088	126763
26033	40985	103	applied	\N	\N	\N	\N	126090	126090	126764
26033	40988	104	applied	\N	\N	\N	\N	126097	126097	126765
26033	40990	105	applied	\N	\N	\N	\N	126104	126104	126766
26033	40991	106	applied	\N	\N	\N	\N	126106	126106	126108
26033	40995	107	applied	\N	\N	\N	\N	126115	126115	126116
26033	40996	108	applied	\N	\N	\N	\N	126117	126117	126118
26033	40999	109	applied	\N	\N	\N	\N	126127	126127	126128
26033	41001	110	applied	\N	\N	\N	\N	126132	126132	126133
26033	41003	111	applied	\N	\N	\N	\N	126136	126136	126137
26033	41004	112	applied	\N	\N	\N	\N	126138	126138	126139
26033	41005	113	applied	\N	\N	\N	\N	126140	126140	126141
26033	41009	114	applied	\N	\N	\N	\N	126150	126150	126151
26033	41010	115	applied	\N	\N	\N	\N	126154	126154	126155
26033	41011	116	applied	\N	\N	\N	\N	126156	126156	126157
26033	41012	117	applied	\N	\N	\N	\N	126158	126158	126159
26033	41013	118	applied	\N	\N	\N	\N	126160	126160	126161
26033	41019	119	applied	\N	\N	\N	\N	126184	126184	126185
26033	41020	120	applied	\N	\N	\N	\N	126188	126188	126189
26033	41021	121	applied	\N	\N	\N	\N	126190	126190	126191
26033	41024	122	applied	\N	\N	\N	\N	126200	126200	126201
26033	41025	123	applied	\N	\N	\N	\N	126202	126202	126203
26033	41028	124	applied	\N	\N	\N	\N	126211	126211	126212
26033	41031	125	applied	\N	\N	\N	\N	126221	126221	126222
26036	41140	0	applied	\N	\N	\N	\N	126769	126769	126770
26036	41141	1	applied	\N	\N	\N	\N	126771	126771	126772
26039	41142	0	applied	\N	\N	\N	\N	126775	126775	126776
26039	41143	1	applied	\N	\N	\N	\N	126777	126777	126778
26039	41144	2	applied	\N	\N	\N	\N	126779	126779	126780
26039	41145	3	applied	\N	\N	\N	\N	126781	126781	126782
26041	41148	0	applied	\N	\N	\N	\N	126793	126793	126794
26041	41149	1	applied	\N	\N	\N	\N	126795	126795	126796
26043	41148	0	applied	\N	\N	\N	\N	126793	126793	126794
26043	41149	1	applied	\N	\N	\N	\N	126795	126795	126796
26045	41150	0	applied	\N	\N	\N	\N	126802	126802	126803
26045	41151	1	applied	\N	\N	\N	\N	126804	126804	126805
26048	41156	0	applied	\N	\N	\N	\N	126817	126817	126818
26048	41157	1	applied	\N	\N	\N	\N	126819	126819	126820
26049	41158	0	applied	\N	\N	\N	\N	126825	126825	126826
26049	41159	1	applied	\N	\N	\N	\N	126827	126827	126828
26049	41160	2	applied	\N	\N	\N	\N	126829	126829	126830
26049	41161	3	applied	\N	\N	\N	\N	126831	126831	126832
26049	41162	4	applied	\N	\N	\N	\N	126833	126833	126834
26049	41163	5	applied	\N	\N	\N	\N	126835	126835	126836
26049	41164	6	applied	\N	\N	\N	\N	126837	126837	126838
26049	41165	7	applied	\N	\N	\N	\N	126839	126839	126840
26049	41166	8	applied	\N	\N	\N	\N	126841	126841	126842
26049	41167	9	applied	\N	\N	\N	\N	126843	126843	126844
26049	41168	10	applied	\N	\N	\N	\N	126845	126845	126846
26054	41179	0	applied	\N	\N	\N	\N	126872	126872	126873
26054	41180	1	applied	\N	\N	\N	\N	126874	126874	126875
26054	41181	2	applied	\N	\N	\N	\N	126876	126876	126877
26054	41182	3	applied	\N	\N	\N	\N	126878	126878	126879
26054	41183	4	applied	\N	\N	\N	\N	126880	126880	126881
26054	41184	5	applied	\N	\N	\N	\N	126882	126882	126883
26054	41185	6	applied	\N	\N	\N	\N	126884	126884	126885
26054	41186	7	applied	\N	\N	\N	\N	126886	126886	126887
26054	41189	8	applied	\N	\N	\N	\N	126894	126894	126895
26054	41190	9	applied	\N	\N	\N	\N	126896	126896	126897
26058	41193	0	applied	\N	\N	\N	\N	126907	126907	126908
26058	41194	1	applied	\N	\N	\N	\N	126909	126909	126910
26064	41216	0	applied	\N	\N	\N	\N	126986	126986	126987
26064	41217	1	applied	\N	\N	\N	\N	126988	126988	126989
26064	41218	2	applied	\N	\N	\N	\N	126990	126990	126991
26064	41219	3	applied	\N	\N	\N	\N	126992	126992	126993
26064	41220	4	applied	\N	\N	\N	\N	126994	126994	126995
26064	41221	5	applied	\N	\N	\N	\N	126996	126996	126997
26064	41222	6	applied	\N	\N	\N	\N	126998	126998	126999
26064	41223	7	applied	\N	\N	\N	\N	127000	127000	127001
26064	41224	8	applied	\N	\N	\N	\N	127002	127002	127003
26064	41225	9	applied	\N	\N	\N	\N	127004	127004	127005
26064	41226	10	applied	\N	\N	\N	\N	127006	127006	127007
26064	41227	11	applied	\N	\N	\N	\N	127008	127008	127009
26064	41228	12	applied	\N	\N	\N	\N	127010	127010	127011
26064	41229	13	applied	\N	\N	\N	\N	127012	127012	127013
26064	41230	14	applied	\N	\N	\N	\N	127014	127014	127015
26065	41231	0	applied	\N	\N	\N	\N	127017	127017	127018
26065	41232	1	applied	\N	\N	\N	\N	127019	127019	127020
26065	41233	2	applied	\N	\N	\N	\N	127021	127021	127022
26065	41234	3	applied	\N	\N	\N	\N	127023	127023	127024
26065	41235	4	applied	\N	\N	\N	\N	127025	127025	127026
26065	41236	5	applied	\N	\N	\N	\N	127027	127027	127028
26065	41237	6	applied	\N	\N	\N	\N	127029	127029	127030
26065	41238	7	applied	\N	\N	\N	\N	127031	127031	127032
26065	41239	8	applied	\N	\N	\N	\N	127033	127033	127034
26068	41240	0	applied	\N	\N	\N	\N	127038	127038	127039
26068	41241	1	applied	\N	\N	\N	\N	127040	127040	127041
26068	41242	2	applied	\N	\N	\N	\N	127042	127042	127043
26068	41243	3	applied	\N	\N	\N	\N	127044	127044	127045
26068	41244	4	applied	\N	\N	\N	\N	127046	127046	127047
26068	41245	5	applied	\N	\N	\N	\N	127048	127048	127049
26071	41254	0	applied	\N	\N	\N	\N	127072	127072	127073
26071	41255	1	applied	\N	\N	\N	\N	127074	127074	127075
26071	41256	2	applied	\N	\N	\N	\N	127076	127076	127077
26071	41257	3	applied	\N	\N	\N	\N	127078	127078	127079
26073	41258	0	applied	\N	\N	\N	\N	127083	127083	127084
26073	41259	1	applied	\N	\N	\N	\N	127085	127085	127086
26076	41260	0	applied	\N	\N	\N	\N	127088	127088	127089
26076	41261	1	applied	\N	\N	\N	\N	127090	127090	127091
26080	41264	0	applied	\N	\N	\N	\N	127101	127101	127102
26080	41265	2	applied	\N	\N	\N	\N	127104	127104	127105
26082	41264	0	applied	\N	\N	\N	\N	127101	127101	127102
26082	41265	2	applied	\N	\N	\N	\N	127104	127104	127105
26085	41274	0	applied	\N	\N	\N	\N	127133	127133	127134
26085	41275	1	applied	\N	\N	\N	\N	127135	127135	127136
26090	41280	0	applied	\N	\N	\N	\N	127152	127152	127153
26090	41281	1	applied	\N	\N	\N	\N	127154	127154	127155
26092	41280	0	applied	\N	\N	\N	\N	127152	127152	127153
26092	41281	1	applied	\N	\N	\N	\N	127154	127154	127155
26097	41291	0	applied	\N	\N	\N	\N	127200	127200	127201
26097	41292	1	applied	\N	\N	\N	\N	127202	127202	127203
26099	41293	0	applied	\N	\N	\N	\N	127206	127206	127207
26099	41294	1	applied	\N	\N	\N	\N	127208	127208	44452
26099	41295	2	applied	\N	\N	\N	\N	127209	127209	127210
26102	41298	0	applied	\N	\N	\N	\N	127217	127217	127218
26102	41299	1	applied	\N	\N	\N	\N	127219	127219	127220
26102	41300	2	applied	\N	\N	\N	\N	127221	127221	127222
26102	41301	3	applied	\N	\N	\N	\N	127223	127223	127224
26104	41302	0	applied	\N	\N	\N	\N	127231	127231	127232
26104	41303	1	applied	\N	\N	\N	\N	127233	127233	127234
26112	41308	0	applied	\N	\N	\N	\N	127294	127294	127295
26112	41309	1	applied	\N	\N	\N	\N	127296	127296	127297
26113	41310	0	applied	\N	\N	\N	\N	127306	127306	127307
26113	41311	1	applied	\N	\N	\N	\N	127308	127308	127309
26116	41316	0	applied	\N	\N	\N	\N	127322	127322	127323
26116	41317	1	applied	\N	\N	\N	\N	127324	127324	127325
26122	41332	0	applied	\N	\N	\N	\N	127365	127365	127366
26122	41333	1	applied	\N	\N	\N	\N	127367	127367	127368
26122	41334	2	applied	\N	\N	\N	\N	127369	127369	127370
26122	41335	3	applied	\N	\N	\N	\N	127371	127371	127372
26127	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26127	41343	1	applied	\N	\N	\N	\N	127391	127391	127392
26131	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26131	41343	1	applied	\N	\N	\N	\N	127391	127391	127392
26134	41344	0	applied	\N	\N	\N	\N	127405	127405	127406
26134	41345	1	applied	\N	\N	\N	\N	127407	127407	127408
26145	41358	0	applied	\N	\N	\N	\N	127454	127454	127455
26145	41359	1	applied	\N	\N	\N	\N	127456	127456	127457
26148	41369	0	applied	\N	\N	\N	\N	127480	127480	127481
26148	41370	1	applied	\N	\N	\N	\N	127482	127482	127483
26148	41371	2	applied	\N	\N	\N	\N	127484	127484	127485
26153	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26153	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26153	41374	2	applied	\N	\N	\N	\N	127505	127505	127506
26153	41375	3	applied	\N	\N	\N	\N	127507	127507	127508
26153	41376	4	applied	\N	\N	\N	\N	127509	127509	127510
26153	41377	5	applied	\N	\N	\N	\N	127511	127511	127512
26155	41378	0	applied	\N	\N	\N	\N	127522	127522	127523
26155	41379	1	applied	\N	\N	\N	\N	127524	127524	127525
26155	41380	2	applied	\N	\N	1000000000	\N	127526	127526	127527
26155	41381	3	applied	\N	\N	\N	\N	127528	127528	127529
26155	41382	4	applied	\N	\N	1000000000	\N	127530	127530	127531
26158	41378	0	applied	\N	\N	\N	\N	127522	127522	127523
26158	41379	1	applied	\N	\N	\N	\N	127524	127524	127525
26158	41380	2	applied	\N	\N	1000000000	\N	127526	127526	127527
26158	41381	3	applied	\N	\N	\N	\N	127528	127528	127529
26158	41382	4	applied	\N	\N	1000000000	\N	127530	127530	127531
26162	41397	0	applied	\N	\N	\N	\N	127572	127572	127573
26162	41398	1	applied	\N	\N	\N	\N	127574	127574	127575
26162	41399	2	applied	\N	\N	\N	\N	127576	127576	127577
26167	41409	0	applied	\N	\N	\N	\N	127603	127603	127604
26167	41410	1	applied	\N	\N	\N	\N	127605	127605	127606
26167	41411	2	applied	\N	\N	\N	\N	127607	127607	127608
26060	41158	0	applied	\N	\N	\N	\N	126927	126927	126826
26060	41161	1	applied	\N	\N	\N	\N	126928	126928	126832
26060	41162	2	applied	\N	\N	\N	\N	126929	126929	126834
26060	41163	3	applied	\N	\N	\N	\N	126930	126930	126836
26060	41169	4	applied	\N	\N	\N	\N	126931	126931	126850
26060	41171	5	applied	\N	\N	\N	\N	126932	126932	126855
26060	41172	6	applied	\N	\N	\N	\N	126933	126933	126857
26060	41173	7	applied	\N	\N	\N	\N	126934	126934	126859
26060	41174	8	applied	\N	\N	\N	\N	126935	126935	126861
26060	41175	9	applied	\N	\N	\N	\N	126936	126936	126863
26060	41176	10	applied	\N	\N	\N	\N	126937	126937	126865
26060	41177	11	applied	\N	\N	\N	\N	126938	126938	126867
26060	41179	12	applied	\N	\N	\N	\N	126939	126939	126873
26060	41180	13	applied	\N	\N	\N	\N	126940	126940	126875
26060	41181	14	applied	\N	\N	\N	\N	126941	126941	126877
26060	41182	15	applied	\N	\N	\N	\N	126942	126942	126879
26060	41183	16	applied	\N	\N	\N	\N	126943	126943	126881
26060	41184	17	applied	\N	\N	\N	\N	126944	126944	126883
26060	41185	18	applied	\N	\N	\N	\N	126945	126945	126885
26060	41186	19	applied	\N	\N	\N	\N	126946	126946	126887
26060	41134	20	applied	\N	\N	\N	\N	126642	126642	126643
26060	41136	21	applied	\N	\N	\N	\N	126650	126650	126651
26060	41138	22	applied	\N	\N	\N	\N	126656	126656	126657
26060	41140	23	applied	\N	\N	\N	\N	126769	126769	126770
26060	41142	24	applied	\N	\N	\N	\N	126775	126775	126776
26060	41143	25	applied	\N	\N	\N	\N	126777	126777	126778
26060	41146	26	applied	\N	\N	\N	\N	126787	126787	126788
26060	41148	27	applied	\N	\N	\N	\N	126793	126793	126794
26060	41150	28	applied	\N	\N	\N	\N	126802	126802	126803
26060	41152	29	applied	\N	\N	\N	\N	126807	126807	126808
26060	41153	30	applied	\N	\N	\N	\N	126809	126809	126810
26060	41156	31	applied	\N	\N	\N	\N	126817	126817	126818
26060	41157	32	applied	\N	\N	\N	\N	126819	126819	126820
26060	41159	33	applied	\N	\N	\N	\N	126827	126827	126828
26060	41160	34	applied	\N	\N	\N	\N	126829	126829	126830
26060	41170	35	applied	\N	\N	\N	\N	126852	126852	126853
26060	41187	36	applied	\N	\N	\N	\N	126888	126888	126889
26060	41189	37	applied	\N	\N	\N	\N	126894	126894	126895
26060	41191	38	applied	\N	\N	\N	\N	126901	126901	126902
26060	41193	39	applied	\N	\N	\N	\N	126907	126907	126908
26060	41199	40	applied	\N	\N	\N	\N	126921	126921	126922
26060	41135	41	applied	\N	\N	\N	\N	126644	126644	126645
26060	41137	42	applied	\N	\N	\N	\N	126652	126652	126653
26060	41139	43	applied	\N	\N	\N	\N	126658	126658	126659
26060	41141	44	applied	\N	\N	\N	\N	126771	126771	126772
26060	41144	45	applied	\N	\N	\N	\N	126779	126779	126780
26060	41145	46	applied	\N	\N	\N	\N	126781	126781	126782
26060	41147	47	applied	\N	\N	\N	\N	126789	126789	126790
26060	41149	48	applied	\N	\N	\N	\N	126795	126795	126796
26060	41151	49	applied	\N	\N	\N	\N	126804	126804	126805
26060	41154	50	applied	\N	\N	\N	\N	126811	126811	126812
26060	41155	51	applied	\N	\N	\N	\N	126813	126813	126814
26060	41164	52	applied	\N	\N	\N	\N	126837	126837	126838
26060	41165	53	applied	\N	\N	\N	\N	126839	126839	126840
26060	41166	54	applied	\N	\N	\N	\N	126841	126841	126842
26060	41167	55	applied	\N	\N	\N	\N	126843	126843	126844
26060	41168	56	applied	\N	\N	\N	\N	126845	126845	126846
26060	41178	57	applied	\N	\N	\N	\N	126868	126868	126869
26060	41188	59	applied	\N	\N	\N	\N	126890	126890	126891
26060	41190	60	applied	\N	\N	\N	\N	126896	126896	126897
26060	41192	61	applied	\N	\N	\N	\N	126903	126903	126904
26060	41194	62	applied	\N	\N	\N	\N	126909	126909	126910
26060	41200	63	applied	\N	\N	\N	\N	126923	126923	126924
26063	41212	0	applied	\N	\N	\N	\N	126974	126974	126975
26063	41213	1	applied	\N	\N	\N	\N	126976	126976	126977
26063	41214	2	applied	\N	\N	\N	\N	126978	126978	126979
26063	41215	3	applied	\N	\N	\N	\N	126980	126980	126981
26067	41240	0	applied	\N	\N	\N	\N	127038	127038	127039
26067	41241	1	applied	\N	\N	\N	\N	127040	127040	127041
26067	41242	2	applied	\N	\N	\N	\N	127042	127042	127043
26067	41243	3	applied	\N	\N	\N	\N	127044	127044	127045
26067	41244	4	applied	\N	\N	\N	\N	127046	127046	127047
26067	41245	5	applied	\N	\N	\N	\N	127048	127048	127049
26070	41246	0	applied	\N	\N	\N	\N	127053	127053	127054
26070	41247	1	applied	\N	\N	\N	\N	127055	127055	127056
26070	41248	2	applied	\N	\N	\N	\N	127057	127057	127058
26070	41250	3	applied	\N	\N	\N	\N	127061	127061	127062
26070	41251	4	applied	\N	\N	\N	\N	127063	127063	127064
26070	41252	5	applied	\N	\N	\N	\N	127065	127065	127066
26075	41260	0	applied	\N	\N	\N	\N	127088	127088	127089
26075	41261	1	applied	\N	\N	\N	\N	127090	127090	127091
26079	41262	0	applied	\N	\N	\N	\N	127093	127093	127094
26079	41263	1	applied	\N	\N	\N	\N	127095	127095	127096
26087	41276	0	applied	\N	\N	\N	\N	127139	127139	127140
26087	41277	1	applied	\N	\N	\N	\N	127141	127141	127142
26094	41284	0	applied	\N	\N	\N	\N	127166	127166	127167
26094	41285	1	applied	\N	\N	\N	\N	127168	127168	127169
26096	41195	0	applied	\N	\N	\N	\N	126913	126913	126914
26096	41158	1	applied	\N	\N	\N	\N	126927	126927	126826
26096	41114	2	applied	\N	\N	\N	\N	126466	126466	126467
26096	41117	3	applied	\N	\N	\N	\N	126474	126474	126475
26096	41120	4	applied	\N	\N	\N	\N	126480	126480	126481
26096	41161	5	applied	\N	\N	\N	\N	126928	126928	126832
26096	41162	6	applied	\N	\N	\N	\N	126929	126929	126834
26096	41163	7	applied	\N	\N	\N	\N	126930	126930	126836
26096	41169	8	applied	\N	\N	\N	\N	126931	126931	126850
26096	41171	9	applied	\N	\N	\N	\N	126932	126932	126855
26096	41124	10	applied	\N	\N	\N	\N	126612	126612	126613
26096	41127	11	applied	\N	\N	\N	\N	126619	126619	126620
26096	41130	12	applied	\N	\N	\N	\N	126630	126630	126631
26096	41132	13	applied	\N	\N	\N	\N	126636	126636	126637
26096	41196	14	applied	\N	\N	\N	\N	126915	126915	126916
26096	41197	15	applied	\N	\N	\N	\N	126917	126917	126918
26096	41198	16	applied	\N	\N	\N	\N	126919	126919	126920
26096	41201	17	applied	\N	\N	\N	\N	126950	126950	126951
26096	41203	18	applied	\N	\N	\N	\N	126954	126954	126955
26096	41204	19	applied	\N	\N	\N	\N	126956	126956	126957
26096	41205	20	applied	\N	\N	\N	\N	126958	126958	126959
26096	41206	21	applied	\N	\N	\N	\N	126960	126960	126961
26096	41207	22	applied	\N	\N	\N	\N	126962	126962	126963
26096	41208	23	applied	\N	\N	\N	\N	126964	126964	126965
26096	41209	24	applied	\N	\N	\N	\N	126966	126966	126967
26096	41210	25	applied	\N	\N	\N	\N	126968	126968	126969
26096	41288	26	applied	\N	\N	\N	\N	127178	127178	127022
26096	41289	27	applied	\N	\N	\N	\N	127179	127179	127041
26096	41290	28	applied	\N	\N	\N	\N	127180	127180	127045
26096	41219	29	applied	\N	\N	\N	\N	127181	127181	126993
26096	41220	30	applied	\N	\N	\N	\N	127182	127182	126995
26096	41221	31	applied	\N	\N	\N	\N	127183	127183	126997
26096	41222	32	applied	\N	\N	\N	\N	127184	127184	126999
26096	41223	33	applied	\N	\N	\N	\N	127185	127185	127001
26096	41172	34	applied	\N	\N	\N	\N	126933	126933	126857
26096	41173	35	applied	\N	\N	\N	\N	126934	126934	126859
26096	41174	36	applied	\N	\N	\N	\N	126935	126935	126861
26096	41175	37	applied	\N	\N	\N	\N	126936	126936	126863
26096	41176	38	applied	\N	\N	\N	\N	126937	126937	126865
26096	41177	39	applied	\N	\N	\N	\N	126938	126938	126867
26096	41179	40	applied	\N	\N	\N	\N	126939	126939	126873
26096	41180	41	applied	\N	\N	\N	\N	126940	126940	126875
26096	41181	42	applied	\N	\N	\N	\N	126941	126941	126877
26096	41182	43	applied	\N	\N	\N	\N	126942	126942	126879
26096	41183	44	applied	\N	\N	\N	\N	126943	126943	126881
26096	41184	45	applied	\N	\N	\N	\N	126944	126944	126883
26096	41185	46	applied	\N	\N	\N	\N	126945	126945	126885
26096	41186	47	applied	\N	\N	\N	\N	126946	126946	126887
26096	41224	48	applied	\N	\N	\N	\N	127186	127186	127003
26096	41233	49	applied	\N	\N	\N	\N	127187	127187	127188
26096	41241	50	applied	\N	\N	\N	\N	127189	127189	127190
26096	41243	51	applied	\N	\N	\N	\N	127191	127191	127192
26096	41134	52	applied	\N	\N	\N	\N	126642	126642	126643
26096	41136	53	applied	\N	\N	\N	\N	126650	126650	126651
26096	41138	54	applied	\N	\N	\N	\N	126656	126656	126657
26096	41140	55	applied	\N	\N	\N	\N	126769	126769	126770
26096	41142	56	applied	\N	\N	\N	\N	126775	126775	126776
26096	41143	57	applied	\N	\N	\N	\N	126777	126777	126778
26096	41146	58	applied	\N	\N	\N	\N	126787	126787	126788
26096	41148	59	applied	\N	\N	\N	\N	126793	126793	126794
26096	41150	60	applied	\N	\N	\N	\N	126802	126802	126803
26096	41152	61	applied	\N	\N	\N	\N	126807	126807	126808
26096	41153	62	applied	\N	\N	\N	\N	126809	126809	126810
26096	41156	63	applied	\N	\N	\N	\N	126817	126817	126818
26096	41157	64	applied	\N	\N	\N	\N	126819	126819	126820
26096	41159	65	applied	\N	\N	\N	\N	126827	126827	126828
26096	41160	66	applied	\N	\N	\N	\N	126829	126829	126830
26096	41170	67	applied	\N	\N	\N	\N	126852	126852	126853
26096	41187	68	applied	\N	\N	\N	\N	126888	126888	126889
26096	41189	69	applied	\N	\N	\N	\N	126894	126894	126895
26096	41191	70	applied	\N	\N	\N	\N	126901	126901	126902
26096	41193	71	applied	\N	\N	\N	\N	126907	126907	126908
26096	41199	72	applied	\N	\N	\N	\N	126921	126921	126922
26096	41202	73	applied	\N	\N	\N	\N	126952	126952	126953
26096	41212	74	applied	\N	\N	\N	\N	126974	126974	126975
26096	41213	75	applied	\N	\N	\N	\N	126976	126976	126977
26096	41225	76	applied	\N	\N	\N	\N	127004	127004	127005
26096	41226	77	applied	\N	\N	\N	\N	127006	127006	127007
26096	41227	78	applied	\N	\N	\N	\N	127008	127008	127009
26096	41231	79	applied	\N	\N	\N	\N	127017	127017	127018
26096	41232	80	applied	\N	\N	\N	\N	127019	127019	127020
26096	41234	81	applied	\N	\N	\N	\N	127023	127023	127024
26096	41235	82	applied	\N	\N	\N	\N	127025	127025	127026
26096	41240	83	applied	\N	\N	\N	\N	127038	127038	127039
26096	41242	84	applied	\N	\N	\N	\N	127042	127042	127043
26096	41246	85	applied	\N	\N	\N	\N	127053	127053	127054
26096	41247	86	applied	\N	\N	\N	\N	127055	127055	127056
26096	41248	87	applied	\N	\N	\N	\N	127057	127057	127058
26096	41249	88	applied	\N	\N	\N	\N	127059	127059	127060
26096	41254	89	applied	\N	\N	\N	\N	127072	127072	127073
26096	41255	90	applied	\N	\N	\N	\N	127074	127074	127075
26096	41258	91	applied	\N	\N	\N	\N	127083	127083	127084
26096	41260	93	applied	\N	\N	\N	\N	127088	127088	127089
26096	41262	94	applied	\N	\N	\N	\N	127093	127093	127094
26096	41264	95	applied	\N	\N	\N	\N	127101	127101	127102
26096	41266	96	applied	\N	\N	\N	\N	127116	127116	127117
26096	41267	97	applied	\N	\N	\N	\N	127118	127118	127119
26096	41268	98	applied	\N	\N	\N	\N	127120	127120	127121
26096	41269	99	applied	\N	\N	\N	\N	127122	127122	127123
26096	41274	100	applied	\N	\N	\N	\N	127133	127133	127134
26096	41276	101	applied	\N	\N	\N	\N	127139	127139	127140
26096	41278	102	applied	\N	\N	\N	\N	127144	127144	127145
26096	41280	103	applied	\N	\N	\N	\N	127152	127152	127153
26096	41282	104	applied	\N	\N	\N	\N	127160	127160	127161
26096	41284	105	applied	\N	\N	\N	\N	127166	127166	127167
26096	41286	106	applied	\N	\N	\N	\N	127172	127172	127173
26096	41121	107	applied	\N	\N	\N	\N	126482	126482	126483
26096	41115	108	applied	\N	\N	\N	\N	126468	126468	126469
26096	41116	109	applied	\N	\N	\N	\N	126470	126470	126471
26096	41118	110	applied	\N	\N	\N	\N	126476	126476	126477
26096	41123	111	applied	\N	\N	\N	\N	126486	126486	127194
26096	41125	112	applied	\N	\N	\N	\N	126614	126614	127195
26096	41129	113	applied	\N	\N	\N	\N	126623	126623	126485
26096	41119	114	applied	\N	\N	\N	\N	126478	126478	127196
26096	41122	115	applied	\N	\N	\N	\N	126484	126484	127197
26096	41126	116	applied	\N	\N	\N	\N	126616	126616	126626
26096	41128	117	applied	\N	\N	\N	\N	126621	126621	126624
26096	41131	118	applied	\N	\N	\N	\N	126632	126632	126633
26096	41133	119	applied	\N	\N	\N	\N	126638	126638	126639
26096	41135	120	applied	\N	\N	\N	\N	126644	126644	126645
26096	41137	121	applied	\N	\N	\N	\N	126652	126652	126653
26096	41139	122	applied	\N	\N	\N	\N	126658	126658	126659
26096	41141	123	applied	\N	\N	\N	\N	126771	126771	126772
26096	41144	124	applied	\N	\N	\N	\N	126779	126779	126780
26096	41145	125	applied	\N	\N	\N	\N	126781	126781	126782
26106	41304	0	applied	\N	\N	\N	\N	127235	127235	127236
26106	41305	1	applied	\N	\N	\N	\N	127237	127237	127238
26106	41306	2	applied	\N	\N	\N	\N	127239	127239	127240
26106	41307	3	applied	\N	\N	\N	\N	127241	127241	127242
26109	41308	0	applied	\N	\N	\N	\N	127294	127294	127295
26109	41309	1	applied	\N	\N	\N	\N	127296	127296	127297
26111	41308	0	applied	\N	\N	\N	\N	127294	127294	127295
26111	41309	1	applied	\N	\N	\N	\N	127296	127296	127297
26115	41314	0	applied	\N	\N	\N	\N	127316	127316	127317
26115	41315	1	applied	\N	\N	\N	\N	127318	127318	127319
26119	41326	0	applied	\N	\N	\N	\N	127348	127348	127349
26119	41327	1	applied	\N	\N	\N	\N	127350	127350	127351
26119	41328	2	applied	\N	\N	\N	\N	127352	127352	127353
26119	41329	3	applied	\N	\N	\N	\N	127354	127354	127355
26121	41330	0	applied	\N	\N	\N	\N	127357	127357	127358
26121	41331	1	applied	\N	\N	\N	\N	127359	127359	127360
26129	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26129	41343	1	applied	\N	\N	\N	\N	127391	127391	127392
26135	41346	0	applied	\N	\N	\N	\N	127414	127414	127415
26135	41347	1	applied	\N	\N	\N	\N	127416	127416	127417
26138	41352	0	applied	\N	\N	\N	\N	127432	127432	127433
26138	41353	1	applied	\N	\N	\N	\N	127434	127434	127435
26140	41352	0	applied	\N	\N	\N	\N	127432	127432	127433
26140	41353	1	applied	\N	\N	\N	\N	127434	127434	127435
26143	41356	0	applied	\N	\N	\N	\N	127446	127446	127447
26143	41357	1	applied	\N	\N	\N	\N	127448	127448	127449
26150	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26150	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26105	41302	0	applied	\N	\N	\N	\N	127231	127231	127232
26105	41303	1	applied	\N	\N	\N	\N	127233	127233	127234
26108	41308	0	applied	\N	\N	\N	\N	127294	127294	127295
26108	41309	1	applied	\N	\N	\N	\N	127296	127296	127297
26118	41322	0	applied	\N	\N	\N	\N	127338	127338	127339
26118	41323	1	applied	\N	\N	\N	\N	127340	127340	127341
26118	41324	2	applied	\N	\N	\N	\N	127342	127342	127343
26118	41325	3	applied	\N	\N	\N	\N	127344	127344	127345
26124	41336	0	applied	\N	\N	\N	\N	127374	127374	127375
26124	41337	1	applied	\N	\N	\N	\N	127376	127376	127377
26126	41340	0	applied	\N	\N	\N	\N	127382	127382	127383
26126	41341	2	applied	\N	\N	\N	\N	127385	127385	127386
26128	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26128	41343	1	applied	\N	\N	\N	\N	127391	127391	127392
26130	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26130	41343	1	applied	\N	\N	\N	\N	127391	127391	127392
26133	41344	0	applied	\N	\N	\N	\N	127405	127405	127406
26133	41345	1	applied	\N	\N	\N	\N	127407	127407	127408
26137	41348	0	applied	\N	\N	\N	\N	127422	127422	127423
26137	41349	1	applied	\N	\N	\N	\N	127424	127424	127425
26137	41350	2	applied	\N	\N	\N	\N	127426	127426	127427
26137	41351	3	applied	\N	\N	\N	\N	127428	127428	127429
26142	41356	0	applied	\N	\N	\N	\N	127446	127446	127447
26142	41357	1	applied	\N	\N	\N	\N	127448	127448	127449
26147	41363	0	applied	\N	\N	\N	\N	127466	127466	127467
26147	41364	1	applied	\N	\N	\N	\N	127468	127468	127469
26147	41365	2	applied	\N	\N	\N	\N	127470	127470	127471
26147	41366	3	applied	\N	\N	\N	\N	127472	127472	127473
26147	41367	4	applied	\N	\N	\N	\N	127474	127474	127475
26147	41368	5	applied	\N	\N	\N	\N	127476	127476	127477
26149	41342	0	applied	\N	\N	\N	\N	127389	127389	127390
26149	41344	1	applied	\N	\N	\N	\N	127405	127405	127406
26149	41346	2	applied	\N	\N	\N	\N	127414	127414	127415
26149	41348	3	applied	\N	\N	\N	\N	127422	127422	127423
26149	41349	4	applied	\N	\N	\N	\N	127424	127424	127425
26149	41352	5	applied	\N	\N	\N	\N	127432	127432	127433
26149	41354	6	applied	\N	\N	\N	\N	127440	127440	127441
26149	41356	7	applied	\N	\N	\N	\N	127446	127446	127447
26149	41358	8	applied	\N	\N	\N	\N	127454	127454	127455
26149	41360	9	applied	\N	\N	\N	\N	127458	127458	127459
26149	41363	10	applied	\N	\N	\N	\N	127466	127466	127467
26149	41364	11	applied	\N	\N	\N	\N	127468	127468	127469
26149	41369	12	applied	\N	\N	\N	\N	127480	127480	127481
26149	41361	13	applied	\N	\N	\N	\N	127460	127460	127488
26149	41365	14	applied	\N	\N	\N	\N	127470	127470	127489
26149	41343	15	applied	\N	\N	\N	\N	127391	127391	127490
26149	41345	16	applied	\N	\N	\N	\N	127407	127407	127491
26149	41366	17	applied	\N	\N	\N	\N	127472	127472	127427
26149	41370	18	applied	\N	\N	\N	\N	127482	127482	127492
26149	41347	19	applied	\N	\N	\N	\N	127416	127416	127493
26149	41350	20	applied	\N	\N	\N	\N	127426	127426	127494
26149	41351	21	applied	\N	\N	\N	\N	127428	127428	127495
26149	41353	22	applied	\N	\N	\N	\N	127434	127434	127496
26149	41355	23	applied	\N	\N	\N	\N	127442	127442	127461
26149	41357	24	applied	\N	\N	\N	\N	127448	127448	127463
26149	41359	25	applied	\N	\N	\N	\N	127456	127456	127497
26149	41362	26	applied	\N	\N	\N	\N	127462	127462	127498
26149	41367	27	applied	\N	\N	\N	\N	127474	127474	127499
26149	41368	28	applied	\N	\N	\N	\N	127476	127476	127483
26149	41371	29	applied	\N	\N	\N	\N	127484	127484	127485
26154	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26154	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26154	41374	2	applied	\N	\N	\N	\N	127505	127505	127506
26154	41375	3	applied	\N	\N	\N	\N	127507	127507	127508
26154	41376	4	applied	\N	\N	\N	\N	127509	127509	127510
26154	41377	5	applied	\N	\N	\N	\N	127511	127511	127512
26163	41397	0	applied	\N	\N	\N	\N	127572	127572	127573
26163	41398	1	applied	\N	\N	\N	\N	127574	127574	127575
26163	41399	2	applied	\N	\N	\N	\N	127576	127576	127577
26176	41437	0	applied	\N	\N	\N	\N	127671	127671	127672
26176	41438	1	applied	\N	\N	\N	\N	127673	127673	127674
26176	41439	2	applied	\N	\N	\N	\N	127675	127675	127676
26176	41440	3	applied	\N	\N	\N	\N	127677	127677	127678
26176	41441	4	applied	\N	\N	\N	\N	127679	127679	127680
26176	41442	5	applied	\N	\N	\N	\N	127681	127681	127682
26176	41443	6	applied	\N	\N	\N	\N	127683	127683	127684
26178	41437	0	applied	\N	\N	\N	\N	127671	127671	127672
26178	41438	1	applied	\N	\N	\N	\N	127673	127673	127674
26178	41439	2	applied	\N	\N	\N	\N	127675	127675	127676
26178	41440	3	applied	\N	\N	\N	\N	127677	127677	127678
26178	41441	4	applied	\N	\N	\N	\N	127679	127679	127680
26178	41442	5	applied	\N	\N	\N	\N	127681	127681	127682
26178	41443	6	applied	\N	\N	\N	\N	127683	127683	127684
26181	41451	0	applied	\N	\N	\N	\N	127706	127706	127707
26181	41452	1	applied	\N	\N	\N	\N	127708	127708	127709
26181	41453	2	applied	\N	\N	\N	\N	127710	127710	127711
26185	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26185	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26185	41378	2	applied	\N	\N	\N	\N	127522	127522	127523
26185	41383	3	applied	\N	\N	\N	\N	127539	127539	127540
26185	41384	4	applied	\N	\N	\N	\N	127541	127541	127542
26185	41391	5	applied	\N	\N	\N	\N	127558	127558	127559
26185	41397	6	applied	\N	\N	\N	\N	127572	127572	127573
26185	41400	7	applied	\N	\N	\N	\N	127581	127581	127582
26185	41401	8	applied	\N	\N	\N	\N	127583	127583	127584
26185	41406	9	applied	\N	\N	\N	\N	127595	127595	127596
26185	41409	10	applied	\N	\N	\N	\N	127603	127603	127604
26185	41410	11	applied	\N	\N	\N	\N	127605	127605	127606
26185	41417	12	applied	\N	\N	\N	\N	127621	127621	127622
26185	41423	13	applied	\N	\N	\N	\N	127638	127638	127639
26185	41424	14	applied	\N	\N	\N	\N	127640	127640	127641
26185	41425	15	applied	\N	\N	\N	\N	127642	127642	127643
26185	41426	16	applied	\N	\N	\N	\N	127644	127644	127645
26185	41437	17	applied	\N	\N	\N	\N	127671	127671	127672
26185	41438	18	applied	\N	\N	\N	\N	127673	127673	127674
26185	41444	19	applied	\N	\N	\N	\N	127690	127690	127691
26185	41446	20	applied	\N	\N	\N	\N	127694	127694	127695
26185	41451	21	applied	\N	\N	\N	\N	127706	127706	127707
26185	41380	22	applied	\N	\N	1000000000	\N	127526	127526	127527
26185	41374	23	applied	\N	\N	\N	\N	127505	127505	127506
26185	41375	24	applied	\N	\N	\N	\N	127507	127507	127508
26185	41376	25	applied	\N	\N	\N	\N	127509	127509	127510
26185	41377	26	applied	\N	\N	\N	\N	127511	127511	127512
26185	41379	27	applied	\N	\N	\N	\N	127524	127524	127525
26185	41385	28	applied	\N	\N	\N	\N	127543	127543	127714
26185	41381	29	applied	\N	\N	\N	\N	127528	127528	127544
26185	41386	30	applied	\N	\N	\N	\N	127545	127545	127546
26185	41429	31	applied	\N	\N	\N	\N	127650	127650	127715
26185	41430	32	applied	\N	\N	\N	\N	127652	127652	127552
26185	41439	33	applied	\N	\N	\N	\N	127675	127675	127716
26107	41176	34	applied	\N	\N	\N	\N	127279	127279	126865
26107	41177	35	applied	\N	\N	\N	\N	127280	127280	126867
26107	41179	36	applied	\N	\N	\N	\N	127281	127281	126873
26107	41180	37	applied	\N	\N	\N	\N	127282	127282	126875
26107	41181	38	applied	\N	\N	\N	\N	127283	127283	126877
26107	41182	39	applied	\N	\N	\N	\N	127284	127284	126879
26107	41183	40	applied	\N	\N	\N	\N	127285	127285	126881
26107	41184	41	applied	\N	\N	\N	\N	127286	127286	126883
26107	41185	42	applied	\N	\N	\N	\N	127287	127287	126885
26107	41186	43	applied	\N	\N	\N	\N	127288	127288	126887
26107	41224	44	applied	\N	\N	\N	\N	127289	127289	127003
26107	41233	45	applied	\N	\N	\N	\N	127290	127290	127188
26107	41241	46	applied	\N	\N	\N	\N	127291	127291	127190
26107	41121	47	applied	\N	\N	\N	\N	126482	126482	126483
26107	41294	48	applied	\N	\N	\N	\N	127208	127208	44452
26107	40867	49	applied	\N	\N	\N	\N	125716	125716	125716
26107	40831	50	applied	\N	\N	1000000000	\N	125612	125612	125613
26107	40744	51	applied	\N	\N	1000000000	\N	125376	125376	125377
26107	40842	52	applied	\N	\N	\N	\N	125641	125641	125642
26107	41042	53	applied	\N	\N	1000000000	\N	126254	126254	126255
26107	40755	54	applied	\N	\N	\N	\N	125407	125407	125408
26107	40961	55	applied	\N	\N	\N	\N	126014	126014	126015
26107	40847	56	applied	\N	\N	\N	\N	125664	125664	125665
26107	40763	57	applied	\N	\N	\N	\N	125424	125424	125377
26110	41308	0	applied	\N	\N	\N	\N	127294	127294	127295
26110	41309	1	applied	\N	\N	\N	\N	127296	127296	127297
26114	41312	0	applied	\N	\N	\N	\N	127310	127310	127311
26114	41313	1	applied	\N	\N	\N	\N	127312	127312	127313
26117	41318	0	applied	\N	\N	\N	\N	127328	127328	127329
26117	41319	1	applied	\N	\N	\N	\N	127330	127330	127331
26117	41320	2	applied	\N	\N	\N	\N	127332	127332	127333
26117	41321	3	applied	\N	\N	\N	\N	127334	127334	127335
26120	41330	0	applied	\N	\N	\N	\N	127357	127357	127358
26120	41331	1	applied	\N	\N	\N	\N	127359	127359	127360
26123	41336	0	applied	\N	\N	\N	\N	127374	127374	127375
26123	41337	1	applied	\N	\N	\N	\N	127376	127376	127377
26125	41338	0	applied	\N	\N	\N	\N	127378	127378	127379
26125	41339	1	applied	\N	\N	\N	\N	127380	127380	127381
26132	41344	0	applied	\N	\N	\N	\N	127405	127405	127406
26132	41345	1	applied	\N	\N	\N	\N	127407	127407	127408
26136	41346	0	applied	\N	\N	\N	\N	127414	127414	127415
26136	41347	1	applied	\N	\N	\N	\N	127416	127416	127417
26139	41352	0	applied	\N	\N	\N	\N	127432	127432	127433
26139	41353	1	applied	\N	\N	\N	\N	127434	127434	127435
26141	41354	0	applied	\N	\N	\N	\N	127440	127440	127441
26141	41355	1	applied	\N	\N	\N	\N	127442	127442	127443
26144	41356	0	applied	\N	\N	\N	\N	127446	127446	127447
26144	41357	1	applied	\N	\N	\N	\N	127448	127448	127449
26146	41360	0	applied	\N	\N	\N	\N	127458	127458	127459
26146	41361	1	applied	\N	\N	\N	\N	127460	127460	127461
26146	41362	2	applied	\N	\N	\N	\N	127462	127462	127463
26151	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26151	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26151	41374	2	applied	\N	\N	\N	\N	127505	127505	127506
26151	41375	3	applied	\N	\N	\N	\N	127507	127507	127508
26151	41376	4	applied	\N	\N	\N	\N	127509	127509	127510
26151	41377	5	applied	\N	\N	\N	\N	127511	127511	127512
26156	41378	0	applied	\N	\N	\N	\N	127522	127522	127523
26156	41379	1	applied	\N	\N	\N	\N	127524	127524	127525
26156	41380	2	applied	\N	\N	1000000000	\N	127526	127526	127527
26156	41381	3	applied	\N	\N	\N	\N	127528	127528	127529
26156	41382	4	applied	\N	\N	1000000000	\N	127530	127530	127531
26160	41383	0	applied	\N	\N	\N	\N	127539	127539	127540
26160	41384	1	applied	\N	\N	\N	\N	127541	127541	127542
26160	41385	2	applied	\N	\N	\N	\N	127543	127543	127544
26160	41386	3	applied	\N	\N	\N	\N	127545	127545	127546
26160	41387	4	applied	\N	\N	1000000000	\N	127547	127547	127548
26160	41388	5	applied	\N	\N	1000000000	\N	127549	127549	127550
26160	41389	6	applied	\N	\N	\N	\N	127551	127551	127552
26160	41390	7	applied	\N	\N	\N	\N	127553	127553	127554
26165	41406	0	applied	\N	\N	\N	\N	127595	127595	127596
26165	41407	1	applied	\N	\N	\N	\N	127597	127597	127598
26165	41408	2	applied	\N	\N	\N	\N	127599	127599	127600
26168	41417	0	applied	\N	\N	\N	\N	127621	127621	127622
26168	41418	1	applied	\N	\N	\N	\N	127623	127623	127624
26168	41419	2	applied	\N	\N	\N	\N	127625	127625	127626
26175	41423	0	applied	\N	\N	\N	\N	127638	127638	127639
26175	41424	1	applied	\N	\N	\N	\N	127640	127640	127641
26175	41425	2	applied	\N	\N	\N	\N	127642	127642	127643
26175	41426	3	applied	\N	\N	\N	\N	127644	127644	127645
26175	41427	4	applied	\N	\N	\N	\N	127646	127646	127647
26175	41428	5	applied	\N	\N	\N	\N	127648	127648	127649
26175	41429	6	applied	\N	\N	\N	\N	127650	127650	127651
26175	41430	7	applied	\N	\N	\N	\N	127652	127652	127653
26175	41431	8	applied	\N	\N	\N	\N	127654	127654	127655
26175	41432	9	applied	\N	\N	\N	\N	127656	127656	127657
26175	41433	10	applied	\N	\N	\N	\N	127658	127658	127659
26175	41434	11	applied	\N	\N	\N	\N	127660	127660	127661
26175	41435	12	applied	\N	\N	\N	\N	127662	127662	127663
26175	41436	13	applied	\N	\N	\N	\N	127664	127664	127665
26180	41446	0	applied	\N	\N	\N	\N	127694	127694	127695
26180	41447	1	applied	\N	\N	\N	\N	127696	127696	127697
26180	41448	2	applied	\N	\N	\N	\N	127698	127698	127699
26180	41449	3	applied	\N	\N	\N	\N	127700	127700	127701
26180	41450	4	applied	\N	\N	\N	\N	127702	127702	127703
26189	41458	0	applied	\N	\N	\N	\N	127749	127749	127750
26189	41459	1	applied	\N	\N	\N	\N	127751	127751	127752
26189	41460	2	applied	\N	\N	\N	\N	127753	127753	127754
26189	41461	3	applied	\N	\N	\N	\N	127755	127755	127756
26192	41473	0	applied	\N	\N	\N	\N	127785	127785	127786
26192	41474	1	applied	\N	\N	\N	\N	127787	127787	127788
26192	41475	2	applied	\N	\N	\N	\N	127789	127789	127790
26192	41476	3	applied	\N	\N	\N	\N	127791	127791	127792
26192	41477	4	applied	\N	\N	1000000000	\N	127793	127793	127794
26197	41484	0	applied	\N	\N	\N	\N	127817	127817	127818
26197	41485	1	applied	\N	\N	1000000000	\N	127819	127819	127820
26197	41486	2	applied	\N	\N	\N	\N	127821	127821	127822
26197	41487	3	applied	\N	\N	\N	\N	127823	127823	127824
26197	41488	4	applied	\N	\N	\N	\N	127825	127825	127826
26201	41495	0	applied	\N	\N	\N	\N	127845	127845	127846
26201	41496	1	applied	\N	\N	\N	\N	127847	127847	127848
26206	41514	0	applied	\N	\N	\N	\N	127891	127891	127892
26206	41515	1	applied	\N	\N	\N	\N	127893	127893	127894
26206	41516	2	applied	\N	\N	\N	\N	127895	127895	127896
26209	41517	0	applied	\N	\N	\N	\N	127899	127899	127900
26209	41518	1	applied	\N	\N	\N	\N	127901	127901	127902
26209	41519	2	applied	\N	\N	\N	\N	127903	127903	127904
26209	41520	3	applied	\N	\N	\N	\N	127905	127905	127906
26211	41521	0	applied	\N	\N	\N	\N	127910	127910	127911
26150	41374	2	applied	\N	\N	\N	\N	127505	127505	127506
26150	41375	3	applied	\N	\N	\N	\N	127507	127507	127508
26150	41376	4	applied	\N	\N	\N	\N	127509	127509	127510
26150	41377	5	applied	\N	\N	\N	\N	127511	127511	127512
26152	41372	0	applied	\N	\N	\N	\N	127501	127501	127502
26152	41373	1	applied	\N	\N	\N	\N	127503	127503	127504
26152	41374	2	applied	\N	\N	\N	\N	127505	127505	127506
26152	41375	3	applied	\N	\N	\N	\N	127507	127507	127508
26152	41376	4	applied	\N	\N	\N	\N	127509	127509	127510
26152	41377	5	applied	\N	\N	\N	\N	127511	127511	127512
26157	41378	0	applied	\N	\N	\N	\N	127522	127522	127523
26157	41379	1	applied	\N	\N	\N	\N	127524	127524	127525
26157	41380	2	applied	\N	\N	1000000000	\N	127526	127526	127527
26157	41381	3	applied	\N	\N	\N	\N	127528	127528	127529
26157	41382	4	applied	\N	\N	1000000000	\N	127530	127530	127531
26159	41383	0	applied	\N	\N	\N	\N	127539	127539	127540
26159	41384	1	applied	\N	\N	\N	\N	127541	127541	127542
26159	41385	2	applied	\N	\N	\N	\N	127543	127543	127544
26159	41386	3	applied	\N	\N	\N	\N	127545	127545	127546
26159	41387	4	applied	\N	\N	1000000000	\N	127547	127547	127548
26159	41388	5	applied	\N	\N	1000000000	\N	127549	127549	127550
26159	41389	6	applied	\N	\N	\N	\N	127551	127551	127552
26159	41390	7	applied	\N	\N	\N	\N	127553	127553	127554
26161	41391	0	applied	\N	\N	\N	\N	127558	127558	127559
26161	41392	1	applied	\N	\N	\N	\N	127560	127560	127561
26161	41393	2	applied	\N	\N	1000000000	\N	127562	127562	127563
26161	41394	3	applied	\N	\N	1000000000	\N	127564	127564	127565
26161	41395	4	applied	\N	\N	1000000000	\N	127566	127566	127567
26161	41396	5	applied	\N	\N	\N	\N	127568	127568	127569
26164	41400	0	applied	\N	\N	\N	\N	127581	127581	127582
26164	41401	1	applied	\N	\N	\N	\N	127583	127583	127584
26164	41402	2	applied	\N	\N	\N	\N	127585	127585	127586
26164	41403	3	applied	\N	\N	\N	\N	127587	127587	127588
26164	41404	4	applied	\N	\N	\N	\N	127589	127589	127590
26164	41405	5	applied	\N	\N	\N	\N	127591	127591	127592
26166	41406	0	applied	\N	\N	\N	\N	127595	127595	127596
26166	41407	1	applied	\N	\N	\N	\N	127597	127597	127598
26166	41408	2	applied	\N	\N	\N	\N	127599	127599	127600
26169	41420	0	applied	\N	\N	1000000000	\N	127629	127629	127630
26169	41421	1	applied	\N	\N	\N	\N	127631	127631	127632
26169	41422	2	applied	\N	\N	\N	\N	127633	127633	127634
26174	41423	0	applied	\N	\N	\N	\N	127638	127638	127639
26174	41424	1	applied	\N	\N	\N	\N	127640	127640	127641
26174	41425	2	applied	\N	\N	\N	\N	127642	127642	127643
26174	41426	3	applied	\N	\N	\N	\N	127644	127644	127645
26174	41427	4	applied	\N	\N	\N	\N	127646	127646	127647
26174	41428	5	applied	\N	\N	\N	\N	127648	127648	127649
26174	41429	6	applied	\N	\N	\N	\N	127650	127650	127651
26174	41430	7	applied	\N	\N	\N	\N	127652	127652	127653
26174	41431	8	applied	\N	\N	\N	\N	127654	127654	127655
26174	41432	9	applied	\N	\N	\N	\N	127656	127656	127657
26174	41433	10	applied	\N	\N	\N	\N	127658	127658	127659
26174	41434	11	applied	\N	\N	\N	\N	127660	127660	127661
26174	41435	12	applied	\N	\N	\N	\N	127662	127662	127663
26174	41436	13	applied	\N	\N	\N	\N	127664	127664	127665
26179	41444	0	applied	\N	\N	\N	\N	127690	127690	127691
26179	41445	1	applied	\N	\N	\N	\N	127692	127692	127693
26182	41451	0	applied	\N	\N	\N	\N	127706	127706	127707
26182	41452	1	applied	\N	\N	\N	\N	127708	127708	127709
26182	41453	2	applied	\N	\N	\N	\N	127710	127710	127711
26184	41451	0	applied	\N	\N	\N	\N	127706	127706	127707
26184	41452	1	applied	\N	\N	\N	\N	127708	127708	127709
26184	41453	2	applied	\N	\N	\N	\N	127710	127710	127711
26188	41458	0	applied	\N	\N	\N	\N	127749	127749	127750
26188	41459	1	applied	\N	\N	\N	\N	127751	127751	127752
26188	41460	2	applied	\N	\N	\N	\N	127753	127753	127754
26188	41461	3	applied	\N	\N	\N	\N	127755	127755	127756
26190	41097	0	applied	\N	\N	\N	\N	126425	126425	126426
26190	41195	1	applied	\N	\N	\N	\N	126913	126913	126914
26190	41158	2	applied	\N	\N	\N	\N	126927	126927	126826
26190	41161	3	applied	\N	\N	\N	\N	126928	126928	126832
26190	41162	4	applied	\N	\N	\N	\N	126929	126929	126834
26190	41163	5	applied	\N	\N	\N	\N	126930	126930	126836
26190	41169	6	applied	\N	\N	\N	\N	126931	126931	126850
26190	41171	7	applied	\N	\N	\N	\N	126932	126932	126855
26190	41196	8	applied	\N	\N	\N	\N	126915	126915	126916
26190	41197	9	applied	\N	\N	\N	\N	126917	126917	126918
26190	41198	10	applied	\N	\N	\N	\N	126919	126919	126920
26190	41201	11	applied	\N	\N	\N	\N	126950	126950	126951
26190	41203	12	applied	\N	\N	\N	\N	126954	126954	126955
26190	41204	13	applied	\N	\N	\N	\N	126956	126956	126957
26190	41205	14	applied	\N	\N	\N	\N	126958	126958	126959
26190	41206	15	applied	\N	\N	\N	\N	126960	126960	126961
26190	41207	16	applied	\N	\N	\N	\N	126962	126962	126963
26190	41208	17	applied	\N	\N	\N	\N	126964	126964	126965
26190	41209	18	applied	\N	\N	\N	\N	126966	126966	126967
26190	41210	19	applied	\N	\N	\N	\N	126968	126968	126969
26190	41288	20	applied	\N	\N	\N	\N	127178	127178	127022
26190	41289	21	applied	\N	\N	\N	\N	127179	127179	127041
26190	41290	22	applied	\N	\N	\N	\N	127180	127180	127045
26190	41219	23	applied	\N	\N	\N	\N	127181	127181	126993
26190	41220	24	applied	\N	\N	\N	\N	127182	127182	126995
26190	41221	25	applied	\N	\N	\N	\N	127183	127183	126997
26190	41222	26	applied	\N	\N	\N	\N	127184	127184	126999
26190	41223	27	applied	\N	\N	\N	\N	127185	127185	127001
26190	41172	28	applied	\N	\N	\N	\N	126933	126933	126857
26190	41173	29	applied	\N	\N	\N	\N	126934	126934	126859
26190	41174	30	applied	\N	\N	\N	\N	126935	126935	126861
26190	41175	31	applied	\N	\N	\N	\N	126936	126936	126863
26190	41176	32	applied	\N	\N	\N	\N	126937	126937	126865
26190	41177	33	applied	\N	\N	\N	\N	126938	126938	126867
26190	41179	34	applied	\N	\N	\N	\N	126939	126939	126873
26190	41180	35	applied	\N	\N	\N	\N	126940	126940	126875
26190	41181	36	applied	\N	\N	\N	\N	126941	126941	126877
26190	41182	37	applied	\N	\N	\N	\N	126942	126942	126879
26190	41183	38	applied	\N	\N	\N	\N	126943	126943	126881
26190	41184	39	applied	\N	\N	\N	\N	126944	126944	126883
26190	41185	40	applied	\N	\N	\N	\N	126945	126945	126885
26190	41186	41	applied	\N	\N	\N	\N	126946	126946	126887
26190	41224	42	applied	\N	\N	\N	\N	127186	127186	127003
26190	41233	43	applied	\N	\N	\N	\N	127187	127187	127188
26190	41241	44	applied	\N	\N	\N	\N	127189	127189	127190
26190	41243	45	applied	\N	\N	\N	\N	127191	127191	127192
26190	41099	46	applied	\N	\N	\N	\N	126430	126430	126431
26190	41100	47	applied	\N	\N	\N	\N	126432	126432	126433
26190	41105	48	applied	\N	\N	\N	\N	126444	126444	126445
26190	41108	49	applied	\N	\N	\N	\N	126452	126452	126453
26190	41109	50	applied	\N	\N	\N	\N	126454	126454	126455
26190	41114	51	applied	\N	\N	\N	\N	126466	126466	126467
26167	41412	3	applied	\N	\N	\N	\N	127609	127609	127610
26167	41413	4	applied	\N	\N	\N	\N	127611	127611	127612
26167	41414	5	applied	\N	\N	\N	\N	127613	127613	127614
26167	41415	6	applied	\N	\N	1000000000	\N	127615	127615	127616
26167	41416	7	applied	\N	\N	1000000000	\N	127617	127617	127618
26177	41437	0	applied	\N	\N	\N	\N	127671	127671	127672
26177	41438	1	applied	\N	\N	\N	\N	127673	127673	127674
26177	41439	2	applied	\N	\N	\N	\N	127675	127675	127676
26177	41440	3	applied	\N	\N	\N	\N	127677	127677	127678
26177	41441	4	applied	\N	\N	\N	\N	127679	127679	127680
26177	41442	5	applied	\N	\N	\N	\N	127681	127681	127682
26177	41443	6	applied	\N	\N	\N	\N	127683	127683	127684
26183	41451	0	applied	\N	\N	\N	\N	127706	127706	127707
26183	41452	1	applied	\N	\N	\N	\N	127708	127708	127709
26183	41453	2	applied	\N	\N	\N	\N	127710	127710	127711
26186	41454	0	applied	\N	\N	\N	\N	127738	127738	127739
26186	41455	1	applied	\N	\N	\N	\N	127740	127740	127741
26186	41456	2	applied	\N	\N	\N	\N	127742	127742	127743
26186	41457	3	applied	\N	\N	1000000000	\N	127744	127744	127745
26191	41462	0	applied	\N	\N	\N	\N	127762	127762	127763
26191	41463	1	applied	\N	\N	\N	\N	127764	127764	127765
26191	41464	2	applied	\N	\N	\N	\N	127766	127766	127767
26191	41465	3	applied	\N	\N	\N	\N	127768	127768	127769
26191	41466	4	applied	\N	\N	\N	\N	127770	127770	127771
26191	41467	5	applied	\N	\N	\N	\N	127772	127772	127773
26191	41468	6	applied	\N	\N	\N	\N	127774	127774	127775
26191	41469	7	applied	\N	\N	\N	\N	127776	127776	127777
26191	41470	8	applied	\N	\N	\N	\N	127778	127778	127779
26191	41471	9	applied	\N	\N	\N	\N	127780	127780	127781
26191	41472	10	applied	\N	\N	\N	\N	127782	127782	127783
26196	41484	0	applied	\N	\N	\N	\N	127817	127817	127818
26196	41485	1	applied	\N	\N	1000000000	\N	127819	127819	127820
26196	41486	2	applied	\N	\N	\N	\N	127821	127821	127822
26196	41487	3	applied	\N	\N	\N	\N	127823	127823	127824
26196	41488	4	applied	\N	\N	\N	\N	127825	127825	127826
26200	41492	0	applied	\N	\N	\N	\N	127838	127838	127839
26200	41493	1	applied	\N	\N	\N	\N	127840	127840	127841
26200	41494	2	applied	\N	\N	\N	\N	127842	127842	127843
26202	41495	0	applied	\N	\N	\N	\N	127845	127845	127846
26202	41496	1	applied	\N	\N	\N	\N	127847	127847	127848
26203	41497	0	applied	\N	\N	\N	\N	127852	127852	127853
26203	41498	1	applied	\N	\N	\N	\N	127854	127854	127855
26203	41499	2	applied	\N	\N	\N	\N	127856	127856	127857
26203	41500	3	applied	\N	\N	\N	\N	127858	127858	127859
26208	41517	0	applied	\N	\N	\N	\N	127899	127899	127900
26208	41518	1	applied	\N	\N	\N	\N	127901	127901	127902
26208	41519	2	applied	\N	\N	\N	\N	127903	127903	127904
26208	41520	3	applied	\N	\N	\N	\N	127905	127905	127906
26230	41584	0	applied	\N	\N	\N	\N	128087	128087	128088
26230	41585	1	applied	\N	\N	\N	\N	128089	128089	128090
26230	41586	2	applied	\N	\N	\N	\N	128091	128091	128092
26230	41587	3	applied	\N	\N	\N	\N	128093	128093	128094
26230	41588	4	applied	\N	\N	\N	\N	128095	128095	128096
26230	41589	5	applied	\N	\N	\N	\N	128097	128097	128098
26230	41590	6	applied	\N	\N	\N	\N	128099	128099	128100
26231	41584	0	applied	\N	\N	\N	\N	128087	128087	128088
26231	41585	1	applied	\N	\N	\N	\N	128089	128089	128090
26231	41586	2	applied	\N	\N	\N	\N	128091	128091	128092
26231	41587	3	applied	\N	\N	\N	\N	128093	128093	128094
26231	41588	4	applied	\N	\N	\N	\N	128095	128095	128096
26231	41589	5	applied	\N	\N	\N	\N	128097	128097	128098
26231	41590	6	applied	\N	\N	\N	\N	128099	128099	128100
26233	41594	0	applied	\N	\N	\N	\N	128111	128111	128112
26233	41595	1	applied	\N	\N	\N	\N	128113	128113	128114
26233	41596	2	applied	\N	\N	\N	\N	128115	128115	128116
26233	41597	3	applied	\N	\N	\N	\N	128117	128117	128118
26233	41598	4	applied	\N	\N	\N	\N	128119	128119	128120
26233	41599	5	applied	\N	\N	\N	\N	128121	128121	128122
26233	41600	6	applied	\N	\N	\N	\N	128123	128123	128124
26246	41624	0	applied	\N	\N	\N	\N	128182	128182	128183
26246	41625	1	applied	\N	\N	\N	\N	128184	128184	128185
26246	41626	2	applied	\N	\N	\N	\N	128186	128186	128187
26249	41630	0	applied	\N	\N	\N	\N	128205	128205	128206
26249	41631	1	applied	\N	\N	\N	\N	128207	128207	128208
26249	41632	2	applied	\N	\N	\N	\N	128209	128209	128210
26253	41653	0	applied	\N	\N	\N	\N	128258	128258	128259
26253	41654	1	applied	\N	\N	\N	\N	128260	128260	128261
26253	41655	2	applied	\N	\N	\N	\N	128262	128262	128263
26253	41656	3	applied	\N	\N	\N	\N	128264	128264	128265
26256	41660	0	applied	\N	\N	\N	\N	128275	128275	128276
26256	41661	1	applied	\N	\N	\N	\N	128277	128277	128278
26256	41662	2	applied	\N	\N	\N	\N	128279	128279	128280
26266	41689	0	applied	\N	\N	\N	\N	128347	128347	128348
26266	41690	1	applied	\N	\N	\N	\N	128349	128349	128350
26266	41691	2	applied	\N	\N	\N	\N	128351	128351	128352
26268	41692	0	applied	\N	\N	\N	\N	128353	128353	128354
26268	41693	1	applied	\N	\N	\N	\N	128355	128355	128356
26268	41694	2	applied	\N	\N	\N	\N	128357	128357	128358
26273	41704	0	applied	\N	\N	\N	\N	128388	128388	128389
26273	41705	1	applied	\N	\N	\N	\N	128390	128390	128391
26273	41706	2	applied	\N	\N	\N	\N	128392	128392	128393
26278	41717	0	applied	\N	\N	\N	\N	128420	128420	128421
26278	41718	1	applied	\N	\N	\N	\N	128422	128422	128423
26278	41719	2	applied	\N	\N	\N	\N	128424	128424	128425
26278	41720	3	applied	\N	\N	\N	\N	128426	128426	128427
26281	41724	0	applied	\N	\N	\N	\N	128459	128459	128460
26281	41725	1	applied	\N	\N	\N	\N	128461	128461	128462
26281	41726	2	applied	\N	\N	\N	\N	128463	128463	128464
26281	41727	3	applied	\N	\N	\N	\N	128465	128465	128466
26281	41728	4	applied	\N	\N	\N	\N	128467	128467	128468
26281	41729	5	applied	\N	\N	\N	\N	128469	128469	128470
26281	41730	6	applied	\N	\N	\N	\N	128471	128471	128472
26291	41747	0	applied	\N	\N	\N	\N	128522	128522	128523
26291	41748	1	applied	\N	\N	\N	\N	128524	128524	128525
26295	41751	0	applied	\N	\N	\N	\N	128533	128533	128534
26295	41752	1	applied	\N	\N	\N	\N	128535	128535	128536
26295	41753	2	applied	\N	\N	\N	\N	128537	128537	128538
26295	41754	3	applied	\N	\N	\N	\N	128539	128539	128540
26295	41755	4	applied	\N	\N	\N	\N	128541	128541	128542
26295	41756	5	applied	\N	\N	\N	\N	128543	128543	128544
26295	41757	6	applied	\N	\N	\N	\N	128545	128545	128546
26295	41758	7	applied	\N	\N	\N	\N	128547	128547	128548
26295	41759	8	applied	\N	\N	\N	\N	128549	128549	128550
26295	41760	9	applied	\N	\N	\N	\N	128551	128551	128552
26295	41761	10	applied	\N	\N	\N	\N	128553	128553	128554
26299	41764	0	applied	\N	\N	\N	\N	128566	128566	128567
26299	41765	1	applied	\N	\N	\N	\N	128568	128568	128569
26299	41766	2	applied	\N	\N	\N	\N	128570	128570	128571
26299	41767	3	applied	\N	\N	\N	\N	128572	128572	128573
26185	41389	34	applied	\N	\N	\N	\N	127551	127551	127554
26185	41392	35	applied	\N	\N	\N	\N	127560	127560	127561
26185	41398	36	applied	\N	\N	\N	\N	127574	127574	127717
26185	41450	37	applied	\N	\N	\N	\N	127702	127702	127569
26185	41404	38	applied	\N	\N	\N	\N	127589	127589	127575
26185	41405	39	applied	\N	\N	\N	\N	127591	127591	127718
26185	41408	40	applied	\N	\N	\N	\N	127599	127599	127719
26185	41411	41	applied	\N	\N	\N	\N	127607	127607	127586
26185	41412	42	applied	\N	\N	\N	\N	127609	127609	127720
26185	41419	43	applied	\N	\N	\N	\N	127625	127625	127721
26185	41421	44	applied	\N	\N	\N	\N	127631	127631	127722
26185	41428	45	applied	\N	\N	\N	\N	127648	127648	127723
26185	41390	46	applied	\N	\N	\N	\N	127553	127553	127724
26185	41382	47	applied	\N	\N	1000000000	\N	127530	127530	127531
26185	41387	48	applied	\N	\N	1000000000	\N	127547	127547	127548
26185	41388	49	applied	\N	\N	1000000000	\N	127549	127549	127550
26185	41393	50	applied	\N	\N	1000000000	\N	127562	127562	127563
26185	41394	51	applied	\N	\N	1000000000	\N	127564	127564	127565
26185	41395	52	applied	\N	\N	1000000000	\N	127566	127566	127567
26185	41431	53	applied	\N	\N	\N	\N	127654	127654	127725
26185	41432	54	applied	\N	\N	\N	\N	127656	127656	127726
26185	41433	55	applied	\N	\N	\N	\N	127658	127658	127727
26185	41440	56	applied	\N	\N	\N	\N	127677	127677	127612
26185	41443	57	applied	\N	\N	\N	\N	127683	127683	127728
26185	41445	58	applied	\N	\N	\N	\N	127692	127692	127729
26185	41447	59	applied	\N	\N	\N	\N	127696	127696	127624
26185	41453	60	applied	\N	\N	\N	\N	127710	127710	127626
26185	41396	61	applied	\N	\N	\N	\N	127568	127568	127730
26185	41399	62	applied	\N	\N	\N	\N	127576	127576	127731
26185	41402	63	applied	\N	\N	\N	\N	127585	127585	127732
26185	41403	64	applied	\N	\N	\N	\N	127587	127587	127653
26185	41407	65	applied	\N	\N	\N	\N	127597	127597	127733
26185	41413	66	applied	\N	\N	\N	\N	127611	127611	127659
26185	41414	67	applied	\N	\N	\N	\N	127613	127613	127661
26185	41418	68	applied	\N	\N	\N	\N	127623	127623	127663
26185	41422	69	applied	\N	\N	\N	\N	127633	127633	127665
26185	41427	70	applied	\N	\N	\N	\N	127646	127646	127678
26185	41434	71	applied	\N	\N	\N	\N	127660	127660	127680
26185	41435	72	applied	\N	\N	\N	\N	127662	127662	127682
26185	41436	73	applied	\N	\N	\N	\N	127664	127664	127734
26185	41441	74	applied	\N	\N	\N	\N	127679	127679	127697
26185	41442	75	applied	\N	\N	\N	\N	127681	127681	127699
26185	41448	76	applied	\N	\N	\N	\N	127698	127698	127701
26185	41449	77	applied	\N	\N	\N	\N	127700	127700	127735
26185	41452	78	applied	\N	\N	\N	\N	127708	127708	127711
26185	41415	79	applied	\N	\N	1000000000	\N	127615	127615	127616
26185	41416	80	applied	\N	\N	1000000000	\N	127617	127617	127618
26185	41420	81	applied	\N	\N	1000000000	\N	127629	127629	127630
26187	41454	0	applied	\N	\N	\N	\N	127738	127738	127739
26187	41455	1	applied	\N	\N	\N	\N	127740	127740	127741
26187	41456	2	applied	\N	\N	\N	\N	127742	127742	127743
26187	41457	3	applied	\N	\N	1000000000	\N	127744	127744	127745
26193	41195	0	applied	\N	\N	\N	\N	126913	126913	126914
26193	41202	1	applied	\N	\N	\N	\N	126952	126952	126953
26193	41196	2	applied	\N	\N	\N	\N	126915	126915	126916
26193	41197	3	applied	\N	\N	\N	\N	126917	126917	126918
26193	41198	4	applied	\N	\N	\N	\N	126919	126919	126920
26193	41201	5	applied	\N	\N	\N	\N	126950	126950	126951
26193	41203	6	applied	\N	\N	\N	\N	126954	126954	126955
26193	41212	7	applied	\N	\N	\N	\N	126974	126974	126975
26193	41204	8	applied	\N	\N	\N	\N	126956	126956	126957
26193	41205	9	applied	\N	\N	\N	\N	126958	126958	126959
26193	41206	10	applied	\N	\N	\N	\N	126960	126960	126961
26193	41207	11	applied	\N	\N	\N	\N	126962	126962	126963
26193	41208	12	applied	\N	\N	\N	\N	126964	126964	126965
26193	41209	13	applied	\N	\N	\N	\N	126966	126966	126967
26193	41210	14	applied	\N	\N	\N	\N	126968	126968	126969
26193	41288	15	applied	\N	\N	\N	\N	127178	127178	127022
26193	41289	16	applied	\N	\N	\N	\N	127179	127179	127041
26193	41290	17	applied	\N	\N	\N	\N	127180	127180	127045
26193	41219	18	applied	\N	\N	\N	\N	127181	127181	126993
26193	41220	19	applied	\N	\N	\N	\N	127182	127182	126995
26193	41221	20	applied	\N	\N	\N	\N	127183	127183	126997
26193	41222	21	applied	\N	\N	\N	\N	127184	127184	126999
26193	41223	22	applied	\N	\N	\N	\N	127185	127185	127001
26193	41224	23	applied	\N	\N	\N	\N	127186	127186	127003
26193	41233	24	applied	\N	\N	\N	\N	127187	127187	127188
26193	41241	25	applied	\N	\N	\N	\N	127189	127189	127190
26193	41243	26	applied	\N	\N	\N	\N	127191	127191	127192
26193	41213	27	applied	\N	\N	\N	\N	126976	126976	126977
26193	41225	28	applied	\N	\N	\N	\N	127004	127004	127005
26193	41226	29	applied	\N	\N	\N	\N	127006	127006	127007
26193	41227	30	applied	\N	\N	\N	\N	127008	127008	127009
26193	41231	31	applied	\N	\N	\N	\N	127017	127017	127018
26193	41232	32	applied	\N	\N	\N	\N	127019	127019	127020
26193	41234	33	applied	\N	\N	\N	\N	127023	127023	127024
26193	41235	34	applied	\N	\N	\N	\N	127025	127025	127026
26193	41240	35	applied	\N	\N	\N	\N	127038	127038	127039
26193	41242	36	applied	\N	\N	\N	\N	127042	127042	127043
26193	41246	37	applied	\N	\N	\N	\N	127053	127053	127054
26193	41247	38	applied	\N	\N	\N	\N	127055	127055	127056
26193	41248	39	applied	\N	\N	\N	\N	127057	127057	127058
26193	41249	40	applied	\N	\N	\N	\N	127059	127059	127060
26193	41254	41	applied	\N	\N	\N	\N	127072	127072	127073
26193	41255	42	applied	\N	\N	\N	\N	127074	127074	127075
26193	41258	43	applied	\N	\N	\N	\N	127083	127083	127084
26193	41260	44	applied	\N	\N	\N	\N	127088	127088	127089
26193	41262	45	applied	\N	\N	\N	\N	127093	127093	127094
26193	41264	46	applied	\N	\N	\N	\N	127101	127101	127102
26193	41266	47	applied	\N	\N	\N	\N	127116	127116	127117
26193	41267	48	applied	\N	\N	\N	\N	127118	127118	127119
26193	41268	49	applied	\N	\N	\N	\N	127120	127120	127121
26193	41269	50	applied	\N	\N	\N	\N	127122	127122	127123
26193	41274	51	applied	\N	\N	\N	\N	127133	127133	127134
26193	41276	52	applied	\N	\N	\N	\N	127139	127139	127140
26193	41278	53	applied	\N	\N	\N	\N	127144	127144	127145
26193	41280	54	applied	\N	\N	\N	\N	127152	127152	127153
26193	41282	55	applied	\N	\N	\N	\N	127160	127160	127161
26193	41284	56	applied	\N	\N	\N	\N	127166	127166	127167
26193	41286	57	applied	\N	\N	\N	\N	127172	127172	127173
26193	41291	58	applied	\N	\N	\N	\N	127200	127200	127201
26193	41293	59	applied	\N	\N	\N	\N	127206	127206	127207
26193	41296	60	applied	\N	\N	\N	\N	127212	127212	127213
26193	41298	61	applied	\N	\N	\N	\N	127217	127217	127218
26193	41299	62	applied	\N	\N	\N	\N	127219	127219	127220
26193	41302	63	applied	\N	\N	\N	\N	127231	127231	127232
26193	41304	64	applied	\N	\N	\N	\N	127235	127235	127236
26193	41305	65	applied	\N	\N	\N	\N	127237	127237	127238
26190	41117	52	applied	\N	\N	\N	\N	126474	126474	126475
26190	41120	53	applied	\N	\N	\N	\N	126480	126480	126481
26190	41124	54	applied	\N	\N	\N	\N	126612	126612	126613
26190	41127	55	applied	\N	\N	\N	\N	126619	126619	126620
26190	41130	56	applied	\N	\N	\N	\N	126630	126630	126631
26190	41132	57	applied	\N	\N	\N	\N	126636	126636	126637
26190	41134	58	applied	\N	\N	\N	\N	126642	126642	126643
26190	41136	59	applied	\N	\N	\N	\N	126650	126650	126651
26190	41138	60	applied	\N	\N	\N	\N	126656	126656	126657
26190	41140	61	applied	\N	\N	\N	\N	126769	126769	126770
26190	41142	62	applied	\N	\N	\N	\N	126775	126775	126776
26190	41143	63	applied	\N	\N	\N	\N	126777	126777	126778
26190	41146	64	applied	\N	\N	\N	\N	126787	126787	126788
26190	41148	65	applied	\N	\N	\N	\N	126793	126793	126794
26190	41150	66	applied	\N	\N	\N	\N	126802	126802	126803
26190	41152	67	applied	\N	\N	\N	\N	126807	126807	126808
26190	41153	68	applied	\N	\N	\N	\N	126809	126809	126810
26190	41156	69	applied	\N	\N	\N	\N	126817	126817	126818
26190	41157	70	applied	\N	\N	\N	\N	126819	126819	126820
26190	41159	71	applied	\N	\N	\N	\N	126827	126827	126828
26190	41160	72	applied	\N	\N	\N	\N	126829	126829	126830
26190	41170	73	applied	\N	\N	\N	\N	126852	126852	126853
26190	41187	74	applied	\N	\N	\N	\N	126888	126888	126889
26190	41189	75	applied	\N	\N	\N	\N	126894	126894	126895
26190	41191	76	applied	\N	\N	\N	\N	126901	126901	126902
26190	41193	77	applied	\N	\N	\N	\N	126907	126907	126908
26190	41199	78	applied	\N	\N	\N	\N	126921	126921	126922
26190	41202	79	applied	\N	\N	\N	\N	126952	126952	126953
26190	41212	80	applied	\N	\N	\N	\N	126974	126974	126975
26190	41213	81	applied	\N	\N	\N	\N	126976	126976	126977
26190	41225	82	applied	\N	\N	\N	\N	127004	127004	127005
26190	41226	83	applied	\N	\N	\N	\N	127006	127006	127007
26190	41227	84	applied	\N	\N	\N	\N	127008	127008	127009
26190	41231	85	applied	\N	\N	\N	\N	127017	127017	127018
26190	41232	86	applied	\N	\N	\N	\N	127019	127019	127020
26190	41234	87	applied	\N	\N	\N	\N	127023	127023	127024
26190	41235	88	applied	\N	\N	\N	\N	127025	127025	127026
26190	41240	89	applied	\N	\N	\N	\N	127038	127038	127039
26190	41242	90	applied	\N	\N	\N	\N	127042	127042	127043
26190	41246	91	applied	\N	\N	\N	\N	127053	127053	127054
26190	41247	92	applied	\N	\N	\N	\N	127055	127055	127056
26190	41248	93	applied	\N	\N	\N	\N	127057	127057	127058
26190	41249	94	applied	\N	\N	\N	\N	127059	127059	127060
26190	41254	95	applied	\N	\N	\N	\N	127072	127072	127073
26190	41255	96	applied	\N	\N	\N	\N	127074	127074	127075
26190	41258	97	applied	\N	\N	\N	\N	127083	127083	127084
26190	41260	98	applied	\N	\N	\N	\N	127088	127088	127089
26190	41262	99	applied	\N	\N	\N	\N	127093	127093	127094
26190	41264	100	applied	\N	\N	\N	\N	127101	127101	127102
26190	41266	101	applied	\N	\N	\N	\N	127116	127116	127117
26190	41267	102	applied	\N	\N	\N	\N	127118	127118	127119
26190	41268	103	applied	\N	\N	\N	\N	127120	127120	127121
26190	41269	104	applied	\N	\N	\N	\N	127122	127122	127123
26190	41274	105	applied	\N	\N	\N	\N	127133	127133	127134
26190	41276	106	applied	\N	\N	\N	\N	127139	127139	127140
26190	41278	107	applied	\N	\N	\N	\N	127144	127144	127145
26190	41280	108	applied	\N	\N	\N	\N	127152	127152	127153
26190	41282	109	applied	\N	\N	\N	\N	127160	127160	127161
26190	41284	110	applied	\N	\N	\N	\N	127166	127166	127167
26190	41286	111	applied	\N	\N	\N	\N	127172	127172	127173
26190	41291	112	applied	\N	\N	\N	\N	127200	127200	127201
26190	41293	113	applied	\N	\N	\N	\N	127206	127206	127207
26190	41296	114	applied	\N	\N	\N	\N	127212	127212	127213
26190	41298	115	applied	\N	\N	\N	\N	127217	127217	127218
26190	41299	116	applied	\N	\N	\N	\N	127219	127219	127220
26190	41302	118	applied	\N	\N	\N	\N	127231	127231	127232
26190	41304	119	applied	\N	\N	\N	\N	127235	127235	127236
26190	41305	120	applied	\N	\N	\N	\N	127237	127237	127238
26190	41308	121	applied	\N	\N	\N	\N	127294	127294	127295
26190	41310	122	applied	\N	\N	\N	\N	127306	127306	127307
26190	41312	123	applied	\N	\N	\N	\N	127310	127310	127311
26190	41314	124	applied	\N	\N	\N	\N	127316	127316	127317
26190	41316	125	applied	\N	\N	\N	\N	127322	127322	127323
26195	41478	0	applied	\N	\N	\N	\N	127801	127801	127802
26195	41479	1	applied	\N	\N	\N	\N	127803	127803	127804
26195	41480	2	applied	\N	\N	\N	\N	127805	127805	127806
26195	41481	3	applied	\N	\N	\N	\N	127807	127807	127808
26195	41482	4	applied	\N	\N	\N	\N	127809	127809	127810
26195	41483	5	applied	\N	\N	\N	\N	127811	127811	127812
26204	41497	0	applied	\N	\N	\N	\N	127852	127852	127853
26204	41498	1	applied	\N	\N	\N	\N	127854	127854	127855
26204	41499	2	applied	\N	\N	\N	\N	127856	127856	127857
26204	41500	3	applied	\N	\N	\N	\N	127858	127858	127859
26205	41501	0	applied	\N	\N	\N	\N	127863	127863	127864
26205	41502	1	applied	\N	\N	\N	\N	127865	127865	127866
26205	41503	2	applied	\N	\N	\N	\N	127867	127867	127868
26205	41504	3	applied	\N	\N	\N	\N	127869	127869	127870
26205	41505	4	applied	\N	\N	\N	\N	127871	127871	127872
26205	41506	5	applied	\N	\N	\N	\N	127873	127873	127874
26205	41507	6	applied	\N	\N	\N	\N	127875	127875	127876
26205	41508	7	applied	\N	\N	\N	\N	127877	127877	127878
26205	41509	8	applied	\N	\N	\N	\N	127879	127879	127880
26205	41510	9	applied	\N	\N	\N	\N	127881	127881	127882
26205	41511	10	applied	\N	\N	\N	\N	127883	127883	127884
26205	41512	11	applied	\N	\N	\N	\N	127885	127885	127886
26205	41513	12	applied	\N	\N	\N	\N	127887	127887	127888
26212	41524	0	applied	\N	\N	\N	\N	127918	127918	127919
26212	41525	1	applied	\N	\N	\N	\N	127920	127920	127921
26212	41526	2	applied	\N	\N	\N	\N	127922	127922	127923
26215	41530	0	applied	\N	\N	\N	\N	127931	127931	127932
26215	41531	1	applied	\N	\N	\N	\N	127933	127933	127934
26215	41532	2	applied	\N	\N	\N	\N	127935	127935	127936
26215	41533	3	applied	\N	\N	\N	\N	127937	127937	127938
26217	41530	0	applied	\N	\N	\N	\N	127931	127931	127932
26217	41531	1	applied	\N	\N	\N	\N	127933	127933	127934
26217	41532	2	applied	\N	\N	\N	\N	127935	127935	127936
26217	41533	3	applied	\N	\N	\N	\N	127937	127937	127938
26220	41540	0	applied	\N	\N	\N	\N	127960	127960	127961
26220	41541	1	applied	\N	\N	\N	\N	127962	127962	127963
26220	41542	2	applied	\N	\N	\N	\N	127964	127964	127965
26220	41543	3	applied	\N	\N	\N	\N	127966	127966	127967
26222	41544	0	applied	\N	\N	\N	\N	127971	127971	127972
26222	41545	1	applied	\N	\N	\N	\N	127973	127973	127974
26222	41546	2	applied	\N	\N	\N	\N	127975	127975	127976
26225	41318	0	applied	\N	\N	\N	\N	127328	127328	127329
26225	41319	1	applied	\N	\N	\N	\N	127330	127330	127331
26225	41322	2	applied	\N	\N	\N	\N	127338	127338	127339
26225	41323	3	applied	\N	\N	\N	\N	127340	127340	127341
26225	41326	4	applied	\N	\N	\N	\N	127348	127348	127349
26225	41327	5	applied	\N	\N	\N	\N	127350	127350	127351
26193	41308	66	applied	\N	\N	\N	\N	127294	127294	127295
26193	41310	67	applied	\N	\N	\N	\N	127306	127306	127307
26193	41312	68	applied	\N	\N	\N	\N	127310	127310	127311
26193	41314	69	applied	\N	\N	\N	\N	127316	127316	127317
26193	41316	70	applied	\N	\N	\N	\N	127322	127322	127323
26193	41318	71	applied	\N	\N	\N	\N	127328	127328	127329
26193	41319	72	applied	\N	\N	\N	\N	127330	127330	127331
26193	41322	73	applied	\N	\N	\N	\N	127338	127338	127339
26193	41323	74	applied	\N	\N	\N	\N	127340	127340	127341
26193	41326	75	applied	\N	\N	\N	\N	127348	127348	127349
26193	41327	76	applied	\N	\N	\N	\N	127350	127350	127351
26193	41330	77	applied	\N	\N	\N	\N	127357	127357	127358
26193	41332	78	applied	\N	\N	\N	\N	127365	127365	127366
26193	41333	79	applied	\N	\N	\N	\N	127367	127367	127368
26193	41336	80	applied	\N	\N	\N	\N	127374	127374	127375
26193	41338	81	applied	\N	\N	\N	\N	127378	127378	127379
26193	41340	82	applied	\N	\N	\N	\N	127382	127382	127383
26193	41342	83	applied	\N	\N	\N	\N	127389	127389	127390
26193	41344	84	applied	\N	\N	\N	\N	127405	127405	127406
26193	41346	85	applied	\N	\N	\N	\N	127414	127414	127415
26193	41348	86	applied	\N	\N	\N	\N	127422	127422	127423
26193	41349	87	applied	\N	\N	\N	\N	127424	127424	127425
26193	41352	88	applied	\N	\N	\N	\N	127432	127432	127433
26193	41354	89	applied	\N	\N	\N	\N	127440	127440	127441
26193	41356	90	applied	\N	\N	\N	\N	127446	127446	127447
26193	41358	91	applied	\N	\N	\N	\N	127454	127454	127455
26193	41360	92	applied	\N	\N	\N	\N	127458	127458	127459
26193	41363	93	applied	\N	\N	\N	\N	127466	127466	127467
26193	41364	94	applied	\N	\N	\N	\N	127468	127468	127469
26193	41369	95	applied	\N	\N	\N	\N	127480	127480	127481
26193	41372	96	applied	\N	\N	\N	\N	127501	127501	127502
26193	41373	97	applied	\N	\N	\N	\N	127503	127503	127504
26193	41378	98	applied	\N	\N	\N	\N	127522	127522	127523
26193	41383	99	applied	\N	\N	\N	\N	127539	127539	127540
26193	41384	100	applied	\N	\N	\N	\N	127541	127541	127542
26193	41391	101	applied	\N	\N	\N	\N	127558	127558	127559
26193	41397	102	applied	\N	\N	\N	\N	127572	127572	127573
26193	41400	103	applied	\N	\N	\N	\N	127581	127581	127582
26193	41401	104	applied	\N	\N	\N	\N	127583	127583	127584
26193	41406	105	applied	\N	\N	\N	\N	127595	127595	127596
26193	41409	106	applied	\N	\N	\N	\N	127603	127603	127604
26193	41410	107	applied	\N	\N	\N	\N	127605	127605	127606
26193	41417	108	applied	\N	\N	\N	\N	127621	127621	127622
26193	41423	109	applied	\N	\N	\N	\N	127638	127638	127639
26193	41424	110	applied	\N	\N	\N	\N	127640	127640	127641
26193	41425	111	applied	\N	\N	\N	\N	127642	127642	127643
26193	41426	112	applied	\N	\N	\N	\N	127644	127644	127645
26193	41437	113	applied	\N	\N	\N	\N	127671	127671	127672
26193	41438	114	applied	\N	\N	\N	\N	127673	127673	127674
26193	41444	115	applied	\N	\N	\N	\N	127690	127690	127691
26193	41446	116	applied	\N	\N	\N	\N	127694	127694	127695
26193	41451	117	applied	\N	\N	\N	\N	127706	127706	127707
26193	41454	118	applied	\N	\N	\N	\N	127738	127738	127739
26193	41458	119	applied	\N	\N	\N	\N	127749	127749	127750
26193	41462	121	applied	\N	\N	\N	\N	127762	127762	127763
26193	41463	122	applied	\N	\N	\N	\N	127764	127764	127765
26193	41464	123	applied	\N	\N	\N	\N	127766	127766	127767
26193	41473	124	applied	\N	\N	\N	\N	127785	127785	127786
26193	41361	125	applied	\N	\N	\N	\N	127460	127460	127798
26194	41478	0	applied	\N	\N	\N	\N	127801	127801	127802
26194	41479	1	applied	\N	\N	\N	\N	127803	127803	127804
26194	41480	2	applied	\N	\N	\N	\N	127805	127805	127806
26194	41481	3	applied	\N	\N	\N	\N	127807	127807	127808
26194	41482	4	applied	\N	\N	\N	\N	127809	127809	127810
26194	41483	5	applied	\N	\N	\N	\N	127811	127811	127812
26198	41484	0	applied	\N	\N	\N	\N	127817	127817	127818
26198	41485	1	applied	\N	\N	1000000000	\N	127819	127819	127820
26198	41486	2	applied	\N	\N	\N	\N	127821	127821	127822
26198	41487	3	applied	\N	\N	\N	\N	127823	127823	127824
26198	41488	4	applied	\N	\N	\N	\N	127825	127825	127826
26199	41489	0	applied	\N	\N	\N	\N	127830	127830	127831
26199	41490	1	applied	\N	\N	\N	\N	127832	127832	127833
26199	41491	2	applied	\N	\N	\N	\N	127834	127834	127835
26207	41517	0	applied	\N	\N	\N	\N	127899	127899	127900
26207	41518	1	applied	\N	\N	\N	\N	127901	127901	127902
26207	41519	2	applied	\N	\N	\N	\N	127903	127903	127904
26207	41520	3	applied	\N	\N	\N	\N	127905	127905	127906
26210	41517	0	applied	\N	\N	\N	\N	127899	127899	127900
26210	41518	1	applied	\N	\N	\N	\N	127901	127901	127902
26210	41519	2	applied	\N	\N	\N	\N	127903	127903	127904
26210	41520	3	applied	\N	\N	\N	\N	127905	127905	127906
26214	41530	0	applied	\N	\N	\N	\N	127931	127931	127932
26214	41531	1	applied	\N	\N	\N	\N	127933	127933	127934
26214	41532	2	applied	\N	\N	\N	\N	127935	127935	127936
26214	41533	3	applied	\N	\N	\N	\N	127937	127937	127938
26219	41540	0	applied	\N	\N	\N	\N	127960	127960	127961
26219	41541	1	applied	\N	\N	\N	\N	127962	127962	127963
26219	41542	2	applied	\N	\N	\N	\N	127964	127964	127965
26219	41543	3	applied	\N	\N	\N	\N	127966	127966	127967
26221	41544	0	applied	\N	\N	\N	\N	127971	127971	127972
26221	41545	1	applied	\N	\N	\N	\N	127973	127973	127974
26221	41546	2	applied	\N	\N	\N	\N	127975	127975	127976
26224	41547	0	applied	\N	\N	\N	\N	127981	127981	127982
26224	41548	1	applied	\N	\N	\N	\N	127983	127983	127984
26224	41549	2	applied	\N	\N	\N	\N	127985	127985	127986
26224	41550	3	applied	\N	\N	\N	\N	127987	127987	127988
26224	41551	4	applied	\N	\N	\N	\N	127989	127989	127990
26224	41552	5	applied	\N	\N	\N	\N	127991	127991	127992
26224	41553	6	applied	\N	\N	\N	\N	127993	127993	127994
26227	41554	0	applied	\N	\N	\N	\N	127997	127997	127998
26227	41555	1	applied	\N	\N	\N	\N	127999	127999	128000
26227	41556	2	applied	\N	\N	\N	\N	128001	128001	128002
26227	41557	3	applied	\N	\N	\N	\N	128026	128026	128027
26227	41558	4	applied	\N	\N	\N	\N	128028	128028	128029
26227	41559	5	applied	\N	\N	\N	\N	128030	128030	128031
26227	41560	6	applied	\N	\N	\N	\N	128032	128032	128033
26227	41561	7	applied	\N	\N	1000000000	\N	128034	128034	128035
26227	41562	8	applied	\N	\N	\N	\N	128036	128036	128037
26227	41563	9	applied	\N	\N	\N	\N	128038	128038	128039
26227	41564	10	applied	\N	\N	\N	\N	128040	128040	128041
26227	41565	11	applied	\N	\N	\N	\N	128042	128042	128043
26227	41566	12	applied	\N	\N	\N	\N	128044	128044	128045
26227	41567	13	applied	\N	\N	\N	\N	128046	128046	128047
26227	41568	14	applied	\N	\N	\N	\N	128048	128048	128049
26227	41569	15	applied	\N	\N	\N	\N	128050	128050	128051
26227	41570	16	applied	\N	\N	\N	\N	128052	128052	128053
26227	41571	17	applied	\N	\N	\N	\N	128054	128054	128055
26227	41572	18	applied	\N	\N	\N	\N	128056	128056	128057
26227	41573	19	applied	\N	\N	\N	\N	128058	128058	128059
26211	41522	1	applied	\N	\N	\N	\N	127912	127912	127913
26211	41523	2	applied	\N	\N	\N	\N	127914	127914	127915
26213	41527	0	applied	\N	\N	\N	\N	127925	127925	127926
26213	41528	1	applied	\N	\N	\N	\N	127927	127927	127928
26213	41529	2	applied	\N	\N	\N	\N	127929	127929	127930
26216	41530	0	applied	\N	\N	\N	\N	127931	127931	127932
26216	41531	1	applied	\N	\N	\N	\N	127933	127933	127934
26216	41532	2	applied	\N	\N	\N	\N	127935	127935	127936
26216	41533	3	applied	\N	\N	\N	\N	127937	127937	127938
26218	41534	0	applied	\N	\N	\N	\N	127946	127946	127947
26218	41535	1	applied	\N	\N	\N	\N	127948	127948	127949
26218	41536	2	applied	\N	\N	\N	\N	127950	127950	127951
26218	41537	3	applied	\N	\N	\N	\N	127952	127952	127953
26218	41538	4	applied	\N	\N	\N	\N	127954	127954	127955
26218	41539	5	applied	\N	\N	\N	\N	127956	127956	127957
26223	41547	0	applied	\N	\N	\N	\N	127981	127981	127982
26223	41548	1	applied	\N	\N	\N	\N	127983	127983	127984
26223	41549	2	applied	\N	\N	\N	\N	127985	127985	127986
26223	41550	3	applied	\N	\N	\N	\N	127987	127987	127988
26223	41551	4	applied	\N	\N	\N	\N	127989	127989	127990
26223	41552	5	applied	\N	\N	\N	\N	127991	127991	127992
26223	41553	6	applied	\N	\N	\N	\N	127993	127993	127994
26226	41554	0	applied	\N	\N	\N	\N	127997	127997	127998
26226	41555	1	applied	\N	\N	\N	\N	127999	127999	128000
26226	41556	2	applied	\N	\N	\N	\N	128001	128001	128002
26226	41557	3	applied	\N	\N	\N	\N	128026	128026	128027
26226	41558	4	applied	\N	\N	\N	\N	128028	128028	128029
26226	41559	5	applied	\N	\N	\N	\N	128030	128030	128031
26226	41560	6	applied	\N	\N	\N	\N	128032	128032	128033
26226	41561	7	applied	\N	\N	1000000000	\N	128034	128034	128035
26226	41562	8	applied	\N	\N	\N	\N	128036	128036	128037
26226	41563	9	applied	\N	\N	\N	\N	128038	128038	128039
26226	41564	10	applied	\N	\N	\N	\N	128040	128040	128041
26226	41565	11	applied	\N	\N	\N	\N	128042	128042	128043
26226	41566	12	applied	\N	\N	\N	\N	128044	128044	128045
26226	41567	13	applied	\N	\N	\N	\N	128046	128046	128047
26226	41568	14	applied	\N	\N	\N	\N	128048	128048	128049
26226	41569	15	applied	\N	\N	\N	\N	128050	128050	128051
26226	41570	16	applied	\N	\N	\N	\N	128052	128052	128053
26226	41571	17	applied	\N	\N	\N	\N	128054	128054	128055
26226	41572	18	applied	\N	\N	\N	\N	128056	128056	128057
26226	41573	19	applied	\N	\N	\N	\N	128058	128058	128059
26226	41574	20	applied	\N	\N	\N	\N	128060	128060	128061
26226	41575	21	applied	\N	\N	\N	\N	128062	128062	128063
26226	41576	22	applied	\N	\N	\N	\N	128064	128064	128065
26226	41577	23	applied	\N	\N	\N	\N	128066	128066	128067
26228	41578	0	applied	\N	\N	\N	\N	128071	128071	128072
26228	41579	1	applied	\N	\N	\N	\N	128073	128073	128074
26228	41580	2	applied	\N	\N	\N	\N	128075	128075	128076
26234	41594	0	applied	\N	\N	\N	\N	128111	128111	128112
26234	41595	1	applied	\N	\N	\N	\N	128113	128113	128114
26234	41596	2	applied	\N	\N	\N	\N	128115	128115	128116
26234	41597	3	applied	\N	\N	\N	\N	128117	128117	128118
26234	41598	4	applied	\N	\N	\N	\N	128119	128119	128120
26234	41599	5	applied	\N	\N	\N	\N	128121	128121	128122
26234	41600	6	applied	\N	\N	\N	\N	128123	128123	128124
26242	41604	0	applied	\N	\N	\N	\N	128137	128137	128138
26242	41605	1	applied	\N	\N	\N	\N	128139	128139	128140
26242	41606	2	applied	\N	\N	\N	\N	128141	128141	128142
26243	41607	0	applied	\N	\N	\N	\N	128145	128145	128146
26243	41608	1	applied	\N	\N	\N	\N	128147	128147	128148
26243	41609	2	applied	\N	\N	\N	\N	128149	128149	128150
26243	41610	4	applied	\N	\N	\N	\N	128152	128152	128153
26243	41611	5	applied	\N	\N	\N	\N	128154	128154	128155
26243	41612	6	applied	\N	\N	1000000000	\N	128156	128156	128157
26243	41613	7	applied	\N	\N	\N	\N	128158	128158	128159
26243	41614	8	applied	\N	\N	\N	\N	128160	128160	128161
26243	41615	9	applied	\N	\N	\N	\N	128162	128162	128163
26243	41616	10	applied	\N	\N	\N	\N	128164	128164	128165
26243	41617	11	applied	\N	\N	\N	\N	128166	128166	128167
26243	41618	12	applied	\N	\N	1000000000	\N	128168	128168	128169
26243	41619	13	applied	\N	\N	\N	\N	128170	128170	128171
26243	41620	14	applied	\N	\N	1000000000	\N	128172	128172	128173
26243	41621	15	applied	\N	\N	\N	\N	128174	128174	128175
26243	41622	16	applied	\N	\N	\N	\N	128176	128176	128177
26243	41623	17	applied	\N	\N	\N	\N	128178	128178	128179
26250	41633	0	applied	\N	\N	\N	\N	128212	128212	128213
26250	41634	1	applied	\N	\N	\N	\N	128214	128214	128215
26250	41635	2	applied	\N	\N	\N	\N	128216	128216	128217
26250	41636	3	applied	\N	\N	\N	\N	128218	128218	128219
26251	41637	0	applied	\N	\N	\N	\N	128222	128222	128223
26251	41638	1	applied	\N	\N	\N	\N	128224	128224	128225
26251	41639	2	applied	\N	\N	\N	\N	128226	128226	128227
26251	41640	3	applied	\N	\N	\N	\N	128228	128228	128229
26251	41641	4	applied	\N	\N	\N	\N	128230	128230	128231
26251	41642	5	applied	\N	\N	\N	\N	128232	128232	128233
26251	41643	6	applied	\N	\N	\N	\N	128234	128234	128235
26251	41644	7	applied	\N	\N	\N	\N	128236	128236	128237
26251	41645	8	applied	\N	\N	\N	\N	128238	128238	128239
26251	41646	9	applied	\N	\N	\N	\N	128240	128240	128241
26251	41647	10	applied	\N	\N	\N	\N	128242	128242	128243
26251	41648	11	applied	\N	\N	\N	\N	128244	128244	128245
26251	41649	12	applied	\N	\N	\N	\N	128246	128246	128247
26254	41657	0	applied	\N	\N	\N	\N	128268	128268	128269
26254	41658	1	applied	\N	\N	\N	\N	128270	128270	128271
26254	41659	2	applied	\N	\N	\N	\N	128272	128272	128273
26261	41666	0	applied	\N	\N	\N	\N	128293	128293	128294
26261	41667	1	applied	\N	\N	\N	\N	128295	128295	128296
26261	41668	2	applied	\N	\N	\N	\N	128297	128297	128298
26261	41669	3	applied	\N	\N	\N	\N	128299	128299	128300
26261	41670	4	applied	\N	\N	\N	\N	128301	128301	128302
26261	41671	5	applied	\N	\N	\N	\N	128303	128303	128304
26269	41695	0	applied	\N	\N	\N	\N	128363	128363	128364
26269	41696	1	applied	\N	\N	\N	\N	128365	128365	128366
26269	41697	2	applied	\N	\N	\N	\N	128367	128367	128368
26271	41698	0	applied	\N	\N	\N	\N	128370	128370	128371
26271	41699	1	applied	\N	\N	\N	\N	128372	128372	128373
26271	41700	3	applied	\N	\N	\N	\N	128375	128375	128376
26271	41701	4	applied	\N	\N	\N	\N	128377	128377	128378
26274	41707	0	applied	\N	\N	\N	\N	128394	128394	128395
26274	41708	1	applied	\N	\N	\N	\N	128396	128396	128397
26274	41709	2	applied	\N	\N	\N	\N	128398	128398	128399
26274	41710	3	applied	\N	\N	\N	\N	128400	128400	128401
26279	41721	0	applied	\N	\N	\N	\N	128428	128428	128429
26279	41722	1	applied	\N	\N	\N	\N	128430	128430	128431
26279	41723	2	applied	\N	\N	\N	\N	128432	128432	128433
26282	41724	0	applied	\N	\N	\N	\N	128459	128459	128460
26282	41725	1	applied	\N	\N	\N	\N	128461	128461	128462
26282	41726	2	applied	\N	\N	\N	\N	128463	128463	128464
26225	41330	6	applied	\N	\N	\N	\N	127357	127357	127358
26225	41332	7	applied	\N	\N	\N	\N	127365	127365	127366
26225	41333	8	applied	\N	\N	\N	\N	127367	127367	127368
26225	41336	9	applied	\N	\N	\N	\N	127374	127374	127375
26225	41338	10	applied	\N	\N	\N	\N	127378	127378	127379
26225	41340	11	applied	\N	\N	\N	\N	127382	127382	127383
26225	41342	12	applied	\N	\N	\N	\N	127389	127389	127390
26225	41344	13	applied	\N	\N	\N	\N	127405	127405	127406
26225	41346	14	applied	\N	\N	\N	\N	127414	127414	127415
26225	41348	15	applied	\N	\N	\N	\N	127422	127422	127423
26225	41349	16	applied	\N	\N	\N	\N	127424	127424	127425
26225	41352	17	applied	\N	\N	\N	\N	127432	127432	127433
26225	41354	18	applied	\N	\N	\N	\N	127440	127440	127441
26225	41356	19	applied	\N	\N	\N	\N	127446	127446	127447
26225	41358	20	applied	\N	\N	\N	\N	127454	127454	127455
26225	41360	21	applied	\N	\N	\N	\N	127458	127458	127459
26225	41363	22	applied	\N	\N	\N	\N	127466	127466	127467
26225	41364	23	applied	\N	\N	\N	\N	127468	127468	127469
26225	41369	24	applied	\N	\N	\N	\N	127480	127480	127481
26225	41372	25	applied	\N	\N	\N	\N	127501	127501	127502
26225	41373	26	applied	\N	\N	\N	\N	127503	127503	127504
26225	41378	27	applied	\N	\N	\N	\N	127522	127522	127523
26225	41383	28	applied	\N	\N	\N	\N	127539	127539	127540
26225	41384	29	applied	\N	\N	\N	\N	127541	127541	127542
26225	41391	30	applied	\N	\N	\N	\N	127558	127558	127559
26225	41397	31	applied	\N	\N	\N	\N	127572	127572	127573
26225	41400	32	applied	\N	\N	\N	\N	127581	127581	127582
26225	41401	33	applied	\N	\N	\N	\N	127583	127583	127584
26225	41406	34	applied	\N	\N	\N	\N	127595	127595	127596
26225	41409	35	applied	\N	\N	\N	\N	127603	127603	127604
26225	41410	36	applied	\N	\N	\N	\N	127605	127605	127606
26225	41417	37	applied	\N	\N	\N	\N	127621	127621	127622
26225	41423	38	applied	\N	\N	\N	\N	127638	127638	127639
26225	41424	39	applied	\N	\N	\N	\N	127640	127640	127641
26225	41425	40	applied	\N	\N	\N	\N	127642	127642	127643
26225	41426	41	applied	\N	\N	\N	\N	127644	127644	127645
26225	41437	42	applied	\N	\N	\N	\N	127671	127671	127672
26225	41438	43	applied	\N	\N	\N	\N	127673	127673	127674
26225	41444	44	applied	\N	\N	\N	\N	127690	127690	127691
26225	41446	45	applied	\N	\N	\N	\N	127694	127694	127695
26225	41451	46	applied	\N	\N	\N	\N	127706	127706	127707
26225	41454	47	applied	\N	\N	\N	\N	127738	127738	127739
26225	41458	48	applied	\N	\N	\N	\N	127749	127749	127750
26225	41462	49	applied	\N	\N	\N	\N	127762	127762	127763
26225	41463	50	applied	\N	\N	\N	\N	127764	127764	127765
26225	41464	51	applied	\N	\N	\N	\N	127766	127766	127767
26225	41473	52	applied	\N	\N	\N	\N	127785	127785	127786
26225	41478	53	applied	\N	\N	\N	\N	127801	127801	127802
26225	41479	54	applied	\N	\N	\N	\N	127803	127803	127804
26225	41484	55	applied	\N	\N	\N	\N	127817	127817	127818
26225	41489	56	applied	\N	\N	\N	\N	127830	127830	127831
26225	41492	57	applied	\N	\N	\N	\N	127838	127838	127839
26225	41497	58	applied	\N	\N	\N	\N	127852	127852	127853
26225	41501	59	applied	\N	\N	\N	\N	127863	127863	127864
26225	41502	60	applied	\N	\N	\N	\N	127865	127865	127866
26225	41503	61	applied	\N	\N	\N	\N	127867	127867	127868
26225	41504	62	applied	\N	\N	\N	\N	127869	127869	127870
26225	41514	63	applied	\N	\N	\N	\N	127891	127891	127892
26225	41517	64	applied	\N	\N	\N	\N	127899	127899	127900
26225	41521	65	applied	\N	\N	\N	\N	127910	127910	127911
26225	41524	66	applied	\N	\N	\N	\N	127918	127918	127919
26225	41527	67	applied	\N	\N	\N	\N	127925	127925	127926
26225	41530	68	applied	\N	\N	\N	\N	127931	127931	127932
26225	41534	69	applied	\N	\N	\N	\N	127946	127946	127947
26225	41535	70	applied	\N	\N	\N	\N	127948	127948	127949
26225	41540	71	applied	\N	\N	\N	\N	127960	127960	127961
26225	41544	72	applied	\N	\N	\N	\N	127971	127971	127972
26225	41547	73	applied	\N	\N	\N	\N	127981	127981	127982
26225	41548	74	applied	\N	\N	\N	\N	127983	127983	127984
26225	41554	75	applied	\N	\N	\N	\N	127997	127997	127998
26225	41555	76	applied	\N	\N	\N	\N	127999	127999	128000
26225	41556	77	applied	\N	\N	\N	\N	128001	128001	128002
26225	41121	78	applied	\N	\N	\N	\N	126482	126482	126483
26225	41459	79	applied	\N	\N	1000000000	\N	127751	127751	128003
26225	41101	80	applied	\N	\N	\N	\N	126434	126434	126435
26225	41294	81	applied	\N	\N	\N	\N	127208	127208	44452
26225	41102	82	applied	\N	\N	\N	\N	126436	126436	126437
26225	41098	83	applied	\N	\N	\N	\N	126428	126428	126438
26225	41471	84	applied	\N	\N	\N	\N	127780	127780	128004
26225	41103	85	applied	\N	\N	\N	\N	126439	126439	126440
26225	41104	86	applied	\N	\N	\N	\N	126441	126441	126442
26225	41429	87	applied	\N	\N	\N	\N	127650	127650	128005
26225	41430	88	applied	\N	\N	\N	\N	127652	127652	126447
26225	41439	89	applied	\N	\N	\N	\N	127675	127675	128006
26225	41106	90	applied	\N	\N	\N	\N	126446	126446	126449
26225	41111	91	applied	\N	\N	\N	\N	126458	126458	128007
26225	41450	92	applied	\N	\N	\N	\N	127702	127702	126457
26225	41112	93	applied	\N	\N	\N	\N	126460	126460	126459
26225	41115	94	applied	\N	\N	\N	\N	126468	126468	126461
26225	41118	95	applied	\N	\N	\N	\N	126476	126476	128008
26225	41123	96	applied	\N	\N	\N	\N	126486	126486	128009
26225	41125	97	applied	\N	\N	\N	\N	126614	126614	128010
26225	41129	98	applied	\N	\N	\N	\N	126623	126623	126471
26225	41361	99	applied	\N	\N	\N	\N	127460	127460	126477
26225	41365	100	applied	\N	\N	\N	\N	127470	127470	127194
26225	41366	101	applied	\N	\N	\N	\N	127472	127472	127195
26225	41370	102	applied	\N	\N	\N	\N	127482	127482	126485
26225	41376	103	applied	\N	\N	\N	\N	127509	127509	126487
26225	41377	104	applied	\N	\N	\N	\N	127511	127511	126615
26225	41379	105	applied	\N	\N	\N	\N	127524	127524	127197
26225	41385	106	applied	\N	\N	\N	\N	127543	127543	128011
26225	41389	107	applied	\N	\N	\N	\N	127551	127551	126622
26225	41392	108	applied	\N	\N	\N	\N	127560	127560	126624
26225	41398	109	applied	\N	\N	\N	\N	127574	127574	128012
26225	41404	110	applied	\N	\N	\N	\N	127589	127589	128013
26225	41405	111	applied	\N	\N	\N	\N	127591	127591	126639
26225	41408	112	applied	\N	\N	\N	\N	127599	127599	128014
26225	41411	113	applied	\N	\N	\N	\N	127607	127607	128015
26225	41412	114	applied	\N	\N	\N	\N	127609	127609	126653
26225	41419	115	applied	\N	\N	\N	\N	127625	127625	128016
26225	41421	116	applied	\N	\N	\N	\N	127631	127631	128017
26225	41428	118	applied	\N	\N	\N	\N	127648	127648	126772
26225	41431	119	applied	\N	\N	\N	\N	127654	127654	128019
26225	41432	120	applied	\N	\N	\N	\N	127656	127656	128020
26225	41433	121	applied	\N	\N	\N	\N	127658	127658	126782
26225	41440	122	applied	\N	\N	\N	\N	127677	127677	128021
26225	41443	123	applied	\N	\N	\N	\N	127683	127683	128022
26225	41445	124	applied	\N	\N	\N	\N	127692	127692	126796
26225	41447	125	applied	\N	\N	\N	\N	127696	127696	128023
26232	41591	0	applied	\N	\N	\N	\N	128104	128104	128105
26227	41574	20	applied	\N	\N	\N	\N	128060	128060	128061
26227	41575	21	applied	\N	\N	\N	\N	128062	128062	128063
26227	41576	22	applied	\N	\N	\N	\N	128064	128064	128065
26227	41577	23	applied	\N	\N	\N	\N	128066	128066	128067
26229	41581	0	applied	\N	\N	\N	\N	128079	128079	128080
26229	41582	1	applied	\N	\N	\N	\N	128081	128081	128082
26229	41583	2	applied	\N	\N	\N	\N	128083	128083	128084
26236	41601	0	applied	\N	\N	\N	\N	128129	128129	128130
26236	41602	1	applied	\N	\N	\N	\N	128131	128131	128132
26236	41603	2	applied	\N	\N	\N	\N	128133	128133	128134
26237	41601	0	applied	\N	\N	\N	\N	128129	128129	128130
26237	41602	1	applied	\N	\N	\N	\N	128131	128131	128132
26237	41603	2	applied	\N	\N	\N	\N	128133	128133	128134
26244	41624	0	applied	\N	\N	\N	\N	128182	128182	128183
26244	41625	1	applied	\N	\N	\N	\N	128184	128184	128185
26244	41626	2	applied	\N	\N	\N	\N	128186	128186	128187
26247	41624	0	applied	\N	\N	\N	\N	128182	128182	128183
26247	41625	1	applied	\N	\N	\N	\N	128184	128184	128185
26247	41626	2	applied	\N	\N	\N	\N	128186	128186	128187
26248	41627	0	applied	\N	\N	\N	\N	128197	128197	128198
26248	41628	1	applied	\N	\N	\N	\N	128199	128199	128200
26248	41629	2	applied	\N	\N	\N	\N	128201	128201	128202
26252	41650	0	applied	\N	\N	\N	\N	128250	128250	128251
26252	41651	1	applied	\N	\N	\N	\N	128252	128252	128253
26252	41652	2	applied	\N	\N	\N	\N	128254	128254	128255
26257	41660	0	applied	\N	\N	\N	\N	128275	128275	128276
26257	41661	1	applied	\N	\N	\N	\N	128277	128277	128278
26257	41662	2	applied	\N	\N	\N	\N	128279	128279	128280
26259	41663	0	applied	\N	\N	\N	\N	128285	128285	128286
26259	41664	1	applied	\N	\N	\N	\N	128287	128287	128288
26259	41665	2	applied	\N	\N	\N	\N	128289	128289	128290
26262	41672	0	applied	\N	\N	\N	\N	128307	128307	128308
26262	41673	1	applied	\N	\N	\N	\N	128309	128309	128310
26262	41674	2	applied	\N	\N	\N	\N	128311	128311	128312
26262	41675	3	applied	\N	\N	\N	\N	128313	128313	128314
26262	41676	4	applied	\N	\N	\N	\N	128315	128315	128316
26262	41677	5	applied	\N	\N	\N	\N	128317	128317	128318
26262	41678	6	applied	\N	\N	\N	\N	128319	128319	128320
26264	41679	0	applied	\N	\N	\N	\N	128324	128324	128325
26264	41680	1	applied	\N	\N	\N	\N	128326	128326	128327
26264	41681	2	applied	\N	\N	\N	\N	128328	128328	128329
26267	41692	0	applied	\N	\N	\N	\N	128353	128353	128354
26267	41693	1	applied	\N	\N	\N	\N	128355	128355	128356
26267	41694	2	applied	\N	\N	\N	\N	128357	128357	128358
26270	41695	0	applied	\N	\N	\N	\N	128363	128363	128364
26270	41696	1	applied	\N	\N	\N	\N	128365	128365	128366
26270	41697	2	applied	\N	\N	\N	\N	128367	128367	128368
26272	41702	0	applied	\N	\N	\N	\N	128382	128382	128383
26272	41703	1	applied	\N	\N	\N	\N	128384	128384	128385
26275	41707	0	applied	\N	\N	\N	\N	128394	128394	128395
26275	41708	1	applied	\N	\N	\N	\N	128396	128396	128397
26275	41709	2	applied	\N	\N	\N	\N	128398	128398	128399
26275	41710	3	applied	\N	\N	\N	\N	128400	128400	128401
26277	41711	0	applied	\N	\N	\N	\N	128407	128407	128408
26277	41712	1	applied	\N	\N	\N	\N	128409	128409	128410
26277	41713	2	applied	\N	\N	\N	\N	128411	128411	128412
26277	41714	3	applied	\N	\N	\N	\N	128413	128413	128414
26277	41715	4	applied	\N	\N	\N	\N	128415	128415	128416
26277	41716	5	applied	\N	\N	\N	\N	128417	128417	128418
26290	41745	0	applied	\N	\N	\N	\N	128516	128516	128517
26290	41746	1	applied	\N	\N	\N	\N	128518	128518	128519
26298	41762	0	applied	\N	\N	\N	\N	128560	128560	128561
26298	41763	1	applied	\N	\N	\N	\N	128562	128562	128563
26306	41783	0	applied	\N	\N	\N	\N	128614	128614	128615
26313	41782	0	applied	\N	\N	\N	\N	128612	128612	128613
26313	41785	1	applied	\N	\N	\N	\N	128638	128638	128639
26313	41786	2	applied	\N	\N	\N	\N	128640	128640	128641
26313	41784	3	applied	\N	\N	\N	\N	128616	128616	128617
26313	41787	4	applied	\N	\N	\N	\N	128642	128642	128643
26313	41788	5	applied	\N	\N	\N	\N	128644	128644	128645
26314	41789	0	applied	\N	\N	\N	\N	128651	128651	128652
26314	41790	1	applied	\N	\N	\N	\N	128653	128653	128654
26314	41791	2	applied	\N	\N	\N	\N	128655	128655	128656
26325	41801	0	applied	\N	\N	\N	\N	128690	128690	128691
26325	41802	1	applied	\N	\N	\N	\N	128692	128692	128693
26328	41803	0	applied	\N	\N	\N	\N	128695	128695	128696
26328	41804	1	applied	\N	\N	\N	\N	128697	128697	128698
26331	41805	0	applied	\N	\N	\N	\N	128702	128702	128703
26331	41806	1	applied	\N	\N	\N	\N	128704	128704	128705
26331	41807	2	applied	\N	\N	\N	\N	128706	128706	128707
26331	41808	3	applied	\N	\N	\N	\N	128711	128711	128712
26331	41809	4	applied	\N	\N	\N	\N	128713	128713	128714
26338	41819	0	applied	\N	\N	\N	\N	128739	128739	128740
26342	41826	0	applied	\N	\N	\N	\N	128760	128760	128761
26342	41827	1	applied	\N	\N	\N	\N	128762	128762	128763
26345	41828	0	applied	\N	\N	\N	\N	128767	128767	128768
26345	41829	1	applied	\N	\N	\N	\N	128769	128769	128770
26345	41830	2	applied	\N	\N	\N	\N	128771	128771	128772
26347	41829	0	applied	\N	\N	\N	\N	128769	128769	128770
26347	41830	1	applied	\N	\N	\N	\N	128771	128771	128772
26352	41832	0	applied	\N	\N	\N	\N	128785	128785	128786
26352	41833	1	applied	\N	\N	\N	\N	128787	128787	128788
26352	41834	2	applied	\N	\N	\N	\N	128789	128789	128790
26352	41835	3	applied	\N	\N	\N	\N	128791	128791	128792
26352	41836	4	applied	\N	\N	\N	\N	128793	128793	128794
26352	41837	5	applied	\N	\N	\N	\N	128795	128795	128796
26352	41838	6	applied	\N	\N	\N	\N	128797	128797	128798
26354	41839	0	applied	\N	\N	\N	\N	128802	128802	128803
26354	41840	1	applied	\N	\N	\N	\N	128804	128804	128805
26357	41843	0	applied	\N	\N	\N	\N	128812	128812	128813
26357	41844	1	applied	\N	\N	\N	\N	128814	128814	128815
26357	41845	2	applied	\N	\N	\N	\N	128816	128816	128817
26357	41846	3	applied	\N	\N	\N	\N	128818	128818	128819
26357	41847	4	applied	\N	\N	\N	\N	128820	128820	128821
26357	41848	5	applied	\N	\N	\N	\N	128822	128822	128823
26357	41849	6	applied	\N	\N	\N	\N	128824	128824	128825
26359	41850	0	applied	\N	\N	\N	\N	128832	128832	128833
26359	41851	1	applied	\N	\N	\N	\N	128834	128834	128835
26359	41852	2	applied	\N	\N	\N	\N	128836	128836	128837
26364	41860	0	applied	\N	\N	\N	\N	128859	128859	128860
26364	41861	1	applied	\N	\N	\N	\N	128861	128861	128862
26367	41869	0	applied	\N	\N	\N	\N	128880	128880	128881
26367	41870	1	applied	\N	\N	\N	\N	128882	128882	128883
26367	41871	2	applied	\N	\N	\N	\N	128884	128884	128885
26367	41872	3	applied	\N	\N	\N	\N	128886	128886	128887
26370	41878	0	applied	\N	\N	\N	\N	128903	128903	128904
26370	41879	1	applied	\N	\N	\N	\N	128905	128905	128906
26370	41876	2	applied	\N	\N	\N	\N	128898	128898	128907
26370	41877	3	applied	\N	\N	\N	\N	128900	128900	128908
26370	41880	4	applied	\N	\N	\N	\N	128909	128909	128910
26232	41592	1	applied	\N	\N	\N	\N	128106	128106	128107
26232	41593	2	applied	\N	\N	\N	\N	128108	128108	128109
26238	41601	0	applied	\N	\N	\N	\N	128129	128129	128130
26238	41602	1	applied	\N	\N	\N	\N	128131	128131	128132
26238	41603	2	applied	\N	\N	\N	\N	128133	128133	128134
26245	41624	0	applied	\N	\N	\N	\N	128182	128182	128183
26245	41625	1	applied	\N	\N	\N	\N	128184	128184	128185
26245	41626	2	applied	\N	\N	\N	\N	128186	128186	128187
26255	41660	0	applied	\N	\N	\N	\N	128275	128275	128276
26255	41661	1	applied	\N	\N	\N	\N	128277	128277	128278
26255	41662	2	applied	\N	\N	\N	\N	128279	128279	128280
26258	41660	0	applied	\N	\N	\N	\N	128275	128275	128276
26258	41661	1	applied	\N	\N	\N	\N	128277	128277	128278
26258	41662	2	applied	\N	\N	\N	\N	128279	128279	128280
26260	41663	0	applied	\N	\N	\N	\N	128285	128285	128286
26260	41664	1	applied	\N	\N	\N	\N	128287	128287	128288
26260	41665	2	applied	\N	\N	\N	\N	128289	128289	128290
26263	41672	0	applied	\N	\N	\N	\N	128307	128307	128308
26263	41673	1	applied	\N	\N	\N	\N	128309	128309	128310
26263	41674	2	applied	\N	\N	\N	\N	128311	128311	128312
26263	41675	3	applied	\N	\N	\N	\N	128313	128313	128314
26263	41676	4	applied	\N	\N	\N	\N	128315	128315	128316
26263	41677	5	applied	\N	\N	\N	\N	128317	128317	128318
26263	41678	6	applied	\N	\N	\N	\N	128319	128319	128320
26265	41682	0	applied	\N	\N	\N	\N	128332	128332	128333
26265	41683	1	applied	\N	\N	\N	\N	128334	128334	128335
26265	41684	2	applied	\N	\N	\N	\N	128336	128336	128337
26265	41685	3	applied	\N	\N	\N	\N	128338	128338	128339
26265	41686	4	applied	\N	\N	\N	\N	128340	128340	128341
26265	41687	5	applied	\N	\N	\N	\N	128342	128342	128343
26265	41688	6	applied	\N	\N	\N	\N	128344	128344	128345
26276	41707	0	applied	\N	\N	\N	\N	128394	128394	128395
26276	41708	1	applied	\N	\N	\N	\N	128396	128396	128397
26276	41709	2	applied	\N	\N	\N	\N	128398	128398	128399
26276	41710	3	applied	\N	\N	\N	\N	128400	128400	128401
26280	41195	0	applied	\N	\N	\N	\N	126913	126913	126914
26280	41158	1	applied	\N	\N	\N	\N	128436	128436	126826
26280	41161	2	applied	\N	\N	\N	\N	128437	128437	126832
26280	41162	3	applied	\N	\N	\N	\N	128438	128438	126834
26280	41163	4	applied	\N	\N	\N	\N	128439	128439	126836
26280	41169	5	applied	\N	\N	\N	\N	128440	128440	126850
26280	41171	6	applied	\N	\N	\N	\N	128441	128441	126855
26280	41196	7	applied	\N	\N	\N	\N	126915	126915	126916
26280	41197	8	applied	\N	\N	\N	\N	126917	126917	126918
26280	41198	9	applied	\N	\N	\N	\N	126919	126919	126920
26280	41201	10	applied	\N	\N	\N	\N	126950	126950	126951
26280	41203	11	applied	\N	\N	\N	\N	126954	126954	126955
26280	41204	12	applied	\N	\N	\N	\N	126956	126956	126957
26280	41205	13	applied	\N	\N	\N	\N	126958	126958	126959
26280	41206	14	applied	\N	\N	\N	\N	126960	126960	126961
26280	41207	15	applied	\N	\N	\N	\N	126962	126962	126963
26280	41208	16	applied	\N	\N	\N	\N	126964	126964	126965
26280	41209	17	applied	\N	\N	\N	\N	126966	126966	126967
26280	41210	18	applied	\N	\N	\N	\N	126968	126968	126969
26280	41288	19	applied	\N	\N	\N	\N	127178	127178	127022
26280	41289	20	applied	\N	\N	\N	\N	127179	127179	127041
26280	41290	21	applied	\N	\N	\N	\N	127180	127180	127045
26280	41219	22	applied	\N	\N	\N	\N	127181	127181	126993
26280	41220	23	applied	\N	\N	\N	\N	127182	127182	126995
26280	41221	24	applied	\N	\N	\N	\N	127183	127183	126997
26280	41222	25	applied	\N	\N	\N	\N	127184	127184	126999
26280	41223	26	applied	\N	\N	\N	\N	127185	127185	127001
26280	41172	27	applied	\N	\N	\N	\N	128442	128442	126857
26280	41173	28	applied	\N	\N	\N	\N	128443	128443	126859
26280	41174	29	applied	\N	\N	\N	\N	128444	128444	126861
26280	41175	30	applied	\N	\N	\N	\N	128445	128445	126863
26280	41176	31	applied	\N	\N	\N	\N	128446	128446	126865
26280	41177	32	applied	\N	\N	\N	\N	128447	128447	126867
26280	41179	33	applied	\N	\N	\N	\N	128448	128448	126873
26280	41180	34	applied	\N	\N	\N	\N	128449	128449	126875
26280	41181	35	applied	\N	\N	\N	\N	128450	128450	126877
26280	41182	36	applied	\N	\N	\N	\N	128451	128451	126879
26280	41183	37	applied	\N	\N	\N	\N	128452	128452	126881
26280	41184	38	applied	\N	\N	\N	\N	128453	128453	126883
26280	41185	39	applied	\N	\N	\N	\N	128454	128454	126885
26280	41186	40	applied	\N	\N	\N	\N	128455	128455	126887
26280	41224	41	applied	\N	\N	\N	\N	127186	127186	127003
26280	41233	42	applied	\N	\N	\N	\N	127187	127187	127188
26280	41241	43	applied	\N	\N	\N	\N	127189	127189	127190
26280	41048	44	applied	\N	\N	\N	\N	126276	126276	126277
26280	41050	45	applied	\N	\N	\N	\N	126283	126283	126284
26280	41052	46	applied	\N	\N	\N	\N	126289	126289	126290
26280	41054	47	applied	\N	\N	\N	\N	126294	126294	126295
26280	41056	48	applied	\N	\N	\N	\N	126302	126302	126303
26280	41058	49	applied	\N	\N	\N	\N	126310	126310	126311
26280	41059	50	applied	\N	\N	\N	\N	126312	126312	126313
26280	41062	51	applied	\N	\N	\N	\N	126320	126320	126321
26280	41064	52	applied	\N	\N	\N	\N	126325	126325	126326
26280	41243	53	applied	\N	\N	\N	\N	127191	127191	127192
26280	41066	54	applied	\N	\N	\N	\N	126331	126331	126332
26280	41068	55	applied	\N	\N	\N	\N	126336	126336	126337
26280	41070	56	applied	\N	\N	\N	\N	126344	126344	126345
26280	41071	57	applied	\N	\N	\N	\N	126346	126346	126347
26280	41072	58	applied	\N	\N	\N	\N	126348	126348	126349
26280	41076	59	applied	\N	\N	\N	\N	126358	126358	126359
26280	41078	60	applied	\N	\N	\N	\N	126363	126363	126364
26280	41080	61	applied	\N	\N	\N	\N	126370	126370	126371
26280	41082	62	applied	\N	\N	\N	\N	126378	126378	126379
26280	41084	63	applied	\N	\N	\N	\N	126384	126384	126385
26280	41086	64	applied	\N	\N	\N	\N	126392	126392	126393
26280	41087	65	applied	\N	\N	\N	\N	126394	126394	126395
26280	41090	66	applied	\N	\N	\N	\N	126405	126405	126406
26280	41091	67	applied	\N	\N	\N	\N	126407	126407	126408
26280	41095	68	applied	\N	\N	\N	\N	126415	126415	126416
26280	41097	69	applied	\N	\N	\N	\N	126425	126425	126426
26280	41099	70	applied	\N	\N	\N	\N	126430	126430	126431
26280	41100	71	applied	\N	\N	\N	\N	126432	126432	126433
26280	41105	72	applied	\N	\N	\N	\N	126444	126444	126445
26280	41108	73	applied	\N	\N	\N	\N	126452	126452	126453
26280	41109	74	applied	\N	\N	\N	\N	126454	126454	126455
26280	41114	75	applied	\N	\N	\N	\N	126466	126466	126467
26280	41117	77	applied	\N	\N	\N	\N	126474	126474	126475
26280	41120	78	applied	\N	\N	\N	\N	126480	126480	126481
26280	41124	79	applied	\N	\N	\N	\N	126612	126612	126613
26280	41127	80	applied	\N	\N	\N	\N	126619	126619	126620
26280	41130	81	applied	\N	\N	\N	\N	126630	126630	126631
26280	41132	82	applied	\N	\N	\N	\N	126636	126636	126637
26280	41134	83	applied	\N	\N	\N	\N	126642	126642	126643
26280	41136	84	applied	\N	\N	\N	\N	126650	126650	126651
26280	41138	85	applied	\N	\N	\N	\N	126656	126656	126657
26280	41140	86	applied	\N	\N	\N	\N	126769	126769	126770
26280	41142	87	applied	\N	\N	\N	\N	126775	126775	126776
26280	41143	88	applied	\N	\N	\N	\N	126777	126777	126778
26280	41146	89	applied	\N	\N	\N	\N	126787	126787	126788
26280	41148	90	applied	\N	\N	\N	\N	126793	126793	126794
26280	41150	91	applied	\N	\N	\N	\N	126802	126802	126803
26280	41152	92	applied	\N	\N	\N	\N	126807	126807	126808
26280	41153	93	applied	\N	\N	\N	\N	126809	126809	126810
26280	41156	94	applied	\N	\N	\N	\N	126817	126817	126818
26280	41157	95	applied	\N	\N	\N	\N	126819	126819	126820
26280	41159	96	applied	\N	\N	\N	\N	126827	126827	126828
26280	41160	97	applied	\N	\N	\N	\N	126829	126829	126830
26280	41170	98	applied	\N	\N	\N	\N	126852	126852	126853
26280	41187	99	applied	\N	\N	\N	\N	126888	126888	126889
26280	41189	100	applied	\N	\N	\N	\N	126894	126894	126895
26280	41191	101	applied	\N	\N	\N	\N	126901	126901	126902
26280	41193	102	applied	\N	\N	\N	\N	126907	126907	126908
26280	41199	103	applied	\N	\N	\N	\N	126921	126921	126922
26280	41202	104	applied	\N	\N	\N	\N	126952	126952	126953
26280	41212	105	applied	\N	\N	\N	\N	126974	126974	126975
26280	41213	106	applied	\N	\N	\N	\N	126976	126976	126977
26280	41225	107	applied	\N	\N	\N	\N	127004	127004	127005
26280	41226	108	applied	\N	\N	\N	\N	127006	127006	127007
26280	41227	109	applied	\N	\N	\N	\N	127008	127008	127009
26280	41231	110	applied	\N	\N	\N	\N	127017	127017	127018
26280	41232	111	applied	\N	\N	\N	\N	127019	127019	127020
26280	41234	112	applied	\N	\N	\N	\N	127023	127023	127024
26280	41235	113	applied	\N	\N	\N	\N	127025	127025	127026
26280	41240	114	applied	\N	\N	\N	\N	127038	127038	127039
26280	41242	115	applied	\N	\N	\N	\N	127042	127042	127043
26280	41246	116	applied	\N	\N	\N	\N	127053	127053	127054
26280	41247	117	applied	\N	\N	\N	\N	127055	127055	127056
26280	41248	118	applied	\N	\N	\N	\N	127057	127057	127058
26280	41249	119	applied	\N	\N	\N	\N	127059	127059	127060
26280	41254	120	applied	\N	\N	\N	\N	127072	127072	127073
26280	41255	121	applied	\N	\N	\N	\N	127074	127074	127075
26280	41258	122	applied	\N	\N	\N	\N	127083	127083	127084
26280	41260	123	applied	\N	\N	\N	\N	127088	127088	127089
26280	41262	124	applied	\N	\N	\N	\N	127093	127093	127094
26280	41264	125	applied	\N	\N	\N	\N	127101	127101	127102
26283	41724	0	applied	\N	\N	\N	\N	128459	128459	128460
26283	41725	1	applied	\N	\N	\N	\N	128461	128461	128462
26283	41726	2	applied	\N	\N	\N	\N	128463	128463	128464
26283	41727	3	applied	\N	\N	\N	\N	128465	128465	128466
26283	41728	4	applied	\N	\N	\N	\N	128467	128467	128468
26283	41729	5	applied	\N	\N	\N	\N	128469	128469	128470
26283	41730	6	applied	\N	\N	\N	\N	128471	128471	128472
26285	41731	0	applied	\N	\N	\N	\N	128479	128479	128480
26285	41732	1	applied	\N	\N	\N	\N	128481	128481	128482
26287	41733	0	applied	\N	\N	\N	\N	128487	128487	128488
26287	41734	1	applied	\N	\N	\N	\N	128489	128489	128490
26288	41735	0	applied	\N	\N	\N	\N	128493	128493	128494
26288	41736	1	applied	\N	\N	\N	\N	128495	128495	128496
26288	41737	2	applied	\N	\N	\N	\N	128497	128497	128498
26288	41738	3	applied	\N	\N	\N	\N	128499	128499	128500
26288	41739	4	applied	\N	\N	\N	\N	128501	128501	128502
26288	41740	5	applied	\N	\N	\N	\N	128503	128503	128504
26288	41741	6	applied	\N	\N	\N	\N	128505	128505	128506
26293	41749	0	applied	\N	\N	\N	\N	128527	128527	128528
26293	41750	1	applied	\N	\N	\N	\N	128529	128529	128530
26294	41751	0	applied	\N	\N	\N	\N	128533	128533	128534
26294	41752	1	applied	\N	\N	\N	\N	128535	128535	128536
26294	41753	2	applied	\N	\N	\N	\N	128537	128537	128538
26294	41754	3	applied	\N	\N	\N	\N	128539	128539	128540
26294	41755	4	applied	\N	\N	\N	\N	128541	128541	128542
26294	41756	5	applied	\N	\N	\N	\N	128543	128543	128544
26294	41757	6	applied	\N	\N	\N	\N	128545	128545	128546
26294	41758	7	applied	\N	\N	\N	\N	128547	128547	128548
26294	41759	8	applied	\N	\N	\N	\N	128549	128549	128550
26294	41760	9	applied	\N	\N	\N	\N	128551	128551	128552
26294	41761	10	applied	\N	\N	\N	\N	128553	128553	128554
26301	41764	0	applied	\N	\N	\N	\N	128566	128566	128567
26301	41765	1	applied	\N	\N	\N	\N	128568	128568	128569
26301	41766	2	applied	\N	\N	\N	\N	128570	128570	128571
26301	41767	3	applied	\N	\N	\N	\N	128572	128572	128573
26301	41768	4	applied	\N	\N	\N	\N	128574	128574	128575
26304	41780	0	applied	\N	\N	\N	\N	128606	128606	128607
26304	41781	1	applied	\N	\N	\N	\N	128608	128608	128609
26315	41789	0	applied	\N	\N	\N	\N	128651	128651	128652
26315	41790	1	applied	\N	\N	\N	\N	128653	128653	128654
26315	41791	2	applied	\N	\N	\N	\N	128655	128655	128656
26317	41792	0	applied	\N	\N	\N	\N	128662	128662	128663
26317	41793	1	applied	\N	\N	\N	\N	128664	128664	128665
26317	41790	2	applied	\N	\N	\N	\N	128653	128653	128656
26317	41794	3	applied	\N	\N	\N	\N	128666	128666	128667
26317	41795	4	applied	\N	\N	\N	\N	128668	128668	128669
26320	41792	0	applied	\N	\N	\N	\N	128662	128662	128663
26320	41793	1	applied	\N	\N	\N	\N	128664	128664	128665
26320	41790	2	applied	\N	\N	\N	\N	128653	128653	128656
26320	41794	3	applied	\N	\N	\N	\N	128666	128666	128667
26320	41795	4	applied	\N	\N	\N	\N	128668	128668	128669
26324	41796	0	applied	\N	\N	\N	\N	128678	128678	128679
26324	41797	1	applied	\N	\N	\N	\N	128680	128680	128681
26324	41798	2	applied	\N	\N	\N	\N	128682	128682	128683
26324	41799	3	applied	\N	\N	\N	\N	128684	128684	128685
26324	41800	4	applied	\N	\N	\N	\N	128686	128686	128687
26326	41803	0	applied	\N	\N	\N	\N	128695	128695	128696
26326	41804	1	applied	\N	\N	\N	\N	128697	128697	128698
26332	41805	0	applied	\N	\N	\N	\N	128702	128702	128703
26332	41806	1	applied	\N	\N	\N	\N	128704	128704	128705
26332	41807	2	applied	\N	\N	\N	\N	128706	128706	128707
26332	41808	3	applied	\N	\N	\N	\N	128711	128711	128712
26332	41809	4	applied	\N	\N	\N	\N	128713	128713	128714
26335	41812	0	applied	\N	\N	\N	\N	128723	128723	128724
26335	41813	1	applied	\N	\N	\N	\N	128725	128725	128726
26335	41814	2	applied	\N	\N	\N	\N	128727	128727	128728
26343	41826	0	applied	\N	\N	\N	\N	128760	128760	128761
26343	41827	1	applied	\N	\N	\N	\N	128762	128762	128763
26346	41828	0	applied	\N	\N	\N	\N	128767	128767	128768
26346	41829	1	applied	\N	\N	\N	\N	128769	128769	128770
26346	41830	2	applied	\N	\N	\N	\N	128771	128771	128772
26348	41828	0	applied	\N	\N	\N	\N	128767	128767	128768
26348	41829	1	applied	\N	\N	\N	\N	128769	128769	128770
26349	41831	0	applied	\N	\N	\N	\N	128780	128780	128781
26362	41857	0	applied	\N	\N	\N	\N	128852	128852	128853
26362	41858	1	applied	\N	\N	\N	\N	128854	128854	128855
26362	41859	2	applied	\N	\N	\N	\N	128856	128856	128857
26368	41873	0	applied	\N	\N	\N	\N	128890	128890	128891
26368	41874	1	applied	\N	\N	\N	\N	128892	128892	128893
26368	41875	2	applied	\N	\N	\N	\N	128894	128894	128895
26282	41727	3	applied	\N	\N	\N	\N	128465	128465	128466
26282	41728	4	applied	\N	\N	\N	\N	128467	128467	128468
26282	41729	5	applied	\N	\N	\N	\N	128469	128469	128470
26282	41730	6	applied	\N	\N	\N	\N	128471	128471	128472
26284	41724	0	applied	\N	\N	\N	\N	128459	128459	128460
26284	41725	1	applied	\N	\N	\N	\N	128461	128461	128462
26284	41726	2	applied	\N	\N	\N	\N	128463	128463	128464
26284	41727	3	applied	\N	\N	\N	\N	128465	128465	128466
26284	41728	4	applied	\N	\N	\N	\N	128467	128467	128468
26284	41729	5	applied	\N	\N	\N	\N	128469	128469	128470
26284	41730	6	applied	\N	\N	\N	\N	128471	128471	128472
26286	41731	0	applied	\N	\N	\N	\N	128479	128479	128480
26286	41732	1	applied	\N	\N	\N	\N	128481	128481	128482
26289	41742	0	applied	\N	\N	\N	\N	128508	128508	128509
26289	41743	1	applied	\N	\N	\N	\N	128510	128510	128511
26289	41744	2	applied	\N	\N	\N	\N	128512	128512	128513
26292	41747	0	applied	\N	\N	\N	\N	128522	128522	128523
26292	41748	1	applied	\N	\N	\N	\N	128524	128524	128525
26296	41751	0	applied	\N	\N	\N	\N	128533	128533	128534
26296	41752	1	applied	\N	\N	\N	\N	128535	128535	128536
26296	41753	2	applied	\N	\N	\N	\N	128537	128537	128538
26296	41754	3	applied	\N	\N	\N	\N	128539	128539	128540
26296	41755	4	applied	\N	\N	\N	\N	128541	128541	128542
26296	41756	5	applied	\N	\N	\N	\N	128543	128543	128544
26296	41757	6	applied	\N	\N	\N	\N	128545	128545	128546
26296	41758	7	applied	\N	\N	\N	\N	128547	128547	128548
26296	41759	8	applied	\N	\N	\N	\N	128549	128549	128550
26296	41760	9	applied	\N	\N	\N	\N	128551	128551	128552
26296	41761	10	applied	\N	\N	\N	\N	128553	128553	128554
26297	41762	0	applied	\N	\N	\N	\N	128560	128560	128561
26297	41763	1	applied	\N	\N	\N	\N	128562	128562	128563
26300	41764	0	applied	\N	\N	\N	\N	128566	128566	128567
26300	41765	1	applied	\N	\N	\N	\N	128568	128568	128569
26300	41766	2	applied	\N	\N	\N	\N	128570	128570	128571
26300	41767	3	applied	\N	\N	\N	\N	128572	128572	128573
26300	41768	4	applied	\N	\N	\N	\N	128574	128574	128575
26303	41775	0	applied	\N	\N	\N	\N	128594	128594	128595
26303	41776	1	applied	\N	\N	\N	\N	128596	128596	128597
26303	41777	2	applied	\N	\N	\N	\N	128598	128598	128599
26303	41778	3	applied	\N	\N	\N	\N	128600	128600	128601
26303	41779	4	applied	\N	\N	\N	\N	128602	128602	128603
26309	41459	0	applied	\N	\N	\N	\N	127751	127751	128622
26309	41471	1	applied	\N	\N	\N	\N	127780	127780	128623
26309	41429	2	applied	\N	\N	\N	\N	127650	127650	128624
26309	41430	3	applied	\N	\N	\N	\N	127652	127652	127525
26309	41439	4	applied	\N	\N	\N	\N	127675	127675	128625
26309	41450	5	applied	\N	\N	\N	\N	127702	127702	127714
26309	41761	6	applied	\N	\N	\N	\N	128553	128553	128554
26309	41472	7	applied	\N	\N	\N	\N	127782	127782	127529
26309	41474	8	applied	\N	\N	\N	\N	127787	127787	128626
26309	41486	9	applied	\N	\N	\N	\N	127821	127821	127544
26309	41499	10	applied	\N	\N	\N	\N	127856	127856	128627
26309	41510	11	applied	\N	\N	\N	\N	127881	127881	128628
26309	41519	12	applied	\N	\N	\N	\N	127903	127903	127546
26309	41531	13	applied	\N	\N	\N	\N	127933	127933	127715
26309	41543	14	applied	\N	\N	\N	\N	127966	127966	127552
26309	41549	15	applied	\N	\N	\N	\N	127985	127985	127716
26309	41570	16	applied	\N	\N	\N	\N	128052	128052	128629
26309	41571	17	applied	\N	\N	\N	\N	128054	128054	127554
26309	41590	18	applied	\N	\N	\N	\N	128099	128099	128630
26309	41600	19	applied	\N	\N	\N	\N	128123	128123	127561
26309	41611	20	applied	\N	\N	\N	\N	128154	128154	128631
26309	41621	21	applied	\N	\N	\N	\N	128174	128174	127717
26309	41636	22	applied	\N	\N	\N	\N	128218	128218	127569
26309	41643	23	applied	\N	\N	\N	\N	128234	128234	128632
26309	41656	24	applied	\N	\N	\N	\N	128264	128264	127575
26309	41671	25	applied	\N	\N	\N	\N	128303	128303	128633
26309	41676	26	applied	\N	\N	\N	\N	128315	128315	127718
26309	41685	27	applied	\N	\N	\N	\N	128338	128338	127577
26309	41699	28	applied	\N	\N	\N	\N	128372	128372	127719
26309	41708	29	applied	\N	\N	\N	\N	128396	128396	128634
26309	41720	30	applied	\N	\N	\N	\N	128426	128426	127586
26309	41730	31	applied	\N	\N	\N	\N	128471	128471	128635
26309	41738	32	applied	\N	\N	\N	\N	128499	128499	127720
26309	41744	33	applied	\N	\N	\N	\N	128512	128512	127588
26309	41755	34	applied	\N	\N	\N	\N	128541	128541	127721
26309	41756	35	applied	\N	\N	\N	\N	128543	128543	127590
26309	41768	36	applied	\N	\N	\N	\N	128574	128574	127722
26309	41777	37	applied	\N	\N	\N	\N	128598	128598	127592
26309	41783	38	applied	\N	\N	\N	\N	128614	128614	127723
26312	41782	0	applied	\N	\N	\N	\N	128612	128612	128613
26312	41785	1	applied	\N	\N	\N	\N	128638	128638	128639
26312	41786	2	applied	\N	\N	\N	\N	128640	128640	128641
26312	41784	3	applied	\N	\N	\N	\N	128616	128616	128617
26312	41787	4	applied	\N	\N	\N	\N	128642	128642	128643
26312	41788	5	applied	\N	\N	\N	\N	128644	128644	128645
26319	41792	0	applied	\N	\N	\N	\N	128662	128662	128663
26319	41793	1	applied	\N	\N	\N	\N	128664	128664	128665
26319	41790	2	applied	\N	\N	\N	\N	128653	128653	128656
26319	41794	3	applied	\N	\N	\N	\N	128666	128666	128667
26319	41795	4	applied	\N	\N	\N	\N	128668	128668	128669
26323	41796	0	applied	\N	\N	\N	\N	128678	128678	128679
26323	41797	1	applied	\N	\N	\N	\N	128680	128680	128681
26323	41798	2	applied	\N	\N	\N	\N	128682	128682	128683
26323	41799	3	applied	\N	\N	\N	\N	128684	128684	128685
26323	41800	4	applied	\N	\N	\N	\N	128686	128686	128687
26330	41805	0	applied	\N	\N	\N	\N	128702	128702	128703
26330	41806	1	applied	\N	\N	\N	\N	128704	128704	128705
26330	41807	2	applied	\N	\N	\N	\N	128706	128706	128707
26333	41805	0	applied	\N	\N	\N	\N	128702	128702	128703
26333	41806	1	applied	\N	\N	\N	\N	128704	128704	128705
26333	41807	2	applied	\N	\N	\N	\N	128706	128706	128707
26333	41808	3	applied	\N	\N	\N	\N	128711	128711	128712
26333	41809	4	applied	\N	\N	\N	\N	128713	128713	128714
26334	41810	0	applied	\N	\N	\N	\N	128718	128718	128719
26334	41808	1	applied	\N	\N	\N	\N	128711	128711	128712
26334	41809	2	applied	\N	\N	\N	\N	128713	128713	128714
26334	41811	3	applied	\N	\N	\N	\N	128720	128720	128721
26337	41819	0	applied	\N	\N	\N	\N	128739	128739	128740
26337	41820	1	applied	\N	\N	\N	\N	128741	128741	128742
26339	41821	0	applied	\N	\N	\N	\N	128746	128746	128747
26339	41822	1	applied	\N	\N	\N	\N	128748	128748	128749
26339	41823	2	applied	\N	\N	\N	\N	128750	128750	128751
26339	41824	3	applied	\N	\N	\N	\N	128752	128752	128753
26339	41825	4	applied	\N	\N	\N	\N	128754	128754	128755
26340	41821	0	applied	\N	\N	\N	\N	128746	128746	128747
26340	41822	1	applied	\N	\N	\N	\N	128748	128748	128749
26340	41823	2	applied	\N	\N	\N	\N	128750	128750	128751
26340	41824	3	applied	\N	\N	\N	\N	128752	128752	128753
26340	41825	4	applied	\N	\N	\N	\N	128754	128754	128755
26299	41768	4	applied	\N	\N	\N	\N	128574	128574	128575
26302	41769	0	applied	\N	\N	\N	\N	128581	128581	128582
26302	41770	1	applied	\N	\N	\N	\N	128583	128583	128584
26302	41771	2	applied	\N	\N	\N	\N	128585	128585	128586
26302	41772	3	applied	\N	\N	\N	\N	128587	128587	128588
26302	41773	4	applied	\N	\N	\N	\N	128589	128589	128590
26302	41774	5	applied	\N	\N	\N	\N	128591	128591	128592
26305	41782	0	applied	\N	\N	\N	\N	128612	128612	128613
26305	41783	1	applied	\N	\N	\N	\N	128614	128614	128615
26305	41784	2	applied	\N	\N	\N	\N	128616	128616	128617
26311	41782	0	applied	\N	\N	\N	\N	128612	128612	128613
26311	41785	1	applied	\N	\N	\N	\N	128638	128638	128639
26311	41786	2	applied	\N	\N	\N	\N	128640	128640	128641
26311	41784	3	applied	\N	\N	\N	\N	128616	128616	128617
26311	41787	4	applied	\N	\N	\N	\N	128642	128642	128643
26311	41788	5	applied	\N	\N	\N	\N	128644	128644	128645
26316	41789	0	applied	\N	\N	\N	\N	128651	128651	128652
26316	41791	1	applied	\N	\N	\N	\N	128655	128655	128660
26318	41792	0	applied	\N	\N	\N	\N	128662	128662	128663
26318	41793	1	applied	\N	\N	\N	\N	128664	128664	128665
26318	41790	2	applied	\N	\N	\N	\N	128653	128653	128656
26318	41794	3	applied	\N	\N	\N	\N	128666	128666	128667
26318	41795	4	applied	\N	\N	\N	\N	128668	128668	128669
26321	41792	0	applied	\N	\N	\N	\N	128662	128662	128663
26321	41793	1	applied	\N	\N	\N	\N	128664	128664	128665
26321	41790	2	applied	\N	\N	\N	\N	128653	128653	128656
26321	41794	3	applied	\N	\N	\N	\N	128666	128666	128667
26321	41795	4	applied	\N	\N	\N	\N	128668	128668	128669
26322	41796	0	applied	\N	\N	\N	\N	128678	128678	128679
26322	41797	1	applied	\N	\N	\N	\N	128680	128680	128681
26322	41798	2	applied	\N	\N	\N	\N	128682	128682	128683
26322	41799	3	applied	\N	\N	\N	\N	128684	128684	128685
26322	41800	4	applied	\N	\N	\N	\N	128686	128686	128687
26327	41803	0	applied	\N	\N	\N	\N	128695	128695	128696
26329	41805	0	applied	\N	\N	\N	\N	128702	128702	128703
26329	41806	1	applied	\N	\N	\N	\N	128704	128704	128705
26329	41807	2	applied	\N	\N	\N	\N	128706	128706	128707
26336	41815	0	applied	\N	\N	\N	\N	128730	128730	128731
26336	41816	1	applied	\N	\N	\N	\N	128732	128732	128733
26336	41817	2	applied	\N	\N	\N	\N	128734	128734	128735
26336	41818	3	applied	\N	\N	\N	\N	128736	128736	128737
26341	41821	0	applied	\N	\N	\N	\N	128746	128746	128747
26341	41822	1	applied	\N	\N	\N	\N	128748	128748	128749
26341	41823	2	applied	\N	\N	\N	\N	128750	128750	128751
26341	41824	3	applied	\N	\N	\N	\N	128752	128752	128753
26341	41825	4	applied	\N	\N	\N	\N	128754	128754	128755
26355	41841	0	applied	\N	\N	\N	\N	128806	128806	128807
26355	41842	1	applied	\N	\N	\N	\N	128808	128808	128809
26360	41853	0	applied	\N	\N	\N	\N	128840	128840	128841
26360	41854	1	applied	\N	\N	\N	\N	128842	128842	128843
26363	41857	0	applied	\N	\N	\N	\N	128852	128852	128853
26363	41858	1	applied	\N	\N	\N	\N	128854	128854	128855
26363	41859	2	applied	\N	\N	\N	\N	128856	128856	128857
26369	41873	0	applied	\N	\N	\N	\N	128890	128890	128891
26369	41874	1	applied	\N	\N	\N	\N	128892	128892	128893
26369	41875	2	applied	\N	\N	\N	\N	128894	128894	128895
26369	41876	3	applied	\N	\N	\N	\N	128898	128898	128899
26369	41877	4	applied	\N	\N	\N	\N	128900	128900	128901
26371	41882	0	applied	\N	\N	\N	\N	128915	128915	128916
26371	41883	1	applied	\N	\N	\N	\N	128917	128917	128918
26371	41884	2	applied	\N	\N	1000000000	\N	128919	128919	128920
26371	41885	3	applied	\N	\N	\N	\N	128921	128921	128922
26371	41886	4	applied	\N	\N	\N	\N	128923	128923	128924
26371	41887	5	applied	\N	\N	\N	\N	128925	128925	128926
26373	41882	0	applied	\N	\N	\N	\N	128915	128915	128916
26373	41883	1	applied	\N	\N	\N	\N	128917	128917	128918
26358	41540	47	applied	\N	\N	\N	\N	127960	127960	127961
26373	41884	2	applied	\N	\N	1000000000	\N	128919	128919	128920
26373	41885	3	applied	\N	\N	\N	\N	128921	128921	128922
26373	41886	4	applied	\N	\N	\N	\N	128923	128923	128924
26373	41887	5	applied	\N	\N	\N	\N	128925	128925	128926
26381	41908	0	applied	\N	\N	\N	\N	128981	128981	128982
26381	41909	1	applied	\N	\N	\N	\N	128983	128983	128984
26381	41910	2	applied	\N	\N	\N	\N	128985	128985	128986
26381	41911	3	applied	\N	\N	\N	\N	128987	128987	128988
26385	41908	0	applied	\N	\N	\N	\N	128981	128981	128982
26385	41909	1	applied	\N	\N	\N	\N	128983	128983	128984
26385	41910	2	applied	\N	\N	\N	\N	128985	128985	128986
26385	41911	3	applied	\N	\N	\N	\N	128987	128987	128988
26388	41918	0	applied	\N	\N	\N	\N	129012	129012	129013
26388	41919	1	applied	\N	\N	\N	\N	129014	129014	129015
26388	41920	2	applied	\N	\N	\N	\N	129016	129016	129017
26388	41921	3	applied	\N	\N	\N	\N	129018	129018	129019
26388	41922	4	applied	\N	\N	\N	\N	129020	129020	129021
26388	41923	5	applied	\N	\N	\N	\N	129022	129022	129023
26388	41924	6	applied	\N	\N	\N	\N	129024	129024	129025
26394	41945	0	applied	\N	\N	\N	\N	129126	129126	129127
26394	41946	1	applied	\N	\N	\N	\N	129128	129128	129129
26394	41947	2	applied	\N	\N	\N	\N	129130	129130	129131
26397	41952	0	applied	\N	\N	\N	\N	129142	129142	129143
26397	41953	2	applied	\N	\N	\N	\N	129145	129145	129146
26397	41954	3	applied	\N	\N	\N	\N	129147	129147	129148
26397	41955	4	applied	\N	\N	\N	\N	129149	129149	129150
26397	41956	5	applied	\N	\N	\N	\N	129151	129151	129152
26397	41957	6	applied	\N	\N	\N	\N	129153	129153	129154
26397	41958	7	applied	\N	\N	\N	\N	129155	129155	129156
26402	41972	0	applied	\N	\N	\N	\N	129190	129190	129191
26402	41973	1	applied	\N	\N	\N	\N	129192	129192	129193
26402	41974	2	applied	\N	\N	\N	\N	129194	129194	129195
26405	41975	0	applied	\N	\N	\N	\N	129200	129200	129201
26405	41976	1	applied	\N	\N	\N	\N	129202	129202	129203
26405	41977	2	applied	\N	\N	\N	\N	129204	129204	129205
26405	41978	3	applied	\N	\N	\N	\N	129206	129206	129207
26407	41979	0	applied	\N	\N	\N	\N	129211	129211	129212
26407	41980	1	applied	\N	\N	\N	\N	129222	129222	129223
26407	41981	2	applied	\N	\N	\N	\N	129224	129224	129225
26407	41982	3	applied	\N	\N	\N	\N	129226	129226	129227
26407	41983	4	applied	\N	\N	\N	\N	129228	129228	129229
26407	41984	5	applied	\N	\N	\N	\N	129230	129230	129231
26409	41557	0	applied	\N	\N	\N	\N	128026	128026	128027
26409	41558	1	applied	\N	\N	\N	\N	128028	128028	128029
26409	41559	2	applied	\N	\N	\N	\N	128030	128030	128031
26409	41560	3	applied	\N	\N	\N	\N	128032	128032	128033
26409	41578	4	applied	\N	\N	\N	\N	128071	128071	128072
26409	41581	5	applied	\N	\N	\N	\N	128079	128079	128080
26409	41584	6	applied	\N	\N	\N	\N	128087	128087	128088
26409	41585	7	applied	\N	\N	\N	\N	128089	128089	128090
26409	41591	8	applied	\N	\N	\N	\N	128104	128104	128105
26409	41594	9	applied	\N	\N	\N	\N	128111	128111	128112
26409	41595	10	applied	\N	\N	\N	\N	128113	128113	128114
26344	41828	0	applied	\N	\N	\N	\N	128767	128767	128768
26344	41829	1	applied	\N	\N	\N	\N	128769	128769	128770
26344	41830	2	applied	\N	\N	\N	\N	128771	128771	128772
26350	41831	0	applied	\N	\N	\N	\N	128780	128780	128781
26351	41832	0	applied	\N	\N	\N	\N	128785	128785	128786
26351	41833	1	applied	\N	\N	\N	\N	128787	128787	128788
26351	41834	2	applied	\N	\N	\N	\N	128789	128789	128790
26351	41835	3	applied	\N	\N	\N	\N	128791	128791	128792
26351	41836	4	applied	\N	\N	\N	\N	128793	128793	128794
26351	41837	5	applied	\N	\N	\N	\N	128795	128795	128796
26351	41838	6	applied	\N	\N	\N	\N	128797	128797	128798
26353	41839	0	applied	\N	\N	\N	\N	128802	128802	128803
26353	41840	1	applied	\N	\N	\N	\N	128804	128804	128805
26356	41843	0	applied	\N	\N	\N	\N	128812	128812	128813
26356	41844	1	applied	\N	\N	\N	\N	128814	128814	128815
26356	41845	2	applied	\N	\N	\N	\N	128816	128816	128817
26356	41846	3	applied	\N	\N	\N	\N	128818	128818	128819
26356	41847	4	applied	\N	\N	\N	\N	128820	128820	128821
26356	41848	5	applied	\N	\N	\N	\N	128822	128822	128823
26356	41849	6	applied	\N	\N	\N	\N	128824	128824	128825
26358	41369	0	applied	\N	\N	\N	\N	127480	127480	127481
26358	41372	1	applied	\N	\N	\N	\N	127501	127501	127502
26358	41373	2	applied	\N	\N	\N	\N	127503	127503	127504
26358	41378	3	applied	\N	\N	\N	\N	127522	127522	127523
26358	41383	4	applied	\N	\N	\N	\N	127539	127539	127540
26358	41384	5	applied	\N	\N	\N	\N	127541	127541	127542
26358	41391	6	applied	\N	\N	\N	\N	127558	127558	127559
26358	41397	7	applied	\N	\N	\N	\N	127572	127572	127573
26358	41400	8	applied	\N	\N	\N	\N	127581	127581	127582
26358	41401	9	applied	\N	\N	\N	\N	127583	127583	127584
26358	41406	10	applied	\N	\N	\N	\N	127595	127595	127596
26358	41409	11	applied	\N	\N	\N	\N	127603	127603	127604
26358	41410	12	applied	\N	\N	\N	\N	127605	127605	127606
26358	41417	13	applied	\N	\N	\N	\N	127621	127621	127622
26358	41423	14	applied	\N	\N	\N	\N	127638	127638	127639
26358	41424	15	applied	\N	\N	\N	\N	127640	127640	127641
26358	41425	16	applied	\N	\N	\N	\N	127642	127642	127643
26358	41426	17	applied	\N	\N	\N	\N	127644	127644	127645
26358	41437	18	applied	\N	\N	\N	\N	127671	127671	127672
26358	41438	19	applied	\N	\N	\N	\N	127673	127673	127674
26358	41444	20	applied	\N	\N	\N	\N	127690	127690	127691
26358	41446	21	applied	\N	\N	\N	\N	127694	127694	127695
26358	41451	22	applied	\N	\N	\N	\N	127706	127706	127707
26358	41454	23	applied	\N	\N	\N	\N	127738	127738	127739
26358	41458	24	applied	\N	\N	\N	\N	127749	127749	127750
26358	41462	25	applied	\N	\N	\N	\N	127762	127762	127763
26358	41463	26	applied	\N	\N	\N	\N	127764	127764	127765
26358	41464	27	applied	\N	\N	\N	\N	127766	127766	127767
26358	41473	28	applied	\N	\N	\N	\N	127785	127785	127786
26358	41478	29	applied	\N	\N	\N	\N	127801	127801	127802
26358	41479	30	applied	\N	\N	\N	\N	127803	127803	127804
26358	41484	31	applied	\N	\N	\N	\N	127817	127817	127818
26358	41489	32	applied	\N	\N	\N	\N	127830	127830	127831
26358	41492	33	applied	\N	\N	\N	\N	127838	127838	127839
26358	41497	34	applied	\N	\N	\N	\N	127852	127852	127853
26358	41501	35	applied	\N	\N	\N	\N	127863	127863	127864
26358	41502	36	applied	\N	\N	\N	\N	127865	127865	127866
26358	41503	37	applied	\N	\N	\N	\N	127867	127867	127868
26358	41504	38	applied	\N	\N	\N	\N	127869	127869	127870
26358	41514	39	applied	\N	\N	\N	\N	127891	127891	127892
26358	41517	40	applied	\N	\N	\N	\N	127899	127899	127900
26358	41521	41	applied	\N	\N	\N	\N	127910	127910	127911
26358	41524	42	applied	\N	\N	\N	\N	127918	127918	127919
26358	41527	43	applied	\N	\N	\N	\N	127925	127925	127926
26358	41530	44	applied	\N	\N	\N	\N	127931	127931	127932
26358	41534	45	applied	\N	\N	\N	\N	127946	127946	127947
26358	41535	46	applied	\N	\N	\N	\N	127948	127948	127949
26358	41544	48	applied	\N	\N	\N	\N	127971	127971	127972
26358	41547	49	applied	\N	\N	\N	\N	127981	127981	127982
26358	41548	50	applied	\N	\N	\N	\N	127983	127983	127984
26358	41554	51	applied	\N	\N	\N	\N	127997	127997	127998
26358	41555	52	applied	\N	\N	\N	\N	127999	127999	128000
26358	41556	53	applied	\N	\N	\N	\N	128001	128001	128002
26358	41557	54	applied	\N	\N	\N	\N	128026	128026	128027
26358	41558	55	applied	\N	\N	\N	\N	128028	128028	128029
26358	41559	56	applied	\N	\N	\N	\N	128030	128030	128031
26358	41560	57	applied	\N	\N	\N	\N	128032	128032	128033
26358	41578	58	applied	\N	\N	\N	\N	128071	128071	128072
26358	41581	59	applied	\N	\N	\N	\N	128079	128079	128080
26358	41584	60	applied	\N	\N	\N	\N	128087	128087	128088
26358	41585	61	applied	\N	\N	\N	\N	128089	128089	128090
26358	41591	62	applied	\N	\N	\N	\N	128104	128104	128105
26358	41594	63	applied	\N	\N	\N	\N	128111	128111	128112
26358	41595	64	applied	\N	\N	\N	\N	128113	128113	128114
26358	41601	65	applied	\N	\N	\N	\N	128129	128129	128130
26358	41604	66	applied	\N	\N	\N	\N	128137	128137	128138
26358	41607	67	applied	\N	\N	\N	\N	128145	128145	128146
26358	41608	68	applied	\N	\N	\N	\N	128147	128147	128148
26358	41609	69	applied	\N	\N	\N	\N	128149	128149	128150
26358	41610	70	applied	\N	\N	\N	\N	128152	128152	128153
26358	41624	71	applied	\N	\N	\N	\N	128182	128182	128183
26358	41627	72	applied	\N	\N	\N	\N	128197	128197	128198
26358	41630	73	applied	\N	\N	\N	\N	128205	128205	128206
26358	41633	74	applied	\N	\N	\N	\N	128212	128212	128213
26358	41637	75	applied	\N	\N	\N	\N	128222	128222	128223
26358	41638	76	applied	\N	\N	\N	\N	128224	128224	128225
26358	41639	78	applied	\N	\N	\N	\N	128226	128226	128227
26358	41640	79	applied	\N	\N	\N	\N	128228	128228	128229
26358	41650	80	applied	\N	\N	\N	\N	128250	128250	128251
26358	41653	81	applied	\N	\N	\N	\N	128258	128258	128259
26358	41657	82	applied	\N	\N	\N	\N	128268	128268	128269
26358	41660	83	applied	\N	\N	\N	\N	128275	128275	128276
26358	41663	84	applied	\N	\N	\N	\N	128285	128285	128286
26358	41666	85	applied	\N	\N	\N	\N	128293	128293	128294
26358	41672	86	applied	\N	\N	\N	\N	128307	128307	128308
26358	41673	87	applied	\N	\N	\N	\N	128309	128309	128310
26358	41679	88	applied	\N	\N	\N	\N	128324	128324	128325
26358	41682	89	applied	\N	\N	\N	\N	128332	128332	128333
26358	41683	90	applied	\N	\N	\N	\N	128334	128334	128335
26358	41689	91	applied	\N	\N	\N	\N	128347	128347	128348
26358	41692	92	applied	\N	\N	\N	\N	128353	128353	128354
26358	41695	93	applied	\N	\N	\N	\N	128363	128363	128364
26358	41698	94	applied	\N	\N	\N	\N	128370	128370	128371
26358	41702	95	applied	\N	\N	\N	\N	128382	128382	128383
26358	41704	96	applied	\N	\N	\N	\N	128388	128388	128389
26358	41707	97	applied	\N	\N	\N	\N	128394	128394	128395
26358	41711	98	applied	\N	\N	\N	\N	128407	128407	128408
26358	41712	99	applied	\N	\N	\N	\N	128409	128409	128410
26358	41717	100	applied	\N	\N	\N	\N	128420	128420	128421
26358	41721	101	applied	\N	\N	\N	\N	128428	128428	128429
26358	41724	102	applied	\N	\N	\N	\N	128459	128459	128460
26358	41725	103	applied	\N	\N	\N	\N	128461	128461	128462
26358	41726	104	applied	\N	\N	\N	\N	128463	128463	128464
26358	41731	105	applied	\N	\N	\N	\N	128479	128479	128480
26358	41733	106	applied	\N	\N	\N	\N	128487	128487	128488
26358	41735	107	applied	\N	\N	\N	\N	128493	128493	128494
26358	41736	108	applied	\N	\N	\N	\N	128495	128495	128496
26358	41737	109	applied	\N	\N	\N	\N	128497	128497	128498
26358	41742	110	applied	\N	\N	\N	\N	128508	128508	128509
26358	41745	111	applied	\N	\N	\N	\N	128516	128516	128517
26358	41747	112	applied	\N	\N	\N	\N	128522	128522	128523
26358	41749	113	applied	\N	\N	\N	\N	128527	128527	128528
26358	41751	114	applied	\N	\N	\N	\N	128533	128533	128534
26358	41752	115	applied	\N	\N	\N	\N	128535	128535	128536
26358	41753	116	applied	\N	\N	\N	\N	128537	128537	128538
26358	41754	117	applied	\N	\N	\N	\N	128539	128539	128540
26358	41762	118	applied	\N	\N	\N	\N	128560	128560	128561
26358	41764	119	applied	\N	\N	\N	\N	128566	128566	128567
26358	41765	120	applied	\N	\N	\N	\N	128568	128568	128569
26358	41769	121	applied	\N	\N	\N	\N	128581	128581	128582
26358	41770	122	applied	\N	\N	\N	\N	128583	128583	128584
26358	41771	123	applied	\N	\N	\N	\N	128585	128585	128586
26358	41775	124	applied	\N	\N	\N	\N	128594	128594	128595
26358	41776	125	applied	\N	\N	\N	\N	128596	128596	128597
26361	41855	0	applied	\N	\N	\N	\N	128846	128846	128847
26361	41856	1	applied	\N	\N	\N	\N	128848	128848	128849
26366	41862	0	applied	\N	\N	\N	\N	128864	128864	128865
26366	41863	1	applied	\N	\N	\N	\N	128866	128866	128867
26366	41864	2	applied	\N	\N	\N	\N	128868	128868	128869
26366	41865	3	applied	\N	\N	\N	\N	128870	128870	128871
26366	41866	4	applied	\N	\N	\N	\N	128872	128872	128873
26366	41867	5	applied	\N	\N	\N	\N	128874	128874	128875
26366	41868	6	applied	\N	\N	\N	\N	128876	128876	128877
26372	41882	0	applied	\N	\N	\N	\N	128915	128915	128916
26372	41883	1	applied	\N	\N	\N	\N	128917	128917	128918
26372	41884	2	applied	\N	\N	1000000000	\N	128919	128919	128920
26372	41885	3	applied	\N	\N	\N	\N	128921	128921	128922
26372	41886	4	applied	\N	\N	\N	\N	128923	128923	128924
26372	41887	5	applied	\N	\N	\N	\N	128925	128925	128926
26374	41888	0	applied	\N	\N	\N	\N	128931	128931	128932
26374	41889	1	applied	\N	\N	\N	\N	128933	128933	128934
26374	41890	2	applied	\N	\N	\N	\N	128935	128935	128936
26374	41891	3	applied	\N	\N	\N	\N	128937	128937	128938
26374	41892	4	applied	\N	\N	\N	\N	128939	128939	128940
26374	41893	5	applied	\N	\N	\N	\N	128941	128941	128942
26377	41902	0	applied	\N	\N	\N	\N	128963	128963	128964
26377	41903	1	applied	\N	\N	\N	\N	128965	128965	128966
26377	41904	2	applied	\N	\N	\N	\N	128967	128967	128968
26379	41905	0	applied	\N	\N	\N	\N	128971	128971	128972
26379	41906	1	applied	\N	\N	\N	\N	128973	128973	128974
26379	41907	2	applied	\N	\N	\N	\N	128975	128975	128976
26382	41908	0	applied	\N	\N	\N	\N	128981	128981	128982
26382	41909	1	applied	\N	\N	\N	\N	128983	128983	128984
26382	41910	2	applied	\N	\N	\N	\N	128985	128985	128986
26382	41911	3	applied	\N	\N	\N	\N	128987	128987	128988
26389	41925	0	applied	\N	\N	\N	\N	129028	129028	129029
26389	41926	1	applied	\N	\N	\N	\N	129030	129030	129031
26389	41927	2	applied	\N	\N	\N	\N	129032	129032	129033
26389	41928	3	applied	\N	\N	\N	\N	129034	129034	129035
26389	41929	4	applied	\N	\N	\N	\N	129036	129036	129037
26389	41930	5	applied	\N	\N	\N	\N	129038	129038	129039
26392	41361	0	applied	\N	\N	\N	\N	127460	127460	129059
26392	41459	1	applied	\N	\N	\N	\N	127751	127751	128622
26392	41365	2	applied	\N	\N	\N	\N	127470	127470	129060
26392	41380	3	applied	\N	\N	1000000000	\N	127526	127526	127527
26392	41471	4	applied	\N	\N	\N	\N	127780	127780	128623
26392	41429	5	applied	\N	\N	\N	\N	127650	127650	129061
26392	41430	6	applied	\N	\N	\N	\N	127652	127652	127222
26392	41439	7	applied	\N	\N	\N	\N	127675	127675	129062
26392	41450	8	applied	\N	\N	\N	\N	127702	127702	129063
26392	41382	9	applied	\N	\N	1000000000	\N	127530	127530	127531
26392	41387	10	applied	\N	\N	1000000000	\N	127547	127547	127548
26392	41388	11	applied	\N	\N	1000000000	\N	127549	127549	127550
26392	41393	12	applied	\N	\N	1000000000	\N	127562	127562	127563
26392	41394	13	applied	\N	\N	1000000000	\N	127564	127564	127565
26392	41395	14	applied	\N	\N	1000000000	\N	127566	127566	127567
26392	41366	15	applied	\N	\N	\N	\N	127472	127472	129064
26392	41370	16	applied	\N	\N	\N	\N	127482	127482	127234
26392	41376	17	applied	\N	\N	\N	\N	127509	127509	129065
26392	41377	18	applied	\N	\N	\N	\N	127511	127511	129066
26392	41379	19	applied	\N	\N	\N	\N	127524	127524	127242
26392	41385	20	applied	\N	\N	\N	\N	127543	127543	129067
26392	41389	21	applied	\N	\N	\N	\N	127551	127551	129068
26392	41392	22	applied	\N	\N	\N	\N	127560	127560	127309
26392	41398	23	applied	\N	\N	\N	\N	127574	127574	129069
26392	41404	24	applied	\N	\N	\N	\N	127589	127589	129070
26392	41405	25	applied	\N	\N	\N	\N	127591	127591	127319
26392	41408	26	applied	\N	\N	\N	\N	127599	127599	129071
26392	41411	27	applied	\N	\N	\N	\N	127607	127607	129072
26392	41412	28	applied	\N	\N	\N	\N	127609	127609	127333
26392	41419	29	applied	\N	\N	\N	\N	127625	127625	129073
26392	41421	30	applied	\N	\N	\N	\N	127631	127631	129074
26392	41428	31	applied	\N	\N	\N	\N	127648	127648	127343
26392	41431	32	applied	\N	\N	\N	\N	127654	127654	129075
26392	41432	33	applied	\N	\N	\N	\N	127656	127656	129076
26392	41433	34	applied	\N	\N	\N	\N	127658	127658	127353
26392	41440	35	applied	\N	\N	\N	\N	127677	127677	129077
26392	41443	36	applied	\N	\N	\N	\N	127683	127683	129078
26392	41445	37	applied	\N	\N	\N	\N	127692	127692	127360
26392	41447	38	applied	\N	\N	\N	\N	127696	127696	129079
26392	41453	39	applied	\N	\N	\N	\N	127710	127710	129080
26392	41455	40	applied	\N	\N	\N	\N	127740	127740	127372
26392	41460	41	applied	\N	\N	\N	\N	127753	127753	129081
26392	41467	42	applied	\N	\N	\N	\N	127772	127772	129082
26392	41468	43	applied	\N	\N	\N	\N	127774	127774	127381
26392	41469	44	applied	\N	\N	\N	\N	127776	127776	129083
26392	41476	45	applied	\N	\N	\N	\N	127791	127791	129084
26392	41482	46	applied	\N	\N	\N	\N	127809	127809	127392
26392	41483	47	applied	\N	\N	\N	\N	127811	127811	129085
26392	41488	48	applied	\N	\N	\N	\N	127825	127825	127490
26392	41491	49	applied	\N	\N	\N	\N	127834	127834	127417
26392	41494	50	applied	\N	\N	\N	\N	127842	127842	129086
26392	41496	51	applied	\N	\N	\N	\N	127847	127847	129087
26392	41500	52	applied	\N	\N	\N	\N	127858	127858	127429
26392	41505	53	applied	\N	\N	\N	\N	127871	127871	127493
26392	41511	54	applied	\N	\N	\N	\N	127883	127883	129088
26392	41512	55	applied	\N	\N	\N	\N	127885	127885	127443
26392	41513	56	applied	\N	\N	\N	\N	127887	127887	127495
26370	41881	5	applied	\N	\N	1000000000	\N	128911	128911	128912
26375	41894	0	applied	\N	\N	\N	\N	128945	128945	128946
26375	41895	1	applied	\N	\N	\N	\N	128947	128947	128948
26375	41896	2	applied	\N	\N	1000000000	\N	128949	128949	128950
26375	41897	3	applied	\N	\N	\N	\N	128951	128951	128952
26375	41898	4	applied	\N	\N	\N	\N	128953	128953	128954
26375	41899	5	applied	\N	\N	\N	\N	128955	128955	128956
26375	41900	6	applied	\N	\N	\N	\N	128957	128957	128958
26375	41901	7	applied	\N	\N	\N	\N	128959	128959	128960
26380	41905	0	applied	\N	\N	\N	\N	128971	128971	128972
26380	41906	1	applied	\N	\N	\N	\N	128973	128973	128974
26380	41907	2	applied	\N	\N	\N	\N	128975	128975	128976
26383	41908	0	applied	\N	\N	\N	\N	128981	128981	128982
26383	41909	1	applied	\N	\N	\N	\N	128983	128983	128984
26383	41910	2	applied	\N	\N	\N	\N	128985	128985	128986
26383	41911	3	applied	\N	\N	\N	\N	128987	128987	128988
26386	41912	0	applied	\N	\N	\N	\N	128996	128996	128997
26386	41913	1	applied	\N	\N	\N	\N	128998	128998	128999
26386	41914	2	applied	\N	\N	\N	\N	129000	129000	129001
26390	41931	0	applied	\N	\N	\N	\N	129042	129042	129043
26390	41932	1	applied	\N	\N	\N	\N	129044	129044	129045
26390	41933	2	applied	\N	\N	\N	\N	129046	129046	129047
26390	41934	3	applied	\N	\N	\N	\N	129048	129048	129049
26390	41935	4	applied	\N	\N	\N	\N	129050	129050	129051
26390	41936	5	applied	\N	\N	\N	\N	129052	129052	129053
26390	41937	6	applied	\N	\N	\N	\N	129054	129054	129055
26393	41938	0	applied	\N	\N	\N	\N	129111	129111	129112
26393	41939	1	applied	\N	\N	\N	\N	129113	129113	129114
26393	41940	2	applied	\N	\N	\N	\N	129115	129115	129116
26393	41941	3	applied	\N	\N	\N	\N	129117	129117	129118
26393	41942	4	applied	\N	\N	\N	\N	129119	129119	129120
26393	41943	5	applied	\N	\N	\N	\N	129121	129121	129122
26393	41944	6	applied	\N	\N	\N	\N	129123	129123	129124
26396	41952	0	applied	\N	\N	\N	\N	129142	129142	129143
26396	41953	2	applied	\N	\N	\N	\N	129145	129145	129146
26396	41954	3	applied	\N	\N	\N	\N	129147	129147	129148
26396	41955	4	applied	\N	\N	\N	\N	129149	129149	129150
26396	41956	5	applied	\N	\N	\N	\N	129151	129151	129152
26396	41957	6	applied	\N	\N	\N	\N	129153	129153	129154
26396	41958	7	applied	\N	\N	\N	\N	129155	129155	129156
26398	41959	0	applied	\N	\N	\N	\N	129159	129159	129160
26398	41960	1	applied	\N	\N	\N	\N	129161	129161	129162
26401	41969	0	applied	\N	\N	\N	\N	129182	129182	129183
26401	41970	1	applied	\N	\N	\N	\N	129184	129184	129185
26401	41971	2	applied	\N	\N	\N	\N	129186	129186	129187
26408	41979	0	applied	\N	\N	\N	\N	129211	129211	129212
26408	41980	1	applied	\N	\N	\N	\N	129222	129222	129223
26408	41981	2	applied	\N	\N	\N	\N	129224	129224	129225
26408	41982	3	applied	\N	\N	\N	\N	129226	129226	129227
26408	41983	4	applied	\N	\N	\N	\N	129228	129228	129229
26408	41984	5	applied	\N	\N	\N	\N	129230	129230	129231
26410	41985	0	applied	\N	\N	\N	\N	129237	129237	129238
26410	41986	1	applied	\N	\N	\N	\N	129239	129239	129240
26410	41987	2	applied	\N	\N	\N	\N	129241	129241	129242
26410	41988	3	applied	\N	\N	\N	\N	129243	129243	129244
26416	42010	0	applied	\N	\N	\N	\N	129299	129299	129300
26416	42011	1	applied	\N	\N	\N	\N	129301	129301	129302
26416	42012	2	applied	\N	\N	\N	\N	129303	129303	129304
26416	42013	3	applied	\N	\N	\N	\N	129305	129305	129306
26418	42014	0	applied	\N	\N	\N	\N	129311	129311	129312
26418	42015	1	applied	\N	\N	\N	\N	129313	129313	129314
26418	42016	2	applied	\N	\N	\N	\N	129315	129315	129316
26422	42024	0	applied	\N	\N	\N	\N	129333	129333	129334
26422	42025	1	applied	\N	\N	\N	\N	129335	129335	129336
26422	42026	2	applied	\N	\N	\N	\N	129337	129337	129338
26425	42027	0	applied	\N	\N	\N	\N	129348	129348	129349
26425	42028	1	applied	\N	\N	\N	\N	129350	129350	129351
26425	42029	2	applied	\N	\N	\N	\N	129352	129352	129353
26430	42033	0	applied	\N	\N	\N	\N	129366	129366	129367
26430	42034	1	applied	\N	\N	\N	\N	129368	129368	129369
26430	42035	2	applied	\N	\N	\N	\N	129370	129370	129371
26430	42036	3	applied	\N	\N	\N	\N	129372	129372	129373
26439	42053	0	applied	\N	\N	\N	\N	129421	129421	129422
26439	42054	1	applied	\N	\N	\N	\N	129423	129423	129424
26439	42055	2	applied	\N	\N	\N	\N	129425	129425	129426
26439	42056	3	applied	\N	\N	\N	\N	129427	129427	129428
26442	42060	0	applied	\N	\N	\N	\N	129442	129442	129443
26442	42061	1	applied	\N	\N	\N	\N	129444	129444	129445
26442	42062	2	applied	\N	\N	\N	\N	129446	129446	129447
26442	42063	3	applied	\N	\N	\N	\N	129448	129448	129449
26442	42064	4	applied	\N	\N	\N	\N	129450	129450	129451
26442	42065	5	applied	\N	\N	\N	\N	129452	129452	129453
26446	42066	0	applied	\N	\N	\N	\N	129459	129459	129460
26446	42067	1	applied	\N	\N	\N	\N	129461	129461	129462
26446	42068	2	applied	\N	\N	\N	\N	129463	129463	129464
26446	42069	3	applied	\N	\N	\N	\N	129465	129465	129466
26457	42079	0	applied	\N	\N	\N	\N	129528	129528	129529
26457	42080	1	applied	\N	\N	\N	\N	129530	129530	129531
26457	42081	2	applied	\N	\N	\N	\N	129532	129532	129533
26460	42089	0	applied	\N	\N	\N	\N	129576	129576	129577
26460	42090	1	applied	\N	\N	\N	\N	129578	129578	129579
26460	42091	2	applied	\N	\N	\N	\N	129580	129580	129581
26463	42092	0	applied	\N	\N	\N	\N	129585	129585	129586
26463	42093	1	applied	\N	\N	\N	\N	129587	129587	129588
26463	42094	2	applied	\N	\N	\N	\N	129589	129589	129590
26463	42095	3	applied	\N	\N	\N	\N	129591	129591	129592
26463	42096	4	applied	\N	\N	\N	\N	129593	129593	129594
26463	42097	5	applied	\N	\N	\N	\N	129595	129595	129596
26465	42101	0	applied	\N	\N	\N	\N	129607	129607	129608
26465	42102	1	applied	\N	\N	\N	\N	129609	129609	129610
26465	42103	2	applied	\N	\N	\N	\N	129611	129611	129612
26467	41985	0	applied	\N	\N	\N	\N	129237	129237	129238
26467	41989	1	applied	\N	\N	\N	\N	129249	129249	129250
26467	41992	2	applied	\N	\N	\N	\N	129259	129259	129260
26467	41993	3	applied	\N	\N	\N	\N	129261	129261	129262
26467	41994	4	applied	\N	\N	\N	\N	129263	129263	129264
26467	41995	5	applied	\N	\N	\N	\N	129265	129265	129266
26467	41996	6	applied	\N	\N	\N	\N	129267	129267	129268
26467	42010	7	applied	\N	\N	\N	\N	129299	129299	129300
26467	42014	8	applied	\N	\N	\N	\N	129311	129311	129312
26467	42017	9	applied	\N	\N	\N	\N	129317	129317	129318
26467	42018	10	applied	\N	\N	\N	\N	129319	129319	129320
26467	42024	11	applied	\N	\N	\N	\N	129333	129333	129334
26467	42027	12	applied	\N	\N	\N	\N	129348	129348	129349
26467	42030	13	applied	\N	\N	\N	\N	129356	129356	129357
26467	42033	14	applied	\N	\N	\N	\N	129366	129366	129367
26467	42037	15	applied	\N	\N	\N	\N	129376	129376	129377
26467	42040	16	applied	\N	\N	\N	\N	129384	129384	129385
26467	42041	17	applied	\N	\N	\N	\N	129386	129386	129387
26376	41894	0	applied	\N	\N	\N	\N	128945	128945	128946
26376	41895	1	applied	\N	\N	\N	\N	128947	128947	128948
26376	41896	2	applied	\N	\N	1000000000	\N	128949	128949	128950
26376	41897	3	applied	\N	\N	\N	\N	128951	128951	128952
26376	41898	4	applied	\N	\N	\N	\N	128953	128953	128954
26376	41899	5	applied	\N	\N	\N	\N	128955	128955	128956
26376	41900	6	applied	\N	\N	\N	\N	128957	128957	128958
26376	41901	7	applied	\N	\N	\N	\N	128959	128959	128960
26378	41902	0	applied	\N	\N	\N	\N	128963	128963	128964
26378	41903	1	applied	\N	\N	\N	\N	128965	128965	128966
26378	41904	2	applied	\N	\N	\N	\N	128967	128967	128968
26384	41908	0	applied	\N	\N	\N	\N	128981	128981	128982
26384	41909	1	applied	\N	\N	\N	\N	128983	128983	128984
26384	41910	2	applied	\N	\N	\N	\N	128985	128985	128986
26384	41911	3	applied	\N	\N	\N	\N	128987	128987	128988
26387	41915	0	applied	\N	\N	\N	\N	129004	129004	129005
26387	41916	1	applied	\N	\N	\N	\N	129006	129006	129007
26387	41917	2	applied	\N	\N	\N	\N	129008	129008	129009
26391	41931	0	applied	\N	\N	\N	\N	129042	129042	129043
26391	41932	1	applied	\N	\N	\N	\N	129044	129044	129045
26391	41933	2	applied	\N	\N	\N	\N	129046	129046	129047
26391	41934	3	applied	\N	\N	\N	\N	129048	129048	129049
26391	41935	4	applied	\N	\N	\N	\N	129050	129050	129051
26391	41936	5	applied	\N	\N	\N	\N	129052	129052	129053
26391	41937	6	applied	\N	\N	\N	\N	129054	129054	129055
26399	41961	0	applied	\N	\N	\N	\N	129163	129163	129164
26399	41962	1	applied	\N	\N	\N	\N	129165	129165	129166
26399	41963	2	applied	\N	\N	\N	\N	129167	129167	129168
26399	41964	3	applied	\N	\N	\N	\N	129169	129169	129170
26404	41975	0	applied	\N	\N	\N	\N	129200	129200	129201
26404	41976	1	applied	\N	\N	\N	\N	129202	129202	129203
26404	41977	2	applied	\N	\N	\N	\N	129204	129204	129205
26404	41978	3	applied	\N	\N	\N	\N	129206	129206	129207
26406	41959	0	applied	\N	\N	\N	\N	129159	129159	129160
26406	41961	1	applied	\N	\N	\N	\N	129163	129163	129164
26406	41965	2	applied	\N	\N	\N	\N	129172	129172	129173
26406	41969	3	applied	\N	\N	\N	\N	129182	129182	129183
26406	41972	4	applied	\N	\N	\N	\N	129190	129190	129191
26406	41975	5	applied	\N	\N	\N	\N	129200	129200	129201
26406	41979	6	applied	\N	\N	\N	\N	129211	129211	129212
26406	41960	7	applied	\N	\N	\N	\N	129161	129161	129162
26406	41962	8	applied	\N	\N	\N	\N	129165	129165	129166
26406	41963	9	applied	\N	\N	\N	\N	129167	129167	129168
26406	41967	10	applied	\N	\N	\N	\N	129176	129176	129213
26406	41970	11	applied	\N	\N	\N	\N	129184	129184	129214
26406	41974	12	applied	\N	\N	\N	\N	129194	129194	129215
26406	41976	13	applied	\N	\N	\N	\N	129202	129202	129216
26406	41968	14	applied	\N	\N	\N	\N	129178	129178	129187
26406	41977	15	applied	\N	\N	\N	\N	129204	129204	129217
26406	41964	16	applied	\N	\N	\N	\N	129169	129169	129218
26406	41966	17	applied	\N	\N	\N	\N	129174	129174	129195
26406	41971	18	applied	\N	\N	\N	\N	129186	129186	129219
26406	41973	19	applied	\N	\N	\N	\N	129192	129192	129205
26406	41978	20	applied	\N	\N	\N	\N	129206	129206	129207
26413	41989	0	applied	\N	\N	\N	\N	129249	129249	129250
26413	41990	1	applied	\N	\N	\N	\N	129251	129251	129252
26413	41991	2	applied	\N	\N	\N	\N	129253	129253	129254
26414	41992	0	applied	\N	\N	\N	\N	129259	129259	129260
26414	41993	1	applied	\N	\N	\N	\N	129261	129261	129262
26414	41994	2	applied	\N	\N	\N	\N	129263	129263	129264
26414	41995	3	applied	\N	\N	\N	\N	129265	129265	129266
26414	41996	4	applied	\N	\N	\N	\N	129267	129267	129268
26414	41997	5	applied	\N	\N	\N	\N	129269	129269	129270
26414	41998	6	applied	\N	\N	\N	\N	129271	129271	129272
26414	41999	7	applied	\N	\N	1000000000	\N	129273	129273	129274
26414	42000	8	applied	\N	\N	1000000000	\N	129275	129275	129276
26414	42001	9	applied	\N	\N	\N	\N	129277	129277	129278
26414	42002	10	applied	\N	\N	\N	\N	129279	129279	129280
26414	42003	11	applied	\N	\N	\N	\N	129281	129281	129282
26414	42004	12	applied	\N	\N	\N	\N	129283	129283	129284
26414	42005	13	applied	\N	\N	\N	\N	129285	129285	129286
26414	42006	14	applied	\N	\N	\N	\N	129287	129287	129288
26414	42007	15	applied	\N	\N	\N	\N	129289	129289	129290
26414	42008	16	applied	\N	\N	\N	\N	129291	129291	129292
26414	42009	17	applied	\N	\N	\N	\N	129293	129293	129294
26417	42010	0	applied	\N	\N	\N	\N	129299	129299	129300
26417	42011	1	applied	\N	\N	\N	\N	129301	129301	129302
26417	42012	2	applied	\N	\N	\N	\N	129303	129303	129304
26417	42013	3	applied	\N	\N	\N	\N	129305	129305	129306
26419	42017	0	applied	\N	\N	\N	\N	129317	129317	129318
26419	42018	1	applied	\N	\N	\N	\N	129319	129319	129320
26419	42019	2	applied	\N	\N	\N	\N	129321	129321	129322
26419	42020	3	applied	\N	\N	\N	\N	129323	129323	129324
26419	42021	4	applied	\N	\N	\N	\N	129325	129325	129326
26419	42022	5	applied	\N	\N	\N	\N	129327	129327	129328
26419	42023	6	applied	\N	\N	\N	\N	129329	129329	129330
26423	42024	0	applied	\N	\N	\N	\N	129333	129333	129334
26423	42025	1	applied	\N	\N	\N	\N	129335	129335	129336
26423	42026	2	applied	\N	\N	\N	\N	129337	129337	129338
26426	42030	0	applied	\N	\N	\N	\N	129356	129356	129357
26426	42031	1	applied	\N	\N	\N	\N	129358	129358	129359
26426	42032	2	applied	\N	\N	\N	\N	129360	129360	129361
26428	42030	0	applied	\N	\N	\N	\N	129356	129356	129357
26428	42031	1	applied	\N	\N	\N	\N	129358	129358	129359
26428	42032	2	applied	\N	\N	\N	\N	129360	129360	129361
26433	42040	0	applied	\N	\N	\N	\N	129384	129384	129385
26433	42041	1	applied	\N	\N	\N	\N	129386	129386	129387
26433	42042	3	applied	\N	\N	\N	\N	129389	129389	129390
26433	42043	4	applied	\N	\N	\N	\N	129391	129391	129392
26433	42044	5	applied	\N	\N	\N	\N	129393	129393	129394
26433	42045	6	applied	\N	\N	\N	\N	129395	129395	129396
26433	42046	7	applied	\N	\N	\N	\N	129397	129397	129398
26435	42040	0	applied	\N	\N	\N	\N	129384	129384	129385
26435	42041	1	applied	\N	\N	\N	\N	129386	129386	129387
26435	42042	3	applied	\N	\N	\N	\N	129389	129389	129390
26435	42043	4	applied	\N	\N	\N	\N	129391	129391	129392
26435	42044	5	applied	\N	\N	\N	\N	129393	129393	129394
26435	42045	6	applied	\N	\N	\N	\N	129395	129395	129396
26435	42046	7	applied	\N	\N	\N	\N	129397	129397	129398
26440	42057	0	applied	\N	\N	\N	\N	129432	129432	129433
26440	42058	1	applied	\N	\N	\N	\N	129434	129434	129435
26440	42059	2	applied	\N	\N	\N	\N	129436	129436	129437
26443	42060	0	applied	\N	\N	\N	\N	129442	129442	129443
26443	42061	1	applied	\N	\N	\N	\N	129444	129444	129445
26443	42062	2	applied	\N	\N	\N	\N	129446	129446	129447
26443	42063	3	applied	\N	\N	\N	\N	129448	129448	129449
26443	42064	4	applied	\N	\N	\N	\N	129450	129450	129451
26443	42065	5	applied	\N	\N	\N	\N	129452	129452	129453
26447	42066	0	applied	\N	\N	\N	\N	129459	129459	129460
26392	41515	57	applied	\N	\N	\N	\N	127893	127893	129089
26392	41518	58	applied	\N	\N	\N	\N	127901	127901	127457
26392	41522	59	applied	\N	\N	\N	\N	127912	127912	127461
26392	41525	60	applied	\N	\N	\N	\N	127920	127920	129090
26392	41528	61	applied	\N	\N	\N	\N	127927	127927	129091
26392	41532	62	applied	\N	\N	\N	\N	127935	127935	127497
26392	41537	63	applied	\N	\N	\N	\N	127952	127952	129092
26392	41539	64	applied	\N	\N	\N	\N	127956	127956	127475
26392	41541	65	applied	\N	\N	\N	\N	127962	127962	127499
26392	41546	66	applied	\N	\N	\N	\N	127975	127975	129093
26392	41550	67	applied	\N	\N	\N	\N	127987	127987	129094
26392	41551	68	applied	\N	\N	\N	\N	127989	127989	127485
26392	41563	69	applied	\N	\N	\N	\N	128038	128038	129095
26392	41564	70	applied	\N	\N	\N	\N	128040	128040	129096
26392	41565	71	applied	\N	\N	\N	\N	128042	128042	127508
26392	41566	72	applied	\N	\N	\N	\N	128044	128044	127510
26392	41567	73	applied	\N	\N	\N	\N	128046	128046	127512
26392	41568	74	applied	\N	\N	\N	\N	128048	128048	127525
26392	41569	75	applied	\N	\N	\N	\N	128050	128050	127714
26392	41580	76	applied	\N	\N	\N	\N	128075	128075	128626
26392	41583	78	applied	\N	\N	\N	\N	128083	128083	128627
26392	41587	79	applied	\N	\N	\N	\N	128093	128093	127546
26392	41588	80	applied	\N	\N	\N	\N	128095	128095	127552
26392	41592	81	applied	\N	\N	\N	\N	128106	128106	128629
26392	41596	82	applied	\N	\N	\N	\N	128115	128115	128630
26392	41597	83	applied	\N	\N	\N	\N	128117	128117	128631
26392	41603	84	applied	\N	\N	\N	\N	128133	128133	127569
26392	41606	85	applied	\N	\N	\N	\N	128141	128141	127575
26392	41613	86	applied	\N	\N	\N	\N	128158	128158	127718
26392	41619	87	applied	\N	\N	\N	\N	128170	128170	127719
26392	41761	88	applied	\N	\N	\N	\N	128553	128553	129098
26392	41472	89	applied	\N	\N	\N	\N	127782	127782	128634
26392	41474	90	applied	\N	\N	\N	\N	127787	127787	127586
26392	41486	91	applied	\N	\N	\N	\N	127821	127821	128635
26392	41499	92	applied	\N	\N	\N	\N	127856	127856	127720
26392	41510	93	applied	\N	\N	\N	\N	127881	127881	127588
26392	41519	94	applied	\N	\N	\N	\N	127903	127903	127721
26392	41531	95	applied	\N	\N	\N	\N	127933	127933	127590
26392	41543	96	applied	\N	\N	\N	\N	127966	127966	127722
26392	41549	97	applied	\N	\N	\N	\N	127985	127985	127592
26392	41570	98	applied	\N	\N	\N	\N	128052	128052	127723
26392	41571	99	applied	\N	\N	\N	\N	128054	128054	129099
26392	41590	100	applied	\N	\N	\N	\N	128099	128099	127598
26392	41600	101	applied	\N	\N	\N	\N	128123	128123	127724
26392	41611	102	applied	\N	\N	\N	\N	128154	128154	127600
26392	41621	103	applied	\N	\N	\N	\N	128174	128174	127725
26392	41636	104	applied	\N	\N	\N	\N	128218	128218	127608
26392	41643	105	applied	\N	\N	\N	\N	128234	128234	127726
26392	41656	106	applied	\N	\N	\N	\N	128264	128264	127610
26392	41671	107	applied	\N	\N	\N	\N	128303	128303	127727
26392	41676	108	applied	\N	\N	\N	\N	128315	128315	129100
26392	41685	109	applied	\N	\N	\N	\N	128338	128338	127612
26392	41699	110	applied	\N	\N	\N	\N	128372	128372	129101
26392	41708	111	applied	\N	\N	\N	\N	128396	128396	127728
26392	41720	112	applied	\N	\N	\N	\N	128426	128426	127614
26392	41730	113	applied	\N	\N	\N	\N	128471	128471	127729
26392	41738	114	applied	\N	\N	\N	\N	128499	128499	129102
26392	41744	115	applied	\N	\N	\N	\N	128512	128512	127624
26395	41948	0	applied	\N	\N	\N	\N	129134	129134	129135
26395	41949	1	applied	\N	\N	\N	\N	129136	129136	129137
26395	41950	2	applied	\N	\N	\N	\N	129138	129138	129139
26395	41951	3	applied	\N	\N	\N	\N	129140	129140	129141
26400	41965	0	applied	\N	\N	\N	\N	129172	129172	129173
26400	41966	1	applied	\N	\N	\N	\N	129174	129174	129175
26400	41967	2	applied	\N	\N	\N	\N	129176	129176	129177
26400	41968	3	applied	\N	\N	\N	\N	129178	129178	129179
26403	41972	0	applied	\N	\N	\N	\N	129190	129190	129191
26403	41973	1	applied	\N	\N	\N	\N	129192	129192	129193
26403	41974	2	applied	\N	\N	\N	\N	129194	129194	129195
26412	41989	0	applied	\N	\N	\N	\N	129249	129249	129250
26412	41990	1	applied	\N	\N	\N	\N	129251	129251	129252
26412	41991	2	applied	\N	\N	\N	\N	129253	129253	129254
26421	42024	0	applied	\N	\N	\N	\N	129333	129333	129334
26421	42025	1	applied	\N	\N	\N	\N	129335	129335	129336
26421	42026	2	applied	\N	\N	\N	\N	129337	129337	129338
26429	42033	0	applied	\N	\N	\N	\N	129366	129366	129367
26429	42034	1	applied	\N	\N	\N	\N	129368	129368	129369
26429	42035	2	applied	\N	\N	\N	\N	129370	129370	129371
26429	42036	3	applied	\N	\N	\N	\N	129372	129372	129373
26432	42040	0	applied	\N	\N	\N	\N	129384	129384	129385
26432	42041	1	applied	\N	\N	\N	\N	129386	129386	129387
26432	42042	3	applied	\N	\N	\N	\N	129389	129389	129390
26432	42043	4	applied	\N	\N	\N	\N	129391	129391	129392
26432	42044	5	applied	\N	\N	\N	\N	129393	129393	129394
26432	42045	6	applied	\N	\N	\N	\N	129395	129395	129396
26432	42046	7	applied	\N	\N	\N	\N	129397	129397	129398
26436	42047	0	applied	\N	\N	\N	\N	129404	129404	129405
26436	42048	1	applied	\N	\N	\N	\N	129406	129406	129407
26436	42049	2	applied	\N	\N	\N	\N	129408	129408	129409
26436	42050	3	applied	\N	\N	\N	\N	129410	129410	129411
26436	42051	4	applied	\N	\N	\N	\N	129412	129412	129413
26436	42052	5	applied	\N	\N	\N	\N	129414	129414	129415
26437	42047	0	applied	\N	\N	\N	\N	129404	129404	129405
26437	42048	1	applied	\N	\N	\N	\N	129406	129406	129407
26437	42049	2	applied	\N	\N	\N	\N	129408	129408	129409
26437	42050	3	applied	\N	\N	\N	\N	129410	129410	129411
26437	42051	4	applied	\N	\N	\N	\N	129412	129412	129413
26437	42052	5	applied	\N	\N	\N	\N	129414	129414	129415
26444	42060	0	applied	\N	\N	\N	\N	129442	129442	129443
26444	42061	1	applied	\N	\N	\N	\N	129444	129444	129445
26444	42062	2	applied	\N	\N	\N	\N	129446	129446	129447
26444	42063	3	applied	\N	\N	\N	\N	129448	129448	129449
26444	42064	4	applied	\N	\N	\N	\N	129450	129450	129451
26444	42065	5	applied	\N	\N	\N	\N	129452	129452	129453
26448	42066	0	applied	\N	\N	\N	\N	129459	129459	129460
26448	42067	1	applied	\N	\N	\N	\N	129461	129461	129462
26448	42068	2	applied	\N	\N	\N	\N	129463	129463	129464
26448	42069	3	applied	\N	\N	\N	\N	129465	129465	129466
26450	42070	0	applied	\N	\N	\N	\N	129473	129473	129474
26450	42071	1	applied	\N	\N	\N	\N	129475	129475	129476
26450	42072	2	applied	\N	\N	\N	\N	129477	129477	129478
26455	41992	0	applied	\N	\N	\N	\N	129259	129259	129260
26455	41993	1	applied	\N	\N	\N	\N	129261	129261	129262
26455	41994	2	applied	\N	\N	\N	\N	129263	129263	129264
26455	41995	3	applied	\N	\N	\N	\N	129265	129265	129266
26455	41996	4	applied	\N	\N	\N	\N	129267	129267	129268
26455	42010	5	applied	\N	\N	\N	\N	129299	129299	129300
26455	42014	6	applied	\N	\N	\N	\N	129311	129311	129312
26455	42017	7	applied	\N	\N	\N	\N	129317	129317	129318
26455	42018	8	applied	\N	\N	\N	\N	129319	129319	129320
26409	41601	11	applied	\N	\N	\N	\N	128129	128129	128130
26409	41604	12	applied	\N	\N	\N	\N	128137	128137	128138
26409	41607	13	applied	\N	\N	\N	\N	128145	128145	128146
26409	41608	14	applied	\N	\N	\N	\N	128147	128147	128148
26409	41609	15	applied	\N	\N	\N	\N	128149	128149	128150
26409	41610	16	applied	\N	\N	\N	\N	128152	128152	128153
26409	41624	17	applied	\N	\N	\N	\N	128182	128182	128183
26409	41627	18	applied	\N	\N	\N	\N	128197	128197	128198
26409	41630	19	applied	\N	\N	\N	\N	128205	128205	128206
26409	41633	20	applied	\N	\N	\N	\N	128212	128212	128213
26409	41637	21	applied	\N	\N	\N	\N	128222	128222	128223
26409	41638	22	applied	\N	\N	\N	\N	128224	128224	128225
26409	41639	23	applied	\N	\N	\N	\N	128226	128226	128227
26409	41640	24	applied	\N	\N	\N	\N	128228	128228	128229
26409	41650	25	applied	\N	\N	\N	\N	128250	128250	128251
26409	41653	26	applied	\N	\N	\N	\N	128258	128258	128259
26409	41657	27	applied	\N	\N	\N	\N	128268	128268	128269
26409	41660	28	applied	\N	\N	\N	\N	128275	128275	128276
26409	41663	29	applied	\N	\N	\N	\N	128285	128285	128286
26409	41666	30	applied	\N	\N	\N	\N	128293	128293	128294
26409	41672	31	applied	\N	\N	\N	\N	128307	128307	128308
26409	41673	32	applied	\N	\N	\N	\N	128309	128309	128310
26409	41679	33	applied	\N	\N	\N	\N	128324	128324	128325
26409	41682	34	applied	\N	\N	\N	\N	128332	128332	128333
26409	41683	35	applied	\N	\N	\N	\N	128334	128334	128335
26409	41689	36	applied	\N	\N	\N	\N	128347	128347	128348
26409	41692	37	applied	\N	\N	\N	\N	128353	128353	128354
26409	41695	38	applied	\N	\N	\N	\N	128363	128363	128364
26409	41698	39	applied	\N	\N	\N	\N	128370	128370	128371
26409	41702	40	applied	\N	\N	\N	\N	128382	128382	128383
26409	41704	41	applied	\N	\N	\N	\N	128388	128388	128389
26409	41707	42	applied	\N	\N	\N	\N	128394	128394	128395
26409	41711	43	applied	\N	\N	\N	\N	128407	128407	128408
26409	41712	44	applied	\N	\N	\N	\N	128409	128409	128410
26409	41717	45	applied	\N	\N	\N	\N	128420	128420	128421
26409	41721	46	applied	\N	\N	\N	\N	128428	128428	128429
26409	41724	47	applied	\N	\N	\N	\N	128459	128459	128460
26409	41725	48	applied	\N	\N	\N	\N	128461	128461	128462
26409	41726	49	applied	\N	\N	\N	\N	128463	128463	128464
26409	41731	50	applied	\N	\N	\N	\N	128479	128479	128480
26409	41733	51	applied	\N	\N	\N	\N	128487	128487	128488
26409	41735	52	applied	\N	\N	\N	\N	128493	128493	128494
26409	41736	53	applied	\N	\N	\N	\N	128495	128495	128496
26409	41737	54	applied	\N	\N	\N	\N	128497	128497	128498
26409	41742	55	applied	\N	\N	\N	\N	128508	128508	128509
26409	41745	56	applied	\N	\N	\N	\N	128516	128516	128517
26409	41747	57	applied	\N	\N	\N	\N	128522	128522	128523
26409	41749	58	applied	\N	\N	\N	\N	128527	128527	128528
26409	41751	59	applied	\N	\N	\N	\N	128533	128533	128534
26409	41752	60	applied	\N	\N	\N	\N	128535	128535	128536
26409	41753	61	applied	\N	\N	\N	\N	128537	128537	128538
26409	41754	62	applied	\N	\N	\N	\N	128539	128539	128540
26409	41762	63	applied	\N	\N	\N	\N	128560	128560	128561
26409	41764	64	applied	\N	\N	\N	\N	128566	128566	128567
26409	41765	65	applied	\N	\N	\N	\N	128568	128568	128569
26409	41769	66	applied	\N	\N	\N	\N	128581	128581	128582
26409	41770	67	applied	\N	\N	\N	\N	128583	128583	128584
26409	41771	68	applied	\N	\N	\N	\N	128585	128585	128586
26409	41775	69	applied	\N	\N	\N	\N	128594	128594	128595
26409	41776	70	applied	\N	\N	\N	\N	128596	128596	128597
26409	41780	71	applied	\N	\N	\N	\N	128606	128606	128607
26409	41782	72	applied	\N	\N	\N	\N	128612	128612	128613
26409	41785	73	applied	\N	\N	\N	\N	128638	128638	128639
26409	41786	74	applied	\N	\N	\N	\N	128640	128640	128641
26409	41789	75	applied	\N	\N	\N	\N	128651	128651	128652
26409	41792	76	applied	\N	\N	\N	\N	128662	128662	128663
26409	41793	77	applied	\N	\N	\N	\N	128664	128664	128665
26409	41796	78	applied	\N	\N	\N	\N	128678	128678	128679
26409	41797	79	applied	\N	\N	\N	\N	128680	128680	128681
26409	41801	80	applied	\N	\N	\N	\N	128690	128690	128691
26409	41803	81	applied	\N	\N	\N	\N	128695	128695	128696
26409	41805	82	applied	\N	\N	\N	\N	128702	128702	128703
26409	41806	83	applied	\N	\N	\N	\N	128704	128704	128705
26409	41810	84	applied	\N	\N	\N	\N	128718	128718	128719
26409	41812	85	applied	\N	\N	\N	\N	128723	128723	128724
26409	41815	86	applied	\N	\N	\N	\N	128730	128730	128731
26409	41816	87	applied	\N	\N	\N	\N	128732	128732	128733
26409	41819	88	applied	\N	\N	\N	\N	128739	128739	128740
26409	41821	89	applied	\N	\N	\N	\N	128746	128746	128747
26409	41822	90	applied	\N	\N	\N	\N	128748	128748	128749
26409	41826	91	applied	\N	\N	\N	\N	128760	128760	128761
26409	41828	92	applied	\N	\N	\N	\N	128767	128767	128768
26409	41832	93	applied	\N	\N	\N	\N	128785	128785	128786
26409	41833	94	applied	\N	\N	\N	\N	128787	128787	128788
26409	41834	95	applied	\N	\N	\N	\N	128789	128789	128790
26409	41839	96	applied	\N	\N	\N	\N	128802	128802	128803
26409	41841	97	applied	\N	\N	\N	\N	128806	128806	128807
26409	41843	98	applied	\N	\N	\N	\N	128812	128812	128813
26409	41844	99	applied	\N	\N	\N	\N	128814	128814	128815
26409	41845	100	applied	\N	\N	\N	\N	128816	128816	128817
26409	41850	101	applied	\N	\N	\N	\N	128832	128832	128833
26409	41853	102	applied	\N	\N	\N	\N	128840	128840	128841
26409	41855	103	applied	\N	\N	\N	\N	128846	128846	128847
26409	41857	104	applied	\N	\N	\N	\N	128852	128852	128853
26409	41860	105	applied	\N	\N	\N	\N	128859	128859	128860
26409	41862	106	applied	\N	\N	\N	\N	128864	128864	128865
26409	41863	107	applied	\N	\N	\N	\N	128866	128866	128867
26409	41864	108	applied	\N	\N	\N	\N	128868	128868	128869
26409	41869	109	applied	\N	\N	\N	\N	128880	128880	128881
26409	41870	110	applied	\N	\N	\N	\N	128882	128882	128883
26409	41873	111	applied	\N	\N	\N	\N	128890	128890	128891
26409	41874	112	applied	\N	\N	\N	\N	128892	128892	128893
26409	41878	113	applied	\N	\N	\N	\N	128903	128903	128904
26409	41882	114	applied	\N	\N	\N	\N	128915	128915	128916
26409	41888	115	applied	\N	\N	\N	\N	128931	128931	128932
26409	41889	116	applied	\N	\N	\N	\N	128933	128933	128934
26411	41985	0	applied	\N	\N	\N	\N	129237	129237	129238
26411	41986	1	applied	\N	\N	\N	\N	129239	129239	129240
26411	41987	2	applied	\N	\N	\N	\N	129241	129241	129242
26411	41988	3	applied	\N	\N	\N	\N	129243	129243	129244
26415	41992	0	applied	\N	\N	\N	\N	129259	129259	129260
26415	41993	1	applied	\N	\N	\N	\N	129261	129261	129262
26415	41994	2	applied	\N	\N	\N	\N	129263	129263	129264
26415	41995	3	applied	\N	\N	\N	\N	129265	129265	129266
26415	41996	4	applied	\N	\N	\N	\N	129267	129267	129268
26415	41997	5	applied	\N	\N	\N	\N	129269	129269	129270
26415	41998	6	applied	\N	\N	\N	\N	129271	129271	129272
26415	41999	7	applied	\N	\N	1000000000	\N	129273	129273	129274
26415	42000	8	applied	\N	\N	1000000000	\N	129275	129275	129276
26415	42001	9	applied	\N	\N	\N	\N	129277	129277	129278
26415	42002	10	applied	\N	\N	\N	\N	129279	129279	129280
26415	42003	11	applied	\N	\N	\N	\N	129281	129281	129282
26415	42004	12	applied	\N	\N	\N	\N	129283	129283	129284
26415	42005	13	applied	\N	\N	\N	\N	129285	129285	129286
26415	42006	14	applied	\N	\N	\N	\N	129287	129287	129288
26415	42007	15	applied	\N	\N	\N	\N	129289	129289	129290
26415	42008	16	applied	\N	\N	\N	\N	129291	129291	129292
26415	42009	17	applied	\N	\N	\N	\N	129293	129293	129294
26420	42024	0	applied	\N	\N	\N	\N	129333	129333	129334
26420	42025	1	applied	\N	\N	\N	\N	129335	129335	129336
26420	42026	2	applied	\N	\N	\N	\N	129337	129337	129338
26424	41780	0	applied	\N	\N	\N	\N	128606	128606	128607
26424	41782	1	applied	\N	\N	\N	\N	128612	128612	128613
26424	41785	2	applied	\N	\N	\N	\N	128638	128638	128639
26424	41786	3	applied	\N	\N	\N	\N	128640	128640	128641
26424	41789	4	applied	\N	\N	\N	\N	128651	128651	128652
26424	41792	5	applied	\N	\N	\N	\N	128662	128662	128663
26424	41793	6	applied	\N	\N	\N	\N	128664	128664	128665
26424	41796	7	applied	\N	\N	\N	\N	128678	128678	128679
26424	41797	8	applied	\N	\N	\N	\N	128680	128680	128681
26424	41801	9	applied	\N	\N	\N	\N	128690	128690	128691
26424	41803	10	applied	\N	\N	\N	\N	128695	128695	128696
26424	41805	11	applied	\N	\N	\N	\N	128702	128702	128703
26424	41806	12	applied	\N	\N	\N	\N	128704	128704	128705
26424	41810	13	applied	\N	\N	\N	\N	128718	128718	128719
26424	41812	14	applied	\N	\N	\N	\N	128723	128723	128724
26424	41815	15	applied	\N	\N	\N	\N	128730	128730	128731
26424	41816	16	applied	\N	\N	\N	\N	128732	128732	128733
26424	41819	17	applied	\N	\N	\N	\N	128739	128739	128740
26424	41821	18	applied	\N	\N	\N	\N	128746	128746	128747
26424	41822	19	applied	\N	\N	\N	\N	128748	128748	128749
26424	41826	20	applied	\N	\N	\N	\N	128760	128760	128761
26424	41828	21	applied	\N	\N	\N	\N	128767	128767	128768
26424	41832	22	applied	\N	\N	\N	\N	128785	128785	128786
26424	41833	23	applied	\N	\N	\N	\N	128787	128787	128788
26424	41834	24	applied	\N	\N	\N	\N	128789	128789	128790
26424	41839	25	applied	\N	\N	\N	\N	128802	128802	128803
26424	41841	26	applied	\N	\N	\N	\N	128806	128806	128807
26424	41843	27	applied	\N	\N	\N	\N	128812	128812	128813
26424	41844	28	applied	\N	\N	\N	\N	128814	128814	128815
26424	41845	29	applied	\N	\N	\N	\N	128816	128816	128817
26424	41850	30	applied	\N	\N	\N	\N	128832	128832	128833
26424	41853	31	applied	\N	\N	\N	\N	128840	128840	128841
26424	41855	32	applied	\N	\N	\N	\N	128846	128846	128847
26424	41857	33	applied	\N	\N	\N	\N	128852	128852	128853
26424	41860	34	applied	\N	\N	\N	\N	128859	128859	128860
26424	41862	35	applied	\N	\N	\N	\N	128864	128864	128865
26424	41863	36	applied	\N	\N	\N	\N	128866	128866	128867
26424	41864	37	applied	\N	\N	\N	\N	128868	128868	128869
26424	41869	38	applied	\N	\N	\N	\N	128880	128880	128881
26424	41870	39	applied	\N	\N	\N	\N	128882	128882	128883
26424	41873	40	applied	\N	\N	\N	\N	128890	128890	128891
26424	41874	41	applied	\N	\N	\N	\N	128892	128892	128893
26424	41878	42	applied	\N	\N	\N	\N	128903	128903	128904
26424	41882	43	applied	\N	\N	\N	\N	128915	128915	128916
26424	41888	44	applied	\N	\N	\N	\N	128931	128931	128932
26424	41889	45	applied	\N	\N	\N	\N	128933	128933	128934
26424	41894	46	applied	\N	\N	\N	\N	128945	128945	128946
26424	41895	47	applied	\N	\N	\N	\N	128947	128947	128948
26424	41902	48	applied	\N	\N	\N	\N	128963	128963	128964
26424	41905	49	applied	\N	\N	\N	\N	128971	128971	128972
26424	41908	50	applied	\N	\N	\N	\N	128981	128981	128982
26424	41912	51	applied	\N	\N	\N	\N	128996	128996	128997
26424	41915	52	applied	\N	\N	\N	\N	129004	129004	129005
26424	41918	53	applied	\N	\N	\N	\N	129012	129012	129013
26424	41919	54	applied	\N	\N	\N	\N	129014	129014	129015
26424	41925	55	applied	\N	\N	\N	\N	129028	129028	129029
26424	41926	56	applied	\N	\N	\N	\N	129030	129030	129031
26424	41931	57	applied	\N	\N	\N	\N	129042	129042	129043
26424	41932	58	applied	\N	\N	\N	\N	129044	129044	129045
26424	41938	59	applied	\N	\N	\N	\N	129111	129111	129112
26424	41939	60	applied	\N	\N	\N	\N	129113	129113	129114
26424	41945	61	applied	\N	\N	\N	\N	129126	129126	129127
26424	41948	62	applied	\N	\N	\N	\N	129134	129134	129135
26424	41952	63	applied	\N	\N	\N	\N	129142	129142	129143
26424	41953	64	applied	\N	\N	\N	\N	129145	129145	129146
26424	41959	65	applied	\N	\N	\N	\N	129159	129159	129160
26424	41961	66	applied	\N	\N	\N	\N	129163	129163	129164
26424	41965	67	applied	\N	\N	\N	\N	129172	129172	129173
26424	41969	68	applied	\N	\N	\N	\N	129182	129182	129183
26424	41972	69	applied	\N	\N	\N	\N	129190	129190	129191
26424	41975	70	applied	\N	\N	\N	\N	129200	129200	129201
26424	41979	71	applied	\N	\N	\N	\N	129211	129211	129212
26424	41980	72	applied	\N	\N	\N	\N	129222	129222	129223
26424	41985	73	applied	\N	\N	\N	\N	129237	129237	129238
26424	41989	74	applied	\N	\N	\N	\N	129249	129249	129250
26424	41992	75	applied	\N	\N	\N	\N	129259	129259	129260
26424	41993	76	applied	\N	\N	\N	\N	129261	129261	129262
26424	41994	78	applied	\N	\N	\N	\N	129263	129263	129264
26424	41995	79	applied	\N	\N	\N	\N	129265	129265	129266
26424	41996	80	applied	\N	\N	\N	\N	129267	129267	129268
26424	42010	81	applied	\N	\N	\N	\N	129299	129299	129300
26424	42014	82	applied	\N	\N	\N	\N	129311	129311	129312
26424	42017	83	applied	\N	\N	\N	\N	129317	129317	129318
26424	42018	84	applied	\N	\N	\N	\N	129319	129319	129320
26424	42024	85	applied	\N	\N	\N	\N	129333	129333	129334
26424	41459	86	applied	\N	\N	\N	\N	127751	127751	128622
26424	41380	87	applied	\N	\N	1000000000	\N	127526	127526	127527
26424	41950	88	applied	\N	\N	\N	\N	129138	129138	129139
26427	42030	0	applied	\N	\N	\N	\N	129356	129356	129357
26427	42031	1	applied	\N	\N	\N	\N	129358	129358	129359
26427	42032	2	applied	\N	\N	\N	\N	129360	129360	129361
26431	42037	0	applied	\N	\N	\N	\N	129376	129376	129377
26431	42038	1	applied	\N	\N	\N	\N	129378	129378	129379
26431	42039	2	applied	\N	\N	\N	\N	129380	129380	129381
26434	42040	0	applied	\N	\N	\N	\N	129384	129384	129385
26434	42041	1	applied	\N	\N	\N	\N	129386	129386	129387
26434	42042	3	applied	\N	\N	\N	\N	129389	129389	129390
26434	42043	4	applied	\N	\N	\N	\N	129391	129391	129392
26434	42044	5	applied	\N	\N	\N	\N	129393	129393	129394
26434	42045	6	applied	\N	\N	\N	\N	129395	129395	129396
26434	42046	7	applied	\N	\N	\N	\N	129397	129397	129398
26438	42053	0	applied	\N	\N	\N	\N	129421	129421	129422
26438	42054	1	applied	\N	\N	\N	\N	129423	129423	129424
26438	42055	2	applied	\N	\N	\N	\N	129425	129425	129426
26438	42056	3	applied	\N	\N	\N	\N	129427	129427	129428
26441	42057	0	applied	\N	\N	\N	\N	129432	129432	129433
26441	42058	1	applied	\N	\N	\N	\N	129434	129434	129435
26441	42059	2	applied	\N	\N	\N	\N	129436	129436	129437
26447	42067	1	applied	\N	\N	\N	\N	129461	129461	129462
26447	42068	2	applied	\N	\N	\N	\N	129463	129463	129464
26447	42069	3	applied	\N	\N	\N	\N	129465	129465	129466
26451	42070	0	applied	\N	\N	\N	\N	129473	129473	129474
26451	42071	1	applied	\N	\N	\N	\N	129475	129475	129476
26451	42072	2	applied	\N	\N	\N	\N	129477	129477	129478
26453	42073	0	applied	\N	\N	\N	\N	129482	129482	129483
26453	42074	1	applied	\N	\N	\N	\N	129484	129484	129485
26456	42075	0	applied	\N	\N	\N	\N	129487	129487	129488
26456	42076	1	applied	\N	\N	\N	\N	129489	129489	129490
26456	42077	2	applied	\N	\N	\N	\N	129491	129491	129492
26456	42078	3	applied	\N	\N	\N	\N	129493	129493	129494
26458	42082	0	applied	\N	\N	\N	\N	129536	129536	129537
26458	42083	1	applied	\N	\N	\N	\N	129538	129538	129539
26458	42084	2	applied	\N	\N	\N	\N	129540	129540	129541
26458	42085	3	applied	\N	\N	\N	\N	129542	129542	129543
26458	42086	4	applied	\N	\N	\N	\N	129544	129544	129545
26458	42087	5	applied	\N	\N	\N	\N	129546	129546	129547
26458	42088	6	applied	\N	\N	\N	\N	129548	129548	129549
26466	42101	0	applied	\N	\N	\N	\N	129607	129607	129608
26466	42102	1	applied	\N	\N	\N	\N	129609	129609	129610
26466	42103	2	applied	\N	\N	\N	\N	129611	129611	129612
26468	41828	0	applied	\N	\N	\N	\N	128767	128767	128768
26468	41832	1	applied	\N	\N	\N	\N	128785	128785	128786
26468	41833	2	applied	\N	\N	\N	\N	128787	128787	128788
26468	41834	3	applied	\N	\N	\N	\N	128789	128789	128790
26468	41839	4	applied	\N	\N	\N	\N	128802	128802	128803
26468	41841	5	applied	\N	\N	\N	\N	128806	128806	128807
26468	41843	6	applied	\N	\N	\N	\N	128812	128812	128813
26468	41844	7	applied	\N	\N	\N	\N	128814	128814	128815
26468	41845	8	applied	\N	\N	\N	\N	128816	128816	128817
26468	41850	9	applied	\N	\N	\N	\N	128832	128832	128833
26468	41853	10	applied	\N	\N	\N	\N	128840	128840	128841
26468	41855	11	applied	\N	\N	\N	\N	128846	128846	128847
26468	41857	12	applied	\N	\N	\N	\N	128852	128852	128853
26468	41860	13	applied	\N	\N	\N	\N	128859	128859	128860
26468	41862	14	applied	\N	\N	\N	\N	128864	128864	128865
26468	41863	15	applied	\N	\N	\N	\N	128866	128866	128867
26468	41864	16	applied	\N	\N	\N	\N	128868	128868	128869
26468	41869	17	applied	\N	\N	\N	\N	128880	128880	128881
26468	41870	18	applied	\N	\N	\N	\N	128882	128882	128883
26468	41873	19	applied	\N	\N	\N	\N	128890	128890	128891
26468	41874	20	applied	\N	\N	\N	\N	128892	128892	128893
26468	41878	21	applied	\N	\N	\N	\N	128903	128903	128904
26468	41882	22	applied	\N	\N	\N	\N	128915	128915	128916
26468	41888	23	applied	\N	\N	\N	\N	128931	128931	128932
26468	41889	24	applied	\N	\N	\N	\N	128933	128933	128934
26468	41894	25	applied	\N	\N	\N	\N	128945	128945	128946
26468	41895	26	applied	\N	\N	\N	\N	128947	128947	128948
26468	41902	27	applied	\N	\N	\N	\N	128963	128963	128964
26468	41905	28	applied	\N	\N	\N	\N	128971	128971	128972
26468	41908	29	applied	\N	\N	\N	\N	128981	128981	128982
26468	41912	30	applied	\N	\N	\N	\N	128996	128996	128997
26468	41915	31	applied	\N	\N	\N	\N	129004	129004	129005
26468	41918	32	applied	\N	\N	\N	\N	129012	129012	129013
26468	41919	33	applied	\N	\N	\N	\N	129014	129014	129015
26468	41925	34	applied	\N	\N	\N	\N	129028	129028	129029
26468	41926	35	applied	\N	\N	\N	\N	129030	129030	129031
26468	41931	36	applied	\N	\N	\N	\N	129042	129042	129043
26468	41932	37	applied	\N	\N	\N	\N	129044	129044	129045
26468	41938	38	applied	\N	\N	\N	\N	129111	129111	129112
26468	41939	39	applied	\N	\N	\N	\N	129113	129113	129114
26468	41945	40	applied	\N	\N	\N	\N	129126	129126	129127
26468	41948	41	applied	\N	\N	\N	\N	129134	129134	129135
26468	41952	42	applied	\N	\N	\N	\N	129142	129142	129143
26468	41953	43	applied	\N	\N	\N	\N	129145	129145	129146
26468	41959	44	applied	\N	\N	\N	\N	129159	129159	129160
26468	41961	45	applied	\N	\N	\N	\N	129163	129163	129164
26468	41965	46	applied	\N	\N	\N	\N	129172	129172	129173
26468	41969	47	applied	\N	\N	\N	\N	129182	129182	129183
26468	41972	48	applied	\N	\N	\N	\N	129190	129190	129191
26468	41975	49	applied	\N	\N	\N	\N	129200	129200	129201
26468	41979	50	applied	\N	\N	\N	\N	129211	129211	129212
26468	41980	51	applied	\N	\N	\N	\N	129222	129222	129223
26468	41985	52	applied	\N	\N	\N	\N	129237	129237	129238
26468	41989	53	applied	\N	\N	\N	\N	129249	129249	129250
26468	41992	54	applied	\N	\N	\N	\N	129259	129259	129260
26468	41993	55	applied	\N	\N	\N	\N	129261	129261	129262
26468	41994	57	applied	\N	\N	\N	\N	129263	129263	129264
26468	41995	58	applied	\N	\N	\N	\N	129265	129265	129266
26468	41996	59	applied	\N	\N	\N	\N	129267	129267	129268
26468	42010	60	applied	\N	\N	\N	\N	129299	129299	129300
26468	42014	61	applied	\N	\N	\N	\N	129311	129311	129312
26468	42017	62	applied	\N	\N	\N	\N	129317	129317	129318
26468	42018	63	applied	\N	\N	\N	\N	129319	129319	129320
26468	42024	64	applied	\N	\N	\N	\N	129333	129333	129334
26468	42027	65	applied	\N	\N	\N	\N	129348	129348	129349
26468	42030	66	applied	\N	\N	\N	\N	129356	129356	129357
26468	42033	67	applied	\N	\N	\N	\N	129366	129366	129367
26468	42037	68	applied	\N	\N	\N	\N	129376	129376	129377
26468	42040	69	applied	\N	\N	\N	\N	129384	129384	129385
26468	42041	70	applied	\N	\N	\N	\N	129386	129386	129387
26468	42047	71	applied	\N	\N	\N	\N	129404	129404	129405
26468	42048	72	applied	\N	\N	\N	\N	129406	129406	129407
26468	42053	73	applied	\N	\N	\N	\N	129421	129421	129422
26468	42057	74	applied	\N	\N	\N	\N	129432	129432	129433
26468	42060	75	applied	\N	\N	\N	\N	129442	129442	129443
26468	42061	76	applied	\N	\N	\N	\N	129444	129444	129445
26468	42066	77	applied	\N	\N	\N	\N	129459	129459	129460
26468	42070	78	applied	\N	\N	\N	\N	129473	129473	129474
26468	42073	79	applied	\N	\N	\N	\N	129482	129482	129483
26468	42075	80	applied	\N	\N	\N	\N	129487	129487	129488
26468	42079	81	applied	\N	\N	\N	\N	129528	129528	129529
26468	42082	82	applied	\N	\N	\N	\N	129536	129536	129537
26468	42083	83	applied	\N	\N	\N	\N	129538	129538	129539
26468	42089	84	applied	\N	\N	\N	\N	129576	129576	129577
26468	42092	85	applied	\N	\N	\N	\N	129585	129585	129586
26468	42093	86	applied	\N	\N	\N	\N	129587	129587	129588
26468	42101	87	applied	\N	\N	\N	\N	129607	129607	129608
26468	41879	88	applied	\N	\N	\N	\N	128905	128905	129652
26468	41829	89	applied	\N	\N	\N	\N	128769	128769	129653
26468	41836	90	applied	\N	\N	\N	\N	128793	128793	128772
26468	41830	91	applied	\N	\N	\N	\N	128771	128771	128781
26468	41831	92	applied	\N	\N	\N	\N	128780	128780	128792
26468	41835	93	applied	\N	\N	\N	\N	128791	128791	129654
26468	41837	94	applied	\N	\N	\N	\N	128795	128795	129655
26468	41838	95	applied	\N	\N	\N	\N	128797	128797	129656
26468	41840	96	applied	\N	\N	\N	\N	128804	128804	129657
26468	41950	97	applied	\N	\N	\N	\N	129138	129138	129139
26468	41847	98	applied	\N	\N	\N	\N	128820	128820	128809
26449	42068	0	applied	\N	\N	\N	\N	129463	129463	129470
26449	42069	1	applied	\N	\N	\N	\N	129465	129465	129471
26452	42070	0	applied	\N	\N	\N	\N	129473	129473	129474
26452	42071	1	applied	\N	\N	\N	\N	129475	129475	129476
26452	42072	2	applied	\N	\N	\N	\N	129477	129477	129478
26454	42075	0	applied	\N	\N	\N	\N	129487	129487	129488
26454	42076	1	applied	\N	\N	\N	\N	129489	129489	129490
26454	42077	2	applied	\N	\N	\N	\N	129491	129491	129492
26454	42078	3	applied	\N	\N	\N	\N	129493	129493	129494
26473	42115	0	applied	\N	\N	\N	\N	129699	129699	129700
26473	42116	1	applied	\N	\N	\N	\N	129701	129701	129702
26473	42117	2	applied	\N	\N	\N	\N	129703	129703	129704
26473	42118	3	applied	\N	\N	\N	\N	129705	129705	129706
26473	42119	4	applied	\N	\N	\N	\N	129707	129707	129708
26473	42120	5	applied	\N	\N	\N	\N	129709	129709	129710
26473	42121	6	applied	\N	\N	\N	\N	129711	129711	129712
26478	42132	0	applied	\N	\N	\N	\N	129741	129741	129742
26478	42133	1	applied	\N	\N	\N	\N	129743	129743	129744
26478	42134	2	applied	\N	\N	\N	\N	129745	129745	111296
26478	42135	3	applied	\N	\N	\N	\N	129746	129746	129747
26480	42136	0	applied	\N	\N	\N	\N	129749	129749	129750
26480	42137	1	applied	\N	\N	\N	\N	129751	129751	129752
26480	42138	2	applied	\N	\N	\N	\N	129753	129753	129754
26480	42139	3	applied	\N	\N	\N	\N	129755	129755	129756
26480	42140	4	applied	\N	\N	\N	\N	129757	129757	129758
26482	42141	0	applied	\N	\N	\N	\N	129762	129762	129763
26482	42142	1	applied	\N	\N	\N	\N	129764	129764	129765
26482	42143	2	applied	\N	\N	\N	\N	129766	129766	129767
26483	42141	0	applied	\N	\N	\N	\N	129762	129762	129763
26483	42142	1	applied	\N	\N	\N	\N	129764	129764	129765
26483	42143	2	applied	\N	\N	\N	\N	129766	129766	129767
26487	42147	0	applied	\N	\N	\N	\N	129782	129782	129783
26487	42148	1	applied	\N	\N	\N	\N	129784	129784	129785
26487	42149	2	applied	\N	\N	\N	\N	129786	129786	129787
26487	42150	3	applied	\N	\N	\N	\N	129788	129788	129789
26490	42154	0	applied	\N	\N	\N	\N	129799	129799	129800
26490	42155	1	applied	\N	\N	\N	\N	129801	129801	129802
26490	42156	2	applied	\N	\N	\N	\N	129803	129803	129804
26490	42157	3	applied	\N	\N	\N	\N	129805	129805	129806
26490	42158	4	applied	\N	\N	\N	\N	129807	129807	129808
26490	42159	5	applied	\N	\N	\N	\N	129809	129809	129810
26490	42160	6	applied	\N	\N	\N	\N	129811	129811	129812
26492	42164	0	applied	\N	\N	\N	\N	129825	129825	129826
26492	42165	1	applied	\N	\N	\N	\N	129827	129827	129828
26492	42166	2	applied	\N	\N	\N	\N	129829	129829	129830
26495	42167	0	applied	\N	\N	\N	\N	129836	129836	129847
26495	42168	1	applied	\N	\N	\N	\N	129838	129838	129848
26495	42170	2	applied	\N	\N	\N	\N	129849	129849	129850
26495	42169	3	applied	\N	\N	\N	\N	129841	129841	129851
26495	42171	4	applied	\N	\N	\N	\N	129852	129852	129853
26495	42172	5	applied	\N	\N	\N	\N	129854	129854	129855
26495	42173	6	applied	\N	\N	\N	\N	129856	129856	129857
26495	42174	7	applied	\N	\N	\N	\N	129858	129858	129859
26495	42175	8	applied	\N	\N	\N	\N	129860	129860	129861
26495	42176	9	applied	\N	\N	\N	\N	129862	129862	129863
26497	42177	0	applied	\N	\N	\N	\N	129866	129866	129867
26497	42178	1	applied	\N	\N	\N	\N	129868	129868	129869
26497	42179	2	applied	\N	\N	\N	\N	129870	129870	129871
26500	42187	0	applied	\N	\N	\N	\N	129894	129894	129895
26500	42188	1	applied	\N	\N	\N	\N	129896	129896	129897
26500	42189	2	applied	\N	\N	\N	\N	129898	129898	129899
26505	42200	0	applied	\N	\N	\N	\N	129926	129926	129927
26505	42201	1	applied	\N	\N	\N	\N	129928	129928	129929
26505	42202	2	applied	\N	\N	\N	\N	129930	129930	129931
26511	42213	0	applied	\N	\N	\N	\N	130018	130018	130019
26511	42214	1	applied	\N	\N	\N	\N	130020	130020	130021
26511	42215	2	applied	\N	\N	\N	\N	130022	130022	130023
26511	42216	3	applied	\N	\N	\N	\N	130024	130024	130025
26511	42217	4	applied	\N	\N	\N	\N	130026	130026	130027
26511	42218	6	applied	\N	\N	\N	\N	130029	130029	130030
26511	42219	7	applied	\N	\N	\N	\N	130031	130031	130032
26511	42220	8	applied	\N	\N	\N	\N	130033	130033	130034
26511	42221	9	applied	\N	\N	\N	\N	130035	130035	130036
26511	42222	10	applied	\N	\N	\N	\N	130037	130037	130038
26520	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26520	42241	1	applied	\N	\N	\N	\N	130092	130092	130093
26520	42242	2	applied	\N	\N	\N	\N	130094	130094	130095
26524	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26524	42241	1	applied	\N	\N	\N	\N	130092	130092	130093
26524	42242	2	applied	\N	\N	\N	\N	130094	130094	130095
26526	42243	0	applied	\N	\N	\N	\N	130107	130107	130108
26526	42244	1	applied	\N	\N	\N	\N	130109	130109	130110
26526	42245	2	applied	\N	\N	\N	\N	130111	130111	130112
26529	42250	0	applied	\N	\N	\N	\N	130124	130124	130125
26529	42251	1	applied	\N	\N	\N	\N	130126	130126	130127
26529	42252	2	applied	\N	\N	\N	\N	130128	130128	130129
26531	42256	0	applied	\N	\N	\N	\N	130142	130142	130143
26531	42257	1	applied	\N	\N	\N	\N	130144	130144	130145
26531	42258	2	applied	\N	\N	\N	\N	130146	130146	130147
26531	42259	3	applied	\N	\N	\N	\N	130148	130148	130149
26535	42260	0	applied	\N	\N	\N	\N	130151	130151	130152
26535	42261	1	applied	\N	\N	\N	\N	130153	130153	130154
26535	42262	2	applied	\N	\N	\N	\N	130155	130155	130156
26535	42263	3	applied	\N	\N	\N	\N	130157	130157	130158
26535	42264	4	applied	\N	\N	\N	\N	130159	130159	130160
26535	42265	5	applied	\N	\N	\N	\N	130161	130161	130162
26535	42266	6	applied	\N	\N	\N	\N	130163	130163	130164
26535	42267	7	applied	\N	\N	\N	\N	130165	130165	130166
26535	42268	8	applied	\N	\N	\N	\N	130167	130167	130168
26542	42289	0	applied	\N	\N	\N	\N	130220	130220	130221
26542	42290	1	applied	\N	\N	\N	\N	130222	130222	130223
26542	42291	2	applied	\N	\N	\N	\N	130224	130224	130225
26542	42292	3	applied	\N	\N	\N	\N	130226	130226	130227
26542	42293	4	applied	\N	\N	\N	\N	130228	130228	130229
26542	42294	5	applied	\N	\N	\N	\N	130230	130230	130231
26542	42295	6	applied	\N	\N	\N	\N	130232	130232	130233
26547	42308	0	applied	\N	\N	\N	\N	130267	130267	130268
26547	42309	2	applied	\N	\N	\N	\N	130270	130270	130271
26547	42310	3	applied	\N	\N	\N	\N	130272	130272	130273
26549	42311	0	applied	\N	\N	\N	\N	130276	130276	130277
26549	42312	1	applied	\N	\N	\N	\N	130278	130278	130279
26552	42317	0	applied	\N	\N	\N	\N	130290	130290	130291
26552	42318	1	applied	\N	\N	\N	\N	130292	130292	130293
26552	42319	2	applied	\N	\N	\N	\N	130294	130294	130295
26555	42333	0	applied	\N	\N	\N	\N	130326	130326	130327
26555	42334	1	applied	\N	\N	\N	\N	130328	130328	130329
26555	42335	2	applied	\N	\N	\N	\N	130330	130330	130331
26560	42336	0	applied	\N	\N	\N	\N	130336	130336	130337
26560	42337	1	applied	\N	\N	\N	\N	130338	130338	130339
26560	42338	2	applied	\N	\N	\N	\N	130340	130340	130341
26455	42024	9	applied	\N	\N	\N	\N	129333	129333	129334
26455	42027	10	applied	\N	\N	\N	\N	129348	129348	129349
26455	42030	11	applied	\N	\N	\N	\N	129356	129356	129357
26455	42033	12	applied	\N	\N	\N	\N	129366	129366	129367
26455	42037	13	applied	\N	\N	\N	\N	129376	129376	129377
26455	42040	14	applied	\N	\N	\N	\N	129384	129384	129385
26455	42041	15	applied	\N	\N	\N	\N	129386	129386	129387
26455	42047	16	applied	\N	\N	\N	\N	129404	129404	129405
26455	42048	17	applied	\N	\N	\N	\N	129406	129406	129407
26455	42053	18	applied	\N	\N	\N	\N	129421	129421	129422
26455	42057	19	applied	\N	\N	\N	\N	129432	129432	129433
26455	42060	20	applied	\N	\N	\N	\N	129442	129442	129443
26455	42061	21	applied	\N	\N	\N	\N	129444	129444	129445
26455	42066	22	applied	\N	\N	\N	\N	129459	129459	129460
26455	42070	23	applied	\N	\N	\N	\N	129473	129473	129474
26455	42073	24	applied	\N	\N	\N	\N	129482	129482	129483
26455	42075	25	applied	\N	\N	\N	\N	129487	129487	129488
26455	41997	26	applied	\N	\N	\N	\N	129269	129269	129270
26455	41998	27	applied	\N	\N	\N	\N	129271	129271	129272
26455	41999	28	applied	\N	\N	1000000000	\N	129273	129273	129274
26455	42000	29	applied	\N	\N	1000000000	\N	129275	129275	129276
26455	42015	30	applied	\N	\N	\N	\N	129313	129313	129314
26455	42013	31	applied	\N	\N	\N	\N	129305	129305	129495
26455	42021	32	applied	\N	\N	\N	\N	129325	129325	129496
26455	42035	33	applied	\N	\N	\N	\N	129370	129370	129278
26455	42045	34	applied	\N	\N	\N	\N	129395	129395	129497
26455	42055	35	applied	\N	\N	\N	\N	129425	129425	129498
26455	42068	36	applied	\N	\N	\N	\N	129463	129463	129280
26455	42077	37	applied	\N	\N	\N	\N	129491	129491	129499
26455	42001	38	applied	\N	\N	\N	\N	129277	129277	129500
26455	42002	39	applied	\N	\N	\N	\N	129279	129279	129501
26455	42003	40	applied	\N	\N	\N	\N	129281	129281	129288
26455	42004	41	applied	\N	\N	\N	\N	129283	129283	129502
26455	42012	42	applied	\N	\N	\N	\N	129303	129303	129294
26455	42022	43	applied	\N	\N	\N	\N	129327	129327	129503
26455	42023	44	applied	\N	\N	\N	\N	129329	129329	129306
26455	42026	45	applied	\N	\N	\N	\N	129337	129337	129504
26455	42028	46	applied	\N	\N	\N	\N	129350	129350	129324
26455	42032	47	applied	\N	\N	\N	\N	129360	129360	129505
26455	42036	48	applied	\N	\N	\N	\N	129372	129372	129506
26455	42039	49	applied	\N	\N	\N	\N	129380	129380	129336
26455	42042	50	applied	\N	\N	\N	\N	129389	129389	129338
26455	42043	51	applied	\N	\N	\N	\N	129391	129391	129351
26455	42051	52	applied	\N	\N	\N	\N	129412	129412	129507
26455	42052	53	applied	\N	\N	\N	\N	129414	129414	129508
26455	42054	54	applied	\N	\N	\N	\N	129423	129423	129369
26455	42059	55	applied	\N	\N	\N	\N	129436	129436	129509
26455	42064	56	applied	\N	\N	\N	\N	129450	129450	129379
26455	42065	57	applied	\N	\N	\N	\N	129452	129452	129381
26455	42069	58	applied	\N	\N	\N	\N	129465	129465	129390
26455	42072	59	applied	\N	\N	\N	\N	129477	129477	129392
26455	42074	60	applied	\N	\N	\N	\N	129484	129484	129396
26455	42076	61	applied	\N	\N	\N	\N	129489	129489	129510
26455	42005	62	applied	\N	\N	\N	\N	129285	129285	129511
26455	42006	63	applied	\N	\N	\N	\N	129287	129287	129512
26455	42007	64	applied	\N	\N	\N	\N	129289	129289	129413
26455	42008	65	applied	\N	\N	\N	\N	129291	129291	129513
26455	42009	66	applied	\N	\N	\N	\N	129293	129293	129514
26455	42011	67	applied	\N	\N	\N	\N	129301	129301	129424
26455	42016	69	applied	\N	\N	\N	\N	129315	129315	129516
26455	42019	70	applied	\N	\N	\N	\N	129321	129321	129517
26455	42020	71	applied	\N	\N	\N	\N	129323	129323	129518
26455	42025	72	applied	\N	\N	\N	\N	129335	129335	129437
26455	42029	73	applied	\N	\N	\N	\N	129352	129352	129447
26455	42031	74	applied	\N	\N	\N	\N	129358	129358	129449
26455	42034	75	applied	\N	\N	\N	\N	129368	129368	129519
26455	42038	76	applied	\N	\N	\N	\N	129378	129378	129520
26455	42044	77	applied	\N	\N	\N	\N	129393	129393	129453
26455	42046	78	applied	\N	\N	\N	\N	129397	129397	129462
26455	42049	79	applied	\N	\N	\N	\N	129408	129408	129471
26455	42050	80	applied	\N	\N	\N	\N	129410	129410	129466
26455	42056	81	applied	\N	\N	\N	\N	129427	129427	129476
26455	42058	82	applied	\N	\N	\N	\N	129434	129434	129521
26455	42062	83	applied	\N	\N	\N	\N	129446	129446	129522
26455	42063	84	applied	\N	\N	\N	\N	129448	129448	129485
26455	42067	85	applied	\N	\N	\N	\N	129461	129461	129523
26455	42071	86	applied	\N	\N	\N	\N	129475	129475	129492
26455	42078	87	applied	\N	\N	\N	\N	129493	129493	129494
26459	41961	0	applied	\N	\N	\N	\N	129163	129163	129164
26459	41965	1	applied	\N	\N	\N	\N	129172	129172	129173
26459	41969	2	applied	\N	\N	\N	\N	129182	129182	129183
26459	41972	3	applied	\N	\N	\N	\N	129190	129190	129191
26459	41975	4	applied	\N	\N	\N	\N	129200	129200	129201
26459	41979	5	applied	\N	\N	\N	\N	129211	129211	129212
26459	41980	6	applied	\N	\N	\N	\N	129222	129222	129223
26459	41985	7	applied	\N	\N	\N	\N	129237	129237	129238
26459	41989	8	applied	\N	\N	\N	\N	129249	129249	129250
26459	41992	9	applied	\N	\N	\N	\N	129259	129259	129260
26459	41993	10	applied	\N	\N	\N	\N	129261	129261	129262
26459	41994	11	applied	\N	\N	\N	\N	129263	129263	129264
26459	41995	12	applied	\N	\N	\N	\N	129265	129265	129266
26459	41996	13	applied	\N	\N	\N	\N	129267	129267	129268
26459	42010	14	applied	\N	\N	\N	\N	129299	129299	129300
26459	42014	15	applied	\N	\N	\N	\N	129311	129311	129312
26459	42017	16	applied	\N	\N	\N	\N	129317	129317	129318
26459	42018	17	applied	\N	\N	\N	\N	129319	129319	129320
26459	42024	18	applied	\N	\N	\N	\N	129333	129333	129334
26459	42027	19	applied	\N	\N	\N	\N	129348	129348	129349
26459	42030	20	applied	\N	\N	\N	\N	129356	129356	129357
26459	42033	21	applied	\N	\N	\N	\N	129366	129366	129367
26459	42037	22	applied	\N	\N	\N	\N	129376	129376	129377
26459	42040	23	applied	\N	\N	\N	\N	129384	129384	129385
26459	42041	24	applied	\N	\N	\N	\N	129386	129386	129387
26459	42047	25	applied	\N	\N	\N	\N	129404	129404	129405
26459	42048	26	applied	\N	\N	\N	\N	129406	129406	129407
26459	42053	27	applied	\N	\N	\N	\N	129421	129421	129422
26459	42057	28	applied	\N	\N	\N	\N	129432	129432	129433
26459	42060	29	applied	\N	\N	\N	\N	129442	129442	129443
26459	42061	30	applied	\N	\N	\N	\N	129444	129444	129445
26459	42066	31	applied	\N	\N	\N	\N	129459	129459	129460
26459	42070	32	applied	\N	\N	\N	\N	129473	129473	129474
26459	42073	33	applied	\N	\N	\N	\N	129482	129482	129483
26459	42075	34	applied	\N	\N	\N	\N	129487	129487	129488
26459	42079	35	applied	\N	\N	\N	\N	129528	129528	129529
26459	42082	36	applied	\N	\N	\N	\N	129536	129536	129537
26459	42083	37	applied	\N	\N	\N	\N	129538	129538	129539
26459	41962	38	applied	\N	\N	\N	\N	129165	129165	129166
26459	41963	39	applied	\N	\N	\N	\N	129167	129167	129168
26459	41999	40	applied	\N	\N	1000000000	\N	129273	129273	129274
26459	42000	41	applied	\N	\N	1000000000	\N	129275	129275	129276
26459	41967	42	applied	\N	\N	\N	\N	129176	129176	129213
26459	41970	43	applied	\N	\N	\N	\N	129184	129184	129214
26459	41974	44	applied	\N	\N	\N	\N	129194	129194	129215
26459	41976	45	applied	\N	\N	\N	\N	129202	129202	129216
26459	41981	46	applied	\N	\N	\N	\N	129224	129224	129193
26459	41982	47	applied	\N	\N	\N	\N	129226	129226	129195
26459	42015	48	applied	\N	\N	\N	\N	129313	129313	129314
26459	41988	49	applied	\N	\N	\N	\N	129243	129243	129203
26459	41991	50	applied	\N	\N	\N	\N	129253	129253	129207
26459	41998	51	applied	\N	\N	\N	\N	129271	129271	129225
26459	42001	52	applied	\N	\N	\N	\N	129277	129277	129227
26459	42002	53	applied	\N	\N	\N	\N	129279	129279	129551
26459	42003	54	applied	\N	\N	\N	\N	129281	129281	129552
26459	42004	55	applied	\N	\N	\N	\N	129283	129283	129553
26459	42012	56	applied	\N	\N	\N	\N	129303	129303	129252
26459	42022	57	applied	\N	\N	\N	\N	129327	129327	129254
26459	42023	58	applied	\N	\N	\N	\N	129329	129329	129554
26459	42026	59	applied	\N	\N	\N	\N	129337	129337	129496
26459	42028	60	applied	\N	\N	\N	\N	129350	129350	129498
26459	42032	61	applied	\N	\N	\N	\N	129360	129360	129555
26459	42036	62	applied	\N	\N	\N	\N	129372	129372	129556
26459	42039	63	applied	\N	\N	\N	\N	129380	129380	129286
26459	42042	64	applied	\N	\N	\N	\N	129389	129389	129557
26459	42043	65	applied	\N	\N	\N	\N	129391	129391	129292
26459	42051	66	applied	\N	\N	\N	\N	129412	129412	129558
26459	42052	67	applied	\N	\N	\N	\N	129414	129414	129559
26459	42054	68	applied	\N	\N	\N	\N	129423	129423	129560
26459	42059	69	applied	\N	\N	\N	\N	129436	129436	129322
26459	42064	70	applied	\N	\N	\N	\N	129450	129450	129326
26459	42065	71	applied	\N	\N	\N	\N	129452	129452	129328
26459	42069	72	applied	\N	\N	\N	\N	129465	129465	129330
26459	42072	73	applied	\N	\N	\N	\N	129477	129477	129561
26459	42074	74	applied	\N	\N	\N	\N	129484	129484	129562
26459	42076	75	applied	\N	\N	\N	\N	129489	129489	129563
26459	42081	76	applied	\N	\N	\N	\N	129532	129532	129359
26459	42086	77	applied	\N	\N	\N	\N	129544	129544	129361
26459	42088	78	applied	\N	\N	\N	\N	129548	129548	129371
26459	41968	79	applied	\N	\N	\N	\N	129178	129178	129564
26459	41977	80	applied	\N	\N	\N	\N	129204	129204	129509
26459	41986	81	applied	\N	\N	\N	\N	129239	129239	129373
26459	41997	82	applied	\N	\N	\N	\N	129269	129269	129565
26459	42013	83	applied	\N	\N	\N	\N	129305	129305	129379
26459	42021	84	applied	\N	\N	\N	\N	129325	129325	129566
26459	42035	85	applied	\N	\N	\N	\N	129370	129370	129567
26459	42045	86	applied	\N	\N	\N	\N	129395	129395	129381
26459	42055	87	applied	\N	\N	\N	\N	129425	129425	129568
26459	42068	88	applied	\N	\N	\N	\N	129463	129463	129569
26459	42077	89	applied	\N	\N	\N	\N	129491	129491	129390
26459	42087	90	applied	\N	\N	\N	\N	129546	129546	129570
26459	41964	91	applied	\N	\N	\N	\N	129169	129169	129392
26459	41966	92	applied	\N	\N	\N	\N	129174	129174	129394
26459	41971	93	applied	\N	\N	\N	\N	129186	129186	129571
26459	41973	94	applied	\N	\N	\N	\N	129192	129192	129510
26459	41978	95	applied	\N	\N	\N	\N	129206	129206	129511
26459	41983	96	applied	\N	\N	\N	\N	129228	129228	129512
26459	41984	97	applied	\N	\N	\N	\N	129230	129230	129413
26459	41987	98	applied	\N	\N	\N	\N	129241	129241	129513
26459	41990	99	applied	\N	\N	\N	\N	129251	129251	129514
26459	42005	100	applied	\N	\N	\N	\N	129285	129285	129424
26459	42006	101	applied	\N	\N	\N	\N	129287	129287	129516
26459	42007	102	applied	\N	\N	\N	\N	129289	129289	129517
26459	42008	103	applied	\N	\N	\N	\N	129291	129291	129518
26459	42009	104	applied	\N	\N	\N	\N	129293	129293	129437
26459	42011	105	applied	\N	\N	\N	\N	129301	129301	129447
26459	42016	106	applied	\N	\N	\N	\N	129315	129315	129449
26459	42019	107	applied	\N	\N	\N	\N	129321	129321	129519
26459	42020	108	applied	\N	\N	\N	\N	129323	129323	129520
26459	42025	109	applied	\N	\N	\N	\N	129335	129335	129453
26459	42029	110	applied	\N	\N	\N	\N	129352	129352	129462
26459	42031	111	applied	\N	\N	\N	\N	129358	129358	129471
26459	42034	112	applied	\N	\N	\N	\N	129368	129368	129466
26459	42038	113	applied	\N	\N	\N	\N	129378	129378	129476
26459	42044	114	applied	\N	\N	\N	\N	129393	129393	129521
26459	42046	116	applied	\N	\N	\N	\N	129397	129397	129522
26459	42049	117	applied	\N	\N	\N	\N	129408	129408	129485
26462	42092	0	applied	\N	\N	\N	\N	129585	129585	129586
26462	42093	1	applied	\N	\N	\N	\N	129587	129587	129588
26462	42094	2	applied	\N	\N	\N	\N	129589	129589	129590
26462	42095	3	applied	\N	\N	\N	\N	129591	129591	129592
26462	42096	4	applied	\N	\N	\N	\N	129593	129593	129594
26462	42097	5	applied	\N	\N	\N	\N	129595	129595	129596
26464	42098	0	applied	\N	\N	\N	\N	129600	129600	129601
26464	42099	1	applied	\N	\N	\N	\N	129602	129602	129603
26464	42100	2	applied	\N	\N	\N	\N	129604	129604	129605
26469	42104	0	applied	\N	\N	\N	\N	129674	129674	129675
26469	42105	1	applied	\N	\N	\N	\N	129676	129676	129677
26469	42106	2	applied	\N	\N	\N	\N	129678	129678	129679
26469	42107	3	applied	\N	\N	\N	\N	129680	129680	129681
26469	42108	4	applied	\N	\N	\N	\N	129682	129682	129683
26469	42109	5	applied	\N	\N	\N	\N	129684	129684	129685
26469	42110	6	applied	\N	\N	\N	\N	129686	129686	129687
26469	42111	7	applied	\N	\N	\N	\N	129688	129688	129689
26471	42112	0	applied	\N	\N	\N	\N	129693	129693	129694
26471	42113	1	applied	\N	\N	\N	\N	129695	129695	129696
26471	42114	2	applied	\N	\N	\N	\N	129697	129697	129698
26479	42132	0	applied	\N	\N	\N	\N	129741	129741	129742
26479	42133	1	applied	\N	\N	\N	\N	129743	129743	129744
26479	42134	2	applied	\N	\N	\N	\N	129745	129745	111296
26479	42135	3	applied	\N	\N	\N	\N	129746	129746	129747
26481	42136	0	applied	\N	\N	\N	\N	129749	129749	129750
26481	42137	1	applied	\N	\N	\N	\N	129751	129751	129752
26481	42138	2	applied	\N	\N	\N	\N	129753	129753	129754
26481	42139	3	applied	\N	\N	\N	\N	129755	129755	129756
26481	42140	4	applied	\N	\N	\N	\N	129757	129757	129758
26493	42164	0	applied	\N	\N	\N	\N	129825	129825	129826
26493	42165	1	applied	\N	\N	\N	\N	129827	129827	129828
26493	42166	2	applied	\N	\N	\N	\N	129829	129829	129830
26498	42179	0	applied	\N	\N	\N	\N	129870	129870	129876
26501	42190	0	applied	\N	\N	\N	\N	129902	129902	129903
26501	42191	1	applied	\N	\N	\N	\N	129904	129904	129905
26501	42192	2	applied	\N	\N	\N	\N	129906	129906	129907
26501	42193	3	applied	\N	\N	\N	\N	129908	129908	129909
26501	42194	4	applied	\N	\N	\N	\N	129910	129910	129911
26501	42195	5	applied	\N	\N	\N	\N	129912	129912	129913
26501	42196	6	applied	\N	\N	\N	\N	129914	129914	129915
26503	42197	0	applied	\N	\N	\N	\N	129919	129919	129920
26503	42198	1	applied	\N	\N	\N	\N	129921	129921	129922
26503	42199	2	applied	\N	\N	\N	\N	129923	129923	129924
26508	42210	0	applied	\N	\N	\N	\N	129952	129952	129953
26467	42047	18	applied	\N	\N	\N	\N	129404	129404	129405
26467	42048	19	applied	\N	\N	\N	\N	129406	129406	129407
26467	42053	20	applied	\N	\N	\N	\N	129421	129421	129422
26467	42057	21	applied	\N	\N	\N	\N	129432	129432	129433
26467	42060	22	applied	\N	\N	\N	\N	129442	129442	129443
26467	42061	23	applied	\N	\N	\N	\N	129444	129444	129445
26467	42066	24	applied	\N	\N	\N	\N	129459	129459	129460
26467	42070	25	applied	\N	\N	\N	\N	129473	129473	129474
26467	42073	26	applied	\N	\N	\N	\N	129482	129482	129483
26467	42075	27	applied	\N	\N	\N	\N	129487	129487	129488
26467	42079	28	applied	\N	\N	\N	\N	129528	129528	129529
26467	42082	29	applied	\N	\N	\N	\N	129536	129536	129537
26467	42083	30	applied	\N	\N	\N	\N	129538	129538	129539
26467	42089	31	applied	\N	\N	\N	\N	129576	129576	129577
26467	42092	32	applied	\N	\N	\N	\N	129585	129585	129586
26467	42093	33	applied	\N	\N	\N	\N	129587	129587	129588
26467	42101	34	applied	\N	\N	\N	\N	129607	129607	129608
26467	41986	35	applied	\N	\N	\N	\N	129239	129239	129240
26467	41997	36	applied	\N	\N	\N	\N	129269	129269	129552
26467	41999	37	applied	\N	\N	1000000000	\N	129273	129273	129274
26467	42000	38	applied	\N	\N	1000000000	\N	129275	129275	129276
26467	41987	39	applied	\N	\N	\N	\N	129241	129241	129617
26467	41990	40	applied	\N	\N	\N	\N	129251	129251	129244
26467	42015	41	applied	\N	\N	\N	\N	129313	129313	129314
26467	41988	42	applied	\N	\N	\N	\N	129243	129243	129618
26467	42013	43	applied	\N	\N	\N	\N	129305	129305	129619
26467	42021	44	applied	\N	\N	\N	\N	129325	129325	129254
26467	42035	45	applied	\N	\N	\N	\N	129370	129370	129270
26467	42045	46	applied	\N	\N	\N	\N	129395	129395	129620
26467	42055	47	applied	\N	\N	\N	\N	129425	129425	129554
26467	42068	48	applied	\N	\N	\N	\N	129463	129463	129272
26467	42077	49	applied	\N	\N	\N	\N	129491	129491	129495
26467	42087	50	applied	\N	\N	\N	\N	129546	129546	129496
26467	42099	51	applied	\N	\N	\N	\N	129602	129602	129278
26467	41991	52	applied	\N	\N	\N	\N	129253	129253	129280
26467	41998	53	applied	\N	\N	\N	\N	129271	129271	129282
26467	42001	54	applied	\N	\N	\N	\N	129277	129277	129284
26467	42002	55	applied	\N	\N	\N	\N	129279	129279	129621
26467	42003	56	applied	\N	\N	\N	\N	129281	129281	129290
26467	42004	57	applied	\N	\N	\N	\N	129283	129283	129622
26467	42012	58	applied	\N	\N	\N	\N	129303	129303	129302
26467	42022	59	applied	\N	\N	\N	\N	129327	129327	129304
26467	42023	60	applied	\N	\N	\N	\N	129329	129329	129316
26467	42026	61	applied	\N	\N	\N	\N	129337	129337	129623
26467	42028	62	applied	\N	\N	\N	\N	129350	129350	129624
26467	42032	63	applied	\N	\N	\N	\N	129360	129360	129625
26467	42036	64	applied	\N	\N	\N	\N	129372	129372	129626
26467	42039	65	applied	\N	\N	\N	\N	129380	129380	129627
26467	42042	66	applied	\N	\N	\N	\N	129389	129389	129628
26467	42043	67	applied	\N	\N	\N	\N	129391	129391	129353
26467	42051	68	applied	\N	\N	\N	\N	129412	129412	129629
26467	42052	69	applied	\N	\N	\N	\N	129414	129414	129630
26467	42054	70	applied	\N	\N	\N	\N	129423	129423	129564
26467	42059	71	applied	\N	\N	\N	\N	129436	129436	129565
26467	42064	72	applied	\N	\N	\N	\N	129450	129450	129567
26467	42065	73	applied	\N	\N	\N	\N	129452	129452	129569
26467	42069	74	applied	\N	\N	\N	\N	129465	129465	129631
26467	42072	75	applied	\N	\N	\N	\N	129477	129477	129394
26467	42074	76	applied	\N	\N	\N	\N	129484	129484	129398
26467	42076	77	applied	\N	\N	\N	\N	129489	129489	129511
26467	42081	78	applied	\N	\N	\N	\N	129532	129532	129632
26467	42086	80	applied	\N	\N	\N	\N	129544	129544	129513
26467	42088	81	applied	\N	\N	\N	\N	129548	129548	129634
26467	42091	82	applied	\N	\N	\N	\N	129580	129580	129516
26467	42094	83	applied	\N	\N	\N	\N	129589	129589	129435
26467	42095	84	applied	\N	\N	\N	\N	129591	129591	129437
26467	42098	85	applied	\N	\N	\N	\N	129600	129600	129635
26467	42102	86	applied	\N	\N	\N	\N	129609	129609	129519
26467	42005	87	applied	\N	\N	\N	\N	129285	129285	129520
26467	42006	88	applied	\N	\N	\N	\N	129287	129287	129453
26467	42007	89	applied	\N	\N	\N	\N	129289	129289	129462
26467	42008	90	applied	\N	\N	\N	\N	129291	129291	129471
26467	42009	91	applied	\N	\N	\N	\N	129293	129293	129466
26467	42011	92	applied	\N	\N	\N	\N	129301	129301	129476
26467	42016	93	applied	\N	\N	\N	\N	129315	129315	129521
26467	42019	94	applied	\N	\N	\N	\N	129321	129321	129522
26467	42020	95	applied	\N	\N	\N	\N	129323	129323	129485
26467	42025	96	applied	\N	\N	\N	\N	129335	129335	129523
26467	42029	97	applied	\N	\N	\N	\N	129352	129352	129492
26467	42031	98	applied	\N	\N	\N	\N	129358	129358	129494
26467	42034	99	applied	\N	\N	\N	\N	129368	129368	129531
26467	42038	100	applied	\N	\N	\N	\N	129378	129378	129636
26467	42044	101	applied	\N	\N	\N	\N	129393	129393	129637
26467	42046	102	applied	\N	\N	\N	\N	129397	129397	129638
26467	42049	103	applied	\N	\N	\N	\N	129408	129408	129639
26467	42050	104	applied	\N	\N	\N	\N	129410	129410	129545
26467	42056	105	applied	\N	\N	\N	\N	129427	129427	129640
26467	42058	106	applied	\N	\N	\N	\N	129434	129434	129549
26467	42062	107	applied	\N	\N	\N	\N	129446	129446	129579
26467	42063	108	applied	\N	\N	\N	\N	129448	129448	129641
26467	42067	109	applied	\N	\N	\N	\N	129461	129461	129642
26467	42071	110	applied	\N	\N	\N	\N	129475	129475	129590
26467	42078	111	applied	\N	\N	\N	\N	129493	129493	129643
26467	42080	112	applied	\N	\N	\N	\N	129530	129530	129644
26467	42084	113	applied	\N	\N	\N	\N	129540	129540	129645
26467	42085	114	applied	\N	\N	\N	\N	129542	129542	129646
26467	42090	115	applied	\N	\N	\N	\N	129578	129578	129601
26467	42096	116	applied	\N	\N	\N	\N	129593	129593	129647
26467	42097	117	applied	\N	\N	\N	\N	129595	129595	129648
26467	42100	118	applied	\N	\N	\N	\N	129604	129604	129610
26467	42103	119	applied	\N	\N	\N	\N	129611	129611	129612
26470	42104	0	applied	\N	\N	\N	\N	129674	129674	129675
26470	42105	1	applied	\N	\N	\N	\N	129676	129676	129677
26470	42106	2	applied	\N	\N	\N	\N	129678	129678	129679
26470	42107	3	applied	\N	\N	\N	\N	129680	129680	129681
26470	42108	4	applied	\N	\N	\N	\N	129682	129682	129683
26470	42109	5	applied	\N	\N	\N	\N	129684	129684	129685
26470	42110	6	applied	\N	\N	\N	\N	129686	129686	129687
26470	42111	7	applied	\N	\N	\N	\N	129688	129688	129689
26472	42112	0	applied	\N	\N	\N	\N	129693	129693	129694
26472	42113	1	applied	\N	\N	\N	\N	129695	129695	129696
26472	42114	2	applied	\N	\N	\N	\N	129697	129697	129698
26474	42122	0	applied	\N	\N	\N	\N	129714	129714	129715
26474	42123	1	applied	\N	\N	1000000000	\N	129716	129716	129717
26474	42124	2	applied	\N	\N	\N	\N	129718	129718	129719
26474	42125	3	applied	\N	\N	\N	\N	129720	129720	129721
26474	42126	4	applied	\N	\N	1000000000	\N	129722	129722	129723
26474	42127	5	applied	\N	\N	\N	\N	129724	129724	129725
26475	42122	0	applied	\N	\N	\N	\N	129714	129714	129715
26468	41885	99	failed	Amount_insufficient_to_create_account	\N	\N	\N	129658	129658	\N
26468	41842	100	applied	\N	\N	\N	\N	128808	128808	128819
26468	41846	101	applied	\N	\N	\N	\N	128818	128818	129659
26468	42015	102	applied	\N	\N	\N	\N	129313	129313	129314
26468	41852	103	applied	\N	\N	\N	\N	128836	128836	128823
26468	41858	104	applied	\N	\N	\N	\N	128854	128854	129660
26468	41868	105	applied	\N	\N	\N	\N	128876	128876	129661
26468	41875	106	applied	\N	\N	\N	\N	128894	128894	128825
26468	41886	107	applied	\N	\N	\N	\N	128923	128923	129662
26468	41897	108	applied	\N	\N	\N	\N	128951	128951	129663
26468	41909	109	applied	\N	\N	\N	\N	128983	128983	128835
26468	41881	110	applied	\N	\N	1000000000	\N	128911	128911	128912
26468	41884	111	applied	\N	\N	1000000000	\N	128919	128919	128920
26468	41896	112	applied	\N	\N	1000000000	\N	128949	128949	128950
26468	41999	113	applied	\N	\N	1000000000	\N	129273	129273	129274
26468	42000	114	applied	\N	\N	1000000000	\N	129275	129275	129276
26468	41922	115	applied	\N	\N	\N	\N	129020	129020	128837
26468	41935	116	applied	\N	\N	\N	\N	129050	129050	129664
26468	41940	117	applied	\N	\N	\N	\N	129115	129115	129665
26468	41958	118	applied	\N	\N	\N	\N	129155	129155	128843
26468	41848	119	applied	\N	\N	\N	\N	128822	128822	128849
26468	41849	120	applied	\N	\N	\N	\N	128824	128824	129666
26468	41851	121	applied	\N	\N	\N	\N	128834	128834	129667
26468	41854	122	applied	\N	\N	\N	\N	128842	128842	129668
26468	41856	123	applied	\N	\N	\N	\N	128848	128848	129669
26468	41859	124	applied	\N	\N	\N	\N	128856	128856	129670
26468	41861	125	applied	\N	\N	\N	\N	128861	128861	129671
26476	42122	0	applied	\N	\N	\N	\N	129714	129714	129715
26476	42123	1	applied	\N	\N	1000000000	\N	129716	129716	129717
26476	42124	2	applied	\N	\N	\N	\N	129718	129718	129719
26476	42125	3	applied	\N	\N	\N	\N	129720	129720	129721
26476	42126	4	applied	\N	\N	1000000000	\N	129722	129722	129723
26476	42127	5	applied	\N	\N	\N	\N	129724	129724	129725
26477	42128	0	applied	\N	\N	\N	\N	129730	129730	129731
26477	42129	1	applied	\N	\N	\N	\N	129732	129732	129733
26477	42130	2	applied	\N	\N	1000000000	\N	129734	129734	129735
26477	42131	4	applied	\N	\N	\N	\N	129737	129737	129738
26485	42141	0	applied	\N	\N	\N	\N	129762	129762	129763
26485	42142	1	applied	\N	\N	\N	\N	129764	129764	129765
26485	42143	2	applied	\N	\N	\N	\N	129766	129766	129767
26486	42144	0	applied	\N	\N	\N	\N	129774	129774	129775
26486	42145	1	applied	\N	\N	\N	\N	129776	129776	129777
26486	42146	2	applied	\N	\N	\N	\N	129778	129778	129779
26489	42154	0	applied	\N	\N	\N	\N	129799	129799	129800
26489	42155	1	applied	\N	\N	\N	\N	129801	129801	129802
26489	42156	2	applied	\N	\N	\N	\N	129803	129803	129804
26489	42157	3	applied	\N	\N	\N	\N	129805	129805	129806
26489	42158	4	applied	\N	\N	\N	\N	129807	129807	129808
26489	42159	5	applied	\N	\N	\N	\N	129809	129809	129810
26489	42160	6	applied	\N	\N	\N	\N	129811	129811	129812
26494	41980	0	applied	\N	\N	\N	\N	129222	129222	129223
26494	41985	1	applied	\N	\N	\N	\N	129237	129237	129238
26494	41989	2	applied	\N	\N	\N	\N	129249	129249	129250
26494	41992	3	applied	\N	\N	\N	\N	129259	129259	129260
26494	41993	4	applied	\N	\N	\N	\N	129261	129261	129262
26494	41994	5	applied	\N	\N	\N	\N	129263	129263	129264
26494	41995	6	applied	\N	\N	\N	\N	129265	129265	129266
26494	41996	7	applied	\N	\N	\N	\N	129267	129267	129268
26494	42010	8	applied	\N	\N	\N	\N	129299	129299	129300
26494	42014	9	applied	\N	\N	\N	\N	129311	129311	129312
26494	42017	10	applied	\N	\N	\N	\N	129317	129317	129318
26494	42018	11	applied	\N	\N	\N	\N	129319	129319	129320
26494	42024	12	applied	\N	\N	\N	\N	129333	129333	129334
26494	42027	13	applied	\N	\N	\N	\N	129348	129348	129349
26494	42030	14	applied	\N	\N	\N	\N	129356	129356	129357
26494	42033	15	applied	\N	\N	\N	\N	129366	129366	129367
26494	42037	16	applied	\N	\N	\N	\N	129376	129376	129377
26494	42040	17	applied	\N	\N	\N	\N	129384	129384	129385
26494	42041	18	applied	\N	\N	\N	\N	129386	129386	129387
26494	42047	19	applied	\N	\N	\N	\N	129404	129404	129405
26494	42048	20	applied	\N	\N	\N	\N	129406	129406	129407
26494	42053	21	applied	\N	\N	\N	\N	129421	129421	129422
26494	42057	22	applied	\N	\N	\N	\N	129432	129432	129433
26494	42060	23	applied	\N	\N	\N	\N	129442	129442	129443
26494	42061	24	applied	\N	\N	\N	\N	129444	129444	129445
26494	42066	25	applied	\N	\N	\N	\N	129459	129459	129460
26494	42070	26	applied	\N	\N	\N	\N	129473	129473	129474
26494	42073	27	applied	\N	\N	\N	\N	129482	129482	129483
26494	42075	28	applied	\N	\N	\N	\N	129487	129487	129488
26494	42079	29	applied	\N	\N	\N	\N	129528	129528	129529
26494	42082	30	applied	\N	\N	\N	\N	129536	129536	129537
26494	42083	31	applied	\N	\N	\N	\N	129538	129538	129539
26494	42089	32	applied	\N	\N	\N	\N	129576	129576	129577
26494	42092	33	applied	\N	\N	\N	\N	129585	129585	129586
26494	42093	34	applied	\N	\N	\N	\N	129587	129587	129588
26494	42101	35	applied	\N	\N	\N	\N	129607	129607	129608
26494	42104	36	applied	\N	\N	\N	\N	129674	129674	129675
26494	42105	37	applied	\N	\N	\N	\N	129676	129676	129677
26494	42112	38	applied	\N	\N	\N	\N	129693	129693	129694
26494	42115	39	applied	\N	\N	\N	\N	129699	129699	129700
26494	42116	40	applied	\N	\N	\N	\N	129701	129701	129702
26494	42122	41	applied	\N	\N	\N	\N	129714	129714	129715
26494	42128	42	applied	\N	\N	\N	\N	129730	129730	129731
26494	42132	43	applied	\N	\N	\N	\N	129741	129741	129742
26494	42136	44	applied	\N	\N	\N	\N	129749	129749	129750
26494	42141	45	applied	\N	\N	\N	\N	129762	129762	129763
26494	42144	46	applied	\N	\N	\N	\N	129774	129774	129775
26494	42147	47	applied	\N	\N	\N	\N	129782	129782	129783
26494	42151	48	applied	\N	\N	\N	\N	129792	129792	129793
26494	42154	49	applied	\N	\N	\N	\N	129799	129799	129800
26494	42155	50	applied	\N	\N	\N	\N	129801	129801	129802
26494	42161	51	applied	\N	\N	\N	\N	129817	129817	129834
26494	42164	52	applied	\N	\N	\N	\N	129825	129825	129835
26494	42167	53	applied	\N	\N	\N	\N	129836	129836	129837
26494	42168	54	applied	\N	\N	\N	\N	129838	129838	129839
26494	41981	55	applied	\N	\N	\N	\N	129224	129224	129225
26494	41982	56	applied	\N	\N	\N	\N	129226	129226	129227
26494	41986	57	applied	\N	\N	\N	\N	129239	129239	129840
26494	41997	58	applied	\N	\N	\N	\N	129269	129269	129229
26494	41999	59	applied	\N	\N	1000000000	\N	129273	129273	129274
26494	42000	60	applied	\N	\N	1000000000	\N	129275	129275	129276
26494	42123	61	applied	\N	\N	1000000000	\N	129716	129716	129717
26494	42126	62	applied	\N	\N	1000000000	\N	129722	129722	129723
26494	42130	63	applied	\N	\N	1000000000	\N	129734	129734	129735
26494	41983	64	applied	\N	\N	\N	\N	129228	129228	129231
26494	41984	65	applied	\N	\N	\N	\N	129230	129230	129552
26494	41987	66	applied	\N	\N	\N	\N	129241	129241	129617
26494	41990	67	applied	\N	\N	\N	\N	129251	129251	129244
26475	42123	1	applied	\N	\N	1000000000	\N	129716	129716	129717
26475	42124	2	applied	\N	\N	\N	\N	129718	129718	129719
26475	42125	3	applied	\N	\N	\N	\N	129720	129720	129721
26475	42126	4	applied	\N	\N	1000000000	\N	129722	129722	129723
26475	42127	5	applied	\N	\N	\N	\N	129724	129724	129725
26484	42141	0	applied	\N	\N	\N	\N	129762	129762	129763
26484	42142	1	applied	\N	\N	\N	\N	129764	129764	129765
26484	42143	2	applied	\N	\N	\N	\N	129766	129766	129767
26488	42151	0	applied	\N	\N	\N	\N	129792	129792	129793
26488	42152	1	applied	\N	\N	\N	\N	129794	129794	129795
26488	42153	2	applied	\N	\N	\N	\N	129796	129796	129797
26491	42161	0	applied	\N	\N	\N	\N	129817	129817	129818
26491	42162	1	applied	\N	\N	\N	\N	129819	129819	129820
26491	42163	2	applied	\N	\N	\N	\N	129821	129821	129822
26496	42177	0	applied	\N	\N	\N	\N	129866	129866	129867
26496	42178	1	applied	\N	\N	\N	\N	129868	129868	129869
26496	42179	2	applied	\N	\N	\N	\N	129870	129870	129871
26504	42200	0	applied	\N	\N	\N	\N	129926	129926	129927
26504	42201	1	applied	\N	\N	\N	\N	129928	129928	129929
26504	42202	2	applied	\N	\N	\N	\N	129930	129930	129931
26506	42203	0	applied	\N	\N	\N	\N	129936	129936	129937
26506	42204	1	applied	\N	\N	\N	\N	129938	129938	129939
26506	42205	2	applied	\N	\N	\N	\N	129940	129940	129941
26506	42206	3	applied	\N	\N	\N	\N	129942	129942	129943
26514	42230	0	applied	\N	\N	\N	\N	130062	130062	130063
26514	42231	1	applied	\N	\N	\N	\N	130064	130064	130065
26514	42232	2	applied	\N	\N	\N	\N	130066	130066	130067
26517	42233	0	applied	\N	\N	\N	\N	130069	130069	130070
26517	42234	1	applied	\N	\N	\N	\N	130071	130071	130072
26517	42235	2	applied	\N	\N	\N	\N	130073	130073	130074
26522	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26522	42241	1	applied	\N	\N	\N	\N	130092	130092	130093
26522	42242	2	applied	\N	\N	\N	\N	130094	130094	130095
26525	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26525	42241	1	applied	\N	\N	\N	\N	130092	130092	130093
26525	42242	2	applied	\N	\N	\N	\N	130094	130094	130095
26530	42253	0	applied	\N	\N	\N	\N	130134	130134	130135
26530	42254	1	applied	\N	\N	\N	\N	130136	130136	130137
26530	42255	2	applied	\N	\N	\N	\N	130138	130138	130139
26533	42260	0	applied	\N	\N	\N	\N	130151	130151	130152
26533	42261	1	applied	\N	\N	\N	\N	130153	130153	130154
26533	42262	2	applied	\N	\N	\N	\N	130155	130155	130156
26533	42263	3	applied	\N	\N	\N	\N	130157	130157	130158
26533	42264	4	applied	\N	\N	\N	\N	130159	130159	130160
26533	42265	5	applied	\N	\N	\N	\N	130161	130161	130162
26533	42266	6	applied	\N	\N	\N	\N	130163	130163	130164
26533	42267	7	applied	\N	\N	\N	\N	130165	130165	130166
26533	42268	8	applied	\N	\N	\N	\N	130167	130167	130168
26538	42269	0	applied	\N	\N	\N	\N	130174	130174	130175
26538	42270	1	applied	\N	\N	\N	\N	130176	130176	130177
26538	42271	2	applied	\N	\N	\N	\N	130178	130178	130179
26538	42274	3	applied	\N	\N	\N	\N	130186	130186	130187
26538	42275	4	applied	\N	\N	\N	\N	130188	130188	130189
26538	42272	5	applied	\N	\N	\N	\N	130180	130180	130190
26538	42273	6	applied	\N	\N	\N	\N	130182	130182	130191
26540	42280	0	applied	\N	\N	\N	\N	130202	130202	130203
26540	42281	1	applied	\N	\N	\N	\N	130204	130204	130205
26540	42282	2	applied	\N	\N	\N	\N	130206	130206	130207
26540	42283	3	applied	\N	\N	\N	\N	130208	130208	130209
26540	42284	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	130210	130210	\N
26540	42285	5	applied	\N	\N	\N	\N	130211	130211	130212
26540	42286	6	applied	\N	\N	\N	\N	130213	130213	130214
26540	42287	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	130215	130215	\N
26540	42288	8	applied	\N	\N	\N	\N	130216	130216	130217
26543	42296	0	applied	\N	\N	\N	\N	130236	130236	130237
26543	42297	1	applied	\N	\N	\N	\N	130238	130238	130239
26553	42320	0	applied	\N	\N	\N	\N	130298	130298	130299
26553	42321	1	applied	\N	\N	\N	\N	130300	130300	130301
26553	42322	2	applied	\N	\N	\N	\N	130302	130302	130303
26553	42323	3	applied	\N	\N	\N	\N	130304	130304	130305
26553	42324	4	applied	\N	\N	\N	\N	130306	130306	130307
26553	42325	5	applied	\N	\N	\N	\N	130308	130308	130309
26553	42326	6	applied	\N	\N	\N	\N	130310	130310	130311
26558	42336	0	applied	\N	\N	\N	\N	130336	130336	130337
26558	42337	1	applied	\N	\N	\N	\N	130338	130338	130339
26558	42338	2	applied	\N	\N	\N	\N	130340	130340	130341
26558	42339	3	applied	\N	\N	\N	\N	130342	130342	130343
26567	42353	0	applied	\N	\N	\N	\N	130432	130432	130433
26567	42354	1	applied	\N	\N	\N	\N	130434	130434	130435
26567	42355	2	applied	\N	\N	\N	\N	130436	130436	130437
26568	42353	0	applied	\N	\N	\N	\N	130432	130432	130433
26568	42354	1	applied	\N	\N	\N	\N	130434	130434	130435
26568	42355	2	applied	\N	\N	\N	\N	130436	130436	130437
26570	42356	0	applied	\N	\N	\N	\N	130443	130443	130444
26570	42357	1	applied	\N	\N	\N	\N	130445	130445	130446
26570	42358	2	applied	\N	\N	\N	\N	130447	130447	130448
26570	42359	3	applied	\N	\N	\N	\N	130449	130449	130450
26570	42360	4	applied	\N	\N	\N	\N	130451	130451	130452
26570	42361	5	applied	\N	\N	\N	\N	130453	130453	130454
26570	42362	6	applied	\N	\N	\N	\N	130455	130455	130456
26572	42363	0	applied	\N	\N	\N	\N	130460	130460	130461
26572	42364	1	applied	\N	\N	\N	\N	130462	130462	128922
26572	42365	2	applied	\N	\N	\N	\N	130463	130463	130464
26572	42366	3	applied	\N	\N	\N	\N	130465	130465	130466
26575	42367	0	applied	\N	\N	\N	\N	130470	130470	130471
26575	42368	1	applied	\N	\N	\N	\N	130472	130472	130473
26575	42369	2	applied	\N	\N	\N	\N	130474	130474	130475
26580	42364	0	applied	\N	\N	\N	\N	130462	130462	128922
26580	42123	1	applied	\N	\N	1000000000	\N	129716	129716	129717
26580	42373	2	applied	\N	\N	\N	\N	130483	130483	130484
26580	42126	3	applied	\N	\N	1000000000	\N	129722	129722	129723
26580	42130	4	applied	\N	\N	1000000000	\N	129734	129734	129735
26580	42374	5	applied	\N	\N	\N	\N	130485	130485	130486
26583	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26583	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26583	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26583	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26583	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26583	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26583	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26585	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26585	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26585	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26585	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26585	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26585	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26585	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26587	42399	0	applied	\N	\N	\N	\N	130552	130552	130553
26494	42015	68	applied	\N	\N	\N	\N	129313	129313	129314
26494	41988	69	applied	\N	\N	\N	\N	129243	129243	129618
26494	42013	70	applied	\N	\N	\N	\N	129305	129305	129619
26494	42021	71	applied	\N	\N	\N	\N	129325	129325	129254
26494	42035	72	applied	\N	\N	\N	\N	129370	129370	129270
26494	42045	73	applied	\N	\N	\N	\N	129395	129395	129620
26494	42055	74	applied	\N	\N	\N	\N	129425	129425	129554
26494	42068	75	applied	\N	\N	\N	\N	129463	129463	129272
26494	42077	76	applied	\N	\N	\N	\N	129491	129491	129495
26494	42087	77	applied	\N	\N	\N	\N	129546	129546	129496
26494	42099	78	applied	\N	\N	\N	\N	129602	129602	129278
26494	42108	79	applied	\N	\N	\N	\N	129682	129682	129497
26494	42121	80	applied	\N	\N	\N	\N	129711	129711	129498
26494	42137	81	applied	\N	\N	\N	\N	129751	129751	129280
26494	42149	82	applied	\N	\N	\N	\N	129786	129786	129499
26494	42156	83	applied	\N	\N	\N	\N	129803	129803	129555
26494	42169	84	applied	\N	\N	\N	\N	129841	129841	129282
26494	41991	85	applied	\N	\N	\N	\N	129253	129253	129284
26494	41998	86	applied	\N	\N	\N	\N	129271	129271	129621
26494	42001	87	applied	\N	\N	\N	\N	129277	129277	129290
26494	42002	88	applied	\N	\N	\N	\N	129279	129279	129622
26494	42003	89	applied	\N	\N	\N	\N	129281	129281	129302
26494	42004	90	applied	\N	\N	\N	\N	129283	129283	129304
26494	42012	91	applied	\N	\N	\N	\N	129303	129303	129316
26494	42022	92	applied	\N	\N	\N	\N	129327	129327	129623
26494	42023	93	applied	\N	\N	\N	\N	129329	129329	129624
26494	42026	94	applied	\N	\N	\N	\N	129337	129337	129625
26494	42028	95	applied	\N	\N	\N	\N	129350	129350	129626
26494	42032	97	applied	\N	\N	\N	\N	129360	129360	129627
26494	42036	98	applied	\N	\N	\N	\N	129372	129372	129628
26494	42039	99	applied	\N	\N	\N	\N	129380	129380	129353
26494	42042	100	applied	\N	\N	\N	\N	129389	129389	129629
26494	42043	101	applied	\N	\N	\N	\N	129391	129391	129630
26494	42051	102	applied	\N	\N	\N	\N	129412	129412	129564
26494	42052	103	applied	\N	\N	\N	\N	129414	129414	129565
26494	42054	104	applied	\N	\N	\N	\N	129423	129423	129567
26494	42059	105	applied	\N	\N	\N	\N	129436	129436	129569
26494	42064	106	applied	\N	\N	\N	\N	129450	129450	129631
26494	42065	107	applied	\N	\N	\N	\N	129452	129452	129394
26494	42069	108	applied	\N	\N	\N	\N	129465	129465	129398
26494	42072	109	applied	\N	\N	\N	\N	129477	129477	129511
26494	42074	110	applied	\N	\N	\N	\N	129484	129484	129632
26494	42076	111	applied	\N	\N	\N	\N	129489	129489	129513
26494	42081	112	applied	\N	\N	\N	\N	129532	129532	129634
26494	42086	113	applied	\N	\N	\N	\N	129544	129544	129516
26494	42088	114	applied	\N	\N	\N	\N	129548	129548	129435
26494	42091	115	applied	\N	\N	\N	\N	129580	129580	129437
26494	42094	116	applied	\N	\N	\N	\N	129589	129589	129635
26494	42095	117	applied	\N	\N	\N	\N	129591	129591	129519
26494	42098	118	applied	\N	\N	\N	\N	129600	129600	129843
26494	42102	119	applied	\N	\N	\N	\N	129609	129609	129462
26494	42110	120	applied	\N	\N	\N	\N	129686	129686	129844
26494	42111	121	applied	\N	\N	\N	\N	129688	129688	129476
26494	42113	122	applied	\N	\N	\N	\N	129695	129695	129478
26494	42118	123	applied	\N	\N	\N	\N	129705	129705	129485
26494	42120	124	applied	\N	\N	\N	\N	129709	129709	129490
26494	42125	125	applied	\N	\N	\N	\N	129720	129720	129494
26499	42180	0	applied	\N	\N	\N	\N	129878	129878	129879
26499	42181	1	applied	\N	\N	\N	\N	129880	129880	129881
26499	42182	2	applied	\N	\N	\N	\N	129882	129882	129883
26499	42183	3	applied	\N	\N	\N	\N	129884	129884	129885
26499	42184	4	applied	\N	\N	\N	\N	129886	129886	129887
26499	42185	5	applied	\N	\N	\N	\N	129888	129888	129889
26499	42186	6	applied	\N	\N	\N	\N	129890	129890	129891
26502	42190	0	applied	\N	\N	\N	\N	129902	129902	129903
26502	42191	1	applied	\N	\N	\N	\N	129904	129904	129905
26502	42192	2	applied	\N	\N	\N	\N	129906	129906	129907
26502	42193	3	applied	\N	\N	\N	\N	129908	129908	129909
26502	42194	4	applied	\N	\N	\N	\N	129910	129910	129911
26502	42195	5	applied	\N	\N	\N	\N	129912	129912	129913
26502	42196	6	applied	\N	\N	\N	\N	129914	129914	129915
26507	42207	0	applied	\N	\N	\N	\N	129946	129946	129947
26507	42208	1	applied	\N	\N	\N	\N	129948	129948	129949
26507	42209	2	applied	\N	\N	\N	\N	129950	129950	129951
26509	42170	0	applied	\N	\N	\N	\N	129849	129849	129960
26509	42177	1	applied	\N	\N	\N	\N	129866	129866	129961
26509	42180	2	applied	\N	\N	\N	\N	129878	129878	129962
26509	42181	3	applied	\N	\N	\N	\N	129880	129880	129963
26509	42187	4	applied	\N	\N	\N	\N	129894	129894	129964
26509	42190	5	applied	\N	\N	\N	\N	129902	129902	129965
26509	42191	6	applied	\N	\N	\N	\N	129904	129904	129966
26509	42197	7	applied	\N	\N	\N	\N	129919	129919	129967
26509	42200	8	applied	\N	\N	\N	\N	129926	129926	129968
26509	42203	9	applied	\N	\N	\N	\N	129936	129936	129969
26509	42207	10	applied	\N	\N	\N	\N	129946	129946	129970
26509	42210	11	applied	\N	\N	\N	\N	129952	129952	129971
26509	42129	12	applied	\N	\N	\N	\N	129732	129732	129972
26509	42133	13	applied	\N	\N	\N	\N	129743	129743	129637
26509	42139	14	applied	\N	\N	\N	\N	129755	129755	129543
26509	42143	15	applied	\N	\N	\N	\N	129766	129766	129545
26509	42145	16	applied	\N	\N	\N	\N	129776	129776	129973
26509	42186	17	applied	\N	\N	\N	\N	129890	129890	129549
26509	42192	18	applied	\N	\N	\N	\N	129906	129906	129974
26509	42204	19	applied	\N	\N	\N	\N	129938	129938	129579
26509	42150	20	applied	\N	\N	\N	\N	129788	129788	129581
26509	42153	21	applied	\N	\N	\N	\N	129796	129796	129590
26509	42157	22	applied	\N	\N	\N	\N	129805	129805	129592
26509	42158	23	applied	\N	\N	\N	\N	129807	129807	129645
26509	42163	24	applied	\N	\N	\N	\N	129821	129821	129975
26509	42165	25	applied	\N	\N	\N	\N	129827	129827	129647
26509	42171	26	applied	\N	\N	\N	\N	129852	129852	129976
26509	42172	27	applied	\N	\N	\N	\N	129854	129854	129612
26509	42173	28	applied	\N	\N	\N	\N	129856	129856	129683
26509	42179	29	applied	\N	\N	\N	\N	129870	129870	129977
26509	42182	30	applied	\N	\N	\N	\N	129882	129882	129978
26509	42183	31	applied	\N	\N	\N	\N	129884	129884	129979
26509	42188	32	applied	\N	\N	\N	\N	129896	129896	129980
26509	42193	33	applied	\N	\N	\N	\N	129908	129908	129704
26509	42194	34	applied	\N	\N	\N	\N	129910	129910	129706
26509	42198	35	applied	\N	\N	\N	\N	129921	129921	129981
26509	42202	36	applied	\N	\N	\N	\N	129930	129930	129712
26509	42206	37	applied	\N	\N	\N	\N	129942	129942	129721
26509	42209	38	applied	\N	\N	\N	\N	129950	129950	129982
26509	42212	39	applied	\N	\N	\N	\N	129956	129956	129983
26509	42005	40	applied	\N	\N	\N	\N	129285	129285	129984
26509	42006	41	applied	\N	\N	\N	\N	129287	129287	129744
26509	42007	42	applied	\N	\N	\N	\N	129289	129289	129747
26509	42008	43	applied	\N	\N	\N	\N	129291	129291	129985
26509	42009	44	applied	\N	\N	\N	\N	129293	129293	129756
26509	42011	45	applied	\N	\N	\N	\N	129301	129301	129758
26508	42211	1	applied	\N	\N	\N	\N	129954	129954	129955
26508	42212	2	applied	\N	\N	\N	\N	129956	129956	129957
26513	42223	0	applied	\N	\N	\N	\N	130044	130044	130045
26513	42227	1	applied	\N	\N	\N	\N	130053	130053	130054
26513	42224	2	applied	\N	\N	\N	\N	130046	130046	130047
26513	42225	3	applied	\N	\N	\N	\N	130048	130048	130049
26513	42228	4	applied	\N	\N	\N	\N	130055	130055	130056
26513	42226	5	applied	\N	\N	\N	\N	130050	130050	130057
26513	42229	6	applied	\N	\N	\N	\N	130058	130058	130059
26516	42233	0	applied	\N	\N	\N	\N	130069	130069	130070
26516	42234	1	applied	\N	\N	\N	\N	130071	130071	130072
26516	42235	2	applied	\N	\N	\N	\N	130073	130073	130074
26521	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26521	42242	1	applied	\N	\N	\N	\N	130094	130094	130098
26527	42246	0	applied	\N	\N	\N	\N	130114	130114	130115
26527	42247	1	applied	\N	\N	\N	\N	130116	130116	130117
26527	42248	2	applied	\N	\N	\N	\N	130118	130118	130119
26527	42249	3	applied	\N	\N	\N	\N	130120	130120	130121
26536	42260	0	applied	\N	\N	\N	\N	130151	130151	130152
26536	42261	1	applied	\N	\N	\N	\N	130153	130153	130154
26536	42262	2	applied	\N	\N	\N	\N	130155	130155	130156
26536	42263	3	applied	\N	\N	\N	\N	130157	130157	130158
26536	42264	4	applied	\N	\N	\N	\N	130159	130159	130160
26536	42265	5	applied	\N	\N	\N	\N	130161	130161	130162
26536	42266	6	applied	\N	\N	\N	\N	130163	130163	130164
26536	42267	7	applied	\N	\N	\N	\N	130165	130165	130166
26536	42268	8	applied	\N	\N	\N	\N	130167	130167	130168
26537	42269	0	applied	\N	\N	\N	\N	130174	130174	130175
26537	42270	1	applied	\N	\N	\N	\N	130176	130176	130177
26537	42271	2	applied	\N	\N	\N	\N	130178	130178	130179
26537	42272	3	applied	\N	\N	\N	\N	130180	130180	130181
26537	42273	4	applied	\N	\N	\N	\N	130182	130182	130183
26539	42276	0	applied	\N	\N	\N	\N	130194	130194	130195
26539	42277	1	applied	\N	\N	\N	\N	130196	130196	130197
26539	42278	2	applied	\N	\N	\N	\N	130198	130198	130199
26539	42279	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	130200	130200	\N
26545	42296	0	applied	\N	\N	\N	\N	130236	130236	130237
26545	42297	1	applied	\N	\N	\N	\N	130238	130238	130239
26548	42308	0	applied	\N	\N	\N	\N	130267	130267	130268
26548	42309	2	applied	\N	\N	\N	\N	130270	130270	130271
26548	42310	3	applied	\N	\N	\N	\N	130272	130272	130273
26550	42313	0	applied	\N	\N	\N	\N	130281	130281	130282
26550	42314	1	applied	\N	\N	\N	\N	130283	130283	130284
26550	42315	2	applied	\N	\N	\N	\N	130285	130285	130286
26550	42316	3	applied	\N	\N	\N	\N	130287	130287	130288
26556	42333	0	applied	\N	\N	\N	\N	130326	130326	130327
26556	42334	1	applied	\N	\N	\N	\N	130328	130328	130329
26556	42335	2	applied	\N	\N	\N	\N	130330	130330	130331
26562	42343	0	applied	\N	\N	\N	\N	130357	130357	130358
26562	42344	1	applied	\N	\N	\N	\N	130359	130359	130360
26562	42345	2	applied	\N	\N	\N	\N	130361	130361	130362
26564	42079	0	applied	\N	\N	\N	\N	129528	129528	129529
26564	42082	1	applied	\N	\N	\N	\N	129536	129536	129537
26564	42083	2	applied	\N	\N	\N	\N	129538	129538	129539
26564	42089	3	applied	\N	\N	\N	\N	129576	129576	129577
26564	42092	4	applied	\N	\N	\N	\N	129585	129585	129586
26564	42093	5	applied	\N	\N	\N	\N	129587	129587	129588
26564	42101	6	applied	\N	\N	\N	\N	129607	129607	129608
26564	42104	7	applied	\N	\N	\N	\N	129674	129674	129675
26564	42105	8	applied	\N	\N	\N	\N	129676	129676	129677
26564	42112	9	applied	\N	\N	\N	\N	129693	129693	129694
26564	42115	10	applied	\N	\N	\N	\N	129699	129699	129700
26564	42116	11	applied	\N	\N	\N	\N	129701	129701	129702
26564	42122	12	applied	\N	\N	\N	\N	129714	129714	129715
26564	42128	13	applied	\N	\N	\N	\N	129730	129730	129731
26564	42132	14	applied	\N	\N	\N	\N	129741	129741	129742
26564	42136	15	applied	\N	\N	\N	\N	129749	129749	129750
26564	42141	16	applied	\N	\N	\N	\N	129762	129762	129763
26564	42144	17	applied	\N	\N	\N	\N	129774	129774	129775
26564	42147	18	applied	\N	\N	\N	\N	129782	129782	129783
26564	42151	19	applied	\N	\N	\N	\N	129792	129792	129793
26564	42154	20	applied	\N	\N	\N	\N	129799	129799	129800
26564	42155	21	applied	\N	\N	\N	\N	129801	129801	129802
26564	42161	22	applied	\N	\N	\N	\N	129817	129817	129834
26564	42164	23	applied	\N	\N	\N	\N	129825	129825	129835
26564	42167	24	applied	\N	\N	\N	\N	129836	129836	129837
26564	42168	25	applied	\N	\N	\N	\N	129838	129838	129839
26564	42170	26	applied	\N	\N	\N	\N	129849	129849	129960
26564	42177	27	applied	\N	\N	\N	\N	129866	129866	129961
26564	42180	28	applied	\N	\N	\N	\N	129878	129878	129962
26564	42181	29	applied	\N	\N	\N	\N	129880	129880	129963
26564	42187	30	applied	\N	\N	\N	\N	129894	129894	129964
26564	42190	31	applied	\N	\N	\N	\N	129902	129902	129965
26564	42191	32	applied	\N	\N	\N	\N	129904	129904	129966
26564	42197	33	applied	\N	\N	\N	\N	129919	129919	129967
26564	42200	34	applied	\N	\N	\N	\N	129926	129926	129968
26564	42203	35	applied	\N	\N	\N	\N	129936	129936	129969
26564	42207	36	applied	\N	\N	\N	\N	129946	129946	129970
26564	42210	37	applied	\N	\N	\N	\N	129952	129952	129971
26564	42213	38	applied	\N	\N	\N	\N	130018	130018	130365
26564	42214	39	applied	\N	\N	\N	\N	130020	130020	130366
26564	42215	40	applied	\N	\N	\N	\N	130022	130022	130367
26564	42223	41	applied	\N	\N	\N	\N	130044	130044	130368
26564	42227	42	applied	\N	\N	\N	\N	130053	130053	130369
26564	42230	43	applied	\N	\N	\N	\N	130062	130062	130370
26564	42233	44	applied	\N	\N	\N	\N	130069	130069	130371
26564	42236	45	applied	\N	\N	\N	\N	130081	130081	130372
26564	42240	46	applied	\N	\N	\N	\N	130090	130090	130373
26564	42243	47	applied	\N	\N	\N	\N	130107	130107	130374
26564	42246	48	applied	\N	\N	\N	\N	130114	130114	130375
26564	42250	49	applied	\N	\N	\N	\N	130124	130124	130376
26564	42253	50	applied	\N	\N	\N	\N	130134	130134	130377
26564	42256	51	applied	\N	\N	\N	\N	130142	130142	130378
26564	42260	52	applied	\N	\N	\N	\N	130151	130151	130379
26564	42261	53	applied	\N	\N	\N	\N	130153	130153	130380
26564	42262	54	applied	\N	\N	\N	\N	130155	130155	130381
26564	42269	55	applied	\N	\N	\N	\N	130174	130174	130382
26564	42270	56	applied	\N	\N	\N	\N	130176	130176	130383
26564	42276	57	applied	\N	\N	\N	\N	130194	130194	130384
26564	42280	58	applied	\N	\N	\N	\N	130202	130202	130385
26564	42281	59	applied	\N	\N	\N	\N	130204	130204	130386
26564	42289	60	applied	\N	\N	\N	\N	130220	130220	130387
26564	42290	61	applied	\N	\N	\N	\N	130222	130222	130388
26564	42298	62	applied	\N	\N	\N	\N	130245	130245	130389
26564	42299	63	applied	\N	\N	\N	\N	130247	130247	130390
26564	42300	64	applied	\N	\N	\N	\N	130249	130249	130391
26564	42308	65	applied	\N	\N	\N	\N	130267	130267	130392
26564	42311	66	applied	\N	\N	\N	\N	130276	130276	130393
26564	42313	67	applied	\N	\N	\N	\N	130281	130281	130394
26509	42016	46	applied	\N	\N	\N	\N	129315	129315	129765
26509	42019	47	applied	\N	\N	\N	\N	129321	129321	129986
26509	42020	48	applied	\N	\N	\N	\N	129323	129323	129987
26509	42025	49	applied	\N	\N	\N	\N	129335	129335	129777
26509	42029	50	applied	\N	\N	\N	\N	129352	129352	129779
26509	42031	51	applied	\N	\N	\N	\N	129358	129358	129785
26509	42034	52	applied	\N	\N	\N	\N	129368	129368	129988
26509	42038	53	applied	\N	\N	\N	\N	129378	129378	129789
26509	42044	54	applied	\N	\N	\N	\N	129393	129393	129795
26509	42046	55	applied	\N	\N	\N	\N	129397	129397	129989
26509	42049	56	applied	\N	\N	\N	\N	129408	129408	129804
26509	42050	57	applied	\N	\N	\N	\N	129410	129410	129990
26509	42056	58	applied	\N	\N	\N	\N	129427	129427	129991
26509	42058	59	applied	\N	\N	\N	\N	129434	129434	129808
26509	42062	60	applied	\N	\N	\N	\N	129446	129446	129810
26509	42063	61	applied	\N	\N	\N	\N	129448	129448	129812
26509	42067	62	applied	\N	\N	\N	\N	129461	129461	129820
26509	42071	63	applied	\N	\N	\N	\N	129475	129475	129992
26509	42078	64	applied	\N	\N	\N	\N	129493	129493	129993
26509	42080	65	applied	\N	\N	\N	\N	129530	129530	129828
26509	42084	66	applied	\N	\N	\N	\N	129540	129540	129830
26509	42085	67	applied	\N	\N	\N	\N	129542	129542	129994
26509	42090	68	applied	\N	\N	\N	\N	129578	129578	129853
26509	42096	69	applied	\N	\N	\N	\N	129593	129593	129995
26509	42097	70	applied	\N	\N	\N	\N	129595	129595	129996
26509	42100	71	applied	\N	\N	\N	\N	129604	129604	129857
26509	42103	72	applied	\N	\N	\N	\N	129611	129611	129859
26509	42106	73	applied	\N	\N	\N	\N	129678	129678	129861
26509	42109	74	applied	\N	\N	\N	\N	129684	129684	129863
26509	42114	75	applied	\N	\N	\N	\N	129697	129697	129869
26509	42117	76	applied	\N	\N	\N	\N	129703	129703	129997
26509	42119	77	applied	\N	\N	\N	\N	129707	129707	129998
26509	42127	78	applied	\N	\N	\N	\N	129724	129724	129883
26509	42131	79	applied	\N	\N	\N	\N	129737	129737	129999
26509	42135	80	applied	\N	\N	\N	\N	129746	129746	130000
26509	42140	81	applied	\N	\N	\N	\N	129757	129757	130001
26509	42142	82	applied	\N	\N	\N	\N	129764	129764	129891
26509	42146	83	applied	\N	\N	\N	\N	129778	129778	130002
26509	42148	84	applied	\N	\N	\N	\N	129784	129784	130003
26509	42152	85	applied	\N	\N	\N	\N	129794	129794	129907
26509	42159	86	applied	\N	\N	\N	\N	129809	129809	130004
26509	42160	87	applied	\N	\N	\N	\N	129811	129811	130005
26509	42162	88	applied	\N	\N	\N	\N	129819	129819	129911
26509	42166	89	applied	\N	\N	\N	\N	129829	129829	129913
26509	42174	90	applied	\N	\N	\N	\N	129858	129858	129915
26509	42175	91	applied	\N	\N	\N	\N	129860	129860	130006
26509	42176	92	applied	\N	\N	\N	\N	129862	129862	130007
26509	42178	93	applied	\N	\N	\N	\N	129868	129868	130008
26509	42184	94	applied	\N	\N	\N	\N	129886	129886	130009
26509	42185	95	applied	\N	\N	\N	\N	129888	129888	129931
26509	42189	97	applied	\N	\N	\N	\N	129898	129898	130011
26509	42195	98	applied	\N	\N	\N	\N	129912	129912	130012
26509	42196	99	applied	\N	\N	\N	\N	129914	129914	129943
26509	42199	100	applied	\N	\N	\N	\N	129923	129923	129949
26509	42201	101	applied	\N	\N	\N	\N	129928	129928	130013
26509	42205	102	applied	\N	\N	\N	\N	129940	129940	130014
26509	42208	103	applied	\N	\N	\N	\N	129948	129948	130015
26509	42211	104	applied	\N	\N	\N	\N	129954	129954	129957
26510	42213	0	applied	\N	\N	\N	\N	130018	130018	130019
26510	42214	1	applied	\N	\N	\N	\N	130020	130020	130021
26510	42215	2	applied	\N	\N	\N	\N	130022	130022	130023
26510	42216	3	applied	\N	\N	\N	\N	130024	130024	130025
26510	42217	4	applied	\N	\N	\N	\N	130026	130026	130027
26510	42218	6	applied	\N	\N	\N	\N	130029	130029	130030
26510	42219	7	applied	\N	\N	\N	\N	130031	130031	130032
26510	42220	8	applied	\N	\N	\N	\N	130033	130033	130034
26510	42221	9	applied	\N	\N	\N	\N	130035	130035	130036
26510	42222	10	applied	\N	\N	\N	\N	130037	130037	130038
26512	42223	0	applied	\N	\N	\N	\N	130044	130044	130045
26512	42224	1	applied	\N	\N	\N	\N	130046	130046	130047
26512	42225	2	applied	\N	\N	\N	\N	130048	130048	130049
26512	42226	3	applied	\N	\N	\N	\N	130050	130050	130051
26515	42230	0	applied	\N	\N	\N	\N	130062	130062	130063
26515	42231	1	applied	\N	\N	\N	\N	130064	130064	130065
26515	42232	2	applied	\N	\N	\N	\N	130066	130066	130067
26518	42233	0	applied	\N	\N	\N	\N	130069	130069	130070
26518	42234	1	applied	\N	\N	\N	\N	130071	130071	130072
26518	42235	2	applied	\N	\N	\N	\N	130073	130073	130074
26519	42236	0	applied	\N	\N	\N	\N	130081	130081	130082
26519	42237	1	applied	\N	\N	\N	\N	130083	130083	130084
26519	42238	2	applied	\N	\N	\N	\N	130085	130085	130086
26519	42239	3	applied	\N	\N	\N	\N	130087	130087	130088
26523	42240	0	applied	\N	\N	\N	\N	130090	130090	130091
26523	42241	1	applied	\N	\N	\N	\N	130092	130092	130093
26523	42242	2	applied	\N	\N	\N	\N	130094	130094	130095
26528	42250	0	applied	\N	\N	\N	\N	130124	130124	130125
26528	42251	1	applied	\N	\N	\N	\N	130126	130126	130127
26528	42252	2	applied	\N	\N	\N	\N	130128	130128	130129
26534	42260	0	applied	\N	\N	\N	\N	130151	130151	130152
26534	42261	1	applied	\N	\N	\N	\N	130153	130153	130154
26534	42262	2	applied	\N	\N	\N	\N	130155	130155	130156
26534	42263	3	applied	\N	\N	\N	\N	130157	130157	130158
26534	42264	4	applied	\N	\N	\N	\N	130159	130159	130160
26534	42265	5	applied	\N	\N	\N	\N	130161	130161	130162
26534	42266	6	applied	\N	\N	\N	\N	130163	130163	130164
26534	42267	7	applied	\N	\N	\N	\N	130165	130165	130166
26534	42268	8	applied	\N	\N	\N	\N	130167	130167	130168
26541	42289	0	applied	\N	\N	\N	\N	130220	130220	130221
26541	42290	1	applied	\N	\N	\N	\N	130222	130222	130223
26541	42291	2	applied	\N	\N	\N	\N	130224	130224	130225
26541	42292	3	applied	\N	\N	\N	\N	130226	130226	130227
26541	42293	4	applied	\N	\N	\N	\N	130228	130228	130229
26541	42294	5	applied	\N	\N	\N	\N	130230	130230	130231
26541	42295	6	applied	\N	\N	\N	\N	130232	130232	130233
26544	42296	0	applied	\N	\N	\N	\N	130236	130236	130237
26544	42297	1	applied	\N	\N	\N	\N	130238	130238	130239
26546	42298	0	applied	\N	\N	\N	\N	130245	130245	130246
26546	42299	1	applied	\N	\N	\N	\N	130247	130247	130248
26546	42300	2	applied	\N	\N	\N	\N	130249	130249	130250
26546	42301	3	applied	\N	\N	\N	\N	130251	130251	130252
26546	42302	4	applied	\N	\N	\N	\N	130253	130253	130254
26546	42303	5	applied	\N	\N	\N	\N	130255	130255	130256
26546	42304	6	applied	\N	\N	\N	\N	130257	130257	130258
26546	42305	7	applied	\N	\N	\N	\N	130259	130259	130260
26546	42306	8	applied	\N	\N	\N	\N	130261	130261	130262
26546	42307	9	applied	\N	\N	\N	\N	130263	130263	130264
26551	42317	0	applied	\N	\N	\N	\N	130290	130290	130291
26551	42318	1	applied	\N	\N	\N	\N	130292	130292	130293
26551	42319	2	applied	\N	\N	\N	\N	130294	130294	130295
26554	42327	0	applied	\N	\N	\N	\N	130313	130313	130314
26554	42328	1	applied	\N	\N	\N	\N	130315	130315	130316
26554	42329	2	applied	\N	\N	\N	\N	130317	130317	130318
26554	42330	3	applied	\N	\N	\N	\N	130319	130319	130320
26554	42331	4	applied	\N	\N	\N	\N	130321	130321	130322
26554	42332	5	applied	\N	\N	\N	\N	130323	130323	130324
26557	42333	0	applied	\N	\N	\N	\N	130326	130326	130327
26557	42334	1	applied	\N	\N	\N	\N	130328	130328	130329
26557	42335	2	applied	\N	\N	\N	\N	130330	130330	130331
26559	42336	0	applied	\N	\N	\N	\N	130336	130336	130337
26559	42337	1	applied	\N	\N	\N	\N	130338	130338	130339
26559	42338	2	applied	\N	\N	\N	\N	130340	130340	130341
26559	42339	3	applied	\N	\N	\N	\N	130342	130342	130343
26561	42340	0	applied	\N	\N	\N	\N	130350	130350	130351
26561	42341	1	applied	\N	\N	\N	\N	130352	130352	130353
26561	42342	2	applied	\N	\N	\N	\N	130354	130354	130355
26563	42343	0	applied	\N	\N	\N	\N	130357	130357	130358
26563	42344	1	applied	\N	\N	\N	\N	130359	130359	130360
26563	42345	2	applied	\N	\N	\N	\N	130361	130361	130362
26565	42346	0	applied	\N	\N	\N	\N	130415	130415	130416
26565	42347	1	applied	\N	\N	\N	\N	130417	130417	130418
26565	42348	2	applied	\N	\N	\N	\N	130419	130419	130420
26569	42353	0	applied	\N	\N	\N	\N	130432	130432	130433
26569	42354	1	applied	\N	\N	\N	\N	130434	130434	130435
26569	42355	2	applied	\N	\N	\N	\N	130436	130436	130437
26571	42356	0	applied	\N	\N	\N	\N	130443	130443	130444
26571	42357	1	applied	\N	\N	\N	\N	130445	130445	130446
26571	42358	2	applied	\N	\N	\N	\N	130447	130447	130448
26571	42359	3	applied	\N	\N	\N	\N	130449	130449	130450
26571	42360	4	applied	\N	\N	\N	\N	130451	130451	130452
26571	42361	5	applied	\N	\N	\N	\N	130453	130453	130454
26571	42362	6	applied	\N	\N	\N	\N	130455	130455	130456
26573	42363	0	applied	\N	\N	\N	\N	130460	130460	130461
26573	42364	1	applied	\N	\N	\N	\N	130462	130462	128922
26573	42365	2	applied	\N	\N	\N	\N	130463	130463	130464
26573	42366	3	applied	\N	\N	\N	\N	130465	130465	130466
26578	42382	0	applied	\N	\N	\N	\N	130503	130503	130504
26578	42383	1	applied	\N	\N	\N	\N	130505	130505	130506
26578	42384	2	applied	\N	\N	\N	\N	130507	130507	130508
26578	42385	3	applied	\N	\N	\N	\N	130509	130509	130510
26581	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26581	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26581	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26581	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26581	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26581	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26581	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26588	42399	0	applied	\N	\N	\N	\N	130552	130552	130553
26588	42400	1	applied	\N	\N	\N	\N	130554	130554	130555
26588	42401	2	applied	\N	\N	\N	\N	130556	130556	130557
26588	42402	3	applied	\N	\N	\N	\N	130558	130558	130559
26588	42403	4	applied	\N	\N	\N	\N	130560	130560	130561
26588	42404	5	applied	\N	\N	\N	\N	130562	130562	130563
26593	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26593	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26593	42421	2	applied	\N	\N	\N	\N	130604	130604	130605
26593	42422	3	applied	\N	\N	\N	\N	130606	130606	130607
26599	42425	0	applied	\N	\N	\N	\N	130621	130621	130622
26599	42426	1	applied	\N	\N	\N	\N	130623	130623	130624
26599	42427	2	applied	\N	\N	\N	\N	130625	130625	130626
26599	42428	3	applied	\N	\N	\N	\N	130627	130627	130628
26602	42429	0	applied	\N	\N	\N	\N	130631	130631	130632
26602	42430	1	applied	\N	\N	\N	\N	130633	130633	130634
26602	42431	2	applied	\N	\N	\N	\N	130635	130635	130636
26602	42432	3	applied	\N	\N	\N	\N	130637	130637	130638
26602	42433	4	applied	\N	\N	\N	\N	130639	130639	130640
26605	42447	0	applied	\N	\N	\N	\N	130673	130673	130674
26605	42448	1	applied	\N	\N	\N	\N	130675	130675	130676
26605	42449	2	applied	\N	\N	\N	\N	130677	130677	130678
26605	42450	3	applied	\N	\N	\N	\N	130679	130679	130680
26607	42451	0	applied	\N	\N	\N	\N	130686	130686	130687
26607	42448	1	applied	\N	\N	\N	\N	130675	130675	130680
26607	42452	2	applied	\N	\N	\N	\N	130688	130688	130689
26612	42456	0	applied	\N	\N	\N	\N	130705	130705	130706
26612	42457	1	applied	\N	\N	\N	\N	130707	130707	130708
26612	42458	2	applied	\N	\N	\N	\N	130709	130709	130710
26612	42459	3	applied	\N	\N	\N	\N	130711	130711	130712
26612	42460	4	applied	\N	\N	\N	\N	130713	130713	130714
26612	42461	5	applied	\N	\N	\N	\N	130715	130715	130716
26619	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26619	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26619	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26619	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26619	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26619	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26619	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26619	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26620	42472	0	applied	\N	\N	\N	\N	130747	130747	130748
26620	42473	1	applied	\N	\N	\N	\N	130749	130749	130750
26620	42474	2	applied	\N	\N	\N	\N	130751	130751	130752
26620	42475	3	applied	\N	\N	\N	\N	130753	130753	130754
26620	42476	4	applied	\N	\N	\N	\N	130755	130755	130756
26620	42477	5	applied	\N	\N	\N	\N	130757	130757	130758
26620	42478	6	applied	\N	\N	1000000000	\N	130759	130759	130760
26620	42479	7	applied	\N	\N	\N	\N	130761	130761	130762
26620	42480	8	applied	\N	\N	\N	\N	130763	130763	130764
26620	42481	9	applied	\N	\N	\N	\N	130765	130765	130766
26620	42482	10	applied	\N	\N	\N	\N	130767	130767	130768
26620	42483	11	applied	\N	\N	\N	\N	130769	130769	130770
26620	42484	12	applied	\N	\N	1000000000	\N	130771	130771	130772
26620	42485	13	applied	\N	\N	1000000000	\N	130773	130773	130774
26620	42486	14	applied	\N	\N	1000000000	\N	130775	130775	130776
26620	42487	15	applied	\N	\N	1000000000	\N	130777	130777	130778
26620	42488	16	applied	\N	\N	\N	\N	130779	130779	130780
26620	42489	17	applied	\N	\N	\N	\N	130781	130781	130782
26620	42490	18	applied	\N	\N	\N	\N	130783	130783	130784
26620	42491	19	applied	\N	\N	\N	\N	130785	130785	130786
26620	42492	20	applied	\N	\N	\N	\N	130787	130787	130788
26620	42493	22	applied	\N	\N	\N	\N	130790	130790	130791
26622	42472	0	applied	\N	\N	\N	\N	130747	130747	130748
26622	42473	1	applied	\N	\N	\N	\N	130749	130749	130750
26622	42474	2	applied	\N	\N	\N	\N	130751	130751	130752
26622	42475	3	applied	\N	\N	\N	\N	130753	130753	130754
26622	42476	4	applied	\N	\N	\N	\N	130755	130755	130756
26622	42477	5	applied	\N	\N	\N	\N	130757	130757	130758
26622	42478	6	applied	\N	\N	1000000000	\N	130759	130759	130760
26622	42479	7	applied	\N	\N	\N	\N	130761	130761	130762
26622	42480	8	applied	\N	\N	\N	\N	130763	130763	130764
26622	42481	9	applied	\N	\N	\N	\N	130765	130765	130766
26622	42482	10	applied	\N	\N	\N	\N	130767	130767	130768
26560	42339	3	applied	\N	\N	\N	\N	130342	130342	130343
26566	42349	0	applied	\N	\N	\N	\N	130422	130422	130423
26566	42350	1	applied	\N	\N	\N	\N	130424	130424	130425
26566	42351	2	applied	\N	\N	\N	\N	130426	130426	130427
26566	42352	3	applied	\N	\N	\N	\N	130428	130428	130429
26576	42370	0	applied	\N	\N	\N	\N	130477	130477	130478
26576	42371	1	applied	\N	\N	\N	\N	130479	130479	130480
26576	42372	2	applied	\N	\N	\N	\N	130481	130481	130482
26576	42373	3	applied	\N	\N	\N	\N	130483	130483	130484
26576	42374	4	applied	\N	\N	\N	\N	130485	130485	130486
26576	42375	5	applied	\N	\N	\N	\N	130487	130487	130488
26576	42376	6	applied	\N	\N	\N	\N	130489	130489	130490
26576	42377	7	applied	\N	\N	\N	\N	130491	130491	130492
26576	42378	8	applied	\N	\N	\N	\N	130493	130493	130494
26576	42379	9	applied	\N	\N	\N	\N	130495	130495	130496
26576	42380	10	applied	\N	\N	\N	\N	130497	130497	130498
26576	42381	11	applied	\N	\N	\N	\N	130499	130499	130500
26579	42386	0	applied	\N	\N	\N	\N	130512	130512	130513
26579	42387	1	applied	\N	\N	\N	\N	130514	130514	130515
26579	42388	2	applied	\N	\N	\N	\N	130516	130516	130517
26579	42389	3	applied	\N	\N	\N	\N	130518	130518	130519
26579	42390	4	applied	\N	\N	\N	\N	130520	130520	130521
26579	42391	5	applied	\N	\N	\N	\N	130522	130522	130523
26584	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26584	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26584	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26584	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26584	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26584	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26584	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26586	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26586	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26586	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26586	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26586	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26586	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26586	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26590	42405	0	applied	\N	\N	\N	\N	130569	130569	130570
26590	42406	1	applied	\N	\N	\N	\N	130571	130571	130572
26590	42407	2	applied	\N	\N	\N	\N	130573	130573	130574
26590	42408	3	applied	\N	\N	\N	\N	130575	130575	130576
26594	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26594	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26594	42423	2	applied	\N	\N	\N	\N	130610	130610	130611
26594	42421	3	applied	\N	\N	\N	\N	130604	130604	130612
26594	42422	4	applied	\N	\N	\N	\N	130606	130606	130613
26594	42424	5	applied	\N	\N	\N	\N	130614	130614	130615
26597	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26597	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26597	42423	2	applied	\N	\N	\N	\N	130610	130610	130611
26597	42421	3	applied	\N	\N	\N	\N	130604	130604	130612
26597	42422	4	applied	\N	\N	\N	\N	130606	130606	130613
26597	42424	5	applied	\N	\N	\N	\N	130614	130614	130615
26600	42425	0	applied	\N	\N	\N	\N	130621	130621	130622
26600	42426	1	applied	\N	\N	\N	\N	130623	130623	130624
26600	42427	2	applied	\N	\N	\N	\N	130625	130625	130626
26600	42428	3	applied	\N	\N	\N	\N	130627	130627	130628
26608	42453	0	applied	\N	\N	\N	\N	130691	130691	130692
26608	42454	1	applied	\N	\N	\N	\N	130693	130693	130694
26608	42455	2	applied	\N	\N	\N	\N	130695	130695	130696
26611	42453	0	applied	\N	\N	\N	\N	130691	130691	130692
26611	42454	1	applied	\N	\N	\N	\N	130693	130693	130694
26611	42455	2	applied	\N	\N	\N	\N	130695	130695	130696
26616	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26616	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26616	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26616	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26616	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26616	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26616	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26616	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26621	42472	0	applied	\N	\N	\N	\N	130747	130747	130748
26621	42473	1	applied	\N	\N	\N	\N	130749	130749	130750
26621	42474	2	applied	\N	\N	\N	\N	130751	130751	130752
26621	42475	3	applied	\N	\N	\N	\N	130753	130753	130754
26621	42476	4	applied	\N	\N	\N	\N	130755	130755	130756
26621	42477	5	applied	\N	\N	\N	\N	130757	130757	130758
26621	42478	6	applied	\N	\N	1000000000	\N	130759	130759	130760
26621	42479	7	applied	\N	\N	\N	\N	130761	130761	130762
26621	42480	8	applied	\N	\N	\N	\N	130763	130763	130764
26621	42481	9	applied	\N	\N	\N	\N	130765	130765	130766
26621	42482	10	applied	\N	\N	\N	\N	130767	130767	130768
26621	42483	11	applied	\N	\N	\N	\N	130769	130769	130770
26621	42484	12	applied	\N	\N	1000000000	\N	130771	130771	130772
26621	42485	13	applied	\N	\N	1000000000	\N	130773	130773	130774
26621	42486	14	applied	\N	\N	1000000000	\N	130775	130775	130776
26621	42487	15	applied	\N	\N	1000000000	\N	130777	130777	130778
26621	42488	16	applied	\N	\N	\N	\N	130779	130779	130780
26621	42489	17	applied	\N	\N	\N	\N	130781	130781	130782
26621	42490	18	applied	\N	\N	\N	\N	130783	130783	130784
26621	42491	19	applied	\N	\N	\N	\N	130785	130785	130786
26621	42492	20	applied	\N	\N	\N	\N	130787	130787	130788
26621	42493	22	applied	\N	\N	\N	\N	130790	130790	130791
26623	42494	0	applied	\N	\N	\N	\N	130800	130800	130801
26623	42495	1	applied	\N	\N	\N	\N	130802	130802	130803
26623	42496	2	applied	\N	\N	\N	\N	130804	130804	130805
26625	42497	0	applied	\N	\N	\N	\N	130808	130808	130809
26625	42498	1	applied	\N	\N	\N	\N	130810	130810	130811
26625	42499	2	applied	\N	\N	\N	\N	130812	130812	130813
26629	42503	0	applied	\N	\N	\N	\N	130824	130824	130825
26629	42504	1	applied	\N	\N	\N	\N	130826	130826	130827
26629	42505	2	applied	\N	\N	\N	\N	130828	130828	130829
26629	42506	3	applied	\N	\N	\N	\N	130830	130830	130831
26629	42507	4	applied	\N	\N	\N	\N	130832	130832	130833
26629	42508	5	applied	\N	\N	\N	\N	130834	130834	130835
26629	42509	6	applied	\N	\N	\N	\N	130836	130836	130837
26630	42510	0	applied	\N	\N	\N	\N	130844	130844	130845
26630	42511	1	applied	\N	\N	1000000000	\N	130846	130846	130847
26630	42512	2	applied	\N	\N	\N	\N	130848	130848	130849
26630	42513	3	applied	\N	\N	\N	\N	130850	130850	130851
26635	42523	0	applied	\N	\N	\N	\N	130877	130877	130878
26635	42524	1	applied	\N	\N	\N	\N	130879	130879	130880
26635	42525	2	applied	\N	\N	\N	\N	130881	130881	130882
26635	42526	3	applied	\N	\N	\N	\N	130883	130883	130884
26638	42523	0	applied	\N	\N	\N	\N	130877	130877	130878
26638	42524	1	applied	\N	\N	\N	\N	130879	130879	130880
26638	42525	2	applied	\N	\N	\N	\N	130881	130881	130882
26638	42526	3	applied	\N	\N	\N	\N	130883	130883	130884
26640	42527	0	applied	\N	\N	\N	\N	130890	130890	130891
26564	42317	68	applied	\N	\N	\N	\N	130290	130290	130395
26564	42320	69	applied	\N	\N	\N	\N	130298	130298	130396
26564	42321	70	applied	\N	\N	\N	\N	130300	130300	130397
26564	42327	71	applied	\N	\N	\N	\N	130313	130313	130398
26564	42328	72	applied	\N	\N	\N	\N	130315	130315	130399
26564	42333	73	applied	\N	\N	\N	\N	130326	130326	130400
26564	42336	74	applied	\N	\N	\N	\N	130336	130336	130401
26564	42340	75	applied	\N	\N	\N	\N	130350	130350	130402
26564	42123	76	applied	\N	\N	1000000000	\N	129716	129716	129717
26564	42126	77	applied	\N	\N	1000000000	\N	129722	129722	129723
26564	42130	78	applied	\N	\N	1000000000	\N	129734	129734	129735
26564	42080	79	applied	\N	\N	\N	\N	129530	129530	129531
26564	42084	80	applied	\N	\N	\N	\N	129540	129540	129636
26564	42085	81	applied	\N	\N	\N	\N	129542	129542	129637
26564	42090	82	applied	\N	\N	\N	\N	129578	129578	129638
26564	42087	83	applied	\N	\N	\N	\N	129546	129546	129543
26564	42099	84	applied	\N	\N	\N	\N	129602	129602	129639
26564	42108	85	applied	\N	\N	\N	\N	129682	129682	130403
26564	42121	86	applied	\N	\N	\N	\N	129711	129711	129545
26564	42137	87	applied	\N	\N	\N	\N	129751	129751	129547
26564	42149	88	applied	\N	\N	\N	\N	129786	129786	129640
26564	42156	89	applied	\N	\N	\N	\N	129803	129803	129973
26564	42169	90	applied	\N	\N	\N	\N	129841	129841	129549
26564	42186	91	applied	\N	\N	\N	\N	129890	129890	129974
26564	42192	92	applied	\N	\N	\N	\N	129906	129906	129579
26564	42204	93	applied	\N	\N	\N	\N	129938	129938	130404
26564	42219	94	applied	\N	\N	\N	\N	130031	130031	129641
26564	42225	95	applied	\N	\N	\N	\N	130048	130048	129581
26564	42238	96	applied	\N	\N	\N	\N	130085	130085	129642
26564	42247	97	applied	\N	\N	\N	\N	130116	130116	130405
26564	42259	98	applied	\N	\N	\N	\N	130148	130148	129590
26564	42271	99	applied	\N	\N	\N	\N	130178	130178	130406
26564	42288	100	applied	\N	\N	\N	\N	130216	130216	129643
26564	42096	101	applied	\N	\N	\N	\N	129593	129593	129644
26564	42097	102	applied	\N	\N	\N	\N	129595	129595	129645
26564	42100	103	applied	\N	\N	\N	\N	129604	129604	129646
26564	42103	104	applied	\N	\N	\N	\N	129611	129611	129601
26564	42106	105	applied	\N	\N	\N	\N	129678	129678	129647
26564	42109	107	applied	\N	\N	\N	\N	129684	129684	129648
26564	42114	108	applied	\N	\N	\N	\N	129697	129697	129610
26564	42117	109	applied	\N	\N	\N	\N	129703	129703	129612
26564	42119	110	applied	\N	\N	\N	\N	129707	129707	129679
26564	42127	111	applied	\N	\N	\N	\N	129724	129724	130408
26564	42131	112	applied	\N	\N	\N	\N	129737	129737	129977
26564	42135	113	applied	\N	\N	\N	\N	129746	129746	129687
26564	42140	114	applied	\N	\N	\N	\N	129757	129757	130409
26564	42142	115	applied	\N	\N	\N	\N	129764	129764	129979
26564	42146	116	applied	\N	\N	\N	\N	129778	129778	129696
26564	42148	117	applied	\N	\N	\N	\N	129784	129784	129698
26564	42152	118	applied	\N	\N	\N	\N	129794	129794	129704
26564	42159	119	applied	\N	\N	\N	\N	129809	129809	130410
26564	42160	120	applied	\N	\N	\N	\N	129811	129811	130411
26564	42162	121	applied	\N	\N	\N	\N	129819	129819	129981
26564	42166	122	applied	\N	\N	\N	\N	129829	129829	129710
26564	42174	123	applied	\N	\N	\N	\N	129858	129858	130412
26564	42175	124	applied	\N	\N	\N	\N	129860	129860	129721
26564	42176	125	applied	\N	\N	\N	\N	129862	129862	129725
26577	42370	0	applied	\N	\N	\N	\N	130477	130477	130478
26577	42371	1	applied	\N	\N	\N	\N	130479	130479	130480
26577	42372	2	applied	\N	\N	\N	\N	130481	130481	130482
26577	42373	3	applied	\N	\N	\N	\N	130483	130483	130484
26577	42374	4	applied	\N	\N	\N	\N	130485	130485	130486
26577	42375	5	applied	\N	\N	\N	\N	130487	130487	130488
26577	42376	6	applied	\N	\N	\N	\N	130489	130489	130490
26577	42377	7	applied	\N	\N	\N	\N	130491	130491	130492
26577	42378	8	applied	\N	\N	\N	\N	130493	130493	130494
26577	42379	9	applied	\N	\N	\N	\N	130495	130495	130496
26577	42380	10	applied	\N	\N	\N	\N	130497	130497	130498
26577	42381	11	applied	\N	\N	\N	\N	130499	130499	130500
26582	42392	0	applied	\N	\N	\N	\N	130527	130527	130528
26582	42393	1	applied	\N	\N	\N	\N	130529	130529	130530
26582	42394	2	applied	\N	\N	\N	\N	130531	130531	130532
26582	42395	3	applied	\N	\N	\N	\N	130533	130533	130534
26582	42396	4	applied	\N	\N	\N	\N	130535	130535	130536
26582	42397	5	applied	\N	\N	\N	\N	130537	130537	130538
26582	42398	7	applied	\N	\N	\N	\N	130540	130540	130541
26591	42409	0	applied	\N	\N	\N	\N	130578	130578	130579
26591	42410	1	applied	\N	\N	\N	\N	130580	130580	130581
26591	42411	2	applied	\N	\N	\N	\N	130582	130582	130583
26591	42412	3	applied	\N	\N	\N	\N	130584	130584	130585
26591	42413	4	applied	\N	\N	\N	\N	130586	130586	130587
26591	42414	5	applied	\N	\N	\N	\N	130588	130588	130589
26595	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26595	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26595	42423	2	applied	\N	\N	\N	\N	130610	130610	130611
26595	42421	3	applied	\N	\N	\N	\N	130604	130604	130612
26595	42422	4	applied	\N	\N	\N	\N	130606	130606	130613
26595	42424	5	applied	\N	\N	\N	\N	130614	130614	130615
26598	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26598	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26598	42423	2	applied	\N	\N	\N	\N	130610	130610	130611
26598	42421	3	applied	\N	\N	\N	\N	130604	130604	130612
26598	42422	4	applied	\N	\N	\N	\N	130606	130606	130613
26598	42424	5	applied	\N	\N	\N	\N	130614	130614	130615
26603	42434	0	applied	\N	\N	\N	\N	130644	130644	130645
26603	42435	1	applied	\N	\N	\N	\N	130646	130646	130647
26603	42436	2	applied	\N	\N	\N	\N	130648	130648	130649
26606	42447	0	applied	\N	\N	\N	\N	130673	130673	130674
26606	42449	1	applied	\N	\N	\N	\N	130677	130677	130683
26606	42450	2	applied	\N	\N	\N	\N	130679	130679	130684
26609	42453	0	applied	\N	\N	\N	\N	130691	130691	130692
26609	42454	1	applied	\N	\N	\N	\N	130693	130693	130694
26609	42455	2	applied	\N	\N	\N	\N	130695	130695	130696
26613	42462	0	applied	\N	\N	\N	\N	130718	130718	130719
26613	42463	1	applied	\N	\N	\N	\N	130720	130720	130721
26614	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26614	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26614	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26614	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26614	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26614	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26614	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26614	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26617	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26617	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26617	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26617	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26617	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26617	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26587	42400	1	applied	\N	\N	\N	\N	130554	130554	130555
26587	42401	2	applied	\N	\N	\N	\N	130556	130556	130557
26587	42402	3	applied	\N	\N	\N	\N	130558	130558	130559
26587	42403	4	applied	\N	\N	\N	\N	130560	130560	130561
26587	42404	5	applied	\N	\N	\N	\N	130562	130562	130563
26589	42399	0	applied	\N	\N	\N	\N	130552	130552	130553
26589	42400	1	applied	\N	\N	\N	\N	130554	130554	130555
26589	42401	2	applied	\N	\N	\N	\N	130556	130556	130557
26589	42402	3	applied	\N	\N	\N	\N	130558	130558	130559
26589	42403	4	applied	\N	\N	\N	\N	130560	130560	130561
26589	42404	5	applied	\N	\N	\N	\N	130562	130562	130563
26592	42415	0	applied	\N	\N	\N	\N	130590	130590	130591
26592	42416	1	applied	\N	\N	\N	\N	130592	130592	130593
26592	42417	2	applied	\N	\N	\N	\N	130594	130594	130595
26592	42418	3	applied	\N	\N	\N	\N	130596	130596	130597
26596	42419	0	applied	\N	\N	\N	\N	130600	130600	130601
26596	42420	1	applied	\N	\N	\N	\N	130602	130602	130603
26596	42423	2	applied	\N	\N	\N	\N	130610	130610	130611
26596	42421	3	applied	\N	\N	\N	\N	130604	130604	130612
26596	42422	4	applied	\N	\N	\N	\N	130606	130606	130613
26596	42424	5	applied	\N	\N	\N	\N	130614	130614	130615
26601	42429	0	applied	\N	\N	\N	\N	130631	130631	130632
26601	42430	1	applied	\N	\N	\N	\N	130633	130633	130634
26601	42431	2	applied	\N	\N	\N	\N	130635	130635	130636
26601	42432	3	applied	\N	\N	\N	\N	130637	130637	130638
26601	42433	4	applied	\N	\N	\N	\N	130639	130639	130640
26604	42437	0	applied	\N	\N	\N	\N	130652	130652	130653
26604	42438	1	applied	\N	\N	\N	\N	130654	130654	130655
26604	42439	2	applied	\N	\N	\N	\N	130656	130656	130657
26604	42440	3	applied	\N	\N	\N	\N	130658	130658	130659
26604	42441	4	applied	\N	\N	\N	\N	130660	130660	130661
26604	42442	5	applied	\N	\N	\N	\N	130662	130662	130663
26604	42443	6	applied	\N	\N	\N	\N	130664	130664	130665
26604	42444	7	applied	\N	\N	\N	\N	130666	130666	130667
26604	42445	8	applied	\N	\N	\N	\N	130668	130668	130669
26604	42446	9	applied	\N	\N	\N	\N	130670	130670	130671
26610	42453	0	applied	\N	\N	\N	\N	130691	130691	130692
26610	42454	1	applied	\N	\N	\N	\N	130693	130693	130694
26610	42455	2	applied	\N	\N	\N	\N	130695	130695	130696
26615	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26615	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26615	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26615	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26615	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26615	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26615	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26615	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26618	42464	0	applied	\N	\N	\N	\N	130724	130724	130725
26618	42465	1	applied	\N	\N	\N	\N	130726	130726	130727
26618	42466	2	applied	\N	\N	\N	\N	130728	130728	130729
26618	42467	3	applied	\N	\N	\N	\N	130730	130730	130731
26618	42468	4	applied	\N	\N	\N	\N	130732	130732	130733
26618	42469	5	applied	\N	\N	\N	\N	130734	130734	130735
26618	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26618	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26624	42494	0	applied	\N	\N	\N	\N	130800	130800	130801
26624	42495	1	applied	\N	\N	\N	\N	130802	130802	130803
26624	42496	2	applied	\N	\N	\N	\N	130804	130804	130805
26627	42503	0	applied	\N	\N	\N	\N	130824	130824	130825
26627	42504	1	applied	\N	\N	\N	\N	130826	130826	130827
26627	42505	2	applied	\N	\N	\N	\N	130828	130828	130829
26627	42506	3	applied	\N	\N	\N	\N	130830	130830	130831
26627	42507	4	applied	\N	\N	\N	\N	130832	130832	130833
26627	42508	5	applied	\N	\N	\N	\N	130834	130834	130835
26627	42509	6	applied	\N	\N	\N	\N	130836	130836	130837
26632	42514	0	applied	\N	\N	\N	\N	130853	130853	130854
26632	42515	1	applied	\N	\N	\N	\N	130855	130855	130856
26632	42516	2	applied	\N	\N	\N	\N	130857	130857	130858
26632	42517	3	applied	\N	\N	\N	\N	130859	130859	130860
26634	42521	0	applied	\N	\N	\N	\N	130872	130872	130873
26634	42522	1	applied	\N	\N	\N	\N	130874	130874	130875
26639	42527	0	applied	\N	\N	\N	\N	130890	130890	130891
26639	42528	1	applied	\N	\N	\N	\N	130892	130892	130893
26639	42529	2	applied	\N	\N	\N	\N	130894	130894	130895
26639	42530	3	applied	\N	\N	\N	\N	130896	130896	130897
26639	42531	4	applied	\N	\N	\N	\N	130898	130898	130899
26639	42532	5	applied	\N	\N	\N	\N	130900	130900	130901
26639	42533	6	applied	\N	\N	\N	\N	130902	130902	130903
26639	42534	7	applied	\N	\N	\N	\N	130904	130904	130905
26639	42535	8	applied	\N	\N	\N	\N	130906	130906	130907
26642	42527	0	applied	\N	\N	\N	\N	130890	130890	130891
26642	42528	1	applied	\N	\N	\N	\N	130892	130892	130893
26642	42529	2	applied	\N	\N	\N	\N	130894	130894	130895
26642	42530	3	applied	\N	\N	\N	\N	130896	130896	130897
26642	42531	4	applied	\N	\N	\N	\N	130898	130898	130899
26642	42532	5	applied	\N	\N	\N	\N	130900	130900	130901
26642	42533	6	applied	\N	\N	\N	\N	130902	130902	130903
26642	42534	7	applied	\N	\N	\N	\N	130904	130904	130905
26642	42535	8	applied	\N	\N	\N	\N	130906	130906	130907
26643	42536	0	applied	\N	\N	\N	\N	130913	130913	130914
26643	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26643	42538	2	applied	\N	\N	\N	\N	130917	130917	130918
26643	42539	3	applied	\N	\N	\N	\N	130919	130919	130920
26646	42542	0	applied	\N	\N	\N	\N	130927	130927	130928
26646	42543	1	applied	\N	\N	\N	\N	130929	130929	130930
26646	42544	2	applied	\N	\N	\N	\N	130931	130931	130932
26646	42545	3	applied	\N	\N	\N	\N	130933	130933	130934
26650	42550	0	applied	\N	\N	\N	\N	130950	130950	130951
26650	42551	1	applied	\N	\N	\N	\N	130952	130952	130953
26650	42552	2	applied	\N	\N	\N	\N	130954	130954	130955
26653	42553	0	applied	\N	\N	\N	\N	131033	131033	131034
26653	42554	1	applied	\N	\N	\N	\N	131035	131035	131036
26653	42555	2	applied	\N	\N	\N	\N	131037	131037	131038
26657	42560	0	applied	\N	\N	\N	\N	131056	131056	131057
26657	42561	1	applied	\N	\N	\N	\N	131058	131058	131059
26657	42562	2	applied	\N	\N	\N	\N	131060	131060	131061
26664	42573	0	applied	\N	\N	\N	\N	131089	131089	131090
26664	42574	1	applied	\N	\N	\N	\N	131091	131091	131092
26664	42575	2	applied	\N	\N	\N	\N	131093	131093	131094
26667	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26667	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26667	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26667	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26667	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26667	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26667	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26670	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26670	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26670	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26670	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26617	42470	6	applied	\N	\N	\N	\N	130736	130736	130737
26617	42471	7	applied	\N	\N	\N	\N	130738	130738	130739
26626	42500	0	applied	\N	\N	\N	\N	130816	130816	130817
26626	42501	1	applied	\N	\N	\N	\N	130818	130818	130819
26626	42502	2	applied	\N	\N	\N	\N	130820	130820	130821
26631	42514	0	applied	\N	\N	\N	\N	130853	130853	130854
26631	42515	1	applied	\N	\N	\N	\N	130855	130855	130856
26631	42516	2	applied	\N	\N	\N	\N	130857	130857	130858
26631	42517	3	applied	\N	\N	\N	\N	130859	130859	130860
26633	42518	0	applied	\N	\N	\N	\N	130864	130864	130865
26633	42519	1	applied	\N	\N	\N	\N	130866	130866	130867
26633	42520	2	applied	\N	\N	\N	\N	130868	130868	130869
26636	42523	0	applied	\N	\N	\N	\N	130877	130877	130878
26636	42524	1	applied	\N	\N	\N	\N	130879	130879	130880
26636	42525	2	applied	\N	\N	\N	\N	130881	130881	130882
26636	42526	3	applied	\N	\N	\N	\N	130883	130883	130884
26641	42527	0	applied	\N	\N	\N	\N	130890	130890	130891
26641	42528	1	applied	\N	\N	\N	\N	130892	130892	130893
26641	42529	2	applied	\N	\N	\N	\N	130894	130894	130895
26641	42530	3	applied	\N	\N	\N	\N	130896	130896	130897
26641	42531	4	applied	\N	\N	\N	\N	130898	130898	130899
26641	42532	5	applied	\N	\N	\N	\N	130900	130900	130901
26641	42533	6	applied	\N	\N	\N	\N	130902	130902	130903
26641	42534	7	applied	\N	\N	\N	\N	130904	130904	130905
26641	42535	8	applied	\N	\N	\N	\N	130906	130906	130907
26648	42546	0	applied	\N	\N	\N	\N	130939	130939	130940
26648	42547	1	applied	\N	\N	\N	\N	130941	130941	130942
26648	42548	2	applied	\N	\N	\N	\N	130943	130943	130944
26648	42549	3	applied	\N	\N	\N	\N	130945	130945	130946
26652	42553	0	applied	\N	\N	\N	\N	131033	131033	131034
26652	42554	1	applied	\N	\N	\N	\N	131035	131035	131036
26652	42555	2	applied	\N	\N	\N	\N	131037	131037	131038
26659	42563	0	applied	\N	\N	\N	\N	131063	131063	131064
26659	42564	1	applied	\N	\N	\N	\N	131065	131065	131066
26662	42566	0	applied	\N	\N	\N	\N	131070	131070	131071
26662	42567	1	applied	\N	\N	\N	\N	131072	131072	131073
26662	42568	2	applied	\N	\N	\N	\N	131074	131074	131075
26662	42565	3	applied	\N	\N	\N	\N	131067	131067	131076
26662	42569	4	applied	\N	\N	\N	\N	131077	131077	131078
26662	42570	5	applied	\N	\N	\N	\N	131079	131079	131080
26662	42571	6	applied	\N	\N	\N	\N	131081	131081	131082
26662	42572	7	applied	\N	\N	\N	\N	131083	131083	131084
26669	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26669	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26669	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26669	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26669	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26669	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26669	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26677	42596	0	applied	\N	\N	\N	\N	131163	131163	131164
26677	42597	1	applied	\N	\N	\N	\N	131165	131165	131166
26677	42598	2	applied	\N	\N	\N	\N	131167	131167	131168
26680	42602	0	applied	\N	\N	\N	\N	131178	131178	131179
26680	42603	1	applied	\N	\N	\N	\N	131180	131180	131181
26680	42604	2	applied	\N	\N	\N	\N	131182	131182	131183
26680	42605	3	applied	\N	\N	\N	\N	131184	131184	131185
26680	42606	4	applied	\N	\N	\N	\N	131186	131186	131187
26680	42607	5	applied	\N	\N	\N	\N	131188	131188	131189
26680	42608	6	applied	\N	\N	\N	\N	131190	131190	131191
26683	42609	0	applied	\N	\N	\N	\N	131201	131201	131202
26683	42610	1	applied	\N	\N	\N	\N	131203	131203	131204
26683	42611	2	applied	\N	\N	\N	\N	131205	131205	131206
26683	42612	3	applied	\N	\N	\N	\N	131207	131207	131208
26683	42613	4	applied	\N	\N	\N	\N	131209	131209	131210
26683	42614	5	applied	\N	\N	\N	\N	131211	131211	131212
26683	42615	6	applied	\N	\N	\N	\N	131213	131213	131214
26683	42616	7	applied	\N	\N	\N	\N	131215	131215	131216
26683	42617	8	applied	\N	\N	\N	\N	131217	131217	131218
26685	42618	0	applied	\N	\N	\N	\N	131222	131222	131223
26685	42619	1	applied	\N	\N	\N	\N	131224	131224	131225
26685	42620	2	applied	\N	\N	\N	\N	131226	131226	131227
26685	42621	3	applied	\N	\N	\N	\N	131228	131228	131229
26685	42622	4	applied	\N	\N	\N	\N	131230	131230	131231
26685	42623	5	applied	\N	\N	1000000000	\N	131232	131232	131233
26685	42624	6	applied	\N	\N	\N	\N	131234	131234	131235
26685	42625	7	applied	\N	\N	\N	\N	131236	131236	131237
26687	42618	0	applied	\N	\N	\N	\N	131222	131222	131223
26687	42619	1	applied	\N	\N	\N	\N	131224	131224	131225
26687	42620	2	applied	\N	\N	\N	\N	131226	131226	131227
26687	42621	3	applied	\N	\N	\N	\N	131228	131228	131229
26687	42622	4	applied	\N	\N	\N	\N	131230	131230	131231
26687	42623	5	applied	\N	\N	1000000000	\N	131232	131232	131233
26687	42624	6	applied	\N	\N	\N	\N	131234	131234	131235
26687	42625	7	applied	\N	\N	\N	\N	131236	131236	131237
26690	42629	0	applied	\N	\N	\N	\N	131252	131252	131253
26690	42630	1	applied	\N	\N	\N	\N	131254	131254	131255
26690	42631	2	applied	\N	\N	\N	\N	131256	131256	131257
26690	42632	3	applied	\N	\N	\N	\N	131258	131258	131259
26690	42633	4	applied	\N	\N	\N	\N	131260	131260	131261
26690	42634	5	applied	\N	\N	\N	\N	131262	131262	131263
26690	42635	6	applied	\N	\N	\N	\N	131264	131264	131265
26690	42636	7	applied	\N	\N	\N	\N	131266	131266	131267
26690	42637	8	applied	\N	\N	\N	\N	131268	131268	131269
26690	42638	9	applied	\N	\N	\N	\N	131270	131270	131271
26705	42669	0	applied	\N	\N	\N	\N	131355	131355	131356
26705	42670	1	applied	\N	\N	\N	\N	131357	131357	131358
26705	42671	2	applied	\N	\N	\N	\N	131359	131359	131360
26705	42672	3	applied	\N	\N	\N	\N	131361	131361	29193
26705	42673	4	applied	\N	\N	\N	\N	131362	131362	131363
26705	42674	5	applied	\N	\N	\N	\N	131364	131364	131365
26705	42675	6	applied	\N	\N	\N	\N	131366	131366	131367
26705	42676	7	applied	\N	\N	\N	\N	131368	131368	131369
26705	42677	8	applied	\N	\N	\N	\N	131370	131370	131371
26705	42678	9	applied	\N	\N	\N	\N	131372	131372	131373
26705	42679	10	applied	\N	\N	\N	\N	131374	131374	131375
26710	42687	0	applied	\N	\N	\N	\N	131430	131430	131431
26710	42688	1	applied	\N	\N	\N	\N	131432	131432	131433
26710	42689	2	applied	\N	\N	\N	\N	131434	131434	131435
26713	42697	0	applied	\N	\N	\N	\N	131452	131452	131453
26713	42698	1	applied	\N	\N	\N	\N	131454	131454	131455
26713	42699	2	applied	\N	\N	\N	\N	131456	131456	131457
26713	42700	3	applied	\N	\N	\N	\N	131458	131458	131459
26713	42701	4	applied	\N	\N	\N	\N	131460	131460	131461
26713	42702	5	applied	\N	\N	\N	\N	131462	131462	131463
26715	42703	0	applied	\N	\N	\N	\N	131467	131467	131468
26715	42704	1	applied	\N	\N	\N	\N	131469	131469	131470
26715	42705	2	applied	\N	\N	\N	\N	131471	131471	131472
26715	42706	3	applied	\N	\N	\N	\N	131473	131473	131474
26720	42710	0	applied	\N	\N	\N	\N	131489	131489	131490
26622	42483	11	applied	\N	\N	\N	\N	130769	130769	130770
26622	42484	12	applied	\N	\N	1000000000	\N	130771	130771	130772
26622	42485	13	applied	\N	\N	1000000000	\N	130773	130773	130774
26622	42486	14	applied	\N	\N	1000000000	\N	130775	130775	130776
26622	42487	15	applied	\N	\N	1000000000	\N	130777	130777	130778
26622	42488	16	applied	\N	\N	\N	\N	130779	130779	130780
26622	42489	17	applied	\N	\N	\N	\N	130781	130781	130782
26622	42490	18	applied	\N	\N	\N	\N	130783	130783	130784
26622	42491	19	applied	\N	\N	\N	\N	130785	130785	130786
26622	42492	20	applied	\N	\N	\N	\N	130787	130787	130788
26622	42493	22	applied	\N	\N	\N	\N	130790	130790	130791
26628	42503	0	applied	\N	\N	\N	\N	130824	130824	130825
26628	42504	1	applied	\N	\N	\N	\N	130826	130826	130827
26628	42505	2	applied	\N	\N	\N	\N	130828	130828	130829
26628	42506	3	applied	\N	\N	\N	\N	130830	130830	130831
26628	42507	4	applied	\N	\N	\N	\N	130832	130832	130833
26628	42508	5	applied	\N	\N	\N	\N	130834	130834	130835
26628	42509	6	applied	\N	\N	\N	\N	130836	130836	130837
26637	42523	0	applied	\N	\N	\N	\N	130877	130877	130878
26637	42524	1	applied	\N	\N	\N	\N	130879	130879	130880
26637	42525	2	applied	\N	\N	\N	\N	130881	130881	130882
26637	42526	3	applied	\N	\N	\N	\N	130883	130883	130884
26644	42540	0	applied	\N	\N	\N	\N	130923	130923	130924
26644	42541	1	applied	\N	\N	\N	\N	130925	130925	130926
26644	42542	2	applied	\N	\N	\N	\N	130927	130927	130928
26644	42543	3	applied	\N	\N	\N	\N	130929	130929	130930
26644	42544	4	applied	\N	\N	\N	\N	130931	130931	130932
26644	42545	5	applied	\N	\N	\N	\N	130933	130933	130934
26651	42343	0	applied	\N	\N	\N	\N	130357	130357	130958
26651	42346	1	applied	\N	\N	\N	\N	130415	130415	130959
26651	42349	2	applied	\N	\N	\N	\N	130422	130422	130960
26651	42353	3	applied	\N	\N	\N	\N	130432	130432	130961
26651	42356	4	applied	\N	\N	\N	\N	130443	130443	130962
26651	42357	5	applied	\N	\N	\N	\N	130445	130445	130963
26651	42363	6	applied	\N	\N	\N	\N	130460	130460	130964
26651	42367	7	applied	\N	\N	\N	\N	130470	130470	130965
26651	42370	8	applied	\N	\N	\N	\N	130477	130477	130966
26651	42371	9	applied	\N	\N	\N	\N	130479	130479	130967
26651	42372	10	applied	\N	\N	\N	\N	130481	130481	130968
26651	42382	11	applied	\N	\N	\N	\N	130503	130503	130969
26651	42386	12	applied	\N	\N	\N	\N	130512	130512	130970
26651	42387	13	applied	\N	\N	\N	\N	130514	130514	130971
26651	42392	14	applied	\N	\N	\N	\N	130527	130527	130972
26651	42393	15	applied	\N	\N	\N	\N	130529	130529	130973
26651	42399	16	applied	\N	\N	\N	\N	130552	130552	130974
26651	42400	17	applied	\N	\N	\N	\N	130554	130554	130975
26651	42405	18	applied	\N	\N	\N	\N	130569	130569	130976
26651	42409	19	applied	\N	\N	\N	\N	130578	130578	130977
26651	42410	20	applied	\N	\N	\N	\N	130580	130580	130978
26651	42415	21	applied	\N	\N	\N	\N	130590	130590	130979
26651	42419	22	applied	\N	\N	\N	\N	130600	130600	130980
26651	42420	23	applied	\N	\N	\N	\N	130602	130602	130981
26651	42425	24	applied	\N	\N	\N	\N	130621	130621	130982
26651	42429	25	applied	\N	\N	\N	\N	130631	130631	130983
26651	42434	26	applied	\N	\N	\N	\N	130644	130644	130984
26651	42437	27	applied	\N	\N	\N	\N	130652	130652	130985
26651	42438	28	applied	\N	\N	\N	\N	130654	130654	130986
26651	42439	29	applied	\N	\N	\N	\N	130656	130656	130987
26651	42447	30	applied	\N	\N	\N	\N	130673	130673	130988
26651	42451	31	applied	\N	\N	\N	\N	130686	130686	130989
26651	42453	32	applied	\N	\N	\N	\N	130691	130691	130990
26651	42456	33	applied	\N	\N	\N	\N	130705	130705	130991
26651	42464	34	applied	\N	\N	\N	\N	130724	130724	130992
26651	42472	35	applied	\N	\N	\N	\N	130747	130747	130993
26651	42473	36	applied	\N	\N	\N	\N	130749	130749	130994
26651	42474	37	applied	\N	\N	\N	\N	130751	130751	130995
26651	42475	38	applied	\N	\N	\N	\N	130753	130753	130996
26651	42476	39	applied	\N	\N	\N	\N	130755	130755	130997
26651	42494	40	applied	\N	\N	\N	\N	130800	130800	130998
26651	42497	41	applied	\N	\N	\N	\N	130808	130808	130999
26651	42500	42	applied	\N	\N	\N	\N	130816	130816	131000
26651	42503	43	applied	\N	\N	\N	\N	130824	130824	131001
26651	42504	44	applied	\N	\N	\N	\N	130826	130826	131002
26651	42510	45	applied	\N	\N	\N	\N	130844	130844	131003
26651	42514	46	applied	\N	\N	\N	\N	130853	130853	131004
26651	42518	47	applied	\N	\N	\N	\N	130864	130864	131005
26651	42523	48	applied	\N	\N	\N	\N	130877	130877	131006
26651	42527	49	applied	\N	\N	\N	\N	130890	130890	131007
26651	42528	50	applied	\N	\N	\N	\N	130892	130892	131008
26651	42529	51	applied	\N	\N	\N	\N	130894	130894	131009
26651	42536	52	applied	\N	\N	\N	\N	130913	130913	131010
26651	42540	53	applied	\N	\N	\N	\N	130923	130923	131011
26651	42541	54	applied	\N	\N	\N	\N	130925	130925	131012
26651	42546	55	applied	\N	\N	\N	\N	130939	130939	131013
26651	42550	56	applied	\N	\N	\N	\N	130950	130950	131014
26651	42511	57	applied	\N	\N	1000000000	\N	130846	130846	130847
26651	42537	58	applied	\N	\N	\N	\N	130915	130915	130916
26651	42364	59	applied	\N	\N	\N	\N	130462	130462	128922
26651	42178	60	applied	\N	\N	\N	\N	129868	129868	131015
26651	42478	61	applied	\N	\N	1000000000	\N	130759	130759	130760
26651	42373	62	applied	\N	\N	\N	\N	130483	130483	130484
26651	42484	63	applied	\N	\N	1000000000	\N	130771	130771	130772
26651	42485	64	applied	\N	\N	1000000000	\N	130773	130773	130774
26651	42486	65	applied	\N	\N	1000000000	\N	130775	130775	130776
26651	42374	66	applied	\N	\N	\N	\N	130485	130485	130486
26651	42487	67	applied	\N	\N	1000000000	\N	130777	130777	130778
26651	42184	68	applied	\N	\N	\N	\N	129886	129886	129983
26651	42185	69	applied	\N	\N	\N	\N	129888	129888	129984
26651	42189	70	applied	\N	\N	\N	\N	129898	129898	129744
26651	42195	71	applied	\N	\N	\N	\N	129912	129912	129747
26651	42196	72	applied	\N	\N	\N	\N	129914	129914	129985
26651	42199	73	applied	\N	\N	\N	\N	129923	129923	129756
26651	42201	74	applied	\N	\N	\N	\N	129928	129928	129758
26651	42205	75	applied	\N	\N	\N	\N	129940	129940	129765
26651	42208	76	applied	\N	\N	\N	\N	129948	129948	129986
26651	42211	77	applied	\N	\N	\N	\N	129954	129954	129987
26651	42217	78	applied	\N	\N	\N	\N	130026	130026	129777
26651	42218	79	applied	\N	\N	\N	\N	130029	130029	129779
26651	42081	80	applied	\N	\N	\N	\N	129532	129532	129787
26651	42086	81	applied	\N	\N	\N	\N	129544	129544	129789
26651	42088	82	applied	\N	\N	\N	\N	129548	129548	131016
26651	42091	83	applied	\N	\N	\N	\N	129580	129580	129804
26651	42094	84	applied	\N	\N	\N	\N	129589	129589	129806
26651	42095	85	applied	\N	\N	\N	\N	129591	129591	129808
26651	42098	86	applied	\N	\N	\N	\N	129600	129600	131017
26651	42102	87	applied	\N	\N	\N	\N	129609	129609	129820
26651	42110	88	applied	\N	\N	\N	\N	129686	129686	129822
26651	42111	89	applied	\N	\N	\N	\N	129688	129688	129828
26640	42528	1	applied	\N	\N	\N	\N	130892	130892	130893
26640	42529	2	applied	\N	\N	\N	\N	130894	130894	130895
26640	42530	3	applied	\N	\N	\N	\N	130896	130896	130897
26640	42531	4	applied	\N	\N	\N	\N	130898	130898	130899
26640	42532	5	applied	\N	\N	\N	\N	130900	130900	130901
26640	42533	6	applied	\N	\N	\N	\N	130902	130902	130903
26640	42534	7	applied	\N	\N	\N	\N	130904	130904	130905
26640	42535	8	applied	\N	\N	\N	\N	130906	130906	130907
26645	42540	0	applied	\N	\N	\N	\N	130923	130923	130924
26645	42541	1	applied	\N	\N	\N	\N	130925	130925	130926
26645	42542	2	applied	\N	\N	\N	\N	130927	130927	130928
26645	42543	3	applied	\N	\N	\N	\N	130929	130929	130930
26645	42544	4	applied	\N	\N	\N	\N	130931	130931	130932
26645	42545	5	applied	\N	\N	\N	\N	130933	130933	130934
26647	42546	0	applied	\N	\N	\N	\N	130939	130939	130940
26647	42547	1	applied	\N	\N	\N	\N	130941	130941	130942
26647	42548	2	applied	\N	\N	\N	\N	130943	130943	130944
26647	42549	3	applied	\N	\N	\N	\N	130945	130945	130946
26649	42546	0	applied	\N	\N	\N	\N	130939	130939	130940
26649	42547	1	applied	\N	\N	\N	\N	130941	130941	130942
26649	42548	2	applied	\N	\N	\N	\N	130943	130943	130944
26649	42549	3	applied	\N	\N	\N	\N	130945	130945	130946
26654	42553	0	applied	\N	\N	\N	\N	131033	131033	131034
26654	42554	1	applied	\N	\N	\N	\N	131035	131035	131036
26654	42555	2	applied	\N	\N	\N	\N	131037	131037	131038
26656	42556	0	applied	\N	\N	\N	\N	131044	131044	131045
26656	42557	1	applied	\N	\N	\N	\N	131046	131046	131047
26656	42558	2	applied	\N	\N	\N	\N	131048	131048	131049
26656	42559	3	applied	\N	\N	\N	\N	131050	131050	131051
26658	42563	0	applied	\N	\N	\N	\N	131063	131063	131064
26658	42564	1	applied	\N	\N	\N	\N	131065	131065	131066
26658	42565	2	applied	\N	\N	\N	\N	131067	131067	131068
26661	42566	0	applied	\N	\N	\N	\N	131070	131070	131071
26661	42567	1	applied	\N	\N	\N	\N	131072	131072	131073
26661	42568	2	applied	\N	\N	\N	\N	131074	131074	131075
26661	42565	3	applied	\N	\N	\N	\N	131067	131067	131076
26661	42569	4	applied	\N	\N	\N	\N	131077	131077	131078
26661	42570	5	applied	\N	\N	\N	\N	131079	131079	131080
26661	42571	6	applied	\N	\N	\N	\N	131081	131081	131082
26661	42572	7	applied	\N	\N	\N	\N	131083	131083	131084
26663	42573	0	applied	\N	\N	\N	\N	131089	131089	131090
26663	42574	1	applied	\N	\N	\N	\N	131091	131091	131092
26663	42575	2	applied	\N	\N	\N	\N	131093	131093	131094
26666	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26666	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26666	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26666	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26666	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26666	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26666	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26672	42586	0	applied	\N	\N	\N	\N	131134	131134	131135
26672	42587	1	applied	\N	\N	\N	\N	131136	131136	131137
26672	42588	2	applied	\N	\N	\N	\N	131138	131138	131139
26675	42589	0	applied	\N	\N	\N	\N	131142	131142	131143
26675	42590	1	applied	\N	\N	\N	\N	131144	131144	131145
26675	42591	2	applied	\N	\N	\N	\N	131146	131146	131147
26675	42592	3	applied	\N	\N	\N	\N	131148	131148	131149
26682	42609	0	applied	\N	\N	\N	\N	131201	131201	131202
26682	42610	1	applied	\N	\N	\N	\N	131203	131203	131204
26682	42611	2	applied	\N	\N	\N	\N	131205	131205	131206
26682	42612	3	applied	\N	\N	\N	\N	131207	131207	131208
26682	42613	4	applied	\N	\N	\N	\N	131209	131209	131210
26682	42614	5	applied	\N	\N	\N	\N	131211	131211	131212
26682	42615	6	applied	\N	\N	\N	\N	131213	131213	131214
26682	42616	7	applied	\N	\N	\N	\N	131215	131215	131216
26682	42617	8	applied	\N	\N	\N	\N	131217	131217	131218
26692	42629	0	applied	\N	\N	\N	\N	131252	131252	131253
26692	42630	1	applied	\N	\N	\N	\N	131254	131254	131255
26692	42631	2	applied	\N	\N	\N	\N	131256	131256	131257
26692	42632	3	applied	\N	\N	\N	\N	131258	131258	131259
26692	42633	4	applied	\N	\N	\N	\N	131260	131260	131261
26692	42634	5	applied	\N	\N	\N	\N	131262	131262	131263
26692	42635	6	applied	\N	\N	\N	\N	131264	131264	131265
26692	42636	7	applied	\N	\N	\N	\N	131266	131266	131267
26692	42637	8	applied	\N	\N	\N	\N	131268	131268	131269
26692	42638	9	applied	\N	\N	\N	\N	131270	131270	131271
26694	42639	0	applied	\N	\N	\N	\N	131277	131277	131278
26694	42640	1	applied	\N	\N	\N	\N	131279	131279	131280
26694	42641	2	applied	\N	\N	\N	\N	131281	131281	131282
26694	42642	3	applied	\N	\N	1000000000	\N	131283	131283	131284
26697	42646	0	applied	\N	\N	\N	\N	131293	131293	131294
26697	42647	1	applied	\N	\N	\N	\N	131295	131295	131296
26697	42648	2	applied	\N	\N	\N	\N	131297	131297	131298
26697	42649	3	applied	\N	\N	\N	\N	131299	131299	131300
26699	42650	0	applied	\N	\N	\N	\N	131304	131304	131305
26699	42651	1	applied	\N	\N	\N	\N	131306	131306	131307
26699	42652	2	applied	\N	\N	\N	\N	131308	131308	131309
26702	42653	0	applied	\N	\N	\N	\N	131314	131314	131315
26702	42654	1	applied	\N	\N	\N	\N	131316	131316	131317
26702	42655	2	applied	\N	\N	\N	\N	131318	131318	131319
26704	42663	0	applied	\N	\N	\N	\N	131341	131341	131342
26704	42664	1	applied	\N	\N	\N	\N	131343	131343	131344
26704	42665	2	applied	\N	\N	\N	\N	131345	131345	131346
26704	42666	3	applied	\N	\N	\N	\N	131347	131347	131348
26704	42667	4	applied	\N	\N	\N	\N	131349	131349	131350
26704	42668	5	applied	\N	\N	\N	\N	131351	131351	131352
26707	42669	0	applied	\N	\N	\N	\N	131355	131355	131356
26707	42670	1	applied	\N	\N	\N	\N	131357	131357	131358
26707	42671	2	applied	\N	\N	\N	\N	131359	131359	131360
26707	42672	3	applied	\N	\N	\N	\N	131361	131361	29193
26707	42673	4	applied	\N	\N	\N	\N	131362	131362	131363
26707	42674	5	applied	\N	\N	\N	\N	131364	131364	131365
26707	42675	6	applied	\N	\N	\N	\N	131366	131366	131367
26707	42676	7	applied	\N	\N	\N	\N	131368	131368	131369
26707	42677	8	applied	\N	\N	\N	\N	131370	131370	131371
26707	42678	9	applied	\N	\N	\N	\N	131372	131372	131373
26707	42679	10	applied	\N	\N	\N	\N	131374	131374	131375
26712	42690	0	applied	\N	\N	\N	\N	131437	131437	131438
26712	42691	1	applied	\N	\N	\N	\N	131439	131439	131440
26712	42692	2	applied	\N	\N	\N	\N	131441	131441	131442
26712	42693	3	applied	\N	\N	\N	\N	131443	131443	131444
26712	42694	4	applied	\N	\N	\N	\N	131445	131445	131446
26712	42695	5	applied	\N	\N	\N	\N	131447	131447	131448
26712	42696	6	applied	\N	\N	\N	\N	131449	131449	131450
26717	42707	0	applied	\N	\N	\N	\N	131479	131479	131480
26717	42708	1	applied	\N	\N	\N	\N	131481	131481	131482
26717	42709	2	applied	\N	\N	\N	\N	131483	131483	131484
26719	42710	0	applied	\N	\N	\N	\N	131489	131489	131490
26719	42711	1	applied	\N	\N	\N	\N	131491	131491	131492
26719	42712	2	applied	\N	\N	\N	\N	131493	131493	131494
26651	42113	90	applied	\N	\N	\N	\N	129695	129695	129851
26651	42118	91	applied	\N	\N	\N	\N	129705	129705	129853
26651	42120	92	applied	\N	\N	\N	\N	129709	129709	129855
26651	42125	93	applied	\N	\N	\N	\N	129720	129720	129857
26651	42129	94	applied	\N	\N	\N	\N	129732	129732	131018
26651	42133	95	applied	\N	\N	\N	\N	129743	129743	129863
26651	42139	96	applied	\N	\N	\N	\N	129755	129755	129876
26651	42143	97	applied	\N	\N	\N	\N	129766	129766	129998
26651	42145	98	applied	\N	\N	\N	\N	129776	129776	131019
26651	42150	99	applied	\N	\N	\N	\N	129788	129788	130000
26651	42153	100	applied	\N	\N	\N	\N	129796	129796	129889
26651	42157	101	applied	\N	\N	\N	\N	129805	129805	130002
26651	42158	102	applied	\N	\N	\N	\N	129807	129807	129899
26651	42163	103	applied	\N	\N	\N	\N	129821	129821	130004
26651	42165	104	applied	\N	\N	\N	\N	129827	129827	131020
26651	42171	105	applied	\N	\N	\N	\N	129852	129852	129913
26651	42172	107	applied	\N	\N	\N	\N	129854	129854	131022
26651	42173	108	applied	\N	\N	\N	\N	129856	129856	130007
26651	42179	109	applied	\N	\N	\N	\N	129870	129870	129929
26651	42182	110	applied	\N	\N	\N	\N	129882	129882	129931
26651	42183	111	applied	\N	\N	\N	\N	129884	129884	129941
26651	42188	112	applied	\N	\N	\N	\N	129896	129896	129943
26651	42193	113	applied	\N	\N	\N	\N	129908	129908	131023
26651	42194	114	applied	\N	\N	\N	\N	129910	129910	130014
26651	42198	115	applied	\N	\N	\N	\N	129921	129921	131024
26651	42202	116	applied	\N	\N	\N	\N	129930	129930	131025
26651	42206	117	applied	\N	\N	\N	\N	129942	129942	130027
26651	42209	118	applied	\N	\N	\N	\N	129950	129950	130032
26651	42212	119	applied	\N	\N	\N	\N	129956	129956	130034
26651	42216	120	applied	\N	\N	\N	\N	130024	130024	130036
26651	42220	121	applied	\N	\N	\N	\N	130033	130033	131026
26651	42221	122	applied	\N	\N	\N	\N	130035	130035	131027
26651	42226	123	applied	\N	\N	\N	\N	130050	130050	131028
26651	42229	124	applied	\N	\N	\N	\N	130058	130058	131029
26651	42231	125	applied	\N	\N	\N	\N	130064	130064	131030
26655	42556	0	applied	\N	\N	\N	\N	131044	131044	131045
26655	42557	1	applied	\N	\N	\N	\N	131046	131046	131047
26655	42558	2	applied	\N	\N	\N	\N	131048	131048	131049
26655	42559	3	applied	\N	\N	\N	\N	131050	131050	131051
26660	42566	0	applied	\N	\N	\N	\N	131070	131070	131071
26660	42567	1	applied	\N	\N	\N	\N	131072	131072	131073
26660	42568	2	applied	\N	\N	\N	\N	131074	131074	131075
26660	42565	3	applied	\N	\N	\N	\N	131067	131067	131076
26660	42569	4	applied	\N	\N	\N	\N	131077	131077	131078
26660	42570	5	applied	\N	\N	\N	\N	131079	131079	131080
26660	42571	6	applied	\N	\N	\N	\N	131081	131081	131082
26660	42572	7	applied	\N	\N	\N	\N	131083	131083	131084
26665	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26665	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26665	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26665	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26665	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26665	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26665	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26668	42576	0	applied	\N	\N	\N	\N	131099	131099	131100
26668	42577	1	applied	\N	\N	\N	\N	131101	131101	131102
26668	42578	3	applied	\N	\N	\N	\N	131104	131104	131105
26668	42579	4	applied	\N	\N	\N	\N	131106	131106	131107
26668	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26668	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26668	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26674	42589	0	applied	\N	\N	\N	\N	131142	131142	131143
26674	42590	1	applied	\N	\N	\N	\N	131144	131144	131145
26674	42591	2	applied	\N	\N	\N	\N	131146	131146	131147
26674	42592	3	applied	\N	\N	\N	\N	131148	131148	131149
26676	42593	0	applied	\N	\N	\N	\N	131155	131155	131156
26676	42594	1	applied	\N	\N	\N	\N	131157	131157	131158
26676	42595	2	applied	\N	\N	\N	\N	131159	131159	131160
26679	42599	0	applied	\N	\N	\N	\N	131170	131170	131171
26679	42600	1	applied	\N	\N	\N	\N	131172	131172	131173
26679	42601	2	applied	\N	\N	\N	\N	131174	131174	131175
26681	42553	0	applied	\N	\N	\N	\N	131033	131033	131193
26681	42556	1	applied	\N	\N	\N	\N	131044	131044	131194
26681	42560	2	applied	\N	\N	\N	\N	131056	131056	131195
26681	42563	3	applied	\N	\N	\N	\N	131063	131063	131196
26681	42566	4	applied	\N	\N	\N	\N	131070	131070	131197
26681	42567	5	applied	\N	\N	\N	\N	131072	131072	131198
26696	42646	0	applied	\N	\N	\N	\N	131293	131293	131294
26696	42647	1	applied	\N	\N	\N	\N	131295	131295	131296
26696	42648	2	applied	\N	\N	\N	\N	131297	131297	131298
26696	42649	3	applied	\N	\N	\N	\N	131299	131299	131300
26698	42650	0	applied	\N	\N	\N	\N	131304	131304	131305
26698	42651	1	applied	\N	\N	\N	\N	131306	131306	131307
26698	42652	2	applied	\N	\N	\N	\N	131308	131308	131309
26701	42653	0	applied	\N	\N	\N	\N	131314	131314	131315
26701	42654	1	applied	\N	\N	\N	\N	131316	131316	131317
26701	42655	2	applied	\N	\N	\N	\N	131318	131318	131319
26703	42656	0	applied	\N	\N	\N	\N	131325	131325	131326
26703	42657	1	applied	\N	\N	\N	\N	131327	131327	131328
26703	42658	2	applied	\N	\N	\N	\N	131329	131329	131330
26703	42659	3	applied	\N	\N	\N	\N	131331	131331	131332
26703	42660	4	applied	\N	\N	\N	\N	131333	131333	131334
26703	42661	5	applied	\N	\N	\N	\N	131335	131335	131336
26703	42662	6	applied	\N	\N	\N	\N	131337	131337	131338
26709	42447	0	applied	\N	\N	\N	\N	130673	130673	130674
26709	42451	1	applied	\N	\N	\N	\N	130686	130686	130687
26709	42453	2	applied	\N	\N	\N	\N	130691	130691	130692
26709	42456	3	applied	\N	\N	\N	\N	130705	130705	130706
26709	42464	4	applied	\N	\N	\N	\N	130724	130724	130725
26709	42472	5	applied	\N	\N	\N	\N	130747	130747	130748
26709	42473	6	applied	\N	\N	\N	\N	130749	130749	130750
26709	42474	7	applied	\N	\N	\N	\N	130751	130751	130752
26709	42475	8	applied	\N	\N	\N	\N	130753	130753	130754
26709	42476	9	applied	\N	\N	\N	\N	130755	130755	130756
26709	42494	10	applied	\N	\N	\N	\N	130800	130800	130801
26709	42497	11	applied	\N	\N	\N	\N	130808	130808	130809
26709	42500	12	applied	\N	\N	\N	\N	130816	130816	130817
26709	42503	13	applied	\N	\N	\N	\N	130824	130824	130825
26709	42504	14	applied	\N	\N	\N	\N	130826	130826	130827
26709	42510	15	applied	\N	\N	\N	\N	130844	130844	130845
26709	42514	16	applied	\N	\N	\N	\N	130853	130853	130854
26709	42518	17	applied	\N	\N	\N	\N	130864	130864	130865
26709	42523	18	applied	\N	\N	\N	\N	130877	130877	130878
26709	42527	19	applied	\N	\N	\N	\N	130890	130890	130891
26709	42528	20	applied	\N	\N	\N	\N	130892	130892	130893
26709	42529	21	applied	\N	\N	\N	\N	130894	130894	130895
26709	42536	22	applied	\N	\N	\N	\N	130913	130913	130914
26709	42540	23	applied	\N	\N	\N	\N	130923	130923	130924
26709	42541	24	applied	\N	\N	\N	\N	130925	130925	130926
26709	42546	25	applied	\N	\N	\N	\N	130939	130939	130940
26670	42580	5	applied	\N	\N	\N	\N	131108	131108	131109
26670	42581	6	applied	\N	\N	\N	\N	131110	131110	131111
26670	42582	7	applied	\N	\N	\N	\N	131112	131112	131113
26671	42583	0	applied	\N	\N	\N	\N	131127	131127	131128
26671	42584	1	applied	\N	\N	\N	\N	131129	131129	131130
26671	42585	2	applied	\N	\N	\N	\N	131131	131131	131132
26673	42589	0	applied	\N	\N	\N	\N	131142	131142	131143
26673	42590	1	applied	\N	\N	\N	\N	131144	131144	131145
26673	42591	2	applied	\N	\N	\N	\N	131146	131146	131147
26673	42592	3	applied	\N	\N	\N	\N	131148	131148	131149
26678	42599	0	applied	\N	\N	\N	\N	131170	131170	131171
26678	42600	1	applied	\N	\N	\N	\N	131172	131172	131173
26678	42601	2	applied	\N	\N	\N	\N	131174	131174	131175
26686	42618	0	applied	\N	\N	\N	\N	131222	131222	131223
26686	42619	1	applied	\N	\N	\N	\N	131224	131224	131225
26686	42620	2	applied	\N	\N	\N	\N	131226	131226	131227
26686	42621	3	applied	\N	\N	\N	\N	131228	131228	131229
26686	42622	4	applied	\N	\N	\N	\N	131230	131230	131231
26686	42623	5	applied	\N	\N	1000000000	\N	131232	131232	131233
26686	42624	6	applied	\N	\N	\N	\N	131234	131234	131235
26686	42625	7	applied	\N	\N	\N	\N	131236	131236	131237
26688	42626	0	applied	\N	\N	\N	\N	131244	131244	131245
26688	42627	1	applied	\N	\N	\N	\N	131246	131246	131247
26688	42628	2	applied	\N	\N	\N	\N	131248	131248	131249
26691	42629	0	applied	\N	\N	\N	\N	131252	131252	131253
26691	42630	1	applied	\N	\N	\N	\N	131254	131254	131255
26691	42631	2	applied	\N	\N	\N	\N	131256	131256	131257
26691	42632	3	applied	\N	\N	\N	\N	131258	131258	131259
26691	42633	4	applied	\N	\N	\N	\N	131260	131260	131261
26691	42634	5	applied	\N	\N	\N	\N	131262	131262	131263
26691	42635	6	applied	\N	\N	\N	\N	131264	131264	131265
26691	42636	7	applied	\N	\N	\N	\N	131266	131266	131267
26691	42637	8	applied	\N	\N	\N	\N	131268	131268	131269
26691	42638	9	applied	\N	\N	\N	\N	131270	131270	131271
26695	42643	0	applied	\N	\N	\N	\N	131285	131285	131286
26695	42644	1	applied	\N	\N	\N	\N	131287	131287	131288
26695	42645	2	applied	\N	\N	\N	\N	131289	131289	131290
26700	42653	0	applied	\N	\N	\N	\N	131314	131314	131315
26700	42654	1	applied	\N	\N	\N	\N	131316	131316	131317
26700	42655	2	applied	\N	\N	\N	\N	131318	131318	131319
26706	41925	0	applied	\N	\N	\N	\N	129028	129028	129029
26706	41926	1	applied	\N	\N	\N	\N	129030	129030	129031
26706	41931	2	applied	\N	\N	\N	\N	129042	129042	129043
26706	41932	3	applied	\N	\N	\N	\N	129044	129044	129045
26706	41938	4	applied	\N	\N	\N	\N	129111	129111	129112
26706	41939	5	applied	\N	\N	\N	\N	129113	129113	129114
26706	41945	6	applied	\N	\N	\N	\N	129126	129126	129127
26706	41948	7	applied	\N	\N	\N	\N	129134	129134	129135
26706	41952	8	applied	\N	\N	\N	\N	129142	129142	129143
26706	41953	9	applied	\N	\N	\N	\N	129145	129145	129146
26706	41959	10	applied	\N	\N	\N	\N	129159	129159	129160
26706	41961	11	applied	\N	\N	\N	\N	129163	129163	129164
26706	41965	12	applied	\N	\N	\N	\N	129172	129172	129173
26706	41969	13	applied	\N	\N	\N	\N	129182	129182	129183
26706	41972	14	applied	\N	\N	\N	\N	129190	129190	129191
26706	41975	15	applied	\N	\N	\N	\N	129200	129200	129201
26706	41979	16	applied	\N	\N	\N	\N	129211	129211	129212
26706	41980	17	applied	\N	\N	\N	\N	129222	129222	129223
26706	41985	18	applied	\N	\N	\N	\N	129237	129237	129238
26706	41989	19	applied	\N	\N	\N	\N	129249	129249	129250
26706	41992	20	applied	\N	\N	\N	\N	129259	129259	129260
26706	41993	21	applied	\N	\N	\N	\N	129261	129261	129262
26706	41994	22	applied	\N	\N	\N	\N	129263	129263	129264
26706	41995	23	applied	\N	\N	\N	\N	129265	129265	129266
26706	41996	24	applied	\N	\N	\N	\N	129267	129267	129268
26706	42010	25	applied	\N	\N	\N	\N	129299	129299	129300
26706	42014	26	applied	\N	\N	\N	\N	129311	129311	129312
26706	42017	27	applied	\N	\N	\N	\N	129317	129317	129318
26706	42018	28	applied	\N	\N	\N	\N	129319	129319	129320
26706	42024	29	applied	\N	\N	\N	\N	129333	129333	129334
26706	42027	30	applied	\N	\N	\N	\N	129348	129348	129349
26706	42030	31	applied	\N	\N	\N	\N	129356	129356	129357
26706	42033	32	applied	\N	\N	\N	\N	129366	129366	129367
26706	42037	33	applied	\N	\N	\N	\N	129376	129376	129377
26706	42040	34	applied	\N	\N	\N	\N	129384	129384	129385
26706	42041	35	applied	\N	\N	\N	\N	129386	129386	129387
26706	42047	36	applied	\N	\N	\N	\N	129404	129404	129405
26706	42048	37	applied	\N	\N	\N	\N	129406	129406	129407
26706	42053	39	applied	\N	\N	\N	\N	129421	129421	129422
26706	42057	40	applied	\N	\N	\N	\N	129432	129432	129433
26706	42060	41	applied	\N	\N	\N	\N	129442	129442	129443
26706	42061	42	applied	\N	\N	\N	\N	129444	129444	129445
26706	42066	43	applied	\N	\N	\N	\N	129459	129459	129460
26706	42070	44	applied	\N	\N	\N	\N	129473	129473	129474
26706	42073	45	applied	\N	\N	\N	\N	129482	129482	129483
26706	42075	46	applied	\N	\N	\N	\N	129487	129487	129488
26706	42079	47	applied	\N	\N	\N	\N	129528	129528	129529
26706	42082	48	applied	\N	\N	\N	\N	129536	129536	129537
26706	42083	49	applied	\N	\N	\N	\N	129538	129538	129539
26706	42089	50	applied	\N	\N	\N	\N	129576	129576	129577
26706	42092	51	applied	\N	\N	\N	\N	129585	129585	129586
26706	42093	52	applied	\N	\N	\N	\N	129587	129587	129588
26706	42101	53	applied	\N	\N	\N	\N	129607	129607	129608
26706	42104	54	applied	\N	\N	\N	\N	129674	129674	129675
26706	42105	55	applied	\N	\N	\N	\N	129676	129676	129677
26706	42112	56	applied	\N	\N	\N	\N	129693	129693	129694
26706	42115	57	applied	\N	\N	\N	\N	129699	129699	129700
26706	42116	58	applied	\N	\N	\N	\N	129701	129701	129702
26706	42122	59	applied	\N	\N	\N	\N	129714	129714	129715
26706	42128	60	applied	\N	\N	\N	\N	129730	129730	129731
26706	42132	61	applied	\N	\N	\N	\N	129741	129741	129742
26706	42136	62	applied	\N	\N	\N	\N	129749	129749	129750
26706	42141	63	applied	\N	\N	\N	\N	129762	129762	129763
26706	42144	64	applied	\N	\N	\N	\N	129774	129774	129775
26706	42147	65	applied	\N	\N	\N	\N	129782	129782	129783
26706	42151	66	applied	\N	\N	\N	\N	129792	129792	129793
26706	42154	67	applied	\N	\N	\N	\N	129799	129799	129800
26706	42155	68	applied	\N	\N	\N	\N	129801	129801	129802
26706	42161	69	applied	\N	\N	\N	\N	129817	129817	129834
26706	42164	70	applied	\N	\N	\N	\N	129825	129825	129835
26706	42167	71	applied	\N	\N	\N	\N	129836	129836	129837
26706	42168	72	applied	\N	\N	\N	\N	129838	129838	129839
26706	42170	73	applied	\N	\N	\N	\N	129849	129849	129960
26706	42177	74	applied	\N	\N	\N	\N	129866	129866	129961
26706	42180	75	applied	\N	\N	\N	\N	129878	129878	129962
26706	42181	76	applied	\N	\N	\N	\N	129880	129880	129963
26706	42187	77	applied	\N	\N	\N	\N	129894	129894	129964
26706	42190	78	applied	\N	\N	\N	\N	129902	129902	129965
26706	42191	79	applied	\N	\N	\N	\N	129904	129904	129966
26706	42197	80	applied	\N	\N	\N	\N	129919	129919	129967
26706	42200	81	applied	\N	\N	\N	\N	129926	129926	129968
26706	42203	82	applied	\N	\N	\N	\N	129936	129936	129969
26706	42207	83	applied	\N	\N	\N	\N	129946	129946	129970
26706	42210	84	applied	\N	\N	\N	\N	129952	129952	129971
26706	42213	85	applied	\N	\N	\N	\N	130018	130018	130365
26706	42214	86	applied	\N	\N	\N	\N	130020	130020	130366
26706	42215	87	applied	\N	\N	\N	\N	130022	130022	130367
26706	42223	88	applied	\N	\N	\N	\N	130044	130044	130368
26706	42227	89	applied	\N	\N	\N	\N	130053	130053	130369
26706	42230	90	applied	\N	\N	\N	\N	130062	130062	130370
26706	42233	91	applied	\N	\N	\N	\N	130069	130069	130371
26706	42236	92	applied	\N	\N	\N	\N	130081	130081	130372
26706	42240	93	applied	\N	\N	\N	\N	130090	130090	130373
26706	42243	94	applied	\N	\N	\N	\N	130107	130107	130374
26706	42246	95	applied	\N	\N	\N	\N	130114	130114	130375
26706	42250	96	applied	\N	\N	\N	\N	130124	130124	130376
26706	42253	97	applied	\N	\N	\N	\N	130134	130134	130377
26706	42256	98	applied	\N	\N	\N	\N	130142	130142	130378
26706	42260	99	applied	\N	\N	\N	\N	130151	130151	130379
26706	42261	100	applied	\N	\N	\N	\N	130153	130153	130380
26706	42262	101	applied	\N	\N	\N	\N	130155	130155	130381
26706	42269	102	applied	\N	\N	\N	\N	130174	130174	130382
26706	42270	103	applied	\N	\N	\N	\N	130176	130176	130383
26706	42276	104	applied	\N	\N	\N	\N	130194	130194	130384
26706	42280	105	applied	\N	\N	\N	\N	130202	130202	130385
26706	42281	106	applied	\N	\N	\N	\N	130204	130204	130386
26706	42289	107	applied	\N	\N	\N	\N	130220	130220	130387
26706	42290	108	applied	\N	\N	\N	\N	130222	130222	130388
26706	42298	109	applied	\N	\N	\N	\N	130245	130245	130389
26706	42299	110	applied	\N	\N	\N	\N	130247	130247	130390
26706	42300	111	applied	\N	\N	\N	\N	130249	130249	130391
26706	42308	112	applied	\N	\N	\N	\N	130267	130267	130392
26706	42311	113	applied	\N	\N	\N	\N	130276	130276	130393
26706	42313	114	applied	\N	\N	\N	\N	130281	130281	130394
26706	42317	115	applied	\N	\N	\N	\N	130290	130290	130395
26706	42320	116	applied	\N	\N	\N	\N	130298	130298	130396
26706	42321	117	applied	\N	\N	\N	\N	130300	130300	130397
26706	42327	118	applied	\N	\N	\N	\N	130313	130313	130398
26706	42328	119	applied	\N	\N	\N	\N	130315	130315	130399
26706	42333	120	applied	\N	\N	\N	\N	130326	130326	130400
26706	42336	121	applied	\N	\N	\N	\N	130336	130336	130401
26706	42340	122	applied	\N	\N	\N	\N	130350	130350	130402
26706	42343	123	applied	\N	\N	\N	\N	130357	130357	130958
26706	42346	124	applied	\N	\N	\N	\N	130415	130415	130959
26706	42349	125	applied	\N	\N	\N	\N	130422	130422	130960
26708	42680	0	applied	\N	\N	\N	\N	131385	131385	131386
26708	42681	1	applied	\N	\N	\N	\N	131387	131387	131388
26708	42682	2	applied	\N	\N	\N	\N	131389	131389	131390
26708	42683	3	applied	\N	\N	\N	\N	131391	131391	131392
26708	42684	4	applied	\N	\N	\N	\N	131393	131393	131394
26708	42685	5	applied	\N	\N	\N	\N	131395	131395	131396
26708	42686	6	applied	\N	\N	\N	\N	131397	131397	131398
26714	42697	0	applied	\N	\N	\N	\N	131452	131452	131453
26714	42698	1	applied	\N	\N	\N	\N	131454	131454	131455
26714	42699	2	applied	\N	\N	\N	\N	131456	131456	131457
26714	42700	3	applied	\N	\N	\N	\N	131458	131458	131459
26714	42701	4	applied	\N	\N	\N	\N	131460	131460	131461
26714	42702	5	applied	\N	\N	\N	\N	131462	131462	131463
26718	42707	0	applied	\N	\N	\N	\N	131479	131479	131480
26718	42708	1	applied	\N	\N	\N	\N	131481	131481	131482
26718	42709	2	applied	\N	\N	\N	\N	131483	131483	131484
26726	42729	0	applied	\N	\N	\N	\N	131533	131533	131534
26726	42730	1	applied	\N	\N	\N	\N	131535	131535	131536
26726	42731	2	applied	\N	\N	\N	\N	131537	131537	131538
26730	42739	0	applied	\N	\N	\N	\N	131559	131559	131560
26730	42740	1	applied	\N	\N	\N	\N	131561	131561	131562
26730	42741	2	applied	\N	\N	\N	\N	131563	131563	131564
26735	42747	0	applied	\N	\N	\N	\N	131584	131584	131585
26735	42748	1	applied	\N	\N	\N	\N	131586	131586	131587
26735	42749	2	applied	\N	\N	\N	\N	131588	131588	131589
26735	42750	3	applied	\N	\N	\N	\N	131590	131590	131591
26743	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26743	42761	1	applied	\N	\N	\N	\N	131617	131617	131618
26743	42762	2	applied	\N	\N	\N	\N	131619	131619	131620
26743	42763	3	applied	\N	\N	\N	\N	131621	131621	131622
26745	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26745	42764	1	applied	\N	\N	\N	\N	131630	131630	131631
26745	42761	2	applied	\N	\N	\N	\N	131617	131617	131618
26745	42762	3	applied	\N	\N	\N	\N	131619	131619	131620
26745	42765	4	applied	\N	\N	\N	\N	131632	131632	131633
26745	42766	5	applied	\N	\N	\N	\N	131634	131634	131635
26745	42763	6	applied	\N	\N	\N	\N	131621	131621	131636
26747	42511	0	applied	\N	\N	1000000000	\N	130846	130846	130847
26747	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26747	42364	2	applied	\N	\N	\N	\N	130462	130462	128922
26747	42672	3	applied	\N	\N	\N	\N	131361	131361	29193
26747	42478	4	applied	\N	\N	1000000000	\N	130759	130759	130760
26747	42373	5	applied	\N	\N	\N	\N	130483	130483	130484
26747	42484	6	applied	\N	\N	1000000000	\N	130771	130771	130772
26747	42485	7	applied	\N	\N	1000000000	\N	130773	130773	130774
26747	42486	8	applied	\N	\N	1000000000	\N	130775	130775	130776
26747	42374	9	applied	\N	\N	\N	\N	130485	130485	130486
26747	42487	10	applied	\N	\N	1000000000	\N	130777	130777	130778
26747	42623	11	applied	\N	\N	1000000000	\N	131232	131232	131233
26747	42642	12	applied	\N	\N	1000000000	\N	131283	131283	131284
26747	42743	13	applied	\N	\N	1000000000	\N	131573	131573	131574
26747	42745	14	applied	\N	\N	1000000000	\N	131577	131577	131578
26747	42279	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	130200	130200	\N
26747	42284	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	130210	130210	\N
26747	42287	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	130215	130215	\N
26756	42511	0	applied	\N	\N	1000000000	\N	130846	130846	130847
26756	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26756	42672	2	applied	\N	\N	\N	\N	131361	131361	29193
26756	42478	3	applied	\N	\N	1000000000	\N	130759	130759	130760
26756	42484	4	applied	\N	\N	1000000000	\N	130771	130771	130772
26756	42485	5	applied	\N	\N	1000000000	\N	130773	130773	130774
26756	42486	6	applied	\N	\N	1000000000	\N	130775	130775	130776
26756	42487	7	applied	\N	\N	1000000000	\N	130777	130777	130778
26756	42623	8	applied	\N	\N	1000000000	\N	131232	131232	131233
26756	42642	9	applied	\N	\N	1000000000	\N	131283	131283	131284
26756	42743	10	applied	\N	\N	1000000000	\N	131573	131573	131574
26756	42745	11	applied	\N	\N	1000000000	\N	131577	131577	131578
26758	42784	0	applied	\N	\N	\N	\N	131685	131685	131686
26758	42785	1	applied	\N	\N	\N	\N	131687	131687	131688
26758	42786	2	applied	\N	\N	\N	\N	131689	131689	131690
26758	42787	3	applied	\N	\N	\N	\N	131691	131691	131692
26709	42550	26	applied	\N	\N	\N	\N	130950	130950	130951
26709	42553	27	applied	\N	\N	\N	\N	131033	131033	131034
26709	42556	28	applied	\N	\N	\N	\N	131044	131044	131045
26709	42560	29	applied	\N	\N	\N	\N	131056	131056	131057
26709	42563	30	applied	\N	\N	\N	\N	131063	131063	131064
26709	42566	31	applied	\N	\N	\N	\N	131070	131070	131071
26709	42567	32	applied	\N	\N	\N	\N	131072	131072	131073
26709	42573	33	applied	\N	\N	\N	\N	131089	131089	131090
26709	42576	34	applied	\N	\N	\N	\N	131099	131099	131100
26709	42577	35	applied	\N	\N	\N	\N	131101	131101	131102
26709	42583	36	applied	\N	\N	\N	\N	131127	131127	131128
26709	42586	37	applied	\N	\N	\N	\N	131134	131134	131135
26709	42589	38	applied	\N	\N	\N	\N	131142	131142	131143
26709	42593	39	applied	\N	\N	\N	\N	131155	131155	131156
26709	42596	40	applied	\N	\N	\N	\N	131163	131163	131164
26709	42599	41	applied	\N	\N	\N	\N	131170	131170	131171
26709	42602	42	applied	\N	\N	\N	\N	131178	131178	131179
26709	42603	43	applied	\N	\N	\N	\N	131180	131180	131181
26709	42609	44	applied	\N	\N	\N	\N	131201	131201	131202
26709	42610	45	applied	\N	\N	\N	\N	131203	131203	131204
26709	42611	46	applied	\N	\N	\N	\N	131205	131205	131206
26709	42618	47	applied	\N	\N	\N	\N	131222	131222	131223
26709	42619	48	applied	\N	\N	\N	\N	131224	131224	131225
26709	42626	49	applied	\N	\N	\N	\N	131244	131244	131245
26709	42629	50	applied	\N	\N	\N	\N	131252	131252	131253
26709	42630	51	applied	\N	\N	\N	\N	131254	131254	131255
26709	42631	52	applied	\N	\N	\N	\N	131256	131256	131257
26709	42639	53	applied	\N	\N	\N	\N	131277	131277	131278
26709	42643	54	applied	\N	\N	\N	\N	131285	131285	131286
26709	42646	55	applied	\N	\N	\N	\N	131293	131293	131294
26709	42650	56	applied	\N	\N	\N	\N	131304	131304	131305
26709	42653	57	applied	\N	\N	\N	\N	131314	131314	131315
26709	42656	59	applied	\N	\N	\N	\N	131325	131325	131326
26709	42657	60	applied	\N	\N	\N	\N	131327	131327	131328
26709	42663	61	applied	\N	\N	\N	\N	131341	131341	131342
26709	42664	62	applied	\N	\N	\N	\N	131343	131343	131344
26709	42669	63	applied	\N	\N	\N	\N	131355	131355	131356
26709	42670	64	applied	\N	\N	\N	\N	131357	131357	131358
26709	42671	65	applied	\N	\N	\N	\N	131359	131359	131360
26709	42680	66	applied	\N	\N	\N	\N	131385	131385	131386
26709	42681	67	applied	\N	\N	\N	\N	131387	131387	131388
26709	42511	68	applied	\N	\N	1000000000	\N	130846	130846	130847
26709	42537	69	applied	\N	\N	\N	\N	130915	130915	130916
26709	42448	70	applied	\N	\N	\N	\N	130675	130675	130676
26709	42672	71	applied	\N	\N	\N	\N	131361	131361	29193
26709	42478	72	applied	\N	\N	1000000000	\N	130759	130759	130760
26709	42452	73	applied	\N	\N	\N	\N	130688	130688	130684
26709	42484	74	applied	\N	\N	1000000000	\N	130771	130771	130772
26709	42485	75	applied	\N	\N	1000000000	\N	130773	130773	130774
26709	42486	76	applied	\N	\N	1000000000	\N	130775	130775	130776
26709	42449	77	applied	\N	\N	\N	\N	130677	130677	131402
26709	42457	78	applied	\N	\N	\N	\N	130707	130707	130680
26709	42465	79	applied	\N	\N	\N	\N	130726	130726	131403
26709	42477	80	applied	\N	\N	\N	\N	130757	130757	130689
26709	42479	81	applied	\N	\N	\N	\N	130761	130761	131404
26709	42487	82	applied	\N	\N	1000000000	\N	130777	130777	130778
26709	42623	83	applied	\N	\N	1000000000	\N	131232	131232	131233
26709	42450	84	applied	\N	\N	\N	\N	130679	130679	131405
26709	42454	85	applied	\N	\N	\N	\N	130693	130693	131406
26709	42458	86	applied	\N	\N	\N	\N	130709	130709	131407
26709	42459	87	applied	\N	\N	\N	\N	130711	130711	131408
26709	42463	88	applied	\N	\N	\N	\N	130720	130720	130716
26709	42455	89	applied	\N	\N	\N	\N	130695	130695	130719
26709	42460	90	applied	\N	\N	\N	\N	130713	130713	131409
26709	42461	91	applied	\N	\N	\N	\N	130715	130715	130727
26709	42462	92	applied	\N	\N	\N	\N	130718	130718	130729
26709	42466	93	applied	\N	\N	\N	\N	130728	130728	130731
26709	42467	94	applied	\N	\N	\N	\N	130730	130730	130733
26709	42468	95	applied	\N	\N	\N	\N	130732	130732	131410
26709	42642	96	applied	\N	\N	1000000000	\N	131283	131283	131284
26709	42489	97	applied	\N	\N	\N	\N	130781	130781	131411
26709	42490	98	applied	\N	\N	\N	\N	130783	130783	130737
26709	42491	99	applied	\N	\N	\N	\N	130785	130785	131412
26709	42492	100	applied	\N	\N	\N	\N	130787	130787	130758
26709	42469	101	applied	\N	\N	\N	\N	130734	130734	131413
26709	42493	102	applied	\N	\N	\N	\N	130790	130790	131414
26709	42495	103	applied	\N	\N	\N	\N	130802	130802	130766
26709	42499	104	applied	\N	\N	\N	\N	130812	130812	131415
26709	42509	105	applied	\N	\N	\N	\N	130836	130836	130768
26709	42516	106	applied	\N	\N	\N	\N	130857	130857	131416
26709	42526	107	applied	\N	\N	\N	\N	130883	130883	131417
26709	42538	108	applied	\N	\N	\N	\N	130917	130917	130770
26709	42547	109	applied	\N	\N	\N	\N	130941	130941	131418
26709	42558	110	applied	\N	\N	\N	\N	131048	131048	131419
26709	42572	111	applied	\N	\N	\N	\N	131083	131083	130780
26709	42582	112	applied	\N	\N	\N	\N	131112	131112	131420
26709	42591	113	applied	\N	\N	\N	\N	131146	131146	130782
26709	42604	114	applied	\N	\N	\N	\N	131182	131182	131421
26709	42613	115	applied	\N	\N	\N	\N	131209	131209	130784
26709	42622	116	applied	\N	\N	\N	\N	131230	131230	131422
26709	42638	117	applied	\N	\N	\N	\N	131270	131270	130786
26709	42648	118	applied	\N	\N	\N	\N	131297	131297	131423
26709	42661	119	applied	\N	\N	\N	\N	131335	131335	130788
26709	42470	120	applied	\N	\N	\N	\N	130736	130736	131424
26709	42471	121	applied	\N	\N	\N	\N	130738	130738	131425
26709	42480	122	applied	\N	\N	\N	\N	130763	130763	131426
26709	42481	123	applied	\N	\N	\N	\N	130765	130765	130813
26709	42482	124	applied	\N	\N	\N	\N	130767	130767	130819
26709	42483	125	applied	\N	\N	\N	\N	130769	130769	131427
26711	42687	0	applied	\N	\N	\N	\N	131430	131430	131431
26711	42688	1	applied	\N	\N	\N	\N	131432	131432	131433
26711	42689	2	applied	\N	\N	\N	\N	131434	131434	131435
26716	42703	0	applied	\N	\N	\N	\N	131467	131467	131468
26716	42704	1	applied	\N	\N	\N	\N	131469	131469	131470
26716	42705	2	applied	\N	\N	\N	\N	131471	131471	131472
26716	42706	3	applied	\N	\N	\N	\N	131473	131473	131474
26728	42732	0	applied	\N	\N	\N	\N	131541	131541	131542
26728	42733	1	applied	\N	\N	\N	\N	131543	131543	131544
26728	42734	2	applied	\N	\N	\N	\N	131545	131545	131546
26728	42735	3	applied	\N	\N	\N	\N	131547	131547	131548
26728	42736	4	applied	\N	\N	\N	\N	131549	131549	131550
26728	42737	5	applied	\N	\N	\N	\N	131551	131551	131552
26728	42738	6	applied	\N	\N	\N	\N	131553	131553	131554
26729	42732	0	applied	\N	\N	\N	\N	131541	131541	131542
26729	42733	1	applied	\N	\N	\N	\N	131543	131543	131544
26729	42734	2	applied	\N	\N	\N	\N	131545	131545	131546
26729	42735	3	applied	\N	\N	\N	\N	131547	131547	131548
26729	42736	4	applied	\N	\N	\N	\N	131549	131549	131550
26729	42737	5	applied	\N	\N	\N	\N	131551	131551	131552
26720	42711	1	applied	\N	\N	\N	\N	131491	131491	131492
26720	42712	2	applied	\N	\N	\N	\N	131493	131493	131494
26722	42713	0	applied	\N	\N	\N	\N	131496	131496	131497
26722	42714	1	applied	\N	\N	\N	\N	131498	131498	131499
26722	42715	2	applied	\N	\N	\N	\N	131500	131500	131501
26722	42716	3	applied	\N	\N	\N	\N	131502	131502	131503
26725	42725	0	applied	\N	\N	\N	\N	131523	131523	131524
26725	42726	1	applied	\N	\N	\N	\N	131525	131525	131526
26725	42727	2	applied	\N	\N	\N	\N	131527	131527	131528
26725	42728	3	applied	\N	\N	\N	\N	131529	131529	131530
26731	42739	0	applied	\N	\N	\N	\N	131559	131559	131560
26731	42740	1	applied	\N	\N	\N	\N	131561	131561	131562
26731	42741	2	applied	\N	\N	\N	\N	131563	131563	131564
26734	42742	0	applied	\N	\N	\N	\N	131571	131571	131572
26734	42743	1	applied	\N	\N	1000000000	\N	131573	131573	131574
26734	42744	2	applied	\N	\N	\N	\N	131575	131575	131576
26734	42745	3	applied	\N	\N	1000000000	\N	131577	131577	131578
26734	42746	4	applied	\N	\N	\N	\N	131579	131579	131580
26736	42751	0	applied	\N	\N	\N	\N	131593	131593	131594
26736	42752	1	applied	\N	\N	\N	\N	131595	131595	131596
26736	42753	2	applied	\N	\N	\N	\N	131597	131597	131598
26736	42754	3	applied	\N	\N	\N	\N	131599	131599	131600
26736	42755	4	applied	\N	\N	\N	\N	131601	131601	131602
26736	42756	5	applied	\N	\N	\N	\N	131603	131603	131604
26739	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26739	42761	1	applied	\N	\N	\N	\N	131617	131617	131618
26739	42762	2	applied	\N	\N	\N	\N	131619	131619	131620
26739	42763	3	applied	\N	\N	\N	\N	131621	131621	131622
26741	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26741	42761	1	applied	\N	\N	\N	\N	131617	131617	131618
26741	42762	2	applied	\N	\N	\N	\N	131619	131619	131620
26741	42763	3	applied	\N	\N	\N	\N	131621	131621	131622
26749	42774	0	applied	\N	\N	\N	\N	131658	131658	131659
26749	42775	1	applied	\N	\N	\N	\N	131660	131660	131661
26749	42776	2	applied	\N	\N	\N	\N	131662	131662	131663
26751	42777	0	applied	\N	\N	\N	\N	131666	131666	131667
26751	42778	1	applied	\N	\N	\N	\N	131668	131668	131669
26751	42779	2	applied	\N	\N	\N	\N	131670	131670	131671
26754	42511	0	applied	\N	\N	1000000000	\N	130846	130846	130847
26754	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26754	42364	2	applied	\N	\N	\N	\N	130462	130462	128922
26754	42672	3	applied	\N	\N	\N	\N	131361	131361	29193
26754	42478	4	applied	\N	\N	1000000000	\N	130759	130759	130760
26754	42373	5	applied	\N	\N	\N	\N	130483	130483	130484
26754	42484	6	applied	\N	\N	1000000000	\N	130771	130771	130772
26754	42485	7	applied	\N	\N	1000000000	\N	130773	130773	130774
26754	42486	8	applied	\N	\N	1000000000	\N	130775	130775	130776
26754	42374	9	applied	\N	\N	\N	\N	130485	130485	130486
26754	42487	10	applied	\N	\N	1000000000	\N	130777	130777	130778
26754	42623	11	applied	\N	\N	1000000000	\N	131232	131232	131233
26754	42642	12	applied	\N	\N	1000000000	\N	131283	131283	131284
26754	42743	13	applied	\N	\N	1000000000	\N	131573	131573	131574
26754	42745	14	applied	\N	\N	1000000000	\N	131577	131577	131578
26765	42797	0	applied	\N	\N	\N	\N	131715	131715	131716
26765	42798	1	applied	\N	\N	\N	\N	131717	131717	131718
26765	42799	2	applied	\N	\N	\N	\N	131719	131719	131720
26765	42800	3	applied	\N	\N	\N	\N	131721	131721	131722
26765	42804	4	applied	\N	\N	\N	\N	131729	131729	131737
26765	42805	5	applied	\N	\N	\N	\N	131731	131731	131728
26765	42806	6	applied	\N	\N	\N	\N	131733	131733	131738
26771	42819	0	applied	\N	\N	\N	\N	131771	131771	131772
26771	42820	1	applied	\N	\N	\N	\N	131773	131773	131774
26771	42821	2	applied	\N	\N	\N	\N	131775	131775	131776
26771	42822	3	applied	\N	\N	\N	\N	131777	131777	131778
26771	42823	4	applied	\N	\N	\N	\N	131779	131779	131780
26771	42824	5	applied	\N	\N	\N	\N	131781	131781	131782
26771	42825	6	applied	\N	\N	\N	\N	131783	131783	131784
26771	42826	7	applied	\N	\N	\N	\N	131785	131785	131786
26771	42827	8	applied	\N	\N	\N	\N	131787	131787	131788
26771	42828	9	applied	\N	\N	\N	\N	131789	131789	131790
26771	42829	10	applied	\N	\N	\N	\N	131791	131791	131792
26771	42830	11	applied	\N	\N	\N	\N	131793	131793	131794
26771	42831	12	applied	\N	\N	\N	\N	131795	131795	131796
26771	42832	13	applied	\N	\N	\N	\N	131797	131797	131798
26771	42833	14	applied	\N	\N	\N	\N	131799	131799	131800
26771	42834	15	applied	\N	\N	\N	\N	131801	131801	131802
26771	42835	16	applied	\N	\N	\N	\N	131803	131803	131804
26771	42836	17	applied	\N	\N	\N	\N	131805	131805	131806
26771	42837	18	applied	\N	\N	\N	\N	131807	131807	131808
26771	42838	19	applied	\N	\N	\N	\N	131809	131809	131810
26774	42839	0	applied	\N	\N	\N	\N	131814	131814	131815
26774	42840	1	applied	\N	\N	\N	\N	131816	131816	131817
26774	42841	2	applied	\N	\N	\N	\N	131818	131818	131819
26774	42842	3	applied	\N	\N	\N	\N	131820	131820	131821
26774	42843	4	applied	\N	\N	\N	\N	131822	131822	131823
26774	42844	5	applied	\N	\N	\N	\N	131824	131824	131825
26785	42867	0	applied	\N	\N	\N	\N	131891	131891	131892
26785	42868	1	applied	\N	\N	\N	\N	131893	131893	131894
26785	42869	2	applied	\N	\N	\N	\N	131895	131895	131896
26790	42874	0	applied	\N	\N	\N	\N	131918	131918	131919
26790	42875	1	applied	\N	\N	\N	\N	131920	131920	131921
26790	42876	2	applied	\N	\N	\N	\N	131922	131922	131923
26792	42877	0	applied	\N	\N	\N	\N	131930	131930	131931
26792	42878	1	applied	\N	\N	\N	\N	131932	131932	131933
26792	42879	2	applied	\N	\N	\N	\N	131934	131934	131935
26792	42880	3	applied	\N	\N	\N	\N	131936	131936	131937
26792	42881	4	applied	\N	\N	\N	\N	131938	131938	131939
26792	42882	5	applied	\N	\N	\N	\N	131940	131940	131941
26792	42883	6	applied	\N	\N	\N	\N	131942	131942	131943
26792	42884	7	applied	\N	\N	\N	\N	131944	131944	131945
26792	42885	8	applied	\N	\N	\N	\N	131946	131946	131947
26792	42886	9	applied	\N	\N	\N	\N	131948	131948	131949
26799	42892	0	applied	\N	\N	\N	\N	131969	131969	131970
26799	42893	1	applied	\N	\N	\N	\N	131971	131971	131972
26799	42894	2	applied	\N	\N	\N	\N	131973	131973	131974
26799	42895	3	applied	\N	\N	\N	\N	131975	131975	131976
26807	42920	0	applied	\N	\N	\N	\N	132039	132039	132040
26807	42921	1	applied	\N	\N	\N	\N	132041	132041	132042
26807	42922	2	applied	\N	\N	\N	\N	132043	132043	132044
26811	42923	0	applied	\N	\N	\N	\N	132045	132045	132046
26811	42924	1	applied	\N	\N	\N	\N	132047	132047	132048
26811	42925	2	applied	\N	\N	\N	\N	132049	132049	132050
26815	42946	0	applied	\N	\N	\N	\N	132103	132103	132104
26815	42947	2	applied	\N	\N	\N	\N	132106	132106	132107
26815	42948	3	applied	\N	\N	\N	\N	132108	132108	132109
26815	42949	4	applied	\N	\N	\N	\N	132110	132110	132111
26817	42950	0	applied	\N	\N	\N	\N	132117	132117	111296
26817	42951	1	applied	\N	\N	\N	\N	132118	132118	132119
26721	42710	0	applied	\N	\N	\N	\N	131489	131489	131490
26721	42711	1	applied	\N	\N	\N	\N	131491	131491	131492
26724	42717	0	applied	\N	\N	\N	\N	131505	131505	131506
26724	42718	1	applied	\N	\N	\N	\N	131507	131507	131508
26724	42719	2	applied	\N	\N	\N	\N	131509	131509	131510
26724	42720	3	applied	\N	\N	\N	\N	131511	131511	131512
26724	42721	4	applied	\N	\N	\N	\N	131513	131513	131514
26724	42722	5	applied	\N	\N	\N	\N	131515	131515	131516
26724	42723	6	applied	\N	\N	\N	\N	131517	131517	131518
26724	42724	7	applied	\N	\N	\N	\N	131519	131519	131520
26727	42732	0	applied	\N	\N	\N	\N	131541	131541	131542
26727	42733	1	applied	\N	\N	\N	\N	131543	131543	131544
26727	42734	2	applied	\N	\N	\N	\N	131545	131545	131546
26727	42735	3	applied	\N	\N	\N	\N	131547	131547	131548
26727	42736	4	applied	\N	\N	\N	\N	131549	131549	131550
26727	42737	5	applied	\N	\N	\N	\N	131551	131551	131552
26727	42738	6	applied	\N	\N	\N	\N	131553	131553	131554
26732	42739	0	applied	\N	\N	\N	\N	131559	131559	131560
26732	42740	1	applied	\N	\N	\N	\N	131561	131561	131562
26732	42741	2	applied	\N	\N	\N	\N	131563	131563	131564
26733	42742	0	applied	\N	\N	\N	\N	131571	131571	131572
26733	42743	1	applied	\N	\N	1000000000	\N	131573	131573	131574
26733	42744	2	applied	\N	\N	\N	\N	131575	131575	131576
26733	42745	3	applied	\N	\N	1000000000	\N	131577	131577	131578
26733	42746	4	applied	\N	\N	\N	\N	131579	131579	131580
26744	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26744	42764	1	applied	\N	\N	\N	\N	131630	131630	131631
26744	42761	2	applied	\N	\N	\N	\N	131617	131617	131618
26744	42762	3	applied	\N	\N	\N	\N	131619	131619	131620
26744	42765	4	applied	\N	\N	\N	\N	131632	131632	131633
26744	42766	5	applied	\N	\N	\N	\N	131634	131634	131635
26744	42763	6	applied	\N	\N	\N	\N	131621	131621	131636
26753	42511	0	applied	\N	\N	1000000000	\N	130846	130846	130847
26753	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26753	42364	2	applied	\N	\N	\N	\N	130462	130462	128922
26753	42672	3	applied	\N	\N	\N	\N	131361	131361	29193
26753	42478	4	applied	\N	\N	1000000000	\N	130759	130759	130760
26753	42373	5	applied	\N	\N	\N	\N	130483	130483	130484
26753	42484	6	applied	\N	\N	1000000000	\N	130771	130771	130772
26753	42485	7	applied	\N	\N	1000000000	\N	130773	130773	130774
26753	42486	8	applied	\N	\N	1000000000	\N	130775	130775	130776
26753	42374	9	applied	\N	\N	\N	\N	130485	130485	130486
26753	42487	10	applied	\N	\N	1000000000	\N	130777	130777	130778
26753	42623	11	applied	\N	\N	1000000000	\N	131232	131232	131233
26753	42642	12	applied	\N	\N	1000000000	\N	131283	131283	131284
26753	42743	13	applied	\N	\N	1000000000	\N	131573	131573	131574
26753	42745	14	applied	\N	\N	1000000000	\N	131577	131577	131578
26757	42672	0	applied	\N	\N	\N	\N	131361	131361	29193
26757	42623	1	applied	\N	\N	1000000000	\N	131232	131232	131233
26757	42642	2	applied	\N	\N	1000000000	\N	131283	131283	131284
26757	42743	3	applied	\N	\N	1000000000	\N	131573	131573	131574
26757	42745	4	applied	\N	\N	1000000000	\N	131577	131577	131578
26760	42784	0	applied	\N	\N	\N	\N	131685	131685	131686
26760	42785	1	applied	\N	\N	\N	\N	131687	131687	131688
26760	42786	2	applied	\N	\N	\N	\N	131689	131689	131690
26760	42787	3	applied	\N	\N	\N	\N	131691	131691	131692
26760	42788	4	applied	\N	\N	\N	\N	131693	131693	131694
26760	42789	5	applied	\N	\N	\N	\N	131695	131695	131696
26764	42797	0	applied	\N	\N	\N	\N	131715	131715	131716
26764	42798	1	applied	\N	\N	\N	\N	131717	131717	131718
26764	42799	2	applied	\N	\N	\N	\N	131719	131719	131720
26764	42800	3	applied	\N	\N	\N	\N	131721	131721	131722
26764	42801	4	applied	\N	\N	\N	\N	131723	131723	131724
26764	42802	5	applied	\N	\N	\N	\N	131725	131725	131726
26764	42803	6	applied	\N	\N	\N	\N	131727	131727	131728
26764	42804	7	applied	\N	\N	\N	\N	131729	131729	131730
26764	42805	8	applied	\N	\N	\N	\N	131731	131731	131732
26764	42806	9	applied	\N	\N	\N	\N	131733	131733	131734
26769	42813	0	applied	\N	\N	\N	\N	131757	131757	131758
26769	42814	1	applied	\N	\N	\N	\N	131759	131759	131760
26769	42815	2	applied	\N	\N	\N	\N	131761	131761	131762
26769	42816	3	applied	\N	\N	\N	\N	131763	131763	131764
26769	42817	4	applied	\N	\N	\N	\N	131765	131765	131766
26769	42818	5	applied	\N	\N	\N	\N	131767	131767	131768
26773	42839	0	applied	\N	\N	\N	\N	131814	131814	131815
26773	42840	1	applied	\N	\N	\N	\N	131816	131816	131817
26773	42841	2	applied	\N	\N	\N	\N	131818	131818	131819
26773	42842	3	applied	\N	\N	\N	\N	131820	131820	131821
26773	42843	4	applied	\N	\N	\N	\N	131822	131822	131823
26773	42844	5	applied	\N	\N	\N	\N	131824	131824	131825
26775	42104	0	applied	\N	\N	\N	\N	129674	129674	129675
26775	42105	1	applied	\N	\N	\N	\N	129676	129676	129677
26775	42112	2	applied	\N	\N	\N	\N	129693	129693	129694
26775	42115	3	applied	\N	\N	\N	\N	129699	129699	129700
26775	42116	4	applied	\N	\N	\N	\N	129701	129701	129702
26775	42122	5	applied	\N	\N	\N	\N	129714	129714	129715
26775	42128	6	applied	\N	\N	\N	\N	129730	129730	129731
26775	42132	7	applied	\N	\N	\N	\N	129741	129741	129742
26775	42136	8	applied	\N	\N	\N	\N	129749	129749	129750
26775	42141	9	applied	\N	\N	\N	\N	129762	129762	129763
26775	42144	10	applied	\N	\N	\N	\N	129774	129774	129775
26775	42147	11	applied	\N	\N	\N	\N	129782	129782	129783
26775	42151	12	applied	\N	\N	\N	\N	129792	129792	129793
26775	42154	13	applied	\N	\N	\N	\N	129799	129799	129800
26775	42155	14	applied	\N	\N	\N	\N	129801	129801	129802
26775	42161	15	applied	\N	\N	\N	\N	129817	129817	129834
26775	42164	16	applied	\N	\N	\N	\N	129825	129825	129835
26775	42167	17	applied	\N	\N	\N	\N	129836	129836	129837
26775	42168	18	applied	\N	\N	\N	\N	129838	129838	129839
26775	42170	19	applied	\N	\N	\N	\N	129849	129849	129960
26775	42177	20	applied	\N	\N	\N	\N	129866	129866	129961
26775	42180	21	applied	\N	\N	\N	\N	129878	129878	129962
26775	42181	22	applied	\N	\N	\N	\N	129880	129880	129963
26775	42187	23	applied	\N	\N	\N	\N	129894	129894	129964
26775	42190	24	applied	\N	\N	\N	\N	129902	129902	129965
26775	42191	25	applied	\N	\N	\N	\N	129904	129904	129966
26775	42197	26	applied	\N	\N	\N	\N	129919	129919	129967
26775	42200	27	applied	\N	\N	\N	\N	129926	129926	129968
26775	42203	28	applied	\N	\N	\N	\N	129936	129936	129969
26775	42207	29	applied	\N	\N	\N	\N	129946	129946	129970
26775	42210	30	applied	\N	\N	\N	\N	129952	129952	129971
26775	42213	31	applied	\N	\N	\N	\N	130018	130018	130365
26775	42214	32	applied	\N	\N	\N	\N	130020	130020	130366
26775	42215	33	applied	\N	\N	\N	\N	130022	130022	130367
26775	42223	34	applied	\N	\N	\N	\N	130044	130044	130368
26775	42227	35	applied	\N	\N	\N	\N	130053	130053	130369
26775	42230	36	applied	\N	\N	\N	\N	130062	130062	130370
26775	42233	37	applied	\N	\N	\N	\N	130069	130069	130371
26729	42738	6	applied	\N	\N	\N	\N	131553	131553	131554
26737	42757	0	applied	\N	\N	\N	\N	131607	131607	131608
26737	42758	1	applied	\N	\N	\N	\N	131609	131609	131610
26737	42759	2	applied	\N	\N	\N	\N	131611	131611	131612
26740	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26740	42762	1	applied	\N	\N	\N	\N	131619	131619	131625
26740	42763	2	applied	\N	\N	\N	\N	131621	131621	131626
26742	42760	0	applied	\N	\N	\N	\N	131615	131615	131616
26742	42761	1	applied	\N	\N	\N	\N	131617	131617	131618
26742	42762	2	applied	\N	\N	\N	\N	131619	131619	131620
26742	42763	3	applied	\N	\N	\N	\N	131621	131621	131622
26746	42767	0	applied	\N	\N	\N	\N	131640	131640	131641
26746	42768	1	applied	\N	\N	\N	\N	131642	131642	131643
26746	42769	2	applied	\N	\N	\N	\N	131644	131644	131645
26746	42770	3	applied	\N	\N	\N	\N	131646	131646	131647
26746	42771	4	applied	\N	\N	\N	\N	131648	131648	131649
26746	42772	5	applied	\N	\N	\N	\N	131650	131650	131651
26746	42773	6	applied	\N	\N	\N	\N	131652	131652	131653
26748	42774	0	applied	\N	\N	\N	\N	131658	131658	131659
26748	42775	1	applied	\N	\N	\N	\N	131660	131660	131661
26748	42776	2	applied	\N	\N	\N	\N	131662	131662	131663
26750	42777	0	applied	\N	\N	\N	\N	131666	131666	131667
26750	42778	1	applied	\N	\N	\N	\N	131668	131668	131669
26750	42779	2	applied	\N	\N	\N	\N	131670	131670	131671
26752	42778	0	applied	\N	\N	\N	\N	131668	131668	131669
26752	42779	1	applied	\N	\N	\N	\N	131670	131670	131671
26755	42780	0	applied	\N	\N	\N	\N	131674	131674	131675
26755	42781	1	applied	\N	\N	\N	\N	131676	131676	131677
26755	42782	2	applied	\N	\N	\N	\N	131678	131678	131679
26755	42783	3	applied	\N	\N	\N	\N	131680	131680	131681
26763	42793	0	applied	\N	\N	\N	\N	131706	131706	131707
26763	42794	1	applied	\N	\N	\N	\N	131708	131708	131709
26763	42795	2	applied	\N	\N	\N	\N	131710	131710	131711
26763	42796	3	applied	\N	\N	\N	\N	131712	131712	131713
26768	42807	0	applied	\N	\N	\N	\N	131743	131743	131744
26768	42808	1	applied	\N	\N	\N	\N	131745	131745	131746
26768	42809	2	applied	\N	\N	\N	\N	131747	131747	131748
26768	42810	3	applied	\N	\N	\N	\N	131749	131749	131750
26768	42811	4	applied	\N	\N	\N	\N	131751	131751	131752
26768	42812	5	applied	\N	\N	\N	\N	131753	131753	131754
26770	42819	0	applied	\N	\N	\N	\N	131771	131771	131772
26770	42820	1	applied	\N	\N	\N	\N	131773	131773	131774
26770	42821	2	applied	\N	\N	\N	\N	131775	131775	131776
26770	42822	3	applied	\N	\N	\N	\N	131777	131777	131778
26770	42823	4	applied	\N	\N	\N	\N	131779	131779	131780
26770	42824	5	applied	\N	\N	\N	\N	131781	131781	131782
26770	42825	6	applied	\N	\N	\N	\N	131783	131783	131784
26770	42826	7	applied	\N	\N	\N	\N	131785	131785	131786
26770	42827	8	applied	\N	\N	\N	\N	131787	131787	131788
26770	42828	9	applied	\N	\N	\N	\N	131789	131789	131790
26770	42829	10	applied	\N	\N	\N	\N	131791	131791	131792
26770	42830	11	applied	\N	\N	\N	\N	131793	131793	131794
26770	42831	12	applied	\N	\N	\N	\N	131795	131795	131796
26770	42832	13	applied	\N	\N	\N	\N	131797	131797	131798
26770	42833	14	applied	\N	\N	\N	\N	131799	131799	131800
26770	42834	15	applied	\N	\N	\N	\N	131801	131801	131802
26770	42835	16	applied	\N	\N	\N	\N	131803	131803	131804
26770	42836	17	applied	\N	\N	\N	\N	131805	131805	131806
26770	42837	18	applied	\N	\N	\N	\N	131807	131807	131808
26770	42838	19	applied	\N	\N	\N	\N	131809	131809	131810
26782	42864	0	applied	\N	\N	\N	\N	131881	131881	131882
26782	42865	1	applied	\N	\N	\N	\N	131883	131883	131884
26782	42866	2	applied	\N	\N	\N	\N	131885	131885	131886
26786	42870	0	applied	\N	\N	\N	\N	131905	131905	131906
26786	42871	1	applied	\N	\N	\N	\N	131907	131907	131908
26786	42872	2	applied	\N	\N	\N	\N	131909	131909	131910
26786	42873	3	applied	\N	\N	\N	\N	131911	131911	131912
26788	42870	0	applied	\N	\N	\N	\N	131905	131905	131906
26788	42871	1	applied	\N	\N	\N	\N	131907	131907	131908
26788	42872	2	applied	\N	\N	\N	\N	131909	131909	131910
26788	42873	3	applied	\N	\N	\N	\N	131911	131911	131912
26793	42887	0	applied	\N	\N	\N	\N	131951	131951	131952
26793	42888	1	applied	\N	\N	\N	\N	131953	131953	131954
26793	42889	2	applied	\N	\N	\N	\N	131955	131955	131956
26800	42896	0	applied	\N	\N	\N	\N	131978	131978	131979
26800	42897	1	applied	\N	\N	\N	\N	131980	131980	131981
26800	42898	2	applied	\N	\N	\N	\N	131982	131982	131983
26802	42899	0	applied	\N	\N	\N	\N	131988	131988	131989
26802	42900	1	applied	\N	\N	\N	\N	131990	131990	131991
26802	42901	2	applied	\N	\N	\N	\N	131992	131992	131993
26805	42906	0	applied	\N	\N	\N	\N	132007	132007	132008
26805	42907	1	applied	\N	\N	\N	\N	132009	132009	132010
26805	42908	2	applied	\N	\N	\N	\N	132011	132011	132012
26805	42909	3	applied	\N	\N	\N	\N	132013	132013	132014
26808	42923	0	applied	\N	\N	\N	\N	132045	132045	132046
26808	42924	1	applied	\N	\N	\N	\N	132047	132047	132048
26808	42925	2	applied	\N	\N	\N	\N	132049	132049	132050
26813	42926	0	applied	\N	\N	\N	\N	132057	132057	132058
26813	42927	1	applied	\N	\N	\N	\N	132059	132059	132060
26813	42928	2	applied	\N	\N	\N	\N	132061	132061	132062
26813	42929	3	applied	\N	\N	\N	\N	132063	132063	132064
26813	42930	4	applied	\N	\N	\N	\N	132065	132065	132066
26813	42931	5	applied	\N	\N	\N	\N	132067	132067	132068
26813	42932	6	applied	\N	\N	\N	\N	132069	132069	132070
26825	42960	0	applied	\N	\N	\N	\N	132146	132146	132147
26825	42961	1	applied	\N	\N	\N	\N	132148	132148	132149
26825	42962	2	applied	\N	\N	\N	\N	132150	132150	132151
26825	42963	3	applied	\N	\N	\N	\N	132152	132152	132153
26829	42966	0	applied	\N	\N	\N	\N	132165	132165	132166
26829	42967	1	applied	\N	\N	\N	\N	132167	132167	132168
26829	42968	2	applied	\N	\N	\N	\N	132169	132169	132170
26832	42973	0	applied	\N	\N	\N	\N	132184	132184	132185
26832	42974	1	applied	\N	\N	\N	\N	132186	132186	132187
26832	42975	2	applied	\N	\N	\N	\N	132188	132188	132189
26834	42973	0	applied	\N	\N	\N	\N	132184	132184	132185
26834	42974	1	applied	\N	\N	\N	\N	132186	132186	132187
26837	42989	0	applied	\N	\N	\N	\N	132224	132224	132225
26837	42990	1	applied	\N	\N	\N	\N	132226	132226	132227
26837	42991	2	applied	\N	\N	\N	\N	132228	132228	132229
26839	42992	0	applied	\N	\N	\N	\N	132232	132232	132233
26839	42993	1	applied	\N	\N	\N	\N	132234	132234	132235
26839	42994	2	applied	\N	\N	\N	\N	132236	132236	132237
26839	42995	3	applied	\N	\N	\N	\N	132238	132238	132239
26844	43002	0	applied	\N	\N	\N	\N	132260	132260	132261
26844	43003	1	applied	\N	\N	\N	\N	132262	132262	132263
26844	43004	2	applied	\N	\N	\N	\N	132264	132264	132265
26844	43005	3	applied	\N	\N	\N	\N	132266	132266	132267
26845	43006	0	applied	\N	\N	\N	\N	132270	132270	132271
26845	43007	1	applied	\N	\N	\N	\N	132272	132272	132273
26845	43008	2	applied	\N	\N	\N	\N	132274	132274	132275
26758	42788	4	applied	\N	\N	\N	\N	131693	131693	131694
26758	42789	5	applied	\N	\N	\N	\N	131695	131695	131696
26762	42790	0	applied	\N	\N	\N	\N	131700	131700	131701
26762	42791	1	applied	\N	\N	\N	\N	131702	131702	131703
26762	42792	2	applied	\N	\N	\N	\N	131704	131704	131705
26766	42797	0	applied	\N	\N	\N	\N	131715	131715	131716
26766	42798	1	applied	\N	\N	\N	\N	131717	131717	131718
26766	42799	2	applied	\N	\N	\N	\N	131719	131719	131720
26766	42800	3	applied	\N	\N	\N	\N	131721	131721	131722
26766	42801	4	applied	\N	\N	\N	\N	131723	131723	131724
26766	42802	5	applied	\N	\N	\N	\N	131725	131725	131726
26766	42803	6	applied	\N	\N	\N	\N	131727	131727	131728
26766	42804	7	applied	\N	\N	\N	\N	131729	131729	131730
26766	42805	8	applied	\N	\N	\N	\N	131731	131731	131732
26766	42806	9	applied	\N	\N	\N	\N	131733	131733	131734
26767	42797	0	applied	\N	\N	\N	\N	131715	131715	131716
26767	42798	1	applied	\N	\N	\N	\N	131717	131717	131718
26767	42799	2	applied	\N	\N	\N	\N	131719	131719	131720
26767	42800	3	applied	\N	\N	\N	\N	131721	131721	131722
26767	42801	4	applied	\N	\N	\N	\N	131723	131723	131724
26767	42802	5	applied	\N	\N	\N	\N	131725	131725	131726
26767	42803	6	applied	\N	\N	\N	\N	131727	131727	131728
26767	42804	7	applied	\N	\N	\N	\N	131729	131729	131730
26767	42805	8	applied	\N	\N	\N	\N	131731	131731	131732
26767	42806	9	applied	\N	\N	\N	\N	131733	131733	131734
26772	42839	0	applied	\N	\N	\N	\N	131814	131814	131815
26772	42840	1	applied	\N	\N	\N	\N	131816	131816	131817
26772	42841	2	applied	\N	\N	\N	\N	131818	131818	131819
26772	42842	3	applied	\N	\N	\N	\N	131820	131820	131821
26772	42843	4	applied	\N	\N	\N	\N	131822	131822	131823
26772	42844	5	applied	\N	\N	\N	\N	131824	131824	131825
26776	42104	0	applied	\N	\N	\N	\N	129674	129674	129675
26776	42105	1	applied	\N	\N	\N	\N	129676	129676	129677
26776	42112	2	applied	\N	\N	\N	\N	129693	129693	129694
26776	42115	3	applied	\N	\N	\N	\N	129699	129699	129700
26776	42116	4	applied	\N	\N	\N	\N	129701	129701	129702
26776	42122	5	applied	\N	\N	\N	\N	129714	129714	129715
26776	42128	6	applied	\N	\N	\N	\N	129730	129730	129731
26776	42132	7	applied	\N	\N	\N	\N	129741	129741	129742
26776	42136	8	applied	\N	\N	\N	\N	129749	129749	129750
26776	42141	9	applied	\N	\N	\N	\N	129762	129762	129763
26776	42144	10	applied	\N	\N	\N	\N	129774	129774	129775
26776	42147	11	applied	\N	\N	\N	\N	129782	129782	129783
26776	42151	12	applied	\N	\N	\N	\N	129792	129792	129793
26776	42154	13	applied	\N	\N	\N	\N	129799	129799	129800
26776	42155	14	applied	\N	\N	\N	\N	129801	129801	129802
26776	42161	15	applied	\N	\N	\N	\N	129817	129817	129834
26776	42164	16	applied	\N	\N	\N	\N	129825	129825	129835
26776	42167	17	applied	\N	\N	\N	\N	129836	129836	129837
26776	42168	18	applied	\N	\N	\N	\N	129838	129838	129839
26776	42170	19	applied	\N	\N	\N	\N	129849	129849	129960
26776	42177	20	applied	\N	\N	\N	\N	129866	129866	129961
26776	42180	21	applied	\N	\N	\N	\N	129878	129878	129962
26776	42181	22	applied	\N	\N	\N	\N	129880	129880	129963
26776	42187	23	applied	\N	\N	\N	\N	129894	129894	129964
26776	42190	24	applied	\N	\N	\N	\N	129902	129902	129965
26776	42191	25	applied	\N	\N	\N	\N	129904	129904	129966
26776	42197	26	applied	\N	\N	\N	\N	129919	129919	129967
26776	42200	27	applied	\N	\N	\N	\N	129926	129926	129968
26776	42203	28	applied	\N	\N	\N	\N	129936	129936	129969
26776	42207	29	applied	\N	\N	\N	\N	129946	129946	129970
26776	42210	30	applied	\N	\N	\N	\N	129952	129952	129971
26776	42213	31	applied	\N	\N	\N	\N	130018	130018	130365
26776	42214	32	applied	\N	\N	\N	\N	130020	130020	130366
26776	42215	33	applied	\N	\N	\N	\N	130022	130022	130367
26776	42223	34	applied	\N	\N	\N	\N	130044	130044	130368
26776	42227	35	applied	\N	\N	\N	\N	130053	130053	130369
26776	42230	36	applied	\N	\N	\N	\N	130062	130062	130370
26776	42233	37	applied	\N	\N	\N	\N	130069	130069	130371
26776	42236	38	applied	\N	\N	\N	\N	130081	130081	130372
26776	42240	39	applied	\N	\N	\N	\N	130090	130090	130373
26776	42243	40	applied	\N	\N	\N	\N	130107	130107	130374
26776	42246	41	applied	\N	\N	\N	\N	130114	130114	130375
26776	42250	42	applied	\N	\N	\N	\N	130124	130124	130376
26776	42253	43	applied	\N	\N	\N	\N	130134	130134	130377
26776	42256	44	applied	\N	\N	\N	\N	130142	130142	130378
26776	42260	45	applied	\N	\N	\N	\N	130151	130151	130379
26776	42261	46	applied	\N	\N	\N	\N	130153	130153	130380
26776	42262	47	applied	\N	\N	\N	\N	130155	130155	130381
26776	42269	48	applied	\N	\N	\N	\N	130174	130174	130382
26776	42270	49	applied	\N	\N	\N	\N	130176	130176	130383
26776	42276	50	applied	\N	\N	\N	\N	130194	130194	130384
26776	42280	51	applied	\N	\N	\N	\N	130202	130202	130385
26776	42281	52	applied	\N	\N	\N	\N	130204	130204	130386
26776	42289	53	applied	\N	\N	\N	\N	130220	130220	130387
26776	42290	54	applied	\N	\N	\N	\N	130222	130222	130388
26776	42298	55	applied	\N	\N	\N	\N	130245	130245	130389
26776	42299	57	applied	\N	\N	\N	\N	130247	130247	130390
26776	42300	58	applied	\N	\N	\N	\N	130249	130249	130391
26776	42308	59	applied	\N	\N	\N	\N	130267	130267	130392
26776	42311	60	applied	\N	\N	\N	\N	130276	130276	130393
26776	42313	61	applied	\N	\N	\N	\N	130281	130281	130394
26776	42317	62	applied	\N	\N	\N	\N	130290	130290	130395
26776	42320	63	applied	\N	\N	\N	\N	130298	130298	130396
26776	42321	64	applied	\N	\N	\N	\N	130300	130300	130397
26776	42327	65	applied	\N	\N	\N	\N	130313	130313	130398
26776	42328	66	applied	\N	\N	\N	\N	130315	130315	130399
26776	42333	67	applied	\N	\N	\N	\N	130326	130326	130400
26776	42336	68	applied	\N	\N	\N	\N	130336	130336	130401
26776	42340	69	applied	\N	\N	\N	\N	130350	130350	130402
26776	42343	70	applied	\N	\N	\N	\N	130357	130357	130958
26776	42346	71	applied	\N	\N	\N	\N	130415	130415	130959
26776	42349	72	applied	\N	\N	\N	\N	130422	130422	130960
26776	42353	73	applied	\N	\N	\N	\N	130432	130432	130961
26776	42356	74	applied	\N	\N	\N	\N	130443	130443	130962
26776	42357	75	applied	\N	\N	\N	\N	130445	130445	130963
26776	42363	76	applied	\N	\N	\N	\N	130460	130460	130964
26776	42367	77	applied	\N	\N	\N	\N	130470	130470	130965
26776	42370	78	applied	\N	\N	\N	\N	130477	130477	130966
26776	42371	79	applied	\N	\N	\N	\N	130479	130479	130967
26776	42372	80	applied	\N	\N	\N	\N	130481	130481	130968
26776	42382	81	applied	\N	\N	\N	\N	130503	130503	130969
26776	42386	82	applied	\N	\N	\N	\N	130512	130512	130970
26776	42387	83	applied	\N	\N	\N	\N	130514	130514	130971
26776	42392	84	applied	\N	\N	\N	\N	130527	130527	130972
26776	42393	85	applied	\N	\N	\N	\N	130529	130529	130973
26776	42399	86	applied	\N	\N	\N	\N	130552	130552	130974
26776	42400	87	applied	\N	\N	\N	\N	130554	130554	130975
26776	42405	88	applied	\N	\N	\N	\N	130569	130569	130976
26776	42409	89	applied	\N	\N	\N	\N	130578	130578	130977
26775	42236	38	applied	\N	\N	\N	\N	130081	130081	130372
26775	42240	39	applied	\N	\N	\N	\N	130090	130090	130373
26775	42243	40	applied	\N	\N	\N	\N	130107	130107	130374
26775	42246	41	applied	\N	\N	\N	\N	130114	130114	130375
26775	42250	42	applied	\N	\N	\N	\N	130124	130124	130376
26775	42253	43	applied	\N	\N	\N	\N	130134	130134	130377
26775	42256	44	applied	\N	\N	\N	\N	130142	130142	130378
26775	42260	45	applied	\N	\N	\N	\N	130151	130151	130379
26775	42261	46	applied	\N	\N	\N	\N	130153	130153	130380
26775	42262	47	applied	\N	\N	\N	\N	130155	130155	130381
26775	42269	48	applied	\N	\N	\N	\N	130174	130174	130382
26775	42270	49	applied	\N	\N	\N	\N	130176	130176	130383
26775	42276	50	applied	\N	\N	\N	\N	130194	130194	130384
26775	42280	51	applied	\N	\N	\N	\N	130202	130202	130385
26775	42281	52	applied	\N	\N	\N	\N	130204	130204	130386
26775	42289	53	applied	\N	\N	\N	\N	130220	130220	130387
26775	42290	54	applied	\N	\N	\N	\N	130222	130222	130388
26775	42298	55	applied	\N	\N	\N	\N	130245	130245	130389
26775	42299	56	applied	\N	\N	\N	\N	130247	130247	130390
26775	42300	57	applied	\N	\N	\N	\N	130249	130249	130391
26775	42308	58	applied	\N	\N	\N	\N	130267	130267	130392
26775	42311	59	applied	\N	\N	\N	\N	130276	130276	130393
26775	42313	60	applied	\N	\N	\N	\N	130281	130281	130394
26775	42317	61	applied	\N	\N	\N	\N	130290	130290	130395
26775	42320	62	applied	\N	\N	\N	\N	130298	130298	130396
26775	42321	63	applied	\N	\N	\N	\N	130300	130300	130397
26775	42327	64	applied	\N	\N	\N	\N	130313	130313	130398
26775	42328	65	applied	\N	\N	\N	\N	130315	130315	130399
26775	42333	66	applied	\N	\N	\N	\N	130326	130326	130400
26775	42336	67	applied	\N	\N	\N	\N	130336	130336	130401
26775	42340	68	applied	\N	\N	\N	\N	130350	130350	130402
26775	42343	69	applied	\N	\N	\N	\N	130357	130357	130958
26775	42346	70	applied	\N	\N	\N	\N	130415	130415	130959
26775	42349	71	applied	\N	\N	\N	\N	130422	130422	130960
26775	42353	72	applied	\N	\N	\N	\N	130432	130432	130961
26775	42356	73	applied	\N	\N	\N	\N	130443	130443	130962
26775	42357	74	applied	\N	\N	\N	\N	130445	130445	130963
26775	42363	75	applied	\N	\N	\N	\N	130460	130460	130964
26775	42367	76	applied	\N	\N	\N	\N	130470	130470	130965
26775	42370	77	applied	\N	\N	\N	\N	130477	130477	130966
26775	42371	78	applied	\N	\N	\N	\N	130479	130479	130967
26775	42372	79	applied	\N	\N	\N	\N	130481	130481	130968
26775	42382	80	applied	\N	\N	\N	\N	130503	130503	130969
26775	42386	81	applied	\N	\N	\N	\N	130512	130512	130970
26775	42387	82	applied	\N	\N	\N	\N	130514	130514	130971
26775	42392	83	applied	\N	\N	\N	\N	130527	130527	130972
26775	42393	84	applied	\N	\N	\N	\N	130529	130529	130973
26775	42399	86	applied	\N	\N	\N	\N	130552	130552	130974
26775	42400	87	applied	\N	\N	\N	\N	130554	130554	130975
26775	42405	88	applied	\N	\N	\N	\N	130569	130569	130976
26775	42409	89	applied	\N	\N	\N	\N	130578	130578	130977
26775	42410	90	applied	\N	\N	\N	\N	130580	130580	130978
26775	42415	91	applied	\N	\N	\N	\N	130590	130590	130979
26775	42419	92	applied	\N	\N	\N	\N	130600	130600	130980
26775	42420	93	applied	\N	\N	\N	\N	130602	130602	130981
26775	42425	94	applied	\N	\N	\N	\N	130621	130621	130982
26775	42429	95	applied	\N	\N	\N	\N	130631	130631	130983
26775	42434	96	applied	\N	\N	\N	\N	130644	130644	130984
26775	42437	97	applied	\N	\N	\N	\N	130652	130652	130985
26775	42438	98	applied	\N	\N	\N	\N	130654	130654	130986
26775	42439	99	applied	\N	\N	\N	\N	130656	130656	130987
26775	42447	100	applied	\N	\N	\N	\N	130673	130673	130988
26775	42451	101	applied	\N	\N	\N	\N	130686	130686	130989
26775	42453	102	applied	\N	\N	\N	\N	130691	130691	130990
26775	42456	103	applied	\N	\N	\N	\N	130705	130705	130991
26775	42464	104	applied	\N	\N	\N	\N	130724	130724	130992
26775	42472	105	applied	\N	\N	\N	\N	130747	130747	130993
26775	42473	106	applied	\N	\N	\N	\N	130749	130749	130994
26775	42474	107	applied	\N	\N	\N	\N	130751	130751	130995
26775	42475	108	applied	\N	\N	\N	\N	130753	130753	130996
26775	42476	109	applied	\N	\N	\N	\N	130755	130755	130997
26775	42494	110	applied	\N	\N	\N	\N	130800	130800	130998
26775	42497	111	applied	\N	\N	\N	\N	130808	130808	130999
26775	42500	112	applied	\N	\N	\N	\N	130816	130816	131000
26775	42503	113	applied	\N	\N	\N	\N	130824	130824	131001
26775	42504	114	applied	\N	\N	\N	\N	130826	130826	131002
26775	42510	115	applied	\N	\N	\N	\N	130844	130844	131003
26775	42514	116	applied	\N	\N	\N	\N	130853	130853	131004
26775	42518	117	applied	\N	\N	\N	\N	130864	130864	131005
26775	42523	118	applied	\N	\N	\N	\N	130877	130877	131006
26775	42527	119	applied	\N	\N	\N	\N	130890	130890	131007
26775	42528	120	applied	\N	\N	\N	\N	130892	130892	131008
26775	42529	121	applied	\N	\N	\N	\N	130894	130894	131009
26775	42536	122	applied	\N	\N	\N	\N	130913	130913	131010
26775	42540	123	applied	\N	\N	\N	\N	130923	130923	131011
26775	42541	124	applied	\N	\N	\N	\N	130925	130925	131012
26775	42546	125	applied	\N	\N	\N	\N	130939	130939	131013
26777	42845	0	applied	\N	\N	\N	\N	131835	131835	131836
26777	42846	1	applied	\N	\N	\N	\N	131837	131837	131838
26777	42847	2	applied	\N	\N	\N	\N	131839	131839	131840
26777	42848	3	applied	\N	\N	\N	\N	131841	131841	131842
26780	42857	0	applied	\N	\N	1000000000	\N	131863	131863	131864
26780	42858	1	applied	\N	\N	1000000000	\N	131865	131865	131866
26780	42863	2	applied	\N	\N	\N	\N	131875	131875	131879
26787	42870	0	applied	\N	\N	\N	\N	131905	131905	131906
26787	42871	1	applied	\N	\N	\N	\N	131907	131907	131908
26787	42872	2	applied	\N	\N	\N	\N	131909	131909	131910
26787	42873	3	applied	\N	\N	\N	\N	131911	131911	131912
26789	42874	0	applied	\N	\N	\N	\N	131918	131918	131919
26789	42875	1	applied	\N	\N	\N	\N	131920	131920	131921
26789	42876	2	applied	\N	\N	\N	\N	131922	131922	131923
26794	42887	0	applied	\N	\N	\N	\N	131951	131951	131952
26794	42888	1	applied	\N	\N	\N	\N	131953	131953	131954
26794	42889	2	applied	\N	\N	\N	\N	131955	131955	131956
26798	42890	0	applied	\N	\N	\N	\N	131961	131961	131962
26798	42891	1	applied	\N	\N	\N	\N	131963	131963	131964
26801	42896	0	applied	\N	\N	\N	\N	131978	131978	131979
26801	42897	1	applied	\N	\N	\N	\N	131980	131980	131981
26801	42898	2	applied	\N	\N	\N	\N	131982	131982	131983
26803	42899	0	applied	\N	\N	\N	\N	131988	131988	131989
26803	42900	1	applied	\N	\N	\N	\N	131990	131990	131991
26803	42901	2	applied	\N	\N	\N	\N	131992	131992	131993
26806	42910	0	applied	\N	\N	\N	\N	132017	132017	132018
26806	42911	1	applied	\N	\N	\N	\N	132019	132019	132020
26806	42912	2	applied	\N	\N	\N	\N	132021	132021	132022
26806	42913	3	applied	\N	\N	\N	\N	132023	132023	132024
26806	42914	4	applied	\N	\N	\N	\N	132025	132025	132026
26806	42915	5	applied	\N	\N	\N	\N	132027	132027	132028
26806	42916	6	applied	\N	\N	\N	\N	132029	132029	132030
26776	42410	90	applied	\N	\N	\N	\N	130580	130580	130978
26776	42415	91	applied	\N	\N	\N	\N	130590	130590	130979
26776	42419	92	applied	\N	\N	\N	\N	130600	130600	130980
26776	42420	93	applied	\N	\N	\N	\N	130602	130602	130981
26776	42425	94	applied	\N	\N	\N	\N	130621	130621	130982
26776	42429	95	applied	\N	\N	\N	\N	130631	130631	130983
26776	42434	96	applied	\N	\N	\N	\N	130644	130644	130984
26776	42437	97	applied	\N	\N	\N	\N	130652	130652	130985
26776	42438	98	applied	\N	\N	\N	\N	130654	130654	130986
26776	42439	99	applied	\N	\N	\N	\N	130656	130656	130987
26776	42447	100	applied	\N	\N	\N	\N	130673	130673	130988
26776	42451	101	applied	\N	\N	\N	\N	130686	130686	130989
26776	42453	102	applied	\N	\N	\N	\N	130691	130691	130990
26776	42456	103	applied	\N	\N	\N	\N	130705	130705	130991
26776	42464	104	applied	\N	\N	\N	\N	130724	130724	130992
26776	42472	105	applied	\N	\N	\N	\N	130747	130747	130993
26776	42473	106	applied	\N	\N	\N	\N	130749	130749	130994
26776	42474	107	applied	\N	\N	\N	\N	130751	130751	130995
26776	42475	108	applied	\N	\N	\N	\N	130753	130753	130996
26776	42476	109	applied	\N	\N	\N	\N	130755	130755	130997
26776	42494	110	applied	\N	\N	\N	\N	130800	130800	130998
26776	42497	111	applied	\N	\N	\N	\N	130808	130808	130999
26776	42500	112	applied	\N	\N	\N	\N	130816	130816	131000
26776	42503	113	applied	\N	\N	\N	\N	130824	130824	131001
26776	42504	114	applied	\N	\N	\N	\N	130826	130826	131002
26776	42510	115	applied	\N	\N	\N	\N	130844	130844	131003
26776	42514	116	applied	\N	\N	\N	\N	130853	130853	131004
26776	42518	117	applied	\N	\N	\N	\N	130864	130864	131005
26776	42523	118	applied	\N	\N	\N	\N	130877	130877	131006
26776	42527	119	applied	\N	\N	\N	\N	130890	130890	131007
26776	42528	120	applied	\N	\N	\N	\N	130892	130892	131008
26776	42529	121	applied	\N	\N	\N	\N	130894	130894	131009
26776	42536	122	applied	\N	\N	\N	\N	130913	130913	131010
26776	42540	123	applied	\N	\N	\N	\N	130923	130923	131011
26776	42541	124	applied	\N	\N	\N	\N	130925	130925	131012
26776	42546	125	applied	\N	\N	\N	\N	130939	130939	131013
26778	42849	0	applied	\N	\N	\N	\N	131845	131845	131846
26778	42850	1	applied	\N	\N	\N	\N	131847	131847	131848
26778	42851	2	applied	\N	\N	\N	\N	131849	131849	131850
26779	42852	0	applied	\N	\N	\N	\N	131852	131852	131853
26779	42853	1	applied	\N	\N	\N	\N	131854	131854	131855
26779	42854	2	applied	\N	\N	\N	\N	131856	131856	131857
26779	42855	3	applied	\N	\N	\N	\N	131858	131858	131859
26779	42856	5	applied	\N	\N	\N	\N	131861	131861	131862
26779	42857	6	applied	\N	\N	1000000000	\N	131863	131863	131864
26779	42858	7	applied	\N	\N	1000000000	\N	131865	131865	131866
26779	42859	8	applied	\N	\N	\N	\N	131867	131867	131868
26779	42860	9	applied	\N	\N	\N	\N	131869	131869	131870
26779	42861	10	applied	\N	\N	\N	\N	131871	131871	131872
26779	42862	11	applied	\N	\N	\N	\N	131873	131873	131874
26779	42863	12	applied	\N	\N	\N	\N	131875	131875	131876
26781	42864	0	applied	\N	\N	\N	\N	131881	131881	131882
26781	42865	1	applied	\N	\N	\N	\N	131883	131883	131884
26781	42866	2	applied	\N	\N	\N	\N	131885	131885	131886
26783	42867	0	applied	\N	\N	\N	\N	131891	131891	131892
26783	42868	1	applied	\N	\N	\N	\N	131893	131893	131894
26783	42869	2	applied	\N	\N	\N	\N	131895	131895	131896
26784	42511	0	applied	\N	\N	1000000000	\N	130846	130846	130847
26784	42537	1	applied	\N	\N	\N	\N	130915	130915	130916
26784	42672	2	applied	\N	\N	\N	\N	131361	131361	29193
26784	42373	3	applied	\N	\N	\N	\N	130483	130483	130484
26784	42374	4	applied	\N	\N	\N	\N	130485	130485	130486
26784	42121	5	applied	\N	\N	\N	\N	129711	129711	131898
26784	42137	6	applied	\N	\N	\N	\N	129751	129751	129704
26784	42149	7	applied	\N	\N	\N	\N	129786	129786	131899
26784	42156	8	applied	\N	\N	\N	\N	129803	129803	130410
26784	42169	9	applied	\N	\N	\N	\N	129841	129841	129706
26784	42186	10	applied	\N	\N	\N	\N	129890	129890	130411
26784	42192	11	applied	\N	\N	\N	\N	129906	129906	129708
26784	42204	12	applied	\N	\N	\N	\N	129938	129938	129981
26784	42219	13	applied	\N	\N	\N	\N	130031	130031	131900
26784	42225	14	applied	\N	\N	\N	\N	130048	130048	129710
26784	42238	15	applied	\N	\N	\N	\N	130085	130085	129712
26784	42247	16	applied	\N	\N	\N	\N	130116	130116	130412
26784	42259	17	applied	\N	\N	\N	\N	130148	130148	131901
26784	42271	18	applied	\N	\N	\N	\N	130178	130178	129721
26791	42874	0	applied	\N	\N	\N	\N	131918	131918	131919
26791	42875	1	applied	\N	\N	\N	\N	131920	131920	131921
26791	42876	2	applied	\N	\N	\N	\N	131922	131922	131923
26795	42887	0	applied	\N	\N	\N	\N	131951	131951	131952
26795	42888	1	applied	\N	\N	\N	\N	131953	131953	131954
26795	42889	2	applied	\N	\N	\N	\N	131955	131955	131956
26796	42887	0	applied	\N	\N	\N	\N	131951	131951	131952
26796	42888	1	applied	\N	\N	\N	\N	131953	131953	131954
26796	42889	2	applied	\N	\N	\N	\N	131955	131955	131956
26797	42890	0	applied	\N	\N	\N	\N	131961	131961	131962
26797	42891	1	applied	\N	\N	\N	\N	131963	131963	131964
26804	42902	0	applied	\N	\N	\N	\N	131997	131997	131998
26804	42903	1	applied	\N	\N	\N	\N	131999	131999	132000
26804	42904	2	applied	\N	\N	\N	\N	132001	132001	132002
26804	42905	3	applied	\N	\N	\N	\N	132003	132003	132004
26810	42923	0	applied	\N	\N	\N	\N	132045	132045	132046
26810	42924	1	applied	\N	\N	\N	\N	132047	132047	132048
26810	42925	2	applied	\N	\N	\N	\N	132049	132049	132050
26812	42926	0	applied	\N	\N	\N	\N	132057	132057	132058
26812	42927	1	applied	\N	\N	\N	\N	132059	132059	132060
26812	42928	2	applied	\N	\N	\N	\N	132061	132061	132062
26812	42929	3	applied	\N	\N	\N	\N	132063	132063	132064
26812	42930	4	applied	\N	\N	\N	\N	132065	132065	132066
26812	42931	5	applied	\N	\N	\N	\N	132067	132067	132068
26812	42932	6	applied	\N	\N	\N	\N	132069	132069	132070
26816	42946	0	applied	\N	\N	\N	\N	132103	132103	132104
26816	42947	2	applied	\N	\N	\N	\N	132106	132106	132107
26816	42948	3	applied	\N	\N	\N	\N	132108	132108	132109
26816	42949	4	applied	\N	\N	\N	\N	132110	132110	132111
26818	42950	0	applied	\N	\N	\N	\N	132117	132117	111296
26818	42953	1	applied	\N	\N	\N	\N	132123	132123	132124
26818	42951	2	applied	\N	\N	\N	\N	132118	132118	132119
26818	42952	3	applied	\N	\N	\N	\N	132120	132120	132121
26820	42953	0	applied	\N	\N	\N	\N	132123	132123	132124
26820	42954	1	applied	\N	\N	\N	\N	132126	132126	132127
26820	42955	2	applied	\N	\N	\N	\N	132128	132128	132129
26820	42956	3	applied	\N	\N	\N	\N	132130	132130	132131
26822	42957	0	applied	\N	\N	\N	\N	132136	132136	132137
26822	42958	1	applied	\N	\N	\N	\N	132138	132138	132139
26822	42959	2	applied	\N	\N	\N	\N	132140	132140	132141
26824	42960	0	applied	\N	\N	\N	\N	132146	132146	132147
26824	42961	1	applied	\N	\N	\N	\N	132148	132148	132149
26824	42962	2	applied	\N	\N	\N	\N	132150	132150	132151
26806	42917	7	applied	\N	\N	\N	\N	132031	132031	132032
26806	42918	8	applied	\N	\N	\N	\N	132033	132033	132034
26806	42919	9	applied	\N	\N	\N	\N	132035	132035	132036
26809	42923	0	applied	\N	\N	\N	\N	132045	132045	132046
26809	42924	1	applied	\N	\N	\N	\N	132047	132047	132048
26809	42925	2	applied	\N	\N	\N	\N	132049	132049	132050
26814	42933	0	applied	\N	\N	\N	\N	132075	132075	132076
26814	42934	1	applied	\N	\N	\N	\N	132077	132077	132078
26814	42935	2	applied	\N	\N	\N	\N	132079	132079	132080
26814	42936	3	applied	\N	\N	\N	\N	132081	132081	132082
26814	42937	4	applied	\N	\N	\N	\N	132083	132083	132084
26814	42938	5	applied	\N	\N	\N	\N	132085	132085	132086
26814	42939	6	applied	\N	\N	\N	\N	132087	132087	132088
26814	42940	7	applied	\N	\N	\N	\N	132089	132089	132090
26814	42941	8	applied	\N	\N	\N	\N	132091	132091	132092
26814	42942	9	applied	\N	\N	\N	\N	132093	132093	132094
26814	42943	10	applied	\N	\N	\N	\N	132095	132095	132096
26814	42944	11	applied	\N	\N	\N	\N	132097	132097	132098
26814	42945	12	applied	\N	\N	\N	\N	132099	132099	132100
26821	42346	0	applied	\N	\N	\N	\N	130415	130415	130416
26821	42349	1	applied	\N	\N	\N	\N	130422	130422	130423
26821	42353	2	applied	\N	\N	\N	\N	130432	130432	130433
26821	42356	3	applied	\N	\N	\N	\N	130443	130443	130444
26821	42357	4	applied	\N	\N	\N	\N	130445	130445	130446
26821	42363	5	applied	\N	\N	\N	\N	130460	130460	130461
26821	42367	6	applied	\N	\N	\N	\N	130470	130470	130471
26821	42370	7	applied	\N	\N	\N	\N	130477	130477	130478
26821	42371	8	applied	\N	\N	\N	\N	130479	130479	130480
26821	42372	9	applied	\N	\N	\N	\N	130481	130481	130482
26821	42382	10	applied	\N	\N	\N	\N	130503	130503	130504
26821	42386	11	applied	\N	\N	\N	\N	130512	130512	130513
26821	42387	12	applied	\N	\N	\N	\N	130514	130514	130515
26821	42392	13	applied	\N	\N	\N	\N	130527	130527	130528
26821	42393	14	applied	\N	\N	\N	\N	130529	130529	130530
26821	42399	15	applied	\N	\N	\N	\N	130552	130552	130553
26821	42400	16	applied	\N	\N	\N	\N	130554	130554	130555
26821	42405	17	applied	\N	\N	\N	\N	130569	130569	130570
26821	42409	18	applied	\N	\N	\N	\N	130578	130578	130579
26821	42410	19	applied	\N	\N	\N	\N	130580	130580	130581
26821	42415	20	applied	\N	\N	\N	\N	130590	130590	130591
26821	42419	21	applied	\N	\N	\N	\N	130600	130600	130601
26821	42420	22	applied	\N	\N	\N	\N	130602	130602	130603
26821	42425	23	applied	\N	\N	\N	\N	130621	130621	130622
26821	42429	24	applied	\N	\N	\N	\N	130631	130631	130632
26821	42434	25	applied	\N	\N	\N	\N	130644	130644	130645
26821	42437	26	applied	\N	\N	\N	\N	130652	130652	130653
26821	42438	27	applied	\N	\N	\N	\N	130654	130654	130655
26821	42439	28	applied	\N	\N	\N	\N	130656	130656	130657
26821	42447	29	applied	\N	\N	\N	\N	130673	130673	130674
26821	42451	30	applied	\N	\N	\N	\N	130686	130686	130687
26821	42453	31	applied	\N	\N	\N	\N	130691	130691	130692
26821	42456	32	applied	\N	\N	\N	\N	130705	130705	130706
26821	42464	33	applied	\N	\N	\N	\N	130724	130724	130725
26821	42472	34	applied	\N	\N	\N	\N	130747	130747	130748
26821	42473	35	applied	\N	\N	\N	\N	130749	130749	130750
26821	42474	36	applied	\N	\N	\N	\N	130751	130751	130752
26821	42475	37	applied	\N	\N	\N	\N	130753	130753	130754
26821	42476	38	applied	\N	\N	\N	\N	130755	130755	130756
26821	42494	39	applied	\N	\N	\N	\N	130800	130800	130801
26821	42497	40	applied	\N	\N	\N	\N	130808	130808	130809
26821	42500	41	applied	\N	\N	\N	\N	130816	130816	130817
26821	42503	42	applied	\N	\N	\N	\N	130824	130824	130825
26821	42504	43	applied	\N	\N	\N	\N	130826	130826	130827
26821	42510	44	applied	\N	\N	\N	\N	130844	130844	130845
26821	42514	45	applied	\N	\N	\N	\N	130853	130853	130854
26821	42518	46	applied	\N	\N	\N	\N	130864	130864	130865
26821	42523	47	applied	\N	\N	\N	\N	130877	130877	130878
26821	42527	48	applied	\N	\N	\N	\N	130890	130890	130891
26821	42528	49	applied	\N	\N	\N	\N	130892	130892	130893
26821	42529	50	applied	\N	\N	\N	\N	130894	130894	130895
26821	42536	51	applied	\N	\N	\N	\N	130913	130913	130914
26821	42540	52	applied	\N	\N	\N	\N	130923	130923	130924
26821	42541	53	applied	\N	\N	\N	\N	130925	130925	130926
26821	42546	54	applied	\N	\N	\N	\N	130939	130939	130940
26821	42550	55	applied	\N	\N	\N	\N	130950	130950	130951
26821	42553	56	applied	\N	\N	\N	\N	131033	131033	131034
26821	42556	57	applied	\N	\N	\N	\N	131044	131044	131045
26821	42560	58	applied	\N	\N	\N	\N	131056	131056	131057
26821	42563	59	applied	\N	\N	\N	\N	131063	131063	131064
26821	42566	60	applied	\N	\N	\N	\N	131070	131070	131071
26821	42567	61	applied	\N	\N	\N	\N	131072	131072	131073
26821	42573	62	applied	\N	\N	\N	\N	131089	131089	131090
26821	42576	63	applied	\N	\N	\N	\N	131099	131099	131100
26821	42577	64	applied	\N	\N	\N	\N	131101	131101	131102
26821	42583	65	applied	\N	\N	\N	\N	131127	131127	131128
26821	42586	66	applied	\N	\N	\N	\N	131134	131134	131135
26821	42589	67	applied	\N	\N	\N	\N	131142	131142	131143
26821	42593	68	applied	\N	\N	\N	\N	131155	131155	131156
26823	42906	0	applied	\N	\N	\N	\N	132143	132143	132008
26823	42857	1	applied	\N	\N	1000000000	\N	131863	131863	131864
26823	42858	2	applied	\N	\N	1000000000	\N	131865	131865	131866
26826	42960	0	applied	\N	\N	\N	\N	132146	132146	132147
26826	42961	1	applied	\N	\N	\N	\N	132148	132148	132149
26826	42962	2	applied	\N	\N	\N	\N	132150	132150	132151
26826	42963	3	applied	\N	\N	\N	\N	132152	132152	132153
26830	42969	0	applied	\N	\N	\N	\N	132173	132173	132174
26830	42970	1	applied	\N	\N	\N	\N	132175	132175	132176
26830	42971	2	applied	\N	\N	\N	\N	132177	132177	132178
26830	42972	3	applied	\N	\N	\N	\N	132179	132179	132180
26833	42973	0	applied	\N	\N	\N	\N	132184	132184	132185
26833	42974	1	applied	\N	\N	\N	\N	132186	132186	132187
26833	42975	2	applied	\N	\N	\N	\N	132188	132188	132189
26835	42976	0	applied	\N	\N	\N	\N	132195	132195	132196
26835	42977	1	applied	\N	\N	\N	\N	132197	132197	132198
26835	42978	2	applied	\N	\N	\N	\N	132199	132199	132200
26835	42979	3	applied	\N	\N	\N	\N	132201	132201	132202
26835	42980	4	applied	\N	\N	\N	\N	132203	132203	132204
26835	42981	5	applied	\N	\N	\N	\N	132205	132205	132206
26835	42982	6	applied	\N	\N	\N	\N	132207	132207	132208
26835	42983	7	applied	\N	\N	\N	\N	132209	132209	132210
26835	42984	8	applied	\N	\N	\N	\N	132211	132211	132212
26835	42985	9	applied	\N	\N	\N	\N	132213	132213	132214
26838	42989	0	applied	\N	\N	\N	\N	132224	132224	132225
26838	42990	1	applied	\N	\N	\N	\N	132226	132226	132227
26838	42991	2	applied	\N	\N	\N	\N	132228	132228	132229
26840	42992	0	applied	\N	\N	\N	\N	132232	132232	132233
26840	42993	1	applied	\N	\N	\N	\N	132234	132234	132235
26840	42994	2	applied	\N	\N	\N	\N	132236	132236	132237
26840	42995	3	applied	\N	\N	\N	\N	132238	132238	132239
26817	42952	2	applied	\N	\N	\N	\N	132120	132120	132121
26819	42953	0	applied	\N	\N	\N	\N	132123	132123	132124
26819	42954	1	applied	\N	\N	\N	\N	132126	132126	132127
26819	42955	2	applied	\N	\N	\N	\N	132128	132128	132129
26819	42956	3	applied	\N	\N	\N	\N	132130	132130	132131
26827	42960	0	applied	\N	\N	\N	\N	132146	132146	132147
26827	42961	1	applied	\N	\N	\N	\N	132148	132148	132149
26827	42962	2	applied	\N	\N	\N	\N	132150	132150	132151
26827	42963	3	applied	\N	\N	\N	\N	132152	132152	132153
26828	42964	0	applied	\N	\N	\N	\N	132159	132159	132160
26828	42965	1	applied	\N	\N	\N	\N	132161	132161	132162
26831	42969	0	applied	\N	\N	\N	\N	132173	132173	132174
26831	42970	1	applied	\N	\N	\N	\N	132175	132175	132176
26831	42971	2	applied	\N	\N	\N	\N	132177	132177	132178
26831	42972	3	applied	\N	\N	\N	\N	132179	132179	132180
26836	42986	0	applied	\N	\N	\N	\N	132217	132217	132218
26836	42987	1	applied	\N	\N	\N	\N	132219	132219	132220
26836	42988	2	applied	\N	\N	\N	\N	132221	132221	132222
26843	42999	0	applied	\N	\N	\N	\N	132251	132251	132252
26843	43000	1	applied	\N	\N	\N	\N	132253	132253	132254
26843	43001	2	applied	\N	\N	\N	\N	132255	132255	132256
26847	43021	0	applied	\N	\N	\N	\N	132304	132304	132305
26847	43022	1	applied	\N	\N	\N	\N	132306	132306	132307
26847	43023	2	applied	\N	\N	\N	\N	132308	132308	132309
26847	43024	3	applied	\N	\N	\N	\N	132310	132310	132311
26847	43025	4	applied	\N	\N	\N	\N	132312	132312	132313
26847	43026	5	applied	\N	\N	\N	\N	132314	132314	132315
26847	43027	6	applied	\N	\N	\N	\N	132316	132316	132317
26849	43028	0	applied	\N	\N	\N	\N	132320	132320	132321
26849	43029	1	applied	\N	\N	\N	\N	132322	132322	132323
26849	43030	2	applied	\N	\N	\N	\N	132324	132324	132325
26854	43041	0	applied	\N	\N	\N	\N	132352	132352	132353
26854	43042	1	applied	\N	\N	\N	\N	132354	132354	132355
26854	43043	2	applied	\N	\N	\N	\N	132356	132356	132357
26856	42906	0	applied	\N	\N	\N	\N	132007	132007	132008
26856	42867	1	applied	\N	\N	\N	\N	131891	131891	131892
26856	42870	2	applied	\N	\N	\N	\N	131905	131905	131906
26856	42874	3	applied	\N	\N	\N	\N	131918	131918	131919
26856	42877	4	applied	\N	\N	\N	\N	131930	131930	131931
26856	42878	5	applied	\N	\N	\N	\N	131932	131932	131933
26856	42879	6	applied	\N	\N	\N	\N	131934	131934	131935
26856	42887	7	applied	\N	\N	\N	\N	131951	131951	131952
26856	42890	8	applied	\N	\N	\N	\N	131961	131961	131962
26856	42892	9	applied	\N	\N	\N	\N	131969	131969	131970
26856	42896	10	applied	\N	\N	\N	\N	131978	131978	131979
26856	42899	11	applied	\N	\N	\N	\N	131988	131988	131989
26856	42902	12	applied	\N	\N	\N	\N	131997	131997	131998
26856	42907	13	applied	\N	\N	\N	\N	132009	132009	132010
26856	42910	14	applied	\N	\N	\N	\N	132017	132017	132018
26856	42911	15	applied	\N	\N	\N	\N	132019	132019	132020
26856	42912	16	applied	\N	\N	\N	\N	132021	132021	132022
26856	42920	17	applied	\N	\N	\N	\N	132039	132039	132040
26856	42923	18	applied	\N	\N	\N	\N	132045	132045	132046
26856	42926	19	applied	\N	\N	\N	\N	132057	132057	132058
26856	42927	20	applied	\N	\N	\N	\N	132059	132059	132060
26856	42933	21	applied	\N	\N	\N	\N	132075	132075	132076
26856	42934	22	applied	\N	\N	\N	\N	132077	132077	132078
26856	42935	23	applied	\N	\N	\N	\N	132079	132079	132080
26856	42936	24	applied	\N	\N	\N	\N	132081	132081	132082
26856	42946	25	applied	\N	\N	\N	\N	132103	132103	132104
26856	42953	26	applied	\N	\N	\N	\N	132123	132123	132124
26856	42954	27	applied	\N	\N	\N	\N	132126	132126	132127
26856	42957	28	applied	\N	\N	\N	\N	132136	132136	132137
26856	42960	29	applied	\N	\N	\N	\N	132146	132146	132147
26856	42964	30	applied	\N	\N	\N	\N	132159	132159	132160
26856	42966	31	applied	\N	\N	\N	\N	132165	132165	132166
26856	42969	32	applied	\N	\N	\N	\N	132173	132173	132174
26856	42973	33	applied	\N	\N	\N	\N	132184	132184	132185
26856	42976	34	applied	\N	\N	\N	\N	132195	132195	132196
26856	42977	35	applied	\N	\N	\N	\N	132197	132197	132198
26856	42978	36	applied	\N	\N	\N	\N	132199	132199	132200
26856	42986	37	applied	\N	\N	\N	\N	132217	132217	132218
26856	42989	38	applied	\N	\N	\N	\N	132224	132224	132225
26856	42992	39	applied	\N	\N	\N	\N	132232	132232	132233
26856	42996	40	applied	\N	\N	\N	\N	132243	132243	132244
26856	42999	41	applied	\N	\N	\N	\N	132251	132251	132252
26856	43002	42	applied	\N	\N	\N	\N	132260	132260	132261
26856	43006	43	applied	\N	\N	\N	\N	132270	132270	132271
26856	43007	44	applied	\N	\N	\N	\N	132272	132272	132273
26856	43008	45	applied	\N	\N	\N	\N	132274	132274	132275
26856	43009	46	applied	\N	\N	\N	\N	132276	132276	132277
26856	43019	47	applied	\N	\N	\N	\N	132298	132298	132299
26856	43021	48	applied	\N	\N	\N	\N	132304	132304	132305
26856	43022	49	applied	\N	\N	\N	\N	132306	132306	132307
26856	43028	50	applied	\N	\N	\N	\N	132320	132320	132321
26856	43031	51	applied	\N	\N	\N	\N	132328	132328	132329
26856	43034	52	applied	\N	\N	\N	\N	132336	132336	132337
26856	43035	53	applied	\N	\N	\N	\N	132338	132338	132339
26856	43041	54	applied	\N	\N	\N	\N	132352	132352	132353
26856	42868	55	applied	\N	\N	\N	\N	131893	131893	131894
26856	42871	56	applied	\N	\N	\N	\N	131907	131907	132362
26856	42875	57	applied	\N	\N	\N	\N	131920	131920	132363
26856	42881	58	applied	\N	\N	\N	\N	131938	131938	131910
26856	42882	59	applied	\N	\N	\N	\N	131940	131940	132364
26856	42883	60	applied	\N	\N	\N	\N	131942	131942	132365
26856	42869	61	applied	\N	\N	\N	\N	131895	131895	132366
26856	42889	62	applied	\N	\N	\N	\N	131955	131955	131937
26856	42891	63	applied	\N	\N	\N	\N	131963	131963	131939
26856	42895	64	applied	\N	\N	\N	\N	131975	131975	131941
26856	42897	65	applied	\N	\N	\N	\N	131980	131980	131943
26856	42900	66	applied	\N	\N	\N	\N	131990	131990	132367
26856	42904	67	applied	\N	\N	\N	\N	132001	132001	132368
26856	42908	68	applied	\N	\N	\N	\N	132011	132011	131947
26856	42914	69	applied	\N	\N	\N	\N	132025	132025	132369
26856	42915	70	applied	\N	\N	\N	\N	132027	132027	132370
26856	42872	71	applied	\N	\N	\N	\N	131909	131909	132371
26856	42880	72	applied	\N	\N	\N	\N	131936	131936	131954
26856	42893	73	applied	\N	\N	\N	\N	131971	131971	132372
26856	42905	74	applied	\N	\N	\N	\N	132003	132003	131956
26856	42913	75	applied	\N	\N	\N	\N	132023	132023	132373
26856	42928	76	applied	\N	\N	\N	\N	132061	132061	131964
26856	42937	77	applied	\N	\N	\N	\N	132083	132083	131972
26856	42948	78	applied	\N	\N	\N	\N	132108	132108	132374
26856	42961	79	applied	\N	\N	\N	\N	132148	132148	132375
26856	42970	80	applied	\N	\N	\N	\N	132175	132175	131974
26856	42983	81	applied	\N	\N	\N	\N	132209	132209	132376
26856	42994	82	applied	\N	\N	\N	\N	132236	132236	131976
26856	43005	83	applied	\N	\N	\N	\N	132266	132266	132377
26856	43015	84	applied	\N	\N	\N	\N	132288	132288	131981
26856	42919	85	applied	\N	\N	\N	\N	132035	132035	132378
26824	42963	3	applied	\N	\N	\N	\N	132152	132152	132153
26841	42996	0	applied	\N	\N	\N	\N	132243	132243	132244
26841	42997	1	applied	\N	\N	\N	\N	132245	132245	132246
26841	42998	2	applied	\N	\N	\N	\N	132247	132247	132248
26850	43031	0	applied	\N	\N	\N	\N	132328	132328	132329
26850	43032	1	applied	\N	\N	\N	\N	132330	132330	132331
26850	43033	2	applied	\N	\N	\N	\N	132332	132332	132333
26853	43041	0	applied	\N	\N	\N	\N	132352	132352	132353
26853	43042	1	applied	\N	\N	\N	\N	132354	132354	132355
26853	43043	2	applied	\N	\N	\N	\N	132356	132356	132357
26860	43054	0	applied	\N	\N	\N	\N	132427	132427	132428
26860	43055	1	applied	\N	\N	\N	\N	132429	132429	132430
26860	43056	2	applied	\N	\N	\N	\N	132431	132431	132432
26842	42999	0	applied	\N	\N	\N	\N	132251	132251	132252
26842	43000	1	applied	\N	\N	\N	\N	132253	132253	132254
26842	43001	2	applied	\N	\N	\N	\N	132255	132255	132256
26846	43019	0	applied	\N	\N	\N	\N	132298	132298	132299
26846	43020	1	applied	\N	\N	\N	\N	132300	132300	132301
26851	43034	0	applied	\N	\N	\N	\N	132336	132336	132337
26851	43035	1	applied	\N	\N	\N	\N	132338	132338	132339
26851	43036	2	applied	\N	\N	\N	\N	132340	132340	132341
26851	43037	3	applied	\N	\N	\N	\N	132342	132342	132343
26851	43038	4	applied	\N	\N	\N	\N	132344	132344	132345
26851	43039	5	applied	\N	\N	\N	\N	132346	132346	132347
26851	43040	6	applied	\N	\N	\N	\N	132348	132348	132349
26859	43054	0	applied	\N	\N	\N	\N	132427	132427	132428
26859	43055	1	applied	\N	\N	\N	\N	132429	132429	132430
26859	43056	2	applied	\N	\N	\N	\N	132431	132431	132432
26862	43054	0	applied	\N	\N	\N	\N	132427	132427	132428
26862	43055	1	applied	\N	\N	\N	\N	132429	132429	132430
26862	43056	2	applied	\N	\N	\N	\N	132431	132431	132432
26845	43009	3	applied	\N	\N	\N	\N	132276	132276	132277
26845	43010	4	applied	\N	\N	\N	\N	132278	132278	132279
26845	43011	5	applied	\N	\N	\N	\N	132280	132280	132281
26845	43012	6	applied	\N	\N	\N	\N	132282	132282	132283
26845	43013	7	applied	\N	\N	\N	\N	132284	132284	132285
26845	43014	8	applied	\N	\N	\N	\N	132286	132286	132287
26845	43015	9	applied	\N	\N	\N	\N	132288	132288	132289
26845	43016	10	applied	\N	\N	\N	\N	132290	132290	132291
26845	43017	11	applied	\N	\N	\N	\N	132292	132292	132293
26845	43018	12	applied	\N	\N	\N	\N	132294	132294	132295
26848	43028	0	applied	\N	\N	\N	\N	132320	132320	132321
26848	43029	1	applied	\N	\N	\N	\N	132322	132322	132323
26848	43030	2	applied	\N	\N	\N	\N	132324	132324	132325
26852	43041	0	applied	\N	\N	\N	\N	132352	132352	132353
26852	43042	1	applied	\N	\N	\N	\N	132354	132354	132355
26852	43043	2	applied	\N	\N	\N	\N	132356	132356	132357
26855	43041	0	applied	\N	\N	\N	\N	132352	132352	132353
26855	43042	1	applied	\N	\N	\N	\N	132354	132354	132355
26855	43043	2	applied	\N	\N	\N	\N	132356	132356	132357
26857	43044	0	applied	\N	\N	\N	\N	132405	132405	132406
26857	43045	1	applied	\N	\N	\N	\N	132407	132407	132408
26857	43046	2	applied	\N	\N	\N	\N	132409	132409	132410
26857	43047	3	applied	\N	\N	\N	\N	132411	132411	132412
26857	43048	4	applied	\N	\N	\N	\N	132413	132413	132414
26857	43049	5	applied	\N	\N	\N	\N	132415	132415	132416
26857	43050	6	applied	\N	\N	\N	\N	132417	132417	132418
26857	43051	7	applied	\N	\N	\N	\N	132419	132419	132420
26857	43052	8	applied	\N	\N	\N	\N	132421	132421	132422
26857	43053	9	applied	\N	\N	\N	\N	132423	132423	132424
26856	42922	86	applied	\N	\N	\N	\N	132043	132043	132379
26856	42924	87	applied	\N	\N	\N	\N	132047	132047	132380
26856	42929	88	applied	\N	\N	\N	\N	132063	132063	131993
26856	42930	89	applied	\N	\N	\N	\N	132065	132065	132381
26856	42942	90	applied	\N	\N	\N	\N	132093	132093	132382
26856	42943	91	applied	\N	\N	\N	\N	132095	132095	132004
26856	42944	92	applied	\N	\N	\N	\N	132097	132097	132012
26856	42945	93	applied	\N	\N	\N	\N	132099	132099	132383
26856	42949	94	applied	\N	\N	\N	\N	132110	132110	132024
26856	42952	95	applied	\N	\N	\N	\N	132120	132120	132026
26856	42956	96	applied	\N	\N	\N	\N	132130	132130	132028
26856	42958	97	applied	\N	\N	\N	\N	132138	132138	132384
26856	42963	98	applied	\N	\N	\N	\N	132152	132152	132385
26856	43027	99	applied	\N	\N	\N	\N	132316	132316	132386
26856	43039	100	applied	\N	\N	\N	\N	132346	132346	132032
26856	42873	101	applied	\N	\N	\N	\N	131911	131911	132034
26856	42876	102	applied	\N	\N	\N	\N	131922	131922	132387
26856	42884	103	applied	\N	\N	\N	\N	131944	131944	132388
26856	42885	104	applied	\N	\N	\N	\N	131946	131946	132048
26856	42886	105	applied	\N	\N	\N	\N	131948	131948	132050
26856	42888	106	applied	\N	\N	\N	\N	131953	131953	132064
26856	42894	107	applied	\N	\N	\N	\N	131973	131973	132389
26856	42898	108	applied	\N	\N	\N	\N	131982	131982	132390
26856	42965	109	applied	\N	\N	\N	\N	132161	132161	132070
26856	42967	110	applied	\N	\N	\N	\N	132167	132167	132391
26856	42971	111	applied	\N	\N	\N	\N	132177	132177	132086
26856	42975	113	applied	\N	\N	\N	\N	132188	132188	132393
26856	42979	114	applied	\N	\N	\N	\N	132201	132201	132394
26856	42984	115	applied	\N	\N	\N	\N	132211	132211	132090
26856	42985	116	applied	\N	\N	\N	\N	132213	132213	132395
26856	42987	117	applied	\N	\N	\N	\N	132219	132219	132396
26856	42990	118	applied	\N	\N	\N	\N	132226	132226	132397
26856	42995	119	applied	\N	\N	\N	\N	132238	132238	132398
26856	42997	120	applied	\N	\N	\N	\N	132245	132245	132399
26856	43001	121	applied	\N	\N	\N	\N	132255	132255	132400
26856	43003	122	applied	\N	\N	\N	\N	132262	132262	132107
26856	43010	123	applied	\N	\N	\N	\N	132278	132278	132401
26856	43012	124	applied	\N	\N	\N	\N	132282	132282	132402
26856	43013	125	applied	\N	\N	\N	\N	132284	132284	132119
26858	43054	0	applied	\N	\N	\N	\N	132427	132427	132428
26858	43055	1	applied	\N	\N	\N	\N	132429	132429	132430
26858	43056	2	applied	\N	\N	\N	\N	132431	132431	132432
26861	42890	0	applied	\N	\N	\N	\N	131961	131961	131962
26861	42906	1	applied	\N	\N	\N	\N	132007	132007	132008
26861	42892	2	applied	\N	\N	\N	\N	131969	131969	131970
26861	42896	3	applied	\N	\N	\N	\N	131978	131978	131979
26861	42899	4	applied	\N	\N	\N	\N	131988	131988	131989
26861	42902	5	applied	\N	\N	\N	\N	131997	131997	131998
26861	42907	6	applied	\N	\N	\N	\N	132009	132009	132010
26861	42910	7	applied	\N	\N	\N	\N	132017	132017	132018
26861	42911	8	applied	\N	\N	\N	\N	132019	132019	132020
26861	42912	9	applied	\N	\N	\N	\N	132021	132021	132022
26861	42920	10	applied	\N	\N	\N	\N	132039	132039	132040
26861	42923	11	applied	\N	\N	\N	\N	132045	132045	132046
26861	42926	12	applied	\N	\N	\N	\N	132057	132057	132058
26861	42927	13	applied	\N	\N	\N	\N	132059	132059	132060
26861	42933	14	applied	\N	\N	\N	\N	132075	132075	132076
26861	42934	15	applied	\N	\N	\N	\N	132077	132077	132078
26861	42935	16	applied	\N	\N	\N	\N	132079	132079	132080
26861	42936	17	applied	\N	\N	\N	\N	132081	132081	132082
26861	42946	18	applied	\N	\N	\N	\N	132103	132103	132104
26861	42953	19	applied	\N	\N	\N	\N	132123	132123	132124
26861	42954	20	applied	\N	\N	\N	\N	132126	132126	132127
26861	42957	21	applied	\N	\N	\N	\N	132136	132136	132137
26861	42960	22	applied	\N	\N	\N	\N	132146	132146	132147
26861	42964	23	applied	\N	\N	\N	\N	132159	132159	132160
26861	42966	24	applied	\N	\N	\N	\N	132165	132165	132166
26861	42969	25	applied	\N	\N	\N	\N	132173	132173	132174
26861	42973	26	applied	\N	\N	\N	\N	132184	132184	132185
26861	42976	27	applied	\N	\N	\N	\N	132195	132195	132196
26861	42977	28	applied	\N	\N	\N	\N	132197	132197	132198
26861	42978	29	applied	\N	\N	\N	\N	132199	132199	132200
26861	42986	30	applied	\N	\N	\N	\N	132217	132217	132218
26861	42989	31	applied	\N	\N	\N	\N	132224	132224	132225
26861	42992	32	applied	\N	\N	\N	\N	132232	132232	132233
26861	42996	33	applied	\N	\N	\N	\N	132243	132243	132244
26861	42999	34	applied	\N	\N	\N	\N	132251	132251	132252
26861	43002	35	applied	\N	\N	\N	\N	132260	132260	132261
26861	43006	36	applied	\N	\N	\N	\N	132270	132270	132271
26861	43007	37	applied	\N	\N	\N	\N	132272	132272	132273
26861	43008	38	applied	\N	\N	\N	\N	132274	132274	132275
26861	43009	39	applied	\N	\N	\N	\N	132276	132276	132277
26861	43019	40	applied	\N	\N	\N	\N	132298	132298	132299
26861	43021	41	applied	\N	\N	\N	\N	132304	132304	132305
26861	43022	42	applied	\N	\N	\N	\N	132306	132306	132307
26861	43028	43	applied	\N	\N	\N	\N	132320	132320	132321
26861	43031	44	applied	\N	\N	\N	\N	132328	132328	132329
26861	43034	45	applied	\N	\N	\N	\N	132336	132336	132337
26861	43035	46	applied	\N	\N	\N	\N	132338	132338	132339
26861	43041	47	applied	\N	\N	\N	\N	132352	132352	132353
26861	43044	48	applied	\N	\N	\N	\N	132405	132405	132406
26861	43045	49	applied	\N	\N	\N	\N	132407	132407	132408
26861	43046	50	applied	\N	\N	\N	\N	132409	132409	132410
26861	43054	51	applied	\N	\N	\N	\N	132427	132427	132428
26861	42893	52	applied	\N	\N	\N	\N	131971	131971	132373
26861	42891	53	applied	\N	\N	\N	\N	131963	131963	131972
26861	42894	54	applied	\N	\N	\N	\N	131973	131973	131974
26861	42905	55	applied	\N	\N	\N	\N	132003	132003	132376
26861	42913	56	applied	\N	\N	\N	\N	132023	132023	131976
26861	42928	57	applied	\N	\N	\N	\N	132061	132061	132377
26861	42937	58	applied	\N	\N	\N	\N	132083	132083	131981
26861	42948	59	applied	\N	\N	\N	\N	132108	132108	132435
26861	42961	60	applied	\N	\N	\N	\N	132148	132148	132378
26861	42970	61	applied	\N	\N	\N	\N	132175	132175	131983
26861	42983	62	applied	\N	\N	\N	\N	132209	132209	132379
26861	42994	63	applied	\N	\N	\N	\N	132236	132236	131991
26861	43005	64	applied	\N	\N	\N	\N	132266	132266	132380
26861	42895	65	applied	\N	\N	\N	\N	131975	131975	131993
26861	42897	66	applied	\N	\N	\N	\N	131980	131980	132381
26861	42900	67	applied	\N	\N	\N	\N	131990	131990	132382
26861	42904	68	applied	\N	\N	\N	\N	132001	132001	132004
26861	42908	69	applied	\N	\N	\N	\N	132011	132011	132012
26861	42914	70	applied	\N	\N	\N	\N	132025	132025	132383
26861	42915	71	applied	\N	\N	\N	\N	132027	132027	132024
26861	42898	72	applied	\N	\N	\N	\N	131982	131982	132436
26861	43015	73	applied	\N	\N	\N	\N	132288	132288	132028
26861	42919	74	applied	\N	\N	\N	\N	132035	132035	132384
26861	42922	75	applied	\N	\N	\N	\N	132043	132043	132385
26861	42924	76	applied	\N	\N	\N	\N	132047	132047	132032
26861	42929	77	applied	\N	\N	\N	\N	132063	132063	132437
26861	42930	78	applied	\N	\N	\N	\N	132065	132065	132438
26861	42942	80	applied	\N	\N	\N	\N	132093	132093	132387
26861	42943	81	applied	\N	\N	\N	\N	132095	132095	132042
26861	42944	82	applied	\N	\N	\N	\N	132097	132097	132044
26861	42945	83	applied	\N	\N	\N	\N	132099	132099	132048
26861	42949	84	applied	\N	\N	\N	\N	132110	132110	132440
26861	42952	85	applied	\N	\N	\N	\N	132120	132120	132062
26861	42956	86	applied	\N	\N	\N	\N	132130	132130	132064
26861	42958	87	applied	\N	\N	\N	\N	132138	132138	132066
26861	42963	88	applied	\N	\N	\N	\N	132152	132152	132441
26861	43027	89	applied	\N	\N	\N	\N	132316	132316	132068
26861	43039	90	applied	\N	\N	\N	\N	132346	132346	132390
26861	43047	91	applied	\N	\N	\N	\N	132411	132411	132442
26861	42965	92	applied	\N	\N	\N	\N	132161	132161	132084
26861	42967	93	applied	\N	\N	\N	\N	132167	132167	132443
26861	42971	94	applied	\N	\N	\N	\N	132177	132177	132444
26861	42975	95	applied	\N	\N	\N	\N	132188	132188	132088
26861	42979	96	applied	\N	\N	\N	\N	132201	132201	132445
26861	42984	97	applied	\N	\N	\N	\N	132211	132211	132446
26861	42985	98	applied	\N	\N	\N	\N	132213	132213	132092
26861	42987	99	applied	\N	\N	\N	\N	132219	132219	132094
26861	42990	100	applied	\N	\N	\N	\N	132226	132226	132096
26861	42995	101	applied	\N	\N	\N	\N	132238	132238	132098
26861	42997	102	applied	\N	\N	\N	\N	132245	132245	132100
26861	43001	103	applied	\N	\N	\N	\N	132255	132255	132447
26861	43003	104	applied	\N	\N	\N	\N	132262	132262	132109
26861	43010	105	applied	\N	\N	\N	\N	132278	132278	132111
26861	43012	106	applied	\N	\N	\N	\N	132282	132282	132448
26861	43013	107	applied	\N	\N	\N	\N	132284	132284	132449
26861	43014	108	applied	\N	\N	\N	\N	132286	132286	132450
26861	43020	109	applied	\N	\N	\N	\N	132300	132300	132129
26861	43024	110	applied	\N	\N	\N	\N	132310	132310	132131
26861	43026	111	applied	\N	\N	\N	\N	132314	132314	132139
26861	43029	112	applied	\N	\N	\N	\N	132322	132322	132451
26861	43033	113	applied	\N	\N	\N	\N	132332	132332	132149
26861	43036	114	applied	\N	\N	\N	\N	132340	132340	132452
26861	43038	115	applied	\N	\N	\N	\N	132344	132344	132453
26861	43043	116	applied	\N	\N	\N	\N	132356	132356	132454
26861	43051	117	applied	\N	\N	\N	\N	132419	132419	132455
26861	43052	118	applied	\N	\N	\N	\N	132421	132421	132456
26861	43053	119	applied	\N	\N	\N	\N	132423	132423	132170
26861	43055	120	applied	\N	\N	\N	\N	132429	132429	132457
26861	42901	121	applied	\N	\N	\N	\N	131992	131992	132458
26861	42903	122	applied	\N	\N	\N	\N	131999	131999	132459
26861	42909	123	applied	\N	\N	\N	\N	132013	132013	132189
26861	42916	124	applied	\N	\N	\N	\N	132029	132029	132460
26861	42917	125	applied	\N	\N	\N	\N	132031	132031	132461
26863	43057	0	applied	\N	\N	\N	\N	132466	132466	132467
26863	43058	1	applied	\N	\N	\N	\N	132468	132468	132469
26863	43059	2	applied	\N	\N	\N	\N	132470	132470	132471
26863	43060	3	applied	\N	\N	\N	\N	132472	132472	132473
26863	43061	4	applied	\N	\N	\N	\N	132474	132474	132475
26863	43062	5	applied	\N	\N	\N	\N	132476	132476	132477
26863	43063	6	applied	\N	\N	\N	\N	132478	132478	132479
26864	43057	0	applied	\N	\N	\N	\N	132466	132466	132467
26864	43058	1	applied	\N	\N	\N	\N	132468	132468	132469
26864	43059	2	applied	\N	\N	\N	\N	132470	132470	132471
26864	43060	3	applied	\N	\N	\N	\N	132472	132472	132473
26864	43061	4	applied	\N	\N	\N	\N	132474	132474	132475
26864	43062	5	applied	\N	\N	\N	\N	132476	132476	132477
26864	43063	6	applied	\N	\N	\N	\N	132478	132478	132479
26865	43057	0	applied	\N	\N	\N	\N	132466	132466	132467
26865	43058	1	applied	\N	\N	\N	\N	132468	132468	132469
26865	43059	2	applied	\N	\N	\N	\N	132470	132470	132471
26865	43060	3	applied	\N	\N	\N	\N	132472	132472	132473
26865	43061	4	applied	\N	\N	\N	\N	132474	132474	132475
26865	43062	5	applied	\N	\N	\N	\N	132476	132476	132477
26865	43063	6	applied	\N	\N	\N	\N	132478	132478	132479
26866	43064	0	applied	\N	\N	\N	\N	132485	132485	132486
26866	43065	1	applied	\N	\N	\N	\N	132487	132487	132488
26866	43066	2	applied	\N	\N	\N	\N	132489	132489	132490
26867	43067	0	applied	\N	\N	\N	\N	132491	132491	132492
26867	43068	1	applied	\N	\N	\N	\N	132493	132493	132494
26867	43069	2	applied	\N	\N	\N	\N	132495	132495	132496
26867	43070	3	applied	\N	\N	\N	\N	132497	132497	132498
26868	43071	0	applied	\N	\N	\N	\N	132500	132500	132501
26868	43072	1	applied	\N	\N	\N	\N	132502	132502	132503
26868	43073	2	applied	\N	\N	\N	\N	132504	132504	132505
26869	43071	0	applied	\N	\N	\N	\N	132500	132500	132501
26869	43072	1	applied	\N	\N	\N	\N	132502	132502	132503
26869	43073	2	applied	\N	\N	\N	\N	132504	132504	132505
26870	43074	0	applied	\N	\N	\N	\N	132509	132509	132510
26870	43075	1	applied	\N	\N	\N	\N	132511	132511	132512
26870	43076	2	applied	\N	\N	\N	\N	132513	132513	132514
26871	43074	0	applied	\N	\N	\N	\N	132509	132509	132510
26871	43075	1	applied	\N	\N	\N	\N	132511	132511	132512
26871	43076	2	applied	\N	\N	\N	\N	132513	132513	132514
26872	43074	0	applied	\N	\N	\N	\N	132509	132509	132510
26872	43075	1	applied	\N	\N	\N	\N	132511	132511	132512
26872	43076	2	applied	\N	\N	\N	\N	132513	132513	132514
26873	43074	0	applied	\N	\N	\N	\N	132509	132509	132510
26873	43075	1	applied	\N	\N	\N	\N	132511	132511	132512
26873	43076	2	applied	\N	\N	\N	\N	132513	132513	132514
26874	43077	0	applied	\N	\N	\N	\N	132518	132518	132519
26874	43078	1	applied	\N	\N	\N	\N	132520	132520	132521
26874	43079	2	applied	\N	\N	\N	\N	132522	132522	132523
26874	43080	3	applied	\N	\N	\N	\N	16600	16600	132524
26874	43081	4	applied	\N	\N	\N	\N	132525	132525	132526
26875	43082	0	applied	\N	\N	\N	\N	132528	132528	132529
26875	43083	1	applied	\N	\N	\N	\N	132530	132530	132531
26875	43084	2	applied	\N	\N	\N	\N	132532	132532	132533
26876	43082	0	applied	\N	\N	\N	\N	132528	132528	132529
26876	43083	1	applied	\N	\N	\N	\N	132530	132530	132531
26876	43084	2	applied	\N	\N	\N	\N	132532	132532	132533
26877	43085	0	applied	\N	\N	\N	\N	132537	132537	132538
26877	43086	1	applied	\N	\N	\N	\N	132539	132539	132540
26877	43087	2	applied	\N	\N	\N	\N	132541	132541	132542
26878	43085	0	applied	\N	\N	\N	\N	132537	132537	132538
26878	43086	1	applied	\N	\N	\N	\N	132539	132539	132540
26878	43087	2	applied	\N	\N	\N	\N	132541	132541	132542
26879	43085	0	applied	\N	\N	\N	\N	132537	132537	132538
26879	43086	1	applied	\N	\N	\N	\N	132539	132539	132540
26879	43087	2	applied	\N	\N	\N	\N	132541	132541	132542
26880	43085	0	applied	\N	\N	\N	\N	132537	132537	132538
26880	43086	1	applied	\N	\N	\N	\N	132539	132539	132540
26880	43087	2	applied	\N	\N	\N	\N	132541	132541	132542
26881	43085	0	applied	\N	\N	\N	\N	132537	132537	132538
26881	43086	1	applied	\N	\N	\N	\N	132539	132539	132540
26881	43087	2	applied	\N	\N	\N	\N	132541	132541	132542
26882	43044	0	applied	\N	\N	\N	\N	132405	132405	132406
26882	43045	1	applied	\N	\N	\N	\N	132407	132407	132408
26882	43046	2	applied	\N	\N	\N	\N	132409	132409	132410
26882	43054	3	applied	\N	\N	\N	\N	132427	132427	132428
26882	43057	4	applied	\N	\N	\N	\N	132466	132466	132467
26882	43058	5	applied	\N	\N	\N	\N	132468	132468	132469
26882	43064	6	applied	\N	\N	\N	\N	132485	132485	132486
26882	43067	7	applied	\N	\N	\N	\N	132491	132491	132492
26882	43071	8	applied	\N	\N	\N	\N	132500	132500	132501
26882	43074	9	applied	\N	\N	\N	\N	132509	132509	132510
26882	43077	10	applied	\N	\N	\N	\N	132518	132518	132519
26882	43082	11	applied	\N	\N	\N	\N	132528	132528	132529
26882	43085	12	applied	\N	\N	\N	\N	132537	132537	132538
26882	43047	13	applied	\N	\N	\N	\N	132411	132411	132449
26882	43014	14	applied	\N	\N	\N	\N	132286	132286	132450
26882	43020	15	applied	\N	\N	\N	\N	132300	132300	132129
26882	43024	16	applied	\N	\N	\N	\N	132310	132310	132131
26882	43026	17	applied	\N	\N	\N	\N	132314	132314	132139
26882	43029	18	applied	\N	\N	\N	\N	132322	132322	132451
26882	43033	19	applied	\N	\N	\N	\N	132332	132332	132149
26882	43036	20	applied	\N	\N	\N	\N	132340	132340	132452
26882	43038	21	applied	\N	\N	\N	\N	132344	132344	132453
26882	43043	22	applied	\N	\N	\N	\N	132356	132356	132454
26882	43051	23	applied	\N	\N	\N	\N	132419	132419	132455
26882	43052	24	applied	\N	\N	\N	\N	132421	132421	132456
26882	43053	25	applied	\N	\N	\N	\N	132423	132423	132170
26882	43055	26	applied	\N	\N	\N	\N	132429	132429	132457
26882	43060	27	applied	\N	\N	\N	\N	132472	132472	132547
26882	43061	28	applied	\N	\N	\N	\N	132474	132474	132180
26882	43066	29	applied	\N	\N	\N	\N	132489	132489	132459
26882	43068	30	applied	\N	\N	\N	\N	132493	132493	132548
26882	43073	31	applied	\N	\N	\N	\N	132504	132504	132549
26882	43075	32	applied	\N	\N	\N	\N	132511	132511	132460
26882	43078	33	applied	\N	\N	\N	\N	132520	132520	132204
26882	43084	34	applied	\N	\N	\N	\N	132532	132532	132550
26882	43087	35	applied	\N	\N	\N	\N	132541	132541	132551
26882	43063	36	applied	\N	\N	\N	\N	132478	132478	132552
26882	43070	37	applied	\N	\N	\N	\N	132497	132497	132208
26882	43081	38	applied	\N	\N	\N	\N	132525	132525	132210
26882	42901	39	applied	\N	\N	\N	\N	131992	131992	132553
26882	42903	40	applied	\N	\N	\N	\N	131999	131999	132220
26882	42909	41	applied	\N	\N	\N	\N	132013	132013	132222
26882	42916	42	applied	\N	\N	\N	\N	132029	132029	132554
26882	42917	43	applied	\N	\N	\N	\N	132031	132031	132555
26882	42918	44	applied	\N	\N	\N	\N	132033	132033	132237
26882	42921	45	applied	\N	\N	\N	\N	132041	132041	132556
26882	42925	46	applied	\N	\N	\N	\N	132049	132049	132557
26882	42931	47	applied	\N	\N	\N	\N	132067	132067	132558
26882	42932	48	applied	\N	\N	\N	\N	132069	132069	132256
26882	42938	49	applied	\N	\N	\N	\N	132085	132085	132559
26882	42939	50	applied	\N	\N	\N	\N	132087	132087	132267
26882	42940	51	applied	\N	\N	\N	\N	132089	132089	132560
26882	42941	52	applied	\N	\N	\N	\N	132091	132091	132561
26882	42947	53	applied	\N	\N	\N	\N	132106	132106	132285
26882	42951	54	applied	\N	\N	\N	\N	132118	132118	132289
26882	42955	55	applied	\N	\N	\N	\N	132128	132128	132291
26882	42959	56	applied	\N	\N	\N	\N	132140	132140	132293
26882	42962	57	applied	\N	\N	\N	\N	132150	132150	132295
26882	42968	58	applied	\N	\N	\N	\N	132169	132169	132562
26882	42972	59	applied	\N	\N	\N	\N	132179	132179	132563
26882	42974	60	applied	\N	\N	\N	\N	132186	132186	132564
26882	42980	61	applied	\N	\N	\N	\N	132203	132203	132315
26882	42981	62	applied	\N	\N	\N	\N	132205	132205	132323
26882	42982	63	applied	\N	\N	\N	\N	132207	132207	132325
26882	42988	64	applied	\N	\N	\N	\N	132221	132221	132331
26882	42991	65	applied	\N	\N	\N	\N	132228	132228	132565
26882	42993	66	applied	\N	\N	\N	\N	132234	132234	132566
26882	42998	67	applied	\N	\N	\N	\N	132247	132247	132345
26882	43000	68	applied	\N	\N	\N	\N	132253	132253	132567
26882	43004	69	applied	\N	\N	\N	\N	132264	132264	132568
26882	43011	70	applied	\N	\N	\N	\N	132280	132280	132357
26882	43016	71	applied	\N	\N	\N	\N	132290	132290	132569
26882	43017	72	applied	\N	\N	\N	\N	132292	132292	132570
26882	43018	73	applied	\N	\N	\N	\N	132294	132294	132571
26882	43023	74	applied	\N	\N	\N	\N	132308	132308	132420
26882	43025	75	applied	\N	\N	\N	\N	132312	132312	132572
26882	43030	76	applied	\N	\N	\N	\N	132324	132324	132430
26882	43032	77	applied	\N	\N	\N	\N	132330	132330	132432
26882	43037	78	applied	\N	\N	\N	\N	132342	132342	132471
26882	43040	79	applied	\N	\N	\N	\N	132348	132348	132573
26882	43042	80	applied	\N	\N	\N	\N	132354	132354	132574
26882	43048	81	applied	\N	\N	\N	\N	132413	132413	132575
26882	43049	82	applied	\N	\N	\N	\N	132415	132415	132576
26882	43050	83	applied	\N	\N	\N	\N	132417	132417	132494
26882	43056	84	applied	\N	\N	\N	\N	132431	132431	132496
26882	43059	85	applied	\N	\N	\N	\N	132470	132470	132577
26882	43062	86	applied	\N	\N	\N	\N	132476	132476	132505
26882	43065	87	applied	\N	\N	\N	\N	132487	132487	132578
26882	43069	88	applied	\N	\N	\N	\N	132495	132495	132579
26882	43072	89	applied	\N	\N	\N	\N	132502	132502	132580
26882	43076	90	applied	\N	\N	\N	\N	132513	132513	132581
26882	43079	91	applied	\N	\N	\N	\N	132522	132522	132582
26882	43083	92	applied	\N	\N	\N	\N	132530	132530	132583
26882	43086	93	applied	\N	\N	\N	\N	132539	132539	132542
26885	43098	0	applied	\N	\N	\N	\N	132608	132608	132609
26885	43099	1	applied	\N	\N	\N	\N	132610	132610	132611
26885	43100	2	applied	\N	\N	\N	\N	132612	132612	132613
26888	43101	0	applied	\N	\N	\N	\N	132616	132616	132617
26888	43102	1	applied	\N	\N	\N	\N	132618	132618	132619
26888	43103	2	applied	\N	\N	\N	\N	132620	132620	132621
26888	43104	3	applied	\N	\N	\N	\N	132622	132622	132623
26889	43105	0	applied	\N	\N	\N	\N	132629	132629	132630
26889	43106	1	applied	\N	\N	\N	\N	132631	132631	132632
26889	43107	2	applied	\N	\N	\N	\N	132633	132633	132634
26893	43111	0	applied	\N	\N	\N	\N	132647	132647	132648
26893	43112	1	applied	\N	\N	\N	\N	132649	132649	132650
26893	43113	2	applied	\N	\N	\N	\N	132651	132651	132652
26893	43114	3	applied	\N	\N	\N	\N	132653	132653	132654
26899	43131	0	applied	\N	\N	\N	\N	132709	132709	132710
26899	43132	1	applied	\N	\N	\N	\N	132711	132711	132712
26899	43133	2	applied	\N	\N	\N	\N	132713	132713	132714
26899	43134	3	applied	\N	\N	\N	\N	132715	132715	132716
26899	43135	4	applied	\N	\N	\N	\N	132717	132717	132718
26899	43136	5	applied	\N	\N	\N	\N	132719	132719	132720
26899	43137	6	applied	\N	\N	\N	\N	132721	132721	132722
26899	43138	7	applied	\N	\N	\N	\N	132723	132723	132724
26899	43139	8	applied	\N	\N	\N	\N	132725	132725	132726
26899	43140	9	applied	\N	\N	\N	\N	132727	132727	132728
26899	43141	10	applied	\N	\N	\N	\N	132729	132729	132730
26906	43157	0	applied	\N	\N	\N	\N	132770	132770	132771
26906	43158	1	applied	\N	\N	\N	\N	132772	132772	132773
26883	43088	0	applied	\N	\N	\N	\N	132586	132586	132587
26883	43089	1	applied	\N	\N	\N	\N	132588	132588	132589
26883	43090	2	applied	\N	\N	\N	\N	132590	132590	132591
26883	43091	3	applied	\N	\N	\N	\N	132592	132592	132593
26883	43092	4	applied	\N	\N	\N	\N	132594	132594	132595
26883	43093	5	applied	\N	\N	\N	\N	132596	132596	132597
26883	43094	6	applied	\N	\N	\N	\N	132598	132598	132599
26883	43095	7	applied	\N	\N	\N	\N	132600	132600	132601
26883	43096	8	applied	\N	\N	\N	\N	132602	132602	132603
26883	43097	9	applied	\N	\N	\N	\N	132604	132604	132605
26890	43105	0	applied	\N	\N	\N	\N	132629	132629	132630
26890	43106	1	applied	\N	\N	\N	\N	132631	132631	132632
26890	43107	2	applied	\N	\N	\N	\N	132633	132633	132634
26894	43088	0	applied	\N	\N	\N	\N	132586	132586	132587
26894	43089	1	applied	\N	\N	\N	\N	132588	132588	132589
26894	43090	2	applied	\N	\N	\N	\N	132590	132590	132591
26894	43098	3	applied	\N	\N	\N	\N	132608	132608	132609
26894	43101	4	applied	\N	\N	\N	\N	132616	132616	132617
26894	43105	5	applied	\N	\N	\N	\N	132629	132629	132630
26894	43108	6	applied	\N	\N	\N	\N	132639	132639	132640
26894	43111	7	applied	\N	\N	\N	\N	132647	132647	132648
26894	43115	8	applied	\N	\N	\N	\N	132658	132658	132659
26894	43091	9	applied	\N	\N	\N	\N	132592	132592	132593
26894	43092	10	applied	\N	\N	\N	\N	132594	132594	132595
26894	43093	11	applied	\N	\N	\N	\N	132596	132596	132597
26894	43094	12	applied	\N	\N	\N	\N	132598	132598	132599
26894	43095	13	applied	\N	\N	\N	\N	132600	132600	132601
26894	43096	14	applied	\N	\N	\N	\N	132602	132602	132603
26894	43103	15	applied	\N	\N	\N	\N	132620	132620	132660
26894	43112	17	applied	\N	\N	\N	\N	132649	132649	132605
26894	43097	18	applied	\N	\N	\N	\N	132604	132604	132611
26894	43099	19	applied	\N	\N	\N	\N	132610	132610	132662
26894	43102	20	applied	\N	\N	\N	\N	132618	132618	132663
26894	43107	21	applied	\N	\N	\N	\N	132633	132633	132621
26894	43110	22	applied	\N	\N	\N	\N	132643	132643	132664
26894	43114	23	applied	\N	\N	\N	\N	132653	132653	132665
26894	43116	24	applied	\N	\N	\N	\N	132666	132666	132632
26894	43100	25	applied	\N	\N	\N	\N	132612	132612	132667
26894	43104	26	applied	\N	\N	\N	\N	132622	132622	132668
26894	43106	27	applied	\N	\N	\N	\N	132631	132631	132669
26894	43109	28	applied	\N	\N	\N	\N	132641	132641	132670
26894	43113	29	applied	\N	\N	\N	\N	132651	132651	132671
26894	43117	30	applied	\N	\N	\N	\N	132672	132672	132673
26897	43124	0	applied	\N	\N	\N	\N	132695	132695	132696
26897	43125	1	applied	\N	\N	\N	\N	132697	132697	132698
26897	43126	2	applied	\N	\N	\N	\N	132699	132699	132700
26897	43127	3	applied	\N	\N	\N	\N	132701	132701	132702
26897	43128	4	applied	\N	\N	\N	\N	132703	132703	132704
26897	43129	5	applied	\N	\N	\N	\N	132705	132705	132706
26897	43130	6	applied	\N	\N	\N	\N	132707	132707	132708
26900	43131	0	applied	\N	\N	\N	\N	132709	132709	132710
26900	43132	1	applied	\N	\N	\N	\N	132711	132711	132712
26900	43133	2	applied	\N	\N	\N	\N	132713	132713	132714
26900	43134	3	applied	\N	\N	\N	\N	132715	132715	132716
26900	43135	4	applied	\N	\N	\N	\N	132717	132717	132718
26900	43136	5	applied	\N	\N	\N	\N	132719	132719	132720
26900	43137	6	applied	\N	\N	\N	\N	132721	132721	132722
26900	43138	7	applied	\N	\N	\N	\N	132723	132723	132724
26900	43139	8	applied	\N	\N	\N	\N	132725	132725	132726
26900	43140	9	applied	\N	\N	\N	\N	132727	132727	132728
26900	43141	10	applied	\N	\N	\N	\N	132729	132729	132730
26901	43142	0	applied	\N	\N	\N	\N	132736	132736	132737
26901	43143	1	applied	\N	\N	\N	\N	132738	132738	132739
26901	43144	2	applied	\N	\N	\N	\N	132740	132740	132741
26901	43145	3	applied	\N	\N	\N	\N	132742	132742	132743
26901	43146	4	applied	\N	\N	\N	\N	132744	132744	132745
26901	43147	5	applied	\N	\N	\N	\N	132746	132746	132747
26902	43148	0	applied	\N	\N	\N	\N	132750	132750	132751
26902	43149	1	applied	\N	\N	\N	\N	132752	132752	132753
26902	43150	2	applied	\N	\N	\N	\N	132754	132754	132755
26907	43157	0	applied	\N	\N	\N	\N	132770	132770	132771
26907	43158	1	applied	\N	\N	\N	\N	132772	132772	132773
26907	43159	2	applied	\N	\N	\N	\N	132774	132774	132775
26907	43160	3	applied	\N	\N	\N	\N	132776	132776	132777
26907	43161	4	applied	\N	\N	\N	\N	132778	132778	132779
26907	43162	5	applied	\N	\N	\N	\N	132780	132780	132781
26911	43163	0	applied	\N	\N	\N	\N	132785	132785	132786
26911	43164	1	applied	\N	\N	\N	\N	132787	132787	132788
26911	43165	2	applied	\N	\N	\N	\N	132789	132789	132790
26920	43118	0	applied	\N	\N	\N	\N	132677	132677	132678
26920	43119	1	applied	\N	\N	\N	\N	132679	132679	132680
26920	43124	2	applied	\N	\N	\N	\N	132695	132695	132696
26920	43125	3	applied	\N	\N	\N	\N	132697	132697	132698
26920	43131	4	applied	\N	\N	\N	\N	132709	132709	132710
26920	43132	5	applied	\N	\N	\N	\N	132711	132711	132712
26920	43133	6	applied	\N	\N	\N	\N	132713	132713	132714
26920	43134	7	applied	\N	\N	\N	\N	132715	132715	132716
26920	43142	8	applied	\N	\N	\N	\N	132736	132736	132737
26920	43143	9	applied	\N	\N	\N	\N	132738	132738	132739
26920	43148	10	applied	\N	\N	\N	\N	132750	132750	132751
26920	43151	11	applied	\N	\N	\N	\N	132758	132758	132759
26920	43154	12	applied	\N	\N	\N	\N	132764	132764	132765
26920	43157	13	applied	\N	\N	\N	\N	132770	132770	132771
26920	43158	14	applied	\N	\N	\N	\N	132772	132772	132773
26920	43163	15	applied	\N	\N	\N	\N	132785	132785	132786
26920	43166	16	applied	\N	\N	\N	\N	132797	132797	132798
26920	43169	17	applied	\N	\N	\N	\N	132805	132805	132806
26920	43172	18	applied	\N	\N	\N	\N	132815	132815	132816
26920	43174	19	applied	\N	\N	\N	\N	132819	132819	132820
26920	43177	20	applied	\N	\N	\N	\N	132829	132829	132830
26920	43178	21	applied	\N	\N	\N	\N	132831	132831	132832
26920	43183	22	applied	\N	\N	\N	\N	132842	132842	132843
26920	43184	23	applied	\N	\N	\N	\N	132844	132844	132845
26920	43122	24	applied	\N	\N	\N	\N	132687	132687	132855
26920	43123	25	applied	\N	\N	\N	\N	132689	132689	132685
26920	43126	26	applied	\N	\N	\N	\N	132699	132699	132686
26920	43127	27	applied	\N	\N	\N	\N	132701	132701	132688
26920	43120	28	applied	\N	\N	\N	\N	132682	132682	132856
26920	43121	29	applied	\N	\N	\N	\N	132684	132684	132702
26920	43128	30	applied	\N	\N	\N	\N	132703	132703	132704
26920	43129	31	applied	\N	\N	\N	\N	132705	132705	132706
26920	43136	32	applied	\N	\N	\N	\N	132719	132719	132857
26920	43137	33	applied	\N	\N	\N	\N	132721	132721	132858
26920	43130	34	applied	\N	\N	\N	\N	132707	132707	132859
26920	43135	35	applied	\N	\N	\N	\N	132717	132717	132722
26920	43138	36	applied	\N	\N	\N	\N	132723	132723	132724
26920	43139	37	applied	\N	\N	\N	\N	132725	132725	132726
26920	43144	38	applied	\N	\N	\N	\N	132740	132740	132860
26920	43145	39	applied	\N	\N	\N	\N	132742	132742	132861
26920	43150	40	applied	\N	\N	\N	\N	132754	132754	132730
26884	43098	0	applied	\N	\N	\N	\N	132608	132608	132609
26884	43099	1	applied	\N	\N	\N	\N	132610	132610	132611
26884	43100	2	applied	\N	\N	\N	\N	132612	132612	132613
26887	43101	0	applied	\N	\N	\N	\N	132616	132616	132617
26887	43102	1	applied	\N	\N	\N	\N	132618	132618	132619
26887	43103	2	applied	\N	\N	\N	\N	132620	132620	132621
26887	43104	3	applied	\N	\N	\N	\N	132622	132622	132623
26892	43111	0	applied	\N	\N	\N	\N	132647	132647	132648
26892	43112	1	applied	\N	\N	\N	\N	132649	132649	132650
26892	43113	2	applied	\N	\N	\N	\N	132651	132651	132652
26892	43114	3	applied	\N	\N	\N	\N	132653	132653	132654
26895	43115	0	applied	\N	\N	\N	\N	132658	132658	132659
26895	43118	1	applied	\N	\N	\N	\N	132677	132677	132678
26895	43119	2	applied	\N	\N	\N	\N	132679	132679	132680
26895	43117	3	applied	\N	\N	\N	\N	132672	132672	132681
26895	43120	4	applied	\N	\N	\N	\N	132682	132682	132683
26895	43121	5	applied	\N	\N	\N	\N	132684	132684	132685
26895	43116	6	applied	\N	\N	\N	\N	132666	132666	132686
26895	43122	7	applied	\N	\N	\N	\N	132687	132687	132688
26895	43123	8	applied	\N	\N	\N	\N	132689	132689	132690
26896	43115	0	applied	\N	\N	\N	\N	132658	132658	132659
26896	43118	1	applied	\N	\N	\N	\N	132677	132677	132678
26896	43119	2	applied	\N	\N	\N	\N	132679	132679	132680
26896	43117	3	applied	\N	\N	\N	\N	132672	132672	132681
26896	43120	4	applied	\N	\N	\N	\N	132682	132682	132683
26896	43121	5	applied	\N	\N	\N	\N	132684	132684	132685
26896	43116	6	applied	\N	\N	\N	\N	132666	132666	132686
26896	43122	7	applied	\N	\N	\N	\N	132687	132687	132688
26896	43123	8	applied	\N	\N	\N	\N	132689	132689	132690
26898	43131	0	applied	\N	\N	\N	\N	132709	132709	132710
26898	43132	1	applied	\N	\N	\N	\N	132711	132711	132712
26898	43133	2	applied	\N	\N	\N	\N	132713	132713	132714
26898	43134	3	applied	\N	\N	\N	\N	132715	132715	132716
26898	43135	4	applied	\N	\N	\N	\N	132717	132717	132718
26898	43136	5	applied	\N	\N	\N	\N	132719	132719	132720
26898	43137	6	applied	\N	\N	\N	\N	132721	132721	132722
26898	43138	7	applied	\N	\N	\N	\N	132723	132723	132724
26898	43139	8	applied	\N	\N	\N	\N	132725	132725	132726
26898	43140	9	applied	\N	\N	\N	\N	132727	132727	132728
26898	43141	10	applied	\N	\N	\N	\N	132729	132729	132730
26904	43151	0	applied	\N	\N	\N	\N	132758	132758	132759
26904	43152	1	applied	\N	\N	\N	\N	132760	132760	132761
26904	43153	2	applied	\N	\N	\N	\N	132762	132762	132763
26905	43154	0	applied	\N	\N	\N	\N	132764	132764	132765
26905	43155	1	applied	\N	\N	\N	\N	132766	132766	132767
26905	43156	2	applied	\N	\N	\N	\N	132768	132768	132769
26909	43163	0	applied	\N	\N	\N	\N	132785	132785	132786
26909	43164	1	applied	\N	\N	\N	\N	132787	132787	132788
26909	43165	2	applied	\N	\N	\N	\N	132789	132789	132790
26913	43169	0	applied	\N	\N	\N	\N	132805	132805	132806
26913	43170	1	applied	\N	\N	\N	\N	132807	132807	132808
26913	43171	2	applied	\N	\N	\N	\N	132809	132809	132810
26915	43172	0	applied	\N	\N	\N	\N	132815	132815	132816
26915	43173	1	applied	\N	\N	\N	\N	132817	132817	132818
26918	43177	0	applied	\N	\N	\N	\N	132829	132829	132830
26918	43178	1	applied	\N	\N	\N	\N	132831	132831	132832
26918	43179	2	applied	\N	\N	\N	\N	132833	132833	132834
26918	43180	3	applied	\N	\N	\N	\N	132835	132835	132836
26918	43181	4	applied	\N	\N	\N	\N	132837	132837	132838
26918	43182	5	applied	\N	\N	\N	\N	132839	132839	132840
26923	43192	0	applied	\N	\N	\N	\N	132886	132886	132887
26923	43193	1	applied	\N	\N	\N	\N	132888	132888	132889
26923	43194	2	applied	\N	\N	\N	\N	132890	132890	132891
26931	43213	0	applied	\N	\N	\N	\N	132942	132942	132943
26931	43214	1	applied	\N	\N	\N	\N	132944	132944	132945
26931	43215	2	applied	\N	\N	\N	\N	132946	132946	132947
26931	43216	3	applied	\N	\N	\N	\N	132948	132948	132949
26931	43217	4	applied	\N	\N	\N	\N	132950	132950	132951
26931	43218	5	applied	\N	\N	\N	\N	132952	132952	132953
26938	43225	0	applied	\N	\N	\N	\N	132974	132974	132975
26938	43226	1	applied	\N	\N	\N	\N	132976	132976	132977
26938	43227	2	applied	\N	\N	\N	\N	132978	132978	132979
26944	43253	0	applied	\N	\N	\N	\N	133037	133037	133038
26944	43254	1	applied	\N	\N	\N	\N	133039	133039	133040
26944	43255	2	applied	\N	\N	\N	\N	133041	133041	133042
26946	43253	0	applied	\N	\N	\N	\N	133037	133037	133038
26946	43254	1	applied	\N	\N	\N	\N	133039	133039	133040
26946	43255	2	applied	\N	\N	\N	\N	133041	133041	133042
26949	43259	0	applied	\N	\N	\N	\N	133054	133054	133055
26949	43260	1	applied	\N	\N	\N	\N	133056	133056	133057
26949	43261	2	applied	\N	\N	\N	\N	133058	133058	133059
26951	43262	0	applied	\N	\N	\N	\N	133062	133062	133063
26951	43263	1	applied	\N	\N	\N	\N	133064	133064	133065
26951	43264	2	applied	\N	\N	\N	\N	133066	133066	133067
26952	43262	0	applied	\N	\N	\N	\N	133062	133062	133063
26952	43263	1	applied	\N	\N	\N	\N	133064	133064	133065
26952	43264	2	applied	\N	\N	\N	\N	133066	133066	133067
26953	43265	0	applied	\N	\N	\N	\N	133072	133072	133073
26953	43266	1	applied	\N	\N	\N	\N	133074	133074	133075
26953	43267	2	applied	\N	\N	\N	\N	133076	133076	133077
26953	43268	3	applied	\N	\N	\N	\N	133078	133078	133079
26962	43279	0	applied	\N	\N	\N	\N	133119	133119	133120
26962	43280	1	applied	\N	\N	\N	\N	133121	133121	133122
26962	43281	2	applied	\N	\N	\N	\N	133123	133123	133124
26962	43282	3	applied	\N	\N	\N	\N	133125	133125	133126
26962	43283	4	applied	\N	\N	\N	\N	133127	133127	133128
26965	43287	0	applied	\N	\N	\N	\N	133138	133138	133139
26965	43288	1	applied	\N	\N	\N	\N	133140	133140	133141
26965	43289	2	applied	\N	\N	\N	\N	133142	133142	133143
26968	43290	0	applied	\N	\N	\N	\N	133144	133144	133145
26968	43291	1	applied	\N	\N	\N	\N	133146	133146	133147
26968	43292	2	applied	\N	\N	\N	\N	133148	133148	133149
26969	43290	0	applied	\N	\N	\N	\N	133144	133144	133145
26969	43291	1	applied	\N	\N	\N	\N	133146	133146	133147
26969	43292	2	applied	\N	\N	\N	\N	133148	133148	133149
26973	43293	0	applied	\N	\N	\N	\N	133184	133184	133185
26973	43294	1	applied	\N	\N	\N	\N	133186	133186	133187
26973	43295	2	applied	\N	\N	\N	\N	133188	133188	133189
26975	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26975	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26975	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26983	43317	0	applied	\N	\N	\N	\N	133251	133251	133252
26983	43318	1	applied	\N	\N	\N	\N	133253	133253	133254
26983	43319	2	applied	\N	\N	\N	\N	133255	133255	133256
26983	43320	3	applied	\N	\N	\N	\N	133257	133257	133258
26983	43321	4	applied	\N	\N	\N	\N	133259	133259	133260
26983	43322	5	applied	\N	\N	\N	\N	133261	133261	133262
26988	43331	0	applied	\N	\N	\N	\N	133286	133286	133287
26988	43332	1	applied	\N	\N	\N	\N	133288	133288	133289
26988	43333	2	applied	\N	\N	\N	\N	133290	133290	133291
26886	43101	0	applied	\N	\N	\N	\N	132616	132616	132617
26886	43102	1	applied	\N	\N	\N	\N	132618	132618	132619
26886	43103	2	applied	\N	\N	\N	\N	132620	132620	132621
26886	43104	3	applied	\N	\N	\N	\N	132622	132622	132623
26891	43108	0	applied	\N	\N	\N	\N	132639	132639	132640
26891	43109	1	applied	\N	\N	\N	\N	132641	132641	132642
26891	43110	2	applied	\N	\N	\N	\N	132643	132643	132644
26903	43148	0	applied	\N	\N	\N	\N	132750	132750	132751
26903	43149	1	applied	\N	\N	\N	\N	132752	132752	132753
26903	43150	2	applied	\N	\N	\N	\N	132754	132754	132755
26908	43163	0	applied	\N	\N	\N	\N	132785	132785	132786
26908	43164	1	applied	\N	\N	\N	\N	132787	132787	132788
26908	43165	2	applied	\N	\N	\N	\N	132789	132789	132790
26912	43166	0	applied	\N	\N	\N	\N	132797	132797	132798
26912	43167	1	applied	\N	\N	\N	\N	132799	132799	132800
26912	43168	2	applied	\N	\N	\N	\N	132801	132801	132802
26917	43174	0	applied	\N	\N	\N	\N	132819	132819	132820
26917	43175	1	applied	\N	\N	\N	\N	132821	132821	132822
26917	43176	2	applied	\N	\N	\N	\N	132823	132823	132824
26925	43195	0	applied	\N	\N	\N	\N	132894	132894	132895
26925	43196	1	applied	\N	\N	\N	\N	132896	132896	132897
26925	43197	2	applied	\N	\N	\N	\N	132898	132898	132899
26930	43204	0	applied	\N	\N	\N	\N	132918	132918	132919
26930	43205	1	applied	\N	\N	\N	\N	132920	132920	132921
26930	43206	2	applied	\N	\N	\N	\N	132922	132922	132923
26930	43207	3	applied	\N	\N	\N	\N	132924	132924	132925
26930	43208	4	applied	\N	\N	\N	\N	132926	132926	132927
26930	43209	5	applied	\N	\N	\N	\N	132928	132928	132929
26930	43210	6	applied	\N	\N	\N	\N	132930	132930	132931
26930	43211	7	applied	\N	\N	\N	\N	132932	132932	132933
26930	43212	9	applied	\N	\N	\N	\N	132935	132935	132936
26933	43213	0	applied	\N	\N	\N	\N	132942	132942	132943
26933	43214	1	applied	\N	\N	\N	\N	132944	132944	132945
26933	43215	2	applied	\N	\N	\N	\N	132946	132946	132947
26933	43216	3	applied	\N	\N	\N	\N	132948	132948	132949
26933	43217	4	applied	\N	\N	\N	\N	132950	132950	132951
26933	43218	5	applied	\N	\N	\N	\N	132952	132952	132953
26935	43219	0	applied	\N	\N	\N	\N	132961	132961	132962
26935	43220	1	applied	\N	\N	\N	\N	132963	132963	132964
26935	43221	2	applied	\N	\N	\N	\N	132965	132965	132966
26940	43228	0	applied	\N	\N	\N	\N	132982	132982	132983
26940	43229	1	applied	\N	\N	\N	\N	132984	132984	132985
26940	43230	2	applied	\N	\N	\N	\N	132986	132986	132987
26948	43259	0	applied	\N	\N	\N	\N	133054	133054	133055
26948	43260	1	applied	\N	\N	\N	\N	133056	133056	133057
26948	43261	2	applied	\N	\N	\N	\N	133058	133058	133059
26950	43262	0	applied	\N	\N	\N	\N	133062	133062	133063
26950	43263	1	applied	\N	\N	\N	\N	133064	133064	133065
26950	43264	2	applied	\N	\N	\N	\N	133066	133066	133067
26956	43265	0	applied	\N	\N	\N	\N	133072	133072	133073
26956	43266	1	applied	\N	\N	\N	\N	133074	133074	133075
26956	43267	2	applied	\N	\N	\N	\N	133076	133076	133077
26956	43268	3	applied	\N	\N	\N	\N	133078	133078	133079
26957	43266	0	applied	\N	\N	\N	\N	133074	133074	133075
26957	43267	1	applied	\N	\N	\N	\N	133076	133076	133077
26957	43268	2	applied	\N	\N	\N	\N	133078	133078	133079
26959	43253	0	applied	\N	\N	\N	\N	133037	133037	133038
26959	43256	1	applied	\N	\N	\N	\N	133047	133047	133048
26959	43259	2	applied	\N	\N	\N	\N	133054	133054	133055
26959	43262	3	applied	\N	\N	\N	\N	133062	133062	133063
26959	43265	4	applied	\N	\N	\N	\N	133072	133072	133073
26959	43254	5	applied	\N	\N	\N	\N	133039	133039	133040
26959	43257	6	applied	\N	\N	\N	\N	133049	133049	133095
26959	43266	7	applied	\N	\N	\N	\N	133074	133074	133075
26959	43261	8	applied	\N	\N	\N	\N	133058	133058	133096
26959	43263	9	applied	\N	\N	\N	\N	133064	133064	133097
26959	43255	10	applied	\N	\N	\N	\N	133041	133041	133098
26959	43258	11	applied	\N	\N	\N	\N	133051	133051	133099
26959	43260	12	applied	\N	\N	\N	\N	133056	133056	133065
26959	43264	13	applied	\N	\N	\N	\N	133066	133066	133067
26959	43267	14	applied	\N	\N	\N	\N	133076	133076	133077
26959	43268	15	applied	\N	\N	\N	\N	133078	133078	133079
26964	43284	0	applied	\N	\N	\N	\N	133132	133132	133133
26964	43285	1	applied	\N	\N	\N	\N	133134	133134	133135
26964	43286	2	applied	\N	\N	\N	\N	133136	133136	133137
26967	43290	0	applied	\N	\N	\N	\N	133144	133144	133145
26967	43291	1	applied	\N	\N	\N	\N	133146	133146	133147
26967	43292	2	applied	\N	\N	\N	\N	133148	133148	133149
26970	42906	0	applied	\N	\N	\N	\N	132007	132007	132008
26970	43274	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	133106	133106	\N
26970	42880	2	applied	\N	\N	\N	\N	131936	131936	132365
26970	43244	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	133019	133019	\N
26970	42893	4	applied	\N	\N	\N	\N	131971	131971	131921
26970	43266	5	applied	\N	\N	\N	\N	133074	133074	133075
26970	42875	6	applied	\N	\N	\N	\N	131920	131920	132366
26970	42881	7	applied	\N	\N	\N	\N	131938	131938	131937
26970	42882	8	applied	\N	\N	\N	\N	131940	131940	131939
26970	42883	9	applied	\N	\N	\N	\N	131942	131942	131941
26970	42905	10	applied	\N	\N	\N	\N	132003	132003	133156
26970	42913	11	applied	\N	\N	\N	\N	132023	132023	131943
26970	42928	12	applied	\N	\N	\N	\N	132061	132061	133157
26970	42937	13	applied	\N	\N	\N	\N	132083	132083	132367
26970	42948	14	applied	\N	\N	\N	\N	132108	132108	131945
26970	42961	15	applied	\N	\N	\N	\N	132148	132148	132368
26970	42970	16	applied	\N	\N	\N	\N	132175	132175	133158
26970	42983	17	applied	\N	\N	\N	\N	132209	132209	131947
26970	42994	18	applied	\N	\N	\N	\N	132236	132236	133159
26970	43005	19	applied	\N	\N	\N	\N	132266	132266	132369
26970	42889	20	applied	\N	\N	\N	\N	131955	131955	132370
26970	42891	21	applied	\N	\N	\N	\N	131963	131963	131954
26970	42895	22	applied	\N	\N	\N	\N	131975	131975	131956
26970	42897	23	applied	\N	\N	\N	\N	131980	131980	131964
26970	42900	24	applied	\N	\N	\N	\N	131990	131990	132374
26970	42904	25	applied	\N	\N	\N	\N	132001	132001	131974
26970	42908	26	applied	\N	\N	\N	\N	132011	132011	131976
26970	42876	27	applied	\N	\N	\N	\N	131922	131922	132435
26970	42884	28	applied	\N	\N	\N	\N	131944	131944	132379
26970	42885	29	applied	\N	\N	\N	\N	131946	131946	133160
26970	42886	30	applied	\N	\N	\N	\N	131948	131948	132381
26970	42888	31	applied	\N	\N	\N	\N	131953	131953	132002
26970	42894	32	applied	\N	\N	\N	\N	131973	131973	132012
26970	42914	33	applied	\N	\N	\N	\N	132025	132025	132383
26970	42915	34	applied	\N	\N	\N	\N	132027	132027	132024
26970	42898	35	applied	\N	\N	\N	\N	131982	131982	132436
26970	43015	36	applied	\N	\N	\N	\N	132288	132288	132028
26970	42919	37	applied	\N	\N	\N	\N	132035	132035	132384
26970	42922	38	applied	\N	\N	\N	\N	132043	132043	132385
26970	42924	39	applied	\N	\N	\N	\N	132047	132047	132032
26970	42929	40	applied	\N	\N	\N	\N	132063	132063	132437
26906	43159	2	applied	\N	\N	\N	\N	132774	132774	132775
26906	43160	3	applied	\N	\N	\N	\N	132776	132776	132777
26906	43161	4	applied	\N	\N	\N	\N	132778	132778	132779
26906	43162	5	applied	\N	\N	\N	\N	132780	132780	132781
26910	43163	0	applied	\N	\N	\N	\N	132785	132785	132786
26910	43164	1	applied	\N	\N	\N	\N	132787	132787	132788
26910	43165	2	applied	\N	\N	\N	\N	132789	132789	132790
26914	43169	0	applied	\N	\N	\N	\N	132805	132805	132806
26914	43170	1	applied	\N	\N	\N	\N	132807	132807	132808
26914	43171	2	applied	\N	\N	\N	\N	132809	132809	132810
26916	43174	0	applied	\N	\N	\N	\N	132819	132819	132820
26916	43175	1	applied	\N	\N	\N	\N	132821	132821	132822
26916	43176	2	applied	\N	\N	\N	\N	132823	132823	132824
26919	43183	0	applied	\N	\N	\N	\N	132842	132842	132843
26919	43184	1	applied	\N	\N	\N	\N	132844	132844	132845
26919	43185	2	applied	\N	\N	\N	\N	132846	132846	132847
26919	43186	3	applied	\N	\N	\N	\N	132848	132848	132849
26919	43187	4	applied	\N	\N	\N	\N	132850	132850	132851
26919	43188	5	applied	\N	\N	\N	\N	132852	132852	132853
26921	43189	0	applied	\N	\N	\N	\N	132877	132877	132878
26921	43190	1	applied	\N	\N	\N	\N	132879	132879	132880
26921	43191	2	applied	\N	\N	\N	\N	132881	132881	132882
26922	43189	0	applied	\N	\N	\N	\N	132877	132877	132878
26922	43190	1	applied	\N	\N	\N	\N	132879	132879	132880
26922	43191	2	applied	\N	\N	\N	\N	132881	132881	132882
26926	43198	0	applied	\N	\N	\N	\N	132904	132904	132905
26926	43199	1	applied	\N	\N	\N	\N	132906	132906	132907
26926	43200	2	applied	\N	\N	\N	\N	132908	132908	132909
26928	43201	0	applied	\N	\N	\N	\N	132912	132912	132913
26928	43202	1	applied	\N	\N	\N	\N	132914	132914	132915
26928	43203	2	applied	\N	\N	\N	\N	132916	132916	132917
26929	43204	0	applied	\N	\N	\N	\N	132918	132918	132919
26929	43205	1	applied	\N	\N	\N	\N	132920	132920	132921
26929	43206	2	applied	\N	\N	\N	\N	132922	132922	132923
26929	43207	3	applied	\N	\N	\N	\N	132924	132924	132925
26929	43208	4	applied	\N	\N	\N	\N	132926	132926	132927
26929	43209	5	applied	\N	\N	\N	\N	132928	132928	132929
26929	43210	6	applied	\N	\N	\N	\N	132930	132930	132931
26929	43211	7	applied	\N	\N	\N	\N	132932	132932	132933
26929	43212	9	applied	\N	\N	\N	\N	132935	132935	132936
26936	43222	0	applied	\N	\N	\N	\N	132967	132967	132968
26936	43223	1	applied	\N	\N	\N	\N	132969	132969	132970
26936	43224	2	applied	\N	\N	\N	\N	132971	132971	132972
26941	43231	0	applied	\N	\N	\N	\N	132990	132990	132991
26941	43232	1	applied	\N	\N	\N	\N	132992	132992	132993
26941	43233	2	applied	\N	\N	\N	\N	132994	132994	132995
26941	43234	3	applied	\N	\N	\N	\N	132996	132996	132997
26941	43235	4	applied	\N	\N	\N	\N	132998	132998	132999
26941	43236	5	applied	\N	\N	\N	\N	133000	133000	133001
26941	43237	6	applied	\N	\N	\N	\N	133002	133002	133003
26941	43238	7	applied	\N	\N	\N	\N	133004	133004	133005
26941	43239	8	applied	\N	\N	\N	\N	133006	133006	133007
26942	43231	0	applied	\N	\N	\N	\N	132990	132990	132991
26942	43232	1	applied	\N	\N	\N	\N	132992	132992	132993
26942	43233	2	applied	\N	\N	\N	\N	132994	132994	132995
26942	43234	3	applied	\N	\N	\N	\N	132996	132996	132997
26942	43235	4	applied	\N	\N	\N	\N	132998	132998	132999
26942	43236	5	applied	\N	\N	\N	\N	133000	133000	133001
26942	43237	6	applied	\N	\N	\N	\N	133002	133002	133003
26942	43238	7	applied	\N	\N	\N	\N	133004	133004	133005
26942	43239	8	applied	\N	\N	\N	\N	133006	133006	133007
26954	43265	0	applied	\N	\N	\N	\N	133072	133072	133073
26954	43266	1	applied	\N	\N	\N	\N	133074	133074	133075
26954	43267	2	applied	\N	\N	\N	\N	133076	133076	133077
26954	43268	3	applied	\N	\N	\N	\N	133078	133078	133079
26960	43272	0	applied	\N	\N	\N	\N	133102	133102	133103
26960	43273	1	applied	\N	\N	\N	\N	133104	133104	133105
26960	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	133106	133106	\N
26960	43275	3	applied	\N	\N	\N	\N	133107	133107	133108
26960	43276	4	applied	\N	\N	\N	\N	133109	133109	133110
26960	43277	5	applied	\N	\N	\N	\N	133111	133111	133112
26960	43278	6	applied	\N	\N	\N	\N	133113	133113	133114
26963	43279	0	applied	\N	\N	\N	\N	133119	133119	133120
26963	43280	1	applied	\N	\N	\N	\N	133121	133121	133122
26963	43281	2	applied	\N	\N	\N	\N	133123	133123	133124
26963	43282	3	applied	\N	\N	\N	\N	133125	133125	133126
26963	43283	4	applied	\N	\N	\N	\N	133127	133127	133128
26971	43293	0	applied	\N	\N	\N	\N	133184	133184	133185
26971	43294	1	applied	\N	\N	\N	\N	133186	133186	133187
26971	43295	2	applied	\N	\N	\N	\N	133188	133188	133189
26976	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26976	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26976	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26978	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26978	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26978	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26980	43299	0	applied	\N	\N	\N	\N	133210	133210	133211
26980	43300	1	applied	\N	\N	\N	\N	133212	133212	133213
26986	43326	0	applied	\N	\N	\N	\N	133273	133273	133274
26986	43327	1	applied	\N	\N	\N	\N	133275	133275	133276
26986	43328	2	applied	\N	\N	\N	\N	133277	133277	133278
26989	43334	0	applied	\N	\N	\N	\N	133294	133294	133295
26989	43335	1	applied	\N	\N	\N	\N	133296	133296	133297
26989	43336	2	applied	\N	\N	\N	\N	133298	133298	133299
26989	43337	3	applied	\N	\N	\N	\N	133300	133300	133301
26989	43338	4	applied	\N	\N	\N	\N	133302	133302	133303
26989	43339	5	applied	\N	\N	\N	\N	133304	133304	133305
26992	43340	0	applied	\N	\N	\N	\N	133308	133308	133309
26992	43341	1	applied	\N	\N	\N	\N	133310	133310	133311
26992	43342	2	applied	\N	\N	\N	\N	133312	133312	133313
26994	43343	0	applied	\N	\N	\N	\N	133314	133314	133315
26994	43344	1	applied	\N	\N	\N	\N	133316	133316	133317
26994	43345	2	applied	\N	\N	\N	\N	133318	133318	133319
26997	43349	0	applied	\N	\N	\N	\N	133330	133330	133331
26997	43350	1	applied	\N	\N	\N	\N	133332	133332	133333
26997	43351	2	applied	\N	\N	\N	\N	133334	133334	133335
26997	43352	3	applied	\N	\N	\N	\N	133336	133336	133337
26997	43353	4	applied	\N	\N	\N	\N	133338	133338	133339
26997	43354	5	applied	\N	\N	\N	\N	133340	133340	133341
26997	43355	6	applied	\N	\N	\N	\N	133342	133342	133343
26997	43356	7	applied	\N	\N	\N	\N	133344	133344	133345
26999	43357	0	applied	\N	\N	\N	\N	133349	133349	133350
26999	43358	1	applied	\N	\N	\N	\N	133351	133351	133352
26999	43359	2	applied	\N	\N	\N	\N	133353	133353	133354
27001	43360	0	applied	\N	\N	\N	\N	133359	133359	133360
27001	43361	1	applied	\N	\N	\N	\N	133361	133361	133362
27004	43366	0	applied	\N	\N	\N	\N	133375	133375	133376
27004	43367	1	applied	\N	\N	\N	\N	133377	133377	133378
27004	43368	2	applied	\N	\N	\N	\N	133379	133379	133380
26920	43152	41	applied	\N	\N	\N	\N	132760	132760	132741
26920	43156	42	applied	\N	\N	\N	\N	132768	132768	132743
26920	43159	43	applied	\N	\N	\N	\N	132774	132774	132862
26920	43140	44	applied	\N	\N	\N	\N	132727	132727	132863
26920	43141	45	applied	\N	\N	\N	\N	132729	132729	132864
26920	43146	46	applied	\N	\N	\N	\N	132744	132744	132755
26920	43147	47	applied	\N	\N	\N	\N	132746	132746	132865
26920	43149	48	applied	\N	\N	\N	\N	132752	132752	132866
26920	43153	49	applied	\N	\N	\N	\N	132762	132762	132867
26920	43155	50	applied	\N	\N	\N	\N	132766	132766	132775
26920	43160	51	applied	\N	\N	\N	\N	132776	132776	132777
26920	43161	52	applied	\N	\N	\N	\N	132778	132778	132779
26920	43165	53	applied	\N	\N	\N	\N	132789	132789	132868
26920	43168	54	applied	\N	\N	\N	\N	132801	132801	132869
26920	43170	55	applied	\N	\N	\N	\N	132807	132807	132800
26920	43176	56	applied	\N	\N	\N	\N	132823	132823	132802
26920	43181	57	applied	\N	\N	\N	\N	132837	132837	132808
26920	43182	58	applied	\N	\N	\N	\N	132839	132839	132870
26920	43186	59	applied	\N	\N	\N	\N	132848	132848	132822
26920	43187	60	applied	\N	\N	\N	\N	132850	132850	132824
26920	43162	61	applied	\N	\N	\N	\N	132780	132780	132834
26920	43164	62	applied	\N	\N	\N	\N	132787	132787	132836
26920	43167	63	applied	\N	\N	\N	\N	132799	132799	132871
26920	43171	64	applied	\N	\N	\N	\N	132809	132809	132872
26920	43173	65	applied	\N	\N	\N	\N	132817	132817	132840
26920	43175	66	applied	\N	\N	\N	\N	132821	132821	132847
26920	43179	67	applied	\N	\N	\N	\N	132833	132833	132873
26920	43180	68	applied	\N	\N	\N	\N	132835	132835	132874
26920	43185	69	applied	\N	\N	\N	\N	132846	132846	132851
26920	43188	70	applied	\N	\N	\N	\N	132852	132852	132853
26924	43195	0	applied	\N	\N	\N	\N	132894	132894	132895
26924	43196	1	applied	\N	\N	\N	\N	132896	132896	132897
26924	43197	2	applied	\N	\N	\N	\N	132898	132898	132899
26927	43198	0	applied	\N	\N	\N	\N	132904	132904	132905
26927	43199	1	applied	\N	\N	\N	\N	132906	132906	132907
26927	43200	2	applied	\N	\N	\N	\N	132908	132908	132909
26932	43213	0	applied	\N	\N	\N	\N	132942	132942	132943
26932	43214	1	applied	\N	\N	\N	\N	132944	132944	132945
26932	43215	2	applied	\N	\N	\N	\N	132946	132946	132947
26932	43216	3	applied	\N	\N	\N	\N	132948	132948	132949
26932	43217	4	applied	\N	\N	\N	\N	132950	132950	132951
26932	43218	5	applied	\N	\N	\N	\N	132952	132952	132953
26934	43213	0	applied	\N	\N	\N	\N	132942	132942	132943
26934	43214	1	applied	\N	\N	\N	\N	132944	132944	132945
26934	43215	2	applied	\N	\N	\N	\N	132946	132946	132947
26934	43216	3	applied	\N	\N	\N	\N	132948	132948	132949
26934	43217	4	applied	\N	\N	\N	\N	132950	132950	132951
26934	43218	5	applied	\N	\N	\N	\N	132952	132952	132953
26937	43225	0	applied	\N	\N	\N	\N	132974	132974	132975
26937	43226	1	applied	\N	\N	\N	\N	132976	132976	132977
26937	43227	2	applied	\N	\N	\N	\N	132978	132978	132979
26939	43228	0	applied	\N	\N	\N	\N	132982	132982	132983
26939	43229	1	applied	\N	\N	\N	\N	132984	132984	132985
26939	43230	2	applied	\N	\N	\N	\N	132986	132986	132987
26943	43240	0	applied	\N	\N	\N	\N	133011	133011	133012
26943	43241	1	applied	\N	\N	\N	\N	133013	133013	133014
26943	43242	2	applied	\N	\N	\N	\N	133015	133015	133016
26943	43243	3	applied	\N	\N	\N	\N	133017	133017	133018
26943	43244	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	133019	133019	\N
26943	43245	5	applied	\N	\N	\N	\N	133020	133020	133021
26943	43246	6	applied	\N	\N	\N	\N	133022	133022	133023
26943	43247	7	applied	\N	\N	\N	\N	133024	133024	133025
26943	43248	8	applied	\N	\N	\N	\N	133026	133026	133027
26943	43249	9	applied	\N	\N	\N	\N	133028	133028	133029
26943	43250	10	applied	\N	\N	\N	\N	133030	133030	133031
26943	43251	11	applied	\N	\N	\N	\N	133032	133032	133033
26943	43252	12	applied	\N	\N	\N	\N	133034	133034	133035
26945	43253	0	applied	\N	\N	\N	\N	133037	133037	133038
26945	43254	1	applied	\N	\N	\N	\N	133039	133039	133040
26945	43255	2	applied	\N	\N	\N	\N	133041	133041	133042
26947	43256	0	applied	\N	\N	\N	\N	133047	133047	133048
26947	43257	1	applied	\N	\N	\N	\N	133049	133049	133050
26947	43258	2	applied	\N	\N	\N	\N	133051	133051	133052
26955	43265	0	applied	\N	\N	\N	\N	133072	133072	133073
26955	43266	1	applied	\N	\N	\N	\N	133074	133074	133075
26955	43267	2	applied	\N	\N	\N	\N	133076	133076	133077
26955	43268	3	applied	\N	\N	\N	\N	133078	133078	133079
26958	43269	0	applied	\N	\N	\N	\N	133087	133087	133088
26958	43270	1	applied	\N	\N	\N	\N	133089	133089	133090
26958	43271	2	applied	\N	\N	\N	\N	133091	133091	133092
26961	43272	0	applied	\N	\N	\N	\N	133102	133102	133103
26961	43273	1	applied	\N	\N	\N	\N	133104	133104	133105
26961	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	133106	133106	\N
26961	43275	3	applied	\N	\N	\N	\N	133107	133107	133108
26961	43276	4	applied	\N	\N	\N	\N	133109	133109	133110
26961	43277	5	applied	\N	\N	\N	\N	133111	133111	133112
26961	43278	6	applied	\N	\N	\N	\N	133113	133113	133114
26966	43290	0	applied	\N	\N	\N	\N	133144	133144	133145
26966	43291	1	applied	\N	\N	\N	\N	133146	133146	133147
26966	43292	2	applied	\N	\N	\N	\N	133148	133148	133149
26972	43293	0	applied	\N	\N	\N	\N	133184	133184	133185
26972	43294	1	applied	\N	\N	\N	\N	133186	133186	133187
26972	43295	2	applied	\N	\N	\N	\N	133188	133188	133189
26974	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26974	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26974	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26977	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26977	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26977	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26981	43301	0	applied	\N	\N	\N	\N	133216	133216	133217
26981	43302	1	applied	\N	\N	\N	\N	133218	133218	133219
26981	43303	2	applied	\N	\N	\N	\N	133220	133220	133221
26981	43304	3	applied	\N	\N	\N	\N	133222	133222	133223
26981	43305	4	applied	\N	\N	\N	\N	133224	133224	133225
26981	43306	5	applied	\N	\N	\N	\N	133226	133226	133227
26981	43307	6	applied	\N	\N	\N	\N	133228	133228	133229
26984	43323	0	applied	\N	\N	\N	\N	133264	133264	133265
26984	43324	1	applied	\N	\N	\N	\N	133266	133266	133267
26984	43325	2	applied	\N	\N	\N	\N	133268	133268	133269
26985	43324	0	applied	\N	\N	\N	\N	133266	133266	133267
26985	43325	1	applied	\N	\N	\N	\N	133268	133268	133269
27008	43369	0	applied	\N	\N	\N	\N	133385	133385	133386
27008	43370	1	applied	\N	\N	\N	\N	133387	133387	133388
27008	43371	2	applied	\N	\N	\N	\N	133389	133389	133390
27008	43372	3	applied	\N	\N	\N	\N	133391	133391	133392
27008	43373	4	applied	\N	\N	\N	\N	133393	133393	133394
27008	43374	5	applied	\N	\N	\N	\N	133395	133395	133396
27011	43375	0	applied	\N	\N	\N	\N	133403	133403	133404
27011	43376	1	applied	\N	\N	\N	\N	133405	133405	133406
26970	42930	41	applied	\N	\N	\N	\N	132065	132065	132438
26970	42942	42	applied	\N	\N	\N	\N	132093	132093	132387
26970	42943	43	applied	\N	\N	\N	\N	132095	132095	132042
26970	42944	44	applied	\N	\N	\N	\N	132097	132097	132044
26970	42945	45	applied	\N	\N	\N	\N	132099	132099	132048
26970	42949	46	applied	\N	\N	\N	\N	132110	132110	132440
26970	42952	47	applied	\N	\N	\N	\N	132120	132120	132062
26970	42956	48	applied	\N	\N	\N	\N	132130	132130	132064
26970	42958	49	applied	\N	\N	\N	\N	132138	132138	132066
26970	42963	50	applied	\N	\N	\N	\N	132152	132152	132441
26970	43027	51	applied	\N	\N	\N	\N	132316	132316	132068
26970	43039	52	applied	\N	\N	\N	\N	132346	132346	132390
26970	43047	53	applied	\N	\N	\N	\N	132411	132411	132442
26970	43063	54	applied	\N	\N	\N	\N	132478	132478	132070
26970	43070	55	applied	\N	\N	\N	\N	132497	132497	132084
26970	43081	56	applied	\N	\N	\N	\N	132525	132525	132391
26970	43093	57	applied	\N	\N	\N	\N	132596	132596	132443
26970	43103	58	applied	\N	\N	\N	\N	132620	132620	132086
26970	43112	59	applied	\N	\N	\N	\N	132649	132649	132444
26970	43129	60	applied	\N	\N	\N	\N	132705	132705	132393
26970	42965	61	applied	\N	\N	\N	\N	132161	132161	132394
26970	42967	62	applied	\N	\N	\N	\N	132167	132167	132090
26970	42971	63	applied	\N	\N	\N	\N	132177	132177	132395
26970	42975	64	applied	\N	\N	\N	\N	132188	132188	132396
26970	42979	65	applied	\N	\N	\N	\N	132201	132201	132397
26970	42984	66	applied	\N	\N	\N	\N	132211	132211	132398
26970	42985	67	applied	\N	\N	\N	\N	132213	132213	132399
26970	42987	68	applied	\N	\N	\N	\N	132219	132219	132400
26970	42990	69	applied	\N	\N	\N	\N	132226	132226	132107
26970	42995	70	applied	\N	\N	\N	\N	132238	132238	132401
26970	42997	71	applied	\N	\N	\N	\N	132245	132245	132402
26970	43001	72	applied	\N	\N	\N	\N	132255	132255	132119
26970	43003	73	applied	\N	\N	\N	\N	132262	132262	132121
26970	43010	74	applied	\N	\N	\N	\N	132278	132278	133161
26970	43012	75	applied	\N	\N	\N	\N	132282	132282	133162
26970	43013	76	applied	\N	\N	\N	\N	132284	132284	133163
26970	43014	77	applied	\N	\N	\N	\N	132286	132286	133164
26970	43020	78	applied	\N	\N	\N	\N	132300	132300	132141
26970	43024	79	applied	\N	\N	\N	\N	132310	132310	133165
26970	43026	80	applied	\N	\N	\N	\N	132314	132314	132151
26970	43029	81	applied	\N	\N	\N	\N	132322	132322	132153
26970	43033	82	applied	\N	\N	\N	\N	132332	132332	132162
26970	43036	83	applied	\N	\N	\N	\N	132340	132340	132168
26970	43038	84	applied	\N	\N	\N	\N	132344	132344	133166
26970	43043	85	applied	\N	\N	\N	\N	132356	132356	132176
26970	43051	86	applied	\N	\N	\N	\N	132419	132419	132178
26970	43052	87	applied	\N	\N	\N	\N	132421	132421	132458
26970	43053	88	applied	\N	\N	\N	\N	132423	132423	133167
26970	43055	89	applied	\N	\N	\N	\N	132429	132429	132187
26970	43060	90	applied	\N	\N	\N	\N	132472	132472	132189
26970	43061	91	applied	\N	\N	\N	\N	132474	132474	132202
26970	43066	92	applied	\N	\N	\N	\N	132489	132489	133168
26970	43068	93	applied	\N	\N	\N	\N	132493	132493	132461
26970	43073	94	applied	\N	\N	\N	\N	132504	132504	132206
26970	43075	95	applied	\N	\N	\N	\N	132511	132511	132552
26970	43078	96	applied	\N	\N	\N	\N	132520	132520	132210
26970	43084	97	applied	\N	\N	\N	\N	132532	132532	132212
26970	43087	98	applied	\N	\N	\N	\N	132541	132541	132214
26970	43091	99	applied	\N	\N	\N	\N	132592	132592	132220
26970	43092	100	applied	\N	\N	\N	\N	132594	132594	133169
26970	43097	102	applied	\N	\N	\N	\N	132604	132604	133171
26970	43099	103	applied	\N	\N	\N	\N	132610	132610	132554
26970	43102	104	applied	\N	\N	\N	\N	132618	132618	132229
26970	43107	105	applied	\N	\N	\N	\N	132633	132633	133172
26970	43110	106	applied	\N	\N	\N	\N	132643	132643	132237
26970	43114	107	applied	\N	\N	\N	\N	132653	132653	132239
26970	43116	108	applied	\N	\N	\N	\N	132666	132666	132246
26970	43122	109	applied	\N	\N	\N	\N	132687	132687	132557
26970	43123	110	applied	\N	\N	\N	\N	132689	132689	133173
26970	43126	111	applied	\N	\N	\N	\N	132699	132699	132254
26970	43127	112	applied	\N	\N	\N	\N	132701	132701	132256
26970	43136	113	applied	\N	\N	\N	\N	132719	132719	132263
26970	43137	114	applied	\N	\N	\N	\N	132721	132721	133174
26970	43139	115	applied	\N	\N	\N	\N	132725	132725	132267
26970	43144	116	applied	\N	\N	\N	\N	132740	132740	132279
26970	43145	117	applied	\N	\N	\N	\N	132742	132742	133175
26970	43150	118	applied	\N	\N	\N	\N	132754	132754	132561
26970	43152	119	applied	\N	\N	\N	\N	132760	132760	133176
26970	43156	120	applied	\N	\N	\N	\N	132768	132768	133177
26970	43159	121	applied	\N	\N	\N	\N	132774	132774	132289
26970	43162	122	applied	\N	\N	\N	\N	132780	132780	133178
26970	43164	123	applied	\N	\N	\N	\N	132787	132787	133179
26970	43167	124	applied	\N	\N	\N	\N	132799	132799	132293
26970	43171	125	applied	\N	\N	\N	\N	132809	132809	133180
26979	43296	0	applied	\N	\N	\N	\N	133192	133192	133193
26979	43297	1	applied	\N	\N	\N	\N	133194	133194	133195
26979	43298	2	applied	\N	\N	\N	\N	133196	133196	133197
26982	43308	0	applied	\N	\N	\N	\N	133232	133232	133233
26982	43309	1	applied	\N	\N	\N	\N	133234	133234	133235
26982	43310	2	applied	\N	\N	\N	\N	133236	133236	133237
26982	43311	3	applied	\N	\N	\N	\N	133238	133238	133239
26982	43312	4	applied	\N	\N	\N	\N	133240	133240	133241
26982	43313	5	applied	\N	\N	\N	\N	133242	133242	133243
26982	43314	6	applied	\N	\N	\N	\N	133244	133244	133245
26982	43315	7	applied	\N	\N	\N	\N	133246	133246	133247
26982	43316	8	applied	\N	\N	\N	\N	133248	133248	133249
26987	43329	0	applied	\N	\N	\N	\N	133280	133280	133281
26987	43330	1	applied	\N	\N	\N	\N	133282	133282	133283
26990	43340	0	applied	\N	\N	\N	\N	133308	133308	133309
26990	43341	1	applied	\N	\N	\N	\N	133310	133310	133311
26990	43342	2	applied	\N	\N	\N	\N	133312	133312	133313
27000	43360	0	applied	\N	\N	\N	\N	133359	133359	133360
27000	43361	1	applied	\N	\N	\N	\N	133361	133361	133362
27002	43362	0	applied	\N	\N	\N	\N	133367	133367	133368
27002	43363	1	applied	\N	\N	\N	\N	133369	133369	133370
27002	43364	2	applied	\N	\N	\N	\N	133371	133371	133372
27002	43365	3	applied	\N	\N	\N	\N	133373	133373	133374
27005	43369	0	applied	\N	\N	\N	\N	133385	133385	133386
27005	43370	1	applied	\N	\N	\N	\N	133387	133387	133388
27005	43371	2	applied	\N	\N	\N	\N	133389	133389	133390
27005	43372	3	applied	\N	\N	\N	\N	133391	133391	133392
27005	43373	4	applied	\N	\N	\N	\N	133393	133393	133394
27005	43374	5	applied	\N	\N	\N	\N	133395	133395	133396
27009	43375	0	applied	\N	\N	\N	\N	133403	133403	133404
27009	43376	1	applied	\N	\N	\N	\N	133405	133405	133406
27009	43377	2	applied	\N	\N	\N	\N	133407	133407	133408
27016	43384	0	applied	\N	\N	\N	\N	133427	133427	133428
27016	43385	2	applied	\N	\N	\N	\N	133430	133430	133431
27016	43386	3	applied	\N	\N	\N	\N	133432	133432	133433
27023	43395	0	applied	\N	\N	\N	\N	133464	133464	133465
26991	43340	0	applied	\N	\N	\N	\N	133308	133308	133309
26991	43341	1	applied	\N	\N	\N	\N	133310	133310	133311
26991	43342	2	applied	\N	\N	\N	\N	133312	133312	133313
26993	43343	0	applied	\N	\N	\N	\N	133314	133314	133315
26993	43344	1	applied	\N	\N	\N	\N	133316	133316	133317
26993	43345	2	applied	\N	\N	\N	\N	133318	133318	133319
26995	43346	0	applied	\N	\N	\N	\N	133324	133324	133325
26995	43347	1	applied	\N	\N	\N	\N	133326	133326	133327
26995	43348	2	applied	\N	\N	\N	\N	133328	133328	133329
26996	43349	0	applied	\N	\N	\N	\N	133330	133330	133331
26996	43350	1	applied	\N	\N	\N	\N	133332	133332	133333
26996	43351	2	applied	\N	\N	\N	\N	133334	133334	133335
26996	43352	3	applied	\N	\N	\N	\N	133336	133336	133337
26996	43353	4	applied	\N	\N	\N	\N	133338	133338	133339
26996	43354	5	applied	\N	\N	\N	\N	133340	133340	133341
26996	43355	6	applied	\N	\N	\N	\N	133342	133342	133343
26996	43356	7	applied	\N	\N	\N	\N	133344	133344	133345
26998	43357	0	applied	\N	\N	\N	\N	133349	133349	133350
26998	43358	1	applied	\N	\N	\N	\N	133351	133351	133352
26998	43359	2	applied	\N	\N	\N	\N	133353	133353	133354
27003	43366	0	applied	\N	\N	\N	\N	133375	133375	133376
27003	43367	1	applied	\N	\N	\N	\N	133377	133377	133378
27003	43368	2	applied	\N	\N	\N	\N	133379	133379	133380
27006	43369	0	applied	\N	\N	\N	\N	133385	133385	133386
27006	43370	1	applied	\N	\N	\N	\N	133387	133387	133388
27006	43371	2	applied	\N	\N	\N	\N	133389	133389	133390
27006	43372	3	applied	\N	\N	\N	\N	133391	133391	133392
27006	43373	4	applied	\N	\N	\N	\N	133393	133393	133394
27006	43374	5	applied	\N	\N	\N	\N	133395	133395	133396
27010	43377	0	applied	\N	\N	\N	\N	133407	133407	133410
27012	43378	0	applied	\N	\N	\N	\N	133414	133414	133415
27012	43379	1	applied	\N	\N	\N	\N	133416	133416	133417
27012	43380	2	applied	\N	\N	\N	\N	133418	133418	133419
27012	43381	3	applied	\N	\N	\N	\N	133420	133420	133421
27012	43382	4	applied	\N	\N	\N	\N	133422	133422	133423
27012	43383	5	applied	\N	\N	\N	\N	133424	133424	133425
27015	43384	0	applied	\N	\N	\N	\N	133427	133427	133428
27015	43385	2	applied	\N	\N	\N	\N	133430	133430	133431
27015	43386	3	applied	\N	\N	\N	\N	133432	133432	133433
27017	43387	0	applied	\N	\N	\N	\N	133439	133439	133440
27017	43388	1	applied	\N	\N	\N	\N	133441	133441	133442
27019	43389	0	applied	\N	\N	\N	\N	133445	133445	133446
27019	43390	1	applied	\N	\N	\N	\N	133447	133447	133448
27024	43395	0	applied	\N	\N	\N	\N	133464	133464	133465
27024	43396	1	applied	\N	\N	\N	\N	133466	133466	133467
27024	43397	2	applied	\N	\N	\N	\N	133468	133468	133469
27026	43399	0	applied	\N	\N	\N	\N	133472	133472	133473
27026	43400	1	applied	\N	\N	\N	\N	133474	133474	133475
27028	43398	0	applied	\N	\N	\N	\N	133470	133470	133471
27028	43401	1	applied	\N	\N	\N	\N	133504	133504	133505
27028	43402	2	applied	\N	\N	\N	\N	133506	133506	133507
27028	43403	3	applied	\N	\N	\N	\N	133508	133508	133509
27030	43362	0	applied	\N	\N	\N	\N	133367	133367	133368
27030	43366	1	applied	\N	\N	\N	\N	133375	133375	133376
27030	43369	2	applied	\N	\N	\N	\N	133385	133385	133386
27030	43370	3	applied	\N	\N	\N	\N	133387	133387	133388
27030	43375	4	applied	\N	\N	\N	\N	133403	133403	133404
27030	43378	5	applied	\N	\N	\N	\N	133414	133414	133415
27030	43379	6	applied	\N	\N	\N	\N	133416	133416	133417
27030	43384	7	applied	\N	\N	\N	\N	133427	133427	133428
27030	43387	8	applied	\N	\N	\N	\N	133439	133439	133440
27030	43389	9	applied	\N	\N	\N	\N	133445	133445	133446
27030	43392	10	applied	\N	\N	\N	\N	133458	133458	133459
27030	43395	11	applied	\N	\N	\N	\N	133464	133464	133465
27030	43398	12	applied	\N	\N	\N	\N	133470	133470	133471
27030	43401	13	applied	\N	\N	\N	\N	133504	133504	133505
27030	43404	14	applied	\N	\N	\N	\N	133512	133512	133513
27030	43363	15	applied	\N	\N	\N	\N	133369	133369	133370
27030	43364	16	applied	\N	\N	\N	\N	133371	133371	133372
27030	43368	17	applied	\N	\N	\N	\N	133379	133379	133514
27030	43371	18	applied	\N	\N	\N	\N	133389	133389	133515
27030	43365	19	applied	\N	\N	\N	\N	133373	133373	133516
27030	43367	20	applied	\N	\N	\N	\N	133377	133377	133390
27030	43372	21	applied	\N	\N	\N	\N	133391	133391	133392
27030	43377	22	applied	\N	\N	\N	\N	133407	133407	133517
27030	43380	23	applied	\N	\N	\N	\N	133418	133418	133518
27030	43381	24	applied	\N	\N	\N	\N	133420	133420	133396
27030	43385	25	applied	\N	\N	\N	\N	133430	133430	133410
27030	43390	26	applied	\N	\N	\N	\N	133447	133447	133519
27030	43394	27	applied	\N	\N	\N	\N	133462	133462	133520
27030	43397	28	applied	\N	\N	\N	\N	133468	133468	133521
27030	43400	29	applied	\N	\N	\N	\N	133474	133474	133522
27030	43403	30	applied	\N	\N	\N	\N	133508	133508	133423
27030	43405	31	applied	\N	\N	\N	\N	133523	133523	133524
27030	43373	32	applied	\N	\N	\N	\N	133393	133393	133431
27033	43404	0	applied	\N	\N	\N	\N	133512	133512	133513
27033	43406	1	applied	\N	\N	\N	\N	133527	133527	133528
27033	43405	2	applied	\N	\N	\N	\N	133523	133523	133529
27034	43404	0	applied	\N	\N	\N	\N	133512	133512	133513
27034	43405	1	applied	\N	\N	\N	\N	133523	133523	133536
27036	43407	0	applied	\N	\N	\N	\N	133538	133538	133539
27036	43408	1	applied	\N	\N	\N	\N	133540	133540	133541
27036	43409	2	applied	\N	\N	\N	\N	133542	133542	133543
27036	43410	3	applied	\N	\N	1000000000	\N	133544	133544	133545
27038	43411	0	applied	\N	\N	\N	\N	133552	133552	133553
27038	43412	1	applied	\N	\N	\N	\N	133554	133554	133555
27038	43413	2	applied	\N	\N	1000000000	\N	133556	133556	133557
27038	43414	3	applied	\N	\N	1000000000	\N	133558	133558	133559
27038	43415	4	applied	\N	\N	1000000000	\N	133560	133560	133561
27039	43410	0	applied	\N	\N	1000000000	\N	133544	133544	133545
27039	43413	1	applied	\N	\N	1000000000	\N	133556	133556	133557
27039	43414	2	applied	\N	\N	1000000000	\N	133558	133558	133559
27039	43415	3	applied	\N	\N	1000000000	\N	133560	133560	133561
27043	43411	0	applied	\N	\N	\N	\N	133552	133552	133553
27043	43412	1	applied	\N	\N	\N	\N	133554	133554	133555
27043	43413	2	applied	\N	\N	1000000000	\N	133556	133556	133557
27043	43414	3	applied	\N	\N	1000000000	\N	133558	133558	133559
27043	43415	4	applied	\N	\N	1000000000	\N	133560	133560	133561
27056	43440	0	applied	\N	\N	\N	\N	133644	133644	133645
27056	43441	1	applied	\N	\N	\N	\N	133646	133646	133647
27056	43442	2	applied	\N	\N	\N	\N	133648	133648	133649
27056	43443	3	applied	\N	\N	\N	\N	133650	133650	133651
27056	43444	4	applied	\N	\N	\N	\N	133652	133652	133653
27056	43445	5	applied	\N	\N	\N	\N	133654	133654	133655
27059	43446	0	applied	\N	\N	\N	\N	133658	133658	133659
27059	43447	1	applied	\N	\N	\N	\N	133660	133660	133661
27059	43448	2	applied	\N	\N	\N	\N	133662	133662	133663
27084	43514	0	applied	\N	\N	\N	\N	133886	133886	133887
27007	43369	0	applied	\N	\N	\N	\N	133385	133385	133386
27007	43370	1	applied	\N	\N	\N	\N	133387	133387	133388
27007	43371	2	applied	\N	\N	\N	\N	133389	133389	133390
27007	43372	3	applied	\N	\N	\N	\N	133391	133391	133392
27007	43373	4	applied	\N	\N	\N	\N	133393	133393	133394
27007	43374	5	applied	\N	\N	\N	\N	133395	133395	133396
27013	43384	0	applied	\N	\N	\N	\N	133427	133427	133428
27013	43385	2	applied	\N	\N	\N	\N	133430	133430	133431
27013	43386	3	applied	\N	\N	\N	\N	133432	133432	133433
27020	43389	0	applied	\N	\N	\N	\N	133445	133445	133446
27020	43390	1	applied	\N	\N	\N	\N	133447	133447	133448
27020	43391	2	applied	\N	\N	\N	\N	133449	133449	133450
27022	43392	0	applied	\N	\N	\N	\N	133458	133458	133459
27022	43393	1	applied	\N	\N	\N	\N	133460	133460	133461
27022	43394	2	applied	\N	\N	\N	\N	133462	133462	133463
27040	43411	0	applied	\N	\N	\N	\N	133552	133552	133553
27040	43412	1	applied	\N	\N	\N	\N	133554	133554	133555
27040	43413	2	applied	\N	\N	1000000000	\N	133556	133556	133557
27040	43414	3	applied	\N	\N	1000000000	\N	133558	133558	133559
27040	43415	4	applied	\N	\N	1000000000	\N	133560	133560	133561
27047	43419	0	applied	\N	\N	\N	\N	133584	133584	133585
27047	43420	1	applied	\N	\N	\N	\N	133586	133586	133587
27047	43421	2	applied	\N	\N	\N	\N	133588	133588	133589
27047	43422	3	applied	\N	\N	\N	\N	133590	133590	133591
27047	43423	4	applied	\N	\N	\N	\N	133592	133592	133593
27047	43424	5	applied	\N	\N	\N	\N	133594	133594	133595
27052	43432	0	applied	\N	\N	\N	\N	133616	133616	133617
27054	43431	0	applied	\N	\N	\N	\N	133614	133614	133615
27054	43434	1	applied	\N	\N	\N	\N	133628	133628	133629
27054	43435	2	applied	\N	\N	\N	\N	133630	133630	133631
27054	43436	3	applied	\N	\N	\N	\N	133632	133632	133633
27054	43437	4	applied	\N	\N	\N	\N	133634	133634	133635
27054	43433	5	applied	\N	\N	\N	\N	133618	133618	133636
27054	43438	6	applied	\N	\N	\N	\N	133637	133637	133638
27054	43439	7	applied	\N	\N	\N	\N	133639	133639	133640
27055	43431	0	applied	\N	\N	\N	\N	133614	133614	133615
27055	43434	1	applied	\N	\N	\N	\N	133628	133628	133629
27055	43435	2	applied	\N	\N	\N	\N	133630	133630	133631
27055	43436	3	applied	\N	\N	\N	\N	133632	133632	133633
27055	43437	4	applied	\N	\N	\N	\N	133634	133634	133635
27055	43433	5	applied	\N	\N	\N	\N	133618	133618	133636
27055	43438	6	applied	\N	\N	\N	\N	133637	133637	133638
27055	43439	7	applied	\N	\N	\N	\N	133639	133639	133640
27057	43440	0	applied	\N	\N	\N	\N	133644	133644	133645
27057	43441	1	applied	\N	\N	\N	\N	133646	133646	133647
27057	43442	2	applied	\N	\N	\N	\N	133648	133648	133649
27057	43443	3	applied	\N	\N	\N	\N	133650	133650	133651
27057	43444	4	applied	\N	\N	\N	\N	133652	133652	133653
27057	43445	5	applied	\N	\N	\N	\N	133654	133654	133655
27062	43458	0	applied	\N	\N	\N	\N	133689	133689	133690
27062	43459	1	applied	\N	\N	\N	\N	133691	133691	133692
27062	43460	2	applied	\N	\N	\N	\N	133693	133693	133694
27062	43461	3	applied	\N	\N	\N	\N	133695	133695	133696
27062	43462	4	applied	\N	\N	\N	\N	133697	133697	133698
27062	43463	5	applied	\N	\N	\N	\N	133699	133699	133700
27062	43464	6	applied	\N	\N	\N	\N	133701	133701	133701
27062	43465	7	applied	\N	\N	\N	\N	133702	133702	133703
27067	43469	0	applied	\N	\N	\N	\N	133714	133714	133715
27067	43470	2	applied	\N	\N	\N	\N	133720	133720	133721
27067	43471	3	applied	\N	\N	\N	\N	133722	133722	133723
27067	43472	4	applied	\N	\N	\N	\N	133724	133724	133725
27067	43473	5	applied	\N	\N	\N	\N	133726	133726	133727
27067	43474	6	applied	\N	\N	\N	\N	133728	133728	133729
27069	43173	0	applied	\N	\N	\N	\N	132817	132817	133738
27069	43175	1	applied	\N	\N	\N	\N	132821	132821	132562
27069	43179	2	applied	\N	\N	\N	\N	132833	132833	132309
27069	43180	3	applied	\N	\N	\N	\N	132835	132835	132311
27069	43185	4	applied	\N	\N	\N	\N	132846	132846	132564
27069	43188	5	applied	\N	\N	\N	\N	132852	132852	133739
27069	43191	6	applied	\N	\N	\N	\N	132881	132881	132317
27069	43460	7	applied	\N	\N	\N	\N	133693	133693	133694
27069	43461	8	applied	\N	\N	\N	\N	133695	133695	133696
27069	43462	9	applied	\N	\N	\N	\N	133697	133697	133698
27069	43463	10	applied	\N	\N	\N	\N	133699	133699	133700
27069	43464	11	applied	\N	\N	\N	\N	133701	133701	133701
27069	43194	12	applied	\N	\N	\N	\N	132890	132890	132323
27069	43197	13	applied	\N	\N	\N	\N	132898	132898	133740
27069	43200	14	applied	\N	\N	\N	\N	132908	132908	133741
27069	43203	15	applied	\N	\N	\N	\N	132916	132916	132331
27069	43207	16	applied	\N	\N	\N	\N	132924	132924	132333
27069	43208	17	applied	\N	\N	\N	\N	132926	132926	132341
27069	43209	18	applied	\N	\N	\N	\N	132928	132928	132566
27069	43215	19	applied	\N	\N	\N	\N	132946	132946	133742
27069	43217	20	applied	\N	\N	\N	\N	132950	132950	132347
27069	43221	21	applied	\N	\N	\N	\N	132965	132965	132567
27069	43223	22	applied	\N	\N	\N	\N	132969	132969	133743
27069	43226	23	applied	\N	\N	\N	\N	132976	132976	132355
27069	43229	24	applied	\N	\N	\N	\N	132984	132984	132357
27069	43237	25	applied	\N	\N	\N	\N	133002	133002	133744
27069	43238	26	applied	\N	\N	\N	\N	133004	133004	132414
27069	43239	27	applied	\N	\N	\N	\N	133006	133006	132570
27069	43246	28	applied	\N	\N	\N	\N	133022	133022	133745
27069	43247	29	applied	\N	\N	\N	\N	133024	133024	132418
27069	43248	30	applied	\N	\N	\N	\N	133026	133026	132420
27069	43249	31	applied	\N	\N	\N	\N	133028	133028	132422
27069	43254	32	applied	\N	\N	\N	\N	133039	133039	132424
27069	43257	33	applied	\N	\N	\N	\N	133049	133049	132430
27069	43261	34	applied	\N	\N	\N	\N	133058	133058	133746
27069	43263	35	applied	\N	\N	\N	\N	133064	133064	133747
27069	43410	36	applied	\N	\N	1000000000	\N	133544	133544	133545
27069	43413	37	applied	\N	\N	1000000000	\N	133556	133556	133557
27069	43414	38	applied	\N	\N	1000000000	\N	133558	133558	133559
27069	43415	39	applied	\N	\N	1000000000	\N	133560	133560	133561
27069	43268	40	applied	\N	\N	\N	\N	133078	133078	132471
27069	43271	41	applied	\N	\N	\N	\N	133091	133091	132473
27069	43276	42	applied	\N	\N	\N	\N	133109	133109	132475
27069	43278	43	applied	\N	\N	\N	\N	133113	133113	132574
27069	43281	44	applied	\N	\N	\N	\N	133123	133123	132479
27069	43283	45	applied	\N	\N	\N	\N	133127	133127	133748
27069	43286	46	applied	\N	\N	\N	\N	133136	133136	132576
27069	43289	47	applied	\N	\N	\N	\N	133142	133142	133749
27069	43292	48	applied	\N	\N	\N	\N	133148	133148	133750
27069	43294	49	applied	\N	\N	\N	\N	133186	133186	132496
27069	43297	50	applied	\N	\N	\N	\N	133194	133194	133751
27069	43299	51	applied	\N	\N	\N	\N	133210	133210	132503
27069	43306	52	applied	\N	\N	\N	\N	133226	133226	132505
27069	43307	53	applied	\N	\N	\N	\N	133228	133228	132512
27069	43311	54	applied	\N	\N	\N	\N	133238	133238	133752
27069	43312	55	applied	\N	\N	\N	\N	133240	133240	132579
27011	43377	2	applied	\N	\N	\N	\N	133407	133407	133408
27014	43384	0	applied	\N	\N	\N	\N	133427	133427	133428
27014	43385	2	applied	\N	\N	\N	\N	133430	133430	133431
27014	43386	3	applied	\N	\N	\N	\N	133432	133432	133433
27018	43389	0	applied	\N	\N	\N	\N	133445	133445	133446
27018	43390	1	applied	\N	\N	\N	\N	133447	133447	133448
27018	43391	2	applied	\N	\N	\N	\N	133449	133449	133450
27021	43389	0	applied	\N	\N	\N	\N	133445	133445	133446
27021	43390	1	applied	\N	\N	\N	\N	133447	133447	133448
27021	43391	2	applied	\N	\N	\N	\N	133449	133449	133450
27025	43398	0	applied	\N	\N	\N	\N	133470	133470	133471
27025	43399	1	applied	\N	\N	\N	\N	133472	133472	133473
27025	43400	2	applied	\N	\N	\N	\N	133474	133474	133475
27027	43172	0	applied	\N	\N	\N	\N	132815	132815	132816
27027	43174	1	applied	\N	\N	\N	\N	132819	132819	132820
27027	43177	2	applied	\N	\N	\N	\N	132829	132829	132830
27027	43178	3	applied	\N	\N	\N	\N	132831	132831	132832
27027	43183	4	applied	\N	\N	\N	\N	132842	132842	132843
27027	43184	5	applied	\N	\N	\N	\N	132844	132844	132845
27027	43189	6	applied	\N	\N	\N	\N	132877	132877	132878
27027	43192	7	applied	\N	\N	\N	\N	132886	132886	132887
27027	43195	8	applied	\N	\N	\N	\N	132894	132894	132895
27027	43198	9	applied	\N	\N	\N	\N	132904	132904	132905
27027	43201	10	applied	\N	\N	\N	\N	132912	132912	132913
27027	43204	11	applied	\N	\N	\N	\N	132918	132918	132919
27027	43205	12	applied	\N	\N	\N	\N	132920	132920	132921
27027	43206	13	applied	\N	\N	\N	\N	132922	132922	132923
27027	43213	14	applied	\N	\N	\N	\N	132942	132942	132943
27027	43214	15	applied	\N	\N	\N	\N	132944	132944	132945
27027	43219	16	applied	\N	\N	\N	\N	132961	132961	132962
27027	43222	17	applied	\N	\N	\N	\N	132967	132967	132968
27027	43225	18	applied	\N	\N	\N	\N	132974	132974	132975
27027	43228	19	applied	\N	\N	\N	\N	132982	132982	132983
27027	43231	20	applied	\N	\N	\N	\N	132990	132990	132991
27027	43232	21	applied	\N	\N	\N	\N	132992	132992	132993
27027	43233	22	applied	\N	\N	\N	\N	132994	132994	132995
27027	43240	23	applied	\N	\N	\N	\N	133011	133011	133012
27027	43241	24	applied	\N	\N	\N	\N	133013	133013	133014
27027	43242	25	applied	\N	\N	\N	\N	133015	133015	133016
27027	43243	26	applied	\N	\N	\N	\N	133017	133017	133018
27027	43253	27	applied	\N	\N	\N	\N	133037	133037	133038
27027	43256	28	applied	\N	\N	\N	\N	133047	133047	133048
27027	43259	29	applied	\N	\N	\N	\N	133054	133054	133055
27027	43262	30	applied	\N	\N	\N	\N	133062	133062	133063
27027	43265	31	applied	\N	\N	\N	\N	133072	133072	133073
27027	43269	32	applied	\N	\N	\N	\N	133087	133087	133088
27027	43272	33	applied	\N	\N	\N	\N	133102	133102	133103
27027	43273	34	applied	\N	\N	\N	\N	133104	133104	133105
27027	43279	35	applied	\N	\N	\N	\N	133119	133119	133120
27027	43280	36	applied	\N	\N	\N	\N	133121	133121	133122
27027	43284	37	applied	\N	\N	\N	\N	133132	133132	133133
27027	43287	38	applied	\N	\N	\N	\N	133138	133138	133139
27027	43290	39	applied	\N	\N	\N	\N	133144	133144	133145
27027	43293	40	applied	\N	\N	\N	\N	133184	133184	133185
27027	43296	41	applied	\N	\N	\N	\N	133192	133192	133193
27027	43301	42	applied	\N	\N	\N	\N	133216	133216	133217
27027	43302	43	applied	\N	\N	\N	\N	133218	133218	133219
27027	43303	44	applied	\N	\N	\N	\N	133220	133220	133221
27027	43308	45	applied	\N	\N	\N	\N	133232	133232	133233
27027	43309	46	applied	\N	\N	\N	\N	133234	133234	133235
27027	43310	47	applied	\N	\N	\N	\N	133236	133236	133237
27027	43317	48	applied	\N	\N	\N	\N	133251	133251	133252
27027	43318	49	applied	\N	\N	\N	\N	133253	133253	133254
27027	43323	50	applied	\N	\N	\N	\N	133264	133264	133265
27027	43326	51	applied	\N	\N	\N	\N	133273	133273	133274
27027	43331	52	applied	\N	\N	\N	\N	133286	133286	133287
27027	43334	53	applied	\N	\N	\N	\N	133294	133294	133295
27027	43335	54	applied	\N	\N	\N	\N	133296	133296	133297
27027	43340	55	applied	\N	\N	\N	\N	133308	133308	133309
27027	43343	56	applied	\N	\N	\N	\N	133314	133314	133315
27027	43346	57	applied	\N	\N	\N	\N	133324	133324	133325
27027	43349	59	applied	\N	\N	\N	\N	133330	133330	133331
27027	43350	60	applied	\N	\N	\N	\N	133332	133332	133333
27027	43351	61	applied	\N	\N	\N	\N	133334	133334	133335
27027	43357	62	applied	\N	\N	\N	\N	133349	133349	133350
27027	43360	63	applied	\N	\N	\N	\N	133359	133359	133360
27027	43362	64	applied	\N	\N	\N	\N	133367	133367	133368
27027	43366	65	applied	\N	\N	\N	\N	133375	133375	133376
27027	43369	66	applied	\N	\N	\N	\N	133385	133385	133386
27027	43370	67	applied	\N	\N	\N	\N	133387	133387	133388
27027	43375	68	applied	\N	\N	\N	\N	133403	133403	133404
27027	43378	69	applied	\N	\N	\N	\N	133414	133414	133415
27027	43379	70	applied	\N	\N	\N	\N	133416	133416	133417
27027	43384	71	applied	\N	\N	\N	\N	133427	133427	133428
27027	43387	72	applied	\N	\N	\N	\N	133439	133439	133440
27027	43389	73	applied	\N	\N	\N	\N	133445	133445	133446
27027	43392	74	applied	\N	\N	\N	\N	133458	133458	133459
27027	43395	75	applied	\N	\N	\N	\N	133464	133464	133465
27027	43398	76	applied	\N	\N	\N	\N	133470	133470	133471
27027	43274	77	failed	Amount_insufficient_to_create_account	\N	\N	\N	133106	133106	\N
27027	43244	78	failed	Amount_insufficient_to_create_account	\N	\N	\N	133019	133019	\N
27027	43266	79	applied	\N	\N	\N	\N	133074	133074	133075
27027	43173	80	applied	\N	\N	\N	\N	132817	132817	132818
27027	43175	81	applied	\N	\N	\N	\N	132821	132821	132822
27027	43179	82	applied	\N	\N	\N	\N	132833	132833	133478
27027	43180	83	applied	\N	\N	\N	\N	132835	132835	133479
27027	43185	84	applied	\N	\N	\N	\N	132846	132846	133480
27027	43188	85	applied	\N	\N	\N	\N	132852	132852	133481
27027	43191	86	applied	\N	\N	\N	\N	132881	132881	132838
27027	43176	87	applied	\N	\N	\N	\N	132823	132823	132840
27027	43181	88	applied	\N	\N	\N	\N	132837	132837	133482
27027	43194	89	applied	\N	\N	\N	\N	132890	132890	132849
27027	43197	90	applied	\N	\N	\N	\N	132898	132898	133483
27027	43200	91	applied	\N	\N	\N	\N	132908	132908	133484
27027	43203	92	applied	\N	\N	\N	\N	132916	132916	133485
27027	43207	93	applied	\N	\N	\N	\N	132924	132924	132880
27027	43208	94	applied	\N	\N	\N	\N	132926	132926	132882
27027	43209	95	applied	\N	\N	\N	\N	132928	132928	133486
27027	43215	96	applied	\N	\N	\N	\N	132946	132946	133487
27027	43217	97	applied	\N	\N	\N	\N	132950	132950	133488
27027	43221	98	applied	\N	\N	\N	\N	132965	132965	132897
27027	43223	99	applied	\N	\N	\N	\N	132969	132969	132899
27027	43226	100	applied	\N	\N	\N	\N	132976	132976	133489
27027	43229	101	applied	\N	\N	\N	\N	132984	132984	133490
27027	43237	102	applied	\N	\N	\N	\N	133002	133002	133491
27027	43238	103	applied	\N	\N	\N	\N	133004	133004	132915
27027	43239	104	applied	\N	\N	\N	\N	133006	133006	132917
27027	43246	105	applied	\N	\N	\N	\N	133022	133022	132925
27027	43247	106	applied	\N	\N	\N	\N	133024	133024	132927
27023	43396	1	applied	\N	\N	\N	\N	133466	133466	133467
27023	43397	2	applied	\N	\N	\N	\N	133468	133468	133469
27032	43404	0	applied	\N	\N	\N	\N	133512	133512	133513
27032	43406	1	applied	\N	\N	\N	\N	133527	133527	133528
27032	43405	2	applied	\N	\N	\N	\N	133523	133523	133529
27041	43189	0	applied	\N	\N	\N	\N	132877	132877	132878
27041	43192	1	applied	\N	\N	\N	\N	132886	132886	132887
27041	43195	2	applied	\N	\N	\N	\N	132894	132894	132895
27041	43198	3	applied	\N	\N	\N	\N	132904	132904	132905
27041	43201	4	applied	\N	\N	\N	\N	132912	132912	132913
27041	43204	5	applied	\N	\N	\N	\N	132918	132918	132919
27041	43205	6	applied	\N	\N	\N	\N	132920	132920	132921
27041	43206	7	applied	\N	\N	\N	\N	132922	132922	132923
27041	43213	8	applied	\N	\N	\N	\N	132942	132942	132943
27041	43214	9	applied	\N	\N	\N	\N	132944	132944	132945
27041	43219	10	applied	\N	\N	\N	\N	132961	132961	132962
27041	43222	11	applied	\N	\N	\N	\N	132967	132967	132968
27041	43225	12	applied	\N	\N	\N	\N	132974	132974	132975
27041	43228	13	applied	\N	\N	\N	\N	132982	132982	132983
27041	43231	14	applied	\N	\N	\N	\N	132990	132990	132991
27041	43232	15	applied	\N	\N	\N	\N	132992	132992	132993
27041	43233	16	applied	\N	\N	\N	\N	132994	132994	132995
27041	43240	17	applied	\N	\N	\N	\N	133011	133011	133012
27041	43241	18	applied	\N	\N	\N	\N	133013	133013	133014
27041	43242	19	applied	\N	\N	\N	\N	133015	133015	133016
27041	43243	20	applied	\N	\N	\N	\N	133017	133017	133018
27041	43253	21	applied	\N	\N	\N	\N	133037	133037	133038
27041	43256	22	applied	\N	\N	\N	\N	133047	133047	133048
27041	43259	23	applied	\N	\N	\N	\N	133054	133054	133055
27041	43262	24	applied	\N	\N	\N	\N	133062	133062	133063
27041	43265	25	applied	\N	\N	\N	\N	133072	133072	133073
27041	43269	26	applied	\N	\N	\N	\N	133087	133087	133088
27041	43272	27	applied	\N	\N	\N	\N	133102	133102	133103
27041	43273	28	applied	\N	\N	\N	\N	133104	133104	133105
27041	43279	29	applied	\N	\N	\N	\N	133119	133119	133120
27041	43280	30	applied	\N	\N	\N	\N	133121	133121	133122
27041	43284	31	applied	\N	\N	\N	\N	133132	133132	133133
27041	43287	32	applied	\N	\N	\N	\N	133138	133138	133139
27041	43290	33	applied	\N	\N	\N	\N	133144	133144	133145
27041	43293	34	applied	\N	\N	\N	\N	133184	133184	133185
27041	43296	35	applied	\N	\N	\N	\N	133192	133192	133193
27041	43301	36	applied	\N	\N	\N	\N	133216	133216	133217
27041	43302	37	applied	\N	\N	\N	\N	133218	133218	133219
27041	43303	39	applied	\N	\N	\N	\N	133220	133220	133221
27041	43308	40	applied	\N	\N	\N	\N	133232	133232	133233
27042	43411	0	applied	\N	\N	\N	\N	133552	133552	133553
27042	43412	1	applied	\N	\N	\N	\N	133554	133554	133555
27042	43413	2	applied	\N	\N	1000000000	\N	133556	133556	133557
27042	43414	3	applied	\N	\N	1000000000	\N	133558	133558	133559
27042	43415	4	applied	\N	\N	1000000000	\N	133560	133560	133561
27044	42780	0	applied	\N	\N	\N	\N	131674	131674	131675
27044	42906	1	applied	\N	\N	\N	\N	132007	132007	132008
27044	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	133106	133106	\N
27044	42781	3	applied	\N	\N	\N	\N	131676	131676	131677
27044	42782	4	applied	\N	\N	\N	\N	131678	131678	131679
27044	43244	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	133019	133019	\N
27044	43266	6	applied	\N	\N	\N	\N	133074	133074	133075
27044	42783	7	applied	\N	\N	\N	\N	131680	131680	131681
27044	42857	8	applied	\N	\N	1000000000	\N	131863	131863	131864
27044	42858	9	applied	\N	\N	1000000000	\N	131865	131865	131866
27044	43410	10	applied	\N	\N	1000000000	\N	133544	133544	133545
27044	43413	11	applied	\N	\N	1000000000	\N	133556	133556	133557
27044	43414	12	applied	\N	\N	1000000000	\N	133558	133558	133559
27044	43415	13	applied	\N	\N	1000000000	\N	133560	133560	133561
27046	43419	0	applied	\N	\N	\N	\N	133584	133584	133585
27046	43420	1	applied	\N	\N	\N	\N	133586	133586	133587
27046	43421	2	applied	\N	\N	\N	\N	133588	133588	133589
27046	43422	3	applied	\N	\N	\N	\N	133590	133590	133591
27046	43423	4	applied	\N	\N	\N	\N	133592	133592	133593
27046	43424	5	applied	\N	\N	\N	\N	133594	133594	133595
27049	43425	0	applied	\N	\N	\N	\N	133598	133598	133599
27049	43426	1	applied	\N	\N	\N	\N	133600	133600	133601
27049	43427	2	applied	\N	\N	\N	\N	133602	133602	133603
27049	43428	3	applied	\N	\N	\N	\N	133604	133604	133605
27049	43429	4	applied	\N	\N	\N	\N	133606	133606	133607
27049	43430	5	applied	\N	\N	\N	\N	133608	133608	133609
27051	43431	0	applied	\N	\N	\N	\N	133614	133614	133615
27051	43432	1	applied	\N	\N	\N	\N	133616	133616	133617
27051	43433	2	applied	\N	\N	\N	\N	133618	133618	133619
27053	43198	0	applied	\N	\N	\N	\N	132904	132904	132905
27053	43201	1	applied	\N	\N	\N	\N	132912	132912	132913
27053	43204	2	applied	\N	\N	\N	\N	132918	132918	132919
27053	43205	3	applied	\N	\N	\N	\N	132920	132920	132921
27053	43206	4	applied	\N	\N	\N	\N	132922	132922	132923
27053	43213	5	applied	\N	\N	\N	\N	132942	132942	132943
27053	43214	6	applied	\N	\N	\N	\N	132944	132944	132945
27053	43219	7	applied	\N	\N	\N	\N	132961	132961	132962
27053	43222	8	applied	\N	\N	\N	\N	132967	132967	132968
27053	43225	9	applied	\N	\N	\N	\N	132974	132974	132975
27053	43228	10	applied	\N	\N	\N	\N	132982	132982	132983
27053	43231	11	applied	\N	\N	\N	\N	132990	132990	132991
27053	43232	12	applied	\N	\N	\N	\N	132992	132992	132993
27053	43233	13	applied	\N	\N	\N	\N	132994	132994	132995
27053	43240	14	applied	\N	\N	\N	\N	133011	133011	133012
27053	43241	15	applied	\N	\N	\N	\N	133013	133013	133014
27053	43242	16	applied	\N	\N	\N	\N	133015	133015	133016
27058	43446	0	applied	\N	\N	\N	\N	133658	133658	133659
27058	43447	1	applied	\N	\N	\N	\N	133660	133660	133661
27058	43448	2	applied	\N	\N	\N	\N	133662	133662	133663
27061	43452	0	applied	\N	\N	\N	\N	133675	133675	133676
27061	43453	1	applied	\N	\N	\N	\N	133677	133677	133678
27061	43454	2	applied	\N	\N	\N	\N	133679	133679	133680
27061	43455	3	applied	\N	\N	\N	\N	133681	133681	133682
27061	43456	4	applied	\N	\N	\N	\N	133683	133683	133684
27061	43457	5	applied	\N	\N	\N	\N	133685	133685	133686
27063	43466	0	applied	\N	\N	\N	\N	133706	133706	133707
27063	43467	1	applied	\N	\N	\N	\N	133708	133708	133709
27063	43468	2	applied	\N	\N	\N	\N	133710	133710	133711
27068	43469	0	applied	\N	\N	\N	\N	133714	133714	133715
27068	43470	2	applied	\N	\N	\N	\N	133720	133720	133721
27068	43471	3	applied	\N	\N	\N	\N	133722	133722	133723
27068	43472	4	applied	\N	\N	\N	\N	133724	133724	133725
27068	43473	5	applied	\N	\N	\N	\N	133726	133726	133727
27068	43474	6	applied	\N	\N	\N	\N	133728	133728	133729
27071	43475	0	applied	\N	\N	\N	\N	133791	133791	133792
27071	43476	1	applied	\N	\N	\N	\N	133793	133793	133794
27071	43477	2	applied	\N	\N	\N	\N	133795	133795	133796
27071	43478	3	applied	\N	\N	\N	\N	133797	133797	133798
27027	43248	107	applied	\N	\N	\N	\N	133026	133026	132929
27027	43249	108	applied	\N	\N	\N	\N	133028	133028	133492
27027	43254	109	applied	\N	\N	\N	\N	133039	133039	133493
27027	43257	110	applied	\N	\N	\N	\N	133049	133049	132933
27027	43261	111	applied	\N	\N	\N	\N	133058	133058	133494
27027	43263	112	applied	\N	\N	\N	\N	133064	133064	133495
27027	43268	113	applied	\N	\N	\N	\N	133078	133078	133496
27027	43271	114	applied	\N	\N	\N	\N	133091	133091	132949
27027	43276	115	applied	\N	\N	\N	\N	133109	133109	132951
27027	43278	116	applied	\N	\N	\N	\N	133113	133113	133497
27027	43281	117	applied	\N	\N	\N	\N	133123	133123	133498
27027	43283	118	applied	\N	\N	\N	\N	133127	133127	132964
27027	43286	119	applied	\N	\N	\N	\N	133136	133136	132966
27027	43289	120	applied	\N	\N	\N	\N	133142	133142	132970
27027	43292	121	applied	\N	\N	\N	\N	133148	133148	133499
27027	43294	122	applied	\N	\N	\N	\N	133186	133186	133500
27027	43297	123	applied	\N	\N	\N	\N	133194	133194	133501
27027	43299	124	applied	\N	\N	\N	\N	133210	133210	132979
27027	43306	125	applied	\N	\N	\N	\N	133226	133226	132985
27029	43398	0	applied	\N	\N	\N	\N	133470	133470	133471
27029	43401	1	applied	\N	\N	\N	\N	133504	133504	133505
27029	43402	2	applied	\N	\N	\N	\N	133506	133506	133507
27029	43403	3	applied	\N	\N	\N	\N	133508	133508	133509
27031	43404	0	applied	\N	\N	\N	\N	133512	133512	133513
27031	43406	1	applied	\N	\N	\N	\N	133527	133527	133528
27031	43405	2	applied	\N	\N	\N	\N	133523	133523	133529
27035	43407	0	applied	\N	\N	\N	\N	133538	133538	133539
27035	43408	1	applied	\N	\N	\N	\N	133540	133540	133541
27035	43409	2	applied	\N	\N	\N	\N	133542	133542	133543
27035	43410	3	applied	\N	\N	1000000000	\N	133544	133544	133545
27037	43407	0	applied	\N	\N	\N	\N	133538	133538	133539
27037	43409	1	applied	\N	\N	\N	\N	133542	133542	133550
27037	43410	2	applied	\N	\N	1000000000	\N	133544	133544	133545
27045	43416	0	applied	\N	\N	\N	\N	133577	133577	133578
27045	43417	1	applied	\N	\N	\N	\N	133579	133579	133580
27045	43418	2	applied	\N	\N	\N	\N	133581	133581	133582
27048	43425	0	applied	\N	\N	\N	\N	133598	133598	133599
27048	43426	1	applied	\N	\N	\N	\N	133600	133600	133601
27048	43427	2	applied	\N	\N	\N	\N	133602	133602	133603
27048	43428	3	applied	\N	\N	\N	\N	133604	133604	133605
27048	43429	4	applied	\N	\N	\N	\N	133606	133606	133607
27048	43430	5	applied	\N	\N	\N	\N	133608	133608	133609
27050	43431	0	applied	\N	\N	\N	\N	133614	133614	133615
27050	43432	1	applied	\N	\N	\N	\N	133616	133616	133617
27050	43433	2	applied	\N	\N	\N	\N	133618	133618	133619
27060	43449	0	applied	\N	\N	\N	\N	133668	133668	133669
27060	43450	1	applied	\N	\N	\N	\N	133670	133670	133671
27060	43451	2	applied	\N	\N	\N	\N	133672	133672	133673
27065	43469	0	applied	\N	\N	\N	\N	133714	133714	133715
27066	43469	0	applied	\N	\N	\N	\N	133714	133714	133715
27066	43470	2	applied	\N	\N	\N	\N	133720	133720	133721
27066	43471	3	applied	\N	\N	\N	\N	133722	133722	133723
27066	43472	4	applied	\N	\N	\N	\N	133724	133724	133725
27066	43473	5	applied	\N	\N	\N	\N	133726	133726	133727
27066	43474	6	applied	\N	\N	\N	\N	133728	133728	133729
27070	43475	0	applied	\N	\N	\N	\N	133791	133791	133792
27070	43476	1	applied	\N	\N	\N	\N	133793	133793	133794
27070	43477	2	applied	\N	\N	\N	\N	133795	133795	133796
27070	43478	3	applied	\N	\N	\N	\N	133797	133797	133798
27070	43479	4	applied	\N	\N	\N	\N	133799	133799	133800
27070	43480	5	applied	\N	\N	\N	\N	133801	133801	133802
27072	43481	0	applied	\N	\N	\N	\N	133805	133805	133806
27072	43482	1	applied	\N	\N	\N	\N	133807	133807	133808
27075	43484	0	applied	\N	\N	\N	\N	133814	133814	133815
27075	43485	1	applied	\N	\N	\N	\N	133816	133816	133817
27075	43486	2	applied	\N	\N	\N	\N	133818	133818	133819
27077	43492	0	applied	\N	\N	\N	\N	133833	133833	133834
27077	43493	1	applied	\N	\N	\N	\N	133835	133835	133836
27077	43494	2	applied	\N	\N	\N	\N	133837	133837	133838
27086	43514	0	applied	\N	\N	\N	\N	133886	133886	133887
27086	43515	1	applied	\N	\N	\N	\N	133888	133888	133889
27086	43516	2	applied	\N	\N	\N	\N	133890	133890	133891
27086	43517	3	applied	\N	\N	\N	\N	133892	133892	133893
27086	43518	4	applied	\N	\N	\N	\N	133894	133894	133895
27086	43519	5	applied	\N	\N	\N	\N	133896	133896	133897
27089	43520	0	applied	\N	\N	\N	\N	133902	133902	133903
27089	43521	1	applied	\N	\N	\N	\N	133904	133904	133905
27089	43522	2	applied	\N	\N	\N	\N	133906	133906	133907
27095	43535	0	applied	\N	\N	\N	\N	133940	133940	133941
27095	43536	1	applied	\N	\N	\N	\N	133942	133942	133943
27095	43537	2	applied	\N	\N	\N	\N	133944	133944	133945
27102	43544	0	applied	\N	\N	\N	\N	133964	133964	133965
27102	43545	1	applied	\N	\N	\N	\N	133966	133966	133967
27102	43546	2	applied	\N	\N	\N	\N	133968	133968	133969
27102	43547	3	applied	\N	\N	\N	\N	133970	133970	133971
27102	43548	4	applied	\N	\N	\N	\N	133972	133972	133973
27102	43549	5	applied	\N	\N	\N	\N	133974	133974	133975
27107	43556	0	applied	\N	\N	\N	\N	133993	133993	133994
27107	43557	1	applied	\N	\N	\N	\N	133995	133995	133996
27107	43558	2	applied	\N	\N	\N	\N	133997	133997	133998
27111	43565	0	applied	\N	\N	\N	\N	134059	134059	134060
27111	43566	1	applied	\N	\N	\N	\N	134061	134061	134062
27113	43567	0	applied	\N	\N	\N	\N	134067	134067	134068
27113	43568	1	applied	\N	\N	\N	\N	134069	134069	134070
27113	43569	2	applied	\N	\N	\N	\N	134071	134071	134072
27118	43576	0	applied	\N	\N	\N	\N	134090	134090	134091
27118	43577	1	applied	\N	\N	\N	\N	134092	134092	134093
27118	43578	2	applied	\N	\N	\N	\N	134094	134094	134095
27126	43599	0	applied	\N	\N	\N	\N	134147	134147	134148
27126	43600	1	applied	\N	\N	\N	\N	134149	134149	134150
27126	43601	2	applied	\N	\N	\N	\N	134151	134151	134152
27129	43605	0	applied	\N	\N	\N	\N	134163	134163	134164
27129	43606	1	applied	\N	\N	\N	\N	134165	134165	134166
27129	43607	2	applied	\N	\N	\N	\N	134167	134167	134168
27136	43620	0	applied	\N	\N	\N	\N	134203	134203	134204
27136	43621	1	applied	\N	\N	\N	\N	134205	134205	134206
27136	43622	2	applied	\N	\N	\N	\N	134207	134207	134208
27148	43637	0	applied	\N	\N	\N	\N	134248	134248	134249
27148	43638	1	applied	\N	\N	\N	\N	134250	134250	134251
27148	43639	2	applied	\N	\N	\N	\N	134252	134252	134253
27157	43655	0	applied	\N	\N	\N	\N	134312	134312	134313
27157	43656	1	applied	\N	\N	\N	\N	134314	134314	134315
27157	43657	2	applied	\N	\N	\N	\N	134316	134316	134317
27157	43658	3	applied	\N	\N	\N	\N	134318	134318	134319
27157	43659	4	applied	\N	\N	\N	\N	134320	134320	134321
27157	43660	5	applied	\N	\N	\N	\N	134322	134322	134323
27160	43664	0	applied	\N	\N	\N	\N	134334	134334	134335
27160	43665	1	applied	\N	\N	\N	\N	134336	134336	134337
27160	43666	2	applied	\N	\N	\N	\N	134338	134338	134339
27069	43313	56	applied	\N	\N	\N	\N	133242	133242	133753
27069	43319	57	applied	\N	\N	\N	\N	133255	133255	132523
27069	43320	58	applied	\N	\N	\N	\N	133257	133257	132581
27069	43325	59	applied	\N	\N	\N	\N	133268	133268	132531
27069	43327	60	applied	\N	\N	\N	\N	133275	133275	132533
27069	43329	61	applied	\N	\N	\N	\N	133280	133280	132583
27069	43332	62	applied	\N	\N	\N	\N	133288	133288	133754
27069	43338	63	applied	\N	\N	\N	\N	133302	133302	133755
27069	43339	64	applied	\N	\N	\N	\N	133304	133304	133756
27069	43341	65	applied	\N	\N	\N	\N	133310	133310	132597
27069	43345	66	applied	\N	\N	\N	\N	133318	133318	133757
27069	43347	67	applied	\N	\N	\N	\N	133326	133326	133758
27069	43354	68	applied	\N	\N	\N	\N	133340	133340	132601
27069	43355	69	applied	\N	\N	\N	\N	133342	133342	133759
27069	43356	70	applied	\N	\N	\N	\N	133344	133344	132660
27069	43359	71	applied	\N	\N	\N	\N	133353	133353	133760
27069	43363	72	applied	\N	\N	\N	\N	133369	133369	133761
27069	43364	73	applied	\N	\N	\N	\N	133371	133371	132613
27069	43368	74	applied	\N	\N	\N	\N	133379	133379	132619
27069	43371	75	applied	\N	\N	\N	\N	133389	133389	133762
27069	43372	76	applied	\N	\N	\N	\N	133391	133391	132623
27069	43377	77	applied	\N	\N	\N	\N	133407	133407	133763
27069	43380	78	applied	\N	\N	\N	\N	133418	133418	133764
27069	43381	79	applied	\N	\N	\N	\N	133420	133420	132667
27069	43385	80	applied	\N	\N	\N	\N	133430	133430	132642
27069	43390	81	applied	\N	\N	\N	\N	133447	133447	132644
27069	43394	82	applied	\N	\N	\N	\N	133462	133462	132669
27069	43397	83	applied	\N	\N	\N	\N	133468	133468	132652
27069	43400	84	applied	\N	\N	\N	\N	133474	133474	132654
27069	43403	85	applied	\N	\N	\N	\N	133508	133508	132671
27069	43405	86	applied	\N	\N	\N	\N	133523	133523	133765
27069	43409	87	applied	\N	\N	\N	\N	133542	133542	132683
27069	43412	88	applied	\N	\N	\N	\N	133554	133554	133766
27069	43417	89	applied	\N	\N	\N	\N	133579	133579	133767
27069	43421	90	applied	\N	\N	\N	\N	133588	133588	133768
27069	43424	91	applied	\N	\N	\N	\N	133594	133594	133769
27069	43429	92	applied	\N	\N	\N	\N	133606	133606	132856
27069	42901	93	applied	\N	\N	\N	\N	131992	131992	132702
27069	42903	94	applied	\N	\N	\N	\N	131999	131999	132704
27069	42909	95	applied	\N	\N	\N	\N	132013	132013	132857
27069	42916	96	applied	\N	\N	\N	\N	132029	132029	133770
27069	42917	97	applied	\N	\N	\N	\N	132031	132031	132720
27069	42918	98	applied	\N	\N	\N	\N	132033	132033	133771
27069	42921	99	applied	\N	\N	\N	\N	132041	132041	133772
27069	42925	100	applied	\N	\N	\N	\N	132049	132049	132860
27069	42931	102	applied	\N	\N	\N	\N	132067	132067	133774
27069	42932	103	applied	\N	\N	\N	\N	132069	132069	132741
27069	42938	104	applied	\N	\N	\N	\N	132085	132085	133775
27069	42939	105	applied	\N	\N	\N	\N	132087	132087	133776
27069	42940	106	applied	\N	\N	\N	\N	132089	132089	133777
27069	42941	107	applied	\N	\N	\N	\N	132091	132091	133778
27069	42947	108	applied	\N	\N	\N	\N	132106	132106	132761
27069	42951	109	applied	\N	\N	\N	\N	132118	132118	132763
27069	42955	110	applied	\N	\N	\N	\N	132128	132128	132767
27069	42959	111	applied	\N	\N	\N	\N	132140	132140	133779
27069	42962	112	applied	\N	\N	\N	\N	132150	132150	133780
27069	42968	113	applied	\N	\N	\N	\N	132169	132169	133781
27069	42972	114	applied	\N	\N	\N	\N	132179	132179	132781
27069	42974	115	applied	\N	\N	\N	\N	132186	132186	133782
27069	42980	116	applied	\N	\N	\N	\N	132203	132203	133783
27069	42981	117	applied	\N	\N	\N	\N	132205	132205	133784
27069	42982	118	applied	\N	\N	\N	\N	132207	132207	133785
27069	42988	119	applied	\N	\N	\N	\N	132221	132221	132810
27069	42991	120	applied	\N	\N	\N	\N	132228	132228	133786
27069	42993	121	applied	\N	\N	\N	\N	132234	132234	133478
27069	42998	122	applied	\N	\N	\N	\N	132247	132247	132834
27069	43000	123	applied	\N	\N	\N	\N	132253	132253	133481
27069	43004	124	applied	\N	\N	\N	\N	132264	132264	132872
27069	43011	125	applied	\N	\N	\N	\N	132280	132280	133787
27074	43484	0	applied	\N	\N	\N	\N	133814	133814	133815
27074	43485	1	applied	\N	\N	\N	\N	133816	133816	133817
27074	43486	2	applied	\N	\N	\N	\N	133818	133818	133819
27076	43487	0	applied	\N	\N	\N	\N	133822	133822	133823
27076	43488	1	applied	\N	\N	\N	\N	133824	133824	133825
27076	43489	2	applied	\N	\N	\N	\N	133826	133826	133827
27076	43490	3	applied	\N	\N	\N	\N	133828	133828	133829
27076	43491	4	applied	\N	\N	\N	\N	133830	133830	133831
27079	43495	0	applied	\N	\N	\N	\N	133841	133841	133842
27079	43496	1	applied	\N	\N	\N	\N	133843	133843	133844
27079	43497	2	applied	\N	\N	\N	\N	133845	133845	133846
27081	43498	0	applied	\N	\N	\N	\N	133850	133850	133851
27081	43499	1	applied	\N	\N	\N	\N	133852	133852	133853
27081	43500	2	applied	\N	\N	\N	\N	133854	133854	133855
27085	43514	0	applied	\N	\N	\N	\N	133886	133886	133887
27085	43515	1	applied	\N	\N	\N	\N	133888	133888	133889
27085	43516	2	applied	\N	\N	\N	\N	133890	133890	133891
27085	43517	3	applied	\N	\N	\N	\N	133892	133892	133893
27085	43518	4	applied	\N	\N	\N	\N	133894	133894	133895
27085	43519	5	applied	\N	\N	\N	\N	133896	133896	133897
27091	43523	0	applied	\N	\N	\N	\N	133911	133911	133912
27091	43524	1	applied	\N	\N	\N	\N	133913	133913	133914
27091	43525	2	applied	\N	\N	\N	\N	133915	133915	133916
27094	43535	0	applied	\N	\N	\N	\N	133940	133940	133941
27094	43536	1	applied	\N	\N	\N	\N	133942	133942	133943
27094	43537	2	applied	\N	\N	\N	\N	133944	133944	133945
27101	43544	0	applied	\N	\N	\N	\N	133964	133964	133965
27101	43545	1	applied	\N	\N	\N	\N	133966	133966	133967
27101	43546	2	applied	\N	\N	\N	\N	133968	133968	133969
27101	43547	3	applied	\N	\N	\N	\N	133970	133970	133971
27101	43548	4	applied	\N	\N	\N	\N	133972	133972	133973
27101	43549	5	applied	\N	\N	\N	\N	133974	133974	133975
27104	43556	0	applied	\N	\N	\N	\N	133993	133993	133994
27104	43557	1	applied	\N	\N	\N	\N	133995	133995	133996
27104	43558	2	applied	\N	\N	\N	\N	133997	133997	133998
27106	43556	0	applied	\N	\N	\N	\N	133993	133993	133994
27106	43557	1	applied	\N	\N	\N	\N	133995	133995	133996
27106	43558	2	applied	\N	\N	\N	\N	133997	133997	133998
27108	43559	0	applied	\N	\N	\N	\N	134005	134005	134006
27108	43560	1	applied	\N	\N	\N	\N	134007	134007	134008
27108	43561	2	applied	\N	\N	\N	\N	134009	134009	134010
27115	43567	0	applied	\N	\N	\N	\N	134067	134067	134068
27115	43570	1	applied	\N	\N	\N	\N	134075	134075	134076
27115	43571	2	applied	\N	\N	\N	\N	134077	134077	134078
27115	43572	3	applied	\N	\N	\N	\N	134079	134079	134080
27123	43588	0	applied	\N	\N	\N	\N	134121	134121	134122
27123	43589	1	applied	\N	\N	\N	\N	134123	134123	134124
27123	43590	2	applied	\N	\N	\N	\N	134125	134125	134126
27123	43591	3	applied	\N	\N	\N	\N	134127	134127	134128
27123	43592	4	applied	\N	\N	\N	\N	134129	134129	134130
27128	43605	0	applied	\N	\N	\N	\N	134163	134163	134164
27071	43479	4	applied	\N	\N	\N	\N	133799	133799	133800
27071	43480	5	applied	\N	\N	\N	\N	133801	133801	133802
27073	43481	0	applied	\N	\N	\N	\N	133805	133805	133806
27073	43482	1	applied	\N	\N	\N	\N	133807	133807	133808
27073	43483	2	applied	\N	\N	\N	\N	133812	133812	133813
27078	43492	0	applied	\N	\N	\N	\N	133833	133833	133834
27078	43493	1	applied	\N	\N	\N	\N	133835	133835	133836
27078	43494	2	applied	\N	\N	\N	\N	133837	133837	133838
27080	43293	0	applied	\N	\N	\N	\N	133184	133184	133185
27080	43296	1	applied	\N	\N	\N	\N	133192	133192	133193
27080	43301	2	applied	\N	\N	\N	\N	133216	133216	133217
27080	43302	3	applied	\N	\N	\N	\N	133218	133218	133219
27080	43303	4	applied	\N	\N	\N	\N	133220	133220	133221
27080	43308	5	applied	\N	\N	\N	\N	133232	133232	133233
27080	43309	6	applied	\N	\N	\N	\N	133234	133234	133235
27080	43310	7	applied	\N	\N	\N	\N	133236	133236	133237
27080	43317	9	applied	\N	\N	\N	\N	133251	133251	133252
27080	43318	10	applied	\N	\N	\N	\N	133253	133253	133254
27080	43323	11	applied	\N	\N	\N	\N	133264	133264	133265
27080	43326	12	applied	\N	\N	\N	\N	133273	133273	133274
27080	43331	13	applied	\N	\N	\N	\N	133286	133286	133287
27080	43334	14	applied	\N	\N	\N	\N	133294	133294	133295
27080	43335	15	applied	\N	\N	\N	\N	133296	133296	133297
27080	43340	16	applied	\N	\N	\N	\N	133308	133308	133309
27080	43343	17	applied	\N	\N	\N	\N	133314	133314	133315
27080	43346	18	applied	\N	\N	\N	\N	133324	133324	133325
27080	43349	19	applied	\N	\N	\N	\N	133330	133330	133331
27080	43350	20	applied	\N	\N	\N	\N	133332	133332	133333
27080	43351	21	applied	\N	\N	\N	\N	133334	133334	133335
27080	43357	22	applied	\N	\N	\N	\N	133349	133349	133350
27080	43360	23	applied	\N	\N	\N	\N	133359	133359	133360
27080	43362	24	applied	\N	\N	\N	\N	133367	133367	133368
27080	43366	25	applied	\N	\N	\N	\N	133375	133375	133376
27080	43369	26	applied	\N	\N	\N	\N	133385	133385	133386
27080	43370	27	applied	\N	\N	\N	\N	133387	133387	133388
27080	43375	28	applied	\N	\N	\N	\N	133403	133403	133404
27080	43378	29	applied	\N	\N	\N	\N	133414	133414	133415
27080	43379	30	applied	\N	\N	\N	\N	133416	133416	133417
27080	43384	31	applied	\N	\N	\N	\N	133427	133427	133428
27080	43387	32	applied	\N	\N	\N	\N	133439	133439	133440
27080	43389	33	applied	\N	\N	\N	\N	133445	133445	133446
27080	43392	34	applied	\N	\N	\N	\N	133458	133458	133459
27080	43395	35	applied	\N	\N	\N	\N	133464	133464	133465
27080	43398	36	applied	\N	\N	\N	\N	133470	133470	133471
27080	43401	37	applied	\N	\N	\N	\N	133504	133504	133505
27080	43404	38	applied	\N	\N	\N	\N	133512	133512	133513
27080	43407	39	applied	\N	\N	\N	\N	133538	133538	133539
27080	43411	40	applied	\N	\N	\N	\N	133552	133552	133553
27080	43416	41	applied	\N	\N	\N	\N	133577	133577	133578
27080	43419	42	applied	\N	\N	\N	\N	133584	133584	133585
27080	43420	43	applied	\N	\N	\N	\N	133586	133586	133587
27080	43425	44	applied	\N	\N	\N	\N	133598	133598	133599
27082	43501	0	applied	\N	\N	\N	\N	133857	133857	133858
27082	43502	1	applied	\N	\N	\N	\N	133859	133859	133860
27082	43503	2	applied	\N	\N	\N	\N	133861	133861	133862
27083	43504	0	applied	\N	\N	\N	\N	133865	133865	133866
27083	43505	1	applied	\N	\N	\N	\N	133867	133867	133868
27083	43506	2	applied	\N	\N	\N	\N	133869	133869	133870
27083	43507	3	applied	\N	\N	\N	\N	133871	133871	133872
27083	43508	4	applied	\N	\N	\N	\N	133873	133873	133874
27083	43509	5	applied	\N	\N	\N	\N	133875	133875	133876
27083	43510	6	applied	\N	\N	\N	\N	133877	133877	133878
27083	43511	7	applied	\N	\N	\N	\N	133879	133879	133880
27083	43512	8	applied	\N	\N	\N	\N	133881	133881	133882
27083	43513	9	applied	\N	\N	\N	\N	133883	133883	133884
27087	43514	0	applied	\N	\N	\N	\N	133886	133886	133887
27087	43515	1	applied	\N	\N	\N	\N	133888	133888	133889
27087	43516	2	applied	\N	\N	\N	\N	133890	133890	133891
27087	43517	3	applied	\N	\N	\N	\N	133892	133892	133893
27087	43518	4	applied	\N	\N	\N	\N	133894	133894	133895
27087	43519	5	applied	\N	\N	\N	\N	133896	133896	133897
27090	43520	0	applied	\N	\N	\N	\N	133902	133902	133903
27090	43521	1	applied	\N	\N	\N	\N	133904	133904	133905
27090	43522	2	applied	\N	\N	\N	\N	133906	133906	133907
27092	43526	0	applied	\N	\N	\N	\N	133919	133919	133920
27092	43527	1	applied	\N	\N	\N	\N	133921	133921	133922
27092	43528	2	applied	\N	\N	\N	\N	133923	133923	133924
27093	43529	0	applied	\N	\N	\N	\N	133926	133926	133927
27093	43530	1	applied	\N	\N	\N	\N	133928	133928	133929
27093	43531	2	applied	\N	\N	\N	\N	133930	133930	133931
27093	43532	3	applied	\N	\N	\N	\N	133932	133932	133933
27093	43533	4	applied	\N	\N	\N	\N	133934	133934	133935
27093	43534	5	applied	\N	\N	\N	\N	133936	133936	133937
27096	43535	0	applied	\N	\N	\N	\N	133940	133940	133941
27096	43536	1	applied	\N	\N	\N	\N	133942	133942	133943
27096	43537	2	applied	\N	\N	\N	\N	133944	133944	133945
27109	43562	0	applied	\N	\N	\N	\N	134013	134013	134014
27109	43563	1	applied	\N	\N	\N	\N	134015	134015	134016
27109	43564	2	applied	\N	\N	\N	\N	134017	134017	134018
27114	43568	0	applied	\N	\N	\N	\N	134069	134069	134070
27114	43569	1	applied	\N	\N	\N	\N	134071	134071	134072
27116	43567	0	applied	\N	\N	\N	\N	134067	134067	134068
27116	43571	1	applied	\N	\N	\N	\N	134077	134077	134078
27116	43572	2	applied	\N	\N	\N	\N	134079	134079	134080
27121	43582	0	applied	\N	\N	\N	\N	134108	134108	134109
27121	43583	1	applied	\N	\N	\N	\N	134110	134110	134111
27121	43584	2	applied	\N	\N	\N	\N	134112	134112	134113
27121	43585	3	applied	\N	\N	\N	\N	134114	134114	134115
27121	43586	4	applied	\N	\N	\N	\N	134116	134116	134117
27121	43587	5	applied	\N	\N	\N	\N	134118	134118	134119
27124	43593	0	applied	\N	\N	\N	\N	134134	134134	134135
27124	43594	1	applied	\N	\N	\N	\N	134136	134136	134137
27124	43595	2	applied	\N	\N	\N	\N	134138	134138	134139
27132	43617	0	applied	\N	\N	\N	\N	134192	134192	134193
27132	43618	1	applied	\N	\N	\N	\N	134194	134194	134195
27132	43619	2	applied	\N	\N	\N	\N	134196	134196	134197
27137	43620	0	applied	\N	\N	\N	\N	134203	134203	134204
27137	43621	1	applied	\N	\N	\N	\N	134205	134205	134206
27137	43622	2	applied	\N	\N	\N	\N	134207	134207	134208
27141	43626	0	applied	\N	\N	\N	\N	134222	134222	134223
27141	43627	1	applied	\N	\N	\N	\N	134224	134224	134225
27141	43628	2	applied	\N	\N	\N	\N	134226	134226	134227
27143	43626	0	applied	\N	\N	\N	\N	134222	134222	134223
27143	43627	1	applied	\N	\N	\N	\N	134224	134224	134225
27143	43628	2	applied	\N	\N	\N	\N	134226	134226	134227
27151	43644	0	applied	\N	\N	\N	\N	134274	134274	134275
27151	43645	1	applied	\N	\N	\N	\N	134276	134276	134277
27154	43646	0	applied	\N	\N	\N	\N	134280	134280	134281
27154	43647	1	applied	\N	\N	\N	\N	134283	134283	134284
27154	43648	2	applied	\N	\N	\N	\N	134285	134285	134286
27084	43515	1	applied	\N	\N	\N	\N	133888	133888	133889
27084	43516	2	applied	\N	\N	\N	\N	133890	133890	133891
27084	43517	3	applied	\N	\N	\N	\N	133892	133892	133893
27084	43518	4	applied	\N	\N	\N	\N	133894	133894	133895
27084	43519	5	applied	\N	\N	\N	\N	133896	133896	133897
27088	43514	0	applied	\N	\N	\N	\N	133886	133886	133887
27088	43515	1	applied	\N	\N	\N	\N	133888	133888	133889
27088	43516	2	applied	\N	\N	\N	\N	133890	133890	133891
27088	43517	3	applied	\N	\N	\N	\N	133892	133892	133893
27088	43518	4	applied	\N	\N	\N	\N	133894	133894	133895
27088	43519	5	applied	\N	\N	\N	\N	133896	133896	133897
27100	43538	0	applied	\N	\N	\N	\N	133950	133950	133951
27100	43539	1	applied	\N	\N	\N	\N	133952	133952	133953
27100	43540	2	applied	\N	\N	\N	\N	133954	133954	133955
27100	43541	3	applied	\N	\N	\N	\N	133956	133956	133957
27100	43542	4	applied	\N	\N	\N	\N	133958	133958	133959
27100	43543	5	applied	\N	\N	\N	\N	133960	133960	133961
27103	43550	0	applied	\N	\N	\N	\N	133980	133980	133981
27103	43551	1	applied	\N	\N	\N	\N	133982	133982	133983
27103	43552	2	applied	\N	\N	\N	\N	133984	133984	133985
27103	43553	3	applied	\N	\N	\N	\N	133986	133986	133987
27103	43554	4	applied	\N	\N	\N	\N	133988	133988	133989
27103	43555	5	applied	\N	\N	\N	\N	133990	133990	133991
27110	43401	0	applied	\N	\N	\N	\N	133504	133504	133505
27110	43404	1	applied	\N	\N	\N	\N	133512	133512	133513
27110	43407	2	applied	\N	\N	\N	\N	133538	133538	133539
27110	43411	3	applied	\N	\N	\N	\N	133552	133552	133553
27110	43416	4	applied	\N	\N	\N	\N	133577	133577	133578
27110	43419	5	applied	\N	\N	\N	\N	133584	133584	133585
27110	43420	6	applied	\N	\N	\N	\N	133586	133586	133587
27110	43425	7	applied	\N	\N	\N	\N	133598	133598	133599
27110	43426	8	applied	\N	\N	\N	\N	133600	133600	133601
27110	43431	9	applied	\N	\N	\N	\N	133614	133614	133615
27110	43434	10	applied	\N	\N	\N	\N	133628	133628	133629
27110	43435	11	applied	\N	\N	\N	\N	133630	133630	133631
27110	43440	12	applied	\N	\N	\N	\N	133644	133644	133645
27110	43441	13	applied	\N	\N	\N	\N	133646	133646	133647
27110	43446	14	applied	\N	\N	\N	\N	133658	133658	133659
27110	43449	15	applied	\N	\N	\N	\N	133668	133668	133669
27110	43452	16	applied	\N	\N	\N	\N	133675	133675	133676
27110	43453	17	applied	\N	\N	\N	\N	133677	133677	133678
27110	43458	18	applied	\N	\N	\N	\N	133689	133689	133690
27110	43466	19	applied	\N	\N	\N	\N	133706	133706	133707
27110	43469	20	applied	\N	\N	\N	\N	133714	133714	133715
27110	43470	21	applied	\N	\N	\N	\N	133720	133720	133721
27110	43475	22	applied	\N	\N	\N	\N	133791	133791	133792
27110	43476	23	applied	\N	\N	\N	\N	133793	133793	133794
27110	43481	24	applied	\N	\N	\N	\N	133805	133805	133806
27110	43484	25	applied	\N	\N	\N	\N	133814	133814	133815
27110	43487	26	applied	\N	\N	\N	\N	133822	133822	133823
27110	43488	27	applied	\N	\N	\N	\N	133824	133824	133825
27110	43492	28	applied	\N	\N	\N	\N	133833	133833	133834
27110	43495	29	applied	\N	\N	\N	\N	133841	133841	133842
27110	43498	30	applied	\N	\N	\N	\N	133850	133850	133851
27110	43501	31	applied	\N	\N	\N	\N	133857	133857	133858
27110	43504	32	applied	\N	\N	\N	\N	133865	133865	133866
27110	43505	33	applied	\N	\N	\N	\N	133867	133867	133868
27110	43506	34	applied	\N	\N	\N	\N	133869	133869	133870
27110	43514	35	applied	\N	\N	\N	\N	133886	133886	133887
27110	43515	36	applied	\N	\N	\N	\N	133888	133888	133889
27110	43520	37	applied	\N	\N	\N	\N	133902	133902	133903
27110	43523	38	applied	\N	\N	\N	\N	133911	133911	133912
27110	43526	39	applied	\N	\N	\N	\N	133919	133919	133920
27110	43529	40	applied	\N	\N	\N	\N	133926	133926	133927
27110	43530	41	applied	\N	\N	\N	\N	133928	133928	133929
27110	43535	42	applied	\N	\N	\N	\N	133940	133940	133941
27110	43538	43	applied	\N	\N	\N	\N	133950	133950	133951
27110	43539	44	applied	\N	\N	\N	\N	133952	133952	133953
27110	43544	45	applied	\N	\N	\N	\N	133964	133964	133965
27110	43545	46	applied	\N	\N	\N	\N	133966	133966	133967
27110	43550	47	applied	\N	\N	\N	\N	133980	133980	133981
27110	43551	48	applied	\N	\N	\N	\N	133982	133982	133983
27110	43556	49	applied	\N	\N	\N	\N	133993	133993	133994
27110	43559	50	applied	\N	\N	\N	\N	134005	134005	134006
27110	43307	51	applied	\N	\N	\N	\N	133228	133228	134021
27110	43311	52	applied	\N	\N	\N	\N	133238	133238	134022
27110	43510	53	applied	\N	\N	\N	\N	133877	133877	133878
27110	43312	54	applied	\N	\N	\N	\N	133240	133240	132997
27110	43313	55	applied	\N	\N	\N	\N	133242	133242	134023
27110	43319	56	applied	\N	\N	\N	\N	133255	133255	134024
27110	43320	57	applied	\N	\N	\N	\N	133257	133257	133001
27110	43325	59	applied	\N	\N	\N	\N	133268	133268	133003
27110	43327	60	applied	\N	\N	\N	\N	133275	133275	133005
27110	43329	61	applied	\N	\N	\N	\N	133280	133280	133007
27110	43332	62	applied	\N	\N	\N	\N	133288	133288	134026
27110	43338	63	applied	\N	\N	\N	\N	133302	133302	134027
27110	43339	64	applied	\N	\N	\N	\N	133304	133304	134028
27110	43341	65	applied	\N	\N	\N	\N	133310	133310	134029
27110	43345	66	applied	\N	\N	\N	\N	133318	133318	134030
27110	43347	67	applied	\N	\N	\N	\N	133326	133326	134031
27110	43354	68	applied	\N	\N	\N	\N	133340	133340	133031
27110	43460	69	applied	\N	\N	\N	\N	133693	133693	133694
27110	43461	70	applied	\N	\N	\N	\N	133695	133695	133696
27110	43462	71	applied	\N	\N	\N	\N	133697	133697	133698
27110	43463	72	applied	\N	\N	\N	\N	133699	133699	133700
27110	43464	73	applied	\N	\N	\N	\N	133701	133701	133701
27110	43355	74	applied	\N	\N	\N	\N	133342	133342	134032
27110	43356	75	applied	\N	\N	\N	\N	133344	133344	134033
27110	43359	76	applied	\N	\N	\N	\N	133353	133353	133035
27110	43363	77	applied	\N	\N	\N	\N	133369	133369	133040
27110	43364	78	applied	\N	\N	\N	\N	133371	133371	133095
27110	43368	79	applied	\N	\N	\N	\N	133379	133379	133096
27110	43371	80	applied	\N	\N	\N	\N	133389	133389	133097
27110	43372	81	applied	\N	\N	\N	\N	133391	133391	133052
27110	43377	82	applied	\N	\N	\N	\N	133407	133407	134034
27110	43380	83	applied	\N	\N	\N	\N	133418	133418	133099
27110	43381	84	applied	\N	\N	\N	\N	133420	133420	134035
27110	43385	85	applied	\N	\N	\N	\N	133430	133430	134036
27110	43390	86	applied	\N	\N	\N	\N	133447	133447	133067
27110	43394	87	applied	\N	\N	\N	\N	133462	133462	134037
27110	43397	88	applied	\N	\N	\N	\N	133468	133468	134038
27110	43400	89	applied	\N	\N	\N	\N	133474	133474	134039
27110	43403	90	applied	\N	\N	\N	\N	133508	133508	133090
27110	43405	91	applied	\N	\N	\N	\N	133523	133523	133092
27110	43409	92	applied	\N	\N	\N	\N	133542	133542	134040
27110	43412	93	applied	\N	\N	\N	\N	133554	133554	134041
27110	43417	94	applied	\N	\N	\N	\N	133579	133579	134042
27110	43421	95	applied	\N	\N	\N	\N	133588	133588	133112
27110	43424	96	applied	\N	\N	\N	\N	133594	133594	133114
27110	43410	97	applied	\N	\N	1000000000	\N	133544	133544	133545
27110	43413	98	applied	\N	\N	1000000000	\N	133556	133556	133557
27110	43414	99	applied	\N	\N	1000000000	\N	133558	133558	133559
27110	43415	100	applied	\N	\N	1000000000	\N	133560	133560	133561
27110	43429	101	applied	\N	\N	\N	\N	133606	133606	133124
27110	43182	102	applied	\N	\N	\N	\N	132839	132839	133126
27110	43186	103	applied	\N	\N	\N	\N	132848	132848	134043
27110	43187	104	applied	\N	\N	\N	\N	132850	132850	134044
27110	43190	105	applied	\N	\N	\N	\N	132879	132879	134045
27110	43193	106	applied	\N	\N	\N	\N	132888	132888	133143
27110	43196	107	applied	\N	\N	\N	\N	132896	132896	133147
27110	43199	108	applied	\N	\N	\N	\N	132906	132906	134046
27110	43202	109	applied	\N	\N	\N	\N	132914	132914	134047
27110	43210	110	applied	\N	\N	\N	\N	132930	132930	133195
27110	43211	111	applied	\N	\N	\N	\N	132932	132932	133197
27110	43212	112	applied	\N	\N	\N	\N	132935	132935	134048
27110	43216	113	applied	\N	\N	\N	\N	132948	132948	134049
27110	43218	114	applied	\N	\N	\N	\N	132952	132952	134050
27110	43220	115	applied	\N	\N	\N	\N	132963	132963	134051
27110	43224	116	applied	\N	\N	\N	\N	132971	132971	133229
27110	43227	117	applied	\N	\N	\N	\N	132978	132978	134052
27110	43230	118	applied	\N	\N	\N	\N	132986	132986	133243
27110	43234	119	applied	\N	\N	\N	\N	132996	132996	133245
27110	43235	120	applied	\N	\N	\N	\N	132998	132998	133247
27110	43236	121	applied	\N	\N	\N	\N	133000	133000	133249
27110	43245	122	applied	\N	\N	\N	\N	133020	133020	134053
27110	43250	123	applied	\N	\N	\N	\N	133030	133030	134054
27110	43251	124	applied	\N	\N	\N	\N	133032	133032	134055
27110	43252	125	applied	\N	\N	\N	\N	133034	133034	134056
27112	43565	0	applied	\N	\N	\N	\N	134059	134059	134060
27112	43566	1	applied	\N	\N	\N	\N	134061	134061	134062
27117	43573	0	applied	\N	\N	\N	\N	134083	134083	134084
27117	43574	1	applied	\N	\N	\N	\N	134085	134085	134086
27117	43575	2	applied	\N	\N	\N	\N	134087	134087	134088
27119	43579	0	applied	\N	\N	\N	\N	134098	134098	134099
27119	43580	1	applied	\N	\N	\N	\N	134100	134100	134101
27119	43581	2	applied	\N	\N	\N	\N	134102	134102	134103
27120	43579	0	applied	\N	\N	\N	\N	134098	134098	134099
27120	43580	1	applied	\N	\N	\N	\N	134100	134100	134101
27120	43581	2	applied	\N	\N	\N	\N	134102	134102	134103
27122	43588	0	applied	\N	\N	\N	\N	134121	134121	134122
27122	43589	1	applied	\N	\N	\N	\N	134123	134123	134124
27122	43590	2	applied	\N	\N	\N	\N	134125	134125	134126
27122	43591	3	applied	\N	\N	\N	\N	134127	134127	134128
27122	43592	4	applied	\N	\N	\N	\N	134129	134129	134130
27125	43596	0	applied	\N	\N	\N	\N	134140	134140	134141
27125	43597	1	applied	\N	\N	\N	\N	134142	134142	134143
27125	43598	2	applied	\N	\N	\N	\N	134144	134144	134145
27127	43602	0	applied	\N	\N	\N	\N	134155	134155	134156
27127	43603	1	applied	\N	\N	\N	\N	134157	134157	134158
27127	43604	2	applied	\N	\N	\N	\N	134159	134159	134160
27130	43608	0	applied	\N	\N	\N	\N	134172	134172	134173
27130	43609	1	applied	\N	\N	\N	\N	134174	134174	134175
27130	43610	2	applied	\N	\N	\N	\N	134176	134176	134177
27130	43611	3	applied	\N	\N	\N	\N	134178	134178	134179
27130	43612	4	applied	\N	\N	\N	\N	134180	134180	134181
27130	43613	5	applied	\N	\N	\N	\N	134182	134182	134183
27130	43614	6	applied	\N	\N	\N	\N	134184	134184	134185
27130	43615	7	applied	\N	\N	\N	\N	134186	134186	134187
27130	43616	8	applied	\N	\N	\N	\N	134188	134188	134189
27133	43617	0	applied	\N	\N	\N	\N	134192	134192	134193
27133	43618	1	applied	\N	\N	\N	\N	134194	134194	134195
27133	43619	2	applied	\N	\N	\N	\N	134196	134196	134197
27139	43623	0	applied	\N	\N	\N	\N	134212	134212	134213
27139	43624	1	applied	\N	\N	\N	\N	134214	134214	134215
27139	43625	2	applied	\N	\N	\N	\N	134216	134216	134217
27142	43626	0	applied	\N	\N	\N	\N	134222	134222	134223
27142	43627	1	applied	\N	\N	\N	\N	134224	134224	134225
27142	43628	2	applied	\N	\N	\N	\N	134226	134226	134227
27144	43629	0	applied	\N	\N	\N	\N	134229	134229	134230
27144	43630	1	applied	\N	\N	\N	\N	134231	134231	134232
27144	43631	2	applied	\N	\N	\N	\N	134233	134233	134234
27144	43632	3	applied	\N	\N	\N	\N	134235	134235	134236
27144	43633	4	applied	\N	\N	\N	\N	134237	134237	134238
27144	43634	5	applied	\N	\N	\N	\N	134239	134239	134240
27144	43635	6	applied	\N	\N	\N	\N	134241	134241	134242
27144	43636	7	applied	\N	\N	\N	\N	134243	134243	134244
27146	43637	0	applied	\N	\N	\N	\N	134248	134248	134249
27146	43638	1	applied	\N	\N	\N	\N	134250	134250	134251
27146	43639	2	applied	\N	\N	\N	\N	134252	134252	134253
27149	43640	0	applied	\N	\N	\N	\N	134257	134257	134258
27149	43641	2	applied	\N	\N	\N	\N	134260	134260	134261
27149	43642	3	applied	\N	\N	\N	\N	134262	134262	134263
27149	43643	4	applied	\N	\N	\N	\N	134264	134264	134265
27161	43673	0	applied	\N	\N	\N	\N	134354	134354	134355
27161	43674	1	applied	\N	\N	\N	\N	134356	134356	134357
27161	43675	2	applied	\N	\N	\N	\N	134358	134358	134359
27162	43673	0	applied	\N	\N	\N	\N	134354	134354	134355
27162	43674	1	applied	\N	\N	\N	\N	134356	134356	134357
27162	43675	2	applied	\N	\N	\N	\N	134358	134358	134359
27166	43682	0	applied	\N	\N	\N	\N	134379	134379	134380
27166	43683	1	applied	\N	\N	\N	\N	134381	134381	134382
27166	43684	2	applied	\N	\N	\N	\N	134383	134383	134384
27168	43682	0	applied	\N	\N	\N	\N	134379	134379	134380
27168	43683	1	applied	\N	\N	\N	\N	134381	134381	134382
27168	43684	2	applied	\N	\N	\N	\N	134383	134383	134384
27176	43705	0	applied	\N	\N	\N	\N	134434	134434	134435
27176	43706	1	applied	\N	\N	\N	\N	134436	134436	134437
27176	43707	2	applied	\N	\N	\N	\N	134438	134438	134439
27182	43723	0	applied	\N	\N	\N	\N	134481	134481	134482
27182	43724	2	applied	\N	\N	\N	\N	134484	134484	134485
27182	43725	3	applied	\N	\N	\N	\N	134486	134486	134487
27182	43726	4	applied	\N	\N	\N	\N	134488	134488	134489
27182	43727	5	applied	\N	\N	\N	\N	134490	134490	134491
27182	43728	6	applied	\N	\N	\N	\N	134492	134492	134493
27186	43732	0	applied	\N	\N	\N	\N	134508	134508	134509
27186	43733	1	applied	\N	\N	\N	\N	134510	134510	134511
27194	43744	0	applied	\N	\N	\N	\N	134545	134545	134546
27194	43745	1	applied	\N	\N	\N	\N	134547	134547	134548
27198	43755	0	applied	\N	\N	\N	\N	134618	134618	134619
27198	43756	1	applied	\N	\N	\N	\N	134620	134620	134621
27198	43757	2	applied	\N	\N	1000000000	\N	134622	134622	134623
27198	43758	3	applied	\N	\N	\N	\N	134624	134624	134625
27198	43759	4	applied	\N	\N	1000000000	\N	134626	134626	134627
27200	43755	0	applied	\N	\N	\N	\N	134618	134618	134619
27200	43756	1	applied	\N	\N	\N	\N	134620	134620	134621
27200	43757	2	applied	\N	\N	1000000000	\N	134622	134622	134623
27200	43758	3	applied	\N	\N	\N	\N	134624	134624	134625
27200	43759	4	applied	\N	\N	1000000000	\N	134626	134626	134627
27202	43760	0	applied	\N	\N	\N	\N	134634	134634	134635
27128	43606	1	applied	\N	\N	\N	\N	134165	134165	134166
27128	43607	2	applied	\N	\N	\N	\N	134167	134167	134168
27131	43608	0	applied	\N	\N	\N	\N	134172	134172	134173
27131	43609	1	applied	\N	\N	\N	\N	134174	134174	134175
27131	43610	2	applied	\N	\N	\N	\N	134176	134176	134177
27131	43611	3	applied	\N	\N	\N	\N	134178	134178	134179
27131	43612	4	applied	\N	\N	\N	\N	134180	134180	134181
27131	43613	5	applied	\N	\N	\N	\N	134182	134182	134183
27131	43614	6	applied	\N	\N	\N	\N	134184	134184	134185
27131	43615	7	applied	\N	\N	\N	\N	134186	134186	134187
27131	43616	8	applied	\N	\N	\N	\N	134188	134188	134189
27134	43618	0	applied	\N	\N	\N	\N	134194	134194	134195
27134	43619	1	applied	\N	\N	\N	\N	134196	134196	134197
27135	43617	0	applied	\N	\N	\N	\N	134192	134192	134193
27135	43618	1	applied	\N	\N	\N	\N	134194	134194	134195
27135	43619	2	applied	\N	\N	\N	\N	134196	134196	134197
27140	43623	0	applied	\N	\N	\N	\N	134212	134212	134213
27140	43624	1	applied	\N	\N	\N	\N	134214	134214	134215
27140	43625	2	applied	\N	\N	\N	\N	134216	134216	134217
27145	43629	0	applied	\N	\N	\N	\N	134229	134229	134230
27145	43630	1	applied	\N	\N	\N	\N	134231	134231	134232
27145	43631	2	applied	\N	\N	\N	\N	134233	134233	134234
27145	43632	3	applied	\N	\N	\N	\N	134235	134235	134236
27145	43633	4	applied	\N	\N	\N	\N	134237	134237	134238
27145	43634	5	applied	\N	\N	\N	\N	134239	134239	134240
27145	43635	6	applied	\N	\N	\N	\N	134241	134241	134242
27145	43636	7	applied	\N	\N	\N	\N	134243	134243	134244
27147	43637	0	applied	\N	\N	\N	\N	134248	134248	134249
27147	43638	1	applied	\N	\N	\N	\N	134250	134250	134251
27147	43639	2	applied	\N	\N	\N	\N	134252	134252	134253
27150	42536	0	applied	\N	\N	\N	\N	130913	130913	130914
27150	42540	1	applied	\N	\N	\N	\N	130923	130923	130924
27150	42541	2	applied	\N	\N	\N	\N	130925	130925	130926
27150	42546	3	applied	\N	\N	\N	\N	130939	130939	130940
27150	42906	4	applied	\N	\N	\N	\N	132007	132007	132008
27150	42550	5	applied	\N	\N	\N	\N	130950	130950	130951
27150	42553	6	applied	\N	\N	\N	\N	131033	131033	131034
27150	42556	7	applied	\N	\N	\N	\N	131044	131044	131045
27150	42560	8	applied	\N	\N	\N	\N	131056	131056	131057
27150	42563	9	applied	\N	\N	\N	\N	131063	131063	131064
27150	42566	10	applied	\N	\N	\N	\N	131070	131070	131071
27150	42567	11	applied	\N	\N	\N	\N	131072	131072	131073
27150	42573	12	applied	\N	\N	\N	\N	131089	131089	131090
27150	42576	13	applied	\N	\N	\N	\N	131099	131099	131100
27150	42577	14	applied	\N	\N	\N	\N	131101	131101	131102
27150	42583	15	applied	\N	\N	\N	\N	131127	131127	131128
27150	42586	16	applied	\N	\N	\N	\N	131134	131134	131135
27150	42589	17	applied	\N	\N	\N	\N	131142	131142	131143
27150	42593	18	applied	\N	\N	\N	\N	131155	131155	131156
27150	42596	19	applied	\N	\N	\N	\N	131163	131163	131164
27150	42599	20	applied	\N	\N	\N	\N	131170	131170	131171
27150	42602	21	applied	\N	\N	\N	\N	131178	131178	131179
27150	42603	22	applied	\N	\N	\N	\N	131180	131180	131181
27150	42609	23	applied	\N	\N	\N	\N	131201	131201	131202
27150	42610	24	applied	\N	\N	\N	\N	131203	131203	131204
27150	42611	25	applied	\N	\N	\N	\N	131205	131205	131206
27150	42618	26	applied	\N	\N	\N	\N	131222	131222	131223
27150	42619	27	applied	\N	\N	\N	\N	131224	131224	131225
27150	42626	28	applied	\N	\N	\N	\N	131244	131244	131245
27150	42629	29	applied	\N	\N	\N	\N	131252	131252	131253
27150	42630	30	applied	\N	\N	\N	\N	131254	131254	131255
27150	42631	31	applied	\N	\N	\N	\N	131256	131256	131257
27150	42639	32	applied	\N	\N	\N	\N	131277	131277	131278
27150	42643	33	applied	\N	\N	\N	\N	131285	131285	131286
27150	42646	34	applied	\N	\N	\N	\N	131293	131293	131294
27150	42650	35	applied	\N	\N	\N	\N	131304	131304	131305
27150	42653	36	applied	\N	\N	\N	\N	131314	131314	131315
27150	42656	37	applied	\N	\N	\N	\N	131325	131325	131326
27150	42657	38	applied	\N	\N	\N	\N	131327	131327	131328
27150	42663	39	applied	\N	\N	\N	\N	131341	131341	131342
27150	42664	40	applied	\N	\N	\N	\N	131343	131343	131344
27150	42669	41	applied	\N	\N	\N	\N	131355	131355	131356
27150	42670	42	applied	\N	\N	\N	\N	131357	131357	131358
27150	42671	43	applied	\N	\N	\N	\N	131359	131359	131360
27150	42680	44	applied	\N	\N	\N	\N	131385	131385	131386
27150	42681	45	applied	\N	\N	\N	\N	131387	131387	131388
27150	42687	46	applied	\N	\N	\N	\N	131430	131430	131431
27150	42690	47	applied	\N	\N	\N	\N	131437	131437	131438
27150	42691	48	applied	\N	\N	\N	\N	131439	131439	131440
27150	42697	49	applied	\N	\N	\N	\N	131452	131452	131453
27150	42698	50	applied	\N	\N	\N	\N	131454	131454	131455
27150	42703	51	applied	\N	\N	\N	\N	131467	131467	131468
27150	42707	52	applied	\N	\N	\N	\N	131479	131479	131480
27150	42710	53	applied	\N	\N	\N	\N	131489	131489	131490
27150	42713	54	applied	\N	\N	\N	\N	131496	131496	131497
27150	42717	55	applied	\N	\N	\N	\N	131505	131505	131506
27150	42718	56	applied	\N	\N	\N	\N	131507	131507	131508
27150	42719	57	applied	\N	\N	\N	\N	131509	131509	131510
27150	42725	58	applied	\N	\N	\N	\N	131523	131523	131524
27150	42729	59	applied	\N	\N	\N	\N	131533	131533	131534
27150	42732	60	applied	\N	\N	\N	\N	131541	131541	131542
27150	42733	61	applied	\N	\N	\N	\N	131543	131543	131544
27150	42739	63	applied	\N	\N	\N	\N	131559	131559	131560
27150	42742	64	applied	\N	\N	\N	\N	131571	131571	131572
27150	42747	65	applied	\N	\N	\N	\N	131584	131584	131585
27150	42751	66	applied	\N	\N	\N	\N	131593	131593	131594
27150	42752	67	applied	\N	\N	\N	\N	131595	131595	131596
27150	42757	68	applied	\N	\N	\N	\N	131607	131607	131608
27150	42760	69	applied	\N	\N	\N	\N	131615	131615	131616
27150	42764	70	applied	\N	\N	\N	\N	131630	131630	131631
27150	42767	71	applied	\N	\N	\N	\N	131640	131640	131641
27150	42768	72	applied	\N	\N	\N	\N	131642	131642	131643
27150	42774	73	applied	\N	\N	\N	\N	131658	131658	131659
27150	42777	74	applied	\N	\N	\N	\N	131666	131666	131667
27150	42780	75	applied	\N	\N	\N	\N	131674	131674	131675
27150	42784	76	applied	\N	\N	\N	\N	131685	131685	131686
27150	42785	77	applied	\N	\N	\N	\N	131687	131687	131688
27150	42790	78	applied	\N	\N	\N	\N	131700	131700	131701
27150	42793	79	applied	\N	\N	\N	\N	131706	131706	131707
27150	42797	80	applied	\N	\N	\N	\N	131715	131715	131716
27150	42798	81	applied	\N	\N	\N	\N	131717	131717	131718
27150	42799	82	applied	\N	\N	\N	\N	131719	131719	131720
27150	42807	83	applied	\N	\N	\N	\N	131743	131743	131744
27150	42808	84	applied	\N	\N	\N	\N	131745	131745	131746
27150	42813	85	applied	\N	\N	\N	\N	131757	131757	131758
27150	42814	86	applied	\N	\N	\N	\N	131759	131759	131760
27150	42819	87	applied	\N	\N	\N	\N	131771	131771	131772
27150	42820	88	applied	\N	\N	\N	\N	131773	131773	131774
27150	42821	89	applied	\N	\N	\N	\N	131775	131775	131776
27150	42822	90	applied	\N	\N	\N	\N	131777	131777	131778
27150	42823	91	applied	\N	\N	\N	\N	131779	131779	131780
27150	42824	92	applied	\N	\N	\N	\N	131781	131781	131782
27150	42839	93	applied	\N	\N	\N	\N	131814	131814	131815
27150	42840	94	applied	\N	\N	\N	\N	131816	131816	131817
27150	42845	95	applied	\N	\N	\N	\N	131835	131835	131836
27150	42849	96	applied	\N	\N	\N	\N	131845	131845	131846
27150	42852	97	applied	\N	\N	\N	\N	131852	131852	131853
27150	42853	98	applied	\N	\N	\N	\N	131854	131854	131855
27150	42854	99	applied	\N	\N	\N	\N	131856	131856	131857
27150	42864	100	applied	\N	\N	\N	\N	131881	131881	131882
27150	42867	101	applied	\N	\N	\N	\N	131891	131891	131892
27150	42870	102	applied	\N	\N	\N	\N	131905	131905	131906
27150	42874	103	applied	\N	\N	\N	\N	131918	131918	131919
27150	42877	104	applied	\N	\N	\N	\N	131930	131930	131931
27150	42878	105	applied	\N	\N	\N	\N	131932	131932	131933
27150	42879	106	applied	\N	\N	\N	\N	131934	131934	131935
27150	42887	107	applied	\N	\N	\N	\N	131951	131951	131952
27150	42890	108	applied	\N	\N	\N	\N	131961	131961	131962
27150	42892	109	applied	\N	\N	\N	\N	131969	131969	131970
27150	42896	110	applied	\N	\N	\N	\N	131978	131978	131979
27150	42899	111	applied	\N	\N	\N	\N	131988	131988	131989
27150	42902	112	applied	\N	\N	\N	\N	131997	131997	131998
27150	42907	113	applied	\N	\N	\N	\N	132009	132009	132010
27150	42910	114	applied	\N	\N	\N	\N	132017	132017	132018
27150	42911	115	applied	\N	\N	\N	\N	132019	132019	132020
27150	42912	116	applied	\N	\N	\N	\N	132021	132021	132022
27150	42920	117	applied	\N	\N	\N	\N	132039	132039	132040
27150	42923	118	applied	\N	\N	\N	\N	132045	132045	132046
27150	42926	119	applied	\N	\N	\N	\N	132057	132057	132058
27150	42927	120	applied	\N	\N	\N	\N	132059	132059	132060
27150	42933	121	applied	\N	\N	\N	\N	132075	132075	132076
27150	42934	122	applied	\N	\N	\N	\N	132077	132077	132078
27150	42935	123	applied	\N	\N	\N	\N	132079	132079	132080
27150	42936	124	applied	\N	\N	\N	\N	132081	132081	132082
27150	42946	125	applied	\N	\N	\N	\N	132103	132103	132104
27152	43646	0	applied	\N	\N	\N	\N	134280	134280	134281
27152	43647	2	applied	\N	\N	\N	\N	134283	134283	134284
27152	43648	3	applied	\N	\N	\N	\N	134285	134285	134286
27152	43649	4	applied	\N	\N	\N	\N	134287	134287	134288
27152	43640	5	applied	\N	\N	\N	\N	134257	134257	134258
27152	43641	6	applied	\N	\N	\N	\N	134260	134260	134261
27152	43645	7	applied	\N	\N	\N	\N	134276	134276	134289
27152	43650	8	applied	\N	\N	\N	\N	134290	134290	134275
27152	43642	9	applied	\N	\N	\N	\N	134262	134262	134291
27152	43643	10	applied	\N	\N	\N	\N	134264	134264	134292
27152	43644	11	applied	\N	\N	\N	\N	134274	134274	134293
27152	43651	12	applied	\N	\N	\N	\N	134294	134294	134295
27153	43646	0	applied	\N	\N	\N	\N	134280	134280	134281
27153	43647	2	applied	\N	\N	\N	\N	134283	134283	134284
27153	43648	3	applied	\N	\N	\N	\N	134285	134285	134286
27153	43649	4	applied	\N	\N	\N	\N	134287	134287	134288
27153	43640	5	applied	\N	\N	\N	\N	134257	134257	134258
27153	43641	6	applied	\N	\N	\N	\N	134260	134260	134261
27153	43645	7	applied	\N	\N	\N	\N	134276	134276	134289
27153	43650	8	applied	\N	\N	\N	\N	134290	134290	134275
27153	43642	9	applied	\N	\N	\N	\N	134262	134262	134291
27153	43643	10	applied	\N	\N	\N	\N	134264	134264	134292
27153	43644	11	applied	\N	\N	\N	\N	134274	134274	134293
27153	43651	12	applied	\N	\N	\N	\N	134294	134294	134295
27159	43661	0	applied	\N	\N	\N	\N	134328	134328	134329
27159	43662	1	applied	\N	\N	\N	\N	134330	134330	134331
27159	43663	2	applied	\N	\N	\N	\N	134332	134332	134333
27164	43510	0	applied	\N	\N	\N	\N	133877	133877	133878
27164	43460	1	applied	\N	\N	\N	\N	133693	133693	133694
27164	43461	2	applied	\N	\N	\N	\N	133695	133695	133696
27164	43462	3	applied	\N	\N	\N	\N	133697	133697	133698
27164	43463	4	applied	\N	\N	\N	\N	133699	133699	133700
27164	43464	5	applied	\N	\N	\N	\N	133701	133701	133701
27167	43682	0	applied	\N	\N	\N	\N	134379	134379	134380
27167	43683	1	applied	\N	\N	\N	\N	134381	134381	134382
27167	43684	2	applied	\N	\N	\N	\N	134383	134383	134384
27169	43685	0	applied	\N	\N	\N	\N	134387	134387	134388
27169	43686	1	applied	\N	\N	\N	\N	134389	134389	134390
27169	43687	2	applied	\N	\N	\N	\N	134391	134391	134392
27169	43688	3	applied	\N	\N	\N	\N	134393	134393	134394
27169	43689	4	applied	\N	\N	\N	\N	134395	134395	134396
27171	43690	0	applied	\N	\N	\N	\N	134399	134399	134400
27171	43691	1	applied	\N	\N	\N	\N	134401	134401	134402
27171	43692	2	applied	\N	\N	\N	\N	134403	134403	134404
27174	43699	0	applied	\N	\N	\N	\N	134418	134418	134419
27174	43700	1	applied	\N	\N	\N	\N	134420	134420	134421
27174	43701	2	applied	\N	\N	\N	\N	134422	134422	134423
27177	43708	0	applied	\N	\N	\N	\N	134442	134442	134443
27177	43709	1	applied	\N	\N	\N	\N	134444	134444	134445
27177	43710	2	applied	\N	\N	\N	\N	134446	134446	134447
27177	43711	3	applied	\N	\N	\N	\N	134448	134448	134449
27177	43712	4	applied	\N	\N	\N	\N	134450	134450	134451
27177	43713	5	applied	\N	\N	\N	\N	134452	134452	134453
27183	43723	0	applied	\N	\N	\N	\N	134481	134481	134482
27183	43724	2	applied	\N	\N	\N	\N	134484	134484	134485
27183	43725	3	applied	\N	\N	\N	\N	134486	134486	134487
27183	43726	4	applied	\N	\N	\N	\N	134488	134488	134489
27183	43727	5	applied	\N	\N	\N	\N	134490	134490	134491
27183	43728	6	applied	\N	\N	\N	\N	134492	134492	134493
27187	43732	0	applied	\N	\N	\N	\N	134508	134508	134509
27187	43733	1	applied	\N	\N	\N	\N	134510	134510	134511
27187	43734	2	applied	\N	\N	\N	\N	134514	134514	134515
27188	43732	0	applied	\N	\N	\N	\N	134508	134508	134509
27188	43733	1	applied	\N	\N	\N	\N	134510	134510	134511
27188	43734	2	applied	\N	\N	\N	\N	134514	134514	134515
27189	43733	0	applied	\N	\N	\N	\N	134510	134510	134511
27189	43734	1	applied	\N	\N	\N	\N	134514	134514	134515
27191	43735	0	applied	\N	\N	\N	\N	134523	134523	134524
27191	43736	1	applied	\N	\N	\N	\N	134525	134525	134526
27191	43737	2	applied	\N	\N	\N	\N	134527	134527	134528
27203	43763	0	applied	\N	\N	\N	\N	134641	134641	134642
27203	43764	1	applied	\N	\N	\N	\N	134643	134643	134644
27203	43765	2	applied	\N	\N	\N	\N	134645	134645	134646
27203	43766	3	applied	\N	\N	1000000000	\N	134647	134647	134648
27203	43767	4	applied	\N	\N	\N	\N	134649	134649	134650
27203	43768	5	applied	\N	\N	\N	\N	134651	134651	134652
27203	43769	6	applied	\N	\N	\N	\N	134653	134653	134654
27206	43770	0	applied	\N	\N	\N	\N	134659	134659	134660
27206	43771	1	applied	\N	\N	\N	\N	134661	134661	134662
27206	43772	2	applied	\N	\N	\N	\N	134663	134663	134664
27211	43778	0	applied	\N	\N	\N	\N	134681	134681	134682
27211	43779	1	applied	\N	\N	\N	\N	134683	134683	134684
27211	43780	2	applied	\N	\N	\N	\N	134685	134685	134686
27212	43781	0	applied	\N	\N	\N	\N	134689	134689	134690
27212	43782	1	applied	\N	\N	\N	\N	134691	134691	134692
27154	43649	3	applied	\N	\N	\N	\N	134287	134287	134288
27154	43651	4	applied	\N	\N	\N	\N	134294	134294	134301
27154	43650	5	applied	\N	\N	\N	\N	134290	134290	134295
27155	43652	0	applied	\N	\N	\N	\N	134304	134304	134305
27155	43653	1	applied	\N	\N	\N	\N	134306	134306	134307
27155	43654	2	applied	\N	\N	\N	\N	134308	134308	134309
27158	43655	0	applied	\N	\N	\N	\N	134312	134312	134313
27158	43656	1	applied	\N	\N	\N	\N	134314	134314	134315
27158	43657	2	applied	\N	\N	\N	\N	134316	134316	134317
27158	43658	3	applied	\N	\N	\N	\N	134318	134318	134319
27158	43659	4	applied	\N	\N	\N	\N	134320	134320	134321
27158	43660	5	applied	\N	\N	\N	\N	134322	134322	134323
27163	43676	0	applied	\N	\N	\N	\N	134361	134361	134362
27163	43677	1	applied	\N	\N	\N	\N	134363	134363	134364
27163	43678	2	applied	\N	\N	\N	\N	134365	134365	134366
27173	43696	0	applied	\N	\N	\N	\N	134412	134412	134413
27173	43697	1	applied	\N	\N	\N	\N	134414	134414	134415
27173	43698	2	applied	\N	\N	\N	\N	134416	134416	134417
27179	43714	0	applied	\N	\N	\N	\N	134454	134454	134455
27179	43715	1	applied	\N	\N	\N	\N	134456	134456	134457
27179	43716	2	applied	\N	\N	\N	\N	134458	134458	134459
27179	43717	3	applied	\N	\N	\N	\N	134460	134460	134461
27179	43718	4	applied	\N	\N	\N	\N	134462	134462	134463
27179	43719	5	applied	\N	\N	\N	\N	134464	134464	134465
27181	43720	0	applied	\N	\N	\N	\N	134473	134473	134474
27181	43721	1	applied	\N	\N	\N	\N	134475	134475	134476
27181	43722	2	applied	\N	\N	\N	\N	134477	134477	134478
27190	43732	0	applied	\N	\N	\N	\N	134508	134508	134509
27190	43733	1	applied	\N	\N	\N	\N	134510	134510	134511
27190	43734	2	applied	\N	\N	\N	\N	134514	134514	134515
27195	43617	0	applied	\N	\N	\N	\N	134192	134192	134193
27195	43620	1	applied	\N	\N	\N	\N	134203	134203	134204
27195	43623	2	applied	\N	\N	\N	\N	134212	134212	134213
27195	43626	3	applied	\N	\N	\N	\N	134222	134222	134223
27195	43629	4	applied	\N	\N	\N	\N	134229	134229	134230
27195	43630	5	applied	\N	\N	\N	\N	134231	134231	134232
27195	43631	6	applied	\N	\N	\N	\N	134233	134233	134234
27195	43637	7	applied	\N	\N	\N	\N	134248	134248	134249
27195	43646	8	applied	\N	\N	\N	\N	134280	134280	134281
27195	43647	9	applied	\N	\N	\N	\N	134283	134283	134284
27195	43648	10	applied	\N	\N	\N	\N	134285	134285	134286
27195	43649	11	applied	\N	\N	\N	\N	134287	134287	134288
27195	43652	12	applied	\N	\N	\N	\N	134304	134304	134305
27195	43655	13	applied	\N	\N	\N	\N	134312	134312	134313
27195	43656	14	applied	\N	\N	\N	\N	134314	134314	134315
27195	43661	15	applied	\N	\N	\N	\N	134328	134328	134329
27195	43664	16	applied	\N	\N	\N	\N	134334	134334	134335
27195	43665	17	applied	\N	\N	\N	\N	134336	134336	134337
27195	43666	18	applied	\N	\N	\N	\N	134338	134338	134339
27195	43673	19	applied	\N	\N	\N	\N	134354	134354	134355
27195	43676	20	applied	\N	\N	\N	\N	134361	134361	134362
27195	43679	21	applied	\N	\N	\N	\N	134371	134371	134372
27195	43682	22	applied	\N	\N	\N	\N	134379	134379	134380
27195	43685	23	applied	\N	\N	\N	\N	134387	134387	134388
27195	43686	24	applied	\N	\N	\N	\N	134389	134389	134390
27195	43690	25	applied	\N	\N	\N	\N	134399	134399	134400
27195	43693	26	applied	\N	\N	\N	\N	134405	134405	134406
27195	43696	27	applied	\N	\N	\N	\N	134412	134412	134413
27195	43699	28	applied	\N	\N	\N	\N	134418	134418	134419
27195	43702	29	applied	\N	\N	\N	\N	134426	134426	134427
27195	43705	30	applied	\N	\N	\N	\N	134434	134434	134435
27195	43708	31	applied	\N	\N	\N	\N	134442	134442	134443
27195	43709	32	applied	\N	\N	\N	\N	134444	134444	134445
27195	43714	33	applied	\N	\N	\N	\N	134454	134454	134455
27195	43715	34	applied	\N	\N	\N	\N	134456	134456	134457
27195	43720	35	applied	\N	\N	\N	\N	134473	134473	134474
27195	43723	37	applied	\N	\N	\N	\N	134481	134481	134482
27195	43724	38	applied	\N	\N	\N	\N	134484	134484	134485
27195	43729	39	applied	\N	\N	\N	\N	134500	134500	134501
27195	43732	40	applied	\N	\N	\N	\N	134508	134508	134509
27195	43735	41	applied	\N	\N	\N	\N	134523	134523	134524
27195	43738	42	applied	\N	\N	\N	\N	134531	134531	134532
27195	43739	43	applied	\N	\N	\N	\N	134533	134533	134534
27195	43744	44	applied	\N	\N	\N	\N	134545	134545	134546
27195	43746	45	applied	\N	\N	\N	\N	134551	134551	134552
27195	43618	46	applied	\N	\N	\N	\N	134194	134194	134195
27195	43622	47	applied	\N	\N	\N	\N	134207	134207	134553
27195	43625	48	applied	\N	\N	\N	\N	134216	134216	134554
27195	43627	49	applied	\N	\N	\N	\N	134224	134224	134206
27195	43632	50	applied	\N	\N	\N	\N	134235	134235	134208
27195	43633	51	applied	\N	\N	\N	\N	134237	134237	134555
27195	43636	52	applied	\N	\N	\N	\N	134243	134243	134556
27195	43639	53	applied	\N	\N	\N	\N	134252	134252	134557
27195	43619	54	applied	\N	\N	\N	\N	134196	134196	134558
27195	43621	55	applied	\N	\N	\N	\N	134205	134205	134236
27195	43624	56	applied	\N	\N	\N	\N	134214	134214	134559
27195	43628	57	applied	\N	\N	\N	\N	134226	134226	134560
27195	43634	58	applied	\N	\N	\N	\N	134239	134239	134561
27195	43635	59	applied	\N	\N	\N	\N	134241	134241	134562
27195	43638	60	applied	\N	\N	\N	\N	134250	134250	134253
27195	43640	61	applied	\N	\N	\N	\N	134257	134257	134258
27195	43641	62	applied	\N	\N	\N	\N	134260	134260	134261
27195	43645	63	applied	\N	\N	\N	\N	134276	134276	134289
27195	43650	64	applied	\N	\N	\N	\N	134290	134290	134275
27195	43653	65	applied	\N	\N	\N	\N	134306	134306	134277
27195	43659	66	applied	\N	\N	\N	\N	134320	134320	134293
27195	43660	67	applied	\N	\N	\N	\N	134322	134322	134563
27195	43662	68	applied	\N	\N	\N	\N	134330	134330	134564
27195	43669	69	applied	\N	\N	\N	\N	134344	134344	134317
27195	43670	70	applied	\N	\N	\N	\N	134346	134346	134565
27195	43671	71	applied	\N	\N	\N	\N	134348	134348	134566
27195	43674	72	applied	\N	\N	\N	\N	134356	134356	134567
27195	43678	73	applied	\N	\N	\N	\N	134365	134365	134568
27195	43680	74	applied	\N	\N	\N	\N	134373	134373	134341
27195	43684	75	applied	\N	\N	\N	\N	134383	134383	134569
27195	43687	76	applied	\N	\N	\N	\N	134391	134391	134570
27195	43691	77	applied	\N	\N	\N	\N	134401	134401	134571
27195	43694	78	applied	\N	\N	\N	\N	134407	134407	134572
27195	43698	79	applied	\N	\N	\N	\N	134416	134416	134573
27195	43701	80	applied	\N	\N	\N	\N	134422	134422	134359
27195	43703	81	applied	\N	\N	\N	\N	134428	134428	134574
27195	43707	82	applied	\N	\N	\N	\N	134438	134438	134575
27195	43710	83	applied	\N	\N	\N	\N	134446	134446	134576
27195	43711	84	applied	\N	\N	\N	\N	134448	134448	134382
27195	43716	85	applied	\N	\N	\N	\N	134458	134458	134384
27195	43719	86	applied	\N	\N	\N	\N	134464	134464	134392
27195	43722	87	applied	\N	\N	\N	\N	134477	134477	134577
27195	43726	88	applied	\N	\N	\N	\N	134488	134488	134578
27195	43727	89	applied	\N	\N	\N	\N	134490	134490	134404
27195	43730	90	applied	\N	\N	\N	\N	134502	134502	134408
27160	43667	3	applied	\N	\N	\N	\N	134340	134340	134341
27160	43668	4	applied	\N	\N	\N	\N	134342	134342	134343
27160	43669	5	applied	\N	\N	\N	\N	134344	134344	134345
27160	43670	6	applied	\N	\N	\N	\N	134346	134346	134347
27160	43671	7	applied	\N	\N	\N	\N	134348	134348	134349
27160	43672	8	applied	\N	\N	\N	\N	134350	134350	134351
27165	43679	0	applied	\N	\N	\N	\N	134371	134371	134372
27165	43680	1	applied	\N	\N	\N	\N	134373	134373	134374
27165	43681	2	applied	\N	\N	\N	\N	134375	134375	134376
27170	43685	0	applied	\N	\N	\N	\N	134387	134387	134388
27170	43686	1	applied	\N	\N	\N	\N	134389	134389	134390
27170	43687	2	applied	\N	\N	\N	\N	134391	134391	134392
27170	43688	3	applied	\N	\N	\N	\N	134393	134393	134394
27170	43689	4	applied	\N	\N	\N	\N	134395	134395	134396
27172	43693	0	applied	\N	\N	\N	\N	134405	134405	134406
27172	43694	1	applied	\N	\N	\N	\N	134407	134407	134408
27172	43695	2	applied	\N	\N	\N	\N	134409	134409	134410
27175	43702	0	applied	\N	\N	\N	\N	134426	134426	134427
27175	43703	1	applied	\N	\N	\N	\N	134428	134428	134429
27175	43704	2	applied	\N	\N	\N	\N	134430	134430	134431
27178	43714	0	applied	\N	\N	\N	\N	134454	134454	134455
27178	43715	1	applied	\N	\N	\N	\N	134456	134456	134457
27178	43716	2	applied	\N	\N	\N	\N	134458	134458	134459
27178	43717	3	applied	\N	\N	\N	\N	134460	134460	134461
27178	43718	4	applied	\N	\N	\N	\N	134462	134462	134463
27178	43719	5	applied	\N	\N	\N	\N	134464	134464	134465
27180	42953	0	applied	\N	\N	\N	\N	132123	132123	132124
27180	42954	1	applied	\N	\N	\N	\N	132126	132126	132127
27180	42957	2	applied	\N	\N	\N	\N	132136	132136	132137
27180	42960	3	applied	\N	\N	\N	\N	132146	132146	132147
27180	42964	4	applied	\N	\N	\N	\N	132159	132159	132160
27180	42966	5	applied	\N	\N	\N	\N	132165	132165	132166
27180	42969	6	applied	\N	\N	\N	\N	132173	132173	132174
27180	42973	7	applied	\N	\N	\N	\N	132184	132184	132185
27180	42976	8	applied	\N	\N	\N	\N	132195	132195	132196
27180	42977	9	applied	\N	\N	\N	\N	132197	132197	132198
27180	42978	10	applied	\N	\N	\N	\N	132199	132199	132200
27180	42986	11	applied	\N	\N	\N	\N	132217	132217	132218
27180	42989	12	applied	\N	\N	\N	\N	132224	132224	132225
27180	42992	13	applied	\N	\N	\N	\N	132232	132232	132233
27180	42996	14	applied	\N	\N	\N	\N	132243	132243	132244
27180	42999	15	applied	\N	\N	\N	\N	132251	132251	132252
27180	43002	16	applied	\N	\N	\N	\N	132260	132260	132261
27180	43006	17	applied	\N	\N	\N	\N	132270	132270	132271
27180	43007	18	applied	\N	\N	\N	\N	132272	132272	132273
27180	43008	19	applied	\N	\N	\N	\N	132274	132274	132275
27180	43009	20	applied	\N	\N	\N	\N	132276	132276	132277
27180	43019	21	applied	\N	\N	\N	\N	132298	132298	132299
27180	43021	22	applied	\N	\N	\N	\N	132304	132304	132305
27180	43022	23	applied	\N	\N	\N	\N	132306	132306	132307
27180	43028	24	applied	\N	\N	\N	\N	132320	132320	132321
27180	43031	25	applied	\N	\N	\N	\N	132328	132328	132329
27180	43034	26	applied	\N	\N	\N	\N	132336	132336	132337
27180	43035	27	applied	\N	\N	\N	\N	132338	132338	132339
27180	43041	28	applied	\N	\N	\N	\N	132352	132352	132353
27180	43044	29	applied	\N	\N	\N	\N	132405	132405	132406
27180	43045	30	applied	\N	\N	\N	\N	132407	132407	132408
27180	43046	31	applied	\N	\N	\N	\N	132409	132409	132410
27180	43054	32	applied	\N	\N	\N	\N	132427	132427	132428
27180	43057	33	applied	\N	\N	\N	\N	132466	132466	132467
27180	43058	34	applied	\N	\N	\N	\N	132468	132468	132469
27180	43064	35	applied	\N	\N	\N	\N	132485	132485	132486
27180	43067	36	applied	\N	\N	\N	\N	132491	132491	132492
27180	43071	37	applied	\N	\N	\N	\N	132500	132500	132501
27180	43074	38	applied	\N	\N	\N	\N	132509	132509	132510
27180	43077	39	applied	\N	\N	\N	\N	132518	132518	132519
27180	43082	40	applied	\N	\N	\N	\N	132528	132528	132529
27180	43085	41	applied	\N	\N	\N	\N	132537	132537	132538
27180	43088	42	applied	\N	\N	\N	\N	132586	132586	132587
27180	43089	43	applied	\N	\N	\N	\N	132588	132588	132589
27180	43090	44	applied	\N	\N	\N	\N	132590	132590	132591
27180	43098	45	applied	\N	\N	\N	\N	132608	132608	132609
27180	43101	46	applied	\N	\N	\N	\N	132616	132616	132617
27180	43105	47	applied	\N	\N	\N	\N	132629	132629	132630
27180	43108	48	applied	\N	\N	\N	\N	132639	132639	132640
27180	43111	49	applied	\N	\N	\N	\N	132647	132647	132648
27180	43115	50	applied	\N	\N	\N	\N	132658	132658	132659
27180	43118	51	applied	\N	\N	\N	\N	132677	132677	132678
27180	43119	52	applied	\N	\N	\N	\N	132679	132679	132680
27180	43124	53	applied	\N	\N	\N	\N	132695	132695	132696
27180	43125	54	applied	\N	\N	\N	\N	132697	132697	132698
27180	43131	55	applied	\N	\N	\N	\N	132709	132709	132710
27180	43132	56	applied	\N	\N	\N	\N	132711	132711	132712
27180	43133	57	applied	\N	\N	\N	\N	132713	132713	132714
27180	43134	58	applied	\N	\N	\N	\N	132715	132715	132716
27180	43142	59	applied	\N	\N	\N	\N	132736	132736	132737
27180	43143	60	applied	\N	\N	\N	\N	132738	132738	132739
27180	43148	61	applied	\N	\N	\N	\N	132750	132750	132751
27180	43151	63	applied	\N	\N	\N	\N	132758	132758	132759
27180	43154	64	applied	\N	\N	\N	\N	132764	132764	132765
27180	43157	65	applied	\N	\N	\N	\N	132770	132770	132771
27180	43158	66	applied	\N	\N	\N	\N	132772	132772	132773
27180	43163	67	applied	\N	\N	\N	\N	132785	132785	132786
27180	43166	68	applied	\N	\N	\N	\N	132797	132797	132798
27180	43169	69	applied	\N	\N	\N	\N	132805	132805	132806
27180	43172	70	applied	\N	\N	\N	\N	132815	132815	132816
27180	43174	71	applied	\N	\N	\N	\N	132819	132819	132820
27180	43177	72	applied	\N	\N	\N	\N	132829	132829	132830
27180	43178	73	applied	\N	\N	\N	\N	132831	132831	132832
27180	43183	74	applied	\N	\N	\N	\N	132842	132842	132843
27180	43184	75	applied	\N	\N	\N	\N	132844	132844	132845
27180	43189	76	applied	\N	\N	\N	\N	132877	132877	132878
27180	43192	77	applied	\N	\N	\N	\N	132886	132886	132887
27180	43195	78	applied	\N	\N	\N	\N	132894	132894	132895
27180	43198	79	applied	\N	\N	\N	\N	132904	132904	132905
27180	43201	80	applied	\N	\N	\N	\N	132912	132912	132913
27180	43204	81	applied	\N	\N	\N	\N	132918	132918	132919
27180	43205	82	applied	\N	\N	\N	\N	132920	132920	132921
27180	43206	83	applied	\N	\N	\N	\N	132922	132922	132923
27180	43213	84	applied	\N	\N	\N	\N	132942	132942	132943
27180	43214	85	applied	\N	\N	\N	\N	132944	132944	132945
27180	43219	86	applied	\N	\N	\N	\N	132961	132961	132962
27180	43222	87	applied	\N	\N	\N	\N	132967	132967	132968
27180	43225	88	applied	\N	\N	\N	\N	132974	132974	132975
27180	43228	89	applied	\N	\N	\N	\N	132982	132982	132983
27180	43231	90	applied	\N	\N	\N	\N	132990	132990	132991
27180	43232	91	applied	\N	\N	\N	\N	132992	132992	132993
27180	43233	92	applied	\N	\N	\N	\N	132994	132994	132995
27180	43240	93	applied	\N	\N	\N	\N	133011	133011	133012
27180	43241	94	applied	\N	\N	\N	\N	133013	133013	133014
27180	43242	95	applied	\N	\N	\N	\N	133015	133015	133016
27180	43243	96	applied	\N	\N	\N	\N	133017	133017	133018
27180	43253	97	applied	\N	\N	\N	\N	133037	133037	133038
27180	43256	98	applied	\N	\N	\N	\N	133047	133047	133048
27180	43259	99	applied	\N	\N	\N	\N	133054	133054	133055
27180	43262	100	applied	\N	\N	\N	\N	133062	133062	133063
27180	43265	101	applied	\N	\N	\N	\N	133072	133072	133073
27180	43269	102	applied	\N	\N	\N	\N	133087	133087	133088
27180	43272	103	applied	\N	\N	\N	\N	133102	133102	133103
27180	43273	104	applied	\N	\N	\N	\N	133104	133104	133105
27180	43279	105	applied	\N	\N	\N	\N	133119	133119	133120
27180	43280	106	applied	\N	\N	\N	\N	133121	133121	133122
27180	43284	107	applied	\N	\N	\N	\N	133132	133132	133133
27180	43287	108	applied	\N	\N	\N	\N	133138	133138	133139
27180	43290	109	applied	\N	\N	\N	\N	133144	133144	133145
27180	43293	110	applied	\N	\N	\N	\N	133184	133184	133185
27180	43296	111	applied	\N	\N	\N	\N	133192	133192	133193
27180	43301	112	applied	\N	\N	\N	\N	133216	133216	133217
27180	43302	113	applied	\N	\N	\N	\N	133218	133218	133219
27180	43303	114	applied	\N	\N	\N	\N	133220	133220	133221
27180	43308	115	applied	\N	\N	\N	\N	133232	133232	133233
27180	43309	116	applied	\N	\N	\N	\N	133234	133234	133235
27180	43310	117	applied	\N	\N	\N	\N	133236	133236	133237
27180	43317	118	applied	\N	\N	\N	\N	133251	133251	133252
27180	43318	119	applied	\N	\N	\N	\N	133253	133253	133254
27180	43323	120	applied	\N	\N	\N	\N	133264	133264	133265
27180	43326	121	applied	\N	\N	\N	\N	133273	133273	133274
27180	43331	122	applied	\N	\N	\N	\N	133286	133286	133287
27180	43334	123	applied	\N	\N	\N	\N	133294	133294	133295
27180	43335	124	applied	\N	\N	\N	\N	133296	133296	133297
27180	43340	125	applied	\N	\N	\N	\N	133308	133308	133309
27184	43723	0	applied	\N	\N	\N	\N	134481	134481	134482
27184	43724	2	applied	\N	\N	\N	\N	134484	134484	134485
27184	43725	3	applied	\N	\N	\N	\N	134486	134486	134487
27184	43726	4	applied	\N	\N	\N	\N	134488	134488	134489
27184	43727	5	applied	\N	\N	\N	\N	134490	134490	134491
27184	43728	6	applied	\N	\N	\N	\N	134492	134492	134493
27185	43729	0	applied	\N	\N	\N	\N	134500	134500	134501
27185	43730	1	applied	\N	\N	\N	\N	134502	134502	134503
27185	43731	2	applied	\N	\N	\N	\N	134504	134504	134505
27192	43735	0	applied	\N	\N	\N	\N	134523	134523	134524
27192	43736	1	applied	\N	\N	\N	\N	134525	134525	134526
27192	43737	2	applied	\N	\N	\N	\N	134527	134527	134528
27193	43738	0	applied	\N	\N	\N	\N	134531	134531	134532
27193	43739	1	applied	\N	\N	\N	\N	134533	134533	134534
27193	43740	2	applied	\N	\N	\N	\N	134535	134535	134536
27193	43741	3	applied	\N	\N	\N	\N	134537	134537	134538
27193	43742	4	applied	\N	\N	\N	\N	134539	134539	134540
27193	43743	5	applied	\N	\N	\N	\N	134541	134541	134542
27196	43746	0	applied	\N	\N	\N	\N	134551	134551	134552
27196	43748	1	applied	\N	\N	\N	\N	134600	134600	134601
27196	43747	2	applied	\N	\N	\N	\N	134581	134581	134602
27196	43749	3	applied	\N	\N	\N	\N	134603	134603	134604
27196	43750	4	applied	\N	\N	\N	\N	134605	134605	134606
27196	43751	5	applied	\N	\N	\N	\N	134607	134607	134608
27197	43752	0	applied	\N	\N	\N	\N	134610	134610	134611
27197	43753	1	applied	\N	\N	\N	\N	134612	134612	134613
27197	43754	2	applied	\N	\N	\N	\N	134614	134614	134615
27199	43755	0	applied	\N	\N	\N	\N	134618	134618	134619
27199	43756	1	applied	\N	\N	\N	\N	134620	134620	134621
27199	43757	2	applied	\N	\N	1000000000	\N	134622	134622	134623
27199	43758	3	applied	\N	\N	\N	\N	134624	134624	134625
27199	43759	4	applied	\N	\N	1000000000	\N	134626	134626	134627
27201	43757	0	applied	\N	\N	1000000000	\N	134622	134622	134623
27201	43759	1	applied	\N	\N	1000000000	\N	134626	134626	134627
27204	43763	0	applied	\N	\N	\N	\N	134641	134641	134642
27204	43764	1	applied	\N	\N	\N	\N	134643	134643	134644
27204	43765	2	applied	\N	\N	\N	\N	134645	134645	134646
27204	43766	3	applied	\N	\N	1000000000	\N	134647	134647	134648
27204	43767	4	applied	\N	\N	\N	\N	134649	134649	134650
27204	43768	5	applied	\N	\N	\N	\N	134651	134651	134652
27204	43769	6	applied	\N	\N	\N	\N	134653	134653	134654
27216	43748	0	applied	\N	\N	\N	\N	134600	134600	134601
27216	43752	1	applied	\N	\N	\N	\N	134610	134610	134611
27216	43755	2	applied	\N	\N	\N	\N	134618	134618	134619
27216	43760	3	applied	\N	\N	\N	\N	134634	134634	134635
27216	43763	4	applied	\N	\N	\N	\N	134641	134641	134642
27216	43764	5	applied	\N	\N	\N	\N	134643	134643	134644
27216	43770	6	applied	\N	\N	\N	\N	134659	134659	134660
27216	43773	7	applied	\N	\N	\N	\N	134669	134669	134670
27216	43774	8	applied	\N	\N	\N	\N	134671	134671	134672
27216	43778	9	applied	\N	\N	\N	\N	134681	134681	134682
27216	43781	10	applied	\N	\N	\N	\N	134689	134689	134690
27216	43784	11	applied	\N	\N	\N	\N	134696	134696	134697
27216	43785	12	applied	\N	\N	\N	\N	134698	134698	134699
27216	43786	13	applied	\N	\N	\N	\N	134700	134700	134701
27216	43787	14	applied	\N	\N	\N	\N	134702	134702	134703
27216	43788	15	applied	\N	\N	\N	\N	134704	134704	134705
27216	43789	16	applied	\N	\N	\N	\N	134712	134712	134713
27216	43790	17	applied	\N	\N	\N	\N	134714	134714	134715
27216	43805	18	applied	\N	\N	\N	\N	134748	134748	134749
27216	43806	19	applied	\N	\N	\N	\N	134750	134750	134751
27216	43757	20	applied	\N	\N	1000000000	\N	134622	134622	134623
27216	43759	21	applied	\N	\N	1000000000	\N	134626	134626	134627
27216	43766	22	applied	\N	\N	1000000000	\N	134647	134647	134648
27216	43751	23	applied	\N	\N	\N	\N	134607	134607	134540
27216	43754	24	applied	\N	\N	\N	\N	134614	134614	134542
27216	43756	25	applied	\N	\N	\N	\N	134620	134620	134548
27216	43762	26	applied	\N	\N	\N	\N	134638	134638	134602
27216	43765	27	applied	\N	\N	\N	\N	134645	134645	134752
27216	43769	28	applied	\N	\N	\N	\N	134653	134653	134753
27216	43772	29	applied	\N	\N	\N	\N	134663	134663	134613
27216	43775	30	applied	\N	\N	\N	\N	134673	134673	134615
27216	43728	31	applied	\N	\N	\N	\N	134492	134492	134754
27216	43731	32	applied	\N	\N	\N	\N	134504	134504	134755
27216	43733	33	applied	\N	\N	\N	\N	134510	134510	134756
27216	43737	34	applied	\N	\N	\N	\N	134527	134527	134757
27216	43740	35	applied	\N	\N	\N	\N	134535	134535	134639
27216	43741	37	applied	\N	\N	\N	\N	134537	134537	134759
27216	43749	38	applied	\N	\N	\N	\N	134603	134603	134760
27216	43750	39	applied	\N	\N	\N	\N	134605	134605	134761
27216	43753	40	applied	\N	\N	\N	\N	134612	134612	134762
27216	43758	41	applied	\N	\N	\N	\N	134624	134624	134654
27216	43761	42	applied	\N	\N	\N	\N	134636	134636	134662
27216	43767	43	applied	\N	\N	\N	\N	134649	134649	134763
27216	43768	44	applied	\N	\N	\N	\N	134651	134651	134764
27216	43771	45	applied	\N	\N	\N	\N	134661	134661	134674
27216	43776	46	applied	\N	\N	\N	\N	134675	134675	134676
27216	43777	47	applied	\N	\N	\N	\N	134677	134677	134678
27195	43734	91	applied	\N	\N	\N	\N	134514	134514	134579
27195	43736	92	applied	\N	\N	\N	\N	134525	134525	134580
27195	43742	93	applied	\N	\N	\N	\N	134539	134539	134421
27195	43743	94	applied	\N	\N	\N	\N	134541	134541	134423
27195	43745	95	applied	\N	\N	\N	\N	134547	134547	134429
27195	43747	96	applied	\N	\N	\N	\N	134581	134581	134582
27195	43642	97	applied	\N	\N	\N	\N	134262	134262	134583
27195	43643	98	applied	\N	\N	\N	\N	134264	134264	134439
27195	43644	99	applied	\N	\N	\N	\N	134274	134274	134584
27195	43651	100	applied	\N	\N	\N	\N	134294	134294	134585
27195	43654	101	applied	\N	\N	\N	\N	134308	134308	134449
27195	43657	102	applied	\N	\N	\N	\N	134316	134316	134451
27195	43658	103	applied	\N	\N	\N	\N	134318	134318	134453
27195	43663	104	applied	\N	\N	\N	\N	134332	134332	134586
27195	43667	105	applied	\N	\N	\N	\N	134340	134340	134587
27195	43668	106	applied	\N	\N	\N	\N	134342	134342	134588
27195	43672	107	applied	\N	\N	\N	\N	134350	134350	134589
27195	43675	108	applied	\N	\N	\N	\N	134358	134358	134465
27195	43677	109	applied	\N	\N	\N	\N	134363	134363	134476
27195	43681	110	applied	\N	\N	\N	\N	134375	134375	134590
27195	43683	111	applied	\N	\N	\N	\N	134381	134381	134591
27195	43688	112	applied	\N	\N	\N	\N	134393	134393	134592
27195	43689	113	applied	\N	\N	\N	\N	134395	134395	134489
27195	43692	114	applied	\N	\N	\N	\N	134403	134403	134593
27195	43695	115	applied	\N	\N	\N	\N	134409	134409	134594
27195	43697	116	applied	\N	\N	\N	\N	134414	134414	134595
27195	43700	117	applied	\N	\N	\N	\N	134420	134420	134503
27195	43704	118	applied	\N	\N	\N	\N	134430	134430	134505
27195	43706	119	applied	\N	\N	\N	\N	134436	134436	134511
27195	43712	120	applied	\N	\N	\N	\N	134450	134450	134596
27195	43713	121	applied	\N	\N	\N	\N	134452	134452	134597
27195	43717	122	applied	\N	\N	\N	\N	134460	134460	134526
27195	43718	123	applied	\N	\N	\N	\N	134462	134462	134528
27195	43721	124	applied	\N	\N	\N	\N	134475	134475	134536
27195	43725	125	applied	\N	\N	\N	\N	134486	134486	134538
27209	43778	0	applied	\N	\N	\N	\N	134681	134681	134682
27209	43779	1	applied	\N	\N	\N	\N	134683	134683	134684
27209	43780	2	applied	\N	\N	\N	\N	134685	134685	134686
27214	43784	0	applied	\N	\N	\N	\N	134696	134696	134697
27214	43785	1	applied	\N	\N	\N	\N	134698	134698	134699
27214	43786	2	applied	\N	\N	\N	\N	134700	134700	134701
27214	43787	3	applied	\N	\N	\N	\N	134702	134702	134703
27214	43788	4	applied	\N	\N	\N	\N	134704	134704	134705
27214	43789	5	applied	\N	\N	\N	\N	134712	134712	134713
27214	43790	6	applied	\N	\N	\N	\N	134714	134714	134715
27214	43791	7	applied	\N	\N	\N	\N	134716	134716	134717
27214	43792	8	applied	\N	\N	\N	\N	134718	134718	134719
27214	43793	9	applied	\N	\N	\N	\N	134720	134720	134721
27214	43794	10	applied	\N	\N	\N	\N	134722	134722	134723
27214	43795	11	applied	\N	\N	\N	\N	134724	134724	134725
27214	43796	12	applied	\N	\N	\N	\N	134726	134726	134727
27214	43797	13	applied	\N	\N	\N	\N	134728	134728	134729
27214	43798	14	applied	\N	\N	\N	\N	134730	134730	134731
27214	43799	15	applied	\N	\N	\N	\N	134732	134732	134733
27214	43800	16	applied	\N	\N	\N	\N	134734	134734	134735
27214	43801	17	applied	\N	\N	\N	\N	134736	134736	134737
27214	43802	18	applied	\N	\N	\N	\N	134738	134738	134739
27214	43803	19	applied	\N	\N	\N	\N	134740	134740	134741
27214	43804	20	applied	\N	\N	\N	\N	134742	134742	134743
27219	43805	0	applied	\N	\N	\N	\N	134748	134748	134749
27219	43806	1	applied	\N	\N	\N	\N	134750	134750	134751
27219	43811	2	applied	\N	\N	\N	\N	134781	134781	134782
27219	43807	3	applied	\N	\N	\N	\N	134768	134768	134783
27219	43808	4	applied	\N	\N	\N	\N	134770	134770	134773
27219	43812	5	applied	\N	\N	\N	\N	134784	134784	134785
27219	43809	6	applied	\N	\N	\N	\N	134774	134774	134786
27219	43810	7	applied	\N	\N	\N	\N	134776	134776	134787
27219	43813	8	applied	\N	\N	\N	\N	134788	134788	134789
27223	43817	0	applied	\N	\N	\N	\N	134806	134806	134807
27223	43818	1	applied	\N	\N	\N	\N	134808	134808	134809
27223	43819	2	applied	\N	\N	\N	\N	134810	134810	134811
27230	43826	0	applied	\N	\N	\N	\N	134840	134840	134841
27230	43827	1	applied	\N	\N	\N	\N	134842	134842	134843
27230	43828	2	applied	\N	\N	\N	\N	134844	134844	134845
27237	43832	0	applied	\N	\N	\N	\N	134858	134858	134859
27237	43834	1	applied	\N	\N	\N	\N	134862	134862	134865
27246	43757	0	applied	\N	\N	1000000000	\N	134622	134622	134623
27249	43855	0	applied	\N	\N	\N	\N	134922	134922	134923
27249	43856	1	applied	\N	\N	\N	\N	134924	134924	134925
27249	43857	2	applied	\N	\N	\N	\N	134926	134926	134927
27253	43858	0	applied	\N	\N	\N	\N	134946	134946	134947
27253	43859	1	applied	\N	\N	\N	\N	134948	134948	134949
27253	43860	2	applied	\N	\N	\N	\N	134950	134950	134951
27255	43864	0	applied	\N	\N	\N	\N	134963	134963	134964
27255	43865	1	applied	\N	\N	\N	\N	134965	134965	134966
27255	43866	2	applied	\N	\N	\N	\N	134967	134967	134968
27263	43870	0	applied	\N	\N	\N	\N	134981	134981	134982
27263	43871	1	applied	\N	\N	\N	\N	134983	134983	134984
27268	43873	0	applied	\N	\N	\N	\N	134994	134994	134995
27268	43874	1	applied	\N	\N	\N	\N	134996	134996	134997
27268	43875	2	applied	\N	\N	\N	\N	134998	134998	134999
27273	43876	0	applied	\N	\N	\N	\N	135047	135047	135048
27273	43877	1	applied	\N	\N	\N	\N	135049	135049	135050
27273	43878	2	applied	\N	\N	\N	\N	135051	135051	135052
27273	43879	3	applied	\N	\N	\N	\N	135053	135053	135054
27273	43880	4	applied	\N	\N	\N	\N	135055	135055	135056
27273	43881	5	applied	\N	\N	\N	\N	135057	135057	135058
27276	43882	0	applied	\N	\N	\N	\N	135062	135062	135063
27276	43883	1	applied	\N	\N	\N	\N	135064	135064	135065
27276	43884	2	applied	\N	\N	\N	\N	135066	135066	135067
27278	43885	0	applied	\N	\N	\N	\N	135070	135070	135071
27278	43886	1	applied	\N	\N	\N	\N	135072	135072	135073
27278	43887	2	applied	\N	\N	\N	\N	135074	135074	135075
27283	43874	0	applied	\N	\N	\N	\N	134996	134996	134783
27283	43878	1	applied	\N	\N	\N	\N	135051	135051	135111
27283	43879	2	applied	\N	\N	\N	\N	135053	135053	135112
27283	43883	3	applied	\N	\N	\N	\N	135064	135064	134785
27283	43886	4	applied	\N	\N	\N	\N	135072	135072	134786
27283	43890	5	applied	\N	\N	\N	\N	135082	135082	134787
27283	43896	6	applied	\N	\N	\N	\N	135096	135096	134789
27283	43898	7	applied	\N	\N	\N	\N	135100	135100	135113
27283	43899	8	applied	\N	\N	\N	\N	135102	135102	135114
27283	43900	9	applied	\N	\N	\N	\N	135106	135106	135115
27286	43907	0	applied	\N	\N	\N	\N	135141	135141	135142
27286	43908	1	applied	\N	\N	\N	\N	135143	135143	135144
27290	43909	0	applied	\N	\N	\N	\N	135151	135151	135152
27290	43910	1	applied	\N	\N	\N	\N	135153	135153	135154
27291	43909	0	applied	\N	\N	\N	\N	135151	135151	135152
27291	43910	1	applied	\N	\N	\N	\N	135153	135153	135154
27293	43911	0	applied	\N	\N	\N	\N	135159	135159	135160
27202	43761	1	applied	\N	\N	\N	\N	134636	134636	134637
27202	43762	2	applied	\N	\N	\N	\N	134638	134638	134639
27205	43770	0	applied	\N	\N	\N	\N	134659	134659	134660
27205	43771	1	applied	\N	\N	\N	\N	134661	134661	134662
27205	43772	2	applied	\N	\N	\N	\N	134663	134663	134664
27207	43773	0	applied	\N	\N	\N	\N	134669	134669	134670
27207	43774	1	applied	\N	\N	\N	\N	134671	134671	134672
27207	43775	2	applied	\N	\N	\N	\N	134673	134673	134674
27207	43776	3	applied	\N	\N	\N	\N	134675	134675	134676
27207	43777	4	applied	\N	\N	\N	\N	134677	134677	134678
27210	43778	0	applied	\N	\N	\N	\N	134681	134681	134682
27210	43779	1	applied	\N	\N	\N	\N	134683	134683	134684
27210	43780	2	applied	\N	\N	\N	\N	134685	134685	134686
27213	43562	0	applied	\N	\N	\N	\N	134013	134013	134014
27213	43565	1	applied	\N	\N	\N	\N	134059	134059	134060
27213	43567	2	applied	\N	\N	\N	\N	134067	134067	134068
27213	43570	3	applied	\N	\N	\N	\N	134075	134075	134076
27213	43573	4	applied	\N	\N	\N	\N	134083	134083	134084
27213	43576	5	applied	\N	\N	\N	\N	134090	134090	134091
27213	43579	6	applied	\N	\N	\N	\N	134098	134098	134099
27213	43582	7	applied	\N	\N	\N	\N	134108	134108	134109
27213	43583	8	applied	\N	\N	\N	\N	134110	134110	134111
27213	43588	9	applied	\N	\N	\N	\N	134121	134121	134122
27213	43593	10	applied	\N	\N	\N	\N	134134	134134	134135
27213	43596	11	applied	\N	\N	\N	\N	134140	134140	134141
27213	43599	12	applied	\N	\N	\N	\N	134147	134147	134148
27213	43602	13	applied	\N	\N	\N	\N	134155	134155	134156
27213	43605	14	applied	\N	\N	\N	\N	134163	134163	134164
27213	43608	15	applied	\N	\N	\N	\N	134172	134172	134173
27213	43609	16	applied	\N	\N	\N	\N	134174	134174	134175
27213	43610	17	applied	\N	\N	\N	\N	134176	134176	134177
27213	43617	18	applied	\N	\N	\N	\N	134192	134192	134193
27213	43620	19	applied	\N	\N	\N	\N	134203	134203	134204
27213	43623	20	applied	\N	\N	\N	\N	134212	134212	134213
27213	43626	21	applied	\N	\N	\N	\N	134222	134222	134223
27213	43629	22	applied	\N	\N	\N	\N	134229	134229	134230
27213	43630	23	applied	\N	\N	\N	\N	134231	134231	134232
27213	43631	24	applied	\N	\N	\N	\N	134233	134233	134234
27213	43637	25	applied	\N	\N	\N	\N	134248	134248	134249
27213	43646	26	applied	\N	\N	\N	\N	134280	134280	134281
27213	43647	27	applied	\N	\N	\N	\N	134283	134283	134284
27213	43648	28	applied	\N	\N	\N	\N	134285	134285	134286
27213	43649	29	applied	\N	\N	\N	\N	134287	134287	134288
27213	43652	30	applied	\N	\N	\N	\N	134304	134304	134305
27213	43655	31	applied	\N	\N	\N	\N	134312	134312	134313
27213	43656	32	applied	\N	\N	\N	\N	134314	134314	134315
27213	43661	33	applied	\N	\N	\N	\N	134328	134328	134329
27213	43664	34	applied	\N	\N	\N	\N	134334	134334	134335
27213	43665	35	applied	\N	\N	\N	\N	134336	134336	134337
27213	43666	36	applied	\N	\N	\N	\N	134338	134338	134339
27213	43673	37	applied	\N	\N	\N	\N	134354	134354	134355
27213	43676	38	applied	\N	\N	\N	\N	134361	134361	134362
27213	43679	39	applied	\N	\N	\N	\N	134371	134371	134372
27213	43682	40	applied	\N	\N	\N	\N	134379	134379	134380
27213	43685	41	applied	\N	\N	\N	\N	134387	134387	134388
27213	43686	42	applied	\N	\N	\N	\N	134389	134389	134390
27213	43690	43	applied	\N	\N	\N	\N	134399	134399	134400
27213	43693	44	applied	\N	\N	\N	\N	134405	134405	134406
27213	43696	45	applied	\N	\N	\N	\N	134412	134412	134413
27213	43699	46	applied	\N	\N	\N	\N	134418	134418	134419
27213	43702	47	applied	\N	\N	\N	\N	134426	134426	134427
27213	43705	48	applied	\N	\N	\N	\N	134434	134434	134435
27213	43708	49	applied	\N	\N	\N	\N	134442	134442	134443
27213	43709	50	applied	\N	\N	\N	\N	134444	134444	134445
27213	43714	51	applied	\N	\N	\N	\N	134454	134454	134455
27213	43715	52	applied	\N	\N	\N	\N	134456	134456	134457
27213	43720	53	applied	\N	\N	\N	\N	134473	134473	134474
27213	43723	54	applied	\N	\N	\N	\N	134481	134481	134482
27213	43724	55	applied	\N	\N	\N	\N	134484	134484	134485
27213	43729	56	applied	\N	\N	\N	\N	134500	134500	134501
27213	43732	57	applied	\N	\N	\N	\N	134508	134508	134509
27213	43735	59	applied	\N	\N	\N	\N	134523	134523	134524
27213	43738	60	applied	\N	\N	\N	\N	134531	134531	134532
27213	43739	61	applied	\N	\N	\N	\N	134533	134533	134534
27213	43744	62	applied	\N	\N	\N	\N	134545	134545	134546
27213	43746	63	applied	\N	\N	\N	\N	134551	134551	134552
27213	43748	64	applied	\N	\N	\N	\N	134600	134600	134601
27213	43752	65	applied	\N	\N	\N	\N	134610	134610	134611
27213	43755	66	applied	\N	\N	\N	\N	134618	134618	134619
27213	43760	67	applied	\N	\N	\N	\N	134634	134634	134635
27213	43763	68	applied	\N	\N	\N	\N	134641	134641	134642
27213	43764	69	applied	\N	\N	\N	\N	134643	134643	134644
27213	43770	70	applied	\N	\N	\N	\N	134659	134659	134660
27213	43773	71	applied	\N	\N	\N	\N	134669	134669	134670
27213	43774	72	applied	\N	\N	\N	\N	134671	134671	134672
27213	43778	73	applied	\N	\N	\N	\N	134681	134681	134682
27213	43781	74	applied	\N	\N	\N	\N	134689	134689	134690
27213	43784	75	applied	\N	\N	\N	\N	134696	134696	134697
27213	43785	76	applied	\N	\N	\N	\N	134698	134698	134699
27213	43786	77	applied	\N	\N	\N	\N	134700	134700	134701
27213	43787	78	applied	\N	\N	\N	\N	134702	134702	134703
27213	43788	79	applied	\N	\N	\N	\N	134704	134704	134705
27213	43757	80	applied	\N	\N	1000000000	\N	134622	134622	134623
27213	43759	81	applied	\N	\N	1000000000	\N	134626	134626	134627
27213	43766	82	applied	\N	\N	1000000000	\N	134647	134647	134648
27213	43255	83	applied	\N	\N	\N	\N	133041	133041	133269
27213	43258	84	applied	\N	\N	\N	\N	133051	133051	134706
27213	43260	85	applied	\N	\N	\N	\N	133056	133056	134707
27213	43264	86	applied	\N	\N	\N	\N	133066	133066	134708
27213	43267	87	applied	\N	\N	\N	\N	133076	133076	133289
27213	43270	88	applied	\N	\N	\N	\N	133089	133089	133291
27213	43275	89	applied	\N	\N	\N	\N	133107	133107	133299
27215	43784	0	applied	\N	\N	\N	\N	134696	134696	134697
27215	43785	1	applied	\N	\N	\N	\N	134698	134698	134699
27215	43786	2	applied	\N	\N	\N	\N	134700	134700	134701
27215	43787	3	applied	\N	\N	\N	\N	134702	134702	134703
27215	43788	4	applied	\N	\N	\N	\N	134704	134704	134705
27215	43789	5	applied	\N	\N	\N	\N	134712	134712	134713
27215	43790	6	applied	\N	\N	\N	\N	134714	134714	134715
27215	43791	7	applied	\N	\N	\N	\N	134716	134716	134717
27215	43792	8	applied	\N	\N	\N	\N	134718	134718	134719
27215	43793	9	applied	\N	\N	\N	\N	134720	134720	134721
27215	43794	10	applied	\N	\N	\N	\N	134722	134722	134723
27215	43795	11	applied	\N	\N	\N	\N	134724	134724	134725
27215	43796	12	applied	\N	\N	\N	\N	134726	134726	134727
27215	43797	13	applied	\N	\N	\N	\N	134728	134728	134729
27215	43798	14	applied	\N	\N	\N	\N	134730	134730	134731
27215	43799	15	applied	\N	\N	\N	\N	134732	134732	134733
27215	43800	16	applied	\N	\N	\N	\N	134734	134734	134735
27212	43783	2	applied	\N	\N	\N	\N	134693	134693	134694
27218	43805	0	applied	\N	\N	\N	\N	134748	134748	134749
27218	43806	1	applied	\N	\N	\N	\N	134750	134750	134751
27218	43811	2	applied	\N	\N	\N	\N	134781	134781	134782
27218	43807	3	applied	\N	\N	\N	\N	134768	134768	134783
27218	43808	4	applied	\N	\N	\N	\N	134770	134770	134773
27218	43812	5	applied	\N	\N	\N	\N	134784	134784	134785
27218	43809	6	applied	\N	\N	\N	\N	134774	134774	134786
27218	43810	7	applied	\N	\N	\N	\N	134776	134776	134787
27218	43813	8	applied	\N	\N	\N	\N	134788	134788	134789
27220	43814	0	applied	\N	\N	\N	\N	134796	134796	134797
27220	43815	1	applied	\N	\N	\N	\N	134798	134798	134799
27220	43816	2	applied	\N	\N	\N	\N	134800	134800	134801
27225	43817	0	applied	\N	\N	\N	\N	134806	134806	134807
27225	43818	1	applied	\N	\N	\N	\N	134808	134808	134809
27225	43819	2	applied	\N	\N	\N	\N	134810	134810	134811
27226	43817	0	applied	\N	\N	\N	\N	134806	134806	134807
27226	43818	1	applied	\N	\N	\N	\N	134808	134808	134809
27226	43819	2	applied	\N	\N	\N	\N	134810	134810	134811
27231	43829	0	applied	\N	\N	\N	\N	134846	134846	134847
27231	43830	1	applied	\N	\N	\N	\N	134848	134848	134849
27231	43831	2	applied	\N	\N	\N	\N	134850	134850	134851
27240	43844	0	applied	\N	\N	\N	\N	134887	134887	134888
27240	43845	1	applied	\N	\N	\N	\N	134889	134889	134890
27243	43848	0	applied	\N	\N	\N	\N	134899	134899	134900
27243	43849	1	applied	\N	\N	\N	\N	134901	134901	134902
27243	43850	2	applied	\N	\N	\N	\N	134903	134903	134904
27243	43851	3	applied	\N	\N	1000000000	\N	134905	134905	134906
27245	43852	0	applied	\N	\N	\N	\N	134912	134912	134913
27245	43853	1	applied	\N	\N	\N	\N	134914	134914	134915
27245	43854	2	applied	\N	\N	\N	\N	134916	134916	134917
27247	43855	0	applied	\N	\N	\N	\N	134922	134922	134923
27247	43856	1	applied	\N	\N	\N	\N	134924	134924	134925
27247	43857	2	applied	\N	\N	\N	\N	134926	134926	134927
27250	43855	0	applied	\N	\N	\N	\N	134922	134922	134923
27250	43856	1	applied	\N	\N	\N	\N	134924	134924	134925
27250	43857	2	applied	\N	\N	\N	\N	134926	134926	134927
27251	43588	0	applied	\N	\N	\N	\N	134121	134121	134122
27251	43593	1	applied	\N	\N	\N	\N	134134	134134	134135
27251	43596	2	applied	\N	\N	\N	\N	134140	134140	134141
27251	43599	3	applied	\N	\N	\N	\N	134147	134147	134148
27251	43602	4	applied	\N	\N	\N	\N	134155	134155	134156
27251	43605	5	applied	\N	\N	\N	\N	134163	134163	134164
27251	43608	6	applied	\N	\N	\N	\N	134172	134172	134173
27251	43609	7	applied	\N	\N	\N	\N	134174	134174	134175
27251	43610	8	applied	\N	\N	\N	\N	134176	134176	134177
27251	43617	9	applied	\N	\N	\N	\N	134192	134192	134193
27251	43620	10	applied	\N	\N	\N	\N	134203	134203	134204
27251	43623	11	applied	\N	\N	\N	\N	134212	134212	134213
27251	43626	12	applied	\N	\N	\N	\N	134222	134222	134223
27251	43629	13	applied	\N	\N	\N	\N	134229	134229	134230
27251	43630	14	applied	\N	\N	\N	\N	134231	134231	134232
27251	43631	15	applied	\N	\N	\N	\N	134233	134233	134234
27251	43637	16	applied	\N	\N	\N	\N	134248	134248	134249
27251	43646	17	applied	\N	\N	\N	\N	134280	134280	134281
27251	43647	18	applied	\N	\N	\N	\N	134283	134283	134284
27251	43648	19	applied	\N	\N	\N	\N	134285	134285	134286
27251	43649	20	applied	\N	\N	\N	\N	134287	134287	134288
27251	43652	21	applied	\N	\N	\N	\N	134304	134304	134305
27251	43655	22	applied	\N	\N	\N	\N	134312	134312	134313
27251	43656	23	applied	\N	\N	\N	\N	134314	134314	134315
27251	43661	24	applied	\N	\N	\N	\N	134328	134328	134329
27251	43664	25	applied	\N	\N	\N	\N	134334	134334	134335
27251	43665	26	applied	\N	\N	\N	\N	134336	134336	134337
27251	43666	27	applied	\N	\N	\N	\N	134338	134338	134339
27251	43673	28	applied	\N	\N	\N	\N	134354	134354	134355
27251	43676	29	applied	\N	\N	\N	\N	134361	134361	134362
27251	43679	30	applied	\N	\N	\N	\N	134371	134371	134372
27251	43682	31	applied	\N	\N	\N	\N	134379	134379	134380
27251	43685	32	applied	\N	\N	\N	\N	134387	134387	134388
27251	43686	33	applied	\N	\N	\N	\N	134389	134389	134390
27251	43690	34	applied	\N	\N	\N	\N	134399	134399	134400
27251	43693	35	applied	\N	\N	\N	\N	134405	134405	134406
27251	43696	36	applied	\N	\N	\N	\N	134412	134412	134413
27251	43699	37	applied	\N	\N	\N	\N	134418	134418	134419
27251	43702	38	applied	\N	\N	\N	\N	134426	134426	134427
27251	43705	39	applied	\N	\N	\N	\N	134434	134434	134435
27251	43708	40	applied	\N	\N	\N	\N	134442	134442	134443
27251	43709	41	applied	\N	\N	\N	\N	134444	134444	134445
27251	43714	42	applied	\N	\N	\N	\N	134454	134454	134455
27251	43715	43	applied	\N	\N	\N	\N	134456	134456	134457
27251	43720	44	applied	\N	\N	\N	\N	134473	134473	134474
27251	43723	45	applied	\N	\N	\N	\N	134481	134481	134482
27251	43724	46	applied	\N	\N	\N	\N	134484	134484	134485
27251	43729	47	applied	\N	\N	\N	\N	134500	134500	134501
27251	43732	48	applied	\N	\N	\N	\N	134508	134508	134509
27251	43735	49	applied	\N	\N	\N	\N	134523	134523	134524
27251	43738	50	applied	\N	\N	\N	\N	134531	134531	134532
27251	43739	51	applied	\N	\N	\N	\N	134533	134533	134534
27251	43744	52	applied	\N	\N	\N	\N	134545	134545	134546
27251	43746	53	applied	\N	\N	\N	\N	134551	134551	134552
27251	43748	54	applied	\N	\N	\N	\N	134600	134600	134601
27251	43752	55	applied	\N	\N	\N	\N	134610	134610	134611
27251	43755	56	applied	\N	\N	\N	\N	134618	134618	134619
27251	43760	57	applied	\N	\N	\N	\N	134634	134634	134635
27251	43763	58	applied	\N	\N	\N	\N	134641	134641	134642
27251	43764	59	applied	\N	\N	\N	\N	134643	134643	134644
27251	43770	60	applied	\N	\N	\N	\N	134659	134659	134660
27251	43773	61	applied	\N	\N	\N	\N	134669	134669	134670
27251	43774	62	applied	\N	\N	\N	\N	134671	134671	134672
27251	43778	63	applied	\N	\N	\N	\N	134681	134681	134682
27251	43781	64	applied	\N	\N	\N	\N	134689	134689	134690
27251	43784	65	applied	\N	\N	\N	\N	134696	134696	134697
27251	43785	66	applied	\N	\N	\N	\N	134698	134698	134699
27251	43786	67	applied	\N	\N	\N	\N	134700	134700	134701
27251	43787	68	applied	\N	\N	\N	\N	134702	134702	134703
27251	43788	69	applied	\N	\N	\N	\N	134704	134704	134705
27251	43789	70	applied	\N	\N	\N	\N	134712	134712	134713
27251	43790	71	applied	\N	\N	\N	\N	134714	134714	134715
27251	43805	72	applied	\N	\N	\N	\N	134748	134748	134749
27251	43806	73	applied	\N	\N	\N	\N	134750	134750	134751
27251	43811	74	applied	\N	\N	\N	\N	134781	134781	134782
27251	43814	75	applied	\N	\N	\N	\N	134796	134796	134797
27251	43817	76	applied	\N	\N	\N	\N	134806	134806	134807
27251	43820	77	applied	\N	\N	\N	\N	134824	134824	134825
27251	43821	78	applied	\N	\N	\N	\N	134826	134826	134827
27251	43826	80	applied	\N	\N	\N	\N	134840	134840	134841
27251	43829	81	applied	\N	\N	\N	\N	134846	134846	134847
27251	43832	82	applied	\N	\N	\N	\N	134858	134858	134859
27251	43835	83	applied	\N	\N	\N	\N	134868	134868	134869
27215	43801	17	applied	\N	\N	\N	\N	134736	134736	134737
27215	43802	18	applied	\N	\N	\N	\N	134738	134738	134739
27215	43803	19	applied	\N	\N	\N	\N	134740	134740	134741
27215	43804	20	applied	\N	\N	\N	\N	134742	134742	134743
27217	43805	0	applied	\N	\N	\N	\N	134748	134748	134749
27217	43806	1	applied	\N	\N	\N	\N	134750	134750	134751
27217	43811	2	applied	\N	\N	\N	\N	134781	134781	134782
27217	43807	3	applied	\N	\N	\N	\N	134768	134768	134783
27217	43808	4	applied	\N	\N	\N	\N	134770	134770	134773
27217	43812	5	applied	\N	\N	\N	\N	134784	134784	134785
27217	43809	6	applied	\N	\N	\N	\N	134774	134774	134786
27217	43810	7	applied	\N	\N	\N	\N	134776	134776	134787
27217	43813	8	applied	\N	\N	\N	\N	134788	134788	134789
27222	43814	0	applied	\N	\N	\N	\N	134796	134796	134797
27222	43815	1	applied	\N	\N	\N	\N	134798	134798	134799
27222	43816	2	applied	\N	\N	\N	\N	134800	134800	134801
27224	43817	0	applied	\N	\N	\N	\N	134806	134806	134807
27224	43818	1	applied	\N	\N	\N	\N	134808	134808	134809
27224	43819	2	applied	\N	\N	\N	\N	134810	134810	134811
27228	43820	0	applied	\N	\N	\N	\N	134824	134824	134825
27228	43821	1	applied	\N	\N	\N	\N	134826	134826	134827
27228	43822	2	applied	\N	\N	\N	\N	134828	134828	134829
27228	43823	3	applied	\N	\N	\N	\N	134830	134830	134831
27228	43824	4	applied	\N	\N	\N	\N	134832	134832	134833
27228	43825	5	applied	\N	\N	\N	\N	134834	134834	134835
27229	43820	0	applied	\N	\N	\N	\N	134824	134824	134825
27229	43821	1	applied	\N	\N	\N	\N	134826	134826	134827
27229	43822	2	applied	\N	\N	\N	\N	134828	134828	134829
27229	43823	3	applied	\N	\N	\N	\N	134830	134830	134831
27229	43824	4	applied	\N	\N	\N	\N	134832	134832	134833
27229	43825	5	applied	\N	\N	\N	\N	134834	134834	134835
27233	43829	0	applied	\N	\N	\N	\N	134846	134846	134847
27233	43830	1	applied	\N	\N	\N	\N	134848	134848	134849
27233	43831	2	applied	\N	\N	\N	\N	134850	134850	134851
27235	43829	0	applied	\N	\N	\N	\N	134846	134846	134847
27239	43835	0	applied	\N	\N	\N	\N	134868	134868	134869
27239	43836	1	applied	\N	\N	\N	\N	134870	134870	134871
27239	43837	2	applied	\N	\N	\N	\N	134872	134872	134873
27239	43838	3	applied	\N	\N	\N	\N	134874	134874	134875
27239	43839	4	applied	\N	\N	1000000000	\N	134876	134876	134877
27239	43840	5	applied	\N	\N	1000000000	\N	134878	134878	134879
27239	43841	6	applied	\N	\N	\N	\N	134880	134880	134881
27239	43842	7	applied	\N	\N	\N	\N	134882	134882	134883
27239	43843	8	applied	\N	\N	\N	\N	134884	134884	134885
27242	43848	0	applied	\N	\N	\N	\N	134899	134899	134900
27242	43849	1	applied	\N	\N	\N	\N	134901	134901	134902
27242	43850	2	applied	\N	\N	\N	\N	134903	134903	134904
27242	43851	3	applied	\N	\N	1000000000	\N	134905	134905	134906
27256	43864	0	applied	\N	\N	\N	\N	134963	134963	134964
27256	43865	1	applied	\N	\N	\N	\N	134965	134965	134966
27256	43866	2	applied	\N	\N	\N	\N	134967	134967	134968
27264	43870	0	applied	\N	\N	\N	\N	134981	134981	134982
27264	43871	1	applied	\N	\N	\N	\N	134983	134983	134984
27264	43872	2	applied	\N	\N	\N	\N	134987	134987	134988
27269	43664	0	applied	\N	\N	\N	\N	134334	134334	134335
27269	43665	1	applied	\N	\N	\N	\N	134336	134336	134337
27269	43666	2	applied	\N	\N	\N	\N	134338	134338	134339
27269	43667	3	applied	\N	\N	\N	\N	134340	134340	134341
27269	43668	4	applied	\N	\N	\N	\N	134342	134342	134343
27269	43669	5	applied	\N	\N	\N	\N	134344	134344	134345
27269	43670	6	applied	\N	\N	\N	\N	134346	134346	134347
27269	43671	7	applied	\N	\N	\N	\N	134348	134348	134349
27269	43674	8	applied	\N	\N	\N	\N	134356	134356	135001
27269	43678	9	applied	\N	\N	\N	\N	134365	134365	135002
27269	43680	10	applied	\N	\N	\N	\N	134373	134373	134364
27269	43684	11	applied	\N	\N	\N	\N	134383	134383	134366
27269	43687	12	applied	\N	\N	\N	\N	134391	134391	134374
27269	43691	13	applied	\N	\N	\N	\N	134401	134401	135003
27269	43694	14	applied	\N	\N	\N	\N	134407	134407	135004
27269	43698	15	applied	\N	\N	\N	\N	134416	134416	135005
27269	43701	16	applied	\N	\N	\N	\N	134422	134422	134394
27269	43703	17	applied	\N	\N	\N	\N	134428	134428	135006
27269	43707	18	applied	\N	\N	\N	\N	134438	134438	135007
27269	43710	19	applied	\N	\N	\N	\N	134446	134446	135008
27269	43711	20	applied	\N	\N	\N	\N	134448	134448	134410
27269	43716	21	applied	\N	\N	\N	\N	134458	134458	135009
27269	43719	22	applied	\N	\N	\N	\N	134464	134464	135010
27269	43722	23	applied	\N	\N	\N	\N	134477	134477	135011
27269	43726	24	applied	\N	\N	\N	\N	134488	134488	135012
27269	43727	25	applied	\N	\N	\N	\N	134490	134490	134431
27269	43730	26	applied	\N	\N	\N	\N	134502	134502	134583
27269	43734	27	applied	\N	\N	\N	\N	134514	134514	135013
27269	43736	28	applied	\N	\N	\N	\N	134525	134525	134585
27269	43742	29	applied	\N	\N	\N	\N	134539	134539	135014
27269	43743	30	applied	\N	\N	\N	\N	134541	134541	134453
27269	43745	31	applied	\N	\N	\N	\N	134547	134547	134459
27269	43747	32	applied	\N	\N	\N	\N	134581	134581	134588
27269	43751	33	applied	\N	\N	\N	\N	134607	134607	135015
27269	43754	34	applied	\N	\N	\N	\N	134614	134614	134476
27269	43672	35	applied	\N	\N	\N	\N	134350	134350	134590
27269	43675	36	applied	\N	\N	\N	\N	134358	134358	134591
27269	43677	37	applied	\N	\N	\N	\N	134363	134363	134592
27269	43681	38	applied	\N	\N	\N	\N	134375	134375	134489
27269	43683	39	applied	\N	\N	\N	\N	134381	134381	134593
27269	43688	40	applied	\N	\N	\N	\N	134393	134393	134594
27269	43689	41	applied	\N	\N	\N	\N	134395	134395	134595
27269	43692	42	applied	\N	\N	\N	\N	134403	134403	134503
27269	43695	43	applied	\N	\N	\N	\N	134409	134409	134505
27269	43697	44	applied	\N	\N	\N	\N	134414	134414	134511
27269	43700	45	applied	\N	\N	\N	\N	134420	134420	134596
27269	43704	46	applied	\N	\N	\N	\N	134430	134430	134597
27269	43706	47	applied	\N	\N	\N	\N	134436	134436	134526
27269	43712	48	applied	\N	\N	\N	\N	134450	134450	134528
27269	43713	49	applied	\N	\N	\N	\N	134452	134452	134536
27269	43717	50	applied	\N	\N	\N	\N	134460	134460	134538
27269	43718	51	applied	\N	\N	\N	\N	134462	134462	135016
27269	43721	52	applied	\N	\N	\N	\N	134475	134475	135017
27269	43725	53	applied	\N	\N	\N	\N	134486	134486	134542
27269	43728	54	applied	\N	\N	\N	\N	134492	134492	135018
27269	43731	55	applied	\N	\N	\N	\N	134504	134504	135019
27269	43733	56	applied	\N	\N	\N	\N	134510	134510	134602
27269	43737	57	applied	\N	\N	\N	\N	134527	134527	134604
27269	43740	58	applied	\N	\N	\N	\N	134535	134535	134606
27269	43741	59	applied	\N	\N	\N	\N	134537	134537	134753
27269	43749	60	applied	\N	\N	\N	\N	134603	134603	135020
27269	43750	61	applied	\N	\N	\N	\N	134605	134605	135021
27269	43753	62	applied	\N	\N	\N	\N	134612	134612	134615
27281	43891	0	applied	\N	\N	\N	\N	135086	135086	135087
27281	43892	1	applied	\N	\N	\N	\N	135088	135088	135089
27216	43779	48	applied	\N	\N	\N	\N	134683	134683	134684
27216	43783	49	applied	\N	\N	\N	\N	134693	134693	134765
27216	43791	50	applied	\N	\N	\N	\N	134716	134716	134766
27216	43780	51	applied	\N	\N	\N	\N	134685	134685	134767
27216	43782	52	applied	\N	\N	\N	\N	134691	134691	134717
27216	43792	53	applied	\N	\N	\N	\N	134718	134718	134719
27216	43793	54	applied	\N	\N	\N	\N	134720	134720	134721
27216	43794	55	applied	\N	\N	\N	\N	134722	134722	134723
27216	43795	56	applied	\N	\N	\N	\N	134724	134724	134725
27216	43796	57	applied	\N	\N	\N	\N	134726	134726	134727
27216	43797	58	applied	\N	\N	\N	\N	134728	134728	134729
27216	43798	59	applied	\N	\N	\N	\N	134730	134730	134731
27216	43807	60	applied	\N	\N	\N	\N	134768	134768	134769
27216	43808	61	applied	\N	\N	\N	\N	134770	134770	134737
27216	43799	62	applied	\N	\N	\N	\N	134732	134732	134739
27216	43800	63	applied	\N	\N	\N	\N	134734	134734	134741
27216	43801	64	applied	\N	\N	\N	\N	134736	134736	134743
27216	43802	65	applied	\N	\N	\N	\N	134738	134738	134771
27216	43803	66	applied	\N	\N	\N	\N	134740	134740	134772
27216	43804	67	applied	\N	\N	\N	\N	134742	134742	134773
27216	43809	68	applied	\N	\N	\N	\N	134774	134774	134775
27216	43810	69	applied	\N	\N	\N	\N	134776	134776	134777
27221	43814	0	applied	\N	\N	\N	\N	134796	134796	134797
27221	43815	1	applied	\N	\N	\N	\N	134798	134798	134799
27221	43816	2	applied	\N	\N	\N	\N	134800	134800	134801
27227	43817	0	applied	\N	\N	\N	\N	134806	134806	134807
27227	43818	1	applied	\N	\N	\N	\N	134808	134808	134809
27227	43819	2	applied	\N	\N	\N	\N	134810	134810	134811
27232	43829	0	applied	\N	\N	\N	\N	134846	134846	134847
27232	43830	1	applied	\N	\N	\N	\N	134848	134848	134849
27232	43831	2	applied	\N	\N	\N	\N	134850	134850	134851
27234	43829	0	applied	\N	\N	\N	\N	134846	134846	134847
27234	43830	1	applied	\N	\N	\N	\N	134848	134848	134849
27234	43831	2	applied	\N	\N	\N	\N	134850	134850	134851
27236	43832	0	applied	\N	\N	\N	\N	134858	134858	134859
27236	43833	1	applied	\N	\N	\N	\N	134860	134860	134861
27236	43834	2	applied	\N	\N	\N	\N	134862	134862	134863
27241	43846	0	applied	\N	\N	\N	\N	134893	134893	134894
27241	43847	1	applied	\N	\N	\N	\N	134895	134895	134896
27244	43848	0	applied	\N	\N	\N	\N	134899	134899	134900
27244	43849	1	applied	\N	\N	\N	\N	134901	134901	134902
27244	43850	2	applied	\N	\N	\N	\N	134903	134903	134904
27244	43851	3	applied	\N	\N	1000000000	\N	134905	134905	134906
27248	43855	0	applied	\N	\N	\N	\N	134922	134922	134923
27248	43856	1	applied	\N	\N	\N	\N	134924	134924	134925
27248	43857	2	applied	\N	\N	\N	\N	134926	134926	134927
27252	43858	0	applied	\N	\N	\N	\N	134946	134946	134947
27252	43859	1	applied	\N	\N	\N	\N	134948	134948	134949
27252	43860	2	applied	\N	\N	\N	\N	134950	134950	134951
27254	43861	0	applied	\N	\N	\N	\N	134955	134955	134956
27254	43862	1	applied	\N	\N	\N	\N	134957	134957	134958
27254	43863	2	applied	\N	\N	\N	\N	134959	134959	134960
27258	43867	0	applied	\N	\N	\N	\N	134972	134972	134973
27258	43868	1	applied	\N	\N	\N	\N	134974	134974	134975
27258	43869	2	applied	\N	\N	\N	\N	134976	134976	134977
27265	43870	0	applied	\N	\N	\N	\N	134981	134981	134982
27265	43871	1	applied	\N	\N	\N	\N	134983	134983	134984
27265	43872	2	applied	\N	\N	\N	\N	134987	134987	134988
27266	43870	0	applied	\N	\N	\N	\N	134981	134981	134982
27266	43871	1	applied	\N	\N	\N	\N	134983	134983	134984
27266	43872	2	applied	\N	\N	\N	\N	134987	134987	134988
27270	43758	0	applied	\N	\N	\N	\N	134624	134624	134754
27270	43761	1	applied	\N	\N	\N	\N	134636	134636	134755
27270	43767	2	applied	\N	\N	\N	\N	134649	134649	134756
27270	43768	3	applied	\N	\N	\N	\N	134651	134651	134757
27270	43771	4	applied	\N	\N	\N	\N	134661	134661	134639
27270	43776	5	applied	\N	\N	\N	\N	134675	134675	134759
27270	43777	6	applied	\N	\N	\N	\N	134677	134677	134760
27270	43779	7	applied	\N	\N	\N	\N	134683	134683	134761
27270	43783	8	applied	\N	\N	\N	\N	134693	134693	134762
27270	43791	9	applied	\N	\N	\N	\N	134716	134716	134654
27270	43799	10	applied	\N	\N	\N	\N	134732	134732	134662
27270	43800	11	applied	\N	\N	\N	\N	134734	134734	134763
27270	43801	12	applied	\N	\N	\N	\N	134736	134736	134764
27270	43802	13	applied	\N	\N	\N	\N	134738	134738	134674
27270	43803	14	applied	\N	\N	\N	\N	134740	134740	134676
27270	43804	15	applied	\N	\N	\N	\N	134742	134742	134678
27270	43809	16	applied	\N	\N	\N	\N	134774	134774	134684
27270	43810	17	applied	\N	\N	\N	\N	134776	134776	134765
27270	43813	18	applied	\N	\N	\N	\N	134788	134788	134766
27270	43816	19	applied	\N	\N	\N	\N	134800	134800	134692
27270	43819	20	applied	\N	\N	\N	\N	134810	134810	134694
27270	43822	21	applied	\N	\N	\N	\N	134828	134828	134717
27270	43823	22	applied	\N	\N	\N	\N	134830	134830	135024
27270	43828	23	applied	\N	\N	\N	\N	134844	134844	135025
27270	43830	25	applied	\N	\N	\N	\N	134848	134848	134721
27270	43833	26	applied	\N	\N	\N	\N	134860	134860	135027
27270	43841	27	applied	\N	\N	\N	\N	134880	134880	135028
27270	43842	28	applied	\N	\N	\N	\N	134882	134882	134725
27270	43843	29	applied	\N	\N	\N	\N	134884	134884	135029
27270	43845	30	applied	\N	\N	\N	\N	134889	134889	135030
27270	43847	31	applied	\N	\N	\N	\N	134895	134895	134729
27270	43849	32	applied	\N	\N	\N	\N	134901	134901	135031
27270	43854	33	applied	\N	\N	\N	\N	134916	134916	135032
27270	43857	34	applied	\N	\N	\N	\N	134926	134926	134769
27270	43860	35	applied	\N	\N	\N	\N	134950	134950	135033
27270	43863	36	applied	\N	\N	\N	\N	134959	134959	135034
27270	43865	37	applied	\N	\N	\N	\N	134965	134965	135035
27270	43868	38	applied	\N	\N	\N	\N	134974	134974	135036
27270	43872	39	applied	\N	\N	\N	\N	134987	134987	135037
27274	43876	0	applied	\N	\N	\N	\N	135047	135047	135048
27274	43877	1	applied	\N	\N	\N	\N	135049	135049	135050
27274	43878	2	applied	\N	\N	\N	\N	135051	135051	135052
27274	43879	3	applied	\N	\N	\N	\N	135053	135053	135054
27274	43880	4	applied	\N	\N	\N	\N	135055	135055	135056
27274	43881	5	applied	\N	\N	\N	\N	135057	135057	135058
27279	43888	0	applied	\N	\N	\N	\N	135078	135078	135079
27279	43889	1	applied	\N	\N	\N	\N	135080	135080	135081
27279	43890	2	applied	\N	\N	\N	\N	135082	135082	135083
27282	43900	0	applied	\N	\N	\N	\N	135106	135106	135107
27282	43901	1	applied	\N	\N	\N	\N	135108	135108	135109
27285	43902	0	applied	\N	\N	\N	\N	135120	135120	135121
27285	43903	1	applied	\N	\N	\N	\N	135131	135131	135132
27285	43904	2	applied	\N	\N	\N	\N	135133	135133	135134
27285	43905	3	applied	\N	\N	\N	\N	135135	135135	135136
27285	43906	4	applied	\N	\N	\N	\N	135137	135137	135138
27288	43907	0	applied	\N	\N	\N	\N	135141	135141	135142
27288	43908	1	applied	\N	\N	\N	\N	135143	135143	135144
27289	43906	0	applied	\N	\N	\N	\N	135137	135137	134809
27294	43913	0	applied	\N	\N	\N	\N	135166	135166	135167
27251	43836	84	applied	\N	\N	\N	\N	134870	134870	134871
27251	43837	85	applied	\N	\N	\N	\N	134872	134872	134873
27251	43844	86	applied	\N	\N	\N	\N	134887	134887	134888
27251	43846	87	applied	\N	\N	\N	\N	134893	134893	134894
27251	43848	88	applied	\N	\N	\N	\N	134899	134899	134900
27251	43852	89	applied	\N	\N	\N	\N	134912	134912	134913
27251	43855	90	applied	\N	\N	\N	\N	134922	134922	134923
27284	43576	0	applied	\N	\N	\N	\N	134090	134090	134091
27251	43757	91	applied	\N	\N	1000000000	\N	134622	134622	134623
27251	43589	92	applied	\N	\N	\N	\N	134123	134123	134124
27251	43590	93	applied	\N	\N	\N	\N	134125	134125	134126
27251	43591	94	applied	\N	\N	\N	\N	134127	134127	134128
27251	43759	95	applied	\N	\N	1000000000	\N	134626	134626	134627
27251	43595	96	applied	\N	\N	\N	\N	134138	134138	134934
27251	43598	97	applied	\N	\N	\N	\N	134144	134144	134935
27251	43600	98	applied	\N	\N	\N	\N	134149	134149	134143
27251	43603	99	applied	\N	\N	\N	\N	134157	134157	134145
27251	43766	100	applied	\N	\N	1000000000	\N	134647	134647	134648
27251	43839	101	applied	\N	\N	1000000000	\N	134876	134876	134877
27251	43840	102	applied	\N	\N	1000000000	\N	134878	134878	134879
27251	43606	103	applied	\N	\N	\N	\N	134165	134165	134150
27251	43851	104	applied	\N	\N	1000000000	\N	134905	134905	134906
27251	43612	105	applied	\N	\N	\N	\N	134180	134180	134936
27251	43613	106	applied	\N	\N	\N	\N	134182	134182	134937
27251	43614	107	applied	\N	\N	\N	\N	134184	134184	134938
27251	43592	108	applied	\N	\N	\N	\N	134129	134129	134939
27251	43594	109	applied	\N	\N	\N	\N	134136	134136	134940
27251	43597	110	applied	\N	\N	\N	\N	134142	134142	134941
27251	43601	111	applied	\N	\N	\N	\N	134151	134151	134181
27251	43604	112	applied	\N	\N	\N	\N	134159	134159	134942
27251	43607	113	applied	\N	\N	\N	\N	134167	134167	134943
27251	43611	114	applied	\N	\N	\N	\N	134178	134178	134185
27251	43615	115	applied	\N	\N	\N	\N	134186	134186	134187
27251	43616	116	applied	\N	\N	\N	\N	134188	134188	134189
27251	43618	117	applied	\N	\N	\N	\N	134194	134194	134195
27251	43622	118	applied	\N	\N	\N	\N	134207	134207	134553
27251	43625	119	applied	\N	\N	\N	\N	134216	134216	134554
27251	43627	120	applied	\N	\N	\N	\N	134224	134224	134206
27251	43632	121	applied	\N	\N	\N	\N	134235	134235	134208
27251	43633	122	applied	\N	\N	\N	\N	134237	134237	134555
27251	43636	123	applied	\N	\N	\N	\N	134243	134243	134556
27251	43639	124	applied	\N	\N	\N	\N	134252	134252	134557
27251	43619	125	applied	\N	\N	\N	\N	134196	134196	134558
27259	43867	0	applied	\N	\N	\N	\N	134972	134972	134973
27259	43868	1	applied	\N	\N	\N	\N	134974	134974	134975
27259	43869	2	applied	\N	\N	\N	\N	134976	134976	134977
27271	43873	0	applied	\N	\N	\N	\N	134994	134994	134995
27271	43874	1	applied	\N	\N	\N	\N	134996	134996	134997
27271	43875	2	applied	\N	\N	\N	\N	134998	134998	134999
27275	43882	0	applied	\N	\N	\N	\N	135062	135062	135063
27275	43883	1	applied	\N	\N	\N	\N	135064	135064	135065
27275	43884	2	applied	\N	\N	\N	\N	135066	135066	135067
27277	43885	0	applied	\N	\N	\N	\N	135070	135070	135071
27277	43886	1	applied	\N	\N	\N	\N	135072	135072	135073
27277	43887	2	applied	\N	\N	\N	\N	135074	135074	135075
27292	43911	0	applied	\N	\N	\N	\N	135159	135159	135160
27292	43912	1	applied	\N	\N	\N	\N	135161	135161	135162
27295	43917	0	applied	\N	\N	\N	\N	135175	135175	135176
27297	43920	0	applied	\N	\N	\N	\N	135185	135185	135186
27297	43921	1	applied	\N	\N	\N	\N	135187	135187	135188
27297	43922	2	applied	\N	\N	\N	\N	135189	135189	135190
27297	43923	3	applied	\N	\N	\N	\N	135191	135191	135192
27297	43924	4	applied	\N	\N	\N	\N	135193	135193	135194
27297	43925	5	applied	\N	\N	\N	\N	135195	135195	135196
27298	43920	0	applied	\N	\N	\N	\N	135185	135185	135186
27298	43921	1	applied	\N	\N	\N	\N	135187	135187	135188
27298	43922	2	applied	\N	\N	\N	\N	135189	135189	135190
27298	43923	3	applied	\N	\N	\N	\N	135191	135191	135192
27298	43924	4	applied	\N	\N	\N	\N	135193	135193	135194
27298	43925	5	applied	\N	\N	\N	\N	135195	135195	135196
27305	43941	0	applied	\N	\N	\N	\N	135236	135236	135237
27305	43942	1	applied	\N	\N	\N	\N	135238	135238	135239
27305	43943	2	applied	\N	\N	\N	\N	135240	135240	135241
27308	43944	0	applied	\N	\N	\N	\N	135246	135246	135247
27308	43945	1	applied	\N	\N	\N	\N	135248	135248	135249
27308	43946	2	applied	\N	\N	\N	\N	135250	135250	135251
27309	43944	0	applied	\N	\N	\N	\N	135246	135246	135247
27309	43945	1	applied	\N	\N	\N	\N	135248	135248	135249
27309	43946	2	applied	\N	\N	\N	\N	135250	135250	135251
27314	43956	0	applied	\N	\N	\N	\N	135283	135283	135284
27314	43957	1	applied	\N	\N	\N	\N	135285	135285	135286
27314	43958	2	applied	\N	\N	\N	\N	135287	135287	135288
27314	43959	3	applied	\N	\N	\N	\N	135289	135289	135290
27314	43960	4	applied	\N	\N	\N	\N	135291	135291	135292
27314	43961	5	applied	\N	\N	\N	\N	135293	135293	135294
27317	43965	0	applied	\N	\N	\N	\N	135303	135303	135304
27317	43966	1	applied	\N	\N	\N	\N	135305	135305	135306
27317	43967	2	applied	\N	\N	\N	\N	135307	135307	135308
27325	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27325	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27325	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27329	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27329	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27329	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27333	43992	0	applied	\N	\N	\N	\N	135384	135384	135385
27333	43993	1	applied	\N	\N	\N	\N	135386	135386	135387
27333	43994	2	applied	\N	\N	\N	\N	135388	135388	135389
27333	43995	3	applied	\N	\N	\N	\N	135390	135390	135391
27336	43999	0	applied	\N	\N	\N	\N	135404	135404	135405
27336	44000	1	applied	\N	\N	\N	\N	135406	135406	135407
27336	44001	2	applied	\N	\N	\N	\N	135408	135408	135409
27336	44002	3	applied	\N	\N	\N	\N	135410	135410	135411
27336	44003	4	applied	\N	\N	\N	\N	135412	135412	135413
27336	44004	5	applied	\N	\N	\N	\N	135414	135414	135415
27336	44005	6	applied	\N	\N	\N	\N	135416	135416	135417
27336	44006	7	applied	\N	\N	\N	\N	135418	135418	135419
27336	44007	8	applied	\N	\N	\N	\N	135420	135420	135421
27346	44032	0	applied	\N	\N	\N	\N	135488	135488	135489
27346	44033	1	applied	\N	\N	\N	\N	135490	135490	135491
27346	44034	2	applied	\N	\N	\N	\N	135492	135492	135493
27347	44032	0	applied	\N	\N	\N	\N	135488	135488	135489
27347	44033	1	applied	\N	\N	\N	\N	135490	135490	135491
27347	44034	2	applied	\N	\N	\N	\N	135492	135492	135493
27358	44053	0	applied	\N	\N	\N	\N	135540	135540	135541
27358	44054	1	applied	\N	\N	\N	\N	135542	135542	135543
27358	44055	2	applied	\N	\N	\N	\N	135544	135544	135545
27358	44056	3	applied	\N	\N	\N	\N	135546	135546	135547
27358	44057	4	applied	\N	\N	\N	\N	135548	135548	135549
27358	44058	5	applied	\N	\N	\N	\N	135550	135550	135551
27358	44059	6	applied	\N	\N	\N	\N	135552	135552	135553
27281	43893	2	applied	\N	\N	\N	\N	135090	135090	135091
27281	43894	3	applied	\N	\N	\N	\N	135092	135092	135093
27281	43895	4	applied	\N	\N	\N	\N	135094	135094	135095
27281	43896	5	applied	\N	\N	\N	\N	135096	135096	135097
27281	43897	6	applied	\N	\N	\N	\N	135098	135098	135099
27281	43898	7	applied	\N	\N	\N	\N	135100	135100	135101
27281	43899	8	applied	\N	\N	\N	\N	135102	135102	135103
27284	43579	1	applied	\N	\N	\N	\N	134098	134098	134099
27284	43582	2	applied	\N	\N	\N	\N	134108	134108	134109
27284	43583	3	applied	\N	\N	\N	\N	134110	134110	134111
27284	43588	4	applied	\N	\N	\N	\N	134121	134121	134122
27284	43593	5	applied	\N	\N	\N	\N	134134	134134	134135
27284	43596	6	applied	\N	\N	\N	\N	134140	134140	134141
27284	43599	7	applied	\N	\N	\N	\N	134147	134147	134148
27284	43602	8	applied	\N	\N	\N	\N	134155	134155	134156
27284	43605	9	applied	\N	\N	\N	\N	134163	134163	134164
27284	43608	10	applied	\N	\N	\N	\N	134172	134172	134173
27284	43609	11	applied	\N	\N	\N	\N	134174	134174	134175
27284	43610	12	applied	\N	\N	\N	\N	134176	134176	134177
27284	43617	13	applied	\N	\N	\N	\N	134192	134192	134193
27284	43620	14	applied	\N	\N	\N	\N	134203	134203	134204
27284	43623	15	applied	\N	\N	\N	\N	134212	134212	134213
27284	43626	16	applied	\N	\N	\N	\N	134222	134222	134223
27284	43629	17	applied	\N	\N	\N	\N	134229	134229	134230
27284	43630	18	applied	\N	\N	\N	\N	134231	134231	134232
27284	43631	19	applied	\N	\N	\N	\N	134233	134233	134234
27284	43637	20	applied	\N	\N	\N	\N	134248	134248	134249
27284	43646	21	applied	\N	\N	\N	\N	134280	134280	134281
27284	43647	22	applied	\N	\N	\N	\N	134283	134283	134284
27284	43648	23	applied	\N	\N	\N	\N	134285	134285	134286
27284	43649	24	applied	\N	\N	\N	\N	134287	134287	134288
27284	43652	25	applied	\N	\N	\N	\N	134304	134304	134305
27284	43655	26	applied	\N	\N	\N	\N	134312	134312	134313
27284	43656	27	applied	\N	\N	\N	\N	134314	134314	134315
27284	43661	28	applied	\N	\N	\N	\N	134328	134328	134329
27284	43664	29	applied	\N	\N	\N	\N	134334	134334	134335
27284	43665	30	applied	\N	\N	\N	\N	134336	134336	134337
27284	43666	31	applied	\N	\N	\N	\N	134338	134338	134339
27284	43673	32	applied	\N	\N	\N	\N	134354	134354	134355
27284	43676	33	applied	\N	\N	\N	\N	134361	134361	134362
27284	43679	34	applied	\N	\N	\N	\N	134371	134371	134372
27284	43682	35	applied	\N	\N	\N	\N	134379	134379	134380
27284	43685	36	applied	\N	\N	\N	\N	134387	134387	134388
27284	43686	37	applied	\N	\N	\N	\N	134389	134389	134390
27284	43690	38	applied	\N	\N	\N	\N	134399	134399	134400
27284	43693	39	applied	\N	\N	\N	\N	134405	134405	134406
27284	43696	40	applied	\N	\N	\N	\N	134412	134412	134413
27284	43699	41	applied	\N	\N	\N	\N	134418	134418	134419
27284	43702	42	applied	\N	\N	\N	\N	134426	134426	134427
27284	43705	43	applied	\N	\N	\N	\N	134434	134434	134435
27284	43708	44	applied	\N	\N	\N	\N	134442	134442	134443
27284	43709	45	applied	\N	\N	\N	\N	134444	134444	134445
27284	43714	46	applied	\N	\N	\N	\N	134454	134454	134455
27284	43715	47	applied	\N	\N	\N	\N	134456	134456	134457
27284	43720	48	applied	\N	\N	\N	\N	134473	134473	134474
27284	43723	49	applied	\N	\N	\N	\N	134481	134481	134482
27284	43724	50	applied	\N	\N	\N	\N	134484	134484	134485
27284	43729	51	applied	\N	\N	\N	\N	134500	134500	134501
27284	43732	52	applied	\N	\N	\N	\N	134508	134508	134509
27284	43735	53	applied	\N	\N	\N	\N	134523	134523	134524
27284	43738	54	applied	\N	\N	\N	\N	134531	134531	134532
27284	43739	55	applied	\N	\N	\N	\N	134533	134533	134534
27284	43744	56	applied	\N	\N	\N	\N	134545	134545	134546
27284	43746	57	applied	\N	\N	\N	\N	134551	134551	134552
27284	43748	58	applied	\N	\N	\N	\N	134600	134600	134601
27284	43752	59	applied	\N	\N	\N	\N	134610	134610	134611
27284	43755	60	applied	\N	\N	\N	\N	134618	134618	134619
27284	43760	61	applied	\N	\N	\N	\N	134634	134634	134635
27284	43763	62	applied	\N	\N	\N	\N	134641	134641	134642
27284	43764	63	applied	\N	\N	\N	\N	134643	134643	134644
27284	43770	64	applied	\N	\N	\N	\N	134659	134659	134660
27284	43773	65	applied	\N	\N	\N	\N	134669	134669	134670
27284	43774	66	applied	\N	\N	\N	\N	134671	134671	134672
27284	43778	67	applied	\N	\N	\N	\N	134681	134681	134682
27284	43781	68	applied	\N	\N	\N	\N	134689	134689	134690
27284	43784	69	applied	\N	\N	\N	\N	134696	134696	134697
27284	43785	70	applied	\N	\N	\N	\N	134698	134698	134699
27284	43786	71	applied	\N	\N	\N	\N	134700	134700	134701
27284	43787	72	applied	\N	\N	\N	\N	134702	134702	134703
27284	43788	73	applied	\N	\N	\N	\N	134704	134704	134705
27284	43789	74	applied	\N	\N	\N	\N	134712	134712	134713
27284	43790	75	applied	\N	\N	\N	\N	134714	134714	134715
27284	43805	76	applied	\N	\N	\N	\N	134748	134748	134749
27284	43806	77	applied	\N	\N	\N	\N	134750	134750	134751
27284	43811	78	applied	\N	\N	\N	\N	134781	134781	134782
27284	43814	79	applied	\N	\N	\N	\N	134796	134796	134797
27284	43817	80	applied	\N	\N	\N	\N	134806	134806	134807
27284	43820	81	applied	\N	\N	\N	\N	134824	134824	134825
27284	43821	82	applied	\N	\N	\N	\N	134826	134826	134827
27284	43826	83	applied	\N	\N	\N	\N	134840	134840	134841
27284	43829	84	applied	\N	\N	\N	\N	134846	134846	134847
27284	43832	85	applied	\N	\N	\N	\N	134858	134858	134859
27284	43835	86	applied	\N	\N	\N	\N	134868	134868	134869
27284	43836	87	applied	\N	\N	\N	\N	134870	134870	134871
27284	43837	88	applied	\N	\N	\N	\N	134872	134872	134873
27284	43844	89	applied	\N	\N	\N	\N	134887	134887	134888
27284	43846	90	applied	\N	\N	\N	\N	134893	134893	134894
27284	43848	91	applied	\N	\N	\N	\N	134899	134899	134900
27284	43852	92	applied	\N	\N	\N	\N	134912	134912	134913
27284	43855	93	applied	\N	\N	\N	\N	134922	134922	134923
27284	43858	94	applied	\N	\N	\N	\N	134946	134946	134947
27284	43861	95	applied	\N	\N	\N	\N	134955	134955	134956
27284	43864	96	applied	\N	\N	\N	\N	134963	134963	134964
27284	43867	98	applied	\N	\N	\N	\N	134972	134972	134973
27284	43870	99	applied	\N	\N	\N	\N	134981	134981	134982
27284	43873	100	applied	\N	\N	\N	\N	134994	134994	134995
27284	43876	101	applied	\N	\N	\N	\N	135047	135047	135048
27284	43877	102	applied	\N	\N	\N	\N	135049	135049	135050
27284	43882	103	applied	\N	\N	\N	\N	135062	135062	135063
27284	43885	104	applied	\N	\N	\N	\N	135070	135070	135071
27284	43888	105	applied	\N	\N	\N	\N	135078	135078	135079
27284	43891	106	applied	\N	\N	\N	\N	135086	135086	135087
27284	43892	107	applied	\N	\N	\N	\N	135088	135088	135089
27284	43893	108	applied	\N	\N	\N	\N	135090	135090	135091
27284	43902	109	applied	\N	\N	\N	\N	135120	135120	135121
27284	43757	110	applied	\N	\N	1000000000	\N	134622	134622	134623
27284	43759	111	applied	\N	\N	1000000000	\N	134626	134626	134627
27284	43766	112	applied	\N	\N	1000000000	\N	134647	134647	134648
27284	43839	113	applied	\N	\N	1000000000	\N	134876	134876	134877
27284	43840	114	applied	\N	\N	1000000000	\N	134878	134878	134879
27284	43577	115	applied	\N	\N	\N	\N	134092	134092	134093
27284	43580	116	applied	\N	\N	\N	\N	134100	134100	135122
27284	43585	117	applied	\N	\N	\N	\N	134114	134114	135123
27284	43851	118	applied	\N	\N	1000000000	\N	134905	134905	134906
27284	43587	119	applied	\N	\N	\N	\N	134118	134118	134113
27284	43590	120	applied	\N	\N	\N	\N	134125	134125	134115
27284	43591	121	applied	\N	\N	\N	\N	134127	134127	135124
27284	43595	122	applied	\N	\N	\N	\N	134138	134138	135125
27284	43598	123	applied	\N	\N	\N	\N	134144	134144	135126
27284	43600	124	applied	\N	\N	\N	\N	134149	134149	135127
27287	43907	0	applied	\N	\N	\N	\N	135141	135141	135142
27287	43908	1	applied	\N	\N	\N	\N	135143	135143	135144
27296	43918	0	applied	\N	\N	\N	\N	135179	135179	135180
27296	43917	1	applied	\N	\N	\N	\N	135175	135175	135181
27296	43919	2	applied	\N	\N	\N	\N	135182	135182	135183
27306	43944	0	applied	\N	\N	\N	\N	135246	135246	135247
27306	43945	1	applied	\N	\N	\N	\N	135248	135248	135249
27306	43946	2	applied	\N	\N	\N	\N	135250	135250	135251
27318	43968	0	applied	\N	\N	\N	\N	135313	135313	135314
27318	43969	1	applied	\N	\N	\N	\N	135315	135315	135316
27318	43970	2	applied	\N	\N	\N	\N	135317	135317	135318
27318	43971	3	applied	\N	\N	\N	\N	135319	135319	135320
27318	43972	4	applied	\N	\N	\N	\N	135321	135321	135322
27318	43973	5	applied	\N	\N	\N	\N	135323	135323	135324
27321	43977	0	applied	\N	\N	\N	\N	135335	135335	135336
27321	43978	1	applied	\N	\N	\N	\N	135337	135337	135338
27321	43979	2	applied	\N	\N	\N	\N	135339	135339	135340
27321	43980	3	applied	\N	\N	\N	\N	135341	135341	135342
27321	43981	4	applied	\N	\N	\N	\N	135343	135343	135344
27321	43982	5	applied	\N	\N	\N	\N	135345	135345	135346
27323	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27323	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27323	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27324	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27324	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27324	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27327	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27327	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27327	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27332	43989	0	applied	\N	\N	\N	\N	135376	135376	135377
27332	43990	1	applied	\N	\N	\N	\N	135378	135378	135379
27332	43991	2	applied	\N	\N	\N	\N	135380	135380	135381
27337	44008	0	applied	\N	\N	\N	\N	135424	135424	135425
27337	44009	1	applied	\N	\N	\N	\N	135426	135426	135427
27337	44010	2	applied	\N	\N	\N	\N	135428	135428	135429
27341	44014	0	applied	\N	\N	\N	\N	135440	135440	135441
27341	44015	1	applied	\N	\N	\N	\N	135442	135442	135443
27341	44016	2	applied	\N	\N	\N	\N	135444	135444	135445
27345	44029	0	applied	\N	\N	\N	\N	135482	135482	135483
27345	44030	1	applied	\N	\N	\N	\N	135484	135484	135485
27345	44031	2	applied	\N	\N	\N	\N	135486	135486	135487
27352	44038	0	applied	\N	\N	\N	\N	135507	135507	135508
27352	44039	1	applied	\N	\N	\N	\N	135509	135509	135510
27352	44040	2	applied	\N	\N	\N	\N	135511	135511	135512
27352	44041	3	applied	\N	\N	\N	\N	135513	135513	135514
27352	44042	4	applied	\N	\N	\N	\N	135515	135515	135516
27352	44043	5	applied	\N	\N	\N	\N	135517	135517	135518
27352	44044	6	applied	\N	\N	\N	\N	135519	135519	135520
27352	44045	7	applied	\N	\N	\N	\N	135521	135521	135522
27352	44046	8	applied	\N	\N	\N	\N	135523	135523	135524
27356	44053	0	applied	\N	\N	\N	\N	135540	135540	135541
27356	44054	1	applied	\N	\N	\N	\N	135542	135542	135543
27356	44055	2	applied	\N	\N	\N	\N	135544	135544	135545
27356	44056	3	applied	\N	\N	\N	\N	135546	135546	135547
27356	44057	4	applied	\N	\N	\N	\N	135548	135548	135549
27356	44058	5	applied	\N	\N	\N	\N	135550	135550	135551
27356	44059	6	applied	\N	\N	\N	\N	135552	135552	135553
27356	44060	7	applied	\N	\N	\N	\N	135554	135554	135555
27356	44061	8	applied	\N	\N	\N	\N	135556	135556	135557
27361	44074	0	applied	\N	\N	\N	\N	135590	135590	135591
27361	44075	1	applied	\N	\N	\N	\N	135592	135592	135593
27361	44076	2	applied	\N	\N	\N	\N	135594	135594	135595
27361	44077	3	applied	\N	\N	\N	\N	135596	135596	135597
27361	44078	4	applied	\N	\N	\N	\N	135598	135598	135599
27361	44079	5	applied	\N	\N	\N	\N	135600	135600	135601
27361	44080	6	applied	\N	\N	\N	\N	135602	135602	135603
27361	44081	7	applied	\N	\N	\N	\N	135604	135604	135605
27361	44082	8	applied	\N	\N	\N	\N	135606	135606	135607
27368	44096	0	applied	\N	\N	\N	\N	135676	135676	135677
27368	44097	1	applied	\N	\N	\N	\N	135678	135678	135679
27368	44098	2	applied	\N	\N	\N	\N	135680	135680	135681
27371	44102	0	applied	\N	\N	\N	\N	135690	135690	135691
27371	44103	1	applied	\N	\N	\N	\N	135692	135692	135693
27371	44104	2	applied	\N	\N	\N	\N	135694	135694	135695
27373	44105	0	applied	\N	\N	\N	\N	135700	135700	135701
27373	44106	1	applied	\N	\N	\N	\N	135702	135702	135703
27373	44107	2	applied	\N	\N	\N	\N	135704	135704	135705
27374	44108	0	applied	\N	\N	\N	\N	135708	135708	135709
27374	44109	1	applied	\N	\N	\N	\N	135710	135710	135711
27374	44110	2	applied	\N	\N	\N	\N	135712	135712	135713
27374	44111	3	applied	\N	\N	\N	\N	135714	135714	135715
27374	44112	4	applied	\N	\N	\N	\N	135716	135716	135717
27374	44113	5	applied	\N	\N	\N	\N	135718	135718	135719
27374	44114	6	applied	\N	\N	\N	\N	135720	135720	135721
27374	44115	7	applied	\N	\N	\N	\N	135722	135722	135723
27374	44116	8	applied	\N	\N	\N	\N	135724	135724	135725
27374	44117	9	applied	\N	\N	\N	\N	135726	135726	135727
27374	44118	10	applied	\N	\N	\N	\N	135728	135728	135729
27374	44119	11	applied	\N	\N	\N	\N	135730	135730	135731
27374	44120	12	applied	\N	\N	\N	\N	135732	135732	135733
27374	44121	13	applied	\N	\N	\N	\N	135734	135734	135735
27374	44122	14	applied	\N	\N	\N	\N	135736	135736	135737
27379	44132	0	applied	\N	\N	\N	\N	135760	135760	135761
27379	44133	1	applied	\N	\N	\N	\N	135762	135762	135763
27379	44134	2	applied	\N	\N	\N	\N	135764	135764	135765
27382	44135	0	applied	\N	\N	\N	\N	135770	135770	135771
27382	44136	1	applied	\N	\N	\N	\N	135772	135772	135773
27382	44137	2	applied	\N	\N	\N	\N	135774	135774	135775
27382	44138	3	applied	\N	\N	\N	\N	135776	135776	135777
27382	44139	4	applied	\N	\N	\N	\N	135778	135778	135779
27382	44140	5	applied	\N	\N	\N	\N	135780	135780	135781
27382	44141	6	applied	\N	\N	\N	\N	135782	135782	135783
27382	44142	7	applied	\N	\N	\N	\N	135784	135784	135785
27382	44143	8	applied	\N	\N	\N	\N	135786	135786	135787
27385	44144	0	applied	\N	\N	\N	\N	135792	135792	135793
27385	44145	1	applied	\N	\N	\N	\N	135794	135794	135795
27385	44146	2	applied	\N	\N	\N	\N	135796	135796	135797
27293	43912	1	applied	\N	\N	\N	\N	135161	135161	135162
27300	43929	0	applied	\N	\N	\N	\N	135206	135206	135207
27300	43930	1	applied	\N	\N	\N	\N	135208	135208	135209
27300	43931	2	applied	\N	\N	\N	\N	135210	135210	135211
27301	43929	0	applied	\N	\N	\N	\N	135206	135206	135207
27301	43930	1	applied	\N	\N	\N	\N	135208	135208	135209
27301	43931	2	applied	\N	\N	\N	\N	135210	135210	135211
27303	43938	0	applied	\N	\N	\N	\N	135230	135230	135231
27303	43939	1	applied	\N	\N	\N	\N	135232	135232	135233
27303	43940	2	applied	\N	\N	\N	\N	135234	135234	135235
27310	43947	0	applied	\N	\N	\N	\N	135260	135260	135261
27310	43948	1	applied	\N	\N	\N	\N	135262	135262	135263
27310	43949	2	applied	\N	\N	\N	\N	135264	135264	135265
27312	43953	0	applied	\N	\N	\N	\N	135275	135275	135276
27312	43954	1	applied	\N	\N	\N	\N	135277	135277	135278
27312	43955	2	applied	\N	\N	\N	\N	135279	135279	135280
27315	43962	0	applied	\N	\N	\N	\N	135296	135296	135297
27315	43963	1	applied	\N	\N	\N	\N	135298	135298	135299
27315	43964	2	applied	\N	\N	\N	\N	135300	135300	135301
27320	43974	0	applied	\N	\N	\N	\N	135327	135327	135328
27320	43975	1	applied	\N	\N	\N	\N	135329	135329	135330
27320	43976	2	applied	\N	\N	\N	\N	135331	135331	135332
27326	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27326	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27326	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27331	43986	0	applied	\N	\N	\N	\N	135367	135367	135368
27331	43987	1	applied	\N	\N	\N	\N	135369	135369	135370
27331	43988	2	applied	\N	\N	\N	\N	135371	135371	135372
27334	43996	0	applied	\N	\N	\N	\N	135394	135394	135395
27334	43997	1	applied	\N	\N	\N	\N	135396	135396	135397
27334	43998	2	applied	\N	\N	\N	\N	135398	135398	135399
27339	44014	0	applied	\N	\N	\N	\N	135440	135440	135441
27339	44015	1	applied	\N	\N	\N	\N	135442	135442	135443
27339	44016	2	applied	\N	\N	\N	\N	135444	135444	135445
27340	44014	0	applied	\N	\N	\N	\N	135440	135440	135441
27340	44015	1	applied	\N	\N	\N	\N	135442	135442	135443
27340	44016	2	applied	\N	\N	\N	\N	135444	135444	135445
27342	44017	0	applied	\N	\N	\N	\N	135452	135452	135453
27342	44018	1	applied	\N	\N	\N	\N	135454	135454	135455
27342	44019	2	applied	\N	\N	\N	\N	135456	135456	135457
27342	44020	3	applied	\N	\N	\N	\N	135458	135458	135459
27342	44021	4	applied	\N	\N	\N	\N	135460	135460	135461
27342	44022	5	applied	\N	\N	\N	\N	135462	135462	135463
27344	44026	0	applied	\N	\N	\N	\N	135474	135474	135475
27344	44027	1	applied	\N	\N	\N	\N	135476	135476	135477
27344	44028	2	applied	\N	\N	\N	\N	135478	135478	135479
27349	44035	0	applied	\N	\N	\N	\N	135498	135498	135499
27349	44036	1	applied	\N	\N	\N	\N	135500	135500	135501
27349	44037	2	applied	\N	\N	\N	\N	135502	135502	135503
27355	44053	0	applied	\N	\N	\N	\N	135540	135540	135541
27355	44054	1	applied	\N	\N	\N	\N	135542	135542	135543
27355	44055	2	applied	\N	\N	\N	\N	135544	135544	135545
27355	44056	3	applied	\N	\N	\N	\N	135546	135546	135547
27355	44057	4	applied	\N	\N	\N	\N	135548	135548	135549
27355	44058	5	applied	\N	\N	\N	\N	135550	135550	135551
27355	44059	6	applied	\N	\N	\N	\N	135552	135552	135553
27355	44060	7	applied	\N	\N	\N	\N	135554	135554	135555
27355	44061	8	applied	\N	\N	\N	\N	135556	135556	135557
27363	44086	0	applied	\N	\N	\N	\N	135617	135617	135618
27363	44087	1	applied	\N	\N	\N	\N	135619	135619	135620
27363	44088	2	applied	\N	\N	\N	\N	135621	135621	135622
27366	44093	0	applied	\N	\N	\N	\N	135635	135635	135636
27366	44094	1	applied	\N	\N	\N	\N	135637	135637	135638
27366	44095	2	applied	\N	\N	\N	\N	135639	135639	135640
27377	44123	0	applied	\N	\N	\N	\N	135741	135741	135742
27377	44124	1	applied	\N	\N	\N	\N	135743	135743	135744
27377	44125	2	applied	\N	\N	\N	\N	135745	135745	135746
27377	44126	3	applied	\N	\N	\N	\N	135747	135747	135748
27377	44127	4	applied	\N	\N	\N	\N	135749	135749	135750
27377	44128	5	applied	\N	\N	\N	\N	135751	135751	135752
27384	44144	0	applied	\N	\N	\N	\N	135792	135792	135793
27384	44145	1	applied	\N	\N	\N	\N	135794	135794	135795
27384	44146	2	applied	\N	\N	\N	\N	135796	135796	135797
27391	44159	0	applied	\N	\N	\N	\N	135831	135831	135832
27391	44160	1	applied	\N	\N	\N	\N	135833	135833	135834
27391	44161	2	applied	\N	\N	\N	\N	135835	135835	135836
27397	44183	0	applied	\N	\N	\N	\N	135884	135884	135885
27397	44184	1	applied	\N	\N	\N	\N	135886	135886	135887
27397	44185	2	applied	\N	\N	\N	\N	135888	135888	135889
27402	44189	0	applied	\N	\N	\N	\N	135898	135898	135899
27402	44190	1	applied	\N	\N	\N	\N	135900	135900	135901
27402	44191	2	applied	\N	\N	\N	\N	135902	135902	135903
27404	44192	0	applied	\N	\N	\N	\N	135908	135908	135909
27404	44193	1	applied	\N	\N	\N	\N	135910	135910	135911
27404	44194	2	applied	\N	\N	\N	\N	135912	135912	135913
27407	44198	0	applied	\N	\N	\N	\N	135923	135923	135924
27407	44199	1	applied	\N	\N	\N	\N	135925	135925	135926
27407	44200	2	applied	\N	\N	\N	\N	135927	135927	135928
27409	44201	0	applied	\N	\N	\N	\N	135931	135931	135932
27409	44202	1	applied	\N	\N	\N	\N	135933	135933	135934
27409	44203	2	applied	\N	\N	\N	\N	135935	135935	135936
27416	44207	0	applied	\N	\N	\N	\N	135953	135953	135954
27416	44208	1	applied	\N	\N	\N	\N	135955	135955	135956
27416	44209	2	applied	\N	\N	\N	\N	135957	135957	135958
27420	44210	0	applied	\N	\N	\N	\N	135967	135967	135968
27420	44211	1	applied	\N	\N	\N	\N	135969	135969	135970
27420	44212	2	applied	\N	\N	\N	\N	135971	135971	135972
27420	44213	3	applied	\N	\N	\N	\N	135973	135973	135974
27420	44214	4	applied	\N	\N	\N	\N	135975	135975	135976
27420	44215	5	applied	\N	\N	\N	\N	135977	135977	135978
27420	44216	6	applied	\N	\N	\N	\N	135979	135979	135980
27420	44217	7	applied	\N	\N	\N	\N	135981	135981	135982
27420	44218	8	applied	\N	\N	\N	\N	135983	135983	135984
27431	44231	0	applied	\N	\N	\N	\N	136049	136049	136050
27431	44232	1	applied	\N	\N	\N	\N	136051	136051	136052
27431	44233	2	applied	\N	\N	\N	\N	136053	136053	136054
27435	44237	0	applied	\N	\N	\N	\N	136067	136067	136068
27435	44238	1	applied	\N	\N	\N	\N	136069	136069	136070
27435	44239	2	applied	\N	\N	\N	\N	136071	136071	136072
27439	44244	0	applied	\N	\N	\N	\N	136092	136092	136093
27439	44245	1	applied	\N	\N	\N	\N	136094	136094	136095
27439	44246	2	applied	\N	\N	\N	\N	136096	136096	136097
27439	44247	3	applied	\N	\N	\N	\N	136098	136098	136099
27439	44248	4	applied	\N	\N	\N	\N	136100	136100	136101
27439	44249	5	applied	\N	\N	\N	\N	136102	136102	136103
27439	44243	6	applied	\N	\N	\N	\N	136089	136089	136090
27445	44250	0	applied	\N	\N	\N	\N	136110	136110	136111
27445	44251	2	applied	\N	\N	\N	\N	136113	136113	136114
27445	44252	3	applied	\N	\N	\N	\N	136115	136115	136116
27449	44253	0	applied	\N	\N	\N	\N	136124	136124	136125
27294	43914	1	applied	\N	\N	\N	\N	135168	135168	135169
27294	43915	2	applied	\N	\N	\N	\N	135170	135170	135171
27294	43916	3	applied	\N	\N	\N	\N	135172	135172	135173
27299	43926	0	applied	\N	\N	\N	\N	135200	135200	135201
27299	43927	1	applied	\N	\N	\N	\N	135202	135202	135203
27299	43928	2	applied	\N	\N	\N	\N	135204	135204	135205
27302	43932	0	applied	\N	\N	\N	\N	135216	135216	135217
27302	43933	1	applied	\N	\N	\N	\N	135218	135218	135219
27302	43934	2	applied	\N	\N	\N	\N	135220	135220	135221
27302	43935	3	applied	\N	\N	\N	\N	135222	135222	135223
27302	43936	4	applied	\N	\N	\N	\N	135224	135224	135225
27302	43937	5	applied	\N	\N	\N	\N	135226	135226	135227
27304	43941	0	applied	\N	\N	\N	\N	135236	135236	135237
27304	43942	1	applied	\N	\N	\N	\N	135238	135238	135239
27304	43943	2	applied	\N	\N	\N	\N	135240	135240	135241
27307	43944	0	applied	\N	\N	\N	\N	135246	135246	135247
27307	43945	1	applied	\N	\N	\N	\N	135248	135248	135249
27307	43946	2	applied	\N	\N	\N	\N	135250	135250	135251
27311	43950	0	applied	\N	\N	\N	\N	135268	135268	135269
27311	43951	1	applied	\N	\N	\N	\N	135270	135270	135271
27311	43952	2	applied	\N	\N	\N	\N	135272	135272	135273
27316	43965	0	applied	\N	\N	\N	\N	135303	135303	135304
27316	43966	1	applied	\N	\N	\N	\N	135305	135305	135306
27316	43967	2	applied	\N	\N	\N	\N	135307	135307	135308
27319	43968	0	applied	\N	\N	\N	\N	135313	135313	135314
27319	43969	1	applied	\N	\N	\N	\N	135315	135315	135316
27319	43970	2	applied	\N	\N	\N	\N	135317	135317	135318
27319	43971	3	applied	\N	\N	\N	\N	135319	135319	135320
27319	43972	4	applied	\N	\N	\N	\N	135321	135321	135322
27319	43973	5	applied	\N	\N	\N	\N	135323	135323	135324
27322	43977	0	applied	\N	\N	\N	\N	135335	135335	135336
27322	43978	1	applied	\N	\N	\N	\N	135337	135337	135338
27322	43979	2	applied	\N	\N	\N	\N	135339	135339	135340
27322	43980	3	applied	\N	\N	\N	\N	135341	135341	135342
27322	43981	4	applied	\N	\N	\N	\N	135343	135343	135344
27322	43982	5	applied	\N	\N	\N	\N	135345	135345	135346
27328	43983	0	applied	\N	\N	\N	\N	135351	135351	135352
27328	43984	1	applied	\N	\N	\N	\N	135353	135353	135354
27328	43985	2	applied	\N	\N	\N	\N	135355	135355	135356
27330	43986	0	applied	\N	\N	\N	\N	135367	135367	135368
27330	43987	1	applied	\N	\N	\N	\N	135369	135369	135370
27330	43988	2	applied	\N	\N	\N	\N	135371	135371	135372
27335	43996	0	applied	\N	\N	\N	\N	135394	135394	135395
27335	43997	1	applied	\N	\N	\N	\N	135396	135396	135397
27335	43998	2	applied	\N	\N	\N	\N	135398	135398	135399
27338	44011	0	applied	\N	\N	\N	\N	135432	135432	135433
27338	44012	1	applied	\N	\N	\N	\N	135434	135434	135435
27338	44013	2	applied	\N	\N	\N	\N	135436	135436	135437
27343	44023	0	applied	\N	\N	\N	\N	135466	135466	135467
27343	44024	1	applied	\N	\N	\N	\N	135468	135468	135469
27343	44025	2	applied	\N	\N	\N	\N	135470	135470	135471
27348	44032	0	applied	\N	\N	\N	\N	135488	135488	135489
27348	44033	1	applied	\N	\N	\N	\N	135490	135490	135491
27348	44034	2	applied	\N	\N	\N	\N	135492	135492	135493
27350	44035	0	applied	\N	\N	\N	\N	135498	135498	135499
27350	44036	1	applied	\N	\N	\N	\N	135500	135500	135501
27350	44037	2	applied	\N	\N	\N	\N	135502	135502	135503
27353	44047	0	applied	\N	\N	\N	\N	135527	135527	135528
27353	44048	1	applied	\N	\N	\N	\N	135529	135529	135530
27353	44049	2	applied	\N	\N	\N	\N	135531	135531	135532
27353	44050	3	applied	\N	\N	\N	\N	135533	135533	135534
27353	44051	4	applied	\N	\N	\N	\N	135535	135535	135536
27353	44052	5	applied	\N	\N	\N	\N	135537	135537	135538
27354	44047	0	applied	\N	\N	\N	\N	135527	135527	135528
27354	44048	1	applied	\N	\N	\N	\N	135529	135529	135530
27354	44049	2	applied	\N	\N	\N	\N	135531	135531	135532
27354	44050	3	applied	\N	\N	\N	\N	135533	135533	135534
27354	44051	4	applied	\N	\N	\N	\N	135535	135535	135536
27354	44052	5	applied	\N	\N	\N	\N	135537	135537	135538
27357	44053	0	applied	\N	\N	\N	\N	135540	135540	135541
27357	44054	1	applied	\N	\N	\N	\N	135542	135542	135543
27357	44055	2	applied	\N	\N	\N	\N	135544	135544	135545
27357	44056	3	applied	\N	\N	\N	\N	135546	135546	135547
27357	44057	4	applied	\N	\N	\N	\N	135548	135548	135549
27357	44058	5	applied	\N	\N	\N	\N	135550	135550	135551
27357	44059	6	applied	\N	\N	\N	\N	135552	135552	135553
27357	44060	7	applied	\N	\N	\N	\N	135554	135554	135555
27357	44061	8	applied	\N	\N	\N	\N	135556	135556	135557
27359	44062	0	applied	\N	\N	\N	\N	135563	135563	135564
27359	44063	1	applied	\N	\N	\N	\N	135565	135565	135566
27359	44064	2	applied	\N	\N	\N	\N	135567	135567	135568
27359	44065	3	applied	\N	\N	\N	\N	135569	135569	135570
27359	44066	4	applied	\N	\N	\N	\N	135571	135571	135572
27359	44067	5	applied	\N	\N	\N	\N	135573	135573	135574
27359	44068	6	applied	\N	\N	\N	\N	135575	135575	135576
27359	44069	7	applied	\N	\N	\N	\N	135577	135577	135578
27359	44070	8	applied	\N	\N	\N	\N	135579	135579	135580
27359	44071	9	applied	\N	\N	\N	\N	135581	135581	135582
27359	44072	10	applied	\N	\N	\N	\N	135583	135583	135584
27359	44073	12	applied	\N	\N	\N	\N	135586	135586	135587
27362	44083	0	applied	\N	\N	\N	\N	135609	135609	135610
27362	44084	1	applied	\N	\N	\N	\N	135611	135611	135612
27362	44085	2	applied	\N	\N	\N	\N	135613	135613	135614
27364	44089	0	applied	\N	\N	\N	\N	135625	135625	135626
27364	44090	1	applied	\N	\N	\N	\N	135627	135627	135628
27364	44091	2	applied	\N	\N	\N	\N	135629	135629	135630
27364	44092	3	applied	\N	\N	1000000000	\N	135631	135631	135632
27369	44099	0	applied	\N	\N	\N	\N	135682	135682	135683
27369	44100	1	applied	\N	\N	\N	\N	135684	135684	135685
27369	44101	2	applied	\N	\N	\N	\N	135686	135686	135687
27372	44102	0	applied	\N	\N	\N	\N	135690	135690	135691
27372	44103	1	applied	\N	\N	\N	\N	135692	135692	135693
27372	44104	2	applied	\N	\N	\N	\N	135694	135694	135695
27375	44108	0	applied	\N	\N	\N	\N	135708	135708	135709
27375	44109	1	applied	\N	\N	\N	\N	135710	135710	135711
27375	44110	2	applied	\N	\N	\N	\N	135712	135712	135713
27375	44111	3	applied	\N	\N	\N	\N	135714	135714	135715
27375	44112	4	applied	\N	\N	\N	\N	135716	135716	135717
27375	44113	5	applied	\N	\N	\N	\N	135718	135718	135719
27375	44114	6	applied	\N	\N	\N	\N	135720	135720	135721
27375	44115	7	applied	\N	\N	\N	\N	135722	135722	135723
27375	44116	8	applied	\N	\N	\N	\N	135724	135724	135725
27375	44117	9	applied	\N	\N	\N	\N	135726	135726	135727
27375	44118	10	applied	\N	\N	\N	\N	135728	135728	135729
27375	44119	11	applied	\N	\N	\N	\N	135730	135730	135731
27375	44120	12	applied	\N	\N	\N	\N	135732	135732	135733
27375	44121	13	applied	\N	\N	\N	\N	135734	135734	135735
27375	44122	14	applied	\N	\N	\N	\N	135736	135736	135737
27380	44132	0	applied	\N	\N	\N	\N	135760	135760	135761
27380	44133	1	applied	\N	\N	\N	\N	135762	135762	135763
27358	44060	7	applied	\N	\N	\N	\N	135554	135554	135555
27358	44061	8	applied	\N	\N	\N	\N	135556	135556	135557
27360	44062	0	applied	\N	\N	\N	\N	135563	135563	135564
27360	44063	1	applied	\N	\N	\N	\N	135565	135565	135566
27360	44064	2	applied	\N	\N	\N	\N	135567	135567	135568
27360	44065	3	applied	\N	\N	\N	\N	135569	135569	135570
27360	44066	4	applied	\N	\N	\N	\N	135571	135571	135572
27360	44067	5	applied	\N	\N	\N	\N	135573	135573	135574
27360	44068	6	applied	\N	\N	\N	\N	135575	135575	135576
27360	44069	7	applied	\N	\N	\N	\N	135577	135577	135578
27360	44070	8	applied	\N	\N	\N	\N	135579	135579	135580
27360	44071	9	applied	\N	\N	\N	\N	135581	135581	135582
27360	44072	10	applied	\N	\N	\N	\N	135583	135583	135584
27360	44073	12	applied	\N	\N	\N	\N	135586	135586	135587
27365	44093	0	applied	\N	\N	\N	\N	135635	135635	135636
27365	44094	1	applied	\N	\N	\N	\N	135637	135637	135638
27365	44095	2	applied	\N	\N	\N	\N	135639	135639	135640
27367	43993	0	applied	\N	\N	\N	\N	135386	135386	135387
27367	44071	1	applied	\N	\N	\N	\N	135581	135581	135582
27367	44072	2	applied	\N	\N	\N	\N	135583	135583	135584
27367	44073	3	applied	\N	\N	\N	\N	135586	135586	135587
27367	43917	4	applied	\N	\N	\N	\N	135175	135175	134811
27367	43922	5	applied	\N	\N	\N	\N	135189	135189	134829
27367	43924	6	applied	\N	\N	\N	\N	135193	135193	134831
27367	43928	7	applied	\N	\N	\N	\N	135204	135204	135644
27367	43931	8	applied	\N	\N	\N	\N	135210	135210	135645
27367	43935	9	applied	\N	\N	\N	\N	135222	135222	134835
27367	43936	10	applied	\N	\N	\N	\N	135224	135224	135646
27367	43940	11	applied	\N	\N	\N	\N	135234	135234	135647
27367	43943	12	applied	\N	\N	\N	\N	135240	135240	135648
27367	43946	13	applied	\N	\N	\N	\N	135250	135250	135649
27367	43949	14	applied	\N	\N	\N	\N	135264	135264	134851
27367	43951	15	applied	\N	\N	\N	\N	135270	135270	134861
27367	43955	16	applied	\N	\N	\N	\N	135279	135279	135650
27367	43960	17	applied	\N	\N	\N	\N	135291	135291	135651
27367	43961	18	applied	\N	\N	\N	\N	135293	135293	134875
27367	43964	19	applied	\N	\N	\N	\N	135300	135300	134881
27367	43967	20	applied	\N	\N	\N	\N	135307	135307	134883
27367	43970	21	applied	\N	\N	\N	\N	135317	135317	134885
27367	43971	22	applied	\N	\N	\N	\N	135319	135319	134890
27367	43976	23	applied	\N	\N	\N	\N	135331	135331	134896
27367	43979	24	applied	\N	\N	\N	\N	135339	135339	134902
27367	43980	25	applied	\N	\N	\N	\N	135341	135341	135652
27367	43984	26	applied	\N	\N	\N	\N	135353	135353	135653
27367	43987	27	applied	\N	\N	\N	\N	135369	135369	134915
27367	43991	28	applied	\N	\N	\N	\N	135380	135380	134917
27367	43994	29	applied	\N	\N	\N	\N	135388	135388	135654
27367	43998	30	applied	\N	\N	\N	\N	135398	135398	135655
27367	44003	31	applied	\N	\N	\N	\N	135412	135412	135656
27367	44004	32	applied	\N	\N	\N	\N	135414	135414	134949
27367	44005	33	applied	\N	\N	\N	\N	135416	135416	134951
27367	44010	34	applied	\N	\N	\N	\N	135428	135428	135657
27367	44012	35	applied	\N	\N	\N	\N	135434	135434	135658
27367	44015	36	applied	\N	\N	\N	\N	135442	135442	135659
27367	44019	37	applied	\N	\N	\N	\N	135456	135456	135660
27367	44022	38	applied	\N	\N	\N	\N	135462	135462	134968
27367	44024	39	applied	\N	\N	\N	\N	135468	135468	134975
27367	44028	40	applied	\N	\N	\N	\N	135478	135478	135661
27367	44031	41	applied	\N	\N	\N	\N	135486	135486	135662
27367	44034	42	applied	\N	\N	\N	\N	135492	135492	134984
27367	44037	43	applied	\N	\N	\N	\N	135502	135502	134988
27367	44041	44	applied	\N	\N	\N	\N	135513	135513	134997
27367	44042	45	applied	\N	\N	\N	\N	135515	135515	135663
27367	44046	46	applied	\N	\N	\N	\N	135523	135523	135664
27367	44049	47	applied	\N	\N	\N	\N	135531	135531	135665
27367	44050	48	applied	\N	\N	\N	\N	135533	135533	135666
27367	44059	49	applied	\N	\N	\N	\N	135552	135552	135056
27367	44060	50	applied	\N	\N	\N	\N	135554	135554	135667
27367	44061	51	applied	\N	\N	\N	\N	135556	135556	135668
27367	44065	52	applied	\N	\N	\N	\N	135569	135569	135669
27367	44066	53	applied	\N	\N	\N	\N	135571	135571	135067
27367	44067	54	applied	\N	\N	\N	\N	135573	135573	135073
27367	44077	55	applied	\N	\N	\N	\N	135596	135596	135670
27367	44078	56	applied	\N	\N	\N	\N	135598	135598	135671
27367	44079	57	applied	\N	\N	\N	\N	135600	135600	135081
27367	44085	58	applied	\N	\N	\N	\N	135613	135613	135083
27367	44087	59	applied	\N	\N	\N	\N	135619	135619	135672
27367	44091	60	applied	\N	\N	\N	\N	135629	135629	135673
27367	44095	61	applied	\N	\N	\N	\N	135639	135639	135095
27370	44099	0	applied	\N	\N	\N	\N	135682	135682	135683
27370	44100	1	applied	\N	\N	\N	\N	135684	135684	135685
27370	44101	2	applied	\N	\N	\N	\N	135686	135686	135687
27376	44123	0	applied	\N	\N	\N	\N	135741	135741	135742
27376	44124	1	applied	\N	\N	\N	\N	135743	135743	135744
27376	44125	2	applied	\N	\N	\N	\N	135745	135745	135746
27376	44126	3	applied	\N	\N	\N	\N	135747	135747	135748
27376	44127	4	applied	\N	\N	\N	\N	135749	135749	135750
27376	44128	5	applied	\N	\N	\N	\N	135751	135751	135752
27378	44129	0	applied	\N	\N	\N	\N	135754	135754	135755
27378	44130	1	applied	\N	\N	\N	\N	135756	135756	135757
27378	44131	2	applied	\N	\N	\N	\N	135758	135758	135759
27381	44135	0	applied	\N	\N	\N	\N	135770	135770	135771
27381	44136	1	applied	\N	\N	\N	\N	135772	135772	135773
27381	44137	2	applied	\N	\N	\N	\N	135774	135774	135775
27381	44138	3	applied	\N	\N	\N	\N	135776	135776	135777
27381	44139	4	applied	\N	\N	\N	\N	135778	135778	135779
27381	44140	5	applied	\N	\N	\N	\N	135780	135780	135781
27381	44141	6	applied	\N	\N	\N	\N	135782	135782	135783
27381	44142	7	applied	\N	\N	\N	\N	135784	135784	135785
27381	44143	8	applied	\N	\N	\N	\N	135786	135786	135787
27383	44144	0	applied	\N	\N	\N	\N	135792	135792	135793
27383	44145	1	applied	\N	\N	\N	\N	135794	135794	135795
27383	44146	2	applied	\N	\N	\N	\N	135796	135796	135797
27386	44144	0	applied	\N	\N	\N	\N	135792	135792	135793
27386	44145	1	applied	\N	\N	\N	\N	135794	135794	135795
27386	44146	2	applied	\N	\N	\N	\N	135796	135796	135797
27388	44147	0	applied	\N	\N	\N	\N	135801	135801	135802
27388	44148	1	applied	\N	\N	\N	\N	135803	135803	135804
27388	44149	2	applied	\N	\N	\N	\N	135805	135805	135806
27388	44150	3	applied	\N	\N	\N	\N	135807	135807	135808
27388	44151	4	applied	\N	\N	\N	\N	135809	135809	135810
27388	44152	5	applied	\N	\N	\N	\N	135811	135811	135812
27389	44147	0	applied	\N	\N	\N	\N	135801	135801	135802
27389	44148	1	applied	\N	\N	\N	\N	135803	135803	135804
27389	44149	2	applied	\N	\N	\N	\N	135805	135805	135806
27389	44150	3	applied	\N	\N	\N	\N	135807	135807	135808
27389	44151	4	applied	\N	\N	\N	\N	135809	135809	135810
27389	44152	5	applied	\N	\N	\N	\N	135811	135811	135812
27390	44153	0	applied	\N	\N	\N	\N	135817	135817	135818
27390	44154	1	applied	\N	\N	\N	\N	135819	135819	135820
27380	44134	2	applied	\N	\N	\N	\N	135764	135764	135765
27387	44147	0	applied	\N	\N	\N	\N	135801	135801	135802
27387	44148	1	applied	\N	\N	\N	\N	135803	135803	135804
27387	44149	2	applied	\N	\N	\N	\N	135805	135805	135806
27387	44150	3	applied	\N	\N	\N	\N	135807	135807	135808
27387	44151	4	applied	\N	\N	\N	\N	135809	135809	135810
27387	44152	5	applied	\N	\N	\N	\N	135811	135811	135812
27396	44177	0	applied	\N	\N	\N	\N	135870	135870	135871
27396	44178	1	applied	\N	\N	\N	\N	135872	135872	135873
27396	44179	2	applied	\N	\N	\N	\N	135874	135874	135875
27396	44180	3	applied	\N	\N	\N	\N	135876	135876	135877
27396	44181	4	applied	\N	\N	\N	\N	135878	135878	135879
27396	44182	5	applied	\N	\N	\N	\N	135880	135880	135881
27399	44183	0	applied	\N	\N	\N	\N	135884	135884	135885
27399	44184	1	applied	\N	\N	\N	\N	135886	135886	135887
27399	44185	2	applied	\N	\N	\N	\N	135888	135888	135889
27400	44186	0	applied	\N	\N	\N	\N	135892	135892	135893
27400	44187	1	applied	\N	\N	\N	\N	135894	135894	135895
27400	44188	2	applied	\N	\N	\N	\N	135896	135896	135897
27411	44201	0	applied	\N	\N	\N	\N	135931	135931	135932
27411	44202	1	applied	\N	\N	\N	\N	135933	135933	135934
27411	44203	2	applied	\N	\N	\N	\N	135935	135935	135936
27412	44204	0	applied	\N	\N	\N	\N	135943	135943	135944
27412	44205	1	applied	\N	\N	\N	\N	135945	135945	135946
27412	44206	2	applied	\N	\N	\N	\N	135947	135947	135948
27418	44207	0	applied	\N	\N	\N	\N	135953	135953	135954
27418	44208	1	applied	\N	\N	\N	\N	135955	135955	135956
27418	44209	2	applied	\N	\N	\N	\N	135957	135957	135958
27424	44219	0	applied	\N	\N	\N	\N	136022	136022	136023
27424	44220	1	applied	\N	\N	\N	\N	136024	136024	136025
27424	44221	2	applied	\N	\N	\N	\N	136026	136026	136027
27424	44222	3	applied	\N	\N	\N	\N	136028	136028	136029
27424	44223	4	applied	\N	\N	\N	\N	136030	136030	136031
27424	44224	5	applied	\N	\N	\N	\N	136032	136032	136033
27424	44225	6	applied	\N	\N	\N	\N	136034	136034	136035
27424	44226	7	applied	\N	\N	\N	\N	136036	136036	136037
27424	44227	8	applied	\N	\N	\N	\N	136038	136038	136039
27426	44228	0	applied	\N	\N	\N	\N	136043	136043	136044
27426	44229	1	applied	\N	\N	\N	\N	136045	136045	136046
27426	44230	2	applied	\N	\N	\N	\N	136047	136047	136048
27429	44231	0	applied	\N	\N	\N	\N	136049	136049	136050
27429	44232	1	applied	\N	\N	\N	\N	136051	136051	136052
27429	44233	2	applied	\N	\N	\N	\N	136053	136053	136054
27433	44237	0	applied	\N	\N	\N	\N	136067	136067	136068
27433	44238	1	applied	\N	\N	\N	\N	136069	136069	136070
27433	44239	2	applied	\N	\N	\N	\N	136071	136071	136072
27441	44243	0	applied	\N	\N	\N	\N	136089	136089	136090
27447	44253	0	applied	\N	\N	\N	\N	136124	136124	136125
27447	44254	1	applied	\N	\N	\N	\N	136126	136126	136127
27447	44255	2	applied	\N	\N	\N	\N	136128	136128	136129
27447	44256	3	applied	\N	\N	\N	\N	136130	136130	136131
27447	44257	4	applied	\N	\N	\N	\N	136132	136132	136133
27447	44258	5	applied	\N	\N	\N	\N	136134	136134	136135
27451	44259	0	applied	\N	\N	\N	\N	136144	136144	136145
27451	44260	1	applied	\N	\N	\N	\N	136146	136146	136147
27451	44261	2	applied	\N	\N	\N	\N	136148	136148	136149
27453	44262	0	applied	\N	\N	\N	\N	136153	136153	136154
27453	44263	1	applied	\N	\N	\N	\N	136155	136155	136156
27453	44264	2	applied	\N	\N	\N	\N	136157	136157	136158
27458	44271	0	applied	\N	\N	\N	\N	136176	136176	136177
27458	44272	1	applied	\N	\N	\N	\N	136178	136178	136179
27458	44273	2	applied	\N	\N	\N	\N	136180	136180	136181
27458	44274	3	applied	\N	\N	\N	\N	136182	136182	136183
27458	44275	4	applied	\N	\N	\N	\N	136184	136184	136185
27458	44276	5	applied	\N	\N	\N	\N	136186	136186	136187
27458	44277	6	applied	\N	\N	\N	\N	136188	136188	136189
27458	44278	7	applied	\N	\N	\N	\N	136190	136190	136191
27458	44279	8	applied	\N	\N	\N	\N	136192	136192	136193
27458	44280	9	applied	\N	\N	\N	\N	136194	136194	136195
27458	44281	10	applied	\N	\N	\N	\N	136196	136196	136197
27458	44282	11	applied	\N	\N	\N	\N	136198	136198	136199
27458	44283	12	applied	\N	\N	\N	\N	136200	136200	136201
27458	44284	13	applied	\N	\N	\N	\N	136202	136202	136203
27464	44295	0	applied	\N	\N	\N	\N	136227	136227	136228
27464	44297	1	applied	\N	\N	\N	\N	136231	136231	136232
27464	44298	2	applied	\N	\N	\N	\N	136233	136233	136234
27464	44299	3	applied	\N	\N	\N	\N	136235	136235	136236
27464	44300	4	applied	\N	\N	\N	\N	136237	136237	136238
27478	44350	0	applied	\N	\N	\N	\N	136357	136357	136358
27478	44351	1	applied	\N	\N	\N	\N	136359	136359	136360
27478	44352	2	applied	\N	\N	\N	\N	136361	136361	136362
27478	44353	3	applied	\N	\N	\N	\N	136363	136363	136364
27478	44354	4	applied	\N	\N	\N	\N	136365	136365	136366
27478	44355	5	applied	\N	\N	\N	\N	136367	136367	136368
27478	44356	6	applied	\N	\N	\N	\N	136369	136369	136370
27478	44357	7	applied	\N	\N	\N	\N	136371	136371	136372
27478	44358	8	applied	\N	\N	\N	\N	136373	136373	136374
27478	44359	9	applied	\N	\N	\N	\N	136375	136375	136376
27478	44360	10	applied	\N	\N	\N	\N	136377	136377	136378
27478	44361	11	applied	\N	\N	\N	\N	136379	136379	136380
27478	44362	12	applied	\N	\N	\N	\N	136381	136381	136382
27478	44363	13	applied	\N	\N	\N	\N	136383	136383	136384
27478	44364	14	applied	\N	\N	\N	\N	136385	136385	136386
27478	44365	15	applied	\N	\N	\N	\N	136387	136387	136388
27478	44366	16	applied	\N	\N	\N	\N	136389	136389	136390
27478	44367	17	applied	\N	\N	\N	\N	136391	136391	136392
27478	44368	18	applied	\N	\N	\N	\N	136393	136393	136394
27478	44369	19	applied	\N	\N	\N	\N	136395	136395	136396
27478	44370	20	applied	\N	\N	\N	\N	136397	136397	136398
27478	44371	21	applied	\N	\N	\N	\N	136399	136399	136400
27478	44372	22	applied	\N	\N	\N	\N	136401	136401	136402
27478	44373	23	applied	\N	\N	\N	\N	136403	136403	136404
27478	44374	24	applied	\N	\N	\N	\N	136405	136405	136406
27478	44375	25	applied	\N	\N	\N	\N	136407	136407	136408
27480	44384	0	applied	\N	\N	\N	\N	136430	136430	136431
27480	44385	1	applied	\N	\N	\N	\N	136432	136432	136433
27480	44386	2	applied	\N	\N	\N	\N	136434	136434	136435
27480	44387	3	applied	\N	\N	\N	\N	136436	136436	136437
27480	44388	4	applied	\N	\N	\N	\N	136438	136438	136439
27480	44389	5	applied	\N	\N	\N	\N	136440	136440	136441
27480	44390	6	applied	\N	\N	\N	\N	136442	136442	136443
27480	44391	7	applied	\N	\N	\N	\N	136444	136444	136445
27480	44392	8	applied	\N	\N	\N	\N	136446	136446	136447
27480	44393	9	applied	\N	\N	\N	\N	136448	136448	136449
27480	44394	10	applied	\N	\N	\N	\N	136450	136450	136451
27480	44395	11	applied	\N	\N	\N	\N	136452	136452	136453
27480	44396	12	applied	\N	\N	\N	\N	136454	136454	136455
27480	44397	13	applied	\N	\N	\N	\N	136456	136456	136457
27480	44398	14	applied	\N	\N	\N	\N	136458	136458	136459
27480	44399	15	applied	\N	\N	\N	\N	136460	136460	136461
27390	44155	2	applied	\N	\N	\N	\N	135821	135821	135822
27390	44156	3	applied	\N	\N	\N	\N	135823	135823	135824
27390	44157	4	applied	\N	\N	\N	\N	135825	135825	135826
27390	44158	5	applied	\N	\N	\N	\N	135827	135827	135828
27401	44189	0	applied	\N	\N	\N	\N	135898	135898	135899
27401	44190	1	applied	\N	\N	\N	\N	135900	135900	135901
27401	44191	2	applied	\N	\N	\N	\N	135902	135902	135903
27406	44195	0	applied	\N	\N	\N	\N	135915	135915	135916
27406	44196	1	applied	\N	\N	\N	\N	135917	135917	135918
27406	44197	2	applied	\N	\N	\N	\N	135919	135919	135920
27413	44204	0	applied	\N	\N	\N	\N	135943	135943	135944
27413	44205	1	applied	\N	\N	\N	\N	135945	135945	135946
27413	44206	2	applied	\N	\N	\N	\N	135947	135947	135948
27414	44204	0	applied	\N	\N	\N	\N	135943	135943	135944
27414	44205	1	applied	\N	\N	\N	\N	135945	135945	135946
27414	44206	2	applied	\N	\N	\N	\N	135947	135947	135948
27415	44207	0	applied	\N	\N	\N	\N	135953	135953	135954
27415	44208	1	applied	\N	\N	\N	\N	135955	135955	135956
27415	44209	2	applied	\N	\N	\N	\N	135957	135957	135958
27419	44207	0	applied	\N	\N	\N	\N	135953	135953	135954
27419	44208	1	applied	\N	\N	\N	\N	135955	135955	135956
27419	44209	2	applied	\N	\N	\N	\N	135957	135957	135958
27425	44219	0	applied	\N	\N	\N	\N	136022	136022	136023
27425	44220	1	applied	\N	\N	\N	\N	136024	136024	136025
27425	44221	2	applied	\N	\N	\N	\N	136026	136026	136027
27425	44222	3	applied	\N	\N	\N	\N	136028	136028	136029
27425	44223	4	applied	\N	\N	\N	\N	136030	136030	136031
27425	44224	5	applied	\N	\N	\N	\N	136032	136032	136033
27425	44225	6	applied	\N	\N	\N	\N	136034	136034	136035
27425	44226	7	applied	\N	\N	\N	\N	136036	136036	136037
27425	44227	8	applied	\N	\N	\N	\N	136038	136038	136039
27427	44228	0	applied	\N	\N	\N	\N	136043	136043	136044
27427	44229	1	applied	\N	\N	\N	\N	136045	136045	136046
27427	44230	2	applied	\N	\N	\N	\N	136047	136047	136048
27430	44231	0	applied	\N	\N	\N	\N	136049	136049	136050
27430	44232	1	applied	\N	\N	\N	\N	136051	136051	136052
27430	44233	2	applied	\N	\N	\N	\N	136053	136053	136054
27434	44237	0	applied	\N	\N	\N	\N	136067	136067	136068
27434	44238	1	applied	\N	\N	\N	\N	136069	136069	136070
27434	44239	2	applied	\N	\N	\N	\N	136071	136071	136072
27438	44243	0	applied	\N	\N	\N	\N	136089	136089	136090
27442	44244	0	applied	\N	\N	\N	\N	136092	136092	136093
27442	44245	1	applied	\N	\N	\N	\N	136094	136094	136095
27442	44246	2	applied	\N	\N	\N	\N	136096	136096	136097
27442	44247	3	applied	\N	\N	\N	\N	136098	136098	136099
27442	44248	4	applied	\N	\N	\N	\N	136100	136100	136101
27442	44249	5	applied	\N	\N	\N	\N	136102	136102	136103
27442	44243	6	applied	\N	\N	\N	\N	136089	136089	136090
27444	44243	0	applied	\N	\N	\N	\N	136089	136089	136090
27448	44253	0	applied	\N	\N	\N	\N	136124	136124	136125
27448	44254	1	applied	\N	\N	\N	\N	136126	136126	136127
27448	44255	2	applied	\N	\N	\N	\N	136128	136128	136129
27448	44256	3	applied	\N	\N	\N	\N	136130	136130	136131
27448	44257	4	applied	\N	\N	\N	\N	136132	136132	136133
27448	44258	5	applied	\N	\N	\N	\N	136134	136134	136135
27452	44259	0	applied	\N	\N	\N	\N	136144	136144	136145
27452	44260	1	applied	\N	\N	\N	\N	136146	136146	136147
27452	44261	2	applied	\N	\N	\N	\N	136148	136148	136149
27456	44268	0	applied	\N	\N	\N	\N	136166	136166	136167
27456	44269	1	applied	\N	\N	\N	\N	136168	136168	136169
27456	44270	2	applied	\N	\N	\N	\N	136170	136170	136171
27459	44285	0	applied	\N	\N	\N	\N	136205	136205	136206
27459	44286	1	applied	\N	\N	\N	\N	136207	136207	136208
27459	44287	2	applied	\N	\N	\N	\N	136209	136209	136210
27459	44288	3	applied	\N	\N	\N	\N	136211	136211	136212
27459	44289	4	applied	\N	\N	\N	\N	136213	136213	136214
27459	44290	5	applied	\N	\N	\N	\N	136215	136215	136216
27459	44291	6	applied	\N	\N	\N	\N	136217	136217	136218
27459	44292	7	applied	\N	\N	\N	\N	136219	136219	136220
27459	44293	8	applied	\N	\N	\N	\N	136221	136221	136222
27461	44294	0	applied	\N	\N	\N	\N	136225	136225	136226
27461	44295	1	applied	\N	\N	\N	\N	136227	136227	136228
27461	44296	2	applied	\N	\N	\N	\N	136229	136229	136230
27461	44297	3	applied	\N	\N	\N	\N	136231	136231	136232
27461	44298	4	applied	\N	\N	\N	\N	136233	136233	136234
27461	44299	5	applied	\N	\N	\N	\N	136235	136235	136236
27461	44300	6	applied	\N	\N	\N	\N	136237	136237	136238
27461	44301	7	applied	\N	\N	\N	\N	136239	136239	136240
27461	44302	8	applied	\N	\N	\N	\N	136241	136241	136242
27465	44303	0	applied	\N	\N	\N	\N	136249	136249	136250
27465	44304	1	applied	\N	\N	\N	\N	136251	136251	136252
27465	44305	2	applied	\N	\N	\N	\N	136253	136253	136254
27465	44306	3	applied	\N	\N	\N	\N	136255	136255	136256
27465	44307	4	applied	\N	\N	\N	\N	136257	136257	136258
27465	44308	5	applied	\N	\N	\N	\N	136259	136259	136260
27465	44309	6	applied	\N	\N	\N	\N	136261	136261	136262
27465	44310	7	applied	\N	\N	\N	\N	136263	136263	136264
27469	44335	0	applied	\N	\N	\N	\N	136319	136319	136320
27469	44336	1	applied	\N	\N	\N	\N	136321	136321	136322
27469	44337	2	applied	\N	\N	\N	\N	136323	136323	136324
27469	44338	3	applied	\N	\N	\N	\N	136325	136325	136326
27469	44339	4	applied	\N	\N	\N	\N	136327	136327	136328
27469	44340	5	applied	\N	\N	\N	\N	136329	136329	136330
27469	44341	6	applied	\N	\N	\N	\N	136331	136331	136332
27469	44342	7	applied	\N	\N	\N	\N	136333	136333	136334
27471	44343	0	applied	\N	\N	\N	\N	136337	136337	136338
27471	44344	1	applied	\N	\N	\N	\N	136339	136339	136340
27471	44345	2	applied	\N	\N	\N	\N	136341	136341	136342
27471	44346	3	applied	\N	\N	\N	\N	136343	136343	136344
27471	44347	4	applied	\N	\N	\N	\N	136345	136345	136346
27471	44348	5	applied	\N	\N	\N	\N	136347	136347	136348
27471	44349	6	applied	\N	\N	\N	\N	136349	136349	136350
27484	44417	0	applied	\N	\N	\N	\N	136503	136503	136504
27484	44418	1	applied	\N	\N	\N	\N	136505	136505	136506
27484	44419	2	applied	\N	\N	\N	\N	136507	136507	136508
27484	44420	3	applied	\N	\N	\N	\N	136509	136509	136510
27484	44421	4	applied	\N	\N	\N	\N	136511	136511	136512
27484	44422	5	applied	\N	\N	\N	\N	136513	136513	136514
27484	44423	6	applied	\N	\N	\N	\N	136515	136515	136516
27484	44424	7	applied	\N	\N	\N	\N	136517	136517	136518
27484	44425	8	applied	\N	\N	\N	\N	136519	136519	136520
27484	44426	9	applied	\N	\N	\N	\N	136521	136521	136522
27484	44427	10	applied	\N	\N	\N	\N	136523	136523	136524
27484	44428	11	applied	\N	\N	\N	\N	136525	136525	136526
27484	44429	12	applied	\N	\N	\N	\N	136527	136527	136089
27484	44430	13	applied	\N	\N	\N	\N	136528	136528	136529
27484	44431	14	applied	\N	\N	\N	\N	136530	136530	136531
27484	44432	15	applied	\N	\N	\N	\N	136532	136532	136533
27484	44433	16	applied	\N	\N	\N	\N	136534	136534	136535
27484	44434	17	applied	\N	\N	\N	\N	136536	136536	136537
27392	44159	0	applied	\N	\N	\N	\N	135831	135831	135832
27392	44160	1	applied	\N	\N	\N	\N	135833	135833	135834
27392	44161	2	applied	\N	\N	\N	\N	135835	135835	135836
27395	44162	0	applied	\N	\N	\N	\N	135838	135838	135839
27395	44163	1	applied	\N	\N	\N	\N	135840	135840	135841
27395	44164	2	applied	\N	\N	\N	\N	135842	135842	135843
27395	44165	3	applied	\N	\N	\N	\N	135844	135844	135845
27395	44166	4	applied	\N	\N	\N	\N	135846	135846	135847
27395	44167	5	applied	\N	\N	\N	\N	135848	135848	135849
27395	44168	6	applied	\N	\N	\N	\N	135850	135850	135851
27395	44169	7	applied	\N	\N	\N	\N	135852	135852	135853
27395	44170	8	applied	\N	\N	\N	\N	135854	135854	135855
27395	44171	9	applied	\N	\N	\N	\N	135856	135856	135857
27395	44172	10	applied	\N	\N	\N	\N	135858	135858	135859
27395	44173	11	applied	\N	\N	\N	\N	135860	135860	135861
27395	44174	12	applied	\N	\N	\N	\N	135862	135862	135863
27395	44175	13	applied	\N	\N	\N	\N	135864	135864	135865
27395	44176	14	applied	\N	\N	\N	\N	135866	135866	135867
27398	44183	0	applied	\N	\N	\N	\N	135884	135884	135885
27398	44184	1	applied	\N	\N	\N	\N	135886	135886	135887
27398	44185	2	applied	\N	\N	\N	\N	135888	135888	135889
27403	44189	0	applied	\N	\N	\N	\N	135898	135898	135899
27403	44190	1	applied	\N	\N	\N	\N	135900	135900	135901
27403	44191	2	applied	\N	\N	\N	\N	135902	135902	135903
27405	44192	0	applied	\N	\N	\N	\N	135908	135908	135909
27405	44193	1	applied	\N	\N	\N	\N	135910	135910	135911
27405	44194	2	applied	\N	\N	\N	\N	135912	135912	135913
27408	44198	0	applied	\N	\N	\N	\N	135923	135923	135924
27408	44199	1	applied	\N	\N	\N	\N	135925	135925	135926
27408	44200	2	applied	\N	\N	\N	\N	135927	135927	135928
27410	44201	0	applied	\N	\N	\N	\N	135931	135931	135932
27410	44202	1	applied	\N	\N	\N	\N	135933	135933	135934
27410	44203	2	applied	\N	\N	\N	\N	135935	135935	135936
27417	44207	0	applied	\N	\N	\N	\N	135953	135953	135954
27417	44208	1	applied	\N	\N	\N	\N	135955	135955	135956
27417	44209	2	applied	\N	\N	\N	\N	135957	135957	135958
27421	44210	0	applied	\N	\N	\N	\N	135967	135967	135968
27421	44211	1	applied	\N	\N	\N	\N	135969	135969	135970
27421	44212	2	applied	\N	\N	\N	\N	135971	135971	135972
27421	44213	3	applied	\N	\N	\N	\N	135973	135973	135974
27421	44214	4	applied	\N	\N	\N	\N	135975	135975	135976
27421	44215	5	applied	\N	\N	\N	\N	135977	135977	135978
27421	44216	6	applied	\N	\N	\N	\N	135979	135979	135980
27421	44217	7	applied	\N	\N	\N	\N	135981	135981	135982
27421	44218	8	applied	\N	\N	\N	\N	135983	135983	135984
27422	44210	0	applied	\N	\N	\N	\N	135967	135967	135968
27422	44211	1	applied	\N	\N	\N	\N	135969	135969	135970
27422	44212	2	applied	\N	\N	\N	\N	135971	135971	135972
27422	44213	3	applied	\N	\N	\N	\N	135973	135973	135974
27422	44214	4	applied	\N	\N	\N	\N	135975	135975	135976
27422	44215	5	applied	\N	\N	\N	\N	135977	135977	135978
27422	44216	6	applied	\N	\N	\N	\N	135979	135979	135980
27422	44217	7	applied	\N	\N	\N	\N	135981	135981	135982
27422	44218	8	applied	\N	\N	\N	\N	135983	135983	135984
27423	44098	0	applied	\N	\N	\N	\N	135680	135680	135097
27423	44100	1	applied	\N	\N	\N	\N	135684	135684	135988
27423	44104	2	applied	\N	\N	\N	\N	135694	135694	135989
27423	44107	3	applied	\N	\N	\N	\N	135704	135704	135990
27423	44113	4	applied	\N	\N	\N	\N	135718	135718	135991
27423	44114	5	applied	\N	\N	\N	\N	135720	135720	135992
27423	44120	6	applied	\N	\N	\N	\N	135732	135732	135109
27423	44121	7	applied	\N	\N	\N	\N	135734	135734	135993
27423	44122	8	applied	\N	\N	\N	\N	135736	135736	135994
27423	44126	9	applied	\N	\N	\N	\N	135747	135747	135136
27423	44127	10	applied	\N	\N	\N	\N	135749	135749	135138
27423	44131	11	applied	\N	\N	\N	\N	135758	135758	135995
27423	44133	12	applied	\N	\N	\N	\N	135762	135762	135996
27423	44139	13	applied	\N	\N	\N	\N	135778	135778	135154
27423	44142	14	applied	\N	\N	\N	\N	135784	135784	135997
27423	44143	15	applied	\N	\N	\N	\N	135786	135786	135998
27423	44145	16	applied	\N	\N	\N	\N	135794	135794	135171
27423	44149	17	applied	\N	\N	\N	\N	135805	135805	135999
27423	44150	18	applied	\N	\N	\N	\N	135807	135807	136000
27423	44156	19	applied	\N	\N	\N	\N	135823	135823	136001
27423	44158	20	applied	\N	\N	\N	\N	135827	135827	135183
27423	44161	21	applied	\N	\N	\N	\N	135835	135835	135190
27423	44172	22	applied	\N	\N	\N	\N	135858	135858	136002
27423	44173	23	applied	\N	\N	\N	\N	135860	135860	136003
27423	44174	24	applied	\N	\N	\N	\N	135862	135862	136004
27423	44175	25	applied	\N	\N	\N	\N	135864	135864	135196
27423	44176	26	applied	\N	\N	\N	\N	135866	135866	136005
27423	44180	27	applied	\N	\N	\N	\N	135876	135876	136006
27423	44182	28	applied	\N	\N	\N	\N	135880	135880	136007
27423	44185	30	applied	\N	\N	\N	\N	135888	135888	135209
27423	44188	31	applied	\N	\N	\N	\N	135896	135896	135211
27423	44191	32	applied	\N	\N	\N	\N	135902	135902	136009
27423	44193	33	applied	\N	\N	\N	\N	135910	135910	136010
27423	44197	34	applied	\N	\N	\N	\N	135919	135919	136011
27423	44200	35	applied	\N	\N	\N	\N	135927	135927	136012
27423	44203	36	applied	\N	\N	\N	\N	135935	135935	135227
27423	44206	37	applied	\N	\N	\N	\N	135947	135947	136013
27423	44209	38	applied	\N	\N	\N	\N	135957	135957	136014
27423	44214	39	applied	\N	\N	\N	\N	135975	135975	136015
27423	44215	40	applied	\N	\N	\N	\N	135977	135977	135239
27423	44218	41	applied	\N	\N	\N	\N	135983	135983	135241
27428	44231	0	applied	\N	\N	\N	\N	136049	136049	136050
27428	44232	1	applied	\N	\N	\N	\N	136051	136051	136052
27428	44233	2	applied	\N	\N	\N	\N	136053	136053	136054
27432	44234	0	applied	\N	\N	\N	\N	136061	136061	136062
27432	44235	1	applied	\N	\N	\N	\N	136063	136063	136064
27432	44236	2	applied	\N	\N	\N	\N	136065	136065	136066
27436	44237	0	applied	\N	\N	\N	\N	136067	136067	136068
27436	44238	1	applied	\N	\N	\N	\N	136069	136069	136070
27436	44239	2	applied	\N	\N	\N	\N	136071	136071	136072
27437	44240	0	applied	\N	\N	\N	\N	136081	136081	136082
27437	44241	1	applied	\N	\N	\N	\N	136083	136083	136084
27437	44242	2	applied	\N	\N	\N	\N	136085	136085	136086
27440	44244	0	applied	\N	\N	\N	\N	136092	136092	136093
27440	44245	1	applied	\N	\N	\N	\N	136094	136094	136095
27440	44246	2	applied	\N	\N	\N	\N	136096	136096	136097
27440	44247	3	applied	\N	\N	\N	\N	136098	136098	136099
27440	44248	4	applied	\N	\N	\N	\N	136100	136100	136101
27440	44249	5	applied	\N	\N	\N	\N	136102	136102	136103
27440	44243	6	applied	\N	\N	\N	\N	136089	136089	136090
27443	44243	0	applied	\N	\N	\N	\N	136089	136089	136090
27446	44253	0	applied	\N	\N	\N	\N	136124	136124	136125
27446	44254	1	applied	\N	\N	\N	\N	136126	136126	136127
27446	44255	2	applied	\N	\N	\N	\N	136128	136128	136129
27446	44256	3	applied	\N	\N	\N	\N	136130	136130	136131
27446	44257	4	applied	\N	\N	\N	\N	136132	136132	136133
27446	44258	5	applied	\N	\N	\N	\N	136134	136134	136135
27450	44253	0	applied	\N	\N	\N	\N	136124	136124	136125
27450	44254	1	applied	\N	\N	\N	\N	136126	136126	136127
27450	44255	2	applied	\N	\N	\N	\N	136128	136128	136129
27450	44256	3	applied	\N	\N	\N	\N	136130	136130	136131
27450	44257	4	applied	\N	\N	\N	\N	136132	136132	136133
27450	44258	5	applied	\N	\N	\N	\N	136134	136134	136135
27455	44265	0	applied	\N	\N	\N	\N	136159	136159	136160
27455	44266	1	applied	\N	\N	\N	\N	136161	136161	136162
27455	44267	2	applied	\N	\N	\N	\N	136163	136163	136164
27457	44268	0	applied	\N	\N	\N	\N	136166	136166	136167
27457	44269	1	applied	\N	\N	\N	\N	136168	136168	136169
27457	44270	2	applied	\N	\N	\N	\N	136170	136170	136171
27460	44294	0	applied	\N	\N	\N	\N	136225	136225	136226
27460	44295	1	applied	\N	\N	\N	\N	136227	136227	136228
27460	44296	2	applied	\N	\N	\N	\N	136229	136229	136230
27460	44297	3	applied	\N	\N	\N	\N	136231	136231	136232
27460	44298	4	applied	\N	\N	\N	\N	136233	136233	136234
27460	44299	5	applied	\N	\N	\N	\N	136235	136235	136236
27460	44300	6	applied	\N	\N	\N	\N	136237	136237	136238
27460	44301	7	applied	\N	\N	\N	\N	136239	136239	136240
27460	44302	8	applied	\N	\N	\N	\N	136241	136241	136242
27463	44295	0	applied	\N	\N	\N	\N	136227	136227	136228
27463	44297	1	applied	\N	\N	\N	\N	136231	136231	136232
27463	44298	2	applied	\N	\N	\N	\N	136233	136233	136234
27463	44299	3	applied	\N	\N	\N	\N	136235	136235	136236
27463	44300	4	applied	\N	\N	\N	\N	136237	136237	136238
27463	44301	5	applied	\N	\N	\N	\N	136239	136239	136240
27467	44311	0	applied	\N	\N	\N	\N	136269	136269	136270
27467	44312	1	applied	\N	\N	\N	\N	136271	136271	136272
27467	44313	2	applied	\N	\N	\N	\N	136273	136273	136274
27467	44314	3	applied	\N	\N	\N	\N	136275	136275	136276
27467	44315	4	applied	\N	\N	\N	\N	136277	136277	136278
27467	44316	5	applied	\N	\N	\N	\N	136279	136279	136280
27467	44317	6	applied	\N	\N	\N	\N	136281	136281	136282
27467	44318	7	applied	\N	\N	\N	\N	136283	136283	136284
27467	44319	8	applied	\N	\N	\N	\N	136285	136285	136286
27467	44320	9	applied	\N	\N	\N	\N	136287	136287	136288
27467	44321	10	applied	\N	\N	\N	\N	136289	136289	136290
27467	44322	11	applied	\N	\N	\N	\N	136291	136291	136292
27467	44323	12	applied	\N	\N	\N	\N	136293	136293	136294
27467	44324	13	applied	\N	\N	\N	\N	136295	136295	136296
27467	44325	14	applied	\N	\N	\N	\N	136297	136297	136298
27467	44326	15	applied	\N	\N	\N	\N	136299	136299	136300
27467	44327	16	applied	\N	\N	\N	\N	136301	136301	136302
27467	44328	17	applied	\N	\N	\N	\N	136303	136303	136304
27467	44329	18	applied	\N	\N	\N	\N	136305	136305	136306
27467	44330	19	applied	\N	\N	\N	\N	136307	136307	136308
27467	44331	20	applied	\N	\N	\N	\N	136309	136309	136310
27467	44332	21	applied	\N	\N	\N	\N	136311	136311	136312
27467	44333	22	applied	\N	\N	\N	\N	136313	136313	136314
27467	44334	23	applied	\N	\N	\N	\N	136315	136315	136316
27472	44343	0	applied	\N	\N	\N	\N	136337	136337	136338
27472	44344	1	applied	\N	\N	\N	\N	136339	136339	136340
27472	44345	2	applied	\N	\N	\N	\N	136341	136341	136342
27472	44346	3	applied	\N	\N	\N	\N	136343	136343	136344
27472	44347	4	applied	\N	\N	\N	\N	136345	136345	136346
27472	44348	5	applied	\N	\N	\N	\N	136347	136347	136348
27472	44349	6	applied	\N	\N	\N	\N	136349	136349	136350
27473	44343	0	applied	\N	\N	\N	\N	136337	136337	136338
27473	44344	1	applied	\N	\N	\N	\N	136339	136339	136340
27473	44345	2	applied	\N	\N	\N	\N	136341	136341	136342
27473	44346	3	applied	\N	\N	\N	\N	136343	136343	136344
27473	44347	4	applied	\N	\N	\N	\N	136345	136345	136346
27473	44348	5	applied	\N	\N	\N	\N	136347	136347	136348
27473	44349	6	applied	\N	\N	\N	\N	136349	136349	136350
27485	44441	0	applied	\N	\N	\N	\N	136552	136552	136553
27485	44442	1	applied	\N	\N	\N	\N	136554	136554	136555
27485	44443	2	applied	\N	\N	\N	\N	136556	136556	136557
27485	44444	3	applied	\N	\N	\N	\N	136558	136558	136559
27485	44445	4	applied	\N	\N	\N	\N	136560	136560	136561
27485	44446	5	applied	\N	\N	\N	\N	136562	136562	136563
27485	44447	6	applied	\N	\N	\N	\N	136564	136564	136565
27485	44448	7	applied	\N	\N	\N	\N	136566	136566	136567
27490	44476	0	applied	\N	\N	\N	\N	136633	136633	136634
27490	44477	1	applied	\N	\N	\N	\N	136635	136635	136636
27490	44478	2	applied	\N	\N	\N	\N	136637	136637	136638
27490	44479	3	applied	\N	\N	\N	\N	136639	136639	136640
27490	44480	4	applied	\N	\N	\N	\N	136641	136641	136642
27490	44481	5	applied	\N	\N	\N	\N	136643	136643	136644
27490	44482	6	applied	\N	\N	\N	\N	136645	136645	136646
27490	44483	7	applied	\N	\N	\N	\N	136647	136647	136648
27490	44484	8	applied	\N	\N	\N	\N	136649	136649	136650
27490	44485	9	applied	\N	\N	\N	\N	136651	136651	136652
27493	44489	0	applied	\N	\N	\N	\N	136661	136661	136662
27493	44490	1	applied	\N	\N	\N	\N	136663	136663	136664
27493	44491	2	applied	\N	\N	\N	\N	136665	136665	136666
27493	44492	3	applied	\N	\N	\N	\N	136667	136667	136668
27500	44509	0	applied	\N	\N	\N	\N	136714	136714	136715
27500	44510	1	applied	\N	\N	\N	\N	136716	136716	136717
27500	44511	2	applied	\N	\N	\N	\N	136718	136718	136719
27502	44509	0	applied	\N	\N	\N	\N	136714	136714	136715
27502	44510	1	applied	\N	\N	\N	\N	136716	136716	136717
27502	44511	2	applied	\N	\N	\N	\N	136718	136718	136719
27505	44521	0	applied	\N	\N	\N	\N	136747	136747	136748
27505	44522	1	applied	\N	\N	\N	\N	136749	136749	136750
27505	44523	2	applied	\N	\N	\N	\N	136751	136751	136752
27505	44524	3	applied	\N	\N	\N	\N	136753	136753	136754
27505	44525	4	applied	\N	\N	\N	\N	136755	136755	136756
27505	44526	5	applied	\N	\N	\N	\N	136757	136757	136758
27507	44530	0	applied	\N	\N	\N	\N	136768	136768	136769
27507	44531	1	applied	\N	\N	\N	\N	136770	136770	136771
27507	44532	2	applied	\N	\N	\N	\N	136772	136772	136773
27507	44533	3	applied	\N	\N	\N	\N	136774	136774	136775
27507	44534	4	applied	\N	\N	\N	\N	136776	136776	136777
27507	44535	5	applied	\N	\N	\N	\N	136778	136778	136779
27507	44536	6	applied	\N	\N	\N	\N	136780	136780	136781
27507	44537	7	applied	\N	\N	\N	\N	136782	136782	136783
27507	44538	8	applied	\N	\N	\N	\N	136784	136784	136785
27507	44539	9	applied	\N	\N	\N	\N	136786	136786	136787
27507	44540	10	applied	\N	\N	\N	\N	136788	136788	136789
27507	44541	11	applied	\N	\N	\N	\N	136790	136790	136791
27507	44542	12	applied	\N	\N	\N	\N	136792	136792	136793
27507	44543	13	applied	\N	\N	\N	\N	136794	136794	136795
27507	44544	14	applied	\N	\N	\N	\N	136796	136796	136797
27508	44530	0	applied	\N	\N	\N	\N	136768	136768	136769
27508	44531	1	applied	\N	\N	\N	\N	136770	136770	136771
27508	44532	2	applied	\N	\N	\N	\N	136772	136772	136773
27508	44533	3	applied	\N	\N	\N	\N	136774	136774	136775
27508	44534	4	applied	\N	\N	\N	\N	136776	136776	136777
27449	44254	1	applied	\N	\N	\N	\N	136126	136126	136127
27449	44255	2	applied	\N	\N	\N	\N	136128	136128	136129
27449	44256	3	applied	\N	\N	\N	\N	136130	136130	136131
27449	44257	4	applied	\N	\N	\N	\N	136132	136132	136133
27449	44258	5	applied	\N	\N	\N	\N	136134	136134	136135
27454	44265	0	applied	\N	\N	\N	\N	136159	136159	136160
27454	44266	1	applied	\N	\N	\N	\N	136161	136161	136162
27454	44267	2	applied	\N	\N	\N	\N	136163	136163	136164
27462	44294	0	applied	\N	\N	\N	\N	136225	136225	136226
27462	44295	1	applied	\N	\N	\N	\N	136227	136227	136228
27462	44296	2	applied	\N	\N	\N	\N	136229	136229	136230
27462	44297	3	applied	\N	\N	\N	\N	136231	136231	136232
27462	44298	4	applied	\N	\N	\N	\N	136233	136233	136234
27462	44299	5	applied	\N	\N	\N	\N	136235	136235	136236
27462	44300	6	applied	\N	\N	\N	\N	136237	136237	136238
27462	44301	7	applied	\N	\N	\N	\N	136239	136239	136240
27462	44302	8	applied	\N	\N	\N	\N	136241	136241	136242
27466	44303	0	applied	\N	\N	\N	\N	136249	136249	136250
27466	44304	1	applied	\N	\N	\N	\N	136251	136251	136252
27466	44305	2	applied	\N	\N	\N	\N	136253	136253	136254
27466	44306	3	applied	\N	\N	\N	\N	136255	136255	136256
27466	44307	4	applied	\N	\N	\N	\N	136257	136257	136258
27466	44308	5	applied	\N	\N	\N	\N	136259	136259	136260
27466	44309	6	applied	\N	\N	\N	\N	136261	136261	136262
27466	44310	7	applied	\N	\N	\N	\N	136263	136263	136264
27468	44311	0	applied	\N	\N	\N	\N	136269	136269	136270
27468	44312	1	applied	\N	\N	\N	\N	136271	136271	136272
27468	44313	2	applied	\N	\N	\N	\N	136273	136273	136274
27468	44314	3	applied	\N	\N	\N	\N	136275	136275	136276
27468	44315	4	applied	\N	\N	\N	\N	136277	136277	136278
27468	44316	5	applied	\N	\N	\N	\N	136279	136279	136280
27468	44317	6	applied	\N	\N	\N	\N	136281	136281	136282
27468	44318	7	applied	\N	\N	\N	\N	136283	136283	136284
27468	44319	8	applied	\N	\N	\N	\N	136285	136285	136286
27468	44320	9	applied	\N	\N	\N	\N	136287	136287	136288
27468	44321	10	applied	\N	\N	\N	\N	136289	136289	136290
27468	44322	11	applied	\N	\N	\N	\N	136291	136291	136292
27468	44323	12	applied	\N	\N	\N	\N	136293	136293	136294
27468	44324	13	applied	\N	\N	\N	\N	136295	136295	136296
27468	44325	14	applied	\N	\N	\N	\N	136297	136297	136298
27468	44326	15	applied	\N	\N	\N	\N	136299	136299	136300
27468	44327	16	applied	\N	\N	\N	\N	136301	136301	136302
27468	44328	17	applied	\N	\N	\N	\N	136303	136303	136304
27468	44329	18	applied	\N	\N	\N	\N	136305	136305	136306
27468	44330	19	applied	\N	\N	\N	\N	136307	136307	136308
27468	44331	20	applied	\N	\N	\N	\N	136309	136309	136310
27468	44332	21	applied	\N	\N	\N	\N	136311	136311	136312
27468	44333	22	applied	\N	\N	\N	\N	136313	136313	136314
27468	44334	23	applied	\N	\N	\N	\N	136315	136315	136316
27477	44350	0	applied	\N	\N	\N	\N	136357	136357	136358
27477	44351	1	applied	\N	\N	\N	\N	136359	136359	136360
27477	44352	2	applied	\N	\N	\N	\N	136361	136361	136362
27477	44353	3	applied	\N	\N	\N	\N	136363	136363	136364
27477	44354	4	applied	\N	\N	\N	\N	136365	136365	136366
27477	44355	5	applied	\N	\N	\N	\N	136367	136367	136368
27477	44356	6	applied	\N	\N	\N	\N	136369	136369	136370
27477	44357	7	applied	\N	\N	\N	\N	136371	136371	136372
27477	44358	8	applied	\N	\N	\N	\N	136373	136373	136374
27477	44359	9	applied	\N	\N	\N	\N	136375	136375	136376
27477	44360	10	applied	\N	\N	\N	\N	136377	136377	136378
27477	44361	11	applied	\N	\N	\N	\N	136379	136379	136380
27477	44362	12	applied	\N	\N	\N	\N	136381	136381	136382
27477	44363	13	applied	\N	\N	\N	\N	136383	136383	136384
27477	44364	14	applied	\N	\N	\N	\N	136385	136385	136386
27477	44365	15	applied	\N	\N	\N	\N	136387	136387	136388
27477	44366	16	applied	\N	\N	\N	\N	136389	136389	136390
27477	44367	17	applied	\N	\N	\N	\N	136391	136391	136392
27477	44368	18	applied	\N	\N	\N	\N	136393	136393	136394
27477	44369	19	applied	\N	\N	\N	\N	136395	136395	136396
27477	44370	20	applied	\N	\N	\N	\N	136397	136397	136398
27477	44371	21	applied	\N	\N	\N	\N	136399	136399	136400
27477	44372	22	applied	\N	\N	\N	\N	136401	136401	136402
27477	44373	23	applied	\N	\N	\N	\N	136403	136403	136404
27477	44374	24	applied	\N	\N	\N	\N	136405	136405	136406
27477	44375	25	applied	\N	\N	\N	\N	136407	136407	136408
27479	44376	0	applied	\N	\N	\N	\N	136412	136412	136413
27479	44377	1	applied	\N	\N	\N	\N	136414	136414	136415
27479	44378	2	applied	\N	\N	\N	\N	136416	136416	136417
27479	44379	3	applied	\N	\N	\N	\N	136418	136418	136419
27479	44380	4	applied	\N	\N	\N	\N	136420	136420	136421
27479	44381	5	applied	\N	\N	\N	\N	136422	136422	136423
27479	44382	6	applied	\N	\N	\N	\N	136424	136424	136425
27479	44383	7	applied	\N	\N	\N	\N	136426	136426	136427
27482	44402	0	applied	\N	\N	\N	\N	136469	136469	136470
27482	44403	1	applied	\N	\N	\N	\N	136471	136471	136472
27482	44404	2	applied	\N	\N	\N	\N	136473	136473	136474
27482	44405	3	applied	\N	\N	\N	\N	136475	136475	136476
27482	44406	4	applied	\N	\N	\N	\N	136477	136477	136478
27482	44407	5	applied	\N	\N	\N	\N	136479	136479	136480
27482	44408	6	applied	\N	\N	\N	\N	136481	136481	136482
27482	44409	7	applied	\N	\N	\N	\N	136483	136483	136484
27482	44410	8	applied	\N	\N	\N	\N	136485	136485	136486
27486	44449	0	applied	\N	\N	\N	\N	136570	136570	136571
27486	44450	1	applied	\N	\N	\N	\N	136572	136572	136573
27486	44451	2	applied	\N	\N	\N	\N	136574	136574	136575
27486	44452	3	applied	\N	\N	\N	\N	136576	136576	136577
27486	44453	4	applied	\N	\N	\N	\N	136578	136578	136579
27486	44454	5	applied	\N	\N	\N	\N	136580	136580	136581
27486	44455	6	applied	\N	\N	\N	\N	136582	136582	136583
27486	44456	7	applied	\N	\N	\N	\N	136584	136584	136585
27486	44457	8	applied	\N	\N	\N	\N	136586	136586	136587
27486	44458	9	applied	\N	\N	\N	\N	136588	136588	136589
27486	44459	10	applied	\N	\N	\N	\N	136590	136590	136591
27486	44460	11	applied	\N	\N	\N	\N	136592	136592	136593
27486	44461	12	applied	\N	\N	\N	\N	136594	136594	136595
27486	44462	13	applied	\N	\N	\N	\N	136596	136596	136597
27486	44463	15	applied	\N	\N	\N	\N	136599	136599	136600
27486	44464	16	applied	\N	\N	\N	\N	136601	136601	136602
27486	44465	17	applied	\N	\N	\N	\N	136603	136603	136604
27486	44466	18	applied	\N	\N	\N	\N	136605	136605	136606
27486	44467	19	applied	\N	\N	\N	\N	136607	136607	136608
27486	44468	20	applied	\N	\N	\N	\N	136609	136609	136610
27486	44469	21	applied	\N	\N	\N	\N	136611	136611	136612
27486	44470	22	applied	\N	\N	\N	\N	136613	136613	136614
27486	44471	23	applied	\N	\N	\N	\N	136615	136615	136616
27486	44472	24	applied	\N	\N	\N	\N	136617	136617	136618
27486	44473	25	applied	\N	\N	\N	\N	136619	136619	136620
27486	44474	26	applied	\N	\N	\N	\N	136621	136621	136622
27486	44475	27	applied	\N	\N	\N	\N	136623	136623	136624
27496	44502	0	applied	\N	\N	\N	\N	136692	136692	136693
27480	44400	16	applied	\N	\N	\N	\N	136462	136462	136463
27480	44401	17	applied	\N	\N	\N	\N	136464	136464	136465
27481	44384	0	applied	\N	\N	\N	\N	136430	136430	136431
27481	44385	1	applied	\N	\N	\N	\N	136432	136432	136433
27481	44386	2	applied	\N	\N	\N	\N	136434	136434	136435
27481	44387	3	applied	\N	\N	\N	\N	136436	136436	136437
27481	44388	4	applied	\N	\N	\N	\N	136438	136438	136439
27481	44389	5	applied	\N	\N	\N	\N	136440	136440	136441
27481	44390	6	applied	\N	\N	\N	\N	136442	136442	136443
27481	44391	7	applied	\N	\N	\N	\N	136444	136444	136445
27481	44392	8	applied	\N	\N	\N	\N	136446	136446	136447
27481	44393	9	applied	\N	\N	\N	\N	136448	136448	136449
27481	44394	10	applied	\N	\N	\N	\N	136450	136450	136451
27481	44395	11	applied	\N	\N	\N	\N	136452	136452	136453
27481	44396	12	applied	\N	\N	\N	\N	136454	136454	136455
27481	44397	13	applied	\N	\N	\N	\N	136456	136456	136457
27481	44398	14	applied	\N	\N	\N	\N	136458	136458	136459
27481	44399	15	applied	\N	\N	\N	\N	136460	136460	136461
27481	44400	16	applied	\N	\N	\N	\N	136462	136462	136463
27481	44401	17	applied	\N	\N	\N	\N	136464	136464	136465
27483	44411	0	applied	\N	\N	\N	\N	136489	136489	136490
27483	44412	1	applied	\N	\N	\N	\N	136491	136491	136492
27483	44413	2	applied	\N	\N	\N	\N	136493	136493	136494
27483	44414	3	applied	\N	\N	\N	\N	136495	136495	136496
27483	44415	4	applied	\N	\N	\N	\N	136497	136497	136498
27483	44416	5	applied	\N	\N	\N	\N	136499	136499	136500
27487	44449	0	applied	\N	\N	\N	\N	136570	136570	136571
27487	44450	1	applied	\N	\N	\N	\N	136572	136572	136573
27487	44451	2	applied	\N	\N	\N	\N	136574	136574	136575
27487	44452	3	applied	\N	\N	\N	\N	136576	136576	136577
27487	44453	4	applied	\N	\N	\N	\N	136578	136578	136579
27487	44454	5	applied	\N	\N	\N	\N	136580	136580	136581
27487	44455	6	applied	\N	\N	\N	\N	136582	136582	136583
27487	44456	7	applied	\N	\N	\N	\N	136584	136584	136585
27487	44457	8	applied	\N	\N	\N	\N	136586	136586	136587
27487	44458	9	applied	\N	\N	\N	\N	136588	136588	136589
27487	44459	10	applied	\N	\N	\N	\N	136590	136590	136591
27487	44460	11	applied	\N	\N	\N	\N	136592	136592	136593
27487	44461	12	applied	\N	\N	\N	\N	136594	136594	136595
27487	44462	13	applied	\N	\N	\N	\N	136596	136596	136597
27487	44463	15	applied	\N	\N	\N	\N	136599	136599	136600
27487	44464	16	applied	\N	\N	\N	\N	136601	136601	136602
27487	44465	17	applied	\N	\N	\N	\N	136603	136603	136604
27487	44466	18	applied	\N	\N	\N	\N	136605	136605	136606
27487	44467	19	applied	\N	\N	\N	\N	136607	136607	136608
27487	44468	20	applied	\N	\N	\N	\N	136609	136609	136610
27487	44469	21	applied	\N	\N	\N	\N	136611	136611	136612
27487	44470	22	applied	\N	\N	\N	\N	136613	136613	136614
27487	44471	23	applied	\N	\N	\N	\N	136615	136615	136616
27487	44472	24	applied	\N	\N	\N	\N	136617	136617	136618
27487	44473	25	applied	\N	\N	\N	\N	136619	136619	136620
27487	44474	26	applied	\N	\N	\N	\N	136621	136621	136622
27487	44475	27	applied	\N	\N	\N	\N	136623	136623	136624
27489	44449	0	applied	\N	\N	\N	\N	136570	136570	136571
27489	44450	1	applied	\N	\N	\N	\N	136572	136572	136573
27489	44451	2	applied	\N	\N	\N	\N	136574	136574	136575
27489	44452	3	applied	\N	\N	\N	\N	136576	136576	136577
27489	44453	4	applied	\N	\N	\N	\N	136578	136578	136579
27489	44454	5	applied	\N	\N	\N	\N	136580	136580	136581
27489	44455	6	applied	\N	\N	\N	\N	136582	136582	136583
27489	44456	7	applied	\N	\N	\N	\N	136584	136584	136585
27489	44457	8	applied	\N	\N	\N	\N	136586	136586	136587
27489	44458	9	applied	\N	\N	\N	\N	136588	136588	136589
27489	44459	10	applied	\N	\N	\N	\N	136590	136590	136591
27489	44460	11	applied	\N	\N	\N	\N	136592	136592	136593
27489	44461	12	applied	\N	\N	\N	\N	136594	136594	136595
27489	44462	13	applied	\N	\N	\N	\N	136596	136596	136597
27489	44463	15	applied	\N	\N	\N	\N	136599	136599	136600
27489	44464	16	applied	\N	\N	\N	\N	136601	136601	136602
27489	44465	17	applied	\N	\N	\N	\N	136603	136603	136604
27489	44466	18	applied	\N	\N	\N	\N	136605	136605	136606
27489	44467	19	applied	\N	\N	\N	\N	136607	136607	136608
27489	44468	20	applied	\N	\N	\N	\N	136609	136609	136610
27489	44469	21	applied	\N	\N	\N	\N	136611	136611	136612
27489	44470	22	applied	\N	\N	\N	\N	136613	136613	136614
27489	44471	23	applied	\N	\N	\N	\N	136615	136615	136616
27489	44472	24	applied	\N	\N	\N	\N	136617	136617	136618
27489	44473	25	applied	\N	\N	\N	\N	136619	136619	136620
27489	44474	26	applied	\N	\N	\N	\N	136621	136621	136622
27489	44475	27	applied	\N	\N	\N	\N	136623	136623	136624
27491	44486	0	applied	\N	\N	\N	\N	136655	136655	136656
27491	44487	1	applied	\N	\N	\N	\N	136657	136657	136658
27491	44488	2	applied	\N	\N	\N	\N	136659	136659	136660
27494	44493	0	applied	\N	\N	\N	\N	136672	136672	136673
27494	44494	1	applied	\N	\N	\N	\N	136674	136674	136675
27494	44495	2	applied	\N	\N	\N	\N	136676	136676	136677
27494	44496	3	applied	\N	\N	\N	\N	136678	136678	136679
27494	44497	4	applied	\N	\N	\N	\N	136680	136680	136681
27494	44498	5	applied	\N	\N	\N	\N	136682	136682	136683
27504	44518	0	applied	\N	\N	\N	\N	136739	136739	136740
27504	44519	1	applied	\N	\N	\N	\N	136741	136741	136742
27504	44520	2	applied	\N	\N	\N	\N	136743	136743	136744
27509	44545	0	applied	\N	\N	\N	\N	136800	136800	136801
27509	44546	1	applied	\N	\N	\N	\N	136802	136802	136803
27509	44547	2	applied	\N	\N	\N	\N	136804	136804	136805
27509	44548	3	applied	\N	\N	\N	\N	136806	136806	136807
27509	44549	4	applied	\N	\N	\N	\N	136808	136808	136809
27509	44550	5	applied	\N	\N	\N	\N	136810	136810	136811
27509	44551	6	applied	\N	\N	\N	\N	136812	136812	136813
27509	44552	7	applied	\N	\N	\N	\N	136814	136814	136815
27509	44553	8	applied	\N	\N	\N	\N	136816	136816	136817
27518	44560	0	applied	\N	\N	\N	\N	136847	136847	136848
27518	44561	1	applied	\N	\N	\N	\N	136849	136849	136850
27521	44582	0	applied	\N	\N	\N	\N	136897	136897	136898
27521	44583	1	applied	\N	\N	\N	\N	136899	136899	136900
27521	44584	2	applied	\N	\N	\N	\N	136901	136901	136902
27521	44585	3	applied	\N	\N	\N	\N	136903	136903	136904
27524	44596	0	applied	\N	\N	\N	\N	136929	136929	136930
27524	44597	1	applied	\N	\N	\N	\N	136931	136931	136932
27524	44598	2	applied	\N	\N	\N	\N	136933	136933	136934
27531	44605	0	applied	\N	\N	\N	\N	137037	137037	137038
27531	44606	1	applied	\N	\N	\N	\N	137039	137039	137040
27533	44607	0	applied	\N	\N	\N	\N	137043	137043	137044
27533	44608	1	applied	\N	\N	\N	\N	137045	137045	137046
27533	44609	2	applied	\N	\N	\N	\N	137047	137047	137048
27535	44610	0	applied	\N	\N	\N	\N	137057	137057	137058
27535	44611	1	applied	\N	\N	\N	\N	137059	137059	137060
27535	44612	2	applied	\N	\N	\N	\N	137061	137061	137062
27535	44613	3	applied	\N	\N	\N	\N	137063	137063	137064
27535	44614	4	applied	\N	\N	\N	\N	137065	137065	137066
27484	44435	18	applied	\N	\N	\N	\N	136538	136538	136539
27484	44436	19	applied	\N	\N	\N	\N	136540	136540	136541
27484	44437	20	applied	\N	\N	\N	\N	136542	136542	136543
27484	44438	21	applied	\N	\N	\N	\N	136544	136544	136545
27484	44439	22	applied	\N	\N	\N	\N	136546	136546	136547
27484	44440	23	applied	\N	\N	\N	\N	136548	136548	136549
27488	44449	0	applied	\N	\N	\N	\N	136570	136570	136571
27488	44450	1	applied	\N	\N	\N	\N	136572	136572	136573
27488	44451	2	applied	\N	\N	\N	\N	136574	136574	136575
27488	44452	3	applied	\N	\N	\N	\N	136576	136576	136577
27488	44453	4	applied	\N	\N	\N	\N	136578	136578	136579
27488	44454	5	applied	\N	\N	\N	\N	136580	136580	136581
27488	44455	6	applied	\N	\N	\N	\N	136582	136582	136583
27488	44456	7	applied	\N	\N	\N	\N	136584	136584	136585
27488	44457	8	applied	\N	\N	\N	\N	136586	136586	136587
27488	44458	9	applied	\N	\N	\N	\N	136588	136588	136589
27488	44459	10	applied	\N	\N	\N	\N	136590	136590	136591
27488	44460	11	applied	\N	\N	\N	\N	136592	136592	136593
27488	44461	12	applied	\N	\N	\N	\N	136594	136594	136595
27488	44462	13	applied	\N	\N	\N	\N	136596	136596	136597
27488	44463	15	applied	\N	\N	\N	\N	136599	136599	136600
27488	44464	16	applied	\N	\N	\N	\N	136601	136601	136602
27488	44465	17	applied	\N	\N	\N	\N	136603	136603	136604
27488	44466	18	applied	\N	\N	\N	\N	136605	136605	136606
27488	44467	19	applied	\N	\N	\N	\N	136607	136607	136608
27488	44468	20	applied	\N	\N	\N	\N	136609	136609	136610
27488	44469	21	applied	\N	\N	\N	\N	136611	136611	136612
27488	44470	22	applied	\N	\N	\N	\N	136613	136613	136614
27488	44471	23	applied	\N	\N	\N	\N	136615	136615	136616
27488	44472	24	applied	\N	\N	\N	\N	136617	136617	136618
27488	44473	25	applied	\N	\N	\N	\N	136619	136619	136620
27488	44474	26	applied	\N	\N	\N	\N	136621	136621	136622
27488	44475	27	applied	\N	\N	\N	\N	136623	136623	136624
27492	44489	0	applied	\N	\N	\N	\N	136661	136661	136662
27492	44490	1	applied	\N	\N	\N	\N	136663	136663	136664
27492	44491	2	applied	\N	\N	\N	\N	136665	136665	136666
27492	44492	3	applied	\N	\N	\N	\N	136667	136667	136668
27495	44499	0	applied	\N	\N	\N	\N	136686	136686	136687
27495	44500	1	applied	\N	\N	\N	\N	136688	136688	136689
27495	44501	2	applied	\N	\N	\N	\N	136690	136690	136691
27497	44502	0	applied	\N	\N	\N	\N	136692	136692	136693
27497	44503	1	applied	\N	\N	\N	\N	136694	136694	136695
27497	44504	2	applied	\N	\N	\N	\N	136696	136696	136697
27506	44527	0	applied	\N	\N	\N	\N	136760	136760	136761
27506	44528	1	applied	\N	\N	\N	\N	136762	136762	136763
27506	44529	2	applied	\N	\N	\N	\N	136764	136764	136765
27510	44554	0	applied	\N	\N	\N	\N	136820	136820	136821
27510	44555	1	applied	\N	\N	\N	\N	136822	136822	136823
27510	44556	2	applied	\N	\N	\N	\N	136824	136824	136825
27512	44554	0	applied	\N	\N	\N	\N	136820	136820	136821
27512	44556	1	applied	\N	\N	\N	\N	136824	136824	136830
27514	44557	0	applied	\N	\N	\N	\N	136832	136832	136833
27514	44558	2	applied	\N	\N	\N	\N	136835	136835	136836
27514	44559	3	applied	\N	\N	\N	\N	136840	136840	136841
27516	44557	0	applied	\N	\N	\N	\N	136832	136832	136833
27516	44558	2	applied	\N	\N	\N	\N	136835	136835	136836
27516	44559	3	applied	\N	\N	\N	\N	136840	136840	136841
27522	44586	0	applied	\N	\N	\N	\N	136907	136907	136908
27522	44587	1	applied	\N	\N	\N	\N	136909	136909	136910
27522	44588	2	applied	\N	\N	\N	\N	136911	136911	136912
27525	44596	0	applied	\N	\N	\N	\N	136929	136929	136930
27525	44597	1	applied	\N	\N	\N	\N	136931	136931	136932
27525	44598	2	applied	\N	\N	\N	\N	136933	136933	136934
27529	44599	0	applied	\N	\N	\N	\N	137021	137021	137022
27529	44600	1	applied	\N	\N	\N	\N	137023	137023	137024
27529	44601	2	applied	\N	\N	\N	\N	137025	137025	137026
27529	44602	3	applied	\N	\N	\N	\N	137027	137027	137028
27529	44603	4	applied	\N	\N	\N	\N	137029	137029	137030
27529	44604	5	applied	\N	\N	\N	\N	137031	137031	137032
27536	44610	0	applied	\N	\N	\N	\N	137057	137057	137058
27536	44611	1	applied	\N	\N	\N	\N	137059	137059	137060
27536	44612	2	applied	\N	\N	\N	\N	137061	137061	137062
27536	44613	3	applied	\N	\N	\N	\N	137063	137063	137064
27536	44614	4	applied	\N	\N	\N	\N	137065	137065	137066
27536	44615	5	applied	\N	\N	\N	\N	137067	137067	137068
27536	44616	6	applied	\N	\N	\N	\N	137069	137069	137070
27540	44617	0	applied	\N	\N	\N	\N	137076	137076	137077
27540	44618	1	applied	\N	\N	\N	\N	137078	137078	137079
27540	44619	2	applied	\N	\N	\N	\N	137080	137080	137081
27545	44624	0	applied	\N	\N	\N	\N	137099	137099	137100
27545	44625	1	applied	\N	\N	\N	\N	137101	137101	137102
27545	44626	2	applied	\N	\N	\N	\N	137103	137103	137104
27545	44627	3	applied	\N	\N	\N	\N	137105	137105	137106
27545	44628	4	applied	\N	\N	\N	\N	137107	137107	137108
27545	44629	5	applied	\N	\N	\N	\N	137109	137109	137110
27545	44630	6	applied	\N	\N	\N	\N	137111	137111	137112
27545	44631	7	applied	\N	\N	\N	\N	137113	137113	137114
27545	44632	8	applied	\N	\N	\N	\N	137115	137115	137116
27552	44644	0	applied	\N	\N	\N	\N	137151	137151	137152
27552	44645	1	applied	\N	\N	\N	\N	137153	137153	137154
27552	44646	2	applied	\N	\N	\N	\N	137155	137155	137156
27552	44647	3	applied	\N	\N	\N	\N	137157	137157	137158
27556	44648	0	applied	\N	\N	\N	\N	137162	137162	137163
27556	44649	1	applied	\N	\N	\N	\N	137164	137164	137165
27556	44650	2	applied	\N	\N	\N	\N	137166	137166	137167
27563	44657	0	applied	\N	\N	\N	\N	137191	137191	137192
27563	44658	1	applied	\N	\N	\N	\N	137193	137193	137194
27563	44659	2	applied	\N	\N	\N	\N	137195	137195	137196
27565	44657	0	applied	\N	\N	\N	\N	137191	137191	137192
27565	44658	1	applied	\N	\N	\N	\N	137193	137193	137194
27565	44659	2	applied	\N	\N	\N	\N	137195	137195	137196
27577	44563	0	applied	\N	\N	\N	\N	136937	136937	137256
27577	44565	1	applied	\N	\N	\N	\N	136860	136860	137257
27577	44571	2	applied	\N	\N	\N	\N	136874	136874	137258
27577	44506	3	applied	\N	\N	\N	\N	136704	136704	130486
27577	44273	4	applied	\N	\N	\N	\N	137259	137259	136181
27577	44583	5	applied	\N	\N	\N	\N	136899	136899	135249
27577	44387	6	applied	\N	\N	\N	\N	136436	136436	136437
27577	44222	7	applied	\N	\N	\N	\N	136028	136028	135251
27577	44223	8	applied	\N	\N	\N	\N	136030	136030	137260
27577	44224	9	applied	\N	\N	\N	\N	136032	136032	137261
27577	44274	10	applied	\N	\N	\N	\N	137262	137262	136183
27577	44229	11	applied	\N	\N	\N	\N	136045	136045	137263
27577	44275	12	applied	\N	\N	\N	\N	137264	137264	136185
27577	44233	13	applied	\N	\N	\N	\N	136053	136053	137265
27577	44235	14	applied	\N	\N	\N	\N	136063	136063	135273
27577	44239	15	applied	\N	\N	\N	\N	136071	136071	137266
27577	44276	16	applied	\N	\N	\N	\N	137267	137267	136187
27577	44277	17	applied	\N	\N	\N	\N	137268	137268	136189
27577	44278	18	applied	\N	\N	\N	\N	137269	137269	136191
27496	44503	1	applied	\N	\N	\N	\N	136694	136694	136695
27496	44504	2	applied	\N	\N	\N	\N	136696	136696	136697
27498	44505	0	applied	\N	\N	\N	\N	136702	136702	136703
27498	44506	1	applied	\N	\N	\N	\N	136704	136704	136705
27498	44507	2	applied	\N	\N	\N	\N	136706	136706	136707
27498	44508	3	applied	\N	\N	\N	\N	136708	136708	136709
27499	44505	0	applied	\N	\N	\N	\N	136702	136702	136703
27499	44506	1	applied	\N	\N	\N	\N	136704	136704	136705
27499	44507	2	applied	\N	\N	\N	\N	136706	136706	136707
27499	44508	3	applied	\N	\N	\N	\N	136708	136708	136709
27501	44509	0	applied	\N	\N	\N	\N	136714	136714	136715
27501	44510	1	applied	\N	\N	\N	\N	136716	136716	136717
27501	44511	2	applied	\N	\N	\N	\N	136718	136718	136719
27503	44512	0	applied	\N	\N	\N	\N	136725	136725	136726
27503	44513	1	applied	\N	\N	\N	\N	136727	136727	136728
27503	44514	2	applied	\N	\N	\N	\N	136729	136729	136730
27503	44515	3	applied	\N	\N	\N	\N	136731	136731	136732
27503	44516	4	applied	\N	\N	\N	\N	136733	136733	136734
27503	44517	5	applied	\N	\N	\N	\N	136735	136735	136736
27511	44554	0	applied	\N	\N	\N	\N	136820	136820	136821
27511	44555	1	applied	\N	\N	\N	\N	136822	136822	136823
27511	44556	2	applied	\N	\N	\N	\N	136824	136824	136825
27513	44557	0	applied	\N	\N	\N	\N	136832	136832	136833
27513	44558	2	applied	\N	\N	\N	\N	136835	136835	136836
27517	44560	0	applied	\N	\N	\N	\N	136847	136847	136848
27517	44561	1	applied	\N	\N	\N	\N	136849	136849	136850
27517	44562	2	applied	\N	\N	\N	\N	136851	136851	136852
27520	44568	0	applied	\N	\N	\N	\N	136868	136868	136869
27520	44569	1	applied	\N	\N	\N	\N	136870	136870	136871
27520	44570	2	applied	\N	\N	\N	\N	136872	136872	136873
27520	44571	3	applied	\N	\N	\N	\N	136874	136874	136875
27520	44572	4	applied	\N	\N	\N	\N	136876	136876	136877
27520	44573	5	applied	\N	\N	\N	\N	136878	136878	136879
27520	44574	6	applied	\N	\N	\N	\N	136880	136880	136881
27520	44575	7	applied	\N	\N	1000000000	\N	136882	136882	136883
27520	44576	8	applied	\N	\N	\N	\N	136884	136884	136885
27520	44577	9	applied	\N	\N	\N	\N	136886	136886	136887
27520	44578	10	applied	\N	\N	1000000000	\N	136888	136888	136889
27520	44579	11	applied	\N	\N	\N	\N	136890	136890	136891
27520	44580	12	applied	\N	\N	1000000000	\N	136892	136892	136893
27520	44581	13	applied	\N	\N	\N	\N	136894	136894	136895
27523	44589	0	applied	\N	\N	\N	\N	136914	136914	136915
27523	44590	1	applied	\N	\N	\N	\N	136916	136916	136917
27523	44591	2	applied	\N	\N	\N	\N	136918	136918	136919
27523	44592	3	applied	\N	\N	\N	\N	136920	136920	136921
27523	44593	4	applied	\N	\N	\N	\N	136922	136922	136923
27523	44594	5	applied	\N	\N	\N	\N	136924	136924	136925
27523	44595	6	applied	\N	\N	\N	\N	136926	136926	136927
27528	44563	0	applied	\N	\N	\N	\N	136937	136937	136938
27528	44565	1	applied	\N	\N	\N	\N	136860	136860	136939
27528	44571	2	applied	\N	\N	\N	\N	136874	136874	135685
27528	44506	3	applied	\N	\N	\N	\N	136704	136704	130486
27528	44273	4	applied	\N	\N	\N	\N	136940	136940	136181
27528	44583	5	applied	\N	\N	\N	\N	136899	136899	136941
27528	44387	6	applied	\N	\N	\N	\N	136436	136436	136437
27528	44274	7	applied	\N	\N	\N	\N	136942	136942	136183
27528	44575	8	applied	\N	\N	1000000000	\N	136882	136882	136883
27528	44275	9	applied	\N	\N	\N	\N	136943	136943	136185
27528	44578	10	applied	\N	\N	1000000000	\N	136888	136888	136889
27528	44579	11	applied	\N	\N	\N	\N	136890	136890	136891
27528	44580	12	applied	\N	\N	1000000000	\N	136892	136892	136893
27528	44276	13	applied	\N	\N	\N	\N	136944	136944	136187
27528	44277	14	applied	\N	\N	\N	\N	136945	136945	136189
27528	44278	15	applied	\N	\N	\N	\N	136946	136946	136191
27528	44279	16	applied	\N	\N	\N	\N	136947	136947	136193
27528	44280	17	applied	\N	\N	\N	\N	136948	136948	136195
27528	44286	18	applied	\N	\N	\N	\N	136949	136949	136208
27528	44287	19	applied	\N	\N	\N	\N	136950	136950	136210
27528	44290	20	applied	\N	\N	\N	\N	136951	136951	136216
27528	44291	21	applied	\N	\N	\N	\N	136952	136952	136218
27528	44292	22	applied	\N	\N	\N	\N	136953	136953	136220
27528	44293	23	applied	\N	\N	\N	\N	136954	136954	136222
27528	44297	24	applied	\N	\N	\N	\N	136955	136955	136232
27528	44298	25	applied	\N	\N	\N	\N	136956	136956	136234
27528	44299	26	applied	\N	\N	\N	\N	136957	136957	136236
27528	44300	27	applied	\N	\N	\N	\N	136958	136958	136238
27528	44301	28	applied	\N	\N	\N	\N	136959	136959	136240
27528	44302	29	applied	\N	\N	\N	\N	136960	136960	136242
27528	44304	30	applied	\N	\N	\N	\N	136961	136961	136252
27528	44305	31	applied	\N	\N	\N	\N	136962	136962	136254
27528	44306	32	applied	\N	\N	\N	\N	136963	136963	136256
27528	44307	33	applied	\N	\N	\N	\N	136964	136964	136258
27528	44308	34	applied	\N	\N	\N	\N	136965	136965	136260
27528	44314	35	applied	\N	\N	\N	\N	136966	136966	136276
27528	44315	36	applied	\N	\N	\N	\N	136967	136967	136278
27528	44316	37	applied	\N	\N	\N	\N	136968	136968	136280
27528	44317	38	applied	\N	\N	\N	\N	136969	136969	136282
27528	44318	39	applied	\N	\N	\N	\N	136970	136970	136284
27528	44319	40	applied	\N	\N	\N	\N	136971	136971	136286
27528	44320	41	applied	\N	\N	\N	\N	136972	136972	136288
27528	44321	42	applied	\N	\N	\N	\N	136973	136973	136290
27528	44322	43	applied	\N	\N	\N	\N	136974	136974	136292
27528	44326	44	applied	\N	\N	\N	\N	136975	136975	136300
27528	44327	45	applied	\N	\N	\N	\N	136976	136976	136302
27528	44328	46	applied	\N	\N	\N	\N	136977	136977	136304
27528	44329	47	applied	\N	\N	\N	\N	136978	136978	136306
27528	44330	48	applied	\N	\N	\N	\N	136979	136979	136308
27528	44595	49	applied	\N	\N	\N	\N	136926	136926	136980
27528	44331	50	applied	\N	\N	\N	\N	136981	136981	136310
27528	44338	51	applied	\N	\N	\N	\N	136982	136982	136326
27528	44339	52	applied	\N	\N	\N	\N	136983	136983	136328
27528	44344	53	applied	\N	\N	\N	\N	136984	136984	136340
27528	44346	54	applied	\N	\N	\N	\N	136985	136985	136344
27528	44347	55	applied	\N	\N	\N	\N	136986	136986	136346
27528	44348	56	applied	\N	\N	\N	\N	136987	136987	136348
27528	44349	57	applied	\N	\N	\N	\N	136988	136988	136350
27528	44356	58	applied	\N	\N	\N	\N	136989	136989	136370
27528	44243	59	applied	\N	\N	\N	\N	136089	136089	136090
27528	44358	60	applied	\N	\N	\N	\N	136990	136990	136374
27528	44359	61	applied	\N	\N	\N	\N	136991	136991	136376
27528	44360	62	applied	\N	\N	\N	\N	136992	136992	136378
27528	44361	63	applied	\N	\N	\N	\N	136993	136993	136380
27528	44362	64	applied	\N	\N	\N	\N	136994	136994	136382
27528	44363	65	applied	\N	\N	\N	\N	136995	136995	136384
27528	44364	66	applied	\N	\N	\N	\N	136996	136996	136386
27528	44365	67	applied	\N	\N	\N	\N	136997	136997	136388
27528	44366	68	applied	\N	\N	\N	\N	136998	136998	136390
27528	44367	69	applied	\N	\N	\N	\N	136999	136999	136392
27528	44368	70	applied	\N	\N	\N	\N	137000	137000	136394
27508	44535	5	applied	\N	\N	\N	\N	136778	136778	136779
27508	44536	6	applied	\N	\N	\N	\N	136780	136780	136781
27508	44537	7	applied	\N	\N	\N	\N	136782	136782	136783
27508	44538	8	applied	\N	\N	\N	\N	136784	136784	136785
27508	44539	9	applied	\N	\N	\N	\N	136786	136786	136787
27508	44540	10	applied	\N	\N	\N	\N	136788	136788	136789
27508	44541	11	applied	\N	\N	\N	\N	136790	136790	136791
27508	44542	12	applied	\N	\N	\N	\N	136792	136792	136793
27508	44543	13	applied	\N	\N	\N	\N	136794	136794	136795
27508	44544	14	applied	\N	\N	\N	\N	136796	136796	136797
27515	44557	0	applied	\N	\N	\N	\N	136832	136832	136833
27515	44558	2	applied	\N	\N	\N	\N	136835	136835	136836
27515	44559	3	applied	\N	\N	\N	\N	136840	136840	136841
27519	44563	0	applied	\N	\N	\N	\N	136856	136856	136857
27519	44564	1	applied	\N	\N	\N	\N	136858	136858	136859
27519	44565	2	applied	\N	\N	\N	\N	136860	136860	136861
27519	44566	3	applied	\N	\N	\N	\N	136862	136862	136852
27519	44562	4	applied	\N	\N	\N	\N	136851	136851	136863
27519	44567	5	applied	\N	\N	\N	\N	136864	136864	136865
27526	44596	0	applied	\N	\N	\N	\N	136929	136929	136930
27526	44597	1	applied	\N	\N	\N	\N	136931	136931	136932
27526	44598	2	applied	\N	\N	\N	\N	136933	136933	136934
27527	44596	0	applied	\N	\N	\N	\N	136929	136929	136930
27527	44597	1	applied	\N	\N	\N	\N	136931	136931	136932
27530	44599	0	applied	\N	\N	\N	\N	137021	137021	137022
27530	44600	1	applied	\N	\N	\N	\N	137023	137023	137024
27530	44601	2	applied	\N	\N	\N	\N	137025	137025	137026
27530	44602	3	applied	\N	\N	\N	\N	137027	137027	137028
27530	44603	4	applied	\N	\N	\N	\N	137029	137029	137030
27530	44604	5	applied	\N	\N	\N	\N	137031	137031	137032
27532	44607	0	applied	\N	\N	\N	\N	137043	137043	137044
27532	44608	1	applied	\N	\N	\N	\N	137045	137045	137046
27532	44609	2	applied	\N	\N	\N	\N	137047	137047	137048
27534	43858	0	applied	\N	\N	\N	\N	134946	134946	134947
27534	43861	1	applied	\N	\N	\N	\N	134955	134955	134956
27534	43864	2	applied	\N	\N	\N	\N	134963	134963	134964
27534	43867	3	applied	\N	\N	\N	\N	134972	134972	134973
27534	44563	4	applied	\N	\N	\N	\N	136937	136937	137051
27534	43870	5	applied	\N	\N	\N	\N	134981	134981	134982
27534	43873	6	applied	\N	\N	\N	\N	134994	134994	134995
27534	43876	7	applied	\N	\N	\N	\N	135047	135047	135048
27534	43877	8	applied	\N	\N	\N	\N	135049	135049	135050
27534	43882	9	applied	\N	\N	\N	\N	135062	135062	135063
27534	43885	10	applied	\N	\N	\N	\N	135070	135070	135071
27534	43888	11	applied	\N	\N	\N	\N	135078	135078	135079
27534	43891	12	applied	\N	\N	\N	\N	135086	135086	135087
27534	43892	13	applied	\N	\N	\N	\N	135088	135088	135089
27534	43893	14	applied	\N	\N	\N	\N	135090	135090	135091
27534	43902	15	applied	\N	\N	\N	\N	135120	135120	135121
27534	43903	16	applied	\N	\N	\N	\N	135131	135131	135132
27534	43907	17	applied	\N	\N	\N	\N	135141	135141	135142
27534	43909	18	applied	\N	\N	\N	\N	135151	135151	135152
27534	43911	19	applied	\N	\N	\N	\N	135159	135159	135160
27534	43913	20	applied	\N	\N	\N	\N	135166	135166	135167
27534	43914	21	applied	\N	\N	\N	\N	135168	135168	135169
27534	43918	22	applied	\N	\N	\N	\N	135179	135179	135180
27534	43920	23	applied	\N	\N	\N	\N	135185	135185	135186
27534	43921	24	applied	\N	\N	\N	\N	135187	135187	135188
27534	43926	25	applied	\N	\N	\N	\N	135200	135200	135201
27534	43929	26	applied	\N	\N	\N	\N	135206	135206	135207
27534	43932	27	applied	\N	\N	\N	\N	135216	135216	135217
27534	43933	28	applied	\N	\N	\N	\N	135218	135218	135219
27534	43938	29	applied	\N	\N	\N	\N	135230	135230	135231
27534	43941	30	applied	\N	\N	\N	\N	135236	135236	135237
27534	43944	31	applied	\N	\N	\N	\N	135246	135246	135247
27534	43947	32	applied	\N	\N	\N	\N	135260	135260	135261
27534	43950	33	applied	\N	\N	\N	\N	135268	135268	135269
27534	43953	34	applied	\N	\N	\N	\N	135275	135275	135276
27534	43956	35	applied	\N	\N	\N	\N	135283	135283	135284
27534	43957	36	applied	\N	\N	\N	\N	135285	135285	135286
27534	43962	37	applied	\N	\N	\N	\N	135296	135296	135297
27534	43965	38	applied	\N	\N	\N	\N	135303	135303	135304
27534	43968	39	applied	\N	\N	\N	\N	135313	135313	135314
27534	43969	40	applied	\N	\N	\N	\N	135315	135315	135316
27534	43974	41	applied	\N	\N	\N	\N	135327	135327	135328
27534	43977	42	applied	\N	\N	\N	\N	135335	135335	135336
27534	43978	43	applied	\N	\N	\N	\N	135337	135337	135338
27534	43983	44	applied	\N	\N	\N	\N	135351	135351	135352
27534	43986	45	applied	\N	\N	\N	\N	135367	135367	135368
27534	43989	46	applied	\N	\N	\N	\N	135376	135376	135377
27534	43992	47	applied	\N	\N	\N	\N	135384	135384	135385
27534	43996	48	applied	\N	\N	\N	\N	135394	135394	135395
27534	43999	49	applied	\N	\N	\N	\N	135404	135404	135405
27534	44000	50	applied	\N	\N	\N	\N	135406	135406	135407
27534	44001	51	applied	\N	\N	\N	\N	135408	135408	135409
27534	44008	52	applied	\N	\N	\N	\N	135424	135424	135425
27534	44011	53	applied	\N	\N	\N	\N	135432	135432	135433
27534	44014	54	applied	\N	\N	\N	\N	135440	135440	135441
27534	44017	55	applied	\N	\N	\N	\N	135452	135452	135453
27534	44018	56	applied	\N	\N	\N	\N	135454	135454	135455
27534	44023	57	applied	\N	\N	\N	\N	135466	135466	135467
27534	44026	58	applied	\N	\N	\N	\N	135474	135474	135475
27534	44029	59	applied	\N	\N	\N	\N	135482	135482	135483
27534	44032	60	applied	\N	\N	\N	\N	135488	135488	135489
27534	44035	61	applied	\N	\N	\N	\N	135498	135498	135499
27534	44038	62	applied	\N	\N	\N	\N	135507	135507	135508
27534	44039	63	applied	\N	\N	\N	\N	135509	135509	135510
27534	44040	64	applied	\N	\N	\N	\N	135511	135511	135512
27534	44047	65	applied	\N	\N	\N	\N	135527	135527	135528
27534	44048	66	applied	\N	\N	\N	\N	135529	135529	135530
27534	44053	67	applied	\N	\N	\N	\N	135540	135540	135541
27534	44054	68	applied	\N	\N	\N	\N	135542	135542	135543
27534	44055	69	applied	\N	\N	\N	\N	135544	135544	135545
27534	44062	70	applied	\N	\N	\N	\N	135563	135563	135564
27534	44063	71	applied	\N	\N	\N	\N	135565	135565	135566
27534	44064	72	applied	\N	\N	\N	\N	135567	135567	135568
27534	44074	73	applied	\N	\N	\N	\N	135590	135590	135591
27537	44610	0	applied	\N	\N	\N	\N	137057	137057	137058
27537	44611	1	applied	\N	\N	\N	\N	137059	137059	137060
27537	44612	2	applied	\N	\N	\N	\N	137061	137061	137062
27537	44613	3	applied	\N	\N	\N	\N	137063	137063	137064
27537	44614	4	applied	\N	\N	\N	\N	137065	137065	137066
27537	44615	5	applied	\N	\N	\N	\N	137067	137067	137068
27537	44616	6	applied	\N	\N	\N	\N	137069	137069	137070
27538	44617	0	applied	\N	\N	\N	\N	137076	137076	137077
27538	44618	1	applied	\N	\N	\N	\N	137078	137078	137079
27538	44619	2	applied	\N	\N	\N	\N	137080	137080	137081
27543	44620	0	applied	\N	\N	\N	\N	137084	137084	137085
27543	44621	1	applied	\N	\N	\N	\N	137086	137086	137087
27543	44623	2	applied	\N	\N	\N	\N	137091	137091	137092
27528	44369	71	applied	\N	\N	\N	\N	137001	137001	136396
27528	44370	72	applied	\N	\N	\N	\N	137002	137002	136398
27528	44371	73	applied	\N	\N	\N	\N	137003	137003	136400
27528	44372	74	applied	\N	\N	\N	\N	137004	137004	136402
27528	44373	75	applied	\N	\N	\N	\N	137005	137005	136404
27528	44377	76	applied	\N	\N	\N	\N	137006	137006	136415
27528	44378	77	applied	\N	\N	\N	\N	137007	137007	136417
27528	44379	78	applied	\N	\N	\N	\N	137008	137008	136419
27528	44380	79	applied	\N	\N	\N	\N	137009	137009	136421
27528	44381	80	applied	\N	\N	\N	\N	137010	137010	136423
27528	44382	81	applied	\N	\N	\N	\N	137011	137011	136425
27528	44386	82	applied	\N	\N	\N	\N	137012	137012	136435
27528	44389	83	applied	\N	\N	\N	\N	137013	137013	136441
27528	44390	84	applied	\N	\N	\N	\N	137014	137014	136443
27528	44391	85	applied	\N	\N	\N	\N	137015	137015	136445
27528	44395	86	applied	\N	\N	\N	\N	137016	137016	136453
27528	44396	88	applied	\N	\N	\N	\N	137018	137018	136455
27539	44617	0	applied	\N	\N	\N	\N	137076	137076	137077
27539	44618	1	applied	\N	\N	\N	\N	137078	137078	137079
27539	44619	2	applied	\N	\N	\N	\N	137080	137080	137081
27541	44620	0	applied	\N	\N	\N	\N	137084	137084	137085
27541	44621	1	applied	\N	\N	\N	\N	137086	137086	137087
27541	44622	2	applied	\N	\N	\N	\N	137088	137088	137089
27544	44620	0	applied	\N	\N	\N	\N	137084	137084	137085
27544	44621	1	applied	\N	\N	\N	\N	137086	137086	137087
27544	44623	2	applied	\N	\N	\N	\N	137091	137091	137092
27544	44622	3	applied	\N	\N	\N	\N	137088	137088	137093
27547	44624	0	applied	\N	\N	\N	\N	137099	137099	137100
27547	44625	1	applied	\N	\N	\N	\N	137101	137101	137102
27547	44626	2	applied	\N	\N	\N	\N	137103	137103	137104
27547	44627	3	applied	\N	\N	\N	\N	137105	137105	137106
27547	44628	4	applied	\N	\N	\N	\N	137107	137107	137108
27547	44629	5	applied	\N	\N	\N	\N	137109	137109	137110
27547	44630	6	applied	\N	\N	\N	\N	137111	137111	137112
27547	44631	7	applied	\N	\N	\N	\N	137113	137113	137114
27547	44632	8	applied	\N	\N	\N	\N	137115	137115	137116
27548	44633	0	applied	\N	\N	\N	\N	137121	137121	137122
27548	44634	1	applied	\N	\N	\N	\N	137123	137123	137124
27548	44635	2	applied	\N	\N	\N	\N	137125	137125	137126
27548	44636	3	applied	\N	\N	\N	\N	137127	137127	137128
27548	44637	4	applied	\N	\N	\N	\N	137129	137129	137130
27548	44638	5	applied	\N	\N	\N	\N	137131	137131	137132
27560	44653	0	applied	\N	\N	\N	\N	137178	137178	137179
27560	44654	1	applied	\N	\N	\N	\N	137180	137180	137181
27560	44655	2	applied	\N	\N	\N	\N	137182	137182	23829
27560	44656	3	applied	\N	\N	\N	\N	137183	137183	137184
27562	44653	0	applied	\N	\N	\N	\N	137178	137178	137179
27562	44654	1	applied	\N	\N	\N	\N	137180	137180	137181
27562	44655	2	applied	\N	\N	\N	\N	137182	137182	23829
27562	44656	3	applied	\N	\N	\N	\N	137183	137183	137184
27566	44660	0	applied	\N	\N	\N	\N	137203	137203	137204
27566	44661	1	applied	\N	\N	\N	\N	137205	137205	137206
27566	44662	2	applied	\N	\N	\N	\N	137207	137207	137208
27569	44669	0	applied	\N	\N	\N	\N	137222	137222	137223
27569	44670	1	applied	\N	\N	\N	\N	137224	137224	137225
27569	44671	2	applied	\N	\N	\N	\N	137226	137226	137227
27571	44669	0	applied	\N	\N	\N	\N	137222	137222	137223
27571	44670	1	applied	\N	\N	\N	\N	137224	137224	137225
27571	44671	2	applied	\N	\N	\N	\N	137226	137226	137227
27574	44678	0	applied	\N	\N	\N	\N	137248	137248	137249
27574	44679	1	applied	\N	\N	\N	\N	137250	137250	137251
27574	44680	2	applied	\N	\N	\N	\N	137252	137252	137253
27575	44678	0	applied	\N	\N	\N	\N	137248	137248	137249
27575	44679	1	applied	\N	\N	\N	\N	137250	137250	137251
27575	44680	2	applied	\N	\N	\N	\N	137252	137252	137253
27587	44706	0	applied	\N	\N	\N	\N	137337	137337	137338
27587	44707	1	applied	\N	\N	\N	\N	137339	137339	137340
27587	44708	2	applied	\N	\N	\N	\N	137341	137341	137342
27587	44709	3	applied	\N	\N	\N	\N	137343	137343	137344
27594	44718	0	applied	\N	\N	\N	\N	137377	137377	137378
27594	44719	1	applied	\N	\N	\N	\N	137379	137379	137380
27594	44720	2	applied	\N	\N	\N	\N	137381	137381	137382
27597	44730	0	applied	\N	\N	\N	\N	137408	137408	137409
27597	44731	1	applied	\N	\N	\N	\N	137410	137410	137411
27597	44732	2	applied	\N	\N	\N	\N	137412	137412	137413
27597	44733	3	applied	\N	\N	\N	\N	137414	137414	137415
27597	44734	4	applied	\N	\N	\N	\N	137416	137416	137417
27597	44735	5	applied	\N	\N	\N	\N	137418	137418	137419
27597	44736	6	applied	\N	\N	\N	\N	137420	137420	137421
27599	44737	0	applied	\N	\N	\N	\N	137424	137424	137425
27599	44738	1	applied	\N	\N	\N	\N	137426	137426	137427
27599	44739	2	applied	\N	\N	\N	\N	137428	137428	137429
27599	44740	3	applied	\N	\N	\N	\N	137430	137430	137431
27599	44741	4	applied	\N	\N	\N	\N	137432	137432	137433
27599	44742	5	applied	\N	\N	\N	\N	137434	137434	137435
27606	44752	0	applied	\N	\N	\N	\N	137459	137459	137460
27606	44753	1	applied	\N	\N	\N	\N	137461	137461	137462
27606	44754	2	applied	\N	\N	\N	\N	137463	137463	137464
27610	44721	0	applied	\N	\N	\N	\N	137502	137502	137388
27610	44722	1	applied	\N	\N	\N	\N	137503	137503	137390
27610	44563	2	applied	\N	\N	\N	\N	136937	136937	136960
27610	44699	3	applied	\N	\N	\N	\N	137321	137321	137322
27610	44303	4	applied	\N	\N	\N	\N	136249	136249	136250
27610	44311	5	applied	\N	\N	\N	\N	136269	136269	136270
27610	44312	6	applied	\N	\N	\N	\N	136271	136271	136272
27610	44313	7	applied	\N	\N	\N	\N	136273	136273	136274
27610	44335	8	applied	\N	\N	\N	\N	136319	136319	136320
27610	44336	9	applied	\N	\N	\N	\N	136321	136321	136322
27610	44350	10	applied	\N	\N	\N	\N	136357	136357	136358
27610	44351	11	applied	\N	\N	\N	\N	136359	136359	136360
27610	44723	12	applied	\N	\N	\N	\N	137504	137504	137392
27610	44724	13	applied	\N	\N	\N	\N	137505	137505	137394
27610	44725	14	applied	\N	\N	\N	\N	137506	137506	137396
27610	44726	15	applied	\N	\N	\N	\N	137507	137507	137507
27610	44744	16	applied	\N	\N	\N	\N	137508	137508	137442
27610	44745	17	applied	\N	\N	\N	\N	137509	137509	137444
27610	44746	18	applied	\N	\N	\N	\N	137510	137510	137446
27610	44747	19	applied	\N	\N	\N	\N	137511	137511	137448
27610	44748	20	applied	\N	\N	\N	\N	137512	137512	137450
27610	44749	21	applied	\N	\N	\N	\N	137513	137513	137513
27610	44352	22	applied	\N	\N	\N	\N	136361	136361	136362
27610	44376	23	applied	\N	\N	\N	\N	136412	136412	136413
27610	44384	24	applied	\N	\N	\N	\N	136430	136430	136431
27610	44385	25	applied	\N	\N	\N	\N	136432	136432	136433
27610	44402	26	applied	\N	\N	\N	\N	136469	136469	136470
27610	44411	27	applied	\N	\N	\N	\N	136489	136489	136490
27610	44417	28	applied	\N	\N	\N	\N	136503	136503	136504
27610	44418	29	applied	\N	\N	\N	\N	136505	136505	136506
27610	44419	30	applied	\N	\N	\N	\N	136507	136507	136508
27610	44441	31	applied	\N	\N	\N	\N	136552	136552	136553
27535	44615	5	applied	\N	\N	\N	\N	137067	137067	137068
27535	44616	6	applied	\N	\N	\N	\N	137069	137069	137070
27542	44620	0	applied	\N	\N	\N	\N	137084	137084	137085
27542	44621	1	applied	\N	\N	\N	\N	137086	137086	137087
27542	44623	2	applied	\N	\N	\N	\N	137091	137091	137092
27542	44622	3	applied	\N	\N	\N	\N	137088	137088	137093
27549	44639	0	applied	\N	\N	\N	\N	137135	137135	137136
27549	44640	1	applied	\N	\N	\N	\N	137137	137137	137138
27549	44641	2	applied	\N	\N	\N	\N	137139	137139	137140
27551	44642	0	applied	\N	\N	\N	\N	137145	137145	137146
27551	44643	1	applied	\N	\N	\N	\N	137147	137147	137148
27554	44644	0	applied	\N	\N	\N	\N	137151	137151	137152
27554	44645	1	applied	\N	\N	\N	\N	137153	137153	137154
27554	44646	2	applied	\N	\N	\N	\N	137155	137155	137156
27554	44647	3	applied	\N	\N	\N	\N	137157	137157	137158
27558	44651	0	applied	\N	\N	\N	\N	137170	137170	137171
27558	44652	1	applied	\N	\N	\N	\N	137172	137172	137173
27561	44653	0	applied	\N	\N	\N	\N	137178	137178	137179
27561	44654	1	applied	\N	\N	\N	\N	137180	137180	137181
27561	44655	2	applied	\N	\N	\N	\N	137182	137182	23829
27561	44656	3	applied	\N	\N	\N	\N	137183	137183	137184
27567	44660	0	applied	\N	\N	\N	\N	137203	137203	137204
27567	44661	1	applied	\N	\N	\N	\N	137205	137205	137206
27567	44662	2	applied	\N	\N	\N	\N	137207	137207	137208
27570	44669	0	applied	\N	\N	\N	\N	137222	137222	137223
27570	44670	1	applied	\N	\N	\N	\N	137224	137224	137225
27570	44671	2	applied	\N	\N	\N	\N	137226	137226	137227
27572	44672	0	applied	\N	\N	\N	\N	137234	137234	137235
27572	44673	1	applied	\N	\N	\N	\N	137236	137236	137237
27572	44674	2	applied	\N	\N	\N	\N	137238	137238	137239
27572	44675	3	applied	\N	\N	\N	\N	137240	137240	137241
27572	44676	4	applied	\N	\N	\N	\N	137242	137242	137243
27572	44677	5	applied	\N	\N	\N	\N	137244	137244	137245
27576	44678	0	applied	\N	\N	\N	\N	137248	137248	137249
27576	44679	1	applied	\N	\N	\N	\N	137250	137250	137251
27576	44680	2	applied	\N	\N	\N	\N	137252	137252	137253
27579	44681	0	applied	\N	\N	\N	\N	137278	137278	137279
27579	44682	1	applied	\N	\N	\N	\N	137280	137280	137281
27579	44683	2	applied	\N	\N	\N	\N	137282	137282	137283
27579	44684	3	applied	\N	\N	\N	\N	137284	137284	137285
27579	44685	4	applied	\N	\N	\N	\N	137286	137286	137287
27579	44686	5	applied	\N	\N	\N	\N	137288	137288	137289
27581	44687	0	applied	\N	\N	\N	\N	137294	137294	137295
27581	44688	1	applied	\N	\N	\N	\N	137296	137296	137297
27581	44689	2	applied	\N	\N	\N	\N	137298	137298	137299
27581	44690	3	applied	\N	\N	\N	\N	137300	137300	137301
27581	44691	4	applied	\N	\N	\N	\N	137302	137302	137303
27581	44692	5	applied	\N	\N	\N	\N	137304	137304	137305
27584	44699	0	applied	\N	\N	\N	\N	137321	137321	137322
27584	44700	1	applied	\N	\N	\N	\N	137323	137323	137324
27584	44701	2	applied	\N	\N	\N	\N	137325	137325	137326
27584	44702	3	applied	\N	\N	\N	\N	137327	137327	137328
27585	44699	0	applied	\N	\N	\N	\N	137321	137321	137322
27585	44700	1	applied	\N	\N	\N	\N	137323	137323	137324
27585	44701	2	applied	\N	\N	\N	\N	137325	137325	137326
27585	44702	3	applied	\N	\N	\N	\N	137327	137327	137328
27590	44712	0	applied	\N	\N	\N	\N	137354	137354	137355
27590	44710	1	applied	\N	\N	\N	\N	137347	137347	137360
27590	44713	2	applied	\N	\N	\N	\N	137356	137356	137361
27590	44711	3	applied	\N	\N	\N	\N	137349	137349	137362
27590	44714	4	applied	\N	\N	\N	\N	137363	137363	137364
27600	44737	0	applied	\N	\N	\N	\N	137424	137424	137425
27600	44738	1	applied	\N	\N	\N	\N	137426	137426	137427
27600	44739	2	applied	\N	\N	\N	\N	137428	137428	137429
27600	44740	3	applied	\N	\N	\N	\N	137430	137430	137431
27600	44741	4	applied	\N	\N	\N	\N	137432	137432	137433
27600	44742	5	applied	\N	\N	\N	\N	137434	137434	137435
27609	44767	0	applied	\N	\N	\N	\N	137494	137494	137495
27609	44768	1	applied	\N	\N	\N	\N	137496	137496	137497
27609	44769	2	applied	\N	\N	\N	\N	137498	137498	137499
27612	44770	0	applied	\N	\N	\N	\N	137522	137522	137523
27612	44771	1	applied	\N	\N	\N	\N	137524	137524	137525
27612	44772	2	applied	\N	\N	\N	\N	137526	137526	137527
27613	44770	0	applied	\N	\N	\N	\N	137522	137522	137523
27613	44771	1	applied	\N	\N	\N	\N	137524	137524	137525
27613	44772	2	applied	\N	\N	\N	\N	137526	137526	137527
27615	44773	0	applied	\N	\N	\N	\N	137533	137533	137534
27615	44774	1	applied	\N	\N	\N	\N	137535	137535	137536
27615	44775	2	applied	\N	\N	\N	\N	137537	137537	137538
27615	44776	3	applied	\N	\N	\N	\N	137539	137539	137540
27618	44794	0	applied	\N	\N	\N	\N	137583	137583	137584
27618	44795	1	applied	\N	\N	\N	\N	137585	137585	137586
27618	44796	2	applied	\N	\N	\N	\N	137587	137587	137588
27635	44825	0	applied	\N	\N	\N	\N	137666	137666	137667
27635	44826	1	applied	\N	\N	\N	\N	137668	137668	137669
27635	44827	2	applied	\N	\N	\N	\N	137670	137670	137671
27655	44869	0	applied	\N	\N	\N	\N	137801	137801	137802
27655	44870	1	applied	\N	\N	\N	\N	137803	137803	137804
27655	44871	2	applied	\N	\N	\N	\N	137805	137805	137806
27657	44872	0	applied	\N	\N	\N	\N	137809	137809	137810
27657	44873	1	applied	\N	\N	\N	\N	137811	137811	137812
27657	44874	2	applied	\N	\N	\N	\N	137813	137813	137814
27660	44878	0	applied	\N	\N	\N	\N	137825	137825	137826
27660	44879	1	applied	\N	\N	\N	\N	137827	137827	137828
27660	44880	2	applied	\N	\N	\N	\N	137829	137829	137830
27663	44884	0	applied	\N	\N	\N	\N	137837	137837	137838
27663	44885	1	applied	\N	\N	\N	\N	137839	137839	137840
27663	44886	2	applied	\N	\N	\N	\N	137841	137841	28166
27663	44887	3	applied	\N	\N	\N	\N	137842	137842	137843
27663	44888	4	applied	\N	\N	\N	\N	137844	137844	137845
27663	44889	5	applied	\N	\N	\N	\N	137846	137846	137847
27663	44890	6	applied	\N	\N	\N	\N	137848	137848	137849
27663	44891	7	applied	\N	\N	\N	\N	137850	137850	137851
27665	44895	0	applied	\N	\N	\N	\N	137863	137863	137864
27665	44896	1	applied	\N	\N	\N	\N	137865	137865	137866
27665	44897	2	applied	\N	\N	\N	\N	137867	137867	137868
27667	44895	0	applied	\N	\N	\N	\N	137863	137863	137864
27667	44896	1	applied	\N	\N	\N	\N	137865	137865	137866
27667	44897	2	applied	\N	\N	\N	\N	137867	137867	137868
27670	44898	0	applied	\N	\N	\N	\N	137873	137873	137874
27670	44899	1	applied	\N	\N	\N	\N	137875	137875	137876
27670	44900	2	applied	\N	\N	\N	\N	137877	137877	137878
27674	44901	0	applied	\N	\N	\N	\N	137884	137884	137885
27674	44902	1	applied	\N	\N	\N	\N	137886	137886	137887
27674	44903	2	applied	\N	\N	\N	\N	137888	137888	137889
27680	44907	0	applied	\N	\N	\N	\N	137907	137907	137908
27680	44908	1	applied	\N	\N	\N	\N	137909	137909	137910
27685	44915	0	applied	\N	\N	\N	\N	137967	137967	137968
27685	44916	1	applied	\N	\N	\N	\N	137969	137969	137970
27685	44917	2	applied	\N	\N	\N	\N	137971	137971	137972
27543	44622	3	applied	\N	\N	\N	\N	137088	137088	137093
27546	44624	0	applied	\N	\N	\N	\N	137099	137099	137100
27546	44625	1	applied	\N	\N	\N	\N	137101	137101	137102
27546	44626	2	applied	\N	\N	\N	\N	137103	137103	137104
27546	44627	3	applied	\N	\N	\N	\N	137105	137105	137106
27546	44628	4	applied	\N	\N	\N	\N	137107	137107	137108
27546	44629	5	applied	\N	\N	\N	\N	137109	137109	137110
27546	44630	6	applied	\N	\N	\N	\N	137111	137111	137112
27546	44631	7	applied	\N	\N	\N	\N	137113	137113	137114
27546	44632	8	applied	\N	\N	\N	\N	137115	137115	137116
27550	44639	0	applied	\N	\N	\N	\N	137135	137135	137136
27550	44640	1	applied	\N	\N	\N	\N	137137	137137	137138
27550	44641	2	applied	\N	\N	\N	\N	137139	137139	137140
27553	44644	0	applied	\N	\N	\N	\N	137151	137151	137152
27553	44645	1	applied	\N	\N	\N	\N	137153	137153	137154
27553	44646	2	applied	\N	\N	\N	\N	137155	137155	137156
27553	44647	3	applied	\N	\N	\N	\N	137157	137157	137158
27555	44644	0	applied	\N	\N	\N	\N	137151	137151	137152
27555	44645	1	applied	\N	\N	\N	\N	137153	137153	137154
27555	44646	2	applied	\N	\N	\N	\N	137155	137155	137156
27555	44647	3	applied	\N	\N	\N	\N	137157	137157	137158
27557	44651	0	applied	\N	\N	\N	\N	137170	137170	137171
27557	44652	1	applied	\N	\N	\N	\N	137172	137172	137173
27559	44653	0	applied	\N	\N	\N	\N	137178	137178	137179
27559	44654	1	applied	\N	\N	\N	\N	137180	137180	137181
27559	44655	2	applied	\N	\N	\N	\N	137182	137182	23829
27559	44656	3	applied	\N	\N	\N	\N	137183	137183	137184
27564	44657	0	applied	\N	\N	\N	\N	137191	137191	137192
27564	44658	1	applied	\N	\N	\N	\N	137193	137193	137194
27564	44659	2	applied	\N	\N	\N	\N	137195	137195	137196
27568	44663	0	applied	\N	\N	\N	\N	137209	137209	137210
27568	44664	1	applied	\N	\N	\N	\N	137211	137211	137212
27568	44665	2	applied	\N	\N	\N	\N	137213	137213	137214
27568	44666	3	applied	\N	\N	\N	\N	137215	137215	137216
27568	44667	4	applied	\N	\N	\N	\N	137217	137217	137218
27568	44668	5	applied	\N	\N	\N	\N	137219	137219	137220
27578	44655	0	applied	\N	\N	\N	\N	137182	137182	23829
27580	44681	0	applied	\N	\N	\N	\N	137278	137278	137279
27580	44682	1	applied	\N	\N	\N	\N	137280	137280	137281
27580	44683	2	applied	\N	\N	\N	\N	137282	137282	137283
27580	44684	3	applied	\N	\N	\N	\N	137284	137284	137285
27580	44685	4	applied	\N	\N	\N	\N	137286	137286	137287
27580	44686	5	applied	\N	\N	\N	\N	137288	137288	137289
27583	44693	0	applied	\N	\N	\N	\N	137308	137308	137309
27583	44694	1	applied	\N	\N	\N	\N	137310	137310	137311
27583	44695	2	applied	\N	\N	\N	\N	137312	137312	137313
27583	44696	3	applied	\N	\N	\N	\N	137314	137314	137315
27583	44697	4	applied	\N	\N	\N	\N	137316	137316	137317
27583	44698	5	applied	\N	\N	\N	\N	137318	137318	137319
27589	44712	0	applied	\N	\N	\N	\N	137354	137354	137355
27589	44713	1	applied	\N	\N	\N	\N	137356	137356	137357
27591	44715	0	applied	\N	\N	\N	\N	137366	137366	137367
27591	44710	1	applied	\N	\N	\N	\N	137347	137347	137361
27591	44716	2	applied	\N	\N	\N	\N	137368	137368	137369
27591	44711	3	applied	\N	\N	\N	\N	137349	137349	137370
27591	44714	4	applied	\N	\N	\N	\N	137363	137363	137371
27591	44717	5	applied	\N	\N	\N	\N	137372	137372	137373
27592	44715	0	applied	\N	\N	\N	\N	137366	137366	137367
27592	44710	1	applied	\N	\N	\N	\N	137347	137347	137361
27592	44716	2	applied	\N	\N	\N	\N	137368	137368	137369
27592	44711	3	applied	\N	\N	\N	\N	137349	137349	137370
27592	44714	4	applied	\N	\N	\N	\N	137363	137363	137371
27592	44717	5	applied	\N	\N	\N	\N	137372	137372	137373
27596	44721	0	applied	\N	\N	\N	\N	137387	137387	137388
27596	44722	1	applied	\N	\N	\N	\N	137389	137389	137390
27596	44723	2	applied	\N	\N	\N	\N	137391	137391	137392
27596	44724	3	applied	\N	\N	\N	\N	137393	137393	137394
27596	44725	4	applied	\N	\N	\N	\N	137395	137395	137396
27596	44726	5	applied	\N	\N	\N	\N	137397	137397	137397
27596	44727	6	applied	\N	\N	\N	\N	137398	137398	137399
27596	44728	7	applied	\N	\N	\N	\N	137400	137400	137401
27596	44729	8	applied	\N	\N	\N	\N	137402	137402	137403
27602	44737	0	applied	\N	\N	\N	\N	137424	137424	137425
27602	44738	1	applied	\N	\N	\N	\N	137426	137426	137427
27602	44739	2	applied	\N	\N	\N	\N	137428	137428	137429
27602	44740	3	applied	\N	\N	\N	\N	137430	137430	137431
27602	44741	4	applied	\N	\N	\N	\N	137432	137432	137433
27602	44742	5	applied	\N	\N	\N	\N	137434	137434	137435
27603	44743	0	applied	\N	\N	\N	\N	137439	137439	137440
27603	44744	1	applied	\N	\N	\N	\N	137441	137441	137442
27603	44745	2	applied	\N	\N	\N	\N	137443	137443	137444
27603	44746	3	applied	\N	\N	\N	\N	137445	137445	137446
27603	44747	4	applied	\N	\N	\N	\N	137447	137447	137448
27603	44748	5	applied	\N	\N	\N	\N	137449	137449	137450
27603	44749	6	applied	\N	\N	\N	\N	137451	137451	137451
27603	44750	7	applied	\N	\N	\N	\N	137452	137452	137453
27603	44751	8	applied	\N	\N	\N	\N	137454	137454	137455
27605	44752	0	applied	\N	\N	\N	\N	137459	137459	137460
27605	44753	1	applied	\N	\N	\N	\N	137461	137461	137462
27605	44754	2	applied	\N	\N	\N	\N	137463	137463	137464
27608	44755	0	applied	\N	\N	\N	\N	137468	137468	137469
27608	44756	1	applied	\N	\N	\N	\N	137470	137470	137471
27608	44757	2	applied	\N	\N	\N	\N	137472	137472	137473
27608	44758	3	applied	\N	\N	\N	\N	137474	137474	137475
27608	44759	4	applied	\N	\N	\N	\N	137476	137476	137477
27608	44760	5	applied	\N	\N	\N	\N	137478	137478	137479
27608	44761	6	applied	\N	\N	\N	\N	137480	137480	137481
27608	44762	7	applied	\N	\N	\N	\N	137482	137482	137483
27608	44763	8	applied	\N	\N	\N	\N	137484	137484	137485
27608	44764	9	applied	\N	\N	\N	\N	137486	137486	137487
27608	44765	10	applied	\N	\N	\N	\N	137488	137488	137489
27608	44766	11	applied	\N	\N	\N	\N	137490	137490	137491
27619	44797	0	applied	\N	\N	\N	\N	137591	137591	137592
27619	44798	1	applied	\N	\N	\N	\N	137593	137593	137594
27619	44799	2	applied	\N	\N	\N	\N	137595	137595	137596
27621	44797	0	applied	\N	\N	\N	\N	137591	137591	137592
27623	44800	0	applied	\N	\N	\N	\N	137600	137600	137601
27623	44801	1	applied	\N	\N	\N	\N	137602	137602	137603
27623	44802	2	applied	\N	\N	\N	\N	137604	137604	137605
27626	44803	0	applied	\N	\N	\N	\N	137608	137608	137609
27626	44804	1	applied	\N	\N	\N	\N	137610	137610	137611
27626	44805	2	applied	\N	\N	\N	\N	137612	137612	137613
27626	44806	3	applied	\N	\N	\N	\N	137614	137614	137615
27626	44807	4	applied	\N	\N	\N	\N	137616	137616	137617
27626	44808	5	applied	\N	\N	\N	\N	137618	137618	137619
27628	44809	0	applied	\N	\N	\N	\N	137625	137625	137626
27628	44810	1	applied	\N	\N	\N	\N	137627	137627	137628
27628	44811	2	applied	\N	\N	\N	\N	137629	137629	102784
27628	44812	3	applied	\N	\N	\N	\N	137630	137630	137631
27631	44822	0	applied	\N	\N	\N	\N	137658	137658	137659
27577	44279	19	applied	\N	\N	\N	\N	137270	137270	136193
27577	44280	20	applied	\N	\N	\N	\N	137271	137271	136195
27577	44286	21	applied	\N	\N	\N	\N	137272	137272	136208
27577	44287	22	applied	\N	\N	\N	\N	137273	137273	136210
27586	44703	0	applied	\N	\N	\N	\N	137330	137330	137331
27586	44704	1	applied	\N	\N	\N	\N	137332	137332	137333
27586	44705	2	applied	\N	\N	\N	\N	137334	137334	137335
27588	44706	0	applied	\N	\N	\N	\N	137337	137337	137338
27588	44707	1	applied	\N	\N	\N	\N	137339	137339	137340
27588	44710	2	applied	\N	\N	\N	\N	137347	137347	137348
27588	44711	3	applied	\N	\N	\N	\N	137349	137349	137350
27588	44708	4	applied	\N	\N	\N	\N	137341	137341	137351
27588	44709	5	applied	\N	\N	\N	\N	137343	137343	137352
27593	44718	0	applied	\N	\N	\N	\N	137377	137377	137378
27593	44719	1	applied	\N	\N	\N	\N	137379	137379	137380
27593	44720	2	applied	\N	\N	\N	\N	137381	137381	137382
27595	44721	0	applied	\N	\N	\N	\N	137387	137387	137388
27595	44722	1	applied	\N	\N	\N	\N	137389	137389	137390
27595	44723	2	applied	\N	\N	\N	\N	137391	137391	137392
27595	44724	3	applied	\N	\N	\N	\N	137393	137393	137394
27595	44725	4	applied	\N	\N	\N	\N	137395	137395	137396
27595	44726	5	applied	\N	\N	\N	\N	137397	137397	137397
27595	44727	6	applied	\N	\N	\N	\N	137398	137398	137399
27595	44728	7	applied	\N	\N	\N	\N	137400	137400	137401
27595	44729	8	applied	\N	\N	\N	\N	137402	137402	137403
27598	44730	0	applied	\N	\N	\N	\N	137408	137408	137409
27598	44731	1	applied	\N	\N	\N	\N	137410	137410	137411
27598	44732	2	applied	\N	\N	\N	\N	137412	137412	137413
27598	44733	3	applied	\N	\N	\N	\N	137414	137414	137415
27598	44734	4	applied	\N	\N	\N	\N	137416	137416	137417
27598	44735	5	applied	\N	\N	\N	\N	137418	137418	137419
27598	44736	6	applied	\N	\N	\N	\N	137420	137420	137421
27611	44721	0	applied	\N	\N	\N	\N	137502	137502	137388
27611	44722	1	applied	\N	\N	\N	\N	137503	137503	137390
27611	44563	2	applied	\N	\N	\N	\N	136937	136937	136981
27611	44699	3	applied	\N	\N	\N	\N	137321	137321	137322
27611	44335	4	applied	\N	\N	\N	\N	136319	136319	136320
27611	44336	5	applied	\N	\N	\N	\N	136321	136321	136322
27611	44350	6	applied	\N	\N	\N	\N	136357	136357	136358
27611	44351	7	applied	\N	\N	\N	\N	136359	136359	136360
27611	44723	8	applied	\N	\N	\N	\N	137504	137504	137392
27611	44724	9	applied	\N	\N	\N	\N	137505	137505	137394
27611	44725	10	applied	\N	\N	\N	\N	137506	137506	137396
27611	44726	11	applied	\N	\N	\N	\N	137507	137507	137507
27611	44744	12	applied	\N	\N	\N	\N	137508	137508	137442
27611	44745	13	applied	\N	\N	\N	\N	137509	137509	137444
27611	44746	14	applied	\N	\N	\N	\N	137510	137510	137446
27611	44747	15	applied	\N	\N	\N	\N	137511	137511	137448
27611	44748	16	applied	\N	\N	\N	\N	137512	137512	137450
27611	44749	17	applied	\N	\N	\N	\N	137513	137513	137513
27611	44352	18	applied	\N	\N	\N	\N	136361	136361	136362
27611	44376	20	applied	\N	\N	\N	\N	136412	136412	136413
27611	44384	21	applied	\N	\N	\N	\N	136430	136430	136431
27611	44385	22	applied	\N	\N	\N	\N	136432	136432	136433
27611	44402	23	applied	\N	\N	\N	\N	136469	136469	136470
27611	44411	24	applied	\N	\N	\N	\N	136489	136489	136490
27611	44417	25	applied	\N	\N	\N	\N	136503	136503	136504
27611	44418	26	applied	\N	\N	\N	\N	136505	136505	136506
27611	44419	27	applied	\N	\N	\N	\N	136507	136507	136508
27611	44441	28	applied	\N	\N	\N	\N	136552	136552	136553
27611	44449	29	applied	\N	\N	\N	\N	136570	136570	136571
27611	44450	30	applied	\N	\N	\N	\N	136572	136572	136573
27611	44451	31	applied	\N	\N	\N	\N	136574	136574	136575
27611	44476	32	applied	\N	\N	\N	\N	136633	136633	136634
27611	44477	33	applied	\N	\N	\N	\N	136635	136635	136636
27611	44486	34	applied	\N	\N	\N	\N	136655	136655	136656
27611	44490	35	applied	\N	\N	\N	\N	136663	136663	136664
27611	44493	36	applied	\N	\N	\N	\N	136672	136672	136673
27611	44494	37	applied	\N	\N	\N	\N	136674	136674	136675
27611	44499	38	applied	\N	\N	\N	\N	136686	136686	136687
27611	44502	39	applied	\N	\N	\N	\N	136692	136692	136693
27611	44505	40	applied	\N	\N	\N	\N	136702	136702	136703
27611	44509	41	applied	\N	\N	\N	\N	136714	136714	136715
27611	44512	42	applied	\N	\N	\N	\N	136725	136725	136726
27611	44513	43	applied	\N	\N	\N	\N	136727	136727	136728
27611	44518	44	applied	\N	\N	\N	\N	136739	136739	136740
27611	44521	45	applied	\N	\N	\N	\N	136747	136747	136748
27611	44522	46	applied	\N	\N	\N	\N	136749	136749	136750
27611	44527	47	applied	\N	\N	\N	\N	136760	136760	136761
27611	44530	48	applied	\N	\N	\N	\N	136768	136768	136769
27611	44531	49	applied	\N	\N	\N	\N	136770	136770	136771
27611	44532	50	applied	\N	\N	\N	\N	136772	136772	136773
27611	44533	51	applied	\N	\N	\N	\N	136774	136774	136775
27611	44534	52	applied	\N	\N	\N	\N	136776	136776	136777
27611	44545	53	applied	\N	\N	\N	\N	136800	136800	136801
27611	44546	54	applied	\N	\N	\N	\N	136802	136802	136803
27611	44547	55	applied	\N	\N	\N	\N	136804	136804	136805
27611	44554	56	applied	\N	\N	\N	\N	136820	136820	136821
27611	44557	57	applied	\N	\N	\N	\N	136832	136832	136833
27611	44560	58	applied	\N	\N	\N	\N	136847	136847	136848
27611	44564	59	applied	\N	\N	\N	\N	136858	136858	136859
27611	44568	60	applied	\N	\N	\N	\N	136868	136868	136869
27611	44569	61	applied	\N	\N	\N	\N	136870	136870	136871
27611	44570	62	applied	\N	\N	\N	\N	136872	136872	136873
27611	44582	63	applied	\N	\N	\N	\N	136897	136897	136898
27611	44586	64	applied	\N	\N	\N	\N	136907	136907	136908
27611	44589	65	applied	\N	\N	\N	\N	136914	136914	136915
27611	44590	66	applied	\N	\N	\N	\N	136916	136916	136917
27611	44596	67	applied	\N	\N	\N	\N	136929	136929	136930
27611	44599	68	applied	\N	\N	\N	\N	137021	137021	137022
27611	44600	69	applied	\N	\N	\N	\N	137023	137023	137024
27611	44605	70	applied	\N	\N	\N	\N	137037	137037	137038
27611	44607	71	applied	\N	\N	\N	\N	137043	137043	137044
27611	44611	72	applied	\N	\N	\N	\N	137059	137059	137060
27611	44612	73	applied	\N	\N	\N	\N	137061	137061	137062
27611	44617	74	applied	\N	\N	\N	\N	137076	137076	137077
27611	44620	75	applied	\N	\N	\N	\N	137084	137084	137085
27611	44624	76	applied	\N	\N	\N	\N	137099	137099	137100
27611	44625	77	applied	\N	\N	\N	\N	137101	137101	137102
27611	44626	78	applied	\N	\N	\N	\N	137103	137103	137104
27611	44633	79	applied	\N	\N	\N	\N	137121	137121	137122
27616	44773	0	applied	\N	\N	\N	\N	137533	137533	137534
27616	44774	1	applied	\N	\N	\N	\N	137535	137535	137536
27616	44775	2	applied	\N	\N	\N	\N	137537	137537	137538
27616	44776	3	applied	\N	\N	\N	\N	137539	137539	137540
27616	44777	4	applied	\N	\N	\N	\N	137542	137542	137543
27616	44778	5	applied	\N	\N	\N	\N	137544	137544	137545
27616	44779	6	applied	\N	\N	\N	\N	137546	137546	137547
27616	44780	7	applied	\N	\N	\N	\N	137548	137548	137549
27616	44781	8	applied	\N	\N	\N	\N	137550	137550	137551
27610	44449	32	applied	\N	\N	\N	\N	136570	136570	136571
27610	44450	33	applied	\N	\N	\N	\N	136572	136572	136573
27610	44451	34	applied	\N	\N	\N	\N	136574	136574	136575
27610	44476	35	applied	\N	\N	\N	\N	136633	136633	136634
27610	44477	36	applied	\N	\N	\N	\N	136635	136635	136636
27610	44486	37	applied	\N	\N	\N	\N	136655	136655	136656
27610	44490	38	applied	\N	\N	\N	\N	136663	136663	136664
27610	44493	39	applied	\N	\N	\N	\N	136672	136672	136673
27610	44494	40	applied	\N	\N	\N	\N	136674	136674	136675
27610	44499	41	applied	\N	\N	\N	\N	136686	136686	136687
27610	44502	42	applied	\N	\N	\N	\N	136692	136692	136693
27610	44505	43	applied	\N	\N	\N	\N	136702	136702	136703
27610	44509	44	applied	\N	\N	\N	\N	136714	136714	136715
27610	44512	45	applied	\N	\N	\N	\N	136725	136725	136726
27610	44513	46	applied	\N	\N	\N	\N	136727	136727	136728
27610	44518	47	applied	\N	\N	\N	\N	136739	136739	136740
27610	44521	48	applied	\N	\N	\N	\N	136747	136747	136748
27610	44522	49	applied	\N	\N	\N	\N	136749	136749	136750
27610	44527	50	applied	\N	\N	\N	\N	136760	136760	136761
27610	44530	51	applied	\N	\N	\N	\N	136768	136768	136769
27610	44531	52	applied	\N	\N	\N	\N	136770	136770	136771
27610	44532	53	applied	\N	\N	\N	\N	136772	136772	136773
27610	44533	54	applied	\N	\N	\N	\N	136774	136774	136775
27610	44534	56	applied	\N	\N	\N	\N	136776	136776	136777
27610	44545	57	applied	\N	\N	\N	\N	136800	136800	136801
27610	44546	58	applied	\N	\N	\N	\N	136802	136802	136803
27610	44547	59	applied	\N	\N	\N	\N	136804	136804	136805
27610	44554	60	applied	\N	\N	\N	\N	136820	136820	136821
27610	44557	61	applied	\N	\N	\N	\N	136832	136832	136833
27610	44560	62	applied	\N	\N	\N	\N	136847	136847	136848
27610	44564	63	applied	\N	\N	\N	\N	136858	136858	136859
27610	44568	64	applied	\N	\N	\N	\N	136868	136868	136869
27610	44569	65	applied	\N	\N	\N	\N	136870	136870	136871
27610	44570	66	applied	\N	\N	\N	\N	136872	136872	136873
27610	44582	67	applied	\N	\N	\N	\N	136897	136897	136898
27610	44586	68	applied	\N	\N	\N	\N	136907	136907	136908
27610	44589	69	applied	\N	\N	\N	\N	136914	136914	136915
27610	44590	70	applied	\N	\N	\N	\N	136916	136916	136917
27610	44596	71	applied	\N	\N	\N	\N	136929	136929	136930
27610	44599	72	applied	\N	\N	\N	\N	137021	137021	137022
27610	44600	73	applied	\N	\N	\N	\N	137023	137023	137024
27610	44605	74	applied	\N	\N	\N	\N	137037	137037	137038
27610	44607	75	applied	\N	\N	\N	\N	137043	137043	137044
27610	44611	76	applied	\N	\N	\N	\N	137059	137059	137060
27610	44612	77	applied	\N	\N	\N	\N	137061	137061	137062
27610	44617	78	applied	\N	\N	\N	\N	137076	137076	137077
27610	44620	79	applied	\N	\N	\N	\N	137084	137084	137085
27610	44624	80	applied	\N	\N	\N	\N	137099	137099	137100
27610	44625	81	applied	\N	\N	\N	\N	137101	137101	137102
27610	44626	82	applied	\N	\N	\N	\N	137103	137103	137104
27610	44633	83	applied	\N	\N	\N	\N	137121	137121	137122
27610	44634	84	applied	\N	\N	\N	\N	137123	137123	137124
27610	44639	85	applied	\N	\N	\N	\N	137135	137135	137136
27610	44642	86	applied	\N	\N	\N	\N	137145	137145	137146
27610	44644	87	applied	\N	\N	\N	\N	137151	137151	137152
27610	44648	88	applied	\N	\N	\N	\N	137162	137162	137163
27610	44653	89	applied	\N	\N	\N	\N	137178	137178	137179
27610	44657	90	applied	\N	\N	\N	\N	137191	137191	137192
27610	44660	91	applied	\N	\N	\N	\N	137203	137203	137204
27610	44663	92	applied	\N	\N	\N	\N	137209	137209	137210
27610	44664	93	applied	\N	\N	\N	\N	137211	137211	137212
27610	44669	94	applied	\N	\N	\N	\N	137222	137222	137223
27610	44672	95	applied	\N	\N	\N	\N	137234	137234	137235
27610	44673	96	applied	\N	\N	\N	\N	137236	137236	137237
27610	44678	97	applied	\N	\N	\N	\N	137248	137248	137249
27610	44681	98	applied	\N	\N	\N	\N	137278	137278	137279
27610	44682	99	applied	\N	\N	\N	\N	137280	137280	137281
27610	44687	100	applied	\N	\N	\N	\N	137294	137294	137295
27610	44688	101	applied	\N	\N	\N	\N	137296	137296	137297
27610	44693	102	applied	\N	\N	\N	\N	137308	137308	137309
27610	44694	103	applied	\N	\N	\N	\N	137310	137310	137311
27610	44700	104	applied	\N	\N	\N	\N	137323	137323	137324
27610	44703	105	applied	\N	\N	\N	\N	137330	137330	137331
27610	44706	106	applied	\N	\N	\N	\N	137337	137337	137338
27610	44707	107	applied	\N	\N	\N	\N	137339	137339	137340
27610	44712	108	applied	\N	\N	\N	\N	137354	137354	137355
27610	44715	109	applied	\N	\N	\N	\N	137366	137366	137367
27610	44718	110	applied	\N	\N	\N	\N	137377	137377	137378
27610	44727	111	applied	\N	\N	\N	\N	137398	137398	137399
27610	44730	112	applied	\N	\N	\N	\N	137408	137408	137409
27610	44731	113	applied	\N	\N	\N	\N	137410	137410	137411
27610	44737	114	applied	\N	\N	\N	\N	137424	137424	137425
27610	44738	115	applied	\N	\N	\N	\N	137426	137426	137427
27610	44743	116	applied	\N	\N	\N	\N	137439	137439	137440
27610	44752	117	applied	\N	\N	\N	\N	137459	137459	137460
27610	44755	118	applied	\N	\N	\N	\N	137468	137468	137469
27610	44756	119	applied	\N	\N	\N	\N	137470	137470	137471
27610	44757	120	applied	\N	\N	\N	\N	137472	137472	137473
27610	44758	121	applied	\N	\N	\N	\N	137474	137474	137475
27610	44767	122	applied	\N	\N	\N	\N	137494	137494	137495
27610	44304	123	applied	\N	\N	\N	\N	136961	136961	136252
27610	44565	124	applied	\N	\N	\N	\N	136860	136860	137515
27610	44571	125	applied	\N	\N	\N	\N	136874	136874	136262
27614	44770	0	applied	\N	\N	\N	\N	137522	137522	137523
27614	44771	1	applied	\N	\N	\N	\N	137524	137524	137525
27614	44772	2	applied	\N	\N	\N	\N	137526	137526	137527
27620	44797	0	applied	\N	\N	\N	\N	137591	137591	137592
27620	44798	1	applied	\N	\N	\N	\N	137593	137593	137594
27620	44799	2	applied	\N	\N	\N	\N	137595	137595	137596
27622	44797	0	applied	\N	\N	\N	\N	137591	137591	137592
27622	44798	1	applied	\N	\N	\N	\N	137593	137593	137594
27622	44799	2	applied	\N	\N	\N	\N	137595	137595	137596
27625	44803	0	applied	\N	\N	\N	\N	137608	137608	137609
27625	44804	1	applied	\N	\N	\N	\N	137610	137610	137611
27625	44805	2	applied	\N	\N	\N	\N	137612	137612	137613
27625	44806	3	applied	\N	\N	\N	\N	137614	137614	137615
27625	44807	4	applied	\N	\N	\N	\N	137616	137616	137617
27625	44808	5	applied	\N	\N	\N	\N	137618	137618	137619
27627	44809	0	applied	\N	\N	\N	\N	137625	137625	137626
27627	44810	1	applied	\N	\N	\N	\N	137627	137627	137628
27627	44811	2	applied	\N	\N	\N	\N	137629	137629	102784
27627	44812	3	applied	\N	\N	\N	\N	137630	137630	137631
27630	44819	0	applied	\N	\N	\N	\N	137650	137650	137651
27630	44820	1	applied	\N	\N	\N	\N	137652	137652	137653
27630	44821	2	applied	\N	\N	\N	\N	137654	137654	137655
27632	44822	0	applied	\N	\N	\N	\N	137658	137658	137659
27632	44823	1	applied	\N	\N	\N	\N	137660	137660	137661
27632	44824	2	applied	\N	\N	\N	\N	137662	137662	137663
27634	44825	0	applied	\N	\N	\N	\N	137666	137666	137667
27634	44826	1	applied	\N	\N	\N	\N	137668	137668	137669
27616	44782	9	applied	\N	\N	\N	\N	137552	137552	137553
27616	44783	10	applied	\N	\N	\N	\N	137554	137554	137555
27616	44784	11	applied	\N	\N	\N	\N	137556	137556	137557
27617	44785	0	applied	\N	\N	\N	\N	137560	137560	137561
27617	44786	1	applied	\N	\N	\N	\N	137562	137562	137563
27617	44787	2	applied	\N	\N	\N	\N	137564	137564	137565
27617	44777	3	applied	\N	\N	\N	\N	137542	137542	137543
27617	44778	4	applied	\N	\N	\N	\N	137544	137544	137545
27617	44779	5	applied	\N	\N	\N	\N	137546	137546	137547
27617	44780	6	applied	\N	\N	\N	\N	137548	137548	137549
27617	44781	7	applied	\N	\N	\N	\N	137550	137550	137551
27617	44788	8	applied	\N	\N	\N	\N	137566	137566	137567
27617	44782	9	applied	\N	\N	\N	\N	137552	137552	137568
27617	44783	10	applied	\N	\N	\N	\N	137554	137554	137569
27617	44789	11	applied	\N	\N	\N	\N	137570	137570	137571
27617	44790	12	applied	\N	\N	\N	\N	137572	137572	137573
27617	44784	13	applied	\N	\N	\N	\N	137556	137556	137574
27617	44791	14	applied	\N	\N	\N	\N	137575	137575	137576
27617	44792	15	applied	\N	\N	\N	\N	137577	137577	137578
27617	44793	16	applied	\N	\N	\N	\N	137579	137579	137580
27624	44803	0	applied	\N	\N	\N	\N	137608	137608	137609
27624	44804	1	applied	\N	\N	\N	\N	137610	137610	137611
27624	44805	2	applied	\N	\N	\N	\N	137612	137612	137613
27624	44806	3	applied	\N	\N	\N	\N	137614	137614	137615
27624	44807	4	applied	\N	\N	\N	\N	137616	137616	137617
27624	44808	5	applied	\N	\N	\N	\N	137618	137618	137619
27629	44813	0	applied	\N	\N	\N	\N	137636	137636	137637
27629	44814	1	applied	\N	\N	\N	\N	137638	137638	137639
27629	44815	2	applied	\N	\N	\N	\N	137640	137640	137641
27629	44816	3	applied	\N	\N	\N	\N	137642	137642	137643
27629	44817	4	applied	\N	\N	\N	\N	137644	137644	137645
27629	44818	5	applied	\N	\N	\N	\N	137646	137646	137647
27641	44828	0	applied	\N	\N	\N	\N	137676	137676	137677
27641	44829	1	applied	\N	\N	\N	\N	137678	137678	137679
27641	44830	2	applied	\N	\N	\N	\N	137680	137680	137681
27641	44831	3	applied	\N	\N	\N	\N	137682	137682	137683
27641	44832	4	applied	\N	\N	\N	\N	137684	137684	137685
27641	44833	5	applied	\N	\N	\N	\N	137686	137686	137687
27641	44834	6	applied	\N	\N	\N	\N	137688	137688	137689
27641	44835	7	applied	\N	\N	\N	\N	137690	137690	137691
27641	44836	8	applied	\N	\N	\N	\N	137692	137692	137693
27641	44837	9	applied	\N	\N	\N	\N	137694	137694	137695
27641	44838	10	applied	\N	\N	\N	\N	137696	137696	137697
27641	44839	11	applied	\N	\N	\N	\N	137698	137698	137699
27644	44828	0	applied	\N	\N	\N	\N	137676	137676	137677
27644	44829	1	applied	\N	\N	\N	\N	137678	137678	137679
27644	44830	2	applied	\N	\N	\N	\N	137680	137680	137681
27644	44831	3	applied	\N	\N	\N	\N	137682	137682	137683
27644	44832	4	applied	\N	\N	\N	\N	137684	137684	137685
27644	44833	5	applied	\N	\N	\N	\N	137686	137686	137687
27644	44834	6	applied	\N	\N	\N	\N	137688	137688	137689
27644	44835	7	applied	\N	\N	\N	\N	137690	137690	137691
27644	44836	8	applied	\N	\N	\N	\N	137692	137692	137693
27644	44837	9	applied	\N	\N	\N	\N	137694	137694	137695
27644	44838	10	applied	\N	\N	\N	\N	137696	137696	137697
27644	44839	11	applied	\N	\N	\N	\N	137698	137698	137699
27645	44840	0	applied	\N	\N	\N	\N	137706	137706	137707
27645	44841	1	applied	\N	\N	\N	\N	137708	137708	135497
27645	44842	2	applied	\N	\N	\N	\N	137709	137709	137710
27645	44843	3	applied	\N	\N	\N	\N	137711	137711	137712
27648	44850	0	applied	\N	\N	\N	\N	137729	137729	137730
27648	44851	1	applied	\N	\N	\N	\N	137731	137731	137732
27648	44852	2	applied	\N	\N	\N	\N	137733	137733	137734
27648	44853	3	applied	\N	\N	\N	\N	137735	137735	137736
27648	44854	4	applied	\N	\N	\N	\N	137737	137737	137738
27648	44855	5	applied	\N	\N	\N	\N	137739	137739	137740
27654	44869	0	applied	\N	\N	\N	\N	137801	137801	137802
27654	44870	1	applied	\N	\N	\N	\N	137803	137803	137804
27654	44871	2	applied	\N	\N	\N	\N	137805	137805	137806
27656	44872	0	applied	\N	\N	\N	\N	137809	137809	137810
27656	44873	1	applied	\N	\N	\N	\N	137811	137811	137812
27656	44874	2	applied	\N	\N	\N	\N	137813	137813	137814
27659	44875	0	applied	\N	\N	\N	\N	137817	137817	137818
27659	44876	1	applied	\N	\N	\N	\N	137819	137819	137820
27659	44877	2	applied	\N	\N	\N	\N	137821	137821	137822
27661	44881	0	applied	\N	\N	\N	\N	137831	137831	137832
27661	44882	1	applied	\N	\N	\N	\N	137833	137833	137834
27661	44883	2	applied	\N	\N	\N	\N	137835	137835	137836
27666	44895	0	applied	\N	\N	\N	\N	137863	137863	137864
27666	44896	1	applied	\N	\N	\N	\N	137865	137865	137866
27666	44897	2	applied	\N	\N	\N	\N	137867	137867	137868
27668	44898	0	applied	\N	\N	\N	\N	137873	137873	137874
27668	44899	1	applied	\N	\N	\N	\N	137875	137875	137876
27668	44900	2	applied	\N	\N	\N	\N	137877	137877	137878
27673	44901	0	applied	\N	\N	\N	\N	137884	137884	137885
27673	44902	1	applied	\N	\N	\N	\N	137886	137886	137887
27673	44903	2	applied	\N	\N	\N	\N	137888	137888	137889
27675	44901	0	applied	\N	\N	\N	\N	137884	137884	137885
27675	44902	1	applied	\N	\N	\N	\N	137886	137886	137887
27675	44903	2	applied	\N	\N	\N	\N	137888	137888	137889
27679	44907	0	applied	\N	\N	\N	\N	137907	137907	137908
27679	44908	1	applied	\N	\N	\N	\N	137909	137909	137910
27681	44909	0	applied	\N	\N	\N	\N	137914	137914	137915
27681	44910	1	applied	\N	\N	\N	\N	137916	137916	137917
27681	44911	2	applied	\N	\N	\N	\N	137918	137918	137919
27691	44928	0	applied	\N	\N	\N	\N	137999	137999	138000
27691	44929	1	applied	\N	\N	\N	\N	138001	138001	138002
27691	44930	2	applied	\N	\N	\N	\N	138003	138003	138004
27693	44931	0	applied	\N	\N	\N	\N	138010	138010	138011
27693	44932	1	applied	\N	\N	\N	\N	138012	138012	138013
27693	44933	2	applied	\N	\N	\N	\N	138014	138014	138015
27703	44944	0	applied	\N	\N	\N	\N	138131	138131	138132
27703	44945	1	applied	\N	\N	\N	\N	138133	138133	138134
27703	44946	2	applied	\N	\N	\N	\N	138135	138135	138136
27703	44947	3	applied	\N	\N	\N	\N	138137	138137	138138
27703	44948	4	applied	\N	\N	\N	\N	138139	138139	138140
27703	44949	5	applied	\N	\N	\N	\N	138141	138141	138142
27703	44950	6	applied	\N	\N	\N	\N	138143	138143	138144
27703	44951	7	applied	\N	\N	\N	\N	138145	138145	138146
27704	44952	0	applied	\N	\N	\N	\N	138149	138149	138150
27704	44953	1	applied	\N	\N	\N	\N	138151	138151	138152
27704	44954	2	applied	\N	\N	\N	\N	138153	138153	138154
27704	44955	3	applied	\N	\N	\N	\N	138155	138155	138156
27704	44956	4	applied	\N	\N	\N	\N	138157	138157	138158
27704	44957	5	applied	\N	\N	\N	\N	138159	138159	138160
27704	44958	6	applied	\N	\N	\N	\N	138161	138161	138162
27704	44959	7	applied	\N	\N	\N	\N	138163	138163	138164
27704	44960	8	applied	\N	\N	\N	\N	138165	138165	138166
27704	44961	9	applied	\N	\N	\N	\N	138167	138167	138168
27706	44952	0	applied	\N	\N	\N	\N	138149	138149	138150
27631	44823	1	applied	\N	\N	\N	\N	137660	137660	137661
27631	44824	2	applied	\N	\N	\N	\N	137662	137662	137663
27633	44825	0	applied	\N	\N	\N	\N	137666	137666	137667
27633	44826	1	applied	\N	\N	\N	\N	137668	137668	137669
27633	44827	2	applied	\N	\N	\N	\N	137670	137670	137671
27640	44828	0	applied	\N	\N	\N	\N	137676	137676	137677
27640	44829	1	applied	\N	\N	\N	\N	137678	137678	137679
27640	44830	2	applied	\N	\N	\N	\N	137680	137680	137681
27640	44831	3	applied	\N	\N	\N	\N	137682	137682	137683
27640	44832	4	applied	\N	\N	\N	\N	137684	137684	137685
27640	44833	5	applied	\N	\N	\N	\N	137686	137686	137687
27640	44834	6	applied	\N	\N	\N	\N	137688	137688	137689
27640	44835	7	applied	\N	\N	\N	\N	137690	137690	137691
27640	44836	8	applied	\N	\N	\N	\N	137692	137692	137693
27640	44837	9	applied	\N	\N	\N	\N	137694	137694	137695
27640	44838	10	applied	\N	\N	\N	\N	137696	137696	137697
27640	44839	11	applied	\N	\N	\N	\N	137698	137698	137699
27643	44828	0	applied	\N	\N	\N	\N	137676	137676	137677
27643	44829	1	applied	\N	\N	\N	\N	137678	137678	137679
27643	44830	2	applied	\N	\N	\N	\N	137680	137680	137681
27643	44831	3	applied	\N	\N	\N	\N	137682	137682	137683
27643	44832	4	applied	\N	\N	\N	\N	137684	137684	137685
27643	44833	5	applied	\N	\N	\N	\N	137686	137686	137687
27643	44834	6	applied	\N	\N	\N	\N	137688	137688	137689
27643	44835	7	applied	\N	\N	\N	\N	137690	137690	137691
27643	44836	8	applied	\N	\N	\N	\N	137692	137692	137693
27643	44837	9	applied	\N	\N	\N	\N	137694	137694	137695
27643	44838	10	applied	\N	\N	\N	\N	137696	137696	137697
27643	44839	11	applied	\N	\N	\N	\N	137698	137698	137699
27647	44844	0	applied	\N	\N	\N	\N	137715	137715	137716
27647	44845	1	applied	\N	\N	\N	\N	137717	137717	137718
27647	44846	2	applied	\N	\N	\N	\N	137719	137719	137720
27647	44847	3	applied	\N	\N	\N	\N	137721	137721	137722
27647	44848	4	applied	\N	\N	\N	\N	137723	137723	137724
27647	44849	5	applied	\N	\N	\N	\N	137725	137725	137726
27651	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
27651	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
27651	44721	2	applied	\N	\N	\N	\N	137387	137387	137388
27651	44722	3	applied	\N	\N	\N	\N	137389	137389	137390
27651	44699	4	applied	\N	\N	\N	\N	137321	137321	137322
27651	44700	5	applied	\N	\N	\N	\N	137323	137323	137324
27651	44703	6	applied	\N	\N	\N	\N	137330	137330	137331
27651	44706	7	applied	\N	\N	\N	\N	137337	137337	137338
27651	44707	8	applied	\N	\N	\N	\N	137339	137339	137340
27651	44712	9	applied	\N	\N	\N	\N	137354	137354	137355
27651	44715	10	applied	\N	\N	\N	\N	137366	137366	137367
27651	44860	11	applied	\N	\N	\N	\N	137750	137750	137751
27651	44718	12	applied	\N	\N	\N	\N	137377	137377	137378
27651	44723	13	applied	\N	\N	\N	\N	137391	137391	137392
27651	44724	14	applied	\N	\N	\N	\N	137393	137393	137394
27651	44725	15	applied	\N	\N	\N	\N	137395	137395	137396
27651	44726	16	applied	\N	\N	\N	\N	137397	137397	137397
27651	44744	17	applied	\N	\N	\N	\N	137441	137441	137442
27651	44745	18	applied	\N	\N	\N	\N	137443	137443	137444
27651	44746	19	applied	\N	\N	\N	\N	137445	137445	137446
27651	44747	20	applied	\N	\N	\N	\N	137447	137447	137448
27651	44748	21	applied	\N	\N	\N	\N	137449	137449	137450
27651	44749	22	applied	\N	\N	\N	\N	137451	137451	137451
27651	44727	23	applied	\N	\N	\N	\N	137398	137398	137399
27651	44730	24	applied	\N	\N	\N	\N	137408	137408	137409
27651	44731	25	applied	\N	\N	\N	\N	137410	137410	137411
27651	44737	26	applied	\N	\N	\N	\N	137424	137424	137425
27651	44738	27	applied	\N	\N	\N	\N	137426	137426	137427
27651	44743	28	applied	\N	\N	\N	\N	137439	137439	137440
27651	44752	29	applied	\N	\N	\N	\N	137459	137459	137460
27651	44755	30	applied	\N	\N	\N	\N	137468	137468	137469
27651	44756	31	applied	\N	\N	\N	\N	137470	137470	137471
27651	44757	32	applied	\N	\N	\N	\N	137472	137472	137473
27651	44758	33	applied	\N	\N	\N	\N	137474	137474	137475
27651	44767	34	applied	\N	\N	\N	\N	137494	137494	137495
27651	44770	35	applied	\N	\N	\N	\N	137522	137522	137523
27651	44773	36	applied	\N	\N	\N	\N	137533	137533	137534
27651	44774	37	applied	\N	\N	\N	\N	137535	137535	137536
27651	44775	38	applied	\N	\N	\N	\N	137537	137537	137538
27651	44776	39	applied	\N	\N	\N	\N	137539	137539	137540
27651	44785	40	applied	\N	\N	\N	\N	137560	137560	137561
27651	44786	41	applied	\N	\N	\N	\N	137562	137562	137563
27651	44787	42	applied	\N	\N	\N	\N	137564	137564	137565
27651	44794	43	applied	\N	\N	\N	\N	137583	137583	137584
27651	44797	44	applied	\N	\N	\N	\N	137591	137591	137592
27651	44800	45	applied	\N	\N	\N	\N	137600	137600	137601
27651	44803	46	applied	\N	\N	\N	\N	137608	137608	137609
27651	44804	47	applied	\N	\N	\N	\N	137610	137610	137611
27651	44809	48	applied	\N	\N	\N	\N	137625	137625	137626
27651	44813	49	applied	\N	\N	\N	\N	137636	137636	137637
27651	44814	50	applied	\N	\N	\N	\N	137638	137638	137639
27651	44819	51	applied	\N	\N	\N	\N	137650	137650	137651
27651	44822	53	applied	\N	\N	\N	\N	137658	137658	137659
27651	44825	54	applied	\N	\N	\N	\N	137666	137666	137667
27651	44828	55	applied	\N	\N	\N	\N	137676	137676	137677
27651	44861	56	applied	\N	\N	\N	\N	137752	137752	135497
27651	44829	57	applied	\N	\N	\N	\N	137678	137678	137679
27651	44830	58	applied	\N	\N	\N	\N	137680	137680	137681
27651	44831	59	applied	\N	\N	\N	\N	137682	137682	137683
27651	44840	60	applied	\N	\N	\N	\N	137706	137706	137707
27651	44844	61	applied	\N	\N	\N	\N	137715	137715	137716
27651	44845	62	applied	\N	\N	\N	\N	137717	137717	137718
27651	44850	63	applied	\N	\N	\N	\N	137729	137729	137730
27651	44851	64	applied	\N	\N	\N	\N	137731	137731	137732
27651	44858	65	applied	\N	\N	\N	\N	137746	137746	137747
27651	44859	66	applied	\N	\N	\N	\N	137748	137748	137749
27651	44841	67	applied	\N	\N	\N	\N	137708	137708	135497
27651	44811	68	applied	\N	\N	\N	\N	137629	137629	102784
27651	44701	69	applied	\N	\N	\N	\N	137325	137325	137326
27651	44704	70	applied	\N	\N	\N	\N	137332	137332	137764
27651	44710	71	applied	\N	\N	\N	\N	137347	137347	137765
27651	44702	72	applied	\N	\N	\N	\N	137327	137327	137766
27651	44705	73	applied	\N	\N	\N	\N	137334	137334	137348
27651	44711	74	applied	\N	\N	\N	\N	137349	137349	137350
27651	44714	75	applied	\N	\N	\N	\N	137363	137363	137344
27651	44717	76	applied	\N	\N	\N	\N	137372	137372	137360
27651	44720	77	applied	\N	\N	\N	\N	137381	137381	137352
27651	44728	78	applied	\N	\N	\N	\N	137400	137400	137767
27651	44733	79	applied	\N	\N	\N	\N	137414	137414	137369
27651	44736	80	applied	\N	\N	\N	\N	137420	137420	137370
27651	44739	81	applied	\N	\N	\N	\N	137428	137428	137371
27651	44740	82	applied	\N	\N	\N	\N	137430	137430	137373
27651	44751	83	applied	\N	\N	\N	\N	137454	137454	137768
27651	44754	84	applied	\N	\N	\N	\N	137463	137463	137769
27651	44759	85	applied	\N	\N	\N	\N	137476	137476	137770
27634	44827	2	applied	\N	\N	\N	\N	137670	137670	137671
27642	44828	0	applied	\N	\N	\N	\N	137676	137676	137677
27642	44829	1	applied	\N	\N	\N	\N	137678	137678	137679
27642	44830	2	applied	\N	\N	\N	\N	137680	137680	137681
27642	44831	3	applied	\N	\N	\N	\N	137682	137682	137683
27642	44832	4	applied	\N	\N	\N	\N	137684	137684	137685
27642	44833	5	applied	\N	\N	\N	\N	137686	137686	137687
27642	44834	6	applied	\N	\N	\N	\N	137688	137688	137689
27642	44835	7	applied	\N	\N	\N	\N	137690	137690	137691
27642	44836	8	applied	\N	\N	\N	\N	137692	137692	137693
27642	44837	9	applied	\N	\N	\N	\N	137694	137694	137695
27642	44838	10	applied	\N	\N	\N	\N	137696	137696	137697
27642	44839	11	applied	\N	\N	\N	\N	137698	137698	137699
27646	44840	0	applied	\N	\N	\N	\N	137706	137706	137707
27646	44841	1	applied	\N	\N	\N	\N	137708	137708	135497
27646	44842	2	applied	\N	\N	\N	\N	137709	137709	137710
27646	44843	3	applied	\N	\N	\N	\N	137711	137711	137712
27650	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
27650	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
27650	44858	2	applied	\N	\N	\N	\N	137746	137746	137747
27650	44859	3	applied	\N	\N	\N	\N	137748	137748	137749
27650	44860	4	applied	\N	\N	\N	\N	137750	137750	137751
27650	44861	5	applied	\N	\N	\N	\N	137752	137752	135497
27650	44862	6	applied	\N	\N	\N	\N	137753	137753	137754
27650	44863	7	applied	\N	\N	\N	\N	137755	137755	137756
27650	44864	8	applied	\N	\N	\N	\N	137757	137757	137758
27650	44865	9	applied	\N	\N	\N	\N	137759	137759	137760
27652	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
27652	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
27652	44858	2	applied	\N	\N	\N	\N	137746	137746	137747
27652	44859	3	applied	\N	\N	\N	\N	137748	137748	137749
27652	44860	4	applied	\N	\N	\N	\N	137750	137750	137751
27652	44861	5	applied	\N	\N	\N	\N	137752	137752	135497
27652	44862	6	applied	\N	\N	\N	\N	137753	137753	137754
27652	44863	7	applied	\N	\N	\N	\N	137755	137755	137756
27652	44864	8	applied	\N	\N	\N	\N	137757	137757	137758
27652	44865	9	applied	\N	\N	\N	\N	137759	137759	137760
27662	44884	0	applied	\N	\N	\N	\N	137837	137837	137838
27662	44885	1	applied	\N	\N	\N	\N	137839	137839	137840
27662	44886	2	applied	\N	\N	\N	\N	137841	137841	28166
27662	44887	3	applied	\N	\N	\N	\N	137842	137842	137843
27662	44888	4	applied	\N	\N	\N	\N	137844	137844	137845
27662	44889	5	applied	\N	\N	\N	\N	137846	137846	137847
27662	44890	6	applied	\N	\N	\N	\N	137848	137848	137849
27662	44891	7	applied	\N	\N	\N	\N	137850	137850	137851
27664	44892	0	applied	\N	\N	\N	\N	137855	137855	137856
27664	44893	1	applied	\N	\N	\N	\N	137857	137857	137858
27664	44894	2	applied	\N	\N	\N	\N	137859	137859	137860
27669	44898	0	applied	\N	\N	\N	\N	137873	137873	137874
27669	44899	1	applied	\N	\N	\N	\N	137875	137875	137876
27669	44900	2	applied	\N	\N	\N	\N	137877	137877	137878
27671	44901	0	applied	\N	\N	\N	\N	137884	137884	137885
27671	44902	1	applied	\N	\N	\N	\N	137886	137886	137887
27671	44903	2	applied	\N	\N	\N	\N	137888	137888	137889
27677	44901	0	applied	\N	\N	\N	\N	137884	137884	137885
27677	44902	1	applied	\N	\N	\N	\N	137886	137886	137887
27677	44903	2	applied	\N	\N	\N	\N	137888	137888	137889
27682	44912	0	applied	\N	\N	\N	\N	137922	137922	137923
27682	44913	1	applied	\N	\N	\N	\N	137924	137924	137925
27682	44914	2	applied	\N	\N	\N	\N	137926	137926	137927
27687	44922	0	applied	\N	\N	\N	\N	137985	137985	137986
27687	44923	1	applied	\N	\N	\N	\N	137987	137987	137988
27687	44924	2	applied	\N	\N	\N	\N	137989	137989	137990
27687	44925	3	applied	\N	\N	\N	\N	137991	137991	137992
27687	44926	4	applied	\N	\N	\N	\N	137993	137993	137994
27687	44927	5	applied	\N	\N	\N	\N	137995	137995	137996
27689	44928	0	applied	\N	\N	\N	\N	137999	137999	138000
27689	44929	1	applied	\N	\N	\N	\N	138001	138001	138002
27689	44930	2	applied	\N	\N	\N	\N	138003	138003	138004
27696	44936	0	applied	\N	\N	\N	\N	138025	138025	138026
27696	44937	1	applied	\N	\N	\N	\N	138027	138027	138028
27698	44915	0	applied	\N	\N	\N	\N	137967	137967	138033
27698	44721	1	applied	\N	\N	\N	\N	137502	137502	137388
27698	44722	2	applied	\N	\N	\N	\N	137503	137503	137390
27698	44563	3	applied	\N	\N	\N	\N	136937	136937	138034
27698	44699	4	applied	\N	\N	\N	\N	137321	137321	137322
27698	44723	5	applied	\N	\N	\N	\N	137504	137504	137392
27698	44724	6	applied	\N	\N	\N	\N	137505	137505	137394
27698	44725	7	applied	\N	\N	\N	\N	137506	137506	137396
27698	44726	8	applied	\N	\N	\N	\N	137507	137507	137507
27698	44744	9	applied	\N	\N	\N	\N	137508	137508	137442
27698	44745	10	applied	\N	\N	\N	\N	137509	137509	137444
27698	44746	11	applied	\N	\N	\N	\N	137510	137510	137446
27698	44747	12	applied	\N	\N	\N	\N	137511	137511	137448
27698	44748	13	applied	\N	\N	\N	\N	137512	137512	137450
27698	44749	14	applied	\N	\N	\N	\N	137513	137513	137513
27698	44565	15	applied	\N	\N	\N	\N	136860	136860	138035
27698	44571	16	applied	\N	\N	\N	\N	136874	136874	138036
27698	44506	17	applied	\N	\N	\N	\N	136704	136704	130486
27698	44273	18	applied	\N	\N	\N	\N	138037	138037	136181
27698	44583	19	applied	\N	\N	\N	\N	136899	136899	135411
27698	44387	20	applied	\N	\N	\N	\N	136436	136436	136437
27698	44886	21	applied	\N	\N	\N	\N	137841	137841	28166
27698	44274	22	applied	\N	\N	\N	\N	138038	138038	136183
27698	44811	23	applied	\N	\N	\N	\N	137629	137629	102784
27698	44275	24	applied	\N	\N	\N	\N	138039	138039	136185
27698	44276	25	applied	\N	\N	\N	\N	138040	138040	136187
27698	44277	26	applied	\N	\N	\N	\N	138041	138041	136189
27698	44278	27	applied	\N	\N	\N	\N	138042	138042	136191
27698	44279	28	applied	\N	\N	\N	\N	138043	138043	136193
27698	44280	29	applied	\N	\N	\N	\N	138044	138044	136195
27698	44286	30	applied	\N	\N	\N	\N	138045	138045	136208
27698	44287	31	applied	\N	\N	\N	\N	138046	138046	136210
27698	44290	32	applied	\N	\N	\N	\N	138047	138047	136216
27698	44291	33	applied	\N	\N	\N	\N	138048	138048	136218
27698	44292	34	applied	\N	\N	\N	\N	138049	138049	136220
27698	44293	35	applied	\N	\N	\N	\N	138050	138050	136222
27698	44889	36	applied	\N	\N	\N	\N	137846	137846	137847
27698	44297	37	applied	\N	\N	\N	\N	138051	138051	136232
27698	44298	38	applied	\N	\N	\N	\N	138052	138052	136234
27698	44299	39	applied	\N	\N	\N	\N	138053	138053	136236
27698	44300	40	applied	\N	\N	\N	\N	138054	138054	136238
27698	44301	41	applied	\N	\N	\N	\N	138055	138055	136240
27698	44302	42	applied	\N	\N	\N	\N	138056	138056	136242
27698	44304	43	applied	\N	\N	\N	\N	138057	138057	136252
27698	44305	44	applied	\N	\N	\N	\N	138058	138058	136254
27698	44306	45	applied	\N	\N	\N	\N	138059	138059	136256
27698	44307	46	applied	\N	\N	\N	\N	138060	138060	136258
27698	44308	47	applied	\N	\N	\N	\N	138061	138061	136260
27698	44314	48	applied	\N	\N	\N	\N	138062	138062	136276
27651	44760	86	applied	\N	\N	\N	\N	137478	137478	137771
27651	44763	87	applied	\N	\N	\N	\N	137484	137484	137403
27651	44764	88	applied	\N	\N	\N	\N	137486	137486	137415
27651	44768	89	applied	\N	\N	\N	\N	137496	137496	137772
27651	44771	90	applied	\N	\N	\N	\N	137524	137524	137773
27651	44778	91	applied	\N	\N	\N	\N	137544	137544	137419
27651	44779	92	applied	\N	\N	\N	\N	137546	137546	137421
27651	44780	93	applied	\N	\N	\N	\N	137548	137548	137429
27651	44781	94	applied	\N	\N	\N	\N	137550	137550	137431
27651	44788	95	applied	\N	\N	\N	\N	137566	137566	137774
27651	44789	96	applied	\N	\N	\N	\N	137570	137570	137775
27651	44790	97	applied	\N	\N	\N	\N	137572	137572	137435
27651	44796	98	applied	\N	\N	\N	\N	137587	137587	137776
27651	44799	99	applied	\N	\N	\N	\N	137595	137595	137777
27651	44801	100	applied	\N	\N	\N	\N	137602	137602	137778
27651	44805	101	applied	\N	\N	\N	\N	137612	137612	137462
27651	44806	102	applied	\N	\N	\N	\N	137614	137614	137464
27651	44812	103	applied	\N	\N	\N	\N	137630	137630	137477
27651	44817	104	applied	\N	\N	\N	\N	137644	137644	137479
27651	44818	105	applied	\N	\N	\N	\N	137646	137646	137779
27651	44820	106	applied	\N	\N	\N	\N	137652	137652	137780
27651	44824	107	applied	\N	\N	\N	\N	137662	137662	137483
27651	44827	108	applied	\N	\N	\N	\N	137670	137670	137485
27651	44832	109	applied	\N	\N	\N	\N	137684	137684	137487
27651	44837	110	applied	\N	\N	\N	\N	137694	137694	137781
27651	44838	111	applied	\N	\N	\N	\N	137696	137696	137782
27651	44839	112	applied	\N	\N	\N	\N	137698	137698	137491
27651	44843	113	applied	\N	\N	\N	\N	137711	137711	137497
27651	44846	114	applied	\N	\N	\N	\N	137719	137719	137783
27651	44847	115	applied	\N	\N	\N	\N	137721	137721	137784
27651	44852	116	applied	\N	\N	\N	\N	137733	137733	137785
27651	44853	117	applied	\N	\N	\N	\N	137735	137735	137527
27651	44862	118	applied	\N	\N	\N	\N	137753	137753	137786
27651	44863	119	applied	\N	\N	\N	\N	137755	137755	137787
27651	44708	120	applied	\N	\N	\N	\N	137341	137341	137547
27651	44709	121	applied	\N	\N	\N	\N	137343	137343	137788
27651	44713	122	applied	\N	\N	\N	\N	137356	137356	137567
27651	44716	123	applied	\N	\N	\N	\N	137368	137368	137568
27651	44719	124	applied	\N	\N	\N	\N	137379	137379	137569
27651	44729	125	applied	\N	\N	\N	\N	137402	137402	137789
27653	44866	0	applied	\N	\N	\N	\N	137794	137794	137795
27653	44867	1	applied	\N	\N	\N	\N	137796	137796	137797
27653	44868	2	applied	\N	\N	\N	\N	137798	137798	137799
27658	44875	0	applied	\N	\N	\N	\N	137817	137817	137818
27658	44876	1	applied	\N	\N	\N	\N	137819	137819	137820
27658	44877	2	applied	\N	\N	\N	\N	137821	137821	137822
27672	44902	0	applied	\N	\N	\N	\N	137886	137886	137887
27672	44903	1	applied	\N	\N	\N	\N	137888	137888	137889
27676	44898	0	applied	\N	\N	\N	\N	137873	137873	137874
27676	44901	1	applied	\N	\N	\N	\N	137884	137884	137885
27676	44899	2	applied	\N	\N	\N	\N	137875	137875	137876
27676	44900	3	applied	\N	\N	\N	\N	137877	137877	137878
27678	44904	0	applied	\N	\N	\N	\N	137901	137901	137902
27678	44905	1	applied	\N	\N	\N	\N	137903	137903	137904
27678	44906	2	applied	\N	\N	\N	\N	137905	137905	137906
27683	44866	0	applied	\N	\N	\N	\N	137794	137794	137795
27683	44869	1	applied	\N	\N	\N	\N	137801	137801	137802
27683	44872	2	applied	\N	\N	\N	\N	137809	137809	137810
27683	44875	3	applied	\N	\N	\N	\N	137817	137817	137818
27683	44878	4	applied	\N	\N	\N	\N	137825	137825	137826
27683	44881	5	applied	\N	\N	\N	\N	137831	137831	137832
27683	44884	6	applied	\N	\N	\N	\N	137837	137837	137838
27683	44885	7	applied	\N	\N	\N	\N	137839	137839	137840
27683	44892	8	applied	\N	\N	\N	\N	137855	137855	137856
27683	44895	9	applied	\N	\N	\N	\N	137863	137863	137864
27683	44898	10	applied	\N	\N	\N	\N	137873	137873	137874
27683	44901	11	applied	\N	\N	\N	\N	137884	137884	137885
27683	44904	12	applied	\N	\N	\N	\N	137901	137901	137902
27683	44907	13	applied	\N	\N	\N	\N	137907	137907	137908
27683	44909	14	applied	\N	\N	\N	\N	137914	137914	137915
27683	44912	15	applied	\N	\N	\N	\N	137922	137922	137923
27683	44867	16	applied	\N	\N	\N	\N	137796	137796	137930
27683	44870	17	applied	\N	\N	\N	\N	137803	137803	137574
27683	44886	18	applied	\N	\N	\N	\N	137841	137841	28166
27683	44889	19	applied	\N	\N	\N	\N	137846	137846	137847
27683	44734	20	applied	\N	\N	\N	\N	137416	137416	137576
27683	44735	21	applied	\N	\N	\N	\N	137418	137418	137578
27683	44741	22	applied	\N	\N	\N	\N	137432	137432	137580
27683	44742	23	applied	\N	\N	\N	\N	137434	137434	137586
27683	44750	24	applied	\N	\N	\N	\N	137452	137452	137931
27683	44753	25	applied	\N	\N	\N	\N	137461	137461	137932
27683	44761	26	applied	\N	\N	\N	\N	137480	137480	137603
27683	44762	27	applied	\N	\N	\N	\N	137482	137482	137605
27683	44765	28	applied	\N	\N	\N	\N	137488	137488	137933
27683	44766	29	applied	\N	\N	\N	\N	137490	137490	137934
27683	44769	30	applied	\N	\N	\N	\N	137498	137498	137935
27683	44772	31	applied	\N	\N	\N	\N	137526	137526	137936
27683	44777	32	applied	\N	\N	\N	\N	137542	137542	137631
27683	44782	33	applied	\N	\N	\N	\N	137552	137552	137641
27683	44783	34	applied	\N	\N	\N	\N	137554	137554	137643
27683	44874	35	applied	\N	\N	\N	\N	137813	137813	137645
27683	44876	36	applied	\N	\N	\N	\N	137819	137819	137647
27683	44879	37	applied	\N	\N	\N	\N	137827	137827	137653
27683	44882	38	applied	\N	\N	\N	\N	137833	137833	137937
27683	44887	39	applied	\N	\N	\N	\N	137842	137842	137938
27683	44888	40	applied	\N	\N	\N	\N	137844	137844	137661
27683	44894	41	applied	\N	\N	\N	\N	137859	137859	137663
27683	44897	42	applied	\N	\N	\N	\N	137867	137867	137939
27683	44784	43	applied	\N	\N	\N	\N	137556	137556	137671
27683	44791	44	applied	\N	\N	\N	\N	137575	137575	137940
27683	44792	45	applied	\N	\N	\N	\N	137577	137577	137941
27683	44793	46	applied	\N	\N	\N	\N	137579	137579	137942
27683	44795	47	applied	\N	\N	\N	\N	137585	137585	137943
27683	44798	48	applied	\N	\N	\N	\N	137593	137593	137944
27683	44802	49	applied	\N	\N	\N	\N	137604	137604	137697
27683	44807	50	applied	\N	\N	\N	\N	137616	137616	137945
27683	44808	51	applied	\N	\N	\N	\N	137618	137618	137946
27683	44810	53	applied	\N	\N	\N	\N	137627	137627	137720
27683	44815	54	applied	\N	\N	\N	\N	137640	137640	137948
27683	44816	55	applied	\N	\N	\N	\N	137642	137642	137949
27683	44821	56	applied	\N	\N	\N	\N	137654	137654	137950
27683	44823	57	applied	\N	\N	\N	\N	137660	137660	137736
27683	44826	58	applied	\N	\N	\N	\N	137668	137668	137738
27683	44833	59	applied	\N	\N	\N	\N	137686	137686	137740
27683	44834	60	applied	\N	\N	\N	\N	137688	137688	137951
27683	44835	61	applied	\N	\N	\N	\N	137690	137690	137952
27683	44836	62	applied	\N	\N	\N	\N	137692	137692	137953
27683	44842	63	applied	\N	\N	\N	\N	137709	137709	137797
27683	44848	64	applied	\N	\N	\N	\N	137723	137723	137799
27683	44849	65	applied	\N	\N	\N	\N	137725	137725	137954
27683	44854	66	applied	\N	\N	\N	\N	137737	137737	137955
27683	44855	67	applied	\N	\N	\N	\N	137739	137739	137956
27683	44864	68	applied	\N	\N	\N	\N	137757	137757	137820
27683	44865	69	applied	\N	\N	\N	\N	137759	137759	137822
27683	44868	70	applied	\N	\N	\N	\N	137798	137798	137957
27683	44871	71	applied	\N	\N	\N	\N	137805	137805	137958
27683	44873	72	applied	\N	\N	\N	\N	137811	137811	137959
27683	44877	73	applied	\N	\N	\N	\N	137821	137821	137843
27683	44880	74	applied	\N	\N	\N	\N	137829	137829	137960
27683	44883	75	applied	\N	\N	\N	\N	137835	137835	137961
27683	44890	76	applied	\N	\N	\N	\N	137848	137848	137962
27683	44891	77	applied	\N	\N	\N	\N	137850	137850	137963
27686	44915	0	applied	\N	\N	\N	\N	137967	137967	137968
27686	44916	1	applied	\N	\N	\N	\N	137969	137969	137970
27686	44917	2	applied	\N	\N	\N	\N	137971	137971	137972
27686	44918	3	applied	\N	\N	\N	\N	137973	137973	137974
27686	44919	4	applied	\N	\N	\N	\N	137975	137975	137976
27686	44920	5	applied	\N	\N	\N	\N	137977	137977	137978
27686	44921	6	applied	\N	\N	\N	\N	137979	137979	137980
27688	44922	0	applied	\N	\N	\N	\N	137985	137985	137986
27688	44923	1	applied	\N	\N	\N	\N	137987	137987	137988
27688	44924	2	applied	\N	\N	\N	\N	137989	137989	137990
27688	44925	3	applied	\N	\N	\N	\N	137991	137991	137992
27688	44926	4	applied	\N	\N	\N	\N	137993	137993	137994
27688	44927	5	applied	\N	\N	\N	\N	137995	137995	137996
27695	44934	0	applied	\N	\N	\N	\N	138017	138017	138018
27695	44935	1	applied	\N	\N	\N	\N	138019	138019	138020
27697	44936	0	applied	\N	\N	\N	\N	138025	138025	138026
27697	44937	1	applied	\N	\N	\N	\N	138027	138027	138028
27700	44938	0	applied	\N	\N	\N	\N	138113	138113	138114
27700	44939	1	applied	\N	\N	\N	\N	138115	138115	138116
27700	44940	2	applied	\N	\N	\N	\N	138117	138117	138118
27700	44941	3	applied	\N	\N	\N	\N	138119	138119	138120
27700	44942	4	applied	\N	\N	\N	\N	138121	138121	138122
27700	44943	5	applied	\N	\N	\N	\N	138123	138123	138124
27702	44938	0	applied	\N	\N	\N	\N	138113	138113	138114
27702	44939	1	applied	\N	\N	\N	\N	138115	138115	138116
27702	44940	2	applied	\N	\N	\N	\N	138117	138117	138118
27702	44941	3	applied	\N	\N	\N	\N	138119	138119	138120
27702	44942	4	applied	\N	\N	\N	\N	138121	138121	138122
27702	44943	5	applied	\N	\N	\N	\N	138123	138123	138124
27709	44972	0	applied	\N	\N	\N	\N	138195	138195	138196
27709	44973	1	applied	\N	\N	\N	\N	138197	138197	138198
27711	44972	0	applied	\N	\N	\N	\N	138195	138195	138196
27711	44973	1	applied	\N	\N	\N	\N	138197	138197	138198
27716	44978	0	applied	\N	\N	\N	\N	138214	138214	138215
27716	44979	1	applied	\N	\N	\N	\N	138216	138216	138217
27718	44980	0	applied	\N	\N	\N	\N	138223	138223	138224
27718	44981	1	applied	\N	\N	\N	\N	138225	138225	138226
27720	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
27720	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
27720	44915	2	applied	\N	\N	\N	\N	137967	137967	137968
27720	44954	3	applied	\N	\N	\N	\N	138153	138153	138231
27720	44721	4	applied	\N	\N	\N	\N	137387	137387	137388
27720	44722	5	applied	\N	\N	\N	\N	137389	137389	137390
27720	44955	6	applied	\N	\N	\N	\N	138155	138155	138232
27720	44699	7	applied	\N	\N	\N	\N	137321	137321	137322
27720	44599	8	applied	\N	\N	\N	\N	137021	137021	137022
27720	44600	9	applied	\N	\N	\N	\N	137023	137023	137024
27720	44957	10	applied	\N	\N	\N	\N	138159	138159	138233
27720	44860	11	applied	\N	\N	\N	\N	137750	137750	138160
27720	44610	12	applied	\N	\N	\N	\N	137057	137057	137058
27720	44621	13	applied	\N	\N	\N	\N	137086	137086	137087
27720	44958	14	applied	\N	\N	\N	\N	138161	138161	138162
27720	44723	15	applied	\N	\N	\N	\N	137391	137391	137392
27720	44724	16	applied	\N	\N	\N	\N	137393	137393	137394
27720	44725	17	applied	\N	\N	\N	\N	137395	137395	137396
27720	44726	18	applied	\N	\N	\N	\N	137397	137397	137397
27720	44744	19	applied	\N	\N	\N	\N	137441	137441	137442
27720	44745	20	applied	\N	\N	\N	\N	137443	137443	137444
27720	44746	21	applied	\N	\N	\N	\N	137445	137445	137446
27720	44747	22	applied	\N	\N	\N	\N	137447	137447	137448
27720	44748	23	applied	\N	\N	\N	\N	137449	137449	137450
27720	44749	24	applied	\N	\N	\N	\N	137451	137451	137451
27720	44605	25	applied	\N	\N	\N	\N	137037	137037	137038
27720	44607	26	applied	\N	\N	\N	\N	137043	137043	137044
27720	44611	27	applied	\N	\N	\N	\N	137059	137059	137060
27720	44612	28	applied	\N	\N	\N	\N	137061	137061	137062
27720	44617	29	applied	\N	\N	\N	\N	137076	137076	137077
27720	44620	30	applied	\N	\N	\N	\N	137084	137084	137085
27720	44624	31	applied	\N	\N	\N	\N	137099	137099	137100
27720	44625	32	applied	\N	\N	\N	\N	137101	137101	137102
27720	44626	33	applied	\N	\N	\N	\N	137103	137103	137104
27720	44633	34	applied	\N	\N	\N	\N	137121	137121	137122
27720	44634	35	applied	\N	\N	\N	\N	137123	137123	137124
27720	44639	36	applied	\N	\N	\N	\N	137135	137135	137136
27720	44642	37	applied	\N	\N	\N	\N	137145	137145	137146
27720	44644	38	applied	\N	\N	\N	\N	137151	137151	137152
27720	44648	39	applied	\N	\N	\N	\N	137162	137162	137163
27720	44653	40	applied	\N	\N	\N	\N	137178	137178	137179
27720	44657	41	applied	\N	\N	\N	\N	137191	137191	137192
27720	44660	42	applied	\N	\N	\N	\N	137203	137203	137204
27720	44663	43	applied	\N	\N	\N	\N	137209	137209	137210
27720	44664	44	applied	\N	\N	\N	\N	137211	137211	137212
27720	44669	45	applied	\N	\N	\N	\N	137222	137222	137223
27720	44672	46	applied	\N	\N	\N	\N	137234	137234	137235
27720	44673	47	applied	\N	\N	\N	\N	137236	137236	137237
27720	44678	48	applied	\N	\N	\N	\N	137248	137248	137249
27720	44681	49	applied	\N	\N	\N	\N	137278	137278	137279
27720	44682	50	applied	\N	\N	\N	\N	137280	137280	137281
27720	44687	51	applied	\N	\N	\N	\N	137294	137294	137295
27720	44688	52	applied	\N	\N	\N	\N	137296	137296	137297
27720	44693	53	applied	\N	\N	\N	\N	137308	137308	137309
27720	44694	54	applied	\N	\N	\N	\N	137310	137310	137311
27720	44700	55	applied	\N	\N	\N	\N	137323	137323	137324
27720	44703	56	applied	\N	\N	\N	\N	137330	137330	137331
27720	44706	57	applied	\N	\N	\N	\N	137337	137337	137338
27720	44707	58	applied	\N	\N	\N	\N	137339	137339	137340
27720	44712	59	applied	\N	\N	\N	\N	137354	137354	137355
27720	44715	60	applied	\N	\N	\N	\N	137366	137366	137367
27720	44718	61	applied	\N	\N	\N	\N	137377	137377	137378
27720	44727	62	applied	\N	\N	\N	\N	137398	137398	137399
27720	44730	63	applied	\N	\N	\N	\N	137408	137408	137409
27720	44731	64	applied	\N	\N	\N	\N	137410	137410	137411
27720	44737	65	applied	\N	\N	\N	\N	137424	137424	137425
27720	44738	66	applied	\N	\N	\N	\N	137426	137426	137427
27720	44743	67	applied	\N	\N	\N	\N	137439	137439	137440
27720	44752	68	applied	\N	\N	\N	\N	137459	137459	137460
27720	44755	69	applied	\N	\N	\N	\N	137468	137468	137469
27720	44756	71	applied	\N	\N	\N	\N	137470	137470	137471
27685	44918	3	applied	\N	\N	\N	\N	137973	137973	137974
27685	44919	4	applied	\N	\N	\N	\N	137975	137975	137976
27685	44920	5	applied	\N	\N	\N	\N	137977	137977	137978
27685	44921	6	applied	\N	\N	\N	\N	137979	137979	137980
27690	44928	0	applied	\N	\N	\N	\N	137999	137999	138000
27690	44929	1	applied	\N	\N	\N	\N	138001	138001	138002
27690	44930	2	applied	\N	\N	\N	\N	138003	138003	138004
27692	44928	0	applied	\N	\N	\N	\N	137999	137999	138000
27692	44929	1	applied	\N	\N	\N	\N	138001	138001	138002
27692	44930	2	applied	\N	\N	\N	\N	138003	138003	138004
27694	44934	0	applied	\N	\N	\N	\N	138017	138017	138018
27694	44935	1	applied	\N	\N	\N	\N	138019	138019	138020
27699	44938	0	applied	\N	\N	\N	\N	138113	138113	138114
27699	44939	1	applied	\N	\N	\N	\N	138115	138115	138116
27699	44940	2	applied	\N	\N	\N	\N	138117	138117	138118
27699	44941	3	applied	\N	\N	\N	\N	138119	138119	138120
27699	44942	4	applied	\N	\N	\N	\N	138121	138121	138122
27699	44943	5	applied	\N	\N	\N	\N	138123	138123	138124
27708	44966	0	applied	\N	\N	\N	\N	138182	138182	138183
27708	44967	1	applied	\N	\N	\N	\N	138184	138184	138185
27708	44968	2	applied	\N	\N	\N	\N	138186	138186	138187
27708	44969	3	applied	\N	\N	\N	\N	138188	138188	138189
27708	44970	4	applied	\N	\N	\N	\N	138190	138190	138191
27708	44971	5	applied	\N	\N	\N	\N	138192	138192	138193
27710	44972	0	applied	\N	\N	\N	\N	138195	138195	138196
27710	44973	1	applied	\N	\N	\N	\N	138197	138197	138198
27717	44980	0	applied	\N	\N	\N	\N	138223	138223	138224
27717	44981	1	applied	\N	\N	\N	\N	138225	138225	138226
27719	44980	0	applied	\N	\N	\N	\N	138223	138223	138224
27719	44981	1	applied	\N	\N	\N	\N	138225	138225	138226
27721	44982	0	applied	\N	\N	\N	\N	138237	138237	138238
27721	44983	1	applied	\N	\N	\N	\N	138239	138239	138240
27727	44987	0	applied	\N	\N	\N	\N	138254	138254	138255
27727	44988	1	applied	\N	\N	\N	\N	138256	138256	138257
27727	44989	2	applied	\N	\N	\N	\N	138258	138258	138259
27727	44990	3	applied	\N	\N	\N	\N	138260	138260	138261
27728	44987	0	applied	\N	\N	\N	\N	138254	138254	138255
27728	44988	1	applied	\N	\N	\N	\N	138256	138256	138257
27728	44989	2	applied	\N	\N	\N	\N	138258	138258	138259
27728	44990	3	applied	\N	\N	\N	\N	138260	138260	138261
27730	44991	0	applied	\N	\N	\N	\N	138268	138268	138269
27730	44992	1	applied	\N	\N	\N	\N	138270	138270	138271
27736	45003	0	applied	\N	\N	\N	\N	138300	138300	138301
27736	45004	1	applied	\N	\N	\N	\N	138302	138302	138303
27740	45005	0	applied	\N	\N	\N	\N	138309	138309	138310
27740	45006	1	applied	\N	\N	\N	\N	138311	138311	138312
27742	45021	0	applied	\N	\N	\N	\N	138346	138346	138347
27742	45022	1	applied	\N	\N	\N	\N	138348	138348	138349
27747	45023	0	applied	\N	\N	\N	\N	138354	138354	138355
27747	45024	1	applied	\N	\N	\N	\N	138356	138356	138357
27747	45025	2	applied	\N	\N	\N	\N	138358	138358	138359
27747	45026	3	applied	\N	\N	\N	\N	138360	138360	138361
27749	45029	0	applied	\N	\N	\N	\N	138370	138370	138371
27749	45030	1	applied	\N	\N	\N	\N	138372	138372	138373
27753	45031	0	applied	\N	\N	\N	\N	138382	138382	138383
27753	45032	1	applied	\N	\N	\N	\N	138384	138384	138385
27758	45035	0	applied	\N	\N	\N	\N	138394	138394	138395
27758	45036	1	applied	\N	\N	\N	\N	138396	138396	138397
27698	44315	49	applied	\N	\N	\N	\N	138063	138063	136278
27698	44316	50	applied	\N	\N	\N	\N	138064	138064	136280
27698	44317	51	applied	\N	\N	\N	\N	138065	138065	136282
27698	44318	52	applied	\N	\N	\N	\N	138066	138066	136284
27698	44319	53	applied	\N	\N	\N	\N	138067	138067	136286
27698	44320	54	applied	\N	\N	\N	\N	138068	138068	136288
27698	44321	55	applied	\N	\N	\N	\N	138069	138069	136290
27698	44322	56	applied	\N	\N	\N	\N	138070	138070	136292
27698	44326	57	applied	\N	\N	\N	\N	138071	138071	136300
27698	44327	58	applied	\N	\N	\N	\N	138072	138072	136302
27698	44328	59	applied	\N	\N	\N	\N	138073	138073	136304
27698	44329	60	applied	\N	\N	\N	\N	138074	138074	136306
27698	44330	61	applied	\N	\N	\N	\N	138075	138075	136308
27698	44595	62	applied	\N	\N	\N	\N	136926	136926	138076
27698	44331	63	applied	\N	\N	\N	\N	138077	138077	136310
27698	44338	64	applied	\N	\N	\N	\N	138078	138078	136326
27698	44339	65	applied	\N	\N	\N	\N	138079	138079	136328
27698	44344	66	applied	\N	\N	\N	\N	138080	138080	136340
27698	44346	67	applied	\N	\N	\N	\N	138081	138081	136344
27698	44347	68	applied	\N	\N	\N	\N	138082	138082	136346
27698	44348	69	applied	\N	\N	\N	\N	138083	138083	136348
27698	44349	70	applied	\N	\N	\N	\N	138084	138084	136350
27698	44356	71	applied	\N	\N	\N	\N	138085	138085	136370
27698	44243	72	applied	\N	\N	\N	\N	136089	136089	136090
27698	44358	73	applied	\N	\N	\N	\N	138086	138086	136374
27698	44359	74	applied	\N	\N	\N	\N	138087	138087	136376
27698	44360	75	applied	\N	\N	\N	\N	138088	138088	136378
27698	44361	76	applied	\N	\N	\N	\N	138089	138089	136380
27698	44362	77	applied	\N	\N	\N	\N	138090	138090	136382
27698	44363	78	applied	\N	\N	\N	\N	138091	138091	136384
27698	44364	79	applied	\N	\N	\N	\N	138092	138092	136386
27698	44365	80	applied	\N	\N	\N	\N	138093	138093	136388
27698	44366	81	applied	\N	\N	\N	\N	138094	138094	136390
27698	44367	82	applied	\N	\N	\N	\N	138095	138095	136392
27698	44368	83	applied	\N	\N	\N	\N	138096	138096	136394
27698	44369	84	applied	\N	\N	\N	\N	138097	138097	136396
27698	44370	85	applied	\N	\N	\N	\N	138098	138098	136398
27698	44371	86	applied	\N	\N	\N	\N	138099	138099	136400
27698	44372	87	applied	\N	\N	\N	\N	138100	138100	136402
27698	44373	88	applied	\N	\N	\N	\N	138101	138101	136404
27698	44377	89	applied	\N	\N	\N	\N	138102	138102	136415
27698	44378	90	applied	\N	\N	\N	\N	138103	138103	136417
27698	44379	91	applied	\N	\N	\N	\N	138104	138104	136419
27698	44380	92	applied	\N	\N	\N	\N	138105	138105	136421
27698	44381	93	applied	\N	\N	\N	\N	138106	138106	136423
27698	44382	94	applied	\N	\N	\N	\N	138107	138107	136425
27698	44386	95	applied	\N	\N	\N	\N	138108	138108	136435
27698	44389	96	applied	\N	\N	\N	\N	138109	138109	136441
27698	44390	97	applied	\N	\N	\N	\N	138110	138110	136443
27698	44391	98	applied	\N	\N	\N	\N	138111	138111	136445
27701	44938	0	applied	\N	\N	\N	\N	138113	138113	138114
27701	44939	1	applied	\N	\N	\N	\N	138115	138115	138116
27701	44940	2	applied	\N	\N	\N	\N	138117	138117	138118
27701	44941	3	applied	\N	\N	\N	\N	138119	138119	138120
27701	44942	4	applied	\N	\N	\N	\N	138121	138121	138122
27701	44943	5	applied	\N	\N	\N	\N	138123	138123	138124
27705	44952	0	applied	\N	\N	\N	\N	138149	138149	138150
27705	44953	1	applied	\N	\N	\N	\N	138151	138151	138152
27705	44954	2	applied	\N	\N	\N	\N	138153	138153	138154
27705	44955	3	applied	\N	\N	\N	\N	138155	138155	138156
27705	44956	4	applied	\N	\N	\N	\N	138157	138157	138158
27705	44957	5	applied	\N	\N	\N	\N	138159	138159	138160
27705	44958	6	applied	\N	\N	\N	\N	138161	138161	138162
27705	44959	7	applied	\N	\N	\N	\N	138163	138163	138164
27705	44960	8	applied	\N	\N	\N	\N	138165	138165	138166
27705	44961	9	applied	\N	\N	\N	\N	138167	138167	138168
27707	44962	0	applied	\N	\N	\N	\N	138173	138173	138174
27707	44963	1	applied	\N	\N	\N	\N	138175	138175	138176
27707	44964	2	applied	\N	\N	\N	\N	138177	138177	138178
27707	44965	3	applied	\N	\N	\N	\N	138179	138179	138180
27712	44974	0	applied	\N	\N	\N	\N	138202	138202	138203
27712	44975	1	applied	\N	\N	\N	\N	138204	138204	138205
27712	44976	2	applied	\N	\N	\N	\N	138206	138206	138207
27712	44977	3	applied	\N	\N	\N	\N	138208	138208	138209
27714	44978	0	applied	\N	\N	\N	\N	138214	138214	138215
27714	44979	1	applied	\N	\N	\N	\N	138216	138216	138217
27715	44978	0	applied	\N	\N	\N	\N	138214	138214	138215
27715	44979	1	applied	\N	\N	\N	\N	138216	138216	138217
27723	44982	0	applied	\N	\N	\N	\N	138237	138237	138238
27723	44983	1	applied	\N	\N	\N	\N	138239	138239	138240
27732	44993	0	applied	\N	\N	\N	\N	138276	138276	138277
27732	44994	1	applied	\N	\N	\N	\N	138278	138278	138279
27735	45001	0	applied	\N	\N	\N	\N	138296	138296	138297
27735	45002	1	applied	\N	\N	\N	\N	138298	138298	138299
27738	45003	0	applied	\N	\N	\N	\N	138300	138300	138301
27738	45004	1	applied	\N	\N	\N	\N	138302	138302	138303
27741	45007	0	applied	\N	\N	\N	\N	138316	138316	138317
27741	45008	1	applied	\N	\N	\N	\N	138318	138318	138319
27741	45009	2	applied	\N	\N	\N	\N	138320	138320	138321
27741	45010	3	applied	\N	\N	\N	\N	138322	138322	138323
27741	45011	4	applied	\N	\N	\N	\N	138324	138324	138325
27741	45012	5	applied	\N	\N	\N	\N	138326	138326	138327
27741	45013	6	applied	\N	\N	\N	\N	138328	138328	138329
27741	45014	7	applied	\N	\N	\N	\N	138330	138330	138331
27741	45015	8	applied	\N	\N	\N	\N	138332	138332	138333
27741	45016	9	applied	\N	\N	\N	\N	138334	138334	138335
27741	45017	10	applied	\N	\N	\N	\N	138336	138336	138337
27741	45018	11	applied	\N	\N	\N	\N	138338	138338	138339
27741	45019	12	applied	\N	\N	\N	\N	138340	138340	138341
27741	45020	13	applied	\N	\N	\N	\N	138342	138342	138343
27744	45021	0	applied	\N	\N	\N	\N	138346	138346	138347
27744	45022	1	applied	\N	\N	\N	\N	138348	138348	138349
27746	45023	0	applied	\N	\N	\N	\N	138354	138354	138355
27746	45024	1	applied	\N	\N	\N	\N	138356	138356	138357
27746	45025	2	applied	\N	\N	\N	\N	138358	138358	138359
27746	45026	3	applied	\N	\N	\N	\N	138360	138360	138361
27748	45027	0	applied	\N	\N	\N	\N	138365	138365	138366
27748	45028	1	applied	\N	\N	\N	\N	138367	138367	138368
27755	45032	0	applied	\N	\N	\N	\N	138384	138384	138385
27757	45035	0	applied	\N	\N	\N	\N	138394	138394	138395
27757	45036	1	applied	\N	\N	\N	\N	138396	138396	138397
27706	44953	1	applied	\N	\N	\N	\N	138151	138151	138152
27706	44954	2	applied	\N	\N	\N	\N	138153	138153	138154
27706	44955	3	applied	\N	\N	\N	\N	138155	138155	138156
27706	44956	4	applied	\N	\N	\N	\N	138157	138157	138158
27706	44957	5	applied	\N	\N	\N	\N	138159	138159	138160
27706	44958	6	applied	\N	\N	\N	\N	138161	138161	138162
27706	44959	7	applied	\N	\N	\N	\N	138163	138163	138164
27706	44960	8	applied	\N	\N	\N	\N	138165	138165	138166
27706	44961	9	applied	\N	\N	\N	\N	138167	138167	138168
27713	44974	0	applied	\N	\N	\N	\N	138202	138202	138203
27713	44975	1	applied	\N	\N	\N	\N	138204	138204	138205
27713	44976	2	applied	\N	\N	\N	\N	138206	138206	138207
27713	44977	3	applied	\N	\N	\N	\N	138208	138208	138209
27722	44982	0	applied	\N	\N	\N	\N	138237	138237	138238
27722	44983	1	applied	\N	\N	\N	\N	138239	138239	138240
27724	44984	0	applied	\N	\N	\N	\N	138246	138246	138247
27724	44985	1	applied	\N	\N	\N	\N	138248	138248	138249
27724	44986	2	applied	\N	\N	\N	\N	138250	138250	138251
27731	44991	0	applied	\N	\N	\N	\N	138268	138268	138269
27731	44992	1	applied	\N	\N	\N	\N	138270	138270	138271
27733	44993	0	applied	\N	\N	\N	\N	138276	138276	138277
27733	44994	1	applied	\N	\N	\N	\N	138278	138278	138279
27743	45021	0	applied	\N	\N	\N	\N	138346	138346	138347
27743	45022	1	applied	\N	\N	\N	\N	138348	138348	138349
27745	45021	0	applied	\N	\N	\N	\N	138346	138346	138347
27745	45022	1	applied	\N	\N	\N	\N	138348	138348	138349
27750	45029	0	applied	\N	\N	\N	\N	138370	138370	138371
27750	45030	1	applied	\N	\N	\N	\N	138372	138372	138373
27754	45031	0	applied	\N	\N	\N	\N	138382	138382	138383
27754	45032	1	applied	\N	\N	\N	\N	138384	138384	138385
27756	45033	0	applied	\N	\N	\N	\N	138389	138389	138390
27756	45034	1	applied	\N	\N	\N	\N	138391	138391	138392
27720	44757	72	applied	\N	\N	\N	\N	137472	137472	137473
27720	44758	73	applied	\N	\N	\N	\N	137474	137474	137475
27720	44767	74	applied	\N	\N	\N	\N	137494	137494	137495
27720	44770	75	applied	\N	\N	\N	\N	137522	137522	137523
27720	44773	76	applied	\N	\N	\N	\N	137533	137533	137534
27720	44774	77	applied	\N	\N	\N	\N	137535	137535	137536
27720	44775	78	applied	\N	\N	\N	\N	137537	137537	137538
27720	44776	79	applied	\N	\N	\N	\N	137539	137539	137540
27720	44785	80	applied	\N	\N	\N	\N	137560	137560	137561
27720	44786	81	applied	\N	\N	\N	\N	137562	137562	137563
27720	44787	82	applied	\N	\N	\N	\N	137564	137564	137565
27720	44794	83	applied	\N	\N	\N	\N	137583	137583	137584
27720	44797	84	applied	\N	\N	\N	\N	137591	137591	137592
27720	44800	85	applied	\N	\N	\N	\N	137600	137600	137601
27720	44803	86	applied	\N	\N	\N	\N	137608	137608	137609
27720	44804	87	applied	\N	\N	\N	\N	137610	137610	137611
27720	44809	88	applied	\N	\N	\N	\N	137625	137625	137626
27720	44813	89	applied	\N	\N	\N	\N	137636	137636	137637
27720	44814	90	applied	\N	\N	\N	\N	137638	137638	137639
27720	44819	91	applied	\N	\N	\N	\N	137650	137650	137651
27720	44822	92	applied	\N	\N	\N	\N	137658	137658	137659
27720	44825	93	applied	\N	\N	\N	\N	137666	137666	137667
27720	44828	94	applied	\N	\N	\N	\N	137676	137676	137677
27720	44861	95	applied	\N	\N	\N	\N	137752	137752	137968
27720	44829	96	applied	\N	\N	\N	\N	137678	137678	137679
27720	44830	97	applied	\N	\N	\N	\N	137680	137680	137681
27720	44831	98	applied	\N	\N	\N	\N	137682	137682	137683
27720	44840	99	applied	\N	\N	\N	\N	137706	137706	137707
27720	44844	100	applied	\N	\N	\N	\N	137715	137715	137716
27720	44845	101	applied	\N	\N	\N	\N	137717	137717	137718
27720	44850	102	applied	\N	\N	\N	\N	137729	137729	137730
27720	44851	103	applied	\N	\N	\N	\N	137731	137731	137732
27720	44858	104	applied	\N	\N	\N	\N	137746	137746	137747
27720	44859	105	applied	\N	\N	\N	\N	137748	137748	137749
27720	44866	106	applied	\N	\N	\N	\N	137794	137794	137795
27720	44869	107	applied	\N	\N	\N	\N	137801	137801	137802
27720	44872	108	applied	\N	\N	\N	\N	137809	137809	137810
27720	44875	109	applied	\N	\N	\N	\N	137817	137817	137818
27720	44878	110	applied	\N	\N	\N	\N	137825	137825	137826
27720	44881	111	applied	\N	\N	\N	\N	137831	137831	137832
27720	44884	112	applied	\N	\N	\N	\N	137837	137837	137838
27720	44885	113	applied	\N	\N	\N	\N	137839	137839	137840
27720	44892	114	applied	\N	\N	\N	\N	137855	137855	137856
27720	44895	115	applied	\N	\N	\N	\N	137863	137863	137864
27720	44898	116	applied	\N	\N	\N	\N	137873	137873	137874
27720	44901	117	applied	\N	\N	\N	\N	137884	137884	137885
27720	44904	118	applied	\N	\N	\N	\N	137901	137901	137902
27720	44907	119	applied	\N	\N	\N	\N	137907	137907	137908
27720	44909	120	applied	\N	\N	\N	\N	137914	137914	137915
27720	44912	121	applied	\N	\N	\N	\N	137922	137922	137923
27720	44916	122	applied	\N	\N	\N	\N	137969	137969	137970
27720	44917	123	applied	\N	\N	\N	\N	137971	137971	137972
27720	44922	124	applied	\N	\N	\N	\N	137985	137985	137986
27720	44923	125	applied	\N	\N	\N	\N	137987	137987	137988
27725	44987	0	applied	\N	\N	\N	\N	138254	138254	138255
27725	44988	1	applied	\N	\N	\N	\N	138256	138256	138257
27725	44989	2	applied	\N	\N	\N	\N	138258	138258	138259
27725	44990	3	applied	\N	\N	\N	\N	138260	138260	138261
27729	44987	0	applied	\N	\N	\N	\N	138254	138254	138255
27729	44988	1	applied	\N	\N	\N	\N	138256	138256	138257
27729	44989	2	applied	\N	\N	\N	\N	138258	138258	138259
27729	44990	3	applied	\N	\N	\N	\N	138260	138260	138261
27734	44995	0	applied	\N	\N	\N	\N	138282	138282	138283
27734	44996	1	applied	\N	\N	\N	\N	138284	138284	138285
27734	44997	2	applied	\N	\N	\N	\N	138286	138286	138287
27734	44998	3	applied	\N	\N	\N	\N	138288	138288	138289
27734	44999	4	applied	\N	\N	\N	\N	138290	138290	138291
27734	45000	5	applied	\N	\N	\N	\N	138292	138292	138293
27737	45003	0	applied	\N	\N	\N	\N	138300	138300	138301
27737	45004	1	applied	\N	\N	\N	\N	138302	138302	138303
27739	45005	0	applied	\N	\N	\N	\N	138309	138309	138310
27739	45006	1	applied	\N	\N	\N	\N	138311	138311	138312
27751	45029	0	applied	\N	\N	\N	\N	138370	138370	138371
27751	45030	1	applied	\N	\N	\N	\N	138372	138372	138373
27752	45029	0	applied	\N	\N	\N	\N	138370	138370	138371
27752	45030	1	applied	\N	\N	\N	\N	138372	138372	138373
27759	45037	0	applied	\N	\N	\N	\N	138469	138469	138470
27759	45038	1	applied	\N	\N	\N	\N	138471	138471	138472
27759	45039	2	applied	\N	\N	\N	\N	138473	138473	138474
27759	45040	3	applied	\N	\N	\N	\N	138475	138475	138476
27759	45041	4	applied	\N	\N	\N	\N	138477	138477	138478
27759	45042	5	applied	\N	\N	\N	\N	138479	138479	138480
27759	45043	6	applied	\N	\N	\N	\N	138481	138481	138482
27759	45044	7	applied	\N	\N	\N	\N	138483	138483	138484
27759	45045	8	applied	\N	\N	\N	\N	138485	138485	138486
27759	45046	9	applied	\N	\N	\N	\N	138487	138487	138488
27760	45037	0	applied	\N	\N	\N	\N	138469	138469	138470
27760	45038	1	applied	\N	\N	\N	\N	138471	138471	138472
27760	45039	2	applied	\N	\N	\N	\N	138473	138473	138474
27760	45040	3	applied	\N	\N	\N	\N	138475	138475	138476
27760	45041	4	applied	\N	\N	\N	\N	138477	138477	138478
27760	45042	5	applied	\N	\N	\N	\N	138479	138479	138480
27760	45043	6	applied	\N	\N	\N	\N	138481	138481	138482
27760	45044	7	applied	\N	\N	\N	\N	138483	138483	138484
27760	45045	8	applied	\N	\N	\N	\N	138485	138485	138486
27760	45046	9	applied	\N	\N	\N	\N	138487	138487	138488
27761	45047	0	applied	\N	\N	\N	\N	138493	138493	138494
27761	45048	1	applied	\N	\N	\N	\N	138495	138495	138496
27762	45049	0	applied	\N	\N	\N	\N	138499	138499	138500
27762	45050	1	applied	\N	\N	\N	\N	138501	138501	138502
27763	45049	0	applied	\N	\N	\N	\N	138499	138499	138500
27763	45050	1	applied	\N	\N	\N	\N	138501	138501	138502
27764	45051	0	applied	\N	\N	\N	\N	138506	138506	138507
27764	45052	1	applied	\N	\N	\N	\N	138508	138508	138509
27765	45053	0	applied	\N	\N	\N	\N	138512	138512	138513
27765	45054	1	applied	\N	\N	\N	\N	138514	138514	138515
27766	45055	0	applied	\N	\N	\N	\N	138518	138518	138519
27766	45056	1	applied	\N	\N	\N	\N	138520	138520	138521
27767	45055	0	applied	\N	\N	\N	\N	138518	138518	138519
27767	45056	1	applied	\N	\N	\N	\N	138520	138520	138521
27768	45055	0	applied	\N	\N	\N	\N	138518	138518	138519
27768	45056	1	applied	\N	\N	\N	\N	138520	138520	138521
27769	45055	0	applied	\N	\N	\N	\N	138518	138518	138519
27769	45056	1	applied	\N	\N	\N	\N	138520	138520	138521
27770	45057	0	applied	\N	\N	\N	\N	138529	138529	138530
27770	45058	1	applied	\N	\N	\N	\N	138531	138531	138532
27772	45059	0	applied	\N	\N	\N	\N	138535	138535	138536
27772	45060	1	applied	\N	\N	\N	\N	138537	138537	138538
27772	45061	2	applied	\N	\N	\N	\N	138539	138539	138540
27772	45062	3	applied	\N	\N	\N	\N	138541	138541	138542
27773	45063	0	applied	\N	\N	\N	\N	138545	138545	138546
27773	45064	1	applied	\N	\N	\N	\N	138547	138547	138548
27773	45065	2	applied	\N	\N	\N	\N	138549	138549	138550
27773	45066	3	applied	\N	\N	\N	\N	138551	138551	138552
27773	45067	4	applied	\N	\N	\N	\N	138553	138553	138554
27773	45068	5	applied	\N	\N	\N	\N	138555	138555	138556
27773	45069	6	applied	\N	\N	\N	\N	138557	138557	138558
27775	45070	0	applied	\N	\N	\N	\N	138560	138560	138561
27775	45071	1	applied	\N	\N	\N	\N	138562	138562	138563
27776	45072	0	applied	\N	\N	\N	\N	138567	138567	138568
27776	45073	1	applied	\N	\N	\N	\N	138569	138569	138570
27776	45074	2	applied	\N	\N	\N	\N	138571	138571	138572
27776	45075	3	applied	\N	\N	\N	\N	138573	138573	138574
27778	45076	0	applied	\N	\N	\N	\N	138577	138577	138578
27778	45077	1	applied	\N	\N	\N	\N	138579	138579	138580
27779	45076	0	applied	\N	\N	\N	\N	138577	138577	138578
27779	45077	1	applied	\N	\N	\N	\N	138579	138579	138580
27785	45093	0	applied	\N	\N	\N	\N	138754	138754	138755
27785	45094	1	applied	\N	\N	\N	\N	138756	138756	138757
27785	45095	2	applied	\N	\N	\N	\N	138758	138758	138759
27785	45096	3	applied	\N	\N	\N	\N	138760	138760	138761
27788	45099	0	applied	\N	\N	\N	\N	138769	138769	138770
27788	45100	1	applied	\N	\N	\N	\N	138771	138771	138772
27788	45101	2	applied	\N	\N	\N	\N	138773	138773	138774
27788	45102	3	applied	\N	\N	\N	\N	138775	138775	138776
27788	45103	4	applied	\N	\N	1000000000	\N	138777	138777	138778
27794	45112	0	applied	\N	\N	\N	\N	138806	138806	138807
27794	45113	1	applied	\N	\N	\N	\N	138808	138808	138809
27794	45114	2	applied	\N	\N	\N	\N	138810	138810	138811
27794	45115	3	applied	\N	\N	\N	\N	138812	138812	138813
27794	45116	4	applied	\N	\N	\N	\N	138814	138814	138815
27794	45117	5	applied	\N	\N	\N	\N	138816	138816	138817
27796	45118	0	applied	\N	\N	\N	\N	138820	138820	138821
27796	45119	1	applied	\N	\N	\N	\N	138822	138822	138823
27796	45120	2	applied	\N	\N	\N	\N	138824	138824	138825
27799	45121	0	applied	\N	\N	\N	\N	138831	138831	138832
27799	45122	1	applied	\N	\N	\N	\N	138833	138833	13857
27799	45123	2	applied	\N	\N	\N	\N	138834	138834	138835
27799	45124	3	applied	\N	\N	\N	\N	138836	138836	138837
27803	45125	0	applied	\N	\N	\N	\N	138845	138845	138846
27803	45126	1	applied	\N	\N	\N	\N	138847	138847	138848
27803	45127	2	applied	\N	\N	\N	\N	138849	138849	138850
27805	45128	0	applied	\N	\N	\N	\N	138852	138852	138853
27805	45129	1	applied	\N	\N	\N	\N	138854	138854	138855
27805	45130	2	applied	\N	\N	\N	\N	138856	138856	138857
27805	45131	3	applied	\N	\N	\N	\N	138858	138858	138859
27805	45132	4	applied	\N	\N	\N	\N	138860	138860	138861
27805	45133	5	applied	\N	\N	\N	\N	138862	138862	138863
27806	45134	0	applied	\N	\N	\N	\N	138868	138868	138869
27806	45135	1	applied	\N	\N	\N	\N	138870	138870	138871
27806	45136	2	applied	\N	\N	\N	\N	138872	138872	138873
27806	45137	3	applied	\N	\N	\N	\N	138874	138874	138875
27806	45138	4	applied	\N	\N	\N	\N	138876	138876	138877
27806	45139	5	applied	\N	\N	\N	\N	138878	138878	138879
27809	45134	0	applied	\N	\N	\N	\N	138868	138868	138869
27809	45135	1	applied	\N	\N	\N	\N	138870	138870	138871
27809	45136	2	applied	\N	\N	\N	\N	138872	138872	138873
27809	45137	3	applied	\N	\N	\N	\N	138874	138874	138875
27809	45138	4	applied	\N	\N	\N	\N	138876	138876	138877
27809	45139	5	applied	\N	\N	\N	\N	138878	138878	138879
27812	45149	0	applied	\N	\N	\N	\N	138905	138905	138906
27812	45150	1	applied	\N	\N	\N	\N	138907	138907	138908
27812	45151	2	applied	\N	\N	\N	\N	138909	138909	138910
27812	45152	3	applied	\N	\N	\N	\N	138911	138911	138912
27812	45153	4	applied	\N	\N	\N	\N	138913	138913	138914
27812	45154	5	applied	\N	\N	\N	\N	138915	138915	138916
27818	45170	0	applied	\N	\N	\N	\N	138956	138956	138957
27818	45171	1	applied	\N	\N	\N	\N	138958	138958	138959
27818	45172	2	applied	\N	\N	\N	\N	138960	138960	138961
27821	45176	0	applied	\N	\N	\N	\N	138974	138974	138975
27821	45177	1	applied	\N	\N	\N	\N	138976	138976	138977
27821	45178	2	applied	\N	\N	\N	\N	138978	138978	138979
27824	45179	0	applied	\N	\N	\N	\N	138981	138981	138982
27824	45180	1	applied	\N	\N	\N	\N	138983	138983	138984
27824	45181	2	applied	\N	\N	\N	\N	138985	138985	138986
27827	45185	0	applied	\N	\N	\N	\N	139000	139000	139001
27827	45186	1	applied	\N	\N	\N	\N	139002	139002	139003
27827	45187	2	applied	\N	\N	\N	\N	139004	139004	139005
27834	45203	0	applied	\N	\N	\N	\N	139045	139045	139046
27834	45204	1	applied	\N	\N	\N	\N	139047	139047	139048
27834	45205	2	applied	\N	\N	\N	\N	139049	139049	139050
27836	45209	0	applied	\N	\N	\N	\N	139064	139064	139065
27836	45210	1	applied	\N	\N	\N	\N	139066	139066	139067
27836	45211	2	applied	\N	\N	\N	\N	139068	139068	139069
27839	45221	0	applied	\N	\N	\N	\N	139093	139093	139094
27839	45222	1	applied	\N	\N	\N	\N	139095	139095	139096
27839	45223	2	applied	\N	\N	\N	\N	139097	139097	139098
27841	45221	0	applied	\N	\N	\N	\N	139093	139093	139094
27841	45222	1	applied	\N	\N	\N	\N	139095	139095	139096
27841	45223	2	applied	\N	\N	\N	\N	139097	139097	139098
27842	45224	0	applied	\N	\N	\N	\N	139104	139104	139105
27842	45225	1	applied	\N	\N	\N	\N	139106	139106	139107
27842	45226	2	applied	\N	\N	\N	\N	139108	139108	139109
27842	45227	3	applied	\N	\N	\N	\N	139110	139110	139111
27842	45228	4	applied	\N	\N	\N	\N	139112	139112	139113
27842	45229	5	applied	\N	\N	\N	\N	139114	139114	139115
27842	45230	6	applied	\N	\N	\N	\N	139116	139116	139117
27842	45231	7	applied	\N	\N	\N	\N	139118	139118	139119
27842	45232	8	applied	\N	\N	\N	\N	139120	139120	139121
27845	45239	0	applied	\N	\N	\N	\N	139140	139140	139141
27845	45240	1	applied	\N	\N	\N	\N	139142	139142	139143
27845	45241	2	applied	\N	\N	\N	\N	139144	139144	139145
27847	45242	0	applied	\N	\N	\N	\N	139147	139147	139148
27847	45243	1	applied	\N	\N	\N	\N	139149	139149	139150
27847	45244	2	applied	\N	\N	\N	\N	139151	139151	139152
27848	45242	0	applied	\N	\N	\N	\N	139147	139147	139148
27848	45243	1	applied	\N	\N	\N	\N	139149	139149	139150
27848	45244	2	applied	\N	\N	\N	\N	139151	139151	139152
27850	45245	0	applied	\N	\N	\N	\N	139159	139159	139160
27850	45246	1	applied	\N	\N	\N	\N	139161	139161	139162
27850	45247	2	applied	\N	\N	\N	\N	139163	139163	139164
27851	45245	0	applied	\N	\N	\N	\N	139159	139159	139160
27851	45246	1	applied	\N	\N	\N	\N	139161	139161	139162
27851	45247	2	applied	\N	\N	\N	\N	139163	139163	139164
27854	45251	0	applied	\N	\N	\N	\N	139175	139175	139176
27854	45252	2	applied	\N	\N	\N	\N	139178	139178	139179
27854	45253	3	applied	\N	\N	\N	\N	139180	139180	139181
27857	45260	0	applied	\N	\N	\N	\N	139200	139200	139201
27857	45261	1	applied	\N	\N	\N	\N	139202	139202	139203
27857	45262	2	applied	\N	\N	\N	\N	139204	139204	139205
27774	45070	0	applied	\N	\N	\N	\N	138560	138560	138561
27774	45071	1	applied	\N	\N	\N	\N	138562	138562	138563
27777	45076	0	applied	\N	\N	\N	\N	138577	138577	138578
27777	45077	1	applied	\N	\N	\N	\N	138579	138579	138580
27780	45078	0	applied	\N	\N	\N	\N	138585	138585	138586
27780	45079	1	applied	\N	\N	\N	\N	138587	138587	138588
27780	45080	2	applied	\N	\N	\N	\N	138589	138589	138590
27780	45081	4	applied	\N	\N	\N	\N	138592	138592	138593
27782	45078	0	applied	\N	\N	\N	\N	138585	138585	138586
27782	45079	1	applied	\N	\N	\N	\N	138587	138587	138588
27782	45080	2	applied	\N	\N	\N	\N	138589	138589	138590
27782	45081	4	applied	\N	\N	\N	\N	138592	138592	138593
27783	45082	0	applied	\N	\N	\N	\N	138730	138730	44452
27783	45083	1	applied	\N	\N	\N	\N	138731	138731	138732
27783	45084	2	applied	\N	\N	\N	\N	138733	138733	138734
27783	45085	3	applied	\N	\N	\N	\N	138735	138735	138736
27783	45086	4	applied	\N	\N	\N	\N	138737	138737	138738
27783	45087	5	applied	\N	\N	\N	\N	138739	138739	138740
27783	45088	6	applied	\N	\N	\N	\N	138741	138741	138742
27786	45097	0	applied	\N	\N	\N	\N	138763	138763	138764
27786	45098	1	applied	\N	\N	\N	\N	138765	138765	138766
27789	45104	0	applied	\N	\N	\N	\N	138781	138781	138782
27789	45105	1	applied	\N	\N	\N	\N	138783	138783	138784
27791	45106	0	applied	\N	\N	\N	\N	138787	138787	138788
27791	45107	1	applied	\N	\N	\N	\N	138789	138789	138790
27791	45108	2	applied	\N	\N	\N	\N	138791	138791	138792
27792	45106	0	applied	\N	\N	\N	\N	138787	138787	138788
27792	45107	1	applied	\N	\N	\N	\N	138789	138789	138790
27792	45108	2	applied	\N	\N	\N	\N	138791	138791	138792
27795	45118	0	applied	\N	\N	\N	\N	138820	138820	138821
27795	45119	1	applied	\N	\N	\N	\N	138822	138822	138823
27795	45120	2	applied	\N	\N	\N	\N	138824	138824	138825
27798	45121	0	applied	\N	\N	\N	\N	138831	138831	138832
27798	45122	1	applied	\N	\N	\N	\N	138833	138833	13857
27798	45123	2	applied	\N	\N	\N	\N	138834	138834	138835
27798	45124	3	applied	\N	\N	\N	\N	138836	138836	138837
27800	45121	0	applied	\N	\N	\N	\N	138831	138831	138832
27800	45122	1	applied	\N	\N	\N	\N	138833	138833	13857
27800	45123	2	applied	\N	\N	\N	\N	138834	138834	138835
27800	45124	3	applied	\N	\N	\N	\N	138836	138836	138837
27801	45121	0	applied	\N	\N	\N	\N	138831	138831	138832
27801	45122	1	applied	\N	\N	\N	\N	138833	138833	13857
27801	45123	2	applied	\N	\N	\N	\N	138834	138834	138835
27801	45124	3	applied	\N	\N	\N	\N	138836	138836	138837
27804	45128	0	applied	\N	\N	\N	\N	138852	138852	138853
27804	45129	1	applied	\N	\N	\N	\N	138854	138854	138855
27804	45130	2	applied	\N	\N	\N	\N	138856	138856	138857
27804	45131	3	applied	\N	\N	\N	\N	138858	138858	138859
27804	45132	4	applied	\N	\N	\N	\N	138860	138860	138861
27804	45133	5	applied	\N	\N	\N	\N	138862	138862	138863
27808	45134	0	applied	\N	\N	\N	\N	138868	138868	138869
27808	45135	1	applied	\N	\N	\N	\N	138870	138870	138871
27808	45136	2	applied	\N	\N	\N	\N	138872	138872	138873
27808	45137	3	applied	\N	\N	\N	\N	138874	138874	138875
27808	45138	4	applied	\N	\N	\N	\N	138876	138876	138877
27808	45139	5	applied	\N	\N	\N	\N	138878	138878	138879
27810	45140	0	applied	\N	\N	\N	\N	138884	138884	138885
27810	45141	1	applied	\N	\N	\N	\N	138886	138886	138887
27810	45142	2	applied	\N	\N	\N	\N	138888	138888	138889
27810	45143	3	applied	\N	\N	\N	\N	138890	138890	138891
27810	45144	4	applied	\N	\N	\N	\N	138892	138892	138893
27810	45145	5	applied	\N	\N	\N	\N	138894	138894	138895
27813	45155	0	applied	\N	\N	\N	\N	138919	138919	138920
27813	45156	1	applied	\N	\N	\N	\N	138921	138921	138922
27813	45157	2	applied	\N	\N	\N	\N	138923	138923	138924
27815	45158	0	applied	\N	\N	\N	\N	138926	138926	138927
27815	45159	1	applied	\N	\N	\N	\N	138928	138928	138929
27815	45160	2	applied	\N	\N	\N	\N	138930	138930	138931
27815	45161	3	applied	\N	\N	\N	\N	138932	138932	138933
27815	45162	4	applied	\N	\N	\N	\N	138934	138934	138935
27815	45163	5	applied	\N	\N	\N	\N	138936	138936	138937
27816	45164	0	applied	\N	\N	\N	\N	138940	138940	138941
27816	45165	1	applied	\N	\N	\N	\N	138942	138942	138943
27816	45166	2	applied	\N	\N	\N	\N	138944	138944	138945
27819	45170	0	applied	\N	\N	\N	\N	138956	138956	138957
27819	45171	1	applied	\N	\N	\N	\N	138958	138958	138959
27819	45172	2	applied	\N	\N	\N	\N	138960	138960	138961
27822	45176	0	applied	\N	\N	\N	\N	138974	138974	138975
27822	45177	1	applied	\N	\N	\N	\N	138976	138976	138977
27822	45178	2	applied	\N	\N	\N	\N	138978	138978	138979
27825	45182	0	applied	\N	\N	\N	\N	138990	138990	138991
27825	45183	1	applied	\N	\N	\N	\N	138992	138992	138993
27825	45184	2	applied	\N	\N	\N	\N	138994	138994	138995
27828	45188	0	applied	\N	\N	\N	\N	139008	139008	139009
27828	45189	1	applied	\N	\N	\N	\N	139010	139010	139011
27828	45190	2	applied	\N	\N	\N	\N	139012	139012	139013
27830	45191	0	applied	\N	\N	\N	\N	139015	139015	139016
27830	45192	1	applied	\N	\N	\N	\N	139017	139017	139018
27830	45193	2	applied	\N	\N	\N	\N	139019	139019	139020
27830	45194	3	applied	\N	\N	\N	\N	139021	139021	139022
27830	45195	4	applied	\N	\N	\N	\N	139023	139023	139024
27830	45196	5	applied	\N	\N	\N	\N	139025	139025	139026
27830	45197	6	applied	\N	\N	\N	\N	139027	139027	139028
27830	45198	7	applied	\N	\N	\N	\N	139029	139029	139030
27830	45199	8	applied	\N	\N	\N	\N	139031	139031	139032
27830	45200	9	applied	\N	\N	\N	\N	139033	139033	139034
27830	45201	10	applied	\N	\N	\N	\N	139035	139035	139036
27830	45202	11	applied	\N	\N	\N	\N	139037	139037	139038
27833	45203	0	applied	\N	\N	\N	\N	139045	139045	139046
27833	45204	1	applied	\N	\N	\N	\N	139047	139047	139048
27833	45205	2	applied	\N	\N	\N	\N	139049	139049	139050
27837	45212	0	applied	\N	\N	\N	\N	139072	139072	139073
27837	45213	1	applied	\N	\N	\N	\N	139074	139074	139075
27837	45214	2	applied	\N	\N	\N	\N	139076	139076	139077
27843	45224	0	applied	\N	\N	\N	\N	139104	139104	139105
27843	45225	1	applied	\N	\N	\N	\N	139106	139106	139107
27843	45226	2	applied	\N	\N	\N	\N	139108	139108	139109
27843	45227	3	applied	\N	\N	\N	\N	139110	139110	139111
27843	45228	4	applied	\N	\N	\N	\N	139112	139112	139113
27843	45229	5	applied	\N	\N	\N	\N	139114	139114	139115
27843	45230	6	applied	\N	\N	\N	\N	139116	139116	139117
27843	45231	7	applied	\N	\N	\N	\N	139118	139118	139119
27843	45232	8	applied	\N	\N	\N	\N	139120	139120	139121
27846	45242	0	applied	\N	\N	\N	\N	139147	139147	139148
27846	45243	1	applied	\N	\N	\N	\N	139149	139149	139150
27846	45244	2	applied	\N	\N	\N	\N	139151	139151	139152
27849	45245	0	applied	\N	\N	\N	\N	139159	139159	139160
27849	45246	1	applied	\N	\N	\N	\N	139161	139161	139162
27849	45247	2	applied	\N	\N	\N	\N	139163	139163	139164
27852	45248	0	applied	\N	\N	\N	\N	139167	139167	139168
27781	45078	0	applied	\N	\N	\N	\N	138585	138585	138586
27781	45079	1	applied	\N	\N	\N	\N	138587	138587	138588
27781	45080	2	applied	\N	\N	\N	\N	138589	138589	138590
27781	45081	4	applied	\N	\N	\N	\N	138592	138592	138593
27784	45089	0	applied	\N	\N	\N	\N	138745	138745	138746
27784	45090	1	applied	\N	\N	\N	\N	138747	138747	138748
27784	45091	2	applied	\N	\N	\N	\N	138749	138749	138750
27784	45092	3	applied	\N	\N	\N	\N	138751	138751	138752
27787	45099	0	applied	\N	\N	\N	\N	138769	138769	138770
27787	45100	1	applied	\N	\N	\N	\N	138771	138771	138772
27787	45101	2	applied	\N	\N	\N	\N	138773	138773	138774
27787	45102	3	applied	\N	\N	\N	\N	138775	138775	138776
27787	45103	4	applied	\N	\N	1000000000	\N	138777	138777	138778
27790	45106	0	applied	\N	\N	\N	\N	138787	138787	138788
27790	45107	1	applied	\N	\N	\N	\N	138789	138789	138790
27790	45108	2	applied	\N	\N	\N	\N	138791	138791	138792
27793	45109	0	applied	\N	\N	\N	\N	138798	138798	138799
27793	45110	1	applied	\N	\N	\N	\N	138800	138800	138801
27793	45111	2	applied	\N	\N	\N	\N	138802	138802	138803
27797	45118	0	applied	\N	\N	\N	\N	138820	138820	138821
27797	45119	1	applied	\N	\N	\N	\N	138822	138822	138823
27797	45120	2	applied	\N	\N	\N	\N	138824	138824	138825
27802	45125	0	applied	\N	\N	\N	\N	138845	138845	138846
27802	45126	1	applied	\N	\N	\N	\N	138847	138847	138848
27802	45127	2	applied	\N	\N	\N	\N	138849	138849	138850
27807	45134	0	applied	\N	\N	\N	\N	138868	138868	138869
27807	45135	1	applied	\N	\N	\N	\N	138870	138870	138871
27807	45136	2	applied	\N	\N	\N	\N	138872	138872	138873
27807	45137	3	applied	\N	\N	\N	\N	138874	138874	138875
27807	45138	4	applied	\N	\N	\N	\N	138876	138876	138877
27807	45139	5	applied	\N	\N	\N	\N	138878	138878	138879
27811	45146	0	applied	\N	\N	\N	\N	138898	138898	138899
27811	45147	1	applied	\N	\N	\N	\N	138900	138900	138901
27811	45148	2	applied	\N	\N	\N	\N	138902	138902	138903
27814	45158	0	applied	\N	\N	\N	\N	138926	138926	138927
27814	45159	1	applied	\N	\N	\N	\N	138928	138928	138929
27814	45160	2	applied	\N	\N	\N	\N	138930	138930	138931
27814	45161	3	applied	\N	\N	\N	\N	138932	138932	138933
27814	45162	4	applied	\N	\N	\N	\N	138934	138934	138935
27814	45163	5	applied	\N	\N	\N	\N	138936	138936	138937
27817	45167	0	applied	\N	\N	\N	\N	138948	138948	138949
27817	45168	1	applied	\N	\N	\N	\N	138950	138950	138951
27817	45169	2	applied	\N	\N	\N	\N	138952	138952	138953
27820	45173	0	applied	\N	\N	\N	\N	138966	138966	138967
27820	45174	1	applied	\N	\N	\N	\N	138968	138968	138969
27820	45175	2	applied	\N	\N	\N	\N	138970	138970	138971
27823	45179	0	applied	\N	\N	\N	\N	138981	138981	138982
27823	45180	1	applied	\N	\N	\N	\N	138983	138983	138984
27823	45181	2	applied	\N	\N	\N	\N	138985	138985	138986
27826	45182	0	applied	\N	\N	\N	\N	138990	138990	138991
27826	45183	1	applied	\N	\N	\N	\N	138992	138992	138993
27826	45184	2	applied	\N	\N	\N	\N	138994	138994	138995
27829	45191	0	applied	\N	\N	\N	\N	139015	139015	139016
27829	45192	1	applied	\N	\N	\N	\N	139017	139017	139018
27829	45193	2	applied	\N	\N	\N	\N	139019	139019	139020
27829	45194	3	applied	\N	\N	\N	\N	139021	139021	139022
27829	45195	4	applied	\N	\N	\N	\N	139023	139023	139024
27829	45196	5	applied	\N	\N	\N	\N	139025	139025	139026
27829	45197	6	applied	\N	\N	\N	\N	139027	139027	139028
27829	45198	7	applied	\N	\N	\N	\N	139029	139029	139030
27829	45199	8	applied	\N	\N	\N	\N	139031	139031	139032
27829	45200	9	applied	\N	\N	\N	\N	139033	139033	139034
27829	45201	10	applied	\N	\N	\N	\N	139035	139035	139036
27829	45202	11	applied	\N	\N	\N	\N	139037	139037	139038
27831	45191	0	applied	\N	\N	\N	\N	139015	139015	139016
27831	45192	1	applied	\N	\N	\N	\N	139017	139017	139018
27831	45193	2	applied	\N	\N	\N	\N	139019	139019	139020
27831	45194	3	applied	\N	\N	\N	\N	139021	139021	139022
27831	45195	4	applied	\N	\N	\N	\N	139023	139023	139024
27831	45196	5	applied	\N	\N	\N	\N	139025	139025	139026
27831	45197	6	applied	\N	\N	\N	\N	139027	139027	139028
27831	45198	7	applied	\N	\N	\N	\N	139029	139029	139030
27831	45199	8	applied	\N	\N	\N	\N	139031	139031	139032
27831	45200	9	applied	\N	\N	\N	\N	139033	139033	139034
27831	45201	10	applied	\N	\N	\N	\N	139035	139035	139036
27831	45202	11	applied	\N	\N	\N	\N	139037	139037	139038
27832	45203	0	applied	\N	\N	\N	\N	139045	139045	139046
27832	45204	1	applied	\N	\N	\N	\N	139047	139047	139048
27832	45205	2	applied	\N	\N	\N	\N	139049	139049	139050
27835	45206	0	applied	\N	\N	\N	\N	139056	139056	139057
27835	45207	1	applied	\N	\N	\N	\N	139058	139058	139059
27835	45208	2	applied	\N	\N	\N	\N	139060	139060	139061
27838	45215	0	applied	\N	\N	\N	\N	139080	139080	139081
27838	45216	1	applied	\N	\N	\N	\N	139082	139082	139083
27838	45217	2	applied	\N	\N	\N	\N	139084	139084	139085
27838	45218	3	applied	\N	\N	\N	\N	139086	139086	139087
27838	45219	4	applied	\N	\N	\N	\N	139088	139088	139089
27838	45220	5	applied	\N	\N	\N	\N	139090	139090	139091
27840	45221	0	applied	\N	\N	\N	\N	139093	139093	139094
27840	45222	1	applied	\N	\N	\N	\N	139095	139095	139096
27840	45223	2	applied	\N	\N	\N	\N	139097	139097	139098
27844	45233	0	applied	\N	\N	\N	\N	139126	139126	139127
27844	45234	1	applied	\N	\N	\N	\N	139128	139128	139129
27844	45235	2	applied	\N	\N	\N	\N	139130	139130	139131
27844	45236	3	applied	\N	\N	\N	\N	139132	139132	139133
27844	45237	4	applied	\N	\N	\N	\N	139134	139134	139135
27844	45238	5	applied	\N	\N	\N	\N	139136	139136	139137
27853	45251	0	applied	\N	\N	\N	\N	139175	139175	139176
27853	45252	2	applied	\N	\N	\N	\N	139178	139178	139179
27853	45253	3	applied	\N	\N	\N	\N	139180	139180	139181
27856	45254	0	applied	\N	\N	\N	\N	139184	139184	139185
27856	45255	1	applied	\N	\N	\N	\N	139186	139186	139187
27856	45256	2	applied	\N	\N	\N	\N	139188	139188	139189
27856	45257	3	applied	\N	\N	\N	\N	139190	139190	139191
27856	45258	4	applied	\N	\N	\N	\N	139192	139192	139193
27856	45259	5	applied	\N	\N	\N	\N	139194	139194	139195
27859	45263	0	applied	\N	\N	\N	\N	139210	139210	139211
27859	45264	1	applied	\N	\N	\N	\N	139212	139212	139213
27859	45265	2	applied	\N	\N	\N	\N	139214	139214	139215
27859	45266	3	applied	\N	\N	\N	\N	139216	139216	139217
27859	45267	4	applied	\N	\N	\N	\N	139218	139218	139219
27859	45268	5	applied	\N	\N	\N	\N	139220	139220	139221
27865	45281	0	applied	\N	\N	\N	\N	139253	139253	139254
27865	45282	1	applied	\N	\N	\N	\N	139255	139255	139256
27865	45283	2	applied	\N	\N	1000000000	\N	139257	139257	139258
27865	45284	3	applied	\N	\N	\N	\N	139259	139259	139260
27868	45295	0	applied	\N	\N	\N	\N	139286	139286	139287
27868	45296	1	applied	\N	\N	\N	\N	139288	139288	139289
27868	45297	2	applied	\N	\N	\N	\N	139290	139290	139291
27852	45249	1	applied	\N	\N	\N	\N	139169	139169	139170
27852	45250	2	applied	\N	\N	\N	\N	139171	139171	139172
27855	45254	0	applied	\N	\N	\N	\N	139184	139184	139185
27855	45255	1	applied	\N	\N	\N	\N	139186	139186	139187
27855	45256	2	applied	\N	\N	\N	\N	139188	139188	139189
27855	45257	3	applied	\N	\N	\N	\N	139190	139190	139191
27855	45258	4	applied	\N	\N	\N	\N	139192	139192	139193
27855	45259	5	applied	\N	\N	\N	\N	139194	139194	139195
27858	45260	0	applied	\N	\N	\N	\N	139200	139200	139201
27858	45261	1	applied	\N	\N	\N	\N	139202	139202	139203
27858	45262	2	applied	\N	\N	\N	\N	139204	139204	139205
27861	45272	0	applied	\N	\N	\N	\N	139229	139229	139230
27861	45273	1	applied	\N	\N	\N	\N	139231	139231	139232
27861	45274	2	applied	\N	\N	\N	\N	139233	139233	139234
27864	45278	0	applied	\N	\N	\N	\N	139245	139245	139246
27864	45279	1	applied	\N	\N	\N	\N	139247	139247	139248
27864	45280	2	applied	\N	\N	\N	\N	139249	139249	139250
27867	45292	0	applied	\N	\N	\N	\N	139278	139278	139279
27867	45293	1	applied	\N	\N	\N	\N	139280	139280	139281
27867	45294	2	applied	\N	\N	\N	\N	139282	139282	139283
27870	45295	0	applied	\N	\N	\N	\N	139286	139286	139287
27870	45296	1	applied	\N	\N	\N	\N	139288	139288	139289
27870	45297	2	applied	\N	\N	\N	\N	139290	139290	139291
27876	45304	0	applied	\N	\N	\N	\N	139352	139352	139353
27876	45305	1	applied	\N	\N	\N	\N	139354	139354	139355
27876	45306	2	applied	\N	\N	\N	\N	139356	139356	139357
27878	45307	0	applied	\N	\N	\N	\N	139359	139359	139360
27878	45308	1	applied	\N	\N	\N	\N	139361	139361	139362
27878	45309	2	applied	\N	\N	\N	\N	139363	139363	139364
27882	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
27882	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
27882	44915	2	applied	\N	\N	\N	\N	137967	137967	137968
27882	44954	3	applied	\N	\N	\N	\N	138153	138153	138231
27882	44721	4	applied	\N	\N	\N	\N	137387	137387	137388
27882	45082	5	applied	\N	\N	\N	\N	138730	138730	44452
27882	44722	6	applied	\N	\N	\N	\N	137389	137389	137390
27882	44955	7	applied	\N	\N	\N	\N	138155	138155	138232
27882	44699	8	applied	\N	\N	\N	\N	137321	137321	137322
27882	44957	9	applied	\N	\N	\N	\N	138159	138159	138233
27882	44860	10	applied	\N	\N	\N	\N	137750	137750	138160
27882	44958	11	applied	\N	\N	\N	\N	138161	138161	138162
27882	44723	12	applied	\N	\N	\N	\N	137391	137391	137392
27882	44724	13	applied	\N	\N	\N	\N	137393	137393	137394
27882	44725	14	applied	\N	\N	\N	\N	137395	137395	137396
27882	44726	15	applied	\N	\N	\N	\N	137397	137397	137397
27882	44744	16	applied	\N	\N	\N	\N	137441	137441	137442
27882	44745	17	applied	\N	\N	\N	\N	137443	137443	137444
27882	44746	18	applied	\N	\N	\N	\N	137445	137445	137446
27882	44747	19	applied	\N	\N	\N	\N	137447	137447	137448
27882	44748	20	applied	\N	\N	\N	\N	137449	137449	137450
27882	44749	21	applied	\N	\N	\N	\N	137451	137451	137451
27882	44861	22	applied	\N	\N	\N	\N	137752	137752	137968
27882	44841	23	applied	\N	\N	\N	\N	137708	137708	137968
27882	45287	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	139267	139267	\N
27882	44886	25	applied	\N	\N	\N	\N	137841	137841	28166
27882	44811	26	applied	\N	\N	\N	\N	137629	137629	102784
27882	45283	27	applied	\N	\N	1000000000	\N	139257	139257	139258
27882	45069	28	applied	\N	\N	\N	\N	138557	138557	139390
27882	45103	29	applied	\N	\N	1000000000	\N	138777	138777	138778
27882	44889	30	applied	\N	\N	\N	\N	137846	137846	137847
27886	45333	0	applied	\N	\N	\N	\N	139427	139427	139428
27886	45334	1	applied	\N	\N	\N	\N	139429	139429	139430
27886	45335	2	applied	\N	\N	\N	\N	139431	139431	139432
27886	45336	3	applied	\N	\N	\N	\N	139433	139433	139434
27886	45337	4	applied	\N	\N	\N	\N	139435	139435	139436
27886	45338	5	applied	\N	\N	\N	\N	139437	139437	139438
27886	45339	7	applied	\N	\N	\N	\N	139440	139440	139441
27886	45340	8	applied	\N	\N	\N	\N	139442	139442	139443
27886	45341	9	applied	\N	\N	\N	\N	139444	139444	139445
27888	45342	0	applied	\N	\N	\N	\N	139448	139448	139449
27888	45343	1	applied	\N	\N	\N	\N	139450	139450	139451
27888	45344	2	applied	\N	\N	\N	\N	139452	139452	139453
27889	45342	0	applied	\N	\N	\N	\N	139448	139448	139449
27889	45343	1	applied	\N	\N	\N	\N	139450	139450	139451
27889	45344	2	applied	\N	\N	\N	\N	139452	139452	139453
27892	45351	0	applied	\N	\N	\N	\N	139479	139479	139480
27892	45352	1	applied	\N	\N	\N	\N	139481	139481	139482
27892	45353	2	applied	\N	\N	\N	\N	139483	139483	139484
27894	45351	0	applied	\N	\N	\N	\N	139479	139479	139480
27894	45352	1	applied	\N	\N	\N	\N	139481	139481	139482
27894	45353	2	applied	\N	\N	\N	\N	139483	139483	139484
27895	45354	0	applied	\N	\N	\N	\N	139489	139489	139490
27895	45355	1	applied	\N	\N	\N	\N	139491	139491	139492
27895	45356	2	applied	\N	\N	\N	\N	139493	139493	139494
27895	45357	3	applied	\N	\N	\N	\N	139495	139495	139496
27895	45358	4	applied	\N	\N	\N	\N	139497	139497	139498
27895	45359	5	applied	\N	\N	\N	\N	139499	139499	139500
27895	45360	6	applied	\N	\N	\N	\N	139501	139501	139502
27898	45361	0	applied	\N	\N	\N	\N	139508	139508	139509
27898	45362	1	applied	\N	\N	\N	\N	139510	139510	139511
27898	45363	2	applied	\N	\N	\N	\N	139512	139512	139513
27901	45367	0	applied	\N	\N	\N	\N	139523	139523	139524
27901	45368	1	applied	\N	\N	\N	\N	139525	139525	139526
27901	45369	2	applied	\N	\N	\N	\N	139527	139527	139528
27901	45370	3	applied	\N	\N	\N	\N	139529	139529	139530
27901	45371	4	applied	\N	\N	\N	\N	139531	139531	139532
27901	45372	5	applied	\N	\N	\N	\N	139533	139533	139534
27904	45379	0	applied	\N	\N	\N	\N	139550	139550	139551
27904	45380	1	applied	\N	\N	\N	\N	139552	139552	139553
27904	45381	2	applied	\N	\N	\N	\N	139554	139554	139555
27907	45404	0	applied	\N	\N	\N	\N	139604	139604	139605
27907	45405	1	applied	\N	\N	\N	\N	139606	139606	139607
27907	45406	2	applied	\N	\N	\N	\N	139608	139608	139609
27907	45407	3	applied	\N	\N	\N	\N	139610	139610	139611
27907	45408	4	applied	\N	\N	\N	\N	139612	139612	139613
27907	45409	5	applied	\N	\N	\N	\N	139614	139614	139615
27909	45410	0	applied	\N	\N	\N	\N	139617	139617	139618
27909	45411	1	applied	\N	\N	\N	\N	139619	139619	139620
27909	45412	2	applied	\N	\N	\N	\N	139621	139621	139622
27910	45410	0	applied	\N	\N	\N	\N	139617	139617	139618
27910	45411	1	applied	\N	\N	\N	\N	139619	139619	139620
27910	45412	2	applied	\N	\N	\N	\N	139621	139621	139622
27913	45419	0	applied	\N	\N	\N	\N	139643	139643	139644
27913	45420	1	applied	\N	\N	\N	\N	139645	139645	139646
27913	45421	2	applied	\N	\N	\N	\N	139647	139647	139648
27916	45431	0	applied	\N	\N	\N	\N	139673	139673	139674
27916	45432	1	applied	\N	\N	\N	\N	139675	139675	139676
27916	45433	2	applied	\N	\N	\N	\N	139677	139677	139678
27918	45425	0	applied	\N	\N	\N	\N	139658	139658	139659
27860	45269	0	applied	\N	\N	\N	\N	139223	139223	139224
27860	45270	1	applied	\N	\N	\N	\N	139225	139225	139226
27860	45271	2	applied	\N	\N	\N	\N	139227	139227	139228
27862	45272	0	applied	\N	\N	\N	\N	139229	139229	139230
27862	45273	1	applied	\N	\N	\N	\N	139231	139231	139232
27862	45274	2	applied	\N	\N	\N	\N	139233	139233	139234
27863	45275	0	applied	\N	\N	\N	\N	139239	139239	139240
27863	45276	1	applied	\N	\N	\N	\N	139241	139241	139242
27863	45277	2	applied	\N	\N	\N	\N	139243	139243	139244
27866	45285	0	applied	\N	\N	\N	\N	139263	139263	139264
27866	45286	1	applied	\N	\N	\N	\N	139265	139265	139266
27866	45287	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	139267	139267	\N
27866	45288	3	applied	\N	\N	\N	\N	139268	139268	139269
27866	45289	4	applied	\N	\N	\N	\N	139270	139270	139271
27866	45290	5	applied	\N	\N	\N	\N	139272	139272	139273
27866	45291	6	applied	\N	\N	\N	\N	139274	139274	139275
27869	45295	0	applied	\N	\N	\N	\N	139286	139286	139287
27869	45296	1	applied	\N	\N	\N	\N	139288	139288	139289
27869	45297	2	applied	\N	\N	\N	\N	139290	139290	139291
27872	45298	0	applied	\N	\N	\N	\N	139336	139336	139337
27872	45299	1	applied	\N	\N	\N	\N	139338	139338	139339
27872	45300	2	applied	\N	\N	\N	\N	139340	139340	139341
27875	45301	0	applied	\N	\N	\N	\N	139345	139345	139346
27875	45302	1	applied	\N	\N	\N	\N	139347	139347	139348
27875	45303	2	applied	\N	\N	\N	\N	139349	139349	139350
27879	45307	0	applied	\N	\N	\N	\N	139359	139359	139360
27879	45308	1	applied	\N	\N	\N	\N	139361	139361	139362
27879	45309	2	applied	\N	\N	\N	\N	139363	139363	139364
27881	45310	0	applied	\N	\N	\N	\N	139370	139370	139371
27881	45311	1	applied	\N	\N	\N	\N	139372	139372	139373
27881	45312	2	applied	\N	\N	\N	\N	139374	139374	139375
27881	45313	3	applied	\N	\N	\N	\N	139376	139376	139377
27881	45314	4	applied	\N	\N	\N	\N	139378	139378	139379
27881	45315	5	applied	\N	\N	\N	\N	139380	139380	139381
27881	45316	6	applied	\N	\N	\N	\N	139382	139382	139383
27881	45317	7	applied	\N	\N	\N	\N	139384	139384	139385
27883	45318	0	applied	\N	\N	\N	\N	139393	139393	139394
27883	45319	1	applied	\N	\N	\N	\N	139395	139395	139396
27883	45320	2	applied	\N	\N	\N	\N	139397	139397	139398
27885	45330	0	applied	\N	\N	\N	\N	139419	139419	139420
27885	45331	1	applied	\N	\N	\N	\N	139421	139421	139422
27885	45332	2	applied	\N	\N	\N	\N	139423	139423	139424
27891	45348	0	applied	\N	\N	\N	\N	139471	139471	139472
27891	45349	1	applied	\N	\N	\N	\N	139473	139473	139474
27891	45350	2	applied	\N	\N	\N	\N	139475	139475	139476
27893	45351	0	applied	\N	\N	\N	\N	139479	139479	139480
27893	45352	1	applied	\N	\N	\N	\N	139481	139481	139482
27893	45353	2	applied	\N	\N	\N	\N	139483	139483	139484
27896	45354	0	applied	\N	\N	\N	\N	139489	139489	139490
27896	45355	1	applied	\N	\N	\N	\N	139491	139491	139492
27896	45356	2	applied	\N	\N	\N	\N	139493	139493	139494
27896	45357	3	applied	\N	\N	\N	\N	139495	139495	139496
27896	45358	4	applied	\N	\N	\N	\N	139497	139497	139498
27896	45359	5	applied	\N	\N	\N	\N	139499	139499	139500
27896	45360	6	applied	\N	\N	\N	\N	139501	139501	139502
27900	45364	0	applied	\N	\N	\N	\N	139515	139515	139516
27900	45365	1	applied	\N	\N	\N	\N	139517	139517	139518
27900	45366	2	applied	\N	\N	\N	\N	139519	139519	139520
27903	45376	0	applied	\N	\N	\N	\N	139542	139542	139543
27903	45377	1	applied	\N	\N	\N	\N	139544	139544	139545
27903	45378	2	applied	\N	\N	\N	\N	139546	139546	139547
27906	45401	0	applied	\N	\N	\N	\N	139596	139596	139597
27906	45402	1	applied	\N	\N	\N	\N	139598	139598	139599
27906	45403	2	applied	\N	\N	\N	\N	139600	139600	139601
27912	45413	0	applied	\N	\N	\N	\N	139628	139628	139629
27912	45414	1	applied	\N	\N	\N	\N	139630	139630	139631
27912	45415	2	applied	\N	\N	\N	\N	139632	139632	139633
27912	45416	3	applied	\N	\N	\N	\N	139634	139634	139635
27912	45417	4	applied	\N	\N	\N	\N	139636	139636	139637
27912	45418	5	applied	\N	\N	\N	\N	139638	139638	139639
27915	45425	0	applied	\N	\N	\N	\N	139658	139658	139659
27915	45426	1	applied	\N	\N	\N	\N	139660	139660	139661
27915	45427	2	applied	\N	\N	\N	\N	139662	139662	139663
27915	45428	4	applied	\N	\N	\N	\N	139665	139665	139666
27915	45429	5	applied	\N	\N	\N	\N	139667	139667	139668
27915	45430	6	applied	\N	\N	\N	\N	139669	139669	139670
27917	45431	0	applied	\N	\N	\N	\N	139673	139673	139674
27917	45432	1	applied	\N	\N	\N	\N	139675	139675	139676
27917	45433	2	applied	\N	\N	\N	\N	139677	139677	139678
27920	45434	0	applied	\N	\N	\N	\N	139688	139688	139689
27920	45435	1	applied	\N	\N	\N	\N	139690	139690	139691
27920	45436	2	applied	\N	\N	\N	\N	139692	139692	139693
27921	45437	0	applied	\N	\N	\N	\N	139696	139696	139697
27921	45438	1	applied	\N	\N	\N	\N	139698	139698	139699
27921	45439	2	applied	\N	\N	\N	\N	139700	139700	139701
27924	45443	0	applied	\N	\N	\N	\N	139713	139713	139714
27924	45444	1	applied	\N	\N	\N	\N	139715	139715	139716
27924	45445	2	applied	\N	\N	\N	\N	139717	139717	139718
27927	45450	0	applied	\N	\N	\N	\N	139732	139732	139733
27927	45451	1	applied	\N	\N	\N	\N	139734	139734	139735
27927	45452	2	applied	\N	\N	\N	\N	139736	139736	139737
27930	45453	0	applied	\N	\N	\N	\N	139740	139740	139741
27930	45454	1	applied	\N	\N	\N	\N	139742	139742	139743
27930	45455	2	applied	\N	\N	\N	\N	139744	139744	139745
27933	45465	0	applied	\N	\N	\N	\N	139767	139767	139768
27933	45466	1	applied	\N	\N	\N	\N	139769	139769	139770
27933	45467	2	applied	\N	\N	\N	\N	139771	139771	139772
27936	45475	0	applied	\N	\N	\N	\N	139790	139790	139791
27936	45476	1	applied	\N	\N	\N	\N	139792	139792	139793
27936	45477	2	applied	\N	\N	\N	\N	139794	139794	139795
27936	45478	3	applied	\N	\N	\N	\N	139796	139796	139797
27936	45479	4	applied	\N	\N	\N	\N	139798	139798	139799
27936	45480	5	applied	\N	\N	\N	\N	139800	139800	139801
27938	45481	0	applied	\N	\N	\N	\N	139804	139804	139805
27938	45482	1	applied	\N	\N	\N	\N	139806	139806	139807
27938	45483	2	applied	\N	\N	\N	\N	139808	139808	139809
27942	45491	0	applied	\N	\N	\N	\N	139831	139831	139832
27942	45492	1	applied	\N	\N	\N	\N	139833	139833	139834
27942	45493	2	applied	\N	\N	\N	\N	139835	139835	139836
27942	45494	3	applied	\N	\N	\N	\N	139837	139837	139838
27942	45495	4	applied	\N	\N	\N	\N	139839	139839	139840
27942	45496	5	applied	\N	\N	\N	\N	139841	139841	139842
27945	45506	0	applied	\N	\N	\N	\N	139864	139864	139865
27945	45507	1	applied	\N	\N	\N	\N	139866	139866	139867
27945	45508	2	applied	\N	\N	\N	\N	139868	139868	139869
27948	45509	0	applied	\N	\N	\N	\N	139876	139876	139877
27948	45510	1	applied	\N	\N	\N	\N	139878	139878	139879
27948	45511	2	applied	\N	\N	\N	\N	139880	139880	139881
27948	45512	3	applied	\N	\N	\N	\N	139882	139882	139883
27871	45134	0	applied	\N	\N	\N	\N	138868	138868	138869
27871	45135	1	applied	\N	\N	\N	\N	138870	138870	138871
27871	45140	2	applied	\N	\N	\N	\N	138884	138884	138885
27871	45141	3	applied	\N	\N	\N	\N	138886	138886	138887
27871	45146	4	applied	\N	\N	\N	\N	138898	138898	138899
27871	45149	5	applied	\N	\N	\N	\N	138905	138905	138906
27871	45150	6	applied	\N	\N	\N	\N	138907	138907	138908
27871	45155	7	applied	\N	\N	\N	\N	138919	138919	138920
27871	45158	8	applied	\N	\N	\N	\N	138926	138926	138927
27871	45159	9	applied	\N	\N	\N	\N	138928	138928	138929
27871	45164	10	applied	\N	\N	\N	\N	138940	138940	138941
27871	45167	11	applied	\N	\N	\N	\N	138948	138948	138949
27871	45170	12	applied	\N	\N	\N	\N	138956	138956	138957
27871	45173	13	applied	\N	\N	\N	\N	138966	138966	138967
27871	45176	14	applied	\N	\N	\N	\N	138974	138974	138975
27871	45179	15	applied	\N	\N	\N	\N	138981	138981	138982
27871	45182	16	applied	\N	\N	\N	\N	138990	138990	138991
27871	45185	17	applied	\N	\N	\N	\N	139000	139000	139001
27871	45188	18	applied	\N	\N	\N	\N	139008	139008	139009
27871	45191	19	applied	\N	\N	\N	\N	139015	139015	139016
27871	45192	20	applied	\N	\N	\N	\N	139017	139017	139018
27871	45193	21	applied	\N	\N	\N	\N	139019	139019	139020
27871	45194	22	applied	\N	\N	\N	\N	139021	139021	139022
27871	45203	23	applied	\N	\N	\N	\N	139045	139045	139046
27871	45206	24	applied	\N	\N	\N	\N	139056	139056	139057
27871	45209	25	applied	\N	\N	\N	\N	139064	139064	139065
27871	45212	26	applied	\N	\N	\N	\N	139072	139072	139073
27871	45215	27	applied	\N	\N	\N	\N	139080	139080	139081
27871	45216	28	applied	\N	\N	\N	\N	139082	139082	139083
27871	45221	29	applied	\N	\N	\N	\N	139093	139093	139094
27871	45224	30	applied	\N	\N	\N	\N	139104	139104	139105
27871	45225	31	applied	\N	\N	\N	\N	139106	139106	139107
27871	45226	32	applied	\N	\N	\N	\N	139108	139108	139109
27871	45233	33	applied	\N	\N	\N	\N	139126	139126	139127
27871	45234	34	applied	\N	\N	\N	\N	139128	139128	139129
27871	45239	35	applied	\N	\N	\N	\N	139140	139140	139141
27871	45242	36	applied	\N	\N	\N	\N	139147	139147	139148
27871	45245	37	applied	\N	\N	\N	\N	139159	139159	139160
27871	45248	38	applied	\N	\N	\N	\N	139167	139167	139168
27871	45251	39	applied	\N	\N	\N	\N	139175	139175	139176
27871	45254	40	applied	\N	\N	\N	\N	139184	139184	139185
27871	45255	41	applied	\N	\N	\N	\N	139186	139186	139187
27871	45260	42	applied	\N	\N	\N	\N	139200	139200	139201
27871	45263	43	applied	\N	\N	\N	\N	139210	139210	139211
27871	45264	44	applied	\N	\N	\N	\N	139212	139212	139213
27871	45269	45	applied	\N	\N	\N	\N	139223	139223	139224
27871	45272	47	applied	\N	\N	\N	\N	139229	139229	139230
27871	45275	48	applied	\N	\N	\N	\N	139239	139239	139240
27871	45278	49	applied	\N	\N	\N	\N	139245	139245	139246
27871	45281	50	applied	\N	\N	\N	\N	139253	139253	139254
27871	45285	51	applied	\N	\N	\N	\N	139263	139263	139264
27871	45286	52	applied	\N	\N	\N	\N	139265	139265	139266
27871	45292	53	applied	\N	\N	\N	\N	139278	139278	139279
27871	45295	54	applied	\N	\N	\N	\N	139286	139286	139287
27871	45287	55	failed	Amount_insufficient_to_create_account	\N	\N	\N	139267	139267	\N
27871	45136	56	applied	\N	\N	\N	\N	138872	138872	138873
27871	45283	57	applied	\N	\N	1000000000	\N	139257	139257	139258
27871	45137	58	applied	\N	\N	\N	\N	138874	138874	138875
27871	45138	59	applied	\N	\N	\N	\N	138876	138876	138877
27871	45142	60	applied	\N	\N	\N	\N	138888	138888	139296
27871	45143	61	applied	\N	\N	\N	\N	138890	138890	139297
27871	45147	62	applied	\N	\N	\N	\N	138900	138900	139298
27871	45151	63	applied	\N	\N	\N	\N	138909	138909	138895
27871	45152	64	applied	\N	\N	\N	\N	138911	138911	138901
27871	45156	65	applied	\N	\N	\N	\N	138921	138921	139299
27871	45161	66	applied	\N	\N	\N	\N	138932	138932	139300
27871	45162	67	applied	\N	\N	\N	\N	138934	138934	139301
27871	45166	68	applied	\N	\N	\N	\N	138944	138944	138916
27871	45168	69	applied	\N	\N	\N	\N	138950	138950	138922
27871	45171	70	applied	\N	\N	\N	\N	138958	138958	139302
27871	45174	71	applied	\N	\N	\N	\N	138968	138968	139303
27871	45178	72	applied	\N	\N	\N	\N	138978	138978	139304
27871	45181	73	applied	\N	\N	\N	\N	138985	138985	138937
27871	45183	74	applied	\N	\N	\N	\N	138992	138992	139305
27871	45187	75	applied	\N	\N	\N	\N	139004	139004	139306
27871	45189	76	applied	\N	\N	\N	\N	139010	139010	139307
27871	45195	77	applied	\N	\N	\N	\N	139023	139023	139308
27871	45139	78	applied	\N	\N	\N	\N	138878	138878	139309
27871	45144	79	applied	\N	\N	\N	\N	138892	138892	139310
27871	45145	80	applied	\N	\N	\N	\N	138894	138894	138969
27871	45148	81	applied	\N	\N	\N	\N	138902	138902	138971
27871	45153	82	applied	\N	\N	\N	\N	138913	138913	138977
27871	45154	83	applied	\N	\N	\N	\N	138915	138915	139311
27871	45157	84	applied	\N	\N	\N	\N	138923	138923	139312
27871	45160	85	applied	\N	\N	\N	\N	138930	138930	139313
27871	45163	86	applied	\N	\N	\N	\N	138936	138936	138986
27871	45165	87	applied	\N	\N	\N	\N	138942	138942	139314
27871	45169	88	applied	\N	\N	\N	\N	138952	138952	139315
27871	45172	89	applied	\N	\N	\N	\N	138960	138960	139316
27871	45175	90	applied	\N	\N	\N	\N	138970	138970	139317
27871	45177	91	applied	\N	\N	\N	\N	138976	138976	139005
27871	45180	92	applied	\N	\N	\N	\N	138983	138983	139318
27871	45184	93	applied	\N	\N	\N	\N	138994	138994	139319
27871	45186	94	applied	\N	\N	\N	\N	139002	139002	139320
27871	45190	95	applied	\N	\N	\N	\N	139012	139012	139024
27871	45196	96	applied	\N	\N	\N	\N	139025	139025	139026
27871	45197	97	applied	\N	\N	\N	\N	139027	139027	139028
27871	45198	98	applied	\N	\N	\N	\N	139029	139029	139030
27871	45199	99	applied	\N	\N	\N	\N	139031	139031	139032
27871	45205	100	applied	\N	\N	\N	\N	139049	139049	139321
27871	45207	101	applied	\N	\N	\N	\N	139058	139058	139322
27871	45211	102	applied	\N	\N	\N	\N	139068	139068	139036
27871	45214	103	applied	\N	\N	\N	\N	139076	139076	139323
27871	45218	104	applied	\N	\N	\N	\N	139086	139086	139324
27871	45219	105	applied	\N	\N	\N	\N	139088	139088	139048
27871	45223	106	applied	\N	\N	\N	\N	139097	139097	139050
27871	45227	107	applied	\N	\N	\N	\N	139110	139110	139059
27871	45231	108	applied	\N	\N	\N	\N	139118	139118	139325
27871	45232	109	applied	\N	\N	\N	\N	139120	139120	139326
27871	45236	110	applied	\N	\N	\N	\N	139132	139132	139067
27871	45237	111	applied	\N	\N	\N	\N	139134	139134	139069
27871	45240	112	applied	\N	\N	\N	\N	139142	139142	139327
27871	45243	113	applied	\N	\N	\N	\N	139149	139149	139328
27871	45246	114	applied	\N	\N	\N	\N	139161	139161	139329
27871	45249	115	applied	\N	\N	\N	\N	139169	139169	139085
27871	45253	116	applied	\N	\N	\N	\N	139180	139180	139087
27871	45258	117	applied	\N	\N	\N	\N	139192	139192	139089
27871	45259	118	applied	\N	\N	\N	\N	139194	139194	139330
27871	45261	119	applied	\N	\N	\N	\N	139202	139202	139331
27871	45266	120	applied	\N	\N	\N	\N	139216	139216	139096
27871	45267	121	applied	\N	\N	\N	\N	139218	139218	139098
27871	45271	122	applied	\N	\N	\N	\N	139227	139227	139111
27871	45274	123	applied	\N	\N	\N	\N	139233	139233	139332
27871	45277	124	applied	\N	\N	\N	\N	139243	139243	139333
27871	45280	125	applied	\N	\N	\N	\N	139249	139249	139115
27873	45298	0	applied	\N	\N	\N	\N	139336	139336	139337
27873	45299	1	applied	\N	\N	\N	\N	139338	139338	139339
27873	45300	2	applied	\N	\N	\N	\N	139340	139340	139341
27874	45301	0	applied	\N	\N	\N	\N	139345	139345	139346
27874	45302	1	applied	\N	\N	\N	\N	139347	139347	139348
27874	45303	2	applied	\N	\N	\N	\N	139349	139349	139350
27877	45307	0	applied	\N	\N	\N	\N	139359	139359	139360
27877	45308	1	applied	\N	\N	\N	\N	139361	139361	139362
27877	45309	2	applied	\N	\N	\N	\N	139363	139363	139364
27880	45310	0	applied	\N	\N	\N	\N	139370	139370	139371
27880	45311	1	applied	\N	\N	\N	\N	139372	139372	139373
27880	45312	2	applied	\N	\N	\N	\N	139374	139374	139375
27880	45313	3	applied	\N	\N	\N	\N	139376	139376	139377
27880	45314	4	applied	\N	\N	\N	\N	139378	139378	139379
27880	45315	5	applied	\N	\N	\N	\N	139380	139380	139381
27880	45316	6	applied	\N	\N	\N	\N	139382	139382	139383
27880	45317	7	applied	\N	\N	\N	\N	139384	139384	139385
27884	45321	0	applied	\N	\N	\N	\N	139400	139400	139401
27884	45322	1	applied	\N	\N	\N	\N	139402	139402	139403
27884	45323	2	applied	\N	\N	\N	\N	139404	139404	139405
27884	45324	3	applied	\N	\N	\N	\N	139406	139406	139407
27884	45325	4	applied	\N	\N	\N	\N	139408	139408	139409
27884	45326	5	applied	\N	\N	\N	\N	139410	139410	139411
27884	45327	6	applied	\N	\N	\N	\N	139412	139412	139413
27884	45328	7	applied	\N	\N	\N	\N	139414	139414	139415
27884	45329	8	applied	\N	\N	\N	\N	139416	139416	139417
27887	45342	0	applied	\N	\N	\N	\N	139448	139448	139449
27887	45343	1	applied	\N	\N	\N	\N	139450	139450	139451
27887	45344	2	applied	\N	\N	\N	\N	139452	139452	139453
27890	45345	0	applied	\N	\N	\N	\N	139463	139463	139464
27890	45346	1	applied	\N	\N	\N	\N	139465	139465	139466
27890	45347	2	applied	\N	\N	\N	\N	139467	139467	139468
27897	45354	0	applied	\N	\N	\N	\N	139489	139489	139490
27897	45355	1	applied	\N	\N	\N	\N	139491	139491	139492
27897	45356	2	applied	\N	\N	\N	\N	139493	139493	139494
27897	45357	3	applied	\N	\N	\N	\N	139495	139495	139496
27897	45358	4	applied	\N	\N	\N	\N	139497	139497	139498
27897	45359	5	applied	\N	\N	\N	\N	139499	139499	139500
27897	45360	6	applied	\N	\N	\N	\N	139501	139501	139502
27899	45361	0	applied	\N	\N	\N	\N	139508	139508	139509
27899	45362	1	applied	\N	\N	\N	\N	139510	139510	139511
27899	45363	2	applied	\N	\N	\N	\N	139512	139512	139513
27902	45373	0	applied	\N	\N	\N	\N	139536	139536	139537
27902	45374	1	applied	\N	\N	\N	\N	139538	139538	139539
27902	45375	2	applied	\N	\N	\N	\N	139540	139540	139541
27905	45382	0	applied	\N	\N	\N	\N	139557	139557	139558
27905	45383	1	applied	\N	\N	\N	\N	139559	139559	139560
27905	45384	2	applied	\N	\N	\N	\N	139561	139561	139562
27905	45385	3	applied	\N	\N	\N	\N	139563	139563	139564
27905	45386	4	applied	\N	\N	\N	\N	139565	139565	139566
27905	45387	5	applied	\N	\N	\N	\N	139567	139567	139568
27905	45388	6	applied	\N	\N	\N	\N	139569	139569	139570
27905	45389	7	applied	\N	\N	\N	\N	139571	139571	139572
27905	45390	8	applied	\N	\N	\N	\N	139573	139573	139574
27905	45391	9	applied	\N	\N	1000000000	\N	139575	139575	139576
27905	45392	10	applied	\N	\N	1000000000	\N	139577	139577	139578
27905	45393	11	applied	\N	\N	1000000000	\N	139579	139579	139580
27905	45394	12	applied	\N	\N	\N	\N	139581	139581	139582
27905	45395	13	applied	\N	\N	\N	\N	139583	139583	139584
27905	45396	14	applied	\N	\N	\N	\N	139585	139585	139586
27905	45397	15	applied	\N	\N	\N	\N	139587	139587	139588
27905	45398	16	applied	\N	\N	\N	\N	139589	139589	139590
27905	45399	17	applied	\N	\N	\N	\N	139591	139591	139592
27905	45400	18	applied	\N	\N	\N	\N	139593	139593	139594
27908	45410	0	applied	\N	\N	\N	\N	139617	139617	139618
27908	45411	1	applied	\N	\N	\N	\N	139619	139619	139620
27908	45412	2	applied	\N	\N	\N	\N	139621	139621	139622
27911	45413	0	applied	\N	\N	\N	\N	139628	139628	139629
27911	45414	1	applied	\N	\N	\N	\N	139630	139630	139631
27911	45415	2	applied	\N	\N	\N	\N	139632	139632	139633
27911	45416	3	applied	\N	\N	\N	\N	139634	139634	139635
27911	45417	4	applied	\N	\N	\N	\N	139636	139636	139637
27911	45418	5	applied	\N	\N	\N	\N	139638	139638	139639
27914	45422	0	applied	\N	\N	\N	\N	139651	139651	139652
27914	45423	1	applied	\N	\N	\N	\N	139653	139653	139654
27914	45424	2	applied	\N	\N	\N	\N	139655	139655	139656
27923	45440	0	applied	\N	\N	\N	\N	139704	139704	139705
27923	45441	1	applied	\N	\N	\N	\N	139706	139706	139707
27926	45446	0	applied	\N	\N	\N	\N	139721	139721	139722
27926	45447	1	applied	\N	\N	\N	\N	139723	139723	139724
27926	45448	2	applied	\N	\N	\N	\N	139725	139725	139726
27926	45449	3	applied	\N	\N	\N	\N	139727	139727	139728
27929	45453	0	applied	\N	\N	\N	\N	139740	139740	139741
27929	45454	1	applied	\N	\N	\N	\N	139742	139742	139743
27929	45455	2	applied	\N	\N	\N	\N	139744	139744	139745
27932	45465	0	applied	\N	\N	\N	\N	139767	139767	139768
27932	45466	1	applied	\N	\N	\N	\N	139769	139769	139770
27932	45467	2	applied	\N	\N	\N	\N	139771	139771	139772
27935	45468	0	applied	\N	\N	\N	\N	139775	139775	139776
27935	45469	1	applied	\N	\N	\N	\N	139777	139777	139778
27935	45470	2	applied	\N	\N	\N	\N	139779	139779	139780
27935	45471	3	applied	\N	\N	\N	\N	139781	139781	139782
27935	45472	4	applied	\N	\N	\N	\N	139783	139783	139784
27935	45473	5	applied	\N	\N	\N	\N	139785	139785	139786
27935	45474	6	applied	\N	\N	\N	\N	139787	139787	139788
27939	45481	0	applied	\N	\N	\N	\N	139804	139804	139805
27939	45482	1	applied	\N	\N	\N	\N	139806	139806	139807
27939	45483	2	applied	\N	\N	\N	\N	139808	139808	139809
27941	45487	0	applied	\N	\N	\N	\N	139821	139821	139822
27941	45488	1	applied	\N	\N	\N	\N	139823	139823	139824
27941	45489	2	applied	\N	\N	\N	\N	139825	139825	139826
27941	45490	3	applied	\N	\N	1000000000	\N	139827	139827	139828
27943	45497	0	applied	\N	\N	\N	\N	139844	139844	139845
27943	45498	1	applied	\N	\N	\N	\N	139846	139846	139847
27943	45499	2	applied	\N	\N	\N	\N	139848	139848	139849
27943	45500	3	applied	\N	\N	\N	\N	139850	139850	139851
27943	45501	4	applied	\N	\N	\N	\N	139852	139852	139853
27943	45502	5	applied	\N	\N	\N	\N	139854	139854	139855
27943	45503	6	applied	\N	\N	\N	\N	139856	139856	139857
27943	45504	7	applied	\N	\N	\N	\N	139858	139858	139859
27943	45505	8	applied	\N	\N	\N	\N	139860	139860	139861
27946	45506	0	applied	\N	\N	\N	\N	139864	139864	139865
27946	45507	1	applied	\N	\N	\N	\N	139866	139866	139867
27918	45426	1	applied	\N	\N	\N	\N	139660	139660	139661
27918	45431	2	applied	\N	\N	\N	\N	139673	139673	139674
27918	45427	4	applied	\N	\N	\N	\N	139662	139662	139663
27918	45428	5	applied	\N	\N	\N	\N	139665	139665	139666
27918	45429	6	applied	\N	\N	\N	\N	139667	139667	139668
27918	45433	7	applied	\N	\N	\N	\N	139677	139677	139684
27918	45430	8	applied	\N	\N	\N	\N	139669	139669	139685
27918	45432	9	applied	\N	\N	\N	\N	139675	139675	139678
27919	45434	0	applied	\N	\N	\N	\N	139688	139688	139689
27919	45435	1	applied	\N	\N	\N	\N	139690	139690	139691
27919	45436	2	applied	\N	\N	\N	\N	139692	139692	139693
27922	45440	0	applied	\N	\N	\N	\N	139704	139704	139705
27922	45441	1	applied	\N	\N	\N	\N	139706	139706	139707
27922	45442	2	applied	\N	\N	\N	\N	139708	139708	139709
27925	45446	0	applied	\N	\N	\N	\N	139721	139721	139722
27925	45447	1	applied	\N	\N	\N	\N	139723	139723	139724
27925	45448	2	applied	\N	\N	\N	\N	139725	139725	139726
27925	45449	3	applied	\N	\N	\N	\N	139727	139727	139728
27928	45453	0	applied	\N	\N	\N	\N	139740	139740	139741
27928	45454	1	applied	\N	\N	\N	\N	139742	139742	139743
27928	45455	2	applied	\N	\N	\N	\N	139744	139744	139745
27931	45456	0	applied	\N	\N	\N	\N	139748	139748	139749
27931	45457	1	applied	\N	\N	\N	\N	139750	139750	139751
27931	45458	2	applied	\N	\N	\N	\N	139752	139752	139753
27931	45459	3	applied	\N	\N	1000000000	\N	139754	139754	139755
27931	45460	4	applied	\N	\N	\N	\N	139756	139756	139757
27931	45461	5	applied	\N	\N	\N	\N	139758	139758	139759
27931	45462	6	applied	\N	\N	\N	\N	139760	139760	139761
27931	45463	7	applied	\N	\N	\N	\N	139762	139762	139763
27931	45464	8	applied	\N	\N	\N	\N	139764	139764	139765
27934	45468	0	applied	\N	\N	\N	\N	139775	139775	139776
27934	45469	1	applied	\N	\N	\N	\N	139777	139777	139778
27934	45470	2	applied	\N	\N	\N	\N	139779	139779	139780
27934	45471	3	applied	\N	\N	\N	\N	139781	139781	139782
27934	45472	4	applied	\N	\N	\N	\N	139783	139783	139784
27934	45473	5	applied	\N	\N	\N	\N	139785	139785	139786
27934	45474	6	applied	\N	\N	\N	\N	139787	139787	139788
27937	45481	0	applied	\N	\N	\N	\N	139804	139804	139805
27937	45482	1	applied	\N	\N	\N	\N	139806	139806	139807
27937	45483	2	applied	\N	\N	\N	\N	139808	139808	139809
27940	45484	0	applied	\N	\N	\N	\N	139813	139813	139814
27940	45485	1	applied	\N	\N	\N	\N	139815	139815	139816
27940	45486	2	applied	\N	\N	\N	\N	139817	139817	139818
27944	45506	0	applied	\N	\N	\N	\N	139864	139864	139865
27944	45507	1	applied	\N	\N	\N	\N	139866	139866	139867
27944	45508	2	applied	\N	\N	\N	\N	139868	139868	139869
27947	45509	0	applied	\N	\N	\N	\N	139876	139876	139877
27947	45510	1	applied	\N	\N	\N	\N	139878	139878	139879
27947	45511	2	applied	\N	\N	\N	\N	139880	139880	139881
27947	45512	3	applied	\N	\N	\N	\N	139882	139882	139883
27947	45513	4	applied	\N	\N	\N	\N	139884	139884	139885
27947	45514	5	applied	\N	\N	\N	\N	139886	139886	139887
27953	45521	0	applied	\N	\N	\N	\N	139906	139906	139907
27953	45522	1	applied	\N	\N	\N	\N	139908	139908	139909
27953	45523	2	applied	\N	\N	\N	\N	139910	139910	139911
27953	45524	3	applied	\N	\N	\N	\N	139912	139912	139913
27953	45525	4	applied	\N	\N	\N	\N	139914	139914	139915
27953	45526	5	applied	\N	\N	\N	\N	139916	139916	139917
27956	45527	0	applied	\N	\N	\N	\N	139921	139921	139922
27956	45528	1	applied	\N	\N	\N	\N	139923	139923	139924
27956	45529	2	applied	\N	\N	\N	\N	139925	139925	139926
27956	45530	3	applied	\N	\N	\N	\N	139927	139927	139928
27956	45531	4	applied	\N	\N	\N	\N	139929	139929	139930
27956	45532	5	applied	\N	\N	\N	\N	139931	139931	139932
27959	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27959	45536	1	applied	\N	\N	\N	\N	139942	139942	139943
27959	45537	2	applied	\N	\N	\N	\N	139944	139944	139945
27959	45538	3	applied	\N	\N	\N	\N	139946	139946	139947
27959	45539	4	applied	\N	\N	\N	\N	139948	139948	139949
27962	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27962	45536	1	applied	\N	\N	\N	\N	139942	139942	139943
27962	45537	2	applied	\N	\N	\N	\N	139944	139944	139945
27962	45540	3	applied	\N	\N	\N	\N	139952	139952	139953
27962	45538	4	applied	\N	\N	\N	\N	139946	139946	139954
27962	45539	5	applied	\N	\N	\N	\N	139948	139948	139955
27962	45541	6	applied	\N	\N	\N	\N	139956	139956	139957
27965	45542	0	applied	\N	\N	\N	\N	139963	139963	139964
27965	45543	1	applied	\N	\N	\N	\N	139965	139965	139966
27965	45544	2	applied	\N	\N	\N	\N	139967	139967	139968
27965	45545	3	applied	\N	\N	\N	\N	139969	139969	139970
27965	45540	4	applied	\N	\N	\N	\N	139952	139952	139971
27965	45541	5	applied	\N	\N	\N	\N	139956	139956	139972
27965	45546	6	applied	\N	\N	\N	\N	139973	139973	139974
27965	45547	7	applied	\N	\N	\N	\N	139975	139975	139976
27965	45548	8	applied	\N	\N	\N	\N	139977	139977	139978
27965	45549	9	applied	\N	\N	\N	\N	139979	139979	139980
27965	45550	10	applied	\N	\N	\N	\N	139981	139981	139982
27968	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27968	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27968	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27968	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27968	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27968	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27968	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27968	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27968	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27968	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27968	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27971	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27971	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27971	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27971	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27971	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27971	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27971	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27971	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27971	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27971	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27971	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27974	45566	0	applied	\N	\N	\N	\N	140029	140029	140030
27974	45567	1	applied	\N	\N	\N	\N	140031	140031	140032
27974	45568	2	applied	\N	\N	\N	\N	140033	140033	140034
27977	45298	0	applied	\N	\N	\N	\N	139336	139336	139337
27977	45301	1	applied	\N	\N	\N	\N	139345	139345	139346
27977	45304	2	applied	\N	\N	\N	\N	139352	139352	139353
27977	45307	3	applied	\N	\N	\N	\N	139359	139359	139360
27977	45423	4	applied	\N	\N	\N	\N	139653	139653	139654
27977	45447	5	applied	\N	\N	\N	\N	139723	139723	139724
27977	45310	6	applied	\N	\N	\N	\N	139370	139370	139371
27977	45311	7	applied	\N	\N	\N	\N	139372	139372	139373
27946	45508	2	applied	\N	\N	\N	\N	139868	139868	139869
27949	45509	0	applied	\N	\N	\N	\N	139876	139876	139877
27949	45510	1	applied	\N	\N	\N	\N	139878	139878	139879
27949	45511	2	applied	\N	\N	\N	\N	139880	139880	139881
27949	45512	3	applied	\N	\N	\N	\N	139882	139882	139883
27949	45513	4	applied	\N	\N	\N	\N	139884	139884	139885
27949	45514	5	applied	\N	\N	\N	\N	139886	139886	139887
27952	45515	0	applied	\N	\N	\N	\N	139894	139894	139895
27952	45516	1	applied	\N	\N	\N	\N	139896	139896	139897
27952	45517	2	applied	\N	\N	\N	\N	139898	139898	139899
27952	45518	3	applied	\N	\N	\N	\N	139900	139900	139901
27952	45519	4	applied	\N	\N	\N	\N	139902	139902	139903
27952	45520	5	applied	\N	\N	\N	\N	139904	139904	139905
27955	45527	0	applied	\N	\N	\N	\N	139921	139921	139922
27955	45528	1	applied	\N	\N	\N	\N	139923	139923	139924
27955	45529	2	applied	\N	\N	\N	\N	139925	139925	139926
27955	45530	3	applied	\N	\N	\N	\N	139927	139927	139928
27955	45531	4	applied	\N	\N	\N	\N	139929	139929	139930
27955	45532	5	applied	\N	\N	\N	\N	139931	139931	139932
27958	45534	0	applied	\N	\N	\N	\N	139935	139935	139936
27958	45535	1	applied	\N	\N	\N	\N	139937	139937	139938
27961	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27961	45536	1	applied	\N	\N	\N	\N	139942	139942	139943
27961	45537	2	applied	\N	\N	\N	\N	139944	139944	139945
27961	45540	3	applied	\N	\N	\N	\N	139952	139952	139953
27961	45538	4	applied	\N	\N	\N	\N	139946	139946	139954
27961	45539	5	applied	\N	\N	\N	\N	139948	139948	139955
27961	45541	6	applied	\N	\N	\N	\N	139956	139956	139957
27967	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27967	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27967	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27967	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27967	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27967	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27967	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27967	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27967	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27967	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27967	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27970	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27970	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27970	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27970	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27970	45561	4	applied	\N	\N	\N	\N	140006	140006	140022
27970	45562	5	applied	\N	\N	\N	\N	140008	140008	140023
27973	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27973	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27973	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27973	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27973	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27973	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27973	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27973	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27973	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27973	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27973	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27976	45569	0	applied	\N	\N	\N	\N	140036	140036	140037
27976	45570	1	applied	\N	\N	\N	\N	140038	140038	140039
27976	45571	2	applied	\N	\N	\N	\N	140040	140040	140041
27979	45580	0	applied	\N	\N	\N	\N	140080	140080	140081
27979	45581	1	applied	\N	\N	\N	\N	140082	140082	140083
27979	45582	2	applied	\N	\N	\N	\N	140084	140084	140085
27982	45583	0	applied	\N	\N	\N	\N	140088	140088	140089
27982	45584	1	applied	\N	\N	\N	\N	140090	140090	140091
27982	45585	2	applied	\N	\N	\N	\N	140092	140092	140093
27985	45592	0	applied	\N	\N	\N	\N	140113	140113	140114
27985	45593	1	applied	\N	\N	\N	\N	140115	140115	140116
27985	45594	2	applied	\N	\N	\N	\N	140117	140117	140118
27988	45601	0	applied	\N	\N	\N	\N	140134	140134	140135
27988	45602	1	applied	\N	\N	\N	\N	140136	140136	140137
27988	45603	2	applied	\N	\N	\N	\N	140138	140138	140139
27988	45604	3	applied	\N	\N	\N	\N	140140	140140	140141
27988	45605	4	applied	\N	\N	\N	\N	140142	140142	140143
27988	45606	5	applied	\N	\N	\N	\N	140144	140144	140145
27988	45607	6	applied	\N	\N	\N	\N	140146	140146	140147
27988	45608	7	applied	\N	\N	\N	\N	140148	140148	140149
27988	45609	8	applied	\N	\N	\N	\N	140150	140150	140151
27991	45610	0	applied	\N	\N	\N	\N	140158	140158	140159
27991	45611	1	applied	\N	\N	\N	\N	140160	140160	140161
27991	45612	2	applied	\N	\N	\N	\N	140162	140162	140163
27994	45610	0	applied	\N	\N	\N	\N	140158	140158	140159
27994	45611	1	applied	\N	\N	\N	\N	140160	140160	140161
27994	45612	2	applied	\N	\N	\N	\N	140162	140162	140163
27997	45613	0	applied	\N	\N	\N	\N	140173	140173	140174
27997	45614	1	applied	\N	\N	\N	\N	140175	140175	140176
27997	45615	2	applied	\N	\N	\N	\N	140177	140177	140178
28000	45616	0	applied	\N	\N	\N	\N	140181	140181	140182
28000	45617	1	applied	\N	\N	\N	\N	140183	140183	140184
28000	45618	2	applied	\N	\N	\N	\N	140185	140185	140186
28003	45622	0	applied	\N	\N	\N	\N	140194	140194	140195
28006	45622	0	applied	\N	\N	\N	\N	140194	140194	140195
28006	45623	1	applied	\N	\N	\N	\N	140198	140198	140199
28006	45624	2	applied	\N	\N	\N	\N	140200	140200	140201
28006	45625	3	applied	\N	\N	\N	\N	140202	140202	140203
28006	45626	4	applied	\N	\N	\N	\N	140204	140204	140205
28006	45627	5	applied	\N	\N	\N	\N	140206	140206	140207
28009	45566	0	applied	\N	\N	\N	\N	140029	140029	140030
28009	45569	1	applied	\N	\N	\N	\N	140036	140036	140037
28009	45572	2	applied	\N	\N	\N	\N	140062	140062	140063
28009	45573	3	applied	\N	\N	\N	\N	140064	140064	140065
28009	45580	4	applied	\N	\N	\N	\N	140080	140080	140081
28009	45583	5	applied	\N	\N	\N	\N	140088	140088	140089
28009	45586	6	applied	\N	\N	\N	\N	140098	140098	140099
28009	45587	7	applied	\N	\N	\N	\N	140100	140100	140101
28009	45592	8	applied	\N	\N	\N	\N	140113	140113	140114
28009	45595	9	applied	\N	\N	\N	\N	140121	140121	140122
28009	45596	10	applied	\N	\N	\N	\N	140123	140123	140124
28009	45601	11	applied	\N	\N	\N	\N	140134	140134	140135
28009	45602	12	applied	\N	\N	\N	\N	140136	140136	140137
28009	45603	13	applied	\N	\N	\N	\N	140138	140138	140139
28009	45610	14	applied	\N	\N	\N	\N	140158	140158	140159
28009	45613	15	applied	\N	\N	\N	\N	140173	140173	140223
28009	45616	16	applied	\N	\N	\N	\N	140181	140181	140224
28009	45619	17	applied	\N	\N	\N	\N	140187	140187	140225
28009	45622	18	applied	\N	\N	\N	\N	140194	140194	140226
28009	45623	19	applied	\N	\N	\N	\N	140198	140198	140227
28009	45628	20	applied	\N	\N	\N	\N	140213	140213	140228
28009	45377	21	applied	\N	\N	\N	\N	139544	139544	139219
28009	45381	22	applied	\N	\N	\N	\N	139554	139554	140229
28009	45387	23	applied	\N	\N	\N	\N	139567	139567	140230
27948	45513	4	applied	\N	\N	\N	\N	139884	139884	139885
27948	45514	5	applied	\N	\N	\N	\N	139886	139886	139887
27951	45515	0	applied	\N	\N	\N	\N	139894	139894	139895
27951	45516	1	applied	\N	\N	\N	\N	139896	139896	139897
27951	45517	2	applied	\N	\N	\N	\N	139898	139898	139899
27951	45518	3	applied	\N	\N	\N	\N	139900	139900	139901
27951	45519	4	applied	\N	\N	\N	\N	139902	139902	139903
27951	45520	5	applied	\N	\N	\N	\N	139904	139904	139905
27954	45521	0	applied	\N	\N	\N	\N	139906	139906	139907
27954	45522	1	applied	\N	\N	\N	\N	139908	139908	139909
27954	45523	2	applied	\N	\N	\N	\N	139910	139910	139911
27954	45524	3	applied	\N	\N	\N	\N	139912	139912	139913
27954	45525	4	applied	\N	\N	\N	\N	139914	139914	139915
27954	45526	5	applied	\N	\N	\N	\N	139916	139916	139917
27957	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27957	45534	1	applied	\N	\N	\N	\N	139935	139935	139936
27957	45535	2	applied	\N	\N	\N	\N	139937	139937	139938
27960	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27960	45536	1	applied	\N	\N	\N	\N	139942	139942	139943
27960	45537	2	applied	\N	\N	\N	\N	139944	139944	139945
27960	45538	3	applied	\N	\N	\N	\N	139946	139946	139947
27960	45539	4	applied	\N	\N	\N	\N	139948	139948	139949
27963	45533	0	applied	\N	\N	\N	\N	139933	139933	139934
27963	45536	1	applied	\N	\N	\N	\N	139942	139942	139943
27963	45537	2	applied	\N	\N	\N	\N	139944	139944	139945
27963	45540	3	applied	\N	\N	\N	\N	139952	139952	139953
27963	45538	4	applied	\N	\N	\N	\N	139946	139946	139954
27963	45539	5	applied	\N	\N	\N	\N	139948	139948	139955
27963	45541	6	applied	\N	\N	\N	\N	139956	139956	139957
27966	45551	0	applied	\N	\N	\N	\N	139984	139984	139985
27966	45552	1	applied	\N	\N	\N	\N	139986	139986	139987
27966	45553	2	applied	\N	\N	\N	\N	139988	139988	139989
27966	45554	3	applied	\N	\N	\N	\N	139990	139990	139991
27969	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27969	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27969	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27969	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27969	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27969	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27969	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27969	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27969	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27969	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27969	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27972	45555	0	applied	\N	\N	\N	\N	139994	139994	139995
27972	45556	1	applied	\N	\N	\N	\N	139996	139996	139997
27972	45557	2	applied	\N	\N	\N	\N	139998	139998	139999
27972	45558	3	applied	\N	\N	\N	\N	140000	140000	140001
27972	45559	4	applied	\N	\N	\N	\N	140002	140002	140003
27972	45560	5	applied	\N	\N	\N	\N	140004	140004	140005
27972	45561	6	applied	\N	\N	\N	\N	140006	140006	140007
27972	45562	7	applied	\N	\N	\N	\N	140008	140008	140009
27972	45563	8	applied	\N	\N	\N	\N	140010	140010	140011
27972	45564	9	applied	\N	\N	\N	\N	140012	140012	140013
27972	45565	10	applied	\N	\N	\N	\N	140014	140014	140015
27975	45569	0	applied	\N	\N	\N	\N	140036	140036	140037
27975	45570	1	applied	\N	\N	\N	\N	140038	140038	140039
27975	45571	2	applied	\N	\N	\N	\N	140040	140040	140041
27978	45572	0	applied	\N	\N	\N	\N	140062	140062	140063
27978	45573	1	applied	\N	\N	\N	\N	140064	140064	140065
27978	45574	2	applied	\N	\N	\N	\N	140066	140066	140067
27978	45575	3	applied	\N	\N	\N	\N	140068	140068	140069
27978	45576	4	applied	\N	\N	\N	\N	140070	140070	140071
27978	45577	5	applied	\N	\N	\N	\N	140072	140072	140073
27978	45578	6	applied	\N	\N	\N	\N	140074	140074	140075
27978	45579	7	applied	\N	\N	\N	\N	140076	140076	140077
27981	45583	0	applied	\N	\N	\N	\N	140088	140088	140089
27981	45584	1	applied	\N	\N	\N	\N	140090	140090	140091
27981	45585	2	applied	\N	\N	\N	\N	140092	140092	140093
27984	45586	0	applied	\N	\N	\N	\N	140098	140098	140099
27984	45587	1	applied	\N	\N	\N	\N	140100	140100	140101
27984	45588	2	applied	\N	\N	\N	\N	140102	140102	140103
27984	45589	3	applied	\N	\N	\N	\N	140104	140104	140105
27984	45590	4	applied	\N	\N	\N	\N	140106	140106	140107
27984	45591	5	applied	\N	\N	\N	\N	140108	140108	140109
27987	45601	0	applied	\N	\N	\N	\N	140134	140134	140135
27987	45602	1	applied	\N	\N	\N	\N	140136	140136	140137
27987	45603	2	applied	\N	\N	\N	\N	140138	140138	140139
27987	45604	3	applied	\N	\N	\N	\N	140140	140140	140141
27987	45605	4	applied	\N	\N	\N	\N	140142	140142	140143
27987	45606	5	applied	\N	\N	\N	\N	140144	140144	140145
27987	45607	6	applied	\N	\N	\N	\N	140146	140146	140147
27987	45608	7	applied	\N	\N	\N	\N	140148	140148	140149
27987	45609	8	applied	\N	\N	\N	\N	140150	140150	140151
27990	45601	0	applied	\N	\N	\N	\N	140134	140134	140135
27990	45602	1	applied	\N	\N	\N	\N	140136	140136	140137
27990	45603	2	applied	\N	\N	\N	\N	140138	140138	140139
27990	45604	3	applied	\N	\N	\N	\N	140140	140140	140141
27990	45605	4	applied	\N	\N	\N	\N	140142	140142	140143
27990	45606	5	applied	\N	\N	\N	\N	140144	140144	140145
27990	45607	6	applied	\N	\N	\N	\N	140146	140146	140147
27990	45608	7	applied	\N	\N	\N	\N	140148	140148	140149
27990	45609	8	applied	\N	\N	\N	\N	140150	140150	140151
27993	45610	0	applied	\N	\N	\N	\N	140158	140158	140159
27993	45611	1	applied	\N	\N	\N	\N	140160	140160	140161
27993	45612	2	applied	\N	\N	\N	\N	140162	140162	140163
27996	45613	0	applied	\N	\N	\N	\N	140173	140173	140174
27996	45614	1	applied	\N	\N	\N	\N	140175	140175	140176
27996	45615	2	applied	\N	\N	\N	\N	140177	140177	140178
28002	45619	0	applied	\N	\N	\N	\N	140187	140187	140188
28002	45620	1	applied	\N	\N	\N	\N	140189	140189	140190
28002	45621	2	applied	\N	\N	\N	\N	140191	140191	140192
28005	45622	0	applied	\N	\N	\N	\N	140194	140194	140195
28005	45623	1	applied	\N	\N	\N	\N	140198	140198	140199
28005	45624	2	applied	\N	\N	\N	\N	140200	140200	140201
28005	45625	3	applied	\N	\N	\N	\N	140202	140202	140203
28005	45626	4	applied	\N	\N	\N	\N	140204	140204	140205
28005	45627	5	applied	\N	\N	\N	\N	140206	140206	140207
28008	45628	0	applied	\N	\N	\N	\N	140213	140213	140214
28008	45629	1	applied	\N	\N	\N	\N	140215	140215	140216
28008	45630	2	applied	\N	\N	\N	\N	140217	140217	140218
28011	45631	0	applied	\N	\N	\N	\N	140273	140273	140274
28011	45632	1	applied	\N	\N	\N	\N	140275	140275	140276
28014	45642	0	applied	\N	\N	\N	\N	140299	140299	140300
28014	45643	1	applied	\N	\N	\N	\N	140301	140301	140302
28014	45644	2	applied	\N	\N	\N	\N	140303	140303	140304
28017	45648	0	applied	\N	\N	\N	\N	140313	140313	140314
28017	45649	1	applied	\N	\N	\N	\N	140315	140315	140316
28017	45650	2	applied	\N	\N	\N	\N	140317	140317	140318
28020	45660	0	applied	\N	\N	\N	\N	140339	140339	140340
27977	45318	8	applied	\N	\N	\N	\N	139393	139393	139394
27977	45321	9	applied	\N	\N	\N	\N	139400	139400	139401
27977	45322	10	applied	\N	\N	\N	\N	139402	139402	139403
27977	45323	11	applied	\N	\N	\N	\N	139404	139404	139405
27977	45330	12	applied	\N	\N	\N	\N	139419	139419	139420
27977	45333	13	applied	\N	\N	\N	\N	139427	139427	139428
27977	45334	14	applied	\N	\N	\N	\N	139429	139429	139430
27977	45335	15	applied	\N	\N	\N	\N	139431	139431	139432
27977	45342	16	applied	\N	\N	\N	\N	139448	139448	139449
27977	45345	17	applied	\N	\N	\N	\N	139463	139463	139464
27977	45348	18	applied	\N	\N	\N	\N	139471	139471	139472
27977	45351	19	applied	\N	\N	\N	\N	139479	139479	139480
27977	45354	20	applied	\N	\N	\N	\N	139489	139489	139490
27977	45355	21	applied	\N	\N	\N	\N	139491	139491	139492
27977	45361	22	applied	\N	\N	\N	\N	139508	139508	139509
27977	45364	23	applied	\N	\N	\N	\N	139515	139515	139516
27977	45367	24	applied	\N	\N	\N	\N	139523	139523	139524
27977	45368	25	applied	\N	\N	\N	\N	139525	139525	139526
27977	45373	26	applied	\N	\N	\N	\N	139536	139536	139537
27977	45376	27	applied	\N	\N	\N	\N	139542	139542	139543
27977	45379	28	applied	\N	\N	\N	\N	139550	139550	139551
27977	45382	29	applied	\N	\N	\N	\N	139557	139557	139558
27977	45383	30	applied	\N	\N	\N	\N	139559	139559	139560
27977	45384	31	applied	\N	\N	\N	\N	139561	139561	139562
27977	45385	32	applied	\N	\N	\N	\N	139563	139563	139564
27977	45386	33	applied	\N	\N	\N	\N	139565	139565	139566
27977	45401	34	applied	\N	\N	\N	\N	139596	139596	139597
27977	45404	35	applied	\N	\N	\N	\N	139604	139604	139605
27977	45405	36	applied	\N	\N	\N	\N	139606	139606	139607
27977	45410	37	applied	\N	\N	\N	\N	139617	139617	139618
27977	45413	38	applied	\N	\N	\N	\N	139628	139628	139629
27977	45414	39	applied	\N	\N	\N	\N	139630	139630	139631
27977	45419	40	applied	\N	\N	\N	\N	139643	139643	139644
27977	45422	41	applied	\N	\N	\N	\N	139651	139651	139652
27977	45425	42	applied	\N	\N	\N	\N	139658	139658	139659
27977	45426	43	applied	\N	\N	\N	\N	139660	139660	139661
27977	45431	44	applied	\N	\N	\N	\N	139673	139673	139674
27977	45434	45	applied	\N	\N	\N	\N	139688	139688	139689
27977	45437	47	applied	\N	\N	\N	\N	139696	139696	139697
27977	45440	48	applied	\N	\N	\N	\N	139704	139704	139705
27977	45443	49	applied	\N	\N	\N	\N	139713	139713	139714
27977	45446	50	applied	\N	\N	\N	\N	139721	139721	139722
27977	45450	51	applied	\N	\N	\N	\N	139732	139732	139733
27977	45453	52	applied	\N	\N	\N	\N	139740	139740	139741
27977	45456	53	applied	\N	\N	\N	\N	139748	139748	139749
27977	45457	54	applied	\N	\N	\N	\N	139750	139750	139751
27977	45458	55	applied	\N	\N	\N	\N	139752	139752	139753
27977	45465	56	applied	\N	\N	\N	\N	139767	139767	139768
27977	45468	57	applied	\N	\N	\N	\N	139775	139775	139776
27977	45469	58	applied	\N	\N	\N	\N	139777	139777	139778
27977	45475	59	applied	\N	\N	\N	\N	139790	139790	139791
27977	45476	60	applied	\N	\N	\N	\N	139792	139792	139793
27977	45481	61	applied	\N	\N	\N	\N	139804	139804	139805
27977	45484	62	applied	\N	\N	\N	\N	139813	139813	139814
27977	45487	63	applied	\N	\N	\N	\N	139821	139821	139822
27977	45491	64	applied	\N	\N	\N	\N	139831	139831	139832
27977	45492	65	applied	\N	\N	\N	\N	139833	139833	139834
27977	45497	66	applied	\N	\N	\N	\N	139844	139844	139845
27977	45498	67	applied	\N	\N	\N	\N	139846	139846	139847
27977	45499	68	applied	\N	\N	\N	\N	139848	139848	139849
27977	45506	69	applied	\N	\N	\N	\N	139864	139864	139865
27977	45509	70	applied	\N	\N	\N	\N	139876	139876	139877
27977	45510	71	applied	\N	\N	\N	\N	139878	139878	139879
27977	45515	72	applied	\N	\N	\N	\N	139894	139894	139895
27977	45516	73	applied	\N	\N	\N	\N	139896	139896	139897
27977	45521	74	applied	\N	\N	\N	\N	139906	139906	139907
27977	45522	75	applied	\N	\N	\N	\N	139908	139908	139909
27977	45527	76	applied	\N	\N	\N	\N	139921	139921	139922
27977	45528	77	applied	\N	\N	\N	\N	139923	139923	139924
27977	45533	78	applied	\N	\N	\N	\N	139933	139933	139934
27977	45536	79	applied	\N	\N	\N	\N	139942	139942	139943
27977	45537	80	applied	\N	\N	\N	\N	139944	139944	139945
27977	45542	81	applied	\N	\N	\N	\N	139963	139963	139964
27977	45543	82	applied	\N	\N	\N	\N	139965	139965	139966
27977	45544	83	applied	\N	\N	\N	\N	139967	139967	139968
27977	45551	84	applied	\N	\N	\N	\N	139984	139984	139985
27977	45552	85	applied	\N	\N	\N	\N	139986	139986	139987
27977	45555	86	applied	\N	\N	\N	\N	139994	139994	139995
27977	45556	87	applied	\N	\N	\N	\N	139996	139996	139997
27977	45557	88	applied	\N	\N	\N	\N	139998	139998	139999
27977	45388	89	applied	\N	\N	\N	\N	139569	139569	139570
27977	45391	90	applied	\N	\N	1000000000	\N	139575	139575	139576
27977	45472	91	applied	\N	\N	\N	\N	139783	139783	139784
27977	45392	92	applied	\N	\N	1000000000	\N	139577	139577	139578
27977	45393	93	applied	\N	\N	1000000000	\N	139579	139579	139580
27977	45284	94	applied	\N	\N	\N	\N	139259	139259	140044
27977	45288	95	applied	\N	\N	\N	\N	139268	139268	140045
27977	45289	96	applied	\N	\N	\N	\N	139270	139270	140046
27977	45490	97	applied	\N	\N	1000000000	\N	139827	139827	139828
27977	45294	98	applied	\N	\N	\N	\N	139282	139282	140047
27977	45297	99	applied	\N	\N	\N	\N	139290	139290	139131
27977	45299	100	applied	\N	\N	\N	\N	139338	139338	139133
27977	45302	101	applied	\N	\N	\N	\N	139347	139347	139135
27977	45306	102	applied	\N	\N	\N	\N	139356	139356	140048
27977	45309	103	applied	\N	\N	\N	\N	139363	139363	140049
27977	45312	104	applied	\N	\N	\N	\N	139374	139374	140050
27977	45316	105	applied	\N	\N	\N	\N	139382	139382	139145
27977	45317	106	applied	\N	\N	\N	\N	139384	139384	139150
27977	45320	107	applied	\N	\N	\N	\N	139397	139397	140051
27977	45325	108	applied	\N	\N	\N	\N	139408	139408	140052
27977	45326	109	applied	\N	\N	\N	\N	139410	139410	140053
27977	45327	110	applied	\N	\N	\N	\N	139412	139412	139164
27977	45332	111	applied	\N	\N	\N	\N	139423	139423	139170
27977	45339	112	applied	\N	\N	\N	\N	139440	139440	140054
27977	45340	113	applied	\N	\N	\N	\N	139442	139442	140055
27977	45341	114	applied	\N	\N	\N	\N	139444	139444	139179
27977	45344	115	applied	\N	\N	\N	\N	139452	139452	139181
27977	45346	116	applied	\N	\N	\N	\N	139465	139465	140056
27977	45349	117	applied	\N	\N	\N	\N	139473	139473	140057
27977	45353	118	applied	\N	\N	\N	\N	139483	139483	139191
27977	45357	119	applied	\N	\N	\N	\N	139495	139495	139193
27977	45358	120	applied	\N	\N	\N	\N	139497	139497	139195
27977	45362	121	applied	\N	\N	\N	\N	139510	139510	139203
27977	45366	122	applied	\N	\N	\N	\N	139519	139519	140058
27977	45371	123	applied	\N	\N	\N	\N	139531	139531	140059
27977	45372	124	applied	\N	\N	\N	\N	139533	139533	139215
27977	45374	125	applied	\N	\N	\N	\N	139538	139538	139217
27980	45583	0	applied	\N	\N	\N	\N	140088	140088	140089
27980	45584	1	applied	\N	\N	\N	\N	140090	140090	140091
27980	45585	2	applied	\N	\N	\N	\N	140092	140092	140093
27983	45586	0	applied	\N	\N	\N	\N	140098	140098	140099
27983	45587	1	applied	\N	\N	\N	\N	140100	140100	140101
27983	45588	2	applied	\N	\N	\N	\N	140102	140102	140103
27983	45589	3	applied	\N	\N	\N	\N	140104	140104	140105
27983	45590	4	applied	\N	\N	\N	\N	140106	140106	140107
27983	45591	5	applied	\N	\N	\N	\N	140108	140108	140109
27986	45595	0	applied	\N	\N	\N	\N	140121	140121	140122
27986	45596	1	applied	\N	\N	\N	\N	140123	140123	140124
27986	45597	2	applied	\N	\N	\N	\N	140125	140125	140126
27986	45598	3	applied	\N	\N	\N	\N	140127	140127	140128
27986	45599	4	applied	\N	\N	\N	\N	140129	140129	140130
27986	45600	5	applied	\N	\N	\N	\N	140131	140131	140132
27989	45601	0	applied	\N	\N	\N	\N	140134	140134	140135
27989	45602	1	applied	\N	\N	\N	\N	140136	140136	140137
27989	45603	2	applied	\N	\N	\N	\N	140138	140138	140139
27989	45604	3	applied	\N	\N	\N	\N	140140	140140	140141
27989	45605	4	applied	\N	\N	\N	\N	140142	140142	140143
27989	45606	5	applied	\N	\N	\N	\N	140144	140144	140145
27989	45607	6	applied	\N	\N	\N	\N	140146	140146	140147
27989	45608	7	applied	\N	\N	\N	\N	140148	140148	140149
27989	45609	8	applied	\N	\N	\N	\N	140150	140150	140151
27992	45610	0	applied	\N	\N	\N	\N	140158	140158	140159
27992	45611	1	applied	\N	\N	\N	\N	140160	140160	140161
27992	45612	2	applied	\N	\N	\N	\N	140162	140162	140163
27995	45613	0	applied	\N	\N	\N	\N	140173	140173	140174
27995	45614	1	applied	\N	\N	\N	\N	140175	140175	140176
27995	45615	2	applied	\N	\N	\N	\N	140177	140177	140178
27998	45616	0	applied	\N	\N	\N	\N	140181	140181	140182
27998	45617	1	applied	\N	\N	\N	\N	140183	140183	140184
27998	45618	2	applied	\N	\N	\N	\N	140185	140185	140186
28004	45623	0	applied	\N	\N	\N	\N	140198	140198	140199
28004	45624	1	applied	\N	\N	\N	\N	140200	140200	140201
28004	45625	2	applied	\N	\N	\N	\N	140202	140202	140203
28004	45626	3	applied	\N	\N	\N	\N	140204	140204	140205
28004	45627	4	applied	\N	\N	\N	\N	140206	140206	140207
28007	45628	0	applied	\N	\N	\N	\N	140213	140213	140214
28007	45629	1	applied	\N	\N	\N	\N	140215	140215	140216
28007	45630	2	applied	\N	\N	\N	\N	140217	140217	140218
28010	45628	0	applied	\N	\N	\N	\N	140213	140213	140214
28010	45629	1	applied	\N	\N	\N	\N	140215	140215	140216
28010	45630	2	applied	\N	\N	\N	\N	140217	140217	140218
28013	45636	0	applied	\N	\N	\N	\N	140286	140286	140287
28013	45637	1	applied	\N	\N	\N	\N	140288	140288	140289
28013	45638	2	applied	\N	\N	\N	\N	140290	140290	140291
28013	45639	3	applied	\N	\N	\N	\N	140292	140292	140293
28013	45640	4	applied	\N	\N	\N	\N	140294	140294	140295
28013	45641	5	applied	\N	\N	\N	\N	140296	140296	140297
28016	45645	0	applied	\N	\N	\N	\N	140306	140306	140307
28016	45646	1	applied	\N	\N	\N	\N	140308	140308	140309
28016	45647	2	applied	\N	\N	\N	\N	140310	140310	140311
28019	45660	0	applied	\N	\N	\N	\N	140339	140339	140340
28022	45662	0	applied	\N	\N	\N	\N	140347	140347	140348
28022	45663	1	applied	\N	\N	\N	\N	140349	140349	140350
28022	45664	2	applied	\N	\N	\N	\N	140351	140351	140352
28025	45665	0	applied	\N	\N	\N	\N	140357	140357	140358
28025	45666	1	applied	\N	\N	\N	\N	140359	140359	140360
28025	45667	2	applied	\N	\N	\N	\N	140361	140361	140362
28025	45668	3	applied	\N	\N	\N	\N	140363	140363	140364
28025	45669	4	applied	\N	\N	\N	\N	140365	140365	140366
28025	45670	5	applied	\N	\N	\N	\N	140367	140367	140368
28028	45671	0	applied	\N	\N	\N	\N	140371	140371	140372
28028	45672	1	applied	\N	\N	\N	\N	140373	140373	140374
28028	45673	2	applied	\N	\N	\N	\N	140375	140375	140376
28034	45678	0	applied	\N	\N	\N	\N	140390	140390	140391
28034	45679	1	applied	\N	\N	\N	\N	140392	140392	140393
28034	45680	2	applied	\N	\N	\N	\N	140394	140394	140395
28034	45681	3	applied	\N	\N	\N	\N	140396	140396	140397
28034	45682	4	applied	\N	\N	\N	\N	140398	140398	140399
28034	45683	5	applied	\N	\N	\N	\N	140400	140400	140401
28034	45684	6	applied	\N	\N	\N	\N	140402	140402	140403
28034	45685	7	applied	\N	\N	\N	\N	140404	140404	140405
28034	45686	8	applied	\N	\N	\N	\N	140406	140406	140407
28034	45687	9	applied	\N	\N	\N	\N	140408	140408	140409
28034	45688	10	applied	\N	\N	\N	\N	140410	140410	140411
28034	45689	11	applied	\N	\N	\N	\N	140412	140412	140413
28034	45690	12	applied	\N	\N	\N	\N	140414	140414	140415
28034	45691	13	applied	\N	\N	\N	\N	140416	140416	140417
28034	45692	14	applied	\N	\N	\N	\N	140418	140418	140419
28037	45696	0	applied	\N	\N	\N	\N	140433	140433	140434
28037	45697	1	applied	\N	\N	\N	\N	140435	140435	140436
28037	45698	2	applied	\N	\N	\N	\N	140437	140437	140438
28040	45699	0	applied	\N	\N	\N	\N	140441	140441	140442
28040	45700	1	applied	\N	\N	\N	\N	140443	140443	140444
28040	45701	2	applied	\N	\N	\N	\N	140447	140447	140448
28043	45705	0	applied	\N	\N	\N	\N	140458	140458	140459
28043	45706	1	applied	\N	\N	\N	\N	140460	140460	140461
28049	45713	0	applied	\N	\N	\N	\N	140478	140478	140479
28049	45714	1	applied	\N	\N	\N	\N	140480	140480	140481
28049	45715	2	applied	\N	\N	\N	\N	140482	140482	140483
28052	45716	0	applied	\N	\N	\N	\N	140489	140489	140490
28052	45717	1	applied	\N	\N	\N	\N	140493	140493	140494
28052	45718	2	applied	\N	\N	\N	\N	140495	140495	140496
28055	45716	0	applied	\N	\N	\N	\N	140489	140489	140490
28055	45717	1	applied	\N	\N	\N	\N	140493	140493	140494
28055	45718	2	applied	\N	\N	\N	\N	140495	140495	140496
28058	45722	0	applied	\N	\N	\N	\N	140509	140509	140510
28058	45723	1	applied	\N	\N	\N	\N	140511	140511	140512
28058	45724	2	applied	\N	\N	\N	\N	140513	140513	140514
28061	45725	0	applied	\N	\N	\N	\N	140519	140519	140520
28061	45726	1	applied	\N	\N	\N	\N	140521	140521	140522
28061	45727	2	applied	\N	\N	\N	\N	140523	140523	140524
28064	45728	0	applied	\N	\N	\N	\N	140526	140526	140527
28064	45729	1	applied	\N	\N	\N	\N	140528	140528	140529
28064	45730	2	applied	\N	\N	\N	\N	140530	140530	140531
28067	45740	0	applied	\N	\N	\N	\N	140557	140557	140558
28067	45741	1	applied	\N	\N	\N	\N	140559	140559	140560
28067	45742	2	applied	\N	\N	\N	\N	140561	140561	140562
28067	45743	3	applied	\N	\N	\N	\N	140563	140563	140564
28067	45744	4	applied	\N	\N	\N	\N	140565	140565	140566
28067	45745	5	applied	\N	\N	\N	\N	140567	140567	140568
28070	45750	0	applied	\N	\N	\N	\N	140584	140584	140585
28070	45751	1	applied	\N	\N	\N	\N	140586	140586	140587
28070	45752	2	applied	\N	\N	\N	\N	140588	140588	140589
28070	45753	3	applied	\N	\N	\N	\N	140590	140590	140591
28073	45007	0	applied	\N	\N	\N	\N	138316	138316	138317
28073	45008	1	applied	\N	\N	\N	\N	138318	138318	138319
28073	45009	2	applied	\N	\N	\N	\N	138320	138320	138321
28073	45010	3	applied	\N	\N	\N	\N	138322	138322	138323
28073	45011	4	applied	\N	\N	\N	\N	138324	138324	138325
28009	45389	24	applied	\N	\N	\N	\N	139571	139571	139226
28009	45390	25	applied	\N	\N	\N	\N	139573	139573	139228
28009	45399	26	applied	\N	\N	\N	\N	139591	139591	140231
28009	45400	27	applied	\N	\N	\N	\N	139593	139593	140232
28009	45403	28	applied	\N	\N	\N	\N	139600	139600	140233
28009	45406	29	applied	\N	\N	\N	\N	139608	139608	139242
28009	45409	30	applied	\N	\N	\N	\N	139614	139614	139244
28009	45411	31	applied	\N	\N	\N	\N	139619	139619	140234
28009	45415	32	applied	\N	\N	\N	\N	139632	139632	140235
28009	45416	33	applied	\N	\N	\N	\N	139634	139634	140236
28009	45421	34	applied	\N	\N	\N	\N	139647	139647	139256
28009	45424	35	applied	\N	\N	\N	\N	139655	139655	139260
28009	45429	36	applied	\N	\N	\N	\N	139667	139667	139269
28009	45430	37	applied	\N	\N	\N	\N	139669	139669	139271
28009	45432	38	applied	\N	\N	\N	\N	139675	139675	140237
28009	45435	39	applied	\N	\N	\N	\N	139690	139690	140238
28009	45439	40	applied	\N	\N	\N	\N	139700	139700	139275
28009	45442	41	applied	\N	\N	\N	\N	139708	139708	140239
28009	45445	42	applied	\N	\N	\N	\N	139717	139717	140240
28009	45449	43	applied	\N	\N	\N	\N	139727	139727	140241
28009	45451	44	applied	\N	\N	\N	\N	139734	139734	139289
28009	45455	45	applied	\N	\N	\N	\N	139744	139744	139291
28009	45460	47	applied	\N	\N	\N	\N	139756	139756	139339
28009	45461	48	applied	\N	\N	\N	\N	139758	139758	140243
28009	45466	49	applied	\N	\N	\N	\N	139769	139769	140244
28009	45470	50	applied	\N	\N	\N	\N	139779	139779	140245
28009	45471	51	applied	\N	\N	\N	\N	139781	139781	139350
28009	45477	52	applied	\N	\N	\N	\N	139794	139794	140246
28009	45478	53	applied	\N	\N	\N	\N	139796	139796	140247
28009	45482	54	applied	\N	\N	\N	\N	139806	139806	140248
28009	45486	55	applied	\N	\N	\N	\N	139817	139817	139362
28009	45489	56	applied	\N	\N	\N	\N	139825	139825	139364
28009	45494	57	applied	\N	\N	\N	\N	139837	139837	139375
28009	45495	58	applied	\N	\N	\N	\N	139839	139839	140249
28009	45500	59	applied	\N	\N	\N	\N	139850	139850	140250
28009	45501	60	applied	\N	\N	\N	\N	139852	139852	139379
28009	45502	61	applied	\N	\N	\N	\N	139854	139854	140251
28009	45507	62	applied	\N	\N	\N	\N	139866	139866	140252
28009	45513	63	applied	\N	\N	\N	\N	139884	139884	140253
28009	45514	64	applied	\N	\N	\N	\N	139886	139886	140254
28009	45517	65	applied	\N	\N	\N	\N	139898	139898	139396
28009	45518	66	applied	\N	\N	\N	\N	139900	139900	139398
28009	45524	67	applied	\N	\N	\N	\N	139912	139912	140255
28009	45526	68	applied	\N	\N	\N	\N	139916	139916	140256
28009	45531	69	applied	\N	\N	\N	\N	139929	139929	140257
28009	45532	70	applied	\N	\N	\N	\N	139931	139931	140258
28009	45535	71	applied	\N	\N	\N	\N	139937	139937	140259
28009	45540	72	applied	\N	\N	\N	\N	139952	139952	139415
28009	45541	73	applied	\N	\N	\N	\N	139956	139956	140260
28009	45546	74	applied	\N	\N	\N	\N	139973	139973	140261
28009	45547	75	applied	\N	\N	\N	\N	139975	139975	139422
28009	45548	76	applied	\N	\N	\N	\N	139977	139977	139424
28009	45559	77	applied	\N	\N	\N	\N	140002	140002	140262
28009	45560	78	applied	\N	\N	\N	\N	140004	140004	140263
28009	45563	79	applied	\N	\N	\N	\N	140010	140010	139436
28009	45564	80	applied	\N	\N	\N	\N	140012	140012	140264
28009	45565	81	applied	\N	\N	\N	\N	140014	140014	140265
28009	45567	82	applied	\N	\N	\N	\N	140031	140031	140266
28009	45570	83	applied	\N	\N	\N	\N	140038	140038	140267
28009	45574	84	applied	\N	\N	\N	\N	140066	140066	140268
28012	45633	0	applied	\N	\N	\N	\N	140278	140278	140279
28012	45634	1	applied	\N	\N	\N	\N	140280	140280	140281
28012	45635	2	applied	\N	\N	\N	\N	140282	140282	140283
28015	45642	0	applied	\N	\N	\N	\N	140299	140299	140300
28015	45643	1	applied	\N	\N	\N	\N	140301	140301	140302
28015	45644	2	applied	\N	\N	\N	\N	140303	140303	140304
28018	45651	0	applied	\N	\N	\N	\N	140320	140320	140321
28018	45652	1	applied	\N	\N	\N	\N	140322	140322	140323
28018	45653	2	applied	\N	\N	\N	\N	140324	140324	140325
28018	45654	3	applied	\N	\N	\N	\N	140326	140326	140327
28018	45655	4	applied	\N	\N	\N	\N	140328	140328	140329
28018	45656	5	applied	\N	\N	\N	\N	140330	140330	140331
28018	45657	6	applied	\N	\N	\N	\N	140332	140332	140333
28018	45658	7	applied	\N	\N	\N	\N	140334	140334	140335
28018	45659	8	applied	\N	\N	\N	\N	140336	140336	140337
28021	45660	0	applied	\N	\N	\N	\N	140339	140339	140340
28021	45661	1	applied	\N	\N	\N	\N	140343	140343	140344
28024	45665	0	applied	\N	\N	\N	\N	140357	140357	140358
28024	45666	1	applied	\N	\N	\N	\N	140359	140359	140360
28024	45667	2	applied	\N	\N	\N	\N	140361	140361	140362
28024	45668	3	applied	\N	\N	\N	\N	140363	140363	140364
28024	45669	4	applied	\N	\N	\N	\N	140365	140365	140366
28024	45670	5	applied	\N	\N	\N	\N	140367	140367	140368
28027	45671	0	applied	\N	\N	\N	\N	140371	140371	140372
28027	45672	1	applied	\N	\N	\N	\N	140373	140373	140374
28027	45673	2	applied	\N	\N	\N	\N	140375	140375	140376
28033	45678	0	applied	\N	\N	\N	\N	140390	140390	140391
28033	45679	1	applied	\N	\N	\N	\N	140392	140392	140393
28033	45680	2	applied	\N	\N	\N	\N	140394	140394	140395
28033	45681	3	applied	\N	\N	\N	\N	140396	140396	140397
28033	45682	4	applied	\N	\N	\N	\N	140398	140398	140399
28033	45683	5	applied	\N	\N	\N	\N	140400	140400	140401
28033	45684	6	applied	\N	\N	\N	\N	140402	140402	140403
28033	45685	7	applied	\N	\N	\N	\N	140404	140404	140405
28033	45686	8	applied	\N	\N	\N	\N	140406	140406	140407
28033	45687	9	applied	\N	\N	\N	\N	140408	140408	140409
28033	45688	10	applied	\N	\N	\N	\N	140410	140410	140411
28033	45689	11	applied	\N	\N	\N	\N	140412	140412	140413
28033	45690	12	applied	\N	\N	\N	\N	140414	140414	140415
28033	45691	13	applied	\N	\N	\N	\N	140416	140416	140417
28033	45692	14	applied	\N	\N	\N	\N	140418	140418	140419
28036	44856	0	applied	\N	\N	\N	\N	137744	137744	135497
28036	44857	1	applied	\N	\N	\N	\N	137745	137745	135497
28036	44915	2	applied	\N	\N	\N	\N	137967	137967	137968
28036	44954	3	applied	\N	\N	\N	\N	138153	138153	138231
28036	44721	4	applied	\N	\N	\N	\N	137387	137387	137388
28036	45423	5	applied	\N	\N	\N	\N	139653	139653	139654
28036	45082	6	applied	\N	\N	\N	\N	138730	138730	44452
28036	44722	7	applied	\N	\N	\N	\N	137389	137389	137390
28036	44955	8	applied	\N	\N	\N	\N	138155	138155	138232
28036	45447	9	applied	\N	\N	\N	\N	139723	139723	139724
28036	44957	10	applied	\N	\N	\N	\N	138159	138159	138233
28036	44860	11	applied	\N	\N	\N	\N	137750	137750	138160
28036	44958	12	applied	\N	\N	\N	\N	138161	138161	138162
28036	44718	13	applied	\N	\N	\N	\N	137377	137377	137378
28036	44723	14	applied	\N	\N	\N	\N	137391	137391	137392
28036	44724	15	applied	\N	\N	\N	\N	137393	137393	137394
28036	44725	16	applied	\N	\N	\N	\N	137395	137395	137396
28036	44726	17	applied	\N	\N	\N	\N	137397	137397	137397
28036	44744	18	applied	\N	\N	\N	\N	137441	137441	137442
28020	45661	1	applied	\N	\N	\N	\N	140343	140343	140344
28023	45662	0	applied	\N	\N	\N	\N	140347	140347	140348
28023	45663	1	applied	\N	\N	\N	\N	140349	140349	140350
28023	45664	2	applied	\N	\N	\N	\N	140351	140351	140352
28032	45674	0	applied	\N	\N	\N	\N	140381	140381	140382
28032	45675	1	applied	\N	\N	\N	\N	140383	140383	140384
28032	45676	2	applied	\N	\N	\N	\N	140385	140385	140386
28032	45677	3	applied	\N	\N	\N	\N	140387	140387	140272
28035	45693	0	applied	\N	\N	\N	\N	140423	140423	140424
28035	45694	1	applied	\N	\N	\N	\N	140425	140425	140426
28035	45695	2	applied	\N	\N	\N	\N	140427	140427	140428
28038	45696	0	applied	\N	\N	\N	\N	140433	140433	140434
28038	45697	1	applied	\N	\N	\N	\N	140435	140435	140436
28038	45698	2	applied	\N	\N	\N	\N	140437	140437	140438
28041	45702	0	applied	\N	\N	\N	\N	140450	140450	140451
28041	45703	1	applied	\N	\N	\N	\N	140452	140452	140453
28041	45704	2	applied	\N	\N	\N	\N	140454	140454	140455
28044	45707	0	applied	\N	\N	\N	\N	140464	140464	140465
28044	45708	1	applied	\N	\N	\N	\N	140466	140466	140467
28044	45709	2	applied	\N	\N	\N	\N	140468	140468	140469
28044	45710	3	applied	\N	\N	\N	\N	140470	140470	140471
28044	45711	4	applied	\N	\N	\N	\N	140472	140472	140473
28044	45712	5	applied	\N	\N	\N	\N	140474	140474	140475
28047	45713	0	applied	\N	\N	\N	\N	140478	140478	140479
28047	45714	1	applied	\N	\N	\N	\N	140480	140480	140481
28047	45715	2	applied	\N	\N	\N	\N	140482	140482	140483
28050	45423	0	applied	\N	\N	\N	\N	139653	139653	139654
28050	45447	1	applied	\N	\N	\N	\N	139723	139723	139724
28050	45388	2	applied	\N	\N	\N	\N	139569	139569	139570
28050	45391	3	applied	\N	\N	1000000000	\N	139575	139575	139576
28050	45472	4	applied	\N	\N	\N	\N	139783	139783	139784
28050	45392	5	applied	\N	\N	1000000000	\N	139577	139577	139578
28050	45393	6	applied	\N	\N	1000000000	\N	139579	139579	139580
28050	45490	7	applied	\N	\N	1000000000	\N	139827	139827	139828
28053	45716	0	applied	\N	\N	\N	\N	140489	140489	140490
28053	45717	1	applied	\N	\N	\N	\N	140493	140493	140494
28056	45719	0	applied	\N	\N	\N	\N	140501	140501	140502
28056	45720	1	applied	\N	\N	\N	\N	140503	140503	140504
28056	45721	2	applied	\N	\N	\N	\N	140505	140505	140506
28059	45722	0	applied	\N	\N	\N	\N	140509	140509	140510
28059	45723	1	applied	\N	\N	\N	\N	140511	140511	140512
28059	45724	2	applied	\N	\N	\N	\N	140513	140513	140514
28062	45728	0	applied	\N	\N	\N	\N	140526	140526	140527
28062	45729	1	applied	\N	\N	\N	\N	140528	140528	140529
28062	45730	2	applied	\N	\N	\N	\N	140530	140530	140531
28065	45731	0	applied	\N	\N	\N	\N	140538	140538	140539
28065	45732	1	applied	\N	\N	\N	\N	140540	140540	140541
28065	45733	2	applied	\N	\N	\N	\N	140542	140542	140543
28065	45734	3	applied	\N	\N	\N	\N	140544	140544	140545
28065	45735	4	applied	\N	\N	\N	\N	140546	140546	140547
28065	45736	5	applied	\N	\N	\N	\N	140548	140548	140549
28065	45737	6	applied	\N	\N	\N	\N	140550	140550	140551
28065	45738	7	applied	\N	\N	\N	\N	140552	140552	140553
28065	45739	8	applied	\N	\N	\N	\N	140554	140554	140555
28068	45746	0	applied	\N	\N	\N	\N	140573	140573	140574
28068	45747	1	applied	\N	\N	\N	\N	140575	140575	140576
28068	45748	2	applied	\N	\N	\N	\N	140577	140577	140578
28068	45749	3	applied	\N	\N	1000000000	\N	140579	140579	140580
28071	45750	0	applied	\N	\N	\N	\N	140584	140584	140585
28071	45751	1	applied	\N	\N	\N	\N	140586	140586	140587
28071	45754	2	applied	\N	\N	\N	\N	140593	140593	140594
28071	45755	3	applied	\N	\N	\N	\N	140595	140595	140596
28071	45752	4	applied	\N	\N	\N	\N	140588	140588	140597
28071	45753	5	applied	\N	\N	\N	\N	140590	140590	140598
28074	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28074	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28074	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28074	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28074	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28074	45761	5	applied	\N	\N	\N	\N	140615	140615	140616
28074	45762	6	applied	\N	\N	\N	\N	140617	140617	140618
28074	45763	7	applied	\N	\N	\N	\N	140619	140619	140620
28074	45764	8	applied	\N	\N	\N	\N	140621	140621	140622
28074	45765	9	applied	\N	\N	\N	\N	140623	140623	140624
28074	45766	10	applied	\N	\N	\N	\N	140625	140625	140626
28074	45767	11	applied	\N	\N	\N	\N	140627	140627	140628
28074	45768	12	applied	\N	\N	\N	\N	140629	140629	140630
28074	45769	13	applied	\N	\N	\N	\N	140631	140631	140632
28074	45770	14	applied	\N	\N	\N	\N	140633	140633	140634
28075	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28075	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28075	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28075	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28075	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28075	45761	5	applied	\N	\N	\N	\N	140615	140615	140616
28075	45762	6	applied	\N	\N	\N	\N	140617	140617	140618
28075	45763	7	applied	\N	\N	\N	\N	140619	140619	140620
28075	45764	8	applied	\N	\N	\N	\N	140621	140621	140622
28075	45765	9	applied	\N	\N	\N	\N	140623	140623	140624
28077	45761	0	applied	\N	\N	\N	\N	140615	140615	140616
28077	45762	1	applied	\N	\N	\N	\N	140617	140617	140618
28077	45763	2	applied	\N	\N	\N	\N	140619	140619	140620
28077	45764	3	applied	\N	\N	\N	\N	140621	140621	140622
28077	45765	4	applied	\N	\N	\N	\N	140623	140623	140624
28080	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28080	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28080	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28080	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28080	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28080	45771	5	applied	\N	\N	\N	\N	140642	140642	140643
28080	45772	6	applied	\N	\N	\N	\N	140644	140644	140645
28080	45773	7	applied	\N	\N	\N	\N	140646	140646	140647
28080	45774	8	applied	\N	\N	\N	\N	140648	140648	140649
28080	45775	9	applied	\N	\N	\N	\N	140650	140650	140651
28080	45776	10	applied	\N	\N	\N	\N	140652	140652	140628
28080	45766	11	applied	\N	\N	\N	\N	140625	140625	140630
28080	45767	12	applied	\N	\N	\N	\N	140627	140627	140632
28080	45768	13	applied	\N	\N	\N	\N	140629	140629	140634
28080	45769	14	applied	\N	\N	\N	\N	140631	140631	140653
28080	45770	15	applied	\N	\N	\N	\N	140633	140633	140654
28080	45777	16	applied	\N	\N	\N	\N	140655	140655	140656
28080	45778	17	applied	\N	\N	\N	\N	140657	140657	140658
28080	45779	18	applied	\N	\N	\N	\N	140659	140659	140660
28083	45783	0	applied	\N	\N	\N	\N	140674	140674	140675
28083	45784	1	applied	\N	\N	\N	\N	140676	140676	140677
28083	45785	2	applied	\N	\N	\N	\N	140678	140678	140679
28083	45786	4	applied	\N	\N	\N	\N	140681	140681	140682
28083	45787	5	applied	\N	\N	\N	\N	140683	140683	140684
28083	45788	6	applied	\N	\N	\N	\N	140685	140685	140686
28036	44745	19	applied	\N	\N	\N	\N	137443	137443	137444
28036	44746	20	applied	\N	\N	\N	\N	137445	137445	137446
28036	44747	21	applied	\N	\N	\N	\N	137447	137447	137448
28036	44748	22	applied	\N	\N	\N	\N	137449	137449	137450
28036	44749	24	applied	\N	\N	\N	\N	137451	137451	137451
28036	44727	25	applied	\N	\N	\N	\N	137398	137398	137399
28036	44730	26	applied	\N	\N	\N	\N	137408	137408	137409
28036	44731	27	applied	\N	\N	\N	\N	137410	137410	137411
28036	44737	28	applied	\N	\N	\N	\N	137424	137424	137425
28036	44738	29	applied	\N	\N	\N	\N	137426	137426	137427
28036	44743	30	applied	\N	\N	\N	\N	137439	137439	137440
28036	44752	31	applied	\N	\N	\N	\N	137459	137459	137460
28036	44755	32	applied	\N	\N	\N	\N	137468	137468	137469
28036	44756	33	applied	\N	\N	\N	\N	137470	137470	137471
28036	44757	34	applied	\N	\N	\N	\N	137472	137472	137473
28036	44758	35	applied	\N	\N	\N	\N	137474	137474	137475
28036	44767	36	applied	\N	\N	\N	\N	137494	137494	137495
28036	44770	37	applied	\N	\N	\N	\N	137522	137522	137523
28036	44773	38	applied	\N	\N	\N	\N	137533	137533	137534
28036	44774	39	applied	\N	\N	\N	\N	137535	137535	137536
28036	44775	40	applied	\N	\N	\N	\N	137537	137537	137538
28036	44776	41	applied	\N	\N	\N	\N	137539	137539	137540
28036	44785	42	applied	\N	\N	\N	\N	137560	137560	137561
28036	44786	43	applied	\N	\N	\N	\N	137562	137562	137563
28036	44787	44	applied	\N	\N	\N	\N	137564	137564	137565
28036	44794	45	applied	\N	\N	\N	\N	137583	137583	137584
28036	44797	46	applied	\N	\N	\N	\N	137591	137591	137592
28036	44800	47	applied	\N	\N	\N	\N	137600	137600	137601
28036	44803	48	applied	\N	\N	\N	\N	137608	137608	137609
28036	44804	49	applied	\N	\N	\N	\N	137610	137610	137611
28036	44809	50	applied	\N	\N	\N	\N	137625	137625	137626
28036	44813	51	applied	\N	\N	\N	\N	137636	137636	137637
28036	44814	52	applied	\N	\N	\N	\N	137638	137638	137639
28036	44819	53	applied	\N	\N	\N	\N	137650	137650	137651
28036	44822	54	applied	\N	\N	\N	\N	137658	137658	137659
28036	44825	55	applied	\N	\N	\N	\N	137666	137666	137667
28036	44828	56	applied	\N	\N	\N	\N	137676	137676	137677
28036	44861	57	applied	\N	\N	\N	\N	137752	137752	139653
28036	44829	58	applied	\N	\N	\N	\N	137678	137678	137679
28036	44830	59	applied	\N	\N	\N	\N	137680	137680	137681
28036	44831	60	applied	\N	\N	\N	\N	137682	137682	137683
28036	44840	61	applied	\N	\N	\N	\N	137706	137706	137707
28036	44844	62	applied	\N	\N	\N	\N	137715	137715	137716
28036	44845	63	applied	\N	\N	\N	\N	137717	137717	137718
28036	44850	64	applied	\N	\N	\N	\N	137729	137729	137730
28036	44851	65	applied	\N	\N	\N	\N	137731	137731	137732
28036	44858	66	applied	\N	\N	\N	\N	137746	137746	137747
28036	44859	67	applied	\N	\N	\N	\N	137748	137748	137749
28036	44866	68	applied	\N	\N	\N	\N	137794	137794	137795
28036	44869	69	applied	\N	\N	\N	\N	137801	137801	137802
28036	44872	70	applied	\N	\N	\N	\N	137809	137809	137810
28036	44875	71	applied	\N	\N	\N	\N	137817	137817	137818
28036	44878	72	applied	\N	\N	\N	\N	137825	137825	137826
28036	44881	73	applied	\N	\N	\N	\N	137831	137831	137832
28036	44884	74	applied	\N	\N	\N	\N	137837	137837	137838
28036	44885	75	applied	\N	\N	\N	\N	137839	137839	137840
28036	44892	76	applied	\N	\N	\N	\N	137855	137855	137856
28036	44895	77	applied	\N	\N	\N	\N	137863	137863	137864
28036	44898	78	applied	\N	\N	\N	\N	137873	137873	137874
28036	44901	79	applied	\N	\N	\N	\N	137884	137884	137885
28036	44904	80	applied	\N	\N	\N	\N	137901	137901	137902
28036	44907	81	applied	\N	\N	\N	\N	137907	137907	137908
28036	44909	82	applied	\N	\N	\N	\N	137914	137914	137915
28036	44912	83	applied	\N	\N	\N	\N	137922	137922	137923
28036	44916	84	applied	\N	\N	\N	\N	137969	137969	137970
28036	44917	85	applied	\N	\N	\N	\N	137971	137971	137972
28036	44922	86	applied	\N	\N	\N	\N	137985	137985	137986
28036	44923	87	applied	\N	\N	\N	\N	137987	137987	137988
28036	44928	88	applied	\N	\N	\N	\N	137999	137999	138000
28036	44931	89	applied	\N	\N	\N	\N	138010	138010	138011
28036	44934	90	applied	\N	\N	\N	\N	138017	138017	138018
28036	44936	91	applied	\N	\N	\N	\N	138025	138025	138026
28036	44938	92	applied	\N	\N	\N	\N	138113	138113	138114
28036	44939	93	applied	\N	\N	\N	\N	138115	138115	138116
28036	44940	94	applied	\N	\N	\N	\N	138117	138117	138118
28036	44944	95	applied	\N	\N	\N	\N	138131	138131	138132
28036	44841	96	applied	\N	\N	\N	\N	137708	137708	139653
28036	44732	97	applied	\N	\N	\N	\N	137412	137412	137413
28036	44945	98	applied	\N	\N	\N	\N	138133	138133	138134
28036	44946	99	applied	\N	\N	\N	\N	138135	138135	138136
28036	44947	100	applied	\N	\N	\N	\N	138137	138137	138138
28036	44952	101	applied	\N	\N	\N	\N	138149	138149	138150
28036	44953	102	applied	\N	\N	\N	\N	138151	138151	138152
28036	44956	103	applied	\N	\N	\N	\N	138157	138157	138158
28036	44962	104	applied	\N	\N	\N	\N	138173	138173	138174
28036	44963	105	applied	\N	\N	\N	\N	138175	138175	138176
28036	44966	106	applied	\N	\N	\N	\N	138182	138182	138183
28036	44967	107	applied	\N	\N	\N	\N	138184	138184	138185
28036	44968	108	applied	\N	\N	\N	\N	138186	138186	138187
28036	44972	109	applied	\N	\N	\N	\N	138195	138195	138196
28036	44974	110	applied	\N	\N	\N	\N	138202	138202	138203
28036	44975	111	applied	\N	\N	\N	\N	138204	138204	138205
28036	44978	112	applied	\N	\N	\N	\N	138214	138214	138215
28036	44980	113	applied	\N	\N	\N	\N	138223	138223	138224
28036	44982	114	applied	\N	\N	\N	\N	138237	138237	138238
28036	44984	115	applied	\N	\N	\N	\N	138246	138246	138247
28036	44987	116	applied	\N	\N	\N	\N	138254	138254	138255
28036	44988	117	applied	\N	\N	\N	\N	138256	138256	138257
28036	44991	118	applied	\N	\N	\N	\N	138268	138268	138269
28036	44993	119	applied	\N	\N	\N	\N	138276	138276	138277
28036	44995	120	applied	\N	\N	\N	\N	138282	138282	138283
28036	44996	121	applied	\N	\N	\N	\N	138284	138284	138285
28036	44997	122	applied	\N	\N	\N	\N	138286	138286	138287
28036	45001	123	applied	\N	\N	\N	\N	138296	138296	138297
28036	45003	124	applied	\N	\N	\N	\N	138300	138300	138301
28036	45005	125	applied	\N	\N	\N	\N	138309	138309	138310
28039	45699	0	applied	\N	\N	\N	\N	140441	140441	140442
28039	45700	1	applied	\N	\N	\N	\N	140443	140443	140444
28042	45703	0	applied	\N	\N	\N	\N	140452	140452	140453
28042	45704	1	applied	\N	\N	\N	\N	140454	140454	140455
28048	45713	0	applied	\N	\N	\N	\N	140478	140478	140479
28048	45714	1	applied	\N	\N	\N	\N	140480	140480	140481
28048	45715	2	applied	\N	\N	\N	\N	140482	140482	140483
28051	45716	0	applied	\N	\N	\N	\N	140489	140489	140490
28054	45716	0	applied	\N	\N	\N	\N	140489	140489	140490
28054	45717	1	applied	\N	\N	\N	\N	140493	140493	140494
28054	45718	2	applied	\N	\N	\N	\N	140495	140495	140496
28057	45722	0	applied	\N	\N	\N	\N	140509	140509	140510
28057	45723	1	applied	\N	\N	\N	\N	140511	140511	140512
28057	45724	2	applied	\N	\N	\N	\N	140513	140513	140514
28060	45722	0	applied	\N	\N	\N	\N	140509	140509	140510
28060	45723	1	applied	\N	\N	\N	\N	140511	140511	140512
28060	45724	2	applied	\N	\N	\N	\N	140513	140513	140514
28063	45728	0	applied	\N	\N	\N	\N	140526	140526	140527
28063	45729	1	applied	\N	\N	\N	\N	140528	140528	140529
28063	45730	2	applied	\N	\N	\N	\N	140530	140530	140531
28066	45740	0	applied	\N	\N	\N	\N	140557	140557	140558
28066	45741	1	applied	\N	\N	\N	\N	140559	140559	140560
28066	45742	2	applied	\N	\N	\N	\N	140561	140561	140562
28066	45743	3	applied	\N	\N	\N	\N	140563	140563	140564
28066	45744	4	applied	\N	\N	\N	\N	140565	140565	140566
28066	45745	5	applied	\N	\N	\N	\N	140567	140567	140568
28069	45746	0	applied	\N	\N	\N	\N	140573	140573	140574
28069	45747	1	applied	\N	\N	\N	\N	140575	140575	140576
28069	45748	2	applied	\N	\N	\N	\N	140577	140577	140578
28069	45749	3	applied	\N	\N	1000000000	\N	140579	140579	140580
28072	45750	0	applied	\N	\N	\N	\N	140584	140584	140585
28072	45751	1	applied	\N	\N	\N	\N	140586	140586	140587
28072	45754	2	applied	\N	\N	\N	\N	140593	140593	140594
28072	45755	3	applied	\N	\N	\N	\N	140595	140595	140596
28072	45752	4	applied	\N	\N	\N	\N	140588	140588	140597
28072	45753	5	applied	\N	\N	\N	\N	140590	140590	140598
28078	45749	0	applied	\N	\N	1000000000	\N	140579	140579	140580
28081	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28081	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28081	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28081	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28081	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28081	45771	5	applied	\N	\N	\N	\N	140642	140642	140643
28081	45772	6	applied	\N	\N	\N	\N	140644	140644	140645
28081	45773	7	applied	\N	\N	\N	\N	140646	140646	140647
28081	45774	8	applied	\N	\N	\N	\N	140648	140648	140649
28081	45775	9	applied	\N	\N	\N	\N	140650	140650	140651
28081	45776	10	applied	\N	\N	\N	\N	140652	140652	140628
28081	45766	11	applied	\N	\N	\N	\N	140625	140625	140630
28081	45767	12	applied	\N	\N	\N	\N	140627	140627	140632
28081	45768	13	applied	\N	\N	\N	\N	140629	140629	140634
28081	45769	14	applied	\N	\N	\N	\N	140631	140631	140653
28081	45770	15	applied	\N	\N	\N	\N	140633	140633	140654
28081	45777	16	applied	\N	\N	\N	\N	140655	140655	140656
28081	45778	17	applied	\N	\N	\N	\N	140657	140657	140658
28081	45779	18	applied	\N	\N	\N	\N	140659	140659	140660
28084	45793	0	applied	\N	\N	\N	\N	140697	140697	140698
28084	45794	1	applied	\N	\N	\N	\N	140699	140699	140700
28084	45795	2	applied	\N	\N	\N	\N	140701	140701	140702
28084	45796	3	applied	\N	\N	\N	\N	140703	140703	140704
28084	45797	4	applied	\N	\N	\N	\N	140705	140705	140706
28084	45798	5	applied	\N	\N	\N	\N	140707	140707	140708
28087	45793	0	applied	\N	\N	\N	\N	140697	140697	140698
28087	45794	1	applied	\N	\N	\N	\N	140699	140699	140700
28087	45795	2	applied	\N	\N	\N	\N	140701	140701	140702
28087	45796	3	applied	\N	\N	\N	\N	140703	140703	140704
28087	45797	4	applied	\N	\N	\N	\N	140705	140705	140706
28087	45798	5	applied	\N	\N	\N	\N	140707	140707	140708
28090	45799	0	applied	\N	\N	\N	\N	140717	140717	140718
28090	45800	1	applied	\N	\N	\N	\N	140719	140719	140720
28090	45801	2	applied	\N	\N	\N	\N	140721	140721	140722
28090	45802	3	applied	\N	\N	\N	\N	140723	140723	140724
28093	45803	0	applied	\N	\N	\N	\N	140729	140729	140730
28093	45804	1	applied	\N	\N	\N	\N	140731	140731	140732
28093	45805	2	applied	\N	\N	\N	\N	140733	140733	140734
28094	45803	0	applied	\N	\N	\N	\N	140729	140729	140730
28094	45804	1	applied	\N	\N	\N	\N	140731	140731	140732
28094	45805	2	applied	\N	\N	\N	\N	140733	140733	140734
28095	45806	0	applied	\N	\N	\N	\N	140740	140740	140741
28095	45807	1	applied	\N	\N	\N	\N	140742	140742	140743
28095	45808	2	applied	\N	\N	\N	\N	140744	140744	140745
28097	45809	0	applied	\N	\N	\N	\N	140747	140747	140748
28097	45810	1	applied	\N	\N	\N	\N	140749	140749	140750
28097	45811	2	applied	\N	\N	\N	\N	140751	140751	140752
28097	45812	3	applied	\N	\N	\N	\N	140753	140753	140754
28098	45813	0	applied	\N	\N	\N	\N	140757	140757	140758
28098	45814	1	applied	\N	\N	\N	\N	140759	140759	140760
28098	45815	2	applied	\N	\N	\N	\N	140761	140761	140762
28098	45816	3	applied	\N	\N	\N	\N	140763	140763	140764
28098	45817	4	applied	\N	\N	\N	\N	140765	140765	140766
28098	45818	5	applied	\N	\N	\N	\N	140767	140767	140768
28098	45819	6	applied	\N	\N	\N	\N	140769	140769	140770
28098	45820	7	applied	\N	\N	\N	\N	140771	140771	140772
28098	45821	8	applied	\N	\N	\N	\N	140773	140773	140774
28098	45822	9	applied	\N	\N	\N	\N	140775	140775	140776
28100	45813	0	applied	\N	\N	\N	\N	140757	140757	140758
28100	45814	1	applied	\N	\N	\N	\N	140759	140759	140760
28100	45815	2	applied	\N	\N	\N	\N	140761	140761	140762
28100	45816	3	applied	\N	\N	\N	\N	140763	140763	140764
28100	45817	4	applied	\N	\N	\N	\N	140765	140765	140766
28100	45818	5	applied	\N	\N	\N	\N	140767	140767	140768
28100	45819	6	applied	\N	\N	\N	\N	140769	140769	140770
28100	45820	7	applied	\N	\N	\N	\N	140771	140771	140772
28100	45821	8	applied	\N	\N	\N	\N	140773	140773	140774
28100	45822	9	applied	\N	\N	\N	\N	140775	140775	140776
28101	45823	0	applied	\N	\N	\N	\N	140781	140781	140782
28101	45824	1	applied	\N	\N	\N	\N	140783	140783	140784
28101	45825	2	applied	\N	\N	\N	\N	140785	140785	140786
28104	45423	0	applied	\N	\N	\N	\N	139653	139653	139654
28104	45447	1	applied	\N	\N	\N	\N	139723	139723	139724
28104	45209	2	applied	\N	\N	\N	\N	139064	139064	139065
28104	45212	3	applied	\N	\N	\N	\N	139072	139072	139073
28104	45215	4	applied	\N	\N	\N	\N	139080	139080	139081
28104	45216	5	applied	\N	\N	\N	\N	139082	139082	139083
28104	45221	6	applied	\N	\N	\N	\N	139093	139093	139094
28104	45224	7	applied	\N	\N	\N	\N	139104	139104	139105
28104	45225	8	applied	\N	\N	\N	\N	139106	139106	139107
28104	45226	9	applied	\N	\N	\N	\N	139108	139108	139109
28104	45233	10	applied	\N	\N	\N	\N	139126	139126	139127
28104	45234	11	applied	\N	\N	\N	\N	139128	139128	139129
28104	45239	12	applied	\N	\N	\N	\N	139140	139140	139141
28104	45242	13	applied	\N	\N	\N	\N	139147	139147	139148
28104	45245	14	applied	\N	\N	\N	\N	139159	139159	139160
28104	45248	15	applied	\N	\N	\N	\N	139167	139167	139168
28104	45251	16	applied	\N	\N	\N	\N	139175	139175	139176
28104	45254	17	applied	\N	\N	\N	\N	139184	139184	139185
28104	45255	18	applied	\N	\N	\N	\N	139186	139186	139187
28104	45260	19	applied	\N	\N	\N	\N	139200	139200	139201
28104	45263	20	applied	\N	\N	\N	\N	139210	139210	139211
28104	45264	21	applied	\N	\N	\N	\N	139212	139212	139213
28104	45269	22	applied	\N	\N	\N	\N	139223	139223	139224
28104	45272	23	applied	\N	\N	\N	\N	139229	139229	139230
28104	45275	24	applied	\N	\N	\N	\N	139239	139239	139240
28073	45012	5	applied	\N	\N	\N	\N	138326	138326	138327
28073	45013	6	applied	\N	\N	\N	\N	138328	138328	138329
28073	45021	7	applied	\N	\N	\N	\N	138346	138346	138347
28073	45023	8	applied	\N	\N	\N	\N	138354	138354	138355
28073	45024	9	applied	\N	\N	\N	\N	138356	138356	138357
28073	45027	10	applied	\N	\N	\N	\N	138365	138365	138366
28073	45029	11	applied	\N	\N	\N	\N	138370	138370	138371
28073	45031	12	applied	\N	\N	\N	\N	138382	138382	138383
28073	45033	13	applied	\N	\N	\N	\N	138389	138389	138390
28073	45035	14	applied	\N	\N	\N	\N	138394	138394	138395
28073	45037	15	applied	\N	\N	\N	\N	138469	138469	138470
28073	45038	16	applied	\N	\N	\N	\N	138471	138471	138472
28073	45039	17	applied	\N	\N	\N	\N	138473	138473	138474
28073	45040	18	applied	\N	\N	\N	\N	138475	138475	138476
28073	45041	19	applied	\N	\N	\N	\N	138477	138477	138478
28073	45047	20	applied	\N	\N	\N	\N	138493	138493	138494
28073	45049	21	applied	\N	\N	\N	\N	138499	138499	138500
28073	45051	22	applied	\N	\N	\N	\N	138506	138506	138507
28073	45053	24	applied	\N	\N	\N	\N	138512	138512	138513
28073	45055	25	applied	\N	\N	\N	\N	138518	138518	138519
28073	45057	26	applied	\N	\N	\N	\N	138529	138529	138530
28073	45059	27	applied	\N	\N	\N	\N	138535	138535	138536
28073	45060	28	applied	\N	\N	\N	\N	138537	138537	138538
28073	45063	29	applied	\N	\N	\N	\N	138545	138545	138546
28073	45064	30	applied	\N	\N	\N	\N	138547	138547	138548
28073	45065	31	applied	\N	\N	\N	\N	138549	138549	138550
28073	45070	32	applied	\N	\N	\N	\N	138560	138560	138561
28073	45072	33	applied	\N	\N	\N	\N	138567	138567	138568
28073	45073	34	applied	\N	\N	\N	\N	138569	138569	138570
28073	45076	35	applied	\N	\N	\N	\N	138577	138577	138578
28073	45078	36	applied	\N	\N	\N	\N	138585	138585	138586
28073	45079	37	applied	\N	\N	\N	\N	138587	138587	138588
28073	45083	38	applied	\N	\N	\N	\N	138731	138731	138732
28073	45084	39	applied	\N	\N	\N	\N	138733	138733	138734
28073	45085	40	applied	\N	\N	\N	\N	138735	138735	138736
28073	45089	41	applied	\N	\N	\N	\N	138745	138745	138746
28073	45090	42	applied	\N	\N	\N	\N	138747	138747	138748
28073	45093	43	applied	\N	\N	\N	\N	138754	138754	138755
28073	45094	44	applied	\N	\N	\N	\N	138756	138756	138757
28073	45097	45	applied	\N	\N	\N	\N	138763	138763	138764
28073	45099	46	applied	\N	\N	\N	\N	138769	138769	138770
28073	45100	47	applied	\N	\N	\N	\N	138771	138771	138772
28073	45104	48	applied	\N	\N	\N	\N	138781	138781	138782
28073	45106	49	applied	\N	\N	\N	\N	138787	138787	138788
28073	45109	50	applied	\N	\N	\N	\N	138798	138798	138799
28073	45112	51	applied	\N	\N	\N	\N	138806	138806	138807
28073	45113	52	applied	\N	\N	\N	\N	138808	138808	138809
28073	45118	53	applied	\N	\N	\N	\N	138820	138820	138821
28073	45121	54	applied	\N	\N	\N	\N	138831	138831	138832
28073	45125	55	applied	\N	\N	\N	\N	138845	138845	138846
28073	45128	56	applied	\N	\N	\N	\N	138852	138852	138853
28073	45129	57	applied	\N	\N	\N	\N	138854	138854	138855
28073	45134	58	applied	\N	\N	\N	\N	138868	138868	138869
28073	45135	59	applied	\N	\N	\N	\N	138870	138870	138871
28073	45140	60	applied	\N	\N	\N	\N	138884	138884	138885
28073	45141	61	applied	\N	\N	\N	\N	138886	138886	138887
28073	45146	62	applied	\N	\N	\N	\N	138898	138898	138899
28073	45149	63	applied	\N	\N	\N	\N	138905	138905	138906
28073	45150	64	applied	\N	\N	\N	\N	138907	138907	138908
28073	45155	65	applied	\N	\N	\N	\N	138919	138919	138920
28073	45158	66	applied	\N	\N	\N	\N	138926	138926	138927
28073	45159	67	applied	\N	\N	\N	\N	138928	138928	138929
28073	45164	68	applied	\N	\N	\N	\N	138940	138940	138941
28073	45167	69	applied	\N	\N	\N	\N	138948	138948	138949
28073	45170	70	applied	\N	\N	\N	\N	138956	138956	138957
28073	45173	71	applied	\N	\N	\N	\N	138966	138966	138967
28073	45176	72	applied	\N	\N	\N	\N	138974	138974	138975
28073	45179	73	applied	\N	\N	\N	\N	138981	138981	138982
28073	45182	74	applied	\N	\N	\N	\N	138990	138990	138991
28073	45185	75	applied	\N	\N	\N	\N	139000	139000	139001
28073	45188	76	applied	\N	\N	\N	\N	139008	139008	139009
28073	45191	77	applied	\N	\N	\N	\N	139015	139015	139016
28073	45192	78	applied	\N	\N	\N	\N	139017	139017	139018
28073	45193	79	applied	\N	\N	\N	\N	139019	139019	139020
28073	45194	80	applied	\N	\N	\N	\N	139021	139021	139022
28073	45203	81	applied	\N	\N	\N	\N	139045	139045	139046
28073	45206	82	applied	\N	\N	\N	\N	139056	139056	139057
28073	45209	83	applied	\N	\N	\N	\N	139064	139064	139065
28073	45212	84	applied	\N	\N	\N	\N	139072	139072	139073
28073	45215	85	applied	\N	\N	\N	\N	139080	139080	139081
28073	45216	86	applied	\N	\N	\N	\N	139082	139082	139083
28073	45221	87	applied	\N	\N	\N	\N	139093	139093	139094
28073	45224	88	applied	\N	\N	\N	\N	139104	139104	139105
28073	45225	89	applied	\N	\N	\N	\N	139106	139106	139107
28073	45226	90	applied	\N	\N	\N	\N	139108	139108	139109
28073	45233	91	applied	\N	\N	\N	\N	139126	139126	139127
28073	45234	92	applied	\N	\N	\N	\N	139128	139128	139129
28073	45239	93	applied	\N	\N	\N	\N	139140	139140	139141
28073	45242	94	applied	\N	\N	\N	\N	139147	139147	139148
28073	45245	95	applied	\N	\N	\N	\N	139159	139159	139160
28073	45248	96	applied	\N	\N	\N	\N	139167	139167	139168
28073	45251	97	applied	\N	\N	\N	\N	139175	139175	139176
28073	45254	98	applied	\N	\N	\N	\N	139184	139184	139185
28073	45255	99	applied	\N	\N	\N	\N	139186	139186	139187
28073	45260	100	applied	\N	\N	\N	\N	139200	139200	139201
28073	45263	101	applied	\N	\N	\N	\N	139210	139210	139211
28073	45264	102	applied	\N	\N	\N	\N	139212	139212	139213
28073	45269	103	applied	\N	\N	\N	\N	139223	139223	139224
28073	45272	104	applied	\N	\N	\N	\N	139229	139229	139230
28073	45275	105	applied	\N	\N	\N	\N	139239	139239	139240
28073	45278	106	applied	\N	\N	\N	\N	139245	139245	139246
28073	45281	107	applied	\N	\N	\N	\N	139253	139253	139254
28073	45285	108	applied	\N	\N	\N	\N	139263	139263	139264
28073	45286	109	applied	\N	\N	\N	\N	139265	139265	139266
28073	45292	110	applied	\N	\N	\N	\N	139278	139278	139279
28073	45295	111	applied	\N	\N	\N	\N	139286	139286	139287
28073	45298	112	applied	\N	\N	\N	\N	139336	139336	139337
28073	45301	113	applied	\N	\N	\N	\N	139345	139345	139346
28073	45304	114	applied	\N	\N	\N	\N	139352	139352	139353
28073	45307	115	applied	\N	\N	\N	\N	139359	139359	139360
28073	45310	116	applied	\N	\N	\N	\N	139370	139370	139371
28073	45311	117	applied	\N	\N	\N	\N	139372	139372	139373
28073	45318	118	applied	\N	\N	\N	\N	139393	139393	139394
28073	45321	119	applied	\N	\N	\N	\N	139400	139400	139401
28073	45322	120	applied	\N	\N	\N	\N	139402	139402	139403
28073	45323	121	applied	\N	\N	\N	\N	139404	139404	139405
28073	45330	122	applied	\N	\N	\N	\N	139419	139419	139420
28073	45333	123	applied	\N	\N	\N	\N	139427	139427	139428
28073	45334	124	applied	\N	\N	\N	\N	139429	139429	139430
28073	45335	125	applied	\N	\N	\N	\N	139431	139431	139432
28076	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28076	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28076	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28076	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28076	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28076	45761	5	applied	\N	\N	\N	\N	140615	140615	140616
28076	45762	6	applied	\N	\N	\N	\N	140617	140617	140618
28076	45763	7	applied	\N	\N	\N	\N	140619	140619	140620
28076	45764	8	applied	\N	\N	\N	\N	140621	140621	140622
28076	45765	9	applied	\N	\N	\N	\N	140623	140623	140624
28076	45766	10	applied	\N	\N	\N	\N	140625	140625	140626
28076	45767	11	applied	\N	\N	\N	\N	140627	140627	140628
28076	45768	12	applied	\N	\N	\N	\N	140629	140629	140630
28076	45769	13	applied	\N	\N	\N	\N	140631	140631	140632
28076	45770	14	applied	\N	\N	\N	\N	140633	140633	140634
28079	45756	0	applied	\N	\N	\N	\N	140605	140605	140606
28079	45757	1	applied	\N	\N	\N	\N	140607	140607	140608
28079	45758	2	applied	\N	\N	\N	\N	140609	140609	140610
28079	45759	3	applied	\N	\N	\N	\N	140611	140611	140612
28079	45760	4	applied	\N	\N	\N	\N	140613	140613	140614
28079	45771	5	applied	\N	\N	\N	\N	140642	140642	140643
28079	45772	6	applied	\N	\N	\N	\N	140644	140644	140645
28079	45773	7	applied	\N	\N	\N	\N	140646	140646	140647
28079	45774	8	applied	\N	\N	\N	\N	140648	140648	140649
28079	45775	9	applied	\N	\N	\N	\N	140650	140650	140651
28079	45776	10	applied	\N	\N	\N	\N	140652	140652	140628
28079	45766	11	applied	\N	\N	\N	\N	140625	140625	140630
28079	45767	12	applied	\N	\N	\N	\N	140627	140627	140632
28079	45768	13	applied	\N	\N	\N	\N	140629	140629	140634
28079	45769	14	applied	\N	\N	\N	\N	140631	140631	140653
28079	45770	15	applied	\N	\N	\N	\N	140633	140633	140654
28079	45777	16	applied	\N	\N	\N	\N	140655	140655	140656
28079	45778	17	applied	\N	\N	\N	\N	140657	140657	140658
28079	45779	18	applied	\N	\N	\N	\N	140659	140659	140660
28082	45780	0	applied	\N	\N	\N	\N	140667	140667	140668
28082	45781	1	applied	\N	\N	\N	\N	140669	140669	140670
28082	45782	2	applied	\N	\N	\N	\N	140671	140671	140672
28085	45793	0	applied	\N	\N	\N	\N	140697	140697	140698
28085	45794	1	applied	\N	\N	\N	\N	140699	140699	140700
28085	45795	2	applied	\N	\N	\N	\N	140701	140701	140702
28085	45796	3	applied	\N	\N	\N	\N	140703	140703	140704
28085	45797	4	applied	\N	\N	\N	\N	140705	140705	140706
28085	45798	5	applied	\N	\N	\N	\N	140707	140707	140708
28088	45799	0	applied	\N	\N	\N	\N	140717	140717	140718
28088	45800	1	applied	\N	\N	\N	\N	140719	140719	140720
28088	45801	2	applied	\N	\N	\N	\N	140721	140721	140722
28088	45802	3	applied	\N	\N	\N	\N	140723	140723	140724
28091	45803	0	applied	\N	\N	\N	\N	140729	140729	140730
28091	45804	1	applied	\N	\N	\N	\N	140731	140731	140732
28091	45805	2	applied	\N	\N	\N	\N	140733	140733	140734
28099	45813	0	applied	\N	\N	\N	\N	140757	140757	140758
28099	45814	1	applied	\N	\N	\N	\N	140759	140759	140760
28099	45815	2	applied	\N	\N	\N	\N	140761	140761	140762
28099	45816	3	applied	\N	\N	\N	\N	140763	140763	140764
28099	45817	4	applied	\N	\N	\N	\N	140765	140765	140766
28099	45818	5	applied	\N	\N	\N	\N	140767	140767	140768
28099	45819	6	applied	\N	\N	\N	\N	140769	140769	140770
28099	45820	7	applied	\N	\N	\N	\N	140771	140771	140772
28099	45821	8	applied	\N	\N	\N	\N	140773	140773	140774
28099	45822	9	applied	\N	\N	\N	\N	140775	140775	140776
28102	45823	0	applied	\N	\N	\N	\N	140781	140781	140782
28102	45824	1	applied	\N	\N	\N	\N	140783	140783	140784
28102	45825	2	applied	\N	\N	\N	\N	140785	140785	140786
28103	45826	0	applied	\N	\N	\N	\N	140789	140789	140790
28103	45827	1	applied	\N	\N	\N	\N	140791	140791	140792
28103	45828	2	applied	\N	\N	\N	\N	140793	140793	140794
28108	45836	0	applied	\N	\N	\N	\N	140818	140818	140819
28108	45837	1	applied	\N	\N	\N	\N	140820	140820	140821
28108	45838	2	applied	\N	\N	\N	\N	140822	140822	140823
28109	45836	0	applied	\N	\N	\N	\N	140818	140818	140819
28109	45837	1	applied	\N	\N	\N	\N	140820	140820	140821
28109	45838	2	applied	\N	\N	\N	\N	140822	140822	140823
28111	45839	0	applied	\N	\N	\N	\N	140828	140828	140829
28111	45840	1	applied	\N	\N	\N	\N	140830	140830	140831
28111	45841	2	applied	\N	\N	\N	\N	140832	140832	140833
28111	45842	3	applied	\N	\N	\N	\N	140834	140834	140835
28111	45843	4	applied	\N	\N	\N	\N	140836	140836	140837
28111	45844	5	applied	\N	\N	\N	\N	140838	140838	140839
28111	45845	6	applied	\N	\N	\N	\N	140840	140840	140841
28112	45846	0	applied	\N	\N	\N	\N	140844	140844	140845
28112	45847	1	applied	\N	\N	1000000000	\N	140846	140846	140847
28112	45848	2	applied	\N	\N	\N	\N	140848	140848	140849
28112	45849	3	applied	\N	\N	\N	\N	140850	140850	140851
28114	45850	0	applied	\N	\N	\N	\N	140854	140854	140855
28114	45851	1	applied	\N	\N	\N	\N	140856	140856	140857
28114	45852	2	applied	\N	\N	\N	\N	140858	140858	140859
28114	45853	3	applied	\N	\N	\N	\N	140860	140860	140861
28114	45854	4	applied	\N	\N	\N	\N	140862	140862	140863
28114	45855	5	applied	\N	\N	\N	\N	140864	140864	140865
28114	45856	6	applied	\N	\N	\N	\N	140866	140866	140867
28115	45857	0	applied	\N	\N	\N	\N	140872	140872	140873
28115	45858	1	applied	\N	\N	\N	\N	140874	140874	140875
28115	45859	2	applied	\N	\N	\N	\N	140876	140876	140877
28115	45860	3	applied	\N	\N	\N	\N	140878	140878	140879
28115	45861	4	applied	\N	\N	\N	\N	140880	140880	140881
28115	45862	5	applied	\N	\N	\N	\N	140882	140882	140883
28117	45863	0	applied	\N	\N	\N	\N	140886	140886	140887
28117	45864	1	applied	\N	\N	\N	\N	140888	140888	140889
28117	45865	2	applied	\N	\N	\N	\N	140890	140890	140891
28118	45866	0	applied	\N	\N	\N	\N	140896	140896	140897
28118	45867	1	applied	\N	\N	\N	\N	140898	140898	140899
28118	45868	2	applied	\N	\N	\N	\N	140900	140900	140901
28118	45869	3	applied	\N	\N	\N	\N	140902	140902	140903
28121	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28121	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28123	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28123	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28125	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28125	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28127	45880	0	applied	\N	\N	\N	\N	140934	140934	140935
28127	45881	1	applied	\N	\N	\N	\N	140936	140936	140937
28129	45880	0	applied	\N	\N	\N	\N	140934	140934	140935
28133	45884	0	applied	\N	\N	\N	\N	140951	140951	140952
28133	45885	1	applied	\N	\N	1000000000	\N	140953	140953	140954
28133	45886	2	applied	\N	\N	\N	\N	140955	140955	140956
28136	45887	0	applied	\N	\N	\N	\N	140961	140961	140962
28136	45888	1	applied	\N	\N	\N	\N	140963	140963	140964
28136	45889	2	applied	\N	\N	1000000000	\N	140965	140965	140966
28136	45890	3	applied	\N	\N	1000000000	\N	140967	140967	140968
28083	45789	7	applied	\N	\N	\N	\N	140687	140687	140688
28083	45790	8	applied	\N	\N	\N	\N	140689	140689	140690
28083	45791	9	applied	\N	\N	\N	\N	140691	140691	140692
28083	45792	10	applied	\N	\N	\N	\N	140693	140693	140694
28086	45793	0	applied	\N	\N	\N	\N	140697	140697	140698
28086	45794	1	applied	\N	\N	\N	\N	140699	140699	140700
28086	45795	2	applied	\N	\N	\N	\N	140701	140701	140702
28086	45796	3	applied	\N	\N	\N	\N	140703	140703	140704
28086	45797	4	applied	\N	\N	\N	\N	140705	140705	140706
28086	45798	5	applied	\N	\N	\N	\N	140707	140707	140708
28089	45799	0	applied	\N	\N	\N	\N	140717	140717	140718
28089	45800	1	applied	\N	\N	\N	\N	140719	140719	140720
28089	45801	2	applied	\N	\N	\N	\N	140721	140721	140722
28089	45802	3	applied	\N	\N	\N	\N	140723	140723	140724
28092	45803	0	applied	\N	\N	\N	\N	140729	140729	140730
28092	45804	1	applied	\N	\N	\N	\N	140731	140731	140732
28092	45805	2	applied	\N	\N	\N	\N	140733	140733	140734
28096	45809	0	applied	\N	\N	\N	\N	140747	140747	140748
28096	45810	1	applied	\N	\N	\N	\N	140749	140749	140750
28096	45811	2	applied	\N	\N	\N	\N	140751	140751	140752
28096	45812	3	applied	\N	\N	\N	\N	140753	140753	140754
28105	45829	0	applied	\N	\N	\N	\N	140800	140800	140801
28105	45830	1	applied	\N	\N	\N	\N	140802	140802	140803
28105	45831	2	applied	\N	\N	\N	\N	140804	140804	140805
28105	45832	3	applied	\N	\N	\N	\N	140806	140806	140807
28105	45833	4	applied	\N	\N	\N	\N	140808	140808	140809
28105	45834	5	applied	\N	\N	\N	\N	140810	140810	140811
28105	45835	6	applied	\N	\N	\N	\N	140812	140812	140813
28120	45873	0	applied	\N	\N	\N	\N	140912	140912	140913
28120	45874	1	applied	\N	\N	\N	\N	140914	140914	140915
28120	45875	2	applied	\N	\N	\N	\N	140916	140916	140917
28120	45876	3	applied	\N	\N	\N	\N	140918	140918	140919
28120	45877	5	applied	\N	\N	\N	\N	140921	140921	140922
28122	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28122	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28124	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28124	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28126	45878	0	applied	\N	\N	\N	\N	140927	140927	140928
28126	45879	1	applied	\N	\N	\N	\N	140929	140929	140930
28130	45880	0	applied	\N	\N	\N	\N	140934	140934	140935
28132	45883	0	applied	\N	\N	\N	\N	140948	140948	140949
28132	45881	1	applied	\N	\N	\N	\N	140936	140936	140937
28132	45882	2	applied	\N	\N	\N	\N	140944	140944	140945
28134	45884	0	applied	\N	\N	\N	\N	140951	140951	140952
28134	45885	1	applied	\N	\N	1000000000	\N	140953	140953	140954
28134	45886	2	applied	\N	\N	\N	\N	140955	140955	140956
28135	45884	0	applied	\N	\N	\N	\N	140951	140951	140952
28135	45885	1	applied	\N	\N	1000000000	\N	140953	140953	140954
28135	45886	2	applied	\N	\N	\N	\N	140955	140955	140956
28138	45893	0	applied	\N	\N	\N	\N	140977	140977	140978
28138	45894	1	applied	\N	\N	\N	\N	140979	140979	140980
28138	45895	2	applied	\N	\N	\N	\N	140981	140981	140982
28142	45898	0	applied	\N	\N	\N	\N	140991	140991	140992
28142	45899	1	applied	\N	\N	\N	\N	140993	140993	140994
28144	45906	0	applied	\N	\N	\N	\N	141013	141013	141014
28144	45907	1	applied	\N	\N	\N	\N	141015	141015	141016
28149	45915	0	applied	\N	\N	\N	\N	141046	141046	141047
28149	45916	1	applied	\N	\N	\N	\N	141048	141048	141049
28152	45924	0	applied	\N	\N	\N	\N	141069	141069	141070
28152	45925	1	applied	\N	\N	\N	\N	141071	141071	141072
28152	45926	2	applied	\N	\N	\N	\N	141073	141073	141074
28152	45927	3	applied	\N	\N	\N	\N	141075	141075	141076
28152	45928	4	applied	\N	\N	\N	\N	141077	141077	141078
28155	45932	0	applied	\N	\N	\N	\N	141092	141092	141093
28155	45933	1	applied	\N	\N	\N	\N	141094	141094	141095
28155	45931	2	applied	\N	\N	\N	\N	141088	141088	141096
28158	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28158	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28158	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28158	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28158	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28158	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28158	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28160	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28160	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28160	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28160	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28160	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28160	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28160	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28163	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28163	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28163	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28163	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28163	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28163	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28163	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28164	45955	0	applied	\N	\N	\N	\N	141155	141155	141156
28164	45956	2	applied	\N	\N	\N	\N	141158	141158	141159
28164	45957	3	applied	\N	\N	\N	\N	141160	141160	141161
28166	45958	0	applied	\N	\N	\N	\N	141163	141163	141164
28166	45959	1	applied	\N	\N	\N	\N	141165	141165	141166
28172	45960	0	applied	\N	\N	\N	\N	141195	141195	141196
28172	45961	1	applied	\N	\N	\N	\N	141197	141197	141198
28172	45962	2	applied	\N	\N	\N	\N	141199	141199	141200
28172	45963	3	applied	\N	\N	\N	\N	141201	141201	141202
28172	45964	4	applied	\N	\N	\N	\N	141203	141203	141204
28172	45965	5	applied	\N	\N	\N	\N	141205	141205	141206
28172	45966	6	applied	\N	\N	\N	\N	141207	141207	141208
28174	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28174	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28177	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28177	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28179	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28179	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28181	45975	0	applied	\N	\N	\N	\N	141237	141237	141238
28181	45976	1	applied	\N	\N	\N	\N	141239	141239	141240
28185	45977	0	applied	\N	\N	\N	\N	141243	141243	141244
28185	45978	1	applied	\N	\N	\N	\N	141245	141245	141246
28185	45979	2	applied	\N	\N	\N	\N	141247	141247	141248
28188	45982	0	applied	\N	\N	\N	\N	141257	141257	141258
28188	45983	1	applied	\N	\N	\N	\N	141259	141259	141260
28195	45993	0	applied	\N	\N	\N	\N	141290	141290	141291
28195	45994	1	applied	\N	\N	\N	\N	141292	141292	141293
28195	45995	2	applied	\N	\N	\N	\N	141294	141294	141295
28198	46000	0	applied	\N	\N	\N	\N	141308	141308	141309
28198	46001	1	applied	\N	\N	\N	\N	141310	141310	141311
28198	46002	2	applied	\N	\N	\N	\N	141312	141312	141313
28200	46003	0	applied	\N	\N	\N	\N	141316	141316	141317
28104	45278	25	applied	\N	\N	\N	\N	139245	139245	139246
28104	45281	26	applied	\N	\N	\N	\N	139253	139253	139254
28104	45285	27	applied	\N	\N	\N	\N	139263	139263	139264
28104	45286	28	applied	\N	\N	\N	\N	139265	139265	139266
28104	45292	29	applied	\N	\N	\N	\N	139278	139278	139279
28104	45295	30	applied	\N	\N	\N	\N	139286	139286	139287
28104	45298	31	applied	\N	\N	\N	\N	139336	139336	139337
28104	45301	32	applied	\N	\N	\N	\N	139345	139345	139346
28104	45304	33	applied	\N	\N	\N	\N	139352	139352	139353
28104	45307	34	applied	\N	\N	\N	\N	139359	139359	139360
28104	45310	35	applied	\N	\N	\N	\N	139370	139370	139371
28104	45311	36	applied	\N	\N	\N	\N	139372	139372	139373
28104	45318	37	applied	\N	\N	\N	\N	139393	139393	139394
28104	45321	38	applied	\N	\N	\N	\N	139400	139400	139401
28104	45322	39	applied	\N	\N	\N	\N	139402	139402	139403
28104	45323	40	applied	\N	\N	\N	\N	139404	139404	139405
28104	45330	41	applied	\N	\N	\N	\N	139419	139419	139420
28104	45333	42	applied	\N	\N	\N	\N	139427	139427	139428
28104	45334	43	applied	\N	\N	\N	\N	139429	139429	139430
28104	45335	44	applied	\N	\N	\N	\N	139431	139431	139432
28104	45342	45	applied	\N	\N	\N	\N	139448	139448	139449
28104	45345	46	applied	\N	\N	\N	\N	139463	139463	139464
28104	45348	47	applied	\N	\N	\N	\N	139471	139471	139472
28104	45351	48	applied	\N	\N	\N	\N	139479	139479	139480
28104	45354	49	applied	\N	\N	\N	\N	139489	139489	139490
28104	45355	50	applied	\N	\N	\N	\N	139491	139491	139492
28104	45361	51	applied	\N	\N	\N	\N	139508	139508	139509
28104	45364	52	applied	\N	\N	\N	\N	139515	139515	139516
28104	45367	53	applied	\N	\N	\N	\N	139523	139523	139524
28104	45368	54	applied	\N	\N	\N	\N	139525	139525	139526
28104	45373	55	applied	\N	\N	\N	\N	139536	139536	139537
28104	45376	56	applied	\N	\N	\N	\N	139542	139542	139543
28104	45379	57	applied	\N	\N	\N	\N	139550	139550	139551
28104	45382	58	applied	\N	\N	\N	\N	139557	139557	139558
28104	45383	59	applied	\N	\N	\N	\N	139559	139559	139560
28104	45384	60	applied	\N	\N	\N	\N	139561	139561	139562
28104	45385	61	applied	\N	\N	\N	\N	139563	139563	139564
28104	45386	62	applied	\N	\N	\N	\N	139565	139565	139566
28104	45401	64	applied	\N	\N	\N	\N	139596	139596	139597
28104	45404	65	applied	\N	\N	\N	\N	139604	139604	139605
28104	45405	66	applied	\N	\N	\N	\N	139606	139606	139607
28104	45410	67	applied	\N	\N	\N	\N	139617	139617	139618
28104	45413	68	applied	\N	\N	\N	\N	139628	139628	139629
28104	45414	69	applied	\N	\N	\N	\N	139630	139630	139631
28104	45419	70	applied	\N	\N	\N	\N	139643	139643	139644
28104	45422	71	applied	\N	\N	\N	\N	139651	139651	139652
28104	45425	72	applied	\N	\N	\N	\N	139658	139658	139659
28104	45426	73	applied	\N	\N	\N	\N	139660	139660	139661
28104	45431	74	applied	\N	\N	\N	\N	139673	139673	139674
28104	45434	75	applied	\N	\N	\N	\N	139688	139688	139689
28104	45437	76	applied	\N	\N	\N	\N	139696	139696	139697
28104	45440	77	applied	\N	\N	\N	\N	139704	139704	139705
28104	45443	78	applied	\N	\N	\N	\N	139713	139713	139714
28104	45446	79	applied	\N	\N	\N	\N	139721	139721	139722
28104	45450	80	applied	\N	\N	\N	\N	139732	139732	139733
28104	45453	81	applied	\N	\N	\N	\N	139740	139740	139741
28104	45456	82	applied	\N	\N	\N	\N	139748	139748	139749
28104	45457	83	applied	\N	\N	\N	\N	139750	139750	139751
28104	45458	84	applied	\N	\N	\N	\N	139752	139752	139753
28104	45465	85	applied	\N	\N	\N	\N	139767	139767	139768
28104	45468	86	applied	\N	\N	\N	\N	139775	139775	139776
28104	45469	87	applied	\N	\N	\N	\N	139777	139777	139778
28104	45475	88	applied	\N	\N	\N	\N	139790	139790	139791
28104	45476	89	applied	\N	\N	\N	\N	139792	139792	139793
28104	45481	90	applied	\N	\N	\N	\N	139804	139804	139805
28104	45484	91	applied	\N	\N	\N	\N	139813	139813	139814
28104	45487	92	applied	\N	\N	\N	\N	139821	139821	139822
28104	45491	93	applied	\N	\N	\N	\N	139831	139831	139832
28104	45492	94	applied	\N	\N	\N	\N	139833	139833	139834
28104	45497	95	applied	\N	\N	\N	\N	139844	139844	139845
28104	45498	96	applied	\N	\N	\N	\N	139846	139846	139847
28104	45499	97	applied	\N	\N	\N	\N	139848	139848	139849
28104	45506	98	applied	\N	\N	\N	\N	139864	139864	139865
28104	45509	99	applied	\N	\N	\N	\N	139876	139876	139877
28104	45510	100	applied	\N	\N	\N	\N	139878	139878	139879
28104	45515	101	applied	\N	\N	\N	\N	139894	139894	139895
28104	45516	102	applied	\N	\N	\N	\N	139896	139896	139897
28104	45521	103	applied	\N	\N	\N	\N	139906	139906	139907
28104	45522	104	applied	\N	\N	\N	\N	139908	139908	139909
28104	45527	105	applied	\N	\N	\N	\N	139921	139921	139922
28104	45528	106	applied	\N	\N	\N	\N	139923	139923	139924
28104	45533	107	applied	\N	\N	\N	\N	139933	139933	139934
28104	45536	108	applied	\N	\N	\N	\N	139942	139942	139943
28104	45537	109	applied	\N	\N	\N	\N	139944	139944	139945
28104	45542	110	applied	\N	\N	\N	\N	139963	139963	139964
28104	45543	111	applied	\N	\N	\N	\N	139965	139965	139966
28104	45544	112	applied	\N	\N	\N	\N	139967	139967	139968
28104	45551	113	applied	\N	\N	\N	\N	139984	139984	139985
28104	45552	114	applied	\N	\N	\N	\N	139986	139986	139987
28104	45555	115	applied	\N	\N	\N	\N	139994	139994	139995
28104	45556	116	applied	\N	\N	\N	\N	139996	139996	139997
28104	45557	117	applied	\N	\N	\N	\N	139998	139998	139999
28104	45566	118	applied	\N	\N	\N	\N	140029	140029	140030
28104	45569	119	applied	\N	\N	\N	\N	140036	140036	140037
28104	45572	120	applied	\N	\N	\N	\N	140062	140062	140063
28104	45573	121	applied	\N	\N	\N	\N	140064	140064	140065
28104	45580	122	applied	\N	\N	\N	\N	140080	140080	140081
28104	45583	123	applied	\N	\N	\N	\N	140088	140088	140089
28104	45586	124	applied	\N	\N	\N	\N	140098	140098	140099
28104	45587	125	applied	\N	\N	\N	\N	140100	140100	140101
28106	45829	0	applied	\N	\N	\N	\N	140800	140800	140801
28106	45830	1	applied	\N	\N	\N	\N	140802	140802	140803
28106	45831	2	applied	\N	\N	\N	\N	140804	140804	140805
28106	45832	3	applied	\N	\N	\N	\N	140806	140806	140807
28106	45833	4	applied	\N	\N	\N	\N	140808	140808	140809
28106	45834	5	applied	\N	\N	\N	\N	140810	140810	140811
28106	45835	6	applied	\N	\N	\N	\N	140812	140812	140813
28107	45836	0	applied	\N	\N	\N	\N	140818	140818	140819
28107	45837	1	applied	\N	\N	\N	\N	140820	140820	140821
28107	45838	2	applied	\N	\N	\N	\N	140822	140822	140823
28110	45839	0	applied	\N	\N	\N	\N	140828	140828	140829
28110	45840	1	applied	\N	\N	\N	\N	140830	140830	140831
28110	45841	2	applied	\N	\N	\N	\N	140832	140832	140833
28110	45842	3	applied	\N	\N	\N	\N	140834	140834	140835
28110	45843	4	applied	\N	\N	\N	\N	140836	140836	140837
28110	45844	5	applied	\N	\N	\N	\N	140838	140838	140839
28110	45845	6	applied	\N	\N	\N	\N	140840	140840	140841
28113	45850	0	applied	\N	\N	\N	\N	140854	140854	140855
28113	45851	1	applied	\N	\N	\N	\N	140856	140856	140857
28113	45852	2	applied	\N	\N	\N	\N	140858	140858	140859
28113	45853	3	applied	\N	\N	\N	\N	140860	140860	140861
28113	45854	4	applied	\N	\N	\N	\N	140862	140862	140863
28113	45855	5	applied	\N	\N	\N	\N	140864	140864	140865
28113	45856	6	applied	\N	\N	\N	\N	140866	140866	140867
28116	45863	0	applied	\N	\N	\N	\N	140886	140886	140887
28116	45864	1	applied	\N	\N	\N	\N	140888	140888	140889
28116	45865	2	applied	\N	\N	\N	\N	140890	140890	140891
28119	45870	0	applied	\N	\N	\N	\N	140905	140905	140906
28119	45871	1	applied	\N	\N	\N	\N	140907	140907	140908
28119	45872	2	applied	\N	\N	\N	\N	140909	140909	140910
28128	45880	0	applied	\N	\N	\N	\N	140934	140934	140935
28131	45881	0	applied	\N	\N	\N	\N	140936	140936	140937
28131	45882	1	applied	\N	\N	\N	\N	140944	140944	140945
28137	45891	0	applied	\N	\N	\N	\N	140971	140971	140972
28137	45892	1	applied	\N	\N	\N	\N	140973	140973	140974
28140	45898	0	applied	\N	\N	\N	\N	140991	140991	140992
28140	45899	1	applied	\N	\N	\N	\N	140993	140993	140994
28143	45900	0	applied	\N	\N	\N	\N	141001	141001	141002
28143	45901	1	applied	\N	\N	\N	\N	141003	141003	141004
28143	45902	2	applied	\N	\N	\N	\N	141005	141005	111296
28143	45903	3	applied	\N	\N	\N	\N	141006	141006	141007
28143	45904	4	applied	\N	\N	\N	\N	141008	141008	141009
28143	45905	5	applied	\N	\N	\N	\N	141010	141010	141011
28148	45913	0	applied	\N	\N	\N	\N	141041	141041	141042
28148	45914	1	applied	\N	\N	\N	\N	141043	141043	141044
28151	45922	0	applied	\N	\N	\N	\N	141063	141063	141064
28151	45923	1	applied	\N	\N	\N	\N	141065	141065	141066
28154	45919	0	applied	\N	\N	\N	\N	141055	141055	141087
28154	45927	1	applied	\N	\N	\N	\N	141075	141075	140514
28154	45931	2	applied	\N	\N	\N	\N	141088	141088	141089
28157	45944	0	applied	\N	\N	\N	\N	141120	141120	141121
28157	45945	1	applied	\N	\N	\N	\N	141122	141122	141123
28157	45946	2	applied	\N	\N	\N	\N	141124	141124	141125
28157	45947	3	applied	\N	\N	\N	\N	141126	141126	141127
28159	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28159	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28159	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28159	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28159	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28159	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28159	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28161	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28161	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28161	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28161	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28161	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28161	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28161	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28162	45948	0	applied	\N	\N	\N	\N	141130	141130	141131
28162	45949	1	applied	\N	\N	\N	\N	141132	141132	141133
28162	45950	2	applied	\N	\N	\N	\N	141134	141134	141135
28162	45951	3	applied	\N	\N	\N	\N	141136	141136	141137
28162	45952	4	applied	\N	\N	\N	\N	141138	141138	141139
28162	45953	5	applied	\N	\N	\N	\N	141140	141140	141141
28162	45954	6	applied	\N	\N	\N	\N	141142	141142	141143
28170	45958	0	applied	\N	\N	\N	\N	141163	141163	141164
28170	45959	1	applied	\N	\N	\N	\N	141165	141165	141166
28173	45960	0	applied	\N	\N	\N	\N	141195	141195	141196
28173	45961	1	applied	\N	\N	\N	\N	141197	141197	141198
28173	45962	2	applied	\N	\N	\N	\N	141199	141199	141200
28173	45963	3	applied	\N	\N	\N	\N	141201	141201	141202
28173	45964	4	applied	\N	\N	\N	\N	141203	141203	141204
28173	45965	5	applied	\N	\N	\N	\N	141205	141205	141206
28173	45966	6	applied	\N	\N	\N	\N	141207	141207	141208
28175	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28175	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28178	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28178	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28182	45977	0	applied	\N	\N	\N	\N	141243	141243	141244
28182	45978	1	applied	\N	\N	\N	\N	141245	141245	141246
28182	45979	2	applied	\N	\N	\N	\N	141247	141247	141248
28189	45984	0	applied	\N	\N	\N	\N	141262	141262	141263
28189	45985	1	applied	\N	\N	\N	\N	141264	141264	141265
28189	45986	2	applied	\N	\N	\N	\N	141266	141266	141267
28189	45987	3	applied	\N	\N	\N	\N	141268	141268	141269
28189	45988	4	applied	\N	\N	\N	\N	141270	141270	141271
28191	45966	0	applied	\N	\N	\N	\N	141207	141207	140524
28191	45971	1	applied	\N	\N	\N	\N	141228	141228	141275
28191	45978	2	applied	\N	\N	\N	\N	141245	141245	140529
28191	45988	3	applied	\N	\N	\N	\N	141270	141270	141276
28196	45996	0	applied	\N	\N	\N	\N	141296	141296	141297
28196	45997	1	applied	\N	\N	\N	\N	141298	141298	141299
28201	46006	0	applied	\N	\N	\N	\N	141323	141323	141324
28203	46006	0	applied	\N	\N	\N	\N	141323	141323	141324
28206	46012	0	applied	\N	\N	\N	\N	141341	141341	141342
28206	46013	1	applied	\N	\N	\N	\N	141343	141343	141344
28208	46014	0	applied	\N	\N	\N	\N	141348	141348	141349
28208	46015	1	applied	\N	\N	\N	\N	141350	141350	141351
28215	46026	0	applied	\N	\N	\N	\N	141381	141381	140953
28215	46027	1	applied	\N	\N	\N	\N	141382	141382	141383
28215	46028	2	applied	\N	\N	\N	\N	141384	141384	141385
28218	46029	0	applied	\N	\N	\N	\N	141387	141387	141388
28218	46030	1	applied	\N	\N	\N	\N	141389	141389	140953
28218	46031	3	applied	\N	\N	\N	\N	141391	141391	141392
28220	46032	0	applied	\N	\N	\N	\N	141395	141395	141396
28220	46033	1	applied	\N	\N	\N	\N	141397	141397	141398
28222	46032	0	applied	\N	\N	\N	\N	141395	141395	141396
28222	46033	1	applied	\N	\N	\N	\N	141397	141397	141398
28224	46034	0	applied	\N	\N	\N	\N	141406	141406	141407
28224	46035	1	applied	\N	\N	\N	\N	141408	141408	141409
28224	46036	2	applied	\N	\N	\N	\N	141410	141410	141411
28227	46039	0	applied	\N	\N	\N	\N	141421	141421	141422
28227	46040	1	applied	\N	\N	\N	\N	141423	141423	141424
28229	46041	0	applied	\N	\N	\N	\N	141429	141429	141430
28229	46042	1	applied	\N	\N	\N	\N	141431	141431	141432
28229	46043	2	applied	\N	\N	\N	\N	141433	141433	141434
28232	46044	0	applied	\N	\N	\N	\N	141435	141435	141436
28232	46045	1	applied	\N	\N	\N	\N	141437	141437	141438
28232	46046	2	applied	\N	\N	\N	\N	141439	141439	141440
28232	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28232	46048	4	applied	\N	\N	\N	\N	141442	141442	141443
28232	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28234	46050	0	applied	\N	\N	\N	\N	141451	141451	141452
28234	46051	1	applied	\N	\N	\N	\N	141453	141453	141454
28234	46052	2	applied	\N	\N	\N	\N	141455	141455	141456
28237	46055	0	applied	\N	\N	\N	\N	141463	141463	141464
28237	46056	1	applied	\N	\N	\N	\N	141465	141465	141466
28241	46057	0	applied	\N	\N	\N	\N	141472	141472	141473
28241	46058	1	applied	\N	\N	\N	\N	141474	141474	141475
28139	45896	0	applied	\N	\N	\N	\N	140985	140985	140986
28139	45897	1	applied	\N	\N	\N	\N	140987	140987	140988
28141	45898	0	applied	\N	\N	\N	\N	140991	140991	140992
28141	45899	1	applied	\N	\N	\N	\N	140993	140993	140994
28145	45908	0	applied	\N	\N	\N	\N	141018	141018	141019
28145	45909	1	applied	\N	\N	\N	\N	141020	141020	141021
28145	45910	2	applied	\N	\N	\N	\N	141022	141022	141023
28146	45885	0	applied	\N	\N	1000000000	\N	140953	140953	140954
28146	45847	1	applied	\N	\N	1000000000	\N	140846	140846	140847
28146	45871	2	applied	\N	\N	\N	\N	140907	140907	140908
28146	45889	3	applied	\N	\N	1000000000	\N	140965	140965	140966
28146	45890	4	applied	\N	\N	1000000000	\N	140967	140967	140968
28146	45790	5	applied	\N	\N	\N	\N	140689	140689	141026
28146	45801	6	applied	\N	\N	\N	\N	140721	140721	141027
28146	45811	7	applied	\N	\N	\N	\N	140751	140751	140494
28146	45818	8	applied	\N	\N	\N	\N	140767	140767	141028
28146	45832	9	applied	\N	\N	\N	\N	140806	140806	140496
28146	45844	10	applied	\N	\N	\N	\N	140838	140838	141029
28146	45853	11	applied	\N	\N	\N	\N	140860	140860	140504
28146	45868	12	applied	\N	\N	\N	\N	140900	140900	141030
28146	45875	13	applied	\N	\N	\N	\N	140916	140916	141031
28146	45882	14	applied	\N	\N	\N	\N	140944	140944	140506
28146	45895	15	applied	\N	\N	\N	\N	140981	140981	141032
28146	45903	16	applied	\N	\N	\N	\N	141006	141006	140512
28146	45909	17	applied	\N	\N	\N	\N	141020	141020	141033
28147	45911	0	applied	\N	\N	\N	\N	141036	141036	141037
28147	45912	1	applied	\N	\N	\N	\N	141038	141038	141039
28150	45917	0	applied	\N	\N	\N	\N	141051	141051	141052
28150	45918	1	applied	\N	\N	\N	\N	141053	141053	141054
28150	45919	2	applied	\N	\N	\N	\N	141055	141055	141056
28150	45920	3	applied	\N	\N	\N	\N	141057	141057	141058
28150	45921	4	applied	\N	\N	\N	\N	141059	141059	141060
28153	45929	0	applied	\N	\N	\N	\N	141081	141081	141082
28153	45930	1	applied	\N	\N	\N	\N	141083	141083	141084
28156	45934	0	applied	\N	\N	\N	\N	141099	141099	141100
28156	45935	1	applied	\N	\N	\N	\N	141101	141101	141102
28156	45936	2	applied	\N	\N	\N	\N	141103	141103	141104
28156	45937	3	applied	\N	\N	\N	\N	141105	141105	141106
28156	45938	4	applied	\N	\N	\N	\N	141107	141107	141108
28156	45939	5	applied	\N	\N	\N	\N	141109	141109	141110
28156	45940	6	applied	\N	\N	\N	\N	141111	141111	141112
28156	45941	7	applied	\N	\N	\N	\N	141113	141113	13857
28156	45942	8	applied	\N	\N	\N	\N	141114	141114	141115
28156	45943	9	applied	\N	\N	\N	\N	141116	141116	141117
28165	45958	0	applied	\N	\N	\N	\N	141163	141163	141164
28165	45959	1	applied	\N	\N	\N	\N	141165	141165	141166
28167	45958	0	applied	\N	\N	\N	\N	141163	141163	141164
28167	45959	1	applied	\N	\N	\N	\N	141165	141165	141166
28169	45885	0	applied	\N	\N	1000000000	\N	140953	140953	140954
28169	45847	1	applied	\N	\N	1000000000	\N	140846	140846	140847
28169	45871	2	applied	\N	\N	\N	\N	140907	140907	140908
28169	45749	3	applied	\N	\N	1000000000	\N	140579	140579	140580
28169	45889	4	applied	\N	\N	1000000000	\N	140965	140965	140966
28169	45890	5	applied	\N	\N	1000000000	\N	140967	140967	140968
28169	45677	6	applied	\N	\N	\N	\N	140387	140387	132508
28169	45941	7	applied	\N	\N	\N	\N	141113	141113	13857
28169	45790	8	applied	\N	\N	\N	\N	140689	140689	141174
28169	45801	9	applied	\N	\N	\N	\N	140721	140721	141175
28169	45811	10	applied	\N	\N	\N	\N	140751	140751	140161
28169	45818	11	applied	\N	\N	\N	\N	140767	140767	141176
28169	45832	12	applied	\N	\N	\N	\N	140806	140806	140163
28169	45844	13	applied	\N	\N	\N	\N	140838	140838	141177
28169	45853	14	applied	\N	\N	\N	\N	140860	140860	141178
28169	45868	15	applied	\N	\N	\N	\N	140900	140900	140176
28169	45875	16	applied	\N	\N	\N	\N	140916	140916	141179
28169	45882	17	applied	\N	\N	\N	\N	140944	140944	140178
28169	45895	18	applied	\N	\N	\N	\N	140981	140981	141180
28169	45903	19	applied	\N	\N	\N	\N	141006	141006	140184
28169	45909	20	applied	\N	\N	\N	\N	141020	141020	141181
28169	45919	21	applied	\N	\N	\N	\N	141055	141055	141182
28169	45927	22	applied	\N	\N	\N	\N	141075	141075	140186
28169	45931	23	applied	\N	\N	\N	\N	141088	141088	141183
28169	45938	24	applied	\N	\N	\N	\N	141107	141107	141184
28169	45954	25	applied	\N	\N	\N	\N	141142	141142	140190
28169	45957	26	applied	\N	\N	\N	\N	141160	141160	141185
28171	45938	0	applied	\N	\N	\N	\N	141107	141107	141191
28171	45954	1	applied	\N	\N	\N	\N	141142	141142	140522
28171	45941	2	applied	\N	\N	\N	\N	141113	141113	13857
28171	45957	3	applied	\N	\N	\N	\N	141160	141160	141192
28176	45967	0	applied	\N	\N	\N	\N	141212	141212	141213
28176	45968	1	applied	\N	\N	\N	\N	141214	141214	141215
28180	45969	0	applied	\N	\N	\N	\N	141224	141224	141225
28180	45970	1	applied	\N	\N	\N	\N	141226	141226	141227
28180	45971	2	applied	\N	\N	\N	\N	141228	141228	141229
28180	45972	3	applied	\N	\N	\N	\N	141230	141230	141231
28180	45973	4	applied	\N	\N	\N	\N	141232	141232	141233
28180	45974	5	applied	\N	\N	\N	\N	141234	141234	141235
28183	45977	0	applied	\N	\N	\N	\N	141243	141243	141244
28183	45978	1	applied	\N	\N	\N	\N	141245	141245	141246
28183	45979	2	applied	\N	\N	\N	\N	141247	141247	141248
28184	45977	0	applied	\N	\N	\N	\N	141243	141243	141244
28184	45978	1	applied	\N	\N	\N	\N	141245	141245	141246
28184	45979	2	applied	\N	\N	\N	\N	141247	141247	141248
28186	45977	0	applied	\N	\N	\N	\N	141243	141243	141244
28186	45978	1	applied	\N	\N	\N	\N	141245	141245	141246
28186	45979	2	applied	\N	\N	\N	\N	141247	141247	141248
28187	45980	0	applied	\N	\N	\N	\N	141253	141253	141254
28187	45981	1	applied	\N	\N	\N	\N	141255	141255	141256
28190	45984	0	applied	\N	\N	\N	\N	141262	141262	141263
28190	45985	1	applied	\N	\N	\N	\N	141264	141264	141265
28190	45986	2	applied	\N	\N	\N	\N	141266	141266	141267
28190	45987	3	applied	\N	\N	\N	\N	141268	141268	141269
28190	45988	4	applied	\N	\N	\N	\N	141270	141270	141271
28192	45989	0	applied	\N	\N	\N	\N	141279	141279	141280
28192	45990	1	applied	\N	\N	\N	\N	141281	141281	141282
28194	45991	0	applied	\N	\N	\N	\N	141284	141284	141285
28194	45992	1	applied	\N	\N	\N	\N	141286	141286	141287
28197	45998	0	applied	\N	\N	\N	\N	141302	141302	141303
28197	45999	1	applied	\N	\N	\N	\N	141304	141304	141305
28199	46003	0	applied	\N	\N	\N	\N	141316	141316	141317
28199	46004	1	applied	\N	\N	\N	\N	141318	141318	141319
28199	46005	2	applied	\N	\N	\N	\N	141320	141320	141321
28202	46006	0	applied	\N	\N	\N	\N	141323	141323	141324
28204	46007	0	applied	\N	\N	\N	\N	141330	141330	141331
28204	46008	1	applied	\N	\N	\N	\N	141332	141332	141333
28204	46009	2	applied	\N	\N	\N	\N	141334	141334	141335
28204	46010	3	applied	\N	\N	\N	\N	141336	141336	141337
28204	46011	4	applied	\N	\N	\N	\N	141338	141338	141339
28207	46012	0	applied	\N	\N	\N	\N	141341	141341	141342
28200	46005	1	applied	\N	\N	\N	\N	141320	141320	141321
28205	46012	0	applied	\N	\N	\N	\N	141341	141341	141342
28205	46013	1	applied	\N	\N	\N	\N	141343	141343	141344
28210	46016	0	applied	\N	\N	\N	\N	141353	141353	141354
28210	46017	1	applied	\N	\N	\N	\N	141355	141355	141356
28210	46018	2	applied	\N	\N	\N	\N	141357	141357	141358
28212	46021	0	applied	\N	\N	\N	\N	141367	141367	141368
28212	46022	1	applied	\N	\N	\N	\N	141369	141369	141370
28219	46032	0	applied	\N	\N	\N	\N	141395	141395	141396
28219	46033	1	applied	\N	\N	\N	\N	141397	141397	141398
28226	46037	0	applied	\N	\N	\N	\N	141416	141416	141417
28226	46038	1	applied	\N	\N	\N	\N	141418	141418	141419
28236	46055	0	applied	\N	\N	\N	\N	141463	141463	141464
28236	46056	1	applied	\N	\N	\N	\N	141465	141465	141466
28239	46055	0	applied	\N	\N	\N	\N	141463	141463	141464
28239	46056	1	applied	\N	\N	\N	\N	141465	141465	141466
28240	46057	0	applied	\N	\N	\N	\N	141472	141472	141473
28240	46058	1	applied	\N	\N	\N	\N	141474	141474	141475
28245	46064	0	applied	\N	\N	\N	\N	141494	141494	141495
28245	46065	1	applied	\N	\N	\N	\N	141496	141496	141497
28248	46069	0	applied	\N	\N	\N	\N	141507	141507	141508
28248	46070	1	applied	\N	\N	\N	\N	141509	141509	141509
28248	46071	2	applied	\N	\N	\N	\N	141510	141510	141511
28252	46072	0	applied	\N	\N	\N	\N	141535	141535	141536
28252	46073	1	applied	\N	\N	\N	\N	141537	141537	141538
28252	46074	2	applied	\N	\N	\N	\N	141539	141539	141540
28252	46075	3	applied	\N	\N	\N	\N	141541	141541	141542
28252	46076	4	applied	\N	\N	1000000000	\N	141543	141543	141544
28252	46077	5	applied	\N	\N	\N	\N	141545	141545	141546
28258	46082	0	applied	\N	\N	\N	\N	141560	141560	141561
28258	46083	1	applied	\N	\N	\N	\N	141562	141562	141563
28260	46084	0	applied	\N	\N	\N	\N	141568	141568	141569
28260	46085	1	applied	\N	\N	\N	\N	141570	141570	141571
28260	46086	2	applied	\N	\N	\N	\N	141572	141572	141573
28262	46084	0	applied	\N	\N	\N	\N	141568	141568	141569
28262	46085	1	applied	\N	\N	\N	\N	141570	141570	141571
28262	46086	2	applied	\N	\N	\N	\N	141572	141572	141573
28265	46089	0	applied	\N	\N	\N	\N	141584	141584	141585
28265	46090	1	applied	\N	\N	\N	\N	141586	141586	141587
28274	46101	0	applied	\N	\N	\N	\N	141628	141628	141629
28274	46102	1	applied	\N	\N	\N	\N	141630	141630	141631
28278	46103	0	applied	\N	\N	\N	\N	141636	141636	141637
28278	46104	1	applied	\N	\N	\N	\N	141638	141638	141639
28280	46103	0	applied	\N	\N	\N	\N	141636	141636	141637
28280	46104	1	applied	\N	\N	\N	\N	141638	141638	141639
28283	46108	0	applied	\N	\N	\N	\N	141649	141649	141650
28283	46109	1	applied	\N	\N	\N	\N	141651	141651	141652
28283	46110	2	applied	\N	\N	\N	\N	141653	141653	141654
28285	46113	0	applied	\N	\N	\N	\N	141665	141665	141666
28285	46114	1	applied	\N	\N	\N	\N	141667	141667	141668
28291	46115	0	applied	\N	\N	\N	\N	141677	141677	141678
28291	46116	1	applied	\N	\N	\N	\N	141679	141679	141680
28291	46117	2	applied	\N	\N	\N	\N	141681	141681	141682
28294	46118	0	applied	\N	\N	\N	\N	141683	141683	141684
28294	46119	1	applied	\N	\N	\N	\N	141685	141685	141686
28296	46120	0	applied	\N	\N	\N	\N	141691	141691	141692
28296	46121	1	applied	\N	\N	\N	\N	141693	141693	141694
28296	46122	2	applied	\N	\N	\N	\N	141695	141695	141696
28296	46123	3	applied	\N	\N	\N	\N	141697	141697	141698
28296	46124	4	applied	\N	\N	\N	\N	141699	141699	141700
28301	46132	0	applied	\N	\N	\N	\N	141721	141721	141722
28301	46133	1	applied	\N	\N	\N	\N	141723	141723	141724
28301	46134	2	applied	\N	\N	\N	\N	141725	141725	141726
28301	46135	3	applied	\N	\N	\N	\N	141727	141727	141728
28301	46136	4	applied	\N	\N	\N	\N	141729	141729	111296
28301	46137	5	applied	\N	\N	\N	\N	141730	141730	141731
28310	46160	0	applied	\N	\N	\N	\N	141786	141786	141787
28310	46161	1	applied	\N	\N	\N	\N	141788	141788	141789
28310	46162	2	applied	\N	\N	\N	\N	141790	141790	141791
28310	46163	3	applied	\N	\N	\N	\N	141792	141792	141793
28310	46164	4	applied	\N	\N	\N	\N	141794	141794	141795
28315	46167	0	applied	\N	\N	\N	\N	141804	141804	141805
28315	46168	1	applied	\N	\N	\N	\N	141806	141806	141807
28317	46169	0	applied	\N	\N	\N	\N	141831	141831	141832
28317	46170	1	applied	\N	\N	\N	\N	141833	141833	132657
28317	46171	2	applied	\N	\N	\N	\N	141834	141834	141835
28317	46172	3	applied	\N	\N	\N	\N	141836	141836	141837
28317	46173	4	applied	\N	\N	\N	\N	141838	141838	141839
28320	46106	0	applied	\N	\N	\N	\N	141644	141644	141644
28320	46136	1	applied	\N	\N	\N	\N	141729	141729	111296
28320	46127	2	applied	\N	\N	\N	\N	141707	141707	141707
28325	46187	0	applied	\N	\N	\N	\N	141878	141878	141879
28325	46188	1	applied	\N	\N	\N	\N	141880	141880	141881
28330	46191	0	applied	\N	\N	\N	\N	141892	141892	141893
28330	46192	1	applied	\N	\N	\N	\N	141894	141894	141895
28330	46193	2	applied	\N	\N	\N	\N	141896	141896	141897
28330	46194	3	applied	\N	\N	\N	\N	141898	141898	141899
28330	46195	4	applied	\N	\N	\N	\N	141900	141900	141901
28330	46196	5	applied	\N	\N	\N	\N	141902	141902	141903
28332	46191	0	applied	\N	\N	\N	\N	141892	141892	141893
28332	46192	1	applied	\N	\N	\N	\N	141894	141894	141895
28332	46193	2	applied	\N	\N	\N	\N	141896	141896	141897
28332	46194	3	applied	\N	\N	\N	\N	141898	141898	141899
28332	46195	4	applied	\N	\N	\N	\N	141900	141900	141901
28332	46196	5	applied	\N	\N	\N	\N	141902	141902	141903
28335	46197	0	applied	\N	\N	\N	\N	141910	141910	141911
28335	46198	1	applied	\N	\N	\N	\N	141912	141912	141913
28337	46199	0	applied	\N	\N	\N	\N	141917	141917	141918
28337	46200	1	applied	\N	\N	\N	\N	141919	141919	141920
28337	46201	2	applied	\N	\N	\N	\N	141921	141921	141922
28337	46202	3	applied	\N	\N	\N	\N	141923	141923	141924
28337	46203	4	applied	\N	\N	\N	\N	141925	141925	141926
28337	46204	5	applied	\N	\N	\N	\N	141927	141927	141928
28337	46205	6	applied	\N	\N	\N	\N	141929	141929	141930
28337	46206	7	applied	\N	\N	\N	\N	141931	141931	141932
28348	46223	0	applied	\N	\N	1000000000	\N	141978	141978	141979
28348	46106	1	applied	\N	\N	\N	\N	141644	141644	141644
28348	46183	2	applied	\N	\N	\N	\N	141867	141867	141868
28348	46224	3	applied	\N	\N	1000000000	\N	141980	141980	141981
28348	46136	4	applied	\N	\N	\N	\N	141729	141729	111296
28348	46127	5	applied	\N	\N	\N	\N	141707	141707	141707
28348	46100	6	applied	\N	\N	\N	\N	141624	141624	140553
28348	46109	7	applied	\N	\N	\N	\N	141651	141651	141992
28348	46116	8	applied	\N	\N	\N	\N	141679	141679	141993
28348	46123	9	applied	\N	\N	\N	\N	141697	141697	140555
28348	46135	10	applied	\N	\N	\N	\N	141727	141727	141994
28348	46141	11	applied	\N	\N	\N	\N	141742	141742	140562
28348	46148	12	applied	\N	\N	\N	\N	141758	141758	141995
28348	46155	13	applied	\N	\N	\N	\N	141775	141775	140564
28207	46013	1	applied	\N	\N	\N	\N	141343	141343	141344
28209	46016	0	applied	\N	\N	\N	\N	141353	141353	141354
28209	46017	1	applied	\N	\N	\N	\N	141355	141355	141356
28209	46018	2	applied	\N	\N	\N	\N	141357	141357	141358
28214	46023	0	applied	\N	\N	\N	\N	141373	141373	141374
28214	46024	1	applied	\N	\N	\N	\N	141375	141375	141376
28214	46025	2	applied	\N	\N	\N	\N	141377	141377	141378
28217	46029	0	applied	\N	\N	\N	\N	141387	141387	141388
28217	46030	1	applied	\N	\N	\N	\N	141389	141389	140953
28217	46031	3	applied	\N	\N	\N	\N	141391	141391	141392
28221	46032	0	applied	\N	\N	\N	\N	141395	141395	141396
28221	46033	1	applied	\N	\N	\N	\N	141397	141397	141398
28228	46039	0	applied	\N	\N	\N	\N	141421	141421	141422
28228	46040	1	applied	\N	\N	\N	\N	141423	141423	141424
28231	46044	0	applied	\N	\N	\N	\N	141435	141435	141436
28231	46045	1	applied	\N	\N	\N	\N	141437	141437	141438
28231	46046	2	applied	\N	\N	\N	\N	141439	141439	141440
28231	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28231	46048	4	applied	\N	\N	\N	\N	141442	141442	141443
28231	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28238	46026	0	applied	\N	\N	\N	\N	141381	141381	140953
28238	46030	1	applied	\N	\N	\N	\N	141389	141389	140953
28238	46047	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28238	46049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28242	46059	0	applied	\N	\N	\N	\N	141478	141478	141479
28242	46060	1	applied	\N	\N	\N	\N	141480	141480	141481
28242	46061	2	applied	\N	\N	\N	\N	141482	141482	141483
28247	46069	0	applied	\N	\N	\N	\N	141507	141507	141508
28247	46070	1	applied	\N	\N	\N	\N	141509	141509	141509
28247	46071	2	applied	\N	\N	\N	\N	141510	141510	141511
28249	46069	0	applied	\N	\N	\N	\N	141507	141507	141508
28249	46070	1	applied	\N	\N	\N	\N	141509	141509	141509
28249	46071	2	applied	\N	\N	\N	\N	141510	141510	141511
28254	46080	0	applied	\N	\N	\N	\N	141554	141554	141555
28254	46081	1	applied	\N	\N	\N	\N	141556	141556	141557
28256	46082	0	applied	\N	\N	\N	\N	141560	141560	141561
28256	46083	1	applied	\N	\N	\N	\N	141562	141562	141563
28259	46082	0	applied	\N	\N	\N	\N	141560	141560	141561
28259	46083	1	applied	\N	\N	\N	\N	141562	141562	141563
28261	46084	0	applied	\N	\N	\N	\N	141568	141568	141569
28261	46085	1	applied	\N	\N	\N	\N	141570	141570	141571
28261	46086	2	applied	\N	\N	\N	\N	141572	141572	141573
28267	46091	0	applied	\N	\N	\N	\N	141592	141592	141593
28267	46092	1	applied	\N	\N	\N	\N	141594	141594	141595
28267	46093	2	applied	\N	\N	\N	\N	141596	141596	141597
28272	46098	0	applied	\N	\N	\N	\N	141620	141620	141621
28272	46099	1	applied	\N	\N	\N	\N	141622	141622	141623
28272	46100	2	applied	\N	\N	\N	\N	141624	141624	141625
28279	46103	0	applied	\N	\N	\N	\N	141636	141636	141637
28279	46104	1	applied	\N	\N	\N	\N	141638	141638	141639
28286	46113	0	applied	\N	\N	\N	\N	141665	141665	141666
28286	46114	1	applied	\N	\N	\N	\N	141667	141667	141668
28288	46113	0	applied	\N	\N	\N	\N	141665	141665	141666
28288	46114	1	applied	\N	\N	\N	\N	141667	141667	141668
28292	46118	0	applied	\N	\N	\N	\N	141683	141683	141684
28292	46119	1	applied	\N	\N	\N	\N	141685	141685	141686
28297	46120	0	applied	\N	\N	\N	\N	141691	141691	141692
28297	46121	1	applied	\N	\N	\N	\N	141693	141693	141694
28297	46122	2	applied	\N	\N	\N	\N	141695	141695	141696
28297	46123	3	applied	\N	\N	\N	\N	141697	141697	141698
28297	46124	4	applied	\N	\N	\N	\N	141699	141699	141700
28299	46130	0	applied	\N	\N	\N	\N	141713	141713	141714
28299	46131	1	applied	\N	\N	\N	\N	141715	141715	141716
28304	46140	0	applied	\N	\N	\N	\N	141740	141740	141741
28304	46141	1	applied	\N	\N	\N	\N	141742	141742	141743
28304	46142	2	applied	\N	\N	\N	\N	141744	141744	141745
28305	46143	0	applied	\N	\N	\N	\N	141746	141746	141747
28305	46144	1	applied	\N	\N	\N	\N	141748	141748	141749
28305	46145	2	applied	\N	\N	\N	\N	141750	141750	141751
28305	46146	3	applied	\N	\N	\N	\N	141752	141752	141753
28307	46147	0	applied	\N	\N	\N	\N	141756	141756	141757
28307	46148	1	applied	\N	\N	\N	\N	141758	141758	141759
28307	46149	2	applied	\N	\N	\N	\N	141760	141760	141761
28311	46165	0	applied	\N	\N	\N	\N	141798	141798	141799
28311	46166	1	applied	\N	\N	\N	\N	141800	141800	141801
28313	46167	0	applied	\N	\N	\N	\N	141804	141804	141805
28313	46168	1	applied	\N	\N	\N	\N	141806	141806	141807
28318	46174	0	applied	\N	\N	\N	\N	141842	141842	141843
28318	46175	1	applied	\N	\N	\N	\N	141844	141844	141845
28323	46180	0	applied	\N	\N	\N	\N	141861	141861	141862
28323	46181	1	applied	\N	\N	\N	\N	141863	141863	141864
28323	46182	2	applied	\N	\N	\N	\N	141865	141865	141866
28323	46183	3	applied	\N	\N	\N	\N	141867	141867	141868
28323	46184	5	applied	\N	\N	\N	\N	141870	141870	141871
28323	46185	6	applied	\N	\N	\N	\N	141872	141872	141873
28323	46186	7	applied	\N	\N	\N	\N	141874	141874	141875
28326	46187	0	applied	\N	\N	\N	\N	141878	141878	141879
28326	46188	1	applied	\N	\N	\N	\N	141880	141880	141881
28331	46191	0	applied	\N	\N	\N	\N	141892	141892	141893
28331	46192	1	applied	\N	\N	\N	\N	141894	141894	141895
28331	46193	2	applied	\N	\N	\N	\N	141896	141896	141897
28331	46194	3	applied	\N	\N	\N	\N	141898	141898	141899
28331	46195	4	applied	\N	\N	\N	\N	141900	141900	141901
28331	46196	5	applied	\N	\N	\N	\N	141902	141902	141903
28338	46207	0	applied	\N	\N	\N	\N	141936	141936	141937
28338	46208	1	applied	\N	\N	\N	\N	141938	141938	141939
28340	46209	0	applied	\N	\N	\N	\N	141940	141940	141941
28340	46210	1	applied	\N	\N	\N	\N	141942	141942	141943
28341	46211	0	applied	\N	\N	\N	\N	141946	141946	141947
28341	46212	1	applied	\N	\N	\N	\N	141948	141948	141949
28341	46213	2	applied	\N	\N	\N	\N	141950	141950	141951
28341	46214	3	applied	\N	\N	\N	\N	141952	141952	141953
28341	46215	4	applied	\N	\N	\N	\N	141954	141954	141955
28341	46216	5	applied	\N	\N	\N	\N	141956	141956	141957
28341	46217	6	applied	\N	\N	\N	\N	141958	141958	141959
28341	46218	7	applied	\N	\N	\N	\N	141960	141960	141961
28343	46211	0	applied	\N	\N	\N	\N	141946	141946	141947
28343	46212	1	applied	\N	\N	\N	\N	141948	141948	141949
28343	46213	2	applied	\N	\N	\N	\N	141950	141950	141951
28343	46214	3	applied	\N	\N	\N	\N	141952	141952	141953
28343	46215	4	applied	\N	\N	\N	\N	141954	141954	141955
28343	46216	5	applied	\N	\N	\N	\N	141956	141956	141957
28343	46217	6	applied	\N	\N	\N	\N	141958	141958	141959
28343	46218	7	applied	\N	\N	\N	\N	141960	141960	141961
28346	46221	0	applied	\N	\N	\N	\N	141974	141974	141975
28346	46222	1	applied	\N	\N	\N	\N	141976	141976	141977
28346	46223	2	applied	\N	\N	1000000000	\N	141978	141978	141979
28346	46224	3	applied	\N	\N	1000000000	\N	141980	141980	141981
28211	46019	0	applied	\N	\N	\N	\N	141361	141361	141362
28211	46020	1	applied	\N	\N	\N	\N	141363	141363	141364
28213	46021	0	applied	\N	\N	\N	\N	141367	141367	141368
28213	46022	1	applied	\N	\N	\N	\N	141369	141369	141370
28216	46029	0	applied	\N	\N	\N	\N	141387	141387	141388
28216	46030	1	applied	\N	\N	\N	\N	141389	141389	140953
28216	46031	3	applied	\N	\N	\N	\N	141391	141391	141392
28225	46026	0	applied	\N	\N	\N	\N	141381	141381	140953
28225	46030	1	applied	\N	\N	\N	\N	141389	141389	140953
28230	46044	0	applied	\N	\N	\N	\N	141435	141435	141436
28230	46045	1	applied	\N	\N	\N	\N	141437	141437	141438
28230	46046	2	applied	\N	\N	\N	\N	141439	141439	141440
28230	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28230	46048	4	applied	\N	\N	\N	\N	141442	141442	141443
28230	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28233	46044	0	applied	\N	\N	\N	\N	141435	141435	141436
28233	46045	1	applied	\N	\N	\N	\N	141437	141437	141438
28233	46046	2	applied	\N	\N	\N	\N	141439	141439	141440
28233	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28233	46048	4	applied	\N	\N	\N	\N	141442	141442	141443
28233	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28235	46053	0	applied	\N	\N	\N	\N	141457	141457	141458
28235	46054	1	applied	\N	\N	\N	\N	141459	141459	141460
28244	46062	0	applied	\N	\N	\N	\N	141486	141486	141487
28244	46063	1	applied	\N	\N	\N	\N	141488	141488	141489
28246	46066	0	applied	\N	\N	\N	\N	141499	141499	141500
28246	46067	1	applied	\N	\N	\N	\N	141501	141501	141502
28246	46068	2	applied	\N	\N	\N	\N	141503	141503	141504
28251	46072	0	applied	\N	\N	\N	\N	141535	141535	141536
28251	46073	1	applied	\N	\N	\N	\N	141537	141537	141538
28251	46074	2	applied	\N	\N	\N	\N	141539	141539	141540
28251	46075	3	applied	\N	\N	\N	\N	141541	141541	141542
28251	46076	4	applied	\N	\N	1000000000	\N	141543	141543	141544
28251	46077	5	applied	\N	\N	\N	\N	141545	141545	141546
28253	46078	0	applied	\N	\N	\N	\N	141550	141550	141551
28253	46079	1	applied	\N	\N	\N	\N	141552	141552	141553
28255	46080	0	applied	\N	\N	\N	\N	141554	141554	141555
28255	46081	1	applied	\N	\N	\N	\N	141556	141556	141557
28257	46082	0	applied	\N	\N	\N	\N	141560	141560	141561
28257	46083	1	applied	\N	\N	\N	\N	141562	141562	141563
28264	46089	0	applied	\N	\N	\N	\N	141584	141584	141585
28264	46090	1	applied	\N	\N	\N	\N	141586	141586	141587
28269	46094	0	applied	\N	\N	\N	\N	141610	141610	141611
28269	46095	1	applied	\N	\N	\N	\N	141612	141612	141613
28271	46096	0	applied	\N	\N	\N	\N	141614	141614	141615
28271	46097	1	applied	\N	\N	\N	\N	141616	141616	141617
28273	46101	0	applied	\N	\N	\N	\N	141628	141628	141629
28273	46102	1	applied	\N	\N	\N	\N	141630	141630	141631
28276	46101	0	applied	\N	\N	\N	\N	141628	141628	141629
28276	46102	1	applied	\N	\N	\N	\N	141630	141630	141631
28282	46108	0	applied	\N	\N	\N	\N	141649	141649	141650
28282	46109	1	applied	\N	\N	\N	\N	141651	141651	141652
28282	46110	2	applied	\N	\N	\N	\N	141653	141653	141654
28284	46111	0	applied	\N	\N	\N	\N	141659	141659	141660
28284	46112	1	applied	\N	\N	\N	\N	141661	141661	141662
28287	46113	0	applied	\N	\N	\N	\N	141665	141665	141666
28287	46114	1	applied	\N	\N	\N	\N	141667	141667	141668
28295	46118	0	applied	\N	\N	\N	\N	141683	141683	141684
28295	46119	1	applied	\N	\N	\N	\N	141685	141685	141686
28298	46125	0	applied	\N	\N	\N	\N	141703	141703	141704
28298	46126	1	applied	\N	\N	\N	\N	141705	141705	141706
28298	46127	2	applied	\N	\N	\N	\N	141707	141707	141707
28298	46128	3	applied	\N	\N	\N	\N	141708	141708	141709
28298	46129	4	applied	\N	\N	\N	\N	141710	141710	141711
28300	46130	0	applied	\N	\N	\N	\N	141713	141713	141714
28300	46131	1	applied	\N	\N	\N	\N	141715	141715	141716
28303	46138	0	applied	\N	\N	\N	\N	141734	141734	141735
28303	46139	1	applied	\N	\N	\N	\N	141736	141736	141737
28308	46147	0	applied	\N	\N	\N	\N	141756	141756	141757
28308	46148	1	applied	\N	\N	\N	\N	141758	141758	141759
28309	46150	0	applied	\N	\N	\N	\N	141765	141765	141766
28309	46151	1	applied	\N	\N	\N	\N	141767	141767	141768
28309	46152	2	applied	\N	\N	\N	\N	141769	141769	141770
28309	46153	3	applied	\N	\N	\N	\N	141771	141771	141772
28309	46154	4	applied	\N	\N	\N	\N	141773	141773	141774
28309	46149	5	applied	\N	\N	\N	\N	141760	141760	141761
28309	46155	6	applied	\N	\N	\N	\N	141775	141775	141776
28309	46156	7	applied	\N	\N	\N	\N	141777	141777	141778
28309	46157	8	applied	\N	\N	\N	\N	141779	141779	141780
28309	46158	9	applied	\N	\N	\N	\N	141781	141781	141782
28309	46159	10	applied	\N	\N	\N	\N	141783	141783	141784
28314	46115	0	applied	\N	\N	\N	\N	141677	141677	141678
28314	46118	1	applied	\N	\N	\N	\N	141683	141683	141684
28314	46120	2	applied	\N	\N	\N	\N	141691	141691	141692
28314	46121	3	applied	\N	\N	\N	\N	141693	141693	141694
28314	46125	4	applied	\N	\N	\N	\N	141703	141703	141704
28314	46126	5	applied	\N	\N	\N	\N	141705	141705	141706
28314	46130	6	applied	\N	\N	\N	\N	141713	141713	141714
28314	46132	7	applied	\N	\N	\N	\N	141721	141721	141722
28314	46133	8	applied	\N	\N	\N	\N	141723	141723	141724
28314	46138	9	applied	\N	\N	\N	\N	141734	141734	141735
28314	46140	10	applied	\N	\N	\N	\N	141740	141740	141741
28314	46143	11	applied	\N	\N	\N	\N	141746	141746	141747
28314	46144	12	applied	\N	\N	\N	\N	141748	141748	141749
28314	46147	13	applied	\N	\N	\N	\N	141756	141756	141757
28314	46150	14	applied	\N	\N	\N	\N	141765	141765	141766
28314	46151	15	applied	\N	\N	\N	\N	141767	141767	141768
28314	46152	16	applied	\N	\N	\N	\N	141769	141769	141770
28314	46153	17	applied	\N	\N	\N	\N	141771	141771	141772
28314	46154	18	applied	\N	\N	\N	\N	141773	141773	141774
28314	46160	19	applied	\N	\N	\N	\N	141786	141786	141787
28314	46161	20	applied	\N	\N	\N	\N	141788	141788	141789
28314	46165	21	applied	\N	\N	\N	\N	141798	141798	141799
28314	46167	22	applied	\N	\N	\N	\N	141804	141804	141805
28314	46116	23	applied	\N	\N	\N	\N	141679	141679	141680
28314	46123	24	applied	\N	\N	\N	\N	141697	141697	141810
28314	46135	25	applied	\N	\N	\N	\N	141727	141727	141811
28314	46136	26	applied	\N	\N	\N	\N	141729	141729	111296
28314	46127	27	applied	\N	\N	\N	\N	141707	141707	141707
28314	46117	28	applied	\N	\N	\N	\N	141681	141681	141812
28314	46119	29	applied	\N	\N	\N	\N	141685	141685	141813
28314	46122	30	applied	\N	\N	\N	\N	141695	141695	141814
28314	46124	31	applied	\N	\N	\N	\N	141699	141699	141815
28314	46141	32	applied	\N	\N	\N	\N	141742	141742	141816
28314	46148	33	applied	\N	\N	\N	\N	141758	141758	141709
28314	46155	34	applied	\N	\N	\N	\N	141775	141775	141817
28314	46162	35	applied	\N	\N	\N	\N	141790	141790	141818
28314	46128	36	applied	\N	\N	\N	\N	141708	141708	141819
28243	46062	0	applied	\N	\N	\N	\N	141486	141486	141487
28243	46063	1	applied	\N	\N	\N	\N	141488	141488	141489
28250	45423	0	applied	\N	\N	\N	\N	139653	139653	139654
28250	45447	1	applied	\N	\N	\N	\N	139723	139723	139724
28250	45885	2	applied	\N	\N	1000000000	\N	140953	140953	140954
28250	45847	3	applied	\N	\N	1000000000	\N	140846	140846	140847
28250	45871	4	applied	\N	\N	\N	\N	140907	140907	140908
28250	45287	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	139267	139267	\N
28250	45472	6	applied	\N	\N	\N	\N	139783	139783	139784
28250	46047	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28250	45283	8	applied	\N	\N	1000000000	\N	139257	139257	139258
28250	45388	9	applied	\N	\N	\N	\N	139569	139569	139570
28250	45391	10	applied	\N	\N	1000000000	\N	139575	139575	139576
28250	45392	11	applied	\N	\N	1000000000	\N	139577	139577	139578
28250	45393	12	applied	\N	\N	1000000000	\N	139579	139579	139580
28250	45941	13	applied	\N	\N	\N	\N	141113	141113	13857
28250	46070	14	applied	\N	\N	\N	\N	141509	141509	141509
28250	45490	15	applied	\N	\N	1000000000	\N	139827	139827	139828
28250	45749	16	applied	\N	\N	1000000000	\N	140579	140579	140580
28250	45889	17	applied	\N	\N	1000000000	\N	140965	140965	140966
28250	45890	18	applied	\N	\N	1000000000	\N	140967	140967	140968
28250	45790	19	applied	\N	\N	\N	\N	140689	140689	141515
28250	45801	20	applied	\N	\N	\N	\N	140721	140721	138766
28250	45811	21	applied	\N	\N	\N	\N	140751	140751	141516
28250	45818	22	applied	\N	\N	\N	\N	140767	140767	138774
28250	45832	23	applied	\N	\N	\N	\N	140806	140806	141517
28250	45844	24	applied	\N	\N	\N	\N	140838	140838	138776
28250	45853	25	applied	\N	\N	\N	\N	140860	140860	141518
28250	45868	26	applied	\N	\N	\N	\N	140900	140900	138784
28250	45875	27	applied	\N	\N	\N	\N	140916	140916	141519
28250	45882	28	applied	\N	\N	\N	\N	140944	140944	138792
28250	45895	29	applied	\N	\N	\N	\N	140981	140981	141520
28250	45903	30	applied	\N	\N	\N	\N	141006	141006	141521
28250	45909	31	applied	\N	\N	\N	\N	141020	141020	138801
28250	45919	32	applied	\N	\N	\N	\N	141055	141055	141522
28250	45927	33	applied	\N	\N	\N	\N	141075	141075	138803
28250	45931	34	applied	\N	\N	\N	\N	141088	141088	141523
28250	45938	35	applied	\N	\N	\N	\N	141107	141107	141524
28250	45954	36	applied	\N	\N	\N	\N	141142	141142	138811
28250	45957	37	applied	\N	\N	\N	\N	141160	141160	141525
28250	45966	38	applied	\N	\N	\N	\N	141207	141207	141526
28250	45971	39	applied	\N	\N	\N	\N	141228	141228	138813
28250	45978	40	applied	\N	\N	\N	\N	141245	141245	141527
28250	45988	41	applied	\N	\N	\N	\N	141270	141270	138815
28250	45994	42	applied	\N	\N	\N	\N	141292	141292	141528
28250	46001	43	applied	\N	\N	\N	\N	141310	141310	138817
28250	46011	44	applied	\N	\N	\N	\N	141338	141338	141529
28250	46017	45	applied	\N	\N	\N	\N	141355	141355	138823
28250	46024	46	applied	\N	\N	\N	\N	141375	141375	141530
28250	46036	47	applied	\N	\N	\N	\N	141410	141410	141531
28250	46043	48	applied	\N	\N	\N	\N	141433	141433	138825
28250	46051	49	applied	\N	\N	\N	\N	141453	141453	141532
28250	46061	50	applied	\N	\N	\N	\N	141482	141482	141533
28250	46067	51	applied	\N	\N	\N	\N	141501	141501	138835
28250	46049	52	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28263	46087	0	applied	\N	\N	\N	\N	141578	141578	141579
28263	46088	1	applied	\N	\N	\N	\N	141580	141580	141581
28266	46089	0	applied	\N	\N	\N	\N	141584	141584	141585
28266	46090	1	applied	\N	\N	\N	\N	141586	141586	141587
28268	45994	0	applied	\N	\N	\N	\N	141292	141292	141600
28268	46001	1	applied	\N	\N	\N	\N	141310	141310	140531
28268	46047	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28268	46011	3	applied	\N	\N	\N	\N	141338	141338	141601
28268	46017	4	applied	\N	\N	\N	\N	141355	141355	140545
28268	46024	5	applied	\N	\N	\N	\N	141375	141375	141602
28268	46036	6	applied	\N	\N	\N	\N	141410	141410	140547
28268	46043	7	applied	\N	\N	\N	\N	141433	141433	141603
28268	46051	8	applied	\N	\N	\N	\N	141453	141453	140549
28268	46061	9	applied	\N	\N	\N	\N	141482	141482	141604
28268	46067	10	applied	\N	\N	\N	\N	141501	141501	141605
28268	46070	11	applied	\N	\N	\N	\N	141509	141509	141509
28268	46076	12	applied	\N	\N	1000000000	\N	141543	141543	141544
28268	46077	13	applied	\N	\N	\N	\N	141545	141545	140551
28268	46086	14	applied	\N	\N	\N	\N	141572	141572	141606
28268	46093	15	applied	\N	\N	\N	\N	141596	141596	141607
28268	46049	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28270	46096	0	applied	\N	\N	\N	\N	141614	141614	141615
28270	46097	1	applied	\N	\N	\N	\N	141616	141616	141617
28275	46101	0	applied	\N	\N	\N	\N	141628	141628	141629
28275	46102	1	applied	\N	\N	\N	\N	141630	141630	141631
28277	46101	0	applied	\N	\N	\N	\N	141628	141628	141629
28277	46102	1	applied	\N	\N	\N	\N	141630	141630	141631
28281	46105	0	applied	\N	\N	\N	\N	141642	141642	141643
28281	46106	1	applied	\N	\N	\N	\N	141644	141644	141644
28281	46107	2	applied	\N	\N	\N	\N	141645	141645	141646
28289	46113	0	applied	\N	\N	\N	\N	141665	141665	141666
28289	46114	1	applied	\N	\N	\N	\N	141667	141667	141668
28290	46115	0	applied	\N	\N	\N	\N	141677	141677	141678
28290	46116	1	applied	\N	\N	\N	\N	141679	141679	141680
28290	46117	2	applied	\N	\N	\N	\N	141681	141681	141682
28302	46132	0	applied	\N	\N	\N	\N	141721	141721	141722
28302	46133	1	applied	\N	\N	\N	\N	141723	141723	141724
28302	46134	2	applied	\N	\N	\N	\N	141725	141725	141726
28302	46135	3	applied	\N	\N	\N	\N	141727	141727	141728
28302	46136	4	applied	\N	\N	\N	\N	141729	141729	111296
28302	46137	5	applied	\N	\N	\N	\N	141730	141730	141731
28306	46143	0	applied	\N	\N	\N	\N	141746	141746	141747
28306	46144	1	applied	\N	\N	\N	\N	141748	141748	141749
28306	46145	2	applied	\N	\N	\N	\N	141750	141750	141751
28306	46146	3	applied	\N	\N	\N	\N	141752	141752	141753
28312	46165	0	applied	\N	\N	\N	\N	141798	141798	141799
28312	46166	1	applied	\N	\N	\N	\N	141800	141800	141801
28316	46169	0	applied	\N	\N	\N	\N	141831	141831	141832
28316	46170	1	applied	\N	\N	\N	\N	141833	141833	132657
28316	46171	2	applied	\N	\N	\N	\N	141834	141834	141835
28316	46172	3	applied	\N	\N	\N	\N	141836	141836	141837
28316	46173	4	applied	\N	\N	\N	\N	141838	141838	141839
28321	46178	0	applied	\N	\N	\N	\N	141854	141854	141855
28321	46179	1	applied	\N	\N	\N	\N	141856	141856	141857
28324	46187	0	applied	\N	\N	\N	\N	141878	141878	141879
28324	46188	1	applied	\N	\N	\N	\N	141880	141880	141881
28328	46189	0	applied	\N	\N	\N	\N	141888	141888	141889
28328	46190	1	applied	\N	\N	\N	\N	141890	141890	141891
28333	46197	0	applied	\N	\N	\N	\N	141910	141910	141911
28333	46198	1	applied	\N	\N	\N	\N	141912	141912	141913
28336	46199	0	applied	\N	\N	\N	\N	141917	141917	141918
28314	46129	37	applied	\N	\N	\N	\N	141710	141710	141820
28314	46131	38	applied	\N	\N	\N	\N	141715	141715	141821
28314	46134	39	applied	\N	\N	\N	\N	141725	141725	141822
28314	46137	40	applied	\N	\N	\N	\N	141730	141730	141743
28314	46139	41	applied	\N	\N	\N	\N	141736	141736	141745
28314	46142	42	applied	\N	\N	\N	\N	141744	141744	141751
28314	46145	43	applied	\N	\N	\N	\N	141750	141750	141753
28314	46146	44	applied	\N	\N	\N	\N	141752	141752	141823
28314	46149	45	applied	\N	\N	\N	\N	141760	141760	141824
28314	46156	46	applied	\N	\N	\N	\N	141777	141777	141825
28314	46157	47	applied	\N	\N	\N	\N	141779	141779	141826
28314	46158	48	applied	\N	\N	\N	\N	141781	141781	141827
28314	46159	49	applied	\N	\N	\N	\N	141783	141783	141791
28314	46163	50	applied	\N	\N	\N	\N	141792	141792	141793
28314	46164	51	applied	\N	\N	\N	\N	141794	141794	141795
28314	46166	52	applied	\N	\N	\N	\N	141800	141800	141801
28314	46168	53	applied	\N	\N	\N	\N	141806	141806	141807
28319	46176	0	applied	\N	\N	\N	\N	141847	141847	141848
28319	46177	1	applied	\N	\N	\N	\N	141849	141849	141850
28322	46070	0	applied	\N	\N	\N	\N	141509	141509	141509
28322	46106	1	applied	\N	\N	\N	\N	141644	141644	141644
28322	46136	2	applied	\N	\N	\N	\N	141729	141729	111296
28322	46127	3	applied	\N	\N	\N	\N	141707	141707	141707
28322	46076	4	applied	\N	\N	1000000000	\N	141543	141543	141544
28327	46187	0	applied	\N	\N	\N	\N	141878	141878	141879
28327	46188	1	applied	\N	\N	\N	\N	141880	141880	141881
28329	46189	0	applied	\N	\N	\N	\N	141888	141888	141889
28329	46190	1	applied	\N	\N	\N	\N	141890	141890	141891
28334	46197	0	applied	\N	\N	\N	\N	141910	141910	141911
28334	46198	1	applied	\N	\N	\N	\N	141912	141912	141913
28339	46207	0	applied	\N	\N	\N	\N	141936	141936	141937
28339	46208	1	applied	\N	\N	\N	\N	141938	141938	141939
28345	46219	0	applied	\N	\N	\N	\N	141966	141966	141967
28345	46220	1	applied	\N	\N	\N	\N	141968	141968	141969
28350	46233	0	applied	\N	\N	\N	\N	142010	142010	142011
28350	46234	1	applied	\N	\N	\N	\N	142012	142012	142013
28354	46235	0	applied	\N	\N	\N	\N	142016	142016	142017
28354	46236	1	applied	\N	\N	\N	\N	142018	142018	142019
28357	46244	0	applied	\N	\N	\N	\N	142038	142038	142039
28357	46245	1	applied	\N	\N	\N	\N	142040	142040	142041
28364	46248	0	applied	\N	\N	\N	\N	142054	142054	142055
28364	46250	1	applied	\N	\N	\N	\N	142059	142059	142060
28364	46251	2	applied	\N	\N	\N	\N	142061	142061	142062
28364	46249	3	applied	\N	\N	\N	\N	142056	142056	142057
28364	46252	4	applied	\N	\N	\N	\N	142063	142063	142064
28364	46253	5	applied	\N	\N	\N	\N	142065	142065	142066
28367	46256	0	applied	\N	\N	\N	\N	142076	142076	142077
28367	46257	1	applied	\N	\N	\N	\N	142078	142078	142079
28370	46258	0	applied	\N	\N	\N	\N	142082	142082	142083
28370	46259	1	applied	\N	\N	\N	\N	142084	142084	142085
28371	46258	0	applied	\N	\N	\N	\N	142082	142082	142083
28371	46259	1	applied	\N	\N	\N	\N	142084	142084	142085
28384	46273	0	applied	\N	\N	\N	\N	142143	142143	142144
28384	46274	1	applied	\N	\N	\N	\N	142145	142145	142146
28387	46273	0	applied	\N	\N	\N	\N	142143	142143	142144
28387	46274	1	applied	\N	\N	\N	\N	142145	142145	142146
28389	46270	0	applied	\N	\N	1000000000	\N	142135	142135	142157
28389	46275	1	applied	\N	\N	\N	\N	142150	142150	142158
28389	46223	2	applied	\N	\N	1000000000	\N	141978	141978	141979
28389	46237	3	applied	\N	\N	\N	\N	142022	142022	142151
28389	46183	4	applied	\N	\N	\N	\N	141867	141867	141868
28389	46224	5	applied	\N	\N	1000000000	\N	141980	141980	141981
28389	46136	6	applied	\N	\N	\N	\N	141729	141729	111296
28391	46275	0	applied	\N	\N	\N	\N	142150	142150	142151
28391	46276	1	applied	\N	\N	\N	\N	142152	142152	142153
28391	46277	2	applied	\N	\N	\N	\N	142154	142154	142155
28395	46280	0	applied	\N	\N	\N	\N	142172	142172	142173
28395	46281	1	applied	\N	\N	\N	\N	142174	142174	142175
28400	46284	0	applied	\N	\N	\N	\N	142182	142182	142183
28400	46285	1	applied	\N	\N	\N	\N	142184	142184	142185
28400	46286	2	applied	\N	\N	\N	\N	142186	142186	142187
28402	46287	0	applied	\N	\N	\N	\N	142192	142192	142193
28402	46288	1	applied	\N	\N	\N	\N	142194	142194	142195
28402	46289	2	applied	\N	\N	\N	\N	142196	142196	142197
28402	46290	3	applied	\N	\N	\N	\N	142198	142198	142199
28405	46291	0	applied	\N	\N	\N	\N	142204	142204	142205
28405	46292	1	applied	\N	\N	\N	\N	142206	142206	142207
28409	46293	0	applied	\N	\N	\N	\N	142214	142214	142215
28409	46294	1	applied	\N	\N	1000000000	\N	142216	142216	142217
28409	46295	2	applied	\N	\N	\N	\N	142218	142218	142219
28415	46296	0	applied	\N	\N	\N	\N	142227	142227	142228
28415	46298	1	applied	\N	\N	\N	\N	142237	142237	142238
28415	46299	2	applied	\N	\N	\N	\N	142239	142239	142240
28415	46300	3	applied	\N	\N	\N	\N	142241	142241	142242
28415	46301	4	applied	\N	\N	\N	\N	142243	142243	142244
28418	46306	0	applied	\N	\N	\N	\N	142257	142257	142258
28418	46307	1	applied	\N	\N	\N	\N	142259	142259	142260
28418	46308	2	applied	\N	\N	\N	\N	142261	142261	142216
28418	46309	3	applied	\N	\N	\N	\N	142262	142262	142263
28418	46310	4	applied	\N	\N	\N	\N	142264	142264	142265
28421	46315	0	applied	\N	\N	\N	\N	142279	142279	142280
28421	46316	1	applied	\N	\N	\N	\N	142281	142281	142282
28425	46331	0	applied	\N	\N	\N	\N	142316	142316	142317
28425	46332	1	applied	\N	\N	\N	\N	142318	142318	142319
28432	46339	0	applied	\N	\N	\N	\N	142343	142343	142344
28432	46340	2	applied	\N	\N	\N	\N	142346	142346	142347
28435	46348	0	applied	\N	\N	\N	\N	142365	142365	142366
28435	46349	1	applied	\N	\N	\N	\N	142367	142367	142368
28437	46348	0	applied	\N	\N	\N	\N	142365	142365	142366
28437	46349	1	applied	\N	\N	\N	\N	142367	142367	142368
28439	46348	0	applied	\N	\N	\N	\N	142365	142365	142366
28439	46349	1	applied	\N	\N	\N	\N	142367	142367	142368
28444	46357	0	applied	\N	\N	\N	\N	142412	142412	142413
28444	46358	1	applied	\N	\N	\N	\N	142414	142414	142415
28444	46359	2	applied	\N	\N	\N	\N	142416	142416	142403
28444	46360	3	applied	\N	\N	\N	\N	142417	142417	142418
28444	46361	4	applied	\N	\N	\N	\N	142419	142419	142420
28447	46362	0	applied	\N	\N	\N	\N	142423	142423	142424
28447	46363	1	applied	\N	\N	\N	\N	142425	142425	142426
28447	46364	2	applied	\N	\N	\N	\N	142427	142427	142428
28447	46365	3	applied	\N	\N	\N	\N	142429	142429	142430
28449	46362	0	applied	\N	\N	\N	\N	142423	142423	142424
28449	46363	1	applied	\N	\N	\N	\N	142425	142425	142426
28449	46364	2	applied	\N	\N	\N	\N	142427	142427	142428
28449	46365	3	applied	\N	\N	\N	\N	142429	142429	142430
28454	46374	0	applied	\N	\N	\N	\N	142457	142457	142458
28454	46375	1	applied	\N	\N	\N	\N	142459	142459	142460
28458	46376	0	applied	\N	\N	\N	\N	142466	142466	142467
28458	46377	1	applied	\N	\N	\N	\N	142468	142468	142469
28336	46200	1	applied	\N	\N	\N	\N	141919	141919	141920
28336	46201	2	applied	\N	\N	\N	\N	141921	141921	141922
28336	46202	3	applied	\N	\N	\N	\N	141923	141923	141924
28336	46203	4	applied	\N	\N	\N	\N	141925	141925	141926
28336	46204	5	applied	\N	\N	\N	\N	141927	141927	141928
28336	46205	6	applied	\N	\N	\N	\N	141929	141929	141930
28336	46206	7	applied	\N	\N	\N	\N	141931	141931	141932
28342	46211	0	applied	\N	\N	\N	\N	141946	141946	141947
28342	46212	1	applied	\N	\N	\N	\N	141948	141948	141949
28342	46213	2	applied	\N	\N	\N	\N	141950	141950	141951
28342	46214	3	applied	\N	\N	\N	\N	141952	141952	141953
28342	46215	4	applied	\N	\N	\N	\N	141954	141954	141955
28342	46216	5	applied	\N	\N	\N	\N	141956	141956	141957
28342	46217	6	applied	\N	\N	\N	\N	141958	141958	141959
28342	46218	7	applied	\N	\N	\N	\N	141960	141960	141961
28344	46219	0	applied	\N	\N	\N	\N	141966	141966	141967
28344	46220	1	applied	\N	\N	\N	\N	141968	141968	141969
28347	46221	0	applied	\N	\N	\N	\N	141974	141974	141975
28347	46222	1	applied	\N	\N	\N	\N	141976	141976	141977
28347	46223	2	applied	\N	\N	1000000000	\N	141978	141978	141979
28347	46224	3	applied	\N	\N	1000000000	\N	141980	141980	141981
28347	46225	4	applied	\N	\N	\N	\N	141982	141982	141983
28347	46226	5	applied	\N	\N	\N	\N	141984	141984	141985
28347	46227	6	applied	\N	\N	\N	\N	141986	141986	141987
28347	46228	7	applied	\N	\N	\N	\N	141988	141988	141989
28352	46233	0	applied	\N	\N	\N	\N	142010	142010	142011
28352	46234	1	applied	\N	\N	\N	\N	142012	142012	142013
28359	46244	0	applied	\N	\N	\N	\N	142038	142038	142039
28359	46245	1	applied	\N	\N	\N	\N	142040	142040	142041
28366	46256	0	applied	\N	\N	\N	\N	142076	142076	142077
28366	46257	1	applied	\N	\N	\N	\N	142078	142078	142079
28369	46258	0	applied	\N	\N	\N	\N	142082	142082	142083
28369	46259	1	applied	\N	\N	\N	\N	142084	142084	142085
28373	46260	0	applied	\N	\N	\N	\N	142091	142091	142092
28373	46261	1	applied	\N	\N	\N	\N	142093	142093	142094
28376	46262	0	applied	\N	\N	\N	\N	142098	142098	142099
28376	46263	2	applied	\N	\N	\N	\N	142101	142101	142102
28377	46223	0	applied	\N	\N	1000000000	\N	141978	141978	141979
28377	46237	1	applied	\N	\N	1000000000	\N	142022	142022	142023
28377	45885	2	applied	\N	\N	1000000000	\N	140953	140953	140954
28377	45847	3	applied	\N	\N	1000000000	\N	140846	140846	140847
28377	45871	4	applied	\N	\N	\N	\N	140907	140907	140908
28377	45749	5	applied	\N	\N	1000000000	\N	140579	140579	140580
28377	46047	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28377	46224	7	applied	\N	\N	1000000000	\N	141980	141980	141981
28377	45889	8	applied	\N	\N	1000000000	\N	140965	140965	140966
28377	45890	9	applied	\N	\N	1000000000	\N	140967	140967	140968
28377	45677	10	applied	\N	\N	\N	\N	140387	140387	130697
28377	45941	11	applied	\N	\N	\N	\N	141113	141113	13857
28377	46070	12	applied	\N	\N	\N	\N	141509	141509	141509
28377	46106	13	applied	\N	\N	\N	\N	141644	141644	141644
28377	46136	14	applied	\N	\N	\N	\N	141729	141729	111296
28377	46127	15	applied	\N	\N	\N	\N	141707	141707	141707
28377	46076	16	applied	\N	\N	1000000000	\N	141543	141543	141544
28377	45790	17	applied	\N	\N	\N	\N	140689	140689	142108
28377	45801	18	applied	\N	\N	\N	\N	140721	140721	139851
28377	45811	19	applied	\N	\N	\N	\N	140751	140751	142109
28377	45818	20	applied	\N	\N	\N	\N	140767	140767	139853
28377	45832	21	applied	\N	\N	\N	\N	140806	140806	142110
28377	45844	22	applied	\N	\N	\N	\N	140838	140838	139855
28377	45853	23	applied	\N	\N	\N	\N	140860	140860	142111
28379	46264	0	applied	\N	\N	\N	\N	142115	142115	142116
28379	46265	1	applied	\N	\N	\N	\N	142117	142117	142118
28381	46266	0	applied	\N	\N	\N	\N	142123	142123	142124
28381	46267	1	applied	\N	\N	\N	\N	142125	142125	142126
28388	46275	0	applied	\N	\N	\N	\N	142150	142150	142151
28388	46276	1	applied	\N	\N	\N	\N	142152	142152	142153
28388	46277	2	applied	\N	\N	\N	\N	142154	142154	142155
28394	46278	0	applied	\N	\N	\N	\N	142166	142166	142167
28394	46279	1	applied	\N	\N	\N	\N	142168	142168	142169
28399	46284	0	applied	\N	\N	\N	\N	142182	142182	142183
28399	46285	1	applied	\N	\N	\N	\N	142184	142184	142185
28399	46286	2	applied	\N	\N	\N	\N	142186	142186	142187
28404	46291	0	applied	\N	\N	\N	\N	142204	142204	142205
28404	46292	1	applied	\N	\N	\N	\N	142206	142206	142207
28406	46291	0	applied	\N	\N	\N	\N	142204	142204	142205
28406	46292	1	applied	\N	\N	\N	\N	142206	142206	142207
28408	46293	0	applied	\N	\N	\N	\N	142214	142214	142215
28408	46294	1	applied	\N	\N	1000000000	\N	142216	142216	142217
28408	46295	2	applied	\N	\N	\N	\N	142218	142218	142219
28412	46296	0	applied	\N	\N	\N	\N	142227	142227	142228
28412	46297	1	applied	\N	\N	\N	\N	142229	142229	142230
28417	46304	0	applied	\N	\N	\N	\N	142251	142251	142252
28417	46305	1	applied	\N	\N	\N	\N	142253	142253	142254
28420	46311	0	applied	\N	\N	\N	\N	142267	142267	142268
28420	46312	1	applied	\N	\N	\N	\N	142269	142269	142270
28420	46313	2	applied	\N	\N	\N	\N	142271	142271	142272
28420	46314	3	applied	\N	\N	\N	\N	142273	142273	142274
28424	46317	0	applied	\N	\N	\N	\N	142287	142287	142288
28424	46318	1	applied	\N	\N	\N	\N	142289	142289	142290
28424	46319	2	applied	\N	\N	\N	\N	142291	142291	142292
28424	46320	3	applied	\N	\N	\N	\N	142293	142293	142294
28424	46321	4	applied	\N	\N	\N	\N	142295	142295	142296
28424	46322	5	applied	\N	\N	\N	\N	142297	142297	142298
28424	46323	6	applied	\N	\N	\N	\N	142299	142299	142300
28424	46324	7	applied	\N	\N	\N	\N	142301	142301	142302
28424	46325	8	applied	\N	\N	\N	\N	142303	142303	142304
28424	46326	9	applied	\N	\N	\N	\N	142305	142305	142306
28424	46327	10	applied	\N	\N	\N	\N	142307	142307	142308
28424	46328	11	applied	\N	\N	\N	\N	142309	142309	142310
28424	46329	12	applied	\N	\N	\N	\N	142311	142311	142312
28424	46330	13	applied	\N	\N	\N	\N	142313	142313	142314
28429	46333	0	applied	\N	\N	\N	\N	142327	142327	142328
28429	46334	1	applied	\N	\N	\N	\N	142329	142329	142330
28429	46335	2	applied	\N	\N	\N	\N	142331	142331	142332
28429	46336	3	applied	\N	\N	\N	\N	142333	142333	142334
28434	46341	0	applied	\N	\N	\N	\N	142350	142350	142351
28434	46342	1	applied	\N	\N	\N	\N	142352	142352	142353
28434	46343	2	applied	\N	\N	\N	\N	142354	142354	142355
28434	46344	3	applied	\N	\N	1000000000	\N	142356	142356	142357
28434	46345	4	applied	\N	\N	\N	\N	142358	142358	142359
28434	46346	5	applied	\N	\N	\N	\N	142360	142360	142361
28434	46347	6	applied	\N	\N	\N	\N	142362	142362	142363
28441	46352	0	applied	\N	\N	\N	\N	142399	142399	142400
28441	46353	1	applied	\N	\N	\N	\N	142401	142401	142402
28441	46354	2	applied	\N	\N	\N	\N	142403	142403	142404
28446	46362	0	applied	\N	\N	\N	\N	142423	142423	142424
28446	46363	1	applied	\N	\N	\N	\N	142425	142425	142426
28346	46225	4	applied	\N	\N	\N	\N	141982	141982	141983
28346	46226	5	applied	\N	\N	\N	\N	141984	141984	141985
28346	46227	6	applied	\N	\N	\N	\N	141986	141986	141987
28346	46228	7	applied	\N	\N	\N	\N	141988	141988	141989
28349	46229	0	applied	\N	\N	\N	\N	142000	142000	142001
28349	46230	1	applied	\N	\N	\N	\N	142002	142002	142003
28349	46231	2	applied	\N	\N	\N	\N	142004	142004	142005
28349	46232	3	applied	\N	\N	\N	\N	142006	142006	142007
28356	46242	0	applied	\N	\N	\N	\N	142034	142034	142035
28356	46243	1	applied	\N	\N	\N	\N	142036	142036	142037
28358	46244	0	applied	\N	\N	\N	\N	142038	142038	142039
28358	46245	1	applied	\N	\N	\N	\N	142040	142040	142041
28361	46246	0	applied	\N	\N	\N	\N	142046	142046	142047
28361	46247	1	applied	\N	\N	\N	\N	142048	142048	142049
28363	46250	0	applied	\N	\N	\N	\N	142059	142059	142060
28363	46251	1	applied	\N	\N	\N	\N	142061	142061	142062
28363	46252	2	applied	\N	\N	\N	\N	142063	142063	142064
28363	46253	3	applied	\N	\N	\N	\N	142065	142065	142066
28368	46258	0	applied	\N	\N	\N	\N	142082	142082	142083
28368	46259	1	applied	\N	\N	\N	\N	142084	142084	142085
28372	46260	0	applied	\N	\N	\N	\N	142091	142091	142092
28372	46261	1	applied	\N	\N	\N	\N	142093	142093	142094
28375	46262	0	applied	\N	\N	\N	\N	142098	142098	142099
28375	46263	2	applied	\N	\N	\N	\N	142101	142101	142102
28383	46270	0	applied	\N	\N	\N	\N	142135	142135	142136
28383	46271	1	applied	\N	\N	\N	\N	142137	142137	142138
28383	46272	2	applied	\N	\N	\N	\N	142139	142139	142140
28386	46273	0	applied	\N	\N	\N	\N	142143	142143	142144
28386	46274	1	applied	\N	\N	\N	\N	142145	142145	142146
28390	46275	0	applied	\N	\N	\N	\N	142150	142150	142151
28390	46276	1	applied	\N	\N	\N	\N	142152	142152	142153
28390	46277	2	applied	\N	\N	\N	\N	142154	142154	142155
28392	46275	0	applied	\N	\N	\N	\N	142150	142150	142151
28392	46276	1	applied	\N	\N	\N	\N	142152	142152	142153
28392	46277	2	applied	\N	\N	\N	\N	142154	142154	142155
28397	46281	0	applied	\N	\N	\N	\N	142174	142174	142175
28398	46282	0	applied	\N	\N	\N	\N	142178	142178	142179
28398	46283	1	applied	\N	\N	\N	\N	142180	142180	142181
28401	46287	0	applied	\N	\N	\N	\N	142192	142192	142193
28401	46288	1	applied	\N	\N	\N	\N	142194	142194	142195
28401	46289	2	applied	\N	\N	\N	\N	142196	142196	142197
28401	46290	3	applied	\N	\N	\N	\N	142198	142198	142199
28403	46291	0	applied	\N	\N	\N	\N	142204	142204	142205
28403	46292	1	applied	\N	\N	\N	\N	142206	142206	142207
28411	46293	0	applied	\N	\N	\N	\N	142214	142214	142215
28411	46294	1	applied	\N	\N	1000000000	\N	142216	142216	142217
28411	46295	2	applied	\N	\N	\N	\N	142218	142218	142219
28414	46270	0	applied	\N	\N	\N	\N	142135	142135	142136
28414	46275	1	applied	\N	\N	\N	\N	142150	142150	142151
28414	46294	2	applied	\N	\N	1000000000	\N	142216	142216	142217
28414	46254	3	applied	\N	\N	\N	\N	142070	142070	142071
28414	46256	4	applied	\N	\N	\N	\N	142076	142076	142077
28414	46258	5	applied	\N	\N	\N	\N	142082	142082	142083
28414	46260	6	applied	\N	\N	\N	\N	142091	142091	142092
28414	46262	7	applied	\N	\N	\N	\N	142098	142098	142099
28414	46264	8	applied	\N	\N	\N	\N	142115	142115	142116
28414	46266	9	applied	\N	\N	\N	\N	142123	142123	142124
28414	46268	10	applied	\N	\N	\N	\N	142130	142130	142131
28414	46271	11	applied	\N	\N	\N	\N	142137	142137	142138
28414	46273	12	applied	\N	\N	\N	\N	142143	142143	142144
28414	46276	13	applied	\N	\N	\N	\N	142152	142152	142153
28414	46278	14	applied	\N	\N	\N	\N	142166	142166	142167
28414	46280	15	applied	\N	\N	\N	\N	142172	142172	142173
28414	46282	16	applied	\N	\N	\N	\N	142178	142178	142179
28414	46284	17	applied	\N	\N	\N	\N	142182	142182	142183
28414	46287	18	applied	\N	\N	\N	\N	142192	142192	142193
28414	46288	20	applied	\N	\N	\N	\N	142194	142194	142195
28414	46291	21	applied	\N	\N	\N	\N	142204	142204	142205
28414	46293	22	applied	\N	\N	\N	\N	142214	142214	142215
28414	46285	23	applied	\N	\N	\N	\N	142184	142184	142185
28414	46255	24	applied	\N	\N	\N	\N	142072	142072	142073
28414	46257	25	applied	\N	\N	\N	\N	142078	142078	142079
28414	46259	26	applied	\N	\N	\N	\N	142084	142084	142085
28414	46261	27	applied	\N	\N	\N	\N	142093	142093	142094
28414	46263	28	applied	\N	\N	\N	\N	142101	142101	142102
28414	46265	29	applied	\N	\N	\N	\N	142117	142117	142118
28414	46267	30	applied	\N	\N	\N	\N	142125	142125	142126
28414	46269	31	applied	\N	\N	\N	\N	142132	142132	142133
28414	46272	32	applied	\N	\N	\N	\N	142139	142139	142140
28414	46274	33	applied	\N	\N	\N	\N	142145	142145	142146
28414	46277	34	applied	\N	\N	\N	\N	142154	142154	142155
28414	46279	35	applied	\N	\N	\N	\N	142168	142168	142169
28414	46281	36	applied	\N	\N	\N	\N	142174	142174	142175
28414	46283	37	applied	\N	\N	\N	\N	142180	142180	142181
28414	46286	38	applied	\N	\N	\N	\N	142186	142186	142187
28414	46289	39	applied	\N	\N	\N	\N	142196	142196	142197
28414	46290	40	applied	\N	\N	\N	\N	142198	142198	142199
28414	46292	41	applied	\N	\N	\N	\N	142206	142206	142207
28422	46315	0	applied	\N	\N	\N	\N	142279	142279	142280
28422	46316	1	applied	\N	\N	\N	\N	142281	142281	142282
28423	46270	0	applied	\N	\N	1000000000	\N	142135	142135	142157
28423	46237	1	applied	\N	\N	\N	\N	142022	142022	142136
28423	46275	2	applied	\N	\N	\N	\N	142150	142150	142151
28423	46294	3	applied	\N	\N	1000000000	\N	142216	142216	142217
28423	46285	4	applied	\N	\N	\N	\N	142184	142184	142185
28427	46331	0	applied	\N	\N	\N	\N	142316	142316	142317
28427	46332	1	applied	\N	\N	\N	\N	142318	142318	142319
28428	46296	0	applied	\N	\N	\N	\N	142227	142227	142228
28428	46298	1	applied	\N	\N	\N	\N	142237	142237	142238
28428	46299	2	applied	\N	\N	\N	\N	142239	142239	142240
28428	46302	3	applied	\N	\N	\N	\N	142247	142247	142248
28428	46304	4	applied	\N	\N	\N	\N	142251	142251	142252
28428	46306	5	applied	\N	\N	\N	\N	142257	142257	142258
28428	46307	6	applied	\N	\N	\N	\N	142259	142259	142260
28428	46311	7	applied	\N	\N	\N	\N	142267	142267	142268
28428	46312	8	applied	\N	\N	\N	\N	142269	142269	142270
28428	46315	9	applied	\N	\N	\N	\N	142279	142279	142280
28428	46317	10	applied	\N	\N	\N	\N	142287	142287	142288
28428	46318	11	applied	\N	\N	\N	\N	142289	142289	142290
28428	46319	12	applied	\N	\N	\N	\N	142291	142291	142292
28428	46320	13	applied	\N	\N	\N	\N	142293	142293	142294
28428	46321	14	applied	\N	\N	\N	\N	142295	142295	142296
28428	46322	15	applied	\N	\N	\N	\N	142297	142297	142298
28428	46323	16	applied	\N	\N	\N	\N	142299	142299	142300
28428	46331	17	applied	\N	\N	\N	\N	142316	142316	142317
28428	46308	18	applied	\N	\N	\N	\N	142261	142261	142216
28428	46297	19	applied	\N	\N	\N	\N	142229	142229	142230
28428	46300	20	applied	\N	\N	\N	\N	142241	142241	142242
28428	46301	21	applied	\N	\N	\N	\N	142243	142243	142244
28348	46162	14	applied	\N	\N	\N	\N	141790	141790	141996
28348	46171	15	applied	\N	\N	\N	\N	141834	141834	141997
28351	46233	0	applied	\N	\N	\N	\N	142010	142010	142011
28351	46234	1	applied	\N	\N	\N	\N	142012	142012	142013
28355	46237	0	applied	\N	\N	1000000000	\N	142022	142022	142023
28355	46238	1	applied	\N	\N	\N	\N	142024	142024	142025
28355	46239	2	applied	\N	\N	\N	\N	142026	142026	142027
28355	46240	3	applied	\N	\N	\N	\N	142028	142028	142029
28355	46241	4	applied	\N	\N	\N	\N	142030	142030	142031
28360	46246	0	applied	\N	\N	\N	\N	142046	142046	142047
28360	46247	1	applied	\N	\N	\N	\N	142048	142048	142049
28362	46248	0	applied	\N	\N	\N	\N	142054	142054	142055
28362	46249	1	applied	\N	\N	\N	\N	142056	142056	142057
28365	46254	0	applied	\N	\N	\N	\N	142070	142070	142071
28365	46255	1	applied	\N	\N	\N	\N	142072	142072	142073
28374	46262	0	applied	\N	\N	\N	\N	142098	142098	142099
28374	46263	2	applied	\N	\N	\N	\N	142101	142101	142102
28378	46264	0	applied	\N	\N	\N	\N	142115	142115	142116
28378	46265	1	applied	\N	\N	\N	\N	142117	142117	142118
28380	46266	0	applied	\N	\N	\N	\N	142123	142123	142124
28380	46267	1	applied	\N	\N	\N	\N	142125	142125	142126
28382	46268	0	applied	\N	\N	\N	\N	142130	142130	142131
28382	46269	1	applied	\N	\N	\N	\N	142132	142132	142133
28385	46273	0	applied	\N	\N	\N	\N	142143	142143	142144
28385	46274	1	applied	\N	\N	\N	\N	142145	142145	142146
28393	46275	0	applied	\N	\N	\N	\N	142150	142150	142151
28393	46276	1	applied	\N	\N	\N	\N	142152	142152	142153
28393	46277	2	applied	\N	\N	\N	\N	142154	142154	142155
28396	46280	0	applied	\N	\N	\N	\N	142172	142172	142173
28396	46281	1	applied	\N	\N	\N	\N	142174	142174	142175
28407	46291	0	applied	\N	\N	\N	\N	142204	142204	142205
28407	46292	1	applied	\N	\N	\N	\N	142206	142206	142207
28410	46293	0	applied	\N	\N	\N	\N	142214	142214	142215
28410	46294	1	applied	\N	\N	1000000000	\N	142216	142216	142217
28410	46295	2	applied	\N	\N	\N	\N	142218	142218	142219
28413	46297	0	applied	\N	\N	\N	\N	142229	142229	142230
28416	46302	0	applied	\N	\N	\N	\N	142247	142247	142248
28416	46303	1	applied	\N	\N	\N	\N	142249	142249	142250
28419	46311	0	applied	\N	\N	\N	\N	142267	142267	142268
28419	46312	1	applied	\N	\N	\N	\N	142269	142269	142270
28419	46313	2	applied	\N	\N	\N	\N	142271	142271	142272
28419	46314	3	applied	\N	\N	\N	\N	142273	142273	142274
28426	46331	0	applied	\N	\N	\N	\N	142316	142316	142317
28426	46332	1	applied	\N	\N	\N	\N	142318	142318	142319
28430	46337	0	applied	\N	\N	\N	\N	142336	142336	142337
28430	46338	1	applied	\N	\N	\N	\N	142338	142338	142339
28442	46355	0	applied	\N	\N	\N	\N	142406	142406	142407
28442	46356	1	applied	\N	\N	\N	\N	142408	142408	142409
28455	46374	0	applied	\N	\N	\N	\N	142457	142457	142458
28455	46375	1	applied	\N	\N	\N	\N	142459	142459	142460
28460	46378	0	applied	\N	\N	\N	\N	142473	142473	142474
28460	46379	1	applied	\N	\N	\N	\N	142475	142475	142476
28466	46382	0	applied	\N	\N	\N	\N	142489	142489	142490
28466	46383	1	applied	\N	\N	\N	\N	142491	142491	142492
28472	46394	0	applied	\N	\N	\N	\N	142524	142524	142525
28472	46395	1	applied	\N	\N	\N	\N	142526	142526	142527
28477	46403	0	applied	\N	\N	\N	\N	142545	142545	142546
28477	46404	1	applied	\N	\N	\N	\N	142547	142547	142548
28482	46407	0	applied	\N	\N	\N	\N	142560	142560	142561
28482	46408	1	applied	\N	\N	\N	\N	142562	142562	142563
28484	46407	0	applied	\N	\N	\N	\N	142560	142560	142561
28484	46408	1	applied	\N	\N	\N	\N	142562	142562	142563
28488	46411	0	applied	\N	\N	\N	\N	142580	142580	142581
28488	46412	1	applied	\N	\N	\N	\N	142582	142582	138833
28488	46413	2	applied	\N	\N	\N	\N	142583	142583	142584
28491	46416	0	applied	\N	\N	\N	\N	142590	142590	142591
28491	46417	1	applied	\N	\N	\N	\N	142592	142592	142593
28491	46418	2	applied	\N	\N	\N	\N	142594	142594	142595
28491	46419	3	applied	\N	\N	\N	\N	142596	142596	142597
28491	46420	4	applied	\N	\N	\N	\N	142598	142598	142599
28491	46421	5	applied	\N	\N	\N	\N	142600	142600	142601
28491	46422	6	applied	\N	\N	\N	\N	142602	142602	142603
28493	46423	0	applied	\N	\N	\N	\N	142607	142607	142608
28493	46424	1	applied	\N	\N	\N	\N	142609	142609	142610
28498	46427	0	applied	\N	\N	\N	\N	142625	142625	142626
28498	46428	1	applied	\N	\N	\N	\N	142627	142627	142628
28498	46429	2	applied	\N	\N	\N	\N	142629	142629	142630
28498	46430	3	applied	\N	\N	\N	\N	142631	142631	142632
28498	46431	4	applied	\N	\N	\N	\N	142633	142633	142634
28498	46432	5	applied	\N	\N	\N	\N	142635	142635	142636
28498	46433	6	applied	\N	\N	\N	\N	142637	142637	142638
28503	46439	0	applied	\N	\N	\N	\N	142655	142655	142656
28503	46440	1	applied	\N	\N	\N	\N	142657	142657	142658
28503	46441	2	applied	\N	\N	\N	\N	142659	142659	142660
28507	46442	0	applied	\N	\N	\N	\N	142667	142667	142668
28507	46443	1	applied	\N	\N	\N	\N	142669	142669	142670
28509	46444	0	applied	\N	\N	\N	\N	142678	142678	142679
28509	46445	1	applied	\N	\N	\N	\N	142680	142680	142681
28509	46446	2	applied	\N	\N	\N	\N	142682	142682	142683
28513	46447	0	applied	\N	\N	\N	\N	142690	142690	142691
28513	46448	1	applied	\N	\N	\N	\N	142692	142692	142693
28513	46449	2	applied	\N	\N	1000000000	\N	142694	142694	142695
28513	46450	3	applied	\N	\N	\N	\N	142696	142696	142697
28513	46451	4	applied	\N	\N	\N	\N	142698	142698	142699
28516	46452	0	applied	\N	\N	\N	\N	142706	142706	142707
28516	46453	1	applied	\N	\N	\N	\N	142708	142708	142709
28516	46454	2	applied	\N	\N	\N	\N	142710	142710	142711
28516	46455	3	applied	\N	\N	\N	\N	142712	142712	142713
28520	46459	0	applied	\N	\N	\N	\N	142726	142726	142727
28520	46460	1	applied	\N	\N	\N	\N	142728	142728	142729
28520	46461	2	applied	\N	\N	\N	\N	142730	142730	142731
28522	46459	0	applied	\N	\N	\N	\N	142726	142726	142727
28522	46460	1	applied	\N	\N	\N	\N	142728	142728	142729
28522	46461	2	applied	\N	\N	\N	\N	142730	142730	142731
28524	46462	0	applied	\N	\N	\N	\N	142736	142736	142737
28524	46463	1	applied	\N	\N	\N	\N	142738	142738	142739
28524	46464	2	applied	\N	\N	\N	\N	142740	142740	142741
28524	46465	3	applied	\N	\N	\N	\N	142742	142742	142743
28524	46466	4	applied	\N	\N	\N	\N	142744	142744	142745
28529	46473	0	applied	\N	\N	\N	\N	142759	142759	142760
28529	46474	1	applied	\N	\N	\N	\N	142761	142761	75428
28529	46475	2	applied	\N	\N	\N	\N	142762	142762	142763
28529	46476	3	applied	\N	\N	\N	\N	142764	142764	76228
28534	46488	0	applied	\N	\N	\N	\N	142791	142791	142792
28534	46489	1	applied	\N	\N	\N	\N	142793	142793	142794
28536	46490	0	applied	\N	\N	\N	\N	142801	142801	142802
28536	46491	1	applied	\N	\N	1000000000	\N	142803	142803	142804
28536	46492	2	applied	\N	\N	\N	\N	142805	142805	75876
28536	46493	3	applied	\N	\N	\N	\N	142806	142806	75877
28428	46303	22	applied	\N	\N	\N	\N	142249	142249	142250
28428	46305	23	applied	\N	\N	\N	\N	142253	142253	142254
28428	46309	24	applied	\N	\N	\N	\N	142262	142262	142263
28428	46310	25	applied	\N	\N	\N	\N	142264	142264	142265
28428	46313	26	applied	\N	\N	\N	\N	142271	142271	142272
28428	46314	27	applied	\N	\N	\N	\N	142273	142273	142274
28428	46316	28	applied	\N	\N	\N	\N	142281	142281	142282
28428	46324	29	applied	\N	\N	\N	\N	142301	142301	142302
28428	46325	30	applied	\N	\N	\N	\N	142303	142303	142304
28428	46326	31	applied	\N	\N	\N	\N	142305	142305	142306
28428	46327	32	applied	\N	\N	\N	\N	142307	142307	142308
28428	46328	33	applied	\N	\N	\N	\N	142309	142309	142310
28428	46329	34	applied	\N	\N	\N	\N	142311	142311	142312
28428	46330	35	applied	\N	\N	\N	\N	142313	142313	142314
28428	46332	36	applied	\N	\N	\N	\N	142318	142318	142319
28431	46337	0	applied	\N	\N	\N	\N	142336	142336	142337
28431	46338	1	applied	\N	\N	\N	\N	142338	142338	142339
28433	46339	0	applied	\N	\N	\N	\N	142343	142343	142344
28433	46340	2	applied	\N	\N	\N	\N	142346	142346	142347
28436	46270	0	applied	\N	\N	1000000000	\N	142135	142135	142157
28436	46275	1	applied	\N	\N	\N	\N	142150	142150	142158
28436	46223	2	applied	\N	\N	1000000000	\N	141978	141978	141979
28436	46237	3	applied	\N	\N	\N	\N	142022	142022	142151
28436	46294	4	applied	\N	\N	1000000000	\N	142216	142216	142217
28436	46344	5	applied	\N	\N	1000000000	\N	142356	142356	142357
28436	46047	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28436	46224	7	applied	\N	\N	1000000000	\N	141980	141980	141981
28436	46070	8	applied	\N	\N	\N	\N	141509	141509	141509
28436	46106	9	applied	\N	\N	\N	\N	141644	141644	141644
28436	46136	10	applied	\N	\N	\N	\N	141729	141729	111296
28436	45966	11	applied	\N	\N	\N	\N	141207	141207	140192
28436	45971	12	applied	\N	\N	\N	\N	141228	141228	142371
28436	46127	13	applied	\N	\N	\N	\N	141707	141707	141707
28436	46076	14	applied	\N	\N	1000000000	\N	141543	141543	141544
28436	45978	15	applied	\N	\N	\N	\N	141245	141245	142372
28436	45988	16	applied	\N	\N	\N	\N	141270	141270	140201
28436	45994	17	applied	\N	\N	\N	\N	141292	141292	142373
28436	46001	18	applied	\N	\N	\N	\N	141310	141310	142374
28436	46011	19	applied	\N	\N	\N	\N	141338	141338	140203
28436	46017	20	applied	\N	\N	\N	\N	141355	141355	142375
28436	46024	21	applied	\N	\N	\N	\N	141375	141375	140205
28436	46036	22	applied	\N	\N	\N	\N	141410	141410	142376
28436	46043	23	applied	\N	\N	\N	\N	141433	141433	140207
28436	46051	24	applied	\N	\N	\N	\N	141453	141453	142377
28436	46061	25	applied	\N	\N	\N	\N	141482	141482	142378
28436	46067	26	applied	\N	\N	\N	\N	141501	141501	140216
28436	46077	27	applied	\N	\N	\N	\N	141545	141545	142379
28436	46086	28	applied	\N	\N	\N	\N	141572	141572	140218
28436	46093	29	applied	\N	\N	\N	\N	141596	141596	142380
28436	46100	30	applied	\N	\N	\N	\N	141624	141624	142381
28436	46109	31	applied	\N	\N	\N	\N	141651	141651	140276
28436	46116	32	applied	\N	\N	\N	\N	141679	141679	142382
28436	46123	33	applied	\N	\N	\N	\N	141697	141697	140281
28436	46135	34	applied	\N	\N	\N	\N	141727	141727	142383
28436	46049	35	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28436	46141	36	applied	\N	\N	\N	\N	141742	141742	142384
28436	46148	37	applied	\N	\N	\N	\N	141758	141758	140283
28436	46155	38	applied	\N	\N	\N	\N	141775	141775	142385
28436	46162	39	applied	\N	\N	\N	\N	141790	141790	140291
28436	46171	40	applied	\N	\N	\N	\N	141834	141834	142386
28438	46348	0	applied	\N	\N	\N	\N	142365	142365	142366
28438	46349	1	applied	\N	\N	\N	\N	142367	142367	142368
28440	46350	0	applied	\N	\N	\N	\N	142393	142393	142394
28440	46351	1	applied	\N	\N	\N	\N	142395	142395	142396
28443	46355	0	applied	\N	\N	\N	\N	142406	142406	142407
28443	46356	1	applied	\N	\N	\N	\N	142408	142408	142409
28445	46357	0	applied	\N	\N	\N	\N	142412	142412	142413
28445	46358	1	applied	\N	\N	\N	\N	142414	142414	142415
28445	46359	2	applied	\N	\N	\N	\N	142416	142416	142403
28445	46360	3	applied	\N	\N	\N	\N	142417	142417	142418
28445	46361	4	applied	\N	\N	\N	\N	142419	142419	142420
28448	46362	0	applied	\N	\N	\N	\N	142423	142423	142424
28448	46363	1	applied	\N	\N	\N	\N	142425	142425	142426
28448	46364	2	applied	\N	\N	\N	\N	142427	142427	142428
28448	46365	3	applied	\N	\N	\N	\N	142429	142429	142430
28450	46366	0	applied	\N	\N	\N	\N	142436	142436	142437
28450	46367	1	applied	\N	\N	\N	\N	142438	142438	142439
28456	46374	0	applied	\N	\N	\N	\N	142457	142457	142458
28456	46375	1	applied	\N	\N	\N	\N	142459	142459	142460
28464	46382	0	applied	\N	\N	\N	\N	142489	142489	142490
28464	46383	1	applied	\N	\N	\N	\N	142491	142491	142492
28475	46401	0	applied	\N	\N	\N	\N	142541	142541	142542
28475	46402	1	applied	\N	\N	\N	\N	142543	142543	142544
28486	46409	0	applied	\N	\N	\N	\N	142572	142572	142573
28486	46410	1	applied	\N	\N	\N	\N	142574	142574	142575
28496	46425	0	applied	\N	\N	\N	\N	142615	142615	142616
28496	46426	1	applied	\N	\N	\N	\N	142617	142617	142618
28499	46434	0	applied	\N	\N	\N	\N	142641	142641	142642
28499	46435	1	applied	\N	\N	\N	\N	142643	142643	142644
28501	46436	0	applied	\N	\N	\N	\N	142646	142646	142647
28501	46437	1	applied	\N	\N	\N	\N	142648	142648	142649
28501	46438	2	applied	\N	\N	\N	\N	142650	142650	142651
28504	46439	0	applied	\N	\N	\N	\N	142655	142655	142656
28504	46440	1	applied	\N	\N	\N	\N	142657	142657	142658
28504	46441	2	applied	\N	\N	\N	\N	142659	142659	142660
28506	46439	0	applied	\N	\N	\N	\N	142655	142655	142656
28506	46440	1	applied	\N	\N	\N	\N	142657	142657	142658
28506	46441	2	applied	\N	\N	\N	\N	142659	142659	142660
28508	46270	0	applied	\N	\N	1000000000	\N	142135	142135	142157
28508	46275	1	applied	\N	\N	\N	\N	142150	142150	142158
28508	46223	2	applied	\N	\N	1000000000	\N	141978	141978	141979
28508	46237	3	applied	\N	\N	\N	\N	142022	142022	142151
28508	46294	4	applied	\N	\N	1000000000	\N	142216	142216	142217
28508	46412	5	applied	\N	\N	\N	\N	142582	142582	138833
28508	46419	6	applied	\N	\N	\N	\N	142596	142596	142597
28508	46344	7	applied	\N	\N	1000000000	\N	142356	142356	142357
28508	46047	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	141441	141441	\N
28508	46224	9	applied	\N	\N	1000000000	\N	141980	141980	141981
28508	46070	10	applied	\N	\N	\N	\N	141509	141509	141509
28508	46106	11	applied	\N	\N	\N	\N	141644	141644	141644
28508	46431	12	applied	\N	\N	\N	\N	142633	142633	142673
28508	46136	13	applied	\N	\N	\N	\N	141729	141729	111296
28508	46127	14	applied	\N	\N	\N	\N	141707	141707	141707
28508	46076	15	applied	\N	\N	1000000000	\N	141543	141543	141544
28508	46354	16	applied	\N	\N	\N	\N	142403	142403	142404
28508	46049	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	141444	141444	\N
28446	46364	2	applied	\N	\N	\N	\N	142427	142427	142428
28446	46365	3	applied	\N	\N	\N	\N	142429	142429	142430
28451	46366	0	applied	\N	\N	\N	\N	142436	142436	142437
28451	46367	1	applied	\N	\N	\N	\N	142438	142438	142439
28452	46368	0	applied	\N	\N	\N	\N	142443	142443	142444
28452	46369	1	applied	\N	\N	\N	\N	142445	142445	142446
28452	46370	2	applied	\N	\N	\N	\N	142447	142447	142448
28452	46371	3	applied	\N	\N	\N	\N	142449	142449	142450
28452	46372	4	applied	\N	\N	\N	\N	142451	142451	142452
28452	46373	5	applied	\N	\N	\N	\N	142453	142453	142454
28453	46374	0	applied	\N	\N	\N	\N	142457	142457	142458
28453	46375	1	applied	\N	\N	\N	\N	142459	142459	142460
28457	46376	0	applied	\N	\N	\N	\N	142466	142466	142467
28457	46377	1	applied	\N	\N	\N	\N	142468	142468	142469
28461	46378	0	applied	\N	\N	\N	\N	142473	142473	142474
28461	46379	1	applied	\N	\N	\N	\N	142475	142475	142476
28465	46382	0	applied	\N	\N	\N	\N	142489	142489	142490
28465	46383	1	applied	\N	\N	\N	\N	142491	142491	142492
28468	46344	0	applied	\N	\N	1000000000	\N	142356	142356	142357
28468	46354	1	applied	\N	\N	\N	\N	142403	142403	142404
28470	46386	0	applied	\N	\N	\N	\N	142502	142502	142503
28470	46387	1	applied	\N	\N	\N	\N	142504	142504	142505
28470	46388	2	applied	\N	\N	\N	\N	142506	142506	142507
28470	46389	3	applied	\N	\N	\N	\N	142508	142508	142509
28473	46396	0	applied	\N	\N	\N	\N	142530	142530	142531
28473	46397	1	applied	\N	\N	\N	\N	142532	142532	142022
28473	46398	2	applied	\N	\N	\N	\N	142533	142533	142534
28476	46403	0	applied	\N	\N	\N	\N	142545	142545	142546
28476	46404	1	applied	\N	\N	\N	\N	142547	142547	142548
28478	46405	0	applied	\N	\N	\N	\N	142552	142552	142553
28478	46406	1	applied	\N	\N	\N	\N	142554	142554	142555
28480	46405	0	applied	\N	\N	\N	\N	142552	142552	142553
28480	46406	1	applied	\N	\N	\N	\N	142554	142554	142555
28487	46409	0	applied	\N	\N	\N	\N	142572	142572	142573
28487	46410	1	applied	\N	\N	\N	\N	142574	142574	142575
28489	46414	0	applied	\N	\N	\N	\N	142586	142586	142587
28489	46415	1	applied	\N	\N	\N	\N	142588	142588	142589
28490	46416	0	applied	\N	\N	\N	\N	142590	142590	142591
28490	46417	1	applied	\N	\N	\N	\N	142592	142592	142593
28490	46418	2	applied	\N	\N	\N	\N	142594	142594	142595
28490	46419	3	applied	\N	\N	\N	\N	142596	142596	142597
28490	46420	4	applied	\N	\N	\N	\N	142598	142598	142599
28490	46421	5	applied	\N	\N	\N	\N	142600	142600	142601
28490	46422	6	applied	\N	\N	\N	\N	142602	142602	142603
28492	46416	0	applied	\N	\N	\N	\N	142590	142590	142591
28492	46417	1	applied	\N	\N	\N	\N	142592	142592	142593
28492	46418	2	applied	\N	\N	\N	\N	142594	142594	142595
28492	46419	3	applied	\N	\N	\N	\N	142596	142596	142597
28492	46420	4	applied	\N	\N	\N	\N	142598	142598	142599
28492	46421	5	applied	\N	\N	\N	\N	142600	142600	142601
28492	46422	6	applied	\N	\N	\N	\N	142602	142602	142603
28494	46423	0	applied	\N	\N	\N	\N	142607	142607	142608
28494	46424	1	applied	\N	\N	\N	\N	142609	142609	142610
28497	46425	0	applied	\N	\N	\N	\N	142615	142615	142616
28497	46426	1	applied	\N	\N	\N	\N	142617	142617	142618
28502	46436	0	applied	\N	\N	\N	\N	142646	142646	142647
28502	46437	1	applied	\N	\N	\N	\N	142648	142648	142649
28502	46438	2	applied	\N	\N	\N	\N	142650	142650	142651
28510	46444	0	applied	\N	\N	\N	\N	142678	142678	142679
28510	46445	1	applied	\N	\N	\N	\N	142680	142680	142681
28510	46446	2	applied	\N	\N	\N	\N	142682	142682	142683
28512	46447	0	applied	\N	\N	\N	\N	142690	142690	142691
28512	46448	1	applied	\N	\N	\N	\N	142692	142692	142693
28512	46449	2	applied	\N	\N	1000000000	\N	142694	142694	142695
28512	46450	3	applied	\N	\N	\N	\N	142696	142696	142697
28512	46451	4	applied	\N	\N	\N	\N	142698	142698	142699
28514	46447	0	applied	\N	\N	\N	\N	142690	142690	142691
28514	46448	1	applied	\N	\N	\N	\N	142692	142692	142693
28514	46449	2	applied	\N	\N	1000000000	\N	142694	142694	142695
28514	46450	3	applied	\N	\N	\N	\N	142696	142696	142697
28514	46451	4	applied	\N	\N	\N	\N	142698	142698	142699
28517	46449	0	applied	\N	\N	1000000000	\N	142694	142694	142695
28517	46450	1	applied	\N	\N	\N	\N	142696	142696	142697
28521	46459	0	applied	\N	\N	\N	\N	142726	142726	142727
28521	46460	1	applied	\N	\N	\N	\N	142728	142728	142729
28521	46461	2	applied	\N	\N	\N	\N	142730	142730	142731
28523	46462	0	applied	\N	\N	\N	\N	142736	142736	142737
28523	46463	1	applied	\N	\N	\N	\N	142738	142738	142739
28523	46464	2	applied	\N	\N	\N	\N	142740	142740	142741
28523	46465	3	applied	\N	\N	\N	\N	142742	142742	142743
28523	46466	4	applied	\N	\N	\N	\N	142744	142744	142745
28528	46473	0	applied	\N	\N	\N	\N	142759	142759	142760
28528	46474	1	applied	\N	\N	\N	\N	142761	142761	75428
28528	46475	2	applied	\N	\N	\N	\N	142762	142762	142763
28528	46476	3	applied	\N	\N	\N	\N	142764	142764	76228
28530	46477	0	applied	\N	\N	\N	\N	142771	142771	142772
28530	46478	1	applied	\N	\N	\N	\N	142773	142773	142774
28530	46479	2	applied	\N	\N	\N	\N	142775	142775	142776
28533	46488	0	applied	\N	\N	\N	\N	142791	142791	142792
28533	46489	1	applied	\N	\N	\N	\N	142793	142793	142794
28537	46494	0	applied	\N	\N	\N	\N	142809	142809	142810
28537	46495	1	applied	\N	\N	\N	\N	142811	142811	75878
28540	46494	0	applied	\N	\N	\N	\N	142809	142809	142810
28540	46495	1	applied	\N	\N	\N	\N	142811	142811	75878
28542	46397	0	applied	\N	\N	\N	\N	142532	142532	142022
28542	46412	1	applied	\N	\N	\N	\N	142582	142582	138833
28542	46359	2	applied	\N	\N	\N	\N	142821	142821	142356
28542	46419	3	applied	\N	\N	\N	\N	142596	142596	142597
28542	46468	4	applied	\N	\N	\N	\N	142822	142822	142823
28542	46454	5	applied	\N	\N	\N	\N	142710	142710	72621
28542	46465	6	applied	\N	\N	\N	\N	142742	142742	142824
28542	46449	7	applied	\N	\N	1000000000	\N	142694	142694	142695
28542	46450	8	applied	\N	\N	\N	\N	142696	142696	142697
28542	46354	9	applied	\N	\N	\N	\N	142403	142403	142416
28542	46471	10	applied	\N	\N	\N	\N	142755	142755	142825
28542	46475	11	applied	\N	\N	\N	\N	142762	142762	142826
28542	46487	12	applied	\N	\N	\N	\N	142788	142788	142827
28542	46492	13	applied	\N	\N	\N	\N	142805	142805	72623
28542	46498	14	applied	\N	\N	\N	\N	142828	142828	142829
28542	46472	15	applied	\N	\N	\N	\N	142756	142756	142830
28542	46491	16	applied	\N	\N	1000000000	\N	142803	142803	142804
28544	46503	0	applied	\N	\N	\N	\N	142840	142840	142841
28544	46504	1	applied	\N	\N	\N	\N	142842	142842	142843
28544	46505	2	applied	\N	\N	\N	\N	142844	142844	75498
28550	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28550	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28557	46512	0	applied	\N	\N	\N	\N	142863	142863	142864
28557	46513	1	applied	\N	\N	\N	\N	142865	142865	75513
28557	46514	2	applied	\N	\N	\N	\N	142866	142866	75892
28459	46378	0	applied	\N	\N	\N	\N	142473	142473	142474
28459	46379	1	applied	\N	\N	\N	\N	142475	142475	142476
28462	46380	0	applied	\N	\N	\N	\N	142481	142481	142482
28462	46381	1	applied	\N	\N	\N	\N	142483	142483	142484
28463	46380	0	applied	\N	\N	\N	\N	142481	142481	142482
28463	46381	1	applied	\N	\N	\N	\N	142483	142483	142484
28467	46384	0	applied	\N	\N	\N	\N	142495	142495	142496
28467	46385	1	applied	\N	\N	\N	\N	142497	142497	142498
28469	46386	0	applied	\N	\N	\N	\N	142502	142502	142503
28469	46387	1	applied	\N	\N	\N	\N	142504	142504	142505
28469	46388	2	applied	\N	\N	\N	\N	142506	142506	142507
28469	46389	3	applied	\N	\N	\N	\N	142508	142508	142509
28471	46390	0	applied	\N	\N	\N	\N	142514	142514	142515
28471	46391	1	applied	\N	\N	\N	\N	142516	142516	142517
28471	46392	2	applied	\N	\N	\N	\N	142518	142518	142519
28471	46393	3	applied	\N	\N	\N	\N	142520	142520	142521
28474	46399	0	applied	\N	\N	\N	\N	142537	142537	142538
28474	46400	1	applied	\N	\N	\N	\N	142539	142539	142540
28479	46405	0	applied	\N	\N	\N	\N	142552	142552	142553
28479	46406	1	applied	\N	\N	\N	\N	142554	142554	142555
28481	46407	0	applied	\N	\N	\N	\N	142560	142560	142561
28481	46408	1	applied	\N	\N	\N	\N	142562	142562	142563
28483	46407	0	applied	\N	\N	\N	\N	142560	142560	142561
28483	46408	1	applied	\N	\N	\N	\N	142562	142562	142563
28485	46409	0	applied	\N	\N	\N	\N	142572	142572	142573
28485	46410	1	applied	\N	\N	\N	\N	142574	142574	142575
28495	46425	0	applied	\N	\N	\N	\N	142615	142615	142616
28495	46426	1	applied	\N	\N	\N	\N	142617	142617	142618
28500	46436	0	applied	\N	\N	\N	\N	142646	142646	142647
28500	46437	1	applied	\N	\N	\N	\N	142648	142648	142649
28500	46438	2	applied	\N	\N	\N	\N	142650	142650	142651
28505	46439	0	applied	\N	\N	\N	\N	142655	142655	142656
28505	46440	1	applied	\N	\N	\N	\N	142657	142657	142658
28505	46441	2	applied	\N	\N	\N	\N	142659	142659	142660
28511	46444	0	applied	\N	\N	\N	\N	142678	142678	142679
28511	46445	1	applied	\N	\N	\N	\N	142680	142680	142681
28511	46446	2	applied	\N	\N	\N	\N	142682	142682	142683
28515	46452	0	applied	\N	\N	\N	\N	142706	142706	142707
28515	46453	1	applied	\N	\N	\N	\N	142708	142708	142709
28515	46454	2	applied	\N	\N	\N	\N	142710	142710	142711
28515	46455	3	applied	\N	\N	\N	\N	142712	142712	142713
28519	46456	0	applied	\N	\N	\N	\N	142719	142719	142720
28519	46457	1	applied	\N	\N	\N	\N	142721	142721	142722
28519	46458	2	applied	\N	\N	\N	\N	142723	142723	142724
28526	46467	0	applied	\N	\N	\N	\N	142750	142750	142751
28526	46468	1	applied	\N	\N	\N	\N	75422	75422	142752
28526	46469	2	applied	\N	\N	\N	\N	142753	142753	76226
28526	46470	3	applied	\N	\N	\N	\N	142754	142754	76227
28526	46471	4	applied	\N	\N	\N	\N	142755	142755	75426
28526	46472	5	applied	\N	\N	\N	\N	142756	142756	142757
28531	46480	0	applied	\N	\N	\N	\N	142778	142778	142779
28531	46481	1	applied	\N	\N	\N	\N	142780	142780	142781
28531	46482	2	applied	\N	\N	\N	\N	142782	142782	75872
28531	46483	3	applied	\N	\N	\N	\N	142783	142783	75442
28531	46484	4	applied	\N	\N	\N	\N	142784	142784	76230
28531	46485	5	applied	\N	\N	\N	\N	142785	142785	142786
28531	46486	6	applied	\N	\N	\N	\N	142787	142787	75450
28531	46487	7	applied	\N	\N	\N	\N	142788	142788	75875
28538	46494	0	applied	\N	\N	\N	\N	142809	142809	142810
28538	46495	1	applied	\N	\N	\N	\N	142811	142811	75878
28545	46503	0	applied	\N	\N	\N	\N	142840	142840	142841
28545	46504	1	applied	\N	\N	\N	\N	142842	142842	142843
28545	46505	2	applied	\N	\N	\N	\N	142844	142844	75498
28547	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28547	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28551	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28551	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28553	46508	0	applied	\N	\N	\N	\N	142855	142855	142856
28553	46509	1	applied	\N	\N	\N	\N	142857	142857	75885
28553	46510	2	applied	\N	\N	\N	\N	142858	142858	75502
28553	46511	3	applied	\N	\N	\N	\N	142859	142859	75888
28555	46508	0	applied	\N	\N	\N	\N	142855	142855	142856
28555	46509	1	applied	\N	\N	\N	\N	142857	142857	75885
28555	46510	2	applied	\N	\N	\N	\N	142858	142858	75502
28555	46511	3	applied	\N	\N	\N	\N	142859	142859	75888
28558	46515	0	applied	\N	\N	\N	\N	142869	142869	142870
28558	46516	1	applied	\N	\N	\N	\N	142871	142871	142872
28558	46517	2	applied	\N	\N	1000000000	\N	142873	142873	142874
28558	46518	3	applied	\N	\N	\N	\N	142875	142875	75524
28558	46519	4	applied	\N	\N	\N	\N	142876	142876	76232
28558	46520	5	applied	\N	\N	\N	\N	142877	142877	75894
28558	46521	6	applied	\N	\N	\N	\N	142878	142878	75538
28561	46525	0	applied	\N	\N	\N	\N	142888	142888	142889
28561	46526	1	applied	\N	\N	\N	\N	142890	142890	142891
28561	46527	2	applied	\N	\N	\N	\N	142892	142892	142893
28561	46528	3	applied	\N	\N	\N	\N	142894	142894	75552
28561	46529	4	applied	\N	\N	\N	\N	142895	142895	75559
28561	46530	5	applied	\N	\N	\N	\N	142896	142896	75560
28561	46531	6	applied	\N	\N	\N	\N	142897	142897	75568
28561	46532	7	applied	\N	\N	\N	\N	142898	142898	142899
28561	46533	8	applied	\N	\N	\N	\N	142900	142900	75582
28563	46534	0	applied	\N	\N	\N	\N	142903	142903	142904
28563	46535	1	applied	\N	\N	\N	\N	142905	142905	75901
28563	46536	2	applied	\N	\N	\N	\N	142906	142906	75593
28571	46553	0	applied	\N	\N	\N	\N	142956	142956	142957
28571	46554	1	applied	\N	\N	\N	\N	142958	142958	142959
28571	46555	2	applied	\N	\N	\N	\N	142960	142960	142961
28571	46556	3	applied	\N	\N	\N	\N	142962	142962	29193
28571	46557	4	applied	\N	\N	\N	\N	142963	142963	75661
28571	46558	5	applied	\N	\N	\N	\N	142964	142964	75690
28573	46462	0	applied	\N	\N	\N	\N	142736	142736	142737
28573	46463	1	applied	\N	\N	\N	\N	142738	142738	142739
28573	46467	2	applied	\N	\N	\N	\N	142750	142750	142751
28573	46473	3	applied	\N	\N	\N	\N	142759	142759	142760
28573	46477	4	applied	\N	\N	\N	\N	142771	142771	142772
28573	46480	5	applied	\N	\N	\N	\N	142778	142778	142779
28573	46481	6	applied	\N	\N	\N	\N	142780	142780	142781
28573	46488	7	applied	\N	\N	\N	\N	142791	142791	142792
28573	46490	8	applied	\N	\N	\N	\N	142801	142801	142802
28573	46494	9	applied	\N	\N	\N	\N	142809	142809	142810
28573	46496	10	applied	\N	\N	\N	\N	142816	142816	142817
28573	46499	11	applied	\N	\N	\N	\N	142833	142833	142834
28573	46503	12	applied	\N	\N	\N	\N	142840	142840	142841
28573	46506	13	applied	\N	\N	\N	\N	142850	142850	142851
28573	46508	14	applied	\N	\N	\N	\N	142855	142855	142856
28573	46512	15	applied	\N	\N	\N	\N	142863	142863	142864
28573	46515	16	applied	\N	\N	\N	\N	142869	142869	142870
28573	46516	17	applied	\N	\N	\N	\N	142871	142871	142872
28573	46522	18	applied	\N	\N	\N	\N	142881	142881	142882
28573	46525	19	applied	\N	\N	\N	\N	142888	142888	142889
28508	46438	18	applied	\N	\N	\N	\N	142650	142650	141248
28508	46441	19	applied	\N	\N	\N	\N	142659	142659	142674
28508	46443	20	applied	\N	\N	\N	\N	142669	142669	142675
28518	46452	0	applied	\N	\N	\N	\N	142706	142706	142707
28518	46453	1	applied	\N	\N	\N	\N	142708	142708	142709
28518	46454	2	applied	\N	\N	\N	\N	142710	142710	142711
28518	46455	3	applied	\N	\N	\N	\N	142712	142712	142713
28525	46462	0	applied	\N	\N	\N	\N	142736	142736	142737
28525	46463	1	applied	\N	\N	\N	\N	142738	142738	142739
28525	46464	2	applied	\N	\N	\N	\N	142740	142740	142741
28525	46465	3	applied	\N	\N	\N	\N	142742	142742	142743
28525	46466	4	applied	\N	\N	\N	\N	142744	142744	142745
28527	46473	0	applied	\N	\N	\N	\N	142759	142759	142760
28527	46474	1	applied	\N	\N	\N	\N	142761	142761	75428
28527	46475	2	applied	\N	\N	\N	\N	142762	142762	142763
28527	46476	3	applied	\N	\N	\N	\N	142764	142764	76228
28532	46488	0	applied	\N	\N	\N	\N	142791	142791	142792
28532	46489	1	applied	\N	\N	\N	\N	142793	142793	142794
28535	46488	0	applied	\N	\N	\N	\N	142791	142791	142792
28535	46489	1	applied	\N	\N	\N	\N	142793	142793	142794
28539	46494	0	applied	\N	\N	\N	\N	142809	142809	142810
28539	46495	1	applied	\N	\N	\N	\N	142811	142811	75878
28541	46496	0	applied	\N	\N	\N	\N	142816	142816	142817
28541	46497	2	applied	\N	\N	\N	\N	142819	142819	75879
28546	46503	0	applied	\N	\N	\N	\N	142840	142840	142841
28546	46505	1	applied	\N	\N	\N	\N	142844	142844	75491
28549	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28549	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28559	46512	0	applied	\N	\N	\N	\N	142863	142863	142864
28559	46515	1	applied	\N	\N	\N	\N	142869	142869	142870
28559	46516	2	applied	\N	\N	\N	\N	142871	142871	142872
28559	46522	3	applied	\N	\N	\N	\N	142881	142881	142882
28559	46517	4	applied	\N	\N	1000000000	\N	142873	142873	142874
28559	46521	5	applied	\N	\N	\N	\N	142878	142878	75511
28559	46513	6	applied	\N	\N	\N	\N	142865	142865	75515
28559	46518	7	applied	\N	\N	\N	\N	142875	142875	76231
28559	46523	8	applied	\N	\N	\N	\N	142883	142883	75536
28559	46514	9	applied	\N	\N	\N	\N	142866	142866	75538
28559	46519	10	applied	\N	\N	\N	\N	142876	142876	75895
28559	46520	11	applied	\N	\N	\N	\N	142877	142877	77076
28559	46524	12	applied	\N	\N	\N	\N	142884	142884	75542
28567	46544	0	applied	\N	\N	\N	\N	142924	142924	142925
28567	46545	1	applied	\N	\N	\N	\N	142926	142926	142927
28567	46546	2	applied	\N	\N	\N	\N	142928	142928	142929
28567	46547	3	applied	\N	\N	\N	\N	142930	142930	142931
28567	46548	4	applied	\N	\N	\N	\N	142932	142932	75636
28567	46549	5	applied	\N	\N	\N	\N	142933	142933	142934
28567	46550	6	applied	\N	\N	\N	\N	142935	142935	75647
28567	46551	7	applied	\N	\N	\N	\N	142936	142936	75649
28567	46552	8	applied	\N	\N	\N	\N	142937	142937	142938
28569	46397	0	applied	\N	\N	\N	\N	142532	142532	142022
28569	46412	1	applied	\N	\N	\N	\N	142582	142582	138833
28569	46419	2	applied	\N	\N	\N	\N	142596	142596	142597
28569	46468	3	applied	\N	\N	\N	\N	72934	72934	142823
28569	46454	4	applied	\N	\N	\N	\N	142710	142710	142942
28569	46465	6	applied	\N	\N	\N	\N	142742	142742	142824
28569	46449	7	applied	\N	\N	1000000000	\N	142694	142694	142695
28569	46450	8	applied	\N	\N	\N	\N	142696	142696	142697
28569	46471	9	applied	\N	\N	\N	\N	142755	142755	72943
28569	46475	10	applied	\N	\N	\N	\N	142762	142762	142826
28569	46487	11	applied	\N	\N	\N	\N	142788	142788	142944
28569	46492	12	applied	\N	\N	\N	\N	142805	142805	72945
28569	46498	13	applied	\N	\N	\N	\N	142828	142828	142945
28569	46509	14	applied	\N	\N	\N	\N	142857	142857	142946
28569	46521	15	applied	\N	\N	\N	\N	142878	142878	72948
28569	46533	16	applied	\N	\N	\N	\N	142900	142900	142947
28569	46540	17	applied	\N	\N	\N	\N	142915	142915	142948
28569	46549	18	applied	\N	\N	\N	\N	142933	142933	72950
28569	46472	19	applied	\N	\N	\N	\N	142756	142756	142830
28569	46491	20	applied	\N	\N	1000000000	\N	142803	142803	142804
28569	46517	21	applied	\N	\N	1000000000	\N	142873	142873	142874
28574	46553	0	applied	\N	\N	\N	\N	142956	142956	142957
28574	46554	1	applied	\N	\N	\N	\N	142958	142958	142959
28574	46555	2	applied	\N	\N	\N	\N	142960	142960	142961
28574	46556	3	applied	\N	\N	\N	\N	142962	142962	29193
28574	46557	4	applied	\N	\N	\N	\N	142963	142963	75661
28574	46558	5	applied	\N	\N	\N	\N	142964	142964	75690
28582	46567	0	applied	\N	\N	\N	\N	143028	143028	143029
28582	46568	1	applied	\N	\N	\N	\N	143030	143030	143031
28582	46569	2	applied	\N	\N	\N	\N	143032	143032	143033
28582	46570	3	applied	\N	\N	\N	\N	143034	143034	143035
28582	46571	4	applied	\N	\N	\N	\N	143036	143036	75715
28583	46572	0	applied	\N	\N	\N	\N	143041	143041	143042
28583	46573	1	applied	\N	\N	\N	\N	143043	143043	143044
28583	46574	2	applied	\N	\N	\N	\N	143045	143045	75717
28583	46575	3	applied	\N	\N	\N	\N	143046	143046	75726
28586	46585	0	applied	\N	\N	\N	\N	143065	143065	143066
28586	46586	1	applied	\N	\N	\N	\N	143067	143067	143068
28586	46587	2	applied	\N	\N	\N	\N	143069	143069	143070
28589	46588	0	applied	\N	\N	\N	\N	143075	143075	143076
28589	46589	2	applied	\N	\N	\N	\N	143078	143078	75763
28589	46590	3	applied	\N	\N	\N	\N	143079	143079	143080
28593	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28593	46596	1	applied	\N	\N	\N	\N	143100	143100	143101
28593	46597	2	applied	\N	\N	\N	\N	143102	143102	143103
28593	46598	3	applied	\N	\N	\N	\N	143104	143104	143105
28593	46599	4	applied	\N	\N	\N	\N	143106	143106	143107
28593	46600	5	applied	\N	\N	\N	\N	143108	143108	143109
28593	46601	6	applied	\N	\N	\N	\N	143110	143110	143111
28593	46602	7	applied	\N	\N	\N	\N	143112	143112	143113
28593	46603	8	applied	\N	\N	\N	\N	143114	143114	143115
28595	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28595	46596	1	applied	\N	\N	\N	\N	143100	143100	143101
28595	46597	2	applied	\N	\N	\N	\N	143102	143102	143103
28595	46598	3	applied	\N	\N	\N	\N	143104	143104	143105
28595	46599	4	applied	\N	\N	\N	\N	143106	143106	143107
28595	46600	5	applied	\N	\N	\N	\N	143108	143108	143109
28595	46601	6	applied	\N	\N	\N	\N	143110	143110	143111
28595	46602	7	applied	\N	\N	\N	\N	143112	143112	143113
28595	46603	8	applied	\N	\N	\N	\N	143114	143114	143115
28597	46604	0	applied	\N	\N	\N	\N	143121	143121	143122
28597	46605	1	applied	\N	\N	\N	\N	143123	143123	75806
28597	46606	2	applied	\N	\N	\N	\N	143124	143124	75808
28599	46607	0	applied	\N	\N	\N	\N	143126	143126	143127
28599	46608	1	applied	\N	\N	\N	\N	143128	143128	143129
28599	46609	2	applied	\N	\N	\N	\N	143130	143130	143131
28602	46610	0	applied	\N	\N	\N	\N	143134	143134	143135
28602	46611	1	applied	\N	\N	\N	\N	143136	143136	143137
28602	46612	2	applied	\N	\N	\N	\N	143138	143138	75822
28543	46499	0	applied	\N	\N	\N	\N	142833	142833	142834
28543	46500	1	applied	\N	\N	\N	\N	142835	142835	75474
28543	46501	2	applied	\N	\N	\N	\N	142836	142836	75881
28543	46502	3	applied	\N	\N	\N	\N	142837	142837	75482
28543	46498	4	applied	\N	\N	\N	\N	142828	142828	142838
28548	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28548	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28552	46506	0	applied	\N	\N	\N	\N	142850	142850	142851
28552	46507	1	applied	\N	\N	\N	\N	142852	142852	75500
28554	46508	0	applied	\N	\N	\N	\N	142855	142855	142856
28554	46509	1	applied	\N	\N	\N	\N	142857	142857	75885
28554	46510	2	applied	\N	\N	\N	\N	142858	142858	75502
28554	46511	3	applied	\N	\N	\N	\N	142859	142859	75888
28562	46525	0	applied	\N	\N	\N	\N	142888	142888	142889
28562	46526	1	applied	\N	\N	\N	\N	142890	142890	142891
28562	46527	2	applied	\N	\N	\N	\N	142892	142892	142893
28562	46528	3	applied	\N	\N	\N	\N	142894	142894	75552
28562	46529	4	applied	\N	\N	\N	\N	142895	142895	75559
28562	46530	5	applied	\N	\N	\N	\N	142896	142896	75560
28562	46531	6	applied	\N	\N	\N	\N	142897	142897	75568
28562	46532	7	applied	\N	\N	\N	\N	142898	142898	142899
28562	46533	8	applied	\N	\N	\N	\N	142900	142900	75582
28564	46537	0	applied	\N	\N	\N	\N	142909	142909	142910
28564	46538	1	applied	\N	\N	\N	\N	142911	142911	142912
28564	46539	2	applied	\N	\N	\N	\N	142913	142913	142914
28564	46540	3	applied	\N	\N	\N	\N	142915	142915	75601
28564	46541	4	applied	\N	\N	\N	\N	142916	142916	75608
28564	46542	5	applied	\N	\N	\N	\N	142917	142917	142918
28564	46543	6	applied	\N	\N	\N	\N	142919	142919	75619
28566	46537	0	applied	\N	\N	\N	\N	142909	142909	142910
28566	46538	1	applied	\N	\N	\N	\N	142911	142911	142912
28566	46539	2	applied	\N	\N	\N	\N	142913	142913	142914
28566	46540	3	applied	\N	\N	\N	\N	142915	142915	75601
28566	46541	4	applied	\N	\N	\N	\N	142916	142916	75608
28566	46542	5	applied	\N	\N	\N	\N	142917	142917	142918
28566	46543	6	applied	\N	\N	\N	\N	142919	142919	75619
28572	46553	0	applied	\N	\N	\N	\N	142956	142956	142957
28572	46554	1	applied	\N	\N	\N	\N	142958	142958	142959
28572	46555	2	applied	\N	\N	\N	\N	142960	142960	142961
28572	46556	3	applied	\N	\N	\N	\N	142962	142962	29193
28572	46557	4	applied	\N	\N	\N	\N	142963	142963	75661
28572	46558	5	applied	\N	\N	\N	\N	142964	142964	75690
28576	46560	0	applied	\N	\N	\N	\N	143006	143006	143007
28576	46561	1	applied	\N	\N	\N	\N	143008	143008	143009
28576	46562	2	applied	\N	\N	\N	\N	143010	143010	143011
28576	46563	3	applied	\N	\N	\N	\N	143012	143012	143013
28576	46564	4	applied	\N	\N	\N	\N	143014	143014	143015
28576	46565	5	applied	\N	\N	\N	\N	143016	143016	75698
28576	46566	6	applied	\N	\N	\N	\N	143017	143017	143018
28581	46567	0	applied	\N	\N	\N	\N	143028	143028	143029
28581	46568	1	applied	\N	\N	\N	\N	143030	143030	143031
28581	46569	2	applied	\N	\N	\N	\N	143032	143032	143033
28581	46570	3	applied	\N	\N	\N	\N	143034	143034	143035
28581	46571	4	applied	\N	\N	\N	\N	143036	143036	75715
28590	46588	0	applied	\N	\N	\N	\N	143075	143075	143076
28590	46589	2	applied	\N	\N	\N	\N	143078	143078	75763
28590	46590	3	applied	\N	\N	\N	\N	143079	143079	143080
28592	46591	0	applied	\N	\N	\N	\N	143089	143089	143090
28592	46592	1	applied	\N	\N	\N	\N	143091	143091	75775
28592	46593	2	applied	\N	\N	1000000000	\N	143092	143092	143093
28592	46594	3	applied	\N	\N	\N	\N	143094	143094	143095
28603	46613	0	applied	\N	\N	\N	\N	143144	143144	143145
28603	46614	1	applied	\N	\N	\N	\N	143146	143146	75832
28603	46615	2	applied	\N	\N	\N	\N	143147	143147	143148
28608	46620	0	applied	\N	\N	\N	\N	143162	143162	143163
28608	46621	1	applied	\N	\N	\N	\N	143164	143164	143165
28610	46620	0	applied	\N	\N	\N	\N	143162	143162	143163
28610	46621	1	applied	\N	\N	\N	\N	143164	143164	143165
28617	46634	0	applied	\N	\N	\N	\N	143194	143194	143195
28617	46635	1	applied	\N	\N	\N	\N	143196	143196	143197
28617	46636	2	applied	\N	\N	\N	\N	143198	143198	75935
28619	46637	0	applied	\N	\N	\N	\N	143199	143199	143200
28619	46638	1	applied	\N	\N	\N	\N	143201	143201	143202
28619	46639	2	applied	\N	\N	\N	\N	143203	143203	75937
28619	46640	3	applied	\N	\N	\N	\N	143204	143204	75948
28621	46637	0	applied	\N	\N	\N	\N	143199	143199	143200
28621	46638	1	applied	\N	\N	\N	\N	143201	143201	143202
28621	46639	2	applied	\N	\N	\N	\N	143203	143203	75937
28621	46640	3	applied	\N	\N	\N	\N	143204	143204	75948
28628	46649	0	applied	\N	\N	\N	\N	143260	143260	143261
28628	46650	1	applied	\N	\N	\N	\N	143262	143262	143263
28628	46651	2	applied	\N	\N	\N	\N	143264	143264	143265
28629	46652	0	applied	\N	\N	\N	\N	143268	143268	143269
28629	46653	1	applied	\N	\N	\N	\N	143270	143270	143271
28629	46654	2	applied	\N	\N	\N	\N	143272	143272	143273
28629	46655	3	applied	\N	\N	\N	\N	143274	143274	143275
28629	46656	4	applied	\N	\N	\N	\N	143276	143276	143277
28629	46657	5	applied	\N	\N	\N	\N	143278	143278	143279
28629	46658	6	applied	\N	\N	\N	\N	143280	143280	75989
28629	46659	7	applied	\N	\N	\N	\N	143281	143281	75997
28629	46660	8	applied	\N	\N	\N	\N	143282	143282	143283
28629	46661	9	applied	\N	\N	\N	\N	143284	143284	76003
28629	46662	10	applied	\N	\N	\N	\N	143285	143285	143286
28629	46663	11	applied	\N	\N	\N	\N	143287	143287	143288
28634	46666	0	applied	\N	\N	\N	\N	143298	143298	143299
28634	46667	1	applied	\N	\N	\N	\N	143300	143300	143301
28634	46668	2	applied	\N	\N	\N	\N	143302	143302	143303
28634	46669	3	applied	\N	\N	\N	\N	143304	143304	143305
28634	46670	4	applied	\N	\N	\N	\N	143306	143306	143307
28634	46671	5	applied	\N	\N	\N	\N	143308	143308	76029
28636	46672	0	applied	\N	\N	\N	\N	143313	143313	143314
28636	46673	1	applied	\N	\N	\N	\N	143315	143315	76037
28639	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28639	46597	1	applied	\N	\N	\N	\N	143102	143102	143103
28639	46598	2	applied	\N	\N	\N	\N	143104	143104	143105
28639	46599	3	applied	\N	\N	\N	\N	143106	143106	143107
28639	46468	4	applied	\N	\N	\N	\N	73863	73863	142823
28639	46556	5	applied	\N	\N	\N	\N	143218	143218	29193
28639	46465	6	applied	\N	\N	\N	\N	142742	142742	143219
28639	46449	7	applied	\N	\N	1000000000	\N	142694	142694	142695
28639	46450	8	applied	\N	\N	\N	\N	142696	142696	142697
28639	46445	9	applied	\N	\N	\N	\N	142680	142680	73871
28639	46451	10	applied	\N	\N	\N	\N	142698	142698	74043
28639	46455	11	applied	\N	\N	\N	\N	142712	142712	73925
28639	46457	12	applied	\N	\N	\N	\N	142721	142721	73883
28639	46472	13	applied	\N	\N	\N	\N	142756	142756	143324
28639	46491	14	applied	\N	\N	1000000000	\N	142803	142803	142804
28639	46517	15	applied	\N	\N	1000000000	\N	142873	142873	142874
28639	46593	16	applied	\N	\N	1000000000	\N	143092	143092	143093
28560	46522	0	applied	\N	\N	\N	\N	142881	142881	142882
28560	46524	1	applied	\N	\N	\N	\N	142884	142884	75895
28560	46523	2	applied	\N	\N	\N	\N	142883	142883	75542
28565	46537	0	applied	\N	\N	\N	\N	142909	142909	142910
28565	46538	1	applied	\N	\N	\N	\N	142911	142911	142912
28565	46539	2	applied	\N	\N	\N	\N	142913	142913	142914
28565	46540	3	applied	\N	\N	\N	\N	142915	142915	75601
28565	46541	4	applied	\N	\N	\N	\N	142916	142916	75608
28565	46542	5	applied	\N	\N	\N	\N	142917	142917	142918
28565	46543	6	applied	\N	\N	\N	\N	142919	142919	75619
28568	46544	0	applied	\N	\N	\N	\N	142924	142924	142925
28568	46545	1	applied	\N	\N	\N	\N	142926	142926	142927
28568	46546	2	applied	\N	\N	\N	\N	142928	142928	142929
28568	46547	3	applied	\N	\N	\N	\N	142930	142930	142931
28568	46548	4	applied	\N	\N	\N	\N	142932	142932	75636
28568	46549	5	applied	\N	\N	\N	\N	142933	142933	142934
28568	46550	6	applied	\N	\N	\N	\N	142935	142935	75647
28568	46551	7	applied	\N	\N	\N	\N	142936	142936	75649
28568	46552	8	applied	\N	\N	\N	\N	142937	142937	142938
28570	46544	0	applied	\N	\N	\N	\N	142924	142924	142925
28570	46545	1	applied	\N	\N	\N	\N	142926	142926	142927
28570	46546	2	applied	\N	\N	\N	\N	142928	142928	142929
28570	46547	3	applied	\N	\N	\N	\N	142930	142930	142931
28570	46548	4	applied	\N	\N	\N	\N	142932	142932	75636
28570	46549	5	applied	\N	\N	\N	\N	142933	142933	142934
28570	46550	6	applied	\N	\N	\N	\N	142935	142935	75647
28570	46551	7	applied	\N	\N	\N	\N	142936	142936	75649
28570	46552	8	applied	\N	\N	\N	\N	142937	142937	142938
28577	46560	0	applied	\N	\N	\N	\N	143006	143006	143007
28577	46561	1	applied	\N	\N	\N	\N	143008	143008	143009
28577	46562	2	applied	\N	\N	\N	\N	143010	143010	143011
28577	46563	3	applied	\N	\N	\N	\N	143012	143012	143013
28577	46564	4	applied	\N	\N	\N	\N	143014	143014	143015
28577	46565	5	applied	\N	\N	\N	\N	143016	143016	75698
28577	46566	6	applied	\N	\N	\N	\N	143017	143017	143018
28579	46556	0	applied	\N	\N	\N	\N	143023	143023	29193
28579	46565	1	applied	\N	\N	\N	\N	143016	143016	143024
28591	46588	0	applied	\N	\N	\N	\N	143075	143075	143076
28591	46589	2	applied	\N	\N	\N	\N	143078	143078	75763
28591	46590	3	applied	\N	\N	\N	\N	143079	143079	143080
28594	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28594	46596	1	applied	\N	\N	\N	\N	143100	143100	143101
28594	46597	2	applied	\N	\N	\N	\N	143102	143102	143103
28594	46598	3	applied	\N	\N	\N	\N	143104	143104	143105
28594	46599	4	applied	\N	\N	\N	\N	143106	143106	143107
28594	46600	5	applied	\N	\N	\N	\N	143108	143108	143109
28594	46601	6	applied	\N	\N	\N	\N	143110	143110	143111
28594	46602	7	applied	\N	\N	\N	\N	143112	143112	143113
28594	46603	8	applied	\N	\N	\N	\N	143114	143114	143115
28600	46610	0	applied	\N	\N	\N	\N	143134	143134	143135
28600	46611	1	applied	\N	\N	\N	\N	143136	143136	143137
28600	46612	2	applied	\N	\N	\N	\N	143138	143138	75822
28611	46620	0	applied	\N	\N	\N	\N	143162	143162	143163
28611	46621	1	applied	\N	\N	\N	\N	143164	143164	143165
28616	46632	0	applied	\N	\N	\N	\N	143189	143189	143190
28616	46633	1	applied	\N	\N	\N	\N	143191	143191	75931
28618	46637	0	applied	\N	\N	\N	\N	143199	143199	143200
28618	46638	1	applied	\N	\N	\N	\N	143201	143201	143202
28618	46639	2	applied	\N	\N	\N	\N	143203	143203	75937
28618	46640	3	applied	\N	\N	\N	\N	143204	143204	75948
28620	46637	0	applied	\N	\N	\N	\N	143199	143199	143200
28620	46638	1	applied	\N	\N	\N	\N	143201	143201	143202
28620	46639	2	applied	\N	\N	\N	\N	143203	143203	75937
28620	46640	3	applied	\N	\N	\N	\N	143204	143204	75948
28625	46645	0	applied	\N	\N	\N	\N	143231	143231	143232
28625	46646	1	applied	\N	\N	\N	\N	143233	143233	143234
28625	46647	2	applied	\N	\N	\N	\N	143235	143235	75965
28625	46648	3	applied	\N	\N	\N	\N	143236	143236	143237
28633	46664	0	applied	\N	\N	\N	\N	143293	143293	143294
28633	46665	1	applied	\N	\N	\N	\N	143295	143295	76015
28637	46672	0	applied	\N	\N	\N	\N	143313	143313	143314
28637	46673	1	applied	\N	\N	\N	\N	143315	143315	76037
28641	46674	0	applied	\N	\N	\N	\N	143318	143318	143319
28641	46675	1	applied	\N	\N	\N	\N	143320	143320	143321
28646	46682	0	applied	\N	\N	\N	\N	143374	143374	143375
28646	46680	1	applied	\N	\N	\N	\N	143369	143369	76063
28646	46681	2	applied	\N	\N	\N	\N	143370	143370	143371
28648	46682	0	applied	\N	\N	\N	\N	143374	143374	143375
28648	46680	1	applied	\N	\N	\N	\N	143369	143369	76063
28648	46681	2	applied	\N	\N	\N	\N	143370	143370	143371
28650	46683	0	applied	\N	\N	\N	\N	143380	143380	143381
28655	46700	0	applied	\N	\N	\N	\N	143416	143416	143417
28655	46701	1	applied	\N	\N	\N	\N	143418	143418	143419
28655	46702	2	applied	\N	\N	\N	\N	143420	143420	143421
28655	46703	3	applied	\N	\N	\N	\N	143422	143422	143423
28655	46704	4	applied	\N	\N	\N	\N	143424	143424	76121
28655	46705	5	applied	\N	\N	\N	\N	143425	143425	143426
28657	46700	0	applied	\N	\N	\N	\N	143416	143416	143417
28657	46701	1	applied	\N	\N	\N	\N	143418	143418	143419
28657	46702	2	applied	\N	\N	\N	\N	143420	143420	143421
28657	46703	3	applied	\N	\N	\N	\N	143422	143422	143423
28657	46704	4	applied	\N	\N	\N	\N	143424	143424	76121
28657	46705	5	applied	\N	\N	\N	\N	143425	143425	143426
28661	46708	0	applied	\N	\N	\N	\N	143441	143441	143442
28663	46709	0	applied	\N	\N	\N	\N	143446	143446	143447
28663	46710	1	applied	\N	\N	\N	\N	143448	143448	143449
28663	46711	2	applied	\N	\N	\N	\N	143450	143450	76141
28667	46714	0	applied	\N	\N	\N	\N	143463	143463	143464
28667	46715	1	applied	\N	\N	\N	\N	143465	143465	76161
28681	46735	0	applied	\N	\N	\N	\N	143609	143609	143610
28681	46736	1	applied	\N	\N	\N	\N	143611	143611	143612
28683	46737	0	applied	\N	\N	\N	\N	143618	143618	143619
28683	46738	1	applied	\N	\N	\N	\N	143620	143620	76216
28683	46739	2	applied	\N	\N	\N	\N	143621	143621	76221
28686	46740	0	applied	\N	\N	\N	\N	143622	143622	143623
28686	46741	1	applied	\N	\N	\N	\N	143624	143624	143625
28686	46742	2	applied	\N	\N	\N	\N	143626	143626	76223
28686	46743	3	applied	\N	\N	\N	\N	143627	143627	143628
28690	46749	0	applied	\N	\N	\N	\N	143644	143644	143645
28690	46750	1	applied	\N	\N	\N	\N	143646	143646	143647
28690	46751	2	applied	\N	\N	\N	\N	143648	143648	143649
28690	46752	3	applied	\N	\N	\N	\N	143650	143650	76293
28697	46758	0	applied	\N	\N	\N	\N	143676	143676	143677
28697	46759	1	applied	\N	\N	\N	\N	143678	143678	143679
28697	46760	2	applied	\N	\N	\N	\N	143680	143680	143681
28699	46761	0	applied	\N	\N	\N	\N	143687	143687	143688
28699	46762	1	applied	\N	\N	\N	\N	143689	143689	143690
28699	46763	2	applied	\N	\N	\N	\N	143691	143691	76609
28699	46764	3	applied	\N	\N	\N	\N	143692	143692	143693
28704	46774	0	applied	\N	\N	\N	\N	143714	143714	143715
28573	46526	20	applied	\N	\N	\N	\N	142890	142890	142891
28573	46527	21	applied	\N	\N	\N	\N	142892	142892	142893
28573	46534	22	applied	\N	\N	\N	\N	142903	142903	142904
28573	46537	23	applied	\N	\N	\N	\N	142909	142909	142910
28573	46538	24	applied	\N	\N	\N	\N	142911	142911	142912
28573	46544	25	applied	\N	\N	\N	\N	142924	142924	142925
28573	46545	26	applied	\N	\N	\N	\N	142926	142926	142927
28573	46546	27	applied	\N	\N	\N	\N	142928	142928	142929
28573	46553	28	applied	\N	\N	\N	\N	142956	142956	142957
28573	46554	29	applied	\N	\N	\N	\N	142958	142958	142959
28573	46468	30	applied	\N	\N	\N	\N	75869	75869	142969
28573	46464	31	applied	\N	\N	\N	\N	142740	142740	142970
28573	46556	32	applied	\N	\N	\N	\N	142971	142971	29193
28573	46465	33	applied	\N	\N	\N	\N	142742	142742	142972
28573	46470	34	applied	\N	\N	\N	\N	142754	142754	76225
28573	46476	35	applied	\N	\N	\N	\N	142764	142764	142973
28573	46471	36	applied	\N	\N	\N	\N	142755	142755	76227
28573	46475	37	applied	\N	\N	\N	\N	142762	142762	142974
28573	46487	38	applied	\N	\N	\N	\N	142788	142788	75426
28573	46492	39	applied	\N	\N	\N	\N	142805	142805	142975
28573	46498	40	applied	\N	\N	\N	\N	142828	142828	75428
28573	46509	41	applied	\N	\N	\N	\N	142857	142857	75871
28573	46521	42	applied	\N	\N	\N	\N	142878	142878	75430
28573	46533	43	applied	\N	\N	\N	\N	142900	142900	76228
28573	46540	44	applied	\N	\N	\N	\N	142915	142915	75432
28573	46549	45	applied	\N	\N	\N	\N	142933	142933	142774
28573	46472	46	applied	\N	\N	\N	\N	142756	142756	142976
28573	46491	47	applied	\N	\N	1000000000	\N	142803	142803	142804
28573	46517	48	applied	\N	\N	1000000000	\N	142873	142873	142874
28573	46466	49	applied	\N	\N	\N	\N	142744	142744	75436
28573	46469	50	applied	\N	\N	\N	\N	142753	142753	75438
28573	46474	52	applied	\N	\N	\N	\N	142761	142761	142978
28573	46478	53	applied	\N	\N	\N	\N	142773	142773	75873
28573	46482	54	applied	\N	\N	\N	\N	142782	142782	76230
28573	46483	55	applied	\N	\N	\N	\N	142783	142783	75448
28573	46489	56	applied	\N	\N	\N	\N	142793	142793	75875
28573	46493	57	applied	\N	\N	\N	\N	142806	142806	142794
28573	46495	58	applied	\N	\N	\N	\N	142811	142811	75462
28573	46497	59	applied	\N	\N	\N	\N	142819	142819	75464
28573	46500	60	applied	\N	\N	\N	\N	142835	142835	75472
28573	46502	61	applied	\N	\N	\N	\N	142837	142837	142979
28573	46504	62	applied	\N	\N	\N	\N	142842	142842	75478
28573	46507	63	applied	\N	\N	\N	\N	142852	142852	75480
28573	46510	64	applied	\N	\N	\N	\N	142858	142858	142980
28573	46514	65	applied	\N	\N	\N	\N	142866	142866	142838
28573	46519	66	applied	\N	\N	\N	\N	142876	142876	142843
28573	46520	67	applied	\N	\N	\N	\N	142877	142877	75491
28573	46524	68	applied	\N	\N	\N	\N	142884	142884	75498
28573	46530	69	applied	\N	\N	\N	\N	142896	142896	75500
28573	46531	70	applied	\N	\N	\N	\N	142897	142897	142981
28573	46532	71	applied	\N	\N	\N	\N	142898	142898	75886
28573	46536	72	applied	\N	\N	\N	\N	142906	142906	75504
28573	46541	73	applied	\N	\N	\N	\N	142916	142916	75511
28573	46542	74	applied	\N	\N	\N	\N	142917	142917	75891
28573	46550	75	applied	\N	\N	\N	\N	142935	142935	75515
28573	46551	76	applied	\N	\N	\N	\N	142936	142936	75522
28573	46552	77	applied	\N	\N	\N	\N	142937	142937	76231
28573	46557	78	applied	\N	\N	\N	\N	142963	142963	75534
28573	46558	79	applied	\N	\N	\N	\N	142964	142964	75536
28573	46479	80	applied	\N	\N	\N	\N	142775	142775	77075
28573	46484	81	applied	\N	\N	\N	\N	142784	142784	77076
28573	46485	82	applied	\N	\N	\N	\N	142785	142785	142962
28573	46486	83	applied	\N	\N	\N	\N	142787	142787	75897
28573	46559	84	applied	\N	\N	\N	\N	142982	142982	75552
28573	46505	85	applied	\N	\N	\N	\N	142983	142983	75559
28573	46511	86	applied	\N	\N	\N	\N	142984	142984	75568
28573	46513	87	applied	\N	\N	\N	\N	142985	142985	75577
28573	46518	88	applied	\N	\N	\N	\N	142986	142986	142987
28573	46523	89	applied	\N	\N	\N	\N	142988	142988	75599
28573	46528	90	applied	\N	\N	\N	\N	142989	142989	75608
28573	46529	91	applied	\N	\N	\N	\N	142990	142990	142991
28573	46535	92	applied	\N	\N	\N	\N	142992	142992	142993
28573	46539	93	applied	\N	\N	\N	\N	142994	142994	142995
28573	46543	94	applied	\N	\N	\N	\N	142996	142996	75638
28573	46547	95	applied	\N	\N	\N	\N	142997	142997	142998
28573	46548	96	applied	\N	\N	\N	\N	142999	142999	75659
28573	46555	97	applied	\N	\N	\N	\N	143000	143000	143001
28575	46553	0	applied	\N	\N	\N	\N	142956	142956	142957
28575	46554	1	applied	\N	\N	\N	\N	142958	142958	142959
28575	46555	2	applied	\N	\N	\N	\N	142960	142960	142961
28575	46556	3	applied	\N	\N	\N	\N	142962	142962	29193
28575	46557	4	applied	\N	\N	\N	\N	142963	142963	75661
28575	46558	5	applied	\N	\N	\N	\N	142964	142964	75690
28578	46560	0	applied	\N	\N	\N	\N	143006	143006	143007
28578	46561	1	applied	\N	\N	\N	\N	143008	143008	143009
28578	46562	2	applied	\N	\N	\N	\N	143010	143010	143011
28578	46563	3	applied	\N	\N	\N	\N	143012	143012	143013
28578	46564	4	applied	\N	\N	\N	\N	143014	143014	143015
28578	46565	5	applied	\N	\N	\N	\N	143016	143016	75698
28578	46566	6	applied	\N	\N	\N	\N	143017	143017	143018
28580	46567	0	applied	\N	\N	\N	\N	143028	143028	143029
28580	46568	1	applied	\N	\N	\N	\N	143030	143030	143031
28580	46569	2	applied	\N	\N	\N	\N	143032	143032	143033
28580	46570	3	applied	\N	\N	\N	\N	143034	143034	143035
28580	46571	4	applied	\N	\N	\N	\N	143036	143036	75715
28584	46572	0	applied	\N	\N	\N	\N	143041	143041	143042
28584	46573	1	applied	\N	\N	\N	\N	143043	143043	143044
28584	46574	2	applied	\N	\N	\N	\N	143045	143045	75717
28584	46575	3	applied	\N	\N	\N	\N	143046	143046	75726
28585	46576	0	applied	\N	\N	\N	\N	143050	143050	143051
28585	46577	1	applied	\N	\N	\N	\N	143052	143052	143053
28585	46578	2	applied	\N	\N	\N	\N	143054	143054	143055
28585	46579	3	applied	\N	\N	\N	\N	143056	143056	75728
28585	46580	4	applied	\N	\N	\N	\N	143057	143057	143058
28585	46581	5	applied	\N	\N	\N	\N	143059	143059	75735
28585	46582	6	applied	\N	\N	\N	\N	143060	143060	75737
28585	46583	7	applied	\N	\N	\N	\N	143061	143061	143062
28585	46584	8	applied	\N	\N	\N	\N	143063	143063	75748
28587	46585	0	applied	\N	\N	\N	\N	143065	143065	143066
28587	46586	1	applied	\N	\N	\N	\N	143067	143067	143068
28587	46587	2	applied	\N	\N	\N	\N	143069	143069	143070
28596	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28596	46596	1	applied	\N	\N	\N	\N	143100	143100	143101
28596	46597	2	applied	\N	\N	\N	\N	143102	143102	143103
28596	46598	3	applied	\N	\N	\N	\N	143104	143104	143105
28596	46599	4	applied	\N	\N	\N	\N	143106	143106	143107
28596	46600	5	applied	\N	\N	\N	\N	143108	143108	143109
28596	46601	6	applied	\N	\N	\N	\N	143110	143110	143111
28596	46602	7	applied	\N	\N	\N	\N	143112	143112	143113
28596	46603	8	applied	\N	\N	\N	\N	143114	143114	143115
28598	46604	0	applied	\N	\N	\N	\N	143121	143121	143122
28598	46605	1	applied	\N	\N	\N	\N	143123	143123	75806
28598	46606	2	applied	\N	\N	\N	\N	143124	143124	75808
28601	46610	0	applied	\N	\N	\N	\N	143134	143134	143135
28601	46611	1	applied	\N	\N	\N	\N	143136	143136	143137
28601	46612	2	applied	\N	\N	\N	\N	143138	143138	75822
28605	46616	0	applied	\N	\N	\N	\N	143151	143151	143152
28605	46617	1	applied	\N	\N	\N	\N	143153	143153	75828
28605	46618	2	applied	\N	\N	\N	\N	143154	143154	75839
28605	46619	3	applied	\N	\N	\N	\N	143155	143155	143156
28607	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28607	46597	1	applied	\N	\N	\N	\N	143102	143102	143103
28607	46598	2	applied	\N	\N	\N	\N	143104	143104	143105
28607	46599	3	applied	\N	\N	\N	\N	143106	143106	143107
28607	46593	4	applied	\N	\N	1000000000	\N	143092	143092	143093
28614	46625	0	applied	\N	\N	\N	\N	143174	143174	143175
28614	46626	1	applied	\N	\N	\N	\N	143176	143176	143177
28614	46627	2	applied	\N	\N	\N	\N	143178	143178	143179
28614	46628	3	applied	\N	\N	\N	\N	143180	143180	143181
28614	46629	4	applied	\N	\N	\N	\N	143182	143182	143183
28614	46630	5	applied	\N	\N	\N	\N	143184	143184	143185
28614	46631	6	applied	\N	\N	\N	\N	143186	143186	75929
28623	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28623	46597	1	applied	\N	\N	\N	\N	143102	143102	143103
28623	46598	2	applied	\N	\N	\N	\N	143104	143104	143105
28623	46599	3	applied	\N	\N	\N	\N	143106	143106	143107
28623	46468	4	applied	\N	\N	\N	\N	143217	143217	142823
28623	46556	5	applied	\N	\N	\N	\N	143218	143218	29193
28623	46454	6	applied	\N	\N	\N	\N	142710	142710	75372
28623	46465	7	applied	\N	\N	\N	\N	142742	142742	143219
28623	46471	8	applied	\N	\N	\N	\N	142755	142755	143220
28623	46475	9	applied	\N	\N	\N	\N	142762	142762	143221
28623	46487	10	applied	\N	\N	\N	\N	142788	142788	75378
28623	46492	11	applied	\N	\N	\N	\N	142805	142805	75866
28623	46498	12	applied	\N	\N	\N	\N	142828	142828	143222
28623	46509	13	applied	\N	\N	\N	\N	142857	142857	75380
28623	46521	14	applied	\N	\N	\N	\N	142878	142878	75867
28623	46533	15	applied	\N	\N	\N	\N	142900	142900	143223
28623	46540	16	applied	\N	\N	\N	\N	142915	142915	75386
28623	46549	17	applied	\N	\N	\N	\N	142933	142933	75868
28623	46565	18	applied	\N	\N	\N	\N	143016	143016	75388
28623	46574	19	applied	\N	\N	\N	\N	143045	143045	143224
28623	46580	20	applied	\N	\N	\N	\N	143057	143057	75395
28623	46594	21	applied	\N	\N	\N	\N	143094	143094	75403
28623	46609	22	applied	\N	\N	\N	\N	143130	143130	75407
28623	46619	23	applied	\N	\N	\N	\N	143155	143155	75397
28623	46631	24	applied	\N	\N	\N	\N	143186	143186	75404
28623	46638	25	applied	\N	\N	\N	\N	143201	143201	143225
28626	46595	0	applied	\N	\N	\N	\N	143240	143240	143099
28626	46597	1	applied	\N	\N	\N	\N	143241	143241	143103
28626	46598	2	applied	\N	\N	\N	\N	143242	143242	143105
28626	46599	3	applied	\N	\N	\N	\N	143243	143243	143107
28626	46574	4	applied	\N	\N	\N	\N	143045	143045	143244
28626	46580	5	applied	\N	\N	\N	\N	143057	143057	72964
28626	46593	6	applied	\N	\N	1000000000	\N	143092	143092	143093
28626	46594	7	applied	\N	\N	\N	\N	143094	143094	143245
28626	46609	8	applied	\N	\N	\N	\N	143130	143130	143246
28626	46619	9	applied	\N	\N	\N	\N	143155	143155	72972
28626	46631	10	applied	\N	\N	\N	\N	143186	143186	143247
28626	46638	11	applied	\N	\N	\N	\N	143201	143201	143248
28626	46648	12	applied	\N	\N	\N	\N	143236	143236	72974
28631	46664	0	applied	\N	\N	\N	\N	143293	143293	143294
28631	46665	1	applied	\N	\N	\N	\N	143295	143295	76015
28638	46674	0	applied	\N	\N	\N	\N	143318	143318	143319
28638	46675	1	applied	\N	\N	\N	\N	143320	143320	143321
28640	46674	0	applied	\N	\N	\N	\N	143318	143318	143319
28640	46675	1	applied	\N	\N	\N	\N	143320	143320	143321
28649	46683	0	applied	\N	\N	\N	\N	143380	143380	143381
28652	46688	0	applied	\N	\N	\N	\N	143393	143393	143394
28652	46689	1	applied	\N	\N	\N	\N	143395	143395	143396
28652	46690	2	applied	\N	\N	\N	\N	143397	143397	143398
28652	46691	3	applied	\N	\N	\N	\N	143399	143399	76080
28652	46692	4	applied	\N	\N	\N	\N	143400	143400	143401
28668	46716	0	applied	\N	\N	\N	\N	143470	143470	143471
28668	46717	1	applied	\N	\N	\N	\N	143472	143472	143473
28668	46718	2	applied	\N	\N	\N	\N	143474	143474	143475
28668	46719	3	applied	\N	\N	\N	\N	143476	143476	143477
28671	46720	0	applied	\N	\N	\N	\N	143480	143480	143481
28671	46721	1	applied	\N	\N	\N	\N	143482	143482	143483
28671	46722	2	applied	\N	\N	\N	\N	143484	143484	143485
28673	46723	0	applied	\N	\N	\N	\N	143569	143569	143570
28673	46724	1	applied	\N	\N	\N	\N	143571	143571	143572
28673	46725	2	applied	\N	\N	\N	\N	143573	143573	143574
28673	46726	3	applied	\N	\N	\N	\N	143575	143575	143576
28676	46723	0	applied	\N	\N	\N	\N	143569	143569	143570
28676	46724	1	applied	\N	\N	\N	\N	143571	143571	143572
28676	46725	2	applied	\N	\N	\N	\N	143573	143573	143574
28676	46726	3	applied	\N	\N	\N	\N	143575	143575	143576
28678	46727	0	applied	\N	\N	\N	\N	143590	143590	143591
28678	46728	1	applied	\N	\N	\N	\N	143592	143592	143593
28678	46729	2	applied	\N	\N	\N	\N	143594	143594	143595
28678	46730	3	applied	\N	\N	\N	\N	143596	143596	143597
28680	46731	0	applied	\N	\N	\N	\N	143600	143600	143601
28680	46732	1	applied	\N	\N	\N	\N	143602	143602	143603
28680	46733	2	applied	\N	\N	\N	\N	143604	143604	76204
28680	46734	3	applied	\N	\N	\N	\N	143605	143605	76206
28682	46733	0	applied	\N	\N	\N	\N	143604	143604	143615
28687	46740	0	applied	\N	\N	\N	\N	143622	143622	143623
28687	46741	1	applied	\N	\N	\N	\N	143624	143624	143625
28687	46742	2	applied	\N	\N	\N	\N	143626	143626	76223
28687	46743	3	applied	\N	\N	\N	\N	143627	143627	143628
28689	46747	0	applied	\N	\N	\N	\N	143640	143640	143641
28689	46748	1	applied	\N	\N	\N	\N	143642	143642	143643
28692	46753	0	applied	\N	\N	\N	\N	143653	143653	143654
28692	46754	1	applied	\N	\N	\N	\N	143655	143655	76349
28692	46755	2	applied	\N	\N	\N	\N	143656	143656	76351
28696	46758	0	applied	\N	\N	\N	\N	143676	143676	143677
28696	46759	1	applied	\N	\N	\N	\N	143678	143678	143679
28696	46760	2	applied	\N	\N	\N	\N	143680	143680	143681
28698	46758	0	applied	\N	\N	\N	\N	143676	143676	143677
28698	46759	1	applied	\N	\N	\N	\N	143678	143678	143679
28698	46760	2	applied	\N	\N	\N	\N	143680	143680	143681
28703	46770	0	applied	\N	\N	\N	\N	143708	143708	143709
28703	46771	1	applied	\N	\N	\N	\N	143710	143710	143711
28703	46772	2	applied	\N	\N	\N	\N	143712	143712	76611
28703	46773	3	applied	\N	\N	\N	\N	143713	143713	76394
28714	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28720	46778	0	applied	\N	\N	\N	\N	143732	143732	143733
28604	46613	0	applied	\N	\N	\N	\N	143144	143144	143145
28604	46614	1	applied	\N	\N	\N	\N	143146	143146	75832
28604	46615	2	applied	\N	\N	\N	\N	143147	143147	143148
28606	46616	0	applied	\N	\N	\N	\N	143151	143151	143152
28606	46617	1	applied	\N	\N	\N	\N	143153	143153	75828
28606	46618	2	applied	\N	\N	\N	\N	143154	143154	75839
28606	46619	3	applied	\N	\N	\N	\N	143155	143155	143156
28609	46620	0	applied	\N	\N	\N	\N	143162	143162	143163
28609	46621	1	applied	\N	\N	\N	\N	143164	143164	143165
28613	46622	0	applied	\N	\N	\N	\N	143169	143169	143170
28613	46623	1	applied	\N	\N	\N	\N	143171	143171	75852
28613	46624	2	applied	\N	\N	\N	\N	143172	143172	143173
28615	46632	0	applied	\N	\N	\N	\N	143189	143189	143190
28615	46633	1	applied	\N	\N	\N	\N	143191	143191	75931
28622	46641	0	applied	\N	\N	\N	\N	143209	143209	143210
28622	46642	1	applied	\N	\N	\N	\N	143211	143211	143212
28622	46643	2	applied	\N	\N	\N	\N	143213	143213	143214
28624	46644	0	applied	\N	\N	\N	\N	143228	143228	143229
28627	46645	0	applied	\N	\N	\N	\N	143231	143231	143232
28627	46646	1	applied	\N	\N	\N	\N	143233	143233	143234
28627	46647	2	applied	\N	\N	\N	\N	143235	143235	75965
28627	46648	3	applied	\N	\N	\N	\N	143236	143236	143237
28630	46658	0	applied	\N	\N	\N	\N	143280	143280	143290
28632	46664	0	applied	\N	\N	\N	\N	143293	143293	143294
28632	46665	1	applied	\N	\N	\N	\N	143295	143295	76015
28635	46666	0	applied	\N	\N	\N	\N	143298	143298	143299
28635	46667	1	applied	\N	\N	\N	\N	143300	143300	143301
28635	46668	2	applied	\N	\N	\N	\N	143302	143302	143303
28635	46669	3	applied	\N	\N	\N	\N	143304	143304	143305
28635	46670	4	applied	\N	\N	\N	\N	143306	143306	143307
28635	46671	5	applied	\N	\N	\N	\N	143308	143308	76029
28642	46676	0	applied	\N	\N	\N	\N	143357	143357	143358
28642	46677	1	applied	\N	\N	\N	\N	143359	143359	143360
28642	46678	2	applied	\N	\N	\N	\N	143361	143361	76049
28642	46679	3	applied	\N	\N	\N	\N	143362	143362	76056
28644	46676	0	applied	\N	\N	\N	\N	143357	143357	143358
28644	46677	1	applied	\N	\N	\N	\N	143359	143359	143360
28644	46678	2	applied	\N	\N	\N	\N	143361	143361	76049
28644	46679	3	applied	\N	\N	\N	\N	143362	143362	76056
28651	46684	0	applied	\N	\N	\N	\N	143385	143385	143386
28651	46685	1	applied	\N	\N	\N	\N	143387	143387	143388
28651	46686	2	applied	\N	\N	\N	\N	143389	143389	76069
28651	46687	3	applied	\N	\N	\N	\N	143390	143390	143391
28656	46700	0	applied	\N	\N	\N	\N	143416	143416	143417
28656	46701	1	applied	\N	\N	\N	\N	143418	143418	143419
28656	46702	2	applied	\N	\N	\N	\N	143420	143420	143421
28656	46703	3	applied	\N	\N	\N	\N	143422	143422	143423
28656	46704	4	applied	\N	\N	\N	\N	143424	143424	76121
28656	46705	5	applied	\N	\N	\N	\N	143425	143425	143426
28659	46706	0	applied	\N	\N	\N	\N	143436	143436	143437
28659	46707	1	applied	\N	\N	\N	\N	143438	143438	76131
28662	46708	0	applied	\N	\N	\N	\N	143441	143441	143442
28664	46712	0	applied	\N	\N	\N	\N	143453	143453	143454
28664	46713	1	applied	\N	\N	\N	\N	143455	143455	76155
28665	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28665	46270	1	applied	\N	\N	1000000000	\N	142135	142135	142157
28665	46275	2	applied	\N	\N	\N	\N	142150	142150	142158
28665	46223	3	applied	\N	\N	1000000000	\N	141978	141978	141979
28665	46237	4	applied	\N	\N	\N	\N	142022	142022	142151
28665	46294	5	applied	\N	\N	1000000000	\N	142216	142216	142217
28665	46597	6	applied	\N	\N	\N	\N	143102	143102	143103
28665	46598	7	applied	\N	\N	\N	\N	143104	143104	143105
28665	46599	8	applied	\N	\N	\N	\N	143106	143106	143107
28665	46412	9	applied	\N	\N	\N	\N	142582	142582	138833
28665	46419	10	applied	\N	\N	\N	\N	142596	142596	142597
28665	46690	11	applied	\N	\N	\N	\N	143397	143397	143398
28665	46468	12	applied	\N	\N	\N	\N	74046	74046	142823
28665	46556	13	applied	\N	\N	\N	\N	143218	143218	29193
28665	46344	14	applied	\N	\N	1000000000	\N	142356	142356	142357
28665	46465	15	applied	\N	\N	\N	\N	142742	142742	143219
28665	46224	16	applied	\N	\N	1000000000	\N	141980	141980	141981
28665	46449	17	applied	\N	\N	1000000000	\N	142694	142694	142695
28665	46450	18	applied	\N	\N	\N	\N	142696	142696	142697
28665	46431	19	applied	\N	\N	\N	\N	142633	142633	74047
28665	46354	20	applied	\N	\N	\N	\N	142403	142403	142404
28665	46472	21	applied	\N	\N	\N	\N	142756	142756	143324
28665	46491	22	applied	\N	\N	1000000000	\N	142803	142803	142804
28665	46517	23	applied	\N	\N	1000000000	\N	142873	142873	142874
28665	46593	24	applied	\N	\N	1000000000	\N	143092	143092	143093
28665	46438	25	applied	\N	\N	\N	\N	142650	142650	73953
28665	46441	26	applied	\N	\N	\N	\N	142659	142659	74049
28665	46443	27	applied	\N	\N	\N	\N	142669	142669	73948
28665	46445	28	applied	\N	\N	\N	\N	142680	142680	73962
28665	46451	29	applied	\N	\N	\N	\N	142698	142698	143326
28665	46455	31	applied	\N	\N	\N	\N	142712	142712	143327
28665	46457	32	applied	\N	\N	\N	\N	142721	142721	74065
28665	46461	33	applied	\N	\N	\N	\N	142730	142730	73973
28665	46462	34	applied	\N	\N	\N	\N	142736	142736	143325
28665	46466	35	applied	\N	\N	\N	\N	142744	142744	143328
28665	46469	36	applied	\N	\N	\N	\N	142753	142753	74067
28665	46474	37	applied	\N	\N	\N	\N	142761	142761	143329
28665	46478	38	applied	\N	\N	\N	\N	142773	142773	73979
28665	46482	39	applied	\N	\N	\N	\N	142782	142782	73981
28665	46483	40	applied	\N	\N	\N	\N	142783	142783	73991
28665	46489	41	applied	\N	\N	\N	\N	142793	142793	73993
28665	46493	42	applied	\N	\N	\N	\N	142806	142806	74070
28665	46495	43	applied	\N	\N	\N	\N	142811	142811	143330
28665	46497	44	applied	\N	\N	\N	\N	142819	142819	73997
28665	46500	45	applied	\N	\N	\N	\N	142835	142835	74005
28665	46502	46	applied	\N	\N	\N	\N	142837	142837	143331
28665	46504	47	applied	\N	\N	\N	\N	142842	142842	143332
28665	46507	48	applied	\N	\N	\N	\N	142852	142852	143333
28665	46510	49	applied	\N	\N	\N	\N	142858	142858	74021
28665	46514	50	applied	\N	\N	\N	\N	142866	142866	143334
28665	46519	51	applied	\N	\N	\N	\N	142876	142876	143335
28665	46520	52	applied	\N	\N	\N	\N	142877	142877	143336
28665	46524	53	applied	\N	\N	\N	\N	142884	142884	74040
28665	46530	54	applied	\N	\N	\N	\N	142896	142896	74042
28665	46531	55	applied	\N	\N	\N	\N	142897	142897	143337
28665	46532	56	applied	\N	\N	\N	\N	142898	142898	143338
28665	46536	57	applied	\N	\N	\N	\N	142906	142906	74099
28665	46541	58	applied	\N	\N	\N	\N	142916	142916	143339
28665	46542	59	applied	\N	\N	\N	\N	142917	142917	143340
28665	46550	60	applied	\N	\N	\N	\N	142935	142935	74121
28665	46551	61	applied	\N	\N	\N	\N	142936	142936	74124
28665	46552	62	applied	\N	\N	\N	\N	142937	142937	74125
28665	46557	63	applied	\N	\N	\N	\N	142963	142963	74126
28665	46558	64	applied	\N	\N	\N	\N	142964	142964	74127
28665	46562	65	applied	\N	\N	\N	\N	143010	143010	74129
28639	46461	17	applied	\N	\N	\N	\N	142730	142730	73885
28639	46462	18	applied	\N	\N	\N	\N	142736	142736	143325
28639	46466	19	applied	\N	\N	\N	\N	142744	142744	73887
28639	46469	20	applied	\N	\N	\N	\N	142753	142753	73927
28639	46474	21	applied	\N	\N	\N	\N	142761	142761	73928
28639	46478	22	applied	\N	\N	\N	\N	142773	142773	73896
28639	46482	23	applied	\N	\N	\N	\N	142782	142782	73898
28639	46483	24	applied	\N	\N	\N	\N	142783	142783	73908
28639	46489	25	applied	\N	\N	\N	\N	142793	142793	73910
28639	46493	26	applied	\N	\N	\N	\N	142806	142806	74044
28639	46495	27	applied	\N	\N	\N	\N	142811	142811	74045
28639	46497	28	applied	\N	\N	\N	\N	142819	142819	73914
28639	46500	29	applied	\N	\N	\N	\N	142835	142835	74046
28639	46502	30	applied	\N	\N	\N	\N	142837	142837	74047
28639	46504	31	applied	\N	\N	\N	\N	142842	142842	73953
28639	46507	32	applied	\N	\N	\N	\N	142852	142852	74049
28639	46510	33	applied	\N	\N	\N	\N	142858	142858	73948
28639	46514	34	applied	\N	\N	\N	\N	142866	142866	73962
28639	46519	35	applied	\N	\N	\N	\N	142876	142876	143326
28639	46520	36	applied	\N	\N	\N	\N	142877	142877	143327
28639	46524	37	applied	\N	\N	\N	\N	142884	142884	74065
28639	46530	38	applied	\N	\N	\N	\N	142896	142896	73973
28639	46531	39	applied	\N	\N	\N	\N	142897	142897	143328
28639	46532	40	applied	\N	\N	\N	\N	142898	142898	74067
28639	46536	41	applied	\N	\N	\N	\N	142906	142906	143329
28639	46541	42	applied	\N	\N	\N	\N	142916	142916	73979
28639	46542	43	applied	\N	\N	\N	\N	142917	142917	73981
28639	46550	44	applied	\N	\N	\N	\N	142935	142935	73991
28639	46551	45	applied	\N	\N	\N	\N	142936	142936	73993
28639	46552	46	applied	\N	\N	\N	\N	142937	142937	74070
28639	46557	47	applied	\N	\N	\N	\N	142963	142963	143330
28639	46558	48	applied	\N	\N	\N	\N	142964	142964	73997
28639	46562	49	applied	\N	\N	\N	\N	143010	143010	74005
28639	46563	50	applied	\N	\N	\N	\N	143012	143012	143331
28639	46570	51	applied	\N	\N	\N	\N	143034	143034	143332
28639	46571	52	applied	\N	\N	\N	\N	143036	143036	143333
28639	46573	53	applied	\N	\N	\N	\N	143043	143043	74021
28639	46579	54	applied	\N	\N	\N	\N	143056	143056	143334
28639	46581	55	applied	\N	\N	\N	\N	143059	143059	143335
28639	46582	56	applied	\N	\N	\N	\N	143060	143060	143336
28639	46586	57	applied	\N	\N	\N	\N	143067	143067	74040
28639	46589	58	applied	\N	\N	\N	\N	143078	143078	74042
28639	46592	59	applied	\N	\N	\N	\N	143091	143091	143337
28639	46602	60	applied	\N	\N	\N	\N	143112	143112	143338
28639	46603	61	applied	\N	\N	\N	\N	143114	143114	74099
28639	46606	62	applied	\N	\N	\N	\N	143124	143124	143339
28639	46608	63	applied	\N	\N	\N	\N	143128	143128	143340
28639	46611	64	applied	\N	\N	\N	\N	143136	143136	74121
28639	46615	65	applied	\N	\N	\N	\N	143147	143147	74124
28639	46617	66	applied	\N	\N	\N	\N	143153	143153	74125
28639	46621	68	applied	\N	\N	\N	\N	143164	143164	74126
28639	46623	69	applied	\N	\N	\N	\N	143171	143171	74127
28639	46629	70	applied	\N	\N	\N	\N	143182	143182	74129
28639	46630	71	applied	\N	\N	\N	\N	143184	143184	143342
28639	46633	72	applied	\N	\N	\N	\N	143191	143191	143343
28639	46635	73	applied	\N	\N	\N	\N	143196	143196	74140
28639	46639	74	applied	\N	\N	\N	\N	143203	143203	74142
28639	46642	75	applied	\N	\N	\N	\N	143211	143211	74144
28639	46646	76	applied	\N	\N	\N	\N	143233	143233	74152
28639	46651	77	applied	\N	\N	\N	\N	143264	143264	143344
28639	46656	78	applied	\N	\N	\N	\N	143276	143276	143345
28639	46661	79	applied	\N	\N	\N	\N	143284	143284	143346
28639	46662	80	applied	\N	\N	\N	\N	143285	143285	74164
28639	46663	81	applied	\N	\N	\N	\N	143287	143287	143347
28639	46665	82	applied	\N	\N	\N	\N	143295	143295	143348
28639	46669	83	applied	\N	\N	\N	\N	143304	143304	74547
28643	46648	0	applied	\N	\N	\N	\N	143236	143236	75408
28643	46658	1	applied	\N	\N	\N	\N	143280	143280	143364
28643	46668	2	applied	\N	\N	\N	\N	143302	143302	75869
28643	46675	3	applied	\N	\N	\N	\N	143320	143320	75410
28645	46680	0	applied	\N	\N	\N	\N	143369	143369	76063
28645	46681	1	applied	\N	\N	\N	\N	143370	143370	143371
28647	46682	0	applied	\N	\N	\N	\N	143374	143374	143375
28647	46680	1	applied	\N	\N	\N	\N	143369	143369	76063
28647	46681	2	applied	\N	\N	\N	\N	143370	143370	143371
28653	46693	0	applied	\N	\N	\N	\N	143404	143404	143405
28653	46694	1	applied	\N	\N	\N	\N	143406	143406	143407
28653	46695	2	applied	\N	\N	\N	\N	143408	143408	143409
28653	46696	3	applied	\N	\N	\N	\N	143410	143410	76090
28653	46697	4	applied	\N	\N	\N	\N	143411	143411	76094
28653	46698	5	applied	\N	\N	\N	\N	143412	143412	76108
28653	46699	6	applied	\N	\N	\N	\N	143413	143413	143414
28654	46700	0	applied	\N	\N	\N	\N	143416	143416	143417
28654	46701	1	applied	\N	\N	\N	\N	143418	143418	143419
28654	46702	2	applied	\N	\N	\N	\N	143420	143420	143421
28654	46703	3	applied	\N	\N	\N	\N	143422	143422	143423
28654	46704	4	applied	\N	\N	\N	\N	143424	143424	76121
28654	46705	5	applied	\N	\N	\N	\N	143425	143425	143426
28658	46690	0	applied	\N	\N	\N	\N	143397	143397	143398
28658	46681	1	applied	\N	\N	\N	\N	143370	143370	75870
28658	46691	2	applied	\N	\N	\N	\N	143399	143399	142970
28658	46696	3	applied	\N	\N	\N	\N	143410	143410	75420
28658	46705	4	applied	\N	\N	\N	\N	143425	143425	75422
28666	46714	0	applied	\N	\N	\N	\N	143463	143463	143464
28666	46715	1	applied	\N	\N	\N	\N	143465	143465	76161
28669	46720	0	applied	\N	\N	\N	\N	143480	143480	143481
28669	46721	1	applied	\N	\N	\N	\N	143482	143482	143483
28669	46722	2	applied	\N	\N	\N	\N	143484	143484	143485
28674	46723	0	applied	\N	\N	\N	\N	143569	143569	143570
28674	46724	1	applied	\N	\N	\N	\N	143571	143571	143572
28674	46725	2	applied	\N	\N	\N	\N	143573	143573	143574
28674	46726	3	applied	\N	\N	\N	\N	143575	143575	143576
28685	46740	0	applied	\N	\N	\N	\N	143622	143622	143623
28685	46741	1	applied	\N	\N	\N	\N	143624	143624	143625
28685	46742	2	applied	\N	\N	\N	\N	143626	143626	76223
28685	46743	3	applied	\N	\N	\N	\N	143627	143627	143628
28694	46756	0	applied	\N	\N	\N	\N	143667	143667	143668
28694	46757	1	applied	\N	\N	\N	\N	143669	143669	143670
28706	46775	0	applied	\N	\N	\N	\N	143716	143716	76407
28706	46776	1	applied	\N	\N	\N	\N	143717	143717	76411
28712	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28716	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28725	46788	0	applied	\N	\N	\N	\N	143753	143753	143754
28725	46789	1	applied	\N	\N	\N	\N	143755	143755	76456
28731	46790	0	applied	\N	\N	\N	\N	143758	143758	143759
28731	46791	1	applied	\N	\N	\N	\N	143760	143760	143761
28731	46792	2	applied	\N	\N	\N	\N	143762	143762	76460
28731	46793	3	applied	\N	\N	\N	\N	143763	143763	143764
28736	46801	0	applied	\N	\N	\N	\N	143781	143781	143782
28736	46802	1	applied	\N	\N	\N	\N	143783	143783	143784
28665	46563	66	applied	\N	\N	\N	\N	143012	143012	143342
28665	46570	67	applied	\N	\N	\N	\N	143034	143034	143343
28670	46720	0	applied	\N	\N	\N	\N	143480	143480	143481
28670	46721	1	applied	\N	\N	\N	\N	143482	143482	143483
28670	46722	2	applied	\N	\N	\N	\N	143484	143484	143485
28672	46595	0	applied	\N	\N	\N	\N	143098	143098	143099
28672	46597	1	applied	\N	\N	\N	\N	143102	143102	143103
28672	46598	2	applied	\N	\N	\N	\N	143104	143104	143105
28672	46599	3	applied	\N	\N	\N	\N	143106	143106	143107
28672	46560	4	applied	\N	\N	\N	\N	143006	143006	143007
28672	46561	5	applied	\N	\N	\N	\N	143008	143008	143009
28672	46567	6	applied	\N	\N	\N	\N	143028	143028	143491
28672	46568	7	applied	\N	\N	\N	\N	143030	143030	143492
28672	46572	8	applied	\N	\N	\N	\N	143041	143041	143493
28672	46576	9	applied	\N	\N	\N	\N	143050	143050	143494
28672	46577	10	applied	\N	\N	\N	\N	143052	143052	143495
28672	46578	11	applied	\N	\N	\N	\N	143054	143054	143496
28672	46585	12	applied	\N	\N	\N	\N	143065	143065	143497
28672	46588	13	applied	\N	\N	\N	\N	143075	143075	143498
28672	46591	14	applied	\N	\N	\N	\N	143089	143089	143499
28672	46596	15	applied	\N	\N	\N	\N	143100	143100	143500
28672	46604	16	applied	\N	\N	\N	\N	143121	143121	143501
28672	46607	17	applied	\N	\N	\N	\N	143126	143126	143502
28672	46610	18	applied	\N	\N	\N	\N	143134	143134	143503
28672	46613	19	applied	\N	\N	\N	\N	143144	143144	143504
28672	46616	20	applied	\N	\N	\N	\N	143151	143151	143505
28672	46620	21	applied	\N	\N	\N	\N	143162	143162	143506
28672	46622	22	applied	\N	\N	\N	\N	143169	143169	143507
28672	46625	23	applied	\N	\N	\N	\N	143174	143174	143508
28672	46626	24	applied	\N	\N	\N	\N	143176	143176	143509
28672	46632	25	applied	\N	\N	\N	\N	143189	143189	143510
28672	46634	26	applied	\N	\N	\N	\N	143194	143194	143511
28672	46637	27	applied	\N	\N	\N	\N	143199	143199	143512
28672	46641	28	applied	\N	\N	\N	\N	143209	143209	143513
28672	46644	29	applied	\N	\N	\N	\N	143228	143228	143514
28672	46645	30	applied	\N	\N	\N	\N	143231	143231	143515
28672	46649	31	applied	\N	\N	\N	\N	143260	143260	143516
28672	46652	32	applied	\N	\N	\N	\N	143268	143268	143517
28672	46653	33	applied	\N	\N	\N	\N	143270	143270	143518
28672	46654	34	applied	\N	\N	\N	\N	143272	143272	143519
28672	46655	35	applied	\N	\N	\N	\N	143274	143274	143520
28672	46664	36	applied	\N	\N	\N	\N	143293	143293	143521
28672	46666	37	applied	\N	\N	\N	\N	143298	143298	143522
28672	46667	38	applied	\N	\N	\N	\N	143300	143300	143523
28672	46672	39	applied	\N	\N	\N	\N	143313	143313	143524
28672	46674	40	applied	\N	\N	\N	\N	143318	143318	143525
28672	46676	41	applied	\N	\N	\N	\N	143357	143357	143526
28672	46677	42	applied	\N	\N	\N	\N	143359	143359	143527
28672	46682	43	applied	\N	\N	\N	\N	143374	143374	143528
28672	46683	44	applied	\N	\N	\N	\N	143380	143380	143529
28672	46684	45	applied	\N	\N	\N	\N	143385	143385	143530
28672	46685	46	applied	\N	\N	\N	\N	143387	143387	143531
28672	46688	47	applied	\N	\N	\N	\N	143393	143393	143532
28672	46689	48	applied	\N	\N	\N	\N	143395	143395	143533
28672	46693	49	applied	\N	\N	\N	\N	143404	143404	143534
28672	46694	50	applied	\N	\N	\N	\N	143406	143406	143535
28672	46695	51	applied	\N	\N	\N	\N	143408	143408	143536
28672	46700	52	applied	\N	\N	\N	\N	143416	143416	143537
28672	46701	53	applied	\N	\N	\N	\N	143418	143418	143538
28672	46702	54	applied	\N	\N	\N	\N	143420	143420	143539
28672	46706	55	applied	\N	\N	\N	\N	143436	143436	143540
28672	46708	56	applied	\N	\N	\N	\N	143441	143441	143541
28672	46709	57	applied	\N	\N	\N	\N	143446	143446	143542
28672	46712	58	applied	\N	\N	\N	\N	143453	143453	143543
28672	46714	59	applied	\N	\N	\N	\N	143463	143463	143544
28672	46716	60	applied	\N	\N	\N	\N	143470	143470	143545
28672	46717	61	applied	\N	\N	\N	\N	143472	143472	143546
28672	46720	62	applied	\N	\N	\N	\N	143480	143480	143547
28672	46690	63	applied	\N	\N	\N	\N	143397	143397	143398
28672	46562	64	applied	\N	\N	\N	\N	143010	143010	75692
28672	46563	65	applied	\N	\N	\N	\N	143012	143012	75694
28672	46593	66	applied	\N	\N	1000000000	\N	143092	143092	143093
28672	46570	67	applied	\N	\N	\N	\N	143034	143034	143548
28672	46721	68	applied	\N	\N	\N	\N	143482	143482	143483
28672	46565	69	applied	\N	\N	\N	\N	143016	143016	75696
28672	46574	70	applied	\N	\N	\N	\N	143045	143045	143549
28672	46580	71	applied	\N	\N	\N	\N	143057	143057	143015
28672	46594	72	applied	\N	\N	\N	\N	143094	143094	75698
28672	46609	73	applied	\N	\N	\N	\N	143130	143130	143550
28672	46619	74	applied	\N	\N	\N	\N	143155	143155	143551
28672	46571	75	applied	\N	\N	\N	\N	143036	143036	143018
28672	46573	76	applied	\N	\N	\N	\N	143043	143043	143552
28672	46579	77	applied	\N	\N	\N	\N	143056	143056	143033
28672	46581	78	applied	\N	\N	\N	\N	143059	143059	143035
28672	46582	80	applied	\N	\N	\N	\N	143060	143060	75715
28672	46586	81	applied	\N	\N	\N	\N	143067	143067	143044
28672	46589	82	applied	\N	\N	\N	\N	143078	143078	75724
28672	46592	83	applied	\N	\N	\N	\N	143091	143091	143554
28672	46631	84	applied	\N	\N	\N	\N	143186	143186	75726
28672	46638	85	applied	\N	\N	\N	\N	143201	143201	143555
28672	46648	86	applied	\N	\N	\N	\N	143236	143236	75728
28672	46658	87	applied	\N	\N	\N	\N	143280	143280	143058
28672	46668	88	applied	\N	\N	\N	\N	143302	143302	143556
28672	46675	89	applied	\N	\N	\N	\N	143320	143320	75735
28672	46681	90	applied	\N	\N	\N	\N	143370	143370	143557
28672	46691	91	applied	\N	\N	\N	\N	143399	143399	75737
28672	46696	92	applied	\N	\N	\N	\N	143410	143410	143558
28672	46705	93	applied	\N	\N	\N	\N	143425	143425	75742
28672	46710	94	applied	\N	\N	\N	\N	143448	143448	143559
28672	46718	95	applied	\N	\N	\N	\N	143474	143474	143062
28672	46602	96	applied	\N	\N	\N	\N	143112	143112	143560
28672	46603	97	applied	\N	\N	\N	\N	143114	143114	75748
28672	46606	98	applied	\N	\N	\N	\N	143124	143124	143068
28672	46608	99	applied	\N	\N	\N	\N	143128	143128	143561
28672	46611	100	applied	\N	\N	\N	\N	143136	143136	143070
28672	46615	101	applied	\N	\N	\N	\N	143147	143147	75763
28672	46617	102	applied	\N	\N	\N	\N	143153	143153	75771
28672	46621	103	applied	\N	\N	\N	\N	143164	143164	143080
28672	46623	104	applied	\N	\N	\N	\N	143171	143171	75775
28672	46629	105	applied	\N	\N	\N	\N	143182	143182	143562
28672	46630	106	applied	\N	\N	\N	\N	143184	143184	143563
28672	46633	107	applied	\N	\N	\N	\N	143191	143191	75779
28672	46635	108	applied	\N	\N	\N	\N	143196	143196	75781
28672	46639	109	applied	\N	\N	\N	\N	143203	143203	75783
28672	46642	110	applied	\N	\N	\N	\N	143211	143211	75789
28672	46646	111	applied	\N	\N	\N	\N	143233	143233	143564
28672	46651	112	applied	\N	\N	\N	\N	143264	143264	143565
28672	46656	113	applied	\N	\N	\N	\N	143276	143276	143566
28672	46661	114	applied	\N	\N	\N	\N	143284	143284	75810
28672	46662	115	applied	\N	\N	\N	\N	143285	143285	143131
28672	46663	116	applied	\N	\N	\N	\N	143287	143287	143137
28672	46665	117	applied	\N	\N	\N	\N	143295	143295	75814
28672	46669	118	applied	\N	\N	\N	\N	143304	143304	75822
28675	46723	0	applied	\N	\N	\N	\N	143569	143569	143570
28675	46724	1	applied	\N	\N	\N	\N	143571	143571	143572
28675	46725	2	applied	\N	\N	\N	\N	143573	143573	143574
28675	46726	3	applied	\N	\N	\N	\N	143575	143575	143576
28677	46690	0	applied	\N	\N	\N	\N	143397	143397	143398
28677	46668	1	applied	\N	\N	\N	\N	143302	143302	72976
28677	46721	2	applied	\N	\N	\N	\N	143482	143482	143483
28677	46675	3	applied	\N	\N	\N	\N	143320	143320	143583
28677	46681	4	applied	\N	\N	\N	\N	143370	143370	72978
28677	46691	5	applied	\N	\N	\N	\N	143399	143399	143584
28677	46696	6	applied	\N	\N	\N	\N	143410	143410	143585
28677	46705	7	applied	\N	\N	\N	\N	143425	143425	72985
28677	46710	8	applied	\N	\N	\N	\N	143448	143448	143586
28677	46718	9	applied	\N	\N	\N	\N	143474	143474	143587
28677	46725	10	applied	\N	\N	\N	\N	143573	143573	73018
28679	46731	0	applied	\N	\N	\N	\N	143600	143600	143601
28679	46732	1	applied	\N	\N	\N	\N	143602	143602	143603
28679	46733	2	applied	\N	\N	\N	\N	143604	143604	76204
28679	46734	3	applied	\N	\N	\N	\N	143605	143605	76206
28688	46744	0	applied	\N	\N	\N	\N	143634	143634	143635
28688	46745	1	applied	\N	\N	\N	\N	143636	143636	143637
28688	46746	2	applied	\N	\N	\N	\N	143638	143638	143639
28691	46753	0	applied	\N	\N	\N	\N	143653	143653	143654
28691	46754	1	applied	\N	\N	\N	\N	143655	143655	76349
28691	46755	2	applied	\N	\N	\N	\N	143656	143656	76351
28693	46753	0	applied	\N	\N	\N	\N	143653	143653	143654
28693	46754	1	applied	\N	\N	\N	\N	143655	143655	76349
28693	46755	2	applied	\N	\N	\N	\N	143656	143656	76351
28695	46756	0	applied	\N	\N	\N	\N	143667	143667	143668
28695	46757	1	applied	\N	\N	\N	\N	143669	143669	143670
28700	46765	0	applied	\N	\N	\N	\N	143696	143696	143697
28700	46766	1	applied	\N	\N	\N	\N	143698	143698	76375
28700	46767	2	applied	\N	\N	\N	\N	143699	143699	143700
28702	46768	0	applied	\N	\N	\N	\N	143704	143704	143705
28702	46769	1	applied	\N	\N	\N	\N	143706	143706	76381
28705	46774	0	applied	\N	\N	\N	\N	143714	143714	143715
28705	46775	1	applied	\N	\N	\N	\N	143716	143716	76407
28705	46776	2	applied	\N	\N	\N	\N	143717	143717	76411
28707	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28711	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28719	46778	0	applied	\N	\N	\N	\N	143732	143732	143733
28719	46779	1	applied	\N	\N	\N	\N	143734	143734	143735
28719	46780	2	applied	\N	\N	\N	\N	143736	143736	76422
28724	46782	0	applied	\N	\N	\N	\N	143741	143741	143742
28724	46783	1	applied	\N	\N	\N	\N	143743	143743	143744
28724	46784	2	applied	\N	\N	\N	\N	143745	143745	76617
28724	46785	3	applied	\N	\N	\N	\N	143746	143746	76436
28724	46781	4	applied	\N	\N	\N	\N	143738	143738	76619
28724	46786	5	applied	\N	\N	\N	\N	143747	143747	76445
28724	46787	6	applied	\N	\N	\N	\N	143748	143748	76447
28730	46790	0	applied	\N	\N	\N	\N	143758	143758	143759
28730	46791	1	applied	\N	\N	\N	\N	143760	143760	143761
28730	46792	2	applied	\N	\N	\N	\N	143762	143762	76460
28730	46793	3	applied	\N	\N	\N	\N	143763	143763	143764
28737	46801	0	applied	\N	\N	\N	\N	143781	143781	143782
28737	46802	1	applied	\N	\N	\N	\N	143783	143783	143784
28739	46803	0	applied	\N	\N	\N	\N	143788	143788	143789
28739	46804	1	applied	\N	\N	\N	\N	143790	143790	76493
28744	46805	0	applied	\N	\N	\N	\N	143799	143799	143800
28744	46806	1	applied	\N	\N	\N	\N	143801	143801	76497
28748	46807	0	applied	\N	\N	\N	\N	143806	143806	143807
28748	46808	1	applied	\N	\N	\N	\N	143808	143808	143809
28748	46809	2	applied	\N	\N	\N	\N	143810	143810	76509
28750	46807	0	applied	\N	\N	\N	\N	143806	143806	143807
28750	46808	1	applied	\N	\N	\N	\N	143808	143808	143809
28750	46809	2	applied	\N	\N	\N	\N	143810	143810	76509
28759	46818	0	applied	\N	\N	\N	\N	143832	143832	143833
28759	46819	1	applied	\N	\N	\N	\N	143834	143834	143835
28766	46828	0	applied	\N	\N	\N	\N	143856	143856	143857
28766	46829	2	applied	\N	\N	\N	\N	143859	143859	143860
28766	46830	3	applied	\N	\N	\N	\N	143861	143861	76563
28766	46831	4	applied	\N	\N	\N	\N	143862	143862	76637
28766	46832	5	applied	\N	\N	\N	\N	143863	143863	76580
28766	46833	6	applied	\N	\N	\N	\N	143864	143864	76638
28766	46834	7	applied	\N	\N	\N	\N	143865	143865	143866
28766	46835	8	applied	\N	\N	\N	\N	143867	143867	76641
28771	46843	0	applied	\N	\N	\N	\N	143888	143888	111296
28771	46844	1	applied	\N	\N	\N	\N	143889	143889	143890
28771	46845	2	applied	\N	\N	\N	\N	143891	143891	143892
28778	46851	0	applied	\N	\N	\N	\N	143907	143907	143908
28778	46853	1	applied	\N	\N	\N	\N	143915	143915	143916
28778	46854	2	applied	\N	\N	\N	\N	143917	143917	143918
28778	46852	3	applied	\N	\N	\N	\N	143909	143909	76698
28778	46855	4	applied	\N	\N	\N	\N	143919	143919	76699
28778	46856	5	applied	\N	\N	\N	\N	143920	143920	143921
28778	46857	6	applied	\N	\N	\N	\N	143922	143922	76700
28778	46858	7	applied	\N	\N	\N	\N	143923	143923	143924
28788	46881	0	applied	\N	\N	\N	\N	143974	143974	143975
28788	46882	1	applied	\N	\N	\N	\N	143976	143976	76787
28791	46895	0	applied	\N	\N	\N	\N	144000	144000	144001
28791	46896	1	applied	\N	\N	\N	\N	144002	144002	76834
28791	46897	2	applied	\N	\N	\N	\N	144003	144003	144004
28791	46898	3	applied	\N	\N	\N	\N	144005	144005	76836
28798	46907	0	applied	\N	\N	\N	\N	144028	144028	144029
28798	46908	1	applied	\N	\N	\N	\N	144030	144030	144031
28798	46909	2	applied	\N	\N	\N	\N	144032	144032	144033
28805	46913	0	applied	\N	\N	\N	\N	144043	144043	144044
28805	46914	1	applied	\N	\N	\N	\N	144045	144045	144046
28805	46915	2	applied	\N	\N	\N	\N	144047	144047	144048
28805	46916	3	applied	\N	\N	\N	\N	144049	144049	144050
28805	46917	4	applied	\N	\N	\N	\N	144051	144051	76930
28805	46918	6	applied	\N	\N	\N	\N	144053	144053	144054
28807	46919	0	applied	\N	\N	\N	\N	144060	144060	144061
28807	46920	1	applied	\N	\N	\N	\N	144062	144062	76934
28807	46921	2	applied	\N	\N	\N	\N	144063	144063	144064
28818	46931	0	applied	\N	\N	\N	\N	144096	144096	144097
28818	46932	1	applied	\N	\N	\N	\N	144098	144098	77261
28818	46933	2	applied	\N	\N	\N	\N	144099	144099	76991
28828	46952	0	applied	\N	\N	\N	\N	144151	144151	144152
28828	46953	1	applied	\N	\N	\N	\N	144153	144153	144154
28828	46954	2	applied	\N	\N	\N	\N	144155	144155	77052
28828	46955	3	applied	\N	\N	\N	\N	144156	144156	77453
28828	46956	4	applied	\N	\N	\N	\N	144157	144157	77454
28828	46957	5	applied	\N	\N	\N	\N	144158	144158	77457
28828	46958	6	applied	\N	\N	\N	\N	144159	144159	77086
28830	46952	0	applied	\N	\N	\N	\N	144151	144151	144152
28830	46953	1	applied	\N	\N	\N	\N	144153	144153	144154
28704	46775	1	applied	\N	\N	\N	\N	143716	143716	76407
28704	46776	2	applied	\N	\N	\N	\N	143717	143717	76411
28709	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28713	46777	0	applied	\N	\N	\N	\N	143721	143721	76413
28721	46778	0	applied	\N	\N	\N	\N	143732	143732	143733
28721	46779	1	applied	\N	\N	\N	\N	143734	143734	143735
28721	46780	2	applied	\N	\N	\N	\N	143736	143736	76422
28721	46781	3	applied	\N	\N	\N	\N	143738	143738	76616
28723	46782	0	applied	\N	\N	\N	\N	143741	143741	143742
28723	46783	1	applied	\N	\N	\N	\N	143743	143743	143744
28723	46784	2	applied	\N	\N	\N	\N	143745	143745	76617
28723	46785	3	applied	\N	\N	\N	\N	143746	143746	76436
28723	46781	4	applied	\N	\N	\N	\N	143738	143738	76619
28723	46786	5	applied	\N	\N	\N	\N	143747	143747	76445
28723	46787	6	applied	\N	\N	\N	\N	143748	143748	76447
28726	46788	0	applied	\N	\N	\N	\N	143753	143753	143754
28726	46789	1	applied	\N	\N	\N	\N	143755	143755	76456
28732	46794	0	applied	\N	\N	\N	\N	143768	143768	143769
28732	46795	1	applied	\N	\N	\N	\N	143770	143770	76473
28732	46796	2	applied	\N	\N	\N	\N	143771	143771	76623
28734	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28734	46790	1	applied	\N	\N	\N	\N	143758	143758	143759
28734	46794	2	applied	\N	\N	\N	\N	143768	143768	143769
28734	46798	3	applied	\N	\N	\N	\N	143775	143775	143776
28734	46791	4	applied	\N	\N	\N	\N	143760	143760	143761
28741	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28741	46595	1	applied	\N	\N	\N	\N	143098	143098	143099
28741	46304	2	applied	\N	\N	\N	\N	142251	142251	142252
28741	46306	3	applied	\N	\N	\N	\N	142257	142257	142258
28741	46307	4	applied	\N	\N	\N	\N	142259	142259	142260
28741	46311	5	applied	\N	\N	\N	\N	142267	142267	142268
28741	46312	6	applied	\N	\N	\N	\N	142269	142269	142270
28741	46315	7	applied	\N	\N	\N	\N	142279	142279	142280
28741	46597	8	applied	\N	\N	\N	\N	143102	143102	143103
28741	46598	9	applied	\N	\N	\N	\N	143104	143104	143105
28741	46599	10	applied	\N	\N	\N	\N	143106	143106	143107
28741	46317	11	applied	\N	\N	\N	\N	142287	142287	142288
28741	46318	12	applied	\N	\N	\N	\N	142289	142289	142290
28741	46319	13	applied	\N	\N	\N	\N	142291	142291	142292
28741	46320	14	applied	\N	\N	\N	\N	142293	142293	142294
28741	46321	15	applied	\N	\N	\N	\N	142295	142295	142296
28741	46322	16	applied	\N	\N	\N	\N	142297	142297	142298
28741	46323	17	applied	\N	\N	\N	\N	142299	142299	142300
28741	46331	18	applied	\N	\N	\N	\N	142316	142316	142317
28741	46333	19	applied	\N	\N	\N	\N	142327	142327	142328
28741	46334	20	applied	\N	\N	\N	\N	142329	142329	142330
28741	46337	21	applied	\N	\N	\N	\N	142336	142336	142337
28741	46339	22	applied	\N	\N	\N	\N	142343	142343	142344
28741	46341	23	applied	\N	\N	\N	\N	142350	142350	142351
28741	46342	24	applied	\N	\N	\N	\N	142352	142352	142353
28741	46343	25	applied	\N	\N	\N	\N	142354	142354	142355
28741	46348	26	applied	\N	\N	\N	\N	142365	142365	142366
28741	46350	27	applied	\N	\N	\N	\N	142393	142393	142394
28741	46352	28	applied	\N	\N	\N	\N	142399	142399	142400
28741	46355	29	applied	\N	\N	\N	\N	142406	142406	142407
28741	46357	30	applied	\N	\N	\N	\N	142412	142412	142413
28741	46358	31	applied	\N	\N	\N	\N	142414	142414	142415
28741	46362	32	applied	\N	\N	\N	\N	142423	142423	142424
28741	46363	33	applied	\N	\N	\N	\N	142425	142425	142426
28741	46366	34	applied	\N	\N	\N	\N	142436	142436	142437
28741	46368	35	applied	\N	\N	\N	\N	142443	142443	142444
28741	46369	36	applied	\N	\N	\N	\N	142445	142445	142446
28741	46370	37	applied	\N	\N	\N	\N	142447	142447	142448
28741	46374	38	applied	\N	\N	\N	\N	142457	142457	142458
28741	46376	39	applied	\N	\N	\N	\N	142466	142466	142467
28741	46378	40	applied	\N	\N	\N	\N	142473	142473	142474
28741	46380	41	applied	\N	\N	\N	\N	142481	142481	142482
28741	46382	42	applied	\N	\N	\N	\N	142489	142489	142490
28741	46384	43	applied	\N	\N	\N	\N	142495	142495	142496
28741	46386	44	applied	\N	\N	\N	\N	142502	142502	142503
28741	46387	45	applied	\N	\N	\N	\N	142504	142504	142505
28741	46390	46	applied	\N	\N	\N	\N	142514	142514	142515
28741	46391	47	applied	\N	\N	\N	\N	142516	142516	142517
28741	46394	48	applied	\N	\N	\N	\N	142524	142524	142525
28741	46396	49	applied	\N	\N	\N	\N	142530	142530	142531
28741	46399	50	applied	\N	\N	\N	\N	142537	142537	142538
28741	46401	51	applied	\N	\N	\N	\N	142541	142541	142542
28741	46403	53	applied	\N	\N	\N	\N	142545	142545	142546
28741	46405	54	applied	\N	\N	\N	\N	142552	142552	142553
28741	46407	55	applied	\N	\N	\N	\N	142560	142560	142561
28741	46409	56	applied	\N	\N	\N	\N	142572	142572	142573
28741	46411	57	applied	\N	\N	\N	\N	142580	142580	142581
28741	46414	58	applied	\N	\N	\N	\N	142586	142586	142587
28741	46416	59	applied	\N	\N	\N	\N	142590	142590	142591
28741	46417	60	applied	\N	\N	\N	\N	142592	142592	142593
28741	46418	61	applied	\N	\N	\N	\N	142594	142594	142595
28741	46423	62	applied	\N	\N	\N	\N	142607	142607	142608
28741	46425	63	applied	\N	\N	\N	\N	142615	142615	142616
28741	46427	64	applied	\N	\N	\N	\N	142625	142625	142626
28741	46428	65	applied	\N	\N	\N	\N	142627	142627	142628
28741	46429	66	applied	\N	\N	\N	\N	142629	142629	142630
28741	46434	67	applied	\N	\N	\N	\N	142641	142641	142642
28741	46436	68	applied	\N	\N	\N	\N	142646	142646	142647
28741	46439	69	applied	\N	\N	\N	\N	142655	142655	142656
28741	46442	70	applied	\N	\N	\N	\N	142667	142667	142668
28741	46444	71	applied	\N	\N	\N	\N	142678	142678	142679
28741	46447	72	applied	\N	\N	\N	\N	142690	142690	142691
28741	46452	73	applied	\N	\N	\N	\N	142706	142706	142707
28741	46456	74	applied	\N	\N	\N	\N	142719	142719	142720
28741	46459	75	applied	\N	\N	\N	\N	142726	142726	142727
28741	46463	76	applied	\N	\N	\N	\N	142738	142738	142739
28741	46467	77	applied	\N	\N	\N	\N	142750	142750	142751
28741	46473	78	applied	\N	\N	\N	\N	142759	142759	142760
28741	46477	79	applied	\N	\N	\N	\N	142771	142771	142772
28741	46480	80	applied	\N	\N	\N	\N	142778	142778	142779
28741	46481	81	applied	\N	\N	\N	\N	142780	142780	142781
28741	46488	82	applied	\N	\N	\N	\N	142791	142791	142792
28741	46490	83	applied	\N	\N	\N	\N	142801	142801	142802
28741	46494	84	applied	\N	\N	\N	\N	142809	142809	142810
28741	46496	85	applied	\N	\N	\N	\N	142816	142816	142817
28741	46499	86	applied	\N	\N	\N	\N	142833	142833	142834
28741	46503	87	applied	\N	\N	\N	\N	142840	142840	142841
28741	46506	88	applied	\N	\N	\N	\N	142850	142850	142851
28741	46508	89	applied	\N	\N	\N	\N	142855	142855	142856
28741	46512	90	applied	\N	\N	\N	\N	142863	142863	142864
28741	46515	91	applied	\N	\N	\N	\N	142869	142869	142870
28741	46516	92	applied	\N	\N	\N	\N	142871	142871	142872
28741	46522	93	applied	\N	\N	\N	\N	142881	142881	142882
28741	46525	94	applied	\N	\N	\N	\N	142888	142888	142889
28741	46526	95	applied	\N	\N	\N	\N	142890	142890	142891
28720	46779	1	applied	\N	\N	\N	\N	143734	143734	143735
28720	46780	2	applied	\N	\N	\N	\N	143736	143736	76422
28720	46781	3	applied	\N	\N	\N	\N	143738	143738	76616
28722	46782	0	applied	\N	\N	\N	\N	143741	143741	143742
28722	46783	1	applied	\N	\N	\N	\N	143743	143743	143744
28722	46784	2	applied	\N	\N	\N	\N	143745	143745	76617
28722	46785	3	applied	\N	\N	\N	\N	143746	143746	76436
28722	46781	4	applied	\N	\N	\N	\N	143738	143738	76619
28722	46786	5	applied	\N	\N	\N	\N	143747	143747	76445
28722	46787	6	applied	\N	\N	\N	\N	143748	143748	76447
28733	46794	0	applied	\N	\N	\N	\N	143768	143768	143769
28733	46795	1	applied	\N	\N	\N	\N	143770	143770	76473
28733	46796	2	applied	\N	\N	\N	\N	143771	143771	76623
28735	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28735	46798	1	applied	\N	\N	\N	\N	143775	143775	143776
28735	46799	2	applied	\N	\N	\N	\N	143778	143778	76479
28735	46800	3	applied	\N	\N	\N	\N	143779	143779	76481
28740	46803	0	applied	\N	\N	\N	\N	143788	143788	143789
28740	46804	1	applied	\N	\N	\N	\N	143790	143790	76493
28742	46805	0	applied	\N	\N	\N	\N	143799	143799	143800
28742	46806	1	applied	\N	\N	\N	\N	143801	143801	76497
28745	46805	0	applied	\N	\N	\N	\N	143799	143799	143800
28745	46806	1	applied	\N	\N	\N	\N	143801	143801	76497
28753	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28755	46812	0	applied	\N	\N	\N	\N	143819	143819	143820
28755	46813	1	applied	\N	\N	\N	\N	143821	143821	143822
28757	46814	0	applied	\N	\N	\N	\N	143825	143825	143826
28757	46815	1	applied	\N	\N	\N	\N	143827	143827	76629
28757	46816	2	applied	\N	\N	\N	\N	143828	143828	143829
28757	46817	3	applied	\N	\N	\N	\N	143830	143830	76533
28760	46818	0	applied	\N	\N	\N	\N	143832	143832	143833
28760	46819	1	applied	\N	\N	\N	\N	143834	143834	143835
28762	46820	0	applied	\N	\N	1000000000	\N	143840	143840	143841
28762	46821	1	applied	\N	\N	\N	\N	143842	143842	143843
28762	46822	2	applied	\N	\N	\N	\N	143844	143844	76542
28762	46823	3	applied	\N	\N	\N	\N	143845	143845	143846
28764	46824	0	applied	\N	\N	\N	\N	143848	143848	143849
28764	46826	1	applied	\N	\N	\N	\N	143852	143852	76634
28764	46827	2	applied	\N	\N	\N	\N	143853	143853	76559
28764	46825	3	applied	\N	\N	\N	\N	143850	143850	76561
28767	46828	0	applied	\N	\N	\N	\N	143856	143856	143857
28767	46829	2	applied	\N	\N	\N	\N	143859	143859	143860
28767	46830	3	applied	\N	\N	\N	\N	143861	143861	76563
28767	46831	4	applied	\N	\N	\N	\N	143862	143862	76637
28767	46832	5	applied	\N	\N	\N	\N	143863	143863	76580
28767	46833	6	applied	\N	\N	\N	\N	143864	143864	76638
28767	46834	7	applied	\N	\N	\N	\N	143865	143865	143866
28767	46835	8	applied	\N	\N	\N	\N	143867	143867	76641
28769	46836	0	applied	\N	\N	\N	\N	143876	143876	143877
28769	46837	1	applied	\N	\N	\N	\N	143878	143878	143879
28769	46838	2	applied	\N	\N	\N	\N	143880	143880	76643
28769	46839	3	applied	\N	\N	\N	\N	143881	143881	76598
28769	46840	4	applied	\N	\N	\N	\N	143882	143882	76649
28769	46841	5	applied	\N	\N	1000000000	\N	143883	143883	143884
28769	46842	6	applied	\N	\N	\N	\N	143885	143885	143886
28774	46851	0	applied	\N	\N	\N	\N	143907	143907	143908
28774	46850	1	applied	\N	\N	\N	\N	143904	143904	143905
28774	46852	2	applied	\N	\N	\N	\N	143909	143909	76698
28776	46850	0	applied	\N	\N	\N	\N	143904	143904	143905
28779	46859	0	applied	\N	\N	\N	\N	143927	143927	143928
28779	46860	1	applied	\N	\N	\N	\N	143929	143929	143930
28779	46861	2	applied	\N	\N	\N	\N	143931	143931	77058
28779	46862	3	applied	\N	\N	\N	\N	143932	143932	76714
28779	46863	4	applied	\N	\N	\N	\N	143933	143933	77062
28779	46864	5	applied	\N	\N	\N	\N	143934	143934	77063
28782	46859	0	applied	\N	\N	\N	\N	143927	143927	143928
28782	46860	1	applied	\N	\N	\N	\N	143929	143929	143930
28782	46861	2	applied	\N	\N	\N	\N	143931	143931	77058
28782	46862	3	applied	\N	\N	\N	\N	143932	143932	76714
28782	46863	4	applied	\N	\N	\N	\N	143933	143933	77062
28782	46864	5	applied	\N	\N	\N	\N	143934	143934	77063
28783	46865	0	applied	\N	\N	\N	\N	143942	143942	143943
28783	46866	1	applied	\N	\N	\N	\N	143944	143944	76734
28783	46867	2	applied	\N	\N	\N	\N	143945	143945	76738
28783	46868	3	applied	\N	\N	\N	\N	143946	143946	76744
28786	46874	0	applied	\N	\N	\N	\N	143958	143958	143959
28786	46875	1	applied	\N	\N	\N	\N	143960	143960	143961
28786	46876	2	applied	\N	\N	\N	\N	143962	143962	143963
28789	46883	0	applied	\N	\N	\N	\N	143978	143978	143979
28789	46884	1	applied	\N	\N	\N	\N	143980	143980	143981
28789	46885	2	applied	\N	\N	\N	\N	143982	143982	143983
28789	46886	3	applied	\N	\N	\N	\N	143984	143984	143985
28789	46887	4	applied	\N	\N	\N	\N	143986	143986	143987
28789	46888	5	applied	\N	\N	\N	\N	143988	143988	143989
28789	46889	6	applied	\N	\N	\N	\N	143990	143990	76798
28789	46890	7	applied	\N	\N	\N	\N	143991	143991	143992
28789	46891	8	applied	\N	\N	\N	\N	143993	143993	76811
28789	46892	9	applied	\N	\N	\N	\N	143994	143994	76817
28792	46899	0	applied	\N	\N	\N	\N	144008	144008	144009
28792	46900	1	applied	\N	\N	\N	\N	144010	144010	144011
28792	46901	2	applied	\N	\N	\N	\N	144012	144012	76844
28792	46902	3	applied	\N	\N	\N	\N	144013	144013	144014
28792	46903	4	applied	\N	\N	\N	\N	144015	144015	144016
28794	46899	0	applied	\N	\N	\N	\N	144008	144008	144009
28794	46900	1	applied	\N	\N	\N	\N	144010	144010	144011
28794	46901	2	applied	\N	\N	\N	\N	144012	144012	76844
28794	46902	3	applied	\N	\N	\N	\N	144013	144013	144014
28794	46903	4	applied	\N	\N	\N	\N	144015	144015	144016
28799	46907	0	applied	\N	\N	\N	\N	144028	144028	144029
28799	46908	1	applied	\N	\N	\N	\N	144030	144030	144031
28806	46913	0	applied	\N	\N	\N	\N	144043	144043	144044
28806	46914	1	applied	\N	\N	\N	\N	144045	144045	144046
28806	46915	2	applied	\N	\N	\N	\N	144047	144047	144048
28806	46916	3	applied	\N	\N	\N	\N	144049	144049	144050
28806	46917	4	applied	\N	\N	\N	\N	144051	144051	76930
28806	46918	6	applied	\N	\N	\N	\N	144053	144053	144054
28810	46919	0	applied	\N	\N	\N	\N	144060	144060	144061
28810	46920	1	applied	\N	\N	\N	\N	144062	144062	76934
28810	46921	2	applied	\N	\N	\N	\N	144063	144063	144064
28812	46922	0	applied	\N	\N	\N	\N	144071	144071	144072
28812	46924	1	applied	\N	\N	\N	\N	144075	144075	76945
28814	46926	0	applied	\N	\N	\N	\N	144083	144083	144084
28816	46925	0	applied	\N	\N	\N	\N	144081	144081	144082
28816	46926	1	applied	\N	\N	\N	\N	144083	144083	144084
28816	46927	2	applied	\N	\N	\N	\N	144085	144085	77255
28821	46936	0	applied	\N	\N	\N	\N	144109	144109	144110
28821	46937	1	applied	\N	\N	\N	\N	144111	144111	77004
28821	46938	2	applied	\N	\N	\N	\N	144112	144112	144113
28824	46941	0	applied	\N	\N	\N	\N	144125	144125	144126
28738	46803	0	applied	\N	\N	\N	\N	143788	143788	143789
28738	46804	1	applied	\N	\N	\N	\N	143790	143790	76493
28747	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28749	46807	0	applied	\N	\N	\N	\N	143806	143806	143807
28749	46808	1	applied	\N	\N	\N	\N	143808	143808	143809
28749	46809	2	applied	\N	\N	\N	\N	143810	143810	76509
28751	46810	0	applied	\N	\N	\N	\N	143816	143816	143817
28751	46811	1	applied	\N	\N	\N	\N	143818	143818	76628
28761	46818	0	applied	\N	\N	\N	\N	143832	143832	143833
28761	46819	1	applied	\N	\N	\N	\N	143834	143834	143835
28768	46828	0	applied	\N	\N	\N	\N	143856	143856	143857
28768	46829	2	applied	\N	\N	\N	\N	143859	143859	143860
28768	46830	3	applied	\N	\N	\N	\N	143861	143861	76563
28768	46831	4	applied	\N	\N	\N	\N	143862	143862	76637
28768	46832	5	applied	\N	\N	\N	\N	143863	143863	76580
28768	46833	6	applied	\N	\N	\N	\N	143864	143864	76638
28768	46834	7	applied	\N	\N	\N	\N	143865	143865	143866
28768	46835	8	applied	\N	\N	\N	\N	143867	143867	76641
28770	46843	0	applied	\N	\N	\N	\N	143888	143888	111296
28770	46844	1	applied	\N	\N	\N	\N	143889	143889	143890
28770	46845	2	applied	\N	\N	\N	\N	143891	143891	143892
28772	46846	0	applied	\N	\N	\N	\N	143896	143896	143897
28772	46847	1	applied	\N	\N	\N	\N	143898	143898	76659
28772	46848	2	applied	\N	\N	\N	\N	143899	143899	143900
28772	46849	3	applied	\N	\N	\N	\N	143901	143901	76669
28777	46851	0	applied	\N	\N	\N	\N	143907	143907	143908
28777	46853	1	applied	\N	\N	\N	\N	143915	143915	143916
28777	46854	2	applied	\N	\N	\N	\N	143917	143917	143918
28777	46852	3	applied	\N	\N	\N	\N	143909	143909	76698
28777	46855	4	applied	\N	\N	\N	\N	143919	143919	76699
28777	46856	5	applied	\N	\N	\N	\N	143920	143920	143921
28777	46857	6	applied	\N	\N	\N	\N	143922	143922	76700
28777	46858	7	applied	\N	\N	\N	\N	143923	143923	143924
28780	46859	0	applied	\N	\N	\N	\N	143927	143927	143928
28780	46860	1	applied	\N	\N	\N	\N	143929	143929	143930
28780	46861	2	applied	\N	\N	\N	\N	143931	143931	77058
28780	46862	3	applied	\N	\N	\N	\N	143932	143932	76714
28780	46863	4	applied	\N	\N	\N	\N	143933	143933	77062
28780	46864	5	applied	\N	\N	\N	\N	143934	143934	77063
28784	46869	0	applied	\N	\N	\N	\N	143949	143949	143950
28784	46870	1	applied	\N	\N	\N	\N	143951	143951	143952
28784	46871	2	applied	\N	\N	\N	\N	143953	143953	143954
28784	46872	3	applied	\N	\N	\N	\N	143955	143955	76758
28784	46873	4	applied	\N	\N	\N	\N	143956	143956	76753
28787	46877	0	applied	\N	\N	\N	\N	143966	143966	143967
28787	46878	1	applied	\N	\N	\N	\N	143968	143968	76775
28787	46879	2	applied	\N	\N	\N	\N	143969	143969	143970
28787	46880	3	applied	\N	\N	\N	\N	143971	143971	76781
28790	46893	0	applied	\N	\N	\N	\N	143996	143996	143997
28790	46894	1	applied	\N	\N	\N	\N	143998	143998	143999
28793	46899	0	applied	\N	\N	\N	\N	144008	144008	144009
28793	46900	1	applied	\N	\N	\N	\N	144010	144010	144011
28793	46901	2	applied	\N	\N	\N	\N	144012	144012	76844
28793	46902	3	applied	\N	\N	\N	\N	144013	144013	144014
28793	46903	4	applied	\N	\N	\N	\N	144015	144015	144016
28795	46904	0	applied	\N	\N	\N	\N	144022	144022	144023
28795	46905	1	applied	\N	\N	\N	\N	144024	144024	76859
28795	46906	2	applied	\N	\N	\N	\N	144025	144025	76874
28797	46904	0	applied	\N	\N	\N	\N	144022	144022	144023
28797	46905	1	applied	\N	\N	\N	\N	144024	144024	76859
28797	46906	2	applied	\N	\N	\N	\N	144025	144025	76874
28808	46919	0	applied	\N	\N	\N	\N	144060	144060	144061
28808	46920	1	applied	\N	\N	\N	\N	144062	144062	76934
28808	46921	2	applied	\N	\N	\N	\N	144063	144063	144064
28815	46925	0	applied	\N	\N	\N	\N	144081	144081	144082
28815	46926	1	applied	\N	\N	\N	\N	144083	144083	144084
28815	46927	2	applied	\N	\N	\N	\N	144085	144085	77255
28817	46928	0	applied	\N	\N	\N	\N	144092	144092	144093
28817	46929	1	applied	\N	\N	\N	\N	144094	144094	77257
28817	46930	2	applied	\N	\N	\N	\N	144095	144095	76976
28819	46931	0	applied	\N	\N	\N	\N	144096	144096	144097
28819	46932	1	applied	\N	\N	\N	\N	144098	144098	77261
28819	46933	2	applied	\N	\N	\N	\N	144099	144099	76991
28822	46939	0	applied	\N	\N	\N	\N	144116	144116	144117
28822	46940	1	applied	\N	\N	\N	\N	144118	144118	77015
28827	46949	0	applied	\N	\N	\N	\N	144143	144143	144144
28827	46950	1	applied	\N	\N	\N	\N	144145	144145	144146
28827	46951	2	applied	\N	\N	\N	\N	144147	144147	144148
28829	46952	0	applied	\N	\N	\N	\N	144151	144151	144152
28829	46953	1	applied	\N	\N	\N	\N	144153	144153	144154
28829	46954	2	applied	\N	\N	\N	\N	144155	144155	77052
28829	46955	3	applied	\N	\N	\N	\N	144156	144156	77453
28829	46956	4	applied	\N	\N	\N	\N	144157	144157	77454
28829	46957	5	applied	\N	\N	\N	\N	144158	144158	77457
28829	46958	6	applied	\N	\N	\N	\N	144159	144159	77086
28832	46952	0	applied	\N	\N	\N	\N	144151	144151	144152
28832	46953	1	applied	\N	\N	\N	\N	144153	144153	144154
28832	46954	2	applied	\N	\N	\N	\N	144155	144155	77052
28832	46955	3	applied	\N	\N	\N	\N	144156	144156	77453
28832	46956	4	applied	\N	\N	\N	\N	144157	144157	77454
28832	46957	5	applied	\N	\N	\N	\N	144158	144158	77457
28832	46958	6	applied	\N	\N	\N	\N	144159	144159	77086
28834	46960	0	applied	\N	\N	\N	\N	144169	144169	144170
28834	46961	1	applied	\N	\N	\N	\N	144171	144171	144172
28834	46962	2	applied	\N	\N	\N	\N	144173	144173	77190
28834	46963	3	applied	\N	\N	\N	\N	144174	144174	77461
28834	46964	4	applied	\N	\N	\N	\N	144175	144175	77109
28834	46965	5	applied	\N	\N	\N	\N	144176	144176	77117
28839	46972	0	applied	\N	\N	\N	\N	144189	144189	144190
28839	46973	1	applied	\N	\N	\N	\N	144191	144191	77142
28839	46974	2	applied	\N	\N	\N	\N	144192	144192	77195
28842	46975	0	applied	\N	\N	\N	\N	144199	144199	144200
28842	46976	1	applied	\N	\N	\N	\N	144201	144201	144202
28842	46977	2	applied	\N	\N	\N	\N	144203	144203	144204
28842	46978	3	applied	\N	\N	\N	\N	144205	144205	77196
28842	46979	4	applied	\N	\N	\N	\N	144206	144206	77463
28842	46980	5	applied	\N	\N	\N	\N	144207	144207	77172
28842	46981	6	applied	\N	\N	\N	\N	144208	144208	77466
28850	46988	0	applied	\N	\N	\N	\N	144229	144229	144230
28850	46989	1	applied	\N	\N	\N	\N	144231	144231	144232
28850	46990	2	applied	\N	\N	\N	\N	144233	144233	144234
28850	46991	3	applied	\N	\N	\N	\N	144235	144235	144236
28850	46992	4	applied	\N	\N	\N	\N	144237	144237	144238
28850	46993	5	applied	\N	\N	\N	\N	144239	144239	77470
28853	47003	0	applied	\N	\N	\N	\N	144259	144259	144260
28853	47004	1	applied	\N	\N	\N	\N	144261	144261	144262
28853	47005	2	applied	\N	\N	\N	\N	144263	144263	144264
28853	47006	3	applied	\N	\N	\N	\N	144265	144265	77274
28853	47007	4	applied	\N	\N	\N	\N	144266	144266	144267
28853	47008	5	applied	\N	\N	\N	\N	144268	144268	77278
28741	46527	96	applied	\N	\N	\N	\N	142892	142892	142893
28741	46534	97	applied	\N	\N	\N	\N	142903	142903	142904
28741	46537	98	applied	\N	\N	\N	\N	142909	142909	142910
28741	46538	99	applied	\N	\N	\N	\N	142911	142911	142912
28741	46544	100	applied	\N	\N	\N	\N	142924	142924	142925
28741	46545	101	applied	\N	\N	\N	\N	142926	142926	142927
28741	46546	102	applied	\N	\N	\N	\N	142928	142928	142929
28741	46553	103	applied	\N	\N	\N	\N	142956	142956	142957
28741	46554	104	applied	\N	\N	\N	\N	142958	142958	142959
28741	46560	105	applied	\N	\N	\N	\N	143006	143006	143007
28741	46561	106	applied	\N	\N	\N	\N	143008	143008	143009
28741	46567	107	applied	\N	\N	\N	\N	143028	143028	143491
28741	46568	108	applied	\N	\N	\N	\N	143030	143030	143492
28741	46572	109	applied	\N	\N	\N	\N	143041	143041	143493
28741	46576	110	applied	\N	\N	\N	\N	143050	143050	143494
28741	46577	111	applied	\N	\N	\N	\N	143052	143052	143495
28741	46578	112	applied	\N	\N	\N	\N	143054	143054	143496
28741	46585	113	applied	\N	\N	\N	\N	143065	143065	143497
28741	46588	114	applied	\N	\N	\N	\N	143075	143075	143498
28741	46591	115	applied	\N	\N	\N	\N	143089	143089	143499
28741	46596	116	applied	\N	\N	\N	\N	143100	143100	143500
28741	46604	117	applied	\N	\N	\N	\N	143121	143121	143501
28741	46607	118	applied	\N	\N	\N	\N	143126	143126	143502
28741	46610	119	applied	\N	\N	\N	\N	143134	143134	143503
28741	46613	120	applied	\N	\N	\N	\N	143144	143144	143504
28741	46616	121	applied	\N	\N	\N	\N	143151	143151	143505
28741	46620	122	applied	\N	\N	\N	\N	143162	143162	143506
28741	46622	123	applied	\N	\N	\N	\N	143169	143169	143507
28741	46625	124	applied	\N	\N	\N	\N	143174	143174	143508
28741	46626	125	applied	\N	\N	\N	\N	143176	143176	143509
28743	46805	0	applied	\N	\N	\N	\N	143799	143799	143800
28743	46806	1	applied	\N	\N	\N	\N	143801	143801	76497
28752	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28754	46797	0	applied	\N	\N	\N	\N	143773	143773	143774
28756	46812	0	applied	\N	\N	\N	\N	143819	143819	143820
28756	46813	1	applied	\N	\N	\N	\N	143821	143821	143822
28758	46814	0	applied	\N	\N	\N	\N	143825	143825	143826
28758	46815	1	applied	\N	\N	\N	\N	143827	143827	76629
28758	46816	2	applied	\N	\N	\N	\N	143828	143828	143829
28758	46817	3	applied	\N	\N	\N	\N	143830	143830	76533
28763	46824	0	applied	\N	\N	\N	\N	143848	143848	143849
28763	46825	1	applied	\N	\N	\N	\N	143850	143850	76548
28773	46850	0	applied	\N	\N	\N	\N	143904	143904	143905
28775	46851	0	applied	\N	\N	\N	\N	143907	143907	143908
28775	46850	1	applied	\N	\N	\N	\N	143904	143904	143905
28775	46852	2	applied	\N	\N	\N	\N	143909	143909	76698
28781	46859	0	applied	\N	\N	\N	\N	143927	143927	143928
28781	46860	1	applied	\N	\N	\N	\N	143929	143929	143930
28781	46861	2	applied	\N	\N	\N	\N	143931	143931	77058
28781	46862	3	applied	\N	\N	\N	\N	143932	143932	76714
28781	46863	4	applied	\N	\N	\N	\N	143933	143933	77062
28781	46864	5	applied	\N	\N	\N	\N	143934	143934	77063
28785	46874	0	applied	\N	\N	\N	\N	143958	143958	143959
28785	46875	1	applied	\N	\N	\N	\N	143960	143960	143961
28785	46876	2	applied	\N	\N	\N	\N	143962	143962	143963
28796	46904	0	applied	\N	\N	\N	\N	144022	144022	144023
28796	46905	1	applied	\N	\N	\N	\N	144024	144024	76859
28796	46906	2	applied	\N	\N	\N	\N	144025	144025	76874
28802	46910	0	applied	\N	\N	\N	\N	144037	144037	144038
28802	46911	1	applied	\N	\N	\N	\N	144039	144039	76899
28802	46909	2	applied	\N	\N	\N	\N	144032	144032	144040
28802	46912	3	applied	\N	\N	\N	\N	144041	144041	76908
28809	46919	0	applied	\N	\N	\N	\N	144060	144060	144061
28809	46920	1	applied	\N	\N	\N	\N	144062	144062	76934
28809	46921	2	applied	\N	\N	\N	\N	144063	144063	144064
28811	46922	0	applied	\N	\N	\N	\N	144071	144071	144072
28811	46923	1	applied	\N	\N	\N	\N	144073	144073	144074
28811	46924	2	applied	\N	\N	\N	\N	144075	144075	144076
28813	46925	0	applied	\N	\N	\N	\N	144081	144081	144082
28813	46926	1	applied	\N	\N	\N	\N	144083	144083	144084
28813	46927	2	applied	\N	\N	\N	\N	144085	144085	77255
28820	46934	0	applied	\N	\N	\N	\N	144103	144103	144104
28820	46935	1	applied	\N	\N	\N	\N	144105	144105	144106
28823	46820	0	applied	\N	\N	1000000000	\N	143840	143840	143841
28823	46797	1	applied	\N	\N	\N	\N	143773	143773	143774
28823	46841	2	applied	\N	\N	1000000000	\N	143883	143883	143884
28823	46751	3	applied	\N	\N	\N	\N	143648	143648	76240
28823	46762	4	applied	\N	\N	\N	\N	143689	143689	143637
28823	46773	5	applied	\N	\N	\N	\N	143713	143713	144121
28823	46780	6	applied	\N	\N	\N	\N	143736	143736	76250
28823	46791	7	applied	\N	\N	\N	\N	143760	143760	76252
28823	46802	8	applied	\N	\N	\N	\N	143783	143783	143639
28823	46808	9	applied	\N	\N	\N	\N	143808	143808	76254
28823	46816	10	applied	\N	\N	\N	\N	143828	143828	143643
28823	46825	11	applied	\N	\N	\N	\N	143850	143850	76289
28823	46833	12	applied	\N	\N	\N	\N	143864	143864	143647
28823	46847	13	applied	\N	\N	\N	\N	143898	143898	143649
28825	46941	0	applied	\N	\N	\N	\N	144125	144125	144126
28825	46942	1	applied	\N	\N	\N	\N	144127	144127	144128
28825	46943	2	applied	\N	\N	\N	\N	144129	144129	144130
28825	46944	3	applied	\N	\N	\N	\N	144131	144131	77017
28825	46945	4	applied	\N	\N	\N	\N	144132	144132	144133
28825	46946	5	applied	\N	\N	\N	\N	144134	144134	77024
28825	46947	6	applied	\N	\N	\N	\N	144135	144135	144136
28825	46948	7	applied	\N	\N	\N	\N	144137	144137	77032
28835	46966	0	applied	\N	\N	\N	\N	144179	144179	144180
28835	46967	1	applied	\N	\N	\N	\N	144181	144181	144182
28835	46968	2	applied	\N	\N	\N	\N	144183	144183	77192
28835	46969	3	applied	\N	\N	\N	\N	144184	144184	77127
28835	46970	4	applied	\N	\N	\N	\N	144185	144185	77165
28835	46971	5	applied	\N	\N	\N	\N	144186	144186	77135
28837	46972	0	applied	\N	\N	\N	\N	144189	144189	144190
28837	46973	1	applied	\N	\N	\N	\N	144191	144191	77142
28837	46974	2	applied	\N	\N	\N	\N	144192	144192	77195
28846	46984	0	applied	\N	\N	\N	\N	144218	144218	144219
28846	46985	1	applied	\N	\N	\N	\N	144220	144220	77468
28846	46986	2	applied	\N	\N	\N	\N	144221	144221	77210
28846	46987	3	applied	\N	\N	\N	\N	144222	144222	77214
28851	46994	0	applied	\N	\N	\N	\N	144241	144241	144242
28851	46995	1	applied	\N	\N	\N	\N	144243	144243	144244
28851	46996	2	applied	\N	\N	\N	\N	144245	144245	77229
28851	46997	3	applied	\N	\N	\N	\N	144246	144246	144247
28851	46998	4	applied	\N	\N	\N	\N	144248	144248	77241
28851	46999	5	applied	\N	\N	\N	\N	144249	144249	77473
28855	47009	0	applied	\N	\N	\N	\N	144271	144271	144272
28855	47010	1	applied	\N	\N	\N	\N	144273	144273	144274
28855	47011	2	applied	\N	\N	\N	\N	144275	144275	144276
28855	47012	3	applied	\N	\N	\N	\N	144277	144277	144278
28855	47013	4	applied	\N	\N	\N	\N	144279	144279	144280
28824	46942	1	applied	\N	\N	\N	\N	144127	144127	144128
28824	46943	2	applied	\N	\N	\N	\N	144129	144129	144130
28824	46944	3	applied	\N	\N	\N	\N	144131	144131	77017
28824	46945	4	applied	\N	\N	\N	\N	144132	144132	144133
28824	46946	5	applied	\N	\N	\N	\N	144134	144134	77024
28824	46947	6	applied	\N	\N	\N	\N	144135	144135	144136
28824	46948	7	applied	\N	\N	\N	\N	144137	144137	77032
28826	46941	0	applied	\N	\N	\N	\N	144125	144125	144126
28826	46942	1	applied	\N	\N	\N	\N	144127	144127	144128
28826	46943	2	applied	\N	\N	\N	\N	144129	144129	144130
28826	46944	3	applied	\N	\N	\N	\N	144131	144131	77017
28826	46945	4	applied	\N	\N	\N	\N	144132	144132	144133
28826	46946	5	applied	\N	\N	\N	\N	144134	144134	77024
28826	46947	6	applied	\N	\N	\N	\N	144135	144135	144136
28826	46948	7	applied	\N	\N	\N	\N	144137	144137	77032
28831	46952	0	applied	\N	\N	\N	\N	144151	144151	144152
28831	46953	1	applied	\N	\N	\N	\N	144153	144153	144154
28831	46954	2	applied	\N	\N	\N	\N	144155	144155	77052
28831	46955	3	applied	\N	\N	\N	\N	144156	144156	77453
28831	46956	4	applied	\N	\N	\N	\N	144157	144157	77454
28831	46957	5	applied	\N	\N	\N	\N	144158	144158	77457
28831	46958	6	applied	\N	\N	\N	\N	144159	144159	77086
28833	46959	0	applied	\N	\N	\N	\N	144167	144167	77459
28836	46972	0	applied	\N	\N	\N	\N	144189	144189	144190
28836	46973	1	applied	\N	\N	\N	\N	144191	144191	77142
28836	46974	2	applied	\N	\N	\N	\N	144192	144192	77195
28838	46972	0	applied	\N	\N	\N	\N	144189	144189	144190
28838	46973	1	applied	\N	\N	\N	\N	144191	144191	77142
28838	46974	2	applied	\N	\N	\N	\N	144192	144192	77195
28843	46982	0	applied	\N	\N	\N	\N	144214	144214	144215
28843	46983	1	applied	\N	\N	\N	\N	144216	144216	77180
28845	46984	0	applied	\N	\N	\N	\N	144218	144218	144219
28845	46985	1	applied	\N	\N	\N	\N	144220	144220	77468
28845	46986	2	applied	\N	\N	\N	\N	144221	144221	77210
28845	46987	3	applied	\N	\N	\N	\N	144222	144222	77214
28857	47019	0	applied	\N	\N	\N	\N	144291	144291	144292
28857	47020	1	applied	\N	\N	\N	\N	144293	144293	144294
28857	47021	2	applied	\N	\N	\N	\N	144295	144295	144296
28857	47022	3	applied	\N	\N	\N	\N	144297	144297	144298
28857	47023	4	applied	\N	\N	\N	\N	144299	144299	144300
28857	47024	5	applied	\N	\N	\N	\N	144301	144301	12588
28857	47025	6	applied	\N	\N	\N	\N	144302	144302	12588
28857	47026	7	applied	\N	\N	\N	\N	144303	144303	77365
28857	47027	8	applied	\N	\N	\N	\N	144304	144304	144305
28857	47028	9	applied	\N	\N	\N	\N	144306	144306	77478
28857	47029	10	applied	\N	\N	\N	\N	144307	144307	77369
28857	47030	11	applied	\N	\N	\N	\N	144308	144308	144309
28857	47031	12	applied	\N	\N	\N	\N	144310	144310	77383
28857	47032	13	applied	\N	\N	\N	\N	144311	144311	77482
28857	47033	14	applied	\N	\N	\N	\N	144312	144312	144313
28857	47034	15	applied	\N	\N	\N	\N	144314	144314	144315
28857	47035	16	applied	\N	\N	\N	\N	144316	144316	77483
28861	47036	0	applied	\N	\N	\N	\N	144323	144323	144324
28861	47037	1	applied	\N	\N	\N	\N	144325	144325	144326
28861	47038	2	applied	\N	\N	\N	\N	144327	144327	77431
28863	47039	0	applied	\N	\N	\N	\N	144332	144332	144333
28863	47040	1	applied	\N	\N	\N	\N	144334	144334	77433
28863	47041	2	applied	\N	\N	\N	\N	144335	144335	77484
28863	47042	3	applied	\N	\N	\N	\N	144336	144336	144337
28868	47054	0	applied	\N	\N	\N	\N	144360	144360	144361
28868	47055	1	applied	\N	\N	\N	\N	144362	144362	144363
28870	47056	0	applied	\N	\N	\N	\N	144365	144365	144366
28870	47057	1	applied	\N	\N	\N	\N	144367	144367	77870
28870	47058	2	applied	\N	\N	\N	\N	144368	144368	144369
28872	47063	0	applied	\N	\N	\N	\N	144381	144381	144382
28872	47064	1	applied	\N	\N	\N	\N	144383	144383	144384
28872	47065	2	applied	\N	\N	\N	\N	144385	144385	144386
28872	47066	3	applied	\N	\N	\N	\N	144387	144387	77526
28872	47067	4	applied	\N	\N	\N	\N	144388	144388	144389
28874	47068	0	applied	\N	\N	\N	\N	144394	144394	77528
28881	47077	0	applied	\N	\N	\N	\N	144416	144416	144417
28881	47078	1	applied	\N	\N	\N	\N	144418	144418	77557
28881	47079	2	applied	\N	\N	\N	\N	144419	144419	77879
28886	47088	0	applied	\N	\N	\N	\N	144434	144434	144435
28886	47089	1	applied	\N	\N	\N	\N	144436	144436	144437
28886	47090	2	applied	\N	\N	\N	\N	144438	144438	77882
28886	47091	3	applied	\N	\N	\N	\N	144439	144439	77591
28886	47092	4	applied	\N	\N	\N	\N	144440	144440	77887
28886	47093	6	applied	\N	\N	\N	\N	144442	144442	77607
28886	47094	7	applied	\N	\N	1000000000	\N	144443	144443	144444
28893	47107	0	applied	\N	\N	\N	\N	144476	144476	144477
28893	47108	1	applied	\N	\N	\N	\N	144478	144478	77896
28893	47109	2	applied	\N	\N	\N	\N	144479	144479	77639
28893	47110	3	applied	\N	\N	\N	\N	144480	144480	144481
28895	47107	0	applied	\N	\N	\N	\N	144476	144476	144477
28895	47109	1	applied	\N	\N	\N	\N	144479	144479	144486
28895	47110	2	applied	\N	\N	\N	\N	144480	144480	77637
28897	47111	0	applied	\N	\N	\N	\N	144489	144489	144490
28897	47108	1	applied	\N	\N	\N	\N	144478	144478	144481
28897	47112	2	applied	\N	\N	\N	\N	144491	144491	77641
28897	47113	3	applied	\N	\N	\N	\N	144492	144492	144493
28905	47063	0	applied	\N	\N	\N	\N	144381	144381	144382
28905	47083	1	applied	\N	\N	\N	\N	144353	144353	138525
28905	47072	2	applied	\N	\N	\N	\N	144405	144405	144426
28905	47064	3	applied	\N	\N	\N	\N	144383	144383	144384
28905	47069	4	applied	\N	\N	\N	\N	144397	144397	144398
28905	47073	5	applied	\N	\N	\N	\N	144407	144407	144408
28905	47077	6	applied	\N	\N	\N	\N	144416	144416	144417
28905	47080	7	applied	\N	\N	\N	\N	144421	144421	144422
28905	47084	8	applied	\N	\N	\N	\N	144427	144427	144428
28905	47088	9	applied	\N	\N	\N	\N	144434	144434	144435
28905	47089	10	applied	\N	\N	\N	\N	144436	144436	144437
28905	47095	11	applied	\N	\N	\N	\N	144448	144448	144449
28905	47097	12	applied	\N	\N	\N	\N	144454	144454	144455
28905	47101	13	applied	\N	\N	\N	\N	144460	144460	144461
28905	47102	14	applied	\N	\N	\N	\N	144462	144462	144463
28905	47107	15	applied	\N	\N	\N	\N	144476	144476	144477
28905	47111	16	applied	\N	\N	\N	\N	144489	144489	144490
28905	47114	17	applied	\N	\N	\N	\N	144497	144497	144498
28905	47117	18	applied	\N	\N	\N	\N	144503	144503	144504
28905	47118	19	applied	\N	\N	\N	\N	144505	144505	144506
28905	47123	20	applied	\N	\N	\N	\N	144519	144519	144520
28905	47065	21	applied	\N	\N	\N	\N	144385	144385	144386
28905	47081	22	applied	\N	\N	1000000000	\N	144423	144423	144424
28905	47070	23	applied	\N	\N	\N	\N	144399	144399	77875
28905	47074	24	applied	\N	\N	\N	\N	144409	144409	144531
28905	47078	25	applied	\N	\N	\N	\N	144418	144418	77546
28905	47104	26	applied	\N	\N	1000000000	\N	144466	144466	144467
28905	47066	27	applied	\N	\N	\N	\N	144387	144387	77548
28830	46954	2	applied	\N	\N	\N	\N	144155	144155	77052
28830	46955	3	applied	\N	\N	\N	\N	144156	144156	77453
28830	46956	4	applied	\N	\N	\N	\N	144157	144157	77454
28830	46957	5	applied	\N	\N	\N	\N	144158	144158	77457
28830	46958	6	applied	\N	\N	\N	\N	144159	144159	77086
28840	46975	0	applied	\N	\N	\N	\N	144199	144199	144200
28840	46976	1	applied	\N	\N	\N	\N	144201	144201	144202
28840	46977	2	applied	\N	\N	\N	\N	144203	144203	144204
28840	46978	3	applied	\N	\N	\N	\N	144205	144205	77196
28840	46979	4	applied	\N	\N	\N	\N	144206	144206	77463
28840	46980	5	applied	\N	\N	\N	\N	144207	144207	77172
28840	46981	6	applied	\N	\N	\N	\N	144208	144208	77466
28841	46975	0	applied	\N	\N	\N	\N	144199	144199	144200
28841	46976	1	applied	\N	\N	\N	\N	144201	144201	144202
28841	46977	2	applied	\N	\N	\N	\N	144203	144203	144204
28841	46978	3	applied	\N	\N	\N	\N	144205	144205	77196
28841	46979	4	applied	\N	\N	\N	\N	144206	144206	77463
28841	46980	5	applied	\N	\N	\N	\N	144207	144207	77172
28841	46981	6	applied	\N	\N	\N	\N	144208	144208	77466
28847	46984	0	applied	\N	\N	\N	\N	144218	144218	144219
28847	46985	1	applied	\N	\N	\N	\N	144220	144220	77468
28847	46986	2	applied	\N	\N	\N	\N	144221	144221	77210
28847	46987	3	applied	\N	\N	\N	\N	144222	144222	77214
28852	47000	0	applied	\N	\N	\N	\N	144252	144252	144253
28852	47001	1	applied	\N	\N	\N	\N	144254	144254	144255
28852	47002	2	applied	\N	\N	\N	\N	144256	144256	77272
28854	47003	0	applied	\N	\N	\N	\N	144259	144259	144260
28854	47004	1	applied	\N	\N	\N	\N	144261	144261	144262
28854	47005	2	applied	\N	\N	\N	\N	144263	144263	144264
28854	47006	3	applied	\N	\N	\N	\N	144265	144265	77274
28854	47007	4	applied	\N	\N	\N	\N	144266	144266	144267
28854	47008	5	applied	\N	\N	\N	\N	144268	144268	77278
28858	47019	0	applied	\N	\N	\N	\N	144291	144291	144292
28858	47020	1	applied	\N	\N	\N	\N	144293	144293	144294
28858	47021	2	applied	\N	\N	\N	\N	144295	144295	144296
28858	47022	3	applied	\N	\N	\N	\N	144297	144297	144298
28858	47023	4	applied	\N	\N	\N	\N	144299	144299	144300
28858	47024	5	applied	\N	\N	\N	\N	144301	144301	12588
28858	47025	6	applied	\N	\N	\N	\N	144302	144302	12588
28858	47026	7	applied	\N	\N	\N	\N	144303	144303	77365
28858	47027	8	applied	\N	\N	\N	\N	144304	144304	144305
28858	47028	9	applied	\N	\N	\N	\N	144306	144306	77478
28858	47029	10	applied	\N	\N	\N	\N	144307	144307	77369
28858	47030	11	applied	\N	\N	\N	\N	144308	144308	144309
28858	47031	12	applied	\N	\N	\N	\N	144310	144310	77383
28858	47032	13	applied	\N	\N	\N	\N	144311	144311	77482
28858	47033	14	applied	\N	\N	\N	\N	144312	144312	144313
28858	47034	15	applied	\N	\N	\N	\N	144314	144314	144315
28858	47035	16	applied	\N	\N	\N	\N	144316	144316	77483
28862	47036	0	applied	\N	\N	\N	\N	144323	144323	144324
28862	47037	1	applied	\N	\N	\N	\N	144325	144325	144326
28862	47038	2	applied	\N	\N	\N	\N	144327	144327	77431
28864	47043	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	144338	144338	\N
28864	47044	1	applied	\N	\N	\N	\N	144339	144339	144340
28864	47045	2	applied	\N	\N	\N	\N	144341	144341	77486
28869	47056	0	applied	\N	\N	\N	\N	144365	144365	144366
28869	47057	1	applied	\N	\N	\N	\N	144367	144367	77870
28869	47058	2	applied	\N	\N	\N	\N	144368	144368	144369
28877	47069	0	applied	\N	\N	\N	\N	144397	144397	144398
28877	47070	1	applied	\N	\N	\N	\N	144399	144399	77532
28877	47071	2	applied	\N	\N	\N	\N	144400	144400	144401
28882	47077	0	applied	\N	\N	\N	\N	144416	144416	144417
28882	47078	1	applied	\N	\N	\N	\N	144418	144418	77557
28882	47079	2	applied	\N	\N	\N	\N	144419	144419	77879
28884	47083	0	applied	\N	\N	\N	\N	144426	144426	138525
28884	47084	1	applied	\N	\N	\N	\N	144427	144427	144428
28884	47085	2	applied	\N	\N	\N	\N	144429	144429	77574
28884	47086	3	applied	\N	\N	\N	\N	144430	144430	77881
28884	47087	4	applied	\N	\N	\N	\N	144431	144431	77581
28885	47088	0	applied	\N	\N	\N	\N	144434	144434	144435
28885	47089	1	applied	\N	\N	\N	\N	144436	144436	144437
28885	47090	2	applied	\N	\N	\N	\N	144438	144438	77882
28885	47091	3	applied	\N	\N	\N	\N	144439	144439	77591
28885	47092	4	applied	\N	\N	\N	\N	144440	144440	77887
28885	47093	6	applied	\N	\N	\N	\N	144442	144442	77607
28885	47094	7	applied	\N	\N	1000000000	\N	144443	144443	144444
28887	47095	0	applied	\N	\N	\N	\N	144448	144448	144449
28887	47096	1	applied	\N	\N	\N	\N	144450	144450	77889
28891	47101	0	applied	\N	\N	\N	\N	144460	144460	144461
28891	47102	1	applied	\N	\N	\N	\N	144462	144462	144463
28891	47103	2	applied	\N	\N	\N	\N	144464	144464	144465
28891	47104	3	applied	\N	\N	1000000000	\N	144466	144466	144467
28891	47105	4	applied	\N	\N	\N	\N	144468	144468	77619
28891	47106	5	applied	\N	\N	\N	\N	144469	144469	144470
28896	47107	0	applied	\N	\N	\N	\N	144476	144476	144477
28896	47108	1	applied	\N	\N	\N	\N	144478	144478	77896
28896	47109	2	applied	\N	\N	\N	\N	144479	144479	77639
28896	47110	3	applied	\N	\N	\N	\N	144480	144480	144481
28898	47111	0	applied	\N	\N	\N	\N	144489	144489	144490
28898	47108	1	applied	\N	\N	\N	\N	144478	144478	144481
28898	47113	2	applied	\N	\N	\N	\N	144492	144492	77898
28900	47114	0	applied	\N	\N	\N	\N	144497	144497	144498
28900	47115	1	applied	\N	\N	\N	\N	144499	144499	77900
28902	47117	0	applied	\N	\N	\N	\N	144503	144503	144504
28902	47118	1	applied	\N	\N	\N	\N	144505	144505	144506
28902	47123	2	applied	\N	\N	\N	\N	144519	144519	144520
28902	47119	3	applied	\N	\N	\N	\N	144509	144509	77902
28902	47124	4	applied	\N	\N	\N	\N	144521	144521	144522
28902	47120	5	applied	\N	\N	\N	\N	144510	144510	144516
28902	47121	6	applied	\N	\N	\N	\N	144514	144514	144523
28902	47122	7	applied	\N	\N	\N	\N	144515	144515	77687
28902	47125	8	applied	\N	\N	\N	\N	144524	144524	144525
28904	47117	0	applied	\N	\N	\N	\N	144503	144503	144504
28904	47118	1	applied	\N	\N	\N	\N	144505	144505	144506
28904	47123	2	applied	\N	\N	\N	\N	144519	144519	144520
28904	47119	3	applied	\N	\N	\N	\N	144509	144509	77902
28904	47124	4	applied	\N	\N	\N	\N	144521	144521	144522
28904	47120	5	applied	\N	\N	\N	\N	144510	144510	144516
28906	47126	0	applied	\N	\N	\N	\N	144536	144536	77687
28906	47127	1	applied	\N	\N	1000000000	\N	144537	144537	144538
28906	47121	2	applied	\N	\N	\N	\N	144514	144514	144525
28906	47122	3	applied	\N	\N	\N	\N	144515	144515	144539
28906	47125	4	applied	\N	\N	\N	\N	144524	144524	77691
28906	47128	5	applied	\N	\N	\N	\N	144540	144540	144541
28909	47132	0	applied	\N	\N	\N	\N	144550	144550	144551
28909	47133	1	applied	\N	\N	\N	\N	144552	144552	77707
28909	47134	2	applied	\N	\N	\N	\N	144553	144553	77720
28911	47135	0	applied	\N	\N	\N	\N	144559	144559	144560
28911	47136	1	applied	\N	\N	\N	\N	144561	144561	144562
28855	47014	5	applied	\N	\N	\N	\N	144281	144281	144282
28855	47015	6	applied	\N	\N	\N	\N	144283	144283	77298
28855	47016	7	applied	\N	\N	\N	\N	144284	144284	144285
28855	47017	8	applied	\N	\N	\N	\N	144286	144286	77476
28855	47018	9	applied	\N	\N	1000000000	\N	144287	144287	144288
28859	47036	0	applied	\N	\N	\N	\N	144323	144323	144324
28859	47037	1	applied	\N	\N	\N	\N	144325	144325	144326
28859	47038	2	applied	\N	\N	\N	\N	144327	144327	77431
28866	47046	0	applied	\N	\N	\N	\N	144345	144345	144346
28866	47047	1	applied	\N	\N	\N	\N	144347	144347	77865
28866	47048	2	applied	\N	\N	\N	\N	144348	144348	77446
28871	47059	0	applied	\N	\N	\N	\N	144373	144373	144374
28871	47060	1	applied	\N	\N	\N	\N	144375	144375	144376
28871	47061	2	applied	\N	\N	\N	\N	144377	144377	77872
28871	47062	3	applied	\N	\N	\N	\N	144378	144378	144379
28876	47069	0	applied	\N	\N	\N	\N	144397	144397	144398
28876	47070	1	applied	\N	\N	\N	\N	144399	144399	77532
28876	47071	2	applied	\N	\N	\N	\N	144400	144400	144401
28878	47072	0	applied	\N	\N	\N	\N	144405	144405	144406
28878	47073	1	applied	\N	\N	\N	\N	144407	144407	144408
28878	47074	2	applied	\N	\N	\N	\N	144409	144409	144410
28878	47075	3	applied	\N	\N	\N	\N	144411	144411	77877
28878	47076	4	applied	\N	\N	\N	\N	144412	144412	77878
28880	47077	0	applied	\N	\N	\N	\N	144416	144416	144417
28880	47078	1	applied	\N	\N	\N	\N	144418	144418	77557
28880	47079	2	applied	\N	\N	\N	\N	144419	144419	77879
28888	47097	0	applied	\N	\N	\N	\N	144454	144454	144455
28888	47098	1	applied	\N	\N	\N	\N	144456	144456	77609
28888	47099	2	applied	\N	\N	\N	\N	144457	144457	77611
28888	47100	3	applied	\N	\N	\N	\N	144458	144458	77615
28890	47101	0	applied	\N	\N	\N	\N	144460	144460	144461
28890	47102	1	applied	\N	\N	\N	\N	144462	144462	144463
28890	47103	2	applied	\N	\N	\N	\N	144464	144464	144465
28890	47104	3	applied	\N	\N	1000000000	\N	144466	144466	144467
28890	47105	4	applied	\N	\N	\N	\N	144468	144468	77619
28890	47106	5	applied	\N	\N	\N	\N	144469	144469	144470
28892	47101	0	applied	\N	\N	\N	\N	144460	144460	144461
28892	47102	1	applied	\N	\N	\N	\N	144462	144462	144463
28892	47103	2	applied	\N	\N	\N	\N	144464	144464	144465
28892	47104	3	applied	\N	\N	1000000000	\N	144466	144466	144467
28892	47105	4	applied	\N	\N	\N	\N	144468	144468	77619
28892	47106	5	applied	\N	\N	\N	\N	144469	144469	144470
28899	47114	0	applied	\N	\N	\N	\N	144497	144497	144498
28899	47115	1	applied	\N	\N	\N	\N	144499	144499	77900
28899	47116	2	applied	\N	\N	\N	\N	144500	144500	77663
28913	47141	0	applied	\N	\N	\N	\N	144573	144573	144574
28913	47142	1	applied	\N	\N	\N	\N	144575	144575	144576
28915	47141	0	applied	\N	\N	\N	\N	144573	144573	144574
28915	47142	1	applied	\N	\N	\N	\N	144575	144575	144576
28918	47141	0	applied	\N	\N	\N	\N	144573	144573	144574
28918	47142	1	applied	\N	\N	\N	\N	144575	144575	144576
28928	47158	0	applied	\N	\N	\N	\N	144622	144622	144623
28928	47159	1	applied	\N	\N	1000000000	\N	144624	144624	144625
28928	47160	2	applied	\N	\N	\N	\N	144626	144626	144627
28928	47161	3	applied	\N	\N	\N	\N	144628	144628	77917
28930	47164	0	applied	\N	\N	\N	\N	144638	144638	144639
28930	47165	1	applied	\N	\N	\N	\N	144640	144640	144641
28930	47166	2	applied	\N	\N	\N	\N	144642	144642	144643
28930	47167	3	applied	\N	\N	\N	\N	144644	144644	77929
28930	47168	4	applied	\N	\N	\N	\N	144645	144645	77945
28930	47169	5	applied	\N	\N	\N	\N	144646	144646	78020
28930	47170	6	applied	\N	\N	\N	\N	144647	144647	77966
28940	47183	0	applied	\N	\N	\N	\N	144675	144675	144676
28940	47184	1	applied	\N	\N	\N	\N	144677	144677	78005
28940	47185	2	applied	\N	\N	\N	\N	144678	144678	78191
28942	47183	0	applied	\N	\N	\N	\N	144675	144675	144676
28942	47185	1	applied	\N	\N	\N	\N	144678	144678	144680
28944	47186	0	applied	\N	\N	\N	\N	144685	144685	144686
28944	47187	1	applied	\N	\N	\N	\N	144687	144687	78013
28944	47188	2	applied	\N	\N	\N	\N	144688	144688	78192
28954	47211	0	applied	\N	\N	\N	\N	144735	144735	144736
28954	47212	1	applied	\N	\N	\N	\N	144737	144737	144738
28954	47213	2	applied	\N	\N	\N	\N	144739	144739	78116
28956	47214	0	applied	\N	\N	\N	\N	144742	144742	144743
28956	47215	1	applied	\N	\N	\N	\N	144744	144744	144745
28956	47216	2	applied	\N	\N	\N	\N	144746	144746	78126
28960	47224	0	applied	\N	\N	\N	\N	144766	144766	144767
28960	47225	1	applied	\N	\N	\N	\N	144768	144768	144769
28960	47226	2	applied	\N	\N	\N	\N	144770	144770	78204
28965	47232	0	applied	\N	\N	\N	\N	144788	144788	144789
28965	47233	1	applied	\N	\N	\N	\N	144790	144790	144791
28965	47234	2	applied	\N	\N	\N	\N	144792	144792	78174
28965	47231	3	applied	\N	\N	\N	\N	144785	144785	144793
28965	47235	4	applied	\N	\N	\N	\N	144794	144794	78182
28976	47246	0	applied	\N	\N	\N	\N	144819	144819	144820
28976	47247	1	applied	\N	\N	\N	\N	144821	144821	144822
28976	47248	2	applied	\N	\N	\N	\N	144823	144823	78363
28976	47249	3	applied	\N	\N	\N	\N	144824	144824	78265
28976	47250	4	applied	\N	\N	\N	\N	144825	144825	78275
28976	47251	5	applied	\N	\N	\N	\N	144826	144826	144827
28978	47252	0	applied	\N	\N	\N	\N	144832	144832	144833
28978	47253	1	applied	\N	\N	\N	\N	144834	144834	144835
28978	47254	2	applied	\N	\N	\N	\N	144836	144836	144837
28980	47255	0	applied	\N	\N	\N	\N	144840	144840	144841
28980	47256	1	applied	\N	\N	\N	\N	144842	144842	78318
28980	47257	2	applied	\N	\N	\N	\N	144843	144843	144844
28983	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28983	47259	1	applied	\N	\N	\N	\N	144850	144850	144851
28983	47260	2	applied	\N	\N	\N	\N	144852	144852	144853
28983	47261	3	applied	\N	\N	\N	\N	144854	144854	144855
28983	47262	5	applied	\N	\N	\N	\N	144857	144857	144858
28983	47263	6	applied	\N	\N	\N	\N	144859	144859	144860
28983	47264	7	applied	\N	\N	\N	\N	144861	144861	78324
28983	47265	8	applied	\N	\N	\N	\N	144862	144862	144863
28985	47266	0	applied	\N	\N	\N	\N	144869	144869	144870
28985	47267	1	applied	\N	\N	\N	\N	144878	144878	78350
28985	47268	2	applied	\N	\N	\N	\N	144879	144879	144880
28991	47269	0	applied	\N	\N	\N	\N	144886	144886	144887
28991	47270	1	applied	\N	\N	\N	\N	144888	144888	78385
28991	47271	2	applied	\N	\N	\N	\N	144889	144889	144890
28998	47278	0	applied	\N	\N	\N	\N	144908	144908	144909
28998	47279	1	applied	\N	\N	\N	\N	144910	144910	78739
28998	47280	2	applied	\N	\N	\N	\N	144911	144911	144912
29000	47281	0	applied	\N	\N	\N	\N	144914	144914	144915
29000	47282	1	applied	\N	\N	\N	\N	144916	144916	78429
29000	47283	2	applied	\N	\N	\N	\N	144917	144917	144918
29006	47303	0	applied	\N	\N	\N	\N	144960	144960	144961
29006	47304	1	applied	\N	\N	\N	\N	144962	144962	144963
29006	47305	2	applied	\N	\N	\N	\N	144964	144964	144965
28856	47019	0	applied	\N	\N	\N	\N	144291	144291	144292
28856	47020	1	applied	\N	\N	\N	\N	144293	144293	144294
28856	47021	2	applied	\N	\N	\N	\N	144295	144295	144296
28856	47022	3	applied	\N	\N	\N	\N	144297	144297	144298
28856	47023	4	applied	\N	\N	\N	\N	144299	144299	144300
28856	47024	5	applied	\N	\N	\N	\N	144301	144301	12588
28856	47025	6	applied	\N	\N	\N	\N	144302	144302	12588
28856	47026	7	applied	\N	\N	\N	\N	144303	144303	77365
28856	47027	8	applied	\N	\N	\N	\N	144304	144304	144305
28856	47028	9	applied	\N	\N	\N	\N	144306	144306	77478
28856	47029	10	applied	\N	\N	\N	\N	144307	144307	77369
28856	47030	11	applied	\N	\N	\N	\N	144308	144308	144309
28856	47031	12	applied	\N	\N	\N	\N	144310	144310	77383
28856	47032	13	applied	\N	\N	\N	\N	144311	144311	77482
28856	47033	14	applied	\N	\N	\N	\N	144312	144312	144313
28856	47034	15	applied	\N	\N	\N	\N	144314	144314	144315
28856	47035	16	applied	\N	\N	\N	\N	144316	144316	77483
28860	47036	0	applied	\N	\N	\N	\N	144323	144323	144324
28860	47037	1	applied	\N	\N	\N	\N	144325	144325	144326
28860	47038	2	applied	\N	\N	\N	\N	144327	144327	77431
28865	47043	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	144338	144338	\N
28865	47044	1	applied	\N	\N	\N	\N	144339	144339	144340
28865	47045	2	applied	\N	\N	\N	\N	144341	144341	77486
28867	47049	0	applied	\N	\N	\N	\N	144350	144350	144351
28867	47050	1	applied	\N	\N	1000000000	\N	144352	144352	144353
28867	47051	2	applied	\N	\N	\N	\N	144354	144354	77502
28867	47052	3	applied	\N	\N	\N	\N	144355	144355	144356
28867	47053	4	applied	\N	\N	\N	\N	144357	144357	77504
28873	47063	0	applied	\N	\N	\N	\N	144381	144381	144382
28873	47064	1	applied	\N	\N	\N	\N	144383	144383	144384
28873	47065	2	applied	\N	\N	\N	\N	144385	144385	144386
28873	47066	3	applied	\N	\N	\N	\N	144387	144387	77526
28873	47067	4	applied	\N	\N	\N	\N	144388	144388	144389
28875	47069	0	applied	\N	\N	\N	\N	144397	144397	144398
28875	47070	1	applied	\N	\N	\N	\N	144399	144399	77532
28875	47071	2	applied	\N	\N	\N	\N	144400	144400	144401
28879	47072	0	applied	\N	\N	\N	\N	144405	144405	144406
28879	47073	1	applied	\N	\N	\N	\N	144407	144407	144408
28879	47074	2	applied	\N	\N	\N	\N	144409	144409	144410
28879	47075	3	applied	\N	\N	\N	\N	144411	144411	77877
28879	47076	4	applied	\N	\N	\N	\N	144412	144412	77878
28883	47080	0	applied	\N	\N	\N	\N	144421	144421	144422
28883	47081	1	applied	\N	\N	1000000000	\N	144423	144423	144424
28883	47082	2	applied	\N	\N	\N	\N	144425	144425	77561
28894	47107	0	applied	\N	\N	\N	\N	144476	144476	144477
28894	47108	1	applied	\N	\N	\N	\N	144478	144478	77896
28894	47109	2	applied	\N	\N	\N	\N	144479	144479	77639
28894	47110	3	applied	\N	\N	\N	\N	144480	144480	144481
28901	47083	0	applied	\N	\N	\N	\N	144353	144353	138525
28901	47072	1	applied	\N	\N	\N	\N	144405	144405	144426
28901	47073	2	applied	\N	\N	\N	\N	144407	144407	144408
28901	47077	3	applied	\N	\N	\N	\N	144416	144416	144417
28901	47080	4	applied	\N	\N	\N	\N	144421	144421	144422
28901	47084	5	applied	\N	\N	\N	\N	144427	144427	144428
28901	47088	6	applied	\N	\N	\N	\N	144434	144434	144435
28901	47089	7	applied	\N	\N	\N	\N	144436	144436	144437
28901	47095	8	applied	\N	\N	\N	\N	144448	144448	144449
28901	47097	9	applied	\N	\N	\N	\N	144454	144454	144455
28901	47101	10	applied	\N	\N	\N	\N	144460	144460	144461
28901	47102	11	applied	\N	\N	\N	\N	144462	144462	144463
28901	47107	12	applied	\N	\N	\N	\N	144476	144476	144477
28901	47111	13	applied	\N	\N	\N	\N	144489	144489	144490
28901	47114	14	applied	\N	\N	\N	\N	144497	144497	144498
28901	47117	15	applied	\N	\N	\N	\N	144503	144503	144504
28901	47118	16	applied	\N	\N	\N	\N	144505	144505	144506
28901	47081	17	applied	\N	\N	1000000000	\N	144423	144423	144424
28901	47074	18	applied	\N	\N	\N	\N	144409	144409	144410
28901	47078	19	applied	\N	\N	\N	\N	144418	144418	144507
28901	47075	20	applied	\N	\N	\N	\N	144411	144411	77552
28901	47076	21	applied	\N	\N	\N	\N	144412	144412	77557
28901	47104	22	applied	\N	\N	1000000000	\N	144466	144466	144467
28901	47086	23	applied	\N	\N	\N	\N	144430	144430	77561
28901	47091	24	applied	\N	\N	\N	\N	144439	144439	77880
28901	47092	25	applied	\N	\N	\N	\N	144440	144440	77587
28901	47100	26	applied	\N	\N	\N	\N	144458	144458	77884
28901	47103	27	applied	\N	\N	\N	\N	144464	144464	77886
28901	47109	28	applied	\N	\N	\N	\N	144479	144479	77888
28901	47113	30	applied	\N	\N	\N	\N	144492	144492	77611
28901	47115	31	applied	\N	\N	\N	\N	144499	144499	77615
28901	47119	32	applied	\N	\N	\N	\N	144509	144509	144465
28901	47087	33	applied	\N	\N	\N	\N	144431	144431	77894
28901	47098	34	applied	\N	\N	\N	\N	144456	144456	77619
28901	47110	35	applied	\N	\N	\N	\N	144480	144480	77895
28901	47120	36	applied	\N	\N	\N	\N	144510	144510	144470
28901	47079	37	applied	\N	\N	\N	\N	144419	144419	77896
28901	47094	38	applied	\N	\N	1000000000	\N	144443	144443	144444
28901	47082	39	applied	\N	\N	\N	\N	144425	144425	144486
28901	47085	40	applied	\N	\N	\N	\N	144429	144429	77639
28901	47090	41	applied	\N	\N	\N	\N	144438	144438	77897
28901	47093	42	applied	\N	\N	\N	\N	144442	144442	144511
28901	47096	43	applied	\N	\N	\N	\N	144450	144450	77643
28901	47099	44	applied	\N	\N	\N	\N	144457	144457	77899
28901	47105	45	applied	\N	\N	\N	\N	144468	144468	144512
28901	47106	46	applied	\N	\N	\N	\N	144469	144469	77655
28901	47108	47	applied	\N	\N	\N	\N	144478	144478	77901
28901	47112	48	applied	\N	\N	\N	\N	144491	144491	77665
28901	47116	49	applied	\N	\N	\N	\N	144500	144500	144513
28901	47121	50	applied	\N	\N	\N	\N	144514	144514	77683
28901	47122	51	applied	\N	\N	\N	\N	144515	144515	144516
28903	47117	0	applied	\N	\N	\N	\N	144503	144503	144504
28903	47118	1	applied	\N	\N	\N	\N	144505	144505	144506
28903	47123	2	applied	\N	\N	\N	\N	144519	144519	144520
28903	47119	3	applied	\N	\N	\N	\N	144509	144509	77902
28903	47124	4	applied	\N	\N	\N	\N	144521	144521	144522
28903	47120	5	applied	\N	\N	\N	\N	144510	144510	144516
28903	47121	6	applied	\N	\N	\N	\N	144514	144514	144523
28903	47122	7	applied	\N	\N	\N	\N	144515	144515	77687
28903	47125	8	applied	\N	\N	\N	\N	144524	144524	144525
28908	47132	0	applied	\N	\N	\N	\N	144550	144550	144551
28908	47133	1	applied	\N	\N	\N	\N	144552	144552	77707
28908	47134	2	applied	\N	\N	\N	\N	144553	144553	77720
28912	47140	0	applied	\N	\N	\N	\N	144570	144570	77774
28914	47142	0	applied	\N	\N	\N	\N	144575	144575	77783
28917	47141	0	applied	\N	\N	\N	\N	144573	144573	144574
28917	47142	1	applied	\N	\N	\N	\N	144575	144575	144576
28921	47146	0	applied	\N	\N	\N	\N	144591	144591	144592
28921	47147	1	applied	\N	\N	\N	\N	144593	144593	144594
28921	47148	2	applied	\N	\N	\N	\N	144595	144595	144596
28921	47149	3	applied	\N	\N	\N	\N	144597	144597	144598
28905	47068	28	applied	\N	\N	\N	\N	144394	144394	77877
28905	47071	29	applied	\N	\N	\N	\N	144400	144400	77878
28905	47076	30	applied	\N	\N	\N	\N	144412	144412	77552
28905	47086	31	applied	\N	\N	\N	\N	144430	144430	77879
28905	47091	32	applied	\N	\N	\N	\N	144439	144439	77574
28905	47092	33	applied	\N	\N	\N	\N	144440	144440	77881
28905	47100	34	applied	\N	\N	\N	\N	144458	144458	77883
28905	47103	35	applied	\N	\N	\N	\N	144464	144464	77885
28905	47109	36	applied	\N	\N	\N	\N	144479	144479	77598
28905	47113	37	applied	\N	\N	\N	\N	144492	144492	77609
28905	47115	38	applied	\N	\N	\N	\N	144499	144499	77613
28905	47119	39	applied	\N	\N	\N	\N	144509	144509	144532
28905	47124	40	applied	\N	\N	\N	\N	144521	144521	77619
28905	47079	41	applied	\N	\N	\N	\N	144419	144419	144470
28905	47067	42	applied	\N	\N	\N	\N	144388	144388	77625
28905	47075	43	applied	\N	\N	\N	\N	144411	144411	77896
28905	47087	45	applied	\N	\N	\N	\N	144431	144431	77627
28905	47098	46	applied	\N	\N	\N	\N	144456	144456	144486
28905	47110	47	applied	\N	\N	\N	\N	144480	144480	77637
28905	47120	48	applied	\N	\N	\N	\N	144510	144510	77639
28905	47094	49	applied	\N	\N	1000000000	\N	144443	144443	144444
28905	47082	50	applied	\N	\N	\N	\N	144425	144425	77897
28905	47085	51	applied	\N	\N	\N	\N	144429	144429	144511
28905	47090	52	applied	\N	\N	\N	\N	144438	144438	77643
28905	47093	53	applied	\N	\N	\N	\N	144442	144442	77899
28905	47096	54	applied	\N	\N	\N	\N	144450	144450	144512
28905	47099	55	applied	\N	\N	\N	\N	144457	144457	77655
28905	47105	56	applied	\N	\N	\N	\N	144468	144468	77901
28905	47106	57	applied	\N	\N	\N	\N	144469	144469	77665
28905	47108	58	applied	\N	\N	\N	\N	144478	144478	144513
28905	47112	59	applied	\N	\N	\N	\N	144491	144491	77683
28905	47116	60	applied	\N	\N	\N	\N	144500	144500	144516
28905	47121	61	applied	\N	\N	\N	\N	144514	144514	144523
28905	47122	62	applied	\N	\N	\N	\N	144515	144515	77687
28905	47125	63	applied	\N	\N	\N	\N	144524	144524	144525
28907	47129	0	applied	\N	\N	\N	\N	144543	144543	144544
28907	47130	1	applied	\N	\N	\N	\N	144545	144545	77705
28907	47131	2	applied	\N	\N	\N	\N	144546	144546	144547
28910	47132	0	applied	\N	\N	\N	\N	144550	144550	144551
28910	47133	1	applied	\N	\N	\N	\N	144552	144552	77707
28910	47134	2	applied	\N	\N	\N	\N	144553	144553	77720
28922	47146	0	applied	\N	\N	\N	\N	144591	144591	144592
28922	47147	1	applied	\N	\N	\N	\N	144593	144593	144594
28922	47148	2	applied	\N	\N	\N	\N	144595	144595	144596
28922	47149	3	applied	\N	\N	\N	\N	144597	144597	144598
28922	47150	4	applied	\N	\N	\N	\N	144599	144599	77824
28924	47151	0	applied	\N	\N	\N	\N	144604	144604	144605
28924	47152	1	applied	\N	\N	\N	\N	144606	144606	144607
28924	47153	2	applied	\N	\N	\N	\N	144608	144608	144609
28924	47154	3	applied	\N	\N	\N	\N	144610	144610	77850
28924	47155	4	applied	\N	\N	\N	\N	144611	144611	144612
28924	47156	5	applied	\N	\N	\N	\N	144613	144613	144614
28924	47157	6	applied	\N	\N	\N	\N	144615	144615	77859
28926	47151	0	applied	\N	\N	\N	\N	144604	144604	144605
28926	47152	1	applied	\N	\N	\N	\N	144606	144606	144607
28926	47153	2	applied	\N	\N	\N	\N	144608	144608	144609
28926	47154	3	applied	\N	\N	\N	\N	144610	144610	77850
28926	47155	4	applied	\N	\N	\N	\N	144611	144611	144612
28926	47156	5	applied	\N	\N	\N	\N	144613	144613	144614
28926	47157	6	applied	\N	\N	\N	\N	144615	144615	77859
28931	47164	0	applied	\N	\N	\N	\N	144638	144638	144639
28931	47165	1	applied	\N	\N	\N	\N	144640	144640	144641
28931	47166	2	applied	\N	\N	\N	\N	144642	144642	144643
28931	47167	3	applied	\N	\N	\N	\N	144644	144644	77929
28931	47168	4	applied	\N	\N	\N	\N	144645	144645	77945
28931	47169	5	applied	\N	\N	\N	\N	144646	144646	78020
28931	47170	6	applied	\N	\N	\N	\N	144647	144647	77966
28936	47177	0	applied	\N	\N	\N	\N	144662	144662	144663
28936	47178	1	applied	\N	\N	\N	\N	144664	144664	78024
28936	47179	2	applied	\N	\N	\N	\N	144665	144665	78187
28938	47180	0	applied	\N	\N	\N	\N	144667	144667	144668
28938	47181	1	applied	\N	\N	\N	\N	144669	144669	77998
28938	47182	2	applied	\N	\N	\N	\N	144670	144670	78189
28945	47186	0	applied	\N	\N	\N	\N	144685	144685	144686
28945	47187	1	applied	\N	\N	\N	\N	144687	144687	78013
28945	47188	2	applied	\N	\N	\N	\N	144688	144688	78192
28946	47189	0	applied	\N	\N	\N	\N	144693	144693	144694
28946	47190	1	applied	\N	\N	\N	\N	144695	144695	144696
28946	47191	2	applied	\N	\N	\N	\N	144697	144697	144698
28946	47192	3	applied	\N	\N	\N	\N	144699	144699	144700
28946	47193	4	applied	\N	\N	\N	\N	144701	144701	78193
28946	47194	5	applied	\N	\N	\N	\N	144702	144702	78043
28946	47195	6	applied	\N	\N	\N	\N	144703	144703	78667
28946	47196	7	applied	\N	\N	\N	\N	144704	144704	78670
28946	47197	8	applied	\N	\N	\N	\N	144705	144705	78065
28946	47198	9	applied	\N	\N	\N	\N	144706	144706	78075
28950	47199	0	applied	\N	\N	\N	\N	144710	144710	144711
28955	47214	0	applied	\N	\N	\N	\N	144742	144742	144743
28955	47215	1	applied	\N	\N	\N	\N	144744	144744	144745
28955	47216	2	applied	\N	\N	\N	\N	144746	144746	78126
28958	47217	0	applied	\N	\N	\N	\N	144749	144749	144750
28958	47218	1	applied	\N	\N	\N	\N	144751	144751	144752
28958	47219	2	applied	\N	\N	\N	\N	144753	144753	78137
28958	47220	3	applied	\N	\N	\N	\N	144754	144754	144755
28958	47221	4	applied	\N	\N	\N	\N	144756	144756	78139
28958	47222	5	applied	\N	\N	\N	\N	144757	144757	78202
28958	47223	6	applied	\N	\N	1000000000	\N	144758	144758	144759
28962	47224	0	applied	\N	\N	\N	\N	144766	144766	144767
28962	47225	1	applied	\N	\N	\N	\N	144768	144768	144769
28962	47226	2	applied	\N	\N	\N	\N	144770	144770	78204
28966	47232	0	applied	\N	\N	\N	\N	144788	144788	144789
28966	47233	1	applied	\N	\N	\N	\N	144790	144790	144791
28966	47234	2	applied	\N	\N	\N	\N	144792	144792	78174
28966	47231	3	applied	\N	\N	\N	\N	144785	144785	144793
28966	47235	4	applied	\N	\N	\N	\N	144794	144794	78182
28968	47236	0	applied	\N	\N	\N	\N	144797	144797	144798
28968	47237	1	applied	\N	\N	\N	\N	144799	144799	78356
28968	47238	2	applied	\N	\N	\N	\N	144800	144800	78358
28970	47240	0	applied	\N	\N	\N	\N	144803	144803	144804
28970	47241	1	applied	\N	\N	\N	\N	144805	144805	144806
28970	47242	2	applied	\N	\N	\N	\N	144807	144807	78360
28970	47239	3	applied	\N	\N	\N	\N	144802	144802	144808
28972	47240	0	applied	\N	\N	\N	\N	144803	144803	144804
28972	47241	1	applied	\N	\N	\N	\N	144805	144805	144806
28972	47242	2	applied	\N	\N	\N	\N	144807	144807	78360
28972	47239	3	applied	\N	\N	\N	\N	144802	144802	144808
28974	47243	0	applied	\N	\N	\N	\N	144812	144812	144813
28974	47244	1	applied	\N	\N	\N	\N	144814	144814	78249
28974	47245	2	applied	\N	\N	\N	\N	144815	144815	144816
28911	47137	2	applied	\N	\N	\N	\N	144563	144563	144564
28911	47138	3	applied	\N	\N	\N	\N	144565	144565	77756
28911	47139	4	applied	\N	\N	\N	\N	144566	144566	144567
28916	47141	0	applied	\N	\N	\N	\N	144573	144573	144574
28916	47142	1	applied	\N	\N	\N	\N	144575	144575	144576
28920	47143	0	applied	\N	\N	\N	\N	144585	144585	77800
28920	47144	1	applied	\N	\N	\N	\N	144586	144586	144587
28920	47145	2	applied	\N	\N	\N	\N	144588	144588	144589
28925	47151	0	applied	\N	\N	\N	\N	144604	144604	144605
28925	47152	1	applied	\N	\N	\N	\N	144606	144606	144607
28925	47153	2	applied	\N	\N	\N	\N	144608	144608	144609
28925	47154	3	applied	\N	\N	\N	\N	144610	144610	77850
28925	47155	4	applied	\N	\N	\N	\N	144611	144611	144612
28925	47156	5	applied	\N	\N	\N	\N	144613	144613	144614
28925	47157	6	applied	\N	\N	\N	\N	144615	144615	77859
28927	47158	0	applied	\N	\N	\N	\N	144622	144622	144623
28927	47159	1	applied	\N	\N	1000000000	\N	144624	144624	144625
28927	47160	2	applied	\N	\N	\N	\N	144626	144626	144627
28927	47161	3	applied	\N	\N	\N	\N	144628	144628	77917
28929	47162	0	applied	\N	\N	\N	\N	144632	144632	144633
28929	47163	1	applied	\N	\N	\N	\N	144634	144634	144635
28933	47171	0	applied	\N	\N	\N	\N	144652	144652	144653
28933	47172	1	applied	\N	\N	\N	\N	144654	144654	78186
28933	47173	2	applied	\N	\N	\N	\N	144655	144655	77970
28935	47174	0	applied	\N	\N	\N	\N	144658	144658	144659
28935	47172	1	applied	\N	\N	\N	\N	144654	144654	77970
28935	47175	2	applied	\N	\N	\N	\N	144660	144660	78023
28935	47176	3	applied	\N	\N	\N	\N	144661	144661	77979
28937	47180	0	applied	\N	\N	\N	\N	144667	144667	144668
28937	47181	1	applied	\N	\N	\N	\N	144669	144669	77998
28937	47182	2	applied	\N	\N	\N	\N	144670	144670	78189
28947	47189	0	applied	\N	\N	\N	\N	144693	144693	144694
28947	47190	1	applied	\N	\N	\N	\N	144695	144695	144696
28947	47191	2	applied	\N	\N	\N	\N	144697	144697	144698
28947	47192	3	applied	\N	\N	\N	\N	144699	144699	144700
28947	47193	4	applied	\N	\N	\N	\N	144701	144701	78193
28947	47194	5	applied	\N	\N	\N	\N	144702	144702	78043
28947	47195	6	applied	\N	\N	\N	\N	144703	144703	78667
28947	47196	7	applied	\N	\N	\N	\N	144704	144704	78670
28947	47197	8	applied	\N	\N	\N	\N	144705	144705	78065
28947	47198	9	applied	\N	\N	\N	\N	144706	144706	78075
28949	47199	0	applied	\N	\N	\N	\N	144710	144710	144711
28949	47200	1	applied	\N	\N	\N	\N	144712	144712	78195
28951	47201	0	applied	\N	\N	\N	\N	144715	144715	144716
28951	47202	1	applied	\N	\N	\N	\N	144717	144717	44452
28951	47203	2	applied	\N	\N	\N	\N	144718	144718	78734
28951	47200	3	applied	\N	\N	\N	\N	144712	144712	78083
28951	47204	4	applied	\N	\N	\N	\N	144719	144719	78197
28953	47209	0	applied	\N	\N	\N	\N	144730	144730	144731
28953	47210	1	applied	\N	\N	\N	\N	144732	144732	78112
28959	47217	0	applied	\N	\N	\N	\N	144749	144749	144750
28959	47218	1	applied	\N	\N	\N	\N	144751	144751	144752
28959	47219	2	applied	\N	\N	\N	\N	144753	144753	78137
28959	47220	3	applied	\N	\N	\N	\N	144754	144754	144755
28959	47221	4	applied	\N	\N	\N	\N	144756	144756	78139
28959	47222	5	applied	\N	\N	\N	\N	144757	144757	78202
28959	47223	6	applied	\N	\N	1000000000	\N	144758	144758	144759
28963	47227	0	applied	\N	\N	\N	\N	144776	144776	144777
28963	47228	1	applied	\N	\N	\N	\N	144778	144778	144779
28963	47229	2	applied	\N	\N	\N	\N	144780	144780	78164
28963	47230	3	applied	\N	\N	\N	\N	144781	144781	144782
28967	47232	0	applied	\N	\N	\N	\N	144788	144788	144789
28967	47233	1	applied	\N	\N	\N	\N	144790	144790	144791
28967	47234	2	applied	\N	\N	\N	\N	144792	144792	78174
28967	47231	3	applied	\N	\N	\N	\N	144785	144785	144793
28967	47235	4	applied	\N	\N	\N	\N	144794	144794	78182
28971	47240	0	applied	\N	\N	\N	\N	144803	144803	144804
28971	47241	1	applied	\N	\N	\N	\N	144805	144805	78359
28971	47242	2	applied	\N	\N	\N	\N	144807	144807	144808
28979	47252	0	applied	\N	\N	\N	\N	144832	144832	144833
28979	47253	1	applied	\N	\N	\N	\N	144834	144834	144835
28979	47254	2	applied	\N	\N	\N	\N	144836	144836	144837
28981	47255	0	applied	\N	\N	\N	\N	144840	144840	144841
28981	47256	1	applied	\N	\N	\N	\N	144842	144842	78318
28981	47257	2	applied	\N	\N	\N	\N	144843	144843	144844
28986	47266	0	applied	\N	\N	\N	\N	144869	144869	144870
28986	47267	1	applied	\N	\N	\N	\N	144878	144878	78350
28986	47268	2	applied	\N	\N	\N	\N	144879	144879	144880
28994	47272	0	applied	\N	\N	\N	\N	144894	144894	144895
28994	47273	1	applied	\N	\N	\N	\N	144896	144896	78387
28994	47274	2	applied	\N	\N	\N	\N	144897	144897	78398
28996	47275	0	applied	\N	\N	\N	\N	144901	144901	144902
28996	47276	1	applied	\N	\N	\N	\N	144903	144903	144904
28996	47277	2	applied	\N	\N	\N	\N	144905	144905	78412
28999	47281	0	applied	\N	\N	\N	\N	144914	144914	144915
28999	47282	1	applied	\N	\N	\N	\N	144916	144916	78429
28999	47283	2	applied	\N	\N	\N	\N	144917	144917	144918
29001	47284	0	applied	\N	\N	\N	\N	144921	144921	144922
29001	47285	1	applied	\N	\N	\N	\N	144923	144923	144924
29001	47286	2	applied	\N	\N	\N	\N	144925	144925	78742
29001	47287	3	applied	\N	\N	\N	\N	144926	144926	144927
29001	47288	4	applied	\N	\N	\N	\N	144928	144928	78445
29001	47289	5	applied	\N	\N	\N	\N	144929	144929	144930
29003	47294	0	applied	\N	\N	\N	\N	144941	144941	144942
29003	47295	1	applied	\N	\N	\N	\N	144943	144943	78469
29010	47311	0	applied	\N	\N	\N	\N	144979	144979	144980
29010	47312	1	applied	\N	\N	\N	\N	144981	144981	144982
29010	47313	2	applied	\N	\N	\N	\N	144983	144983	78537
29010	47314	3	applied	\N	\N	\N	\N	144984	144984	144985
29012	47315	0	applied	\N	\N	\N	\N	144992	144992	144993
29012	47316	1	applied	\N	\N	\N	\N	144994	144994	78751
29012	47317	2	applied	\N	\N	\N	\N	144995	144995	78559
29017	47327	0	applied	\N	\N	\N	\N	145018	145018	29193
29017	47328	1	applied	\N	\N	\N	\N	145019	145019	145020
29017	47329	2	applied	\N	\N	\N	\N	145021	145021	145022
29017	47330	3	applied	\N	\N	\N	\N	145023	145023	78593
29017	47331	4	applied	\N	\N	\N	\N	145024	145024	145025
29017	47332	5	applied	\N	\N	\N	\N	145026	145026	78595
29017	47333	6	applied	\N	\N	\N	\N	145027	145027	145028
29019	47337	0	applied	\N	\N	\N	\N	145037	145037	145038
29019	47338	1	applied	\N	\N	\N	\N	145039	145039	145040
29019	47339	2	applied	\N	\N	\N	\N	145041	145041	145042
29026	47346	0	applied	\N	\N	\N	\N	145061	145061	145062
29026	47347	1	applied	\N	\N	\N	\N	145063	145063	145064
29026	47348	2	applied	\N	\N	\N	\N	145065	145065	78658
29026	47349	3	applied	\N	\N	\N	\N	145066	145066	145067
29026	47350	4	applied	\N	\N	\N	\N	145068	145068	78678
29030	47358	0	applied	\N	\N	\N	\N	145083	145083	145084
29030	47359	1	applied	\N	\N	\N	\N	145085	145085	145086
28921	47150	4	applied	\N	\N	\N	\N	144599	144599	77824
28923	47146	0	applied	\N	\N	\N	\N	144591	144591	144592
28923	47147	1	applied	\N	\N	\N	\N	144593	144593	144594
28923	47148	2	applied	\N	\N	\N	\N	144595	144595	144596
28923	47149	3	applied	\N	\N	\N	\N	144597	144597	144598
28923	47150	4	applied	\N	\N	\N	\N	144599	144599	77824
28932	47171	0	applied	\N	\N	\N	\N	144652	144652	144653
28932	47172	1	applied	\N	\N	\N	\N	144654	144654	78186
28932	47173	2	applied	\N	\N	\N	\N	144655	144655	77970
28934	47171	0	applied	\N	\N	\N	\N	144652	144652	144653
28934	47173	1	applied	\N	\N	\N	\N	144655	144655	78021
28939	47180	0	applied	\N	\N	\N	\N	144667	144667	144668
28939	47181	1	applied	\N	\N	\N	\N	144669	144669	77998
28939	47182	2	applied	\N	\N	\N	\N	144670	144670	78189
28941	47183	0	applied	\N	\N	\N	\N	144675	144675	144676
28941	47185	1	applied	\N	\N	\N	\N	144678	144678	144680
28943	47183	0	applied	\N	\N	\N	\N	144675	144675	144676
28943	47184	1	applied	\N	\N	\N	\N	144677	144677	78005
28943	47185	2	applied	\N	\N	\N	\N	144678	144678	78191
28952	47205	0	applied	\N	\N	\N	\N	144721	144721	144722
28952	47206	1	applied	\N	\N	\N	\N	144723	144723	144724
28952	47207	2	applied	\N	\N	\N	\N	144725	144725	78199
28952	47208	3	applied	\N	\N	\N	\N	144726	144726	144727
28957	47217	0	applied	\N	\N	\N	\N	144749	144749	144750
28957	47218	1	applied	\N	\N	\N	\N	144751	144751	144752
28957	47219	2	applied	\N	\N	\N	\N	144753	144753	78137
28957	47220	3	applied	\N	\N	\N	\N	144754	144754	144755
28957	47221	4	applied	\N	\N	\N	\N	144756	144756	78139
28957	47222	5	applied	\N	\N	\N	\N	144757	144757	78202
28957	47223	6	applied	\N	\N	1000000000	\N	144758	144758	144759
28961	47224	0	applied	\N	\N	\N	\N	144766	144766	144767
28961	47225	1	applied	\N	\N	\N	\N	144768	144768	144769
28961	47226	2	applied	\N	\N	\N	\N	144770	144770	78204
28964	47231	0	applied	\N	\N	\N	\N	144785	144785	144786
28969	47236	0	applied	\N	\N	\N	\N	144797	144797	144798
28969	47237	1	applied	\N	\N	\N	\N	144799	144799	78356
28969	47239	2	applied	\N	\N	\N	\N	144802	144802	78736
28969	47238	3	applied	\N	\N	\N	\N	144800	144800	78230
28973	47240	0	applied	\N	\N	\N	\N	144803	144803	144804
28973	47241	1	applied	\N	\N	\N	\N	144805	144805	144806
28973	47242	2	applied	\N	\N	\N	\N	144807	144807	78360
28973	47239	3	applied	\N	\N	\N	\N	144802	144802	144808
28975	47246	0	applied	\N	\N	\N	\N	144819	144819	144820
28975	47247	1	applied	\N	\N	\N	\N	144821	144821	144822
28975	47248	2	applied	\N	\N	\N	\N	144823	144823	78363
28975	47249	3	applied	\N	\N	\N	\N	144824	144824	78265
28975	47250	4	applied	\N	\N	\N	\N	144825	144825	78275
28975	47251	5	applied	\N	\N	\N	\N	144826	144826	144827
28982	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28982	47259	1	applied	\N	\N	\N	\N	144850	144850	144851
28982	47260	2	applied	\N	\N	\N	\N	144852	144852	144853
28982	47261	3	applied	\N	\N	\N	\N	144854	144854	144855
28982	47262	5	applied	\N	\N	\N	\N	144857	144857	144858
28982	47263	6	applied	\N	\N	\N	\N	144859	144859	144860
28982	47264	7	applied	\N	\N	\N	\N	144861	144861	78324
28982	47265	8	applied	\N	\N	\N	\N	144862	144862	144863
28984	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28984	47129	1	applied	\N	\N	\N	\N	144543	144543	144544
28984	47132	2	applied	\N	\N	\N	\N	144550	144550	144551
28984	47146	3	applied	\N	\N	\N	\N	144591	144591	144592
28984	47147	4	applied	\N	\N	\N	\N	144593	144593	144594
28984	47151	5	applied	\N	\N	\N	\N	144604	144604	144605
28984	47152	6	applied	\N	\N	\N	\N	144606	144606	144607
28984	47158	7	applied	\N	\N	\N	\N	144622	144622	144623
28984	47162	8	applied	\N	\N	\N	\N	144632	144632	144633
28984	47164	9	applied	\N	\N	\N	\N	144638	144638	144639
28984	47165	10	applied	\N	\N	\N	\N	144640	144640	144641
28984	47171	11	applied	\N	\N	\N	\N	144652	144652	144653
28984	47174	12	applied	\N	\N	\N	\N	144658	144658	144659
28984	47177	13	applied	\N	\N	\N	\N	144662	144662	144663
28984	47180	14	applied	\N	\N	\N	\N	144667	144667	144668
28984	47183	15	applied	\N	\N	\N	\N	144675	144675	144676
28984	47186	16	applied	\N	\N	\N	\N	144685	144685	144686
28984	47189	17	applied	\N	\N	\N	\N	144693	144693	144694
28984	47190	18	applied	\N	\N	\N	\N	144695	144695	144696
28984	47191	19	applied	\N	\N	\N	\N	144697	144697	144698
28984	47199	20	applied	\N	\N	\N	\N	144710	144710	144711
28984	47201	21	applied	\N	\N	\N	\N	144715	144715	144716
28984	47205	22	applied	\N	\N	\N	\N	144721	144721	144722
28984	47209	23	applied	\N	\N	\N	\N	144730	144730	144731
28984	47211	24	applied	\N	\N	\N	\N	144735	144735	144736
28984	47214	25	applied	\N	\N	\N	\N	144742	144742	144743
28984	47217	26	applied	\N	\N	\N	\N	144749	144749	144750
28984	47218	27	applied	\N	\N	\N	\N	144751	144751	144752
28984	47224	28	applied	\N	\N	\N	\N	144766	144766	144767
28984	47227	29	applied	\N	\N	\N	\N	144776	144776	144777
28984	47232	30	applied	\N	\N	\N	\N	144788	144788	144789
28984	47233	31	applied	\N	\N	\N	\N	144790	144790	144791
28984	47236	32	applied	\N	\N	\N	\N	144797	144797	144798
28984	47240	33	applied	\N	\N	\N	\N	144803	144803	144804
28984	47243	34	applied	\N	\N	\N	\N	144812	144812	144813
28984	47246	35	applied	\N	\N	\N	\N	144819	144819	144820
28984	47247	36	applied	\N	\N	\N	\N	144821	144821	144822
28984	47252	37	applied	\N	\N	\N	\N	144832	144832	144833
28984	47255	38	applied	\N	\N	\N	\N	144840	144840	144841
28984	47259	39	applied	\N	\N	\N	\N	144850	144850	144851
28984	47260	40	applied	\N	\N	\N	\N	144852	144852	144853
28984	47266	41	applied	\N	\N	\N	\N	144869	144869	144870
28984	47261	42	applied	\N	\N	\N	\N	144854	144854	144855
28984	47128	43	applied	\N	\N	\N	\N	144540	144540	144539
28984	47130	44	applied	\N	\N	\N	\N	144545	144545	77691
28984	47133	45	applied	\N	\N	\N	\N	144552	144552	144541
28984	47135	46	applied	\N	\N	\N	\N	144559	144559	77705
28984	47136	47	applied	\N	\N	\N	\N	144561	144561	144871
28984	47131	48	applied	\N	\N	\N	\N	144546	144546	77707
28984	47137	49	applied	\N	\N	\N	\N	144563	144563	144872
28984	47144	50	applied	\N	\N	\N	\N	144586	144586	144873
28984	47127	51	applied	\N	\N	1000000000	\N	144537	144537	144538
28984	47159	52	applied	\N	\N	1000000000	\N	144624	144624	144625
28984	47140	53	applied	\N	\N	\N	\N	144570	144570	77720
28984	47141	54	applied	\N	\N	\N	\N	144573	144573	144560
28984	47143	55	applied	\N	\N	\N	\N	144585	144585	144562
28984	47149	56	applied	\N	\N	\N	\N	144597	144597	77750
28984	47150	57	applied	\N	\N	\N	\N	144599	144599	144874
28984	47153	58	applied	\N	\N	\N	\N	144608	144608	144875
28984	47154	59	applied	\N	\N	\N	\N	144610	144610	77763
28988	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28988	47261	1	applied	\N	\N	\N	\N	144854	144854	144855
28990	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28977	47252	0	applied	\N	\N	\N	\N	144832	144832	144833
28977	47253	1	applied	\N	\N	\N	\N	144834	144834	144835
28977	47254	2	applied	\N	\N	\N	\N	144836	144836	144837
28987	47266	0	applied	\N	\N	\N	\N	144869	144869	144870
28987	47267	1	applied	\N	\N	\N	\N	144878	144878	78350
28987	47268	2	applied	\N	\N	\N	\N	144879	144879	144880
28989	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
28989	47261	1	applied	\N	\N	\N	\N	144854	144854	144855
28993	47269	0	applied	\N	\N	\N	\N	144886	144886	144887
28993	47270	1	applied	\N	\N	\N	\N	144888	144888	78385
28993	47271	2	applied	\N	\N	\N	\N	144889	144889	144890
28997	47275	0	applied	\N	\N	\N	\N	144901	144901	144902
28997	47276	1	applied	\N	\N	\N	\N	144903	144903	144904
28997	47277	2	applied	\N	\N	\N	\N	144905	144905	78412
29002	47290	0	applied	\N	\N	\N	\N	144933	144933	144934
29002	47291	1	applied	\N	\N	\N	\N	144935	144935	144936
29002	47292	2	applied	\N	\N	\N	\N	144937	144937	78461
29002	47293	3	applied	\N	\N	\N	\N	144938	144938	144939
29005	47296	0	applied	\N	\N	\N	\N	144946	144946	144947
29005	47297	1	applied	\N	\N	\N	\N	144948	144948	144949
29005	47298	2	applied	\N	\N	\N	\N	144950	144950	78745
29005	47299	3	applied	\N	\N	\N	\N	144951	144951	144952
29005	47300	4	applied	\N	\N	\N	\N	144953	144953	78747
29005	47301	5	applied	\N	\N	\N	\N	144954	144954	144955
29005	47302	6	applied	\N	\N	\N	\N	144956	144956	144957
29011	47311	0	applied	\N	\N	\N	\N	144979	144979	144980
29011	47312	1	applied	\N	\N	\N	\N	144981	144981	144982
29011	47313	2	applied	\N	\N	\N	\N	144983	144983	78537
29011	47314	3	applied	\N	\N	\N	\N	144984	144984	144985
29014	47318	0	applied	\N	\N	\N	\N	144998	144998	144999
29014	47319	1	applied	\N	\N	\N	\N	145000	145000	145001
29014	47320	2	applied	\N	\N	\N	\N	145002	145002	78752
29014	47321	3	applied	\N	\N	\N	\N	145003	145003	145004
29014	47322	4	applied	\N	\N	\N	\N	145005	145005	78575
29014	47323	5	applied	\N	\N	\N	\N	145006	145006	145007
29016	47324	0	applied	\N	\N	\N	\N	145012	145012	145013
29016	47325	1	applied	\N	\N	\N	\N	145014	145014	78582
29016	47326	2	applied	\N	\N	\N	\N	145015	145015	145016
29020	47340	0	applied	\N	\N	\N	\N	145045	145045	145046
29020	47341	1	applied	\N	\N	\N	\N	145047	145047	145048
29022	47342	0	applied	\N	\N	\N	\N	145052	145052	145053
29022	47343	1	applied	\N	\N	\N	\N	145054	145054	78637
29022	47344	2	applied	\N	\N	\N	\N	145055	145055	78656
29022	47345	3	applied	\N	\N	\N	\N	145056	145056	145057
29025	47346	0	applied	\N	\N	\N	\N	145061	145061	145062
29025	47347	1	applied	\N	\N	\N	\N	145063	145063	145064
29025	47348	2	applied	\N	\N	\N	\N	145065	145065	78658
29025	47349	3	applied	\N	\N	\N	\N	145066	145066	145067
29025	47350	4	applied	\N	\N	\N	\N	145068	145068	78678
29027	47346	0	applied	\N	\N	\N	\N	145061	145061	145062
29027	47347	1	applied	\N	\N	\N	\N	145063	145063	145064
29027	47348	2	applied	\N	\N	\N	\N	145065	145065	78658
29027	47349	3	applied	\N	\N	\N	\N	145066	145066	145067
29027	47350	4	applied	\N	\N	\N	\N	145068	145068	78678
29029	47358	0	applied	\N	\N	\N	\N	145083	145083	145084
29029	47359	1	applied	\N	\N	\N	\N	145085	145085	145086
29029	47360	2	applied	\N	\N	\N	\N	145087	145087	78708
29029	47361	3	applied	\N	\N	\N	\N	145088	145088	78766
29029	47362	4	applied	\N	\N	\N	\N	145089	145089	145090
29029	47363	5	applied	\N	\N	\N	\N	145091	145091	78767
29032	47364	0	applied	\N	\N	\N	\N	145095	145095	145096
29032	47365	1	applied	\N	\N	\N	\N	145097	145097	78777
29032	47366	2	applied	\N	\N	\N	\N	145098	145098	79139
29034	47367	0	applied	\N	\N	\N	\N	145102	145102	145102
29034	47368	1	applied	\N	\N	\N	\N	145103	145103	145104
29034	47369	2	applied	\N	\N	\N	\N	145105	145105	79140
29034	47370	3	applied	\N	\N	\N	\N	145106	145106	79141
29037	47371	0	applied	\N	\N	\N	\N	145111	145111	145112
29037	47372	1	applied	\N	\N	\N	\N	145113	145113	145114
29041	47380	0	applied	\N	\N	\N	\N	145130	145130	145131
29041	47381	1	applied	\N	\N	\N	\N	145132	145132	145133
29041	47382	2	applied	\N	\N	\N	\N	145134	145134	78835
29043	47383	0	applied	\N	\N	\N	\N	145137	145137	145138
29043	47384	1	applied	\N	\N	\N	\N	145139	145139	145140
29043	47385	2	applied	\N	\N	\N	\N	145141	145141	145142
29043	47386	3	applied	\N	\N	\N	\N	145143	145143	145144
29043	47387	4	applied	\N	\N	\N	\N	145145	145145	145146
29043	47388	5	applied	\N	\N	\N	\N	145147	145147	78850
29045	47389	0	applied	\N	\N	\N	\N	145151	145151	145152
29045	47390	1	applied	\N	\N	\N	\N	145153	145153	79148
29045	47391	2	applied	\N	\N	\N	\N	145154	145154	79149
29048	47392	0	applied	\N	\N	\N	\N	145156	145156	145157
29048	47393	1	applied	\N	\N	\N	\N	145158	145158	145159
29048	47394	2	applied	\N	\N	\N	\N	145160	145160	78869
29048	47395	3	applied	\N	\N	\N	\N	145161	145161	145162
29048	47396	4	applied	\N	\N	\N	\N	145163	145163	78875
29048	47397	5	applied	\N	\N	\N	\N	145164	145164	145165
29049	47398	0	applied	\N	\N	\N	\N	145169	145169	145170
29049	47399	1	applied	\N	\N	\N	\N	145171	145171	78889
29049	47400	2	applied	\N	\N	\N	\N	145172	145172	78897
29068	47422	0	applied	\N	\N	\N	\N	145219	145219	145220
29068	47423	1	applied	\N	\N	\N	\N	145221	145221	145222
29068	47424	2	applied	\N	\N	\N	\N	145223	145223	78966
29068	47425	3	applied	\N	\N	\N	\N	145224	145224	78971
29069	47426	0	applied	\N	\N	\N	\N	145232	145232	145233
29069	47427	1	applied	\N	\N	\N	\N	145234	145234	79020
29072	47431	0	applied	\N	\N	\N	\N	145241	145241	145242
29072	47432	1	applied	\N	\N	\N	\N	145244	145244	79483
29072	47433	3	applied	\N	\N	\N	\N	145246	145246	79484
29076	47434	0	applied	\N	\N	\N	\N	145258	145258	145259
29076	47435	1	applied	\N	\N	\N	\N	145260	145260	79023
29076	47436	2	applied	\N	\N	\N	\N	145261	145261	79024
29076	47437	3	applied	\N	\N	\N	\N	145262	145262	145263
29081	47438	0	applied	\N	\N	\N	\N	145271	145271	145272
29081	47439	1	applied	\N	\N	\N	\N	145273	145273	145274
29084	47440	0	applied	\N	\N	\N	\N	145277	145277	145278
29084	47441	1	applied	\N	\N	\N	\N	145279	145279	79158
29084	47442	2	applied	\N	\N	\N	\N	145280	145280	145281
29088	47449	0	applied	\N	\N	\N	\N	145298	145298	145299
29088	47450	1	applied	\N	\N	\N	\N	145300	145300	79160
29088	47451	2	applied	\N	\N	\N	\N	145301	145301	145302
29090	47456	0	applied	\N	\N	\N	\N	145311	145311	145312
29090	47457	1	applied	\N	\N	\N	\N	145313	145313	138833
29090	47458	2	applied	\N	\N	\N	\N	145314	145314	145315
29090	47459	3	applied	\N	\N	\N	\N	145316	145316	79092
29090	47460	4	applied	\N	\N	\N	\N	145317	145317	79163
29090	47461	5	applied	\N	\N	\N	\N	145318	145318	79100
29092	47462	0	applied	\N	\N	\N	\N	145322	145322	145323
29092	47463	1	applied	\N	\N	\N	\N	145324	145324	79106
29092	47464	2	applied	\N	\N	\N	\N	145325	145325	145326
28990	47261	1	applied	\N	\N	\N	\N	144854	144854	144855
28992	47269	0	applied	\N	\N	\N	\N	144886	144886	144887
28992	47270	1	applied	\N	\N	\N	\N	144888	144888	78385
28992	47271	2	applied	\N	\N	\N	\N	144889	144889	144890
28995	47272	0	applied	\N	\N	\N	\N	144894	144894	144895
28995	47273	1	applied	\N	\N	\N	\N	144896	144896	78387
28995	47274	2	applied	\N	\N	\N	\N	144897	144897	78398
29004	47296	0	applied	\N	\N	\N	\N	144946	144946	144947
29004	47297	1	applied	\N	\N	\N	\N	144948	144948	144949
29004	47298	2	applied	\N	\N	\N	\N	144950	144950	78745
29004	47299	3	applied	\N	\N	\N	\N	144951	144951	144952
29004	47300	4	applied	\N	\N	\N	\N	144953	144953	78747
29004	47301	5	applied	\N	\N	\N	\N	144954	144954	144955
29004	47302	6	applied	\N	\N	\N	\N	144956	144956	144957
29007	47306	0	applied	\N	\N	\N	\N	144967	144967	144968
29007	47307	1	applied	\N	\N	\N	\N	144969	144969	144970
29007	47308	2	applied	\N	\N	\N	\N	144971	144971	78516
29007	47309	3	applied	\N	\N	\N	\N	144972	144972	144973
29007	47310	4	applied	\N	\N	\N	\N	144974	144974	78526
29009	47311	0	applied	\N	\N	\N	\N	144979	144979	144980
29009	47312	1	applied	\N	\N	\N	\N	144981	144981	144982
29009	47313	2	applied	\N	\N	\N	\N	144983	144983	78537
29009	47314	3	applied	\N	\N	\N	\N	144984	144984	144985
29015	47318	0	applied	\N	\N	\N	\N	144998	144998	144999
29015	47319	1	applied	\N	\N	\N	\N	145000	145000	145001
29015	47320	2	applied	\N	\N	\N	\N	145002	145002	78752
29015	47321	3	applied	\N	\N	\N	\N	145003	145003	145004
29015	47322	4	applied	\N	\N	\N	\N	145005	145005	78575
29015	47323	5	applied	\N	\N	\N	\N	145006	145006	145007
29018	47334	0	applied	\N	\N	\N	\N	145031	145031	145032
29018	47335	1	applied	\N	\N	\N	\N	145033	145033	78607
29018	47336	2	applied	\N	\N	\N	\N	145034	145034	78618
29021	47340	0	applied	\N	\N	\N	\N	145045	145045	145046
29021	47341	1	applied	\N	\N	\N	\N	145047	145047	145048
29023	47342	0	applied	\N	\N	\N	\N	145052	145052	145053
29023	47343	1	applied	\N	\N	\N	\N	145054	145054	78637
29023	47344	2	applied	\N	\N	\N	\N	145055	145055	78656
29023	47345	3	applied	\N	\N	\N	\N	145056	145056	145057
29028	47351	0	applied	\N	\N	\N	\N	145072	145072	144758
29028	47352	1	applied	\N	\N	\N	\N	145073	145073	145074
29028	47353	2	applied	\N	\N	\N	\N	145075	145075	145076
29028	47354	3	applied	\N	\N	\N	\N	145077	145077	145078
29028	47355	4	applied	\N	\N	\N	\N	145079	145079	78763
29028	47356	5	applied	\N	\N	\N	\N	145080	145080	78700
29028	47357	6	applied	\N	\N	\N	\N	145081	145081	78764
29031	47364	0	applied	\N	\N	\N	\N	145095	145095	145096
29031	47365	1	applied	\N	\N	\N	\N	145097	145097	78777
29031	47366	2	applied	\N	\N	\N	\N	145098	145098	79139
29033	47364	0	applied	\N	\N	\N	\N	145095	145095	145096
29033	47365	1	applied	\N	\N	\N	\N	145097	145097	78777
29033	47366	2	applied	\N	\N	\N	\N	145098	145098	79139
29035	47367	0	applied	\N	\N	\N	\N	145102	145102	145102
29035	47368	1	applied	\N	\N	\N	\N	145103	145103	145104
29035	47369	2	applied	\N	\N	\N	\N	145105	145105	79140
29035	47370	3	applied	\N	\N	\N	\N	145106	145106	79141
29040	47377	0	applied	\N	\N	\N	\N	145124	145124	145125
29040	47378	1	applied	\N	\N	\N	\N	145126	145126	78806
29040	47379	2	applied	\N	\N	\N	\N	145127	145127	145128
29046	47392	0	applied	\N	\N	\N	\N	145156	145156	145157
29046	47393	1	applied	\N	\N	\N	\N	145158	145158	145159
29046	47394	2	applied	\N	\N	\N	\N	145160	145160	78869
29046	47395	3	applied	\N	\N	\N	\N	145161	145161	145162
29046	47396	4	applied	\N	\N	\N	\N	145163	145163	78875
29046	47397	5	applied	\N	\N	\N	\N	145164	145164	145165
29051	47398	0	applied	\N	\N	\N	\N	145169	145169	145170
29051	47399	1	applied	\N	\N	\N	\N	145171	145171	78889
29051	47400	2	applied	\N	\N	\N	\N	145172	145172	78897
29055	47404	0	applied	\N	\N	\N	\N	145183	145183	145184
29055	47405	1	applied	\N	\N	\N	\N	145185	145185	145186
29055	47406	2	applied	\N	\N	\N	\N	145187	145187	79013
29055	47407	3	applied	\N	\N	\N	\N	145188	145188	78914
29055	47408	4	applied	\N	\N	\N	\N	145189	145189	78984
29055	47409	5	applied	\N	\N	\N	\N	145190	145190	78921
29057	47410	0	applied	\N	\N	\N	\N	145194	145194	145195
29057	47411	1	applied	\N	\N	\N	\N	145196	145196	78932
29057	47412	2	applied	\N	\N	\N	\N	145197	145197	78934
29060	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29060	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29060	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29060	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29060	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29060	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29060	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29060	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29060	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29064	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29064	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29064	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29064	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29064	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29064	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29064	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29064	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29064	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29066	47422	0	applied	\N	\N	\N	\N	145219	145219	145220
29066	47423	1	applied	\N	\N	\N	\N	145221	145221	145222
29066	47424	2	applied	\N	\N	\N	\N	145223	145223	78966
29066	47425	3	applied	\N	\N	\N	\N	145224	145224	78971
29071	47431	0	applied	\N	\N	\N	\N	145241	145241	145242
29073	47431	0	applied	\N	\N	\N	\N	145241	145241	145242
29073	47432	1	applied	\N	\N	\N	\N	145244	145244	79483
29073	47433	3	applied	\N	\N	\N	\N	145246	145246	79484
29079	47434	0	applied	\N	\N	\N	\N	145258	145258	145259
29079	47435	1	applied	\N	\N	\N	\N	145260	145260	79023
29079	47436	2	applied	\N	\N	\N	\N	145261	145261	79024
29091	47456	0	applied	\N	\N	\N	\N	145311	145311	145312
29091	47457	1	applied	\N	\N	\N	\N	145313	145313	138833
29091	47458	2	applied	\N	\N	\N	\N	145314	145314	145315
29091	47459	3	applied	\N	\N	\N	\N	145316	145316	79092
29091	47460	4	applied	\N	\N	\N	\N	145317	145317	79163
29091	47461	5	applied	\N	\N	\N	\N	145318	145318	79100
29095	47465	0	applied	\N	\N	\N	\N	145330	145330	145331
29095	47466	1	applied	\N	\N	\N	\N	145332	145332	145333
29095	47467	2	applied	\N	\N	\N	\N	145334	145334	79118
29095	47468	3	applied	\N	\N	\N	\N	145335	145335	79120
29100	47469	0	applied	\N	\N	\N	\N	145346	145346	145347
29100	47470	1	applied	\N	\N	\N	\N	145348	145348	79130
29109	47490	0	applied	\N	\N	\N	\N	145412	145412	145413
29109	47491	1	applied	\N	\N	\N	\N	145414	145414	145415
29109	47492	2	applied	\N	\N	\N	\N	145416	145416	145417
29008	47306	0	applied	\N	\N	\N	\N	144967	144967	144968
29008	47307	1	applied	\N	\N	\N	\N	144969	144969	144970
29008	47308	2	applied	\N	\N	\N	\N	144971	144971	78516
29008	47309	3	applied	\N	\N	\N	\N	144972	144972	144973
29008	47310	4	applied	\N	\N	\N	\N	144974	144974	78526
29013	47315	0	applied	\N	\N	\N	\N	144992	144992	144993
29013	47316	1	applied	\N	\N	\N	\N	144994	144994	78751
29013	47317	2	applied	\N	\N	\N	\N	144995	144995	78559
29024	47346	0	applied	\N	\N	\N	\N	145061	145061	145062
29024	47347	1	applied	\N	\N	\N	\N	145063	145063	145064
29024	47348	2	applied	\N	\N	\N	\N	145065	145065	78658
29024	47349	3	applied	\N	\N	\N	\N	145066	145066	145067
29024	47350	4	applied	\N	\N	\N	\N	145068	145068	78678
29036	47351	0	applied	\N	\N	\N	\N	145072	145072	144758
29038	47373	0	applied	\N	\N	\N	\N	145115	145115	145116
29038	47374	1	applied	\N	\N	\N	\N	145117	145117	79143
29038	47375	2	applied	\N	\N	\N	\N	145118	145118	78798
29038	47376	3	applied	\N	\N	\N	\N	145119	145119	79144
29044	47389	0	applied	\N	\N	\N	\N	145151	145151	145152
29044	47390	1	applied	\N	\N	\N	\N	145153	145153	79148
29044	47391	2	applied	\N	\N	\N	\N	145154	145154	79149
29047	47392	0	applied	\N	\N	\N	\N	145156	145156	145157
29047	47393	1	applied	\N	\N	\N	\N	145158	145158	145159
29047	47394	2	applied	\N	\N	\N	\N	145160	145160	78869
29047	47395	3	applied	\N	\N	\N	\N	145161	145161	145162
29047	47396	4	applied	\N	\N	\N	\N	145163	145163	78875
29047	47397	5	applied	\N	\N	\N	\N	145164	145164	145165
29052	47398	0	applied	\N	\N	\N	\N	145169	145169	145170
29052	47399	1	applied	\N	\N	\N	\N	145171	145171	78889
29052	47400	2	applied	\N	\N	\N	\N	145172	145172	78897
29053	47401	0	applied	\N	\N	\N	\N	145177	145177	145178
29053	47402	1	applied	\N	\N	\N	\N	145179	145179	79011
29053	47403	2	applied	\N	\N	\N	\N	145180	145180	78907
29058	47410	0	applied	\N	\N	\N	\N	145194	145194	145195
29058	47411	1	applied	\N	\N	\N	\N	145196	145196	78932
29058	47412	2	applied	\N	\N	\N	\N	145197	145197	78934
29061	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29061	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29061	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29061	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29061	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29061	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29061	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29061	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29061	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29062	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29062	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29062	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29062	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29062	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29062	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29062	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29062	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29062	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29067	47422	0	applied	\N	\N	\N	\N	145219	145219	145220
29067	47423	1	applied	\N	\N	\N	\N	145221	145221	145222
29067	47424	2	applied	\N	\N	\N	\N	145223	145223	78966
29067	47425	3	applied	\N	\N	\N	\N	145224	145224	78971
29070	47428	0	applied	\N	\N	\N	\N	145236	145236	145237
29070	47429	1	applied	\N	\N	\N	\N	145238	145238	78992
29070	47430	2	applied	\N	\N	\N	\N	145239	145239	79482
29075	47431	0	applied	\N	\N	\N	\N	145241	145241	145242
29075	47432	1	applied	\N	\N	\N	\N	145244	145244	79483
29075	47433	3	applied	\N	\N	\N	\N	145246	145246	79484
29077	47434	0	applied	\N	\N	\N	\N	145258	145258	145259
29077	47435	1	applied	\N	\N	\N	\N	145260	145260	79023
29077	47436	2	applied	\N	\N	\N	\N	145261	145261	79024
29077	47437	3	applied	\N	\N	\N	\N	145262	145262	145263
29083	47440	0	applied	\N	\N	\N	\N	145277	145277	145278
29083	47441	1	applied	\N	\N	\N	\N	145279	145279	79158
29083	47442	2	applied	\N	\N	\N	\N	145280	145280	145281
29085	47443	0	applied	\N	\N	\N	\N	145286	145286	145287
29085	47444	1	applied	\N	\N	\N	\N	145288	145288	79488
29085	47445	2	applied	\N	\N	\N	\N	145289	145289	79489
29085	47446	3	applied	\N	\N	\N	\N	145290	145290	79050
29087	47447	0	applied	\N	\N	\N	\N	145293	145293	145294
29087	47448	1	applied	\N	\N	\N	\N	145295	145295	79052
29093	47462	0	applied	\N	\N	\N	\N	145322	145322	145323
29093	47463	1	applied	\N	\N	\N	\N	145324	145324	79106
29093	47464	2	applied	\N	\N	\N	\N	145325	145325	145326
29097	47465	0	applied	\N	\N	\N	\N	145330	145330	145331
29097	47466	1	applied	\N	\N	\N	\N	145332	145332	145333
29097	47467	2	applied	\N	\N	\N	\N	145334	145334	79118
29097	47468	3	applied	\N	\N	\N	\N	145335	145335	79120
29099	47469	0	applied	\N	\N	\N	\N	145346	145346	145347
29099	47470	1	applied	\N	\N	\N	\N	145348	145348	79130
29102	47471	0	applied	\N	\N	\N	\N	145352	145352	145353
29102	47472	1	applied	\N	\N	\N	\N	145354	145354	145355
29102	47473	2	applied	\N	\N	\N	\N	145356	145356	145357
29102	47474	3	applied	\N	\N	\N	\N	145358	145358	145359
29102	47475	4	applied	\N	\N	\N	\N	145360	145360	145361
29102	47476	5	applied	\N	\N	\N	\N	145362	145362	145363
29102	47477	6	applied	\N	\N	\N	\N	145364	145364	79184
29102	47478	7	applied	\N	\N	\N	\N	145365	145365	79186
29102	47479	8	applied	\N	\N	\N	\N	145366	145366	145367
29102	47480	9	applied	\N	\N	\N	\N	145368	145368	79197
29104	47481	0	applied	\N	\N	\N	\N	145372	145372	145373
29104	47482	1	applied	\N	\N	\N	\N	145374	145374	79202
29106	47483	0	applied	\N	\N	\N	\N	145395	145395	145396
29106	47484	1	applied	\N	\N	\N	\N	145397	145397	145398
29106	47485	2	applied	\N	\N	\N	\N	145399	145399	145400
29106	47486	3	applied	\N	\N	\N	\N	145401	145401	79217
29110	47495	0	applied	\N	\N	\N	\N	145423	145423	145424
29110	47496	1	applied	\N	\N	\N	\N	145425	145425	145426
29110	47497	2	applied	\N	\N	\N	\N	145427	145427	79247
29110	47498	3	applied	\N	\N	\N	\N	145428	145428	145429
29114	47508	0	applied	\N	\N	\N	\N	145451	145451	145452
29114	47509	1	applied	\N	\N	\N	\N	145453	145453	145454
29114	47510	2	applied	\N	\N	\N	\N	145455	145455	145456
29114	47511	3	applied	\N	\N	\N	\N	145457	145457	79298
29114	47512	4	applied	\N	\N	\N	\N	145458	145458	145459
29114	47513	5	applied	\N	\N	\N	\N	145460	145460	145461
29114	47514	6	applied	\N	\N	\N	\N	145462	145462	79302
29114	47515	7	applied	\N	\N	\N	\N	145463	145463	145464
29115	47508	0	applied	\N	\N	\N	\N	145451	145451	145452
29115	47509	1	applied	\N	\N	\N	\N	145453	145453	145454
29115	47510	2	applied	\N	\N	\N	\N	145455	145455	145456
29115	47511	3	applied	\N	\N	\N	\N	145457	145457	79298
29115	47512	4	applied	\N	\N	\N	\N	145458	145458	145459
29115	47513	5	applied	\N	\N	\N	\N	145460	145460	145461
29030	47360	2	applied	\N	\N	\N	\N	145087	145087	78708
29030	47361	3	applied	\N	\N	\N	\N	145088	145088	78766
29030	47362	4	applied	\N	\N	\N	\N	145089	145089	145090
29030	47363	5	applied	\N	\N	\N	\N	145091	145091	78767
29039	47373	0	applied	\N	\N	\N	\N	145115	145115	145116
29039	47374	1	applied	\N	\N	\N	\N	145117	145117	79143
29039	47375	2	applied	\N	\N	\N	\N	145118	145118	78798
29039	47376	3	applied	\N	\N	\N	\N	145119	145119	79144
29042	47383	0	applied	\N	\N	\N	\N	145137	145137	145138
29042	47384	1	applied	\N	\N	\N	\N	145139	145139	145140
29042	47385	2	applied	\N	\N	\N	\N	145141	145141	145142
29042	47386	3	applied	\N	\N	\N	\N	145143	145143	145144
29042	47387	4	applied	\N	\N	\N	\N	145145	145145	145146
29042	47388	5	applied	\N	\N	\N	\N	145147	145147	78850
29050	47398	0	applied	\N	\N	\N	\N	145169	145169	145170
29050	47399	1	applied	\N	\N	\N	\N	145171	145171	78889
29050	47400	2	applied	\N	\N	\N	\N	145172	145172	78897
29054	47401	0	applied	\N	\N	\N	\N	145177	145177	145178
29054	47402	1	applied	\N	\N	\N	\N	145179	145179	79011
29054	47403	2	applied	\N	\N	\N	\N	145180	145180	78907
29056	47404	0	applied	\N	\N	\N	\N	145183	145183	145184
29056	47405	1	applied	\N	\N	\N	\N	145185	145185	145186
29056	47406	2	applied	\N	\N	\N	\N	145187	145187	79013
29056	47407	3	applied	\N	\N	\N	\N	145188	145188	78914
29056	47408	4	applied	\N	\N	\N	\N	145189	145189	78984
29056	47409	5	applied	\N	\N	\N	\N	145190	145190	78921
29059	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29059	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29059	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29059	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29059	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29059	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29059	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29059	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29059	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29063	47413	0	applied	\N	\N	\N	\N	145200	145200	145201
29063	47414	1	applied	\N	\N	\N	\N	145202	145202	145203
29063	47415	2	applied	\N	\N	\N	\N	145204	145204	145205
29063	47416	3	applied	\N	\N	\N	\N	145206	145206	78947
29063	47417	4	applied	\N	\N	\N	\N	145207	145207	78938
29063	47418	5	applied	\N	\N	\N	\N	145208	145208	78940
29063	47419	6	applied	\N	\N	\N	\N	145209	145209	79017
29063	47420	7	applied	\N	\N	\N	\N	145210	145210	79154
29063	47421	8	applied	\N	\N	\N	\N	145211	145211	78954
29065	47422	0	applied	\N	\N	\N	\N	145219	145219	145220
29065	47423	1	applied	\N	\N	\N	\N	145221	145221	145222
29065	47424	2	applied	\N	\N	\N	\N	145223	145223	78966
29065	47425	3	applied	\N	\N	\N	\N	145224	145224	78971
29074	47431	0	applied	\N	\N	\N	\N	145241	145241	145242
29074	47432	1	applied	\N	\N	\N	\N	145244	145244	79483
29074	47433	3	applied	\N	\N	\N	\N	145246	145246	79484
29078	47434	0	applied	\N	\N	\N	\N	145258	145258	145259
29078	47435	1	applied	\N	\N	\N	\N	145260	145260	79023
29078	47436	2	applied	\N	\N	\N	\N	145261	145261	79024
29078	47437	3	applied	\N	\N	\N	\N	145262	145262	145263
29080	47434	0	applied	\N	\N	\N	\N	145258	145258	145259
29080	47435	1	applied	\N	\N	\N	\N	145260	145260	79023
29080	47436	2	applied	\N	\N	\N	\N	145261	145261	79024
29082	47440	0	applied	\N	\N	\N	\N	145277	145277	145278
29082	47441	1	applied	\N	\N	\N	\N	145279	145279	79158
29082	47442	2	applied	\N	\N	\N	\N	145280	145280	145281
29086	47443	0	applied	\N	\N	\N	\N	145286	145286	145287
29086	47444	1	applied	\N	\N	\N	\N	145288	145288	79488
29086	47445	2	applied	\N	\N	\N	\N	145289	145289	79489
29086	47446	3	applied	\N	\N	\N	\N	145290	145290	79050
29089	47452	0	applied	\N	\N	\N	\N	145303	145303	145304
29089	47453	1	applied	\N	\N	\N	\N	145305	145305	79161
29089	47454	2	applied	\N	\N	\N	\N	145306	145306	145307
29089	47455	3	applied	\N	\N	\N	\N	145308	145308	79087
29096	47465	0	applied	\N	\N	\N	\N	145330	145330	145331
29096	47466	1	applied	\N	\N	\N	\N	145332	145332	145333
29096	47467	2	applied	\N	\N	\N	\N	145334	145334	79118
29096	47468	3	applied	\N	\N	\N	\N	145335	145335	79120
29098	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
29098	47457	2	applied	\N	\N	\N	\N	145313	145313	138833
29098	47043	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	144338	144338	\N
29098	47351	4	applied	\N	\N	\N	\N	145072	145072	143092
29098	47050	5	applied	\N	\N	1000000000	\N	144352	144352	144353
29098	47060	6	applied	\N	\N	\N	\N	144375	144375	144376
29098	47072	7	applied	\N	\N	\N	\N	145342	145342	145343
29098	47261	8	applied	\N	\N	\N	\N	144854	144854	144855
29098	47024	9	applied	\N	\N	\N	\N	144301	144301	12588
29098	47025	10	applied	\N	\N	\N	\N	144302	144302	12588
29098	47081	11	applied	\N	\N	1000000000	\N	144423	144423	144424
29098	47094	12	applied	\N	\N	1000000000	\N	144443	144443	144444
29107	47487	0	applied	\N	\N	\N	\N	145404	145404	145405
29107	47488	1	applied	\N	\N	\N	\N	145406	145406	79219
29107	47489	2	applied	\N	\N	\N	\N	145407	145407	79235
29112	47499	0	applied	\N	\N	\N	\N	145433	145433	145434
29112	47500	1	applied	\N	\N	\N	\N	145435	145435	79253
29112	47501	2	applied	\N	\N	\N	\N	145436	145436	79265
29116	47508	0	applied	\N	\N	\N	\N	145451	145451	145452
29116	47509	1	applied	\N	\N	\N	\N	145453	145453	145454
29116	47510	2	applied	\N	\N	\N	\N	145455	145455	145456
29116	47511	3	applied	\N	\N	\N	\N	145457	145457	79298
29116	47512	4	applied	\N	\N	\N	\N	145458	145458	145459
29116	47513	5	applied	\N	\N	\N	\N	145460	145460	145461
29116	47514	6	applied	\N	\N	\N	\N	145462	145462	79302
29116	47515	7	applied	\N	\N	\N	\N	145463	145463	145464
29121	47525	0	applied	\N	\N	\N	\N	145502	145502	145503
29121	47526	1	applied	\N	\N	\N	\N	145504	145504	145505
29121	47527	2	applied	\N	\N	\N	\N	145506	145506	79333
29121	47528	3	applied	\N	\N	\N	\N	145507	145507	145508
29125	47532	0	applied	\N	\N	\N	\N	145521	145521	145522
29125	47533	1	applied	\N	\N	\N	\N	145523	145523	145524
29125	47534	2	applied	\N	\N	\N	\N	145525	145525	79356
29125	47535	3	applied	\N	\N	\N	\N	145526	145526	79358
29125	47536	4	applied	\N	\N	\N	\N	145527	145527	145528
29125	47537	5	applied	\N	\N	\N	\N	145529	145529	145530
29131	47554	0	applied	\N	\N	\N	\N	145573	145573	145574
29131	47555	1	applied	\N	\N	\N	\N	145575	145575	145576
29131	47556	2	applied	\N	\N	\N	\N	145577	145577	145578
29131	47557	3	applied	\N	\N	\N	\N	145579	145579	145580
29131	47558	4	applied	\N	\N	\N	\N	145581	145581	145582
29131	47559	5	applied	\N	\N	\N	\N	145583	145583	145584
29131	47560	6	applied	\N	\N	\N	\N	145585	145585	145586
29131	47561	7	applied	\N	\N	\N	\N	145587	145587	79449
29134	47572	0	applied	\N	\N	\N	\N	145609	145609	145610
29134	47573	1	applied	\N	\N	\N	\N	145611	145611	145612
29094	47465	0	applied	\N	\N	\N	\N	145330	145330	145331
29094	47466	1	applied	\N	\N	\N	\N	145332	145332	145333
29094	47467	2	applied	\N	\N	\N	\N	145334	145334	79118
29094	47468	3	applied	\N	\N	\N	\N	145335	145335	79120
29101	47471	0	applied	\N	\N	\N	\N	145352	145352	145353
29101	47472	1	applied	\N	\N	\N	\N	145354	145354	145355
29101	47473	2	applied	\N	\N	\N	\N	145356	145356	145357
29101	47474	3	applied	\N	\N	\N	\N	145358	145358	145359
29101	47475	4	applied	\N	\N	\N	\N	145360	145360	145361
29101	47476	5	applied	\N	\N	\N	\N	145362	145362	145363
29101	47477	6	applied	\N	\N	\N	\N	145364	145364	79184
29101	47478	7	applied	\N	\N	\N	\N	145365	145365	79186
29101	47479	8	applied	\N	\N	\N	\N	145366	145366	145367
29101	47480	9	applied	\N	\N	\N	\N	145368	145368	79197
29103	47481	0	applied	\N	\N	\N	\N	145372	145372	145373
29103	47482	1	applied	\N	\N	\N	\N	145374	145374	79202
29105	47327	0	applied	\N	\N	\N	\N	145018	145018	29193
29105	47296	1	applied	\N	\N	\N	\N	144946	144946	144947
29105	47297	2	applied	\N	\N	\N	\N	144948	144948	144949
29105	47367	3	applied	\N	\N	\N	\N	145102	145102	145102
29105	47457	4	applied	\N	\N	\N	\N	145313	145313	138833
29105	47351	5	applied	\N	\N	\N	\N	145072	145072	144758
29105	47303	6	applied	\N	\N	\N	\N	144960	144960	144961
29105	47306	7	applied	\N	\N	\N	\N	144967	144967	144968
29105	47307	8	applied	\N	\N	\N	\N	144969	144969	144970
29105	47311	9	applied	\N	\N	\N	\N	144979	144979	144980
29105	47315	10	applied	\N	\N	\N	\N	144992	144992	144993
29105	47318	11	applied	\N	\N	\N	\N	144998	144998	144999
29105	47319	12	applied	\N	\N	\N	\N	145000	145000	145001
29105	47324	13	applied	\N	\N	\N	\N	145012	145012	145013
29105	47328	14	applied	\N	\N	\N	\N	145019	145019	145020
29105	47329	15	applied	\N	\N	\N	\N	145021	145021	145022
29105	47334	16	applied	\N	\N	\N	\N	145031	145031	145032
29105	47337	17	applied	\N	\N	\N	\N	145037	145037	145038
29105	47340	18	applied	\N	\N	\N	\N	145045	145045	145046
29105	47342	19	applied	\N	\N	\N	\N	145052	145052	145053
29105	47346	20	applied	\N	\N	\N	\N	145061	145061	145062
29105	47347	21	applied	\N	\N	\N	\N	145063	145063	145064
29105	47352	22	applied	\N	\N	\N	\N	145073	145073	145074
29105	47353	23	applied	\N	\N	\N	\N	145075	145075	145076
29105	47358	24	applied	\N	\N	\N	\N	145083	145083	145084
29105	47359	25	applied	\N	\N	\N	\N	145085	145085	145086
29105	47364	26	applied	\N	\N	\N	\N	145095	145095	145096
29105	47368	27	applied	\N	\N	\N	\N	145103	145103	145104
29105	47371	28	applied	\N	\N	\N	\N	145111	145111	145112
29105	47373	29	applied	\N	\N	\N	\N	145115	145115	145116
29105	47377	30	applied	\N	\N	\N	\N	145124	145124	145125
29105	47380	31	applied	\N	\N	\N	\N	145130	145130	145131
29105	47383	32	applied	\N	\N	\N	\N	145137	145137	145138
29105	47384	33	applied	\N	\N	\N	\N	145139	145139	145140
29105	47389	34	applied	\N	\N	\N	\N	145151	145151	145152
29105	47392	35	applied	\N	\N	\N	\N	145156	145156	145157
29105	47393	36	applied	\N	\N	\N	\N	145158	145158	145159
29105	47398	37	applied	\N	\N	\N	\N	145169	145169	145170
29105	47401	38	applied	\N	\N	\N	\N	145177	145177	145178
29105	47404	39	applied	\N	\N	\N	\N	145183	145183	145184
29105	47405	40	applied	\N	\N	\N	\N	145185	145185	145186
29105	47410	41	applied	\N	\N	\N	\N	145194	145194	145195
29105	47413	42	applied	\N	\N	\N	\N	145200	145200	145201
29105	47414	43	applied	\N	\N	\N	\N	145202	145202	145203
29105	47415	44	applied	\N	\N	\N	\N	145204	145204	145205
29105	47422	45	applied	\N	\N	\N	\N	145219	145219	145220
29105	47426	46	applied	\N	\N	\N	\N	145232	145232	145233
29105	47428	47	applied	\N	\N	\N	\N	145236	145236	145237
29105	47431	48	applied	\N	\N	\N	\N	145241	145241	145242
29105	47434	49	applied	\N	\N	\N	\N	145258	145258	145259
29105	47438	50	applied	\N	\N	\N	\N	145271	145271	145272
29105	47440	51	applied	\N	\N	\N	\N	145277	145277	145278
29105	47443	52	applied	\N	\N	\N	\N	145286	145286	145287
29105	47447	53	applied	\N	\N	\N	\N	145293	145293	145294
29105	47449	54	applied	\N	\N	\N	\N	145298	145298	145299
29105	47452	55	applied	\N	\N	\N	\N	145303	145303	145304
29105	47456	56	applied	\N	\N	\N	\N	145311	145311	145312
29105	47458	57	applied	\N	\N	\N	\N	145314	145314	145315
29105	47462	58	applied	\N	\N	\N	\N	145322	145322	145323
29105	47465	59	applied	\N	\N	\N	\N	145330	145330	145331
29105	47469	60	applied	\N	\N	\N	\N	145346	145346	145347
29105	47471	61	applied	\N	\N	\N	\N	145352	145352	145353
29105	47472	62	applied	\N	\N	\N	\N	145354	145354	145355
29105	47473	63	applied	\N	\N	\N	\N	145356	145356	145357
29105	47481	64	applied	\N	\N	\N	\N	145372	145372	145373
29105	47298	65	applied	\N	\N	\N	\N	144950	144950	78745
29105	47299	66	applied	\N	\N	\N	\N	144951	144951	144952
29105	47300	67	applied	\N	\N	\N	\N	144953	144953	78747
29105	47304	68	applied	\N	\N	\N	\N	144962	144962	78491
29105	47309	69	applied	\N	\N	\N	\N	144972	144972	144955
29105	47310	70	applied	\N	\N	\N	\N	144974	144974	78502
29105	47313	71	applied	\N	\N	\N	\N	144983	144983	145379
29105	47301	72	applied	\N	\N	\N	\N	144954	144954	78508
29105	47305	74	applied	\N	\N	\N	\N	144964	144964	145381
29105	47308	75	applied	\N	\N	\N	\N	144971	144971	144982
29105	47314	76	applied	\N	\N	\N	\N	144984	144984	78749
29105	47316	77	applied	\N	\N	\N	\N	144994	144994	78542
29105	47321	78	applied	\N	\N	\N	\N	145003	145003	78559
29105	47325	79	applied	\N	\N	\N	\N	145014	145014	78573
29105	47333	80	applied	\N	\N	\N	\N	145027	145027	145382
29105	47336	81	applied	\N	\N	\N	\N	145034	145034	145383
29105	47339	82	applied	\N	\N	\N	\N	145041	145041	78587
29105	47344	83	applied	\N	\N	\N	\N	145055	145055	78595
29105	47349	84	applied	\N	\N	\N	\N	145066	145066	145028
29105	47354	85	applied	\N	\N	\N	\N	145077	145077	78756
29105	47355	86	applied	\N	\N	\N	\N	145079	145079	145040
29105	47361	87	applied	\N	\N	\N	\N	145088	145088	145042
29105	47365	88	applied	\N	\N	\N	\N	145097	145097	78637
29105	47302	89	applied	\N	\N	\N	\N	144956	144956	145384
29105	47312	90	applied	\N	\N	\N	\N	144981	144981	145385
29105	47320	91	applied	\N	\N	\N	\N	145002	145002	78643
29105	47331	92	applied	\N	\N	\N	\N	145024	145024	78656
29105	47345	93	applied	\N	\N	\N	\N	145056	145056	145057
29105	47357	94	applied	\N	\N	\N	\N	145081	145081	78758
29105	47362	95	applied	\N	\N	\N	\N	145089	145089	78658
29105	47375	96	applied	\N	\N	\N	\N	145118	145118	145386
29105	47388	97	applied	\N	\N	\N	\N	145147	145147	78759
29105	47395	98	applied	\N	\N	\N	\N	145161	145161	78660
29105	47409	99	applied	\N	\N	\N	\N	145190	145190	145067
29105	47416	100	applied	\N	\N	\N	\N	145206	145206	78760
29105	47424	101	applied	\N	\N	\N	\N	145223	145223	78678
29105	47435	102	applied	\N	\N	\N	\N	145260	145260	145387
29105	47444	103	applied	\N	\N	\N	\N	145288	145288	78761
29105	47454	104	applied	\N	\N	\N	\N	145306	145306	78686
29105	47467	105	applied	\N	\N	\N	\N	145334	145334	145078
29105	47480	106	applied	\N	\N	\N	\N	145368	145368	78762
29105	47370	107	applied	\N	\N	\N	\N	145106	145106	78698
29105	47374	108	applied	\N	\N	\N	\N	145117	145117	78708
29105	47379	109	applied	\N	\N	\N	\N	145127	145127	78766
29105	47381	110	applied	\N	\N	\N	\N	145132	145132	145388
29105	47387	111	applied	\N	\N	\N	\N	145145	145145	145389
29105	47391	112	applied	\N	\N	\N	\N	145154	145154	145390
29105	47394	113	applied	\N	\N	\N	\N	145160	145160	78789
29105	47400	114	applied	\N	\N	\N	\N	145172	145172	145391
29105	47403	115	applied	\N	\N	\N	\N	145180	145180	79144
29105	47408	116	applied	\N	\N	\N	\N	145189	145189	79146
29105	47411	117	applied	\N	\N	\N	\N	145196	145196	78825
29105	47417	118	applied	\N	\N	\N	\N	145207	145207	78835
29105	47421	119	applied	\N	\N	\N	\N	145211	145211	145144
29105	47423	120	applied	\N	\N	\N	\N	145221	145221	145146
29105	47429	121	applied	\N	\N	\N	\N	145238	145238	145392
29105	47432	122	applied	\N	\N	\N	\N	145244	145244	78862
29105	47437	123	applied	\N	\N	\N	\N	145262	145262	145162
29105	47442	124	applied	\N	\N	\N	\N	145280	145280	145165
29105	47446	125	applied	\N	\N	\N	\N	145290	145290	78978
29108	47487	0	applied	\N	\N	\N	\N	145404	145404	145405
29108	47488	1	applied	\N	\N	\N	\N	145406	145406	79219
29108	47489	2	applied	\N	\N	\N	\N	145407	145407	79235
29111	47495	0	applied	\N	\N	\N	\N	145423	145423	145424
29111	47496	1	applied	\N	\N	\N	\N	145425	145425	145426
29111	47497	2	applied	\N	\N	\N	\N	145427	145427	79247
29111	47498	3	applied	\N	\N	\N	\N	145428	145428	145429
29113	47502	0	applied	\N	\N	\N	\N	145439	145439	145440
29113	47503	1	applied	\N	\N	\N	\N	145441	145441	145442
29113	47504	2	applied	\N	\N	\N	\N	145443	145443	79267
29113	47505	3	applied	\N	\N	\N	\N	145444	145444	145445
29113	47506	4	applied	\N	\N	\N	\N	145446	145446	145447
29113	47507	5	applied	\N	\N	\N	\N	145448	145448	79273
29117	47508	0	applied	\N	\N	\N	\N	145451	145451	145452
29117	47509	1	applied	\N	\N	\N	\N	145453	145453	145454
29117	47510	2	applied	\N	\N	\N	\N	145455	145455	145456
29117	47511	3	applied	\N	\N	\N	\N	145457	145457	79298
29117	47512	4	applied	\N	\N	\N	\N	145458	145458	145459
29117	47513	5	applied	\N	\N	\N	\N	145460	145460	145461
29117	47514	6	applied	\N	\N	\N	\N	145462	145462	79302
29117	47515	7	applied	\N	\N	\N	\N	145463	145463	145464
29124	47529	0	applied	\N	\N	\N	\N	145514	145514	145515
29124	47530	1	applied	\N	\N	\N	\N	145516	145516	145517
29124	47531	2	applied	\N	\N	\N	\N	145518	145518	79347
29128	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
29128	47367	1	applied	\N	\N	\N	\N	145102	145102	145102
29128	47457	2	applied	\N	\N	\N	\N	145313	145313	138833
29128	47123	3	applied	\N	\N	\N	\N	144519	144519	144520
29128	47129	4	applied	\N	\N	\N	\N	144543	144543	144544
29128	47351	5	applied	\N	\N	\N	\N	145072	145072	144466
29128	47132	6	applied	\N	\N	\N	\N	144550	144550	144551
29128	47146	7	applied	\N	\N	\N	\N	144591	144591	144592
29128	47147	8	applied	\N	\N	\N	\N	144593	144593	144594
29128	47151	9	applied	\N	\N	\N	\N	144604	144604	144605
29128	47152	10	applied	\N	\N	\N	\N	144606	144606	144607
29128	47158	11	applied	\N	\N	\N	\N	144622	144622	144623
29128	47162	12	applied	\N	\N	\N	\N	144632	144632	144633
29128	47164	13	applied	\N	\N	\N	\N	144638	144638	144639
29128	47165	14	applied	\N	\N	\N	\N	144640	144640	144641
29128	47171	15	applied	\N	\N	\N	\N	144652	144652	144653
29128	47174	16	applied	\N	\N	\N	\N	144658	144658	144659
29128	47177	17	applied	\N	\N	\N	\N	144662	144662	144663
29128	47180	18	applied	\N	\N	\N	\N	144667	144667	144668
29128	47183	19	applied	\N	\N	\N	\N	144675	144675	144676
29128	47186	20	applied	\N	\N	\N	\N	144685	144685	144686
29128	47189	21	applied	\N	\N	\N	\N	144693	144693	144694
29128	47190	22	applied	\N	\N	\N	\N	144695	144695	144696
29128	47191	23	applied	\N	\N	\N	\N	144697	144697	144698
29128	47199	24	applied	\N	\N	\N	\N	144710	144710	144711
29128	47201	25	applied	\N	\N	\N	\N	144715	144715	144716
29128	47205	26	applied	\N	\N	\N	\N	144721	144721	144722
29128	47209	27	applied	\N	\N	\N	\N	144730	144730	144731
29128	47211	28	applied	\N	\N	\N	\N	144735	144735	144736
29128	47214	29	applied	\N	\N	\N	\N	144742	144742	144743
29128	47217	30	applied	\N	\N	\N	\N	144749	144749	144750
29128	47218	31	applied	\N	\N	\N	\N	144751	144751	144752
29128	47224	32	applied	\N	\N	\N	\N	144766	144766	144767
29128	47227	33	applied	\N	\N	\N	\N	144776	144776	144777
29128	47232	34	applied	\N	\N	\N	\N	144788	144788	144789
29128	47233	35	applied	\N	\N	\N	\N	144790	144790	144791
29128	47236	36	applied	\N	\N	\N	\N	144797	144797	144798
29128	47240	37	applied	\N	\N	\N	\N	144803	144803	144804
29128	47243	38	applied	\N	\N	\N	\N	144812	144812	144813
29128	47246	39	applied	\N	\N	\N	\N	144819	144819	144820
29128	47247	40	applied	\N	\N	\N	\N	144821	144821	144822
29128	47252	41	applied	\N	\N	\N	\N	144832	144832	144833
29128	47255	42	applied	\N	\N	\N	\N	144840	144840	144841
29128	47259	43	applied	\N	\N	\N	\N	144850	144850	144851
29128	47260	44	applied	\N	\N	\N	\N	144852	144852	144853
29128	47266	45	applied	\N	\N	\N	\N	144869	144869	144870
29128	47269	46	applied	\N	\N	\N	\N	144886	144886	144887
29128	47272	47	applied	\N	\N	\N	\N	144894	144894	144895
29128	47275	48	applied	\N	\N	\N	\N	144901	144901	144902
29128	47278	49	applied	\N	\N	\N	\N	144908	144908	144909
29128	47281	50	applied	\N	\N	\N	\N	144914	144914	144915
29128	47284	51	applied	\N	\N	\N	\N	144921	144921	144922
29128	47285	52	applied	\N	\N	\N	\N	144923	144923	144924
29128	47290	53	applied	\N	\N	\N	\N	144933	144933	144934
29128	47294	54	applied	\N	\N	\N	\N	144941	144941	144942
29128	47296	55	applied	\N	\N	\N	\N	144946	144946	144947
29128	47297	56	applied	\N	\N	\N	\N	144948	144948	144949
29128	47303	57	applied	\N	\N	\N	\N	144960	144960	144961
29128	47306	58	applied	\N	\N	\N	\N	144967	144967	144968
29128	47307	59	applied	\N	\N	\N	\N	144969	144969	144970
29128	47311	60	applied	\N	\N	\N	\N	144979	144979	144980
29128	47315	61	applied	\N	\N	\N	\N	144992	144992	144993
29128	47318	62	applied	\N	\N	\N	\N	144998	144998	144999
29128	47319	63	applied	\N	\N	\N	\N	145000	145000	145001
29128	47324	64	applied	\N	\N	\N	\N	145012	145012	145013
29128	47328	65	applied	\N	\N	\N	\N	145019	145019	145020
29128	47329	66	applied	\N	\N	\N	\N	145021	145021	145022
29128	47334	67	applied	\N	\N	\N	\N	145031	145031	145032
29128	47337	68	applied	\N	\N	\N	\N	145037	145037	145038
29128	47340	69	applied	\N	\N	\N	\N	145045	145045	145046
29128	47342	70	applied	\N	\N	\N	\N	145052	145052	145053
29128	47346	71	applied	\N	\N	\N	\N	145061	145061	145062
29128	47347	72	applied	\N	\N	\N	\N	145063	145063	145064
29128	47352	73	applied	\N	\N	\N	\N	145073	145073	145074
29128	47353	74	applied	\N	\N	\N	\N	145075	145075	145076
29109	47493	3	applied	\N	\N	\N	\N	145418	145418	79239
29109	47494	4	applied	\N	\N	\N	\N	145419	145419	145420
29118	47327	0	applied	\N	\N	\N	\N	145018	145018	29193
29118	47367	1	applied	\N	\N	\N	\N	145102	145102	145102
29118	47457	2	applied	\N	\N	\N	\N	145313	145313	138833
29118	47269	3	applied	\N	\N	\N	\N	144886	144886	144887
29118	47272	4	applied	\N	\N	\N	\N	144894	144894	144895
29118	47351	5	applied	\N	\N	\N	\N	145072	145072	144758
29118	47275	6	applied	\N	\N	\N	\N	144901	144901	144902
29118	47278	7	applied	\N	\N	\N	\N	144908	144908	144909
29118	47281	8	applied	\N	\N	\N	\N	144914	144914	144915
29118	47284	9	applied	\N	\N	\N	\N	144921	144921	144922
29118	47285	10	applied	\N	\N	\N	\N	144923	144923	144924
29118	47290	11	applied	\N	\N	\N	\N	144933	144933	144934
29118	47294	12	applied	\N	\N	\N	\N	144941	144941	144942
29118	47296	13	applied	\N	\N	\N	\N	144946	144946	144947
29118	47297	14	applied	\N	\N	\N	\N	144948	144948	144949
29118	47303	15	applied	\N	\N	\N	\N	144960	144960	144961
29118	47306	16	applied	\N	\N	\N	\N	144967	144967	144968
29118	47307	17	applied	\N	\N	\N	\N	144969	144969	144970
29118	47311	18	applied	\N	\N	\N	\N	144979	144979	144980
29118	47315	19	applied	\N	\N	\N	\N	144992	144992	144993
29118	47318	20	applied	\N	\N	\N	\N	144998	144998	144999
29118	47319	21	applied	\N	\N	\N	\N	145000	145000	145001
29118	47324	22	applied	\N	\N	\N	\N	145012	145012	145013
29118	47328	23	applied	\N	\N	\N	\N	145019	145019	145020
29118	47329	24	applied	\N	\N	\N	\N	145021	145021	145022
29118	47334	25	applied	\N	\N	\N	\N	145031	145031	145032
29118	47337	26	applied	\N	\N	\N	\N	145037	145037	145038
29118	47340	27	applied	\N	\N	\N	\N	145045	145045	145046
29118	47342	28	applied	\N	\N	\N	\N	145052	145052	145053
29118	47346	29	applied	\N	\N	\N	\N	145061	145061	145062
29118	47347	30	applied	\N	\N	\N	\N	145063	145063	145064
29118	47352	31	applied	\N	\N	\N	\N	145073	145073	145074
29118	47353	32	applied	\N	\N	\N	\N	145075	145075	145076
29118	47358	33	applied	\N	\N	\N	\N	145083	145083	145084
29118	47359	34	applied	\N	\N	\N	\N	145085	145085	145086
29118	47364	35	applied	\N	\N	\N	\N	145095	145095	145096
29118	47368	36	applied	\N	\N	\N	\N	145103	145103	145104
29118	47371	37	applied	\N	\N	\N	\N	145111	145111	145112
29118	47373	38	applied	\N	\N	\N	\N	145115	145115	145116
29118	47377	39	applied	\N	\N	\N	\N	145124	145124	145125
29118	47380	40	applied	\N	\N	\N	\N	145130	145130	145131
29118	47383	41	applied	\N	\N	\N	\N	145137	145137	145138
29118	47384	42	applied	\N	\N	\N	\N	145139	145139	145140
29118	47389	43	applied	\N	\N	\N	\N	145151	145151	145152
29118	47392	44	applied	\N	\N	\N	\N	145156	145156	145157
29118	47393	45	applied	\N	\N	\N	\N	145158	145158	145159
29118	47398	46	applied	\N	\N	\N	\N	145169	145169	145170
29118	47401	47	applied	\N	\N	\N	\N	145177	145177	145178
29118	47404	48	applied	\N	\N	\N	\N	145183	145183	145184
29118	47405	49	applied	\N	\N	\N	\N	145185	145185	145186
29118	47410	50	applied	\N	\N	\N	\N	145194	145194	145195
29118	47413	51	applied	\N	\N	\N	\N	145200	145200	145201
29118	47414	52	applied	\N	\N	\N	\N	145202	145202	145203
29118	47415	53	applied	\N	\N	\N	\N	145204	145204	145205
29118	47422	54	applied	\N	\N	\N	\N	145219	145219	145220
29118	47426	55	applied	\N	\N	\N	\N	145232	145232	145233
29118	47428	56	applied	\N	\N	\N	\N	145236	145236	145237
29118	47431	57	applied	\N	\N	\N	\N	145241	145241	145242
29118	47434	58	applied	\N	\N	\N	\N	145258	145258	145259
29118	47438	59	applied	\N	\N	\N	\N	145271	145271	145272
29118	47440	60	applied	\N	\N	\N	\N	145277	145277	145278
29118	47443	61	applied	\N	\N	\N	\N	145286	145286	145287
29118	47447	62	applied	\N	\N	\N	\N	145293	145293	145294
29118	47449	63	applied	\N	\N	\N	\N	145298	145298	145299
29118	47452	64	applied	\N	\N	\N	\N	145303	145303	145304
29118	47456	65	applied	\N	\N	\N	\N	145311	145311	145312
29118	47458	66	applied	\N	\N	\N	\N	145314	145314	145315
29118	47462	67	applied	\N	\N	\N	\N	145322	145322	145323
29118	47465	68	applied	\N	\N	\N	\N	145330	145330	145331
29118	47469	69	applied	\N	\N	\N	\N	145346	145346	145347
29118	47471	70	applied	\N	\N	\N	\N	145352	145352	145353
29118	47472	71	applied	\N	\N	\N	\N	145354	145354	145355
29118	47473	72	applied	\N	\N	\N	\N	145356	145356	145357
29118	47481	73	applied	\N	\N	\N	\N	145372	145372	145373
29118	47483	74	applied	\N	\N	\N	\N	145395	145395	145396
29118	47487	75	applied	\N	\N	\N	\N	145404	145404	145405
29118	47490	76	applied	\N	\N	\N	\N	145412	145412	145413
29118	47491	77	applied	\N	\N	\N	\N	145414	145414	145415
29118	47495	78	applied	\N	\N	\N	\N	145423	145423	145424
29118	47499	79	applied	\N	\N	\N	\N	145433	145433	145434
29118	47502	80	applied	\N	\N	\N	\N	145439	145439	145440
29118	47503	81	applied	\N	\N	\N	\N	145441	145441	145442
29118	47508	82	applied	\N	\N	\N	\N	145451	145451	145452
29118	47509	83	applied	\N	\N	\N	\N	145453	145453	145454
29118	47510	84	applied	\N	\N	\N	\N	145455	145455	145456
29118	47270	85	applied	\N	\N	\N	\N	144888	144888	78385
29118	47273	86	applied	\N	\N	\N	\N	144896	144896	145472
29118	47277	87	applied	\N	\N	\N	\N	144905	144905	145473
29118	47271	88	applied	\N	\N	\N	\N	144889	144889	145474
29118	47282	89	applied	\N	\N	\N	\N	144916	144916	78392
29118	47292	90	applied	\N	\N	\N	\N	144937	144937	78398
29118	47279	91	applied	\N	\N	\N	\N	144910	144910	78737
29118	47283	92	applied	\N	\N	\N	\N	144917	144917	144904
29118	47286	93	applied	\N	\N	\N	\N	144925	144925	78412
29118	47274	94	applied	\N	\N	\N	\N	144897	144897	78416
29118	47276	95	applied	\N	\N	\N	\N	144903	144903	78741
29118	47288	96	applied	\N	\N	\N	\N	144928	144928	78431
29118	47280	97	applied	\N	\N	\N	\N	144911	144911	78743
29118	47287	98	applied	\N	\N	\N	\N	144926	144926	145475
29118	47302	99	applied	\N	\N	\N	\N	144956	144956	145476
29118	47312	100	applied	\N	\N	\N	\N	144981	144981	78451
29118	47320	101	applied	\N	\N	\N	\N	145002	145002	144930
29118	47331	102	applied	\N	\N	\N	\N	145024	145024	145477
29118	47345	103	applied	\N	\N	\N	\N	145056	145056	78459
29118	47357	104	applied	\N	\N	\N	\N	145081	145081	145478
29118	47362	105	applied	\N	\N	\N	\N	145089	145089	144936
29118	47375	106	applied	\N	\N	\N	\N	145118	145118	78461
29118	47388	107	applied	\N	\N	\N	\N	145147	145147	78463
29118	47395	108	applied	\N	\N	\N	\N	145161	145161	144939
29118	47409	109	applied	\N	\N	\N	\N	145190	145190	78744
29118	47416	110	applied	\N	\N	\N	\N	145206	145206	78469
29118	47424	111	applied	\N	\N	\N	\N	145223	145223	78480
29118	47435	112	applied	\N	\N	\N	\N	145260	145260	78745
29118	47444	113	applied	\N	\N	\N	\N	145288	145288	145479
29118	47454	114	applied	\N	\N	\N	\N	145306	145306	78482
29118	47467	115	applied	\N	\N	\N	\N	145334	145334	78746
29118	47289	117	applied	\N	\N	\N	\N	144929	144929	145481
29118	47291	118	applied	\N	\N	\N	\N	144935	144935	144957
29115	47514	6	applied	\N	\N	\N	\N	145462	145462	79302
29115	47515	7	applied	\N	\N	\N	\N	145463	145463	145464
29119	47516	0	applied	\N	\N	\N	\N	145485	145485	145486
29119	47517	1	applied	\N	\N	\N	\N	145487	145487	79312
29119	47518	3	applied	\N	\N	\N	\N	145489	145489	145490
29119	47519	4	applied	\N	\N	\N	\N	145491	145491	79314
29120	47520	0	applied	\N	\N	\N	\N	145493	145493	145494
29120	47521	1	applied	\N	\N	\N	\N	145495	145495	145496
29120	47522	2	applied	\N	\N	\N	\N	145497	145497	79316
29120	47523	3	applied	\N	\N	\N	\N	145498	145498	79318
29120	47524	4	applied	\N	\N	\N	\N	145499	145499	79322
29127	47538	0	applied	\N	\N	\N	\N	145540	145540	145541
29127	47539	1	applied	\N	\N	\N	\N	145542	145542	145543
29127	47540	2	applied	\N	\N	\N	\N	145544	145544	145545
29127	47541	3	applied	\N	\N	\N	\N	145546	145546	145547
29127	47542	4	applied	\N	\N	\N	\N	145548	145548	79369
29127	47543	5	applied	\N	\N	\N	\N	145549	145549	79371
29127	47544	6	applied	\N	\N	\N	\N	145550	145550	145551
29127	47545	7	applied	\N	\N	\N	\N	145552	145552	79381
29127	47546	8	applied	\N	\N	\N	\N	145553	145553	79383
29127	47547	9	applied	\N	\N	\N	\N	145554	145554	145555
29127	47548	10	applied	\N	\N	\N	\N	145556	145556	79402
29127	47549	11	applied	\N	\N	\N	\N	145557	145557	145558
29132	47562	0	applied	\N	\N	\N	\N	145591	145591	145592
29132	47563	1	applied	\N	\N	\N	\N	145593	145593	145594
29132	47564	2	applied	\N	\N	\N	\N	145595	145595	145596
29132	47565	3	applied	\N	\N	\N	\N	145597	145597	79451
29132	47566	4	applied	\N	\N	\N	\N	145598	145598	145599
29132	47567	5	applied	\N	\N	\N	\N	145600	145600	79453
29132	47568	6	applied	\N	\N	\N	\N	145601	145601	145602
29132	47569	7	applied	\N	\N	\N	\N	145603	145603	145604
29132	47570	8	applied	\N	\N	\N	\N	145605	145605	79465
29132	47571	9	applied	\N	\N	\N	\N	145606	145606	79495
29135	47574	0	applied	\N	\N	\N	\N	145616	145616	145617
29135	47575	1	applied	\N	\N	\N	\N	145618	145618	145619
29135	47576	2	applied	\N	\N	\N	\N	145620	145620	79497
29135	47577	3	applied	\N	\N	\N	\N	145621	145621	145622
29135	47578	4	applied	\N	\N	\N	\N	145623	145623	79508
29135	47579	5	applied	\N	\N	\N	\N	145624	145624	145625
29135	47580	6	applied	\N	\N	\N	\N	145626	145626	145627
29138	47583	0	applied	\N	\N	\N	\N	145633	145633	145634
29138	47584	1	applied	\N	\N	\N	\N	145635	145635	145636
29138	47585	2	applied	\N	\N	\N	\N	145637	145637	79524
29138	47586	3	applied	\N	\N	\N	\N	145638	145638	145639
29138	47587	4	applied	\N	\N	\N	\N	145640	145640	145641
29138	47588	5	applied	\N	\N	\N	\N	145642	145642	145643
29141	47589	0	applied	\N	\N	\N	\N	145648	145648	145649
29141	47590	1	applied	\N	\N	\N	\N	145650	145650	79541
29141	47591	2	applied	\N	\N	\N	\N	145651	145651	145652
29144	47601	0	applied	\N	\N	\N	\N	145678	145678	145679
29144	47602	1	applied	\N	\N	\N	\N	145680	145680	79579
29144	47603	2	applied	\N	\N	\N	\N	145681	145681	145682
29154	47624	0	applied	\N	\N	\N	\N	145730	145730	145731
29154	47625	1	applied	\N	\N	\N	\N	145732	145732	145733
29154	47626	2	applied	\N	\N	\N	\N	145734	145734	79656
29163	47639	0	applied	\N	\N	\N	\N	145786	145786	79701
29163	47640	1	applied	\N	\N	\N	\N	145787	145787	145788
29167	47639	0	applied	\N	\N	\N	\N	145786	145786	79701
29167	47640	1	applied	\N	\N	\N	\N	145787	145787	145788
29118	47299	119	applied	\N	\N	\N	\N	144951	144951	78506
29118	47301	120	applied	\N	\N	\N	\N	144954	144954	145482
29118	47305	121	applied	\N	\N	\N	\N	144964	144964	144973
29118	47308	122	applied	\N	\N	\N	\N	144971	144971	78748
29118	47314	123	applied	\N	\N	\N	\N	144984	144984	78540
29118	47316	124	applied	\N	\N	\N	\N	144994	144994	78553
29118	47321	125	applied	\N	\N	\N	\N	145003	145003	78752
29122	47525	0	applied	\N	\N	\N	\N	145502	145502	145503
29122	47526	1	applied	\N	\N	\N	\N	145504	145504	145505
29122	47527	2	applied	\N	\N	\N	\N	145506	145506	79333
29122	47528	3	applied	\N	\N	\N	\N	145507	145507	145508
29123	47525	0	applied	\N	\N	\N	\N	145502	145502	145503
29123	47526	1	applied	\N	\N	\N	\N	145504	145504	145505
29123	47527	2	applied	\N	\N	\N	\N	145506	145506	79333
29123	47528	3	applied	\N	\N	\N	\N	145507	145507	145508
29126	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
29126	47457	1	applied	\N	\N	\N	\N	145313	145313	138833
29126	47043	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	144338	144338	\N
29126	47351	3	applied	\N	\N	\N	\N	145072	145072	144287
29126	47050	4	applied	\N	\N	1000000000	\N	144352	144352	144353
29126	47060	5	applied	\N	\N	\N	\N	144375	144375	144376
29126	47072	6	applied	\N	\N	\N	\N	145342	145342	145343
29126	47261	7	applied	\N	\N	\N	\N	144854	144854	144855
29126	47081	8	applied	\N	\N	1000000000	\N	144423	144423	144424
29126	47041	9	applied	\N	\N	\N	\N	144335	144335	145532
29126	47104	10	applied	\N	\N	1000000000	\N	144466	144466	144467
29126	47127	11	applied	\N	\N	1000000000	\N	144537	144537	144538
29126	47159	12	applied	\N	\N	1000000000	\N	144624	144624	144625
29126	47053	13	applied	\N	\N	\N	\N	144357	144357	77433
29126	47067	14	applied	\N	\N	\N	\N	144388	144388	77484
29126	47075	15	applied	\N	\N	\N	\N	144411	144411	77435
29126	47087	16	applied	\N	\N	\N	\N	144431	144431	77437
29126	47098	17	applied	\N	\N	\N	\N	144456	144456	77485
29126	47110	18	applied	\N	\N	\N	\N	144480	144480	144337
29126	47120	19	applied	\N	\N	\N	\N	144510	144510	77439
29126	47131	20	applied	\N	\N	\N	\N	144546	144546	77486
29126	47137	21	applied	\N	\N	\N	\N	144563	144563	77441
29126	47144	22	applied	\N	\N	\N	\N	144586	144586	77865
29126	47157	23	applied	\N	\N	\N	\N	144615	144615	77443
29126	47166	24	applied	\N	\N	\N	\N	144642	144642	77866
29126	47094	25	applied	\N	\N	1000000000	\N	144443	144443	144444
29126	47223	26	applied	\N	\N	1000000000	\N	144758	144758	144759
29126	47176	27	applied	\N	\N	\N	\N	144661	144661	145533
29126	47188	28	applied	\N	\N	\N	\N	144688	144688	77446
29126	47192	29	applied	\N	\N	\N	\N	144699	144699	145534
29126	47208	30	applied	\N	\N	\N	\N	144726	144726	77867
29126	47220	31	applied	\N	\N	\N	\N	144754	144754	77448
29126	47229	32	applied	\N	\N	\N	\N	144780	144780	77502
29126	47239	33	applied	\N	\N	\N	\N	144802	144802	77868
29126	47250	34	applied	\N	\N	\N	\N	144825	144825	144356
29126	47262	35	applied	\N	\N	\N	\N	144857	144857	77504
29126	47271	36	applied	\N	\N	\N	\N	144889	144889	77869
29126	47282	37	applied	\N	\N	\N	\N	144916	144916	144363
29126	47292	38	applied	\N	\N	\N	\N	144937	144937	77506
29126	47302	39	applied	\N	\N	\N	\N	144956	144956	77870
29126	47312	40	applied	\N	\N	\N	\N	144981	144981	145535
29126	47320	41	applied	\N	\N	\N	\N	145002	145002	77508
29126	47331	42	applied	\N	\N	\N	\N	145024	145024	77871
29126	47345	43	applied	\N	\N	\N	\N	145056	145056	144369
29126	47357	44	applied	\N	\N	\N	\N	145081	145081	77510
29126	47362	45	applied	\N	\N	\N	\N	145089	145089	77872
29126	47375	46	applied	\N	\N	\N	\N	145118	145118	77512
29126	47388	47	applied	\N	\N	\N	\N	145147	145147	145536
29126	47395	48	applied	\N	\N	\N	\N	145161	145161	77514
29126	47409	49	applied	\N	\N	\N	\N	145190	145190	144379
29126	47416	50	applied	\N	\N	\N	\N	145206	145206	77516
29126	47424	51	applied	\N	\N	\N	\N	145223	145223	77873
29126	47435	52	applied	\N	\N	\N	\N	145260	145260	77518
29126	47444	53	applied	\N	\N	\N	\N	145288	145288	144386
29126	47454	54	applied	\N	\N	\N	\N	145306	145306	77874
29126	47467	55	applied	\N	\N	\N	\N	145334	145334	77526
29126	47480	56	applied	\N	\N	\N	\N	145368	145368	144389
29126	47485	57	applied	\N	\N	\N	\N	145399	145399	77875
29126	47498	58	applied	\N	\N	\N	\N	145428	145428	77528
29126	47504	59	applied	\N	\N	\N	\N	145443	145443	145537
29126	47519	60	applied	\N	\N	\N	\N	145491	145491	77530
29126	47526	61	applied	\N	\N	\N	\N	145504	145504	144531
29126	47535	62	applied	\N	\N	\N	\N	145526	145526	77532
29130	47554	0	applied	\N	\N	\N	\N	145573	145573	145574
29130	47555	1	applied	\N	\N	\N	\N	145575	145575	145576
29130	47556	2	applied	\N	\N	\N	\N	145577	145577	145578
29130	47557	3	applied	\N	\N	\N	\N	145579	145579	145580
29130	47558	4	applied	\N	\N	\N	\N	145581	145581	145582
29130	47559	5	applied	\N	\N	\N	\N	145583	145583	145584
29130	47560	6	applied	\N	\N	\N	\N	145585	145585	145586
29130	47561	7	applied	\N	\N	\N	\N	145587	145587	79449
29133	47572	0	applied	\N	\N	\N	\N	145609	145609	145610
29133	47573	1	applied	\N	\N	\N	\N	145611	145611	145612
29139	47589	0	applied	\N	\N	\N	\N	145648	145648	145649
29139	47590	1	applied	\N	\N	\N	\N	145650	145650	79541
29139	47591	2	applied	\N	\N	\N	\N	145651	145651	145652
29143	47592	0	applied	\N	\N	\N	\N	145659	145659	145660
29143	47593	1	applied	\N	\N	\N	\N	145661	145661	145662
29143	47594	2	applied	\N	\N	\N	\N	145663	145663	145664
29143	47595	3	applied	\N	\N	\N	\N	145665	145665	79555
29143	47596	4	applied	\N	\N	\N	\N	145666	145666	79557
29143	47597	5	applied	\N	\N	\N	\N	145667	145667	145668
29143	47598	6	applied	\N	\N	\N	\N	145669	145669	79569
29143	47599	7	applied	\N	\N	\N	\N	145670	145670	145671
29143	47600	8	applied	\N	\N	\N	\N	145672	145672	145673
29146	47604	0	applied	\N	\N	\N	\N	145685	145685	145686
29146	47605	1	applied	\N	\N	\N	\N	145687	145687	79593
29149	47610	0	applied	\N	\N	\N	\N	145700	145700	145701
29149	47611	1	applied	\N	\N	\N	\N	145702	145702	145703
29149	47612	2	applied	\N	\N	\N	\N	145704	145704	145705
29149	47613	3	applied	\N	\N	\N	\N	145706	145706	145707
29149	47614	4	applied	\N	\N	\N	\N	145708	145708	145709
29149	47615	5	applied	\N	\N	\N	\N	145710	145710	79622
29151	47621	0	applied	\N	\N	\N	\N	145723	145723	145724
29151	47622	1	applied	\N	\N	\N	\N	145725	145725	145726
29151	47623	2	applied	\N	\N	\N	\N	145727	145727	79650
29157	47635	0	applied	\N	\N	\N	\N	145755	145755	145756
29157	47636	1	applied	\N	\N	\N	\N	145757	145757	79685
29159	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
29159	46820	1	applied	\N	\N	1000000000	\N	143840	143840	143841
29159	46797	2	applied	\N	\N	\N	\N	143773	143773	143774
29159	47457	3	applied	\N	\N	\N	\N	145313	145313	138833
29159	47043	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	144338	144338	\N
29128	47358	75	applied	\N	\N	\N	\N	145083	145083	145084
29128	47359	76	applied	\N	\N	\N	\N	145085	145085	145086
29128	47364	77	applied	\N	\N	\N	\N	145095	145095	145096
29128	47368	78	applied	\N	\N	\N	\N	145103	145103	145104
29128	47371	79	applied	\N	\N	\N	\N	145111	145111	145112
29128	47373	80	applied	\N	\N	\N	\N	145115	145115	145116
29128	47377	81	applied	\N	\N	\N	\N	145124	145124	145125
29128	47380	82	applied	\N	\N	\N	\N	145130	145130	145131
29128	47383	83	applied	\N	\N	\N	\N	145137	145137	145138
29128	47384	84	applied	\N	\N	\N	\N	145139	145139	145140
29128	47389	85	applied	\N	\N	\N	\N	145151	145151	145152
29128	47392	86	applied	\N	\N	\N	\N	145156	145156	145157
29128	47393	87	applied	\N	\N	\N	\N	145158	145158	145159
29128	47398	88	applied	\N	\N	\N	\N	145169	145169	145170
29128	47401	89	applied	\N	\N	\N	\N	145177	145177	145178
29128	47404	90	applied	\N	\N	\N	\N	145183	145183	145184
29128	47405	91	applied	\N	\N	\N	\N	145185	145185	145186
29128	47410	92	applied	\N	\N	\N	\N	145194	145194	145195
29128	47413	93	applied	\N	\N	\N	\N	145200	145200	145201
29128	47414	94	applied	\N	\N	\N	\N	145202	145202	145203
29128	47415	95	applied	\N	\N	\N	\N	145204	145204	145205
29128	47422	96	applied	\N	\N	\N	\N	145219	145219	145220
29128	47426	97	applied	\N	\N	\N	\N	145232	145232	145233
29128	47428	98	applied	\N	\N	\N	\N	145236	145236	145237
29128	47431	99	applied	\N	\N	\N	\N	145241	145241	145242
29128	47434	100	applied	\N	\N	\N	\N	145258	145258	145259
29128	47438	101	applied	\N	\N	\N	\N	145271	145271	145272
29128	47440	102	applied	\N	\N	\N	\N	145277	145277	145278
29128	47443	104	applied	\N	\N	\N	\N	145286	145286	145287
29128	47447	105	applied	\N	\N	\N	\N	145293	145293	145294
29128	47449	106	applied	\N	\N	\N	\N	145298	145298	145299
29128	47452	107	applied	\N	\N	\N	\N	145303	145303	145304
29128	47456	108	applied	\N	\N	\N	\N	145311	145311	145312
29128	47458	109	applied	\N	\N	\N	\N	145314	145314	145315
29128	47462	110	applied	\N	\N	\N	\N	145322	145322	145323
29128	47465	111	applied	\N	\N	\N	\N	145330	145330	145331
29128	47469	112	applied	\N	\N	\N	\N	145346	145346	145347
29128	47471	113	applied	\N	\N	\N	\N	145352	145352	145353
29128	47472	114	applied	\N	\N	\N	\N	145354	145354	145355
29128	47473	115	applied	\N	\N	\N	\N	145356	145356	145357
29128	47481	116	applied	\N	\N	\N	\N	145372	145372	145373
29128	47483	117	applied	\N	\N	\N	\N	145395	145395	145396
29128	47487	118	applied	\N	\N	\N	\N	145404	145404	145405
29128	47490	119	applied	\N	\N	\N	\N	145412	145412	145413
29128	47491	120	applied	\N	\N	\N	\N	145414	145414	145415
29128	47495	121	applied	\N	\N	\N	\N	145423	145423	145424
29128	47499	122	applied	\N	\N	\N	\N	145433	145433	145434
29128	47502	123	applied	\N	\N	\N	\N	145439	145439	145440
29128	47503	124	applied	\N	\N	\N	\N	145441	145441	145442
29128	47508	125	applied	\N	\N	\N	\N	145451	145451	145452
29129	47550	0	applied	\N	\N	\N	\N	145564	145564	145565
29129	47551	1	applied	\N	\N	\N	\N	145566	145566	145567
29129	47552	2	applied	\N	\N	\N	\N	145568	145568	145569
29129	47553	3	applied	\N	\N	\N	\N	145570	145570	79408
29137	47583	0	applied	\N	\N	\N	\N	145633	145633	145634
29137	47584	1	applied	\N	\N	\N	\N	145635	145635	145636
29137	47585	2	applied	\N	\N	\N	\N	145637	145637	79524
29137	47586	3	applied	\N	\N	\N	\N	145638	145638	145639
29137	47587	4	applied	\N	\N	\N	\N	145640	145640	145641
29137	47588	5	applied	\N	\N	\N	\N	145642	145642	145643
29140	47589	0	applied	\N	\N	\N	\N	145648	145648	145649
29140	47590	1	applied	\N	\N	\N	\N	145650	145650	79541
29140	47591	2	applied	\N	\N	\N	\N	145651	145651	145652
29142	47592	0	applied	\N	\N	\N	\N	145659	145659	145660
29142	47593	1	applied	\N	\N	\N	\N	145661	145661	145662
29142	47594	2	applied	\N	\N	\N	\N	145663	145663	145664
29142	47595	3	applied	\N	\N	\N	\N	145665	145665	79555
29142	47596	4	applied	\N	\N	\N	\N	145666	145666	79557
29142	47597	5	applied	\N	\N	\N	\N	145667	145667	145668
29142	47598	6	applied	\N	\N	\N	\N	145669	145669	79569
29142	47599	7	applied	\N	\N	\N	\N	145670	145670	145671
29142	47600	8	applied	\N	\N	\N	\N	145672	145672	145673
29145	47604	0	applied	\N	\N	\N	\N	145685	145685	145686
29145	47605	1	applied	\N	\N	\N	\N	145687	145687	79593
29148	47606	0	applied	\N	\N	\N	\N	145690	145690	145691
29148	47607	1	applied	\N	\N	\N	\N	145692	145692	145693
29148	47608	2	applied	\N	\N	\N	\N	145694	145694	145695
29148	47609	3	applied	\N	\N	\N	\N	145696	145696	79606
29152	47624	0	applied	\N	\N	\N	\N	145730	145730	145731
29152	47625	1	applied	\N	\N	\N	\N	145732	145732	145733
29152	47626	2	applied	\N	\N	\N	\N	145734	145734	79656
29156	47627	0	applied	\N	\N	\N	\N	145736	145736	145737
29156	47628	1	applied	\N	\N	\N	\N	145738	145738	145739
29156	47629	2	applied	\N	\N	\N	\N	145740	145740	145741
29156	47630	3	applied	\N	\N	\N	\N	145742	145742	79661
29156	47626	4	applied	\N	\N	\N	\N	145734	145734	145743
29156	47631	5	applied	\N	\N	\N	\N	145744	145744	145745
29156	47632	6	applied	\N	\N	\N	\N	145746	145746	79671
29156	47633	7	applied	\N	\N	\N	\N	145747	145747	145748
29156	47634	8	applied	\N	\N	\N	\N	145749	145749	145750
29162	47509	0	applied	\N	\N	\N	\N	145453	145453	145454
29162	47510	1	applied	\N	\N	\N	\N	145455	145455	145456
29162	47516	2	applied	\N	\N	\N	\N	145485	145485	145486
29162	47520	3	applied	\N	\N	\N	\N	145493	145493	145494
29162	47521	4	applied	\N	\N	\N	\N	145495	145495	145496
29162	47525	5	applied	\N	\N	\N	\N	145502	145502	145503
29162	47529	6	applied	\N	\N	\N	\N	145514	145514	145515
29162	47532	7	applied	\N	\N	\N	\N	145521	145521	145522
29162	47533	8	applied	\N	\N	\N	\N	145523	145523	145524
29162	47538	9	applied	\N	\N	\N	\N	145540	145540	145541
29162	47539	10	applied	\N	\N	\N	\N	145542	145542	145543
29162	47540	11	applied	\N	\N	\N	\N	145544	145544	145545
29162	47541	12	applied	\N	\N	\N	\N	145546	145546	145547
29162	47550	13	applied	\N	\N	\N	\N	145564	145564	145565
29162	47551	14	applied	\N	\N	\N	\N	145566	145566	145567
29162	47554	15	applied	\N	\N	\N	\N	145573	145573	145574
29162	47555	16	applied	\N	\N	\N	\N	145575	145575	145576
29162	47562	17	applied	\N	\N	\N	\N	145591	145591	145592
29162	47563	18	applied	\N	\N	\N	\N	145593	145593	145594
29162	47564	19	applied	\N	\N	\N	\N	145595	145595	145596
29162	47572	20	applied	\N	\N	\N	\N	145609	145609	145610
29162	47574	21	applied	\N	\N	\N	\N	145616	145616	145617
29162	47575	22	applied	\N	\N	\N	\N	145618	145618	145619
29162	47581	23	applied	\N	\N	\N	\N	145629	145629	145630
29162	47583	24	applied	\N	\N	\N	\N	145633	145633	145634
29162	47584	25	applied	\N	\N	\N	\N	145635	145635	145636
29162	47589	26	applied	\N	\N	\N	\N	145648	145648	145649
29162	47592	27	applied	\N	\N	\N	\N	145659	145659	145660
29162	47593	28	applied	\N	\N	\N	\N	145661	145661	145662
29162	47594	29	applied	\N	\N	\N	\N	145663	145663	145664
29136	47581	0	applied	\N	\N	\N	\N	145629	145629	145630
29136	47582	1	applied	\N	\N	\N	\N	145631	145631	79523
29147	47606	0	applied	\N	\N	\N	\N	145690	145690	145691
29147	47607	1	applied	\N	\N	\N	\N	145692	145692	145693
29147	47608	2	applied	\N	\N	\N	\N	145694	145694	145695
29147	47609	3	applied	\N	\N	\N	\N	145696	145696	79606
29150	47616	0	applied	\N	\N	\N	\N	145713	145713	145714
29150	47617	1	applied	\N	\N	\N	\N	145715	145715	145716
29150	47618	2	applied	\N	\N	\N	\N	145717	145717	145718
29150	47619	3	applied	\N	\N	\N	\N	145719	145719	79626
29150	47620	4	applied	\N	\N	\N	\N	145720	145720	145721
29153	47624	0	applied	\N	\N	\N	\N	145730	145730	145731
29153	47625	1	applied	\N	\N	\N	\N	145732	145732	145733
29155	47627	0	applied	\N	\N	\N	\N	145736	145736	145737
29155	47628	1	applied	\N	\N	\N	\N	145738	145738	145739
29155	47629	2	applied	\N	\N	\N	\N	145740	145740	145741
29155	47630	3	applied	\N	\N	\N	\N	145742	145742	79661
29155	47626	4	applied	\N	\N	\N	\N	145734	145734	145743
29155	47631	5	applied	\N	\N	\N	\N	145744	145744	145745
29155	47632	6	applied	\N	\N	\N	\N	145746	145746	79671
29155	47633	7	applied	\N	\N	\N	\N	145747	145747	145748
29155	47634	8	applied	\N	\N	\N	\N	145749	145749	145750
29158	47635	0	applied	\N	\N	\N	\N	145755	145755	145756
29158	47636	1	applied	\N	\N	\N	\N	145757	145757	79685
29160	47635	0	applied	\N	\N	\N	\N	145755	145755	145756
29160	47636	1	applied	\N	\N	\N	\N	145757	145757	79685
29161	47637	0	applied	\N	\N	\N	\N	145766	145766	145767
29161	47638	1	applied	\N	\N	\N	\N	145768	145768	145769
29164	47639	0	applied	\N	\N	\N	\N	145786	145786	79701
29164	47640	1	applied	\N	\N	\N	\N	145787	145787	145788
29168	47641	0	applied	\N	\N	\N	\N	145793	145793	145794
29168	47642	1	applied	\N	\N	\N	\N	145795	145795	145796
29168	47643	2	applied	\N	\N	\N	\N	145797	145797	145798
29168	47644	3	applied	\N	\N	\N	\N	145799	145799	79722
29168	47645	4	applied	\N	\N	\N	\N	145800	145800	79733
29159	47351	5	applied	\N	\N	\N	\N	145072	145072	140967
29159	47050	6	applied	\N	\N	1000000000	\N	144352	144352	144353
29159	47060	7	applied	\N	\N	\N	\N	144375	144375	144376
29159	47072	8	applied	\N	\N	\N	\N	145342	145342	145343
29159	47261	9	applied	\N	\N	\N	\N	144854	144854	144855
29159	47081	10	applied	\N	\N	1000000000	\N	144423	144423	144424
29159	46710	11	applied	\N	\N	\N	\N	143448	143448	76225
29159	46718	12	applied	\N	\N	\N	\N	143474	143474	76226
29159	46725	13	applied	\N	\N	\N	\N	143573	143573	75424
29159	46733	14	applied	\N	\N	\N	\N	143604	143604	142973
29159	46721	15	applied	\N	\N	\N	\N	143482	143482	143483
29159	46742	16	applied	\N	\N	\N	\N	143626	143626	76227
29159	46751	17	applied	\N	\N	\N	\N	143648	143648	75426
29159	46762	18	applied	\N	\N	\N	\N	143689	143689	142975
29159	47094	19	applied	\N	\N	1000000000	\N	144443	144443	144444
29159	46773	20	applied	\N	\N	\N	\N	143713	143713	75428
29159	46780	21	applied	\N	\N	\N	\N	143736	143736	75871
29159	46791	22	applied	\N	\N	\N	\N	143760	143760	75430
29159	46802	23	applied	\N	\N	\N	\N	143783	143783	76228
29159	46808	24	applied	\N	\N	\N	\N	143808	143808	75432
29159	46816	25	applied	\N	\N	\N	\N	143828	143828	142774
29159	46825	26	applied	\N	\N	\N	\N	143850	143850	76229
29159	46833	27	applied	\N	\N	\N	\N	143864	143864	75436
29159	46847	28	applied	\N	\N	\N	\N	143898	143898	142776
29159	46856	29	applied	\N	\N	\N	\N	143920	143920	75438
29159	46866	30	applied	\N	\N	\N	\N	143944	143944	75872
29159	46878	31	applied	\N	\N	\N	\N	143968	143968	142978
29159	46886	33	applied	\N	\N	\N	\N	143984	143984	75442
29159	46897	34	applied	\N	\N	\N	\N	144003	144003	75873
29159	46907	35	applied	\N	\N	\N	\N	144028	144028	75444
29159	46916	36	applied	\N	\N	\N	\N	144049	144049	76230
29159	46926	37	applied	\N	\N	\N	\N	144083	144083	75874
29159	46938	38	applied	\N	\N	\N	\N	144112	144112	75448
29159	46944	39	applied	\N	\N	\N	\N	144131	144131	75450
29159	46954	40	applied	\N	\N	\N	\N	144155	144155	75875
29159	46971	41	applied	\N	\N	\N	\N	144186	144186	75452
29159	46977	42	applied	\N	\N	\N	\N	144203	144203	142794
29159	46985	43	applied	\N	\N	\N	\N	144220	144220	75876
29159	46996	44	applied	\N	\N	\N	\N	144245	144245	75462
29159	47005	45	applied	\N	\N	\N	\N	144263	144263	75877
29170	47641	0	applied	\N	\N	\N	\N	145793	145793	145794
29170	47642	1	applied	\N	\N	\N	\N	145795	145795	145796
29170	47643	2	applied	\N	\N	\N	\N	145797	145797	145798
29170	47644	3	applied	\N	\N	\N	\N	145799	145799	79722
29170	47645	4	applied	\N	\N	\N	\N	145800	145800	79733
29172	47641	0	applied	\N	\N	\N	\N	145793	145793	145794
29172	47642	1	applied	\N	\N	\N	\N	145795	145795	145796
29172	47643	2	applied	\N	\N	\N	\N	145797	145797	145798
29172	47644	3	applied	\N	\N	\N	\N	145799	145799	79722
29172	47645	4	applied	\N	\N	\N	\N	145800	145800	79733
29172	47646	5	applied	\N	\N	\N	\N	145803	145803	145804
29172	47647	6	applied	\N	\N	\N	\N	145805	145805	79737
29172	47648	7	applied	\N	\N	\N	\N	145806	145806	79739
29162	47601	30	applied	\N	\N	\N	\N	145678	145678	145679
29162	47604	31	applied	\N	\N	\N	\N	145685	145685	145686
29162	47606	32	applied	\N	\N	\N	\N	145690	145690	145691
29162	47610	33	applied	\N	\N	\N	\N	145700	145700	145701
29162	47611	34	applied	\N	\N	\N	\N	145702	145702	145703
29162	47616	35	applied	\N	\N	\N	\N	145713	145713	145714
29162	47617	36	applied	\N	\N	\N	\N	145715	145715	145716
29162	47621	37	applied	\N	\N	\N	\N	145723	145723	145724
29162	47624	38	applied	\N	\N	\N	\N	145730	145730	145731
29162	47627	39	applied	\N	\N	\N	\N	145736	145736	145737
29162	47628	40	applied	\N	\N	\N	\N	145738	145738	145739
29162	47629	41	applied	\N	\N	\N	\N	145740	145740	145741
29162	47635	42	applied	\N	\N	\N	\N	145755	145755	145756
29162	47261	43	applied	\N	\N	\N	\N	144854	144854	144855
29162	47124	44	applied	\N	\N	\N	\N	144521	144521	77687
29162	47125	45	applied	\N	\N	\N	\N	144524	144524	144525
29162	47128	46	applied	\N	\N	\N	\N	144540	144540	144539
29162	47130	47	applied	\N	\N	\N	\N	144545	144545	77691
29162	47133	48	applied	\N	\N	\N	\N	144552	144552	144541
29162	47135	49	applied	\N	\N	\N	\N	144559	144559	77705
29162	47136	50	applied	\N	\N	\N	\N	144561	144561	144871
29162	47131	51	applied	\N	\N	\N	\N	144546	144546	77707
29162	47137	52	applied	\N	\N	\N	\N	144563	144563	144872
29162	47144	53	applied	\N	\N	\N	\N	144586	144586	144873
29162	47126	54	applied	\N	\N	\N	\N	144536	144536	144560
29162	47127	55	applied	\N	\N	1000000000	\N	144537	144537	144538
29162	47159	56	applied	\N	\N	1000000000	\N	144624	144624	144625
29162	47140	57	applied	\N	\N	\N	\N	144570	144570	144562
29162	47141	58	applied	\N	\N	\N	\N	144573	144573	77750
29162	47143	59	applied	\N	\N	\N	\N	144585	144585	144874
29162	47149	60	applied	\N	\N	\N	\N	144597	144597	144875
29162	47134	61	applied	\N	\N	\N	\N	144553	144553	145772
29162	47138	62	applied	\N	\N	\N	\N	144565	144565	145773
29162	47139	63	applied	\N	\N	\N	\N	144566	144566	145774
29162	47142	64	applied	\N	\N	\N	\N	144575	144575	77802
29162	47145	65	applied	\N	\N	\N	\N	144588	144588	77813
29162	47148	66	applied	\N	\N	\N	\N	144595	144595	144598
29162	47155	67	applied	\N	\N	\N	\N	144611	144611	144609
29162	47156	68	applied	\N	\N	\N	\N	144613	144613	145775
29162	47161	69	applied	\N	\N	\N	\N	144628	144628	77854
29162	47150	70	applied	\N	\N	\N	\N	144599	144599	144614
29162	47153	71	applied	\N	\N	\N	\N	144608	144608	145776
29162	47154	72	applied	\N	\N	\N	\N	144610	144610	77912
29162	47160	73	applied	\N	\N	\N	\N	144626	144626	145777
29162	47163	74	applied	\N	\N	\N	\N	144634	144634	77919
29162	47167	75	applied	\N	\N	\N	\N	144644	144644	145778
29162	47168	76	applied	\N	\N	\N	\N	144645	144645	145779
29162	47172	77	applied	\N	\N	\N	\N	144654	144654	78020
29162	47179	78	applied	\N	\N	\N	\N	144665	144665	78021
29162	47181	79	applied	\N	\N	\N	\N	144669	144669	77970
29162	47185	80	applied	\N	\N	\N	\N	144678	144678	145780
29162	47196	81	applied	\N	\N	\N	\N	144704	144704	78025
29162	47197	82	applied	\N	\N	\N	\N	144705	144705	78188
29162	47157	83	applied	\N	\N	\N	\N	144615	144615	77998
29162	47166	84	applied	\N	\N	\N	\N	144642	144642	78027
29162	47223	85	applied	\N	\N	1000000000	\N	144758	144758	144759
29162	47176	86	applied	\N	\N	\N	\N	144661	144661	78189
29162	47188	87	applied	\N	\N	\N	\N	144688	144688	78000
29162	47192	88	applied	\N	\N	\N	\N	144699	144699	78005
29162	47208	89	applied	\N	\N	\N	\N	144726	144726	78190
29162	47220	90	applied	\N	\N	\N	\N	144754	144754	144680
29162	47229	91	applied	\N	\N	\N	\N	144780	144780	78007
29162	47239	92	applied	\N	\N	\N	\N	144802	144802	78191
29162	47250	93	applied	\N	\N	\N	\N	144825	144825	145781
29162	47262	94	applied	\N	\N	\N	\N	144857	144857	78013
29162	47271	95	applied	\N	\N	\N	\N	144889	144889	78192
29162	47282	96	applied	\N	\N	\N	\N	144916	144916	144700
29162	47292	97	applied	\N	\N	\N	\N	144937	144937	78037
29162	47302	98	applied	\N	\N	\N	\N	144956	144956	78193
29162	47312	99	applied	\N	\N	\N	\N	144981	144981	78666
29162	47320	100	applied	\N	\N	\N	\N	145002	145002	78043
29162	47331	101	applied	\N	\N	\N	\N	145024	145024	78047
29162	47345	102	applied	\N	\N	\N	\N	145056	145056	78667
29162	47357	104	applied	\N	\N	\N	\N	145081	145081	78668
29162	47362	105	applied	\N	\N	\N	\N	145089	145089	78053
29162	47375	106	applied	\N	\N	\N	\N	145118	145118	78669
29162	47388	107	applied	\N	\N	\N	\N	145147	145147	78670
29162	47395	108	applied	\N	\N	\N	\N	145161	145161	78059
29162	47409	109	applied	\N	\N	\N	\N	145190	145190	78671
29162	47416	110	applied	\N	\N	\N	\N	145206	145206	78672
29162	47424	111	applied	\N	\N	\N	\N	145223	145223	78065
29162	47435	112	applied	\N	\N	\N	\N	145260	145260	78073
29162	47444	113	applied	\N	\N	\N	\N	145288	145288	78731
29162	47454	114	applied	\N	\N	\N	\N	145306	145306	78194
29162	47467	115	applied	\N	\N	\N	\N	145334	145334	78075
29162	47169	116	applied	\N	\N	\N	\N	144646	144646	78195
29162	47170	117	applied	\N	\N	\N	\N	144647	144647	78734
29162	47173	118	applied	\N	\N	\N	\N	144655	144655	78083
29162	47175	119	applied	\N	\N	\N	\N	144660	144660	78197
29162	47178	120	applied	\N	\N	\N	\N	144664	144664	78092
29162	47182	121	applied	\N	\N	\N	\N	144670	144670	144724
29162	47184	122	applied	\N	\N	\N	\N	144677	144677	78199
29162	47187	123	applied	\N	\N	\N	\N	144687	144687	78106
29162	47193	124	applied	\N	\N	\N	\N	144701	144701	145783
29162	47194	125	applied	\N	\N	\N	\N	144702	144702	78114
29165	47639	0	applied	\N	\N	\N	\N	145786	145786	79701
29165	47640	1	applied	\N	\N	\N	\N	145787	145787	145788
29169	47641	0	applied	\N	\N	\N	\N	145793	145793	145794
29169	47642	1	applied	\N	\N	\N	\N	145795	145795	145796
29169	47643	2	applied	\N	\N	\N	\N	145797	145797	145798
29169	47644	3	applied	\N	\N	\N	\N	145799	145799	79722
29169	47645	4	applied	\N	\N	\N	\N	145800	145800	79733
29169	47646	5	applied	\N	\N	\N	\N	145803	145803	145804
29169	47647	6	applied	\N	\N	\N	\N	145805	145805	79737
29169	47648	7	applied	\N	\N	\N	\N	145806	145806	79739
29171	47641	0	applied	\N	\N	\N	\N	145793	145793	145794
29171	47642	1	applied	\N	\N	\N	\N	145795	145795	145796
29171	47643	2	applied	\N	\N	\N	\N	145797	145797	145798
29173	47649	0	applied	\N	\N	\N	\N	145812	145812	145813
29173	47650	1	applied	\N	\N	\N	\N	145814	145814	145815
29173	47651	2	applied	\N	\N	\N	\N	145816	145816	79743
29174	47649	0	applied	\N	\N	\N	\N	145812	145812	145813
29174	47650	1	applied	\N	\N	\N	\N	145814	145814	145815
29174	47651	2	applied	\N	\N	\N	\N	145816	145816	79743
29175	47652	0	applied	\N	\N	\N	\N	145820	145820	145821
29175	47653	1	applied	\N	\N	\N	\N	145822	145822	145823
29175	47654	2	applied	\N	\N	\N	\N	145824	145824	145825
29176	47655	0	applied	\N	\N	\N	\N	145828	145828	145829
29176	47656	1	applied	\N	\N	\N	\N	145830	145830	79766
29177	47657	0	applied	\N	\N	\N	\N	145832	145832	145833
29177	47658	1	applied	\N	\N	\N	\N	145834	145834	145835
29177	47659	2	applied	\N	\N	\N	\N	145836	145836	79770
29182	47258	0	applied	\N	\N	\N	\N	144849	144849	144849
29182	47367	1	applied	\N	\N	\N	\N	145102	145102	145102
29182	47457	2	applied	\N	\N	\N	\N	145313	145313	138833
29182	47351	3	applied	\N	\N	\N	\N	145072	145072	144624
29182	47261	4	applied	\N	\N	\N	\N	144854	144854	144855
29182	47223	5	applied	\N	\N	1000000000	\N	144758	144758	144759
29195	47680	0	applied	\N	\N	\N	\N	145901	145901	145902
29195	47681	1	applied	\N	\N	\N	\N	145903	145903	145904
29195	47682	2	applied	\N	\N	\N	\N	145905	145905	79849
29195	47683	3	applied	\N	\N	\N	\N	145906	145906	79838
29195	47684	4	applied	\N	\N	\N	\N	145907	145907	79853
29198	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29198	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29198	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29198	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29198	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29198	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29198	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29198	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29201	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29201	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29201	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29201	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29201	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29201	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29201	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29201	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29204	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29204	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29204	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29204	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29204	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29204	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29204	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29204	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29218	47711	0	applied	\N	\N	\N	\N	146024	146024	146025
29218	47712	1	applied	\N	\N	\N	\N	146026	146026	146027
29220	47713	0	applied	\N	\N	\N	\N	146031	146031	146032
29220	47715	1	applied	\N	\N	\N	\N	146036	146036	79964
29220	47714	2	applied	\N	\N	\N	\N	146033	146033	79968
29222	47716	0	applied	\N	\N	\N	\N	146037	146037	146038
29222	47717	1	applied	\N	\N	\N	\N	146039	146039	146040
29224	47716	0	applied	\N	\N	\N	\N	146037	146037	146038
29224	47717	1	applied	\N	\N	\N	\N	146039	146039	146040
29224	47718	2	applied	\N	\N	\N	\N	146042	146042	79974
29226	47719	0	applied	\N	\N	\N	\N	146045	146045	146046
29226	47720	1	applied	\N	\N	\N	\N	146047	146047	79988
29226	47721	2	applied	\N	\N	\N	\N	146048	146048	146049
29233	47734	0	applied	\N	\N	\N	\N	146080	146080	146081
29233	47735	1	applied	\N	\N	\N	\N	146082	146082	146083
29233	47736	2	applied	\N	\N	\N	\N	146084	146084	80079
29233	47737	3	applied	\N	\N	\N	\N	146085	146085	146086
29233	47738	4	applied	\N	\N	\N	\N	146087	146087	80083
29233	47739	5	applied	\N	\N	\N	\N	146088	146088	80480
29235	47747	0	applied	\N	\N	\N	\N	146103	146103	146104
29235	47748	1	applied	\N	\N	\N	\N	146105	146105	146106
29235	47749	2	applied	\N	\N	\N	\N	146107	146107	80487
29235	47750	3	applied	\N	\N	\N	\N	146108	146108	146109
29242	47756	0	applied	\N	\N	\N	\N	146126	146126	146127
29242	47757	1	applied	\N	\N	\N	\N	146128	146128	80358
29242	47758	2	applied	\N	\N	\N	\N	146129	146129	80488
29248	47768	0	applied	\N	\N	\N	\N	146149	146149	146150
29248	47769	1	applied	\N	\N	\N	\N	146151	146151	80178
29248	47770	2	applied	\N	\N	\N	\N	146152	146152	80495
29248	47771	3	applied	\N	\N	\N	\N	146153	146153	80497
29252	47774	0	applied	\N	\N	\N	\N	146164	146164	146165
29252	47775	1	applied	\N	\N	\N	\N	146166	146166	80364
29252	47776	2	applied	\N	\N	\N	\N	146167	146167	146168
29255	47781	0	applied	\N	\N	\N	\N	146176	146176	146177
29255	47783	1	applied	\N	\N	\N	\N	146180	146180	80369
29257	47784	0	applied	\N	\N	\N	\N	146184	146184	146185
29257	47782	1	applied	\N	\N	\N	\N	146178	146178	80225
29257	47785	2	applied	\N	\N	\N	\N	146186	146186	146187
29261	47792	0	applied	\N	\N	\N	\N	146205	146205	146206
29261	47793	1	applied	\N	\N	\N	\N	146207	146207	146208
29261	47794	2	applied	\N	\N	\N	\N	146209	146209	146210
29261	47795	3	applied	\N	\N	\N	\N	146211	146211	80267
29265	47808	0	applied	\N	\N	\N	\N	146237	146237	146238
29265	47809	1	applied	\N	\N	\N	\N	146239	146239	80507
29265	47810	2	applied	\N	\N	\N	\N	146240	146240	80376
29265	47811	3	applied	\N	\N	\N	\N	146241	146241	80509
29267	47812	0	applied	\N	\N	\N	\N	146246	146246	146247
29267	47813	1	applied	\N	\N	\N	\N	146248	146248	146249
29267	47814	2	applied	\N	\N	\N	\N	146250	146250	146251
29267	47815	3	applied	\N	\N	\N	\N	146252	146252	80343
29267	47816	4	applied	\N	\N	\N	\N	146253	146253	146254
29267	47817	5	applied	\N	\N	\N	\N	146255	146255	80352
29270	47818	0	applied	\N	\N	\N	\N	146261	146261	146262
29270	47819	1	applied	\N	\N	\N	\N	146263	146263	146264
29270	47820	2	applied	\N	\N	\N	\N	146265	146265	146266
29270	47821	3	applied	\N	\N	\N	\N	146267	146267	146268
29270	47822	4	applied	\N	\N	\N	\N	146269	146269	146270
29270	47823	5	applied	\N	\N	\N	\N	146271	146271	80382
29270	47824	6	applied	\N	\N	\N	\N	146272	146272	146273
29270	47825	7	applied	\N	\N	\N	\N	146274	146274	146275
29270	47826	8	applied	\N	\N	\N	\N	146276	146276	80402
29270	47827	9	applied	\N	\N	\N	\N	146277	146277	80426
29270	47828	10	applied	\N	\N	\N	\N	146278	146278	80445
29270	47829	11	applied	\N	\N	\N	\N	146279	146279	80515
29272	47818	0	applied	\N	\N	\N	\N	146261	146261	146262
29272	47819	1	applied	\N	\N	\N	\N	146263	146263	146264
29272	47820	2	applied	\N	\N	\N	\N	146265	146265	146266
29272	47821	3	applied	\N	\N	\N	\N	146267	146267	146268
29272	47822	4	applied	\N	\N	\N	\N	146269	146269	146270
29272	47823	5	applied	\N	\N	\N	\N	146271	146271	80382
29272	47824	6	applied	\N	\N	\N	\N	146272	146272	146273
29272	47825	7	applied	\N	\N	\N	\N	146274	146274	146275
29272	47826	8	applied	\N	\N	\N	\N	146276	146276	80402
29272	47827	9	applied	\N	\N	\N	\N	146277	146277	80426
29272	47828	10	applied	\N	\N	\N	\N	146278	146278	80445
29272	47829	11	applied	\N	\N	\N	\N	146279	146279	80515
29274	47327	0	applied	\N	\N	\N	\N	145018	145018	29193
29274	47367	1	applied	\N	\N	\N	\N	145102	145102	145102
29274	47457	2	applied	\N	\N	\N	\N	145313	145313	138833
29274	47793	3	applied	\N	\N	\N	\N	146207	146207	146208
29274	47351	4	applied	\N	\N	\N	\N	145072	145072	144758
29274	47303	5	applied	\N	\N	\N	\N	144960	144960	144961
29178	47657	0	applied	\N	\N	\N	\N	145832	145832	145833
29178	47658	1	applied	\N	\N	\N	\N	145834	145834	145835
29178	47659	2	applied	\N	\N	\N	\N	145836	145836	79770
29181	47660	0	applied	\N	\N	\N	\N	145840	145840	145841
29181	47661	1	applied	\N	\N	\N	\N	145842	145842	145843
29181	47662	2	applied	\N	\N	\N	\N	145844	145844	145845
29184	47610	0	applied	\N	\N	\N	\N	145700	145700	145701
29184	47611	1	applied	\N	\N	\N	\N	145702	145702	145703
29184	47616	2	applied	\N	\N	\N	\N	145713	145713	145714
29184	47617	3	applied	\N	\N	\N	\N	145715	145715	145716
29184	47621	4	applied	\N	\N	\N	\N	145723	145723	145724
29184	47624	5	applied	\N	\N	\N	\N	145730	145730	145731
29184	47627	6	applied	\N	\N	\N	\N	145736	145736	145737
29184	47628	7	applied	\N	\N	\N	\N	145738	145738	145739
29184	47629	8	applied	\N	\N	\N	\N	145740	145740	145741
29184	47635	9	applied	\N	\N	\N	\N	145755	145755	145756
29184	47641	10	applied	\N	\N	\N	\N	145793	145793	145794
29184	47642	11	applied	\N	\N	\N	\N	145795	145795	145796
29184	47643	12	applied	\N	\N	\N	\N	145797	145797	145798
29184	47649	13	applied	\N	\N	\N	\N	145812	145812	145813
29184	47652	14	applied	\N	\N	\N	\N	145820	145820	145821
29184	47655	15	applied	\N	\N	\N	\N	145828	145828	145829
29184	47657	16	applied	\N	\N	\N	\N	145832	145832	145833
29184	47660	17	applied	\N	\N	\N	\N	145840	145840	145841
29184	47612	18	applied	\N	\N	\N	\N	145704	145704	145705
29184	47613	19	applied	\N	\N	\N	\N	145706	145706	145707
29184	47614	20	applied	\N	\N	\N	\N	145708	145708	145709
29184	47620	21	applied	\N	\N	\N	\N	145720	145720	145718
29184	47623	22	applied	\N	\N	\N	\N	145727	145727	79632
29184	47625	23	applied	\N	\N	\N	\N	145732	145732	145726
29184	47630	24	applied	\N	\N	\N	\N	145742	145742	79650
29184	47632	25	applied	\N	\N	\N	\N	145746	145746	145733
29184	47638	26	applied	\N	\N	\N	\N	145768	145768	79661
29184	47639	27	applied	\N	\N	\N	\N	145786	145786	145745
29184	47644	28	applied	\N	\N	\N	\N	145799	145799	79671
29184	47645	29	applied	\N	\N	\N	\N	145800	145800	145750
29184	47615	30	applied	\N	\N	\N	\N	145710	145710	79685
29184	47618	31	applied	\N	\N	\N	\N	145717	145717	145767
29184	47619	32	applied	\N	\N	\N	\N	145719	145719	145856
29184	47622	33	applied	\N	\N	\N	\N	145725	145725	145769
29184	47626	34	applied	\N	\N	\N	\N	145734	145734	145857
29184	47631	35	applied	\N	\N	\N	\N	145744	145744	79701
29184	47633	36	applied	\N	\N	\N	\N	145747	145747	145788
29184	47634	37	applied	\N	\N	\N	\N	145749	145749	79715
29184	47651	38	applied	\N	\N	\N	\N	145816	145816	79731
29184	47636	39	applied	\N	\N	\N	\N	145757	145757	79733
29184	47637	40	applied	\N	\N	\N	\N	145766	145766	145804
29184	47640	41	applied	\N	\N	\N	\N	145787	145787	79737
29184	47646	42	applied	\N	\N	\N	\N	145803	145803	79739
29184	47647	43	applied	\N	\N	\N	\N	145805	145805	145815
29184	47648	44	applied	\N	\N	\N	\N	145806	145806	145858
29184	47650	45	applied	\N	\N	\N	\N	145814	145814	79743
29184	47653	46	applied	\N	\N	\N	\N	145822	145822	145823
29184	47658	47	applied	\N	\N	\N	\N	145834	145834	79766
29184	47662	48	applied	\N	\N	\N	\N	145844	145844	145835
29184	47654	49	applied	\N	\N	\N	\N	145824	145824	79770
29184	47656	50	applied	\N	\N	\N	\N	145830	145830	145843
29184	47659	51	applied	\N	\N	\N	\N	145836	145836	145859
29184	47661	52	applied	\N	\N	\N	\N	145842	145842	145845
29184	47664	53	applied	\N	\N	\N	\N	145853	145853	145854
29186	47665	0	applied	\N	\N	\N	\N	145861	145861	145862
29186	47666	1	applied	\N	\N	\N	\N	145863	145863	145864
29186	47667	2	applied	\N	\N	\N	\N	145865	145865	79782
29186	47668	3	applied	\N	\N	\N	\N	145866	145866	145867
29186	47669	4	applied	\N	\N	\N	\N	145868	145868	79793
29186	47670	5	applied	\N	\N	\N	\N	145869	145869	79801
29188	47671	0	applied	\N	\N	\N	\N	145875	145875	145876
29188	47672	1	applied	\N	\N	\N	\N	145877	145877	145878
29188	47673	2	applied	\N	\N	\N	\N	145879	145879	79809
29191	47676	0	applied	\N	\N	\N	\N	145887	145887	145888
29191	47677	1	applied	\N	\N	\N	\N	145889	145889	145890
29191	47678	2	applied	\N	\N	\N	\N	145891	145891	79823
29191	47679	3	applied	\N	\N	\N	\N	145892	145892	145893
29197	47685	0	applied	\N	\N	\N	\N	145912	145912	145913
29197	47686	1	applied	\N	\N	\N	\N	145914	145914	145915
29197	47687	2	applied	\N	\N	\N	\N	145916	145916	79855
29197	47688	3	applied	\N	\N	\N	\N	145917	145917	145918
29200	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29200	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29200	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29200	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29200	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29200	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29200	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29200	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29202	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29202	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29202	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29202	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29202	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29202	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29202	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29202	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29205	47697	0	applied	\N	\N	\N	\N	145943	145943	145944
29205	47698	1	applied	\N	\N	\N	\N	145945	145945	79880
29205	47699	2	applied	\N	\N	\N	\N	145946	145946	145947
29205	47695	3	applied	\N	\N	\N	\N	145933	145933	145948
29205	47696	4	applied	\N	\N	\N	\N	145935	145935	145949
29205	47700	5	applied	\N	\N	\N	\N	145950	145950	79910
29210	47701	0	applied	\N	\N	\N	\N	145995	145995	145996
29210	47702	1	applied	\N	\N	\N	\N	145997	145997	145998
29210	47703	2	applied	\N	\N	\N	\N	145999	145999	79927
29212	47704	0	applied	\N	\N	\N	\N	146007	146007	146008
29212	47705	1	applied	\N	\N	\N	\N	146009	146009	146010
29212	47706	2	applied	\N	\N	\N	\N	146011	146011	79931
29214	47707	0	applied	\N	\N	\N	\N	146014	146014	146015
29214	47708	1	applied	\N	\N	\N	\N	146016	146016	146010
29214	47709	2	applied	\N	\N	\N	\N	146017	146017	146018
29214	47705	3	applied	\N	\N	\N	\N	146009	146009	146019
29216	47710	0	applied	\N	\N	\N	\N	146022	146022	146023
29216	47711	1	applied	\N	\N	\N	\N	146024	146024	146025
29216	47712	2	applied	\N	\N	\N	\N	146026	146026	146027
29219	47713	0	applied	\N	\N	\N	\N	146031	146031	146032
29219	47714	1	applied	\N	\N	\N	\N	146033	146033	146034
29221	47713	0	applied	\N	\N	\N	\N	146031	146031	146032
29221	47715	1	applied	\N	\N	\N	\N	146036	146036	79964
29221	47714	2	applied	\N	\N	\N	\N	146033	146033	79968
29228	47722	0	applied	\N	\N	\N	\N	146053	146053	146054
29228	47723	1	applied	\N	\N	\N	\N	146055	146055	146056
29228	47724	2	applied	\N	\N	\N	\N	146057	146057	80012
29179	47660	0	applied	\N	\N	\N	\N	145840	145840	145841
29179	47661	1	applied	\N	\N	\N	\N	145842	145842	145843
29179	47662	2	applied	\N	\N	\N	\N	145844	145844	145845
29187	47665	0	applied	\N	\N	\N	\N	145861	145861	145862
29187	47666	1	applied	\N	\N	\N	\N	145863	145863	145864
29187	47667	2	applied	\N	\N	\N	\N	145865	145865	79782
29187	47668	3	applied	\N	\N	\N	\N	145866	145866	145867
29187	47669	4	applied	\N	\N	\N	\N	145868	145868	79793
29187	47670	5	applied	\N	\N	\N	\N	145869	145869	79801
29189	47674	0	applied	\N	\N	\N	\N	145882	145882	145883
29189	47675	1	applied	\N	\N	\N	\N	145884	145884	79811
29194	47680	0	applied	\N	\N	\N	\N	145901	145901	145902
29194	47681	1	applied	\N	\N	\N	\N	145903	145903	145904
29194	47682	2	applied	\N	\N	\N	\N	145905	145905	79849
29194	47683	3	applied	\N	\N	\N	\N	145906	145906	79838
29194	47684	4	applied	\N	\N	\N	\N	145907	145907	79853
29203	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29203	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29203	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29203	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29203	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29203	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29206	47697	0	applied	\N	\N	\N	\N	145943	145943	145944
29206	47698	1	applied	\N	\N	\N	\N	145945	145945	79880
29206	47699	2	applied	\N	\N	\N	\N	145946	145946	145947
29206	47695	3	applied	\N	\N	\N	\N	145933	145933	145948
29206	47696	4	applied	\N	\N	\N	\N	145935	145935	145949
29206	47700	5	applied	\N	\N	\N	\N	145950	145950	79910
29208	47550	0	applied	\N	\N	\N	\N	145564	145564	145565
29208	47551	1	applied	\N	\N	\N	\N	145566	145566	145567
29208	47554	2	applied	\N	\N	\N	\N	145573	145573	145574
29208	47555	3	applied	\N	\N	\N	\N	145575	145575	145576
29208	47562	4	applied	\N	\N	\N	\N	145591	145591	145592
29208	47563	5	applied	\N	\N	\N	\N	145593	145593	145594
29208	47564	6	applied	\N	\N	\N	\N	145595	145595	145596
29208	47572	7	applied	\N	\N	\N	\N	145609	145609	145610
29208	47574	8	applied	\N	\N	\N	\N	145616	145616	145617
29208	47575	9	applied	\N	\N	\N	\N	145618	145618	145619
29208	47581	10	applied	\N	\N	\N	\N	145629	145629	145630
29208	47583	11	applied	\N	\N	\N	\N	145633	145633	145634
29208	47584	12	applied	\N	\N	\N	\N	145635	145635	145636
29208	47589	13	applied	\N	\N	\N	\N	145648	145648	145649
29208	47592	14	applied	\N	\N	\N	\N	145659	145659	145660
29208	47593	15	applied	\N	\N	\N	\N	145661	145661	145662
29208	47594	16	applied	\N	\N	\N	\N	145663	145663	145664
29208	47601	17	applied	\N	\N	\N	\N	145678	145678	145679
29208	47604	18	applied	\N	\N	\N	\N	145685	145685	145686
29208	47606	19	applied	\N	\N	\N	\N	145690	145690	145691
29208	47610	20	applied	\N	\N	\N	\N	145700	145700	145701
29208	47611	21	applied	\N	\N	\N	\N	145702	145702	145703
29208	47616	22	applied	\N	\N	\N	\N	145713	145713	145714
29208	47617	23	applied	\N	\N	\N	\N	145715	145715	145716
29208	47621	24	applied	\N	\N	\N	\N	145723	145723	145724
29208	47624	25	applied	\N	\N	\N	\N	145730	145730	145731
29208	47627	26	applied	\N	\N	\N	\N	145736	145736	145737
29208	47628	27	applied	\N	\N	\N	\N	145738	145738	145739
29208	47629	28	applied	\N	\N	\N	\N	145740	145740	145741
29208	47635	29	applied	\N	\N	\N	\N	145755	145755	145756
29208	47641	30	applied	\N	\N	\N	\N	145793	145793	145794
29208	47642	31	applied	\N	\N	\N	\N	145795	145795	145796
29208	47643	32	applied	\N	\N	\N	\N	145797	145797	145798
29208	47649	33	applied	\N	\N	\N	\N	145812	145812	145813
29208	47652	34	applied	\N	\N	\N	\N	145820	145820	145821
29208	47655	35	applied	\N	\N	\N	\N	145828	145828	145829
29208	47657	36	applied	\N	\N	\N	\N	145832	145832	145833
29208	47660	37	applied	\N	\N	\N	\N	145840	145840	145841
29208	47663	38	applied	\N	\N	\N	\N	145851	145851	145852
29208	47665	39	applied	\N	\N	\N	\N	145861	145861	145862
29208	47666	40	applied	\N	\N	\N	\N	145863	145863	145864
29208	47671	41	applied	\N	\N	\N	\N	145875	145875	145876
29208	47674	42	applied	\N	\N	\N	\N	145882	145882	145883
29208	47676	43	applied	\N	\N	\N	\N	145887	145887	145888
29208	47680	44	applied	\N	\N	\N	\N	145901	145901	145902
29208	47681	45	applied	\N	\N	\N	\N	145903	145903	145904
29208	47685	46	applied	\N	\N	\N	\N	145912	145912	145913
29208	47689	47	applied	\N	\N	\N	\N	145921	145921	145922
29208	47690	48	applied	\N	\N	\N	\N	145923	145923	145924
29208	47691	49	applied	\N	\N	\N	\N	145925	145925	145926
29208	47697	50	applied	\N	\N	\N	\N	145943	145943	145944
29208	47556	51	applied	\N	\N	\N	\N	145577	145577	79408
29208	47557	52	applied	\N	\N	\N	\N	145579	145579	145578
29208	47558	53	applied	\N	\N	\N	\N	145581	145581	145580
29208	47559	54	applied	\N	\N	\N	\N	145583	145583	145959
29208	47566	55	applied	\N	\N	\N	\N	145598	145598	79429
29208	47576	56	applied	\N	\N	\N	\N	145620	145620	79431
29208	47586	57	applied	\N	\N	\N	\N	145638	145638	145582
29208	47597	58	applied	\N	\N	\N	\N	145667	145667	145584
29208	47607	59	applied	\N	\N	\N	\N	145692	145692	79437
29208	47678	60	applied	\N	\N	\N	\N	145891	145891	145586
29208	47687	61	applied	\N	\N	\N	\N	145916	145916	79439
29208	47699	62	applied	\N	\N	\N	\N	145946	145946	79449
29208	47569	63	applied	\N	\N	\N	\N	145603	145603	145960
29208	47570	64	applied	\N	\N	\N	\N	145605	145605	79455
29208	47571	65	applied	\N	\N	\N	\N	145606	145606	79463
29208	47579	66	applied	\N	\N	\N	\N	145624	145624	145961
29208	47580	67	applied	\N	\N	\N	\N	145626	145626	145962
29208	47587	68	applied	\N	\N	\N	\N	145640	145640	145622
29208	47588	69	applied	\N	\N	\N	\N	145642	145642	145963
29208	47591	70	applied	\N	\N	\N	\N	145651	145651	145964
29208	47598	71	applied	\N	\N	\N	\N	145669	145669	79523
29208	47599	72	applied	\N	\N	\N	\N	145670	145670	145965
29208	47603	73	applied	\N	\N	\N	\N	145681	145681	79537
29208	47608	74	applied	\N	\N	\N	\N	145694	145694	145966
29208	47612	75	applied	\N	\N	\N	\N	145704	145704	79548
29208	47613	76	applied	\N	\N	\N	\N	145706	145706	145967
29208	47620	77	applied	\N	\N	\N	\N	145720	145720	79559
29208	47623	78	applied	\N	\N	\N	\N	145727	145727	145968
29208	47625	79	applied	\N	\N	\N	\N	145732	145732	145673
29208	47630	80	applied	\N	\N	\N	\N	145742	145742	79585
29208	47632	81	applied	\N	\N	\N	\N	145746	145746	79593
29208	47638	82	applied	\N	\N	\N	\N	145768	145768	79604
29208	47639	84	applied	\N	\N	\N	\N	145786	145786	145970
29208	47644	85	applied	\N	\N	\N	\N	145799	145799	79610
29208	47645	86	applied	\N	\N	\N	\N	145800	145800	79620
29208	47651	87	applied	\N	\N	\N	\N	145816	145816	145971
29208	47552	88	applied	\N	\N	\N	\N	145568	145568	79624
29208	47553	89	applied	\N	\N	\N	\N	145570	145570	145972
29208	47560	90	applied	\N	\N	\N	\N	145585	145585	145973
29208	47561	91	applied	\N	\N	\N	\N	145587	145587	79634
29208	47565	92	applied	\N	\N	\N	\N	145597	145597	79648
29180	47660	0	applied	\N	\N	\N	\N	145840	145840	145841
29180	47661	1	applied	\N	\N	\N	\N	145842	145842	145843
29180	47662	2	applied	\N	\N	\N	\N	145844	145844	145845
29183	47663	0	applied	\N	\N	\N	\N	145851	145851	145852
29183	47664	1	applied	\N	\N	\N	\N	145853	145853	145854
29185	47665	0	applied	\N	\N	\N	\N	145861	145861	145862
29185	47666	1	applied	\N	\N	\N	\N	145863	145863	145864
29185	47667	2	applied	\N	\N	\N	\N	145865	145865	79782
29185	47668	3	applied	\N	\N	\N	\N	145866	145866	145867
29185	47669	4	applied	\N	\N	\N	\N	145868	145868	79793
29185	47670	5	applied	\N	\N	\N	\N	145869	145869	79801
29190	47676	0	applied	\N	\N	\N	\N	145887	145887	145888
29190	47677	1	applied	\N	\N	\N	\N	145889	145889	145890
29190	47678	2	applied	\N	\N	\N	\N	145891	145891	79823
29190	47679	3	applied	\N	\N	\N	\N	145892	145892	145893
29192	47676	0	applied	\N	\N	\N	\N	145887	145887	145888
29192	47677	1	applied	\N	\N	\N	\N	145889	145889	145890
29192	47678	2	applied	\N	\N	\N	\N	145891	145891	79823
29192	47679	3	applied	\N	\N	\N	\N	145892	145892	145893
29196	47680	0	applied	\N	\N	\N	\N	145901	145901	145902
29196	47681	1	applied	\N	\N	\N	\N	145903	145903	145904
29196	47684	2	applied	\N	\N	\N	\N	145907	145907	79838
29199	47689	0	applied	\N	\N	\N	\N	145921	145921	145922
29199	47690	1	applied	\N	\N	\N	\N	145923	145923	145924
29199	47691	2	applied	\N	\N	\N	\N	145925	145925	145926
29199	47692	3	applied	\N	\N	\N	\N	145927	145927	145928
29199	47693	4	applied	\N	\N	\N	\N	145929	145929	79870
29199	47694	5	applied	\N	\N	\N	\N	145930	145930	145931
29199	47695	7	applied	\N	\N	\N	\N	145933	145933	145934
29199	47696	8	applied	\N	\N	\N	\N	145935	145935	145936
29207	47697	0	applied	\N	\N	\N	\N	145943	145943	145944
29207	47698	1	applied	\N	\N	\N	\N	145945	145945	79880
29207	47699	2	applied	\N	\N	\N	\N	145946	145946	145947
29207	47695	3	applied	\N	\N	\N	\N	145933	145933	145948
29207	47696	4	applied	\N	\N	\N	\N	145935	145935	145949
29207	47700	5	applied	\N	\N	\N	\N	145950	145950	79910
29209	47701	0	applied	\N	\N	\N	\N	145995	145995	145996
29209	47702	1	applied	\N	\N	\N	\N	145997	145997	145998
29209	47703	2	applied	\N	\N	\N	\N	145999	145999	79927
29213	47704	0	applied	\N	\N	\N	\N	146007	146007	146008
29213	47706	1	applied	\N	\N	\N	\N	146011	146011	146013
29215	47707	0	applied	\N	\N	\N	\N	146014	146014	146015
29215	47708	1	applied	\N	\N	\N	\N	146016	146016	146010
29215	47709	2	applied	\N	\N	\N	\N	146017	146017	146018
29215	47705	3	applied	\N	\N	\N	\N	146009	146009	146019
29217	47710	0	applied	\N	\N	\N	\N	146022	146022	146023
29217	47711	1	applied	\N	\N	\N	\N	146024	146024	146025
29217	47712	2	applied	\N	\N	\N	\N	146026	146026	146027
29229	47722	0	applied	\N	\N	\N	\N	146053	146053	146054
29229	47723	1	applied	\N	\N	\N	\N	146055	146055	146056
29229	47724	2	applied	\N	\N	\N	\N	146057	146057	80012
29229	47725	3	applied	\N	\N	\N	\N	146058	146058	146059
29229	47726	4	applied	\N	\N	\N	\N	146060	146060	146061
29231	47727	0	applied	\N	\N	\N	\N	146065	146065	146066
29231	47728	1	applied	\N	\N	\N	\N	146067	146067	80030
29231	47729	2	applied	\N	\N	\N	\N	146068	146068	80038
29231	47730	3	applied	\N	\N	\N	\N	146069	146069	146070
29236	47747	0	applied	\N	\N	\N	\N	146103	146103	146104
29236	47748	1	applied	\N	\N	\N	\N	146105	146105	146106
29236	47749	2	applied	\N	\N	\N	\N	146107	146107	80487
29236	47750	3	applied	\N	\N	\N	\N	146108	146108	146109
29240	47751	0	applied	\N	\N	\N	\N	146116	146116	146117
29240	47752	1	applied	\N	\N	\N	\N	146118	146118	80123
29243	47756	0	applied	\N	\N	\N	\N	146126	146126	146127
29243	47757	1	applied	\N	\N	\N	\N	146128	146128	80358
29243	47758	2	applied	\N	\N	\N	\N	146129	146129	80488
29245	47759	0	applied	\N	\N	\N	\N	146135	146135	146136
29245	47760	1	applied	\N	\N	\N	\N	146137	146137	80360
29245	47761	2	applied	\N	\N	\N	\N	146138	146138	80489
29259	47786	0	applied	\N	\N	\N	\N	146192	146192	146193
29259	47787	1	applied	\N	\N	\N	\N	146194	146194	80231
29259	47788	2	applied	\N	\N	\N	\N	146195	146195	146196
29263	47796	0	applied	\N	\N	\N	\N	146214	146214	146215
29263	47797	1	applied	\N	\N	\N	\N	146216	146216	146217
29263	47798	2	applied	\N	\N	\N	\N	146218	146218	146219
29263	47799	3	applied	\N	\N	\N	\N	146220	146220	146221
29263	47800	4	applied	\N	\N	\N	\N	146222	146222	80505
29263	47801	5	applied	\N	\N	\N	\N	146223	146223	80373
29263	47802	6	applied	\N	\N	\N	\N	146224	146224	146225
29263	47803	7	applied	\N	\N	\N	\N	146226	146226	80375
29263	47804	8	applied	\N	\N	\N	\N	146227	146227	80299
29263	47805	9	applied	\N	\N	\N	\N	146228	146228	146229
29263	47806	10	applied	\N	\N	\N	\N	146230	146230	80309
29263	47807	11	applied	\N	\N	\N	\N	146231	146231	146232
29268	47812	0	applied	\N	\N	\N	\N	146246	146246	146247
29268	47813	1	applied	\N	\N	\N	\N	146248	146248	146249
29268	47814	2	applied	\N	\N	\N	\N	146250	146250	146251
29268	47815	3	applied	\N	\N	\N	\N	146252	146252	80343
29273	47830	0	applied	\N	\N	\N	\N	146286	146286	146287
29273	47831	1	applied	\N	\N	\N	\N	146288	146288	146289
29273	47832	2	applied	\N	\N	\N	\N	146290	146290	80461
29273	47833	3	applied	\N	\N	\N	\N	146291	146291	80463
29273	47834	4	applied	\N	\N	\N	\N	146292	146292	146293
29273	47835	5	applied	\N	\N	\N	\N	146294	146294	80467
29276	47836	0	applied	\N	\N	\N	\N	146300	146300	146301
29276	47837	1	applied	\N	\N	\N	\N	146302	146302	146303
29276	47838	2	applied	\N	\N	\N	\N	146304	146304	80471
29282	47852	0	applied	\N	\N	\N	\N	146345	146345	146346
29282	47853	1	applied	\N	\N	\N	\N	146347	146347	146348
29282	47854	2	applied	\N	\N	\N	\N	146349	146349	80599
29286	47855	0	applied	\N	\N	\N	\N	146357	146357	146358
29286	47856	1	applied	\N	\N	\N	\N	146359	146359	80578
29286	47857	2	applied	\N	\N	\N	\N	146360	146360	80586
29288	47855	0	applied	\N	\N	\N	\N	146357	146357	146358
29288	47856	1	applied	\N	\N	\N	\N	146359	146359	80578
29288	47857	2	applied	\N	\N	\N	\N	146360	146360	80586
29290	47865	0	applied	\N	\N	\N	\N	146379	146379	146380
29290	47866	1	applied	\N	\N	\N	\N	146381	146381	146382
29292	47867	0	applied	\N	\N	\N	\N	146385	146385	146386
29292	47868	2	applied	\N	\N	\N	\N	146388	146388	146389
29292	47869	3	applied	\N	\N	\N	\N	146390	146390	146391
29294	47867	0	applied	\N	\N	\N	\N	146385	146385	146386
29294	47868	2	applied	\N	\N	\N	\N	146388	146388	146389
29294	47869	3	applied	\N	\N	\N	\N	146390	146390	146391
29296	47870	0	applied	\N	\N	\N	\N	146402	146402	146403
29296	47871	1	applied	\N	\N	\N	\N	146404	146404	146405
29296	47872	2	applied	\N	\N	\N	\N	146406	146406	146407
29296	47873	3	applied	\N	\N	\N	\N	146408	146408	146409
29299	47877	0	applied	\N	\N	\N	\N	146419	146419	146420
29299	47878	1	applied	\N	\N	\N	\N	146421	146421	146422
29208	47567	93	applied	\N	\N	\N	\N	145600	145600	145974
29208	47568	94	applied	\N	\N	\N	\N	145601	145601	145975
29208	47573	95	applied	\N	\N	\N	\N	145611	145611	79652
29208	47577	96	applied	\N	\N	\N	\N	145621	145621	79654
29208	47578	97	applied	\N	\N	\N	\N	145623	145623	145976
29208	47582	98	applied	\N	\N	\N	\N	145631	145631	145977
29208	47585	99	applied	\N	\N	\N	\N	145637	145637	79663
29208	47590	100	applied	\N	\N	\N	\N	145650	145650	79669
29208	47595	101	applied	\N	\N	\N	\N	145665	145665	145978
29208	47596	102	applied	\N	\N	\N	\N	145666	145666	79681
29208	47600	103	applied	\N	\N	\N	\N	145672	145672	79683
29208	47602	104	applied	\N	\N	\N	\N	145680	145680	145979
29208	47605	105	applied	\N	\N	\N	\N	145687	145687	145980
29208	47609	106	applied	\N	\N	\N	\N	145696	145696	79691
29208	47614	107	applied	\N	\N	\N	\N	145708	145708	79693
29208	47615	108	applied	\N	\N	\N	\N	145710	145710	79699
29208	47618	109	applied	\N	\N	\N	\N	145717	145717	145981
29208	47619	110	applied	\N	\N	\N	\N	145719	145719	145982
29208	47622	111	applied	\N	\N	\N	\N	145725	145725	79713
29208	47626	112	applied	\N	\N	\N	\N	145734	145734	145983
29208	47631	113	applied	\N	\N	\N	\N	145744	145744	145984
29208	47633	114	applied	\N	\N	\N	\N	145747	145747	145985
29208	47634	115	applied	\N	\N	\N	\N	145749	145749	79735
29208	47636	116	applied	\N	\N	\N	\N	145757	145757	145986
29208	47637	117	applied	\N	\N	\N	\N	145766	145766	145987
29208	47640	118	applied	\N	\N	\N	\N	145787	145787	145988
29208	47646	119	applied	\N	\N	\N	\N	145803	145803	79741
29208	47647	120	applied	\N	\N	\N	\N	145805	145805	145989
29208	47648	121	applied	\N	\N	\N	\N	145806	145806	145990
29208	47650	122	applied	\N	\N	\N	\N	145814	145814	79751
29208	47653	123	applied	\N	\N	\N	\N	145822	145822	145991
29208	47658	124	applied	\N	\N	\N	\N	145834	145834	79768
29208	47662	125	applied	\N	\N	\N	\N	145844	145844	145992
29211	47701	0	applied	\N	\N	\N	\N	145995	145995	145996
29211	47702	1	applied	\N	\N	\N	\N	145997	145997	145998
29211	47703	2	applied	\N	\N	\N	\N	145999	145999	79927
29223	47716	0	applied	\N	\N	\N	\N	146037	146037	146038
29223	47717	1	applied	\N	\N	\N	\N	146039	146039	146040
29223	47718	2	applied	\N	\N	\N	\N	146042	146042	79974
29225	47719	0	applied	\N	\N	\N	\N	146045	146045	146046
29225	47720	1	applied	\N	\N	\N	\N	146047	146047	79988
29225	47721	2	applied	\N	\N	\N	\N	146048	146048	146049
29227	47719	0	applied	\N	\N	\N	\N	146045	146045	146046
29227	47720	1	applied	\N	\N	\N	\N	146047	146047	79988
29227	47721	2	applied	\N	\N	\N	\N	146048	146048	146049
29232	47731	0	applied	\N	\N	\N	\N	146075	146075	146076
29232	47732	1	applied	\N	\N	\N	\N	146077	146077	146078
29232	47733	2	applied	\N	\N	\N	\N	146079	146079	80059
29238	47747	0	applied	\N	\N	\N	\N	146103	146103	146104
29238	47748	1	applied	\N	\N	\N	\N	146105	146105	146106
29238	47749	2	applied	\N	\N	\N	\N	146107	146107	80487
29238	47750	3	applied	\N	\N	\N	\N	146108	146108	146109
29244	47756	0	applied	\N	\N	\N	\N	146126	146126	146127
29244	47757	1	applied	\N	\N	\N	\N	146128	146128	80358
29244	47758	2	applied	\N	\N	\N	\N	146129	146129	80488
29247	47768	0	applied	\N	\N	\N	\N	146149	146149	146150
29247	47769	1	applied	\N	\N	\N	\N	146151	146151	80178
29247	47770	2	applied	\N	\N	\N	\N	146152	146152	80495
29247	47771	3	applied	\N	\N	\N	\N	146153	146153	80497
29249	47768	0	applied	\N	\N	\N	\N	146149	146149	146150
29249	47770	1	applied	\N	\N	\N	\N	146152	146152	80494
29249	47771	2	applied	\N	\N	\N	\N	146153	146153	80180
29251	47772	0	applied	\N	\N	\N	\N	146159	146159	146160
29251	47773	1	applied	\N	\N	\N	\N	146161	146161	80193
29254	47781	0	applied	\N	\N	\N	\N	146176	146176	146177
29254	47782	1	applied	\N	\N	\N	\N	146178	146178	146179
29254	47783	2	applied	\N	\N	\N	\N	146180	146180	80225
29256	47784	0	applied	\N	\N	\N	\N	146184	146184	146185
29256	47782	1	applied	\N	\N	\N	\N	146178	146178	80225
29256	47785	2	applied	\N	\N	\N	\N	146186	146186	146187
29258	47786	0	applied	\N	\N	\N	\N	146192	146192	146193
29258	47787	1	applied	\N	\N	\N	\N	146194	146194	80231
29258	47788	2	applied	\N	\N	\N	\N	146195	146195	146196
29262	47796	0	applied	\N	\N	\N	\N	146214	146214	146215
29262	47797	1	applied	\N	\N	\N	\N	146216	146216	146217
29262	47798	2	applied	\N	\N	\N	\N	146218	146218	146219
29262	47799	3	applied	\N	\N	\N	\N	146220	146220	146221
29262	47800	4	applied	\N	\N	\N	\N	146222	146222	80505
29262	47801	5	applied	\N	\N	\N	\N	146223	146223	80373
29262	47802	6	applied	\N	\N	\N	\N	146224	146224	146225
29262	47803	7	applied	\N	\N	\N	\N	146226	146226	80375
29262	47804	8	applied	\N	\N	\N	\N	146227	146227	80299
29262	47805	9	applied	\N	\N	\N	\N	146228	146228	146229
29262	47806	10	applied	\N	\N	\N	\N	146230	146230	80309
29262	47807	11	applied	\N	\N	\N	\N	146231	146231	146232
29271	47793	0	applied	\N	\N	\N	\N	146207	146207	146208
29271	47641	1	applied	\N	\N	\N	\N	145793	145793	145794
29271	47642	2	applied	\N	\N	\N	\N	145795	145795	145796
29271	47643	3	applied	\N	\N	\N	\N	145797	145797	145798
29271	47649	4	applied	\N	\N	\N	\N	145812	145812	145813
29271	47652	5	applied	\N	\N	\N	\N	145820	145820	145821
29271	47655	6	applied	\N	\N	\N	\N	145828	145828	145829
29271	47657	7	applied	\N	\N	\N	\N	145832	145832	145833
29271	47660	8	applied	\N	\N	\N	\N	145840	145840	145841
29271	47663	9	applied	\N	\N	\N	\N	145851	145851	145852
29271	47665	10	applied	\N	\N	\N	\N	145861	145861	145862
29271	47666	11	applied	\N	\N	\N	\N	145863	145863	145864
29271	47671	12	applied	\N	\N	\N	\N	145875	145875	145876
29271	47674	13	applied	\N	\N	\N	\N	145882	145882	145883
29271	47676	14	applied	\N	\N	\N	\N	145887	145887	145888
29271	47680	15	applied	\N	\N	\N	\N	145901	145901	145902
29271	47681	16	applied	\N	\N	\N	\N	145903	145903	145904
29271	47685	17	applied	\N	\N	\N	\N	145912	145912	145913
29271	47689	18	applied	\N	\N	\N	\N	145921	145921	145922
29271	47690	19	applied	\N	\N	\N	\N	145923	145923	145924
29275	47836	0	applied	\N	\N	\N	\N	146300	146300	146301
29275	47837	1	applied	\N	\N	\N	\N	146302	146302	146303
29275	47838	2	applied	\N	\N	\N	\N	146304	146304	80471
29280	47845	0	applied	\N	\N	\N	\N	146333	146333	146334
29280	47846	1	applied	\N	\N	\N	\N	146335	146335	146336
29280	47847	2	applied	\N	\N	1000000000	\N	146337	146337	146338
29280	47848	3	applied	\N	\N	\N	\N	146339	146339	80559
29280	47849	4	applied	\N	\N	\N	\N	146340	146340	80595
29280	47850	5	applied	\N	\N	\N	\N	146341	146341	146342
29280	47851	6	applied	\N	\N	\N	\N	146343	146343	80598
29283	47852	0	applied	\N	\N	\N	\N	146345	146345	146346
29283	47853	1	applied	\N	\N	\N	\N	146347	146347	146348
29283	47854	2	applied	\N	\N	\N	\N	146349	146349	80599
29285	47852	0	applied	\N	\N	\N	\N	146345	146345	146346
29285	47853	1	applied	\N	\N	\N	\N	146347	146347	146348
29228	47725	3	applied	\N	\N	\N	\N	146058	146058	146059
29228	47726	4	applied	\N	\N	\N	\N	146060	146060	146061
29230	47727	0	applied	\N	\N	\N	\N	146065	146065	146066
29230	47728	1	applied	\N	\N	\N	\N	146067	146067	80030
29230	47729	2	applied	\N	\N	\N	\N	146068	146068	80038
29230	47730	3	applied	\N	\N	\N	\N	146069	146069	146070
29234	47740	0	applied	\N	\N	\N	\N	146091	146091	146092
29234	47741	1	applied	\N	\N	\N	\N	146093	146093	146094
29234	47742	2	applied	\N	\N	\N	\N	146095	146095	146096
29234	47743	3	applied	\N	\N	\N	\N	146097	146097	80087
29234	47744	4	applied	\N	\N	\N	\N	146098	146098	80483
29234	47745	5	applied	\N	\N	\N	\N	146099	146099	80091
29234	47746	6	applied	\N	\N	\N	\N	146100	146100	80486
29237	47747	0	applied	\N	\N	\N	\N	146103	146103	146104
29237	47748	1	applied	\N	\N	\N	\N	146105	146105	146106
29237	47749	2	applied	\N	\N	\N	\N	146107	146107	80487
29237	47750	3	applied	\N	\N	\N	\N	146108	146108	146109
29239	47747	0	applied	\N	\N	\N	\N	146103	146103	146104
29239	47748	1	applied	\N	\N	\N	\N	146105	146105	146106
29239	47749	2	applied	\N	\N	\N	\N	146107	146107	80487
29239	47750	3	applied	\N	\N	\N	\N	146108	146108	146109
29241	47753	0	applied	\N	\N	\N	\N	146121	146121	146122
29241	47754	1	applied	\N	\N	\N	\N	146123	146123	80356
29241	47755	2	applied	\N	\N	\N	\N	146124	146124	80133
29246	47762	0	applied	\N	\N	\N	\N	146139	146139	146140
29246	47763	1	applied	\N	\N	\N	\N	146141	146141	146142
29246	47764	2	applied	\N	\N	\N	\N	146143	146143	80155
29246	47765	3	applied	\N	\N	\N	\N	146144	146144	80165
29246	47766	4	applied	\N	\N	\N	\N	146145	146145	146146
29246	47767	5	applied	\N	\N	\N	\N	146147	146147	80493
29250	47772	0	applied	\N	\N	\N	\N	146159	146159	146160
29250	47773	1	applied	\N	\N	\N	\N	146161	146161	80193
29253	47777	0	applied	\N	\N	\N	\N	146170	146170	146171
29253	47778	1	applied	\N	\N	\N	\N	146172	146172	80206
29253	47779	2	applied	\N	\N	\N	\N	146173	146173	146174
29253	47780	3	applied	\N	\N	\N	\N	146175	146175	80213
29260	47789	0	applied	\N	\N	\N	\N	146200	146200	80502
29260	47790	1	applied	\N	\N	\N	\N	146201	146201	80259
29260	47791	2	applied	\N	\N	\N	\N	146202	146202	80503
29264	47796	0	applied	\N	\N	\N	\N	146214	146214	146215
29264	47797	1	applied	\N	\N	\N	\N	146216	146216	146217
29264	47798	2	applied	\N	\N	\N	\N	146218	146218	146219
29264	47799	3	applied	\N	\N	\N	\N	146220	146220	146221
29264	47800	4	applied	\N	\N	\N	\N	146222	146222	80505
29264	47801	5	applied	\N	\N	\N	\N	146223	146223	80373
29264	47802	6	applied	\N	\N	\N	\N	146224	146224	146225
29264	47803	7	applied	\N	\N	\N	\N	146226	146226	80375
29264	47804	8	applied	\N	\N	\N	\N	146227	146227	80299
29264	47805	9	applied	\N	\N	\N	\N	146228	146228	146229
29264	47806	10	applied	\N	\N	\N	\N	146230	146230	80309
29264	47807	11	applied	\N	\N	\N	\N	146231	146231	146232
29266	47367	0	applied	\N	\N	\N	\N	145102	145102	145102
29266	47457	1	applied	\N	\N	\N	\N	145313	145313	138833
29266	47793	2	applied	\N	\N	\N	\N	146207	146207	146208
29266	47351	3	applied	\N	\N	\N	\N	145072	145072	144758
29266	47742	4	applied	\N	\N	\N	\N	146095	146095	146096
29269	47812	0	applied	\N	\N	\N	\N	146246	146246	146247
29269	47813	1	applied	\N	\N	\N	\N	146248	146248	146249
29269	47814	2	applied	\N	\N	\N	\N	146250	146250	146251
29269	47815	3	applied	\N	\N	\N	\N	146252	146252	80343
29269	47816	4	applied	\N	\N	\N	\N	146253	146253	146254
29269	47817	5	applied	\N	\N	\N	\N	146255	146255	80352
29279	47839	0	applied	\N	\N	\N	\N	146322	146322	146323
29279	47840	1	applied	\N	\N	\N	\N	146324	146324	146325
29279	47841	2	applied	\N	\N	\N	\N	146326	146326	146327
29279	47842	3	applied	\N	\N	\N	\N	146328	146328	80524
29279	47843	4	applied	\N	\N	\N	\N	146329	146329	146330
29279	47844	5	applied	\N	\N	\N	\N	146331	146331	80593
29281	47852	0	applied	\N	\N	\N	\N	146345	146345	146346
29281	47853	1	applied	\N	\N	\N	\N	146347	146347	146348
29281	47854	2	applied	\N	\N	\N	\N	146349	146349	80599
29287	47855	0	applied	\N	\N	\N	\N	146357	146357	146358
29287	47856	1	applied	\N	\N	\N	\N	146359	146359	80578
29287	47857	2	applied	\N	\N	\N	\N	146360	146360	80586
29293	47867	0	applied	\N	\N	\N	\N	146385	146385	146386
29293	47868	2	applied	\N	\N	\N	\N	146388	146388	146389
29293	47869	3	applied	\N	\N	\N	\N	146390	146390	146391
29295	47867	0	applied	\N	\N	\N	\N	146385	146385	146386
29295	47868	2	applied	\N	\N	\N	\N	146388	146388	146389
29295	47869	3	applied	\N	\N	\N	\N	146390	146390	146391
29297	47874	0	applied	\N	\N	\N	\N	146411	146411	146412
29297	47875	1	applied	\N	\N	\N	\N	146413	146413	146414
29297	47876	2	applied	\N	\N	\N	\N	146415	146415	146416
29300	47877	0	applied	\N	\N	\N	\N	146419	146419	146420
29300	47878	1	applied	\N	\N	\N	\N	146421	146421	146422
29300	47879	2	applied	\N	\N	\N	\N	146423	146423	80666
29300	47880	3	applied	\N	\N	\N	\N	146424	146424	80686
29300	47881	4	applied	\N	\N	\N	\N	146425	146425	146426
29303	47882	0	applied	\N	\N	\N	\N	146432	146432	146433
29303	47883	1	applied	\N	\N	\N	\N	146434	146434	146435
29303	47884	2	applied	\N	\N	\N	\N	146436	146436	146437
29303	47885	3	applied	\N	\N	\N	\N	146438	146438	80693
29310	47896	0	applied	\N	\N	\N	\N	146464	146464	146465
29310	47897	1	applied	\N	\N	\N	\N	146466	146466	146467
29310	47898	2	applied	\N	\N	\N	\N	146468	146468	146469
29317	47911	0	applied	\N	\N	\N	\N	146501	146501	146502
29317	47912	1	applied	\N	\N	\N	\N	146503	146503	146504
29317	47913	2	applied	\N	\N	\N	\N	146505	146505	146506
29317	47914	3	applied	\N	\N	\N	\N	146507	146507	146508
29321	47918	0	applied	\N	\N	\N	\N	146520	146520	146521
29321	47917	1	applied	\N	\N	\N	\N	146517	146517	146518
29321	47919	2	applied	\N	\N	\N	\N	146522	146522	80817
29324	47924	0	applied	\N	\N	\N	\N	146534	146534	146535
29324	47925	1	applied	\N	\N	\N	\N	146536	146536	146537
29324	47926	2	applied	\N	\N	\N	\N	146538	146538	80837
29326	47927	0	applied	\N	\N	\N	\N	146545	146545	146546
29326	47928	1	applied	\N	\N	\N	\N	146547	146547	146548
29330	47936	0	applied	\N	\N	\N	\N	146566	146566	146567
29330	47937	1	applied	\N	\N	\N	\N	146568	146568	146569
29330	47938	2	applied	\N	\N	1000000000	\N	146570	146570	146571
29330	47939	3	applied	\N	\N	1000000000	\N	146572	146572	146573
29330	47940	4	applied	\N	\N	\N	\N	146574	146574	146575
29333	47941	0	applied	\N	\N	\N	\N	146584	146584	146585
29333	47942	1	applied	\N	\N	\N	\N	146586	146586	146587
29333	47943	2	applied	\N	\N	\N	\N	146588	146588	146589
29337	47948	0	applied	\N	\N	\N	\N	146605	146605	146606
29337	47949	1	applied	\N	\N	\N	\N	146607	146607	146608
29337	47950	2	applied	\N	\N	\N	\N	146609	146609	146610
29337	47951	4	applied	\N	\N	\N	\N	146612	146612	80910
29274	47306	6	applied	\N	\N	\N	\N	144967	144967	144968
29274	47307	7	applied	\N	\N	\N	\N	144969	144969	144970
29274	47311	8	applied	\N	\N	\N	\N	144979	144979	144980
29274	47315	9	applied	\N	\N	\N	\N	144992	144992	144993
29274	47318	10	applied	\N	\N	\N	\N	144998	144998	144999
29274	47319	11	applied	\N	\N	\N	\N	145000	145000	145001
29274	47324	12	applied	\N	\N	\N	\N	145012	145012	145013
29274	47328	13	applied	\N	\N	\N	\N	145019	145019	145020
29274	47329	14	applied	\N	\N	\N	\N	145021	145021	145022
29274	47334	15	applied	\N	\N	\N	\N	145031	145031	145032
29274	47337	16	applied	\N	\N	\N	\N	145037	145037	145038
29274	47340	17	applied	\N	\N	\N	\N	145045	145045	145046
29274	47342	18	applied	\N	\N	\N	\N	145052	145052	145053
29274	47346	19	applied	\N	\N	\N	\N	145061	145061	145062
29274	47347	20	applied	\N	\N	\N	\N	145063	145063	145064
29274	47352	21	applied	\N	\N	\N	\N	145073	145073	145074
29274	47353	22	applied	\N	\N	\N	\N	145075	145075	145076
29274	47358	23	applied	\N	\N	\N	\N	145083	145083	145084
29274	47359	24	applied	\N	\N	\N	\N	145085	145085	145086
29274	47364	25	applied	\N	\N	\N	\N	145095	145095	145096
29274	47368	26	applied	\N	\N	\N	\N	145103	145103	145104
29274	47371	27	applied	\N	\N	\N	\N	145111	145111	145112
29274	47373	28	applied	\N	\N	\N	\N	145115	145115	145116
29274	47377	29	applied	\N	\N	\N	\N	145124	145124	145125
29274	47380	30	applied	\N	\N	\N	\N	145130	145130	145131
29274	47383	31	applied	\N	\N	\N	\N	145137	145137	145138
29274	47384	32	applied	\N	\N	\N	\N	145139	145139	145140
29274	47389	33	applied	\N	\N	\N	\N	145151	145151	145152
29274	47392	34	applied	\N	\N	\N	\N	145156	145156	145157
29274	47393	35	applied	\N	\N	\N	\N	145158	145158	145159
29274	47398	36	applied	\N	\N	\N	\N	145169	145169	145170
29274	47401	37	applied	\N	\N	\N	\N	145177	145177	145178
29274	47404	38	applied	\N	\N	\N	\N	145183	145183	145184
29274	47405	39	applied	\N	\N	\N	\N	145185	145185	145186
29274	47410	40	applied	\N	\N	\N	\N	145194	145194	145195
29274	47413	41	applied	\N	\N	\N	\N	145200	145200	145201
29274	47414	42	applied	\N	\N	\N	\N	145202	145202	145203
29274	47415	43	applied	\N	\N	\N	\N	145204	145204	145205
29274	47422	44	applied	\N	\N	\N	\N	145219	145219	145220
29274	47426	45	applied	\N	\N	\N	\N	145232	145232	145233
29274	47428	46	applied	\N	\N	\N	\N	145236	145236	145237
29274	47431	47	applied	\N	\N	\N	\N	145241	145241	145242
29274	47434	48	applied	\N	\N	\N	\N	145258	145258	145259
29274	47438	49	applied	\N	\N	\N	\N	145271	145271	145272
29274	47440	50	applied	\N	\N	\N	\N	145277	145277	145278
29274	47443	51	applied	\N	\N	\N	\N	145286	145286	145287
29274	47447	52	applied	\N	\N	\N	\N	145293	145293	145294
29274	47449	53	applied	\N	\N	\N	\N	145298	145298	145299
29274	47452	54	applied	\N	\N	\N	\N	145303	145303	145304
29274	47456	55	applied	\N	\N	\N	\N	145311	145311	145312
29274	47458	56	applied	\N	\N	\N	\N	145314	145314	145315
29274	47462	57	applied	\N	\N	\N	\N	145322	145322	145323
29274	47465	58	applied	\N	\N	\N	\N	145330	145330	145331
29274	47469	59	applied	\N	\N	\N	\N	145346	145346	145347
29274	47471	60	applied	\N	\N	\N	\N	145352	145352	145353
29274	47472	61	applied	\N	\N	\N	\N	145354	145354	145355
29274	47473	62	applied	\N	\N	\N	\N	145356	145356	145357
29274	47481	63	applied	\N	\N	\N	\N	145372	145372	145373
29274	47483	65	applied	\N	\N	\N	\N	145395	145395	145396
29274	47487	66	applied	\N	\N	\N	\N	145404	145404	145405
29274	47490	67	applied	\N	\N	\N	\N	145412	145412	145413
29274	47491	68	applied	\N	\N	\N	\N	145414	145414	145415
29274	47495	69	applied	\N	\N	\N	\N	145423	145423	145424
29274	47499	70	applied	\N	\N	\N	\N	145433	145433	145434
29274	47502	71	applied	\N	\N	\N	\N	145439	145439	145440
29274	47503	72	applied	\N	\N	\N	\N	145441	145441	145442
29274	47508	73	applied	\N	\N	\N	\N	145451	145451	145452
29274	47509	74	applied	\N	\N	\N	\N	145453	145453	145454
29274	47510	75	applied	\N	\N	\N	\N	145455	145455	145456
29274	47516	76	applied	\N	\N	\N	\N	145485	145485	145486
29274	47520	77	applied	\N	\N	\N	\N	145493	145493	145494
29274	47521	78	applied	\N	\N	\N	\N	145495	145495	145496
29274	47525	79	applied	\N	\N	\N	\N	145502	145502	145503
29274	47529	80	applied	\N	\N	\N	\N	145514	145514	145515
29274	47532	81	applied	\N	\N	\N	\N	145521	145521	145522
29274	47533	82	applied	\N	\N	\N	\N	145523	145523	145524
29274	47538	83	applied	\N	\N	\N	\N	145540	145540	145541
29274	47539	84	applied	\N	\N	\N	\N	145542	145542	145543
29274	47540	85	applied	\N	\N	\N	\N	145544	145544	145545
29274	47541	86	applied	\N	\N	\N	\N	145546	145546	145547
29274	47550	87	applied	\N	\N	\N	\N	145564	145564	145565
29274	47551	88	applied	\N	\N	\N	\N	145566	145566	145567
29274	47554	89	applied	\N	\N	\N	\N	145573	145573	145574
29274	47555	90	applied	\N	\N	\N	\N	145575	145575	145576
29274	47562	91	applied	\N	\N	\N	\N	145591	145591	145592
29274	47563	92	applied	\N	\N	\N	\N	145593	145593	145594
29274	47564	93	applied	\N	\N	\N	\N	145595	145595	145596
29274	47572	94	applied	\N	\N	\N	\N	145609	145609	145610
29274	47574	95	applied	\N	\N	\N	\N	145616	145616	145617
29274	47575	96	applied	\N	\N	\N	\N	145618	145618	145619
29274	47581	97	applied	\N	\N	\N	\N	145629	145629	145630
29274	47583	98	applied	\N	\N	\N	\N	145633	145633	145634
29274	47584	99	applied	\N	\N	\N	\N	145635	145635	145636
29274	47589	100	applied	\N	\N	\N	\N	145648	145648	145649
29274	47592	101	applied	\N	\N	\N	\N	145659	145659	145660
29274	47593	102	applied	\N	\N	\N	\N	145661	145661	145662
29274	47594	103	applied	\N	\N	\N	\N	145663	145663	145664
29274	47601	104	applied	\N	\N	\N	\N	145678	145678	145679
29274	47604	105	applied	\N	\N	\N	\N	145685	145685	145686
29274	47606	106	applied	\N	\N	\N	\N	145690	145690	145691
29274	47610	107	applied	\N	\N	\N	\N	145700	145700	145701
29274	47611	108	applied	\N	\N	\N	\N	145702	145702	145703
29274	47616	109	applied	\N	\N	\N	\N	145713	145713	145714
29274	47617	110	applied	\N	\N	\N	\N	145715	145715	145716
29274	47621	111	applied	\N	\N	\N	\N	145723	145723	145724
29274	47624	112	applied	\N	\N	\N	\N	145730	145730	145731
29274	47627	113	applied	\N	\N	\N	\N	145736	145736	145737
29274	47628	114	applied	\N	\N	\N	\N	145738	145738	145739
29274	47629	115	applied	\N	\N	\N	\N	145740	145740	145741
29274	47635	116	applied	\N	\N	\N	\N	145755	145755	145756
29274	47641	117	applied	\N	\N	\N	\N	145793	145793	145794
29274	47642	118	applied	\N	\N	\N	\N	145795	145795	145796
29274	47643	119	applied	\N	\N	\N	\N	145797	145797	145798
29274	47649	120	applied	\N	\N	\N	\N	145812	145812	145813
29274	47652	121	applied	\N	\N	\N	\N	145820	145820	145821
29274	47655	122	applied	\N	\N	\N	\N	145828	145828	145829
29274	47657	123	applied	\N	\N	\N	\N	145832	145832	145833
29274	47660	124	applied	\N	\N	\N	\N	145840	145840	145841
29274	47663	125	applied	\N	\N	\N	\N	145851	145851	145852
29277	47836	0	applied	\N	\N	\N	\N	146300	146300	146301
29277	47837	1	applied	\N	\N	\N	\N	146302	146302	146303
29277	47838	2	applied	\N	\N	\N	\N	146304	146304	80471
29278	47731	0	applied	\N	\N	\N	\N	146075	146075	146076
29278	47793	1	applied	\N	\N	\N	\N	146207	146207	146208
29278	47734	2	applied	\N	\N	\N	\N	146080	146080	146081
29278	47735	3	applied	\N	\N	\N	\N	146082	146082	146083
29278	47740	4	applied	\N	\N	\N	\N	146091	146091	146092
29278	47741	5	applied	\N	\N	\N	\N	146093	146093	146094
29278	47747	6	applied	\N	\N	\N	\N	146103	146103	146104
29278	47751	7	applied	\N	\N	\N	\N	146116	146116	146117
29278	47753	8	applied	\N	\N	\N	\N	146121	146121	146122
29278	47756	9	applied	\N	\N	\N	\N	146126	146126	146127
29278	47759	10	applied	\N	\N	\N	\N	146135	146135	146136
29278	47762	11	applied	\N	\N	\N	\N	146139	146139	146140
29278	47763	12	applied	\N	\N	\N	\N	146141	146141	146142
29278	47768	13	applied	\N	\N	\N	\N	146149	146149	146150
29278	47772	14	applied	\N	\N	\N	\N	146159	146159	146160
29278	47774	15	applied	\N	\N	\N	\N	146164	146164	146165
29278	47777	16	applied	\N	\N	\N	\N	146170	146170	146171
29278	47781	17	applied	\N	\N	\N	\N	146176	146176	146177
29278	47784	18	applied	\N	\N	\N	\N	146184	146184	146185
29278	47786	19	applied	\N	\N	\N	\N	146192	146192	146193
29278	47792	20	applied	\N	\N	\N	\N	146205	146205	146206
29278	47794	21	applied	\N	\N	\N	\N	146209	146209	146210
29278	47796	22	applied	\N	\N	\N	\N	146214	146214	146215
29278	47797	23	applied	\N	\N	\N	\N	146216	146216	146217
29278	47798	24	applied	\N	\N	\N	\N	146218	146218	146219
29278	47799	25	applied	\N	\N	\N	\N	146220	146220	146221
29278	47808	26	applied	\N	\N	\N	\N	146237	146237	146238
29278	47812	27	applied	\N	\N	\N	\N	146246	146246	146247
29278	47813	28	applied	\N	\N	\N	\N	146248	146248	146249
29278	47818	29	applied	\N	\N	\N	\N	146261	146261	146262
29278	47819	30	applied	\N	\N	\N	\N	146263	146263	146264
29278	47820	31	applied	\N	\N	\N	\N	146265	146265	146266
29278	47821	32	applied	\N	\N	\N	\N	146267	146267	146268
29278	47830	33	applied	\N	\N	\N	\N	146286	146286	146287
29278	47831	34	applied	\N	\N	\N	\N	146288	146288	146289
29278	47836	35	applied	\N	\N	\N	\N	146300	146300	146301
29278	47732	36	applied	\N	\N	\N	\N	146077	146077	146078
29278	47736	37	applied	\N	\N	\N	\N	146084	146084	80057
29278	47748	38	applied	\N	\N	\N	\N	146105	146105	80059
29278	47733	39	applied	\N	\N	\N	\N	146079	146079	80478
29278	47737	40	applied	\N	\N	\N	\N	146085	146085	80081
29278	47738	41	applied	\N	\N	\N	\N	146087	146087	80085
29278	47742	42	applied	\N	\N	\N	\N	146095	146095	146096
29278	47739	43	applied	\N	\N	\N	\N	146088	146088	80481
29278	47743	44	applied	\N	\N	\N	\N	146097	146097	80482
29278	47744	45	applied	\N	\N	\N	\N	146098	146098	80089
29278	47749	46	applied	\N	\N	\N	\N	146107	146107	146311
29278	47752	47	applied	\N	\N	\N	\N	146118	146118	80485
29278	47754	48	applied	\N	\N	\N	\N	146123	146123	80093
29278	47757	49	applied	\N	\N	\N	\N	146128	146128	146106
29278	47760	50	applied	\N	\N	\N	\N	146137	146137	80487
29278	47745	51	applied	\N	\N	\N	\N	146099	146099	146109
29278	47746	52	applied	\N	\N	\N	\N	146100	146100	80356
29278	47750	53	applied	\N	\N	\N	\N	146108	146108	80133
29278	47755	54	applied	\N	\N	\N	\N	146124	146124	80139
29278	47758	55	applied	\N	\N	\N	\N	146129	146129	80360
29278	47764	56	applied	\N	\N	\N	\N	146143	146143	80490
29278	47765	57	applied	\N	\N	\N	\N	146144	146144	80163
29278	47771	58	applied	\N	\N	\N	\N	146153	146153	80167
29278	47766	59	applied	\N	\N	\N	\N	146145	146145	80494
29278	47767	60	applied	\N	\N	\N	\N	146147	146147	80495
29278	47769	61	applied	\N	\N	\N	\N	146151	146151	80180
29278	47773	62	applied	\N	\N	\N	\N	146161	146161	80497
29278	47775	63	applied	\N	\N	\N	\N	146166	146166	80193
29278	47779	64	applied	\N	\N	\N	\N	146173	146173	80364
29278	47782	65	applied	\N	\N	\N	\N	146178	146178	80202
29278	47785	66	applied	\N	\N	\N	\N	146186	146186	146168
29278	47787	67	applied	\N	\N	\N	\N	146194	146194	80366
29278	47790	68	applied	\N	\N	\N	\N	146201	146201	80206
29278	47795	70	applied	\N	\N	\N	\N	146211	146211	146174
29278	47803	71	applied	\N	\N	\N	\N	146226	146226	80368
29278	47804	72	applied	\N	\N	\N	\N	146227	146227	80223
29278	47805	73	applied	\N	\N	\N	\N	146228	146228	146313
29278	47806	74	applied	\N	\N	\N	\N	146230	146230	80227
29278	47761	75	applied	\N	\N	\N	\N	146138	146138	146187
29278	47770	76	applied	\N	\N	\N	\N	146152	146152	80499
29278	47780	77	applied	\N	\N	\N	\N	146175	146175	80231
29278	47791	78	applied	\N	\N	\N	\N	146202	146202	146314
29278	47807	79	applied	\N	\N	\N	\N	146231	146231	80500
29278	47809	80	applied	\N	\N	\N	\N	146239	146239	80241
29278	47823	81	applied	\N	\N	\N	\N	146271	146271	146196
29278	47833	82	applied	\N	\N	\N	\N	146291	146291	80501
29278	47776	83	applied	\N	\N	\N	\N	146167	146167	80257
29278	47778	84	applied	\N	\N	\N	\N	146172	146172	80267
29278	47783	85	applied	\N	\N	\N	\N	146180	146180	80505
29278	47788	86	applied	\N	\N	\N	\N	146195	146195	80373
29278	47789	87	applied	\N	\N	\N	\N	146200	146200	146225
29278	47800	88	applied	\N	\N	\N	\N	146222	146222	80299
29278	47801	89	applied	\N	\N	\N	\N	146223	146223	80309
29278	47802	90	applied	\N	\N	\N	\N	146224	146224	80321
29278	47810	91	applied	\N	\N	\N	\N	146240	146240	80509
29278	47814	92	applied	\N	\N	\N	\N	146250	146250	146251
29278	47815	93	applied	\N	\N	\N	\N	146252	146252	80343
29278	47827	94	applied	\N	\N	\N	\N	146277	146277	80352
29278	47828	95	applied	\N	\N	\N	\N	146278	146278	146315
29278	47829	96	applied	\N	\N	\N	\N	146279	146279	146316
29278	47834	97	applied	\N	\N	\N	\N	146292	146292	80512
29278	47837	98	applied	\N	\N	\N	\N	146302	146302	80440
29278	47811	99	applied	\N	\N	\N	\N	146241	146241	80514
29278	47816	100	applied	\N	\N	\N	\N	146253	146253	80447
29278	47817	101	applied	\N	\N	\N	\N	146255	146255	146317
29278	47822	102	applied	\N	\N	\N	\N	146269	146269	80463
29278	47824	103	applied	\N	\N	\N	\N	146272	146272	146318
29278	47825	104	applied	\N	\N	\N	\N	146274	146274	146293
29278	47826	105	applied	\N	\N	\N	\N	146276	146276	80467
29278	47832	106	applied	\N	\N	\N	\N	146290	146290	146319
29278	47835	107	applied	\N	\N	\N	\N	146294	146294	146303
29278	47838	108	applied	\N	\N	\N	\N	146304	146304	80471
29284	47852	0	applied	\N	\N	\N	\N	146345	146345	146346
29284	47853	1	applied	\N	\N	\N	\N	146347	146347	146348
29284	47854	2	applied	\N	\N	\N	\N	146349	146349	80599
29291	47865	0	applied	\N	\N	\N	\N	146379	146379	146380
29291	47866	1	applied	\N	\N	\N	\N	146381	146381	146382
29298	47877	0	applied	\N	\N	\N	\N	146419	146419	146420
29298	47878	1	applied	\N	\N	\N	\N	146421	146421	146422
29298	47879	2	applied	\N	\N	\N	\N	146423	146423	80666
29298	47880	3	applied	\N	\N	\N	\N	146424	146424	80686
29298	47881	4	applied	\N	\N	\N	\N	146425	146425	146426
29285	47854	2	applied	\N	\N	\N	\N	146349	146349	80599
29289	47858	0	applied	\N	\N	\N	\N	146365	146365	146366
29289	47859	1	applied	\N	\N	\N	\N	146367	146367	146368
29289	47860	2	applied	\N	\N	\N	\N	146369	146369	146370
29289	47861	3	applied	\N	\N	\N	\N	146371	146371	146372
29289	47862	4	applied	\N	\N	\N	\N	146373	146373	80620
29289	47863	5	applied	\N	\N	\N	\N	146374	146374	146375
29289	47864	6	applied	\N	\N	\N	\N	146376	146376	80624
29304	47886	0	applied	\N	\N	\N	\N	146439	146439	146440
29304	47887	1	applied	\N	\N	\N	\N	146441	146441	146442
29304	47888	2	applied	\N	\N	\N	\N	146443	146443	146444
29304	47889	3	applied	\N	\N	\N	\N	146445	146445	80703
29304	47890	4	applied	\N	\N	\N	\N	146446	146446	146447
29306	47891	0	applied	\N	\N	\N	\N	146450	146450	146451
29306	47892	1	applied	\N	\N	\N	\N	146452	146452	80714
29306	47893	2	applied	\N	\N	\N	\N	146453	146453	146454
29306	47894	3	applied	\N	\N	\N	\N	146455	146455	146456
29311	47899	0	applied	\N	\N	\N	\N	146474	146474	146475
29311	47900	1	applied	\N	\N	\N	\N	146476	146476	146477
29311	47901	2	applied	\N	\N	\N	\N	146478	146478	80740
29311	47902	3	applied	\N	\N	\N	\N	146479	146479	80746
29311	47903	4	applied	\N	\N	\N	\N	146480	146480	146481
29311	47904	5	applied	\N	\N	\N	\N	146482	146482	80759
29311	47905	6	applied	\N	\N	\N	\N	146483	146483	146484
29318	47915	0	applied	\N	\N	\N	\N	146511	146511	146512
29318	47916	1	applied	\N	\N	\N	\N	146513	146513	146514
29320	47918	0	applied	\N	\N	\N	\N	146520	146520	146521
29320	47917	1	applied	\N	\N	\N	\N	146517	146517	146518
29320	47919	2	applied	\N	\N	\N	\N	146522	146522	80817
29323	47924	0	applied	\N	\N	\N	\N	146534	146534	146535
29323	47925	1	applied	\N	\N	\N	\N	146536	146536	146537
29323	47926	2	applied	\N	\N	\N	\N	146538	146538	80837
29325	47924	0	applied	\N	\N	\N	\N	146534	146534	146535
29325	47925	1	applied	\N	\N	\N	\N	146536	146536	146537
29325	47926	2	applied	\N	\N	\N	\N	146538	146538	80837
29336	47944	0	applied	\N	\N	\N	\N	146593	146593	146594
29336	47945	1	applied	\N	\N	\N	\N	146595	146595	146596
29336	47946	2	applied	\N	\N	\N	\N	146597	146597	146598
29336	47947	3	applied	\N	\N	\N	\N	146599	146599	146600
29339	47954	0	applied	\N	\N	\N	\N	146619	146619	146620
29339	47955	1	applied	\N	\N	\N	\N	146621	146621	146622
29339	47956	2	applied	\N	\N	\N	\N	146623	146623	146624
29339	47957	3	applied	\N	\N	\N	\N	146625	146625	146626
29341	47961	0	applied	\N	\N	\N	\N	146637	146637	146638
29341	47962	1	applied	\N	\N	\N	\N	146639	146639	146640
29341	47963	2	applied	\N	\N	\N	\N	146641	146641	146642
29344	47964	0	applied	\N	\N	\N	\N	146645	146645	146646
29344	47965	1	applied	\N	\N	\N	\N	146647	146647	146648
29344	47966	2	applied	\N	\N	\N	\N	146649	146649	146650
29344	47967	3	applied	\N	\N	\N	\N	146651	146651	146652
29344	47968	4	applied	\N	\N	\N	\N	146653	146653	80983
29344	47969	5	applied	\N	\N	\N	\N	146654	146654	80993
29345	47970	0	applied	\N	\N	\N	\N	146661	146661	146662
29345	47971	1	applied	\N	\N	\N	\N	146663	146663	146664
29345	47972	2	applied	\N	\N	\N	\N	146665	146665	81001
29347	47973	0	applied	\N	\N	\N	\N	146666	146666	146667
29347	47974	1	applied	\N	\N	\N	\N	146668	146668	81019
29347	47975	2	applied	\N	\N	\N	\N	146669	146669	146670
29353	47991	0	applied	\N	\N	\N	\N	146708	146708	146709
29353	47992	1	applied	\N	\N	\N	\N	146710	146710	146711
29353	47993	2	applied	\N	\N	\N	\N	146712	146712	81072
29355	47994	0	applied	\N	\N	\N	\N	146717	146717	146718
29355	47995	1	applied	\N	\N	\N	\N	146719	146719	146720
29355	47996	2	applied	\N	\N	\N	\N	146721	146721	81080
29355	47997	3	applied	\N	\N	\N	\N	146722	146722	81084
29358	47998	0	applied	\N	\N	\N	\N	146726	146726	146727
29358	47999	1	applied	\N	\N	\N	\N	146728	146728	146729
29364	48006	0	applied	\N	\N	\N	\N	146749	146749	146750
29364	48007	1	applied	\N	\N	\N	\N	146751	146751	146752
29364	48008	2	applied	\N	\N	\N	\N	146753	146753	81128
29367	48012	0	applied	\N	\N	\N	\N	146763	146763	146764
29367	48013	1	applied	\N	\N	\N	\N	146765	146765	146766
29367	48014	2	applied	\N	\N	\N	\N	146767	146767	81140
29377	48032	0	applied	\N	\N	\N	\N	146810	146810	146811
29377	48033	1	applied	\N	\N	\N	\N	146812	146812	146813
29377	48034	2	applied	\N	\N	\N	\N	146814	146814	146815
29377	48035	3	applied	\N	\N	\N	\N	146816	146816	81206
29377	48036	4	applied	\N	\N	\N	\N	146817	146817	81226
29377	48037	5	applied	\N	\N	\N	\N	146818	146818	81241
29377	48038	6	applied	\N	\N	\N	\N	146819	146819	81276
29377	48039	7	applied	\N	\N	\N	\N	146820	146820	81329
29377	48040	8	applied	\N	\N	\N	\N	146821	146821	81389
29379	48041	0	applied	\N	\N	\N	\N	146826	146826	146827
29379	48042	1	applied	\N	\N	\N	\N	146828	146828	81462
29379	48043	2	applied	\N	\N	\N	\N	146829	146829	81488
29382	48050	0	applied	\N	\N	\N	\N	146843	146843	146844
29382	48051	1	applied	\N	\N	\N	\N	146845	146845	81658
29382	48052	2	applied	\N	\N	\N	\N	146846	146846	81730
29389	48074	0	applied	\N	\N	\N	\N	146886	146886	146887
29389	48075	1	applied	\N	\N	\N	\N	146888	146888	146889
29389	48076	2	applied	\N	\N	\N	\N	146890	146890	82375
29389	48077	3	applied	\N	\N	\N	\N	146891	146891	82192
29393	48082	0	applied	\N	\N	\N	\N	146915	146915	146916
29393	48083	1	applied	\N	\N	\N	\N	146917	146917	82377
29395	48084	0	applied	\N	\N	\N	\N	146921	146921	146922
29395	48085	1	applied	\N	\N	\N	\N	146923	146923	83273
29395	48086	2	applied	\N	\N	\N	\N	146924	146924	82378
29395	48087	3	applied	\N	\N	\N	\N	146925	146925	146926
29395	48088	4	applied	\N	\N	\N	\N	146927	146927	82219
29400	48095	0	applied	\N	\N	\N	\N	146947	146947	146948
29400	48096	1	applied	\N	\N	\N	\N	146949	146949	146950
29400	48097	2	applied	\N	\N	\N	\N	146951	146951	82251
29400	48098	3	applied	\N	\N	\N	\N	146952	146952	82253
29400	48099	4	applied	\N	\N	\N	\N	146953	146953	82384
29400	48100	5	applied	\N	\N	\N	\N	146954	146954	83279
29402	48105	0	applied	\N	\N	\N	\N	146965	146965	146966
29402	48106	1	applied	\N	\N	\N	\N	146967	146967	82387
29404	48105	0	applied	\N	\N	\N	\N	146965	146965	146966
29404	48107	1	applied	\N	\N	\N	\N	146971	146971	146972
29404	48108	2	applied	\N	\N	\N	\N	146973	146973	82277
29404	48109	3	applied	\N	\N	\N	\N	146974	146974	146975
29404	48110	4	applied	\N	\N	\N	\N	146976	146976	82284
29406	48105	0	applied	\N	\N	\N	\N	146965	146965	146966
29406	48107	1	applied	\N	\N	\N	\N	146971	146971	146972
29406	48108	2	applied	\N	\N	\N	\N	146973	146973	82277
29406	48109	3	applied	\N	\N	\N	\N	146974	146974	146975
29406	48110	4	applied	\N	\N	\N	\N	146976	146976	82284
29415	48127	0	applied	\N	\N	\N	\N	147016	147016	147021
29415	48128	1	applied	\N	\N	\N	\N	147022	147022	147023
29415	48129	2	applied	\N	\N	\N	\N	147024	147024	147025
29299	47879	2	applied	\N	\N	\N	\N	146423	146423	80666
29299	47880	3	applied	\N	\N	\N	\N	146424	146424	80686
29299	47881	4	applied	\N	\N	\N	\N	146425	146425	146426
29302	47877	0	applied	\N	\N	\N	\N	146419	146419	146420
29302	47878	1	applied	\N	\N	\N	\N	146421	146421	146422
29302	47879	2	applied	\N	\N	\N	\N	146423	146423	80666
29302	47880	3	applied	\N	\N	\N	\N	146424	146424	80686
29302	47881	4	applied	\N	\N	\N	\N	146425	146425	146426
29305	47891	0	applied	\N	\N	\N	\N	146450	146450	146451
29305	47892	1	applied	\N	\N	\N	\N	146452	146452	80714
29305	47893	2	applied	\N	\N	\N	\N	146453	146453	146454
29305	47894	3	applied	\N	\N	\N	\N	146455	146455	146456
29307	47895	0	applied	\N	\N	\N	\N	146459	146459	146460
29309	47896	0	applied	\N	\N	\N	\N	146464	146464	146465
29309	47897	1	applied	\N	\N	\N	\N	146466	146466	146467
29309	47898	2	applied	\N	\N	\N	\N	146468	146468	146469
29315	47908	0	applied	\N	\N	\N	\N	146493	146493	146494
29315	47909	1	applied	\N	\N	\N	\N	146495	146495	80777
29315	47910	2	applied	\N	\N	\N	\N	146496	146496	146497
29322	47920	0	applied	\N	\N	\N	\N	146525	146525	146526
29322	47921	1	applied	\N	\N	\N	\N	146527	146527	146528
29322	47922	2	applied	\N	\N	\N	\N	146529	146529	80819
29322	47923	3	applied	\N	\N	\N	\N	146530	146530	146531
29327	47927	0	applied	\N	\N	\N	\N	146545	146545	146546
29327	47928	1	applied	\N	\N	\N	\N	146547	146547	146548
29329	47929	0	applied	\N	\N	\N	\N	146551	146551	146552
29329	47930	1	applied	\N	\N	\N	\N	146553	146553	146554
29329	47931	2	applied	\N	\N	\N	\N	146555	146555	80851
29329	47932	3	applied	\N	\N	\N	\N	146556	146556	146557
29329	47933	4	applied	\N	\N	\N	\N	146558	146558	146559
29329	47934	5	applied	\N	\N	\N	\N	146560	146560	146561
29329	47935	6	applied	\N	\N	\N	\N	146562	146562	146563
29331	47665	0	applied	\N	\N	\N	\N	145861	145861	145862
29331	47666	1	applied	\N	\N	\N	\N	145863	145863	145864
29331	47671	2	applied	\N	\N	\N	\N	145875	145875	145876
29331	47674	3	applied	\N	\N	\N	\N	145882	145882	145883
29331	47676	4	applied	\N	\N	\N	\N	145887	145887	145888
29331	47680	5	applied	\N	\N	\N	\N	145901	145901	145902
29331	47681	6	applied	\N	\N	\N	\N	145903	145903	145904
29331	47685	7	applied	\N	\N	\N	\N	145912	145912	145913
29331	47689	8	applied	\N	\N	\N	\N	145921	145921	145922
29331	47690	9	applied	\N	\N	\N	\N	145923	145923	145924
29331	47691	10	applied	\N	\N	\N	\N	145925	145925	145926
29331	47697	11	applied	\N	\N	\N	\N	145943	145943	145944
29331	47701	12	applied	\N	\N	\N	\N	145995	145995	145996
29331	47704	13	applied	\N	\N	\N	\N	146007	146007	146008
29331	47707	14	applied	\N	\N	\N	\N	146014	146014	146015
29331	47710	15	applied	\N	\N	\N	\N	146022	146022	146023
29331	47713	16	applied	\N	\N	\N	\N	146031	146031	146032
29331	47716	17	applied	\N	\N	\N	\N	146037	146037	146038
29331	47719	18	applied	\N	\N	\N	\N	146045	146045	146046
29331	47722	19	applied	\N	\N	\N	\N	146053	146053	146054
29331	47723	20	applied	\N	\N	\N	\N	146055	146055	146056
29331	47727	21	applied	\N	\N	\N	\N	146065	146065	146066
29331	47731	22	applied	\N	\N	\N	\N	146075	146075	146076
29331	47734	23	applied	\N	\N	\N	\N	146080	146080	146081
29331	47735	24	applied	\N	\N	\N	\N	146082	146082	146083
29331	47740	25	applied	\N	\N	\N	\N	146091	146091	146092
29331	47741	26	applied	\N	\N	\N	\N	146093	146093	146094
29331	47747	27	applied	\N	\N	\N	\N	146103	146103	146104
29331	47751	28	applied	\N	\N	\N	\N	146116	146116	146117
29331	47753	29	applied	\N	\N	\N	\N	146121	146121	146122
29331	47756	30	applied	\N	\N	\N	\N	146126	146126	146127
29331	47759	31	applied	\N	\N	\N	\N	146135	146135	146136
29331	47762	32	applied	\N	\N	\N	\N	146139	146139	146140
29331	47763	33	applied	\N	\N	\N	\N	146141	146141	146142
29331	47768	34	applied	\N	\N	\N	\N	146149	146149	146150
29331	47772	35	applied	\N	\N	\N	\N	146159	146159	146160
29331	47774	36	applied	\N	\N	\N	\N	146164	146164	146165
29331	47777	37	applied	\N	\N	\N	\N	146170	146170	146171
29331	47781	38	applied	\N	\N	\N	\N	146176	146176	146177
29331	47784	39	applied	\N	\N	\N	\N	146184	146184	146185
29331	47786	40	applied	\N	\N	\N	\N	146192	146192	146193
29331	47792	41	applied	\N	\N	\N	\N	146205	146205	146206
29331	47794	42	applied	\N	\N	\N	\N	146209	146209	146210
29331	47796	43	applied	\N	\N	\N	\N	146214	146214	146215
29331	47797	44	applied	\N	\N	\N	\N	146216	146216	146217
29331	47798	45	applied	\N	\N	\N	\N	146218	146218	146219
29331	47799	46	applied	\N	\N	\N	\N	146220	146220	146221
29331	47808	47	applied	\N	\N	\N	\N	146237	146237	146238
29331	47812	48	applied	\N	\N	\N	\N	146246	146246	146247
29331	47813	49	applied	\N	\N	\N	\N	146248	146248	146249
29331	47818	50	applied	\N	\N	\N	\N	146261	146261	146262
29331	47819	51	applied	\N	\N	\N	\N	146263	146263	146264
29331	47820	52	applied	\N	\N	\N	\N	146265	146265	146266
29331	47821	53	applied	\N	\N	\N	\N	146267	146267	146268
29331	47830	54	applied	\N	\N	\N	\N	146286	146286	146287
29331	47831	55	applied	\N	\N	\N	\N	146288	146288	146289
29331	47836	56	applied	\N	\N	\N	\N	146300	146300	146301
29331	47839	57	applied	\N	\N	\N	\N	146322	146322	146323
29331	47840	58	applied	\N	\N	\N	\N	146324	146324	146325
29331	47845	59	applied	\N	\N	\N	\N	146333	146333	146334
29331	47846	60	applied	\N	\N	\N	\N	146335	146335	146336
29331	47852	61	applied	\N	\N	\N	\N	146345	146345	146346
29331	47855	62	applied	\N	\N	\N	\N	146357	146357	146358
29331	47858	63	applied	\N	\N	\N	\N	146365	146365	146366
29331	47859	65	applied	\N	\N	\N	\N	146367	146367	146368
29331	47865	66	applied	\N	\N	\N	\N	146379	146379	146380
29331	47867	67	applied	\N	\N	\N	\N	146385	146385	146386
29331	47870	68	applied	\N	\N	\N	\N	146402	146402	146403
29331	47874	69	applied	\N	\N	\N	\N	146411	146411	146412
29331	47877	70	applied	\N	\N	\N	\N	146419	146419	146420
29331	47878	71	applied	\N	\N	\N	\N	146421	146421	146422
29331	47882	72	applied	\N	\N	\N	\N	146432	146432	146433
29331	47886	73	applied	\N	\N	\N	\N	146439	146439	146440
29331	47887	74	applied	\N	\N	\N	\N	146441	146441	146442
29331	47891	75	applied	\N	\N	\N	\N	146450	146450	146451
29331	47895	76	applied	\N	\N	\N	\N	146459	146459	146460
29331	47896	77	applied	\N	\N	\N	\N	146464	146464	146465
29331	47899	78	applied	\N	\N	\N	\N	146474	146474	146475
29331	47900	79	applied	\N	\N	\N	\N	146476	146476	146477
29331	47906	80	applied	\N	\N	\N	\N	146487	146487	146488
29331	47908	81	applied	\N	\N	\N	\N	146493	146493	146494
29331	47911	82	applied	\N	\N	\N	\N	146501	146501	146502
29331	47915	83	applied	\N	\N	\N	\N	146511	146511	146512
29331	47918	84	applied	\N	\N	\N	\N	146520	146520	146521
29331	47920	85	applied	\N	\N	\N	\N	146525	146525	146526
29331	47924	86	applied	\N	\N	\N	\N	146534	146534	146535
29331	47927	87	applied	\N	\N	\N	\N	146545	146545	146546
29331	47929	88	applied	\N	\N	\N	\N	146551	146551	146552
29301	47877	0	applied	\N	\N	\N	\N	146419	146419	146420
29301	47878	1	applied	\N	\N	\N	\N	146421	146421	146422
29301	47879	2	applied	\N	\N	\N	\N	146423	146423	80666
29301	47880	3	applied	\N	\N	\N	\N	146424	146424	80686
29301	47881	4	applied	\N	\N	\N	\N	146425	146425	146426
29308	47895	0	applied	\N	\N	\N	\N	146459	146459	146460
29312	47906	0	applied	\N	\N	\N	\N	146487	146487	146488
29312	47907	1	applied	\N	\N	\N	\N	146489	146489	80767
29316	47908	0	applied	\N	\N	\N	\N	146493	146493	146494
29316	47909	1	applied	\N	\N	\N	\N	146495	146495	80777
29316	47910	2	applied	\N	\N	\N	\N	146496	146496	146497
29319	47915	0	applied	\N	\N	\N	\N	146511	146511	146512
29319	47916	1	applied	\N	\N	\N	\N	146513	146513	146514
29319	47917	2	applied	\N	\N	\N	\N	146517	146517	146518
29328	47927	0	applied	\N	\N	\N	\N	146545	146545	146546
29328	47928	1	applied	\N	\N	\N	\N	146547	146547	146548
29332	47941	0	applied	\N	\N	\N	\N	146584	146584	146585
29332	47942	1	applied	\N	\N	\N	\N	146586	146586	146587
29332	47943	2	applied	\N	\N	\N	\N	146588	146588	146589
29342	47964	0	applied	\N	\N	\N	\N	146645	146645	146646
29342	47965	1	applied	\N	\N	\N	\N	146647	146647	146648
29342	47966	2	applied	\N	\N	\N	\N	146649	146649	146650
29342	47967	3	applied	\N	\N	\N	\N	146651	146651	146652
29342	47968	4	applied	\N	\N	\N	\N	146653	146653	80983
29342	47969	5	applied	\N	\N	\N	\N	146654	146654	80993
29349	47979	0	applied	\N	\N	\N	\N	146681	146681	146682
29349	47980	1	applied	\N	\N	\N	\N	146683	146683	146684
29349	47981	2	applied	\N	\N	\N	\N	146685	146685	81025
29349	47982	3	applied	\N	\N	\N	\N	146686	146686	81033
29349	47983	4	applied	\N	\N	\N	\N	146687	146687	146688
29349	47984	5	applied	\N	\N	\N	\N	146689	146689	146690
29354	47991	0	applied	\N	\N	\N	\N	146708	146708	146709
29354	47992	1	applied	\N	\N	\N	\N	146710	146710	146711
29354	47993	2	applied	\N	\N	\N	\N	146712	146712	81072
29362	48000	0	applied	\N	\N	\N	\N	146732	146732	146733
29362	48001	1	applied	\N	\N	\N	\N	146734	146734	146735
29362	48002	2	applied	\N	\N	\N	\N	146736	146736	146737
29365	48009	0	applied	\N	\N	\N	\N	146756	146756	146757
29365	48010	1	applied	\N	\N	\N	\N	146758	146758	146759
29365	48011	2	applied	\N	\N	\N	\N	146760	146760	81132
29370	48018	0	applied	\N	\N	\N	\N	146778	146778	146779
29370	48019	1	applied	\N	\N	\N	\N	146780	146780	81156
29370	48020	2	applied	\N	\N	\N	\N	146781	146781	146782
29374	48027	0	applied	\N	\N	\N	\N	146801	146801	146802
29374	48028	1	applied	\N	\N	\N	\N	146803	146803	146804
29374	48029	2	applied	\N	\N	\N	\N	146805	146805	146806
29374	48030	3	applied	\N	\N	\N	\N	146807	146807	81438
29374	48031	4	applied	\N	\N	\N	\N	146808	146808	81439
29381	48048	0	applied	\N	\N	\N	\N	146839	146839	146840
29381	48049	1	applied	\N	\N	\N	\N	146841	146841	81625
29386	48062	0	applied	\N	\N	\N	\N	146865	146865	146866
29386	48063	1	applied	\N	\N	\N	\N	146867	146867	146868
29386	48064	2	applied	\N	\N	\N	\N	146869	146869	146870
29386	48065	3	applied	\N	\N	\N	\N	146871	146871	81983
29386	48066	4	applied	\N	\N	\N	\N	146872	146872	82027
29386	48067	5	applied	\N	\N	\N	\N	146873	146873	146874
29386	48068	6	applied	\N	\N	\N	\N	146875	146875	82085
29386	48069	7	applied	\N	\N	\N	\N	146876	146876	82116
29386	48070	8	applied	\N	\N	\N	\N	146877	146877	82161
29386	48071	9	applied	\N	\N	\N	\N	146878	146878	82169
29386	48072	10	applied	\N	\N	\N	\N	146879	146879	82174
29386	48073	11	applied	\N	\N	\N	\N	146880	146880	82374
29388	48062	0	applied	\N	\N	\N	\N	146865	146865	146866
29388	48063	1	applied	\N	\N	\N	\N	146867	146867	146868
29388	48064	2	applied	\N	\N	\N	\N	146869	146869	146870
29388	48065	3	applied	\N	\N	\N	\N	146871	146871	81983
29388	48066	4	applied	\N	\N	\N	\N	146872	146872	82027
29388	48067	5	applied	\N	\N	\N	\N	146873	146873	146874
29388	48072	6	applied	\N	\N	\N	\N	146879	146879	82116
29388	48073	7	applied	\N	\N	\N	\N	146880	146880	82169
29390	48078	0	applied	\N	\N	\N	\N	146894	146894	146895
29390	48079	1	applied	\N	\N	\N	\N	146896	146896	146897
29390	48080	2	applied	\N	\N	\N	\N	146898	146898	146899
29390	48081	3	applied	\N	\N	\N	\N	146900	146900	83272
29396	48089	0	applied	\N	\N	\N	\N	146931	146931	146932
29396	48090	1	applied	\N	\N	\N	\N	146933	146933	82230
29396	48091	2	applied	\N	\N	\N	\N	146934	146934	83276
29398	48092	0	applied	\N	\N	\N	\N	146937	146937	146938
29398	48093	1	applied	\N	\N	\N	\N	146939	146939	146940
29398	48094	2	applied	\N	\N	\N	\N	146941	146941	82242
29401	48101	0	applied	\N	\N	\N	\N	146957	146957	146958
29401	48102	1	applied	\N	\N	\N	\N	146959	146959	82266
29401	48103	2	applied	\N	\N	1000000000	\N	146960	146960	146961
29401	48104	3	applied	\N	\N	\N	\N	146962	146962	83281
29408	48114	0	applied	\N	\N	\N	\N	146988	146988	146989
29408	48115	1	applied	\N	\N	\N	\N	146990	146990	82392
29408	48116	2	applied	\N	\N	\N	\N	146991	146991	146992
29408	48117	3	applied	\N	\N	\N	\N	146993	146993	82305
29411	48118	0	applied	\N	\N	\N	\N	146996	146996	146997
29411	48119	2	applied	\N	\N	\N	\N	146999	146999	147000
29411	48120	3	applied	\N	\N	\N	\N	147001	147001	147002
29411	48121	4	applied	\N	\N	\N	\N	147003	147003	147004
29411	48122	5	applied	\N	\N	\N	\N	147005	147005	82397
29411	48123	6	applied	\N	\N	\N	\N	147006	147006	82342
29411	48124	7	applied	\N	\N	\N	\N	147007	147007	83286
29411	48125	8	applied	\N	\N	\N	\N	147008	147008	147009
29411	48126	9	applied	\N	\N	\N	\N	147010	147010	82352
29413	48127	0	applied	\N	\N	\N	\N	147016	147016	147017
29413	47847	1	applied	\N	\N	1000000000	\N	146337	146337	146338
29413	47950	2	applied	\N	\N	\N	\N	146609	146609	146610
29413	48087	3	applied	\N	\N	\N	\N	146925	146925	146926
29413	48103	4	applied	\N	\N	1000000000	\N	146960	146960	146961
29413	48116	5	applied	\N	\N	\N	\N	146991	146991	146992
29413	48067	6	applied	\N	\N	\N	\N	147018	147018	146874
29413	47938	7	applied	\N	\N	1000000000	\N	146579	146579	146571
29413	47939	8	applied	\N	\N	1000000000	\N	146580	146580	146573
29417	48138	0	applied	\N	\N	\N	\N	147042	147042	147043
29421	48143	0	applied	\N	\N	\N	\N	147055	147055	147056
29421	48144	1	applied	\N	\N	\N	\N	147057	147057	83297
29421	48145	2	applied	\N	\N	\N	\N	147058	147058	147059
29423	48146	0	applied	\N	\N	1000000000	\N	147060	147060	147061
29423	48147	1	applied	\N	\N	\N	\N	147062	147062	147063
29423	48148	2	applied	\N	\N	\N	\N	147064	147064	82439
29423	48149	3	applied	\N	\N	\N	\N	147065	147065	82441
29425	48150	0	applied	\N	\N	\N	\N	147072	147072	147073
29425	48151	1	applied	\N	\N	\N	\N	147074	147074	147075
29425	48152	2	applied	\N	\N	\N	\N	147076	147076	147077
29425	48153	3	applied	\N	\N	\N	\N	147078	147078	147079
29425	48154	4	applied	\N	\N	\N	\N	147080	147080	82447
29331	47930	89	applied	\N	\N	\N	\N	146553	146553	146554
29331	47936	90	applied	\N	\N	\N	\N	146566	146566	146567
29331	47847	91	applied	\N	\N	1000000000	\N	146337	146337	146338
29331	47304	92	applied	\N	\N	\N	\N	144962	144962	144963
29331	47309	93	applied	\N	\N	\N	\N	144972	144972	78506
29331	47310	94	applied	\N	\N	\N	\N	144974	144974	144965
29331	47312	95	applied	\N	\N	\N	\N	144981	144981	78508
29331	47320	96	applied	\N	\N	\N	\N	145002	145002	145482
29331	47313	97	applied	\N	\N	\N	\N	144983	144983	78516
29331	47331	98	applied	\N	\N	\N	\N	145024	145024	145381
29331	47742	99	applied	\N	\N	\N	\N	146095	146095	146096
29331	47938	100	applied	\N	\N	1000000000	\N	146579	146579	146571
29331	47939	101	applied	\N	\N	1000000000	\N	146580	146580	146573
29331	47345	102	applied	\N	\N	\N	\N	145056	145056	144973
29331	47305	103	applied	\N	\N	\N	\N	144964	144964	78748
29331	47308	104	applied	\N	\N	\N	\N	144971	144971	78540
29331	47314	105	applied	\N	\N	\N	\N	144984	144984	78553
29331	47316	106	applied	\N	\N	\N	\N	144994	144994	78752
29331	47321	107	applied	\N	\N	\N	\N	145003	145003	145004
29331	47325	108	applied	\N	\N	\N	\N	145014	145014	145007
29331	47333	109	applied	\N	\N	\N	\N	145027	145027	78582
29331	47336	110	applied	\N	\N	\N	\N	145034	145034	78593
29331	47339	111	applied	\N	\N	\N	\N	145041	145041	146581
29331	47344	112	applied	\N	\N	\N	\N	145055	145055	78755
29331	47349	113	applied	\N	\N	\N	\N	145066	145066	78612
29331	47354	114	applied	\N	\N	\N	\N	145077	145077	78626
29331	47355	115	applied	\N	\N	\N	\N	145079	145079	78635
29331	47361	116	applied	\N	\N	\N	\N	145088	145088	145384
29331	47365	117	applied	\N	\N	\N	\N	145097	145097	145057
29331	47357	118	applied	\N	\N	\N	\N	145081	145081	78758
29331	47362	119	applied	\N	\N	\N	\N	145089	145089	78658
29331	47375	120	applied	\N	\N	\N	\N	145118	145118	145386
29331	47388	121	applied	\N	\N	\N	\N	145147	145147	78759
29331	47395	122	applied	\N	\N	\N	\N	145161	145161	78660
29331	47409	123	applied	\N	\N	\N	\N	145190	145190	145067
29331	47416	124	applied	\N	\N	\N	\N	145206	145206	78760
29331	47424	125	applied	\N	\N	\N	\N	145223	145223	78678
29334	47941	0	applied	\N	\N	\N	\N	146584	146584	146585
29334	47942	1	applied	\N	\N	\N	\N	146586	146586	146587
29334	47943	2	applied	\N	\N	\N	\N	146588	146588	146589
29335	47944	0	applied	\N	\N	\N	\N	146593	146593	146594
29335	47945	1	applied	\N	\N	\N	\N	146595	146595	146596
29335	47946	2	applied	\N	\N	\N	\N	146597	146597	146598
29335	47947	3	applied	\N	\N	\N	\N	146599	146599	146600
29338	47954	0	applied	\N	\N	\N	\N	146619	146619	146620
29338	47955	1	applied	\N	\N	\N	\N	146621	146621	146622
29338	47956	2	applied	\N	\N	\N	\N	146623	146623	146624
29338	47957	3	applied	\N	\N	\N	\N	146625	146625	146626
29340	47958	0	applied	\N	\N	\N	\N	146629	146629	146630
29340	47959	1	applied	\N	\N	\N	\N	146631	146631	146632
29340	47960	2	applied	\N	\N	\N	\N	146633	146633	146634
29343	47964	0	applied	\N	\N	\N	\N	146645	146645	146646
29343	47965	1	applied	\N	\N	\N	\N	146647	146647	146648
29343	47966	2	applied	\N	\N	\N	\N	146649	146649	146650
29343	47967	3	applied	\N	\N	\N	\N	146651	146651	146652
29343	47968	4	applied	\N	\N	\N	\N	146653	146653	80983
29343	47969	5	applied	\N	\N	\N	\N	146654	146654	80993
29351	47985	0	applied	\N	\N	\N	\N	146695	146695	146696
29351	47986	1	applied	\N	\N	\N	\N	146697	146697	146698
29351	47987	2	applied	\N	\N	\N	\N	146699	146699	146700
29351	47988	3	applied	\N	\N	\N	\N	146701	146701	146702
29351	47989	4	applied	\N	\N	\N	\N	146703	146703	81052
29351	47990	5	applied	\N	\N	\N	\N	146704	146704	81063
29356	47994	0	applied	\N	\N	\N	\N	146717	146717	146718
29356	47995	1	applied	\N	\N	\N	\N	146719	146719	146720
29356	47996	2	applied	\N	\N	\N	\N	146721	146721	81080
29356	47997	3	applied	\N	\N	\N	\N	146722	146722	81084
29357	47994	0	applied	\N	\N	\N	\N	146717	146717	146718
29357	47995	1	applied	\N	\N	\N	\N	146719	146719	146720
29357	47996	2	applied	\N	\N	\N	\N	146721	146721	81080
29357	47997	3	applied	\N	\N	\N	\N	146722	146722	81084
29363	48003	0	applied	\N	\N	\N	\N	146742	146742	146743
29363	48004	1	applied	\N	\N	\N	\N	146744	146744	146745
29363	48005	2	applied	\N	\N	\N	\N	146746	146746	81126
29366	48009	0	applied	\N	\N	\N	\N	146756	146756	146757
29366	48010	1	applied	\N	\N	\N	\N	146758	146758	146759
29366	48011	2	applied	\N	\N	\N	\N	146760	146760	81132
29368	48015	0	applied	\N	\N	\N	\N	146770	146770	146771
29368	48016	1	applied	\N	\N	\N	\N	146772	146772	81142
29368	48017	2	applied	\N	\N	\N	\N	146773	146773	146774
29369	48015	0	applied	\N	\N	\N	\N	146770	146770	146771
29369	48016	1	applied	\N	\N	\N	\N	146772	146772	81142
29369	48017	2	applied	\N	\N	\N	\N	146773	146773	146774
29371	48018	0	applied	\N	\N	\N	\N	146778	146778	146779
29371	48019	1	applied	\N	\N	\N	\N	146780	146780	81156
29371	48020	2	applied	\N	\N	\N	\N	146781	146781	146782
29372	48021	0	applied	\N	\N	\N	\N	146787	146787	146788
29372	48022	1	applied	\N	\N	\N	\N	146789	146789	81166
29372	48023	2	applied	\N	\N	\N	\N	146790	146790	146791
29373	48024	0	applied	\N	\N	\N	\N	146794	146794	146795
29373	48025	1	applied	\N	\N	\N	\N	146796	146796	146797
29373	48026	2	applied	\N	\N	\N	\N	146798	146798	81180
29376	48032	0	applied	\N	\N	\N	\N	146810	146810	146811
29376	48033	1	applied	\N	\N	\N	\N	146812	146812	146813
29376	48034	2	applied	\N	\N	\N	\N	146814	146814	146815
29376	48035	3	applied	\N	\N	\N	\N	146816	146816	81206
29376	48036	4	applied	\N	\N	\N	\N	146817	146817	81226
29376	48037	5	applied	\N	\N	\N	\N	146818	146818	81241
29376	48038	6	applied	\N	\N	\N	\N	146819	146819	81276
29376	48039	7	applied	\N	\N	\N	\N	146820	146820	81329
29376	48040	8	applied	\N	\N	\N	\N	146821	146821	81389
29378	48032	0	applied	\N	\N	\N	\N	146810	146810	146811
29378	48033	1	applied	\N	\N	\N	\N	146812	146812	146813
29378	48034	2	applied	\N	\N	\N	\N	146814	146814	146815
29378	48035	3	applied	\N	\N	\N	\N	146816	146816	81206
29378	48036	4	applied	\N	\N	\N	\N	146817	146817	81226
29378	48037	5	applied	\N	\N	\N	\N	146818	146818	81241
29378	48038	6	applied	\N	\N	\N	\N	146819	146819	81276
29378	48039	7	applied	\N	\N	\N	\N	146820	146820	81329
29378	48040	8	applied	\N	\N	\N	\N	146821	146821	81389
29384	48053	0	applied	\N	\N	\N	\N	146849	146849	146850
29384	48054	1	applied	\N	\N	\N	\N	146851	146851	146852
29384	48055	2	applied	\N	\N	\N	\N	146853	146853	81752
29384	48056	3	applied	\N	\N	\N	\N	146854	146854	81779
29384	48057	4	applied	\N	\N	\N	\N	146855	146855	81819
29384	48058	5	applied	\N	\N	\N	\N	146856	146856	81896
29384	48059	6	applied	\N	\N	\N	\N	146857	146857	81941
29391	47839	0	applied	\N	\N	\N	\N	146322	146322	146323
29391	47840	1	applied	\N	\N	\N	\N	146324	146324	146325
29337	47952	5	applied	\N	\N	\N	\N	146613	146613	146614
29337	47953	6	applied	\N	\N	\N	\N	146615	146615	146616
29346	47973	0	applied	\N	\N	\N	\N	146666	146666	146667
29346	47974	1	applied	\N	\N	\N	\N	146668	146668	81019
29346	47975	2	applied	\N	\N	\N	\N	146669	146669	146670
29348	47976	0	applied	\N	\N	\N	\N	146675	146675	146676
29348	47977	1	applied	\N	\N	\N	\N	146677	146677	146678
29348	47978	2	applied	\N	\N	\N	\N	146679	146679	146680
29350	47979	0	applied	\N	\N	\N	\N	146681	146681	146682
29350	47980	1	applied	\N	\N	\N	\N	146683	146683	146684
29350	47981	2	applied	\N	\N	\N	\N	146685	146685	81025
29350	47982	3	applied	\N	\N	\N	\N	146686	146686	81033
29350	47983	4	applied	\N	\N	\N	\N	146687	146687	146688
29350	47984	5	applied	\N	\N	\N	\N	146689	146689	146690
29352	47985	0	applied	\N	\N	\N	\N	146695	146695	146696
29352	47986	1	applied	\N	\N	\N	\N	146697	146697	146698
29352	47987	2	applied	\N	\N	\N	\N	146699	146699	146700
29352	47988	3	applied	\N	\N	\N	\N	146701	146701	146702
29352	47989	4	applied	\N	\N	\N	\N	146703	146703	81052
29352	47990	5	applied	\N	\N	\N	\N	146704	146704	81063
29359	47998	0	applied	\N	\N	\N	\N	146726	146726	146727
29359	47999	1	applied	\N	\N	\N	\N	146728	146728	146729
29361	48000	0	applied	\N	\N	\N	\N	146732	146732	146733
29361	48001	1	applied	\N	\N	\N	\N	146734	146734	146735
29361	48002	2	applied	\N	\N	\N	\N	146736	146736	146737
29380	48044	0	applied	\N	\N	\N	\N	146832	146832	146833
29380	48045	1	applied	\N	\N	\N	\N	146834	146834	81523
29380	48046	2	applied	\N	\N	\N	\N	146835	146835	81575
29380	48047	3	applied	\N	\N	\N	\N	146836	146836	81593
29383	48050	0	applied	\N	\N	\N	\N	146843	146843	146844
29383	48051	1	applied	\N	\N	\N	\N	146845	146845	81658
29383	48052	2	applied	\N	\N	\N	\N	146846	146846	81730
29385	48060	0	applied	\N	\N	\N	\N	146860	146860	146861
29385	48061	1	applied	\N	\N	\N	\N	146862	146862	81973
29387	48062	0	applied	\N	\N	\N	\N	146865	146865	146866
29387	48063	1	applied	\N	\N	\N	\N	146867	146867	146868
29387	48064	2	applied	\N	\N	\N	\N	146869	146869	146870
29387	48065	3	applied	\N	\N	\N	\N	146871	146871	81983
29387	48066	4	applied	\N	\N	\N	\N	146872	146872	82027
29387	48067	5	applied	\N	\N	\N	\N	146873	146873	146874
29387	48068	6	applied	\N	\N	\N	\N	146875	146875	82085
29387	48069	7	applied	\N	\N	\N	\N	146876	146876	82116
29387	48070	8	applied	\N	\N	\N	\N	146877	146877	82161
29387	48071	9	applied	\N	\N	\N	\N	146878	146878	82169
29387	48072	10	applied	\N	\N	\N	\N	146879	146879	82174
29387	48073	11	applied	\N	\N	\N	\N	146880	146880	82374
29392	48082	0	applied	\N	\N	\N	\N	146915	146915	146916
29392	48083	1	applied	\N	\N	\N	\N	146917	146917	82377
29394	48084	0	applied	\N	\N	\N	\N	146921	146921	146922
29394	48085	1	applied	\N	\N	\N	\N	146923	146923	83273
29394	48086	2	applied	\N	\N	\N	\N	146924	146924	82378
29394	48087	3	applied	\N	\N	\N	\N	146925	146925	146926
29394	48088	4	applied	\N	\N	\N	\N	146927	146927	82219
29403	48106	0	applied	\N	\N	\N	\N	146967	146967	82387
29405	48078	0	applied	\N	\N	\N	\N	146894	146894	146895
29405	48082	1	applied	\N	\N	\N	\N	146915	146915	146916
29405	48084	2	applied	\N	\N	\N	\N	146921	146921	146922
29405	48089	3	applied	\N	\N	\N	\N	146931	146931	146932
29405	48092	4	applied	\N	\N	\N	\N	146937	146937	146938
29405	48095	5	applied	\N	\N	\N	\N	146947	146947	146948
29405	48096	6	applied	\N	\N	\N	\N	146949	146949	146950
29405	48101	7	applied	\N	\N	\N	\N	146957	146957	146958
29405	48105	8	applied	\N	\N	\N	\N	146965	146965	146966
29405	48107	9	applied	\N	\N	\N	\N	146971	146971	146972
29405	48085	10	applied	\N	\N	\N	\N	146923	146923	83270
29405	48087	11	applied	\N	\N	\N	\N	146925	146925	146926
29405	48103	12	applied	\N	\N	1000000000	\N	146960	146960	146961
29405	48100	13	applied	\N	\N	\N	\N	146954	146954	82194
29405	48109	14	applied	\N	\N	\N	\N	146974	146974	83271
29405	48079	15	applied	\N	\N	\N	\N	146896	146896	146897
29405	48080	16	applied	\N	\N	\N	\N	146898	146898	82207
29405	48088	17	applied	\N	\N	\N	\N	146927	146927	82378
29405	48090	18	applied	\N	\N	\N	\N	146933	146933	82219
29405	48093	19	applied	\N	\N	\N	\N	146939	146939	82230
29405	48099	20	applied	\N	\N	\N	\N	146953	146953	82381
29405	48102	21	applied	\N	\N	\N	\N	146959	146959	82242
29405	48108	22	applied	\N	\N	\N	\N	146973	146973	82253
29405	48081	23	applied	\N	\N	\N	\N	146900	146900	83278
29405	48083	24	applied	\N	\N	\N	\N	146917	146917	82384
29405	48086	25	applied	\N	\N	\N	\N	146924	146924	82257
29405	48091	26	applied	\N	\N	\N	\N	146934	146934	83280
29405	48094	27	applied	\N	\N	\N	\N	146941	146941	82386
29405	48097	28	applied	\N	\N	\N	\N	146951	146951	82268
29405	48098	29	applied	\N	\N	\N	\N	146952	146952	82270
29405	48104	30	applied	\N	\N	\N	\N	146962	146962	82388
29405	48106	31	applied	\N	\N	\N	\N	146967	146967	146975
29405	48110	32	applied	\N	\N	\N	\N	146976	146976	82284
29407	48111	0	applied	\N	\N	\N	\N	146981	146981	146982
29407	48112	1	applied	\N	\N	\N	\N	146983	146983	146984
29407	48113	2	applied	\N	\N	\N	\N	146985	146985	82293
29410	48118	0	applied	\N	\N	\N	\N	146996	146996	146997
29410	48119	2	applied	\N	\N	\N	\N	146999	146999	147000
29410	48120	3	applied	\N	\N	\N	\N	147001	147001	147002
29410	48121	4	applied	\N	\N	\N	\N	147003	147003	147004
29410	48122	5	applied	\N	\N	\N	\N	147005	147005	82397
29410	48123	6	applied	\N	\N	\N	\N	147006	147006	82342
29410	48124	7	applied	\N	\N	\N	\N	147007	147007	83286
29410	48125	8	applied	\N	\N	\N	\N	147008	147008	147009
29410	48126	9	applied	\N	\N	\N	\N	147010	147010	82352
29414	48127	0	applied	\N	\N	\N	\N	147016	147016	147021
29414	48128	1	applied	\N	\N	\N	\N	147022	147022	147023
29414	48129	2	applied	\N	\N	\N	\N	147024	147024	147025
29414	48130	3	applied	\N	\N	\N	\N	147026	147026	147027
29414	48131	4	applied	\N	\N	\N	\N	147028	147028	147029
29414	48132	5	applied	\N	\N	\N	\N	147030	147030	83289
29414	48133	6	applied	\N	\N	\N	\N	147031	147031	82405
29414	48134	7	applied	\N	\N	\N	\N	147032	147032	83291
29414	48135	8	applied	\N	\N	1000000000	\N	147033	147033	147034
29414	48136	9	applied	\N	\N	\N	\N	147035	147035	147036
29414	48137	10	applied	\N	\N	\N	\N	147037	147037	82415
29416	48138	0	applied	\N	\N	\N	\N	147042	147042	147043
29416	48139	1	applied	\N	\N	\N	\N	147044	147044	82429
29416	48140	2	applied	\N	\N	\N	\N	147045	147045	82431
29419	48141	0	applied	\N	\N	\N	\N	147049	147049	147050
29419	48139	1	applied	\N	\N	\N	\N	147044	147044	82429
29419	48140	2	applied	\N	\N	\N	\N	147045	147045	82431
29419	48142	3	applied	\N	\N	\N	\N	147051	147051	147052
29426	48155	0	applied	\N	\N	\N	\N	147083	147083	147084
29426	48156	1	applied	\N	\N	\N	\N	147085	147085	147086
29391	47845	2	applied	\N	\N	\N	\N	146333	146333	146334
29391	47846	3	applied	\N	\N	\N	\N	146335	146335	146336
29391	47852	4	applied	\N	\N	\N	\N	146345	146345	146346
29391	47855	5	applied	\N	\N	\N	\N	146357	146357	146358
29391	47858	6	applied	\N	\N	\N	\N	146365	146365	146366
29391	47859	7	applied	\N	\N	\N	\N	146367	146367	146368
29391	47865	8	applied	\N	\N	\N	\N	146379	146379	146380
29391	47867	9	applied	\N	\N	\N	\N	146385	146385	146386
29391	47870	10	applied	\N	\N	\N	\N	146402	146402	146403
29391	47874	11	applied	\N	\N	\N	\N	146411	146411	146412
29391	47877	12	applied	\N	\N	\N	\N	146419	146419	146420
29391	47878	13	applied	\N	\N	\N	\N	146421	146421	146422
29391	47882	14	applied	\N	\N	\N	\N	146432	146432	146433
29391	47886	15	applied	\N	\N	\N	\N	146439	146439	146440
29391	47887	16	applied	\N	\N	\N	\N	146441	146441	146442
29391	47891	17	applied	\N	\N	\N	\N	146450	146450	146451
29391	47895	18	applied	\N	\N	\N	\N	146459	146459	146460
29391	47896	19	applied	\N	\N	\N	\N	146464	146464	146465
29391	47899	20	applied	\N	\N	\N	\N	146474	146474	146475
29391	47900	21	applied	\N	\N	\N	\N	146476	146476	146477
29391	47906	22	applied	\N	\N	\N	\N	146487	146487	146488
29391	47908	23	applied	\N	\N	\N	\N	146493	146493	146494
29391	47911	24	applied	\N	\N	\N	\N	146501	146501	146502
29391	47915	25	applied	\N	\N	\N	\N	146511	146511	146512
29391	47918	26	applied	\N	\N	\N	\N	146520	146520	146521
29391	47920	27	applied	\N	\N	\N	\N	146525	146525	146526
29391	47924	28	applied	\N	\N	\N	\N	146534	146534	146535
29391	47927	29	applied	\N	\N	\N	\N	146545	146545	146546
29391	47929	30	applied	\N	\N	\N	\N	146551	146551	146552
29391	47930	31	applied	\N	\N	\N	\N	146553	146553	146554
29391	47936	32	applied	\N	\N	\N	\N	146566	146566	146567
29391	47941	33	applied	\N	\N	\N	\N	146584	146584	146585
29391	47944	34	applied	\N	\N	\N	\N	146593	146593	146594
29391	47948	35	applied	\N	\N	\N	\N	146605	146605	146606
29391	47949	36	applied	\N	\N	\N	\N	146607	146607	146608
29391	47954	37	applied	\N	\N	\N	\N	146619	146619	146620
29391	47958	38	applied	\N	\N	\N	\N	146629	146629	146630
29391	47961	39	applied	\N	\N	\N	\N	146637	146637	146638
29391	47964	40	applied	\N	\N	\N	\N	146645	146645	146646
29391	47965	41	applied	\N	\N	\N	\N	146647	146647	146648
29391	47970	42	applied	\N	\N	\N	\N	146661	146661	146662
29391	47973	43	applied	\N	\N	\N	\N	146666	146666	146667
29391	47976	44	applied	\N	\N	\N	\N	146675	146675	146676
29391	47979	45	applied	\N	\N	\N	\N	146681	146681	146682
29391	47980	46	applied	\N	\N	\N	\N	146683	146683	146684
29391	47985	47	applied	\N	\N	\N	\N	146695	146695	146696
29391	47986	48	applied	\N	\N	\N	\N	146697	146697	146698
29391	47991	49	applied	\N	\N	\N	\N	146708	146708	146709
29391	47994	50	applied	\N	\N	\N	\N	146717	146717	146718
29391	47998	51	applied	\N	\N	\N	\N	146726	146726	146727
29391	48000	52	applied	\N	\N	\N	\N	146732	146732	146733
29391	48003	53	applied	\N	\N	\N	\N	146742	146742	146743
29391	48006	54	applied	\N	\N	\N	\N	146749	146749	146750
29391	48009	55	applied	\N	\N	\N	\N	146756	146756	146757
29391	48012	56	applied	\N	\N	\N	\N	146763	146763	146764
29391	48015	57	applied	\N	\N	\N	\N	146770	146770	146771
29391	48018	58	applied	\N	\N	\N	\N	146778	146778	146779
29391	48021	59	applied	\N	\N	\N	\N	146787	146787	146788
29391	48024	60	applied	\N	\N	\N	\N	146794	146794	146795
29391	48027	61	applied	\N	\N	\N	\N	146801	146801	146802
29391	48028	62	applied	\N	\N	\N	\N	146803	146803	146804
29391	48032	63	applied	\N	\N	\N	\N	146810	146810	146811
29391	48033	64	applied	\N	\N	\N	\N	146812	146812	146813
29391	48034	65	applied	\N	\N	\N	\N	146814	146814	146815
29391	48041	66	applied	\N	\N	\N	\N	146826	146826	146827
29391	48044	67	applied	\N	\N	\N	\N	146832	146832	146833
29391	48048	68	applied	\N	\N	\N	\N	146839	146839	146840
29391	48050	69	applied	\N	\N	\N	\N	146843	146843	146844
29391	48053	70	applied	\N	\N	\N	\N	146849	146849	146850
29391	48054	71	applied	\N	\N	\N	\N	146851	146851	146852
29391	48060	72	applied	\N	\N	\N	\N	146860	146860	146861
29391	48062	73	applied	\N	\N	\N	\N	146865	146865	146866
29391	48063	74	applied	\N	\N	\N	\N	146867	146867	146868
29391	48064	75	applied	\N	\N	\N	\N	146869	146869	146870
29391	48074	76	applied	\N	\N	\N	\N	146886	146886	146887
29391	48078	77	applied	\N	\N	\N	\N	146894	146894	146895
29391	47847	78	applied	\N	\N	1000000000	\N	146337	146337	146338
29391	47950	79	applied	\N	\N	\N	\N	146609	146609	146610
29391	47841	80	applied	\N	\N	\N	\N	146326	146326	146327
29391	47942	81	applied	\N	\N	\N	\N	146586	146586	146587
29391	47842	82	applied	\N	\N	\N	\N	146328	146328	80524
29391	47853	83	applied	\N	\N	\N	\N	146347	146347	146902
29391	48067	84	applied	\N	\N	\N	\N	146903	146903	146874
29391	47843	85	applied	\N	\N	\N	\N	146329	146329	80526
29391	47848	87	applied	\N	\N	\N	\N	146339	146339	146905
29391	47860	88	applied	\N	\N	\N	\N	146369	146369	80593
29391	47871	89	applied	\N	\N	\N	\N	146404	146404	80533
29391	47885	90	applied	\N	\N	\N	\N	146438	146438	80559
29391	47893	91	applied	\N	\N	\N	\N	146453	146453	80594
29391	47938	92	applied	\N	\N	1000000000	\N	146570	146570	146571
29391	47939	93	applied	\N	\N	1000000000	\N	146572	146572	146573
29391	47902	94	applied	\N	\N	\N	\N	146479	146479	80544
29391	47844	95	applied	\N	\N	\N	\N	146331	146331	80562
29391	47849	96	applied	\N	\N	\N	\N	146340	146340	80598
29391	47850	97	applied	\N	\N	\N	\N	146341	146341	146906
29391	47914	98	applied	\N	\N	\N	\N	146507	146507	80578
29391	47921	99	applied	\N	\N	\N	\N	146527	146527	80600
29391	47935	100	applied	\N	\N	\N	\N	146562	146562	146907
29391	47945	101	applied	\N	\N	\N	\N	146595	146595	80584
29391	47957	102	applied	\N	\N	\N	\N	146625	146625	80586
29391	47969	103	applied	\N	\N	\N	\N	146654	146654	146370
29391	47978	104	applied	\N	\N	\N	\N	146679	146679	146908
29391	47987	105	applied	\N	\N	\N	\N	146699	146699	80608
29391	47996	106	applied	\N	\N	\N	\N	146721	146721	146909
29391	48007	107	applied	\N	\N	\N	\N	146751	146751	146372
29391	48016	108	applied	\N	\N	\N	\N	146772	146772	80610
29391	48026	109	applied	\N	\N	\N	\N	146798	146798	146910
29391	48037	110	applied	\N	\N	\N	\N	146818	146818	146911
29391	48047	111	applied	\N	\N	\N	\N	146836	146836	80620
29391	48055	112	applied	\N	\N	\N	\N	146853	146853	80622
29391	48065	113	applied	\N	\N	\N	\N	146871	146871	146375
29391	48075	114	applied	\N	\N	\N	\N	146888	146888	146912
29391	47857	115	applied	\N	\N	\N	\N	146360	146360	80629
29391	47861	116	applied	\N	\N	\N	\N	146371	146371	80648
29391	47862	117	applied	\N	\N	\N	\N	146373	146373	146407
29391	47869	118	applied	\N	\N	\N	\N	146390	146390	146409
29391	47873	119	applied	\N	\N	\N	\N	146408	146408	80662
29391	47876	120	applied	\N	\N	\N	\N	146415	146415	80666
29391	47880	121	applied	\N	\N	\N	\N	146424	146424	80686
29391	47884	122	applied	\N	\N	\N	\N	146436	146436	146435
29391	47890	123	applied	\N	\N	\N	\N	146446	146446	146437
29391	47894	124	applied	\N	\N	\N	\N	146455	146455	80701
29391	47897	125	applied	\N	\N	\N	\N	146466	146466	80709
29397	48092	0	applied	\N	\N	\N	\N	146937	146937	146938
29397	48093	1	applied	\N	\N	\N	\N	146939	146939	146940
29397	48094	2	applied	\N	\N	\N	\N	146941	146941	82242
29399	48092	0	applied	\N	\N	\N	\N	146937	146937	146938
29399	48093	1	applied	\N	\N	\N	\N	146939	146939	146940
29399	48094	2	applied	\N	\N	\N	\N	146941	146941	82242
29409	48114	0	applied	\N	\N	\N	\N	146988	146988	146989
29409	48115	1	applied	\N	\N	\N	\N	146990	146990	82392
29409	48116	2	applied	\N	\N	\N	\N	146991	146991	146992
29409	48117	3	applied	\N	\N	\N	\N	146993	146993	82305
29418	48141	0	applied	\N	\N	\N	\N	147049	147049	147050
29418	48139	1	applied	\N	\N	\N	\N	147044	147044	82429
29418	48140	2	applied	\N	\N	\N	\N	147045	147045	82431
29418	48142	3	applied	\N	\N	\N	\N	147051	147051	147052
29428	48160	0	applied	\N	\N	\N	\N	147093	147093	147094
29428	48161	1	applied	\N	\N	\N	\N	147095	147095	147096
29428	48162	2	applied	\N	\N	\N	\N	147097	147097	147098
29428	48163	3	applied	\N	\N	\N	\N	147099	147099	82465
29430	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29430	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29430	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29432	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29432	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29432	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29434	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29434	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29434	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29443	48198	0	applied	\N	\N	\N	\N	147183	147183	147184
29443	48199	1	applied	\N	\N	\N	\N	147185	147185	147186
29445	48198	0	applied	\N	\N	\N	\N	147183	147183	147184
29445	48199	1	applied	\N	\N	\N	\N	147185	147185	147186
29448	48209	0	applied	\N	\N	\N	\N	147210	147210	147211
29448	48210	1	applied	\N	\N	\N	\N	147212	147212	147213
29448	48211	2	applied	\N	\N	\N	\N	147214	147214	147215
29448	48212	3	applied	\N	\N	\N	\N	147216	147216	82581
29448	48213	4	applied	\N	\N	\N	\N	147217	147217	147218
29448	48214	5	applied	\N	\N	\N	\N	147219	147219	82595
29448	48215	6	applied	\N	\N	\N	\N	147220	147220	82597
29448	48216	7	applied	\N	\N	\N	\N	147221	147221	147222
29448	48217	8	applied	\N	\N	\N	\N	147223	147223	147224
29450	48218	0	applied	\N	\N	\N	\N	147227	147227	147228
29450	48219	1	applied	\N	\N	\N	\N	147229	147229	82615
29450	48220	2	applied	\N	\N	\N	\N	147231	147231	82624
29452	48227	0	applied	\N	\N	\N	\N	147243	147243	147244
29452	48228	1	applied	\N	\N	\N	\N	147245	147245	147246
29452	48229	2	applied	\N	\N	\N	\N	147247	147247	147248
29452	48230	3	applied	\N	\N	\N	\N	147249	147249	147250
29463	48250	0	applied	\N	\N	\N	\N	147298	147298	147299
29463	48251	1	applied	\N	\N	\N	\N	147300	147300	147301
29463	48252	2	applied	\N	\N	\N	\N	147302	147302	82706
29466	48253	0	applied	\N	\N	\N	\N	147305	147305	147306
29466	48254	1	applied	\N	\N	\N	\N	147307	147307	147308
29466	48255	2	applied	\N	\N	\N	\N	147309	147309	147310
29466	48256	3	applied	\N	\N	\N	\N	147311	147311	147312
29466	48257	4	applied	\N	\N	\N	\N	147313	147313	147314
29466	48258	5	applied	\N	\N	\N	\N	147315	147315	82724
29466	48259	6	applied	\N	\N	\N	\N	147316	147316	82726
29466	48260	7	applied	\N	\N	\N	\N	147317	147317	82730
29468	48265	0	applied	\N	\N	\N	\N	147331	147331	147332
29468	48266	1	applied	\N	\N	\N	\N	147333	147333	147334
29468	48267	2	applied	\N	\N	\N	\N	147335	147335	147336
29468	48268	3	applied	\N	\N	1000000000	\N	147337	147337	147338
29468	48269	4	applied	\N	\N	\N	\N	147339	147339	147340
29468	48270	5	applied	\N	\N	\N	\N	147341	147341	147342
29468	48271	6	applied	\N	\N	\N	\N	147343	147343	82745
29468	48272	7	applied	\N	\N	\N	\N	147344	147344	82751
29473	48280	0	applied	\N	\N	\N	\N	147363	147363	147364
29473	48281	1	applied	\N	\N	\N	\N	147365	147365	82777
29473	48282	2	applied	\N	\N	\N	\N	147366	147366	147367
29473	48283	3	applied	\N	\N	\N	\N	147368	147368	82799
29477	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29477	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29477	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29477	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29477	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29477	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29477	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29477	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29477	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29477	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29477	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29479	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29479	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29479	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29479	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29479	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29479	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29479	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29479	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29479	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29479	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29479	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29481	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29481	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29481	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29481	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29481	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29481	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29481	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29481	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29481	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29481	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29481	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29483	48302	0	applied	\N	\N	\N	\N	147413	147413	147414
29483	48303	1	applied	\N	\N	\N	\N	147415	147415	147416
29483	48304	2	applied	\N	\N	\N	\N	147417	147417	147418
29485	48302	0	applied	\N	\N	\N	\N	147413	147413	147414
29485	48303	1	applied	\N	\N	\N	\N	147415	147415	147416
29485	48304	2	applied	\N	\N	\N	\N	147417	147417	147418
29486	48305	0	applied	\N	\N	\N	\N	147423	147423	147424
29486	48306	1	applied	\N	\N	\N	\N	147425	147425	147426
29486	48307	2	applied	\N	\N	\N	\N	147427	147427	147428
29486	48308	3	applied	\N	\N	\N	\N	147429	147429	147430
29486	48309	4	applied	\N	\N	\N	\N	147431	147431	147432
29486	48310	5	applied	\N	\N	\N	\N	147433	147433	147434
29486	48311	6	applied	\N	\N	\N	\N	147435	147435	82871
29415	48130	3	applied	\N	\N	\N	\N	147026	147026	147027
29415	48131	4	applied	\N	\N	\N	\N	147028	147028	147029
29415	48132	5	applied	\N	\N	\N	\N	147030	147030	83289
29415	48133	6	applied	\N	\N	\N	\N	147031	147031	82405
29415	48134	7	applied	\N	\N	\N	\N	147032	147032	83291
29415	48135	8	applied	\N	\N	1000000000	\N	147033	147033	147034
29415	48136	9	applied	\N	\N	\N	\N	147035	147035	147036
29415	48137	10	applied	\N	\N	\N	\N	147037	147037	82415
29420	48141	0	applied	\N	\N	\N	\N	147049	147049	147050
29420	48139	1	applied	\N	\N	\N	\N	147044	147044	82429
29420	48140	2	applied	\N	\N	\N	\N	147045	147045	82431
29420	48142	3	applied	\N	\N	\N	\N	147051	147051	147052
29422	48146	0	applied	\N	\N	1000000000	\N	147060	147060	147061
29422	48147	1	applied	\N	\N	\N	\N	147062	147062	147063
29422	48148	2	applied	\N	\N	\N	\N	147064	147064	82439
29422	48149	3	applied	\N	\N	\N	\N	147065	147065	82441
29424	48146	0	applied	\N	\N	1000000000	\N	147060	147060	147061
29424	48147	1	applied	\N	\N	\N	\N	147062	147062	147063
29424	48148	2	applied	\N	\N	\N	\N	147064	147064	82439
29424	48149	3	applied	\N	\N	\N	\N	147065	147065	82441
29436	48170	0	applied	\N	\N	\N	\N	147123	147123	147124
29436	48171	1	applied	\N	\N	\N	\N	147125	147125	147126
29436	48172	2	applied	\N	\N	\N	\N	147127	147127	82490
29436	48173	3	applied	\N	\N	\N	\N	147128	147128	147129
29440	48184	0	applied	\N	\N	\N	\N	147155	147155	147156
29440	48185	1	applied	\N	\N	\N	\N	147157	147157	147158
29440	48186	2	applied	\N	\N	\N	\N	147159	147159	147160
29440	48187	3	applied	\N	\N	\N	\N	147161	147161	147162
29440	48188	4	applied	\N	\N	\N	\N	147163	147163	82525
29440	48189	5	applied	\N	\N	\N	\N	147164	147164	82529
29440	48190	6	applied	\N	\N	\N	\N	147165	147165	82552
29440	48191	7	applied	\N	\N	1000000000	\N	147166	147166	147167
29440	48192	8	applied	\N	\N	1000000000	\N	147168	147168	147169
29440	48193	9	applied	\N	\N	\N	\N	147170	147170	147171
29440	48194	10	applied	\N	\N	\N	\N	147172	147172	147173
29440	48195	11	applied	\N	\N	\N	\N	147174	147174	82556
29440	48196	12	applied	\N	\N	\N	\N	147175	147175	147176
29440	48197	13	applied	\N	\N	\N	\N	147177	147177	82558
29442	48184	0	applied	\N	\N	\N	\N	147155	147155	147156
29442	48185	1	applied	\N	\N	\N	\N	147157	147157	147158
29442	48186	2	applied	\N	\N	\N	\N	147159	147159	147160
29442	48187	3	applied	\N	\N	\N	\N	147161	147161	147162
29442	48188	4	applied	\N	\N	\N	\N	147163	147163	82525
29442	48189	5	applied	\N	\N	\N	\N	147164	147164	82529
29442	48190	6	applied	\N	\N	\N	\N	147165	147165	82552
29442	48191	7	applied	\N	\N	1000000000	\N	147166	147166	147167
29442	48192	8	applied	\N	\N	1000000000	\N	147168	147168	147169
29442	48193	9	applied	\N	\N	\N	\N	147170	147170	147171
29442	48194	10	applied	\N	\N	\N	\N	147172	147172	147173
29442	48195	11	applied	\N	\N	\N	\N	147174	147174	82556
29442	48196	12	applied	\N	\N	\N	\N	147175	147175	147176
29442	48197	13	applied	\N	\N	\N	\N	147177	147177	82558
29444	48198	0	applied	\N	\N	\N	\N	147183	147183	147184
29444	48199	1	applied	\N	\N	\N	\N	147185	147185	147186
29446	48200	0	applied	\N	\N	\N	\N	147193	147193	147193
29446	48201	1	applied	\N	\N	\N	\N	147194	147194	147194
29446	48202	2	applied	\N	\N	\N	\N	147195	147195	147196
29446	48203	3	applied	\N	\N	\N	\N	147197	147197	147198
29446	48204	4	applied	\N	\N	\N	\N	147199	147199	147200
29446	48205	5	applied	\N	\N	\N	\N	147201	147201	82566
29449	48218	0	applied	\N	\N	\N	\N	147227	147227	147228
29449	48219	1	applied	\N	\N	\N	\N	147229	147229	82615
29454	48231	0	applied	\N	\N	\N	\N	147254	147254	147255
29454	48232	1	applied	\N	\N	\N	\N	147256	147256	147257
29457	48240	0	applied	\N	\N	\N	\N	147275	147275	147276
29457	48241	1	applied	\N	\N	\N	\N	147277	147277	147278
29457	48242	2	applied	\N	\N	\N	\N	147279	147279	147280
29457	48243	3	applied	\N	\N	\N	\N	147281	147281	82680
29457	48244	4	applied	\N	\N	\N	\N	147282	147282	147283
29457	48245	5	applied	\N	\N	\N	\N	147284	147284	147285
29457	48246	6	applied	\N	\N	\N	\N	147286	147286	82688
29459	48240	0	applied	\N	\N	\N	\N	147275	147275	147276
29459	48241	1	applied	\N	\N	\N	\N	147277	147277	147278
29459	48242	2	applied	\N	\N	\N	\N	147279	147279	147280
29459	48243	3	applied	\N	\N	\N	\N	147281	147281	82680
29459	48244	4	applied	\N	\N	\N	\N	147282	147282	147283
29459	48245	5	applied	\N	\N	\N	\N	147284	147284	147285
29459	48246	6	applied	\N	\N	\N	\N	147286	147286	82688
29461	48247	0	applied	\N	\N	\N	\N	147291	147291	147292
29461	48248	1	applied	\N	\N	\N	\N	147293	147293	147294
29461	48249	2	applied	\N	\N	\N	\N	147295	147295	147296
29470	48273	0	applied	\N	\N	\N	\N	147348	147348	147349
29470	48274	1	applied	\N	\N	\N	\N	147350	147350	147351
29470	48275	2	applied	\N	\N	\N	\N	147352	147352	147353
29470	48276	3	applied	\N	\N	\N	\N	147354	147354	82761
29472	48277	0	applied	\N	\N	\N	\N	147356	147356	147357
29472	48278	1	applied	\N	\N	\N	\N	147358	147358	147359
29472	48279	2	applied	\N	\N	\N	\N	147360	147360	82775
29475	48284	0	applied	\N	\N	\N	\N	147371	147371	147372
29475	48285	1	applied	\N	\N	\N	\N	147373	147373	142216
29475	48286	2	applied	\N	\N	\N	\N	147374	147374	147375
29475	48287	3	applied	\N	\N	\N	\N	147376	147376	147377
29475	48288	4	applied	\N	\N	\N	\N	147378	147378	82818
29475	48289	5	applied	\N	\N	\N	\N	147379	147379	147380
29475	48290	6	applied	\N	\N	\N	\N	147381	147381	147382
29482	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29482	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29482	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29482	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29482	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29482	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29482	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29482	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29482	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29482	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29482	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29490	48320	0	applied	\N	\N	\N	\N	147449	147449	147450
29490	48321	1	applied	\N	\N	\N	\N	147451	147451	147452
29490	48322	2	applied	\N	\N	\N	\N	147453	147453	147454
29490	48323	3	applied	\N	\N	\N	\N	147455	147455	82899
29490	48324	4	applied	\N	\N	\N	\N	147456	147456	82917
29490	48325	5	applied	\N	\N	\N	\N	147457	147457	82929
29490	48326	6	applied	\N	\N	\N	\N	147458	147458	147459
29491	48327	0	applied	\N	\N	\N	\N	147465	147465	147466
29491	48328	1	applied	\N	\N	\N	\N	147467	147467	147468
29491	48329	2	applied	\N	\N	\N	\N	147469	147469	147470
29491	48330	3	applied	\N	\N	\N	\N	147471	147471	147472
29491	48331	4	applied	\N	\N	\N	\N	147473	147473	147474
29491	48332	5	applied	\N	\N	\N	\N	147475	147475	82936
29426	48157	2	applied	\N	\N	\N	\N	147087	147087	147088
29426	48158	3	applied	\N	\N	\N	\N	147089	147089	82455
29426	48159	4	applied	\N	\N	\N	\N	147090	147090	147091
29431	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29431	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29431	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29433	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29433	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29433	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29438	48178	0	applied	\N	\N	\N	\N	147140	147140	147141
29438	48179	1	applied	\N	\N	\N	\N	147142	147142	82502
29438	48180	2	applied	\N	\N	\N	\N	147143	147143	147144
29447	48206	0	applied	\N	\N	\N	\N	147203	147203	147204
29447	48207	1	applied	\N	\N	\N	\N	147205	147205	82570
29447	48208	2	applied	\N	\N	\N	\N	147206	147206	147207
29456	48237	0	applied	\N	\N	\N	\N	147268	147268	147269
29456	48238	1	applied	\N	\N	\N	\N	147270	147270	147271
29456	48239	2	applied	\N	\N	\N	\N	147272	147272	82676
29458	48240	0	applied	\N	\N	\N	\N	147275	147275	147276
29458	48241	1	applied	\N	\N	\N	\N	147277	147277	147278
29458	48242	2	applied	\N	\N	\N	\N	147279	147279	147280
29458	48243	3	applied	\N	\N	\N	\N	147281	147281	82680
29458	48244	4	applied	\N	\N	\N	\N	147282	147282	147283
29458	48245	5	applied	\N	\N	\N	\N	147284	147284	147285
29458	48246	6	applied	\N	\N	\N	\N	147286	147286	82688
29460	48240	0	applied	\N	\N	\N	\N	147275	147275	147276
29460	48241	1	applied	\N	\N	\N	\N	147277	147277	147278
29460	48242	2	applied	\N	\N	\N	\N	147279	147279	147280
29460	48243	3	applied	\N	\N	\N	\N	147281	147281	82680
29460	48244	4	applied	\N	\N	\N	\N	147282	147282	147283
29460	48245	5	applied	\N	\N	\N	\N	147284	147284	147285
29460	48246	6	applied	\N	\N	\N	\N	147286	147286	82688
29465	48253	0	applied	\N	\N	\N	\N	147305	147305	147306
29465	48254	1	applied	\N	\N	\N	\N	147307	147307	147308
29465	48255	2	applied	\N	\N	\N	\N	147309	147309	147310
29465	48256	3	applied	\N	\N	\N	\N	147311	147311	147312
29465	48257	4	applied	\N	\N	\N	\N	147313	147313	147314
29465	48258	5	applied	\N	\N	\N	\N	147315	147315	82724
29465	48259	6	applied	\N	\N	\N	\N	147316	147316	82726
29465	48260	7	applied	\N	\N	\N	\N	147317	147317	82730
29467	48261	0	applied	\N	\N	\N	\N	147322	147322	147323
29467	48262	1	applied	\N	\N	\N	\N	147324	147324	147325
29467	48263	2	applied	\N	\N	\N	\N	147326	147326	82732
29467	48264	3	applied	\N	\N	\N	\N	147327	147327	147328
29469	48265	0	applied	\N	\N	\N	\N	147331	147331	147332
29469	48266	1	applied	\N	\N	\N	\N	147333	147333	147334
29469	48267	2	applied	\N	\N	\N	\N	147335	147335	147336
29469	48268	3	applied	\N	\N	1000000000	\N	147337	147337	147338
29469	48269	4	applied	\N	\N	\N	\N	147339	147339	147340
29469	48270	5	applied	\N	\N	\N	\N	147341	147341	147342
29469	48271	6	applied	\N	\N	\N	\N	147343	147343	82745
29469	48272	7	applied	\N	\N	\N	\N	147344	147344	82751
29471	48277	0	applied	\N	\N	\N	\N	147356	147356	147357
29471	48278	1	applied	\N	\N	\N	\N	147358	147358	147359
29471	48279	2	applied	\N	\N	\N	\N	147360	147360	82775
29474	48284	0	applied	\N	\N	\N	\N	147371	147371	147372
29474	48285	1	applied	\N	\N	\N	\N	147373	147373	142216
29474	48286	2	applied	\N	\N	\N	\N	147374	147374	147375
29474	48287	3	applied	\N	\N	\N	\N	147376	147376	147377
29474	48288	4	applied	\N	\N	\N	\N	147378	147378	82818
29474	48289	5	applied	\N	\N	\N	\N	147379	147379	147380
29474	48290	6	applied	\N	\N	\N	\N	147381	147381	147382
29478	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29478	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29478	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29478	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29478	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29478	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29478	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29478	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29478	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29478	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29478	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29480	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29480	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29480	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29480	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29480	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29480	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29480	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29480	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29480	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29480	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29480	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29484	48302	0	applied	\N	\N	\N	\N	147413	147413	147414
29484	48303	1	applied	\N	\N	\N	\N	147415	147415	147416
29484	48304	2	applied	\N	\N	\N	\N	147417	147417	147418
29488	48320	0	applied	\N	\N	\N	\N	147449	147449	147450
29488	48321	1	applied	\N	\N	\N	\N	147451	147451	147452
29488	48322	2	applied	\N	\N	\N	\N	147453	147453	147454
29488	48323	3	applied	\N	\N	\N	\N	147455	147455	82899
29488	48324	4	applied	\N	\N	\N	\N	147456	147456	82917
29488	48325	5	applied	\N	\N	\N	\N	147457	147457	82929
29488	48326	6	applied	\N	\N	\N	\N	147458	147458	147459
29497	48341	0	applied	\N	\N	\N	\N	147493	147493	147494
29497	48342	1	applied	\N	\N	\N	\N	147495	147495	82969
29497	48343	2	applied	\N	\N	\N	\N	147496	147496	147497
29499	48348	0	applied	\N	\N	\N	\N	147513	147513	147514
29499	48349	1	applied	\N	\N	\N	\N	147515	147515	147516
29501	48350	0	applied	\N	\N	\N	\N	147519	147519	147520
29501	48351	1	applied	\N	\N	\N	\N	147521	147521	82987
29507	48369	0	applied	\N	\N	\N	\N	147558	147558	147559
29507	48370	1	applied	\N	\N	\N	\N	147560	147560	83066
29507	48371	2	applied	\N	\N	\N	\N	147561	147561	147562
29509	48372	0	applied	\N	\N	\N	\N	147563	147563	147564
29509	48373	1	applied	\N	\N	\N	\N	147565	147565	147565
29509	48374	2	applied	\N	\N	\N	\N	147566	147566	147567
29509	48375	3	applied	\N	\N	\N	\N	147568	147568	83068
29515	48387	0	applied	\N	\N	\N	\N	147598	147598	147599
29515	48388	1	applied	\N	\N	\N	\N	147600	147600	147601
29515	48389	2	applied	\N	\N	\N	\N	147602	147602	147603
29515	48390	4	applied	\N	\N	\N	\N	147605	147605	147606
29515	48391	5	applied	\N	\N	\N	\N	147607	147607	147608
29515	48392	6	applied	\N	\N	\N	\N	147609	147609	147610
29515	48393	7	applied	\N	\N	\N	\N	147611	147611	83092
29520	48405	0	applied	\N	\N	\N	\N	147642	147642	83143
29520	48406	1	applied	\N	\N	\N	\N	147643	147643	83145
29522	48405	0	applied	\N	\N	\N	\N	147642	147642	83143
29522	48406	1	applied	\N	\N	\N	\N	147643	147643	83145
29524	48407	0	applied	\N	\N	\N	\N	147653	147653	147654
29427	48160	0	applied	\N	\N	\N	\N	147093	147093	147094
29427	48161	1	applied	\N	\N	\N	\N	147095	147095	147096
29427	48162	2	applied	\N	\N	\N	\N	147097	147097	147098
29427	48163	3	applied	\N	\N	\N	\N	147099	147099	82465
29429	48164	0	applied	\N	\N	\N	\N	147103	147103	147104
29429	48165	1	applied	\N	\N	\N	\N	147105	147105	147106
29429	48166	2	applied	\N	\N	\N	\N	147107	147107	82477
29435	48167	0	applied	\N	\N	\N	\N	147116	147116	147117
29435	48168	1	applied	\N	\N	\N	\N	147118	147118	147119
29435	48169	2	applied	\N	\N	\N	\N	147120	147120	82488
29437	48174	0	applied	\N	\N	\N	\N	147131	147131	147132
29437	48175	1	applied	\N	\N	\N	\N	147133	147133	147134
29437	48176	2	applied	\N	\N	\N	\N	147135	147135	82500
29437	48177	3	applied	\N	\N	\N	\N	147136	147136	147137
29439	48181	0	applied	\N	\N	\N	\N	147147	147147	147148
29439	48182	1	applied	\N	\N	\N	\N	147149	147149	147150
29439	48183	2	applied	\N	\N	\N	\N	147151	147151	147152
29441	48184	0	applied	\N	\N	\N	\N	147155	147155	147156
29441	48185	1	applied	\N	\N	\N	\N	147157	147157	147158
29441	48186	2	applied	\N	\N	\N	\N	147159	147159	147160
29441	48187	3	applied	\N	\N	\N	\N	147161	147161	147162
29441	48188	4	applied	\N	\N	\N	\N	147163	147163	82525
29441	48189	5	applied	\N	\N	\N	\N	147164	147164	82529
29441	48190	6	applied	\N	\N	\N	\N	147165	147165	82552
29441	48191	7	applied	\N	\N	1000000000	\N	147166	147166	147167
29441	48192	8	applied	\N	\N	1000000000	\N	147168	147168	147169
29441	48193	9	applied	\N	\N	\N	\N	147170	147170	147171
29441	48194	10	applied	\N	\N	\N	\N	147172	147172	147173
29441	48195	11	applied	\N	\N	\N	\N	147174	147174	82556
29441	48196	12	applied	\N	\N	\N	\N	147175	147175	147176
29441	48197	13	applied	\N	\N	\N	\N	147177	147177	82558
29451	48221	0	applied	\N	\N	\N	\N	147233	147233	147234
29451	48222	1	applied	\N	\N	\N	\N	147235	147235	147236
29451	48223	2	applied	\N	\N	\N	\N	147237	147237	147238
29451	48224	3	applied	\N	\N	\N	\N	147239	147239	82628
29451	48220	4	applied	\N	\N	\N	\N	147231	147231	147240
29451	48225	5	applied	\N	\N	\N	\N	147241	147241	82634
29451	48226	6	applied	\N	\N	\N	\N	147242	147242	82635
29453	48227	0	applied	\N	\N	\N	\N	147243	147243	147244
29453	48228	1	applied	\N	\N	\N	\N	147245	147245	147246
29453	48229	2	applied	\N	\N	\N	\N	147247	147247	147248
29453	48230	3	applied	\N	\N	\N	\N	147249	147249	147250
29455	48233	0	applied	\N	\N	\N	\N	147260	147260	147261
29455	48234	1	applied	\N	\N	\N	\N	147262	147262	82658
29455	48235	2	applied	\N	\N	\N	\N	147263	147263	82660
29455	48236	3	applied	\N	\N	\N	\N	147264	147264	147265
29462	48247	0	applied	\N	\N	\N	\N	147291	147291	147292
29462	48248	1	applied	\N	\N	\N	\N	147293	147293	147294
29462	48249	2	applied	\N	\N	\N	\N	147295	147295	147296
29464	48250	0	applied	\N	\N	\N	\N	147298	147298	147299
29464	48251	1	applied	\N	\N	\N	\N	147300	147300	147301
29464	48252	2	applied	\N	\N	\N	\N	147302	147302	82706
29476	48291	0	applied	\N	\N	\N	\N	147386	147386	147386
29476	48292	1	applied	\N	\N	\N	\N	147387	147387	147388
29476	48293	2	applied	\N	\N	\N	\N	147389	147389	147390
29476	48294	3	applied	\N	\N	\N	\N	147391	147391	147392
29476	48295	4	applied	\N	\N	\N	\N	147393	147393	147394
29476	48296	5	applied	\N	\N	\N	\N	147395	147395	82821
29476	48297	6	applied	\N	\N	\N	\N	147396	147396	147397
29476	48298	7	applied	\N	\N	\N	\N	147398	147398	147399
29476	48299	8	applied	\N	\N	\N	\N	147400	147400	147401
29476	48300	9	applied	\N	\N	\N	\N	147402	147402	147403
29476	48301	10	applied	\N	\N	\N	\N	147404	147404	82846
29487	48314	0	applied	\N	\N	\N	\N	147440	147440	147441
29487	48315	1	applied	\N	\N	\N	\N	147442	147442	147443
29487	48316	2	applied	\N	\N	\N	\N	147444	147444	83794
29487	48317	3	applied	\N	\N	\N	\N	147445	147445	147446
29487	48318	4	applied	\N	\N	\N	\N	147447	147447	83795
29487	48319	5	applied	\N	\N	\N	\N	147448	147448	82895
29489	48320	0	applied	\N	\N	\N	\N	147449	147449	147450
29489	48321	1	applied	\N	\N	\N	\N	147451	147451	147452
29489	48322	2	applied	\N	\N	\N	\N	147453	147453	147454
29489	48323	3	applied	\N	\N	\N	\N	147455	147455	82899
29489	48324	4	applied	\N	\N	\N	\N	147456	147456	82917
29489	48325	5	applied	\N	\N	\N	\N	147457	147457	82929
29489	48326	6	applied	\N	\N	\N	\N	147458	147458	147459
29500	48350	0	applied	\N	\N	\N	\N	147519	147519	147520
29500	48351	1	applied	\N	\N	\N	\N	147521	147521	82987
29502	48352	0	applied	\N	\N	\N	\N	147523	147523	147524
29502	48353	1	applied	\N	\N	\N	\N	147525	147525	147526
29502	48354	2	applied	\N	\N	\N	\N	147527	147527	82995
29502	48355	3	applied	\N	\N	\N	\N	147528	147528	147529
29504	48358	0	applied	\N	\N	\N	\N	147536	147536	147537
29504	48359	1	applied	\N	\N	\N	\N	147538	147538	147539
29504	48360	2	applied	\N	\N	\N	\N	147540	147540	147541
29506	48364	0	applied	\N	\N	\N	\N	147549	147549	147550
29506	48365	1	applied	\N	\N	\N	\N	147551	147551	147552
29506	48366	2	applied	\N	\N	\N	\N	147553	147553	83063
29506	48367	3	applied	\N	\N	\N	\N	147554	147554	83064
29506	48368	4	applied	\N	\N	\N	\N	147555	147555	83042
29508	48369	0	applied	\N	\N	\N	\N	147558	147558	147559
29508	48370	1	applied	\N	\N	\N	\N	147560	147560	83066
29508	48371	2	applied	\N	\N	\N	\N	147561	147561	147562
29513	48383	0	applied	\N	\N	\N	\N	147588	147588	147589
29513	48384	1	applied	\N	\N	\N	\N	147590	147590	147591
29513	48385	2	applied	\N	\N	\N	\N	147592	147592	83081
29513	48386	3	applied	\N	\N	\N	\N	147593	147593	12588
29516	48387	0	applied	\N	\N	\N	\N	147598	147598	147599
29516	48388	1	applied	\N	\N	\N	\N	147600	147600	147601
29516	48389	2	applied	\N	\N	\N	\N	147602	147602	147603
29516	48390	4	applied	\N	\N	\N	\N	147605	147605	147606
29516	48391	5	applied	\N	\N	\N	\N	147607	147607	147608
29516	48392	6	applied	\N	\N	\N	\N	147609	147609	147610
29516	48393	7	applied	\N	\N	\N	\N	147611	147611	83092
29518	48394	0	applied	\N	\N	\N	\N	147620	147620	147621
29518	48395	1	applied	\N	\N	\N	\N	147622	147622	147623
29518	48396	2	applied	\N	\N	\N	\N	147624	147624	147625
29518	48397	3	applied	\N	\N	\N	\N	147626	147626	147627
29518	48398	4	applied	\N	\N	\N	\N	147628	147628	83112
29518	48399	5	applied	\N	\N	\N	\N	147629	147629	83113
29518	48400	6	applied	\N	\N	\N	\N	147630	147630	147631
29518	48401	7	applied	\N	\N	\N	\N	147632	147632	147633
29518	48402	8	applied	\N	\N	\N	\N	147634	147634	147635
29518	48403	9	applied	\N	\N	\N	\N	147636	147636	147637
29518	48404	10	applied	\N	\N	\N	\N	147638	147638	147639
29523	48405	0	applied	\N	\N	\N	\N	147642	147642	83143
29523	48406	1	applied	\N	\N	\N	\N	147643	147643	83145
29525	48407	0	applied	\N	\N	\N	\N	147653	147653	147654
29525	48408	1	applied	\N	\N	\N	\N	147655	147655	147656
29486	48312	7	applied	\N	\N	\N	\N	147436	147436	82873
29486	48313	8	applied	\N	\N	\N	\N	147437	147437	147438
29492	48339	0	applied	\N	\N	\N	\N	147487	147487	147488
29492	48340	1	applied	\N	\N	\N	\N	147489	147489	147490
29494	48341	0	applied	\N	\N	\N	\N	147493	147493	147494
29494	48342	1	applied	\N	\N	\N	\N	147495	147495	82969
29494	48343	2	applied	\N	\N	\N	\N	147496	147496	147497
29496	48341	0	applied	\N	\N	\N	\N	147493	147493	147494
29496	48342	1	applied	\N	\N	\N	\N	147495	147495	82969
29496	48343	2	applied	\N	\N	\N	\N	147496	147496	147497
29505	48361	0	applied	\N	\N	\N	\N	147544	147544	147545
29505	48362	1	applied	\N	\N	\N	\N	147546	147546	83061
29505	48363	2	applied	\N	\N	\N	\N	147547	147547	147548
29510	48376	0	applied	\N	\N	\N	\N	147571	147571	147572
29510	48377	1	applied	\N	\N	\N	\N	147573	147573	147574
29510	48378	2	applied	\N	\N	\N	\N	147575	147575	147575
29510	48379	3	applied	\N	\N	\N	\N	147576	147576	83048
29510	48380	4	applied	\N	\N	\N	\N	147577	147577	147578
29510	48381	5	applied	\N	\N	\N	\N	147579	147579	147580
29510	48382	6	applied	\N	\N	\N	\N	147581	147581	147582
29512	48376	0	applied	\N	\N	\N	\N	147571	147571	147572
29512	48377	1	applied	\N	\N	\N	\N	147573	147573	147574
29512	48378	2	applied	\N	\N	\N	\N	147575	147575	147575
29512	48379	3	applied	\N	\N	\N	\N	147576	147576	83048
29512	48380	4	applied	\N	\N	\N	\N	147577	147577	147578
29512	48381	5	applied	\N	\N	\N	\N	147579	147579	147580
29512	48382	6	applied	\N	\N	\N	\N	147581	147581	147582
29514	48383	0	applied	\N	\N	\N	\N	147588	147588	147589
29514	48384	1	applied	\N	\N	\N	\N	147590	147590	147591
29514	48385	2	applied	\N	\N	\N	\N	147592	147592	83081
29514	48386	3	applied	\N	\N	\N	\N	147593	147593	12588
29517	48387	0	applied	\N	\N	\N	\N	147598	147598	147599
29517	48388	1	applied	\N	\N	\N	\N	147600	147600	147601
29517	48389	2	applied	\N	\N	\N	\N	147602	147602	147603
29517	48390	4	applied	\N	\N	\N	\N	147605	147605	147606
29517	48391	5	applied	\N	\N	\N	\N	147607	147607	147608
29517	48392	6	applied	\N	\N	\N	\N	147609	147609	147610
29517	48393	7	applied	\N	\N	\N	\N	147611	147611	83092
29521	48405	0	applied	\N	\N	\N	\N	147642	147642	83143
29521	48406	1	applied	\N	\N	\N	\N	147643	147643	83145
29526	48413	0	applied	\N	\N	\N	\N	147666	147666	147667
29526	48414	1	applied	\N	\N	\N	\N	147668	147668	147669
29526	48415	2	applied	\N	\N	\N	\N	147670	147670	83178
29526	48416	3	applied	\N	\N	\N	\N	147671	147671	147672
29528	48417	0	applied	\N	\N	\N	\N	147673	147673	147674
29528	48418	1	applied	\N	\N	\N	\N	147675	147675	147676
29530	48419	0	applied	\N	\N	\N	\N	147683	147683	147684
29530	48420	1	applied	\N	\N	\N	\N	147685	147685	83191
29530	48421	2	applied	\N	\N	\N	\N	147686	147686	147687
29530	48422	3	applied	\N	\N	\N	\N	147688	147688	83195
29532	48419	0	applied	\N	\N	\N	\N	147683	147683	147684
29532	48420	1	applied	\N	\N	\N	\N	147685	147685	83191
29532	48421	2	applied	\N	\N	\N	\N	147686	147686	147687
29532	48422	3	applied	\N	\N	\N	\N	147688	147688	83195
29534	48419	0	applied	\N	\N	\N	\N	147683	147683	147684
29534	48420	1	applied	\N	\N	\N	\N	147685	147685	83191
29534	48421	2	applied	\N	\N	\N	\N	147686	147686	147687
29534	48422	3	applied	\N	\N	\N	\N	147688	147688	83195
29536	48423	0	applied	\N	\N	\N	\N	147697	147697	147698
29536	48424	1	applied	\N	\N	\N	\N	147699	147699	83197
29536	48425	2	applied	\N	\N	\N	\N	147700	147700	147701
29538	48423	0	applied	\N	\N	\N	\N	147697	147697	147698
29538	48424	1	applied	\N	\N	\N	\N	147699	147699	83197
29538	48425	2	applied	\N	\N	\N	\N	147700	147700	147701
29548	48442	0	applied	\N	\N	\N	\N	147741	147741	147742
29548	48443	1	applied	\N	\N	\N	\N	147743	147743	147744
29548	48444	2	applied	\N	\N	\N	\N	147745	147745	147746
29548	48445	3	applied	\N	\N	\N	\N	147747	147747	83254
29548	48446	4	applied	\N	\N	\N	\N	147748	147748	147749
29548	48447	5	applied	\N	\N	\N	\N	147750	147750	83258
29548	48448	6	applied	\N	\N	\N	\N	147751	147751	147752
29550	48449	0	applied	\N	\N	\N	\N	147759	147759	147760
29550	48450	1	applied	\N	\N	\N	\N	147761	147761	147762
29552	48451	0	applied	\N	\N	\N	\N	147765	147765	147766
29552	48452	1	applied	\N	\N	\N	\N	147767	147767	147768
29552	48453	2	applied	\N	\N	\N	\N	147769	147769	83264
29552	48454	3	applied	\N	\N	\N	\N	147770	147770	83312
29552	48456	4	applied	\N	\N	\N	\N	147772	147772	147773
29552	48458	5	applied	\N	\N	\N	\N	147776	147776	147775
29554	48451	0	applied	\N	\N	\N	\N	147765	147765	147766
29554	48452	1	applied	\N	\N	\N	\N	147767	147767	147768
29554	48453	2	applied	\N	\N	\N	\N	147769	147769	83264
29554	48454	3	applied	\N	\N	\N	\N	147770	147770	83312
29554	48455	4	applied	\N	\N	\N	\N	147771	147771	83314
29554	48456	5	applied	\N	\N	\N	\N	147772	147772	147773
29554	48457	6	applied	\N	\N	\N	\N	147774	147774	147775
29554	48458	7	applied	\N	\N	\N	\N	147776	147776	147777
29558	48462	0	applied	\N	\N	\N	\N	147795	147795	147796
29558	48463	1	applied	\N	\N	\N	\N	147797	147797	83334
29558	48464	2	applied	\N	\N	\N	\N	147798	147798	83364
29560	48358	0	applied	\N	\N	\N	\N	147536	147536	147537
29560	48361	1	applied	\N	\N	\N	\N	147544	147544	147545
29560	48364	2	applied	\N	\N	\N	\N	147549	147549	147550
29560	48365	3	applied	\N	\N	\N	\N	147551	147551	147552
29560	48369	4	applied	\N	\N	\N	\N	147558	147558	147559
29560	48372	5	applied	\N	\N	\N	\N	147563	147563	147564
29560	48376	6	applied	\N	\N	\N	\N	147571	147571	147572
29560	48377	7	applied	\N	\N	\N	\N	147573	147573	147574
29560	48383	8	applied	\N	\N	\N	\N	147588	147588	147589
29560	48387	9	applied	\N	\N	\N	\N	147598	147598	147599
29560	48388	10	applied	\N	\N	\N	\N	147600	147600	147601
29560	48394	11	applied	\N	\N	\N	\N	147620	147620	147621
29560	48395	12	applied	\N	\N	\N	\N	147622	147622	147623
29560	48396	13	applied	\N	\N	\N	\N	147624	147624	147625
29560	48407	14	applied	\N	\N	\N	\N	147653	147653	147654
29560	48408	15	applied	\N	\N	\N	\N	147655	147655	147656
29560	48413	16	applied	\N	\N	\N	\N	147666	147666	147667
29560	48417	17	applied	\N	\N	\N	\N	147673	147673	147674
29560	48419	18	applied	\N	\N	\N	\N	147683	147683	147684
29560	48423	19	applied	\N	\N	\N	\N	147697	147697	147698
29560	48426	20	applied	\N	\N	\N	\N	147708	147708	147709
29560	48427	21	applied	\N	\N	\N	\N	147710	147710	147711
29560	48433	22	applied	\N	\N	\N	\N	147720	147720	147721
29560	48434	23	applied	\N	\N	\N	\N	147722	147722	147723
29560	48439	24	applied	\N	\N	\N	\N	147735	147735	147736
29560	48442	25	applied	\N	\N	\N	\N	147741	147741	147742
29560	48443	26	applied	\N	\N	\N	\N	147743	147743	147744
29560	48449	27	applied	\N	\N	\N	\N	147759	147759	147760
29560	48451	28	applied	\N	\N	\N	\N	147765	147765	147766
29560	48452	29	applied	\N	\N	\N	\N	147767	147767	147768
29491	48333	6	applied	\N	\N	\N	\N	147476	147476	147477
29491	48334	7	applied	\N	\N	\N	\N	147478	147478	147479
29491	48335	8	applied	\N	\N	\N	\N	147480	147480	82942
29491	48336	9	applied	\N	\N	\N	\N	147481	147481	82958
29491	48337	10	applied	\N	\N	\N	\N	147482	147482	147483
29491	48338	11	applied	\N	\N	\N	\N	147484	147484	147485
29493	48339	0	applied	\N	\N	\N	\N	147487	147487	147488
29493	48340	1	applied	\N	\N	\N	\N	147489	147489	147490
29495	48341	0	applied	\N	\N	\N	\N	147493	147493	147494
29495	48342	1	applied	\N	\N	\N	\N	147495	147495	82969
29495	48343	2	applied	\N	\N	\N	\N	147496	147496	147497
29498	48344	0	applied	\N	\N	\N	\N	147503	147503	147504
29498	48345	1	applied	\N	\N	\N	\N	147505	147505	147506
29498	48346	2	applied	\N	\N	\N	\N	147507	147507	147508
29498	48347	3	applied	\N	\N	\N	\N	147509	147509	147510
29503	48356	0	applied	\N	\N	\N	\N	147531	147531	147532
29503	48357	1	applied	\N	\N	\N	\N	147533	147533	83011
29511	48376	0	applied	\N	\N	\N	\N	147571	147571	147572
29511	48377	1	applied	\N	\N	\N	\N	147573	147573	147574
29511	48378	2	applied	\N	\N	\N	\N	147575	147575	147575
29511	48379	3	applied	\N	\N	\N	\N	147576	147576	83048
29511	48380	4	applied	\N	\N	\N	\N	147577	147577	147578
29511	48381	5	applied	\N	\N	\N	\N	147579	147579	147580
29511	48382	6	applied	\N	\N	\N	\N	147581	147581	147582
29519	48405	0	applied	\N	\N	\N	\N	147642	147642	83143
29519	48406	1	applied	\N	\N	\N	\N	147643	147643	83145
29527	48413	0	applied	\N	\N	\N	\N	147666	147666	147667
29527	48414	1	applied	\N	\N	\N	\N	147668	147668	147669
29527	48415	2	applied	\N	\N	\N	\N	147670	147670	83178
29527	48416	3	applied	\N	\N	\N	\N	147671	147671	147672
29529	48227	0	applied	\N	\N	\N	\N	147243	147243	147244
29529	48200	1	applied	\N	\N	\N	\N	147193	147193	147193
29529	48127	2	applied	\N	\N	\N	\N	147016	147016	147017
29529	48201	3	applied	\N	\N	\N	\N	147194	147194	147194
29529	48146	4	applied	\N	\N	1000000000	\N	147060	147060	147061
29529	47457	5	applied	\N	\N	\N	\N	145313	145313	138833
29529	48150	6	applied	\N	\N	\N	\N	147072	147072	147073
29529	47452	7	applied	\N	\N	\N	\N	145303	145303	145304
29529	47456	8	applied	\N	\N	\N	\N	145311	145311	145312
29529	47793	9	applied	\N	\N	\N	\N	146207	146207	146208
29529	47458	10	applied	\N	\N	\N	\N	145314	145314	145315
29529	48291	11	applied	\N	\N	\N	\N	147386	147386	147386
29529	47462	12	applied	\N	\N	\N	\N	145322	145322	145323
29529	48255	13	applied	\N	\N	\N	\N	147309	147309	147678
29529	48265	14	applied	\N	\N	\N	\N	147331	147331	147679
29529	47465	15	applied	\N	\N	\N	\N	145330	145330	145331
29529	47469	16	applied	\N	\N	\N	\N	145346	145346	145347
29529	47471	17	applied	\N	\N	\N	\N	145352	145352	145353
29529	47472	18	applied	\N	\N	\N	\N	145354	145354	145355
29529	48152	19	applied	\N	\N	\N	\N	147076	147076	147077
29529	48155	20	applied	\N	\N	\N	\N	147083	147083	147084
29529	47473	21	applied	\N	\N	\N	\N	145356	145356	145357
29529	47481	22	applied	\N	\N	\N	\N	145372	145372	145373
29529	47483	23	applied	\N	\N	\N	\N	145395	145395	145396
29529	47487	24	applied	\N	\N	\N	\N	145404	145404	145405
29529	47490	25	applied	\N	\N	\N	\N	145412	145412	145413
29529	47491	26	applied	\N	\N	\N	\N	145414	145414	145415
29529	47495	27	applied	\N	\N	\N	\N	145423	145423	145424
29529	47499	28	applied	\N	\N	\N	\N	145433	145433	145434
29529	47502	29	applied	\N	\N	\N	\N	145439	145439	145440
29529	47503	30	applied	\N	\N	\N	\N	145441	145441	145442
29529	47508	31	applied	\N	\N	\N	\N	145451	145451	145452
29529	47509	32	applied	\N	\N	\N	\N	145453	145453	145454
29529	47510	33	applied	\N	\N	\N	\N	145455	145455	145456
29529	47516	34	applied	\N	\N	\N	\N	145485	145485	145486
29529	47520	35	applied	\N	\N	\N	\N	145493	145493	145494
29529	47521	36	applied	\N	\N	\N	\N	145495	145495	145496
29529	47525	37	applied	\N	\N	\N	\N	145502	145502	145503
29529	47529	38	applied	\N	\N	\N	\N	145514	145514	145515
29529	47532	39	applied	\N	\N	\N	\N	145521	145521	145522
29529	47533	40	applied	\N	\N	\N	\N	145523	145523	145524
29529	47538	41	applied	\N	\N	\N	\N	145540	145540	145541
29529	47539	42	applied	\N	\N	\N	\N	145542	145542	145543
29529	47540	43	applied	\N	\N	\N	\N	145544	145544	145545
29529	47541	44	applied	\N	\N	\N	\N	145546	145546	145547
29529	47550	45	applied	\N	\N	\N	\N	145564	145564	145565
29529	47551	46	applied	\N	\N	\N	\N	145566	145566	145567
29529	47554	47	applied	\N	\N	\N	\N	145573	145573	145574
29529	47555	48	applied	\N	\N	\N	\N	145575	145575	145576
29529	47562	49	applied	\N	\N	\N	\N	145591	145591	145592
29529	47563	50	applied	\N	\N	\N	\N	145593	145593	145594
29529	47564	51	applied	\N	\N	\N	\N	145595	145595	145596
29529	47572	52	applied	\N	\N	\N	\N	145609	145609	145610
29529	47574	53	applied	\N	\N	\N	\N	145616	145616	145617
29529	47575	54	applied	\N	\N	\N	\N	145618	145618	145619
29529	47581	55	applied	\N	\N	\N	\N	145629	145629	145630
29529	47583	56	applied	\N	\N	\N	\N	145633	145633	145634
29529	47584	57	applied	\N	\N	\N	\N	145635	145635	145636
29529	47589	58	applied	\N	\N	\N	\N	145648	145648	145649
29529	47592	59	applied	\N	\N	\N	\N	145659	145659	145660
29529	47593	60	applied	\N	\N	\N	\N	145661	145661	145662
29529	47594	61	applied	\N	\N	\N	\N	145663	145663	145664
29529	47601	62	applied	\N	\N	\N	\N	145678	145678	145679
29529	47604	63	applied	\N	\N	\N	\N	145685	145685	145686
29529	47606	64	applied	\N	\N	\N	\N	145690	145690	145691
29529	47610	65	applied	\N	\N	\N	\N	145700	145700	145701
29529	47611	66	applied	\N	\N	\N	\N	145702	145702	145703
29529	47616	67	applied	\N	\N	\N	\N	145713	145713	145714
29529	47617	68	applied	\N	\N	\N	\N	145715	145715	145716
29529	47621	69	applied	\N	\N	\N	\N	145723	145723	145724
29529	47624	70	applied	\N	\N	\N	\N	145730	145730	145731
29529	47627	71	applied	\N	\N	\N	\N	145736	145736	145737
29529	47628	72	applied	\N	\N	\N	\N	145738	145738	145739
29529	47629	73	applied	\N	\N	\N	\N	145740	145740	145741
29529	47635	74	applied	\N	\N	\N	\N	145755	145755	145756
29529	47641	75	applied	\N	\N	\N	\N	145793	145793	145794
29529	47642	76	applied	\N	\N	\N	\N	145795	145795	145796
29529	47643	77	applied	\N	\N	\N	\N	145797	145797	145798
29529	47649	78	applied	\N	\N	\N	\N	145812	145812	145813
29529	47652	79	applied	\N	\N	\N	\N	145820	145820	145821
29529	47655	80	applied	\N	\N	\N	\N	145828	145828	145829
29529	47657	81	applied	\N	\N	\N	\N	145832	145832	145833
29529	47660	82	applied	\N	\N	\N	\N	145840	145840	145841
29529	47663	83	applied	\N	\N	\N	\N	145851	145851	145852
29529	47665	84	applied	\N	\N	\N	\N	145861	145861	145862
29529	47666	85	applied	\N	\N	\N	\N	145863	145863	145864
29529	47671	86	applied	\N	\N	\N	\N	145875	145875	145876
29529	47674	87	applied	\N	\N	\N	\N	145882	145882	145883
29529	47676	88	applied	\N	\N	\N	\N	145887	145887	145888
29529	47680	89	applied	\N	\N	\N	\N	145901	145901	145902
29524	48408	1	applied	\N	\N	\N	\N	147655	147655	147656
29524	48409	2	applied	\N	\N	\N	\N	147657	147657	147658
29524	48410	3	applied	\N	\N	\N	\N	147659	147659	83150
29524	48411	4	applied	\N	\N	\N	\N	147660	147660	83152
29524	48412	5	applied	\N	\N	\N	\N	147661	147661	147662
29531	48419	0	applied	\N	\N	\N	\N	147683	147683	147684
29531	48420	1	applied	\N	\N	\N	\N	147685	147685	83191
29531	48421	2	applied	\N	\N	\N	\N	147686	147686	147687
29531	48422	3	applied	\N	\N	\N	\N	147688	147688	83195
29533	48419	0	applied	\N	\N	\N	\N	147683	147683	147684
29533	48420	1	applied	\N	\N	\N	\N	147685	147685	83191
29533	48421	2	applied	\N	\N	\N	\N	147686	147686	147687
29533	48422	3	applied	\N	\N	\N	\N	147688	147688	83195
29542	48433	0	applied	\N	\N	\N	\N	147720	147720	147721
29542	48434	1	applied	\N	\N	\N	\N	147722	147722	147723
29542	48435	2	applied	\N	\N	\N	\N	147724	147724	83226
29542	48436	3	applied	\N	\N	\N	\N	147725	147725	147726
29542	48437	4	applied	\N	\N	\N	\N	147727	147727	83228
29542	48438	5	applied	\N	\N	\N	\N	147728	147728	147729
29544	48433	0	applied	\N	\N	\N	\N	147720	147720	147721
29544	48434	1	applied	\N	\N	\N	\N	147722	147722	147723
29544	48435	2	applied	\N	\N	\N	\N	147724	147724	83226
29544	48436	3	applied	\N	\N	\N	\N	147725	147725	147726
29544	48437	4	applied	\N	\N	\N	\N	147727	147727	83228
29544	48438	5	applied	\N	\N	\N	\N	147728	147728	147729
29547	48442	0	applied	\N	\N	\N	\N	147741	147741	147742
29547	48443	1	applied	\N	\N	\N	\N	147743	147743	147744
29547	48444	2	applied	\N	\N	\N	\N	147745	147745	147746
29547	48445	3	applied	\N	\N	\N	\N	147747	147747	83254
29547	48446	4	applied	\N	\N	\N	\N	147748	147748	147749
29547	48447	5	applied	\N	\N	\N	\N	147750	147750	83258
29547	48448	6	applied	\N	\N	\N	\N	147751	147751	147752
29553	48451	0	applied	\N	\N	\N	\N	147765	147765	147766
29553	48452	1	applied	\N	\N	\N	\N	147767	147767	147768
29553	48453	2	applied	\N	\N	\N	\N	147769	147769	83264
29553	48454	3	applied	\N	\N	\N	\N	147770	147770	83312
29553	48455	4	applied	\N	\N	\N	\N	147771	147771	83314
29553	48456	5	applied	\N	\N	\N	\N	147772	147772	147773
29553	48457	6	applied	\N	\N	\N	\N	147774	147774	147775
29553	48458	7	applied	\N	\N	\N	\N	147776	147776	147777
29556	48459	0	applied	\N	\N	\N	\N	147786	147786	147787
29556	48460	1	applied	\N	\N	\N	\N	147788	147788	147789
29556	48461	2	applied	\N	\N	\N	\N	147790	147790	147791
29561	48469	0	applied	\N	\N	\N	\N	147831	147831	147832
29561	48470	1	applied	\N	\N	\N	\N	147833	147833	83350
29566	48487	0	applied	\N	\N	\N	\N	147873	147873	147874
29566	48488	1	applied	\N	\N	\N	\N	147875	147875	147876
29566	48489	2	applied	\N	\N	\N	\N	147877	147877	147878
29566	48490	3	applied	\N	\N	\N	\N	147879	147879	83418
29566	48491	4	applied	\N	\N	\N	\N	147880	147880	147881
29566	48492	5	applied	\N	\N	\N	\N	147882	147882	147883
29577	48513	0	applied	\N	\N	\N	\N	147933	147933	147934
29577	48514	1	applied	\N	\N	\N	\N	147935	147935	147936
29579	48515	0	applied	\N	\N	\N	\N	147940	147940	147941
29579	48516	1	applied	\N	\N	\N	\N	147942	147942	83490
29579	48517	2	applied	\N	\N	\N	\N	147943	147943	147944
29579	48518	3	applied	\N	\N	\N	\N	147945	147945	147946
29581	48519	0	applied	\N	\N	\N	\N	147948	147948	147949
29581	48520	1	applied	\N	\N	\N	\N	147950	147950	147951
29581	48521	2	applied	\N	\N	\N	\N	147952	147952	147953
29587	48536	0	applied	\N	\N	\N	\N	147989	147989	147990
29587	48537	1	applied	\N	\N	\N	\N	147991	147991	147992
29587	48538	2	applied	\N	\N	\N	\N	147993	147993	147994
29587	48539	3	applied	\N	\N	\N	\N	147995	147995	83566
29587	48540	4	applied	\N	\N	\N	\N	147996	147996	147997
29587	48541	5	applied	\N	\N	1000000000	\N	147998	147998	147999
29587	48542	6	applied	\N	\N	\N	\N	148000	148000	148001
29587	48543	7	applied	\N	\N	\N	\N	148002	148002	148003
29589	48508	0	applied	\N	\N	\N	\N	147924	147924	147925
29589	48048	1	applied	\N	\N	\N	\N	146839	146839	146840
29589	48509	2	applied	\N	\N	\N	\N	147926	147926	147927
29589	48522	3	applied	\N	\N	\N	\N	147957	147957	147958
29589	48523	4	applied	\N	\N	\N	\N	147959	147959	147960
29589	48050	5	applied	\N	\N	\N	\N	146843	146843	146844
29589	48053	6	applied	\N	\N	\N	\N	146849	146849	146850
29589	48054	7	applied	\N	\N	\N	\N	146851	146851	146852
29589	48060	8	applied	\N	\N	\N	\N	146860	146860	146861
29589	48062	9	applied	\N	\N	\N	\N	146865	146865	146866
29589	48063	10	applied	\N	\N	\N	\N	146867	146867	146868
29589	48064	11	applied	\N	\N	\N	\N	146869	146869	146870
29589	48074	12	applied	\N	\N	\N	\N	146886	146886	146887
29589	48078	13	applied	\N	\N	\N	\N	146894	146894	146895
29589	48082	14	applied	\N	\N	\N	\N	146915	146915	146916
29589	48084	15	applied	\N	\N	\N	\N	146921	146921	146922
29589	48089	16	applied	\N	\N	\N	\N	146931	146931	146932
29589	48092	17	applied	\N	\N	\N	\N	146937	146937	146938
29589	48095	18	applied	\N	\N	\N	\N	146947	146947	146948
29589	48096	19	applied	\N	\N	\N	\N	146949	146949	146950
29589	48101	20	applied	\N	\N	\N	\N	146957	146957	146958
29589	48105	21	applied	\N	\N	\N	\N	146965	146965	146966
29589	48107	22	applied	\N	\N	\N	\N	146971	146971	146972
29589	48111	23	applied	\N	\N	\N	\N	146981	146981	146982
29589	48114	24	applied	\N	\N	\N	\N	146988	146988	146989
29589	48118	25	applied	\N	\N	\N	\N	146996	146996	146997
29589	48119	26	applied	\N	\N	\N	\N	146999	146999	147000
29589	48120	27	applied	\N	\N	\N	\N	147001	147001	147002
29589	48128	28	applied	\N	\N	\N	\N	147022	147022	147023
29589	48129	29	applied	\N	\N	\N	\N	147024	147024	147025
29589	48130	30	applied	\N	\N	\N	\N	147026	147026	147027
29589	48138	31	applied	\N	\N	\N	\N	147042	147042	147043
29589	48141	32	applied	\N	\N	\N	\N	147049	147049	147050
29589	48143	33	applied	\N	\N	\N	\N	147055	147055	147056
29589	48147	34	applied	\N	\N	\N	\N	147062	147062	147063
29589	48151	35	applied	\N	\N	\N	\N	147074	147074	147075
29589	48156	36	applied	\N	\N	\N	\N	147085	147085	147086
29589	48160	37	applied	\N	\N	\N	\N	147093	147093	147094
29589	48164	38	applied	\N	\N	\N	\N	147103	147103	147104
29589	48167	39	applied	\N	\N	\N	\N	147116	147116	147117
29589	48170	40	applied	\N	\N	\N	\N	147123	147123	147124
29589	48174	41	applied	\N	\N	\N	\N	147131	147131	147132
29589	48178	42	applied	\N	\N	\N	\N	147140	147140	147141
29589	48181	43	applied	\N	\N	\N	\N	147147	147147	147148
29589	48184	44	applied	\N	\N	\N	\N	147155	147155	147156
29589	48185	45	applied	\N	\N	\N	\N	147157	147157	147158
29589	48186	46	applied	\N	\N	\N	\N	147159	147159	147160
29589	48187	47	applied	\N	\N	\N	\N	147161	147161	147162
29589	48198	48	applied	\N	\N	\N	\N	147183	147183	147184
29589	48202	49	applied	\N	\N	\N	\N	147195	147195	147196
29589	48206	50	applied	\N	\N	\N	\N	147203	147203	147204
29589	48209	51	applied	\N	\N	\N	\N	147210	147210	147211
29525	48409	2	applied	\N	\N	\N	\N	147657	147657	147658
29525	48410	3	applied	\N	\N	\N	\N	147659	147659	83150
29525	48411	4	applied	\N	\N	\N	\N	147660	147660	83152
29525	48412	5	applied	\N	\N	\N	\N	147661	147661	147662
29537	48423	0	applied	\N	\N	\N	\N	147697	147697	147698
29537	48424	1	applied	\N	\N	\N	\N	147699	147699	83197
29537	48425	2	applied	\N	\N	\N	\N	147700	147700	147701
29541	48426	0	applied	\N	\N	\N	\N	147708	147708	147709
29541	48427	1	applied	\N	\N	\N	\N	147710	147710	147711
29541	48428	2	applied	\N	\N	\N	\N	147712	147712	83207
29541	48429	3	applied	\N	\N	\N	\N	147713	147713	147714
29541	48430	4	applied	\N	\N	\N	\N	147715	147715	147715
29541	48431	5	applied	\N	\N	\N	\N	147716	147716	147717
29541	48432	6	applied	\N	\N	\N	\N	147718	147718	147719
29543	48433	0	applied	\N	\N	\N	\N	147720	147720	147721
29543	48434	1	applied	\N	\N	\N	\N	147722	147722	147723
29543	48435	2	applied	\N	\N	\N	\N	147724	147724	83226
29543	48436	3	applied	\N	\N	\N	\N	147725	147725	147726
29543	48437	4	applied	\N	\N	\N	\N	147727	147727	83228
29543	48438	5	applied	\N	\N	\N	\N	147728	147728	147729
29545	48439	0	applied	\N	\N	\N	\N	147735	147735	147736
29545	48440	1	applied	\N	\N	\N	\N	147737	147737	147738
29545	48441	2	applied	\N	\N	\N	\N	147739	147739	83239
29549	48442	0	applied	\N	\N	\N	\N	147741	147741	147742
29549	48443	1	applied	\N	\N	\N	\N	147743	147743	147744
29549	48444	2	applied	\N	\N	\N	\N	147745	147745	147746
29549	48445	3	applied	\N	\N	\N	\N	147747	147747	83254
29549	48446	4	applied	\N	\N	\N	\N	147748	147748	147749
29549	48447	5	applied	\N	\N	\N	\N	147750	147750	83258
29549	48448	6	applied	\N	\N	\N	\N	147751	147751	147752
29559	48465	0	applied	\N	\N	\N	\N	147800	147800	147801
29559	48466	1	applied	\N	\N	\N	\N	147802	147802	147803
29559	48467	2	applied	\N	\N	\N	\N	147804	147804	83344
29559	48468	3	applied	\N	\N	\N	\N	147805	147805	83365
29562	48471	0	applied	\N	\N	\N	\N	147836	147836	147837
29562	48472	1	applied	\N	\N	\N	\N	147838	147838	147839
29562	48473	2	applied	\N	\N	\N	\N	147840	147840	147841
29562	48474	3	applied	\N	\N	\N	\N	147842	147842	147843
29562	48475	4	applied	\N	\N	\N	\N	147844	147844	147845
29562	48476	5	applied	\N	\N	\N	\N	147846	147846	147847
29562	48477	6	applied	\N	\N	\N	\N	147848	147848	147849
29562	48478	7	applied	\N	\N	\N	\N	147850	147850	147851
29562	48479	8	applied	\N	\N	\N	\N	147852	147852	147853
29562	48480	9	applied	\N	\N	\N	\N	147854	147854	83388
29564	48481	0	applied	\N	\N	\N	\N	147857	147857	147858
29564	48482	1	applied	\N	\N	\N	\N	147859	147859	83390
29569	48487	0	applied	\N	\N	\N	\N	147873	147873	147874
29569	48488	1	applied	\N	\N	\N	\N	147875	147875	147876
29569	48489	2	applied	\N	\N	\N	\N	147877	147877	147878
29569	48490	3	applied	\N	\N	\N	\N	147879	147879	83418
29569	48491	4	applied	\N	\N	\N	\N	147880	147880	147881
29569	48492	5	applied	\N	\N	\N	\N	147882	147882	147883
29571	48499	0	applied	\N	\N	\N	\N	147899	147899	147900
29571	48500	1	applied	\N	\N	\N	\N	147901	147901	147902
29571	48501	2	applied	\N	\N	\N	\N	147903	147903	147904
29573	48499	0	applied	\N	\N	\N	\N	147899	147899	147900
29573	48501	1	applied	\N	\N	\N	\N	147903	147903	83442
29580	48519	0	applied	\N	\N	\N	\N	147948	147948	147949
29580	48520	1	applied	\N	\N	\N	\N	147950	147950	147951
29580	48521	2	applied	\N	\N	\N	\N	147952	147952	147953
29583	48533	0	applied	\N	\N	\N	\N	147977	147977	147978
29583	48534	1	applied	\N	\N	\N	\N	147979	147979	147980
29583	48535	2	applied	\N	\N	\N	\N	147981	147981	147982
29586	48533	0	applied	\N	\N	\N	\N	147977	147977	147978
29586	48534	1	applied	\N	\N	\N	\N	147979	147979	147980
29586	48535	2	applied	\N	\N	\N	\N	147981	147981	147982
29592	48549	0	applied	\N	\N	\N	\N	148023	148023	148024
29592	48550	1	applied	\N	\N	\N	\N	148025	148025	148026
29592	48551	2	applied	\N	\N	\N	\N	148027	148027	148028
29592	48552	3	applied	\N	\N	\N	\N	148029	148029	148030
29592	48553	4	applied	\N	\N	\N	\N	148031	148031	148032
29592	48554	5	applied	\N	\N	\N	\N	148033	148033	83622
29594	48555	0	applied	\N	\N	\N	\N	148037	148037	148038
29594	48556	1	applied	\N	\N	\N	\N	148039	148039	148040
29594	48557	2	applied	\N	\N	\N	\N	148041	148041	148042
29596	48558	0	applied	\N	\N	\N	\N	148043	148043	148044
29596	48559	1	applied	\N	\N	\N	\N	148045	148045	148046
29596	48560	2	applied	\N	\N	\N	\N	148047	148047	148048
29596	48561	3	applied	\N	\N	\N	\N	148049	148049	148050
29596	48562	4	applied	\N	\N	\N	\N	148051	148051	148052
29596	48563	5	applied	\N	\N	\N	\N	148053	148053	83632
29596	48564	6	applied	\N	\N	\N	\N	148054	148054	83634
29596	48565	7	applied	\N	\N	\N	\N	148055	148055	148056
29596	48566	8	applied	\N	\N	\N	\N	148057	148057	148058
29596	48567	9	applied	\N	\N	\N	\N	148059	148059	148060
29596	48568	10	applied	\N	\N	\N	\N	148061	148061	148062
29596	48569	11	applied	\N	\N	\N	\N	148063	148063	83656
29600	48578	0	applied	\N	\N	\N	\N	148085	148085	148086
29600	48580	1	applied	\N	\N	\N	\N	148089	148089	148095
29600	48581	2	applied	\N	\N	\N	\N	148091	148091	83695
29608	48595	0	applied	\N	\N	\N	\N	148151	148151	148152
29608	48596	1	applied	\N	\N	\N	\N	148153	148153	83748
29608	48597	2	applied	\N	\N	\N	\N	148154	148154	83750
29610	48598	0	applied	\N	\N	\N	\N	148160	148160	148161
29610	48599	1	applied	\N	\N	\N	\N	148162	148162	148163
29610	48600	2	applied	\N	\N	\N	\N	148164	148164	148165
29612	48614	0	applied	\N	\N	\N	\N	148193	148193	148194
29612	48615	1	applied	\N	\N	\N	\N	148195	148195	148196
29612	48616	2	applied	\N	\N	\N	\N	148197	148197	148198
29612	48617	3	applied	\N	\N	\N	\N	148199	148199	83826
29612	48618	4	applied	\N	\N	\N	\N	148200	148200	148201
29612	48619	5	applied	\N	\N	\N	\N	148202	148202	83843
29612	48620	6	applied	\N	\N	\N	\N	148203	148203	83847
29620	48634	0	applied	\N	\N	\N	\N	148239	148239	148240
29620	48635	1	applied	\N	\N	\N	\N	148241	148241	148242
29620	48636	2	applied	\N	\N	\N	\N	148243	148243	83916
29620	48637	3	applied	\N	\N	\N	\N	148244	148244	148245
29620	48638	4	applied	\N	\N	\N	\N	148246	148246	83918
29620	48639	5	applied	\N	\N	\N	\N	148247	148247	83922
29622	48634	0	applied	\N	\N	\N	\N	148239	148239	148240
29622	48635	1	applied	\N	\N	\N	\N	148241	148241	148242
29622	48636	2	applied	\N	\N	\N	\N	148243	148243	83916
29622	48637	3	applied	\N	\N	\N	\N	148244	148244	148245
29622	48638	4	applied	\N	\N	\N	\N	148246	148246	83918
29622	48639	5	applied	\N	\N	\N	\N	148247	148247	83922
29625	48646	0	applied	\N	\N	\N	\N	148264	148264	148265
29625	48647	1	applied	\N	\N	\N	\N	148266	148266	148267
29625	48648	2	applied	\N	\N	\N	\N	148268	148268	148269
29625	48649	3	applied	\N	\N	\N	\N	148270	148270	148271
29625	48650	4	applied	\N	\N	\N	\N	148272	148272	148273
29529	47681	90	applied	\N	\N	\N	\N	145903	145903	145904
29529	47685	91	applied	\N	\N	\N	\N	145912	145912	145913
29529	47689	92	applied	\N	\N	\N	\N	145921	145921	145922
29529	47690	93	applied	\N	\N	\N	\N	145923	145923	145924
29529	47691	95	applied	\N	\N	\N	\N	145925	145925	145926
29529	47697	96	applied	\N	\N	\N	\N	145943	145943	145944
29529	47701	97	applied	\N	\N	\N	\N	145995	145995	145996
29546	48442	0	applied	\N	\N	\N	\N	147741	147741	147742
29546	48443	1	applied	\N	\N	\N	\N	147743	147743	147744
29546	48444	2	applied	\N	\N	\N	\N	147745	147745	147746
29546	48445	3	applied	\N	\N	\N	\N	147747	147747	83254
29546	48446	4	applied	\N	\N	\N	\N	147748	147748	147749
29546	48447	5	applied	\N	\N	\N	\N	147750	147750	83258
29546	48448	6	applied	\N	\N	\N	\N	147751	147751	147752
29551	48451	0	applied	\N	\N	\N	\N	147765	147765	147766
29551	48452	1	applied	\N	\N	\N	\N	147767	147767	147768
29551	48453	2	applied	\N	\N	\N	\N	147769	147769	83264
29551	48454	3	applied	\N	\N	\N	\N	147770	147770	83312
29551	48455	4	applied	\N	\N	\N	\N	147771	147771	83314
29551	48456	5	applied	\N	\N	\N	\N	147772	147772	147773
29551	48457	6	applied	\N	\N	\N	\N	147774	147774	147775
29551	48458	7	applied	\N	\N	\N	\N	147776	147776	147777
29555	48227	0	applied	\N	\N	\N	\N	147243	147243	147244
29555	48200	1	applied	\N	\N	\N	\N	147193	147193	147193
29555	48127	2	applied	\N	\N	\N	\N	147016	147016	147017
29555	48201	3	applied	\N	\N	\N	\N	147194	147194	147194
29555	48146	4	applied	\N	\N	1000000000	\N	147060	147060	147061
29555	48150	5	applied	\N	\N	\N	\N	147072	147072	147073
29555	47793	6	applied	\N	\N	\N	\N	146207	146207	146208
29555	47701	7	applied	\N	\N	\N	\N	145995	145995	145996
29555	47704	8	applied	\N	\N	\N	\N	146007	146007	146008
29555	48291	9	applied	\N	\N	\N	\N	147386	147386	147386
29555	48255	10	applied	\N	\N	\N	\N	147309	147309	147678
29555	48265	11	applied	\N	\N	\N	\N	147331	147331	147679
29555	47707	12	applied	\N	\N	\N	\N	146014	146014	146015
29555	47710	13	applied	\N	\N	\N	\N	146022	146022	146023
29555	47713	14	applied	\N	\N	\N	\N	146031	146031	146032
29555	47716	15	applied	\N	\N	\N	\N	146037	146037	146038
29555	47719	16	applied	\N	\N	\N	\N	146045	146045	146046
29555	47722	17	applied	\N	\N	\N	\N	146053	146053	146054
29555	47723	18	applied	\N	\N	\N	\N	146055	146055	146056
29555	47727	19	applied	\N	\N	\N	\N	146065	146065	146066
29555	47731	20	applied	\N	\N	\N	\N	146075	146075	146076
29555	47734	21	applied	\N	\N	\N	\N	146080	146080	146081
29555	47735	22	applied	\N	\N	\N	\N	146082	146082	146083
29555	47740	23	applied	\N	\N	\N	\N	146091	146091	146092
29555	48152	24	applied	\N	\N	\N	\N	147076	147076	147077
29555	48155	25	applied	\N	\N	\N	\N	147083	147083	147084
29555	47741	26	applied	\N	\N	\N	\N	146093	146093	146094
29555	47747	27	applied	\N	\N	\N	\N	146103	146103	146104
29555	47751	28	applied	\N	\N	\N	\N	146116	146116	146117
29555	47753	29	applied	\N	\N	\N	\N	146121	146121	146122
29555	47756	30	applied	\N	\N	\N	\N	146126	146126	146127
29555	47759	31	applied	\N	\N	\N	\N	146135	146135	146136
29555	47762	32	applied	\N	\N	\N	\N	146139	146139	146140
29555	47763	33	applied	\N	\N	\N	\N	146141	146141	146142
29555	47768	34	applied	\N	\N	\N	\N	146149	146149	146150
29555	47772	35	applied	\N	\N	\N	\N	146159	146159	146160
29555	47774	36	applied	\N	\N	\N	\N	146164	146164	146165
29555	47777	37	applied	\N	\N	\N	\N	146170	146170	146171
29555	47781	38	applied	\N	\N	\N	\N	146176	146176	146177
29555	47784	39	applied	\N	\N	\N	\N	146184	146184	146185
29555	47786	40	applied	\N	\N	\N	\N	146192	146192	146193
29555	47792	41	applied	\N	\N	\N	\N	146205	146205	146206
29555	47794	42	applied	\N	\N	\N	\N	146209	146209	146210
29555	47796	43	applied	\N	\N	\N	\N	146214	146214	146215
29555	47797	44	applied	\N	\N	\N	\N	146216	146216	146217
29555	47798	45	applied	\N	\N	\N	\N	146218	146218	146219
29555	47799	46	applied	\N	\N	\N	\N	146220	146220	146221
29555	47808	47	applied	\N	\N	\N	\N	146237	146237	146238
29555	47812	48	applied	\N	\N	\N	\N	146246	146246	146247
29555	47813	49	applied	\N	\N	\N	\N	146248	146248	146249
29555	47818	50	applied	\N	\N	\N	\N	146261	146261	146262
29555	47819	51	applied	\N	\N	\N	\N	146263	146263	146264
29555	47820	52	applied	\N	\N	\N	\N	146265	146265	146266
29555	47821	53	applied	\N	\N	\N	\N	146267	146267	146268
29555	47830	54	applied	\N	\N	\N	\N	146286	146286	146287
29555	47831	55	applied	\N	\N	\N	\N	146288	146288	146289
29555	47836	56	applied	\N	\N	\N	\N	146300	146300	146301
29555	47839	57	applied	\N	\N	\N	\N	146322	146322	146323
29555	47840	58	applied	\N	\N	\N	\N	146324	146324	146325
29555	47845	59	applied	\N	\N	\N	\N	146333	146333	146334
29555	47846	60	applied	\N	\N	\N	\N	146335	146335	146336
29555	47852	61	applied	\N	\N	\N	\N	146345	146345	146346
29555	47855	62	applied	\N	\N	\N	\N	146357	146357	146358
29555	47858	63	applied	\N	\N	\N	\N	146365	146365	146366
29555	47859	64	applied	\N	\N	\N	\N	146367	146367	146368
29555	47865	65	applied	\N	\N	\N	\N	146379	146379	146380
29555	47867	66	applied	\N	\N	\N	\N	146385	146385	146386
29555	47870	67	applied	\N	\N	\N	\N	146402	146402	146403
29555	47874	68	applied	\N	\N	\N	\N	146411	146411	146412
29555	47877	69	applied	\N	\N	\N	\N	146419	146419	146420
29555	47878	70	applied	\N	\N	\N	\N	146421	146421	146422
29555	47882	71	applied	\N	\N	\N	\N	146432	146432	146433
29555	47886	72	applied	\N	\N	\N	\N	146439	146439	146440
29555	47887	73	applied	\N	\N	\N	\N	146441	146441	146442
29555	47891	74	applied	\N	\N	\N	\N	146450	146450	146451
29555	47895	75	applied	\N	\N	\N	\N	146459	146459	146460
29555	47896	76	applied	\N	\N	\N	\N	146464	146464	146465
29555	47899	77	applied	\N	\N	\N	\N	146474	146474	146475
29555	47900	78	applied	\N	\N	\N	\N	146476	146476	146477
29555	47906	79	applied	\N	\N	\N	\N	146487	146487	146488
29555	47908	80	applied	\N	\N	\N	\N	146493	146493	146494
29555	47911	81	applied	\N	\N	\N	\N	146501	146501	146502
29555	47915	82	applied	\N	\N	\N	\N	146511	146511	146512
29555	47918	84	applied	\N	\N	\N	\N	146520	146520	146521
29555	47920	85	applied	\N	\N	\N	\N	146525	146525	146526
29555	47924	86	applied	\N	\N	\N	\N	146534	146534	146535
29555	47927	87	applied	\N	\N	\N	\N	146545	146545	146546
29555	47929	88	applied	\N	\N	\N	\N	146551	146551	146552
29555	47930	89	applied	\N	\N	\N	\N	146553	146553	146554
29555	47936	90	applied	\N	\N	\N	\N	146566	146566	146567
29555	47941	91	applied	\N	\N	\N	\N	146584	146584	146585
29555	47944	92	applied	\N	\N	\N	\N	146593	146593	146594
29555	47948	93	applied	\N	\N	\N	\N	146605	146605	146606
29555	47949	94	applied	\N	\N	\N	\N	146607	146607	146608
29555	47954	95	applied	\N	\N	\N	\N	146619	146619	146620
29555	47958	96	applied	\N	\N	\N	\N	146629	146629	146630
29555	47961	97	applied	\N	\N	\N	\N	146637	146637	146638
29555	47964	98	applied	\N	\N	\N	\N	146645	146645	146646
29555	47965	99	applied	\N	\N	\N	\N	146647	146647	146648
29555	47970	100	applied	\N	\N	\N	\N	146661	146661	146662
29555	47973	101	applied	\N	\N	\N	\N	146666	146666	146667
29555	47976	102	applied	\N	\N	\N	\N	146675	146675	146676
29555	47979	103	applied	\N	\N	\N	\N	146681	146681	146682
29555	47980	104	applied	\N	\N	\N	\N	146683	146683	146684
29555	47985	105	applied	\N	\N	\N	\N	146695	146695	146696
29555	47986	106	applied	\N	\N	\N	\N	146697	146697	146698
29555	47991	107	applied	\N	\N	\N	\N	146708	146708	146709
29555	47994	108	applied	\N	\N	\N	\N	146717	146717	146718
29555	47998	109	applied	\N	\N	\N	\N	146726	146726	146727
29555	48000	110	applied	\N	\N	\N	\N	146732	146732	146733
29555	48003	111	applied	\N	\N	\N	\N	146742	146742	146743
29555	48006	112	applied	\N	\N	\N	\N	146749	146749	146750
29555	48009	113	applied	\N	\N	\N	\N	146756	146756	146757
29555	48012	114	applied	\N	\N	\N	\N	146763	146763	146764
29555	48015	115	applied	\N	\N	\N	\N	146770	146770	146771
29555	48018	116	applied	\N	\N	\N	\N	146778	146778	146779
29555	48021	117	applied	\N	\N	\N	\N	146787	146787	146788
29555	48024	118	applied	\N	\N	\N	\N	146794	146794	146795
29555	48027	119	applied	\N	\N	\N	\N	146801	146801	146802
29555	48028	120	applied	\N	\N	\N	\N	146803	146803	146804
29555	48032	121	applied	\N	\N	\N	\N	146810	146810	146811
29555	48033	122	applied	\N	\N	\N	\N	146812	146812	146813
29555	48034	123	applied	\N	\N	\N	\N	146814	146814	146815
29555	48041	124	applied	\N	\N	\N	\N	146826	146826	146827
29555	48044	125	applied	\N	\N	\N	\N	146832	146832	146833
29557	48459	0	applied	\N	\N	\N	\N	147786	147786	147787
29557	48460	1	applied	\N	\N	\N	\N	147788	147788	147789
29557	48461	2	applied	\N	\N	\N	\N	147790	147790	147791
29568	48487	0	applied	\N	\N	\N	\N	147873	147873	147874
29568	48488	1	applied	\N	\N	\N	\N	147875	147875	147876
29568	48489	2	applied	\N	\N	\N	\N	147877	147877	147878
29568	48490	3	applied	\N	\N	\N	\N	147879	147879	83418
29568	48491	4	applied	\N	\N	\N	\N	147880	147880	147881
29568	48492	5	applied	\N	\N	\N	\N	147882	147882	147883
29570	48493	0	applied	\N	\N	\N	\N	147888	147888	147889
29570	48494	1	applied	\N	\N	\N	\N	147890	147890	147891
29570	48495	2	applied	\N	\N	\N	\N	147892	147892	83424
29570	48496	3	applied	\N	\N	\N	\N	147893	147893	147894
29570	48497	4	applied	\N	\N	\N	\N	147895	147895	83430
29570	48498	5	applied	\N	\N	\N	\N	147896	147896	83438
29572	48499	0	applied	\N	\N	\N	\N	147899	147899	147900
29572	48500	1	applied	\N	\N	\N	\N	147901	147901	147902
29572	48501	2	applied	\N	\N	\N	\N	147903	147903	147904
29574	48502	0	applied	\N	\N	\N	\N	147910	147910	147911
29574	48500	1	applied	\N	\N	\N	\N	147901	147901	147904
29574	48503	2	applied	\N	\N	\N	\N	147912	147912	147913
29576	48508	0	applied	\N	\N	\N	\N	147924	147924	147925
29576	48509	1	applied	\N	\N	\N	\N	147926	147926	147927
29576	48510	2	applied	\N	\N	\N	\N	147928	147928	147929
29576	48511	3	applied	\N	\N	\N	\N	147930	147930	83478
29576	48512	4	applied	\N	\N	\N	\N	147931	147931	83488
29582	48522	0	applied	\N	\N	\N	\N	147957	147957	147958
29582	48523	1	applied	\N	\N	\N	\N	147959	147959	147960
29582	48524	2	applied	\N	\N	\N	\N	147961	147961	147962
29582	48525	3	applied	\N	\N	\N	\N	147963	147963	147964
29582	48526	4	applied	\N	\N	\N	\N	147965	147965	147966
29582	48527	5	applied	\N	\N	\N	\N	147967	147967	147968
29582	48528	6	applied	\N	\N	\N	\N	147969	147969	83535
29582	48529	7	applied	\N	\N	\N	\N	147970	147970	83537
29582	48530	8	applied	\N	\N	\N	\N	147971	147971	83544
29582	48531	9	applied	\N	\N	\N	\N	147972	147972	147973
29582	48532	10	applied	\N	\N	\N	\N	147974	147974	83546
29585	48533	0	applied	\N	\N	\N	\N	147977	147977	147978
29585	48534	1	applied	\N	\N	\N	\N	147979	147979	147980
29585	48535	2	applied	\N	\N	\N	\N	147981	147981	147982
29588	48536	0	applied	\N	\N	\N	\N	147989	147989	147990
29588	48537	1	applied	\N	\N	\N	\N	147991	147991	147992
29588	48538	2	applied	\N	\N	\N	\N	147993	147993	147994
29588	48539	3	applied	\N	\N	\N	\N	147995	147995	83566
29588	48540	4	applied	\N	\N	\N	\N	147996	147996	147997
29588	48541	5	applied	\N	\N	1000000000	\N	147998	147998	147999
29588	48542	6	applied	\N	\N	\N	\N	148000	148000	148001
29588	48543	7	applied	\N	\N	\N	\N	148002	148002	148003
29591	48544	0	applied	\N	\N	\N	\N	148010	148010	148011
29591	48545	1	applied	\N	\N	\N	\N	148012	148012	148013
29591	48546	2	applied	\N	\N	\N	\N	148014	148014	148015
29591	48547	3	applied	\N	\N	\N	\N	148016	148016	83579
29591	48548	4	applied	\N	\N	\N	\N	148017	148017	148018
29595	48558	0	applied	\N	\N	\N	\N	148043	148043	148044
29595	48559	1	applied	\N	\N	\N	\N	148045	148045	148046
29595	48560	2	applied	\N	\N	\N	\N	148047	148047	148048
29595	48561	3	applied	\N	\N	\N	\N	148049	148049	148050
29595	48562	4	applied	\N	\N	\N	\N	148051	148051	148052
29595	48563	5	applied	\N	\N	\N	\N	148053	148053	83632
29595	48564	6	applied	\N	\N	\N	\N	148054	148054	83634
29595	48565	7	applied	\N	\N	\N	\N	148055	148055	148056
29595	48566	8	applied	\N	\N	\N	\N	148057	148057	148058
29595	48567	9	applied	\N	\N	\N	\N	148059	148059	148060
29595	48568	10	applied	\N	\N	\N	\N	148061	148061	148062
29595	48569	11	applied	\N	\N	\N	\N	148063	148063	83656
29602	48586	0	applied	\N	\N	\N	\N	148105	148105	148106
29602	48587	1	applied	\N	\N	\N	\N	148107	148107	148108
29602	48588	2	applied	\N	\N	\N	\N	148109	148109	148110
29616	48626	0	applied	\N	\N	\N	\N	148219	148219	83853
29618	48624	0	applied	\N	\N	\N	\N	148215	148215	148216
29618	48627	1	applied	\N	\N	\N	\N	148222	148222	111296
29618	48628	2	applied	\N	\N	\N	\N	148223	148223	148224
29618	48629	3	applied	\N	\N	\N	\N	148225	148225	148226
29618	48630	4	applied	\N	\N	\N	\N	148227	148227	83878
29618	48625	5	applied	\N	\N	\N	\N	148217	148217	148228
29618	48631	6	applied	\N	\N	\N	\N	148229	148229	83889
29618	48632	7	applied	\N	\N	\N	\N	148230	148230	148231
29618	48633	8	applied	\N	\N	\N	\N	148232	148232	148233
29624	48640	0	applied	\N	\N	\N	\N	148251	148251	148252
29624	48641	1	applied	\N	\N	\N	\N	148253	148253	148254
29624	48642	2	applied	\N	\N	\N	\N	148255	148255	44452
29624	48643	3	applied	\N	\N	\N	\N	148256	148256	83924
29624	48644	4	applied	\N	\N	\N	\N	148257	148257	148258
29624	48645	5	applied	\N	\N	\N	\N	148259	148259	83934
29629	48659	0	applied	\N	\N	\N	\N	148287	148287	148288
29629	48660	1	applied	\N	\N	\N	\N	148289	148289	148290
29629	48661	2	applied	\N	\N	\N	\N	148291	148291	148292
29633	48662	0	applied	\N	\N	\N	\N	148299	148299	148300
29633	48663	1	applied	\N	\N	\N	\N	148301	148301	148302
29633	48664	2	applied	\N	\N	\N	\N	148303	148303	148304
29633	48665	3	applied	\N	\N	\N	\N	148305	148305	148306
29633	48666	4	applied	\N	\N	\N	\N	148307	148307	83984
29648	48703	5	applied	\N	\N	\N	\N	148395	148395	84133
29560	48459	30	applied	\N	\N	\N	\N	147786	147786	147787
29560	48462	31	applied	\N	\N	\N	\N	147795	147795	147796
29560	48465	32	applied	\N	\N	\N	\N	147800	147800	147801
29560	48460	33	applied	\N	\N	\N	\N	147788	147788	147789
29560	48378	34	applied	\N	\N	\N	\N	147575	147575	147575
29560	48359	35	applied	\N	\N	\N	\N	147538	147538	147539
29560	48371	36	applied	\N	\N	\N	\N	147561	147561	147562
29560	48414	37	applied	\N	\N	\N	\N	147668	147668	147669
29560	48363	38	applied	\N	\N	\N	\N	147547	147547	83061
29560	48402	39	applied	\N	\N	\N	\N	147634	147634	147635
29560	48403	40	applied	\N	\N	\N	\N	147636	147636	147637
29560	48373	41	applied	\N	\N	\N	\N	147565	147565	147565
29560	48386	42	applied	\N	\N	\N	\N	147593	147593	12588
29560	48431	43	applied	\N	\N	\N	\N	147716	147716	147717
29560	48360	44	applied	\N	\N	\N	\N	147540	147540	83034
29560	48362	45	applied	\N	\N	\N	\N	147546	147546	147548
29560	48366	47	applied	\N	\N	\N	\N	147553	147553	83063
29560	48370	48	applied	\N	\N	\N	\N	147560	147560	83038
29560	48374	49	applied	\N	\N	\N	\N	147566	147566	83065
29560	48367	50	applied	\N	\N	\N	\N	147554	147554	83042
29560	48379	51	applied	\N	\N	\N	\N	147576	147576	147807
29560	48389	52	applied	\N	\N	\N	\N	147602	147602	83066
29560	48397	53	applied	\N	\N	\N	\N	147626	147626	83044
29560	48410	54	applied	\N	\N	\N	\N	147659	147659	147567
29560	48421	55	applied	\N	\N	\N	\N	147686	147686	83067
29560	48436	56	applied	\N	\N	\N	\N	147725	147725	83046
29560	48447	57	applied	\N	\N	\N	\N	147750	147750	147808
29560	48453	58	applied	\N	\N	\N	\N	147769	147769	83068
29560	48468	59	applied	\N	\N	\N	\N	147805	147805	83048
29560	48381	60	applied	\N	\N	\N	\N	147579	147579	147809
29560	48382	61	applied	\N	\N	\N	\N	147581	147581	147578
29560	48384	62	applied	\N	\N	\N	\N	147590	147590	147580
29560	48392	63	applied	\N	\N	\N	\N	147609	147609	147582
29560	48393	64	applied	\N	\N	\N	\N	147611	147611	147591
29560	48398	65	applied	\N	\N	\N	\N	147628	147628	83079
29560	48399	66	applied	\N	\N	\N	\N	147629	147629	83081
29560	48404	67	applied	\N	\N	\N	\N	147638	147638	83083
29560	48406	68	applied	\N	\N	\N	\N	147643	147643	83085
29560	48409	69	applied	\N	\N	\N	\N	147657	147657	147810
29560	48411	70	applied	\N	\N	\N	\N	147660	147660	147811
29560	48415	71	applied	\N	\N	\N	\N	147670	147670	83090
29560	48418	72	applied	\N	\N	\N	\N	147675	147675	147812
29560	48420	73	applied	\N	\N	\N	\N	147685	147685	147627
29560	48424	74	applied	\N	\N	\N	\N	147699	147699	83112
29560	48428	75	applied	\N	\N	\N	\N	147712	147712	83113
29560	48432	76	applied	\N	\N	\N	\N	147718	147718	83114
29560	48437	77	applied	\N	\N	\N	\N	147727	147727	147631
29560	48438	78	applied	\N	\N	\N	\N	147728	147728	83124
29560	48440	79	applied	\N	\N	\N	\N	147737	147737	147633
29560	48445	80	applied	\N	\N	\N	\N	147747	147747	147639
29560	48446	81	applied	\N	\N	\N	\N	147748	147748	147813
29560	48450	82	applied	\N	\N	\N	\N	147761	147761	83143
29560	48455	83	applied	\N	\N	\N	\N	147771	147771	83145
29560	48457	84	applied	\N	\N	\N	\N	147774	147774	147658
29560	48461	85	applied	\N	\N	\N	\N	147790	147790	147814
29560	48464	86	applied	\N	\N	\N	\N	147798	147798	147815
29560	48466	87	applied	\N	\N	\N	\N	147802	147802	147816
29560	48368	88	applied	\N	\N	\N	\N	147555	147555	147817
29560	48375	89	applied	\N	\N	\N	\N	147568	147568	83182
29560	48380	90	applied	\N	\N	\N	\N	147577	147577	147687
29560	48385	91	applied	\N	\N	\N	\N	147592	147592	83195
29560	48390	92	applied	\N	\N	\N	\N	147605	147605	83203
29560	48391	93	applied	\N	\N	\N	\N	147607	147607	83207
29560	48400	94	applied	\N	\N	\N	\N	147630	147630	147714
29560	48401	95	applied	\N	\N	\N	\N	147632	147632	147818
29560	48405	96	applied	\N	\N	\N	\N	147642	147642	147819
29560	48412	97	applied	\N	\N	\N	\N	147661	147661	83232
29560	48416	98	applied	\N	\N	\N	\N	147671	147671	147820
29560	48422	99	applied	\N	\N	\N	\N	147688	147688	147821
29560	48425	100	applied	\N	\N	\N	\N	147700	147700	147822
29560	48429	101	applied	\N	\N	\N	\N	147713	147713	147823
29560	48435	102	applied	\N	\N	\N	\N	147724	147724	147762
29560	48441	103	applied	\N	\N	\N	\N	147739	147739	147824
29560	48444	104	applied	\N	\N	\N	\N	147745	147745	83316
29560	48448	105	applied	\N	\N	\N	\N	147751	147751	147825
29560	48454	106	applied	\N	\N	\N	\N	147770	147770	147826
29560	48458	107	applied	\N	\N	\N	\N	147776	147776	147827
29560	48463	108	applied	\N	\N	\N	\N	147797	147797	147828
29560	48467	109	applied	\N	\N	\N	\N	147804	147804	83365
29563	48481	0	applied	\N	\N	\N	\N	147857	147857	147858
29563	48482	1	applied	\N	\N	\N	\N	147859	147859	83390
29565	48483	0	applied	\N	\N	\N	\N	147864	147864	147865
29565	48484	1	applied	\N	\N	\N	\N	147866	147866	147867
29565	48485	2	applied	\N	\N	\N	\N	147868	147868	83392
29565	48486	3	applied	\N	\N	\N	\N	147869	147869	147870
29567	48487	0	applied	\N	\N	\N	\N	147873	147873	147874
29567	48488	1	applied	\N	\N	\N	\N	147875	147875	147876
29567	48489	2	applied	\N	\N	\N	\N	147877	147877	147878
29567	48490	3	applied	\N	\N	\N	\N	147879	147879	83418
29567	48491	4	applied	\N	\N	\N	\N	147880	147880	147881
29567	48492	5	applied	\N	\N	\N	\N	147882	147882	147883
29575	48504	0	applied	\N	\N	\N	\N	147915	147915	147916
29575	48505	1	applied	\N	\N	\N	\N	147917	147917	83454
29575	48506	2	applied	\N	\N	\N	\N	147918	147918	147919
29575	48507	3	applied	\N	\N	\N	\N	147920	147920	147921
29578	48513	0	applied	\N	\N	\N	\N	147933	147933	147934
29578	48514	1	applied	\N	\N	\N	\N	147935	147935	147936
29584	48533	0	applied	\N	\N	\N	\N	147977	147977	147978
29584	48534	1	applied	\N	\N	\N	\N	147979	147979	147980
29584	48535	2	applied	\N	\N	\N	\N	147981	147981	147982
29590	48544	0	applied	\N	\N	\N	\N	148010	148010	148011
29590	48545	1	applied	\N	\N	\N	\N	148012	148012	148013
29590	48546	2	applied	\N	\N	\N	\N	148014	148014	148015
29590	48547	3	applied	\N	\N	\N	\N	148016	148016	83579
29590	48548	4	applied	\N	\N	\N	\N	148017	148017	148018
29598	48576	0	applied	\N	\N	\N	\N	148081	148081	148082
29598	48577	1	applied	\N	\N	\N	\N	148083	148083	83671
29604	48589	0	applied	\N	\N	\N	\N	148113	148113	148114
29604	48590	1	applied	\N	\N	\N	\N	148131	148131	83720
29606	48595	0	applied	\N	\N	\N	\N	148151	148151	148152
29606	48596	1	applied	\N	\N	\N	\N	148153	148153	83748
29606	48597	2	applied	\N	\N	\N	\N	148154	148154	83750
29614	48621	0	applied	\N	\N	\N	\N	148207	148207	148208
29614	48622	1	applied	\N	\N	\N	\N	148209	148209	148210
29614	48623	2	applied	\N	\N	\N	\N	148211	148211	148212
29619	48624	0	applied	\N	\N	\N	\N	148215	148215	148216
29619	48627	1	applied	\N	\N	\N	\N	148222	148222	111296
29619	48628	2	applied	\N	\N	\N	\N	148223	148223	148224
29619	48629	3	applied	\N	\N	\N	\N	148225	148225	148226
29619	48630	4	applied	\N	\N	\N	\N	148227	148227	83878
29589	48210	52	applied	\N	\N	\N	\N	147212	147212	147213
29589	48211	53	applied	\N	\N	\N	\N	147214	147214	147215
29589	48218	54	applied	\N	\N	\N	\N	147227	147227	147228
29589	48221	55	applied	\N	\N	\N	\N	147233	147233	147234
29589	48222	56	applied	\N	\N	\N	\N	147235	147235	147236
29589	48228	57	applied	\N	\N	\N	\N	147245	147245	147246
29589	48231	58	applied	\N	\N	\N	\N	147254	147254	147255
29589	48233	59	applied	\N	\N	\N	\N	147260	147260	147261
29589	48237	60	applied	\N	\N	\N	\N	147268	147268	147269
29589	48240	61	applied	\N	\N	\N	\N	147275	147275	147276
29589	48241	62	applied	\N	\N	\N	\N	147277	147277	147278
29589	48247	63	applied	\N	\N	\N	\N	147291	147291	147292
29589	48250	64	applied	\N	\N	\N	\N	147298	147298	147299
29589	48254	65	applied	\N	\N	\N	\N	147307	147307	147308
29589	48256	66	applied	\N	\N	\N	\N	147311	147311	147312
29589	48261	67	applied	\N	\N	\N	\N	147322	147322	147323
29589	48266	68	applied	\N	\N	\N	\N	147333	147333	147334
29589	48267	69	applied	\N	\N	\N	\N	147335	147335	147336
29589	48274	70	applied	\N	\N	\N	\N	147350	147350	147351
29589	48277	71	applied	\N	\N	\N	\N	147356	147356	147357
29589	48280	72	applied	\N	\N	\N	\N	147363	147363	147364
29589	48284	73	applied	\N	\N	\N	\N	147371	147371	147372
29589	48286	74	applied	\N	\N	\N	\N	147374	147374	147375
29589	48292	75	applied	\N	\N	\N	\N	147387	147387	147388
29589	48293	76	applied	\N	\N	\N	\N	147389	147389	147390
29589	48294	77	applied	\N	\N	\N	\N	147391	147391	147392
29589	48302	78	applied	\N	\N	\N	\N	147413	147413	147414
29589	48305	79	applied	\N	\N	\N	\N	147423	147423	147424
29589	48306	80	applied	\N	\N	\N	\N	147425	147425	147426
29589	48307	81	applied	\N	\N	\N	\N	147427	147427	147428
29589	48314	82	applied	\N	\N	\N	\N	147440	147440	147441
29589	48315	84	applied	\N	\N	\N	\N	147442	147442	147443
29589	48320	85	applied	\N	\N	\N	\N	147449	147449	147450
29589	48321	86	applied	\N	\N	\N	\N	147451	147451	147452
29589	48327	87	applied	\N	\N	\N	\N	147465	147465	147466
29589	48328	88	applied	\N	\N	\N	\N	147467	147467	147468
29589	48329	89	applied	\N	\N	\N	\N	147469	147469	147470
29589	48330	90	applied	\N	\N	\N	\N	147471	147471	147472
29589	48339	91	applied	\N	\N	\N	\N	147487	147487	147488
29589	48341	92	applied	\N	\N	\N	\N	147493	147493	147494
29589	48344	93	applied	\N	\N	\N	\N	147503	147503	147504
29589	48348	94	applied	\N	\N	\N	\N	147513	147513	147514
29589	48350	95	applied	\N	\N	\N	\N	147519	147519	147520
29589	48352	96	applied	\N	\N	\N	\N	147523	147523	147524
29593	48549	0	applied	\N	\N	\N	\N	148023	148023	148024
29593	48550	1	applied	\N	\N	\N	\N	148025	148025	148026
29593	48551	2	applied	\N	\N	\N	\N	148027	148027	148028
29593	48552	3	applied	\N	\N	\N	\N	148029	148029	148030
29593	48553	4	applied	\N	\N	\N	\N	148031	148031	148032
29593	48554	5	applied	\N	\N	\N	\N	148033	148033	83622
29597	48570	0	applied	\N	\N	\N	\N	148067	148067	148068
29597	48571	2	applied	\N	\N	\N	\N	148070	148070	148071
29597	48572	3	applied	\N	\N	\N	\N	148072	148072	148073
29597	48573	4	applied	\N	\N	\N	\N	148074	148074	83658
29597	48574	5	applied	\N	\N	\N	\N	148075	148075	148076
29597	48575	6	applied	\N	\N	\N	\N	148077	148077	148078
29599	48578	0	applied	\N	\N	\N	\N	148085	148085	148086
29599	48579	1	applied	\N	\N	\N	\N	148087	148087	148088
29599	48580	2	applied	\N	\N	\N	\N	148089	148089	148090
29599	48581	3	applied	\N	\N	\N	\N	148091	148091	148092
29601	48582	0	applied	\N	\N	\N	\N	148097	148097	148098
29601	48583	1	applied	\N	\N	\N	\N	148099	148099	148100
29601	48579	2	applied	\N	\N	\N	\N	148087	148087	83703
29601	48584	3	applied	\N	\N	1000000000	\N	148101	148101	148102
29601	48585	4	applied	\N	\N	\N	\N	148103	148103	83705
29603	48508	0	applied	\N	\N	\N	\N	147924	147924	147925
29603	48509	1	applied	\N	\N	\N	\N	147926	147926	147927
29603	48522	2	applied	\N	\N	\N	\N	147957	147957	147958
29603	48469	3	applied	\N	\N	\N	\N	147831	147831	147832
29603	48471	4	applied	\N	\N	\N	\N	147836	147836	147837
29603	48523	5	applied	\N	\N	\N	\N	147959	147959	147960
29603	48472	6	applied	\N	\N	\N	\N	147838	147838	147839
29603	48473	7	applied	\N	\N	\N	\N	147840	147840	147841
29603	48481	8	applied	\N	\N	\N	\N	147857	147857	147858
29603	48483	9	applied	\N	\N	\N	\N	147864	147864	147865
29603	48487	10	applied	\N	\N	\N	\N	147873	147873	147874
29603	48488	11	applied	\N	\N	\N	\N	147875	147875	147876
29603	48493	12	applied	\N	\N	\N	\N	147888	147888	147889
29603	48494	13	applied	\N	\N	\N	\N	147890	147890	147891
29603	48499	14	applied	\N	\N	\N	\N	147899	147899	147900
29603	48502	15	applied	\N	\N	\N	\N	147910	147910	147911
29603	48504	16	applied	\N	\N	\N	\N	147915	147915	147916
29603	48510	17	applied	\N	\N	\N	\N	147928	147928	147929
29603	48513	18	applied	\N	\N	\N	\N	147933	147933	147934
29603	48515	19	applied	\N	\N	\N	\N	147940	147940	147941
29603	48519	20	applied	\N	\N	\N	\N	147948	147948	147949
29603	48524	21	applied	\N	\N	\N	\N	147961	147961	147962
29603	48525	22	applied	\N	\N	\N	\N	147963	147963	147964
29603	48526	23	applied	\N	\N	\N	\N	147965	147965	147966
29603	48533	24	applied	\N	\N	\N	\N	147977	147977	147978
29603	48536	25	applied	\N	\N	\N	\N	147989	147989	147990
29603	48537	26	applied	\N	\N	\N	\N	147991	147991	147992
29603	48544	27	applied	\N	\N	\N	\N	148010	148010	148011
29603	48545	28	applied	\N	\N	\N	\N	148012	148012	148013
29603	48549	29	applied	\N	\N	\N	\N	148023	148023	148024
29603	48550	30	applied	\N	\N	\N	\N	148025	148025	148026
29603	48555	31	applied	\N	\N	\N	\N	148037	148037	148038
29603	48558	32	applied	\N	\N	\N	\N	148043	148043	148044
29603	48559	33	applied	\N	\N	\N	\N	148045	148045	148046
29603	48560	34	applied	\N	\N	\N	\N	148047	148047	148048
29603	48561	35	applied	\N	\N	\N	\N	148049	148049	148050
29603	48570	36	applied	\N	\N	\N	\N	148067	148067	148068
29603	48571	37	applied	\N	\N	\N	\N	148070	148070	148071
29603	48576	38	applied	\N	\N	\N	\N	148081	148081	148082
29603	48578	39	applied	\N	\N	\N	\N	148085	148085	148086
29603	48582	40	applied	\N	\N	\N	\N	148097	148097	148098
29603	48586	41	applied	\N	\N	\N	\N	148105	148105	148106
29603	48589	42	applied	\N	\N	\N	\N	148113	148113	148114
29603	48540	43	applied	\N	\N	\N	\N	147996	147996	147997
29603	48541	44	applied	\N	\N	1000000000	\N	147998	147998	147999
29603	48584	45	applied	\N	\N	1000000000	\N	148101	148101	148102
29603	48475	46	applied	\N	\N	\N	\N	147844	147844	147843
29603	48476	47	applied	\N	\N	\N	\N	147846	147846	147845
29603	48477	48	applied	\N	\N	\N	\N	147848	147848	147847
29603	48486	49	applied	\N	\N	\N	\N	147869	147869	147849
29603	48489	50	applied	\N	\N	\N	\N	147877	147877	83384
29603	48490	51	applied	\N	\N	\N	\N	147879	147879	147867
29603	48478	52	applied	\N	\N	\N	\N	147850	147850	148115
29603	48484	53	applied	\N	\N	\N	\N	147866	147866	83392
29603	48496	54	applied	\N	\N	\N	\N	147893	147893	148116
29603	48506	55	applied	\N	\N	\N	\N	147918	147918	83397
29603	48516	56	applied	\N	\N	\N	\N	147942	147942	148117
29603	48498	57	applied	\N	\N	\N	\N	147896	147896	83409
29603	48501	58	applied	\N	\N	\N	\N	147903	147903	148118
29603	48507	59	applied	\N	\N	\N	\N	147920	147920	83420
29603	48511	60	applied	\N	\N	\N	\N	147930	147930	147894
29603	48518	61	applied	\N	\N	\N	\N	147945	147945	83432
29603	48520	63	applied	\N	\N	\N	\N	147950	147950	147902
29603	48527	64	applied	\N	\N	\N	\N	147967	147967	147904
29603	48528	65	applied	\N	\N	\N	\N	147969	147969	83454
29603	48534	66	applied	\N	\N	\N	\N	147979	147979	83458
29603	48538	67	applied	\N	\N	\N	\N	147993	147993	148120
29603	48546	68	applied	\N	\N	\N	\N	148014	148014	148121
29603	48470	69	applied	\N	\N	\N	\N	147833	147833	83490
29603	48474	70	applied	\N	\N	\N	\N	147842	147842	147944
29603	48479	71	applied	\N	\N	\N	\N	147852	147852	83501
29603	48480	72	applied	\N	\N	\N	\N	147854	147854	147946
29603	48482	73	applied	\N	\N	\N	\N	147859	147859	148122
29603	48485	74	applied	\N	\N	\N	\N	147868	147868	147951
29603	48491	75	applied	\N	\N	\N	\N	147880	147880	147953
29603	48492	76	applied	\N	\N	\N	\N	147882	147882	83529
29603	48495	77	applied	\N	\N	\N	\N	147892	147892	147968
29603	48497	78	applied	\N	\N	\N	\N	147895	147895	148123
29603	48500	79	applied	\N	\N	\N	\N	147901	147901	83535
29603	48503	80	applied	\N	\N	\N	\N	147912	147912	83537
29603	48505	81	applied	\N	\N	\N	\N	147917	147917	83544
29603	48512	82	applied	\N	\N	\N	\N	147931	147931	147973
29603	48514	83	applied	\N	\N	\N	\N	147935	147935	83558
29603	48517	84	applied	\N	\N	\N	\N	147943	147943	83560
29603	48521	85	applied	\N	\N	\N	\N	147952	147952	83562
29603	48529	86	applied	\N	\N	\N	\N	147970	147970	148124
29603	48530	87	applied	\N	\N	\N	\N	147971	147971	148125
29603	48531	88	applied	\N	\N	\N	\N	147972	147972	83566
29603	48535	89	applied	\N	\N	\N	\N	147981	147981	148001
29603	48542	90	applied	\N	\N	\N	\N	148000	148000	148003
29603	48543	91	applied	\N	\N	\N	\N	148002	148002	148126
29603	48547	92	applied	\N	\N	\N	\N	148016	148016	148015
29603	48552	93	applied	\N	\N	\N	\N	148029	148029	83579
29603	48553	94	applied	\N	\N	\N	\N	148031	148031	148127
29603	48557	95	applied	\N	\N	\N	\N	148041	148041	148018
29603	48564	96	applied	\N	\N	\N	\N	148054	148054	83589
29603	48565	97	applied	\N	\N	\N	\N	148055	148055	148028
29603	48567	98	applied	\N	\N	\N	\N	148059	148059	148030
29603	48568	99	applied	\N	\N	\N	\N	148061	148061	148032
29603	48572	100	applied	\N	\N	\N	\N	148072	148072	148128
29603	48574	101	applied	\N	\N	\N	\N	148075	148075	83624
29603	48577	102	applied	\N	\N	\N	\N	148083	148083	83626
29603	48581	103	applied	\N	\N	\N	\N	148091	148091	148129
29603	48585	104	applied	\N	\N	\N	\N	148103	148103	148130
29603	48587	105	applied	\N	\N	\N	\N	148107	148107	83630
29603	48590	106	applied	\N	\N	\N	\N	148131	148131	148132
29603	48532	107	applied	\N	\N	\N	\N	147974	147974	83632
29603	48539	108	applied	\N	\N	\N	\N	147995	147995	148133
29603	48554	109	applied	\N	\N	\N	\N	148033	148033	83634
29603	48569	110	applied	\N	\N	\N	\N	148063	148063	83636
29603	48573	111	applied	\N	\N	\N	\N	148074	148074	148056
29603	48579	112	applied	\N	\N	\N	\N	148087	148087	83639
29603	48548	113	applied	\N	\N	\N	\N	148017	148017	83652
29603	48551	114	applied	\N	\N	\N	\N	148027	148027	83656
29603	48556	115	applied	\N	\N	\N	\N	148039	148039	148134
29603	48562	116	applied	\N	\N	\N	\N	148051	148051	83665
29603	48563	117	applied	\N	\N	\N	\N	148053	148053	148088
29603	48566	118	applied	\N	\N	\N	\N	148057	148057	148090
29603	48575	119	applied	\N	\N	\N	\N	148077	148077	148135
29603	48580	120	applied	\N	\N	\N	\N	148089	148089	83705
29603	48583	121	applied	\N	\N	\N	\N	148099	148099	148136
29603	48588	122	applied	\N	\N	\N	\N	148109	148109	83720
29605	48591	0	applied	\N	\N	\N	\N	148141	148141	148142
29605	48592	1	applied	\N	\N	\N	\N	148143	148143	148144
29605	48593	2	applied	\N	\N	\N	\N	148145	148145	148146
29605	48594	3	applied	\N	\N	\N	\N	148147	148147	148148
29607	48595	0	applied	\N	\N	\N	\N	148151	148151	148152
29607	48596	1	applied	\N	\N	\N	\N	148153	148153	83748
29607	48597	2	applied	\N	\N	\N	\N	148154	148154	83750
29609	48598	0	applied	\N	\N	\N	\N	148160	148160	148161
29609	48599	1	applied	\N	\N	\N	\N	148162	148162	148163
29609	48600	2	applied	\N	\N	\N	\N	148164	148164	148165
29611	48601	0	applied	\N	\N	\N	\N	148170	148170	148171
29611	48602	1	applied	\N	\N	\N	\N	148172	148172	148173
29611	48603	2	applied	\N	\N	\N	\N	148174	148174	148175
29611	48604	3	applied	\N	\N	\N	\N	148176	148176	148177
29611	48605	4	applied	\N	\N	\N	\N	148178	148178	83760
29611	48606	5	applied	\N	\N	\N	\N	148179	148179	83801
29611	48607	6	applied	\N	\N	\N	\N	148180	148180	148181
29611	48608	7	applied	\N	\N	\N	\N	148182	148182	83805
29611	48609	8	applied	\N	\N	\N	\N	148183	148183	148184
29611	48610	9	applied	\N	\N	\N	\N	148185	148185	148186
29611	48611	10	applied	\N	\N	\N	\N	148187	148187	83809
29611	48612	11	applied	\N	\N	\N	\N	148188	148188	83824
29611	48613	12	applied	\N	\N	\N	\N	148189	148189	148190
29613	48614	0	applied	\N	\N	\N	\N	148193	148193	148194
29613	48615	1	applied	\N	\N	\N	\N	148195	148195	148196
29613	48616	2	applied	\N	\N	\N	\N	148197	148197	148198
29613	48617	3	applied	\N	\N	\N	\N	148199	148199	83826
29613	48618	4	applied	\N	\N	\N	\N	148200	148200	148201
29613	48619	5	applied	\N	\N	\N	\N	148202	148202	83843
29613	48620	6	applied	\N	\N	\N	\N	148203	148203	83847
29615	48624	0	applied	\N	\N	\N	\N	148215	148215	148216
29615	48625	1	applied	\N	\N	\N	\N	148217	148217	148218
29615	48626	2	applied	\N	\N	\N	\N	148219	148219	83876
29617	48624	0	applied	\N	\N	\N	\N	148215	148215	148216
29617	48627	1	applied	\N	\N	\N	\N	148222	148222	111296
29617	48628	2	applied	\N	\N	\N	\N	148223	148223	148224
29617	48629	3	applied	\N	\N	\N	\N	148225	148225	148226
29617	48630	4	applied	\N	\N	\N	\N	148227	148227	83878
29617	48625	5	applied	\N	\N	\N	\N	148217	148217	148228
29617	48631	6	applied	\N	\N	\N	\N	148229	148229	83889
29617	48632	7	applied	\N	\N	\N	\N	148230	148230	148231
29617	48633	8	applied	\N	\N	\N	\N	148232	148232	148233
29646	48693	0	applied	\N	\N	\N	\N	148374	148374	148375
29646	48694	1	applied	\N	\N	\N	\N	148376	148376	84088
29646	48695	2	applied	\N	\N	\N	\N	148377	148377	148378
29646	48696	3	applied	\N	\N	\N	\N	148379	148379	84103
29646	48697	4	applied	\N	\N	\N	\N	148380	148380	148381
29648	48698	0	applied	\N	\N	\N	\N	148386	148386	148387
29648	48699	1	applied	\N	\N	\N	\N	148388	148388	148389
29648	48700	2	applied	\N	\N	\N	\N	148390	148390	148391
29648	48701	3	applied	\N	\N	\N	\N	148392	148392	84123
29648	48702	4	applied	\N	\N	\N	\N	148393	148393	148394
29619	48625	5	applied	\N	\N	\N	\N	148217	148217	148228
29619	48631	6	applied	\N	\N	\N	\N	148229	148229	83889
29619	48632	7	applied	\N	\N	\N	\N	148230	148230	148231
29619	48633	8	applied	\N	\N	\N	\N	148232	148232	148233
29621	48634	0	applied	\N	\N	\N	\N	148239	148239	148240
29621	48635	1	applied	\N	\N	\N	\N	148241	148241	148242
29621	48636	2	applied	\N	\N	\N	\N	148243	148243	83916
29621	48637	3	applied	\N	\N	\N	\N	148244	148244	148245
29621	48638	4	applied	\N	\N	\N	\N	148246	148246	83918
29621	48639	5	applied	\N	\N	\N	\N	148247	148247	83922
29623	48640	0	applied	\N	\N	\N	\N	148251	148251	148252
29623	48641	1	applied	\N	\N	\N	\N	148253	148253	148254
29623	48642	2	applied	\N	\N	\N	\N	148255	148255	44452
29623	48643	3	applied	\N	\N	\N	\N	148256	148256	83924
29623	48644	4	applied	\N	\N	\N	\N	148257	148257	148258
29623	48645	5	applied	\N	\N	\N	\N	148259	148259	83934
29626	48646	0	applied	\N	\N	\N	\N	148264	148264	148265
29626	48647	1	applied	\N	\N	\N	\N	148266	148266	148267
29626	48648	2	applied	\N	\N	\N	\N	148268	148268	148269
29626	48649	3	applied	\N	\N	\N	\N	148270	148270	148271
29626	48650	4	applied	\N	\N	\N	\N	148272	148272	148273
29626	48651	5	applied	\N	\N	\N	\N	148274	148274	83945
29626	48652	6	applied	\N	\N	\N	\N	148275	148275	83954
29626	48653	7	applied	\N	\N	\N	\N	148276	148276	148277
29626	48654	8	applied	\N	\N	\N	\N	148278	148278	148279
29626	48655	9	applied	\N	\N	\N	\N	148280	148280	83962
29626	48656	10	applied	\N	\N	\N	\N	148281	148281	83964
29626	48657	11	applied	\N	\N	\N	\N	148282	148282	148283
29626	48658	12	applied	\N	\N	\N	\N	148284	148284	83976
29628	48660	0	applied	\N	\N	\N	\N	148289	148289	148290
29628	48661	1	applied	\N	\N	\N	\N	148291	148291	148292
29634	48673	0	applied	\N	\N	\N	\N	148323	148323	148324
29634	48674	1	applied	\N	\N	\N	\N	148325	148325	148326
29634	48675	2	applied	\N	\N	\N	\N	148327	148327	148328
29639	48679	0	applied	\N	\N	\N	\N	148340	148340	148341
29639	48680	1	applied	\N	\N	\N	\N	148342	148342	148343
29639	48681	2	applied	\N	\N	\N	\N	148344	148344	84050
29639	48682	3	applied	\N	\N	\N	\N	148345	148345	148346
29639	48683	4	applied	\N	\N	\N	\N	148347	148347	148348
29641	48684	0	applied	\N	\N	\N	\N	148351	148351	148352
29641	48685	1	applied	\N	\N	\N	\N	148353	148353	84054
29641	48686	2	applied	\N	\N	\N	\N	148354	148354	148355
29645	48690	0	applied	\N	\N	\N	\N	148367	148367	148368
29645	48691	1	applied	\N	\N	\N	\N	148369	148369	148370
29645	48689	2	applied	\N	\N	\N	\N	148362	148362	84082
29645	48692	3	applied	\N	\N	\N	\N	148371	148371	84084
29649	48698	0	applied	\N	\N	\N	\N	148386	148386	148387
29649	48699	1	applied	\N	\N	\N	\N	148388	148388	148389
29649	48704	2	applied	\N	\N	\N	\N	148397	148397	148398
29649	48700	3	applied	\N	\N	\N	\N	148390	148390	148399
29649	48705	4	applied	\N	\N	\N	\N	148400	148400	84123
29649	48706	5	applied	\N	\N	\N	\N	148401	148401	148402
29649	48701	6	applied	\N	\N	\N	\N	148392	148392	148403
29649	48702	7	applied	\N	\N	\N	\N	148393	148393	148404
29649	48703	8	applied	\N	\N	\N	\N	148395	148395	84145
29652	48726	0	applied	\N	\N	\N	\N	148438	148438	148439
29652	48727	1	applied	\N	\N	\N	\N	148440	148440	148441
29652	48728	2	applied	\N	\N	\N	\N	148442	148442	148443
29652	48729	3	applied	\N	\N	\N	\N	148444	148444	148445
29652	48730	4	applied	\N	\N	\N	\N	148446	148446	148447
29652	48731	5	applied	\N	\N	\N	\N	148448	148448	148449
29652	48732	6	applied	\N	\N	\N	\N	148450	148450	148451
29654	48733	0	applied	\N	\N	\N	\N	148457	148457	148457
29654	48734	1	applied	\N	\N	\N	\N	148458	148458	148459
29654	48735	2	applied	\N	\N	\N	\N	148460	148460	148461
29654	48736	3	applied	\N	\N	\N	\N	148462	148462	148463
29654	48737	4	applied	\N	\N	\N	\N	148464	148464	84251
29654	48738	5	applied	\N	\N	\N	\N	148465	148465	148466
29654	48739	6	applied	\N	\N	\N	\N	148467	148467	84261
29654	48740	7	applied	\N	\N	\N	\N	148468	148468	84263
29654	48741	8	applied	\N	\N	\N	\N	148469	148469	148470
29654	48742	9	applied	\N	\N	\N	\N	148471	148471	148472
29654	48743	10	applied	\N	\N	\N	\N	148473	148473	84283
29654	48744	11	applied	\N	\N	\N	\N	148474	148474	148475
29654	48745	12	applied	\N	\N	\N	\N	148476	148476	84294
29654	48746	13	applied	\N	\N	\N	\N	148477	148477	148478
29654	48747	14	applied	\N	\N	\N	\N	148479	148479	84320
29654	48748	15	applied	\N	\N	\N	\N	148480	148480	148481
29654	48749	16	applied	\N	\N	\N	\N	148482	148482	84332
29654	48750	17	applied	\N	\N	\N	\N	148483	148483	148484
29654	48751	18	applied	\N	\N	\N	\N	148485	148485	84338
29654	48752	19	applied	\N	\N	\N	\N	148486	148486	84340
29656	48783	0	applied	\N	\N	\N	\N	148540	148540	85328
29656	48784	1	applied	\N	\N	\N	\N	148541	148541	84488
29656	48785	2	applied	\N	\N	\N	\N	148542	148542	85329
29656	48786	3	applied	\N	\N	\N	\N	148543	148543	148544
29656	48787	4	applied	\N	\N	\N	\N	148545	148545	84495
29656	48788	5	applied	\N	\N	\N	\N	148546	148546	148547
29656	48789	6	applied	\N	\N	\N	\N	148548	148548	85330
29656	48790	7	applied	\N	\N	\N	\N	148549	148549	148550
29656	48791	8	applied	\N	\N	\N	\N	148551	148551	148551
29662	48829	0	applied	\N	\N	\N	\N	148623	148623	148624
29662	48830	1	applied	\N	\N	\N	\N	148625	148625	84672
29662	48831	2	applied	\N	\N	\N	\N	148626	148626	148627
29662	48832	3	applied	\N	\N	\N	\N	148628	148628	84683
29662	48833	4	applied	\N	\N	\N	\N	148629	148629	148630
29662	48834	5	applied	\N	\N	\N	\N	148551	148551	148348
29662	48835	6	applied	\N	\N	\N	\N	148633	148633	148634
29662	48836	7	applied	\N	\N	\N	\N	148635	148635	84691
29662	48837	8	applied	\N	\N	\N	\N	148636	148636	84698
29664	48838	0	applied	\N	\N	\N	\N	148640	148640	148641
29664	48839	1	applied	\N	\N	\N	\N	148642	148642	84702
29664	48840	2	applied	\N	\N	\N	\N	148643	148643	148644
29664	48841	3	applied	\N	\N	\N	\N	148645	148645	148646
29664	48842	4	applied	\N	\N	\N	\N	148647	148647	84714
29664	48843	5	applied	\N	\N	\N	\N	148648	148648	148649
29664	48844	6	applied	\N	\N	\N	\N	148650	148650	84718
29669	48892	0	applied	\N	\N	\N	\N	148731	148731	148732
29669	48893	1	applied	\N	\N	\N	\N	148733	148733	84939
29669	48894	2	applied	\N	\N	\N	\N	148734	148734	148735
29669	48895	3	applied	\N	\N	\N	\N	148736	148736	148737
29669	48896	4	applied	\N	\N	\N	\N	148738	148738	148739
29669	48897	5	applied	\N	\N	\N	\N	148740	148740	84943
29669	48898	6	applied	\N	\N	\N	\N	148741	148741	148742
29669	48899	7	applied	\N	\N	\N	\N	148743	148743	84951
29669	48900	8	applied	\N	\N	\N	\N	148744	148744	148745
29674	48919	0	applied	\N	\N	\N	\N	148784	148784	148785
29674	48920	1	applied	\N	\N	\N	\N	148786	148786	148787
29674	48921	2	applied	\N	\N	\N	\N	148788	148788	85131
29674	48922	3	applied	\N	\N	\N	\N	148789	148789	85040
29625	48651	5	applied	\N	\N	\N	\N	148274	148274	83945
29625	48652	6	applied	\N	\N	\N	\N	148275	148275	83954
29625	48653	7	applied	\N	\N	\N	\N	148276	148276	148277
29625	48654	8	applied	\N	\N	\N	\N	148278	148278	148279
29625	48655	9	applied	\N	\N	\N	\N	148280	148280	83962
29625	48656	10	applied	\N	\N	\N	\N	148281	148281	83964
29625	48657	11	applied	\N	\N	\N	\N	148282	148282	148283
29625	48658	12	applied	\N	\N	\N	\N	148284	148284	83976
29627	48659	0	applied	\N	\N	\N	\N	148287	148287	148288
29627	48660	1	applied	\N	\N	\N	\N	148289	148289	148290
29627	48661	2	applied	\N	\N	\N	\N	148291	148291	148292
29632	48662	0	applied	\N	\N	\N	\N	148299	148299	148300
29632	48663	1	applied	\N	\N	\N	\N	148301	148301	148302
29632	48664	2	applied	\N	\N	\N	\N	148303	148303	148304
29632	48665	3	applied	\N	\N	\N	\N	148305	148305	148306
29632	48666	4	applied	\N	\N	\N	\N	148307	148307	83984
29632	48667	5	applied	\N	\N	1000000000	\N	148308	148308	148309
29632	48668	6	applied	\N	\N	\N	\N	148310	148310	148311
29632	48669	7	applied	\N	\N	\N	\N	148312	148312	148313
29632	48670	8	applied	\N	\N	\N	\N	148314	148314	148315
29632	48671	9	applied	\N	\N	\N	\N	148316	148316	148317
29632	48672	10	applied	\N	\N	\N	\N	148318	148318	148319
29636	48676	0	applied	\N	\N	\N	\N	148331	148331	148332
29636	48677	1	applied	\N	\N	\N	\N	148333	148333	148333
29636	48678	2	applied	\N	\N	\N	\N	148334	148334	84048
29640	48684	0	applied	\N	\N	\N	\N	148351	148351	148352
29640	48685	1	applied	\N	\N	\N	\N	148353	148353	84054
29640	48686	2	applied	\N	\N	\N	\N	148354	148354	148355
29643	48687	0	applied	\N	\N	\N	\N	148357	148357	148358
29643	48688	1	applied	\N	\N	\N	\N	148359	148359	84080
29643	48689	2	applied	\N	\N	\N	\N	148362	148362	148363
29650	48707	0	applied	\N	\N	\N	\N	148407	148407	148408
29650	48708	1	applied	\N	\N	\N	\N	148409	148409	148410
29650	48709	2	applied	\N	\N	\N	\N	148411	148411	148412
29650	48710	3	applied	\N	\N	\N	\N	148413	148413	84147
29650	48711	4	applied	\N	\N	\N	\N	148414	148414	84149
29650	48712	5	applied	\N	\N	\N	\N	148415	148415	148416
29650	48713	6	applied	\N	\N	\N	\N	148417	148417	84158
29650	48714	7	applied	\N	\N	\N	\N	148418	148418	84164
29650	48715	8	applied	\N	\N	\N	\N	148419	148419	148420
29650	48716	9	applied	\N	\N	\N	\N	148421	148421	148422
29650	48717	10	applied	\N	\N	\N	\N	148423	148423	148424
29650	48718	11	applied	\N	\N	\N	\N	148425	148425	84187
29650	48719	12	applied	\N	\N	\N	\N	148426	148426	148427
29650	48720	13	applied	\N	\N	\N	\N	148428	148428	84203
29650	48721	14	applied	\N	\N	\N	\N	148429	148429	84208
29650	48722	15	applied	\N	\N	\N	\N	148430	148430	148431
29650	48723	16	applied	\N	\N	\N	\N	148432	148432	84210
29650	48724	17	applied	\N	\N	\N	\N	148433	148433	84221
29650	48725	18	applied	\N	\N	\N	\N	148434	148434	148435
29655	48753	0	applied	\N	\N	\N	\N	148488	148488	111296
29655	48754	1	applied	\N	\N	1000000000	\N	148489	148489	148490
29655	48755	2	applied	\N	\N	\N	\N	148491	148491	148492
29655	48756	3	applied	\N	\N	\N	\N	148493	148493	148494
29655	48757	4	applied	\N	\N	\N	\N	148495	148495	148496
29655	48758	5	applied	\N	\N	\N	\N	148497	148497	148498
29655	48759	6	applied	\N	\N	\N	\N	148499	148499	84375
29655	48760	7	applied	\N	\N	\N	\N	148500	148500	148501
29655	48761	8	applied	\N	\N	\N	\N	148502	148502	84385
29655	48762	9	applied	\N	\N	\N	\N	148503	148503	148504
29655	48763	10	applied	\N	\N	\N	\N	148505	148505	148506
29655	48764	11	applied	\N	\N	\N	\N	148507	148507	148508
29655	48765	13	applied	\N	\N	\N	\N	148510	148510	84389
29655	48766	14	applied	\N	\N	\N	\N	148511	148511	84391
29655	48767	15	applied	\N	\N	\N	\N	148512	148512	148513
29655	48768	16	applied	\N	\N	\N	\N	148514	148514	148515
29655	48769	17	applied	\N	\N	\N	\N	148516	148516	84401
29655	48770	18	applied	\N	\N	\N	\N	148517	148517	84403
29655	48771	19	applied	\N	\N	\N	\N	148518	148518	84405
29655	48772	20	applied	\N	\N	\N	\N	148519	148519	148520
29655	48773	21	applied	\N	\N	\N	\N	148521	148521	84413
29655	48774	22	applied	\N	\N	\N	\N	148522	148522	148523
29655	48775	23	applied	\N	\N	\N	\N	148524	148524	148525
29655	48776	24	applied	\N	\N	\N	\N	148526	148526	148527
29655	48777	25	applied	\N	\N	\N	\N	148528	148528	148529
29655	48778	26	applied	\N	\N	\N	\N	148530	148530	148531
29655	48779	27	applied	\N	\N	\N	\N	148532	148532	84464
29655	48780	28	applied	\N	\N	\N	\N	148533	148533	148534
29655	48781	29	applied	\N	\N	\N	\N	148535	148535	84470
29655	48782	30	applied	\N	\N	\N	\N	148536	148536	148537
29657	48792	0	applied	\N	\N	\N	\N	148553	148553	148554
29657	48793	1	applied	\N	\N	\N	\N	148555	148555	148556
29657	48783	2	applied	\N	\N	\N	\N	148540	148540	85328
29657	48784	3	applied	\N	\N	\N	\N	148541	148541	84488
29657	48785	4	applied	\N	\N	\N	\N	148542	148542	85329
29657	48794	5	applied	\N	\N	\N	\N	148557	148557	84490
29657	48786	6	applied	\N	\N	\N	\N	148543	148543	148558
29657	48787	7	applied	\N	\N	\N	\N	148545	148545	148559
29657	48788	8	applied	\N	\N	\N	\N	148546	148546	148560
29657	48795	9	applied	\N	\N	\N	\N	148561	148561	148198
29657	48789	10	applied	\N	\N	\N	\N	148548	148548	84517
29657	48790	11	applied	\N	\N	\N	\N	148549	148549	84521
29657	48796	12	applied	\N	\N	\N	\N	148562	148562	148563
29657	48797	13	applied	\N	\N	\N	\N	148564	148564	84539
29657	48798	14	applied	\N	\N	\N	\N	148565	148565	85334
29657	48799	15	applied	\N	\N	\N	\N	148566	148566	84549
29657	48800	16	applied	\N	\N	\N	\N	148567	148567	148568
29657	48791	17	applied	\N	\N	\N	\N	148347	148347	148347
29657	48801	18	applied	\N	\N	\N	\N	148569	148569	84573
29657	48802	19	applied	\N	\N	\N	\N	148570	148570	148571
29657	48803	20	applied	\N	\N	\N	\N	148572	148572	148573
29657	48804	21	applied	\N	\N	\N	\N	148574	148574	148575
29659	48806	0	applied	\N	\N	\N	\N	148583	148583	148584
29659	48807	1	applied	\N	\N	\N	\N	148585	148585	148586
29659	48808	2	applied	\N	\N	\N	\N	148587	148587	84583
29659	48809	3	applied	\N	\N	\N	\N	148588	148588	148589
29659	48810	4	applied	\N	\N	\N	\N	148590	148590	148591
29659	48811	5	applied	\N	\N	\N	\N	148592	148592	148593
29659	48812	6	applied	\N	\N	\N	\N	148594	148594	148595
29659	48813	7	applied	\N	\N	\N	\N	148596	148596	84603
29659	48814	8	applied	\N	\N	\N	\N	148597	148597	148598
29659	48815	9	applied	\N	\N	\N	\N	148599	148599	148600
29659	48816	10	applied	\N	\N	\N	\N	148601	148601	148602
29659	48817	11	applied	\N	\N	\N	\N	148603	148603	148604
29659	48818	12	applied	\N	\N	\N	\N	148605	148605	84623
29659	48819	13	applied	\N	\N	\N	\N	148606	148606	84625
29659	48820	14	applied	\N	\N	\N	\N	148607	148607	148608
29661	48829	0	applied	\N	\N	\N	\N	148623	148623	148624
29661	48830	1	applied	\N	\N	\N	\N	148625	148625	84672
29633	48667	5	applied	\N	\N	1000000000	\N	148308	148308	148309
29633	48668	6	applied	\N	\N	\N	\N	148310	148310	148311
29633	48669	7	applied	\N	\N	\N	\N	148312	148312	148313
29633	48670	8	applied	\N	\N	\N	\N	148314	148314	148315
29633	48671	9	applied	\N	\N	\N	\N	148316	148316	148317
29633	48672	10	applied	\N	\N	\N	\N	148318	148318	148319
29635	48676	0	applied	\N	\N	\N	\N	148331	148331	148332
29635	48677	1	applied	\N	\N	\N	\N	148333	148333	148333
29635	48678	2	applied	\N	\N	\N	\N	148334	148334	84048
29637	48676	0	applied	\N	\N	\N	\N	148331	148331	148332
29637	48677	1	applied	\N	\N	\N	\N	148333	148333	148333
29642	48687	0	applied	\N	\N	\N	\N	148357	148357	148358
29642	48688	1	applied	\N	\N	\N	\N	148359	148359	84080
29644	48687	0	applied	\N	\N	\N	\N	148357	148357	148358
29644	48688	1	applied	\N	\N	\N	\N	148359	148359	84080
29644	48689	2	applied	\N	\N	\N	\N	148362	148362	148363
29647	48693	0	applied	\N	\N	\N	\N	148374	148374	148375
29647	48694	1	applied	\N	\N	\N	\N	148376	148376	84088
29647	48695	2	applied	\N	\N	\N	\N	148377	148377	148378
29647	48696	3	applied	\N	\N	\N	\N	148379	148379	84103
29647	48697	4	applied	\N	\N	\N	\N	148380	148380	148381
29658	48792	0	applied	\N	\N	\N	\N	148553	148553	148554
29658	48793	1	applied	\N	\N	\N	\N	148555	148555	148556
29658	48794	2	applied	\N	\N	\N	\N	148557	148557	84521
29658	48805	3	applied	\N	\N	\N	\N	148578	148578	148579
29658	48796	4	applied	\N	\N	\N	\N	148562	148562	84529
29658	48797	5	applied	\N	\N	\N	\N	148564	148564	84541
29658	48798	6	applied	\N	\N	\N	\N	148565	148565	84545
29658	48799	7	applied	\N	\N	\N	\N	148566	148566	85336
29658	48800	8	applied	\N	\N	\N	\N	148567	148567	84557
29658	48795	9	applied	\N	\N	\N	\N	148561	148561	148347
29658	48801	10	applied	\N	\N	\N	\N	148569	148569	148580
29658	48802	11	applied	\N	\N	\N	\N	148570	148570	84577
29658	48803	12	applied	\N	\N	\N	\N	148572	148572	84581
29658	48804	13	applied	\N	\N	\N	\N	148574	148574	148581
29677	48961	0	applied	\N	\N	\N	\N	148846	148846	148847
29677	48962	1	applied	\N	\N	\N	\N	148848	148848	148849
29677	48963	2	applied	\N	\N	\N	\N	148850	148850	148851
29677	48964	3	applied	\N	\N	\N	\N	148852	148852	85253
29677	48965	4	applied	\N	\N	\N	\N	148853	148853	148854
29677	48966	5	applied	\N	\N	\N	\N	148855	148855	148856
29677	48967	6	applied	\N	\N	\N	\N	148857	148857	148858
29677	48968	7	applied	\N	\N	\N	\N	148859	148859	85236
29677	48969	8	applied	\N	\N	\N	\N	148860	148860	85260
29677	48970	9	applied	\N	\N	\N	\N	148861	148861	148862
29677	48971	10	applied	\N	\N	\N	\N	148863	148863	148864
29677	48972	11	applied	\N	\N	\N	\N	148865	148865	85642
29679	48961	0	applied	\N	\N	\N	\N	148846	148846	148847
29679	48962	1	applied	\N	\N	\N	\N	148848	148848	148849
29679	48963	2	applied	\N	\N	\N	\N	148850	148850	148851
29679	48964	3	applied	\N	\N	\N	\N	148852	148852	85253
29679	48965	4	applied	\N	\N	\N	\N	148853	148853	148854
29679	48966	5	applied	\N	\N	\N	\N	148855	148855	148856
29679	48967	6	applied	\N	\N	\N	\N	148857	148857	148858
29679	48968	7	applied	\N	\N	\N	\N	148859	148859	85236
29679	48969	8	applied	\N	\N	\N	\N	148860	148860	85260
29679	48970	9	applied	\N	\N	\N	\N	148861	148861	148862
29679	48971	10	applied	\N	\N	\N	\N	148863	148863	148864
29679	48972	11	applied	\N	\N	\N	\N	148865	148865	85642
29683	48982	0	applied	\N	\N	\N	\N	148887	148887	148888
29683	48983	1	applied	\N	\N	\N	\N	148889	148889	148890
29683	48984	2	applied	\N	\N	\N	\N	148891	148891	85294
29683	48985	3	applied	\N	\N	\N	\N	148892	148892	148893
29683	48986	4	applied	\N	\N	\N	\N	148894	148894	148895
29683	48987	6	applied	\N	\N	\N	\N	148897	148897	148898
29683	48988	7	applied	\N	\N	\N	\N	148899	148899	85308
29683	48989	8	applied	\N	\N	\N	\N	148900	148900	148901
29683	48990	9	applied	\N	\N	\N	\N	148902	148902	85323
29683	48991	10	applied	\N	\N	\N	\N	148903	148903	85345
29683	48992	11	applied	\N	\N	\N	\N	148904	148904	85355
29683	48993	12	applied	\N	\N	\N	\N	148905	148905	148906
29683	48994	13	applied	\N	\N	\N	\N	148907	148907	85362
29683	48995	14	applied	\N	\N	\N	\N	148908	148908	85650
29683	48996	15	applied	\N	\N	\N	\N	148909	148909	85374
29683	48997	16	applied	\N	\N	\N	\N	148910	148910	148911
29683	48998	17	applied	\N	\N	\N	\N	148912	148912	148913
29690	49023	0	applied	\N	\N	\N	\N	148965	148965	148966
29690	49024	1	applied	\N	\N	\N	\N	148967	148967	85665
29690	49025	2	applied	\N	\N	\N	\N	148968	148968	148969
29690	49026	3	applied	\N	\N	\N	\N	148970	148970	85486
29690	49027	4	applied	\N	\N	\N	\N	148971	148971	85498
29690	49028	5	applied	\N	\N	\N	\N	148972	148972	148973
29690	49029	6	applied	\N	\N	\N	\N	148974	148974	148975
29692	49035	0	applied	\N	\N	\N	\N	148986	148986	148995
29692	49036	1	applied	\N	\N	1000000000	\N	148987	148987	148988
29692	49037	2	applied	\N	\N	\N	\N	148989	148989	85502
29698	49040	0	applied	\N	\N	\N	\N	148997	148997	148998
29698	49041	1	applied	\N	\N	\N	\N	148999	148999	149000
29698	49042	2	applied	\N	\N	\N	\N	149001	149001	149002
29698	49043	3	applied	\N	\N	\N	\N	149003	149003	85543
29698	49044	4	applied	\N	\N	\N	\N	149004	149004	85675
29698	49045	5	applied	\N	\N	\N	\N	149005	149005	85677
29703	49046	0	applied	\N	\N	\N	\N	149015	149015	149016
29703	49047	1	applied	\N	\N	\N	\N	149017	149017	85555
29703	49048	2	applied	\N	\N	\N	\N	149018	149018	149019
29703	49049	3	applied	\N	\N	\N	\N	149020	149020	85565
29703	49050	4	applied	\N	\N	\N	\N	149021	149021	149022
29703	49051	5	applied	\N	\N	\N	\N	149023	149023	85569
29703	49052	6	applied	\N	\N	\N	\N	149024	149024	85681
29703	49053	7	applied	\N	\N	\N	\N	149025	149025	85578
29703	49054	8	applied	\N	\N	\N	\N	149026	149026	85682
29707	49055	0	applied	\N	\N	\N	\N	149034	149034	149035
29707	49056	1	applied	\N	\N	\N	\N	149036	149036	85584
29707	49057	2	applied	\N	\N	\N	\N	149037	149037	85586
29707	49058	3	applied	\N	\N	\N	\N	149038	149038	85597
29707	49059	4	applied	\N	\N	\N	\N	149039	149039	149040
29707	49060	5	applied	\N	\N	\N	\N	149041	149041	85601
29707	49061	6	applied	\N	\N	\N	\N	149042	149042	85901
29715	49092	0	applied	\N	\N	\N	\N	149096	149096	149097
29715	49093	1	applied	\N	\N	\N	\N	149098	149098	149099
29715	49094	3	applied	\N	\N	\N	\N	149101	149101	149102
29715	49095	4	applied	\N	\N	\N	\N	149103	149103	85814
29715	49096	5	applied	\N	\N	\N	\N	149104	149104	85816
29715	49097	6	applied	\N	\N	\N	\N	149105	149105	149106
29715	49098	7	applied	\N	\N	\N	\N	149107	149107	149108
29715	49099	8	applied	\N	\N	\N	\N	149109	149109	85767
29715	49100	9	applied	\N	\N	\N	\N	149110	149110	85772
29715	49101	10	applied	\N	\N	\N	\N	149111	149111	85817
29715	49102	11	applied	\N	\N	\N	\N	149112	149112	85778
29651	48726	0	applied	\N	\N	\N	\N	148438	148438	148439
29651	48727	1	applied	\N	\N	\N	\N	148440	148440	148441
29651	48728	2	applied	\N	\N	\N	\N	148442	148442	148443
29651	48729	3	applied	\N	\N	\N	\N	148444	148444	148445
29651	48730	4	applied	\N	\N	\N	\N	148446	148446	148447
29651	48731	5	applied	\N	\N	\N	\N	148448	148448	148449
29651	48732	6	applied	\N	\N	\N	\N	148450	148450	148451
29653	48726	0	applied	\N	\N	\N	\N	148438	148438	148439
29653	48727	1	applied	\N	\N	\N	\N	148440	148440	148441
29653	48728	2	applied	\N	\N	\N	\N	148442	148442	148443
29653	48729	3	applied	\N	\N	\N	\N	148444	148444	148445
29653	48730	4	applied	\N	\N	\N	\N	148446	148446	148447
29653	48731	5	applied	\N	\N	\N	\N	148448	148448	148449
29653	48732	6	applied	\N	\N	\N	\N	148450	148450	148451
29660	48821	0	applied	\N	\N	\N	\N	148611	148611	148612
29660	48822	1	applied	\N	\N	\N	\N	148613	148613	84640
29660	48823	2	applied	\N	\N	\N	\N	148614	148614	84633
29660	48824	3	applied	\N	\N	\N	\N	148615	148615	84643
29660	48825	4	applied	\N	\N	\N	\N	148616	148616	84666
29660	48826	5	applied	\N	\N	\N	\N	148617	148617	84656
29660	48827	6	applied	\N	\N	\N	\N	148618	148618	84668
29660	48828	7	applied	\N	\N	\N	\N	148619	148619	148620
29665	48845	0	applied	\N	\N	\N	\N	148652	148652	111296
29665	48846	1	applied	\N	\N	1000000000	\N	148653	148653	148654
29665	48847	2	applied	\N	\N	\N	\N	148655	148655	148656
29665	48848	3	applied	\N	\N	\N	\N	148657	148657	148658
29665	48849	4	applied	\N	\N	\N	\N	148659	148659	148660
29665	48850	5	applied	\N	\N	\N	\N	148661	148661	84722
29665	48851	6	applied	\N	\N	\N	\N	148662	148662	84730
29665	48852	7	applied	\N	\N	\N	\N	148663	148663	148664
29665	48853	8	applied	\N	\N	\N	\N	148665	148665	148666
29665	48854	9	applied	\N	\N	\N	\N	148667	148667	84732
29665	48855	10	applied	\N	\N	\N	\N	148668	148668	148669
29665	48856	11	applied	\N	\N	\N	\N	148670	148670	148671
29665	48857	12	applied	\N	\N	\N	\N	148672	148672	148673
29665	48858	13	applied	\N	\N	\N	\N	148674	148674	148675
29665	48859	14	applied	\N	\N	\N	\N	148676	148676	84759
29665	48860	15	applied	\N	\N	\N	\N	148677	148677	84761
29665	48861	16	applied	\N	\N	\N	\N	148678	148678	148679
29665	48862	17	applied	\N	\N	\N	\N	148680	148680	84773
29665	48863	18	applied	\N	\N	\N	\N	148681	148681	148682
29665	48864	19	applied	\N	\N	\N	\N	148683	148683	148684
29665	48865	20	applied	\N	\N	\N	\N	148685	148685	84777
29665	48866	21	applied	\N	\N	\N	\N	148686	148686	84781
29665	48867	22	applied	\N	\N	\N	\N	148687	148687	84788
29665	48868	23	applied	\N	\N	\N	\N	148688	148688	148689
29665	48869	24	applied	\N	\N	\N	\N	148690	148690	84799
29665	48870	25	applied	\N	\N	\N	\N	148691	148691	148692
29665	48871	26	applied	\N	\N	\N	\N	148693	148693	84814
29665	48872	27	applied	\N	\N	\N	\N	148694	148694	148695
29665	48873	28	applied	\N	\N	\N	\N	148696	148696	84831
29668	48892	0	applied	\N	\N	\N	\N	148731	148731	148732
29668	48893	1	applied	\N	\N	\N	\N	148733	148733	84939
29668	48894	2	applied	\N	\N	\N	\N	148734	148734	148735
29668	48895	3	applied	\N	\N	\N	\N	148736	148736	148737
29668	48896	4	applied	\N	\N	\N	\N	148738	148738	148739
29668	48897	5	applied	\N	\N	\N	\N	148740	148740	84943
29668	48898	6	applied	\N	\N	\N	\N	148741	148741	148742
29668	48899	7	applied	\N	\N	\N	\N	148743	148743	84951
29668	48900	8	applied	\N	\N	\N	\N	148744	148744	148745
29670	48892	0	applied	\N	\N	\N	\N	148731	148731	148732
29670	48893	1	applied	\N	\N	\N	\N	148733	148733	84939
29670	48894	2	applied	\N	\N	\N	\N	148734	148734	148735
29670	48895	3	applied	\N	\N	\N	\N	148736	148736	148737
29670	48896	4	applied	\N	\N	\N	\N	148738	148738	148739
29670	48897	5	applied	\N	\N	\N	\N	148740	148740	84943
29670	48898	6	applied	\N	\N	\N	\N	148741	148741	148742
29670	48899	7	applied	\N	\N	\N	\N	148743	148743	84951
29670	48900	8	applied	\N	\N	\N	\N	148744	148744	148745
29672	48901	0	applied	\N	\N	\N	\N	148749	148749	44452
29672	48902	1	applied	\N	\N	\N	\N	148750	148750	148751
29672	48903	2	applied	\N	\N	\N	\N	148752	148752	148753
29672	48904	3	applied	\N	\N	\N	\N	148754	148754	148755
29672	48905	4	applied	\N	\N	\N	\N	148756	148756	148757
29672	48906	5	applied	\N	\N	\N	\N	148758	148758	148759
29672	48907	6	applied	\N	\N	\N	\N	148760	148760	84966
29672	48908	7	applied	\N	\N	\N	\N	148761	148761	148762
29672	48909	8	applied	\N	\N	\N	\N	148763	148763	148764
29672	48910	9	applied	\N	\N	\N	\N	148765	148765	84974
29672	48911	10	applied	\N	\N	\N	\N	148766	148766	148767
29672	48912	11	applied	\N	\N	\N	\N	148768	148768	148769
29672	48913	12	applied	\N	\N	\N	\N	148770	148770	148771
29672	48914	13	applied	\N	\N	\N	\N	148772	148772	148773
29672	48915	14	applied	\N	\N	\N	\N	148774	148774	85008
29672	48916	15	applied	\N	\N	\N	\N	148775	148775	148776
29672	48917	16	applied	\N	\N	\N	\N	148777	148777	85026
29672	48918	17	applied	\N	\N	\N	\N	148778	148778	85129
29675	48934	0	applied	\N	\N	\N	\N	148806	148806	148807
29675	48935	1	applied	\N	\N	\N	\N	148808	148808	148808
29675	48936	2	applied	\N	\N	\N	\N	148809	148809	148810
29675	48937	3	applied	\N	\N	\N	\N	148811	148811	85098
29675	48938	4	applied	\N	\N	\N	\N	148812	148812	148813
29675	48939	5	applied	\N	\N	\N	\N	148814	148814	85135
29675	48940	6	applied	\N	\N	\N	\N	148815	148815	85136
29675	48941	7	applied	\N	\N	\N	\N	148816	148816	85113
29675	48942	8	applied	\N	\N	\N	\N	148817	148817	148818
29675	48943	9	applied	\N	\N	\N	\N	148819	148819	85137
29675	48944	10	applied	\N	\N	\N	\N	148820	148820	85123
29675	48945	11	applied	\N	\N	\N	\N	148821	148821	148822
29675	48946	12	applied	\N	\N	\N	\N	148823	148823	85145
29675	48947	13	applied	\N	\N	\N	\N	148824	148824	85155
29675	48948	14	applied	\N	\N	\N	\N	148825	148825	85166
29675	48949	15	applied	\N	\N	\N	\N	148826	148826	85179
29675	48950	16	applied	\N	\N	\N	\N	148827	148827	85244
29675	48951	17	applied	\N	\N	\N	\N	148828	148828	85245
29681	48982	0	applied	\N	\N	\N	\N	148887	148887	148888
29681	48983	1	applied	\N	\N	\N	\N	148889	148889	148890
29681	48984	2	applied	\N	\N	\N	\N	148891	148891	85294
29681	48985	3	applied	\N	\N	\N	\N	148892	148892	148893
29681	48986	4	applied	\N	\N	\N	\N	148894	148894	148895
29681	48987	6	applied	\N	\N	\N	\N	148897	148897	148898
29681	48988	7	applied	\N	\N	\N	\N	148899	148899	85308
29681	48989	8	applied	\N	\N	\N	\N	148900	148900	148901
29681	48990	9	applied	\N	\N	\N	\N	148902	148902	85323
29681	48991	10	applied	\N	\N	\N	\N	148903	148903	85345
29681	48992	11	applied	\N	\N	\N	\N	148904	148904	85355
29681	48993	12	applied	\N	\N	\N	\N	148905	148905	148906
29681	48994	13	applied	\N	\N	\N	\N	148907	148907	85362
29681	48995	14	applied	\N	\N	\N	\N	148908	148908	85650
29681	48996	15	applied	\N	\N	\N	\N	148909	148909	85374
29661	48831	2	applied	\N	\N	\N	\N	148626	148626	148627
29661	48832	3	applied	\N	\N	\N	\N	148628	148628	84683
29661	48833	4	applied	\N	\N	\N	\N	148629	148629	148630
29661	48834	5	applied	\N	\N	\N	\N	148551	148551	148348
29663	48829	0	applied	\N	\N	\N	\N	148623	148623	148624
29663	48830	1	applied	\N	\N	\N	\N	148625	148625	84672
29663	48831	2	applied	\N	\N	\N	\N	148626	148626	148627
29663	48832	3	applied	\N	\N	\N	\N	148628	148628	84683
29663	48833	4	applied	\N	\N	\N	\N	148629	148629	148630
29663	48834	5	applied	\N	\N	\N	\N	148551	148551	148348
29663	48835	6	applied	\N	\N	\N	\N	148633	148633	148634
29663	48836	7	applied	\N	\N	\N	\N	148635	148635	84691
29663	48837	8	applied	\N	\N	\N	\N	148636	148636	84698
29666	48874	0	applied	\N	\N	\N	\N	148699	148699	148700
29666	48875	1	applied	\N	\N	\N	\N	148701	148701	148702
29666	48876	3	applied	\N	\N	\N	\N	148704	148704	148705
29666	48877	4	applied	\N	\N	\N	\N	148706	148706	84845
29666	48878	5	applied	\N	\N	\N	\N	148707	148707	84838
29666	48879	6	applied	\N	\N	\N	\N	148708	148708	148709
29666	48880	7	applied	\N	\N	\N	\N	148710	148710	84854
29666	48881	8	applied	\N	\N	\N	\N	148711	148711	148712
29666	48882	9	applied	\N	\N	\N	\N	148713	148713	148714
29666	48883	10	applied	\N	\N	\N	\N	148715	148715	84882
29666	48884	11	applied	\N	\N	\N	\N	148716	148716	148717
29666	48885	12	applied	\N	\N	\N	\N	148718	148718	148719
29666	48886	13	applied	\N	\N	\N	\N	148720	148720	148721
29666	48887	14	applied	\N	\N	\N	\N	148722	148722	84912
29666	48888	15	applied	\N	\N	\N	\N	148723	148723	148724
29666	48889	16	applied	\N	\N	\N	\N	148725	148725	84928
29666	48890	17	applied	\N	\N	\N	\N	148726	148726	148727
29666	48891	18	applied	\N	\N	\N	\N	148728	148728	84930
29667	48874	0	applied	\N	\N	\N	\N	148699	148699	148700
29667	48875	1	applied	\N	\N	\N	\N	148701	148701	148702
29667	48876	3	applied	\N	\N	\N	\N	148704	148704	148705
29667	48877	4	applied	\N	\N	\N	\N	148706	148706	84845
29667	48878	5	applied	\N	\N	\N	\N	148707	148707	84838
29667	48879	6	applied	\N	\N	\N	\N	148708	148708	148709
29667	48880	7	applied	\N	\N	\N	\N	148710	148710	84854
29667	48881	8	applied	\N	\N	\N	\N	148711	148711	148712
29667	48882	9	applied	\N	\N	\N	\N	148713	148713	148714
29667	48883	10	applied	\N	\N	\N	\N	148715	148715	84882
29667	48884	11	applied	\N	\N	\N	\N	148716	148716	148717
29667	48885	12	applied	\N	\N	\N	\N	148718	148718	148719
29667	48886	13	applied	\N	\N	\N	\N	148720	148720	148721
29667	48887	14	applied	\N	\N	\N	\N	148722	148722	84912
29667	48888	15	applied	\N	\N	\N	\N	148723	148723	148724
29667	48889	16	applied	\N	\N	\N	\N	148725	148725	84928
29667	48890	17	applied	\N	\N	\N	\N	148726	148726	148727
29667	48891	18	applied	\N	\N	\N	\N	148728	148728	84930
29671	48901	0	applied	\N	\N	\N	\N	148749	148749	44452
29671	48902	1	applied	\N	\N	\N	\N	148750	148750	148751
29671	48903	2	applied	\N	\N	\N	\N	148752	148752	148753
29671	48904	3	applied	\N	\N	\N	\N	148754	148754	148755
29671	48905	4	applied	\N	\N	\N	\N	148756	148756	148757
29671	48906	5	applied	\N	\N	\N	\N	148758	148758	148759
29671	48907	6	applied	\N	\N	\N	\N	148760	148760	84966
29671	48908	7	applied	\N	\N	\N	\N	148761	148761	148762
29671	48909	8	applied	\N	\N	\N	\N	148763	148763	148764
29671	48910	9	applied	\N	\N	\N	\N	148765	148765	84974
29671	48911	10	applied	\N	\N	\N	\N	148766	148766	148767
29671	48912	11	applied	\N	\N	\N	\N	148768	148768	148769
29671	48913	12	applied	\N	\N	\N	\N	148770	148770	148771
29671	48914	13	applied	\N	\N	\N	\N	148772	148772	148773
29671	48915	14	applied	\N	\N	\N	\N	148774	148774	85008
29671	48916	15	applied	\N	\N	\N	\N	148775	148775	148776
29671	48917	16	applied	\N	\N	\N	\N	148777	148777	85026
29671	48918	17	applied	\N	\N	\N	\N	148778	148778	85129
29673	48901	0	applied	\N	\N	\N	\N	148749	148749	44452
29673	48902	1	applied	\N	\N	\N	\N	148750	148750	148751
29673	48903	2	applied	\N	\N	\N	\N	148752	148752	148753
29673	48904	3	applied	\N	\N	\N	\N	148754	148754	148755
29673	48905	4	applied	\N	\N	\N	\N	148756	148756	148757
29673	48906	5	applied	\N	\N	\N	\N	148758	148758	148759
29673	48907	6	applied	\N	\N	\N	\N	148760	148760	84966
29673	48908	7	applied	\N	\N	\N	\N	148761	148761	148762
29673	48909	8	applied	\N	\N	\N	\N	148763	148763	148764
29673	48910	9	applied	\N	\N	\N	\N	148765	148765	84974
29673	48911	10	applied	\N	\N	\N	\N	148766	148766	148767
29673	48912	11	applied	\N	\N	\N	\N	148768	148768	148769
29673	48913	12	applied	\N	\N	\N	\N	148770	148770	148771
29673	48914	13	applied	\N	\N	\N	\N	148772	148772	148773
29673	48915	14	applied	\N	\N	\N	\N	148774	148774	85008
29673	48916	15	applied	\N	\N	\N	\N	148775	148775	148776
29673	48917	16	applied	\N	\N	\N	\N	148777	148777	85026
29673	48918	17	applied	\N	\N	\N	\N	148778	148778	85129
29682	48982	0	applied	\N	\N	\N	\N	148887	148887	148888
29682	48983	1	applied	\N	\N	\N	\N	148889	148889	148890
29682	48984	2	applied	\N	\N	\N	\N	148891	148891	85294
29682	48985	3	applied	\N	\N	\N	\N	148892	148892	148893
29682	48986	4	applied	\N	\N	\N	\N	148894	148894	148895
29682	48987	6	applied	\N	\N	\N	\N	148897	148897	148898
29682	48988	7	applied	\N	\N	\N	\N	148899	148899	85308
29682	48989	8	applied	\N	\N	\N	\N	148900	148900	148901
29682	48990	9	applied	\N	\N	\N	\N	148902	148902	85323
29682	48991	10	applied	\N	\N	\N	\N	148903	148903	85345
29682	48992	11	applied	\N	\N	\N	\N	148904	148904	85355
29682	48993	12	applied	\N	\N	\N	\N	148905	148905	148906
29682	48994	13	applied	\N	\N	\N	\N	148907	148907	85362
29682	48995	14	applied	\N	\N	\N	\N	148908	148908	85650
29682	48996	15	applied	\N	\N	\N	\N	148909	148909	85374
29682	48997	16	applied	\N	\N	\N	\N	148910	148910	148911
29682	48998	17	applied	\N	\N	\N	\N	148912	148912	148913
29688	49009	0	applied	\N	\N	\N	\N	148942	148942	148943
29688	49010	1	applied	\N	\N	\N	\N	148944	148944	85428
29688	49011	2	applied	\N	\N	\N	\N	148945	148945	85439
29688	49012	3	applied	\N	\N	\N	\N	148946	148946	148947
29688	49013	4	applied	\N	\N	\N	\N	148948	148948	85441
29688	49014	5	applied	\N	\N	\N	\N	148949	148949	148950
29699	49040	0	applied	\N	\N	\N	\N	148997	148997	148998
29699	49041	1	applied	\N	\N	\N	\N	148999	148999	149000
29699	49042	2	applied	\N	\N	\N	\N	149001	149001	149002
29699	49043	3	applied	\N	\N	\N	\N	149003	149003	85543
29699	49044	4	applied	\N	\N	\N	\N	149004	149004	85675
29699	49045	5	applied	\N	\N	\N	\N	149005	149005	85677
29702	49046	0	applied	\N	\N	\N	\N	149015	149015	149016
29702	49047	1	applied	\N	\N	\N	\N	149017	149017	85555
29702	49048	2	applied	\N	\N	\N	\N	149018	149018	149019
29702	49049	3	applied	\N	\N	\N	\N	149020	149020	85565
29702	49050	4	applied	\N	\N	\N	\N	149021	149021	149022
29702	49051	5	applied	\N	\N	\N	\N	149023	149023	85569
29674	48923	4	applied	\N	\N	\N	\N	148790	148790	85042
29674	48924	5	applied	\N	\N	\N	\N	148791	148791	148792
29674	48925	6	applied	\N	\N	\N	\N	148793	148793	85052
29674	48926	7	applied	\N	\N	\N	\N	148794	148794	148795
29674	48927	8	applied	\N	\N	\N	\N	148796	148796	85062
29674	48928	9	applied	\N	\N	\N	\N	148797	148797	85064
29674	48929	10	applied	\N	\N	\N	\N	148798	148798	148799
29674	48930	11	applied	\N	\N	\N	\N	148800	148800	85133
29674	48931	12	applied	\N	\N	\N	\N	148801	148801	85080
29674	48932	13	applied	\N	\N	\N	\N	148802	148802	148803
29674	48933	14	applied	\N	\N	\N	\N	148804	148804	85090
29676	48952	0	applied	\N	\N	\N	\N	148831	148831	148832
29676	48953	1	applied	\N	\N	\N	\N	148833	148833	148834
29676	48954	2	applied	\N	\N	\N	\N	148835	148835	148836
29676	48955	3	applied	\N	\N	\N	\N	148837	148837	85182
29676	48956	4	applied	\N	\N	\N	\N	148838	148838	85191
29676	48957	5	applied	\N	\N	\N	\N	148839	148839	85249
29676	48958	6	applied	\N	\N	\N	\N	148840	148840	85205
29676	48959	7	applied	\N	\N	\N	\N	148841	148841	148842
29676	48960	8	applied	\N	\N	\N	\N	148843	148843	148844
29678	48961	0	applied	\N	\N	\N	\N	148846	148846	148847
29678	48962	1	applied	\N	\N	\N	\N	148848	148848	148849
29678	48963	2	applied	\N	\N	\N	\N	148850	148850	148851
29678	48964	3	applied	\N	\N	\N	\N	148852	148852	85253
29678	48967	4	applied	\N	\N	\N	\N	148857	148857	148858
29678	48969	5	applied	\N	\N	\N	\N	148860	148860	85222
29678	48970	6	applied	\N	\N	\N	\N	148861	148861	148868
29678	48971	7	applied	\N	\N	\N	\N	148863	148863	148854
29678	48972	8	applied	\N	\N	\N	\N	148865	148865	85226
29680	48973	0	applied	\N	\N	\N	\N	148872	148872	148873
29680	48974	1	applied	\N	\N	\N	\N	148874	148874	148875
29680	48975	2	applied	\N	\N	\N	\N	148876	148876	148856
29680	48965	3	applied	\N	\N	\N	\N	148853	148853	85236
29680	48966	4	applied	\N	\N	\N	\N	148855	148855	148864
29680	48968	5	applied	\N	\N	\N	\N	148859	148859	85268
29680	48976	6	applied	\N	\N	\N	\N	148877	148877	85644
29680	48977	7	applied	\N	\N	\N	\N	148878	148878	148879
29680	48978	8	applied	\N	\N	\N	\N	148880	148880	85286
29680	48979	9	applied	\N	\N	\N	\N	148881	148881	85288
29680	48980	10	applied	\N	\N	\N	\N	148882	148882	85292
29680	48981	11	applied	\N	\N	\N	\N	148883	148883	148884
29684	48982	0	applied	\N	\N	\N	\N	148887	148887	148888
29684	48983	1	applied	\N	\N	\N	\N	148889	148889	148890
29684	48984	2	applied	\N	\N	\N	\N	148891	148891	85294
29684	48985	3	applied	\N	\N	\N	\N	148892	148892	148893
29684	48986	4	applied	\N	\N	\N	\N	148894	148894	148895
29684	48987	6	applied	\N	\N	\N	\N	148897	148897	148898
29684	48988	7	applied	\N	\N	\N	\N	148899	148899	85308
29684	48989	8	applied	\N	\N	\N	\N	148900	148900	148901
29684	48990	9	applied	\N	\N	\N	\N	148902	148902	85323
29684	48991	10	applied	\N	\N	\N	\N	148903	148903	85345
29684	48992	11	applied	\N	\N	\N	\N	148904	148904	85355
29684	48993	12	applied	\N	\N	\N	\N	148905	148905	148906
29684	48994	13	applied	\N	\N	\N	\N	148907	148907	85362
29684	48995	14	applied	\N	\N	\N	\N	148908	148908	85650
29684	48996	15	applied	\N	\N	\N	\N	148909	148909	85374
29684	48997	16	applied	\N	\N	\N	\N	148910	148910	148911
29684	48998	17	applied	\N	\N	\N	\N	148912	148912	148913
29686	48999	0	applied	\N	\N	\N	\N	148923	148923	148924
29686	49000	1	applied	\N	\N	\N	\N	148925	148925	148926
29686	49001	2	applied	\N	\N	\N	\N	148927	148927	85388
29686	49002	3	applied	\N	\N	\N	\N	148928	148928	85390
29686	49003	4	applied	\N	\N	\N	\N	148929	148929	148930
29686	49004	5	applied	\N	\N	\N	\N	148931	148931	85394
29686	49005	6	applied	\N	\N	\N	\N	148932	148932	85403
29686	49006	7	applied	\N	\N	\N	\N	148933	148933	85413
29686	49007	8	applied	\N	\N	\N	\N	148934	148934	148935
29686	49008	9	applied	\N	\N	\N	\N	148936	148936	85426
29694	49040	0	applied	\N	\N	\N	\N	148997	148997	148998
29694	49041	1	applied	\N	\N	\N	\N	148999	148999	149000
29694	49042	2	applied	\N	\N	\N	\N	149001	149001	149002
29694	49043	3	applied	\N	\N	\N	\N	149003	149003	85543
29694	49044	4	applied	\N	\N	\N	\N	149004	149004	85675
29694	49045	5	applied	\N	\N	\N	\N	149005	149005	85677
29697	49040	0	applied	\N	\N	\N	\N	148997	148997	148998
29697	49041	1	applied	\N	\N	\N	\N	148999	148999	149000
29697	49042	2	applied	\N	\N	\N	\N	149001	149001	149002
29697	49043	3	applied	\N	\N	\N	\N	149003	149003	85543
29697	49044	4	applied	\N	\N	\N	\N	149004	149004	85675
29697	49045	5	applied	\N	\N	\N	\N	149005	149005	85677
29705	49046	0	applied	\N	\N	\N	\N	149015	149015	149016
29705	49047	1	applied	\N	\N	\N	\N	149017	149017	85555
29705	49048	2	applied	\N	\N	\N	\N	149018	149018	149019
29705	49049	3	applied	\N	\N	\N	\N	149020	149020	85565
29705	49050	4	applied	\N	\N	\N	\N	149021	149021	149022
29705	49051	5	applied	\N	\N	\N	\N	149023	149023	85569
29705	49052	6	applied	\N	\N	\N	\N	149024	149024	85681
29705	49053	7	applied	\N	\N	\N	\N	149025	149025	85578
29705	49054	8	applied	\N	\N	\N	\N	149026	149026	85682
29710	49062	0	applied	\N	\N	\N	\N	149047	149047	149048
29710	49063	1	applied	\N	\N	\N	\N	149049	149049	149050
29710	49064	2	applied	\N	\N	\N	\N	149051	149051	149052
29710	49065	3	applied	\N	\N	\N	\N	149053	149053	149054
29710	49066	4	applied	\N	\N	\N	\N	149055	149055	149055
29710	49067	5	applied	\N	\N	\N	\N	149056	149056	85603
29710	49068	6	applied	\N	\N	\N	\N	149057	149057	85902
29710	49069	7	applied	\N	\N	\N	\N	149058	149058	85605
29710	49070	8	applied	\N	\N	\N	\N	149059	149059	85621
29710	49071	9	applied	\N	\N	\N	\N	149060	149060	85904
29710	49080	10	applied	\N	\N	\N	\N	149071	149071	149071
29710	49081	11	applied	\N	\N	\N	\N	149072	149072	149073
29710	49082	12	applied	\N	\N	\N	\N	149074	149074	85627
29710	49083	13	applied	\N	\N	\N	\N	149075	149075	85803
29710	49084	14	applied	\N	\N	\N	\N	149076	149076	85805
29710	49085	15	applied	\N	\N	\N	\N	149078	149078	149070
29710	49086	16	applied	\N	\N	\N	\N	149080	149080	85907
29710	49087	17	applied	\N	\N	\N	\N	149081	149081	85806
29710	49088	18	applied	\N	\N	\N	\N	149083	149083	149077
29710	49089	19	applied	\N	\N	\N	\N	149084	149084	149079
29710	49090	20	applied	\N	\N	\N	\N	149085	149085	85807
29710	49091	21	applied	\N	\N	\N	\N	149086	149086	149082
29713	49062	0	applied	\N	\N	\N	\N	149047	149047	149048
29713	49063	1	applied	\N	\N	\N	\N	149049	149049	149050
29713	49064	2	applied	\N	\N	\N	\N	149051	149051	149052
29713	49065	3	applied	\N	\N	\N	\N	149053	149053	149054
29713	49066	4	applied	\N	\N	\N	\N	149055	149055	149055
29713	49067	5	applied	\N	\N	\N	\N	149056	149056	85603
29713	49068	6	applied	\N	\N	\N	\N	149057	149057	85902
29713	49069	7	applied	\N	\N	\N	\N	149058	149058	85605
29713	49070	8	applied	\N	\N	\N	\N	149059	149059	85621
29681	48997	16	applied	\N	\N	\N	\N	148910	148910	148911
29681	48998	17	applied	\N	\N	\N	\N	148912	148912	148913
29685	48999	0	applied	\N	\N	\N	\N	148923	148923	148924
29685	49000	1	applied	\N	\N	\N	\N	148925	148925	148926
29685	49001	2	applied	\N	\N	\N	\N	148927	148927	85388
29685	49002	3	applied	\N	\N	\N	\N	148928	148928	85390
29685	49003	4	applied	\N	\N	\N	\N	148929	148929	148930
29685	49004	5	applied	\N	\N	\N	\N	148931	148931	85394
29685	49005	6	applied	\N	\N	\N	\N	148932	148932	85403
29685	49006	7	applied	\N	\N	\N	\N	148933	148933	85413
29685	49007	8	applied	\N	\N	\N	\N	148934	148934	148935
29685	49008	9	applied	\N	\N	\N	\N	148936	148936	85426
29687	48999	0	applied	\N	\N	\N	\N	148923	148923	148924
29687	49000	1	applied	\N	\N	\N	\N	148925	148925	148926
29687	49001	2	applied	\N	\N	\N	\N	148927	148927	85388
29687	49002	3	applied	\N	\N	\N	\N	148928	148928	85390
29687	49003	4	applied	\N	\N	\N	\N	148929	148929	148930
29687	49004	5	applied	\N	\N	\N	\N	148931	148931	85394
29687	49005	6	applied	\N	\N	\N	\N	148932	148932	85403
29687	49006	7	applied	\N	\N	\N	\N	148933	148933	85413
29687	49007	8	applied	\N	\N	\N	\N	148934	148934	148935
29689	49015	0	applied	\N	\N	\N	\N	148953	148953	148954
29689	49016	1	applied	\N	\N	\N	\N	148955	148955	85456
29689	49017	2	applied	\N	\N	\N	\N	148956	148956	148957
29689	49018	3	applied	\N	\N	\N	\N	148958	148958	85460
29689	49019	4	applied	\N	\N	\N	\N	148959	148959	85661
29689	49020	5	applied	\N	\N	\N	\N	148960	148960	148961
29689	49021	6	applied	\N	\N	\N	\N	148962	148962	85663
29689	49022	7	applied	\N	\N	\N	\N	148963	148963	85474
29691	49030	0	applied	\N	\N	\N	\N	148978	148978	148979
29691	49031	1	applied	\N	\N	\N	\N	148980	148980	85504
29691	49032	2	applied	\N	\N	\N	\N	148981	148981	85669
29691	49033	3	applied	\N	\N	\N	\N	148982	148982	148983
29691	49034	4	applied	\N	\N	\N	\N	148984	148984	148985
29691	49035	5	applied	\N	\N	\N	\N	148986	148986	85671
29691	49036	6	applied	\N	\N	1000000000	\N	148987	148987	148988
29691	49037	7	applied	\N	\N	\N	\N	148989	148989	85522
29691	49038	8	applied	\N	\N	\N	\N	148990	148990	148991
29691	49039	9	applied	\N	\N	\N	\N	148992	148992	148993
29696	49040	0	applied	\N	\N	\N	\N	148997	148997	148998
29696	49041	1	applied	\N	\N	\N	\N	148999	148999	149000
29696	49042	2	applied	\N	\N	\N	\N	149001	149001	149002
29696	49043	3	applied	\N	\N	\N	\N	149003	149003	85543
29696	49044	4	applied	\N	\N	\N	\N	149004	149004	85675
29696	49045	5	applied	\N	\N	\N	\N	149005	149005	85677
29704	49046	0	applied	\N	\N	\N	\N	149015	149015	149016
29704	49047	1	applied	\N	\N	\N	\N	149017	149017	85555
29704	49048	2	applied	\N	\N	\N	\N	149018	149018	149019
29704	49049	3	applied	\N	\N	\N	\N	149020	149020	85565
29704	49052	4	applied	\N	\N	\N	\N	149024	149024	149031
29704	49053	5	applied	\N	\N	\N	\N	149025	149025	149022
29709	49062	0	applied	\N	\N	\N	\N	149047	149047	149048
29709	49063	1	applied	\N	\N	\N	\N	149049	149049	149050
29709	49064	2	applied	\N	\N	\N	\N	149051	149051	149052
29709	49065	3	applied	\N	\N	\N	\N	149053	149053	149054
29709	49066	4	applied	\N	\N	\N	\N	149055	149055	149055
29709	49067	5	applied	\N	\N	\N	\N	149056	149056	85603
29709	49068	6	applied	\N	\N	\N	\N	149057	149057	85902
29709	49069	7	applied	\N	\N	\N	\N	149058	149058	85605
29709	49070	8	applied	\N	\N	\N	\N	149059	149059	85621
29709	49071	9	applied	\N	\N	\N	\N	149060	149060	85904
29709	49072	10	applied	\N	\N	\N	\N	149061	149061	85802
29709	49073	11	applied	\N	\N	\N	\N	149062	149062	85627
29709	49074	12	applied	\N	\N	\N	\N	149063	149063	149064
29709	49075	13	applied	\N	\N	\N	\N	149065	149065	85803
29709	49076	14	applied	\N	\N	\N	\N	149066	149066	85690
29709	49077	15	applied	\N	\N	\N	\N	149067	149067	85805
29709	49078	16	applied	\N	\N	\N	\N	149068	149068	85906
29709	49079	17	applied	\N	\N	\N	\N	149069	149069	149070
29709	49080	18	applied	\N	\N	\N	\N	149071	149071	149071
29709	49081	19	applied	\N	\N	\N	\N	149072	149072	149073
29709	49082	20	applied	\N	\N	\N	\N	149074	149074	85907
29709	49083	21	applied	\N	\N	\N	\N	149075	149075	85806
29709	49084	22	applied	\N	\N	\N	\N	149076	149076	149077
29709	49085	23	applied	\N	\N	\N	\N	149078	149078	149079
29709	49086	24	applied	\N	\N	\N	\N	149080	149080	85807
29709	49087	25	applied	\N	\N	\N	\N	149081	149081	149082
29709	49088	26	applied	\N	\N	\N	\N	149083	149083	85809
29709	49089	27	applied	\N	\N	\N	\N	149084	149084	85810
29709	49090	28	applied	\N	\N	\N	\N	149085	149085	85745
29709	49091	29	applied	\N	\N	\N	\N	149086	149086	85759
29712	49062	0	applied	\N	\N	\N	\N	149047	149047	149048
29712	49063	1	applied	\N	\N	\N	\N	149049	149049	149050
29712	49064	2	applied	\N	\N	\N	\N	149051	149051	149052
29712	49065	3	applied	\N	\N	\N	\N	149053	149053	149054
29712	49066	4	applied	\N	\N	\N	\N	149055	149055	149055
29712	49067	5	applied	\N	\N	\N	\N	149056	149056	85603
29712	49068	6	applied	\N	\N	\N	\N	149057	149057	85902
29712	49069	7	applied	\N	\N	\N	\N	149058	149058	85605
29712	49070	8	applied	\N	\N	\N	\N	149059	149059	85621
29712	49071	9	applied	\N	\N	\N	\N	149060	149060	85904
29712	49072	10	applied	\N	\N	\N	\N	149061	149061	85802
29712	49073	11	applied	\N	\N	\N	\N	149062	149062	85627
29712	49074	12	applied	\N	\N	\N	\N	149063	149063	149064
29712	49075	13	applied	\N	\N	\N	\N	149065	149065	85803
29712	49076	14	applied	\N	\N	\N	\N	149066	149066	85690
29712	49077	15	applied	\N	\N	\N	\N	149067	149067	85805
29712	49078	16	applied	\N	\N	\N	\N	149068	149068	85906
29712	49079	17	applied	\N	\N	\N	\N	149069	149069	149070
29712	49080	18	applied	\N	\N	\N	\N	149071	149071	149071
29712	49081	19	applied	\N	\N	\N	\N	149072	149072	149073
29712	49082	20	applied	\N	\N	\N	\N	149074	149074	85907
29712	49083	21	applied	\N	\N	\N	\N	149075	149075	85806
29712	49084	22	applied	\N	\N	\N	\N	149076	149076	149077
29712	49085	23	applied	\N	\N	\N	\N	149078	149078	149079
29712	49086	24	applied	\N	\N	\N	\N	149080	149080	85807
29712	49087	25	applied	\N	\N	\N	\N	149081	149081	149082
29712	49088	26	applied	\N	\N	\N	\N	149083	149083	85809
29712	49089	27	applied	\N	\N	\N	\N	149084	149084	85810
29712	49090	28	applied	\N	\N	\N	\N	149085	149085	85745
29712	49091	29	applied	\N	\N	\N	\N	149086	149086	85759
29714	48846	0	applied	\N	\N	1000000000	\N	148653	148653	148654
29714	48733	1	applied	\N	\N	\N	\N	148457	148457	148457
29714	48707	2	applied	\N	\N	\N	\N	148407	148407	148408
29714	48961	3	applied	\N	\N	\N	\N	148846	148846	148847
29714	48734	4	applied	\N	\N	\N	\N	148458	148458	148459
29714	48508	5	applied	\N	\N	\N	\N	147924	147924	147925
29714	48753	6	applied	\N	\N	\N	\N	148488	148488	111296
29714	48598	7	applied	\N	\N	\N	\N	148160	148160	148161
29702	49052	6	applied	\N	\N	\N	\N	149024	149024	85681
29702	49053	7	applied	\N	\N	\N	\N	149025	149025	85578
29702	49054	8	applied	\N	\N	\N	\N	149026	149026	85682
29706	49055	0	applied	\N	\N	\N	\N	149034	149034	149035
29706	49056	1	applied	\N	\N	\N	\N	149036	149036	85584
29706	49057	2	applied	\N	\N	\N	\N	149037	149037	85586
29706	49058	3	applied	\N	\N	\N	\N	149038	149038	85597
29706	49059	4	applied	\N	\N	\N	\N	149039	149039	149040
29706	49060	5	applied	\N	\N	\N	\N	149041	149041	85601
29706	49061	6	applied	\N	\N	\N	\N	149042	149042	85901
29708	49056	0	applied	\N	\N	\N	\N	149036	149036	85584
29708	49057	1	applied	\N	\N	\N	\N	149037	149037	85586
29708	49058	2	applied	\N	\N	\N	\N	149038	149038	85597
29708	49059	3	applied	\N	\N	\N	\N	149039	149039	149040
29708	49060	4	applied	\N	\N	\N	\N	149041	149041	85601
29708	49061	5	applied	\N	\N	\N	\N	149042	149042	85901
29711	49062	0	applied	\N	\N	\N	\N	149047	149047	149048
29711	49063	1	applied	\N	\N	\N	\N	149049	149049	149050
29711	49064	2	applied	\N	\N	\N	\N	149051	149051	149052
29711	49065	3	applied	\N	\N	\N	\N	149053	149053	149054
29711	49066	4	applied	\N	\N	\N	\N	149055	149055	149055
29711	49067	5	applied	\N	\N	\N	\N	149056	149056	85603
29711	49068	6	applied	\N	\N	\N	\N	149057	149057	85902
29711	49069	7	applied	\N	\N	\N	\N	149058	149058	85605
29711	49070	8	applied	\N	\N	\N	\N	149059	149059	85621
29711	49071	9	applied	\N	\N	\N	\N	149060	149060	85904
29711	49072	10	applied	\N	\N	\N	\N	149061	149061	85802
29711	49073	11	applied	\N	\N	\N	\N	149062	149062	85627
29711	49074	12	applied	\N	\N	\N	\N	149063	149063	149064
29711	49075	13	applied	\N	\N	\N	\N	149065	149065	85803
29711	49076	14	applied	\N	\N	\N	\N	149066	149066	85690
29711	49077	15	applied	\N	\N	\N	\N	149067	149067	85805
29711	49078	16	applied	\N	\N	\N	\N	149068	149068	85906
29711	49079	17	applied	\N	\N	\N	\N	149069	149069	149070
29711	49080	18	applied	\N	\N	\N	\N	149071	149071	149071
29711	49081	19	applied	\N	\N	\N	\N	149072	149072	149073
29711	49082	20	applied	\N	\N	\N	\N	149074	149074	85907
29711	49083	21	applied	\N	\N	\N	\N	149075	149075	85806
29711	49084	22	applied	\N	\N	\N	\N	149076	149076	149077
29711	49085	23	applied	\N	\N	\N	\N	149078	149078	149079
29711	49086	24	applied	\N	\N	\N	\N	149080	149080	85807
29711	49087	25	applied	\N	\N	\N	\N	149081	149081	149082
29711	49088	26	applied	\N	\N	\N	\N	149083	149083	85809
29711	49089	27	applied	\N	\N	\N	\N	149084	149084	85810
29711	49090	28	applied	\N	\N	\N	\N	149085	149085	85745
29711	49091	29	applied	\N	\N	\N	\N	149086	149086	85759
29716	49092	0	applied	\N	\N	\N	\N	149096	149096	149097
29716	49093	1	applied	\N	\N	\N	\N	149098	149098	149099
29716	49094	3	applied	\N	\N	\N	\N	149101	149101	149102
29716	49095	4	applied	\N	\N	\N	\N	149103	149103	85814
29716	49096	5	applied	\N	\N	\N	\N	149104	149104	85816
29716	49097	6	applied	\N	\N	\N	\N	149105	149105	149106
29716	49098	7	applied	\N	\N	\N	\N	149107	149107	149108
29716	49099	8	applied	\N	\N	\N	\N	149109	149109	85767
29716	49100	9	applied	\N	\N	\N	\N	149110	149110	85772
29716	49101	10	applied	\N	\N	\N	\N	149111	149111	85817
29716	49102	11	applied	\N	\N	\N	\N	149112	149112	85778
29716	49103	12	applied	\N	\N	\N	\N	149113	149113	149114
29716	49104	13	applied	\N	\N	\N	\N	149115	149115	149116
29716	49105	14	applied	\N	\N	\N	\N	149117	149117	149118
29716	49106	15	applied	\N	\N	\N	\N	149119	149119	149120
29716	49107	16	applied	\N	\N	\N	\N	149121	149121	149122
29716	49108	17	applied	\N	\N	\N	\N	149123	149123	149124
29716	49110	18	applied	\N	\N	\N	\N	149127	149127	149128
29716	49111	19	applied	\N	\N	\N	\N	149129	149129	85780
29718	49112	0	applied	\N	\N	\N	\N	149133	149133	149134
29718	49114	1	applied	\N	\N	\N	\N	149137	149137	85820
29718	49115	2	applied	\N	\N	\N	\N	149138	149138	85792
29718	49116	3	applied	\N	\N	\N	\N	149139	149139	85912
29718	49109	4	applied	\N	\N	\N	\N	149125	149125	149126
29718	49113	5	applied	\N	\N	\N	\N	149135	149135	149136
29718	49117	6	applied	\N	\N	\N	\N	149140	149140	85828
29718	49118	7	applied	\N	\N	\N	\N	149141	149141	149142
29718	49119	8	applied	\N	\N	\N	\N	149143	149143	149144
29718	49120	9	applied	\N	\N	\N	\N	149145	149145	149146
29718	49121	10	applied	\N	\N	\N	\N	149147	149147	85838
29718	49122	11	applied	\N	\N	\N	\N	149148	149148	85840
29718	49123	12	applied	\N	\N	\N	\N	149149	149149	149150
29718	49124	13	applied	\N	\N	\N	\N	149151	149151	149152
29718	49125	14	applied	\N	\N	\N	\N	149153	149153	149154
29718	49126	15	applied	\N	\N	\N	\N	149155	149155	149156
29718	49127	16	applied	\N	\N	\N	\N	149159	149159	149160
29718	49128	17	applied	\N	\N	\N	\N	149161	149161	149162
29718	49129	18	applied	\N	\N	\N	\N	149163	149163	149164
29718	49130	19	applied	\N	\N	\N	\N	149165	149165	149166
29718	49131	20	applied	\N	\N	\N	\N	149167	149167	149168
29718	49132	21	applied	\N	\N	\N	\N	149169	149169	149170
29718	49133	22	applied	\N	\N	\N	\N	149171	149171	149172
29718	49134	23	applied	\N	\N	\N	\N	149173	149173	149174
29718	49135	24	applied	\N	\N	\N	\N	149175	149175	149176
29718	49136	25	applied	\N	\N	\N	\N	149177	149177	149178
29718	49137	26	applied	\N	\N	\N	\N	149179	149179	149180
29721	49148	0	applied	\N	\N	\N	\N	149204	149204	149205
29721	49149	1	applied	\N	\N	\N	\N	149206	149206	149207
29721	49150	2	applied	\N	\N	\N	\N	149208	149208	149209
29721	49151	3	applied	\N	\N	\N	\N	149210	149210	85888
29721	49152	4	applied	\N	\N	\N	\N	149211	149211	85892
29721	49153	5	applied	\N	\N	\N	\N	149212	149212	149213
29721	49154	6	applied	\N	\N	\N	\N	149214	149214	149215
29721	49155	7	applied	\N	\N	\N	\N	149216	149216	149217
29721	49156	8	applied	\N	\N	\N	\N	149218	149218	149219
29726	49157	0	applied	\N	\N	\N	\N	149227	149227	149228
29726	49158	1	applied	\N	\N	\N	\N	149229	149229	149230
29726	49159	2	applied	\N	\N	\N	\N	149231	149231	149232
29726	49160	3	applied	\N	\N	\N	\N	149233	149233	85943
29726	49161	4	applied	\N	\N	\N	\N	149234	149234	85949
29726	49162	5	applied	\N	\N	\N	\N	149235	149235	149236
29726	49163	6	applied	\N	\N	\N	\N	149237	149237	149238
29726	49164	7	applied	\N	\N	\N	\N	149239	149239	85965
29726	49165	8	applied	\N	\N	\N	\N	149240	149240	86376
29726	49166	9	applied	\N	\N	\N	\N	149241	149241	149242
29726	49167	10	applied	\N	\N	\N	\N	149243	149243	85967
29726	49168	11	applied	\N	\N	\N	\N	149244	149244	85969
29726	49169	12	applied	\N	\N	\N	\N	149245	149245	86377
29726	49170	13	applied	\N	\N	\N	\N	149246	149246	86378
29726	49171	14	applied	\N	\N	\N	\N	149247	149247	86379
29726	49172	15	applied	\N	\N	\N	\N	149248	149248	86380
29726	49173	16	applied	\N	\N	\N	\N	149249	149249	86382
29733	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29733	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29713	49071	9	applied	\N	\N	\N	\N	149060	149060	85904
29713	49072	10	applied	\N	\N	\N	\N	149061	149061	85802
29713	49073	11	applied	\N	\N	\N	\N	149062	149062	85627
29713	49074	12	applied	\N	\N	\N	\N	149063	149063	149064
29713	49075	13	applied	\N	\N	\N	\N	149065	149065	85803
29713	49076	14	applied	\N	\N	\N	\N	149066	149066	85690
29713	49077	15	applied	\N	\N	\N	\N	149067	149067	85805
29713	49078	16	applied	\N	\N	\N	\N	149068	149068	85906
29713	49079	17	applied	\N	\N	\N	\N	149069	149069	149070
29713	49080	18	applied	\N	\N	\N	\N	149071	149071	149071
29713	49081	19	applied	\N	\N	\N	\N	149072	149072	149073
29713	49082	20	applied	\N	\N	\N	\N	149074	149074	85907
29713	49083	21	applied	\N	\N	\N	\N	149075	149075	85806
29713	49084	22	applied	\N	\N	\N	\N	149076	149076	149077
29713	49085	23	applied	\N	\N	\N	\N	149078	149078	149079
29713	49086	24	applied	\N	\N	\N	\N	149080	149080	85807
29713	49087	25	applied	\N	\N	\N	\N	149081	149081	149082
29713	49088	26	applied	\N	\N	\N	\N	149083	149083	85809
29713	49089	27	applied	\N	\N	\N	\N	149084	149084	85810
29713	49090	28	applied	\N	\N	\N	\N	149085	149085	85745
29713	49091	29	applied	\N	\N	\N	\N	149086	149086	85759
29723	49148	0	applied	\N	\N	\N	\N	149204	149204	149205
29723	49149	1	applied	\N	\N	\N	\N	149206	149206	149207
29723	49150	2	applied	\N	\N	\N	\N	149208	149208	149209
29723	49151	3	applied	\N	\N	\N	\N	149210	149210	85888
29723	49152	4	applied	\N	\N	\N	\N	149211	149211	85892
29723	49153	5	applied	\N	\N	\N	\N	149212	149212	149213
29723	49154	6	applied	\N	\N	\N	\N	149214	149214	149215
29723	49155	7	applied	\N	\N	\N	\N	149216	149216	149217
29723	49156	8	applied	\N	\N	\N	\N	149218	149218	149219
29725	49148	0	applied	\N	\N	\N	\N	149204	149204	149205
29725	49149	1	applied	\N	\N	\N	\N	149206	149206	149207
29725	49150	2	applied	\N	\N	\N	\N	149208	149208	149209
29725	49151	3	applied	\N	\N	\N	\N	149210	149210	85888
29725	49152	4	applied	\N	\N	\N	\N	149211	149211	85892
29725	49153	5	applied	\N	\N	\N	\N	149212	149212	149213
29725	49154	6	applied	\N	\N	\N	\N	149214	149214	149215
29725	49155	7	applied	\N	\N	\N	\N	149216	149216	149217
29725	49156	8	applied	\N	\N	\N	\N	149218	149218	149219
29727	49174	0	applied	\N	\N	\N	\N	149252	149252	149253
29727	49175	1	applied	\N	\N	\N	\N	149254	149254	86383
29727	49176	2	applied	\N	\N	\N	\N	149255	149255	86000
29727	49177	3	applied	\N	\N	\N	\N	149256	149256	90314
29727	49178	4	applied	\N	\N	\N	\N	149257	149257	90316
29727	49179	5	applied	\N	\N	\N	\N	149258	149258	86387
29727	49180	6	applied	\N	\N	\N	\N	149259	149259	86019
29727	49181	7	applied	\N	\N	\N	\N	149260	149260	86388
29727	49182	8	applied	\N	\N	\N	\N	149261	149261	149262
29729	49174	0	applied	\N	\N	\N	\N	149252	149252	149253
29729	49175	1	applied	\N	\N	\N	\N	149254	149254	86383
29729	49176	2	applied	\N	\N	\N	\N	149255	149255	86000
29729	49177	3	applied	\N	\N	\N	\N	149256	149256	90314
29729	49178	4	applied	\N	\N	\N	\N	149257	149257	90316
29729	49179	5	applied	\N	\N	\N	\N	149258	149258	86387
29729	49180	6	applied	\N	\N	\N	\N	149259	149259	86019
29729	49181	7	applied	\N	\N	\N	\N	149260	149260	86388
29729	49182	8	applied	\N	\N	\N	\N	149261	149261	149262
29731	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29731	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29731	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29731	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29731	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29731	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29731	49189	6	applied	\N	\N	\N	\N	149280	149280	149281
29735	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29735	49179	1	applied	\N	\N	\N	\N	149258	149258	86019
29735	49181	2	applied	\N	\N	\N	\N	149260	149260	86388
29735	49186	3	applied	\N	\N	\N	\N	149274	149274	86021
29735	49182	4	applied	\N	\N	\N	\N	149261	149261	86027
29735	49184	5	applied	\N	\N	\N	\N	149271	149271	149288
29735	49185	6	applied	\N	\N	\N	\N	149273	149273	149275
29735	49187	7	applied	\N	\N	\N	\N	149276	149276	149277
29735	49188	8	applied	\N	\N	\N	\N	149278	149278	149279
29737	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29737	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29737	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29737	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29737	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29737	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29742	49243	0	applied	\N	\N	\N	\N	149380	149380	149381
29742	49244	1	applied	\N	\N	\N	\N	149382	149382	149383
29742	49245	2	applied	\N	\N	\N	\N	149384	149384	149385
29742	49246	3	applied	\N	\N	\N	\N	149386	149386	86532
29742	49247	4	applied	\N	\N	\N	\N	149387	149387	86540
29742	49248	5	applied	\N	\N	\N	\N	149388	149388	149389
29742	49249	6	applied	\N	\N	\N	\N	149390	149390	86552
29742	49250	7	applied	\N	\N	\N	\N	149391	149391	149392
29742	49251	8	applied	\N	\N	\N	\N	149393	149393	86618
29742	49252	9	applied	\N	\N	\N	\N	149394	149394	86819
29742	49253	10	applied	\N	\N	\N	\N	149395	149395	149396
29742	49254	11	applied	\N	\N	\N	\N	149397	149397	149398
29742	49255	12	applied	\N	\N	\N	\N	149399	149399	86820
29742	49256	13	applied	\N	\N	\N	\N	149400	149400	149401
29742	49257	14	applied	\N	\N	\N	\N	149402	149402	86632
29742	49258	15	applied	\N	\N	\N	\N	149403	149403	86821
29744	49259	0	applied	\N	\N	\N	\N	149406	149406	149407
29744	49260	1	applied	\N	\N	\N	\N	149408	149408	149409
29744	49261	2	applied	\N	\N	\N	\N	149410	149410	86634
29744	49262	3	applied	\N	\N	\N	\N	149411	149411	86727
29744	49271	4	applied	\N	\N	\N	\N	149424	149424	86728
29744	49272	5	applied	\N	\N	\N	\N	149425	149425	86650
29744	49273	6	applied	\N	\N	\N	\N	149426	149426	149415
29744	49274	7	applied	\N	\N	\N	\N	149427	149427	86659
29744	49275	8	applied	\N	\N	\N	\N	149428	149428	86729
29744	49263	9	applied	\N	\N	\N	\N	149412	149412	86660
29744	49264	10	applied	\N	\N	\N	\N	149413	149413	149429
29744	49276	11	applied	\N	\N	\N	\N	149430	149430	86731
29744	49265	12	applied	\N	\N	\N	\N	149414	149414	149419
29744	49266	13	applied	\N	\N	\N	\N	149416	149416	86740
29744	49267	14	applied	\N	\N	\N	\N	149417	149417	86744
29744	49268	15	applied	\N	\N	\N	\N	149418	149418	149431
29744	49269	16	applied	\N	\N	\N	\N	149420	149420	86764
29744	49270	17	applied	\N	\N	\N	\N	149421	149421	86774
29748	49277	0	applied	\N	\N	\N	\N	149436	149436	149437
29748	49278	1	applied	\N	\N	\N	\N	149438	149438	149439
29748	49279	2	applied	\N	\N	\N	\N	149440	149440	149441
29748	49280	3	applied	\N	\N	\N	\N	149442	149442	86920
29748	49281	4	applied	\N	\N	\N	\N	149443	149443	86776
29748	49282	5	applied	\N	\N	\N	\N	149444	149444	86921
29748	49293	6	applied	\N	\N	\N	\N	149458	149458	86778
29714	48509	8	applied	\N	\N	\N	\N	147926	147926	147927
29714	48522	9	applied	\N	\N	\N	\N	147957	147957	147958
29714	48462	10	applied	\N	\N	\N	\N	147795	147795	147796
29714	48465	11	applied	\N	\N	\N	\N	147800	147800	147801
29714	48469	12	applied	\N	\N	\N	\N	147831	147831	147832
29714	48471	13	applied	\N	\N	\N	\N	147836	147836	147837
29714	48754	14	applied	\N	\N	1000000000	\N	148489	148489	148490
29714	48627	15	applied	\N	\N	\N	\N	148222	148222	111296
29714	48523	16	applied	\N	\N	\N	\N	147959	147959	147960
29714	48472	17	applied	\N	\N	\N	\N	147838	147838	147839
29714	48473	18	applied	\N	\N	\N	\N	147840	147840	147841
29714	48481	19	applied	\N	\N	\N	\N	147857	147857	147858
29714	48483	20	applied	\N	\N	\N	\N	147864	147864	147865
29714	48487	21	applied	\N	\N	\N	\N	147873	147873	147874
29714	48488	22	applied	\N	\N	\N	\N	147875	147875	147876
29714	48493	23	applied	\N	\N	\N	\N	147888	147888	147889
29714	48494	24	applied	\N	\N	\N	\N	147890	147890	147891
29714	48499	26	applied	\N	\N	\N	\N	147899	147899	147900
29714	48502	27	applied	\N	\N	\N	\N	147910	147910	147911
29714	48504	28	applied	\N	\N	\N	\N	147915	147915	147916
29714	48510	29	applied	\N	\N	\N	\N	147928	147928	147929
29714	48513	30	applied	\N	\N	\N	\N	147933	147933	147934
29714	48515	31	applied	\N	\N	\N	\N	147940	147940	147941
29714	48519	32	applied	\N	\N	\N	\N	147948	147948	147949
29714	48524	33	applied	\N	\N	\N	\N	147961	147961	147962
29714	48525	34	applied	\N	\N	\N	\N	147963	147963	147964
29714	48526	35	applied	\N	\N	\N	\N	147965	147965	147966
29714	48533	36	applied	\N	\N	\N	\N	147977	147977	147978
29714	48536	37	applied	\N	\N	\N	\N	147989	147989	147990
29714	48537	38	applied	\N	\N	\N	\N	147991	147991	147992
29714	48544	39	applied	\N	\N	\N	\N	148010	148010	148011
29714	48545	40	applied	\N	\N	\N	\N	148012	148012	148013
29714	48549	41	applied	\N	\N	\N	\N	148023	148023	148024
29714	48550	42	applied	\N	\N	\N	\N	148025	148025	148026
29714	48555	43	applied	\N	\N	\N	\N	148037	148037	148038
29714	48558	44	applied	\N	\N	\N	\N	148043	148043	148044
29714	48559	45	applied	\N	\N	\N	\N	148045	148045	148046
29714	48560	46	applied	\N	\N	\N	\N	148047	148047	148048
29714	48561	47	applied	\N	\N	\N	\N	148049	148049	148050
29714	48570	48	applied	\N	\N	\N	\N	148067	148067	148068
29714	48571	49	applied	\N	\N	\N	\N	148070	148070	148071
29714	48576	50	applied	\N	\N	\N	\N	148081	148081	148082
29714	48578	51	applied	\N	\N	\N	\N	148085	148085	148086
29714	48582	52	applied	\N	\N	\N	\N	148097	148097	148098
29714	48586	53	applied	\N	\N	\N	\N	148105	148105	148106
29714	48589	54	applied	\N	\N	\N	\N	148113	148113	148114
29714	48591	55	applied	\N	\N	\N	\N	148141	148141	148142
29714	48595	56	applied	\N	\N	\N	\N	148151	148151	148152
29714	48599	57	applied	\N	\N	\N	\N	148162	148162	148163
29714	48601	58	applied	\N	\N	\N	\N	148170	148170	148171
29714	48602	59	applied	\N	\N	\N	\N	148172	148172	148173
29714	48603	60	applied	\N	\N	\N	\N	148174	148174	148175
29714	48604	61	applied	\N	\N	\N	\N	148176	148176	148177
29714	48614	62	applied	\N	\N	\N	\N	148193	148193	148194
29714	48615	63	applied	\N	\N	\N	\N	148195	148195	148196
29714	48621	64	applied	\N	\N	\N	\N	148207	148207	148208
29714	48624	65	applied	\N	\N	\N	\N	148215	148215	148216
29714	48628	66	applied	\N	\N	\N	\N	148223	148223	148224
29714	48629	67	applied	\N	\N	\N	\N	148225	148225	148226
29714	48634	68	applied	\N	\N	\N	\N	148239	148239	148240
29714	48635	69	applied	\N	\N	\N	\N	148241	148241	148242
29714	48640	70	applied	\N	\N	\N	\N	148251	148251	148252
29714	48641	71	applied	\N	\N	\N	\N	148253	148253	148254
29714	48646	72	applied	\N	\N	\N	\N	148264	148264	148265
29714	48647	73	applied	\N	\N	\N	\N	148266	148266	148267
29714	48648	74	applied	\N	\N	\N	\N	148268	148268	148269
29714	48649	75	applied	\N	\N	\N	\N	148270	148270	148271
29714	48659	76	applied	\N	\N	\N	\N	148287	148287	148288
29714	48662	77	applied	\N	\N	\N	\N	148299	148299	148300
29714	48663	78	applied	\N	\N	\N	\N	148301	148301	148302
29714	48664	79	applied	\N	\N	\N	\N	148303	148303	148304
29714	48673	80	applied	\N	\N	\N	\N	148323	148323	148324
29714	48676	81	applied	\N	\N	\N	\N	148331	148331	148332
29714	48679	82	applied	\N	\N	\N	\N	148340	148340	148341
29714	48684	83	applied	\N	\N	\N	\N	148351	148351	148352
29714	48687	84	applied	\N	\N	\N	\N	148357	148357	148358
29714	48690	85	applied	\N	\N	\N	\N	148367	148367	148368
29714	48693	86	applied	\N	\N	\N	\N	148374	148374	148375
29714	48698	87	applied	\N	\N	\N	\N	148386	148386	148387
29714	48708	88	applied	\N	\N	\N	\N	148409	148409	148410
29714	48709	89	applied	\N	\N	\N	\N	148411	148411	148412
29714	48726	90	applied	\N	\N	\N	\N	148438	148438	148439
29714	48735	91	applied	\N	\N	\N	\N	148460	148460	148461
29714	48736	92	applied	\N	\N	\N	\N	148462	148462	148463
29714	48755	93	applied	\N	\N	\N	\N	148491	148491	148492
29714	48756	94	applied	\N	\N	\N	\N	148493	148493	148494
29714	48757	95	applied	\N	\N	\N	\N	148495	148495	148496
29714	48792	96	applied	\N	\N	\N	\N	148553	148553	148554
29714	48793	97	applied	\N	\N	\N	\N	148555	148555	148556
29714	48806	98	applied	\N	\N	\N	\N	148583	148583	148584
29714	48807	99	applied	\N	\N	\N	\N	148585	148585	148586
29714	48821	100	applied	\N	\N	\N	\N	148611	148611	148612
29714	48829	101	applied	\N	\N	\N	\N	148623	148623	148624
29714	48838	102	applied	\N	\N	\N	\N	148640	148640	148641
29714	48847	103	applied	\N	\N	\N	\N	148655	148655	148656
29714	48848	104	applied	\N	\N	\N	\N	148657	148657	148658
29714	48849	105	applied	\N	\N	\N	\N	148659	148659	148660
29714	48874	106	applied	\N	\N	\N	\N	148699	148699	148700
29714	48875	107	applied	\N	\N	\N	\N	148701	148701	148702
29714	48892	108	applied	\N	\N	\N	\N	148731	148731	148732
29714	48902	109	applied	\N	\N	\N	\N	148750	148750	148751
29714	48903	110	applied	\N	\N	\N	\N	148752	148752	148753
29714	48919	111	applied	\N	\N	\N	\N	148784	148784	148785
29714	48920	112	applied	\N	\N	\N	\N	148786	148786	148787
29714	48934	113	applied	\N	\N	\N	\N	148806	148806	148807
29714	48952	114	applied	\N	\N	\N	\N	148831	148831	148832
29714	48962	115	applied	\N	\N	\N	\N	148848	148848	148849
29714	48974	116	applied	\N	\N	\N	\N	148874	148874	148875
29714	48982	117	applied	\N	\N	\N	\N	148887	148887	148888
29714	48983	118	applied	\N	\N	\N	\N	148889	148889	148890
29714	48999	119	applied	\N	\N	\N	\N	148923	148923	148924
29714	49009	120	applied	\N	\N	\N	\N	148942	148942	148943
29714	49015	121	applied	\N	\N	\N	\N	148953	148953	148954
29714	49023	122	applied	\N	\N	\N	\N	148965	148965	148966
29714	49030	123	applied	\N	\N	\N	\N	148978	148978	148979
29714	49040	124	applied	\N	\N	\N	\N	148997	148997	148998
29714	49046	125	applied	\N	\N	\N	\N	149015	149015	149016
29720	48227	0	applied	\N	\N	\N	\N	147243	147243	147244
29720	48846	1	applied	\N	\N	1000000000	\N	148653	148653	148654
29715	49103	12	applied	\N	\N	\N	\N	149113	149113	149114
29715	49104	13	applied	\N	\N	\N	\N	149115	149115	149116
29715	49105	14	applied	\N	\N	\N	\N	149117	149117	149118
29715	49106	15	applied	\N	\N	\N	\N	149119	149119	149120
29715	49107	16	applied	\N	\N	\N	\N	149121	149121	149122
29715	49108	17	applied	\N	\N	\N	\N	149123	149123	149124
29715	49109	18	applied	\N	\N	\N	\N	149125	149125	149126
29715	49110	19	applied	\N	\N	\N	\N	149127	149127	149128
29715	49111	20	applied	\N	\N	\N	\N	149129	149129	85780
29717	49112	0	applied	\N	\N	\N	\N	149133	149133	149134
29717	49113	1	applied	\N	\N	\N	\N	149135	149135	149136
29717	49114	2	applied	\N	\N	\N	\N	149137	149137	85820
29717	49115	3	applied	\N	\N	\N	\N	149138	149138	85792
29717	49116	4	applied	\N	\N	\N	\N	149139	149139	85912
29717	49117	5	applied	\N	\N	\N	\N	149140	149140	85828
29717	49118	6	applied	\N	\N	\N	\N	149141	149141	149142
29717	49119	7	applied	\N	\N	\N	\N	149143	149143	149144
29717	49120	8	applied	\N	\N	\N	\N	149145	149145	149146
29717	49121	9	applied	\N	\N	\N	\N	149147	149147	85838
29717	49122	10	applied	\N	\N	\N	\N	149148	149148	85840
29717	49123	11	applied	\N	\N	\N	\N	149149	149149	149150
29717	49124	12	applied	\N	\N	\N	\N	149151	149151	149152
29717	49125	13	applied	\N	\N	\N	\N	149153	149153	149154
29717	49126	14	applied	\N	\N	\N	\N	149155	149155	149156
29719	49138	0	applied	\N	\N	\N	\N	149183	149183	149184
29719	49139	1	applied	\N	\N	\N	\N	149185	149185	149186
29719	49127	2	applied	\N	\N	\N	\N	149159	149159	149160
29719	49140	3	applied	\N	\N	\N	\N	149187	149187	149188
29719	49141	4	applied	\N	\N	\N	\N	149189	149189	149190
29719	49128	5	applied	\N	\N	\N	\N	149161	149161	149162
29719	49142	6	applied	\N	\N	\N	\N	149191	149191	85844
29719	49143	7	applied	\N	\N	\N	\N	149192	149192	149193
29719	49144	8	applied	\N	\N	\N	\N	149194	149194	149195
29719	49145	9	applied	\N	\N	\N	\N	149196	149196	85869
29719	49146	10	applied	\N	\N	\N	\N	149197	149197	149198
29719	49147	11	applied	\N	\N	\N	\N	149199	149199	85875
29719	49129	12	applied	\N	\N	\N	\N	149163	149163	149164
29719	49130	13	applied	\N	\N	\N	\N	149165	149165	149166
29719	49131	14	applied	\N	\N	\N	\N	149167	149167	149168
29719	49132	15	applied	\N	\N	\N	\N	149169	149169	149170
29719	49133	16	applied	\N	\N	\N	\N	149171	149171	149172
29719	49134	17	applied	\N	\N	\N	\N	149173	149173	149174
29719	49135	18	applied	\N	\N	\N	\N	149175	149175	149176
29719	49136	19	applied	\N	\N	\N	\N	149177	149177	149178
29719	49137	20	applied	\N	\N	\N	\N	149179	149179	149180
29724	49148	0	applied	\N	\N	\N	\N	149204	149204	149205
29724	49149	1	applied	\N	\N	\N	\N	149206	149206	149207
29724	49153	2	applied	\N	\N	\N	\N	149212	149212	85877
29724	49154	3	applied	\N	\N	\N	\N	149214	149214	85922
29724	49155	4	applied	\N	\N	\N	\N	149216	149216	85886
29724	49156	5	applied	\N	\N	\N	\N	149218	149218	85924
29738	49190	0	applied	\N	\N	\N	\N	149293	149293	149294
29738	49191	1	applied	\N	\N	\N	\N	149295	149295	86101
29738	49192	2	applied	\N	\N	\N	\N	149296	149296	149297
29738	49193	3	applied	\N	\N	\N	\N	149298	149298	86795
29738	49194	4	applied	\N	\N	\N	\N	149299	149299	86140
29738	49195	5	applied	\N	\N	\N	\N	149300	149300	86142
29738	49196	6	applied	\N	\N	\N	\N	149301	149301	86144
29740	49234	0	applied	\N	\N	\N	\N	149364	149364	149365
29740	49235	1	applied	\N	\N	\N	\N	149366	149366	86492
29740	49236	2	applied	\N	\N	\N	\N	149367	149367	149368
29740	49237	3	applied	\N	\N	\N	\N	149369	149369	86500
29740	49238	4	applied	\N	\N	\N	\N	149370	149370	149371
29740	49239	5	applied	\N	\N	\N	\N	149372	149372	86519
29740	49240	6	applied	\N	\N	\N	\N	149373	149373	86521
29740	49241	7	applied	\N	\N	\N	\N	149374	149374	86528
29740	49242	8	applied	\N	\N	\N	\N	149375	149375	149376
29747	49277	0	applied	\N	\N	\N	\N	149436	149436	149437
29747	49278	1	applied	\N	\N	\N	\N	149438	149438	149439
29747	49279	2	applied	\N	\N	\N	\N	149440	149440	149441
29747	49280	3	applied	\N	\N	\N	\N	149442	149442	86920
29747	49281	4	applied	\N	\N	\N	\N	149443	149443	86776
29747	49282	5	applied	\N	\N	\N	\N	149444	149444	86921
29747	49283	6	applied	\N	\N	\N	\N	149445	149445	87791
29747	49284	7	applied	\N	\N	\N	\N	149446	149446	86780
29747	49285	8	applied	\N	\N	\N	\N	149447	149447	87793
29747	49286	9	applied	\N	\N	\N	\N	149448	149448	86926
29747	49287	10	applied	\N	\N	\N	\N	149449	149449	86841
29747	49288	11	applied	\N	\N	\N	\N	149450	149450	87794
29747	49289	12	applied	\N	\N	\N	\N	149451	149451	86856
29747	49290	13	applied	\N	\N	\N	\N	149452	149452	149453
29747	49291	14	applied	\N	\N	\N	\N	149454	149454	86862
29747	49292	15	applied	\N	\N	\N	\N	149455	149455	86876
29749	49277	0	applied	\N	\N	\N	\N	149436	149436	149437
29749	49278	1	applied	\N	\N	\N	\N	149438	149438	149439
29749	49279	2	applied	\N	\N	\N	\N	149440	149440	149441
29749	49280	3	applied	\N	\N	\N	\N	149442	149442	86920
29749	49281	4	applied	\N	\N	\N	\N	149443	149443	86776
29749	49282	5	applied	\N	\N	\N	\N	149444	149444	86921
29749	49293	6	applied	\N	\N	\N	\N	149458	149458	86778
29749	49294	7	applied	\N	\N	\N	\N	149459	149459	86922
29749	49295	8	applied	\N	\N	\N	\N	149460	149460	86923
29749	49296	9	applied	\N	\N	\N	\N	149461	149461	86924
29749	49297	10	applied	\N	\N	\N	\N	149462	149462	86788
29749	49298	11	applied	\N	\N	\N	\N	149463	149463	86832
29749	49299	12	applied	\N	\N	\N	\N	149464	149464	87028
29749	49300	13	applied	\N	\N	\N	\N	149465	149465	86927
29749	49283	14	applied	\N	\N	\N	\N	149445	149445	86841
29749	49284	15	applied	\N	\N	\N	\N	149446	149446	87794
29749	49285	16	applied	\N	\N	\N	\N	149447	149447	86856
29749	49286	17	applied	\N	\N	\N	\N	149448	149448	149453
29749	49287	18	applied	\N	\N	\N	\N	149449	149449	86862
29749	49288	19	applied	\N	\N	\N	\N	149450	149450	86876
29749	49289	20	applied	\N	\N	\N	\N	149451	149451	87035
29749	49290	21	applied	\N	\N	\N	\N	149452	149452	87036
29749	49291	22	applied	\N	\N	\N	\N	149454	149454	86884
29749	49292	23	applied	\N	\N	\N	\N	149455	149455	86888
29751	49301	0	applied	\N	\N	\N	\N	149470	149470	149471
29751	49302	1	applied	\N	\N	\N	\N	149472	149472	149473
29753	49309	0	applied	\N	\N	\N	\N	149485	149485	149486
29753	49310	1	applied	\N	\N	\N	\N	149487	149487	86944
29753	49311	2	applied	\N	\N	\N	\N	149488	149488	149489
29755	49309	0	applied	\N	\N	\N	\N	149485	149485	149486
29755	49310	1	applied	\N	\N	\N	\N	149487	149487	86944
29755	49311	2	applied	\N	\N	\N	\N	149488	149488	149489
29755	49315	3	applied	\N	\N	\N	\N	149494	149494	86951
29755	49316	4	applied	\N	\N	\N	\N	149496	149496	86959
29760	49355	0	applied	\N	\N	\N	\N	149591	149591	149592
29760	49356	1	applied	\N	\N	\N	\N	149593	149593	87088
29760	49357	2	applied	\N	\N	\N	\N	149594	149594	149595
29720	48733	2	applied	\N	\N	\N	\N	148457	148457	148457
29720	48200	3	applied	\N	\N	\N	\N	147193	147193	147193
29720	48707	4	applied	\N	\N	\N	\N	148407	148407	148408
29720	48127	5	applied	\N	\N	\N	\N	147016	147016	147017
29720	48961	6	applied	\N	\N	\N	\N	148846	148846	148847
29720	48734	7	applied	\N	\N	\N	\N	148458	148458	148459
29720	48508	8	applied	\N	\N	\N	\N	147924	147924	147925
29720	48753	9	applied	\N	\N	\N	\N	148488	148488	111296
29720	48201	10	applied	\N	\N	\N	\N	147194	147194	147194
29720	48598	11	applied	\N	\N	\N	\N	148160	148160	148161
29720	48146	12	applied	\N	\N	1000000000	\N	147060	147060	147061
29720	47908	13	applied	\N	\N	\N	\N	146493	146493	146494
29720	48509	14	applied	\N	\N	\N	\N	147926	147926	147927
29720	48522	15	applied	\N	\N	\N	\N	147957	147957	147958
29720	48150	16	applied	\N	\N	\N	\N	147072	147072	147073
29720	48754	17	applied	\N	\N	1000000000	\N	148489	148489	148490
29720	47911	18	applied	\N	\N	\N	\N	146501	146501	146502
29720	47915	19	applied	\N	\N	\N	\N	146511	146511	146512
29720	47918	20	applied	\N	\N	\N	\N	146520	146520	146521
29720	48291	21	applied	\N	\N	\N	\N	147386	147386	147386
29720	48523	22	applied	\N	\N	\N	\N	147959	147959	147960
29720	48255	23	applied	\N	\N	\N	\N	147309	147309	147678
29720	48265	24	applied	\N	\N	\N	\N	147331	147331	147679
29720	48152	25	applied	\N	\N	\N	\N	147076	147076	147077
29720	48155	26	applied	\N	\N	\N	\N	147083	147083	147084
29720	47920	27	applied	\N	\N	\N	\N	146525	146525	146526
29720	47924	28	applied	\N	\N	\N	\N	146534	146534	146535
29720	47927	29	applied	\N	\N	\N	\N	146545	146545	146546
29720	47929	30	applied	\N	\N	\N	\N	146551	146551	146552
29720	47930	31	applied	\N	\N	\N	\N	146553	146553	146554
29720	47936	32	applied	\N	\N	\N	\N	146566	146566	146567
29720	47941	33	applied	\N	\N	\N	\N	146584	146584	146585
29720	47944	34	applied	\N	\N	\N	\N	146593	146593	146594
29720	47948	35	applied	\N	\N	\N	\N	146605	146605	146606
29720	47949	36	applied	\N	\N	\N	\N	146607	146607	146608
29720	47954	37	applied	\N	\N	\N	\N	146619	146619	146620
29720	47958	38	applied	\N	\N	\N	\N	146629	146629	146630
29720	47961	39	applied	\N	\N	\N	\N	146637	146637	146638
29720	47964	40	applied	\N	\N	\N	\N	146645	146645	146646
29720	47965	41	applied	\N	\N	\N	\N	146647	146647	146648
29720	47970	42	applied	\N	\N	\N	\N	146661	146661	146662
29720	47973	43	applied	\N	\N	\N	\N	146666	146666	146667
29720	47976	44	applied	\N	\N	\N	\N	146675	146675	146676
29720	47979	45	applied	\N	\N	\N	\N	146681	146681	146682
29720	47980	46	applied	\N	\N	\N	\N	146683	146683	146684
29720	47985	47	applied	\N	\N	\N	\N	146695	146695	146696
29720	47986	48	applied	\N	\N	\N	\N	146697	146697	146698
29720	47991	49	applied	\N	\N	\N	\N	146708	146708	146709
29720	47994	50	applied	\N	\N	\N	\N	146717	146717	146718
29720	47998	51	applied	\N	\N	\N	\N	146726	146726	146727
29720	48000	52	applied	\N	\N	\N	\N	146732	146732	146733
29720	48003	53	applied	\N	\N	\N	\N	146742	146742	146743
29720	48006	54	applied	\N	\N	\N	\N	146749	146749	146750
29720	48009	55	applied	\N	\N	\N	\N	146756	146756	146757
29720	48012	56	applied	\N	\N	\N	\N	146763	146763	146764
29720	48015	57	applied	\N	\N	\N	\N	146770	146770	146771
29720	48018	58	applied	\N	\N	\N	\N	146778	146778	146779
29720	48021	59	applied	\N	\N	\N	\N	146787	146787	146788
29720	48024	60	applied	\N	\N	\N	\N	146794	146794	146795
29720	48027	61	applied	\N	\N	\N	\N	146801	146801	146802
29720	48028	62	applied	\N	\N	\N	\N	146803	146803	146804
29720	48032	63	applied	\N	\N	\N	\N	146810	146810	146811
29720	48033	64	applied	\N	\N	\N	\N	146812	146812	146813
29720	48034	66	applied	\N	\N	\N	\N	146814	146814	146815
29720	48041	67	applied	\N	\N	\N	\N	146826	146826	146827
29720	48044	68	applied	\N	\N	\N	\N	146832	146832	146833
29720	48048	69	applied	\N	\N	\N	\N	146839	146839	146840
29720	48050	70	applied	\N	\N	\N	\N	146843	146843	146844
29720	48053	71	applied	\N	\N	\N	\N	146849	146849	146850
29720	48054	72	applied	\N	\N	\N	\N	146851	146851	146852
29720	48060	73	applied	\N	\N	\N	\N	146860	146860	146861
29720	48062	74	applied	\N	\N	\N	\N	146865	146865	146866
29720	48063	75	applied	\N	\N	\N	\N	146867	146867	146868
29720	48064	76	applied	\N	\N	\N	\N	146869	146869	146870
29720	48074	77	applied	\N	\N	\N	\N	146886	146886	146887
29720	48078	78	applied	\N	\N	\N	\N	146894	146894	146895
29720	48082	79	applied	\N	\N	\N	\N	146915	146915	146916
29720	48084	80	applied	\N	\N	\N	\N	146921	146921	146922
29720	48089	81	applied	\N	\N	\N	\N	146931	146931	146932
29720	48092	82	applied	\N	\N	\N	\N	146937	146937	146938
29720	48095	83	applied	\N	\N	\N	\N	146947	146947	146948
29720	48096	84	applied	\N	\N	\N	\N	146949	146949	146950
29720	48101	85	applied	\N	\N	\N	\N	146957	146957	146958
29720	48105	86	applied	\N	\N	\N	\N	146965	146965	146966
29720	48107	87	applied	\N	\N	\N	\N	146971	146971	146972
29720	48111	88	applied	\N	\N	\N	\N	146981	146981	146982
29720	48114	89	applied	\N	\N	\N	\N	146988	146988	146989
29720	48118	90	applied	\N	\N	\N	\N	146996	146996	146997
29720	48119	91	applied	\N	\N	\N	\N	146999	146999	147000
29720	48120	92	applied	\N	\N	\N	\N	147001	147001	147002
29720	48128	93	applied	\N	\N	\N	\N	147022	147022	147023
29720	48129	94	applied	\N	\N	\N	\N	147024	147024	147025
29720	48130	95	applied	\N	\N	\N	\N	147026	147026	147027
29720	48138	96	applied	\N	\N	\N	\N	147042	147042	147043
29720	48141	97	applied	\N	\N	\N	\N	147049	147049	147050
29720	48143	98	applied	\N	\N	\N	\N	147055	147055	147056
29720	48147	99	applied	\N	\N	\N	\N	147062	147062	147063
29720	48151	100	applied	\N	\N	\N	\N	147074	147074	147075
29720	48156	101	applied	\N	\N	\N	\N	147085	147085	147086
29720	48160	102	applied	\N	\N	\N	\N	147093	147093	147094
29720	48164	103	applied	\N	\N	\N	\N	147103	147103	147104
29720	48167	104	applied	\N	\N	\N	\N	147116	147116	147117
29720	48170	105	applied	\N	\N	\N	\N	147123	147123	147124
29720	48174	106	applied	\N	\N	\N	\N	147131	147131	147132
29720	48178	107	applied	\N	\N	\N	\N	147140	147140	147141
29720	48181	108	applied	\N	\N	\N	\N	147147	147147	147148
29720	48184	109	applied	\N	\N	\N	\N	147155	147155	147156
29720	48185	110	applied	\N	\N	\N	\N	147157	147157	147158
29720	48186	111	applied	\N	\N	\N	\N	147159	147159	147160
29720	48187	112	applied	\N	\N	\N	\N	147161	147161	147162
29720	48198	113	applied	\N	\N	\N	\N	147183	147183	147184
29720	48202	114	applied	\N	\N	\N	\N	147195	147195	147196
29720	48206	115	applied	\N	\N	\N	\N	147203	147203	147204
29720	48209	116	applied	\N	\N	\N	\N	147210	147210	147211
29720	48210	117	applied	\N	\N	\N	\N	147212	147212	147213
29720	48211	118	applied	\N	\N	\N	\N	147214	147214	147215
29720	48218	119	applied	\N	\N	\N	\N	147227	147227	147228
29720	48221	120	applied	\N	\N	\N	\N	147233	147233	147234
29720	48222	121	applied	\N	\N	\N	\N	147235	147235	147236
29720	48228	122	applied	\N	\N	\N	\N	147245	147245	147246
29720	48231	123	applied	\N	\N	\N	\N	147254	147254	147255
29720	48233	124	applied	\N	\N	\N	\N	147260	147260	147261
29720	48237	125	applied	\N	\N	\N	\N	147268	147268	147269
29722	49148	0	applied	\N	\N	\N	\N	149204	149204	149205
29722	49149	1	applied	\N	\N	\N	\N	149206	149206	149207
29722	49150	2	applied	\N	\N	\N	\N	149208	149208	149209
29722	49151	3	applied	\N	\N	\N	\N	149210	149210	85888
29722	49152	4	applied	\N	\N	\N	\N	149211	149211	85892
29722	49153	5	applied	\N	\N	\N	\N	149212	149212	149213
29722	49154	6	applied	\N	\N	\N	\N	149214	149214	149215
29722	49155	7	applied	\N	\N	\N	\N	149216	149216	149217
29722	49156	8	applied	\N	\N	\N	\N	149218	149218	149219
29728	49174	0	applied	\N	\N	\N	\N	149252	149252	149253
29728	49175	1	applied	\N	\N	\N	\N	149254	149254	86383
29728	49176	2	applied	\N	\N	\N	\N	149255	149255	86000
29728	49177	3	applied	\N	\N	\N	\N	149256	149256	90314
29728	49178	4	applied	\N	\N	\N	\N	149257	149257	90316
29728	49180	5	applied	\N	\N	\N	\N	149259	149259	149265
29730	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29730	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29730	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29730	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29730	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29730	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29730	49189	6	applied	\N	\N	\N	\N	149280	149280	149281
29732	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29732	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29732	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29732	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29732	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29732	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29732	49189	6	applied	\N	\N	\N	\N	149280	149280	149281
29734	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29734	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29734	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29734	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29734	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29734	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29734	49189	6	applied	\N	\N	\N	\N	149280	149280	149281
29736	49183	0	applied	\N	\N	\N	\N	149269	149269	149270
29736	49184	1	applied	\N	\N	\N	\N	149271	149271	149272
29736	49186	2	applied	\N	\N	\N	\N	149274	149274	149288
29736	49187	3	applied	\N	\N	\N	\N	149276	149276	149290
29736	49188	4	applied	\N	\N	\N	\N	149278	149278	86059
29739	49197	0	applied	\N	\N	\N	\N	149304	149304	149305
29739	49198	1	applied	\N	\N	\N	\N	149306	149306	149307
29739	49199	2	applied	\N	\N	\N	\N	149308	149308	149309
29739	49200	3	applied	\N	\N	\N	\N	149310	149310	86797
29739	49201	4	applied	\N	\N	\N	\N	149311	149311	86179
29739	49202	5	applied	\N	\N	\N	\N	149312	149312	86181
29739	49203	6	applied	\N	\N	\N	\N	149313	149313	86183
29739	49204	7	applied	\N	\N	\N	\N	149314	149314	86204
29739	49205	9	applied	\N	\N	\N	\N	149316	149316	149317
29739	49206	10	applied	\N	\N	\N	\N	149318	149318	86800
29739	49207	11	applied	\N	\N	\N	\N	149319	149319	86206
29739	49208	12	applied	\N	\N	\N	\N	149320	149320	149321
29739	49209	13	applied	\N	\N	\N	\N	149322	149322	149323
29739	49210	14	applied	\N	\N	\N	\N	149324	149324	149325
29739	49211	15	applied	\N	\N	\N	\N	149326	149326	149327
29739	49212	16	applied	\N	\N	\N	\N	149328	149328	149329
29739	49213	17	applied	\N	\N	\N	\N	149330	149330	86230
29739	49214	18	applied	\N	\N	\N	\N	149331	149331	86226
29739	49215	19	applied	\N	\N	\N	\N	149332	149332	86247
29739	49216	20	applied	\N	\N	\N	\N	149333	149333	86271
29739	49217	21	applied	\N	\N	\N	\N	149334	149334	149335
29739	49218	22	applied	\N	\N	\N	\N	149336	149336	149337
29739	49219	23	applied	\N	\N	\N	\N	149338	149338	86408
29739	49220	24	applied	\N	\N	\N	\N	149339	149339	86442
29739	49221	25	applied	\N	\N	\N	\N	149340	149340	149341
29739	49222	26	applied	\N	\N	\N	\N	149342	149342	86808
29739	49223	27	applied	\N	\N	\N	\N	149343	149343	149344
29739	49224	28	applied	\N	\N	\N	\N	149345	149345	86484
29739	49225	29	applied	\N	\N	\N	\N	149346	149346	149347
29739	49226	30	applied	\N	\N	\N	\N	149348	149348	149349
29739	49227	31	applied	\N	\N	\N	\N	149350	149350	149351
29739	49228	32	applied	\N	\N	\N	\N	149352	149352	149353
29739	49229	33	applied	\N	\N	\N	\N	149354	149354	149355
29739	49230	34	applied	\N	\N	\N	\N	149356	149356	149357
29739	49231	35	applied	\N	\N	\N	\N	149358	149358	149359
29739	49232	36	applied	\N	\N	\N	\N	149360	149360	86490
29739	49233	37	applied	\N	\N	\N	\N	149361	149361	86810
29745	49259	0	applied	\N	\N	\N	\N	149406	149406	149407
29745	49260	1	applied	\N	\N	\N	\N	149408	149408	149409
29745	49261	2	applied	\N	\N	\N	\N	149410	149410	86634
29745	49262	3	applied	\N	\N	\N	\N	149411	149411	86727
29745	49271	4	applied	\N	\N	\N	\N	149424	149424	86728
29745	49272	5	applied	\N	\N	\N	\N	149425	149425	86650
29745	49273	6	applied	\N	\N	\N	\N	149426	149426	149415
29745	49274	7	applied	\N	\N	\N	\N	149427	149427	86659
29745	49275	8	applied	\N	\N	\N	\N	149428	149428	86729
29745	49263	9	applied	\N	\N	\N	\N	149412	149412	86660
29745	49264	10	applied	\N	\N	\N	\N	149413	149413	149429
29745	49276	11	applied	\N	\N	\N	\N	149430	149430	86731
29745	49265	12	applied	\N	\N	\N	\N	149414	149414	149419
29745	49266	13	applied	\N	\N	\N	\N	149416	149416	86740
29745	49267	14	applied	\N	\N	\N	\N	149417	149417	86744
29745	49268	15	applied	\N	\N	\N	\N	149418	149418	149431
29745	49269	16	applied	\N	\N	\N	\N	149420	149420	86764
29745	49270	17	applied	\N	\N	\N	\N	149421	149421	86774
29752	49301	0	applied	\N	\N	\N	\N	149470	149470	149471
29752	49303	1	applied	\N	\N	\N	\N	149476	149476	86890
29752	49304	2	applied	\N	\N	\N	\N	149477	149477	86896
29752	49302	3	applied	\N	\N	\N	\N	149472	149472	86932
29752	49305	4	applied	\N	\N	\N	\N	149478	149478	86904
29752	49306	5	applied	\N	\N	\N	\N	149479	149479	149480
29752	49307	6	applied	\N	\N	\N	\N	149481	149481	86937
29752	49308	7	applied	\N	\N	\N	\N	149482	149482	149483
29754	49309	0	applied	\N	\N	\N	\N	149485	149485	149486
29754	49312	1	applied	\N	\N	\N	\N	149491	149491	149489
29754	49313	2	applied	\N	\N	\N	\N	149492	149492	87038
29754	49314	3	applied	\N	\N	\N	\N	149493	149493	86951
29754	49310	4	applied	\N	\N	\N	\N	149487	149487	87039
29754	49311	5	applied	\N	\N	\N	\N	149488	149488	86953
29754	49315	6	applied	\N	\N	\N	\N	149494	149494	149495
29754	49316	7	applied	\N	\N	\N	\N	149496	149496	87040
29757	49317	0	applied	\N	\N	\N	\N	149500	149500	149501
29757	49318	1	applied	\N	\N	\N	\N	149502	149502	149503
29757	49319	2	applied	\N	\N	\N	\N	149504	149504	149505
29757	49312	3	applied	\N	\N	\N	\N	149491	149491	149495
29733	49185	2	applied	\N	\N	\N	\N	149273	149273	86029
29733	49186	3	applied	\N	\N	\N	\N	149274	149274	149275
29733	49187	4	applied	\N	\N	\N	\N	149276	149276	149277
29733	49188	5	applied	\N	\N	\N	\N	149278	149278	149279
29733	49189	6	applied	\N	\N	\N	\N	149280	149280	149281
29741	49234	0	applied	\N	\N	\N	\N	149364	149364	149365
29741	49235	1	applied	\N	\N	\N	\N	149366	149366	86492
29741	49236	2	applied	\N	\N	\N	\N	149367	149367	149368
29741	49237	3	applied	\N	\N	\N	\N	149369	149369	86500
29741	49238	4	applied	\N	\N	\N	\N	149370	149370	149371
29741	49239	5	applied	\N	\N	\N	\N	149372	149372	86519
29741	49240	6	applied	\N	\N	\N	\N	149373	149373	86521
29741	49241	7	applied	\N	\N	\N	\N	149374	149374	86528
29741	49242	8	applied	\N	\N	\N	\N	149375	149375	149376
29743	49259	0	applied	\N	\N	\N	\N	149406	149406	149407
29743	49260	1	applied	\N	\N	\N	\N	149408	149408	149409
29743	49261	2	applied	\N	\N	\N	\N	149410	149410	86634
29743	49262	3	applied	\N	\N	\N	\N	149411	149411	86727
29743	49263	4	applied	\N	\N	\N	\N	149412	149412	86642
29743	49264	5	applied	\N	\N	\N	\N	149413	149413	86728
29743	49265	6	applied	\N	\N	\N	\N	149414	149414	149415
29743	49266	7	applied	\N	\N	\N	\N	149416	149416	86729
29743	49267	8	applied	\N	\N	\N	\N	149417	149417	86731
29743	49268	9	applied	\N	\N	\N	\N	149418	149418	149419
29743	49269	10	applied	\N	\N	\N	\N	149420	149420	86740
29743	49270	11	applied	\N	\N	\N	\N	149421	149421	86744
29746	49259	0	applied	\N	\N	\N	\N	149406	149406	149407
29746	49260	1	applied	\N	\N	\N	\N	149408	149408	149409
29746	49261	2	applied	\N	\N	\N	\N	149410	149410	86634
29746	49262	3	applied	\N	\N	\N	\N	149411	149411	86727
29746	49271	4	applied	\N	\N	\N	\N	149424	149424	86728
29746	49272	5	applied	\N	\N	\N	\N	149425	149425	86650
29746	49273	6	applied	\N	\N	\N	\N	149426	149426	149415
29746	49274	7	applied	\N	\N	\N	\N	149427	149427	86659
29746	49275	8	applied	\N	\N	\N	\N	149428	149428	86729
29746	49263	9	applied	\N	\N	\N	\N	149412	149412	86660
29746	49264	10	applied	\N	\N	\N	\N	149413	149413	149429
29746	49276	11	applied	\N	\N	\N	\N	149430	149430	86731
29746	49265	12	applied	\N	\N	\N	\N	149414	149414	149419
29746	49266	13	applied	\N	\N	\N	\N	149416	149416	86740
29746	49267	14	applied	\N	\N	\N	\N	149417	149417	86744
29746	49268	15	applied	\N	\N	\N	\N	149418	149418	149431
29746	49269	16	applied	\N	\N	\N	\N	149420	149420	86764
29746	49270	17	applied	\N	\N	\N	\N	149421	149421	86774
29756	49317	0	applied	\N	\N	\N	\N	149500	149500	149501
29756	49318	1	applied	\N	\N	\N	\N	149502	149502	149503
29756	49319	2	applied	\N	\N	\N	\N	149504	149504	149505
29756	49312	3	applied	\N	\N	\N	\N	149491	149491	149495
29756	49320	5	applied	\N	\N	\N	\N	149507	149507	149508
29756	49321	6	applied	\N	\N	\N	\N	149509	149509	149510
29756	49322	7	applied	\N	\N	\N	\N	149511	149511	149512
29756	49323	8	applied	\N	\N	\N	\N	149513	149513	149514
29756	49324	9	applied	\N	\N	\N	\N	149515	149515	149516
29756	49325	10	applied	\N	\N	\N	\N	149517	149517	149518
29756	49326	11	applied	\N	\N	\N	\N	149519	149519	149520
29756	49327	12	applied	\N	\N	\N	\N	149521	149521	149522
29756	49328	13	applied	\N	\N	\N	\N	149523	149523	149524
29756	49329	14	applied	\N	\N	\N	\N	149525	149525	86961
29756	49330	15	applied	\N	\N	\N	\N	149526	149526	149527
29756	49331	16	applied	\N	\N	\N	\N	149528	149528	86967
29756	49313	17	applied	\N	\N	\N	\N	149492	149492	149529
29756	49314	18	applied	\N	\N	\N	\N	149493	149493	87041
29758	49317	0	applied	\N	\N	\N	\N	149500	149500	149501
29758	49318	2	applied	\N	\N	\N	\N	149502	149502	149503
29758	49319	3	applied	\N	\N	\N	\N	149504	149504	149505
29758	49332	4	applied	\N	\N	\N	\N	149543	149543	86974
29758	49333	5	applied	\N	\N	\N	\N	149544	149544	86982
29758	49334	6	applied	\N	\N	\N	\N	149545	149545	87044
29758	49335	7	applied	\N	\N	\N	\N	149546	149546	149547
29758	49320	8	applied	\N	\N	\N	\N	149507	149507	149508
29758	49321	9	applied	\N	\N	\N	\N	149509	149509	149510
29758	49322	10	applied	\N	\N	\N	\N	149511	149511	149512
29758	49323	11	applied	\N	\N	\N	\N	149513	149513	149514
29758	49324	12	applied	\N	\N	\N	\N	149515	149515	149516
29758	49325	13	applied	\N	\N	\N	\N	149517	149517	149518
29758	49326	14	applied	\N	\N	\N	\N	149519	149519	149520
29758	49327	15	applied	\N	\N	\N	\N	149521	149521	149522
29758	49328	16	applied	\N	\N	\N	\N	149523	149523	149524
29758	49329	17	applied	\N	\N	\N	\N	149525	149525	86991
29758	49330	18	applied	\N	\N	\N	\N	149526	149526	87046
29758	49331	19	applied	\N	\N	\N	\N	149528	149528	86993
29758	49336	20	applied	\N	\N	\N	\N	149548	149548	87047
29758	49337	21	applied	\N	\N	\N	\N	149549	149549	149550
29758	49338	22	applied	\N	\N	\N	\N	149551	149551	149552
29758	49339	23	applied	\N	\N	\N	\N	149553	149553	87048
29758	49340	24	applied	\N	\N	\N	\N	149554	149554	87008
29767	49405	0	applied	\N	\N	\N	\N	149689	149689	149690
29767	49406	1	applied	\N	\N	\N	\N	149691	149691	149692
29767	49407	2	applied	\N	\N	\N	\N	149693	149693	87174
29767	49408	3	applied	\N	\N	\N	\N	149694	149694	149695
29767	49409	4	applied	\N	\N	\N	\N	149696	149696	149697
29767	49410	5	applied	\N	\N	\N	\N	149698	149698	149699
29767	49411	6	applied	\N	\N	\N	\N	149700	149700	87176
29767	49412	7	applied	\N	\N	\N	\N	149701	149701	149702
29767	49413	8	applied	\N	\N	\N	\N	149703	149703	149704
29767	49414	9	applied	\N	\N	\N	\N	149705	149705	149706
29767	49415	10	applied	\N	\N	\N	\N	149707	149707	149708
29767	49416	11	applied	\N	\N	\N	\N	149709	149709	87195
29767	49417	12	applied	\N	\N	\N	\N	149710	149710	149711
29767	49418	13	applied	\N	\N	\N	\N	149712	149712	87213
29767	49419	14	applied	\N	\N	\N	\N	149713	149713	149714
29767	49420	15	applied	\N	\N	\N	\N	149715	149715	87223
29767	49421	16	applied	\N	\N	\N	\N	149716	149716	149717
29767	49422	17	applied	\N	\N	\N	\N	149718	149718	87235
29767	49423	18	applied	\N	\N	\N	\N	149719	149719	87241
29769	49405	0	applied	\N	\N	\N	\N	149689	149689	149690
29769	49406	1	applied	\N	\N	\N	\N	149691	149691	149692
29769	49407	2	applied	\N	\N	\N	\N	149693	149693	87174
29769	49408	3	applied	\N	\N	\N	\N	149694	149694	149695
29769	49411	4	applied	\N	\N	\N	\N	149700	149700	87176
29769	49412	5	applied	\N	\N	\N	\N	149701	149701	149702
29769	49413	6	applied	\N	\N	\N	\N	149703	149703	149704
29769	49414	7	applied	\N	\N	\N	\N	149705	149705	149706
29769	49415	8	applied	\N	\N	\N	\N	149707	149707	149708
29769	49416	9	applied	\N	\N	\N	\N	149709	149709	87195
29769	49417	10	applied	\N	\N	\N	\N	149710	149710	149711
29769	49418	11	applied	\N	\N	\N	\N	149712	149712	87213
29769	49419	12	applied	\N	\N	\N	\N	149713	149713	149714
29769	49420	13	applied	\N	\N	\N	\N	149715	149715	87223
29769	49421	14	applied	\N	\N	\N	\N	149716	149716	149717
29748	49294	7	applied	\N	\N	\N	\N	149459	149459	86922
29748	49295	8	applied	\N	\N	\N	\N	149460	149460	86923
29748	49296	9	applied	\N	\N	\N	\N	149461	149461	86924
29748	49297	10	applied	\N	\N	\N	\N	149462	149462	86788
29748	49298	11	applied	\N	\N	\N	\N	149463	149463	86832
29748	49299	12	applied	\N	\N	\N	\N	149464	149464	87028
29748	49300	13	applied	\N	\N	\N	\N	149465	149465	86927
29748	49283	14	applied	\N	\N	\N	\N	149445	149445	86841
29748	49284	15	applied	\N	\N	\N	\N	149446	149446	87794
29748	49285	16	applied	\N	\N	\N	\N	149447	149447	86856
29748	49286	17	applied	\N	\N	\N	\N	149448	149448	149453
29748	49287	18	applied	\N	\N	\N	\N	149449	149449	86862
29748	49288	19	applied	\N	\N	\N	\N	149450	149450	86876
29748	49289	20	applied	\N	\N	\N	\N	149451	149451	87035
29748	49290	21	applied	\N	\N	\N	\N	149452	149452	87036
29748	49291	22	applied	\N	\N	\N	\N	149454	149454	86884
29748	49292	23	applied	\N	\N	\N	\N	149455	149455	86888
29750	49277	0	applied	\N	\N	\N	\N	149436	149436	149437
29750	49278	1	applied	\N	\N	\N	\N	149438	149438	149439
29750	49279	2	applied	\N	\N	\N	\N	149440	149440	149441
29750	49280	3	applied	\N	\N	\N	\N	149442	149442	86920
29750	49281	4	applied	\N	\N	\N	\N	149443	149443	86776
29765	49380	0	applied	\N	\N	\N	\N	149638	149638	149639
29765	49381	1	applied	\N	\N	\N	\N	149640	149640	149641
29765	49382	2	applied	\N	\N	\N	\N	149642	149642	149643
29765	49383	3	applied	\N	\N	\N	\N	149644	149644	149645
29765	49384	4	applied	\N	\N	\N	\N	149646	149646	149647
29765	49385	5	applied	\N	\N	\N	\N	149648	149648	149649
29765	49386	6	applied	\N	\N	\N	\N	149650	149650	149651
29765	49387	7	applied	\N	\N	\N	\N	149652	149652	149653
29765	49388	8	applied	\N	\N	\N	\N	149654	149654	149655
29765	49389	9	applied	\N	\N	\N	\N	149656	149656	149657
29765	49390	10	applied	\N	\N	\N	\N	149658	149658	149659
29765	49391	11	applied	\N	\N	\N	\N	149660	149660	149661
29768	49405	0	applied	\N	\N	\N	\N	149689	149689	149690
29768	49406	1	applied	\N	\N	\N	\N	149691	149691	149692
29768	49407	2	applied	\N	\N	\N	\N	149693	149693	87174
29768	49408	3	applied	\N	\N	\N	\N	149694	149694	149695
29768	49409	4	applied	\N	\N	\N	\N	149696	149696	149697
29768	49410	5	applied	\N	\N	\N	\N	149698	149698	149699
29768	49411	6	applied	\N	\N	\N	\N	149700	149700	87176
29768	49412	7	applied	\N	\N	\N	\N	149701	149701	149702
29768	49413	8	applied	\N	\N	\N	\N	149703	149703	149704
29768	49414	9	applied	\N	\N	\N	\N	149705	149705	149706
29768	49415	10	applied	\N	\N	\N	\N	149707	149707	149708
29768	49416	11	applied	\N	\N	\N	\N	149709	149709	87195
29768	49417	12	applied	\N	\N	\N	\N	149710	149710	149711
29768	49418	13	applied	\N	\N	\N	\N	149712	149712	87213
29768	49419	14	applied	\N	\N	\N	\N	149713	149713	149714
29768	49420	15	applied	\N	\N	\N	\N	149715	149715	87223
29768	49421	16	applied	\N	\N	\N	\N	149716	149716	149717
29768	49422	17	applied	\N	\N	\N	\N	149718	149718	87235
29768	49423	18	applied	\N	\N	\N	\N	149719	149719	87241
29773	49449	0	applied	\N	\N	\N	\N	149776	149776	149777
29773	49450	1	applied	\N	\N	\N	\N	149778	149778	149779
29773	49451	2	applied	\N	\N	\N	\N	149780	149780	87327
29773	49452	3	applied	\N	\N	\N	\N	149781	149781	149782
29773	49453	4	applied	\N	\N	\N	\N	149783	149783	149784
29773	49454	5	applied	\N	\N	\N	\N	149785	149785	149786
29773	49455	6	applied	\N	\N	\N	\N	149787	149787	87350
29773	49456	7	applied	\N	\N	\N	\N	149788	149788	149789
29773	49457	8	applied	\N	\N	\N	\N	149790	149790	149791
29773	49458	9	applied	\N	\N	\N	\N	149792	149792	149793
29773	49459	10	applied	\N	\N	\N	\N	149794	149794	87381
29773	49460	11	applied	\N	\N	\N	\N	149795	149795	149796
29773	49461	12	applied	\N	\N	\N	\N	149797	149797	149798
29773	49462	13	applied	\N	\N	\N	\N	149799	149799	87400
29773	49463	14	applied	\N	\N	\N	\N	149800	149800	149801
29773	49464	15	applied	\N	\N	\N	\N	149802	149802	149803
29773	49465	16	applied	\N	\N	\N	\N	149804	149804	149805
29773	49466	17	applied	\N	\N	\N	\N	149806	149806	149807
29773	49467	18	applied	\N	\N	\N	\N	149808	149808	149809
29773	49468	19	applied	\N	\N	\N	\N	149810	149810	149811
29773	49469	20	applied	\N	\N	\N	\N	149812	149812	149813
29773	49470	21	applied	\N	\N	\N	\N	149814	149814	149815
29773	49471	22	applied	\N	\N	\N	\N	149816	149816	87412
29773	49472	23	applied	\N	\N	\N	\N	149817	149817	149818
29773	49473	24	applied	\N	\N	\N	\N	149819	149819	149820
29773	49474	25	applied	\N	\N	\N	\N	149821	149821	149822
29773	49475	26	applied	\N	\N	\N	\N	149823	149823	149824
29773	49476	27	applied	\N	\N	\N	\N	149825	149825	87422
29773	49477	28	applied	\N	\N	\N	\N	149826	149826	149827
29773	49478	29	applied	\N	\N	\N	\N	149828	149828	149829
29773	49479	30	applied	\N	\N	\N	\N	149830	149830	149831
29775	49480	0	applied	\N	\N	\N	\N	149837	149837	149838
29775	49481	1	applied	\N	\N	\N	\N	149839	149839	149840
29775	49482	2	applied	\N	\N	\N	\N	149841	149841	149842
29775	49483	3	applied	\N	\N	\N	\N	149843	149843	87429
29775	49484	4	applied	\N	\N	\N	\N	149844	149844	87431
29775	49485	5	applied	\N	\N	\N	\N	149845	149845	149846
29775	49486	6	applied	\N	\N	\N	\N	149847	149847	87441
29775	49487	7	applied	\N	\N	\N	\N	149848	149848	87453
29775	49488	8	applied	\N	\N	\N	\N	149849	149849	87457
29775	49489	9	applied	\N	\N	\N	\N	149850	149850	149851
29775	49490	10	applied	\N	\N	\N	\N	149852	149852	149853
29775	49491	11	applied	\N	\N	\N	\N	149854	149854	149855
29775	49492	12	applied	\N	\N	\N	\N	149856	149856	149857
29775	49493	13	applied	\N	\N	\N	\N	149858	149858	149859
29775	49494	14	applied	\N	\N	\N	\N	149860	149860	87491
29775	49495	15	applied	\N	\N	\N	\N	149861	149861	87497
29775	49496	16	applied	\N	\N	\N	\N	149862	149862	149863
29775	49497	17	applied	\N	\N	\N	\N	149864	149864	149865
29775	49498	18	applied	\N	\N	\N	\N	149866	149866	149867
29775	49499	19	applied	\N	\N	\N	\N	149868	149868	149869
29775	49500	20	applied	\N	\N	\N	\N	149870	149870	149871
29775	49501	21	applied	\N	\N	\N	\N	149872	149872	149873
29775	49502	22	applied	\N	\N	\N	\N	149874	149874	149875
29775	49503	23	applied	\N	\N	\N	\N	149876	149876	149877
29775	49504	24	applied	\N	\N	\N	\N	149878	149878	149879
29775	49505	25	applied	\N	\N	\N	\N	149880	149880	149881
29775	49506	26	applied	\N	\N	\N	\N	149882	149882	149883
29775	49507	27	applied	\N	\N	\N	\N	149884	149884	149885
29778	49508	0	applied	\N	\N	\N	\N	149888	149888	149889
29778	49509	1	applied	\N	\N	\N	\N	149890	149890	87505
29778	49510	2	applied	\N	\N	\N	\N	149891	149891	87507
29778	49511	3	applied	\N	\N	\N	\N	149892	149892	149893
29778	49512	4	applied	\N	\N	\N	\N	149894	149894	149895
29778	49513	5	applied	\N	\N	\N	\N	149896	149896	87523
29778	49514	6	applied	\N	\N	\N	\N	149897	149897	149898
29778	49515	7	applied	\N	\N	\N	\N	149899	149899	87535
29757	49320	5	applied	\N	\N	\N	\N	149507	149507	149508
29757	49321	6	applied	\N	\N	\N	\N	149509	149509	149510
29757	49322	7	applied	\N	\N	\N	\N	149511	149511	149512
29757	49323	8	applied	\N	\N	\N	\N	149513	149513	149514
29757	49324	9	applied	\N	\N	\N	\N	149515	149515	149516
29757	49325	10	applied	\N	\N	\N	\N	149517	149517	149518
29757	49326	11	applied	\N	\N	\N	\N	149519	149519	149520
29757	49327	12	applied	\N	\N	\N	\N	149521	149521	149522
29757	49328	13	applied	\N	\N	\N	\N	149523	149523	149524
29757	49329	14	applied	\N	\N	\N	\N	149525	149525	86961
29757	49330	15	applied	\N	\N	\N	\N	149526	149526	149527
29757	49331	16	applied	\N	\N	\N	\N	149528	149528	86967
29757	49313	17	applied	\N	\N	\N	\N	149492	149492	149529
29757	49314	18	applied	\N	\N	\N	\N	149493	149493	87041
29759	49341	0	applied	\N	\N	\N	\N	149560	149560	149561
29759	49342	1	applied	\N	\N	\N	\N	149562	149562	149563
29759	49343	2	applied	\N	\N	\N	\N	149564	149564	149565
29759	49344	3	applied	\N	\N	\N	\N	149566	149566	149567
29759	49345	4	applied	\N	\N	\N	\N	149568	149568	149569
29759	49346	5	applied	\N	\N	\N	\N	149570	149570	149571
29759	49347	6	applied	\N	\N	\N	\N	149572	149572	149573
29759	49332	7	applied	\N	\N	\N	\N	149543	149543	149574
29759	49333	8	applied	\N	\N	\N	\N	149544	149544	86984
29759	49334	9	applied	\N	\N	\N	\N	149545	149545	87045
29759	49335	10	applied	\N	\N	\N	\N	149546	149546	86993
29759	49348	11	applied	\N	\N	\N	\N	149575	149575	149576
29759	49349	12	applied	\N	\N	\N	\N	149577	149577	86999
29759	49336	13	applied	\N	\N	\N	\N	149548	149548	87004
29759	49337	14	applied	\N	\N	\N	\N	149549	149549	149578
29759	49338	15	applied	\N	\N	\N	\N	149551	149551	87010
29759	49339	16	applied	\N	\N	\N	\N	149553	149553	149579
29759	49340	17	applied	\N	\N	\N	\N	149554	149554	149580
29759	49350	18	applied	\N	\N	\N	\N	149581	149581	149582
29759	49351	19	applied	\N	\N	\N	\N	149583	149583	87064
29759	49352	20	applied	\N	\N	\N	\N	149584	149584	87066
29759	49353	21	applied	\N	\N	\N	\N	149585	149585	149586
29759	49354	22	applied	\N	\N	\N	\N	149587	149587	87076
29761	49356	0	applied	\N	\N	\N	\N	149593	149593	87088
29761	49357	1	applied	\N	\N	\N	\N	149594	149594	149595
29761	49358	2	applied	\N	\N	\N	\N	149596	149596	149597
29761	49359	3	applied	\N	\N	\N	\N	149598	149598	87092
29761	49360	4	applied	\N	\N	\N	\N	149599	149599	87094
29761	49361	5	applied	\N	\N	\N	\N	149600	149600	87096
29761	49362	6	applied	\N	\N	\N	\N	149601	149601	149602
29761	49363	7	applied	\N	\N	\N	\N	149603	149603	149604
29761	49364	8	applied	\N	\N	\N	\N	149605	149605	149606
29761	49365	9	applied	\N	\N	\N	\N	149607	149607	149608
29761	49366	10	applied	\N	\N	\N	\N	149609	149609	149610
29761	49367	11	applied	\N	\N	\N	\N	149611	149611	149612
29763	49355	0	applied	\N	\N	\N	\N	149591	149591	149592
29763	49356	1	applied	\N	\N	\N	\N	149593	149593	87088
29763	49357	2	applied	\N	\N	\N	\N	149594	149594	149595
29763	49358	3	applied	\N	\N	\N	\N	149596	149596	149597
29763	49359	4	applied	\N	\N	\N	\N	149598	149598	87092
29763	49363	5	applied	\N	\N	\N	\N	149603	149603	149604
29763	49364	6	applied	\N	\N	\N	\N	149605	149605	149606
29763	49365	7	applied	\N	\N	\N	\N	149607	149607	149608
29763	49366	8	applied	\N	\N	\N	\N	149609	149609	149610
29763	49367	9	applied	\N	\N	\N	\N	149611	149611	149612
29763	49368	10	applied	\N	\N	\N	\N	149613	149613	149614
29770	49424	0	applied	\N	\N	\N	\N	149723	149723	149724
29770	49425	1	applied	\N	\N	\N	\N	149725	149725	149726
29770	49426	2	applied	\N	\N	\N	\N	149727	149727	149728
29770	49427	3	applied	\N	\N	\N	\N	149729	149729	149730
29770	49428	4	applied	\N	\N	\N	\N	149731	149731	149732
29770	49429	5	applied	\N	\N	\N	\N	149733	149733	87273
29770	49430	7	applied	\N	\N	\N	\N	149735	149735	149736
29770	49431	8	applied	\N	\N	\N	\N	149737	149737	149738
29770	49409	9	applied	\N	\N	\N	\N	149696	149696	149697
29770	49410	10	applied	\N	\N	\N	\N	149698	149698	149699
29770	49432	11	applied	\N	\N	\N	\N	149739	149739	87287
29770	49433	12	applied	\N	\N	\N	\N	149740	149740	149741
29770	49434	13	applied	\N	\N	\N	\N	149742	149742	87303
29770	49435	14	applied	\N	\N	\N	\N	149743	149743	149744
29770	49436	15	applied	\N	\N	\N	\N	149745	149745	149746
29770	49437	16	applied	\N	\N	\N	\N	149747	149747	87309
29770	49438	17	applied	\N	\N	\N	\N	149748	149748	87319
29770	49439	18	applied	\N	\N	\N	\N	149749	149749	149750
29770	49440	19	applied	\N	\N	\N	\N	149751	149751	149752
29770	49441	20	applied	\N	\N	\N	\N	149753	149753	149754
29770	49442	21	applied	\N	\N	\N	\N	149755	149755	149756
29770	49443	22	applied	\N	\N	\N	\N	149757	149757	149758
29770	49444	23	applied	\N	\N	\N	\N	149759	149759	149760
29770	49445	24	applied	\N	\N	\N	\N	149761	149761	149762
29770	49446	25	applied	\N	\N	\N	\N	149763	149763	149764
29770	49447	26	applied	\N	\N	\N	\N	149765	149765	149766
29770	49448	27	applied	\N	\N	\N	\N	149767	149767	149768
29772	49449	0	applied	\N	\N	\N	\N	149776	149776	149777
29772	49450	1	applied	\N	\N	\N	\N	149778	149778	149779
29772	49451	2	applied	\N	\N	\N	\N	149780	149780	87327
29772	49452	3	applied	\N	\N	\N	\N	149781	149781	149782
29772	49453	4	applied	\N	\N	\N	\N	149783	149783	149784
29772	49454	5	applied	\N	\N	\N	\N	149785	149785	149786
29772	49455	6	applied	\N	\N	\N	\N	149787	149787	87350
29772	49456	7	applied	\N	\N	\N	\N	149788	149788	149789
29772	49457	8	applied	\N	\N	\N	\N	149790	149790	149791
29772	49458	9	applied	\N	\N	\N	\N	149792	149792	149793
29772	49459	10	applied	\N	\N	\N	\N	149794	149794	87381
29772	49460	11	applied	\N	\N	\N	\N	149795	149795	149796
29772	49461	12	applied	\N	\N	\N	\N	149797	149797	149798
29772	49462	13	applied	\N	\N	\N	\N	149799	149799	87400
29772	49463	14	applied	\N	\N	\N	\N	149800	149800	149801
29772	49464	15	applied	\N	\N	\N	\N	149802	149802	149803
29772	49465	16	applied	\N	\N	\N	\N	149804	149804	149805
29772	49466	17	applied	\N	\N	\N	\N	149806	149806	149807
29772	49467	18	applied	\N	\N	\N	\N	149808	149808	149809
29772	49468	19	applied	\N	\N	\N	\N	149810	149810	149811
29772	49469	20	applied	\N	\N	\N	\N	149812	149812	149813
29772	49470	21	applied	\N	\N	\N	\N	149814	149814	149815
29772	49471	22	applied	\N	\N	\N	\N	149816	149816	87412
29772	49472	23	applied	\N	\N	\N	\N	149817	149817	149818
29772	49473	24	applied	\N	\N	\N	\N	149819	149819	149820
29772	49474	25	applied	\N	\N	\N	\N	149821	149821	149822
29772	49475	26	applied	\N	\N	\N	\N	149823	149823	149824
29772	49476	27	applied	\N	\N	\N	\N	149825	149825	87422
29772	49477	28	applied	\N	\N	\N	\N	149826	149826	149827
29772	49478	29	applied	\N	\N	\N	\N	149828	149828	149829
29772	49479	30	applied	\N	\N	\N	\N	149830	149830	149831
29780	49508	0	applied	\N	\N	\N	\N	149888	149888	149889
29780	49509	1	applied	\N	\N	\N	\N	149890	149890	87505
29760	49358	3	applied	\N	\N	\N	\N	149596	149596	149597
29760	49359	4	applied	\N	\N	\N	\N	149598	149598	87092
29760	49360	5	applied	\N	\N	\N	\N	149599	149599	87094
29760	49361	6	applied	\N	\N	\N	\N	149600	149600	87096
29760	49362	7	applied	\N	\N	\N	\N	149601	149601	149602
29760	49363	8	applied	\N	\N	\N	\N	149603	149603	149604
29760	49364	9	applied	\N	\N	\N	\N	149605	149605	149606
29760	49365	10	applied	\N	\N	\N	\N	149607	149607	149608
29760	49366	11	applied	\N	\N	\N	\N	149609	149609	149610
29760	49367	12	applied	\N	\N	\N	\N	149611	149611	149612
29760	49368	13	applied	\N	\N	\N	\N	149613	149613	149614
29762	49355	0	applied	\N	\N	\N	\N	149591	149591	149592
29762	49356	1	applied	\N	\N	\N	\N	149593	149593	87088
29762	49357	2	applied	\N	\N	\N	\N	149594	149594	149595
29762	49358	3	applied	\N	\N	\N	\N	149596	149596	149597
29762	49359	4	applied	\N	\N	\N	\N	149598	149598	87092
29762	49360	5	applied	\N	\N	\N	\N	149599	149599	87094
29762	49361	6	applied	\N	\N	\N	\N	149600	149600	87096
29762	49362	7	applied	\N	\N	\N	\N	149601	149601	149602
29762	49363	8	applied	\N	\N	\N	\N	149603	149603	149604
29762	49364	9	applied	\N	\N	\N	\N	149605	149605	149606
29762	49365	10	applied	\N	\N	\N	\N	149607	149607	149608
29762	49366	11	applied	\N	\N	\N	\N	149609	149609	149610
29762	49367	12	applied	\N	\N	\N	\N	149611	149611	149612
29762	49368	13	applied	\N	\N	\N	\N	149613	149613	149614
29764	49369	0	applied	\N	\N	\N	\N	149618	149618	149619
29764	49370	1	applied	\N	\N	\N	\N	149620	149620	87112
29764	49371	2	applied	\N	\N	\N	\N	149621	149621	149622
29764	49372	3	applied	\N	\N	\N	\N	149623	149623	87126
29764	49373	4	applied	\N	\N	\N	\N	149624	149624	149625
29764	49374	5	applied	\N	\N	\N	\N	149626	149626	87128
29764	49375	6	applied	\N	\N	\N	\N	149627	149627	149628
29764	49376	7	applied	\N	\N	\N	\N	149629	149629	149630
29764	49377	8	applied	\N	\N	\N	\N	149631	149631	149632
29764	49378	9	applied	\N	\N	\N	\N	149633	149633	149634
29764	49379	10	applied	\N	\N	\N	\N	149635	149635	149636
29766	49392	0	applied	\N	\N	\N	\N	149663	149663	149664
29766	49393	1	applied	\N	\N	\N	\N	149665	149665	149666
29766	49394	2	applied	\N	\N	\N	\N	149667	149667	149668
29766	49395	3	applied	\N	\N	\N	\N	149669	149669	87160
29766	49396	4	applied	\N	\N	\N	\N	149670	149670	149671
29766	49397	5	applied	\N	\N	\N	\N	149672	149672	87162
29766	49398	6	applied	\N	\N	\N	\N	149673	149673	149674
29766	49399	7	applied	\N	\N	\N	\N	149675	149675	149676
29766	49400	8	applied	\N	\N	\N	\N	149677	149677	149678
29766	49401	9	applied	\N	\N	\N	\N	149679	149679	149680
29766	49402	10	applied	\N	\N	\N	\N	149681	149681	149682
29766	49403	11	applied	\N	\N	\N	\N	149683	149683	149684
29766	49404	12	applied	\N	\N	\N	\N	149685	149685	149686
29774	49449	0	applied	\N	\N	\N	\N	149776	149776	149777
29774	49450	1	applied	\N	\N	\N	\N	149778	149778	149779
29774	49451	2	applied	\N	\N	\N	\N	149780	149780	87327
29774	49452	3	applied	\N	\N	\N	\N	149781	149781	149782
29774	49453	4	applied	\N	\N	\N	\N	149783	149783	149784
29774	49454	5	applied	\N	\N	\N	\N	149785	149785	149786
29774	49455	6	applied	\N	\N	\N	\N	149787	149787	87350
29774	49456	7	applied	\N	\N	\N	\N	149788	149788	149789
29774	49457	8	applied	\N	\N	\N	\N	149790	149790	149791
29774	49458	9	applied	\N	\N	\N	\N	149792	149792	149793
29774	49459	10	applied	\N	\N	\N	\N	149794	149794	87381
29774	49460	11	applied	\N	\N	\N	\N	149795	149795	149796
29774	49461	12	applied	\N	\N	\N	\N	149797	149797	149798
29774	49462	13	applied	\N	\N	\N	\N	149799	149799	87400
29774	49463	14	applied	\N	\N	\N	\N	149800	149800	149801
29774	49464	15	applied	\N	\N	\N	\N	149802	149802	149803
29774	49465	16	applied	\N	\N	\N	\N	149804	149804	149805
29774	49466	17	applied	\N	\N	\N	\N	149806	149806	149807
29774	49467	18	applied	\N	\N	\N	\N	149808	149808	149809
29774	49468	19	applied	\N	\N	\N	\N	149810	149810	149811
29774	49469	20	applied	\N	\N	\N	\N	149812	149812	149813
29774	49470	21	applied	\N	\N	\N	\N	149814	149814	149815
29774	49471	22	applied	\N	\N	\N	\N	149816	149816	87412
29774	49472	23	applied	\N	\N	\N	\N	149817	149817	149818
29774	49473	24	applied	\N	\N	\N	\N	149819	149819	149820
29774	49474	25	applied	\N	\N	\N	\N	149821	149821	149822
29774	49475	26	applied	\N	\N	\N	\N	149823	149823	149824
29774	49476	27	applied	\N	\N	\N	\N	149825	149825	87422
29774	49477	28	applied	\N	\N	\N	\N	149826	149826	149827
29774	49478	29	applied	\N	\N	\N	\N	149828	149828	149829
29774	49479	30	applied	\N	\N	\N	\N	149830	149830	149831
29776	49508	0	applied	\N	\N	\N	\N	149888	149888	149889
29776	49509	1	applied	\N	\N	\N	\N	149890	149890	87505
29776	49510	2	applied	\N	\N	\N	\N	149891	149891	87507
29776	49511	3	applied	\N	\N	\N	\N	149892	149892	149893
29776	49512	4	applied	\N	\N	\N	\N	149894	149894	149895
29776	49513	5	applied	\N	\N	\N	\N	149896	149896	87523
29776	49514	6	applied	\N	\N	\N	\N	149897	149897	149898
29776	49515	7	applied	\N	\N	\N	\N	149899	149899	87535
29776	49516	8	applied	\N	\N	\N	\N	149900	149900	149901
29776	49517	9	applied	\N	\N	\N	\N	149902	149902	149903
29776	49518	10	applied	\N	\N	\N	\N	149904	149904	149905
29776	49519	11	applied	\N	\N	\N	\N	149906	149906	149907
29776	49520	12	applied	\N	\N	\N	\N	149908	149908	149909
29776	49521	13	applied	\N	\N	\N	\N	149910	149910	149911
29782	49541	0	applied	\N	\N	\N	\N	149953	149953	149954
29782	49542	1	applied	\N	\N	\N	\N	149955	149955	87621
29782	49543	3	applied	\N	\N	\N	\N	149957	149957	149958
29782	49544	4	applied	\N	\N	\N	\N	149959	149959	149960
29782	49545	5	applied	\N	\N	\N	\N	149961	149961	149962
29782	49546	6	applied	\N	\N	\N	\N	149963	149963	149964
29782	49547	7	applied	\N	\N	\N	\N	149965	149965	149966
29782	49548	8	applied	\N	\N	\N	\N	149967	149967	149968
29782	49549	9	applied	\N	\N	\N	\N	149969	149969	149970
29782	49550	10	applied	\N	\N	\N	\N	149971	149971	87635
29782	49551	11	applied	\N	\N	\N	\N	149972	149972	149973
29782	49552	12	applied	\N	\N	\N	\N	149974	149974	149975
29784	49541	0	applied	\N	\N	\N	\N	149953	149953	149954
29784	49542	1	applied	\N	\N	\N	\N	149955	149955	87621
29784	49543	3	applied	\N	\N	\N	\N	149957	149957	149958
29784	49544	4	applied	\N	\N	\N	\N	149959	149959	149960
29784	49545	5	applied	\N	\N	\N	\N	149961	149961	149962
29784	49546	6	applied	\N	\N	\N	\N	149963	149963	149964
29784	49547	7	applied	\N	\N	\N	\N	149965	149965	149966
29784	49548	8	applied	\N	\N	\N	\N	149967	149967	149968
29784	49549	9	applied	\N	\N	\N	\N	149969	149969	149970
29784	49550	10	applied	\N	\N	\N	\N	149971	149971	87635
29784	49551	11	applied	\N	\N	\N	\N	149972	149972	149973
29784	49552	12	applied	\N	\N	\N	\N	149974	149974	149975
29793	49595	0	applied	\N	\N	\N	\N	150103	150103	150104
29793	49596	1	applied	\N	\N	\N	\N	150105	150105	150106
29769	49422	15	applied	\N	\N	\N	\N	149718	149718	87235
29769	49423	16	applied	\N	\N	\N	\N	149719	149719	87241
29771	49424	0	applied	\N	\N	\N	\N	149723	149723	149724
29771	49425	1	applied	\N	\N	\N	\N	149725	149725	149726
29771	49409	2	applied	\N	\N	\N	\N	149696	149696	149697
29771	49410	3	applied	\N	\N	\N	\N	149698	149698	149699
29771	49435	4	applied	\N	\N	\N	\N	149743	149743	149773
29771	49439	5	applied	\N	\N	\N	\N	149749	149749	149750
29771	49440	7	applied	\N	\N	\N	\N	149751	149751	149752
29771	49441	8	applied	\N	\N	\N	\N	149753	149753	149754
29771	49442	9	applied	\N	\N	\N	\N	149755	149755	149728
29771	49443	10	applied	\N	\N	\N	\N	149757	149757	87245
29771	49444	11	applied	\N	\N	\N	\N	149759	149759	149760
29771	49445	12	applied	\N	\N	\N	\N	149761	149761	149762
29771	49446	13	applied	\N	\N	\N	\N	149763	149763	149764
29771	49447	14	applied	\N	\N	\N	\N	149765	149765	149766
29771	49448	15	applied	\N	\N	\N	\N	149767	149767	149768
29777	49508	0	applied	\N	\N	\N	\N	149888	149888	149889
29777	49509	1	applied	\N	\N	\N	\N	149890	149890	87505
29777	49510	2	applied	\N	\N	\N	\N	149891	149891	87507
29777	49511	3	applied	\N	\N	\N	\N	149892	149892	149893
29777	49512	4	applied	\N	\N	\N	\N	149894	149894	149895
29777	49513	5	applied	\N	\N	\N	\N	149896	149896	87523
29777	49514	6	applied	\N	\N	\N	\N	149897	149897	149898
29777	49515	7	applied	\N	\N	\N	\N	149899	149899	87535
29777	49516	8	applied	\N	\N	\N	\N	149900	149900	149901
29777	49517	9	applied	\N	\N	\N	\N	149902	149902	149903
29777	49518	10	applied	\N	\N	\N	\N	149904	149904	149905
29777	49519	11	applied	\N	\N	\N	\N	149906	149906	149907
29777	49520	12	applied	\N	\N	\N	\N	149908	149908	149909
29777	49521	13	applied	\N	\N	\N	\N	149910	149910	149911
29777	49522	14	applied	\N	\N	\N	\N	149914	149914	149915
29781	49523	0	applied	\N	\N	\N	\N	149921	149921	149922
29781	49524	1	applied	\N	\N	\N	\N	149923	149923	149924
29781	49525	2	applied	\N	\N	\N	\N	149925	149925	87543
29781	49520	3	applied	\N	\N	\N	\N	149908	149908	149909
29781	49526	4	applied	\N	\N	\N	\N	149926	149926	149927
29781	49527	5	applied	\N	\N	\N	\N	149928	149928	149929
29781	49522	6	applied	\N	\N	\N	\N	149914	149914	149930
29781	49528	7	applied	\N	\N	\N	\N	149931	149931	149932
29781	49529	8	applied	\N	\N	\N	\N	149933	149933	87545
29781	49530	9	applied	\N	\N	\N	\N	149934	149934	149935
29781	49531	10	applied	\N	\N	\N	\N	149936	149936	87551
29781	49532	11	applied	\N	\N	\N	\N	149937	149937	149938
29781	49533	12	applied	\N	\N	\N	\N	149939	149939	87570
29781	49534	13	applied	\N	\N	\N	\N	149940	149940	149941
29781	49535	14	applied	\N	\N	\N	\N	149942	149942	87593
29781	49536	15	applied	\N	\N	\N	\N	149943	149943	87594
29781	49537	16	applied	\N	\N	\N	\N	149944	149944	149945
29781	49538	17	applied	\N	\N	\N	\N	149946	149946	87604
29781	49539	18	applied	\N	\N	\N	\N	149947	149947	149948
29781	49540	19	applied	\N	\N	\N	\N	149949	149949	149950
29783	49317	0	applied	\N	\N	\N	\N	149500	149500	149501
29783	49318	2	applied	\N	\N	\N	\N	149502	149502	149503
29783	49341	3	applied	\N	\N	\N	\N	149560	149560	149561
29783	49355	4	applied	\N	\N	\N	\N	149591	149591	149592
29783	49380	5	applied	\N	\N	\N	\N	149638	149638	149639
29783	49392	6	applied	\N	\N	\N	\N	149663	149663	149664
29783	49405	7	applied	\N	\N	\N	\N	149689	149689	149690
29783	49406	8	applied	\N	\N	\N	\N	149691	149691	149692
29783	49424	9	applied	\N	\N	\N	\N	149723	149723	149724
29783	49425	10	applied	\N	\N	\N	\N	149725	149725	149726
29783	49449	11	applied	\N	\N	\N	\N	149776	149776	149777
29783	49450	12	applied	\N	\N	\N	\N	149778	149778	149779
29783	49480	13	applied	\N	\N	\N	\N	149837	149837	149838
29783	49481	14	applied	\N	\N	\N	\N	149839	149839	149840
29783	49508	15	applied	\N	\N	\N	\N	149888	149888	149889
29783	49523	16	applied	\N	\N	\N	\N	149921	149921	149922
29783	49524	17	applied	\N	\N	\N	\N	149923	149923	149924
29783	49541	18	applied	\N	\N	\N	\N	149953	149953	149954
29783	49319	19	applied	\N	\N	\N	\N	149504	149504	149505
29783	49332	20	applied	\N	\N	\N	\N	149543	149543	86974
29783	49320	21	applied	\N	\N	\N	\N	149507	149507	149508
29783	49321	22	applied	\N	\N	\N	\N	149509	149509	149510
29783	49329	23	applied	\N	\N	\N	\N	149525	149525	149988
29783	49336	24	applied	\N	\N	\N	\N	149548	149548	149574
29783	49337	25	applied	\N	\N	\N	\N	149549	149549	87042
29783	49338	26	applied	\N	\N	\N	\N	149551	149551	86984
29783	49339	27	applied	\N	\N	\N	\N	149553	149553	149989
29783	49340	28	applied	\N	\N	\N	\N	149554	149554	87045
29783	49350	29	applied	\N	\N	\N	\N	149581	149581	86991
29783	49351	30	applied	\N	\N	\N	\N	149583	149583	86993
29783	49352	31	applied	\N	\N	\N	\N	149584	149584	87047
29783	49360	32	applied	\N	\N	\N	\N	149599	149599	149550
29783	49361	33	applied	\N	\N	\N	\N	149600	149600	149552
29783	49362	34	applied	\N	\N	\N	\N	149601	149601	87048
29783	49372	35	applied	\N	\N	\N	\N	149623	149623	87008
29783	49374	36	applied	\N	\N	\N	\N	149626	149626	149990
29783	49390	37	applied	\N	\N	\N	\N	149658	149658	87054
29783	49391	38	applied	\N	\N	\N	\N	149660	149660	87056
29783	49397	39	applied	\N	\N	\N	\N	149672	149672	149991
29783	49398	40	applied	\N	\N	\N	\N	149673	149673	149992
29783	49399	41	applied	\N	\N	\N	\N	149675	149675	149993
29783	49408	42	applied	\N	\N	\N	\N	149694	149694	149994
29783	49414	43	applied	\N	\N	\N	\N	149705	149705	87074
29783	49415	44	applied	\N	\N	\N	\N	149707	149707	149995
29783	49422	45	applied	\N	\N	\N	\N	149718	149718	149996
29783	49423	46	applied	\N	\N	\N	\N	149719	149719	87080
29783	49426	47	applied	\N	\N	\N	\N	149727	149727	149997
29783	49430	48	applied	\N	\N	\N	\N	149735	149735	87090
29783	49431	49	applied	\N	\N	\N	\N	149737	149737	149597
29783	49432	50	applied	\N	\N	\N	\N	149739	149739	149998
29783	49433	51	applied	\N	\N	\N	\N	149740	149740	149999
29783	49434	52	applied	\N	\N	\N	\N	149742	149742	150000
29783	49459	53	applied	\N	\N	\N	\N	149794	149794	87102
29783	49470	54	applied	\N	\N	\N	\N	149814	149814	87104
29783	49471	55	applied	\N	\N	\N	\N	149816	149816	150001
29783	49472	56	applied	\N	\N	\N	\N	149817	149817	150002
29783	49475	57	applied	\N	\N	\N	\N	149823	149823	150003
29783	49476	58	applied	\N	\N	\N	\N	149825	149825	87116
29783	49493	59	applied	\N	\N	\N	\N	149858	149858	87118
29783	49494	60	applied	\N	\N	\N	\N	149860	149860	149625
29783	49495	61	applied	\N	\N	\N	\N	149861	149861	87128
29783	49496	62	applied	\N	\N	\N	\N	149862	149862	149647
29783	49497	63	applied	\N	\N	\N	\N	149864	149864	150004
29783	49509	64	applied	\N	\N	\N	\N	149890	149890	149655
29783	49510	65	applied	\N	\N	\N	\N	149891	149891	150005
29783	49525	66	applied	\N	\N	\N	\N	149925	149925	149657
29783	49535	67	applied	\N	\N	\N	\N	149942	149942	149659
29783	49536	68	applied	\N	\N	\N	\N	149943	149943	149661
29778	49516	8	applied	\N	\N	\N	\N	149900	149900	149901
29778	49517	9	applied	\N	\N	\N	\N	149902	149902	149903
29778	49518	10	applied	\N	\N	\N	\N	149904	149904	149905
29778	49519	11	applied	\N	\N	\N	\N	149906	149906	149907
29778	49520	12	applied	\N	\N	\N	\N	149908	149908	149909
29778	49521	13	applied	\N	\N	\N	\N	149910	149910	149911
29778	49522	14	applied	\N	\N	\N	\N	149914	149914	149915
29779	49508	0	applied	\N	\N	\N	\N	149888	149888	149889
29779	49509	1	applied	\N	\N	\N	\N	149890	149890	87505
29779	49510	2	applied	\N	\N	\N	\N	149891	149891	87507
29779	49511	3	applied	\N	\N	\N	\N	149892	149892	149893
29779	49512	4	applied	\N	\N	\N	\N	149894	149894	149895
29779	49513	5	applied	\N	\N	\N	\N	149896	149896	87523
29779	49514	6	applied	\N	\N	\N	\N	149897	149897	149898
29779	49515	7	applied	\N	\N	\N	\N	149899	149899	87535
29779	49516	8	applied	\N	\N	\N	\N	149900	149900	149901
29779	49517	9	applied	\N	\N	\N	\N	149902	149902	149903
29779	49518	10	applied	\N	\N	\N	\N	149904	149904	149905
29779	49519	11	applied	\N	\N	\N	\N	149906	149906	149907
29779	49521	12	applied	\N	\N	\N	\N	149910	149910	149911
29787	49553	0	applied	\N	\N	\N	\N	150015	150015	150016
29787	49554	1	applied	\N	\N	\N	\N	150017	150017	150018
29787	49555	2	applied	\N	\N	\N	\N	150019	150019	150020
29787	49556	3	applied	\N	\N	\N	\N	150021	150021	150022
29787	49557	4	applied	\N	\N	\N	\N	150023	150023	150024
29787	49558	5	applied	\N	\N	\N	\N	150025	150025	150026
29787	49559	6	applied	\N	\N	\N	\N	150027	150027	87693
29787	49560	7	applied	\N	\N	\N	\N	150028	150028	150029
29787	49561	8	applied	\N	\N	\N	\N	150030	150030	87697
29787	49562	9	applied	\N	\N	\N	\N	150031	150031	150032
29787	49563	10	applied	\N	\N	\N	\N	150033	150033	150034
29787	49564	11	applied	\N	\N	\N	\N	150035	150035	150036
29787	49565	12	applied	\N	\N	\N	\N	150037	150037	150038
29787	49566	13	applied	\N	\N	\N	\N	150039	150039	150040
29787	49567	14	applied	\N	\N	\N	\N	150041	150041	150042
29787	49568	15	applied	\N	\N	\N	\N	150043	150043	150044
29787	49569	16	applied	\N	\N	\N	\N	150045	150045	150046
29787	49570	17	applied	\N	\N	\N	\N	150047	150047	150048
29787	49571	18	applied	\N	\N	\N	\N	150049	150049	87699
29787	49572	19	applied	\N	\N	\N	\N	150050	150050	150051
29787	49573	20	applied	\N	\N	\N	\N	150052	150052	150053
29787	49574	21	applied	\N	\N	\N	\N	150054	150054	150055
29787	49575	22	applied	\N	\N	\N	\N	150056	150056	150057
29787	49576	23	applied	\N	\N	\N	\N	150058	150058	87703
29787	49577	24	applied	\N	\N	\N	\N	150059	150059	87707
29787	49578	25	applied	\N	\N	\N	\N	150060	150060	150061
29787	49579	26	applied	\N	\N	\N	\N	150062	150062	150063
29787	49580	27	applied	\N	\N	\N	\N	150064	150064	87715
29787	49581	28	applied	\N	\N	\N	\N	150065	150065	150066
29791	49582	0	applied	\N	\N	\N	\N	150076	150076	150077
29791	49583	1	applied	\N	\N	\N	\N	150078	150078	150079
29791	49584	2	applied	\N	\N	\N	\N	150080	150080	150081
29791	49585	3	applied	\N	\N	\N	\N	150082	150082	87734
29791	49586	4	applied	\N	\N	\N	\N	150083	150083	150084
29791	49587	5	applied	\N	\N	\N	\N	150085	150085	150086
29791	49588	6	applied	\N	\N	\N	\N	150087	150087	150088
29791	49589	7	applied	\N	\N	\N	\N	150089	150089	150090
29791	49590	8	applied	\N	\N	\N	\N	150091	150091	150092
29791	49591	9	applied	\N	\N	\N	\N	150093	150093	150094
29791	49592	10	applied	\N	\N	\N	\N	150095	150095	150096
29791	49593	11	applied	\N	\N	\N	\N	150097	150097	150098
29791	49594	12	applied	\N	\N	\N	\N	150099	150099	87767
29796	49595	0	applied	\N	\N	\N	\N	150103	150103	150104
29796	49596	1	applied	\N	\N	\N	\N	150105	150105	150106
29796	49597	2	applied	\N	\N	\N	\N	150107	150107	87775
29796	49598	3	applied	\N	\N	\N	\N	150108	150108	150109
29796	49599	4	applied	\N	\N	\N	\N	150110	150110	150111
29796	49602	5	applied	\N	\N	\N	\N	150115	150115	150116
29796	49603	6	applied	\N	\N	\N	\N	150117	150117	150118
29796	49604	7	applied	\N	\N	\N	\N	150119	150119	150120
29796	49605	8	applied	\N	\N	\N	\N	150121	150121	150122
29798	49667	0	applied	\N	\N	\N	\N	150245	150245	150246
29798	49668	1	applied	\N	\N	\N	\N	150247	150247	150248
29798	49669	2	applied	\N	\N	\N	\N	150249	150249	87969
29798	49670	3	applied	\N	\N	\N	\N	150250	150250	150251
29798	49671	4	applied	\N	\N	\N	\N	150252	150252	150253
29798	49672	5	applied	\N	\N	\N	\N	150254	150254	150255
29798	49673	6	applied	\N	\N	\N	\N	150256	150256	150257
29798	49674	7	applied	\N	\N	\N	\N	150258	150258	150259
29798	49675	8	applied	\N	\N	\N	\N	150260	150260	150261
29808	49720	0	applied	\N	\N	\N	\N	150355	150355	150356
29808	49721	1	applied	\N	\N	\N	\N	150357	150357	150358
29808	49722	2	applied	\N	\N	\N	\N	150359	150359	88282
29808	49723	3	applied	\N	\N	\N	\N	150360	150360	150361
29808	49724	4	applied	\N	\N	\N	\N	150362	150362	150363
29814	49725	0	applied	\N	\N	\N	\N	150378	150378	150379
29814	49726	1	applied	\N	\N	\N	\N	150380	150380	150381
29814	49727	2	applied	\N	\N	\N	\N	150382	150382	88286
29814	49728	3	applied	\N	\N	\N	\N	150383	150383	88288
29814	49729	4	applied	\N	\N	\N	\N	150384	150384	150385
29814	49730	5	applied	\N	\N	\N	\N	150386	150386	150387
29814	49731	6	applied	\N	\N	\N	\N	150388	150388	88292
29814	49732	7	applied	\N	\N	\N	\N	150389	150389	150390
29814	49733	8	applied	\N	\N	\N	\N	150391	150391	88324
29814	49734	9	applied	\N	\N	\N	\N	150392	150392	88305
29814	49735	10	applied	\N	\N	\N	\N	150393	150393	88328
29816	49725	0	applied	\N	\N	\N	\N	150378	150378	150379
29816	49726	1	applied	\N	\N	\N	\N	150380	150380	150381
29816	49736	2	applied	\N	\N	\N	\N	150395	150395	150396
29816	49727	3	applied	\N	\N	\N	\N	150382	150382	88286
29816	49737	4	applied	\N	\N	\N	\N	150397	150397	150385
29816	49740	5	applied	\N	\N	\N	\N	150401	150401	88292
29816	49741	6	applied	\N	\N	\N	\N	150403	150403	88324
29816	49728	7	applied	\N	\N	\N	\N	150383	150383	88328
29816	49729	8	applied	\N	\N	\N	\N	150384	150384	88307
29816	49730	9	applied	\N	\N	\N	\N	150386	150386	150398
29816	49731	10	applied	\N	\N	\N	\N	150388	150388	88330
29816	49732	11	applied	\N	\N	\N	\N	150389	150389	88311
29816	49733	12	applied	\N	\N	\N	\N	150391	150391	150402
29816	49742	13	applied	\N	\N	\N	\N	150404	150404	88332
29816	49743	14	applied	\N	\N	\N	\N	150406	150406	150405
29816	49744	15	applied	\N	\N	\N	\N	150407	150407	88629
29816	49745	16	applied	\N	\N	\N	\N	150408	150408	88631
29816	49746	17	applied	\N	\N	\N	\N	150409	150409	88632
29816	49747	18	applied	\N	\N	\N	\N	150410	150410	88369
29816	49748	19	applied	\N	\N	\N	\N	150411	150411	88377
29816	49749	20	applied	\N	\N	\N	\N	150413	150413	150412
29816	49750	21	applied	\N	\N	\N	\N	150414	150414	88389
29816	49751	22	applied	\N	\N	\N	\N	150416	150416	150415
29816	49734	23	applied	\N	\N	\N	\N	150392	150392	88401
29780	49510	2	applied	\N	\N	\N	\N	149891	149891	87507
29780	49511	3	applied	\N	\N	\N	\N	149892	149892	149893
29780	49512	4	applied	\N	\N	\N	\N	149894	149894	149895
29780	49513	5	applied	\N	\N	\N	\N	149896	149896	87523
29780	49514	6	applied	\N	\N	\N	\N	149897	149897	149898
29780	49515	7	applied	\N	\N	\N	\N	149899	149899	87535
29780	49516	8	applied	\N	\N	\N	\N	149900	149900	149901
29780	49517	9	applied	\N	\N	\N	\N	149902	149902	149903
29780	49518	10	applied	\N	\N	\N	\N	149904	149904	149905
29780	49519	11	applied	\N	\N	\N	\N	149906	149906	149907
29780	49520	12	applied	\N	\N	\N	\N	149908	149908	149909
29780	49521	13	applied	\N	\N	\N	\N	149910	149910	149911
29780	49522	14	applied	\N	\N	\N	\N	149914	149914	149915
29786	49553	0	applied	\N	\N	\N	\N	150015	150015	150016
29786	49554	1	applied	\N	\N	\N	\N	150017	150017	150018
29786	49555	2	applied	\N	\N	\N	\N	150019	150019	150020
29786	49556	3	applied	\N	\N	\N	\N	150021	150021	150022
29786	49557	4	applied	\N	\N	\N	\N	150023	150023	150024
29786	49558	5	applied	\N	\N	\N	\N	150025	150025	150026
29786	49559	6	applied	\N	\N	\N	\N	150027	150027	87693
29786	49560	7	applied	\N	\N	\N	\N	150028	150028	150029
29786	49561	8	applied	\N	\N	\N	\N	150030	150030	87697
29786	49562	9	applied	\N	\N	\N	\N	150031	150031	150032
29786	49563	10	applied	\N	\N	\N	\N	150033	150033	150034
29786	49564	11	applied	\N	\N	\N	\N	150035	150035	150036
29786	49565	12	applied	\N	\N	\N	\N	150037	150037	150038
29786	49566	13	applied	\N	\N	\N	\N	150039	150039	150040
29786	49567	14	applied	\N	\N	\N	\N	150041	150041	150042
29786	49568	15	applied	\N	\N	\N	\N	150043	150043	150044
29786	49569	16	applied	\N	\N	\N	\N	150045	150045	150046
29786	49570	17	applied	\N	\N	\N	\N	150047	150047	150048
29786	49571	18	applied	\N	\N	\N	\N	150049	150049	87699
29786	49572	19	applied	\N	\N	\N	\N	150050	150050	150051
29786	49573	20	applied	\N	\N	\N	\N	150052	150052	150053
29786	49574	21	applied	\N	\N	\N	\N	150054	150054	150055
29786	49575	22	applied	\N	\N	\N	\N	150056	150056	150057
29786	49576	23	applied	\N	\N	\N	\N	150058	150058	87703
29786	49577	24	applied	\N	\N	\N	\N	150059	150059	87707
29786	49578	25	applied	\N	\N	\N	\N	150060	150060	150061
29786	49579	26	applied	\N	\N	\N	\N	150062	150062	150063
29786	49580	27	applied	\N	\N	\N	\N	150064	150064	87715
29786	49581	28	applied	\N	\N	\N	\N	150065	150065	150066
29789	49553	0	applied	\N	\N	\N	\N	150015	150015	150016
29789	49554	1	applied	\N	\N	\N	\N	150017	150017	150018
29789	49555	2	applied	\N	\N	\N	\N	150019	150019	150020
29789	49556	3	applied	\N	\N	\N	\N	150021	150021	150022
29789	49557	4	applied	\N	\N	\N	\N	150023	150023	150024
29789	49558	5	applied	\N	\N	\N	\N	150025	150025	150026
29789	49559	6	applied	\N	\N	\N	\N	150027	150027	87693
29789	49560	7	applied	\N	\N	\N	\N	150028	150028	150029
29789	49561	8	applied	\N	\N	\N	\N	150030	150030	87697
29789	49562	9	applied	\N	\N	\N	\N	150031	150031	150032
29789	49563	10	applied	\N	\N	\N	\N	150033	150033	150034
29789	49564	11	applied	\N	\N	\N	\N	150035	150035	150036
29789	49565	12	applied	\N	\N	\N	\N	150037	150037	150038
29789	49566	13	applied	\N	\N	\N	\N	150039	150039	150040
29789	49567	14	applied	\N	\N	\N	\N	150041	150041	150042
29789	49568	15	applied	\N	\N	\N	\N	150043	150043	150044
29789	49569	16	applied	\N	\N	\N	\N	150045	150045	150046
29789	49570	17	applied	\N	\N	\N	\N	150047	150047	150048
29789	49571	18	applied	\N	\N	\N	\N	150049	150049	87699
29789	49572	19	applied	\N	\N	\N	\N	150050	150050	150051
29789	49573	20	applied	\N	\N	\N	\N	150052	150052	150053
29789	49574	21	applied	\N	\N	\N	\N	150054	150054	150055
29789	49575	22	applied	\N	\N	\N	\N	150056	150056	150057
29789	49576	23	applied	\N	\N	\N	\N	150058	150058	87703
29789	49577	24	applied	\N	\N	\N	\N	150059	150059	87707
29789	49578	25	applied	\N	\N	\N	\N	150060	150060	150061
29789	49579	26	applied	\N	\N	\N	\N	150062	150062	150063
29789	49580	27	applied	\N	\N	\N	\N	150064	150064	87715
29789	49581	28	applied	\N	\N	\N	\N	150065	150065	150066
29792	49582	0	applied	\N	\N	\N	\N	150076	150076	150077
29792	49583	1	applied	\N	\N	\N	\N	150078	150078	150079
29792	49584	2	applied	\N	\N	\N	\N	150080	150080	150081
29792	49585	3	applied	\N	\N	\N	\N	150082	150082	87734
29792	49586	4	applied	\N	\N	\N	\N	150083	150083	150084
29792	49587	5	applied	\N	\N	\N	\N	150085	150085	150086
29792	49588	6	applied	\N	\N	\N	\N	150087	150087	150088
29792	49589	7	applied	\N	\N	\N	\N	150089	150089	150090
29792	49590	8	applied	\N	\N	\N	\N	150091	150091	150092
29792	49591	9	applied	\N	\N	\N	\N	150093	150093	150094
29792	49592	10	applied	\N	\N	\N	\N	150095	150095	150096
29792	49593	11	applied	\N	\N	\N	\N	150097	150097	150098
29792	49594	12	applied	\N	\N	\N	\N	150099	150099	87767
29799	49667	0	applied	\N	\N	\N	\N	150245	150245	150246
29799	49668	1	applied	\N	\N	\N	\N	150247	150247	150248
29799	49669	2	applied	\N	\N	\N	\N	150249	150249	87969
29799	49670	3	applied	\N	\N	\N	\N	150250	150250	150251
29799	49671	4	applied	\N	\N	\N	\N	150252	150252	150253
29799	49672	5	applied	\N	\N	\N	\N	150254	150254	150255
29799	49673	6	applied	\N	\N	\N	\N	150256	150256	150257
29799	49674	7	applied	\N	\N	\N	\N	150258	150258	150259
29804	49705	0	applied	\N	\N	\N	\N	150328	150328	150329
29804	49706	1	applied	\N	\N	\N	\N	150330	150330	88216
29804	49707	2	applied	\N	\N	\N	\N	150331	150331	150332
29804	49708	3	applied	\N	\N	\N	\N	150333	150333	88224
29804	49709	4	applied	\N	\N	\N	\N	150334	150334	150335
29804	49710	5	applied	\N	\N	\N	\N	150336	150336	88249
29806	49714	0	applied	\N	\N	\N	\N	150345	150345	150346
29806	49715	1	applied	\N	\N	\N	\N	150347	150347	88257
29806	49716	2	applied	\N	\N	\N	\N	150348	150348	88259
29806	49717	3	applied	\N	\N	\N	\N	150349	150349	150350
29806	49718	4	applied	\N	\N	\N	\N	150351	150351	88261
29806	49719	5	applied	\N	\N	\N	\N	150352	150352	88268
29809	49720	0	applied	\N	\N	\N	\N	150355	150355	150356
29809	49721	1	applied	\N	\N	\N	\N	150357	150357	150358
29809	49722	2	applied	\N	\N	\N	\N	150359	150359	88282
29809	49723	3	applied	\N	\N	\N	\N	150360	150360	150361
29809	49724	4	applied	\N	\N	\N	\N	150362	150362	150363
29813	49607	0	applied	\N	\N	\N	\N	150128	150128	150129
29813	49317	1	applied	\N	\N	\N	\N	149500	149500	149501
29813	49318	2	applied	\N	\N	\N	\N	149502	149502	149503
29813	49341	3	applied	\N	\N	\N	\N	149560	149560	149561
29813	49355	5	applied	\N	\N	\N	\N	149591	149591	149592
29813	49380	6	applied	\N	\N	\N	\N	149638	149638	149639
29813	49392	7	applied	\N	\N	\N	\N	149663	149663	149664
29813	49405	8	applied	\N	\N	\N	\N	149689	149689	149690
29813	49406	9	applied	\N	\N	\N	\N	149691	149691	149692
29813	49424	10	applied	\N	\N	\N	\N	149723	149723	149724
29813	49425	11	applied	\N	\N	\N	\N	149725	149725	149726
29783	49538	69	applied	\N	\N	\N	\N	149946	149946	87151
29783	49539	70	applied	\N	\N	\N	\N	149947	149947	149668
29783	49540	71	applied	\N	\N	\N	\N	149949	149949	87155
29783	49548	72	applied	\N	\N	\N	\N	149967	149967	87160
29783	49549	73	applied	\N	\N	\N	\N	149969	149969	150006
29785	49553	0	applied	\N	\N	\N	\N	150015	150015	150016
29785	49554	1	applied	\N	\N	\N	\N	150017	150017	150018
29785	49555	2	applied	\N	\N	\N	\N	150019	150019	150020
29785	49556	3	applied	\N	\N	\N	\N	150021	150021	150022
29785	49557	4	applied	\N	\N	\N	\N	150023	150023	150024
29785	49558	5	applied	\N	\N	\N	\N	150025	150025	150026
29785	49559	6	applied	\N	\N	\N	\N	150027	150027	87693
29785	49560	7	applied	\N	\N	\N	\N	150028	150028	150029
29785	49561	8	applied	\N	\N	\N	\N	150030	150030	87697
29785	49562	9	applied	\N	\N	\N	\N	150031	150031	150032
29785	49563	10	applied	\N	\N	\N	\N	150033	150033	150034
29785	49564	11	applied	\N	\N	\N	\N	150035	150035	150036
29785	49565	12	applied	\N	\N	\N	\N	150037	150037	150038
29785	49566	13	applied	\N	\N	\N	\N	150039	150039	150040
29785	49567	14	applied	\N	\N	\N	\N	150041	150041	150042
29785	49568	15	applied	\N	\N	\N	\N	150043	150043	150044
29785	49569	16	applied	\N	\N	\N	\N	150045	150045	150046
29785	49570	17	applied	\N	\N	\N	\N	150047	150047	150048
29785	49571	18	applied	\N	\N	\N	\N	150049	150049	87699
29785	49572	19	applied	\N	\N	\N	\N	150050	150050	150051
29785	49573	20	applied	\N	\N	\N	\N	150052	150052	150053
29785	49574	21	applied	\N	\N	\N	\N	150054	150054	150055
29785	49575	22	applied	\N	\N	\N	\N	150056	150056	150057
29785	49576	23	applied	\N	\N	\N	\N	150058	150058	87703
29785	49577	24	applied	\N	\N	\N	\N	150059	150059	87707
29785	49578	25	applied	\N	\N	\N	\N	150060	150060	150061
29785	49579	26	applied	\N	\N	\N	\N	150062	150062	150063
29785	49580	27	applied	\N	\N	\N	\N	150064	150064	87715
29785	49581	28	applied	\N	\N	\N	\N	150065	150065	150066
29788	49553	0	applied	\N	\N	\N	\N	150015	150015	150016
29788	49554	1	applied	\N	\N	\N	\N	150017	150017	150018
29788	49555	2	applied	\N	\N	\N	\N	150019	150019	87170
29788	49556	3	applied	\N	\N	\N	\N	150021	150021	87172
29788	49558	4	applied	\N	\N	\N	\N	150025	150025	87174
29788	49559	5	applied	\N	\N	\N	\N	150027	150027	149695
29788	49560	6	applied	\N	\N	\N	\N	150028	150028	150071
29788	49561	7	applied	\N	\N	\N	\N	150030	150030	87179
29794	49595	0	applied	\N	\N	\N	\N	150103	150103	150104
29794	49596	1	applied	\N	\N	\N	\N	150105	150105	150106
29794	49597	2	applied	\N	\N	\N	\N	150107	150107	87775
29794	49598	3	applied	\N	\N	\N	\N	150108	150108	150109
29794	49599	4	applied	\N	\N	\N	\N	150110	150110	150111
29794	49600	5	applied	\N	\N	\N	\N	150112	150112	87781
29794	49601	6	applied	\N	\N	\N	\N	150113	150113	150114
29794	49602	7	applied	\N	\N	\N	\N	150115	150115	150116
29794	49603	8	applied	\N	\N	\N	\N	150117	150117	150118
29794	49604	9	applied	\N	\N	\N	\N	150119	150119	150120
29794	49605	10	applied	\N	\N	\N	\N	150121	150121	150122
29794	49606	11	applied	\N	\N	\N	\N	150123	150123	150124
29800	49607	0	applied	\N	\N	\N	\N	150128	150128	150129
29800	49341	1	applied	\N	\N	\N	\N	149560	149560	149561
29800	49355	2	applied	\N	\N	\N	\N	149591	149591	149592
29800	49380	3	applied	\N	\N	\N	\N	149638	149638	149639
29800	49392	4	applied	\N	\N	\N	\N	149663	149663	149664
29800	49405	5	applied	\N	\N	\N	\N	149689	149689	149690
29800	49406	6	applied	\N	\N	\N	\N	149691	149691	149692
29800	49424	7	applied	\N	\N	\N	\N	149723	149723	149724
29800	49425	8	applied	\N	\N	\N	\N	149725	149725	149726
29800	49449	9	applied	\N	\N	\N	\N	149776	149776	149777
29800	49450	10	applied	\N	\N	\N	\N	149778	149778	149779
29800	49480	11	applied	\N	\N	\N	\N	149837	149837	149838
29800	49481	12	applied	\N	\N	\N	\N	149839	149839	149840
29800	49508	13	applied	\N	\N	\N	\N	149888	149888	149889
29800	49523	14	applied	\N	\N	\N	\N	149921	149921	149922
29800	49524	15	applied	\N	\N	\N	\N	149923	149923	149924
29800	49541	16	applied	\N	\N	\N	\N	149953	149953	149954
29800	49553	17	applied	\N	\N	\N	\N	150015	150015	150016
29800	49554	18	applied	\N	\N	\N	\N	150017	150017	150018
29800	49582	19	applied	\N	\N	\N	\N	150076	150076	150077
29800	49595	20	applied	\N	\N	\N	\N	150103	150103	150104
29800	49608	21	applied	\N	\N	\N	\N	150130	150130	150131
29800	49609	22	applied	\N	\N	\N	\N	150132	150132	150133
29800	49610	23	applied	\N	\N	\N	\N	150134	150134	150135
29800	49611	24	applied	\N	\N	\N	\N	150136	150136	150137
29800	49667	25	applied	\N	\N	\N	\N	150245	150245	150246
29800	49342	26	applied	\N	\N	\N	\N	149562	149562	149563
29800	49343	27	applied	\N	\N	\N	\N	149564	149564	149565
29800	49344	28	applied	\N	\N	\N	\N	149566	149566	149567
29800	49345	29	applied	\N	\N	\N	\N	149568	149568	149569
29800	49346	30	applied	\N	\N	\N	\N	149570	149570	149571
29800	49347	31	applied	\N	\N	\N	\N	149572	149572	149573
29800	49348	32	applied	\N	\N	\N	\N	149575	149575	86974
29800	49336	33	applied	\N	\N	\N	\N	149548	149548	86980
29800	49337	34	applied	\N	\N	\N	\N	149549	149549	86982
29800	49338	35	applied	\N	\N	\N	\N	149551	149551	150274
29800	49339	36	applied	\N	\N	\N	\N	149553	149553	87044
29800	49358	37	applied	\N	\N	\N	\N	149596	149596	149989
29800	49359	38	applied	\N	\N	\N	\N	149598	149598	86986
29800	49373	39	applied	\N	\N	\N	\N	149624	149624	87045
29800	49381	40	applied	\N	\N	\N	\N	149640	149640	149547
29800	49384	41	applied	\N	\N	\N	\N	149646	149646	86991
29800	49340	42	applied	\N	\N	\N	\N	149554	149554	86993
29800	49350	43	applied	\N	\N	\N	\N	149581	149581	87047
29800	49351	44	applied	\N	\N	\N	\N	149583	149583	149550
29800	49352	45	applied	\N	\N	\N	\N	149584	149584	149552
29800	49396	46	applied	\N	\N	\N	\N	149670	149670	87004
29800	49407	47	applied	\N	\N	\N	\N	149693	149693	87048
29800	49411	48	applied	\N	\N	\N	\N	149700	149700	149578
29800	49416	49	applied	\N	\N	\N	\N	149709	149709	87008
29800	49435	50	applied	\N	\N	\N	\N	149743	149743	87010
29800	49442	51	applied	\N	\N	\N	\N	149755	149755	149990
29800	49443	52	applied	\N	\N	\N	\N	149757	149757	149579
29800	49451	53	applied	\N	\N	\N	\N	149780	149780	87054
29800	49452	54	applied	\N	\N	\N	\N	149781	149781	149580
29800	49454	55	applied	\N	\N	\N	\N	149785	149785	87056
29800	49482	56	applied	\N	\N	\N	\N	149841	149841	149582
29800	49483	57	applied	\N	\N	\N	\N	149843	149843	149991
29800	49484	58	applied	\N	\N	\N	\N	149844	149844	87064
29800	49521	59	applied	\N	\N	\N	\N	149910	149910	149992
29800	49522	60	applied	\N	\N	\N	\N	149914	149914	87066
29800	49528	61	applied	\N	\N	\N	\N	149931	149931	149993
29800	49529	62	applied	\N	\N	\N	\N	149933	149933	87072
29800	49530	63	applied	\N	\N	\N	\N	149934	149934	149994
29800	49542	64	applied	\N	\N	\N	\N	149955	149955	149586
29800	49557	65	applied	\N	\N	\N	\N	150023	150023	87074
29793	49597	2	applied	\N	\N	\N	\N	150107	150107	87775
29793	49598	3	applied	\N	\N	\N	\N	150108	150108	150109
29793	49599	4	applied	\N	\N	\N	\N	150110	150110	150111
29793	49600	5	applied	\N	\N	\N	\N	150112	150112	87781
29793	49601	6	applied	\N	\N	\N	\N	150113	150113	150114
29793	49602	7	applied	\N	\N	\N	\N	150115	150115	150116
29793	49603	8	applied	\N	\N	\N	\N	150117	150117	150118
29793	49604	9	applied	\N	\N	\N	\N	150119	150119	150120
29793	49605	10	applied	\N	\N	\N	\N	150121	150121	150122
29793	49606	11	applied	\N	\N	\N	\N	150123	150123	150124
29795	49595	0	applied	\N	\N	\N	\N	150103	150103	150104
29795	49596	1	applied	\N	\N	\N	\N	150105	150105	150106
29795	49597	2	applied	\N	\N	\N	\N	150107	150107	87775
29795	49598	3	applied	\N	\N	\N	\N	150108	150108	150109
29795	49599	4	applied	\N	\N	\N	\N	150110	150110	150111
29795	49600	5	applied	\N	\N	\N	\N	150112	150112	87781
29795	49601	6	applied	\N	\N	\N	\N	150113	150113	150114
29795	49602	7	applied	\N	\N	\N	\N	150115	150115	150116
29795	49603	8	applied	\N	\N	\N	\N	150117	150117	150118
29795	49604	9	applied	\N	\N	\N	\N	150119	150119	150120
29795	49605	10	applied	\N	\N	\N	\N	150121	150121	150122
29795	49606	11	applied	\N	\N	\N	\N	150123	150123	150124
29797	49607	0	applied	\N	\N	\N	\N	150128	150128	150129
29797	49608	1	applied	\N	\N	\N	\N	150130	150130	150131
29797	49609	2	applied	\N	\N	\N	\N	150132	150132	150133
29797	49610	3	applied	\N	\N	\N	\N	150134	150134	150135
29797	49611	4	applied	\N	\N	\N	\N	150136	150136	150137
29797	49612	5	applied	\N	\N	\N	\N	150138	150138	150139
29797	49613	6	applied	\N	\N	\N	\N	150140	150140	150141
29797	49614	7	applied	\N	\N	\N	\N	150142	150142	150143
29797	49615	8	applied	\N	\N	\N	\N	150144	150144	87800
29797	49616	9	applied	\N	\N	\N	\N	150145	150145	150146
29797	49617	10	applied	\N	\N	\N	\N	150147	150147	150148
29797	49618	11	applied	\N	\N	\N	\N	150149	150149	87819
29797	49619	12	applied	\N	\N	\N	\N	150150	150150	87827
29797	49620	13	applied	\N	\N	\N	\N	150151	150151	87831
29797	49621	14	applied	\N	\N	\N	\N	150152	150152	150153
29797	49622	15	applied	\N	\N	\N	\N	150154	150154	87832
29797	49623	16	applied	\N	\N	\N	\N	150155	150155	150156
29797	49624	17	applied	\N	\N	\N	\N	150157	150157	150158
29797	49625	18	applied	\N	\N	\N	\N	150159	150159	87846
29797	49626	19	applied	\N	\N	\N	\N	150160	150160	87850
29797	49627	20	applied	\N	\N	\N	\N	150161	150161	150162
29797	49628	21	applied	\N	\N	\N	\N	150163	150163	87870
29797	49629	22	applied	\N	\N	\N	\N	150164	150164	150165
29797	49630	23	applied	\N	\N	\N	\N	150166	150166	87876
29797	49631	24	applied	\N	\N	\N	\N	150167	150167	150168
29797	49632	25	applied	\N	\N	\N	\N	150169	150169	87904
29797	49633	26	applied	\N	\N	\N	\N	150170	150170	150171
29797	49634	27	applied	\N	\N	\N	\N	150172	150172	150173
29797	49635	28	applied	\N	\N	\N	\N	150174	150174	150175
29797	49636	29	applied	\N	\N	\N	\N	150176	150176	150177
29797	49637	30	applied	\N	\N	\N	\N	150178	150178	150179
29797	49638	31	applied	\N	\N	\N	\N	150180	150180	150181
29797	49639	32	applied	\N	\N	\N	\N	150182	150182	150183
29797	49640	33	applied	\N	\N	\N	\N	150184	150184	150185
29797	49641	34	applied	\N	\N	\N	\N	150186	150186	150187
29797	49642	35	applied	\N	\N	\N	\N	150188	150188	150189
29797	49643	36	applied	\N	\N	\N	\N	150190	150190	150191
29797	49644	37	applied	\N	\N	\N	\N	150192	150192	150193
29797	49645	38	applied	\N	\N	\N	\N	150194	150194	150195
29797	49646	39	applied	\N	\N	\N	\N	150196	150196	150197
29797	49647	40	applied	\N	\N	\N	\N	150198	150198	150199
29797	49648	41	applied	\N	\N	\N	\N	150200	150200	150201
29797	49649	42	applied	\N	\N	\N	\N	150202	150202	150203
29797	49650	43	applied	\N	\N	\N	\N	150204	150204	150205
29797	49651	44	applied	\N	\N	\N	\N	150206	150206	150207
29797	49652	45	applied	\N	\N	\N	\N	150208	150208	150209
29797	49653	46	applied	\N	\N	\N	\N	150210	150210	150211
29797	49654	47	applied	\N	\N	\N	\N	150212	150212	150213
29797	49655	48	applied	\N	\N	\N	\N	150214	150214	150215
29797	49656	49	applied	\N	\N	\N	\N	150216	150216	87928
29797	49657	51	applied	\N	\N	\N	\N	150218	150218	87934
29797	49658	52	applied	\N	\N	\N	\N	150219	150219	150220
29797	49659	53	applied	\N	\N	\N	\N	150221	150221	87948
29797	49660	54	applied	\N	\N	\N	\N	150222	150222	150223
29797	49661	55	applied	\N	\N	\N	\N	150224	150224	150225
29797	49662	56	applied	\N	\N	\N	\N	150226	150226	87952
29797	49663	57	applied	\N	\N	\N	\N	150227	150227	150228
29797	49664	58	applied	\N	\N	\N	\N	150229	150229	150230
29797	49665	59	applied	\N	\N	\N	\N	150231	150231	150232
29797	49666	60	applied	\N	\N	\N	\N	150233	150233	150234
29801	49676	0	applied	\N	\N	\N	\N	150278	150278	150279
29801	49675	1	applied	\N	\N	\N	\N	150260	150260	150261
29801	49677	2	applied	\N	\N	\N	\N	150280	150280	88014
29801	49678	3	applied	\N	\N	\N	\N	150281	150281	150282
29801	49679	4	applied	\N	\N	\N	\N	150283	150283	88016
29801	49680	5	applied	\N	\N	\N	\N	150284	150284	150285
29801	49681	6	applied	\N	\N	\N	\N	150286	150286	88030
29801	49682	7	applied	\N	\N	\N	\N	150287	150287	150288
29801	49683	8	applied	\N	\N	\N	\N	150289	150289	88043
29801	49684	9	applied	\N	\N	\N	\N	150290	150290	88051
29801	49685	10	applied	\N	\N	\N	\N	150291	150291	88055
29803	49686	0	applied	\N	\N	\N	\N	150296	150296	150297
29803	49687	1	applied	\N	\N	\N	\N	150298	150298	150299
29803	49688	2	applied	\N	\N	\N	\N	150300	150300	150301
29803	49689	3	applied	\N	\N	\N	\N	150302	150302	150303
29803	49690	4	applied	\N	\N	\N	\N	150304	150304	150305
29803	49691	5	applied	\N	\N	\N	\N	150306	150306	88080
29803	49692	6	applied	\N	\N	\N	\N	150307	150307	88082
29803	49693	7	applied	\N	\N	\N	\N	150308	150308	88093
29803	49694	8	applied	\N	\N	\N	\N	150309	150309	150310
29803	49695	9	applied	\N	\N	\N	\N	150311	150311	88101
29803	49696	10	applied	\N	\N	\N	\N	150312	150312	150313
29803	49697	11	applied	\N	\N	\N	\N	150314	150314	88111
29803	49698	12	applied	\N	\N	\N	\N	150315	150315	88113
29803	49699	13	applied	\N	\N	\N	\N	150316	150316	150317
29803	49700	14	applied	\N	\N	\N	\N	150318	150318	150319
29803	49701	15	applied	\N	\N	\N	\N	150320	150320	88133
29803	49702	16	applied	\N	\N	\N	\N	150321	150321	88202
29803	49703	17	applied	\N	\N	\N	\N	150322	150322	150323
29803	49704	18	applied	\N	\N	\N	\N	150324	150324	150325
29805	49705	0	applied	\N	\N	\N	\N	150328	150328	150329
29805	49706	1	applied	\N	\N	\N	\N	150330	150330	88216
29805	49707	2	applied	\N	\N	\N	\N	150331	150331	150332
29805	49708	3	applied	\N	\N	\N	\N	150333	150333	88224
29805	49709	4	applied	\N	\N	\N	\N	150334	150334	150335
29805	49710	5	applied	\N	\N	\N	\N	150336	150336	88249
29805	49711	6	applied	\N	\N	\N	\N	150339	150339	150340
29805	49712	7	applied	\N	\N	\N	\N	150341	150341	150342
29800	49570	66	applied	\N	\N	\N	\N	150047	150047	150275
29800	49571	67	applied	\N	\N	\N	\N	150049	150049	149995
29800	49585	68	applied	\N	\N	\N	\N	150082	150082	87076
29800	49597	69	applied	\N	\N	\N	\N	150107	150107	149996
29800	49598	70	applied	\N	\N	\N	\N	150108	150108	87078
29800	49615	71	applied	\N	\N	\N	\N	150144	150144	87080
29800	49620	72	applied	\N	\N	\N	\N	150151	150151	87088
29800	49621	73	applied	\N	\N	\N	\N	150152	150152	149997
29800	49622	74	applied	\N	\N	\N	\N	150154	150154	150276
29800	49623	75	applied	\N	\N	\N	\N	150155	150155	87090
29800	49624	76	applied	\N	\N	\N	\N	150157	150157	149595
29800	49669	77	applied	\N	\N	\N	\N	150249	150249	149597
29800	49360	78	applied	\N	\N	\N	\N	149599	149599	149998
29800	49361	79	applied	\N	\N	\N	\N	149600	149600	149999
29800	49362	80	applied	\N	\N	\N	\N	149601	149601	150000
29800	49363	81	applied	\N	\N	\N	\N	149603	149603	149604
29800	49364	82	applied	\N	\N	\N	\N	149605	149605	149606
29800	49365	83	applied	\N	\N	\N	\N	149607	149607	149608
29800	49366	84	applied	\N	\N	\N	\N	149609	149609	149610
29800	49367	85	applied	\N	\N	\N	\N	149611	149611	149612
29800	49368	86	applied	\N	\N	\N	\N	149613	149613	149614
29800	49375	87	applied	\N	\N	\N	\N	149627	149627	149628
29800	49376	88	applied	\N	\N	\N	\N	149629	149629	149630
29800	49377	89	applied	\N	\N	\N	\N	149631	149631	149632
29800	49378	90	applied	\N	\N	\N	\N	149633	149633	149634
29800	49379	91	applied	\N	\N	\N	\N	149635	149635	149636
29800	49382	92	applied	\N	\N	\N	\N	149642	149642	149643
29800	49383	93	applied	\N	\N	\N	\N	149644	149644	149645
29800	49385	94	applied	\N	\N	\N	\N	149648	149648	149649
29800	49386	95	applied	\N	\N	\N	\N	149650	149650	149651
29800	49387	96	applied	\N	\N	\N	\N	149652	149652	149653
29800	49393	97	applied	\N	\N	\N	\N	149665	149665	149666
29800	49400	98	applied	\N	\N	\N	\N	149677	149677	149678
29800	49401	99	applied	\N	\N	\N	\N	149679	149679	149680
29800	49402	100	applied	\N	\N	\N	\N	149681	149681	149682
29800	49403	101	applied	\N	\N	\N	\N	149683	149683	149684
29802	49676	0	applied	\N	\N	\N	\N	150278	150278	150279
29802	49675	1	applied	\N	\N	\N	\N	150260	150260	150261
29802	49677	2	applied	\N	\N	\N	\N	150280	150280	88014
29802	49678	3	applied	\N	\N	\N	\N	150281	150281	150282
29802	49679	4	applied	\N	\N	\N	\N	150283	150283	88016
29802	49680	5	applied	\N	\N	\N	\N	150284	150284	150285
29802	49681	6	applied	\N	\N	\N	\N	150286	150286	88030
29802	49682	7	applied	\N	\N	\N	\N	150287	150287	150288
29802	49683	8	applied	\N	\N	\N	\N	150289	150289	88043
29802	49684	9	applied	\N	\N	\N	\N	150290	150290	88051
29802	49685	10	applied	\N	\N	\N	\N	150291	150291	88055
29811	49720	0	applied	\N	\N	\N	\N	150355	150355	150356
29811	49721	1	applied	\N	\N	\N	\N	150357	150357	150358
29811	49722	2	applied	\N	\N	\N	\N	150359	150359	88282
29811	49723	3	applied	\N	\N	\N	\N	150360	150360	150361
29811	49724	4	applied	\N	\N	\N	\N	150362	150362	150363
29817	49754	0	applied	\N	\N	\N	\N	150422	150422	150423
29817	49755	1	applied	\N	\N	\N	\N	150424	150424	88416
29817	49756	2	applied	\N	\N	\N	\N	150425	150425	88644
29817	49757	3	applied	\N	\N	\N	\N	150426	150426	88426
29819	49768	0	applied	\N	\N	\N	\N	150456	150456	150457
29819	49769	1	applied	\N	\N	\N	\N	150458	150458	88655
29819	49770	2	applied	\N	\N	\N	\N	150459	150459	150460
29819	49771	3	applied	\N	\N	\N	\N	150461	150461	88479
29819	49772	4	applied	\N	\N	\N	\N	150462	150462	150463
29819	49773	5	applied	\N	\N	\N	\N	150464	150464	88658
29819	49774	6	applied	\N	\N	\N	\N	150465	150465	150466
29819	49775	7	applied	\N	\N	\N	\N	150467	150467	150468
29819	49776	8	applied	\N	\N	\N	\N	150469	150469	88659
29819	49777	9	applied	\N	\N	\N	\N	150470	150470	150471
29819	49778	10	applied	\N	\N	\N	\N	150472	150472	88519
29819	49779	11	applied	\N	\N	\N	\N	150473	150473	88529
29819	49780	12	applied	\N	\N	\N	\N	150474	150474	150475
29819	49781	13	applied	\N	\N	\N	\N	150476	150476	88662
29819	49782	14	applied	\N	\N	\N	\N	150477	150477	88544
29819	49783	15	applied	\N	\N	\N	\N	150478	150478	150479
29819	49784	16	applied	\N	\N	\N	\N	150480	150480	88663
29819	49785	17	applied	\N	\N	\N	\N	150481	150481	88557
29819	49786	18	applied	\N	\N	\N	\N	150482	150482	150483
29824	49806	0	applied	\N	\N	\N	\N	150523	150523	150524
29824	49807	1	applied	\N	\N	\N	\N	150525	150525	150526
29824	49808	2	applied	\N	\N	\N	\N	150527	150527	150528
29824	49809	3	applied	\N	\N	\N	\N	150529	150529	150530
29824	49810	4	applied	\N	\N	\N	\N	150531	150531	88739
29824	49811	5	applied	\N	\N	\N	\N	150532	150532	88753
29824	49812	6	applied	\N	\N	\N	\N	150533	150533	88763
29824	49813	7	applied	\N	\N	\N	\N	150534	150534	150535
29824	49814	8	applied	\N	\N	\N	\N	150536	150536	150537
29824	49815	9	applied	\N	\N	\N	\N	150538	150538	88774
29824	49816	10	applied	\N	\N	\N	\N	150539	150539	150540
29826	49806	0	applied	\N	\N	\N	\N	150523	150523	150524
29826	49807	1	applied	\N	\N	\N	\N	150525	150525	150526
29826	49808	2	applied	\N	\N	\N	\N	150527	150527	150528
29826	49813	3	applied	\N	\N	\N	\N	150534	150534	150543
29826	49814	4	applied	\N	\N	\N	\N	150536	150536	150530
29826	49815	5	applied	\N	\N	\N	\N	150538	150538	150544
29828	49817	0	applied	\N	\N	\N	\N	150546	150546	150547
29828	49818	1	applied	\N	\N	\N	\N	150548	150548	150549
29828	49819	2	applied	\N	\N	\N	\N	150550	150550	150551
29828	49820	3	applied	\N	\N	\N	\N	150552	150552	88790
29828	49821	4	applied	\N	\N	\N	\N	150553	150553	150554
29828	49822	5	applied	\N	\N	\N	\N	150555	150555	150556
29828	49823	6	applied	\N	\N	\N	\N	150557	150557	88818
29828	49824	7	applied	\N	\N	\N	\N	150558	150558	88825
29828	49825	8	applied	\N	\N	\N	\N	150559	150559	88833
29835	49849	0	applied	\N	\N	\N	\N	150603	150603	150604
29835	49850	1	applied	\N	\N	\N	\N	150605	150605	88927
29835	49851	2	applied	\N	\N	\N	\N	150606	150606	150607
29835	49852	3	applied	\N	\N	\N	\N	150608	150608	88929
29835	49853	4	applied	\N	\N	\N	\N	150609	150609	150610
29843	49947	0	applied	\N	\N	\N	\N	150769	150769	150770
29843	49948	1	applied	\N	\N	\N	\N	150771	150771	89877
29843	49949	2	applied	\N	\N	\N	\N	150772	150772	89653
29843	49950	3	applied	\N	\N	\N	\N	150773	150773	89878
29843	49951	4	applied	\N	\N	\N	\N	150774	150774	89879
29843	49952	5	applied	\N	\N	\N	\N	150775	150775	89880
29854	50042	0	applied	\N	\N	\N	\N	150959	150959	150960
29854	50043	1	applied	\N	\N	\N	\N	150961	150961	150962
29854	50044	2	applied	\N	\N	\N	\N	150963	150963	90243
29854	50045	3	applied	\N	\N	\N	\N	150964	150964	150965
29854	50046	4	applied	\N	\N	\N	\N	150966	150966	90253
29854	50047	5	applied	\N	\N	\N	\N	150967	150967	150968
29854	50048	6	applied	\N	\N	\N	\N	150969	150969	90265
29854	50049	7	applied	\N	\N	\N	\N	150970	150970	90337
29805	49713	8	applied	\N	\N	\N	\N	150343	150343	88253
29807	49714	0	applied	\N	\N	\N	\N	150345	150345	150346
29810	49720	0	applied	\N	\N	\N	\N	150355	150355	150356
29810	49721	1	applied	\N	\N	\N	\N	150357	150357	150358
29810	49722	2	applied	\N	\N	\N	\N	150359	150359	88282
29810	49723	3	applied	\N	\N	\N	\N	150360	150360	150361
29810	49724	4	applied	\N	\N	\N	\N	150362	150362	150363
29820	49768	0	applied	\N	\N	\N	\N	150456	150456	150457
29820	49769	1	applied	\N	\N	\N	\N	150458	150458	88655
29820	49770	2	applied	\N	\N	\N	\N	150459	150459	150460
29820	49771	3	applied	\N	\N	\N	\N	150461	150461	88479
29820	49772	4	applied	\N	\N	\N	\N	150462	150462	150463
29820	49773	5	applied	\N	\N	\N	\N	150464	150464	88658
29820	49774	6	applied	\N	\N	\N	\N	150465	150465	150466
29820	49775	7	applied	\N	\N	\N	\N	150467	150467	150468
29820	49776	8	applied	\N	\N	\N	\N	150469	150469	88659
29820	49777	9	applied	\N	\N	\N	\N	150470	150470	150471
29820	49778	10	applied	\N	\N	\N	\N	150472	150472	88519
29820	49779	11	applied	\N	\N	\N	\N	150473	150473	88529
29820	49780	12	applied	\N	\N	\N	\N	150474	150474	150475
29820	49781	13	applied	\N	\N	\N	\N	150476	150476	88662
29820	49782	14	applied	\N	\N	\N	\N	150477	150477	88544
29820	49783	15	applied	\N	\N	\N	\N	150478	150478	150479
29820	49784	16	applied	\N	\N	\N	\N	150480	150480	88663
29820	49785	17	applied	\N	\N	\N	\N	150481	150481	88557
29820	49786	18	applied	\N	\N	\N	\N	150482	150482	150483
29837	49859	0	applied	\N	\N	\N	\N	150624	150624	150625
29837	49860	1	applied	\N	\N	\N	\N	150626	150626	150627
29837	49861	2	applied	\N	\N	\N	\N	150628	150628	88952
29837	49862	3	applied	\N	\N	\N	\N	150629	150629	88954
29837	49863	4	applied	\N	\N	\N	\N	150630	150630	89137
29837	49864	5	applied	\N	\N	\N	\N	150631	150631	89138
29837	49865	6	applied	\N	\N	\N	\N	150632	150632	89023
29837	49866	7	applied	\N	\N	\N	\N	150633	150633	89140
29840	49890	0	applied	\N	\N	\N	\N	150677	150677	150678
29840	49891	1	applied	\N	\N	\N	\N	150679	150679	89189
29840	49892	2	applied	\N	\N	\N	\N	150680	150680	150681
29840	49893	3	applied	\N	\N	\N	\N	150682	150682	89194
29840	49894	4	applied	\N	\N	\N	\N	150683	150683	150684
29840	49895	5	applied	\N	\N	\N	\N	150685	150685	150686
29840	49896	6	applied	\N	\N	\N	\N	150687	150687	89196
29840	49897	7	applied	\N	\N	\N	\N	150688	150688	150689
29840	49898	8	applied	\N	\N	\N	\N	150690	150690	150691
29840	49899	9	applied	\N	\N	\N	\N	150692	150692	89234
29840	49900	10	applied	\N	\N	\N	\N	150693	150693	150694
29840	49901	11	applied	\N	\N	\N	\N	150695	150695	150696
29840	49902	12	applied	\N	\N	\N	\N	150697	150697	150698
29840	49903	13	applied	\N	\N	\N	\N	150699	150699	89301
29840	49904	14	applied	\N	\N	\N	\N	150700	150700	89348
29840	49905	15	applied	\N	\N	\N	\N	150701	150701	150702
29840	49906	16	applied	\N	\N	\N	\N	150703	150703	150704
29840	49907	17	applied	\N	\N	\N	\N	150705	150705	89383
29840	49908	18	applied	\N	\N	\N	\N	150706	150706	89448
29840	49909	19	applied	\N	\N	\N	\N	150707	150707	89450
29840	49910	20	applied	\N	\N	\N	\N	150708	150708	150709
29840	49911	21	applied	\N	\N	\N	\N	150710	150710	150711
29840	49912	22	applied	\N	\N	\N	\N	150712	150712	150713
29840	49913	23	applied	\N	\N	\N	\N	150714	150714	150715
29840	49914	24	applied	\N	\N	\N	\N	150716	150716	89485
29840	49915	25	applied	\N	\N	\N	\N	150717	150717	150718
29840	49916	26	applied	\N	\N	\N	\N	150719	150719	89504
29845	49953	0	applied	\N	\N	\N	\N	150778	150778	150779
29845	49954	1	applied	\N	\N	\N	\N	150780	150780	89677
29845	49955	2	applied	\N	\N	\N	\N	150781	150781	150782
29845	49956	3	applied	\N	\N	\N	\N	150783	150783	150784
29845	49957	4	applied	\N	\N	\N	\N	150785	150785	89685
29850	50000	0	applied	\N	\N	\N	\N	150872	150872	150873
29850	50001	1	applied	\N	\N	\N	\N	150874	150874	150875
29850	50002	2	applied	\N	\N	\N	\N	150876	150876	150877
29850	50003	3	applied	\N	\N	\N	\N	150878	150878	150879
29850	50004	4	applied	\N	\N	\N	\N	150880	150880	90061
29850	50005	5	applied	\N	\N	\N	\N	150881	150881	150882
29850	50006	6	applied	\N	\N	\N	\N	150883	150883	90063
29850	50007	7	applied	\N	\N	\N	\N	150884	150884	90069
29850	50008	8	applied	\N	\N	\N	\N	150885	150885	90111
29852	50009	0	applied	\N	\N	\N	\N	150893	150893	150894
29852	50010	1	applied	\N	\N	\N	\N	150895	150895	150896
29852	50011	2	applied	\N	\N	\N	\N	150897	150897	150898
29852	50012	3	applied	\N	\N	\N	\N	150899	150899	150900
29852	50013	4	applied	\N	\N	\N	\N	150901	150901	150902
29852	50014	5	applied	\N	\N	\N	\N	150903	150903	150904
29852	50015	6	applied	\N	\N	\N	\N	150905	150905	150906
29852	50016	7	applied	\N	\N	\N	\N	150907	150907	150908
29852	50017	8	applied	\N	\N	\N	\N	150909	150909	150910
29852	50018	9	applied	\N	\N	\N	\N	150911	150911	150912
29852	50019	10	applied	\N	\N	\N	\N	150913	150913	90123
29852	50020	11	applied	\N	\N	\N	\N	150914	150914	150915
29852	50021	12	applied	\N	\N	\N	\N	150916	150916	150917
29852	50023	13	applied	\N	\N	\N	\N	150920	150920	90153
29852	50022	14	applied	\N	\N	\N	\N	150918	150918	150921
29857	50051	0	applied	\N	\N	\N	\N	150974	150974	150975
29857	50055	1	applied	\N	\N	\N	\N	150981	150981	150993
29857	50056	2	applied	\N	\N	\N	\N	150983	150983	90339
29857	50057	3	applied	\N	\N	\N	\N	150984	150984	150980
29857	50058	4	applied	\N	\N	\N	\N	150985	150985	90566
29857	50059	5	applied	\N	\N	\N	\N	150987	150987	150994
29857	50060	6	applied	\N	\N	\N	\N	150988	150988	90357
29859	50070	0	applied	\N	\N	\N	\N	151010	151010	151011
29859	50071	1	applied	\N	\N	\N	\N	151012	151012	90463
29859	50072	2	applied	\N	\N	\N	\N	151013	151013	151014
29859	50073	3	applied	\N	\N	\N	\N	151015	151015	90467
29859	50074	4	applied	\N	\N	\N	\N	151016	151016	90469
29859	50075	6	applied	\N	\N	\N	\N	151018	151018	90471
29859	50076	7	applied	\N	\N	\N	\N	151019	151019	151020
29859	50077	8	applied	\N	\N	\N	\N	151021	151021	90582
29859	50078	9	applied	\N	\N	\N	\N	151022	151022	151023
29859	50079	10	applied	\N	\N	\N	\N	151024	151024	90492
29863	50109	0	applied	\N	\N	\N	\N	151089	151089	151090
29863	50110	1	applied	\N	\N	\N	\N	151091	151091	151092
29863	50111	2	applied	\N	\N	\N	\N	151093	151093	90681
29863	50112	3	applied	\N	\N	\N	\N	151094	151094	90692
29863	50113	4	applied	\N	\N	\N	\N	151095	151095	151096
29863	50114	5	applied	\N	\N	\N	\N	151097	151097	90694
29863	50115	6	applied	\N	\N	\N	\N	151098	151098	90703
29863	50116	7	applied	\N	\N	\N	\N	151099	151099	90769
29863	50117	8	applied	\N	\N	\N	\N	151100	151100	90709
29868	50118	0	applied	\N	\N	\N	\N	151106	151106	151107
29868	50119	1	applied	\N	\N	\N	\N	151108	151108	151109
29868	50120	2	applied	\N	\N	\N	\N	151110	151110	90771
29868	50121	3	applied	\N	\N	\N	\N	151111	151111	90772
29813	49449	12	applied	\N	\N	\N	\N	149776	149776	149777
29813	49450	13	applied	\N	\N	\N	\N	149778	149778	149779
29813	49480	14	applied	\N	\N	\N	\N	149837	149837	149838
29813	49481	15	applied	\N	\N	\N	\N	149839	149839	149840
29813	49508	16	applied	\N	\N	\N	\N	149888	149888	149889
29813	49523	17	applied	\N	\N	\N	\N	149921	149921	149922
29813	49524	18	applied	\N	\N	\N	\N	149923	149923	149924
29813	49541	19	applied	\N	\N	\N	\N	149953	149953	149954
29813	49553	20	applied	\N	\N	\N	\N	150015	150015	150016
29813	49554	21	applied	\N	\N	\N	\N	150017	150017	150018
29813	49582	22	applied	\N	\N	\N	\N	150076	150076	150077
29813	49595	23	applied	\N	\N	\N	\N	150103	150103	150104
29813	49608	24	applied	\N	\N	\N	\N	150130	150130	150131
29813	49609	25	applied	\N	\N	\N	\N	150132	150132	150133
29813	49610	26	applied	\N	\N	\N	\N	150134	150134	150135
29813	49611	27	applied	\N	\N	\N	\N	150136	150136	150137
29813	49667	28	applied	\N	\N	\N	\N	150245	150245	150246
29813	49676	29	applied	\N	\N	\N	\N	150278	150278	150279
29813	49686	30	applied	\N	\N	\N	\N	150296	150296	150297
29813	49687	31	applied	\N	\N	\N	\N	150298	150298	150299
29813	49705	32	applied	\N	\N	\N	\N	150328	150328	150329
29813	49714	33	applied	\N	\N	\N	\N	150345	150345	150346
29813	49720	34	applied	\N	\N	\N	\N	150355	150355	150356
29813	49319	35	applied	\N	\N	\N	\N	149504	149504	149505
29813	49312	36	applied	\N	\N	\N	\N	149491	149491	149495
29813	49332	37	applied	\N	\N	\N	\N	149543	149543	87040
29813	49333	38	applied	\N	\N	\N	\N	149544	149544	86974
29813	49334	39	applied	\N	\N	\N	\N	149545	149545	86982
29813	49335	40	applied	\N	\N	\N	\N	149546	149546	87044
29813	49320	41	applied	\N	\N	\N	\N	149507	149507	149508
29813	49321	42	applied	\N	\N	\N	\N	149509	149509	149510
29813	49322	43	applied	\N	\N	\N	\N	149511	149511	149512
29813	49323	44	applied	\N	\N	\N	\N	149513	149513	149514
29813	49324	45	applied	\N	\N	\N	\N	149515	149515	149516
29813	49325	46	applied	\N	\N	\N	\N	149517	149517	149518
29813	49326	47	applied	\N	\N	\N	\N	149519	149519	149520
29813	49327	48	applied	\N	\N	\N	\N	149521	149521	149522
29813	49328	49	applied	\N	\N	\N	\N	149523	149523	149524
29813	49342	50	applied	\N	\N	\N	\N	149562	149562	149563
29813	49343	51	applied	\N	\N	\N	\N	149564	149564	149565
29813	49344	52	applied	\N	\N	\N	\N	149566	149566	149567
29813	49345	53	applied	\N	\N	\N	\N	149568	149568	149569
29813	49346	54	applied	\N	\N	\N	\N	149570	149570	149571
29813	49347	55	applied	\N	\N	\N	\N	149572	149572	149573
29813	49349	56	applied	\N	\N	\N	\N	149577	149577	149547
29813	49329	57	applied	\N	\N	\N	\N	149525	149525	86991
29813	49330	58	applied	\N	\N	\N	\N	149526	149526	87046
29813	49331	59	applied	\N	\N	\N	\N	149528	149528	86993
29813	49348	60	applied	\N	\N	\N	\N	149575	149575	149576
29813	49313	61	applied	\N	\N	\N	\N	149492	149492	86997
29813	49314	62	applied	\N	\N	\N	\N	149493	149493	86999
29813	49336	63	applied	\N	\N	\N	\N	149548	149548	87004
29813	49337	64	applied	\N	\N	\N	\N	149549	149549	149578
29813	49338	65	applied	\N	\N	\N	\N	149551	149551	87010
29813	49339	66	applied	\N	\N	\N	\N	149553	149553	149579
29813	49358	67	applied	\N	\N	\N	\N	149596	149596	87054
29813	49359	68	applied	\N	\N	\N	\N	149598	149598	149580
29813	49373	69	applied	\N	\N	\N	\N	149624	149624	87056
29813	49381	70	applied	\N	\N	\N	\N	149640	149640	149582
29813	49384	71	applied	\N	\N	\N	\N	149646	149646	149991
29813	49340	72	applied	\N	\N	\N	\N	149554	149554	149992
29813	49350	73	applied	\N	\N	\N	\N	149581	149581	149993
29813	49351	74	applied	\N	\N	\N	\N	149583	149583	149994
29813	49352	75	applied	\N	\N	\N	\N	149584	149584	87074
29813	49396	76	applied	\N	\N	\N	\N	149670	149670	150275
29813	49407	77	applied	\N	\N	\N	\N	149693	149693	149995
29813	49411	78	applied	\N	\N	\N	\N	149700	149700	87076
29813	49353	79	applied	\N	\N	\N	\N	149585	149585	87088
29813	49354	80	applied	\N	\N	\N	\N	149587	149587	149595
29813	49356	81	applied	\N	\N	\N	\N	149593	149593	87094
29813	49357	82	applied	\N	\N	\N	\N	149594	149594	149602
29813	49369	83	applied	\N	\N	\N	\N	149618	149618	149619
29813	49370	84	applied	\N	\N	\N	\N	149620	149620	87112
29813	49371	85	applied	\N	\N	\N	\N	149621	149621	149622
29813	49416	86	applied	\N	\N	\N	\N	149709	149709	87118
29813	49435	87	applied	\N	\N	\N	\N	149743	149743	87126
29813	49442	88	applied	\N	\N	\N	\N	149755	149755	149625
29813	49443	89	applied	\N	\N	\N	\N	149757	149757	150370
29813	49451	90	applied	\N	\N	\N	\N	149780	149780	87128
29813	49452	91	applied	\N	\N	\N	\N	149781	149781	149641
29813	49454	92	applied	\N	\N	\N	\N	149785	149785	149647
29813	49482	93	applied	\N	\N	\N	\N	149841	149841	87130
29813	49483	94	applied	\N	\N	\N	\N	149843	149843	150004
29813	49484	95	applied	\N	\N	\N	\N	149844	149844	87132
29813	49521	96	applied	\N	\N	\N	\N	149910	149910	149655
29813	49522	97	applied	\N	\N	\N	\N	149914	149914	87134
29813	49528	98	applied	\N	\N	\N	\N	149931	149931	150005
29813	49529	99	applied	\N	\N	\N	\N	149933	149933	87145
29813	49530	100	applied	\N	\N	\N	\N	149934	149934	149657
29813	49542	101	applied	\N	\N	\N	\N	149955	149955	87147
29813	49557	102	applied	\N	\N	\N	\N	150023	150023	149659
29813	49570	103	applied	\N	\N	\N	\N	150047	150047	87149
29813	49571	104	applied	\N	\N	\N	\N	150049	150049	149661
29813	49585	105	applied	\N	\N	\N	\N	150082	150082	150371
29813	49597	106	applied	\N	\N	\N	\N	150107	150107	87151
29813	49598	107	applied	\N	\N	\N	\N	150108	150108	150372
29813	49615	108	applied	\N	\N	\N	\N	150144	150144	149668
29813	49620	109	applied	\N	\N	\N	\N	150151	150151	87153
29813	49621	110	applied	\N	\N	\N	\N	150152	150152	87155
29813	49622	111	applied	\N	\N	\N	\N	150154	150154	150373
29813	49623	112	applied	\N	\N	\N	\N	150155	150155	87160
29813	49624	113	applied	\N	\N	\N	\N	150157	150157	149671
29813	49669	114	applied	\N	\N	\N	\N	150249	150249	150006
29813	49678	115	applied	\N	\N	\N	\N	150281	150281	87162
29813	49679	116	applied	\N	\N	\N	\N	150283	150283	87170
29813	49688	117	applied	\N	\N	\N	\N	150300	150300	149674
29813	49691	118	applied	\N	\N	\N	\N	150306	150306	87172
29813	49692	119	applied	\N	\N	\N	\N	150307	150307	149676
29813	49708	120	applied	\N	\N	\N	\N	150333	150333	87174
29813	49717	121	applied	\N	\N	\N	\N	150349	150349	150374
29813	49718	122	applied	\N	\N	\N	\N	150351	150351	149695
29813	49723	123	applied	\N	\N	\N	\N	150360	150360	87176
29815	49736	0	applied	\N	\N	\N	\N	150395	150395	150396
29815	49737	1	applied	\N	\N	\N	\N	150397	150397	150398
29815	49738	2	applied	\N	\N	\N	\N	150399	150399	88309
29815	49739	3	applied	\N	\N	\N	\N	150400	150400	88330
29815	49740	4	applied	\N	\N	\N	\N	150401	150401	150402
29815	49741	5	applied	\N	\N	\N	\N	150403	150403	88628
29815	49742	6	applied	\N	\N	\N	\N	150404	150404	150405
29815	49743	7	applied	\N	\N	\N	\N	150406	150406	88629
29815	49744	8	applied	\N	\N	\N	\N	150407	150407	88631
29815	49745	9	applied	\N	\N	\N	\N	150408	150408	88632
29815	49746	10	applied	\N	\N	\N	\N	150409	150409	88369
29815	49747	11	applied	\N	\N	\N	\N	150410	150410	88377
29815	49748	12	applied	\N	\N	\N	\N	150411	150411	150412
29815	49749	13	applied	\N	\N	\N	\N	150413	150413	88389
29815	49750	14	applied	\N	\N	\N	\N	150414	150414	150415
29815	49751	15	applied	\N	\N	\N	\N	150416	150416	88412
29815	49752	16	applied	\N	\N	\N	\N	150417	150417	88414
29815	49753	17	applied	\N	\N	\N	\N	150418	150418	150419
29818	49758	0	applied	\N	\N	\N	\N	150429	150429	150430
29818	49759	1	applied	\N	\N	\N	\N	150431	150431	88645
29818	49760	2	applied	\N	\N	\N	\N	150432	150432	88428
29818	49761	3	applied	\N	\N	\N	\N	150433	150433	88432
29818	49762	4	applied	\N	\N	\N	\N	150434	150434	150435
29818	49763	5	applied	\N	\N	\N	\N	150436	150436	150437
29818	49764	6	applied	\N	\N	\N	\N	150438	150438	88442
29818	49765	7	applied	\N	\N	\N	\N	150439	150439	150440
29818	49766	8	applied	\N	\N	\N	\N	150441	150441	150442
29818	49767	9	applied	\N	\N	\N	\N	150443	150443	88477
29822	49797	0	applied	\N	\N	\N	\N	150503	150503	150504
29822	49798	1	applied	\N	\N	\N	\N	150505	150505	150506
29822	49799	2	applied	\N	\N	\N	\N	150507	150507	88622
29822	49800	3	applied	\N	\N	\N	\N	150508	150508	150509
29822	49801	4	applied	\N	\N	\N	\N	150510	150510	88677
29822	49802	5	applied	\N	\N	\N	\N	150511	150511	150512
29822	49803	6	applied	\N	\N	\N	\N	150513	150513	150514
29822	49804	7	applied	\N	\N	\N	\N	150515	150515	150516
29822	49805	8	applied	\N	\N	\N	\N	150517	150517	150518
29829	49826	0	applied	\N	\N	\N	\N	150562	150562	150563
29829	49827	1	applied	\N	\N	\N	\N	150564	150564	150565
29829	49828	2	applied	\N	\N	\N	\N	150566	150566	88835
29829	49829	3	applied	\N	\N	\N	\N	150567	150567	150568
29829	49830	4	applied	\N	\N	\N	\N	150569	150569	88839
29829	49831	5	applied	\N	\N	\N	\N	150570	150570	88845
29831	49826	0	applied	\N	\N	\N	\N	150562	150562	150563
29831	49827	1	applied	\N	\N	\N	\N	150564	150564	150565
29831	49828	2	applied	\N	\N	\N	\N	150566	150566	88835
29831	49830	3	applied	\N	\N	\N	\N	150569	150569	150573
29833	49843	0	applied	\N	\N	\N	\N	150591	150591	150592
29833	49844	1	applied	\N	\N	\N	\N	150593	150593	88905
29833	49845	2	applied	\N	\N	\N	\N	150594	150594	150595
29833	49846	3	applied	\N	\N	\N	\N	150596	150596	150597
29833	49847	4	applied	\N	\N	\N	\N	150598	150598	150599
29833	49848	5	applied	\N	\N	\N	\N	150600	150600	88925
29839	49867	0	applied	\N	\N	\N	\N	150646	150646	150647
29839	49868	1	applied	\N	\N	\N	\N	150648	150648	150649
29839	49869	2	applied	\N	\N	\N	\N	150650	150650	150651
29839	49870	3	applied	\N	\N	\N	\N	150652	150652	89033
29839	49871	4	applied	\N	\N	\N	\N	150653	150653	89141
29839	49872	5	applied	\N	\N	\N	\N	150654	150654	150655
29839	49873	6	applied	\N	\N	\N	\N	150656	150656	89049
29839	49874	7	applied	\N	\N	\N	\N	150657	150657	89145
29839	49875	8	applied	\N	\N	\N	\N	150658	150658	89064
29839	49876	9	applied	\N	\N	\N	\N	150659	150659	89147
29839	49877	10	applied	\N	\N	\N	\N	150660	150660	150661
29839	49878	11	applied	\N	\N	\N	\N	150662	150662	89068
29839	49879	12	applied	\N	\N	\N	\N	150663	150663	89072
29839	49880	13	applied	\N	\N	\N	\N	150664	150664	89150
29839	49881	14	applied	\N	\N	\N	\N	150665	150665	150666
29839	49882	15	applied	\N	\N	\N	\N	150667	150667	89096
29839	49883	16	applied	\N	\N	\N	\N	150668	150668	89100
29839	49884	17	applied	\N	\N	\N	\N	150669	150669	89102
29839	49885	18	applied	\N	\N	\N	\N	150670	150670	89104
29839	49886	19	applied	\N	\N	\N	\N	150671	150671	89156
29839	49887	20	applied	\N	\N	\N	\N	150672	150672	89164
29839	49888	21	applied	\N	\N	\N	\N	150673	150673	90320
29839	49889	22	applied	\N	\N	\N	\N	150674	150674	90322
29841	49917	0	applied	\N	\N	\N	\N	150721	150721	89497
29841	49918	1	applied	\N	\N	\N	\N	150722	150722	150723
29841	49919	2	applied	\N	\N	\N	\N	150724	150724	150725
29841	49920	3	applied	\N	\N	\N	\N	150726	150726	150727
29841	49921	4	applied	\N	\N	\N	\N	150728	150728	89528
29841	49922	5	applied	\N	\N	\N	\N	150729	150729	89530
29841	49923	6	applied	\N	\N	\N	\N	150730	150730	150731
29841	49924	7	applied	\N	\N	\N	\N	150732	150732	89536
29841	49925	8	applied	\N	\N	\N	\N	150733	150733	150734
29847	49958	0	applied	\N	\N	\N	\N	150789	150789	150790
29847	49959	1	applied	\N	\N	\N	\N	150791	150791	150792
29847	49960	2	applied	\N	\N	\N	\N	150793	150793	150794
29847	49961	3	applied	\N	\N	\N	\N	150795	150795	150796
29847	49962	4	applied	\N	\N	\N	\N	150797	150797	89693
29847	49963	5	applied	\N	\N	\N	\N	150798	150798	150799
29847	49964	6	applied	\N	\N	\N	\N	150800	150800	150801
29847	49965	7	applied	\N	\N	\N	\N	150802	150802	89882
29847	49966	8	applied	\N	\N	\N	\N	150803	150803	150804
29847	49967	10	applied	\N	\N	\N	\N	150806	150806	89883
29847	49968	11	applied	\N	\N	\N	\N	150807	150807	150808
29847	49969	12	applied	\N	\N	\N	\N	150809	150809	89746
29847	49970	13	applied	\N	\N	\N	\N	150810	150810	89760
29847	49971	14	applied	\N	\N	\N	\N	150811	150811	150812
29847	49972	15	applied	\N	\N	\N	\N	150813	150813	89763
29847	49973	16	applied	\N	\N	\N	\N	150814	150814	89889
29847	49974	17	applied	\N	\N	\N	\N	150815	150815	150816
29847	49975	18	applied	\N	\N	\N	\N	150817	150817	89806
29847	49976	19	applied	\N	\N	\N	\N	150818	150818	89810
29847	49977	20	applied	\N	\N	\N	\N	150819	150819	89891
29847	49978	21	applied	\N	\N	\N	\N	150820	150820	89892
29847	49979	22	applied	\N	\N	\N	\N	150821	150821	89894
29847	49980	23	applied	\N	\N	\N	\N	150822	150822	89832
29847	49981	24	applied	\N	\N	\N	\N	150823	150823	89896
29847	49982	25	applied	\N	\N	\N	\N	150824	150824	89898
29847	49983	26	applied	\N	\N	\N	\N	150825	150825	89904
29847	49984	27	applied	\N	\N	\N	\N	150826	150826	150827
29847	49985	28	applied	\N	\N	\N	\N	150828	150828	89914
29847	49986	29	applied	\N	\N	\N	\N	150829	150829	89919
29847	49987	30	applied	\N	\N	\N	\N	150830	150830	150831
29847	49988	31	applied	\N	\N	\N	\N	150832	150832	89931
29847	49989	32	applied	\N	\N	\N	\N	150833	150833	150834
29847	49990	33	applied	\N	\N	\N	\N	150835	150835	89943
29847	49991	34	applied	\N	\N	\N	\N	150836	150836	150837
29847	49992	35	applied	\N	\N	\N	\N	150838	150838	150839
29847	49993	36	applied	\N	\N	\N	\N	150840	150840	89960
29847	49994	37	applied	\N	\N	\N	\N	150841	150841	150842
29847	49995	38	applied	\N	\N	\N	\N	150843	150843	89974
29847	49996	39	applied	\N	\N	\N	\N	150844	150844	150845
29847	49997	40	applied	\N	\N	\N	\N	150846	150846	89997
29847	49998	41	applied	\N	\N	\N	\N	150847	150847	150848
29847	49999	42	applied	\N	\N	\N	\N	150849	150849	150850
29849	50000	0	applied	\N	\N	\N	\N	150872	150872	150873
29816	49735	24	applied	\N	\N	\N	\N	150393	150393	88403
29816	49738	25	applied	\N	\N	\N	\N	150399	150399	88641
29816	49739	26	applied	\N	\N	\N	\N	150400	150400	88412
29816	49752	27	applied	\N	\N	\N	\N	150417	150417	88414
29816	49753	28	applied	\N	\N	\N	\N	150418	150418	150419
29821	49787	0	applied	\N	\N	\N	\N	150488	150488	150489
29821	49788	1	applied	\N	\N	\N	\N	150490	150490	88574
29821	49789	2	applied	\N	\N	\N	\N	150491	150491	88578
29821	49790	3	applied	\N	\N	\N	\N	150492	150492	150493
29821	49791	4	applied	\N	\N	\N	\N	150494	150494	88582
29821	49792	5	applied	\N	\N	\N	\N	150495	150495	150496
29821	49793	6	applied	\N	\N	\N	\N	150497	150497	88607
29821	49794	7	applied	\N	\N	\N	\N	150498	150498	88665
29821	49795	8	applied	\N	\N	\N	\N	150499	150499	88609
29821	49796	9	applied	\N	\N	\N	\N	150500	150500	88666
29823	49797	0	applied	\N	\N	\N	\N	150503	150503	150504
29823	49798	1	applied	\N	\N	\N	\N	150505	150505	150506
29823	49799	2	applied	\N	\N	\N	\N	150507	150507	88622
29823	49800	3	applied	\N	\N	\N	\N	150508	150508	150509
29823	49801	4	applied	\N	\N	\N	\N	150510	150510	88677
29823	49802	5	applied	\N	\N	\N	\N	150511	150511	150512
29823	49803	6	applied	\N	\N	\N	\N	150513	150513	150514
29823	49804	7	applied	\N	\N	\N	\N	150515	150515	150516
29823	49805	8	applied	\N	\N	\N	\N	150517	150517	150518
29825	49806	0	applied	\N	\N	\N	\N	150523	150523	150524
29825	49807	1	applied	\N	\N	\N	\N	150525	150525	150526
29825	49808	2	applied	\N	\N	\N	\N	150527	150527	150528
29825	49809	3	applied	\N	\N	\N	\N	150529	150529	150530
29825	49810	4	applied	\N	\N	\N	\N	150531	150531	88739
29825	49811	5	applied	\N	\N	\N	\N	150532	150532	88753
29825	49812	6	applied	\N	\N	\N	\N	150533	150533	88763
29825	49813	7	applied	\N	\N	\N	\N	150534	150534	150535
29825	49814	8	applied	\N	\N	\N	\N	150536	150536	150537
29825	49815	9	applied	\N	\N	\N	\N	150538	150538	88774
29825	49816	10	applied	\N	\N	\N	\N	150539	150539	150540
29827	49817	0	applied	\N	\N	\N	\N	150546	150546	150547
29827	49818	1	applied	\N	\N	\N	\N	150548	150548	150549
29827	49819	2	applied	\N	\N	\N	\N	150550	150550	150551
29827	49820	3	applied	\N	\N	\N	\N	150552	150552	88790
29827	49821	4	applied	\N	\N	\N	\N	150553	150553	150554
29827	49822	5	applied	\N	\N	\N	\N	150555	150555	150556
29827	49823	6	applied	\N	\N	\N	\N	150557	150557	88818
29827	49824	7	applied	\N	\N	\N	\N	150558	150558	88825
29827	49825	8	applied	\N	\N	\N	\N	150559	150559	88833
29832	49826	0	applied	\N	\N	\N	\N	150562	150562	150563
29832	49832	1	applied	\N	\N	\N	\N	150575	150575	150576
29832	49827	2	applied	\N	\N	\N	\N	150564	150564	150565
29832	49828	3	applied	\N	\N	\N	\N	150566	150566	88835
29832	49829	4	applied	\N	\N	\N	\N	150567	150567	150568
29832	49833	5	applied	\N	\N	\N	\N	150577	150577	88837
29832	49830	6	applied	\N	\N	\N	\N	150569	150569	150578
29832	49834	7	applied	\N	\N	\N	\N	150579	150579	88847
29832	49835	8	applied	\N	\N	\N	\N	150580	150580	150581
29832	49836	9	applied	\N	\N	\N	\N	150582	150582	88865
29832	49837	10	applied	\N	\N	\N	\N	150583	150583	89125
29832	49838	11	applied	\N	\N	\N	\N	150584	150584	88875
29832	49839	12	applied	\N	\N	\N	\N	150585	150585	89127
29832	49831	13	applied	\N	\N	\N	\N	150570	150570	150586
29832	49840	14	applied	\N	\N	\N	\N	150587	150587	88895
29832	49841	15	applied	\N	\N	\N	\N	150588	150588	88903
29832	49842	16	applied	\N	\N	\N	\N	150589	150589	89129
29834	49849	0	applied	\N	\N	\N	\N	150603	150603	150604
29834	49850	1	applied	\N	\N	\N	\N	150605	150605	88927
29834	49851	2	applied	\N	\N	\N	\N	150606	150606	150607
29834	49852	3	applied	\N	\N	\N	\N	150608	150608	88929
29834	49853	4	applied	\N	\N	\N	\N	150609	150609	150610
29836	49854	0	applied	\N	\N	\N	\N	150614	150614	150615
29836	49855	1	applied	\N	\N	\N	\N	150616	150616	88931
29836	49856	2	applied	\N	\N	\N	\N	150617	150617	88933
29836	49857	3	applied	\N	\N	\N	\N	150618	150618	150619
29836	49858	4	applied	\N	\N	\N	\N	150620	150620	150621
29838	49867	0	applied	\N	\N	\N	\N	150646	150646	150647
29838	49868	1	applied	\N	\N	\N	\N	150648	150648	150649
29838	49869	2	applied	\N	\N	\N	\N	150650	150650	150651
29838	49870	3	applied	\N	\N	\N	\N	150652	150652	89033
29838	49871	4	applied	\N	\N	\N	\N	150653	150653	89141
29838	49872	5	applied	\N	\N	\N	\N	150654	150654	150655
29838	49873	6	applied	\N	\N	\N	\N	150656	150656	89049
29838	49874	7	applied	\N	\N	\N	\N	150657	150657	89145
29838	49875	8	applied	\N	\N	\N	\N	150658	150658	89064
29838	49876	9	applied	\N	\N	\N	\N	150659	150659	89147
29838	49877	10	applied	\N	\N	\N	\N	150660	150660	150661
29838	49878	11	applied	\N	\N	\N	\N	150662	150662	89068
29838	49879	12	applied	\N	\N	\N	\N	150663	150663	89072
29838	49880	13	applied	\N	\N	\N	\N	150664	150664	89150
29838	49881	14	applied	\N	\N	\N	\N	150665	150665	150666
29838	49882	15	applied	\N	\N	\N	\N	150667	150667	89096
29838	49883	16	applied	\N	\N	\N	\N	150668	150668	89100
29838	49884	17	applied	\N	\N	\N	\N	150669	150669	89102
29838	49885	18	applied	\N	\N	\N	\N	150670	150670	89104
29838	49886	19	applied	\N	\N	\N	\N	150671	150671	89156
29838	49887	20	applied	\N	\N	\N	\N	150672	150672	89164
29838	49888	21	applied	\N	\N	\N	\N	150673	150673	90320
29838	49889	22	applied	\N	\N	\N	\N	150674	150674	90322
29842	49926	0	applied	\N	\N	\N	\N	150737	150737	89557
29842	49927	1	applied	\N	\N	\N	\N	150738	150738	150739
29842	49928	2	applied	\N	\N	\N	\N	150740	150740	89563
29842	49929	3	applied	\N	\N	\N	\N	150741	150741	150742
29842	49930	4	applied	\N	\N	\N	\N	150743	150743	150744
29842	49931	5	applied	\N	\N	\N	\N	150745	150745	89596
29842	49932	6	applied	\N	\N	\N	\N	150746	150746	89598
29842	49933	7	applied	\N	\N	\N	\N	150747	150747	89605
29842	49934	8	applied	\N	\N	\N	\N	150748	150748	89608
29842	49935	9	applied	\N	\N	\N	\N	150749	150749	150750
29842	49936	10	applied	\N	\N	\N	\N	150751	150751	150752
29842	49937	11	applied	\N	\N	\N	\N	150753	150753	89610
29842	49938	12	applied	\N	\N	\N	\N	150754	150754	150755
29842	49939	13	applied	\N	\N	\N	\N	150756	150756	150757
29842	49940	14	applied	\N	\N	\N	\N	150758	150758	89623
29842	49941	15	applied	\N	\N	\N	\N	150759	150759	150760
29842	49942	16	applied	\N	\N	\N	\N	150761	150761	89630
29842	49943	17	applied	\N	\N	\N	\N	150762	150762	89875
29842	49944	18	applied	\N	\N	\N	\N	150763	150763	150764
29842	49945	19	applied	\N	\N	\N	\N	150765	150765	150766
29842	49946	20	applied	\N	\N	\N	\N	150767	150767	89651
29844	49953	0	applied	\N	\N	\N	\N	150778	150778	150779
29844	49954	1	applied	\N	\N	\N	\N	150780	150780	89677
29844	49955	2	applied	\N	\N	\N	\N	150781	150781	150782
29844	49956	3	applied	\N	\N	\N	\N	150783	150783	150784
29844	49957	4	applied	\N	\N	\N	\N	150785	150785	89685
29848	49958	0	applied	\N	\N	\N	\N	150789	150789	150790
29848	49959	1	applied	\N	\N	\N	\N	150791	150791	150792
29848	49960	2	applied	\N	\N	\N	\N	150793	150793	150794
29848	49961	3	applied	\N	\N	\N	\N	150795	150795	150796
29848	49962	4	applied	\N	\N	\N	\N	150797	150797	89693
29848	49967	5	applied	\N	\N	\N	\N	150806	150806	150801
29848	49968	6	applied	\N	\N	\N	\N	150807	150807	150804
29848	49969	7	applied	\N	\N	\N	\N	150809	150809	89883
29848	49970	8	applied	\N	\N	\N	\N	150810	150810	150808
29848	49971	10	applied	\N	\N	\N	\N	150811	150811	89746
29848	49972	11	applied	\N	\N	\N	\N	150813	150813	89760
29848	49973	12	applied	\N	\N	\N	\N	150814	150814	150812
29848	49974	13	applied	\N	\N	\N	\N	150815	150815	89763
29848	49975	14	applied	\N	\N	\N	\N	150817	150817	89889
29848	49976	15	applied	\N	\N	\N	\N	150818	150818	150816
29848	49977	16	applied	\N	\N	\N	\N	150819	150819	89806
29848	49978	17	applied	\N	\N	\N	\N	150820	150820	89810
29848	49979	18	applied	\N	\N	\N	\N	150821	150821	89891
29848	49980	19	applied	\N	\N	\N	\N	150822	150822	89892
29848	49981	20	applied	\N	\N	\N	\N	150823	150823	89894
29848	49982	21	applied	\N	\N	\N	\N	150824	150824	89832
29848	49983	22	applied	\N	\N	\N	\N	150825	150825	89896
29848	49984	23	applied	\N	\N	\N	\N	150826	150826	89898
29848	49985	24	applied	\N	\N	\N	\N	150828	150828	89904
29848	49987	25	applied	\N	\N	\N	\N	150830	150830	150827
29848	49988	26	applied	\N	\N	\N	\N	150832	150832	89914
29848	49989	27	applied	\N	\N	\N	\N	150833	150833	150863
29848	49990	28	applied	\N	\N	\N	\N	150835	150835	89929
29848	49991	29	applied	\N	\N	\N	\N	150836	150836	89939
29848	49992	30	applied	\N	\N	\N	\N	150838	150838	150864
29848	49993	31	applied	\N	\N	\N	\N	150840	150840	89945
29848	49994	32	applied	\N	\N	\N	\N	150841	150841	150865
29848	49995	33	applied	\N	\N	\N	\N	150843	150843	150866
29848	49996	34	applied	\N	\N	\N	\N	150844	150844	150867
29848	49997	35	applied	\N	\N	\N	\N	150846	150846	89972
29848	49998	36	applied	\N	\N	\N	\N	150847	150847	89976
29848	49999	37	applied	\N	\N	\N	\N	150849	150849	150868
29860	50080	0	applied	\N	\N	\N	\N	151038	151038	151039
29860	50081	1	applied	\N	\N	\N	\N	151040	151040	151041
29860	50082	2	applied	\N	\N	\N	\N	151042	151042	90584
29860	50083	3	applied	\N	\N	\N	\N	151043	151043	90505
29860	50084	4	applied	\N	\N	\N	\N	151044	151044	90586
29860	50085	5	applied	\N	\N	\N	\N	151045	151045	151046
29860	50086	6	applied	\N	\N	\N	\N	151047	151047	90534
29860	50087	7	applied	\N	\N	\N	\N	151048	151048	90538
29860	50088	8	applied	\N	\N	\N	\N	151049	151049	151050
29860	50089	9	applied	\N	\N	\N	\N	151051	151051	90545
29865	50109	0	applied	\N	\N	\N	\N	151089	151089	151090
29865	50110	1	applied	\N	\N	\N	\N	151091	151091	151092
29865	50111	2	applied	\N	\N	\N	\N	151093	151093	90681
29865	50112	3	applied	\N	\N	\N	\N	151094	151094	90692
29865	50113	4	applied	\N	\N	\N	\N	151095	151095	151096
29865	50114	5	applied	\N	\N	\N	\N	151097	151097	90694
29865	50115	6	applied	\N	\N	\N	\N	151098	151098	90703
29865	50116	7	applied	\N	\N	\N	\N	151099	151099	90769
29865	50117	8	applied	\N	\N	\N	\N	151100	151100	90709
29869	50118	0	applied	\N	\N	\N	\N	151106	151106	151107
29869	50119	1	applied	\N	\N	\N	\N	151108	151108	151109
29869	50120	2	applied	\N	\N	\N	\N	151110	151110	90771
29869	50121	3	applied	\N	\N	\N	\N	151111	151111	90772
29869	50122	4	applied	\N	\N	\N	\N	151112	151112	90719
29869	50123	5	applied	\N	\N	\N	\N	151113	151113	90727
29869	50124	6	applied	\N	\N	\N	\N	151114	151114	151115
29869	50125	7	applied	\N	\N	\N	\N	151116	151116	151117
29869	50126	8	applied	\N	\N	\N	\N	151118	151118	90750
29869	50127	9	applied	\N	\N	\N	\N	151119	151119	151120
29872	50128	0	applied	\N	\N	\N	\N	151126	151126	151127
29872	50129	1	applied	\N	\N	\N	\N	151128	151128	151129
29872	50130	2	applied	\N	\N	\N	\N	151130	151130	91469
29872	50132	3	applied	\N	\N	\N	\N	151132	151132	90785
29872	50133	4	applied	\N	\N	\N	\N	151134	151134	91470
29872	50134	5	applied	\N	\N	\N	\N	151135	151135	90793
29872	50135	6	applied	\N	\N	\N	\N	151136	151136	91473
29872	50137	7	applied	\N	\N	\N	\N	151138	151138	90818
29872	50138	8	applied	\N	\N	\N	\N	151139	151139	91480
29872	50139	9	applied	\N	\N	\N	\N	151140	151140	90829
29872	50140	10	applied	\N	\N	\N	\N	151141	151141	90839
29872	50145	11	applied	\N	\N	\N	\N	151146	151146	90843
29872	50146	12	applied	\N	\N	\N	\N	151147	151147	91484
29872	50147	13	applied	\N	\N	\N	\N	151148	151148	90854
29878	48846	0	applied	\N	\N	1000000000	\N	148653	148653	148654
29878	48733	1	applied	\N	\N	\N	\N	148457	148457	148457
29878	48707	2	applied	\N	\N	\N	\N	148407	148407	148408
29878	48961	3	applied	\N	\N	\N	\N	148846	148846	148847
29878	50158	4	applied	\N	\N	\N	\N	151195	151195	151196
29878	48734	5	applied	\N	\N	\N	\N	148458	148458	148459
29878	48753	6	applied	\N	\N	\N	\N	148488	148488	111296
29878	48598	7	applied	\N	\N	\N	\N	148160	148160	148161
29878	49148	8	applied	\N	\N	\N	\N	149204	149204	149205
29878	49157	9	applied	\N	\N	\N	\N	149227	149227	149228
29878	49607	10	applied	\N	\N	\N	\N	150128	150128	150129
29878	48973	11	applied	\N	\N	\N	\N	148872	148872	148851
29878	48754	12	applied	\N	\N	1000000000	\N	148489	148489	148490
29878	48627	13	applied	\N	\N	\N	\N	148222	148222	111296
29878	48963	14	applied	\N	\N	\N	\N	148850	148850	148873
29878	49138	15	applied	\N	\N	\N	\N	149183	149183	149184
29878	48642	16	applied	\N	\N	\N	\N	148255	148255	44452
29878	48935	17	applied	\N	\N	\N	\N	148808	148808	148808
29878	49093	18	applied	\N	\N	\N	\N	149098	149098	149099
29878	49094	19	applied	\N	\N	\N	\N	149101	149101	149102
29883	50207	0	applied	\N	\N	\N	\N	151282	151282	151283
29883	50208	1	applied	\N	\N	\N	\N	151284	151284	151285
29883	50209	2	applied	\N	\N	\N	\N	151286	151286	91123
29883	50210	3	applied	\N	\N	\N	\N	151287	151287	91125
29883	50211	4	applied	\N	\N	\N	\N	151288	151288	91137
29883	50212	5	applied	\N	\N	\N	\N	151289	151289	91138
29883	50213	6	applied	\N	\N	\N	\N	151290	151290	151291
29883	50214	7	applied	\N	\N	\N	\N	151292	151292	91140
29883	50215	8	applied	\N	\N	\N	\N	151293	151293	151294
29883	50216	9	applied	\N	\N	\N	\N	151295	151295	151296
29883	50217	10	applied	\N	\N	\N	\N	151297	151297	151298
29883	50218	11	applied	\N	\N	\N	\N	151299	151299	151300
29883	50219	12	applied	\N	\N	\N	\N	151301	151301	91171
29883	50220	13	applied	\N	\N	\N	\N	151302	151302	91175
29883	50221	14	applied	\N	\N	\N	\N	151303	151303	91183
29883	50222	15	applied	\N	\N	\N	\N	151304	151304	151305
29883	50223	16	applied	\N	\N	\N	\N	151306	151306	91209
29883	50224	17	applied	\N	\N	\N	\N	151307	151307	91213
29883	50225	18	applied	\N	\N	\N	\N	151308	151308	151309
29849	50001	1	applied	\N	\N	\N	\N	150874	150874	150875
29849	50002	2	applied	\N	\N	\N	\N	150876	150876	150877
29849	50003	3	applied	\N	\N	\N	\N	150878	150878	150879
29849	50004	4	applied	\N	\N	\N	\N	150880	150880	90061
29849	50005	5	applied	\N	\N	\N	\N	150881	150881	150882
29849	50006	6	applied	\N	\N	\N	\N	150883	150883	90063
29849	50007	7	applied	\N	\N	\N	\N	150884	150884	90069
29849	50008	8	applied	\N	\N	\N	\N	150885	150885	90111
29851	50009	0	applied	\N	\N	\N	\N	150893	150893	150894
29851	50010	1	applied	\N	\N	\N	\N	150895	150895	150896
29851	50011	2	applied	\N	\N	\N	\N	150897	150897	150898
29851	50012	3	applied	\N	\N	\N	\N	150899	150899	150900
29851	50013	4	applied	\N	\N	\N	\N	150901	150901	150902
29851	50014	5	applied	\N	\N	\N	\N	150903	150903	150904
29851	50015	6	applied	\N	\N	\N	\N	150905	150905	150906
29851	50016	7	applied	\N	\N	\N	\N	150907	150907	150908
29851	50017	8	applied	\N	\N	\N	\N	150909	150909	150910
29851	50018	9	applied	\N	\N	\N	\N	150911	150911	150912
29851	50019	10	applied	\N	\N	\N	\N	150913	150913	90123
29851	50020	11	applied	\N	\N	\N	\N	150914	150914	150915
29851	50021	12	applied	\N	\N	\N	\N	150916	150916	150917
29851	50022	13	applied	\N	\N	\N	\N	150918	150918	90139
29853	50024	0	applied	\N	\N	\N	\N	150924	150924	150925
29853	50025	1	applied	\N	\N	\N	\N	150926	150926	150927
29853	50026	2	applied	\N	\N	\N	\N	150928	150928	150929
29853	50027	3	applied	\N	\N	\N	\N	150930	150930	150931
29853	50028	4	applied	\N	\N	\N	\N	150932	150932	90153
29853	50023	5	applied	\N	\N	\N	\N	150920	150920	150933
29853	50029	6	applied	\N	\N	\N	\N	150934	150934	150935
29853	50030	7	applied	\N	\N	\N	\N	150936	150936	150937
29853	50031	8	applied	\N	\N	\N	\N	150938	150938	150939
29853	50032	9	applied	\N	\N	\N	\N	150940	150940	90180
29853	50033	10	applied	\N	\N	\N	\N	150941	150941	150942
29853	50034	11	applied	\N	\N	\N	\N	150943	150943	150944
29853	50035	12	applied	\N	\N	\N	\N	150945	150945	150946
29853	50036	13	applied	\N	\N	\N	\N	150947	150947	150948
29853	50037	14	applied	\N	\N	\N	\N	150949	150949	150950
29853	50038	15	applied	\N	\N	\N	\N	150951	150951	150952
29853	50039	16	applied	\N	\N	\N	\N	150953	150953	90233
29853	50040	17	applied	\N	\N	\N	\N	150954	150954	150955
29853	50041	18	applied	\N	\N	\N	\N	150956	150956	150957
29855	50051	0	applied	\N	\N	\N	\N	150974	150974	150975
29855	50052	1	applied	\N	\N	\N	\N	150976	150976	90339
29855	50053	2	applied	\N	\N	\N	\N	150977	150977	150978
29855	50054	3	applied	\N	\N	\N	\N	150979	150979	150980
29855	50055	4	applied	\N	\N	\N	\N	150981	150981	150982
29855	50056	5	applied	\N	\N	\N	\N	150983	150983	90343
29855	50057	6	applied	\N	\N	\N	\N	150984	150984	90567
29855	50058	7	applied	\N	\N	\N	\N	150985	150985	150986
29855	50059	8	applied	\N	\N	\N	\N	150987	150987	90419
29855	50060	9	applied	\N	\N	\N	\N	150988	150988	90423
29858	50061	0	applied	\N	\N	\N	\N	150996	150996	150997
29858	50062	1	applied	\N	\N	\N	\N	150998	150998	150999
29858	50063	2	applied	\N	\N	\N	\N	151000	151000	90427
29858	50064	3	applied	\N	\N	\N	\N	151001	151001	151002
29858	50065	4	applied	\N	\N	\N	\N	151003	151003	90429
29858	50066	5	applied	\N	\N	\N	\N	151004	151004	90576
29858	50067	6	applied	\N	\N	\N	\N	151005	151005	90448
29858	50068	7	applied	\N	\N	\N	\N	151006	151006	90452
29858	50069	8	applied	\N	\N	\N	\N	151007	151007	90578
29861	50080	0	applied	\N	\N	\N	\N	151038	151038	151039
29861	50081	1	applied	\N	\N	\N	\N	151040	151040	151041
29861	50082	2	applied	\N	\N	\N	\N	151042	151042	90584
29861	50083	3	applied	\N	\N	\N	\N	151043	151043	90505
29861	50084	4	applied	\N	\N	\N	\N	151044	151044	90586
29861	50085	5	applied	\N	\N	\N	\N	151045	151045	151046
29861	50086	6	applied	\N	\N	\N	\N	151047	151047	90534
29861	50087	7	applied	\N	\N	\N	\N	151048	151048	90538
29861	50088	8	applied	\N	\N	\N	\N	151049	151049	151050
29861	50089	9	applied	\N	\N	\N	\N	151051	151051	90545
29864	50109	0	applied	\N	\N	\N	\N	151089	151089	151090
29864	50110	1	applied	\N	\N	\N	\N	151091	151091	151092
29864	50111	2	applied	\N	\N	\N	\N	151093	151093	90681
29864	50112	3	applied	\N	\N	\N	\N	151094	151094	90692
29864	50113	4	applied	\N	\N	\N	\N	151095	151095	151096
29864	50114	5	applied	\N	\N	\N	\N	151097	151097	90694
29864	50115	6	applied	\N	\N	\N	\N	151098	151098	90703
29864	50116	7	applied	\N	\N	\N	\N	151099	151099	90769
29864	50117	8	applied	\N	\N	\N	\N	151100	151100	90709
29866	50118	0	applied	\N	\N	\N	\N	151106	151106	151107
29866	50119	1	applied	\N	\N	\N	\N	151108	151108	151109
29866	50120	2	applied	\N	\N	\N	\N	151110	151110	90771
29866	50121	3	applied	\N	\N	\N	\N	151111	151111	90772
29866	50122	4	applied	\N	\N	\N	\N	151112	151112	90719
29866	50123	5	applied	\N	\N	\N	\N	151113	151113	90727
29866	50124	6	applied	\N	\N	\N	\N	151114	151114	151115
29866	50125	7	applied	\N	\N	\N	\N	151116	151116	151117
29866	50126	8	applied	\N	\N	\N	\N	151118	151118	90750
29866	50127	9	applied	\N	\N	\N	\N	151119	151119	151120
29871	50128	0	applied	\N	\N	\N	\N	151126	151126	151127
29871	50129	1	applied	\N	\N	\N	\N	151128	151128	151129
29871	50130	2	applied	\N	\N	\N	\N	151130	151130	91469
29871	50131	3	applied	\N	\N	\N	\N	151131	151131	91470
29871	50132	4	applied	\N	\N	\N	\N	151132	151132	151133
29871	50133	5	applied	\N	\N	\N	\N	151134	151134	90791
29871	50134	6	applied	\N	\N	\N	\N	151135	151135	90801
29871	50135	7	applied	\N	\N	\N	\N	151136	151136	91474
29871	50136	8	applied	\N	\N	\N	\N	151137	151137	90818
29871	50137	9	applied	\N	\N	\N	\N	151138	151138	91480
29871	50138	10	applied	\N	\N	\N	\N	151139	151139	90829
29871	50139	11	applied	\N	\N	\N	\N	151140	151140	90839
29871	50140	12	applied	\N	\N	\N	\N	151141	151141	90843
29871	50141	13	applied	\N	\N	\N	\N	151142	151142	91483
29871	50142	14	applied	\N	\N	\N	\N	151143	151143	91484
29871	50143	15	applied	\N	\N	\N	\N	151144	151144	91485
29871	50144	16	applied	\N	\N	\N	\N	151145	151145	90854
29871	50145	17	applied	\N	\N	\N	\N	151146	151146	92009
29871	50146	18	applied	\N	\N	\N	\N	151147	151147	90868
29871	50147	19	applied	\N	\N	\N	\N	151148	151148	92010
29875	50148	0	applied	\N	\N	\N	\N	151154	151154	151155
29875	50155	1	applied	\N	\N	\N	\N	151164	151164	92011
29875	50156	2	applied	\N	\N	\N	\N	151165	151165	90874
29875	50149	3	applied	\N	\N	\N	\N	151156	151156	151166
29875	50150	4	applied	\N	\N	\N	\N	151157	151157	90884
29875	50157	5	applied	\N	\N	\N	\N	151167	151167	92012
29877	50158	0	applied	\N	\N	\N	\N	151195	151195	151196
29877	50159	1	applied	\N	\N	\N	\N	151197	151197	151198
29877	50160	2	applied	\N	\N	\N	\N	151199	151199	151200
29877	50161	3	applied	\N	\N	\N	\N	151201	151201	151202
29877	50162	4	applied	\N	\N	\N	\N	151203	151203	151204
29854	50050	8	applied	\N	\N	\N	\N	150971	150971	150972
29856	50051	0	applied	\N	\N	\N	\N	150974	150974	150975
29856	50052	1	applied	\N	\N	\N	\N	150976	150976	90339
29856	50053	2	applied	\N	\N	\N	\N	150977	150977	150978
29856	50054	3	applied	\N	\N	\N	\N	150979	150979	150980
29856	50055	4	applied	\N	\N	\N	\N	150981	150981	150982
29856	50056	5	applied	\N	\N	\N	\N	150983	150983	90343
29856	50057	6	applied	\N	\N	\N	\N	150984	150984	90567
29856	50058	7	applied	\N	\N	\N	\N	150985	150985	150986
29856	50059	8	applied	\N	\N	\N	\N	150987	150987	90419
29856	50060	9	applied	\N	\N	\N	\N	150988	150988	90423
29862	50090	0	applied	\N	\N	\N	\N	151060	151060	151061
29862	50091	1	applied	\N	\N	\N	\N	151062	151062	151063
29862	50092	2	applied	\N	\N	\N	\N	151064	151064	151065
29862	50093	3	applied	\N	\N	\N	\N	151066	151066	151067
29862	50094	4	applied	\N	\N	\N	\N	151068	151068	90561
29862	50095	5	applied	\N	\N	\N	\N	151069	151069	151070
29862	50096	6	applied	\N	\N	\N	\N	151071	151071	90597
29862	50097	7	applied	\N	\N	\N	\N	151072	151072	90599
29862	50098	8	applied	\N	\N	\N	\N	151073	151073	90612
29862	50099	9	applied	\N	\N	\N	\N	151074	151074	151075
29862	50100	10	applied	\N	\N	\N	\N	151076	151076	151077
29862	50101	11	applied	\N	\N	\N	\N	151078	151078	90630
29862	50102	12	applied	\N	\N	\N	\N	151079	151079	90761
29862	50103	13	applied	\N	\N	\N	\N	151080	151080	90658
29862	50104	14	applied	\N	\N	\N	\N	151081	151081	90672
29862	50105	15	applied	\N	\N	\N	\N	151082	151082	90674
29862	50106	16	applied	\N	\N	\N	\N	151083	151083	90654
29862	50107	17	applied	\N	\N	\N	\N	151084	151084	151085
29862	50108	18	applied	\N	\N	\N	\N	151086	151086	90764
29867	50118	0	applied	\N	\N	\N	\N	151106	151106	151107
29867	50119	1	applied	\N	\N	\N	\N	151108	151108	151109
29867	50120	2	applied	\N	\N	\N	\N	151110	151110	90771
29867	50121	3	applied	\N	\N	\N	\N	151111	151111	90772
29867	50122	4	applied	\N	\N	\N	\N	151112	151112	90719
29867	50123	5	applied	\N	\N	\N	\N	151113	151113	90727
29867	50124	6	applied	\N	\N	\N	\N	151114	151114	151115
29867	50125	7	applied	\N	\N	\N	\N	151116	151116	151117
29867	50126	8	applied	\N	\N	\N	\N	151118	151118	90750
29867	50127	9	applied	\N	\N	\N	\N	151119	151119	151120
29873	50148	0	applied	\N	\N	\N	\N	151154	151154	151155
29873	50149	1	applied	\N	\N	\N	\N	151156	151156	90872
29873	50150	2	applied	\N	\N	\N	\N	151157	151157	92011
29873	50151	3	applied	\N	\N	\N	\N	151158	151158	90884
29873	50152	4	applied	\N	\N	\N	\N	151159	151159	90888
29873	50153	5	applied	\N	\N	\N	\N	151160	151160	92013
29873	50154	6	applied	\N	\N	\N	\N	151161	151161	92015
29876	50009	0	applied	\N	\N	\N	\N	150893	150893	151171
29876	49806	1	applied	\N	\N	\N	\N	150523	150523	150894
29876	50010	2	applied	\N	\N	\N	\N	150895	150895	150896
29876	49754	3	applied	\N	\N	\N	\N	150422	150422	150423
29876	50011	4	applied	\N	\N	\N	\N	150897	150897	150898
29876	49758	5	applied	\N	\N	\N	\N	150429	150429	150430
29876	49768	7	applied	\N	\N	\N	\N	150456	150456	150457
29876	49787	8	applied	\N	\N	\N	\N	150488	150488	150489
29876	49797	9	applied	\N	\N	\N	\N	150503	150503	150504
29876	49807	10	applied	\N	\N	\N	\N	150525	150525	150526
29876	49817	11	applied	\N	\N	\N	\N	150546	150546	150547
29876	49826	12	applied	\N	\N	\N	\N	150562	150562	150563
29876	49832	13	applied	\N	\N	\N	\N	150575	150575	150576
29876	49843	14	applied	\N	\N	\N	\N	150591	150591	150592
29876	49849	15	applied	\N	\N	\N	\N	150603	150603	150604
29876	49854	16	applied	\N	\N	\N	\N	150614	150614	150615
29876	49859	17	applied	\N	\N	\N	\N	150624	150624	150625
29876	49867	18	applied	\N	\N	\N	\N	150646	150646	150647
29876	50013	19	applied	\N	\N	\N	\N	150901	150901	150902
29876	49868	20	applied	\N	\N	\N	\N	150648	150648	150649
29876	49890	21	applied	\N	\N	\N	\N	150677	150677	150678
29876	49947	22	applied	\N	\N	\N	\N	150769	150769	150770
29876	49953	23	applied	\N	\N	\N	\N	150778	150778	150779
29876	49958	24	applied	\N	\N	\N	\N	150789	150789	150790
29876	49959	25	applied	\N	\N	\N	\N	150791	150791	150792
29876	50000	26	applied	\N	\N	\N	\N	150872	150872	150873
29876	50012	27	applied	\N	\N	\N	\N	150899	150899	150900
29876	50024	28	applied	\N	\N	\N	\N	150924	150924	150925
29876	50025	29	applied	\N	\N	\N	\N	150926	150926	150927
29876	50042	30	applied	\N	\N	\N	\N	150959	150959	150960
29876	50051	31	applied	\N	\N	\N	\N	150974	150974	150975
29876	50061	32	applied	\N	\N	\N	\N	150996	150996	150997
29876	50070	33	applied	\N	\N	\N	\N	151010	151010	151011
29876	50080	34	applied	\N	\N	\N	\N	151038	151038	151039
29876	50090	35	applied	\N	\N	\N	\N	151060	151060	151061
29876	50091	36	applied	\N	\N	\N	\N	151062	151062	151063
29876	50109	37	applied	\N	\N	\N	\N	151089	151089	151090
29876	50119	38	applied	\N	\N	\N	\N	151108	151108	151109
29876	50128	39	applied	\N	\N	\N	\N	151126	151126	151127
29876	50129	40	applied	\N	\N	\N	\N	151128	151128	151129
29876	50148	41	applied	\N	\N	\N	\N	151154	151154	151155
29876	49761	42	applied	\N	\N	\N	\N	150433	150433	88418
29876	49755	43	applied	\N	\N	\N	\N	150424	150424	88426
29876	49760	44	applied	\N	\N	\N	\N	150432	150432	151173
29876	49769	45	applied	\N	\N	\N	\N	150458	150458	88645
29876	49770	46	applied	\N	\N	\N	\N	150459	150459	88428
29876	49771	47	applied	\N	\N	\N	\N	150461	150461	88646
29876	49756	48	applied	\N	\N	\N	\N	150425	150425	88647
29876	49757	49	applied	\N	\N	\N	\N	150426	150426	88648
29876	49759	50	applied	\N	\N	\N	\N	150431	150431	88434
29876	49762	51	applied	\N	\N	\N	\N	150434	150434	88649
29876	49763	52	applied	\N	\N	\N	\N	150436	150436	88650
29876	49794	53	applied	\N	\N	\N	\N	150498	150498	88442
29876	49795	54	applied	\N	\N	\N	\N	150499	150499	88652
29876	49801	55	applied	\N	\N	\N	\N	150510	150510	88452
29876	49808	56	applied	\N	\N	\N	\N	150527	150527	88454
29876	49815	57	applied	\N	\N	\N	\N	150538	150538	150440
29876	49821	58	applied	\N	\N	\N	\N	150553	150553	88653
29876	49827	59	applied	\N	\N	\N	\N	150564	150564	88456
29876	49828	60	applied	\N	\N	\N	\N	150566	150566	88654
29876	49833	61	applied	\N	\N	\N	\N	150577	150577	150442
29876	49844	62	applied	\N	\N	\N	\N	150593	150593	88458
29876	49848	63	applied	\N	\N	\N	\N	150600	150600	151174
29876	49851	64	applied	\N	\N	\N	\N	150606	150606	88460
29876	49855	65	applied	\N	\N	\N	\N	150616	150616	88477
29876	49856	66	applied	\N	\N	\N	\N	150617	150617	88655
29876	49862	67	applied	\N	\N	\N	\N	150629	150629	150460
29876	49869	68	applied	\N	\N	\N	\N	150650	150650	88479
29876	49870	69	applied	\N	\N	\N	\N	150652	150652	88656
29876	49871	70	applied	\N	\N	\N	\N	150653	150653	88657
29876	49892	71	applied	\N	\N	\N	\N	150680	150680	88481
29876	49893	72	applied	\N	\N	\N	\N	150682	150682	150463
29876	49894	73	applied	\N	\N	\N	\N	150683	150683	88483
29868	50122	4	applied	\N	\N	\N	\N	151112	151112	90719
29868	50123	5	applied	\N	\N	\N	\N	151113	151113	90727
29868	50124	6	applied	\N	\N	\N	\N	151114	151114	151115
29868	50125	7	applied	\N	\N	\N	\N	151116	151116	151117
29868	50126	8	applied	\N	\N	\N	\N	151118	151118	90750
29868	50127	9	applied	\N	\N	\N	\N	151119	151119	151120
29870	50128	0	applied	\N	\N	\N	\N	151126	151126	151127
29870	50129	1	applied	\N	\N	\N	\N	151128	151128	151129
29870	50130	2	applied	\N	\N	\N	\N	151130	151130	91469
29870	50131	3	applied	\N	\N	\N	\N	151131	151131	91470
29870	50132	4	applied	\N	\N	\N	\N	151132	151132	151133
29870	50133	5	applied	\N	\N	\N	\N	151134	151134	90791
29870	50134	6	applied	\N	\N	\N	\N	151135	151135	90801
29870	50135	7	applied	\N	\N	\N	\N	151136	151136	91474
29870	50136	8	applied	\N	\N	\N	\N	151137	151137	90818
29870	50137	9	applied	\N	\N	\N	\N	151138	151138	91480
29870	50138	10	applied	\N	\N	\N	\N	151139	151139	90829
29870	50139	11	applied	\N	\N	\N	\N	151140	151140	90839
29870	50140	12	applied	\N	\N	\N	\N	151141	151141	90843
29870	50141	13	applied	\N	\N	\N	\N	151142	151142	91483
29870	50142	14	applied	\N	\N	\N	\N	151143	151143	91484
29870	50143	15	applied	\N	\N	\N	\N	151144	151144	91485
29870	50144	16	applied	\N	\N	\N	\N	151145	151145	90854
29870	50145	17	applied	\N	\N	\N	\N	151146	151146	92009
29870	50146	18	applied	\N	\N	\N	\N	151147	151147	90868
29870	50147	19	applied	\N	\N	\N	\N	151148	151148	92010
29874	50148	0	applied	\N	\N	\N	\N	151154	151154	151155
29874	50155	1	applied	\N	\N	\N	\N	151164	151164	92011
29874	50156	2	applied	\N	\N	\N	\N	151165	151165	90874
29874	50149	3	applied	\N	\N	\N	\N	151156	151156	151166
29874	50150	4	applied	\N	\N	\N	\N	151157	151157	90884
29874	50151	5	applied	\N	\N	\N	\N	151158	151158	90888
29874	50152	6	applied	\N	\N	\N	\N	151159	151159	92013
29874	50153	7	applied	\N	\N	\N	\N	151160	151160	92015
29874	50154	8	applied	\N	\N	\N	\N	151161	151161	90906
29874	50157	9	applied	\N	\N	\N	\N	151167	151167	90912
29880	50177	0	applied	\N	\N	\N	\N	151223	151223	151224
29880	50178	1	applied	\N	\N	\N	\N	151225	151225	92035
29880	50179	3	applied	\N	\N	\N	\N	151227	151227	90985
29880	50180	4	applied	\N	\N	\N	\N	151228	151228	92036
29880	50181	5	applied	\N	\N	\N	\N	151229	151229	90993
29880	50182	6	applied	\N	\N	\N	\N	151230	151230	91001
29880	50183	7	applied	\N	\N	\N	\N	151231	151231	91017
29880	50184	8	applied	\N	\N	\N	\N	151232	151232	151233
29880	50185	9	applied	\N	\N	\N	\N	151234	151234	151235
29880	50186	10	applied	\N	\N	\N	\N	151236	151236	91023
29884	50207	0	applied	\N	\N	\N	\N	151282	151282	151283
29884	50208	1	applied	\N	\N	\N	\N	151284	151284	151285
29884	50209	2	applied	\N	\N	\N	\N	151286	151286	91123
29884	50210	3	applied	\N	\N	\N	\N	151287	151287	91125
29884	50211	4	applied	\N	\N	\N	\N	151288	151288	91137
29884	50212	5	applied	\N	\N	\N	\N	151289	151289	91138
29884	50213	6	applied	\N	\N	\N	\N	151290	151290	151291
29884	50214	7	applied	\N	\N	\N	\N	151292	151292	91140
29884	50215	8	applied	\N	\N	\N	\N	151293	151293	151294
29884	50216	9	applied	\N	\N	\N	\N	151295	151295	151296
29884	50217	10	applied	\N	\N	\N	\N	151297	151297	151298
29884	50218	11	applied	\N	\N	\N	\N	151299	151299	151300
29884	50219	12	applied	\N	\N	\N	\N	151301	151301	91171
29884	50220	13	applied	\N	\N	\N	\N	151302	151302	91175
29884	50221	14	applied	\N	\N	\N	\N	151303	151303	91183
29884	50222	15	applied	\N	\N	\N	\N	151304	151304	151305
29884	50223	16	applied	\N	\N	\N	\N	151306	151306	91209
29884	50224	17	applied	\N	\N	\N	\N	151307	151307	91213
29884	50225	18	applied	\N	\N	\N	\N	151308	151308	151309
29884	50226	19	applied	\N	\N	\N	\N	151310	151310	151311
29886	50227	0	applied	\N	\N	\N	\N	151317	151317	151318
29886	50228	1	applied	\N	\N	\N	\N	151319	151319	91226
29886	50229	2	applied	\N	\N	\N	\N	151320	151320	91228
29886	50230	3	applied	\N	\N	\N	\N	151321	151321	151322
29886	50231	4	applied	\N	\N	\N	\N	151323	151323	151324
29886	50232	5	applied	\N	\N	\N	\N	151325	151325	151326
29886	50233	6	applied	\N	\N	\N	\N	151327	151327	91254
29886	50234	7	applied	\N	\N	\N	\N	151328	151328	151329
29886	50235	8	applied	\N	\N	\N	\N	151330	151330	91260
29895	50255	0	applied	\N	\N	\N	\N	151372	151372	151373
29895	50256	1	applied	\N	\N	\N	\N	151374	151374	91335
29895	50257	2	applied	\N	\N	\N	\N	151375	151375	91339
29895	50258	3	applied	\N	\N	\N	\N	151376	151376	151377
29895	50259	4	applied	\N	\N	\N	\N	151378	151378	91356
29895	50260	5	applied	\N	\N	\N	\N	151379	151379	91358
29895	50261	6	applied	\N	\N	\N	\N	151380	151380	151381
29895	50262	7	applied	\N	\N	\N	\N	151382	151382	151383
29895	50263	8	applied	\N	\N	\N	\N	151384	151384	91368
29895	50264	9	applied	\N	\N	\N	\N	151385	151385	91392
29897	50255	0	applied	\N	\N	\N	\N	151372	151372	151373
29897	50256	1	applied	\N	\N	\N	\N	151374	151374	91335
29897	50257	2	applied	\N	\N	\N	\N	151375	151375	91339
29897	50258	3	applied	\N	\N	\N	\N	151376	151376	151377
29897	50259	4	applied	\N	\N	\N	\N	151378	151378	91356
29897	50260	5	applied	\N	\N	\N	\N	151379	151379	91358
29897	50261	6	applied	\N	\N	\N	\N	151380	151380	151381
29897	50262	7	applied	\N	\N	\N	\N	151382	151382	151383
29897	50263	8	applied	\N	\N	\N	\N	151384	151384	91368
29897	50264	9	applied	\N	\N	\N	\N	151385	151385	91392
29911	50315	0	applied	\N	\N	\N	\N	151499	151499	151500
29911	50316	1	applied	\N	\N	\N	\N	151501	151501	91632
29911	50317	2	applied	\N	\N	\N	\N	151502	151502	91636
29911	50318	3	applied	\N	\N	\N	\N	151503	151503	151504
29911	50319	4	applied	\N	\N	\N	\N	151505	151505	91708
29911	50320	5	applied	\N	\N	\N	\N	151506	151506	151507
29911	50321	6	applied	\N	\N	\N	\N	151508	151508	151509
29911	50322	7	applied	\N	\N	\N	\N	151510	151510	91663
29911	50323	8	applied	\N	\N	\N	\N	151511	151511	151512
29911	50324	9	applied	\N	\N	\N	\N	151513	151513	91683
29920	50275	0	applied	\N	\N	\N	\N	151413	151413	151414
29920	50286	1	applied	\N	\N	\N	\N	151432	151432	151433
29920	50295	2	applied	\N	\N	\N	\N	151459	151459	151460
29920	50310	3	applied	\N	\N	\N	\N	151489	151489	151490
29920	50315	4	applied	\N	\N	\N	\N	151499	151499	151500
29920	50325	5	applied	\N	\N	\N	\N	151522	151522	151523
29920	50333	6	applied	\N	\N	\N	\N	151536	151536	151537
29920	50343	7	applied	\N	\N	\N	\N	151553	151553	151554
29920	50276	8	applied	\N	\N	\N	\N	151415	151415	151416
29920	50277	9	applied	\N	\N	\N	\N	151417	151417	151417
29920	50278	10	applied	\N	\N	\N	\N	151418	151418	151419
29920	50279	12	applied	\N	\N	\N	\N	151420	151420	91441
29920	50280	13	applied	\N	\N	\N	\N	151421	151421	151422
29920	50281	14	applied	\N	\N	\N	\N	151423	151423	91461
29920	50282	15	applied	\N	\N	\N	\N	151424	151424	91492
29876	49895	74	applied	\N	\N	\N	\N	150685	150685	151175
29876	49896	75	applied	\N	\N	\N	\N	150687	150687	88485
29876	49919	76	applied	\N	\N	\N	\N	150724	150724	88658
29876	49926	77	applied	\N	\N	\N	\N	150737	150737	88487
29876	49931	78	applied	\N	\N	\N	\N	150745	150745	151176
29876	49935	79	applied	\N	\N	\N	\N	150749	150749	88496
29876	49936	80	applied	\N	\N	\N	\N	150751	150751	150466
29876	49937	81	applied	\N	\N	\N	\N	150753	150753	151177
29876	49938	82	applied	\N	\N	\N	\N	150754	150754	88498
29876	49949	83	applied	\N	\N	\N	\N	150772	150772	151178
29876	49950	84	applied	\N	\N	\N	\N	150773	150773	150468
29876	49955	85	applied	\N	\N	\N	\N	150781	150781	88500
29876	49960	86	applied	\N	\N	\N	\N	150793	150793	151179
29876	49961	87	applied	\N	\N	\N	\N	150795	150795	88502
29876	49962	88	applied	\N	\N	\N	\N	150797	150797	88659
29876	50005	89	applied	\N	\N	\N	\N	150881	150881	151180
29876	50019	90	applied	\N	\N	\N	\N	150913	150913	88509
29876	50022	91	applied	\N	\N	\N	\N	150918	150918	88513
29876	50026	92	applied	\N	\N	\N	\N	150928	150928	150471
29876	50027	93	applied	\N	\N	\N	\N	150930	150930	88515
29876	50028	94	applied	\N	\N	\N	\N	150932	150932	88660
29876	50050	95	applied	\N	\N	\N	\N	150971	150971	151181
29876	50055	96	applied	\N	\N	\N	\N	150981	150981	88519
29876	50056	97	applied	\N	\N	\N	\N	150983	150983	88661
29876	50065	98	applied	\N	\N	\N	\N	151003	151003	88522
29876	50071	99	applied	\N	\N	\N	\N	151012	151012	151182
29876	50076	100	applied	\N	\N	\N	\N	151019	151019	88529
29876	50088	101	applied	\N	\N	\N	\N	151049	151049	151183
29876	50095	102	applied	\N	\N	\N	\N	151069	151069	151184
29876	50096	103	applied	\N	\N	\N	\N	151071	151071	88533
29876	50097	104	applied	\N	\N	\N	\N	151072	151072	150475
29876	50112	105	applied	\N	\N	\N	\N	151094	151094	88542
29876	50113	106	applied	\N	\N	\N	\N	151095	151095	88662
29876	50122	107	applied	\N	\N	\N	\N	151112	151112	151185
29876	50130	108	applied	\N	\N	\N	\N	151130	151130	88544
29876	50132	109	applied	\N	\N	\N	\N	151132	151132	88546
29876	50133	110	applied	\N	\N	\N	\N	151134	151134	150479
29876	50149	111	applied	\N	\N	\N	\N	151156	151156	88555
29876	50150	112	applied	\N	\N	\N	\N	151157	151157	88663
29876	49781	113	applied	\N	\N	\N	\N	150476	150476	88557
29876	49782	114	applied	\N	\N	\N	\N	150477	150477	150483
29876	49783	115	applied	\N	\N	\N	\N	150478	150478	88572
29876	49784	116	applied	\N	\N	\N	\N	150480	150480	88574
29876	49785	117	applied	\N	\N	\N	\N	150481	150481	88576
29876	49786	118	applied	\N	\N	\N	\N	150482	150482	88578
29876	49791	119	applied	\N	\N	\N	\N	150494	150494	151186
29876	49796	120	applied	\N	\N	\N	\N	150500	150500	150493
29881	50187	0	applied	\N	\N	\N	\N	151251	151251	151252
29881	50188	1	applied	\N	\N	\N	\N	151253	151253	151254
29881	50189	2	applied	\N	\N	\N	\N	151255	151255	151256
29881	50190	3	applied	\N	\N	\N	\N	151257	151257	91040
29881	50191	4	applied	\N	\N	\N	\N	151258	151258	92039
29881	50192	5	applied	\N	\N	\N	\N	151259	151259	91050
29881	50193	6	applied	\N	\N	\N	\N	151260	151260	151261
29881	50194	7	applied	\N	\N	\N	\N	151262	151262	91069
29881	50195	8	applied	\N	\N	\N	\N	151263	151263	91071
29881	50196	9	applied	\N	\N	\N	\N	151264	151264	151265
29881	50197	10	applied	\N	\N	\N	\N	151266	151266	92042
29881	50198	11	applied	\N	\N	\N	\N	151267	151267	91075
29881	50199	12	applied	\N	\N	\N	\N	151268	151268	151269
29881	50200	13	applied	\N	\N	\N	\N	151270	151270	91085
29881	50201	14	applied	\N	\N	\N	\N	151271	151271	151272
29881	50202	15	applied	\N	\N	\N	\N	151273	151273	91087
29881	50203	16	applied	\N	\N	\N	\N	151274	151274	151275
29881	50204	17	applied	\N	\N	\N	\N	151276	151276	91099
29881	50205	18	applied	\N	\N	\N	\N	151277	151277	151278
29881	50206	19	applied	\N	\N	\N	\N	151279	151279	91131
29885	50227	0	applied	\N	\N	\N	\N	151317	151317	151318
29885	50228	1	applied	\N	\N	\N	\N	151319	151319	91226
29885	50229	2	applied	\N	\N	\N	\N	151320	151320	91228
29885	50230	3	applied	\N	\N	\N	\N	151321	151321	151322
29885	50231	4	applied	\N	\N	\N	\N	151323	151323	151324
29885	50232	5	applied	\N	\N	\N	\N	151325	151325	151326
29885	50233	6	applied	\N	\N	\N	\N	151327	151327	91254
29885	50234	7	applied	\N	\N	\N	\N	151328	151328	151329
29885	50235	8	applied	\N	\N	\N	\N	151330	151330	91260
29892	50246	0	applied	\N	\N	\N	\N	151354	151354	151355
29892	50247	1	applied	\N	\N	\N	\N	151356	151356	151357
29892	50248	2	applied	\N	\N	\N	\N	151358	151358	151359
29892	50249	3	applied	\N	\N	\N	\N	151360	151360	91309
29892	50250	4	applied	\N	\N	\N	\N	151361	151361	151362
29892	50251	5	applied	\N	\N	\N	\N	151363	151363	91321
29892	50252	6	applied	\N	\N	\N	\N	151364	151364	151365
29892	50253	7	applied	\N	\N	\N	\N	151366	151366	151367
29894	50255	0	applied	\N	\N	\N	\N	151372	151372	151373
29894	50256	1	applied	\N	\N	\N	\N	151374	151374	91335
29894	50257	2	applied	\N	\N	\N	\N	151375	151375	91339
29894	50258	3	applied	\N	\N	\N	\N	151376	151376	151377
29894	50259	4	applied	\N	\N	\N	\N	151378	151378	91356
29894	50260	5	applied	\N	\N	\N	\N	151379	151379	91358
29894	50261	6	applied	\N	\N	\N	\N	151380	151380	151381
29894	50262	7	applied	\N	\N	\N	\N	151382	151382	151383
29894	50263	8	applied	\N	\N	\N	\N	151384	151384	91368
29894	50264	9	applied	\N	\N	\N	\N	151385	151385	91392
29898	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29898	50266	1	applied	\N	\N	\N	\N	151393	151393	151394
29898	50267	2	applied	\N	\N	\N	\N	151395	151395	91387
29898	50268	3	applied	\N	\N	\N	\N	151396	151396	91396
29898	50269	4	applied	\N	\N	\N	\N	151397	151397	91408
29898	50270	5	applied	\N	\N	\N	\N	151398	151398	91409
29898	50271	6	applied	\N	\N	\N	\N	151399	151399	91411
29898	50272	7	applied	\N	\N	\N	\N	151400	151400	151401
29898	50273	8	applied	\N	\N	\N	\N	151402	151402	151402
29898	50274	9	applied	\N	\N	\N	\N	151403	151403	151404
29901	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29901	50266	1	applied	\N	\N	\N	\N	151393	151393	151394
29901	50267	2	applied	\N	\N	\N	\N	151395	151395	91387
29901	50268	3	applied	\N	\N	\N	\N	151396	151396	91396
29901	50269	4	applied	\N	\N	\N	\N	151397	151397	91408
29901	50270	5	applied	\N	\N	\N	\N	151398	151398	91409
29901	50271	6	applied	\N	\N	\N	\N	151399	151399	91411
29901	50272	7	applied	\N	\N	\N	\N	151400	151400	151401
29901	50273	8	applied	\N	\N	\N	\N	151402	151402	151402
29901	50274	9	applied	\N	\N	\N	\N	151403	151403	151404
29905	50286	0	applied	\N	\N	\N	\N	151432	151432	151433
29905	50287	1	applied	\N	\N	\N	\N	151434	151434	91506
29905	50288	2	applied	\N	\N	\N	\N	151435	151435	151436
29905	50289	3	applied	\N	\N	\N	\N	151437	151437	91520
29905	50290	4	applied	\N	\N	\N	\N	151438	151438	91524
29905	50291	5	applied	\N	\N	\N	\N	151439	151439	151440
29877	50163	5	applied	\N	\N	\N	\N	151205	151205	90922
29877	50164	6	applied	\N	\N	\N	\N	151206	151206	90926
29877	50165	7	applied	\N	\N	\N	\N	151207	151207	151208
29877	50166	8	applied	\N	\N	\N	\N	151209	151209	92024
29877	50167	9	applied	\N	\N	\N	\N	151210	151210	92026
29877	50168	10	applied	\N	\N	\N	\N	151211	151211	90952
29877	50169	11	applied	\N	\N	\N	\N	151212	151212	92029
29877	50170	12	applied	\N	\N	\N	\N	151213	151213	92030
29877	50171	13	applied	\N	\N	\N	\N	151214	151214	90968
29877	50172	14	applied	\N	\N	\N	\N	151215	151215	90967
29877	50173	15	applied	\N	\N	\N	\N	151216	151216	92032
29877	50174	16	applied	\N	\N	\N	\N	151217	151217	90979
29877	50175	17	applied	\N	\N	\N	\N	151218	151218	92033
29877	50176	18	applied	\N	\N	\N	\N	151219	151219	92034
29879	50177	0	applied	\N	\N	\N	\N	151223	151223	151224
29879	50178	1	applied	\N	\N	\N	\N	151225	151225	92035
29879	50179	3	applied	\N	\N	\N	\N	151227	151227	90985
29879	50180	4	applied	\N	\N	\N	\N	151228	151228	92036
29879	50181	5	applied	\N	\N	\N	\N	151229	151229	90993
29879	50182	6	applied	\N	\N	\N	\N	151230	151230	91001
29879	50183	7	applied	\N	\N	\N	\N	151231	151231	91017
29879	50184	8	applied	\N	\N	\N	\N	151232	151232	151233
29879	50185	9	applied	\N	\N	\N	\N	151234	151234	151235
29879	50186	10	applied	\N	\N	\N	\N	151236	151236	91023
29882	50207	0	applied	\N	\N	\N	\N	151282	151282	151283
29882	50208	1	applied	\N	\N	\N	\N	151284	151284	151285
29882	50209	2	applied	\N	\N	\N	\N	151286	151286	91123
29882	50210	3	applied	\N	\N	\N	\N	151287	151287	91125
29882	50211	4	applied	\N	\N	\N	\N	151288	151288	91137
29882	50212	5	applied	\N	\N	\N	\N	151289	151289	91138
29882	50213	6	applied	\N	\N	\N	\N	151290	151290	151291
29882	50214	7	applied	\N	\N	\N	\N	151292	151292	91140
29882	50215	8	applied	\N	\N	\N	\N	151293	151293	151294
29882	50216	9	applied	\N	\N	\N	\N	151295	151295	151296
29882	50217	10	applied	\N	\N	\N	\N	151297	151297	151298
29882	50218	11	applied	\N	\N	\N	\N	151299	151299	151300
29882	50219	12	applied	\N	\N	\N	\N	151301	151301	91171
29882	50220	13	applied	\N	\N	\N	\N	151302	151302	91175
29882	50221	14	applied	\N	\N	\N	\N	151303	151303	91183
29882	50222	15	applied	\N	\N	\N	\N	151304	151304	151305
29882	50223	16	applied	\N	\N	\N	\N	151306	151306	91209
29882	50224	17	applied	\N	\N	\N	\N	151307	151307	91213
29882	50225	18	applied	\N	\N	\N	\N	151308	151308	151309
29882	50226	19	applied	\N	\N	\N	\N	151310	151310	151311
29888	50236	0	applied	\N	\N	\N	\N	151334	151334	151335
29888	50237	1	applied	\N	\N	\N	\N	151336	151336	151337
29888	50238	2	applied	\N	\N	\N	\N	151338	151338	151339
29888	50239	3	applied	\N	\N	\N	\N	151340	151340	151341
29888	50240	4	applied	\N	\N	\N	\N	151342	151342	151343
29888	50241	5	applied	\N	\N	\N	\N	151344	151344	151345
29888	50242	6	applied	\N	\N	\N	\N	151346	151346	91285
29888	50243	7	applied	\N	\N	\N	\N	151347	151347	91291
29888	50244	8	applied	\N	\N	\N	\N	151348	151348	151349
29888	50245	9	applied	\N	\N	\N	\N	151350	151350	91301
29890	50236	0	applied	\N	\N	\N	\N	151334	151334	151335
29890	50237	1	applied	\N	\N	\N	\N	151336	151336	151337
29890	50239	2	applied	\N	\N	\N	\N	151340	151340	91265
29890	50242	3	applied	\N	\N	\N	\N	151346	151346	151353
29890	50243	4	applied	\N	\N	\N	\N	151347	151347	151339
29890	50244	5	applied	\N	\N	\N	\N	151348	151348	91273
29893	50255	0	applied	\N	\N	\N	\N	151372	151372	151373
29893	50256	1	applied	\N	\N	\N	\N	151374	151374	91335
29893	50257	2	applied	\N	\N	\N	\N	151375	151375	91339
29893	50258	3	applied	\N	\N	\N	\N	151376	151376	151377
29893	50259	4	applied	\N	\N	\N	\N	151378	151378	91356
29893	50260	5	applied	\N	\N	\N	\N	151379	151379	91358
29893	50261	6	applied	\N	\N	\N	\N	151380	151380	151381
29893	50262	7	applied	\N	\N	\N	\N	151382	151382	151383
29893	50263	8	applied	\N	\N	\N	\N	151384	151384	91368
29893	50264	9	applied	\N	\N	\N	\N	151385	151385	91392
29899	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29899	50266	1	applied	\N	\N	\N	\N	151393	151393	151394
29899	50267	2	applied	\N	\N	\N	\N	151395	151395	91387
29899	50268	3	applied	\N	\N	\N	\N	151396	151396	91396
29899	50269	4	applied	\N	\N	\N	\N	151397	151397	91408
29899	50270	5	applied	\N	\N	\N	\N	151398	151398	91409
29899	50271	6	applied	\N	\N	\N	\N	151399	151399	91411
29899	50272	7	applied	\N	\N	\N	\N	151400	151400	151401
29899	50273	8	applied	\N	\N	\N	\N	151402	151402	151402
29899	50274	9	applied	\N	\N	\N	\N	151403	151403	151404
29903	50275	0	applied	\N	\N	\N	\N	151413	151413	151414
29903	50276	1	applied	\N	\N	\N	\N	151415	151415	151416
29903	50277	2	applied	\N	\N	\N	\N	151417	151417	151417
29903	50278	3	applied	\N	\N	\N	\N	151418	151418	151419
29903	50279	4	applied	\N	\N	\N	\N	151420	151420	91441
29903	50280	5	applied	\N	\N	\N	\N	151421	151421	151422
29903	50281	6	applied	\N	\N	\N	\N	151423	151423	91461
29903	50282	7	applied	\N	\N	\N	\N	151424	151424	91492
29903	50283	8	applied	\N	\N	\N	\N	151425	151425	151426
29903	50284	9	applied	\N	\N	\N	\N	151427	151427	91494
29903	50285	10	applied	\N	\N	\N	\N	151428	151428	151429
29910	50310	0	applied	\N	\N	\N	\N	151489	151489	151490
29910	50307	1	applied	\N	\N	\N	\N	151483	151483	91601
29910	50311	2	applied	\N	\N	\N	\N	151491	151491	91605
29910	50312	3	applied	\N	\N	\N	\N	151492	151492	91705
29910	50313	4	applied	\N	\N	\N	\N	151493	151493	91614
29910	50306	5	applied	\N	\N	\N	\N	151480	151480	151494
29910	50314	6	applied	\N	\N	\N	\N	151495	151495	91628
29910	50308	7	applied	\N	\N	\N	\N	151485	151485	151496
29910	50309	8	applied	\N	\N	\N	\N	151487	151487	151497
29913	50315	0	applied	\N	\N	\N	\N	151499	151499	151500
29913	50316	1	applied	\N	\N	\N	\N	151501	151501	91632
29913	50317	2	applied	\N	\N	\N	\N	151502	151502	91636
29913	50318	3	applied	\N	\N	\N	\N	151503	151503	151504
29913	50319	4	applied	\N	\N	\N	\N	151505	151505	91708
29913	50320	5	applied	\N	\N	\N	\N	151506	151506	151507
29913	50321	6	applied	\N	\N	\N	\N	151508	151508	151509
29913	50322	7	applied	\N	\N	\N	\N	151510	151510	91663
29913	50323	8	applied	\N	\N	\N	\N	151511	151511	151512
29913	50324	9	applied	\N	\N	\N	\N	151513	151513	91683
29916	50325	0	applied	\N	\N	\N	\N	151522	151522	151523
29916	50319	1	applied	\N	\N	\N	\N	151505	151505	151512
29916	50326	2	applied	\N	\N	\N	\N	151524	151524	151532
29916	50327	3	applied	\N	\N	\N	\N	151525	151525	91683
29916	50328	4	applied	\N	\N	\N	\N	151526	151526	91715
29916	50324	5	applied	\N	\N	\N	\N	151513	151513	91717
29916	50329	6	applied	\N	\N	\N	\N	151527	151527	91718
29916	50330	7	applied	\N	\N	\N	\N	151528	151528	91720
29916	50331	8	applied	\N	\N	\N	\N	151529	151529	91723
29916	50332	9	applied	\N	\N	\N	\N	151533	151533	151534
29883	50226	19	applied	\N	\N	\N	\N	151310	151310	151311
29887	50227	0	applied	\N	\N	\N	\N	151317	151317	151318
29887	50228	1	applied	\N	\N	\N	\N	151319	151319	91226
29887	50229	2	applied	\N	\N	\N	\N	151320	151320	91228
29887	50230	3	applied	\N	\N	\N	\N	151321	151321	151322
29887	50231	4	applied	\N	\N	\N	\N	151323	151323	151324
29887	50232	5	applied	\N	\N	\N	\N	151325	151325	151326
29887	50233	6	applied	\N	\N	\N	\N	151327	151327	91254
29887	50234	7	applied	\N	\N	\N	\N	151328	151328	151329
29887	50235	8	applied	\N	\N	\N	\N	151330	151330	91260
29889	50236	0	applied	\N	\N	\N	\N	151334	151334	151335
29889	50237	1	applied	\N	\N	\N	\N	151336	151336	151337
29889	50238	2	applied	\N	\N	\N	\N	151338	151338	151339
29889	50239	3	applied	\N	\N	\N	\N	151340	151340	151341
29889	50240	4	applied	\N	\N	\N	\N	151342	151342	151343
29889	50241	5	applied	\N	\N	\N	\N	151344	151344	151345
29889	50242	6	applied	\N	\N	\N	\N	151346	151346	91285
29889	50243	7	applied	\N	\N	\N	\N	151347	151347	91291
29889	50244	8	applied	\N	\N	\N	\N	151348	151348	151349
29889	50245	9	applied	\N	\N	\N	\N	151350	151350	91301
29891	50246	0	applied	\N	\N	\N	\N	151354	151354	151355
29891	50247	1	applied	\N	\N	\N	\N	151356	151356	151357
29891	50248	2	applied	\N	\N	\N	\N	151358	151358	151359
29891	50249	3	applied	\N	\N	\N	\N	151360	151360	91309
29891	50250	4	applied	\N	\N	\N	\N	151361	151361	151362
29891	50251	5	applied	\N	\N	\N	\N	151363	151363	91321
29891	50252	6	applied	\N	\N	\N	\N	151364	151364	151365
29891	50253	7	applied	\N	\N	\N	\N	151366	151366	151367
29891	50254	8	applied	\N	\N	\N	\N	151368	151368	151369
29896	50255	0	applied	\N	\N	\N	\N	151372	151372	151373
29896	50256	1	applied	\N	\N	\N	\N	151374	151374	91335
29896	50257	2	applied	\N	\N	\N	\N	151375	151375	91339
29896	50258	3	applied	\N	\N	\N	\N	151376	151376	151377
29896	50259	4	applied	\N	\N	\N	\N	151378	151378	91356
29896	50260	5	applied	\N	\N	\N	\N	151379	151379	91358
29896	50261	6	applied	\N	\N	\N	\N	151380	151380	151381
29896	50262	7	applied	\N	\N	\N	\N	151382	151382	151383
29896	50263	8	applied	\N	\N	\N	\N	151384	151384	91368
29896	50264	9	applied	\N	\N	\N	\N	151385	151385	91392
29900	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29900	50266	1	applied	\N	\N	\N	\N	151393	151393	151394
29900	50267	2	applied	\N	\N	\N	\N	151395	151395	91387
29900	50268	3	applied	\N	\N	\N	\N	151396	151396	91396
29900	50269	4	applied	\N	\N	\N	\N	151397	151397	91408
29900	50270	5	applied	\N	\N	\N	\N	151398	151398	91409
29900	50271	6	applied	\N	\N	\N	\N	151399	151399	91411
29900	50272	7	applied	\N	\N	\N	\N	151400	151400	151401
29900	50273	8	applied	\N	\N	\N	\N	151402	151402	151402
29900	50274	9	applied	\N	\N	\N	\N	151403	151403	151404
29902	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29902	50266	1	applied	\N	\N	\N	\N	151393	151393	151394
29902	50267	2	applied	\N	\N	\N	\N	151395	151395	91387
29902	50269	3	applied	\N	\N	\N	\N	151397	151397	151411
29902	50270	4	applied	\N	\N	\N	\N	151398	151398	91397
29902	50271	5	applied	\N	\N	\N	\N	151399	151399	91410
29902	50272	6	applied	\N	\N	\N	\N	151400	151400	91413
29902	50273	7	applied	\N	\N	\N	\N	151402	151402	151402
29904	50286	0	applied	\N	\N	\N	\N	151432	151432	151433
29904	50287	1	applied	\N	\N	\N	\N	151434	151434	91506
29904	50288	2	applied	\N	\N	\N	\N	151435	151435	151436
29904	50289	3	applied	\N	\N	\N	\N	151437	151437	91520
29904	50290	4	applied	\N	\N	\N	\N	151438	151438	91524
29904	50291	5	applied	\N	\N	\N	\N	151439	151439	151440
29904	50292	6	applied	\N	\N	\N	\N	151441	151441	151442
29904	50293	7	applied	\N	\N	\N	\N	151443	151443	151444
29904	50294	8	applied	\N	\N	\N	\N	151445	151445	91576
29906	50295	0	applied	\N	\N	\N	\N	151459	151459	151460
29906	50296	1	applied	\N	\N	\N	\N	151461	151461	151462
29906	50297	2	applied	\N	\N	\N	\N	151463	151463	91577
29906	50298	3	applied	\N	\N	\N	\N	151464	151464	151465
29906	50299	4	applied	\N	\N	\N	\N	151466	151466	151466
29906	50300	5	applied	\N	\N	\N	\N	151467	151467	91578
29906	50301	6	applied	\N	\N	\N	\N	151468	151468	151469
29906	50302	7	applied	\N	\N	\N	\N	151470	151470	151471
29906	50303	8	applied	\N	\N	\N	\N	151472	151472	91559
29906	50304	9	applied	\N	\N	\N	\N	151473	151473	151474
29906	50305	10	applied	\N	\N	\N	\N	151475	151475	151476
29908	50306	0	applied	\N	\N	\N	\N	151480	151480	91703
29915	50325	0	applied	\N	\N	\N	\N	151522	151522	151523
29915	50326	1	applied	\N	\N	\N	\N	151524	151524	91685
29915	50327	2	applied	\N	\N	\N	\N	151525	151525	91692
29915	50328	3	applied	\N	\N	\N	\N	151526	151526	91717
29915	50329	4	applied	\N	\N	\N	\N	151527	151527	91718
29915	50330	5	applied	\N	\N	\N	\N	151528	151528	91720
29915	50331	6	applied	\N	\N	\N	\N	151529	151529	91723
29917	50333	0	applied	\N	\N	\N	\N	151536	151536	151537
29917	50334	1	applied	\N	\N	\N	\N	151538	151538	91748
29917	50335	2	applied	\N	\N	\N	\N	151539	151539	91757
29917	50336	3	applied	\N	\N	\N	\N	151540	151540	151541
29917	50337	4	applied	\N	\N	\N	\N	151542	151542	91862
29917	50338	5	applied	\N	\N	\N	\N	151543	151543	151544
29917	50339	6	applied	\N	\N	\N	\N	151545	151545	151546
29917	50340	7	applied	\N	\N	\N	\N	151547	151547	91765
29917	50341	8	applied	\N	\N	\N	\N	151548	151548	151549
29917	50342	9	applied	\N	\N	\N	\N	151550	151550	91864
29919	50343	0	applied	\N	\N	\N	\N	151553	151553	151554
29919	50344	1	applied	\N	\N	\N	\N	151555	151555	91786
29919	50345	2	applied	\N	\N	\N	\N	151556	151556	151557
29919	50347	3	applied	\N	\N	\N	\N	151560	151560	91792
29919	50348	4	applied	\N	\N	\N	\N	151561	151561	151562
29919	50346	5	applied	\N	\N	\N	\N	151558	151558	151563
29919	50349	6	applied	\N	\N	\N	\N	151564	151564	151565
29919	50350	7	applied	\N	\N	\N	\N	151566	151566	91871
29919	50351	8	applied	\N	\N	\N	\N	151567	151567	91849
29921	50343	0	applied	\N	\N	\N	\N	151553	151553	151554
29921	50344	1	applied	\N	\N	\N	\N	151555	151555	91786
29921	50345	2	applied	\N	\N	\N	\N	151556	151556	151557
29921	50347	3	applied	\N	\N	\N	\N	151560	151560	91792
29921	50348	4	applied	\N	\N	\N	\N	151561	151561	151562
29921	50346	5	applied	\N	\N	\N	\N	151558	151558	151563
29921	50349	6	applied	\N	\N	\N	\N	151564	151564	151565
29921	50350	7	applied	\N	\N	\N	\N	151566	151566	91871
29921	50351	8	applied	\N	\N	\N	\N	151567	151567	91849
29923	50352	0	applied	\N	\N	\N	\N	151595	151595	151596
29923	50353	1	applied	\N	\N	\N	\N	151597	151597	151598
29923	50354	2	applied	\N	\N	\N	\N	151599	151599	91893
29923	50355	3	applied	\N	\N	\N	\N	151600	151600	91881
29923	50356	4	applied	\N	\N	\N	\N	151601	151601	151602
29923	50357	5	applied	\N	\N	\N	\N	151603	151603	91899
29923	50358	6	applied	\N	\N	\N	\N	151604	151604	91905
29905	50292	6	applied	\N	\N	\N	\N	151441	151441	151442
29905	50293	7	applied	\N	\N	\N	\N	151443	151443	151444
29905	50294	8	applied	\N	\N	\N	\N	151445	151445	91576
29907	50295	0	applied	\N	\N	\N	\N	151459	151459	151460
29907	50296	1	applied	\N	\N	\N	\N	151461	151461	151462
29907	50297	2	applied	\N	\N	\N	\N	151463	151463	91577
29907	50298	3	applied	\N	\N	\N	\N	151464	151464	151465
29907	50299	4	applied	\N	\N	\N	\N	151466	151466	151466
29907	50300	5	applied	\N	\N	\N	\N	151467	151467	91578
29907	50301	6	applied	\N	\N	\N	\N	151468	151468	151469
29907	50302	7	applied	\N	\N	\N	\N	151470	151470	151471
29907	50303	8	applied	\N	\N	\N	\N	151472	151472	91559
29907	50304	9	applied	\N	\N	\N	\N	151473	151473	151474
29907	50305	10	applied	\N	\N	\N	\N	151475	151475	151476
29909	50307	0	applied	\N	\N	\N	\N	151483	151483	91601
29909	50306	1	applied	\N	\N	\N	\N	151480	151480	151484
29909	50308	2	applied	\N	\N	\N	\N	151485	151485	151486
29909	50309	3	applied	\N	\N	\N	\N	151487	151487	91704
29912	50315	0	applied	\N	\N	\N	\N	151499	151499	151500
29912	50316	1	applied	\N	\N	\N	\N	151501	151501	91632
29912	50317	2	applied	\N	\N	\N	\N	151502	151502	91636
29912	50318	3	applied	\N	\N	\N	\N	151503	151503	151504
29912	50320	4	applied	\N	\N	\N	\N	151506	151506	91641
29912	50321	5	applied	\N	\N	\N	\N	151508	151508	91649
29912	50322	6	applied	\N	\N	\N	\N	151510	151510	91711
29912	50323	7	applied	\N	\N	\N	\N	151511	151511	91713
29914	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29914	50158	1	applied	\N	\N	\N	\N	151195	151195	151196
29914	49582	2	applied	\N	\N	\N	\N	150076	150076	150077
29914	49583	3	applied	\N	\N	\N	\N	150078	150078	151518
29914	50273	4	applied	\N	\N	\N	\N	151402	151402	151402
29914	50277	5	applied	\N	\N	\N	\N	151417	151417	151417
29914	50299	6	applied	\N	\N	\N	\N	151466	151466	151466
29914	49593	7	applied	\N	\N	\N	\N	150097	150097	151519
29924	50352	0	applied	\N	\N	\N	\N	151595	151595	151596
29924	50353	1	applied	\N	\N	\N	\N	151597	151597	151598
29924	50354	2	applied	\N	\N	\N	\N	151599	151599	91893
29924	50355	3	applied	\N	\N	\N	\N	151600	151600	91881
29924	50356	4	applied	\N	\N	\N	\N	151601	151601	151602
29924	50357	5	applied	\N	\N	\N	\N	151603	151603	91899
29924	50358	6	applied	\N	\N	\N	\N	151604	151604	91905
29924	50359	7	applied	\N	\N	\N	\N	151605	151605	92540
29927	50360	0	applied	\N	\N	\N	\N	151609	151609	151610
29927	50361	1	applied	\N	\N	\N	\N	151611	151611	151612
29927	50365	2	applied	\N	\N	\N	\N	151619	151619	91918
29927	50366	3	applied	\N	\N	\N	\N	151620	151620	91920
29927	50367	4	applied	\N	\N	\N	\N	151621	151621	91934
29927	50368	5	applied	\N	\N	\N	\N	151622	151622	92548
29927	50362	6	applied	\N	\N	\N	\N	151613	151613	91936
29927	50363	7	applied	\N	\N	\N	\N	151614	151614	151623
29927	50364	8	applied	\N	\N	\N	\N	151616	151616	91948
29927	50369	9	applied	\N	\N	\N	\N	151624	151624	151625
29927	50370	10	applied	\N	\N	\N	\N	151626	151626	151627
29927	50371	11	applied	\N	\N	\N	\N	151628	151628	151629
29927	50372	12	applied	\N	\N	\N	\N	151630	151630	92549
29927	50373	13	applied	\N	\N	\N	\N	151631	151631	91963
29927	50374	14	applied	\N	\N	\N	\N	151632	151632	91975
29927	50375	15	applied	\N	\N	\N	\N	151633	151633	92553
29927	50376	16	applied	\N	\N	\N	\N	151634	151634	92555
29927	50377	17	applied	\N	\N	\N	\N	151635	151635	92557
29927	50378	18	applied	\N	\N	\N	\N	151636	151636	91993
29929	50379	0	applied	\N	\N	\N	\N	151642	151642	151643
29929	50380	1	applied	\N	\N	\N	\N	151644	151644	91918
29929	50365	2	applied	\N	\N	\N	\N	151619	151619	91934
29929	50366	3	applied	\N	\N	\N	\N	151620	151620	92548
29929	50367	4	applied	\N	\N	\N	\N	151621	151621	151623
29929	50368	5	applied	\N	\N	\N	\N	151622	151622	151645
29929	50369	6	applied	\N	\N	\N	\N	151624	151624	91950
29929	50370	7	applied	\N	\N	\N	\N	151626	151626	151646
29929	50381	8	applied	\N	\N	\N	\N	151647	151647	151648
29929	50382	9	applied	\N	\N	\N	\N	151649	151649	91954
29929	50371	10	applied	\N	\N	\N	\N	151628	151628	91958
29929	50372	11	applied	\N	\N	\N	\N	151630	151630	151650
29929	50373	12	applied	\N	\N	\N	\N	151631	151631	92551
29929	50374	13	applied	\N	\N	\N	\N	151632	151632	92554
29929	50375	14	applied	\N	\N	\N	\N	151633	151633	91981
29929	50376	15	applied	\N	\N	\N	\N	151634	151634	91985
29929	50377	16	applied	\N	\N	\N	\N	151635	151635	92435
29929	50378	17	applied	\N	\N	\N	\N	151636	151636	92436
29929	50383	18	applied	\N	\N	\N	\N	151651	151651	92050
29929	50384	19	applied	\N	\N	\N	\N	151652	151652	92438
29929	50385	20	applied	\N	\N	\N	\N	151653	151653	92440
29929	50386	21	applied	\N	\N	\N	\N	151654	151654	92082
29929	50387	22	applied	\N	\N	\N	\N	151655	151655	92086
29929	50388	23	applied	\N	\N	\N	\N	151656	151656	92444
29935	50404	0	applied	\N	\N	\N	\N	151734	151734	151735
29935	50405	1	applied	\N	\N	\N	\N	151736	151736	151737
29935	50406	2	applied	\N	\N	\N	\N	151738	151738	92453
29935	50407	3	applied	\N	\N	\N	\N	151739	151739	92132
29935	50408	4	applied	\N	\N	\N	\N	151740	151740	92128
29935	50409	5	applied	\N	\N	\N	\N	151741	151741	92133
29935	50410	6	applied	\N	\N	\N	\N	151742	151742	92454
29935	50411	7	applied	\N	\N	\N	\N	151743	151743	92155
29935	50412	8	applied	\N	\N	\N	\N	151744	151744	92156
29935	50413	9	applied	\N	\N	\N	\N	151745	151745	92158
29937	50404	0	applied	\N	\N	\N	\N	151734	151734	151735
29937	50405	1	applied	\N	\N	\N	\N	151736	151736	151737
29937	50406	2	applied	\N	\N	\N	\N	151738	151738	92453
29937	50407	3	applied	\N	\N	\N	\N	151739	151739	92132
29937	50408	4	applied	\N	\N	\N	\N	151740	151740	92128
29937	50409	5	applied	\N	\N	\N	\N	151741	151741	92133
29937	50410	6	applied	\N	\N	\N	\N	151742	151742	92454
29937	50411	7	applied	\N	\N	\N	\N	151743	151743	92155
29937	50412	8	applied	\N	\N	\N	\N	151744	151744	92156
29937	50413	9	applied	\N	\N	\N	\N	151745	151745	92158
29939	50414	0	applied	\N	\N	\N	\N	151761	151761	151762
29939	50415	1	applied	\N	\N	\N	\N	151763	151763	92160
29939	50416	2	applied	\N	\N	\N	\N	151764	151764	92455
29939	50417	3	applied	\N	\N	\N	\N	151765	151765	92168
29939	50418	4	applied	\N	\N	\N	\N	151766	151766	151767
29954	50480	0	applied	\N	\N	\N	\N	151880	151880	151881
29954	50481	1	applied	\N	\N	\N	\N	151882	151882	151883
29954	50482	2	applied	\N	\N	\N	\N	151884	151884	92601
29954	50483	3	applied	\N	\N	\N	\N	151885	151885	92605
29954	50484	4	applied	\N	\N	\N	\N	151886	151886	92609
29954	50485	5	applied	\N	\N	\N	\N	151887	151887	151888
29954	50486	6	applied	\N	\N	\N	\N	151889	151889	92611
29954	50487	7	applied	\N	\N	\N	\N	151890	151890	92613
29954	50488	8	applied	\N	\N	\N	\N	151891	151891	92617
29954	50489	9	applied	\N	\N	\N	\N	151892	151892	92626
29918	50343	0	applied	\N	\N	\N	\N	151553	151553	151554
29918	50344	1	applied	\N	\N	\N	\N	151555	151555	91786
29918	50345	2	applied	\N	\N	\N	\N	151556	151556	151557
29918	50346	3	applied	\N	\N	\N	\N	151558	151558	91788
29925	50360	0	applied	\N	\N	\N	\N	151609	151609	151610
29925	50361	1	applied	\N	\N	\N	\N	151611	151611	151612
29925	50362	2	applied	\N	\N	\N	\N	151613	151613	91912
29925	50363	3	applied	\N	\N	\N	\N	151614	151614	151615
29925	50364	4	applied	\N	\N	\N	\N	151616	151616	92060
29932	50389	0	applied	\N	\N	\N	\N	151698	151698	151699
29932	50390	1	applied	\N	\N	\N	\N	151700	151700	151701
29932	50391	2	applied	\N	\N	\N	\N	151702	151702	151703
29932	50392	3	applied	\N	\N	\N	\N	151704	151704	92090
29932	50393	4	applied	\N	\N	\N	\N	151705	151705	151706
29932	50394	5	applied	\N	\N	\N	\N	151707	151707	92100
29932	50395	6	applied	\N	\N	\N	\N	151708	151708	151709
29932	50396	7	applied	\N	\N	1000000000	\N	151710	151710	151711
29932	50397	8	applied	\N	\N	1000000000	\N	151712	151712	151713
29932	50398	9	applied	\N	\N	\N	\N	151714	151714	92102
29932	50399	10	applied	\N	\N	\N	\N	151715	151715	151716
29932	50400	11	applied	\N	\N	\N	\N	151717	151717	93248
29932	50401	12	applied	\N	\N	\N	\N	151718	151718	92112
29932	50402	13	applied	\N	\N	\N	\N	151719	151719	92114
29932	50403	14	applied	\N	\N	\N	\N	151720	151720	92116
29934	50404	0	applied	\N	\N	\N	\N	151734	151734	151735
29934	50405	1	applied	\N	\N	\N	\N	151736	151736	151737
29934	50406	2	applied	\N	\N	\N	\N	151738	151738	92453
29934	50407	3	applied	\N	\N	\N	\N	151739	151739	92132
29934	50408	4	applied	\N	\N	\N	\N	151740	151740	92128
29934	50409	5	applied	\N	\N	\N	\N	151741	151741	92133
29934	50410	6	applied	\N	\N	\N	\N	151742	151742	92454
29934	50411	7	applied	\N	\N	\N	\N	151743	151743	92155
29934	50412	8	applied	\N	\N	\N	\N	151744	151744	92156
29934	50413	9	applied	\N	\N	\N	\N	151745	151745	92158
29936	50404	0	applied	\N	\N	\N	\N	151734	151734	151735
29936	50405	1	applied	\N	\N	\N	\N	151736	151736	151737
29936	50406	2	applied	\N	\N	\N	\N	151738	151738	92453
29936	50407	3	applied	\N	\N	\N	\N	151739	151739	92132
29936	50408	4	applied	\N	\N	\N	\N	151740	151740	92128
29936	50409	5	applied	\N	\N	\N	\N	151741	151741	92133
29936	50410	6	applied	\N	\N	\N	\N	151742	151742	92454
29936	50411	7	applied	\N	\N	\N	\N	151743	151743	92155
29936	50412	8	applied	\N	\N	\N	\N	151744	151744	92156
29936	50413	9	applied	\N	\N	\N	\N	151745	151745	92158
29950	50452	0	applied	\N	\N	\N	\N	151829	151829	151830
29950	50453	1	applied	\N	\N	\N	\N	151831	151831	151832
29950	50454	2	applied	\N	\N	\N	\N	151833	151833	151834
29950	50455	3	applied	\N	\N	\N	\N	151835	151835	92365
29950	50456	4	applied	\N	\N	\N	\N	151836	151836	151837
29950	50457	5	applied	\N	\N	\N	\N	151838	151838	151839
29950	50458	6	applied	\N	\N	\N	\N	151840	151840	151841
29950	50459	7	applied	\N	\N	\N	\N	151842	151842	151843
29950	50460	8	applied	\N	\N	\N	\N	151844	151844	92385
29950	50461	9	applied	\N	\N	\N	\N	151845	151845	92398
29950	50462	10	applied	\N	\N	\N	\N	151846	151846	151847
29950	50463	11	applied	\N	\N	\N	\N	151848	151848	151849
29950	50464	12	applied	\N	\N	\N	\N	151850	151850	92408
29950	50465	13	applied	\N	\N	\N	\N	151851	151851	151852
29950	50466	14	applied	\N	\N	\N	\N	151853	151853	92426
29950	50467	15	applied	\N	\N	\N	\N	151854	151854	151855
29950	50468	16	applied	\N	\N	\N	\N	151856	151856	92486
29950	50469	17	applied	\N	\N	\N	\N	151857	151857	151858
29950	50470	18	applied	\N	\N	\N	\N	151859	151859	92501
29963	50511	0	applied	\N	\N	\N	\N	151948	151948	151949
29963	50512	1	applied	\N	\N	\N	\N	151950	151950	151951
29963	50513	2	applied	\N	\N	\N	\N	151952	151952	92710
29963	50514	3	applied	\N	\N	\N	\N	151953	151953	92716
29963	50515	4	applied	\N	\N	\N	\N	151954	151954	151955
29967	50535	0	applied	\N	\N	\N	\N	151993	151993	151994
29967	50533	1	applied	\N	\N	\N	\N	151988	151988	92851
29967	50534	2	applied	\N	\N	\N	\N	151989	151989	151990
29967	50536	3	applied	\N	\N	\N	\N	151995	151995	151996
29967	50537	4	applied	\N	\N	\N	\N	151997	151997	151998
29967	50538	5	applied	\N	\N	\N	\N	151999	151999	92863
29967	50539	6	applied	\N	\N	\N	\N	152000	152000	152001
29967	50540	7	applied	\N	\N	\N	\N	152002	152002	152003
29967	50541	8	applied	\N	\N	\N	\N	152004	152004	92903
29967	50542	9	applied	\N	\N	\N	\N	152005	152005	93350
29967	50543	10	applied	\N	\N	\N	\N	152006	152006	92920
29967	50544	11	applied	\N	\N	\N	\N	152007	152007	93352
29967	50545	12	applied	\N	\N	\N	\N	152008	152008	93355
29969	50546	0	applied	\N	\N	\N	\N	152013	152013	152014
29969	50547	1	applied	\N	\N	\N	\N	152015	152015	93356
29969	50548	2	applied	\N	\N	\N	\N	152016	152016	93359
29969	50549	3	applied	\N	\N	\N	\N	152017	152017	152018
29969	50550	4	applied	\N	\N	\N	\N	152019	152019	152020
29969	50551	5	applied	\N	\N	\N	\N	152021	152021	152022
29969	50552	6	applied	\N	\N	\N	\N	152023	152023	92980
29969	50553	7	applied	\N	\N	\N	\N	152024	152024	92982
29969	50554	8	applied	\N	\N	\N	\N	152025	152025	92990
29976	50555	0	applied	\N	\N	\N	\N	152033	152033	152034
29976	50556	1	applied	\N	\N	\N	\N	152035	152035	152036
29976	50557	2	applied	\N	\N	\N	\N	152037	152037	152038
29976	50558	3	applied	\N	\N	\N	\N	152039	152039	92994
29976	50559	4	applied	\N	\N	\N	\N	152040	152040	92998
29976	50564	5	applied	\N	\N	\N	\N	152047	152047	93366
29976	50565	6	applied	\N	\N	\N	\N	152049	152049	152065
29976	50566	7	applied	\N	\N	\N	\N	152050	152050	93004
29976	50572	8	applied	\N	\N	\N	\N	152059	152059	93008
29980	50612	0	applied	\N	\N	\N	\N	152138	152138	152139
29980	50613	1	applied	\N	\N	\N	\N	152140	152140	93558
29980	50614	2	applied	\N	\N	\N	\N	152141	152141	152142
29980	50615	3	applied	\N	\N	\N	\N	152143	152143	93447
29980	50616	4	applied	\N	\N	\N	\N	152144	152144	93449
29980	50617	5	applied	\N	\N	\N	\N	152145	152145	152146
29980	50618	6	applied	\N	\N	\N	\N	152147	152147	152148
29980	50619	7	applied	\N	\N	\N	\N	152149	152149	93463
29980	50620	8	applied	\N	\N	\N	\N	152150	152150	152151
29980	50621	9	applied	\N	\N	\N	\N	152152	152152	93471
29982	50612	0	applied	\N	\N	\N	\N	152138	152138	152139
29982	50613	1	applied	\N	\N	\N	\N	152140	152140	93558
29982	50614	2	applied	\N	\N	\N	\N	152141	152141	152142
29982	50615	3	applied	\N	\N	\N	\N	152143	152143	93447
29982	50616	4	applied	\N	\N	\N	\N	152144	152144	93449
29982	50617	5	applied	\N	\N	\N	\N	152145	152145	152146
29982	50618	6	applied	\N	\N	\N	\N	152147	152147	152148
29982	50619	7	applied	\N	\N	\N	\N	152149	152149	93463
29982	50620	8	applied	\N	\N	\N	\N	152150	152150	152151
29982	50621	9	applied	\N	\N	\N	\N	152152	152152	93471
29920	50283	16	applied	\N	\N	\N	\N	151425	151425	151426
29920	50287	17	applied	\N	\N	\N	\N	151434	151434	151429
29920	50289	18	applied	\N	\N	\N	\N	151437	151437	91506
29920	50290	19	applied	\N	\N	\N	\N	151438	151438	151570
29920	50291	20	applied	\N	\N	\N	\N	151439	151439	91522
29920	50299	21	applied	\N	\N	\N	\N	151466	151466	151466
29920	50292	22	applied	\N	\N	\N	\N	151441	151441	151571
29920	50296	23	applied	\N	\N	\N	\N	151461	151461	91524
29920	50300	24	applied	\N	\N	\N	\N	151467	151467	91574
29920	50306	25	applied	\N	\N	\N	\N	151480	151480	91575
29920	50318	26	applied	\N	\N	\N	\N	151503	151503	91526
29920	50319	27	applied	\N	\N	\N	\N	151505	151505	151440
29920	50328	28	applied	\N	\N	\N	\N	151526	151526	151442
29920	50336	29	applied	\N	\N	\N	\N	151540	151540	91528
29920	50337	30	applied	\N	\N	\N	\N	151542	151542	151444
29920	50345	31	applied	\N	\N	\N	\N	151556	151556	91535
29920	50284	32	applied	\N	\N	\N	\N	151427	151427	151462
29920	50285	33	applied	\N	\N	\N	\N	151428	151428	91577
29920	50288	34	applied	\N	\N	\N	\N	151435	151435	151465
29920	50301	35	applied	\N	\N	\N	\N	151468	151468	91547
29920	50302	36	applied	\N	\N	\N	\N	151470	151470	91551
29920	50303	37	applied	\N	\N	\N	\N	151472	151472	151572
29920	50304	38	applied	\N	\N	\N	\N	151473	151473	91587
29920	50305	39	applied	\N	\N	\N	\N	151475	151475	91591
29920	50311	40	applied	\N	\N	\N	\N	151491	151491	151484
29920	50312	41	applied	\N	\N	\N	\N	151492	151492	91704
29920	50313	42	applied	\N	\N	\N	\N	151493	151493	151573
29920	50314	43	applied	\N	\N	\N	\N	151495	151495	151494
29920	50317	44	applied	\N	\N	\N	\N	151502	151502	91628
29920	50321	45	applied	\N	\N	\N	\N	151508	151508	151497
29920	50322	46	applied	\N	\N	\N	\N	151510	151510	91634
29920	50323	47	applied	\N	\N	\N	\N	151511	151511	91708
29920	50324	48	applied	\N	\N	\N	\N	151513	151513	151574
29920	50329	49	applied	\N	\N	\N	\N	151527	151527	91651
29920	50330	50	applied	\N	\N	\N	\N	151528	151528	91670
29920	50331	51	applied	\N	\N	\N	\N	151529	151529	151532
29920	50332	52	applied	\N	\N	\N	\N	151533	151533	91685
29920	50334	53	applied	\N	\N	\N	\N	151538	151538	151575
29920	50335	54	applied	\N	\N	\N	\N	151539	151539	91696
29920	50293	55	applied	\N	\N	\N	\N	151443	151443	91698
29920	50294	56	applied	\N	\N	\N	\N	151445	151445	91726
29920	50297	57	applied	\N	\N	\N	\N	151463	151463	151576
29920	50298	58	applied	\N	\N	\N	\N	151464	151464	151577
29920	50307	59	applied	\N	\N	\N	\N	151483	151483	151578
29920	50308	60	applied	\N	\N	\N	\N	151485	151485	91736
29920	50309	61	applied	\N	\N	\N	\N	151487	151487	151579
29920	50316	62	applied	\N	\N	\N	\N	151501	151501	151580
29920	50320	63	applied	\N	\N	\N	\N	151506	151506	91861
29920	50326	64	applied	\N	\N	\N	\N	151524	151524	151541
29920	50327	65	applied	\N	\N	\N	\N	151525	151525	91759
29920	50338	66	applied	\N	\N	\N	\N	151543	151543	91763
29920	50339	67	applied	\N	\N	\N	\N	151545	151545	151581
29920	50340	68	applied	\N	\N	\N	\N	151547	151547	151582
29920	50344	69	applied	\N	\N	\N	\N	151555	151555	91774
29920	50346	70	applied	\N	\N	\N	\N	151558	151558	91782
29920	50341	71	applied	\N	\N	\N	\N	151548	151548	151583
29920	50342	72	applied	\N	\N	\N	\N	151550	151550	91788
29920	50347	73	applied	\N	\N	\N	\N	151560	151560	151584
29920	50348	74	applied	\N	\N	\N	\N	151561	151561	151563
29920	50349	75	applied	\N	\N	\N	\N	151564	151564	151565
29920	50350	76	applied	\N	\N	\N	\N	151566	151566	91871
29920	50351	77	applied	\N	\N	\N	\N	151567	151567	91849
29922	50352	0	applied	\N	\N	\N	\N	151595	151595	151596
29922	50353	1	applied	\N	\N	\N	\N	151597	151597	151598
29922	50354	2	applied	\N	\N	\N	\N	151599	151599	91893
29922	50355	3	applied	\N	\N	\N	\N	151600	151600	91881
29922	50356	4	applied	\N	\N	\N	\N	151601	151601	151602
29922	50357	5	applied	\N	\N	\N	\N	151603	151603	91899
29922	50358	6	applied	\N	\N	\N	\N	151604	151604	91905
29922	50359	7	applied	\N	\N	\N	\N	151605	151605	92540
29926	50360	0	applied	\N	\N	\N	\N	151609	151609	151610
29926	50361	1	applied	\N	\N	\N	\N	151611	151611	151612
29926	50365	2	applied	\N	\N	\N	\N	151619	151619	91918
29926	50366	3	applied	\N	\N	\N	\N	151620	151620	91920
29926	50367	4	applied	\N	\N	\N	\N	151621	151621	91934
29926	50368	5	applied	\N	\N	\N	\N	151622	151622	92548
29926	50362	6	applied	\N	\N	\N	\N	151613	151613	91936
29926	50363	7	applied	\N	\N	\N	\N	151614	151614	151623
29926	50364	8	applied	\N	\N	\N	\N	151616	151616	91948
29926	50369	9	applied	\N	\N	\N	\N	151624	151624	151625
29926	50370	10	applied	\N	\N	\N	\N	151626	151626	151627
29926	50371	11	applied	\N	\N	\N	\N	151628	151628	151629
29926	50372	12	applied	\N	\N	\N	\N	151630	151630	92549
29926	50373	13	applied	\N	\N	\N	\N	151631	151631	91963
29926	50374	14	applied	\N	\N	\N	\N	151632	151632	91975
29926	50375	15	applied	\N	\N	\N	\N	151633	151633	92553
29926	50376	16	applied	\N	\N	\N	\N	151634	151634	92555
29926	50377	17	applied	\N	\N	\N	\N	151635	151635	92557
29926	50378	18	applied	\N	\N	\N	\N	151636	151636	91993
29928	50360	0	applied	\N	\N	\N	\N	151609	151609	151610
29928	50361	1	applied	\N	\N	\N	\N	151611	151611	151612
29928	50365	2	applied	\N	\N	\N	\N	151619	151619	91918
29928	50366	3	applied	\N	\N	\N	\N	151620	151620	91920
29928	50367	4	applied	\N	\N	\N	\N	151621	151621	91934
29928	50368	5	applied	\N	\N	\N	\N	151622	151622	92548
29928	50362	6	applied	\N	\N	\N	\N	151613	151613	91936
29928	50363	7	applied	\N	\N	\N	\N	151614	151614	151623
29928	50364	8	applied	\N	\N	\N	\N	151616	151616	91948
29928	50369	9	applied	\N	\N	\N	\N	151624	151624	151625
29928	50370	10	applied	\N	\N	\N	\N	151626	151626	151627
29928	50371	11	applied	\N	\N	\N	\N	151628	151628	151629
29928	50372	12	applied	\N	\N	\N	\N	151630	151630	92549
29928	50373	13	applied	\N	\N	\N	\N	151631	151631	91963
29928	50374	14	applied	\N	\N	\N	\N	151632	151632	91975
29928	50375	15	applied	\N	\N	\N	\N	151633	151633	92553
29928	50376	16	applied	\N	\N	\N	\N	151634	151634	92555
29928	50377	17	applied	\N	\N	\N	\N	151635	151635	92557
29928	50378	18	applied	\N	\N	\N	\N	151636	151636	91993
29930	50265	0	applied	\N	\N	\N	\N	151391	151391	151392
29930	50207	1	applied	\N	\N	\N	\N	151282	151282	151283
29930	50208	2	applied	\N	\N	\N	\N	151284	151284	151285
29930	50227	3	applied	\N	\N	\N	\N	151317	151317	151318
29930	50236	4	applied	\N	\N	\N	\N	151334	151334	151335
29930	50246	5	applied	\N	\N	\N	\N	151354	151354	151355
29930	50255	6	applied	\N	\N	\N	\N	151372	151372	151373
29930	50266	7	applied	\N	\N	\N	\N	151393	151393	151394
29930	50275	8	applied	\N	\N	\N	\N	151413	151413	151414
29930	50286	9	applied	\N	\N	\N	\N	151432	151432	151433
29930	50295	10	applied	\N	\N	\N	\N	151459	151459	151460
29930	50310	11	applied	\N	\N	\N	\N	151489	151489	151490
29923	50359	7	applied	\N	\N	\N	\N	151605	151605	92540
29938	50360	0	applied	\N	\N	\N	\N	151609	151609	151610
29938	50361	1	applied	\N	\N	\N	\N	151611	151611	151612
29938	50379	2	applied	\N	\N	\N	\N	151642	151642	151643
29938	50389	3	applied	\N	\N	\N	\N	151698	151698	151699
29938	50390	4	applied	\N	\N	\N	\N	151700	151700	151701
29938	50404	5	applied	\N	\N	\N	\N	151734	151734	151735
29938	50405	6	applied	\N	\N	\N	\N	151736	151736	151737
29938	50365	7	applied	\N	\N	\N	\N	151619	151619	91918
29938	50366	8	applied	\N	\N	\N	\N	151620	151620	91920
29938	50367	9	applied	\N	\N	\N	\N	151621	151621	91934
29938	50368	10	applied	\N	\N	\N	\N	151622	151622	92548
29938	50362	11	applied	\N	\N	\N	\N	151613	151613	91936
29938	50363	12	applied	\N	\N	\N	\N	151614	151614	151623
29938	50364	13	applied	\N	\N	\N	\N	151616	151616	91948
29938	50380	14	applied	\N	\N	\N	\N	151644	151644	151645
29938	50369	15	applied	\N	\N	\N	\N	151624	151624	91950
29938	50370	16	applied	\N	\N	\N	\N	151626	151626	151646
29938	50381	17	applied	\N	\N	\N	\N	151647	151647	151648
29938	50382	18	applied	\N	\N	\N	\N	151649	151649	91954
29938	50371	19	applied	\N	\N	\N	\N	151628	151628	91958
29938	50372	20	applied	\N	\N	\N	\N	151630	151630	151650
29938	50373	21	applied	\N	\N	\N	\N	151631	151631	92551
29938	50374	22	applied	\N	\N	\N	\N	151632	151632	92554
29938	50375	23	applied	\N	\N	\N	\N	151633	151633	91981
29938	50376	24	applied	\N	\N	\N	\N	151634	151634	91985
29938	50377	25	applied	\N	\N	\N	\N	151635	151635	92435
29938	50378	26	applied	\N	\N	\N	\N	151636	151636	92436
29938	50383	27	applied	\N	\N	\N	\N	151651	151651	92050
29938	50384	28	applied	\N	\N	\N	\N	151652	151652	92438
29938	50385	29	applied	\N	\N	\N	\N	151653	151653	92440
29938	50386	30	applied	\N	\N	\N	\N	151654	151654	92082
29938	50387	31	applied	\N	\N	\N	\N	151655	151655	92086
29938	50392	33	applied	\N	\N	\N	\N	151704	151704	151750
29938	50393	34	applied	\N	\N	\N	\N	151705	151705	151751
29938	50396	35	applied	\N	\N	1000000000	\N	151710	151710	151711
29938	50397	36	applied	\N	\N	1000000000	\N	151712	151712	151713
29938	50388	37	applied	\N	\N	\N	\N	151656	151656	92092
29938	50391	38	applied	\N	\N	\N	\N	151702	151702	151706
29938	50394	39	applied	\N	\N	\N	\N	151707	151707	92100
29938	50395	40	applied	\N	\N	\N	\N	151708	151708	151709
29938	50406	41	applied	\N	\N	\N	\N	151738	151738	92448
29938	50407	42	applied	\N	\N	\N	\N	151739	151739	92102
29938	50408	43	applied	\N	\N	\N	\N	151740	151740	92449
29938	50398	44	applied	\N	\N	\N	\N	151714	151714	92110
29938	50399	45	applied	\N	\N	\N	\N	151715	151715	92450
29938	50400	46	applied	\N	\N	\N	\N	151717	151717	92451
29938	50401	47	applied	\N	\N	\N	\N	151718	151718	92452
29938	50402	48	applied	\N	\N	\N	\N	151719	151719	92453
29938	50403	49	applied	\N	\N	\N	\N	151720	151720	92128
29938	50409	50	applied	\N	\N	\N	\N	151741	151741	92133
29938	50410	51	applied	\N	\N	\N	\N	151742	151742	92454
29938	50411	52	applied	\N	\N	\N	\N	151743	151743	92155
29938	50412	53	applied	\N	\N	\N	\N	151744	151744	92156
29938	50413	54	applied	\N	\N	\N	\N	151745	151745	92158
29940	50419	0	applied	\N	\N	\N	\N	151769	151769	151770
29940	50420	1	applied	\N	\N	\N	\N	151771	151771	151772
29940	50421	2	applied	\N	\N	\N	\N	151773	151773	92180
29940	50422	3	applied	\N	\N	\N	\N	151774	151774	92457
29940	50423	4	applied	\N	\N	\N	\N	151775	151775	92184
29940	50424	5	applied	\N	\N	\N	\N	151776	151776	92197
29944	50425	0	applied	\N	\N	\N	\N	151779	151779	92459
29944	50426	1	applied	\N	\N	\N	\N	151780	151780	92461
29944	50427	2	applied	\N	\N	\N	\N	151781	151781	92211
29944	50428	3	applied	\N	\N	\N	\N	151782	151782	92213
29944	50429	4	applied	\N	\N	\N	\N	151783	151783	151784
29944	50430	5	applied	\N	\N	\N	\N	151785	151785	151786
29944	50431	6	applied	\N	\N	\N	\N	151787	151787	92229
29946	50432	0	applied	\N	\N	\N	\N	151790	151790	151791
29946	50433	1	applied	\N	\N	\N	\N	151794	151794	151795
29946	50434	2	applied	\N	\N	\N	\N	151796	151796	92251
29946	50435	3	applied	\N	\N	\N	\N	151797	151797	151798
29946	50436	4	applied	\N	\N	\N	\N	151799	151799	92466
29946	50437	5	applied	\N	\N	\N	\N	151800	151800	151801
29946	50438	6	applied	\N	\N	\N	\N	151802	151802	151803
29946	50439	7	applied	\N	\N	\N	\N	151804	151804	92467
29946	50440	8	applied	\N	\N	\N	\N	151805	151805	92271
29946	50441	9	applied	\N	\N	\N	\N	151806	151806	92288
29946	50442	10	applied	\N	\N	\N	\N	151807	151807	92471
29948	50432	0	applied	\N	\N	\N	\N	151790	151790	151791
29948	50433	1	applied	\N	\N	\N	\N	151794	151794	151795
29948	50434	2	applied	\N	\N	\N	\N	151796	151796	92251
29948	50435	3	applied	\N	\N	\N	\N	151797	151797	151798
29948	50436	4	applied	\N	\N	\N	\N	151799	151799	92466
29948	50437	5	applied	\N	\N	\N	\N	151800	151800	151801
29948	50438	6	applied	\N	\N	\N	\N	151802	151802	151803
29948	50439	7	applied	\N	\N	\N	\N	151804	151804	92467
29948	50440	8	applied	\N	\N	\N	\N	151805	151805	92271
29948	50441	9	applied	\N	\N	\N	\N	151806	151806	92288
29948	50442	10	applied	\N	\N	\N	\N	151807	151807	92471
29956	50490	0	applied	\N	\N	\N	\N	151897	151897	151898
29956	50491	1	applied	\N	\N	\N	\N	151899	151899	92648
29956	50492	3	applied	\N	\N	\N	\N	151901	151901	92634
29956	50493	4	applied	\N	\N	\N	\N	151902	151902	93195
29956	50494	5	applied	\N	\N	\N	\N	151903	151903	92655
29956	50495	6	applied	\N	\N	\N	\N	151904	151904	92657
29956	50496	7	applied	\N	\N	\N	\N	151905	151905	93197
29956	50497	8	applied	\N	\N	\N	\N	151906	151906	92661
29956	50498	9	applied	\N	\N	\N	\N	151907	151907	92671
29956	50499	10	applied	\N	\N	\N	\N	151908	151908	93202
29958	50500	0	applied	\N	\N	\N	\N	151921	151921	151922
29958	50501	1	applied	\N	\N	\N	\N	151923	151923	151924
29958	50502	2	applied	\N	\N	\N	\N	151925	151925	151926
29958	50503	3	applied	\N	\N	\N	\N	151927	151927	151928
29958	50504	4	applied	\N	\N	\N	\N	151929	151929	93205
29958	50505	5	applied	\N	\N	\N	\N	151930	151930	151931
29960	50507	0	applied	\N	\N	\N	\N	151940	151940	151941
29960	50508	1	applied	\N	\N	\N	\N	151942	151942	92702
29960	50509	2	applied	\N	\N	\N	\N	151943	151943	151944
29960	50510	3	applied	\N	\N	\N	\N	151945	151945	92708
29971	50546	0	applied	\N	\N	\N	\N	152013	152013	152014
29971	50547	1	applied	\N	\N	\N	\N	152015	152015	93356
29971	50548	2	applied	\N	\N	\N	\N	152016	152016	93359
29971	50549	3	applied	\N	\N	\N	\N	152017	152017	152018
29971	50550	4	applied	\N	\N	\N	\N	152019	152019	152020
29971	50551	5	applied	\N	\N	\N	\N	152021	152021	152022
29971	50552	6	applied	\N	\N	\N	\N	152023	152023	92980
29971	50553	7	applied	\N	\N	\N	\N	152024	152024	92982
29971	50554	8	applied	\N	\N	\N	\N	152025	152025	92990
29930	50315	12	applied	\N	\N	\N	\N	151499	151499	151500
29930	50325	13	applied	\N	\N	\N	\N	151522	151522	151523
29930	50333	14	applied	\N	\N	\N	\N	151536	151536	151537
29930	50343	15	applied	\N	\N	\N	\N	151553	151553	151554
29930	50352	16	applied	\N	\N	\N	\N	151595	151595	151596
29930	50360	17	applied	\N	\N	\N	\N	151609	151609	151610
29930	50361	18	applied	\N	\N	\N	\N	151611	151611	151612
29930	50379	19	applied	\N	\N	\N	\N	151642	151642	151643
29930	50209	20	applied	\N	\N	\N	\N	151286	151286	91123
29930	50210	21	applied	\N	\N	\N	\N	151287	151287	91125
29930	50211	22	applied	\N	\N	\N	\N	151288	151288	91137
29930	50212	23	applied	\N	\N	\N	\N	151289	151289	91138
29930	50213	24	applied	\N	\N	\N	\N	151290	151290	151291
29930	50214	25	applied	\N	\N	\N	\N	151292	151292	91140
29930	50273	26	applied	\N	\N	\N	\N	151402	151402	151402
29930	50277	27	applied	\N	\N	\N	\N	151417	151417	151417
29930	50299	28	applied	\N	\N	\N	\N	151466	151466	151466
29930	50215	29	applied	\N	\N	\N	\N	151293	151293	151294
29930	50228	30	applied	\N	\N	\N	\N	151319	151319	91150
29930	50239	31	applied	\N	\N	\N	\N	151340	151340	151296
29930	50242	32	applied	\N	\N	\N	\N	151346	151346	91153
29930	50216	33	applied	\N	\N	\N	\N	151295	151295	151659
29930	50217	34	applied	\N	\N	\N	\N	151297	151297	151660
29930	50229	35	applied	\N	\N	\N	\N	151320	151320	91157
29930	50253	36	applied	\N	\N	\N	\N	151366	151366	151661
29930	50261	37	applied	\N	\N	\N	\N	151380	151380	91178
29930	50262	38	applied	\N	\N	\N	\N	151382	151382	91171
29930	50269	39	applied	\N	\N	\N	\N	151397	151397	151662
29930	50276	40	applied	\N	\N	\N	\N	151415	151415	91179
29930	50283	41	applied	\N	\N	\N	\N	151425	151425	91173
29930	50292	42	applied	\N	\N	\N	\N	151441	151441	91175
29930	50296	43	applied	\N	\N	\N	\N	151461	151461	91180
29930	50300	44	applied	\N	\N	\N	\N	151467	151467	151663
29930	50306	45	applied	\N	\N	\N	\N	151480	151480	91182
29930	50318	46	applied	\N	\N	\N	\N	151503	151503	91183
29930	50319	47	applied	\N	\N	\N	\N	151505	151505	151664
29930	50328	48	applied	\N	\N	\N	\N	151526	151526	91195
29930	50336	49	applied	\N	\N	\N	\N	151540	151540	151665
29930	50337	50	applied	\N	\N	\N	\N	151542	151542	151305
29930	50345	51	applied	\N	\N	\N	\N	151556	151556	91197
29930	50353	52	applied	\N	\N	\N	\N	151597	151597	151666
29930	50362	53	applied	\N	\N	\N	\N	151613	151613	151667
29930	50363	54	applied	\N	\N	\N	\N	151614	151614	91209
29930	50364	55	applied	\N	\N	\N	\N	151616	151616	151668
29930	50380	56	applied	\N	\N	\N	\N	151644	151644	91211
29930	50235	57	applied	\N	\N	\N	\N	151330	151330	91213
29930	50237	58	applied	\N	\N	\N	\N	151336	151336	91215
29930	50243	59	applied	\N	\N	\N	\N	151347	151347	151309
29930	50244	60	applied	\N	\N	\N	\N	151348	151348	91219
29930	50247	61	applied	\N	\N	\N	\N	151356	151356	151311
29930	50248	62	applied	\N	\N	\N	\N	151358	151358	151669
29930	50254	63	applied	\N	\N	\N	\N	151368	151368	151670
29930	50256	64	applied	\N	\N	\N	\N	151374	151374	151671
29930	50260	65	applied	\N	\N	\N	\N	151379	151379	91232
29930	50268	66	applied	\N	\N	\N	\N	151396	151396	151672
29930	50274	67	applied	\N	\N	\N	\N	151403	151403	91240
29930	50284	68	applied	\N	\N	\N	\N	151427	151427	91242
29930	50285	69	applied	\N	\N	\N	\N	151428	151428	151673
29930	50288	70	applied	\N	\N	\N	\N	151435	151435	151674
29930	50293	71	applied	\N	\N	\N	\N	151443	151443	151675
29930	50294	72	applied	\N	\N	\N	\N	151445	151445	151676
29930	50297	73	applied	\N	\N	\N	\N	151463	151463	91258
29930	50298	74	applied	\N	\N	\N	\N	151464	151464	151677
29930	50307	75	applied	\N	\N	\N	\N	151483	151483	91265
29930	50308	76	applied	\N	\N	\N	\N	151485	151485	91267
29930	50309	77	applied	\N	\N	\N	\N	151487	151487	151341
29930	50316	78	applied	\N	\N	\N	\N	151501	151501	151678
29930	50320	79	applied	\N	\N	\N	\N	151506	151506	151343
29930	50326	80	applied	\N	\N	\N	\N	151524	151524	91281
29930	50327	81	applied	\N	\N	\N	\N	151525	151525	151345
29930	50338	82	applied	\N	\N	\N	\N	151543	151543	151679
29930	50339	83	applied	\N	\N	\N	\N	151545	151545	151680
29930	50340	84	applied	\N	\N	\N	\N	151547	151547	91293
29930	50344	85	applied	\N	\N	\N	\N	151555	151555	151681
29930	50346	86	applied	\N	\N	\N	\N	151558	151558	91303
29930	50354	87	applied	\N	\N	\N	\N	151599	151599	91305
29930	50355	88	applied	\N	\N	\N	\N	151600	151600	91307
29930	50366	89	applied	\N	\N	\N	\N	151620	151620	151682
29930	50367	90	applied	\N	\N	\N	\N	151621	151621	151683
29930	50368	92	applied	\N	\N	\N	\N	151622	151622	151685
29930	50369	93	applied	\N	\N	\N	\N	151624	151624	91315
29930	50370	94	applied	\N	\N	\N	\N	151626	151626	151686
29930	50381	95	applied	\N	\N	\N	\N	151647	151647	151687
29933	50389	0	applied	\N	\N	\N	\N	151698	151698	151699
29933	50390	1	applied	\N	\N	\N	\N	151700	151700	151701
29933	50391	2	applied	\N	\N	\N	\N	151702	151702	151703
29933	50392	3	applied	\N	\N	\N	\N	151704	151704	92090
29933	50393	4	applied	\N	\N	\N	\N	151705	151705	151706
29933	50394	5	applied	\N	\N	\N	\N	151707	151707	92100
29933	50395	6	applied	\N	\N	\N	\N	151708	151708	151709
29933	50396	7	applied	\N	\N	1000000000	\N	151710	151710	151711
29933	50397	8	applied	\N	\N	1000000000	\N	151712	151712	151713
29933	50398	9	applied	\N	\N	\N	\N	151714	151714	92102
29933	50399	10	applied	\N	\N	\N	\N	151715	151715	151716
29933	50400	11	applied	\N	\N	\N	\N	151717	151717	93248
29933	50401	12	applied	\N	\N	\N	\N	151718	151718	92112
29933	50402	13	applied	\N	\N	\N	\N	151719	151719	92114
29933	50403	14	applied	\N	\N	\N	\N	151720	151720	92116
29945	50432	0	applied	\N	\N	\N	\N	151790	151790	151791
29945	50425	1	applied	\N	\N	\N	\N	151779	151779	92459
29945	50426	2	applied	\N	\N	\N	\N	151780	151780	92461
29945	50427	3	applied	\N	\N	\N	\N	151781	151781	92211
29945	50428	4	applied	\N	\N	\N	\N	151782	151782	92213
29945	50429	5	applied	\N	\N	\N	\N	151783	151783	151784
29945	50430	6	applied	\N	\N	\N	\N	151785	151785	151786
29945	50431	7	applied	\N	\N	\N	\N	151787	151787	92229
29947	50432	0	applied	\N	\N	\N	\N	151790	151790	151791
29947	50433	1	applied	\N	\N	\N	\N	151794	151794	151795
29947	50434	2	applied	\N	\N	\N	\N	151796	151796	92251
29947	50435	3	applied	\N	\N	\N	\N	151797	151797	151798
29947	50437	4	applied	\N	\N	\N	\N	151800	151800	92253
29947	50438	5	applied	\N	\N	\N	\N	151802	151802	92255
29947	50439	6	applied	\N	\N	\N	\N	151804	151804	92257
29947	50440	7	applied	\N	\N	\N	\N	151805	151805	92468
29947	50441	8	applied	\N	\N	\N	\N	151806	151806	92297
29947	50442	9	applied	\N	\N	\N	\N	151807	151807	151810
29949	50443	0	applied	\N	\N	\N	\N	151813	151813	151814
29949	50444	1	applied	\N	\N	\N	\N	151815	151815	151816
29949	50445	2	applied	\N	\N	\N	\N	151817	151817	151818
29949	50446	3	applied	\N	\N	\N	\N	151819	151819	92317
29949	50447	4	applied	\N	\N	\N	\N	151820	151820	92473
29949	50448	5	applied	\N	\N	\N	\N	151821	151821	151822
29949	50449	6	applied	\N	\N	\N	\N	151823	151823	151824
29949	50450	7	applied	\N	\N	\N	\N	151825	151825	92345
29949	50451	8	applied	\N	\N	\N	\N	151826	151826	151827
29951	50471	0	applied	\N	\N	\N	\N	151862	151862	151863
29951	50472	1	applied	\N	\N	\N	\N	151864	151864	92508
29951	50473	2	applied	\N	\N	\N	\N	151865	151865	151866
29951	50474	3	applied	\N	\N	\N	\N	151867	151867	151868
29951	50475	4	applied	\N	\N	\N	\N	151869	151869	151870
29951	50476	5	applied	\N	\N	\N	\N	151871	151871	92530
29951	50477	6	applied	\N	\N	\N	\N	151872	151872	151873
29951	50478	7	applied	\N	\N	\N	\N	151874	151874	151875
29951	50479	8	applied	\N	\N	\N	\N	151876	151876	92597
29955	50480	0	applied	\N	\N	\N	\N	151880	151880	151881
29955	50481	1	applied	\N	\N	\N	\N	151882	151882	151883
29955	50482	2	applied	\N	\N	\N	\N	151884	151884	92601
29955	50483	3	applied	\N	\N	\N	\N	151885	151885	92605
29955	50484	4	applied	\N	\N	\N	\N	151886	151886	92609
29955	50485	5	applied	\N	\N	\N	\N	151887	151887	151888
29955	50486	6	applied	\N	\N	\N	\N	151889	151889	92611
29955	50487	7	applied	\N	\N	\N	\N	151890	151890	92613
29955	50488	8	applied	\N	\N	\N	\N	151891	151891	92617
29955	50489	9	applied	\N	\N	\N	\N	151892	151892	92626
29957	50490	0	applied	\N	\N	\N	\N	151897	151897	151898
29957	50491	1	applied	\N	\N	\N	\N	151899	151899	92648
29957	50492	3	applied	\N	\N	\N	\N	151901	151901	92634
29957	50493	4	applied	\N	\N	\N	\N	151902	151902	93195
29957	50494	5	applied	\N	\N	\N	\N	151903	151903	92655
29957	50495	6	applied	\N	\N	\N	\N	151904	151904	92657
29957	50496	7	applied	\N	\N	\N	\N	151905	151905	93197
29957	50497	8	applied	\N	\N	\N	\N	151906	151906	92661
29957	50498	9	applied	\N	\N	\N	\N	151907	151907	92671
29957	50499	10	applied	\N	\N	\N	\N	151908	151908	93202
29959	50500	0	applied	\N	\N	\N	\N	151921	151921	151922
29959	50501	1	applied	\N	\N	\N	\N	151923	151923	151924
29959	50502	2	applied	\N	\N	\N	\N	151925	151925	151926
29959	50503	3	applied	\N	\N	\N	\N	151927	151927	151928
29959	50504	4	applied	\N	\N	\N	\N	151929	151929	93205
29959	50506	5	applied	\N	\N	\N	\N	151937	151937	92698
29959	50505	6	applied	\N	\N	\N	\N	151930	151930	93206
29962	50511	0	applied	\N	\N	\N	\N	151948	151948	151949
29962	50512	1	applied	\N	\N	\N	\N	151950	151950	151951
29962	50513	2	applied	\N	\N	\N	\N	151952	151952	92710
29962	50514	3	applied	\N	\N	\N	\N	151953	151953	92716
29962	50515	4	applied	\N	\N	\N	\N	151954	151954	151955
29966	50516	0	applied	\N	\N	\N	\N	151961	151961	151962
29966	50517	1	applied	\N	\N	\N	\N	151963	151963	92729
29966	50518	2	applied	\N	\N	\N	\N	151964	151964	151965
29966	50519	3	applied	\N	\N	\N	\N	151966	151966	92737
29966	50520	4	applied	\N	\N	\N	\N	151967	151967	92739
29966	50521	5	applied	\N	\N	\N	\N	151968	151968	151969
29966	50522	6	applied	\N	\N	\N	\N	151970	151970	92753
29966	50523	7	applied	\N	\N	\N	\N	151971	151971	151972
29966	50524	8	applied	\N	\N	\N	\N	151973	151973	92774
29966	50525	9	applied	\N	\N	\N	\N	151974	151974	151975
29966	50526	10	applied	\N	\N	\N	\N	151976	151976	151977
29966	50527	11	applied	\N	\N	\N	\N	151978	151978	151979
29966	50528	12	applied	\N	\N	\N	\N	151980	151980	92807
29966	50529	13	applied	\N	\N	\N	\N	151981	151981	151982
29966	50530	14	applied	\N	\N	\N	\N	151983	151983	92814
29966	50531	15	applied	\N	\N	\N	\N	151984	151984	92818
29966	50532	16	applied	\N	\N	\N	\N	151985	151985	92822
29966	50533	17	applied	\N	\N	\N	\N	151988	151988	92851
29966	50534	18	applied	\N	\N	\N	\N	151989	151989	151990
29968	50535	0	applied	\N	\N	\N	\N	151993	151993	151994
29968	50533	1	applied	\N	\N	\N	\N	151988	151988	92851
29968	50534	2	applied	\N	\N	\N	\N	151989	151989	151990
29968	50536	3	applied	\N	\N	\N	\N	151995	151995	151996
29968	50537	4	applied	\N	\N	\N	\N	151997	151997	151998
29968	50538	5	applied	\N	\N	\N	\N	151999	151999	92863
29968	50539	6	applied	\N	\N	\N	\N	152000	152000	152001
29968	50540	7	applied	\N	\N	\N	\N	152002	152002	152003
29968	50541	8	applied	\N	\N	\N	\N	152004	152004	92903
29968	50542	9	applied	\N	\N	\N	\N	152005	152005	93350
29968	50543	10	applied	\N	\N	\N	\N	152006	152006	92920
29968	50544	11	applied	\N	\N	\N	\N	152007	152007	93352
29968	50545	12	applied	\N	\N	\N	\N	152008	152008	93355
29970	50546	0	applied	\N	\N	\N	\N	152013	152013	152014
29970	50547	1	applied	\N	\N	\N	\N	152015	152015	93356
29970	50548	2	applied	\N	\N	\N	\N	152016	152016	93359
29970	50549	3	applied	\N	\N	\N	\N	152017	152017	152018
29970	50550	4	applied	\N	\N	\N	\N	152019	152019	152020
29970	50551	5	applied	\N	\N	\N	\N	152021	152021	152022
29970	50552	6	applied	\N	\N	\N	\N	152023	152023	92980
29970	50553	7	applied	\N	\N	\N	\N	152024	152024	92982
29970	50554	8	applied	\N	\N	\N	\N	152025	152025	92990
29987	50641	0	applied	\N	\N	\N	\N	152228	152228	152229
29987	50642	1	applied	\N	\N	\N	\N	152230	152230	152231
29987	50643	2	applied	\N	\N	\N	\N	152232	152232	152233
29987	50644	3	applied	\N	\N	\N	\N	152234	152234	93597
29987	50645	4	applied	\N	\N	\N	\N	152235	152235	152236
29987	50646	5	applied	\N	\N	\N	\N	152237	152237	152238
29987	50647	6	applied	\N	\N	\N	\N	152239	152239	93616
29987	50648	7	applied	\N	\N	\N	\N	152240	152240	94011
29987	50649	8	applied	\N	\N	\N	\N	152241	152241	93626
29987	50650	9	applied	\N	\N	\N	\N	152242	152242	94015
29987	50651	10	applied	\N	\N	\N	\N	152243	152243	94016
29987	50652	11	applied	\N	\N	\N	\N	152244	152244	93642
29987	50653	12	applied	\N	\N	\N	\N	152245	152245	94017
29987	50654	13	applied	\N	\N	\N	\N	152246	152246	94018
29987	50655	14	applied	\N	\N	\N	\N	152247	152247	94019
29987	50656	15	applied	\N	\N	\N	\N	152248	152248	93662
29987	50657	16	applied	\N	\N	\N	\N	152249	152249	152250
29987	50658	17	applied	\N	\N	\N	\N	152251	152251	152252
29987	50659	18	applied	\N	\N	\N	\N	152253	152253	93693
29989	50641	0	applied	\N	\N	\N	\N	152228	152228	152229
29989	50642	1	applied	\N	\N	\N	\N	152230	152230	152231
29989	50643	2	applied	\N	\N	\N	\N	152232	152232	152233
29989	50644	3	applied	\N	\N	\N	\N	152234	152234	93597
29989	50645	4	applied	\N	\N	\N	\N	152235	152235	152236
29989	50646	5	applied	\N	\N	\N	\N	152237	152237	152238
29989	50647	6	applied	\N	\N	\N	\N	152239	152239	93616
29989	50648	7	applied	\N	\N	\N	\N	152240	152240	94011
29989	50649	8	applied	\N	\N	\N	\N	152241	152241	93626
29989	50650	9	applied	\N	\N	\N	\N	152242	152242	94015
29989	50651	10	applied	\N	\N	\N	\N	152243	152243	94016
29989	50652	11	applied	\N	\N	\N	\N	152244	152244	93642
29989	50653	12	applied	\N	\N	\N	\N	152245	152245	94017
29961	50511	0	applied	\N	\N	\N	\N	151948	151948	151949
29961	50512	1	applied	\N	\N	\N	\N	151950	151950	151951
29961	50513	2	applied	\N	\N	\N	\N	151952	151952	92710
29961	50514	3	applied	\N	\N	\N	\N	151953	151953	92716
29961	50515	4	applied	\N	\N	\N	\N	151954	151954	151955
29964	50511	0	applied	\N	\N	\N	\N	151948	151948	151949
29964	50512	1	applied	\N	\N	\N	\N	151950	151950	151951
29964	50513	2	applied	\N	\N	\N	\N	151952	151952	92710
29964	50514	3	applied	\N	\N	\N	\N	151953	151953	92716
29964	50515	4	applied	\N	\N	\N	\N	151954	151954	151955
29965	50516	0	applied	\N	\N	\N	\N	151961	151961	151962
29965	50517	1	applied	\N	\N	\N	\N	151963	151963	92729
29965	50518	2	applied	\N	\N	\N	\N	151964	151964	151965
29965	50519	3	applied	\N	\N	\N	\N	151966	151966	92737
29965	50520	4	applied	\N	\N	\N	\N	151967	151967	92739
29965	50521	5	applied	\N	\N	\N	\N	151968	151968	151969
29965	50522	6	applied	\N	\N	\N	\N	151970	151970	92753
29965	50523	7	applied	\N	\N	\N	\N	151971	151971	151972
29965	50524	8	applied	\N	\N	\N	\N	151973	151973	92774
29965	50525	9	applied	\N	\N	\N	\N	151974	151974	151975
29965	50526	10	applied	\N	\N	\N	\N	151976	151976	151977
29965	50527	11	applied	\N	\N	\N	\N	151978	151978	151979
29965	50528	12	applied	\N	\N	\N	\N	151980	151980	92807
29965	50529	13	applied	\N	\N	\N	\N	151981	151981	151982
29965	50530	14	applied	\N	\N	\N	\N	151983	151983	92814
29965	50531	15	applied	\N	\N	\N	\N	151984	151984	92818
29965	50532	16	applied	\N	\N	\N	\N	151985	151985	92822
29972	50546	0	applied	\N	\N	\N	\N	152013	152013	152014
29972	50547	1	applied	\N	\N	\N	\N	152015	152015	93356
29972	50548	2	applied	\N	\N	\N	\N	152016	152016	93359
29972	50549	3	applied	\N	\N	\N	\N	152017	152017	152018
29972	50550	4	applied	\N	\N	\N	\N	152019	152019	152020
29972	50551	5	applied	\N	\N	\N	\N	152021	152021	152022
29972	50552	6	applied	\N	\N	\N	\N	152023	152023	92980
29972	50553	7	applied	\N	\N	\N	\N	152024	152024	92982
29972	50554	8	applied	\N	\N	\N	\N	152025	152025	92990
29974	50555	0	applied	\N	\N	\N	\N	152033	152033	152034
29974	50556	1	applied	\N	\N	\N	\N	152035	152035	152036
29974	50557	2	applied	\N	\N	\N	\N	152037	152037	152038
29974	50558	3	applied	\N	\N	\N	\N	152039	152039	92994
29974	50559	4	applied	\N	\N	\N	\N	152040	152040	92998
29974	50560	5	applied	\N	\N	\N	\N	152041	152041	152042
29974	50561	6	applied	\N	\N	\N	\N	152043	152043	93019
29974	50562	7	applied	\N	\N	\N	\N	152044	152044	152045
29974	50563	8	applied	\N	\N	\N	\N	152046	152046	93027
29974	50564	9	applied	\N	\N	\N	\N	152047	152047	152048
29974	50565	10	applied	\N	\N	\N	\N	152049	152049	93032
29974	50566	11	applied	\N	\N	\N	\N	152050	152050	152051
29974	50567	12	applied	\N	\N	\N	\N	152052	152052	152053
29974	50568	13	applied	\N	\N	\N	\N	152054	152054	93054
29974	50569	14	applied	\N	\N	\N	\N	152055	152055	152056
29974	50570	15	applied	\N	\N	\N	\N	152057	152057	93060
29974	50571	16	applied	\N	\N	\N	\N	152058	152058	93371
29974	50572	17	applied	\N	\N	\N	\N	152059	152059	152060
29977	50573	0	applied	\N	\N	\N	\N	152067	152067	152068
29977	50574	1	applied	\N	\N	\N	\N	152069	152069	152070
29977	50575	2	applied	\N	\N	\N	\N	152071	152071	93079
29977	50576	3	applied	\N	\N	\N	\N	152072	152072	93081
29977	50577	4	applied	\N	\N	\N	\N	152073	152073	152074
29977	50578	5	applied	\N	\N	\N	\N	152075	152075	152076
29977	50579	6	applied	\N	\N	\N	\N	152077	152077	152078
29977	50580	7	applied	\N	\N	\N	\N	152079	152079	93372
29977	50581	8	applied	\N	\N	\N	\N	152080	152080	152081
29977	50582	9	applied	\N	\N	\N	\N	152082	152082	93144
29977	50583	10	applied	\N	\N	\N	\N	152083	152083	152084
29977	50584	11	applied	\N	\N	\N	\N	152085	152085	93146
29977	50585	12	applied	\N	\N	\N	\N	152086	152086	152087
29977	50586	13	applied	\N	\N	\N	\N	152088	152088	152089
29977	50587	14	applied	\N	\N	\N	\N	152090	152090	93374
29977	50588	15	applied	\N	\N	\N	\N	152091	152091	93214
29977	50589	16	applied	\N	\N	\N	\N	152092	152092	152093
29977	50590	17	applied	\N	\N	\N	\N	152094	152094	93233
29977	50591	18	applied	\N	\N	\N	\N	152095	152095	93264
29977	50592	19	applied	\N	\N	\N	\N	152096	152096	93268
29983	50622	0	applied	\N	\N	\N	\N	152161	152161	152162
29983	50623	1	applied	\N	\N	\N	\N	152163	152163	152164
29983	50624	2	applied	\N	\N	\N	\N	152165	152165	93479
29983	50625	3	applied	\N	\N	\N	\N	152166	152166	93481
29983	50626	4	applied	\N	\N	\N	\N	152167	152167	152168
29983	50627	5	applied	\N	\N	\N	\N	152169	152169	93806
29983	50628	6	applied	\N	\N	\N	\N	152170	152170	93565
29983	50629	7	applied	\N	\N	\N	\N	152171	152171	93493
29983	50630	8	applied	\N	\N	\N	\N	152172	152172	93566
29983	50631	9	applied	\N	\N	\N	\N	152173	152173	93495
29983	50632	10	applied	\N	\N	\N	\N	152174	152174	93567
29983	50633	11	applied	\N	\N	\N	\N	152175	152175	93569
29983	50634	12	applied	\N	\N	\N	\N	152176	152176	93510
29983	50635	13	applied	\N	\N	\N	\N	152177	152177	93571
29983	50636	14	applied	\N	\N	\N	\N	152178	152178	93573
29983	50637	15	applied	\N	\N	\N	\N	152179	152179	93541
29983	50638	16	applied	\N	\N	\N	\N	152180	152180	93576
29983	50639	17	applied	\N	\N	\N	\N	152181	152181	93585
29983	50640	18	applied	\N	\N	\N	\N	152182	152182	94008
29985	50622	0	applied	\N	\N	\N	\N	152161	152161	152162
29985	50623	1	applied	\N	\N	\N	\N	152163	152163	152164
29985	50624	2	applied	\N	\N	\N	\N	152165	152165	93479
29985	50625	3	applied	\N	\N	\N	\N	152166	152166	93481
29985	50626	4	applied	\N	\N	\N	\N	152167	152167	152168
29985	50627	5	applied	\N	\N	\N	\N	152169	152169	93806
29985	50628	6	applied	\N	\N	\N	\N	152170	152170	93565
29985	50629	7	applied	\N	\N	\N	\N	152171	152171	93493
29985	50630	8	applied	\N	\N	\N	\N	152172	152172	93566
29985	50631	9	applied	\N	\N	\N	\N	152173	152173	93495
29985	50632	10	applied	\N	\N	\N	\N	152174	152174	93567
29985	50633	11	applied	\N	\N	\N	\N	152175	152175	93569
29985	50634	12	applied	\N	\N	\N	\N	152176	152176	93510
29985	50635	13	applied	\N	\N	\N	\N	152177	152177	93571
29985	50636	14	applied	\N	\N	\N	\N	152178	152178	93573
29985	50637	15	applied	\N	\N	\N	\N	152179	152179	93541
29985	50638	16	applied	\N	\N	\N	\N	152180	152180	93576
29985	50639	17	applied	\N	\N	\N	\N	152181	152181	93585
29985	50640	18	applied	\N	\N	\N	\N	152182	152182	94008
29988	50641	0	applied	\N	\N	\N	\N	152228	152228	152229
29988	50642	1	applied	\N	\N	\N	\N	152230	152230	152231
29988	50643	2	applied	\N	\N	\N	\N	152232	152232	152233
29988	50644	3	applied	\N	\N	\N	\N	152234	152234	93597
29988	50645	4	applied	\N	\N	\N	\N	152235	152235	152236
29988	50646	5	applied	\N	\N	\N	\N	152237	152237	152238
29988	50647	6	applied	\N	\N	\N	\N	152239	152239	93616
29988	50648	7	applied	\N	\N	\N	\N	152240	152240	94011
29973	50546	0	applied	\N	\N	\N	\N	152013	152013	152014
29973	50547	1	applied	\N	\N	\N	\N	152015	152015	93356
29973	50549	2	applied	\N	\N	\N	\N	152017	152017	92938
29973	50553	3	applied	\N	\N	\N	\N	152024	152024	92949
29973	50554	4	applied	\N	\N	\N	\N	152025	152025	152018
29975	50555	0	applied	\N	\N	\N	\N	152033	152033	152034
29975	50556	1	applied	\N	\N	\N	\N	152035	152035	152036
29975	50557	2	applied	\N	\N	\N	\N	152037	152037	152038
29975	50558	3	applied	\N	\N	\N	\N	152039	152039	92994
29975	50559	4	applied	\N	\N	\N	\N	152040	152040	92998
29975	50560	5	applied	\N	\N	\N	\N	152041	152041	152042
29975	50561	6	applied	\N	\N	\N	\N	152043	152043	93019
29975	50562	7	applied	\N	\N	\N	\N	152044	152044	152045
29975	50563	8	applied	\N	\N	\N	\N	152046	152046	93027
29975	50564	9	applied	\N	\N	\N	\N	152047	152047	152048
29975	50565	10	applied	\N	\N	\N	\N	152049	152049	93032
29975	50566	11	applied	\N	\N	\N	\N	152050	152050	152051
29975	50567	12	applied	\N	\N	\N	\N	152052	152052	152053
29975	50568	13	applied	\N	\N	\N	\N	152054	152054	93054
29975	50569	14	applied	\N	\N	\N	\N	152055	152055	152056
29975	50570	15	applied	\N	\N	\N	\N	152057	152057	93060
29975	50571	16	applied	\N	\N	\N	\N	152058	152058	93371
29975	50572	17	applied	\N	\N	\N	\N	152059	152059	152060
29978	50573	0	applied	\N	\N	\N	\N	152067	152067	152068
29978	50574	1	applied	\N	\N	\N	\N	152069	152069	152070
29978	50575	2	applied	\N	\N	\N	\N	152071	152071	93079
29978	50576	3	applied	\N	\N	\N	\N	152072	152072	93081
29978	50577	4	applied	\N	\N	\N	\N	152073	152073	152074
29978	50578	5	applied	\N	\N	\N	\N	152075	152075	152076
29978	50579	6	applied	\N	\N	\N	\N	152077	152077	152078
29978	50580	7	applied	\N	\N	\N	\N	152079	152079	93372
29978	50581	8	applied	\N	\N	\N	\N	152080	152080	152081
29978	50582	9	applied	\N	\N	\N	\N	152082	152082	93144
29978	50583	10	applied	\N	\N	\N	\N	152083	152083	152084
29978	50584	11	applied	\N	\N	\N	\N	152085	152085	93146
29978	50585	12	applied	\N	\N	\N	\N	152086	152086	152087
29978	50586	13	applied	\N	\N	\N	\N	152088	152088	152089
29978	50587	14	applied	\N	\N	\N	\N	152090	152090	93374
29978	50588	15	applied	\N	\N	\N	\N	152091	152091	93214
29978	50589	16	applied	\N	\N	\N	\N	152092	152092	152093
29978	50590	17	applied	\N	\N	\N	\N	152094	152094	93233
29978	50591	18	applied	\N	\N	\N	\N	152095	152095	93264
29978	50592	19	applied	\N	\N	\N	\N	152096	152096	93268
29979	50593	0	applied	\N	\N	\N	\N	152100	152100	152101
29979	50594	1	applied	\N	\N	\N	\N	152102	152102	152103
29979	50595	2	applied	\N	\N	\N	\N	152104	152104	152105
29979	50596	4	applied	\N	\N	\N	\N	152107	152107	93270
29979	50597	5	applied	\N	\N	\N	\N	152108	152108	93291
29979	50598	6	applied	\N	\N	\N	\N	152109	152109	93292
29979	50599	7	applied	\N	\N	\N	\N	152110	152110	152111
29979	50600	8	applied	\N	\N	\N	\N	152112	152112	93315
29979	50601	9	applied	\N	\N	\N	\N	152113	152113	152114
29979	50602	10	applied	\N	\N	\N	\N	152115	152115	93333
29979	50603	11	applied	\N	\N	\N	\N	152116	152116	93552
29979	50604	12	applied	\N	\N	\N	\N	152117	152117	93803
29979	50605	13	applied	\N	\N	\N	\N	152118	152118	93805
29979	50606	14	applied	\N	\N	\N	\N	152119	152119	93554
29979	50607	15	applied	\N	\N	\N	\N	152120	152120	93411
29979	50608	16	applied	\N	\N	\N	\N	152121	152121	152122
29979	50609	17	applied	\N	\N	\N	\N	152123	152123	93428
29979	50610	18	applied	\N	\N	\N	\N	152124	152124	93557
29979	50611	19	applied	\N	\N	\N	\N	152125	152125	152126
29981	50612	0	applied	\N	\N	\N	\N	152138	152138	152139
29981	50613	1	applied	\N	\N	\N	\N	152140	152140	93558
29981	50614	2	applied	\N	\N	\N	\N	152141	152141	152142
29981	50615	3	applied	\N	\N	\N	\N	152143	152143	93447
29981	50617	4	applied	\N	\N	\N	\N	152145	152145	152156
29981	50618	5	applied	\N	\N	\N	\N	152147	152147	93560
29981	50619	6	applied	\N	\N	\N	\N	152149	152149	93455
29981	50620	7	applied	\N	\N	\N	\N	152150	152150	152157
29981	50621	8	applied	\N	\N	\N	\N	152152	152152	93465
29997	50688	0	applied	\N	\N	\N	\N	152297	152297	152298
29997	50689	1	applied	\N	\N	\N	\N	152299	152299	94263
29997	50690	2	applied	\N	\N	\N	\N	152300	152300	94041
29997	50691	3	applied	\N	\N	\N	\N	152301	152301	94265
29997	50692	4	applied	\N	\N	\N	\N	152302	152302	94266
29997	50693	5	applied	\N	\N	\N	\N	152303	152303	93898
29997	50694	6	applied	\N	\N	\N	\N	152304	152304	94042
29997	50695	7	applied	\N	\N	\N	\N	152305	152305	152306
30005	50743	0	applied	\N	\N	\N	\N	152422	152422	152423
30005	50744	1	applied	\N	\N	\N	\N	152424	152424	152425
30005	50745	2	applied	\N	\N	\N	\N	152426	152426	152427
30005	50746	3	applied	\N	\N	\N	\N	152428	152428	152429
30005	50747	4	applied	\N	\N	\N	\N	152430	152430	94207
30005	50748	5	applied	\N	\N	\N	\N	152431	152431	152432
30005	50749	6	applied	\N	\N	\N	\N	152433	152433	152434
30005	50750	7	applied	\N	\N	\N	\N	152435	152435	94247
30005	50751	8	applied	\N	\N	\N	\N	152436	152436	94249
30005	50752	9	applied	\N	\N	\N	\N	152437	152437	94255
30005	50753	10	applied	\N	\N	\N	\N	152438	152438	152439
30005	50754	11	applied	\N	\N	\N	\N	152440	152440	94297
30005	50755	12	applied	\N	\N	\N	\N	152441	152441	94301
30005	50756	13	applied	\N	\N	\N	\N	152442	152442	94305
30005	50757	14	applied	\N	\N	\N	\N	152443	152443	94323
30005	50758	15	applied	\N	\N	\N	\N	152444	152444	152445
30005	50759	16	applied	\N	\N	\N	\N	152446	152446	94331
30005	50760	17	applied	\N	\N	\N	\N	152447	152447	94362
30005	50761	18	applied	\N	\N	\N	\N	152448	152448	94344
30005	50762	19	applied	\N	\N	\N	\N	152449	152449	152450
30011	50782	0	applied	\N	\N	\N	\N	152489	152489	152490
30011	50783	1	applied	\N	\N	\N	\N	152491	152491	152492
30011	50784	2	applied	\N	\N	\N	\N	152493	152493	152494
30011	50785	3	applied	\N	\N	\N	\N	152495	152495	94459
30011	50786	4	applied	\N	\N	\N	\N	152496	152496	152497
30011	50787	5	applied	\N	\N	\N	\N	152498	152498	152499
30011	50788	6	applied	\N	\N	\N	\N	152500	152500	152501
30011	50789	7	applied	\N	\N	\N	\N	152502	152502	94495
30011	50790	8	applied	\N	\N	\N	\N	152503	152503	94500
30011	50791	9	applied	\N	\N	\N	\N	152504	152504	152505
30011	50792	10	applied	\N	\N	\N	\N	152506	152506	94506
30011	50793	11	applied	\N	\N	\N	\N	152507	152507	94520
30011	50794	12	applied	\N	\N	\N	\N	152508	152508	152509
30011	50795	13	applied	\N	\N	\N	\N	152510	152510	94558
30011	50796	14	applied	\N	\N	\N	\N	152511	152511	152512
30011	50797	15	applied	\N	\N	\N	\N	152513	152513	152514
30011	50798	16	applied	\N	\N	\N	\N	152515	152515	152516
30011	50799	17	applied	\N	\N	\N	\N	152517	152517	94667
30011	50800	18	applied	\N	\N	\N	\N	152518	152518	94677
30011	50801	19	applied	\N	\N	\N	\N	152519	152519	152520
30011	50802	20	applied	\N	\N	\N	\N	152521	152521	94679
29984	50622	0	applied	\N	\N	\N	\N	152161	152161	152162
29984	50623	1	applied	\N	\N	\N	\N	152163	152163	152164
29984	50624	2	applied	\N	\N	\N	\N	152165	152165	93479
29984	50625	3	applied	\N	\N	\N	\N	152166	152166	93481
29984	50626	4	applied	\N	\N	\N	\N	152167	152167	152168
29984	50627	5	applied	\N	\N	\N	\N	152169	152169	93806
29984	50628	6	applied	\N	\N	\N	\N	152170	152170	93565
29984	50629	7	applied	\N	\N	\N	\N	152171	152171	93493
29984	50630	8	applied	\N	\N	\N	\N	152172	152172	93566
29984	50631	9	applied	\N	\N	\N	\N	152173	152173	93495
29984	50632	10	applied	\N	\N	\N	\N	152174	152174	93567
29984	50633	11	applied	\N	\N	\N	\N	152175	152175	93569
29984	50634	12	applied	\N	\N	\N	\N	152176	152176	93510
29984	50635	13	applied	\N	\N	\N	\N	152177	152177	93571
29984	50636	14	applied	\N	\N	\N	\N	152178	152178	93573
29984	50637	15	applied	\N	\N	\N	\N	152179	152179	93541
29984	50638	16	applied	\N	\N	\N	\N	152180	152180	93576
29984	50639	17	applied	\N	\N	\N	\N	152181	152181	93585
29984	50640	18	applied	\N	\N	\N	\N	152182	152182	94008
29986	50452	0	applied	\N	\N	\N	\N	151829	151829	151830
29986	50453	1	applied	\N	\N	\N	\N	151831	151831	151832
29986	50471	2	applied	\N	\N	\N	\N	151862	151862	151863
29986	50480	3	applied	\N	\N	\N	\N	151880	151880	151881
29986	50490	4	applied	\N	\N	\N	\N	151897	151897	151898
29986	50500	5	applied	\N	\N	\N	\N	151921	151921	151922
29986	50507	6	applied	\N	\N	\N	\N	151940	151940	151941
29986	50511	7	applied	\N	\N	\N	\N	151948	151948	151949
29986	50516	8	applied	\N	\N	\N	\N	151961	151961	151962
29986	50535	9	applied	\N	\N	\N	\N	151993	151993	151994
29986	50546	10	applied	\N	\N	\N	\N	152013	152013	152014
29986	50555	11	applied	\N	\N	\N	\N	152033	152033	152034
29986	50556	12	applied	\N	\N	\N	\N	152035	152035	152036
29986	50573	13	applied	\N	\N	\N	\N	152067	152067	152068
29986	50574	14	applied	\N	\N	\N	\N	152069	152069	152070
29986	50593	15	applied	\N	\N	\N	\N	152100	152100	152101
29986	50594	16	applied	\N	\N	\N	\N	152102	152102	152103
29986	50612	17	applied	\N	\N	\N	\N	152138	152138	152139
29986	50622	18	applied	\N	\N	\N	\N	152161	152161	152162
29986	50623	19	applied	\N	\N	\N	\N	152163	152163	152164
29986	50454	20	applied	\N	\N	\N	\N	151833	151833	151834
29986	50455	21	applied	\N	\N	\N	\N	151835	151835	92365
29986	50456	22	applied	\N	\N	\N	\N	151836	151836	151837
29986	50457	23	applied	\N	\N	\N	\N	151838	151838	151839
29986	50473	24	applied	\N	\N	\N	\N	151865	151865	92367
29986	50458	25	applied	\N	\N	\N	\N	151840	151840	92379
29986	50459	26	applied	\N	\N	\N	\N	151842	151842	92381
29986	50460	27	applied	\N	\N	\N	\N	151844	151844	152188
29986	50461	28	applied	\N	\N	\N	\N	151845	151845	92400
29986	50462	29	applied	\N	\N	\N	\N	151846	151846	92406
29986	50463	30	applied	\N	\N	\N	\N	151848	151848	152189
29986	50464	31	applied	\N	\N	\N	\N	151850	151850	152190
29986	50476	32	applied	\N	\N	\N	\N	151871	151871	92415
29986	50477	33	applied	\N	\N	\N	\N	151872	151872	92419
29986	50481	34	applied	\N	\N	\N	\N	151882	151882	152191
29986	50485	35	applied	\N	\N	\N	\N	151887	151887	152192
29986	50487	36	applied	\N	\N	\N	\N	151890	151890	92482
29986	50491	37	applied	\N	\N	\N	\N	151899	151899	92484
29986	50495	38	applied	\N	\N	\N	\N	151904	151904	152193
29986	50496	39	applied	\N	\N	\N	\N	151905	151905	152194
29986	50503	40	applied	\N	\N	\N	\N	151927	151927	92493
29986	50504	41	applied	\N	\N	\N	\N	151929	151929	92495
29986	50506	42	applied	\N	\N	\N	\N	151937	151937	152195
29986	50508	43	applied	\N	\N	\N	\N	151942	151942	152196
29986	50509	44	applied	\N	\N	\N	\N	151943	151943	152197
29986	50514	45	applied	\N	\N	\N	\N	151953	151953	151866
29986	50515	47	applied	\N	\N	\N	\N	151954	151954	92510
29986	50519	48	applied	\N	\N	\N	\N	151966	151966	151868
29986	50520	49	applied	\N	\N	\N	\N	151967	151967	152199
29986	50537	50	applied	\N	\N	\N	\N	151997	151997	151870
29986	50539	51	applied	\N	\N	\N	\N	152000	152000	92530
29986	50540	52	applied	\N	\N	\N	\N	152002	152002	151873
29986	50547	53	applied	\N	\N	\N	\N	152015	152015	92595
29986	50465	54	applied	\N	\N	\N	\N	151851	151851	152200
29986	50466	55	applied	\N	\N	\N	\N	151853	151853	152201
29986	50467	56	applied	\N	\N	\N	\N	151854	151854	152202
29986	50468	57	applied	\N	\N	\N	\N	151856	151856	152203
29986	50469	58	applied	\N	\N	\N	\N	151857	151857	92611
29986	50470	59	applied	\N	\N	\N	\N	151859	151859	92615
29986	50472	60	applied	\N	\N	\N	\N	151864	151864	92619
29986	50474	61	applied	\N	\N	\N	\N	151867	151867	92648
29986	50475	62	applied	\N	\N	\N	\N	151869	151869	92638
29986	50478	63	applied	\N	\N	\N	\N	151874	151874	92657
29986	50482	64	applied	\N	\N	\N	\N	151884	151884	93198
29986	50483	65	applied	\N	\N	\N	\N	151885	151885	93200
29986	50484	66	applied	\N	\N	\N	\N	151886	151886	152204
29986	50553	67	applied	\N	\N	\N	\N	152024	152024	93202
29986	50554	68	applied	\N	\N	\N	\N	152025	152025	92685
29986	50557	69	applied	\N	\N	\N	\N	152037	152037	151924
29986	50558	70	applied	\N	\N	\N	\N	152039	152039	93204
29986	50559	71	applied	\N	\N	\N	\N	152040	152040	151926
29986	50572	72	applied	\N	\N	\N	\N	152059	152059	151928
29986	50576	73	applied	\N	\N	\N	\N	152072	152072	93205
29986	50577	74	applied	\N	\N	\N	\N	152073	152073	92698
29986	50579	75	applied	\N	\N	\N	\N	152077	152077	92700
29986	50580	76	applied	\N	\N	\N	\N	152079	152079	152205
29986	50581	77	applied	\N	\N	\N	\N	152080	152080	92708
29986	50582	78	applied	\N	\N	\N	\N	152082	152082	92710
29986	50595	79	applied	\N	\N	\N	\N	152104	152104	92716
29986	50598	80	applied	\N	\N	\N	\N	152109	152109	151955
29986	50488	81	applied	\N	\N	\N	\N	151891	151891	92729
29986	50489	82	applied	\N	\N	\N	\N	151892	151892	152206
29986	50493	83	applied	\N	\N	\N	\N	151902	151902	152207
29986	50497	84	applied	\N	\N	\N	\N	151906	151906	92766
29986	50498	85	applied	\N	\N	\N	\N	151907	151907	92755
29986	50499	86	applied	\N	\N	\N	\N	151908	151908	152208
29986	50501	87	applied	\N	\N	\N	\N	151923	151923	92781
29986	50502	88	applied	\N	\N	\N	\N	151925	151925	92799
29986	50517	89	applied	\N	\N	\N	\N	151963	151963	152209
29986	50521	90	applied	\N	\N	\N	\N	151968	151968	152210
29986	50522	91	applied	\N	\N	\N	\N	151970	151970	92810
29986	50523	92	applied	\N	\N	\N	\N	151971	151971	152211
29986	50524	93	applied	\N	\N	\N	\N	151973	151973	152212
29986	50525	94	applied	\N	\N	\N	\N	151974	151974	152213
29986	50526	95	applied	\N	\N	\N	\N	151976	151976	92844
29986	50527	96	applied	\N	\N	\N	\N	151978	151978	92852
29986	50528	97	applied	\N	\N	\N	\N	151980	151980	152214
29986	50529	98	applied	\N	\N	\N	\N	151981	151981	92863
29986	50530	99	applied	\N	\N	\N	\N	151983	151983	152003
29986	50531	100	applied	\N	\N	\N	\N	151984	151984	92911
29986	50532	101	applied	\N	\N	\N	\N	151985	151985	93351
29986	50533	102	applied	\N	\N	\N	\N	151988	151988	92928
29986	50534	103	applied	\N	\N	\N	\N	151989	151989	93354
29986	50536	104	applied	\N	\N	\N	\N	151995	151995	92938
29986	50542	105	applied	\N	\N	\N	\N	152005	152005	152018
29986	50543	106	applied	\N	\N	\N	\N	152006	152006	152020
29986	50544	107	applied	\N	\N	\N	\N	152007	152007	152022
29986	50545	108	applied	\N	\N	\N	\N	152008	152008	92980
29986	50548	109	applied	\N	\N	\N	\N	152016	152016	92990
29986	50550	110	applied	\N	\N	\N	\N	152019	152019	92994
29986	50551	111	applied	\N	\N	\N	\N	152021	152021	152065
29986	50552	112	applied	\N	\N	\N	\N	152023	152023	152215
29986	50560	113	applied	\N	\N	\N	\N	152041	152041	152216
29986	50561	114	applied	\N	\N	\N	\N	152043	152043	93025
29986	50562	115	applied	\N	\N	\N	\N	152044	152044	93032
29986	50563	116	applied	\N	\N	\N	\N	152046	152046	152217
29986	50567	117	applied	\N	\N	\N	\N	152052	152052	93041
29986	50568	118	applied	\N	\N	\N	\N	152054	152054	93056
29986	50569	119	applied	\N	\N	\N	\N	152055	152055	152218
29986	50570	120	applied	\N	\N	\N	\N	152057	152057	152219
29986	50571	121	applied	\N	\N	\N	\N	152058	152058	93069
29990	50660	0	applied	\N	\N	\N	\N	152258	152258	152259
29990	50661	1	applied	\N	\N	\N	\N	152260	152260	93664
29990	50662	2	applied	\N	\N	\N	\N	152261	152261	93669
29990	50663	3	applied	\N	\N	\N	\N	152262	152262	94023
29990	50651	4	applied	\N	\N	\N	\N	152243	152243	94024
29990	50652	5	applied	\N	\N	\N	\N	152244	152244	94025
29990	50653	6	applied	\N	\N	\N	\N	152245	152245	93697
29990	50654	7	applied	\N	\N	\N	\N	152246	152246	94026
29990	50655	8	applied	\N	\N	\N	\N	152247	152247	93719
29990	50664	9	applied	\N	\N	\N	\N	152263	152263	93721
29990	50665	10	applied	\N	\N	\N	\N	152264	152264	93728
29990	50666	11	applied	\N	\N	\N	\N	152265	152265	94028
29990	50667	12	applied	\N	\N	\N	\N	152266	152266	93746
29990	50668	13	applied	\N	\N	\N	\N	152267	152267	94030
29995	50688	0	applied	\N	\N	\N	\N	152297	152297	152298
29995	50689	1	applied	\N	\N	\N	\N	152299	152299	94263
29995	50690	2	applied	\N	\N	\N	\N	152300	152300	94041
29995	50691	3	applied	\N	\N	\N	\N	152301	152301	94265
29995	50692	4	applied	\N	\N	\N	\N	152302	152302	94266
29995	50693	5	applied	\N	\N	\N	\N	152303	152303	93898
29995	50694	6	applied	\N	\N	\N	\N	152304	152304	94042
29995	50695	7	applied	\N	\N	\N	\N	152305	152305	152306
29999	50696	0	applied	\N	\N	\N	\N	152311	152311	152312
29999	50697	1	applied	\N	\N	\N	\N	152313	152313	152314
29999	50698	2	applied	\N	\N	\N	\N	152315	152315	93908
29999	50699	3	applied	\N	\N	\N	\N	152316	152316	94592
29999	50700	4	applied	\N	\N	\N	\N	152317	152317	93989
29999	50701	5	applied	\N	\N	\N	\N	152318	152318	93931
29999	50702	6	applied	\N	\N	\N	\N	152319	152319	94593
29999	50703	8	applied	\N	\N	\N	\N	152321	152321	93990
29999	50704	9	applied	\N	\N	\N	\N	152322	152322	93954
29999	50705	10	applied	\N	\N	\N	\N	152323	152323	93956
29999	50706	11	applied	\N	\N	\N	\N	152324	152324	93960
29999	50707	12	applied	\N	\N	\N	\N	152325	152325	94273
29999	50708	13	applied	\N	\N	\N	\N	152326	152326	93995
29999	50709	14	applied	\N	\N	\N	\N	152327	152327	93976
29999	50710	15	applied	\N	\N	\N	\N	152328	152328	93978
29999	50711	16	applied	\N	\N	\N	\N	152329	152329	94276
29999	50712	17	applied	\N	\N	\N	\N	152330	152330	152331
29999	50713	18	applied	\N	\N	\N	\N	152332	152332	94049
29999	50714	19	applied	\N	\N	\N	\N	152333	152333	94057
30009	50773	0	applied	\N	\N	\N	\N	152471	152471	152472
30009	50774	1	applied	\N	\N	\N	\N	152473	152473	94400
30009	50775	2	applied	\N	\N	\N	\N	152474	152474	152475
30009	50776	3	applied	\N	\N	\N	\N	152476	152476	94412
30009	50777	4	applied	\N	\N	\N	\N	152477	152477	152478
30009	50778	5	applied	\N	\N	\N	\N	152479	152479	94432
30009	50779	6	applied	\N	\N	\N	\N	152480	152480	152481
30009	50780	7	applied	\N	\N	\N	\N	152482	152482	94457
30009	50781	8	applied	\N	\N	\N	\N	152483	152483	152484
30017	50838	0	applied	\N	\N	\N	\N	152579	152579	152580
30017	50839	1	applied	\N	\N	\N	\N	152581	152581	152582
30017	50840	2	applied	\N	\N	\N	\N	152583	152583	152584
30017	50841	3	applied	\N	\N	\N	\N	152585	152585	95090
30017	50842	4	applied	\N	\N	\N	\N	152586	152586	95307
30017	50843	5	applied	\N	\N	\N	\N	152587	152587	95106
30017	50844	6	applied	\N	\N	\N	\N	152588	152588	95308
30017	50845	7	applied	\N	\N	\N	\N	152589	152589	95108
30017	50846	8	applied	\N	\N	\N	\N	152590	152590	95309
30017	50847	9	applied	\N	\N	\N	\N	152591	152591	95310
30017	50848	10	applied	\N	\N	\N	\N	152592	152592	95121
30017	50849	11	applied	\N	\N	\N	\N	152593	152593	95123
30017	50850	12	applied	\N	\N	\N	\N	152594	152594	95132
30017	50851	13	applied	\N	\N	\N	\N	152595	152595	95311
30017	50852	14	applied	\N	\N	\N	\N	152596	152596	95312
30017	50853	15	applied	\N	\N	\N	\N	152597	152597	95313
30017	50854	16	applied	\N	\N	\N	\N	152598	152598	95314
30017	50855	17	applied	\N	\N	\N	\N	152599	152599	95170
30017	50856	18	applied	\N	\N	\N	\N	152600	152600	95187
30017	50857	19	applied	\N	\N	\N	\N	152601	152601	95199
30017	50858	20	applied	\N	\N	\N	\N	152602	152602	95316
30017	50859	21	applied	\N	\N	\N	\N	152603	152603	95240
30017	50860	22	applied	\N	\N	\N	\N	152604	152604	95254
30017	50861	23	applied	\N	\N	\N	\N	152605	152605	95317
30017	50862	24	applied	\N	\N	\N	\N	152606	152606	95319
30017	50863	25	applied	\N	\N	\N	\N	152607	152607	95295
30017	50864	26	applied	\N	\N	\N	\N	152608	152608	95331
30017	50865	27	applied	\N	\N	\N	\N	152609	152609	152610
30017	50866	28	applied	\N	\N	\N	\N	152611	152611	152612
30017	50867	29	applied	\N	\N	\N	\N	152613	152613	95374
30019	50838	0	applied	\N	\N	\N	\N	152579	152579	152580
30019	50839	1	applied	\N	\N	\N	\N	152581	152581	152582
30019	50840	2	applied	\N	\N	\N	\N	152583	152583	152584
30019	50841	3	applied	\N	\N	\N	\N	152585	152585	95090
30019	50842	4	applied	\N	\N	\N	\N	152586	152586	95307
30019	50843	5	applied	\N	\N	\N	\N	152587	152587	95106
30019	50844	6	applied	\N	\N	\N	\N	152588	152588	95308
30019	50845	7	applied	\N	\N	\N	\N	152589	152589	95108
30019	50846	8	applied	\N	\N	\N	\N	152590	152590	95309
30019	50847	9	applied	\N	\N	\N	\N	152591	152591	95310
30019	50848	10	applied	\N	\N	\N	\N	152592	152592	95121
30019	50849	11	applied	\N	\N	\N	\N	152593	152593	95123
30019	50850	12	applied	\N	\N	\N	\N	152594	152594	95132
30019	50851	13	applied	\N	\N	\N	\N	152595	152595	95311
30019	50852	14	applied	\N	\N	\N	\N	152596	152596	95312
30019	50853	15	applied	\N	\N	\N	\N	152597	152597	95313
30019	50854	16	applied	\N	\N	\N	\N	152598	152598	95314
30019	50855	17	applied	\N	\N	\N	\N	152599	152599	95170
30019	50856	18	applied	\N	\N	\N	\N	152600	152600	95187
30019	50857	19	applied	\N	\N	\N	\N	152601	152601	95199
29988	50649	8	applied	\N	\N	\N	\N	152241	152241	93626
29988	50650	9	applied	\N	\N	\N	\N	152242	152242	94015
29988	50656	10	applied	\N	\N	\N	\N	152248	152248	93638
29988	50657	11	applied	\N	\N	\N	\N	152249	152249	152255
29988	50658	12	applied	\N	\N	\N	\N	152251	152251	93660
29988	50659	13	applied	\N	\N	\N	\N	152253	152253	152256
29992	50669	0	applied	\N	\N	\N	\N	152271	152271	152272
29992	50670	1	applied	\N	\N	\N	\N	152273	152273	93758
29992	50671	2	applied	\N	\N	\N	\N	152274	152274	94032
29992	50672	3	applied	\N	\N	\N	\N	152275	152275	93772
29992	50673	4	applied	\N	\N	\N	\N	152276	152276	93774
29992	50674	5	applied	\N	\N	\N	\N	152277	152277	93776
29992	50675	6	applied	\N	\N	\N	\N	152278	152278	94035
29992	50676	7	applied	\N	\N	\N	\N	152279	152279	93784
29992	50677	8	applied	\N	\N	\N	\N	152280	152280	152281
29992	50678	9	applied	\N	\N	\N	\N	152282	152282	94037
29994	50679	0	applied	\N	\N	\N	\N	152284	152284	152285
29994	50680	1	applied	\N	\N	\N	\N	152286	152286	93820
29994	50686	2	applied	\N	\N	\N	\N	152294	152294	93822
29994	50681	3	applied	\N	\N	\N	\N	152287	152287	152295
29994	50687	4	applied	\N	\N	\N	\N	152296	152296	93824
29994	50682	5	applied	\N	\N	\N	\N	152289	152289	94261
29994	50683	6	applied	\N	\N	\N	\N	152290	152290	93851
29994	50684	7	applied	\N	\N	\N	\N	152291	152291	94040
29994	50685	8	applied	\N	\N	\N	\N	152292	152292	93865
30001	50352	0	applied	\N	\N	\N	\N	151595	151595	151596
30001	50360	1	applied	\N	\N	\N	\N	151609	151609	151610
30001	50361	2	applied	\N	\N	\N	\N	151611	151611	151612
30001	50379	3	applied	\N	\N	\N	\N	151642	151642	151643
30001	50389	4	applied	\N	\N	\N	\N	151698	151698	151699
30001	50390	5	applied	\N	\N	\N	\N	151700	151700	151701
30001	50404	6	applied	\N	\N	\N	\N	151734	151734	151735
30001	50405	7	applied	\N	\N	\N	\N	151736	151736	151737
30001	50414	8	applied	\N	\N	\N	\N	151761	151761	151762
30001	50419	9	applied	\N	\N	\N	\N	151769	151769	151770
30001	50432	10	applied	\N	\N	\N	\N	151790	151790	151791
30001	50433	11	applied	\N	\N	\N	\N	151794	151794	151795
30001	50443	12	applied	\N	\N	\N	\N	151813	151813	151814
30001	50452	13	applied	\N	\N	\N	\N	151829	151829	151830
30001	50453	14	applied	\N	\N	\N	\N	151831	151831	151832
30001	50471	15	applied	\N	\N	\N	\N	151862	151862	151863
30001	50480	16	applied	\N	\N	\N	\N	151880	151880	151881
30001	50490	17	applied	\N	\N	\N	\N	151897	151897	151898
30001	50500	18	applied	\N	\N	\N	\N	151921	151921	151922
30001	50507	19	applied	\N	\N	\N	\N	151940	151940	151941
30001	50511	20	applied	\N	\N	\N	\N	151948	151948	151949
30001	50516	21	applied	\N	\N	\N	\N	151961	151961	151962
30001	50535	22	applied	\N	\N	\N	\N	151993	151993	151994
30001	50546	23	applied	\N	\N	\N	\N	152013	152013	152014
30001	50555	24	applied	\N	\N	\N	\N	152033	152033	152034
30001	50556	25	applied	\N	\N	\N	\N	152035	152035	152036
30001	50573	26	applied	\N	\N	\N	\N	152067	152067	152068
30001	50574	27	applied	\N	\N	\N	\N	152069	152069	152070
30001	50593	28	applied	\N	\N	\N	\N	152100	152100	152101
30001	50594	29	applied	\N	\N	\N	\N	152102	152102	152103
30001	50612	30	applied	\N	\N	\N	\N	152138	152138	152139
30001	50622	31	applied	\N	\N	\N	\N	152161	152161	152162
30001	50623	32	applied	\N	\N	\N	\N	152163	152163	152164
30001	50641	33	applied	\N	\N	\N	\N	152228	152228	152229
30001	50642	34	applied	\N	\N	\N	\N	152230	152230	152231
30001	50660	35	applied	\N	\N	\N	\N	152258	152258	152259
30001	50669	36	applied	\N	\N	\N	\N	152271	152271	152272
30001	50679	37	applied	\N	\N	\N	\N	152284	152284	152285
30001	50688	38	applied	\N	\N	\N	\N	152297	152297	152298
30001	50696	39	applied	\N	\N	\N	\N	152311	152311	152365
30001	50697	40	applied	\N	\N	\N	\N	152313	152313	152366
30001	50715	41	applied	\N	\N	\N	\N	152348	152348	152367
30001	50353	42	applied	\N	\N	\N	\N	151597	151597	151598
30001	50354	43	applied	\N	\N	\N	\N	151599	151599	91893
30001	50355	44	applied	\N	\N	\N	\N	151600	151600	91881
30001	50366	45	applied	\N	\N	\N	\N	151620	151620	152368
30001	50367	46	applied	\N	\N	\N	\N	151621	151621	151602
30001	50368	47	applied	\N	\N	\N	\N	151622	151622	92538
30001	50356	48	applied	\N	\N	\N	\N	151601	151601	91901
30001	50362	49	applied	\N	\N	\N	\N	151613	151613	92058
30001	50363	50	applied	\N	\N	\N	\N	151614	151614	91905
30001	50364	51	applied	\N	\N	\N	\N	151616	151616	92059
30001	50380	52	applied	\N	\N	\N	\N	151644	151644	152369
30001	50369	53	applied	\N	\N	\N	\N	151624	151624	92540
30001	50370	56	applied	\N	\N	\N	\N	151626	151626	151615
30001	50381	57	applied	\N	\N	\N	\N	151647	151647	91918
30001	50382	58	applied	\N	\N	\N	\N	151649	151649	91920
30001	50396	59	applied	\N	\N	1000000000	\N	151710	151710	151711
30001	50397	60	applied	\N	\N	1000000000	\N	151712	151712	151713
30001	50388	61	applied	\N	\N	\N	\N	151656	151656	92541
30001	50391	62	applied	\N	\N	\N	\N	151702	151702	91934
30001	50394	63	applied	\N	\N	\N	\N	151707	151707	152374
30001	50395	64	applied	\N	\N	\N	\N	151708	151708	92548
30001	50406	65	applied	\N	\N	\N	\N	151738	151738	91936
30001	50407	66	applied	\N	\N	\N	\N	151739	151739	151623
30001	50408	67	applied	\N	\N	\N	\N	151740	151740	91948
30001	50417	68	applied	\N	\N	\N	\N	151765	151765	151645
30001	50421	69	applied	\N	\N	\N	\N	151773	151773	151625
30001	50423	70	applied	\N	\N	\N	\N	151775	151775	91950
30001	50425	71	applied	\N	\N	\N	\N	151779	151779	151627
30001	50435	72	applied	\N	\N	\N	\N	151797	151797	151646
30001	50436	73	applied	\N	\N	\N	\N	151799	151799	91952
30001	50446	74	applied	\N	\N	\N	\N	151819	151819	151648
30001	50455	75	applied	\N	\N	\N	\N	151835	151835	151629
30001	50456	76	applied	\N	\N	\N	\N	151836	151836	91954
30001	50457	77	applied	\N	\N	\N	\N	151838	151838	152375
30001	50473	78	applied	\N	\N	\N	\N	151865	151865	91956
30001	50357	79	applied	\N	\N	\N	\N	151603	151603	92550
30001	50358	80	applied	\N	\N	\N	\N	151604	151604	152376
30001	50359	81	applied	\N	\N	\N	\N	151605	151605	91977
30001	50365	82	applied	\N	\N	\N	\N	151619	151619	152377
30001	50371	83	applied	\N	\N	\N	\N	151628	151628	91983
30001	50372	84	applied	\N	\N	\N	\N	151630	151630	92434
30001	50373	85	applied	\N	\N	\N	\N	151631	151631	152378
30001	50374	86	applied	\N	\N	\N	\N	151632	151632	92437
30001	50375	87	applied	\N	\N	\N	\N	151633	151633	92065
30001	50376	88	applied	\N	\N	\N	\N	151634	151634	92439
30001	50377	89	applied	\N	\N	\N	\N	151635	151635	92080
30001	50378	90	applied	\N	\N	\N	\N	151636	151636	92084
30001	50383	91	applied	\N	\N	\N	\N	151651	151651	151703
30001	50384	92	applied	\N	\N	\N	\N	151652	151652	92090
30001	50385	93	applied	\N	\N	\N	\N	151653	151653	151706
30001	50386	94	applied	\N	\N	\N	\N	151654	151654	92102
30001	50387	95	applied	\N	\N	\N	\N	151655	151655	93248
29989	50654	13	applied	\N	\N	\N	\N	152246	152246	94018
29989	50655	14	applied	\N	\N	\N	\N	152247	152247	94019
29989	50656	15	applied	\N	\N	\N	\N	152248	152248	93662
29989	50657	16	applied	\N	\N	\N	\N	152249	152249	152250
29989	50658	17	applied	\N	\N	\N	\N	152251	152251	152252
29989	50659	18	applied	\N	\N	\N	\N	152253	152253	93693
29991	50660	0	applied	\N	\N	\N	\N	152258	152258	152259
29991	50661	1	applied	\N	\N	\N	\N	152260	152260	93664
29991	50662	2	applied	\N	\N	\N	\N	152261	152261	93669
29991	50663	3	applied	\N	\N	\N	\N	152262	152262	94023
29991	50651	4	applied	\N	\N	\N	\N	152243	152243	94024
29991	50652	5	applied	\N	\N	\N	\N	152244	152244	94025
29991	50653	6	applied	\N	\N	\N	\N	152245	152245	93697
29991	50654	7	applied	\N	\N	\N	\N	152246	152246	94026
29991	50655	8	applied	\N	\N	\N	\N	152247	152247	93719
29991	50664	9	applied	\N	\N	\N	\N	152263	152263	93721
29991	50665	10	applied	\N	\N	\N	\N	152264	152264	93728
29991	50666	11	applied	\N	\N	\N	\N	152265	152265	94028
29991	50667	12	applied	\N	\N	\N	\N	152266	152266	93746
29991	50668	13	applied	\N	\N	\N	\N	152267	152267	94030
29993	50679	0	applied	\N	\N	\N	\N	152284	152284	152285
29993	50680	1	applied	\N	\N	\N	\N	152286	152286	93820
29993	50681	2	applied	\N	\N	\N	\N	152287	152287	152288
29993	50682	3	applied	\N	\N	\N	\N	152289	152289	93824
29993	50683	4	applied	\N	\N	\N	\N	152290	152290	94261
29993	50684	5	applied	\N	\N	\N	\N	152291	152291	93851
29993	50685	6	applied	\N	\N	\N	\N	152292	152292	94040
29996	50688	0	applied	\N	\N	\N	\N	152297	152297	152298
29996	50689	1	applied	\N	\N	\N	\N	152299	152299	94263
29996	50690	2	applied	\N	\N	\N	\N	152300	152300	94041
29996	50693	3	applied	\N	\N	\N	\N	152303	152303	93894
29996	50694	4	applied	\N	\N	\N	\N	152304	152304	93898
29996	50695	5	applied	\N	\N	\N	\N	152305	152305	94042
29998	50696	0	applied	\N	\N	\N	\N	152311	152311	152312
29998	50697	1	applied	\N	\N	\N	\N	152313	152313	152314
29998	50698	2	applied	\N	\N	\N	\N	152315	152315	93908
29998	50699	3	applied	\N	\N	\N	\N	152316	152316	94592
29998	50700	4	applied	\N	\N	\N	\N	152317	152317	93989
29998	50701	5	applied	\N	\N	\N	\N	152318	152318	93931
29998	50702	6	applied	\N	\N	\N	\N	152319	152319	94593
29998	50703	8	applied	\N	\N	\N	\N	152321	152321	93990
29998	50704	9	applied	\N	\N	\N	\N	152322	152322	93954
29998	50705	10	applied	\N	\N	\N	\N	152323	152323	93956
29998	50706	11	applied	\N	\N	\N	\N	152324	152324	93960
29998	50707	12	applied	\N	\N	\N	\N	152325	152325	94273
29998	50708	13	applied	\N	\N	\N	\N	152326	152326	93995
29998	50709	14	applied	\N	\N	\N	\N	152327	152327	93976
29998	50710	15	applied	\N	\N	\N	\N	152328	152328	93978
29998	50711	16	applied	\N	\N	\N	\N	152329	152329	94276
29998	50712	17	applied	\N	\N	\N	\N	152330	152330	152331
29998	50713	18	applied	\N	\N	\N	\N	152332	152332	94049
29998	50714	19	applied	\N	\N	\N	\N	152333	152333	94057
30000	50715	0	applied	\N	\N	\N	\N	152348	152348	152349
30000	50716	1	applied	\N	\N	\N	\N	152350	152350	152351
30000	50717	2	applied	\N	\N	\N	\N	152352	152352	94279
30000	50718	3	applied	\N	\N	\N	\N	152353	152353	152354
30000	50719	4	applied	\N	\N	\N	\N	152355	152355	94069
30000	50720	5	applied	\N	\N	\N	\N	152356	152356	94281
30000	50721	6	applied	\N	\N	\N	\N	152357	152357	94080
30000	50722	7	applied	\N	\N	\N	\N	152358	152358	94594
30000	50723	8	applied	\N	\N	\N	\N	152359	152359	94095
30000	50724	9	applied	\N	\N	\N	\N	152360	152360	152361
30002	50725	0	applied	\N	\N	\N	\N	152390	152390	152391
30002	50726	1	applied	\N	\N	\N	\N	152392	152392	94101
30002	50727	2	applied	\N	\N	\N	\N	152393	152393	94126
30002	50728	3	applied	\N	\N	\N	\N	152394	152394	94284
30002	50729	4	applied	\N	\N	\N	\N	152395	152395	94131
30002	50730	5	applied	\N	\N	\N	\N	152396	152396	94133
30002	50731	6	applied	\N	\N	\N	\N	152397	152397	94145
30002	50732	7	applied	\N	\N	\N	\N	152398	152398	152399
30002	50733	8	applied	\N	\N	\N	\N	152400	152400	152401
30004	50734	0	applied	\N	\N	\N	\N	152404	152404	152405
30004	50735	1	applied	\N	\N	\N	\N	152406	152406	152407
30004	50736	2	applied	\N	\N	\N	\N	152408	152408	152409
30004	50738	3	applied	\N	\N	\N	\N	152411	152411	94173
30004	50739	4	applied	\N	\N	\N	\N	152413	152413	94177
30004	50740	5	applied	\N	\N	\N	\N	152415	152415	94181
30004	50741	6	applied	\N	\N	\N	\N	152417	152417	94195
30004	50742	7	applied	\N	\N	\N	\N	152418	152418	152421
30007	50763	0	applied	\N	\N	\N	\N	152454	152454	152455
30007	50764	1	applied	\N	\N	\N	\N	152456	152456	94350
30007	50765	2	applied	\N	\N	\N	\N	152457	152457	152458
30007	50766	3	applied	\N	\N	\N	\N	152459	152459	94357
30007	50767	4	applied	\N	\N	\N	\N	152460	152460	152461
30007	50768	5	applied	\N	\N	\N	\N	152462	152462	94377
30007	50769	6	applied	\N	\N	\N	\N	152463	152463	152464
30007	50770	7	applied	\N	\N	\N	\N	152465	152465	94396
30007	50771	8	applied	\N	\N	\N	\N	152466	152466	94398
30007	50772	9	applied	\N	\N	\N	\N	152467	152467	152468
30013	50820	0	applied	\N	\N	\N	\N	152556	152556	152557
30013	50821	1	applied	\N	\N	\N	\N	152558	152558	95214
30013	50822	2	applied	\N	\N	\N	\N	152559	152559	94896
30013	50823	3	applied	\N	\N	\N	\N	152560	152560	94898
30013	50824	4	applied	\N	\N	\N	\N	152561	152561	95216
30013	50825	5	applied	\N	\N	\N	\N	152562	152562	95218
30013	50826	6	applied	\N	\N	\N	\N	152563	152563	94958
30013	50827	7	applied	\N	\N	\N	\N	152564	152564	94971
30013	50828	8	applied	\N	\N	\N	\N	152565	152565	95219
30031	50894	0	applied	\N	\N	\N	\N	152661	152661	152662
30031	50895	1	applied	\N	\N	\N	\N	152663	152663	152664
30031	50896	2	applied	\N	\N	\N	\N	152665	152665	95580
30031	50897	3	applied	\N	\N	\N	\N	152666	152666	95596
30031	50898	4	applied	\N	\N	\N	\N	152667	152667	95598
30031	50899	5	applied	\N	\N	\N	\N	152668	152668	95958
30031	50900	6	applied	\N	\N	\N	\N	152669	152669	95959
30031	50901	7	applied	\N	\N	\N	\N	152670	152670	95960
30031	50902	8	applied	\N	\N	\N	\N	152671	152671	95634
30031	50903	9	applied	\N	\N	\N	\N	152672	152672	95651
30031	50904	10	applied	\N	\N	\N	\N	152673	152673	95962
30031	50905	11	applied	\N	\N	\N	\N	152674	152674	95964
30031	50906	12	applied	\N	\N	\N	\N	152675	152675	95681
30031	50907	13	applied	\N	\N	\N	\N	152676	152676	95683
30031	50908	14	applied	\N	\N	\N	\N	152677	152677	95687
30031	50909	15	applied	\N	\N	\N	\N	152678	152678	95966
30031	50910	16	applied	\N	\N	\N	\N	152679	152679	95968
30031	50911	17	applied	\N	\N	\N	\N	152680	152680	95726
30031	50912	18	applied	\N	\N	\N	\N	152681	152681	95969
30034	50931	0	applied	\N	\N	\N	\N	152722	152722	152723
30034	50932	1	applied	\N	\N	\N	\N	152724	152724	95913
30034	50933	2	applied	\N	\N	\N	\N	152725	152725	95915
30001	50392	96	applied	\N	\N	\N	\N	151704	151704	92114
30001	50393	97	applied	\N	\N	\N	\N	151705	151705	92132
30001	50426	98	applied	\N	\N	\N	\N	151780	151780	152379
30001	50427	99	applied	\N	\N	\N	\N	151781	151781	92147
30001	50430	100	applied	\N	\N	\N	\N	151785	151785	92173
30001	50431	101	applied	\N	\N	\N	\N	151787	151787	92168
30001	50434	102	applied	\N	\N	\N	\N	151796	151796	151772
30001	50440	103	applied	\N	\N	\N	\N	151805	151805	92184
30001	50441	104	applied	\N	\N	\N	\N	151806	151806	152380
30001	50442	105	applied	\N	\N	\N	\N	151807	151807	92201
30001	50447	106	applied	\N	\N	\N	\N	151820	151820	152381
30001	50448	107	applied	\N	\N	\N	\N	151821	151821	92218
30001	50449	108	applied	\N	\N	\N	\N	151823	151823	92465
30001	50450	109	applied	\N	\N	\N	\N	151825	151825	152382
30001	50451	110	applied	\N	\N	\N	\N	151826	151826	151798
30001	50458	111	applied	\N	\N	\N	\N	151840	151840	92255
30001	50460	112	applied	\N	\N	\N	\N	151844	151844	92265
30001	50461	113	applied	\N	\N	\N	\N	151845	151845	92280
30001	50465	114	applied	\N	\N	\N	\N	151851	151851	92470
30001	50466	115	applied	\N	\N	\N	\N	151853	151853	92306
30001	50467	116	applied	\N	\N	\N	\N	151854	151854	92317
30001	50468	117	applied	\N	\N	\N	\N	151856	151856	92473
30001	50469	118	applied	\N	\N	\N	\N	151857	151857	151822
30001	50470	119	applied	\N	\N	\N	\N	151859	151859	151824
30001	50472	120	applied	\N	\N	\N	\N	151864	151864	92345
30003	50734	0	applied	\N	\N	\N	\N	152404	152404	152405
30003	50735	1	applied	\N	\N	\N	\N	152406	152406	152407
30003	50736	2	applied	\N	\N	\N	\N	152408	152408	152409
30003	50737	3	applied	\N	\N	\N	\N	152410	152410	94163
30003	50738	4	applied	\N	\N	\N	\N	152411	152411	152412
30003	50739	5	applied	\N	\N	\N	\N	152413	152413	152414
30003	50740	6	applied	\N	\N	\N	\N	152415	152415	152416
30003	50741	7	applied	\N	\N	\N	\N	152417	152417	94197
30003	50742	8	applied	\N	\N	\N	\N	152418	152418	152419
30006	50743	0	applied	\N	\N	\N	\N	152422	152422	152423
30006	50744	1	applied	\N	\N	\N	\N	152424	152424	152425
30006	50745	2	applied	\N	\N	\N	\N	152426	152426	152427
30006	50746	3	applied	\N	\N	\N	\N	152428	152428	152429
30006	50747	4	applied	\N	\N	\N	\N	152430	152430	94207
30006	50748	5	applied	\N	\N	\N	\N	152431	152431	152432
30006	50749	6	applied	\N	\N	\N	\N	152433	152433	152434
30006	50750	7	applied	\N	\N	\N	\N	152435	152435	94247
30006	50751	8	applied	\N	\N	\N	\N	152436	152436	94249
30006	50752	9	applied	\N	\N	\N	\N	152437	152437	94255
30006	50753	10	applied	\N	\N	\N	\N	152438	152438	152439
30006	50754	11	applied	\N	\N	\N	\N	152440	152440	94297
30006	50755	12	applied	\N	\N	\N	\N	152441	152441	94301
30006	50756	13	applied	\N	\N	\N	\N	152442	152442	94305
30006	50757	14	applied	\N	\N	\N	\N	152443	152443	94323
30006	50758	15	applied	\N	\N	\N	\N	152444	152444	152445
30006	50759	16	applied	\N	\N	\N	\N	152446	152446	94331
30006	50760	17	applied	\N	\N	\N	\N	152447	152447	94362
30006	50761	18	applied	\N	\N	\N	\N	152448	152448	94344
30006	50762	19	applied	\N	\N	\N	\N	152449	152449	152450
30008	50773	0	applied	\N	\N	\N	\N	152471	152471	152472
30008	50774	1	applied	\N	\N	\N	\N	152473	152473	94400
30008	50775	2	applied	\N	\N	\N	\N	152474	152474	152475
30008	50776	3	applied	\N	\N	\N	\N	152476	152476	94412
30008	50777	4	applied	\N	\N	\N	\N	152477	152477	152478
30008	50778	5	applied	\N	\N	\N	\N	152479	152479	94432
30008	50779	6	applied	\N	\N	\N	\N	152480	152480	152481
30008	50780	7	applied	\N	\N	\N	\N	152482	152482	94457
30008	50781	8	applied	\N	\N	\N	\N	152483	152483	152484
30010	50773	0	applied	\N	\N	\N	\N	152471	152471	152472
30010	50774	1	applied	\N	\N	\N	\N	152473	152473	94400
30010	50775	2	applied	\N	\N	\N	\N	152474	152474	152475
30010	50776	3	applied	\N	\N	\N	\N	152476	152476	94412
30010	50777	4	applied	\N	\N	\N	\N	152477	152477	152478
30010	50778	5	applied	\N	\N	\N	\N	152479	152479	94432
30010	50779	6	applied	\N	\N	\N	\N	152480	152480	152481
30010	50780	7	applied	\N	\N	\N	\N	152482	152482	94457
30010	50781	8	applied	\N	\N	\N	\N	152483	152483	152484
30012	50811	0	applied	\N	\N	\N	\N	152535	152535	152536
30012	50812	1	applied	\N	\N	\N	\N	152537	152537	94812
30012	50813	2	applied	\N	\N	\N	\N	152538	152538	94817
30012	50814	3	applied	\N	\N	\N	\N	152539	152539	94819
30012	50815	4	applied	\N	\N	\N	\N	152540	152540	152541
30012	50816	5	applied	\N	\N	\N	\N	152542	152542	152543
30012	50817	6	applied	\N	\N	\N	\N	152544	152544	94840
30012	50818	7	applied	\N	\N	\N	\N	152545	152545	94863
30012	50819	8	applied	\N	\N	\N	\N	152546	152546	95213
30025	50868	0	applied	\N	\N	\N	\N	152620	152620	152621
30025	50869	1	applied	\N	\N	\N	\N	152622	152622	95385
30025	50870	2	applied	\N	\N	\N	\N	152623	152623	152624
30025	50871	3	applied	\N	\N	\N	\N	152625	152625	96231
30025	50872	4	applied	\N	\N	\N	\N	152626	152626	95415
30025	50874	5	applied	\N	\N	\N	\N	152628	152628	95423
30025	50875	6	applied	\N	\N	\N	\N	152629	152629	96234
30027	50868	0	applied	\N	\N	\N	\N	152620	152620	152621
30027	50870	1	applied	\N	\N	\N	\N	152623	152623	95380
30027	50874	2	applied	\N	\N	\N	\N	152628	152628	95385
30027	50875	3	applied	\N	\N	\N	\N	152629	152629	95387
30029	50876	0	applied	\N	\N	\N	\N	152636	152636	152637
30029	50877	1	applied	\N	\N	\N	\N	152638	152638	95435
30029	50873	2	applied	\N	\N	\N	\N	152627	152627	95439
30029	50878	3	applied	\N	\N	\N	\N	152639	152639	96237
30029	50879	4	applied	\N	\N	\N	\N	152640	152640	95449
30032	50894	0	applied	\N	\N	\N	\N	152661	152661	152662
30032	50895	1	applied	\N	\N	\N	\N	152663	152663	152664
30032	50896	2	applied	\N	\N	\N	\N	152665	152665	95580
30032	50897	3	applied	\N	\N	\N	\N	152666	152666	95596
30032	50898	4	applied	\N	\N	\N	\N	152667	152667	95598
30032	50899	5	applied	\N	\N	\N	\N	152668	152668	95958
30032	50900	6	applied	\N	\N	\N	\N	152669	152669	95959
30032	50901	7	applied	\N	\N	\N	\N	152670	152670	95960
30032	50902	8	applied	\N	\N	\N	\N	152671	152671	95634
30032	50903	9	applied	\N	\N	\N	\N	152672	152672	95651
30032	50904	10	applied	\N	\N	\N	\N	152673	152673	95962
30032	50905	11	applied	\N	\N	\N	\N	152674	152674	95964
30032	50906	12	applied	\N	\N	\N	\N	152675	152675	95681
30032	50907	13	applied	\N	\N	\N	\N	152676	152676	95683
30032	50908	14	applied	\N	\N	\N	\N	152677	152677	95687
30032	50909	15	applied	\N	\N	\N	\N	152678	152678	95966
30032	50910	16	applied	\N	\N	\N	\N	152679	152679	95968
30032	50911	17	applied	\N	\N	\N	\N	152680	152680	95726
30032	50912	18	applied	\N	\N	\N	\N	152681	152681	95969
30037	50942	0	applied	\N	\N	\N	\N	152745	152745	152746
30037	50943	1	applied	\N	\N	\N	\N	152747	152747	96039
30037	50944	2	applied	\N	\N	\N	\N	152748	152748	152749
30037	50945	3	applied	\N	\N	1000000000	\N	152750	152750	152751
30011	50803	21	applied	\N	\N	\N	\N	152522	152522	94688
30011	50804	22	applied	\N	\N	\N	\N	152523	152523	152524
30011	50805	23	applied	\N	\N	\N	\N	152525	152525	152526
30011	50806	24	applied	\N	\N	\N	\N	152527	152527	94726
30011	50807	25	applied	\N	\N	\N	\N	152528	152528	94757
30011	50808	26	applied	\N	\N	\N	\N	152529	152529	152530
30011	50809	27	applied	\N	\N	\N	\N	152531	152531	94797
30011	50810	28	applied	\N	\N	\N	\N	152532	152532	94801
30014	50829	0	applied	\N	\N	\N	\N	152567	152567	152568
30014	50830	1	applied	\N	\N	\N	\N	152569	152569	95282
30014	50831	2	applied	\N	\N	\N	\N	152570	152570	95028
30014	50832	3	applied	\N	\N	\N	\N	152571	152571	95221
30014	50833	4	applied	\N	\N	\N	\N	152572	152572	95050
30014	50834	5	applied	\N	\N	\N	\N	152573	152573	95052
30014	50835	6	applied	\N	\N	\N	\N	152574	152574	95069
30014	50836	7	applied	\N	\N	\N	\N	152575	152575	95223
30014	50837	8	applied	\N	\N	\N	\N	152576	152576	95224
30016	50838	0	applied	\N	\N	\N	\N	152579	152579	152580
30016	50839	1	applied	\N	\N	\N	\N	152581	152581	152582
30016	50840	2	applied	\N	\N	\N	\N	152583	152583	152584
30016	50841	3	applied	\N	\N	\N	\N	152585	152585	95090
30016	50842	4	applied	\N	\N	\N	\N	152586	152586	95307
30016	50843	5	applied	\N	\N	\N	\N	152587	152587	95106
30016	50844	6	applied	\N	\N	\N	\N	152588	152588	95308
30016	50845	7	applied	\N	\N	\N	\N	152589	152589	95108
30016	50846	8	applied	\N	\N	\N	\N	152590	152590	95309
30016	50847	9	applied	\N	\N	\N	\N	152591	152591	95310
30016	50848	10	applied	\N	\N	\N	\N	152592	152592	95121
30016	50849	11	applied	\N	\N	\N	\N	152593	152593	95123
30016	50850	12	applied	\N	\N	\N	\N	152594	152594	95132
30016	50851	13	applied	\N	\N	\N	\N	152595	152595	95311
30016	50852	14	applied	\N	\N	\N	\N	152596	152596	95312
30016	50853	15	applied	\N	\N	\N	\N	152597	152597	95313
30016	50854	16	applied	\N	\N	\N	\N	152598	152598	95314
30016	50855	17	applied	\N	\N	\N	\N	152599	152599	95170
30016	50856	18	applied	\N	\N	\N	\N	152600	152600	95187
30016	50857	19	applied	\N	\N	\N	\N	152601	152601	95199
30016	50858	20	applied	\N	\N	\N	\N	152602	152602	95316
30016	50859	21	applied	\N	\N	\N	\N	152603	152603	95240
30016	50860	22	applied	\N	\N	\N	\N	152604	152604	95254
30016	50861	23	applied	\N	\N	\N	\N	152605	152605	95317
30016	50862	24	applied	\N	\N	\N	\N	152606	152606	95319
30016	50863	25	applied	\N	\N	\N	\N	152607	152607	95295
30016	50864	26	applied	\N	\N	\N	\N	152608	152608	95331
30016	50865	27	applied	\N	\N	\N	\N	152609	152609	152610
30016	50866	28	applied	\N	\N	\N	\N	152611	152611	152612
30016	50867	29	applied	\N	\N	\N	\N	152613	152613	95374
30020	50838	0	applied	\N	\N	\N	\N	152579	152579	152580
30020	50839	1	applied	\N	\N	\N	\N	152581	152581	152582
30020	50840	2	applied	\N	\N	\N	\N	152583	152583	152584
30020	50841	3	applied	\N	\N	\N	\N	152585	152585	95090
30020	50842	4	applied	\N	\N	\N	\N	152586	152586	95307
30020	50843	5	applied	\N	\N	\N	\N	152587	152587	95106
30020	50844	6	applied	\N	\N	\N	\N	152588	152588	95308
30020	50845	7	applied	\N	\N	\N	\N	152589	152589	95108
30020	50846	8	applied	\N	\N	\N	\N	152590	152590	95309
30020	50847	9	applied	\N	\N	\N	\N	152591	152591	95310
30020	50848	10	applied	\N	\N	\N	\N	152592	152592	95121
30020	50849	11	applied	\N	\N	\N	\N	152593	152593	95123
30020	50850	12	applied	\N	\N	\N	\N	152594	152594	95132
30020	50851	13	applied	\N	\N	\N	\N	152595	152595	95311
30020	50852	14	applied	\N	\N	\N	\N	152596	152596	95312
30020	50853	15	applied	\N	\N	\N	\N	152597	152597	95313
30020	50854	16	applied	\N	\N	\N	\N	152598	152598	95314
30020	50855	17	applied	\N	\N	\N	\N	152599	152599	95170
30020	50856	18	applied	\N	\N	\N	\N	152600	152600	95187
30020	50857	19	applied	\N	\N	\N	\N	152601	152601	95199
30020	50858	20	applied	\N	\N	\N	\N	152602	152602	95316
30020	50859	21	applied	\N	\N	\N	\N	152603	152603	95240
30020	50860	22	applied	\N	\N	\N	\N	152604	152604	95254
30020	50861	23	applied	\N	\N	\N	\N	152605	152605	95317
30020	50862	24	applied	\N	\N	\N	\N	152606	152606	95319
30020	50863	25	applied	\N	\N	\N	\N	152607	152607	95295
30020	50864	26	applied	\N	\N	\N	\N	152608	152608	95331
30020	50865	27	applied	\N	\N	\N	\N	152609	152609	152610
30020	50866	28	applied	\N	\N	\N	\N	152611	152611	152612
30020	50867	29	applied	\N	\N	\N	\N	152613	152613	95374
30024	50868	0	applied	\N	\N	\N	\N	152620	152620	152621
30024	50869	1	applied	\N	\N	\N	\N	152622	152622	95385
30024	50870	2	applied	\N	\N	\N	\N	152623	152623	152624
30024	50871	3	applied	\N	\N	\N	\N	152625	152625	96231
30024	50872	4	applied	\N	\N	\N	\N	152626	152626	95415
30024	50873	5	applied	\N	\N	\N	\N	152627	152627	95433
30024	50874	6	applied	\N	\N	\N	\N	152628	152628	96235
30024	50875	7	applied	\N	\N	\N	\N	152629	152629	95437
30026	50868	0	applied	\N	\N	\N	\N	152620	152620	152621
30026	50875	1	applied	\N	\N	\N	\N	152629	152629	152633
30028	50876	0	applied	\N	\N	\N	\N	152636	152636	152637
30028	50877	1	applied	\N	\N	\N	\N	152638	152638	95435
30028	50873	2	applied	\N	\N	\N	\N	152627	152627	95439
30028	50878	3	applied	\N	\N	\N	\N	152639	152639	96237
30028	50879	4	applied	\N	\N	\N	\N	152640	152640	95449
30028	50880	5	applied	\N	\N	\N	\N	152641	152641	96238
30030	50881	0	applied	\N	\N	\N	\N	152645	152645	152646
30030	50882	1	applied	\N	\N	\N	\N	152647	152647	96240
30030	50883	2	applied	\N	\N	\N	\N	152648	152648	95477
30030	50884	3	applied	\N	\N	\N	\N	152649	152649	95490
30030	50885	4	applied	\N	\N	\N	\N	152650	152650	95505
30030	50886	5	applied	\N	\N	\N	\N	152651	152651	95949
30030	50887	6	applied	\N	\N	\N	\N	152652	152652	95533
30030	50888	7	applied	\N	\N	\N	\N	152653	152653	95545
30030	50889	8	applied	\N	\N	\N	\N	152654	152654	95954
30030	50890	9	applied	\N	\N	\N	\N	152655	152655	95956
30030	50891	10	applied	\N	\N	\N	\N	152656	152656	95957
30030	50892	11	applied	\N	\N	\N	\N	152657	152657	95574
30030	50893	12	applied	\N	\N	\N	\N	152658	152658	152659
30033	50913	0	applied	\N	\N	\N	\N	152686	152686	152687
30033	50914	1	applied	\N	\N	\N	\N	152688	152688	152689
30033	50915	2	applied	\N	\N	\N	\N	152690	152690	95970
30033	50916	3	applied	\N	\N	\N	\N	152691	152691	95748
30033	50917	5	applied	\N	\N	\N	\N	152693	152693	95750
30033	50918	6	applied	\N	\N	\N	\N	152694	152694	152695
30033	50919	7	applied	\N	\N	\N	\N	152696	152696	152697
30033	50920	8	applied	\N	\N	\N	\N	152698	152698	95789
30033	50921	9	applied	\N	\N	\N	\N	152699	152699	152700
30033	50922	10	applied	\N	\N	\N	\N	152701	152701	95793
30033	50923	11	applied	\N	\N	\N	\N	152702	152702	95799
30033	50924	12	applied	\N	\N	\N	\N	152703	152703	95813
30033	50925	13	applied	\N	\N	\N	\N	152704	152704	152705
30033	50926	14	applied	\N	\N	\N	\N	152706	152706	95854
30019	50858	20	applied	\N	\N	\N	\N	152602	152602	95316
30019	50859	21	applied	\N	\N	\N	\N	152603	152603	95240
30019	50860	22	applied	\N	\N	\N	\N	152604	152604	95254
30019	50861	23	applied	\N	\N	\N	\N	152605	152605	95317
30019	50862	24	applied	\N	\N	\N	\N	152606	152606	95319
30019	50863	25	applied	\N	\N	\N	\N	152607	152607	95295
30019	50864	26	applied	\N	\N	\N	\N	152608	152608	95331
30019	50865	27	applied	\N	\N	\N	\N	152609	152609	152610
30019	50866	28	applied	\N	\N	\N	\N	152611	152611	152612
30019	50867	29	applied	\N	\N	\N	\N	152613	152613	95374
30039	50952	0	applied	\N	\N	\N	\N	152766	152766	152767
30039	50953	1	applied	\N	\N	\N	\N	152768	152768	152769
30039	50954	2	applied	\N	\N	\N	\N	152770	152770	152771
30039	50955	3	applied	\N	\N	\N	\N	152772	152772	96111
30039	50956	4	applied	\N	\N	\N	\N	152773	152773	96132
30039	50957	5	applied	\N	\N	\N	\N	152774	152774	96145
30039	50958	6	applied	\N	\N	\N	\N	152775	152775	97267
30039	50959	7	applied	\N	\N	\N	\N	152776	152776	96155
30039	50960	8	applied	\N	\N	\N	\N	152777	152777	96163
30039	50961	9	applied	\N	\N	\N	\N	152778	152778	152779
30039	50962	10	applied	\N	\N	\N	\N	152780	152780	152781
30039	50963	11	applied	\N	\N	\N	\N	152782	152782	96184
30039	50964	12	applied	\N	\N	\N	\N	152783	152783	152784
30039	50965	13	applied	\N	\N	\N	\N	152785	152785	96191
30039	50966	14	applied	\N	\N	\N	\N	152786	152786	96195
30039	50967	15	applied	\N	\N	\N	\N	152787	152787	152788
30039	50968	16	applied	\N	\N	\N	\N	152789	152789	98386
30039	50969	17	applied	\N	\N	\N	\N	152790	152790	96268
30039	50970	18	applied	\N	\N	\N	\N	152791	152791	96282
30039	50971	19	applied	\N	\N	\N	\N	152792	152792	98388
30039	50972	20	applied	\N	\N	\N	\N	152793	152793	96292
30039	50973	21	applied	\N	\N	\N	\N	152794	152794	152795
30043	50974	0	applied	\N	\N	\N	\N	152802	152802	152803
30043	50975	1	applied	\N	\N	\N	\N	152804	152804	152805
30043	50976	2	applied	\N	\N	\N	\N	152806	152806	152807
30043	50977	3	applied	\N	\N	\N	\N	152808	152808	96306
30043	50978	4	applied	\N	\N	\N	\N	152809	152809	98389
30043	50979	5	applied	\N	\N	\N	\N	152810	152810	152810
30043	50980	6	applied	\N	\N	1000000000	\N	152811	152811	152812
30043	50981	7	applied	\N	\N	\N	\N	152813	152813	96333
30043	50982	8	applied	\N	\N	\N	\N	152814	152814	96338
30043	50983	9	applied	\N	\N	\N	\N	152815	152815	96360
30043	50984	10	applied	\N	\N	\N	\N	152816	152816	152817
30043	50985	11	applied	\N	\N	\N	\N	152818	152818	96387
30043	50986	12	applied	\N	\N	\N	\N	152819	152819	96402
30043	50987	13	applied	\N	\N	\N	\N	152820	152820	152821
30043	50988	14	applied	\N	\N	\N	\N	152822	152822	96433
30043	50989	15	applied	\N	\N	\N	\N	152823	152823	96435
30043	50990	16	applied	\N	\N	\N	\N	152824	152824	96444
30043	50991	17	applied	\N	\N	\N	\N	152825	152825	96450
30043	50992	18	applied	\N	\N	\N	\N	152826	152826	96456
30043	50993	19	applied	\N	\N	\N	\N	152827	152827	96458
30043	50994	20	applied	\N	\N	\N	\N	152828	152828	152829
30044	50974	0	applied	\N	\N	\N	\N	152802	152802	152803
30044	50975	1	applied	\N	\N	\N	\N	152804	152804	152805
30044	50976	2	applied	\N	\N	\N	\N	152806	152806	152807
30044	50977	3	applied	\N	\N	\N	\N	152808	152808	96306
30044	50978	4	applied	\N	\N	\N	\N	152809	152809	98389
30044	50979	5	applied	\N	\N	\N	\N	152810	152810	152810
30044	50980	6	applied	\N	\N	1000000000	\N	152811	152811	152812
30044	50981	7	applied	\N	\N	\N	\N	152813	152813	96333
30044	50982	8	applied	\N	\N	\N	\N	152814	152814	96338
30044	50983	9	applied	\N	\N	\N	\N	152815	152815	96360
30044	50984	10	applied	\N	\N	\N	\N	152816	152816	152817
30044	50985	11	applied	\N	\N	\N	\N	152818	152818	96387
30044	50986	12	applied	\N	\N	\N	\N	152819	152819	96402
30044	50987	13	applied	\N	\N	\N	\N	152820	152820	152821
30044	50988	14	applied	\N	\N	\N	\N	152822	152822	96433
30044	50989	15	applied	\N	\N	\N	\N	152823	152823	96435
30044	50990	16	applied	\N	\N	\N	\N	152824	152824	96444
30044	50991	17	applied	\N	\N	\N	\N	152825	152825	96450
30044	50992	18	applied	\N	\N	\N	\N	152826	152826	96456
30044	50993	19	applied	\N	\N	\N	\N	152827	152827	96458
30044	50994	20	applied	\N	\N	\N	\N	152828	152828	152829
30048	51015	0	applied	\N	\N	\N	\N	152865	152865	152866
30048	51016	1	applied	\N	\N	\N	\N	152867	152867	152868
30048	51017	2	applied	\N	\N	\N	\N	152869	152869	96610
30048	51018	3	applied	\N	\N	\N	\N	152870	152870	96622
30048	51019	4	applied	\N	\N	\N	\N	152871	152871	96624
30048	51020	5	applied	\N	\N	\N	\N	152872	152872	96630
30048	51021	6	applied	\N	\N	\N	\N	152873	152873	96637
30048	51022	7	applied	\N	\N	\N	\N	152874	152874	96648
30048	51023	8	applied	\N	\N	\N	\N	152875	152875	96660
30048	51024	9	applied	\N	\N	\N	\N	152876	152876	96668
30054	51042	0	applied	\N	\N	\N	\N	152912	152912	152913
30054	51043	1	applied	\N	\N	\N	\N	152914	152914	96842
30054	51044	2	applied	\N	\N	\N	\N	152915	152915	96853
30054	51045	3	applied	\N	\N	\N	\N	152916	152916	96855
30054	51046	4	applied	\N	\N	\N	\N	152917	152917	152918
30054	51047	5	applied	\N	\N	\N	\N	152919	152919	96857
30054	51048	6	applied	\N	\N	\N	\N	152920	152920	96873
30054	51049	7	applied	\N	\N	\N	\N	152921	152921	96885
30054	51050	8	applied	\N	\N	\N	\N	152922	152922	96900
30054	51051	9	applied	\N	\N	\N	\N	152923	152923	152924
30057	51052	0	applied	\N	\N	\N	\N	152929	152929	152930
30057	51053	1	applied	\N	\N	\N	\N	152931	152931	152932
30057	51054	2	applied	\N	\N	\N	\N	152933	152933	96913
30057	51055	3	applied	\N	\N	\N	\N	152934	152934	152935
30057	51056	4	applied	\N	\N	\N	\N	152936	152936	98859
30057	51057	5	applied	\N	\N	\N	\N	152937	152937	152938
30057	51058	6	applied	\N	\N	\N	\N	152939	152939	152940
30057	51059	7	applied	\N	\N	\N	\N	152941	152941	98860
30057	51060	8	applied	\N	\N	\N	\N	152942	152942	152943
30057	51061	9	applied	\N	\N	\N	\N	152944	152944	152945
30057	51062	10	applied	\N	\N	\N	\N	152946	152946	152947
30057	51063	11	applied	\N	\N	\N	\N	152948	152948	96956
30057	51064	12	applied	\N	\N	\N	\N	152949	152949	96966
30057	51065	13	applied	\N	\N	\N	\N	152950	152950	96983
30057	51066	14	applied	\N	\N	\N	\N	152951	152951	96997
30057	51067	15	applied	\N	\N	\N	\N	152952	152952	97029
30057	51068	16	applied	\N	\N	\N	\N	152953	152953	97053
30057	51069	17	applied	\N	\N	\N	\N	152954	152954	98865
30057	51070	18	applied	\N	\N	\N	\N	152955	152955	152956
30057	51071	19	applied	\N	\N	\N	\N	152957	152957	152958
30063	51131	0	applied	\N	\N	\N	\N	153065	153065	153066
30063	51132	1	applied	\N	\N	\N	\N	153067	153067	97473
30063	51133	2	applied	\N	\N	\N	\N	153068	153068	153069
30063	51134	3	applied	\N	\N	\N	\N	153070	153070	153071
30063	51135	4	applied	\N	\N	\N	\N	153072	153072	97479
30033	50927	15	applied	\N	\N	\N	\N	152707	152707	95864
30033	50928	16	applied	\N	\N	\N	\N	152708	152708	95875
30033	50929	17	applied	\N	\N	\N	\N	152709	152709	98727
30033	50930	18	applied	\N	\N	\N	\N	152710	152710	152711
30035	50931	0	applied	\N	\N	\N	\N	152722	152722	152723
30035	50932	1	applied	\N	\N	\N	\N	152724	152724	95913
30035	50933	2	applied	\N	\N	\N	\N	152725	152725	95915
30035	50934	3	applied	\N	\N	\N	\N	152726	152726	95935
30035	50935	4	applied	\N	\N	\N	\N	152727	152727	95937
30035	50936	5	applied	\N	\N	\N	\N	152728	152728	95941
30035	50937	6	applied	\N	\N	\N	\N	152729	152729	152730
30035	50938	7	applied	\N	\N	\N	\N	152731	152731	95980
30035	50939	8	applied	\N	\N	\N	\N	152732	152732	96000
30035	50940	9	applied	\N	\N	\N	\N	152733	152733	96004
30035	50941	10	applied	\N	\N	\N	\N	152734	152734	152735
30041	50952	0	applied	\N	\N	\N	\N	152766	152766	152767
30041	50953	1	applied	\N	\N	\N	\N	152768	152768	152769
30041	50954	2	applied	\N	\N	\N	\N	152770	152770	152771
30041	50955	3	applied	\N	\N	\N	\N	152772	152772	96111
30041	50956	4	applied	\N	\N	\N	\N	152773	152773	96132
30041	50957	5	applied	\N	\N	\N	\N	152774	152774	96145
30041	50958	6	applied	\N	\N	\N	\N	152775	152775	97267
30041	50959	7	applied	\N	\N	\N	\N	152776	152776	96155
30041	50960	8	applied	\N	\N	\N	\N	152777	152777	96163
30041	50961	9	applied	\N	\N	\N	\N	152778	152778	152779
30041	50962	10	applied	\N	\N	\N	\N	152780	152780	152781
30041	50963	11	applied	\N	\N	\N	\N	152782	152782	96184
30041	50964	12	applied	\N	\N	\N	\N	152783	152783	152784
30041	50965	13	applied	\N	\N	\N	\N	152785	152785	96191
30041	50966	14	applied	\N	\N	\N	\N	152786	152786	96195
30041	50967	15	applied	\N	\N	\N	\N	152787	152787	152788
30041	50968	16	applied	\N	\N	\N	\N	152789	152789	98386
30041	50969	17	applied	\N	\N	\N	\N	152790	152790	96268
30041	50970	18	applied	\N	\N	\N	\N	152791	152791	96282
30041	50971	19	applied	\N	\N	\N	\N	152792	152792	98388
30041	50972	20	applied	\N	\N	\N	\N	152793	152793	96292
30041	50973	21	applied	\N	\N	\N	\N	152794	152794	152795
30047	50995	0	applied	\N	\N	\N	\N	152833	152833	152834
30047	50996	1	applied	\N	\N	\N	\N	152835	152835	152836
30047	50997	2	applied	\N	\N	\N	\N	152837	152837	152838
30047	50998	3	applied	\N	\N	\N	\N	152839	152839	96465
30047	50999	4	applied	\N	\N	\N	\N	152840	152840	152841
30047	51000	5	applied	\N	\N	\N	\N	152842	152842	96467
30047	51001	6	applied	\N	\N	\N	\N	152843	152843	152844
30047	51002	7	applied	\N	\N	\N	\N	152845	152845	152846
30047	51003	8	applied	\N	\N	\N	\N	152847	152847	96497
30047	51004	9	applied	\N	\N	\N	\N	152848	152848	96511
30047	51005	10	applied	\N	\N	\N	\N	152849	152849	152850
30047	51006	11	applied	\N	\N	\N	\N	152851	152851	96545
30047	51007	12	applied	\N	\N	\N	\N	152852	152852	96546
30047	51008	13	applied	\N	\N	\N	\N	152853	152853	96547
30047	51009	14	applied	\N	\N	\N	\N	152854	152854	96549
30047	51010	15	applied	\N	\N	\N	\N	152855	152855	96564
30047	51011	16	applied	\N	\N	\N	\N	152856	152856	152857
30047	51012	17	applied	\N	\N	\N	\N	152858	152858	96591
30047	51013	18	applied	\N	\N	\N	\N	152859	152859	96595
30047	51014	19	applied	\N	\N	\N	\N	152860	152860	96604
30051	51025	0	applied	\N	\N	\N	\N	152882	152882	152883
30051	51026	1	applied	\N	\N	\N	\N	152884	152884	152885
30051	51027	2	applied	\N	\N	\N	\N	152886	152886	96676
30051	51028	3	applied	\N	\N	\N	\N	152887	152887	98846
30051	51029	4	applied	\N	\N	\N	\N	152888	152888	96682
30051	51030	5	applied	\N	\N	\N	\N	152889	152889	96690
30051	51031	6	applied	\N	\N	\N	\N	152890	152890	96695
30051	51032	7	applied	\N	\N	\N	\N	152891	152891	96705
30051	51033	8	applied	\N	\N	\N	\N	152892	152892	96722
30051	51034	9	applied	\N	\N	\N	\N	152893	152893	96737
30051	51035	10	applied	\N	\N	\N	\N	152894	152894	96744
30051	51036	11	applied	\N	\N	\N	\N	152895	152895	96756
30051	51037	12	applied	\N	\N	\N	\N	152896	152896	96783
30051	51038	13	applied	\N	\N	\N	\N	152897	152897	96787
30051	51039	14	applied	\N	\N	\N	\N	152898	152898	96799
30051	51040	15	applied	\N	\N	\N	\N	152899	152899	96811
30051	51041	16	applied	\N	\N	\N	\N	152900	152900	96837
30056	51052	0	applied	\N	\N	\N	\N	152929	152929	152930
30056	51053	1	applied	\N	\N	\N	\N	152931	152931	152932
30056	51054	2	applied	\N	\N	\N	\N	152933	152933	96913
30056	51055	3	applied	\N	\N	\N	\N	152934	152934	152935
30056	51056	4	applied	\N	\N	\N	\N	152936	152936	98859
30056	51057	5	applied	\N	\N	\N	\N	152937	152937	152938
30056	51058	6	applied	\N	\N	\N	\N	152939	152939	152940
30056	51059	7	applied	\N	\N	\N	\N	152941	152941	98860
30056	51060	8	applied	\N	\N	\N	\N	152942	152942	152943
30056	51061	9	applied	\N	\N	\N	\N	152944	152944	152945
30056	51062	10	applied	\N	\N	\N	\N	152946	152946	152947
30056	51063	11	applied	\N	\N	\N	\N	152948	152948	96956
30056	51064	12	applied	\N	\N	\N	\N	152949	152949	96966
30056	51065	13	applied	\N	\N	\N	\N	152950	152950	96983
30056	51066	14	applied	\N	\N	\N	\N	152951	152951	96997
30056	51067	15	applied	\N	\N	\N	\N	152952	152952	97029
30056	51068	16	applied	\N	\N	\N	\N	152953	152953	97053
30056	51069	17	applied	\N	\N	\N	\N	152954	152954	98865
30056	51070	18	applied	\N	\N	\N	\N	152955	152955	152956
30056	51071	19	applied	\N	\N	\N	\N	152957	152957	152958
30060	51091	0	applied	\N	\N	\N	\N	152999	152999	153000
30060	51092	1	applied	\N	\N	\N	\N	153001	153001	97285
30060	51093	2	applied	\N	\N	\N	\N	153002	153002	153003
30060	51094	3	applied	\N	\N	\N	\N	153004	153004	97289
30060	51095	4	applied	\N	\N	\N	\N	153005	153005	153006
30060	51096	5	applied	\N	\N	\N	\N	153007	153007	97303
30060	51097	6	applied	\N	\N	\N	\N	153008	153008	153009
30060	51098	7	applied	\N	\N	\N	\N	153010	153010	97313
30068	51167	0	applied	\N	\N	\N	\N	153139	153139	153140
30068	51168	1	applied	\N	\N	\N	\N	153141	153141	153142
30068	51169	2	applied	\N	\N	\N	\N	153143	153143	97907
30068	51170	3	applied	\N	\N	\N	\N	153144	153144	97630
30068	51171	4	applied	\N	\N	\N	\N	153145	153145	97634
30068	51172	5	applied	\N	\N	\N	\N	153146	153146	97636
30070	51167	0	applied	\N	\N	\N	\N	153139	153139	153140
30070	51168	1	applied	\N	\N	\N	\N	153141	153141	153142
30070	51169	2	applied	\N	\N	\N	\N	153143	153143	97907
30070	51170	3	applied	\N	\N	\N	\N	153144	153144	97630
30070	51173	4	applied	\N	\N	\N	\N	153149	153149	97636
30070	51174	5	applied	\N	\N	\N	\N	153150	153150	97645
30070	51175	6	applied	\N	\N	\N	\N	153151	153151	153152
30070	51176	7	applied	\N	\N	\N	\N	153153	153153	153154
30070	51177	8	applied	\N	\N	\N	\N	153155	153155	97663
30070	51171	9	applied	\N	\N	\N	\N	153145	153145	153156
30070	51172	10	applied	\N	\N	\N	\N	153146	153146	153157
30076	51197	0	applied	\N	\N	\N	\N	153195	153195	153196
30034	50934	3	applied	\N	\N	\N	\N	152726	152726	95935
30034	50935	4	applied	\N	\N	\N	\N	152727	152727	95937
30034	50936	5	applied	\N	\N	\N	\N	152728	152728	95941
30034	50937	6	applied	\N	\N	\N	\N	152729	152729	152730
30034	50938	7	applied	\N	\N	\N	\N	152731	152731	95980
30034	50939	8	applied	\N	\N	\N	\N	152732	152732	96000
30034	50940	9	applied	\N	\N	\N	\N	152733	152733	96004
30034	50941	10	applied	\N	\N	\N	\N	152734	152734	152735
30036	50396	0	applied	\N	\N	1000000000	\N	151710	151710	151711
30036	50397	1	applied	\N	\N	1000000000	\N	151712	151712	151713
30038	50942	0	applied	\N	\N	\N	\N	152745	152745	152746
30038	50943	1	applied	\N	\N	\N	\N	152747	152747	96039
30038	50944	2	applied	\N	\N	\N	\N	152748	152748	152749
30038	50945	3	applied	\N	\N	1000000000	\N	152750	152750	152751
30038	50946	4	applied	\N	\N	1000000000	\N	152752	152752	152753
30038	50947	5	applied	\N	\N	\N	\N	152754	152754	152755
30038	50948	6	applied	\N	\N	\N	\N	152756	152756	96069
30038	50949	7	applied	\N	\N	\N	\N	152757	152757	96088
30038	50950	8	applied	\N	\N	\N	\N	152758	152758	152759
30038	50951	9	applied	\N	\N	\N	\N	152760	152760	152761
30042	50974	0	applied	\N	\N	\N	\N	152802	152802	152803
30042	50975	1	applied	\N	\N	\N	\N	152804	152804	152805
30042	50976	2	applied	\N	\N	\N	\N	152806	152806	152807
30042	50977	3	applied	\N	\N	\N	\N	152808	152808	96306
30042	50978	4	applied	\N	\N	\N	\N	152809	152809	98389
30042	50979	5	applied	\N	\N	\N	\N	152810	152810	152810
30042	50980	6	applied	\N	\N	1000000000	\N	152811	152811	152812
30042	50981	7	applied	\N	\N	\N	\N	152813	152813	96333
30042	50982	8	applied	\N	\N	\N	\N	152814	152814	96338
30042	50983	9	applied	\N	\N	\N	\N	152815	152815	96360
30042	50984	10	applied	\N	\N	\N	\N	152816	152816	152817
30042	50985	11	applied	\N	\N	\N	\N	152818	152818	96387
30042	50986	12	applied	\N	\N	\N	\N	152819	152819	96402
30042	50987	13	applied	\N	\N	\N	\N	152820	152820	152821
30042	50988	14	applied	\N	\N	\N	\N	152822	152822	96433
30042	50989	15	applied	\N	\N	\N	\N	152823	152823	96435
30042	50990	16	applied	\N	\N	\N	\N	152824	152824	96444
30042	50991	17	applied	\N	\N	\N	\N	152825	152825	96450
30042	50992	18	applied	\N	\N	\N	\N	152826	152826	96456
30042	50993	19	applied	\N	\N	\N	\N	152827	152827	96458
30042	50994	20	applied	\N	\N	\N	\N	152828	152828	152829
30045	50995	0	applied	\N	\N	\N	\N	152833	152833	152834
30045	50996	1	applied	\N	\N	\N	\N	152835	152835	152836
30045	50997	2	applied	\N	\N	\N	\N	152837	152837	152838
30045	50998	3	applied	\N	\N	\N	\N	152839	152839	96465
30045	50999	4	applied	\N	\N	\N	\N	152840	152840	152841
30045	51000	5	applied	\N	\N	\N	\N	152842	152842	96467
30045	51001	6	applied	\N	\N	\N	\N	152843	152843	152844
30045	51002	7	applied	\N	\N	\N	\N	152845	152845	152846
30045	51003	8	applied	\N	\N	\N	\N	152847	152847	96497
30045	51004	9	applied	\N	\N	\N	\N	152848	152848	96511
30045	51005	10	applied	\N	\N	\N	\N	152849	152849	152850
30045	51006	11	applied	\N	\N	\N	\N	152851	152851	96545
30045	51007	12	applied	\N	\N	\N	\N	152852	152852	96546
30045	51008	13	applied	\N	\N	\N	\N	152853	152853	96547
30045	51009	14	applied	\N	\N	\N	\N	152854	152854	96549
30045	51010	15	applied	\N	\N	\N	\N	152855	152855	96564
30045	51011	16	applied	\N	\N	\N	\N	152856	152856	152857
30045	51012	17	applied	\N	\N	\N	\N	152858	152858	96591
30045	51013	18	applied	\N	\N	\N	\N	152859	152859	96595
30045	51014	19	applied	\N	\N	\N	\N	152860	152860	96604
30053	51042	0	applied	\N	\N	\N	\N	152912	152912	152913
30053	51043	1	applied	\N	\N	\N	\N	152914	152914	96842
30053	51044	2	applied	\N	\N	\N	\N	152915	152915	96853
30053	51045	3	applied	\N	\N	\N	\N	152916	152916	96855
30053	51046	4	applied	\N	\N	\N	\N	152917	152917	152918
30053	51047	5	applied	\N	\N	\N	\N	152919	152919	96857
30053	51048	6	applied	\N	\N	\N	\N	152920	152920	96873
30053	51049	7	applied	\N	\N	\N	\N	152921	152921	96885
30053	51050	8	applied	\N	\N	\N	\N	152922	152922	96900
30053	51051	9	applied	\N	\N	\N	\N	152923	152923	152924
30055	51052	0	applied	\N	\N	\N	\N	152929	152929	152930
30055	51053	1	applied	\N	\N	\N	\N	152931	152931	152932
30055	51054	2	applied	\N	\N	\N	\N	152933	152933	96913
30055	51055	3	applied	\N	\N	\N	\N	152934	152934	152935
30055	51056	4	applied	\N	\N	\N	\N	152936	152936	98859
30055	51057	5	applied	\N	\N	\N	\N	152937	152937	152938
30055	51058	6	applied	\N	\N	\N	\N	152939	152939	152940
30055	51059	7	applied	\N	\N	\N	\N	152941	152941	98860
30055	51060	8	applied	\N	\N	\N	\N	152942	152942	152943
30055	51061	9	applied	\N	\N	\N	\N	152944	152944	152945
30055	51062	10	applied	\N	\N	\N	\N	152946	152946	152947
30055	51063	11	applied	\N	\N	\N	\N	152948	152948	96956
30055	51064	12	applied	\N	\N	\N	\N	152949	152949	96966
30055	51065	13	applied	\N	\N	\N	\N	152950	152950	96983
30055	51066	14	applied	\N	\N	\N	\N	152951	152951	96997
30055	51067	15	applied	\N	\N	\N	\N	152952	152952	97029
30055	51068	16	applied	\N	\N	\N	\N	152953	152953	97053
30055	51069	17	applied	\N	\N	\N	\N	152954	152954	98865
30055	51070	18	applied	\N	\N	\N	\N	152955	152955	152956
30055	51071	19	applied	\N	\N	\N	\N	152957	152957	152958
30058	51072	0	applied	\N	\N	\N	\N	152965	152965	152966
30058	51073	1	applied	\N	\N	\N	\N	152967	152967	152968
30058	51074	2	applied	\N	\N	\N	\N	152969	152969	152970
30058	51075	3	applied	\N	\N	\N	\N	152971	152971	152972
30058	51076	4	applied	\N	\N	\N	\N	152973	152973	152974
30058	51077	5	applied	\N	\N	\N	\N	152975	152975	97271
30058	51078	6	applied	\N	\N	\N	\N	152976	152976	152977
30058	51079	7	applied	\N	\N	\N	\N	152978	152978	97272
30058	51080	8	applied	\N	\N	\N	\N	152979	152979	152980
30058	51081	9	applied	\N	\N	\N	\N	152981	152981	97177
30058	51082	10	applied	\N	\N	\N	\N	152982	152982	97195
30058	51083	11	applied	\N	\N	\N	\N	152983	152983	152984
30058	51084	12	applied	\N	\N	\N	\N	152985	152985	152986
30058	51085	13	applied	\N	\N	\N	\N	152987	152987	152988
30058	51086	14	applied	\N	\N	\N	\N	152989	152989	97249
30058	51087	15	applied	\N	\N	\N	\N	152990	152990	152991
30058	51088	16	applied	\N	\N	\N	\N	152992	152992	97255
30058	51089	17	applied	\N	\N	\N	\N	152993	152993	97278
30058	51090	18	applied	\N	\N	\N	\N	152994	152994	97259
30061	51099	0	applied	\N	\N	\N	\N	153012	153012	153013
30061	51100	1	applied	\N	\N	\N	\N	153014	153014	153015
30061	51101	2	applied	\N	\N	\N	\N	153016	153016	153017
30061	51102	3	applied	\N	\N	1000000000	\N	153018	153018	153019
30061	51103	4	applied	\N	\N	\N	\N	153020	153020	153021
30061	51104	5	applied	\N	\N	\N	\N	153022	153022	153023
30061	51105	6	applied	\N	\N	\N	\N	153024	153024	97319
30061	51106	7	applied	\N	\N	\N	\N	153025	153025	153026
30061	51107	8	applied	\N	\N	\N	\N	153027	153027	97321
30037	50946	4	applied	\N	\N	1000000000	\N	152752	152752	152753
30037	50947	5	applied	\N	\N	\N	\N	152754	152754	152755
30037	50948	6	applied	\N	\N	\N	\N	152756	152756	96069
30037	50949	7	applied	\N	\N	\N	\N	152757	152757	96088
30037	50950	8	applied	\N	\N	\N	\N	152758	152758	152759
30037	50951	9	applied	\N	\N	\N	\N	152760	152760	152761
30040	50952	0	applied	\N	\N	\N	\N	152766	152766	152767
30040	50953	1	applied	\N	\N	\N	\N	152768	152768	152769
30040	50954	2	applied	\N	\N	\N	\N	152770	152770	152771
30040	50955	3	applied	\N	\N	\N	\N	152772	152772	96111
30040	50956	4	applied	\N	\N	\N	\N	152773	152773	96132
30040	50957	5	applied	\N	\N	\N	\N	152774	152774	96145
30040	50958	6	applied	\N	\N	\N	\N	152775	152775	97267
30040	50959	7	applied	\N	\N	\N	\N	152776	152776	96155
30040	50960	8	applied	\N	\N	\N	\N	152777	152777	96163
30040	50961	9	applied	\N	\N	\N	\N	152778	152778	152779
30040	50962	10	applied	\N	\N	\N	\N	152780	152780	152781
30040	50963	11	applied	\N	\N	\N	\N	152782	152782	96184
30040	50964	12	applied	\N	\N	\N	\N	152783	152783	152784
30040	50965	13	applied	\N	\N	\N	\N	152785	152785	96191
30040	50966	14	applied	\N	\N	\N	\N	152786	152786	96195
30040	50967	15	applied	\N	\N	\N	\N	152787	152787	152788
30040	50968	16	applied	\N	\N	\N	\N	152789	152789	98386
30040	50969	17	applied	\N	\N	\N	\N	152790	152790	96268
30040	50970	18	applied	\N	\N	\N	\N	152791	152791	96282
30040	50971	19	applied	\N	\N	\N	\N	152792	152792	98388
30040	50972	20	applied	\N	\N	\N	\N	152793	152793	96292
30040	50973	21	applied	\N	\N	\N	\N	152794	152794	152795
30046	50995	0	applied	\N	\N	\N	\N	152833	152833	152834
30046	50996	1	applied	\N	\N	\N	\N	152835	152835	152836
30046	50997	2	applied	\N	\N	\N	\N	152837	152837	152838
30046	50998	3	applied	\N	\N	\N	\N	152839	152839	96465
30046	50999	4	applied	\N	\N	\N	\N	152840	152840	152841
30046	51000	5	applied	\N	\N	\N	\N	152842	152842	96467
30046	51001	6	applied	\N	\N	\N	\N	152843	152843	152844
30046	51002	7	applied	\N	\N	\N	\N	152845	152845	152846
30046	51003	8	applied	\N	\N	\N	\N	152847	152847	96497
30046	51004	9	applied	\N	\N	\N	\N	152848	152848	96511
30046	51005	10	applied	\N	\N	\N	\N	152849	152849	152850
30046	51006	11	applied	\N	\N	\N	\N	152851	152851	96545
30046	51007	12	applied	\N	\N	\N	\N	152852	152852	96546
30046	51008	13	applied	\N	\N	\N	\N	152853	152853	96547
30046	51009	14	applied	\N	\N	\N	\N	152854	152854	96549
30046	51010	15	applied	\N	\N	\N	\N	152855	152855	96564
30046	51011	16	applied	\N	\N	\N	\N	152856	152856	152857
30046	51012	17	applied	\N	\N	\N	\N	152858	152858	96591
30046	51013	18	applied	\N	\N	\N	\N	152859	152859	96595
30046	51014	19	applied	\N	\N	\N	\N	152860	152860	96604
30049	51015	0	applied	\N	\N	\N	\N	152865	152865	152866
30049	51016	1	applied	\N	\N	\N	\N	152867	152867	152868
30049	51017	2	applied	\N	\N	\N	\N	152869	152869	96610
30049	51018	3	applied	\N	\N	\N	\N	152870	152870	96622
30049	51019	4	applied	\N	\N	\N	\N	152871	152871	96624
30049	51020	5	applied	\N	\N	\N	\N	152872	152872	96630
30049	51021	6	applied	\N	\N	\N	\N	152873	152873	96637
30049	51022	7	applied	\N	\N	\N	\N	152874	152874	96648
30049	51023	8	applied	\N	\N	\N	\N	152875	152875	96660
30049	51024	9	applied	\N	\N	\N	\N	152876	152876	96668
30052	51025	0	applied	\N	\N	\N	\N	152882	152882	152883
30052	51026	1	applied	\N	\N	\N	\N	152884	152884	152885
30052	51027	2	applied	\N	\N	\N	\N	152886	152886	96676
30052	51028	3	applied	\N	\N	\N	\N	152887	152887	98846
30052	51029	4	applied	\N	\N	\N	\N	152888	152888	96682
30052	51030	5	applied	\N	\N	\N	\N	152889	152889	96690
30052	51031	6	applied	\N	\N	\N	\N	152890	152890	96695
30052	51032	7	applied	\N	\N	\N	\N	152891	152891	96705
30052	51033	8	applied	\N	\N	\N	\N	152892	152892	96722
30052	51034	9	applied	\N	\N	\N	\N	152893	152893	96737
30052	51035	10	applied	\N	\N	\N	\N	152894	152894	96744
30052	51036	11	applied	\N	\N	\N	\N	152895	152895	96756
30052	51037	12	applied	\N	\N	\N	\N	152896	152896	96783
30052	51038	13	applied	\N	\N	\N	\N	152897	152897	96787
30052	51039	14	applied	\N	\N	\N	\N	152898	152898	96799
30052	51040	15	applied	\N	\N	\N	\N	152899	152899	96811
30052	51041	16	applied	\N	\N	\N	\N	152900	152900	96837
30059	51072	0	applied	\N	\N	\N	\N	152965	152965	152966
30059	51073	1	applied	\N	\N	\N	\N	152967	152967	152968
30059	51074	2	applied	\N	\N	\N	\N	152969	152969	152970
30059	51075	3	applied	\N	\N	\N	\N	152971	152971	152972
30059	51076	4	applied	\N	\N	\N	\N	152973	152973	152974
30059	51077	5	applied	\N	\N	\N	\N	152975	152975	97271
30059	51078	6	applied	\N	\N	\N	\N	152976	152976	152977
30059	51079	7	applied	\N	\N	\N	\N	152978	152978	97272
30059	51080	8	applied	\N	\N	\N	\N	152979	152979	152980
30059	51081	9	applied	\N	\N	\N	\N	152981	152981	97177
30059	51082	10	applied	\N	\N	\N	\N	152982	152982	97195
30059	51083	11	applied	\N	\N	\N	\N	152983	152983	152984
30059	51084	12	applied	\N	\N	\N	\N	152985	152985	152986
30059	51085	13	applied	\N	\N	\N	\N	152987	152987	152988
30059	51086	14	applied	\N	\N	\N	\N	152989	152989	97249
30059	51087	15	applied	\N	\N	\N	\N	152990	152990	152991
30059	51088	16	applied	\N	\N	\N	\N	152992	152992	97255
30059	51089	17	applied	\N	\N	\N	\N	152993	152993	97278
30059	51090	18	applied	\N	\N	\N	\N	152994	152994	97259
30062	51099	0	applied	\N	\N	\N	\N	153012	153012	153013
30062	51100	1	applied	\N	\N	\N	\N	153014	153014	153015
30062	51101	2	applied	\N	\N	\N	\N	153016	153016	153017
30062	51108	3	applied	\N	\N	\N	\N	153029	153029	153023
30062	51109	4	applied	\N	\N	\N	\N	153030	153030	153026
30062	51110	5	applied	\N	\N	\N	\N	153031	153031	97327
30062	51111	6	applied	\N	\N	\N	\N	153032	153032	153033
30062	51112	7	applied	\N	\N	\N	\N	153034	153034	153035
30062	51113	8	applied	\N	\N	\N	\N	153036	153036	97338
30062	51114	9	applied	\N	\N	\N	\N	153037	153037	97347
30062	51115	10	applied	\N	\N	\N	\N	153038	153038	153039
30062	51116	11	applied	\N	\N	\N	\N	153040	153040	153041
30062	51117	12	applied	\N	\N	\N	\N	153042	153042	97351
30062	51118	13	applied	\N	\N	\N	\N	153043	153043	97353
30062	51102	14	applied	\N	\N	1000000000	\N	153018	153018	153019
30062	51103	15	applied	\N	\N	\N	\N	153020	153020	97360
30062	51104	16	applied	\N	\N	\N	\N	153022	153022	153044
30062	51105	17	applied	\N	\N	\N	\N	153024	153024	153045
30062	51106	18	applied	\N	\N	\N	\N	153025	153025	97362
30062	51107	19	applied	\N	\N	\N	\N	153027	153027	153046
30062	51119	20	applied	\N	\N	\N	\N	153047	153047	97373
30062	51120	21	applied	\N	\N	\N	\N	153048	153048	153049
30062	51121	22	applied	\N	\N	\N	\N	153050	153050	153051
30062	51122	23	applied	\N	\N	\N	\N	153052	153052	97390
30062	51123	24	applied	\N	\N	\N	\N	153053	153053	97399
30062	51124	25	applied	\N	\N	\N	\N	153054	153054	97412
30062	51125	26	applied	\N	\N	\N	\N	153055	153055	153056
30062	51126	27	applied	\N	\N	\N	\N	153057	153057	97426
30062	51127	28	applied	\N	\N	\N	\N	153058	153058	97439
30062	51128	29	applied	\N	\N	\N	\N	153059	153059	153060
30062	51129	30	applied	\N	\N	\N	\N	153061	153061	97457
30062	51130	31	applied	\N	\N	\N	\N	153062	153062	153063
30072	51178	0	applied	\N	\N	\N	\N	153163	153163	153164
30072	51179	1	applied	\N	\N	\N	\N	153165	153165	97670
30072	51180	2	applied	\N	\N	\N	\N	153166	153166	97674
30072	51181	3	applied	\N	\N	\N	\N	153167	153167	153168
30072	51182	4	applied	\N	\N	\N	\N	153169	153169	97690
30072	51183	5	applied	\N	\N	\N	\N	153170	153170	153171
30072	51184	6	applied	\N	\N	\N	\N	153172	153172	97704
30072	51185	7	applied	\N	\N	\N	\N	153173	153173	97920
30075	51197	0	applied	\N	\N	\N	\N	153195	153195	153196
30075	51198	1	applied	\N	\N	\N	\N	153197	153197	153198
30075	51199	2	applied	\N	\N	\N	\N	153199	153199	97742
30075	51200	3	applied	\N	\N	\N	\N	153200	153200	153201
30075	51201	4	applied	\N	\N	\N	\N	153202	153202	153203
30075	51202	5	applied	\N	\N	\N	\N	153204	153204	97746
30075	51203	6	applied	\N	\N	\N	\N	153205	153205	97748
30075	51204	7	applied	\N	\N	\N	\N	153206	153206	97752
30075	51205	8	applied	\N	\N	\N	\N	153207	153207	97756
30075	51206	9	applied	\N	\N	\N	\N	153208	153208	153209
30075	51207	10	applied	\N	\N	\N	\N	153210	153210	97770
30075	51208	11	applied	\N	\N	\N	\N	153211	153211	153212
30075	51209	12	applied	\N	\N	\N	\N	153213	153213	97794
30075	51210	13	applied	\N	\N	\N	\N	153214	153214	97928
30075	51211	14	applied	\N	\N	\N	\N	153215	153215	97805
30075	51212	15	applied	\N	\N	\N	\N	153216	153216	153217
30075	51213	16	applied	\N	\N	\N	\N	153218	153218	97813
30075	51214	17	applied	\N	\N	\N	\N	153219	153219	153220
30075	51215	18	applied	\N	\N	\N	\N	153221	153221	97815
30079	51225	0	applied	\N	\N	\N	\N	153242	153242	153243
30079	51226	1	applied	\N	\N	\N	\N	153244	153244	97856
30079	51227	2	applied	\N	\N	\N	\N	153245	153245	97866
30079	51228	3	applied	\N	\N	\N	\N	153246	153246	97877
30079	51229	4	applied	\N	\N	\N	\N	153247	153247	153248
30079	51230	5	applied	\N	\N	\N	\N	153249	153249	97885
30079	51231	6	applied	\N	\N	\N	\N	153250	153250	153251
30079	51232	7	applied	\N	\N	\N	\N	153252	153252	97887
30079	51233	8	applied	\N	\N	\N	\N	153253	153253	97893
30079	51234	9	applied	\N	\N	\N	\N	153254	153254	153255
30079	51235	10	applied	\N	\N	\N	\N	153258	153258	97952
30084	51236	0	applied	\N	\N	\N	\N	153260	153260	153261
30084	51237	1	applied	\N	\N	\N	\N	153262	153262	97962
30084	51238	2	applied	\N	\N	\N	\N	153263	153263	97964
30084	51239	4	applied	\N	\N	\N	\N	153265	153265	153266
30084	51240	5	applied	\N	\N	\N	\N	153267	153267	153268
30084	51242	6	applied	\N	\N	\N	\N	153271	153271	153291
30084	51244	7	applied	\N	\N	\N	\N	153273	153273	97987
30085	51245	0	applied	\N	\N	\N	\N	153297	153297	153298
30085	51246	1	applied	\N	\N	\N	\N	153299	153299	153300
30085	51247	2	applied	\N	\N	\N	\N	153301	153301	98012
30085	51248	3	applied	\N	\N	\N	\N	153302	153302	153303
30085	51249	4	applied	\N	\N	\N	\N	153304	153304	98023
30085	51250	5	applied	\N	\N	\N	\N	153305	153305	153306
30085	51251	6	applied	\N	\N	\N	\N	153307	153307	98038
30085	51252	7	applied	\N	\N	\N	\N	153308	153308	153309
30085	51253	8	applied	\N	\N	\N	\N	153310	153310	98062
30096	51300	0	applied	\N	\N	\N	\N	153402	153402	153403
30096	51301	1	applied	\N	\N	\N	\N	153404	153404	153405
30096	51302	2	applied	\N	\N	\N	\N	153406	153406	153407
30096	51303	3	applied	\N	\N	\N	\N	153408	153408	98290
30096	51304	4	applied	\N	\N	\N	\N	153409	153409	98298
30096	51305	5	applied	\N	\N	\N	\N	153410	153410	153411
30096	51306	6	applied	\N	\N	\N	\N	153412	153412	153413
30096	51307	7	applied	\N	\N	\N	\N	153414	153414	98311
30096	51308	8	applied	\N	\N	\N	\N	153415	153415	153416
30106	51337	0	applied	\N	\N	\N	\N	153500	153500	153501
30106	51338	1	applied	\N	\N	\N	\N	153502	153502	153503
30106	51339	2	applied	\N	\N	\N	\N	153504	153504	153505
30108	51337	0	applied	\N	\N	\N	\N	153500	153500	153501
30108	51338	1	applied	\N	\N	\N	\N	153502	153502	153503
30108	51339	2	applied	\N	\N	\N	\N	153504	153504	153505
30108	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30108	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30108	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30108	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30108	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30108	51331	8	applied	\N	\N	\N	\N	153482	153482	153487
30108	51332	9	applied	\N	\N	\N	\N	153484	153484	98430
30108	51333	10	applied	\N	\N	\N	\N	153486	153486	98438
30108	51344	11	applied	\N	\N	\N	\N	153514	153514	153496
30108	51345	12	applied	\N	\N	\N	\N	153515	153515	153490
30108	51346	13	applied	\N	\N	\N	\N	153516	153516	98452
30108	51347	14	applied	\N	\N	\N	\N	153517	153517	98454
30108	51348	15	applied	\N	\N	\N	\N	153518	153518	153519
30108	51349	17	applied	\N	\N	\N	\N	153521	153521	153522
30108	51350	18	applied	\N	\N	\N	\N	153523	153523	98458
30108	51351	19	applied	\N	\N	\N	\N	153524	153524	153525
30108	51334	20	applied	\N	\N	\N	\N	153488	153488	153526
30108	51335	21	applied	\N	\N	\N	\N	153489	153489	98474
30108	51336	22	applied	\N	\N	\N	\N	153491	153491	98491
30108	51352	23	applied	\N	\N	\N	\N	153529	153529	153530
30108	51353	24	applied	\N	\N	\N	\N	153531	153531	153532
30108	51354	25	applied	\N	\N	\N	\N	153533	153533	98501
30108	51355	26	applied	\N	\N	\N	\N	153534	153534	98508
30108	51356	27	applied	\N	\N	\N	\N	153535	153535	153536
30108	51357	28	applied	\N	\N	\N	\N	153537	153537	98527
30108	51358	29	applied	\N	\N	\N	\N	153538	153538	153539
30108	51359	30	applied	\N	\N	\N	\N	153540	153540	98535
30108	51360	31	applied	\N	\N	\N	\N	153541	153541	153542
30108	51361	32	applied	\N	\N	\N	\N	153543	153543	153544
30108	51362	33	applied	\N	\N	\N	\N	153545	153545	153546
30108	51363	34	applied	\N	\N	\N	\N	153547	153547	153548
30108	51364	35	applied	\N	\N	\N	\N	153549	153549	153550
30111	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30111	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30111	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30111	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30111	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30111	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30111	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30111	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30111	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30111	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30111	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30111	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30063	51136	5	applied	\N	\N	\N	\N	153073	153073	153074
30063	51137	7	applied	\N	\N	\N	\N	153076	153076	97485
30063	51138	8	applied	\N	\N	\N	\N	153077	153077	153078
30065	51139	0	applied	\N	\N	\N	\N	153087	153087	153088
30065	51140	1	applied	\N	\N	\N	\N	153089	153089	153090
30065	51141	2	applied	\N	\N	\N	\N	153091	153091	97495
30065	51142	3	applied	\N	\N	\N	\N	153092	153092	97503
30065	51143	4	applied	\N	\N	\N	\N	153093	153093	153094
30065	51144	5	applied	\N	\N	\N	\N	153095	153095	97512
30065	51145	6	applied	\N	\N	\N	\N	153096	153096	153097
30065	51146	7	applied	\N	\N	\N	\N	153098	153098	97530
30065	51147	8	applied	\N	\N	\N	\N	153099	153099	153100
30067	51159	0	applied	\N	\N	\N	\N	153126	153126	153127
30067	51160	1	applied	\N	\N	\N	\N	153128	153128	97902
30067	51161	2	applied	\N	\N	\N	\N	153129	153129	97594
30067	51162	3	applied	\N	\N	\N	\N	153130	153130	97904
30067	51163	4	applied	\N	\N	\N	\N	153131	153131	97607
30067	51164	5	applied	\N	\N	\N	\N	153132	153132	97906
30067	51165	6	applied	\N	\N	\N	\N	153133	153133	153134
30067	51166	7	applied	\N	\N	\N	\N	153135	153135	153136
30069	51167	0	applied	\N	\N	\N	\N	153139	153139	153140
30069	51168	1	applied	\N	\N	\N	\N	153141	153141	153142
30069	51169	2	applied	\N	\N	\N	\N	153143	153143	97907
30069	51170	3	applied	\N	\N	\N	\N	153144	153144	97630
30069	51173	4	applied	\N	\N	\N	\N	153149	153149	97636
30069	51174	5	applied	\N	\N	\N	\N	153150	153150	97645
30069	51175	6	applied	\N	\N	\N	\N	153151	153151	153152
30069	51176	7	applied	\N	\N	\N	\N	153153	153153	153154
30069	51177	8	applied	\N	\N	\N	\N	153155	153155	97663
30069	51171	9	applied	\N	\N	\N	\N	153145	153145	153156
30069	51172	10	applied	\N	\N	\N	\N	153146	153146	153157
30073	51186	0	applied	\N	\N	\N	\N	153175	153175	153176
30073	51187	1	applied	\N	\N	\N	\N	153177	153177	153178
30073	51188	2	applied	\N	\N	\N	\N	153179	153179	153180
30073	51189	3	applied	\N	\N	\N	\N	153181	153181	97706
30073	51190	4	applied	\N	\N	\N	\N	153182	153182	153183
30073	51191	5	applied	\N	\N	\N	\N	153184	153184	153185
30073	51192	6	applied	\N	\N	\N	\N	153186	153186	97923
30073	51193	7	applied	\N	\N	\N	\N	153187	153187	153188
30073	51194	8	applied	\N	\N	\N	\N	153189	153189	153190
30073	51195	9	applied	\N	\N	\N	\N	153191	153191	97740
30073	51196	10	applied	\N	\N	\N	\N	153192	153192	153193
30077	51216	0	applied	\N	\N	\N	\N	153229	153229	153230
30077	51217	1	applied	\N	\N	\N	\N	153231	153231	97827
30077	51218	2	applied	\N	\N	\N	\N	153232	153232	97829
30077	51219	3	applied	\N	\N	\N	\N	153233	153233	97837
30077	51220	4	applied	\N	\N	\N	\N	153234	153234	153235
30077	51221	5	applied	\N	\N	\N	\N	153236	153236	97841
30077	51222	6	applied	\N	\N	\N	\N	153237	153237	97933
30077	51223	7	applied	\N	\N	\N	\N	153238	153238	97850
30077	51224	8	applied	\N	\N	\N	\N	153239	153239	97854
30082	51236	0	applied	\N	\N	\N	\N	153260	153260	153261
30082	51237	1	applied	\N	\N	\N	\N	153262	153262	97962
30082	51238	2	applied	\N	\N	\N	\N	153263	153263	97964
30082	51239	4	applied	\N	\N	\N	\N	153265	153265	153266
30082	51240	5	applied	\N	\N	\N	\N	153267	153267	153268
30082	51241	6	applied	\N	\N	\N	\N	153269	153269	153270
30082	51242	7	applied	\N	\N	\N	\N	153271	153271	97991
30082	51243	8	applied	\N	\N	\N	\N	153272	153272	97993
30082	51244	9	applied	\N	\N	\N	\N	153273	153273	153274
30086	51254	0	applied	\N	\N	\N	\N	153314	153314	153315
30086	51255	1	applied	\N	\N	\N	\N	153316	153316	153317
30086	51256	2	applied	\N	\N	\N	\N	153318	153318	153319
30086	51257	3	applied	\N	\N	\N	\N	153320	153320	153321
30086	51258	4	applied	\N	\N	\N	\N	153322	153322	98064
30086	51259	5	applied	\N	\N	\N	\N	153323	153323	153324
30086	51260	6	applied	\N	\N	\N	\N	153325	153325	153326
30086	51261	7	applied	\N	\N	\N	\N	153327	153327	98086
30086	51262	8	applied	\N	\N	\N	\N	153328	153328	98090
30086	51263	9	applied	\N	\N	\N	\N	153329	153329	153330
30086	51264	10	applied	\N	\N	\N	\N	153331	153331	98102
30086	51265	11	applied	\N	\N	\N	\N	153332	153332	153333
30086	51266	12	applied	\N	\N	\N	\N	153334	153334	153335
30086	51267	13	applied	\N	\N	\N	\N	153336	153336	98112
30086	51268	14	applied	\N	\N	\N	\N	153337	153337	98118
30086	51269	15	applied	\N	\N	\N	\N	153338	153338	153339
30086	51270	16	applied	\N	\N	\N	\N	153340	153340	153341
30086	51271	17	applied	\N	\N	\N	\N	153342	153342	153343
30086	51272	18	applied	\N	\N	\N	\N	153344	153344	98136
30086	51273	19	applied	\N	\N	\N	\N	153345	153345	153346
30086	51274	20	applied	\N	\N	\N	\N	153347	153347	153348
30086	51275	21	applied	\N	\N	\N	\N	153349	153349	98153
30086	51276	22	applied	\N	\N	\N	\N	153350	153350	153351
30086	51277	23	applied	\N	\N	\N	\N	153352	153352	98165
30086	51278	24	applied	\N	\N	\N	\N	153353	153353	153354
30086	51279	25	applied	\N	\N	\N	\N	153355	153355	153356
30086	51280	26	applied	\N	\N	\N	\N	153357	153357	153358
30086	51281	27	applied	\N	\N	\N	\N	153359	153359	98185
30088	51282	0	applied	\N	\N	\N	\N	153362	153362	153363
30088	51283	1	applied	\N	\N	\N	\N	153364	153364	153365
30088	51284	2	applied	\N	\N	\N	\N	153366	153366	153367
30088	51285	3	applied	\N	\N	\N	\N	153368	153368	153369
30088	51286	4	applied	\N	\N	\N	\N	153370	153370	98203
30088	51287	5	applied	\N	\N	\N	\N	153371	153371	153372
30088	51288	6	applied	\N	\N	\N	\N	153373	153373	98209
30088	51289	7	applied	\N	\N	\N	\N	153374	153374	153375
30088	51290	8	applied	\N	\N	\N	\N	153376	153376	98221
30090	51282	0	applied	\N	\N	\N	\N	153362	153362	153363
30090	51283	1	applied	\N	\N	\N	\N	153364	153364	153365
30090	51284	2	applied	\N	\N	\N	\N	153366	153366	153367
30090	51285	3	applied	\N	\N	\N	\N	153368	153368	153369
30090	51286	4	applied	\N	\N	\N	\N	153370	153370	98203
30090	51287	5	applied	\N	\N	\N	\N	153371	153371	153372
30090	51288	6	applied	\N	\N	\N	\N	153373	153373	98209
30090	51289	7	applied	\N	\N	\N	\N	153374	153374	153375
30090	51290	8	applied	\N	\N	\N	\N	153376	153376	98221
30092	51291	0	applied	\N	\N	\N	\N	153385	153385	153386
30092	51292	1	applied	\N	\N	\N	\N	153387	153387	153388
30092	51293	2	applied	\N	\N	\N	\N	153389	153389	98225
30092	51294	3	applied	\N	\N	\N	\N	153390	153390	153391
30092	51295	4	applied	\N	\N	\N	\N	153392	153392	98246
30092	51296	5	applied	\N	\N	\N	\N	153393	153393	153394
30092	51297	6	applied	\N	\N	\N	\N	153395	153395	98258
30092	51298	7	applied	\N	\N	\N	\N	153396	153396	153397
30092	51299	8	applied	\N	\N	\N	\N	153398	153398	98274
30095	51300	0	applied	\N	\N	\N	\N	153402	153402	153403
30095	51301	1	applied	\N	\N	\N	\N	153404	153404	153405
30095	51302	2	applied	\N	\N	\N	\N	153406	153406	153407
30095	51303	3	applied	\N	\N	\N	\N	153408	153408	98290
30095	51304	4	applied	\N	\N	\N	\N	153409	153409	98298
30064	51131	0	applied	\N	\N	\N	\N	153065	153065	153066
30064	51132	1	applied	\N	\N	\N	\N	153067	153067	97473
30064	51133	2	applied	\N	\N	\N	\N	153068	153068	153069
30064	51134	3	applied	\N	\N	\N	\N	153070	153070	153071
30064	51135	4	applied	\N	\N	\N	\N	153072	153072	97479
30064	51136	5	applied	\N	\N	\N	\N	153073	153073	153074
30064	51137	7	applied	\N	\N	\N	\N	153076	153076	97485
30064	51138	8	applied	\N	\N	\N	\N	153077	153077	153078
30066	51148	0	applied	\N	\N	\N	\N	153108	153108	153109
30066	51149	1	applied	\N	\N	\N	\N	153110	153110	153110
30066	51150	2	applied	\N	\N	\N	\N	153111	153111	97532
30066	51151	3	applied	\N	\N	\N	\N	153112	153112	153113
30066	51152	4	applied	\N	\N	\N	\N	153114	153114	153115
30066	51153	5	applied	\N	\N	\N	\N	153116	153116	153117
30066	51154	6	applied	\N	\N	\N	\N	153118	153118	97555
30066	51155	7	applied	\N	\N	\N	\N	153119	153119	97897
30066	51156	8	applied	\N	\N	\N	\N	153120	153120	97566
30066	51157	9	applied	\N	\N	\N	\N	153121	153121	153122
30066	51158	10	applied	\N	\N	\N	\N	153123	153123	97586
30071	51167	0	applied	\N	\N	\N	\N	153139	153139	153140
30071	51168	1	applied	\N	\N	\N	\N	153141	153141	153142
30071	51169	2	applied	\N	\N	\N	\N	153143	153143	97907
30071	51170	3	applied	\N	\N	\N	\N	153144	153144	97630
30071	51173	4	applied	\N	\N	\N	\N	153149	153149	97636
30071	51174	5	applied	\N	\N	\N	\N	153150	153150	97645
30071	51175	6	applied	\N	\N	\N	\N	153151	153151	153152
30071	51176	7	applied	\N	\N	\N	\N	153153	153153	153154
30071	51177	8	applied	\N	\N	\N	\N	153155	153155	97663
30071	51171	9	applied	\N	\N	\N	\N	153145	153145	153156
30071	51172	10	applied	\N	\N	\N	\N	153146	153146	153157
30074	51197	0	applied	\N	\N	\N	\N	153195	153195	153196
30074	51198	1	applied	\N	\N	\N	\N	153197	153197	153198
30074	51199	2	applied	\N	\N	\N	\N	153199	153199	97742
30074	51200	3	applied	\N	\N	\N	\N	153200	153200	153201
30074	51201	4	applied	\N	\N	\N	\N	153202	153202	153203
30074	51202	5	applied	\N	\N	\N	\N	153204	153204	97746
30074	51203	6	applied	\N	\N	\N	\N	153205	153205	97748
30074	51204	7	applied	\N	\N	\N	\N	153206	153206	97752
30074	51205	8	applied	\N	\N	\N	\N	153207	153207	97756
30074	51206	9	applied	\N	\N	\N	\N	153208	153208	153209
30074	51207	10	applied	\N	\N	\N	\N	153210	153210	97770
30074	51208	11	applied	\N	\N	\N	\N	153211	153211	153212
30074	51209	12	applied	\N	\N	\N	\N	153213	153213	97794
30074	51210	13	applied	\N	\N	\N	\N	153214	153214	97928
30074	51211	14	applied	\N	\N	\N	\N	153215	153215	97805
30074	51212	15	applied	\N	\N	\N	\N	153216	153216	153217
30074	51213	16	applied	\N	\N	\N	\N	153218	153218	97813
30074	51214	17	applied	\N	\N	\N	\N	153219	153219	153220
30074	51215	18	applied	\N	\N	\N	\N	153221	153221	97815
30083	51236	0	applied	\N	\N	\N	\N	153260	153260	153261
30083	51237	1	applied	\N	\N	\N	\N	153262	153262	97962
30083	51238	2	applied	\N	\N	\N	\N	153263	153263	97964
30083	51239	4	applied	\N	\N	\N	\N	153265	153265	153266
30083	51240	5	applied	\N	\N	\N	\N	153267	153267	153268
30083	51241	6	applied	\N	\N	\N	\N	153269	153269	153270
30083	51242	7	applied	\N	\N	\N	\N	153271	153271	97991
30083	51243	8	applied	\N	\N	\N	\N	153272	153272	97993
30083	51244	9	applied	\N	\N	\N	\N	153273	153273	153274
30087	51282	0	applied	\N	\N	\N	\N	153362	153362	153363
30087	51283	1	applied	\N	\N	\N	\N	153364	153364	153365
30087	51284	2	applied	\N	\N	\N	\N	153366	153366	153367
30087	51285	3	applied	\N	\N	\N	\N	153368	153368	153369
30087	51286	4	applied	\N	\N	\N	\N	153370	153370	98203
30087	51287	5	applied	\N	\N	\N	\N	153371	153371	153372
30087	51288	6	applied	\N	\N	\N	\N	153373	153373	98209
30087	51289	7	applied	\N	\N	\N	\N	153374	153374	153375
30087	51290	8	applied	\N	\N	\N	\N	153376	153376	98221
30091	51282	0	applied	\N	\N	\N	\N	153362	153362	153363
30091	51283	1	applied	\N	\N	\N	\N	153364	153364	153365
30091	51284	2	applied	\N	\N	\N	\N	153366	153366	153367
30091	51285	3	applied	\N	\N	\N	\N	153368	153368	153369
30091	51286	4	applied	\N	\N	\N	\N	153370	153370	98203
30091	51287	5	applied	\N	\N	\N	\N	153371	153371	153372
30091	51288	6	applied	\N	\N	\N	\N	153373	153373	98209
30091	51289	7	applied	\N	\N	\N	\N	153374	153374	153375
30091	51290	8	applied	\N	\N	\N	\N	153376	153376	98221
30094	51291	0	applied	\N	\N	\N	\N	153385	153385	153386
30094	51292	1	applied	\N	\N	\N	\N	153387	153387	153388
30094	51293	2	applied	\N	\N	\N	\N	153389	153389	98225
30094	51294	3	applied	\N	\N	\N	\N	153390	153390	153391
30094	51295	4	applied	\N	\N	\N	\N	153392	153392	98246
30094	51296	5	applied	\N	\N	\N	\N	153393	153393	153394
30094	51297	6	applied	\N	\N	\N	\N	153395	153395	98258
30094	51298	7	applied	\N	\N	\N	\N	153396	153396	153397
30094	51299	8	applied	\N	\N	\N	\N	153398	153398	98274
30098	51309	0	applied	\N	\N	\N	\N	153422	153422	153423
30098	51310	1	applied	\N	\N	\N	\N	153424	153424	153425
30098	51302	2	applied	\N	\N	\N	\N	153406	153406	153407
30098	51303	3	applied	\N	\N	\N	\N	153408	153408	98290
30098	51304	4	applied	\N	\N	\N	\N	153409	153409	98298
30098	51305	5	applied	\N	\N	\N	\N	153410	153410	153411
30098	51311	6	applied	\N	\N	\N	\N	153426	153426	98311
30098	51312	7	applied	\N	\N	\N	\N	153427	153427	153428
30098	51313	8	applied	\N	\N	\N	\N	153429	153429	98324
30098	51306	9	applied	\N	\N	\N	\N	153412	153412	98326
30098	51314	10	applied	\N	\N	\N	\N	153430	153430	153431
30098	51315	11	applied	\N	\N	\N	\N	153432	153432	98343
30098	51316	12	applied	\N	\N	\N	\N	153433	153433	153434
30098	51317	13	applied	\N	\N	\N	\N	153435	153435	98355
30098	51318	14	applied	\N	\N	\N	\N	153436	153436	153437
30098	51319	15	applied	\N	\N	\N	\N	153438	153438	153439
30098	51307	16	applied	\N	\N	\N	\N	153414	153414	98380
30098	51308	17	applied	\N	\N	\N	\N	153415	153415	153440
30098	51320	18	applied	\N	\N	\N	\N	153441	153441	98398
30098	51321	19	applied	\N	\N	\N	\N	153442	153442	153443
30098	51322	20	applied	\N	\N	\N	\N	153444	153444	153445
30098	51323	21	applied	\N	\N	\N	\N	153446	153446	153447
30098	51324	22	applied	\N	\N	\N	\N	153448	153448	98404
30098	51325	23	applied	\N	\N	\N	\N	153449	153449	153450
30098	51326	24	applied	\N	\N	\N	\N	153451	153451	153452
30098	51327	25	applied	\N	\N	\N	\N	153453	153453	153454
30101	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30101	51330	1	applied	\N	\N	\N	\N	153480	153480	98416
30115	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30115	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30115	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30115	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30115	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30115	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30115	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30076	51198	1	applied	\N	\N	\N	\N	153197	153197	153198
30076	51213	2	applied	\N	\N	\N	\N	153218	153218	153225
30076	51214	3	applied	\N	\N	\N	\N	153219	153219	97742
30076	51215	4	applied	\N	\N	\N	\N	153221	153221	153226
30078	51225	0	applied	\N	\N	\N	\N	153242	153242	153243
30078	51226	1	applied	\N	\N	\N	\N	153244	153244	97856
30078	51227	2	applied	\N	\N	\N	\N	153245	153245	97866
30078	51228	3	applied	\N	\N	\N	\N	153246	153246	97877
30078	51229	4	applied	\N	\N	\N	\N	153247	153247	153248
30078	51230	5	applied	\N	\N	\N	\N	153249	153249	97885
30078	51231	6	applied	\N	\N	\N	\N	153250	153250	153251
30078	51232	7	applied	\N	\N	\N	\N	153252	153252	97887
30078	51233	8	applied	\N	\N	\N	\N	153253	153253	97893
30078	51234	9	applied	\N	\N	\N	\N	153254	153254	153255
30080	51236	0	applied	\N	\N	\N	\N	153260	153260	153261
30080	51237	1	applied	\N	\N	\N	\N	153262	153262	97962
30080	51238	2	applied	\N	\N	\N	\N	153263	153263	97964
30080	51239	4	applied	\N	\N	\N	\N	153265	153265	153266
30080	51240	5	applied	\N	\N	\N	\N	153267	153267	153268
30080	51241	6	applied	\N	\N	\N	\N	153269	153269	153270
30080	51242	7	applied	\N	\N	\N	\N	153271	153271	97991
30080	51243	8	applied	\N	\N	\N	\N	153272	153272	97993
30080	51244	9	applied	\N	\N	\N	\N	153273	153273	153274
30081	51236	0	applied	\N	\N	\N	\N	153260	153260	153261
30081	51237	1	applied	\N	\N	\N	\N	153262	153262	97962
30081	51238	2	applied	\N	\N	\N	\N	153263	153263	97964
30081	51239	4	applied	\N	\N	\N	\N	153265	153265	153266
30081	51240	5	applied	\N	\N	\N	\N	153267	153267	153268
30081	51241	6	applied	\N	\N	\N	\N	153269	153269	153270
30081	51242	7	applied	\N	\N	\N	\N	153271	153271	97991
30081	51243	8	applied	\N	\N	\N	\N	153272	153272	97993
30081	51244	9	applied	\N	\N	\N	\N	153273	153273	153274
30089	51282	0	applied	\N	\N	\N	\N	153362	153362	153363
30089	51283	1	applied	\N	\N	\N	\N	153364	153364	153365
30089	51284	2	applied	\N	\N	\N	\N	153366	153366	153367
30089	51285	3	applied	\N	\N	\N	\N	153368	153368	153369
30089	51286	4	applied	\N	\N	\N	\N	153370	153370	98203
30093	51291	0	applied	\N	\N	\N	\N	153385	153385	153386
30093	51292	1	applied	\N	\N	\N	\N	153387	153387	153388
30093	51293	2	applied	\N	\N	\N	\N	153389	153389	98225
30093	51294	3	applied	\N	\N	\N	\N	153390	153390	153391
30093	51295	4	applied	\N	\N	\N	\N	153392	153392	98246
30093	51296	5	applied	\N	\N	\N	\N	153393	153393	153394
30093	51297	6	applied	\N	\N	\N	\N	153395	153395	98258
30093	51298	7	applied	\N	\N	\N	\N	153396	153396	153397
30100	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30100	51329	1	applied	\N	\N	\N	\N	153479	153479	98418
30100	51330	2	applied	\N	\N	\N	\N	153480	153480	153481
30100	51331	3	applied	\N	\N	\N	\N	153482	153482	153483
30100	51332	4	applied	\N	\N	\N	\N	153484	153484	153485
30100	51333	5	applied	\N	\N	\N	\N	153486	153486	153487
30100	51334	6	applied	\N	\N	\N	\N	153488	153488	98438
30100	51335	7	applied	\N	\N	\N	\N	153489	153489	153490
30100	51336	8	applied	\N	\N	\N	\N	153491	153491	98454
30103	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30103	51329	1	applied	\N	\N	\N	\N	153479	153479	98418
30103	51330	2	applied	\N	\N	\N	\N	153480	153480	153481
30103	51331	3	applied	\N	\N	\N	\N	153482	153482	153483
30103	51332	4	applied	\N	\N	\N	\N	153484	153484	153485
30103	51334	5	applied	\N	\N	\N	\N	153488	153488	98430
30103	51335	6	applied	\N	\N	\N	\N	153489	153489	153496
30103	51336	7	applied	\N	\N	\N	\N	153491	153491	98452
30109	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30109	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30109	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30109	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30109	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30109	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30109	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30109	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30109	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30109	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30109	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30109	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30109	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30109	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30109	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30109	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30109	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30109	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30109	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30109	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30109	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30109	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30109	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30109	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30109	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30109	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30109	51352	27	applied	\N	\N	\N	\N	153529	153529	98497
30109	51353	28	applied	\N	\N	\N	\N	153531	153531	153568
30109	51354	29	applied	\N	\N	\N	\N	153533	153533	153569
30109	51355	30	applied	\N	\N	\N	\N	153534	153534	98521
30109	51356	31	applied	\N	\N	\N	\N	153535	153535	153570
30109	51357	32	applied	\N	\N	\N	\N	153537	153537	153571
30109	51358	33	applied	\N	\N	\N	\N	153538	153538	153572
30109	51359	34	applied	\N	\N	\N	\N	153540	153540	98542
30109	51360	35	applied	\N	\N	\N	\N	153541	153541	153573
30109	51361	36	applied	\N	\N	\N	\N	153543	153543	98557
30109	51362	37	applied	\N	\N	\N	\N	153545	153545	153574
30109	51363	38	applied	\N	\N	\N	\N	153547	153547	98573
30109	51364	39	applied	\N	\N	\N	\N	153549	153549	153575
30109	51372	40	applied	\N	\N	\N	\N	153576	153576	153577
30109	51373	41	applied	\N	\N	\N	\N	153578	153578	98600
30109	51374	42	applied	\N	\N	\N	\N	153579	153579	153580
30109	51375	43	applied	\N	\N	\N	\N	153581	153581	153582
30109	51376	44	applied	\N	\N	\N	\N	153583	153583	98624
30109	51377	45	applied	\N	\N	\N	\N	153584	153584	99255
30109	51378	46	applied	\N	\N	\N	\N	153585	153585	99256
30109	51379	47	applied	\N	\N	\N	\N	153586	153586	98643
30109	51380	48	applied	\N	\N	\N	\N	153587	153587	153588
30109	51381	49	applied	\N	\N	\N	\N	153589	153589	98655
30109	51382	50	applied	\N	\N	\N	\N	153590	153590	98661
30109	51383	51	applied	\N	\N	\N	\N	153591	153591	153592
30109	51384	52	applied	\N	\N	\N	\N	153593	153593	153594
30113	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30113	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30113	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30113	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30113	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30095	51305	5	applied	\N	\N	\N	\N	153410	153410	153411
30095	51306	6	applied	\N	\N	\N	\N	153412	153412	153413
30095	51307	7	applied	\N	\N	\N	\N	153414	153414	98311
30095	51308	8	applied	\N	\N	\N	\N	153415	153415	153416
30097	51300	0	applied	\N	\N	\N	\N	153402	153402	153403
30097	51301	1	applied	\N	\N	\N	\N	153404	153404	153405
30099	51186	0	applied	\N	\N	\N	\N	153175	153175	153176
30099	51187	1	applied	\N	\N	\N	\N	153177	153177	153178
30099	50952	2	applied	\N	\N	\N	\N	152766	152766	152767
30099	50725	3	applied	\N	\N	\N	\N	152390	152390	152391
30099	50734	4	applied	\N	\N	\N	\N	152404	152404	152405
30099	50743	5	applied	\N	\N	\N	\N	152422	152422	152423
30099	50744	6	applied	\N	\N	\N	\N	152424	152424	152425
30099	50763	7	applied	\N	\N	\N	\N	152454	152454	152455
30099	50773	8	applied	\N	\N	\N	\N	152471	152471	152472
30099	50782	9	applied	\N	\N	\N	\N	152489	152489	152490
30099	50783	10	applied	\N	\N	\N	\N	152491	152491	152492
30099	50784	11	applied	\N	\N	\N	\N	152493	152493	152494
30099	50811	12	applied	\N	\N	\N	\N	152535	152535	152536
30099	50820	13	applied	\N	\N	\N	\N	152556	152556	152557
30099	50829	14	applied	\N	\N	\N	\N	152567	152567	152568
30099	50838	15	applied	\N	\N	\N	\N	152579	152579	152580
30099	50839	16	applied	\N	\N	\N	\N	152581	152581	152582
30099	50840	17	applied	\N	\N	\N	\N	152583	152583	152584
30099	50868	18	applied	\N	\N	\N	\N	152620	152620	152621
30099	50876	19	applied	\N	\N	\N	\N	152636	152636	152637
30099	50881	20	applied	\N	\N	\N	\N	152645	152645	152646
30099	50894	21	applied	\N	\N	\N	\N	152661	152661	152662
30099	50895	22	applied	\N	\N	\N	\N	152663	152663	152664
30099	50913	23	applied	\N	\N	\N	\N	152686	152686	152687
30099	50914	24	applied	\N	\N	\N	\N	152688	152688	152689
30099	50931	25	applied	\N	\N	\N	\N	152722	152722	152723
30099	50942	26	applied	\N	\N	\N	\N	152745	152745	152746
30099	50953	27	applied	\N	\N	\N	\N	152768	152768	152769
30099	50954	28	applied	\N	\N	\N	\N	152770	152770	152771
30099	50974	29	applied	\N	\N	\N	\N	152802	152802	152803
30099	50975	30	applied	\N	\N	\N	\N	152804	152804	152805
30099	50995	31	applied	\N	\N	\N	\N	152833	152833	152834
30099	50996	32	applied	\N	\N	\N	\N	152835	152835	152836
30099	51015	33	applied	\N	\N	\N	\N	152865	152865	152866
30099	51025	34	applied	\N	\N	\N	\N	152882	152882	152883
30099	51026	35	applied	\N	\N	\N	\N	152884	152884	152885
30099	51042	36	applied	\N	\N	\N	\N	152912	152912	152913
30099	51052	37	applied	\N	\N	\N	\N	152929	152929	152930
30099	51053	38	applied	\N	\N	\N	\N	152931	152931	152932
30099	51072	39	applied	\N	\N	\N	\N	152965	152965	152966
30099	51073	40	applied	\N	\N	\N	\N	152967	152967	152968
30099	51091	41	applied	\N	\N	\N	\N	152999	152999	153000
30099	51099	42	applied	\N	\N	\N	\N	153012	153012	153013
30099	51100	43	applied	\N	\N	\N	\N	153014	153014	153015
30099	51101	44	applied	\N	\N	\N	\N	153016	153016	153017
30099	51131	45	applied	\N	\N	\N	\N	153065	153065	153066
30099	51139	46	applied	\N	\N	\N	\N	153087	153087	153088
30099	51148	47	applied	\N	\N	\N	\N	153108	153108	153109
30099	51159	48	applied	\N	\N	\N	\N	153126	153126	153127
30099	51167	49	applied	\N	\N	\N	\N	153139	153139	153140
30099	51178	50	applied	\N	\N	\N	\N	153163	153163	153164
30099	51188	51	applied	\N	\N	\N	\N	153179	153179	153180
30099	51197	52	applied	\N	\N	\N	\N	153195	153195	153196
30099	51198	53	applied	\N	\N	\N	\N	153197	153197	153198
30099	51216	54	applied	\N	\N	\N	\N	153229	153229	153230
30099	51225	55	applied	\N	\N	\N	\N	153242	153242	153243
30099	51236	56	applied	\N	\N	\N	\N	153260	153260	153261
30099	51245	57	applied	\N	\N	\N	\N	153297	153297	153298
30099	51254	58	applied	\N	\N	\N	\N	153314	153314	153315
30099	51255	59	applied	\N	\N	\N	\N	153316	153316	153317
30099	51256	60	applied	\N	\N	\N	\N	153318	153318	153319
30099	51282	61	applied	\N	\N	\N	\N	153362	153362	153363
30099	51291	62	applied	\N	\N	\N	\N	153385	153385	153386
30099	51300	63	applied	\N	\N	\N	\N	153402	153402	153403
30099	51309	64	applied	\N	\N	\N	\N	153422	153422	153423
30099	51149	65	applied	\N	\N	\N	\N	153110	153110	153110
30099	50997	66	applied	\N	\N	\N	\N	152837	152837	152838
30099	50945	67	applied	\N	\N	1000000000	\N	152750	152750	152751
30099	50946	68	applied	\N	\N	1000000000	\N	152752	152752	152753
30099	50726	69	applied	\N	\N	\N	\N	152392	152392	94101
30099	50727	70	applied	\N	\N	\N	\N	152393	152393	94126
30099	50728	71	applied	\N	\N	\N	\N	152394	152394	94284
30099	50736	72	applied	\N	\N	\N	\N	152408	152408	94285
30099	50737	73	applied	\N	\N	\N	\N	152410	152410	94131
30099	50729	74	applied	\N	\N	\N	\N	152395	152395	94133
30099	50730	75	applied	\N	\N	\N	\N	152396	152396	94598
30099	50735	76	applied	\N	\N	\N	\N	152406	152406	94145
30099	50746	77	applied	\N	\N	\N	\N	152428	152428	153456
30099	50747	78	applied	\N	\N	\N	\N	152430	152430	153457
30099	50964	79	applied	\N	\N	\N	\N	152783	152783	152784
30099	50980	80	applied	\N	\N	1000000000	\N	152811	152811	152812
30099	51102	81	applied	\N	\N	1000000000	\N	153018	153018	153019
30099	50748	82	applied	\N	\N	\N	\N	152431	152431	94147
30099	50765	83	applied	\N	\N	\N	\N	152457	152457	152399
30099	50774	84	applied	\N	\N	\N	\N	152473	152473	94149
30099	50775	85	applied	\N	\N	\N	\N	152474	152474	153458
30099	50785	86	applied	\N	\N	\N	\N	152495	152495	94151
30099	50800	87	applied	\N	\N	\N	\N	152518	152518	152401
30099	50801	88	applied	\N	\N	\N	\N	152519	152519	94161
30099	50802	89	applied	\N	\N	\N	\N	152521	152521	152407
30099	50814	90	applied	\N	\N	\N	\N	152539	152539	152409
30099	50815	91	applied	\N	\N	\N	\N	152540	152540	94163
30099	50824	92	applied	\N	\N	\N	\N	152561	152561	153459
30099	50832	93	applied	\N	\N	\N	\N	152571	152571	153460
30099	50841	94	applied	\N	\N	\N	\N	152585	152585	94173
30099	50843	95	applied	\N	\N	\N	\N	152587	152587	152412
30099	50844	97	applied	\N	\N	\N	\N	152588	152588	153462
30099	50845	98	applied	\N	\N	\N	\N	152589	152589	94175
30099	50846	99	applied	\N	\N	\N	\N	152590	152590	94177
30099	50875	100	applied	\N	\N	\N	\N	152629	152629	152414
30099	50878	101	applied	\N	\N	\N	\N	152639	152639	94179
30099	50879	102	applied	\N	\N	\N	\N	152640	152640	153463
30099	50893	103	applied	\N	\N	\N	\N	152658	152658	94181
30099	50896	104	applied	\N	\N	\N	\N	152665	152665	152416
30099	50906	105	applied	\N	\N	\N	\N	152675	152675	94187
30099	50907	106	applied	\N	\N	\N	\N	152676	152676	153464
30099	50916	107	applied	\N	\N	\N	\N	152691	152691	94195
30099	50920	108	applied	\N	\N	\N	\N	152698	152698	94197
30099	50921	109	applied	\N	\N	\N	\N	152699	152699	152421
30099	50938	110	applied	\N	\N	\N	\N	152731	152731	152419
30099	50941	111	applied	\N	\N	\N	\N	152734	152734	94199
30099	50944	112	applied	\N	\N	\N	\N	152748	152748	152427
30099	50959	113	applied	\N	\N	\N	\N	152776	152776	152429
30099	50972	114	applied	\N	\N	\N	\N	152793	152793	94207
30099	50973	115	applied	\N	\N	\N	\N	152794	152794	152432
30099	50977	116	applied	\N	\N	\N	\N	152808	152808	94209
30099	50993	117	applied	\N	\N	\N	\N	152827	152827	152434
30099	50994	118	applied	\N	\N	\N	\N	152828	152828	153465
30099	50998	119	applied	\N	\N	\N	\N	152839	152839	94247
30099	50999	120	applied	\N	\N	\N	\N	152840	152840	153466
30099	51000	121	applied	\N	\N	\N	\N	152842	152842	94249
30099	51016	122	applied	\N	\N	\N	\N	152867	152867	153467
30102	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30102	51329	1	applied	\N	\N	\N	\N	153479	153479	98418
30102	51330	2	applied	\N	\N	\N	\N	153480	153480	153481
30102	51331	3	applied	\N	\N	\N	\N	153482	153482	153483
30102	51332	4	applied	\N	\N	\N	\N	153484	153484	153485
30102	51333	5	applied	\N	\N	\N	\N	153486	153486	153487
30102	51334	6	applied	\N	\N	\N	\N	153488	153488	98438
30102	51335	7	applied	\N	\N	\N	\N	153489	153489	153490
30102	51336	8	applied	\N	\N	\N	\N	153491	153491	98454
30104	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30104	51329	1	applied	\N	\N	\N	\N	153479	153479	98418
30104	51330	2	applied	\N	\N	\N	\N	153480	153480	153481
30104	51331	3	applied	\N	\N	\N	\N	153482	153482	153483
30104	51332	4	applied	\N	\N	\N	\N	153484	153484	153485
30104	51333	5	applied	\N	\N	\N	\N	153486	153486	153487
30104	51334	6	applied	\N	\N	\N	\N	153488	153488	98438
30104	51335	7	applied	\N	\N	\N	\N	153489	153489	153490
30104	51336	8	applied	\N	\N	\N	\N	153491	153491	98454
30105	51328	0	applied	\N	\N	\N	\N	153477	153477	153478
30105	51329	1	applied	\N	\N	\N	\N	153479	153479	98418
30105	51330	2	applied	\N	\N	\N	\N	153480	153480	153481
30105	51332	3	applied	\N	\N	\N	\N	153484	153484	98420
30105	51333	4	applied	\N	\N	\N	\N	153486	153486	153483
30107	51337	0	applied	\N	\N	\N	\N	153500	153500	153501
30107	51338	1	applied	\N	\N	\N	\N	153502	153502	153503
30107	51339	2	applied	\N	\N	\N	\N	153504	153504	153505
30107	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30107	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30107	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30107	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30107	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30107	51331	8	applied	\N	\N	\N	\N	153482	153482	153487
30107	51332	9	applied	\N	\N	\N	\N	153484	153484	98430
30107	51333	10	applied	\N	\N	\N	\N	153486	153486	98438
30107	51344	11	applied	\N	\N	\N	\N	153514	153514	153496
30107	51345	12	applied	\N	\N	\N	\N	153515	153515	153490
30107	51346	13	applied	\N	\N	\N	\N	153516	153516	98452
30107	51347	14	applied	\N	\N	\N	\N	153517	153517	98454
30107	51348	15	applied	\N	\N	\N	\N	153518	153518	153519
30107	51349	17	applied	\N	\N	\N	\N	153521	153521	153522
30107	51350	18	applied	\N	\N	\N	\N	153523	153523	98458
30107	51351	19	applied	\N	\N	\N	\N	153524	153524	153525
30107	51334	20	applied	\N	\N	\N	\N	153488	153488	153526
30107	51335	21	applied	\N	\N	\N	\N	153489	153489	98474
30107	51336	22	applied	\N	\N	\N	\N	153491	153491	98491
30110	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30110	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30110	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30110	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30110	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30110	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30110	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30110	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30110	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30110	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30110	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30110	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30110	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30110	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30110	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30110	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30110	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30110	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30110	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30110	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30110	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30110	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30110	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30110	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30110	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30110	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30110	51352	27	applied	\N	\N	\N	\N	153529	153529	98497
30110	51353	28	applied	\N	\N	\N	\N	153531	153531	153568
30110	51354	29	applied	\N	\N	\N	\N	153533	153533	153569
30110	51355	30	applied	\N	\N	\N	\N	153534	153534	98521
30110	51356	31	applied	\N	\N	\N	\N	153535	153535	153570
30110	51357	32	applied	\N	\N	\N	\N	153537	153537	153571
30110	51358	33	applied	\N	\N	\N	\N	153538	153538	153572
30110	51359	34	applied	\N	\N	\N	\N	153540	153540	98542
30110	51360	35	applied	\N	\N	\N	\N	153541	153541	153573
30110	51361	36	applied	\N	\N	\N	\N	153543	153543	98557
30110	51362	37	applied	\N	\N	\N	\N	153545	153545	153574
30110	51363	38	applied	\N	\N	\N	\N	153547	153547	98573
30110	51364	39	applied	\N	\N	\N	\N	153549	153549	153575
30110	51372	40	applied	\N	\N	\N	\N	153576	153576	153577
30110	51373	41	applied	\N	\N	\N	\N	153578	153578	98600
30110	51374	42	applied	\N	\N	\N	\N	153579	153579	153580
30110	51375	43	applied	\N	\N	\N	\N	153581	153581	153582
30110	51376	44	applied	\N	\N	\N	\N	153583	153583	98624
30110	51377	45	applied	\N	\N	\N	\N	153584	153584	99255
30110	51378	46	applied	\N	\N	\N	\N	153585	153585	99256
30110	51379	47	applied	\N	\N	\N	\N	153586	153586	98643
30110	51380	48	applied	\N	\N	\N	\N	153587	153587	153588
30110	51381	49	applied	\N	\N	\N	\N	153589	153589	98655
30110	51382	50	applied	\N	\N	\N	\N	153590	153590	98661
30110	51383	51	applied	\N	\N	\N	\N	153591	153591	153592
30110	51384	52	applied	\N	\N	\N	\N	153593	153593	153594
30114	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30114	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30114	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30114	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30114	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30114	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30114	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30114	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30114	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30114	51332	9	applied	\N	\N	\N	\N	153484	153484	98428
30114	51333	10	applied	\N	\N	\N	\N	153486	153486	153559
30114	51369	12	applied	\N	\N	\N	\N	153563	153563	98430
30114	51344	13	applied	\N	\N	\N	\N	153514	153514	98438
30111	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30111	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30111	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30111	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30111	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30111	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30111	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30111	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30111	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30111	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30111	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30111	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30111	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30111	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30111	51352	27	applied	\N	\N	\N	\N	153529	153529	98497
30111	51353	28	applied	\N	\N	\N	\N	153531	153531	153568
30111	51354	29	applied	\N	\N	\N	\N	153533	153533	153569
30111	51355	30	applied	\N	\N	\N	\N	153534	153534	98521
30111	51356	31	applied	\N	\N	\N	\N	153535	153535	153570
30111	51357	32	applied	\N	\N	\N	\N	153537	153537	153571
30111	51358	33	applied	\N	\N	\N	\N	153538	153538	153572
30111	51359	34	applied	\N	\N	\N	\N	153540	153540	98542
30111	51360	35	applied	\N	\N	\N	\N	153541	153541	153573
30111	51361	36	applied	\N	\N	\N	\N	153543	153543	98557
30111	51362	37	applied	\N	\N	\N	\N	153545	153545	153574
30111	51363	38	applied	\N	\N	\N	\N	153547	153547	98573
30111	51364	39	applied	\N	\N	\N	\N	153549	153549	153575
30111	51372	40	applied	\N	\N	\N	\N	153576	153576	153577
30111	51373	41	applied	\N	\N	\N	\N	153578	153578	98600
30111	51374	42	applied	\N	\N	\N	\N	153579	153579	153580
30111	51375	43	applied	\N	\N	\N	\N	153581	153581	153582
30111	51376	44	applied	\N	\N	\N	\N	153583	153583	98624
30111	51377	45	applied	\N	\N	\N	\N	153584	153584	99255
30111	51378	46	applied	\N	\N	\N	\N	153585	153585	99256
30111	51379	47	applied	\N	\N	\N	\N	153586	153586	98643
30111	51380	48	applied	\N	\N	\N	\N	153587	153587	153588
30111	51381	49	applied	\N	\N	\N	\N	153589	153589	98655
30111	51382	50	applied	\N	\N	\N	\N	153590	153590	98661
30111	51383	51	applied	\N	\N	\N	\N	153591	153591	153592
30111	51384	52	applied	\N	\N	\N	\N	153593	153593	153594
30112	51365	0	applied	\N	\N	1000000000	\N	153552	153552	153553
30112	51366	1	applied	\N	\N	\N	\N	153554	153554	153555
30112	51367	2	applied	\N	\N	\N	\N	153556	153556	153557
30112	51340	3	applied	\N	\N	\N	\N	153508	153508	98418
30112	51329	4	applied	\N	\N	\N	\N	153479	153479	153509
30112	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30112	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30112	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30112	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30112	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30112	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30112	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30112	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30112	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30112	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30112	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30112	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30112	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30112	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30112	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30112	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30112	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30112	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30112	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30112	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30112	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30112	51381	27	applied	\N	\N	\N	\N	153589	153589	153604
30112	51382	28	applied	\N	\N	\N	\N	153590	153590	98497
30112	51383	29	applied	\N	\N	\N	\N	153591	153591	153605
30112	51384	30	applied	\N	\N	\N	\N	153593	153593	153568
30118	51385	0	applied	\N	\N	\N	\N	153616	153616	99262
30118	51386	1	applied	\N	\N	\N	\N	153617	153617	99263
30118	51387	2	applied	\N	\N	\N	\N	153618	153618	99264
30118	51393	3	applied	\N	\N	\N	\N	153627	153627	98676
30118	51394	4	applied	\N	\N	\N	\N	153628	153628	153628
30118	51395	5	applied	\N	\N	\N	\N	153629	153629	153630
30118	51388	6	applied	\N	\N	\N	\N	153619	153619	98686
30118	51389	7	applied	\N	\N	\N	\N	153620	153620	153631
30118	51390	8	applied	\N	\N	\N	\N	153621	153621	98692
30118	51391	9	applied	\N	\N	\N	\N	153622	153622	153632
30120	51392	0	applied	\N	\N	\N	\N	153625	153625	153626
30120	51396	1	applied	\N	\N	\N	\N	153637	153637	153638
30120	51397	2	applied	\N	\N	\N	\N	153639	153639	153640
30120	51398	3	applied	\N	\N	\N	\N	153641	153641	111296
30120	51399	4	applied	\N	\N	\N	\N	153642	153642	98699
30120	51393	5	applied	\N	\N	\N	\N	153627	153627	99271
30120	51400	6	applied	\N	\N	\N	\N	153643	153643	98708
30120	51401	7	applied	\N	\N	\N	\N	153644	153644	98736
30120	51394	8	applied	\N	\N	\N	\N	153628	153628	153628
30120	51395	9	applied	\N	\N	\N	\N	153629	153629	153645
30120	51402	10	applied	\N	\N	\N	\N	153646	153646	98738
30120	51403	11	applied	\N	\N	\N	\N	153647	153647	98744
30120	51404	12	applied	\N	\N	\N	\N	153648	153648	153649
30120	51405	13	applied	\N	\N	\N	\N	153650	153650	153651
30120	51406	14	applied	\N	\N	\N	\N	153652	153652	153653
30120	51407	15	applied	\N	\N	\N	\N	153654	153654	98767
30120	51408	16	applied	\N	\N	\N	\N	153655	153655	153656
30120	51409	17	applied	\N	\N	\N	\N	153657	153657	98788
30120	51410	18	applied	\N	\N	\N	\N	153658	153658	99282
30120	51411	19	applied	\N	\N	\N	\N	153659	153659	153660
30120	51412	20	applied	\N	\N	\N	\N	153661	153661	100953
30120	51413	21	applied	\N	\N	\N	\N	153662	153662	98800
30120	51414	22	applied	\N	\N	\N	\N	153663	153663	153664
30125	51463	0	applied	\N	\N	\N	\N	153739	153739	153740
30125	51464	1	applied	\N	\N	\N	\N	153741	153741	153742
30125	51465	2	applied	\N	\N	\N	\N	153743	153743	99660
30125	51466	3	applied	\N	\N	\N	\N	153744	153744	99083
30125	51467	4	applied	\N	\N	\N	\N	153745	153745	99662
30125	51468	5	applied	\N	\N	\N	\N	153746	153746	99101
30125	51469	6	applied	\N	\N	\N	\N	153747	153747	153748
30125	51470	7	applied	\N	\N	\N	\N	153749	153749	99106
30125	51471	8	applied	\N	\N	\N	\N	153750	153750	153751
30125	51472	9	applied	\N	\N	\N	\N	153752	153752	99665
30125	51473	10	applied	\N	\N	\N	\N	153753	153753	153754
30125	51474	11	applied	\N	\N	\N	\N	153755	153755	153756
30125	51475	12	applied	\N	\N	\N	\N	153757	153757	99131
30125	51476	13	applied	\N	\N	\N	\N	153758	153758	153759
30125	51477	14	applied	\N	\N	\N	\N	153760	153760	99144
30125	51478	15	applied	\N	\N	\N	\N	153761	153761	153762
30125	51479	16	applied	\N	\N	\N	\N	153763	153763	99164
30113	51341	5	applied	\N	\N	\N	\N	153510	153510	98420
30113	51342	6	applied	\N	\N	\N	\N	153511	153511	153512
30113	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30113	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30113	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30113	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30113	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30113	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30113	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30113	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30113	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30113	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30113	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30113	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30113	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30113	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30113	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30113	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30113	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30113	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30113	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30113	51352	27	applied	\N	\N	\N	\N	153529	153529	98497
30113	51353	28	applied	\N	\N	\N	\N	153531	153531	153568
30113	51354	29	applied	\N	\N	\N	\N	153533	153533	153569
30113	51355	30	applied	\N	\N	\N	\N	153534	153534	98521
30113	51356	31	applied	\N	\N	\N	\N	153535	153535	153570
30113	51357	32	applied	\N	\N	\N	\N	153537	153537	153571
30113	51358	33	applied	\N	\N	\N	\N	153538	153538	153572
30113	51359	34	applied	\N	\N	\N	\N	153540	153540	98542
30113	51360	35	applied	\N	\N	\N	\N	153541	153541	153573
30113	51361	36	applied	\N	\N	\N	\N	153543	153543	98557
30113	51362	37	applied	\N	\N	\N	\N	153545	153545	153574
30113	51363	38	applied	\N	\N	\N	\N	153547	153547	98573
30113	51364	39	applied	\N	\N	\N	\N	153549	153549	153575
30113	51372	40	applied	\N	\N	\N	\N	153576	153576	153577
30113	51373	41	applied	\N	\N	\N	\N	153578	153578	98600
30113	51374	42	applied	\N	\N	\N	\N	153579	153579	153580
30113	51375	43	applied	\N	\N	\N	\N	153581	153581	153582
30113	51376	44	applied	\N	\N	\N	\N	153583	153583	98624
30113	51377	45	applied	\N	\N	\N	\N	153584	153584	99255
30113	51378	46	applied	\N	\N	\N	\N	153585	153585	99256
30113	51379	47	applied	\N	\N	\N	\N	153586	153586	98643
30113	51380	48	applied	\N	\N	\N	\N	153587	153587	153588
30113	51381	49	applied	\N	\N	\N	\N	153589	153589	98655
30113	51382	50	applied	\N	\N	\N	\N	153590	153590	98661
30113	51383	51	applied	\N	\N	\N	\N	153591	153591	153592
30113	51384	52	applied	\N	\N	\N	\N	153593	153593	153594
30116	51385	0	applied	\N	\N	\N	\N	153616	153616	99262
30116	51386	1	applied	\N	\N	\N	\N	153617	153617	99263
30116	51387	2	applied	\N	\N	\N	\N	153618	153618	99264
30116	51388	3	applied	\N	\N	\N	\N	153619	153619	99265
30116	51389	4	applied	\N	\N	\N	\N	153620	153620	99267
30116	51390	5	applied	\N	\N	\N	\N	153621	153621	98690
30116	51391	6	applied	\N	\N	\N	\N	153622	153622	99269
30121	51392	0	applied	\N	\N	\N	\N	153625	153625	153626
30121	51396	1	applied	\N	\N	\N	\N	153637	153637	153638
30121	51397	2	applied	\N	\N	\N	\N	153639	153639	153640
30121	51398	3	applied	\N	\N	\N	\N	153641	153641	111296
30121	51399	4	applied	\N	\N	\N	\N	153642	153642	98699
30121	51393	5	applied	\N	\N	\N	\N	153627	153627	99271
30121	51400	6	applied	\N	\N	\N	\N	153643	153643	98708
30121	51401	7	applied	\N	\N	\N	\N	153644	153644	98736
30121	51394	8	applied	\N	\N	\N	\N	153628	153628	153628
30121	51395	9	applied	\N	\N	\N	\N	153629	153629	153645
30121	51402	10	applied	\N	\N	\N	\N	153646	153646	98738
30121	51403	11	applied	\N	\N	\N	\N	153647	153647	98744
30121	51404	12	applied	\N	\N	\N	\N	153648	153648	153649
30121	51405	13	applied	\N	\N	\N	\N	153650	153650	153651
30121	51406	14	applied	\N	\N	\N	\N	153652	153652	153653
30121	51407	15	applied	\N	\N	\N	\N	153654	153654	98767
30121	51408	16	applied	\N	\N	\N	\N	153655	153655	153656
30121	51409	17	applied	\N	\N	\N	\N	153657	153657	98788
30121	51410	18	applied	\N	\N	\N	\N	153658	153658	99282
30121	51411	19	applied	\N	\N	\N	\N	153659	153659	153660
30121	51412	20	applied	\N	\N	\N	\N	153661	153661	100953
30121	51413	21	applied	\N	\N	\N	\N	153662	153662	98800
30121	51414	22	applied	\N	\N	\N	\N	153663	153663	153664
30123	51415	0	applied	\N	\N	\N	\N	153670	153670	153671
30123	51416	1	applied	\N	\N	\N	\N	153672	153672	153673
30123	51417	2	applied	\N	\N	\N	\N	153674	153674	153675
30123	51418	3	applied	\N	\N	\N	\N	153676	153676	98804
30123	51419	4	applied	\N	\N	\N	\N	153677	153677	99284
30123	51420	5	applied	\N	\N	\N	\N	153678	153678	98826
30123	51421	6	applied	\N	\N	\N	\N	153679	153679	98876
30123	51422	7	applied	\N	\N	\N	\N	153680	153680	98880
30123	51423	8	applied	\N	\N	\N	\N	153681	153681	100957
30123	51424	9	applied	\N	\N	\N	\N	153682	153682	153683
30123	51425	10	applied	\N	\N	\N	\N	153684	153684	98882
30123	51426	11	applied	\N	\N	\N	\N	153685	153685	100959
30123	51427	12	applied	\N	\N	\N	\N	153686	153686	98904
30123	51428	13	applied	\N	\N	\N	\N	153687	153687	99286
30123	51429	14	applied	\N	\N	\N	\N	153688	153688	98909
30123	51430	15	applied	\N	\N	\N	\N	153689	153689	98915
30123	51431	16	applied	\N	\N	\N	\N	153690	153690	100963
30123	51432	17	applied	\N	\N	\N	\N	153691	153691	98922
30123	51433	18	applied	\N	\N	\N	\N	153692	153692	100966
30123	51434	19	applied	\N	\N	\N	\N	153693	153693	98950
30123	51435	20	applied	\N	\N	\N	\N	153694	153694	98952
30123	51436	21	applied	\N	\N	\N	\N	153695	153695	98960
30123	51437	22	applied	\N	\N	\N	\N	153696	153696	153697
30123	51438	23	applied	\N	\N	\N	\N	153698	153698	153699
30123	51439	24	applied	\N	\N	\N	\N	153700	153700	153701
30123	51440	25	applied	\N	\N	\N	\N	153702	153702	98971
30123	51441	26	applied	\N	\N	\N	\N	153703	153703	153704
30123	51442	27	applied	\N	\N	\N	\N	153705	153705	153706
30131	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30131	51494	1	applied	\N	\N	\N	\N	153795	153795	153811
30131	51495	2	applied	\N	\N	\N	\N	153797	153797	99225
30136	51508	0	applied	\N	\N	\N	\N	153828	153828	153829
30136	51511	1	applied	\N	\N	\N	\N	153832	153832	153842
30136	51512	2	applied	\N	\N	\N	\N	153833	153833	99686
30136	51516	3	applied	\N	\N	\N	\N	153838	153838	99374
30136	51517	4	applied	\N	\N	\N	\N	153839	153839	153843
30138	51518	0	applied	\N	\N	\N	\N	153844	153844	153845
30138	51519	1	applied	\N	\N	\N	\N	153846	153846	99376
30138	51509	2	applied	\N	\N	\N	\N	153830	153830	99386
30138	51510	3	applied	\N	\N	\N	\N	153831	153831	99391
30138	51520	4	applied	\N	\N	1000000000	\N	153847	153847	153848
30138	51521	5	applied	\N	\N	\N	\N	153849	153849	99392
30138	51522	6	applied	\N	\N	\N	\N	153850	153850	100018
30114	51345	14	applied	\N	\N	\N	\N	153515	153515	153496
30114	51346	15	applied	\N	\N	\N	\N	153516	153516	153490
30114	51347	16	applied	\N	\N	\N	\N	153517	153517	98452
30114	51348	17	applied	\N	\N	\N	\N	153518	153518	98454
30114	51349	18	applied	\N	\N	\N	\N	153521	153521	153519
30114	51350	19	applied	\N	\N	\N	\N	153523	153523	153522
30114	51351	20	applied	\N	\N	\N	\N	153524	153524	98458
30114	51370	21	applied	\N	\N	\N	\N	153565	153565	153525
30114	51371	22	applied	\N	\N	\N	\N	153566	153566	98460
30114	51381	23	applied	\N	\N	\N	\N	153589	153589	98462
30114	51382	24	applied	\N	\N	\N	\N	153590	153590	153609
30114	51383	25	applied	\N	\N	\N	\N	153591	153591	153610
30114	51384	26	applied	\N	\N	\N	\N	153593	153593	153611
30119	51392	0	applied	\N	\N	\N	\N	153625	153625	153626
30119	51385	1	applied	\N	\N	\N	\N	153616	153616	99262
30119	51386	2	applied	\N	\N	\N	\N	153617	153617	99263
30119	51387	3	applied	\N	\N	\N	\N	153618	153618	99264
30119	51393	4	applied	\N	\N	\N	\N	153627	153627	98676
30119	51394	5	applied	\N	\N	\N	\N	153628	153628	153628
30119	51395	6	applied	\N	\N	\N	\N	153629	153629	153630
30119	51388	7	applied	\N	\N	\N	\N	153619	153619	98686
30119	51389	8	applied	\N	\N	\N	\N	153620	153620	153631
30119	51390	9	applied	\N	\N	\N	\N	153621	153621	98692
30119	51391	10	applied	\N	\N	\N	\N	153622	153622	153632
30127	51482	0	applied	\N	\N	\N	\N	153777	153777	153778
30127	51483	1	applied	\N	\N	\N	\N	153779	153779	99187
30127	51484	2	applied	\N	\N	\N	\N	153780	153780	99672
30127	51485	3	applied	\N	\N	\N	\N	153781	153781	153782
30127	51486	4	applied	\N	\N	\N	\N	153783	153783	99673
30127	51487	5	applied	\N	\N	\N	\N	153784	153784	153785
30127	51488	6	applied	\N	\N	\N	\N	153786	153786	99209
30127	51489	7	applied	\N	\N	\N	\N	153787	153787	99223
30129	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30129	51491	1	applied	\N	\N	\N	\N	153791	153791	99225
30129	51492	2	applied	\N	\N	\N	\N	153792	153792	153793
30129	51496	3	applied	\N	\N	\N	\N	153799	153799	99231
30129	51497	4	applied	\N	\N	\N	\N	153800	153800	99679
30129	51494	5	applied	\N	\N	\N	\N	153795	153795	99296
30129	51495	6	applied	\N	\N	\N	\N	153797	153797	153801
30129	51498	7	applied	\N	\N	\N	\N	153802	153802	153803
30129	51499	8	applied	\N	\N	\N	\N	153804	153804	153805
30133	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30133	51491	1	applied	\N	\N	\N	\N	153791	153791	99225
30133	51492	2	applied	\N	\N	\N	\N	153792	153792	153793
30133	51494	3	applied	\N	\N	\N	\N	153795	153795	99229
30133	51495	4	applied	\N	\N	\N	\N	153797	153797	99677
30139	51518	0	applied	\N	\N	\N	\N	153844	153844	153845
30139	51519	1	applied	\N	\N	\N	\N	153846	153846	99376
30139	51509	2	applied	\N	\N	\N	\N	153830	153830	99386
30139	51510	3	applied	\N	\N	\N	\N	153831	153831	99391
30139	51520	4	applied	\N	\N	1000000000	\N	153847	153847	153848
30139	51522	5	applied	\N	\N	\N	\N	153850	153850	99398
30139	51513	6	applied	\N	\N	\N	\N	153834	153834	153861
30139	51514	7	applied	\N	\N	\N	\N	153835	153835	99413
30139	51515	8	applied	\N	\N	\N	\N	153836	153836	153862
30139	51523	9	applied	\N	\N	\N	\N	153851	153851	99419
30139	51524	10	applied	\N	\N	\N	\N	153853	153853	100023
30139	51525	11	applied	\N	\N	\N	\N	153855	153855	153863
30141	51509	0	applied	\N	\N	\N	\N	153830	153830	99384
30141	51510	1	applied	\N	\N	\N	\N	153831	153831	153867
30141	51522	2	applied	\N	\N	\N	\N	153850	153850	99396
30141	51513	3	applied	\N	\N	\N	\N	153834	153834	100018
30141	51514	4	applied	\N	\N	\N	\N	153835	153835	99401
30141	51515	5	applied	\N	\N	\N	\N	153836	153836	99415
30143	51527	0	applied	\N	\N	\N	\N	153869	153869	153870
30143	51528	1	applied	\N	\N	\N	\N	153871	153871	100026
30143	51529	2	applied	\N	\N	\N	\N	153872	153872	99468
30143	51532	3	applied	\N	\N	\N	\N	153876	153876	100027
30154	51564	0	applied	\N	\N	\N	\N	153939	153939	153940
30154	51565	1	applied	\N	\N	\N	\N	153941	153941	153942
30154	51566	2	applied	\N	\N	\N	\N	153943	153943	153944
30154	51567	3	applied	\N	\N	\N	\N	153945	153945	153946
30154	51568	4	applied	\N	\N	\N	\N	153947	153947	153948
30154	51569	5	applied	\N	\N	\N	\N	153949	153949	99735
30154	51570	6	applied	\N	\N	\N	\N	153950	153950	99739
30154	51571	7	applied	\N	\N	\N	\N	153951	153951	153952
30154	51572	8	applied	\N	\N	\N	\N	153953	153953	99744
30154	51573	9	applied	\N	\N	\N	\N	153954	153954	153955
30154	51574	10	applied	\N	\N	\N	\N	153956	153956	99760
30154	51575	11	applied	\N	\N	\N	\N	153957	153957	153958
30154	51576	12	applied	\N	\N	\N	\N	153959	153959	99771
30154	51577	13	applied	\N	\N	\N	\N	153960	153960	99781
30154	51578	14	applied	\N	\N	\N	\N	153961	153961	153962
30154	51579	15	applied	\N	\N	\N	\N	153963	153963	99790
30154	51580	16	applied	\N	\N	\N	\N	153964	153964	100050
30154	51581	17	applied	\N	\N	\N	\N	153965	153965	100052
30154	51582	18	applied	\N	\N	\N	\N	153966	153966	100054
30154	51583	19	applied	\N	\N	\N	\N	153967	153967	100055
30154	51584	20	applied	\N	\N	\N	\N	153968	153968	99823
30154	51585	21	applied	\N	\N	\N	\N	153969	153969	100056
30154	51586	22	applied	\N	\N	\N	\N	153970	153970	100057
30154	51587	23	applied	\N	\N	\N	\N	153971	153971	99827
30154	51588	24	applied	\N	\N	\N	\N	153972	153972	100058
30154	51589	25	applied	\N	\N	\N	\N	153973	153973	100059
30154	51590	26	applied	\N	\N	\N	\N	153974	153974	99834
30154	51591	27	applied	\N	\N	\N	\N	153975	153975	153976
30154	51592	28	applied	\N	\N	\N	\N	153977	153977	99839
30154	51593	29	applied	\N	\N	\N	\N	153978	153978	99848
30154	51594	30	applied	\N	\N	\N	\N	153979	153979	99853
30154	51595	31	applied	\N	\N	\N	\N	153980	153980	99855
30154	51596	32	applied	\N	\N	\N	\N	153981	153981	99857
30154	51597	33	applied	\N	\N	\N	\N	153982	153982	100168
30154	51598	34	applied	\N	\N	\N	\N	153983	153983	153984
30154	51599	35	applied	\N	\N	\N	\N	153985	153985	153986
30154	51600	36	applied	\N	\N	\N	\N	153987	153987	99872
30154	51601	37	applied	\N	\N	\N	\N	153988	153988	100169
30154	51602	38	applied	\N	\N	\N	\N	153989	153989	99889
30154	51603	39	applied	\N	\N	\N	\N	153990	153990	99897
30154	51604	40	applied	\N	\N	\N	\N	153991	153991	100171
30154	51605	41	applied	\N	\N	\N	\N	153992	153992	99903
30154	51606	42	applied	\N	\N	\N	\N	153993	153993	100351
30154	51607	43	applied	\N	\N	\N	\N	153994	153994	99920
30154	51608	44	applied	\N	\N	\N	\N	153995	153995	153996
30154	51609	45	applied	\N	\N	\N	\N	153997	153997	99924
30154	51610	46	applied	\N	\N	\N	\N	153998	153998	100173
30154	51611	47	applied	\N	\N	\N	\N	153999	153999	99926
30154	51612	48	applied	\N	\N	\N	\N	154000	154000	154001
30157	51613	0	applied	\N	\N	\N	\N	154007	154007	154008
30157	51614	1	applied	\N	\N	\N	\N	154009	154009	154010
30157	51615	2	applied	\N	\N	\N	\N	154011	154011	100174
30115	51343	7	applied	\N	\N	\N	\N	153513	153513	153483
30115	51368	8	applied	\N	\N	\N	\N	153558	153558	98422
30115	51331	9	applied	\N	\N	\N	\N	153482	153482	153559
30115	51332	10	applied	\N	\N	\N	\N	153484	153484	153560
30115	51333	12	applied	\N	\N	\N	\N	153486	153486	153562
30115	51369	13	applied	\N	\N	\N	\N	153563	153563	153496
30115	51344	14	applied	\N	\N	\N	\N	153514	153514	153490
30115	51345	15	applied	\N	\N	\N	\N	153515	153515	98452
30115	51346	16	applied	\N	\N	\N	\N	153516	153516	98454
30115	51347	17	applied	\N	\N	\N	\N	153517	153517	153519
30115	51348	18	applied	\N	\N	\N	\N	153518	153518	153522
30115	51349	19	applied	\N	\N	\N	\N	153521	153521	98458
30115	51350	20	applied	\N	\N	\N	\N	153523	153523	153525
30115	51351	21	applied	\N	\N	\N	\N	153524	153524	153564
30115	51370	22	applied	\N	\N	\N	\N	153565	153565	153526
30115	51334	23	applied	\N	\N	\N	\N	153488	153488	98474
30115	51335	24	applied	\N	\N	\N	\N	153489	153489	98491
30115	51336	25	applied	\N	\N	\N	\N	153491	153491	153530
30115	51371	26	applied	\N	\N	\N	\N	153566	153566	153567
30115	51352	27	applied	\N	\N	\N	\N	153529	153529	98497
30115	51353	28	applied	\N	\N	\N	\N	153531	153531	153568
30115	51354	29	applied	\N	\N	\N	\N	153533	153533	153569
30115	51355	30	applied	\N	\N	\N	\N	153534	153534	98521
30115	51356	31	applied	\N	\N	\N	\N	153535	153535	153570
30115	51357	32	applied	\N	\N	\N	\N	153537	153537	153571
30115	51358	33	applied	\N	\N	\N	\N	153538	153538	153572
30115	51359	34	applied	\N	\N	\N	\N	153540	153540	98542
30115	51360	35	applied	\N	\N	\N	\N	153541	153541	153573
30115	51361	36	applied	\N	\N	\N	\N	153543	153543	98557
30115	51362	37	applied	\N	\N	\N	\N	153545	153545	153574
30115	51363	38	applied	\N	\N	\N	\N	153547	153547	98573
30115	51364	39	applied	\N	\N	\N	\N	153549	153549	153575
30115	51372	40	applied	\N	\N	\N	\N	153576	153576	153577
30115	51373	41	applied	\N	\N	\N	\N	153578	153578	98600
30115	51374	42	applied	\N	\N	\N	\N	153579	153579	153580
30115	51375	43	applied	\N	\N	\N	\N	153581	153581	153582
30115	51376	44	applied	\N	\N	\N	\N	153583	153583	98624
30115	51377	45	applied	\N	\N	\N	\N	153584	153584	99255
30115	51378	46	applied	\N	\N	\N	\N	153585	153585	99256
30115	51379	47	applied	\N	\N	\N	\N	153586	153586	98643
30115	51380	48	applied	\N	\N	\N	\N	153587	153587	153588
30115	51381	49	applied	\N	\N	\N	\N	153589	153589	98655
30115	51382	50	applied	\N	\N	\N	\N	153590	153590	98661
30115	51383	51	applied	\N	\N	\N	\N	153591	153591	153592
30115	51384	52	applied	\N	\N	\N	\N	153593	153593	153594
30117	51392	0	applied	\N	\N	\N	\N	153625	153625	153626
30117	51385	1	applied	\N	\N	\N	\N	153616	153616	99262
30117	51386	2	applied	\N	\N	\N	\N	153617	153617	99263
30117	51387	3	applied	\N	\N	\N	\N	153618	153618	99264
30117	51393	4	applied	\N	\N	\N	\N	153627	153627	98676
30117	51394	5	applied	\N	\N	\N	\N	153628	153628	153628
30117	51395	6	applied	\N	\N	\N	\N	153629	153629	153630
30117	51388	7	applied	\N	\N	\N	\N	153619	153619	98686
30117	51389	8	applied	\N	\N	\N	\N	153620	153620	153631
30117	51390	9	applied	\N	\N	\N	\N	153621	153621	98692
30117	51391	10	applied	\N	\N	\N	\N	153622	153622	153632
30122	51392	0	applied	\N	\N	\N	\N	153625	153625	153626
30122	51396	1	applied	\N	\N	\N	\N	153637	153637	153638
30122	51397	2	applied	\N	\N	\N	\N	153639	153639	153640
30122	51398	3	applied	\N	\N	\N	\N	153641	153641	111296
30122	51399	4	applied	\N	\N	\N	\N	153642	153642	98699
30122	51393	5	applied	\N	\N	\N	\N	153627	153627	99271
30122	51400	6	applied	\N	\N	\N	\N	153643	153643	98708
30122	51401	7	applied	\N	\N	\N	\N	153644	153644	98736
30122	51394	8	applied	\N	\N	\N	\N	153628	153628	153628
30122	51395	9	applied	\N	\N	\N	\N	153629	153629	153645
30122	51402	10	applied	\N	\N	\N	\N	153646	153646	98738
30122	51403	11	applied	\N	\N	\N	\N	153647	153647	98744
30122	51404	12	applied	\N	\N	\N	\N	153648	153648	153649
30122	51405	13	applied	\N	\N	\N	\N	153650	153650	153651
30122	51406	14	applied	\N	\N	\N	\N	153652	153652	153653
30122	51407	15	applied	\N	\N	\N	\N	153654	153654	98767
30122	51408	16	applied	\N	\N	\N	\N	153655	153655	153656
30122	51409	17	applied	\N	\N	\N	\N	153657	153657	98788
30122	51410	18	applied	\N	\N	\N	\N	153658	153658	99282
30122	51411	19	applied	\N	\N	\N	\N	153659	153659	153660
30122	51412	20	applied	\N	\N	\N	\N	153661	153661	100953
30122	51413	21	applied	\N	\N	\N	\N	153662	153662	98800
30122	51414	22	applied	\N	\N	\N	\N	153663	153663	153664
30124	51443	0	applied	\N	\N	\N	\N	153708	153708	153709
30124	51444	1	applied	\N	\N	\N	\N	153710	153710	153711
30124	51445	2	applied	\N	\N	\N	\N	153712	153712	98979
30124	51446	3	applied	\N	\N	\N	\N	153713	153713	98987
30124	51447	4	applied	\N	\N	\N	\N	153714	153714	153715
30124	51448	5	applied	\N	\N	\N	\N	153716	153716	153717
30124	51449	6	applied	\N	\N	\N	\N	153718	153718	99002
30124	51450	7	applied	\N	\N	\N	\N	153719	153719	153720
30124	51451	8	applied	\N	\N	\N	\N	153721	153721	153722
30124	51452	9	applied	\N	\N	\N	\N	153723	153723	153724
30124	51453	10	applied	\N	\N	\N	\N	153725	153725	153726
30124	51454	11	applied	\N	\N	\N	\N	153727	153727	99038
30124	51455	12	applied	\N	\N	\N	\N	153728	153728	99040
30124	51456	13	applied	\N	\N	\N	\N	153729	153729	99652
30124	51457	14	applied	\N	\N	\N	\N	153730	153730	153731
30124	51458	15	applied	\N	\N	\N	\N	153732	153732	99056
30124	51459	16	applied	\N	\N	\N	\N	153733	153733	99654
30124	51460	17	applied	\N	\N	\N	\N	153734	153734	99656
30124	51461	18	applied	\N	\N	\N	\N	153735	153735	99658
30124	51462	19	applied	\N	\N	\N	\N	153736	153736	99074
30126	51463	0	applied	\N	\N	\N	\N	153739	153739	153740
30126	51464	1	applied	\N	\N	\N	\N	153741	153741	153742
30126	51465	2	applied	\N	\N	\N	\N	153743	153743	99660
30126	51466	3	applied	\N	\N	\N	\N	153744	153744	99083
30126	51467	4	applied	\N	\N	\N	\N	153745	153745	99662
30126	51468	5	applied	\N	\N	\N	\N	153746	153746	99101
30126	51469	6	applied	\N	\N	\N	\N	153747	153747	153748
30126	51470	7	applied	\N	\N	\N	\N	153749	153749	99106
30126	51471	8	applied	\N	\N	\N	\N	153750	153750	153751
30126	51472	9	applied	\N	\N	\N	\N	153752	153752	99665
30126	51473	10	applied	\N	\N	\N	\N	153753	153753	153754
30126	51474	11	applied	\N	\N	\N	\N	153755	153755	153756
30126	51475	12	applied	\N	\N	\N	\N	153757	153757	99131
30126	51476	13	applied	\N	\N	\N	\N	153758	153758	153759
30126	51477	14	applied	\N	\N	\N	\N	153760	153760	99144
30126	51478	15	applied	\N	\N	\N	\N	153761	153761	153762
30126	51479	16	applied	\N	\N	\N	\N	153763	153763	99164
30126	51480	17	applied	\N	\N	\N	\N	153764	153764	99176
30126	51481	18	applied	\N	\N	\N	\N	153765	153765	153766
30128	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30128	51491	1	applied	\N	\N	\N	\N	153791	153791	99225
30125	51480	17	applied	\N	\N	\N	\N	153764	153764	99176
30125	51481	18	applied	\N	\N	\N	\N	153765	153765	153766
30130	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30130	51491	1	applied	\N	\N	\N	\N	153791	153791	99225
30130	51492	2	applied	\N	\N	\N	\N	153792	153792	153793
30130	51493	3	applied	\N	\N	\N	\N	153794	153794	99677
30130	51496	4	applied	\N	\N	\N	\N	153799	153799	99292
30130	51497	5	applied	\N	\N	\N	\N	153800	153800	153801
30130	51494	6	applied	\N	\N	\N	\N	153795	153795	99304
30130	51495	7	applied	\N	\N	\N	\N	153797	153797	153807
30130	51498	8	applied	\N	\N	\N	\N	153802	153802	99310
30130	51499	9	applied	\N	\N	\N	\N	153804	153804	153808
30130	51500	10	applied	\N	\N	\N	\N	153809	153809	99319
30132	51490	0	applied	\N	\N	\N	\N	153789	153789	153790
30132	51491	1	applied	\N	\N	\N	\N	153791	153791	99225
30132	51492	2	applied	\N	\N	\N	\N	153792	153792	153793
30132	51493	3	applied	\N	\N	\N	\N	153794	153794	99677
30132	51496	4	applied	\N	\N	\N	\N	153799	153799	99292
30132	51497	5	applied	\N	\N	\N	\N	153800	153800	153801
30132	51494	6	applied	\N	\N	\N	\N	153795	153795	99304
30132	51495	7	applied	\N	\N	\N	\N	153797	153797	153807
30132	51498	8	applied	\N	\N	\N	\N	153802	153802	99310
30132	51499	9	applied	\N	\N	\N	\N	153804	153804	153808
30132	51500	10	applied	\N	\N	\N	\N	153809	153809	99319
30134	51501	0	applied	\N	\N	\N	\N	153816	153816	153817
30134	51491	1	applied	\N	\N	\N	\N	153791	153791	153793
30134	51492	2	applied	\N	\N	\N	\N	153792	153792	99677
30134	51502	3	applied	\N	\N	\N	\N	153818	153818	153796
30134	51493	4	applied	\N	\N	\N	\N	153794	153794	99678
30134	51496	5	applied	\N	\N	\N	\N	153799	153799	99296
30134	51497	6	applied	\N	\N	\N	\N	153800	153800	99308
30134	51498	7	applied	\N	\N	\N	\N	153802	153802	99681
30134	51499	8	applied	\N	\N	\N	\N	153804	153804	99682
30134	51500	9	applied	\N	\N	\N	\N	153809	153809	153819
30134	51503	10	applied	\N	\N	\N	\N	153820	153820	99334
30134	51504	11	applied	\N	\N	\N	\N	153821	153821	99684
30134	51505	12	applied	\N	\N	\N	\N	153822	153822	99359
30134	51506	13	applied	\N	\N	\N	\N	153823	153823	99362
30134	51507	14	applied	\N	\N	\N	\N	153824	153824	153825
30145	51536	0	applied	\N	\N	\N	\N	153884	153884	153885
30145	51537	1	applied	\N	\N	\N	\N	153886	153886	153887
30145	51538	2	applied	\N	\N	\N	\N	153888	153888	99513
30145	51539	3	applied	\N	\N	\N	\N	153889	153889	99520
30145	51540	4	applied	\N	\N	\N	\N	153890	153890	100033
30145	51541	5	applied	\N	\N	\N	\N	153891	153891	99522
30145	51542	6	applied	\N	\N	\N	\N	153892	153892	153893
30145	51543	7	applied	\N	\N	\N	\N	153894	153894	99532
30145	51544	8	applied	\N	\N	\N	\N	153895	153895	153896
30145	51545	9	applied	\N	\N	\N	\N	153897	153897	153898
30147	51546	0	applied	\N	\N	\N	\N	153903	153903	153904
30147	51547	1	applied	\N	\N	\N	\N	153905	153905	153906
30147	51548	2	applied	\N	\N	\N	\N	153907	153907	99562
30147	51549	3	applied	\N	\N	\N	\N	153908	153908	153909
30147	51550	4	applied	\N	\N	\N	\N	153910	153910	99572
30147	51551	5	applied	\N	\N	\N	\N	153911	153911	100036
30147	51552	6	applied	\N	\N	\N	\N	153912	153912	153913
30147	51553	7	applied	\N	\N	\N	\N	153914	153914	153915
30149	51554	0	applied	\N	\N	\N	\N	153922	153922	153923
30149	51555	1	applied	\N	\N	\N	\N	153924	153924	153925
30149	51556	2	applied	\N	\N	\N	\N	153926	153926	99599
30149	51557	3	applied	\N	\N	\N	\N	153927	153927	100039
30149	51558	4	applied	\N	\N	\N	\N	153928	153928	153929
30149	51559	5	applied	\N	\N	\N	\N	153930	153930	99702
30149	51560	6	applied	\N	\N	\N	\N	153931	153931	100041
30149	51561	7	applied	\N	\N	\N	\N	153932	153932	99714
30149	51562	8	applied	\N	\N	\N	\N	153933	153933	99722
30149	51563	9	applied	\N	\N	\N	\N	153934	153934	99716
30156	51613	0	applied	\N	\N	\N	\N	154007	154007	154008
30156	51614	1	applied	\N	\N	\N	\N	154009	154009	154010
30156	51615	2	applied	\N	\N	\N	\N	154011	154011	100174
30156	51616	3	applied	\N	\N	\N	\N	154012	154012	154013
30156	51617	4	applied	\N	\N	\N	\N	154014	154014	154015
30156	51618	5	applied	\N	\N	\N	\N	154016	154016	154017
30156	51619	6	applied	\N	\N	\N	\N	154018	154018	100175
30156	51620	7	applied	\N	\N	\N	\N	154019	154019	99945
30156	51621	8	applied	\N	\N	\N	\N	154020	154020	154021
30156	51622	9	applied	\N	\N	\N	\N	154022	154022	100355
30158	51623	0	applied	\N	\N	\N	\N	154026	154026	154027
30158	51624	1	applied	\N	\N	\N	\N	154028	154028	100178
30158	51625	2	applied	\N	\N	\N	\N	154029	154029	99968
30158	51626	3	applied	\N	\N	\N	\N	154030	154030	100180
30158	51627	4	applied	\N	\N	\N	\N	154031	154031	100182
30158	51628	5	applied	\N	\N	\N	\N	154032	154032	100183
30158	51629	6	applied	\N	\N	\N	\N	154033	154033	100184
30158	51630	7	applied	\N	\N	\N	\N	154034	154034	100076
30162	51639	0	applied	\N	\N	\N	\N	154049	154049	154050
30162	51640	1	applied	\N	\N	\N	\N	154051	154051	100359
30162	51641	2	applied	\N	\N	\N	\N	154052	154052	100361
30162	51642	3	applied	\N	\N	\N	\N	154053	154053	100139
30162	51643	4	applied	\N	\N	\N	\N	154054	154054	100197
30162	51644	5	applied	\N	\N	\N	\N	154055	154055	100362
30162	51645	6	applied	\N	\N	\N	\N	154056	154056	154057
30162	51646	7	applied	\N	\N	\N	\N	154058	154058	100153
30162	51647	8	applied	\N	\N	\N	\N	154059	154059	154060
30162	51648	9	applied	\N	\N	\N	\N	154061	154061	100365
30162	51649	10	applied	\N	\N	\N	\N	154062	154062	100366
30164	51650	0	applied	\N	\N	\N	\N	154065	154065	154066
30164	51651	1	applied	\N	\N	\N	\N	154067	154067	154068
30164	51652	2	applied	\N	\N	\N	\N	154069	154069	154070
30164	51653	3	applied	\N	\N	\N	\N	154071	154071	154072
30164	51654	4	applied	\N	\N	\N	\N	154073	154073	100209
30164	51655	5	applied	\N	\N	\N	\N	154074	154074	100231
30164	51656	6	applied	\N	\N	\N	\N	154075	154075	100218
30164	51657	7	applied	\N	\N	\N	\N	154076	154076	154077
30164	51658	8	applied	\N	\N	\N	\N	154078	154078	100232
30164	51659	9	applied	\N	\N	\N	\N	154079	154079	100224
30164	51660	10	applied	\N	\N	\N	\N	154080	154080	154081
30164	51661	11	applied	\N	\N	\N	\N	154082	154082	100451
30164	51662	12	applied	\N	\N	\N	\N	154083	154083	100238
30164	51663	13	applied	\N	\N	\N	\N	154084	154084	100242
30164	51664	14	applied	\N	\N	\N	\N	154085	154085	100453
30164	51665	15	applied	\N	\N	\N	\N	154086	154086	154087
30164	51666	16	applied	\N	\N	\N	\N	154088	154088	154089
30164	51667	17	applied	\N	\N	\N	\N	154090	154090	100257
30164	51668	18	applied	\N	\N	\N	\N	154091	154091	100259
30164	51669	19	applied	\N	\N	\N	\N	154092	154092	100456
30164	51670	20	applied	\N	\N	\N	\N	154093	154093	100507
30164	51671	21	applied	\N	\N	\N	\N	154094	154094	154095
30164	51672	22	applied	\N	\N	\N	\N	154096	154096	100275
30164	51673	23	applied	\N	\N	\N	\N	154097	154097	154098
30128	51492	2	applied	\N	\N	\N	\N	153792	153792	153793
30128	51493	3	applied	\N	\N	\N	\N	153794	153794	99677
30128	51494	4	applied	\N	\N	\N	\N	153795	153795	153796
30128	51495	5	applied	\N	\N	\N	\N	153797	153797	99231
30135	51508	0	applied	\N	\N	\N	\N	153828	153828	153829
30135	51509	1	applied	\N	\N	\N	\N	153830	153830	99686
30135	51510	2	applied	\N	\N	\N	\N	153831	153831	99376
30135	51511	3	applied	\N	\N	\N	\N	153832	153832	99384
30135	51512	4	applied	\N	\N	\N	\N	153833	153833	99386
30135	51513	5	applied	\N	\N	\N	\N	153834	153834	99391
30135	51514	6	applied	\N	\N	\N	\N	153835	153835	99399
30135	51515	7	applied	\N	\N	\N	\N	153836	153836	153837
30135	51516	8	applied	\N	\N	\N	\N	153838	153838	99413
30135	51517	9	applied	\N	\N	\N	\N	153839	153839	153840
30137	51518	0	applied	\N	\N	\N	\N	153844	153844	153845
30137	51519	1	applied	\N	\N	\N	\N	153846	153846	99376
30137	51509	2	applied	\N	\N	\N	\N	153830	153830	99386
30137	51510	3	applied	\N	\N	\N	\N	153831	153831	99391
30137	51520	4	applied	\N	\N	1000000000	\N	153847	153847	153848
30137	51521	5	applied	\N	\N	\N	\N	153849	153849	99392
30137	51522	6	applied	\N	\N	\N	\N	153850	153850	100018
30137	51513	7	applied	\N	\N	\N	\N	153834	153834	99401
30137	51514	8	applied	\N	\N	\N	\N	153835	153835	99415
30137	51515	9	applied	\N	\N	\N	\N	153836	153836	100021
30137	51523	10	applied	\N	\N	\N	\N	153851	153851	153852
30137	51524	11	applied	\N	\N	\N	\N	153853	153853	153854
30137	51525	12	applied	\N	\N	\N	\N	153855	153855	100024
30137	51526	13	applied	\N	\N	\N	\N	153856	153856	99466
30166	51650	0	applied	\N	\N	\N	\N	154065	154065	154066
30166	51651	1	applied	\N	\N	\N	\N	154067	154067	154068
30166	51652	2	applied	\N	\N	\N	\N	154069	154069	154070
30166	51653	3	applied	\N	\N	\N	\N	154071	154071	154072
30166	51654	4	applied	\N	\N	\N	\N	154073	154073	100209
30166	51655	5	applied	\N	\N	\N	\N	154074	154074	100231
30166	51656	6	applied	\N	\N	\N	\N	154075	154075	100218
30166	51657	7	applied	\N	\N	\N	\N	154076	154076	154077
30166	51658	8	applied	\N	\N	\N	\N	154078	154078	100232
30166	51659	9	applied	\N	\N	\N	\N	154079	154079	100224
30166	51660	10	applied	\N	\N	\N	\N	154080	154080	154081
30166	51661	11	applied	\N	\N	\N	\N	154082	154082	100451
30166	51662	12	applied	\N	\N	\N	\N	154083	154083	100238
30166	51663	13	applied	\N	\N	\N	\N	154084	154084	100242
30166	51664	14	applied	\N	\N	\N	\N	154085	154085	100453
30166	51665	15	applied	\N	\N	\N	\N	154086	154086	154087
30166	51666	16	applied	\N	\N	\N	\N	154088	154088	154089
30166	51667	17	applied	\N	\N	\N	\N	154090	154090	100257
30166	51668	18	applied	\N	\N	\N	\N	154091	154091	100259
30166	51669	19	applied	\N	\N	\N	\N	154092	154092	100456
30166	51670	20	applied	\N	\N	\N	\N	154093	154093	100507
30166	51671	21	applied	\N	\N	\N	\N	154094	154094	154095
30166	51672	22	applied	\N	\N	\N	\N	154096	154096	100275
30166	51673	23	applied	\N	\N	\N	\N	154097	154097	154098
30166	51674	24	applied	\N	\N	\N	\N	154099	154099	100295
30166	51675	25	applied	\N	\N	\N	\N	154100	154100	100510
30166	51676	26	applied	\N	\N	\N	\N	154101	154101	100462
30166	51677	27	applied	\N	\N	\N	\N	154102	154102	100513
30166	51678	28	applied	\N	\N	\N	\N	154103	154103	100320
30166	51679	29	applied	\N	\N	\N	\N	154104	154104	100465
30166	51680	31	applied	\N	\N	\N	\N	154106	154106	100515
30166	51681	32	applied	\N	\N	\N	\N	154107	154107	100374
30166	51682	33	applied	\N	\N	\N	\N	154108	154108	100378
30166	51683	34	applied	\N	\N	\N	\N	154109	154109	100517
30166	51684	35	applied	\N	\N	\N	\N	154110	154110	100397
30166	51685	36	applied	\N	\N	\N	\N	154111	154111	100404
30166	51686	37	applied	\N	\N	\N	\N	154112	154112	100518
30166	51687	38	applied	\N	\N	\N	\N	154113	154113	100422
30166	51688	39	applied	\N	\N	\N	\N	154114	154114	100426
30168	51689	0	applied	\N	\N	\N	\N	154131	154131	154132
30168	51690	1	applied	\N	\N	\N	\N	154133	154133	100428
30168	51691	2	applied	\N	\N	\N	\N	154134	154134	100478
30168	51693	3	applied	\N	\N	\N	\N	154136	154136	100479
30168	51694	4	applied	\N	\N	\N	\N	154137	154137	100481
30168	51695	5	applied	\N	\N	\N	\N	154138	154138	100489
30168	51696	6	applied	\N	\N	\N	\N	154139	154139	154150
30168	51697	7	applied	\N	\N	\N	\N	154141	154141	100493
30170	51698	0	applied	\N	\N	\N	\N	154155	154155	154156
30170	51699	1	applied	\N	\N	\N	\N	154157	154157	100527
30170	51700	2	applied	\N	\N	\N	\N	154158	154158	100530
30170	51701	3	applied	\N	\N	\N	\N	154159	154159	154160
30170	51702	4	applied	\N	\N	\N	\N	154161	154161	100537
30170	51703	5	applied	\N	\N	\N	\N	154162	154162	100549
30170	51704	6	applied	\N	\N	\N	\N	154163	154163	154164
30170	51705	7	applied	\N	\N	\N	\N	154165	154165	101146
30172	51698	0	applied	\N	\N	\N	\N	154155	154155	154156
30172	51699	1	applied	\N	\N	\N	\N	154157	154157	100527
30172	51700	2	applied	\N	\N	\N	\N	154158	154158	100530
30172	51701	3	applied	\N	\N	\N	\N	154159	154159	154160
30172	51702	4	applied	\N	\N	\N	\N	154161	154161	100537
30172	51703	5	applied	\N	\N	\N	\N	154162	154162	100549
30172	51704	6	applied	\N	\N	\N	\N	154163	154163	154164
30172	51705	7	applied	\N	\N	\N	\N	154165	154165	101146
30174	51706	0	applied	\N	\N	\N	\N	154169	154169	154170
30174	51707	1	applied	\N	\N	\N	\N	154171	154171	154172
30174	51708	2	applied	\N	\N	\N	\N	154173	154173	101148
30174	51709	3	applied	\N	\N	\N	\N	154174	154174	100581
30174	51710	4	applied	\N	\N	\N	\N	154175	154175	100585
30174	51711	5	applied	\N	\N	\N	\N	154176	154176	154177
30174	51712	6	applied	\N	\N	\N	\N	154178	154178	100596
30174	51713	7	applied	\N	\N	\N	\N	154179	154179	101151
30174	51714	8	applied	\N	\N	\N	\N	154180	154180	154181
30184	51752	0	applied	\N	\N	\N	\N	154256	154256	154257
30184	51753	1	applied	\N	\N	\N	\N	154258	154258	101656
30184	51754	2	applied	\N	\N	\N	\N	154259	154259	101657
30184	51756	3	applied	\N	\N	\N	\N	154261	154261	100750
30184	51757	4	applied	\N	\N	\N	\N	154263	154263	154271
30184	51758	5	applied	\N	\N	\N	\N	154264	154264	154272
30184	51759	6	applied	\N	\N	\N	\N	154266	154266	154273
30184	51760	7	applied	\N	\N	\N	\N	154268	154268	154274
30186	51761	0	applied	\N	\N	\N	\N	154283	154283	154284
30186	51762	1	applied	\N	\N	\N	\N	154285	154285	154286
30186	51763	2	applied	\N	\N	\N	\N	154287	154287	101663
30186	51764	3	applied	\N	\N	\N	\N	154288	154288	101664
30186	51765	4	applied	\N	\N	\N	\N	154289	154289	101666
30186	51766	5	applied	\N	\N	\N	\N	154290	154290	101667
30186	51767	6	applied	\N	\N	\N	\N	154291	154291	101669
30193	51798	0	applied	\N	\N	\N	\N	154368	154368	154369
30193	51799	1	applied	\N	\N	\N	\N	154370	154370	154371
30193	51800	2	applied	\N	\N	\N	\N	154372	154372	29193
30193	51801	3	applied	\N	\N	\N	\N	154373	154373	100924
30193	51802	4	applied	\N	\N	\N	\N	154374	154374	100930
30138	51513	7	applied	\N	\N	\N	\N	153834	153834	99401
30138	51514	8	applied	\N	\N	\N	\N	153835	153835	99415
30138	51515	9	applied	\N	\N	\N	\N	153836	153836	100021
30138	51523	10	applied	\N	\N	\N	\N	153851	153851	153852
30138	51524	11	applied	\N	\N	\N	\N	153853	153853	153854
30138	51525	12	applied	\N	\N	\N	\N	153855	153855	100024
30138	51526	13	applied	\N	\N	\N	\N	153856	153856	99466
30140	51518	0	applied	\N	\N	\N	\N	153844	153844	153845
30140	51519	1	applied	\N	\N	\N	\N	153846	153846	99376
30140	51509	2	applied	\N	\N	\N	\N	153830	153830	99386
30140	51510	3	applied	\N	\N	\N	\N	153831	153831	99391
30140	51520	4	applied	\N	\N	1000000000	\N	153847	153847	153848
30140	51513	5	applied	\N	\N	\N	\N	153834	153834	99399
30140	51514	6	applied	\N	\N	\N	\N	153835	153835	153837
30140	51515	7	applied	\N	\N	\N	\N	153836	153836	100020
30140	51523	8	applied	\N	\N	\N	\N	153851	153851	153865
30140	51524	9	applied	\N	\N	\N	\N	153853	153853	99425
30140	51525	10	applied	\N	\N	\N	\N	153855	153855	99460
30142	51527	0	applied	\N	\N	\N	\N	153869	153869	153870
30142	51528	1	applied	\N	\N	\N	\N	153871	153871	100026
30142	51529	2	applied	\N	\N	\N	\N	153872	153872	99468
30142	51530	3	applied	\N	\N	\N	\N	153873	153873	153874
30142	51531	4	applied	\N	\N	\N	\N	153875	153875	99479
30142	51532	5	applied	\N	\N	\N	\N	153876	153876	99484
30142	51533	6	applied	\N	\N	\N	\N	153877	153877	100029
30142	51534	7	applied	\N	\N	\N	\N	153878	153878	99494
30142	51535	8	applied	\N	\N	\N	\N	153879	153879	153880
30144	51536	0	applied	\N	\N	\N	\N	153884	153884	153885
30144	51537	1	applied	\N	\N	\N	\N	153886	153886	153887
30144	51538	2	applied	\N	\N	\N	\N	153888	153888	99513
30144	51539	3	applied	\N	\N	\N	\N	153889	153889	99520
30144	51540	4	applied	\N	\N	\N	\N	153890	153890	100033
30144	51541	5	applied	\N	\N	\N	\N	153891	153891	99522
30144	51542	6	applied	\N	\N	\N	\N	153892	153892	153893
30144	51543	7	applied	\N	\N	\N	\N	153894	153894	99532
30144	51544	8	applied	\N	\N	\N	\N	153895	153895	153896
30144	51545	9	applied	\N	\N	\N	\N	153897	153897	153898
30146	51546	0	applied	\N	\N	\N	\N	153903	153903	153904
30146	51547	1	applied	\N	\N	\N	\N	153905	153905	153906
30146	51548	2	applied	\N	\N	\N	\N	153907	153907	99562
30146	51549	3	applied	\N	\N	\N	\N	153908	153908	153909
30146	51550	4	applied	\N	\N	\N	\N	153910	153910	99572
30146	51551	5	applied	\N	\N	\N	\N	153911	153911	100036
30146	51552	6	applied	\N	\N	\N	\N	153912	153912	153913
30146	51553	7	applied	\N	\N	\N	\N	153914	153914	153915
30148	51546	0	applied	\N	\N	\N	\N	153903	153903	153904
30148	51547	1	applied	\N	\N	\N	\N	153905	153905	153906
30148	51548	2	applied	\N	\N	\N	\N	153907	153907	99562
30148	51549	3	applied	\N	\N	\N	\N	153908	153908	153909
30148	51550	4	applied	\N	\N	\N	\N	153910	153910	99572
30148	51551	5	applied	\N	\N	\N	\N	153911	153911	100036
30148	51552	6	applied	\N	\N	\N	\N	153912	153912	153913
30148	51553	7	applied	\N	\N	\N	\N	153914	153914	153915
30150	51554	0	applied	\N	\N	\N	\N	153922	153922	153923
30150	51555	1	applied	\N	\N	\N	\N	153924	153924	153925
30150	51556	2	applied	\N	\N	\N	\N	153926	153926	99599
30150	51557	3	applied	\N	\N	\N	\N	153927	153927	100039
30150	51558	4	applied	\N	\N	\N	\N	153928	153928	153929
30150	51559	5	applied	\N	\N	\N	\N	153930	153930	99702
30150	51560	6	applied	\N	\N	\N	\N	153931	153931	100041
30150	51561	7	applied	\N	\N	\N	\N	153932	153932	99714
30150	51562	8	applied	\N	\N	\N	\N	153933	153933	99722
30150	51563	9	applied	\N	\N	\N	\N	153934	153934	99716
30153	51564	0	applied	\N	\N	\N	\N	153939	153939	153940
30153	51565	1	applied	\N	\N	\N	\N	153941	153941	153942
30153	51566	2	applied	\N	\N	\N	\N	153943	153943	153944
30153	51567	3	applied	\N	\N	\N	\N	153945	153945	153946
30153	51568	4	applied	\N	\N	\N	\N	153947	153947	153948
30153	51569	5	applied	\N	\N	\N	\N	153949	153949	99735
30153	51570	6	applied	\N	\N	\N	\N	153950	153950	99739
30153	51571	7	applied	\N	\N	\N	\N	153951	153951	153952
30153	51572	8	applied	\N	\N	\N	\N	153953	153953	99744
30153	51573	9	applied	\N	\N	\N	\N	153954	153954	153955
30153	51574	10	applied	\N	\N	\N	\N	153956	153956	99760
30153	51575	11	applied	\N	\N	\N	\N	153957	153957	153958
30153	51576	12	applied	\N	\N	\N	\N	153959	153959	99771
30153	51577	13	applied	\N	\N	\N	\N	153960	153960	99781
30153	51578	14	applied	\N	\N	\N	\N	153961	153961	153962
30153	51579	15	applied	\N	\N	\N	\N	153963	153963	99790
30153	51580	16	applied	\N	\N	\N	\N	153964	153964	100050
30153	51581	17	applied	\N	\N	\N	\N	153965	153965	100052
30153	51582	18	applied	\N	\N	\N	\N	153966	153966	100054
30153	51583	19	applied	\N	\N	\N	\N	153967	153967	100055
30153	51584	20	applied	\N	\N	\N	\N	153968	153968	99823
30153	51585	21	applied	\N	\N	\N	\N	153969	153969	100056
30153	51586	22	applied	\N	\N	\N	\N	153970	153970	100057
30153	51587	23	applied	\N	\N	\N	\N	153971	153971	99827
30153	51588	24	applied	\N	\N	\N	\N	153972	153972	100058
30153	51589	25	applied	\N	\N	\N	\N	153973	153973	100059
30153	51590	26	applied	\N	\N	\N	\N	153974	153974	99834
30153	51591	27	applied	\N	\N	\N	\N	153975	153975	153976
30153	51592	28	applied	\N	\N	\N	\N	153977	153977	99839
30153	51593	29	applied	\N	\N	\N	\N	153978	153978	99848
30153	51594	30	applied	\N	\N	\N	\N	153979	153979	99853
30153	51595	31	applied	\N	\N	\N	\N	153980	153980	99855
30153	51596	32	applied	\N	\N	\N	\N	153981	153981	99857
30153	51597	33	applied	\N	\N	\N	\N	153982	153982	100168
30153	51598	34	applied	\N	\N	\N	\N	153983	153983	153984
30153	51599	35	applied	\N	\N	\N	\N	153985	153985	153986
30153	51600	36	applied	\N	\N	\N	\N	153987	153987	99872
30153	51601	37	applied	\N	\N	\N	\N	153988	153988	100169
30153	51602	38	applied	\N	\N	\N	\N	153989	153989	99889
30153	51603	39	applied	\N	\N	\N	\N	153990	153990	99897
30153	51604	40	applied	\N	\N	\N	\N	153991	153991	100171
30153	51605	41	applied	\N	\N	\N	\N	153992	153992	99903
30153	51606	42	applied	\N	\N	\N	\N	153993	153993	100351
30153	51607	43	applied	\N	\N	\N	\N	153994	153994	99920
30153	51608	44	applied	\N	\N	\N	\N	153995	153995	153996
30153	51609	45	applied	\N	\N	\N	\N	153997	153997	99924
30153	51610	46	applied	\N	\N	\N	\N	153998	153998	100173
30153	51611	47	applied	\N	\N	\N	\N	153999	153999	99926
30153	51612	48	applied	\N	\N	\N	\N	154000	154000	154001
30155	51613	0	applied	\N	\N	\N	\N	154007	154007	154008
30155	51614	1	applied	\N	\N	\N	\N	154009	154009	154010
30155	51615	2	applied	\N	\N	\N	\N	154011	154011	100174
30155	51616	3	applied	\N	\N	\N	\N	154012	154012	154013
30155	51617	4	applied	\N	\N	\N	\N	154014	154014	154015
30155	51618	5	applied	\N	\N	\N	\N	154016	154016	154017
30155	51619	6	applied	\N	\N	\N	\N	154018	154018	100175
30155	51620	7	applied	\N	\N	\N	\N	154019	154019	99945
30155	51621	8	applied	\N	\N	\N	\N	154020	154020	154021
30155	51622	9	applied	\N	\N	\N	\N	154022	154022	100355
30159	51623	0	applied	\N	\N	\N	\N	154026	154026	154027
30159	51624	1	applied	\N	\N	\N	\N	154028	154028	100178
30159	51625	2	applied	\N	\N	\N	\N	154029	154029	99968
30159	51626	3	applied	\N	\N	\N	\N	154030	154030	100180
30159	51627	4	applied	\N	\N	\N	\N	154031	154031	100182
30159	51628	5	applied	\N	\N	\N	\N	154032	154032	100183
30163	51650	0	applied	\N	\N	\N	\N	154065	154065	154066
30163	51651	1	applied	\N	\N	\N	\N	154067	154067	154068
30163	51652	2	applied	\N	\N	\N	\N	154069	154069	154070
30163	51653	3	applied	\N	\N	\N	\N	154071	154071	154072
30163	51654	4	applied	\N	\N	\N	\N	154073	154073	100209
30163	51655	5	applied	\N	\N	\N	\N	154074	154074	100231
30163	51656	6	applied	\N	\N	\N	\N	154075	154075	100218
30163	51657	7	applied	\N	\N	\N	\N	154076	154076	154077
30163	51658	8	applied	\N	\N	\N	\N	154078	154078	100232
30163	51659	9	applied	\N	\N	\N	\N	154079	154079	100224
30163	51660	10	applied	\N	\N	\N	\N	154080	154080	154081
30163	51661	11	applied	\N	\N	\N	\N	154082	154082	100451
30163	51662	12	applied	\N	\N	\N	\N	154083	154083	100238
30163	51663	13	applied	\N	\N	\N	\N	154084	154084	100242
30163	51664	14	applied	\N	\N	\N	\N	154085	154085	100453
30163	51665	15	applied	\N	\N	\N	\N	154086	154086	154087
30163	51666	16	applied	\N	\N	\N	\N	154088	154088	154089
30163	51667	17	applied	\N	\N	\N	\N	154090	154090	100257
30163	51668	18	applied	\N	\N	\N	\N	154091	154091	100259
30163	51669	19	applied	\N	\N	\N	\N	154092	154092	100456
30163	51670	20	applied	\N	\N	\N	\N	154093	154093	100507
30163	51671	21	applied	\N	\N	\N	\N	154094	154094	154095
30163	51672	22	applied	\N	\N	\N	\N	154096	154096	100275
30163	51673	23	applied	\N	\N	\N	\N	154097	154097	154098
30163	51674	24	applied	\N	\N	\N	\N	154099	154099	100295
30163	51675	25	applied	\N	\N	\N	\N	154100	154100	100510
30163	51676	26	applied	\N	\N	\N	\N	154101	154101	100462
30163	51677	27	applied	\N	\N	\N	\N	154102	154102	100513
30163	51678	28	applied	\N	\N	\N	\N	154103	154103	100320
30163	51679	29	applied	\N	\N	\N	\N	154104	154104	100465
30163	51680	31	applied	\N	\N	\N	\N	154106	154106	100515
30163	51681	32	applied	\N	\N	\N	\N	154107	154107	100374
30163	51682	33	applied	\N	\N	\N	\N	154108	154108	100378
30163	51683	34	applied	\N	\N	\N	\N	154109	154109	100517
30163	51684	35	applied	\N	\N	\N	\N	154110	154110	100397
30163	51685	36	applied	\N	\N	\N	\N	154111	154111	100404
30163	51686	37	applied	\N	\N	\N	\N	154112	154112	100518
30163	51687	38	applied	\N	\N	\N	\N	154113	154113	100422
30163	51688	39	applied	\N	\N	\N	\N	154114	154114	100426
30167	51689	0	applied	\N	\N	\N	\N	154131	154131	154132
30167	51690	1	applied	\N	\N	\N	\N	154133	154133	100428
30167	51691	2	applied	\N	\N	\N	\N	154134	154134	100478
30167	51692	3	applied	\N	\N	\N	\N	154135	154135	100430
30167	51693	4	applied	\N	\N	\N	\N	154136	154136	100480
30167	51694	5	applied	\N	\N	\N	\N	154137	154137	100449
30167	51695	6	applied	\N	\N	\N	\N	154138	154138	100491
30167	51696	7	applied	\N	\N	\N	\N	154139	154139	154140
30167	51697	8	applied	\N	\N	\N	\N	154141	154141	100526
30171	51698	0	applied	\N	\N	\N	\N	154155	154155	154156
30171	51699	1	applied	\N	\N	\N	\N	154157	154157	100527
30171	51700	2	applied	\N	\N	\N	\N	154158	154158	100530
30171	51701	3	applied	\N	\N	\N	\N	154159	154159	154160
30171	51702	4	applied	\N	\N	\N	\N	154161	154161	100537
30171	51703	5	applied	\N	\N	\N	\N	154162	154162	100549
30171	51704	6	applied	\N	\N	\N	\N	154163	154163	154164
30171	51705	7	applied	\N	\N	\N	\N	154165	154165	101146
30176	50265	0	applied	\N	\N	\N	\N	154203	154203	151392
30176	51186	1	applied	\N	\N	\N	\N	153175	153175	153176
30176	51187	2	applied	\N	\N	\N	\N	153177	153177	153178
30176	51365	3	applied	\N	\N	1000000000	\N	153552	153552	153553
30176	51398	4	applied	\N	\N	\N	\N	153641	153641	111296
30176	51149	5	applied	\N	\N	\N	\N	153110	153110	153110
30176	48616	6	applied	\N	\N	\N	\N	148197	148197	148198
30176	50997	7	applied	\N	\N	\N	\N	152837	152837	152838
30176	49319	8	applied	\N	\N	\N	\N	149504	149504	149505
30178	51725	0	applied	\N	\N	\N	\N	154209	154209	154210
30178	51726	1	applied	\N	\N	\N	\N	154211	154211	154212
30178	51727	2	applied	\N	\N	\N	\N	154213	154213	154214
30178	51728	3	applied	\N	\N	\N	\N	154215	154215	101158
30178	51729	4	applied	\N	\N	\N	\N	154216	154216	100646
30178	51730	5	applied	\N	\N	\N	\N	154217	154217	101159
30178	51731	6	applied	\N	\N	\N	\N	154218	154218	154219
30178	51732	7	applied	\N	\N	\N	\N	154220	154220	154221
30178	51733	8	applied	\N	\N	\N	\N	154222	154222	100657
30178	51734	9	applied	\N	\N	\N	\N	154223	154223	101160
30183	51752	0	applied	\N	\N	\N	\N	154256	154256	154257
30183	51753	1	applied	\N	\N	\N	\N	154258	154258	101656
30183	51754	2	applied	\N	\N	\N	\N	154259	154259	101657
30183	51755	3	applied	\N	\N	\N	\N	154260	154260	101658
30183	51756	4	applied	\N	\N	\N	\N	154261	154261	154262
30183	51757	5	applied	\N	\N	\N	\N	154263	154263	100754
30183	51758	6	applied	\N	\N	\N	\N	154264	154264	154265
30183	51759	7	applied	\N	\N	\N	\N	154266	154266	154267
30183	51760	8	applied	\N	\N	\N	\N	154268	154268	100774
30185	48846	0	applied	\N	\N	1000000000	\N	148653	148653	148654
30185	48733	1	applied	\N	\N	\N	\N	148457	148457	148457
30185	48707	2	applied	\N	\N	\N	\N	148407	148407	148408
30185	50265	3	applied	\N	\N	\N	\N	154203	154203	151392
30185	48961	4	applied	\N	\N	\N	\N	148846	148846	148847
30185	50158	5	applied	\N	\N	\N	\N	151195	151195	151196
30185	48734	6	applied	\N	\N	\N	\N	148458	148458	148459
30185	48753	7	applied	\N	\N	\N	\N	148488	148488	111296
30185	48598	8	applied	\N	\N	\N	\N	148160	148160	148161
30185	51186	9	applied	\N	\N	\N	\N	153175	153175	153176
30185	49148	10	applied	\N	\N	\N	\N	149204	149204	149205
30185	51187	11	applied	\N	\N	\N	\N	153177	153177	153178
30185	49157	12	applied	\N	\N	\N	\N	149227	149227	149228
30185	49607	13	applied	\N	\N	\N	\N	150128	150128	150129
30185	51365	14	applied	\N	\N	1000000000	\N	153552	153552	153553
30185	48754	15	applied	\N	\N	1000000000	\N	148489	148489	148490
30185	48627	16	applied	\N	\N	\N	\N	148222	148222	111296
30185	48963	17	applied	\N	\N	\N	\N	154276	154276	154277
30185	51398	18	applied	\N	\N	\N	\N	153641	153641	111296
30185	48935	19	applied	\N	\N	\N	\N	148808	148808	148808
30185	51149	20	applied	\N	\N	\N	\N	153110	153110	153110
30185	49093	21	applied	\N	\N	\N	\N	149098	149098	149099
30185	49094	22	applied	\N	\N	\N	\N	149101	149101	149102
30185	48616	23	applied	\N	\N	\N	\N	148197	148197	148198
30185	50997	24	applied	\N	\N	\N	\N	152837	152837	152838
30185	49319	25	applied	\N	\N	\N	\N	149504	149504	149505
30185	49066	26	applied	\N	\N	\N	\N	149055	149055	149055
30157	51616	3	applied	\N	\N	\N	\N	154012	154012	154013
30157	51618	4	applied	\N	\N	\N	\N	154016	154016	99935
30157	51619	5	applied	\N	\N	\N	\N	154018	154018	99937
30157	51620	6	applied	\N	\N	\N	\N	154019	154019	100176
30157	51621	7	applied	\N	\N	\N	\N	154020	154020	99951
30161	51631	0	applied	\N	\N	\N	\N	154040	154040	154041
30161	51632	1	applied	\N	\N	\N	\N	154042	154042	100186
30161	51633	2	applied	\N	\N	\N	\N	154043	154043	100188
30161	51634	3	applied	\N	\N	\N	\N	154044	154044	100084
30161	51635	4	applied	\N	\N	\N	\N	154045	154045	100357
30161	51636	5	applied	\N	\N	\N	\N	154046	154046	100110
30161	51637	6	applied	\N	\N	\N	\N	154047	154047	100112
30161	51638	7	applied	\N	\N	\N	\N	154048	154048	100114
30165	51650	0	applied	\N	\N	\N	\N	154065	154065	154066
30165	51651	1	applied	\N	\N	\N	\N	154067	154067	154068
30165	51652	2	applied	\N	\N	\N	\N	154069	154069	154070
30165	51653	3	applied	\N	\N	\N	\N	154071	154071	154072
30165	51654	4	applied	\N	\N	\N	\N	154073	154073	100209
30165	51655	5	applied	\N	\N	\N	\N	154074	154074	100231
30165	51656	6	applied	\N	\N	\N	\N	154075	154075	100218
30165	51657	7	applied	\N	\N	\N	\N	154076	154076	154077
30165	51658	8	applied	\N	\N	\N	\N	154078	154078	100232
30165	51659	9	applied	\N	\N	\N	\N	154079	154079	100224
30165	51660	10	applied	\N	\N	\N	\N	154080	154080	154081
30165	51661	11	applied	\N	\N	\N	\N	154082	154082	100451
30165	51662	12	applied	\N	\N	\N	\N	154083	154083	100238
30165	51663	13	applied	\N	\N	\N	\N	154084	154084	100242
30165	51664	14	applied	\N	\N	\N	\N	154085	154085	100453
30165	51665	15	applied	\N	\N	\N	\N	154086	154086	154087
30165	51666	16	applied	\N	\N	\N	\N	154088	154088	154089
30165	51667	17	applied	\N	\N	\N	\N	154090	154090	100257
30165	51668	18	applied	\N	\N	\N	\N	154091	154091	100259
30165	51669	19	applied	\N	\N	\N	\N	154092	154092	100456
30165	51670	20	applied	\N	\N	\N	\N	154093	154093	100507
30165	51671	21	applied	\N	\N	\N	\N	154094	154094	154095
30165	51672	22	applied	\N	\N	\N	\N	154096	154096	100275
30165	51673	23	applied	\N	\N	\N	\N	154097	154097	154098
30165	51674	24	applied	\N	\N	\N	\N	154099	154099	100295
30165	51675	25	applied	\N	\N	\N	\N	154100	154100	100510
30165	51676	26	applied	\N	\N	\N	\N	154101	154101	100462
30165	51677	27	applied	\N	\N	\N	\N	154102	154102	100513
30165	51678	28	applied	\N	\N	\N	\N	154103	154103	100320
30165	51679	29	applied	\N	\N	\N	\N	154104	154104	100465
30165	51680	31	applied	\N	\N	\N	\N	154106	154106	100515
30165	51681	32	applied	\N	\N	\N	\N	154107	154107	100374
30165	51682	33	applied	\N	\N	\N	\N	154108	154108	100378
30165	51683	34	applied	\N	\N	\N	\N	154109	154109	100517
30165	51684	35	applied	\N	\N	\N	\N	154110	154110	100397
30165	51685	36	applied	\N	\N	\N	\N	154111	154111	100404
30165	51686	37	applied	\N	\N	\N	\N	154112	154112	100518
30165	51687	38	applied	\N	\N	\N	\N	154113	154113	100422
30165	51688	39	applied	\N	\N	\N	\N	154114	154114	100426
30180	51744	0	applied	\N	\N	\N	\N	154241	154241	154242
30180	51745	1	applied	\N	\N	\N	\N	154243	154243	100710
30180	51746	2	applied	\N	\N	\N	\N	154244	154244	154245
30180	51747	3	applied	\N	\N	\N	\N	154246	154246	100712
30180	51748	4	applied	\N	\N	\N	\N	154247	154247	100716
30180	51749	5	applied	\N	\N	\N	\N	154248	154248	100734
30180	51750	6	applied	\N	\N	\N	\N	154249	154249	154250
30180	51751	7	applied	\N	\N	\N	\N	154251	154251	100746
30182	51744	0	applied	\N	\N	\N	\N	154241	154241	154242
30182	51745	1	applied	\N	\N	\N	\N	154243	154243	100710
30182	51746	2	applied	\N	\N	\N	\N	154244	154244	154245
30182	51747	3	applied	\N	\N	\N	\N	154246	154246	100712
30187	51768	0	applied	\N	\N	\N	\N	154294	154294	154295
30187	51769	1	applied	\N	\N	\N	\N	154296	154296	154297
30187	51770	2	applied	\N	\N	\N	\N	154298	154298	101670
30187	51771	3	applied	\N	\N	\N	\N	154299	154299	100816
30187	51772	4	applied	\N	\N	\N	\N	154300	154300	101671
30187	51773	5	applied	\N	\N	\N	\N	154301	154301	101672
30187	51774	6	applied	\N	\N	\N	\N	154302	154302	101673
30187	51775	7	applied	\N	\N	\N	\N	154303	154303	100826
30200	51831	0	applied	\N	\N	\N	\N	154426	154426	154427
30200	51827	1	applied	\N	\N	\N	\N	154416	154416	154428
30200	51832	2	applied	\N	\N	\N	\N	154429	154429	101057
30200	51833	3	applied	\N	\N	\N	\N	154430	154430	101059
30200	51834	4	applied	\N	\N	\N	\N	154431	154431	101065
30200	51835	5	applied	\N	\N	\N	\N	154432	154432	154433
30200	51836	6	applied	\N	\N	\N	\N	154434	154434	101067
30200	51828	7	applied	\N	\N	\N	\N	154417	154417	154423
30200	51829	8	applied	\N	\N	\N	\N	154418	154418	101081
30200	51830	9	applied	\N	\N	\N	\N	154420	154420	101085
30200	51837	10	applied	\N	\N	\N	\N	154435	154435	154436
30200	51838	11	applied	\N	\N	\N	\N	154437	154437	101100
30200	51839	12	applied	\N	\N	\N	\N	154438	154438	154439
30200	51840	13	applied	\N	\N	\N	\N	154440	154440	154441
30200	51841	14	applied	\N	\N	\N	\N	154442	154442	154443
30200	51842	15	applied	\N	\N	\N	\N	154444	154444	154445
30200	51843	16	applied	\N	\N	\N	\N	154446	154446	154447
30200	51844	17	applied	\N	\N	\N	\N	154448	154448	154449
30200	51845	18	applied	\N	\N	\N	\N	154450	154450	101140
30200	51846	19	applied	\N	\N	\N	\N	154451	154451	154452
30202	51847	0	applied	\N	\N	\N	\N	154457	154457	154458
30202	51848	1	applied	\N	\N	\N	\N	154459	154459	154460
30202	51849	2	applied	\N	\N	\N	\N	154461	154461	154462
30202	51850	3	applied	\N	\N	\N	\N	154463	154463	154464
30202	51851	4	applied	\N	\N	\N	\N	154465	154465	101183
30202	51852	5	applied	\N	\N	\N	\N	154466	154466	101193
30202	51853	6	applied	\N	\N	\N	\N	154467	154467	154468
30202	51854	7	applied	\N	\N	\N	\N	154469	154469	154470
30202	51855	8	applied	\N	\N	\N	\N	154471	154471	101197
30202	51856	9	applied	\N	\N	\N	\N	154472	154472	154473
30202	51857	10	applied	\N	\N	\N	\N	154474	154474	154475
30202	51858	11	applied	\N	\N	\N	\N	154476	154476	101215
30202	51859	12	applied	\N	\N	\N	\N	154477	154477	154478
30202	51860	13	applied	\N	\N	\N	\N	154479	154479	154480
30202	51861	14	applied	\N	\N	\N	\N	154481	154481	101237
30202	51862	15	applied	\N	\N	\N	\N	154482	154482	154483
30202	51863	16	applied	\N	\N	\N	\N	154484	154484	154485
30202	51864	17	applied	\N	\N	\N	\N	154486	154486	101253
30202	51865	18	applied	\N	\N	\N	\N	154487	154487	154488
30202	51866	19	applied	\N	\N	\N	\N	154489	154489	154490
30202	51867	20	applied	\N	\N	\N	\N	154491	154491	101262
30204	51868	0	applied	\N	\N	\N	\N	154494	154494	154495
30204	51869	1	applied	\N	\N	\N	\N	154496	154496	154497
30204	51870	2	applied	\N	\N	\N	\N	154498	154498	154499
30204	51871	3	applied	\N	\N	\N	\N	154500	154500	154501
30204	51872	4	applied	\N	\N	\N	\N	154502	154502	154503
30204	51873	5	applied	\N	\N	\N	\N	154504	154504	101285
30204	51874	6	applied	\N	\N	1000000000	\N	154505	154505	154506
30164	51674	24	applied	\N	\N	\N	\N	154099	154099	100295
30164	51675	25	applied	\N	\N	\N	\N	154100	154100	100510
30164	51676	26	applied	\N	\N	\N	\N	154101	154101	100462
30164	51677	27	applied	\N	\N	\N	\N	154102	154102	100513
30164	51678	28	applied	\N	\N	\N	\N	154103	154103	100320
30164	51679	29	applied	\N	\N	\N	\N	154104	154104	100465
30164	51680	31	applied	\N	\N	\N	\N	154106	154106	100515
30164	51681	32	applied	\N	\N	\N	\N	154107	154107	100374
30164	51682	33	applied	\N	\N	\N	\N	154108	154108	100378
30164	51683	34	applied	\N	\N	\N	\N	154109	154109	100517
30164	51684	35	applied	\N	\N	\N	\N	154110	154110	100397
30164	51685	36	applied	\N	\N	\N	\N	154111	154111	100404
30164	51686	37	applied	\N	\N	\N	\N	154112	154112	100518
30164	51687	38	applied	\N	\N	\N	\N	154113	154113	100422
30164	51688	39	applied	\N	\N	\N	\N	154114	154114	100426
30169	51689	0	applied	\N	\N	\N	\N	154131	154131	154132
30169	51690	1	applied	\N	\N	\N	\N	154133	154133	100428
30169	51691	2	applied	\N	\N	\N	\N	154134	154134	100478
30169	51692	3	applied	\N	\N	\N	\N	154135	154135	100430
30169	51693	4	applied	\N	\N	\N	\N	154136	154136	100480
30169	51694	5	applied	\N	\N	\N	\N	154137	154137	100449
30169	51695	6	applied	\N	\N	\N	\N	154138	154138	100491
30169	51696	7	applied	\N	\N	\N	\N	154139	154139	154140
30169	51697	8	applied	\N	\N	\N	\N	154141	154141	100526
30173	51706	0	applied	\N	\N	\N	\N	154169	154169	154170
30173	51707	1	applied	\N	\N	\N	\N	154171	154171	154172
30173	51708	2	applied	\N	\N	\N	\N	154173	154173	101148
30173	51709	3	applied	\N	\N	\N	\N	154174	154174	100581
30173	51710	4	applied	\N	\N	\N	\N	154175	154175	100585
30173	51711	5	applied	\N	\N	\N	\N	154176	154176	154177
30173	51712	6	applied	\N	\N	\N	\N	154178	154178	100596
30173	51713	7	applied	\N	\N	\N	\N	154179	154179	101151
30173	51714	8	applied	\N	\N	\N	\N	154180	154180	154181
30175	51715	0	applied	\N	\N	\N	\N	154186	154186	154187
30175	51716	1	applied	\N	\N	\N	\N	154188	154188	101152
30175	51717	2	applied	\N	\N	\N	\N	154189	154189	154190
30175	51718	3	applied	\N	\N	\N	\N	154191	154191	100614
30175	51719	4	applied	\N	\N	1000000000	\N	154192	154192	154193
30175	51720	5	applied	\N	\N	\N	\N	154194	154194	154195
30175	51721	6	applied	\N	\N	\N	\N	154196	154196	100620
30175	51722	7	applied	\N	\N	\N	\N	154197	154197	101156
30175	51723	8	applied	\N	\N	\N	\N	154198	154198	100632
30175	51724	9	applied	\N	\N	\N	\N	154199	154199	154200
30177	51725	0	applied	\N	\N	\N	\N	154209	154209	154210
30177	51726	1	applied	\N	\N	\N	\N	154211	154211	154212
30177	51727	2	applied	\N	\N	\N	\N	154213	154213	154214
30177	51728	3	applied	\N	\N	\N	\N	154215	154215	101158
30177	51729	4	applied	\N	\N	\N	\N	154216	154216	100646
30177	51730	5	applied	\N	\N	\N	\N	154217	154217	101159
30177	51731	6	applied	\N	\N	\N	\N	154218	154218	154219
30177	51732	7	applied	\N	\N	\N	\N	154220	154220	154221
30177	51733	8	applied	\N	\N	\N	\N	154222	154222	100657
30177	51734	9	applied	\N	\N	\N	\N	154223	154223	101160
30177	51735	10	applied	\N	\N	\N	\N	154224	154224	154225
30177	51736	11	applied	\N	\N	\N	\N	154226	154226	154227
30177	51737	12	applied	\N	\N	\N	\N	154228	154228	101163
30177	51738	13	applied	\N	\N	\N	\N	154229	154229	100682
30177	51739	14	applied	\N	\N	\N	\N	154230	154230	154231
30177	51740	15	applied	\N	\N	\N	\N	154232	154232	101167
30177	51741	16	applied	\N	\N	\N	\N	154233	154233	154234
30177	51742	17	applied	\N	\N	\N	\N	154235	154235	100701
30177	51743	18	applied	\N	\N	\N	\N	154236	154236	101170
30179	51725	0	applied	\N	\N	\N	\N	154209	154209	154210
30179	51726	1	applied	\N	\N	\N	\N	154211	154211	154212
30179	51727	2	applied	\N	\N	\N	\N	154213	154213	154214
30179	51728	3	applied	\N	\N	\N	\N	154215	154215	101158
30179	51729	4	applied	\N	\N	\N	\N	154216	154216	100646
30179	51730	5	applied	\N	\N	\N	\N	154217	154217	101159
30179	51731	6	applied	\N	\N	\N	\N	154218	154218	154219
30179	51732	7	applied	\N	\N	\N	\N	154220	154220	154221
30179	51733	8	applied	\N	\N	\N	\N	154222	154222	100657
30179	51734	9	applied	\N	\N	\N	\N	154223	154223	101160
30179	51735	10	applied	\N	\N	\N	\N	154224	154224	154225
30179	51736	11	applied	\N	\N	\N	\N	154226	154226	154227
30179	51737	12	applied	\N	\N	\N	\N	154228	154228	101163
30179	51738	13	applied	\N	\N	\N	\N	154229	154229	100682
30179	51739	14	applied	\N	\N	\N	\N	154230	154230	154231
30179	51740	15	applied	\N	\N	\N	\N	154232	154232	101167
30179	51741	16	applied	\N	\N	\N	\N	154233	154233	154234
30179	51742	17	applied	\N	\N	\N	\N	154235	154235	100701
30179	51743	18	applied	\N	\N	\N	\N	154236	154236	101170
30181	51744	0	applied	\N	\N	\N	\N	154241	154241	154242
30181	51745	1	applied	\N	\N	\N	\N	154243	154243	100710
30181	51746	2	applied	\N	\N	\N	\N	154244	154244	154245
30181	51747	3	applied	\N	\N	\N	\N	154246	154246	100712
30181	51748	4	applied	\N	\N	\N	\N	154247	154247	100716
30181	51749	5	applied	\N	\N	\N	\N	154248	154248	100734
30181	51750	6	applied	\N	\N	\N	\N	154249	154249	154250
30181	51751	7	applied	\N	\N	\N	\N	154251	154251	100746
30188	51768	0	applied	\N	\N	\N	\N	154294	154294	154295
30188	51769	1	applied	\N	\N	\N	\N	154296	154296	154297
30188	51776	2	applied	\N	\N	\N	\N	154306	154306	100814
30188	51770	3	applied	\N	\N	\N	\N	154298	154298	154307
30188	51777	4	applied	\N	\N	\N	\N	154308	154308	100822
30188	51778	5	applied	\N	\N	\N	\N	154309	154309	154310
30188	51771	6	applied	\N	\N	\N	\N	154299	154299	154311
30188	51772	7	applied	\N	\N	\N	\N	154300	154300	154312
30188	51773	8	applied	\N	\N	\N	\N	154301	154301	154313
30188	51774	9	applied	\N	\N	\N	\N	154302	154302	154314
30188	51775	10	applied	\N	\N	\N	\N	154303	154303	100846
30188	51779	11	applied	\N	\N	\N	\N	154315	154315	101675
30188	51780	12	applied	\N	\N	\N	\N	154316	154316	154317
30188	51781	13	applied	\N	\N	\N	\N	154318	154318	100850
30188	51782	14	applied	\N	\N	\N	\N	154319	154319	100860
30188	51783	16	applied	\N	\N	\N	\N	154321	154321	154322
30188	51784	17	applied	\N	\N	\N	\N	154323	154323	100869
30188	51785	18	applied	\N	\N	\N	\N	154324	154324	154325
30188	51786	19	applied	\N	\N	\N	\N	154326	154326	154327
30188	51787	20	applied	\N	\N	\N	\N	154328	154328	100885
30191	51788	0	applied	\N	\N	\N	\N	154343	154343	154344
30191	51789	1	applied	\N	\N	\N	\N	154345	154345	154346
30191	51790	2	applied	\N	\N	\N	\N	154347	154347	154348
30191	51791	3	applied	\N	\N	\N	\N	154349	154349	154350
30191	51792	4	applied	\N	\N	\N	\N	154351	154351	100899
30191	51793	5	applied	\N	\N	\N	\N	154352	154352	101686
30191	51794	6	applied	\N	\N	\N	\N	154353	154353	100909
30191	51795	7	applied	\N	\N	\N	\N	154354	154354	154355
30191	51796	8	applied	\N	\N	\N	\N	154356	154356	100918
30191	51797	9	applied	\N	\N	\N	\N	154357	154357	154358
30194	51798	0	applied	\N	\N	\N	\N	154368	154368	154369
30185	48540	27	applied	\N	\N	\N	\N	147996	147996	147997
30185	48677	28	applied	\N	\N	\N	\N	148333	148333	148333
30185	49097	29	applied	\N	\N	\N	\N	149105	149105	149106
30185	49098	30	applied	\N	\N	\N	\N	149107	149107	149108
30185	48584	31	applied	\N	\N	1000000000	\N	148101	148101	148102
30185	48967	32	applied	\N	\N	\N	\N	148857	148857	148858
30185	51719	33	applied	\N	\N	1000000000	\N	154278	154278	154193
30185	48905	34	applied	\N	\N	\N	\N	148756	148756	148757
30185	49320	35	applied	\N	\N	\N	\N	149507	149507	149508
30185	49321	36	applied	\N	\N	\N	\N	149509	149509	149510
30185	49322	37	applied	\N	\N	\N	\N	149511	149511	149512
30185	49323	38	applied	\N	\N	\N	\N	149513	149513	149514
30185	49324	39	applied	\N	\N	\N	\N	149515	149515	149516
30185	49325	40	applied	\N	\N	\N	\N	149517	149517	149518
30185	49326	41	applied	\N	\N	\N	\N	149519	149519	149520
30185	49327	42	applied	\N	\N	\N	\N	149521	149521	149522
30185	49328	43	applied	\N	\N	\N	\N	149523	149523	149524
30185	49342	44	applied	\N	\N	\N	\N	149562	149562	149563
30185	49343	45	applied	\N	\N	\N	\N	149564	149564	149565
30185	49344	46	applied	\N	\N	\N	\N	149566	149566	149567
30185	49345	47	applied	\N	\N	\N	\N	149568	149568	149569
30185	49346	48	applied	\N	\N	\N	\N	149570	149570	149571
30185	49347	49	applied	\N	\N	\N	\N	149572	149572	149573
30185	50273	50	applied	\N	\N	\N	\N	151402	151402	151402
30185	50277	51	applied	\N	\N	\N	\N	151417	151417	151417
30185	51394	52	applied	\N	\N	\N	\N	153628	153628	153628
30185	51520	53	applied	\N	\N	1000000000	\N	153847	153847	153848
30185	50299	54	applied	\N	\N	\N	\N	151466	151466	151466
30185	48795	55	applied	\N	\N	\N	\N	148561	148561	154279
30185	49103	56	applied	\N	\N	\N	\N	149113	149113	149114
30185	49104	57	applied	\N	\N	\N	\N	149115	149115	149116
30185	49105	58	applied	\N	\N	\N	\N	149117	149117	149118
30185	49106	59	applied	\N	\N	\N	\N	149119	149119	149120
30185	49107	60	applied	\N	\N	\N	\N	149121	149121	149122
30185	49108	61	applied	\N	\N	\N	\N	149123	149123	149124
30185	49109	62	applied	\N	\N	\N	\N	149125	149125	149126
30185	49113	64	applied	\N	\N	\N	\N	149135	149135	149136
30185	49118	65	applied	\N	\N	\N	\N	149141	149141	149142
30185	49119	66	applied	\N	\N	\N	\N	149143	149143	149144
30185	51598	67	applied	\N	\N	\N	\N	153983	153983	153984
30185	51613	68	applied	\N	\N	\N	\N	154007	154007	154008
30185	49123	69	applied	\N	\N	\N	\N	149149	149149	149150
30185	49124	70	applied	\N	\N	\N	\N	149151	149151	149152
30185	49363	71	applied	\N	\N	\N	\N	149603	149603	149604
30185	49364	72	applied	\N	\N	\N	\N	149605	149605	149606
30185	49365	73	applied	\N	\N	\N	\N	149607	149607	149608
30185	49366	74	applied	\N	\N	\N	\N	149609	149609	149610
30189	51768	0	applied	\N	\N	\N	\N	154294	154294	154295
30189	51769	1	applied	\N	\N	\N	\N	154296	154296	154297
30189	51776	2	applied	\N	\N	\N	\N	154306	154306	100814
30189	51770	3	applied	\N	\N	\N	\N	154298	154298	154307
30189	51771	4	applied	\N	\N	\N	\N	154299	154299	154340
30189	51772	5	applied	\N	\N	\N	\N	154300	154300	100822
30189	51773	6	applied	\N	\N	\N	\N	154301	154301	100824
30189	51774	7	applied	\N	\N	\N	\N	154302	154302	154310
30189	51775	8	applied	\N	\N	\N	\N	154303	154303	154311
30189	51779	9	applied	\N	\N	\N	\N	154315	154315	100828
30189	51780	10	applied	\N	\N	\N	\N	154316	154316	154312
30190	51768	0	applied	\N	\N	\N	\N	154294	154294	154295
30190	51769	1	applied	\N	\N	\N	\N	154296	154296	154297
30190	51776	2	applied	\N	\N	\N	\N	154306	154306	100814
30190	51770	3	applied	\N	\N	\N	\N	154298	154298	154307
30190	51777	4	applied	\N	\N	\N	\N	154308	154308	100822
30190	51778	5	applied	\N	\N	\N	\N	154309	154309	154310
30190	51771	6	applied	\N	\N	\N	\N	154299	154299	154311
30190	51772	7	applied	\N	\N	\N	\N	154300	154300	154312
30190	51773	8	applied	\N	\N	\N	\N	154301	154301	154313
30190	51774	9	applied	\N	\N	\N	\N	154302	154302	154314
30190	51775	10	applied	\N	\N	\N	\N	154303	154303	100846
30190	51779	11	applied	\N	\N	\N	\N	154315	154315	101675
30190	51780	12	applied	\N	\N	\N	\N	154316	154316	154317
30190	51781	13	applied	\N	\N	\N	\N	154318	154318	100850
30190	51782	14	applied	\N	\N	\N	\N	154319	154319	100860
30190	51783	16	applied	\N	\N	\N	\N	154321	154321	154322
30190	51784	17	applied	\N	\N	\N	\N	154323	154323	100869
30190	51785	18	applied	\N	\N	\N	\N	154324	154324	154325
30190	51786	19	applied	\N	\N	\N	\N	154326	154326	154327
30190	51787	20	applied	\N	\N	\N	\N	154328	154328	100885
30192	51788	0	applied	\N	\N	\N	\N	154343	154343	154344
30192	51789	1	applied	\N	\N	\N	\N	154345	154345	154346
30192	51790	2	applied	\N	\N	\N	\N	154347	154347	154348
30192	51791	3	applied	\N	\N	\N	\N	154349	154349	154350
30192	51792	4	applied	\N	\N	\N	\N	154351	154351	100899
30192	51793	5	applied	\N	\N	\N	\N	154352	154352	101686
30192	51794	6	applied	\N	\N	\N	\N	154353	154353	100909
30192	51795	7	applied	\N	\N	\N	\N	154354	154354	154355
30192	51796	8	applied	\N	\N	\N	\N	154356	154356	100918
30192	51797	9	applied	\N	\N	\N	\N	154357	154357	154358
30197	51822	0	applied	\N	\N	\N	\N	154406	154406	154407
30197	51823	1	applied	\N	\N	\N	\N	154408	154408	101039
30197	51827	2	applied	\N	\N	\N	\N	154416	154416	154412
30197	51828	3	applied	\N	\N	\N	\N	154417	154417	101049
30197	51829	4	applied	\N	\N	\N	\N	154418	154418	154419
30197	51830	5	applied	\N	\N	\N	\N	154420	154420	154421
30197	51824	6	applied	\N	\N	\N	\N	154409	154409	101067
30197	51825	7	applied	\N	\N	\N	\N	154411	154411	154422
30197	51826	8	applied	\N	\N	\N	\N	154413	154413	154423
30211	51869	0	applied	\N	\N	\N	\N	154496	154496	154497
30211	51880	1	applied	\N	\N	\N	\N	154548	154548	154549
30211	51881	2	applied	\N	\N	\N	\N	154550	154550	154551
30211	51870	3	applied	\N	\N	\N	\N	154498	154498	154499
30211	51871	4	applied	\N	\N	\N	\N	154500	154500	154501
30211	51872	5	applied	\N	\N	\N	\N	154502	154502	154503
30211	51873	6	applied	\N	\N	\N	\N	154504	154504	101285
30211	51882	7	applied	\N	\N	\N	\N	154552	154552	154553
30211	51875	8	applied	\N	\N	\N	\N	154507	154507	154554
30211	51876	9	applied	\N	\N	\N	\N	154509	154509	101291
30211	51877	10	applied	\N	\N	\N	\N	154511	154511	154555
30211	51883	11	applied	\N	\N	\N	\N	154556	154556	154557
30211	51878	12	applied	\N	\N	\N	\N	154512	154512	154558
30211	51879	13	applied	\N	\N	\N	\N	154514	154514	154559
30211	51884	14	applied	\N	\N	1000000000	\N	154560	154560	154561
30211	51885	15	applied	\N	\N	1000000000	\N	154562	154562	154563
30211	51886	16	applied	\N	\N	1000000000	\N	154564	154564	154565
30211	51887	17	applied	\N	\N	\N	\N	154566	154566	154567
30211	51888	18	applied	\N	\N	\N	\N	154568	154568	154569
30211	51889	20	applied	\N	\N	\N	\N	154571	154571	101309
30211	51890	21	applied	\N	\N	\N	\N	154572	154572	154573
30211	51891	22	applied	\N	\N	\N	\N	154574	154574	101317
30193	51803	5	applied	\N	\N	\N	\N	154375	154375	154376
30193	51804	6	applied	\N	\N	\N	\N	154377	154377	100999
30193	51805	7	applied	\N	\N	\N	\N	154378	154378	101690
30193	51806	8	applied	\N	\N	\N	\N	154379	154379	100938
30193	51807	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30193	51808	10	applied	\N	\N	\N	\N	154381	154381	101000
30193	51809	11	applied	\N	\N	\N	\N	154382	154382	100991
30193	51810	12	applied	\N	\N	\N	\N	154383	154383	100993
30193	51811	13	applied	\N	\N	\N	\N	154384	154384	154385
30193	51812	14	applied	\N	\N	\N	\N	154386	154386	101007
30193	51813	15	applied	\N	\N	\N	\N	154387	154387	154388
30193	51814	16	applied	\N	\N	\N	\N	154389	154389	101017
30193	51815	17	applied	\N	\N	\N	\N	154390	154390	154391
30193	51816	18	applied	\N	\N	\N	\N	154392	154392	101027
30193	51817	19	applied	\N	\N	\N	\N	154393	154393	101035
30193	51818	20	applied	\N	\N	\N	\N	154394	154394	154395
30193	51819	21	applied	\N	\N	\N	\N	154396	154396	154397
30193	51820	22	applied	\N	\N	\N	\N	154398	154398	154399
30193	51821	23	applied	\N	\N	\N	\N	154400	154400	154401
30195	51798	0	applied	\N	\N	\N	\N	154368	154368	154369
30195	51799	1	applied	\N	\N	\N	\N	154370	154370	154371
30195	51800	2	applied	\N	\N	\N	\N	154372	154372	29193
30195	51801	3	applied	\N	\N	\N	\N	154373	154373	100924
30195	51802	4	applied	\N	\N	\N	\N	154374	154374	100930
30195	51803	5	applied	\N	\N	\N	\N	154375	154375	154376
30195	51804	6	applied	\N	\N	\N	\N	154377	154377	100999
30195	51805	7	applied	\N	\N	\N	\N	154378	154378	101690
30195	51806	8	applied	\N	\N	\N	\N	154379	154379	100938
30195	51807	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30195	51808	10	applied	\N	\N	\N	\N	154381	154381	101000
30195	51809	11	applied	\N	\N	\N	\N	154382	154382	100991
30195	51810	12	applied	\N	\N	\N	\N	154383	154383	100993
30195	51811	13	applied	\N	\N	\N	\N	154384	154384	154385
30195	51812	14	applied	\N	\N	\N	\N	154386	154386	101007
30195	51813	15	applied	\N	\N	\N	\N	154387	154387	154388
30195	51814	16	applied	\N	\N	\N	\N	154389	154389	101017
30195	51815	17	applied	\N	\N	\N	\N	154390	154390	154391
30195	51816	18	applied	\N	\N	\N	\N	154392	154392	101027
30195	51817	19	applied	\N	\N	\N	\N	154393	154393	101035
30195	51818	20	applied	\N	\N	\N	\N	154394	154394	154395
30195	51819	21	applied	\N	\N	\N	\N	154396	154396	154397
30195	51820	22	applied	\N	\N	\N	\N	154398	154398	154399
30195	51821	23	applied	\N	\N	\N	\N	154400	154400	154401
30199	51831	0	applied	\N	\N	\N	\N	154426	154426	154427
30199	51827	1	applied	\N	\N	\N	\N	154416	154416	154428
30199	51832	2	applied	\N	\N	\N	\N	154429	154429	101057
30199	51833	3	applied	\N	\N	\N	\N	154430	154430	101059
30199	51834	4	applied	\N	\N	\N	\N	154431	154431	101065
30199	51835	5	applied	\N	\N	\N	\N	154432	154432	154433
30199	51836	6	applied	\N	\N	\N	\N	154434	154434	101067
30199	51828	7	applied	\N	\N	\N	\N	154417	154417	154423
30199	51829	8	applied	\N	\N	\N	\N	154418	154418	101081
30199	51830	9	applied	\N	\N	\N	\N	154420	154420	101085
30199	51837	10	applied	\N	\N	\N	\N	154435	154435	154436
30199	51838	11	applied	\N	\N	\N	\N	154437	154437	101100
30199	51839	12	applied	\N	\N	\N	\N	154438	154438	154439
30199	51840	13	applied	\N	\N	\N	\N	154440	154440	154441
30199	51841	14	applied	\N	\N	\N	\N	154442	154442	154443
30199	51842	15	applied	\N	\N	\N	\N	154444	154444	154445
30199	51843	16	applied	\N	\N	\N	\N	154446	154446	154447
30199	51844	17	applied	\N	\N	\N	\N	154448	154448	154449
30199	51845	18	applied	\N	\N	\N	\N	154450	154450	101140
30199	51846	19	applied	\N	\N	\N	\N	154451	154451	154452
30213	51869	0	applied	\N	\N	\N	\N	154496	154496	154497
30213	51880	1	applied	\N	\N	\N	\N	154548	154548	154549
30213	51881	2	applied	\N	\N	\N	\N	154550	154550	154551
30213	51870	3	applied	\N	\N	\N	\N	154498	154498	154499
30213	51871	4	applied	\N	\N	\N	\N	154500	154500	154501
30213	51872	5	applied	\N	\N	\N	\N	154502	154502	154503
30213	51873	6	applied	\N	\N	\N	\N	154504	154504	101285
30213	51882	7	applied	\N	\N	\N	\N	154552	154552	154553
30213	51875	8	applied	\N	\N	\N	\N	154507	154507	154554
30213	51876	9	applied	\N	\N	\N	\N	154509	154509	101291
30213	51877	10	applied	\N	\N	\N	\N	154511	154511	154555
30213	51883	11	applied	\N	\N	\N	\N	154556	154556	154557
30213	51878	12	applied	\N	\N	\N	\N	154512	154512	154558
30213	51879	13	applied	\N	\N	\N	\N	154514	154514	154559
30213	51884	14	applied	\N	\N	1000000000	\N	154560	154560	154561
30213	51885	15	applied	\N	\N	1000000000	\N	154562	154562	154563
30213	51886	16	applied	\N	\N	1000000000	\N	154564	154564	154565
30213	51887	17	applied	\N	\N	\N	\N	154566	154566	154567
30213	51888	18	applied	\N	\N	\N	\N	154568	154568	154569
30213	51889	20	applied	\N	\N	\N	\N	154571	154571	101309
30213	51890	21	applied	\N	\N	\N	\N	154572	154572	154573
30213	51891	22	applied	\N	\N	\N	\N	154574	154574	101317
30213	51892	23	applied	\N	\N	\N	\N	154575	154575	101319
30213	51893	24	applied	\N	\N	\N	\N	154576	154576	154577
30213	51894	25	applied	\N	\N	\N	\N	154578	154578	154579
30213	51895	26	applied	\N	\N	\N	\N	154580	154580	154581
30213	51896	27	applied	\N	\N	\N	\N	154582	154582	154583
30213	51897	28	applied	\N	\N	\N	\N	154584	154584	101338
30213	51898	29	applied	\N	\N	\N	\N	154585	154585	154586
30213	51899	30	applied	\N	\N	\N	\N	154587	154587	154588
30213	51900	31	applied	\N	\N	\N	\N	154589	154589	154590
30213	51901	32	applied	\N	\N	\N	\N	154591	154591	154592
30213	51902	33	applied	\N	\N	\N	\N	154593	154593	154594
30214	51869	0	applied	\N	\N	\N	\N	154496	154496	154497
30214	51880	1	applied	\N	\N	\N	\N	154548	154548	154549
30214	51881	2	applied	\N	\N	\N	\N	154550	154550	154551
30214	51870	3	applied	\N	\N	\N	\N	154498	154498	154499
30214	51871	4	applied	\N	\N	\N	\N	154500	154500	154501
30214	51872	5	applied	\N	\N	\N	\N	154502	154502	154503
30214	51873	6	applied	\N	\N	\N	\N	154504	154504	101285
30214	51882	7	applied	\N	\N	\N	\N	154552	154552	154553
30214	51875	8	applied	\N	\N	\N	\N	154507	154507	154554
30214	51876	9	applied	\N	\N	\N	\N	154509	154509	101291
30214	51877	10	applied	\N	\N	\N	\N	154511	154511	154555
30214	51883	11	applied	\N	\N	\N	\N	154556	154556	154557
30214	51878	12	applied	\N	\N	\N	\N	154512	154512	154558
30214	51879	13	applied	\N	\N	\N	\N	154514	154514	154559
30214	51884	14	applied	\N	\N	1000000000	\N	154560	154560	154561
30214	51885	15	applied	\N	\N	1000000000	\N	154562	154562	154563
30214	51886	16	applied	\N	\N	1000000000	\N	154564	154564	154565
30214	51887	17	applied	\N	\N	\N	\N	154566	154566	154567
30214	51888	18	applied	\N	\N	\N	\N	154568	154568	154569
30214	51889	20	applied	\N	\N	\N	\N	154571	154571	101309
30214	51890	21	applied	\N	\N	\N	\N	154572	154572	154573
30214	51891	22	applied	\N	\N	\N	\N	154574	154574	101317
30194	51799	1	applied	\N	\N	\N	\N	154370	154370	154371
30194	51800	2	applied	\N	\N	\N	\N	154372	154372	29193
30194	51802	3	applied	\N	\N	\N	\N	154374	154374	100998
30194	51805	4	applied	\N	\N	\N	\N	154378	154378	154376
30194	51806	5	applied	\N	\N	\N	\N	154379	154379	100932
30194	51807	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30194	51810	7	applied	\N	\N	\N	\N	154383	154383	100946
30194	51811	8	applied	\N	\N	\N	\N	154384	154384	154385
30194	51818	9	applied	\N	\N	\N	\N	154394	154394	154395
30194	51819	10	applied	\N	\N	\N	\N	154396	154396	154397
30194	51820	11	applied	\N	\N	\N	\N	154398	154398	154399
30196	51822	0	applied	\N	\N	\N	\N	154406	154406	154407
30196	51823	1	applied	\N	\N	\N	\N	154408	154408	101039
30196	51824	2	applied	\N	\N	\N	\N	154409	154409	154410
30196	51825	3	applied	\N	\N	\N	\N	154411	154411	154412
30196	51826	4	applied	\N	\N	\N	\N	154413	154413	154414
30198	51788	0	applied	\N	\N	\N	\N	154343	154343	154344
30198	51800	1	applied	\N	\N	\N	\N	154372	154372	29193
30198	51807	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30198	51811	3	applied	\N	\N	\N	\N	154384	154384	154385
30198	51818	4	applied	\N	\N	\N	\N	154394	154394	154395
30198	51819	5	applied	\N	\N	\N	\N	154396	154396	154397
30198	51820	6	applied	\N	\N	\N	\N	154398	154398	154399
30203	51847	0	applied	\N	\N	\N	\N	154457	154457	154458
30203	51848	1	applied	\N	\N	\N	\N	154459	154459	154460
30203	51849	2	applied	\N	\N	\N	\N	154461	154461	154462
30203	51850	3	applied	\N	\N	\N	\N	154463	154463	154464
30203	51851	4	applied	\N	\N	\N	\N	154465	154465	101183
30203	51852	5	applied	\N	\N	\N	\N	154466	154466	101193
30203	51853	6	applied	\N	\N	\N	\N	154467	154467	154468
30203	51854	7	applied	\N	\N	\N	\N	154469	154469	154470
30203	51855	8	applied	\N	\N	\N	\N	154471	154471	101197
30203	51856	9	applied	\N	\N	\N	\N	154472	154472	154473
30203	51857	10	applied	\N	\N	\N	\N	154474	154474	154475
30203	51858	11	applied	\N	\N	\N	\N	154476	154476	101215
30203	51859	12	applied	\N	\N	\N	\N	154477	154477	154478
30203	51860	13	applied	\N	\N	\N	\N	154479	154479	154480
30203	51861	14	applied	\N	\N	\N	\N	154481	154481	101237
30203	51862	15	applied	\N	\N	\N	\N	154482	154482	154483
30203	51863	16	applied	\N	\N	\N	\N	154484	154484	154485
30203	51864	17	applied	\N	\N	\N	\N	154486	154486	101253
30203	51865	18	applied	\N	\N	\N	\N	154487	154487	154488
30203	51866	19	applied	\N	\N	\N	\N	154489	154489	154490
30203	51867	20	applied	\N	\N	\N	\N	154491	154491	101262
30205	51868	0	applied	\N	\N	\N	\N	154494	154494	154495
30205	51869	1	applied	\N	\N	\N	\N	154496	154496	154497
30205	51870	2	applied	\N	\N	\N	\N	154498	154498	154499
30205	51871	3	applied	\N	\N	\N	\N	154500	154500	154501
30205	51872	4	applied	\N	\N	\N	\N	154502	154502	154503
30205	51873	5	applied	\N	\N	\N	\N	154504	154504	101285
30205	51874	6	applied	\N	\N	1000000000	\N	154505	154505	154506
30205	51875	7	applied	\N	\N	\N	\N	154507	154507	154508
30205	51876	8	applied	\N	\N	\N	\N	154509	154509	154510
30205	51877	9	applied	\N	\N	\N	\N	154511	154511	101293
30205	51878	10	applied	\N	\N	\N	\N	154512	154512	154513
30205	51879	11	applied	\N	\N	\N	\N	154514	154514	154515
30207	51788	0	applied	\N	\N	\N	\N	154343	154343	154344
30207	51536	1	applied	\N	\N	\N	\N	153884	153884	153885
30207	51546	2	applied	\N	\N	\N	\N	153903	153903	153904
30207	51554	3	applied	\N	\N	\N	\N	153922	153922	153923
30207	51564	4	applied	\N	\N	\N	\N	153939	153939	153940
30207	51565	5	applied	\N	\N	\N	\N	153941	153941	153942
30207	51566	6	applied	\N	\N	\N	\N	153943	153943	153944
30207	51567	7	applied	\N	\N	\N	\N	153945	153945	153946
30207	51568	8	applied	\N	\N	\N	\N	153947	153947	153948
30207	51614	9	applied	\N	\N	\N	\N	154009	154009	154010
30207	51623	10	applied	\N	\N	\N	\N	154026	154026	154027
30207	51631	11	applied	\N	\N	\N	\N	154040	154040	154041
30207	51639	12	applied	\N	\N	\N	\N	154049	154049	154050
30207	51650	13	applied	\N	\N	\N	\N	154065	154065	154066
30207	51651	14	applied	\N	\N	\N	\N	154067	154067	154068
30207	51652	15	applied	\N	\N	\N	\N	154069	154069	154070
30207	51653	16	applied	\N	\N	\N	\N	154071	154071	154072
30207	51689	17	applied	\N	\N	\N	\N	154131	154131	154132
30207	51698	18	applied	\N	\N	\N	\N	154155	154155	154156
30207	51706	19	applied	\N	\N	\N	\N	154169	154169	154170
30207	51715	20	applied	\N	\N	\N	\N	154186	154186	154187
30207	51725	21	applied	\N	\N	\N	\N	154209	154209	154210
30207	51726	22	applied	\N	\N	\N	\N	154211	154211	154212
30207	51744	23	applied	\N	\N	\N	\N	154241	154241	154242
30207	51752	24	applied	\N	\N	\N	\N	154256	154256	154257
30207	51761	25	applied	\N	\N	\N	\N	154283	154283	154284
30207	51768	26	applied	\N	\N	\N	\N	154294	154294	154295
30207	51769	27	applied	\N	\N	\N	\N	154296	154296	154297
30207	51789	28	applied	\N	\N	\N	\N	154345	154345	154346
30207	51831	29	applied	\N	\N	\N	\N	154426	154426	154427
30207	51848	30	applied	\N	\N	\N	\N	154459	154459	154460
30207	51849	31	applied	\N	\N	\N	\N	154461	154461	154462
30207	51869	32	applied	\N	\N	\N	\N	154496	154496	154497
30207	51800	33	applied	\N	\N	\N	\N	154372	154372	29193
30207	51537	34	applied	\N	\N	\N	\N	153886	153886	153887
30207	51538	36	applied	\N	\N	\N	\N	153888	153888	99513
30207	51719	37	applied	\N	\N	1000000000	\N	154192	154192	154193
30207	51798	38	applied	\N	\N	\N	\N	154368	154368	154369
30207	51799	39	applied	\N	\N	\N	\N	154370	154370	154371
30207	51847	40	applied	\N	\N	\N	\N	154457	154457	154458
30207	51868	41	applied	\N	\N	\N	\N	154494	154494	154495
30207	51807	42	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30207	51874	43	applied	\N	\N	1000000000	\N	154505	154505	154506
30207	51539	44	applied	\N	\N	\N	\N	153889	153889	99520
30207	51540	45	applied	\N	\N	\N	\N	153890	153890	100033
30207	51547	46	applied	\N	\N	\N	\N	153905	153905	153893
30207	51548	47	applied	\N	\N	\N	\N	153907	153907	99530
30207	51555	48	applied	\N	\N	\N	\N	153924	153924	99532
30207	51811	49	applied	\N	\N	\N	\N	154384	154384	154385
30207	51541	50	applied	\N	\N	\N	\N	153891	153891	99547
30207	51542	51	applied	\N	\N	\N	\N	153892	153892	154521
30207	51543	52	applied	\N	\N	\N	\N	153894	153894	100034
30207	51544	53	applied	\N	\N	\N	\N	153895	153895	153906
30207	51545	54	applied	\N	\N	\N	\N	153897	153897	154522
30207	51549	55	applied	\N	\N	\N	\N	153908	153908	99570
30207	51550	56	applied	\N	\N	\N	\N	153910	153910	99578
30207	51551	57	applied	\N	\N	\N	\N	153911	153911	154523
30207	51552	58	applied	\N	\N	\N	\N	153912	153912	99591
30207	51556	59	applied	\N	\N	\N	\N	153926	153926	154524
30207	51557	60	applied	\N	\N	\N	\N	153927	153927	99605
30207	51558	61	applied	\N	\N	\N	\N	153928	153928	99692
30207	51559	62	applied	\N	\N	\N	\N	153930	153930	154525
30204	51875	7	applied	\N	\N	\N	\N	154507	154507	154508
30204	51876	8	applied	\N	\N	\N	\N	154509	154509	154510
30204	51877	9	applied	\N	\N	\N	\N	154511	154511	101293
30204	51878	10	applied	\N	\N	\N	\N	154512	154512	154513
30204	51879	11	applied	\N	\N	\N	\N	154514	154514	154515
30206	51868	0	applied	\N	\N	\N	\N	154494	154494	154495
30206	51869	1	applied	\N	\N	\N	\N	154496	154496	154497
30206	51870	2	applied	\N	\N	\N	\N	154498	154498	154499
30206	51871	3	applied	\N	\N	\N	\N	154500	154500	154501
30206	51872	4	applied	\N	\N	\N	\N	154502	154502	154503
30206	51873	5	applied	\N	\N	\N	\N	154504	154504	101285
30206	51874	6	applied	\N	\N	1000000000	\N	154505	154505	154506
30206	51875	7	applied	\N	\N	\N	\N	154507	154507	154508
30206	51876	8	applied	\N	\N	\N	\N	154509	154509	154510
30206	51877	9	applied	\N	\N	\N	\N	154511	154511	101293
30206	51878	10	applied	\N	\N	\N	\N	154512	154512	154513
30206	51879	11	applied	\N	\N	\N	\N	154514	154514	154515
30208	51868	0	applied	\N	\N	\N	\N	154494	154494	154495
30208	51874	1	applied	\N	\N	1000000000	\N	154505	154505	154506
30210	51869	0	applied	\N	\N	\N	\N	154496	154496	154497
30210	51880	1	applied	\N	\N	\N	\N	154548	154548	154549
30210	51881	2	applied	\N	\N	\N	\N	154550	154550	154551
30210	51870	3	applied	\N	\N	\N	\N	154498	154498	154499
30210	51871	4	applied	\N	\N	\N	\N	154500	154500	154501
30210	51872	5	applied	\N	\N	\N	\N	154502	154502	154503
30210	51873	6	applied	\N	\N	\N	\N	154504	154504	101285
30210	51882	7	applied	\N	\N	\N	\N	154552	154552	154553
30210	51875	8	applied	\N	\N	\N	\N	154507	154507	154554
30210	51876	9	applied	\N	\N	\N	\N	154509	154509	101291
30210	51877	10	applied	\N	\N	\N	\N	154511	154511	154555
30210	51883	11	applied	\N	\N	\N	\N	154556	154556	154557
30210	51878	12	applied	\N	\N	\N	\N	154512	154512	154558
30210	51879	13	applied	\N	\N	\N	\N	154514	154514	154559
30210	51884	14	applied	\N	\N	1000000000	\N	154560	154560	154561
30210	51885	15	applied	\N	\N	1000000000	\N	154562	154562	154563
30210	51886	16	applied	\N	\N	1000000000	\N	154564	154564	154565
30210	51887	17	applied	\N	\N	\N	\N	154566	154566	154567
30210	51888	18	applied	\N	\N	\N	\N	154568	154568	154569
30210	51889	20	applied	\N	\N	\N	\N	154571	154571	101309
30210	51890	21	applied	\N	\N	\N	\N	154572	154572	154573
30210	51891	22	applied	\N	\N	\N	\N	154574	154574	101317
30210	51892	23	applied	\N	\N	\N	\N	154575	154575	101319
30210	51893	24	applied	\N	\N	\N	\N	154576	154576	154577
30210	51894	25	applied	\N	\N	\N	\N	154578	154578	154579
30210	51895	26	applied	\N	\N	\N	\N	154580	154580	154581
30210	51896	27	applied	\N	\N	\N	\N	154582	154582	154583
30210	51897	28	applied	\N	\N	\N	\N	154584	154584	101338
30210	51898	29	applied	\N	\N	\N	\N	154585	154585	154586
30210	51899	30	applied	\N	\N	\N	\N	154587	154587	154588
30210	51900	31	applied	\N	\N	\N	\N	154589	154589	154590
30210	51901	32	applied	\N	\N	\N	\N	154591	154591	154592
30210	51902	33	applied	\N	\N	\N	\N	154593	154593	154594
30217	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30217	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30217	51905	2	applied	\N	\N	\N	\N	154614	154614	101373
30217	51908	3	applied	\N	\N	\N	\N	154619	154619	101375
30217	51902	4	applied	\N	\N	\N	\N	154593	154593	154636
30217	51906	5	applied	\N	\N	\N	\N	154616	154616	154637
30217	51907	6	applied	\N	\N	\N	\N	154617	154617	154620
30217	51909	7	applied	\N	\N	\N	\N	154621	154621	101393
30217	51910	8	applied	\N	\N	\N	\N	154622	154622	154623
30217	51912	9	applied	\N	\N	\N	\N	154626	154626	154627
30220	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30220	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30220	51905	2	applied	\N	\N	\N	\N	154614	154614	154615
30220	51906	3	applied	\N	\N	\N	\N	154616	154616	101379
30220	51907	4	applied	\N	\N	\N	\N	154617	154617	154618
30220	51908	5	applied	\N	\N	\N	\N	154619	154619	154620
30220	51909	6	applied	\N	\N	\N	\N	154621	154621	101393
30220	51910	7	applied	\N	\N	\N	\N	154622	154622	154623
30220	51911	8	applied	\N	\N	\N	\N	154624	154624	154625
30220	51912	9	applied	\N	\N	\N	\N	154626	154626	154627
30223	51186	0	applied	\N	\N	\N	\N	153175	153175	153176
30223	51187	1	applied	\N	\N	\N	\N	153177	153177	153178
30223	50725	2	applied	\N	\N	\N	\N	152390	152390	154676
30223	51365	3	applied	\N	\N	1000000000	\N	153552	153552	153553
30223	51788	4	applied	\N	\N	\N	\N	154343	154343	154344
30223	50734	5	applied	\N	\N	\N	\N	152404	152404	154677
30223	50743	6	applied	\N	\N	\N	\N	152422	152422	154678
30223	50744	7	applied	\N	\N	\N	\N	152424	152424	154679
30223	50763	8	applied	\N	\N	\N	\N	152454	152454	154680
30223	50773	9	applied	\N	\N	\N	\N	152471	152471	154681
30223	50782	10	applied	\N	\N	\N	\N	152489	152489	154682
30223	50783	11	applied	\N	\N	\N	\N	152491	152491	154683
30223	50784	12	applied	\N	\N	\N	\N	152493	152493	154684
30223	50811	13	applied	\N	\N	\N	\N	152535	152535	154685
30223	50820	14	applied	\N	\N	\N	\N	152556	152556	154686
30223	50829	15	applied	\N	\N	\N	\N	152567	152567	154687
30223	50838	16	applied	\N	\N	\N	\N	152579	152579	154688
30223	50839	17	applied	\N	\N	\N	\N	152581	152581	154689
30223	50840	18	applied	\N	\N	\N	\N	152583	152583	154690
30223	50868	19	applied	\N	\N	\N	\N	152620	152620	154691
30223	50876	20	applied	\N	\N	\N	\N	152636	152636	154692
30223	50881	21	applied	\N	\N	\N	\N	152645	152645	154693
30223	50894	22	applied	\N	\N	\N	\N	152661	152661	154694
30223	50895	23	applied	\N	\N	\N	\N	152663	152663	154695
30223	50913	24	applied	\N	\N	\N	\N	152686	152686	154696
30223	50914	25	applied	\N	\N	\N	\N	152688	152688	154697
30223	50931	26	applied	\N	\N	\N	\N	152722	152722	154698
30223	50942	27	applied	\N	\N	\N	\N	152745	152745	154699
30223	50953	28	applied	\N	\N	\N	\N	152768	152768	154700
30223	50954	29	applied	\N	\N	\N	\N	152770	152770	154701
30223	50974	30	applied	\N	\N	\N	\N	152802	152802	154702
30223	50975	31	applied	\N	\N	\N	\N	152804	152804	154703
30223	50995	32	applied	\N	\N	\N	\N	152833	152833	154704
30223	50996	33	applied	\N	\N	\N	\N	152835	152835	154705
30223	51015	34	applied	\N	\N	\N	\N	152865	152865	154706
30223	51025	35	applied	\N	\N	\N	\N	152882	152882	154707
30223	51026	36	applied	\N	\N	\N	\N	152884	152884	154708
30223	51042	37	applied	\N	\N	\N	\N	152912	152912	154709
30223	51052	38	applied	\N	\N	\N	\N	152929	152929	154710
30223	51053	39	applied	\N	\N	\N	\N	152931	152931	154711
30223	51072	40	applied	\N	\N	\N	\N	152965	152965	154712
30223	51073	41	applied	\N	\N	\N	\N	152967	152967	154713
30223	51091	42	applied	\N	\N	\N	\N	152999	152999	154714
30223	51099	43	applied	\N	\N	\N	\N	153012	153012	154715
30223	51100	44	applied	\N	\N	\N	\N	153014	153014	154716
30223	51101	45	applied	\N	\N	\N	\N	153016	153016	154717
30223	51131	46	applied	\N	\N	\N	\N	153065	153065	154718
30207	51560	63	applied	\N	\N	\N	\N	153931	153931	99704
30207	51570	64	applied	\N	\N	\N	\N	153950	153950	100042
30207	51571	65	applied	\N	\N	\N	\N	153951	153951	154526
30207	51573	66	applied	\N	\N	\N	\N	153954	153954	154527
30207	51574	67	applied	\N	\N	\N	\N	153956	153956	100045
30207	51575	68	applied	\N	\N	\N	\N	153957	153957	99746
30207	51576	69	applied	\N	\N	\N	\N	153959	153959	154528
30207	51577	70	applied	\N	\N	\N	\N	153960	153960	99767
30207	51578	71	applied	\N	\N	\N	\N	153961	153961	154529
30207	51579	72	applied	\N	\N	\N	\N	153963	153963	154530
30207	51580	73	applied	\N	\N	\N	\N	153964	153964	99783
30207	51581	74	applied	\N	\N	\N	\N	153965	153965	154531
30207	51582	75	applied	\N	\N	\N	\N	153966	153966	99802
30207	51563	76	applied	\N	\N	\N	\N	153934	153934	99804
30207	51569	77	applied	\N	\N	\N	\N	153949	153949	99815
30207	51572	78	applied	\N	\N	\N	\N	153953	153953	99817
30207	51583	79	applied	\N	\N	\N	\N	153967	153967	99819
30207	51584	80	applied	\N	\N	\N	\N	153968	153968	99821
30207	51585	81	applied	\N	\N	\N	\N	153969	153969	100166
30207	51586	82	applied	\N	\N	\N	\N	153970	153970	154532
30207	51587	83	applied	\N	\N	\N	\N	153971	153971	99825
30207	51588	84	applied	\N	\N	\N	\N	153972	153972	100167
30207	51589	85	applied	\N	\N	\N	\N	153973	153973	154533
30207	51590	86	applied	\N	\N	\N	\N	153974	153974	99829
30207	51553	87	applied	\N	\N	\N	\N	153914	153914	100059
30207	51561	88	applied	\N	\N	\N	\N	153932	153932	99838
30207	51562	89	applied	\N	\N	\N	\N	153933	153933	99834
30207	51591	90	applied	\N	\N	\N	\N	153975	153975	153976
30207	51592	91	applied	\N	\N	\N	\N	153977	153977	99839
30207	51593	92	applied	\N	\N	\N	\N	153978	153978	99848
30207	51818	93	applied	\N	\N	\N	\N	154394	154394	154395
30207	51819	94	applied	\N	\N	\N	\N	154396	154396	154397
30207	51820	95	applied	\N	\N	\N	\N	154398	154398	154399
30207	51594	96	applied	\N	\N	\N	\N	153979	153979	99853
30207	51595	97	applied	\N	\N	\N	\N	153980	153980	99855
30207	51596	98	applied	\N	\N	\N	\N	153981	153981	99857
30207	51597	99	applied	\N	\N	\N	\N	153982	153982	100168
30207	51618	100	applied	\N	\N	\N	\N	154016	154016	154534
30207	51619	101	applied	\N	\N	\N	\N	154018	154018	153986
30207	51598	102	applied	\N	\N	\N	\N	153983	153983	153984
30207	51613	103	applied	\N	\N	\N	\N	154007	154007	154008
30207	51822	104	applied	\N	\N	\N	\N	154406	154406	154407
30207	51599	105	applied	\N	\N	\N	\N	153985	153985	99872
30207	51600	106	applied	\N	\N	\N	\N	153987	153987	100169
30207	51601	107	applied	\N	\N	\N	\N	153988	153988	99889
30207	51602	108	applied	\N	\N	\N	\N	153989	153989	99897
30207	51603	109	applied	\N	\N	\N	\N	153990	153990	100171
30207	51604	110	applied	\N	\N	\N	\N	153991	153991	99903
30207	51605	111	applied	\N	\N	\N	\N	153992	153992	100351
30207	51606	112	applied	\N	\N	\N	\N	153993	153993	99920
30207	51607	113	applied	\N	\N	\N	\N	153994	153994	153996
30207	51608	114	applied	\N	\N	\N	\N	153995	153995	154001
30207	51616	115	applied	\N	\N	\N	\N	154012	154012	99930
30207	51620	116	applied	\N	\N	\N	\N	154019	154019	154017
30207	51621	117	applied	\N	\N	\N	\N	154020	154020	154535
30207	51622	118	applied	\N	\N	\N	\N	154022	154022	100177
30207	51625	119	applied	\N	\N	\N	\N	154029	154029	154536
30207	51626	120	applied	\N	\N	\N	\N	154030	154030	99963
30215	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30215	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30215	51905	2	applied	\N	\N	\N	\N	154614	154614	154615
30215	51906	3	applied	\N	\N	\N	\N	154616	154616	101379
30215	51907	4	applied	\N	\N	\N	\N	154617	154617	154618
30215	51908	5	applied	\N	\N	\N	\N	154619	154619	154620
30215	51909	6	applied	\N	\N	\N	\N	154621	154621	101393
30215	51910	7	applied	\N	\N	\N	\N	154622	154622	154623
30215	51911	8	applied	\N	\N	\N	\N	154624	154624	154625
30215	51912	9	applied	\N	\N	\N	\N	154626	154626	154627
30218	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30218	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30218	51905	2	applied	\N	\N	\N	\N	154614	154614	101373
30218	51908	3	applied	\N	\N	\N	\N	154619	154619	101375
30218	51902	4	applied	\N	\N	\N	\N	154593	154593	154636
30218	51906	5	applied	\N	\N	\N	\N	154616	154616	154637
30218	51907	6	applied	\N	\N	\N	\N	154617	154617	154620
30218	51909	7	applied	\N	\N	\N	\N	154621	154621	101393
30218	51910	8	applied	\N	\N	\N	\N	154622	154622	154623
30218	51911	9	applied	\N	\N	\N	\N	154624	154624	154625
30218	51912	10	applied	\N	\N	\N	\N	154626	154626	154627
30221	51913	0	applied	\N	\N	\N	\N	154644	154644	154645
30221	51914	1	applied	\N	\N	\N	\N	154646	154646	154647
30221	51915	2	applied	\N	\N	\N	\N	154648	154648	101417
30221	51916	3	applied	\N	\N	\N	\N	154649	154649	154650
30221	51917	4	applied	\N	\N	\N	\N	154651	154651	154652
30221	51918	5	applied	\N	\N	\N	\N	154653	154653	154654
30221	51919	6	applied	\N	\N	\N	\N	154655	154655	101425
30221	51920	7	applied	\N	\N	\N	\N	154656	154656	154657
30221	51921	8	applied	\N	\N	\N	\N	154658	154658	101438
30224	51930	0	applied	\N	\N	\N	\N	154785	154785	154786
30224	51931	1	applied	\N	\N	\N	\N	154787	154787	29193
30224	51932	2	applied	\N	\N	\N	\N	154788	154788	154789
30224	51933	3	applied	\N	\N	\N	\N	154790	154790	101474
30224	51934	4	applied	\N	\N	\N	\N	154791	154791	101486
30224	51935	5	applied	\N	\N	\N	\N	154792	154792	154793
30224	51936	6	applied	\N	\N	\N	\N	154794	154794	101510
30224	51937	7	applied	\N	\N	\N	\N	154795	154795	154796
30224	51938	8	applied	\N	\N	\N	\N	154797	154797	154798
30226	51939	0	applied	\N	\N	\N	\N	154800	154800	154801
30226	51940	1	applied	\N	\N	\N	\N	154802	154802	152064
30226	51941	2	applied	\N	\N	\N	\N	154803	154803	101522
30226	51942	3	applied	\N	\N	\N	\N	154804	154804	154805
30226	51943	4	applied	\N	\N	\N	\N	154806	154806	154807
30226	51944	5	applied	\N	\N	\N	\N	154808	154808	154809
30226	51945	6	applied	\N	\N	\N	\N	154810	154810	154811
30226	51946	7	applied	\N	\N	\N	\N	154812	154812	101554
30226	51947	8	applied	\N	\N	\N	\N	154813	154813	154814
30226	51948	9	applied	\N	\N	\N	\N	154815	154815	101564
30226	51949	10	applied	\N	\N	\N	\N	154816	154816	154817
30233	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30233	51978	1	applied	\N	\N	\N	\N	154869	154869	154870
30233	51979	2	applied	\N	\N	\N	\N	154871	154871	154872
30233	51980	3	applied	\N	\N	\N	\N	154873	154873	101736
30233	51981	4	applied	\N	\N	\N	\N	154874	154874	101738
30233	51982	5	applied	\N	\N	\N	\N	154875	154875	101747
30233	51983	6	applied	\N	\N	\N	\N	154876	154876	154877
30233	51984	7	applied	\N	\N	\N	\N	154878	154878	101758
30233	51985	8	applied	\N	\N	\N	\N	154879	154879	101767
30233	51986	9	applied	\N	\N	\N	\N	154880	154880	101764
30237	51980	0	applied	\N	\N	\N	\N	154873	154873	154887
30237	51981	1	applied	\N	\N	\N	\N	154874	154874	101728
30211	51892	23	applied	\N	\N	\N	\N	154575	154575	101319
30211	51893	24	applied	\N	\N	\N	\N	154576	154576	154577
30211	51894	25	applied	\N	\N	\N	\N	154578	154578	154579
30211	51895	26	applied	\N	\N	\N	\N	154580	154580	154581
30211	51896	27	applied	\N	\N	\N	\N	154582	154582	154583
30211	51897	28	applied	\N	\N	\N	\N	154584	154584	101338
30211	51898	29	applied	\N	\N	\N	\N	154585	154585	154586
30211	51899	30	applied	\N	\N	\N	\N	154587	154587	154588
30211	51900	31	applied	\N	\N	\N	\N	154589	154589	154590
30211	51901	32	applied	\N	\N	\N	\N	154591	154591	154592
30222	51922	0	applied	\N	\N	\N	\N	154661	154661	154662
30222	51923	1	applied	\N	\N	\N	\N	154663	154663	101440
30222	51924	2	applied	\N	\N	\N	\N	154664	154664	154665
30222	51925	3	applied	\N	\N	\N	\N	154666	154666	154667
30222	51926	4	applied	\N	\N	\N	\N	154668	154668	101452
30222	51927	5	applied	\N	\N	\N	\N	154669	154669	154670
30222	51928	6	applied	\N	\N	\N	\N	154671	154671	154672
30222	51929	7	applied	\N	\N	\N	\N	154673	154673	101470
30227	51922	0	applied	\N	\N	\N	\N	154661	154661	154662
30227	51923	1	applied	\N	\N	\N	\N	154663	154663	101440
30227	51924	2	applied	\N	\N	\N	\N	154664	154664	154665
30227	51925	3	applied	\N	\N	\N	\N	154666	154666	154667
30227	51926	4	applied	\N	\N	\N	\N	154668	154668	101452
30227	51927	5	applied	\N	\N	\N	\N	154669	154669	154670
30227	51928	6	applied	\N	\N	\N	\N	154671	154671	154672
30227	51929	7	applied	\N	\N	\N	\N	154673	154673	101470
30227	51932	8	applied	\N	\N	\N	\N	154788	154788	154789
30228	51939	0	applied	\N	\N	\N	\N	154800	154800	154801
30228	51940	1	applied	\N	\N	\N	\N	154802	154802	152064
30228	51941	2	applied	\N	\N	\N	\N	154803	154803	101522
30228	51942	3	applied	\N	\N	\N	\N	154804	154804	154805
30228	51943	4	applied	\N	\N	\N	\N	154806	154806	154807
30228	51944	5	applied	\N	\N	\N	\N	154808	154808	154809
30228	51945	6	applied	\N	\N	\N	\N	154810	154810	154811
30228	51946	7	applied	\N	\N	\N	\N	154812	154812	101554
30228	51947	8	applied	\N	\N	\N	\N	154813	154813	154814
30228	51948	9	applied	\N	\N	\N	\N	154815	154815	101564
30228	51949	10	applied	\N	\N	\N	\N	154816	154816	154817
30229	51939	0	applied	\N	\N	\N	\N	154800	154800	154801
30229	51940	1	applied	\N	\N	\N	\N	154802	154802	152064
30229	51941	2	applied	\N	\N	\N	\N	154803	154803	101522
30229	51942	3	applied	\N	\N	\N	\N	154804	154804	154805
30229	51943	4	applied	\N	\N	\N	\N	154806	154806	154807
30229	51944	5	applied	\N	\N	\N	\N	154808	154808	154809
30229	51945	6	applied	\N	\N	\N	\N	154810	154810	154811
30229	51946	7	applied	\N	\N	\N	\N	154812	154812	101554
30229	51947	8	applied	\N	\N	\N	\N	154813	154813	154814
30229	51948	9	applied	\N	\N	\N	\N	154815	154815	101564
30229	51949	10	applied	\N	\N	\N	\N	154816	154816	154817
30231	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30231	51978	1	applied	\N	\N	\N	\N	154869	154869	154870
30231	51979	2	applied	\N	\N	\N	\N	154871	154871	154872
30231	51980	3	applied	\N	\N	\N	\N	154873	154873	101736
30231	51981	4	applied	\N	\N	\N	\N	154874	154874	101738
30231	51982	5	applied	\N	\N	\N	\N	154875	154875	101747
30231	51983	6	applied	\N	\N	\N	\N	154876	154876	154877
30231	51984	7	applied	\N	\N	\N	\N	154878	154878	101758
30231	51985	8	applied	\N	\N	\N	\N	154879	154879	101767
30231	51986	9	applied	\N	\N	\N	\N	154880	154880	101764
30234	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30234	51978	1	applied	\N	\N	\N	\N	154869	154869	154870
30234	51979	2	applied	\N	\N	\N	\N	154871	154871	154872
30234	51980	3	applied	\N	\N	\N	\N	154873	154873	101736
30234	51981	4	applied	\N	\N	\N	\N	154874	154874	101738
30234	51982	5	applied	\N	\N	\N	\N	154875	154875	101747
30234	51983	6	applied	\N	\N	\N	\N	154876	154876	154877
30234	51984	7	applied	\N	\N	\N	\N	154878	154878	101758
30234	51985	8	applied	\N	\N	\N	\N	154879	154879	101767
30234	51986	9	applied	\N	\N	\N	\N	154880	154880	101764
30236	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30236	51978	1	applied	\N	\N	\N	\N	154869	154869	154870
30236	51979	2	applied	\N	\N	\N	\N	154871	154871	154872
30236	51980	3	applied	\N	\N	\N	\N	154873	154873	101736
30236	51981	4	applied	\N	\N	\N	\N	154874	154874	101738
30236	51982	5	applied	\N	\N	\N	\N	154875	154875	101747
30236	51983	6	applied	\N	\N	\N	\N	154876	154876	154877
30236	51984	7	applied	\N	\N	\N	\N	154878	154878	101758
30236	51985	8	applied	\N	\N	\N	\N	154879	154879	101767
30236	51986	9	applied	\N	\N	\N	\N	154880	154880	101764
30238	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30238	51987	1	applied	\N	\N	\N	\N	154893	154893	154894
30238	51988	2	applied	\N	\N	\N	\N	154895	154895	154896
30238	51989	3	applied	\N	\N	\N	\N	154897	154897	101736
30238	51978	4	applied	\N	\N	\N	\N	154869	154869	101747
30238	51979	5	applied	\N	\N	\N	\N	154871	154871	103114
30238	51984	6	applied	\N	\N	\N	\N	154878	154878	101760
30238	51985	7	applied	\N	\N	\N	\N	154879	154879	154898
30238	51990	8	applied	\N	\N	\N	\N	154899	154899	101773
30238	51991	9	applied	\N	\N	\N	\N	154900	154900	103121
30238	51992	10	applied	\N	\N	\N	\N	154901	154901	154902
30238	51993	12	applied	\N	\N	\N	\N	154904	154904	101795
30238	51994	13	applied	\N	\N	\N	\N	154905	154905	101797
30238	51995	14	applied	\N	\N	\N	\N	154906	154906	101804
30238	51996	15	applied	\N	\N	\N	\N	154907	154907	103123
30238	51997	16	applied	\N	\N	\N	\N	154908	154908	101806
30238	51998	17	applied	\N	\N	\N	\N	154909	154909	154910
30238	51999	18	applied	\N	\N	\N	\N	154911	154911	101812
30238	52000	19	applied	\N	\N	\N	\N	154912	154912	101829
30238	52001	20	applied	\N	\N	\N	\N	154913	154913	103127
30238	52002	21	applied	\N	\N	\N	\N	154914	154914	101843
30238	52003	22	applied	\N	\N	\N	\N	154915	154915	101847
30238	52004	23	applied	\N	\N	\N	\N	154916	154916	101858
30245	52031	0	applied	\N	\N	\N	\N	154970	154970	154971
30245	52032	1	applied	\N	\N	\N	\N	154972	154972	154973
30245	52033	2	applied	\N	\N	\N	\N	154974	154974	101981
30245	52034	3	applied	\N	\N	\N	\N	154975	154975	101985
30245	52035	4	applied	\N	\N	\N	\N	154976	154976	154977
30245	52036	5	applied	\N	\N	\N	\N	154978	154978	101991
30245	52037	6	applied	\N	\N	\N	\N	154979	154979	154980
30245	52038	7	applied	\N	\N	\N	\N	154981	154981	101993
30245	52039	8	applied	\N	\N	\N	\N	154982	154982	103222
30245	52040	9	applied	\N	\N	\N	\N	154983	154983	103223
30245	52041	10	applied	\N	\N	\N	\N	154984	154984	102001
30245	52042	11	applied	\N	\N	\N	\N	154985	154985	102008
30245	52043	12	applied	\N	\N	\N	\N	154986	154986	103224
30245	52044	13	applied	\N	\N	\N	\N	154987	154987	102018
30245	52045	14	applied	\N	\N	\N	\N	154988	154988	102182
30245	52046	15	applied	\N	\N	\N	\N	154989	154989	102036
30245	52047	16	applied	\N	\N	\N	\N	154990	154990	102052
30245	52048	17	applied	\N	\N	\N	\N	154991	154991	102056
30214	51892	23	applied	\N	\N	\N	\N	154575	154575	101319
30214	51893	24	applied	\N	\N	\N	\N	154576	154576	154577
30214	51894	25	applied	\N	\N	\N	\N	154578	154578	154579
30214	51895	26	applied	\N	\N	\N	\N	154580	154580	154581
30214	51896	27	applied	\N	\N	\N	\N	154582	154582	154583
30214	51897	28	applied	\N	\N	\N	\N	154584	154584	101338
30214	51898	29	applied	\N	\N	\N	\N	154585	154585	154586
30214	51899	30	applied	\N	\N	\N	\N	154587	154587	154588
30214	51900	31	applied	\N	\N	\N	\N	154589	154589	154590
30214	51901	32	applied	\N	\N	\N	\N	154591	154591	154592
30214	51902	33	applied	\N	\N	\N	\N	154593	154593	154594
30216	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30216	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30216	51905	2	applied	\N	\N	\N	\N	154614	154614	154615
30216	51906	3	applied	\N	\N	\N	\N	154616	154616	101379
30216	51907	4	applied	\N	\N	\N	\N	154617	154617	154618
30216	51908	5	applied	\N	\N	\N	\N	154619	154619	154620
30216	51909	6	applied	\N	\N	\N	\N	154621	154621	101393
30216	51910	7	applied	\N	\N	\N	\N	154622	154622	154623
30216	51911	8	applied	\N	\N	\N	\N	154624	154624	154625
30216	51912	9	applied	\N	\N	\N	\N	154626	154626	154627
30219	51903	0	applied	\N	\N	\N	\N	154610	154610	154611
30219	51904	1	applied	\N	\N	\N	\N	154612	154612	154613
30219	51905	2	applied	\N	\N	\N	\N	154614	154614	154615
30219	51906	3	applied	\N	\N	\N	\N	154616	154616	101379
30219	51907	4	applied	\N	\N	\N	\N	154617	154617	154618
30219	51908	5	applied	\N	\N	\N	\N	154619	154619	154620
30219	51909	6	applied	\N	\N	\N	\N	154621	154621	101393
30219	51910	7	applied	\N	\N	\N	\N	154622	154622	154623
30219	51911	8	applied	\N	\N	\N	\N	154624	154624	154625
30219	51912	9	applied	\N	\N	\N	\N	154626	154626	154627
30240	52005	0	applied	\N	\N	\N	\N	154927	154927	154928
30240	52010	1	applied	\N	\N	\N	\N	154933	154933	101855
30240	52011	2	applied	\N	\N	\N	\N	154934	154934	101859
30240	52012	3	applied	\N	\N	\N	\N	154935	154935	103135
30242	52013	0	applied	\N	\N	\N	\N	154944	154944	154945
30242	52014	1	applied	\N	\N	\N	\N	154946	154946	103144
30242	52015	2	applied	\N	\N	\N	\N	154947	154947	103146
30242	52016	3	applied	\N	\N	\N	\N	154948	154948	154949
30242	52017	4	applied	\N	\N	\N	\N	154950	154950	101922
30242	52018	5	applied	\N	\N	\N	\N	154951	154951	101929
30242	52019	6	applied	\N	\N	\N	\N	154952	154952	101935
30242	52020	7	applied	\N	\N	\N	\N	154953	154953	101943
30242	52021	8	applied	\N	\N	\N	\N	154954	154954	103149
30242	52022	9	applied	\N	\N	\N	\N	154955	154955	103150
30244	52030	0	applied	\N	\N	\N	\N	154966	154966	154967
30247	52050	0	applied	\N	\N	\N	\N	154995	154995	154996
30247	52051	1	applied	\N	\N	\N	\N	154997	154997	154998
30247	52052	2	applied	\N	\N	\N	\N	154999	154999	102192
30247	52053	3	applied	\N	\N	\N	\N	155000	155000	155001
30247	52054	4	applied	\N	\N	\N	\N	155002	155002	102193
30247	52055	5	applied	\N	\N	\N	\N	155003	155003	102064
30247	52056	6	applied	\N	\N	\N	\N	155004	155004	102194
30247	52057	7	applied	\N	\N	\N	\N	155005	155005	102195
30247	52058	8	applied	\N	\N	\N	\N	155006	155006	102071
30247	52059	9	applied	\N	\N	\N	\N	155007	155007	102196
30247	52060	10	applied	\N	\N	\N	\N	155008	155008	102077
30247	52061	11	applied	\N	\N	\N	\N	155009	155009	102090
30247	52062	12	applied	\N	\N	\N	\N	155010	155010	102200
30247	52063	13	applied	\N	\N	\N	\N	155011	155011	102099
30247	52064	14	applied	\N	\N	\N	\N	155012	155012	102103
30247	52065	15	applied	\N	\N	\N	\N	155013	155013	102203
30247	52066	16	applied	\N	\N	\N	\N	155014	155014	155015
30247	52067	17	applied	\N	\N	\N	\N	155016	155016	155017
30247	52068	18	applied	\N	\N	\N	\N	155018	155018	102207
30250	52069	0	applied	\N	\N	\N	\N	155022	155022	155023
30250	52070	1	applied	\N	\N	\N	\N	155024	155024	155025
30250	52071	2	applied	\N	\N	\N	\N	155026	155026	102208
30250	52072	3	applied	\N	\N	\N	\N	155027	155027	102158
30250	52073	4	applied	\N	\N	\N	\N	155028	155028	102209
30250	52074	5	applied	\N	\N	1000000000	\N	155029	155029	155030
30250	52075	6	applied	\N	\N	\N	\N	155031	155031	155032
30250	52077	7	applied	\N	\N	\N	\N	155034	155034	102167
30250	52078	8	applied	\N	\N	\N	\N	155036	155036	155041
30254	52088	0	applied	\N	\N	\N	\N	155061	155061	155062
30254	52089	1	applied	\N	\N	\N	\N	155063	155063	102263
30254	52090	2	applied	\N	\N	\N	\N	155064	155064	155065
30254	52091	3	applied	\N	\N	\N	\N	155066	155066	102267
30254	52092	4	applied	\N	\N	\N	\N	155067	155067	155068
30254	52093	5	applied	\N	\N	\N	\N	155069	155069	155070
30254	52094	6	applied	\N	\N	\N	\N	155071	155071	155072
30254	52095	7	applied	\N	\N	\N	\N	155073	155073	155074
30254	52096	9	applied	\N	\N	\N	\N	155076	155076	102287
30256	52097	0	applied	\N	\N	\N	\N	155084	155084	155085
30256	52098	1	applied	\N	\N	\N	\N	155086	155086	155087
30256	52099	2	applied	\N	\N	\N	\N	155088	155088	102295
30256	52100	3	applied	\N	\N	\N	\N	155089	155089	102444
30256	52101	4	applied	\N	\N	\N	\N	155090	155090	155091
30256	52102	5	applied	\N	\N	\N	\N	155092	155092	102305
30256	52103	6	applied	\N	\N	\N	\N	155093	155093	102307
30256	52104	7	applied	\N	\N	\N	\N	155094	155094	102448
30256	52105	8	applied	\N	\N	\N	\N	155095	155095	155096
30256	52106	9	applied	\N	\N	\N	\N	155097	155097	102449
30256	52107	10	applied	\N	\N	\N	\N	155098	155098	155099
30256	52108	11	applied	\N	\N	\N	\N	155100	155100	155101
30256	52109	12	applied	\N	\N	\N	\N	155102	155102	102331
30256	52110	13	applied	\N	\N	\N	\N	155103	155103	155104
30256	52111	14	applied	\N	\N	\N	\N	155105	155105	155106
30256	52112	15	applied	\N	\N	\N	\N	155107	155107	155108
30256	52113	16	applied	\N	\N	\N	\N	155109	155109	155110
30256	52114	17	applied	\N	\N	\N	\N	155111	155111	102362
30261	52116	0	applied	\N	\N	\N	\N	155125	155125	155126
30261	52117	1	applied	\N	\N	\N	\N	155127	155127	155128
30261	52118	2	applied	\N	\N	\N	\N	155129	155129	155130
30261	52119	3	applied	\N	\N	\N	\N	155131	155131	155132
30261	52156	4	applied	\N	\N	\N	\N	155194	155194	155195
30261	52121	5	applied	\N	\N	\N	\N	155135	155135	155136
30261	52122	6	applied	\N	\N	\N	\N	155137	155137	155138
30261	52123	7	applied	\N	\N	\N	\N	155139	155139	102368
30261	52124	8	applied	\N	\N	\N	\N	155140	155140	155141
30261	52125	9	applied	\N	\N	\N	\N	155142	155142	102376
30261	52126	10	applied	\N	\N	\N	\N	155143	155143	155144
30261	52127	11	applied	\N	\N	\N	\N	155145	155145	155146
30261	52128	12	applied	\N	\N	\N	\N	155147	155147	102384
30261	52129	13	applied	\N	\N	\N	\N	155148	155148	155149
30261	52130	14	applied	\N	\N	\N	\N	155150	155150	155151
30261	52131	15	applied	\N	\N	\N	\N	155152	155152	102410
30261	52132	16	applied	\N	\N	\N	\N	155153	155153	155154
30261	52157	17	applied	\N	\N	\N	\N	155196	155196	155197
30261	52133	18	applied	\N	\N	\N	\N	155155	155155	102414
30223	51139	47	applied	\N	\N	\N	\N	153087	153087	154719
30223	51148	48	applied	\N	\N	\N	\N	153108	153108	154720
30223	51159	49	applied	\N	\N	\N	\N	153126	153126	154721
30223	51167	56	applied	\N	\N	\N	\N	153139	153139	154728
30223	51178	57	applied	\N	\N	\N	\N	153163	153163	154729
30223	51188	58	applied	\N	\N	\N	\N	153179	153179	154730
30223	51197	59	applied	\N	\N	\N	\N	153195	153195	154731
30223	51198	60	applied	\N	\N	\N	\N	153197	153197	154732
30223	51216	61	applied	\N	\N	\N	\N	153229	153229	154733
30223	51225	62	applied	\N	\N	\N	\N	153242	153242	154734
30223	51236	63	applied	\N	\N	\N	\N	153260	153260	154735
30223	51245	64	applied	\N	\N	\N	\N	153297	153297	154736
30223	51254	65	applied	\N	\N	\N	\N	153314	153314	154737
30223	51255	66	applied	\N	\N	\N	\N	153316	153316	154738
30223	51256	67	applied	\N	\N	\N	\N	153318	153318	154739
30223	51282	68	applied	\N	\N	\N	\N	153362	153362	154740
30223	51291	69	applied	\N	\N	\N	\N	153385	153385	154741
30223	51300	70	applied	\N	\N	\N	\N	153402	153402	154742
30223	51309	71	applied	\N	\N	\N	\N	153422	153422	154743
30223	51310	72	applied	\N	\N	\N	\N	153424	153424	154744
30223	51328	73	applied	\N	\N	\N	\N	153477	153477	154745
30223	51337	74	applied	\N	\N	\N	\N	153500	153500	154746
30223	51338	75	applied	\N	\N	\N	\N	153502	153502	154747
30223	51339	76	applied	\N	\N	\N	\N	153504	153504	154748
30223	51366	77	applied	\N	\N	\N	\N	153554	153554	154749
30223	51367	78	applied	\N	\N	\N	\N	153556	153556	154750
30223	51392	79	applied	\N	\N	\N	\N	153625	153625	154751
30223	51396	80	applied	\N	\N	\N	\N	153637	153637	154752
30223	51397	81	applied	\N	\N	\N	\N	153639	153639	154753
30223	51415	82	applied	\N	\N	\N	\N	153670	153670	154754
30223	51416	83	applied	\N	\N	\N	\N	153672	153672	154755
30223	51417	84	applied	\N	\N	\N	\N	153674	153674	154756
30223	51443	85	applied	\N	\N	\N	\N	153708	153708	154757
30223	51444	86	applied	\N	\N	\N	\N	153710	153710	154758
30223	51463	87	applied	\N	\N	\N	\N	153739	153739	154759
30223	51482	88	applied	\N	\N	\N	\N	153777	153777	154760
30223	51490	89	applied	\N	\N	\N	\N	153789	153789	154761
30223	51501	90	applied	\N	\N	\N	\N	153816	153816	154762
30223	51508	91	applied	\N	\N	\N	\N	153828	153828	154763
30223	51518	92	applied	\N	\N	\N	\N	153844	153844	154764
30223	51527	93	applied	\N	\N	\N	\N	153869	153869	154765
30223	51536	94	applied	\N	\N	\N	\N	153884	153884	154766
30223	51546	95	applied	\N	\N	\N	\N	153903	153903	154767
30223	51554	96	applied	\N	\N	\N	\N	153922	153922	154768
30225	51939	0	applied	\N	\N	\N	\N	154800	154800	154801
30225	51940	1	applied	\N	\N	\N	\N	154802	154802	152064
30225	51941	2	applied	\N	\N	\N	\N	154803	154803	101522
30225	51942	3	applied	\N	\N	\N	\N	154804	154804	154805
30225	51943	4	applied	\N	\N	\N	\N	154806	154806	154807
30225	51944	5	applied	\N	\N	\N	\N	154808	154808	154809
30225	51945	6	applied	\N	\N	\N	\N	154810	154810	154811
30225	51946	7	applied	\N	\N	\N	\N	154812	154812	101554
30225	51947	8	applied	\N	\N	\N	\N	154813	154813	154814
30225	51948	9	applied	\N	\N	\N	\N	154815	154815	101564
30225	51949	10	applied	\N	\N	\N	\N	154816	154816	154817
30230	51950	0	applied	\N	\N	\N	\N	154824	154824	154825
30230	51951	1	applied	\N	\N	\N	\N	154826	154826	154827
30230	51952	2	applied	\N	\N	\N	\N	154828	154828	154829
30230	51953	3	applied	\N	\N	\N	\N	154830	154830	101572
30230	51954	4	applied	\N	\N	\N	\N	154831	154831	154832
30230	51955	5	applied	\N	\N	\N	\N	154833	154833	154834
30230	51956	6	applied	\N	\N	\N	\N	154835	154835	101580
30230	51957	7	applied	\N	\N	\N	\N	154836	154836	154837
30230	51958	8	applied	\N	\N	\N	\N	154838	154838	154839
30230	51959	9	applied	\N	\N	\N	\N	154840	154840	101598
30230	51960	10	applied	\N	\N	\N	\N	154841	154841	154842
30230	51961	11	applied	\N	\N	\N	\N	154843	154843	154844
30230	51962	12	applied	\N	\N	\N	\N	154845	154845	154846
30230	51963	13	applied	\N	\N	\N	\N	154847	154847	101623
30230	51964	14	applied	\N	\N	\N	\N	154848	154848	101625
30230	51965	15	applied	\N	\N	\N	\N	154849	154849	101627
30230	51966	16	applied	\N	\N	\N	\N	154850	154850	154851
30230	51967	17	applied	\N	\N	\N	\N	154852	154852	154853
30230	51968	18	applied	\N	\N	\N	\N	154854	154854	101642
30230	51969	19	applied	\N	\N	\N	\N	154855	154855	154856
30230	51970	20	applied	\N	\N	\N	\N	154857	154857	101697
30230	51971	21	applied	\N	\N	\N	\N	154858	154858	101707
30230	51972	22	applied	\N	\N	\N	\N	154859	154859	154860
30230	51973	23	applied	\N	\N	\N	\N	154861	154861	101715
30230	51974	24	applied	\N	\N	\N	\N	154862	154862	101717
30230	51975	25	applied	\N	\N	\N	\N	154863	154863	101723
30230	51976	26	applied	\N	\N	\N	\N	154864	154864	101725
30232	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30232	51978	1	applied	\N	\N	\N	\N	154869	154869	154870
30232	51979	2	applied	\N	\N	\N	\N	154871	154871	154872
30232	51980	3	applied	\N	\N	\N	\N	154873	154873	101736
30232	51981	4	applied	\N	\N	\N	\N	154874	154874	101738
30232	51982	5	applied	\N	\N	\N	\N	154875	154875	101747
30232	51983	6	applied	\N	\N	\N	\N	154876	154876	154877
30232	51984	7	applied	\N	\N	\N	\N	154878	154878	101758
30232	51985	8	applied	\N	\N	\N	\N	154879	154879	101767
30232	51986	9	applied	\N	\N	\N	\N	154880	154880	101764
30235	51977	0	applied	\N	\N	\N	\N	154867	154867	154868
30235	51980	1	applied	\N	\N	\N	\N	154873	154873	154887
30235	51981	2	applied	\N	\N	\N	\N	154874	154874	101728
30235	51982	3	applied	\N	\N	\N	\N	154875	154875	154888
30235	51983	4	applied	\N	\N	\N	\N	154876	154876	154889
30235	51986	5	applied	\N	\N	\N	\N	154880	154880	154872
30241	52005	0	applied	\N	\N	\N	\N	154927	154927	154928
30241	52010	1	applied	\N	\N	\N	\N	154933	154933	101855
30248	52069	0	applied	\N	\N	\N	\N	155022	155022	155023
30248	52070	1	applied	\N	\N	\N	\N	155024	155024	155025
30248	52071	2	applied	\N	\N	\N	\N	155026	155026	102208
30248	52072	3	applied	\N	\N	\N	\N	155027	155027	102158
30248	52073	4	applied	\N	\N	\N	\N	155028	155028	102209
30248	52074	5	applied	\N	\N	1000000000	\N	155029	155029	155030
30248	52075	6	applied	\N	\N	\N	\N	155031	155031	155032
30248	52076	7	applied	\N	\N	\N	\N	155033	155033	102165
30248	52077	8	applied	\N	\N	\N	\N	155034	155034	155035
30248	52078	9	applied	\N	\N	\N	\N	155036	155036	102174
30248	52079	10	applied	\N	\N	\N	\N	155037	155037	155038
30252	52080	0	applied	\N	\N	\N	\N	155044	155044	155045
30252	52079	1	applied	\N	\N	\N	\N	155037	155037	102211
30252	52081	2	applied	\N	\N	\N	\N	155046	155046	102218
30252	52082	3	applied	\N	\N	\N	\N	155047	155047	102226
30252	52076	4	applied	\N	\N	\N	\N	155033	155033	155048
30252	52083	5	applied	\N	\N	\N	\N	155049	155049	102237
30252	52084	6	applied	\N	\N	\N	\N	155050	155050	102246
30252	52085	7	applied	\N	\N	\N	\N	155051	155051	155052
30252	52086	8	applied	\N	\N	\N	\N	155053	155053	102252
30237	51982	2	applied	\N	\N	\N	\N	154875	154875	154888
30237	51983	3	applied	\N	\N	\N	\N	154876	154876	154889
30237	51986	4	applied	\N	\N	\N	\N	154880	154880	154872
30239	52005	0	applied	\N	\N	\N	\N	154927	154927	154928
30239	52006	1	applied	\N	\N	\N	\N	154929	154929	101864
30239	52007	2	applied	\N	\N	\N	\N	154930	154930	103137
30239	52008	3	applied	\N	\N	\N	\N	154931	154931	103139
30239	52009	4	applied	\N	\N	\N	\N	154932	154932	101908
30239	52010	5	applied	\N	\N	\N	\N	154933	154933	103142
30239	52011	6	applied	\N	\N	\N	\N	154934	154934	103143
30239	52012	7	applied	\N	\N	\N	\N	154935	154935	101912
30243	52023	0	applied	\N	\N	\N	\N	154956	154956	154957
30243	52024	1	applied	\N	\N	\N	\N	154958	154958	101955
30243	52025	2	applied	\N	\N	\N	\N	154959	154959	103215
30243	52026	3	applied	\N	\N	\N	\N	154960	154960	101973
30243	52027	4	applied	\N	\N	\N	\N	154961	154961	103218
30243	52028	5	applied	\N	\N	\N	\N	154962	154962	103219
30243	52029	6	applied	\N	\N	\N	\N	154963	154963	103220
30246	52050	0	applied	\N	\N	\N	\N	154995	154995	154996
30246	52051	1	applied	\N	\N	\N	\N	154997	154997	154998
30246	52052	2	applied	\N	\N	\N	\N	154999	154999	102192
30246	52053	3	applied	\N	\N	\N	\N	155000	155000	155001
30246	52054	4	applied	\N	\N	\N	\N	155002	155002	102193
30246	52055	5	applied	\N	\N	\N	\N	155003	155003	102064
30246	52056	6	applied	\N	\N	\N	\N	155004	155004	102194
30246	52057	7	applied	\N	\N	\N	\N	155005	155005	102195
30246	52058	8	applied	\N	\N	\N	\N	155006	155006	102071
30246	52059	9	applied	\N	\N	\N	\N	155007	155007	102196
30246	52060	10	applied	\N	\N	\N	\N	155008	155008	102077
30246	52061	11	applied	\N	\N	\N	\N	155009	155009	102090
30246	52062	12	applied	\N	\N	\N	\N	155010	155010	102200
30246	52063	13	applied	\N	\N	\N	\N	155011	155011	102099
30246	52064	14	applied	\N	\N	\N	\N	155012	155012	102103
30246	52065	15	applied	\N	\N	\N	\N	155013	155013	102203
30246	52066	16	applied	\N	\N	\N	\N	155014	155014	155015
30246	52067	17	applied	\N	\N	\N	\N	155016	155016	155017
30246	52068	18	applied	\N	\N	\N	\N	155018	155018	102207
30251	52069	0	applied	\N	\N	\N	\N	155022	155022	155023
30251	52070	1	applied	\N	\N	\N	\N	155024	155024	155025
30251	52071	2	applied	\N	\N	\N	\N	155026	155026	102208
30251	52072	3	applied	\N	\N	\N	\N	155027	155027	102158
30251	52073	4	applied	\N	\N	\N	\N	155028	155028	102209
30251	52074	5	applied	\N	\N	1000000000	\N	155029	155029	155030
30251	52075	6	applied	\N	\N	\N	\N	155031	155031	155032
30251	52076	7	applied	\N	\N	\N	\N	155033	155033	102165
30251	52077	8	applied	\N	\N	\N	\N	155034	155034	155035
30251	52078	9	applied	\N	\N	\N	\N	155036	155036	102174
30251	52079	10	applied	\N	\N	\N	\N	155037	155037	155038
30257	52097	0	applied	\N	\N	\N	\N	155084	155084	155085
30257	52098	1	applied	\N	\N	\N	\N	155086	155086	155087
30257	52099	2	applied	\N	\N	\N	\N	155088	155088	102295
30257	52100	3	applied	\N	\N	\N	\N	155089	155089	102444
30257	52101	4	applied	\N	\N	\N	\N	155090	155090	155091
30257	52102	5	applied	\N	\N	\N	\N	155092	155092	102305
30257	52103	6	applied	\N	\N	\N	\N	155093	155093	102307
30257	52104	7	applied	\N	\N	\N	\N	155094	155094	102448
30257	52105	8	applied	\N	\N	\N	\N	155095	155095	155096
30257	52106	9	applied	\N	\N	\N	\N	155097	155097	102449
30257	52107	10	applied	\N	\N	\N	\N	155098	155098	155099
30257	52108	11	applied	\N	\N	\N	\N	155100	155100	155101
30257	52109	12	applied	\N	\N	\N	\N	155102	155102	102331
30257	52110	13	applied	\N	\N	\N	\N	155103	155103	155104
30257	52111	14	applied	\N	\N	\N	\N	155105	155105	155106
30257	52112	15	applied	\N	\N	\N	\N	155107	155107	155108
30257	52113	16	applied	\N	\N	\N	\N	155109	155109	155110
30257	52114	17	applied	\N	\N	\N	\N	155111	155111	102362
30260	52115	0	applied	\N	\N	\N	\N	155123	155123	155124
30260	52120	1	applied	\N	\N	\N	\N	155133	155133	155134
30262	52166	0	applied	\N	\N	\N	\N	155224	155224	155225
30262	52167	1	applied	\N	\N	\N	\N	155226	155226	155227
30262	52168	2	applied	\N	\N	\N	\N	155228	155228	155229
30262	52169	3	applied	\N	\N	\N	\N	155230	155230	102598
30262	52170	4	applied	\N	\N	\N	\N	155231	155231	155232
30262	52171	5	applied	\N	\N	\N	\N	155233	155233	102600
30262	52172	6	applied	\N	\N	\N	\N	155234	155234	155235
30262	52173	7	applied	\N	\N	\N	\N	155236	155236	155237
30262	52174	8	applied	\N	\N	\N	\N	155238	155238	102611
30262	52175	9	applied	\N	\N	\N	\N	155239	155239	102623
30262	52176	10	applied	\N	\N	\N	\N	155240	155240	155241
30262	52177	11	applied	\N	\N	\N	\N	155242	155242	102627
30262	52178	12	applied	\N	\N	\N	\N	155243	155243	155244
30262	52179	13	applied	\N	\N	\N	\N	155245	155245	155246
30262	52180	14	applied	\N	\N	\N	\N	155247	155247	102643
30262	52181	15	applied	\N	\N	\N	\N	155248	155248	102647
30262	52182	16	applied	\N	\N	\N	\N	155249	155249	155250
30262	52183	17	applied	\N	\N	\N	\N	155251	155251	102657
30262	52184	18	applied	\N	\N	\N	\N	155252	155252	155253
30262	52185	19	applied	\N	\N	\N	\N	155254	155254	155255
30268	52224	0	applied	\N	\N	\N	\N	155338	155338	155339
30268	52225	1	applied	\N	\N	\N	\N	155340	155340	155341
30268	52226	2	applied	\N	\N	1000000000	\N	155342	155342	155343
30268	52227	3	applied	\N	\N	\N	\N	155344	155344	102875
30268	52228	4	applied	\N	\N	\N	\N	155345	155345	103844
30268	52229	5	applied	\N	\N	\N	\N	155346	155346	155347
30268	52230	6	applied	\N	\N	\N	\N	155348	155348	103845
30268	52231	7	applied	\N	\N	\N	\N	155349	155349	155350
30268	52232	8	applied	\N	\N	\N	\N	155351	155351	102891
30268	52233	9	applied	\N	\N	\N	\N	155352	155352	103848
30268	52234	10	applied	\N	\N	\N	\N	155353	155353	103849
30268	52235	11	applied	\N	\N	\N	\N	155354	155354	102913
30268	52236	12	applied	\N	\N	\N	\N	155355	155355	102917
30268	52237	13	applied	\N	\N	\N	\N	155356	155356	102927
30268	52238	14	applied	\N	\N	\N	\N	155357	155357	155358
30268	52239	15	applied	\N	\N	\N	\N	155359	155359	155360
30268	52240	16	applied	\N	\N	\N	\N	155361	155361	102933
30268	52241	17	applied	\N	\N	\N	\N	155362	155362	155363
30268	52242	18	applied	\N	\N	\N	\N	155364	155364	155365
30268	52243	19	applied	\N	\N	\N	\N	155366	155366	102942
30270	52244	0	applied	\N	\N	\N	\N	155375	155375	155376
30270	52227	1	applied	\N	\N	\N	\N	155344	155344	103847
30270	52245	2	applied	\N	\N	\N	\N	155377	155377	102893
30270	52246	3	applied	\N	\N	\N	\N	155378	155378	155379
30270	52231	4	applied	\N	\N	\N	\N	155349	155349	102903
30270	52232	5	applied	\N	\N	\N	\N	155351	155351	103851
30270	52233	6	applied	\N	\N	\N	\N	155352	155352	102915
30270	52247	7	applied	\N	\N	\N	\N	155380	155380	105162
30270	52248	8	applied	\N	\N	\N	\N	155381	155381	155382
30270	52249	9	applied	\N	\N	\N	\N	155383	155383	155384
30270	52234	10	applied	\N	\N	\N	\N	155353	155353	102931
30245	52049	18	applied	\N	\N	\N	\N	154992	154992	102190
30249	52069	0	applied	\N	\N	\N	\N	155022	155022	155023
30249	52070	1	applied	\N	\N	\N	\N	155024	155024	155025
30249	52071	2	applied	\N	\N	\N	\N	155026	155026	102208
30249	52072	3	applied	\N	\N	\N	\N	155027	155027	102158
30249	52073	4	applied	\N	\N	\N	\N	155028	155028	102209
30249	52074	5	applied	\N	\N	1000000000	\N	155029	155029	155030
30249	52075	6	applied	\N	\N	\N	\N	155031	155031	155032
30249	52076	7	applied	\N	\N	\N	\N	155033	155033	102165
30249	52077	8	applied	\N	\N	\N	\N	155034	155034	155035
30249	52078	9	applied	\N	\N	\N	\N	155036	155036	102174
30249	52079	10	applied	\N	\N	\N	\N	155037	155037	155038
30253	52080	0	applied	\N	\N	\N	\N	155044	155044	155045
30253	52079	1	applied	\N	\N	\N	\N	155037	155037	102211
30253	52081	2	applied	\N	\N	\N	\N	155046	155046	102218
30253	52082	3	applied	\N	\N	\N	\N	155047	155047	102226
30253	52076	4	applied	\N	\N	\N	\N	155033	155033	155048
30253	52083	5	applied	\N	\N	\N	\N	155049	155049	102237
30253	52084	6	applied	\N	\N	\N	\N	155050	155050	102246
30253	52087	7	applied	\N	\N	\N	\N	155056	155056	102252
30253	52085	8	applied	\N	\N	\N	\N	155051	155051	155057
30253	52086	9	applied	\N	\N	\N	\N	155053	155053	155058
30258	52115	0	applied	\N	\N	\N	\N	155123	155123	155124
30258	52116	1	applied	\N	\N	\N	\N	155125	155125	155126
30258	52117	2	applied	\N	\N	\N	\N	155127	155127	155128
30258	52118	3	applied	\N	\N	\N	\N	155129	155129	155130
30258	52119	4	applied	\N	\N	\N	\N	155131	155131	155132
30258	52120	5	applied	\N	\N	\N	\N	155133	155133	155134
30258	52121	6	applied	\N	\N	\N	\N	155135	155135	155136
30258	52122	7	applied	\N	\N	\N	\N	155137	155137	155138
30258	52123	8	applied	\N	\N	\N	\N	155139	155139	102368
30258	52124	9	applied	\N	\N	\N	\N	155140	155140	155141
30258	52125	10	applied	\N	\N	\N	\N	155142	155142	102376
30258	52126	11	applied	\N	\N	\N	\N	155143	155143	155144
30258	52127	12	applied	\N	\N	\N	\N	155145	155145	155146
30258	52128	13	applied	\N	\N	\N	\N	155147	155147	102384
30258	52129	14	applied	\N	\N	\N	\N	155148	155148	155149
30258	52130	15	applied	\N	\N	\N	\N	155150	155150	155151
30258	52131	16	applied	\N	\N	\N	\N	155152	155152	102410
30258	52132	17	applied	\N	\N	\N	\N	155153	155153	155154
30258	52133	18	applied	\N	\N	\N	\N	155155	155155	102412
30258	52134	19	applied	\N	\N	\N	\N	155156	155156	155157
30258	52135	20	applied	\N	\N	\N	\N	155158	155158	155159
30258	52136	21	applied	\N	\N	\N	\N	155160	155160	102422
30258	52137	22	applied	\N	\N	\N	\N	155161	155161	155162
30258	52138	23	applied	\N	\N	\N	\N	155163	155163	155164
30258	52139	24	applied	\N	\N	\N	\N	155165	155165	155166
30258	52140	25	applied	\N	\N	\N	\N	155167	155167	155168
30258	52141	26	applied	\N	\N	\N	\N	155169	155169	102477
30258	52142	27	applied	\N	\N	\N	\N	155170	155170	102488
30258	52143	28	applied	\N	\N	\N	\N	155171	155171	102492
30258	52144	29	applied	\N	\N	\N	\N	155172	155172	155173
30258	52145	30	applied	\N	\N	\N	\N	155174	155174	102498
30258	52146	31	applied	\N	\N	\N	\N	155175	155175	155176
30258	52147	32	applied	\N	\N	\N	\N	155177	155177	102512
30258	52148	33	applied	\N	\N	\N	\N	155178	155178	155179
30258	52149	34	applied	\N	\N	\N	\N	155180	155180	102526
30258	52150	35	applied	\N	\N	\N	\N	155181	155181	155182
30258	52151	36	applied	\N	\N	\N	\N	155183	155183	155184
30258	52152	37	applied	\N	\N	\N	\N	155185	155185	102540
30258	52153	38	applied	\N	\N	\N	\N	155186	155186	102542
30258	52154	39	applied	\N	\N	\N	\N	155187	155187	102552
30258	52155	40	applied	\N	\N	\N	\N	155188	155188	155189
30259	52115	0	applied	\N	\N	\N	\N	155123	155123	155124
30259	52116	1	applied	\N	\N	\N	\N	155125	155125	155126
30259	52117	2	applied	\N	\N	\N	\N	155127	155127	155128
30259	52118	3	applied	\N	\N	\N	\N	155129	155129	155130
30259	52119	4	applied	\N	\N	\N	\N	155131	155131	155132
30259	52120	5	applied	\N	\N	\N	\N	155133	155133	155134
30259	52121	6	applied	\N	\N	\N	\N	155135	155135	155136
30259	52122	7	applied	\N	\N	\N	\N	155137	155137	155138
30259	52123	8	applied	\N	\N	\N	\N	155139	155139	102368
30259	52124	9	applied	\N	\N	\N	\N	155140	155140	155141
30259	52125	10	applied	\N	\N	\N	\N	155142	155142	102376
30259	52126	11	applied	\N	\N	\N	\N	155143	155143	155144
30259	52127	12	applied	\N	\N	\N	\N	155145	155145	155146
30259	52128	13	applied	\N	\N	\N	\N	155147	155147	102384
30259	52129	14	applied	\N	\N	\N	\N	155148	155148	155149
30259	52130	15	applied	\N	\N	\N	\N	155150	155150	155151
30259	52131	16	applied	\N	\N	\N	\N	155152	155152	102410
30259	52132	17	applied	\N	\N	\N	\N	155153	155153	155154
30259	52133	18	applied	\N	\N	\N	\N	155155	155155	102412
30259	52134	19	applied	\N	\N	\N	\N	155156	155156	155157
30259	52135	20	applied	\N	\N	\N	\N	155158	155158	155159
30259	52136	21	applied	\N	\N	\N	\N	155160	155160	102422
30259	52137	22	applied	\N	\N	\N	\N	155161	155161	155162
30259	52138	23	applied	\N	\N	\N	\N	155163	155163	155164
30259	52139	24	applied	\N	\N	\N	\N	155165	155165	155166
30259	52140	25	applied	\N	\N	\N	\N	155167	155167	155168
30259	52141	26	applied	\N	\N	\N	\N	155169	155169	102477
30259	52142	27	applied	\N	\N	\N	\N	155170	155170	102488
30259	52143	28	applied	\N	\N	\N	\N	155171	155171	102492
30259	52144	29	applied	\N	\N	\N	\N	155172	155172	155173
30259	52145	30	applied	\N	\N	\N	\N	155174	155174	102498
30259	52146	31	applied	\N	\N	\N	\N	155175	155175	155176
30259	52147	32	applied	\N	\N	\N	\N	155177	155177	102512
30259	52148	33	applied	\N	\N	\N	\N	155178	155178	155179
30259	52149	34	applied	\N	\N	\N	\N	155180	155180	102526
30259	52150	35	applied	\N	\N	\N	\N	155181	155181	155182
30259	52151	36	applied	\N	\N	\N	\N	155183	155183	155184
30259	52152	37	applied	\N	\N	\N	\N	155185	155185	102540
30259	52153	38	applied	\N	\N	\N	\N	155186	155186	102542
30259	52154	39	applied	\N	\N	\N	\N	155187	155187	102552
30259	52155	40	applied	\N	\N	\N	\N	155188	155188	155189
30264	52186	0	applied	\N	\N	\N	\N	155259	155259	155260
30264	52187	1	applied	\N	\N	\N	\N	155261	155261	102686
30264	52188	2	applied	\N	\N	\N	\N	155262	155262	155263
30264	52189	3	applied	\N	\N	\N	\N	155264	155264	102677
30264	52190	4	applied	\N	\N	\N	\N	155265	155265	155266
30273	52265	0	applied	\N	\N	\N	\N	155415	155415	155416
30273	52266	1	applied	\N	\N	\N	\N	155417	155417	155418
30273	52267	2	applied	\N	\N	\N	\N	155419	155419	155420
30273	52268	3	applied	\N	\N	\N	\N	155421	155421	155422
30273	52269	4	applied	\N	\N	1000000000	\N	155423	155423	155424
30273	52270	5	applied	\N	\N	\N	\N	155425	155425	103041
30273	52271	6	applied	\N	\N	\N	\N	155426	155426	155427
30273	52272	7	applied	\N	\N	\N	\N	155428	155428	103047
30273	52273	8	applied	\N	\N	\N	\N	155429	155429	155430
30273	52274	9	applied	\N	\N	\N	\N	155431	155431	103049
30255	52097	0	applied	\N	\N	\N	\N	155084	155084	155085
30255	52098	1	applied	\N	\N	\N	\N	155086	155086	155087
30255	52099	2	applied	\N	\N	\N	\N	155088	155088	102295
30255	52100	3	applied	\N	\N	\N	\N	155089	155089	102444
30255	52101	4	applied	\N	\N	\N	\N	155090	155090	155091
30255	52102	5	applied	\N	\N	\N	\N	155092	155092	102305
30255	52103	6	applied	\N	\N	\N	\N	155093	155093	102307
30255	52104	7	applied	\N	\N	\N	\N	155094	155094	102448
30255	52105	8	applied	\N	\N	\N	\N	155095	155095	155096
30255	52106	9	applied	\N	\N	\N	\N	155097	155097	102449
30255	52107	10	applied	\N	\N	\N	\N	155098	155098	155099
30255	52108	11	applied	\N	\N	\N	\N	155100	155100	155101
30255	52109	12	applied	\N	\N	\N	\N	155102	155102	102331
30255	52110	13	applied	\N	\N	\N	\N	155103	155103	155104
30255	52111	14	applied	\N	\N	\N	\N	155105	155105	155106
30255	52112	15	applied	\N	\N	\N	\N	155107	155107	155108
30255	52113	16	applied	\N	\N	\N	\N	155109	155109	155110
30255	52114	17	applied	\N	\N	\N	\N	155111	155111	102362
30266	52195	0	applied	\N	\N	\N	\N	155275	155275	155276
30266	52196	1	applied	\N	\N	\N	\N	155277	155277	155278
30266	52197	2	applied	\N	\N	\N	\N	155279	155279	155280
30266	52198	3	applied	\N	\N	\N	\N	155281	155281	102679
30266	52199	4	applied	\N	\N	\N	\N	155282	155282	102695
30266	52200	5	applied	\N	\N	\N	\N	155283	155283	102697
30266	52201	6	applied	\N	\N	\N	\N	155284	155284	155285
30266	52202	7	applied	\N	\N	\N	\N	155286	155286	155271
30266	52203	8	applied	\N	\N	\N	\N	155287	155287	102705
30266	52191	9	applied	\N	\N	\N	\N	155269	155269	155288
30266	52192	10	applied	\N	\N	\N	\N	155270	155270	155289
30266	52193	11	applied	\N	\N	\N	\N	155272	155272	155290
30266	52194	12	applied	\N	\N	\N	\N	155273	155273	102727
30266	52204	13	applied	\N	\N	\N	\N	155291	155291	155292
30266	52205	15	applied	\N	\N	\N	\N	155294	155294	155295
30266	52206	16	applied	\N	\N	\N	\N	155296	155296	155297
30266	52207	17	applied	\N	\N	\N	\N	155298	155298	102752
30266	52208	18	applied	\N	\N	\N	\N	155299	155299	155300
30266	52209	19	applied	\N	\N	\N	\N	155301	155301	155302
30266	52210	20	applied	\N	\N	\N	\N	155303	155303	102758
30266	52211	21	applied	\N	\N	\N	\N	155304	155304	155305
30266	52212	22	applied	\N	\N	\N	\N	155306	155306	102779
30266	52213	23	applied	\N	\N	\N	\N	155307	155307	155308
30266	52214	24	applied	\N	\N	\N	\N	155309	155309	102794
30266	52215	25	applied	\N	\N	\N	\N	155310	155310	155311
30266	52216	26	applied	\N	\N	\N	\N	155312	155312	102816
30266	52217	27	applied	\N	\N	\N	\N	155313	155313	102818
30266	52218	28	applied	\N	\N	\N	\N	155314	155314	155315
30266	52219	29	applied	\N	\N	\N	\N	155316	155316	102834
30266	52220	30	applied	\N	\N	\N	\N	155317	155317	102836
30266	52221	31	applied	\N	\N	\N	\N	155318	155318	155319
30266	52222	32	applied	\N	\N	\N	\N	155320	155320	102860
30266	52223	33	applied	\N	\N	\N	\N	155321	155321	155322
30269	52224	0	applied	\N	\N	\N	\N	155338	155338	155339
30269	52225	1	applied	\N	\N	\N	\N	155340	155340	155341
30269	52226	2	applied	\N	\N	1000000000	\N	155342	155342	155343
30269	52228	3	applied	\N	\N	\N	\N	155345	155345	102867
30269	52229	4	applied	\N	\N	\N	\N	155346	155346	102869
30269	52230	5	applied	\N	\N	\N	\N	155348	155348	102875
30269	52239	6	applied	\N	\N	\N	\N	155359	155359	155347
30269	52240	7	applied	\N	\N	\N	\N	155361	155361	103845
30269	52241	8	applied	\N	\N	\N	\N	155362	155362	102885
30269	52242	9	applied	\N	\N	\N	\N	155364	155364	155350
30269	52243	10	applied	\N	\N	\N	\N	155366	155366	102887
30271	52254	0	applied	\N	\N	\N	\N	155396	155396	155397
30271	52255	1	applied	\N	\N	\N	\N	155398	155398	155399
30271	52256	2	applied	\N	\N	\N	\N	155400	155400	102997
30271	52257	3	applied	\N	\N	\N	\N	155401	155401	103005
30271	52258	4	applied	\N	\N	\N	\N	155402	155402	103015
30271	52259	5	applied	\N	\N	\N	\N	155403	155403	155404
30271	52260	6	applied	\N	\N	\N	\N	155405	155405	155406
30271	52261	7	applied	\N	\N	\N	\N	155407	155407	103026
30271	52262	8	applied	\N	\N	\N	\N	155408	155408	155409
30271	52263	9	applied	\N	\N	\N	\N	155410	155410	155411
30271	52264	10	applied	\N	\N	\N	\N	155412	155412	103039
30275	52304	0	applied	\N	\N	\N	\N	155481	155481	155482
30275	52305	1	applied	\N	\N	\N	\N	155483	155483	155460
30275	52306	2	applied	\N	\N	\N	\N	155484	155484	155485
30275	52307	3	applied	\N	\N	\N	\N	155486	155486	103098
30288	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30288	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30288	52356	2	applied	\N	\N	\N	\N	155608	155608	155609
30288	52357	3	applied	\N	\N	\N	\N	155610	155610	103527
30288	52358	4	applied	\N	\N	\N	\N	155611	155611	155612
30295	52367	0	applied	\N	\N	\N	\N	155637	155637	155638
30295	52368	1	applied	\N	\N	\N	\N	155639	155639	155640
30295	52369	2	applied	\N	\N	\N	\N	155641	155641	103587
30295	52370	3	applied	\N	\N	\N	\N	155642	155642	155643
30295	52371	4	applied	\N	\N	\N	\N	155644	155644	103600
30295	52372	5	applied	\N	\N	\N	\N	155645	155645	155646
30295	52373	6	applied	\N	\N	\N	\N	155647	155647	155648
30301	52374	0	applied	\N	\N	\N	\N	155656	155656	155656
30301	52377	1	applied	\N	\N	\N	\N	155662	155662	155662
30301	52378	2	applied	\N	\N	\N	\N	155663	155663	155663
30301	52375	3	applied	\N	\N	\N	\N	155657	155657	155658
30301	52368	4	applied	\N	\N	\N	\N	155639	155639	103619
30301	52369	5	applied	\N	\N	\N	\N	155641	155641	155648
30301	52376	6	applied	\N	\N	\N	\N	155659	155659	155660
30301	52379	7	applied	\N	\N	\N	\N	155664	155664	103623
30301	52380	8	applied	\N	\N	\N	\N	155665	155665	155666
30301	52381	9	applied	\N	\N	\N	\N	155667	155667	103635
30304	52389	0	applied	\N	\N	\N	\N	155686	155686	155687
30304	52390	1	applied	\N	\N	\N	\N	155688	155688	155689
30304	52391	2	applied	\N	\N	\N	\N	155690	155690	155691
30304	52392	3	applied	\N	\N	\N	\N	155692	155692	103957
30304	52393	4	applied	\N	\N	\N	\N	155693	155693	103959
30304	52394	5	applied	\N	\N	\N	\N	155694	155694	155695
30304	52395	6	applied	\N	\N	\N	\N	155696	155696	103962
30306	52382	0	applied	\N	\N	\N	\N	155671	155671	155672
30306	52389	1	applied	\N	\N	\N	\N	155686	155686	155687
30306	52390	2	applied	\N	\N	\N	\N	155688	155688	155689
30306	52391	3	applied	\N	\N	\N	\N	155690	155690	103641
30306	52392	4	applied	\N	\N	\N	\N	155692	155692	155699
30306	52383	5	applied	\N	\N	\N	\N	155673	155673	103643
30306	52394	6	applied	\N	\N	\N	\N	155694	155694	155695
30306	52385	7	applied	\N	\N	\N	\N	155676	155676	155677
30309	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30309	52397	1	applied	\N	\N	\N	\N	155703	155703	103963
30310	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30310	52397	1	applied	\N	\N	\N	\N	155703	155703	103963
30315	52398	0	applied	\N	\N	\N	\N	155713	155713	155714
30315	52399	1	applied	\N	\N	\N	\N	155715	155715	61342
30261	52134	19	applied	\N	\N	\N	\N	155156	155156	102420
30261	52135	20	applied	\N	\N	\N	\N	155158	155158	155198
30261	52136	21	applied	\N	\N	\N	\N	155160	155160	155199
30261	52137	22	applied	\N	\N	\N	\N	155161	155161	102435
30261	52138	23	applied	\N	\N	\N	\N	155163	155163	102437
30261	52139	24	applied	\N	\N	\N	\N	155165	155165	155200
30261	52140	25	applied	\N	\N	\N	\N	155167	155167	155201
30261	52141	26	applied	\N	\N	\N	\N	155169	155169	102486
30261	52142	27	applied	\N	\N	\N	\N	155170	155170	155202
30261	52143	28	applied	\N	\N	\N	\N	155171	155171	155203
30261	52144	29	applied	\N	\N	\N	\N	155172	155172	102496
30261	52145	30	applied	\N	\N	\N	\N	155174	155174	155204
30261	52146	31	applied	\N	\N	\N	\N	155175	155175	102510
30261	52147	32	applied	\N	\N	\N	\N	155177	155177	155205
30261	52148	33	applied	\N	\N	\N	\N	155178	155178	102522
30261	52149	34	applied	\N	\N	\N	\N	155180	155180	155206
30261	52150	35	applied	\N	\N	\N	\N	155181	155181	102534
30261	52158	36	applied	\N	\N	\N	\N	155207	155207	155208
30261	52159	37	applied	\N	\N	\N	\N	155209	155209	102554
30261	52160	38	applied	\N	\N	\N	\N	155210	155210	155211
30261	52161	39	applied	\N	\N	\N	\N	155212	155212	102564
30261	52162	40	applied	\N	\N	\N	\N	155213	155213	155214
30261	52151	41	applied	\N	\N	\N	\N	155183	155183	102580
30261	52152	42	applied	\N	\N	\N	\N	155185	155185	155215
30261	52153	43	applied	\N	\N	\N	\N	155186	155186	155216
30261	52163	44	applied	\N	\N	\N	\N	155217	155217	102584
30261	52154	45	applied	\N	\N	\N	\N	155187	155187	102586
30261	52155	46	applied	\N	\N	\N	\N	155188	155188	155218
30261	52164	47	applied	\N	\N	\N	\N	155219	155219	155220
30261	52165	48	applied	\N	\N	\N	\N	155221	155221	102596
30263	52166	0	applied	\N	\N	\N	\N	155224	155224	155225
30265	52186	0	applied	\N	\N	\N	\N	155259	155259	155260
30265	52187	1	applied	\N	\N	\N	\N	155261	155261	102686
30265	52188	2	applied	\N	\N	\N	\N	155262	155262	155263
30265	52189	3	applied	\N	\N	\N	\N	155264	155264	102677
30265	52190	4	applied	\N	\N	\N	\N	155265	155265	155266
30265	52191	5	applied	\N	\N	\N	\N	155269	155269	102697
30265	52192	6	applied	\N	\N	\N	\N	155270	155270	155271
30265	52193	7	applied	\N	\N	\N	\N	155272	155272	102707
30265	52194	8	applied	\N	\N	\N	\N	155273	155273	102715
30267	52115	0	applied	\N	\N	\N	\N	155123	155123	155124
30267	52030	1	applied	\N	\N	\N	\N	154966	154966	154967
30267	52166	2	applied	\N	\N	\N	\N	155224	155224	155225
30267	51365	3	applied	\N	\N	1000000000	\N	153552	153552	153553
30267	51788	4	applied	\N	\N	\N	\N	154343	154343	154344
30267	51245	5	applied	\N	\N	\N	\N	153297	153297	153298
30267	51254	6	applied	\N	\N	\N	\N	153314	153314	153315
30267	51255	7	applied	\N	\N	\N	\N	153316	153316	153317
30267	51256	8	applied	\N	\N	\N	\N	153318	153318	153319
30267	51282	9	applied	\N	\N	\N	\N	153362	153362	153363
30267	51291	10	applied	\N	\N	\N	\N	153385	153385	153386
30267	51300	11	applied	\N	\N	\N	\N	153402	153402	153403
30267	51309	12	applied	\N	\N	\N	\N	153422	153422	153423
30267	51310	13	applied	\N	\N	\N	\N	153424	153424	153425
30267	51328	14	applied	\N	\N	\N	\N	153477	153477	153478
30267	51337	15	applied	\N	\N	\N	\N	153500	153500	153501
30267	51338	16	applied	\N	\N	\N	\N	153502	153502	153503
30267	51339	17	applied	\N	\N	\N	\N	153504	153504	153505
30267	51366	18	applied	\N	\N	\N	\N	153554	153554	153555
30267	51367	19	applied	\N	\N	\N	\N	153556	153556	153557
30267	51392	20	applied	\N	\N	\N	\N	153625	153625	153626
30267	51396	21	applied	\N	\N	\N	\N	153637	153637	153638
30267	51397	22	applied	\N	\N	\N	\N	153639	153639	153640
30267	51415	23	applied	\N	\N	\N	\N	153670	153670	153671
30267	51416	24	applied	\N	\N	\N	\N	153672	153672	153673
30267	51417	25	applied	\N	\N	\N	\N	153674	153674	153675
30267	51443	26	applied	\N	\N	\N	\N	153708	153708	153709
30267	51444	27	applied	\N	\N	\N	\N	153710	153710	153711
30267	51463	28	applied	\N	\N	\N	\N	153739	153739	153740
30267	51482	29	applied	\N	\N	\N	\N	153777	153777	153778
30267	51490	30	applied	\N	\N	\N	\N	153789	153789	153790
30267	51501	31	applied	\N	\N	\N	\N	153816	153816	153817
30267	51508	32	applied	\N	\N	\N	\N	153828	153828	153829
30267	51518	33	applied	\N	\N	\N	\N	153844	153844	153845
30267	51527	34	applied	\N	\N	\N	\N	153869	153869	153870
30267	51536	35	applied	\N	\N	\N	\N	153884	153884	153885
30267	51546	36	applied	\N	\N	\N	\N	153903	153903	153904
30267	51554	37	applied	\N	\N	\N	\N	153922	153922	153923
30267	51564	38	applied	\N	\N	\N	\N	153939	153939	153940
30267	51565	39	applied	\N	\N	\N	\N	153941	153941	153942
30267	51566	40	applied	\N	\N	\N	\N	153943	153943	153944
30267	51567	41	applied	\N	\N	\N	\N	153945	153945	153946
30267	51568	42	applied	\N	\N	\N	\N	153947	153947	153948
30267	51614	43	applied	\N	\N	\N	\N	154009	154009	154010
30267	51623	44	applied	\N	\N	\N	\N	154026	154026	154027
30267	51631	45	applied	\N	\N	\N	\N	154040	154040	154041
30267	51639	46	applied	\N	\N	\N	\N	154049	154049	154050
30267	51650	47	applied	\N	\N	\N	\N	154065	154065	154066
30267	51651	48	applied	\N	\N	\N	\N	154067	154067	154068
30267	51652	49	applied	\N	\N	\N	\N	154069	154069	154070
30267	51653	50	applied	\N	\N	\N	\N	154071	154071	154072
30267	51689	51	applied	\N	\N	\N	\N	154131	154131	154132
30267	51698	52	applied	\N	\N	\N	\N	154155	154155	154156
30267	51706	53	applied	\N	\N	\N	\N	154169	154169	154170
30267	51715	54	applied	\N	\N	\N	\N	154186	154186	154187
30267	51725	55	applied	\N	\N	\N	\N	154209	154209	154210
30267	51726	56	applied	\N	\N	\N	\N	154211	154211	154212
30267	51744	57	applied	\N	\N	\N	\N	154241	154241	154242
30267	51752	58	applied	\N	\N	\N	\N	154256	154256	154257
30267	51761	59	applied	\N	\N	\N	\N	154283	154283	154284
30267	51768	60	applied	\N	\N	\N	\N	154294	154294	154295
30267	51769	61	applied	\N	\N	\N	\N	154296	154296	154297
30267	51789	62	applied	\N	\N	\N	\N	154345	154345	154346
30267	51831	63	applied	\N	\N	\N	\N	154426	154426	154427
30267	51848	64	applied	\N	\N	\N	\N	154459	154459	154460
30267	51849	65	applied	\N	\N	\N	\N	154461	154461	154462
30267	51869	66	applied	\N	\N	\N	\N	154496	154496	154497
30267	51880	67	applied	\N	\N	\N	\N	154548	154548	154549
30267	51881	68	applied	\N	\N	\N	\N	154550	154550	154551
30267	51904	69	applied	\N	\N	\N	\N	154612	154612	154613
30267	51913	70	applied	\N	\N	\N	\N	154644	154644	154645
30267	51922	71	applied	\N	\N	\N	\N	154661	154661	154662
30267	51930	72	applied	\N	\N	\N	\N	154785	154785	154786
30267	51939	73	applied	\N	\N	\N	\N	154800	154800	154801
30267	51950	74	applied	\N	\N	\N	\N	154824	154824	154825
30267	51951	75	applied	\N	\N	\N	\N	154826	154826	154827
30267	51952	76	applied	\N	\N	\N	\N	154828	154828	154829
30267	51977	77	applied	\N	\N	\N	\N	154867	154867	154868
30267	51987	78	applied	\N	\N	\N	\N	154893	154893	154894
30267	51988	79	applied	\N	\N	\N	\N	154895	154895	154896
30267	52005	80	applied	\N	\N	\N	\N	154927	154927	154928
30267	52013	81	applied	\N	\N	\N	\N	154944	154944	154945
30267	52023	82	applied	\N	\N	\N	\N	154956	154956	154957
30267	52031	83	applied	\N	\N	\N	\N	154970	154970	154971
30267	52032	84	applied	\N	\N	\N	\N	154972	154972	154973
30267	52050	85	applied	\N	\N	\N	\N	154995	154995	154996
30267	52051	86	applied	\N	\N	\N	\N	154997	154997	154998
30267	52069	87	applied	\N	\N	\N	\N	155022	155022	155023
30267	52080	88	applied	\N	\N	\N	\N	155044	155044	155045
30267	52088	89	applied	\N	\N	\N	\N	155061	155061	155062
30267	52097	90	applied	\N	\N	\N	\N	155084	155084	155085
30267	52098	91	applied	\N	\N	\N	\N	155086	155086	155087
30267	52116	92	applied	\N	\N	\N	\N	155125	155125	155126
30267	52117	93	applied	\N	\N	\N	\N	155127	155127	155128
30267	52118	94	applied	\N	\N	\N	\N	155129	155129	155130
30267	52119	95	applied	\N	\N	\N	\N	155131	155131	155132
30267	52156	96	applied	\N	\N	\N	\N	155194	155194	155195
30267	52167	97	applied	\N	\N	\N	\N	155226	155226	155227
30267	52168	98	applied	\N	\N	\N	\N	155228	155228	155229
30267	52186	99	applied	\N	\N	\N	\N	155259	155259	155260
30267	52195	100	applied	\N	\N	\N	\N	155275	155275	155276
30267	52196	101	applied	\N	\N	\N	\N	155277	155277	155278
30267	52197	102	applied	\N	\N	\N	\N	155279	155279	155280
30267	51398	103	applied	\N	\N	\N	\N	153641	153641	111296
30267	51719	104	applied	\N	\N	1000000000	\N	154192	154192	154193
30267	51798	105	applied	\N	\N	\N	\N	154368	154368	154369
30267	51799	106	applied	\N	\N	\N	\N	154370	154370	154371
30267	51847	107	applied	\N	\N	\N	\N	154457	154457	154458
30267	51868	108	applied	\N	\N	\N	\N	154494	154494	154495
30267	51246	109	applied	\N	\N	\N	\N	153299	153299	153300
30267	51807	110	failed	Amount_insufficient_to_create_account	\N	\N	\N	154380	154380	\N
30267	51874	111	applied	\N	\N	1000000000	\N	154505	154505	154506
30267	51884	112	applied	\N	\N	1000000000	\N	154560	154560	154561
30267	51885	113	applied	\N	\N	1000000000	\N	154562	154562	154563
30267	51886	114	applied	\N	\N	1000000000	\N	154564	154564	154565
30267	51247	116	applied	\N	\N	\N	\N	153301	153301	98012
30267	51248	117	applied	\N	\N	\N	\N	153302	153302	153303
30267	51249	118	applied	\N	\N	\N	\N	153304	153304	98023
30267	51250	119	applied	\N	\N	\N	\N	153305	153305	153306
30267	52074	120	applied	\N	\N	1000000000	\N	155029	155029	155030
30267	52075	121	applied	\N	\N	\N	\N	155031	155031	155032
30267	51394	122	applied	\N	\N	\N	\N	153628	153628	153628
30267	51520	123	applied	\N	\N	1000000000	\N	153847	153847	153848
30272	52254	0	applied	\N	\N	\N	\N	155396	155396	155397
30272	52255	1	applied	\N	\N	\N	\N	155398	155398	155399
30272	52256	2	applied	\N	\N	\N	\N	155400	155400	102997
30272	52257	3	applied	\N	\N	\N	\N	155401	155401	103005
30272	52258	4	applied	\N	\N	\N	\N	155402	155402	103015
30272	52259	5	applied	\N	\N	\N	\N	155403	155403	155404
30272	52260	6	applied	\N	\N	\N	\N	155405	155405	155406
30272	52261	7	applied	\N	\N	\N	\N	155407	155407	103026
30272	52262	8	applied	\N	\N	\N	\N	155408	155408	155409
30272	52263	9	applied	\N	\N	\N	\N	155410	155410	155411
30272	52264	10	applied	\N	\N	\N	\N	155412	155412	103039
30276	52308	0	applied	\N	\N	\N	\N	155487	155487	155488
30276	52309	1	applied	\N	\N	\N	\N	155489	155489	155490
30276	52310	2	applied	\N	\N	\N	\N	155491	155491	155492
30276	52287	3	applied	\N	\N	\N	\N	155451	155451	103106
30276	52288	4	applied	\N	\N	\N	\N	155452	155452	155493
30276	52289	5	applied	\N	\N	\N	\N	155454	155454	103161
30276	52311	6	applied	\N	\N	\N	\N	155494	155494	103163
30276	52312	7	applied	\N	\N	\N	\N	155495	155495	103171
30276	52313	8	applied	\N	\N	\N	\N	155496	155496	103369
30276	52290	9	applied	\N	\N	\N	\N	155456	155456	103371
30276	52291	10	applied	\N	\N	\N	\N	155459	155459	103372
30276	52292	11	applied	\N	\N	\N	\N	155461	155461	103192
30276	52293	12	applied	\N	\N	\N	\N	155462	155462	155471
30276	52294	13	applied	\N	\N	\N	\N	155463	155463	155473
30276	52295	14	applied	\N	\N	\N	\N	155465	155465	155474
30276	52296	15	applied	\N	\N	\N	\N	155467	155467	103246
30276	52297	16	applied	\N	\N	\N	\N	155468	155468	103380
30276	52298	17	applied	\N	\N	\N	\N	155469	155469	155497
30276	52299	18	applied	\N	\N	\N	\N	155470	155470	155498
30276	52300	19	applied	\N	\N	\N	\N	155475	155475	155499
30276	52301	20	applied	\N	\N	\N	\N	155476	155476	155500
30276	52302	21	applied	\N	\N	\N	\N	155477	155477	103282
30276	52303	22	applied	\N	\N	\N	\N	155479	155479	103388
30276	52314	23	applied	\N	\N	\N	\N	155501	155501	155502
30276	52315	25	applied	\N	\N	\N	\N	155504	155504	155505
30276	52316	26	applied	\N	\N	\N	\N	155506	155506	103389
30276	52317	27	applied	\N	\N	\N	\N	155507	155507	155508
30276	52318	28	applied	\N	\N	\N	\N	155509	155509	103312
30276	52319	29	applied	\N	\N	\N	\N	155510	155510	103391
30276	52320	30	applied	\N	\N	\N	\N	155511	155511	155512
30276	52321	31	applied	\N	\N	\N	\N	155513	155513	155514
30276	52322	32	applied	\N	\N	\N	\N	155515	155515	103326
30278	52334	0	applied	\N	\N	\N	\N	155555	155555	155556
30278	52335	1	applied	\N	\N	\N	\N	155557	155557	103410
30278	52336	2	applied	\N	\N	\N	\N	155558	155558	103418
30278	52337	3	applied	\N	\N	1000000000	\N	155559	155559	155560
30278	52338	4	applied	\N	\N	\N	\N	155561	155561	155562
30278	52339	5	applied	\N	\N	\N	\N	155563	155563	155564
30278	52340	6	applied	\N	\N	\N	\N	155565	155565	155566
30278	52341	7	applied	\N	\N	\N	\N	155567	155567	103437
30280	52115	0	applied	\N	\N	\N	\N	155123	155123	155124
30280	52030	1	applied	\N	\N	\N	\N	154966	154966	154967
30280	52166	2	applied	\N	\N	\N	\N	155224	155224	155225
30280	52120	3	applied	\N	\N	\N	\N	155133	155133	155134
30280	52226	4	applied	\N	\N	1000000000	\N	155342	155342	155343
30280	52269	5	applied	\N	\N	1000000000	\N	155423	155423	155424
30280	52255	6	applied	\N	\N	\N	\N	155398	155398	155399
30280	52074	7	applied	\N	\N	1000000000	\N	155029	155029	155030
30280	52075	8	applied	\N	\N	\N	\N	155031	155031	155032
30280	52331	9	applied	\N	\N	\N	\N	155538	155538	155539
30280	52337	10	applied	\N	\N	1000000000	\N	155559	155559	155560
30282	52342	0	applied	\N	\N	\N	\N	155573	155573	155574
30282	52343	1	applied	\N	\N	\N	\N	155575	155575	155576
30282	52344	2	applied	\N	\N	\N	\N	155577	155577	103450
30282	52345	3	applied	\N	\N	\N	\N	155578	155578	155579
30282	52346	4	applied	\N	\N	\N	\N	155580	155580	155581
30289	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30289	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30289	52359	2	applied	\N	\N	\N	\N	155615	155615	155616
30289	52356	3	applied	\N	\N	\N	\N	155608	155608	103535
30289	52360	4	applied	\N	\N	\N	\N	155617	155617	155618
30289	52357	5	applied	\N	\N	\N	\N	155610	155610	103541
30289	52358	6	applied	\N	\N	\N	\N	155611	155611	155619
30289	52361	7	applied	\N	\N	\N	\N	155620	155620	155621
30270	52235	11	applied	\N	\N	\N	\N	155354	155354	155385
30270	52236	12	applied	\N	\N	\N	\N	155355	155355	102942
30270	52237	13	applied	\N	\N	\N	\N	155356	155356	155386
30270	52238	14	applied	\N	\N	\N	\N	155357	155357	155387
30270	52250	15	applied	\N	\N	\N	\N	155388	155388	155389
30270	52251	16	applied	\N	\N	\N	\N	155390	155390	102965
30270	52252	17	applied	\N	\N	\N	\N	155391	155391	102993
30270	52253	18	applied	\N	\N	\N	\N	155392	155392	155393
30274	52265	0	applied	\N	\N	\N	\N	155415	155415	155416
30274	52266	1	applied	\N	\N	\N	\N	155417	155417	155418
30274	52267	2	applied	\N	\N	\N	\N	155419	155419	155420
30274	52268	3	applied	\N	\N	\N	\N	155421	155421	155422
30274	52269	4	applied	\N	\N	1000000000	\N	155423	155423	155424
30274	52270	5	applied	\N	\N	\N	\N	155425	155425	103041
30274	52271	6	applied	\N	\N	\N	\N	155426	155426	155427
30274	52287	7	applied	\N	\N	\N	\N	155451	155451	103051
30274	52288	8	applied	\N	\N	\N	\N	155452	155452	103062
30274	52272	9	applied	\N	\N	\N	\N	155428	155428	155453
30274	52289	10	applied	\N	\N	\N	\N	155454	155454	155455
30274	52290	11	applied	\N	\N	\N	\N	155456	155456	155457
30274	52273	12	applied	\N	\N	\N	\N	155429	155429	155444
30274	52274	13	applied	\N	\N	\N	\N	155431	155431	103076
30274	52275	14	applied	\N	\N	\N	\N	155432	155432	103078
30274	52276	15	applied	\N	\N	\N	\N	155433	155433	155458
30274	52277	16	applied	\N	\N	\N	\N	155435	155435	155447
30274	52291	17	applied	\N	\N	\N	\N	155459	155459	155460
30274	52292	18	applied	\N	\N	\N	\N	155461	155461	103098
30274	52293	19	applied	\N	\N	\N	\N	155462	155462	103104
30274	52294	20	applied	\N	\N	\N	\N	155463	155463	155464
30274	52295	21	applied	\N	\N	\N	\N	155465	155465	155466
30274	52296	22	applied	\N	\N	\N	\N	155467	155467	103163
30274	52297	23	applied	\N	\N	\N	\N	155468	155468	103369
30274	52298	24	applied	\N	\N	\N	\N	155469	155469	103371
30274	52299	25	applied	\N	\N	\N	\N	155470	155470	103372
30274	52278	26	applied	\N	\N	\N	\N	155436	155436	103190
30274	52279	27	applied	\N	\N	\N	\N	155437	155437	103192
30274	52280	28	applied	\N	\N	\N	\N	155439	155439	103200
30274	52281	29	applied	\N	\N	\N	\N	155441	155441	155471
30274	52282	30	applied	\N	\N	\N	\N	155442	155442	155472
30274	52283	31	applied	\N	\N	\N	\N	155443	155443	155473
30274	52284	32	applied	\N	\N	\N	\N	155445	155445	103209
30274	52285	33	applied	\N	\N	\N	\N	155446	155446	155474
30274	52286	34	applied	\N	\N	\N	\N	155448	155448	103244
30274	52300	35	applied	\N	\N	\N	\N	155475	155475	103248
30274	52301	36	applied	\N	\N	\N	\N	155476	155476	103252
30274	52302	37	applied	\N	\N	\N	\N	155477	155477	155478
30274	52303	38	applied	\N	\N	\N	\N	155479	155479	103266
30277	52323	0	applied	\N	\N	\N	\N	155527	155527	155528
30277	52324	1	applied	\N	\N	\N	\N	155529	155529	103328
30277	52325	2	applied	\N	\N	\N	\N	155530	155530	155531
30277	52326	3	applied	\N	\N	\N	\N	155532	155532	103393
30277	52327	4	applied	\N	\N	\N	\N	155533	155533	103339
30277	52328	5	applied	\N	\N	\N	\N	155534	155534	155535
30277	52329	6	applied	\N	\N	\N	\N	155536	155536	103361
30277	52330	7	applied	\N	\N	\N	\N	155537	155537	103367
30277	52331	8	applied	\N	\N	\N	\N	155538	155538	155539
30277	52332	9	applied	\N	\N	\N	\N	155540	155540	155541
30277	52333	10	applied	\N	\N	\N	\N	155542	155542	155543
30279	52334	0	applied	\N	\N	\N	\N	155555	155555	155556
30279	52335	1	applied	\N	\N	\N	\N	155557	155557	103410
30279	52336	2	applied	\N	\N	\N	\N	155558	155558	103418
30279	52337	3	applied	\N	\N	1000000000	\N	155559	155559	155560
30279	52338	4	applied	\N	\N	\N	\N	155561	155561	155562
30279	52339	5	applied	\N	\N	\N	\N	155563	155563	155564
30279	52340	6	applied	\N	\N	\N	\N	155565	155565	155566
30279	52341	7	applied	\N	\N	\N	\N	155567	155567	103437
30284	52348	0	applied	\N	\N	\N	\N	155587	155587	155588
30284	52349	1	applied	\N	\N	\N	\N	155589	155589	155590
30286	52348	0	applied	\N	\N	\N	\N	155587	155587	155588
30286	52350	1	applied	\N	\N	\N	\N	155593	155593	155594
30286	52351	2	applied	\N	\N	\N	\N	155595	155595	103509
30286	52349	3	applied	\N	\N	\N	\N	155589	155589	103511
30286	52352	4	applied	\N	\N	\N	\N	155596	155596	155597
30286	52353	5	applied	\N	\N	\N	\N	155598	155598	155599
30290	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30290	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30290	52359	2	applied	\N	\N	\N	\N	155615	155615	155616
30290	52356	3	applied	\N	\N	\N	\N	155608	155608	103535
30290	52360	4	applied	\N	\N	\N	\N	155617	155617	155618
30290	52357	5	applied	\N	\N	\N	\N	155610	155610	103541
30290	52358	6	applied	\N	\N	\N	\N	155611	155611	155619
30290	52361	7	applied	\N	\N	\N	\N	155620	155620	155621
30290	52362	8	applied	\N	\N	\N	\N	155622	155622	155623
30290	52363	9	applied	\N	\N	\N	\N	155624	155624	103560
30290	52364	10	applied	\N	\N	\N	\N	155625	155625	155626
30290	52365	11	applied	\N	\N	\N	\N	155627	155627	155628
30290	52366	12	applied	\N	\N	\N	\N	155629	155629	155630
30292	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30292	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30292	52359	2	applied	\N	\N	\N	\N	155615	155615	155616
30292	52356	3	applied	\N	\N	\N	\N	155608	155608	103535
30292	52360	4	applied	\N	\N	\N	\N	155617	155617	155618
30292	52357	5	applied	\N	\N	\N	\N	155610	155610	103541
30292	52358	6	applied	\N	\N	\N	\N	155611	155611	155619
30292	52361	7	applied	\N	\N	\N	\N	155620	155620	155621
30292	52362	8	applied	\N	\N	\N	\N	155622	155622	155623
30292	52363	9	applied	\N	\N	\N	\N	155624	155624	103560
30292	52364	10	applied	\N	\N	\N	\N	155625	155625	155626
30292	52365	11	applied	\N	\N	\N	\N	155627	155627	155628
30292	52366	12	applied	\N	\N	\N	\N	155629	155629	155630
30293	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30293	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30293	52359	2	applied	\N	\N	\N	\N	155615	155615	155616
30293	52356	3	applied	\N	\N	\N	\N	155608	155608	103535
30293	52360	4	applied	\N	\N	\N	\N	155617	155617	155618
30293	52357	5	applied	\N	\N	\N	\N	155610	155610	103541
30293	52358	6	applied	\N	\N	\N	\N	155611	155611	155619
30293	52361	7	applied	\N	\N	\N	\N	155620	155620	155621
30293	52362	8	applied	\N	\N	\N	\N	155622	155622	155623
30293	52363	9	applied	\N	\N	\N	\N	155624	155624	103560
30293	52364	10	applied	\N	\N	\N	\N	155625	155625	155626
30293	52365	11	applied	\N	\N	\N	\N	155627	155627	155628
30293	52366	12	applied	\N	\N	\N	\N	155629	155629	155630
30299	52374	0	applied	\N	\N	\N	\N	155656	155656	155656
30299	52377	1	applied	\N	\N	\N	\N	155662	155662	155662
30299	52378	2	applied	\N	\N	\N	\N	155663	155663	155663
30299	52375	3	applied	\N	\N	\N	\N	155657	155657	155658
30299	52368	4	applied	\N	\N	\N	\N	155639	155639	103619
30299	52369	5	applied	\N	\N	\N	\N	155641	155641	155648
30273	52275	10	applied	\N	\N	\N	\N	155432	155432	103051
30273	52276	11	applied	\N	\N	\N	\N	155433	155433	155434
30273	52277	12	applied	\N	\N	\N	\N	155435	155435	103060
30273	52278	13	applied	\N	\N	\N	\N	155436	155436	103062
30273	52279	14	applied	\N	\N	\N	\N	155437	155437	155438
30273	52280	15	applied	\N	\N	\N	\N	155439	155439	155440
30273	52281	16	applied	\N	\N	\N	\N	155441	155441	103068
30273	52282	17	applied	\N	\N	\N	\N	155442	155442	103074
30273	52283	18	applied	\N	\N	\N	\N	155443	155443	155444
30273	52284	19	applied	\N	\N	\N	\N	155445	155445	103078
30273	52285	20	applied	\N	\N	\N	\N	155446	155446	155447
30273	52286	21	applied	\N	\N	\N	\N	155448	155448	155449
30281	52334	0	applied	\N	\N	\N	\N	155555	155555	155556
30281	52335	1	applied	\N	\N	\N	\N	155557	155557	103410
30281	52336	2	applied	\N	\N	\N	\N	155558	155558	103418
30281	52337	3	applied	\N	\N	1000000000	\N	155559	155559	155560
30281	52338	4	applied	\N	\N	\N	\N	155561	155561	155562
30281	52339	5	applied	\N	\N	\N	\N	155563	155563	155564
30281	52340	6	applied	\N	\N	\N	\N	155565	155565	155566
30281	52341	7	applied	\N	\N	\N	\N	155567	155567	103437
30283	52342	0	applied	\N	\N	\N	\N	155573	155573	155574
30283	52343	1	applied	\N	\N	\N	\N	155575	155575	155576
30283	52344	2	applied	\N	\N	\N	\N	155577	155577	103450
30283	52345	3	applied	\N	\N	\N	\N	155578	155578	155579
30283	52346	4	applied	\N	\N	\N	\N	155580	155580	155581
30283	52347	5	applied	\N	\N	\N	\N	155584	155584	103498
30285	52348	0	applied	\N	\N	\N	\N	155587	155587	155588
30285	52350	1	applied	\N	\N	\N	\N	155593	155593	155594
30285	52351	2	applied	\N	\N	\N	\N	155595	155595	103509
30285	52349	3	applied	\N	\N	\N	\N	155589	155589	103511
30285	52352	4	applied	\N	\N	\N	\N	155596	155596	155597
30285	52353	5	applied	\N	\N	\N	\N	155598	155598	155599
30287	52348	0	applied	\N	\N	\N	\N	155587	155587	155588
30287	52350	1	applied	\N	\N	\N	\N	155593	155593	155594
30287	52351	2	applied	\N	\N	\N	\N	155595	155595	103509
30287	52349	3	applied	\N	\N	\N	\N	155589	155589	103511
30287	52352	4	applied	\N	\N	\N	\N	155596	155596	155597
30287	52353	5	applied	\N	\N	\N	\N	155598	155598	155599
30294	52367	0	applied	\N	\N	\N	\N	155637	155637	155638
30294	52368	1	applied	\N	\N	\N	\N	155639	155639	155640
30294	52369	2	applied	\N	\N	\N	\N	155641	155641	103587
30294	52370	3	applied	\N	\N	\N	\N	155642	155642	155643
30294	52371	4	applied	\N	\N	\N	\N	155644	155644	103600
30294	52372	5	applied	\N	\N	\N	\N	155645	155645	155646
30294	52373	6	applied	\N	\N	\N	\N	155647	155647	155648
30297	52367	0	applied	\N	\N	\N	\N	155637	155637	155638
30297	52370	1	applied	\N	\N	\N	\N	155642	155642	103589
30297	52371	2	applied	\N	\N	\N	\N	155644	155644	103598
30297	52372	3	applied	\N	\N	\N	\N	155645	155645	103611
30297	52373	4	applied	\N	\N	\N	\N	155647	155647	155655
30298	52374	0	applied	\N	\N	\N	\N	155656	155656	155656
30298	52375	1	applied	\N	\N	\N	\N	155657	155657	155658
30298	52368	2	applied	\N	\N	\N	\N	155639	155639	103619
30298	52369	3	applied	\N	\N	\N	\N	155641	155641	155648
30298	52376	4	applied	\N	\N	\N	\N	155659	155659	155660
30300	52374	0	applied	\N	\N	\N	\N	155656	155656	155656
30300	52377	1	applied	\N	\N	\N	\N	155662	155662	155662
30300	52378	2	applied	\N	\N	\N	\N	155663	155663	155663
30300	52375	3	applied	\N	\N	\N	\N	155657	155657	155658
30300	52368	4	applied	\N	\N	\N	\N	155639	155639	103619
30300	52369	5	applied	\N	\N	\N	\N	155641	155641	155648
30300	52376	6	applied	\N	\N	\N	\N	155659	155659	155660
30300	52379	7	applied	\N	\N	\N	\N	155664	155664	103623
30300	52380	8	applied	\N	\N	\N	\N	155665	155665	155666
30300	52381	9	applied	\N	\N	\N	\N	155667	155667	103635
30308	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30308	52397	1	applied	\N	\N	\N	\N	155703	155703	103963
30317	52405	0	applied	\N	\N	\N	\N	155726	155726	155727
30317	52406	1	applied	\N	\N	\N	\N	155728	155728	155729
30317	52407	3	applied	\N	\N	\N	\N	155730	155730	155731
30289	52362	8	applied	\N	\N	\N	\N	155622	155622	155623
30289	52363	9	applied	\N	\N	\N	\N	155624	155624	103560
30289	52364	10	applied	\N	\N	\N	\N	155625	155625	155626
30289	52365	11	applied	\N	\N	\N	\N	155627	155627	155628
30289	52366	12	applied	\N	\N	\N	\N	155629	155629	155630
30291	52354	0	applied	\N	\N	\N	\N	155604	155604	155605
30291	52355	1	applied	\N	\N	\N	\N	155606	155606	155607
30291	52359	2	applied	\N	\N	\N	\N	155615	155615	155616
30291	52356	3	applied	\N	\N	\N	\N	155608	155608	103535
30291	52360	4	applied	\N	\N	\N	\N	155617	155617	155618
30291	52357	5	applied	\N	\N	\N	\N	155610	155610	103541
30291	52358	6	applied	\N	\N	\N	\N	155611	155611	155619
30291	52361	7	applied	\N	\N	\N	\N	155620	155620	155621
30291	52362	8	applied	\N	\N	\N	\N	155622	155622	155623
30291	52363	9	applied	\N	\N	\N	\N	155624	155624	103560
30291	52364	10	applied	\N	\N	\N	\N	155625	155625	155626
30291	52365	11	applied	\N	\N	\N	\N	155627	155627	155628
30291	52366	12	applied	\N	\N	\N	\N	155629	155629	155630
30296	52367	0	applied	\N	\N	\N	\N	155637	155637	155638
30296	52368	1	applied	\N	\N	\N	\N	155639	155639	155640
30296	52369	2	applied	\N	\N	\N	\N	155641	155641	103587
30296	52370	3	applied	\N	\N	\N	\N	155642	155642	155643
30296	52371	4	applied	\N	\N	\N	\N	155644	155644	103600
30296	52372	5	applied	\N	\N	\N	\N	155645	155645	155646
30296	52373	6	applied	\N	\N	\N	\N	155647	155647	155648
30302	52382	0	applied	\N	\N	\N	\N	155671	155671	155672
30302	52383	1	applied	\N	\N	\N	\N	155673	155673	155674
30302	52384	2	applied	\N	\N	\N	\N	155675	155675	103643
30302	52385	3	applied	\N	\N	\N	\N	155676	155676	155677
30302	52386	4	applied	\N	\N	\N	\N	155678	155678	155679
30302	52387	5	applied	\N	\N	\N	\N	155680	155680	155681
30302	52388	6	applied	\N	\N	\N	\N	155682	155682	103667
30311	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30313	52398	0	applied	\N	\N	\N	\N	155713	155713	155714
30313	52399	1	applied	\N	\N	\N	\N	155715	155715	61342
30313	52400	2	applied	\N	\N	\N	\N	155716	155716	103693
30313	52401	3	applied	\N	\N	\N	\N	155717	155717	155718
30313	52402	4	applied	\N	\N	\N	\N	155719	155719	103705
30316	52403	0	applied	\N	\N	\N	\N	155721	155721	155722
30316	52404	1	applied	\N	\N	\N	\N	155723	155723	103709
30318	52405	0	applied	\N	\N	\N	\N	155726	155726	155727
30318	52406	1	applied	\N	\N	\N	\N	155728	155728	155729
30318	52407	3	applied	\N	\N	\N	\N	155730	155730	155731
30299	52376	6	applied	\N	\N	\N	\N	155659	155659	155660
30299	52379	7	applied	\N	\N	\N	\N	155664	155664	103623
30299	52380	8	applied	\N	\N	\N	\N	155665	155665	155666
30299	52381	9	applied	\N	\N	\N	\N	155667	155667	103635
30303	52382	0	applied	\N	\N	\N	\N	155671	155671	155672
30303	52383	1	applied	\N	\N	\N	\N	155673	155673	155674
30303	52385	2	applied	\N	\N	\N	\N	155676	155676	103641
30305	52389	0	applied	\N	\N	\N	\N	155686	155686	155687
30305	52390	1	applied	\N	\N	\N	\N	155688	155688	155689
30305	52391	2	applied	\N	\N	\N	\N	155690	155690	155691
30305	52392	3	applied	\N	\N	\N	\N	155692	155692	103957
30305	52393	4	applied	\N	\N	\N	\N	155693	155693	103959
30305	52394	5	applied	\N	\N	\N	\N	155694	155694	155695
30305	52395	6	applied	\N	\N	\N	\N	155696	155696	103962
30307	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30307	52397	1	applied	\N	\N	\N	\N	155703	155703	103963
30312	52396	0	applied	\N	\N	\N	\N	155701	155701	155702
30314	52398	0	applied	\N	\N	\N	\N	155713	155713	155714
30314	52399	1	applied	\N	\N	\N	\N	155715	155715	61342
30314	52400	2	applied	\N	\N	\N	\N	155716	155716	103693
30314	52401	3	applied	\N	\N	\N	\N	155717	155717	155718
30314	52402	4	applied	\N	\N	\N	\N	155719	155719	103705
30315	52400	2	applied	\N	\N	\N	\N	155716	155716	103693
30315	52401	3	applied	\N	\N	\N	\N	155717	155717	155718
30315	52402	4	applied	\N	\N	\N	\N	155719	155719	103705
\.


--
-- Data for Name: epoch_data; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.epoch_data (id, seed, ledger_hash_id) FROM stdin;
1	2va9BGv9JrLTtrzZttiEMDYw1Zj6a6EHzXjmP9evHDTG3oEquURA	1
2	2vaRh7FQ5wSzmpFReF9gcRKjv48CcJvHs25aqb3SSZiPgHQBy5Dt	1
3	2vbJ9MyuaQbetkM41dnrBRgoioefF5SsnYgT4nD5Dfst7SrAzTAM	1
4	2vbsVxBcEcCteELXMaSprEnMikJ1Y7LwUjENiBN2FygP8nyMhvX6	1
5	2vaAacnAihstCS2ugN4P61vEqFsdtERB3hnEC5ZFZiwV92JBTPgy	1
6	2vaGKALUWBAyjCG5DZgAdPwHfgoSa3RpBVPbcWc9nAJgqiP9uUxU	1
7	2vaG7P6N4x4umDk37gPFBXX8HShshwmtv2spKUTE6iviR9qhbXdp	1
8	2vbuMt3o4gAUhVfWq8joReEAUAJUQfCqv9gSKtx2yqxjm9HzvePd	1
9	2vbpwhApYQbaAP4G85EZaZyedxUefxcTFTTmnPxeV3RdxiL7hszH	1
10	2vapLu6tAdD21NruwHqjfSf2Ag1QYjniaCMVaNZBwEvbw58tdCeR	1
11	2vbUZNKiRGo1sF1WJXwrxi2Ui9Fcnp2P48gatd4iUvc6MPNhfJ5E	1
12	2vasdBVnbKBXN4wYTdxxEF5sH9FyYHxX28gCyJWZKrtdctHJAVXn	1
13	2vaTpcWoEhr3xbWP82Tg3nbeSwNfRiv9M9iwpz6q3wmM1ptt67Ng	1
14	2vaHw6mxB6fbcED1gTxyhcvf1TfenGZzkREnf75LvftGyszAHc5o	1
15	2vbf1keW5b3bLo4s22LxPiQXSPWh3jopQrZHy1abF3iQPGhwkCUa	1
16	2vbrZjeEQSWo1GFDMs9kwPTk9y7x48oHqF33oujb5t6hPFRz9xxG	1
17	2vbQS1bQX8HJC5RiPsKXAc7V8UTeQ8SXCNvbWwwPKfFyyvqV59sc	1
18	2vaDVUc8JgvF5H1K4vdcQFWtLjCioCEfDUz2wpGpX9swUe4kTm8x	1
19	2vbXdy1cedJuQpwmbgM9JdnRffDD2E17XRE7diq15YdHXRJdLt7b	1
20	2vaEjL2BR4SxsrPtMJD2SWxvri53tq1XrQNfsRK3nH2fXmTFQjBa	1
21	2vbkuNArUcfAtLpGFXEtsaAvnyBCJwRhXo951L7Jg78kyKE8GbDt	1
22	2vb3PvU98YyE4vs6vbgcAjYKF6Senc6M92pGmq5H8SqeZ3TaPrRG	1
23	2vb5KCbVB7frH9ziC34S2FvYYmTjwoRJBKUDnDm8t6f5SbHdAyjA	1
24	2vc4qvQ6QTZ7eNi3vuUZew7ErEmnzL457uJpJzPLQBy6aPcgTJ2W	1
25	2vbzw3Tg2u1mL5JPibj9k6ZSwrdJ2CuU7KrSNqBD7654wPHkS62c	1
26	2vaDixuSBwJ7L3ygE1csfwatV31soZLApJAaw6PAMigKNwB9RJut	1
27	2vbAp2odJ4B2gk2YD2t21F5KVWJmkG8RyjT2LwZSW1gPZo4Lo9zy	1
28	2vbfAvyjoh7CnC3F54K6vq8EjHuSp6bSCV3HXPR6Uwt4J5T4wjNE	1
29	2vbuepufNF1Qp7N7bmQncHvbfauunoKQp2h282bxMVKr4axdboUH	1
30	2vbo5n2ZJ4V15DLpt7pDMfX5wz2B5PUJiapDaHYJZasV88Rv95kn	1
31	2vbRR2PAXTvrRZCtfzBqnPXD54gN6Q6Nz3MS2QjYDF278KbhaJES	1
32	2vbMYvpJT39CHL8M6nqk79CL5NJ23rxQH87C7J9CRoCxiwEFEhM1	1
33	2vb4Pfo6gYhAqqppmq4guG6SzhnvEkoXoz5qqNfHcyn58o2pc8fk	1
34	2vbzCYVxG1NvCtQ6u4gLiEGJw97eBa6DovxrC8nWm21gkF3XUhzk	1
35	2vbjGUPNpPtgNn2DnYyHu8GkQsEXsxWcxM3eLEwfkdeLGVCoKgWs	1
36	2vaiy2boN1pZgYg1t15KtxMKJem4bMTYAgxV1W3gfnGv1VChdVTR	1
37	2vabLpuWrbb2raJAQhTn5mJ3oy5NBaqCP2bmXYMPCM9TMcRom2JE	1
38	2vafRmkndigvZaVdXQZvUtDpudNYzVaLV6M3YXq94sseZmvXjnBZ	1
39	2vbpqXZGLbZDcpqRz3PRjmqVKfDtdefzHFyWCzTyAV6RaXjZEw8Z	1
40	2vbsNhS5FpacpNVQM2pK9sgskZhq8GAds1m8XVADTuXqbD6andKf	1
41	2vaSfvNxvNoteArZoNvgcCHeFa9ddsxySfVyt4re518qw6bseRTa	1
42	2vb5N8m5ianqR8KaFEi6d2jEhT6hdSTm822kgHoJfF2KEWgGR65i	1
43	2vaoeLXoqgk18ew9S5ZCNAB9H4Qzgw1buJV4w1Sg3QKSqPxXzxj2	1
44	2vaoKAeU8aci94u9vg2Cfa9Tqa7DYHpPcSpxfdtcBWh3XsLAf33y	1
45	2vbGj1X65gn52EwqxTUeksfSW83mkfmLPaDSUvWDuaoAQP5HzrxW	1
46	2vbemWYgxE3azYz6j7FqvxXEdT5YmmVFCjCJZKfX28NkLnn5bQg5	1
47	2vbypmPvjSTsepDoKXrmBQEMvqU1x7Sm73yW8VTEj2uJgLx5YfV2	1
48	2vbzsFvMoMb18nBgT2ML81u6AcCy96bCv6V5jaxts7BZ5AUBKC26	1
49	2vbzNyU8GkbCHJkAAvFRxa2TEJZsQYksYJm5ZGYBY5MA53Rmqamu	1
50	2vbiunJ4cbHL6cQFiY36UJYTJ8PLJtehQkFrTWftQyWUS51JWVEk	1
51	2vaKLmroGtgSUA5wTikQftJ2qkJGDHcD9b5HM9ud7ZaAERyaVUyS	1
52	2vb5TfKsivLowfAS33hg1yrAhAL1k3RzL8v5obameYsMGuFEDYVA	1
53	2vbQPCpDTWyggL9WGjxL96vQPf4fSSEG7H6sYJ56mVCghEttqCr1	1
54	2vazxCVB5AmqFnAqYPMGruewnsCPheU6k9gbJeCuKKq8yMvmJ3g5	1
55	2vaeCMZTftKkYC3vMkSKHGtVHcVyQMtypJJDBgPvStne8ViiSwuy	1
56	2vaNm28bUkgK1CDhzYy6R5QCc9PVmbU7A1azTdiTAUPSJfCigaXp	1
57	2vb7fn2KdfGb5ijAShSZdR1nyFzaG5ydJBSc5kNFK5dPUNsdD3kB	1
58	2vbWkWWdCqCejfJGPSxqpLkTMnNZ43ASKoC6pJMMgcCqo42gVeBr	1
59	2vbHGyyvzVxdWdwTJN4UmBjRQpNgYfEgCkoKa1zv6b3arTJCojWx	1
60	2vbRtXca36VcJtaHhUaTjfc7FjTZTLHnHj7wNsRA5cBpVqyC6DhB	1
61	2vavJpDtLM9H4wM7P55CmNtkueae5sE3Tbxnrzckkqj7T932KeMR	1
62	2va9mr7pSwFJDJTK5HDgU9PU4JbZyxynnsVJT2VqzBjKpdFUPd3r	1
63	2vbDfZLrQxv5CyEfQ3mqTSjdGgmZdPDgr5kDjzyDsuYnUAGHVaUS	1
64	2vbQ88D9VQHt9EV5yrbh8FD3tPRVrFpb3D3iogZh2oMVViX8YmBy	1
65	2vaXTcWFRNw68rSgQ9cpBHFjXB6jYUwKhzw4BjYu6tEtkmsuUQLT	1
66	2vaaZTve3Y9sZY94xCvHigWe8VyZs2k15RnN7QSFzGbnAxuC6xDN	1
67	2vbKk5b21KqXzbJVoCFrNr8bYbFX4SuCcfJHSmSQr8W6KxZu8FU4	1
68	2vb12RBq4t9kgjbMNX1uZoDCNbEMgJitNsup93E17Ax7jbGnxZr5	1
69	2vbaDf1bt1juKEJE83CQbLnSkivGrVf6nudNWmNcGppUwEP21mCo	1
70	2vbDSBD8tZngXEt1c2MnG4g87uzcduv8UoB43eZEEHH1dYS2cBCx	1
71	2vaf86gHtX7a2gtB2ZFMycEmoZgFxi6Yid8dbecrAyoqAMdootnJ	1
72	2vaqJmXfMQSCCtt8uXBo69FNFn47wzWF2sjZQPtnPEHNALhpMrUR	1
73	2vb5iANW6t7vnmC2KXCDnwf3vjmCnnZatyp4ohtEoHSjhPV1ChDM	1
74	2vaPRkit7NvbxJMHNida5UcZBXsbCzuLsHoHSqGjyusVPwfPwiXo	1
75	2vb8kAui3J1KvF3TmGh46S6uwdBEjcJt2TVtFydRJmqYvJxiUJGB	1
76	2vbipCQ6fy8Zi3xz1Sxtkng8NwLtWc9s7c1DPvmsGCMtCHHT7UqW	1
77	2vaNa4vcCcg1tCU2cjk4uJFSYaeuEaRxgeS9Ly7yXmaYvtLuXePJ	1
78	2vakuzhuw4dHza1qPWCeQhyaBK8T6gjwtHgEcMHnumMWFKk6Snw2	1
79	2vbyuGutYcBLC9vz4mHZSZurqWKo2mNRcAhZWhdL1y8Bgva8vcSs	1
80	2vbPUYjJ8QvjcKc5D5FNF3xbQUDEVKrASWtsvh64PVk9Mwvs3zA7	1
81	2vbBzGi4PNNjkSNUMnt2zsE3hn4yUymSvYHKuKZG2k2Lu3WmbzFU	1
82	2vbMP7DSc4qbUaRLLXJLiEaMLL7cdy8fyYec1Yj391sxb4Njg4JX	1
83	2vahTBGFXr1KKYLAg2khr4qXCdcE18woPrEJiASq2gZQY6fYjXhg	1
84	2vaKUg3oyZ55UjRwDm5VDr6pBjdR4Wv5USzjoE7fVenRoFDNFAHy	1
85	2vbnuCgU22WEebhUojoRb3gW87VoV6onNJ4u8W6ZJFk7TYBvkkMo	1
86	2vaqBCDTxQW9CJ4iLXsWcNS536ZhRJPsPoXeXh6SbgUxqCWnfm4u	1
87	2vbzcM7Lqn67FWapEZRvakab98GKKuLwAU2FojQJVTLW65bngD2A	1
88	2vaqa6Hitfu32YZBjfJWth4GYm45vXT1JbtK3Cq9HpCarhqyjHgT	1
89	2vbQ1Ri5QuVoo1MsWci3s7rP7sGAzGuNSWmzb521LcUJYVgSr2m7	1
90	2vbatYpFYq5pWKQWByD8A6bquhWEwdCRubNxXd4BAv4sAEs8BMMR	1
93	2vc2tKc6WcUngUStvwbm1RqzTNzLmmatXgntntSwYg4eoK5NQciZ	1
96	2vaitLn6BWLmGKfgQ7rM7V1RUjhPkdwjYZfL65zeD8EwZw5oAKV6	1
99	2vb4PUmssM33Q2pSNHWe5GbjBTANp5ufTvyeVwfVgSab61AadVGy	1
100	2vbE6QXDafQJHPWdNFWcQyDjs3t7M1VWhLskAPgN9gAkQq8pW1yR	1
101	2vbV8mCzU6wzHtGGNoqC5pEyQQt9UaMi9Uzzwrte1L2MTefuzPJS	1
105	2vaKpXLU63CS6AfduSEfcbHhS8B5q7jvKVUoUhdMknb2iQxktNqN	1
106	2vaUJq4Gj1XeaUrCiPDmpJHqjFwZu8HaZnRBZfheHpBEwmWwW2QD	1
107	2vb8SMt9XmFxK9K9gTrSEdEr78SqbhuZ4CA9xfNQT8KtdXwkdZyB	1
91	2vayW5XMUfvDCLivYrTBsEJ22esdAprk3WUQm4Nxp3cHHedQqjyt	1
94	2vbhHy6r6eg7tH4D5tDmTj7BA85s3ooqDCjzGfvwDPSroAHKnP41	1
97	2vc3v5yi2rHidVp9kvLNU6to6XnDxvGx6tC2J1Fa6BvCqUwGkWvs	1
102	2vaZJNug1BdXex4MK4KZLVrcVbjpxtuDNgiEvg9v6VauvVvCF7wc	1
104	2vc5GAmoQGqPsJd5ykdBQQX19iyKujXaMdN2xUxdZMxkfkkBgsU3	1
92	2vbVSxG7VW1kQP1hGLmTuo89fwkJPVd31zmnYtbcgXKTtKrNtdFp	1
95	2vbgyEkKzuBtk7SMdcayu3Fh2SCBdktc8j5NWn7qZtgp4HKdpTa9	1
98	2vataxM3VUntahKptPfmG4J7P8ifodhzHyJtRxrPmTcw2L5FrYsx	1
103	2vbYa7WpmpUctWMtEcHSZF7mPTjinZaUpLUK4HvYubLTe8zEdrqa	1
108	2vaeJdKRsqKBB2G5xAYnvWqkKJoqNYQ7GHGwXLYFWUDDtawsYtPj	1
109	2vb4C3Nf4f4VQKG9ZEUy5kdi5Fcm4FX7dSJQY4M3jARnsQ9EwHdc	1
110	2vbQrDC4iGYJpRWRTApDB3pugzrhMWef3iKDPxth5oGnHwR22dPg	1
111	2vafEargVE7HySyiPELbLXkKiUbbhbKfghiijsunsoqREdmx4uwD	1
112	2vaJwQHEUaJnzgymsS5QJQGmVukEVacVBpp3ccWTdE2LCiv9b5S4	1
113	2vajUPhiwX4cBNFNhSsJLLVHVyBuUNbiBeFRBSGXDgB6wRc7pagH	1
114	2vaCnhTJ5oLphU7smCiZikGTg3M7wn8NrMaYrdZHiTuDTUDNoL1X	1
115	2vbY7HDNsesCrTwrmtpr6aTihdMy4Ji1F9Ei4J1oSKYjmps2Hni8	1
116	2vaxcYDibYCwEUFZMJRaVWasftw7yPMBLdZwkSkfidunjtvpRmDK	1
117	2vbn8JGJ7D3hf7cd4PcBJfTxf5ieT4X17qTUuF5e6JVMfYxw1jHd	1
118	2vb29AjXzWjEfZZn6HazsiFB6dQcuSKVJZ48zWwvhHGY8RW6kTUR	1
119	2vaqeixg1iRP7M7NhPZT2THzVxAkPtpiYAeXMBSYzydVdchXVM6B	1
120	2vayjuMMXBbDeHaradQFbSqy8U5bmoVAicaNgWuG9esjZxn3PTJr	1
121	2vaJkCTJifjPwwcBsXfPVUbY5cwbN5bVnGxmwB7x6r3hgEt7WE2V	1
122	2vaJzzyZVE9iRhryiLxQoihKxMw4DzfTjL7kuqDLzrYakdjf7Kkv	1
123	2vbAdnEgX1BnRwqLoY1HR6GvGMjqGFUM9NvCr8npDVD9DyDZvjp6	1
124	2vbEVNToYMbqaoY8NCAjyovz7fGeJjfaHHk8DQXSvSM6iPjpe6e4	1
125	2vaC33ZkFiHofQCZJdbFuweddG6FjWZhnZZBGa6kzEsjMNtYy29H	1
126	2vaSfmJgz7YX8LvgQVx2qmZpcKdhXWq9YD2tpMkSudcByANd1Q1k	1
127	2vaoMb22zVT9m86cRJNCGX5jKpYHzGwePYhCWVhtckjPWqN2ShnQ	1
128	2vba4wESNLwGss8iKyg7ZuWPAQYqeyYuPJKdBoikjT6FULDXkAsf	1
129	2vbyJkKCUTxEGYsBTpkK6yBVM15rXhYUTg8XFAhSmVXCwMWrD6sv	1
130	2vaxgo1Wz2jJQXSaRBD5Bnz4F9wYRqFs2pQqqmSiBJgByictBJ4f	1
131	2vbxZ6habfeDzbsR4Gvuvb2eJLYNss8umuEUrEXtDJsiV9VeaCuW	1
132	2vavxFGuKuz6YihRayXcE9JDUDGTgeaef57i2Bj7FUr5YzjSnwMa	1
133	2vbDCHeSi8wjUheN6b1WknxnSSnEPGVhXUjJV3rSZDSeiVsaibWt	1
134	2vaqvvJv3Q3zbiE7184hK5hzB5QQuuaHXVddQzaKuSsZnGzNnNSZ	1
135	2vaPC9JxSxRg14czNwUgPmBEZaxJQN39KTAUGqVYHaumtbVss8tf	1
136	2vb1mzpqUbGgVFRkqSpcrTPG1ZAdL6zmisdVsD9biXramFH4XMZF	1
137	2vb41eZWEg1RHCPY594Ww9tXBHE2zNYUMAV3xuypevtKNFGJ7s9M	1
138	2vaC2kBqYctGzWmd5KMsVn1w9PVdviAz4oYunb97tmRsGgemCnSq	1
139	2vb9wDXfvDFtqeT3SubeXCFh2fmNaGK9yCjbm9xewm6Qpk6aKsi9	1
140	2vbacXBr47XtM1Wk8xGveXVS5STgGQyRCEvpFMHPF7TnbAerxLNa	1
141	2vaVQFZQhSBJyMrdc7hk4aoxKgdyFjs8TwoUHFYTsRgwsMpxAjig	1
142	2vbdy7TARY9U1wEwbxr94qmCokVPydUCjHNWcCJh8ti3SB9jsrJH	1
143	2vbnrd1DQj2EvohJBKNcBhgpcPdLsG5Hb1U56VzLK7J5GgugUp9D	1
144	2vafKFgNrGv1LMKfQP7hQs6TVNqg1FErbhgNv8t5sV5oGuVoAJZ6	1
145	2vbZV3WdjL7YedrGbjv7pTFDTkr7FtA1rQp5xCUuzquPa9BTdZKg	1
146	2vaHryLQ43RMXv8Jfx4PUVvZJt8JnNvpfYPRA4JayYqjuZXmiQ5N	1
147	2vbYqJpN3xocNCeG4oFgHFP3YdHvW8nruvjG2Ry9sSFyJBPY2EHa	1
148	2vaiE5mvY4PkzM8MVGMDKFDYYwhnyxTj9Z52Ux2pbdMoBUfGmR3Y	1
149	2vaGN5EjrLRzgAxBoi89CKkSrjQCWexzYyuyKh6iZmd6HLe1Xj7n	1
150	2vbFwdsvg4BxhP3RtjP8dPqdzZLT3e6vrAXZcsvx7aTRt6Fo1j6X	1
151	2vauZPbCA3CeoxMS1vygAskfr5fiwEYWAriQWFphmNmxsiV11DbF	1
152	2vaHAXePUtfBiaveDqSpSv5h91EeEdVGdfiRXZSyXYYyNfSNhCVS	1
153	2vbw9AZbFqXHqcJL85PdJedrJJ2SgxGRCyzFoTuRC5pM53nS2bf4	1
154	2vc4UgWkoC64QNaWg4x8Mp7XvX5MZSAuP4rfBpEa6PxHwDNquYqE	1
155	2vayvwsjZAHYLE6MGxe3U9DgXZ5tEfKNRqhEsyki2UVCb68ugTxJ	1
156	2vb5tzkCWTLn9uB5SdFduKDHSDFEce8x5qG6YGby8Mt6oSa3a7kp	1
157	2vc22Q4aswexb8A5hJwbEy6ELvWbassbmQWeMB917eeK2m8yLYYV	1
158	2vbB94UEqo7jSabcNRHQDnco93PfvdyeX6f51nqiu2NH3mAp7M87	1
159	2vb3d6UdrpXTrLxjxjbwHPZJLpJzQZNBYV2xrZYJRWJs3KaX7LGY	1
160	2vbHacZT8YJm6HGsgfSu93juFFQCwNCxB882EhbAeZKPhUbN45Aa	1
161	2va9bnep3ExEEEFgssW6TvpoQsm4vrmBvbSp5Jyhax52Rm7e7XrV	1
162	2vaHMB7wzefvJryKqEsMnC1vH9ugnno5sHZfNBdYACToL3ktLp55	1
163	2va9p5yW54Js15v24uUExEbRDKX3uxyEYxK3LVq3Q5tsAJWRosJN	1
164	2vbsBY3gMefwnKVVSqyp5CJFDhPaD8V53pDDzxDrqvTH3iRTRVDQ	1
165	2vbkn5JBDVv2hqJiTCVXQJgbhXKUWMLDZrJrDVfGhYzNEB36fMWr	1
166	2vbLpVw67u1qZS8T3DRjLrwcZjZT3Moevmdxj9qfRtmZXKLk8Fbm	1
167	2vaNjQX3eEa4LYWjWA1JtedCiw7nuSXfmQkPXi1zBMecxBPs1VVG	1
168	2vbasEzcFyw9McNCQjav77M1xR3BRQkRVbHiwg6GUttdyqzNT1AS	1
169	2vbrFzKjq3R4X6HBJeKe3qei6DPQ1VEv19KJANzjFt2v3pRH3xLb	1
170	2vbfqshz8jJLtU1Vr6HU9MQtWpjeSVG63PxoQ2m1fu51tAngiNVV	1
171	2vbDyAyibsVL4cn4cpu3ZCawEPR5UuF4jfZJXeL3vMXCBaFVRK2P	1
172	2vaJjXerR5dGs9N36SKXoDBYwoHyBFZyDJEYVajc72kE2tmcdMox	1
173	2vaMfsarj8vkdtc5uAtLvjSdL17EsrVBbGVYC5FkEkjCHFD9rKPU	1
174	2vbqSJ2naxJWw76NjvLMEQ8njNsRZGY89AbNKzN4tt1b5DacKorh	1
175	2vaArBxB1CL31JzbFNXnXmw3KY4JyrnjveXxnKxzua8fudK4srTY	1
176	2vaoij6bt9wkuyp2cUiaUGtQR5XHEGEom9a6GAb2bDod719PoAvH	1
177	2vaZFS2RhTwismU36JEGVXfLCutWKW9GhqWLTdtbdrm6RycPRJp3	1
178	2vagQt6R5yZ9DPcdYemm6svWtmeLTXScGyiUZGUvdHDfsb5TzDA4	1
179	2vafeYw9VvHoaENDfJJvGDWiQqaNWTDwtSnHGHmJ8C8qkqcfv2yi	1
180	2vangQnvXCbnrU4Mnne67KKGpCtsnccid5Pdgg8NV9tTVfN1ps9u	1
181	2vbwjhdy4NuY4JgWZWHhDBynWbveZFoxzXYb5zDHBHsc5yk7kGF3	1
182	2vaQxEbbRwgMrGVi2igFPxdwm1ggfkzGaMSSBbffMEktPBr6u33K	1
183	2vaMKKMp3RGr26wWYrbDjSrDRFR3Qw5vCMAdk8tnjg5JNzHeCdGq	1
184	2vbKcQXrkMLer1kcpj1Yrpq8fukz2wTpv1Rr9VsN98D9B2y7kzv5	1
185	2vbBLHzPcQANU98821Jk8DXtzchomkZGd69VuTEvJBQrLZTjwzCf	1
186	2vbdzZncCY8eRVzJSf7FV2SE4NPTUhdcmHFMGwxDvjCtMkvMyW3Q	1
187	2vbyQ3q82pRb9hbzX5PWDKdchKSLcmZY76PedSFSgi3955hYwxmS	1
188	2vakJew18PRU7UGGHNJLqGVaJPBiViYMfHc3aaU7NDtkCLwQ6WYu	1
189	2vahUS6wBSSV77kgkgMaShQZEbVZg1NE1odsrD6SF76fGHE8HSrp	1
190	2vaz3xDqCv4eUGXQsCkmsp3vygHKHVpC39TyWpGmZHSrWFkHscbt	1
191	2vaRhCTAGAf2ig6b51p9ihNqX7A9Vx8Rrjkmqg4i3wMh3624EiQv	1
192	2vbBLc9dhEtC4csKGB2sYDNhX3NasRVHmooFLaaCHwN3kX65SXrv	1
195	2vahUbhUEoP6TUqYKY3Y4aU4RN9JnsGzuMME33HqTkMgR3bJdFW1	1
196	2vc4CaJXs57FSAE3TDPrBmsQdr9v4aYJ7EaPJCi1Yppnpdm6VCAq	1
199	2vbvfQdh5BB65Q25kDxTuVfzNumST88soTiAxFpBVSEPLEJmXUPr	1
202	2vaKZ8Kd3iB8sD5hiZy6Sq3V6QVq7CKqT3TWPEAfTkaBtzG6ATUR	1
205	2vakCk7x8jThw4f5dBhK9h6wern1RzoRcpETieYJfVt8nzhL99cb	1
211	2vbrEm8F5odX46ANA4ELEczxxCPtXaQ8xTbo8veSHFxEJVp4Umud	1
214	2vaKVTK2xNBpbNB1rfVibFL1yYonRf6Fi9zLJgxqFWJy1iLA5pGM	1
217	2vbNEgTjToZ8ZgfCUTJE5pqaL3SN6Ctwsdvj2oxiwdzD6MyrQiuM	1
220	2vaRfeUW5MgZ7fXsN4R5QbHtHVzYSuCd2eaKMEByPVKnbwMgSHhj	1
223	2vao8VF2t38UcZa661db88pZhEBZ9TsMdRFgrqkxmtxFJAGkMSs2	1
226	2vbPK641xFweqq3UzWcbZBpQYYL1hue8tozLeePTpLDe2b1to2fA	1
229	2vc1Xh48JHV7H5tajTyD5p9hB7d41JyqTgbgb9HLHg19Q8rbVDc3	1
232	2vaBySkcDQCPtSiD5ekqqwaxVQPfaedgNuKEqZ4158y6URAM4Qhq	1
235	2vau6bNR3GRgdT4v9HD1ZvjskbZGzFRJ8hJTJMSg7TFv4vqfrCnK	1
236	2vb1vbX3JywKsgzYS7xvqXhsxPMzdxZyGohYD6zC5MZxNss156ri	1
193	2vaeAsWBhg4x68aBmyPTSHMeXrGo1BRUqRVD1QGy9dh1CK2u6Sgc	1
198	2vbcWspZmkL2GkZY9iL2HSaGPnzHdLNuuNotS3dN7FPxuwpcm1xS	1
203	2vbaNmYY2ZtwkwiHwSLMUxy7PRDhSwgfBMYboq3ANXDfUzJy879F	1
206	2vauy59AqadAD47pzsFTu8Q2KauBADnD3HsYc1vw6MAQkkjcTpsy	1
207	2vbz8xkTLD3w9myzfDquZ7RoMvpFeT8omwg4didmwV5gmru2u9EJ	1
210	2vbhjBZUws5ZactQYA7ayqY4Pcdvd4Q86VFHniFapnqDSmQQqZLH	1
213	2vaLtgKZXfwVRc4t8VKUA1oyQAdqP96hiGV5ZCBPR1HbuTgCytkt	1
215	2vaHLxuBNPBphGsH4MF7qdS9opKnDjQK6mVbdBnJQNAKVU9DgWM1	1
218	2vb1N3SWif42YADVnFwcgQSUPKTvLkbLzGoAsVypqvVaQi5HC5xz	1
221	2vbjTxwJR4quKTq2EyVq1ZfgpMCQsyMaFCpLwJEBZ9qRYrqSBvSU	1
224	2vazQ3ewpHZCqMDrcqgVk7kKeedABgEUuFy7BdeZUFqsk4CxgD35	1
227	2vaJkGWBxAAvaXxaHsn9Uw1LmZvb15rJgZnJRLEJgFQ3CLzkyTBd	1
230	2vaNXTXFE7YqpmzHUJCAhyKbZhorFCDCERNqZsyP9rDDas9bVpbK	1
233	2vatj3YmHxVyHbMAR6vxNEA6EgufKUBtVh9bPgoZBWHTX4WkWQ9r	1
238	2vaB2SSNatSmXR5dGXkSkL97YfcSLNv4gAs3Gsfz2kNtVaeCzRF3	1
194	2vbD9D2gUpzHry3MArNwTMgbTnCRCdmgtzC3tqyurZnD9JJULX6p	1
197	2vaLxpB6btcftyrecnde3nt6i9b6M43YvbxjfgR2WrGbeieBw6gK	1
200	2vbsuBMoGaf2TsjkJPJNXC5Rid8HE1TtF2oqkumj7hP9SxaKLQeS	1
201	2vbgs98vBpzdNmWGmQge2P673EnWK9BLU7NoDmJef95h1DZsbkUH	1
204	2vbvJ2SjAVKN33JbdhEzQ6miWmBAtxqeBEKnGSvNQ1zSWjLvD47j	1
208	2vaF7Xnk1uGWasNDAxWioJNBWd2NEoAQtAf89xcmZDwSFPGtSYzr	1
209	2vaRD3Luw9g4pTY9wGAJH4kwiv9r59Qxkno9zzE2V7dKmN3pMuPf	1
212	2vbgvCPsiFYtbwXQeiXxrnvVvU8VhqZbUxNoYseeN5eM3h4VpDiM	1
216	2vbN2NQc9rKLkgktXsxBxd5FGBfzjKF96g5jm33itoN8aSFCSvPQ	1
219	2vah2mjEBdR5PNNypnt6dJmiZQ7LWcgynfrCYnYCxJttTmWy6UC4	1
222	2vbWLk4B7D96bRVds4oiKd1rS4zoHSwfHvqycMoTJDpZAAhfiD8n	1
225	2vaBADQsR8EQVe73up3ack5JDWDmShxiiHrsUEoXqLdbUp5TCVip	1
228	2vbkwjT72ZjmX5pv6Le1a8eyqLMN5ZD59dXWLmLQxhTTDuHK5Qz1	1
231	2vbLRCRoWxjJ2bBxVBR471affvwnBznQfCK78MWQ85UW9NmAwW7S	1
234	2vbsaw9AqRSPMAAdTGSQVwU39TaaQGP5kmpLMjvYjYfB8NSe4ucf	1
237	2vbaP5wUyrREcakx6ezmYc2fr5k4CEoXbG4BxwRyWrsRU5HG44NB	1
239	2vaKttkEd184Ac6GdZaw7NqMUyrgG6fUTvHcXHxHoj3uZPV6ts5g	1
240	2vaCMzHgZi3kBdc4knU86hLNt64e7NmY7u5bJktUGRUAE4FApA7Y	1
241	2vbsTpnwku3539GVvjx7EQHtLjWhSRP27aP1et3PiQgx1qFpcYvf	1
242	2vbnwcCRvN51HbdVzL2CB61UdZwf53GDnvUoyPqrizcZvBe3dTHa	1
243	2vbCwbqDwb8qbvC1ue2EiEmgeSW3sLpKTR7iusufto3cKbmNe2gv	1
244	2vbcJG4DrJw9iapsMvtRi3Xvfmrz4jGUVwk8rNEiFDYP7NL8WCBB	1
245	2vbwj1wBn34NCZKj27JuemgZyhUtdnd7NZ5bxwcwP9PKEv3z41a3	1
246	2vb6EX5jeVryEapAkmj9DM6GjPH8drn97qU4BpwfZxj9DRJAE2uJ	1
247	2vajBbxqcackpUFZ1GNTbYsfxT5EyXbcLe86c2Yh141uuYouaRjw	1
248	2vabSxhgdBUZgfr6EaSmfm1JxeQqZaXgZjGF9PsnaJQFr35s2Mgb	1
249	2vahhShD8475S5oyieufGc6TBRNbRc5VqyitQj4FKAmKk2wLJ81Z	1
250	2vaE76tFNKjZH6yKo6U1MXwPKytkms5PecsWvfE3o6G8TiF5FH9x	1
251	2vbrz4TiCdZe8QsQWfa4q28vTpzc2qb7jvZNEDvTuqPXgbhBUGet	1
252	2vbgadqci76pTpGWzr8Jos9NF9zSP9NK78g7V5YvXvXoeuyBQSyH	1
253	2vbZPVU33EcihbZefjXxKVoCCe4wJC5VY9iK5iKHLQz3PEFnmcNk	1
254	2va9rHqUghXPGPJUKd2Mif3KA3uTALWrwMzBMCDoKwv95Ciy3BRm	1
255	2vb3T7vp4LWQ543MHT7rv81U3XQg3MyotGYYWX5B3uLKmHebEDic	1
256	2vaBJK1gxot98j1oVLwK56iX8BbdEZLsshH9A4nLfjBaufxVvFhR	1
257	2vbkJdNxWAgS1GZsKbKtEcn55mMUChTWSDQuAH4RobMVtpf9Jc2i	1
258	2vaH6gdagW5QZEwxRGoe2cevvXd65zJyNGzZXiacLDGW9ebHmHFn	1
259	2vbKi4fkAKG5vit1ucNuFEDXxwXRuQqcLC8h3pjJA39mPN96YK47	1
260	2vbHxCuPMnX2Zc1iWu4qa8x4bLn4QRZ1ZSB4TA9dEkkEyuGqBDui	1
261	2vapzEHgRqh7g2FvFLn878cVnmLjyoJvUrs88uCerC1BVUmPEUSF	1
262	2vbdHfCjQoFAiYHcgeiUmc6d8JMdskR6cRVJodVGJtqBmjdUcTAR	1
263	2varQpkU59brYiZgDNCANMy4wYz1oZeM6VD1pN34L67JFK7mkN2Z	1
264	2vbWatZrdH6cXiCcZBVsgjHQ152jfGgkhet9WLw3azn64XqEkWLw	1
265	2vbue2HYcHFpD1C5xNmU8yiSj5bUQeay33kWSozsrgcKw9JtYViu	1
266	2vbn19AmktU5xMYG3rCgfg8TcogcKrXFa3fSh6gwdWFpTPrWTX6W	1
267	2vaWs9cyETA5tEcBXZJzD1zdJKTbeaGmeq472pFG67dd6VRa5WLe	1
268	2vb9cpScuDF3UQn9VjaCDEQSEb3YQUAfUoSBEEV5UoT5F7jG51x1	1
269	2vaR5c48Rgw8AT3o5shgHMcne7q4XJx5uUKtfopKf9ZePFtPWdkL	1
270	2vamgBK3UqY9C2KQxxM2EoGrWKHx43kT7EKwqnC1FFED23ADYGsa	1
271	2vaL48y2ipWRcV9TyaFn83L3cQe4wSBiXa2HaHLPBWq56qVSsEjG	1
272	2vbqAdqfUVkWW3bdRZrX34qNnypuAxwVbmxuinHW6Tm92yuh8Nwx	1
273	2varkuLcQRSqf6SSjMtheZrJ7e9XjKVVsbaYD8YwHPzy52YFpYSc	1
274	2vbFmkcEkDdgKwfEVcVJHN9tCJ1Vnkvf8VNonHZyQJhUD2v1dvnB	1
275	2va9FyfbX4HoG46h5Qg9GdjkwAcKGYHaCp9KMFAaSoi24qk5QmVo	1
276	2vbXRsmLcSMJbTHZ5TWoN5LLncj7ew9Tbd6PVE8QgYqHJ2vHmfpE	1
277	2vbL3V8yJCioBDZDF2HrydZgXbdNB76cgeeRRpomojBJResQB4Hb	1
278	2vb9XwqQKWc7ibvFghnLP4UDFgsq2EykfiaGEy4AgLm77uXWRz5Y	1
279	2vbQFYhNQcfwCrjf5sYnWUNzb4aMau92Ais9PgKpEWU13UpeYR3o	1
280	2vae4TnkCS6z6R45tvBPVcMnEsKZrmDDXASZhPUvkxTeoTdL8FJS	1
281	2vanRaCMRJitUyFmSMtF1aE1bqwZzdDdxo7vsca3kDUc2qDkumJp	1
282	2vbQiRW7R5KiESRK2R5rBuQdXQqreZ3drWoUhzcrDYr53e7SW99F	1
283	2vavdswpSULJ9RXbnE8JfeV7GZmrUH6psPK3toJwrQJHu5gDBPHs	1
284	2vaqcGaC7JJeqCYkRCMB6F7qwcZmzyVJsGkWu7QzAvKipui5So54	1
285	2vbzz3cK5mPsF7dXv65DY9jrsj93dJEsvAmPV1K4oPmELfrpG6bG	1
286	2vb7fd6qr9jh4Ms1GYQmgMdjiNMJPaFkZVJZo3NYdw9PRikbqiGs	1
287	2vbqvf24zdKEWiZxD9qjb6QNVPgxFGeieNYVaKyoocwd5kVSGqY9	1
288	2vb5umGS69d9wEiCBrv7tiwgk8QhvomMu6vFk17S17xE8C1NfxL7	1
289	2vazjD2DTMUUEa5UHnHtmvE6rWBcNdAq8wmACtd6YMPkjFi8mVpD	1
290	2vapHMf2MP3xQrVrfh8R5kDTqsokMLD2nos7tkjusewf3QVvhFqQ	1
291	2vasswbFwK4v9XkUif7WfEYUJCtugW5msykwdPsbMYigNs4xmH6x	1
292	2vb2k44DRMGebf4FMYhMC7zZe6B2FDVdsMwuMEaFvGU2GrEUqsSv	1
293	2vaWhJ6mD3PB9AMiH7xH4dTTkEgCuLMgCoXDroQTSzvmYdkZQPte	1
294	2vbe4TQTxeEHAq5ZYKMRiBA5HmiCUZsADGv6uRtiia1fztEj7Zcp	1
295	2vasEqNM7xA9Wdk5VWJB5KaXW6wczDUT5QMepCvasmX6Q4GWcTsR	1
296	2vaH6zkTndSNcYK2j5d3orCb68BNpXLnrvabLqnhN1gAcKmAYT9p	1
297	2vbswbkvFhRaY2JpJnbDUhuoAMe2fhgiSY4fjFHGjF2mLxpUbynN	1
298	2vaPW1EMSD8UgPt8ttXxpyGZ5RgfThKjKratD7Gki9p4vroXvaWK	1
299	2vaKo9DWCdbwEG9SYUjQ3S5UTRkTQBhDFwJgoqtsqcdVrPPhxrxg	1
300	2vabn4fd7doYGyHwyQKbXC9E99e5GRdczuH4c6kZQocgmMcCgVnN	1
301	2vbR3hpYiqPjtbEcbGqLWxu9bdxE5enEygWsVADVFsMSj1WBT48b	1
302	2vbCMByArUawXtgNEhHxn9GeKLpQTPojmtur3B8r9jHtoBCvJJsz	1
303	2vbteNyyk5vCTpiKCMGrBgAJDqTgNqNe5UzPdaCufpV3gXmKcdCr	1
304	2vbqbckntDpfhR246nBz4ecd5Y2JeqTnvbjjR1NNpx4DC7ahoxBN	1
305	2vaAhcZjSai7fob3hTobUbDGjBwmG6qtGRhxFhhSBAn6piYw4qfJ	1
306	2vb8gcRZ4YswksvcwihbV5gqDbdSduE9uHXLajB9tajy8rfnFYsy	1
307	2vb7scz7bgbmEVi1buyxPufwK2LY3YEXyxRuKjJ4eDUoxEQsigpV	1
308	2vazRWMDxvPV8AXUXGennJjEsu1zsrBR9fWvguuWKFCVY6GArKgd	1
309	2vanX95PZaHnXJuxgfmaFs1VmqNnZL5TvFKpRMqzEvqHqVmjWqhw	1
310	2vaEAKbDVCuGkbDVVjD9KUbgVPYT18h6iifpeYvYpsHJ82dESXXE	1
311	2vaLVSNcAQTJfo1a3HHUoXba7vfbkQjNRUJeXyQzoWT5n6y2cH91	1
312	2vaDpesvzR7w33myvTdx6aCHRP3gPC2vC3ahDpkYuWTnxqQkeAUe	1
313	2vb6VKt6w1pf7Pz3VSZpVkjmcZa45QdYjzNfPDExYzCgCq6AeigT	1
314	2vb3Sb1M5MtEgMqB5H3Wzqa5xSMWpnqd45LXCVLEa3KX8jWpMAyn	1
315	2vbLUqMgLr8cLWvUkR6QdrkYewrP7QKaiNRP2bEJxwDScF1TRoPe	1
316	2vaKP5rJWBZaZbqCDe9PmWTYgSzLreUoYB4TkYfdfDcwYZ8NN2q4	1
317	2vbr7XsxuS7rTTxgPQmpZ6qjb6v3mgwwXfXSPHweJrXxWW2zhMfN	1
318	2vaFPTTXnbDYMwikakAz1KEsSTRjqmgbPdCxynZ3kEZe6ed6HwWc	1
319	2vbcZJrgSfNwbg9Fu8hKt7gqRSYhSfBWH4rEanSmtu8fd1kBBWB5	1
320	2vbbub29siz7TRQV6sEdxcbuUdDHipQbzChfsQumcRoUR5wAhBuV	1
321	2vakuA6anQvooe79KR2rguaBGC4TAygf3RzUMvkVt1HK6wkdaYgj	1
322	2vbtv6CgsqNhk42ETcdAR4LxVN8A5aDqLraGSe4k7eqQQmvTifqe	1
323	2vbgqbckEQ7Y7hAbQw1xgVG8QRj1T7tZJstPCKUp8b19wgScsvMU	1
324	2vaWPzehQsiXomi9Ted65KDsbVz9trJDQ9orSsFEDKR3fdrxf8eh	1
325	2vb49Nih1wQstBcgjUUvuS2cH1v5C7cT6MwVKfFS4ojD3ESBnP7w	1
326	2vbBgCUrH9kTVqLHv6yAhAtY7RJz7Naz9pWsXfZKT6Nnc8CfHLXy	1
327	2vb63fTocVjxv4Zp9MXy7HcoeyvTzNM7bhNjNk4WzLG2sa6pZuBh	1
328	2vaZFQmVLBaSyMHcXRieHBVk57aKtGnjGFCyQtEwvjUJ9Hh2F3Wn	1
329	2vaJsTGpVzwAW4JJDBqZAsKNV38mcTC1hErU59FCyiZLBnqtnbq2	1
330	2vbwvQx4i3KQKEJPAWNp8xrZ1KQfvirLMhjCcr5FiFtrKnKUoZiu	1
331	2vaFo7sgxUURAdcyF39GXCMaNJyvqyiLXjRntQ37u6Qbg1FoP2Qa	1
332	2vaqwCsx7ksZLDYxea37JvVqZjYYPPxz9473ikncF2SGwZ9uYVcG	1
333	2vavNbiupd2tjX4HcUEW6yuTzQAZPfi5Knkak1UF1RF2DVRUX5iQ	1
334	2vbyNb6ZuimMiFomjW7J2JTBTwscnL7uGBX9TBVjbBLXasYrorYG	1
335	2vbp3e53QrTyzT2fsQ3Kw5VoLPGRrsX4cU6d8Lm35TdrjyGvpG8c	1
336	2vbTTQdnb2yTEqMCUrHpxNLGqN1sErbifikNFNaHar4xrEfnVKTR	1
337	2vaQdRWBLQ6WTBW8RaD93VX4noup6613J6SosoTn69PYWtGcxo9T	1
338	2vabHTYFB73ZpW1ZzSHdQjTzXG3W7meixM8D9Sy8wrmKfCfhkcoK	1
339	2vaGsnkvzqgpm1sUoVTwG3qaLFeAYNQi15jE2xLgguX1fPUcZCAZ	1
340	2vbAPvTLF47TFbFsF6egDjTpZkBrZi4Wp2AgpsvT8HLu23aLqVep	1
341	2vbPXYm6yxipgF9Ym75KqxiwPysVaMaFz8WiczY5TFsBtYmi6cp2	1
342	2vboUacGu1n1ywPEELrV4ZCqCguEKeYWoZRxAUiGtyZychdmQKSL	1
343	2vbbYf1LqNMtqxSJ4Gj9AxB9b8uKSj3n7NY1ZDjdV7Qv4Gwkb6vH	1
344	2vbd8fY2W3o4f1XcHFMWGGBkiEuCk8eixMNRF39YjKsX8ox1g8Qn	1
345	2vaZRd3euW7ofso8ByvWuvZzFjUwmsMjm7kGFg9oBEheiknzHDze	1
346	2vbrq9dheHEKqP7DN2PR143X4q9M31SxQArn3AWgG2ybHoFYuX8v	1
347	2vbNha7oTH84dtB1k8rXpndsAa3kYPzLPPRYjxLrGe5RcEgQ1FT4	1
348	2vatgQNTomTwExqDpAH6zHnU7yj925h9sc8p4QQewyMNWZJGuoee	1
349	2vbYM6hgHvdTJZa7YtJBeE6UTy1GJJEiWH9QeCtqbKgLfCgGCuj7	1
350	2vaSQRCb9WsctSuA9Ti6AmHj3GXTLNDZxu19vU9ZSCKmmTvXPKt9	1
351	2vbrPoQrgVfJnvtWtuKCAssbjLxmNezC2tar1WPX7sMwZksTdVEu	1
352	2vc3DWtLprq8uPNtBuRPWbQqEsgqBnBAsWg96AuConfraoVQZzty	1
353	2vboPtF4mudSp3UYvS2iPNieMBmWkBJ4eRajYPa87YUb26UYjLZv	1
354	2vbqBgn84f27eFFuD34AncLxHpaXo2C4r6phAdKhfDTRZuGBjJhN	1
355	2vaPWDHn4zmJAcvxVfbiosLX9phrHTnVhQTcPkjiK8zXq4ZvcXmV	1
356	2vbsJ9i842NvTWppvxVdidzS1W85ByYF8bJz811vENBvDm9NX7DD	1
357	2vbrZTmbryu2WQgwozu2C4gijcZ6y5WfpEgkatjUeWbHcPFreGgb	1
358	2vauy3gagDtsVGnuGW8T55snNLK2cHSaHeN2NLSr1GDmSnyDBxFz	1
359	2vbVaE928CBmxnJx6K9CVdToq2f4bGaLNw5NnTPDUZi5iDMosMvF	1
360	2vbk3o4MywNjUmgfWTiep4FoTgFvm4WsvryDGqPRxSkvb9YqrnyM	1
361	2vbf4YJL9BvcxBZMq6cimPkz8QPyxZfN5FLVPSr4b2yw23kW6Dwg	1
362	2vbTcHFWP1Wt7nnfum1BxjxprEaRhmRjGFDqAfhEVrdemcWg9uLA	1
363	2vbFPV1DdPeQMEQ8nwTyTpCVrB6mpkBMwsHUoFGXruQZee8ZEheD	1
364	2vaWMFnFpuGHbXf4oP6bA5KZxJpty1yGKrGeNAbXuQkqbypz7QBp	1
365	2vbBAhabgWrD9NV2QX7A3FUd2DNMbGYPFyevq9tmv64vmHM26iQe	1
366	2vc1p86BWskx34pzn86St1Y6jbXYPjAQFerZiALFLNRrBPaS6Hrg	1
367	2vam1BZKjrfruGu6d7F1gmijNPi78qoN95aSzr1FgyEFUofdEozZ	1
368	2vaGLHvVUr7x4CnS1rdrRjCGVWwcKm7bq7W2rmWPjWwX5rhMut7e	1
369	2vbm4u5R6MUvh82pmyRu8XK6QxAGgdDMBjLyt5V7vUkQjWTCvu9H	1
370	2vayQSkNLzEx2vDM9oZVFwjcxxa9BgPPLiTUJ6oJ74FtWFE9gPDG	1
371	2vb1K3my1i2s4R7x4qC6VveCvEv8BpzJwK4M19BYkcsnVJneHWTk	1
372	2vaKaan2x9m9AJRdW3ZEEg1csZt5oCe4XVnRkgCvwKFgW7DNzE3u	1
373	2vbKhs5s3bDErcZnDR1K11Jrcw7yByN2Dfh8GqGCrGjYCo85sbUE	1
374	2vc5WFwAX2S4xw4W8DiVkjn9M7YrRSQiUxYiGVwjDwt57e4jvn5P	1
375	2vaMte5icXxiP9fG5Ya9m2eJWZbciU5BZTEvtTCgEVXzzNq3Ldcg	1
376	2vabA7gz5yKo6gYnrzZqUYsbwakQdy9sqatTdNAzHbHHgsktpqS3	1
377	2vbXNnQUP8tNhmDnZV6tHmRFr1Eu36N63fRnaDG8nyTDhfvcKTFA	1
378	2vaCEnLm9BBZf1A6ftjSNz4c636SqEwpJtVSaS4JuJXNnUt1qWfL	1
379	2vbJna72vqrk88r2hwZWKMPJRusrAkQLHqvMsDfLRYDEogTNetMw	1
380	2vbsbwGAjtwR3HxD33henpadRqUXDMJ9Q4TqqVmgJT3UE8YLNfe7	1
381	2vaAxMN65Z4TXfyPvAvAApMwxN6usQYPzfuLshRwF4riwsDuT5S7	1
382	2vbsXrSagQoonRDDXk74147VsJac5Lmjq9TW9j1gx7oPZuG1SYSN	1
383	2vbk3z4cFKWpsE3RnYQ5CbgAfg8MgXA9sN3qiS23iCWiJHnt5bbk	1
384	2vc5ukf2bZMNNqEbmbK158wZZ54vDgz1gxZ9iE7h7JVv619LPVZi	1
385	2vbFC2w9qeavx4iuk9rGjxY69AAhm8tmpAEo91gjiW575WwaqGJC	1
386	2vaieqBxy7aVwfrFySmpkf19JHz88fAGkqcTw4K3zgr4nUquSjkg	1
387	2vagZSrMAVMrh9THZh1QSMNoM3Qsp7BfjrFSrEHiFg1YNAQh2hrt	1
388	2vbRAxcY3KcFc1RjBvqYkmjV9pYifCTQW7i7x5SG4BJMVbt7yUre	1
389	2vbf688pKerbfKVRmMqWbAp5VzkaUV7LWGAZxqhTsZ5eaMYxzAfB	1
390	2vbj8xKNqunHL9RzyBGUh314fAEbDEwfFQsKP5fGYsAAgju7D6EC	1
391	2vbdqL5Ye61ohgBHXBCYAZs4ESRizPikrUCv8tnt5Yruu72sNCfP	1
392	2vaBw5tdKLe3vT4dEUPgRfXNWycg6kqSkbAPYCR1E1uTFefSh8JC	1
393	2vaitxB2tkhpYE3X9RPL57JRqrfHFBUiF5w26nYRejRphHGwA6eH	1
394	2vbKJz4TmtBdiDVYAAHJsmHmtmxDRFPzHGTQEN8LsJFoEs9TJrjR	1
395	2vakXoQT61jgNBwD2PtZUwn15Hmwb6b1GkhYzyaj7MYf4eZaMEsu	1
396	2vb6SSvnYoDcRpXMV6ypSTmTG4WDENvJE5W7W1D935fVGKXiYMRe	1
397	2vavDqrUBvmjgnMBz2fav1oBfybJVjVpwmDm48L8AuDAku5jND5E	1
398	2vaw2p3bKEfhZ3i3GsbSEdHxwqSfsfiuDNcYY48fWpTw2AMU6vwJ	1
399	2vabqs29vHYz6ZneeKwX8YQup3SLuRtjPNzNLiYjgYhPjpkcENts	1
400	2vbzGMTc2fmG34yYuFZ9Q6SnVPyuuKtR4ep2ixBJAz5zyfHsxFSt	1
403	2vaXv8ansbWtcUh8w95WyoShHuwZjMMF7g1pzpAhcJkNeSk9Q4zt	1
404	2vbHkAin3bUkj2bJ4X9RFjxBgj5JTo5SMxoXy5CG5pN9yQofq7cr	1
407	2vbFtFYXex2rRAxPPsXXGswLD5L1UtnprpGLyQ3762xeTdyfA8sX	1
410	2vb53d5Qwo9g4gJU8dyXAMHUdy7A8gqEXjR7nN8rTQwg9Kh9yQdm	1
411	2vbJf5BQh59sTSVaUdSQBqKugJriGmM9x5WjUd5m3fUSYNAtx6t8	1
416	2vb8SVru7tSBmpzSKFQMCPaU8VgDukMASGxJeDnLRtHCbjoXsf1m	1
422	2vayDuwyPrd1G1yQpHA1CoUJ2pTZEF35buDgrEEXzP7JFuqcDSWL	1
423	2vbbMbTXYqmzfemTnKLn2XKtuyJxaBj9MCSwbKzYbxGERJECSPXw	1
425	2vaMEuNHw3mA9qea6ANi6eKEBw1wnhafrpUzLwhuSX6FLVV5fNLY	1
427	2vaGW4Z7317CiQJdSiXLTUbQCJRRGVSaFM5A1Dvq2F5A3aPGXMUk	1
428	2vaJjtFS1XstsVSEu8SSYfg7SBTGkbtEw1AUTwEmvFEVaZaB7PYj	1
433	2vbZ1bAoDZZhAym79L27d4LVs3Bpsmhahp17Th1tzwAHdvF6ZwMU	1
438	2vbZk9vsg4fKvtkW2PpreV2iymcn3XjZ1hawH8mhmz8Xr6kvcuMS	1
441	2vbJWZHSHKuNds5wzgJ7faLi5EfoJkujbne1WFF1RxaMZ8Ney6JR	1
442	2vbfF72uRRVdPzbfFSr6W3jzxAnC7BWYvUdyTZ5He3ynhiTT7fmb	1
445	2vb41sRgyGM5rw92xnMvX24eVMFuKuFjrCANneSbB3tQZRv1RL2w	1
446	2vbYAqNQyDduo16aSvvrnKcxFunmcXdxYSsRga7ig3CwCyq5w64Z	1
449	2vax3nCUxwCxqwwhs6aJ87ozGihqq1sx9Gi9opmPaKhG267AWPBC	1
450	2vaSUmGAyL6oTLCCmxBixBdWqXdBMibanhnhtDQ8L67HUyLq8ivZ	1
453	2vbDF4shPGG6XoZoW7GSSvfyQiWFW89SzrNZ9ajgpvKM96rEXfMt	1
457	2vbxAe5sevnCrU5R1ooJvYPEHoqibxRNJvFuLQ3CPTms3tVnmSho	1
459	2vauGbZxgGDLvUsMZM1gRF8q1BzgFpYpj9zJws5u5QSBaojswwVu	1
460	2vbm7VeYimPMVARFsGw5uaCMz4RmSwRjmL7TojAV7E9tnS5iYdNS	1
461	2vbCCFPhv17CRcTvWXrwbirVUua2QnxCZ7mHZQ4eb51VSNwB3Rpp	1
464	2vbBsBvkLk5ERpYE3duEMeHn3jzA4o13PfhXwZRVyFkzsF9Scm2C	1
468	2vacaTtWQBaiiijrnJJ4pRZYMkKYRhnhopPTdWZgKXcDodWZiiM1	1
471	2vbtquSsew3xnuoVpyPKtie1iNd8w7koWFsna6FzZxyBBSwLttMd	1
474	2vbFrpTFXTmnnS7CPBHEVVVEAVRJRL7MyGBg8giUF4iejmaXE4mY	1
477	2vbDqXgBjYn2E8iTNbXXMnW3UJHTw4GM96WxdSeincUybEWtSeXW	1
480	2vbuVKzeEKb2QPL627HbYyCZTz6wzsqvPQqABiyaZmTVaU92iQeB	1
482	2vak7kYZYcq2GTeJiGnnaMoXRWGu1Y6abDSxF9MuFiCW4Mq5MCNc	1
401	2vbxWebkpG74Qn8kxkr6Duy5trxMqsMAKeYysxtQXgNZYgbniunW	1
402	2vaV3AWobpRT5bpN9TGgQ1xcrSQ6NqLPcxBEXWnunN2kYS3ymeBP	1
405	2vb5esQC7MLFDfWEF8VS266F1bykkKqJ1DegMemxTvXzPvu7B7Bg	1
406	2vbXfMBkzBt9AMpBpD9PU4EZJCZWWTmMz3RfhbvWKnvcXdrs18PA	1
408	2vbbvnM4HvWU659AAd9mhhu8WAHWZBrPRvxhUJaPN36mVjktnipE	1
409	2vawFpnsTjLNeAnACbuSev4GCxT3wLDBcVh3bsQ4AXwfzo88FbDi	1
412	2vbBt8nPLByiZaUsq9pepLAabhW4vamJssawSgkwQcFffxdC4VYr	1
413	2vbZCqTDsgBmQ6EuVwcgFThmzdvMbeYnCz3goAj3KkaegfmqtDmt	1
414	2vagSHWzdEma7vN1mX2nHz168q6Cz8TdfhwgW1z2sSDSJsUnmeAd	1
415	2vb12kjFKWrDYyicdrLP6KKbBmLotFXEfjKowAx8KknaZ5FsgCYA	1
417	2vaXtVDNh6gjUbJw6oWs81KGxcQeEF7THGHypajBsaFKR12gLJyb	1
418	2vaEpuFHr22nCzLWi3qc578c2peHmbex5cRygZNj7fCy7we7RFQd	1
419	2vaqaJ4smX5JmRAL1MiUPqZjRTTg7fTgkk3y4QADNS2vDbMZh5yo	1
420	2vabM1o7ujszY6zmd9HkRKHYD1wRVZA4fG2kbYF1pbZT9dj7zfcv	1
421	2vbMBUmqe15pXn1ysPhfdz7BskEEs7SLcoTTwAnkf3sSDNkVvt8c	1
424	2vajk4QHAUddJTRMMH5FnQHGyxsA2DfiBPssx59qqxzCquzcuh8L	1
426	2vamVfL5KWqB4DohDHcn5bVaZeUt6V9GwRWYiQPLU4XN35Rbgkfb	1
429	2vaWMfFivwqHzPuRTR7Gk9rBHbmoYNXVPtZoRDJfDaYgG1TBp2jP	1
430	2vbGpZKNkU1MPxvTTpT2onywru3VtyFAv2fw9vmeeEsVjtVDbZHy	1
431	2vbweKjrYa5LnsE5PLTMExfiCSkvntxGEwBfB8UMZ2a8VDVG894r	1
432	2vaKtcCKPfhd5M54RjBYh3HYQEDzhGZGs66Q6gbqqyHsBCUNbvkh	1
434	2vb3WdVvt3tEYdWVfpg3iB7Xpq1FgxgRzX4zTZdHDmxUpdycyBNY	1
435	2vbryiULgjPVWDTrB6asYxVVDuAy7P5C53QTtJNpgYq1uxRjsfbb	1
436	2vbkyhwqn4QgyFP6cxFmZpZ1oRRBGwAnY8xw3f4EcRNgAsjSHsVh	1
437	2vbixPd84BEkSBPB9odwbEYUimpdMG2iCVs1z7xRoMiyQ5BdFHCc	1
439	2vc3af6KuFEGdMP1AeCfvkCtY1eTNzUqPwABr4LoG3MPN6tXa3r1	1
440	2vbB5UYFwoSu5ULU2bGBgmRmEWq6Ufxz35BYJT6gv5iHFVDKZKLH	1
443	2vatPMSNoEAHPjn85gTzQieRZuBzkccMDCh8rfb6N5U2B3PPdC7u	1
444	2vaogCxV4d3QKdrfd3qtN85g82Bxwvfg9sNpaEawb1oKPPHQDCKN	1
447	2vaiFCwcFNSQPa5XmQDBmCCAmuBHZpWMcrY7FzxPxwcJPWNMrRGX	1
448	2vbP5Vro86jzZ6iBiGx6cY21LuDJ3Xho2pcnZCWGcXRWqv2jgRj1	1
451	2vb2qkgs5MQ56hz5SYQs7z5G7q3bQYC22y9f1F73kDrraWPgLeM2	1
452	2vaAyZ9dpAMsaMQrtSYHFhV6AaLc4GoVdiAJM2oFhKyKSPFuiDHR	1
454	2vaGt259aXVbHSJCRH8gwpxMf9PgvMJHNaNoZFkHZ4Gax17tiVaY	1
455	2vbWyUKvi8LQ34T8fDFjAstPctQ3VM7X5bew5KTxLS9HKYD8EzQn	1
456	2vbyHnr9XTW8Mzf4FUefFjHa6J3DKcxF33nhfaUJ1QXnJgMKhdTL	1
458	2vb1n6DkrxowBrv6sXLeAdQbVLeS24Z1EQ946z7FQhtchvngG972	1
462	2vbYhFHnDyF461UKjA55YUcP1rap5pyW4k3YkEcSQiziXx7sWFZ3	1
463	2vbEJ71oQbM9PfwefQ27MpQS2SMEDhcKAUHrC6kjnM3WG9xra1xL	1
465	2vaQyu4Hw2HzHxdtepQe8xYgnt6Yp5Cug4iy9VjjUbzEEEfqMQTB	1
466	2vc3iHS6zKRphKnmg5wUPFk67nvhqg82sn6aCQCiEzsA7R9dSf7g	1
467	2vbmPECH2gZtz4nDMWL9Fjpdb5SgMpcqSRJWuUJABQgsRFDnZBhh	1
469	2vbypWGu2wYhzDu4J8sPSpLNGCueLJNnNJZhacKKgnY8JFgeUqKr	1
470	2vbG1PUYRotcBBKbatRS36Qgxvca3h4sL6Ze7quKEWM4Y2hAUKvx	1
472	2vaRt62pRwqLRN4aek11b7PKRM25AJYaHN9hYhneA4apLV6i62dt	1
473	2vbrrb9fH2CzFoF3PTVYtBL7v2nkFtFq4QaueQGHBuSZaG4isYFL	1
475	2vb7vkdEeUCRVAAHtEBhEu525op1ZEobMKkfWP59rndXzXDVJJp3	1
476	2vbfMaPBH7ZdxjLnnUqQwcxu5WjTabbKS5gnK2yF8K8Ao4yVPkhW	1
478	2vbZbL7HWVrvcCmpRKg3fe6nHSPSVwo1qHA2xeZ5nJd4pt9YqNxa	1
479	2vaNZZ2BzBC69k9WEDis1vjZFAoHKxjh1tDaLokkBH6ZHWpV6iGh	1
481	2vaCYskaLH6aW55sZKrv8jW62m5bfZu2WvcPPidqMGFqaqrePfpz	1
483	2vb8PBQEp1nFEwd6Kc3Bj2dn82fo7ct5GKdZNtL5hDHnFWCdfEoH	1
484	2vb5putTZv3jTri2eCmWsBDfgQZNVUkb5jApDisDuqNsD43VyZVP	1
485	2vadtzzGaZB3gng9jjF4SkDJYP249Mgo9axwHzj5DT7h16AsJXVe	1
486	2vacyyM4wx1c7oxy4SmZxV2SLcYDqR9bnh7rTgGRUycfqLZxHt6N	1
487	2vb2BhBwXjFghxPq67XnBcHUwtJKyfF25gbc55UdT3fCBXgPhNJx	1
488	2vbAaj89qPk5XsJQUPk5bVx8fYW7YsyUxdZLZMC17rdd73RVGPLb	1
489	2vb3RJMe7gBUdGz5qMp2pQvjHhQWSpja14xWs7w8vk3GVV2WTwx4	1
490	2vbH5VLCedh9XxxPatXYTexHysnNC4D9bL3fUujFBwQzqttQQxtV	1
491	2vbc9y9XQBknDrLRHAn3iWA62MiXmmVNo5SKkq9YZcQzDfDStu7N	1
492	2vacUuaQU2eyqAii2fbMiKBfXUAuQuMstkBqTzXVER8zKVMd4HUR	1
493	2vakfeeHbagusvQHggTq84XDhxADvcjHs7C2PzbabBbL9CFgUt6Z	1
494	2vbdTgGv4eT3YbqJsrKtcuQyKnBWQmsba98SxBPpLkQoC9YfEy5A	1
495	2vaoemo1M2SJg37XdcJYU52iiuKKM7vW62nq34yYT8rNenqpPiEF	1
496	2vb25QQhUTtkzKf5TufJwrb2hMox736BJo3MUuLjF3aNn1kzdKhC	1
497	2vbsJGzytWGgz71GPpamezii4B8CeDrxrowAT1kCmF47ct1JQSnb	1
498	2vaCjhLW2i3yvHCbwCvXRkAD3dv7KbNtU9B1HpKdGhngLEYvcG7c	1
499	2vaRtB94Rq5pPqHEeyNfSv17qYDYfipnVMUoLudqNKjC8f591Pfn	1
500	2vah9oXRPKske2uBTJtoEmQ2kn32E6PS3xaFsWLJFz85nqz8zqc2	1
501	2vaxnFJ27ZbXdHxswEpGXPUnmS1bMX34LAynbnvADSCusnrDURzR	1
502	2vacvuT2yS1rLMcVjpZfAbvTcSVx2ubJvkhe1URGawL75nzNzkqL	1
503	2vaTxR3FCpRnsXM5UCjS8ihcHQhP6bRuDc5xwe6Jj6vC5a3YwFpj	1
504	2vaqiDiSjcbgnxbuQM7kFJwr1QnxPiKKP5SzNVs5zsGYubJkKmg1	1
505	2vbnYBfJyvpqaMwuz2wVN6LLrDTscSpSWyx9ApTEB8pmKhkYK8Y8	1
506	2vbm9vGpSMc9Ncjysn1TTf6y2Y8hMGcHYseorpiznGfgHoN6A4Ai	1
507	2vb4N1rXUdn9sJxNaU5mbm42u7cLyjB8KhGuFUmeX77GhJ1a1sz6	1
508	2vbaPRCYTQWchXB3zzwSC2UeFYhTkfimzshs2rAoFwrNSTcDAobe	1
509	2vbrY1YvaPoZVhE9mjWsEgNsgnJ1sfAWSEQcykQhtKL45DfarDYt	1
510	2vbYd5VN1aYENx3F1YEZqitojAUcPLLs6Y8rgEmN2WeD86Hj2Tav	1
511	2vbaLcg4CA6vB4R6LV88pvQUG3PLrfUpzUX7mBtHVe3kZc44YRbx	1
512	2vaB418518FjBmVkH6ZUf1y1KLRghPhyqPkTzysoGVUm3USmLefz	1
513	2vao5ysBeZHYoSPt3cBtJe96cSz1BvcYUzMB8uzVKCb833pgDMXe	1
514	2vbmGC3gmRs6CJrM5r5MYsKMegfhMZ3oQYTHV3rX7DDGweLXfHnA	1
515	2vbDW3pGRJEsZdhmGm19uByBdciGY5fVNBdbG3L1FMj1mUgj5coQ	1
516	2vbkM3sxqaLQRbC6RKNXTEfSG2rmYKG7fmBpDBCzcs75MoDSVSYS	1
517	2vba7qYkAcjph5gVTQSn4QNRTkDuYwwXDvKo5n7pYEJmxXoV4CvN	1
518	2vb5uX8PyAL2tVAr8AK9MX3MhUMzmbUeyD8CbNZjKpuc6txa1Cdc	1
519	2vbW1adxxHrkEV2AuDfvW6Z34tZTZRkfxiEBw2dGXp2Mn7PyRJUo	1
520	2vbn8U7GgTgyF93qjx6VtSWBjDeJBcCqAzZeVNprDTp4rh32bCXw	1
523	2vbsxT3QaJCvdF7mhj58bLBEuhwvC3yRhUyPpcUWy28BSY5iFEf3	1
526	2vb4HEhGMmCMYnqUrJQD2d7XNx7ytSeKyyMUpreKWdCyZctiyemE	1
529	2vasXgwBSnXUvU67HG2BPp2qhQfZ2g1zhutxmxSBrJjR1NWu8qej	1
532	2vbkwUt2FHw4GLroWFjUsMCNjvHnhwk1u84x9tWzfNAziuYpoLXS	1
535	2vb9kvTbXmMC8xpeQjrwV2A8cavUTLv9FySwg9cc7B42zE5fhRSU	1
538	2vaRvHYquCEsFNwwvB8XsWFpiBvTPsK7swWdFFuN9LhyTCL6Yrku	1
540	2vbzkw3vgwNoGJnatkv8H57qJ9QXAnFCDkSyZEUzm1XjGessUUNq	1
541	2vbPEeHXKEQFMhBDx97jKWJNaTVMt8D989dm34Y4CpmHLgGNSkGy	1
542	2vbxWzaQ38j5AV7YCz1yZiFrV3Sm3zPa3TvrhiDDNfm3pzhu4AKW	1
545	2vaj1jy5bS3TPBz6Y1KmsDrtDwDBzzhj9Uo6BKuwxKJuKedwPxkH	1
547	2vayv2Pnqg4krKwByHitcp3kxCMv5ckkguJu6XSCpiLaMi2hVSf5	1
548	2vbE23DbEakqTyi9pwXRuaJTdTA7ww5XosoVT8aYesShXfyGRup7	1
551	2vbkjriHyN3iwmy44UP6YqpVbeGNbbCYJN6tH4DfCJsMDzLa4GjT	1
554	2vaGrK2AKZbHWo37utTEy1TS3TuzgJMoP6VXU1gCogDG7ME2bvGF	1
557	2vbXZZWBRUH2FvcCUeH3PEAb2tF8XMvgY1Z7xPABgpQ2rFmP4yWX	1
560	2vbamWGdWQ6KLdkmisoWk9nyaC2TLqoFskiJLfa71LPkAfvQjHyX	1
563	2vbBPcogKU6be7XrvhZsU6bvHMaQdYV9JPJdeFQgpP5yEnBiqN2D	1
566	2vbdSHZLdofdg3m2gVUL1ti1RcfHfHqv6bSnG2QFqUcFgLKb6N3m	1
569	2va9nZc5uZEh6ArAY6m3gpthuZ755uxZ3G6NLd2EZhxgBpNEyufc	1
572	2vb1cQBWR6M5gBZ3uZcHFXVcMDTXW4xvu9W8MLn7wajJpYyKejLr	1
577	2vaZbapYSR2dq4x3i4tHA3mgrTegBU5nLpn1cz2ZAD2hiaX28258	1
580	2vb9fx6CYSMbTpF81SRLkDhc6M8qeYT6ZPtYCd2R8niceFcYg2wH	1
521	2vbRu3jDXdcHL3U1ne1Z2kB4yftASWdqQqkczkjYzbPntj7Ss5fQ	1
522	2vbUWw8aCcWrF2Xv12kB9BCoHrv4zzXmNpGyjAD9cUpXn4qKd6cA	1
525	2vahu3Hmandy8iDwUbcew1pzFux2n9cvPQg6s3uH8bWe1xfR5hS8	1
528	2vaeCAr6Pp1VHv3EU2vvYzrNMShxUMMarVhox3USHm6exBw3ik6E	1
531	2vbUcoZH5idnyvUdEGW4Eb97jQTJ9Uhni6nEkKQWFDjvMf9NkSuX	1
534	2vb3sKQDfF2cQUtyNypsNzGzUr9y1qaNs3gScsautZaDdMba7Hnq	1
537	2vbhnGYTsqzrZzLMppFFZEJozDZksVZx9LVaqzYLXYWrJCtLiwgH	1
544	2vbN1THLgQELwyczejjij8zPk8k4eE2iCxqhHuk9ZKD3ZryXD67F	1
550	2vbCTcCaMJXQHZHLf6uHtVssniCgwLsjDM72SXP6QwuwVcffCsm2	1
553	2vbTYxGZ67U2oD6DkDhURhRqo8TeyGG79GNELR9o4umemJQbGtK6	1
555	2vbHTBwCCQv2jSo2bV8sUDCQbZ1VEohQQsDyn14KVE6fWbsJSTVX	1
556	2vc1ZkQnTCRzMQGjmWN5ZtwgfpAAe1fRKXVNzcJHBZLFt1qR1mFA	1
559	2vbJAN9n3RbFQrGi5RFdg7T4izVtxymV1ndcEAhhnfe2TEg78ctT	1
562	2vbvFBye1zjN3btxhpANaJ2oZaaRzfWShGj1aAvDw9EewPhKVYQz	1
565	2vaTBGVAWtqj3ZZba4EupVs92Ne4LMv5GCHzu7CiEzLyrN4u1bgo	1
568	2vbkRK5vd9WhA5CKti3fwCHyni4HvjKHaFNfmqC19435gcanyn7B	1
571	2vahbD9BG7Ce19kGokodoHDPzY4izqBDtMtwpB36JC8urkTTgPoA	1
574	2vbw3TVUrmGmyxaThnibiZBbm3naFf6x5gSLXcMfLXub5gQTSy6G	1
575	2vbnoTpCzzQXBnx5gzhLfyFYPwFajQc6qQRGRRhsLm9R1Arw3JNc	1
579	2vaThAeqM6Dhbc6p6VZymd5B21Qhv7tKbnsHfWmFJrCYpGTLgixD	1
583	2vb6ukrRBVAf5htyDCTtZRQ7ZCPzaHxEZZuNg5khKfncDEqKewWA	1
524	2vauYBWmq388YArzGosTg6yPzfTtp1cBW7J1DqdftwWL1DeWiftp	1
527	2vaE2JA7c4qaQzKjktDfaBxru59gkNcvcRUt7zYJMcUNWpfLwCbN	1
530	2vbHuUFxkhY7jx1FrxBpRUXkY4s9c27PmvvPWQz1eKCuS2tDAozx	1
533	2vaAR8tTei1jBiSFJ7J9zSQZQ46fFqBQT39Cg4fpP4qfjhAFMoub	1
536	2vbqv2d1sU4ZG2z9HA2BBa3H5Q4LJCs3TYqWb4dEq3oSFhPdVubA	1
539	2vb5huqCgKY9Eq9wPLpvujPKLBDsXz7iXEnyWWLtrRNU7opD8zUg	1
543	2vaq5foF9uGDWynpFnakgjKYuBU5uqEUGZEUXozN9sWVk24ebBEL	1
546	2vbxVuMScwKfxnPjHwpRnssB1KwXgZ5mLhpFrSBYE43qcuEqxJ2P	1
549	2vaACuTbPLqTPae6tuxyN98HWARavbVgKRtdSuo54HPFgsya7B5B	1
552	2vbZhHuRiyUBXYPV2uk9Z8PopHcfw6E3ajg5KvQ2JxZovCPfLMTr	1
558	2vazv5RBqdKfuEMkKri4Vg3PF1VD1KcVB6XrbRztK5qnFcem5DVT	1
561	2vbjX4A1dkh2QGKyFMvBx2YixCn6sjVXbNcsdMW3PPSF8UbXniho	1
564	2vbqjopxji47EndBFV2qsYCgXdMMSD5kvfRKKXdnx3892PeMf5vC	1
567	2vaApf5xZc8YarW9v4HedZjgnnQT4bcBbKZnHtKnnNxyogtUUJbg	1
570	2vaRhcuPyPzCwdwuQjZstnS2UDQ5qNJpon4GSpQ3mtudcUB49kbJ	1
573	2vaRHNnaBMRa39tjm1cLr1J6SwzskpNmwPgZFSz4DfRPu1WMTBaR	1
576	2vagUs4fF4YuDw5SVPoiem687yYmDmnvqZ8k95PQb1SY4TrRrBSJ	1
578	2vah3G69ZuWDwr6mrsLqeqFxqPfKvDhv8SLbA6VS3zHnHis5rjAB	1
581	2vamxxZjHSDBFQRSLzt7uU3FhyP3mf8zNcewGZCGGCQ5RJvppN16	1
582	2vasjYQRiGXD9zLwiNScQxRo1AYyx1nGMNw2TffseLJ96nb5fNw6	1
584	2vaNHm2obzyXUKoLvjPTwqNjoKao3JB2nqagPRHtcARVP8dBgkFs	1
585	2vbeTkdPwocmRf3H4onWrWyZ3j959io2FUEsi83P87JHXC7G7bpA	1
586	2vatjgW1MGD4fcMx6Tu2RjQWApapo3pYk2doLN1msDWUfQd7229R	1
587	2vatsA1xsKFZ2zMnACvULeNAo6FununmsUjN6mPF8EZehYYR3Mg1	1
588	2vaL5abp8qrZraJ9MdvwzShTibGkUcJZLoPUviCxuGuw3RZi5Cj2	1
589	2vc223Q7h2tK5LYt2iep8L5ACP3MFP1Aom9SnzSkoAaWfAtHQCrF	1
590	2vak2XydjaBxbaWUygRnAx9H9eGTF3euDMkeCdyNbo28rJBFwvMU	1
591	2vbK2Q3H7dM7AZqnUxsdkCDzDavSRxHYdbjeCK2rGmH5pRdgNd6f	1
592	2vb5yNnWFMQiwm7WvC6BZTE4Tg8xeao9wg9FLKuF91TsMPprX4ww	1
593	2vbtSWCWap2QnmCRAhN7BvZJeV9hWCCccG3gJYj7sgaw62jN7e9x	1
594	2vamg8KXsarDjxYJ7Ys4eXFbMjUN4QXh2qvn4K363jfdhJoQyvvh	1
595	2vbMEtZGe3EJmLj2v5ah4QymyVxEpxYGdNWEmkJaT6bQS6S6GFAE	1
596	2vbRmKsz2XHc5D72c4RrU6nqawmq5Qnoq4dfdk2kNtuBAf5u5HLg	1
597	2vaCvrs3D81SBSMgYJnk5X4SKrnqR31H9NqqvJF65U1B5GnZth8P	1
598	2vaPe4Z9a9gENcuzYdFKYCJ46noawXJ4w3KYtButnFsCZBL9MCtK	1
599	2vbGcso6TRML79UyHEzpH54oanu9xr5iZ4dBSNjyfpJjEcesXWjL	1
600	2vbFgRkxXDRzUSEjK1gLir6Zjup7iPVPTzEbVycoXMf99XUHWVn6	1
601	2vaWzuUroX9eQxFByUHh72SqiM48EU9wqwwoBwhMBq39EFJ8YcX9	1
602	2vbsDvfzPHSTrAhUYDmHV4xTr5sRdbFnrE8JZEw4jvQVmUamwLR4	1
603	2vbPbTya4Su4LtfaCCv4sNjSLqe87RVki41xb7dZL3mWN7suYBq3	1
604	2vayEARdPstFahjjFkTonSHbka3Rb54obLYCfEosF93W1xbTJpbh	1
605	2vayny6bHVa8yBBHeR3fowN1VJ5SFgCem48yEHWDyQd8Bu4gG6Bo	1
606	2vb99R51akcGop7ErAyKE8HHMMXTXUFK7f9u6qGtmwj8UaK9sw8Y	1
607	2vaD3aXPPJ1gW1pXPGz2fjZ5PWC2B7GJtZAYav7RFSJmZMbmgtcW	1
608	2vacXjreaVYTspH2pXdZuCsSQKWSsvG4rHhqQqM5wVusk8QUD31T	1
609	2vawm7E6y9iUp9QwTvCQCDjW2nuYU8fH4nyKPGF3WJiD9ePANspM	1
610	2vbSQfkMfFtRsqh8mjS1KsMbFVmtr4rE8y2DD3XetZTgr5kf2XQA	1
611	2vb6Wskkj7axgftMidgAD9Tmx6hTzkF2N36P6TkjU9NLKpmPC6oQ	1
612	2vaiKZzPqyXvwNZnFmmipMJVgTs8FRhD7cfihad2kKbWgsL4EhSa	1
613	2vbfNC8UN3ymh9HGstKWFeoQNyN4rWNTZ5XJ6cxeTCs7Dj4SqS91	1
614	2vaRGic1PitavnmEcYrLYvUYFmaYtzapdQJKyKGcSYYxDLteRf38	1
615	2vafcTf5vbeN3btU2r8kWnEVqDMKvD6HsFHazRHGvJ64k9Ya9HZC	1
616	2vb3ycNJ8MkanpbjhnJN7y2uWsaJbCpktTMGCtwNU3gBZKSN8pgn	1
617	2vaPcTtBdsw617U8cNsYCJST11F35PREAnaDWrDiSanT9DHkVH3K	1
618	2vbJQfasL1kz5B2eVUyHg8ftqKuJstWHANXGMSDnoinRpt5zzRun	1
619	2vaVNaKSTWa5gv6661cYhZ5Z1BwhbKxCVBgcKB9pm2dUBe1x1etv	1
620	2vb8Uf5TEkyQcwmxzvitsPeGZNqa4cAgv6qs6fUPVKJJVMXRAfmc	1
621	2vaFGs7KB3C93dGUXvxFx8LJA5CvLs6iunWP1pYnTcPFA7u4TNMx	1
622	2vaBkuUTeidcaXXWdWugYwXQ3gV6oS9qKaLkFDcAQdgXtCF7tHTj	1
623	2vbzFVwYDGMVZCJKhSquc13CJk1j88WSSmvxNLuzr4RsfeaqCU2n	1
624	2vbZkS5nBPSxfN6iJPvqnt8pM9gFCBKnPetdD4FTmHL9wPqx74E6	1
625	2vaQcA5kATzmrknkY7wyRrR28XcG4iEPoLu1hQz4JQ2pcVncFHgN	1
626	2vbs6wAeuQByHhSokpUNfF6e9MT5vzVMeuVPk5tvUCfMaUneR8N2	1
627	2vaRKAiJNkSoMZoydf1Msio5eWerWWL3KrzGNFuJLRYtSzPm7Bjo	1
628	2vbPBBmLig5jkQDDB838CWxVL98YAcr3U1Fpg7kZrck5fKwFys8u	1
629	2vbRZ9qKs2t1GzL7DBrBTqwtznyL49poN3akdZzZjYQZk5sY74kM	1
630	2vafQHyfF15xg6WcTJAjxgG68XiXAdj1waGQxJxnkQZ6Dp2PaiUi	1
631	2vbGQePAp1KKrszsMeSovuYcqchAcqpXCVzVav5sBXXQsdqqa3Wg	1
632	2vbftzR4VW7bi3K7jdT6PfNJwY4RT8tjeRiWsm8djmGWZKghrrkv	1
633	2vbUAkSocHcMgTVzRBXnLarH6NyRS1DhseQaQTyo75VzXX3Xn4QU	1
634	2vb3oooiqiNuotJ34hE58NB8AfUhNRX1LWL4QD3yB3dfJMLCphdN	1
635	2vc2g9tkHFmtGT1jzEff4XR9MmrG5Rw32HBkBeqAyscescfo69A8	1
636	2vbtyTveHodXjdtKjxofhArvCfzu5CM3RrWrRfFmhEGuhmquPZwa	1
637	2vbVEGaUzTJ4ykbKhYK9AB13WDKoaXTAfsFTPW1BjMJ41eDd5FfH	1
638	2vbh6ZkpVvtArsoUs2mAuR4UXKsipq74TwLBdPTmsddBTBeTaC2R	1
639	2vbybPBFJ1QasHW8HVyrGRdd6zSx2HmXxfC3zZihAr5MMk7xu2ri	1
640	2vbRMvHjBYAuQx4KPTBw7b3WGvTyrp9B3z9SibVPEDZWFzk1nDJB	1
641	2vaJtc3JjrxLzSdpR5ZLq4Gknr9G2GN9bGUqh6kyodFgfAiuQpDX	1
642	2vbX8wTM1bgiUSbj6yQFdBNY6NjmZvCKtdx12e5ayuPyzxi5Y1FZ	1
643	2vahDvNmfsgVE3uiNVuJfYTV3MoDCPLM9Z5yaCaysR7Pk6VeSSvQ	1
644	2vbvH4Z2N3D3cvQ5Week9H41csHSNaGhmCyFrP1Kd4kzuetFQLkx	1
645	2vbYwjvzesUvH4g83fXtti1zTdvUQ3jp8HgkaeCdNHGiJGdLUzFX	1
646	2vaMQeMq4pxEDAC48vdgWvsMcUpfgu7E4Kx5vLzjU7PyD1MugDaA	1
647	2vbvseJry1raWjgJ2DPQnF1jys7h7KtF8FD1kRsko6ypxiN9gyHu	1
648	2vbW1ce9J9BFgHHuxjeS6oYv38d7yoJesv27Ej2FhKJPYeqPbtRj	1
649	2vbcbCoj24ugzujAVic6UPZyAeXFbi9P1hMkFCoS8AUv6vJRmMsZ	1
650	2vbDFcpzzqLDFtfNXbyEgptDXf4MfFaXMGmvGEybo52ts4T14hPe	1
651	2vaLaM6D6SFVtWgteCDGn387kAGwDndoSGKS6XjQbhoqPkKRWr5M	1
652	2vawDGCJku9qDMi5Q1BqC9iJH8BZmwQjEFQpENefUFuRExva19r4	1
654	2vahDLHgzr9xAWzCpG5MdZi4ATXLCeDJQVh6yQd2FdEGp8KyKSkP	1
657	2vavB8bUh7ymxigpofsKFUidzxZQRyhQf6p2JpnBsJHc47V5ZVZ5	1
661	2vb3MuL8s54WvUJoHWFLyd9a78XQCeq2uKafoTB3jY9p3p67dX4K	1
664	2vbnGGqk8iUq8rc6apY1LSLKMzgfdNLsXgyzzQurZTEDTxt7ieup	1
667	2vbTKswVshYzGrndTRELBSTw1Q5FRT99zYs2fKcWHzTGuxfhz5qN	1
670	2vbqimvnNVr9scQyMWT3BzqnjTNceXXfgxNN54T5wN1gRbJC8SUu	1
672	2vbCLKBYoE64kjgnF5mMUhzTHX7DZAFCQ14Afa9f7hAeV7pQePz1	1
675	2vawXEkmjiu9UonQyALTZHxVnqCDskDPD1wEZ9BZyeYjwxYJ8aPJ	1
678	2vaBPetVrTrxmABoCocymAuaKpZd4MTq8WPxZ8UuFJcY6MDzxNB4	1
681	2vamHXrWsAtWEC9LhdJZ8JPQi6MMkg2hMr4qELHTmFpUiUVPb8ag	1
683	2vbhJSeAeo1AWMRPQbRhuUvoHUEb33pVSeC4tQxT43pU5yTJpTYC	1
684	2vaBjMnAWLcJFkJ8JQL7pwBwCaWxCDeQ4sG8NRKHFVeW1m3FE48i	1
687	2vb83tUy1i8uU5rHg4VzWJiWnDvtqfLDGenKnyMQvnZp3aXuiNKV	1
653	2vaqgbT9QhZm8pQNTx4Z4ZgMSibwWGjKxm8jk2Wm5jM2wyuFLGPZ	1
655	2vbzdx59eiwrhsKp276cW4fEyAdWJ9WaeN7tAbhCn21ouTnGwBLo	1
658	2vbGyUB5wcaZyjuFUM1Tjiy8ptnYJEGB1xqBVvmcJgiZqhPf89Fs	1
660	2vbRYz5FcHwCJPRtEnBM2L1mQkwckUtzGAf9uauQL5QJem59DV16	1
663	2vafpJ455UumPfrsLPxzLh7vDv45LzNjP3tJcT5eyjETvxeaAfAf	1
666	2varWG4r5oqzVQ4wd9Cg24NRSR6Qk3AuHddSeYRyxz5zFdS4e3gr	1
669	2vb6hovXAbQfSqjxgUMcoaGgsorcv9XQXoit6pHTuTgX27qfSqRQ	1
673	2vab8H8ZjPWVzJAAxvmy2DMQXeLQPDGSMiq8ftrnQEPLs67L1EDK	1
674	2vaVb15c6rVrQpCXeYaw5KEMFuvm6X9LguAeYvNjKtzbXZv4Bj3g	1
677	2vaV3Zvj6MuHEvB3WiXur7qdMuaomG5S3zPueJKyWzPqewEsfQkW	1
680	2vb8UyLXZJ4aT5oekKb5n7TScBVkV2Faznz2Aq9VmyttY8DNJSjM	1
686	2vb38snhmjYmXxap1yqd4DoVVrwND7BDWRRf6wJQo5JChnSLkQt5	1
690	2vbVxC1Wp3yGdhtBmzVxqzjTfUJiduzyqJ4T5xwP6JDhiri5Gh2q	1
691	2vc3vXzvyKoK5wagGLYtviD3XraUiUAbYaTpTc17zbkD6FxKjX1E	1
692	2vbHbberD1dyeEyLEGHhNPrprErkrsfbYvi7bnCMU5QtsYEcx6ZX	1
656	2vaKbuM3TY2d2ZtZngA5vZcmLyJroAU8iNvpWw77fxECYyKDnawi	1
659	2vaZo6JHVLrcHgzX8V6SjQfQXTgeUQRsV65eg5vsvKX1hV6DorNa	1
662	2vbqvqFHnmhGK2NcKtufFjHZ2vFaRpHgjy6xXqMujfMWFHKbStBG	1
665	2vbKesSsehbnAWTvsU3QHLxadSDL5yw2wswRHV5AE1BUCGymCsoa	1
668	2vbLDHHuJbtcDJXpkqShGJKsnuK71PZfbgsaTo2nuDGXKQSMr4Pd	1
671	2vaSJHxFDFhaQkSm1LNiQGrDKKqEku6Ks54AXc2qq2FBwF4yqSyr	1
676	2vb2t1dPm17gepjPG84Kdxd44xbNqArhRhi6uWD3noMDWePEkFkW	1
679	2vakavhHt3KYxbQKX1FfCkeph4stgm3XGeK8zGQjoEdQVSuJwKA9	1
682	2vaGJvZ2vcxrq3pgqzRSAgdxnMjQfE6xGMwkHzgUJdpU21vG3Lyq	1
685	2vb5F7EvgidW8PkKZhbHBrCiM4xgDbFkaTL3JDmqoXbhUxd8UbgU	1
688	2vaSL6a2yhDem1dDCvCYgSCEA6Ehbc2kT8hJmvz8TbyDa1CxgKSQ	1
689	2vbj47EwAroujLwEDaY7UHt4iqbCVgyQSDwQePNo463uyTw36Mzg	1
693	2vaHjyooXGsZwwABZwXDmPUHiPqjhv3rc63yY49EP9bzUemkmi8Z	1
694	2vbzzmiERe5ZWicBe8tzQmqyJ1r65Jbtopceaf9oMYWoZt4iNQBR	1
695	2vbsTckpQc922UAovJUihnQHYWvCacyEjiwh4uNSuaiDFcFnYP7c	1
696	2vb8FaRGi4QCbvRi8xMQ3AYx5WyzaCz4NKFpA8ijTLngXtsGpBxN	1
697	2vadpW5Ze3M4jpsMhSPxCjegRKk6PeWxDUuukeQQLU6VamiXw2pX	1
698	2vbtMDWbFdtdLpxUBVxNahLwiVjRXmKgYpc2QNDg8SH2im3PPCZG	1
699	2vbDoenhbJ4ie6zcbzD3N46WC9reSUAqxFh2Wdj2z3BaDgFiLjZ6	1
700	2vbzLSQF7ptLCgx9bsgs8ShoKL2tEipEE1XShCy6f4e1E8ss6zsX	1
701	2vaRy9SHRXccP5ULvCMtFEm9gzx4EJiCbaxL7zHFSDMkne1Lf2ro	1
702	2vb9e8EWTZ5w4KdzvGm8QUQbgTjdL4HZ4cbymtTnxn42eVeSFe2E	1
703	2vbsJYiiP4mq18SZjC6fpsYPBwmYuNk9yFfJytgZ19tAnftbp7V6	1
704	2vaWocveQQTPQtaACxpQ7P7WgtUdsh5LtFd9XyVhWnrV7E4gz4mm	1
705	2vbDxhRycg7y1kLtMqdRYCWr9cNzPvuKCEgRqXLGvQoEeRWiCFjL	1
706	2vbYkGm4RNYnYnT4xw7dixpb3x1oJCaRiCo8WMJPWbZQQEVxB4PT	1
707	2vawSkK5PbUmUB7SD5orgS1Y6rD4Knp2N8HqAbAXxNnEiJ18MJZd	1
708	2vaDcrThFsA1yoXGS6rWRHzbsASf1A4rx2E3iEnr5EftLGnVrhn9	1
709	2vafsa7nfHgXxcd8oRA5quASUi9HjBpY4Xb3UzxAJ3EnX7fdbbVG	1
710	2vbNqhG6G8DJQHGWcZL41WJXpAjikNzvDPx8LFvVTbayxzgKV4FN	1
711	2vbhbnnecdE6S9W6NukFhCTC7wgXZCiVzX72CuxcPeWz8PSYHVxZ	1
712	2vav6fSMu4Gz8ZYWZbCVB8iWURH8nJeBXbsUyRvWub4XUEzJ6dqm	1
713	2vbMrSqMXkbyaetGK3cJn2s4nWnCVsbo3kEgzhzaTpUkLJMAv3an	1
714	2vc56YUiXAndNLheTiEPcK8A4er9F4MPNUPpcJfuU8tdYHefaLL1	1
715	2vbAgn71SwULDnfGPSkB9MMfiqRxCR2jAHaGqNFtTAoiaNRnG66s	1
716	2vb3kwH5bXmotbYinQDEjDP2jkLuwao8BzKjTJNsrcxFkaTw1f5Q	1
717	2vaauJQZEe7P9CRpLYRn9TQ7nwMTDJCQcNnqQcVfsGUpRQPb9rN2	1
718	2vafzSekey9T8LPySzyj7UhHhxoGnAfp1pQDPEXyf817CcGFSvJ1	1
719	2vazwzJjHQno81SFRodvfjQQSgWYHEUxmafAfYESYa1QBaSmmMLu	1
720	2vaVbKZbUXipfk4QgCfqPM5VoGkNrhsZeHV9TUbwh8M1ArFK1fe8	1
721	2vajYJiV6QShqn5Kw61cuxUSEnWoJQYhXCPGzoyVTHS6rTvj7MfP	1
722	2vbQZbZjs8J5njXx7KUf4EMwtxGaDbx4p1cLwFaMzstBmtB3XSob	1
723	2vbd1jum3GTyPrS5z5wBBBSxwE5ZPZXZUsHsZDF4YLuMmKmk75Ld	1
724	2vc4JShZZGFyJeZH9ZcbiBRY3bA5H7vsyTtGBJdzrkX46YXM2k6E	1
725	2vbb5pup9mhrwehzc4KE9tjn2qoLB2g3L9GvnVi6Yti7o8ongAzS	1
726	2vbh8sGiyrqHAjuN5V6io8ArRbtmyYyprYKJRgFovtgFfnoyWr3e	1
727	2vbsuGtrwGAdQUQhEHfLUv8F85Xah7hb6Z4cSpBbByL5ubLmgdiF	1
728	2vbfvskmA2svrBTceBy98VDAVXWGvWZQYwMTsXDRS5HkKxESgT2j	1
729	2vbicc632zMdgHS3TKVrqG4SmxnGPRKypaGjhCQzraWKg4UcpYJD	1
730	2vbagSo7kDsq2dLYVzkaDNYg66qFbZF3SRxzu8FuaQn5hTgAN5gU	1
731	2vbBTA4ZDRaBctyCND7dHeP65jauQyk8TfQY1M3och52TWavhd3N	1
732	2vbf69aJA5MDRfTK9mb7zozEyS1SNgV4LQqReL17wcP17e55ToEc	1
733	2vc2N8MaQwuwgSCtg9BcUE1VPPuFd5kquP93zzcBCFtwVFbA783P	1
734	2vbcuEVf3SH8kE7oisRq1ChEtG82eX9jSXnaStH4yTUu6Yxf3ej8	1
735	2vaid9yQxmrR8L9UZUVueTLL3S4GebkGkM127DehKuQ5o5XjAJjb	1
736	2vaiiHmPcUB5XBybJS7Djazq9xYNqEU9WanSk6hpC9dWEN9pVMgG	1
737	2vamw4DQjin8UrDqk1SCvaLgaw7a54Bp8Jkr4ojGeNFtaECpd4si	1
738	2vaiFeBAVXvyvxwKw6s7s86n1Gkk1V3UAmx8YZ9c84rdnVbBA7oK	1
739	2vadecsao2QbRSkjZhbBgSYRnKnDnUE5TeLrDznVp39aatFY9WNz	1
740	2vaCdNxaPRuox4j8RREGi55AuvNF2bTHJ76Tp4Qt8caWWwy4PzGW	1
741	2vaRMYjxppFVMLKac7LV7FYk2Nh8HumChGugfxt9btGKRCayfajJ	1
742	2vaZ8zLWVnQmCv4hK4r7fMPa4WagFqeTHffKKUyqKcjKkqdfwD1u	1
743	2vb9REZh58zWrifneBFpmxKkPGMGMT1hLfZSsVsMvygAhRCoqWtM	1
744	2vaCPGCFPrfu1HSfN9G2xVhAHDPuBPnFreoLugyEY8BLGuMZQAeG	1
745	2vauqgTFiChio4iELBhTipNSCw4amdro6J8JbkYGdBfxZT8xfp91	1
746	2vbSgq85QFXamDawPsLyBvC7geh1RvkiYZGV8eeGVPc88BS32Qd6	1
747	2vbCQNSHXe942YpVzdmjbyqvuzwXGXwwYw8SLpMLwAJEqEkc7ZMF	1
748	2vbFeA9hfDKPyxdKcwWZdR71rLqbt6wACkWDeJmQZaCmcJQbgkw5	1
749	2vb4J9XhKEQbKt2mScG2SBeqshFwbdJ6K6dSUf4b4wkVBQnE88oo	1
750	2vbPTr7Q5EnnrSGf8e7iPLgHjAAj2rYjhhRndzGmjxHsuMp5NpaW	1
751	2vbmxHnYH5T78vPTtcsNhpTg8PxoU3CUGf2DDYP6XVLdcnfRZxZj	1
752	2vbmiW8HpYBi5wPh2pkx6TA3CgNhAWVpW3XZ5yrb67nFGCurrkfn	1
753	2vaj6QdFcGDwak2YVbJNKDbvJ1wRdfMGoRXa2avjUvnfxfaXx666	1
754	2vbeba7MreGbWUczbQ4sMfmj56zjaMYh8GXFEcRMmfk2pvTgM4vn	1
755	2vaJMis4x1naCKVGNjsfETxmGidtebNccvvYeWjuoZeRkUBCRZyh	1
756	2vbH56dZwumrRBnJZa88Bwq7f9hyDQD8183KpMwBFoJ468sSEDTX	1
757	2vbXyb6KP6M2XzL5upDbTGPQH2dSkEZMA8Vrjn9NxYYsbtowzV5L	1
758	2vbYnDMrV1wUkQq3jJU59xY1Bcu4ak6vV886NcZGUpWwPLM7YEM2	1
759	2vasERVdw3kajwmaJB4qQvrds4YkGkRHFegArUsAJMy7sWQUf2jr	1
760	2vaGAEK7SVLMzgTRnb4haVprJtk5pF1zAwbpV46gHX3Pj4snnHig	1
761	2vbm5bYZTNk4nK42hGjt7gDnRApPP8Jf8rPdBX4xLF6pdRWTfsNK	1
762	2vc2o4yGbhR7nDWgKz9BqFzjkW3orEVUhwK6T39fL4svuM7nHNPF	1
763	2vawGMTDN3tscJjLNd5fFKWtmsZD2X338vrJppWzFdF4wvf7yH4z	1
764	2vajBoPRZcBUgyH7wq6obf7vQAcsFD4BL73dQKnFAqhApeDbFV4j	1
765	2vavFnHf9XP4oPSHd89GzK74TMWVLYviAEhagYMeQT2XPYLdn5Z5	1
766	2vbDU642VapyPEuK5xER1x4RJefHu9PUg15nAfdNmev6TLtQRAKu	1
767	2vbQLLXXyiTZtoNRQANHcuMwZVY945b3rhDbnMQd7uYqPC2i7jr1	1
768	2vaS9eXMC3KsPdVryd9Csw6zcVEa59T5QvV8eX75xwvvXXcbvvBy	1
769	2vbXzJZdVk9aY964H91h6XU32QEfXKPBWqYJvRvj1e6s22VB6LQp	1
771	2vb9ANa6fJxK2NVkWQ8KF8uqpFb1WcpPzQyDz6PgHhgyDiBhMGey	1
772	2vbAh8ipwapK2UofrKp8gCwGVreV2MdMXmuA9yY5VRDXPHCGh3Ku	1
775	2vaYV9ghi8f6yBv2sBZmmPmLpkjBM9aVbY2mfvXNXhxDFDkTAjDh	1
777	2vbdXeibytt8rHuZ185baPDiCKG9yNH2c7qE9y8yLXA58W2kcQMU	1
778	2vb2Fa5KfvcX9Z2trKYMyFmTE3fsvyMfxYvfkEp64hQk5Q665Deb	1
783	2vaVdYNP4izEXXVNchXsfDRJ3dF9RSzxaWZEjRekZbn4PRwABYXz	1
786	2vb13JN1pzdAwNcityZiVfoL5e8Q7sn8HTEkEAWt7QQ8Zj5qg3RC	1
789	2vaQGCb6YHcJuta3Cps3zRPpeVethtiHzyHKq8VBWSi632itSS3r	1
792	2vbZ5WuAG79Pimp9BC6Cn1ZFq6TLATbfrpRfpBhkiHs5vhUx6djH	1
795	2vbWngN72YcyqLEWQsSi27n9fsYee7CmT2BrKZNmnXjSVUEk6nCF	1
799	2vbUnA59LeKatKaiEmchWmzSZn7cDuKEXcU8vjW2kWz6wQYejzv6	1
800	2vbqMwNbuWt6UykF3nrjKZALDt9gEUZBLfEww5brM91XzaVrvKvS	1
803	2vaY7BHT2qtF2aCVpowW7d95WHN5kAztJWAKUfQinmRvENwLLtQZ	1
804	2vbX3M4PH9fVbweRFDpYk2TB3a127Rt7znubU12cwGwiz318ZrAf	1
807	2vb2XfM3hXCpF67B6H7GKV1AFz4Bgn5XwcRttt2G3Wg751G41Urx	1
813	2vai2UWPz8nTpjmPG7yYRJgk22s8dimU41TD4nG6EDAaBi4KBEeq	1
770	2vahugD6MMj9CEMR7hyugwyyeju6QNjHhdVjtzF7JvCn6HcHaNHN	1
774	2vbY9ryzxtkGQWx82d4V7e7wJJXfehh3dF93ktDKAZrvi5ivUQ6n	1
779	2va9wv7ZEz4HEfjWrUF1UDMBQGvvXzrsojSAfes4jg3D5NRyiGp3	1
780	2vasyyzDuHPTKUSMcP5QytsPR57fpu3jWxWH3B3MuQMZsdKKR3Ut	1
781	2vaq14vCUwhn6ouvUW5DHGHnrtVtFPkq6fFijqFLiRfgW4CotBVc	1
785	2vaHPLsEutLkw4FNsbjQwgX9hn969FB4YngvBTBoTXn5n8Vnf4Np	1
788	2vbNfzJL8NveWLzHYkWFsx3CV5WQJiiQ1jvo7kAGN7APuKjQR1s3	1
791	2vbctChB4h4iiiXWnRnvQkAWbGGc7541XvWPbPaxSwwQkM9tv3s1	1
794	2vbWjngfX9KVu7NHb76UaAP5ihJ3k4XTZbb5Smta2GvRKmtHzg2D	1
797	2vad3C7rM2Z3BmjRSY4UsDtEzf4DzD5txZdJo4GYQdNGmM5wtnM5	1
798	2vam64czLHmcjCheh1hwDCX1GJT4FGDWNwrza1F7j4SWRoWqZHoH	1
801	2vad4kF2fU8kf2sXdDKf3MJZzpgiJM9G9oPqUmuooF7rnWxvsHeo	1
806	2vampVHno9PhhV5ybthGCdUZLDxHfyZ2WEKnKgeJZyeghGstjkb8	1
808	2vbdWfxwDNjX6VpdomhGbBGmq2Pp8RDemTT5hgyYK4isajy3WV81	1
810	2vaUtD4y9JgKRCpcBay4NeAeNVkNmJDpVVQdnyPc9utpSUMzqAtc	1
811	2vaALrRnoBCeVjWNeuBm9QN3B7GgpLeW2t8ca7voSBqpuwvNy1vg	1
814	2vbdYC7xouLBEFabmx4p81hZsoqzCcVyq8sasDp8KNfbFdJqzdiJ	1
773	2vaog5wsba6XuPHxsXj4HcBYwfLCkCHYoBPjAUh2tNnQp3uHuQ8p	1
776	2vahheugzxKdzfTu13SKWR3xGk9enYUtM7umg2ni69i1xHc4xhz9	1
782	2vabBe5V5TPtJAZaU7XvFUMgTBAY913J65X9m38oqr5b5CajgdLt	1
784	2vbMbuYHkoSMEBTRfBNcs83JVgndq2av5k9BkBr1gr4MxFTPpisR	1
787	2vbZpJu245P2zkw1cdg2Ukbht9TVRUrQixrhMsrDTXKjKUzooFkx	1
790	2vbq7c2kpnEGxykyshmhf2t5F4JpYW5BmDvizv9VUeGqxDhkwU1H	1
793	2vanQpKnC6z9jk5dfEry6U1GzZGFjmQbokisu2r3CkqPFV1TkbLq	1
796	2vbNBg6PEfCt6SuB6XbXb432vLoq9TojJuX4YMp891jcK41vu5dL	1
802	2vbdcwF8aR8Zw19BwG33wmLS59B3nrejrM935kw4ZoUJh7HdzJZx	1
805	2vavMT3EUg5c7r7Bqe9QS5HLomegQ7tUcvFhiHFSNRVHvJzYypCD	1
809	2vanr7RgV81VaFuLe1Q2wQfFMCBunJWgZd492LmhqGyZrYLGLmts	1
812	2vagHaJKN2CWhPFpwuDxHV2XG7j6EdASMi7UjggXeNm7Knx9VuSL	1
815	2vc2kgNRD6zTrAq1E92nJBV7JaApYe2eqUigo6TK9HQUViMwdAhe	1
816	2vaqST1TZPPmYV7ySKWsLhtpRH4KQrbn6mYM9d5BCNjbFk5393Ye	1
817	2vbSvaj7nRZp1EwddPPPrnfMttCKmYc9oyQDmPsgZSwacyvRf8HB	1
818	2vbZHbhdht7tBsgsvrdY4mjGph1hu7HyifYv9dBhFJMKbjpf9Zjs	1
819	2vbyuC9BWdL9EFHwnp9ShAdTUrewDeBqgzTjqGuWt7DEMAcghWHn	1
820	2vbiBnjSHxto8m76YGqyVjAvCjarP7YMsV4kagwNZnC863bbb4nw	1
821	2vb7tT3GQDCngt5bEQ6JQSPfJFfvZ2zWs4QdvgVVuMmyLyPV7FFf	1
822	2vaT3e5GMu81uUDDbTzzRVziUr6EzxiLYXmtnN7TCw7yhuEhp7yM	1
823	2vaUcCL6xK229DkaK3y5ABHJoXtuVYXfj18W5BZcGcT84JV4nedv	1
824	2vbaCBdc1JwVKAxvCyrJN3mP2xK2uPCvw3126xXdTco7L2V2LJ2r	1
825	2vaBE51JiaQznbqxyURR5XqFLuzQyFQJYm9rnPQ1AvNgqJ226quF	1
826	2vbHFfUrkzEs1k1ijpaZgz7PBHVjEuGkttbCMKRJMdbC146oUC1E	1
827	2vbLCXwPChxLakEFToa31Yw14hCCJMSe8Yz8FRMK3hb5X6kFvck5	1
828	2vbNkrLbYd89k9HuB2okERU9iw171epDWxBr46wGnw8w74B8EpRv	1
829	2vbrvuhZbxHctFbaJy9SS36zD19McUUhsDhkH3G7mQqzEpRttXc1	1
830	2vb8sPgUUx9wfUF3SaFePwPCkhvW6KHPpp92x7YVM5GGpL8ak9wb	1
831	2vaeDX4qgPWpJ4ck6ApqjKFkaLyYP4wAk8xFSRHTV5sLgiJY6WWX	1
832	2vbVont5nPbVfBEicCwujmabB1TAuBKmt4grCFwQzu8ZTkJPYHap	1
833	2vaeFg7SGap45xXJ8zSEan7dQXvPgyFCNz5hkT6cW6AaGne1yDH3	1
834	2vaZgLKputywGySqJRTPKKS96xePJYHNUBEVJGPBhKtuaK5KgCf9	1
835	2vadvH6bVSfj523NpiQKzQbD9ijSkBA1LribrcsX8kiijW4UhsPQ	1
836	2vbtZbceL2vtinnPRwuAAHF1vXwgWKraQbVkXLHwtQYJVm6b7Q1x	1
837	2vam7WeyM7nbx8zibxEEHQbRDoQ3SKcZxtsW4AxYqpszDEcKjhky	1
838	2vbv8tdXkdCZss2oX1qJec5BY33XNv1MPRfL76DZQZxeHqJpDNoD	1
839	2vbxuhGE4nRe4vf8G3J1ebsvRjNNxWX2xWoqRXyYwAkeFnh86awF	1
840	2vbAxGXKGgwT5NKYSXMGDrgQEhfyR8sX8Hsecejk7RH3YxAY8JxS	1
841	2vanvm5ceCcGbJRrKnSNc8yXaeD5UYAmNNBCKTH54noJB3qo6bMR	1
842	2vaZGiUJse94hmEqDkTY1x277BG6hXg9LpiM1f1WeyrKfjw4kqV4	1
843	2vbe6sYzvc8qHNpWeVBt3VCYVULLcnPJxyX1JkEfSEhQjfNohEdn	1
844	2vbKCMaDhjHg5Axr6Fhyqh8MrbmczSZToMefotwEzcBwm7uxdFFC	1
845	2va9WCsyArJZ1ZakoGY8vDcqdGMgCdCxyhVVakHydwqBCvh4sFWc	1
846	2vc1YdgFP1or6hDkgGuxYRScBpTqXvkiG6a5tMHizE4Evgj81vwW	1
847	2vbwWxKbpe6WZey98VubDVSPSNpKEuV9pWewRi1zAESUrhSjPhw2	1
848	2vaTD9VcK6XmvJWFbG6uoTHazza6tk9rZpR4UMgzHxAezZLpGr4y	1
849	2vaJEU2En22eRoSJ8YZHLQ489jvjRwPCCexhygobaQSFYnzVMVja	1
850	2vbiHpdEj6FqdqDQU41uBHLW3Skcqpxwe57YKKMkz1CF7dSXThQw	1
851	2vbW46K2qFPspnhAowSM4G724P3nbZTMRWTtt8i4DNKsvGXXJuLi	1
852	2vadc3KgyFwxjTGRMWJSo9Js9iSJ1uvt6iCvUkhoVHmQmGivSTxi	1
853	2va9YEPWQGBMB7sEmoBJuVyFzrHpPDGDWHzNFdrLyTNr35KPKuzt	1
854	2vbwAqmBeNwCm9P4FNxUhmoEHKeXf1zJt4175Gdj8RVk4ybtsW6g	1
855	2vaHHwLEfcZdZ1BSy5m4ZwzbDnZ5Wsx2kmFpZVj7nk12Kj75rYwf	1
856	2vbQoY4Nap2T88cFbp4cphUZEEi4kKjvUcSDp9xcDyxDzoUSv7nx	1
857	2vaerrRMU1pUg4Rj1SqXRceyvpTvQC6j6oQNjo2S56Ejbf6BsUSa	1
858	2vavHxKGjJboZDBt7gpv8mYzmL4Pos4Kw7K27iDNhBxKeq42UQTY	1
859	2vc4hHyoKMGo5YmagTLjmioa7UXckqx5TrJd5pn5aCBAZ7eh7okm	1
860	2vayCTR9cNiE6oz1PEw9CVTsQQAovjzGxNKkW2pQ6P9KzU8rBBhD	1
861	2vahh9GwXwyaRi4PD1iCsCKATTY6YV7YKyGKER6vjDmC4XELvVrs	1
862	2vbsj8dLjLjBPktUZSugVRC5wsfpXv7U4oukWqy7TQTmWAKEzS28	1
863	2vbevTCrJsQBAZU1DELe6VMH3R7htfE5EiqGRPRYir4Dji2jtL12	1
864	2vagR2ruz7Nq6U6mg9aC26iRBdYRbCLJckLhgGvQg1SaQRvgQYCu	1
865	2vbFQ88ZuuyELx3tZVd75goExJh6EEangefvbAyqukG35FoYMugM	1
866	2vatMV2447pdHqbdAy8Q6YNa7szn1abCw6m1PYuzWSfZfZdnhqZd	1
867	2vbsWQRQByYCqTFdAYPrsEGhzrSB3JyCFK6JH9F6B2HtvGcgkHzF	1
868	2vab82nate27krxr9AfLfRckNeL51bHMc5Zy697mpe4nFfAcwgMF	1
869	2vb5fVEKuNiXvCXH4rtDXipJu57mVNvfpTqoAu9bMEBnAddNAWjF	1
870	2vaU2fvX5H43UkBSa328TgrimdMRaNmiN4jDTjmo7pxGcrAkYHLN	1
871	2vb9QuyodERdsGsjKCSBGAJimNTFd12zGtjpDpXtaU9YawAqzkpV	1
872	2vaRf5gNcXnCabmWyskwPbSoE3HpEGSVAuTM75QyQRF6iULRZX7u	1
873	2vbWRmEghV3NXyZDs5HhAh3x3i8vMMa76zLQNn3a5UzhJDDN3uPv	1
874	2vbgVoNCj64T6TH34rUNH1YHoi8RkN6wPgLBvfJ7XQ2KQhmzxLWR	1
875	2vaaVFrZCuURD2bRzk7qcs3ZPr2mpsqQb4NoiwfVq1CodPm2H3C3	1
876	2vbCDZK32ksjt1fqQKqioq6WBXrRWg4ZFcEBck9fEXdeUwofAGsL	1
877	2vaToZxdiPwmgu7uvor9gw3FjRUtQTVGW6oH1MJuYEtqRjhGmg3N	1
878	2vbXLeo1GgmMxwZMVJjMXrZL6mwmip5xwbptfDnRRW5vhaLUcn8A	1
879	2vbjRfswd9acu97EEMkPRSFT414g38Z9bwxQpNjFKNr9hvKJTEop	1
880	2vbB34tPCxhbu3xWCEpJAk8UXsuXV6Yer9a3W4TFZAXkSwnNSWLw	1
881	2vbAdeRFrZGQnf5x2Y3mpqFYt1KmfCSdC5ntnvaKqJLYdx4M3X7C	1
882	2vaL424aFRFg8x1wvSBn19bFWgYXU8ZWvYJqyFj3nbnnNURFrA31	1
883	2vb8abFsMwVVfNe1FrZwLXhgxxvf8qF4yh1A6PfjSj4EhZ6Gsbco	1
884	2vbpfdw2kAmgpqhUb3A6vhNFby1ntwhyPTEtiWZvum8T7GKgTxs2	1
885	2vai3vPMp6FfC7q8cHg3JQUvtHmsYcjDzrFruSL1VgyWGcHtLDGK	1
886	2vbxdedKhYingEmxbQoXhPnhsXsCdz8JLnpzyGbcdGktTYe7tPxV	1
887	2vbMMfX1QSDJCr7qXMvinozEgQyJK56E99ZfQaN49ozovRMVx24q	1
888	2vb7J9WRJwP7Qkb2jmyBdCY89axCDsSMvSmdaGkdTN54c6V3kATu	1
889	2vbiHwegMSJRNZaq6fNdFS7JGNjJgEwbiXbDgTtFpFjHBVn1EWqN	1
890	2vbvEQzqDH12cBWbj98MyNVkFsBghsuKazzWK2DoN39FNYwASAaT	1
891	2vbEJHAVLoJTNh5wkMT2GYqfMWsX7pZy2KhwHiCvCPnHQS5YJAnF	1
895	2vbdhw4DpufzQps9ed1wi1gSeeKQnTeRqxs22kvA23Ft7ccqaFK2	1
898	2vb85By2BnZtJ6T7RvqsVuTDq4Kk3LXR27k5eYCSAZAeeRCtZYve	1
901	2vak4oWWBhXNUqL4SsXeDkfhiwDNZuCL6UCKsmZFgR3i5fiq5GMz	1
903	2vaAgmPQjA2uW5ZscPwvUyBPSqimZN13xsKeff3WpCyxGqhucdHa	1
907	2vaqThf5SzRTqnWEU3uUwM5THTDNKcbk7JTDxvDVKV7sLUQEMDF3	1
910	2vaQtYiwjW2MAKBdADDh1fEuYrHNTL33WVsv87BMGBZ9j5rNKLZp	1
913	2vaLB6dhcwryHqZwsHRiP3MBGS42cLdhyUTR8hmKLQffHkAKs6s7	1
916	2vbe8gxsavVhbEuMvXg6o8bEJjHy2djBWjRZpEZTwwog5kdHoHyE	1
918	2vbH7dLnGwLgF4QTwVqxVkZYM7wTD4WSzsFWRf1suu8vYSmAkwfc	1
920	2vakga1Frtd3shHmwxYvprBAEA4SxC8YA7QzphP2M3P9T2827qnf	1
922	2vbra1tEKpobWqBo1pTeqsPCd1tLf3XSKCWkixip6i8tdtBtAyhD	1
925	2vayKuRjogqTgYkQpxSJKUbjFXw4AajfaT3xd8x7HnEWzj4F59Xn	1
928	2vbxto37n8iQyRaynsu7dnn9FrtYzfkxnotecrYPzzryHsWyRZff	1
931	2vbgCCWbVMxuXfumD1GDz9idz9dFwheSs4TPmN9PSyAV4HGj7eL8	1
936	2vbxNPfkzSum7qBpPiXBnLCLHZ53pDHGPpdEfh98pWLRCcUBeK9R	1
943	2vc5LCU1qptqwyPGdo6bRSVEpk2VrXAdx13i5kWBQze2giCgvw3H	1
946	2vafa7JGpYDmK4mjKB1cftNQoMusDy2WYL3fLdqsoELVAmBrmE1P	1
892	2vbNNC76BRxD9Umc6qjyAQXvAAGtbyLRXJU7FKVFDqEAoPE3Fzks	1
894	2vaPc7wADKqrUjYWLPRMBAhZdC8GLh7v2HUWZEQe9nbkrwxCJ94T	1
897	2vayWKou8augXCn7P9RVw7nzKp4cLtXS3sFTpYCcu6nXxGDwsFir	1
900	2vbQSFUUToJuH749uGVdDjMXfa9fbsc7PPcrc8zSLbBhyW6efNB7	1
906	2vaTPJ3FxZCNiYUGHeFhbG6eAkYqMwajhny1sEBevQgYybSey4Ps	1
911	2vb9vaRmNVMcYuQcNZBjwN9p43yKuVDQV2vTf3bN5Ds2vuxLqfFW	1
914	2vb6pdx532mR9LqWvw5gn7RzcZPZM8GxDkD9Qrt4wpMBaY7iQJD2	1
915	2vaZzpLJeY8Q1FQnrMfrQ4fD96kGNVQafmzQ6bXExfYEf6eoYBKi	1
917	2vb43bdDBLV4Q6oD7ouVjaH3jwrjEtv9mXmZviUAD5E6Sa2CbotT	1
919	2vbFyMHSnjhzpciCSjD8DTz6cTm9tJ5NTtMptgZ7crgw4Sr2eghW	1
923	2vbV3wUU9ndkHq9MUFZLvSC6C1TJVDpwYTad6CotwTu6QeYmRFWB	1
926	2vbCpmQ8a7WAzUCLSoy4JuctyuocHo44L7HtRkcvdsiJnBrUtsNn	1
929	2vbcCQCsbq9QoXUvU49m63qBqNqYhRLinNzi4R1ghxnoejS3NWPe	1
932	2vasQk9UCffYH3n69k14qhsiMko9ZhoXg1psdcvw3ofaSrPL6A1d	1
935	2vbJgM2z5WX5x1t2CtEBztxfML3TBV1wyWaagXX2c6KPydYCkRDb	1
939	2vbeKNxiufP9vCvgiePhothVm6p6u914E7RCAbpuGoSBouRa8ipz	1
940	2vaxT1FsY2xN1xwnnNdhSerpKp5seBeTJg3SMkaLrvGQSnfjcQKz	1
941	2vaMX4JEwqLZSwJA84iPgFGupT7JbXCwCeF6SkphC5v8U2Gi9CMT	1
944	2vbJWs3uCRhyPatFCvegM5AyvSF2gunezT5KnaUDiQFMWAqJqSyU	1
893	2vawqrn7eobXimHP4WkbemnhuB8vhYw9BZ1exzj5WJNVzN6X9AQW	1
896	2var1fYWdYmnooebBUuuDVKk7t9HiiyJm6Gj1UmtR3nG28mzc8C8	1
899	2vb1e6MtfTouVWuVCyy7BsYuSGpu3imggaNLfrVfGULKuRsko7gp	1
902	2vbTwDu84cQab1A1AvwDBgFvomjS7P345bJyF7u7wtSQceQCyC86	1
904	2vbvcswjnLUnEZhPhecC4FEQDgFHMNiEgiU3JDkBUtyN47DrxriK	1
905	2vbi5KVCmEGmuAnCcR892UfGy3VwRExpWWiN456abcB2sX4JRoup	1
908	2vbZCRKmvL27prZz197jBY3npwVGCMYeeaCL8kF9KL4aYZaHPteC	1
909	2vbSuu9oUoFQMVgsxAbvCMFQya9kTBC8EP4AXgxzEvaj3ftVQ5Yx	1
912	2vbpJFQXGTgWsbyWyfjnjyy9eoo3W66nSdn5dKQUQAbL4zaEj4gW	1
921	2vbnsKui1b5htLLnLVRDZfnik3xkLrzmLfjcMvxMYjsTx9VKJ2jN	1
924	2vb93vfwAooCBUGQ5nVGf6DzUWaMYVafpgcDEyXaWjcrMtotusYP	1
927	2vb5YP8GwqHH14ihLTSadQPrnZ8UfktgK8JcoGMH5WCBaJVppjiM	1
930	2vaXGmiHfvLeyAvp2wPX8cZdWAKGY4ePg1vARugm8nGonzoqY9tb	1
933	2vaRZaFmERdX6oX9jDbv8XeE4hJ5kDqpiXM6NnMLV6eumGLfYM36	1
934	2vbxqjrvdc5SCHvJ9d7UzMhAZCBK46BiceVcAB4Lsfso36uFFNxG	1
937	2vaw2XrfvCbH41bnTY2vVew4QgU7675EfKtYGjWE4zHwmyLGWSsp	1
938	2vbj8x6Q8JM9pEahCA7WbqET4onCP5ya5HYqcAgjVtLfGv7EHbec	1
942	2vayZjWaJJKNggusWsND7KLi5K97GcXxPaZj7XNHkNmDhdVFk2uf	1
945	2vbC9S8z5LKWNY5wXPphQqDJWk15vnaH5UMf7fa4cs84B8XrzrBg	1
947	2vaY2Nbnig9hHDiUNteW9gsMJQ3FS16ADGtxsQ4T7sWTnxvFjTfr	1
948	2vaHPgh2iS5QnmyrVdLUr6a6ipgQ3UNi3psA9CapE7zpFhSqkVQp	1
949	2vaVAP4Bx3Nq6XKjNBMvNC1vFqXDVdT8e5qrkVeNTTWRz3RX2PcM	1
950	2vaP1vggZryMtMSDpK36adYLSXwa29mGkzmPbadLKrPdkgbL5qL9	1
951	2vbF8D41ikjY9rELCWgnTsBPcFA6z3jMA2RDWJBrEGV1EUvEkHn3	1
952	2vbtixHu3sCixoaNvxzU8S6Nre8uRDQRRj8hvhXLZ9refYDrX8fu	1
953	2vaihaVtjo6ReN2ZvtqaLe61q69PBfTAuM3oUPkYsybn3MxZj6BA	1
954	2vc5gAGNLaDg33YUvhQC7o8KWdHXaogigzLhNkgAHMKBJe9KufVQ	1
955	2vbbVTewGc1bLJpQvJBJRya5YLx1owtUocgQKdSRdP7UavkxaQkt	1
956	2vaBXKUp34SSi6p96jefTwTvTsJAGbjsvbzUcqEKxChFsVKGmcCb	1
957	2vbw35772Fmc63MajimhmrYi1H53CEFnfSz3kejhHTgs3sPaS9KU	1
958	2vbDeZmoGhG9MWDyrtGn25RXpeagN9eZrpQybNaWPKgVLweLona3	1
959	2vaPhAtF2Dxe1HYAN3MPsHLdAymgNWZw2d1QKf6yNrv5RnCdz4jT	1
960	2vaP9WskxdvdvuJeGcfiYLCcHL8Y6YZ43CYgYDqYVASvYNfA5s6j	1
961	2vaiyesEAXxg5LPVGQQ2Cjw1kypReHN1jWjN13KFrWR35w8Yaz3T	1
962	2vbckENfgNK14nuZdcy4oqVkAMUhXeaDBud1LGvQnpqBzdCMscAK	1
963	2vaMZcLoDY6HZdiWrTuYBeoC5zVVrDBCp9fc6uSjEcfC5uhax6sh	1
964	2vbyyPPrwkhpx1xe2J4PEKUsJj9qg9spMXC9Uzzf89fJJmXCdmBU	1
965	2vafxP5cshRrAH7unJhFd2EXBrDZtBPobRvaZge98EJ9tmmmneYY	1
966	2vbT6dWHb9HLjhjX5AFGYNJmSDMshDyAn368SJQfQ3pand6YvMzB	1
967	2vbBQJEp1fSY6gWk6sCKW2Kvk8tuuRC6mgug754Qk1pGtWvGYpng	1
968	2vbPgTVQ4r22ccEUo2RtQLRQu6ivwpPa58nCVXBj5KwSBWVhyHB6	1
969	2vbak6Ydq7vuNEcLbRgY6aCaHQsiqXYWvrZiiBndUAAfCchfdYSP	1
970	2vb4VjN5VhKhh28UEJETqNMP8PD8fxupAJFC5o8obdkFezK9GXpa	1
971	2vav5tfePNxPZ3WFqeoBE36zEjJ2ifWuRKQ6AhmLYWUHBY4zZYRu	1
972	2vbxDfLkVyhfzZsj7STduqYwU91ukTz7Yd1A7b2UB1XJatddd3be	1
973	2vbmpPTBqYJ5YfQGp9Gx1YNHkgEJitPvvyDcd9VkKYrir2wxb1r8	1
974	2vc3sNN2MWUzAsdL8K2iVfLCerUGmRHP7stfpAGrXDsA1aYchrET	1
975	2vajtNwDoLQbQMGSu8nmG1hBp961tGgEFBhtRwx14Qcj26p9be3o	1
976	2vannyQGT1BPRaUEgXPzcgzMVnmEMNGVMLCB8hCxMtb6ruSbpAg2	1
977	2vbVN1ib3Uy7rv3dFbSRbtfmPNjZ5qcu31PfEDbtnz4sJEvUbcqK	1
978	2vaF52taUzh2bd5szo8zUF2HUidcDcgyxXc3JgQgWtEAhyoXtpAF	1
979	2vaNemT5XFb8vrQJETmEGojvRcAnh5jSFe7gM6VFkimKvixEKqab	1
980	2vbz1MsEmq43CWHbYvy7AADpfverSA4r6af8jsQoLJ79NY4Bw7Rm	1
981	2vaAfjJJmBYdVf9rbTV2ZczuWqEi6vFs7oHYCmms2F6vhSzdUN12	1
982	2vbV2pJAgQTKwgat8LD2tEAQUgnhP9j8RFfdZsj5kKCG4gtVmQmr	1
983	2vaY1gRh9FrPK6Uhw1p748hLroAfcRW2a1HrvuHgYqxf8fNaQPRR	1
984	2vaH9ZwNxUTtHCSBYknqyRFSutqUsAHsHCQdtZ5ewiURvrmuGe2T	1
985	2vadzgTEUoEYti1pWNEtHzCcqDJJxxBK3ZQ6nM85L8pTg6ZqmAJZ	1
986	2vayRshVssNawpiF248xBMGLTLG73uS3VfUU6xr7wzaGf11jVjR1	1
987	2vaopLvBinjQufJDHHcwPE3SuwFEUjGvDs8TJD4hGnVbVGTWjzLa	1
988	2vbzz4iBY6k3bwPnsi1Yv6Dmdq4WtfkqPLycxXkf1X6xvtWRELTU	1
989	2vbaLqtDQ5wv7AUAmWx9cK9LCkFX1pwJD8of2uVQ1by8NcuQNENp	1
990	2vbV1Cy6hnjZ2tHjEoZ8TrprjBsN4ryfgNHSUPjrR7tMoRXJkq2c	1
991	2vaRdTaKe68ZbR68BLJDi65wPZuYHE4QdXtTPZHRLzAY1j1KYwWg	1
992	2vb8rhjXbsPXDKRrV1nub9yvSV8wCn87766PNCK3zRa2zuWe2i3K	1
993	2vb6gig43v3P5e2sKXbC3y25x27GpU1PZvfUtbh8ikQFZwNzJxri	1
994	2vaMF18bRTWa7RsZcwvxj7rmrijYME19wq7Ah66Q4yKrtig4if6N	1
995	2vbB97snqjTdoFqtQNte1wetk3KWLx281LnSbf88pCiKRqtGPo9u	1
996	2vbgeeZrgzp7UXHqjJYWcfkQJ6dtHdTT5SEZjVYox88nvFMhL1DT	1
997	2vc3YTvTWkDkJQufWtHhXt1u1UGjcBEjMuG4mFvhXEGrDkrD8Pgj	1
998	2vaiw1MVMSDtzwkSRXCGDTaCCcfNPnF1x2wsijHGryRz7Qmg3vF6	1
999	2vb3i65BAZ97kGN6hLLFZyWQSVcU6sQriYfHWLKLZ2bdZLMDjZt5	1
1000	2vbze4emfnmBr7ky1yabcnNjH5ePqGWwyVnoiFo7BhcKtuktdfwy	1
1001	2vaHds1cUEazjppDgoJMnHUfqfG52MSMvqnCPM5Ah48L5asbTJzV	1
1002	2vaks6wAVURdH2B5KWFJCCnQvQc4v8DSQarXPNSVAtdxXGnGgpGA	1
1003	2vasSaegduvd5Kb3GMqZfsbigFsd2qK8J6QE6JaMEVefWD5yZNcZ	1
1004	2vbpxyjpVfvdun2THk6eDNkAEAzje3nEXYxUWrej5Pf7FTDksCUJ	1
1005	2vajai6N6vgx3Q8Fk4M7f7qMHVmQbK523C7EWc9BYrdSeCLrjscd	1
1006	2vaEp7i91FVLNidUpcPRcd7WxJGJbboHEN8zUyCrPnnRsEK3aHyK	1
1007	2vc1FsoHZFKMAp2g1i26JyP5g6Pg8Yv4uih1tAChBsQuRSahT2y4	1
1008	2vaGQbS7TMBtWYwzSMFbvqvVjLx1swSrsAgceWZucir14VjRavU8	1
1009	2vautTw4kT6rvC1QB2hJRrsqMqt2cFisohNt2eDMiiT9PARB8eac	1
1010	2vc2K51r1vd9mHQfvB726oKibaeq2Eh2JZkfzuL7xnVsvCPvKJnn	1
1011	2vbzzibnW63k7JWLE6jbmt4dSJ6e3jNBdwYW46w1w6TbqTA7tC6W	1
1012	2vbA6VtKC32QDK55RchfGFHuYxyNNkmBfVdYrdRdgEdZdCQfimbw	1
1013	2vbK9KnC31CxffL3XZvwGvBQQRRzP1uu8KsgzxNFSyzD6DmFxxrV	1
1014	2vbZ8RoPULcqq4jJUEjcH7usmnPqVXN5nAAoXBuYGd3D7Gu9ivB2	1
1015	2vaaPwaDfznhuBnGczxKwoMvJyGKFwm5wQzwKsM2p12ErxrsD2mQ	1
1016	2vbSjXkmRbfYy6hom6nAUMQrPYQro3EUBE5pvTxwtDXV53Ly5t64	1
1019	2vbdCKxpMGP7gWCLAhdAGYFdKUMgSS3itzeAMrvGZNSu8MH4HVPL	1
1020	2vbE1KupFbVPHF9F6gC6SXkvdGxY1RR1yoM7XzhGH2MXZQkzhYoU	1
1025	2vbDNM7VShVvGmhKRqZdggQ77RaZxYqYbmJFxGjuoFzFH2ejzSff	1
1030	2vafrP3uJ3TN1f2E8CHc1EJocCF4CVn6Zzy6G9ZMNwxUixioaeMF	1
1033	2vb6YUBudAgLo8bhfu7i7Le3BYjqJwAF6xPjQMdtvpdqkoY2RrnK	1
1036	2vaXH3vg5h4ARqgqT5D1yJuLEsVJfhUFENLDiEkDyJPbEfiQWSKB	1
1039	2vbxqJ9ozdC9v5vkvjfRdPRv3VywYAUXDSYvifhbsXN6m6U78uDF	1
1042	2vang4QKSPCSyaJKaUW218U6mNbkk6cLrpCMmon7bXCvXnwEGgpc	1
1045	2vaKHKURY7g5KZqXvaFmKREZAgioXW737MzDst89NMP6ANSeo7pu	1
1055	2vbPEyQcv1DkuE7pTXBantKNsxk9hGMrL2MG5Qads6cTQmrtGmZn	1
1058	2vaLY1ku29nQpSok2FghFiDNo5gyFuaHSyurQZhtgpwsedGWnL8X	1
1061	2vaewNVH2vN6mmjtwKRrdr87g2YWdgPzrL6tzY8V8sgfwB5prXBt	1
1064	2vaVJBfue2pS6WFP1YQ1DYgPdntekmWLnCJJ2NV79y4N71r2fabk	1
1067	2vc3Pg3XwjeQpMCftVZmGvo4NdG8hCr4HKCpUhp33GFLAo8KK7RL	1
1069	2vanvqkBL5n2EHvqdSFRkge1AKku7xFXVvHkzUNxu7aM97KB98U8	1
1073	2vbz3qiXJNwSeVHCGizQPqgSgbNwRjcxtLNPrB8gWV2wTwj33Kx8	1
1074	2vaTTKfJJXoQziUvwwXwuviaX3bbcadP5BAuH4StY2UHwhcwHH11	1
1080	2vawQ1AbYQxWCJq1D7FfME9ghgBnwzEtgx2kC4s984uA2r9SjKZb	1
1083	2vbLT6vZ3bE1g35VjPVRrcxG1FJJE9xsFJ6npaFDevLWuh7AQAUP	1
1086	2vbRAUbGXMPeq2Z2Jh9S8XorueptKCQyY4Qsv8qDrXgx1qefz1Kn	1
1089	2vaEyDZgyGiHVZTQqmPx1K4zqtSw3PzVQ9TkpfZDxv9ZMVHEojcL	1
1017	2vc3Yc4mTHRZ3krvNKDaXNXXehcKRfWRQTuzQgjL22Qq1JafRWnd	1
1021	2vbwGKY3Z875Vs8DWDrFoQdu6obLyrARdRT1PRSLrSqqDU8pQBSv	1
1022	2vam2FaZBNyd9K1gZnTPiND36RPHjzjq5NQwRZDRbQMEwV2A1TMY	1
1023	2vbFnop2bMCvrFWGMx7DXBoYZEU69zBAdzskNt3ZTGi4oMeXSCx3	1
1026	2vamtbr42C5um69UUTG7UKquPFBef62fRwSu63yBv4zKizqsQVwT	1
1029	2vb89gD3ZebaKpnPC56WavYtzAR72wYUY3RHyHsNq4vZ6yBi4ci5	1
1032	2vaUyhxkxsaAGg5YNZwyH2VZBP1DuJ1P1oyeMGboUzz2xkDgfCgQ	1
1035	2vbQLJVxudxDCtEZwLgipYHs7TE3jjV3mtFA9tr9KgmFcP8VhMie	1
1037	2vau8M6inv2btGxsRv9yZHG5a3kWUXSpapM1tVX46pNiaBzi3S7u	1
1040	2vbXghY9hG9B5s62qx1hVJS6TP1KK8ooZ7zwTzVF3LX4p6n6Jwdm	1
1043	2vazmmL7ZaKC81xxX8SHFLCAe15B6qbZe3TgKrndspHx5gBpo3xK	1
1046	2vb5DtR3StnzxPkkXkEvk9rPAdApfW9p8yP9nDf3y9h1yp13SE35	1
1048	2vaJYgiYG2bFSduaYanWNfVBgQa469bwxAYnYsLHGw9YNYcAg2dC	1
1049	2va9fbZwfyjJEEPgq7odmyzWhWUtijqZ2zPGaV4AihFpviGonvU2	1
1051	2vbGNQjZXWFdhkzc8dJshGwp9rQpKMZ5s8Js4tD1zYUGKiKHWAK7	1
1056	2vbjWX4qDqaGN15p6tJPePSRxMZ8Q6LuiahSnVbCYfC8xUturoPC	1
1059	2vc3SW9AAxizZv5UR9kdgWNRfTb6hyt9QjHYLXwDZwhpTAiE2sp3	1
1062	2vaSciEdriuryRiJPVkyaPPEWxL5rKeHYarXR8nrUg49yU9zn526	1
1065	2vatdZzcdEw5dbioLYoq7Y5s2YbG98DNDYGzzw4utdz1YRM4GLRg	1
1068	2vc2tpdBdqfxYJaigsKdv8HsHXte1xyLhosE2GXhn3CESbiWRthX	1
1071	2vaeRDnj3BNi94FNUxQHMpREchwq9X3xzbuNLgV1Bi78bfjZmyBS	1
1072	2vaiswnzgJmbd6QEsysELv4JswTtsVs4RKLdtWjrNGLLr9TgrLZP	1
1075	2vatpWnZAWfpzoqHcaDEGvGfuAEtoLn4rKWEH1cZQwrH3NVe9uwh	1
1077	2vaPyeW6wKEEJjfZ8VUSsVAxxrAW7GMzJopuTGZsB5ZUfCEuTUiw	1
1082	2vaEUodRFzuEQZLE964eFQPc1oiRaxmyhmvj1TUd7nbFgaEB7FUf	1
1085	2vbj5XZfN6EvD78DdZFsuesS1VmGbTKBvrJtQpNuESgBA8aUCbw6	1
1090	2vayjMsaQKW67W9S7YQ8KtNVn57LNZZnUHXYwwmqrDSy11KzEzXp	1
1018	2vaXwzKsiWko2FQDbTBVMAjbgw4hKb1NH4vr7bkkjmuCrqnm3cEm	1
1024	2vay7GUzLK4xjTLMpmn73MkLFwnaeFiAmKUhP9en5VgGNMmksrWt	1
1027	2vbyiUkvFL2QZfwrXAWaGqZVhhK9QQnFZAAYAR94JTwjmVjKUEmP	1
1028	2vbq1g9do6yfsLaEeoNHumq8roxa62u38TH6qaDLdWpF3nyDGzHj	1
1031	2vb4VykL3rezcRp9scWMbxQsfoF3vNtfQ16wkt2x3qF9zkZsgMka	1
1034	2vb4EW4tmR2ZhrA6H1uDRiFkW7ZYYv5EJs9DFvZXM7KqDzBwMGNr	1
1038	2vb5yz9FAST5J1UZaGvuJ2D4hjeFyUt9pVb3WH8Skxn1BxhJB9NF	1
1041	2vbmwvMh9BrUoYKJFC9ZN558g7NGe52PXGFTYkRPHX2XBzJT2fNC	1
1044	2vc3TZzNAwz14XAQ2xPjFTAwkwqg7DtY7kBAWNAUPwnukRVLiGLa	1
1047	2vbNcAeiR6pD2VwUkUNmFLEyVyottTotwEZWN9Vq7jE9VfW3yrLq	1
1050	2vc13AdtQiGLyMtyiYzMZZiTbt36HbebFxN6TycCayV9AVGuMHCy	1
1052	2vbc2D2RLt4PiGUJB3SLkT63y4LEhSyZqT5oGBVAvHkVcoUzLCQb	1
1053	2vaRfKEKgET9ZjVXy1qNVvRtZSV2YxQJaVCa78bfM7RABm3mzJSm	1
1054	2vaEL6J518Lz3dA4HQAF4V2Z2VmMmBN3rpZuQaXj1akmV5m4Vjwj	1
1057	2vayyqrZ1wztjkUAVcwt9EXFzGSzFbtJGQPZ41XU4zjCb2LfaHvw	1
1060	2vagf4o2FfhHQQEDg6gvuQMyg48s1yrcEUTYACT4QWy48oGztwAK	1
1063	2vbU3P5yC1cRvjeMQQ43pk3CJouAh3jjkW4mHoaEvc37gBA2mXMK	1
1066	2vaHEMWM5snVsTmnNYAMoYvpDWo3eVMmbxMfhK4gB3aGmzFY6Zd3	1
1070	2vc1REd6TpktpYjRyFakAN58hQM2pSKXKXBPtiiZM163PsgzDy3t	1
1076	2vbC1EC1VG9jn4Q9SBiiVpPWWBaX5JxzRgXPcG6MnVQVtiLctF4P	1
1078	2vaEvRzJdtpwPwEqx2b3QqnCctXzFCf43F7yhJQd7DVSkzT7awGv	1
1079	2vaq3kuMEH1THmN6QgcdRdqr8FDu2afJLMLQo4keUQu9TidSQd8T	1
1081	2vayoRJ9TtCLtqSQVDi12i7H4VMaTQ5qiX3C2L85EE7dAUguxhtg	1
1084	2vaybR2M2cCjQRU9yFoLNJAcrMHbe1Mijf6iipUrrWUBMo9pkWfQ	1
1087	2vayVxYohVXp11PE5S3hra2LUVegBbv3odcNuvQTfiZujzB6AU4r	1
1088	2vauiHV8EvUpDNBbb1ZhWacm3UFn6yt84wHCDsa7fGDFEhzTWAw9	1
1091	2vbFG1Y4Brm2vfobsmCaftQzhRoJBv1EQ8ugPK8gVjAKwFg6xbc9	1
1092	2vaEgb2KwxkH7haWYo9Ac5f7yXbXv9Yx9nCcBtNA9W9FozYf3hKg	1
1093	2vaf11saWahmwT2Whp7SmqEwBJfC9bQcWXCvLSnpSCU2A1ZBVSiM	1
1094	2vb1FCEf1psp8yoV4sX8tVv2fWdHfoj6HcUS3exwdiJgmH4igpMA	1
1095	2vby8HhBrU8H99WcfSSkA9FszzJirSm49XN7MWzvNmMeCbB3LFTg	1
1096	2vaat1ypwRn9e2Pra26tReb1RbAm5hwthstECmDjppCHtGVsvRma	1
1097	2vbGxao3d7WMCGza525urABhitfgbGTXEq6rbikziji5hMbt8g1q	1
1098	2vax4cGdaWWnDdXzetxYKok3JYCT42ri1TVJYsqTCpihNpkXPS2E	1
1099	2vaevmMwfZqNr8j2zGpbrg3crG8LGb27HqwDitZtBrTnHUjgf9dx	1
1100	2vbHBzDkhB9B5H9J1iRRrdiWBrMne2QwgVViQ1vNnwFQgVhJkp76	1
1101	2vaYG5U11i56f8hVEonjN2EuMNqj1wNsYjG124CXX6KzeCibsZwv	1
1102	2vaog1aLPvYizRw2yVQs7Cb711VBmMniWB24YbpBDkBc9RyZEMqs	1
1103	2vaHj7h9EFdL3iFBBp1R5depZCyowBQoKDyYXacEfAguFmrsneaS	1
1104	2vbpC1ACY8HGWa18ocPSuqVM1puMSEy2ofChbBKHVSAZJ5HjJiHz	1
1105	2vbJ8568aw8dvQ3yvTxhp8HKCPgayzCWjaSDAxUiSKXsUUyLEupr	1
1106	2vbm4oFqMTx8igk4kQcjzh4dUSHY7LYWTfxNeTr6pVrxhCJBXLHp	1
1107	2vbveEQtzZjfpiAHRgeoatJNpqCUVFA2vNDe4rLYDP3qjC7R3h9B	1
1108	2vboeVcgkdh4VhxRhmUDPGfHLkH91a7mHJYhBvowcr6GCH9q99vN	1
1109	2vbvZKLdsoq3kW4B4zGc1PEiYPmXes47VQJovTcfT8i2tevPxA6F	1
1110	2vbbYYLrtTbko1Uh3TdAeY2UQoUD12brLDPzHAe3cdCudpb7hbTg	1
1111	2vbjo43mNhRXjRUiuREhAuDqwCM59Bajei3SwjeLpcK2UKUuGVAB	1
1112	2vaqXF1gN6SMuKJEKxgVbkeA64NHE97nqhHz7tLeMK3A9hgK56iy	1
1113	2vbFTLMZjZ8Dg9y5jabT6gixyRJiYGPeS7kbN3Qi57YqAggFE8jB	1
1114	2vbGKVoeyDATU3gSccLCpfNpp2anGtLuupntzG6MuhNa5iDWZBrD	1
1115	2vbuxGvFxbic44Vt2jHr3QLpq2jffWhFgMo34jgkqV9Cm92P24BB	1
1116	2vaT87MBYoaHjvsYDwoWWw67quG3ZvxC7iiFJn7VHETHnLHdSLjd	1
1117	2vama5WrDA1Rnrcf4WpDeMe36Lu2DZDeGxdajgCGTZYyXhF9yo4U	1
1118	2vaRfhTR4SYujTWUBnLEc8bz1NybJGphoRnMM7WrYvouaxQeN3DT	1
1119	2vbqGgVHZHipY3GJBgmrWk5jawpbMJST91qoYmmHq6h24F7BTj5d	1
1120	2vae58RkFbULdpSj8Lj9QAejQRPwJBKVyMtpDMZGv3mLet7qFEhV	1
1121	2vaRfCYfjNqggpLoJFeigsmn23FRsUecLfZ9MJmzpK62F78fNxLd	1
1122	2vapxVughvATRnxHKhxgAGgKLaUyBN94L4YYubDn9x7FLg1zC9dR	1
1123	2vavpruLkE8yDRxeoSD6DqCVQRsK6sdDAeSv41kdrBWMu9C4WUXT	1
1124	2vbXoSUNEp7eFqQ2eJxJUNNpwSWfxEkhxHJZhwx9MhbYH7aW8Wtq	1
1125	2vbgjBpC78Kj6ffaDvCgM1dF15CfPRWvqn6CJBwDWpRhsPz5tb8F	1
1126	2vbqa31ndfXwrV1ewv5rTHUt9Q1L5hPe3quKLwmi5bZhv3dMW5dt	1
1127	2vbhXPj74ZccSUXRhx8EguSkw3gxQwiEYa8Fiat78a6YojmZJbXz	1
1128	2vaLtQJgtzCoU6AJDGNt41uCEEcgzRtfNdEF3HozyGovWHniCG8k	1
1129	2vbuLfpfqowZE9Up947gZ7WP5guLViKZ81LzxqWA8x8KkqpmR4fB	1
1130	2vbjVb7my9fE8cZYTa8yqLkcHpPzCiV2GctGETnCrt4mRp7QHnkV	1
1131	2vbduXX5S18WuWVWXS6g4rDsGgmjWTBJQ2d5LNCT6Vq9UFig6ZDy	1
1132	2vbf35uThPvMQxNRSwEGqB6ChLwRmNTf8ceofZAwjJmtcxsn4BKQ	1
1133	2vburzGBvhSCYg9ggj5MTgiSx5dx8HxfLrbFLvAPadMijp3NT5m6	1
1134	2vaFNP9WUSEQWpCUQWLHJbto6SoZiSgrkeDjmdD11KrgeL6SwgBF	1
1135	2vaPtP69gJLSKnQEaBTQb5xnwaow8xo3JSEoBhvLmAKyFZb68B9W	1
1136	2vaWzvMgSqgiT5fvSYcNPGFcJ3tKVAbbhoM9D49HF9n8Kw3yXGXS	1
1137	2vaBZ1sgpZ1f5MK55Njog8VLkqryH13xmK28RMAxHaH1i7MXoJyw	1
1138	2vbUHX6b4SNPbtcVk2U55quL3QP9J7YamR4XUgtFwDicW4LjnVMM	1
1139	2vb4iXzcC9MSxKHq1dR5szpZmYRMN7wA35VV5VyozpdYufBwjQc5	1
1140	2vc4pCgibGP8eQmcFoZXfDzsqyKkE12ZmLfNrHSvKpxojwLpDZhL	1
1141	2vb9nkPtDQzyZgg86wTRkQY7iBB2PZM2MhmUreW4vsTC7mGpdv5M	1
1142	2vbsLRaZbxEKrvhiQnjQXmjKXsYxYikfboBm3saeNkf4pmKBFzzi	1
1143	2vbvd4UyKAro7oBhVEp1z3Ye3BtwJnq2hocXscKbsabHD8R47oVL	1
1144	2vb8CTK9r1xDpcpVx7u59gTYtWiPkYHKU22sNAoKmHUbkyFw7yiu	1
1145	2vb5w1MKyn7Pxwa6hAeQC3KYdzoAB9oopJKseYN84vbEAK4oV7Rn	1
1146	2vbYxPKjMpTBVDD69pa8jDjw1VPZ4wP6GSJQpNNYPDdNGGsEyznt	1
1147	2vaW45qPFAH36ePiysP8QVe21WSxCqjxRCMmYsc9hQqLLdrmFPcW	1
1148	2vbrdWVk5QJfDPEfhzUgVivEXvBrsECAJ2ojUk8qGrsz3wBquh1q	1
1149	2vaBzSiTocFf5Yw9te6pL7cngfnHcKcJzyFTEALe5jPhpjZ3aLWk	1
1150	2vaDmyZMpQ6JVcv1BxcYYnKTHQYejR3U8fk42ZUbTPFMgapQFEAt	1
1151	2vbVAky3m4pMiHx5Gr4wDumXACE35rAfAqw2frvNv1uUCe4hesMa	1
1152	2vbkT77qBdMRiMq95bgLJMk4dG8VTi466TLWUWbgwNbxNieJLA6J	1
1153	2vaDuxjtsJjwC3AbfCVM2g37XmTTnEN4ek1WNF97kmxRWyeNWgRm	1
1158	2vaHSVLdcwh8V8WGgwBxzRFMnV2GiF3KF84KaE342rooeAwkXkdW	1
1159	2vbR7LpvmW7gY9kxxmv94f3mWbr65CntfuQVjVfTNY9kePZJU9xx	1
1164	2vb5M1zZtAhDDL2WCB1yUYvmaVB4nNLwBqZXF9eeMbMt6Zurq8Tc	1
1167	2vbzv38dosWZkUEJMrqTMvMj7VjC8uQ3sp5rhUTx8sysqUAqDSNZ	1
1170	2vaXS8VDESST3K8pRAU457oqFRfpH1huEuNftRDD8JWET5fpKMwS	1
1174	2vbmk1ZFUuS6u5kH9mMgF3HhgS7aLN2kFQCzBbQcCKFzv8sEfG8g	1
1175	2vaznzwt5pRPu83Y4wLfV8mCZQWAgYZwiFx9qwB7yBjhm2EpgajF	1
1177	2vaUNY4hxYt67UzroLvbLbTXjuJHofZXsthbjyi9kNKTEHDPT12c	1
1178	2vaXnL24HmCdoWhe2LFTXMW1TLzTQ9C9qXkgWvHWSNJk54CTZko5	1
1181	2vbxzxrGrr4BnrVrEzu8N3Kymwzxye66mjQXim46mZNUcSszA5MT	1
1184	2vaYesDhs5MSbVNzHvVWVdXhnMQb4qe2KrC3iFyndRCHWEmLuwT9	1
1187	2vb9j9aqanZMKd9r5a2wLhDRzugVSZxPwZaogjJYgMqV4x1GDDdX	1
1192	2vabvQYquAmNQg4h2CfUM8RUZdwLcdvYVNpbpU6JBxUirSKnjFEB	1
1195	2vbPRmATfe8sTz8khqbRhYhDgMg72hh32uaijsH48udknN7y3BFu	1
1196	2vbwYJPdpvZKHYf7PrshGw74AM144JJFitqSDu64yPpFEMBYcvNF	1
1199	2vbzQ9bnp7249nq9HP4m9q3XFMSzfWzcQwVPJhSAe1itHRLYjQWd	1
1202	2vbSTXHoKdw5wmxAsDgtoig64pKcqjFXgneErTtjuU8j7UEPfmKk	1
1203	2vat8fHSpddv49m2HHGdxoxhNhUqdnT4hfWoDvwGMpC4DZW859ZV	1
1209	2vaLfKShBLGFGFX561FLevoaj97CdipBCM6hEkPH8bD1bqvW8mdN	1
1212	2vaNmgKYnctZtk8X7uFwoxSEbSs21EdYbpecT45drCfrZ4LF4Jna	1
1213	2vaTxUFReGJ4eW2PMNPc1rUChb6mt8Vb7M55UuuDBpLigyzN9xR3	1
1218	2vaE7YFDwMEFXgnsniobUXRztXFSB3dw2RDgc9gV9WEXABesKtcp	1
1221	2vbsYmgsm8YQYa3uQKdDHPNdjT5ebawBXgpdBGQpuoDgrtVSJhCy	1
1222	2vaHEhFoDzxzSHk8rNsEBWAfjJHtwXF7haUA7nSz5zZMtZjDpDDB	1
1227	2vbmd2K7eHkW5MHLVa2KN7Gp8UhduFajNQ2NW8d7WYGm8MVq252L	1
1230	2vbm9C2NFpBiqrsqZk77U7oM6dt5GbNzVrN5XoRczjcvfHaJk9FW	1
1240	2vaEWKegfZT5qrhXBCGzTaArxfnPDam5LSy7guzXu8BrBnQsSjnW	1
1243	2vaTe3fJHzZ3DD9qwc5LSvUGMHcJcFFeJqYzJJA4jnz8LhhqjGKx	1
1244	2vaLxXgXT8PmstK1j9nHu5gGUFMdkvoTq1RjQPFnbYZZweUG19Qd	1
1154	2vaMHnsVSM7TrTSsKPHkLCKvAG6zxTxD79b8j8QnWD1gbaJhSYvU	1
1155	2vc2V52u58sJ6aqCGpC3FTtm6Pz3j6oqYhHF2DBkE5EP5szPttPV	1
1157	2vanjHJxzohtoRJjiGzNiGRzUfLJkH41ELQxP89CeHSLnBazEJSY	1
1161	2vbkLN92i4UfThAnodTQuWMSjQRaVoF4eKcNQMgPcobjMWdVoudc	1
1162	2vatiA3GzCnGkJj53paQA5BMrkbuM1oJfAnvCgacGS7fh1i5fAx6	1
1165	2vaWXRTkHxcYeXVkQuu3spaQUYHxLo5f1XQNEFcmXqM3nqCRAn68	1
1166	2vb9jjpj7rbDFCZBnvd35iHBtv55MUVZ1BrLbtJW9LDGGjYypicV	1
1169	2vaPCZZE9sPZTEwyHF8LSyDiijvNGE1rMYduw8y5co4PG5iYnCch	1
1172	2vbcKJ13N2Lu7ngLdGVQbGCxDerYpexgUvZ427Co6j9zsyQcTPcn	1
1173	2vbuyefaB8jGtuRwHu6XwUAqxSRx2AgX7ya7FVm6NqyCgLUBsKoA	1
1176	2vax5xRQwNTvJXQd3tLRu3STfr47tEcfCDmNoNqWvaoX3oRJu1BG	1
1179	2vawebyQ1CeyAzcvMCuoLttp35HFKJVDMVKfiY6FkbJVNVc6L6Up	1
1182	2vaM5uPtWtpFnXoWxE7NqUDaKn2ETrHaxc58FPPs6iXV1GEtmo79	1
1185	2vb3NiUQvXdfxfVFjq1f2AHwpDbyxobbUygwwq6tEoByLeqcvKzR	1
1188	2vbYB5KTj55kSSNqD64Wg8ak1Dz9UpWH8Vyf5Eg8tynBpWwCJpxs	1
1191	2vb5SzaXLwHfMnhHJuMJ2seh6tq1mRQVHJ9ZGFseFfjENBKHH1pn	1
1194	2vaPd71RZyKTBjybDJYJB9GKvd4BnuMYVZvq4d42pTPifP91pMiS	1
1197	2vbrHzSW9LWEBxeTzKBU2Z2gcjCuhi7Fo2a87NfPj3s3sftdk7Xi	1
1198	2vaxgf1o25cVsxR21ZkK1NA7fAGMfjTkZBT2K4d6C2j5z8vkNbBK	1
1200	2vbhkx6f6dmp4uZK2Y2AJshPimHqPuhdDrVSrLHZV54MXTcKT7E5	1
1201	2vagfdD1crhF1s329z8d1tTH7brmeyr9VJyBg1CiJx73prJrauRg	1
1204	2vbM1KtcGkTcucuvRAeAZXeSkDJkPBdJTsJsq7MCGyUspxXt63Dp	1
1206	2vaQExRso1HvZTBcdwnQ24yDHTVs1GbqiAKi5iJRfVq7192vSQte	1
1207	2vaWUWqqc9ZiQGrGdzouPqJkDmhVDepfByLpd6wpUq7MYiXTuxdc	1
1210	2vapvFS3ti88ykMj5k7j6ooeDk8z2uJzpVPnsZtsf2WwdpzCUgU5	1
1215	2vatj9zqfSwk47DWokECX6k5i3xf9FUG9J4NATyu2zcYgJwVGCbp	1
1216	2vaV2e8nWMjbfBexDkUva9bm5hjRsXxjXZFPd1J4fftxbck4tSHk	1
1219	2vaMbH4V6Pv3XCAXM1PNRaGtjahtMi5bp3wR1t3AunJ3Px285Ak2	1
1224	2vbR3ENVRv1LFi27gH5bwaRnuG18aCWpErwPJFcbPv2gswraVTwY	1
1226	2vas39p2BWg3TNAyRFQpcjmcakfnmUnx8GW6ehfGW34AL3cJB8UN	1
1229	2vaTPhvrL36Zd2h2txZrib4i4dnJe63zVpKtEzgmRgCAxk8acZ94	1
1232	2vbBXpBYKZ9jNUAEEeX6Ut4psrd3pboZEGQneV4RY3nnJBhMHubb	1
1235	2vbmc5uBoMi5D61yj3yBLHGuz4MTRnuf4YUWZ5bTd9h8EsXguKNu	1
1241	2vbR8FxSASKkHcuskoBMmbpH24gmtxp81MZVHrAHa8pPEWUvbxfz	1
1245	2vbDecSYMH5wuCUPtpXKqWG9a5LWgbjHCKspyax5bnJEEjyjEmhc	1
1247	2vawoFML9V9WfNxBWfDaLNtZGWN5w11To4L5t8soriEJS7P4Myn5	1
1250	2vaaxLzHAVWTUuawsBrrzKFWFDgRwdqNrCZ9yKegxWcAihcyvwTn	1
1156	2vbK1nZ7XnpR65m5vekwCXMN6hFsHQMAfkCBiqEyo9eZF6HdBtGc	1
1160	2vb6vDPL3zd2UHc5yHeLQ3sNo7dxxH4XjPY82tFBT26qviP5wmeT	1
1163	2vaFUi3KDRKg3GmbfxUBQMnzVkEDy5X675YMM1sVjvTfzF5cTpmS	1
1168	2vaUhY7g7gYMgNPzAvgie4XMEeegL7U91NrtRHHpzHnEVKXRR63J	1
1171	2vbRNRYe8BAi2jkXK3BkeD4YDqUaq7vXAJ3QmEpk82GogSb1sqou	1
1180	2vaS7VVVN1LwrGMyCxGHZgapM2cvbjbUKQQw1CdFTaGKS4PEkEXU	1
1183	2vavHMJxj8g7d35xgZtZKbDfrJCW1PH372zCAf65s9w5y84thDst	1
1186	2vbKoo6u5FBsiqxYGXQ8gZ1u64YuWkkehe4SjzEojYDbSkrqxYcz	1
1189	2vaXTQpejy6hyjCT5XrrJxUpekRbXR2McZy9j7kUTwV3FbDnb9iE	1
1190	2vbc2wMRzouoCkuy8fpCjkTjGYuzKKsECop28E9ghpczYMJPG8Zy	1
1193	2vbZ3Gk1LnGaY3LTW89YeDSgBN8KvFDJcGrghvSJinFe6Jjf8Udg	1
1205	2vanZ3f5T6QjBBsAqbaDPwiEYw9xBascJ9VeAK5TNReKWL6R3vtB	1
1208	2vaiVoni1KQvDucXi99484xxcveehh5yqwKrJWdvrb7y8seWeHuo	1
1211	2vbuf1qqspVbbL4zgLAiaPdx8HRWL8AcZypCkQgZoVB6dramSqpv	1
1214	2vbzg7o8bERMV73DjAb8Lg2g9EhN98u8PFLjhrAzV7aHmQCCwvp7	1
1217	2vbPAtAfQzL92QeBFAeDG72qYvbKk6atEs1qhhHfj7kU9s5fz8cY	1
1220	2vaaVxWpdyBrve8nBGUtSxDBkotXiVdnXZKaoEY1qG5CXaVHkYaa	1
1223	2vb47pkdWVePjb5DZr4QK3VzRm5cjLhHU948AZMoDy2B7BrShH3o	1
1225	2vaTuFKfWKPeVDnKePHbTB3bok3jvcC6BC9NKz7EzU8VYHNCEu3A	1
1228	2vbE2GW2yy6A5EgQCbgSWAn4BzRVCHHBhsWWFC5MU86hLDLHVRYZ	1
1231	2vbU481pBmPDDoyvy3HTaLVZU5i1hSQsSLLe1EF3dzwbT3PgeFpR	1
1233	2vbwHgpYkzsqjuBuarxTwqNUUwyK3j4JwJzNUYmxMWCRnt9WDu65	1
1234	2vaVYzMyckaKcvkabTGBFWbrx7HiBQkebErXG9dQHsEeLDB7yeiq	1
1236	2vaeRYRc4quL8AHoRpDfvhxNvWN8uuvZJE6ubqu5bv7xYLcnhcES	1
1237	2vbfuJ4AuT4EysqsCTmDgba8v3czHkPkWWkuzQM4W1KDebMxcJEZ	1
1238	2vaaD9mLaWXdVrRHdYpQ3RAJBd8V4Tj2NCH93Fv5nFX9mDCtrQMk	1
1239	2vaFZmLKBNoSJ7NJGNhxXeEi1L8p6t6vLqokuDZgdYE2TiWKcV4B	1
1242	2vbFqw5tXg7cdhNC45YFHTvALJVgKDmPnZm7vdFAoTwSCocHr2hT	1
1246	2vaD2sKybV8PSjWP62hmyoWGmR4YJL2csNVxMfRzXcapQxqvMGds	1
1248	2vc3ENyPggKWGPAMX2pJLxYuts4CbujQHgPPchTR3LNnnB7afn6y	1
1249	2vbo1XPXCt7bsiRKWQSnHCNQpqrBv3AcqEtiXDXvqK55o2ZyMnqa	1
1251	2vap6XkNwdK8kvYBxXcsTh6RDjeVao9mkcB9JKBeVVXoDgqB1t3D	1
1252	2vaXaAYJRCVwhirDmNNegJe5YbgfFHaHooS4YXyr6ubvdz5yymYH	1
1253	2vaqvqSjkq7tGjohkJptxDgHxzzCiCoWoBJWMchsJDE9D82NGLVE	1
1254	2vbvbYovHK227mmLD9BfKp8jjMfHSRihE2tGvnsnHjCCV7xrb1fL	1
1255	2vaaLMzVDznmZLchWgujsFEXSeweyfLa66KhtaeQdHjYMeQHJ79g	1
1256	2vaqwtRAcMzw5bZ5SiH2fM4rNiZLG1AMuDosv2i32qcpVHBLTbLd	1
1257	2vaTxD9TbsUYS7Qcxhy8DewBedKWgxM8ZC1NEPE7GAo5aLa7irHF	1
1258	2vc4k4GGvu6p2kGtE767GyobkeJDquywTCivHUeyB6dVrFZXpNjV	1
1259	2vbwZdACHHZFE2o1kJ1gbQPJ1kgeyPssDX2SKVLn8eePQeCmyBhY	1
1260	2vaEAH4kxqEx9rFGq3sYwPnPBiqXyGtD2Sk8XDAvyLs7dJ51GcMm	1
1261	2vbcAHvYpJ6VycwZSPdZ6uhVTYP4yDt9HZzgJWsDtuxAxQuyF9vy	1
1262	2vafH5CbE46pRXC3zHyZUrWdGYBWpqCpzNx6A1EFpcJVv3vG5d9F	1
1263	2vbmJH4aoeEosZ3VCJhaqf842HB4QmCZEqwA6bMFkxmTCRxduYfe	1
1264	2vc1KJJLV3NrYEpGFeQtU3fNYPFGgGpGWZMG1Thh1Xnd2qhZ8ewG	1
1265	2vb4taftq1iULmK9uxKLG1VPYMpgTXnDHom69bjtWVLZCQcaUCpo	1
1266	2vc58Mx97p8A7NdsWA5gr557o6TnxNyTkX1hheCYF4CHZ9PuLwyr	1
1267	2vbAGcuWGMmkYEfNUx6JMLE4Ke1Kp5SXCh8eNBXWA11jGSQXFxuc	1
1268	2vaERDKQuAToWNsdGSuwhG9eRXfy6ycmWpsxh55gszXW8VPa1YoR	1
1269	2vbeR4CsqCJNsRapEN2iStWTUifMQa1piEnDFRmea5yucZS4wtx2	1
1270	2vaREJsj3YHYovz6eQwe4chmLLotp7EJNNyQMeFCQc1onmoLn495	1
1271	2vbbMdcKNZARvea7kn2nPp6tSAJ6JdR6UaRUA14Z1SygcEEVJZhW	1
1272	2vbNgduVhs5xfWSdYEB5prTAXpoFpiL6RWJ1nWkKaCLxjNuhY9Jd	1
1273	2vbgdjirC5gzFhvWmABKUyMWu4PRMhHSaQ4s7tis31eAHqc81WJf	1
1274	2vbkrwxkxmxWmAAv7TVZNPrqMJMKRQXivVK2ToNhS2YSeSvXtCT6	1
1275	2vaNjsEcAPvaFxGDP9GYr5phe5YpmhmVhydLCsrxt9moMLFWDgfK	1
1276	2vbsPaHNV6iEeWV868sZ8oqD6EhE3ZsEQQsAkEAm1hqeDFdrJYVg	1
1277	2vbCUsHdTXcYBaQ8YUPomY9R2hS1vr5Mb3xMNpHcLuUhFPmBznrC	1
1278	2vaJ9Kgd4KWHCk9bPyNFCb8Gk2cQytzFGWCWEPeNB1k3zY2DWvts	1
1279	2vaDguykmMVfS3XrWkUt4nugVN8VXN6rs5KEQGWE3DWRHQfiJyHg	1
1280	2vasxwkXMMuhuZA2f6fDAgF1sWeEFYn4QuL65g1k1wZYSP2DJUNu	1
1281	2vbfvGjwUFrFqkobk1nXoMXHvZWCZYE1pr8oZfTByPbVKyH7kPyQ	1
1282	2vbZMYnKnxmMHgyAFTqAu8fc37vcu7UDrcN5gWHHtK9YkPU8bpVh	1
1283	2vbpZjqZRYX37rMkgMQSnESgXzbUyqNDh3zJqXPTA2CemG3o8yx4	1
1284	2vadnHHNMPxaeSp3BPypfXKR6xcHVBdNpJEwPJqpr87sLT9xquqZ	1
1285	2vaXZcRwMshFcGxeUez7WMHtYYJVPdztNw7ANS3kDN222oKtkJME	1
1286	2vbxzPxLmxb5AAy9cVB3UjZpyiFGNyN3Wb9bexsiYKE9xEeYgZoS	1
1287	2vbRHAi58toE6RGLBzGDAt8BmDRre4SqoMVY7SRPnVxgerXfH8Dw	1
1288	2vb93i7UK8FNq1T5R4Sq2KaDFtJp7zsZU14K3odWwvXkhwZAdB1C	1
1289	2vaUBKHtMdNrACV19SjD4tMWN3C5cfSmC5pCaP42KiBZqwh3iqBp	1
1290	2vanLvmRWaXUNekwqFV6Y9rmdHxCS5PZHxW7ey6iShLdUKYQzrtc	1
1291	2vaSXhcfxNNw51wknR9CMYZ3mEKYy2hkLBEAbDuSspNtCRrw7VvU	1
1292	2vaX8XEFH2fXsUpyWYtrCCjd5AVXqNcbqwZcefBzhsAV5Wwr15N8	1
1293	2vbWzQodrezApVmFrvXyLBS62QPD8eViWmYHVLuASGx9EjoHiNjo	1
1294	2vbxjgwGv2aHR65QvrHPu9RbBdUG4iEugNWrNcZSEeAPvS4aeHjF	1
1295	2vbXwJqzgYAfM1LYQpqC9GNZhPjAod9DSemH5gQKsAVotKBB6pxn	1
1296	2vaBWZWX9mTwtiSqbCM9TGfnqKvJ6oiFXvvLemuHj3fCgwaaw2Cv	1
1297	2vbSqJ8ynpFHaUHDNjxP1DdJwewovaLRLbxevvWhKU8YhJax72XN	1
1298	2vbk2DiQ4tEXxqpFvt71nNFTTEWoqrakkRnQCq4vNso1LZkbg629	1
1299	2vbRU2H8WP5etCWppLT9bvgp8UpeAR87HQriYPsMc8pfAvodm3uL	1
1300	2vbqY9TkuiQ4URYbay4hwSXFLQPb9YYJorXAEaKfREcfRaWHMGFX	1
1301	2vbcajQvjec6SeHGCCa1PLKzg3LiPopZDrp4mSsgme6nVPMpWZzb	1
1302	2vbbWK6ZRPisMktoVMxoW93gqLK8joyFbDhUJLLV8jq2pS1o84D3	1
1303	2vbvQJvbDBr8t4N8JjibysyRHg7s3tMZA47HWhED8q6K7aAF7GaD	1
1304	2vafkyvB5TdDsQoRDvBTbgtLbyDrnUF8RbYGcXzmUjEjFuGJ6tVa	1
1305	2vaDgbW7v6rQVEDwuVjQKXeuQ4bHREiYMibXJ8tNCkbFjC2iyiRy	1
1306	2vancmCvAbdCq9xTgtmNbbuhX3HoUA224Hkrj7P2UU34ys7G4nbM	1
1307	2vb457BTSwHnQt1KdxwE8DXdRZzquH9hXVX8sDh2EyNY463zhbcA	1
1308	2vbo7qk87zJYxWCwVn5uSxAPBVYjf3HZzbxibgsrhGbnbxxREUuT	1
1311	2vaEGFY2XHUnpZT6jGHqukB1pM4UJyWdRNCGDXXdGQX9qro1P7T3	1
1314	2vbeyTeMHJPVvx4Nif5mP2vhVCRsCkqHn46tXs5DeWNKR4MqUTcP	1
1316	2vaV2A6gvrxqXNgDSyD19qq75uAZigMh4manM8DMbqwBNkWqrNyo	1
1317	2vaZUnbBstNo6smNtExjuCVEDNSbZTpd8prXYEVdf9KovyDaxpBj	1
1328	2vb3tZB2yBh81DJdLeTXMj6hEAVMPUxaD2YJKe7nJQbUd8ze999A	1
1331	2vbHmxX5MrtW4Ug4ZRd7SARZTJZsa84XcNgZfLzzJ22Npk1BragD	1
1333	2vbAMNanCZZfFy5Smh8F6iRa7V5iEjg9sRdsrdsVsjRVBTJWpe3i	1
1335	2vai1KstaW4fGcpkopw3f1CAS8kMrA9jC3bR6uAMy73z2TR1GhS6	1
1341	2vbCtoqoaUQiKJgrdVBPG1bWMcPi9iRc6nYNnqgek16smYABAifv	1
1344	2vbxiB5svPDfHw6DLDkR8ZWTM8eBC5xgRzc9bdWhuYziCFSkxVE3	1
1346	2vb3w81SEh6HoAtgNAybKG7UthEFqhAJVGPfQXLBVrPesaGZzH8Q	1
1347	2vbXaQdwmG57nkAV7Cv1J4SoYEq1N5qcNh5R7LuKvWhJjx962SGa	1
1353	2vbz85Mk5CErndx6PkvLvcQ23XzR5Brq87vL1S4UJPnHv6b8ZWkb	1
1356	2vb4Y9G6byYSiznukDyVFEx38DMx4gnXQR2YyMWmqBimWorA1vmh	1
1357	2vaRGtNq3DRFFUa7D4PUdCFPZL3DZBM53rXKjBStDBdA8JnhLjGP	1
1359	2vaZGuWFCUJJD8dNnNawWezPkCc2HendhJs4jjztEaF4u5jQF7XR	1
1360	2vbUDy6X8EHSeE7dNEfUaZd1BU1nd2K5pPhqgo8QphknF7DsgwyJ	1
1363	2vaRiy3FrdwNjDNSjjZx6HFkmsNSsYxpvAxiu8ksC6bjEw1uSPAG	1
1366	2vaFty1rEAo1utwV1CKSEf81FUz2jqWzGggWfXLDQKywtFfyig1f	1
1367	2vahx2FUEaN9AFtGzujaJ2hurZzzdbsKcB7EqHvBAdHLozFgDi6V	1
1371	2vbjTcEMF4g4p4mhdkUCctDXnqsSWfHJ4nWUoA2QUB8tVnJexq3F	1
1374	2vaS4JpCz33tVETf4vCRCTJD7uG7at4otJWYeko1nTRZLKAyDo3U	1
1376	2vbUW6tH7ZATHzkJseobJ1m4KhtpdfRJmB1aFfhQHqDp8MRoUwGX	1
1379	2vags1aJPgdvEJE2HvH26Xtc1zeb2CJM4zfX25JhZpd3y5WGLGXP	1
1381	2vbkB1eSgGuNhBAByXFLZejSdfVfpLiuiVSqZ5hQPMfGhzmFYRV2	1
1386	2vbCNqTta2gCXMtqQ937wqBwzJHJrYsmfJHytgEHHojjFAhvcHPJ	1
1389	2vabpL1gWgKnq4iAAMEhEnC1RNJKd1HV7dWYyviM9p4Yg17bpdT5	1
1390	2vbZe5q5TsDT8GdDk2PgvSePVbUaJZy3miSHq3k64NxsitY3hLYs	1
1394	2vaC3FErSZvuDxv8GHRV4EZBUsKHoe61UsaRyZdQC9weRW87Qnsd	1
1396	2vbGVwVn3hTcixc6K2M9AqdZhVsNyQGiR1vbAVYFfBwR3dhDSnRc	1
1398	2vaZVdPWhNtAQGUxGG5asymVEAvJP5eMMPc9ku1T2fx1ZMWfiTKD	1
1402	2vaWnDUfdX78GRAHVTHrq7MX4LgNQejJudCzf2bgRHrf5FpbcfnF	1
1405	2vaoGnMsXaFuikY8U26yFWS8QWAJsxj3bZzEFgw3aiCgojf18up3	1
1410	2vawHWWz66gjQ8VJTdv3u5uhWUfjZH1c8r2YvFJopwHCKxgkpTbP	1
1415	2vacBoUvM2AgsMAFB5JcSdKKxbeS9WBnvaGEdkM43VexNXzCwHtw	1
1416	2vb5yrgendoTsS8X7wv637GeoiNbN1E3hqinQu2NzJywu1HXPRjw	1
1418	2vaAeWUoTeQAzi2Vk6kvSfmU1yXBiAp4fB15TCHd4B9SKsYKY5FW	1
1419	2vbSMK7d26ezh2ZswNRx59RLpu5HTeAA7iMxV2y6c5RJohwBJNE9	1
1423	2vbpCZnD7ezxYhxKa6uFM1pxwHGZp95J5VXKGAJDTEDUUsm4J7rp	1
1425	2vbWoGJcJCtAddvJ73qtmZ48WD3dR1MZjXUn1zz2JkTSSvYSpdoU	1
1309	2vbByDHiAeqyoDew3T3idv9R7WWKz5VCiysWV2Gc4KRBUB48VcME	1
1312	2vbj7VxGmajvDKSngtAktQ29EEQPUJQXpirBaHZuCkhxYveRExxY	1
1315	2vbwJvjut7iUDCRQUMFMfY2G5eJ3aRdssV9DCLerC2YSHDGj4xsP	1
1318	2vbGTJ5hmUv77MsXeECrM3TYdCs7Ao3TWACzfRAbaNMWfatdM4HW	1
1321	2vbA1jx76toAuCjqPJAY4Dag3DXUCyjmF7gqFsBsSMNGZkSrjvJg	1
1324	2vaqGXi7xnMe3cSUjTtUvCuGSzTZw9RiRsHBhnBJ8kTxyfXUkwar	1
1329	2vaHL5EAMMxgc71iMU55oYGmYoSEWm1LQBN8rd1yzoDDC6o38pZL	1
1336	2vaAhsWUEW6qqjCVDSDVzM7M5vNTma4zzmBM6A4L8XMFKN2PjGRW	1
1338	2vbM9zudtoZAz35bpdiN1sxBfeN3hLVmm8sfFFyHvQ8mh3j83son	1
1339	2vaCbh74UkTT47K58Xm6wCNeE4CtbaRMAA6TFtas1VQTjZw5EGpT	1
1340	2vbbNX88Cytogbtut4B9wrLWQY5GQzB5dud6NUD3nfZQSLBYNNPu	1
1343	2vat4YS65uuiDjj7mrWpAWH17UirbtBqhFgoDodKxe4WWfR863m5	1
1350	2vapj8wWY4vhXEtnh88FEh2o441XnLwqLC5TzEBNprcYec5AFrTy	1
1351	2vbhdMgwwe6GzjvhqUGZzsp3kJ44f8dMwMqmkUBKFSPWAn1ESqvo	1
1358	2vbQKdqF4MGhDRYhZ5uKFdn9NqqyhNje6bB9sQwPH2UJD8p8GJ9B	1
1361	2vaw373Fd4pUJ58W7q2itkbm2hJymaYGoBpGzvahoGwFaSWqVgg8	1
1364	2vaHX3tBarwSDQf3GL4j3kdZDTXzXkzEbgsmuoYqf4ETtUs5GN8a	1
1370	2vbyqD8SHYyYinEoJ2vuRNonqrpVu5aN6bQVPVoDqNVxHTq6qo2d	1
1373	2vaNfM6i14zTRRUsSpo1P2h1cUC532V1eNUMCofz1UZikcKTX2E5	1
1377	2vbLfJSEBYGkjq2n3oong6DCGtPvuZu8hEPPHvaMzLZixgSDZ3xc	1
1380	2vc4D134mUHLrd243MeFdPyXftN3vw8iYBK9Gf9NUHEeWJsA1MiA	1
1384	2vaLZqnsLvouAFo1P7bUBXTYBqXeSUbXTqdbiCCrSx7efggP56ud	1
1388	2vbwiagA75hEoezUWpEkVP6x9oMdggc2CjfmL5akxz1xB2dMPQyW	1
1391	2vak1VhyWUyhZwZEKausLFV4R1SgaAraDfUhjp2Vtw71SMXcPRku	1
1399	2vaqXpUXBzgra5v5GLhygm4K4WBtuRHnYBU9DmMY8TwJKW8QS1H7	1
1400	2vbuRPs79BCcMXtiRfpGwsRyMTgPkc9bnPFqEBptASm7bJ7FiWFD	1
1401	2vc5nYVp2iVAfWJHdDE6cPu3VktcfRXuEWepGtNcgLFThQrNTgNk	1
1404	2vbwz1tfbDvwQAVCaEkXQkiUmhjU3Bb55YVwmgSzvRgGUUhnQ2kk	1
1407	2vb8U5YWJPer8Tp5ok3z4JTwTbwb9dkQrPxo9eF4m1k4SVio1eUQ	1
1412	2vbT5QQhwdCPL3c9giTzPhCV4ifNSbWZ2kVxLdTT9wujhthj7aE3	1
1420	2vaDFPEqqjHsQBvhAd4eexUedjiyErZY7vuUziM1J5B6ZdwZpR6V	1
1421	2vbUA2ecRSP4bQ2WfdmVvdUhhibthcBWfqGBVAqxSxJYZFQDNsDi	1
1424	2vbNgRFYwCq8g1xAw9edZzyrPC8bMy7bfaHh7qSYTvk78TmxLZ4t	1
1427	2vbQaW4qkKqy4uh2rWztWXoYHhTYdyuNzvd71vqva5wDuLUsh95Y	1
1310	2vboYVRKSxi85AtSJM1TWpTxYZL9foBijPffcrXwcPxdxXCiZtMf	1
1313	2vafN8adV4yVoCHoiN6oxiHHsLdTMcxcEtfuv8wtafZGHc9KyXtM	1
1319	2vaS2WvN2YNVeSNCVUmfVra4NL54d1PoGVcCF51hYwdckxnPYB2Q	1
1320	2vbaUBkVHSeeL8JcKfVXUiwvBn8fyCGgTaLagBMavKSvte2kfzWN	1
1322	2vbjW2L1YPKrk87jN2BJSwwR5t9xDW6WFW8Ay5ZgokGn6ArpdcLf	1
1323	2vbMidR2Vs9bN89UxYnEwi73LNgKg7rF8ZxeCZi6SZPuSvwCNPH4	1
1325	2vaZjWqr6k7bB3wJjjqJjbQDpTDMGp5Px8J5AhQVLhDvN4ziSP75	1
1326	2vbsw2mkC9s3VVN849giaDPmSsbCLLW1yPsUypbvDGCxuDwsUM1a	1
1327	2vbWYvjPw7aTkxDyCHRfJdyCHf9vJuqAS4BE1uH7Ch53jjAbnTqq	1
1330	2vbN4F4YjZR8S6Bqwz16qFb16Dj9vskyDHB3LvoBButc9k6FDjnQ	1
1332	2vbUHeb7waVYCgD4w2yTeEixRX4yRyM92B74Q7Yh4NKS7Nf2C6hT	1
1334	2vc56VbRqterJDWiYy2BnJJE5X25TuR6PqVQYeLNZwMuHRq5xdpA	1
1337	2vbPfoDozNWyBhr4pkFs9Z3fJQHEWFGEmrZYDCNSysNVmx5tasGc	1
1342	2vbYYDAE4kDkmeYJdf3edtv3p2mJzbvq1pXPaKqkqy6b4kYfcsNh	1
1345	2vbqV3paystcMyYkPXeaASC3ictbQ5drcAobRjNYPk6ueYjEy22d	1
1348	2vbo2QpA9X5QUPriSCWUw6phHrQMbpyoKk3kiPvUSfj8xokc77Dh	1
1349	2vb5KP8Y3LNFWgjxaXNfPwvfG1CWdixawZKwwwNLNKVUAKC7urHq	1
1352	2vc2aKVi2mk3pD5xr2gsjzpX2gN2YFHtUweUamVvuWkkr5WcPHCP	1
1354	2vbKJguLrjUHpyWT3cH9Xv5MvDnyz9CCdWGbQXBkaQic3aE6o8DD	1
1355	2vam1GnMaKonWQiKPT12Csxxb5dpymJGtEEhbuqnGvetnw5NZx8m	1
1362	2vbNZw3Lvj9y8VZ64yt7KGdnxzURwaZSQtT4f3K345uDpK9r6rxE	1
1365	2vbWESUrKd3cR2w2P8g224oPK6ZSyWfQ6rPbDn3H53deGbhAagbL	1
1368	2vavCynhzGNMzuo5U4jpy7QT3tiD8UDx9p7xDDhcCbB6agZRHAR8	1
1369	2vbGo9RH5auJ1pij9dVXVtwudXQD13knDwjap3ifSw3F5kQpHfiE	1
1372	2vbSZcwoZeYdmRHDiSNTqyTz1XhVmNihre9asuXBPm7aEYKUnphU	1
1375	2vaHLwQdTsGTajeXnEGzcWhGU6FefRmYJKFFc8yZSw2YzUccGR79	1
1378	2vbhNnyndrgLb6JoEgkpHiz4p6qSQRFduNP8Q2SL3u6puDaaXbaC	1
1382	2vbpL9j3a3GaYYaiXiPpzYMLo8xvxwWZ4LETFxUDj7NhcttZvgpT	1
1383	2vbpyoCNxfL41nHDaK3eGWox73jEktt6tMPQkxe3gejssJYQAP1w	1
1385	2vbBw4GR81sgeXcZedHap8Rn6oz9HinjCidGKmoYC7o4gn6uYQMv	1
1387	2vatb97xfNANQFrvAsKvDbJ3Q5noBq99M3ZHVRjMTGsaakJAiGbz	1
1392	2vaUs7uELdBdgqAzfmX8B2xMFKxBSCe84tgtLbNY547p9tzF1neE	1
1393	2vbiQcsDwbPUqfFTe1HgZP9Bmq2v5aLsrazye5zEmK6te1nX19EW	1
1395	2vbogZymgvexigfouuUchBBfcjexVpXxckCqwXpzQRBoXaadNjKN	1
1397	2vbHAuPE7n7PU6DSFLjmwzxD6mQSRmwkoPujSxzsiiHbn6w9dbw7	1
1403	2vbpxgCQdff2Qfx52MH7Tb3dmMq6N4Q1fvTtZEoTqc8gkyKm21t6	1
1406	2vbJRgAJUqqrEkeyNeydSj7eaAZd91bTLhAwzhHqudd1c4jFFCWs	1
1408	2vaXfnBuTfSi44QTXWmikJiiK5sWqaATV5Gm573xEBvq6pJrGQ9U	1
1409	2vbgCdfzrQTy29afG75WdSM2Bqkw4JMA3D5tycYVaUFWotFDAtyQ	1
1411	2vbQX2nNMBnLTStYms7tX3FcBeWkKmWEutY95iA3FuhEfPdfm1Qh	1
1413	2vag69NAqP2G6KVi22tbdMzende4Cidvm6GEaURx3D2rPNAvLFsy	1
1414	2vai543XxJFLqQyiVUMqP5E66L3ZNbywQc8wWF8u2Qh27pi32kek	1
1417	2vbFzds7faALLvy1Sjz5LfuxCgyDZGCbr9kCC2cvYNFDjfVoRmvM	1
1422	2vbTxEay5XTig3VkA6Dap3ZVG6SQVCg116oE42L5eLU9Jsp4iJvh	1
1426	2vaRVciKLWUwBqLZoRkehZtWYo5mb2vqcqtcmeKBBMoKmkjkFiGX	1
1428	2vbvheGUojwFNQSE4suAap4hiddFLoxug3EnHfuC73Lk4ufsmatQ	1
1429	2vaHVQwShPTr4zPkw7eSjrhkQFr41tgYyE1jbioJCVhWSwThdKcE	1
1430	2varYtqGeuXB6Gw5qxERgSjgdGbrz4cKYbeQGasd4NYJMEsQYX6j	1
1431	2vaS56YPGi73ZgCmaJ5UCYmLKL6cEYqPmM2QZgTU2sFBt2dEwMH5	1
1432	2vaApwn3G8eJQWsxVTYPWU8vkbiXxvRn91YL1TCtNsB8YeGpJVFJ	1
1433	2vbRMffy6bh98hqAYzNYsJbofMcEsFP3CzVP6kzQXJ6WiTCgXgG4	1
1434	2vab9ExUmxHGWoGiVowk6oLj1beea3hVwHJHV9NWMnEGtZy1Xmfj	1
1435	2vbjUKqxfYRRDsAkJzTgv62QtHnR3UZ39UF1VH3kJTZh6kibbMxi	1
1436	2vaVVkKtp6ieXctGbWvKHUPfdY8Xszv3hCE7tngjbH7yMSKTawDy	1
1437	2vaNhD5AMAfmPLqjSspWdfKbUfrP2zXA7aeCAzf5Pe4kkcDeXnqg	1
1438	2vaoYNufQE6a3RncG8SopGqN1jDf27Z62Ze5n1b9ZjwFF3nMjccz	1
1439	2vbDxN6XoN2UUhgwbBMwfL5SfrVMzaNhAedFJD63WqFyVpN5qcMv	1
1440	2vbTPEwza9ZiZqdsrqoJiM4cmBKA5tsvqn5akZvcJqF34PSqHxgj	1
1441	2vbEFN8gN41UjhcnqrBV2kM9F6Na1shcXVzgcVoBvs12mKWtsTtx	1
1442	2vaZZbYen3Rgmvvr3cvj9ULA86ujAy72H1XppBXV8ePZUQXpcCDM	1
1443	2vbFiiSHN4H15385wL6Z6mQ73skjoLaVxDva7dwRdk6vCsQqkgvp	1
1444	2vbD3x2LwZTvh89GQeEuowzWU4n9jCAAququj6M1JpjDAMQn5jy3	1
1445	2vaQPzLphXQzy3m4jhn9ecjEoFn4HwXfgYQBkh8jvcJVQfJ6EkqY	1
1446	2vaf7p1gqBBQHZ1tqn8GEnk3STdWExEj3LmxVLEYYF2ExK7Hnb4F	1
1447	2vaik9WaWJgZezxF6aSNWGvG19qprVaBjn7hZgzErDo5zNH51DLN	1
1448	2vbjyYAYu84uberrYS69tDT9EwWJ5p6bJ5PK9iZgUnZBvxRMk5Nw	1
1449	2vbR1MPNCbSo3buwtx7deQCRtp8eHXkyT1Aj492m6eZ398JF3XCH	1
1450	2vc1b1iLcd8rodUZD28Fw81q6YzQDn4EvZdUhop4V5bA51JbEoPx	1
1451	2vbYoN2wuy79pALizqmTXKS7NfLQA8HQ32N6uanGci3Yaz8XF7VB	1
1452	2vaZR24ASMBn64E6oZ5FjXJtbw6qFj21SvgF9rmKkwMR2qU7Wp4S	1
1453	2vaRm5kXGKaZ9MN8WctmGRsMKzrhGJAfDYCCG7rx91wE3ZNw1fJj	1
1454	2vaTrvLpVdE23WzPgAY1FbFmbfFAntufyyR4PgZgse2TqX8XQ9hF	1
1455	2vbAcJtNdcGFvS3BjFVrJrvzrxpsGwoBN6mkQPKsLFRwKJ4BLR62	1
1456	2vaJcuYerfJVKndhuCgYCGvfpeC9wFiRzSJbGeut3aCxPfo4tB7Q	1
1457	2vbSfaSXHqEsX89z4gEAJMTumkbMdMu62m9adX7cCqQL7gCsk71J	1
1458	2vaAdJm2exRgLaSwTmCkDhyzKW34gEA3MnE1fnozaz7z7F689Zfi	1
1459	2vbiL8AeDmQj82SDJoDjndy5fmSHxL5FzFXMoCSvHaNuCPCtzxSv	1
1460	2vbLByTTd8FZKW7z9ydCEvzaW4ShT6i5vj9hwcZfrpsea8o9onDV	1
1461	2vbfSTnDhgisWx2pkFT16yK16mdxcQLTL2n26mVEgLmvgQ3rpKSH	1
1462	2vbP4WUF9UT6ovFx5rvixWzBn4wLQnt8sbHoPNWkiFhJy9yiaV8P	1
1463	2vahMkcQGFiJg6C7ozmLs1hiwkVp9aYR8WhGwexByPy1Qs7uFifY	1
1464	2vc48uFmhUqgwcSuP54HR3MXxcayq62yTLSskLVCZCCmuSNfahKi	1
1465	2vbaoAAX1PGHToUa8CrWCfDSJyAdTBiuVmbT41bnZqPFpvHRLu1e	1
1466	2vaUqzzS7LBca9HDZdYHGVUrVf3uB75sPhqC9Qn9jTy2zyFRJgE7	1
1467	2vaHxvK4KtVZQcdJAAME3LAA3c5m2rttZTyVwCe7HghdGKKgvhXJ	1
1468	2vaC3g3jJaLGc86BvnNG59DtDvNYmd7sVcStC6d4kbLBoTdrGr1G	1
1469	2vawv2M8oxo43c7xqiavXnLKUj7ceWZJm8QLCfTgiM9CEVoU47L2	1
1470	2vacgeGBiHQw1decpmCj9xEu4o684a5RwoSPdTHGdVLGNriK6tPv	1
1471	2vaYKYPMTHykDkrhJTEGrpckhfMfZno5W4GEKYoD3ubwUowScQSs	1
1474	2vc3G2qevozoiyFHQ34mSYxr4o9UBvfaubgaygjcr2ARSDYEEVAA	1
1480	2vaebzjeWqJZ2CTuP6bfn8DxXBGzQ1Q35ejek6FjVs1Bfy78tx5y	1
1483	2vaVS4SNeqMgHxSVDBB5deirDAGKSDcyctbWahDfYmNzMTh8bt2d	1
1486	2vbbGWe2UtEVCftzLtonuG5TKGRsYoLfkvpWUkfVHtYG17PVhyFc	1
1488	2vaEWfbViRz5gkx2wekQ8xUouu7DbX3uU43dL7BSu3EnyFfVyy8z	1
1491	2vbgxYTNAkvJ6aFNkr3aPCyby8EPV6rfA3rmB53TqQmZGxiD1xqF	1
1492	2vavBhFtrRiU645CF1evhTjskbJyjqNteEx7GRnPKLRQ2o7inMJL	1
1494	2vbx4Rxu8siPVNJc8gigGQ67PnEQv54fbn57JkhceR4ckyb1XspF	1
1495	2vbW6TEXxeWbo2pbj9N8jL8wb4ep3Wri3jUCs73n34zRiCub8VRC	1
1496	2vbjxDpxGtnnR65n2Z5QHLkgT6rbJKZYskQsxVsfxDYASfPSYrvE	1
1499	2vaCgBbK5zbPD3DR9ZszSNDgrtdg8LZtLAq9ggXcadrrAWeJHxqX	1
1506	2vbkycp9fZeDRrf2CGZ8Lu7Dk14YXTSMtzNj3JSNi96QNWYMjXnE	1
1512	2vbU4Xx9hmhGbPvwR1jm324shaM6BeDRe5WUCbACRnKzgEPZePFC	1
1515	2vbkj1hnDqXeBMkzactesNDsGfkZngtD6eJ3fk4Tu1cEVthd4D6z	1
1517	2vbQPiGddJx73ehTDw1GC4Snp8sFDy2y6ipMtYjRrtmMNooNf41d	1
1519	2vato8V1M3oTg1j1ohhwfCum5QuKAREtd9o1PfM9fwSt2bDSsmvN	1
1523	2vbyd9RkCLg5QnWMK9uE5cEvPDi9HumMkqA9BHRF1QzAF93amyi8	1
1526	2vbk4rr8wrYsozX6PybYnaXTaTg4VQX5d3ttgrbKPXB3WravJXR9	1
1530	2vbUu7bAAYyCh4uRJGuxrNFpJLvzHTpRiZwRWtPELJRoBqbwHMEu	1
1531	2vbAi3gYwTDoXHohp3rqaG4GME8rMmgFjdPRjMnoBFknoy3p1fvL	1
1532	2vapbptf2gdjZKSLEYd3zkeUrzpQ83936mzd7tge9hpHZVFaUMNx	1
1535	2vagx5i8ZcG4xU7WyvMaK9xtsnattzcA8DX8iLDYUzyYHt65vv1x	1
1539	2vbNk9bCUYD73zv8GQEMd3UEqRYJc3sKN5bP5YZMdr6KizMA3UAs	1
1540	2vaaDckk4WXg6wg1HCYj6WBxh5SbeEZwpy6EXjB3HGSCyrgr13z8	1
1546	2va9R3vmM8hAtV1CBLwuCWsv5YVx1oXx7XcVsYhnv22ieUDs18x8	1
1549	2vbPq2fs2We3hT5LWnXP2h9J3EUTKSSq14yariMYPNJt7nSzcX6t	1
1552	2vbYk1JXCyCekdK5GHN3yfEBmcFfLqhLqDSsr96Bvhi1teQ6PurY	1
1560	2vbMhwzsZgVr8azY6hc9D8cmpWQM3SSzAnpBksyJ2xiZEuomnRJG	1
1562	2vaYN5JyqUCU2wh172bEFb8DA12ccZrd2G2r9t1H1c5NX6ZcZTza	1
1566	2vbdxJX9juZR8QwYmit8cEkZJdWKJDdedHT1fshF2sPPfxx8jebd	1
1567	2vbRAG2ExJ1NsZs6WDLCBhcN9GBe2EZbz2dYwvxbLPAurEBMnFiF	1
1576	2vbKKJ4iEAFLhAUwUe5EkTxrHkfePyV1hRL37aXNHTb5eJ3v2tn2	1
1580	2vaJ8iT1uwVoDjdgtuEpwJnufiWZJMqXF59Twr3LuXLZXiEc12QB	1
1582	2vbFWWBeYeUnseLf5igw1d1MLecm97XLi8kNzrNpWmTedVzNaxYo	1
1586	2vadGoEHrajLvEFVdJ53hNjk5ynBdD6kJVzuNjbxrT8CoWiRytXS	1
1593	2vbJhR1LvP9cgpn9MVuV7MgzY7X7r4YP4a5S8fF4J23bKAcvjX4k	1
1595	2vb12DvHcakHAt8coamGwDPJ9d5zRXWoS5CEs5XadFmqJcsf93rt	1
1596	2vbarpqPsKu6XXSnyNizbZLuJNNFWnrk8rKWpQoWynDFnUP7NXDF	1
1599	2vahpNc4UwEERJiy3AFZTcbRGs9Khzry91BeNpt8ymxpL2LUPShZ	1
1609	2vaZMM8ZqNCmw9Xr2hEu54Sk83UdRheGN5uac6pc4DLcmkVyN5yw	1
1612	2vbZfM7Mm3Ks9JCeXv3KyNrZJusTtidQQkNFUBDvv5ZubPmFFu5S	1
1617	2vbo1iJHYfVPHLPT7nF7jEs3m5xFRtzLL9nHuBqeZN6zQk1jCHHc	1
1620	2vbzUppqvhFW3KTCDZs9cnEPmmz5rWQTdGoEpah4dbokLfD7NNEX	1
1621	2vav5NAPRPeDdAyrY9yuDDixNeS27iqF1Xsqr1H2iRcvC9KL44nm	1
1623	2vaUM3xRXEbm2T2xyzR7buY2JbpNxAtUUn6HBjJY2fhMC6eVyrdb	1
1472	2vaMhfi7c2oHD3LmSZPyHZRfo1ch1J88F3zJiJxGD8PfFUzcvw34	1
1475	2vb7BUGEAi6brbeXyQ3PMwS6coFnzR8rpq55gPeXrAYLVR4mptGE	1
1476	2vbY89AmUBzjMsW8L1GpZ4grxPQdKQHPrM1Zud68ZHxEfLVYGNrY	1
1478	2vbrjrkKNU2jG1RGxzJR8KvcfrUeuoarQbuR2dkX4crmwG7xs83h	1
1479	2vaq8jeKy92G8DLjkVAjxnG2Q5bExzw2b39VziA7foMFaBNihZ6V	1
1484	2vc59SrBZK77j6AjK6uq5ehaK1Ysc2qBeU1gjuDaCUXXeN5P3T9p	1
1490	2vaw3sng9EZ7TK6SZt7V2GaENsrDPMkRcjfCBHgSSxta1apuKYpY	1
1493	2vaj6reAq8ASvp5CBkkqWwZzdbYK9y9pwccaeRh2KMTuHSX6STQ2	1
1498	2vboCHpt8Sf6KmRPAicLDDDwQgHEp3mbbipwHrEm87PWXmAvwtod	1
1500	2vamcCBmrqX59ekGWp9FAPE1Hbbe9DYJgjj1VH9FLdDhEatj8rAp	1
1501	2vbJhnR5Kyvg7VWQyaTUrzATUc18vMTMthjdF8sPpfaVNFv7ogMW	1
1503	2vaAZYkyCYFBLsNt8GUux954sDc6Gphvi686WFFB8mcUkKyYji6e	1
1504	2vbcQN8exwqwWcE6MwDbfRWA3DnMBQsvCZP3q3AqqhMvn7jfknLc	1
1505	2vbFs7JipCXgyunbYPa3CLZu9PA2Fkn5z5wWi4wnm9KvAHyrzQ4y	1
1508	2vaGqaRMBEjRYF7x4CuPnd4braHvHa6bRbk1vKJrP1h48F1aR21S	1
1511	2vb7g6eLaEXHZ8UzUmtoMRvPuDMLeyM3mBSrPVb2jooHsqcfBg6c	1
1513	2vbvhzYbdp2sZGchYfNSZBEEaQBivAFa5JwGkneWuv7oQe18dsfd	1
1514	2vbc2ZWKSwTkuQJcTLH78QQA3rt7JY3qAPC52ii4BHnamjAMuk83	1
1520	2vc3Dm5XPipKvrXLaDrnsfcwrUURSLJtHQrXj53PG37m8wtbE1sa	1
1522	2vbT2BCmHrnWbs7SYZfFH6BPTcENYxKXxDrCnFfGszjgpMGBpLPr	1
1525	2vbEebQ2fd2biJsvkx1azjrJRM3QVpdBb99mBGTrVQSNcVEZqCZh	1
1527	2vbX8rnupYeDkHWjoP4UQo3DsRw1cNFuKgU6GDjUwMPmWTzojXw9	1
1529	2vacq8eyvTx2SUhs6XJkA5W9qKgtGzpRwzXNera749R7wMN98tn4	1
1536	2vaz5X245XXu75HehQn1baqHEX6GFtStByNMPTCuYCFjGpdFXbLT	1
1541	2vaYnwJy88xX6oHFNCvpZLso6vHYYYgd9AhJvX3aE5PEQvj3UKjq	1
1542	2vamdStiQUWobuprq4QF8t7kL5RD4SNHmYUQYKfm6xCkX9b7SSin	1
1545	2vb5SnS2CH6mf9SQz7936AQp3koWTTQsC7xAA8L8rSU9UxRY8v7o	1
1548	2vbeQXhDFbj4evVNiRs2WT5f2GGr5n4r8wwXL7bxeZzGKAmyYHka	1
1551	2vajT1FnrwsaLSU9t1nPW82hkH8D1NcbrzXCxiMZCHan8YXoM3YY	1
1553	2vbWVRF9nE1BNb9YunPWSww7nWzVg6jWfmnjB3H3WsB1Sa9VH4ry	1
1554	2vbVoJrnysPc1Ko1gXbwfpR3FJvgtQJx6DAY2UMSTKU2BDVJ2GFh	1
1557	2vaXDL6kyerm2JDZRnXRhEtKtEu9hiFddZqWPcMse7Qvw7PL3Cd3	1
1563	2vamCLWGkDqhd6V66Es6G8QXiuLMWU2ryQcpQdurjS3xJ8bhnpTd	1
1569	2vaGs92xHfLFy9K5VwuXgQNt21n1i51TM9jPFgU4h6RLFsxAnGYa	1
1571	2vbzgFMw8yEG4G6UArNVwms4ufamz7Vt4dPiqCaEfErX1gSJ9GSc	1
1573	2vanBuYmUWvDRhZgQCoxUdWxrqbxp9Uk9rzKT7JCe6N5kztLcXp3	1
1578	2vbLx3yhBG4wuFVyWsobwUJSXKE2PdKxiVextXYJdmkdUUaPRAUi	1
1581	2vaBWeN46FnVpjXTgkA3fVpqimt6aPgtRqYAGmVvDL8c2eXFN9Bz	1
1583	2vaL1tGYWCsN4VkQJmvjPEE4vD8UsqrAfbsF9ikYqZP1nh6skDFu	1
1584	2vaMW2hf1a7BJueq9vmNQtTjADJMtmQAWKQMX7dbyi9zp9h1Nqmn	1
1587	2vaTXKdz4kBKCmmDLVii6Pc8LdbPborhFjj1T2vXWfDh7SBuEGvN	1
1588	2vaLQfp3tUZHRo5ssZwUek3xgXt6Wd4FTiCqNk5WjRPs36Fgdhww	1
1591	2vaACsGyspRMAhbWxmMB8GnJVQLhbvhdrjY6hZLppLHw11TpShDW	1
1594	2vbsriEKNp9KKpMKmv51NWrpAx6aGQRQHUdcgv8n4GzT5cAsWGAB	1
1597	2vawG2eXKm5rnoE9pbamGZn6sGoXjYt9fpd1PyyNoNa4mXWJKs1P	1
1602	2vahzRLyATHk21bkg8Un6JUSDkFsTUUFSFhwgwv5prapNeK86hQW	1
1603	2vaKhCuiezwtmcsgEXrHH9KMRU1YAPz8TwQje1CRureUWLvMwQEj	1
1605	2vbFdom5mhFwEbgusCjgtGyUCTidvfypRSkQCQWMcbfe9SikMe7R	1
1606	2vaZV9iSz864FXYc9ymc6pXCY6tucV9JPBanmUzd5vi765Svw2km	1
1608	2vbckvm3jwRpYFpELY25X81Fkrkf6Eax4A8Kp2f28b6EEUUnrY22	1
1613	2vb57oyHVzJM7vF8fdoMccyRuCLjAnbeya56GqyEscWLMLSwQ2L2	1
1616	2vabFZGfzRokVbYMmwPDy4pFVge67VJS7TTJdB8w37T3CZWLgE4B	1
1618	2vbiPSuJG872ZDta47y5wuPaDy6TNbVRYrwJ4tBcnRyMHTfTcq2y	1
1473	2vbWSqVNPcyzJzXMYWTXgCh5muuEsrU1nu77zhgPGDWfNmiiRgAc	1
1477	2vbz1h3kw4FJmHntiD63bNaEUkrQVUJmY3iLXeuQoSra73YQrSiE	1
1481	2vb9s3uPQiEaxvYNrG8qksMjNxC2XbEFmdjPNsHyZ6aPRRckYwXd	1
1482	2vaAxXdj3Sw5Ait4ez2Hr2VEiYL5EFP6fQVJCHq41xT28yEopwVB	1
1485	2vaDBUpNAxA5pNG9SW2oWjv3RXRvu81yzMz7B1uQysCjUwfKbfeh	1
1487	2vamc44uzxNL2Kaf5s7v99JtNS7zDL6AUamUP5HZEp5sHx4SiubJ	1
1489	2vb1hHsAjoWdmasUc3jXZLpQ2k1H6muUNFN4wpwSviub42Tb1uud	1
1497	2vaqLHLpoLHK7MV2jbwZCn4bFkK9ErxihBH24CEXVpo9psGyMNdu	1
1502	2vbihW6msdJxwvLwpgqgufAe2Q7n2JgTn4H2bse6wduXvJG4C2Hx	1
1507	2vaocQrvyw3qpfEAa995zggJchXe7jHaf91qWkUEqzABCXjdxfBN	1
1509	2vagGGevUdgHrjBaLuTFLq2cm5xcYStBBjUmZ8bMdyhcNNDkJW6p	1
1510	2vaAR5GcfqejN1veD28BLiVWmUDkVzFGzEQ3GB27dHkeMRR1yAXc	1
1516	2vbSgUvJhbxZapxmi2xU1AVbYmti6crYnNhsz8ofg8DNmFrjGfwN	1
1518	2vbiXcFqkuX3zJwMGr7VGBoZMZmenHxi3mCfWtxNDyGEwbuN518m	1
1521	2vaz6G8PG79zjqNVeHXjneYnEh8YDZhpYe8YKkbdrmK5W2HrL4Mx	1
1524	2vbKNoaM3gDijkfL8J88UJ8jLKQbQTGSnSNKNLZbRysbAf9zyiTL	1
1528	2vbMMG1TSPVu5vC7xF5JttEntnRwUow9F2QDe47fEH59j7mqfPWt	1
1533	2vbF1rPrzTdzJ7QzZMK6juMwvRBs9o9bCtu7iAbFUuATWi66estm	1
1534	2vbFNhpqjzRiif3eSMFPmq3rz4FCG11tVCZAKbjdBqzEGS4bMFyQ	1
1537	2vbRHkuLZyGQzYSqJSoDovJipREeBGpmcFSMi891nj4qC6t7fFJW	1
1538	2vbDJCoxzYKsFfNeEP8B9maEsXZa7TMDoZ2fByT37zsVqbr7ubYY	1
1543	2vbkT4V4Urxg2zGhGT4Hy1vCbAmTiTGpxhWa8vAb4esd3cdyLZBq	1
1544	2vaUNfQtZ7i8h2RY93LD7DXarZ2muGUWvSTA4cpm7HXscveNxGqq	1
1547	2vbTjnNBHiBLZA7y3ojuPTahL3ZA8eMCbmw5GyyRc3x2kTGYAEH6	1
1550	2vbxSjXvQiDfrfmx3rg4e3bGRaiypKqCKr1BGtxQ6YWtTBHEfkEY	1
1555	2vbtv88gQ2SWLFFkPiZeKv7c4TiaGkzD7u35QdohhWzjHfjW7YEm	1
1556	2vaf8tzdNZFvxbzkm7qjHKCFWo9VGUvNL6hz8hzRApwBRfJHaw8X	1
1558	2vaiYJjHTTDtLirKcDSzk26rDY5AhgiTLwfEeJkqEoSDEY3Pspr9	1
1559	2vb3d7hAH3gkbwVELmzuYFF1FckomqB5G3wchuNLb7eYzm7pSkib	1
1561	2vbz9r93vnt9fPAFvi9KMRycVrf3pj3fUSWukXo3H6n8qqeH8NgD	1
1564	2vakQV2eA65uo1GKoSaWG4SY1iQnc3kysWbHc6P8r1p8w1QUvYF2	1
1565	2vbrGdnNUnLhVigwoqWZE92WsVjs9dVZix1NcVd6Kq9CF2chFddU	1
1568	2vbUiXS2tyZmpmSBqW5b6VfRWPsDBYhByWS1SZC2sEsRY5VbBre9	1
1570	2vc1t1wkHKVQUZq94spG6j9kDwpe7JApCgCUg82MQhxpgkKcHTCU	1
1572	2vad6opHuitQEJuPUpNLyUYMx3RsBtQHNAdUs6AeNtrdJE8Gqm37	1
1574	2vbzmFyMK56R9GUvNP6Q2KMWnnq92TVo2WssUDNzteZMzRuSacVA	1
1575	2vas6266DsascuxZGionwNm47CEhpk2L4jBXDgkRnTPQE9HzLVr8	1
1577	2vb3hL1RbzQdq22x5EP5FfRxGQa9vZNr7zUJoz2VeNYfj7nJxi1M	1
1579	2vc3owdPvjg7jwEF4RP1ZrHg6LoRSMCAJQc5fbQVJ1L8BEGRrBuN	1
1585	2vbUdtDGeTfnxZopStwzcEbeVXPAcppNpNK7Rz9RFjPmq3XLWvhg	1
1589	2vaumdA58tLfTXFp8EFjDh8XqWDmkoZVaBKeYzu3LtW4MaT7obvb	1
1590	2vaR3USwWie7GQrCABRe4VQeTS5FjqsTYvFQJvRUvFBB6Qqnhg4e	1
1592	2vamhACjn4taLRCHHjTq4R1pY8yxvE7dDu7S4p9JVdpbWuMaBYoc	1
1598	2vbBZkfFgXdnp1q1Q8ctRMc52a5nvkbqJ4RMwXKo42yGH1g6H9EJ	1
1600	2vbDUyJyPQ5HidD2BasCcdUCRK2YWjxNUoM4QFeM2kVm88DCno4T	1
1601	2vaP5QzKdnKKcuRData1QJAVHPdpgzu7ubfqPWrAvYhBzKYDmzVx	1
1604	2vbwtbW1AuKDWh3JjPzKtvXVAomhoRHEwd7SpzHTUCxBYDRexsnL	1
1607	2vbt2qorJhW7jDkwSKs5EVwF6BEubbXyKPNprKVY6FMm3UU7i1WS	1
1610	2vbnASdhCame6N5NDUDVLcCS7foBWh6egntnnfoXgDLyKEScMCSo	1
1611	2var81URQ1gshKbn3agg9TjTbL4NqcuYPBpKLasmM87Lczr4NRxS	1
1614	2vbqAGCnFs83Wu5TDjafKATzR23hZqc9ezAsikHJ92THrP5nuaig	1
1615	2vanSguZRG5fCeovAFMCTJtz6sV2yok5CUJ65mWQbVu9nsA8HyiR	1
1619	2vak8AuHxjNUH4xVdjkGfis1EWePT5bgamVruBHsW7B8LRDnK33C	1
1622	2vbT4RgyfHTt9NupEd4avpppLpkawcJuraw6VQhvAp3q9ABYt2TT	1
1624	2vayuBZ7r4MkjfQgoa1ANa9eZbCJLFaKEVQ8CEz2muSzpbXZem8S	1
1625	2vb1jxt6fKrqd2q6qSxrGNjEs87yF1hY16njsRRKcYBrH7Ks6Uww	1
1626	2vbLHefdJAFX7ThSMhS7AKFkt8eS6ucJWaSCPrQGyUNrrse18nQQ	1
1627	2vbCATHDEaJzdccL635hdo3mJwnF1WemVypD9SeRB5cLJUcHfnPs	1
1628	2vativvV3A8jiDnyivkiw1kTCH3Pn7XDnR9trTV1gmsehJncaH9c	1
1629	2vaQAVfCwnanSKaQTHH7LMcS96qJapvqYaPHddVjUYw8NB1dysKk	1
1630	2vbHBLfzoAvkQ7tYfxsaijq5t8AUT1d4Sieb54QvqgyWnVUFfTER	1
1631	2vaDg9Uu69EifW1hQFwHT1UtnjA9hCgdJ6aBBTuuSSF4WJbLeRUL	1
1632	2vanU6jmjNnuLRWgUySvFRNfeazmrooJx1pHgHGmHdq37f8HsZNJ	1
1633	2vbPKVHE5DPzN8wVCUhGWuvXy7FzgjaKmZZ4ZhfkTx3AjxYXhUqn	1
1634	2vbpYDtqcV6u18fZaSgpPKUdWhkJD42j6YKm9L1EpwiohhUSKGdi	1
1635	2vaXbtUpLsBAuvkNKD2CTrx3kfD9goFAJGuxdLdEoKT8fKb2HZya	1
1636	2vbmaMreqKLwVSo8zDufqhndYfrrTrtDS64FgW6zSjRMrCTHwytg	1
1637	2vbbFwaqf3jBRfzgiHV6ECn7t4Dh6YeG5cmkK6La34Vt7XMsoK3g	1
1638	2vbtoDTdUW4uJ7LK833SgKuvpn5ThzqV9YpWaGx5mqhh3jCkvwU2	1
1639	2vbn2nmvhsE2n6xVVmbvUve244hB67ZR29gcpXWtYQhChuKk9W9t	1
1640	2vaNb8ZGGG953Fyd3FbRw1ySLbwF1GZy1k5BT8Yb2fuBURzcpKQX	1
1641	2vbXLRmoJvgqmBjprJBaKqDnuKmifwJB58xh4w7wjSRK1npAzJjv	1
1642	2vaYySgBdAKGxCfZ8mTkjsnUTkcti6VYBz9VfyXKgVRmFUqMDV43	1
1643	2vbtgQTxzoAo1Mso3H6K5prvTb6DNBTFpnVF9nA8XM8XzxrV3dXn	1
1644	2vbEVGGaVxTaTyBgmdThHw2DkPhNBKXMjDiHgTjLfcCifQAtVXFH	1
1645	2vaDbJu8yVzLAWSHv5fKEY8UKd69hSEtZ793KZ1dMe78mXvJXS7s	1
1646	2vaVGZWqGB4AJ2AaSvaZ9MHWBS8KzF1f7ExuH4Eryc4bv2V89SM8	1
1647	2vb33YiSoAzPN3UBUTb9U16DPcV5pW6vF6Lp32toWAv3a5orem6o	1
1648	2vbraNMHfvfmLhFWwaxSwaxPYPzaaR3nCh8s7y2F5uxWEd8bLqRL	1
1649	2vbFYPFJHZ76RDbWHojHu361N4ZzwgitBPVrhk8pPMQk3X6AwiGR	1
1650	2vbpSB1VE14eAzXxCRGWFyiAAJshYRjsSuWjRTrjQyUED3xvDWZA	1
1651	2vaBbtfE1NkLN4stXohLsb2M6mUWqfnBBEijFXVPppFiGSeAgvff	1
1652	2vbn4sD5E5GtVDZz2VX9v9Ycod6KCViLWBa9Hpgp8VqL61bQaxnt	1
1653	2vb9cV3XDu6MLF4y9uzjJDb6v9qsTJRCYTs6na3vZUFGDh8vm5KR	1
1654	2vaWR6xAJdtyrDfjQqjcxhk8UUZA2wMCY8a1Bv17MmcDCvtq9PKa	1
1655	2vaosgPeyWTh8VJ7CXd3KptNzSkQxvZKzpzQWMPy2aqeW5tJ7xTq	1
1656	2vawFn4fAY3vSihquPaERfPKJKUWYbX1VkYxAN1TpAYgf8zXixBo	1
1657	2vbK8afdGT5iVGMHpEGbGuLZNA2JfjfYZhX4S3QBtAE75PaRBT7E	1
1658	2vbBTMe1jc9uSapF7qVPFFThc38sVKQ5tdq4u94k2FPnfysCUNBg	1
1659	2vaW1mqZqLFvBdUyPUM2mkQNFcX8xFDariapWKFgHbW17mtwKy6A	1
1662	2vc2yj8ztYk1v6LH1ss1TZpsjC6SQhJGiDBX7pUbgMPe3RZbfo9m	1
1665	2vavcAzRgNi8x7smMxg9m6mDCV4cw4w6k19pX6sKbCecxYGtcNYf	1
1670	2vaPS959PhuYwBL2EuZDmWniuM85JZVU7Kxkg8aSwp13QuzZZkwR	1
1673	2vbBZdtuqyoj2Xm39EwAcfcjEm7PsCnep4qQVEFKEJMtu3RUW8VZ	1
1674	2vaCZwVXjqsADdQ1GmCEXtrJUNpdZhakJFegSbwd2bSfGifNJ72V	1
1677	2vbQFywyNQCgnW52fa8QpaQgz8Bi3Ht81kHb4pRzm4PinG6Qy33D	1
1682	2vbfdCN115TadmvAgMdPT68jS4TZe867cC7kFFKeJCuSbR8AjRSZ	1
1686	2vbGKdSus44VUzeviiQw8sWiFGBxqtTj8AUWKBNTytJkR7iUB6Sa	1
1689	2vbksxwG6ZkEEnDjaCE64FSeK6oLWzT4oXMRdiwB3HvsEHtCFrHR	1
1693	2vapbVWq3XHLgES95jnC8huMCbwcEYwYtj7mm3fNtJ2qGaQziQXT	1
1694	2vbJhGc1L9LsjiNzQPL1unx5n9rsvUABXoEJpbjaATMqz1nnZtoK	1
1695	2vbQEyBmUHghoX5ViYyTc5SLMhyvYZ3Dx7eopseZSTyKpC1o4hcm	1
1701	2vbxVFDSTZNWAAZLqMNK1sFfJm7DuG553Pqum2BJ1Pqp9Z1MEo7s	1
1704	2vbwh4f99T9iUSUM1KoNCiw1JTgu6Tiitk5gpEKjwnH4S9AeM1ks	1
1709	2vbGG8fe2MBPR58jMEvkLUhkvXfG4RSRUAS2PCbvEBwbXk2tM2NP	1
1710	2vaQ2QkGPwfv26R4g7Ww2vcZfNMPApGJ6nQm7w5qc29SrHZnSPYV	1
1714	2vbp6ytLrvSPV4mVB1d8JoKtvN38c4Zg4x9yYsrqzHVxBYhDQbhZ	1
1715	2vaqv4mivLQRAi7qNDotbLWgR1Mu28sh7gt3LP162GkoiHqzRtoe	1
1720	2vbVWD9tEWGmEuEmVLxSLghC5nuyGhrkgGsS6pHwWqdsap5j5Du7	1
1722	2vamN8jdWf8P1iyDfCWpT6gAYCUnNYGJq6ruhjJRm3zKyDyMXBot	1
1724	2vb6cFWuD5Q1b5KA6pq3cxBSznaVZtMf5frMFrbXo7zUvrxo1YPX	1
1729	2vbbVFq7ZxKsqfBxfCyhMU8JNSpLd3a4wkVSKhM7pFNXFwRk17R3	1
1730	2vbfhFFavVigA4Ze2QzS6eZWNLdGWRFzPUftSk75HT8uRTfAr5nz	1
1733	2vbpF4C69wS7zUcqzFvTxaWXfbRtYsixb26o8mvq1XBEbvvS7jAv	1
1736	2vbm2qpwn2QU8jM1LgjLNxTEGcsKigodwzBbVmthQpPDDDEfKFzN	1
1739	2vafRePiMeJsYsMTrgrZfKnhDi3NqanJA6AoacHLiphRtBUqHry2	1
1741	2vaHY4doqYXXvmMiw3iNQG3KuPg5TYMmKsu6ycwYqbKRZENjUh8Z	1
1742	2vad1Wad8cCGSTGWwtxfisC3vziNYrxHXK1Sivk8jBUVSCQcU6Ea	1
1745	2vajWHZytRZBUEF1c52me4VudfebuTfQJ8pmiCfdsi5p8wBdBtW1	1
1747	2vb91tHN4ZvuYvpTnfpPgJqchYuLa3PdSefcLuLSnD8hcmi3Dpvh	1
1752	2vb9Zr5jQruLcZ5yeeYBgtJk8iFEfKmkW4baRHvxABVSjqKPGnzz	1
1754	2vbH6hvX27THmnew5mjHYfnz9xmffGD6i7pHe6ZiRhEmFpTnsWE3	1
1757	2vaDgfpSFMr1nkDoYq9eEM22mSpcZoWLgjoEXKeWz4eWCGTgda9N	1
1760	2vb9RYuup7BFdoGUW9DyYoWMyk7xBDRaR8PqsdKr6YhUde3fpNtd	1
1762	2vbfaV8QW2Wv8UvJSUQ23kFJAEqDmvemjFK7MSj9hi2yDrbnXxvi	1
1763	2vb3MJ6yzug1rVqdY1e1RSZuc92SpxxdFehWuhEwmMr2YjJHouWm	1
1766	2vaWj6Sa3gYFPtkfcT9Ya1B3ADooFT9EjkD7RFpiA31LRHnu8SrB	1
1768	2vaxsxfxQUskzBmD9e4drerVUToq1VVkLHeCvTKbYnyJx5fSryxJ	1
1774	2vbrMDEzUjCetwsswbLux1VcQqR1r8dronV8RV1cXsaEH2A43zpN	1
1778	2vbdLP1J4Q9iGzDcHCafws72NjxxR42tnSSrvYZtzzXj3wWEtF7j	1
1782	2vaQMmTTR5QzBmPEAo86fGicvN3vJyLfTWe2FjecMv4ZuM7VJBaJ	1
1783	2vaSMLX2V7Dx7hsaXWNEZfaLCZH9MewWhGpVDnT64ECHXXfBC3kD	1
1787	2vaS4bMtd8q9S7ZXnxbjrmXpkqkiqbu4kzAvt4FD6hpwZS3qLPHv	1
1790	2vaLzi2AHdsSAjqzaf92bd6GbZrGPfreTb5jAnb2RFhmteSChpBa	1
1792	2vbUPpJmQfjwg5DoNpeXcQUjZGLqyHPW2uQ9yioUefJ3FsrikF5H	1
1794	2vaXBu7io6fakzhZxZep2KPSjgAvaCfFuiWWyGdsr2RPxeN44vwz	1
1798	2va9pV9prNzgJnyzfGohvPjoKaPXB6recXhWKQaKtnNrki7Hj3Bz	1
1800	2vaRne9KE6CMitgFTH177phTuSqTdhNPr7iEH4GXMGpB3dKvUtfF	1
1801	2vb6JrTVX89HznzB836Krc78BRBXkEoPzfaHfPg2DLpnrf1WjQFD	1
1803	2va9hL8Pfs5GFqbY11uNgvF7azHVDzBgU6drowr7Vc5wEtB6WETM	1
1806	2vbUvQu8rTKMPaWSasdxj63BCi38YVJy9PpG3hAjee8jdLLLtbPC	1
1809	2vanDqQNBZpA8EoPKC86bo81UyRoj4jDaxX1W9DrboUReU78Y5w8	1
1811	2vbTZsDANjQJT6CUk6zsQPCv7h5bXNYYec9sacJeCvjDK8CNNxAs	1
1812	2vbNe6WqrAs3QGmyG1RfRNXsauTAoXCqZmYmLDY22Sti52F1X58E	1
1815	2vbYcNRUuDGMtax11xRzhh6T2NHSbfGi12jZAZsYJ78G8E4ZuCrK	1
1818	2vaS7CmTGQqf5a6RMLpCAmizfwokNP8DBYBWZ3EDd8ZMArgC2D9p	1
1820	2vbmPnd743CTZcf1gD4J8LWWd31Rnbj55DVkFD3x9zxGhZTRG5gN	1
1821	2vaq6gjvfhTJ5LKPiK9JBpcuWHBtvsUdge619iAthTH2ciUBHbgF	1
1824	2vbUXo3MS9TBsg7N3chCzYTsE7dvtz8xnBV2qbi5jhtdsZj7wMhQ	1
1827	2vbt3ZEVzpsN4D7CMGAdNcBDBo7dHLPj7vj35EA5jr359sLAAnEL	1
1830	2vbscoGETAwxK5GUsxWHwr8CJb7Q39krtsBXbqX2QVmrkTDCGqxi	1
1833	2vazQVn1yTgeqN4uGCAR8MjriDSMRNk5Teo3nL9z5zsi1akKmu7c	1
1836	2vahb1oAQTMDaKRwp28M9QnQT877fksU13Xpr3711fpdw74suzsh	1
1660	2vbgFmuZsNLCfsdJ8VaFNpgs3qXKsbjFkeCZ58hZMCw4mbpnsGWj	1
1663	2vbiH9oo7PBfR8hxwp8W66CnbCqV9CheyH7F9U5wgpXCqzeGfSFx	1
1666	2vaHMQq3hw9C8R5KU6hQNJVF5vAiHTWzVc2wwBX2vfEs8ds8FqFU	1
1669	2vaBg3hopQs9JBSpSBn6TbDztJifnSoHop9pWotGeNpqvb8mzFvC	1
1672	2vbAFHwXtXJ5WhqACB4tALG3G98Uo8groNCxGutwP7r2dM6MzxEm	1
1675	2vc16EiaX9UJJqwXLnSPBfeHe94zUr9ty69kFBCsm9vytMR8qQhH	1
1678	2vaCLYd7nuVchPjF7w36pQrZhvmqb79Y1jFqLUM4XFfe12Qtmyzt	1
1680	2vaa3tRWwLPZC8wLQtzwDd8juvgPfWp66ooPgDWj2DZpX55NmBRE	1
1683	2vazfgQy4s8yE95GhY7QftxR7jzJQXVsdMEMy6ZhzGGb4yTVhJio	1
1685	2vbc29SdtKA3LLyELhg58Gy9nRhQAdVUWwmAwqbdM8UKeFbHoEmj	1
1688	2vaLvxXWe6adE4GumJYbHtvcJHYjZPuoEbrqTispE1iztiqwcLUJ	1
1691	2vc4PznUeAZTXbEy4Cdqvwxr3HZNbmta1RwsWReCVDt3tGwX1RPy	1
1696	2vc44hXbQAW6Z9AqyJuKSmoRqyLpgXpf5uPAk36GG9cWeSpvkVAr	1
1697	2vbFr2Mntm1E6oXjRJJW5CahsBQVTUE8Y5ycqJh92dBkMWhgeBBS	1
1700	2vbmnGmpfAKX9VEKCXGmwQsLf1mBGPYVdZKRr2WALRv388kR6w74	1
1702	2vbvNLGWJwq44jWBQk897GRb5DHUUunnGQbkuD5tTytXzhFyAeQf	1
1703	2vbPBYyA6wB6TtvEUGgwi5WdGnnHfxvC2jRtFirzdMGUrijzamE9	1
1706	2vaftR57EAZoqTVEw1zeQgMhP42NcT6Kxab7NfyERwrGsUTuoT9w	1
1708	2vbQ8EtHSY7i7PpUtz5Zbo9LjaEjkdgQBtvjF8bcWjd167Y4bryh	1
1712	2vb2zubtik6iPuw47zopB8Fz2u8iM9xEpY1d7BDeRbS5yfZXmn3w	1
1717	2vbV47FzeDTo4HUQohyaXunoNTqdDrFXixxt85ZE2bNZnBLPc3L8	1
1723	2vaZmYk1XaUEQAy5pyeDydJhWQ9Ct2EGdomrEBwneMtVibidbyvm	1
1725	2vaDzS7EegjTgN5fYePBRRDX1qoEfK6HpgopPeXyosEBRM6eo5qF	1
1726	2vbt752zZe5gDEKRd6ue74LMQCsfwbcmQbUBnGf1ntVdCUt4ru8v	1
1731	2vbcjuEBnvFh2MwJK8bmLLB5cnedZEG7G6253oAR6mFkwdmmXL6A	1
1732	2vbckinVVKyvmSgT5BxBME5ycVVzaNZagpbT9TqgzV2a9ynbPhAG	1
1735	2vaA2wXqMaVZ87jHkAbt26tdPJsEwXHmYFFTqCXjKr9cmYetpsrY	1
1738	2vc3Sz5nSo5CS9mJHem2qha7uBtQsJqsCpMVCzjFmTfuzCCEE3Ew	1
1744	2vbGmGyLgcsPP7D2QCW1TeF2AgWgGJLsJFXgU5TiQKSo17Bhyhc2	1
1750	2vaqzcbauS4fhxHMhBTPEaUfbtaHRraDQfcCMgm14ovkh9SgjU1f	1
1753	2vbdZL5pEJWbTgrVfG9151JUToMehzMsKEVpHKKVwLaaD2nvjDQm	1
1756	2vboHqFn6PVXYUvnDNn8XuAQRs2eaCM4M736eMKAopFxX9MDt7o8	1
1761	2vb3sG8K5rRfNc5dqX4ijpbRnqGrizEt4asuUWwN426wJJynwdSM	1
1764	2vaxDntEy3q6cbnC73GQaZinUE4LMgQ3dNaEQeb2qn7R1e7F2xC2	1
1767	2vbEBNx3tseLvvzpWiFD4vpFQRVdaG58pmr5sQAPXDeCaMTWnJ1f	1
1769	2vbQ8TP7saG4rsBXxmLwDi9wMo8w3BSQ2smPibo2Jem8uuAGtWZ7	1
1771	2vajTrv7kNLxNDmWWAZNhTp6qALVtEagJ7U5oNXX6xZ5njQYx6jK	1
1772	2vbLibJ4211pPraxWDfYE9iirZb94KFPWS5epVD43uE5CQaajrpa	1
1777	2vbVEeUY8Px6t8iFPyrgoBH6Ev4WyCEatQRMv25yY8oZTbKNPegd	1
1780	2vbMNauHYu4GEPW8KDXQE5xqB5WzZxtnzFTjVQdiyPGmPoHotsee	1
1781	2vaza3Gs3tTzjhjZfujL6C2u34rzEGvt4MAEjzvKZX88m7Xvoy3d	1
1784	2vaz5rY86q9sjw58zB54upmn5kgcQzrtAMvabXF9LL6vfxnRxB3r	1
1786	2vaWkcgnHCSCfQ4RcqTxsVk191cu2RzKTDMFhrEnUwjXWv8pmHbj	1
1788	2vacunaTiq2NmFSWd94Mj21cAmS6dXDG5qaZQu3ZcPgm98CHqySo	1
1789	2vbJ82dLssX8VcapS9fsZqdDxxVgs9RKAG1XxRXeRj2fQjuM5iMo	1
1793	2vaksvDkkA4XpxqpBgX3kvXYaGjzJPCaA4nwKsg6o7yFXWGqy9QJ	1
1795	2vbBoXwPY4nBckjDpazDD3BTmf992fU5dveM8PM4Pp3jnD6UZ8Lb	1
1797	2vaWVnMz1iNSF8GncChqEbhrzkioK3BuqhNySt7Mp3prwv7ByikJ	1
1799	2vbePv2rMLcGkcncCs6hxWGGwrpmbWq1y1iUkGgTXxJfnPG7nkDu	1
1802	2vbj39DJakJztFdgx98bE7dPn6vLxb7wTeVsGfkQaisRU7oHVufj	1
1805	2vbwwh1houepJscyyZBydtUDmf9vZmVaQiXyiYhs5G4y4ymaMTq4	1
1808	2vaUEbsV7zSfn3vMvgFSsnt5EeeVXowmm73BrbypwwPomGupqeTD	1
1813	2vaWmGdLWQaqMZi6VVBnTMccYCVaEQDVAAqFjAdhaPFB18EdVA4y	1
1819	2vbWDPUcRL1jXci9mqCCB27BcDSULahJB2a18Rqytys8cumqtBJm	1
1822	2vaEBNRg2NBT5MboRWstzUBtGfaKURtKGGXuq3p8FrF58RbvELdT	1
1825	2vbeb3xNgUrhLEDdkoMAr5Ay7kqHy99qCMmEc9GsyYmFvgBSDJ83	1
1831	2vbAevzfLHkGPsx1eP5zNgQrbu7dZ4ga7PrCP5e4eHen51ELKZHi	1
1834	2vbvgTY9iryeS1qt3JVgBmFE2BqY1Xj1VTBfdvXgBrXQsvgAAucb	1
1661	2vbj8BGBzDq6Ko31mjQ1Cn3g8kE6WmV6dG9VCsv7XcV48NFWVVq1	1
1664	2vaK5ECEfJs3jBLd9SHXWxEq1u1yBU3tfth3N23ycBE4j6k8rh3K	1
1667	2vbHbuzgpa32a6G1voZyePVFHTPQRwX7hmeKaLEivx3vfkBJGu92	1
1668	2vaappD3MyfXj5Xpo2ReN4PRwBFjjf4emYsphAQnHhTJJWZDtJzU	1
1671	2vbzfzoivWujQ8KGUb6Wmn7k5CDBEmYeCuG5dLNd8LsvwvHXRHxd	1
1676	2vaikEafDGuhnfNNtJPcs2EjLLFf36oKwhqnPEAbnhQaCsLAVv1k	1
1679	2vacZniZKbvgKkptgkMW51MFt8X2P2LPSB13xoTLXfb4uVusLonK	1
1681	2vaLJFRivqCJUuPrdwufQDyQv7u76z5tsybEBsTHukX1hKR3tAEj	1
1684	2vaJHo5CLe9XU6qt6LE4Ldy9ViNWtfYSm3PBUw8TJt7tWGrTER3Q	1
1687	2vauanTSyi2t5NACdm5F73L6bS4Yi3n5FqVedexTXLMnXKZw5bAs	1
1690	2vaEsPTyFwdcG6KvjTpW5KnEPeRiAtYE37gskPdt5mBM8dZNyXyp	1
1692	2vaJY5hCMdE74qg26rPvwANV8kWzBVpyFdHcyb6eDuCHXQ9h8TPt	1
1698	2vaujugFWXz2HJ3DH2UbiixCae9gmhsQiMssC4VvxnxnfGpNBkLX	1
1699	2vax9ch1tDNEfBZonDgbQ6X9wFbw6aBvfJsL2T44gfPvvmWbbbY2	1
1705	2varU5Lk7pGgEDxFAFqtyr8FVHeqhjzK4K4TMbS3TCDXTFxpVNRS	1
1707	2vc3RUBHvMS9ktEmAyvQSqE56iMDQo1uKvsfRJBgySueQXFhC4xN	1
1711	2vaazVQXtC6ZBF4HMXYTSjfAhZHbE6syiLQu9xahNFsLfsv3bZiB	1
1713	2vbdAeMUKZF1KjMXThrmqfu9sD1CWjNQ2gyryZm6ybdsy7mJjTww	1
1716	2vbEciRhFd8vPFq5ncSzgZgbH8vDtYqRspYw4M8YUy9RAJkmGAMP	1
1718	2vc5tVDQizNBHpkmft1Xdtvbefjvh8JKWkBS5zPAAf4isjs2hPhm	1
1719	2vbhBxbpuGxm4CVDaLg1qYTPFbkC8hh81dLcHRsJNCnXkq8rym6R	1
1721	2vbMQT3pra7NDtLYFz3yqK9UAGARDrTGfUL3ev2WdSo2xYLEAkk4	1
1727	2vaV8X5bTeu42d7ssxPNzjBZPF49bESvudugk5TLHfRVQPLazrCr	1
1728	2vb1og1bJhU8dLCcnsEBhwPGMH4PU5zzL6ZAodrw1uiFALTnbyKr	1
1734	2vaeYwfRNJ764jALXYiE8XKhMb7zDj9N1LuEdKRuM9T8v9XuB7BR	1
1737	2vbSDSoVYG91ZzSfxfvJYvmMLo1rrM9ureK61PXH7mEiKBpV9ij2	1
1740	2vagwAFKjQ8GbvKwKm9b74kCDXocefXLeD2gvM85zsr3CyEyoj4s	1
1743	2vaSUjKwDFgbcNwVZTDncwQkyVRK8myaeydF4BkUX2cGDa1bAc1R	1
1746	2vbrBe2cWCVbaooGuChqGSH5CW7tD6axJriBXs5X9ehffEWy4FQp	1
1748	2varbBx3dtJPktiFGsYb9DfoMimCzBeK8aaKoXWPvy92UqTwVRQi	1
1749	2vbCVFhM8QStb3ppSbEeyCz6eWVafZoTB8BXBQJdeKBMDA9SJmpB	1
1751	2vaMYF4JJ4dVMgWHCTmfMCEqkxpuTrJ7QK1BcrMLiLS3xkNCierL	1
1755	2vasPYBsSAbyXHsAFpys9VcGiALYav1mM2qUD1Eia1hcvHw5z4pD	1
1758	2vb2bJmzz2EmU6W9eRNUL8ftebx3aduCExehaRw5WVBu2keGZMa5	1
1759	2vaAig4BmzQtEhWT7DCTQhTR2SxVzoQFtHdBSjtfGs2xrZVQcG4P	1
1765	2vbvtK2qV5KM311VoycvBkenXpkCuQehZi4vyPyYCJt2fLQVisNA	1
1770	2vakk5Ga626pFCCyH2Fhdt4XVjBdsK97TfNPoMeHAimEMPSCedqa	1
1773	2vbTw2vitGgXX1zRtagcShaNMt3BCH7JK4oL2W1y7FVCobBuvyED	1
1775	2vbJRbxHzE26tjbrf1BymMjjysWdhhf5BLxtzpvq1UsLhC17Un9s	1
1776	2vbNeUbmg82c8QJVuMUd5ER1onCFCr3wFECstM7R2SBi7M2TfNQV	1
1779	2vatbUc83fDk82kjGYXvQXDWomfyURJKFz65jdaj7NbEPq2TNLCy	1
1785	2vbxmgoHScn9fZ4YjbB5GfbPdPauYXuLZb1yMP7QZhSR3HZkp9Ft	1
1791	2vam8e7aiVdVyMsHMdJTdJ9z4eVhfgHunGSD5xsmMDuhF2bQspSB	1
1796	2vaGHL4yAmX8ePRMQePm6DKj9SrD6WkwU5zykWzte6MdpaQ6gSdc	1
1804	2vbKMxmSbKvNetXmYjLYf5rSZScVz1xKfbd7ymxgrDwEffdfNu33	1
1807	2vafQCKUTPRaQMtR7jpd3fNspPBLVd2qStYttCpZBB5RrFFzAxF8	1
1810	2vbme2AZK9YhmYVsfH3WNiTYNDB1rPm9T7RVBqCvcr5LdNFyRVr2	1
1814	2vbik7LdaYqaQLoxfcBscwmGMcCc3tcFXR4RxL92p5vqFnLnyQ1G	1
1816	2vafPLWQxht47zgJLdpwMU4JfXVpMcAZ2jzjwxHVxASGPXA2ZGsU	1
1817	2vaFF51jR9xsG8ujV7Y5ECxJHUpxQerU27wsberWHZZTTQTYfs84	1
1823	2vbjUehGP5jxUC5x8bA3EgBV4jEoLHSnaTmx1wWsDntTzaWJt2Y6	1
1826	2vc5smx5C8Pt2fryDSsaF4aZWh4WBmmGRMyxJ3E2By6cZFdvif2m	1
1828	2vaP9Fg2yr8zMwTHSLaz6RgTj1LfTua9nTMTaMF5s2e6XrpZWvjX	1
1829	2vc2LBPmTnwgUJAQV4vRueyv3MosXQA6NuAwnto4TCfBnBxv4Tmo	1
1832	2vb3bErcsDbTyZvS54sgQbqGD5VAaDv2v2giuNm921EHB3omcYeq	1
1835	2vbGb6JxoScz7p1XPmM8wuDcidjWR3QtK5TncfLcURQ2iLuJLq4j	1
1837	2vaW6F2vboknsC1snoYEEaN6mb3Vkd2S5REa7xBf9PY32Eo7PnyT	1
1838	2vaSrsucwNaRvuE9fUKo3kDakC832i3sP2Te5wxXRB18v1vkY2Qv	1
1839	2vaZWx9PUnpeEuik25PRxEZV3VfMiwBV3wTGcsCCzZYVrAbjRwWZ	1
1840	2vasSk2dcWYNgYtVopCCY9yVMC9heFGazb7mmZjwcTqaJW9LSWSW	1
1841	2vbzgqhBbfmdpZNgboECxka2Dt8Hz1XxYDyM2n1Do8VAXTV2tttR	1
1842	2vbkJsquXGms8UMdWjy512yujno4QMDHsdngYTezjHJydoQF1pgV	1
1843	2vbh1eNQeBPyvufYFPAiaEH3qL2KXyisGEWd2xWMca8BMQUTR2sh	1
1844	2vb533Yon9fCfQaYc1meNEAq3dVwwcVixrJUfmH4yPerDq9Tkfwu	1
1845	2vaUvWneDZ1s3czomGeXorwmpeY7Ah4nPjYXGwZ3WNA1XBZJ16ML	1
1846	2vc2MQR4ukGfQbwd6bAe4WGvL6hNLEaqMbUfn87WGUUekCMfv5b4	1
1847	2vbbaQw9sUgundsTSfxmTESEcoTEZE4zgwK9JUqSrA4Tm7vqDkZN	1
1848	2vbVtqnxFTpxpax8MvBJdcMCsegQpqMdNizYogHtvjpDQhaabTXL	1
1849	2vbboBVAXUpJKhxKhuh387RgP8M2H2JYyJ846ysp9UXxPwmFFmnS	1
1850	2vaH9ruWKHsdQUEYvcR9m5vFuDrmsYD3SGxEeYf21GTTY3h8wVxE	1
1851	2vbJ5ezNkDUdxCE42fhHAaXLttkEyGtxjyh2GN65HZBVg5gprkLA	1
1852	2vamgY9MEgNgHNQuCHMus318sin1MQD4iegWD5Av5yHPjpgJinG2	1
1853	2vb4zdpa36xSCDTacNvhNo25Sio5Ju1QJHedwKH7Qg6AW7gzGeGP	1
1854	2vb9ZVabi5VpYyBNsk7p3B2iZ7uhL8ieK3NpNymsyygfKWL1jkB5	1
1855	2vb3i9D7c29kqhGPyXpJkBpYFfapTechqJr3zUqD9beqAa56ZoQj	1
1856	2vajaygj14cpoaj2CUwoggD8oWAf5ZbKfPpnafmqz351dikM5PPD	1
1857	2vaKJD9HxtoveMgtqvQMH7NfKjwVfvWoCttBx3rd7C6LRbTZrcm3	1
1858	2vaBaFmwfm77Q1EvRcjciM99pHpPs1GnTBoWMkd2CMUmkk5hkAYD	1
1859	2vaXQrE99QuJx4PqhF8f2AxeLLCK8BRqjoWpAA5ffHF7SdDhvJpg	1
1860	2vbFuzdf4NrU8A9qhZyMcTk3U9P8D7tE3LnwwJQNGzEhvQNByjFe	1
1861	2vbbxgL22qUxkC7mZrJec82UrvNNE31F9WA8kf9hrsWPGLW6fC1e	1
1862	2vbuR19LoSik9RQ4qRpPpT3zmZLkN3NhgWVHxQkQitiwr42FUVst	1
1863	2vbj8RiCnr2hVta4wc1GwcAizDFhcHVrzCRfHWTi1sr31ULydqis	1
1864	2vc115j69MfruxWLybsLqKoKL6DXRrfpA5BFmaH62uaTwtj4sG6h	1
1865	2vaK3ysDFCCpU69HGXsKzWQU73QJ4jbX82uzGmP1iiidzfQFPAhT	1
1866	2vaDNEyuNMyLaP4RGGWuZgLDqRxLYJ2MfEvNxupzRAspuknfKc16	1
1867	2vawJ3APBNnfXWNGr9GJMaDkc3AVT7LA5fiBJCNX3sxvNR6A8pUs	1
1868	2vc5mGApmQU1RFMgEgxtxaBLsBeW2vL1Wj4P7d6KD3gHdMMwE8u8	1
1869	2vaNVocegjtz6hdSiWsGw2dchnzGUtNMQgei6ZgQvr2RfZaLftsK	1
1870	2vbHk5gczFcVFDnDBPi1V1hHJ4yrUCnZpFnK4zD6CvF4AHkj9V8P	1
1872	2vaaajLxvA9nUfDn1oi77kFTtmyVe5D5CGwrFroMLiVdjdNfaKnA	1
1879	2vbEpQq6zjzyf3pUPjLfZmUKBmJck6mnGdp1usXWpMMNhakb7zsj	1
1882	2vaUJfjpXRHH91sRc5aXFPwSJ6vXjhC7FejnonD18k92FJwnSvdX	1
1885	2vbem1PtoNS25vLZnEHi9QznNkAYfXsSWwgdAmziXDYKTeeMnBsb	1
1887	2vbupkjtAyVRMaLsc2jPvv14UkfXpAh3EyTE52wonrdNP6VktRta	1
1897	2vbBKMv5ifx1sN8kTeeNutaxBJSR8WTKnc9HzEaCWzbDXPYfpdtU	1
1903	2vanQn8b3G7ae4kWGYAt5AvXJPXbiRtEpQJPZ3rqZupxpNey9mUt	1
1906	2vaMqf5xdij8xPEnNPPyYApFZazYokCLCqBK9xzG1tdaAkMvf96h	1
1909	2vbgURRbUp33aJctcSoF9TSd39vk5K8dSiLHuufUBk4k615Wj4nQ	1
1913	2vaJ2R68JZ3RJwsmtYPqGSbMgUYtu88kSrBW3Wk3xd2fywed31sZ	1
1915	2vb9ZFYg1ujDE6LgV18PDMXe4pzM2M13AAHKSDjJqTeeFiL6xNMh	1
1917	2vanEDvTBwKd2HZCnt8djXiuiXpY139y6x3yGKjSPpixMZARpBCE	1
1918	2vaFcRwnyUM7AVbwRLT5CMMHzqM2moUpc18gx7vWjYMmRbqX8AG7	1
1923	2vb8p6rzZBTdnBxoD813sfm1VtvVMB7HEoivd2dpRze2nb1QPKWj	1
1925	2vaLs6mebvcgNTBQPozN5rSwALQSGmUTPbfN4swas4o4jDjfLhGn	1
1926	2vaQ7hbx93bKVAiuU9Li82WTfRwE8covyXcp5feymCBdQMSLzSwZ	1
1931	2vbXgx3AqJN5QMzdZ7DDM7uqLja8mkX41nPj4g735a4ob8AcW76W	1
1932	2vbAPzF2rJxFiFSVgVkCP66cbwPgstTohTzn27rzJLBU9twm3T77	1
1934	2vb8bqtLf2dKknwuh2xUd9CN3zHinvS6UGtz24aWM1qfy2PqYZTk	1
1938	2vaPqqpNq4AFS7cR7TFUNRN8r6oMh75t7Rqdu1tCqw63RZ1aryay	1
1944	2vb8UjbPXnhnxYuXGhekuQHz7fPCCLQhVUhsSsZccc4DBELQvV17	1
1947	2vbKp3uzoZbTu8AT7Hn2vmci7f3ssZUcEqxef173X4H7nfVwaymf	1
1950	2vboYgVmNd4wp6Yq4JGNykKA8q2Z6NQDiwtjzPAU2o5MGQHiGZSH	1
1954	2vaQPXdEW9guG5fNBRjFXtLtMG6aCaXzhdYt5UaWMykHQqm3QsHP	1
1956	2vbMcRjTREzVzF9AEL1F4oPiT45DLtDaQPs1LH2jxEgqzqRdehSK	1
1960	2vbv7ba6qF3YqFSLzreFBdBgaeTQapru2mNvEZj7epmoMgPYLwKT	1
1964	2vbjsNKzvwMoQPuhGLQVducoBNkwZcy69CDpTKJ3fEaTYkqJa4H3	1
1970	2vaRMH6jKXpmZfkXC82MxCuWQ6BaAcRSNJUNegvjVPexbY9zVDmi	1
1974	2vbaJUKQpCx47eHfVdBX8C8YKDdx1iNbJcJNNUZsrF7FpQRh2ijy	1
1977	2vbHzR4tPJiacGJcyU4sqNcFa4zitSX5hVTuKJWLprsNPUk3aawg	1
1978	2vamfFJJzXQiXaqL1A6T9178Bt4nFRBep2xATyfs6J53ZrPYULv6	1
1981	2vbnepXDPomnsKFpPE9GbYMRph2s7ks1tQ9NbAPmYEcXHceimWRi	1
1984	2vaQTXRne58YVs1mCSR4BgUwP6SqWhJoQwJa5Eais7qpig9vYAYP	1
1985	2vbE2mr79JG2ACHtGDSTszvRrom2vqmGZwcvwvMhmeABHioASUjV	1
1987	2vb6pW39WG2swFkB3rGoHiL5TWVeUU6PQ2NEukVru16pb7TnmLqF	1
1992	2vb5JouEFfgw1xV8eug1fYcztNTJXJ3MaxdmQ9HACZaPyC5Nnj9f	1
1997	2vajn6ZuzXzz69ttg7fgny5PxwtsDmMkeEoTjsmWffoGjMZEsjpH	1
2001	2vaLvwwcuepXx8SJtGE92vdc5nqK7o9DX4asfZ4rFjZLgrvUE2VP	1
2004	2vahHs4SPmfjQDp2uTTZdWu91uTxkzcxVi3NHw67ZFJZ8kcVqKNK	1
2007	2vaLpRkoiG52GYEdQW1MXNMLvAUsPLRawxeVm6B5Ympy6AMHvV9H	1
2009	2vacrittaiap8Ki5iNQjnfJt7WVb98W2t4QDM5dsPi3124tTvWxM	1
2011	2vbDstEqDTvN2PWxSuj1mq3EUcy52XLJxfrbeaYHrLy31XDxd5XV	1
2012	2varfNjiWK57NDcwR2hVYuymytgrjXTE7KaGtfwJMTBJtb7L5QhD	1
2013	2vaGF6QxmZtK2hx3gbnZcEhPhZQv87vEV2iC2DKovnPEGbZXG2jT	1
2017	2vb7oRZQtp88GQCLsG1Lx734zg1wPCvvJRgMq5hbKSbmM6U9HQeC	1
2018	2vbz9rUE8rtWkDfu7W6E1rtfjJ7BheWJkm7vfiZhiXoeCNkmuKNb	1
2021	2vazMm5h2QWcx8XHFdKzfRiZ1UcdeQNFehDZBdEzY4NyQh9uWFdh	1
2023	2vaAog865nJdB4EyWDvobTXCAqcM62gsUQiFiKoyqSd7Nkkh5gen	1
2024	2vaNEonRLvZvpN4LGjtK73N2e41Qc29kTND9P3MDCAgj8tVmuvPm	1
2027	2vbtiL2chL3Qx5vfydmULW32xHB9bVWh7439nco6siTtju7tfdFD	1
2029	2vbHmg5K79XmDz5uSCRPLHgi9CgTggRLzvZJCK5T1Zx9f5muQjX7	1
2030	2vb5d8KZFGcEe3pRSopYrReXW8hLrZKENTvS5gz9SDqnM1xpP9AP	1
2031	2vbjDi88gkzPt5yf84Cwnoz7resdj3doaXiPrXX3XyQgta2GXEuD	1
2034	2vbsAaSyhtNUse5wAM2GoDGeZXxFLxiXh6jKdebqMF2xRb3yUXRZ	1
2037	2vbXrErYXeuSxdS7WUR8zTZ7wHhpXmaTnMHm8mPiuKPm5rjG59VX	1
2040	2vbUwKKRybbxUWFBGHj59vigoZfbETpkxL13aHeKKEHXbSRJe9Yb	1
2042	2vbB9Je387D3dPF2Nr8bfbMWXA6wYeNAYEyTAZHib1N5pi84smKD	1
2043	2vbLfn61UHM1WM4ZJWFdh7fETFVG8rdRuzoSgSuCNAAfLvqtafL9	1
2045	2vbajmf2uR6PnfRuTLZNdKdHpMQp1xfLge5oFzmZzrVp5iLh3UAY	1
2048	2vaAayqCKeDR1iuGhw23QBV6caDEjah1a3Nd4XZBmk4vLtZ6cdSF	1
2050	2vatZojCvXQe74vsy1mWNwJdaEhVe7ShX8BDxCPK8xPe2XTDm4hJ	1
2052	2vbrJyWoSFuCSNm9AP7TL2pQdHSqDR6dhrF4dgoknQCF6S8FcqrS	1
2056	2vabARW2soUnZq4nLjjjPn6WHHx7afS3NPDcP3eAJNQRxbRaffVQ	1
2059	2vbVTVU2hWdpU7VvY3yKPmNUwMd7NYVBc4q7SbCaGVG6W4TnMvpC	1
2061	2vb5HptUJyYCc75TRpKSbLEjmL9FuXfyZJ58X6MAhTx1TVXGSBv9	1
2063	2vb5d8uCSkdLUEs7U1Uyv2H1fsf8iUampboaTRKJ2abAUamRD6Pp	1
2068	2vauVPpg53UGrtSWMKMu7W9GNVTnSypy9NU5ksnAUwUdKxGvxMNa	1
1871	2vbTL14FgcoKzfc7YPU1QobNqGFex3ZVgnGetK5ZwF1zwMAueaKn	1
1876	2vaeoxagGJns6Y4S3gogNvshv6SbTBZurmSYKftDcantBEnK9P1K	1
1877	2vbhhoBL7aB743jzyWyMw4TMALbZEwQgeRSE7tMjpAJJfqFySeq3	1
1880	2vanCevTRUdcQszL1iPfCxwewoBcaSJnfBu11qwMYmKNPZmNviuZ	1
1883	2vbse2EXL8C1woBnKZAuxGZ1zHNKgyUUSY2iekGi7AFT6AhDV9J9	1
1889	2vaCUxcBs1jQhesT54Xyv1x1ihrRt2ZLHruxrVxAtC6qo1R9vkEX	1
1891	2vbGFBULz7VWPJx7nAaSsLKg5FUkzVUoHbnzh62S6uvX2TnHSzUH	1
1892	2vafVLV5bxYnBxtBAGPPWUDVtbCfXM1FpLo6zpjiLVYkP3zS9bSv	1
1894	2vaZHSfHzMD7Zxwd827Te2LseGPoiTBd8ve5QV8vJYDsbJUfE7Rf	1
1898	2vayGqVuUXaAJPa51kf4Ak3A9NYeYjovP47naPwah6qRznpZfJgU	1
1900	2vajPRrPvMsxKKhnyYyJTT24qLZBJAqMwpyWFMXUAgQPkPP53Boq	1
1902	2vbJiWH5z7eeHv29ZeVRgMvM28eseEeAaMwVmnEc1xuvPopYb313	1
1908	2vbCFSXB9FQnmpks7Utp77CbPKky9LFQ6sxQ1VftTULmtdjJ9QnT	1
1912	2vbxMtt58ZxyYtcfetu4wTtaYnvLfpkSU6U99uUunjx544npaV1k	1
1916	2vaMde9D1qXVnQhvtyJo8QUJuy9tAeHhrHKwcNhof5MZv1jJC2B3	1
1919	2vbCq9Y7zB8tfdMWKDe8KAwrtu3Mqr27Fw5sCGNuDMzJNMJT2GVN	1
1921	2vakeDcjjN8j6cmhMThLN7qgZBGkfNzPGo3ZG5yJ9sKPyS84rvRu	1
1927	2vbUMBFAWmNHQggPHHekeXsrwNUreW45pMZ2wy9pgo8Q97YktB29	1
1929	2vaDSzJzL8HgaZJbN8c3eKLn37T9dNcxKZgdrspzhtfAeaGnLymH	1
1930	2vbdtrxBUovYXeWnQAdyzKftNmXN6EpXU8cDJVXW8Xa8LTKYR5Z3	1
1933	2vagojZVPxSe2PPyFhSsuSuRndtfhVYY3eN743DB45eLVPvHuDEf	1
1935	2vaDCYjncsde77BENFDTCbNQQSgZBdfhYcFqifwEXnSfiSFLTw5R	1
1936	2vadyouh8VjP2EfdwigT713yKwqLsaQ8RM8M1T3tjvJQevsV2awg	1
1940	2vagESRET4rTkPwVY3auRH3NXMrwm6RA3ytxA5TWtvsWhkpBPqJp	1
1942	2vaq8nrmPwb52WLegvatf4eSfnhukJEqr6SctJRcMM8ZmeR1XAc3	1
1945	2vakwRmsn6GpNciRukXt9oKapxQJjJgrR42ZyET7a3P6E5Tdqo8g	1
1951	2vaWRAnmVL3fbfhKmquXjA6tZHBtwf42swF11Xmm8DUuDsfEEmyy	1
1953	2vavm7Mxiv8ZDqKtiR8vioxJuBRVkdyL8SBUfa99KGxB7f2dFZxG	1
1955	2vbHUDkmeXKTRwwftL7tz4emhaTNYVFSD5D28kMcrtN3iizNgskN	1
1958	2vbHJ4bFkavDVo18LCw4AkcXTWJvh2N3WyEreSquwmfTJ3YTMFkK	1
1963	2vbJELyCnfpjd7yJyF5d1ndFtwcfxzcfiNUjxKSD6LM8fuoTVzYm	1
1966	2vavS5QhCr5xa2Baih5XzHmYfb41fDmB7GAcgs5bcjx7zCxRMRtT	1
1968	2vbgL5mQzFhrKw8Sp31TnBTS6xHz4fgcXxLzQog7CciDXG3ZAN3c	1
1969	2vazvRFPpFazgTTwkJdNztGvbAGDw6WyP6T2Z63ZtWWhKjUS4BDa	1
1972	2vaAV5SC8czXYqCa9vrtqnjRgMdubmo6cP6AYvbBmzavUUNsQPXj	1
1975	2varN3x1uQegxBYE9p6GW7X2YmsPNiYXTzdWzYZkoLuH6vhfMfav	1
1979	2vaQ1iUkXK5Xe9NeepdgYaiemKc1fxNeiJ9ZFYW2TMYnh82yw7bP	1
1983	2varoT7EbVThDbY9YK4NyU1HUUZBTcsBH2ZKYB9JmNBHsivSDQHy	1
1986	2vadVcCUUXReea83PE45BP5CG5wgKKFbdZVcuMxuSTqtxYytDVeq	1
1989	2vc2AK7nY3g4zVVsKRqMS2dLpTVxQq1qvqkVwsZTv8bUbBqBFC5q	1
1990	2vahgENZo7pvKmqY3RjQZgWuRnDD6PJFP6Hhz4r9FKHk4bE1Zgn9	1
1991	2vb5whHRmArGDGrvNGZtqPmd1b8S4WckUGNAxtuCwGqXmbTa5oQt	1
1993	2vb72jamTsjZcUvDqDYU2U9M5FFbWmf3NBUNrLyFawMees4PgPht	1
1994	2vaUGijsq2odEHGHRzeG9MLv3gDXbuH9zqxULbuhoPU63PvG652g	1
1995	2vamPEsBhRVYChPqbBhiNoyfRJjQUPmLkoEFToTNKSeBJwav6R1K	1
2002	2vbAmoq2a5ZKtpPeSxWekmYDVGMttAdWhFr9mEmyAnGwNApFFsAT	1
2003	2vaiWvFNV4RMgT9Jk6Y3den2jATckqNfUqV4FXCdBkkFHqsNcXbP	1
2005	2vbp14ALq9qfXWVTPg8WwVgHUonhoicEoXor9XA63ZiNkfkJv4As	1
2006	2vbea55ZSE1H5RPLGpiAyvPqjDzaHya4qc6aNGp2aDe1qxxD8QCE	1
2014	2vbiNDzjdgDKuJVNRLQ92QiJWNyopsLw3HEPeHWDuNrb6FZw4h5n	1
2016	2vc31TFvp2on4qpPN1k53ek4gLjHxUvjybJD88bEn9k8GvR6LpBb	1
2020	2vanfWCdvsdW5KeK7YpkSPv75E6a1Sz9ocKwAZCi8R2aY4NTWXvZ	1
2026	2vbELjDGpKMZuFXLMX3VCcpW71BJnnXDsm8KzjhRvQ8Q7jTVqBdj	1
2033	2vbGnMq5SBX29N7wEnBa1HCiWtqjyBbcyVdfyFWA7w7HM8VbAbxY	1
2036	2vaMX8vSUMnzY7CmeXKzbVRS1huXNXr2AeUn2XB1Jb9RpAMEcFLr	1
2039	2vaT5132byeA74Huha4AeHpkmfKxCsiVVcCV9a5KtCTGxsrzbHfM	1
2044	2vc28H4iyKYpEQ1jg8jqdcY27s16J7CquEwsoTNVZQRPPkba2qtD	1
2047	2vbBKppexCPS1WT5xDLWtQnVZgwrRohk1qJF3f5aZ4zBWJPhixU4	1
2049	2vagmeLLGj48nwojuXvApTbDg8JshdYR65GGrWf1rsh9K3MQCZFQ	1
2055	2vbYdLpVbJiwGaFHcXuCqTUmvP671xbNBy7ryo4dMXhXi22uzNo1	1
2058	2vaKwiZ7PcmKezqdfCARTAxsPTVvdvSqyVQWhTAPCTdBbS8qQUsm	1
2065	2vbwNH1SnZFbSsVHjjrY3aaySw4GrbViidDKX6TTeYnEb5DwGh3R	1
2066	2vc1a3eWGTanzvKdMS41oXjbhDSt79x76zWEVegTr8hCPM1VAW6Z	1
2070	2vbsYtHvqPth1nnJNbK4AfZCJXxyDzSLrbCWhGDACM47cjDcwVTa	1
1873	2vaRRW5zeubqe8MkNe7iPo1TwDBP3xQzbCT6SwtzWEGGQE5VMCky	1
1874	2vaFH4AwQLXn9LsNR8UdjmpCMgMyHvZR3mrppnGHp6hPD8GUdKXF	1
1875	2vad937LRQkrPpYu5YPqy4deKi1s3mdiCCWGiLCeDoQGNhGb6WdX	1
1878	2vbjSz7hReb41gG8t4Y5J6TXR4nmR84RByLWbYnByRvxKTrg7U8V	1
1881	2vadvM26PsFeRcf3AWcMy8sTP9Y356FzymQKqnZb8TkvFNKeGwBc	1
1884	2vak6oQVijeC9F8qq4NknQZRifckH1oPC6ZCzpbgKeaLusMrNEgZ	1
1886	2vapwdzY7RPUXohV9dkPEUmsCsW2ipxE5TmafmaCdBKexuWtZQc2	1
1888	2vafAcVbdGWanVn5yVNPpqJm5wNapZfxv5G7ZKwrYYpuZsWbFEDD	1
1890	2vaBUwPmvTCraAfwTcv1W2qpEPkmk4yUrmKC1RTghPTNmcfdPRNJ	1
1893	2vaVFM4rtYWEj2VGNEkwWb9muQCV8xeFtz1ENwxQByrwYtsHmQYa	1
1895	2vaqbs38s2cJMtZ7sBetzM7pvR9qzoJuwG8M6dg7AZuEPLx7Hj9s	1
1896	2vbBPDKyfSeQFD4NRtpS9dbX6XZyG73FwQs3uPSPVCBknNZ6KNQb	1
1899	2vbjZkocATzxkQ6hK3FvWhgmnYbT3bRLEdKWs5PTzRfKUQrynuus	1
1901	2vaHHcXJvX3NFzGDgn2jis8kCKJ5rEbz6KCyefK35zvW4nNhbdgm	1
1904	2vbYZxQoWUvsHjoGCPhFQy1bqn867aoR9YFvUhK9UfS3gUYxeguB	1
1905	2vbQxmJA74QKeCvqgEDCZBfLDU4CddAtcuTmQQkwzapcSPAnKxw3	1
1907	2vb9aUgNGaBmojcSxR88vZyTju7X5nL3H9oAxry9aXa1Qar13ddw	1
1910	2vamD2Q7aRCWQwWEXbTpoGzUpAS4WLd56x5Xb2LiTsL8vztqhrTA	1
1911	2vb9jTT9mGooByhFLMr8ohwSuV1n7fWaiFNKG6kYTYaan93FCciS	1
1914	2vbX4hmfrinFBpEN16wow16vT3DdMEFuYhR6ATcunzf2sefr63Ya	1
1920	2vc4qNmuTSzfb47KmhkwHnawQEv3Vh1RAhkvmCTH8GHPedWRWdoF	1
1922	2vbCCzrHu19gvbePJo4p6tf7G3njMxziDVymcvrndM97i4GsUKaW	1
1924	2vbdGZHL3paah4HQgdLHnQnvhn7Dh9KRyvPdYZg9QfBVd48avY8D	1
1928	2vaZZGWNnokg9pYpnhtQkBm5HpXcdVjKTngqLKwBbydUyghHQiFq	1
1937	2vaycMasDivjnLPycgNP2TJa7onLUsoAwG8A3fhRRnaRYbvEYxAx	1
1939	2vbV2w3hsbDpKNeJz2BS3tvrspPnPCB3kLZEvS8CLBcDFQGcBRtg	1
1941	2vaWbqQSVmnjM8YEQEQJe8dULeWqoAVhmoVWWcD2eGZqu5QrP4oL	1
1943	2vbdWhq7eoXgThUdnuQ7YsEHiAKmuv25mdEvVgyo4J6UMKRqM6de	1
1946	2vbdSj24CqixLBYZGTtXuvPFbmqAXwSQifNH3NBN84f2xBcGjMbQ	1
1948	2vaBo5GSf9SYfZPc1wyuykH7aciYSXuAg6j56Gb1zQjtaVcA4zeM	1
1949	2vaSth6TVDU3uBuzM82BEBoKoBxE8Bc2C6J2gF9xMkQwnySqVuD5	1
1952	2vb4gvDNiHgEskxZ7rC7FWKxMpEdWCzFu4arHzM8brU7nV3AqBuU	1
1957	2vbH8h2rtL3RjKZjRv4rm6VqB861XvHJvt8pgKxSp1zWhRk4o1DT	1
1959	2vahibJXDaVC9V9Agjh9Ri7MJDWeAfxGbTirxThLUg6dsgjFJB88	1
1961	2vaZx3eH7oj9eLYYB6hHiCnneWPcTYnXzGk4FfifJ5y4FCErtabi	1
1962	2vbwoT3rLLiQbeLhrDCqhFi1Pss2AjmU8FsrzHDBa173Y5bte1gn	1
1965	2vbwH6Wvm68R6eF69Pdn6tu7M47A7utP4dkye3LycM6Gu6nCUduF	1
1967	2vaKRXUYhCzA7YYcPuTBhngWr3jDTQD1rkZM6s5cL68Ke7teKuVE	1
1971	2vbmYKSJpCM5hZwGN1wK7fzMjdG8hxqp2UXwx8zsVbBH2q6RLt7L	1
1973	2vajRnPRiSoBpXMEJJs4gAYSYQGh2eNuJqWStxknt5n2dH39DJG8	1
1976	2vaPY62Tt1DhbiUVEUzHuVjs7dGsV78HUds8sEzus8FRc6Etqu5x	1
1980	2vaumaq7ibgJK5ceR59KqbNCDSE64EPnjNKrLmsq2QadBJ3QE1Hw	1
1982	2vc2BqiGJbPUPvb5DWhw96vobPGBNp6RCBw1iJEHJbU2deAQVnzr	1
1988	2vbJeZjpLp5oSdvSXaqtvVFMESu242xqbfwVcwwtdP957Sv98DEK	1
1996	2vbH3zxKjd7FJze6yMnXvz3YYU7P4Biz9fsiF3ma54Cv8YVjCNo1	1
1998	2vbDEHayEUgcWojMEyZJMs4mwrDb1PQUDU75sHFSS6J37x5fMbrP	1
1999	2vaGuLb4M1gY5NrVLf2jm6e3MXMFGdj9YAzgF8P6b1KbixomDZqA	1
2000	2vbTjLA2rAT4ozc6cfZDiPkdbgMWzMbEyLy6r3iu7CgBpXPgEUAp	1
2008	2va9yEf3u4h7ewPidCD3QaHC3wYf9aSQYNTvvML3VVre1JbScT7Z	1
2010	2vb5R4mZccbLWF1rknZkMnhgqUV3c3AEnDRnshqCsPrf1xxZ3WVU	1
2015	2vbXxYAUcQE8XdEuQCjtvotYVWjKcctgBwzcTvJSM6DBRdRHBuzR	1
2019	2vb9uozufS92XfmgWLFjUHUDAXmvL9TdQpGJ32fFB9ycopK91TSy	1
2022	2vbrr72ZZ7MCdT24skG1GJxpamuva3s4DHLVfCfMdUfWDvcpzxcE	1
2025	2vau7sMQF3KUduMrpKrEgnVkZB4wz3CS2E7HrgUFi57GpkPr6Zyr	1
2028	2vazZUWmsTeJRHgJK6teBAmEaAJFHbLJegVoGWfLWiZXvddndvtb	1
2032	2vao2gxiZ33jd7JHQXybjMFiLVCBW2TS1F3XGonQFFFyLSL1THU6	1
2035	2vaYVnGjhZErgu7CJz7WoNftvK5tewdq3faYWPdV9BjLVuwUbDix	1
2038	2vbfcf9dj5mxiwqAV2FKDeeANiRZ1MAB5hFHmte13iugYy9tq6hN	1
2041	2vagTtyHXYnf3T2k7GEZEWwM7S9yMG3U19RYMVa8UB3osipRLxKs	1
2046	2vbrQ3LVCmvBW8ryhGyfbUu19Z97tF29R8Y6vz1ScZG7aB8jucvw	1
2051	2vaD5jKvER26a8jp2zRHB8m7Wrd2xqgp9VdschFVCSFM5Ghtgv8F	1
2053	2vbVuQ5emtgg9hhb8UHVsppzxhmpK5FrYxznTDZwh5q4iREkmr4D	1
2054	2vbGa8JhjnWdvyb3KVNqbPmkPwL6qAD3RvfAFn7VPxHDiXToYPUt	1
2057	2vavb2auJX7atSpkoijkiUkLSwFVezQKaKEL6jX9JTTJeymEvpee	1
2060	2vbYn8TmTbG5p2XXU9JiQChRgEHYdfMG4iCDd2UrzrHmDXbnxYbi	1
2062	2vaJeYGacFKsinyQptBvcMpB89Ldjn7Qz9uBjDU4iLdFaRfMekgf	1
2064	2vaiaVkU4tbqSdSgacNA5ZNVJ1kr1ETS3J9CUacVqdYHTwQTnhxa	1
2067	2vaFH9Hn77Vwnys5CYCWmtcapSdrAum8FzewsjhHf9M6j2ZDTNEt	1
2069	2vaciPUGbxdU7NHmDVjZ123F7gBXXuWcmo89LjvU3HtRLi8a31aR	1
2071	2vb92zqCRY1PwLpFS8oGLAeJd5T78cTMcZucPwAduMq3cgjr2jPS	1
2072	2vbb3nJA1eNVfKtKP5Wc77uyFazZ7bJGBifUVVaemty69W8xYsQq	1
2073	2vbzD7KS2KtmgMSP1WuAuRVmAJWRdmygLp2XCLeVxFKeAXYNFRmz	1
2074	2vbH4CATLTxcsGBunSesDitXMc1wZsetWtipZkud5fjQq1FyqhEU	1
2075	2vc2gLaxXnS8SLdqMAnNQjhDHvp96RW4k2mHMUuvTULg1y3Xda9d	1
2076	2vagSwamSLnXvQcAZVg9FKoYKXmaFiNvedstrHD6okCs6WCmL8pP	1
2077	2vbWsdU5yq8nitfPJSPd5xQ4Yuh7GvyqJZhzwdFcDAJepy45rg8t	1
2078	2vanPex4AJsvSePTpV2JWJki8iFk55AK7LL8Wp3FH3JeybKVCoVW	1
2079	2vbQpRKUocSHvSK5wvW4wnS2hFrTpAbBW5CHWBSXxXR8wwmGSJUy	1
2080	2vc4okzv7p9pRy61px1v4WGMd2nptJVe8uwK3RLf7FoB7Ei4J9Po	1
2081	2vbPci68QnE7z7oeg1r7mi6TAiz11TTcayNZXuzf69i1B5DQugcd	1
2082	2vbfpioDrRA2v3p5UBytrq9GVSxDSgYwDQQRNXp3siJo5em6kDkY	1
2083	2vbiAVG7Mgd98t2YTPf2miaGdrsf2vqRnPdEC5YpazeVWGjLmqBc	1
2084	2vbbo6BLixXZoxp5r3Y72iYnS49uEgmUUiSbLZF6RASkwX9n5uwQ	1
2085	2vaQBK47j4Li2d3YVZi1VW6BSgVBvZmGqUkdyae4Vuc9bv27h1CV	1
2086	2vbeRQH64PeuV6AtNMSBchr9DMrS3RkJeebGmmerXT6DxpPf3kHf	1
2087	2vaRrk8HypudmxB5phorgJGmnP4Knfxdw3sTvzFaU6QdnRCUuWcH	1
2088	2vaot3x7g1X7G8Hb4FMzEKJK3gMLbs1djNFHb2LsiGZoCFhsmBcz	1
2089	2vaNsDQNGeGRRba9seQevCk9n3Qsf2WxFoASuHTZ4Bv1Bw5iS1qP	1
2090	2vaWRjWn5R6XSs9Vps5zd4nbQJxmCqYLouaiNrFqy8Us6eEpE7DB	1
2095	2vbESxHGyQM7WzmJTNYdrdCLL4wXQ9ccRhsRBBRGnu6He5EN2o9e	1
2099	2va9aofAzV2r49jqkBt6dUvo9p8RDYMwMphQ8pWnyZtehJS24NuX	1
2105	2vbBS5LjQ8eB7c1XysmTDKWV7K1ns4JF3HpR3TFivNg8Xra3wNfX	1
2107	2vaxSskQpfKLkwapGSzitYqnjRL1rmZsm2XMEYESJDxYtGjqieh3	1
2110	2vbTNhttzhsqtokuuiZoKGPSjwofAkUv168nCQzr3kc4FDE17VVc	1
2111	2vaqFJx5PdJPSRucqP38uf9j7NbVmduq2FFuzJsgn74fsGQCFX2V	1
2112	2vbvQDFSknryEkPt3UZrCUWg2BRZMeFMvKBdjwWUGGySoaXo3gGc	1
2113	2vb8u4LyyXYqLRa3JT2gNsh31Pr5g4zwPsdFSphbnD5gwos7CW51	1
2115	2vbpU8YKUN7TGCc4PKTyp2xJJNCDyJYrSdfx3D8VvewMmvbBfU9d	1
2117	2vaePdwfLhmMUtXDbZVhn6i9f3E71dLiSHhRmVBWCiBzBca6387f	1
2118	2vay17ALYmCvtSW7khd78iaSaBaFnkKnjNvVAiKYd8DJ6ddoZr3K	1
2120	2vaVRZ1y1ChgCSJzvbxPkVEj6eXpJvgvYU1VKa1fvzy3aDURfgYU	1
2128	2vaPt77ocgdPD7W6FNUwTYycKhgqPZu1hdZYJyMWWzrhSmr7zff5	1
2131	2vai88dya3ZFDFwjegYmFZSQSVy523ePKmZtkEirLEbXcTnbTufJ	1
2132	2vb4soAW6Xc2o4mrBFeXjJGusAYQ4LzhUGtpmvc6mgp9J14Q4UHb	1
2135	2vbh2Gh7FYZ7c6iueGSqiL32m62iEQaC64Vu489kCyZwjruKjeHc	1
2139	2vby1m8THsytvfuBJSagfw6kWY1zXmrxD2D9BYqsjQnStXS7HGa4	1
2142	2vagMMVruVYa2ijD7bnXSaFw7VU4tVP3dfHS9DwcDxFxoGafb1T7	1
2145	2vbQFr6pDd7xAHmJLodRcy9U8YuscLt2A2aoG1kHbTeHHdatyyS2	1
2147	2vbu6pYopq8deusBWmWahoM8W4ERxHPk4scVYR5htUJwg3SdxUVb	1
2148	2vbZDbXWYNsyP4FXTrY6r2JkT7yfZ5mUH8wn1NF8WhNBX7DjoWYX	1
2155	2vaDgqZrAZPop1qLGa5zpVSshhhWgbvrTiA2mV3fWm3tT4GJCY5D	1
2160	2vaMtPPzUaroVBFHk19egyByQsQYue8MsWvRzt3asYHYWf3SwfbD	1
2161	2vbfYVd42GE85g3XSEH3ZpRr1Xrkgfnu1rnvCyjY3PPgm9cjG4iv	1
2163	2vaq885sAFgXTr7mmvXjp51wpTXTZgd4XrJAnxQvuu56Jva9QGvX	1
2166	2vbLJN7vPPcUEdMyTfsUJvMfYN3CHzVwc8rczC2isSytcDvotqn6	1
2168	2vau4kmvsUtTrf3WpHqz13hv4ojrhESa6VNfgMNTkDb6vihQpo8R	1
2170	2vaL9YioSK5ovm5Mpk5S7g1EtQfY5VbBKAzprfiyfYenJEwjki1G	1
2171	2vbUrXtMAwjJpm6ibcCABe3yVq5tV8aEjWmqsYv6pg1QB9NDLn4D	1
2173	2vbpZBERVqzGpm6HeJYFpMiEaazBGKNZF7sE5GEnjgGqffLXe9eZ	1
2174	2vaCY5on8AMkmgdca3wfLct6N9AFntC2CnUKZkCemPT5jx8d71eu	1
2176	2vc5AbvDD523WTck2q8m8DJHdkcX7pJhBSjce1X1WRkuj4S1c9jV	1
2180	2vatbUka1Lgd9bvKzNapWG2Ho8RF4RutZ6HdaZtx14ncHArpkjYK	1
2184	2vbEUZuKz5NF81RgVLB4WgDR7BUrnyzUqn19vhuh5v4mhV41rhpV	1
2187	2vaqobVBvHdHLnCSAdYJ1bGWj719qT69kdE9B1qXqngSPrSFjYvd	1
2192	2vbE9LTjbWMBavxRLCfKPrwXB2bRthRGXTfx1MFkFwcPGzVvSzf6	1
2196	2vc2BwmJj613D2oixKaRAxjiSi7xgBVUx8sXWrXnENUuo6sErJri	1
2198	2vaQfNN9stcepf9Xy5Vbt8nJj2UxL8dnEqkezKaRndS3SQidcE6b	1
2199	2vb1jtVr78NN9cbr9HVKt7SHquz1f5PRKsza5zsoKLnNTYrLc5Z8	1
2206	2vbkNM2vCJmn42hJTjEbHjJhXStzAnKnTVSACtxAcCGz8YcoLAtp	1
2212	2va9Rmiqy2LgNXgtGkGVYpquKumtZ5qytzxCoPnWuN9TtbGaN8ur	1
2219	2vaorKfkTgiFePU3How7C4pGKbU5sF4pp3VN1xsqs9uj6QcqACbG	1
2221	2vbHcfU2dXY4LEnDC1VpsFqyKvMpBWNB639qxzcsCXy2k1vQiwXf	1
2226	2vboarc5wmRmz5jCMpto3wLmfxCjzoL9Tq9kqAEd3M3R86ehQFAG	1
2229	2vass2XA7BNkvzJMmWH85udmMKQo1Qqwgo94GtqmhnK4fy3dyd8R	1
2235	2vbop3E64EDcSoS7XV8wcZPeb9SSSi4ytwSN8VuevKMXznQMGkg2	1
2237	2vc1kkyk5zeWMfS36fJzP9g124Zg5P84sU8YhvhE2k247VrvgQVx	1
2239	2vbAvLGHsMuijv7u9BEpKi1L9MfR6fSgJhWWdqLmEkmN66NKm25H	1
2240	2vbHMhAZR6d3TThxNXspjSNXpo7srLCvj11t2jhgASstZAVee9nJ	1
2243	2vaGCBmtYvQ4sue3hTCTDUFEDeeMurFA15cbJvLnuAWUpNSwScgY	1
2246	2vawAuemwogXbmhbhxHUqJbyZnEApEDvFSRYu6jsDzWVPZqWfN1r	1
2249	2vacNJ2gEnjwsM217aEyaErM7QmUw1Z36RgrP9JXZY4vHC3Y3TEq	1
2251	2vb8sprUvvnw3Fwg6GVB3smbqB8nZKh9RTMS7dMgfffd4JeiYjJx	1
2254	2vaFjTJuPrqY9pcA77KkUJUTwphe862sJRCpJB1fVNpQQyRBaYSo	1
2255	2vb6wnoMPd1eiDyYdMueSeEtBsE3bPh94VkGzM1jy9gR4ThUSwnC	1
2259	2vaG9hQiR23ZYzSjoKH8NxuTTyjMkYacxHoQHMftbuEAAfLK1VTd	1
2261	2vaveyfiUqJLjxDT6JV9SoQLxHeJUfS8f4xWt1XTryJNEgzNFZtL	1
2263	2vc2tEMv5MqgD2Q2L55gww6Lgv6aEHJ9MniDGXJxcQmgQsx83yGd	1
2266	2vaGrzjyyXSZespXskCeWLbT9YiESCvAXhyiS2NaP85EaXMJStau	1
2267	2vavxuznXgsmCzFrLWm1xVjqkmoEJr574wwSGx9nrjQCAjA1AiEA	1
2273	2vbk6f5ndZaqCLvdm1QTdHMGD8HvzUUpyvWqWXYMUjNvsZtBqAKV	1
2274	2vanE1gKSE11LtZopFQqC1hmZNcVJHz6T27rffd4QacMJn7pjgrZ	1
2277	2vaoHzSn2pP4RKc2wcwbSGrBnCYKjq5obwkDzpzCk6mrbpZ41im4	1
2280	2vbGPLHbGRrvgcHdCThufHFvzaT6xLiQ6PXXownmA8UunW9JZiVb	1
2281	2vbrMeJXBAFFxKbErk1ETdbbUjE1yMdzfPhr9FiygH7CYLameL22	1
2285	2vbQmbMvRkki74FchpYLdJzJG3rtBrCvyCWuVA4E2krb14JpQXAk	1
2289	2vbcSpq2mkvr2BALmSaT76QStEGh17L21p4TD6KGjFX7hHtWYbVn	1
2292	2vbao3mKFWJ2duZSWkz7eVwNXspimZ1ES9tqNkXTfzVAaetnunJ7	1
2295	2vadaYsk9kw9BDg3aGfjBfcNfbgyBGqA4iBCmf2aD9WuHcNYFhya	1
2297	2vby4u82nE675GrMGqjT7Ea3DyKzQ1zXo3LRra7B8xGA2XLYdiNx	1
2301	2vb5aMs1bwo4ZoetwjaBs9cBAeTVHTfz7rsxMY26bg3cCyeUkemH	1
2304	2va9r9jR67jrgnRShHNRbbV9kPoJLVLYr5hM5Rkt7gwEA62a7mkn	1
2310	2vbuHJmaACiiKYD5MobfhUzjAMdjfTVHyZEA2BojdXdffUiRpqup	1
2315	2vbDfvJsiMNhJvM66bNLvR8vE5NUre5swVRZMGe8ALJPyAEynGpL	1
2318	2vaxyRJP6REra9Zm2vSNKiGKSr9ynPrJ9iDyBPqXoCqSuNwNw9t3	1
2319	2vbJYPueL7HXKxw6bJXL2PscVdVxyhMbwfb46NjECmAqjPLMT5B6	1
2322	2vbqxZdv1JWoNRjLYiWxWYxLUdnrwM3otSTxw3WXrG1cQw3XFCGw	1
2325	2vbUWDccNpNTzXLU7JkQgXrpswx53g55LR616qH9kYVLBrAQsZ1B	1
2091	2vaNnh22nDkFoovkbUxhw9KQpmFC7Ltk2wkDcwBmDd762mTysrRU	1
2097	2vanAbFveiLD4ZTqHq6MuhzBck5WMrQXF53Z8ndHJT4hLoXWmm8S	1
2100	2vc1vdxP7vaTALsu5frkdmoBiFyFvVqr2bxnwic1Xor9saE7LXnB	1
2102	2vb9UHgWkpt45qwvEwDcCwSoCtZ3HQua7vxF6nPnW6kn7KE15BnR	1
2109	2vbupwTkZTe5btCCJiihVkacihfkYbucvgb1qZ2zUzVHsdPuKjoi	1
2114	2vasdQ1uwhEmHGMhmZmyEbyQw7xXSHE3uRgD16zMfEo7zLNiYA68	1
2121	2vaXkHQuxoeFr6vv5AnabxZG7tsYaxcodmFADd4MfYEy5Q51Q8Gy	1
2123	2vbX6WRQJHWsZofdzpa1Cq4hX2p4ypCuoE2HmTtLUqX9vFLvLgTs	1
2126	2vb7oFQK2DttxYUYu5U51hCr4wmYp5uiYBxyUnMLV175RRnbvmUU	1
2127	2vbFtddQuAe4uLZnimZiLtftwdcrNe3zow59QPJNQQZxNbNpw6hk	1
2130	2vbSPT5tJvr5pBeJuMDo9rDwExMaKWxDzcQG3ZWeRkRBtBpKgX28	1
2133	2vbiMuCPtW3NjKkV2DrXmv3UxyjZyi2bDvfjDfZXdaFSeu2RkfgB	1
2134	2vbinuDPSE1UVGHY8FMt5iD7gu3MGHh2SxFQNMhhvFKTP2SBcvtB	1
2137	2vb4kySz6tADdNQ5DQbiyMWFE3H1i2UjX1v6p4UviQwWwuWGSiNc	1
2140	2vb8L51JBzgAhH1m3PWLFbXdHpJoviUa1BuQ69asBDjaAsksGn5m	1
2141	2vbbLjZTwTYwTpFKLWkn7etTyfXckAGNebyHNS1xZRuCGkF1YVon	1
2144	2vaTzcehCbxhDbucr3EbMcdAfoQA7ieEibr42gddnqZiW2SEgDMj	1
2149	2vaLf4Bn8BE97eezxrPPEQLkH4FQ1Js5Lx1WFZWdKwUaBscrXhsB	1
2151	2vawFipDYGH77mckMD3ZC4r6fA7yY7VhborMkw23DyKRarRnJt85	1
2153	2vaULzaZLCLZb8fTuGX8TpEGZ3JBzkQy4hjFWqUV8vPxgvvFZ5h2	1
2154	2vbSYdWv3apzrQabCZnJcTGAQMwV22NhCs5S5azBN5cja7w2XbZw	1
2156	2vac4xA3p7Ybamxv7a86ADngEbM6Wr7qQ2XjoWp3GNkj65gK27bn	1
2158	2vbVHxyaFLvjNDeeK6itrVvRGhCqnusy4LeMLVzkxH3vgHwrxRek	1
2164	2vaY7Hg5WNNqEkfkZ7DB5jUH6E6jjCJTqX3zVFthYiidFPXbH6sM	1
2167	2vbS8CLaJEGb1v4aop5WioMYjEGdPCuwFFfmnAUJzS6niDGAUQiv	1
2172	2vb24KKP7ky3dL91YP6GwgAWhZntYEPXjLu3JhexcSnyPoVVrbQR	1
2177	2vaxvxz5XP3VxofcpFJDmfssgYWBeih7ir8wW8gvsEmTkH3mMc5W	1
2179	2vaXvD6PyXVDpZuo9zP3EyJ3Ve5WB5ydrkPvpWV9B4to37vjEtUE	1
2182	2vaGg4R756ZpbFdsSwbMuVRUtZR5bgWdSzb8oq9e1TbSiQo43RVs	1
2185	2vaEkxFbDaNKa94nuSNUYF4BgbEQpvfX9b3ihVJmzgLM1Nwrdohm	1
2190	2vb8uck8kwp6WP3Qa7mmg4kmZLk2uJyjNAbFHa6RTYGzFVjcvz8H	1
2191	2varKdvM7rrUHf1pg5gRNFSkWWdRvsVXK8amtjsS4Tw2tRRvg9sT	1
2194	2vbxh1pcJasycmxbvnqkkusBPt9oFsTXHYJZiPYXf8QNPmsmJVF7	1
2197	2vahihTukZ7oYu3pqwipRa3PywEDaTWdVsABNZ3Aw9pvUNZhhorw	1
2201	2vaMBbcH7p4iJ4Q3wqu6rmCY2Y9CPYxonPPNxvQHGWuLMG4odcQA	1
2203	2vaiybWy3NEnd9MQcLSDoa9t8ea14HBCrwTyEcAJAkfsixV9rTpH	1
2205	2vaF4kLFJCB6Hvbg2wtq84HAebrJ843FVVz3RZ2duTAtg65iDf9r	1
2209	2vadof8GSgn4WNR61qyE3nyFdTUtaT2w8m7eu4o95mJWrw3Efzn2	1
2210	2vbU4W7J3KF5Bg31AV8gPqfzxdZhYpEFXwBU8XK5SL29qyTg4wa5	1
2213	2vaEfu38dQfGctW95mv3ZDs2Cx3zKVZQB7r1nmaMTUPkj9Hirbib	1
2215	2vaqSfWFwvFzf77DfrKYjyfJMmv5Y2MHX5CMrwjyjSzoXu4bTikr	1
2218	2vaYeuyNzBavvsbcsVgFhsUGKzSN6VesckoxGA72hGZUVAqdfb9u	1
2222	2vazKL1MVbiRBDCtDwaawsxEMNkVsBqoZPcyDLWGWk5QZLjbXW9o	1
2224	2vaX16n9h5bnagCHxbmKB6MNaPg8rkgefndWts226huqeABHAgWy	1
2225	2vahJKxpQhhAXoT4aecdMmh9HtQM9moWuq1T83M9p15NrraZzBJA	1
2228	2vbnUrPT9Toi7Y63avf6mKTc9i9dcAJCdb1EzHSoxRZekTxPrxDy	1
2232	2vbFwVVckWjMnR8igF8h5CuqRQfBVVfgtwP43DH8wR4BJJtafs4L	1
2233	2vc4r8KHzSCkz9EsvTavj3EDGPwS6Gq8FrPNLJ4no2yCxFatz9Mi	1
2238	2vaL73qFozL8jj8Ctt3oQFzFJmsKNUd4sPLg8Bdwj6xgTvQVnFUQ	1
2245	2vbidtuuBKUbEWzf4HiQhiTY1DaghottZtP82KqRk3vLpPTex2ja	1
2252	2vc4no1N97KLDUV719n7AbHeYV61N9bbVHRWCGo55rF5j86YZLv4	1
2253	2vbyQz8NZWCPWeND3mmxSxEfrRxZNZ9HU5w1UTcBbn1WCVnvDkdT	1
2256	2vahqhSzGcWC2MNeKf2SgXrVJVUynNbMqhcsYaJe2ZGciQazWx5s	1
2258	2vaa7Uz14rk75GcQJRsbgYzQj7zfwseGME7gU41v8HxivRAPzNwM	1
2262	2vaq4mNNiZeZEczbsUPWZpiQsqMuzAqXwAFoPLLk5b8id65bMyuX	1
2265	2vbn7UfH4uWqSeXnxyT8mAXukEuM9GZhiLftrxP15ytnzE6BYMXi	1
2268	2vb7z8H2MCB3UBbTTRbvWRrizcJ1qceWhXpDaTKVcc8BjbegZPA4	1
2271	2vaLNdUqSXLzzS578H9M3VkFuj8BN8JJeQCGG1x4tfzeFdAUNpsd	1
2272	2vad7BZgDwpM79T3hxseuqWkXSc1TZop3TxiXetkJfyaL875c7yX	1
2275	2vanmueLGrf1NKBNJBiupqzTqAKnUPmjZpV2fTs9m1sEutewtX8J	1
2279	2vafjvtVFGMR78CqBgQbRNVMJa96j3VQSdp4dY6TVHxyXG4qcGK7	1
2283	2vbDeMauJai8qZperggX8Q3zSTd6Y4F65euRxbEQFtLfGnV465iv	1
2284	2vadhYUbWoW81GZhox5yVzQKrsuFE444k1zLUdFFiKuPjVGKTgVy	1
2287	2vbge5JR981zk9Kf5C7jreFykqRp9ZdTxs8dXg1qcQZeo2y1DSPF	1
2291	2vaX6VmYiWqKbRjjwZjbQFL15M3wSyn71MkEPLKAq7a3cdy1ScCR	1
2293	2vacP3GQdYPqBYaiQhZozxv32xT1AjJLwPoctudnErS1u1YAyv86	1
2294	2vadPu6Hbkuo7kWG8ccADSBmXLRuyapP5HN8grooPS6CJRL1sM76	1
2298	2vaofP5bW4phQbu63C4wTVH7aW5xUz4F9d9HFZ9eKYfRwAmbZjEn	1
2300	2vaJsaJdpVpCwhxT3bgzDPWhhjmjNT7gcXaDTmmUawCtcuJR8eQb	1
2303	2vbSF2sQrVoVhE3w4nZTthKPMYLSsrBkqJwrw29CK4BtJQAFDesN	1
2306	2vbcCATcT1qabj4BdDdaaKjiNNhsPyXaWrU4mkuKnsyT2duoDtXq	1
2309	2vb9Ad7cxAhuzFex4fCv5C5rHtYVwVmUJRn4f4qt9vVQXcce9Rjb	1
2311	2vbvnXT4CHDg7fS8fdQXErWFwAFjr7uzzm9iiwn6viqfPJ8gA4SY	1
2312	2vbuxZkAtDjvBmKnk6YzgsVmsEfDpprkvJ1QUo9q8Fq85VLBsybM	1
2321	2vaK5ogCHqQMxDEQBHrjLJZBkTkhnrvRnu6zLgh8Y7zviK8MPHfC	1
2323	2vbw59bZLrY1JCzExwmnwaFLTe5KR6upkCTNvTfSJFpRhYXofGC6	1
2324	2vaAQBHShZqjkLXJiiUK1o1rP6NxwPGV9wNLZpZA2M2VxQmowL7d	1
2327	2vc3gLzevLr4gok7fSgk41jByJUYiiHBGQxETKvYtXkcwjsGXpoW	1
2092	2vazrEenmCmQBPXrv6Wp9eDBerNi39gKGX5wkCsW4sasATpzEeHh	1
2093	2vavnhi8dGawjfE7Sup92FYJNU9AorMKcbwvG1RUg873QDqfnLwA	1
2094	2vbvo5DtEzwDhy3Mv1m9Yv6i6nVfoy7XYU9PrjSHYEHquDgqPDwf	1
2096	2vaQ3GuX6KU1J4Qzc9sqjr19omVMWmMuqC3DPN16PuzD6t5Z6N2h	1
2098	2vawq8qcCLvMfhpbhyt8zTvB2TGzhFfoipH23yS2S3dBycYHwDNQ	1
2101	2vaqq6jZ3S2AsTebpSJYWqNbGkNxnaw4qDCm2rBimq93C6ye5jGB	1
2103	2vaVw9FZsGR8qpg2osJX26UYzYnYnqGJgTiKjZ74drRjkEYYj6ZY	1
2104	2vc21FRoMWoFrsBoG9rcWZjLZ7kvNxCHNcSuPxbuixi3NoNJe9pu	1
2106	2vbSp5UDgjGP33ZMBefqfj8ArEpEfuXKiQ2djAqNTHFqjNmbicxm	1
2108	2vbjWRrVvJwTi25rzDnHowPRSgSXzaUQ83s74mJzGRQXxfuH17tz	1
2116	2vbcgHgMi8EMf8EsKhGgDgXfagbsvGLnFWNjr8khoFHe1zJ5rM77	1
2119	2vasK3RKv1KwqVQD2C1MzWV5FD47mDXb3zo8gczpF4HTGbSgmQo2	1
2122	2vbRLL2GuVaBXbhwQ1VWtF1rQtqq3KyuX1Lt1FUUJrqeE9Ay86Ae	1
2124	2vaYAFJQvKwar5GGDG2KaZZB5Ctp5998Q5EdzMdp5Ld81VCKFgJZ	1
2125	2vbrAo3PYEmwmP8t7S6DW9CHB6X5FqAz4R1JvxB1HQg941Dy1xUg	1
2129	2vaFYpS6mF33jMGhu163oMB9PdP5pT1zpwcwHvcoZ3SpvTHneq9B	1
2136	2vavggtm4oH3LvJ4GZSTd27NCCUATnUaJAHsDjg7avaBYDbyZJJT	1
2138	2vc4zWVib83Y1H6VBR7zARPnGXQv9k1pKycw8mUYqzfZgAm3qEXS	1
2143	2vaJAjLqE4ztJHii6qEwdqAXWq3tDtNW3UCQXWYT4YRgZBdf6gXk	1
2146	2vbEs1kjQgdw7LfdGjijoZ6G2rgft59Bkc1FeqLTmuKUDoiNR9kY	1
2150	2vaML7hGCL1AQEJEZ3UXwhjzEr4LtfxrLtEWk3MmDh4vU1A97VtC	1
2152	2vbrKsPrw6r1fWF8E5rrNPwvqMN2T8UDnGRXWXqEVc8V8JhpkofW	1
2157	2vbHcw7ooDwaFMSLcT34jph2TGo6ZewMbVwKQuvfASnwYV26zfLm	1
2159	2vbfkDQTvvJDQCy6yoNmsBz7Z1pfv1ufLJymuSBoCrbYgGz3f33e	1
2162	2vatku6oF11PvJb2x9z6q3cq2YaCTjpwyqEd5cZQ8wHsYXpB5r2t	1
2165	2vbu2U3nw1bAzo4wFwRyonTTdHVFCS1wyCBFsPhrTCvjrWZ58avq	1
2169	2vb4zejwL5ScWyUeXusqtHvERCrrsbwxrSMp6BY5zWajKccRAS9U	1
2175	2vbrv1eLYaBhc1TcEdAC6fV4DUNWf5v3RTzhfDq15tNB7FPAXMuH	1
2178	2vbFycsZJYVbovSc5MARFkFpv1awetbsTx6PEkyNsbsFbMxegFMb	1
2181	2vayxTf4xtovM6Ye5B8ooy611CPPfRTPwWPQVNaLwRsX7M6nAv18	1
2183	2vc4SeSxxs8GtDQDT4VEsscZrMwBH1RuRDt34kbbGhAH3jrmRYrH	1
2186	2vay4KMgiKdc9vpGC8pZYsrdd9wcEfarAcwx8biFgrxaAZhymuLH	1
2188	2vb8u9nvxS3a9PdwAaSHBuDa1HkwPbgiara71wfeRC9qdV5FC5EF	1
2189	2vaUZuJjAi6diChubeVCJraKgXZBS9pxhJ5P4mLCXDT6XAfCGhuJ	1
2193	2vbQNz6QGocLu69UtepMig8v4DHPGsoqNXkfcmjFMAEpu9Pd8PMc	1
2195	2vavMVr6SUC7KkmNrQ1vAhREHcxN1ER4SpWafdDLYDLG7P9x2qRX	1
2200	2vbhzVhY2oywrd14FSBmt5J76AtS6pj4NJetjZgMURhtyqwieaEa	1
2202	2vbzxp9rscTAKZMRPJdePztGMqjJmEgiWfPETLcEUTZGTcYh3sRM	1
2204	2vadB4r2QGhVpVep9HsemU1ikiXzLoZxwTTvXpYXsZRwYcSoiNe3	1
2207	2vamEyyT65XpSamA8FzUjNv43gtZF8SamdzeXW11ifnkq6Es25u3	1
2208	2vaQ4SMpd89vyqkGmFTmQpMZJBXdP5cCcxvc3eneZjMn3JnZsBsc	1
2211	2vbjvWXnWJVurqoZQKFiUPmvGV8nCzcdz5uofv9tVwGk5YFLUWpg	1
2214	2vapC63mUASYHWNiwpGCnn8Ak79GopbZBy8HHH71DcfYpNX7KhiM	1
2216	2vaR4gJUsjVLpsyHhM8zDEb6T5KHAiPQURTwZ2rzH8DPUq5y8Pdd	1
2217	2vaMXxFGCv8YHHMCFD4NMQ74DPdUgy1xmRRkh7YPw9XHugMQzkpT	1
2220	2vaaFT3VPFEgQWcAPUB5WMdYUz3s7mn7ybutr9nioHaK8S6sLiGT	1
2223	2vaT5adSzpF9GbNZKHxgcBAWS83jnRpYRSNHhCqExkrCi9vg3GcF	1
2227	2vaFf2itSNHaEk1EUfPpBi9dW27EKhHyzGhjuUJeXGPuuxnSxGaH	1
2230	2vbdhy2aoMdAAXNVNV8624hKpb2PmAWuigicTBUDVrm1GBZ5ZA7R	1
2231	2vbcZZrDWUYREpQyWLPHujbUNxMy4hTeHykZ5SwPNcBXQGb3rUKU	1
2234	2vbVPVbAutKkBt8TiGEqRESH9vqwsn1CEVtExnYDmbMJVw92huZy	1
2236	2vaXfAe5Wf8b7GWfgkwuFwvvYhuo58dSLaGsXwjaibCSRfxxy6Bm	1
2241	2vawgRkztZtkZDQ5BSNaT9t7moZ8C9H7v2sQ5iPfJ4h7RW39bxDt	1
2242	2vbGyPHn1BWY2izGL9hGTiTyQGT3QanwjHaGvoRyPb7x7QzyvcqV	1
2244	2vc3C7Z4izLWZYfcd5b7smGVgQ9M4N9qRE9m9s4uwdtsug88zPgN	1
2247	2vaZA36g5W5P2zA8MkurKqCbA31QgEc5w4wMFG8Lddw9gk4ARSJL	1
2248	2vbd2PAhjK19CCcTvYCe2PsdASCJzUXKvJsDWm9pdVM9fsb69yVk	1
2250	2vbrySigvSRKxhJS8NicU54fcB5eVofbAHGc1ehL6nGRDRJHAdDS	1
2257	2vbt1kWPKP1MeCPWVkWV1wfQUpdFHXi5XPs3SpVJqQkX4kwAxtCM	1
2260	2vbncPVERRGNReaD3VALismwbBFjdAu6iUvxmvD1bvwJdAmRzhcK	1
2264	2vbbCasoH5LnA5dWyDC8FgXySqP4E4EV4vcjADn9mmmtya9S1L6t	1
2269	2vaqgBDroUvdA3XNixKZtkNwKppuyRoPEo1higkgsHQMYakucZoA	1
2270	2vbRAsozzRRM9ZuD6ktJ8aMYnsLR7kjZWY2gHR1GLw74JVv8QJnr	1
2276	2vbijXhWWcxgHr1wf46Gr95neXktgRHkJHxpK3WqQdWxjsccLhAw	1
2278	2vapfpxbrhjw9CazoSUYGnRgZu8La4ujvDifA1BkLa7yuNw7cbRw	1
2282	2vagHYTSRwYxx72tY4RjaMbkUQgnbkdr85zVY57UayAeKd6Dd1NP	1
2286	2vazVczBgo9qj2RKKc1AQ3HDBu8Y8KZ1QibksbybzZHAvuQbbbXN	1
2288	2vbyFc2XJWpeNe4Q7L31PAijRdxVdaYgocWcfXRSnk1ZQwrYrk2q	1
2290	2vaS5NLvPeWtyAf5gKvSCE4JgY5P5LaGTfBdcJ3bbxrLjjBHvK1A	1
2296	2vb6gRV2xhptdL19JDME27gYiF42iAebB8w9uGJE4V6JJRmyTjHm	1
2299	2vc4cE7QFUvh5qgyN8D48bMdDSCjbN7Ffxfyri5YodGmcNxqTX85	1
2302	2vaQP8TuYKP6nL9huo4Lz7LBrxgYPfQ4P3u7JHensr9S4yJQwLP8	1
2305	2vam5GHJ57mhJcrnykDyKgvoGRD6FY92W5Qm8H54HtSQupMxyZ6a	1
2307	2vbzjTGV6GX9N3hE1mXKRwir54x38nBthuQJvS3VNqHcRboWPAbB	1
2308	2vbmzhtfe3EjVeEHXxDb2LbBxax8FtLyJbCQjFMh1T6LwuWp2jjr	1
2313	2vbx478AxdZBo5qjjfrDjQgU7AAWpbG2BdTWnhVjptrui7tpcofe	1
2314	2vb7hWWTmSAU51k4PBMagzssGacyd1p1ECto2jkUaYittk5haXBA	1
2316	2vbuRQK7g6Ep2wcBuDqyW8eRW7Q6PG6kovtH78bMrUvyj9DN1TAo	1
2317	2vaGwczbMD4CzHtoL6jeGJm42dezVHpmuAicmqReJRkBJBy2K88p	1
2320	2vbctsCrfY12pvarJS477orT6EcVAmwfKtWmrcHsL2fY8JXcQxNL	1
2326	2vbHW2DJaLXcYjD13D4aKoxU829Gw3DFX6taPtgJhCYgTXFSzFNK	1
2328	2vaEjbsHUzeDpNoSnc7Q7ZvL2hRfiVCLh1P5D91pWo7VMLZdWQV4	1
2329	2vbC4uJFvJvufBcCeEKw4ctqYQ2d1eRDTvWC7jeb9dbjQBSyQ9EH	1
2330	2vaneQ2eJZ2KG9axWQboA1Ey6wXAgcst7YsAZ7uMGaqoRK94Uuv6	1
2331	2vc4AZZej2cXEa8Z5jc7PvonVcYu2TU3cPWWhjfci7xjrkmH1gF4	1
2332	2vbBa7qVeAcfFCwNv7gxiRFFrbH7PvVQRHZDpQVovDc1wP7HuauP	1
2333	2vazmMwkjmKUBvjJXQGyMiiGJPj3wQ7XhW6pbkFJV5HJcGKCSSEr	1
2334	2vbpTPsg9gpG87bkqofaueUJe2oQVQBxx1SVoFpS58uGobwp5pgu	1
2335	2vaJV2YPPqyUCC6CDpH7x53QnUXSd4d6t83hCwZ5zUrovRLTxTSP	1
2341	2vbXer9pf5De8WyKHVRVhY3HpLRMwJCDiBcttfieQiqLoaYMRdbQ	1
2344	2vbLJaaF7kggcVKPHdiEzkNZFBVUjdszh1Gix9Qsdjv1NnPTepLn	1
2347	2vbvtXEGCN6W9MaiCdDXbEsuKT74rpXvJh2Xo4BqqkYazbXtT7uD	1
2349	2vc5n1aoYxurK5YxMNP2n8ypCDCgVJDgEwMp3d2PKuWkR17aZXPQ	1
2350	2vbMESk16Y3u4dGZdku9v7JJerCQEdCkNEgEPoG8gka43Gy7KKvZ	1
2353	2vc2utm8Jv2GNWZ9QXVVLBgPxUKurGCYiJHRxHn8tyE3SvtNQ18p	1
2355	2vbbuQbpLmLQfphQJJ4Fn4yL5jSpTP2JCwTce8MReY84kQDGDz4L	1
2356	2vbnJGGgsPYaW2qT7fS2kdza74vNPNjrjk6hHF8ZzhkDDnVCZPvw	1
2359	2vc5Cn1ZQzmwiNBiwgPGhmWjTMkDx8wWjg7U2YsZo9YDNhTTXHDU	1
2362	2vapFkPoNjcg8NwSU2iqn4FLp2J3f96YLSx64vv8kMP2K1FpQ8D6	1
2365	2vaNn3FjHAbvgVzqNBJhzVq3ADeEXAxCfMwkhpQPjdsziUwugMnG	1
2371	2vaLNZgo2Zmyy9edavoSV8kcgQY5HLUBCMRw9dfvJuEq81L3DGTM	1
2376	2vanbFR1fufBfP3H4Bs4MQvijbPqN4CYRe42G3jsSENWKRt4kwSr	1
2377	2vbi7ChcJZX7zxP9ueBYS9sXiLiapbTPjaZtTRi64HVYttzvJSa3	1
2380	2vaVcofYrPDyTEgin4j1iD1n9zyZ3sNAL4Xk8QkBhDeHcMe521gB	1
2384	2vb1wc1xKZzkD7qPqNtS7obaeLmof6DNE4zvgigSFAxQNT4AZPPw	1
2386	2vaHfKs9pD9CX4AFZeHChSeToiYsGqfZ7Tqjh8Y3GPUAYrRBoy7B	1
2389	2vbhu8tSdTdiw8N9MbSKKS1BRix5Y24cHeLx5vk6sK6g5VRhZ8H1	1
2393	2vaDBBUsCzhFPAoQLHSeUENX3idry1trMHUWpTZWu73UvMVLGQZk	1
2399	2vbFr94Wwrf2wpu5uGmHT1mUwNJmFrTTpi8qrVy9afjwDp11zAmL	1
2401	2vasA53QX3SkSBuuxhxSwCDLHdjyYS3QHHervdcxmf8h2x2HNaMJ	1
2404	2vbVYyVEU4KmbyCvqscpAAc1fYFZYU7ewPhzJG8LzP7rXouAFxh4	1
2410	2vbABkyiVzbU3WTqBQvUwAnhf5HZwfpYJou6GMHVmczREkv1nvYz	1
2413	2vaEkq8pM2rzBAHbmHaLYQttFJ8mpEozJeugKbLAGyc6dbquM5Zt	1
2416	2vaCaasVyKcqeXfVL87FSkfexmMgFtfgHyd2cgfp7X4fEJQec5bU	1
2420	2vb5H3M7CyDw3HmWFSQE2zvvwGRa25VjmLRGv6s2aaEcpqfZXRfD	1
2422	2vb74fUUAYWaZK7diovKvjhfFuKU4VnHqVxMwFNFvVu9nzZUiM4V	1
2425	2vbr9zDbumP9iBaCtVNYQzfbry4hgKBu6kjW4tCFLFzX6mFfduc9	1
2426	2vbpxxdahZ43c84ZhCqc4DwrPiLbkhGk1CY4Zaxjop5WCKhrXeon	1
2427	2vbGurbmUDuTFCnfE6q4sBnNz2LTTERMX4rJMNSaTAAA4K9qKPyh	1
2430	2vboPKWuZmXLtxt8qzUEaocGzCcKqvfQBDpqDR5rnTecWLBPDgVq	1
2432	2vap3H7CXQVLeTkC2cDdwieAR8Dt6QmK1hwGxPgMgL87e6vwSLC2	1
2434	2vavKwyCvK1xiqgPapfaSSLMPHChzoxQ9rSVndkXkbjf4DRnEfVX	1
2435	2vaRyfJwR1hNhaJDNYDk8ybhoUAoTKvEy3Fc1hTb9PE5nEvoxkgk	1
2438	2vbxHkFQmL3kH6dwGB9DpWDxYBkrvCW9HhVYdTNBH4fEbnKe36J3	1
2441	2vagyzG8pTPh18xqvMeJ12ax6zDzwo5dRQxV4Bz2V6fgUy7TMQok	1
2446	2vbJBM3WDSmK5VBvZ529AmNu5m9GjKLc14j7B9cecHVAP6p54kf7	1
2447	2vaY6Kb1YdmV9dT4Je6GsLJmeyCpsfn1MxgddDQwLmUds3GHLE5R	1
2452	2vaGY48ymahWy13YbADpiijMxtJJ3yXRqgT85WPViZe11t4KTQQH	1
2453	2vazTkNWpQpUme3hENdELDseRCNaW3moQVtH64Vfy1wEwfm7ppyA	1
2455	2vbwu1ZGDcGFBpHrhi4QrZAezarJQpySJ3Gr4nQnPQeCv74b5XQy	1
2457	2vatTo7g3kuUHPYxAPB6e6FrdJMazyS1gtkVawGuHeYZp9LbezYi	1
2459	2vc4w4Y9NxvRzR6yinKm4uq53syrC8tqf6a4URTnfqWqRvGZLy3K	1
2460	2vauRQ84LPs4uCbCe2prHLyeWH8sAKTeXFz6HTGw4wBACZjdqULv	1
2463	2vag9SS6Q84cnXC6X9i7qMekHXC3A5iFNpXUjECwjbrfqC1VfGNV	1
2464	2vbw347sWW17QYnZ1VLMHxrhvHyR1RMati2xraAjktQaGrVLkqvm	1
2467	2vaBMG7GE5K5xEzupbuXrMBkJrxp9ciJESvGZDo4r77qEHKyktaU	1
2470	2vbECzTRCjNpzs2M98FahBC7BMrk6yP2keUMpfBxtwb9R7G4k1gc	1
2473	2vbVvmcBQJAtupBoRJmXZYXD8sJBRqBEdW88ZXWfGWhWmiKSheu1	1
2475	2vancP5VNUhSJRnhqxci3yCgKvoBh2YRsMiTq8NFwthTkihRn7bR	1
2487	2vbhmcxdCN4EKBw6KCw2SZFYj2DhCyrW9wzp23jhVcwwEiK71eix	1
2489	2vaMGbp3gD6vDPwowrtrr94Fsjh1hpHVTyyzq2ch6JwZcYqHRaeR	1
2492	2vaJM5hH2FwPTBdUUF3pPsFrkvMZcCk2ZyPHAiveVu3EipeNKA1U	1
2495	2vayAJKVgHA7eMqvFTZdGFJ4Z1xMRZwVjGrrYFsH6T2YFyXjBfcq	1
2496	2vbQVDgcDfmNE2VsvhBFfpuMUEGqji3Y8yxuZjjH29CPe8mKqQae	1
2499	2vajzLVA1GLxtux8LJTEQ3wTLwcv2jpzK8V7F4avsh86pq3DcZ1F	1
2502	2vb15nbHJ1oEUxb2BUMhd8sb7XniEiyMPipvfzRXYFHoEc1oQFoS	1
2505	2vc1zkVsJsgDiHgdwnzjLYk2VMS4d2PJfiuq34tGZUQQa5ntPV7X	1
2508	2vb8CCEHagGAGp17XdYMGdWre5VzdntwcvigBzsXbQUu6phKeuEZ	1
2514	2vaZFBNHjhhuAM3pfXL51RjB7zLDJBMweHjLQrSgGkpp9B6drCGM	1
2517	2vaLM5dgG5Dsuj2KLiH2Jp4qDEPJe5PnM7MtRp8YavdTQtEQdUei	1
2520	2vbmNVwdp4tP1s5mvMQorqWXttK3JxM719ijeLTbwr2fVde5Yy8T	1
2523	2vc2AyNNHFbgCeaSBpuU2sx2rtQKQ3DHhpvWMyUqnBbt5f15pw1D	1
2525	2vaUHigqpRuxQudEBPWfycKmAXDyB3QnkL9s24f93NBjcYpJyHSy	1
2526	2vb9g5MYoMPttze4hYj1wCtUr45XTufxhjBJpYZkhLji3NuJfZA7	1
2528	2vaRESxpGAvzRftChJdbpX5pa6SxLcKgktRZ3GtmvaqGrjAdwiAb	1
2529	2vaFyffs3uKJ1NC5xU4UBQ7uhfQZds33CQgHckcEdAMu1mhiyGKN	1
2539	2vaeTWZ8SkScCJzJGfivWq7ths8harEpapHxviW1ZEB8ogrfb6hh	1
2542	2vbWMgUD9pgs6oMgMiaSUsMvZiqE9f4MWbHqPeKfpHpTJcNEfXrh	1
2545	2vaTPnvEiQmdvXqfmrXTScgxZ6pPAfsDzDu3m2Lsj5JTj8bZHuTb	1
2548	2vb75eR7YVZuSwKtr7y29oN2xvJxXFaovZSLNHKKF8A7DaKB6dFW	1
2555	2vbgKBce6QxyrwGhgVUJ4CcRvmtDryGRNHy8F7tbrfJEZjPb6fnG	1
2558	2vaExQKNXCHGjVzRFpMDmqzMhGsTAWh5jbZ239V7u6d6Z8VvNJic	1
2563	2vb1KfwzWPdBR7Jw3kmfmH4Bgp4Di1wH47PrQyhm8Fgz2LayLtn3	1
2569	2vaZ318K2pKuNPSyNU1N2dDUTFFMXpM5ABA52Vb6WRmJYnFkVFhK	1
2572	2vaU4JpT41YoFUfCaV1W23gFFPYgDcUz1pA74wJosTCSChHiVK7a	1
2578	2vaViHZ1r4q5YNqGaJY4Usd2Z9ufdv1efgGdbFoXZmWvuv5xJz36	1
2580	2vaHe2KW41t2nwP5ZjBKdmaN999cGiVhdUZgkLMbbNg7C3Mg6A5T	1
2581	2vbPypZYD7ZqZ2ziDUmwojJ8ASPhwzw9KgAxLsx8B9DssGnA4T6S	1
2584	2vaRCUquFYkcZB2ibv96tBWdUjfdq4tzG5xycbY8KJTTtG6UC3W7	1
2587	2vbgHrFtZpeQ26cw8YyvSCynqekaewXAEwJ8zrPATjhK4D3VaheX	1
2593	2vbRkfMrUbeKZBeu1ArebiemUQSomhvnyV7WgYa3SRVE8eAkKGwu	1
2598	2vb9kbWgPE7fXz1Xy7Ycks6E1PA6Yy23WMNicQRv173UwGNNCGcf	1
2601	2vbGrA8S4Pb88nwBVRqw7fq3DLsaLtthJjKzeiKvaTCVUVzdbxH9	1
2606	2vaFH7n9xhNy7VZ5JsZ7W7FerAvmahhdRTWpDiVYaA9TDLfhCpDd	1
2608	2vbmZsV4USfDAbmLBhYq8g9XTL3CC5MNeSWEDUKnN5GsMHL8J5SF	1
2611	2vbyVgyXDRU9B5c3ZDrHAhXwZp4mnKjxkUWCcukH2BKMJp3MPm2P	1
2336	2vatGbc6pYXMfnsYjFBEL1ZHa6LbSNmwp2bAkvVLuWWytNqGC7zz	1
2338	2vadzBpJZ785ne2hwcwgKtnGEN5nLQbNRkARKKQVUdJjjXMj36x4	1
2342	2vai6KQuHCHXc81wv9xQXptmAmsnsGtguLc6gHr4eRujLGDPRioc	1
2346	2vbGAST1WhjRqrUvrWrD6qx54bdcE7jHkuxnYdkA2SsqhJz6qrP7	1
2351	2vbapvHVLYjhKDm9hdXRsNDtb33JMdzJgM6S9vBW8E6VSo7QSDDD	1
2354	2vazd5sZiy65usgwsmn9BpAuQCQHUnuwX1skEaXgbx8jyF2YTZYM	1
2364	2vapbsC4ia1aZk5PRoR2hfzvTPxrK1qW2sLhgxR6HyvaFrNtiWdT	1
2368	2vaotigZhXf359kGEqBoxVToQ8iCWaTKnRpYos8jmfaZRFoGMYJN	1
2369	2vbknC65zeEpBXzbeP1zVphmf99EZJwFJnYgzaQZ8hcnUko5bfDb	1
2374	2vatXgKvS5G8LxpfmY7P6RMt4txYaqjBbDiupUYVNpC1NefyBFMZ	1
2375	2vazZLozPzEkGepFGfvGnBgdmDHB6hGqExC1bwvngHmfKkykhxBj	1
2379	2vaqKwZNvChurWa83yGcLxdM4cBm6vwusoKuZosebVvX989aLcAS	1
2381	2vaSwKFAaEii2zs2aFwNZgp1isyZtJ2GKr7kwzvyrkHhFykizmZh	1
2383	2vaSdwJhjtHEfZpHsC35JW6BD6NAyoaGoWC1LZV5eygb64H7rEZa	1
2388	2vadNMEJhfyQeCQ31Ws8NN4554v5wUrhX3Atd4VZUeAGZet1vWZ6	1
2394	2vbHHeQCkQ55F1sSURSvZBPHoVgTLwK2nrCMDsDEcqidE5t5XQEk	1
2396	2vaFdK21wH95PmA1zSxjwiVPzHHRV1hG3q8fwumyaDcbBa3EmwkA	1
2397	2vbajQRzBLvD2UG4LSSv8gwunstQxznHYZhyHwAgcr2LVK4eXC2c	1
2398	2vaM6L6NW9WKCDKCfgaYv1qBzmeuEDgAC7njF5J1jhbFben7vrY4	1
2406	2vaG5pN6B6vDF9bAJKL1Fnvn4sQGttgt3WUfMc8wpJer1pyv3p6f	1
2411	2vaXvDhnt6Uu2g8s6R9k15SJsmNEqrE5dgWUT24qhraQEoHkaAx1	1
2414	2vb1BW2VBMsMsUZFnkDdAaN1qUcmuMjVCECw7NSbjvHhDQuSd4Jy	1
2417	2vacXF6wJgasQCqWaFEH4mCMWLXGiqHEEmAcFvo4fiLKUbjVbv6X	1
2419	2vaq5iHdLnSxZcynKFwmeaciJWrp2RZ8dKZ3uTCrofBQLnpkY5AA	1
2421	2vaijsjRzzYHQ97NZQxSrvipsF7HDvLqrsV3PJuRpPMxqecHFviP	1
2424	2vaXdm98BgyS5rq7Zn5mBySx3wUdDvcpSYvhgFiyqYp4L3MNzxFz	1
2429	2vaPCA3vs1g3jw9ZR74ySDqj66gwmEbnuMB1mtSnRezkaDRD6GtE	1
2436	2vaZPsP5Js4UEcp8AcCYAb89yPTADKE6AegrPvNCrPFA8fTLTBLK	1
2437	2vbvGvrcGhB1hYJ2BQw8pVkwffD42iw6Woz5ibqHsYYahkhMca9C	1
2440	2vap58RtFKrsgmHRmKfLz2P3Mz4Y1zrs7dv1t4imvF9KB9P3ZccA	1
2442	2vbhGY1i2JoUckSyLp7NHnTvxB2BJJtB2fnBvYjWwanE59RCJbvd	1
2450	2vaJZFeeCZsXHZGTefaasw1dwv2pKerpZcZgN4GKigwanWAev2uE	1
2469	2vbkVdA7KZgfUFS7c32VeWNPivETQ3zzimjF2YvMwY1YVeu7DX89	1
2471	2vc4oBE9NJVHMsTxRTACZmJDyv6LG3dNm5N5DC5Zy7qiqm5gup9f	1
2472	2vaCbXGbgr7KxqPgHnoN2fp4avxs45yShN1UEpAh9JX8U77ydkc6	1
2474	2vbkXXaVkRN9v8PpVKd1zvfFa6uEZRZXTgbfbzNpsdnUM376QsZN	1
2477	2vaoEDQAN2mBE3Hb7wVBkZ5wSqDh5LRLgXB5rPWo1yRFH57VaFgW	1
2478	2vbJSu9pgsZwDsJTgL2NFoK3jB3MeDKbKwsUo4odGinPkeQXR8HF	1
2480	2vbUXJwsUCazg2GXEXVztnyGTRh3LbLe488C4CLH1Hr527Uf5V8S	1
2482	2vbnU1bvfD58URmT4Yhe2jnDjV4UT99K2URUpM7iGDGL2augYbkd	1
2484	2vaALrqykjCo6E9BdEwmA9x5TNiyq9F3ee7PCiiCnD7LSQjuzFDc	1
2485	2vbyM4fwT2tngrtcazpmY2ztE6Q13ijpEri7jVxQvkcQELpVejRW	1
2488	2vapuoHH3vc48fb1ss8egntmsH8C47apRh2rYXgtkw8fSFpEzpSh	1
2490	2vbJhAVtERnXVwFV3EyL8Q7rRJtEcCYSKdpj8rUt8PUsavUX9sVf	1
2493	2vaoUJCxaeTgLE3TUkwc3f1CgfaiEi6wfiiHSQqogAToth2kkMjc	1
2497	2vaR5vPArAEwWtnB1VhTNv4zsDcGauqC6G4dzost194wr3K62Bap	1
2500	2vaf8xh2kPDsPQ1kBcCP2KKUqsB1Ce8StLwqukEXScYFD6LoVQUP	1
2503	2varnHjH6BrpSjRkNg8kAZW7pvC7k7ZeBNL6WcLKeZz45XAWQpz7	1
2511	2vbVdoqtft4LEbKkAeUmsxtxz5ZVtxx13Fyi6kuczB3ySwHs2goP	1
2512	2vavDqFtWhkBZ7HKe78hvF3J6PRDA9c7tjAsQV2kLZJZYUmjnb28	1
2515	2vb5TmSbD8Ci2CPNRzG9kGZJPRnyXYyuDcX2YpEfV1tGkxUj7J33	1
2518	2vauhBoboA9fon6ANusvwDMSRG9U8ubTvGkYnY4BL9PgnPcSvXdx	1
2521	2vaAWgUuWCxw2ozgDiuGKehnvGqqMkEDDdaRxMDJ2wk5WkGFn84U	1
2524	2vbmVzW8UXRs9UFEGmF3GYuSp8y5sxa7xstw1iRwr7aLXWSFe1DM	1
2527	2vat5sg3HT3v8p6MkokCK8adZtHbBVH4oMj1R1hSbEYmJGMpQuZ4	1
2531	2vaPQNBe9GewbyLMrYiJGDAUCsCtAR1dUwuHjetaG3dEE2atqatG	1
2532	2vaX6TTGyVwo9pRvFLAkisQezcfr7NHSoMFGXtTFhFYHyfuZG3WS	1
2534	2vboxpxhkCw5TsJe4nRL8ZZLYdJKtXSJmDFgHucTfnau3fqYjhGH	1
2535	2vbxGTdfp6sPCST36cZRtwz8CAq7BMLeRpL2AVS2x4B19JEvTjPx	1
2537	2vaMoNQ87oYGEifsjDS4BQxd6aU6XPQtN2nUT82cup6Py5zJgFh8	1
2538	2vbReNvmVKRzLYtSNNWrLit3PTNQgAYRpyULQYSRyy4Z2pcxFBVN	1
2541	2vbXNFTshk4PAjk3TguX35EHD8b1nZUtVTmp9aXcUUcKy5LMq6kp	1
2544	2vc49jr6KRHKYMn52mr5NUwU4f1xqhEoXcXPdASy1BkyBsSL5gaS	1
2547	2vbgsZjatXQnKwrSXt52VukMFKjK4nQHvPUYrz4kxeugPHrfpGiL	1
2550	2vas1MAuadaKeMnbd8HzQ2SsYxgEf94Ng8v3St7wzQKyyhbw9ngb	1
2553	2vbuHToD2wXh3bShPiMnEtAxRHLZfwDS3n7ty8wuCY4wznb2sbB2	1
2554	2vafcEzVC6peemqFR6SVydjbHphNLTanoajdUBLu3AAzDbEnq3kA	1
2557	2vbguyykMWXce5ufzkjvGzUGQzjc11vQnUoJwTMhVK3EQYdJpiAx	1
2560	2vbwtNFPgCgk9vNw7Cd6HtJr3V7BmztioTQS7kXbgByNe5GKmJ1Y	1
2562	2vbwf3eGF9Mdbz8wAap3TYmAmoMdNroShWEfDTyQjuYGEWNvVKcT	1
2565	2vaRdR4WDa9XFf4AQBZAjWaDWBMof3b5VKpGKPizNnkaZHmMZjFQ	1
2568	2vbZoamRWuRvSMs6HpWs1RJGAXZDtRrJdNVYjiYx4joTokc1vRmK	1
2571	2vbcpngAgEFKww5HUaBjEMr6mkq5DiAfNrgriV5qdtZzyFU3gCLp	1
2574	2vawFj4xV52EZ9D7kNZWprgXu8qMeNGPhmeSigsWvCxJpnb3xxwG	1
2577	2vbBmV6Kcaadknc9aNVWgpbe8nWcPKUbhZPoC3XQNZKSNhbzgsJJ	1
2583	2vbcSXAje46uHsVFX9oDLKJHjHke9dd8GfZwBXqmow3VxXHQKkJJ	1
2586	2vbe9gXG1waWpBckdThpwXrGqqhknSJZrgj9G4eF5z6JtZYxrEis	1
2589	2vaBHdLVJBH1MvYV5s3WEUxNatW4VLaR6x4R9sJwEvbwwypfFeEE	1
2592	2vaL4bS5Vr2e4Dgf7Zw5Rw3t8JX64sbp2p2r5hEAh3aD6nye1k2t	1
2595	2vbWNeCbD1KMoQiF6fy6YQbJBwvxGty4Ba4XbGSCEumYNgRCjFQn	1
2596	2vbgZHujn7h66vymiKJhC69Z7D5v1PjuWvmzyTATrqqdwcjrftvm	1
2599	2vbzxVg3ZhyJvY6bvstpjVFJK6EVBg2rWVuWLEE8wRwbokkRiQ5D	1
2602	2vb7mWL2H5Z4nMUymZdweyWpRUiivjfXXb9bxBoZ41Yn6mNhQemK	1
2604	2vbgfxH3LJ1bT2qwECUP7VWhdp49Wa1YGex2FVD8gxyjeZXJNtaT	1
2609	2vbdchkYkH3XPKY19geTmVvYZiywUFwP3DiYnD84xT8ugqZrZFjj	1
2337	2vbcfB5k1hmKdEdn3RKN2QzsH251TFf8udum7HRsG5GkyJnzj9m8	1
2339	2vaJA8CBrLmikZjoKH9CdQ85YpwYAuSzXetRVSKzUCnSGB99yh7G	1
2340	2vbDVdubQhMLuUtAvHp9BYJ5Cf7cQhcRj9nWQtRmKoikvJYmfMyg	1
2343	2vc4RGWEj1reN2WtYvzKzdN6wDn1to32SADJUH2PFV6SEv6Xmrzf	1
2345	2vc22hUXxnRdGNmgaaq1wgWv7bG5ANYvmyWFvYUwjYTbwrG8xA4t	1
2348	2vbLXPBft6u2SaqVZJMzcuvq44ayo3GpKwyZ5E8kfXZsCHP6YTMx	1
2352	2vbFEh7vHVxPsub4GjxsQ648z5Ytt65kHuDUKme832JUUD7NcnsR	1
2357	2vbWVB9ttnQMvjreAT264GUUUyQuD3v4wpxSaAvGYt9Phg9L3DA5	1
2358	2vbZ8Wj7VdDksixnf2M1bbqAGGnYs2EYxFx4EsAVfMC1VXcsorA6	1
2360	2vbNenMcJR1eExswfVKvwcSv4cukcVj9NvdrqbWEdcXUN6R7RJDW	1
2361	2vaQ2Xf1kUBEBybpS9z7yKXU2CNmJBvQZLcEKbDyZncdfCxS4Thd	1
2363	2vbNvJV91Azkb2MLXPAfkRtRwdf7tELQm7KdhtHYiuqbk97PrvT7	1
2366	2vbxmFiGf8TNuEc18hmVk3BaN6VFJgTUQwg19A4F5Waag2oPv1C6	1
2367	2vaqnLepxB7gnemtCWtkQvjV9N8CUbBKbKcgUx6i25rTGtH9o4FH	1
2370	2vaFJqGWLk9kn2di7TGMzSab8YHGVuDr6JNWn6Gbbd58U7jn3V4C	1
2372	2vbvDDHcLfM83GgH3S3JTjYUNhmMMwByD44UhR9WaVBY8eu1Sn2e	1
2373	2vbbgA2VD9CX2cArdusu7tngpb2rj3SESVREUdVwZ3vrGNJEqmj3	1
2378	2vbozN2WtbW4TD46mFn5BHpHmvst5sdvyek4QzJmfhmkTeJBDbrC	1
2382	2vbp1HnfmKaCDtxVJCaXe63KPtWrMpgY6c2swXo8X75aicVGVrrM	1
2385	2vbUfBt6GZjt6YSpTqyCnjfHodnjhoDr5V1rGEfY6yrCunbPn2Hs	1
2387	2vbgKRSMo48xmeAxZjEJojSjGJRWvTGPSxzmXgomurRKJB4QQxwp	1
2390	2vbCRB9dyc94xrkiLvAkkh85C1hdH9hXLy9uPEzd3v1E7QY83i6c	1
2391	2vaArRkmXPduZdnj5mKEySpqLXJQgxUjqjoz8nC6FrRL9ithHX93	1
2392	2vayQPrguuJmPgBDtyh5KCCFaBb3mnEqiGgnA76WpeGw1U39X8Zq	1
2395	2vbtkfeaWpmF8jMP5AvYSMKXstWWDYAS6MbVxYYw2F6fYbpkhpqT	1
2400	2vbDTePYuuz12Rs53pSYoANompyfYAogxvUGGByA4nASpdR74hYP	1
2402	2vbhKGpCpT9Qncu2o33X42LDRq2dVPULXey4wL7jHkwEqzAk4eeF	1
2403	2vazRHfQh8pmYyLvFXqzEqvkHsxJWEpPdTT8af6QpnSGHyikj7W6	1
2405	2vas6BXHrhGsY5cxRy8w7Hv1GbTHyNEQUEHrJ6ngHHGt9YXrUg63	1
2407	2vayM786a2piN1pKdogzq6uprae7NgSdvBAkxwCaBdTRLb6YJ6bj	1
2408	2vaFBcv3DhvJYaBqJJGyvB7rW6JvgiPaTtk7t82yqntoCor8GLSD	1
2409	2vbaw5FnHEdJtHFtFduSB3MKFn2S4EB6GZc6cjfDuQuioyP4zuo9	1
2412	2vaAv3wKF1qLwpTQzWvMdTV7qxhavpBX7aSTLnceLgD3htZSDLuM	1
2415	2vayLZXfH3o2TTcGBfNZJ1KYJ8LRmna2Ccb3CAfvp7LujaXGNQYE	1
2418	2vaGHu5vMyaULWhb4XduALyKb4DB3vRRKfFeFiN8CTgunWbQpete	1
2423	2vaX3MxmqCrzQvpbtAcwKvFGNBrYxeztegydtTzhwrSgY67ggy2G	1
2428	2vb2Gq7LQZenPddscaBEW3rKZkeQjjdkAzBXddjkJYU91nqk9r2s	1
2431	2vatxKYkFegvcKEeGy7hD3UtoANewy5yxSWwd4Zgk7w5g7LZqkvt	1
2433	2vbCisqwLYvdCzRGzseKt9XuVxJSkoJSSwhcdPTbBp52ZxtHas1d	1
2439	2vaeqwCEV146uUPxJ8gPqXuF8HEKXBQeX1MH3FarpE1U9EXew5AD	1
2443	2vbKeA3WhZQDBSfYzrKtw1YYu3G1ES5dcjyhayQHcZiNZ5CzVuno	1
2444	2vc2gKyw3fkcexBCCdJ2KejEBEDFEJDjxkciZ3A5pLfcMRueQoJy	1
2445	2vapvFomc1FoN8o9EpVYuqvyd3NcEVB6c5xBjTYEF81P7WF2ybQS	1
2448	2vbY4TgACex8hp4ATq5LXH86gF7TZpK7ianr9Ffrk6Sh1rxD1PR4	1
2449	2vbMykhn19mCHcoj4kTdAT46Bmaxf8ciwGGQbX2nNqMWYa2qTB1V	1
2451	2vbPuUUSU1qF3HQLkUj4YE75byfP8JckuXTsqfdfQaos1CNDfL1w	1
2454	2vaFudyiiKQBzoWJGbywCW1ZYQEob5QcdjTZ1iP6ivBhe4Jh79Rm	1
2456	2vaBm5iT6ZEvAYoLPj4w35gNZSZRif2E8tkdnJLwDnQnqbAM2EYs	1
2458	2vaaZJsUBj7jytSed7HzQsifqRChFfW7ivSfFH8BJ7HEGLNxyvS7	1
2461	2vaVKv4Q3qgy2JfxwiDKTRwL8idKbqBJxkbNc4WmaGoDuQaKZDX4	1
2462	2vaGdkbeTgh5UWGnzdLUa4uiJPbfrm313ekNLm6veSorUiKjhjkm	1
2465	2varrgeyVqbsfzVTt7iGtRUFQugi758BsM2FPjwQtRX6BuGmiyuz	1
2466	2vbYefrD7cpEkDt4qzCkqBMBJo6J7gHF9NvjKkV1fG91z1L92Zp9	1
2468	2vbiQhTxS91ueQxPVw1CqdU12ePxj29z3Q3uYi6XQWRGJQ8frxx7	1
2476	2vakpsosTL8xZHSeHP67Y9x6YXHSELBsE9dacGXYhKY9iZMdebqr	1
2479	2vbUqWwBjCMX31MQ7dUMvMRrNxCDAFHT8VrvDA54UCPboAjvynK9	1
2481	2vc31wdJxmec3XJbUx3CgGDrMvuf14eNmnV9j6eY7FJWnAv4G1kh	1
2483	2vafvqw8XcGTsj3W1LyBJPDNtyBoCtCQwPVGZrVqXy7qaQ4d2Evv	1
2486	2vbtMJG5uRYWVrsTXASynCEgbaoSb1sYJKDTmD2UTLytN4nXZYpH	1
2491	2vbAWBaJSV1JVzaqE3hKNNdCgjRVYz3p2VVmnsghQ7LzPYCk1HFq	1
2494	2vb25dQNy3U7u7uMDCXJiw6KZtt8FTRq4GFSeF5JDGvkaqRaLUjG	1
2498	2vaUuY2Mvt24zk3RnBhKkD5X3h5P1ij8x4ZWQpWasYNrc3rcMw1a	1
2501	2vaEaZ2GFu4NYAL6tb3jr7xg6xkRf497iEAAUH5P6K5eYizDAaYC	1
2504	2vaF7JhwJWt1vMcMxDzSsCxm3jexbwP35BXW2SUQhq2JHbpuhQK2	1
2506	2vaE4Sae7wS55TT5iimYtmNAzStJr1miLMFEFnTsF2ogYPhARWmb	1
2507	2vbt2GUUWJCJmKfYZJWXS4QVsK87ykWTfrRWk3hCTw43VdqoMF2f	1
2509	2vbY9GhrPSWUz3tYup7dv5F9GZKscd7odyDVntfq3ixP929kBKnd	1
2510	2vbk6FKDQzvr3qBEcKmDWRt68tCiAxtu3Ad5enG1tpSHC6uMp61D	1
2513	2vbxhBfWSLKBtEdovf2fGDqt51oXQZ3ejuDWw9VfnJjabBL3LBmB	1
2516	2vac6qszs8aSoyYWfDs6pcibZpvN7ERD87TJz5nHF99ULi2bA5tg	1
2519	2vadT8LmMKyyD3YBjCbc9HHyDvJ91Aw6P5JYzjNkzsoKjhDnPVL3	1
2522	2vbb15v2bZ3sx8f9u7FZioo5qTMkzVTnFvZ72nYapRK3Ztw2FE4J	1
2530	2vaTPo3rRmKYzE1pQrDen9cgVwZzFqqCwKnwSWGEwBBbbb6Ac4D7	1
2533	2vbADgPWTF6Du1ub3pP7QsFUxqCPvrQHSvSJv6mNtDTVudajwRCC	1
2536	2vbSRjxFg7yFv3b9dpmZiSPJarDJfJLcGwGxK64nmgo1WXLgNSLM	1
2540	2vaEzsYNy3qiy58aHTnE1faYwdaLhKPbsYX3JiHZqzdELn5bxzg9	1
2543	2vbCMH9YPZjBcJoNyAfq5ZR1B7gedjHgEuhDU2TeDdPAePEVqiEU	1
2546	2vbg5zp8HFMeehbMVwZN8ZhJW7a5ezmy6AQs3ytjHh8hgQci9Vtt	1
2549	2vc1HLPaKJSdyb2NixSTkJMES6xBDgmaFJDn1sGDVSoQKSzxAfac	1
2551	2vbihNXmzFhZRQWDhUYqUpMqe5xQv6S1PTkKP3J1iDeFP1KEHmWT	1
2552	2vaUk7rUmm6f163XmUmoJDJ8fGFghfWbWfaDgtuVVoE7b8dmcCqJ	1
2556	2vaX9u9CesJLkp9QBU6fxcWVCW37WJyNib7MRRzBBKnofAzbLpWM	1
2559	2vbBdT1pgrtudEsYpPx7nYRJyfiYE2P2vzWWzxgL4ca6EhK1UKtd	1
2561	2vaoLgMqoDSvvFd16BG5hFRxGHMJuJLmGQnj9nDjKDUPHPRrkB9i	1
2564	2vaERdX9CTHwVATr6x9aJMxKB4n3sXSMfCUMzpqUG46PWb9KFwcC	1
2566	2vby3dUZtzWM7DvemAoqzHWhTbK8X5LZkL8GPQqT1HsvqkoRx1CK	1
2567	2vb8Pxa9FKURaQeUNV1TB7S6UZ5FWYxEV6FhRQoN6YsTB7CRRtWF	1
2570	2vaq9AtKcU3mMahcd7oAijpxMkzxAbRkXCMyzYp2rtgzSgziMpWe	1
2573	2varjb7ffXhFZn3qdEt8Zz11VJnogMBc7c3wWLmb6sLtjH7LTMCn	1
2575	2vb6cYsGBNF8sGq8BAxieRbKhRpkNcGpJN4CgdGkth7CXkghhD2t	1
2576	2vbmpPsdgx426HzpQdanoQ5eCjnVreaaNgLrxhB72Wa2Ww7kQdTY	1
2579	2vbSdUWdrpNLoTCB8RAW4ZkLDDMfSY1wEcsYDmwEARjeJXfeshUj	1
2582	2vbDNn5ownWzrCBv5bvK3B6J17ZWPBuM95TPdYnicUzzQrNFf9tC	1
2585	2vbfoSJxwCmBtz3vX8LidjbhuFj3HvrT4sdVaKsc4cBogsVj98LK	1
2588	2vb9rnfZZ2WcbiC1uetBA7eoUBK1pWwXVLC2ovHcPbdLHEQAgjwM	1
2590	2vbH2wNTTfUUV5LJpZjwWYtGM44Whz8HTeCHS7f1rR37gAU5AHtq	1
2591	2vaxoi9quGZH7PAvucB3imwcRoBrfez477CRYjWtTXcd4R6Eo98m	1
2594	2vbWdJPyFDXvBuSoT7kmPkEZfFforKDkdS3kiqcmaXVr7ChWw7ok	1
2597	2vafLjqu5HcpA9PswU1z229Dt9jWrbA9Zko1eNSmPib235BDJsmi	1
2600	2vbcDPGpusuRYWykEbcrjdV841qtcLYXFuyH8NAqSb3DsPVNscD8	1
2603	2vc2LChGoTsFJhdKL7cbCNCN3trUxhVxCQBWv1wpv6bpWHGFL2UF	1
2605	2vaEZDgg7sVPcLdmNB98mLNsRCVFqdCaRYtfbnCUbGNZGSdvFgzC	1
2607	2vb5BQpvfsubacVHLhmBQuhCKkUZW7tGRojWMi6VuKhj6jFT1Fvp	1
2610	2vbRpF5ZG748NheGtXdeWvRDrnuS5Teic3KCV4UyYHW5QqQyRvvN	1
2612	2vbRYuFzW3zwNpttsnt22dSTWR2aXh43D67XbXK4ooasQDk2nPjU	1
2613	2vakNJuqsm5kLSA97wXiuRgZSQBwqoV6xQQNr65kNxyV8iJhtbjF	1
2614	2vaK5173brSzyyhu8X7aTc9mLF8jpFbQB58wvMrfaQFFGwYjTnnD	1
2615	2vaKP6P9chVtZ4a2PCaSuhUDUxRFGTDk1659nUnpVZ5cBVNjhkEX	1
2616	2vbtrJTza4FVPhsAYdhwFfSfiEd4cphsFY2ndSbA2wzhik86m3zy	1
2617	2vbXnHQNf3LUMQvo7XXL1CA5ABg9EcoYSfPMejhiAZ2UdeVDVQar	1
2618	2vayCbHot7vq634gZDCz9VK1mGyP4kgBiXZmrFhwp9Gtuds4MGNi	1
2619	2vaXodS1S6knirxARSAx6CrWh2EegkF8Ejvknt8zA7N3GpwQRShQ	1
2620	2vbzvE2tAGK7tj4bjCXWL9JWPPWSF3rhHJZYTa5ERNAE8BCvpNze	1
2621	2vaRDWGL3QbPSPMLBuTnV2TUeKVe7PTRAwfdZAnLqzhsqJcZPgEe	1
2622	2vaKXoeCECTRnuo2ErGmYybYooxnrk5xA5qZTVK1zpxpSPsRtaRf	1
2623	2vbv7emq7SQZBAjcWTjPp3L2sLRFBBHwEmPnhqitvHdRYstnKjNd	1
2624	2vb55oLoqj4qFTX2Wdkr7FG4qugX3PLfrqCufyaaxg3uUBGhw9Fp	1
2625	2vbuqHRc7V2W5GaiotkEQuPSRScScthtUEZt8yN8mud38seNeosH	1
2626	2vbNAJ64dpzQfP1HSP6LQ9RJxHoMJSJMiD8k4G42j49bHCCBMq5x	1
2627	2vahzqwGiAsUkL7HVaJdNFCdcnbWFvzsimFTGLwfghuwM7GHcVYP	1
2628	2vaCQVimaZhsAPM7PygzDzYutCYAJSMMCmdFok268Q4AQMKCyUWz	1
2629	2vbDcxAydXjukpwNsa31gFx7bDy3KVsc62RjzuCBCtexsmtJRKRk	1
2630	2vbWXga6cxrzk5oJdH6h4UHpxioE2xSAHu91oFE7Sc3NqkbWa7jP	1
2631	2va9ozHFP2CwSBWEW5xHtttonUEx76rg19us2v5YhNmQRQdGB8s5	1
2632	2vbvq7yb6yXxa41KYyJewH45jeoS1Q6fZrC3S6knuT6HmuXb97Se	1
2633	2vb1HWKAZ9qozDN6ido5nCwgsoTvdLydEupQDU9iZUUGmtrsimE1	1
2634	2vbKHLBVAUgUy9m4t4rmFsDLUBtTMch33PV2XkcDKvTF3DGmU5g3	1
2635	2vamRzUBQWuNVGsy4L7NZ2FRepRt1d575CtTkQ9B5nnJHFasPJAf	1
2636	2vaDYHY2uZbSUTXmvXBJ9ns5zurEN5a5BuE9dzoazwsg9LrEiDDT	1
2637	2vaoHu4CFsB7Ww2cXJU6FgUUhztwrGY8C7AuMJgzQGPbKAPvCvBZ	1
2638	2vacWbKMmFA3qWqmE7vkRpEXXME1TpWnnXwA94wxjNGrYPm7mHvY	1
2639	2vaiSrb9RiyEEQQkm2Nr2AGH3gKtsDoBc7VuEggomZjLHn2oRXZs	1
2640	2vauUKeSqsG14hsqpLRByRM5rtnrWGs3YGusShPawBYvG6Qvi1aU	1
2641	2vbFD9NJZyHm1DatEmMurFfesK3zeqegfK28yaGg7mJZK3izxwVU	1
2642	2vaJ7i1jYkwWjmcnD48ixKhV6SZcngL1cpbozxfTZnLV3uRFx2ia	1
2643	2vaczvazdgUha147HA6NTubeii913ZYaR8JrrToJTdThefztPo9T	1
2644	2vbNTkw6NYMLAyPrikDzPaHAp1VoXemQpzgY7n5GxmhdV6Je6QiQ	1
2645	2vajKhhwdNSFWvu4qJpLQBmSY2JocdJ8AyDw3396UaEgxko7tsUS	1
2646	2vatvoZLgVEMw8Kx78rfLsyqtnsvHxP1kWPJkHxH2FQBidDfdPXV	1
2647	2vbnHzthntW1GQFvE2Thn4YmTg6PHktuMtmJfM5Prmhw1M2sGAhb	1
2648	2vaXVmpnmBLGqkz7c7XxowrPmpoZfcCeEn4kFxhg4YYXUSZXBAPw	1
2649	2vbsY3UZ9YKfhEuXYwt2iWMSsSgFr1Dcvt5dZkoLNVpK9T37gCDY	1
2650	2vapxedLQM3z6S7CmyB8j5JDgPa2qQz1LSpy1BbZzA3WLDcrmMf6	1
2651	2vbmQ7fv3ty2e9AneTrJJY7yASu3rm9AfRQXvHEAgwHiMGxEwdaD	1
2652	2vaUhv8cG5XRUHR9awZwy5v6AhrYf7nURBfco5w6JN1AGwGmczRZ	1
2653	2vbEjxCbTCmHSG5bacch4Xrc677rWWNvzw3Mh4gkYZkyGd4uUiLC	1
2654	2vaF3LD9dQRLMuvVWSjbRM1udgNSAfEFNZTzBa2i4dSUrP7CrynQ	1
2655	2vawEqiBvzeTL1DbxiMKu6nuzLq6tQSj1ABww8c2u4pfVEeTjtkb	1
2656	2vbc2qVGwuWz8rJmBNaQLsSXPSTnwGCLYFNUscey9tSoBkWQrRWd	1
2657	2vbyXKZNFYr7ChXqWWzMhfHUineBTtiZXuCGj4x5EMxYJxU6ZsjH	1
2658	2vboa6ByFsWrYFwhFdTpReCYTGSf7a6sibxydseAXcsSzZPd3muG	1
2659	2vb2LPrjXutQjhvLe4CGxyDMyqTV2PjcdQ2bZH4vpMTk7fYSUfoF	1
2660	2vbXVojE2KwVkJ295FhobSQQ33X8Y4XAYULJQDH6C5Jh9mq7cFZL	1
2661	2vb1A8nMTMX7WfPPD6vo9qoSjujK4qgA3iaLQEwzeMJ9rCafWCRP	1
2662	2vb9v6b9WXaa8W4EncJ6uMrUcC6m39VpTqUNoAqXftoC95TPSzQp	1
2663	2vadifjTpw9ufU5ozYh1TR2xaygD6FQRbFprGqquxXCNKbUx4Reu	1
2664	2vbQo2eSjs3NYyRhYi1ruDpJ8byEXwXFsKwHk57ehbJ4sPaS6nWv	1
2665	2vavvdEqXmXwPxhc7ZJ9V3yYPtuPDCyxCFoFvoUtWuFJJJxmuN3W	1
2666	2vbJ49wvaGGTBWHnH7q11h4JLvTz6rv8YrHP5pyUqYaZwbZ2pi9A	1
2667	2vaFfK3WiBSNgkQXJvYrdf3SjpppeWfjKTvgpkYPUDquMLD9Wp4p	1
2668	2vbECfzHguv6wR8heX8jrZbtcbVXTA8Nf7wrTXggRDiytub5qNfC	1
2669	2vc4YTxKdb4FTRpuNQvgLQrrSKAUQRAtKJjXhvfBFGKNdMxW64hr	1
2670	2vbBjrrkcFAhxDcFYBC9xZr11kaEJ5YF9jrrnPrZRVwYmtzYw7iT	1
2671	2vamxSV4vNBbSn7RrjVZzhBpomLuACaXdEd1LwEfMK6R5uafN7hH	1
2672	2vc4RD4Hkxo1cvjCBgqZKNSEYzR2SbVg8iHAGuupJrS5TiBp74qC	1
2673	2vaTPDGt2bmMBwY5QaRz4aWu6iPdmF64LyTMcPkDy2oumDH8vsGW	1
2674	2vbxNAXKD6taicD57FVEx9sxPy4Z2pBqtfXroHr5TsB3pTYiw1vE	1
2675	2vaL29gKp4cquym9zkDX2VAjQWZ4BA69HVBf6YgnxvrAngbee4t3	1
2676	2vbExrMqz5D9hHtqfnEbCVHzFw3wGkFK2FNMam38ZkVQvsDijamA	1
2677	2vaxWAS2dDsyfV2tBAqn7xYNvoJiKgeq1HrRJx3egcBXt72vAtd8	1
2678	2vbzAjdPkfqEUTB7wzD3dK12ZbXrZ55g1wEwT7bn9A8zjFXk2Qig	1
2679	2vbbHaTNe3iGtZ8s7vEfZC2LhxYgp2DBG1hLpVTahEGu1u9wWj6A	1
2680	2vbirLPRxnWWjQaNTghsvdf6J2aTdbQ6N6EvPtN8D6EgZHmd31Ds	1
2681	2vamos6NGnZrvABPXkxgCGKNvg7dkbnBAt1STEhDrkZ3pW64umMF	1
2682	2vaxKNvDw7j1PXMUP93xKt2JBmXmWxJGbvcXaKhtbyyc7ziaY7qh	1
2683	2vbPa4Kd8BaFhwD8SL9mSV1raLb8t397khjMW9ith4BgA8f87jhJ	1
2684	2vbCAn8UusSdWLLvpewdFtpv1LA1ju9S8F4eqTtnfr7wQviXC1Q7	1
2693	2vaTcmBcLiED96vyQDubghoN2E3wxz8WoQyh6aotpxjqm3fNMSkz	1
2697	2vbUs4bQWWQd2LBay8DG1Ns4WRAjCEUmRiVK1Q2vucDnaKBKwD9G	1
2699	2vbiX94yvwMtkRHCBGNKQiogVQDZgzgdU5m98sx2eZqE8Yb7fUoo	1
2702	2vaiVWL1zcxAq6phV6t6iUjP6mDMj8DyAZe4Etr68tSXpmHLf8Pk	1
2704	2vaMkVUdsQKPrccDNEa6nYBFBa2JUX9kdqSpxSATxoioaGiLgdgQ	1
2707	2vaXmuUWu82YUrtJZsnUAVvvqz6mjkncwb2P1k5J3zznR8UmJV8a	1
2713	2vbdR1BecxXxx7pSM3eJcgirBSmpZA9qDYEMMUkyFMnEEMU7cRxy	1
2716	2vaRRAWRS2bKWLirzE3fTLtPetaQkAySXeycyLcUDPB2hPd2s9k7	1
2719	2vaLpmhowzH8mDc3DyBDS9FhwWXByK4QGcUNphrAzHVxYuK48YNd	1
2721	2vc4bHWWbvkcKEBexpJdg2vbVYwfzNrBCv1p1Qx6DgZmfdATxD99	1
2722	2vbtXGt4ew1K8X8FQU86LpEnuj7KxJpDuEPAVPiysYr7bAB6TLk7	1
2725	2vaubbkMGD1Efsyxb9Y5gKdY5neArjmAocKHYXTmh42TNzS3nob5	1
2728	2varxkRpW6Hws9y38CJC7hpY7MgWY6u7vCEKnDbTNEsXABCMGnWr	1
2731	2vaaLz2bcEFpEkyidkKBWRG3Jhbn4EoQdPo3dv7kHDsA8EQT4S58	1
2734	2vaMpFaD3aJM39wG4eY435QGp4TSsiw3sHvSWm2tndVLw73cnwd3	1
2737	2vaTBUf1F9KKdgxeKecs72EL3JZ2jxt26RXtBq7Lc8vAZvFd8MiX	1
2740	2vaEZHqnWvYdvmUPix2ThGFhwJ6uXqjj2EFsL7FEqCDkQsbcyVdi	1
2743	2vaU75whsV7X9ranNqfsKX8o55tkb5va8Rpf9kmZk2xUa87m7aLP	1
2746	2vaNVpL4sVvmeSVBpdPXmwXApZk9FMisy5t8CCrPe3MDn4KscKdm	1
2749	2vb7u8oXQTVHvorMshudovRCEQcfyn16EGEkro7HV9CUjFLVfpWD	1
2752	2vbJRqtf1dVZuzUiR5GyFonaV6XRueK2nHzQj8qYsxSg55mz7atk	1
2757	2vaXxBfiYrN2vwEXhxXGBpziEYVt1w6b9wZ73kTsm9xndpcCudhB	1
2760	2vb22rxSg77bEnQSMwscvqueKZA6SeG3pJb3x4aP94V9k5mbEvFN	1
2763	2vbh5Kk36Nm79xfvsjUagf5tpUACxxnQJwm34FHXTYAiwerV9TxZ	1
2766	2vaMrZ13LskZyfmCizmwvu3AExmSGKTKNfxFmaRoLfC19dmvLuqJ	1
2772	2vbuu5Q1B8ZKvHy51JMSDd3pkqtybfVLkyc3EKkmqHxk1NQdwkDH	1
2775	2vbLHTYy7k1mhUQhtECHSpuvwpDJZLdj5y6DjXcxX6YP81oL3p65	1
2778	2vad1q4FrxKVDtcy6sjuWVsrVoGMk8EwrdYYCKKMiQSXhD1DtY9V	1
2781	2vbtHSVQPsqSZbdpGNxVt3AK38AofebppjvBhcJVN9qDYZvWVpda	1
2784	2vaE7UPFYuv4AjiLn66UXGcVMKcvRvFkdEHUndWCjiXw9rU2zLca	1
2787	2vbZH2nDcJe8GVoAkiKdQEdx9n4886D4Pme1g1TbgDwRW7x5wF9P	1
2790	2vbKWKefd5U9EbXmmZqqM2a9NTwLcuSKHEyWimo2p3BxAcb1oNG7	1
2796	2vaN7HgTwYYF4kibMee4WcShLJVhXsoXJrD8iF4PUWJVeQBFVSs2	1
2799	2vbrokatszumZfeLxmTwwiDrbHtsL6ZMo3mVoGEy4xJFP8i48JRP	1
2802	2vb2mXAGxqNXjPAxkPhn7hzeSJiTqmmo7RKMqH9uTC3Ee6XWznND	1
2805	2vbMGrtQTasjWRjKGZZkYWoTqT8oz5DrwpNESyzyuVopfoWP9hKm	1
2808	2vaZRwhzKB9PN3rwpukxeYcKM25gR9x3NhJvjxMx2v2HRetq3oNj	1
2811	2vbruWecCHyq5ckPPuxX19Cjxy1rARW5a4APp2BdeRdkS9NDSYhf	1
2813	2vc2H98Np3mitXKkVSVoZw9BAKhRpSCNAboMg19rFcSmVhNMaaAC	1
2817	2vbsUY5oL267nb7ZAW6XNzjBYsCAGiRWVjw3qjrGwAeFnDwduNev	1
2823	2vbGugBYNxA8xvRSv63f9hYMJP58jqnroFuUMxPwaKXYDDzmjmGD	1
2826	2vbgVB4ydemzvCYCcGACckD7nWP9LhnCWVzr79LPPJxjDjshRLrJ	1
2829	2vbbCCQxfD3DUrvBE9frNTJe72iYcnXQqPaAzvbNRYvGvizWs9vZ	1
2832	2vb9i55McYJ4UAq7Cy2YCryiq6tq5z4987yDQVgknLEFjKjxTVEs	1
2834	2vanP7oa2rtqdw9xgHyZkv2KN5X7eFC4RFwwTNbL7BeNGv9nVrp7	1
2836	2vbC9SoBfRAzpL1Ph2hbtTMNbD5QQ2XVwyeAeayz2f66oBjrARSP	1
2838	2vaVcpdUh2dQzEmzWY7xYTRksVNP7M49Ez4aUEtUq6thPpGdaPTw	1
2839	2vaqh79AsHznfBxHZntuJVxsSxYsQ2NAoJreRmgRAZyiv89d5E4f	1
2840	2vbm5kF5cP2hrMT3fti9VNeN7cfgHMHwcsjxRs2iEYXtHVUqYYpq	1
2844	2vabVh413BS6vC5xs4fsKvh8TrR72guG7SUbjrGEzEGV6wRjRwpA	1
2845	2vadZHShJRdrtrMNFWVLLkivxbzhbmPbK5YhQyLKXjwjyZB69bmF	1
2846	2vb2BdokDT538YaKef6NNr7CJCUxmEu9qd381cUeNB8Phyo7mGte	1
2849	2vaMGvsFoumKABCPR6cMG9VViYkmVmhYvb5AzqGT7hXCZyG3yY1g	1
2854	2vbdPReekMSRiPYvTXSYQsgt84ciRUxLMptq3iNrSRYQ3NURC594	1
2857	2vaxMtfYYkJXBngJrNAUvGksj5bdkmVGJeAra3dPaQ6yXjaXSdHh	1
2860	2vbAip9Fwenp3LH4M7NYQdgmfiNcfsQdGcYu78qK9zWWjR7aDYmf	1
2863	2vbneD4Ei3r7gwju7DDbBf1JpVLdM8RRf7rr2n2HQHcxwA2BeecA	1
2864	2vbKUzSYmabg8qof518rb3py72WE4Aom8boc7KVoEZGkYCeH71oL	1
2866	2vbMwZ3x6z7zVtjLG9pZ6WiH1z3Thqm7xaiKQ5gC1xA1f9Ahud36	1
2871	2van1iUuvMtFWbAgJhmvfriT7JinR3Q71J8kqPMSNiiiuHHP1uAQ	1
2873	2vbhS62XzDTvbCYJsP755dskPSAi35HY6LptCLDVtsYMR5eEt11i	1
2876	2vbUJzaDzsmhZ5GvkytGqqr8QhT8Su7BsvkFM15q1UTMVo4QbJ4y	1
2883	2vbRVgQcXV87CkGykwRc1yaHS1ahypGrCwn7kzwHoDcbM5F7kPpr	1
2885	2vbu6ndkHFP8jxgpzXviSMLEpL2nznTmcS77xNugVcADk5o16hXC	1
2887	2vaaHQ6f7VNh3KgKzuLjugbgqw5qn37crA4aruZEP6dvHCKADqoK	1
2890	2vaV2YwyQFQFnpK7BcY3Eq6Rs1n1ecshXEhfKYqFYfZEp9Fo7GhK	1
2893	2vbYGwDnxKBd8xmZuezk7wTv1rUeqT7sVd2nz4FvK32znWibQPdg	1
2896	2vbDGLhodziVYMQFkke5TzDKyjREnAwvgVh8yFaAN4awhb2WCski	1
2899	2vaSQFM927aMU4KfjUMEJ1kXY6ipnVLY9ZNKA9rQ29ZsAE6FFMjV	1
2903	2vc4n9bsENfEyw6kqdFu3UU7Mr8smY3686vd7o4vYhT2fACtw4Li	1
2906	2vbTGPDwFqMZKdK34wjaKM3b9BFS2LkgsiAAfjwPfmiKzYtgWUTN	1
2909	2vaxa2GgxtWLyVLYreNUd6YznuSnt4uP48A7fcxxRanRzoF7pqea	1
2912	2vbBF3ckh6UdL2SgyNfmEizWzT1iJR4vK5E1spVXFn67jPW9ZKep	1
2915	2vaQpAcKUXXY8m5ZqpwDFEqcCx62YTZZnat6SrTCEXuyLeU8RPyD	1
2918	2vbcQvLVvthoGFH6kJrsFHy1xKPVgfoNSwaDTzR9JxRkQHib4hE6	1
2921	2vbiiGTCMr7mfpgammQ2MjrkzrmKzngHCjegRhVLmF16sXrej5NK	1
2685	2vbuECXG9LzZ9AenKVPf16Dab2c2b5TgpJKdidZk9Z2egxvzUYFq	1
2687	2vaeStCL16WQomiXBuVnWXF2oxVWSEpDwj2HsLtxEfkFmstDpwJP	1
2691	2vb4H3PhMeSBRF29KXscRqvUjD515K6C3Nv23Ek4Ut5RSDK8ssJB	1
2694	2vbRqeY5opmhd1qN1hnKoJ72DKTLLBrQ5kQyud5kTn7s1gwwK3h1	1
2695	2vbBDCetRERLHs94zupwZqfBS9q8pRgx2gTUrmg66f2MGX8BVZfm	1
2698	2vaLL8WA1AbzvLcN6sPCRtrGcUkt5MgDWhTpx6JjhXGy5gsYfMzj	1
2700	2vaZXqfXFjL3PALZrVbuxQ7SoapXs8mFBU6gyitRBNUu3uUJuNqn	1
2705	2vaczksjN9PpoBs9YaYjM9ZFWPjqB2cqrs3D5VxUC7FVMYgygDPb	1
2708	2vc3g8PDf1tEkYYGt8uvqRdZJHpKpNBuzVsJhp2rnFTMwTtxKgDn	1
2710	2vaTTgD9vCabMMHXEuor7zRP8GFpbJ4eY137Y2EEBaiESCJRxToG	1
2714	2vbRNnTcPK48z7J2Jrki6AK43pXi6vYyHj7htgiaAFfeCZaHgFDU	1
2717	2vbL3743AJU2StC1JnRML5inDExEhtzj5XTHyta8AGGsDihErEmf	1
2720	2vbYKKomRnEMmar8jENH8HdJod6FeuLGCtsXFWtb5RomemAvSvC4	1
2723	2vbcayysWgcBb2LHhs8Rxj1kL5ow9Th6mRu7CFAfLQK9Efvzomce	1
2726	2vbQSVUYcrdELGox5aEEFM2ZigXM9znhMnknuJzBMd8QNF6DKyn2	1
2729	2vbFaxdK33Ra9BJNFWdq1ZLdxDpVAAaHVoT2VQVLSWimaFBU2mG9	1
2732	2vbcGga9b9GdSjc3UW7Y4ZQDcgvzJkFEthzLnnpdewcG5NdcHv4e	1
2741	2vaWSMxU8EFEkLJRtQY8AbXe8cXGJGhBXpJmqHYuZmTipz3rH1ZE	1
2744	2vaY8wH4ZgabS77PDKxiPAoSS6uWNehDQxp3vqvrPDXuLipx88Kt	1
2747	2vbxzmqjLSUjfDrZkgHoSCQG1f8zJSQHraA3XNgdm6HmYjhBA8Je	1
2750	2vbRtqCU7NH6qCFPRqQLxdycpkPntxoRgW9iTwHZWuUvnqHjutcn	1
2753	2vc4acBWBcSAnnnbg88Tox7gJo8vViSkcFARTUXHAXdupfH2fFJ9	1
2755	2vbKweXwvLEDJPc9oznvw6bgRKoAC75NUybbsrWbJoWvy4rEf7Ax	1
2758	2vbVoD1LwgN1by1paFbDvRCNb2vpu17dtrT6AuE74B39YQApc7S7	1
2761	2vbYeg4eNTBkStaZsB4tbEeJ2uKUYtGEbeu6aLyS5caLidbesbD1	1
2764	2vbanewf832sRDVK83w5hYBpNMX4E9Rxt4e6E8Cj8AeWuMePf39B	1
2769	2vaHNgoAygARJViAdF4zXRBkPXqB7fqNXiK84ohBMCKfR5jFGEzf	1
2770	2vamYxfLfVnNymgCwpsQd1ty8YRMuZMQJzqABFNko57ZXQHKiM7w	1
2773	2vbxg7x7edFMUaykGsQLEfpm6CKgWRobCVddDEm8sSVYX2ULLCes	1
2776	2vbUStWAQsN4KezeRuCWd4uP8S7VXhcvaALbF9XrVSxvDNCbjetN	1
2779	2vbWgz5ohCbyRrXX8AaDcAprTEMhDmxvGr4zzxVeMgwRyFB9KxoS	1
2782	2vbD1XZLYpyhDGNWgjaPqD8JVTWZrm3g4zTypvv68AVqZXsa5TJ7	1
2785	2vbaCs9aQxB27skucKhij3wtjjadVMNYeJNnbxBvL6EWtpQKxZ2R	1
2788	2vaDxVHofo14KueyWyRdEvREaC1VdjCmgFwxSQvSCwxUguVAuUPy	1
2792	2vbFDjHhf1skwSzgr2SaoAq79KYoqNGYakcd3Rz4t6N1BaF2kwjY	1
2793	2vaMv6Tum9hFTqEtbDGVkxYqYkX9GudsJd1rB7kVL4X3MtBJDxdU	1
2797	2vaiZKnEejBeHMvcwEE5u8WQyxw2CFgjtx6pTTxZq2jdqzBbmKCR	1
2800	2vatfwuWSfa3RZRnVhuZRBg5QjaL6pntGK64UMnW3w9fHE5K4tmp	1
2803	2vbfwfybTUA7MTyLxKmwmg7QGme6g36TRvBSd8QMEbkjvpExTHz1	1
2806	2vbQGEX4qkUZ3Hedfy42dMVFJdFujbr2XNt2oMcgz74KKDJhMUNi	1
2809	2vbryyDqQHET3XNSfpRZG6nNV64C2R6YSz9RvW7i1y9ZYKQtTZfJ	1
2818	2vajswFZYTukB7Pbc7zbQApnQNUQfsWd9DihNGVKG4Gr8GH6nqem	1
2820	2vaFAALWnbqRyfq94BfYagXyFrUZWKULPtwZmTmGqqBF3xge8kZu	1
2822	2vaPaP8LrqLJr4wob6rAHuW1cjXusLpkZZJhaze5VxU5MKSiu7RS	1
2824	2vaAN9H1GiSvRqFvbxBWvWPh1NuByfgFTL43CiUpoQW1W8CUrC2A	1
2827	2vaqdF85gFF12ebi5dPAc6xfjQSnecSNTWkS1Nu7C9oeFSXmc29G	1
2830	2vbgXJ71nwWNb7rWh4eM1VvBu1Pz28QvnSLrvyEYfQYNK7WY1L8x	1
2833	2vbQXvTYNvp3AHqRwncYTK8RSwEPpJG8k1PAiaxqnH1LAj5YmrfV	1
2843	2vbBFnxKcLusT5hYCgviPTuLMgdRMbfo6BmtaHz3SsSAPVwL1mXx	1
2847	2vaVvX7kKhV4Zscd6kr7X3LpvMcbD6EmizJSBCQhwyGHhnn5xNaD	1
2848	2vagJrLLgbyJ3qbbLkdXHVCnCWz3Mv5w7JpjrhwtMqdw5f5DXfQC	1
2852	2vc314ixY36yFNxY1asKYb85y69stgjxi4znVeSs8Fc14xCe6fNj	1
2853	2vbhQ7xEDVp61UkHausobH6FVW5giqTFC2qiuh1uWvWWvSLvX5uS	1
2856	2vbosmyzLwfYA29Z1RHMef5ARnSaELZsFgUByMALjCZyiGR1Q4ud	1
2859	2vbB7ygqkVfhVPixCcYujHMujirXTTm8nx7AypfgRc7qGgQgETaF	1
2861	2vaWqc463DpGPmFxHY6S1qWYEdpkUfaCaEtwpVWG6drWACBUj5CF	1
2862	2vbQ4Eq4sPdqFBXLtn9GCo93dTj2TvuDxG9dBTMMH1wP7vzf1drs	1
2865	2vboYdEKiZCJSNBPhQ9VTMVjfKVZdC6ua7EaiynscrNJ7yR2Z6zi	1
2867	2vapRRn4Qn3qzMzivJGTCupKivA5dbzC39wW7ZpZ1arwyuMqVaDK	1
2869	2vbY9HCyZXNWoWuGADUm1Vz1zWXSWKdmCm6SYBpD68Ffv8dq8mLp	1
2870	2vaATwTPZdw3g79xKDF9RaDCWPCV8vBneBGec6GCZa2BRN3fgGfk	1
2872	2vc2EQBvnrUdNxgcNd1sWeHf5fMdvq5N42Y5gBmLicaj6jqBPpAD	1
2874	2vbEZ4C4V31P7NqVwEbH4o2Q363DoEBKCFha3RPqEYgY7wyNsmtN	1
2875	2vbQhw2etxNCjdzumTHQP2xfAAr1HA5AjujLemRrzksSWw2CYgUy	1
2877	2vbKUhWxvwWbrUSMW5ecYrKjDSFHryBNQBWoTSRV7z2uthJgeKTu	1
2879	2vbit5fTkA1FPaNmvbpE9HQApxZ7VtrEPyEt2jzaXAfR5JMFXgyg	1
2880	2vbW5BXBzdKs2urMDHr3DTxU7VQffnyNs7Xv423C3RSxuyTiqkWi	1
2882	2vaQb2L3aFhJvBiG5ckGozti6k2FUtBP3AedXDNBU5s5D23LmrWb	1
2884	2vbyQjXkKoJrzqAvxwL1DcqcF3x6No6UhiJWuzprq2SakXjduvoD	1
2888	2vahc3oECe73Jc7QPXUeuu6pDdyzg9vszTtCjMGc1mdypwmY5bGu	1
2891	2vaCX95AwKfrk4LHAT1SwNPJwvRhQowNguN8AcKgEiWbhqgaqj9C	1
2894	2vbrH7mxzzeZJqcJwKi8RqGhHxGTKpDSaVMwXURdCMjSguy5XSE8	1
2897	2va9XWgTkbzkqqzw2RHhBSjKvLwUkU9LL2pHeu2EsExbcUKuk9fE	1
2900	2vbgfxrzkxx1tq5cvm91uEJKtzHu3gKqYcCtSEAz6CB89Y1XCkSS	1
2907	2vaQrVGmTn7JWRwqNvM9Gigv2cDvWdgSwGNQnTbfXyzkLcJJytmg	1
2910	2vaxtXmiEPBFgvAxMxvyMZJShRTUGVU2mkfvkRHoPMrzSTxrE7qK	1
2913	2vbASoH2jXJYusNDhYfy2sCbuFprg7nVquKsXo7CqUpmVC8pZr9L	1
2916	2varh5QjKJU5SWLLryAjAY9Ug24rearmSL3Qf2oqmVsS5EEPWpNu	1
2919	2vbSwpkYt66vT5SFhhLejy6baiQWFi2kRbRMBS2B2EQrPPzWfAav	1
2922	2vbfzWtuzbNtLXj4b2HQwa67oahU2Kmfu1fq7Wis35noZ45GP5ME	1
2686	2vbxFWhLcnZWSjCT8ESd7zVLS1gdLUY55yVYPWDGLggadYc2G7c3	1
2688	2vaV6PDG79x8daUDP7LUPLyik7WRiqkuLvsNfSh9QbsfVvBoK7io	1
2689	2vaqnmzCaknCVEJAYGbJWX3k8gJtiEYvv59bPQxYpKH5no982bSw	1
2690	2vc3Z19Sgojfbpmmk6kMCeM53mxhCsXuzLJDd9gSB42VWgyGyAaB	1
2692	2vajss245HrQmaFxPe97P2FzSZHtDSXoZNHWFhnbTNkfV9yKZZVM	1
2696	2vaa92gfNfWjLEaqMEjTqoArfNjdt7rfxKBrGeXdVULyNRS5VSac	1
2701	2vb5BFGTcGuuQsUfMYt2FWBLcVirXV2qa6mQ3puYMBXZ8iSrhiUA	1
2703	2vbnLWvA3rRhrDc9SdggtqokiSeozrkEaTQjLah4mEzKvDxEbuQW	1
2706	2vbSQQUZxJqjQ3AWgiFeY2TmByLbQfwtUx8b4PeKNPSom3954tam	1
2709	2vbh3uHF261G1Lr1uriBVMFsmABjSaSrMDh6QC3JjB4jBSVkKYuN	1
2711	2vaf32qTMECbxMBGrhFGV14Y3NpWXbxqUCFF4BmJy9a9eMFbBXSf	1
2712	2vaMqEz34fQiZndv7aX7Qgax6muvbKrE5JsK9DP5ohoYNY382e1b	1
2715	2vaivG3dKApErnBpaw5bNAL6TzjtpQoun83wH1hJCJmoELdGLZ2k	1
2718	2vbfZ9XTRhHL6eQ9SXqZtvPeJNB7nNabAuuwsB9H22HNUYi7QiGm	1
2724	2vbvuS2o3zx5ndnVqrq5FuwyK3JRGj2potd5B7qGn1M2sRWtyo7x	1
2727	2vaa5HCxSmTTBqvjp9cYyhNozyz7HHM6yzcCo6B5rwFoVsKpizPv	1
2730	2vankcSMFAmRPLipD9GXEwRgWAoJ62ti6BbyMizGvHAEHiyTsJCR	1
2733	2vbRxTkkaPSbpWz6mVPiG5pAgJiAxmjXDrkh8g7FwfePcBLieTzn	1
2735	2vbPEF7ruVke9HehHNZfWMUey1oLkTy2xngAg1C9uVjMBYHrURQq	1
2736	2vbt7u2EbKDVBXj4Ce38XdBxYxQ1U61opvw9sHb3AkchefBg85ux	1
2738	2vbZmmPyCqXi4TQSnddyYDVwtYK98fzCfxzTbsvjr9s4d65RSzdZ	1
2739	2vabU34v1YvWGhmRQurPwKjiiYZdhKLPSKB4DCTAtyMrC1GQcKzt	1
2742	2vb3HpME9EPBdy61dDnBnjiKiC9N1sjPba6xQe5YCGLa1ACRQ3yC	1
2745	2vbAf8nLXcP4EyphyQeR2WQmvjqepqbarFKP7Em53uhiCP3vG3gZ	1
2748	2vb3Wrc3jbhJLZ8Lwn3tzQuHCPazPoWZeTbJzyayGHbKKkeLB9Cx	1
2751	2vavLPRrcNY9DK6LD8LhFWWCGqK2P63UxHkMHGksezvBV2CH6phg	1
2754	2vaWWUqhMAtrZj6V5YB1vNuQnCP7QXPJKs2RycGsByzzL4Amjhvb	1
2756	2vams7AE8CXzoH6BdaayNtkAAGVJQwSJ4cAWGmfvT5tDkvsg1fGF	1
2759	2vav9J5gWnvLaTwmZSSmTk3NmrWGsh2Xb5qhEPdSbrcXi5TyNMBV	1
2762	2vaft1awFhh9c8q6RwQTfbBEpJTozbNRcbiepEdjjtyStpcuGgCb	1
2765	2vb58NYnEaF8CDfPEq7ptaYxReUCbhAm9CPoHmb3NPEuRQn5PJEV	1
2767	2vbfhkqMFHYycoorzTUSh74ATGtNG3FmuBkHiHneafV2poTXHANF	1
2768	2vaf4BqFke4THSQ2Q7fNxeipcCKqKZYq4UiP9y3SjH6N5E6t3xVW	1
2771	2vbcDnCroi28Ty3fKjUhpfRMyjaL5yv2cs4o1J4WqRvh2UbPuFiM	1
2774	2vaXv58pWMva6U3aDewhLNNGNGijLHKtX9odFyjsUVh2pj1Nt4DV	1
2777	2vb5HXSknFdHaUE7bmniEerkcbbP3Df4UKZyZzkubTTxwtafs4dE	1
2780	2vajRs4PtvZbHYqonpbPAkWa1zkbG2S8SrPAWM5SEQVKyrLjyynx	1
2783	2vbN49qihmQodtLJZ4vjYtritJUV3Hr5mvYgdvrQnTvVLcAwEKxY	1
2786	2vbnFTVPTC7UudcNLvWHuHuXgdnaQSgj78i3xYBmZ2BFtMBXH7mQ	1
2789	2vbmi7yBYRFJ62GVwY6jX21EcLX1BLRCuB4BYsf3PWkVRVuPbs3r	1
2791	2vaJf8aRvszLnxDDFFqJ1bGowgAqzPewUy45MQ83vHQtP8MGSuvT	1
2794	2vb9pMaRCZxgYreCQsh91t3CLwU7v1TWt9UCiv9Zu6LLxPmFVBnH	1
2795	2vaeXLKiy2V3q5YEyfu2pWoDvtAQuTvrxAuV8BpteC5qDKVdJeuS	1
2798	2vaZ8EsTrtWrDopUQNrF5FwM3wNRmvvpDzvzTgTtHK89TQX8682N	1
2801	2vc4Le2Z5aso3n9CaZEFG8rM7RpVg1TSRgKsPQUeKtJzrNKArQyb	1
2804	2vaFHT2z2FrzmkyYsbo27ZFoaWRyAWAK5SStgKTf4hup9XM1odt4	1
2807	2vbsjhWfnUmNc2eunXHTRFx1e5RQ9jZhSKiK6zTwh7HMKpRmg36w	1
2810	2vc2c2qsw9oKLCPxWYLGr5LR6KqnK2J7xgNQvPMBWRRD4aac9wtX	1
2812	2vbWkVQaMSPzFvhiMDjP6QcCJhDQfhvZnShV3gH6bFReynQye6Lt	1
2814	2vbsbwGcnn6UWaNkFUHN6nN1Trr9RDVCoHKsgS9Ho1PooQJQ1oca	1
2815	2vbRuL34uF1TTJM2WiUBApTFpAfXXW4DyUv17HCTqAPd4ymhe4wS	1
2816	2vbTTioKfnidq53HkmmDWk1ZXzJtT9V18n43hTTbEo2ABeRVWBp9	1
2819	2vaTenabNicJsKpyoMa2zFGg6gjsdpVhbqbwHWhGUC6zN7ske5Dn	1
2821	2vbSrVudCVTg5xteiZLMJKaJMufufPtN2aSJC6YZ1CqLViBsRqHN	1
2825	2vaCukut9yPLVwji1PbReyZeGCz7uDX1U3AM3byagtvW1q4CjUvC	1
2828	2vbv9fbArGUvkp1CGeCLb63HoYVRWUF6xPSuRbNV6Gj8fVXxDeVt	1
2831	2vbqhcmqDKRXCW4RUXTrKNSUaSbpQoeRBpKq9Ktfq8wsRuZwmsbk	1
2835	2vboTewQMLSoB432Fx7xd5mg2rzN1qn6mduiJ2uWUYpjAxz9yAgu	1
2837	2vaNDy8UKP2gUqrAYQ4LAhypi3EvPoWFHQ9wnEKndZEWeCupVam7	1
2841	2vc42ZcQ7ATGm9SX1ip6moRWxnjcGzra6iBCeF4WtUFn2CEKp6p4	1
2842	2vap7VCxLbNbqTYM9fcxcp84pdveqXF7qPJ1j2jbrpToq3okHVyR	1
2850	2vbJ3GNX5Mkr18ceAUb4RfdwtFfYp43B7E3iCBwUp6Hx9sENbgXL	1
2851	2vb9co2XMPAp9kgqM9H8Qhc3CjLL4oimvEPkBaBeA83SpC1JJPT2	1
2855	2vasv2LFq3o6eyPAXdGAGd673sJYZkFpRVnxRnUcmyTo4tPEM5hV	1
2858	2vbyW3ZAMVoPzpoKbDs28sNFx8gTjU75DkjFPVmysicXt7h3tWfR	1
2868	2vboh3FFb7EdjNt6bwZb91c5bzzC2HPJZoBts4SLozA2f6nKr3QG	1
2878	2vbH2fzH4K2LBqQai3jZRgtBpDo83XcSbwBsTMstZKWMyxCQ9nnZ	1
2881	2vbafDMnQodtaCiycw6XLmeoXfxLWnWGB4DSvSxrfiGdHqBt6E27	1
2886	2vbnCFVTA88n5AWwgZqtjBjrsWWg56Nw2H8Gu9uWhqsMWyLcGyRf	1
2889	2vb8yPSzA787wSrjNanZqnG6FJVPpaXyVWCN7D3MZ778c85NJHsq	1
2892	2vbziHvNU48bwFkhMZeaF6DfUdUXB7CLAoxH4NaaZU2PM7pKFnyE	1
2895	2vamMUXtHfL4AMyooqDtRX6xw8ehuxVi3N4BXB8d5tzdaapvt3EN	1
2898	2vbkrECkUzCvrRC3cjBkoPqCDFVkCE57X27yYbkdTPA1gNE7NvYo	1
2901	2vbkRT8J7ZWJ86GFzZ3JponcDmQTz96bk3BuSTqaeyKAJC43xPxy	1
2902	2vbBjYFqcDyoRprQjUxd1cWF7tR8eETDG7jgbAN6XgnLkHHjmiH5	1
2904	2vaYvQwH7rdpyYuRpcPJxe5NKarvXdTx88pE1Up7Y6zgpbgP1Jiw	1
2905	2vbGGQ4WjpeTtPLJQ6u1UynRAsFZJfBtENtpTLSQqmVocJayeBnq	1
2908	2vbAhKietEZfGZvkxAGRt63u91g9FBiU3gXXHvKNiGLaqdmTqGy5	1
2911	2vaFAQ5YedBwwa6x4HGtYV2MpQZPZoUZf4Lvuz3WyCzabLikr8TG	1
2914	2vbWvF5yfyfY5KZvAGHwzRKkGL9p9vCEEZL7KxZoM3jLLvULPmXo	1
2917	2vbB3MnNJuqxvUdN1FRHuXLmFvHjewanxAoPjCiYAZNmUJCsT4Ay	1
2920	2vayex4B2AuRe1JgQvJFMkJdnhVjHjFshB93btyaif9b5EdNWFH4	1
2923	2vbEQd4oRvQhctzok2M6BrPAEozvHiAT8zv5Wacrxz6KhaJ5kPw4	1
2924	2vbWPayQ3Qb8u2ZkBUrsCpLPzpy59nZHdVpdM6K9ixycJCxS3x1s	1
2925	2vbG5e5RoWKCAqxuuCDF46tNDHiteVSdSWBeKXyTFqJQnWYGfLgN	1
2926	2vaAVf9A6R9kkMJvSYwmz2YT64Yb5GxPCRg5nWVvqGPqBu3zbYas	1
2927	2vbzbWnqYNeTRaTLKDeiG6s57vPubt1g2MwpSNRW9PSjy2RXWb5K	1
2928	2vbBXQxYrjuzb2xWMcXQTntHaaa1CdXnfao7XxTk1qdgiP1YXvtx	1
2929	2vaG2UGeVWo7QBk1cwbZEwmWzZc3fT66T49YD18Cidru8zJduQik	1
2931	2vb4mTP6yuoD4iabTZtbZqGps3QWntzXhih6YkZiUiSvnmz73RKQ	1
2934	2vb7qho234FXkzhVAVnoQg6g6W9AwZJB9iS4R9pGBMZRLfcu35ce	1
2937	2vbctN5kgKGopLdcfjMs4KZAZL9h2wAPvFFxdDDSsdwoqw1ULNC3	1
2943	2vbgLKQBbNNSUJU3pjnnFraYnyiM1YxNzCrYiymqCZbDFHB6bcsf	1
2946	2vbVN4ESvvE3wr63EZcJtt4vDXy9EYZhKcQrnGQPwv6H1HPQA7xh	1
2952	2vawkGYi1ytirJagUD8YkVZjNW3MQZwMRwq2oVJeg9MfsEF1UaTQ	1
2955	2vb9iTWNUGkeihoC6KLxLNg1tVE1DUhYF5xNKGmkDY3sTBFrSUTX	1
2957	2vb98yr6zxwgrQQqa2KrFMJqEk6ZSvKXRoHKsmNdHckLyT8LJXQB	1
2960	2vbC8moHgofi34UTXyvmws1JYWUz1kHkdRk5HaohFPbK9F9xztUd	1
2963	2vbvPNppxwUkGyDzSdDkmLyzc3wbiGabMQYd6mwCfvBkdZjAUUw9	1
2965	2vbqdJLYHM2uyjkXA6zUn4R5p1su9NmVu8LycbvwJUKcKvtqjKEv	1
2968	2vb3ew2p1BVEdAX4nzxQLtaQsfHDGffSEMs6x2debbs3ZUVWko6a	1
2971	2vaSxLCcoGmrHuxMPpqBiqbpR8eJ4dY5msS4GiTjhDZQSEQpkCq5	1
2974	2vbZ8iaT5pkbZ6R2TwxaVztAiQ9Bm6NPer8ttVoCz3oBESCwv5PV	1
2977	2vacfp4mxq28o5vkQA1RHH2SDYTPFyi7UbUJwFZTDta5gxRc159L	1
2980	2vb6puRScDa2SUVrgr6467zituehwK6FdoDFMJswqgQEWJqy1vSL	1
2983	2vbj5zXTHYRfvi5VLyiWw2Y7Y6eao4Zi9YFJAtHXSfAfxJ7mmRkK	1
2986	2vbwJwtDEPpk81tYSXBtcMSjXif1YTCC2mJ6XjrkcLpGwKVvy36Z	1
2989	2vbqEgBkKjsx3PDctCahTCWyVMZrFay2kQMzo3uYotRnH2zPe1UC	1
2992	2vaBcKxNnHW4oehZtPDr1U2fPVqzqUpYtkWucxLZTw3xiGXhjWdg	1
2995	2varaHpngbNK3Dqh3VzaFfQVQL2mKSFyB2bUPhWSEcdehn4PgEf3	1
3007	2vazFAxRRqmACBhj1o2PWzRY1XupG43qbt275GxZ5FMynWZhKYb7	1
3010	2vbMdDGiuwxvg3GN4eSbj8rxQspQ194cyBwUByZKvvfxfWakR2mZ	1
3013	2vbf3fV2oPv8o2bDD12VCgMicKYk9BrrMjLErKWbrNBnGgzM2hJK	1
3015	2vaSNeETRqVgRzoTovXXseXsWwNHe5Qm69N48kTezxgA6LEaA9bq	1
3018	2vbnN6tzy2TuPAUNxFX74LMjvnSXuNVqRFjWFFqfXrQrQwGA2tSc	1
3021	2vc1DStktC6CaMT8mroQYndYMW2VDk6CZZBkQPQHTSGTWUkm9pfG	1
3024	2vb4aY4sKgiA82TM5zfzibD3ekEYttqWwkzezeQ1Ukw48sdzEmX7	1
3027	2vbAgpZTVE2RujNJQL4iep3SHFafcFwWMbLXCGWdRtznMN7gT1sw	1
3030	2vas8TGKnUubQeh8LumvNuScW5Vkekvk9NHtATWBZvb6WYBARYMX	1
3036	2vbxbRYzxxP5GgGzYcsZWhcYkCWsZFacPsWoqDzVhMoHwHaBvhNd	1
3039	2vbPsBSaC6HG7Pr7mmU6PE4x26vXQqzrBfSRnqwwbYC54fcsp4SK	1
3042	2vaN7jh8tVeczUfQ92s9iJ8QVdtyTU1NpcMMRm54ZHf6k1wkCeyJ	1
3045	2vai9oCobaNWAnkQWdmKTAJvQz1NvHGuW9uLLSgBwyMT4MniBxQb	1
3046	2vbte2jeZ1Wv8nBKqYaKqRyoW12TNzCM3Ag42oieMRjkGS4kTUZe	1
3049	2vaJut8MBFTCK6STCX237kgD8NJEMctJbUXQepj9BhkESYbktmYK	1
3052	2vasEjpb3DbPoztQ3mBqtvaBMhZpvXbzy8uECzdwLLGveyP2mUzL	1
3055	2vbozfr7EQUK3YfdyTUvBEDowaWvfeStHCzfdiuopz1FVwGjS4rj	1
3064	2vawfpTihDA71oCmvLpYugMkdgQKQx7inib3Nt8d9eisg4JtuWcx	1
3067	2vbYFBj1VvCC9J3BoEoh4dPPS5UBxDhNg1gQAfFb7NSD65EiaBL2	1
3070	2vbxoSHjLZxoBPw4N8Lwxq8Pv34Ug5HbquDz1kruZyuM81ZyPynb	1
3073	2vbRQcTQXc41Q2CETXBt5F6FUuPzk9PJUJXZdDyxBmHUiZ9JCaa1	1
3076	2vbEJYyZFuZWminD5fdSyebvyshHKnwpQDRwzDXnvLK2k8jJtRWq	1
3078	2varwFjhb7nd8A2VUmfTnavZF3dZfgjkvJeGZGS68XYKKtRsUiUL	1
3085	2vacNDwCKY5G326zFroajeArqujXAg2RsGhfvD1vvvjdRiVNtAhR	1
3088	2varQtjaUwU5K4vdNo28YR2WB6SmXbKz815JpwS57GxWNKXZRhJw	1
3091	2vbhQMQq4TMV16taDKYkv3xGvtPWnwcTvPyVuNAjXkmvKyCXggJ6	1
3094	2vaeAgQbubHCy15cQ4wG2YQiQVq9szphtVKQyg9KMRN5vHiKnVtv	1
3097	2vanRAQs5MJWVMw6B2coaazGk2CXsURZkEAKkfHbAVz6pN8HXjvh	1
3100	2vbDLWABAV9jE1CxSGRYeVhzmD4vFm4gPwrajjR5D5cxpgoNCkoD	1
3102	2varKtsGYP2FudrxrxuhNcgBQ9LQoXKJU1AJ7hjwbQYqc2dckQRV	1
3110	2vbSPGvF3hWbE1UzmzSGyJDBmwVsxwuiSbm8g92nBgb9bJeEkP8h	1
3112	2vc3FZVDaHSnigNhejqKmZU2seS54dyjDjgxBs7H543fp4AU9Ri5	1
3116	2vbDnQGZtReRrhD8k99BCSet1PrdaPFhvq246XfKqiSZ4Z5LL5Mq	1
3118	2vbmtFLHScuDxhYMiAhxmbSAvEaJyafNLVvq1ANK1QhigcP9dEt4	1
3120	2vb2sdxuLWZNqhHqGoPQ25gm7EXWkdC6znUccUt6Dye7Jw7wZQXa	1
3123	2vaai8QiacYiq41ewMgvN9Ceb8ZLZ82sanxA9KKDnYCANWbPBSLi	1
3126	2vb4pcnbiVkQj9xCHNRhAzkcKS1YjSFpeJ8E8HxTmqRHQc3rkLkp	1
3129	2vbHXeBiCPscREZuRYMdp1ihAhEW5vkE9kQyxB4SubpZ6y9tKtPw	1
3131	2vbjHhv5nR1qJUBC14sAGQPrjjjPmZ9ZvWX1nAZ5taJf1GQrsfBh	1
3135	2vaTxFQMLHSGWjzzTzhwkXm8swsHRbeCHHNsZJPK1FR6qh2rypME	1
3136	2vb7ST4pvKvY8woPyCMdVyKcep55rBfUb4wY5JxYSKxVWh94pdEf	1
3137	2vajtqDTFaPdf6oYVFTTLNikNnqxVxKF6mFkRvBrfUtZNuN1qX9m	1
3139	2vahL7aVGMR2Mnctc3tfVtQRqSLCk1mhk4nG2w42ogT4UBHmPvMV	1
3141	2vam6eyce6nppLV4x5uWfuJC3E9QBKbf2cQmvcD3eyMLmjeQedtW	1
3148	2vaoNQifQJSZdBMBKfZFxtrrFE6SqBpq5qzeYWoCgydudB2iXRMZ	1
3155	2vb3n9vxcYu9ab1ZFSqXhLRuEVBKe4TBqnL3TeqLyrPRNMP9wrV7	1
3158	2vazXCYLm2vNhYodxHJJiafrPaX3bk9nWxzSrmCtVkphd41XGcZ3	1
3160	2vbwn7Y32ZoBiGnUrf6XdQSe3GTTUFEeYbXpoT6agXYX3cUbARaP	1
3161	2vbLx4cNfi8Yp6wcyUVuQcydoWA2TfuZqYxzPCRSi1k2owm99KAD	1
3162	2vbB3gHrhqbMyoQunjtfja2Yh5wHivxaV4E8j7tBLQfQgAW5YxUa	1
3164	2vaYxh3P4btn9zWqZGPwiavcHBpbbk7Un9gX8Mf15XbdCZHL4r5g	1
3166	2vbm9vk4QbrdxYNAdcM384Rty6aakdtDsFxAmQf5hsu6BHyjxFFR	1
3171	2vaFhq7c82Z34eUiEYHrAo9VsFZpMp8gWtMMSpV3YuGY3wnGVdth	1
3176	2vbtW3QdVeNS8iZ7zYmAjbdbWFFxRHzoTTR4Dk9cDmuAt9f6isCX	1
3179	2vbJkkQ38knk1i7PZv724FwuEH2CxpmkoPqSftxD8NqCQRj9ZRjV	1
3181	2vaCz7n6gjWhZxULr8dKdb2LPqwvyVLiisxcRUSReXk5xJzkTPA7	1
3186	2vauAv1cTR82MdEWDhNorhygtfLN8C2g2Ke7bFyjuzbfveNyRizY	1
3193	2vbPzXx7hahZSGWZT1z45EPHRtE7ru4YKeQeqABrdA5bdUHNcjhe	1
3201	2vbjvjp41DvoPWzJsovmGMUDCkkaaTFHAu6vZCpPB8kp6xCekgqj	1
3206	2vbuNicHn9VyKFRszoUx3dYbC8jBdJj9rv4tMoW6ybHHFvaebCQN	1
3209	2vaeNzAKNqK6jEcs9Xps1EgLHA5FAQB4HgzFU6MLJ3V6AiTs47Ke	1
3210	2vaBzBKnitLpBUMrYfCqtkxJnHaqM28Qx3uDYotxofeJqybgXNVr	1
3214	2vaJUk8QCZV8RQD2RPViauekrQmwGg8LK3TktPmDtfHASGMCUk9Q	1
3215	2vaY3pi4m2kQEmWMEmQ4nQYCo2ZX2TCmTkr4nSRPByLVzCNvxie9	1
3218	2vbRKMEMSyaXcSC7HCigEL23vncUBGG8TmRRRdeq3kqJDwvCG8LY	1
3221	2vbdzE2KRHvuKKcdc8SHyFwW3PneKRDYtccTyNmz68j1ixHDBcaK	1
2930	2vbrQvim7JZJUzk9djpMV12CNnJbbZAbdRVKiuJb3PajRZWPmbYa	1
2935	2vaaxN7zQfbAn6uLsWkFU2NDmvxrqjw1ZHhrmizLBkKw6RoTxorf	1
2938	2vc2zh3QwsHEa6aNRp4cutS8SK2yCAaZZ13pfgr8YkdPCA9puYgf	1
2940	2vadsh4WPSqr9iTX3JdNoai4TV14VyWihZ5pYXdt8CJaakBCnpVK	1
2941	2vbMbJvuy1Q8S3DDssGv3eAJtv6SXMp93b6M6xkyCJ4BfYRjn3q1	1
2944	2vbeW3YQ9hZPXhdHnCt595sSAS3jNksGYwTv8a3KCGRRcmA9aEM1	1
2947	2vasCHAUyChWjdD9siRKHPkNkhHCjgrh35FV254P1Zpe87ayp7gR	1
2949	2vbfQrEKb3vzHvgEKCaLbw1eH9RzN3nz7vHSD6MGo4VKw9D6K94t	1
2950	2vbPePKj9U7kAQ1Hbuz7FyyBbBKuHykLXUYVEr6czS457MNiqvaV	1
2953	2vbzLJa7DmLQjR4nkWgwdq3dP6HKXPAaSs1nyzKKU9HbDcnsWivN	1
2958	2vbqh3YTBLg1a2ZWbcQqtoQaPWuHqJHpg2oHp7aURTkmVYnSBSAX	1
2961	2vaotPPPScPNXpNkkB5DBiPhM6bcLuoeFn51vc4VcnaNbYb88qzD	1
2966	2vc5WR3KZ2tAGUiopezT7pQv897ZndtFLhZtgAgfxJBFWgioyABn	1
2969	2vbsg7pHuBgN3H1Ux91yrLHFdf9UgbdfKLciu66UhXzNdqUA1EPs	1
2972	2vb7eQ76GipbVvC1SScerPTzGNRGQXDdQ4LpTqQMZM2R6JpmdG3u	1
2975	2vaBHx5tororWGZpJg7ikBFD1oApaoCntdiyMLieTgugoPSzHVtU	1
2978	2vbmbkLARkYc8vkXwZKhjmLb1fSXKDbVYgc2JqHxnhZRDWs8EkE2	1
2981	2vaRCyPoQ4hgvvWqb6SwKv6N11Bp2xLt6vgm7gqsUhN5vngHxkav	1
2984	2vaAoRdy1zbRSmLQLBxJkB49aWk2nXvxRrY5DUk7rbHUBHmwTNEg	1
2987	2vaKFbDPCquyUQcqjGJvzPp4yJ9i5XTtquHjiS62TXrARwDmncMk	1
2990	2vaghcpQRRVvPYSmXnpbtNrfu65dPxbCTSHUxDY1YdRVqXrqiMxc	1
2993	2vbZhu9833jTrn6uq5o4hZrxWNjwUQh5sMByfpYk8K428YZKC455	1
2998	2vaLJUnHJ9hVSnu3nuKqyFr8hDtdkd3yT37wSSwgHwuzFBCSyRpd	1
2999	2vaVc2NqVgbkdymaS1RTATgo754HiSfMv8LdjSevdcAFQ1vUGvCc	1
3001	2vbrEvV7w5TLQYGhpN988UazVJ648L53EvPU6jvYR3KBCRzgriJC	1
3004	2vb2pUp9s3vALmo7jkKKGxS6xvcBkjUxMXpCAyWi5vgYmHeNujLt	1
3005	2vbVoYyq19uL22E1pJRiU1ZvYW49voRgc8dKk6Yqy8pGbaU79cw1	1
3008	2vbF8kkvRudCEoM44T3iZSTpxJwrpGnZT3XsjPVS66zLV7e4U1bR	1
3011	2vaEYC2mE9CdNbbni6iU6bkdBQxcucK3E8oMJ3VQSEyX9voVuX32	1
3014	2vbtrPc5t5oebPE79YnpFdrc21FDaa7p7TQhqfY6cuDTXJUjJYSi	1
3016	2vbiX9eZ4NeZ4UciiHDA7EhQ6PixMY1z843tyV3jpQ2xcSZinUt4	1
3019	2vbNN2Bz5EUnFKSb2A5P2CWeBuxfvDaSQw1fo6st6DDzTScFfu2T	1
3022	2vbR349UKYVWAruAQWDLWLHARyNY6dCcTfQyK98CLTfpiLFHdJia	1
3025	2vaYVpUJLjsFd7xfZS2868e8KuyL2St4t1CiMHUYrax8dBDe9gB8	1
3033	2vaQy4QVr6vpnkWrbYDqvjWqki5iTWmg8PTF8xKc7bsMxiu9pjqE	1
3034	2vaKSXf9ZZKERroQhf9GKJoPJwuu1XCnTniq8fzBiQYghyZYjdNp	1
3037	2vbLqVmHrDTVAmrcUw7ojQqMMUJDWS3efHsQ72n7oAwJdrvPDv81	1
3040	2vb7iUckmxY5TWrk1hRSZwLCSKyGURMdqGeFetqDaSPu5fM52gJN	1
3043	2vaVvqhiq5Q1rHDALBnNqW75vp1H5zFNYXuZsUEfi8nZMLzCUGCr	1
3048	2vaiDGHckhVFQbJjFAfJ5S18xrE9pNfvGu25yVX89NoePLSmgGeX	1
3051	2vaj8tWr9xBxCTL6k7Xh4QQtNaZ49Zvzo5NQvnESBZJNqdt53VDn	1
3054	2vbDT6LyZxdCGgTPNgPcSFKowAajYVxfsj5qe3wYXqNAdgJWcq6r	1
3057	2vaE29rsAbiKTiEbrsvHEre85Rm3Mf8zG8koPLZ2aziPeC99J4bU	1
3060	2vaukQrshV5abWm6kMaWAFDy98ucSzv9Qsk2GdhwGg9KG4TBTptz	1
3063	2vaQttZT4W1cv6Z7QywqT9xZERVg65tDen2UzusjGpt2H5ogyjsc	1
3066	2vbiiQs5CRjd5QgQB2jzjENsRMuRRBy1kT6MFwCNRkaop3cuBjjD	1
3069	2vbL7nrLF9n9C8kUx9CPRwb9caizQfmLSJ924hvFqMGvouRoMmwd	1
3072	2vaLpKZtRfbrhaevkqbSJ8rrKNtPDWrTLN6M8NSmo8UVhrxBthX3	1
3075	2vagEyJCx6fQo3vQANJkEtZqCR5B7vjqnHtbKAUuANCnTDxzyQmv	1
3079	2vc2ecYodDrwkWVhPRkT5NXHePKT6Z1VM7bgHY2Hh7UDNMzRWaL2	1
3081	2vb85FKvooQimbFqYJKwAXroXTidHpurpH5nSwQ98DBC2nWHBqKb	1
3084	2vasjHnGRtLzyiYWkAQVUVeJ6LHbLc3fm2U3vSkQ7BjPRmdduFFL	1
3087	2vasEKa9963M59YgHCCfUVWAn27gKjwQXM5H9BT6y6afCyfUkjZe	1
3090	2vaxzS4h1ASbRQyMCE1cCiVDT5j7UXVVwBn6q6SAXZ8FEQaCWAGr	1
3093	2vbxAmNtTK5iq5h7JUqbPvD9LaqGMHdH2AMh9J1zTUf4GA2RB19X	1
3095	2vaLszmFmrNsHAKGGzNnwN2LHZYAaJadwCQVHUHhf9wAz9M5HD6g	1
3096	2vb9uTDFBhCgjbwNDuUi9TzWXvUX5skFBVgN3kqaXfDTjnau1JJD	1
3103	2vbxfrwemjpY98yqXq4j7CSDSxQTxemrDc4RXPZqbv31WCJW4CHk	1
3105	2vax3P3efnt8mka5UhKhJdQUqtaZMWgbKdTVqnmwoyHKvYeXntHg	1
3106	2vbGxy8nERPNKajgQqh2suD5VUAmmNQsyFFJG9MYGq6RSxCYboNh	1
3107	2vaxUog3pmbsTEYdmpkiTSWJTnXNZDd6aHP7Yc65xh3kGGytqpxj	1
3108	2vaz92mZDtUCPz1wbL3xhs435i5dJusNgxEHcuffR1jw3AmVdJz6	1
3111	2vaL3mtcUdFzVq7AFjAAYV4SeTrvjZHvY1VuAsUZ4vVkLGpLGaqL	1
3113	2vbddz4UpWk259QVaxnWXTC5E42Vyo8NuqskdMyruKNjsBrffnnd	1
3114	2vaeXGbnHVttd6Dcta5F4rYHFq4E1pbARZ4RcfZaNrw6X5UjmDcE	1
3119	2vc3VW5Mj4mEuG66VWoLo12S6kmEW8nSgDUf3nt5xU9HDoQ7C8Ci	1
3121	2vaGCpxnMFzVCMKgLUBb7ZauQ8SLJ5ByoSa9VumVpdMWBuZxfAdH	1
3122	2vbwfDKun6J1mtTpKwdv29nVGKLtFhnxh4LPdE7gXTyg4fpjWwAw	1
3124	2vbN88kBtkcmmAqxPvmbdDteXXWNjdLMLorJ9dchnjTFzckHDRUE	1
3127	2vaDdXDujHa8C21rsDCYFBjM5pRSJEr2PJx3UbPEkuNh3Ugi23B2	1
3130	2vacvDb2dhFkozEGEaStFp8wiWydQsYiew7U1dMZtJmqcR6L6Uja	1
3132	2vaMhm9nHi3BMwqiqFKCt79QyyMwBSdnftpWrQqVDkJwzmzAWxVY	1
3133	2vbRyCwt6iJ5G1wK19VqZyHYeB3nUHEYsBiBaASZMqEypAJ7AajT	1
3134	2vacTt97g3Mjw7GBaEfYNjQ8TGTdPTvLhenEF8x4qwmTqKHdXGzD	1
3138	2vbi8U3dZHeHPB4PXLv6G1NLLDsVuKcuPwuTfq7BThTYJXWPHzMY	1
3140	2vaH9374vuZMVmQzyUmBCbfLUq6rgeX8Uht2ocsjprwNk2XPcqgV	1
3142	2vbBZB1cWw3vCHrzrBTdPAq4Z7Yqw7HLHU2MMXPJkogt1N4bPZzY	1
3144	2vaVgLTUGuVLZjxykrHzKo62rHegdMYsgq5CMjVvsajWpB2rnfFi	1
3145	2vbA6zezecqyDUe3sXphbFp4f4a4pZ5jMkrkcRshZb55DRanFtrr	1
3146	2vaNLEnNPSHHZ259P7tZPFuhs6xgrQPQsfds1Xc6wJv9oyZx2zme	1
3147	2vbHRgsmozGpMwU7xRiquSt73WLEuZUGp3Uuos22Yh5LHMZbsiMv	1
3149	2vadaiWV1rmwecbcGXsK8N79MQFboG8K33u38R4igTJqKXXteGCW	1
3150	2vbSf3fHmGtFpg64ULr4SjhPZZi3F2Y3SWX4dQFWrjRgyKFCDzzV	1
3153	2vaVr9YBmncHNKrn6bRJpsmePn47qfE21bq2jxSeVrz13fEc75ig	1
3156	2vbkQfx4YTXRRWUCSKFRG5gsnZMuPTDrBNPxu7KbS2s8LJKkdNWY	1
3157	2vbsPjiUG4g6RFxa91Z6Daxu5Ro33awFBf3Xh1QsUQ8J1yju6Zw4	1
3159	2vbA2Suo9P1ptPPsejwrNsi4GppwFczjEbLSnQaPGivx6VbJ2fTS	1
3168	2vbEsHHSiEsD5egzdBR4QtvETvaXQCNDtMqyW22YwQrVi9Hq3eNN	1
2932	2vbUcYjx39GUVtsvjSG2cF8fG4MTmLH3R2rGxCrq7iXRiYp19rge	1
2933	2vbwUFGALXyTZrerwywub7GE6VrmZNNdxw4rQyMmjvrbPUnVviL8	1
2936	2vb5xiJQLCHHC7imdXXJSbSCzxEf8ZaSbphtVbjLHyUG8N81iDiB	1
2939	2vaAprDWrj23DJRWmV2g2cxcLKSve8sLczHpWZR9UXs28P7D1q37	1
2942	2vbgzqJa1ivJuUUFetiRwtP3d56eyYwTyUVBmYdrrYVbEbv3dncM	1
2945	2vbJskho9nnQWYZkGKAzPZtrNXuCJUxDv1XSuXSMDTkfyFtuSU9N	1
2948	2vaGLsXyAdaMp38WUFrPzCsLNGduSPLCNV6EYbpU4Ec8ZEvzJQKn	1
2951	2vaCdtHJxyu5vV6SJU9QWMqgUyKRYPk23PbWZfyUNkBd7EPEJwaC	1
2954	2vawwwWGzDtz42N8EucgPWYUKfEW1GHQwsfpA1Ebf9WmviZ1LvWG	1
2956	2vamYDsemF7Wm1ErNNFUJa5R4aRzsWavGKecaHhoywRGrG1r8v8L	1
2959	2vbaUmT8U9ZCU31Xo1cQ8e9yuppzCysX1VPyEbVDcRcWQC8v7WNd	1
2962	2vaWrxhBdb2CaaKSLrA7HHuHG4ZUf7PfJRveebUnnCxRUP9rzQtV	1
2964	2vc2ktHVwLYpkoTDg5htW3iwsDCs71h7EtrX8GPMjjFKDHeiXG5w	1
2967	2vaNzwtzakaB4FVd21kq5REq2YzmNpWWxFqzvK2vPVD18YbTNqwM	1
2970	2vaCKik4ELP6gWr9kFPfxWrS8w4V5f7kLNyKAqeMyrGfnWJosqRC	1
2973	2vavBjEHDi6kDGGJ87JSq265TEJJXvsQ3AnJDFXvuPoMKR5cojBf	1
2976	2vbApt7VDQhEksDXUcdvqgw47odG8RQ1ZHfrUbUuTuSm1nTXuUAF	1
2979	2va9zBuKvgc5qe1wrcgTcT7p5ApcYRsNGcPmHyiFCBiihF5zFHbw	1
2982	2vbu79hjMSz85BvV6CCVjdSmTN3NR51CthPQWkh7WsxQc4ySUkMP	1
2985	2vbF3f3hjNrPABhYWPDropYNoVzWGhzK9usBUi3EuhmpRa7b2a2D	1
2988	2va9v44EmwMCs7G71dJK7tfDzCaSezpL6EGy9SQzAFzZPJjqrx1J	1
2991	2vayzAcuVECBh631C36Qj14UH1Lvyd3doBr9cUts1Y5TPQxCJfJr	1
2994	2vbxH8LynKsMsduzMcyginvwGZeuQ16NdvCTvnWghFeYaW6As2Pk	1
2996	2van973QWLJnLnDK7qCaBjkRwBdVthJJ24GBfPTZGnTjyuK9uba7	1
2997	2vbpXPt9NWqfYFLt1KnWcGQvzvP5afyGyyThyzvBmoxQVT66s2LS	1
3000	2vbTd4dGPoDVPXSJYmCV83wrcKBxwUAhaiurwLMwQmHwtFzGcVZr	1
3002	2vbf5ernAMEW2CG2PNQrtBb6K3s81NbPwgqYhycDYy7Gmv9AkQZR	1
3003	2vbSaA2mCF5mc174Sj2fzey7LZ6WoeHSWAKfq9cDHyn8c6YPcMMj	1
3006	2vbqzGbYtJ8YgCcvEvSmkFKb6iDHXD6npyxUxbSZVWNfEfJv7LnZ	1
3009	2vaqEcVNV1JddQLj9fq7HmcaYCayAhAEZFvFjqYJGNhs17d5CSpL	1
3012	2vc2YFUTtyaZ8mcgiCqw5GSWePAA7T4pMFUuZ2HTZiPRB84rStrD	1
3017	2vbKBaxskvRYuQYecEkTgPT6YrLwvDJpCQDhDGXQhfE7cSctvSWy	1
3020	2vaBoSNu6878hSwuuGA52kN7vkzQgmqyBnB1ozBbRhRmpAe3asyo	1
3023	2vbn3PE987C8UKPzBFAwUCxAJtJsm3nMqaPPQJ8TGiVhA5oruBoA	1
3026	2vadFua32k6PKf7rjswKEWrq912kXNuVA8FekeXamrszvtxSxTt4	1
3028	2vajcUr71xnzerJAh7GQkf1Gv2z9zsDuAzuH1sq3P31afRRV3Eed	1
3029	2vaSSb83PkAC9nZ9oFQekSLqSVqdeyUQErHt3zT9e7irAHjFHQDZ	1
3031	2vaJ38uM6fN9qJSvi5XJVTWgBPPp8oQ4BZ55CBYjZnnevTZ6NCWG	1
3032	2vaTsTUYMu2iVAeLrpdNSM8eTG6VBEYumiRLxg1kZ1MFWrP8smwE	1
3035	2vb1i2B7xdiTsXpjkKHuAs2oekN9kB6cgnSxAt5gs8Uf3ocYo1Tp	1
3038	2vapYa94WjFS4TS8F5o7Hwhm6iezSoA5Czrp7h48XrXWfV39dnzQ	1
3041	2vakybKHxsRLW5r823CaprnuPc7GsQtWnbAzoVc9Hs7yFixB8vqa	1
3044	2vbvizE2x9wh36fGjXBeuiEQRHL6aumaVrcpgiowQ3ddMdnp7mif	1
3047	2vaGhGmhcVKG61WSiCmafcapDeRFtohFG18tM5bLD7iJYqfZR35J	1
3050	2vc41SwkfJ3TM8U31pDPakAv9HpyhWpneGjyQFaqFRR6QpSCvxdT	1
3053	2vbvQdCHSWmNh576mFysLDTXVX3LUuJJNbg1D1owPNna7sLBSEmi	1
3056	2vbdnsaDbRfYq5J237Rz8SivcKKiK633NWAD3ajjLm3iNzmziePW	1
3058	2vbzgrUojrHm4Tru15Yj2ubd7jR222v49qiWHaWkPLspQeEJkjd7	1
3059	2vbnSZR99YWwT9phuXEYrStMAmVEpWoVX2JbPTHwBMdhChgqVgQu	1
3061	2vaodz9fz3dXtYQWzEoKmjJmcvMVHAxnXbrfD96iouj9UxVPTZES	1
3062	2vaVzoJSJDf7Veiohjwwm9keKAenUAn8FPrsTKi45TV7hRmVDymJ	1
3065	2vbERMe9jL5qsZfxuUJmvVpUYyi7CG1pb5AqrpPtStjRyZc2jYQJ	1
3068	2vbzvLYYX1vv5yRj5RKSMxTm6Ubama1omc8avnokcPYtVqGJzQS9	1
3071	2vaeJpkSga7zh9UKvd6SzaKN6posMqimdTZ7JwUWaUJZot7orgUE	1
3074	2vbG4tNgcx5qxaNFQU28Xbwqx3BqTTfXWVRrnyUvnKWiw3bA4G42	1
3077	2vavs78VKS6NTqrTUQPMA4PtikgTfhkYmpVYK5S1vfFDeBkkWd8M	1
3080	2vaB349Mpt5NqR48EB37ugv4KA6iA8f4VrMzd7BsUVfJ9gtLqsxe	1
3082	2vc3wRybtPzSPYxWZxKoo3r2asLt3aWmDqMyfFUAmjDnjPnaV17p	1
3083	2vbKdR3Q7oxvakqVtAFBsq5GCvrhwz6o4zhzhoBdKc3ssPJySBEJ	1
3086	2vb9fD14s9QaEUVDXwAcZzpTmvq1qhz7ZEwKeYXFxobzUZDNpy8o	1
3089	2vaX77Vqw5aG2aT16GXZG9ewGoKAQjTx1eizg5DUa3pzpKAuc66p	1
3092	2vbuydbvYy6DB9LLAVdHUiCb4UDk5DKJ3VAwfqM4dcEyaVrQNySh	1
3098	2vbb6G5PaduYHNsiVJMBSBxfaBXC9T6an8d9L8YdS1xgAJttGSEX	1
3099	2vakLzbojr6uA2vKzBHLUW91KfVrMzrtPHXgUUk7bAHaifA7iSpJ	1
3101	2vc1CyVM2axjD24jxkbKLACrq2aV4rfMNGuYv1eDbVb9y2B4yEdg	1
3104	2vanka76auEpo5oFMUHtuePgWaJP46jesGUtT4uyUUd7BR21PZyr	1
3109	2vaNNczSLcRbyVK526jhoHuGJufHgC6QXP7p6AN4ZzpoBzzNb5V3	1
3115	2vazFcEpUuw4pXo469GC9etukqbJ9TMn591NEwczjoy1GkRRFasD	1
3117	2vb4wZ475wfRu4WT4ZaoKfNerdXdewPhyzdkRu6BpdTmqjkLPnE3	1
3125	2vbejCufcjcKNXVb6BszMbCtyTpgQpqDgocCPqvjqxKVfZJdhmV1	1
3128	2vbanxd3R6uVBnC5iw37tCmsLNfbMfjYqJweRYTTSGZrAKcmGe9C	1
3143	2vbBHPkgtophadRttuQ4yYR8ijQP6JPL49yUTb4ogrsaD2EucrKL	1
3151	2vbTdxAaNMhtpRSr6P5eJ85DBujWHgvKM95Ft144iVVKNFJkrs9D	1
3152	2vbMVLWps15oJNyzYEJY1tWbAdXNVFyZyZtPMqUZpd9GDZYZbJYH	1
3154	2va9cNz6tj3nXoKQE2FWU5QiPQmQBRQyJtgFDfto6T1MeBs4zGA2	1
3163	2vam9smUDQNXFhp1rUoJmVL9ihcvyi6vksugEWKnPaMxat41mkUp	1
3165	2va9iY5YzykMbunJf9KiV2DM7AmBt2WWr2jNWmc5jFfSy6cmLPNR	1
3167	2vbBEuRA117gvFkKf6UHTA6HTWbVPdWceoo63ZbxbNyryf2a3Wyt	1
3170	2vbWtg72CYwbwJvgSpw5LiswPuSaHwEbob1R2dtWmLZ8D9TYzNQU	1
3172	2vbAeYhspTSiRdtTNBAduGBUWBfsU6YHxuDa8ioYzyE3KwMuoneX	1
3175	2vafNA8sHi2tnzwRnXBRRf4LXrqwpya8MgjdXw9KERMwpUts3GJz	1
3178	2vagVNXKJqT8yaSN2B4nW8GZ58u9kVxP1KFs4vzMXGzNLF2HnnaH	1
3180	2vbZLA9mehskWk4EkULiQfTaasP9qXRwuk4tA5gJtmtGXJRroKmR	1
3183	2vahoS66KbzP3dvWLCafiSDb1aiT5HHq8T2L1SfLxbZiYTxhE8UJ	1
3185	2vbZdiW9k9aJaaxNxr3quuwpAss6C71ESHLAKAK8tapbHSaUirrm	1
3187	2vbepnYFP8vqvJXFYJ52eudW4M5HHX9jD7ma3iQDMcGWGdB8q2ab	1
3188	2vbkrSkEeGauwykJQxZqpp9rb9jKcYxYWLJdJRvTiA47pGNU8f2a	1
3190	2vaPa9pnZXu4GWPShRc7N3SqqKiiUrvkywXiueVGYUg7PK81Lx6y	1
3169	2vbqtYR49kWwL2oAgpvHywL4xj6om6uCCCuoxJ4MFPo1qERN5gtJ	1
3173	2vbskdoPyuB8DN4Ygqyw8E5a1N1yeGE8JLnDarWiSnYENE8Su2uF	1
3174	2vagNhhEBPXQPVjRFciGqQUta3CBhGCc148uXQBBepaB95hzRxwR	1
3177	2vaWF3DMntTNyp3UeiMmc2qCazmCSCw52VUHm4M7sAopEZZP8fGP	1
3182	2vaqzkMXVFoFDSbi6p9Pm92dDHHSvTsmKxbDbuNvspHojeCVLtCh	1
3184	2vb82fA9UVRJXzqLR5aj5hQHXd3SSWBT52BhSTEqvYtgKiGi1Yf9	1
3189	2vbdSzHu2sCrmeWYTbRDxReNet3nY38CJwMHemKXe3USSsjiqHvx	1
3191	2vaUSxKAAaPg5mxPhXZQ2PHjMFWQ7sZaMUG7xwhgqoRJU8ApwRAt	1
3194	2vbocpEzaNRRdrrjxCHsbm6TWYinSzToAKo9A2pwR2FAW1GQut2H	1
3198	2vbdBnUvgSFFB8nJkPZxAQsJk8xnrssswGR73ZkGxFhWTJxTc1ea	1
3199	2vacNgkmNruG9maXtd9cmfZ1t5ivq7b3Zxc9drdM6Lys9eJqX58T	1
3204	2vbjDuUoyFsX2iw1jU8sGuFfobdefDcCe3s5zFnruTx44chKLfq8	1
3205	2vaoBWggQEdy67BkT1Vxfmd3q9oBHYRJbxnzry8aqmFoPXnnc53J	1
3207	2vaG8dYD4MPSwT5KDBPY2Ja5TrbQTeVVvkYFNdWCSrwf9aJKS5tS	1
3208	2vaXTTx4veimiYhcurkK8TYAwe1FSGQt5rYBuc6sWr22AfKBGxwc	1
3212	2vbTJbdWAoCu89Bzsm5qta9AuxY2sde5bTJUxyw2XqjUq9VN7s91	1
3213	2vaLkeV8fqnoRqCbnTU8W2yAGZzTE7XtdS1tYnuHrMi5rjDpBQ6c	1
3217	2vc3sccTe9phuzg4UGCwTQXtqKa2kywY9dC9up1sVxvMtDvHhFCA	1
3220	2vaMVXGyJU2GnWG9KnLXNy1xaqHRFkr7rPWw3tMGNiyr4Kd1xMq6	1
3223	2vaWYTto6ZPpR81Fiko2ke7HT6Txayaq9DUcPvdYEcvp7P8UVTyz	1
3226	2vangYMWGtzy656RG6N1pNCvtPbTAJWkbcE9d5uzqShbv2DbLUKP	1
3228	2vaJedaXhjZ5x81t8e4bMDSnjeC1fccZQDt5qsZuAvKtzbttmz1V	1
3229	2vaH65ZpEVQu4giqELkLuxV5ZjQN9bzUgeGiXscND7SvcmNW1BD7	1
3231	2vbJcEFhGWnkG9rwRhf2zwtPBfZzwSKomq2ZHrvvwpK7rjKKJL69	1
3232	2vaEuqykPgHEGhwFNPqmZvuD5wTAvRBPFaksyaYRyCywC2r1NJYu	1
3238	2vacCX8swN9Cjth9Zv6DYeRGCvqJhp2vEDeM8ZLhzGCcgjWzoFNe	1
3241	2vbUWdYTgJVUCt3G3r8YcMDqhTRJaan5isiXNutTdAJ5hjiBbwZN	1
3244	2vah4cpNAJPmi5mM2tmEswrYt1ufwEWJSXA5BCkYZxnsYScLuJT5	1
3247	2vbZWUmVhbja9suMddb5a4g9oTQ7BcixGJxjrd1bLZEHwaXDCJyz	1
3251	2va9sXAWSyGQb2XuSuVY9RJYkA4PSNXW7V38mH5xkt8siyiSEpHm	1
3254	2vaLaZDVu9vHyyXQhVLh69T1j8UdFm34aHAdAnrXxzTyJAvCnRVh	1
3257	2vaFfvL1bUhJAW69kP2b42bUQbAbBMgisy16P1kGv6qrWTWRMptk	1
3260	2vamCEcrdr5wuUMmyTcBpa6ouk3bisSBm9FKBMSYt1kvQmHigZ5s	1
3266	2vaUVE4NuNWMKwEggpjMCZLwHHv2FS3c9isNCVU6eHhMjtgq8HDA	1
3192	2vbeJmyEdaNyex9ioW1UxPnXEMsdMwmdeVL4TdScNngyuKynUjaz	1
3195	2vbbfXbFhQ6SJDQazzF6wjBKQQVUgfeny8foGqJzEG6baZFTzXVH	1
3196	2vasb5eQgKLRPhssm9BvWqUEiRvHJKE6rRALS45k2NdPqzPwCLnb	1
3197	2vbdeurNxpqCpGyS7us6abajVip1X6AAHdbfD57jgAb7FJHfTNBU	1
3200	2vaAVYGk8FbmXLqTymZgkcXxrpnbenACo6K4jLeBvef3xsLfndjq	1
3202	2vbQkT3rN4vadGtwbcPm6YxmW691du18dCwBrhmsDgmMDZxMenx6	1
3203	2vbCbG3f1AWeWmvwkV8dzK9aigXJ8Es82xwM4naLwT38KzjrEt4P	1
3211	2vaXptpxtereTn3ks5QnmcE1DY4iyy5C9PntGTScqJm5J69HMfxp	1
3216	2vbHAND9frQdvvtedS6zrbHCLYrNgQMYzdE5PkMGMDVpQMWaX2mJ	1
3219	2vbAfgKWr8kwLmFAZnoUpo6yxZVkwe714s9SYea8W2dfYmM3cLFE	1
3222	2vaPaXELEDB2KzikhonKr5WLz6vom8fgNorvWXu5DSV3YjWFvNvG	1
3224	2vaU14wABvt9muFDXhe92yB88KRiR2mMxRoXHufBWgDK5gA5WUEY	1
3225	2vaTeVN4VQSNE2nTg3qfxv1TyjVwcTjmD13VZGyoFoZY2vnEawzv	1
3230	2vaxEZsbXttRsP3V2rZtyVwMa5zY1niC96vg8z3q9S3Ft3jJEv2F	1
3233	2vb4oRGojhTyikM8AVtTAEh4aP7CvsSSyovZVQWDvCC4EXmh7Xjy	1
3235	2vbwQ1hVcLHo7TXFnVuBRQ7kqJatPXuMCsSvAGTvA29Zbbs6uX5H	1
3237	2vaHG4v4iTWGocRSQmGVF4FuTQ4DNWFCZZ6ZvZKNrnEMdoNDHsCE	1
3240	2vbt8ZRLK7Gy1AufGSLFBJsi9qzm5QhrDKqFGYYGoFZox6Cs6KFL	1
3243	2vaiWpRCkmRitbeUius5Qfd1m1D8TpFubAePWB9YYbBhVeMz29xy	1
3246	2vaUA2Hjk2eDX9HuQ4nJWyLQUAVVRPLZPZYPYBJTwhNQvfqgbj4U	1
3250	2vbw72vynH1g4dsZMXThjvMAwnUi6gAp5oWEbybHS3Auf72GFzL3	1
3253	2vaCQAeds2SGkHrAT7egooMLFwYhuqkvXfsD1mWhKqjUY1vMSpTa	1
3256	2vaVQMw2YpGbniSW7dLpRpJm5rUg6a6hnvWjZvht5tTtznYvc8on	1
3259	2vbKS8cpi81HdcpP1aBeMCbYDmpQzCTHqcPLUUEUsxXK5VvVAbGj	1
3262	2vbMsm6a6FFpZzLWa1RwYDMegHCSj7YEEuCaip92Lu6eHV5Scssc	1
3265	2vbLKGXa7V3vnwtZHd7fDFxtjc96hQgqcrRpGZpJaQBGTRYTXWqm	1
3227	2vaqzxyjV7QQmgabaPfSEV6niWdgUduZQAVnsGf7chg6gzbhXufU	1
3234	2vaRAkD5opKBcFeG8KyBWoaYYBzQsycGidjKNzHEaZHQrda3SNnq	1
3236	2vb9fVwVxNs719GWf1CWT1f5QEjfZ2bFS4zHVH8cba8C7MGExBzK	1
3239	2vbqLK86RRxBwGe94Hr2q1pMLZzuYxkr5eDZ5cT2NLNJxrvn1fZd	1
3242	2vb8VdnSc78zdahVyVEeXoupdeVLt4TUdkD6TBfXG5yzC1iVLk2S	1
3245	2vasUbTTxMyf1xXJ9Kj3S1EXYCa23YaEkPmZTKULUpf1pzBbM6jX	1
3248	2vbkSfvXX5J9iqt9V7xbLqYDdESSoXpUMvyPADaWDq9c1wRWe3r1	1
3249	2vaFnQ9Vyjd3KFrPgddGQCkrzkzVS8yyhzg9dMNErYT4ePoWDa76	1
3252	2vaQnhh6LQ3fexCAubSPSd1Se2xT1PaQsEnYnoX87tGTPFHPUYXR	1
3255	2vauz6UN8isv9PD4yTqbnGo6gqHtjE8DFVWvApH77ZWXevmRuioJ	1
3258	2vbGESMAwFyRY8nrpttWiDith2N4zsEXsLrWRLeVQFxcakYHzj2o	1
3261	2vbHnxGKzd97k2pr8WoiSpCCJTxitHrYeAKSEAabA8xaQeMmXzRq	1
3263	2vaRuzZjnsRPZKnPdX8vPxfAVhFkXJAgMd9rHnZbawUrhiyghaid	1
3264	2vb3fZHkVchauamohqMgqdHXUEsyTFbSxYgyCj2jczbSQhJ58Qpu	1
3267	2vaxCb2iY1op59nMKnHxbVnKPfgLBMCYUCUKGmKWgU7oz9ak1nAU	1
3268	2vaK2jpNsgM1PVWY7GRySzUF5EfHiGoJpQRFTEY869x3mEj7TJ5E	1
3269	2vbVp7ib4gTjCAz4nh4k1Y5dVssXMtLaAgSRUAnHLVSyFegvb6ib	1
3270	2vbcuTuewBPLLPHvvCTWKUBfSjqLkJ3Nrf7N5Qc69BpVk945AhXN	1
3271	2vb3uNhUcxc5SambTHVwCQN9Mxyag8SpkrgY2HmpdGQ1rq7QZvr9	1
3272	2vaUTuAERfPQeuYpioV1KiPtQnQbbv6RWPN6rxPUjfVKBVZUFSG7	1
3273	2vaFwwbAusTai7yUs8Zkv9xSDuYdKyoYQvsRZWsSsLg5yVSBV6tw	1
3274	2vbYDSKNJmRwGasaGf38vyMU4XVEnT1qJDG1RMWE5J8AXsSzFBPg	1
3275	2vaGyk2Bo7rjcoipDePceGRhuh5dKd1ywupbKDs5GQQsDGEjiLD9	1
3276	2vbfj4EAVhyEZ4YB5PTPZnW28Bk2wWeei3AXTZyezeehfvszMo9g	1
3277	2vaGjotjM7ZAwcmUc8GkebNgnSQrRsSjVoAfBYcftrQW96z99Rwp	1
3278	2vc2D5UwZMnt3p9c95MkKMfg6BcbKQUDSfbJxedfQYwQaZu6MUZV	1
3279	2vafbfK4mhWBjmS6AmhpigDoQRAc1u2FNib3QUhVRPyaTQZ5tDBN	1
3280	2vasTMTubRrKjtWQermmpgDBJou6HjNHc4Q6rh3HVToHnrdYhwtv	1
3281	2vb3Sv376q5U9mNRGiWcLyM445AJyehGjdzJQvk85QehUXJa2DLW	1
3282	2vbzDGssMd5Uq5t8jhBqe98Y9wDfXdCz9p4k5gK8RwZVCbj4Do6R	1
3283	2vbjjxAN35fhhVBC7BxrxdvsiGNYSo6hg6z1zfp3TV5ZDpL3J8DA	1
3284	2vaZEBKdPaszri5wsG2kZtYpYdDME5RBfRctW57tNz4uRc7XPHC6	1
3285	2vaLE7QJMZuNr86vbuNvLwjhVsXjiBmVuWYtQMsbGb45TQJTfvuu	1
3286	2vbot3XnVxM16bCg4Gub391jmEyq4iMWcTCrH7EGgf3oSvwNRMmz	1
3287	2vauypR9cUrnFqdWKUjtiMJWzjSPqQRm3dBFhettKc4Qh6tuuaQH	1
3288	2vbYHDENPZ1EvVySGixViBrEJ2aY76AJCBv6CqnD7AZKaPjkwjFC	1
3289	2vbyzYfVKWVSDpJWhKkG3oN1dQdDpgctg6g3HPiuYXganM2YFRr8	1
3290	2vaDTYavdacXpVKCoN2sGs3DfFkzvUsweN9VHGfWr3gNjWiGk3LW	1
3291	2vbfqBxeeCsAa3yJawCGwE3uotJJF4c8kDCRiHqrENi4ozgxmtBX	1
3292	2vabHbc4evPCbjqrXtjV2JfojoX23Qzik89kwYw7DLZZFxrVgiXt	1
3293	2vbtPZhgoEiEnSZhbpwyRYwNnSUs9mUHUDQfBviCz4qG7Kd68HdB	1
3294	2vaQ5DD9CiKodBjLQm3FbRj6rrTPhSY6KvNDrVpkFuUkUPBm1jkM	1
3295	2va9FBvnzvAEwqCtLjgVgomzVAuMmLhfpGLLQvAYT3s15eH7c7gc	1
3296	2vbbtesG7ygLrJAC5eBXRCx8kjJ5rnSDDFXveyrYNGa33dnvXti9	1
3297	2vaGVzBiqvLYamPEpNHKewuzRv5TWEKePDe5SAbNhYHj2aUoubv6	1
3298	2vaJkKL6kjywXmw2rBJ3zmbbbB4bvGEZBKQtXp7oHXn6LD95tSUH	1
3299	2vc17ZvepKEiXm2pBPuxR9g45w9Ud7ZRgeB3uMiSBXX2F1iBvBps	1
3300	2vaJD6YKJmVSFJ7fVy8dm5VjTYtouWL7UcAJ1ZbwsAfeb3zjrF3F	1
3301	2vaEBF7ag4XufaaNSKmHA594P8dPb26AFjyjN476vuiykASf4rCk	1
3302	2vaTcKrwvyHca6s6g3P5oNQigCbBvQzBxi3fn6wnm5EACUvXFof3	1
3303	2vbmsmDY8H2bP75Ay9P2GNY1HkTYg5gwCqCcsVQdbejZifvG9xMd	1
3304	2vbJCQxuJA72izcoGX9Q8gNhyzAYYFf9PX1DKaFug59yLFpUKQEE	1
3305	2vacrk3Rfmz2yLSQb3coBVQ5SzdRiFFnwpjQy1h7cpmar2RYVK6w	1
3306	2vaCqWxe3SMCKHZA7VJx7Ls8kKYrhdzbt3urJFhWbKSwj2dJcLAn	1
3307	2vawP3eqPoQVj1Pbwdf5ByPMvRhweeCUociTtELdKB14RQdsURC9	1
3308	2vbA9HN4cxY945HUMMai1eeVtVcNLjLHw8S2SjZV9tqGYme2y6ny	1
3309	2vbGSiriY6BHJmy18YxewoULFDNktqZEJa9JVMNRM1aFuPAWmDuj	1
3310	2vb8eWhdtK3xMm1oAPMsbsWmip9H3YyyKHxBJn34LXJwSvB7iEZH	1
3311	2vaDbJcEGCS3YXFoQsa46NLdtJ3QSrXRTnkyr78p9DtKvoscnxsk	1
3312	2vbx6bUyRBiAGpwKoLwEPBZBa5EnFVoFPepw5wpiFb7rjdEVoBoK	1
3313	2vade1c3Z389ga3SjdpTAnC8QjNsiicMjkLW8vdF7qC7gCbeYZhH	1
3314	2vbuoTxbzjs1TCsj4fvw38Y89s4NwJHZoCDgEc8dXnMzvimC7BUh	1
3315	2vbgTwiw7EJxnxVw1g2XpGQ5HYkJwb9QXDW9HBCcv4wdM3FaAskW	1
3316	2vaXuQkYT4GbYESpSbWYSgkTbQLMEzFc9iuzDBB9TTwie3C6hvYQ	1
3317	2vazJMonjGGGJWHZTaD4mUwv7N1b91pNxNCjZjBfHkGZzvbHBvcA	1
3318	2vbrmPARXCtyTCEFFSthLwGcXBLWAB6BaKyexfQ9pFVfvuyyufDR	1
3319	2varsbQpLpWXroWfornZgPmf44LNqxCPAw3TzHv7knq6XUjHuFKe	1
3320	2vacNCSbngyD36ji5FuVpK4ZtTnoVgKvDggEZ6Y7FTj6o4YrkGR8	1
3321	2vaxhBEZXk5Aw4mbZdEqozNdx9HHToSFk7RWDLnVwtRtW3ZfD1d5	1
3322	2vbVHkGh8sQtqyJkTebE9vRQd1Tn64w1LWzPZkc4tdzRcQQoynep	1
3323	2vawGGGEqZzU7exzPRVhCRwrKDkQH9BCYWWN7qXvgvDs4h65RJJp	1
3324	2vbxd7AAgwijBi7GuFjojyJrNEcJoLaVRwDp2dBSCfKH57Qz8nAp	1
3325	2vc58SDmqbSHpwLfBXC93fHcwJn4sCDeQ4gyis6JXgHxxATc2RTw	1
3326	2vb3gp25QgDSJpqpw9qTMst8iv7eokrrExS4oJGadif4ZdsCkKho	1
3327	2vbeipqaifd9tcDBbpqRacTv3g4FDsBjA4ZVs9bWvt4ek4baLkhp	1
3328	2vabCxVSRfNZEFhapQutoouiuM6nqnXjyskHPCj67xzD4wQJYQM6	1
3329	2vaMt5du42CetQmRAQ8ENY8nuFoj5WghmS5EihNbrW5yU2B63NSY	1
3330	2vb3M3oSYTj66kncnc5nqNk9TJtRhhcQRmugFrPL8qxCNYKQsdZk	1
3331	2vaqsEN8FgrS8RTzMxVRvhsWvk9BKtCdH23VDFzdzFndnhFSejr3	1
3332	2vabQGYFr1AP3yCiQzHBZFwQsXLeiB1bxgpv2xdP1Z6jL2V5j6eH	1
3333	2vaNoPMa8zMyQGhoyVYHwi7BnhampTaP5wbXszfgKZv8yu8A5E6X	1
3334	2vbu4rcZ4NWA98vLF5EuhQqEqntYHYaxyebnuHGNiAcFwqKyfMAe	1
3335	2vauDXskqAc64YvLyaWh9Joof17GvTA42yp3LkUqxt1ptjomAtuC	1
3336	2vbPpaq88Y8c3PBPy1MkVLXKB6RmHrGmAbiVhHvDMksGnLq8wyq5	1
3337	2vav1c38X1xQcpDR2cAaNyeM8vtWG3y5Gq4q7GwxmkXYtzMkaN4m	1
3338	2vb68MGBmg9a1pvmijEuVv1EF32QJ2TN8QtfVCJvhiPneFnh6qmw	1
3339	2vb1JJHLQxZudHbq7A25Ac4fgfCfMDzxkQ6n7D1rYKDSXbTwSeJ5	1
3340	2vadgQdCjJUouHbae8XJf8T5bFTrxCSgSPhkAETPm3jYFHFA3dUM	1
3341	2vaDqn8qgNYvdd96DWnwToMVjmKkEefHv9MMZyuVjSimwpAjP7rx	1
3342	2vaffqoU5zLk7aabMBDzeuQNvXMV4xrCGQM6Kk55jpe5eARqBvWZ	1
3345	2vbqNadZQjTscwKgFyDiddPx4Af74nP496NJXzeygUvHY4L1haPR	1
3346	2vahJwJwKXF1VWdrmnFjte8NNhfrRZBmCAT8Kd5you5oTnsTPAzi	1
3348	2vbvDJ8DbZiaEUdyYXJMPKZRKymEm8kMNagSgGsihcxfaR9P8AkZ	1
3354	2vc2hug36oVUsZpGAkB2bgTaijGj3KbWgWuk1wig6CC4XZxZQLPW	1
3357	2vbnHmY7yvtzGDpy6FwN5XL6i9DPFfao86UDRSyhwTmNbQWUon6r	1
3360	2vbpGxKFikTXvBNb7TK7v5fB2zKoDDC5wtmowi2vVxn9tPgGRkiZ	1
3363	2vaSVpUQz39x9fLqiRYLVH2Te1C8oVERAAYgGdDA2w7fYowSUj4E	1
3370	2vauqjXnc2TXHo7E6GxhFEkYe7UbR5Qhcwmw7hgR1ZaB1LN9YsVt	1
3373	2vbbpwfwVTBMeRd4NkXZRCty6mTgXg4zc8VMyLz3ewkai4QLttjw	1
3379	2vaeooJGwT7mq3HP8VQwCb7HD6ejioF5qMDpBRUDgreJP9wDCWqy	1
3382	2vbWkYNv5UvNLviHxQSeS1dRrJQrr7CecYckKrRjBJzzAzhCLPT3	1
3385	2vbHrj7HyNstH34Ht3a6fnyqd7bBrZR6YRZbpRQCAZ6gr9LNCwKS	1
3388	2vasGTvxtghtGxkrNfBZXK6AmrPsfdYD3M6tHsDgdpaEjqwZiinF	1
3389	2vaphsrSYs9NsDhYnvPeYutdpwYS3tNqUQZA9TLc93ot19Y1kgrV	1
3392	2vaB8bPEumPFxo5EUyLoopwGbKh1PoerSDMSdSU2ZN1bwP2LkwNE	1
3395	2vaTrnpH1WXTmEaPT9ewRebLtEB7r5HbakjB6hHH3PuviM9sN7kk	1
3397	2vb2mMnLhsdW7P4okDsD8171m2gZJVqptoAZtpgjZJHS3Z2fQpFk	1
3398	2vahkDVbsFyGQA4Hp62fjkoHai1haKs6fz6nZiDTZBoE6PSuTFkf	1
3401	2vaK64sv5xbapXy4gdmrpqbZQJ9M3kMfyzhk6MtPUqTMvMFu9oeG	1
3407	2vb7Tx34FiLvZr9gPsHU5t1syLFxq6GSnKTFg4n1QxiFUiQ6dF42	1
3410	2vc5KHX9onYHXeV8kAcfT6sQsHSYhbxExmLnTD8HheuNuXQikkgu	1
3413	2vaoDUGJQSnQPNTRRZ3jDrs12VTtW8NGpFGvkbeHuDyYFXddfYNV	1
3416	2vbj1XkXMFunP3rXF5jEkWMyAiFkRobNWYp7mepCZQP7zBsTEKhd	1
3419	2vacbpS8SBpf3Rjye1PzzBq6ZbUnVr2juEr2rapSo1Ht5dzzqoyu	1
3422	2vb8GYVGbBR5xB5SoN79HdPZB79JX6LcpeCv72M2FH9QgCXcJ7Ho	1
3424	2vaA6mhoWvJFsxnBMjued2tpWesXUbSTPyTBLrnF7h4GyY7DRSsz	1
3425	2vaxjkoFZnzqAdEaSSTM2uLhBD4PYHzMotEbBR9Eg47iPfUQLGJs	1
3428	2vbgJq7qiEMg88vHMSSRRoXJ8SpGhewZcaUyp2royZh3RwcVQbyA	1
3431	2vbYpvzXfL9XmrDYsevitj3SYPcj6pM6vS2mFv7SZEwFcVv5QtxW	1
3437	2vbiAcH8tzfiq6DxEGjiUAVU8enay4RvgB2jqy5FkfEr42ytXcLP	1
3439	2vbKfbSB2SLfcK6aP6W9c1WZWuon9KDtARxrK4WVfwiQXZeydPtr	1
3441	2vbYDXvwnAKVPkXbx71qXTwwgHiWY4XuG2cyNsXcG8DJ21J4tuwQ	1
3442	2vb9fx5igtNC7xuyRStshijqzGTh6zuNHyQzUq3NkgEJsJyfV5GF	1
3445	2vb87JzGRCbynYg5upmgUozBtX22xbCQAqe61e8vgZctc6DupWBD	1
3448	2vbYq65WSi2GPveQ6GrTbCRAD6mgMiwRb5XCyMnMEz94M3SM7auG	1
3449	2vaZb9ko2cSFXJJQLGCQujqTih3gAQydE3Br8dngRJijdJg9haag	1
3463	2vau2VckfNNcg6t1vAq49Pp52gvH3WRVXdfJ96mLVbkQRHTTvSZx	1
3466	2vbQuXMjDb1jeWgy5fbVqtLZFoHMfKzj6wPyMH5Vbpq6uBUeg8FY	1
3469	2vafsHgqQeCD7E8731ukKaofj9mX5n6qXp3CxqcDUdR392DAavVU	1
3472	2vaWKWqhmmKLGVLo3A8sVyhYRmiYx3RiX4hMfo8SaBnvC1H5Bbyj	1
3475	2vbP52FX65qAEsY488nhryHTyjWtFjQRRUJuWZVbZqpwauySWpW9	1
3478	2vbC8VxYg5Sn4jhX9Nk9yF6BwXyVknmSsC8d3CuZtY2mPA97QxDW	1
3481	2vafYgqQrG6Qp7N9X6tATb5zsyXEXiixUtN96N6Qs89Fy9QWpreq	1
3484	2vaboiQBitvhnRoRXfrvjuP6S5PPK6LxJyYJyDyiACnW7vuo1Mss	1
3487	2vb93ixWw8dzB24Yak1rLkQgLQdzS7dU3wWBPJ7RmdSamcdCSwrT	1
3490	2vb1GdsajKjD7y2QzycyucLVqGceK9tmrZhGqwDSGqWRyYdLWmDU	1
3493	2vbMLeXY8rTR6ohhFcydU31eyeGVyWA5bft92sTauBTgYNvN2qZy	1
3499	2vbCUtYJJDZvFV77HD8jv8ziPfepnYP3M73WUrsAE4efeRDeXNxz	1
3502	2va9X7gfTLcBoTQ7rgKtsqZz2YZjZMniHNecwabm1EwxFAEpdKb3	1
3505	2vbDQ1gGU2kgTWdQWKPmFmZ7n8nusEF8vwqCgCkQ2fvdKTTRdtZh	1
3508	2vaBXWpamhKmmGhCo5epN2dasHAX2g5xEZPzuTKU6gFdTDRr1isG	1
3513	2vbockQoJcSMikuko1WRMSXqtYnr3RwdY6qMrAHSpK731TkF2HRb	1
3516	2vb6m2WDJyNqwKUghEHgkMf2zGm4G5f61YjZHGxY1URixeBRDF5H	1
3517	2vaxD6naEMvCs9DUygUXcFuUHekVmF7NpTavY11ct5jqQN6ddnht	1
3523	2vaJdYzRA8XQiLttUYT1etcWixhR3jx4aqDZjzrF3S9W51tvyjKc	1
3526	2vb4Gc5d6vJqsittH66mWzP75vSvAkMnVUmjHZLkyEWJ5CX8Cmhw	1
3529	2vbid41LstDe31JuMiKAFY2U7DVB9qcimC3EgCfZzwvixNkNfchJ	1
3533	2vamAzBJmszjWFUJAX3614weXMED7jcDYcXEUpDt6MmSxHry87tp	1
3536	2vbWpKiB7NkTTAR3WRAo35Mr23aDa3RCe23QBfvXpfAEMQdzjiLd	1
3538	2vbbUjFSVtqUtbNGhTSi6LYArVhnxSphJQLUn63pmSaQdhanCQN9	1
3541	2vazMNwzYKPerzU2mxGNcoYr2vjiMcuTt2SXdYDhCitF1jwshxqC	1
3544	2vbeZ59sKW5Z5R9AvBty6Q6U3ujGLraNCgN7EZGWosAbBdoVW5c2	1
3547	2vaoCemGt1FVPkSdyAS3S6deytdu8y18bbZyJ7wfseYHqRcbL6Pc	1
3550	2vabBVBG3ELBEGidauUTzY47ziU9dj4Dd2wYP12uo5FstAchic4U	1
3553	2vbPnR1YwnUU9ZeHcoCQwGF86TwC7f4aZCVVjN57256P9H5Mr6Tj	1
3556	2vaUKRP5Fc2QK6wahvHCzWBzLdkjXfs8QGuwNimXdmEdtTxzCXzH	1
3558	2vbnNiaQuzqLScURzY647WskJLfCcemhedtyxSksSvGvmugnzm7X	1
3560	2vaAefQwNPZS8DDgzRG7TH328mfJG6bKVzAgCKzuELH3BGYyaWby	1
3563	2vaojEQ4aZz4RwzNwi6B6Gddj2T5zvGzBuqUfZazYPBQ9Tin6xeh	1
3567	2vc4BSFUR9hELerYxVTrCktty6wR8EWDGBL9VspFnQMDkfJQUNoC	1
3578	2vbZth7GjCXL42uRfpWGcSVv51Zuh3udhecrSjmPbBHQHDR4BCmZ	1
3582	2vag5w8wCRLu6HaGcsWHoNt4muUTHqfUNiZ5b53HVeLqEFqL2jXe	1
3586	2vaKZPVkYZP5cNvDjTnT5bhqsRaXgfSNBz2ZFZGmnjvPawdwTWmj	1
3594	2vaCeGyjX4hH6J6nF4E896NswJDb8EtW8dDaZUkTWMCUDUZtBSa7	1
3596	2vayygdU3D7AkDTxCp9LMWSWNbQkYzwxwXusJ6DogH8TKAQqtcEw	1
3600	2vbwh5Jbs8sddZA7Emz1WG44nBfFSDvWxwVQ8xBfMYgeUDMzqDDZ	1
3601	2vafEa3hDNyS2sGXQ1kdTxm9B5kpF8gMH34asnBqvcQdUjkqURrp	1
3604	2vbkHxKzEnXcy7pYQuRz5yN3nLoCc5NRZTApftoEq22zf2nxzZA8	1
3606	2vbhFvGezo4AgCvjecQq26SvMT13VWrf9MQzc9hyiqK4FqDjsyyV	1
3607	2vbYqGn3hbYaUYcoNpcjiq3DtBVnN2RX3AiHJ3Y8yMz2Xj8BwGoD	1
3612	2vbiUPJS2tZJ1FE47aBxsVEhk8xKYPcw6468setw7Hjq5tnzKu1Q	1
3618	2vbUTz2fCw5SqP6r7AF9kkJyCGUW6ZQZycjFy8fK1fAb3ngLG6ks	1
3622	2vaxx8v6R44ijeGa43qxcCYzkF6kP1XR7w5mNDUtrrizYdja3n3q	1
3624	2vaWBh5sATCocoVWLXJV3gwtCNgY1yt9DfZdPtnTurngR4jKAKhD	1
3631	2vbcfahHWMxPwnZV39GY3xKgk3cCYeqNTHKdtS8rmYJYKW8iwJ3k	1
3633	2vb6DGKm9aVJs63b1V9BsmXyi6n6AgHeV8uopYErkvzK8fVT5x1S	1
3343	2vbXTRA4D2kSd4FAuT3uFP8i5oBdMmJHCiCmFoWcuBveNcPKbwH2	1
3349	2vaZXCEsRrqLFmG1dVey8iW5L4Xj4SYqmUi9tZdJ6bNztH8byma2	1
3356	2vbT2aj2zUwWfnYqBaNisBi8xxfhbmTV4Zr6MhWFPNTQfMFmaM1v	1
3358	2vb86NpWimaPD8HfRtXjdY7uPVTzk328pWaMDqrk1KHBSiqbmgXV	1
3359	2vaAcWXQktexdQtCottv76bFopM6wnR9X6QZ9jKS43pf6LbnJhZz	1
3362	2vaFs2Gj16ij1T6rbkdpj4sMivr3WjX6WuiewG26AAdMENmqePuW	1
3364	2vbX7fmZk4bb8uaYUhU76Jr4BAK445MC5BTHz1Yu3B7rAwBtVBDS	1
3365	2vbkuFs8yzsgD6TP5j7MrJUDe5HVjmewFjLFsvC5jQZZVPx4Tbb4	1
3367	2vb1CN6wfhUwBtUhTiYLiTkiDwaeUxKLHUGXVoVdiCJFgq48w1UE	1
3369	2vb5RvrScjqNjFUpAbh49k94MiLxBgn58avfcqbzLZzGvda4oMgN	1
3372	2vbNTAE5AHUniZLBiB4Kh7caDASEFZhVNsxc8rmJetv2NHmYdJuc	1
3375	2vbfBnkuU53MXz2s8ncczU8KUExjtFmB4ovaygcshaVmwznZ8gaF	1
3378	2vbBRrwiRG5ccaWZzwHhdWZoCWEMHXyVQfx9ABVohaKpeyTw2E3y	1
3381	2vbA52Ur6ejT2s4KkLNxUe6PZppBaTFPaK2RKkrjUkZZdvLrrXEX	1
3384	2vase1r7e4ghmww65fDug1A9kzB6pCHTatFrZcviGqDQSE8uT4XH	1
3387	2vbtnCfjBFqvMD1rtt6J9kVV9Jh6FGSELHbQW45Vw7ZFzC6Wm1VA	1
3390	2vbAxhzASDnoDxiBU62A1otFx8847g3ng4cdqeSPzHXt38g6KXMx	1
3391	2vaqYuE4ZN3waXMAc15Jv23QYNA6EgSyUcNKg8uSJ3BHeCoFaLtt	1
3394	2vb597EUff2RFLDnyh5CnCRtXrYfL5Z3y4cM6g3VapMomAzHFoG5	1
3400	2vbdpr7dVTihfg5Nbs3WN18rfzng8asbknfXPzX2LEQcXuyyErhU	1
3403	2vbYfPrS1QzqcdUAKQMv5AhxUqyvsGXe248hn5nYbWnSqYiAcgfb	1
3404	2vahszyVAq775zrNTfK3urPetkVKGFjS7Vodcpc1BgLRtEYheSYN	1
3406	2vbYKkt4tbhBYSyXK3eBTe2XAYgymUV9SaqUKXrqRLC88Ni4LjgG	1
3409	2vaPkvFcvtQT14ZAEG3dExLDipr4pg1zfx8ii65b9r93gUba524a	1
3412	2vbUy8G2gXZo3ueqJ94RUYxZkXEk9epYEYfhcMCaYxj6w4f197BL	1
3415	2vaVnkumNAecjKX8sguvmsYagrebyQ4XiNJT4Yj852rEd31meHsm	1
3418	2vaWfZg4uifRhXsHJxdA46Lucnxq28SZqFbs5yqPtQAD8cQ6jzsZ	1
3421	2vazEDuZDz1HaNCv9Rv6ma51qkDVUN5aefQcnXtQUycx3bkMMY3U	1
3427	2vbrdhs9Vz9r44oi7PtgwY7oGsPnHa2g3FutoBYrba81mnP2buxS	1
3430	2vbdHzqkLVcUXGjnkuH4nAs7FrNpNa54jtFyUxKq6c2yVhdWXVEg	1
3433	2vbUNGamCEq89GjvCQRD53AFmM4eDsf3KzuZ1NuHnDMidR1X5mA8	1
3436	2vadK9z66y7YHDUYg6BXusgTW5vrhLorguBY3AD6uAzAEVYaeVp2	1
3438	2vaz6NKw7oyVHweNDtf41yxt6hXogpHgMZL6Gathcu4k9CHifoQp	1
3440	2vbJcHbQdv4bgNyF864jBgGKnTu3o44bPyKDq4aZDSwemneU5MV6	1
3444	2vaEeLzzMoQ3i2fcy2QTE6c7qp25K3YTcWoqCJNQLexLgDxGC9yT	1
3446	2vamzSAjUFr2cug41Fma2ViztfuU2tAPaxHGrBt8Akbm4QGKjeBY	1
3447	2vbyR1RG8mx45T6cgvs3MF6yesnqLnnHB9KYmnAq253pyMSJU1Nx	1
3450	2vbTT8kjbHdk8GkREZA7Rvs5nvJQQnjtfxfUugdtUHr95cuJQsed	1
3452	2vaWQxLmpYaQD8tioqfyCjFWAjYjrZkuh9zebhAtejRox5ie1NSv	1
3455	2vc1dydZowZRx1KSarQdo3xm1kvVv838T7V6Hj4jNX3U4SVAi8tW	1
3457	2vaSfpHcQcrGSgwtABk5fqE7ksnj8TeKQwCpjCTQtnkdHqqaLpA4	1
3458	2vbXVcHP3gTZYQaewd2isMquQ5hDnfwKghCwZrKctNrAvCiCLF1C	1
3460	2vam9GWuUUyuVQz7dBAwcrShdubUDu43j5VPL7z1F67gYB4cU18J	1
3461	2vaAkoxowoBTuBSMBaSLPJPDtcmkinmf7fuFNbxoDQ8efaah4JzZ	1
3464	2vaSzcR9qd8UxWN8kAUaR2a87EzHd39fkq5Bs4iaXPzGsjTR1em4	1
3470	2vbqCULdeVJ2V75BKeMF82stGRRa8veBR3puDZn5amh6jMFwcBxW	1
3473	2vas4SGsXRsiWU5Vv9PWMTB8zr87V8Tp5dbwVrs4rBU8jWtZHxz4	1
3476	2vb5erno5bUSt5AjWYRqH5LbV5B6bkXM4JmBign7LdaPSCUfBmtL	1
3479	2vbXCaqityDTgEcEpbnZzfY4ojpLpRweTmQbRx6dpmXy4krWm637	1
3482	2vbRmaBfBpZdWHU1xbKXBxWU8eaagUeUoaWXFcmiuD4ktn7zsxFm	1
3485	2vaJziPNFUWvkbQBRD4ngWMaCaFrJtYwKRbkGFPTFtAommobK3dX	1
3488	2vaZCE3iJ1tQAskooQXn8xEvjdGnGMTicX5fgD3y3dwAmS3RqVTY	1
3491	2vaEYX9SmUcJQwxTd6irnZsfGfiatZrvx1fh78rbeEFo7dvRzVHd	1
3494	2vanLVeYhLk34QqPDsdkGTbGs8cLupi1VLMxtFkyh2mGUXLVe9C7	1
3496	2vajf3BHPqNMid62sbEmGmLQargdvo5GtjayPBbT1bggg4xHejBK	1
3497	2vanej4R1u4qRYgvG8HeDUZqNhPahwRynFwDcA4UPd7Sj3bkXDMy	1
3500	2vaXazvMJgjY8v8i32qkfCD5rBYpsz1PYS9JxEb7xWLZh1j7qyG4	1
3503	2vbVMHc7NLfZkPEYwnLjMoZsL4Bv2F7RRi8Ut4sNKZAEsS9MwQs7	1
3506	2vaeUqP1p9SMdSkKeit1B1jBxmXXSm2Nq9db9UBu75Qk49YrRNzJ	1
3510	2vab16MpXdTMmjpNqWTv2LPTWNTgQphJyMSRpchGW7UMeiFPVxtq	1
3512	2vaA3EaWmKckx5GRq3zcuzoWtXAwSZcVzYmtAf8H3sz9o79aNQbc	1
3514	2vaB2MpxEiCqtu6fMcG6kWLPP1ZgT2CqU82pBQdBQ3Hi8UvtvSZc	1
3515	2vb7jwVVLBFM46LqaJtPcyYfuwA89y36h2NKMPAaj21hi3JPSiPU	1
3518	2vaSDzLLdoSb73psuP9gXpcjSKpqRjTtznm8u5u5inARHQB9E4ex	1
3520	2vb1aSKiJsfEzncoLhBjUTBs421B68U62fj9hZ6ET5keZwP4k4os	1
3521	2vb5QRg9dZs19WuqkguuEe1kyRNjcPnoE3FrJ9LifUbK51Qi5TKb	1
3524	2vb6ubUytme8AUxRaM3TBfC69PnTNzroRiRyPNzDzVBGJ9CzxMm7	1
3527	2vbP9tuL5FEApK7LzC8ZpbR67Q96chfbFV3AKwNMQc5iZP13CHdE	1
3531	2vaDDiPpaM2JbdCDyGEwEFuek9KikS14QW76QgWACEM6Roia6Zsk	1
3534	2vaK7GhRAnFHVjtTTfFMyhmGXL5GoEGvmdM3ZzfrhRcJjacPrZyV	1
3537	2vaJzMEgRx7LQZKt6eygki49dzh6XCatLUcFek48qS3Km3Lnpwqu	1
3539	2vbpwsEQc4j6A5y7p3mns7LUu7SNYFGGhx2ozmk95Ziw9FsFUjxP	1
3542	2vb6RjAYUbmpyD3FvHHkWLTXPGhBnMhuaNg6C5HoRQq43d1Eughg	1
3546	2vajkwPgJd1ycnU3iuPyB6fFtELLnCppVMFFmFTwWkD7vXzwL3ye	1
3548	2vazWkxbyQT9VNfDURDcKUWubJBTsphQ28ZsWiDab7bZohucmzRH	1
3551	2vbQN9xAEjrMTeyjqNcXPHTsj92s663yQXQLyuBM7g4GgQn1s1L1	1
3555	2vbNjPXCU6YHi3mQz65K4V8qnuCYfVwzbRK6qkcTRNSZg6k8FC8P	1
3562	2vbAfCKJjQxXzULEka5hr68zWG5ugwH1LmDADRD7H8moNM2jBsmL	1
3565	2vbEefHkgjWda5Cun4RbZHJ3pnooRFMSkYaeiQnz8CW2owbERC92	1
3569	2vbd7i3iZRxPs6YbFcarKwAkEeQRq3YmJd7KFeKQqU2SV4VMkNhL	1
3570	2vaTxhgsoXg2iRVZxjnBudrT15vz2j5iTb9QH8rxEqqBiWny96XM	1
3573	2vbZYH7fKSq9bK5aNERCQTWNpQhbfoEMnHUJXhN6RoGT1Be7Seaj	1
3575	2vauxVFU72t9qW92kKN41tVsoDdCtWQ6NrwMpc16VMezsYyefwfE	1
3581	2vaWnyv85VbYB1uJp6b3VWgoG9tk2H8SupgPHY3yRekxKJij8YNo	1
3588	2vaTMV8FRTmPzxdY1h9rfWokYicqkKFFprCcWXoTueMQMk4cSgJZ	1
3591	2vaydVeYktYZnspqtQJBeCxDyJ6NzK3qAYwqMjVhfsNrXAtwkoWw	1
3593	2vbM58JjYmR3iFMC3NhkTab7tL6EH513GQ6GSMAa9r3d6vsGDX41	1
3599	2vbPaQzsCJXzEbLqQHNNW8U34RoiAemWF7aW9AhbEJTzb7mkrg1B	1
3344	2vaAAAwdLvCakxFKbCZnnzYY3ftxZ9vEs6xC4s6pXmPdNx2mFqSh	1
3347	2vaPngMkMjjLUn5wMQPA6woXMW4DkHVMPWJWpjgfsWDXvnRN8zuj	1
3350	2vb8kZ8TNMaaVgzo8T2FZzpVf2gVJFCCBW43wcEqAd5MQQrcRkQS	1
3351	2vaQWCsoa8B8BoohT8WGLxeAyG25BT1LsBKsqEY1PXeyLzvCLt8n	1
3352	2vbfT3rJPLjqnBbtQDzvnsT4RWVd2LwJJ5atDgbmV5r3y1cMvNhn	1
3353	2vbHMNuvY92iVi9CTA2uzwu11bt43FZ6JMoyR3pBLVy4xirKGe8e	1
3355	2vb35tvE8o2eJfhyujKxFnjeVbjfZXe7xPM95iigrhif52TqPx5f	1
3361	2vazQ6q3L33B3RRqDYFr29GharkmevripzZm7ngqmdfiFNwAy2RN	1
3366	2vc4Mw1evK6kacJZaW5mdfoHTHvQDWsYpVFJPssGsqdC9R84zuE6	1
3368	2vau5C9zTAF1rNxznZDes73UpTeTUtyj491JSZoHAdiz1ACbyhTA	1
3371	2vaShF6WMqAZ14YRed8JEdTEbmohzgARpAobfireUsRaoTKrFEiM	1
3374	2vaM1HXu2nbje4WRwL4P4GUc4cBGvxaXPWULKd4foSBYQZvWgrdp	1
3376	2vauYNJrekmxSSM8Z187dCUhEePYCipe3KpZUE5UpjXwWzyX16dH	1
3377	2vaA4n8sBy5Amf6wnSGGfXXeFjELvpL9JKFv6opUqCr4A7PawarW	1
3380	2vc5PRNz1Y6P2pYdVxBp77e6fci75GzkDCMwz12eiZyXuhfUph5c	1
3383	2vb3J2ckCM3H9M7EhEPLFZr2HY48SKzrG3UtB13Bxjq4mQumwTGF	1
3386	2vaQuZgVXDTMFgLBZW7zHxgYrR8ZtNt8ydtzPm2YkBZfjA2HiFYy	1
3393	2vbRh1NJ7JXPj2PvDi81uR1MNpx6QH1wETJpQanDsTGgKumXitat	1
3396	2vbQK8zRqbJtup1ruXDDWtitwB332CpFH1oJ8UyE2kAgWKTLfQ1v	1
3399	2vbxTCmP1tsCK68UYG98w8zDd6ShZ2YxvMtqbx7psXLQsXphmB2c	1
3402	2vatfAEASkRfhTRYmM1MZRXFUoSoC9i1ALhY9cB2K6Jgk27sW5tu	1
3405	2vanbzQuZXBQwRtnXH8mEFopMaRkbxBhHjY2Np9sN7VwNFvfqrzm	1
3408	2vaCgh6efmn5zLizLNR38uV9AEfByW4sANQs5aXSsoqjMuEYuxi3	1
3411	2vaPPcYP5ebWzSVkxHKcaY7LoCw4GSVrtu1uv7BRTKqP279rgEKN	1
3414	2vaynbeh51KG5VDTMnBrWX9YhzFPCbBbLd2KDEzAcDDz1qLJ8Dre	1
3417	2vaXvtuB43ivJEsjtQQSyGzEDbUW2ovreRSGaxqEtesctKR7VBcu	1
3420	2vbUgN6h3DYWFMxZNdNJhjDuJhPEG4YfgS4DHqHCCUXE8UexNUU5	1
3423	2vbYFDwQvhdg6Tgvv1yL4V4CNiymVPrtMyh8cqSALLqw2FExcGLM	1
3426	2vbFwhBoJDUeFd21e74ZLmKEmVTWdsJzi8JSgT6NvXVpVFWHYVr5	1
3429	2vbTyPwXXkFNcTNLa7eKC91cJ7HByChzUcbV4B8smjhDN11dPngg	1
3432	2vbXysuu8MJCbDtjd8pA8etsC5tNy7NtVtMecAVvZyxNHbxHxZLL	1
3434	2vbm1WzX6kkiopo1NAS17o4xmazCt8Y8T16oQH7Wg5H71KSUxNKT	1
3435	2vbHEA76sH2emLSos7eqMR486SvMw62mYmTBJP2vu1qsxsEZ3FLD	1
3443	2vb7QziJs8ECEt7QDYQLbTaL4JjTP3pnwEncCocA2VMeTzq5W39F	1
3451	2vaM2U54QfbvUKhPTFyXBPuRJ6WbdVVP7v2ugC9Y5tbTxreaNQuf	1
3453	2vacogMZjtHpPdPwui2PGALZT4UZLAWM48NrykwTFtKhnmJZNQtd	1
3454	2vahzyfEyh6smTgrygECvjJjfXuKKzUZT8PejQh5v1VUUejMKaUo	1
3456	2vaAZtbm8e6bFL861AMpL6Ahhn3gwApSnjLm94QG6Wvkp4Vzw2R4	1
3459	2vbsj8PQTqGaZaYMx56ae1AYpx64rnEhw3zvCpZs7s9gPRgCFTri	1
3462	2vbb74XmPaeRHSPQKptpERvdvzfGPcd87bRYr3MAm2R1AV4J6ia6	1
3465	2vbjc1noPCnkr8aqx5rSiB1mrr8SNnvBpBQT4E1JzNKYbHUh1Z81	1
3467	2vbLbSAvL52ZD1taPYY8vBHjCxFq9UJsuA7NxyZpFodrWKqbTSVS	1
3468	2vb9Nh37j21mQZExVzxWdNVGt8WbGtTasrMh4k2cz9ZcZvB8pff7	1
3471	2vafG6V2H6FDURtHjchWr3zWq1XaNvGzQKubMzUkxEok8PKABbnP	1
3474	2vbmfuqhmAgQw82yC4H4BkN3Q8mMt7D1fx7ZrnADgb8JZtSMUbWJ	1
3477	2vbk1BYpB2Kx4C7ynJ2rxDo3BawKEtBJsjFFZTticCy7C4Ai6Jsw	1
3480	2vaojTPFwqGTu5XsKF8soDt6XheK2WGmXrkgv5FLoEY2rmDzejZY	1
3483	2vahaeDkEBteZbpLCf4otrA1E8uNFDxnfJmtX5wWXMiFhCf9acCh	1
3486	2vbTBf1Mq9aUcP69WpStGWD87peUsTjSjPEWuhkACdqeth9xVryr	1
3489	2vbRzUMDWmn3m124jra8ao3JYeBrjBPSXBFxZYeAHSDd3edZNaED	1
3492	2vbkEqQ3CxrbKWVqmtphZnSwah9bF53WVNoCXVBctHV1T8UoA35i	1
3495	2vbD1Jz7b9T7jUi5Z77wWymA72reJpKfXkimYwbsue3aHL8zeeQB	1
3498	2vacsRr2TkUHbvFzzaoteUNz6YiTrc7gnGN2yTidpi32rCqeNwd5	1
3501	2vbp8oyhxvozvJqydM3t9jBqogGZRbJCoh2tL3Hcdn1LhRTwBsZz	1
3504	2vbgzjSXMqbjkt2EatddC2dJcGGG4RahWXvaC5YkKZ81gGrNHwAd	1
3507	2vaYkwQ16wv9YaeYfwyN7Cxs8gijViMKgU8NB8sPUfvwcvnfn5bf	1
3509	2vawtnG5uFCQXUMwj77WTWNCEZDHqDCXm3BquDJa9yRUcvN4MeQV	1
3511	2vaXpL1aaYSN8qt9AvMzepG6rSJZu3xko9amwmcDDtAikTKZwtN3	1
3519	2vbd61hrizL9EhZvTbFLgZ6sj9ejZ1wQtWgjVuZeg3WzhPxT7ZBj	1
3522	2vb1j22oe6YCP2S51HM4GAvFgXStJhtGYNtMdg6yuXbMMQHWNTpD	1
3525	2vb8a3ZyZsr8KBX96wiW2SgVGaafpDn19nTbg4FNoXbeqbVEoMs4	1
3528	2vbFKVg5fX9eQzrdVYQ6S3ua8xFGrYn7YVNGWxK8u5LcDgNEAGxC	1
3530	2vbHCSSUMkFHnnssNGaaq3xUKgQH3tAVsZwZzvcRHdySuJAviqqv	1
3532	2vaYyMvcQxjJepBGJgi87284XNuksdvw9MRYieZnMBG6tTborx2C	1
3535	2vaSmrRiSUnSCGdKn2JfsymHJqqoJxB2SeRj4z4kkwQNfEbCtC6u	1
3540	2vbHWzWhiDszj7t6PD8djJHor22qfNAPiaoaHfTohWPat4G6T8hH	1
3543	2vb1dyRbvq4zgTizsVw3cVqDB2BgAxEPnrX9cDc4HN36Za1FJ4YE	1
3545	2vaEMPeSPsMK1NG9cqfKJEPVigt5rGfkQdnMmKcB2MdqhTfavj1P	1
3549	2vafvzmWaWGqt9BMW5uAWK82x7R6MrWjL7KGoH4sBQQH6dMpvhXd	1
3552	2vbt5PFCP9p55cUyPZGokJm7YCeRYEKY9rjxsYCmhs9JmWd6N4rj	1
3554	2vc5mvMdhaaod69BiLfbBrEADkUENFTjjLfbZc2BGCiQjNriLfvR	1
3557	2vazkyNvha1UZd54XtSnGA51HF6dJBaCuforUvuQdBA1336DeyPt	1
3559	2vc1SSZm5M8icLjrada5V2DdNWJRHDauGhYgmHY2qSiJCMt9QA63	1
3561	2vaofz5K5Ca57rh4rD9PWvuynqXghtPw4jCn8Z8mJRSDhbJdwkcs	1
3564	2vazj4RLAMJNZs6Kq9ds59MbHXR1x3AXqyR3qqGSNGXnTpJ7rS2e	1
3566	2vbyN15fmMey2Fp8o7Qc7tVUMvWsjrzFo1y9vXe8YNwK1vv7KZQg	1
3568	2vbndkcKZabG25Nhq8Z2u1HVMTZMjNaaLK6ZduVhxPzFGcum5Tdx	1
3571	2vbFeM88PBgQHpQ5Ga5x9rQVMgKHdd3TrzKEzpKsHPZe93xyLGKH	1
3572	2vaqssFJdZ5ugMZDBCWPxYakwPxv5dTWaDNpsTS8WPcYmXSSPpdY	1
3574	2vb5nTYWr6oeLY15vnegafsYzZVENC1jun8Pz12k88DMMEy7oBAT	1
3576	2vc5NgHdPeDUdrPNzmdPiCqHSthVv7aZaNujnEevr6n7NxVbLoY8	1
3577	2vbgQxyyi4ngGft7Wo7HcYnSR6EWCKG9XrXtaMGDKNyDtLyeZ3ra	1
3579	2vbpJJVvo8X7NnMGTto6KmkGVQR5Y1Tc91fQgTzgRGKXAihJGRA6	1
3580	2vbxZLQtJ4okP4QQKUKov7dQq2bWtpvuqL5Uw7WLocxZj18DGW2N	1
3583	2vaaGAAcZHfJw2ocA273psfWNsQw13TJHXm8nKoaBYMh2L2MXzUf	1
3584	2vbXdQtPgMpaja8rfzKR8FsUsdN5zAw1ozMKUqZ3rv26e11UYQ5G	1
3585	2vbhA2r1HhxAeK4J86QgVzLTU7PCTgMaRzJPHRRmxBGGJFVfC57R	1
3587	2vbjHvysQC9RfekGwpW6DHtzQ3swtRhZZQLcrNMzMoygUe3bBScA	1
3589	2vbxej4x27ASChLGhZE6a8ZCbDwy5fpVk2DC74En9PU5oiPxXas1	1
3592	2vb7nYCA9SJKRxuqR9sm5nhAJ58Sa4zhZMxmde6uxnA1QjVid1Zg	1
3616	2vbrRvAiMbGr8Q7EzRQKXW9TMCYwPex7ePiG4ToJ3uoA1RNeJ8Vf	1
3625	2vaDP9Vfn6mmCLbtCPaZhZ491Jmtzd3WkLM9zeUmP9QvhVr4rSxJ	1
3627	2vam8Hb2ZsTyVr2djhfVxXd51zZfmv8trZ4QWLAjqgkfjGk2sSh1	1
3629	2vbwkyFZiaVccqBuxEXytjjaSAiDBNa6VYyFPEwQ8GpCNwEHNiU9	1
3640	2vatgEkzuEuCoSKGVGmfRECP3m5L32cDGeAdbnb1gT6ZV3LvXZFk	1
3642	2vaGRQN34wKZFn4wL9dR1Z3WWLYUMzDXZvd11i3VSTRnq4LMUAoa	1
3590	2vbcNu1eXijPxd3Bcb6ARDV4MgR5vGNHU8WFPuMzgraUnaEFpFfj	1
3595	2vaD8YEScki3U3kHAqkKQpvpmZSgJCHD5LggfFiaGgdTNaGpcduq	1
3597	2vb1iipYuetd9u8unbF3D5GdEajboQ4Y2MYJywNUw1H4aWfeSrSh	1
3598	2vaCX8rvUWE2fQrM5Lc6JJsHAh5AVf7gDz6k3cML68PerWofV7Fy	1
3602	2vbPo7CkF4Q6b5yW8P6kdgzAigjiq1siiX4J4uS9MRoQ1BpDp8Rb	1
3608	2vbotQXz9TnhZz766Qo3Cp5EVqfay1FLc8d6ZAiiwJV9CH6QMyge	1
3609	2vaJKCY3MHLtGfpTy2ynQsmZLsjcW2dkuo7C42hHvk73rhMeef9y	1
3613	2vbeAs4kUmFQaRhNn3M46vCRmvhr2qwFbn7tT8yDGGJhLQAEbw8M	1
3615	2vaK5wwte2mbQbpkrAXGcjVXgAvXHQp4gjCeLsiubj3i9jZCTwCH	1
3619	2vayzSo6xGfVQYXu2ngFgR7aBXcEzjnQvcfrUmvcHN5TkcxLyAvs	1
3621	2vaweuQKy2NDXh8eSjyDhhNJ8z5xzeHuaBDUvsfuMvDeau9ShN9k	1
3623	2vaMtaxVxXWDGFkX4tsYsscvmm2VpfgVNQRC8iuKiGz3ow2DnfKy	1
3626	2vbAmnpHE78jVg2F8M76fjj8WWdNdsiF92n7BThiP8K7XFhbM1WP	1
3630	2vaeA9DabfRuJdwiYHNVjUKjVAUSkSydKfPsgUCyaZVioCop8Ff6	1
3632	2vbvnF1EkcQw8vXPMMuXy3puZ7Pr5YpTjHZxHwHb7FrRvSsL3J9C	1
3634	2vbHQtG5dLVsyyBYokcgcA3iBUaEmj5kfwDNgSZJFa6BYaiD3LP8	1
3638	2vasqEMAuqmSBDyMBesj9yZYqH35ie1JM5xYfc5fZeLRYxfA4Dsd	1
3641	2vb1P4nCgN9w2enxp8JjEjT5PCkYfP6UgyGSee8hbNZzNA9Pm38L	1
3603	2vbow3jfL6vZevVTLix9aVnYm2dFUrhYSNJ5nb3gmhStp9PCua72	1
3605	2vbKyhsV7qpBxX7tY8RajMukjQfit6vkw6ScMWGvdbEcCtKFc157	1
3610	2vaH3o8hXPwBTCqXFtMm3LUXtEXxMTCMgvUJi4DQaVQt3JoyEp3M	1
3611	2vaJAxBf8D5M6Ya4P7GEgY3PJBrgvUNNTcozJ84QiG54jiDPL6pq	1
3614	2vayWrYUnHQUuaXYS4H4xhD47acQagbyftGAuZ8n4YQJYwGki665	1
3617	2vbgEtZgcszNMtBWi78VmYbRXs7pGC2Z51txkKbXmcCedxU8Q6MW	1
3620	2vbcte1jQUhjHpXYaMEJE8xZRtRrdwvhAcKxeaBZ3gSSSfZQsPVa	1
3628	2vb1PmZjnVZ8ibGbQSo3buij9GPMMD3unEXF3sSpXQvnv6umHYYL	1
3635	2vaEJXhreGUML1HQBsSYsEJQuatWD55U5kiiHENa2eyccSnJZ1aL	1
3643	2varE1HDc8ZVJzbfg6yp6VNgJEwPg8jyLwSLGzw2Xhm55wgDxVEi	1
3636	2vb3ZZwqp283prAJX39jq5xX2kL7VBzDupRupibmS9yzAxVZzDt9	1
3637	2vbxuchCyP1DbeD8D871pqLsybRJFsHr7P7PaUX5MortA38VAW5S	1
3639	2vaDtNGwguKKJ1HS6Pgi5wYf2R2bywj5AyCxbqnBuU5AERdGFskk	1
3644	2vagsa23c5jkpn8pBtx4wyh5UKFNsEpY8A3g1BHabrXmMY8zcP7d	1
3645	2vaawKC5RbHFTXP5BzLjFozcgEzpRicYb146kndX6Arfw958orNA	1
3646	2vb1dvDTa8pba5JoGpsEqxvKUEoH519ji6QmdckC65gp7iaJBS7i	1
3647	2vbYSr8SumZRk68VxsYagcvvfZWzao6VeF7hzyo6tiJjbiTN9oVj	1
3648	2vbkQzmffQHJwXQCipeS8HUPn6LonHiXz4Fd6mjAevt1EATWNkZQ	1
3649	2vaz9kD9c4utm8kRTUqjEyCJ7mjCgBAtBztbjCsC6gHsEhaYZqEU	1
3650	2vc57Y7JvKZ5pcy5iwEutY6SXMhYzoc9pDTpk2FS1vQ2dGC5TDvi	1
3651	2vbZ8RFXapyBi8dofDhP4WJhwzqiBYSzAJBc799SHtatzPouw58z	1
3652	2vavDv9LJbczsmH6gXF4gyok5E8F3vCrFAeRKgSVcKm9hoDRwTCm	1
3653	2vaUUjY2ycvoLHVGn2h8aLfs19W4Zdez6CAkMenrG32QDPDtRNcB	1
3654	2vahT5xBJaMbQ1mPQypuoayFAgCkyK9sxW4zTeRjt9dKFKxttPDb	1
3655	2vaPaFyCjKXN8h2RGf9i1hBGH56dRStgz8GV7xDiUbptL2PrKRqs	1
3656	2vaUZGZ4yEd7hEs6MtThhKhL5DHqdiGmcD5ExvJWhZHahxM5TLR7	1
3657	2vbrhajoqXUCLd4vZmQiQqNxnTVairkBkK5jf95YmSiP7Ar75X5r	1
3658	2vbXggCDTZtHURxV5fPk9RvcCqAXG6u3EKMjzTUZsb7Qi6ZkqHMz	1
3659	2vb7cNU83e6cnvkjSt4B4dD4FYHQ8hzGjLcaRHrAkFJiAAGgmcwf	1
3660	2vb7kYDirUyN8EJCduPGvyUjaRWGGhGiQN7xLsWHXgNFgeCh2VVc	1
3661	2vaQ3KLpDkgULNnrunogNJfhqKxzTK5wkvJiExbcvYXot4YpGzPW	1
3662	2vbMfZjqw1vtjAf9BVKxBdpDsdRGM37NF6L1fg2HKrP6Zp3uAqPv	1
3663	2vb3Zyd8C6x79dT8v2zw6kAAsyVpExFCemc4DcrK2qRCz2HKMu5R	1
3664	2vadhA9eviLsMwK6Qj7n9246YU8LVoeb2mDDKZWgtUKT3jL67hXL	1
3665	2vbk4nA3A1rWJvS9ACfi3Tt6LCnrc7iXEHw5Zqr23xoGQMLAPfWA	1
3666	2vbKYfuordYEkABBizShqSjTs13iysAfjPeDF7JfRJcGEvFSxfi5	1
3667	2vbDu8HD7atwkhKcVPqFFJk3HDiiVUxvUMgS5eaYWsP3j3bi9deX	1
3668	2vagNWUd2J59YcL9EG87eFRxLfjSrTRh8bB6RfsCm1gbqrh8Guxv	1
3669	2vbXsLQnjWfbGaAvG8tbxzbPWCbt6V4QqixtLxNdpcHyUpqX4Qz3	1
3670	2vahcZLqEjT8wXhnsa7fecFRZv4d4gLp9Bb29aBrZQPRDtw4kGPR	1
3671	2vauMJ1gSZLwBAB9y5189oNTjW6ui1ZiqGC8b9mFuBXLGfsJW2Ld	1
3672	2vc3KRPD8KmnCkzJZTaEBCsEwD1eVY5zFk1hcJVzZuu7T7KbasgQ	1
3673	2vbpM5v662y2LgKARA9SxUk7uaJs9Z3MFoNBzhBZuKj1oD5R1iY3	1
3674	2vbDh8sFp8xZVC1BwY9kbRzQdV39mmFWm74VUbUZZ4rbSExECiCG	1
3675	2vaxzF4FnDM1pRCHVYu1wN143Dz8ZKVHKQ8FHXsTBp9wBd7LwXf3	1
3676	2vaFFmvERmZVTSgkVSBQVPo3FrZpiGrhqzxDw3FToMuosMC5hqFi	1
3677	2vanU6NZhUeCZEQLey4TBhNRum4k3Zu9xyCdH3QdZLnzeM53A338	1
3678	2vb41dupkumGmuuwxyif9jTKyQG59X47KWMDThexajKHgoxaDCbf	1
3679	2vaiDaS1eaaKV3BPGjF694U36ZpCvj8qZE7H5XhTxu8skLt4Nij2	1
3680	2varGoWoBBWZnr6KkYrT9YPWvpTfVkBwAkQ2hscuizqF1TeZEtjk	1
3681	2vaNn5rj3DLVApFNaWRZ2hiqBgse1p4oq29CiXXq6z1uuTbWY63r	1
3682	2vaTZEVgPES3o4o9NV7e6btG88oBEBvLQVmnTzn9MYdXAh36bRtT	1
3683	2vaX7TExAjLsKBrQ6WtRRkFR8Z61Zxco8b3rWUfN1tbiorkALh9b	1
3684	2vbjcq2uKrtYwaGzJ7txGst7Hn65PCWzJRiHTjBkWzxp8AJDAE1e	1
3685	2vaBZsF8NyiSBodDryGhyrE93ARbwi7w8vCQvZWYX3LfDELfdEqm	1
3686	2vatiQRMXmoRf79M8q93x9yST5K76tnuWd98Q38AMBHqwYzP6jDn	1
3687	2vbEiN6tcdQJsWycxqhsEZdqBjrpub3M1DGoa1uTvmSMCE45yRFP	1
3688	2vbGHVjoSGNnhPG3r7mNvqMNhniDMReYfUP1WDxtvxqXCQBL4i3T	1
3689	2vbNWf2dz7E2smox4pko6SSmniNkWchqsy2bZbdu1koZRLfgQ1MR	1
3690	2vaPErpiAaFVns4sW3QmVRbp78y6Uy6K7t9Mxa1zyNoGfK4Ret8P	1
3691	2vannneK4Y7CZFjgXBhUxJPA6JYNq9xJE2XtpJLvr5aDpfxeY6LW	1
3692	2vaNhTEW1VtwZfTZ9xtPuUxSkwT322KTuhmnWWJq3wpL8yqCY6Wh	1
3693	2vaHGE2jzN1KzRAQnK4Jk1Nj4Tr2qoLrngDc9AFvev1RCgZW5VZL	1
3694	2vakQnvpWy6mYuv22L7LXZGh57f2GioN1RuQFsGhFLkNFsgDoFeP	1
3695	2vbdqwqyK4jmRLUm2voGsdBZdToNtuixYfqgNS7USJkhGVXyUETb	1
3696	2vata8UiUzj8bghAe3cb2AJrfURaTLXLmHxXd7DJdHfiXhbYDdg5	1
3697	2vahuEXxkLFKZu2SixUr5nvwEZGZg7bdk1PECTXfzJ3JpDwyqLkm	1
3698	2vc195F1MU8jTY7Wvu7yZAzfibJmGYxCYJGBLUmEYTSpd8ugqvyK	1
3699	2vbDUnuwbPutznB5yyxLmNjuA5i4uZBrTDMUAUJ7AdXcuhYkBLSM	1
3700	2vaezv1yozTkWmKDHtnAAuH22GFvmQxBmYcD8A5WjaDtbmuwV3Wn	1
3701	2vb5tKLAUZi716H9Py2sGue9VtPii8uYigxYMTU37uGJSRULfoDK	1
3702	2vbQ9uLadU4sFXRSVazhrZxc8GX4q4CYVGsK8JdsKNh8KGy8o8WD	1
3703	2vaMaNKmJGys5M3WQTtB6Kq5CPK3pqGZKpvnqWbGmy2EL3DLzkU6	1
3704	2vakKTuACqvEQcMzTjQe2fHobjnRBhYGZWdR2EAxxJViWDtyqcWM	1
3705	2vaHZFpNPNwSRJv18R8vzacPCYU2yKnQUHvKeagZBmBYrEoQAvj3	1
3706	2vadfz7AGPVba1YZd6EQqfpV9TyDiPM1HNXHCiBNJSGHTfWm2Pk3	1
3707	2vbeEskrQBY9jYuonT18DUNoPDPcmeWK6KUM8fjmNkpUFz5PDk9G	1
3708	2vaQYYi94P7ApwR555mFk3nnpofUFU5SMPYR2JuTQ19t6EqRQd1V	1
3709	2vb5R2Y7nm6BLRH4UmiVG8kpdYCx5L8MDvQXDeZrDvTGbsUZ1HKs	1
3710	2vbN1ZsVGr2iXpmVZAvm8AEyGWGreUNaacgEnzJAbvzU1bsBAHp8	1
3711	2vbUbLtCvLkDAoJ1F6AjHnik2BzKZvRYVEgQaruXR2xKKCNFJkK6	1
3712	2vbbXNY4Rkxg1gG7fkWdyEE4zE57z2CnPJhzYc5Zivi2zGFyfG3H	1
3713	2vah4zLk5Uz89hXgLwDorRL6MAXzCozUecskAt3BaGXhZeneBDqh	1
3714	2vbwUgQns3Ez2KL1kLWo8ii85nn56n7sHFn6qcLouKqQZATunXxQ	1
3715	2vaWQeXwX8gmgFM9574h4aNTGSa5fy7dRuU7kumiwv5s6g45dWgr	1
3716	2vbzNSogaGdQ8nhvsFoUPATmhMF3UPncwwUhoHYE7ZoPBgKvX7uB	1
3717	2vbEFyDhvFVxHgqMc2gMgAmC77sJuauaFCknHvShrU3hvWhcQwsp	1
3718	2vbjb2JBhyYWbvtCC2sAeDxs81CZd3itWYbXR8wqdTfY4jMnqx78	1
3719	2vajNFA84hqMpGaxHFGjmdkTnZGdWoucFkWQYN5aDSrMsLdTXo5W	1
3720	2vaf8THWznDZiVaxnGUDeDWedr6X6SFkPnDyQ3FdQgshxRKSKqJb	1
3721	2vc4zTf7RceE4AHmM2JuuDgLdaCCtL6so5p4Rn99XweK1Rn3WU4W	1
3722	2vbkTACXmXf2HX2mcNVgzKwdsyMRimezeL5k1QTecY3Vb4esMRHx	1
3723	2vaHdYsa1J4FjiZQE6nUgLxgjetw8aWrEzwToTSrf1PnWR5AMUFJ	1
3724	2vbf6VCsppAH3kqrRrYxt4j1sT2xggZ7AwdhJuQT1BU2gXLBeaNc	1
3725	2vb4HSEaL2KrXioyazTt38zbaTuv9cfWp9x5phSpLrTf81DZwSgW	1
3726	2vaMTE8M4LLZ62axipnG5dMYGCrNr37dNrWXzpm75vUmM7HYeqzw	1
3727	2vaRn9QqQPb1K1KiX7v7VnZHb6WhEDT4nUmDprq863dA53antC2B	1
3728	2vaMFUwRnYfRXAqarhGwXCYAWoKEfHtkmDnDrTNCmy9tF2vRjwzy	1
3729	2vaKHXhGGBTsaC7o2iQVVCZgZSsE8CphXz7ekAQitnzNm2pb8rMd	1
3732	2vbSfzqEFZscuW5MYK1xGTHqgxyWagBmQbt5EMySoPNaCBAtWYHF	1
3735	2vbbA4dXraatrjJCM23EJqVKeQMoBqqxVaubKbqFbJnwyd545VP8	1
3737	2vay7zGtGCj22cTe3wDDrSSNQRCRkj2MueGK7tP1Yp9M9N2rQ8yT	1
3739	2vaggLNVit9NBdSnw5SFiwNrsy39rYyzc74BfAtQPZcfKCmUsEW4	1
3744	2vc4inA5H4hVQVLH6wxC9Utq4Mai1hnt1MGFZSWfVQuSaT3PRt1i	1
3752	2vaAKhgAmAZmHsKVLUXAhrTd2ZQbVduvpaVfZeJrhkKEg6Dfr3nj	1
3754	2vbzggGKVDzxm3vN71LWjUayvcKfwHi5tNmfUjmZriqBamTRkuzi	1
3757	2vbM5V3Tky5fHbjQBQt9jwWfAuCbq2wgiXDrnkSiGv92dBq7iNDM	1
3759	2vaxsjZ8f9Vuyw7siy92aUMUv891hLpbngyF49KQJ7bSyEvoNzqA	1
3762	2vaDmNFkfhXGrAqo3e9zphpF3XRNZqEZqueVmmL6nv3gg51VfTrd	1
3769	2vbo2WkZdALZeypcbRD3EZnG2XXRXE9dXYgURSni3eziMeiSghZn	1
3772	2vbm8FkP8SkRUkvQBkt1oobQM3QGDhQzHYiRYqS8JxhRNoVvd3YH	1
3776	2vbS3Nq42kznq5GTAqwUdjh3D54EmJDXC5pkunaUVAeyTj3YGyLo	1
3779	2vbvnirhCnegamA7R12REK4DaDBdfmH9CtVs7mqrBSjPU3tN8dtJ	1
3782	2vaHPPWgBBwXmmsmYBsg7G62WVSWfdyUoW9aeycFBUtxr4jBhUmU	1
3788	2vbbwCdbuP45kKXony3yZRHhx6uazh7QxXex5iZZcSS85hj4siZd	1
3791	2vbgkyF8Qm7CBLD5ZGNzop14HNKk16oM99k6sJJe5EVAyFnxq8mz	1
3793	2vc2vQVjbETKZtVQkPmPymbjH414TaAFXn753FXFMcVVMiCZheiM	1
3795	2vb4HqYFV6nh253d7H7zDFJnMkXZ49ZdcosYkzNTRubytSbAe9E5	1
3801	2vas58KM1D9KQjNwBUnKF8VpQjPLcvXrN3pFYiEnRicRb1gu6djv	1
3805	2vbq2eRwwErt2e2LVdSi5zLeLbAChPa8VJio9F6sKDiNB9paehkq	1
3807	2vaR1cmgsEq8qRGmKSeXWufJCQCuhfTi5Cmc9Va6kGAV8KNy9hcG	1
3812	2vb5AE7aQYTpyjF88GhB8rWJ5PDDk8CKGF9dxzyvvNV1vSmPNtJ8	1
3815	2vbmbzhCD2kwU2vcCNPLeVUu35i2eFQPa2oSLZtDzdc8j2aPxvPK	1
3817	2vatgEqSUKWGAB4Go87fkBCmp1iDQpcvqtVmhWYWPSZuJHGFpih5	1
3820	2vaPfoNewBvwQgibbMTUnBgC1VFWtQs9JJvvvSCNammFaguGWEkN	1
3829	2vc2GfUjHmxFyuLG4uUjgBLVMV43TxxYaJPspvfaGHqPMFNcL3cn	1
3832	2vaCXKXH2yHy88jXBZtqF1DEr3vvJBY5rwqiZpdAq5u4JPdMUj6Q	1
3835	2vaVrR6GN1xxMbRKQVc6Bt6mYkDgS2kw3WfYerbex1NfwafZEFAm	1
3837	2vaXNB796z1WujEYBqieQU2wuraNQbuoJx9DbEvioZJgKSDv5E1m	1
3840	2vaVbTG32HWZdY1CiMZtymM3zRbWitMvefnH5ykB5RB2mF8rxwZZ	1
3843	2vc4DB9qj4b5JWkkV49xzCk1PxZNLb4HwBioVsnHUCCRaLB2FHEh	1
3847	2vbdDjKt51Lbr3M76wyKHVYHq1GwdPzPt2WvuP61etM8h4nDX9Jo	1
3852	2vbs8StGMUJxDhjtBDfu7BSB8Gqwuo111TzRoQnEbwR8ePtPyquS	1
3854	2vbvzEYkv28EPQwfwnWZwAgFaFb8hEwhqGkUdcE1EUJdQGgvmtb1	1
3856	2vb91XUXpuj4qwRmcAbSMgsj6ocqvEuLuBqdEYX7dbbDDeiD8dBC	1
3858	2vaGZZsxV9bUc4SmmQQiPN4G5xo7CTjPbTDZtHERm3GjpxhvS1E7	1
3861	2vbu8SB5JznstrkRZZHUsA6QosWfZPfyAuhjnS9yR3umAEwPGPzB	1
3863	2vayVKQrZgT5SHajLPcQg5e1nWZ747bYyPAQgQPdWzRrNhV6XhmP	1
3866	2vbfTnFjHCo4vCLM4HjLWFszjTUWQZg79593n3tDVnHiPYTGo47d	1
3870	2vbvxCc9Cdzh2qrhLhPggbDqizdnacn8WiDA1FZ2HNY99agZzeNm	1
3875	2vb2hdMpaFvQr4Pby9Lrg1mXdjyqQNz7LSgMBT9uiYMzRTq9xHRv	1
3878	2vad4egdS1TAAJvUoaYVnMZkWnbPJy8tEQKu6xm49KQ2qKdNrPoQ	1
3880	2vaKwKbkQtn8rpZKpSsua4iYaXRpdrQ8uzk4c8ba6vWyj78Cdc82	1
3882	2vbWJKmtJjoaYNj3AzQhHEiDoqsLkHu6G98iKGqSeRMbe7Y13ce5	1
3887	2vbwT3CP1PueFB4NGjX9W8CqjMBUwF97FAe3qkLPGhhyPP6CHeua	1
3892	2vb9MVx2CJxzyt7MBprc2nodV8dpZB9jmSiPiL98Ch7McS6g81he	1
3896	2vbLTgz7y44TFZD6QfqGhiWTJgBQMdk2jDaKiHWXjtw6L4vBCDfd	1
3899	2vaDFDCNV6gaEhWqgddTVXdgeH4LwNo9CFDyP8u6Xm2tKrm9vysh	1
3913	2vbxnJsqYYH92YgA5D1ZcTggRSB3yRXPmprjJMWQEmdKdyQ9xZVw	1
3916	2vaF5f3ERq1se6GJhH8wMhBnU4Zb3Kd9cZivgCKjKA4sb67mZcRJ	1
3918	2vbTeAWAZBHZuFSuQXWHHPEjrfokPRrsLdtYy1pB9T5b7MJ2Mfxa	1
3924	2vbcUeHsF5reiY6aVcC46RtnvKtq52eu9jkXqKqPju4SPNpbMnkq	1
3932	2vaEM2xA6G13mkkNDchBN4ruvUdgqB89RiL6PKJqbBh8D29ezNJh	1
3937	2vb1BCAK7p7Hxr9xVW8JjATu23iXoiQXs7frZc7sKs4c4Bp3GMUZ	1
3943	2vaLQpp8AY96hAw3JqSoiStJj6Ahdtyd4RQApSj1nfTzNokHRiN5	1
3953	2vbZbPy9zBztZeGxX5CDpXLavzTz2RFbSmH16CmAEgoe9nn5ofkD	1
3954	2vagxuMwBaaJpJw22ej4GdGUN2uq3qZvphumgSSro15RGzuyft1j	1
3965	2vboekUs9YcuepfU87SJYrrkugY5CQ69aCifht4YNUKYeFPxTMFt	1
3966	2vbxrnswKKEde8mRtYE8EsC4MDPhZEQN9jVy5x62bf55eyeidXNe	1
3969	2vbVXvtUmpGiSdeRRZnqrtxjGNXxq44qnQPAu1GgxxB8oPCiHdiy	1
3981	2vbzCznTB9c2hc5S8kQHaZXT3ttBo8FQvJnVmZiLNe5hBdzurwSH	1
3983	2vbdeBK669JZXUxHe718MbGwLAi9ukx7ThdcCgY4c9DtzKGf54VN	1
3997	2vbcp2JMFs51HrB3Gogon4FgvXLCLhP3exGZ44JjjSX1yt5NKP8T	1
4000	2vbuCu6Wm8HxLLKc93uxqbRUx2wh1tLU1v31ACAi376fkN4KFVnt	1
4002	2vamAChZ8nejaPTGShmQKye9xxV3cbwMtWuwBCALU7qnKwSa58M4	1
4004	2vajjVFzQwcorSReMLEee7nVHDbZUupZX1w7phBoZVsxbg3ivms5	1
4018	2vaE1q7qPecUXhQv7JJrvvWNEfoFB36oWedtj2gFmLoChiKG4pyn	1
4021	2vaozZe2WVymec9C3BootfWRjxHh7e32maSa77RbTdDiSYiB2q17	1
4023	2vaYrxm9frg3ZURV4d89wv4WxZ6nJKNsemthBuYXD5HnETvUSwUW	1
4029	2vbQ8mxAdo21YdUFZ4JcrbSrcz66qNAhZN3qPY8eMMqZrjP6pq6z	1
4037	2vbYy6uMqLQPPi5n825TXkgP85FDkrhBtYdaSntHFoo6TFFPMnHw	1
4044	2vbfbYPMZbxPV4v7AwuifzVcas7P8F6Te6Z1bSZ21yVNV71ASavo	1
4046	2vbw6uGWwT9HYkWnri41Y92MoZRTZHJjThuBveisnhpK6H6Ky8zc	1
4051	2vbx7cdEYy2t2n9hqMCPfdawAzotuQFZabL8aEhNre5aHPBzk4eV	1
4054	2vbXncA2YjtELhTkaLNmmPRwyiDfgDVBaUD7JnQ83tYwKJMEkPA7	1
4055	2vbtDDzuR4XnLgw9TeYr5VGPFDeqEfe11DUrbHUAHuyhpxVNJ3uU	1
4056	2vaJyY8FW7VLkufjbZ9eBp68E3zmhLWLiJUdVzoh8LJuWv1A3xuq	1
3730	2vad6knf6BxP1wnq8JUEtjp1EuvSmyapiXP75hKYH84CF8PjmePf	1
3733	2vaaY4P42YkWWv7Cd7ESJM7xyQLB4yM6wPMu8UCnacLk19Lrus2f	1
3738	2vaJcZkjBEqdFL3oFNGC4EfHKMMB4qjNvokpuiZ5v8m8CV4k92yK	1
3742	2vaPgUPh4mRnKmCSkUDzw3AZ5XS9HQobLFVjs87H6q3UD6WZgSKb	1
3745	2vauVH3bMJ5xs8nKHGjjaAAi6KNtSXvA1BXj1j8WaYrbinJz3cC6	1
3747	2vboMWz1pPWriFthv8z86jWmKrhpyKV6iySC1wo2eBVSZxmqm2xk	1
3750	2vbrcjgsKZwyKc4gAUTdwSo3h6kAAR2w9s6DRKEwGvmRwLiP2DCt	1
3755	2vaAbPmN2dqMvL8YWv6CQ8awMDUqDQ2opsXXcnYQ4LDiSuv4wrJ3	1
3758	2vbbnz74145ug8feddh7ZJZm7GVb9w9iY26Zb2dTfnCjCyYkTjfY	1
3760	2vaGMNB6CfcVDm4j8UoACaJbGtTunWfNdjzJLT7Nv9sFnhDdq1Wr	1
3765	2vaLgPQ1WaSPkidGewoFXKVGp9JRpV96dUmCHseDGTSWTQFqVco4	1
3767	2vaRMW6hE71ogKbSEpb7RZRh9Lc5HxPyUNpNizc8Cadgsoi9NJu6	1
3770	2vbrYhbAjRh4h1sWaNcscJBb1BhtRJhViunmbNjPRVPbmsHfydKu	1
3774	2vauGMczAAH2WGEcktdKLnG4zikwrM8Kh74NRGftkwcmvBC9Ux8Z	1
3777	2vbMiyJ4mn3DS15BLQU67v67YVQFc2iBPZAas8QDvzMb4a9iDC5S	1
3780	2vaky7RQmZa2jCDcmHGUER1kjPXJE2D9fr6V7ujuyTenugzbtSvD	1
3784	2vbQG1Th5dE5jVw4ugYp7jxCp9JEAGBv3RndLKdAScquwTDuZTnw	1
3786	2vbvBRvBbixS9MBwW7HZLZ7C8pTkjuXdFzjvng7ado11rqYNGsX1	1
3798	2vbmDQq9j4SNrh1GtuB7y8vdiUtxBTy6taCeGa158q6NfUPQE7av	1
3803	2vb9cV14HH1Gpb7EHD5hRwomtUe9iMpkZNLzmLuoKuEV76AtZnxU	1
3806	2vbnsQeQvDG9bXTMUAzjjRctJxDn6gEkLrkgbumfsq5kV4CD5caH	1
3810	2vaiJco4bpJLbhvrNiMFq7VbyeB9S2kpq1rTjWL8zLBKUXnRZiAu	1
3813	2vaNXgeNNRnQ1MS4yQkSp9jN6pEJWgPvktZhtgp3vjtD3kMJk28E	1
3822	2vb9PcdTUdL3jM4k7djTThh7QoYweaRUVzjCJeBh3HD2BgLCakm5	1
3825	2vbdeopXAcJEFoWficcAmeQv4TWUbrdJX2t1oVNNyFNiK8Sdiizz	1
3827	2vbNrNp9ZkvSNoiV6Drig34Js7YB1Byh5bcHjB6nMvMXcTFwNJnp	1
3833	2vb9hdd7h4zqgLrEchrhq6taQgYUGzBz3NjNjthkG6joyo2PswX9	1
3844	2vbmBSF8GFgU9xjwh5e3R1TmUEwhRvMqX3QyYDvj4kMFYG2jSUBY	1
3848	2vaCr9FBrkM1FcCF7WiXgvezQV8oksmqkVsqGHx8iPG5KPxXSN8v	1
3850	2vaG73T8SqXhkKZAsfLhgT6LQv5RXt826MpCUjLMUsH5uZ9EadkF	1
3853	2vc47gBd8TyxvnbGZvkqYXPYzATdBtUGVXRFREwEwJ57V5iPXUMi	1
3868	2vb8Jj9EZf6SnErGQpgv8mUf9BqbMnAQsDhjF3gVNgHXQpGFYTVv	1
3871	2vayyCNF3yuEpsXU5zPJxj7jyT5cTSf2YW6G8AR4vXGWxkuJm3Rw	1
3873	2vbb7yqfQnvLr4tUXHfGruK6xVBXNTqD93SoxyiEwVfaDSouDAGN	1
3883	2vamwKXz2uNuikyTCHAmA5xNp1wvQpqwPYHTZe3bRFWPVUoLDuC7	1
3884	2vbrc3G6aL4WgAgz2mYLkUBx4hMikQEFkNCcoZt1kDPREAcpehNV	1
3885	2vbL13JKkmwF9sks7nmyRyXKDgFAwo3XWpnCAbkW9xX9hzK2LDHb	1
3890	2vbJTwR8B3XcFBvkh2MMoR8gjfWc2Mqrw1xnda9tqNjEDu683Amj	1
3894	2vbYWjj4e3NLudcW6nnTCeShQMw2GLkJYx8rPNZ5GMW1rhng1ee3	1
3897	2vbMLtjPQGFwi4FrLmRnFTXyrwFkWhuV1iHYFmLhxP3Bt9XxQE7g	1
3902	2vc3sm1W9NuPCx4RwfDA9ZXFj4MHT7XshQfE9uij9j9ztnoHVX5a	1
3904	2vbWy8h3zjQYMSubu2KPyAB5FMt7WpZFuG33cAzzyJQ9qnsyY2H8	1
3906	2vbB7nApT8FnvQVBNbCNGYBsgdquurJTtw1FQNb3N1SqTK8Byx2f	1
3908	2vb9K4mQtXmr9hBZctMuJ1stfDnYcXbTzqBmx5ZgJreF9VnmxWps	1
3911	2vaqHBMdWatFZq8ZHMJ37ordPtbP7SENWCnq88EDU4dqRtXR6q6o	1
3914	2vbPEwMUjFhx4K6hSLtgvoSZcn3NJAZbhcacR3fuEry2dgax1dAx	1
3920	2vaz14g4rGZ8HE67xwpDSp2tBrbVnFq2HdVLGCKafc8nyCNycHEX	1
3922	2vaYNcwDrANoaFScShqPXJoVQ1EhW6EGC9SBTmFDPKBAyejAFznR	1
3925	2vafxDE4cEvDsyDG9vLtpJeQxttimRG1HuAxpS7kRu4kugypw3aF	1
3927	2vaN59uiRbs7ypQMTBcqnAUc3bXJPVZKx4X1aaYrFcQFiTMYGArz	1
3929	2vbuzzTWCuREN7ekxNZ7XVp2WJajZBRqLdz7dKagb1J9YBDhWFWb	1
3930	2vaaCzbkURLomQkEoVgJ9fUuBRCG94y45k1sNonK6F8dC9nqJz6V	1
3935	2vahCQKMNNJvtKJGr2YYoA9ZM2nB8HNJ3dYi9cxUoK5VoFuPePyz	1
3938	2vbicf22zxAT3drqTQLvACNLhJpUu3261xtiqCc8g7s2ZiirPzjA	1
3944	2vaccVinTQRSm1go6Fw6zQipPJvXtALhNKyFyJzPQ3FfGGvoqkkQ	1
3945	2vay7JK76DxsbDaSHMQV6NDzJZGbdcD6CoGhvFVpGAbKZ15GS3gk	1
3949	2vbdLTWwhSKNG4EPKG9rKYDLEmvfyLUPBLpHk6vRkztEUgmjgwgM	1
3955	2vav7jzhHeC1QyVGWK1RJBHSAPY7raNHKK7hwGEetwBhpEcS8L2T	1
3958	2vbMw6nUoN5RkP2U929o2Tgt6DhQW93Pz7bRS18sEM9TUw16Tpjo	1
3959	2vamZ5axceL9ymodRHXX2eE3TmZ1bwQgCVpcpYGi7Y1cCTgvF2Xr	1
3967	2vagkHHGhGZmNvP5ze7idsV6tdFxzbW3nv4xfQGRnsANAJ343k5z	1
3970	2vakT4yaKfiH98GRJ2XX5VHqeLBkvkLP59BrJUiEcMbmYyDjoSsK	1
3977	2vaBKDfSoNFaJpWrSy9jBjp8aiYqMDe4xpp1xc3mz9yWXSgfFzV3	1
3986	2vbGnWhsBdiRZypJiymBBBQqBct6bUFpbUv8whRQqDtDkM9MBGgV	1
3989	2vaLczSVy1HHPx4Cg5Dibmjkc3inf1UhmVygo93Qk2esA8mTnkjz	1
3991	2vaYgVfHtVjcLiHZ1nz8GoiU9JjB6PunqU2tP6kETA2mXFVVZjT8	1
3994	2vbUVZrwgmZkEktN5sb12FjTmC2Fs4qA6K2N9r8FTZVXuYdiCj9G	1
3996	2varuxeuRyjYJPq9cFroZz5Qr7N8f6C8zF6PfdyHiEmd8s1U6Rk7	1
3998	2vbXCKTwDoggLkgaCknTrCcTpsUMmMYRFmN1GnczMgFniVGRwopG	1
4001	2vbBSEXPqRhzp87iMQSgGStXV5RWnKP85VdHGXNfWh6wyzByagUK	1
4007	2vbZHJURosURREQBhMe4a5nHVZKYNWQTjiQ7eNUnbYSPqEUmKRoJ	1
4013	2vbWPzoWzxbbaspCjUhBgz7ebPkQhegeFfUgy68saxxyUBDPkMJk	1
4015	2vbnrpVEhmoZF1EGXEeMdi4Bet7e3JxZqh61pv8TvB2CvpDNVN64	1
4020	2vb45mmjw5TP5GfYSp6hGLoHaQzYPtRb6ZxrxWUHzZCSXJjRZwHL	1
4027	2vaJ3zf9c7vFad533ny8BZkZqCpryH728uyAjydMFjkTwc42WTz2	1
4028	2vaxcKFHcy3zebemRkAw8MzwFXBrWCm55iZ2KKpfPH4X6thmfFsU	1
4031	2vanfnEa3QoWTwB2n6V9bF98Atang6yVyZoTSqWxWtV7Y1cL3b2L	1
4036	2vbAdcVCxkw1BsD7FDDuoSKZfo4Si6UvptRZiEgtRsee9crpjxfj	1
4039	2vbPn9hTWMH983qB4JngPvvCKmxqrNKk4M7jyiEGcVSxaCDz5LGH	1
4041	2vaxxtkuYeXot6hbzYjinZFbNWU1wUdUU8qdN5VaYkY85NhRCF76	1
4043	2vaE6gQFewcKKt4ejhHUQYZjUY8UPMicKMebHPn1tcFUf27kDhwg	1
4048	2vapCFrWChEg1X48MW6Ktpkcnk1TgjGJGbWwnMs3bJsvYrfjsTvj	1
4050	2vb5svD4u3wAmaNVJcmAXtjbrCa1ce8Un2WLW1vH4QxLEEQTqEHG	1
4053	2vbYyDaudyya4KDApxsgxPb8fN9SQjPdj4J2M1rDRc9mQY6dTKFE	1
4058	2vc4JxPntgMmZdfhiTY5NMhF6AyKGb5ZWyAoVkLxBqeBJBqPJyvo	1
4060	2vb6aZJj32jNRQHz7EMJqLvQMiAfRNZzm72Vqkgr8PtW2JLGEKR8	1
3731	2vbfq3baaE3TZpntiXuJx1McZE5mzJkyicVaqf39q5yChfhnvM8z	1
3734	2vbfqeNwT9spoeHh9pfpLRPQUscc6cS3n1VygmYNw3UdyAWVWMzm	1
3741	2vaTqYwBSNmN5FgPyHxMUqt32swjmSVaU6mp2BR8AavWw4ojdryP	1
3746	2vayfKR3PqCunXAW2dat5hDYm513B5epDbAuJMaYNkZW67yH6Voi	1
3748	2vavstZGMUF8dxjAgxjmKcBDHSgeNAmXNW7DmYYqJjiCFuixrrnM	1
3749	2vbCvMZ8Qbpvue5e2p2xfW6HDgToEZQJHFE6teit9wpGKtzkZWWm	1
3756	2vb7dz6uEoaLWLfYTZNGCfoxoKLtbLkLXmuugk2RYCyaNt8p7CXQ	1
3764	2vbKp7tVkCzp4ZrhnbfMqgWUpuebHxhEYBpn8ANDQVCnPRhuupcr	1
3766	2varZaKAw4NmaTbemLByDyxdyDsU8DjLp4opsRiENsMbZMf27Fzo	1
3771	2vaymGCyeEMgQrDnxPs1VhfyAZXapUPbgMZ3pkfd1ZjP92hZcoUu	1
3773	2vbjXCb2cpC7dArLJmXa9QVCsPZ2ivYEyMpnLEgEApoPRr7N8vwh	1
3778	2vafbZMK6pGJTgCryHQBAnbEmRfdMqXQ6eyzeueuFwkkdiZtu7ov	1
3781	2vaHjcwucTyaZzxKPEwbMEyMSNujPc3XukfPtVeiaTQQtYdBvym9	1
3783	2vbSh65QxeyoW51t7xoC1gfjVh41Zjy6TfBTjA6g1bGZ2jfNtB4Y	1
3785	2vat8gMQnsEzso48PPWjrWwitrefomnhbnaaAMvMCxhgi3Ucxw8j	1
3787	2vb5pBJN78AFCaWKVA1ysAp1ztV4XdVN8dXkemPQqMiuYyVSvYpr	1
3790	2vajsZcybtC3pZK6jqXqyQ1ZkneBHq5Zo8yz4vKg5csTQoNqWzpY	1
3792	2vaGfNGcTeP8XzaVL6ApJBf9HzrGNj5EvoXF6fL7jZAQy6YLW54T	1
3797	2vbd1v9dH1NhCsXEM8vFBfpCYVoiYB1yU6b7mL215Utnk9ecSzxa	1
3800	2vafFnioMo7GiUmbVmXsyCHHMuASs1Gs3v55yJkUDHANbum1M6oL	1
3809	2vbaQ6tNwSxMrb9XP9JdYZ18Zj6tseTZTZ8G2e62RPRDfUvaArrp	1
3814	2vbKFbSThohFpoAyGVV3UpCMwEm4uVCMCuxmg7QqAisrQC7f9LuW	1
3816	2vacieGNWMciz7UMBtGbNddbLbyWRuaXq4G6Zt8DnRGvmT77rFBa	1
3819	2vbbp8SWHYNqmRNu3F3LEwGnnVVkLYz3emszb1FadK42p5FMNTuv	1
3821	2vbMdnoyfoK2c2HM1kSUMicgAwssTC1vKGfWuJCfqiFbT3zWKbUq	1
3824	2vbyZ9CrSQiNfMBwJxzTP5Lza8AHf4nWFuTX33LjpPpmZ6UoxQ7a	1
3826	2vaGxLaK9sAySh2gW8egvRBwZvczgYZ8MV6FEv1HCqnQdkrduafv	1
3831	2vb1BvSqrperkMsPGBaWJBkf7ZtdEMQ2C8BPMyxmaRCwt6AQG4RC	1
3834	2vaGukzUii42UawPHcZRNnGrrZgA2Bc2WPKAeyt4hweH5A3h3zgz	1
3836	2vbh7XHmxcmZgshP598wgAAjVt6RbhkPAPozM3EjSon1p7UTXQva	1
3839	2vajb5TxYuVyApD33Bg4rFV268yoqkiR9g3GrVt8vgk5MPQZwXSR	1
3842	2vbs9snkQ8QY2L22amg3cAEVubiP6yZbc4sid4LSEkEbiRrSe17K	1
3845	2vaTwCnyBTyD9oXFpjbB68Lt6V7uVLmhRsgT4LyroYC63rT1n94i	1
3851	2vaYjvnTbkqVE3z5SLFsf2kkYQXQyPKaYVCocVNuwqvWkA9vYa3e	1
3860	2vb2rhPJi5RESQHCVd84j2FVau64PxdFQdPXG1VQTT13LBmrMhtx	1
3865	2vbL6KtbMnKXnpq1udZuMWQF5cRHXDdQHvwDG71NJHKrkpZWm6UG	1
3872	2vauGbi5UkHAunv6qb1xJyE5xzShX1uhA1AZFGyauAs7jwmM7wCg	1
3877	2vbjFQoaRmgemwmqPTYoYLDpH4jap1DkEWiU5a4EKVWVPxEZWB42	1
3879	2vbrRpwbjgK5vffWy3vUT8uPVmvuRTQJJpijnoKTQgSUAzzKLXJD	1
3886	2vbyJcHBZdgPnGouMFzMJRdX1zZjaRunEynCQsosw6Ubm5tQFcQv	1
3888	2vbHG721gTGepRrqNeiG31Ac9J19KpaAExUE8Wa7j9sMo39E4oVt	1
3889	2vaymk7mUYdtVrskaYtHkeJeM9fnn4sGESAifHcsRMjSQxJ9bcK1	1
3891	2vbwWNfjTqv3bca81JdB4Ms3Eos4JbvtmiaQWXMb7zQ2u28eceAA	1
3893	2vb1qSgstzg2VeypDXAhVwPwcngcZ8vNXoBHCzBmPLajt6Sox2N8	1
3898	2vaHAdgaBXn5GDvQeED3he7AgqBXELMYXiH2goafo4QWHQWhjfz9	1
3901	2vb3QmgRoMhevE41ouD4SaZYYgTVRuUeRcNvcFbqcrnYo9PUB844	1
3910	2vasKg6vZi4n7xQzoLYGKVErGi5jniLzvuhqW1v92cQwqB3ZDrdC	1
3915	2vbz6bSyQycLwzoQ7iviBcohwVx1xAGkjPq6pVr4J3X6E3DFZndP	1
3919	2vbec919aookcKQxdsjhb9ZLfMqtXBQZ4AMydPEgJqUsgXjaBHRe	1
3921	2vbmyWcwUWYH7sXwUG9476t2ou8hTotBCzA9jT7RMwbfaYda9eY9	1
3926	2vb6AJpCkat9F3dCtsX1oH5iQ29GpmYWzZoV9kFejM8S9h5gpqdc	1
3931	2vapJ3tH7iuXUNQuF9jK54sRzQEH8XcDpestLCPgK8nJZcvoHjcb	1
3934	2vadoiwSja2MCJNLX1AuXZBB7u4CV8R4vFRnc6SeWWY8vTaiZPwe	1
3936	2vaqmssEUM6eR5724pDMYKSQzBAMKBsyZpPx71T6wcJa3zMCP59d	1
3940	2vaLcDX1CWi3P26QaiydbnQL6yNiAdWNsLh92zD2sPksDmSBHJ7E	1
3941	2vaSGCgkQ7erw24teHrbQCMMwMnDvRWsPmZdmF3TWPAzd91n9XiH	1
3942	2vc3wTtwFzuy3F5MyZgDdknUYxZDHPdo4hRc7yocxxxWYs1PZ9C5	1
3948	2vadbgUitihgvjvbTHpETGUf9i52bTJEbsmqTuW1P9R9EooX9rpK	1
3951	2vaCwePkAZiz6iZaqixNL64MmLhGpfMjYWsnxVVcyuSaGryvSp1T	1
3952	2vbzNQDP2k7G749wCuWSVD19Gz6zuCCbUStCkMSnSFmJzUX1ZXcs	1
3961	2vaTGpwDmAJB6eWQaXbqWzzSGChBEr2ucfXV9oweW9zS7C3FKLiM	1
3968	2vbDaXJPT1SKzYf9x6XVxYpnh4UkpLHked83CQo2nWaHW2Q2CSAy	1
3973	2vbCZGkWSFtW3bM9BrfhBwS9nsFSpWk1YiXKzaZGTjUbK8E3mHFA	1
3974	2vc237pGQ8bsMBhhuf41j5owAU1HXEbBeDMckUnz82EGECpdHpfN	1
3978	2vaXxvE1xe51Zzkm6oHGCL73TLvEURgcNjCydf3xUfU88Q7f6FpQ	1
3980	2vb1A1RoSVGUiPZfoVP57FVbxr7QR6ozBhF3QHhsPLwkvmerS3qz	1
3985	2vaCeUYxdwnim7njhYH5bNuVtCtL55h35ZQPEAni7qzSP985fKgu	1
3988	2vajY7tyYNLmmjqy7U3YfEvzeLMQRwxWkwmGzsS1HvPGbyZQicwN	1
3990	2vaKKyk8uJhMfbjPvBNDyVn9fhE65LnR7GxPckHNdg1wtcgKGXMb	1
3993	2vanWQ7dvXivGHeo3Hha9GG3wXc7HT6RGhJZ6Kgyp2Rxh3fNGmPu	1
3999	2vaB51i2SUjrfyydkRZ8S6tEDZh5xtduKT7FR7QNW5eL7yKU57Pg	1
4006	2vaCWN98vbWYR4skCxzVEpawwLMKCPNhevEU1mvQZBNWfVQC23iW	1
4009	2vaLezmAoreMguNan2DSSCKX4FBoRebwno5Fq4bkyWzqDNt6N6vD	1
4011	2vabU1dKTKEnrsBo6dsLu65QKLKu5EiNLpPFEuxDNzhtgjXdtqUw	1
4014	2vbYU6pwkxHQybAQ3gNheEhmgzw2792KPfAL4936UzcY27HA3TnM	1
4016	2vbvmyTNbavzC5NHbzguouDuUFvgMdz9MCiVBHy34U5PrpgLJWhA	1
4024	2vbT9cQgJw2kVJ8jubrcdesBxaMcTpGQJYBUDXrjDt39M1kNmneF	1
4026	2vbHdDfxFvs17ZsAJn7h35v9WVDidhjM1oHfgsgd26qoSZ3jewG4	1
4033	2vaphKwkiAVFLKqgbceDESTyoeM8ZYLuBWAUYw2t6NtAVuToZr5v	1
4035	2vb2FRV5QYWTX7bC7rxPJkdxw8Hwr1rXjXAnWPEuMhmcEHeqrTzt	1
4038	2vb7TZRVDmnmMhzDxGWQmqAxqYZiSYagFYCTKYESNCnNg9WAQtkD	1
4045	2vaGDxRrKRtLRoHr2udeHW3MXd3Q8q9PdVsgwhEw1FmiMsWE7R39	1
4052	2vbfUYmbZ8W5zekF5U2kcZwrKXeZELEP4PCMDtaFfV2mKrXtk1se	1
4057	2vc56Jj9oWer6bbfwvhFPBupVbqin2zvUwG5ubpmtbZbk6rdrfhd	1
3736	2vaomxBZrzy95p8Szm3Hs9uyJC1cswct8s8NZtCS4nzv58oW3yGs	1
3740	2vaWirGELUgzbjuqmdV5Ebv9VqcnG3ZrQ1hEACmo5PwjGCGp4zDG	1
3743	2vbUjwPrWMSHrFrpmjp5riz2cEckdD69mduVEiC8mLxLd7MpKBCX	1
3751	2vbhBupzxaFD14CKJ7XW5VRw63AtPKKcxeAuXLRCps3yiW6BQqqF	1
3753	2vbvh4QrJu6CtxY4hxJxC5tb3XpS7WVS7YaaGSAiah8fVKuSqxvM	1
3761	2vbyDDehSBV5BrQJGCm6WkCeHbwmF69u2am6L43Tq5QKXGSkyWov	1
3763	2vbpaoTn1yPLmRD8ta5gYXTrh4izRpukYW3JT3fQBenXpcHT3WQC	1
3768	2vbCSEpkUX77EY834LgYB3UGzStk6ZWa91GYvDQWQ8ZcRjRCj3dM	1
3775	2vbiWWkcxsW4BBvpF9TTMG9hdUmMja2j2fvGtTeucYC3fxZGsynv	1
3789	2vbz5snHi4mNxiKyU6WzVwFBD5nivFx7ACCrnbKPSn9cEDeWvtcM	1
3794	2vaPMghjMNFurXMowoHDqDy7kqsho4juFgWkZwovPfuXrMP7s1M9	1
3796	2vaZjGMaNxn3B1bMs71nSCndWKwvPLJpzGLtZDmQLz4k5H937aC9	1
3799	2vaUYwdxRCtBTrewG5JZsyboc4frJT72wFGAcTU4JNtiJGV2W8fz	1
3802	2vbDPp2iSB45Zng7HKWDTnpHysGpLEiJhREoLySKECdzzbXxG7Ld	1
3804	2vaSqbE9tVft8uDvoEZFJiJMEBC3HPoAQmimQsUDnkpKWxQnN84r	1
3808	2vbwZp3Hf2RwKTePMrYESgNaSarFw6HL88h5DxqeGzjuQE7wuCFF	1
3811	2vaRkdL2oUPApFXRQrAshihpxZ7NC53y3Lzd7LgjwJotNF7dTLbH	1
3818	2vbxaUu2dL2P1WuFxYqXw5Y2BEmF5nfEmGe9XGYfKBswsqJipzPR	1
3823	2vatp9ZsUbvo99Qp5Q6Zhpu6rZvohciEM5imiuzBTWv2hqS6tgEr	1
3828	2vagQZ1KEk985BSZdnfoKNAT15HF9sGvcZj2ixUMYbAbs3J1DAhM	1
3830	2vaAAQgkDdZ7JqzxiS6N2DUwdNJJMjVbkh6B9P4dP6zJrEmdujxk	1
3838	2vaExgafowZX7AP2ShB6jk5ymd2LDGb18ztUy79x4SJnc3bTPLhc	1
3841	2vbugZuUvMuZFiqoAe1XDeStpnLJ1TW1cBSfS8V2qJZxcHUmxjDT	1
3846	2vbDgeZ6k89LBJw3NH8GC9U54Z1SwDyjV6AJuhZAba5t7QnrD3bM	1
3849	2vajw4kAumqjgJQut3cbYbLkteZvHeS6wYYfbbaiU4DXo3meHFCy	1
3855	2vanmpCoztrr9aZitzYhtYEkaKtRVZ3uGAhtgxnB5fVcoM4BpaTf	1
3857	2vabqxnMVZ73pPN8jZkEGVRF72gCM91a8CszBk8VjCrihNvxzUw9	1
3859	2vbPtYJ6xAVcbkr6dUz5nxjC8bGfikkiCLKyse95TimWdoyzE4Cn	1
3862	2vawAhkdwVLaHq2CUB4CZeUiUukgGXBTtvW9WRJtpyNcfu6c1cHV	1
3864	2vbV1qbLMq8hcnfSHyyX4tLC6k53A1mYu8Cj47rS6EmGxupdAAf6	1
3867	2vc3hsVMmAYheVRBdWkoop4DYhjXJiRy29cAZrzJ4MQ5ufVkEfWL	1
3869	2vbzUCfpbjYD4KZVXFZCdRftAfqcbPuEihdtLyZ78D2yxsWzr9Gr	1
3874	2vc5aLEghbJBEpRcyJ6vLiRxioA1ioycs1SPHND7f77Deon4KiTf	1
3876	2vaEmHCTNyQ3WXj8pD5rE8V27uQqPLEYk2b2RhEfpQYJtLUZe2Uu	1
3881	2vaCPadAtGotep7BkayrGzYYrbTgSZPf4WMN9KFR63Pm8Dt6UfS1	1
3895	2vaPC9Pehv57AY9fUwQAPmCwV6BSAVZMtNMnSrLNzfxKZDHP81B2	1
3900	2vbNZPtZ9kSYLn7zXRiDZuRkfxd3tn6zFWg8TkuXZFdUe4uAywYg	1
3903	2vahLMfER3HgWa5uZPkLRUJWtRyJdhkBpdQACzsxHDgPv1ynhsMw	1
3905	2vabnUn68cU8WbBJ2mzhBvoLQd9GDaK259RyfLzMpVVBTByaFKkj	1
3907	2vaQ3AAf2hGakF83akxrQEvR6qkzrgDiGZ8kAKVZb8PbGpvVoDca	1
3909	2vaccJPVyvidajWitpC4VbRbx1xNMnpbgUBu4WSvUyrrJ8RPM88b	1
3912	2vbkAcP1oWpi6eJ5wU1bJfvYehVtRHBMUPv1hgNxXC7h2QKmWkMN	1
3917	2vaynrpRUk2NZQoAzkZi4EDNx4jMgjps2fG6L6upVVZcQxKMunNL	1
3923	2vaMk7YDtkKDph4J7bvVsVsnFcuDHEtGbixK973WgoHZqMVNwzKZ	1
3928	2vbX4M2MG65ntPRQ9zWvVT82oGHV52wyd6vdCWjHLt1tVBAcN9B6	1
3933	2vaGK4gCXxBnDiqiBW2Pm9LsMRSdVutvPg8mgKmy5BxYkdgAw99Z	1
3939	2vbARiMpKQae9DLZjL3eJNAfihhD1jsymGLAM94r3CAiYhtkH8Dc	1
3946	2vaBnqxJ8gPE1HyvoNzVEFNimEzpucrAFGf5jfRqqXKgSLao5aMt	1
3947	2vb6nRctMPCRiYCuDMvug7SgMT8JrHofPhsTb4rwJJVLESynM1Ak	1
3950	2vbx4aSVUkrsuX5BvuTjLTQQa7o65N5eTZF8YRGRtBqg1CCKvQcS	1
3956	2vbSjiXRzPzJAPWnYbLCQT9qtgXuJfnwwqptxpQWN3vgSapbuZ3T	1
3957	2vbhtRshZwrbZv6NAsfUD3isWAJqotJHwprArndFqhSGqyGNNEKr	1
3960	2vaHYZcXAxNpma5Zz5zhrnyWbQyRPJYyk8FgtPbi967YfPnjXK6V	1
3962	2vbzzLY9SmTLkvC7BfSk7SgSS3cxza5FiBpv5PaZfBMmetr5kKYs	1
3963	2varb7eVpsxxRUnaUC65qw7wAJq7nMqmcmzu4L3gV9XkbpvnYZmx	1
3964	2vb9wpzutY26Mt1A5bScAR26Lo94mLwYoP1YoRXxGytzZhjrM3os	1
3971	2vaoME5ymojDzo3HFZUCzbY9cLZVxFjGTtxrhHGb79K8aNLZm4n7	1
3972	2vbUDwxpmYjAtqGCvKDTHvsbq42qLfJFevfkAiiWv1aAun3DfxFK	1
3975	2vbrFMRx6zXeobgWR6aodGNbqKykasaSPR9x4WfthR78jMnY1c2R	1
3976	2vaGqJPn3essvLppLJN9EpkTpqfbyYG4hDEbX1P3mwPWuFzqihAc	1
3979	2vbbBeqQ8xFARZbNnJJ89C3Bwh7fcze6uquAByFNs6on6QTWjoSJ	1
3982	2vaobE3UqSABNYR83uKvgP9v28ZiZtnnXMTspMX6gM2BEEwi4SKu	1
3984	2vbgFA2TTJqGb62G4PensZ3ffVU2ehSZRFVrPwhzYoSZNyNtsXH8	1
3987	2vatnimU6qbfJNvjHTm1NrxetmnttAHMbEXPmrGaj1twVCdYcGUf	1
3992	2vc1Vka9TTnX2sUYBgehdBqLLcvUfJqs6myCFm3xYUUrmA6yYL8e	1
3995	2vbbJ6baP4niqEDDEtTzZXRSDMvb4Z2boZqkADhfTxBZm3PNwS9j	1
4003	2vbNqLRHdgJmbksLweqE2tZ7n4xGm9dNBPEbo7uV8pdW7ZHW1pau	1
4005	2vbAWnECdGBSXzWDmPusbvd2SUWroaF1NvL99Yn8uF3QNFNxLHDf	1
4008	2vaxtnf9SMunjK8xS5oNDLY4ToXG4FVt9LwqoD1iRc8iuuBZpy4v	1
4010	2vaAiefmVCJizV3P2V172pfENVsWe4W3LEucSduAiFKx9RzXYoi5	1
4012	2vbxAAJtG9wWGRqXWAeTXjvAMnfN4ymYc96det1qHJjmwg6EP22u	1
4017	2vaggLk3SUJiowCZxcVsesR6Zpoo2sG9DVfF426kx3RUjDVei5mK	1
4019	2vbiVSFLtHhXCz7ZKPtfbzxBGh4Jj33EP9WsHsqrWCqR7TmiDE76	1
4022	2vc1btGCHn1arAujZBbnj27Fgj7qCqZpRtLPAUxagCVcyFPGDkpf	1
4025	2vaC8KWUoJbnNJkFqzfmCsNdUtrfoybHfTJP23xGyKEuPMS8j3WC	1
4030	2vbvdZkgGCNxNAtW9v3ZqxtYGETgbbTpKZr5hrPpAN24kqLzrGGY	1
4032	2vbnpxJe6f87vejx9Vfpi8bSnkmgGtoA8mvQ8796parTbiyHZe3p	1
4034	2vaoPDGQhNubYqsrnWs3SmRzm592jaYgrWUFoRtDsxJm5JDbthtv	1
4040	2vbi8pkbfzmM4cpui3MDNf9VrnkS6p1qTxhS5wpBAKMG2dMadWfX	1
4042	2vaSAcykLSM3nEv71nX68DhxRrmGSoxKhDgt5hRa1mD1QF7sy4RM	1
4047	2vbZkMR1FLckd7o5Jo4nqY7Nbj6fh2Qx5YU1vjFiLX6nWjTbFyHA	1
4049	2vaGaQvs4kzMLEZh7vpFZtiLpHvGMfHKcn8N8b728N9ri98Cu4oU	1
4059	2vbwjku9mxfxmxRVfB4L4br3RGLdxxBdqneVAfDRDEeoVqU2Pc5H	1
4061	2vaYV7QL2tLaSYs2dwsoi6PxyHLk9cWW4cU14HChdd5ffvHT6DcJ	1
4062	2vbLuNmx5t4g9KCA2KuFS2cuDrJ8Bgs6kP8y55eD5Hp5FHLuzEG1	1
4063	2vbBgbuMDCHL7FWYFJsnohFdG32sszu1CeHyRa21G44nang5b8gF	1
4064	2vaQmRZtdpJp6MTubE9rz77SpkMSAj1S9PL7F8zVsWbHdjq3LYAX	1
4065	2vbaF9cfcS7Gzef8RmKuLoQTTcBz8axoz2r9mtHjcpWf83gLXrLx	1
4066	2vbGsikYqMeyfmuVACFNZ7rzDAj2Rpnw2cYUiTnx9BenAWPgsD7K	1
4070	2vbNX4K1FGKhp76iRGvjGYcd7eRPx9kUMMArEgkKaKVU579tn5ha	1
4075	2vaiwdREhp96EJBKjEqG8TCYy5f8zg6x7dGq7YeKq2Y2dTdfpp6b	1
4077	2vai8oweTsRDvYKeaQU3Y1unmkB4S183HRMjUK1c8KYkZipGJcJs	1
4083	2vaQtfej1q6SpVp43nJTSrksvUYzYrWB9Yo8XW65rTrWpXm79Er5	1
4091	2vbN6KrHRmwaCujijpG48nroXHzqpRqm1cUBmzjz7Sdao6nuXk2Y	1
4093	2vaAJ2nuD9zenB3fwYq2G4rpdxbRwtqjwWuTjo6zowuTLc9DpQXo	1
4098	2vaAGh9tsKngK3mQH7rH6wqaJCCycNrjPnQLBdxaLousCkryFcmT	1
4100	2vbeeCxcJFFLMfU1JkVemrn21LjKo1Nwvqm7oa3x2jJ8q5Zyg3uy	1
4102	2vaKkQeHpbebeD6WrEwL47SWu4zuqznQpeevHPvTTLYYgCFf1A8a	1
4110	2vaVLqH98ACNN4BJdyTeDmFWrW4JsiwBwCDMEoFkG6Rn5ASEzn9y	1
4116	2vbN8aMg6hXtynGGirotPcStxzNWH6fi127NxGYThj2vjvdviAEr	1
4124	2vc3EN5dJKUVZvUjES7TM3o7dhWpGjKTKDdNo1ajDmf9VkXsPknz	1
4126	2vb7GG4SSMvgbFFa5oPn1azE7Fs46qoqKFwrq1Tu4hqamCNKpqmV	1
4128	2vbPeTcFuRZ5wfYjrXvUcqGmTDoHwPWdhgJ3FobTLpu9V9YFa9FT	1
4135	2vbqAPW7aB8N8bUWxwRGsxGcHrqAA9P2M7WBL1ens2vXywVahJsk	1
4139	2vanBQqCL6i8L7feBNP9qukHqcwamd9RhHY37JJowHnt6tgXTCgJ	1
4141	2vbWf3pFLVq6xZPbBXSmE1BHy8gBGUW5jPH3YA15cJjw5PqmK6xc	1
4146	2vaYUaZZfHQDQnU43CRrJRTzNe5cQYpuSoLcLgVYFGgKMwmrySwD	1
4148	2vbLSyN6su4yWufWAaPDUB895cYKNwCFZPzjRzqX5HpziVFDTa7i	1
4149	2vbDuGsHPiHYdqP7stnjDHSyTuq5zGQRyzuzhzZBt6kwezoLeLqt	1
4151	2vbew1UWuneT28uzFXg7jXHFMM57Ykc8ivSNHCqMfFBTpBQqbTo6	1
4154	2vaYsKU9AD4byGDQ7WFVoaEQRQqe9JbxTJSk9ksknas8g2UDDLKP	1
4156	2vamkjJDrJh4bEnpCGoJRtJz18BJSY45gdCaU3o2aKovE4zNw93N	1
4159	2vapEEstudNaQm5gR1bV1iJMNV2iogf9pEkXLtGUZjVsZ1NYREMS	1
4161	2vbFDMKDgCtdFCQVgGHKk1oP7ozniQZcrSG2F1oZeMAg2iWbJesP	1
4162	2vadhqdCpFvzMFuDUdqV5ZX2MXmniG5a4vtMybPXDZRR4uC6THJ2	1
4167	2vb4q57xm211pbAibdKVDkJGLEcYuGSmmwEkWbCqx64VfWh9qk6e	1
4173	2vc14uq7Yeo2dTqVUY9yPj9HNWKtV1VRiLdnbdXheywN3p8nDx5W	1
4176	2vaCsVRUGbkFWCYPdpWL84jo3gXgeXs3FDCNcHjbWuZnwZmwqyhU	1
4178	2vbUzWpLd7QFkvoNxRRLjNBXtYPBbH9Rg2b8ZUPbqGbDnWHRuXNQ	1
4183	2vbnGLJaqUVF2S5FezSguJMK2TPPhuTJp6zUwuQsCxxqxcbvA8rR	1
4189	2vb9WN3XAbN7rZ5jG24rureZbesYUVfe8bw4jGL6hoQmaYauRtUe	1
4193	2vbVfk7krpqbwWoYAKbiH1iWwKdfZ4pBaEGyjYW5MBTjDUHwPQwP	1
4195	2vbsqDLEn8bgdjtSbd1xLwTHxvnTC36Vc8Fyxsd8w9cs5Jnk65hJ	1
4198	2vbN3eyhYHfQdKJQwFUEF8ui4fq3YQEw4yQJ2m39QJNVCiqM6Vh6	1
4200	2vbC5KcSWABqk4yMrGCrE5VWfL113HnMFPvH6Lx93YfGJKVMmBfb	1
4202	2vbtsKnj4QRcEcKHiLc1Y6jph9cWQbYTHPtzMMWyqYQf1m4QL6Gp	1
4205	2vbzuNo8EEtnuXkBBBcBVLyiZpc6Vck4ejPwo6v2iEE4JJYX8zeQ	1
4210	2vbzBKVUKuCW2t1Nhdh5fYFB6aA6GUbkrkas8T1Q1xnup96ahQoF	1
4212	2vbQGqFCsjKaupNNu6LdW4Yz9itjRjVmoFcrV8u4bhRtiFTn2L22	1
4214	2vaczKYWz9XzsdwahzSmanekHtdCyRieaq9bBuEEznfG7VXHQcVY	1
4220	2vaGFmLVxZtbjCY4iWTZFvYfoAjrArQRNsRUzSQBRPUkJCKu8vyV	1
4223	2vbm2RrDorV9Vmnw1CexAT8TusNhTjUS4qh9XCdYe3PvptDVAQXM	1
4224	2vbZjzYNBYKjdg7q4tyeCfCLeu77AC1kqq3rnDFHwpygAw8DzU2D	1
4226	2vb5Pk9bU1VjF6GukDKXpyp4XVeVuiCdWmqWVCAFuwTtguQZMEKs	1
4229	2vahHkY9aGHFn9JbD2CJdHa6Hv2BxLRw9WbxqkmagzErnEBoQLe4	1
4232	2vaQW2Hb7bALCwyp3X2pGUpTVR4QneUaRK6bKYzzFC6qDZ4z86Yn	1
4237	2vaPAJ1ZwihCi5CZquQunYGduQD1nvdDYNxeHUixA3MMFdCkE5BZ	1
4242	2vc5kPDkwEM2MnMHw77PQ4nReaELHHpSN8hki2efG6DzEqeg17MT	1
4247	2vb6Mm5uXhjQC4EfrooyKTf9rGucjWiVuKdQyDEFmUsQBrwR2mWy	1
4250	2vbXMYrMMUeaXmeMWCj4XvfxgUftMvCALT6qmWxjKvon3HKEBRtP	1
4252	2vaWqAzC3PPeqZTTn741REN7dS2NpRVaziwnkirV413R8oDC7uTi	1
4259	2vbTqPXFkTPDGaMmBTqTu8gt3MbkSHS46HTZPTHtpzCjfwAZhjnR	1
4266	2vaFgZ5hsZSK6nHq3jZiJR4VaJS8tmN1eFviwXQRQWgJcEfhC2BN	1
4268	2vaCs9KuxisHewDmxB9qcpG4DXjjT14dEkiEMHVzQucCrZPEkacw	1
4275	2vbG9egsZTMBUxcCBXsrxaCFetivkCdhHMAR6g5ftbPF1gTAaJmQ	1
4280	2vbwnav6EWDzkyfAyNL5bo9fFa2GXLLXzCeMBUZuE2GWcgbmcaYq	1
4281	2vas6KrBGxDtSFqfMyQnxn26a8qeJkJaxzh4QMoKd5uRSzHxc8Wo	1
4283	2vb53ZmVovdPkJQhcxjdJLKY1meQQUNYe2yzfpsXd335QTV4cvoN	1
4285	2vaR18xhJQDF8mF8XRrXaeXg6j9XTK32KbBLabKXhw5cJ3S4zmoA	1
4288	2vbFdMGQDM3cQZrTnL8sFbdFXchiuAD8mmrCVdh6mXzSreKhqZPz	1
4296	2vbtgWYPMYLqFNMsDgAA8wgS5sNXZdfm75iCjURQAfqhfrzmyJiS	1
4299	2vaK8x76covFM3sRbzTKRUHREykZ6D6yJW84K2iU6MfAorTW1HxQ	1
4304	2vc1NyjVCmAXMkvWW3gKNEGns4c26ZxfR2XMfBumi7rT6ZUU7i4b	1
4306	2vba3JQh5s6nWXqP5ntN2gVGRPWtXQbj47Ahgt2eQCV21gbuDzgN	1
4309	2vbZBvUFAQ7ZniGX5MeNJGRp2rE6zpXtquCP25BQ7aYfk3RmQpcj	1
4311	2vb7LHLmi4trCbM5hhyCXu2RnWVZie9hNKrnJLievJv4CBgbh36D	1
4314	2vbrRyAPBjTuqStKyXbkZpxkWvAHv8V7QDfqXbUJAXcXxwh2tyyR	1
4316	2vaNb6gZkQJDf64UnLK83et3GsEEQsK5fNdmzTBL4HYF1u2YYwS1	1
4318	2vc16rygjQu31WC4S9BJaqcEnFSQSm9mLoy6LbpTvopAX8WbgVAs	1
4323	2vbEJqG885LE89qriwkKbRvkeLPgoMEqL3WH8BpHFTQ6jTaRmMTA	1
4329	2vbkWx5MxcnUJxnckqjduHBV3nRoqV8pGREC7MSHNwRFi4aPPTfb	1
4335	2vbsfYWgt5FRG8r5MjGBw7B7DGAiYJS1dcHQa7xiRmL97viByUKe	1
4340	2vbNRPNpsZiCLFSLkSmGBQ3LArx2CURf9ySu2mprCHMhwLAbAwBj	1
4346	2vaoTP3v9PGjqQX8nu1MNLXNc86ZUfeSEpNo3KhDmBiist6KAsBU	1
4354	2vbEAD5YP9E9S6GXfEtnW7o1Ysp2Utiq6pvELLGR6zz9oKr7qRqg	1
4356	2vbkNzLZBL14HPcCyqh3P2kxS7qoJCftap2NuFnG6p1UofBLnwTw	1
4361	2vbPyLtc9Hj15ZBYUvRc6SDJPkopHiNNZpsJ8vGUyPJFcQGcQsdP	1
4363	2vbFi8zk7ocmxxtapZUgo1RrGoJ9LdYzFVKsdKZXxz7UX7Zj5Rc5	1
4366	2vb77fGuKYxL1kvjb3cbDQaTRgx6CmQP1F7kgrLH7J6wyG9DT2aR	1
4368	2vaRHx9HPGMV5BYSWV524qLbTAWTDUjm2nHvZ4vkYJ5JizQq9ECu	1
4370	2vbZEeKgXAB5xo521kiwpHG6KZ18CaA9gq39qLTauRuDZaWWpB57	1
4372	2vc1fGKecidtpZjzcRn7wPh1MfNw561zRfWkD88VGNW8QN1wMTFv	1
4376	2vc4yoDmzN8duQEbNDKisWT7ZLPGizSpuccZXaNw4bpABpW3MTnM	1
4380	2vbUf1J26VhjEk3BXUffqfQ8CNFdZMNcotcGtvvbSPS6YwEySVht	1
4382	2vbrpwwRqdk5613AtuqPDe7C6VbBjyCTtLsU89yWBBKaza6Svhtf	1
4384	2vatTmUPefB722XMjjQKyWt8EcshVVuJKfz3yFBdbxsTJFLMnZMo	1
4067	2vauAGZMdFquAzsygDF2QTfLZnQdde6KdwvztLrbVhYhBNjoAgVU	1
4069	2vamFJF1XiPEzqnqxhAnTLWJVMyWK1xEz8qzNEZ5R9Q1PDrfLoh6	1
4073	2vaasZhMx1KzW1SK8NP5EuHuyeQB9XyVUJSejn9dDuaJKZoWkdR8	1
4078	2vaqQ7p8n4L3QZMyTM8BUYXEesfSs4DufGbE8WMNt33w5Qt6vPzY	1
4081	2vbUWHVwKQEE7hgb3AjUjG3jVapz9aBM2WMorVKAwvutUnxNqZ3i	1
4084	2vc39zUn56PCDrstSXFt7xT4FzVT4531kEs4q9DrC1DV3mvkMZ8v	1
4089	2vaqDJXLHxj12AM8fEKVXhNxATuGcpiMYXAoGhEvyyB5RNq4a5ZH	1
4094	2vbT5WufWP13csoXEvUeWvxeUzCurAH5drfe9GCuGLHKgA4WLkhu	1
4096	2vbzgGaZhHsSq17vSZDfV3a75pM873UexzxCPFfUEpEE2hDVs2LL	1
4103	2vaw7gxkTeCoVBGmPG5BtStChGUy4Wj4X8HcZ9nnaEpMYhARwyST	1
4106	2vbogxKaAySfySPFDLxjUoQCBALw5eMkdjyiDWXr7EffgHL2VWBa	1
4108	2vbUKNjedk35GFdZ4z1nyEiqvMFakFQ5S3CR46LPQxDMqruVCrJa	1
4114	2vaim8eax7mWr7A3z9LsiUE47TFaPKRcLbVDtYjEZ6z9A5uGTKwV	1
4117	2vasyZA8mzHmP8rF1x7N23AMdhojPcGSUg5n4mQrGVhjmfVijQTP	1
4118	2vbVpC7RdwZDrD6DGxgFGyDoXT6d2H113LHvkfjHJcFC1zBV7ATQ	1
4120	2vb5due1BQjNXKGzxugTqt6vAEu94aE9dT5U31s1TuVesGCpjMXB	1
4122	2vaBzb66hKiYJgrQvyFsoH4Px1qhFg9AD1vD4srutFfghxdiiZBk	1
4129	2vc3QmAbC68AQUdX5enjLJxNXyhvW29oKyvt3Kp3s2mwB8j8V7Lf	1
4131	2vaW8Yipkt36WmTgyqibWqkKi6WYPUjDwJpUAYsetzygehkCfZ3m	1
4136	2vc1nY3wu9oX92ySZb2FQhfkqEHgBvHfKKouhUqpNacFVYGg6W3S	1
4142	2vaFr1ibzZgofADuPNkuDEhzB3xykXsS7kwzU1RkxM8aoFkKG6Sq	1
4144	2vav9GEoZpu7tzwYEvk2EQoVFPWCyVtBMBHjpvstbxh21RhdAwLD	1
4157	2vbWFUXDRhvV5ETrUzgj1sxDiPKrJjtrP33W1UJ3gKHomQ6H7WB9	1
4163	2vbSHD1KFFzU9hhtV9s7NoQxPRt1sTcMwKg2r2SeCRBdiAdfNSZL	1
4165	2vbrRNENMk9EySmYAiXMP5ibdLegQ8EvM9fMyJvEMTLqoLoKM1PH	1
4168	2vb9ysYzQNUYsxcuVBk6uqtWxqVo9WRqtJXnZoppie7xFUUJQFdV	1
4170	2vazW3y7VTTsspS41hm58B1vU44YWFsPwUTra8garRxUioPf9tdK	1
4174	2vbSWtmjPc8CGXBVtWUJ8X6vLmE4TZVKyA14cyihzbbutqRwHZTS	1
4179	2vbKixpEZi6azKQG8j2qMgMYmeUnX1qHAEVJsi4d8JJgjejm1UKs	1
4181	2vbZyekFLih2acQncoaSMx4ZYwEt4j8X9MQUY8DFGA1bFjzvZvvy	1
4186	2vb3n7AcKHb4hdfADK543VaE4mJcb6xwuApWfQJRxnwhVCXTAmTb	1
4187	2vap5GFzWmGBJiN8HVZpDR4Zds8DfFDwfeTsPFqEQiqdhV7kwzT3	1
4192	2vbr2rx7b4P7ZbytSiGKXNLrGFD3VhtbASccPzTeUWYhgDekjtBY	1
4196	2vae3H5FHk7HkMSfTJzv5aBf3ntidYgs66for8ttjgHaEX2nGeHB	1
4203	2vaKn5g4tV4QUPmPibja8FhunX6wWBnK1VpxfJ41AP72wMkSd8z8	1
4208	2vaEe98bUMTFmzprmukhR9yL3F8q1THgm8RFSnGngzeoFNnKP8uB	1
4211	2vbRyPtrnkRbhLHHbKJA64y6Gdffg4ea1Gbngx2UTRn5EH9HsZ61	1
4213	2vaHisxGNbdxPQEYLUB2LqvkKPNU8zhE83Ud6ppMHSSVjMA3zmw5	1
4215	2vbjCvwhFGmqbkHyLwCxsnmnh8WY56wibc7hmZKeCfjbqmJEnXEF	1
4218	2vajG2YgjbAwoLgzYupwwusjLduxTn9BnY39YYTRe1Z3WwLf9iFr	1
4227	2vbivKE1tRecVoLoLJG1HYPm8s878D14mpXvKaaEm5BwcG3NCnbY	1
4230	2vaRUis1GJz6YK1EMMA1hm9H1Jk8vHfWupBLkw1KdESexZ6tmJFj	1
4233	2vaMTPWGViWeKbrNJmdB9FxPGNvT89UahAa8boWPD3mdFNdFhwC3	1
4235	2vasMvuyM8Pwu845T3bPFn3Ks6vwF7NCnuPy3cAxw4q4rcuZJSvk	1
4238	2vb1nYFGSWNa7VT4xnsdpCfzvsB8fdn4cnS6rrEQvAjc53ynNAXk	1
4240	2vaHuYG3Eobk8mFnCAmpQ9YqE6n9hfhKP61Lrr8ZF3UKDGVvmaJ2	1
4245	2vbZTcHMKyMGV39g5NEbDw6HZQfUxqbur23fPnzH3RAtJ5215kBN	1
4253	2vbYQgrt44EsZYWSajBFyzfyTHudXukrqURWZTnfGDpwdbHaipGF	1
4255	2vbzuF6GHd4pEWFv2tywS7nnNyHeZVM2Ub3wEnJ9LrKiGzLYV5UU	1
4257	2vakwom1zJrnjF3mazycQVsWGqNnqKHgDiRZaMAMDCJCCnbvuBiN	1
4262	2vbrwKTR2S5HjN9DV7udsMEBi2d912WdYTNh4s4A76ovT2EfH3hf	1
4264	2vaLPMfvGVjzngCjTsbWHNdb4AzHfp5ahKpxLUFVCxCjDLqeuiWR	1
4269	2vaZLKcCrfafptJ68178TwcJ2MQpQsLdGuQDHzb4dFvVXrwWNMMV	1
4271	2vbBBnyKydoEc91KckpnstEFxUgRUJFEorVw7LojMzSr2L3pDxMx	1
4273	2vafQg2MG9kfLcxRqannRxjXC9LUM5mDDDnMT2TJACJyfvUZTRcd	1
4276	2vaKdhTbk9UL8ebN8xet9YgyAZ8SUdbJiNsAKDBhaGyD46VtBpwm	1
4277	2vausVkVUaBwfTkHeBRNgpzgYfeKrQLjXGBam84YFD3pXXkhLVJ2	1
4278	2vbYbd2h3WMb97rK6fvRcubgGg58SU5YjSc5g17x8zKGnjEhTE4F	1
4286	2vaWeJnMLdng1DRY2hek7U1kDKAUcymMGXQM7Rim9EoFyGjyYoJs	1
4291	2vacYXsenFSYqzFBUGRVwkFUQWiYFhPAtjP8qjB88JsXFPgiagd9	1
4292	2vab2d5yBK5PjmTKZePksg3R6qE5c3ShXhbzjnQwynh6BZtjajqp	1
4297	2vbH35qAmtGQpsfYRQTHiiL4ZVqRViNyCJTbUaXQuFMC4Tx4yjHP	1
4302	2vbX1ApvEc23urAkGTbvWF1YLiBoy26TgvVwasftncpQi15hbisx	1
4319	2vaYD2CzjGLE4FKcW23RuCVzHbccXwwhyDYE9sVA9LG92fJR5p7G	1
4321	2vaW1TQHp583a5BqqwwCqFs1bgpVVarG1dvLAEcdk82WBU3MAt1H	1
4324	2vbRJs45nkNXHH8uJJTM68J5tYxNdQAA4fc6VZEySCYFwB8GbDr6	1
4326	2vbyvGFVqRqDSPZ9VLA6RQS2NCV7BfaYQfXR2hcgsCDTv7aCXNE7	1
4327	2vaY6mUQSoNhaEDHEMFiWEz9RxLc3hfyqygNcj3XdLi6mk16gE3L	1
4330	2vbeXi5FsPAjQaJ1Pk3dR6grdBxaLJo5n1qVCyHKv25tAA4RQVMf	1
4336	2vaPtUj97ZnpvUJgZTZ4ZB8Fpjhi287srNjiDmL4UVVPkA886Ydi	1
4344	2vbmfVnfQbJqpN5fxNHAHdUz2S63T1sAPq5WxSPPRbucNwUJtcAM	1
4348	2vbsGb7FNHJwiHSe3XsmjgcidMxpudbcN68QPHaszE9nm3SBsv1x	1
4353	2vajgLBnuijzwnTAoovdYBAvX2GHMHAQTvhb1YzzE3UT6cjz9W5d	1
4357	2vbZxCo5N9kjPbsFc6XHt2Avo68MEzQxekFrAWb1MKgFLao8UF4R	1
4360	2vbnDsXVV5uKxV5RWYc9GCZRzBwpYDehUZKXHESSJc3KMUiXesFT	1
4362	2vb16SBD9vRCQWUfx8ZtCUKsxk6FHP7Q28nL6Q3eQKj8YUWMiAFt	1
4365	2vbm6MR42a7NKKfWqvEAPLWoVKzu6FcWRcQK6QEfRCJVpTjzaYFq	1
4369	2vc1rs2u7hzwz5yLUMp3t6wn9Zd7zVV4KYqjH7z15VS24TSEmsfC	1
4371	2vbAS6rPFGifTZSKAEhKkcWaF6jQU6Qe2P2NvXf7TLrGfcM5Cd1U	1
4374	2vbuArmzG5W1R4Mgq1xBnMR4bHXwDFE7kJcm6TomLEntapgn2Eao	1
4379	2vbAw9EbKHBR96MixE7qwJGuR9nW8JLxGADH9dg3k9Z9wEUD9MX4	1
4388	2va9vBEgcW994DVr2LeCfqorWn8WMG8yTWxUZr2WMdozG4TBERZq	1
4390	2vb7avV7T9wRsVxw6t8PG1cytaz4G1z5JbFkocF4BLCPnD4suuHr	1
4395	2vbTobyM5zG9F18upKbntQQAb3gfqJwpTnCvT4PZZki4aw2E1h1h	1
4403	2vahsPnDu6Yj2HVWuw5DwyzwMPfBU4hGSoeM9gteBLYJbPKxoRJi	1
4412	2vbVpE7DZ1yopNXHGeHCWt3ieyyM4U2PGDsss4dhRB5o1tdG6MG6	1
4415	2vbw79pGfT9juzhWYcEstFD4aH2eGutXxQdQawB34RoaW7Q5jBqe	1
4418	2varmLYqjLw7Pw6ZUgpmtMkfqkgbVe6GM1NMJ7LJehfp259gY7RC	1
4068	2vbwUGo7DQyMYYVnevxL6gxZsi5rmvLT95Cta5vyXP8Y4zwtm28d	1
4071	2vb68CziVEmoSYpUPNoLGnQC8r36mw5CfKRNDK5cMunVWWhMBxeM	1
4072	2vbouMk3DeihASSrWmd415fLvDaJrcTLuTSPrWTjGgzgN7tiUHkg	1
4074	2vaV5RRxFdaCCFazM1xWJVBo8WMHqe5PoCJ9n71MzXVz9G2NRWve	1
4076	2vbmTbToZtATS7kReR1tunz7wooMbqXV5EU3oszQtuuaGoGBqx99	1
4079	2vaTg8hT3ZEEKBP3gAuZPuKooPqVCJccLf7btYGeTJ82Y31xb57Y	1
4080	2vb71eCxDhFkBbm6hcm8hWA5HRvsDbjwMfJcnoUajHrc3kbERePr	1
4082	2vb6ueWGQQyy9Mo975eRhTrr3tLo9xAcbufiBpbYkDMc7nHrsgwM	1
4085	2vbtHL9HMXBBdmKAnq1VdgxqE1JZeEFQkwTgQgeynfVgoboddMwm	1
4086	2vaV1LxBiqPY6aR4QdgvbmyhAyawLP81ckmnGWTFqPkYBf4X3npR	1
4087	2vb8xCRNn8hYtd1ZhD1f5r5xXzUnsow9XfiDRvsdEF4825PYDscE	1
4088	2vbMoctmTh7hZ9FeSik8TsoNDwnyLTu6CQAJUue6Rdbz4H8gUZRH	1
4090	2vaCT4dbfHHc8QXsXN61rAMRewdhguSL7kG6hicD63RvUPaYLz1v	1
4092	2vavRRo36fpLgQC27S8SM2wQVg1wkERE5AAMqMRTSKBpsKWQWqUm	1
4095	2vaSFXSTQBHVsu9udzcfZQPyibZLNsAfRcdAhUgwBnCYJLyeXJEH	1
4097	2vbogAhJu6ym9xQ78mxGihc4RRnrBhhTJA9qV2eersxrYf6esarz	1
4099	2vajP4v7iXgdk8NLKDY1ob1CjfwG8DiqqfXcSemarGutuxavJ7Ji	1
4101	2vb4pkG1QUD2gZDkNuux4LojFmgoEdbnwutHZePmmrHgzVhj7qD4	1
4104	2vaGnN4Z7BrnWYgh1Ffeqt3TbR4fAhLJmSJ7npHt7juAuVbBtB9o	1
4105	2vbQAZFbiubkUX2fK5YdV9qptuoP7gTCLaS5MxMgAPjUs64ZaTDJ	1
4107	2vaHDunNnqCjo9NbX5LSMtro9NS7o4tbJay6WWATmBirc9F3xHAP	1
4109	2vbT4nYE6AE1UhRyknFFUAnub5xVJ1pc998mMJTNNYNRoproP2Er	1
4111	2vapiVxXs26LxRHEaY9sW2P76DNNMQzkc9Qf2K6UJnatwuDAyw5C	1
4112	2vbuEZ5EEy8U2Unuw3Rh2BH33xZ4GJ6B95424xb5zUHfZN6FN9eY	1
4113	2vbr5gq5AXNKwghr2z9oqtW9uMNBkWWY42xFpJ5NpfG4VLvYdTAj	1
4115	2vaPWifCcRDw781k89xZFGhra34oftNiNwNMWs33kex9m2uKXmN1	1
4119	2vbgT8ciT3drkot1hM5zeWDE2SNcycG8PQTgFt5yQ4bsJBhEaij6	1
4121	2vbHoeY7g98VeLf5EfVSbQLiMoxLwzGT3PWo7DxxSrEic92gvnwr	1
4123	2vbVpmYYoYPixd1Y5qJiSrQBXC5nJPiertsrhh4WBZCJEPF3dJTL	1
4125	2vaUMuoTAXzgT6QMoc8MNhkH5SYEFtWmEXgYEBH9qodq454iLG5d	1
4127	2vbXJsDzjKV4SqNGSzXetYSzyhipJRsWZgUjttC4WMQYEpvvykah	1
4130	2vaNJujsWGUptcxT8eHDVF7ziedvaaN8zeXgMEPKEDSrSq2UtNG7	1
4132	2vbBg6iCdZDsMms2XAudRSQmPNdUdtUdBadt5DAkX6Mrzz265YhR	1
4133	2vbBnABhshtbsN7z23NkzVnqWu7pqMbAiCYUkem8oa2A8o3Y1mHk	1
4134	2vaUZcw8HX8pchtoQdbx3YzJTc8ww5DCR1T6V6foaWbk2W8Xabf3	1
4137	2vaKwfi73oxr76FY1R6XPVZxkmegBU8FeR97pzCxEyZrwAX262Zp	1
4138	2vbApFAJWnfzAxcCaeiyUtKwULyNKY5bdfyj5migEe7L3T53bsCD	1
4140	2vbv64rnz34xVdxjhASLWo4UcCHZeWvQngMaE3aemdSvhtPKyVLX	1
4143	2vaPW2DHodaFPH19x1cLP3g2fp1Q3MNgS8QsjTUZ9U97CD9GRFZb	1
4145	2vaos2oMT5K1gB75aFVXWCupnHYGei8kXWCX4vLEnk5epbyAigCt	1
4147	2vbpwJ49kkmB7DkuFqnAjvZMPEbcCf7yPJrd25rLHjHZse5iwk5V	1
4150	2va9MDqBSuEPfEXsodoFzYW25n3xJWBwczjBVg6ji2m7LMTTdyrL	1
4152	2vbJk4rSBViSKcv5VUkLUzqBpbDaJNNn95PgUkAy75JHfeKxU5mB	1
4153	2vb3ENomEWTT7BakLunSzz54qadhtijqph2qYnoz2r585p7vvkXk	1
4155	2vbrS2z5mn86eK3rdeAWo8J1faLozjX4Wdr1h8FbJfkCJxe7tuEE	1
4158	2vbci4YB75WV1CTD9SVS5xEbRdreJhZfbojmBSSDPUocDL3B9yyB	1
4160	2vaV34eFChVaUuAnmkQT9caLrMxiBNSVridat3xp9JM5xhahPKXk	1
4164	2vacKe1p36Qug3RZcR67yuqLqs399E5K6D35AsvY9jXgZbyPN34H	1
4166	2va9c1Yaa83JxbGovhSFWJxCCqiWf2H1mxsWY4yKm7T5ePJsrP3o	1
4169	2varvgopAQojBe4C47wUZ81TmC8Rrbxa5UTYLnLkDPvSg7H16BJi	1
4171	2vbW71zFK2nMLUz3RnD3pine2Xp31y411o2xtK1i2pncgAUQU7i9	1
4172	2vbNgarfEwPBmWihDT3JpiyfUqs3y4dX2Dqqo5CVtbUdtbYAuEG1	1
4175	2vbqz1mNVkkqTcYbksYWRt5FYXFAXhgEVXTc2zPLMH2t1sAPhBVz	1
4177	2vbM7YXWhqYCMViZhhkYSnhtEvwfU6dJE7f3HWyqdnqK4QJWroPE	1
4180	2vbM62zfFAf6ww8TChx5RvaxLHcogsv3StynkCU5yrHJYMkBoiQi	1
4182	2vbpNfkQuUoQbD89mMNaLdCghcvNhgtwX2eBvyqKqFaj1FkpXeK4	1
4184	2vc5FJuAck3gTfv3uWsPzx1qMh1h5V5jBW6JagGCkYbVf7PYyUEQ	1
4185	2vb4m1ZZYayt8nwHuoU3kKQ3fgpvWseZMSmkoZ3URJYRSvL4m5qp	1
4188	2vaP3EuoiCpHRXeBVzwnA3zeGuSKM6tC5dRFCW4AZpT553G4By7g	1
4190	2vaLyWsuWZ5G3Gt1hjokUh6inENGbARaJaWuRcoHd6RHfq33TZ5a	1
4191	2vaHAueCJZRavcW71qpT4hYm1tRtV7jQyAhhnDE7HhgoenNsUEdV	1
4194	2vbkrWaKVgDhX1jSzU3Fn8cQ5zhJ3m6cR2b62mmqg83nUyuvMdis	1
4197	2vaMGwVuZqqQDC1WNzkpxXR5Bs2FS9auwKBhaLPmG6VLz6cR9FHA	1
4199	2vbyK3zCDpqVxxD8GwjX2iJzpPybDUS1nXfhRyDyd9JLSzx8W7pL	1
4201	2vaP48tKFqGaBzwvirvtznWKrSWLp6nA16m1bLJS9ewqeUjbBeNQ	1
4204	2vbXvVtLVjwiGjqVuwgcYcJ4urjQMFFbvDRpsQhpu33shpm63mW9	1
4206	2vaHMXhvf5yygSWMsuxcjQejBLF5XUWrqjGhp4nH6jMNLGAeqpP4	1
4207	2vaxaLg1i13qQYbftnPzVZu9BEgx2s4uFxHp1xSamfNjCU6quAMP	1
4209	2vbEpQb34QdsU8obFPFVpM6WQkBASVTD4ftBWj7Udr6jbtbBrMiY	1
4216	2vc2qLj9Nkq2jzKtnaHD4got7W8VLde56vSmqy4CXUPwEXmjUN1w	1
4217	2vbZfcr7HdQ9PPcJ8av7JCyeJA3vCTUYRMq8ywL5zKB79YYDPSdk	1
4219	2vavYBv91kFaHpAQDLjCYBNH1BLbYKUtMobUPzZMPd1WgdztzNab	1
4221	2vbiMdf9z8YcpmTFHrHFkVzLiKVMFJxK61cQF2JtyBYtJf1huLMa	1
4222	2vc1eEP5pdVUhVcr9LS4nkV9w7vaPPggj9aTF34ZLS4W5wUqq6WY	1
4225	2vaJ1UnnqudaGzmrQJNWS1tpX9Jd26mnyZHpu4T7D1fRtLrng9tP	1
4228	2vbhJPp9MJDoYL7muTvmPiBwJ7dZqSrB1jrCEkPq6Er5rGPbQP3U	1
4231	2vbhHHtRABhJM7NXaKQELr6YCs7mgf8Vs2pz8h5cceQ4gpeye5kr	1
4234	2vbwJM8upSXfvr1dfB3L67iFTpgZQMpcfi4ecRymYu1HS1bQHAEd	1
4236	2vaNb4A82ZsXKTfUQEsyXvRw1w5Y2sHjxPBMEFWUco1LyHqfoqAv	1
4239	2vaDcJyPJ644K4c39Vbnj6ooBpLoHeZfhUH2FwXBAfXU8VGvM1hG	1
4241	2vaseMBAZHKe5qptKDEyXPeM5dJPZQSsXHNJS3jWg8J1S2boykef	1
4243	2vaHRhCFbupRC19nRBPNDaF3PPLp1Rhj3Xh6B65QjdJzQmyy9Ydd	1
4244	2vbwXs4pVKGJLAvALF74Pq69yqNT57xAYqoDTjbAi28DyRXD3v5L	1
4246	2vaVvDPDKBtCPgvSmCQxaoHh2igHLWs7p3nBQeHAkb8Z74m6F7KX	1
4248	2vbHyvkWmrDkfriAMDT71ev3c92UPYHwuLWvJu6Qgd6E3bzvQ3Ru	1
4249	2vbqSiU3kAD9WcFns8USqnnya3wddUETJBgwjj51MkbS5dr3gX83	1
4251	2vaPvjyeyiFLJ9GfsDnAjs5fELkg73ideduicgJdXnuhBbLSh63L	1
4254	2vbs7R3PAc1G5HvTbcrKrkQFHzgwxebALUnuQdkiudD3Sbp8m7d8	1
4256	2vbAhjZmeQGdDyvZ3aX5qbVcjZo7zL5BXW8PapKRf4Dzq76pe9YM	1
4258	2vadUHjuW5Rj2vTzwR1Pu84U1VCSogJqHHf2JnePgTVQrVDmSGs1	1
4261	2vbds1cfnGLw4bc6UQyWFC84CmN56atHSve7bhjzUaY6Dj449gVC	1
4263	2vc27krYBSWJvKupZ6fTScXVViY2ZKjYdVnaQFQxhHDYcJNNikQ6	1
4265	2vaNsaou5GJiPLitjtHdPnwsbT6qzA8mXQ5MtnZdFnDrpa8Tdc6P	1
4270	2vb91tiG3ZJnVvKdhmGdMCGaV92Hhwze2hWrGWr4Gr6xxm5Jthet	1
4272	2vaXgh4KDXRrMjtHJmWyQRjP5kqkPVvWbNA5WN4yQuGD5sWjgUKq	1
4287	2vbsNRSjbXNzHLGAr5W6purHMtWUmXaopKKR4gPhn98wARdW1aBL	1
4290	2vbEJ7nkD7sfcwcj29dSaBwrYgQXbuQDFfbZNJdSSu5Ahf7GbHWw	1
4295	2vbYgG5UiuUmg6bzKWEXZaAa1RdjUs6Bsp1dz1e3q6qCxdozd7PS	1
4298	2vaLVEcrnZbEytFdNLxtj3tNZusQsv7RSdWHSJBXXA8XMowf3m5p	1
4301	2vadd4zYwyn37f6cSdtQbGRYvzEzPakWVcMwCUxwipTkFkv8Wy1E	1
4303	2vbQvuHFz8afhqgDeycnYkZ755HVkdpE1e6V2uyd8N8QULH62G3m	1
4308	2vb28e4kPgz7JFTyGE2eaRfbRp3nruiVtprTsiWiiahp9JYWVmyp	1
4313	2vbr6Qt9G4W195F4ZN28zF5fWju1CoQwJGgKz4F9NH7hNu8wuqLa	1
4315	2vacs1SSfArM5bo7vxvfThcsZZrxwkAh3xfJ19R2LqYpiujoj6w3	1
4320	2vbv8YLrDe7dJBXYdVpfFU99EnFbdNbe8kLVsuXFXwBdFW6a2omd	1
4322	2vam3KVTR2gKtWvnKghzAj5DMs7uapzvbQfUUQUKgADqwKMrQ455	1
4325	2vbRGsK8wbdKWnFKPAYKskdwjdvX2WhULbsWQiXabYwtbvTxykWw	1
4331	2vb7fkDQPb3mNm8zJxRYkdXyqumBrL7iz6eMjGmGwbZKR7UqZjaY	1
4333	2vb978MsxXypKsrrxGR3dbwHarUWiShqNTQrQZaqHtKuhqwMKY7U	1
4338	2vbDuvSkqbUrXKkcfk3brUTxecxMHRKRqJSEt7FBJJjoQrvJEi2y	1
4341	2vbvrqffxFjSEyNXf6qoX2jqBCnEoRYtzrtajhh662KVECS62wd3	1
4342	2vaDbCUp5WHdFAhty7Chw1KdHCXrP2vsS8KyG4sjYSbmdfWTSe84	1
4347	2vb5WQE9mZqLjYKmyNdc7LjD42AcJaSJ5uroHbfJDWncw5ezNiQS	1
4350	2vbZeSVpV32KJAE377tJnZkUE6NJzSqBXhFrdSfv22au5iEZ6a25	1
4352	2vbPfWdPKpKv8Em79EzUKCStM5vgzYjDdFHpWfxa2y2ecR2Ys2gG	1
4355	2vadEvBYXSwc6xhPFyQzpYc2Jx3cHJ4tzvRtWoBkbWBcmMFZKTnq	1
4359	2vbeybFAeeHbhxogDu74aCiQrUw1EcN3RsQqpostNdrHjYacSveL	1
4364	2vb7qMgd4HTfKsCVHd1VpQBgkKGXZStr5R8k8P6kgBCsrWUVrPb3	1
4373	2varaX7z1NEUgWKpexhzkRaNefaQkJabrJdzuRFHLYnkkq7Sh5sB	1
4378	2vbPYywumwAM4NfFin7fgiHa8a2GUP8KL5BKMJZdDHgoSp2gqitg	1
4381	2vaZ2VygBxiNpRLKnCAtXiw7a41TTvz9aDWb2dseJNvVRvgLXuKV	1
4383	2vaxU4C5Zrm1RickzbshmVtpb3TcPrcUKgiiBCUBbrSU1yfGXgGg	1
4385	2vaDpHorTdDpzAZcYuD4GWovEvTGkerEGcP4fBYuzzDbL5348WvT	1
4387	2vabmmgHa4azMste7uqDYzfhK3WHjz3kiP8CVw6kifLDQjvNQ5ie	1
4392	2vaXh2Npsr9J9g4vQLwJnm5MyMRYZBS3TPnR9F5Y42rjnTzYhD7s	1
4396	2vayEaLWpqBjNr48N1cJzogmyXfZZxqBNJzeV6o7pqAtS8mhJENM	1
4398	2vbNFZEjeHzSZsjDchfVP8QEssgtJCMmHhMYJ6rhwb4giCWr8TFS	1
4401	2vbzdmiNQKLdeUzuEBdsqsger61zdHwuUB9zMMB26yZ1LPofmqPH	1
4405	2vbneTtE6wf16ikPvnG8kEsQ3QCwVdjxLK6acSrsRKjaZJHV7Fkf	1
4407	2vbWnDdcb7N6TmjvBrLhKWoGRGefxR4jVtnfaoDR68hy7bNYcru6	1
4410	2vakiomaZtXJSy6oTfD5p4FoXtchEkL6PNDjCGnibe3qECTf6HQL	1
4414	2vaZZgQ7mngxNYoPAWEajCfs6XzCsjLvyy7EJFubriykkj2SGQFi	1
4420	2vbukDP9oZvzSLJGHxizDTwPKhKLciWmm4CKYZnCmZheCYCoZhoy	1
4422	2vbZU9TKQ5GoYUVoxvSuUNo7RPe1xbEzUfmCRq1LbR9TnZz3DiMG	1
4425	2vb3SXxKJ2Cz9myrvcJQVffMmoxJ8aoBdU67fSZoCwUGhFzvtMMU	1
4428	2vaKBvkx3xqxkTEYJxusq6zAP5Go3UShkvM6mCK3xoohAE4zHee6	1
4430	2vbWomXimzNiDgLzJkrRB5TzXRdn5xK6BuFnJGwCQrwQSpkt3txZ	1
4431	2vaNiGHbrJ71XiBURRb2Eqrz5vTU6s86zTgDcGYn1UChKEVkN5NU	1
4434	2vbS5wcK7Yym75WS5TjedzwowdQnp7JFCZb84Pxhf1wPqMsbQVND	1
4438	2vbx38Y3gec8hDruDoU8BNPXcZSndfkk23hqg5kKgt8J9uy9WatP	1
4440	2vb3aiQLxHr4qxbi7rpZ9hTk8sjYThcXvQRfkYB43zDgatwaGGSW	1
4443	2vbjmefRHuCH2oTgs8CC48XHuFWkxkRR9kPUwcsSkkxtGn3GXdmb	1
4452	2vaTG4coEFtZeMgBeQ5ZMwkmtw4yvBmg4FohLgizGmJmnpAFsfSC	1
4456	2vaCKB1bchLgWdKgoeGAo9pWSXpMksX7qCWQdMyBS5F2ahBiap9m	1
4460	2vbKfH7nKyZGTp6cqjCWSLgcMyADvFnqdzKQwn3k5p51vMohLQhb	1
4463	2vaSB993rMdmg7Ho8QhadtMToXS4KcR69txDKoM6NcMPSXi1Ug7q	1
4466	2vavzEh8eQ1UNFeEfPDfBQ2ZynpccTYZTbd1au6N83T26Pb64jm5	1
4469	2vbiGdEyQi6ga43LVp1VcptX2J4k3Ydd8aGzYkxHy6RJGX2ocLVm	1
4472	2vbXDnNjUiwRTqsnDdEHK95tgDfUif6CpcBXVvUc6FUWYmxYp5uT	1
4474	2vaPg76KcxhzbXfBQpi6VoEwzhcghBBAUcVPEPbHFJz76SdjgPzZ	1
4476	2vbqQvjmr41SPrqu9UAXJ2Tfr3ZKRPjLkjAXNd6UMqHFcvt6qYL4	1
4484	2vbfC1hq6hsYQmZJ2xoh9JxAcSSb12NePWaC7exFqyw452eiND1A	1
4486	2vbXqr87uvz5HY8VEUjX4wxYcmwSdi6wVn5AEZQeusZ2tbhgDJ5V	1
4488	2vaViTqo42UVfBw2TURkxGiFEVGW7pEqVbyTUQbA5b1urRPYZKyt	1
4493	2vb1Kn7kmL1AAE84LV8AApm49oDKQak5H4qG9nSGYBBLbUVeH6RA	1
4495	2vbM7m69yFGnHJkt2QGtoh9nxrnCB3GQnvvjuDd5CWMPNkPgd1iF	1
4501	2vb3iejxZHtP9dSGPk8ZvJJ8K7bykUaaCdFVbV3z4QzQ9vD6iCU7	1
4505	2vc19dTrShcaKWCyyqw2QNnNdd6Rj16JWbpEwwcwgovk6yVtX2n1	1
4507	2vbLJuLdeMuu5VGmLjX75Dd2BjjjDqWqDEcEtEH1EFBuA7uCTM3k	1
4508	2vajdN8EzjoNYimTSjS7ZKMnvFcc6d6d6nAxXjCt4sE7tFewHeWq	1
4509	2vbhrEaRm9rCjWaRGjcpPEMjd5eoRLfm4bcp2YtmZFxTjppaGJES	1
4511	2vc1Znps7KNrLF6DPQKykcvXv497pNhJGodM5P6PnNeMHJtkYNPr	1
4260	2vayLpvucVRvFaog4ykwVqzNNSxt3skjPrbfHhKwsAv2KSQRnvzW	1
4267	2vaed7LjhHpoCYuM7H8YPykh7cP6GzXJxmZmqoTcKUDpn7xKpwXh	1
4274	2vaYZQMKnhZLmGVpPvBgJQQYGWgx6JzPQ3a4JmaZfkj3k28HpV4V	1
4279	2vaB14PLqSpoMMiSbUeeiTMZpUv3ijFxEfDCSqwo7YD6ueNjr7ak	1
4282	2vaD1HG7s8RiEa3YFW9iwvN4RvAR79Dp56BZS2xzjtAvGhT13Fxv	1
4284	2vaYWrLahBTPSZAsc1c1RKWZmzMn8YHXxrzH5DNT6GZRz2YjptPh	1
4289	2vahQGwgSw85iA7W1m6u2sXQRVQmmqieEY4gsPS2Kw19Pv5Te4Vw	1
4293	2va9hFYphmxSR5e6ZcypxxpbVBsbn5Bqp5SQh2fMq51fBebqgWaC	1
4294	2vb7ixu61w74rxaoHQAW8JQVgvEqXUqEmDqo6MJcKKws4sNGkTBk	1
4300	2vaPAKu8avaTc7Ezo9DAvmo2FXNiQm3ZHyEWujYYgruy8Ykz2HVY	1
4305	2vbaTbujZEBzm8WLW1GxzXkyZz2zgxgYXaPLG4ySTieD2JftuLPQ	1
4307	2vc3bSA1WazojnyhsPUR7Nv3K6682SeCGRpnNCntwJEReGXWEgzP	1
4310	2vbg3G7nkt6SuejURvvZH6ter5sPWZ8hhxbBpKJYX4X25atxwiJa	1
4312	2vaEVjRGmdTQRtXjFnFuTeCXg2vHbYRBA2Z1DtFpgtcTXxEh1R91	1
4317	2vbM15gwBaS8kW7WEktc9ke6wZtXfFLHQUsh8TsuyTPu8MNZkvNu	1
4328	2vbyB5K5tJC1JFKfP97SHcbcPyoPxdSo5HZFj5xdo5j65frw9757	1
4332	2vbP9K2Rw4kGD74JLqJDEYPewZgipQ6P2Dy93VsJhrm14WXKhMon	1
4334	2vaZv3WgP1nj9XrdVbCTj5YH2cuF4TcYNjan36WniRAbXyrE9q8t	1
4337	2vbZZigvJY6NkBfPSAzUUiLnYgzudNA55Mkbiz7Nn86xsaTqMqYp	1
4339	2vbJrTrxLS2TqVs1VRuwf3w9S3gG6LKcyj55sghBqZEgWRg4M44b	1
4343	2vbRvatkZKW1UzBGL2cBxPNH7wakaSrShx6mAkQNh3qQrpNUahuc	1
4345	2vb1EtCsq1PsUbVEZKG43JWzUEgxmPY7cJvFknVAEtrJ3JPVWgZ3	1
4349	2vb8sJY1zn4JEqZQZEtnykdwj2vxz5x4g86A4xiPonTF6wHaeDBG	1
4351	2vabpta9WcBMvcvxsX3YxL3b5Z4GoMAKWsKS4htGtw4jj9mRKQ7x	1
4358	2vaXyK8Scmc4azUDq2zNh82dpDS35z24nEt3DqMtCA7Vx4v4PDY8	1
4367	2vb5Lk6jfcj63XYTJX2KhHZMKBcB5wVP664cWpnxVaa55FTVcihe	1
4375	2vam8LTEr3mVcvcRtybgcwG7UiksVMSv8N4RRHX8a2ZhYTJfBm6F	1
4377	2vamnkUV8vjMkR6u7iQZd6rSbsUNGqr9xpvDwSUeBDvHdkEbe7uc	1
4386	2vbe9eCNF68Cq2D1xRjdoM4oFDjyqg9L42pS1SDk6MQHZxUW7K18	1
4393	2vaL1hDuetHywvAwYkH1GYR8h28AMFmZfaxxudhNkm6iodd8SmbB	1
4397	2vaYPvFoh3cULRhkgpPyau9qUjTiFGZvgT4VjRZrQxptjnAoBvi2	1
4399	2vaW5iFa8FR5eFu1ErBoYa4VJprqW1rXXyta8iaNcMruYpdfK61N	1
4406	2vbRzoosCisEfGcBtfygcne6nos8M5NxWSpGPvFezHwJi82Xk3Kt	1
4408	2vaZEauevy8sNNviCaBj2KFtSUtUvrvPhxk9Zdzkqn1hRBhMEYXB	1
4413	2vaLWX1sqGNQs9JT7TxDVw7TKGZmcCsnTkwe7k1JXcW2t3p835Bj	1
4421	2vaF6SdJ7DwqaRT8ioJsXFR9YFPZUJyTffa8Da8dfNmLypv5L7XN	1
4426	2vasBNSwUVcL8SHD3wkTZS6htznmUwvubqm9Da4Xk958gKhbWJfK	1
4435	2vbSWm7Gc37t2QQNrjXxiM5KEnZtjHFCsPJZyYyUr3QvGE5tRaCA	1
4439	2vbUoUQ8UkaERiBHTDaT68u1QbuWoduK2tj1roWMS3uuTT1xqpRw	1
4444	2vaEBnjJ8ekC97mMDEY7QZM26BwFv5r4HB6GKzmPTX4QoyQ5kP6N	1
4449	2vaNguX2rvePzRaTDEAb5mmqZ3b8PuC213mb1pLr66Mzu4ea5KsE	1
4451	2vbQ4kHvx7kNRdynKncy5WXtavWfSxYRdi74Vih1gSfiLVKDUABP	1
4453	2vbsh56mBX4BrTVgsvKtFAYxBtmXuD1SkYR38DqEowtGwP7Cm9k7	1
4454	2vc1vEkFUB2DhxdQaGk6ttQU9MpwEZUh1h12q5rBhKxWMeaQ8m8v	1
4457	2vav4gxVoAYHhyX6Jfu2xx2gcMeZu9FrESp7ucdjDGS1CCN46vqJ	1
4459	2va9pSjvzv2rp6hnhEnHk94TdMpa6mFncemev7b5VtuS4nkLdwxU	1
4462	2vb95qqDzFWD7sC4BbWAsnFM4mZHoDAT7rtmLJQdmpmEzkgoBfwr	1
4465	2vaMymkJY65WnJ7nxZHFSNmEEJB3vbs1zbsHgFagg9fWXrz4KbHB	1
4467	2vbrxPyXrAmaW31SrjeE6KrwQgriE3XHbXKQkYAGAZmtXA21taf7	1
4468	2vaya3g9NetpJZnMGiydRz8oJLaMh5hvPisyHn8XRePZsn3B7uxS	1
4473	2vabUDMTHBdjE4H2WSrNDvuYz9Gg68m59TUdJvuFmLSpPns7EYh3	1
4475	2vbbHNudYjvvSq836jqLipnpyiJrJcv5btvxRfdS5xbVgr4ZXfe9	1
4478	2vaeafuR5cbAsWHZTQ1SyHUqvVw8aQYzC8cMihmhn7T6sp5hd55z	1
4481	2vb4xhtX76aKfPBQyJzNHDcaBXic3FmqQVNbRdcZq4gCjUQaAdg2	1
4485	2vbyCMA6y53WAxD1H7cLJ3AhtQWgfGFKTXnYdFx8nhidM1UgA3MR	1
4487	2vbeHZfTfNoT1jyTAR5vw2HZiMXCczEvuTwwqHbu85wD5Yk4QotR	1
4499	2vbVPSrWQfmNUJgrhk6uv6RGqEW4QygGyt6RpeZtUfKk6QSGeezB	1
4503	2vc42ynJFwZMh5x88kkwFeZ9bCs5KTt6AZyEA6PPqYcEmCBaH9vA	1
4510	2vbCCVgCvdfULuu9SKEtS6mtjeYzUp4EqxZWpp5hS7HU6SSpTPcS	1
4513	2vb8H1oxTR63daG6c5izuw54z8oyUSAAdhhzwuRmJQLQwovQmbt7	1
4517	2vbEJZLGNxffRNiJVjZWtYR6MtCqeCbYBzaNun1LRGofSnc6WLGQ	1
4389	2vbFynp1wT8UH3kSPPrJyrRwuiuqyLGNcsoY7xichqnFTgTVduzx	1
4391	2vbyucYba7XFjYbnzCD1r2tEjUNbcTWFjb72rRm6GwrUvnsJxXn8	1
4394	2vbCAtN2WtR4rVUfFMu2qtHowULoWCMnCd1xNKMHV4wqDKWhK3GA	1
4400	2vac5d1EQRjDUuX8n2ZVjEXKCtZ5Nt7QXSpjPbN5adY2rRXdmb7A	1
4402	2vaxisPSpzwa6crYnSyohmpBLDotLBUZza5darLG1yKVRb3u8s3N	1
4404	2vbLWHLiBQ2McEWe4XTUFTFezJ4hYmCZwp5kkeVZvMasSBwK8Ucx	1
4409	2vbmtGL92QZGWHbfmL3tQagUMHfCLgvCtRJmXLbcUhNQtvkMtz5h	1
4411	2vaHLMvTFPyj6gEctJRaLH3r7AFL4LVbMADaYQRmEK8rL58SUMRd	1
4416	2vbHo6njERShdNirbymgq8dZfzJyMnRiBAKU77pg6gSsw7dkxCi1	1
4417	2vbzyMXHMxaPvTXqKujwGNdkgwjmniuJ8CnmKbdBwxMzwALysXaP	1
4419	2vbVHFEMobK9tncehdNSfc1KMgedF2QDtrsZg4C2KZc8N8Jighst	1
4424	2vbGj7bCcUp6pxhDxTz3gJtoGuo5ubdAx4PamLqRn1712d6f24ne	1
4427	2va9wRrxHRe2dJX51Fk2cR7nhGAt8PQwAHZzJi3ay62nNsuknGUc	1
4433	2vaGhJKbVQDF331LTSdTsAQ4UYqCvY6sJ7GJ1fdjkHyxYAVR9GKQ	1
4437	2vaTRy61xxSRZgVmdFcYQkXnWWRhHPwGL45YtgAmHa5fjXxxEkMe	1
4442	2vanVvu3A9h1oxmnsbCFgUcNP8F4aShEA7x41CZmneNxe8KvwjfS	1
4445	2vac7DGPchHNt3Zyb2KmayUoTefAwhhM82HtaS1jJ8cXJ3y825kZ	1
4447	2vacPNKwK7QWwZQSy9h2deM5JxfPytWow8vBB6ZtA8UcNJUqiA7m	1
4450	2vbavoMoKFy5oPs9ntLJmze62W4bQSFHJEUCd4Gfn9ZqbwFKhHFR	1
4455	2vaU8vFJTLhrdLfxfe9xTn9H67kXh14Ve2une9rEh9z78CzY5qQj	1
4471	2vbgucm9ACTxg4wHupnU36JuSVBkVp8xLFNRXUby1NcpsAEyPM4s	1
4479	2vbuCZVCtyE3UjxJoz2J7dySD2aVrR3WnZ8u23umBsPHYoUDwEYo	1
4483	2vbSpQeCd4CyGNneJ5wUstihfEDQ1DZFpCeh3AmsWikjFTC8GN7G	1
4490	2vaHtxqodjT9VHxC5dJdVDt77Rk5HtoExd43oDi6QGra7STTFTsD	1
4492	2vbdgvXw6i9u6MGpMYryPwyhsoA79DhkqPLm5wMhYK3zH7LtdAfU	1
4494	2vbB1G87JMumH2yLurcrTd4u3YDDUoibgGCS9pPhdvmfa47EDMwb	1
4497	2vaWpT1STFqGqjcSDx156EY2TAd6u4KYcFPSurncifiT7SyJJxR1	1
4500	2vc5Wamzxt9dNrLpamHnLGz2jQUTVCYqNtkFLW1E85e9JthGKaC1	1
4502	2vbfBFwPJhfwykLarNZtUfwCQNZUnpqtNEP3axScqGW3jXQfq3fz	1
4504	2vaAzKV8eunSoSJ72aZrc9fHPkxvrFRR57F48S4SVcY3oPnypesg	1
4506	2vbqnAwST9EGNH2F3jArPZGMzn5YA8QTxX72LB2MQgH3jCL2Q1rt	1
4515	2vazpkYHif3qVvugNspwjqp4ereMd4A1wFXBNxEjKpL6EEdf23wK	1
4423	2vbLqwSTt6pauPrVZDGXNqd1chiGhSJWFHHM7aqrA7QQtjSDYnKp	1
4429	2vbFauKUK5RyGQpiDW5fSNJ4PT4DLFrYUSf7DKFyHLrKDrPqCr9R	1
4432	2vbNLEqEpddLaj5xzCA9EtzvbzRShAZKWjJYemu8DWf794dRrrsw	1
4436	2vamENyYLTB4LHk3BsxXMyvgc9XiGfHoEXmhWW8xvvqjYmoEuUbf	1
4441	2vaDhkpaAxzpH1XF1WiwUyhqfQoygxq3nAAseEkeHpM2bNzgTj5C	1
4446	2vafmbtbc6E4cpEes53mk9owjWKfuCu9dHpss3w483bgAC6JkqWn	1
4448	2vaiAB9a3L4b8UZdjHAjrzQ9fx2QssH5oNM23GbnwWaTKVniErkP	1
4458	2vbbdMGHBpsSMqYsNpWQZNxjyZTBLyxjGXXqhUfm3JFbLqanc4EU	1
4461	2vaSRJz1XZDVzkqBfRa5BszgQ9Bgsw8ti9p6u5qWEcRx9Twqw7sV	1
4464	2vbm18MBvgpqoUATEAz9hCnW7ACULFRVkMCtVMGJjBrn8bSwyaqQ	1
4470	2vahbPwbVfeEnHUWtppxFDFUchhcVzMmD9eXZb4zkp4hmupH2JdW	1
4477	2vb7cYV4AwWSobGuwsojBmK8a4mY3upcGsDwfFZFN8Pehsu7qjx2	1
4480	2vavp3Cd2KuA8omWfqE1dT5fBnntZxRffdHXMqkjRzoreEix1DBW	1
4482	2vb7wdBERP2DRDyQx3as2NhekMfyhUabJDud7wuxsiH8kdxY7XPp	1
4489	2vbWJBCFjZdCsthFmtzMSKxz6KmevKKSoTWEmyL2ygdHyujFFrRa	1
4491	2vbMN7gddq5f3A3AxZz9Ks7XoCr996nFnDnAf6MNSR9FTkLBfw2b	1
4496	2vbrWuxkrzjeYbCndYJdrReBZ7JeiJayTNtVeaoCDFzb7tGK7Pb9	1
4498	2vaR61wuxwmPfh2Jqic9nkkTDsKN74fw9Qff2hdWhTzQJ3KoALkB	1
4512	2vbqmPo9XNC6xuUPaeY2QndbN2ZhPXJxN5Jaxug4UKpa7s4iy2NE	1
4514	2vbzCQXvJtC8evj6YNW5NvT5NL8rbYcFj9aTTP3sEWtCLawQB4WZ	1
4516	2vbxZ4KGPHGYxrNHxeypLgWi5n6MMEe5yjyHo6f5yfXqYo5DL8uT	1
4518	2vboqMgXytLzoo91T7MhatzyCfsnBtidSQJZHJYEKDVPaPZsy7q3	1
4519	2vav2oAvCSE9vhY5tvYDbMLZNj4Bu93vhdtkZv3yUcUgs1ayKg1Z	1
4520	2vb9Bq2Wh2wQmkZdpmarb1JRx7MB4jQTGaBKWgo1TDcB4RHzFxi7	1
4521	2vb454Mj1kF24P8zGZBUXGurZUoKwDRAJDREvLyV7LA1djVRBEnX	1
4522	2vc5iZffUeUh8Mz4EMT4r2QeGpMhGTmhpNKhtH2k9aFqkgQj3kQ6	1
4523	2vbaAX3g4rPZRz1L3DBL3dWVsUN6sjKQhhGyd95H7L79aR7WgWx6	1
4524	2vbAfNhf2D9u5r3d9cKqPmxKnmM2hdtTHRqQPYtPuZXCjgakep8K	1
4525	2vagYa2hV5fLCY5dwSXmkTcjDyU2cRNcT9gAGfmAmXb1URycb4q4	1
4526	2vaUfGssBR7WLYqNW2nGdwJvzeGS1fhpYUwzepFwh3hykwjyHGWz	1
4527	2vafxQPqWXqdy2r9FuKe2jnfhCRtyUeMVi5fJcz6HtBhBzEAMJW1	1
4528	2vbJBGG9gaYDXpxYbsAsmiLxGmoTd6sq1KuawHLYfPUyVbvDBmTN	1
4529	2vbMGPrZWb7Exvg2qgJmHbw8HCbcz66YNAo8QvnUQ3v81bCHwW7h	1
4530	2vbDpSp7s3XzYeEwvvuTD21Qr3Z1vbTN29jQdWXWNhEs1AwsbsHo	1
4531	2vbhmqX2yekinzUhXsDPiP8HeAr5YU1CekmGfqSuCwx6wpuvxWgu	1
4532	2vafeaqynEBEhuCTek8439T4TW9wUX5ZzMUqD7NQR8LKUZZWWvhZ	1
4533	2vbTbQnTZSr5knne6Pf6w9dtojYXn8hVX3qqVJwbuKqbi9TZGZjJ	1
4534	2vbCFidV4sjdCJZYsmPn2654C6HeNmDNDW9kJz4X23U7ZsWTBsvx	1
4535	2vb2gQARquPskmHCNVAmCwu4iV8FU2bh2WCCWx3duFAeWJnMS4co	1
4536	2vbbsPQNpLSca6eowEUVmw5jAi5Xe6uYaHjoxWSDXzjeKJSFhuSW	1
4537	2vc3eBNcUR9oPNdvseTb971iN8Na8S7QxZxboGdBmDNsC77xhh3R	1
4538	2vbBL7w8xHcBWWyBjJs2jUX4S6GG6fthaEWX7AvxWPzt2kAMPjVt	1
4539	2vaDGyWDm3MB7MqUuwq4aUhLBqjUw39X8jccM7HzkaqBbCcAmxS9	1
4540	2vaGCEtw5dCmCpdniWJaD6Y7s5EqDjssNgw34qURzUuxythynBwa	1
4541	2vat1u88b8yjzR2Bj2caYDWaKwcsWpJqn2prL33zdKZgMXa9MdNf	1
4542	2vb6qoWtuVym2yaovTbYKGAcZzwiQ6M4oDaRiKquFkf6VNroBkcv	1
4543	2vbKi8g2UHrCu9GW5wkxhXkDQb3PBbsyG3osjspKYKED9S7UDC8u	1
4544	2vc1LjHsPMmRMxwV9ZixozM3kdXaa7bVku3dr7EZhcgjZdQ4s8Ao	1
4545	2vbgu6ADykVV3pWu3PyC9hhaCDbbXuYs4tssXETsM9g6eybbfDS9	1
4546	2vaZKGeJrgdFoshSrTnDbGXfoYBwJgfJve5bo1Sty52skDzJfHRC	1
4547	2vaRsDcHhS1bj8otPkzy1PTkexMZCpmpecpzHfgqnyK1eWrDbtxh	1
4548	2vbXMk3kr8sFa9aErJhuCGp38cmy7KWeM7FkT8qBi1mwRK78baFK	1
4549	2vavtGfxdEdomcVAEM8arcn5qLb6YP49sg2NaNshVrrnT7cjJgEt	1
4550	2vaZuJjCNzmHGxN6uh2cCP2E2ACj9MJgcQtsgx8yYicGwycpvK6U	1
4551	2vb73qDvN1tD9nHwobQL82HrvWMh3GZbCzESZL8QA7wfcDM92XtX	1
4552	2vbtRAre4Yo2yB7WZjxRSuz1p5TPcRQFtK5raRUNo8mrRedHWUKg	1
4553	2vbMMs39GWEyVnPJhDwpNykumz3MGL8CHPhNpHxoxTR4C8G6kfqU	1
4554	2vagqGkFJztTxTcJbqper3RhbPCmwQSoJyjPhC8QPFXDmQVAUbLw	1
4555	2vb8HJkzmPMFgv2tFaqwY5ChNPJMFEHHdsWUyFZWB83kRVN42j7k	1
4556	2vane7bKxEk1T8yagq7ERdjp5ctXrjxq1f6cWWvJNGZxsCBSbqzj	1
4557	2vaesP5bzjLXnkiG1Y9twgeqzJr7USMoPrN5kjTPqD9wqTLi3x3y	1
4558	2vasK75Muw1kM1jmDfKQ4zNd77BJ1jGnACAJjqoEMSPFzaRHZWKN	1
4559	2vbCzZPETRkHdtPo4fRb3hDwvdWgAsNGgSWzfJqsig7tEFTTuwig	1
4560	2vaHNKGL2m6FfUEuvAJW9hGD8skqv5dCHbNpAr4Wm6V4NrPYM68E	1
4561	2vaoWLzBQQc8B4bCkb94U7YRwqYEHW6RTk8x9dKKTai5113sHseQ	1
4562	2vbUBbtxs5UB2nUmi7WABfbjc1BpCLu4GXyTiFzqfzC98vV8RFJC	1
4563	2vajtPEAhu89aN8WFe4z3WTWPZ6nBKm22tR26dfNXgR3Ca23twg9	1
4564	2vbHsaxxGnKjE9GSKmWwytsN4CHS8QpBbdTFAztxqSiTLhFaVuNS	1
4565	2vaZ4a2v5p63h2WoLBCrg21Ukrdp7QmJ7dNo5gZcKD7iuy8iidqG	1
4566	2varNZQwoNMr56pyR1HiYEML6QMQtJg4AK2UzF5bGwxxHa1zj3dT	1
4567	2vbaAvMH7vi5kwNY5mw1fhueZuNVrAqhoH7i59MgTtBmFDT4YUoJ	1
4568	2vakUKJ9XBB7PgCTAdJreQHnmsah3GmLEgzFgQrjk1FJYCF8P8wR	1
4569	2vbEaCmVy17TBG2Pi2b8ngAkbyaBjKbb5cq6ohzjqL4uZUkBfN6H	1
4570	2vaF3i1sDNRnd54bULyqdhvT5Fcd1kTbvgWuoUDyyw4T466C8gTz	1
4571	2vbCDjf3a6TBNYNLX1D8tqbkrw9t8aK8dhimjgL2wQdxz4gwFMWe	1
4572	2vbgAuPFdPfV3u7d3ss96daYTJhzZ3veMXhxCvXLMw8itVPSMVG3	1
4573	2vbgPCmXqFvupasEi9FFpxKABXxgCFvrjRvsVw452pk4jYGkAXpq	1
4574	2vbVyLACvm2f8rXZvqdhBtERDMcBgDEN2yB5j3uKV6DmW4dB9TTy	1
4575	2vaaMPqkjxY2SWK2LHzzT2uT4cey5Mq6ZCSAJRGoGBKGvRLNXctZ	1
4576	2vbes2tQYfHqAC8znRFxgExsQ9sm6LWXyUvLRMURgwosFvQjPnFD	1
4577	2vaL5Em2P27cL5qMM6e5xkpMKsZZMVMmyMCyJPatxwoTdD2LEgH5	1
4578	2vc1j2tGa1xA7ff81wKWgGKsZeQDSptiDurEVYjBobnXEdGugndb	1
4579	2vbUvRCi5QD142CSdUX8hASAwmiWbUHn5iUgZvWsDLiUoPz53sS4	1
4580	2vbiHVqVLy9DkYgKpoHsB1xTv4nhQqGCVvHStiM8AnJL96GcAuox	1
4581	2vajG74uJtUV5QK5HdEMG6KAijjMZYjoHb6nkZc5ZeBRw87QczdZ	1
4582	2vbVoR4kEtwMSbtSBLLgzdNwVcfWcxhoGwhoMxxiKsZXu3sKMf78	1
4583	2vb9gmHZg9danXw5mAjJRJdGtcXFk33p6VgNALCtQmpxaLGWWihJ	1
4584	2vbvXhMXfLsAY2fTpdSef9WHqL7UoV2VDUuAwfzaYjbPb7EKyxXS	1
4585	2vakiWhVYs73EyAEJzBr8kDWzefuPjA1W2s5vqgxhripeBXhSTtC	1
4589	2vbKZdzedPVV53g9NoVDEqSYSMQAJ4H9mVsf9tysqZ1EaJSQ2c6e	1
4591	2vbKBJzYn7zzQpnnBQVUF5gTWtQ9usWt6WjL1FLLt5FWeBscHrp5	1
4593	2vbh2e91jFtEMkSPmFEwWQ67m5bk1tPrG7X4XYQxzLxxEoXMuRFo	1
4595	2vbhs8eARdqw7scZ8xuQR6fGxgWwdvYCxmfH5ecAfHaYKNrCxxGL	1
4603	2vb3GpBhPgwCopq3K3sDMXkNjQGKc5eyQhFJ3QLhoAgkFr8Z88J9	1
4610	2vbrifGCC2xbS2hpAhjinpU3JVUVv69ayXYwyi3fUiWzuUB5S5XZ	1
4612	2vaSVqzLcCPThrurKVzFSEEy4ENGZV9hHj2sanR2hYSfAQ6emvYJ	1
4617	2vc2G8A4YE43RiRhHv8k1Q8XCpK1XDYWLcFphzDETUGx1uSeC1MC	1
4619	2vbExVazgCsK9mfsvvjWJyLCnfiGDLwsLAU5Zc3VJX47jibNxgsb	1
4625	2vbE3WiaM9wBCaWaS2FiYFEXX2YZM1Td9FjewDeLwMPtSK1SRvUw	1
4626	2vbvPaXyLjtG6D91N7GkLXeKrpj4EqY8DBrAzzAXo7iRBm8TnvAQ	1
4631	2vae8387wwt6NzqEVs3pqXxwowLWZRu4D3KgVdkCUwrK4QeWjkTq	1
4634	2vbzP9mcDSSmCW35gYr162uXTE1KWBEETeqBg3Lk1GCVfK8VK7mU	1
4636	2vasxDN89LkMfUerAwJiMwtuBHQDxWqa8sME2tawe2XzXExkYeHA	1
4641	2vbvpWf39uDBBKnWLoDz7nQSkhKJRJ6UAsqcW6s4XgxvUCSdMZJt	1
4646	2vajaAMj4xnH2ymwceDhq4yPayYMRZXyVDJVSwD2qpM1AiU1MFWz	1
4652	2vbrb39K3sfr1P63XjCdikXrWcs3aHQ7f5eXSVTcA9mDbjomXadu	1
4659	2vahKqUTDgz6693JCZkXevTSW7AemHi28UEBgKuAi5HD2u4d2k8D	1
4662	2vbhfnLmMwgWYDv6un56JqdEDCLt4MqjpjzKZnqLRa4H1LRNi1zA	1
4664	2vbohyVNz75epLTzJSSKQPynSzLSHnv3dtoz44fiCSF2CEtXQseU	1
4666	2vbJgwJEoHCTVR27CJQmKVpzSspY2ZPUTjU9dWns7UAWoeTMUtMy	1
4669	2vbXfJQmG48JwfTccdKNRbbv52boQFCiHWYwK47DtqJuKAsiKVAF	1
4671	2vbsQiZJg7MBamY8jwP3asGPWz43i7r2xpQNRmKbs7cxLu2KjzJp	1
4675	2vadwc8n3rQtiZ6tRF7gHuDYBVJ5J8c4h7v7MVyfyKaHCdkbqEcq	1
4682	2vbFeqEKQGfXvdRzd6amWMcVDvNB854ukFCNeYMrnAQK9bjNsufP	1
4685	2vaqzYZh7JLw4aTJbx3QpFHraHCNQRTwRHbuwa4ixjeBuuu9v8no	1
4689	2vbr7BftoavqddTpDiiHKDnoR2ZZUPHgGWvDW4EDUQS2sap281o6	1
4695	2vaPDiVJxccKTFcu3vz1yLmn41nGmj7buP8FZBPgTqdsjep3Ax4v	1
4699	2vbrK8UPVVivfR5vYLYoPamftRRPnWdjwEJwYi6cUrWTQwPKZRH6	1
4700	2vawqqooCSzd1eZ2E5w88MomdBdhKdaYnZcc736LApLMGJePmyQR	1
4705	2vbkKwdqZHsfiU8SBgWAiP38SsiqHJ9PJatyAVYjGtnhUkT9UbSf	1
4708	2vahfDDGXdoV86tcvnjhkJT95MbroFPtyGbNy1t6RJfwTMsPd18T	1
4709	2vb1DNipXdCRoeBv3uzSH18V4s7bjN2bZTzvdDi1FH8rtTh5Wnfo	1
4714	2vamm1hvvW15Rnn6qXCx5AhsTsijDhEAop2K985Eag5e9F9J1fG8	1
4721	2vb1ovvjrsQkudwajD7gA6FHC5kXc8ddjRtF3JDxPfnccoyWxpTi	1
4723	2vaubcF2HFZ878z6SiFHNUyeb74wtUxG1k3Crf9RL5TMSfpYUQrw	1
4727	2vb3E26QUFVCA5MH3pPbo7yYhNsdZdLnLXZURYZChbFJ9NaLtheY	1
4730	2vaaeceadezFrzVhCFEJ9ZEhMwA7pAyHdNQf3vgUzje47iHMy4ff	1
4732	2vaykWRcFyVS9zDuVYWKAp4yid97UAM1hsQBXW57CFaKZ5hcHVUi	1
4741	2vc5aH85Q67K1dLPaP2CbsVBtYt8rNq54e5KqGAJ11BoUJGmjSsE	1
4745	2vboiCEQXc7z3f77XYuLQjZWUY8gCapUQDaBfKQsi1tpCJUggiJx	1
4748	2vaeW7v3JCynUFRtpmpJfgycn1hp9MP9GVML26cctcybP533M3bq	1
4750	2vauFik7YHdETwDdznZucKnDsPpnmUNgbLQDqfYkPDKdfW4vTwZs	1
4753	2vbzgvvFc4FB4hpyKqLvs3UUp71k2DA8pEQSN9oN3bmeXDCGESDw	1
4757	2vbSsVJbDQUELQCm2Ynijm817Zo22DmqoRnHwFZaGUkGnSHES6qz	1
4760	2vad1mfvEXx2EiX1gBaBN1KoQ1L5Ay7iLrchATKaW2HDnwEbNFdq	1
4762	2vao1uU9ZFgCqFXPxFgmAjm6TmeZos5wSuRbuDqQ73BZsqkdEzsP	1
4764	2vaJKTSTvhpEwR7ATBpHSMBW1pAABHTxdPRKX95BL1JY1Xnmbsd1	1
4770	2vagCt4FVHfMehayhs7ChWrhqLG7R9mByUkobfBJm45HtW9zbEeT	1
4772	2vaqmnibVpHJg7R9hrZ57mMWVcY6TTDq6YtdKZZJey7LvLfHoL9U	1
4780	2vbpTaAuQsS5zYEz8q9NkmqwUTJvsdmdge18c9oxgx1DPK41T62n	1
4782	2vaXZxVJuE4MdRiEp5EMiB2vHfEk3fMSqyk3jTkcgMHK2H3NQc1F	1
4788	2vaPjMxKgVvNNX4D8Vm57oNbS1f4j7wZ7Efz5jRiyYnYU9q7FQs6	1
4791	2vamGjrYf75HnTDfNnqtjUbiyryroLfd2aSLeBXnFqc1JzzAj9Zq	1
4796	2vamrvhLJ4NsEUstVQ7r8ePXazPsDkVkKbrR42QPK6AqAXxAExUA	1
4800	2vbdbC8dtn2UmJjGtx3w1JfntkRzvNUpfgxbzzdtLdyNaQwQVb73	1
4807	2vaYK8UY8iRnSGQ5kGiryT6njTVG4fgACNroJ3zJJDXoSuNe2qvR	1
4810	2vacjish23THmLV6zeg2QfM73qiwUPHUBJXPfipM8tJRuM6k9axC	1
4813	2vaT13KGZo8qgXNzvYkUysP2x6CG4vYKAnDiTNNyWottMQUW4dHU	1
4815	2vb8FTAXjsQzwi8q9biNU34C2vJn6QGg7kmsw1DdgD2aeHXmMg38	1
4818	2vaRChgicks4qLmKQarv5L3qk35dRTkR6yakLMgdCWgFoiWVD51r	1
4823	2vbFEa1PgKTVX16o947bXKSjB1ctFTCXsep6oUNmKd9mFNJPzVUf	1
4826	2vc2iMJkGJh6jurdMSJhn1GvrMaNhHUjEEWbFp4Lrri6eiQ3YeRW	1
4828	2vaquBrwesyGqU6wTGzr79681uNL9HZu55a1kFfKyS9fm6eMisss	1
4833	2vasbtoV9q2eWdb2VQiQ6srLCUTdbx9hrZrcF9yzbngkzCLesqAo	1
4835	2vb4467BFjKPKzg1ptGwXEs8LoQhK5SmoGnQvZrD9QYuvNWSuEh8	1
4838	2vb5XUBooF1tAvuvj7tctsrYtfRG2N4dmmjLQmZZmP7Yv4nP7A9o	1
4849	2vare5CNbr9bwyuMmp1jVU1esARsdkSRy9Men3ZxWxQkRoKxCHx8	1
4857	2vbvdRNAFrkZsaoXi78NN6JQrU3vHbXCGMnGt3gfP85c1jDkhtLn	1
4859	2vbi2k7AEPx1FRbiAy8JrVm7pSyS3Zwsgxh7YbMiYbxPwWvzkkpP	1
4860	2vbhZzisVgj6452eRBo8SXyQ6yMnzegkmeRRtx62oDqtE2VNwe26	1
4864	2vbXbQDKLmoj6N2neb8YH9AtizvFWNdJxmHf7v76gCVtHQXfVu5J	1
4872	2vb79tuqqq8vCTGuLvocYDEbLhUovL59Vsrx5pkPH9GnqyYxLH5J	1
4876	2vb9F8JwVcyomLE5omED1oX9WVMcdDmuYG3cVPkqsFoHigc2etkF	1
4885	2vbfN7NXPFdHeDpH6PyHjGRQBvzEovEY2ziLybpboLwa2JcnzWtQ	1
4887	2vaKeg1tdeeiJRjS2LorgPV2DFHKzW7m3DUchPxVwzMujwqHBop7	1
4889	2vbVSrkCjkqZfWjGXJGYkfcFz8dygQjMdtQ6dshXLt1UNEWeFfY8	1
4891	2vbj8WDVJx9en31oPtLWBnTPP8EEEUi5bXeEjqXJSxadRcC2fMVb	1
4895	2vbfvpruUhWfr8cGVoHutkrbT2KP9MDLQqeccoNtw7sDajfhJFRX	1
4896	2vbBiirpN9Qaj7avtDmuV2PayR2SqnpeY1uDvTxQkusmUJbfyWmn	1
4900	2vbgeB5fLm7VZGzKe7Zi7xW9LrrGJVAsR1Y49yQN38WBCVycH6Hu	1
4906	2vbsZP5uJuzM2Lu1QoY7E2Y3WcR7HfnbAyDh4ZoScpmJZsCTQKHT	1
4908	2vbpJpcwQ8MsQQSP8JfTu9hSNSYPDuGuGMW9pPySzEag4KGtkDij	1
4909	2vbFce9RRRmHk91czP6gBWBxahjXskVedtGK1XzTmCw6mv8Bys1u	1
4916	2vbwdcvhPZvCT28nYwBtYfUvwRF9Xi5jcshum4gbfqoBCaHb2UtY	1
4924	2vb2SipNqe1NjXiQxGy5X65TsFNJ1fDHQU5LJ4LaWbYZZNv9LvzD	1
4931	2vby9q7Jfy5kRXtomSBPWAqgsx76vs3SfxX164QgvUZWsRQLWZ47	1
4586	2vamx2gx6J58ajZNpxJYsxg7b9JDAUHvzVkbUeG3Ym6CrUtS4om2	1
4592	2vbF5iCJeYE4bRWj6oLRmfm4tQ3eaDGKeFKBgdgRuHApo6JW9BEE	1
4598	2vbygMMZHAYqQGD7GVtb1ooBpy5yA1Pbu6AcuauY5pnupYHrAyyz	1
4600	2vbnSuri9f3asVurwnXSpEnePaohYLoFvgjLnRWFxzvC1N2gnkTc	1
4604	2vaCrJM1qTyXVLyLNEerZM4AtcodqGPmJmyHxBCHPhw1tcK5nmsX	1
4609	2vbwbYxE5SybcP2KmMNG2c3cgv5mxeusfZM3yTRS2jhWhRP2t7G5	1
4613	2vbQ6k4uRmeP5ypkHmC3AXwFYnVKZeqPV6RyG658tqwHSXSHdSsi	1
4618	2vaQjHeNxD3mrxfmC4Ypc9XWgr9YiMH3M1amYYB9qZhuwBK9hpLF	1
4620	2vbmZ8RwgMr5YtcdVuW7Gz6LVquoMHFuVGYnKYCxCUsf8KyCaaNk	1
4622	2vc3AMDu82RU3eC7wEz8n52kprCTheb5fwC8EKCMYw8X2JnTERjs	1
4627	2vaGj1nbbMWKiRqAZvpDP8FmfC8FPXKSeZCF5ThHCHxEVQCiKgJ9	1
4629	2vbEdPujMCtMbrhZWJVdAxJr4iMZgQhjD22VKXynsWaVJpfPszgE	1
4632	2vbaACNJZNkig7WqLwjNAgwNahK7rPqvgYdXguXQXeaL1WqU85mT	1
4637	2vaXEbWuBvJmT3wKrapLirTJFXiwSTBsXDxsKbE1qj7PqQaPE5sV	1
4644	2vbh94VMos3HjG32UgW6tpgU54cMpjrYL43wXcrwPVCkB3fufCyV	1
4647	2vayqHgnM5jXSuDhDWZr2okJEwz7irFXcLoykdFFxz5ZnfxsCmYe	1
4649	2vb6PqbbkR5br9F5GLgBGoNhJnfmRXhgFAXcRhBMF47EB9UziLyr	1
4657	2vaihqEF65SYZZEJhiTwq81nkm4cfp8fZo1ropAd194iyuVTRvgg	1
4667	2vao24sW2U66967SXJmsUr1qT7gBAxktSo8eSRXWTcENuphwSMkw	1
4678	2vaezc9KZwmuseBmwuVUgT81ZBP17Nsu1za9onFKq6WnKe7NV9Sd	1
4681	2vagAnACBxWrFbAwTstABUBvZ888D1tvzHAyoNFW1VDSf1xnxuCP	1
4683	2vbTzLW3HekktjRtCCTPKCY6n97dQhxQXHsCZ2qHbVrGzPpsRZEP	1
4688	2vbKwYrurivrT4h9iHVYgEsdK79LunMF8Vs1WQ4649Wm8kMt4TzL	1
4692	2vb8k8jJZPLt3XvVMBgByBmLJKYcQbGwjFKNYQKYyUiRcDDQzSgR	1
4693	2vbrLwzrsCcwaAziYydp5pSrdxsE7WLGQLkhimv4dYFmgtFGs9Be	1
4701	2vaphwjzf7b9ufcd6TKgPvBZJp6bPpFGrwFRAn6eyNZYzMBm8x1q	1
4703	2vbF8QqkkvK67gm4x1mwfiboKtwLS5evs7x9uizZ1cKCVJSupwxd	1
4710	2vbYGium1qNcA5h74rabpHMeusFavHKocKLsrUEDbwfwZ32JY35H	1
4712	2vb3Ko2AbCXBcK2MZknasTzLFbtdUVgxSc8xud3sXxmqN7WqnG12	1
4715	2vbR8twZawzXZfbW5SNTu6fRrCAeV8QrPB3hjmCP48Wg5x54X9aZ	1
4717	2vaWHbTSragxhp6TUTKA2J9JZoz4MBzrUfdw7StVSuJWJaNhBMRD	1
4725	2vatuEX8jgNcGHPLnZpVZqKXY8UTNdzPdEXkhiwqu4TVEfhwkLjJ	1
4728	2vas6bkd3bjbtXxYWSmBNUNNVzkc7Pbyn1LQieN2sU7kf1jV9y1L	1
4731	2vaXkRei18Zk8iGyLDSejKc6ZPfzwm8EW61sd7zMgQrpRihcXxFQ	1
4733	2vbDqfnsPgpcvLzFYbRGKX3a8NT1uZm3uCAD7fijjfi3s8DQv4cc	1
4738	2vbuoyGd7RnoYLTfHJouM1PckWDGjfNJfQCkW2yw3yZSKNfvbRMH	1
4742	2vaUycGNCA5MiHU13CYTYApHxw9hiuWsvZGViPGSv3pxN9TN6ygt	1
4751	2vay4uvyhDuEdxouEro7ef4ZqQ8p8dGV4XWchiQifubzU9cKNFg4	1
4755	2vb2Jmpvt7SeNMAcfcukHDyqy6fSug7hdCXMQsEvyAB4kmh7NFY9	1
4765	2vacfoC9fGnp8UX3ksKpTE1NgSdsQ63d6KGqPCmNASQAG7HkeLEn	1
4767	2vb8rJLzJGaTrUengcM5mVN9sd4Rr6oKD6HvhN6rrus3fL78eLDk	1
4771	2vaRC5ogNdGPbyLAuVB7upzXvAxQFkFyFtb54KgX7cRX3myTt9zh	1
4773	2vbihGwoMmpuEv3ymc72NQMbcnfooF83YDT3gKAuPinzrYp2Nc67	1
4776	2vbUcuRKbS2Nh236rDyKKFe8TpaEj4BC31wT2VmCiBaUGwYWPckm	1
4781	2vaSyW9iKtYUG98BS9MUwg8BEq1akiBDaxiYtvXdHj3hrsH8rDnb	1
4783	2vb267WNTJh2wEsZuc9quU5heP4saqMGCa7U69TZGoHmcuzq4q2n	1
4785	2vavgqgumXCa4nxTWwP29Yx7qSTekqADpfXsDy82oV8KTzy7tArU	1
4794	2vaDSUD4XdpCgfKQMMZuyAfBfatfeDZmk5oUfCXe8UNRirDaoX5X	1
4805	2vaQXpPxcDq46Tw1xRLANL9HXVL88yiT67uqU3RfSWSPas6Yyppx	1
4808	2vaqqXQiKrCMxuExBatYPSU6HkQKSjgBKXbgoaVqc5NxuEdnUsJH	1
4811	2vaW1rHZG4gtJwC137DAzjmbvCLLXEZAQXYKCnzyt5Z1xNkARc8B	1
4816	2vbmxE7xXqP8EH9Kz1tCKUN9bDpFeEpEJ92xzbs1tTP6p9qiDbRC	1
4819	2vaaEA2b4hKJ1UNjRcu32YPNNS9o1mUCMYUMr7ESUsuZaTJSb6UG	1
4824	2vax2MRAhU44VyvES9dHYAA4ZNtXG3SQWChSKsDww1RjFKTjVeDB	1
4829	2vaWTaeUd2u4u3w2sAaHHbC5e26yCa2bGKXz185Vr3aBHU4TRx2a	1
4831	2vbCeSnRAZLGmHXVYdGQ1L6zuie3LaisGH6gPAhNqWd4vfvZ1yop	1
4834	2vafkCpkAViEQSd4ZrVjRejjNdkgaVdvfmnJ66nvaE8oCJUGrdM5	1
4837	2vahonr6TuSKhE55k22dqhLbfMwTdcZjYLA1kfSCx7vFWPExDN7h	1
4842	2vaBspewGjaLuvY7aUdfkyd1Y5N8Tzs5W5mKLVbwkh699s8C3J2r	1
4845	2vaAu4V7xEt6jWWxbYuUNszrUrea2XSkBCeyKcNhQBjBjhvYK5Ht	1
4846	2vaa8jDVwb2GSbkFgARUbd9hcg2KCd1vajUPTYzZRHEiAoTzcNYJ	1
4847	2vc2jf7Q62WUMFJ2As5Rd8ha76VazWQ4GAmHYABxMGfm7AFwnTcc	1
4850	2vbqU99qJ53HMzK5QVbgfJLn7TZCVe2ZsgbWawWrArFxmMAM8SGZ	1
4851	2vaxpsHLRZuW8mMoKiFS6oQPRvf5VuyAjewRistmF1amuXmcmEso	1
4852	2vajQkPD5KCyKKRzFUhyvsGVDpq7c7goVGH6iD64DpV7ofdxsF8w	1
4854	2vaZdJHzREMqm8z9BsMfVzFPsBHvWmQP1i5FPYLTK2UnQDNEPxxf	1
4861	2vbhDy7gZhu3Gqf1PDo6JTZ6Vn492v4s1XW3jSZmjJSTA52gFu8e	1
4865	2vadBEiwpZcwdcFLWQhhsQix7AU7yAmZhX1KNgEbSGQxWcnF1kua	1
4873	2vab4sN3eepDtkQqXoHa7216KjenFEvY9u6BzWG5onbbQgQtHRVo	1
4874	2vbe9vY3gAHnGSbkaRxqrirneqq4Hq2KYCzjsvHchzcma4ARtdJ9	1
4881	2vaa9Kg3Wm1PWKNChYAWZdwnqMoDpjqwT2wc1X9seJhMe5k3uLjq	1
4882	2vaUYAECXiaboQ6w8J8FTAHs3XGrSDDSyLDJyCzWZkpGpx5vXDP1	1
4888	2vbfQtkDqxMLWeCHPdXv63Ya9FhK6gkAruGLHvNi7fhRwPR1MYyY	1
4901	2vaQyHQksGW6tvrxaFYR2d4eXtDpbVMrSmYGXjBtD5CCXKmnbdSS	1
4902	2vbjoN9LrTmoTgNtbmx85RQ3pNPh3sP8hFZsh8njEZVH2WDmEgRk	1
4907	2vbs176saiWtTdoJz6JjVaWsYhzFPGa8aW5rAiYa5hz4j7p75d2G	1
4910	2vaRBCjJcdRt7hqECdcaiNvZ371fdBbckFcGAu5EfwhSuFS5Cvyf	1
4917	2vc4zHaxndf6m5mjGqdahn15drC91ucGSwGzEghrjLu5zREQjoUW	1
4920	2vbMu3aBCDE8Vrfxwnh4W6raKLibamysCTCedpRChKW5Kj3yRnB7	1
4925	2vbWyeY8HCggpYDEHAopfTeLuGMz74QLmWcKE8wKGkg1hXvPR1PE	1
4927	2vbz1niGSq7UXYavo75Z1WRYvY15214cQsPLF7gPNs3iGjbRA37s	1
4929	2vaBHEPygBdJENPPrDsSxHNEd1u3ktDq9cKEeRj35tabhZR5TzBX	1
4932	2vbqrycZYZAYYHek57gn7XXdRYhhqDTX3K6fNwYt9NEVpSjkjJuv	1
4938	2vbQFqag69BgWSctgxb8V4LXJFjgoozjJbK8QTopTR1AtaFPQgt5	1
4940	2vbPkrX18hcoE3WD9srcSn4YTpcXWtvWs6NZqEKBtb3mZ8f42Waw	1
4941	2vc5SJ14EUPyvFZMiunGHUiTX5r7Ry7rgRAoJeJP794KJfRgDHo3	1
4946	2vbQRazfNoiuEjs6KHzKvouDjMpsnnjz8UxmdL4YcWgu8zctdsYq	1
4954	2vaVnX9Zh3QDmYRcueTuoexmyxWT1N6rdvi9hLejYn7w5ArsdmG3	1
4587	2vbnQ5RyKus8k98ENprsmMbuhao1mHqdYUJakDyY1WU3frqzPvxs	1
4588	2vaeKgz1uhCifjbPpCxoA3UkC2XekyfMCo27DrPNNvaavPthBAUn	1
4590	2vagcgcaxjqnXoCKHB2kkqoarERfkZF9x3uqQRo71FXoDDcJeeTf	1
4597	2vaKRzSm5VMrCNTUToMKNojTqJVLk35Dv4MBQtdpnDFtsuKzv7f1	1
4602	2vaRnvMehbHE4fPPhbuyfB29jvccBu3HzMj3wUpLjeVupiCLJ6KM	1
4605	2vapU3Gzrb7AmJ3w3sHKk9VYyD3qXvDXk5RTxL9BXGzzoM7RQ2or	1
4607	2vavbquynmeMio3v3ze9vGPMrMZCJqWzqrJsS4NEncxTNMNqsnpy	1
4615	2vaz11GHaDhQVEJSaihuFNrw76i6C6uLhaHTwXfHscZ6CmwUGC8k	1
4616	2vbvv6M6kgBwyZvWKkbuPahHVNHraF6kSxWLjPxL2sV9SvZ2BUcJ	1
4621	2vaVm5DSSMKk6XtV52APQ64jMrBGRRJkbcGJJ7Vuamn5uEtUXcYV	1
4624	2vb8uakshTCKxj8wTKmAzGKYb77tGqSGBTRW3EsRteSBAZoosh82	1
4628	2vbToDtX3kFg46dcP6yAMMtriQh8PzpQjMjkG7zoRxuHXxE1DitV	1
4630	2vbxepV8kDgQxom1sbSWG1nwXbdoqjnyFrWuRCTLKsExirU8LReb	1
4639	2vb4eG6ecF7cabGfGwauKGCUBbTCBEn1YTqDV5Vjh9Arru5jeLZC	1
4643	2vbJcV75gAvVucbwKn77dzQAj6jtRwgEwtwQnYgfmfBr7QUooQ1u	1
4645	2vao5GBvfKqHN6ko9b9tK7w1bbHq1Mmt6DzTAnMU1rU8uEbRvEBE	1
4648	2vb38TjCEXb9JBUXNeD9TKKsJ84xQAJvPUsQTDcJSVnmA7aGqxro	1
4651	2vbBmvQcUVXGyPLW9QrJeLHgK1d3fRsAqH9YQw9XSXEZdUqNtAcx	1
4654	2vbwaoeeyprWAePhGLWRpvyNNeQ95w9vk3Kb6yC6Mk9YgBzRKfMP	1
4656	2vazpc4CYjKkk6ZGULVCUuEkb9EdhNFD5txCDrxZX9dJzUKBdvYD	1
4661	2vbTW9PcaNECuyYQmGWHePhiadnWX4LfSBEmNpXbqfgqKrKaoNXM	1
4663	2vbFARu56TxALTyeWJJy8UHSTUcXyYZbgwTzwTRqkPFyLTje3nMh	1
4668	2vaejsi6QASJhfJrLitmrbuTEUpuHpwCxz5AZHVUX95R53RJf2uD	1
4670	2vb7j4g9TJkEyHHBuUKKTXAZkyMh4QgyGsiMYLRU69nsbWYhv2Gq	1
4673	2vbbpnLwAv71ieqw1YXjF2gTyykMr5ukqVuFcMyowfNrwEbsBSUu	1
4677	2vbc5nZXhz1X56PgxNtLiMjbRuvKHMAZx2kQvnXGo3LFk7xsx5gx	1
4680	2vavREPDGGT1w11DNAfzby5VjHN3SM1X3cbHKwkxW623aZ5EvY8G	1
4684	2vatf7Bb7ssPE6c6NmNHVFcuD4AYxXawUak4YbzWt5SFdrLimN7K	1
4687	2vbp27PqMR3R17xuBzoNcbKTojQpLovkX4QVuWiXuCHkKZNy2SfR	1
4691	2vbPxKg7MAw8MbiZJBt2BeiKuUWYJKe1bSbmoDPajJb6cU1b25Gi	1
4698	2vapCqWeGavfWkcUrZYkofMjYShr8JcwGMneppTUVuTj9WZkppU8	1
4702	2vc2JMoe3cQJEZ4heS7iVCXPNuneMy98yUTwVeKvLXkxQ6eFSLsJ	1
4707	2vaa89vGRwViq7dqx5tcUKHEt4ufPR3HpuoASiaX1DoADX45c6Cd	1
4716	2vajUYiTdmR6N3gABbZvxxwEPs4ZwZENeAQCF3GHM884mLgxTJu3	1
4719	2vaiiovDv56ccsmBqzwfXw8YhhEnELrtC12C4svBUJAQHA8RUh8Q	1
4720	2vbSzAuefNMZDMg5hLoEZGFthsgs9Hp4fYSJh9rTEwafo6io5wxR	1
4722	2vbmUn6zLUHJHZHYBxgbNt1s2j9ce4Pgv8bPYvQVB9o45t4sHpcp	1
4729	2vb2mcr6XMXdXsc25d9LPAsvp8HhXtLgPH1sUHuuUy1YXmSSkTwb	1
4737	2vbVz6zxcZkBRAXs2ocuUaaEa3EWjKM2s7eDtdFXbgdJaFiaVrgD	1
4740	2vbbRpr4nvNDzSdRnU6LJwD9Rk7dyVPaJq6v8CSL8sJX66iczyZZ	1
4743	2vadECjXSBhKRnYheUfkSvfHDfpVVsEp5FsdFuXrteVY2WMDCt5L	1
4747	2vbjcXR6Xk1i9977akcHCkZRTZBFULxRJ82hvmSBzVsiyggEosq8	1
4749	2vb1WPeWiiow4JKxzMpMHu5Nvq4KxDE2epwXqmN2QLTN9h9Rv5qk	1
4752	2vampUGCG2xnWaKPsYbwqTQLUKA9QDfKZmD5Ti4wQ5qPzvGFBYUS	1
4754	2vbHZe9jduDKaXX53GoQmhX4YQSvCQPF8qxQAmtDJ71PaN51XDvF	1
4759	2vaP3yGAaMpYXN28RWnMq1dsQzkNTzSZrEJ59Rb1vF3pRX53Vn49	1
4766	2vbW9W1WsqufyoUUPAEUS4TyLtn7EhhubfeQXyz8BLuzMCam4obc	1
4769	2vaTD6r9HbfFFAtTg9CvZ5r8MMKCUWEVVpjGw3fCc5aH5SPAfef3	1
4775	2vaH3F2TitqFuxvcDNFX1dbj5qZRMEhTvMtneEFpLd2L58FBP4w4	1
4778	2vaJUwybpzxuLJFVCbEob5tSNgJiLLgetwY32Z1Lgxbc2wpvaJF5	1
4779	2vaebZUmDeMcmm68UgJEkYWrgQ99jVuSHpFRRTEhfwCm2NSEgfPE	1
4784	2vapVXQBrSnZ54zFjD9t4axLWgbZZfQH6hvTy9pnHnjTfhvwiwQT	1
4787	2vboMezCTT9X2rhfG5sPCq4hW3pvHus92naZnzEpPRbLATVmDEJa	1
4793	2vaAMkzoKsskPrCd8GRGjMAVEvAvCqhzmkYhkymWVaNQjGNQnrfk	1
4795	2vaSSrRbm9WVc2mNPZyiBU5gSMqiNfkPXshX2dDg89R1heaLj5yd	1
4798	2vbRfCSt5eZEWB4kvxzbSDN4DBrTVo6kVVS7a56QTEffgVT8C2tt	1
4799	2vb5ECXUtfHkov9WbiUa4KFPSJ3fPzqpLVFPpfkp9YHHzdrojY9w	1
4802	2vbB9wMpHknazY2Eq2NJA1xUHHjZrzbgJ53usk8Zu81ZVZo5DsJY	1
4804	2vc3W42eJiTjbMzkghXJgp1wwAr11RkMZeh4KH3WNKFvnXN17dvy	1
4806	2vbts61UuAAga4tr4u4Ayabw5Nbx6d2waPgGnfEAweXtpCby17v3	1
4812	2vaHtKod3Bs3sjmor4JJwzRreCb3WZJXm2dNWd6YWZBJGhDBfHxp	1
4821	2vaTgpuhdE93iPjPpzdctkhzPBkeb6xWSuQafL4FYGFdaeLsaGvo	1
4822	2vaWkHqgiNckmzxZPMBpUwk4A4eoy9Rp56D6Be4oCpLiyHe1TdgE	1
4825	2vaarFQ4UvPncmKqF4wsfbNN9jYzPQkZsdZwwkYSrUYeRnDzKgRs	1
4832	2vbBNQTatUkEavCZ2TFx6QnXCPtvjgZAPfb6fnFa9ufy2CR2aygo	1
4841	2vbkfZjR3jazUDgQ4v33Srs3bzqpAxSxchGwqw1VEPEnrp3H7ut8	1
4844	2vazcMe9tYdfHvxGTdWPpZqpgWYkPgWjfVFS3Ua7unaUkkCjAoTF	1
4848	2vbTZpM8K2FkosUHaRrTz82K5skB35RoTeqMcxG8nazZiSQh9dzi	1
4856	2vb31CiTKR7hUMw9d8LJjBKahpmyvmHgdBvwLC2vLyv6i4FXNK8T	1
4858	2vaxUP1bERVZhkSGZUYvCfAsFCMs63jBa7FMQEEixRUxbTnXQvzk	1
4863	2vaPAHsdeKM9EeqJFBAZxmf7Hn6L7k1ivdMNqsL6yXUmsfnjoP1W	1
4867	2vbkrYJphYgQniCPuqcd39MXam1N72wfYdyNvRrsmAEcUcGKbBtD	1
4869	2vbq1aYaViDuPsADYqkfF8ZnicV58zhbeRHAYAWWAojb6EqKz5sF	1
4870	2vbVg1XVrPFtZuAB1Vzx8xfg3suadVyxS7uKMEnGdAM6MNUtEPa8	1
4871	2vaaaaCTpzykSQwrMt1AdS84JntjDpyw8MoV7fKUu27xxzSb6iw8	1
4880	2vauTAqjzp5ya3ouLa8o9BS9FhbDmx2BcKJbChsQEYNU8sbpfo3A	1
4884	2vbpm4xytFTFRq5K89ySULgqZ8egVRyfgqDzWyZnFduVh9AtmHGZ	1
4890	2vbxxHB5z7Zdah95ZuZ59z3ohFLRuY4zsw6aKQ9MsdWa4egPMPtC	1
4894	2vbNSsmVPDuFMSutXwGQTjgAiZPTLfbEphHaVwQ8FxvrrWwPMmJR	1
4898	2vbiYHru8fPGUKmFWqKKGG5chUuqPLqiNn1JEMx4gQYWGk1CRXpY	1
4899	2vbX9xHsBT4pZATRb1vd4EAhVip9B1yqzPaixuG7pfHcitH2oAM8	1
4903	2vaBDLxp5xg8F8iabVRW9MGcuniCPpPJgkt7fxwsVJoNvwE1PwK8	1
4905	2vb2b7QeTFdfsk6tjMbmg3mcbioXCHHGQjfhH2UoBX3s3sk8n3po	1
4912	2vc1jw4u4bFobnxkhVdqDqh17kTEFjGGSrZVidUNtLKm8A36C7S3	1
4915	2vakj17ovipd3jKZwELtRDRqzdNW5fRFNZvCSVJ9CDTqKKW7dgHt	1
4919	2vaGyq71csMksb1WbL5uqxCfMS6LYCMWLLQacqd7qNhpVwq14Zsk	1
4922	2vbo4ZrnT2sj5yDfUSuEFcXc9LqdHh6G435LfBStbbdDtfuChNwZ	1
4923	2vaJ6qZD3de2FP5CNCcCN3FuiEitmAMZVu1CrXhjr7y8Yo1fsv41	1
4594	2vbKB6C9CvEnsTkK7TZLMkkhfTSAaR4trjgrsKPB4PV9XsGTJuX9	1
4596	2vbjcfcm6PWwADAhPo4VppCyCp7jVCNixUsdKK3pCNnqqo5Q566s	1
4599	2vaxcTevv1qaqcN2117VqshLTnGPz5kJTQkFMGio9CSGAnH5qxJd	1
4601	2vaknNsdx9uVeiqm39iRCzYLeoUDKzbDVEgnUDnn6jqwGQKWL1ZU	1
4606	2vamESbzhDbc8bPp5nGvTytXs4cVgcqqpv58NS9oJ2wXqR9H58wk	1
4608	2vbnZKqB7CAKv389iUBThhvS8TWWbZYeyFJAY7Vy5HQatt3y9Kku	1
4611	2vaeZ6R4Askn2UJU1DczdT7dEsaBvrQ4JCTbHyW8wJ2DW43futPR	1
4614	2vbY9tUMWt2zWhuwBmstU6yp9JfV77sotLx6bCr7MM5waPhCJP2S	1
4623	2vbJRboAGtcnA6dHjzTipCVzMyGie4tpCe8fRWpuncUxdNKZpptx	1
4633	2vbXNCVuL9djbWZeNJLnJ95YeXYauq5MXwXTQgxq97hhBLPX1U5W	1
4635	2vc5EUwBJyz2L6cvAY2xSQb8LHJnaZgFwBDxyie5wSWDWSgfhEgU	1
4638	2vaBNwjZS4oi8TggtE7GmwxvPqnPj4gfeTEtgpcNFEvX8H1R9sZA	1
4640	2vb3iiUjQbCHKLHsvdPUfBo5MBdNLtPMXPPkww2tmqz54SVk4Yoe	1
4642	2vc5uCSQP2hHBAFSuCCajqkLBxV7nN5nxUWLTRbycikeeU7AHJ5q	1
4650	2vaCZjT5G6EjnrcW7T1ybHZzFFYyLeaF9HpxxyRjEDEagntnasWY	1
4653	2vbU58WjHvo2L4prxtvD3T8BvH3arpNdFY6mvh4uJcZEFs63FtkN	1
4655	2vbbXAFaAbfEGt8YFKcaBr8GF2o8fhRnF87jxkssQ96VzyS2wh5E	1
4658	2vb5K81nTieiq3EN7Jg6pPN2kVHkGjGsrgZgRJs9Meao6rxZerfJ	1
4660	2vb5Wb9ZzXoGdg3U5ir8xwbdVz3uUpRQux4Km96YfNV4dCRFbAgy	1
4665	2vbhffX6rMz3YjnDiAsatqCgNzThVCFZtJianaZkNtoSjnnF5Uqw	1
4672	2vbiL8P6Fp5h4pwiGVNdtPoqL6fmS8urDEDHkkVeXRvMaBbnMKb5	1
4674	2vb5cRcUTD19fvqTwz5fbcdwtweBvvaFkcJxdVEZPP4gkCsRZULg	1
4676	2vbwSQmfYZiZJoZU4F5Acwbt7DLRhss7DBJT1neqgo2nyGJb61vb	1
4679	2vauor4gfQ3VzUTv7A2GtpfaJ49ZHtrD3emqRGiUvfTY1acY8wWe	1
4686	2vbsQLcxTGCf39ZTWfsTuWZYm9XJNZaCyqtyxZac9evYTVb19ZdU	1
4690	2vayG2iTiZC1XAC4mkQssmrDPVAamUrGMbtpNrGRiQHS6QGJajMf	1
4694	2vbCziBMFCgZSNaJGjcHUdnFZmRQ7jp4SzQ6uY6JmhGW6ZRbQgQo	1
4696	2vc1RAjqoqesi2SFmXJwLMy8xrQADTzSx4KK3k1ZzXqByCz6VeT9	1
4697	2vaDXszxmJj7pkB4CBHXoJPwWjVmaZxT1GdWaiwssN8WipqtxPUu	1
4704	2vaKkxAFjk2EnnaJp1XBGQhF4zfVeApcuhRsBBRd5UFFurSKWHG7	1
4706	2vbReNEAuYNGHS9CdM3SnPfe3Si8gXW6DzJqww8fwpxQAmCXvfUd	1
4711	2vaor5AWrNv3puom1N9RtEJrXWcV1Mm8mJ9mZrNXxcxLXLbL6rZM	1
4713	2vaHdfcwVH39kMyV7m8NVCKHXP8XcomM5XBpPkmrfN3Jfr5WrUJQ	1
4718	2vat9nzneL9ayrqWsLapCgCNfnFo7CrUzPAJd2hKheomkRavgP2X	1
4724	2vbn2eSUtW9hJ7iKtS17JD8i6CPxdC2GK694s8J9dW99NFnCN7c9	1
4726	2vbjwLZzvfpd2xJRiNtoddnkkGqFLfPwh7jprkf8Kx43e5XWp2Bg	1
4734	2vbLXkxdcXngYnxs3jV8QV52MtjcrKB4kBydeXAkkwUEPomZyN6p	1
4735	2vaNWa2YDoAa1ASNfham6Y626oreyMXJ1AZjCBhomd95SSvAAJj4	1
4736	2vbFgJzMBUnCttQreXWPSz1sG9sbbFPDRqghB4Z5DFTtSmtQbYDZ	1
4739	2vaCPqMYFdSZntM6rEB8LxY4F1ifwTN7c94LvKg4UVvjKa16u2fK	1
4744	2vbVizuBiej8MzxVBHgwQZvEHdTnSpq8n8jZRhSh44egZJe5ZVLs	1
4746	2vanjJ8az2QALizHLXaDCobJzzFdvmHcrTaRzzYVBQEuUtCBfefK	1
4756	2vaqfQUHGVuG8LC8ER1fGW7Q4HEtGPmUPHswVBc1nsnteXMRhJ7u	1
4758	2vb959uKFTdzTU7GFnLeZK9nZ1bAcwLBcwmfjyfWRn9c3aTQiTwa	1
4761	2vbrf1QiTo7Lkuw9m4a8jjy1PyLYNtr9RoJoYjs9SEPrK2bzJVRb	1
4763	2vbm8jZRQe1qAAqY4BkzVwbKYWryjAbbhriEBPQ4sH9A9ARGigt5	1
4768	2vc4JLMcaNQvS4b2P6GNXqwjgEmCTwJyvDB5p3ntNTVcjLqm79St	1
4774	2vbx94YYK9xCDiXvbjEQxvYww4e8ZtxQBJfzjShjyN4JaczGtRhk	1
4777	2vb1R1tCjo4X8Ytg2pGBiu5YSFU1tNvGVDU9uYnPkF9MCkQkXKa8	1
4786	2vbUTZaLajB3zoh727EZcNX6cWkAMWEk8KyyLQwRp2CbaJ1HCupt	1
4789	2vacyR3ykzgQmKYqQLFJJRLbxSDzH6hL6gHigUfr3SBjnnSRfswQ	1
4790	2vaGVxLz7GMn62NDMW2raqKAfNS7qBN14DmUftCPYVNz4j6H93AX	1
4792	2vaQ5csoY8Ge4vemwdpBqwtfhAFuCtnCrcDYLeAaaVpSw96UMnvz	1
4797	2vboTD6NuJvMSUUjc7pY33KDUpFtA6PJYiQ48SFYhRBYnSDQFxXF	1
4801	2vbEdDUHwjEUhi5pK88A4Xoow2c15bx2VdmQxqyXxBDDDQ75Y7Zc	1
4803	2vaeS4p4LXKMuorJq5jpPwgRxsbFp3d3LDEhzh9JkkrhYHAkMSWT	1
4809	2vbm8FiCv2DznMZhqLFQ7QzzRUaj5iA7RwprsaYFc82rRBmzBKEF	1
4814	2vaaYkESBeq8ugGzL7xXrjJyAb1UEiSdPvTTB6Nfc4uYQvHiZoid	1
4817	2vattaWGwUu74gf6ovADccVTCnQStLdLAHR2Bich4pGt1fhE3bHe	1
4820	2vb2nRGTDEkzA8rRyXwziuw1mecgshwYCLHhrRmGPvoBGUT4c3j2	1
4827	2vbmxaZjjKUfh9LiMcZJFRiXiTW1yvJqMJXZ7NcsRQnte1hcgGnw	1
4830	2vbh3xKjddsGBGJBGFv9VtVtRYtgzWCW7X86RDZDtU4eSo5pBzzz	1
4836	2vb5GVa7pUS84boDiUpMVM7T8fXtcHN928XRb8B8vCVcyHHPJMpB	1
4839	2vaABG6qC1DxXFkUM1pRvy8i29dx1Ur1wn8vzXzcDzf1eM4mQ42F	1
4840	2vbU8n35pC2CByEhpHte21AVZjZGXh3jdAZ3bQqWS2xVsfsA16XD	1
4843	2vb7TmxUZKHAKtGcJ2skgqvxu2K2TwTJSL2m4PxQ1KKgBD4DL7mf	1
4853	2vb3Z5sprFRRovWeLuQSS8TQ9vDwkSKi86n2nXKuTnV8Zck68SNH	1
4855	2vadWGmPNgu69qWArfihAg7Rf9wFPvveWQS1k6GPCQCwKNxV8bwx	1
4862	2vaSZuA8FECHYVHnAQEys5bD4mNRSKMnqq7D5BZHRpVzRJGTwdAK	1
4866	2vbx7p7Tcic5C7FV2k7KgRxL2eM7w1AsRPy6b4ddxHruL89VM1DX	1
4868	2vaQCoVQvhnqJ1ZNDh9tJR54zcp49LS3wb473jcFgWR7mX7RH9E3	1
4875	2vc11j8Fpgm7iMeEnGTPh6sJkBF8adaeMye3DAt97qAUgoA7QRCA	1
4877	2va9tm55rHut54JCKueU2RfhMQjCpJo5Kxwntab8tfGqbEDgxLEc	1
4878	2vbshr3EzwXMwxiT4FffecSWwSY1PAUFyXPeHNSBCZQzZiaVpbuC	1
4879	2vaRWMDAd2f2DGx3q9mkVpGERcZXqJSDKDKH2FuuUtRaKE6GBJ8B	1
4883	2vabc7zgYnefFMyBb9KceoXEok4jrX16dsBh1vRBC2SkTXWd4juz	1
4886	2vbyMAHMF9xVxBuxriUauC91pCvkqDfeWYahGg5YooZgvebt3s7n	1
4892	2vbNRYWtUfW6nfqfC7cGft99S9nebFGfFdmeAxPRpvoXGHjyk4LZ	1
4893	2vapkRynep1vau9rwPsRQeRD2J4urEbaQtEQyWE1bSoBaTd6K5GS	1
4897	2vbJMqbeDEZpWc44LmnuckKUMtMFt7fVAuNpNWrzh8hc7zye2Dpo	1
4904	2vbauo48UwZgzgBqsUrEEj9Ltvvm9d1gwnmTf2GiTDeReGvQRRtL	1
4911	2vb6863QhqBhymizW1JBFihJEa1Lw1vZjiSCBc4NcQd7WS61Fctj	1
4913	2vaH9R8ieumHW3QqvxzA4X8pWeRU1PMJV7jSMG5uyngjjRB7NDgD	1
4914	2vbsmwDgB5Wr4BNX7PRdXuWUFRxYgEKwneiZmYpJhHmgtqNzU8Um	1
4918	2vbBYtsVDdKYu4Gd7eRYDbXYoHPNYmcaXV64Ss5Ybd1rwPHWX6pn	1
4921	2vaEEVmRZuwGBX5jLuK1QrS8G8h1bCmUYQBKV9R9j3zyqhfkzae6	1
4928	2vbccFGdWVk18EzFfTzWmisHTLhwV9qbznzqZmSABYQrvNBzYkWb	1
4933	2vb8BJrMBuemLQ9N94y9GkL4rrywyccDW4NGLUGwNfHusSpS3BYu	1
4926	2vbsHgjw2P9dsNx9anBxtd23NvUmEziqwCkwkvSWLx8uMUB3mamg	1
4930	2vaHrk8hUHpKFcvCRpWwJw59G8RCgVgqApCat9EACBGAc9nN6Fp3	1
4943	2vbnXwvWTogtw9icrKyE3xDF6M4GfYagzaSpC3414bytxzALLsqM	1
4944	2vacjg3nSZs9i2BpQTVSf3GabqxMFNHrPSeyaUjH38CQC8w15xYd	1
4945	2vb1x8Q41Y94QtCqtUXuPifQd2G7s4tLxdK2iV5dSqdhPe4HjyDD	1
4948	2vbmqw3geUgDG7Nfdu5XtXQGinFhyEoryphgQSSydiak1GiXKPLL	1
4952	2vaZZMgbZF95u7kbpH9AsZtJTzqMXSrrjiiRTuh8rhK1PKH1FArD	1
4956	2vaTA1Gr47PvCuwbATEf6XtccXkkDrm7pnCqt5WsRSqEB6NsBXwU	1
4960	2vaNU9XigjKbGtZsFa3E4aUTdL9hu6FPVv1r8SGHA1fQrZQ9h5YY	1
4967	2vbXnKQUaZP2xHQHip2Gdw9YJv8dJCWWqxLTtQ1qDaCVjD2oCoEy	1
4970	2vaPBANfQQtU5MMDbkBwRhJ45FhZB6jMXugQX2vHbU75n5GNJQym	1
4976	2vaY3t1PUtVME2drM2gqwzmAX7BiRLK9eZyyYrFcnrXQ3ZE8WyYm	1
4978	2vbPnBbHKYmgSxzAEamVAcp4QfHFV7AY5R8tLTuqGzuBeXWjxRyn	1
4980	2vbCRozgkvjCJYkRG32keB1MSfdLmuA5mcnrE8sfzR4QxHv12J5o	1
4985	2vc1zrNmxMjyHM7UPw6cWUh2WEd4sZGCiwePmgBHNbCoLP8eiQNG	1
4991	2vb5rkP1Ez51szVkmonuPFrWYkXQaXkLnMTfAiE4iZEf9JM3reU3	1
4992	2vaUirWq9LhZ3czaTzvE9j6K9ytXjARvEtsMqDvDYPGbkGKTjF1F	1
4994	2vc2AD2Rt4AUPRwrB3W79pmGPfTN1g3oxqbAnp5JKcvythNXvWpy	1
4996	2vbqwj3scECQ2gSAbxabjYjfZnQBDtNjfu2nZFxkzk5CvsMJt9Qj	1
5001	2vbG2SdPbDzF6F9PvoFujn1jJoLW4g9g1zfF6qMRFJubLJWusKXT	1
5002	2vaK3djrWv2V8uYn8WNRpGFHs6t1ZqZ6z491xToPu2cfDEfBaHqL	1
5015	2vbLpsYiGZiYotn4VRWw3vwpk5UgkGDkkXYz1ikv8mzSAF8v3xsG	1
5020	2vc4Dqr3y8uHWKcxAUMB4NfV4Do14e4XrZfJj4oKyqRM8D5jGZxm	1
4934	2va9snA5jSy3JUYui5awknwJPKXDP7dyqAJhJqKiCvKw2hdkESpL	1
4936	2vaaXgahUmk1gaFeeDvFwwHQkBMJRRUsFiJFQJ75zp7eZUaa1PFE	1
4939	2vbXdbGscMZQouU863teiSWAprGRkWYukiXwQVmtd3FdYN2piZxo	1
4942	2vbM34EQ7Dx2zhn97mnuYUrzVx667fM4tW71TokiXk161kWVTuDy	1
4947	2vbfiwTunJC2RU4UxQ1gxruafvDcDbQa5KQ8W2EZGsGSwxMG7xKL	1
4949	2vahpwhsmef6hqaTSrS5bffxf9MqsMkf1cgGpRyKc1xgMUoriGhi	1
4950	2vab79ZHuCxaLyhQwgFAno7LHo4CMDKsXHHrn2qph92e3K6TKoJQ	1
4955	2vbAyFopnJ2o8BqL2JjKAopxj9ccdALnP7LBuvw9oSEyWXpSuAAf	1
4961	2vbZ77hwkghvzYE8W4qMk3Y2B3iepAYUsvkL5t5WXEVoW8hwEvCg	1
4964	2vc51C3jwBx3B1riGnKKfQwDw9desfoMLMvXtnHsErhhGwg7HEmG	1
4969	2vbjy7EA87UatpCmoGj4zfvtMHLPDwtEMEro7macfNEV2Tw2fjzb	1
4971	2vavVPm7czyBoHNX7os6txUFg5qJQ1otz1eAHtbZzYtH1hNxHJ5q	1
4973	2vaGzToL4w9pu2SsWw3GvWFpM2hN6WAkpiugXxykM9kXoqkZhesq	1
4979	2vc3885QyxQpaQtVTVQP6nYZMjqiEtNq2FMZ4pu6mPbraKmTndSv	1
4983	2vbSiHs1P19r6XKYA6pZEBHLZhoEiY3CfNVHixJdGRR1k33U1aoK	1
4986	2vaommPigoaPitP1rHsMh9cB93mFEtrRWdJU14S3WgHCpjKNFsvC	1
4993	2vadpwAvvbU5n4Ab2TXGPJWJnqik1doygX4eR9eajdgqfeiowpKu	1
4995	2vbvh2NRmYYRwM2cjFogfrG1JspsRzktLyavz17RPv98fAayyMNf	1
4998	2vaL8TbiZu6GnH5sFx511AiWy7VAYqesjvgZKoXFLxw8zEbw4dx6	1
5004	2vaWeNmr3gBjByiNPwkuKt9r2EfHW6vi7KaPiRJcHDPTHJapc22b	1
5005	2vbzXffAMTGD5fPPQuSbvrckqaggVHBYXMgDYZUiQ1xDAFzmMVEn	1
5009	2vbR5pKSMxwd1bYES5hHFaMRErXfM19wAdiLyUd7y7N6snvEhakW	1
5012	2vbpLF1B9AyDJ61152mEwhfUqXwL2F2EzRMjcR7A1unV72axAtCu	1
5016	2vbqtSNaKAtXJK91bUqf2oqgzXVAVQTe3tuykorPq8R1dAePdd2J	1
4935	2vanMMMxoxTgTdpDni23afbymJNwThkQAbf6vYhzaLmC8sSPUaVB	1
4937	2vab5tjiZJAGdNpVw1BzEbmJfeqmyds7gnNPVpy5EQ9FNjqFCXkB	1
4951	2vc2iTnKRYFfi5PXE1fpbHkNk5gDegAXcNnyCEv9ppomGQDxi3T1	1
4953	2vaiCP5w2my8bqBSveKaEWn7L2AhBrS7x27u58DpCAFoy8kUCTGy	1
4957	2vaFFp9Thp9AzLDcatrLnVXCriehku7wFLZemBbWVWPXq3pg8RUL	1
4958	2vaTdizozMXcc4J19pT8snut8DTioPfdD1hm3RwsrFZ6yg2Erjmj	1
4959	2vam17U4HqdJk68vFS7ozstLodWb5U8CSVJxmpV12NdhtzgheBQT	1
4963	2vaX9V6fWE27bf6duzhHouQPHp3ffE4VDqeexAMDouk8ZP96Ty3h	1
4965	2vaYpNimxuyNa3n14pDSSNYZWjfRFBpkRuVatQsqkxXvmbn9uAkC	1
4966	2vbrvE47RSRcjf8RdjqcNhtfub5gHiiQxXxW79aN59Xm29D6ZkgS	1
4974	2vc3ehjoSJtb5PvctrzQwkTZZpidSSyyKdnyTJ4KBrdE5raR4bUQ	1
4975	2vb3N9dionPvKVu49ef5uZnz4C8EHZ3zJes31Jt8NUdEXjQmGnJ2	1
4981	2vc31wjasnFWCxsd7NhavtRSUHTXTGXd3Xv8fySvsi8brkfyWYB4	1
4982	2vb9ECtRAL4PpdTT4QNx9vwyQMnUC7qvxuNyhd73bUK9GTEH3n7c	1
4984	2vayD1DZw9PCxEp5bjGaPehzC81c6iV41UkSuoiF2ds3jV1J8uQD	1
4988	2vaWFuZ96aKRvZ78if4NaikqtaGY8CCh5w88wVYcz7gvvxrrhgF1	1
4989	2vajA6k6GG89DchSSEqdG3dzv1gSRV7XcdKtehWGkefjWX1UBgNq	1
4990	2vbKUv2BDMSngvZmUFNcXUQo9MNvUV7CVikE1sgoAFnTuMGVspdZ	1
5000	2vasRQkiyVWPyVZoa6ZoFE7N39srpruvkFscYY7MBgwKTEx2Wbop	1
5006	2vbpoQie1sas3M1YbRSe4jQEE2auBywi18YFjesYB7MLfsoLf9wo	1
5011	2vaY1wWWVKW7J3b53K3bLsHj3P1ySvmxGYjy28MUGTewde2fkijQ	1
5013	2vbUCsRJGEXKQ43k4JKvP5fg47kRhdrDfWR6s33AiNi3aFCMvzaw	1
5019	2vaeG36EdGTE2NM4KTxRJGt2Xc2jPPUDakCcizAKzRffyGebTzgu	1
4962	2vasrx9gz4kBPNFpG5bHf5bxUFUGVYaaeMd6jiguMxDTfUQCCpRj	1
4968	2vb3dzcc9SBHhuMPQgqPjSRQTYhwjDbdmCDkvfK6t5mzv2v5n1hr	1
4972	2vbxbU6pj6Puo5EaTJFk9nzqSJqWBg6smQdmMFYL8hFNoYFaoHLo	1
4977	2vbhg8G7JStPTL7JirZUgyqUemoJLFFmaBGYBXB9JbUbwuGqZGak	1
4987	2vaBzTsJVYzYKqf5VZTRJGkeBGGCatmHUp9vEfYSPXoMQDUnSQmn	1
4997	2vbiR3UWUE9fgLbvFoquqDzvxwcmn4SiPn7A19NBxr4GcmeNnTtR	1
4999	2vadDJkBf6q4sTNQbB5R6egntQZhybAvhW9V7BsrKSZ8iMobdey6	1
5003	2vacaukhycRoJHXzZrn9wVMJo4Y7inXe23JNRSZwykzKX5CxxyD6	1
5007	2vaB3p1JbtmCcDjrGUu9hosoXYrsuCA5iW7DFCxVb1wLc5LVcvSX	1
5008	2vavf4Z2o4qxrhHkB85V1WzRdT1nwxicPx34moSiosVYNsCw3wyo	1
5010	2vbFfVYGSoMcB21KQc5Z74kqc6WoNearHyxgX5Mr9kHpn6NKtW2B	1
5014	2vbvreheAtnwyMnrQiqZBs4om52Uyp6HjHS17M7a8AqBcdb63pc8	1
5017	2vayBDUGmWQ5ipwjrmxAPDhyRPMsuSeG4mUhJnr1qVLCCbbsKzZ9	1
5018	2vbWhHbXzRtYJ6yLLokmNYhg3B4YTGF32CC6KAeU4iPABUASJdQr	1
5021	2vbrFc8kJdh584uGoa9LosM5p75sLHJKVT7CNxZnhWnufnL7uQaR	1
5022	2vaw6ctPu2wTLNuvN9rkFEBA1fE9TGQkYuGRAsWLzV2MBwGjzx1n	1
5023	2vc1PQXjDmiJErRZAZAC45N6cEX9ew2HU7o1gzwJ5XLrzeMonsNU	1
5024	2vbaCu4doovkgZ3EwtuE9oZM3QsLo8fiVTProFqzAkRJhJ24QnRu	1
5025	2vb9nAAYXDoXbhMFyGx9jwpgSLQEYV6MwUDTdwz5rtvCFhyGyHDQ	1
5026	2vb2V3frJkMYsARt9MN6JwUCMXaXTToWvCxp588riAkbyCSJosQt	1
5027	2vadEv5t82h4U7YpXSL65sDJWcMvmaTcuCZXA1JGL3zY1WCkRRDj	1
5028	2vboUdcgGEMvueAJTJLYc6hTkxMLcjzjD2XNHzXPnNQNzUsDEV4X	1
5029	2vauL1PedFN96gvyNXDjtzxwGHhq63cmpxe8i47svTjhucZGKyQ4	1
5030	2vaVKtsYVSYExN8pkGzRpDsYaL4JKiv3upbuNGvofdxYxYgJEaTD	1
5031	2vbjE6YrLH7W5TALwMLJKixiwQU2J4TZ8spyowwxqeJgR7XA6f2n	1
5032	2vbHqwMb3ngaaqps3sBYgxiHepKdY5i1eAeDU8rqaHvquiNurJi5	1
5033	2vb4ZNSFc4B7C2pnPa5E8WWqP8oChwEdoY2bav2pY8ikrHRqeYmB	1
5034	2vbn6Nk87pS2TUCFusaY9yvFHXRtaut5684KhDoXbYSn8dsxcs5V	1
5035	2vbpPpFM3xwBACS8N4g1ifKFXWesVLwRfzaC5MPL8qV9TCCLkvuu	1
5036	2vb38dqvEtNaeDER1b4JttL18xFZbnDeeXQQgim31fLv1djPYhCi	1
5037	2vbgTvPLKaBK3ghZ7uQRiUCpeDyByaFYrKXPsxfEhbEdG2itts6v	1
5038	2vacndxhytK7Wg5EVVKXQcKGHX4iLsuEFXP9ELvX4g76MR5vWHAL	1
5039	2vboj9Tj8YeSAP9GgD9zWwuHCmLmw3gzxyG9YJeCZtwspmqTG94J	1
5040	2vaBsxX3iheqh98zYHTSobJU3mh4XugVBZCtgzFwAmcGHxppQAsg	1
5041	2vb7i2RnSE14TzGPankeBTBV4dVb6wTFh9Q8JLpQB5Vzpw9GVdVw	1
5042	2vbWiUw34P9wH9hN9azgKgN2ARkiDRf8J5t2eMrSZFnPexr3JxB9	1
5043	2vc1j3NEAbiNNRKCwqcmekFdjh7gjJ7w2tR1hJVhKEm8Wd4vy5XE	1
5044	2vbKBcWf7M4nKdAjGMo4R5ST9NeUqehwSiUkrq3GpvShvV6nYBn5	1
5045	2vaMJer8zU4JBGKoMAqtACLxi9D9kCAP7czTt1D6Dhb5x4SN8nPA	1
5046	2vbN86EAtJyGrKEbyZdK8UnJneV6ZPjRMoVPCiRPMw4YGBMwEGY4	1
5047	2vbgUjHuxASLCMm6HGJicr7q1PFo4e1nCSjaSyhzxAR32kSND6Sj	1
5048	2vaCLfZxtmVp6pHb4rwwT5oHA1Ms3Nw7eTW3Wgq3Rush3i6ZTPDV	1
5049	2vbapUKNxcjqPvwJ1ENdMwgdAPtcQgkEPcaS8vCrpxTcNyREtcPA	1
5050	2vbMfBvYRJ9vs5dmQwAJSD8X3GzEEgnbyP81L5Yn7uA9HKitQkFz	1
5051	2vbhwaFRXS8BAJLjR6HPoLPk7HixUkQeQuUK4uXqs8Cg397kR18r	1
5052	2vbpDMteBpHDQZrJH3EtTRrXpU8mZAfu7LWw1hgct47bKgCsJL7V	1
5053	2vaUZgJeujUztpVwcaqqJAAaHdBtfYykDPFynNj3peHeeAejFna1	1
5054	2vaHULB7ncr7986RXRi7vUbgTc2oWfgkVTHH9anYN697gcLEv7dG	1
5055	2vbBcdDmopfDwrwHtQCejhNkSWq9pq5ZyNWy43XSkJb2Hze2BH7x	1
5056	2vbMXUMhmEhTtEG1K61wY8iWGKw273gB2FCgxtVTXwgg7Fy1TWCh	1
5057	2vaQ1GpGPFYvGRjfBehtFGCDYA8a67iG9gt7fS53L6DBtdwjv6t8	1
5058	2vb8m5wp4ZCHDvdwVAZ1JhB32Zd8WCkgmGWA7ahnXrPXiiwXbmZJ	1
5059	2vbeTncDdwHwFaDbHDBF5ecYraUcCp9r64VxSpWyuAER9hdLjSxT	1
5060	2vbSdZG8NRRfaJBca5qnkowXHHUrguRak3zbKBrYmrbu1D7PTfgD	1
5061	2vayEx36mEZ9oUCivNrw5fMg2QFdW1jDvPKzHhLGeorVMoCRiJj9	1
5062	2vbi6bUFF2j22mtNsgjizBqH4ARdfuhKPXSmQTnNtrxaeBLwveVm	1
5063	2vbbebVkB79fgtMQ5fB4M6fKjy93WyxZYL7kTcNaCaNcAM4GzNyS	1
5064	2vbNvYhoxBkZdJbzdMBZ9sEJV54XEAdNtsbitB7nKt6bK4W7QCJ2	1
5065	2vbZNsBvm5xT26DCvPdLRq9FVjgonMRL32Q9Uaurusz7qvNuCYUw	1
5066	2vasXxSuncuLxykcAmfgjNLNyvNXTWxhsWUwhYKiQxQccPTsxoSc	1
5067	2vasQBJnb62fVfdeYVvF4inoZstPjWb9fZg1ZeNyUS6tbiLNeBSW	1
5068	2vc2DvDwCqSsy8uziciuBVXMHX6Ey65FEb2dFfhZMH4M7naHiHq8	1
5069	2vaeSJybk48jBGE23Yd2xqzjxwsMmbWsX2Sov8u9qTyjuzBtJXJg	1
5070	2vbSU8GEHXd8TTPy8AVxreqG16dLyGBpC9Ve4hubyraUvbDaG2Zr	1
5071	2vaQNg3CAxmBw5y5AJdTafnK3XewayM3Vq8gX1cDvp8d6CjEXXKR	1
5072	2vauXf7T8ftbJP7VXrseHr2Nxj8oCJMyLWmNFiaVABUkNLBxbPNG	1
5073	2vbLCuBv6nnwXYce7ANdn6hrNtMLnDfNSYTaQx2iZvk3nkmVxpaQ	1
5074	2vbsxwBCHGSKLzx4fqYrFsWExnrsNZgMYAgG4hchvvZEQVGmPHqB	1
5075	2vbrTXQyanrGSsWSAg5zzWdy8mFSvg22LnnMhXxSoBh9To1q7vZz	1
5076	2vbZts6BpGcYfskMAAVphSzHpHdVuhhoBHrQTTE9JF4xizmZP81Y	1
5077	2vazS6owem6GituNxnPpih2FY74ZhjZXZbA6pYHiPwiz6omuEnAe	1
5078	2vajSJrCNqJF4SjjuJ8ktXHgGrA1QjWrVLwMvtXeWpXFBmaWZCMG	1
5079	2vabWgbYYx7gCTn2uaYoacqBE8iiePNFvLZnQuiTfxKvu5vMTmZP	1
5080	2vbkJQ1nsCQVwuYbVDVTHBoiihhemXQz5iaMPFvGtaeHGc1E1Jju	1
5081	2vbLegD9DAsgDLmqHg2Pr7NxbtFnHK4K7dV6q8ms14sBmyTPzGs1	1
5082	2vbY1DeALhGyrqNStxjvFyhWmm16KaPoC5ctc8jwciv27AXrWfoe	1
5083	2vbeGSQgvsyCkzNmV82j6ddGRJ38dUvPRekrs1p2oA1kmCF4Ka8i	1
5084	2vbeyDk1sYiipNCbL6Q9wcWg9wDWNPqrtNy2A4r8FVaQbXphdaBr	1
5085	2vbc64RZULyaBU1fasez65cqSd5V3p7Mo91WVoP3k8Ti28qP22Zq	1
5086	2vbcEwZqyuX5DEmKUqFaHx2CtDYxGuvWKmQK2DPpdNx6uA3Qn2sq	1
5087	2vbQrWpS2jry7vef7jxU6FdkKX9UmDoZqVZtsEqdSg5FQBoZWMob	1
5088	2vbx1zLaFMQSXTxfqJcHZ5zTxWpS5n5XPWoQwhXai8uZMa9Gho4F	1
5089	2vaAcH7JMF762geKdeMbs3XatWyRv4sWaQ1NbEhc6pn42zYFbWAZ	1
5090	2vabVc2ay4bwoQaA6HtSsh4iHDqF3LK7YFCmD6AbFKYhcPBotPr8	1
5091	2vbtiTzB5r9bbbpeG4aYttLmtgP75uzrPv7r7VKCh9cjwn4He6uH	1
5092	2vb8329txXKtjk8u7RQWk186BuP9gqrmNCGQHSPUDjJVWqxRykRp	1
5093	2vbMn6TfjgXhQYMdZQp5kLyMF67LFb5Rh9WSch2GmTXyLH57wWRX	1
5094	2vbZYLnLGRUAat9BGXdR66S789TjRUBRwi475BiTBJPS82NdsW64	1
5095	2vawwubFsfnEYetTFF5pHHH6r3s43Xbj2KqLvkQc85MVFXvX3kKX	1
5099	2va9GPSBE54uxYHaCt7YX7kcdvzd817inWLvAbipcZcQkNRgvbPH	1
5102	2vbpqiaUg9aCTM9rePSa8fqVjDt7G6CuQS1kRpkFicyH35N6SFAH	1
5113	2vbDEQyr6ZaLZinJ3xcXzxQMvAF5oN1pzyMK62iijAmdW2WgYMN3	1
5116	2vaihz6VMMGm874rReR9MHR4zCQokVmWHSCq2NgFpKKjnVgb1ejB	1
5121	2vaV74q9hdJw4riW22bAiPTm3eo9QPCBmZhfk8rw4JG7cWbVzAEq	1
5122	2vazSdN87pRPBg7cKo84TNEp5JxdyGSWG38RxmCbLZ259w8WdiMz	1
5132	2vacQ25PPoxYB2gwXLm2xKEMhVhp9pRWa2PiLGKH8Tf1fNMdQ37o	1
5134	2vbRFoYCKXsZUphYqirFY1wWD6JWuFkggMpbL3s3cSMxAvnYjpDb	1
5137	2vaNBys33p8wPE93Shg87UPyhfpsbwocq3NH7Ai7wSCQKv9AbVt1	1
5144	2vaoHcM5PryKBWcT4CMKBfregLxFuNXkQ58SWCQ6WyeK8c5nB3kp	1
5147	2vbvXyWJ31vJraWauRiGoABZXffhYvYR6c37hbFXHduEpsTpG54Q	1
5156	2vbeu48uxBSRuhsRQGv3M71Xf2PnqF41PMr9u6S2ggmet47DWY5F	1
5158	2vaokXWQxS9Dz2JJXdkhvBGVNNdu8r8YFxxym3wr3XLw2DXRJ5e5	1
5167	2vbFRdnea9ohC6JkNfj79Gapia3qGszDJJ4ThSnN6vP8eyDUmnDC	1
5169	2vbFh6w7VmSngSwVpBxkXsogTLeodN357H9NUEtuosbC25F6NFcV	1
5171	2vbky2AcoF3W224KAETBmw77QmTybs29sWtGQWzz2gYsN77sLh6B	1
5173	2vbpBdzYMCGyenJWnwNB7P9DFfdNibjbSM725X2AY7gJQHGNJmvM	1
5178	2vaFYkXZZi6JFfEcXdJwDGQJJ836BMxvYJAmMR4ZU3bNTGFEPdVX	1
5180	2vaQkPeExmY8qLtQaPbnzeopWtepYj7YMGtLhhAxNd6hgtns2MHL	1
5185	2vbaDQcPWggWkMr78K3kmq6ZyAAjHyuDMhNgevoMv281DpqvaGMF	1
5188	2vbv88XtxQDSWHUm7LoWdA7TKsgPFFf84fkqQ5nEmv7sNHQmh6FZ	1
5190	2vbsk7Not5vah5f4wL7FrANu3TnLcw4hoYprA6Usgpp38urHqQqd	1
5195	2vbsZcukCuM5x4YCzfuruPTCpZoLHYqqNLeDqYGLF6sxVgSdNynQ	1
5200	2vbHt7BY8c1DfJHrPWXzryTvttMevwRQfyB9feDiJRMYhz9QeLhn	1
5203	2vbN4gEYk9qk75rMQTM2YorqgCQDyqc9Co5ebPXn1GwMEr38wyGG	1
5209	2vbKGx6MMJjZvAuFrZ63U1D32frihc5SHPDvx1Pxdq8A7qWw5rQT	1
5212	2vaead8BZ7FZXfMvSMzV8ZN8eTFe3MV5nLCSZe3Cm8qZMzsFdKfL	1
5217	2vbmmvUuj26qcESqbR5gPGEtH52qmRpBgUoDRwh4Nw5Udgh43m9r	1
5223	2vaQxXcQ7JsNJNwDkB4JjcgHeyR1HzFHSreNqg7zC4fxhTNuZV9R	1
5224	2vaoTvXSsDnryGfrca3NYv3uGyKnRAdJdud7sJMZTxbGntSndNsk	1
5226	2vau6NLHwevRFrd64bq22qWn5D8BJjp3ELC968UQPY5gUKcS81iP	1
5229	2vaV2hZV3ouPsjp84V2oH8SQ2P62o8cobC4Z67YsbebZJkJvcsvq	1
5231	2vbxgiUcWghHdcY6zgbY6qoMVJwCbwbQbgTN9GNe3dDCXJUqj8xn	1
5233	2vbNtXAknUvN63WUhmb87Wu2FM9EXDKnLwGJ9e98frrwpRmACMhP	1
5238	2vc3BRr6YPySzKqqnNRReJzA2UT6o2rhprxz9D1h1hRHgr2XrgjX	1
5241	2vbnsMTUXR7s82tXTPXtwNqhoQcBhz89ur8DzePm5AR8JqoWrVPt	1
5245	2vaxYWXcw1CT8EVq8v1eGpUKqwx1MmUNgjPDnYi2YvyzS5c8hwro	1
5249	2vauDvb4ShqtPAUSfXLLHo2ocfZgq3QdDugtsng46vddEnfufbHW	1
5253	2vbVLZB1oSGH3muYpGFLhaRjis3RMfNzeW9oFRNywLRtfJr1T9pj	1
5256	2vbts8xNPJgRzTPmkLbnfpkegQqky7r3ars6QXxSDosDw5CyWFXZ	1
5262	2vawKzb9gxAmVqHMntijG9zzSgn1ygoLGkLA3QxgRBCzyWPPrbhp	1
5267	2vc16SSX7w7PP3V76StySDAPQSQCNNnT5cnQAK2ZeHuciwWHgyox	1
5269	2vbURkMVL2vEnFem9cmSxBuSdttmHuweXbHJYfbw3uyUDUDwZSmZ	1
5274	2vbwviak4u8M4T5qr1xB3BxhmPjobJ97ghL8FKzHQRwN1RJcHuMT	1
5279	2vaZ71rQF4tPrjFmvQ6TG6LiUdcCycEYuTisn68B1EiP5du1Dqgh	1
5284	2vby4M35J5V5dY2hyx6ThmyYbbFVAYXZi8JriopkKY6w6SWKkaMJ	1
5285	2vaqWdQ8rg73YkaLBJPQcVYyi4q3FHRg2FSg4Ru2nMVcJrYKW486	1
5290	2vaLz2Ueq2KBGGL7Yquz53sGoTy3qhsutUoJ4NKn6mBtXrwYZAk5	1
5295	2vbbdi7vhfpezy62fXALKcJaNCAowg7ZUoVT3mLpG3Sd2d3nPbYa	1
5298	2va9oFy4DtiPvDdTk2BJsBzADZjhFVam13moZxTv3nydQE7T318G	1
5300	2vc1soJnEvn9qqbThx7Xw7npqwGWFzxgyFsCZgALbR2iYCzBndEy	1
5309	2vazgaAhNjWFnyUMbi6dWVG6pQDh1xk33S2VyfseCrxs2UmtYyvU	1
5314	2vaG8niw1pvXS7pmPPDhoB4s3rY84SXrnrMNQKM7gFiNN3qaE29m	1
5316	2vbvarXFG4xpDV955FLEeXSy8SnsaBJcX4ZQ6Yt47uVJKUDGRPiH	1
5319	2vbb2744S9ao3uNJo8bQMVz32cdPXafRy44vmMQLSmxFJft5DFNk	1
5323	2vb4gKJhaxh1TsXcBXKrCUsQEJ5DPf2wV5ZMVwe7fzGZqapaP7TB	1
5326	2vb2atcyzeMyJpB8dsXx1FgDSNHSkQ3vqznV6QL8yJ2g84UB9qwy	1
5327	2vbFoiyuhPf9qNmQW7qw3WneHX9vvQ8MroE4VmH4hNv2MFyrgqJF	1
5334	2vb2qDXpMPW6HChrJRzKjb1uUSDfaQ8cVvTbeLEDSbqbEe3quxSx	1
5341	2vc55roKWwntVGYbp2PBJNnyUMfuvX77qtEYoKQQTCo4aosWzENd	1
5344	2vbVit1NaCwu9SpXc3oyVjnFvnS754FpHXB1gwAk9agwmEGyA9Xv	1
5347	2vbcVQG3hxyQYpwHGCvYramtAXaS6Ym3qKDFXD28UsNbRKveLYGd	1
5353	2vbFvZVKRMqnUoYTAHQoFCYFLfFf3edyE7mBeKzo15DDB9CrDV4C	1
5360	2vaTnpvZqUbR76WFfZEdbDkp9M4KhbfmQSHt4d6wW1XdwTiNeaQn	1
5365	2vaaRdSAPvFQSzpzfD87pnsSgArDSJ8UpJJ8S1yPtU6Eo537cBxz	1
5374	2varX4gi2Kd3F3TKH4ioTudEMr98bdJjemHzcQbZxGZFYjK7q67a	1
5376	2vbA3VMzPiiArqApArsEB51LENkQoqyKPCtYPM8E2Gw4JSCrCXZG	1
5380	2vbKCAPN4QrrqMSRyPg5ULfP2EGRg9n3U1hZRkrdv1UhbzptXt77	1
5382	2vaRgomiCmtxDB149cby4zHjBokbGUVLpPuKqB6erd3zRQimHHdJ	1
5389	2vaySj7baEeuNva7Si1cqqjfXj76BTJeiBtVVJcXHd3kjvGuJeic	1
5394	2vbBgUXfEJ4pRbVs2Vv5spdjeo8p7bA5nx9a56LvrG3y5618uX3K	1
5396	2varBFDiHgwz35yg2JVHz1dWgzE5F9n7KsT6bqhoEdW9XtdqX73R	1
5399	2vaz8LVXvH5gox8ZiiWL3eaA1UnD7H8RyeT2X9wUHA5StfMBjY6F	1
5408	2vb8Q84PfoVjAvaP4oMRP5bNVSa7n3Cd6FBHUtgftxxxPj4qKzNe	1
5409	2van6gwK5nmtaqmoz8edVyvW4B3Mfj8ejqDM4NjrnyQTyCe8Twan	1
5411	2vayTtuqCtKqkS1DnG8yvi32RW6wXjxdvN3ExT3mXfGjEWBUeHmR	1
5413	2vaU2HmPaTn2FNkEqvdpZkBXZvfmD81iESFDrb3UwfPW4a3PR9ZD	1
5419	2vaadJbu4unWHGf6NKydi9Fdzdnp4TdpP5oLGnTb1Sw41Zos9bhj	1
5422	2vbdLHCyNbhHFNRnFgKdp2xsbkxb6ACEwBNfPBq7ehdSbfwVdd4F	1
5425	2vbGALEQeA5c1RyjRvTT1a79tn51xoWJXe1DQwFcz9S1M177N3Yu	1
5427	2vbg4XkPPATJLXYVSUvuKuTwDSJPtwhmVpJ1k4jBTdmjsBqWsUGe	1
5437	2vbdxt1HvL7e2ZMKso8khymLuDmZ7W7jMjeCBL7U1JCLyNaYjcjn	1
5444	2vaZjAKbeysXEPAwsRK4Rko7HwNorVLnYc8hViW1rTaBM93CYJ8u	1
5447	2vaEMfTQfiZEjLxNwzhraTHSKAyuEwPRGcuTFZEaJJWFxQAGpAUF	1
5450	2vaXpj186zJroBHi7NGfU6EJa66tLDjQAFt5rZwxQMP81hshD4jf	1
5452	2vc5htyRG19DjT3RvauyU3s4PwHru84CxeC6k8anq2oeKfJhYfpx	1
5455	2vbST9vRLa7d1QMxvmKATg27zhHuZ4M5H76mtRnPbGAN1dPDGyqZ	1
5096	2vahknxdFwntqgvQ7L2jitdpqZ4S6Jk9iQ3i8PifFeojKahk4msH	1
5106	2vawk8obzyuesaT9vZrANWFzLUUJue7K886uK5WFQB28HmQbmXSx	1
5109	2vavgZPC67sktycn4y2VmhjBAefrked9pDGc7231LJhzBZjXvsCb	1
5111	2vbWemLgx8vDmMevznMb3wVf4fw7YtRgHnWGkXz3Yp7RbFnGrPqs	1
5114	2vav5z64xwMjgpdS8XKbE9SeuSt5rA7ChvzTTZbq2sJen78WSfes	1
5119	2vbdS5YDkidC4xYvrLpdfAEKze3wj4noFP7Y9iYytyuASSkfHPhM	1
5123	2vbawG5h3pcDFTX3BSaUERGWRGeHy5oDYDVMdtRFuAAfGkd3q9Q5	1
5126	2vbxnzd1jPMAzknZiHG3p2eh3DhRXVUPrB3udWmwEzTLqn1RiwTq	1
5131	2vbSESKu8s2fQ1YvXX3EHBrmdmpzcz2PhGaPSrxNLp1CHWNDbUCU	1
5133	2vaK6hnyC937QnAxBGQAacXjJSKbAc9Z2omgsqo16Yv1zUwxJKs1	1
5136	2vbuXq2pLeHa5QXeqtKf8qB7ZUchWTosD4rWaMPeCGuGWaj6usvD	1
5138	2vb7GZGAxrH3STKT44RiKdYsvZWiPbNQBFp51Sc2WtwWq4Tyj3RK	1
5148	2vaaSM7LbsH5SJPfSQYq3N4aND48WSVyYtf7xUBBEEuo9mEP2yRz	1
5151	2vaAhnjAv6epbNXhvZkidDxq2kbERKBF7v3h8UmaCjG9egLZVHb5	1
5153	2vbs7mJyKkMnfMDtPXcraYbi9oeZSRA4NyaGYaKyf28SL5cwQ2Jw	1
5155	2vawVntua6Txe3zjJnxkrTyGfWxQcSdM24CwCpJCm2qpGUad1nsz	1
5157	2vbdVfPqrZe4KjQG4otNu4MYwPk3cGSAddpuTrvX9LayQyzw8Lsr	1
5160	2vbDL1pd4t2nKZDGAmhwd2ym4YBNGuPdCNMbGVYMAQohYbZY5C9y	1
5163	2vbTzXEuyH6hakytdgixSyaURyeA62248hYZ2BRC3ADp9iGyv75G	1
5165	2vapt7JrGfLW2jZNrxx6apxQsrfXWuyzeJCMRxWtRmeLaxvGsCjU	1
5168	2vbvKHobVBZodXrpNUkbTex855js174MeRSrbeQQGCZ5ucx1vW4K	1
5176	2vaMG2G8HuTYHu9TRNVzgKem89qJ6vkFghpscFmagS9nBLKwi1kF	1
5184	2vbaVUxPZMUdyAt5avGYreCVum9XhoZkctzBhJCakk4sQgA7pFPf	1
5186	2vbFpwgzyY9evm6zw4WsaTW3pJmzihJYzRb5EPK6rK1xhmVi11CN	1
5191	2vbPjf3zgTnjTSsP3pHzpHA83fwhnwJN6w5aNYY6kv1S7HeSKh2D	1
5193	2vbYqYby3vrviVKCW3KPtDgxyDnf9cjLsciTMc8Mq8NabQmVYRrT	1
5196	2vaRCkqo66Cndx18276LSN5kqdYrRnXJmaqWea24sKnjfeNiHCx5	1
5199	2vannFjgzzQ7vZTzXzJuzTFzqFeLESmWSMzT5ML9GStK8k4gBqEY	1
5202	2vb49JsQsZrbCpvpDrjpPhU7rB1AuAMDopFoirs6Z5aw8R2y2AbZ	1
5213	2vbyuFxPNSvRLx5Ynry29sz9BWQo4P5XGHPxucboFWGF8uEXktRX	1
5216	2vb6bLuYiyofgYGK1D3bdNMZt4gmiMW8iymrTaAhr5LUNxjc6Rkr	1
5218	2vadnQpeZRv3YCB8ibyEUvusuqUJ2M1c1F39t77ZVLL1o2ELdGD3	1
5221	2vb5xAdzHVAEfkBfLyej3Y2wpMREGAX8zxZbLE5ZzzMmxnZjetso	1
5230	2vbU2bq5DkmcrFHMNfVtxVkwMiXRSvFwNiUikF44EnVdg5nwu3Sa	1
5232	2vaXQiMXnLhMFxZPGUjXNH8vc4Jk1Rz2HNtkVTetbGTGdzBxXeM3	1
5243	2vbLybEdjpSSmCPcLDRDt314LakfJvbNo28JEUKD3Guj23UEzjSR	1
5247	2vb7EraEPeSKaoCsnWbXYxY8g4mbn9YhcenfEhQL3msEvTxucZw9	1
5252	2vbKJxZ1trorRqurL38CseeqHqrmAHgHU1SD9uTyFp5azu3Q5yJ8	1
5255	2vb7vJ4wAnUCMgcNcQAcZ6cFggrPKpndrecEfDGKhznYhfSpAWnc	1
5259	2vaHCBnQgQ7LKAPgWq9p3KVSnJZqaAtstUVsw4gE5a4sb1SVh2mL	1
5260	2vbWeCZK8qc2gryUPrpkJnZW24wAr9BFi3VU8ogW3N7wos42kQ9x	1
5261	2vbycCbpGxWewu55WWZaM9nFqgmJQtrUdmjDos6VR39U3ayFAG9e	1
5265	2vbWpp28v4E9CRYtz2ACsjgCbKSpVDunotDw3xyyDzKk75rQfQu4	1
5268	2vbUMzmrRfL3ThswB7wpKU99UEscSdkha9yXU89nETb7hdMAnY94	1
5271	2vaTMqPzmqu4k2C2X4nvRwZof3JK3oTgtFamDNnYR2dAiUtXUeXP	1
5276	2vbF1nGi4nAACSVRs6QYV6d1K1g5z8CmNitqtmomadjcshZxaM1J	1
5278	2vaffowziWuMv5CgKkkN7MdtZUt5bcVY33p1DKNwphWZH6WPXth2	1
5289	2vaBoT8npfNQyDSbHwEtGaZPZA7rg2YVU6Q1vv95Mwju1qn7bbVA	1
5294	2vacozRVDqQbYDLA7YkGwMGVVdE2pDWcSTm6vN3edmSjQ4ep36zT	1
5299	2vaSjGQD5cJVBso3LwLeFY7o3LrkqAMFHoJHamH7Amg1vh9oiAZc	1
5302	2vbRQaTiXHmWD23Hh5oTeJnMCKuGGXFEPhB4UieV1uY5v41hfqMf	1
5305	2vbpQxKQVUnKMScukAEyBjJPx8LYrWQDgXxwPf5H9TVGmrDvjFYk	1
5308	2vaVdHfwLsRt2xYAiyyJzeJBW5XGTr3xG9sXs8ATdZq7pfbK5kbN	1
5310	2vb6ewmCcC2V93qhq8Mtc3igJnWvDzJjV5HRxa1dgoaGMJuP4pFf	1
5317	2va9o3Qxv4WSJddnJa7Ev7eLoLgPMxuyzuC9DgdEUyTZtNzQsQgF	1
5325	2vbTFvUV3ZX7kWjqRFmCqkbGr3hhoferUN72jqpDoPpi9objkbuN	1
5328	2vb3H1pNt65QZmbsQgCF1XMPcdWr88UYL3MkdZ6Xpxgnf2my51QV	1
5331	2vaAnSLVqKWCWxdSiofRchsfspruvqMAdtQKWLfRL4oMo2UMVXXD	1
5335	2vauY14tFjghsrUrkSWY432RH9QZ6cPNH8SMCmdoGzqeFGizggNH	1
5338	2vbDaHkZqXVdid3GSDWyzFrE2NHJ3Bso45p9zxxfpmHeQEGUX42K	1
5340	2vb5K37EBJEWg2KfS3pKHXV6Lbp8UcYy89TuRXLfnEBH6Epon8XH	1
5345	2vaNDyyaRbZmCTEVNf9VcqQupC2j27QWbK1XNzCpqFqmBzY7yFXu	1
5350	2vbo3exFt1RKRpB95Fw4sUjvzpcGENbbRD18oGdc7yVqJNPJ8aPf	1
5354	2vaYyeYK5C669ogjwaEeY4xSonJ2UYiZvxC3Nwf5WcuhhSU9Easc	1
5361	2vbgriEY9EegH1m4aWoue1xjPCxS5kPUqLRcqFi3T4YYpcvCDszt	1
5368	2vaYiXEUBihgiJmQVAgsTV2aMvWUroebGL7GSPtPumSCYZzyL3pU	1
5370	2vbs3CjywPxusum1pSfoqfetP36WN5TUzrpeWw4ncgBSqA5jAvjN	1
5375	2vazXT7Go6JGmgM1uhN2JuMWiyCVjm4sUpJC5u5WRtK3syUd6wN5	1
5377	2vaKWKu3ayBSRfP3LpLjJ2Ah6gbYbFGkMuCWdEvXFaU2P9PgA1eM	1
5378	2vbBK7KuyLzGov9yLUqR56M2TNrgFbsVd4YHqgqfXTsHxC8CK2SY	1
5383	2vabVX5GV1eGbYjFm7QQ7zDdXk7UaeDkGiaYQ7pZgU3tRKjs2pVn	1
5386	2vbFF4MH3ewk87VQyC1qCCvUFagrNRAgA9BBGCUXjBX9nw4djCZp	1
5388	2vb1orzJW7QrbzeLoUaGs8d66KpextKbNHC64PtSANZwgoZF9sLf	1
5391	2vbtDqsavw6v6ASCwLYhk9ij6mTsCQb89bgNf3DezfuFmsNhP12F	1
5395	2vaeUrxdS7i4BBqLobpqZj6aUMZEjDLFsnD2QzJwEJPWZW8pcXf4	1
5402	2vaX2uPVBtjvq4Ss1ewauB4M29icGm3QUeYV768b1xeBn7Lrhjry	1
5407	2vaVmRiXmYg52sLmA4A7fxMwgn4UDmzc6kEp5anGWkoAdfHMxcQV	1
5410	2vbReAiLiom2kXT4QeGyKASmKtqY9UUeNGv4LWy2WYs6SJSmfQXP	1
5416	2vbQG1RJWsTSQVebiBjzXffwBnpZpCgXnBKaJ1LFtUhobtPeHSnU	1
5430	2vbfJSa4dL1m1Mu3A1mAZFM3XDm6rYyf6X3c1683QMwv2bJpspE3	1
5433	2vbcLvvPfkMrPqXvkePbkR3YuBQCebg6SYHr6T5QizQSU7X5KNxV	1
5435	2vc2ZFozXBNNejQmw8NfCxnCX6rKZCBkYpeUq9KwBnpKai4vxPJc	1
5438	2vaqtR51mMxeo8JshGGinr3Q7Ch35cFzSJMXSt7833zp6CDbE1kd	1
5441	2vbXwvUKQAXugRDnqdLNNdscYN66YCgc6zpoJEUkAT5y8CiLdEK3	1
5445	2van8vtEFCwUjRBDVeqF1ggCAVzKLgTEQiPopf5zRonnFEztwRur	1
5448	2vbKQKat98Dgc86JstWN78uB48L7cwQ5d5B82eFodXr3iuzqDbPK	1
5453	2vc3xHF3gfC3DwWYpbDJ3NGRL96dbmAoTSRdT9i9SeCKQ3SLiHPr	1
5457	2vbrAG2ReQSSUu3c48oeVTBbazBx6h1mjgg1gLCKCzBVQ3hf7ne7	1
5097	2vbbSRuqRUTwyqr2V6QkQzAmemMkFeke7CoGPNZQVkVSzZ1dJbLF	1
5101	2varHPab1rEiBeNmy4URmsSaEkZ3KocSjeVJHANP4WeGUZU6uXF5	1
5104	2vbqUSuj7Y9ctZuM6eYuq6nn2MuESjPvLHC46vJwKXbFooS6xFiV	1
5107	2vbAzT6CZx23KCULi2KcKySdTXuBTW9hK5VXuhWfiHjBSUQx13RN	1
5112	2vaxiSFpbHd5rw2edEBKVEG16qXHfdSx5exz6rAZrYZmdzVSpB7A	1
5115	2vaSAsuyNxWMQtt1PiKy7XwLy5ki99dX9SGMVZF85iVPJpJzh3YV	1
5118	2vbDxAzsweYZ7mKNAW8t5nQ15gDoeuZkVg5Ga2Btw1sNo7px85iq	1
5120	2vau9KL8a4ArEfMXamYeLyJet7pvMfV4Un1ZtPAQFGMc5SNZtFLf	1
5124	2vaP5DWm2gPav3rTQ6gfccV9FFV1RpzePmS8hoBhCxB7vFZigWKT	1
5127	2vafezrRGxhLqQKV2Hdq2pfTQCenYzX4brcpkPMmzJoSJy5EAZsH	1
5129	2vaVCz8ZYbMU4EP3LxcFgccUYByBVHbmQtUKNpKcF1jmqNSzHrq3	1
5139	2vbzN4cRYQMGJzEyhA6M3Qz3s9M7J6QBz1877sTQmGg5YhmDhb4P	1
5141	2var8hK2cXCqMc3BVu6aBCGjV646MAprtYEZfmgUVJAtF22dnkfB	1
5143	2vbxcAgwMZbZ7tNrG2JjJCiHXRH68HsvLMuKBGkRweiWWFyPLZmJ	1
5146	2vaDDZLtqNJFcL1iS6KD2FB2Coz43SqgufhYJsUuZTw3Aszab7GF	1
5149	2vaBr6nWUkmswjhY11qHNVzrAmgXHcw2BeBvnkA8jBAGenFnevDq	1
5154	2vbMThZTjrixX8HJWyaLHcknLMChEwD2C5eC7jUAhGji7xUvTwsv	1
5161	2vbCNAy9JSNuArXZfyeL54pg53VNvzxmFxpLB52ugTrq4LJECSL4	1
5162	2vau3aXcCkLAhZ6o749QsPFUdss7zBxGzvVVkc5E89VU5JTGRaS5	1
5164	2vc2N5bpUPFLWBKk3oes5SvcJDiT7XJoUXHFqoGQPdSZo9874mMD	1
5166	2vbHFgohWPfMa8ppjhKULSY7r16FJzJyvzewaYHCzjrFXs4Tb8Rp	1
5170	2vaTxurwThTkzE6uviWcPKXr2f91dv1EioKC1KxoQpAW1zvRuwPZ	1
5175	2vbg5rnJPC1hKyb9r2urpu3u9yoE5sPxbXdGSvtMEPALgH5GS9Tn	1
5177	2vb3YRNXqC9W9PCfCkkUWFLKt1sBX6C6yX6tpTzdLLWFqCM2YWPG	1
5179	2vbDMsdrrX3U7hXpRkHpyuDq6gSsgVF4biTnHcSKN1LgrggQCGib	1
5182	2vbsG16wZsNPFwQcNi4TLHiCvbUFYniA2Gz4jw9id1yQf29uTYm9	1
5187	2vapaThVcgrLfHYYa5Grq8v2LgYuyDWs39a5zbuxbXcMaT1WRmpp	1
5189	2vbG2Mzd8K2kRdu4na1PmGShUvLJjRtg5FGEkgTh2r5jL6oDnXz5	1
5192	2vaUzfihETwvU7hD9MiZErWyr8PVCe43SaQPbQBqrcsvqryn9MeE	1
5194	2vbao3B2dWWTRpuo3U76suPLKpvv26Js8nzA6vU8by5jg3rYpcsh	1
5197	2vbAXcoEjyqLwQrnMQHw1PycxgCGThELpSN7xVaGhNH5Dwt21rgT	1
5205	2vbpCvPMVrXJgZ9VpVZxqGBxVqhWoGEj2pFbGbaSrKTnzEGT4i5Z	1
5206	2vbZ2tzLJS4HYdpKmzcNNypr6XYA7Srn3xxTRn79VddrrRMCp3QX	1
5208	2vbGZRS4TdGCQvAZeWaGgJwkxhdimHmf1ns2WdeXDS3cctS8Q1eF	1
5211	2vbSL6woSXKPCvvAV5V7HDbfgxuFjXjsFNing5pZPqG6vNCJj666	1
5214	2vb4qziMDWH18paZnSh7re6SygwLdssV8QS6hacamwd2UxELJafG	1
5219	2vaBSTHDvPVB6veZsjcz84e3CVNBjZgDTWtE4aF1hkjYwwT3KXAd	1
5222	2vbwx7cgunbWXYeK77RK5QkH2nsPTCqswU1KFNKGTcMBw7fvL92D	1
5228	2vbLYgwXbjGJZfULB5aC2dyH1nnKnmCmLxPFnUqh2UNbnk4pV5in	1
5235	2vb7YCZt9RLbDv8tScgzqZPfbcmS6Kx4CKpz1JJ2ha2Jqi1S9Mmd	1
5237	2vbprQ51JiBH13Nf2czZTEaRo698ANUcUiCmPWsgq2BecUuoM82i	1
5240	2vbaoDR83msB5xp9DtjUgEGy3JtJn2XdKsGNAC61xEEVMR3G5Cjr	1
5244	2vacTgm5J1bR2EozkUex2QPyaj2sea5aDHxFd7uGfS34yoQbVfaK	1
5248	2vb1SGYY5dY8hwyvdssqgXTvj8eEGdCM7nKeK5oFquDTjuQfHArf	1
5251	2vaRUSbjV3iaw7gSHmqehTcR8bwFXmbQFGpaEYbUiXFef7L93d9A	1
5258	2vadhpsEqy1RGQiUMCTZYFMrxVgo3izfCKcnMCMQC1vtFtHiJjGe	1
5263	2vbHrwC9sdPF1E2oAvP5XessPUfQBSwwGKuU1CNNFm42gdvuBksE	1
5266	2vadLBL4NNJVuUZRrr5hKbh3iwygnbL88KdV15S2giuDcFQ8zvhT	1
5272	2vbghXvXQhYu97A9bkChzyMdGeWfPPPxhY3XkettUfow5NWahVBC	1
5273	2vc3KU8WxLgG11GnawXRuoXykcdCcRH3f3MBjjNTcKUG2L4CLdFf	1
5277	2vbNTURPuk3HB8pEDX4Qo4jdDSLW1DK9hXnVvrcGExYvxu7mLp8x	1
5281	2vaJDMWfdtmBTUNDf6W6VfH9VCuXaDhWrEB2st4B7U8Rv4drZSKj	1
5283	2vaSTDYANVbNPs4ij5YSqrJe2hhtExLCvVXai8hTER95AnGjKPDn	1
5287	2vbvRezA7KUaV6hu892Xj84HHSXMCcz8NC8u3uSpmBAa3fir5ZDa	1
5292	2vbx4Lw7y69yaV35moKfHaDMzhAVLtJQguvTW81kwRzWrcXRa6vq	1
5297	2vbuf4GRFnaHT64ygWAGfK6iCVJfGBzbnUaQXh5ZWbmD8PAyhtcv	1
5303	2vaXTTDqiknCXY1dKzd7Nwwonh3o9obdjW3v1Sre8v4Ft5VoYbUk	1
5306	2vaQ7onzkHQxPVc7pb7UxvRc5REGPr65EPLZWkspNahrv1DSLYot	1
5311	2vbhm2rN9D22zShPeqhJmFTojgsyUoGSfHM5nw3pKXvSUHgkG1Wr	1
5313	2vbHm3YySbAfXyd7Xge27F8qpPc3EcqZCVEL7nuWcycUrgMEm97H	1
5315	2vapXvy1DqPU4UsymgUCXeBPyxfBxxnVeeJp8zZHGexRxWSA9hzn	1
5318	2vajv9GKujEGq549y7HQJAAgu48nWbCrffp83AK64xDbfxpTmg54	1
5320	2vaznJid1eqCVs2JNTwJKe4UPBuXqvjQBbYc713XgtpaSonKTBDF	1
5322	2vbcVFtxoWetZhMae93Vpzd3t3eiEfezKcYkbZjNKq9CQ1miV2rN	1
5329	2vaAZ4wroiYCe17V6ECS9D9Cch2x7CxLPXkUfYoK6sgWtRwe8vez	1
5333	2vbfkvtUvNTz71nH5z1sH5KesfQdWmgZvvFszdhHoBxGWrW3H9AD	1
5336	2vbTFEMmuCKM7eGiQVuuSJAL2CWjpr8v59wMmYscPKthFD2yjX1Q	1
5343	2vagytQdSs514DYRbFf1cJHLHabhqD1H3Np2PUeAcPaSCYmAaryT	1
5346	2vc2SAeXxnri1ud1jA37BY2DqoAAhHSxTPACngHyU3c4FCKSF39m	1
5348	2varUmeH4kJ9ZCnRic6bH2QcUjUHj55YDanbDiXeR6u3Cu1W9npP	1
5352	2vavoMvnN9Tjx2eYZ4VUvQxkrzkUr3LEhWrAvNeCpPRWXUbp5yjV	1
5355	2vaf1x2g9MG1fX3XKV8k1SS5qijb3LQ9vhGmjEVmpG3BzvMWAomD	1
5357	2vbiTxa3R1sfzwTmnndgUmUKJnxyBwanfUm64C5tcoxJzYXUDVDf	1
5359	2vaSDo4stnXJDjWfS5nn7Ri9gKm1GqfvmFpaTcP2Lk4a8jjYsiEr	1
5362	2vaXjCbvA9eUEns88pct6ZXZn8zQBTduX4D3owvdMEKb5YWqUjzb	1
5364	2vbJZHUvSjaTwPYxQwqRpADG939RgrzSBjnnrVsMLwYpWSCXA22A	1
5369	2vbwTBhcv3VgwLTzNoZM2MAqStN4Q6cV8hBvKbJbXfLY1Ea8r74b	1
5371	2vbEjTXr5NiGrf5s9byM19hqyFbVKyNJugeM6ybcqzXUihcC6LXd	1
5373	2vaUg6WHbfpYYycGwj3sfWCykMXqstPuKTz8XxKMFrbu8Gd4e7kB	1
5379	2vaPssqGsWoGYRtz1Vrpak9coXpUA3ZETQm8pB68qvs68smitHKj	1
5381	2vbmDCN7ZbZ5k71g2HBWCjpB7EtgMRA4jZ617hqiUSp7doyF5XN4	1
5384	2vbMW4Yk5iNd46ANpJeKGALvgATuV4Pb6KMwKsAr72JQBdzUWWJn	1
5387	2vbMgnNQHAVahVrxGTGdbQQkSgkZm5DtDDxsWEyQpocxYfqKMpxP	1
5393	2vc3LK8aBxQfKMhJ7JT2QHJuKNDAqqTk3hWkoKyaHV9FfMHHLf4K	1
5398	2vapmFeS7ZuFS7PeWNpwuf6jxTs9Do74BXss5tpneBTRitnKN8Fa	1
5401	2vafyfe2QsKuptMAofM7rSK5iTwJSuaAAKFDohezyRWfxDiFRJ9N	1
5403	2vaSb9jEhAvyojYJ3eq1PMonhqRR9ppcKvf1XPhQVsVi7xuZ1oH2	1
5405	2vb2CtQuSABZUDAcxkoU3NGfiLkEsnLCnjnGFqLEhMxow6zwjMMZ	1
5098	2vc4xD3FVbLSuDwbfdGxPhD2PJF6ZCF1LdTonSbbUJ3YsXMBbazR	1
5100	2vaM5S7BPdLQESW8UpcRKro1xv6E5xiHBTzd1p31A6YYC3YP84wb	1
5103	2vapsmKZeaLLiRCB5Nr7JuxW4wGHwgGHcqNFq1999rBfMMjY13Gs	1
5105	2vangUFq2g7mVQb5W3P2hRoJBkfeKAqTQR8NjjhBfmLk1UjPVtWN	1
5108	2vatBhLmjwZeqZ2ZibVbhhM3hgnWVtXt6Nz8Srx7et6y7xaC6VJ7	1
5110	2vaiwmEkn8goVUVcuP3SE1SebJryNxY8pogxZCpDXdwpANkBZG7H	1
5117	2vaf6Hse7ZJDYvSkbU4FTBrTtQ7GuMF5aumFiN4HxxW52F8Fo4XU	1
5125	2vaYYbA8Mo2XFTrqaBt9HU5MHJju1ArLsXnC2SBzSsx61Bit7JAt	1
5128	2vbt5DmcJPWPGh3WrhkVXVbz62s7rBri82K1CwQ3DPmgAX61aaEh	1
5130	2vbcbycaT93VXZdwXJ7VFcVu9H8Et4FVb2c39p6pUBw7q742Lwz6	1
5135	2vc3fMkSMJDpHvNUxLxxQjNBPyHpEgtsUvJidX55S1NH59hgwoQb	1
5140	2vbZybs6hQfroFEEXYcaCyyLHyZDufCM7CrEyyWEqS5epZ4xDkFK	1
5142	2vc2mjfaVFUUg3FZUhnfTKoqA7QzXWQ3nzhB3seqVcH9vkLL7etS	1
5145	2vaRdgDQqWm3EqSEG3q8RMzWAMiwhiS7vBme36HL2dBeUkUgF355	1
5150	2vbttF95WazbMEozeh9Ln8giE9fRnmnsPmpc86SaPf2At9p57fJz	1
5152	2vbypvmzVTmLgjKUmgVi6LsqkJpZQAAuuo1DuzFHMQHzEphytdzN	1
5159	2vbCinkdrEirfeHe6hz9ngjxrLe28APVMRE4Hf6PqbjLGg1kbef9	1
5172	2vaEjhatfkKjM2xP2YCNkQQGvz4BE5zmYPUH1iLZXcpeGGkG4aE2	1
5174	2vaLkGdK778Jo99E9exo6sWDjSe25N19J85P9kWFrgTGAggt1heT	1
5181	2vbhyLSFHer2zAvhusdq4n2h6TLb8T9goYy6xPgZnbyNsseYDVwQ	1
5183	2vaTRvmdNofoKgjQwFpMvpKWarGEfrQcPFaq9V2LVZ8yU1FcYRz3	1
5198	2vbYJbXiM5SVpqsbj7ZfkYMure31jkaw4ZhhMrWFfN76o6gRuEYi	1
5201	2vaPGgUruVzahbMJBLSCiQGQKkY82N3p8DfhwbiuaXELspbBVjLW	1
5204	2vaEsxRX74sFKqLSLtvwPUCiy5KMN7Gsk7w7mnf4ZLtvcaUKSyWm	1
5207	2vbPDj13zR7Ac1gEQpY3hLnfGZvtJvzuLYkuXQpEqMKqVuHeyCkd	1
5210	2vbubnuTCYUBCBkbuz1hgMtcejigFjq3pkq8oH1anCVtGSLWrhau	1
5215	2vaRaL8sS85pMrrLE7PuvsRJZsMhyUaRBEh7prc2btjvCA4V9x15	1
5220	2vbhgDaNF4fDkG5dekKUkgQFWmi6B1LioDXiRfPqnK6pwLw9gjbM	1
5225	2vbaYbpEscFAXs7u5gDFUox9iLE391eJb2MvZdF4EvhGDhX38Xxs	1
5227	2vbki8xKLeGSmST5KuBL88f8ePqnVVXs79XiPqGuBmk5Ya5ry4w2	1
5234	2vaGdtmqVxiA18jbTDsGN2cspcfYPaR6objDiGJivkEtrxrhugDq	1
5236	2vbtChNPJd3pdtcHzVfHDYRMr4EM7MtoXGcBTxr7MND6b8bvozJc	1
5239	2vaymdQRVHzqzGUSPMGzjie3fscbtPNuRJEQBTF8kudLmzC5Y2wn	1
5242	2vaeT9miFkf1o6VkhCQHS8nNWdsmpfjL2LvY4nfT7mGw4MYsPX3V	1
5246	2vbP8Y9Zk3FPHqEZTCdnYJpZ5XssqTcJYvzwAkFmTq977dqFcAPu	1
5250	2vc355gdhiHuKvyr4BRbjPtcxkPbjUHbZCYHhVqaCRsV9bK8v8qp	1
5254	2vbZesjFebXPZeYiwDVrspcrdnTMK1VFJiZW2tnC5CVFBntKKSzM	1
5257	2vaEAM4fbRKm913YRtDu2dZYt6Cg5yTBckBew48vMjA1Jp23uXJ9	1
5264	2vaz21tSQ1in3wZBqWH9xKnADkg1WJmW3uejuXdACCaJyUGrs2ZX	1
5270	2vbuyrmhMXqVG8RbM9veWvYXUF6mxpwUT8KDn2FuXyRSA5Fanxhs	1
5275	2vaPH3g5adv6sdf9EHBgbG7JtSJmW68ojG9VGZLqN5Zab6K97Aoc	1
5280	2vajrneqgXEFMD98p3oXBYBMkE6hBZae8Twr8h1WxUKBEgwRJuEV	1
5282	2vbRiRxujCfLhuiRGyUznxZB3FeRog2joBbmdQUaNgHdJakRBmUM	1
5286	2vabdUHqUXjYiuER6jjm8EXRKbPXuTs15kKXTTLUzcUztzngdch2	1
5288	2vbDPzRP7Np8NCWUpbnU8kSjrVRDVkrfviY1mx8jJMgtSNKvj5nW	1
5291	2vauUF2F5zUaz3Jj9CRjyo4MpR3WiR7UNU6cJLTVRWWbAkFetMP9	1
5293	2vbiEmTuYWxs85swx11RkYhX6eHwTKwoBJ82oeACg41vUzKm38u7	1
5296	2vaF63gL5YU4ZGUS4JRTbpzQY8ornLrNRnk16BAYb2hoYgYMvKSE	1
5301	2vahJGxZXN7pghvKpcbKf69KGiRJ3PN6A8eEyXWDN3HQk86L3nvP	1
5304	2vaJizLjTaJFaKfxFftwNAag4fFv2ueFLfoPqWEXqAALV3dCjsjH	1
5307	2vaysbNU4T7g68Dyi4MNiAKN2RSMZKRfxVLjSdnxzB3UetL3CQRt	1
5312	2vbRqtigHtd3BUX4UrghWmn6nyfwQp4ctqRSXiUz5AU74hsg5n8y	1
5321	2vbRXKo669FNCor44mw5d73JAReFVz2c3d34LPTGvYH3BUrLCPTk	1
5324	2vaUGy7zStTqkn1ZEafWULUJ66zXGRtYsjuSwoSYmFzCAGYTduBc	1
5330	2vaCnCcob6TUFHYajn8fGrDDJgErxcN37ANG1CpSpMSTc6g4g1st	1
5332	2vb4RLtrd2Ca8uBaUyYz3h5SMzBczgmCXRCLLFJHS7Hx6gFUHhwj	1
5337	2vbkkxtsoSjxXQ5pxa4rp4we1duS8UwguKd7HoJsBh4eB21HNu31	1
5339	2vbFm43C9iuyHdzrS3LBeeYuKTd84dxhC4XQpcYeir3Z3zrKw914	1
5342	2vc2HXkDn5v8jjeTNWX8TyFXgTiiLFjwDLwP8tzA8s38oUk4SLQw	1
5349	2vavutx8Px49RbZPAhCqQ2zNncg6QvGYEe28aJU49qBRTf5cwJjW	1
5351	2vbZNEsZfmqwB4ABjNpvGUjQrnW8eZDgGo8z8tVnfRK293zqZK6L	1
5356	2vbEAJjRQgTNCiYgYvfPJfUR35vxUSwvvhM1Uw9x4GDCF9Qp4dg7	1
5358	2vaL25PfWSF9BcBxXmjF3gF1KVb8BFBu9PoLEZj7riAu3vXed7d9	1
5363	2vbh8J2XZHvRMmSv8RBJN6LSYafqsNibif5eU7YXismi7yvfTrzJ	1
5366	2vb4Dcxz21PNMXPM3iRiah8ZcNtkiYDDroGKF62vwKgbArhXcyJv	1
5367	2vbbehLFhig33QcXq6LchCdn5RYRGF9iJwP9NGVEE2XiZAn1Sn54	1
5372	2vbGGooEwvQWifDDT3zjVRk2eTGTjgZt1yNjsah5jhxCZ5W3dM34	1
5385	2vbXPqsS4qHrU8cYjj2JtN7w7wnXvHTM9ehjFJuLwhquaZumfm69	1
5390	2vaJLSmv2zPLyPezedLia2QoAt364tD8RSCf6fqeHesMS8MdVdLN	1
5392	2vacWskqGPGPfMVR91BwLRPmjsivEawFaB53NJveeDELCb9o3aTd	1
5397	2vbPSg5qznLWhDAHs92y7jdDSCE1DsnWJDyXu7NcMEYTp8MXV7w8	1
5400	2va9GSL1Sqjyo5iywAViKUkgz7uDWMwaC2vkkRHLX8Tp4h6dTyLu	1
5404	2vbPESUEnkbMFoWSvXKYMDkYkHqrQhhgZXNLLdCyLAh2JhVtcBvf	1
5406	2vbdkUV7D3YDbFsCqTeXw5k25uBeKJ4QHf8tidxqumiXmNh6PXUm	1
5412	2vbRxUcPkF3kjm8FsZT3QL19CuYjmp6vq5NKd4SJ7UvBjdHVcKTF	1
5415	2vbXqjmfGA3xWWVXwYZxbnV4TMpcnn7HQUjHYsoScSg8EuCWuUBL	1
5418	2vavZwEkjF45wSc4heKZ3kJoduSwj6UGE3usqE3xT1RyjaaaHBKj	1
5420	2vakqZa3wFiJsUBRnodVh7xGJNtr1TUQiy1WbQf6HX8bozkbnmx9	1
5424	2vaZfrJHGpngCA4xS4EPL4pHTF6FNXK2i2g2fxRwuC8n7d9xJv3Y	1
5426	2vasYxMUxbua2dYKB39xKZ5VVecYku2eg1SLyMY9RqxLF4veWuHR	1
5429	2vbJTiCypFjD1EUogdHGWiEtCbdAVDiXoKbxSUYFeam4Khx2TC9q	1
5432	2vbSG5CLdYgPfcqPR4ke1bMA2d4bNR6ne5E4WjoAhgHFZdv1m5RP	1
5434	2vaUmXRh6hRGZfqELHG9ZBpCC1q8x6NehnAe1KHPkptkDkhsrdhS	1
5440	2vaLDotXtMBcaovp9m1aYt8NXnSs1XDQAQE4n6CKMi5gV2DSUVqT	1
5443	2vaBbmcMddtKms1ikGE9pgx556aqghP9yao5RFBAwz7jNtqk1Nt8	1
5449	2vbDrh2R5MWEy7fXoSVyxkZdKhwJJEQFFMJUy4zYWdKRKUEuDxZB	1
5451	2vbcaUNV19chvKJQB2TkKKbRZzGV8vo3Gfq6q4MbM5nh1eVp4qM1	1
5454	2vaafSk64cQxqzWRe8Nv6p8a7xmNasUgoRADhJvfEjsmGiZwam9e	1
5414	2vbdjm6VFGAgZ6N2H79ASSzTpaTiSwYWGt9c6RW6DiTNdB6bT2gG	1
5417	2vaM2j2mV6kGqdReBhATL3c2xQpiapTjuqQWvfy5fnuRBS2UPmt8	1
5421	2vbpA3anyuSQz1G5ybpSz9pnzUwe6mB5NB6gqRfX14gS1Qpzpvo6	1
5423	2vaRrGwewDAN91y3Sc7hRD1zNq54A7gKPigCsq9BtfaXvhsQwTMt	1
5428	2vajrz2NzT82xZXsKnnzP1uVkcpPxykRUyUEGPbTxPGXH2Z5pRp1	1
5431	2vbXrkJo3cqaQtpopsLgMU4ayHk3QQafEk9GRZLvbz5m6PBsYa6M	1
5436	2vaeKffNeCsji9VVbBmjZkSnoG7YVusyyrVHp5N3iKP5KfVz8u7z	1
5439	2vacrzsdjsyNHQ1K8txQcS6Ze6cYFNu4vhLrzzxvrQiw3TUY98Go	1
5442	2vbuHmkPmvAmibmqFRuqEUjjcdLqYNpEMzDobCKMigwDTULE2ZLv	1
5446	2vbSCh7o5ZojkzhT7wryDJY67TCMLe9McVGRJtbpwLNvsqv33gyN	1
5458	2vb8uoSgBXpeMUc2VosMsBhXcHXvTfUKDA1j2BnUX6xaWvQFXW7o	1
5461	2vbSqcjKBc4ywqSnCH8X47o6g7ADGKXY2TAFabMKxUtMWoMZaicK	1
5466	2vb6M8hJAE4H9ZnfoiQQbqPfDm2q1MH9WuoPLDHop999Ri4tKiyG	1
5468	2vb7YqgvEUfp6EnzCgyQeGrX8m3buK11Q9ph2iGavnrN5ip9QfQw	1
5474	2vbjpCbzASQVBikKSfxzQaKuBm69c6J53pDZShFoqMYsHdjsewse	1
5479	2vbdS7FUixSUqDvDNxnMunzPC8gwuuACMuzW3pCTojsbfgKmu9aL	1
5480	2vaSB1Bb65wC1QmbetRwnYFb4cJbDXbS5hydviwF9Z7Qy42Dt8FK	1
5483	2vadh3PtDdFsVqYaJPQgVf93v1EVn9p8us7t4y28WjuV2iigL2yX	1
5485	2vbo6E13JNBmYNu2TbXEUWZ8xqJT2iM4MWw4vSGjCb9r52RhBfdL	1
5487	2vbrkCLqFNANLUxvgsmFgjYU55E1bPtUTibrLLU5gvGQmMJFKJYK	1
5490	2vaHeEnmnZsEWUtWyHD8TLnRgXRUSDDpobYrkJzdQ6J4MkoGFsdF	1
5493	2vam2NDu9oxdhVrmo3s9ZDqKZ8DSiS9jGNWvQWVfVNTyzJsn5BQV	1
5494	2vb6VPNdBmUrCUM2vYKee4AJRboLGTxSHS5dQwetejQ5YNCDV2hh	1
5499	2vaCTQSWCqhXt8jNBf9AfHuPS2jW7erzWzYN15AxF31zD82eNo1U	1
5502	2vaXXkSYst6Vf5VY3yMecNHKNR6EjMK3FeJg2h65Bp9mq1Epr61u	1
5504	2vbYPb4CSW2isaa7aWJprkn43f63aFBFXeDGE2v7oMadCCeq3uWT	1
5508	2vbNHkrcG6Zzp2v9eqjitLLpFEwGyhY2H1yJYaA7mVmKfGGYSqf7	1
5512	2vb5H4J2mE3UuJ4uMbK75pq4XmVcz174zw2vU3BtzXttALyoTU29	1
5514	2vbw6JAL6DU1aBr1fpGd6b2A7B9AnLEkZmUeKVwRsNfCb6f39kZN	1
5529	2vbikopnBEuujk2dbgjzb5vdxzVHiUssBa3KpFA9EXHe3oXQ55gf	1
5533	2vbuU6UgX4MdzPDyfk6HQdQgTxdJHNZdspJci3ZbMwVXPLsQcJye	1
5534	2vbLFdS64QAPuFPqiCEq6xsQH8iTCTbtx4GNVzaycjPNn4JphWQ1	1
5538	2vbgNiaX3bLxDiJtYYBEyDL1BKGmptjQF6qH91ADNT2BUqtzfxvf	1
5541	2vbFLcwhSSbmCLpHnADZGPxrUDBz8t9qLa9JpMAitPVCW3erXEn7	1
5544	2vaSVEiN2cpbZJeextrMdUBd9EAG8hXVbFtqTPme6zQXLVqhixLG	1
5556	2vaFTaEauovb5a5N33Lz5miqxtbpcf691dufnWLHh3e7A1BCKJ22	1
5559	2vbRsh1NYBZnPag4vXNp5YFvUNEM2p3GFcqzdzDjLpdqbXVS3dE8	1
5561	2vc21z71aaKQQWzrvAgxWyfz9nGnnbXm7e92NrcmmF3FwETtztxW	1
5564	2vbEtazZSTZBKMF3CXFCK4S6Qw2kX4eScx3qEZjH7akhdhkYJ1h6	1
5571	2vaD7BMkVE4ster9HaTpGm1QzU1gxMv4SkMsXjow82qwdQJA9NoE	1
5456	2vbBNfZTi6avkDAXZoZsist46VmbYAutVJC8oYsLN39JdNiS4dEt	1
5464	2vbbvRSUfr12uUWcLyzSCv8pNyzZc9TLpsiAf2ouUFH51TJfE9zU	1
5470	2vaXkLJSyNHCEPvFpkv3dTy2uyCxVkZFjd59tSb1i2FSJqRi1SuH	1
5472	2vaKYKkZKr7CSVkxXfaRNQWw3H32qwx8aA89E4VYz3S5p7MxRH8C	1
5477	2vbPYvMFnFYjWpzcpAGRD7FbBDWC4GsRs4Wa3y4giDhtKpK7oJhj	1
5481	2vamjb9DgBQmgViC4KRzdugzJYkRCEGGDPxFsYs5EPAXFfRcBqYT	1
5497	2vaak1V1XPdj2uqZLk6tM5D9ryyqvr31qFHywotEBNyzfhhkRM2A	1
5500	2vaK4w1e3HbarUusXqzU4pDEh98Rfvs9kvtuZgVbyEbsuE5eQYQU	1
5505	2vbHMB5u3Hj4ha8MaRe7X1gbbtFTrxMRnDdxwCjdAH4uMVE2eeSe	1
5509	2vasj18XNbDD9bLpB5qDa34FtvDYtkWQc4c5G5RsPzdyCmC1xb1b	1
5515	2vbHC2f3Dp6NLWturSfCeVELuBGk3PdVPxSXzZ2aMFjGRGGvNgtU	1
5517	2vasKqK55ukkf7G6Gsucj3zAkQV8NRxaS9nhY6kJpz242wYG1zDa	1
5522	2vbeUnvbWzdhcXBwhhwrbohbN2fCbq79C4uhNAjmdWQwjuGFpzNo	1
5527	2vc4Tw88mFTUCEvSPXXHHiepv3AQz85h7KpiT8rJivpWhKo9UeYZ	1
5530	2vbK186BCKewEn4HKdRBNzA4NAcFJdRGtHANY9c9wLDb8p1djXGg	1
5535	2vbpLovoKk9xq9bo3qNDnatHk5TcT4exWFMn4qHRiv6rd6MrB9oZ	1
5539	2vbLpENBhERk1c7ix9jSjaQk8whRfECNqx7BHfapoNxrA8w8DhNw	1
5542	2vbJSKi5rKAVF6kzYMcyRKDPNGLjNWbuNqPdAnAn4XpjTHYqSJGf	1
5547	2vab3R7iegxmch8N1mZYoUni8ycSzuTyoEt4skUnn3ivLtNHtodp	1
5551	2vaEEd3D1SzJxCe1vYYnrMn6KfGJQRJQiqTU8ujLonkideTjmYwy	1
5569	2varS335zDtdYQHQ4Le8rdNFnLas4XthKbuvbx8VUgan1rNKYPRF	1
5572	2vbVJq1nnsqKcUsQZSzDxgjydsiccrKFYx21RQ3RjuNefAkexhZD	1
5459	2vbzeXcK2PdyvBAE5kfK7bcWnuTPpsuAcvnqrKKcS1hQQYHUHXxb	1
5460	2vas6brnRwTv5gYJzoWNWyUGAwGaeksUHb6meqxDg3EKQNxTwAhD	1
5462	2vbbB5bYG3U3oVdRQP8XSGxQYvf3VMWKnUZBTv7Jy6mXEs4avdyA	1
5467	2vb6wqxB2QhDJkbmfEnmsJ9eS97iMPNZqzGaEXsSxHGSgRtJaYZb	1
5475	2vbbspkiuY9sUcn1r6yqaK3hvWdrsZ7gFeiKbf3YVnC5BvXqAKmT	1
5484	2vavT7QzfscjJKNRuWh45wW3iroi42374qHVwUFZKZ57fCrSqXkb	1
5486	2vaL6PV8XxKNnx2RZaNJ2Xf9hjBEeSXcDd9dQXcRcVqtJjZT6abs	1
5488	2vc1YPALFFAufYVX3UAHpKiJUS9nCpg88az2BVQjUWhkxdMkY6uT	1
5491	2vb3oEBtg9o9qUEcqi44U8JeTqBVGxZjJDJz6i4rWuSRCZv2gDB5	1
5495	2vaxjDi4kxneRPYDZd1yt3NdJSFgwTPTVWz466C5x9cirAHn6RsR	1
5506	2vakoig52NnCJYRbTER8pbce7QcL9Ui24jV7utJ6L8ZSYFzA2NNW	1
5510	2vb3zhsjv8NVAJzSNBeJ8WsGbs2GPP7F8amWofs5Zwis4hnND48x	1
5513	2vbwCrDLZuSzr7KeJigurSgKCULLwGAxKgqNjnE18b5Zusp6j3ZT	1
5518	2vaZei9uaWSeLgi2yjJ66L6vmEeeRPjJ3rcsQXFtGsHpA73PgTGq	1
5520	2vaAw1YUCYSbH8PrmYQN32bAvPGd8Jr5rqtECuch1cGiz5JwNCcH	1
5523	2vaozS9xX1iqJWVXZPmMKPeBbruyDTKzppTHnN9R5NK7vPdUdJAB	1
5525	2vaSB7nboei7pYkWVNDswPRRjc8XYEEDFq6zkN1H5cZH7HMYi4Ap	1
5528	2vbzjQFL4wHs5tH764vakMbSS4gSpo7wZBDgg2gQpfSkEbPmhLkc	1
5531	2vafstTVU4uykVgzGb5aCva7LT8iLCDAZP2Whf4FdQpEXXTziy3v	1
5536	2vb4koWp5bpcYJJmB5ghkkbDAXeZgFN5kffJx6VY6amwUvfJMxgQ	1
5540	2vbUkL4JRoFzhDJF3aNWmrfPJKsXy8m92LLn6Sy2JY5vVLj5h4Hp	1
5545	2vc5rDhPmMCDR2p9FmLTnb3w8jeRQDFSCrnaJmjquNSxtxGomJuY	1
5548	2vbHLep5jcc3hUcE9a53GCgPL1TeoY2eT7zUUkrzXTtQiMqTwQwX	1
5552	2vbcdsMgF7wt2RHKninkSkrYMwtyni5o9mXtbzdrw5ASB2VjHKU4	1
5554	2vbmtDU5ZsCCrWfNCGPiGHyoGvs9ZynWcgtM33fAWLqfFxDdQApt	1
5557	2vb59QFYmsmse1nugs9WbinF8XiXytJPJ9NBresgJVeuuy1J3pGf	1
5560	2vbUSJ1tBf6c7CLjY23SoA9KqxEGK3fi9JC7h8jbHPBgFMCF23gS	1
5562	2vbLJ5xCkPZTqhtukfnEYZcqeE5KbqGpvUgtxP1svkCHQjrMEwwF	1
5565	2vbEHUCDCNWC4AaonkiFWLVCCTPHhB5FUAbrwEVFyyiT2of8hhBK	1
5567	2vaGRuvNf4M64yr1hyHtnQZEUNoWVTUMX18PA4sPsdAnRCtZdTmk	1
5570	2varAzedKX9QbmfvvDNpuZhfNHjssTqMER7Z2B7Ef2JQrRvUzSNM	1
5573	2vbTog5NyoamoZFYsfJhgw3rG2xnizj5B4ErV5JBwf71vfC4EjhA	1
5463	2vbHpf9251zVBoubmVBUGpUrW31wVo9SVn7gg8mmL3txeryoAdAN	1
5465	2vbEEPzBALAnrD2sxkwLpUFEuqgep6UszKaxvudstVbJKWUeZfc7	1
5469	2vbfqhwPnDP23wKLiBFSsdRunn4BNn8DwVrY5JX8ECJisoexpNjX	1
5471	2vaaYEy5CFHrXjkCEdtcgMqK1aM9mgqYgQp9LiJUzxuYWdsXx95Q	1
5473	2vbLMYTPN2WdC9taydDKrH2oJeo81mNt1ard1VqxtxLfGiUHzuWD	1
5476	2vacJGGgWa67hEGyYgKG2hqp1mtXJtQfpYopiaHn5FQTeboHWy1J	1
5478	2vbAT1k1gn2YGXzULhrazaXDPfoaRCdA4wR21cGdV2crNCFYSxEo	1
5482	2vamNRDgmvZbFyV5xMDyUTWS378gCJ31W7WaN1F8hxMeZo2q1UeG	1
5489	2vajnoW6yrNDh7i5TEX4Ruv3Xyvu7Pjzc1ifixZd8Dq3GotENsC4	1
5492	2vaBnEAv82N16sis3p1dKvwfa2mW2u4SNSMYH5oGCc7P312NiYBU	1
5496	2vbNHGfieWiX3w9AiioFCGVaDjHC2bxLc2b8z2gE8TrBW2S33fVv	1
5498	2vbyDVsDZqww3cVWiaNKQ1EGdLj3uubDZDLUVKFwMyhreNgVEtrC	1
5501	2vamsEd8xFsruhCqst7ZiSwjytYXWqq6Nxpb7btpn2XM3oopSF6h	1
5503	2vb3FQuBA85UKrCau6ZagcnuC5HmoBhyUTS6UesMCvAq6GWbYmhv	1
5507	2vbvGwEUdiPFzQ6UXDWWJYZEKbpRVGMq2yVHS2R6qyJHdVN4ft79	1
5511	2vbvM1G4jQWScUwCrpqFR2JxpsPXpq4wffG8DLYCebtqdskGHjy9	1
5516	2vahnukchN874c5UwZ3d46XRvhkEnon9QzpxgrFeRnRpXDfs9sT8	1
5519	2vaCCfyf7kWAeTbZoZZ9CwYFfpr9BghyTxRmUZNM7oLXt7mwdkk6	1
5521	2vaQVTGWuvCFd4bFnmQgpQ4KeSEFmMCju7ADTCD14Rbas4PgeWz4	1
5524	2vaweLbXj4TN24yXNuE991Crmpr1Bx3g9c9T2vkYud4ByAdtG8Ug	1
5526	2vafnAasU97BwSwjuvXiGh9omQDrARWW4Wa134CirwVimNBTAEpg	1
5532	2vb1ZUW7Pkkf5UfYmhsqh8uDFW32F5nyihB8RJuPNYdm6F3zPwRX	1
5537	2vc4CEEeT9QyirkwMwpP8h75MesV5gm9cVMMjSDRttDkaBBQvkwd	1
5543	2vaELCf22wsoPFQvckfP5nsvGwoAjzd7SyGPvzRdXpz72cqUCTpd	1
5546	2vawJ3ash7gi9ErXsW1zaFXyds6VGeqeqqvd1gRKN6rtqKBzSgLw	1
5549	2vaNP3RC7MuxXoXLvoYjW3YJtLUyxmQ7Yguax3WQQ3dXDqHCYsxB	1
5550	2vak9KNMsPQjEwCRGQKuqzzNcwrWK9msWXyWvypSPqqTCqdT8yVR	1
5553	2vb7orLZwuM6D4fhT3gcL1Xpshq6dSaL9uGcTSmhxZqzEG9hTo9K	1
5555	2vbdNWacUFWYwQ6VyZz8HY3dPHGnwpdWyK4Rfj2r3UcP5PBd1YRr	1
5558	2vbC1SrcSGPnLgpRLVgNeqQQUPNxnjoiAiJBQazncCKQgDAKbuj2	1
5563	2va9LAwDZYpiTVwVgfoKXn74sBooQ82yjEEpwbfuGGuyNTy8DACr	1
5566	2vbypoGjgs5wEjY559GRjLkNEGVvRCUTo3hxVAuUg1JU2nnKPhuE	1
5568	2vbFrV7tBa7UoSTWmtM88miZWGfimJMWQXv2631JJSLPFbLSiT7v	1
5574	2vbgPdJKqf6oXRWVv8ooDoVPLVvXtcSpuXV3CxU4nP4nuTBuVQZV	1
5575	2vbFCZsyKbjsTbgx6GRectai1RW9LvAfvnK9EpSu8FCKPSPiK156	1
5576	2vby2RQW7dy5fir9cvzmjsqawQ4KFS6mH11yxDG6bNpvCEijxJpy	1
5577	2vbi25hMYCWrUTNZcWj4wipyurXGjGohDYWXt7upK6kPAYsYBwei	1
5578	2vaiHGGsruSecfCRBFHNm7siK9A1xpd2Bzgd3SguNP24FN5HuSmS	1
5579	2vadF1Ux97SteY9u4EUwzqcRdWoBqxAcsUHvL4bZtj7hdFkDgTN6	1
5580	2vaG1DzpEk3ZVRcNiZxuFfadXD7QSAUExT73D6M32TiyHd4k7gUx	1
5581	2vapHkHTSQqakyKZqDTANLRUhAcDBSGpATUAdwvNhyUFT2HDVRsW	1
5582	2vbEk9GYKL5KwUsPrJtqTqu4TRgUy2gYzZipcwoH6qAkcL3tN9zG	1
5583	2vbmcXaC81wR4hZgBvG2qErW17r6qGVXzFpX3ipDkwjNncvGYpNE	1
5584	2vaxHGY8A7wseeL7z8gvEqn9feNPyuZxznAUJEmTUKzrN6Uk3nmk	1
5585	2vaDu1CdaneNPmV7iqtPf3vCqxRASZABLS8ZYegUK78wuuHrAVT4	1
5586	2vbuL85Pb6yA8GWyxcwFcsogK12TXRcSrpUqEUrUDsmhPfMhxnN4	1
5587	2vaHDsYozSij8yD79A2oRtroxhf2GeDYL62RZ4vj9UfJ3fjB8bYJ	1
5588	2vbE2T3kHnscyr3cGBpyopY6ewyCwaXrnMEwhKHLungCwav6VeBV	1
5589	2vawMaJaEND1AP29L1bpPD3veWGoxQwzxtDq14SKGTXueVtkkwga	1
5590	2vbiDzi8voANEvJK3RxG7zzAcQcvqNsZGK4XR41CEyj3c7FtD2Ck	1
5591	2vbTrHwpf2P8fnRYU3rmdSS8exESroXLW1AGTBEprVtc1SzdmcAx	1
5592	2vaeDQNtHZyx6Mb3rdmfB4UYZTozNJHjCumqt9dzGgbjHS4HFL1V	1
5593	2vbhusqa2aqfuCcDXP58AVgUKroLcLdEmT68L6qvRUDnzr95dirw	1
5594	2vbzuobb5LqyGNVPSF6s31qmDK7uBawaKkbNDpWXUT3yvxNzmoP3	1
5595	2vbyMWquQMedSnQnTqkHqMPeckA5Gzf8hJGa1fRKqXKHMuLxpkyB	1
5596	2vbeXDkhWodPY4vjheeayBNiuC3eW2DUgJmps9bnfzAAffQNTy2t	1
5597	2vb9CYabXYoQFErZrgN1iz7KXK9FeyL5R6WagdMFN8k79GuNrEji	1
5598	2vaLSxcH4N79MtGV4HjF3RLNRNdaSFDmrKFrAN7zCPXRLU8g7KMo	1
5599	2vbTw6Ysu72sNu2TSfMqwkVnonyDfsNsBkK37rRZrsuQMFAK2KA7	1
5600	2vbDtLrFwwMdCeB3ckes4kn1BRzMuzWdPxv4YA4WYFiwKBwFSnDW	1
5601	2vadHsRvMAM2rU7ES89hXcjcmUzZTfYSU6ecSLrLEmVhtBrEdZVi	1
5602	2vaqYbqqsVko7TCufcmUPUJM9y18AdQRHGjrccsByqDj7djHCB92	1
5603	2vaSVgxjZYFakLHXmhVbBbzqj1TkCYQRYMPnN2edSEWYfQ5yxzv6	1
5604	2vaMbrgZSWt483CCLVWDPJ6NjCGRDhW3yhLXFxDPXdtfkYiWC163	1
5605	2vamC6p974AjCWRFmaSUjKZQinYdDQMPu12s3fX6RnB7agQtakpY	1
5606	2vaT8NoWSGoTL5QeYhfsFXgKRUMfJuYwDVr29EvEJGR127BsbLks	1
5607	2vaupr4V46v5h1bWnjdJu8Ty95VWy4iyRjPEigo1FxonvjgXc85t	1
5608	2vaHhszcVhCmeG3NNWkVzEdbHPXtLKcFbRkiCCjBzBGxa8Y4teik	1
5609	2vaCs8G1iAekfCtNHMP8CTvxeehoNDqJoBwutaquf7YnmapiXd3g	1
5610	2vc38cJouSa9og5JbTsrus1jfzyavi3UtTn1qBjQPR8MmnUdQdMM	1
5611	2vbKY2xSLutdgoNFHStBGNDnDLH6XdkVXUQFT1czrZwzqBTu7y2A	1
5612	2vanarSsqgC7ApR6crVo37E1KJDDFuCtMi69MYv7eS5B3USkJF1k	1
5613	2vav4u1wmBu9h2EuCtKBFzrvxyY2tA7HkViTyJ4qNTHn3A462qg7	1
5614	2vavuERkuL8vASdzkoR6orJLrNSK3E78hFp7bd5Zv2oHiZrEyxEp	1
5615	2vbshDCMiinkBQxeZdywbov296gDZ4b92iebCN3Dix6y6u7VpkTp	1
5616	2vaU2r99MJHcK1gGNe6pNMS9VU8iECvpVdoSW7MRX9HTFVTt1hEu	1
5617	2vb9fPWf7PeaNqDSFyVrYspLuvHW7CzSadTf7FcxCvr1HM3G1TTZ	1
5618	2vb4kVQmgQFfPgsYQPy4C53jFsqRiX7HGndhFTsbQFhkv8EQqHFJ	1
5619	2vbHXCvfTKMVCEDW2bZbQiduaynoigb3VNrwfBe2bcJphHv5cXEB	1
5620	2vbYVAFAB48idwtTh1D91QSD8LVg1LQSBC5jBefpB5zSN3dG13f3	1
5621	2vbQekPNk8XiEcnRBwMWYoLD7oSJCPEMmHkYBjoKP4pZEqDZ5puK	1
5622	2vagxMNinZdTTsXRdanrYCygv1NAmsQLV6yivpWFNCtNZTvkH3U6	1
5623	2vbsufTMCAqAfWA3fynW1eL5u6AtmpupjxDhou9Pyt7XKknt1yq9	1
5624	2vat8aSapyfaFLHphmon6GaGXDejJsf19BE8bqWrAZifaLi91rQw	1
5625	2vaUD9KFfSVKmdCrnZcGzaQqzBFso4HmgJnPXgRc3LygwVgT1Cgj	1
5626	2vadL5SXyua52fgxUBGDif2uBEfjLyENwpD1NrE3m9x6V6CMXXzk	1
5627	2vbbxe3NU2b1kj6EWm8aqpujycUWYvvAEVFr4ANdPHZycrKTJcZU	1
5628	2vbbULTou7AMyL1LyhrYfZoNKWQDsijoYSSJACnwwZAByDrSuBtA	1
5629	2vaQbsTGifrhxXcjXB9o4xwgcFciMWMjqeqWS7iJyD4aQ35LftHj	1
5631	2vbAjKRdb1AqXX2i7CCRaN1xXsBiXN681b7fMfnPqNBRQHEHSGAu	1
5639	2vabhkZ5QPh4Sbrgs54VcLwLhNbMogrfJCNEgmjcz1jQTRAYRGnt	1
5641	2vbQrZ76G13feYLhUB2W7g5qkt3LLwTGkHJMz2qUPybMHZhRzhZB	1
5644	2vb9tTyzM5PRKq5MJyNb7AytnDZyY55n7DfJxqFQ9p7smVCHsa5Y	1
5648	2vapLkySB5HtYMwcQs4TtaAeWkknXCKwjBwRzN4hPTnTrLzCy3St	1
5656	2vaK4DaaABqDusPz7aH8XV9TpLVpTuGfV5CZLjzcWAPejr5Y6CC4	1
5659	2vbHPur2vkvSpV4XhuqoFn4gmKaQnHhCfgZjgY1Ee9GEwdiNNRow	1
5660	2vbpcnFDf1t7Yk8qv5RGYSSGAnLsJbm1GGph7wdGjHS2JaD8WKhB	1
5661	2vbipG2TTyjuWesxGmfWVAtNNdvcUp7YudjPVuMeqrWgYas2aPNz	1
5663	2vaXaMAMUyrLJodS11WzPujG8GSN54Uc3Y28th3M957T6ZzNwN68	1
5666	2vbjLVet5cmqFj7fBg1P9dYDH7Q5ChXMhiwBKKxBHNwJwry66cj1	1
5673	2vbeGAbXDnH8DPYFn7PinQ8aGqnjtpRCGCnUTL1WLpxt4QzV2gpH	1
5685	2vbmMf8oFGsHTTkDcmTLKjRQn9GxFZch6PfYxFN5NM5x78EwV3VG	1
5689	2vbfwe3kYs3pGjToz81MhUARuG8bzRUAQM8acPkWaBrAxxrTQvdb	1
5693	2vbKPMxXwgnZVENfhh3qPifDG8drFEDrjHmNxvPKayGFyDhU8E5s	1
5695	2vaQ5vT6CQu231K9qAYCDMxzZuHceJSRzBDKgQ9AVRCEPtpueKvp	1
5697	2vbpTHmbRTp71j2NbzR4rttKubXYmNwyWscGRoBSbzCphLZrBhfQ	1
5705	2vaTMTVXemLZHQsLSGsGweqHfDHU8SfBGLSL5THhzhvgdZyAe9Zq	1
5707	2vaYJ3XtoJ7ydp37Zi7mp8xahJoxckgoreN2pvDPHvJ2GKUW8UYM	1
5715	2vb9PV1uSGssjpA9M6kEMqBwk6brKWUg64LrTempV11NLwSugVp2	1
5720	2vamcyKuAC9i843T76bdUqjGpvt367bCho8NXaf2Y9WJBEcv3ErT	1
5722	2vbXN1B9HKeEm8qHEhLsP58N9VJuZdRBs6zJykcF9pWqhoq5y9fv	1
5725	2vbuPrkgHgqKZ3uY2UgoW3wHJLYdhfW1YTfXiBJ4Fi4wjHzWaeNb	1
5727	2vbsf2UJtQHvZq61qXtZFx1aAH8JBpRKi9Cwq5kk6FEzRKE4shAS	1
5730	2vaRXBntb6XPpjAFvbzqm3yEHMvX6Roced2u9u7hbBLitn62ejZU	1
5731	2vakt9L3YYF1LwLHQQrQ3AYEptk9e58GtjQ96jDUxijYLEcqDJKB	1
5732	2vbUGYC4FmxmucbU54ZBeFS1hgdvqhf9QZzbT2k6k7p3XATQCmhp	1
5734	2vaBYC2VuHqC9EsoVQZVoXVD1axmeYgkygUB1hPzsw5GRCd3QFTB	1
5738	2vaparyy44PuEXcFviHzgzAoqqAjGZki1yra7HJTajzyM6B4Nhnj	1
5745	2vakKFAsVqbGuXh8CdcxNWPQydjw58kxF136gV1epA5T3H9EwMSY	1
5746	2vbjQwAxiUEky4ePZzmJfMP9W3NCGPQr9FpK7NUQaJVcGKjRqYHa	1
5749	2vatYtyUh5D1WeBoxVWJdbH3Kwt5qfivUB1CwSGEXJKmkscFD6Qm	1
5767	2vbWX7v2QHBSZ9TALXUCwNj48QUiQMqGJgL5gbtfFMeYsaZj9RcT	1
5772	2vadXXZ3wCA8dzYzgjZ8HgS7dsA5NNie8w3o8njKipUVvRzQBfu9	1
5780	2vajGNvXQjqoMxV9oWpxeRTZuKfbzwsJKYdr3Mak23GCMkrmd2Yy	1
5785	2vasYDkZ5PvfhZZY6TniHK5iaU1HQLeWrhEqHXNvgHQniQcpeJxc	1
5788	2vapHaDxDkpCXHNDn8efdtFPMC6d23KeiRdbe7FpKT5x9HHnYDau	1
5790	2vb6xaix1TwXU2WXZCLjH8VXKwZNHdyUKjJScmwMe343VmwBapKW	1
5795	2vbsJio7aHS9jTg6Ch3JDKtgGdKCUDz1y8L4tiXJHZBLc5SWERfR	1
5801	2vbGuKHkW4xCiE5DKuxZaJcNaURG2bMoSg7CFYM6PCrpR7cv9gy4	1
5803	2vbhWtJn2CxYnSWicPanvnbj6xyawshoquGUqSRghDVQGCRrai91	1
5808	2vaYfv6swYFVWsRr5kLUAcaZBQcg78fP2ktqa6K8p2Q6vAtobwq1	1
5814	2vaYgvtx3t2RhJywUhQ8aNCS2Qm5fBZUyDbCH6YcLUMF2DtrXboq	1
5821	2vayA2WHJ2cT2M1LMagADk5J9M3swda8JNGqfmRovJmUHAMc3vUv	1
5824	2vaXkmNn98WKT2Q29MWYCRYtcWgcqz2VrvSJSKvdqWhByvTy9oxp	1
5826	2vay2p2mYBW8ZcNbjWVur7Gvtpvt4RmtPNrey58zTTzjFmxNwDH5	1
5828	2vaEhDFHmgJVvNtbDzgiRPdPaD7674NGQ9s15RGmKxLcxhMLRc2c	1
5831	2vbx1HScPe3GEW2RLiFtEmAsdWVEscNGWCU6RMZStynWUMYncWnE	1
5838	2vaHbc7sLAGtXVxjHY5kPx615NqH2yitNamjMJV3J2hUMgtrznbk	1
5841	2vakpN8yVtduKCw5Cc4cKrsfX5yA8iyrqD1ZBGstHkSd2QHmqGuz	1
5844	2vaiutxXQrKkeFofjW5ZTABXsHQ99kumrdgEkcm46cDCAcnFWr3X	1
5846	2vaGKRa7r9HGNsbPLVetfgCzyyGxhZyGGDC712fDokZqwSCY4E37	1
5849	2vaKVLw4RB88yzb4qmdBYdsduELVuoynZYFnn6pka2xx2sqkgDr1	1
5851	2vafwzWLvkXGjPkP7beLW5fJc4KbtAGC796c1zJyoxXyJzsxr699	1
5854	2vawzfnHd1rBTrPYPfXUtLgjgFWnZ3FD4ka6Mpy5zEPakZpCJBam	1
5858	2va9ab2zDXFid6Zs9D8Gzfs8xfB89cR65bvnaRiedZGM25nxsCBR	1
5863	2vaSXz3VjHEyWAqiYNWiSeppH1xRRNZ3ij9E1aKS7wTWc19VNdv1	1
5868	2vax2TtZsgpCsi1cgE9ZnKxJEDvQTYrprZFqYnZJ1aYTvZ7xeEHc	1
5870	2vbe3udVGqwwoNUyy4wKPSvdQerueGMcUsmvce52E8LWg4Ebq5JV	1
5875	2vbZNXQEHnVsuZ81B8zcNGvpvjmDXcZLC9c9ToFzBGek7PM7xHN7	1
5883	2vbN4BnVaXPrT6rzza5pnSqJ5M9wgL1xM7iFzA6P12DkE8Ud4QHX	1
5886	2vaNzzzyoNfiCqefZRLJkK1NSDgrsFyPvaaesWtb7FrENjA8KCDh	1
5890	2vb8svGqJGjRuNGiE2P7irAfSaob3rd2Sxod5fJKWHAdx79NFUX8	1
5892	2vbQUdAsaWmr6GwUqvtcvFVABpU9EfiskBN1Jje8nzT73VEDEQ8a	1
5897	2vas9Jj66vJnhJWZuDJFgYrkFBnGsRpDThxUMQW3eRhR6wMcLppt	1
5899	2vaGZAgY1gBMnXpeMniFhSMF3wVTECRmwAz7gkhLHzuyqmnvje7g	1
5907	2vbSG2kL2ox9mhtgozFvLcrm9BrrrDe2hX1WVcmKJwxQtP8aWUVz	1
5909	2vb3vE8aUGiJK2V27s371XohfR2kLG6S1ZBhJd4dxnpsMtENUCrq	1
5912	2vahQw8kVMybEkF35kvFHUF3t8m8apVbft8vm7iLTyn1di3L3Cze	1
5930	2vapRQUHnNWBRP7bQRma4dSBzy8HfrxCiwQjaxJEqtAVuyqmT21M	1
5934	2vbPo1JWmdR1qKAzcAWETz2vDT5KzNQUuDLvYxVnGL7tBjju8Ltc	1
5937	2vaidXWeeCX1T23wE4uVH2RVenCNgXtiYPjY2k69y1NLaSPJmn1h	1
5940	2vatLVhGpNPfMmYAodxB15x7F6RKipQSn8FDkp47SG64eycGLw8d	1
5942	2vbMfpAcYcUdjBRLZjFHtS1U4q4tqamrCQEmVKTXakTKnLWuuaez	1
5948	2vbzFioCufTbyZVmuwWkskuJmySDfFUN51cN19fV2PhcVyptqYCq	1
5952	2vaWLS1dUhbCFh9nA1w1qvhCMtQW4496H6rL1YnFnnKVg765NNp1	1
5954	2vbGjcDt7CQ6hutxW3vfH4RPeAAunQt2isyGR5sHgRe3DUmcHfvi	1
5956	2var8Q6dkeF4CF5utfage1XQyjtnf86vh9PMbvPTAPMq7WLW8VTY	1
5958	2vaUBUNRekkt98qrfyJZi9FzS5ZYCGrZcq5eTVSE4KXtP8Nw8V5H	1
5963	2vai3VsnMRwsYLnuxdWFJ3pmoAE1utwNVWtHZvznAY2LEHySDCGu	1
5965	2vbHhffknWCyWfJzogapC7RfGaznRCGXmso9RrTGAs5hRd5PpKRr	1
5972	2vaNiPKF15gh2zmmjBH1kW6Vhv1phBSbZg67djHrrpyhUc8gqRkD	1
5976	2vbKqwRQWRxrbRFM2js3V9s4AXkNgAWPSpW3shAhYJb1rbnkF4NN	1
5982	2vbdS25dx9C2yureUVeYRZMU3vNZiqk6Dz1LFcbieUHEVQveVRwu	1
5986	2vanL3NFRb4ob8dEmz6deCNhG35zMKajDDYG6B3mAgMHsyLBopSj	1
5991	2vaiYqGvzXpSxTJSyrgrK1FzFhQjMQ4iUgtejuh9NN8qyHV1ZaGT	1
5994	2vaibLCWv6JZV1Y4QkGsXG5GJtei1rrLPFPCjmCBx9ZTT7hR6BKg	1
5630	2vazit1ZE55nSbPS9gbs5uEe36vPJCmM4Rk72wgbXYY47iyKVSfG	1
5638	2vbUH4rYeHosqfyJPwAj5xfLd6hKBdnK3Usztib2GvjzynkTqNDq	1
5643	2vapXntZRswC9JniaPsqCStUWPrQXnAjuSJ4htnkyG3HbVWN9xGm	1
5647	2vbPei7uP3BkEghEEQm11pjLP6Xo5A1wLYt6Ge1HzucdCaCk9AJx	1
5650	2vbu5ookcfh714TCY2LpjafEYpBAyCHCnZToKeEJkrpW6XkfnLdB	1
5653	2vbXzxvNBb4zFMbbNposbeF2GMrgwKjJhwkskrxbaVfbFdcvaeph	1
5655	2vboaP76fcYKnBJh1gxZecdBJMfXVY1Rsz47b8s8w76tS6ejZUyP	1
5658	2vb3SDaS3StiMu1cHmHhbpmwPQQzUmLwTkpkc5C2xkDaDt1RYJTf	1
5665	2vae43hYhUKW2uPGwU46UQMTaenp6XZokyum8hLSN1TeyP25Cm1E	1
5670	2vbsZbxMHPgYxhaF5VUBwhtKgT4QvxtSJBCcW8JncTGx7UU4XsK5	1
5672	2vbGirQT2XEE6N3TQwELkcBbQRG3cXy5pAxZV5Lsi3GeGPGU2Ffh	1
5675	2vbxEU1NRiwPQMtuV2XRydybxQYGJ28dh65G4knYgKoLsREJkvit	1
5679	2vbRRc2gtyYb4GibD3e76VH5oHQfDi8cNCK8ZEexpCGuPPhHv35J	1
5682	2vc3KYhkCLWMWo37235uw9poDFuLXasimpatXEt1D1S4pXe8mgEF	1
5692	2vacv5NYkA3kZeA6ygJ3fhFt3tBv2RAy4miS1DfQSeB36QkGuzmL	1
5694	2vaxRTWd5Lprkg1hosZapr5fvXinkZ3Yga22iSeeJ7RuJw8ZQt2S	1
5702	2vc1XTA8cvzjzUcgm5uPnqqQhuwWQwgm6fnzpuB8DV4N4i7Ud4aw	1
5704	2vc3KV68iooc7c1Sdc6fFNZFzV5rSQtjKMoSbav1YYoPrMUtBeNf	1
5710	2vbbKYrbDKfirg7B3hq47kRVyEpRv2zSWr9C6TqCJL1icgNVB9e8	1
5713	2vc54AKmCDK36wBbffLBdx2jAyaCD7Mdp9SipuCDYinFrqc2R3Ru	1
5718	2vc2xuv3PbFDSPV3eP5B2YhfnYB15ekUwGPHAjC1TThwZMh3xymS	1
5719	2vaycWEJo4yQYKbe32jJK8Fp3b5aamU67NTuqgvpWhEv25WXWJX5	1
5726	2vbXehZFMXmE4eVxwXP1imo3zEZYDht4T9J6RTp5VbrAPtkaaLnJ	1
5729	2vb2n7oB6UjTfxxNAHipek1e4HmgXifKCyWSmJnHDAZCw5j66NPR	1
5733	2vbN4a747eihCHLmbpunAN2cEk1kubvXqHCAunxTwhDQxfbYanR8	1
5737	2vaJJk6dEaNyLgSDZGN4d4Urhrc7f9dLiiXKsxwXu49saTwBichx	1
5741	2vbSNnYj5CtD4RUYRjVWX1NWPj5oq53M7JYfM1aJDTjaaHgUj97e	1
5753	2vbueJXFwzJxZg3GsZ7UPowvRGYwwXUj9TUUk4XyrhHDUHxQJVeH	1
5756	2vaxtBn287JUDhdL1yELR6zcPZNwuHZwgxw69hmZUbmsBG9Rk4WH	1
5758	2vbnL5F8fBj51WXXNYwDxvQtWMSzLpgoGcJNBfLgj7mk4NJPSBnN	1
5761	2vbyjLzxFvoZsUmyW3N6bXxbXMcGa6HMYFe18vahpJW6SN6uYfdD	1
5764	2vaceFkhFnpB3S5C1TDYqQAbjVafRXtHMcaJPhfRh6pfRAkDR7mY	1
5769	2vbZpy8oVZWhmgyhdeXR7aSXzrv6SxmonUdJ1f8WVVpg94XJ9nyd	1
5771	2vaZDQcEbZ1V2byix16UuA7MArhZ3jHDc5KUsbCqbRRRgDVEtnVV	1
5774	2vc3ZJpZTNxETpjwFSZJfj38GpwJggMmm8LzvgspgNvVq7XtYG8C	1
5777	2vatRdXnqX4imavTt5yY8DDJbaUnpbYhUycx1NMSdsYmbh63Z9aC	1
5784	2vb7EfWkgaagP9YnGhBJfdnDX9HpzBY54vgJujYAe9Vu24yTK9S7	1
5787	2vawNS46S4XjHS5zoUrjHahB3LxHRdhFkuDavQ4Sv9bdU3DzVmhk	1
5792	2vaUMdZGokmErr1KGXT2Xf3GRGNAGqUMEc2TWvMnte3FRw8Jt5LW	1
5798	2vaB5CoVpvdNkGdyjKXUPDnoEf7siJA1yFMCbp7Chb1NdTBS7dMB	1
5800	2vbMZ8kKEREWc19SiRdbqBdEGNwnk8dpGTgsPb2KHQL19TscmTWV	1
5802	2vc5NQa3EfSqgshxvMLnj2pBXCWg21HNsMJoa3Qr5iBDw6Z6avsS	1
5810	2vc2YwzcqbxxxpT1R1jVyjGab9uVQtKqA29yU5G4bZGJxJvY3Hyt	1
5820	2vb3HfEgAWUAcEHxokht3jAnAUin18gf5Rwr4u3SbENuN41bWZ9q	1
5822	2vaom4fANZ437CYyk1ALPF5bGWmhZQaG2RPBdN3NNgqxVnk7sxDe	1
5825	2vb59BgXXHDDtKKGseznYGv32SbQmoTmFrcZ2r3Mva8kQqUejapP	1
5827	2vb6UUvgw8Wbh6entoxhBhfRjV49iEFruFGGU5JwHhfwQcqCHPyS	1
5830	2vaRdgdTrmUqHS5yoFnxzCwVL5NrjZicRPrAfS1EvxFUSPn8Jref	1
5834	2vbPMM6MZPStu5P6SXyYYyXAiJ9ekAtmqrGBXriyGugLcSpCT1xh	1
5836	2vbe5DVNSNxph7r8PxBDNLLxgNhkTupzNgbTyKWYQKDcndRRfQGf	1
5845	2vaSTNr8HsUho4Ncdp8gx82ng7RhWcfq7FRsGcX6hVqgPSc4VnY5	1
5855	2vadh9DZWWcWJAEqhXzC9pvUnSezP7YNCmfTyt6jU6d9qUL5hv3L	1
5857	2vbqTu67bprScRXtjYjtTdrUxv4NGyYNGj4Z8u6nnRcuZwGGLZsU	1
5862	2vbDr4BWHubgpaLYYDPMLxyfMKuFgZU762eLogDWC2m2cWX9vcJw	1
5869	2vbqvywB59VHGCDD28ThEXqQVRF72QcnPXeqsa7YsYvgVdfR9q1p	1
5873	2vayQwosMo5CuEwn92c96hhN7YesZBHr3XdNx9Cck2BghAqGPw9t	1
5882	2vauyS9N3kZAYzXWUPCyDdtK9oqqX2PbQEKXseeQDR6LActR2Snk	1
5884	2vbu3MgaMSKP8m1GLWjYXmgh4U7L7dn7N5nxng4is48x7vbD3G5t	1
5896	2vafbwtuEc6B2gUzfQw2jdDciWvCZt5cioUYnNTCiY2aZyT4pFN7	1
5898	2vc2GTt2adWoMMEKF23dSdxZdpBoqYRt5wDkJxMqwCYX9pXUE6zX	1
5900	2vbLWLpaG8StQ1Wa72T35Xu5S4xA7D3kpGZ1GMjaigM7zSYmM5Bm	1
5903	2vb9vr7Mny5vSyqCCV2PMb8RU2w4XkshGuxr6cyS7fdq7Wt5pNnU	1
5914	2vagaSbMAe2n1AFDAgfmSNQGAMfMgd1FdYS17JJjPQ4Hfwi86mDe	1
5918	2vbnZFzq5kqsyWqpfNhvfvCFxhnuCYmghRc6PmhNR13D1ALr8dSA	1
5920	2vbRe9BbzY9TsXxDaZxBE3s9mkdQh5irwnyz8ELF4MZhxoU2dpmv	1
5922	2vbZD3mV1DpXJeDJjgpRJs6NhVktm5TTg1oWThsg3aRX8q2BF5ui	1
5927	2vbX8afTAC2rKxVjV7f38NfN17U5AXCFtvSzPoXUjbSDFmost5xq	1
5929	2vajGzjW7PDaLGP7NPLFGwmtRbUS3usE58SeySew3xfW4zsNBkw7	1
5933	2vbn8zqcDuPN9f5xPuVMuTVcVSN3MuPMWY4qsqPGkhKeCpHSJ4T6	1
5936	2vb46ECPPy5qAx7Apke8t2JLmRWSaWEx7Zd6h9tMsHyGH3wVb5JE	1
5944	2vajSAywzbQ3oRRVtrmcEyVEH3C8FQhdKQdkUody8iyevCNvK8hr	1
5946	2vb85iNtFrWMuj6f2UwgVvWwdSDht1uUxBQMcY7Qb4ju4VMzzMai	1
5951	2vbaMdcz1vV9jUudBnkUi77ZeRLDKAst87hfvE698So85JUT4N6i	1
5955	2vaa8BBGv5AB4ZB1s68a2KakANJBJcGZg6GLBXaaubRhu3xD4gF9	1
5957	2vbEaknwJ6vaPmefmLm7P2sse2R7iwAe15WKerfGwZBRQkKwkbVU	1
5962	2vaCye3C9qk9krbfD4UfwGNWq4FPobsvASAvvb7kcUhz65ckHcBn	1
5964	2vb1dMpNBMJANjCisCbrTGp34wcct6KeJ6qCcrBAryTVwhmQGYE2	1
5971	2vbSAGrDNpJDDaTkgD9qgDsKVfFk23cMrXhJ41jynuQbUKwVZFqS	1
5978	2vb6AbzJn6nZGLgqLdLsF96CVwwnvYKfN7Rniks7FjgJ8DpVdEeJ	1
5989	2vaJ3KhYwFja4uvHBfxGeChhfJae4uzcNF7Y3ehohYiFotAXbpWG	1
6001	2vatNhfvNhgxhZcVa8KhcNTZGYAn2yEzPszX56GwPjxR6vFDYVdu	1
6002	2vbrw3QKPe2v5XVc9nwcA4kwhSRi5cG9GuWouhshuBQYj7DmCgrR	1
6005	2vaFZkyY1gkbYhQvNdkR2CJA71e8dkS6NVbWkNZxjiLzBbSXrMPE	1
6012	2vaE65v3L4db2grQx1eeYiPxnNvY25VHmZRA2e9TqDaNtL2pJcV4	1
6017	2vb8YZbCRZBV7zPAS6ADquicnuyTR5K1HJdrdd2AwMdhBsg2sB4C	1
6019	2vbg6nwe7Fg3hDEDPHup7gGQBu5SfM4HYyn8EaHBH6wGtobVe4k9	1
6022	2vb4BZUNFRVHWRPgx4AuTKxdtHd8aPUoTYCz7DT3ewL9PCZ5j6CC	1
6024	2vbpnrS8gqo9zsHw6xjQMRNpjr72sViffvsxNbvFKMRrYFYdKS1L	1
5632	2vakBjxrX2Q5C22DnT19hcnoJHBRRtJnYf9CdCeW9zZgo6xDQmX4	1
5634	2vbdEmg5S4d5K5Va7GpVnFc4o564ywg66C5xw3DqVTY5BCwhQWeV	1
5636	2vaHrjDjpRu34MGssaqczchgjz3RQY2BJwWed1YzxfFasmw8Hpda	1
5640	2vaBZbbrjYCAhsM2jzr1GWtK7uy29ZKLtW3ZFDuVgPZK9TMa5qy3	1
5645	2vba1qwgVJeWdepeqieVMdzmniA6KKw9BQy9pw3EKfqCzQ1BX9rE	1
5646	2vbGLZ3kpR1u5fkAnDb5t8PYxVGWKmM9bYcQesQ5jCu9idVxo1Gb	1
5649	2vbZsccbiWSissEcrcvPU7daex9erZnUkq9tNx2MWqBUQdNYPeQr	1
5651	2vaHgpDhczwNCVDo8nCoWubVgXvLcWqWxitjXXyjr9nkuD1cWARe	1
5662	2vbFekAe6hQ7ci94hv4bXFmnwpP9K8tC2urhKcvVjfBimb8uqeob	1
5664	2vbTjBJREvX53vsDLB6eosb6qoFXvUbSt953kjMw7mhxUTyyBbJR	1
5667	2vbiHoztNgoEfMPRmo7qdg64GmumAvygW5YSUaxmNZ6pe5gDHaxH	1
5668	2vbaS58NDLKL15xgj7aYR4UES88qJ2BFQ1mPeQkHnobUxkJm1PY7	1
5674	2vbrCNeqoL7PxWsaJxque2SrtQutk7rvq1T9fcbtn5gFvc6MYKdz	1
5676	2vakamBbm4xzGgKaoWduUY6ZypBbVkccgC6XwevW5imEcHwtfzmj	1
5678	2vbaNQuzzJvAAAVcXY7r2hjhpQbAgVzgDh1EiVvey9exc9qqFk5N	1
5680	2vbn1iXLRgomFcy89Eji98hu7zN5gDhuW5b3TPRrhXGLycpQHxxG	1
5683	2vc47CExFEpXP9cZHqE1jwtoS3bG4Hc94Mmxh8pRyD3fbq2p6Rje	1
5686	2vaE5uAsZT84EQdHLoZDQxxAZ8QypC5eh2HR4ZZvizNQKrGTBmZa	1
5687	2vaqMxpkoDrSYP4tp5tQbhDd8GdJD1Kx2GeMSSpLyLDrPkBd5vwK	1
5690	2vacpba2Z4ZHsXYFwzcy2xv1R6eb9anfxm62MGYBosjfeP6m6zBk	1
5696	2vafSHnXNFkUX5e16o9YQHHyD8dkkPBPEkTRgJAw8H88oy156GRf	1
5698	2vc1LoVjPfJf8KRGNPdQWJoCdf1StvvsPq2cRu5PjDRcU6iFEcZj	1
5700	2vbr77aPBhkcr3pWakbSwgDBaLQHmHHdSC2zNw92gYz9f9cQvLgG	1
5703	2vbvTpGkA9WCgUS4mpyN1qY45Ro4i2JRQLfbZjkbAqWtSUebiZLh	1
5706	2vasKEfd2kFE3MRoUESWSYao2T3SQDE8ZoMYAbVcKpb3UxrchacT	1
5708	2vbygAMAheyRHGDe3EJofzHX3r4scAR4fmacucofQ6RpQPFNT7vn	1
5709	2vbzD4HyTR2qWPPoSf1WjF9QLnJn6e8g7d47B5P3cWpEAbmAcExK	1
5711	2vadgLPJ8k2ExcfuXN4LRkqnEu7JkHd8wsiq35Udp3dJ8XFikK2Z	1
5712	2vaL9PQqwQP5e39BA3srQcD5yj5J2VPSDM4CHsaPGhgQY3Cu6Piv	1
5716	2vbf3rfS4K7B9G2hQRR6vWVGvVZrtqPuqX9BWgJKg8agk7Gc3AhJ	1
5721	2vbs9qdjvMRS7saRk1SfLN1GKupMzSUD2cYJuQzvWq5By6dhrW5S	1
5723	2vbBSBcDz1K8KgJEP3KhrgwL3eqPpmCqrXeoSAgMCepujepnYLBS	1
5735	2vae6LvzA19TMcWDGH7LEW286rR7y8yvtBjDLLfjBML7fyfr4eNs	1
5739	2vaedmMtUawSkXsSdEPDdhEGMkGHLyu1ai5Qg35Fe1NTAjcpE72r	1
5743	2vasKKxhs33fozguvLz1m59hV5wJGxt4JbVLz519deUmkbrppoTT	1
5744	2vatyQDyPHM7buUozscVDMJxrMBCbwqWssncoG8vrdKCH1nkSEt9	1
5747	2vavWXA2S9BGgRacpV3nowhYkhU5mv3opKHLj3QNjyv6kgBVVgAv	1
5750	2vb9WA6e8R2Gp234o633Cehy4st7kAMEt1fndyZh96WqNoe8VExN	1
5752	2vb4nMo6vgkW4YaipFupQG9n2gZgQSQTjSabYq3M4MqHxCoxLQfT	1
5754	2vbCngjNeRMfdd6XsMjNAC1AzojYkYQGhdaPhAxWsUX7Sag4tStM	1
5757	2vbBbpZJc3zPxvaM8PARiQiqPkZRWenitqSf23S9dB8ywR6cfZBL	1
5760	2vbqu5Zn2Z73kBzv3W8qYj7QV2ptSqdSTwqr4r98dZhPHBF89H4b	1
5762	2vaDzp8HT8zUCqMwiT6KLUBEAiiCZqUMhbS6ZaqTvBe29H9fswDJ	1
5765	2vbc3gUvD8rZEYhzB5XJJvx3mZ15R1y67rYjJETUVs11yf6ioZrQ	1
5775	2vaifCXdra5YJzisi6TC6j1rmSqfFJxpDtSNMXCCi3K25LVFvecf	1
5778	2vazWjy2NdKyVbctHZwdMhv2G2cDyWvZpgsXV7ctcCS4CDDFBrkY	1
5781	2vc2fkuyTp7fb16pHTsMDRsmnqrXvh8hYF5FHs278wCBd3qKn782	1
5783	2vaj3uCg5y2Vu85wmNg9KrBnRg5Erq5mCtQEQhrvBm9nerLtAmes	1
5786	2vbQCoLTiCG5fFAza3NanCM9uBkvJEG9oPYmiNzDaHfpGLJwFfVs	1
5791	2vbkpReEEPQhvRTqTH57w24zDHW5tovT17V8FomfoYLin9jAbvBh	1
5793	2vc1m1oQJui3Eyh3C9rGXQA4sFZMapTAhcUC3g1tdmxZKBtRuM7m	1
5797	2vc2FjC6ygzpJYsVfK9ZB39rRFnWboj11DW3gQ1cEoksTZZVdD7B	1
5805	2vaVFVqU1N1LWRVynPDpxNUWabheiNN86HR8k1wjtX2ea8jaBDor	1
5807	2vb8hJymCFyME1YqUMBvgGAyNe5XMRLBFWo4Taac9Sc4uzJhyyhp	1
5811	2vbYRbjDfP2FZUmAoZguyJpgWqdkft2615TL5mPGQu8TqsfxvBnK	1
5813	2vap9mgbBx597rsAKHDe6azGCYYZKjRgoXzYbVs3e7BB3cfAhJMU	1
5816	2vbxzWXWydtqJLAGao9Ptzboia9uWFmKe7qe3n5GYuDhGBxnpT51	1
5818	2vag2i8V7XdHxJA1bmbnfS9qvWooWQkNfAnpp8YpLWJDwTHV2STh	1
5823	2vbWabaga77CH4r2fUugoBbL6a5rzfBpVaSoFhfvtC9L7LuvDf5t	1
5832	2vbGWJnntuNqTfScvpkFmViKi8kjTDLibjcy9WFKgLYAEPTAi785	1
5835	2vauvh3k2bEPi154JcdR28LvEnAyv5hDHqpWqMbZHCwd5tsUiW6Y	1
5837	2vb7BzEqVwZVCVWH7Bke4EgRAhcQiwLiV52cAgPgtncbMAFhy2Zs	1
5840	2vastLpDtJj8PpTZY2EjPC4hVXy4LXF7DYr4EfDUBzu4CH3PMtkB	1
5843	2vbHsY1rH2CdjHPMCyTtdaaPy23bADEPHbvmRNkmBTarNiwzy8Yh	1
5848	2vb7kA1NEzCf6LvknD6hK9oGcFqVk1NvWaeKPQWaFdFJ9jc4v5yu	1
5853	2vamNPkVnABXnpbfu4FrwqhFQp3tgFFW3R2wG37VLKQmjmvcARWE	1
5860	2vbRAA1YDyjV7X6nPQdjfnZZdne6FXJV82wvPKep5gHbQ2E3rGPk	1
5865	2vaeWMVUyZrNDziLPJBC2aHRb3B5aWvbHB57TYeMFUbJE4wogoT9	1
5867	2vaHwGnN5R3kMYPKbL1ekLsu6ZfEzWUR145SsHdfi1m4qeL9Lbf3	1
5872	2vbNuNa5e4h9P3Qn2hWT4WhHRQKGRdkoJANESyCCYwqJ2v14Hz9K	1
5874	2vbLiKTZY2xGPrhhLfjMDqWBo1gNmgTcPbo6XMsJ2yY2aThMq8DJ	1
5877	2vbsxW4bpMGP5viWKq3S7j7sVeGiDxyRAPnCKF2Fx1NdYNDzofQ7	1
5879	2vaSWdkaFpBAYmo5oUJZU3E1B5ppVNC3DKV3n3ez8Kr5mDe3nZFG	1
5885	2vb9bpnSczX739n7Wz7gySZQmVbjGcTWX5KFH5cYnSzutizGFDpg	1
5887	2vaMatPmT5UniqUbn2hyt1QST6Cy5X3KH5FryXBcVahNk49Lf7Jd	1
5889	2vasCuZwSgSrAh6RgfN9pEUcLHQpzKnXSfQKjEnYGBPGEgJQuhmn	1
5894	2vaVGBeHVjnokGMnBUTdBAgng6antg3RG3hgEchw2c9X74i9kgAa	1
5901	2vafQGrAWLMsjEk1x6FdpDiyUfffzMRjSzKrK3v6oGxz7BxnrxUh	1
5905	2vc52kKs2z6oiWLNbtPUvgMn2yumLEYrJ9CMCzpoAnjF8pM3Gth8	1
5906	2vb5Wyvio9eA1NQFJwEXwL6KHBTSm2zHHVgV112HNfbeqHoPSWWF	1
5908	2vaKdbtVtXCY2n6ZSfm6SNCM17ef66ZaYw7Daq346cLhTYMYwqvj	1
5911	2vbi2xkHCL7QPMN999jnTaLdLkcTdCEt2h64MK4GrhsVPXdEirHf	1
5916	2vbPqtDtvKWGy321saCxV9CyhV4khacY5Pft2HWGXsCpcbP45SSD	1
5923	2vbL8FrGUc5TvJVWbFfEMcjXBd9vv7BJyankcHVW8CATh91DoZJT	1
5925	2vattDxU63xYreFoimsjQHZs842zStYr9kh1UikgB4JrKPsU5XCZ	1
5932	2vbhb7DbG4dE5rqb5KqSh4b7c8KXnrsDvYUNeq1Yw4nRuyGrFriG	1
5939	2vakPVusPLFmRbgJMEdhu2qhVjN4VkwPw2V5m2yYrgwSKHWAHYa4	1
5941	2vasHyhShjsV5WwNr3Y3GzwAjsSjhu8tfCw15X61WFFEEejYN8oq	1
5633	2vc5b2TgzcVW5czQy1ND4E8obtSaSppT1vWTV7KppXTKrgHT29n8	1
5635	2vbkjrwSNt2WUuaVzpMQV6mNaNn2KoYS9dPpht5AJJYeGwkUtZs4	1
5637	2vb6uBwzHpjbESfTKj5YbgSVLcfed4mgaBD5CAGUksqnNQnAYsvB	1
5642	2vai4y62Sxktw4JvZ6yrZd3nToFm4sMQqU8ze17MSnfUyQNwA5WT	1
5652	2vb2n2MJ2gukpv6Sed9nWzRTEEFxcEi7RyzVk2SnNkDgtxVwNnWw	1
5654	2vbDo4zZFCLC1xu9nSPZtepvEhyw29PbY14FTxpumZfaeYwkSbd8	1
5657	2vb4pxfFfCz4ffo2JbwJCiRjfgZZSoVFrPBLZooGnYAJ9f4KYZVY	1
5669	2vb9zoBmpMADZayx6NfUFD5AZBBKNzauqk3ouGoxzGvTK8ibYf8X	1
5671	2vatZDjKKhgZL3PaideAPYUAnaEsGX6vBJFhgyom68JWT2ugcuzG	1
5677	2vaNeyrzvtT9uUoxfrDXKPG5F9ukUmoaFwFZxd2BhzEMHmTiG5SV	1
5681	2vb1miYLjVVqYACRkTqyhBK3tL6d6JAw8Bq3vuoNaQSAV4bjhng7	1
5684	2vaV8dm1U1TkKmVfyYvxsiEUCgkkMLQScTpCTvrDtWg2Y8A52j6k	1
5688	2vboC6qJsMsHvXkxXYTbVj72sG79EkSapdfFv6ottkYpQBqxSKHK	1
5691	2vbmGhQXP1HHCJu7tKPq2WXNgHmcHobDgofegaBaSjwyYr74nVaW	1
5699	2vb1hZqjPBZLZ4GCANGuNvsJyJTbo63qQrMDd3o6eR7Srct5t9k5	1
5701	2vbG3DgARdC3UtJFaup37yNy5YhioaBVY5ueq38dYS7tCg9r2gq8	1
5714	2vbh6dBas4eEFn2Q9pfGmEC9XpVE29Jk2qwbvdDVh3utBVCfPXTn	1
5717	2vatuoFjJayX4onKp3XbbckL67VpuLBfPjBnLqMaEuzB7b8cNJir	1
5724	2vaoFvHfrif1LtrXa7qGNCSQadpM7VS6w4Nsje5Gy2mYN11fKRVk	1
5728	2vaiU6oxKyrjW8T1mCF7fK89pnXRDFHZ27f68G6L8ajdmeQ7EyJg	1
5736	2vaeeoJUQjEPfy7sRS3ENQ5swmZ793WmPdBesR4iuiPEEzaYzgFx	1
5740	2vbmywopLd6tNT7hQQ4k2Qas1XqHrCPM2LMB9hatN3ZC6CGJfvZv	1
5742	2vazxhqTTnmmQVv56Q876azMZpq6DsaAfmUzKEvEbHPXLyzgMQus	1
5748	2vbJRQmBxoe5jLsNPc9z7oNHQYPuvf5BvURZvvtDzBQiJafcnw9H	1
5751	2vaWe8pep6mHeXnBBebG2cac9NNVCjJbTZ2ccAR9ScrhkGcDSAVq	1
5755	2vbHKUFzCkfYjX6K99BmxRECDpYLKHRvPVDfNamo7uhnwhWSrLek	1
5759	2vaJN7kL6f22VxEdRDXiBQMhZ4YkvwCSdZnU5MWLY8gZ8Di9f8Mw	1
5763	2vc3ihsoeKVFxdqBNpnU7um8KUPf6mG9CqoGnLJgDYBufCwvHMLS	1
5766	2vaWZkQbqZf4NioWJkLoTnXWHhMXZxjrNEqhtPVAt9ZJd2YBifVb	1
5768	2vb2ND8icXzDXLjWqrA6T4rkos1AQQWd5YQ1t8CpFhZaKpEMGdWg	1
5770	2vaThuHQauDzdDA1qeYZHLHuYMsEgM2VgzJdqA9wHMfWFSDQZ28P	1
5773	2vbuvWiYPnzaoVbe39xqzBjTr1UEydSnXGUkejinyyjB2u8SJen1	1
5776	2vaKTvXtWRQ8D65TmUeCPUBMnE6ZqKegFi4Lxv9wWcPn9PKQ2NhC	1
5779	2vbTkNHz2cdZkhLNDZGC57aBtmYoCM2sfHv8EgjE9aaze1Y3ADkX	1
5782	2vaozhHrZWhnQZecWXmzRZzpZT7LgdnYPpGsXaBchqrGJysXCoqt	1
5789	2vaaegJfyeF9WsUhoy6GeRKZZn8RoQsxdV9xp2wvgS3CJfnmZpfp	1
5794	2vawUzAaj6re2puV3mYmuCfLCv64T4KMzVYUFsKw9kuWkjKmCTxU	1
5796	2vaxyciSGXSQju3ij5FWPKFiJQFroyTSoLqUfbZ3nT5iNqoKrj9u	1
5799	2vb4Yk3BV3a96cXV3SkYNvws41iqSt4uHSFcDSXxPgSBFnBtrAMZ	1
5804	2vaD3und5e91HCdnzgL5Cba9VGk6zJiu3GLkAZ1ZYGbAbpZFUPyP	1
5806	2vaFj9mPiSsnQeYmwumZPa3MoC16UmFtcT27ZjR1dDa411MMAo1y	1
5809	2vabhqXx36qu7LMFodDASdx7fWfzQzZxbpHWGjiy4csbmUpv94Mb	1
5812	2vbWGmRzFxatAP3TSd1epLZ3fvWi8SWJY8QbHkpUx1JSNTLRsmmF	1
5815	2vbgowQrKyUnGfe7qVX4R2ghx3s7nD9679Pp9LKEWFnK5WEvpsbX	1
5817	2vaY5YJmG6aXWyNy4PKCq45TuNYbosDJ9ZW9rXQRsuDiCiSwbCy3	1
5819	2vbynU3Cs2b3h1ps65Lmz3ALZGai1hXzJmcFHPyJQgF1xwetn94F	1
5829	2vavRFaie7RaVf9JzH4uam85htWV8iJTZDVoqhztwJ4pLSdNCHSR	1
5833	2vazJCebyRBvDrYboK9EuDNBEV2SHxVYnemvSotjjRN5QdZkBapF	1
5839	2vaj1arDYcAatD4VitAfxXAZifv8hHprieNimPWfZtoa5EbkAtZs	1
5842	2vby2QNrJHX6pvcAtVz44NjVR3bk3fY2gG31HF5btTNDr61CbWTs	1
5847	2vb42wXGdeZ4M8FT53DbvmjjdQYx7NGbyXcpg7eLY7ABKhaKfbd3	1
5850	2vaN51CeANQmJTWVcJ4mrzKmwMchvoFZS3eEDd5YCNhfq6C6DxGf	1
5852	2vayC3PbYCTrMaJxt4hSoaD7ADB92PY1o1T4Qgc73zPMEN73YmNU	1
5856	2vbkX3yzJioYEtC2NLXEKxAaHo1F7RbvhDz9eJBwXAumg5Qc3474	1
5859	2vbzEtCmnRkB61iocBSeRhJq2CcKrJaNPNEqDivazRY6H1fW2SeK	1
5861	2vbgBiTSbaqvhUSiRcLeYjHZKCfqTPMpaqgYLsfzY8NLm3JNya89	1
5864	2vc1SbKZJ5yQ8wDRakmqdooYA9dpQTtsAGBeQMrQsj6dHQrdwZpe	1
5866	2vaJQhDMTwNJrQByNG343xGS1U9iVQKTFFUp9ADGDbZYFEQmfrCy	1
5871	2vbFTnzVkuqhbdBcKb1YasjcL5edKPb5CbzU6V3rciAi66eTATom	1
5876	2vaaMRMzFqqnKkhUz9gTMHhYByuyWdCZXLcM2oD66n4Nxc1n1CXQ	1
5878	2vaWqnc9o7UhvvNhkh8UaiwYQtfvGoNZh5b98Z5bm5kSQB7LahXE	1
5880	2vavQiPXfv9heqmUcN73JAoNh68LszZ6oQCEmt4y3zgAb8xmps3u	1
5881	2vatkKjncyKJ5xJshkcV8GYYydNseo2fjJZFVs6bLpNZh7wS3ZaD	1
5888	2vc5TXmbuDjjqrYRfkFWFzpG3D2LZffYsC1j6rb4Jg4XW8Kyk59g	1
5891	2vafnmY422qcVwtnoDSxWciyVQMjFjZQdgdScPjSamMB8r1bASiv	1
5893	2vaZjThgYKECMcVYZj87n3WiwduTc7oZg152N7PLXDXTxbY54sWs	1
5895	2vbAwyUYWkmMhPiY7bgfGmUTV3Zab84KmTrLBYhbko7PiwUDNn3L	1
5902	2vbcJRvFy13fAeMRLZWLdU92s5fnr8GqNqmmiCJTwQJkLWgvHwCz	1
5904	2vavkHyG7sb6dxhpDrTFWqPV3i2DBVi1VNiVzYGfZFnes9uk3h2b	1
5910	2vasqrtf8nfqNMvLotr9NHzrPkKMAH7G8YKPFHFEynrTsM6vkoHS	1
5913	2vaauzFCy7RYGBTPYPMR2FG34kHHbnUPyYhxeyfzAzuU3ELeiYUT	1
5915	2vaGUS7hyV6pC4zjvUKp5g52iivQcLi5Kpw2n34vFWQuvoDZv9Hn	1
5917	2vaLr47SP7NrEi5tiKWieZqUoE2zy6bxqPaqDCP8TBCj82biM6eG	1
5919	2vb8HyGGoRo1KdxPHzyTawo2uxomeofMnjdaW1aHPtmoAYijGjch	1
5921	2vacGaPUzf8MLLhMhrH6JFFkZUNDYZDopdDpnUcFyboBSCyABd4s	1
5924	2vasxjD2gDqTHtcebEf6Ro2wHb5E9EaiChUShMLUiu34MjeXtR72	1
5926	2vbBtwGxDNJmxKxJkoiztWopVhz8ehhpiYmsNighNK4BrBHZRexU	1
5928	2vaHBXftdPUn55DRtZDu2e4PY11ogA6hRzW5xh8xzhpwMCQbdLxw	1
5931	2vbKBxP63rX2VsbptGiGAD1PMHnn1a9xEDb6DskSiKyz7FK9FN1o	1
5935	2vb5muZTST2XcpaNBmv4utHFAeFGXZRppARL74KVRdRYN891w1w2	1
5938	2vaXThWzpneaBWMb6swuNRoYhou1RMQ9EBesFUE9TkXv5FHYCyS3	1
5949	2vaUipgnRjsNrWGRxEUibmL23NPkJ2eFKKmWgtyJjwFv7LcHJQgx	1
5950	2vaGLfFVuGv4HtcohbVMAUHecF4uEAY3H45HywHuq2XYYEH4vfjV	1
5953	2vagr7maJTxadPaXDgJnjWV4GQ2hcWB6Xx8yCZg8mdcGqyzuBY1P	1
5959	2vbGvpWt2BibjwTHasQQySJzA1cHc2PYTyuQBgH6WEcwrd9yWdSv	1
5961	2vbxyc9FnM5NJWX1WqZ4fCstnnAvforuumVysXo7FcGDxA7TS6rx	1
5966	2vaQ4P7cgAafuFhcgRQDFBKe2vNNerBxdaEV51YyJVUjGMHmCWNT	1
5968	2vbkPcH78ddEJ4YWaxsyupjer79uNtMp1xoYtBVMETzA8n4S1UCU	1
5943	2vbfbLQb54V92Qaj8CE8fXuF5S5XWjxH5qe9vZVDpsRQUECzxTkw	1
5945	2vaj2g7gRdW1cmuF54zyR1XN5BzyPmi9VD6C82ZvMygw4sxRGhgv	1
5947	2vawbRcTN3VoaCfwzqa13829X2xwQ7GJS8brMvhZUNwkRzbRJCAq	1
5960	2vazs9yMeRjyWXVRrYMF8AqP5rwubQo1jCoH9gvnh5zRwcDWhohw	1
5967	2vaJTi4RoUGGGrqftJsmpkVbrFbuZfEXRVXw3riecraDgCfvQGjw	1
5969	2vbwAbXchqDuLk8jFg3VNbvcVY5GgKFvX8pNjCi4zuwNVCD8pDqH	1
5974	2vaHEuMY5KAsNWX8U8G79DB4EHwYkLseeQzwSoM4McSVFmkgXhte	1
5979	2vapiwszc5PZxykrTrrkzAhBArdZ3dmAqmDQnbEwG2wHG1wWntqv	1
5981	2vakhQ2KfwZfAkvBBxtQzDBjBLLRbDt6KxfYQEio6VErGjqeYWxT	1
5983	2vbHDnYrSe1zenFW3KWMLvEpNXMJRM581jqtaEP7TacqFJ3rqFCi	1
5984	2vagPqc399sdvhbMc9w5myfA5QmJbxd4M4DiREF6yX8CnbQnYCm6	1
5990	2vaVcT2RafHvGmm5EjoXBkp5NDgqrxqLwd1LsMDC13tekzn6Yjxc	1
5992	2vavJDeVTfj8CSyK3p25PEgz5imW6sXttahJA5WwwojMYsKuRtsi	1
5997	2vbTf5GnTdxRFHg7RNirScFJpgFpi894YaK58Pra6z6jD7x2mpiP	1
6000	2vbr4qLebqkDhowVoQNjTYXWK2hyhNgghX6pSC3jDazKhnty3wqn	1
6009	2vbsEoi4V4R7MMZ6UjFKS7rbhhucKiuEG2RmydKymZPtkoCwvnFn	1
6011	2vaGA7xA1rnxYvWnpp8ikGEzwxXZHetgJ2TWFh7s8Te8PY4w2xK4	1
6015	2vbKvNjugvxkJTdz4Rp2j4BcSLkx2pQdj9aT3mwhnF4e49eFqq9o	1
6016	2vajM61b7BQmwbttdq7qwu29591aDrGfn1pj7kvAsUfKLaAVbuTg	1
6026	2vbsBwfhtVFtAM6BKo6fpSSWTaEnK5d4GPcdVZwznsqzyvcUPru1	1
6032	2vaXpSFJmcriecTkcZoRUCHqcTmbAr2wBzYvqMxksvsEG68wohxq	1
6036	2vayftS1bPygX9jZseTUyPD5qCxXiJJGqoeBjxK1R7mstNxcAWxW	1
6039	2vbLx1QT9eHwoo8zKHUbTJGmRAs51FRAyb5koU2WRX8kUkhZFatB	1
6041	2vbttBKRkM1yWNGwZmJJBxknwgggVLCo7kJ8fva5Hu5M5GfuRXrX	1
6056	2vc21iKBKr13zzbvUBCUYtQi1paDwWAiHsWhU7wM7AYFb5yXbCwp	1
6058	2vbAbA73F9MNv1vnsAZwYAupTP7REohL59yCWRsZ8MNp5FKjTacn	1
6067	2vbws2FZZ35RoL2dxsCJaykmMmj6NtwaWH717L52ZgTZg8Uc7tdn	1
6068	2vc3ZMJXkCGtTd2j3kRMBqSjwwwWrUDm3Cz1N6AH3cUUhVXZgiNj	1
6070	2vc1coRwz915cbYR6E2zMa4abjECvbAPa8P1NkRydDm8rphTwhR3	1
6072	2vbGYtrPuViXg6gQJ1uxva7iB91QhFpg3zfDN8LKRak2nYh5W22Y	1
6075	2vabGjYCdwhpuJZc1n5Pg7sAdHUGripkzhq32uVpVp1jto99MBuN	1
6080	2vau4y2R93vAQvmLqW1wMfA1bLRKDqNc8LLTPLYzEqm9CgnjCamz	1
6086	2vbBGv3o4sRrqQjvbZCmKtuYSHKJwG3hz19tN6NCk6dZGQ2XXSC6	1
6088	2vakTXDccZFWU9vRpqnatah68n7bGbAJpEJCKU1CKyY5Kowu1M5C	1
6093	2vbMMHMZBUR5Xc1ttZHtpm53XZnQG6Uh52hMR9MDgJdSjWoYxpwD	1
6096	2vaMbx5VCawGc1X5K7df6M8WeRVh6WCcY6oYBwCq2HNvEFSVKYor	1
6098	2vaDjEECkp2KKfUt5ScpckkHeWDj7NkcUAan2QbHHHWJoNMMAwVh	1
6111	2vayTBs78pni1Nij8AQoTz4bFGmCzYbqbtYsEWoVNtLvA9ABZcCP	1
6113	2vaPxjEWhNSFH8Rs7gnLu1E9hfv9ieEkAt1YBesEzJFBFVEmNmsW	1
6116	2vaqUyiiTibVy4QSxH5yxSKfxpCEsmwz5ZKg7y5LMQq9bExdJYM4	1
6118	2vbfcfRbCegb59KxfnuaQcSSRStr3ByEQnRhe1ijXx9AwCAhBxi8	1
6119	2vbnU11L7PqNtTeWYswYSwXF1cvf4RzMn5Y7pEDw74yUUZ7MCAVe	1
6121	2vbY3tmQGDpeg1U3yFnHBAPCSeSFUgJyF2TWwRDfGHBx2FURTkj1	1
6124	2vbtrFJheQw85UTr5fLUn2NWVuD9hJEMf2kbczBFCSPjtCi9vDx7	1
6128	2vaNXSf3C42f5zbvL8Ufjuxk5qVvDuTiDTMXSATwttEvidXKo1YT	1
6140	2vaujoB2VX2g35Cb4uLUY4nTcDVZFRD61odCAKk11tknCKSf5K6x	1
6147	2vbe1Vy6Ek15GmkWngbt7vEW1t1xG3fkXWhBBK1zEGecz1ShiQzN	1
6150	2va9D1fimzdqRSeCSVVh7LgytfpRcrcuwELoyCkkcHuXzK62qbti	1
6151	2vbVbn9WZMXi8665aYPePLrk84w7yonT7TfuTqEGNgXjHA63YH38	1
6154	2vc1fAC2HHR41z5kacRAJNd3yqTSVoPUhApdfkZEETfvMDmxsL9q	1
6156	2vahQvtmx83W4mstAE6Xu7KuUc7FnjzSbc4hesnGmxNzyGrrkECj	1
6159	2vbz2ZQ4kwvnyLDMb999jvBTiQdUKomTySDrDcVMJ9oZfQikfRsn	1
6162	2vbFCh5oU2wXuWfNG2hUsjviu9zANNVSo3wKrUkHoo9j5sXe1Nj5	1
6165	2vaJ6i9noxopR1KiufxZ6KDM64ZT4t1pqdMjBxXZiKVxNJMaWAYb	1
6172	2vaDRV8d93PECdn4ryTzubXkvPCT5UPp6NR985KPzADgSSRcD7w3	1
6179	2vb9FNiheNNFLQSzZyatHLnQMmtx9ZotkKi49C2V9mabvHJJ4Go5	1
6180	2vam3aezNZd2dnDXSjw2FN5kwuCxhKGghLCYe7G46aVxGURNMuTN	1
5970	2vbFzcT6hzxYZZQqB5bwBs1eQ8KsTmPLU8PvUfAPGYLFz9KFffxJ	1
5973	2vbEAUt8XmDxCGzp6ExXBgbq3utBMbiZFKVfkmnahGiAyzQgyT9o	1
5975	2vaRoQGNnfZAjNPUyAsSXQqWeTn9LnfqkGeBdnwoVjgep43vckNN	1
5977	2vbLyoUGd2KBCQikFrzZ1smrUMzjkvgqwgJpVCUJmP4m9n8JyrH8	1
5980	2vbWYdQHoXQkWmDDpBfDwpw9jNFpMJa3adLgfaMvYiPqbZNcTY6o	1
5985	2vaCHWZS4ifpSRD7VFKeYows51rnYUrqbDYuvwWyzzT3dcEGwT15	1
5987	2vbEcXcA939PsE5zwL2jcUPf5ZQTa3pSkuBTAMARmJire5iJ6YXJ	1
5988	2vbQY52KPm2mZQKYwPSWz3aU9kM8yNmr71sHbc9U7hbGDp8KnphT	1
5993	2vaiRjzajkcG5KQhTo1tZKNQ53VogmiLpXmhQRgbkTtLqUeTtFTt	1
5995	2vbc7tcMmXUubmUKRsLo7FAyHpB3MES2owHiy1wom8vwi6WGbFgE	1
5998	2vbP4dkJgyr5PoCrZ1nZ1vVFagfxjYDHa1kWVR8fDgmuvrY4TJzq	1
5999	2vaqL8zQk1EZ9EjUauTbquYY7tAehjZtHfCv6Nspw6fdFuEu2gQv	1
6004	2vaSN25TsVZy1Q5shQ9765Ba3wqM68tFymcm39ia5pCTtUWpGMKs	1
6007	2vautnRfZXzChoi8uceToxKyjXUfePzEzwKjMfrxwFDsnaYDD156	1
6014	2vae9rVQoArkV97ZNjBVXGez2JGi2J4az7zXm8gaBpwHuVRLeXw8	1
6018	2vbnfDbV617hYgmvtVuZu3iqU3VkfBcRyiMtDZS4JDAw2ZekCBtu	1
6021	2vc5sP8yxJRdmx6rR8RZCHQq9oQsJLg8wNgdaNAe5MNMtRLWB2sD	1
6023	2vaWNdoGRQZCoQBkm7qgMNXm5wvvBXcRQdEdcH6vHGu2YBNLnG5f	1
6028	2vbfKrQxsGut1xj1hPbY73d9KPvVv8Ln6HS7rt6um6LuYC66yT3C	1
6031	2vbu83hFM6SrtAzt4T6289p6CMyuwKvQ3SPsdDSxLQXmNUyg2F6r	1
6034	2vbjxpzc2xkGGRBvJB9tTeFHATwPtsx8e8woTbxCB7HhtyQBAYCS	1
6044	2vaPcHKL37sq4pWEdH9rVnzJjfWBaSnGCd8kq3ZfPB7tP8321qcZ	1
6048	2vbSFwFDdaTqBbyM16igtAij1cirB3ApUi1wv4mZMFrLAwQBFiJr	1
6051	2vaXPUJ6AwQmFZsWRTTV8t8k1G2PFVqD781iVgTMb4jWJ9WqcTSX	1
6053	2vbFYrudLURztueqkDihgNPvW95c3P56rH5Ty4sEjyGZtGZAG8XA	1
6055	2vaMTdmjvehK57NuWYNeKEaVDZji7Cq9gr4PLdfKVWgcTscc8tJ6	1
6061	2vbPabBYwzJunLibeGr3cwzsECNDPqHf5kfwjbMkucK5eunbbHH9	1
6063	2vbSJYFs6zL5VqExCte37DpGBpV6mdwEUt1JuDT7inFqdnY1uUev	1
6064	2vbsjGcL2tY6PDg979eKqB4wf5yUiQ1SJQiyxziyFPetjCALpUJC	1
6074	2vaR12xdkZWcAPvQVGe1WJyExETipSK2nCEgKsWYnC7fYGHVvqWJ	1
6077	2vbDKpA9a3kMRmFfVhsHquG8ANb5GGYjKXPGAS8QWRGVibf4WYss	1
6078	2vajv4DM6uN2yWgqwhNKj5wpqVhSUfvbofytXwZUJXWNszfKmVzN	1
6079	2vaGZnu1JWMKJWuyACzgyE9ZyFsNzHtgYEKXizyP9NC4NpT1LuFR	1
6084	2vbptBJLMRyiVW1h7eALmwZmhrMnZicjCJNWD4LBaY19n9QYTAHx	1
6090	2vb3LNaBUfUKEBFMFKbQuy4KHGYhomtcNrtCgjJGapot6FwEE98S	1
6095	2vaoDGoSCsuPRSTGyvJAH2CS2DaHmiaTbzzs2W88bK3i5szVrZMU	1
6101	2vb7QtZkTWeJ327yWW9NzVnUFw4dMMvniZnpGbDiEbSPpLppfELo	1
6102	2vbGpQh8P9CdGBjEMyDAF93dqa1msaYKDeFfeAtFqgSTzyhQCAwL	1
6105	2vabTqnFhDqPk82cdrKffM4zBsMePs4sTUSU8sTMEn7NmLn1qucq	1
6110	2vbuginnJK9RYdk9Gi2GgGmDh3ZntbCzZ54kCsceGgcVftNUzx7i	1
6115	2vbW1m9Vkk6LJdWJPjoDfzZ4mF9UALyip8PsJ6Mz9U5ZpvyH2v8w	1
6123	2vbKAtRPACb2Z6aZohLVrtFLBcZUF22mgRLrJFK8G6sNEAoDmewW	1
6125	2vbwNtqU1XFxGjAagTbZMagkMvFUVcdUB4pskX5t62NPPTCKBvRX	1
6127	2vaTXX7FQePT1hjXuhwiKM7Nzd3Y2UhqYDub4Z5h8YwZd9heAjiN	1
6130	2vbRdfqaUwfHoTW6ZRwfNpSyQFbSFJJmiGpWA4jpiJ6uFNDs9FT4	1
6132	2vbCVeU7r6b3XyurSY9bX861ZfmbiVqGhXU7T3wgyDSwcAYZ73gi	1
6134	2vbHmGLhUKbTi5wzzkWQ8fhnxvNmWQZNwiNyaDA8Xgfw9F5gzAJ8	1
6135	2vboBZQESd1PmX95CPzQKsJS32zFGbxr5iH7tgY8C9tP6EfS2NBC	1
6138	2vb6hQ8tanym4FMPcVqf2E1jAykvSRkNPvv5fptt9GJpddN4FJ8Y	1
6142	2vbhgZLbRSYud5veZiJEhEHEpZKqyoaKXd75pNtDdzv9MYJYPy7J	1
6144	2vaXHhAzgcazPg4Uq6jSh6aebnDmCu1dmqMaRGZd1RUZP2bXdRv7	1
6146	2vagvqoTTbkkhBsjoYk1sE9rYpEU5LRhNJkTnwaJixtLgmgs27kx	1
6149	2vb6RKhv2UmXPoN3g8Z1HY2gncLgm8timX9c2hZ2EjgB5JYuDVtc	1
6153	2vactiRMHqwXo4vseFCsokbJBH5reRhFabEjNUX92EqjTNEhDAcU	1
6167	2vbBsnBtnooBcXWzodU38JJZDePd7AZzaxPDfNaHJ7ARCCo9W1ej	1
6171	2vaqTSsc4AsxKznZDwTkj21vxSQNtnGvu6EywLnr7BKKsFbDBvZ6	1
6175	2vbEf9vkMcWQok2yioB1RWFPhwAZ2Av3pNcPnxUQqt1Pkbg7oc1y	1
6178	2vaCDFcvyhkvL6QVLr9MbQe5H4CRF335SVFH1fZbt7XRLnTVYs1h	1
5996	2vbNaxWxg4XUPUi4Uuij9Yf2pwaAgiGbPMukhxdA4z7DnibxNQzY	1
6003	2vaiXofkzTpR6bkd1zhCVvfduF5tnLEch48DLszUJdaFKtAWXt7e	1
6006	2vbHEPe8EcAP3VaSm1MkAV8GQcwdGsaYzpPh5rd5TvDwmjtjf6tQ	1
6008	2vbdoLy47BXcYps41sGaKYsg7bTnMmUPf3CVzBTotoB3bBsfA1jy	1
6010	2vaWje7QkEHeEHcuXD1VYMz3N5RLNbp5FLs4pGqj4hh5u9Thx9DC	1
6013	2vayXeW4Hc3ZGCeXTZqRMefZrSdXzt9yetQGR6NgHuu8jHDWvU16	1
6020	2vafUWQ3vd6GyMF7X7Nt1qGRXS2RD7DVdM2XzyJSxrP396stZccC	1
6025	2vbgzSKuL4RkJVRAoPQH2wL8JxHRN2U5C3DdBTBjnLzhcDVvpCb3	1
6030	2vbayfLZsMWnJGcsVKE8Ld2SDhwsxnkV42BtsAAytSCbqsnDkzZ3	1
6035	2vbJ1C61FHJvjXQ97as3PQEcPtAWZM1kEdUNSBQ4SBau2rPnyWDv	1
6037	2vaPTeTwKLnQecwWjoebcUaEQUtbdjmSNSEEKZ43YMdPWSSpLPJb	1
6038	2vaywY8Pr2ALYDjh6xGyiKjBRkRup5UU3dLTPs1UXVuQHxAeritG	1
6043	2vaMhmgK3jHoB6aCH5Dxw6gz2b5H6vep8wTEKfNKJmz9WXdiA8WY	1
6046	2vbHZd46adtKY5bg5UNnopBbAnNqcW7p71aWGZATe29eiW5XJ77F	1
6047	2vbdrebSFKcuzdpNTwrL8U532D9on7m92HyRTirzk9G9gPyb3UwC	1
6050	2vbhQ4GBbaDPxQtvxyiuXTkpqQRxHeaVMJjc7gp9muewqHH8sYkR	1
6052	2va9DYrkeQiEeMXpQ8aEY5RAFfHSNYhy4jcqbpuqyUQsQ2JBaeZo	1
6057	2vbfDs6j3oDVnAoDAvbMB3tnR2U6YyaJBCzpcYRKhom75TCDARJT	1
6060	2vaE3W6mfuXqSMqkiJLhQ1sruu9xHrW3iPcSuBqCnLTzrYNkHcCZ	1
6066	2vaRAh5aBqUCe4ooSZAjRzte9V1AYEdUWUYjJvfEL6DTYHTbpBWB	1
6069	2vap1hKcTrVqyH2ZDihxxAptCT3mdp2qZUptFrGajnu2U85pVvbZ	1
6083	2vbQx6Mw5zxZUbEZ4xAQKgRfHDjgpQNmnUHvSDqGqutVjBh7bLgJ	1
6085	2vaqgSLNccdWq2SHCgTm4Jdst9jHDR6q7Kv3V7SEhf9mFFb5GhWF	1
6092	2va9UVmyPNiYjR7xGGM6QpUCDViyfVBZP47BzGGYTPWjJjfAe84R	1
6094	2vaggzVAeXP7oUskJBZsWC98AoFSCiDnnXEdcvtvZgEQTnFBVUgU	1
6097	2vbKbDD6rtoivkGWknT9CHFYHhq7ZjfxFn1dmwGcZYdUYPUhkpJT	1
6100	2vbAnp3JpAaeJKYa8UmBcmVUf2WoeFYG8qkymZakB3xjzbaUoRnM	1
6104	2vbTQRzqisC7pBip398a1bLX1vUEzXzsDn7GWZWb7k2NNXPnECwn	1
6107	2vbwUPn96eKWFhnjb8BfZKRg1vZcF65aQD7GQ7Fjf2mToWHJePeB	1
6109	2vbD7UBHdoRCEZrMBDY95sQr5D5byrouQTUZfUach9QMN7tzGQam	1
6112	2vaLcYr9iiVmk1gqChQpcVSHLPhp4m9p6EgA6fzqnkDE4US384mi	1
6117	2vbLUy5Pb1weNc3aAFt9QnsXFQZPCbtkToq3uDnc4NFCUtmLYt2n	1
6120	2vb6dC2GHwjuGdBpXnZLjqHXY9Anu8axQHyMHXVXr7ve6UrUri87	1
6129	2vbi9N7KYj2onVfsEc56nds6xM7YJu49Y3vpsG9G2XV4r1nRKQpc	1
6131	2vbPLp5xmx4rhHJHNQYZfo9c5mA2wVLynYGZSXsG4X3qPUt3SngZ	1
6137	2vay3odG9uoeNBHXGvPnjcagWHuGS6Y5cVV7j6QFUHHMG1GzAdZg	1
6148	2vaFeyHhGuTuxBB5QrFoYRQL54g2rRW5M2eZ8DQDEGcHhEovvH65	1
6155	2vb23N4HkUQq4diYEVqCRh3Tyykosd3mcgZttKeKQ2xoXJYbrLwP	1
6158	2vbxdZKPGCQqrEdKRy8W1Rru4HghVbfSRwqBGjsxHFbkPAxwjHnk	1
6161	2vb4Krpoqc5PSQvzcF5eQgvLTmwwA7EBkommSu17TCtWJnYU5jJq	1
6164	2vacQP9FBVy5QStnviSrx7VrY4YoTayLmkthvb76dbManVAY7fzG	1
6166	2vc553MrXVEFCiPjxDCgPeLs7KQrLDtXBigw4NekBFp1NrvoeDPw	1
6169	2vaeY16RwVXC8Bjoi5aEFJAN13YQiw4BWQZXPjntPaaB7W1rARFR	1
6174	2vbvdGDTqSKj3XD5tfi4Lq4Y6BebwpnfSFGjVNyGEXJFsoCaLmVE	1
6177	2vbsVHLfBckRTd6vwDgHQaigv4vnk65XKC1wEs6KxYHVPYaBw8XH	1
6181	2vaFiGkqXrEYNNarr6oW6sEAhMTbo4Tt1XkWsSJ5WTFtXXPXjpP2	1
6027	2vbT4S4KsHF1Dfch9kcw5zvCFe3aTJtoX56RnHw85mmHshKEU433	1
6029	2vbXZurvELNcDX9PbnXUYcQbybCKiGEf8qJX9nnQg1179KUrgTcn	1
6033	2vaGTw122QYW4F3QbY3ETRc73UccVk9HptGaoJB2ajKt4tj9fHNR	1
6040	2vbbJqRFKCPhaA9GcpzknRK1Ff9TnyFK5AnfS27EB8jrmcbWsyHW	1
6042	2varUB9Vv1L8ry8h2EMoePykbvmLjFtUYjwxGppKvSzThW5ZNWkR	1
6045	2vc2UqzFKpCdnLmupvB2iWYXqG9Um2Hog2giJSwetR2RKXUMugWL	1
6049	2vbsmYo1gCMHdRoh5d363eEsF6gEAaPAcvpAeEXtUpdsAjnqwfAi	1
6054	2varNmHfyNg4T8sd2NAWJ7KjaYfzbpaTHMkoekFtBYAKJGYjQ6EV	1
6059	2vauEBU6DdPro5AUQiTfpvxMkooHj3whXoLf3fXjuWGPdUnDW3iu	1
6062	2vaZHU4ggiCQefFE1a3SCuLmyTUKGs2ceenUQtsU5qAjXPqG4kM8	1
6065	2vaX99knmaiiiKUHeuKL48hpxuYwLBMK1ENZ6ujSKAwvs2ZnMsqB	1
6071	2vbHaSdxyDZSmt4KGBoD17nyroc7Dr82Y8Gksywhq9iktzfjZtoE	1
6073	2vbaqgPSfMKeV3s1iiYXXgJyzJHZUDQf5tNry9J6YGLZc8d6yUyq	1
6076	2vbTtmMFo9VzWJjYfVMBdbR4nc79pZpjEp1KYcdanBcHo6FyDjpw	1
6081	2vbCHwoMiutAriJkgzKpVRGoqd2RhHWC4nbeBqc79didkryU2Esp	1
6082	2vaqNDaimECZozuQiwAgVuv5cN4uEFbzmagpo3H6iG8jtzxc6g6T	1
6087	2vbjr5m3cMThSddhZbgWvSZkELoSJLiDGpxhPFGGWjW34tspq3v4	1
6089	2vaUa9dnWVzf1KdxVE8fjAWqoVETvRJzwoWspwTe1hPvdLwVKDCq	1
6091	2vbZx8edbnWmidL5QLmiZ1bGkQdjjcr1cRBNWJRFVggrVCph6bZg	1
6099	2vbbCZ9jKDxUH5jntbhLVW5BfrePQsuz3uEPDdFjNnyRUa7XgSXj	1
6103	2vbDQus3D42LKzwktJ4JLqAPZzCCUHmbAav1zNCz8KTu14Fo9fDu	1
6106	2vc2QjTT7vHmpbXLMZmTg64BcCCtGRZySiUyEd6Q9o2xLgnRE24q	1
6108	2varuAftz1tiWcA64sZgzCyS8BaxzBdVKibFXJFGDL2oBByzScWj	1
6114	2vaKaiDvhwfhsp2Z1ZSYqKQenkXv42QkLsdToD4uB5NouNKcnQje	1
6122	2vadR26MfVf1chgz8PL6E6U4ZNDgHz62GMtCZSMh72diMCcvPEQv	1
6126	2vak5DDfhQXqRU3hzSKjbZFb5TYsVAnkdJSiqg44y971ecQxqpdK	1
6133	2vaneieLEw7ddMEStMKPYyaz1C8hxZa89NtzdACV2tXWg5uKcVq5	1
6136	2va9obhx9V2EfwWgRAwMmxtdpRJaVWAQoLTstmgw9yokBFR4E2KE	1
6139	2vbFY9PrfET9Jfrkw5yhGicCDBYucTDnVTtrMQZT5eeujNGGdZGt	1
6141	2vbHN79gvwJSWi2fvoeMHo43NSXjY8mTAMWv8gkSbtJ7FEBGEVKH	1
6143	2vaKumBxCZvR5pxB5UGYh371xQ8aKVxpLPduttfPquCCRH6PXned	1
6145	2vboJhcN36H6hrWudRqPftaJ1MZ2w648Cb9F8XGoHSiBt4ubSsHx	1
6152	2vbCiwPmfY8MztfgnthgAAxsydDxMMvrWgXTS2fuScUMXUvWpJKh	1
6157	2vbEVXSi87nUQiFvkB7PwYY9HRu11rB4SWjd4iXA9CxYLZQHnACQ	1
6160	2vbLnALpZWZzGheZ1MGNaX9RGrr7VRfjyARFTajq8NVh1yMyXYGu	1
6163	2vap9hAi8jw2HJiw1hnuiDRuxZJF6zdsf3VXrxngZD7EU7X7WxhF	1
6168	2vbkMeHHc6mfwy2bxEjKHrde81FfH53nfXzMvYNxhJZizoEa6f8e	1
6170	2vaanw41gHcbU1V6fQFhTvdQbHKZMSrXMLZbdWzjDGMZYa7u6ju1	1
6173	2vbmXUsCDTTkQhdKcrUMJ2aSczpQruvKP9AgCCzfW1voYhZkKRSh	1
6176	2vaQxuChADH1cr9AJAPEaFq4rHTuDiG5CLYCoHuA2hdupJcxuvyT	1
6182	2vb8N5vjJBBq3pGaCRemEcYavp3v9GDYuxyrKPG1tKcHzvoEsYLJ	1
6183	2vbFLWK3T3sM91zP3wxSVAmWTCF6gBPDxt7uCgXqBAke1TEhcER3	1
6184	2vb7REA98XzpKo8taNaxh5WKY9G5tNdD9jxJikJvzNw7RafnTDQN	1
6185	2vb3TZLnTXd7qRHkdBjuRpZbD53wtXi9bgRRZ3QSAGguqKJAJGx2	1
6186	2vaLGUaiYgMMJRcoNFbvJRQB8sMqS3LAgXXcV8YrEfxuvR7C8byE	1
6187	2vaHnqZyKfnFG5kSBn1AaQamCBMNi9d4ZTCRAEkjds4mGtZvKpv3	1
6188	2vbZyyTj7xbA6rt26NZwwzrbXWdTK1hS4MTTuwJoGZQSGbfLLbaY	1
6189	2vbim4Wbeq5eN1i1HDnoLoCddPQ4B1hVTEW6otK6jSrwNPYejEQB	1
6190	2vaeRv2ARpi9ckd6kU7hTSWszCEemgf6SBtPGZQJjVFXtqvELg8n	1
6191	2vb8nAeXSskxAprGGYq6SdTnvMZJ8ysf2V2AxdoeR9h2sWvoA1ZR	1
6192	2vbXH5G8JNmhswgt8VjWneTjn2z7eVmGHQaZdPRM98nRor9krBY2	1
6193	2vakLuKEqXaGiQqnQ7oJsqDmAWJujcYLt2PMkaAE1HV6SBsYjF9k	1
6194	2vbbzq61i6R5erV6NHFQGpxKAeG9o5tTHR1rz8heUG27UtFv2SoF	1
6195	2vbNsSxqzpHJ9m5stVZfy4hvch6a1g5DtGhysTVaDZjLm465zBsF	1
6196	2vasNMksRw6YCHu2DbKo9m5rCekmRebC6RePYEJKYP37m3eZ7M2d	1
6197	2vbbSUT6hYk65ZCWcyyhZ9g8br2oiGowScQCHy6QwYCSf6kJyCjL	1
6198	2vbf6rn8E9T7KgE74BAYPjpUVcg6HrADiGqkLwZn1imKv5veJdRT	1
6199	2vaN9n8DaX9spktbxNbxCyqH4mzSb8s5pndjZ8jGZZxSHvAg1Yvt	1
6200	2vbEX2QJo8W3oJMR3M1bEf3MXRuaJoW3tfbNfB5zrLmB1MmUgBqa	1
6201	2vbzAwRz3pjo4srfXkgFD1JCkWAPWDk5aRWLvRx8eTJZ6EMev5w4	1
6202	2vb8vg3hiXwc6MNs74G99SQ6JdeoBPT3KZNU5h554rqsXzrfNeKV	1
6203	2vaF7cAhJbGQCiDMv5bVUNFifcCze2jeuXG5o2pvdFLSNDuZH7qu	1
6204	2vafDucyS4Mvb9kn6sEqUaAc1GjjuWr8Vgv1qCH1o9UpVkpTdqYA	1
6205	2vacYaqm4P1iPbmggsvTXKo5cYt9R5Fzxu8jrbe55hy7XdFNA68M	1
6206	2vbwR6Hxokh6qcYnPmssbJRo4GrfArRxhkQiwFzDJfW31WaTamFd	1
6207	2vbxrgCDzSeW37eu8cVj7DdTG73LeBjvXDakv6AX33iTPsfmBy8Z	1
6208	2vbdCNmmoZx2jbj2HFBBvLjubdmpqE1fefjJhcUCqHXyUZj52CDF	1
6209	2vbnpSVcHmvSHpsZwpNoV5s4bHVBHMRG1gdBsbD65D2NB9hfPg7j	1
6210	2vbCeCWG8b8q8bCiRda6jVVLQWb8zbTzzPdB1x7S6PXwDS72YZzp	1
6211	2vbJjkbNsCtNdvJfCRRhz8b1xBSEDAt6tTv5BGm3XATLR4Y2xkjY	1
6212	2va9vXU4ev1yihFLhDJkmwCD1Uv5wq59MVZSev5T3HUdDr6NsQHs	1
6213	2vaLykeaeFEiZFfstDNX4BesKQewT2UqsmQbFGRjpqZJyv5YDfM6	1
6214	2vbk9BNQpBvdMtie6KEPCyEnWtKn6kKg93vpvT74HY2WM8jmS4j8	1
6215	2vbvXbQHFLx6T6b3rxJGUYNqNRxs6Qan3rJKCuV949gkyKQkV5ai	1
6216	2vayhjB1AHyTxgoFwWYctQADHTEWmHBLKdytCPVHohctnd5Qv8qM	1
6217	2vb7TkEQQp72585UPNknhb6xkLSwxdU5qSjhubUDn6JZjez13MPm	1
6218	2vbBH9krFDtinA4Nd3Hio2XGDFcFnkXom83YdBN5xJrQdtd17VRt	1
6219	2vbYqPRkSQpqKjgh6TR2sbiHPUdFxje19bRaQkeaVaFqUFAA5X2H	1
6220	2vb1UbtoitUqAkCEhMb58inKmbVrraLLv8nt7rrErjrDkdKmpDeu	1
6221	2vbZu1R1e8MvZJUfzsLheDdkkn8EbkdRtYfxrzwHjnyPsEqGs68w	1
6222	2vavN9VD9nQprRDFz2pBMUqgcKzxQUFzxdzc86bCgL2GqKyY3KWT	1
6223	2vaKuw5UwL34aUrxiAtaRm1By4s7QghiEorWgNjVphemw4NUYw3P	1
6224	2vaHavPcVQRBg1pFajnSKkc1bkGoLN6fNvTPHyzYvW4BeJih7WWm	1
6225	2vas5vhcu6rw4U9eBnZXPA2NfF9ZZWsQJCFM5SNkTTwnMjvHnywL	1
6226	2vatNhqYf8feNneDeL3YbtdMPCyFAE5vncWdcWPn3EPpHbApKGcK	1
6227	2vaUZgDJwss4aaJyXpm6ptAz8xFEErHTnofBP9Y23ew7zfWWpcHF	1
6228	2vakFGef6XAnGXXbgn8DUUn1EaaoRaUjKSxdBmyxTHWyKMEFNCB3	1
6229	2vbgBeQuaJXj9hjWA4628tQakGe74zZRZ7HvoBUXkudavA6VSVuY	1
6230	2vaFqSW8bAFwk1tEz9NFHdevdsRWBvJSZDqFgXmrM4tdbLwV1bKR	1
6236	2vakWsJvcAtSqwnhncJzbkZhfgVr6sibv2DcJ12YaNWBLPHSpcgW	1
6242	2vaojNPjMX17JaEdnMnatfsxkUe1Hdh7Mn66knpGExbSf3T19VMN	1
6244	2vaSRNEQwuELWbuPh88tqiHQx8TezNf2o3BoEBEdpU6c5GYMv7K7	1
6246	2vb2R9GCe3GpXT6uZBXtUtuSyNyzsybrrRCJ1ZgaR6EUXGdEAwn2	1
6249	2vbz6osfGibHwZWpswU9JTRQBwVA8g7ejUKYHPZEjykfE8Bg433f	1
6251	2vapFhSth3vGZF2DqrmEnx8quikFjA17onCyPDhCxEhKALYUYYzj	1
6256	2vbAJcyZovErCbDa2wCj1rMroim5DsUobwozRyW6BKWkvHc9kGei	1
6262	2vbRbbXDVbLkcsT9ANfwtMEHVUC24ydNHmJpwERjKs4gbrW8JyKy	1
6267	2vbwtUayBMvcxUW3V4p1iDQFCaKRfQwrCoQdfUbRZ6CGsaPLHwmr	1
6269	2vbbaj5rr8Kxuf9NffhPUeH1hRXdZsjNCSCUgLqBkEL8ENdi4bn4	1
6272	2vbXTGfdtTcUcdnhmMZKqF8yyekyoqS7PbVaX7o6sXfhph3sfHKT	1
6282	2vaQK7iv9pirzjGeV4iNJxxpggz2ZRp91W91roxLKJSNpxwwAX36	1
6286	2vbGudkw4teZAxbMqxFz7gwKWBtct8fY3HWKisPnXDD2GrqmvGso	1
6291	2vaJx4ueAVpKbocBFF5NKAJanVB4rKJ6MbCLkMqcMTQijYKT3uB2	1
6296	2vb79dnZESUw5nW5M3vVaMaGuPupwT6GuAZCcnX9SkF5Z7QfeFNo	1
6298	2vaaZW7amgm2Ff7cUC8bYdPGVZzakMJf3v1QvBBmuQSfdjsetMHg	1
6303	2vb4ZMiUaKryySgLTzx3eJFW1kt7W25yhrsCsPu4xhGeGkDfKiUn	127
6313	2vaqNs42ME49X6VC4K3strrko2v4ijvAqm87HdGaaKCUsuG1rEiJ	127
6314	2vbyPAspdyeCNWKMhG8dNwbDg5CiYZrdg6rTYFVYWnjrFtZ9g1LU	127
6316	2vax3GBWJKzZXego1h1AMj37tNpnstm3UArGxgFd99vNw5ZTkeQN	127
6319	2vbAC6N8BWKbL5gos9vW8RQ3woqdiNHsKamTNREVo1trnms6wG9K	127
6321	2vaVeVdzzN82TWqTWcnMKEtxSNAu3m3ABM9UyVRWitySnhcWyZun	127
6328	2varKSfarMt1GRWJ9MUpeYoiyiShGX5LdnRFn6KHaW3Nxg1D4jwT	127
6332	2vaNgJcyJseyUcyRcZ4zgVuQYDDa6sjxv7wcr8rwPs7KrcPa1vsn	127
6339	2vagPZ4ETMnCG7yjEbhHEwu7odV3imeTxbh5dkzhFGB3FGUcKu34	127
6342	2vbjRYPGXGLd3hwAqXA4qAEycsC3HPZEhMva6GiGWzWiCd2x7sFE	127
6345	2vaeHGhzLSqV4cwTWEhnudeoX4zRCaHdBgLZSz3SRCXsqnteXiME	127
6347	2vaubs1SSDJw8hwb9QHkzchWJburdq5nxFkQGAy6NAZ5i7wGCZyw	127
6356	2vaj6ZU9cgpMnwpVs2qfAMU6UwM5Eyrdh4VioGmzqThzf8goXwPW	127
6361	2vbgTBn5iswxUwggjzuEDmadTnoNDsmjoKAANYiJya1dRW7migWU	127
6364	2vate9zARWMx9J6MCXnTKKE6ETAQgAQVpgm5Z2BLCWyhWz4z5UX6	127
6367	2vb2Sd55b5Z52g6JrnxsrZXT3NnquY6meopEtJsHb1Em4wNa9orY	127
6370	2vbYrdwWriGStnaspzNdddrrLtQnji46FSzvkWmdYzhYt18PKCVV	127
6374	2vaQbQUv8DKYZURahdtUnDbNbFQNBKc5eX1EmoAvSYHPszd1PeYZ	127
6378	2vaZoB17Rn6ut51AXmDdp8CigxgvEiXjaVhNN2znkQ7aC1FUEsta	127
6383	2vbS31wMq5hwUzrSjNux7RSpks95cojXg8WXgPa9EhshkWe2bBxa	125
6392	2vbkhvrnvFrjz8b8sDEs1YUe1YJG28ECgmHAhNcid3HuSidbvSGT	127
6402	2vbwBvqnuRNqVALi1XtNaxDHWdz6qBncouCUYSKJo8bqJ3WFvuvq	127
6404	2vc2shLF9kqFp1DmaTxkRepTnCw27R2Bzifst8PVLw9ZM2g7vpas	127
6407	2vc4M7nbqEaQ94DZCpKqaNGtdYSz2wxkMfyZobXxkLNwo18JCdC2	127
6415	2vbYzJYiLwxN8Gd8kUHoRejCb5wCPFrot6EZZkfUp1jX1y9FVreZ	127
6434	2vbxaMMcQn6s4x7ecs5YvWwarWvVG97Z4rBuQgxasZ3ec9eS17UT	127
6439	2vbjgpYVRajptw9Xxf4ZsCwJ2X1XUoTCSJDHHcVzWQACA2TV2aus	127
6441	2vb18TEVb418eEvTeorSWPgWi5QCD8WYpz3gFSBZ4VkdmAxP6T92	127
6445	2vbS9dfzwh3h7MStwf4jViUkDGR8D3vZLfeBjEPqJ7Wm729PkPmh	127
6452	2vabDXC9j2z4tXRFQXuN1JecAHSgWTqaLnTgE6Su4cw2LY5k8CKV	127
6454	2vafVyjPQj265spvMAdaozyJLKCeei4Yga32zYUcbGDGaZ5sPzzx	127
6459	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	121
6460	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	122
6461	2vbdNwizoKz2WwLuszSKqRPMN8F4APeqGqms33JsVNcLcMyQKo3w	127
6466	2vaQ7PpGCJwvzDa3TpGQvdsed3NuLbKsbz2Rq39gGnzDKxtMcwJx	127
6470	2vaXsdu38b738F8kVgRV6SvWYGGwSbV2HkySCj7175JPWrh8qJxw	127
6475	2vc3ndxoQzCa1Uy4eQ5FFL65454CdPKHWPbai5mKRmwgxfo3bG8z	127
6479	2vbWpTDv5PWrebAuP6J3inVQsnnTaNFZDFGeLpiojqsnxWUkcjYW	127
6482	2vbsAsYDuxJVnYDMDtY8vPzEBJJCRVWg3gVC6w1j72agn4knEZ4E	127
6485	2vbDiggC2mtc53wGmBxdiU2Hx3zA7cfrsbgfmTxEETDhHKM3Ka9b	127
6489	2vaQZfmBcw8yxP3jcv69ctxUAmvTbrPAP1tLPwUPMguBgD4nfRxd	127
6492	2vbPa4buzw521f2LvbUBm1figrku3b7LqbEG35dCERKjaipfGWMo	127
6496	2vbJEWsJ6DxSv4WEi2ZirvwtqcLUNXz1CQS9DhvHcmvnyX53gdUR	124
6501	2vaAhmwAKvhBUNe8NVW8M5uiQvMuPXYP7K5qC2M7RVr1yQHKdEkn	127
6504	2vb8waoVvRo9uEunBkdtvCW5RhRLNHMuBgR778GhzESoZ43wX9xr	127
6505	2vb5sXLa2Br1rV6mxaA7H5qCBFNGfsdHZKt7vtWSjjzwXhfQy33R	127
6508	2vaK8Kz4VWyG7buYnsHgUB4rt8w25riLx4voDNEKknrtAWXauFKW	127
6518	2vaSdU9rEkU6MzDLFBU5VpK1dzzXkcDnJCC4rpD2zof93mpejfr5	127
6521	2vaBfgFLdg6EDrXNQygUFGXM4Rn5vM6L3JkdksW1NHqQW8aStudm	127
6527	2vb5HHmR8NT3JtYAtQe3T5S2wGQXa7rZBBhxCe5mmEZMYG5n8fPA	127
6535	2vaqtgDUk2fkU8kxgsM6CdtEPNQZNxYoxQ4NML9KraSafYKjeNGf	127
6538	2vaRPiAwPCrwruwHKYdcBGCNPemQ4myS7LwEPcfPpcpUgKJ6h327	127
6542	2vasQY2sQeKpvovgZsriBErMWkz2KWUGcYwWyH4FL9aqnnjeNGFX	127
6544	2vamSodB2XG7Fybk8fPohrNt3UbRAu1AmHL4uMbSiXp2eCNvZKPB	127
6548	2vbjddDYERTnMe235MzHwzfzw4GbwK91oYKCpqe4tsfU5F6PfvLN	127
6551	2vaxb9UN6LZwyCQMg2hkGJeHTuNtiodGpHLr3USupQdFf42D7Nzz	127
6553	2vazp78z73A3FYahwnxZa7UVGQXcuqG4yjBozKfgfyZ8uiSFJ3rV	127
6564	2vbUvUr5epFUZLXcXfs9iFDVMNvxP7MfH3QBzrHkXdjtZyfkkGMA	127
6568	2vaHzBiz5DChHv1APJRiz5UhpvUzai6yuSH4LmDV4cVCXuohy6M9	127
6571	2vbadasPGMCWwqJwxHZg4Y63apJfvELqApBVzvmP9CbFN2zAGEiP	127
6573	2vbvW8DuUb95j2twncZ8LLzXGqDk7jXtW1vzccQpW8gdRcqekc1P	127
6579	2vb6dGAPi6pJUVfCPTsuE3KTSDkhESLAcyK3o13hVdbZLmFzVqTS	127
6586	2vb3sGubF48k8qjVghNunP9owVuNsp6JwYF2sVGtsfdF97T8UHcS	127
6590	2vbtrPdgwtjhUz6Kpr2E8ZAHKhj5Af4Wm5KfTfm4yCV9VXC3xpiL	127
6592	2vbnYCkyckebCaTZiuEQNFTmdTpjYts2jpT3BE6FE1k4LyD8pJwZ	127
6595	2vaghJCMo3WY5vxSRun69VABzjmx3FjcFbWqKDixWEej9N9DgfcE	127
6597	2vazYXjJeyrYdQAmLwUdu8QUbqBjrbws1CoL3xd8QRYVbLT5h8fL	127
6607	2vbB7EsZ1ZFB3t9EJLzKR2mopKYACQvhmrjvTeFxvEdMY76RAEdU	127
6609	2vbQiFfzBF1t4VfxBRjbmh4TdKaNxGhyYTKQft3pRbVzfNgV8yLK	127
6619	2vaR4aQTz8TsY4bGNTLNtjopNbCDfHKQovwQAsGSqt4dzRN7YbZc	127
6622	2vaXDHqocTrAt42SXLCRC6rWu9ub7YsPHHzknKyqYBqRuAqLhwvD	127
6231	2vbjHmzJa6eQYXhB5pVDZGPbSM1KBtsFqfgQRqRDTPwZcugox1Hw	1
6233	2vaj5TUrUYUWovrxwgSuuR2PqPc8M9t1m8VWbQvmBcZz1dNEjoTz	1
6235	2vaz9dZHCY3h2M4hQfENrPBwU5w9f7tCFNeMeAHcHX54ceQNTg6s	1
6241	2vbNhjRevm6bKr1abdeTvB5ENaYSfnrjZswxYsX2cRBNCwegndCA	1
6243	2vbik9MNtJGdDpGegvW5jvMj73qumkBu5WcgP46mUivgfmoyHqr7	1
6248	2vabRMEYxZgzLZiQh1MFwvD9bnPNt9LMBmLXUMHhGk5UYYs1uGSC	1
6259	2vba5kZFtYdAGQmFsUjsjBWZi51jpjy1ZBt66Uk3DNsBKWcLYv7g	1
6261	2vbX7pZXh1JiBZNh7s7VEhjecNKVYpYvjNng5rgEY5dKX4MB5FJY	1
6264	2vbnuStyPsPcjv5d392nLVktLEWstUqzTzmDJFgf6kScHgms9F4d	1
6275	2vaYjVH6KGhnDNio5Y6qPnnZhG2MLrSWqnUn71obi2kKoGuUKLAt	1
6277	2vc4Eh5QKGPAkttPuAszeeYbGCs29cH6GEtizcT1iAuVmsZbaqZf	1
6280	2vbpjRpUixPpWyEarBoGioXeLe8i5D7yqUdMSZT8AaW7aDHfmrHZ	1
6284	2vbpKceM5qWUHPkgALkkfLLviEPfG6p4GPA4fcwo4T83APzLU86G	1
6289	2vb9ve1pt4N9ovQiNtMJNu5eSoGkjfznMsWUHQ7VbuKrEM8Rn5tz	1
6294	2vbK8EfnTcq4pi9Z61htWMPtGiumEWbBvRZQ92wKoh1eXBE8cvL6	1
6301	2vaMKZSXxYDaUzYVRZBNVRmwW7JwXE3vS3NKZfR8d1aijpZU2t3q	1
6302	2vak3rrudGmUWKRaYLZgnhjrkn8E5sJ5mfGABnyAEmSnfsZrWhJX	127
6305	2vaTPXuxcwBHAoRb1UCx3KEQf7wwYxhQCk6B9yLpKGeqzAqFdtjc	127
6308	2vajWUJFiuSp3XWku2RHCKLBb6XURvcKdmZhf4G1QEpYfCLpNhpC	127
6310	2vbUSLk5QDB8xmVZA43hNdv4wa697983Cduoom86Wjr5Tbp9DqiA	127
6312	2vbUDPEbCJkiiEC1uzaoUiwoTqLJYbfRjtu3qiShpppnhEhGpBDa	127
6320	2vbzHqwuLH6JWQ8tGSvxFDDwEBuzDQpvKWUjVxTWK4jNqcMUnwaw	127
6323	2vbU41s1wC9wSi2NeCbGC2zdC6RWBuQKdMo6fk75jMvsMqHFQFvH	127
6325	2vbTLTNBYU7TCUiiRSdh4pToPKm4nA8qLQjBDZMULskRGBSLNT9J	127
6327	2vbE24pVUe8PBTo4ECtGUErvek9swdcKQW2yDpVc9pvnXBU5HFEt	127
6330	2vav1Rg6TYdrN2ov537zLbR8yB4BrzCPJ4xsi9FTk8vAnNaPChTC	127
6331	2vaHEmyEqiBXgdvKJ7sSqAsNfRLjBphiBwXgKHqRr7kaZXX4fqne	127
6334	2vajP2tRteJKqP7jGSxnQmwtCGbMhcmbvmSefcGqtFhW9mhtAvEk	124
6336	2vakBWhiiJdC2EiJCH25htWyJc1GituAEKoQ9Z41Lhn4jQZghXeq	127
6337	2vb4seqSZAiLV1WDKjjdbhK9sgqKmvtUY3eH4M7LxgbGZU6tEbGi	127
6338	2vaeWoVeAEbhZGFhbpgsYDoWQtYCQUCsFHim34NFy5WwgLzEC3Z3	125
6341	2varXxvadnjo5ER88XDNYcEzDfVUYwMFV9J1eRoVnTGU2Bthp3gJ	127
6344	2vau9je2gXqU9NxYuowC96J3PCZniymJgDxcqXmkVZRMJdNycmWn	127
6349	2vaL6yqaeHNqdSX5uCt383C8TdvTEG8CC42xcTgtiJQVyKxWktdM	127
6351	2vbBwZnb1p3izxegAuVcnGFKBQ3e4y2L1eiGjCsJKdaLi2bB58Hp	127
6354	2vayRhiJDM419uL7Fj15wu9dcXaGBh7F5m5j1ExmANADwF8mHgYL	127
6355	2vbiU7xbkns1RaMevuui36wGjHvu7ZV6ExtBvDQDFJxzXQ1D124r	127
6358	2vbpw7Am7HnGaayrVUhraLobjFXSYebFACMi3JJnY3ABD1ciRj9v	127
6363	2vaTboSFJ7RasJRAZCExPJuNuKMce3JWhr8wnkpJSFHuszmhZFWe	127
6377	2vbbyB5q9Eak59WDX9riqBWteYm7AUxaxwykanZnMcP1i5royAcd	127
6380	2vbuQM3QctXKoWMFw12f7UNra23Sd8qz2SB37czwXrq7rXTmECRT	127
6385	2vaCrxrCUHy7XfDFwbA2Kzg6h5UCgdsaKVL88xmH5y7QS1wAdxAW	127
6388	2vbKGFerg43zBXmWcawXU5PnhEqxqrvzPaGdzjwohMAbg6Sf1h4A	127
6390	2vbi2sw8kBTx66uhphQbUVWGmN9ggG9bzTNsns8qag72hsbgvRNB	127
6394	2vb9TzZqHstfsLkwePAW2yqt8TUkDD21moJS3Y4a3bQZH5ArcQeb	127
6397	2vbHcfnBoFxR2P4db5Pb5y8Wax5SP5cCENbfeNWrwbty1hAbQSLa	127
6399	2vb2wq3WJtmEFv6osA7UueP5PRaSK9qqUzyqGMgpq35RT4f8kCXr	127
6406	2vbDLVtLah5jqmvtaigjGTvkuvaoQ2NDDZFQmVyzqspWwXSq31Na	127
6412	2vbYM88ceJUYVpUVaY9rtdKNcMiKDdoB59ig2CiWmATG6GoJs6QK	127
6414	2vbCkWTYqs5SJ1MGqVvZsjfvdMnbmoNovZsaaCmfwqDzcTXZz9Xq	127
6417	2vbwL689bxHstkB8jQfDfNNWkx9GX7jR2Mm6SJjx1cs8n772e52B	127
6420	2vbi2S5jsdMQBSpEvM9jEJV8VQkxp1Wd4h4ugNTNHp5uLr7BrEPk	127
6422	2vbqqfzy1EMP1M4VVKZ8LJCkZAno66aZazVNQK4rLKvdbwDiHehL	127
6423	2vafEsAanxwVw7sDFwU6Aj9xBgw71ZtbqJpEPadFjT44U7BbcicB	127
6427	2vaa6wLyn7mtm6LL3EddokrY21NJZ2xP4kbWKdcKmFotdJphyEWZ	127
6429	2vaUfPee64YDnwukHBE5BpULRcMid533Vc6pR72mu4ydESnq5H1H	127
6433	2vc2ZqCmQ8ZQbrEgdggwxMCHp5GhT1KjWD51euiaPsHy3AQ18bab	127
6436	2vbYMbu41CTuh2bgWEBXmLCges9qTesmbKHNYw2R27GNNL85Hi42	127
6438	2vbKzB2xG1gotYovtMDPXcugScGxxMGE7tyKHcLTdTq4WeDdaL3G	127
6440	2vbqcj2VTFmvKdQGi7KgJ4oFhvKYnLaNzeJqiqobUJpGhyNdC3aN	127
6443	2vc15kemVB7EAxFfxFtTqmnrP6SzwvVtfwzfZ8eACjksGBCNnB5f	127
6444	2vasZHFtywnhvpk81Upi3pnVa321UF11h2nTqCxCTNhSNoppiC1Q	127
6449	2vbLNXXnjxEx47cKhv3jj24yQ7gxohtBpqstreQ6aAuL49V11yxM	127
6451	2vaFxH3MQ6Y7sNKS4uhDa2S9janKy7NzXNg2GoLxBnJBu42EENyq	127
6463	2vb4vWoJcDtuZ6mwuCChNXXF1jymBiQzqD5gmWP6DfgWtiyjpuVf	123
6465	2vaNCFi2qVypXZWbn8pyScAdRr9EBZ9NByTyDejRwUWPqz2H9rxt	127
6467	2vbRZ9iyingA1PcdgBnnNryecF19Awp4hu82C35VWhK1iKpgqpTA	127
6472	2vbborwMFw5tJ7DnbdZsNgUQfPLVxYGCoQGNFBo8hS1MBG3UbT1n	127
6474	2vbGb2n8PJPEe5WnhcEgeWqtUnzgo1cEzaPKrsdYB5zCCTQw8CpC	127
6484	2vaWNiBt6BCDMHbGh5xXFAG5UfHEFu3Sh9xAF6cYhhBWaCAzxLoJ	127
6486	2vbFgHvB4toAU1MuTzW7HCyo3UXbN46BbR5mDe59BWVXHv12MFMU	127
6488	2vakHqoG2c9EaspsJrjFEnsdWXNN8zj34twhAvgLcn5wuHqtGGQy	127
6491	2vc2S4tKMWT8WEoAZ7rvPJtqzWpybPRsbTSZozBjYqVjtLDddjor	127
6494	2vaj8yErrpNPvHj8Gt9GTDiYzhEUhsqGGXDh8qFPe7C1n8q5rXuq	127
6499	2vaeA6oM8X4srViMrebwuhha22JjmWbngLdFN4LqQPCEPHRw5nFX	127
6510	2vaNpTdFgTjyvZzoY3gp8HPSN6SehpCUEKmJbemHHRcxtWXwLLeX	127
6513	2vaNnFpF7hguC68bWDViR3cHCeAiBicoiVetjTtvQMDfFkB6H7mg	127
6520	2vavVvUGwrSvC2m9k62e4f2bwSeE2rJr7c6SuxUPxqUiDMnUPVe3	127
6523	2vamuzayj9T6CJdTKeEEdBw4GQuqGrgTFEUS8t19Gyh4Hcz67nMd	127
6526	2vabpSaXFcsWgXkM9RzeRZn7QvU7D3YL8Ym5pG7GHJafPadN5UUC	127
6529	2vaP8PGFxGuPb7k9dVrFMJnQqpD6TqsvzhFZw3UaHPsccRXTmBfV	127
6533	2vbZmoRn33cm5vPyoBrE3Cqysvbf3Lop3V8x99XvkGBVGuYxWYqo	127
6537	2vc4ZYPDGmao5kLfJ5nBzXtySqsChNW7XWAU78gd6v7uh3YxfJUn	127
6539	2vbE8NUaRNpekCu2TW5ZLqgTEffPMgrfgR3CkEMiLmbSw5AUFxAi	127
6541	2vamowvAVwvqRXHte795zoPG6eeUtUv1EASXH5ubm3oVbH3rhZL1	127
6545	2vbqmmHk6gKPhpGi5PUifBThiMM6jScJdbThjfDd2jKGedEgembD	127
6550	2vbegf66jAu51gZ89u2xyHp3CgT371pHeWahvWCRwZBWNPftTvri	127
6555	2vbmsaxK8ti8TyuLuTi9t5rKRuhzeqaERSQM8Bm5zxaGhHdTAi4w	127
6232	2vbgMxs4siuWdTeg3xyHJNmQaTMcnwjjL5uE13EyfCvfmkxePUHm	1
6234	2vaTYTqh9wzbLPSUuYRSCqPt8AukEoK6jnMq1VmJWPbwcMmFj3s5	1
6237	2vaD9C1in2kTBv48xNStpgfXYkGAFNp3SbMQsFVKJkizJwYxD3Xx	1
6239	2vaj2NmXz9YMkGgvjA13zSyYkfFimgFBTKBmW8kf49vZuTxn6Qs1	1
6240	2vb74vJ47RzvPhvV2wxJPW2pyfFkGYnS53tEdk8YMhPzELjoy3z8	1
6245	2vb6yU38HooA49h95LK6KuAp3gxcx2cy1ogSv2ZMf8MJkDh2VE8w	1
6247	2vbZRZ82gpsJtCsgAEHGQzhi9KPMAUv5aoXq3Kr3LZ8213T26M9E	1
6252	2vaUjbi37iahzsuD7WZZzC4E2gxkhJmQAnAWTo84yFmcUTHdZpsi	1
6254	2vaoD7PmqdQ1K7tziG52jiadNPt4nun4c1eqYMYFRhW6SY4jeCNb	1
6257	2vbKxMg5v76bC8DDv9zmQuXkTM7r2cwiBhn7N847NXru7eb4fKAP	1
6260	2vaiFiXb4JyEVKDwjS5PTifuWy2WyqBncVX77r2YxCovx7mGX8SP	1
6265	2vaPiJHzo3LgypWwmDKBAq2R5n5srHkQ5Bym8PgANiwFza6tvWMB	1
6270	2vbbzXwWyrcrWkKKhJzQnCwTWWAjFDe18Er4vwyWgBAWWgZPHUKZ	1
6274	2vae6NvT4Tj57rerkvTWgFuqGgxg3SmweRA1F2m5u4KiteS1kHLU	1
6276	2vba9FkBb1rZgBg1wAPUsbWs58MEUvGrrusCSEagrj4tqEBsfmdt	1
6279	2vbdiWvAjQ3JXLqyw2fJXh5GZ8n6PxL9cTcWBv6156e2ggy8u3Et	1
6281	2vahEqHW8sHVCsDo29tut3iKDbhoNoPUseufgWM5CcyAu5rfc7MH	1
6283	2vbA9e5gPhYgNYtuF2jHzjdi6gv2zMWhFBFpw2XY6dgBMJoWhZz9	1
6288	2vbySvGrZEjge6metgnzUNJZtTkrp9tHpLaNcE6UJoVY64ibRs1D	1
6290	2vawJZjBDGhwdmx1Qp1ooc7TMKkWCpHWQjBnHSjnh3ww1vpEwCps	1
6293	2vbPnZqWHNMoCJbPQXSz5zEJYQ3xX5CzxgK2uH8PPvjfwBEej8km	1
6295	2vbqEkjTi6c5myZUnKricqXByitY9WBvEijys2ZdDoyMrA1yGaEg	1
6300	2vaBi1ZufTGhZKXsf9LEoFYWxXzpVYD1gzdWj1PJCUc5BAD7xLSB	1
6304	2vaYHjaswZy1zCV1VdBudVU9i8bX3TMoamNwwVdT2b15xwLuZLzn	127
6306	2vb6n8kBetHSCbRuMhB9A85tFPuf8GqaSMLCta4LQ7PvuK91cMFg	127
6311	2vai9ngPC4h3ggELpEhvEPPRkAzed2swM7MToKphXZM3W2S2q7GF	127
6317	2vbmdUGrgAK2m8bLMDZpezPi2sdYx83qmH81xJWfdUtQKVh2dKnu	127
6329	2vbJySGMit3JBYdFmWjCqr447gGsm9TMAkbEUNnxFejV8ZVC6jxk	127
6335	2vax3qoLJo7Xhwn5eiDNQGzA9vWMau9QmEyPKYDqm7knFH93LH3z	127
6340	2vaDgPjQNmPvgdr3L31rg5FwwWAJx5rKVLE4jnFN1n3j6PB2kEme	127
6343	2vbGxLLmoXQou8xwrFLKkC3icDE7GVtNaDv3S3qQcJcYCHKC3CvA	127
6352	2vak8YsuFBLuxmmi1rrLmaGcsqHBm33FofUobDaz8R8msyarzUCE	127
6359	2vc4z871NWGcb3Hb16ANzPgrFMKwyw51qAujvCBGyXjd7ZdjP5yP	127
6362	2vaFUnUMMvfvg7BGafCSjvsubDjJexQQmGUSYXRpjtpajc9pPjk7	127
6365	2vb1eyNyEoUfQCy53nMgHEE8wqkb2m68MFcqA6sze4HP1R7aYuBQ	127
6368	2vbH6wBp71rGmCUT5Bg5ZvQAGfRk5WNMKX1ccD4fF9VDto7r7TPA	127
6371	2vbTZ2PY4jrKKeLXwpmoh2znFmWafFfeEYhjSWPGzU79JZLVAbpZ	127
6372	2vbQjqXVYXpyXy9g1ssv6AaDWderQzSSVJyA6tJpkmAGzmhbx276	127
6376	2vc1NckreekDLoJ2mqxjUxabBygf1c4Xy9P7d1cdvqbEH1n3DR5z	127
6386	2vbS31wMq5hwUzrSjNux7RSpks95cojXg8WXgPa9EhshkWe2bBxa	126
6393	2vbspNhthQau7Au97MpBKfZf5Puu1DQ685Ebi49dsupCYB9kFxCq	127
6395	2vaKbjfwyqc4Jc25yT6x7PpDVf77K6tgCq3ykTdkrXvSPoq8kqiz	127
6400	2vaL2vpuUUXALJU5UofvknHA7cqykaRtFGzLZ4zNX7VKPSaWVHji	127
6405	2vbnjriF12A7FjTPHbyNC8pbbp6eKcLmHyYKFqRi44w5iRJfc8My	127
6408	2vb2bbLsvPhNrzw1g7zaEBXsgWub1hh4EjUf4bCBBVYAcnGysSbL	127
6410	2vag4NuejBYKXh8gs9gsvNxBR8W2FNxLh5HKzEY6ihism5YwGDhU	127
6413	2vb84dJzod8d4KiRaPw72oHuSrZtu1pEjRPEh52TfhjwgGgHqMSR	127
6416	2vaHTGUUq5mAmyo37wFJQDSkhaWhyvkSPh9VYxpj3csi47gbbfT1	127
6418	2vaVQcShAkuEWXySnqFKs48tcbCJL75RUxG1JhkyxVJiEsQChgPR	127
6421	2vaMifke2V43chvhPKw71y159Diu3myTeoxAP19Vv2cqrWoSYGrR	127
6424	2vakpdTGB6ruk31msb5cp8vvQvvggPymu9af735nRLuFAWfjEwF3	127
6428	2vaDa9CrnnqdNSgdVdSQNr4iojELivxkvEdrUjgGjqomnB5VedDD	127
6430	2vaADbNJ5RuqCLpsnJsnghm7QDe33oBFwdKAUnzugdAJS5zBnDBG	127
6442	2vaMAbu6CDSQYTDwcypuKBmpyTU5k9j4EUq9F3M6uvuhhGjRRgHM	127
6446	2vaAQE3Zh1KTbyxd8tkXT8ShVB67EudroRx7nMRaTsAMzR1gBwVb	127
6450	2vaysXXJTBPtwM2BrMRJaw6zH2JbXQzBhLS4eeQB2vswiFGvfDVV	127
6455	2vajQk5pH3FwQQ7pmfr9rLzc6VxXJV4dLZ7CzPuNXA6P1uyi8Ayh	127
6457	2vaM9UrpjpykLvqUxNzVBdZEDPqku5jfHYDveEdQdJxwi5qrXLWq	127
6464	2vbsoGUPqpSQPC8AC5pjrLzJjK1CQxPhrcpjkYCwKnMYYQmAAk1K	127
6468	2vbsVTP1v7dfxAhwjZ5YkFZYsumjys4dtthsanzftshLmHTo1J8D	127
6471	2vbSqyJfF1ggLGLqkdTS44KtNs95U21pBrCtrKS3gE1vi1a8xA8d	127
6477	2vaFp98JXf47AmtfUVmR6oYfZehY2Jrdu74eyzo8AY6TCV15RkJR	127
6480	2vaZWjxJR14WThkD5pQNn2Qf2EGbLo83NuFmrciBnTsoEYQRQTGP	127
6483	2vc4kaw2jGJVzM5Crk4a49rnU5BhS2YXTdShThPA657bdq3NxS22	127
6487	2vaoKAEY26ez91kgPt3h7usoiqJQfHazGddMSJDDDSiRGnLeV9pv	127
6495	2vanXY7MjWfTT58JvtgnYqf4xaM9mubwNEBMjANzqqNQ9LXRAr6Y	127
6497	2vaZ1B257y2D5FEn5N2mQuwet9Kfxs5buJeZG9ZN8gpCnaS58ewp	127
6502	2vc5MJhDmBVYDoAmBrh14z2Pg2nD5CM3UyyX1WpKYKfFBxtiR12T	127
6506	2vbMNPrzapPbuzSPA2B3vEc6tN3oTLgVy1dQ5Arc774iDA3cSrec	127
6511	2vaeZmBKkd2wjdZ8tjJHmhuRHYgznBZLFmhNayoqeEjS5iYnqzHb	127
6514	2vbjthvTPX5yQXG9c8WE59yLMJnCBoxmbPjs6L2Lo4TNCEf6BU8E	127
6516	2vag5xsZ4a2KJp8EAU2vhcAfvtsQjV9d7A4LvZvZhRqAdH2gM1ng	127
6519	2vbBXYMpxWyCWxraWVS4i5K3NXUYoJmhXdjCjpgtNQU427ymSaHD	127
6524	2vb9bW3i59nKavz6emZLYKR5ABMTFqLgAiDe3WDick3Vrg7PXC8W	127
6528	2vbY9JT6xHC5oL7eX1E18iqNJcGoS3b1w9nknqYsGQJxMquznSpy	127
6530	2vaJnVFd3KL5nEScT68Z1gU3tmQ86saXigEvHUUeWUJ55NUM36gN	127
6534	2vbGB15WQHquA8k4uGLeMUSQA9QR9wfgQofpNwkuJuLr6TYTdouD	127
6540	2vazUvkmeThp3RGUgVzPyr922aUeNxmSAF3LoAoK16tFZ6vt4WBx	124
6546	2vakS9xXyfmfU5HUwjykhT8norYCuyPhceKQLPwBoLQN7fxrkUU9	127
6549	2vbgfj7md1nh195rwCnZnWXVYH3maX4YZoyjyzSdaxVJNS9HtYBP	127
6558	2vby5ru5o8Zui78cnNLwbiTdxg9Spa515Nt41RXG8xFguss3S4Py	127
6560	2vaFY3eN55n2kiweL5QitnsSoyYtoWtcgUC5aWqGrWtDJUPNzMEs	127
6562	2vaVXBhPfQRZdixYkrsrrsPCttrPixnjsZYMrtjbU7cK7WFFA1Ui	127
6565	2vbPokGtYcwjv6vgXDcaUnRNMLQ6KvG2kYw4eCTtccYq6nVY32Ww	127
6574	2vbsSFeJ4m2YQbWgoCDFDTR81oR1ma42rpJEh2KTn8U9kg7HTQKr	127
6576	2vanfNKm81VZHGSryZyPe7EN4C6dCRq473GEdoh4WEdcHtXGrc7c	127
6582	2vaJkPs3WSDUaBnxorA54HFsL9bgAxgj74xyvsNyWZZx2ybvRQRU	127
6584	2vbGpGCkZDyEx6GhSyL5mEr5ofVmiGz21MbfKoujpYqfegfy9im5	127
6238	2vbfmbtZWfdTycwmM2XjSSZ5JXdU1TrqFXjLg6zZbDq7zbTUJ4Je	1
6250	2vauPA87dBpXbhXvVpoQWjWQUudMQr1kX9PCtJS6uNkSh2pKkkQ2	1
6253	2vaJKLHWMvikCoqnE9pfz5wYymoHH55UPFEAb1tWuP3bwRdyCaoi	1
6255	2vaCVsNoyVAkoDcXFzVJeTKdBfcvzw8WLRjK3hVhn6awNHrmLeR3	1
6258	2vaifebXRAyFB3VnUHVVb3V49QeJB3BJ82RGht6CzriMUH5qfN6d	1
6263	2vbvfWSZTYukeBqgL4sNig9LXUBoUs4oaCex9dLhdjn9ZsK24TPt	1
6266	2vazYXJaaw6etgRrRJP6eckkATURPcvmM1zWn9xbWdz4XPpBM6Jm	1
6268	2vbBhBcB3XBqRbh7tkSSqhsFyV9D8vmcq4BCjBXLLGQCDEahWBCS	1
6271	2vbUXrtoBHr7YqJfQNXELJk5wZgXJFuuhAher6dPeXYTQrCuKABs	1
6273	2vanjByLZ4vu83dQnj2Df75PMahkxiaCqbdt7XmNV86CCE18Y7w9	1
6278	2vaAiabzsZh8WwqQJM9LjjYfpHtQwYqi2Gvzva8h7wvgQ2WcAa3G	1
6285	2vbmkQnXTrsf6S8Gacfx6Msd5yUx5FjBH74oTPEzKG8ASHh8gExX	1
6287	2vbQL8CcCZU7F4TfiHnUGcoVhPeUKcT1qERMatKiBxZVQVrdW3xi	1
6292	2vbRAXqNhznZCYM1dHq3ryepBnivrebhb71DMaeRFkFuYJ2RgDDZ	1
6297	2vam5CG7yXD2Upip1JCbvDkiiWoXv8NF9u2DHFYSRf8w4Jv4nwzx	1
6299	2vawipJmuBM3u65MToGRXFFVix4VcL34nfy8PsGXJWi8mtWwC22a	1
6307	2vaHcC5BedicSLYUFw5jdWkWSVYNWr8PYDyd3b7PaeUMGkXN8aPP	127
6309	2vaNGHCQKbr4z9KoyMp7vRYQ2N4UrGxaD3WmD7Bz5C9YXRnDE59q	127
6315	2vbNSx2zJPnrer9HN92fg83ChJ8n3JceWkbRgV1xdwHAF8Dnv3bh	127
6318	2vbS3czyJQupW8aCpaw6nSrQxeaaa6hCdMkzsV3UbmVM2vH1W8Bq	127
6322	2vb21YWoUiZUjNKhAj1AeRh7LK5ZnhEqWetgXYB2RuUXManrG7P4	127
6324	2vahZpjcxgEexh7M863j5AuAb3rmdzTHNAaLkzuYFRujMYaXnwGv	127
6326	2vbdnGUyoPrSTJ6ajVNNW7o1ar78kaV9Yv5W5TZS1aDMtigNezQ1	127
6333	2vbDLSFiFFfEShqARTWzQvVrApSUqpbcwh8gTNqWkGFgDjZhrmDA	127
6346	2vbj19wyPo65ssWEiEefN1VLtNQvDSd7WaF9pDrsY3wLbhnGzmud	127
6348	2vbK4sk69FEHp2ooCsxd6vzCuGoaZFjFrFhNZC12TJpCL9Xua5HQ	127
6350	2vc5ddaV11xD9GKN3wJFi4hhArzgY9URiFVGZzEFonMG1fPusz1q	127
6353	2vaTeW6Wh9iJT8EGymm6wDzdKSr1eXd1irwdXkqHoReb8ExBmXXU	127
6357	2vawhjjug2sWYePrjrzKfrwa9NTGZ47TYSEwyiuUhwEoKKvs4icA	127
6360	2vbZuuKSqBWpzJmqNwgXxqpgJ5A9HoRXdCVX26xYYTwyVvBtxrdV	127
6366	2vaqm7B6bkmLXHDMpfzRVSWjz6N57ATMxn8sxjd7VTWAVAk78q2r	127
6369	2vbAUZRjfSx3kXi3pAgW8vFYWxPfPLYwafpstnzwf3TeVeETMJbJ	127
6373	2vaPG8cuPV56C51Mxa8zAgwnJe6CjuFJCQiudNFUFqVmH1AW4ekU	127
6375	2vacKexYWwcTY5haFYyoeTen9CRUkPmiUng8hnduDCPRYd2qcsR5	127
6379	2vaMVLUexrDT5cmYs6nLw9QkjVkdcCsjTCtRLzXysd2wrfu2GEAH	127
6381	2vaazrogAKGdB6YtryVWSwQZZwReKuuEmSsM3fbBt6DuBG2eT9yh	127
6382	2vaVo4rLZqRz5SJdPuimop2K9bc6HWCBhriSq1tMFsMU4VTujJwy	127
6384	2vaNHnPAGWzk9ULzuc4Mjg892zbms23n6omaEDh4F154K5FEhsgg	127
6387	2vb6D1FEntdopsboKFA4id9DFA8JjFBpyNJTeXaZcDSb2PW2XGGh	127
6389	2vaMfGBrUm51uHJggtTTrBjvnZanLmdnKZXwfo2nx3Cw5wx9PQLf	127
6391	2vbgoj9TvYgm89JtLgJN3Kf6VQpQLktq4fjhkvPKV9pF2B1qv84Z	127
6396	2vbsYkxYezPaxtU9Ti51LhXePB2YXc7iWbYVMre8uahcoWYWDv7Q	127
6398	2vbLAKYntAdMFeyAzwMCYwa9rid8etQa9TUNZ8VgaC3qe71N57jh	127
6401	2vaBPjqk35EsYHRHYKiLW2mUC5qzLT8GEYDG89VatTRSFXus1HXS	127
6403	2vbYUiYRk4Kqi7gQsszZGqt2SyJRsXuYA6ie74ARw92AwCMfXxAr	127
6409	2vasG3MQ6v6DufWTJejDVge7r4NaR3qgqDqTq1B7t3ghQbVzv97R	127
6411	2vb7nPtQxyMjnSqHdtNkePQX7W6vcUkYe9HCSMFgdJdrwjB9AsSV	127
6419	2vaSxqQVgtpardczuzUo6ynN9wqBtUB31uUtHPQ6Rixc7FASHXDq	127
6425	2vamANchimWdjtCMi2oTBT51zbyg6mpsJUo439wyFr9t7nxgb6RJ	127
6426	2vaLd7VKi8yKQeX84Wh7VXEqvQE3tWXr4mDo7eVY1Ejrp5JKmoD4	127
6431	2vbHHyL1EaVK8biE49kzNQqDBgPMFSeQSCg6QXXSfvZqhHeNKqKt	127
6432	2vbYfvNeAScJVWyww7uzgRyUbZTYdKnaigWBE8BjmupTig8ygU27	127
6435	2vaPr4Vaz9dZHY1ruNHVJThUpUXjwPgSTzZ9jnL2eUyvFK4wzfih	127
6437	2vbYzbQvgEWEBwZu72RpiyhSsZif7XAyLyh4nZwtXYfzWEZu7gWm	127
6447	2vabpCz38ZpNQ1SKkRMRi6MbXNSDtviqVGBUxhSuhV1oB63jg36s	127
6448	2vagMF4c9CVXX9agrYUoAQbj1h3aGy3mA2L6XHLhrG7jPmotzNYS	127
6453	2vbRm3AzooTj3tWb22obKFmCBjkMDgStEatVuZZNRmK8YoyuXuTY	127
6456	2vb3JA6viyoQCryqemEc21zQf2RV5V26QQ6tsdXVyNWB21Feuhr9	127
6458	2vbDR9gedJnxa1MKaeHJzGi2MRfFZngRrXFtRfmvUwX11Cp8rLak	127
6462	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	123
6469	2vbumLY12X8eK8JPxaxf6d5vPiNLAM2hC6LrnxHCaR2UrwDu42H9	127
6473	2vbfgckS58AtKNZ8NbpDT6UV4M6JkkpsuhPaqFqJh5RsNbpaLuEk	127
6476	2vaFna3JAu3spc9qNhcG9RAPskJEBJqWvAVxJ8x4YmLYCN1emBBM	127
6478	2vaSEdajjy2mZX7w5kAEQrreNqE9uBoX57XGyyeaobTB2F3niYdn	127
6481	2vbKBwRYVMELeVMZekAEUN9dJbxzKYNGAK2B9Vm7pDaLFxT5fm8G	127
6490	2vb2qtr2KenRMsE9PBf1atw7omCuCUDZu2Eqr6Yhvag46WMTkMSQ	127
6493	2vbYr67RSx64mgVnSuKfzCRBpmWEaWbiAhExpuFr7dnndiU4QkjZ	127
6498	2vbidgphTAkzxAkh4E31x1SkDz4y8ziLtUa9S4QbQrKrWJFsb54T	127
6500	2vbPaWBS93kXvKoQoSfcn4apNZka6CJTm45ck7A1Us3GTWP2Fh3V	127
6503	2vbf83BU1XjhcwMzAcnD7gJwnXKCsBUA9ck9wufRTv28y4YNmLP9	127
6507	2vaJUh7PDug74f1Shg5EZi5zpaeDYXg5Vq6fjEVa4CS3MPvavr1h	127
6509	2vbAoExsBVhrBc76Pdcwac7V4NjFJW6SbXzT2fT7Ud39ogVmJCMg	127
6512	2varqwPHomFT3aGDhU6UFmCYX3pFFEpSRuxXrRyc1yhRGwc7u7mk	127
6515	2vbXUhKi2C1GREzhVYb3Eznw8FpZrH9wq5bXYRuQG1qXKFgFQiUo	127
6517	2vaujiqFpwsRV8CnKgSKscVuYAm3am1t9TDrDgGpRxgNFsxd3N9A	127
6522	2vayZbdnMbF4tsqdqdbGTppwGoyT2pg63x9j6BdBZhdKt46HbvyD	127
6525	2vbeSgGioAAac44rRfXQpKNdDpgH9NmZvbh49TgF6qNRZs9TeKnB	127
6531	2vb7113DbJkzqHBHpKMP6xnSKvyvTjWGMHJJ7QQ2VQqneFeL7vAJ	127
6532	2vaWfadx2Txn68LDVCHYKeMW1WRubS472CijDcGnKEVAS9YQE6Kt	127
6536	2vbL5Jo1DKevmrAGH3vHBDygEkR8cmSkKhEMMThaSQ1sKbzkH8uj	127
6543	2vakgqgv9KGsLcEGGqvZj9219DaLrjfG7unE2QvJDVDiC4eJGYmt	127
6547	2vc1yBvGhdKvkBQz547ESCSB3JH4EV33vLAzy87qha4zpN6R2id4	127
6552	2vbP3jw9SQot67DKX35gkdmCgkNeEMBzjUmSMLc5q7jS3WGRh3kW	127
6554	2vato2LZrHv7mgj5kr2UYXitYxRTBRrCwH8FnAcqqi9W1mTdWcsA	127
6556	2vb4wScB9zjXycz2Mswp2VqzGiRyqfjF1P4ZKWhq43kuygn86XGh	126
6566	2vbknndv2vuZauN1qjK8nyioPYwgRhNpwm8UyuA2vqexdr7baSs4	127
6567	2vbS3T2RBBRQVo1PUiBAcjzCBHw29aW7ZwgBMyoswgG5VgqpKQ6T	127
6569	2vboAcLYru4yzgg8VHJjVuwx9AHqK26nJFia1o9sWUExES3HybDo	127
6557	2vaKxSRzwrWNWm7avzQjHEEd1PKDidKiGaarTGXbK9V8SaFWVJia	127
6559	2vavvwcdfmc3jVaHA5Jn5MfNbzDqWJow1MWTrUnQaSy9SJMoBhW1	127
6561	2vbvbMFijZmECGwTrrG2wGd1u6FshkSDgJnN1U3LC7Xt1FzV7v4v	127
6563	2vbGExdPrVrGigbp7mEwxsjieXJhnw9JuqJiHZ99shFiUr8E3h4P	127
6570	2vaM45A1C6nwXwUptaCswmLT2nVzdkURTgPN5ja2Pf4yqqVck5Zi	127
6575	2vbMcin4xVMS5NNNLSZ2AZij2Y5eSuDet2vgoNG4yP1a3zUnxHW8	127
6578	2vaMgKN7KMXkCgejt5q6tXWwTWwPoH1b3CTJTEcAJyvvCJhJhrGM	127
6581	2vb7EetdMkFGzGCC5ssYEG6SdYUfS92MEoFDRBNRVnNZ88HmeLaV	127
6583	2vbw3hJMHHEka4Cu73w8hAoTyswis3Lb1hjXzQtmRdX74cW83y56	127
6585	2vbMFdhAfHoCjYSC3PyPihsZrPegv2c2x11yjgCg9hSRWb83hE9m	127
6587	2vbonNxjZPA1siao5vLUnRQ2t4LMQ3qpCAXr3uUHvim27XRXbWUY	127
6588	2vai85xT87SWdY7vsCorcg4h17tU8ac8suQFaeaUf1FHgp2raGnT	127
6589	2vbGyMdUH7msFoBXobsou27vNJbey48Q3zQfHjvSAABqzYU7frRv	127
6599	2vaCiKBCpzmXpMmv9S6vLRneqkhD92Xd6Cmxt7qPfvLFmGUCZhRA	127
6602	2vb4uhmQyJSpdoWXrjN2yoijDbrs2CAgvXSGEip5dFUvJtaLc3f6	127
6604	2vaMnqrzcXEBN2Y7VZG1As5M24Hz438JjXinVg93pgZ8RqxsdMQe	127
6606	2vaZVjoFoXJkMkTFHh3dxM58YrohkU6ktLok2Biko3XtAdfy6Bow	127
6612	2vaaisBRgUVENKxbzVBsAuG6uHk39i5ZpmpHdii4YDmKFKa2aNxD	127
6615	2vaouYJAf9cwBcK2ckR6245ifnmXfN5MUeTXKCvAD4LVXjUCKeQR	127
6624	2vaECgR3GiQ22jXruXF45F7RnXESVbbrcno8NF6dbCZhq6rHSMD5	127
6628	2vbwRxfG6MJA2sMk1DHuUFHEgsJTFu44QKq1DbBdX59jx99Ch3F6	127
6629	2vbGzHPxi8v9dhvaQDvwdmt5ReV1tPBvjXXk33mUzDZw8izcFp9D	127
6634	2vbSZyHQJTr7fLyx5n9Jooiik4xiYatTPSAEJGDAMt67VYtmrJUB	127
6639	2vaAkdEmVwru39V264g86dv5vfqHbgf3C72qrpdD5TwPiuHeKdGT	127
6644	2vaANY6yLc77QGmCiPg1KNsj1xFnbcMDuaj8zABEnMQuypGrDMQQ	127
6647	2vbH4dAjj2QgasUVxfhhssZQ4xTnYuGrRwQL9Wt9dEcDpp5ZdS9g	127
6652	2vb7baGjAwAyvyKUyzNXgzrSAwdJgoMwCss3rsyPxCEmVgPn6s49	127
6656	2vbLd4rje8qn9TCM9Ct4nUwWtkZC3jhzUqcFHr4kHrYMcp2sTVLQ	127
6657	2vaQDpwH9PZpcpmYuRaDrti2MEteB6scv74MRz2b95SDxpJFHueN	127
6662	2vb6ZUA1iCvA57qRZVzyfEC2G6V2KRbJEdKyFMoPbzNx6RyRRJb8	127
6667	2vbJ2ST3FDsM25QTuQc6HaaL4MnMrVnWxaBjfYbtzrodtH5NPRVS	127
6673	2vaHNUGpJHKE9Jyg3ivooT7z4m8tPXvf4xYgieHQ8ZRKAVhaj7PV	127
6674	2vadipf9PohCxoaBs9neFoSwz8tfHKrNsYWH61X6MMwcAKxwTpqa	127
6679	2vb5XCd2D7Q4w88KXWPwWPHMZX5JRiDhXDToLzKhGaDUeVgNhu7z	127
6684	2vboK1B9ougBFnDh9h7m6R2jC1MGe42w7HnkSfysrLNHCAhvakZi	127
6685	2vbXUJrb6G2rjD513UVqGnR33BvNPF7yYLM4hWq3aAdVQ7R1s6x8	127
6691	2vbGWQZfgTkHFrPi2BgVQJTyi7kRZtL2zPxHvEk4QaHfsEZp85p5	127
6695	2vb3zhPCnCMp4JoHXZHfEHFrRbY69NewbvXzUSTXuA4H8X6CRHw9	127
6696	2vc3EHX6GM1CFaNRk4qjrkScafgyCWsPkgKb872LcPfq3LmBgsor	127
6700	2vbqxiKjFokmcpF73urveJVDH9mz9b5z5DJSoeZYpUXBLg1G2o8L	124
6701	2vaTHTmEikjisDyJ2L3WahoTLgHRpZTGisNRBme7cEwkgmrVEPdb	127
6702	2vc4cR3ZGd2yjkzcoeZj2ZqruHcFfaDFsxmMU2AgGNHUsej1Awy5	127
6709	2vavz7L7JyBva5BwjUKwZh3MyeCi8DFCSzdXRbc7YoDJT9qrsVbm	127
6713	2vaeMd9shfnQfDUY9s7qTrmsx6PZKMe3SWM4snvcrVNbGfvbfa7a	127
6714	2vbgrVcA6Df26ekn5Rj99tYvipEN4Psp9oGSVNihsghc3HK5UKRX	127
6719	2vaKH5VzQVUdk9Xb3R5QLyJSWZHDLWAHFivpUBh78ZMUK8o8YyH2	127
6724	2vbmp56QSQTekBUqGFu3mj28uxc9SmDqoRHtcfSww2XCPXzcfpfS	127
6725	2vaxdFmDD2Vh4zhW9VZjUvPAURCKxKzjWr223ArcXrfFgoDQehiT	127
6726	2vaHnqqRasi7JXsBAQXWkng68vGeqWsEyX79eiPL6Zp263cPUFNT	127
6727	2vaAsp86yyeb82Zokk4WSTbMbPE1FMrHEudUB1Nk9zQMJtNTri8n	127
6729	2vaSraVchX2YmmsX4QnQ6nD1pAc9WjyWKeDThzPUY6ys9RZ2f4Dv	127
6732	2vbwukE5cHveqBPZyUHLJ621KJokpwpCxBi9aMwVqNsGB9ZUVfqc	127
6733	2vakPucys6ymUWRQN5e14UtHg3rUkDmASJjkRWzstAq1vRk62ki3	127
6739	2vaNkaon8ru94GTLzE3Zyo9NeUHe1o3RnVBLC4eMuso9pwp8eN1p	127
6745	2vbqAVhLyqqpRVcSmaUx9CDWWsw6khU6mG7PovPkA2d2HhaGfjFQ	127
6753	2vb6JmVLhYF476bY4hfKsB9i8v9CLQTzH2EgaBdwQ7NPPiJivERD	127
6757	2vaP5GBYH1wD9AGTEVvrNiVAsbCeqTYhsf7yxvmVkAvpqAr5PuKP	127
6760	2vaAnFYiAmKU2LpFWEW3fCp3DVcKvPmoHqTCpVoG8utRzSgRzteP	127
6765	2vbod4bUcHYpwfZhC2vDGMWKxy528ZEcwbqtKp6pB8DeQ9NqRfhA	127
6771	2vbXQFwuyVYAncWJhPEcsnTwaUG11LCMsMpK9Stj9hPUHvzA2dGT	127
6778	2vazhyNL74UqSmuMc57sh9GY8cGD4WUjrUC7sAAiGjxyjRvey8wa	127
6779	2vb2mD2uaeXHsB6bkK82SpxpoQWQjRG4ve2bJKcEYMTE3Xw8Vpam	127
6781	2vaXP79danKZaC7fCPq4J545CZHPEEvzDWYkHf9bWYBxKaLxymaN	127
6782	2vbTbqujb9oe7K5CimBBe6JZxouDKQEAyrTvfvU53PZmtc6vAdC9	127
6790	2vbZBZaQXZ7N25KJrabTHhKSXu8Xe9dt2u5j3mWFDyYdPxYRSZYk	127
6791	2vbB9GwbMN1GEgkBV17pTJwMMhhbT4txocSVXaDSKkAp6uKReyHk	127
6794	2vbXsyBxh66LaUYG1KD7VFeNY15EfPnk66WzVy3ve68xjTwryiRU	127
6804	2vaeFpbtQaSgiryxzSvoptUmezLWT1Jojk64WTaNUSiijRmX7zES	127
6805	2vbWj8xQyximhoZgH225X8YJWDndS9tVBMo4QgYWPrK3HR3vYYA1	127
6810	2vbxQ344aae7q9TZ7ZnbcQnzDQssAUd4gMxRdEy95wZzryPmiPk2	127
6816	2vaTzQwCheWYGYVBMFZ3Tt8RisKRvPbbm9hX4GVC62Pfp193DDhP	127
6824	2vatR46tskQPS6ijtxw8dWgD3rspMnoTtbawUNkmwL9TyGv44VVN	127
6829	2vc3mFsovNTFAuxJtuCdueRwdnYeCKvLvKsCmdQFv6sPDMNGGw5Z	127
6845	2vatRGNpGhtFTZTRn3n2u6qFPDwZ8tAgvGeaZs6ggwk5ZGLEbtby	127
6572	2vaZGNMD6HvFpT5CqV5rwCvJbNkY6WwxUtZ6YBAsi65KSYQxPXfc	127
6577	2vbXrj9deLiWWNARKyn2CcvSoqQ7U9c6DzVHAhU5YCWKuUXQ1x22	127
6580	2vb39UMVWqcBpWZqUioJVFL87iXzsEkQ2YzMdV8qCyqENP9T2JDQ	127
6591	2vaThpADJv9CSaxjhRfayeSnQ3sZNSMNZCfbfaxAw7qy7kvBJei8	127
6594	2vaCvTns6Yh3sDSdZZAkc7Bh84jQnhR6x48gzCZX1s8rwnGsbmRv	127
6598	2vaNn3S6kv8koGZm7y3C2oG16dBDaJpHB8FmMKNhfm5JDuHdBuje	127
6601	2vc2xwsamBhYiNRc5TvM9axZyp11UUiieu5mGJpb3iNLNwM79Vwu	127
6603	2vaX7ZaAaD4Cdsz2PH1TXY9hu1pa1PLCSy5meTdTmTQqSEoi2AFA	127
6608	2vaMfvofZRyYfANeDV1ZLrz9d7D1n64KFGWKEQx7qbewWK8ASVFc	127
6611	2vaS81BXgthzcTxQanM3smmiuQDWvx8Dzi2mhfiEjDQPku3myVW8	127
6614	2vbSMXM7GjnyCF4DtC9Ev6LaUDuNSoGDsiqu7G5ZRXyxiRDfkjet	127
6617	2vb9fvSZFYRQm6aBTJiDaYuj6Wju2Yyn5Xxic533StiEHkh6MmGL	127
6618	2vaetyw8ewfjZwHSaQEYGP4vfctW1HVc9onHhBCFTT63N5YJurA3	127
6621	2va9ttsQeCzaqUUcFasN7S1MeygPBoWX1ASUo139kJXa9EmhR71S	127
6623	2vbNMECiPNurd8mXYRKBNBuga3baLugVCzLV3oLqkZ5jED7sp73o	124
6627	2vacTJmaVGaM7SRm8jf2kkAwT5mgGhHMxjAHLtLnALsL7gkha4ms	124
6632	2vawxgixJJLs5P7rffcArezphrTquTc5RG3sMeFce6VmcnGBV76g	127
6633	2vboKSekBKXtNUkVL8YfuxtAKsUymS7Np1xHd8fbwXmJVxMopKtt	127
6637	2vaCApBBUceuyXvMzcJwDr2F7HeU5i3AyNed2n7oDUmH7eGxjjTZ	127
6638	2vbpksPkvDVqaB9rRyd681iMzDMMtHHqZLh1B3pwa3TWtR4ez4BW	127
6643	2vbtWL9VZduAizVcYc1qkNaVuzjj3sAF1wBX6cJx1PQf65BguSzA	127
6648	2vaLjL65aukXFNwFPspwTecyECR5vp6SET7FA4k84xFvAuFseKpL	127
6649	2vbxzZ6ei7885aBqyyZS15Ps65AnRqyHoptvTGax64uB2bV5vZfK	127
6653	2vapkMcUkLNYvTZKG4T2uTjAWLyy1XjXNQ5vetJSqUjX8Ug13CH2	127
6658	2vapGwzE5F1gxPQ2PC9gdFSrzmopULkTa5qCVVw9nuE2RsToxTj8	127
6663	2vbULthNXXB3Kb5cb3EMvSHxuMTnajWTeZHYSX6VR7ps6p2pJFqD	127
6664	2vb1E4v7bzMdP5BtzmBxt1WP4kGjjQak4NR6oH13vfgKXUu98A3p	127
6668	2vakvh3zxoprYoPmGmvaCustTiGXzptXQtokE8hU6WBtRLN9cXHM	127
6669	2vbmBMpaNCj39qPTXwGoCeCzcbH78fcnaTgFZ9vuvCtVkQkv9wWk	127
6675	2vbfaB6pNLvmw31ULKyi8Ea9HYcVtvKZix2uGSR6bgr4nrE9Q6Ad	127
6680	2vc1z3PSDrS5UrQJCa2N5nvRLJF7i2aSCu9GBogQHwH6jGHcCkmf	127
6681	2vbJgGWiho54U51qat38K3qnnpC5FPA3iag6K9P317mPczrBVCm5	127
6686	2vaNi63hd13f9KGg69h1MKfuddsKArHDZQn64uQz14KNPtEKSdSo	127
6692	2vaB8MUrh1VphCHmWsLXMgVaacGSJeHutJo5ShomXX9nb4gSMnTj	127
6697	2vaWEojaghE5RCe4fsdcboDqy24djJoKhFk4UrEfQ62WcAUCZi7z	127
6703	2vbgsALhqR22rDt1iTSfwsVVsF1N5r4qzquQsjzQDAkWxEzp3NaZ	127
6710	2vbbMjaL7PNt2yw8rBkCisLu28GpXUHmrbHs9GqDR5NvC5DXwfJp	127
6715	2vbwaEYVec4HsCQyKEZbYBww9jfacnVMAPHQuEFsUDMDF6NjXVXT	127
6720	2vbY9czoo9WDKsW5h6uSb8DdVx2mDTiL7Zf69K3cT9Jap66zXejz	127
6734	2vb7oCPzRVGLcJP7g2uq3Jgp8LLRi2byq5ReHZX3sq2gYfDpXC33	127
6735	2vaMDfokyd1NFaQ8EVKYDA9BK65HGgpM1dmWg2eYMzCL7Du4g6c9	127
6740	2vbn1J8bbq8E2G46cgwu9F5ZLbZ7WD8GEupsocgrCLtxYb9NFmBJ	127
6746	2vae55YDAMN3K9CHFshNkPHCCSZpaF67wdF65eVRM13GN3nRNrEi	127
6747	2vbXcBsWwvR5mAhJq8oazig8YiJQEdRcBHQg8n2vyraaEyHPoHnE	127
6759	2vc5BAPum2PJofYs7zRCHCqHT2k3M9zbuekWXBsigvjwMGXDJAWF	127
6762	2vbsU9uEWTLEyXGN8LaPdzV7LRpSyMYT3FXkzKRFBmahEL8taLhA	127
6768	2vbxhyJukM2bPT8RTogNnHojPzZAghNi7mqFu7pQwTVU9Ug3jZ59	127
6769	2vaR5cFeFwehp4nmZ9ijVTemKjnr7kjJyb4tkzEqwCGBA4WpmCge	127
6775	2vaqjgxdK3kfrVEMRXBYbo9ZQwEQ7ZZ836wwxciuNpZMg5uz6Dxc	127
6780	2vbWJndr25e5iVCzsVXsmxECbZDg7yPtYhGAdRj8xphzg6Ez5fTD	127
6785	2vc2EpkUoxgejgM5MDFURGNySHtFejk3UkjThpBfB5WXxNJEDR1S	127
6797	2vafZKieUw2LCgXKVouJSMVWmYm9zLDAs9hrbWWDc8tWvxNV4Gmy	127
6802	2vbR4fT5XwxgsD6TBc3nEGGn89qqm6Qzp1BFZBoGPEYSEUv55Ggw	127
6808	2vaBvyDiLVPDgNhTFhA6oUW1YaLDU3ZU62ZBBRWUSeiZtbzsEuMK	127
6814	2vaoqWqJ11doX4wmymMsEvo5tT2V5DXQJeUBzARYRnzfvirP6mzS	127
6819	2vabAQbh8VDsHtK4naJNu5149Qw4VBfRnttDPgcF3S5wXVnY5goH	127
6820	2vasygvnYK9bSFdyDvgoyityWb56zTsjioH136QkpZ2BDkzMG7LK	127
6822	2vbj8bKciL871zm1urmvpW3avzBdc19j515TfUffkmcEfcqz1QA4	127
6826	2vbTvGYZezYapA1nHvQ97J5mMPCoQkSTfpQsNWgdLRDNaUftFLLp	127
6832	2vaMHcctzzmtwMRy4qmeD789H7RmyjPn7D42cHUUwkmFrQqknoEq	127
6833	2vc5drjQrPEsvDEh3jJd7fsrSgf7MYVjHGRuMnsqE8RDLqvUR7A2	127
6839	2vbmx3RjM59hd1UV4hZirp14UnbPkZnmLhaG7DBNjb5ce9BzTLHU	127
6842	2vbFbvXLmwv3Eski3b1nNaa4PN88P1dvmq26Aog7trxXTrBwyaWv	127
6843	2vbLWB2VXXpJUCTMuTCiowekGffM3zhrVPQnTgXjffarhUb6mQxr	127
6848	2vbp5nUKXcLCTpA57FGNTRZAug6EUb6T41FPgtMT5QE5dDVejkgH	127
6593	2vaB9fiDLrfitbj7QAiM6Q25ArWXdTwNYz1UHCD24GRdAFZicv9x	127
6596	2vbxYkvHhzJrimbWWnbrat6LYzALy48Fox94cqg64uds8SsgQygv	127
6600	2vaYHayNoQRp4sGntcjfFDUx2pfjs6m8CEDQ81tmQsebPNVBWC3z	127
6605	2vbphW3xjHYzddFCCiGoCwqWcH5AKJjMeinXF6yrRsSSx1wsQJwn	127
6610	2var8B3JTX8kZBzkGMEuaQ39ua738jrDFABC9pt1vQVDmHna2N86	127
6613	2vbeH6cyFMdsxHump89U1Sok9JppvkfFXjCSCw8CwcVML2c8kvti	127
6616	2vaJC9BURE75QxMaS1VFfFLFwVmDcdnmvcxt95c3WmevVzjYT4P5	127
6620	2vbHyfQ3JxwqFqfGXxvJpAJbziQbTTQu6m4yTBfcaKEufZrxNnqA	127
6626	2vazzFWwC9sMwESAQbnL7yysPZYsVy7qfAsHzci7iJSCSu6WLFm7	124
6631	2vc2fsCMk8vNA1QYbs5a26BaGTNFS2pAuSXcXLKghfkc9MkHYyj4	127
6636	2vajSDPBwwGt1zDdbUK65QiB1KeFeFa3TAWeQBJ7fWbkiPcpJMze	127
6642	2vb2GTkBZR6est5DKiackRXwUtp1ejTPNm2a6bDWo5pMGitk5NpC	127
6645	2vbajfYKtLJUqxBJ9KpHfK55by6aBkBQGcwNZYRris1h6zmkQxZo	127
6650	2vbWP2Qo7AgiaAebJteEQ3b4qBwUacuCc38JhGeWgu1ZhKwEByEc	127
6654	2vb1Lnfc36igipucLYeQfPXwXiY7oHXwchCR8EcKQBvkdDuYvfwJ	127
6655	2vaoY3xGjnSj1HCPVSUDg39sKzeW44fs1h9D1Vc9XRsEbKpXNZVg	127
6659	2vaLwCaQmEz3cmhpMFBeLfiDJ3xt4u48Tq9oLGaczR2SqWuEV23c	127
6660	2vb3tcqpaMXVPCcmcfwd7mYkZFLpPkiTQWSsduapyqFGCDGmMA2L	127
6670	2vaxQkKE7QhTs4SYTTvQEFfVAUYmmEAJk6EWEf4NaV8KNBRtFzc1	127
6671	2vb2ECggKrf5Fn1MHJkNefyw1ipdi3dniKohR8ZS7wi6m5BNBe9t	127
6676	2vbix6gF1MRiFArPWsE6nmcwnuWBr9RWDRirxDY58KbF91zgrmt3	127
6682	2vaiyKZx6uDrWn61f2V8ExoMLh45TmvxnUXmVfxKwvzdKEQ6DBkb	127
6687	2vaxRLPeb3nG9cHWR8esN3gzvZogqoPSiHxcTCi74J21ZjMnskA3	127
6693	2vbT9qQpGwi5mZeCnwwP3cQd7fKy2wGvqt1MN2SncZRq4fdb2UC6	127
6698	2vapC8oS8ENxuGfUQnpU8UGqKAPgkYcgWjE6KcgPsHQAy73kaD7A	127
6704	2vb86XCE1obyh18xsXzDJ8m3pNfsWfFka9i7QX235z4V6jBsBEX4	127
6711	2vbS9aQuWDfRpDEMvGxBGJSXUBfhZnrGg1w2zUkb8XHmC9Fit758	127
6716	2vaPuosRSFxMns9k4rXzMyQAhFjebhd4y1F6bDMZYfWF2P6LoiTG	127
6721	2vbHLjZrHJLH56X16JakPBDxWKmi9oVAeuBwWDhkUttZZj6GFQcR	127
6722	2vbKDXJevyy2THxpk2JDpHEJyCyGCeHmrSCMFN1aH79MATEBSBvU	127
6730	2vafyaRjXz7WgG9rTCj1iD6gS7RreG5ZoP6a5b7mQdvUPRmTq2J2	127
6736	2vbPMN4QSiM3qDJc3nwU9Ks9g6xpfkBhefuf3Fhwq8ABvgorWGJf	127
6741	2vagzgihJPHPBKiqtak45GGNyGQvYwjij23y7YMkEZQpUCv9K1kZ	127
6742	2vaZSW9o24V32XSBVSoXrcX328Kpg9uvAivABdaXRMrDEuRV5sXT	127
6748	2vbPTB5GUGjXk5H1RiLJUz9S5WPLRW2vemi9RxwqQScde2tfyPZs	127
6749	2vc33wcfCy1bfrAXZFn9Y6jq3DP51K9fR8U2BfmUA6NVgEN2YvB1	127
6754	2vaE9FVRVjvKr3EhQyMsEqY4w8k9xW59UrsMbC1VVWCjgzwKJLit	127
6756	2vaeSaMCQrW3Pc8sVgp1W1syFB6LtG8edACsjbRSPEeMNgDpPABX	127
6758	2vadVXZfS6Mg3LU7GpNkpjEJpB8uC8dyZcmgdzqwjipkBFwqxY9v	127
6761	2vacnAp2JCTa4MsWxH74X28QB4VLBBpnyruEtbVAxCTUraDiyJiu	127
6766	2vbjzzfMDwU7ee2aJdTPy7dXVmHPdTGaC9EB7Ek48sBHjpZCbGDf	127
6767	2vbPAukAHBEbbFF4UkerJyDkjVXyR1YAKk1MuQv4oLNdgQFCNxzr	127
6772	2vbBM6EMFH4EfRzwUCp6sH8AZbBmzti8UvLkWugdFVCarGASN44B	127
6773	2vbM96i8BbFan9dwMAKqVtAgQZcXAn3HErWmoV8pxmQBX8Kkc14Q	127
6774	2vad8fWEKLSCmVJMJKCBDE1ifFrHFsLjpHHdgp2b6tdRvTpPrd1K	127
6783	2vafJbpAmmvtrCMYMwUFuVWhoyPTZNb39NxtCRzMN4MhQUVnM9ZN	127
6784	2vbiwYEiFja2GSrPyUELpJ5NZ3b1aQEKYqKQUPDpsca9QMYAYVtx	127
6792	2vbV5L6j2VvVJFV2tWKUXDTWLBFuTAZGUNg7vuf16wcoZmY8d5Lu	127
6795	2vaHvDmet8zoCtcdbqB1dKN3fybD8FPdn14RPZvBL55dSKyHKi7G	127
6796	2vbjuQCJitgyZWp2W1UEF8gCwL1PhGYhCyaFtP4LiyYi4qapi2nV	127
6806	2vbVSfJJvkGuSZBiAq7gZQuCh1YeSXrMzJRaqf2abdgKyntu8PT5	127
6807	2vb1gF8ZuNHUhae6pE7ZKcVctszdmiPu5BQeWCNhUMhqLNPw95SH	127
6811	2vc4v3vKZtoA3fiNRrRZXgNRVDfYyd5mgDChLpEvvp3jg66Sgccb	127
6812	2vadetvDGbwRDZ5ij47xgBaqBrV4uWvaxyprhZXbBFkSddW9eMsB	127
6813	2vbnVi7qajgbjrZAGN2zytXwMN9RC9fS3TEbkVedMeTstxS6ft5i	127
6817	2vadVFEmEroYQfWRV1t7t6TthpR56r2g4cV7LUnGJuwM4FbT1Y6r	127
6818	2vaxFZTh9x3zFh24deSsYnVg1aSWrDpUHc3TeGmpD4JNW9CPNqky	127
6825	2vantnRLRzfkwwugkyxJgRSVFadRUyaozuk4V8evheZfvskchWG2	127
6830	2vbXoHRSfA7vtzNh7QgfmY1QH6mkv3StN6rkfYRFaGUD6dPTVMgz	127
6831	2vbT9g17opRzCNpRQvt8xyiJk1MTsZPjVHiYVFYSDgmgWaFPECMP	127
6835	2vahfVbqwoyvDsxEbnS9xYJocLGKVyoLFq9tcVfyE5kezK15uW7x	127
6837	2var9ThojD9EFxWEQwnQEADWx9k19WDpBt6TLo3ZVNYDc435rSb5	127
6838	2vbZ7SGvheKyRcwph6BDaCaX9cySXqLnN7rTZ5h8reLGjerHBNfV	127
6840	2vaNP2Cq41AyDG4TSYecV4dvwRtqxugsJ5tzLjkQdvtqbrF5RuTT	127
6841	2vbmapo5qZTsHMH5HSnk8ZeuAWjEpa9TGtazdZKZKnLgAoZ9BVB1	127
6846	2vbgKRMDmW8PbKeCzUXapy3Fy65NHibxLwAp43byHaevzvA7Fhps	127
6847	2vbnKQ84QJnYyWeHEJHGX6jm9inuv3asX8WAMHXhjDVnNf8ZL3XY	127
6625	2vbdfm5yCvMGgopsTuEQA3JMfSA7yHpLspUFPwrJm87KL2UQs5S7	127
6630	2vbKbUiXX5wYd79PxJd3shpve4VnTPHM7VTvjKgJzGdGQ7L1ULBo	127
6635	2vaB1zH2vwUSJT7fBW2L3gqUAa85zZS2kUtsD5znnNfRTKRs7DSR	127
6640	2vadXhfodPj4HiX62wfETQ7k3PkHwJGurkgqJirxp6EMX6WRbxUD	127
6641	2vbK91k1vgFs4wdKz1yWyTH1ftoshp8mysny5VaRNynQ6yo45u5t	127
6646	2vaQ3NChY3xpFTd9BhxfmGZRGRAVfarvMMQc2VhW63XYefbs4cJP	127
6651	2vaUkr6rJEdjUNuVDRHGWSzFDEVmNLLHop1ZPAkr2Usqkb8cXfza	127
6661	2vb71T6MKDpRe96kwNrQSwPge4iKS1dSzTsR2HGDe8uaKeU2dy6k	127
6665	2va9T942guuXwFSrbyfPxG6QZab7QmXs5Zq6zSH3FJP9SraSftyW	127
6666	2vaoje64sDGWFiZRLv3KZi3jk3V1eVvA4EZSHJAzDUaCjQxrCvGd	127
6672	2vboVRrGWHjWiovwyax95KVC9sjzJwoSn3nbHK3TU5acKxjUdusy	127
6677	2vbSL5J8SP9dXCyhqBvVJ8sK8JPEq5dLfrB9yXV4SgqtgUBy18nH	127
6678	2vbd1ijHWPRr3xt9PtfuY97hZ6BATtyWvbm1ExBMfZnvyCwmgDVN	127
6683	2vaz4FcVVNYXTX9gT6MSrYy8bc4CUTFEYVYspeiz42QreTyS6yFc	127
6688	2vbPSuxUZDQWhxupnMHvDaTBVnhaPDu7Yb5PJKWNBusaD5Tx8Z81	127
6689	2vbuNDkFj9ibsfGSNgGWdmfewHLBAj9akwdRbZdMzfVEAejBAHnX	127
6690	2vbbybeXhvo5kFAjkXm3666VHAQHseFt1dFAdUR3vK68WyGA56h5	127
6694	2vbbiJoDShb4P48yemVBSQTKYLQ3HZu3S36b6X5kWTexLvmWoFR4	127
6699	2vangKGpbHe64KFi9kKNge7GGwrh4pdNskUU3Sf94ow2JPb2RQgj	127
6705	2vbygbnrNwYBUyCC32Jfj2oBpCzYm2XLymnhTSFAfQ1KpNQnTCzJ	127
6706	2vbzEJVjfWYGMdmhfGfQjr4pDgaaBrQss5KjYWx3Aa4P6Bbugz3g	127
6707	2vbfE9aSsWGULGXwd9tD6wrgqTGeuiTX4PzmcAiRRqKuSsRFk7tn	123
6708	2vbHvDjy4DPHrL7bZew9SNLqNvHRz3E7WopLmqMtauWB4Mx75e2j	127
6712	2vaugf3qY2sXqiFqDaZA4oqXMkpw52nbvBLvWQZVHvvbhLibdh2R	127
6717	2vatpjeGySE69mfRnKhjoQFP3BbCtqrMNHQy4HvNpeRKHZBEBH7h	127
6718	2vbERvun4QV6QEyryQRRjQAWQj4jZsSdxPTJgtDfTwMytyTp1Nuv	127
6723	2vbSpYn4p7nh3F1iPhaoseRbKPcDGvDPiCnFdbCSPPAv2ZmB1F2x	127
6728	2vbqw83TBcBHCfAEw4nhYWp4Ks9jXyTJVR9Vk3R6CnK6MyfvtpPt	124
6731	2vbWDMN79Q6TQbRvHYBgbwVGmycxnq39VZEizfToBeRouckJPGQb	127
6737	2vbZ555W16bCQoZ5ZmxUrV8XrZErrp5H8qB59XCHCSVWJVv5HkFH	127
6738	2vbRdQgdh4gfDy9QsZMBJxwT4KEwFPNGrsodcUvXvgn74XFBhhoi	127
6743	2vby8inA8w6v3hqKDxMamoFDcaKy3hopsuAijhF6s8CZpEQVdw8X	127
6744	2vb1J3o3Gvqs6hocuT7TRLZDrT612Ac1BUnQC4DrG6X22pcCpEx8	127
6750	2vbQ3zFxhfXUxSMwoSigeu4mUJENs9L8wm4CbwDTXt1Tob3bUNuq	127
6751	2vaUuGe7KkWJ1MoygJPGyX9ripuMQaU19H2LwwtfhwMmAh14Edwe	127
6752	2vbZSteTcAb895Q1PMtLTexxRmzHEqHY6jjXX4ksG13WNj2oSCaX	127
6755	2vbuLcnu93of6ZzyH8sc3U6yTW6QfrSCRVBbSeYN6jvmiLN6kZHK	127
6763	2vaCvyqQR31frcbF7HXuU3BiMxiTBXnA2oLaiSene2SjzsA5Boux	127
6764	2vbHLe8e3raASm4p6bg1jGPM3u2FJKZjXz36s5bQ5ezRXCLRmdi6	127
6770	2vb8wCnDN6nwBfbenCTticVuft33nMjjF7WXWyjHMiscGh8ywLgE	127
6776	2vbqZdY6dsEp7t5zMfkR8WJNe3gdUfi44oSW6KmffTh9YMxuNQZ7	127
6777	2vapbCkDQMG4E2xwHqGu671T2g39Qg2ScgoiHLb37YCnWsRSBZdD	127
6786	2vbXE2pVDxogfb5y84DCEziWQBCm7hRrHCicQ2AVBhgL1Zophzt9	127
6787	2vaa7j3LCt3upmDUgMFvYqeyDavSiDiE3iDkBVuEVSSpfKJRfUi8	127
6788	2vbCTx2nCtjR5ZthYke27VxipLx8pSw2Kt4jBdWFu4m5RUX5rNar	127
6789	2vaCCJMVbYegM5UNboce378NgYGHBaZd14PD27yUZ7uoNvtWt7sM	127
6793	2vaF3Hm3PwCiuyWWFdv3AXjmFptwwjqecrDNiEdaZuNHiReFSqJG	127
6798	2vac9Ki7Kb75LQQWXWqHiX5Z5FTyFRknmNc42BHarUZZDohRXGWT	127
6799	2vbqSunfpPTgpCJ1yVBN7JSCvsKEETqGFj1hftRcng8NbZFYZCDP	127
6800	2vbPftWkze89j99BneLmmX71dtQuFYcKWRswKpDGDfxW8FWZy989	127
6801	2vbzV7XTAfnmxuLFuX6CvaPooA4iYmzVv6KbktHHgB1bkr8BPdEY	127
6803	2vaN9Jgo6cJMjJErKNMCr6c3oxXuTrwMXpZxrHhtP3jVyJZozNVx	127
6809	2vaL3z3zK2XDnFb6Q4J789PUZRxPSWZp9F8cyqJiXY17atcD46Bq	127
6815	2vbh92vAC5kjd9tmfVzem4Mt5s4fJ7cAxbcC5Z4C9BHpvydtEtTU	127
6821	2vb87pnhayvoYkm7ZZTRWreZkqcfBUKq9bs3yh2eAVi2ABV9Bhi8	127
6823	2vbwVgHYtd6pruT5TW8ce1EDagU1nW62ouD456mGU94d2LTbKX9Z	127
6827	2vauX6VmbKQfHjsvqfcefL3bpSJZh8tvRhf4mFpCFyHVFNMAJX2q	127
6828	2vbbhEXM2AiJ6RMANaP1zWov4kBDjSSwr1mtBqoHN2wV1GfGcsfW	127
6834	2vbfhGW6TNaSHsevDSrtth1BUkoZ7QJ7xUWrCMpJwD4xTWUV96sU	127
6836	2vbmcMBrjQEUY2bdeYmVmqXNeWwCFp5oU3piE2pY8NsDdy2e4JJL	127
6844	2vbdbjK4kg2av3mDpeNfyue6XYg1rqY3YkSPcKnJ4DbTWu77EDce	127
6849	2vc2pmqwkDrB4F1AarguXwWXQxoNWnYf2jwsd3qFtEgE5aZDdcTx	127
6850	2vbR12qDWJRpbDZ3voPi3CkBBuWL8REqbJmJxh21voieXPG7TNnq	127
6851	2vaGBB2AqBgCAzyNj18nYjBGvY1kzXscxqTPzkPdbYgyUwnotHgA	127
6852	2vaqhJS3AA8FY5EEYuF8uzL77vQciA1BsgsNmY5Z5xrwdZaMSbQw	127
6853	2vbWUam3noWFHn8dqZep8puQwtcKcDTJeNpxB7ExJsAQ67J28i2Z	127
6854	2vaoHie78B6sxcSAP8ugXcApr4J7V8pckzTAK8AqHKmD6YBDZ6Mp	127
6855	2vaQDfs7UmucUyfe1SynV6Fc97GpCWZftL3CB9Hm82WSz2543W4U	127
6856	2vbrTsLEdQpWqjtwdpXW7oBtCEnLHtGCPAbrBHbaoz18fNv5DCyj	127
6857	2vbq8zB99rhnY47vg8DkX6xPs3arfrRJn2yJvwV7ckmvE8Pz4vo5	127
6858	2vbNnemXwst4QWM23Xg597tant7qPt8u6yidkYn6nmd4t21qUmqi	127
6859	2vaLtHusYWKgqJ8cmSEAUbymfX5SQQNmNcGcc55qMpiK2WGkR8WP	127
6860	2vbUWbzYNQv7cxeXQK2K9CzmmVXAhwQZQ19xtaNXYuiBZrTC9SG5	127
6861	2vam3RXUEhfr3e7k1gp7fbDceeArSLmeyZKGgJ92qgyTzPMiXP2a	127
6862	2vbkXrV2Ltf57a5j1pJ5kKcaLN2o3ZbF4dspwCnR43EkXAxwGpgc	127
6863	2vad8tpwNpWE7KKNAEVyUagT1VgriHSq8RhxUuAa7eE9it8JY9am	127
6864	2vbsqX2pXLBVbn88ZXfLD9s4UqM7fi42aqZ3LgRsgfkFCx1xR5iu	127
6865	2vbjjEmbnQdzHMgGsbHcrHZANhuZVCYgT3BKoDzN7UZPDp9mkZAP	127
6866	2vbkRp6fT9kYSongAsWJGyiYAzdtMhVb9seNm35zbD4eD2gjvb5U	127
6867	2vbUWePuKbVw3TUX9F2m1kHwzdJxZ2U8PdJhcgXmXMw5FXUY8iJH	127
6868	2vbNGH1on6jXEeyXncPtqzu7B8v57KzEEWGbBoF2sqP1si8yZ9t1	127
6869	2vaoc3v7aHUTLW9QytK68r8feUaPnxGmfBM9vvuCXEF4DhUi1zm2	127
6870	2vaRyqshgBpfKgq6VdKCDQTEpReBqa89uJtMqcyBkZWmbnisa6oU	127
6871	2vaKBiUxfgqVx9UoiLoFFYtNQjYCpP466t4Ag75FAq96if7PBFjH	127
6872	2vaLo91FG5CsMkPw1Cj477VQgJKqtubEwoGbVUhHawx1iA4bnMnk	127
6873	2vc1Qn46VP4qMYEtzmqMg9ikHyFb4fPmjf4XHPmX15fQrkLsRut4	127
6874	2vc1qz7eSpqxfJntnAwW9Bzw6683T2MsLgwyrusQ6iEhi5DCxdDy	127
6875	2vbSxPKumsbuq39dYm3p2pgKxs9AjpxjXgUesFAVE7CzKGXdGHHZ	127
6876	2vaRFg8fffpbkJYZBq54cRMAJi4BPqXrJ63eKr2vkpofigPzAga4	127
6881	2vbFYfY3cTEZZs4iKoLchZoJWQ6RJVGe6nRx5faxFUzA65KLzk2q	127
6882	2vbw93hZgGNipF9uEsxUBsHAZ11EnrC7aJKwG33VxWRmAix8Q8SJ	127
6883	2vbXjEvwzVA1LNg7juys7XXBKQqEaKnck9c2HFHC3ARcaSXgTrx7	127
6885	2vc36E6caeUeQcJVKVBTxQ3PD5SwwbfAYv16d5rM7aSucqT2ZnCm	127
6886	2vaxkrn4W4jH6Cso4HDyqfxQakdJcb69A6jcYkpsdCnwMEZNq4ji	127
6894	2vakcwYiR5WfZYuZMd1Sc1k7TwiEGjXcwN6BpD7u9zTb4DFiTLY8	127
6895	2vbYanekFigGTeoTGjb225ypkXsq5ewb1ERHjtHnWhhjJFmwaKZn	127
6900	2vaynVQRDBQsjqofkTheVNuV1FNiAB5JdQ1Cs728vpqhyBd8sTo7	127
6903	2vbEVV8xgLEGmLhijCoku53UvYo958JsEct7Bwg3nhFQE2aoheXg	127
6904	2vaGs6ASXczD28gNbrd7XAHCdfVX1QwyhrjPLYy5nqu3ThrKCrGZ	127
6907	2vayhPqY98zwGv2TtHDHk7zhXtGhp2jRFrktEeB7aixSvJe8VYzo	127
6909	2vbtfm3fTs3nhBUukytyMgdiXY1xLmLSnkaarsVzUo8WW4o2NwMU	127
6915	2vaXrjRtA92VsSdt34ZS6GG7jxRLaxWsNNFHUcVavhm7WUrTfNbX	127
6919	2vbBN3m9HGgup9fEgGYU9cWjzpZGtevBqnZdSnneRRqdCYdMfZZL	127
6920	2vbLXsPHwTaaQ22HXpGLDLh9yjYiRuGftDqNuVSq5EBKpdueMxrK	127
6925	2vaLBjUXR3dxS6ey1gHfKsB1aAxsPc4EX6QTVtw2sEwSGHBh1J9g	127
6930	2vafW1TEsnNgAyEehyg91HbaBBNrMqm1tuBCvVZqZSd1SBqyJhWC	127
6939	2vaGNfhRq5VGuAWW2ras6jxec2AaoSVntTgEWQQBNdGvzUJphZsg	127
6946	2vaAPT7sHmaKUYhdubjtMepxf6F4Fd7p7qsRJZecKEd5bFeacZVF	127
6950	2vaeTPisrqvRMTR5SJR2ezYSYR8gAv87XgBbnccxeu2CJRwqYRaA	127
6953	2vbuXRGyUFg97YDuHsVVB8vvwGmyyKooJoZdnnaE7kYFuDqUEuUq	127
6956	2vaqGcoDRjwBSFrHPm4oHuGiNng5W2mTjKsKr7i76GfUBUihNH8e	127
6957	2vbMkvGK7sfzeKRc76inRyKDyoivLuepmjNTcHCf5Cg53x34GkwG	127
6964	2vaWv3f5v1mfyyadou88gPKzpntUexMPKrJGLERVYuNKXomi9hxn	127
6966	2vaDECDsNaafUNThemLt77E8HWLxfvVQKP8dfwWG67SFk79hT3bH	127
6970	2vbH1PQumkCS3cWaEoBRQ32D31CHxEhWUn3f68guF5Ms5qFUFnrf	127
6975	2vb8epy97xkBsnYeUqWibPxm2drBNznqNBy1uFaZFyUpfacRQMzu	127
6978	2vacyQhHc9XpceapLNT3emwb7Wi7JuHBBc8nNyzKPPkRzpxjk3Pr	127
6981	2vaqvrJ23CKZuN9Wm19CCYHUDuqYtHnnnPs4r4J4M6PdFGkwCrmZ	127
6983	2vayWUEi6ufUeXvBXCK7vZ9UQd8gFAoL4s9GNvj4UfeBNdjehAXf	127
6988	2vbgdTdsDCYQ5kywMmeeftLqbdrBydJZeGUfcvpiZpZ1TEx3P4QL	127
6991	2vb8xpYXgLYxYeYZwBPzeG1K7pmjfTQYjAe4yGZuxyjjDThriWdi	127
6994	2vbQX5kqxrE5LisvAyWq1gyCBp2BLmsAjMy59wA53N5B57mFYAVA	127
7005	2vaHt2nPrCpZhrAvRgD59JYxGgEv4ohJLfmFziqrHSHbkaiGUVpB	127
7008	2vaU55k5PKjC6gRM8Wpjsi6fVuzg3bCrUTHrMWCt4VrVHjjekgp3	127
7013	2vbj9d6LB3QXUF78Rgzf8PdYtuXU5MUdmosX9CWBzCbFBj9TVDnv	127
7020	2vb9HThydaupPdzEVE9j2CG7M1SaKzBgQXF8iGmBSQtwL2P7SouM	127
7024	2vbK3q8Z6NcgzY3EzkZ7NTQzv2rkcKCj1moZCT2P3EfFvU9y2niG	127
7027	2vbU4dghm1HoALpG7zX4JA6m2qRHmviexyxHne1eohxh5QmCXk5K	127
7032	2vbmyDipGRa8ZnamDErqSDGkpXjkbAeS9BGXVRbsqqEgujuKeYrd	127
7036	2vaJaXBqCyHnGUnNGgtgdERoFQjnipcrsVa2SLzrwataKrztUhuZ	127
7038	2vaizLWSUSDrXE4wLhyebMN6K8aK8xd22BQ6shebyumQy8V8qHBz	127
7040	2vaRfrcmAa5uccCaDGRG2fBAcyd92U1kD5mH8qyca86V4qJCe6GL	127
7045	2vaDoJFf9qaRRwDzwXTFnkLRKNUr8jrFhaVH4fjtxhBLkXBcv3sJ	127
7050	2vaEJW2hyzFSCakb2vLtzCkzYwvVXSAKYjFbTqMhdKevMQcEUHQX	127
7052	2vbvktjtk799Brqe1usbcHQSQR6C56mP5x7HvvreYnunp2n9zR2m	127
7054	2vbYbQDBtu2URYqFu5nSAHPASLd43ahfKd49aEHweFkkbQVtt3XD	127
7059	2vaJeEg1Lno5hASfyfAJvpxZkAfycCq4e6r64AJbSgjhLkfrcEL8	127
7061	2vbyM99wovcFQEsUcn3fhei8KSXEq3mWdY42ajJwg3BDA51ijAAc	127
7069	2vaqEWtQZda7YsyuoMMMv51PnMGHkoyZsVxS6iPaWTji7LsHmvSC	127
7071	2vaiqqpp3RHJ1Aq37wjc9CNvuRRQfdJUf2U9LNtWbcMZw8Jqjept	127
7076	2vaphJr459xETjyxWLUywaAYWDzR36YnK92BzsQbn1yXHzgrKK9p	127
7084	2vaiE4y18U1BYvn3JDteUmWWot3xBzDEjxY2iM3d5zru51GF6L4y	127
7086	2vajNFy2GQS2EiX7EouTdj3iypUynCpFTSg2y11LMzaikgnRxJmi	127
7091	2vb97CWNDsAibBPxqBayfHiEgixwkRGYms9qEP1r8NmcPUbW6BJS	127
7099	2vaNDeTmaor5NgTLfPc5kXFsmKX7kpEo2kVW4wdcUSrZFzW6nRzJ	127
7104	2vawiXZUq97FtQooqyKaeSKs9ZNZ4DZfYWJWevYp9Tw5fyWizsjF	127
7111	2vbigifQKXP8tbT52CEQ3pQkDk1Brg7GPhiReqeRCSHpzbAdFy6g	127
7114	2vbEpjCwAFgQ2tc1ojzeEs8Tc6zqiFncqy3F3EoAsman9bvqDCdm	127
7122	2vbZwSfpdtRbiEmn4LisDpy47fU8wrJ2c5dTbAR8T59i7C5bs6t2	127
7125	2vbEbnjW78MTUrCuLEoouXLHkwPaqpoARVbQkrpNoArBskPYuvMB	127
7127	2vbN8ZrdPRhFEsdBtenqE7KCk43ew3XeFm1gWnWWxHzhXmM7PDCb	127
7134	2vbbmqXX474ZGnVsHsJc38M3SceLWmxQzdmvhgwRqP3y9TAGTKkz	127
7135	2vaNoYWaP9ctJgKVEujfxEY74WgY45qpGDPtSQb9Q4uvY5xvn7GW	127
7147	2vb3zdtzCEPExpnZ9owq5jHtFux6BZmZM2RJKMho9sVpY7ZUmjUo	127
7149	2vbFF62u3Gmj9Bz8EBNdhPBfRnyxbSTS4CPFs5NeQSsKhTemuQU1	127
7155	2vaxfVsM5KGhmcPvey57wa5CYTSSYT6CbxhW5wSsLyREnusu64Ti	127
7164	2vbkbFBWUtwzj4LCcHUbYk483B6n5VjyXhBwDUPpGq4Mc3GNYWgf	127
7166	2vaE3Y4jMvUgj3KWEmrZMfAoQHGzcJbqcGtaNHiF89Z8xfYXvpD5	127
7167	2vbskjGZrJYRMZ3ZUo1EmVECKaWwBm6ZbV7YU6zRA6GAYj2hcjfM	127
7170	2vbcWVigQWuDAHEwBzbdfptmuMYmRAj7AG39gocLFEX2HUifzYNF	127
7173	2vbYi5hEWY3dVMC6JNP4UHMKNTqmjkSSy8Jgw2tZHQutFWUYcvUi	127
7174	2vbUpE61XfWi45iMrz97Hiohv8R9K68BAgMMdpfvfzzFR3gFRzMr	127
7179	2vaqxF3K2ABzDtFEm24z6YwyC2CMD46JHXeRsV3ZfHFCXQ9hGtkm	127
7181	2vaDCWpSZJa8eFiXa4jj3pHyX9DSwaUqm71kDta5nBTbFoedjokk	127
7187	2vc5UQi9w3bkhk8CUz9Vku9cYvFPMtv7i8CKS49R63AJoBn7KbwJ	127
7189	2vaRsUTeyp53wAhbhyk6G4uZBB9yxNaXUfhys5p7EW8CNGpgGhrg	127
7192	2vajyapqeu6JdYqZqvt5DDNkkU3w5puM4oKnXk26peyRpKs7GDuG	127
7195	2vbFuGQ8tM6sd4zpzYHY63ztBqxnx7d4z4bKA3pwGG7FM1kExw6j	127
7196	2vbyhMcwnkao5tVLNPZkAsZxYigL5EaY4b9VYqWMbYSqTcvkyqFz	127
7200	2vaxfBBvRdP3Sskb2nF2Qtuqot7bJWMgWoM5nS6TPGTYAaKwy9jM	127
7201	2vaFkru76tc8YxXFMxQuPmxNFcXFmYomWNmajiKEP7WjiuL7G1g2	127
7207	2vas1QMFAdsVSR4FpXaQyQmBfyrXi1RrcC813n86eVHTziu6dpJN	127
7209	2vbtqaR9mq5NjjH4FbUoqLACysTouL5j3zdwEb6HZvD2AbJQGGdD	127
7211	2vaFSQozLPQS9QZSkqhuA8CxC54RLosVdpd7SGa5BXJGC13Rd1nq	127
7216	2vaG2jpsYWtbTF6FcKvYFUBWeVA7t424wb8r1kf2btV7xqzHZYz9	127
7222	2vbFLQJc6zrQCMVKg7YiBWeSzBDSiWtmr3s9op1g7wbPtMswxxWd	127
6877	2vbBJhF8XoQ5CmyJcfiweKydPU7ZKh8mfioHFnmPpuhPF7Xafc3q	127
6888	2vc3YSTFETEEQFNPS2qYUeX3Fh6cD5yfM2s477DyWAH2bUYhRVgK	127
6889	2vbRn314Z7LyZzV6yBCS8eVxAf1mMpy9GxepuuLHDqY9V6UrP1X2	127
6891	2var1fFrvC9a5wuhDt9QFDt3iJpUhjiT7Fo5hhgrdRPamaFW3QLc	127
6910	2vaeKhzBAWmf45CMFRsyzjxfw5vzwKFEE6bygr8cDm1o2V9HpMqq	127
6916	2vbQkkhGUZgzcebQLbaon77PQWGDeNnHvHKHvy5jiR2R2rDr2RCF	127
6918	2vb6adPqZHSRrc3vTdGSXseSxGSgTbeHZncoj4ameanskJRAMAb1	127
6921	2vbkiHpJfMEERE88ABUeXtY1RT4ANMFfXULqov12Nj3TbPcpQum9	127
6923	2vadS7vYM16Tpreoc36cTkaVRvTFGRVvaTrUAzi9L86ByNyGmLnW	127
6926	2vayZpogYCY9ApScupM2TyLFvjNw1bH6pG7xhFjpMwcGjkge9VmY	127
6928	2va9sA2NzXJPAK8ZZg3bWyjZAeRRW5QcXXn9WdxBb6sr1QYWNXog	127
6931	2vaaaoXHAmrNrnZXGCbTBEFcarZWGet8y9KJv9sxRPYDpH1fpSjf	127
6933	2vb3xA4NXvAv79V5rScf9Re74wn7hWQMaSjrAcxhbm8NeCDkiaQ4	127
6934	2vb31KqixunNmkq5ikjd9WLG91YAK6AP5obp53N7L8MVdFbWUabU	127
6937	2vbP36CPzzuSF6Ud5Tgw2fagwio5SscM2iC7wwHYC9iSCDTpftbq	127
6940	2vb1m3NPZjCPuTGFec72YF12DvA3W9PSDf2sJa8vxrGyKfCqCxtK	127
6943	2vaGH7hk78ToFQsS8ctur212EHsVNvoPTCFoCGHGdD9gSGoYeC21	127
6948	2vapTUMqUee9hVw3fkX6L1YV4UDMTFBLmFvvQGoAU3ri7fTEU3ma	127
6954	2vaVSWFbTdmPaX7pfix3rY4HT6jZax6Nv2gSjjJiRzJ1WGtHx5UL	127
6958	2vaauG3DBPHwTGNxCv1A6uNAE2phoNRRrzYDXc1QcZ5585iLshco	127
6965	2vawms4pGc5yAtqBD6yKhGpnCn7uz2ifBTHF9YrQyxYoCsq7ZfLD	127
6967	2vb7Ni1hGtCJ2HtjAdq8bcZib25CD5feUWbfEECxeavNRZWhBrXu	127
6968	2vc2jBRuSMWptfhT26j41zbutCA44q7YT9pGCqVyDiqMh4UB15h4	127
6971	2vax8JQeQHJvaoaXNDg18M1FZouXFb9A9F6hnsbuFbs6KktWzaHD	127
6976	2vbJWxQAqxo2rZHm7nFKPomuvJc9cjRzf9J1ivD5Ry78TtLK4WNa	127
6984	2var3CjZEKMsjaSiqWDiKouwyL4xLpuLZ3uB2DYURvvYRqdAZtqZ	127
6986	2va9vVpCrdeeauhCVBhi7CumhyG3LhZLKwtKCW4dTf9ebeoLQpnu	127
6989	2vauhkD7ncKSkhMY4o33mWjWw815DRE7p3ZVajZcfyRhk23wNfnj	127
6992	2vbwz6869afcqUcsiMTdooiCqoPz3gxsBmMfS8dCx3FBCXSzTNME	127
6995	2vbTerXg6KCYKSa3mSyeBBKEGjZPq289hSxcKzTtwrQvCDdScTXj	127
6998	2vavsMK4J1MTMBFLNgn1SY7JuUMpjQPD5qVhGwsamqv4JrXDf8Rq	127
7001	2vc3MPR6UzVST4YSaEtoR9MfEC9FB9wPRydGCKE7cRdvZR2PHVtX	127
7003	2vc5sWtPR2a5HehzREyF75GTpfc98FRrbiHX7xG83nYmG4vCBcU1	127
7007	2vbmoyzcX3qMtEZ4yKzjTk5JraZSG85gWk4UXSNx6VzPyG82mgVR	127
7009	2vamisxujjcwsq9qFA5pzdnRawFuhP7fSayVqGzRYcwoUDZGias9	127
7011	2vbCL8yUC2Ze8LMU16a2qC3gwsVadNdofwxSQhDvGquz99fsry2p	127
7030	2vbj4z4gP2fDPkHqFTGuPZPmMcYtws8fLdUZhiygd4mcg9AZeCNo	127
7034	2vc4ZWCFgeBj2S9APuax9FtJ4FPdq5MaGGcrKreexnUa1NVPDJ6t	127
7037	2vasqoZBcBk3hUpEEmsQMaxizcoC9fspcQQ6WWu9qGJ8hvbkrmpE	127
7039	2vc4p7VxUm7DfMUDNVyf8M68vwUsURFaWbwsgNY2Z73aTZcirV26	127
7043	2vbvWKV7w8CLbUtNwtKSXvqXmfsNpjrz9ygeFMHVTSZTJpaw7G71	127
7048	2vaVPnPHAtaxmXUHyeGkB5EPrX2HEFtbnB3m3R9jKReNEJCS9xvT	127
7055	2vaaTfms4CnSPqffFkyJKAqamDfHx582Ax6YzHdPLyN7ADFgdPjw	127
7057	2vasHSyAf8imi5GVToiLS5ewb19Jdhy35joL7HBD56WNW7ru3U6A	127
7062	2vaktgbcezRk4m7ATYQ52gZZg1jMAezUj4GFmJszyiozp3BDDX7g	127
7064	2vaVjBQgumPxKontDDKotM8rpoRpRvvMYZR5kFkppzJjFaeGUD5C	127
7066	2vbMRCf3H3kXaRqDX91rB3X6j2bywL9G4g4PhTBetuAZjtaEN75a	127
7070	2vc2TDH2BP6FpEhPoFcwHYMmNaQ7UZSYXyTXzFAAUPA9d3VpubG3	127
7072	2vbM5RoGuBeqGFv8gwHNEroqZB2ystetR5gK4LrSjjggnGog7eoJ	127
7074	2vbGqqRoNuYv73qYsL1YJv6EnxHFXT2BpGp8sR23Y1EPzWGzkGEa	127
7077	2vaa48nEtYCJW12RTLNXzCZ2wrUn1pnUsR38xgKcz7iwSJF8Tw1k	127
7080	2vbCFeSpSZ7xqEbN4yiFys5dYJgvJvWDipFUPUe3Khi6go1CcyUc	127
7081	2vbczdVC1jRMLBN798pSJj889dBmdc6c919xZV84mFUMZ4n2RuFH	127
7082	2vbYUz8fKxgZGRR1q1xxzX42V78rrzeQaX4opJhzcHs1FrYwf7SP	127
7087	2vbLcAghZqMxeBUzotEBg5nhiRNGY4ptC6qT8yLBq6ZkPywaxVQ4	127
7089	2vc2TnLWGfkBPcLWshSqp69dW5C1GhF3hvNm1ti5P1tf4FgUEQv6	127
7094	2vbHfyhMMkwDeWdw41WPvT5B6XULVmwVqR8TLnsArqHk5bnWNM1L	127
7095	2vbauQRN74QtFQ3q3cFX521SrZYjbe294AN37EVUNxV6dnvZvxVG	127
7100	2vaou7xCxUAVFqfbzWGM1Ub37W78eMmdBGpxp9YZgkvFpWTFNR2E	127
7103	2vbjeS9hQ9iHBrb3xvNbVJDBdpmFFP4dbV2uisSSbG8UaUuHimhq	127
7107	2vc4qxCQG1GX55tKVCBBJRVLBtpTPdeBUCcxgSwsmmUHuSJpDoYU	127
7109	2vaSPqGXq1ULrsdojZpJ54amapQgmhAGbtss7Q43E4PrSLQqWb4y	127
7115	2vbgYfRauNDN7BcEfN3TciFRXonzqqYfPsDu9vNgNbuYciPS1r6K	127
7118	2vaWbxQMtQ7KVeVDJPat4UGXDdyD1L5Mo87UXPbihfha3BYP2m9k	127
7130	2vbNeLpaR4UvXQJ6bVqYXt7fToC4uvx3rPpXdStjrmTsHwQxWTGc	127
7131	2vaeuD36DjJDZZXVBxyi6DFntmNScGhtCR6vAniNcvv8tg2pnQwh	127
7138	2vbLcVcgbajA1rUVyAwgfhW8UMTsm29sBawiwmNAAMgvuQa19hYr	127
7142	2vanJiWimNXT1pJJj9JAgdE1f8xD36JPmBv2ANm67NN54aNSxRki	127
7143	2vbhezPcZYM698p4N3eJhWR3FaPUnv3ffXmSV2P7skAu5HwXrsu3	127
7145	2vbJeWnpUoP6QUD4Fbxnq3WV6LAR3pXjR8uMdbm4XtcjuGZPYgP8	127
7146	2vaW6MyJzQrTuZ6AJJf7qRnehGadovqEDRjvEjpMjgPGwtHUefox	127
7150	2vbtDrpWJWzM1wTPjUXPF5v6ow9vBBotBsg2XkzehY8i4vmHN5Ag	127
7153	2vbkYid1SKzW7tS6UgmPXMYXrFqMBEyNmDfvHVkZEPWVRwTsc2XP	127
7156	2vbjfp69KKnPSqpthhwsQpLHuTtDnpwdWPP7R8XyguRgPVg3SKdq	127
7158	2vbtTCJmpnKgMqoSPMLiiRjm92Ck8DFisA6kbeuC4atKJkEa76Gk	127
7160	2vbHxCqbLiuRLHSgpoohB4H6hVMhYQ6HFaJcBetvf4PKVjz59kys	127
7162	2vaDZnBgPLfXCmZS9PKuwbGXBnzo3qu42mxLJduSQiww7QUC7CjK	127
7168	2vbHpyALu69QD2fs7a1FMCVcFGWzyVmfr5Vi1KXnbhjp8dpzztsy	127
7171	2vb3jmxuEkfJNgq25xmovjVRJ2tTsPoPwyZx9waC39NJSo33J1dw	127
7175	2vag4TaAkNC72x3KBMtGHbkYyk4r8LxWMeyQC8KUYngr4vba1htW	127
7177	2vamJyjRD1LeVBMSPWKZjfUcLG2k68YKQDkQzx5SXudFSLtXow5g	127
7178	2vaYeEzjAooAwic9zWCngTXcutrYy7AH7bubvEm8BjD9mSzvvWAK	127
7182	2vbtejbAxnAaAtmXvVfY6U2YoNYQeo5vYeQrxokbMknhMyfetuDM	127
7188	2vbJa2cvcxwmNByWuVAosd5buso2w7ZZni9rw246JWMBYYWfVCed	127
7193	2vc2ggAXHdsCWDKBtyaYZnZ7kWQ322DKb3Ah4KJsERJjcgvB6DUZ	127
7197	2vaDqcKGJzgpCugh6KzeHLFVUXvPoxm7KaDSkB8z974LuBKyg6fU	127
7202	2vae9Xq53CQFjgZGqdHzDfateGgeCbss5EHYTM8RCWUjqBy4fh32	127
7210	2vbez5divF2eyxu2c9Xy7LGMyBhyQUBmqG5vM1Nb642diLydurHo	127
6878	2vbaKCm3A2ocit1BcySrt6Dn5nwgEvpFUeFcvAv6sANWMg3rezrs	127
6879	2vbDRDuNgE1eCVpmNBki32zwKhUQqDnekD8noDmT6D6pMw517g5S	127
6892	2vaSUfquG3gVz7gRmLbFCi418zd6eXR8bC6gi4f5ei2wKufPfS4X	127
6896	2vaARC7ructiyXyCkDjqUL8o11ERhKt5JFQa64ZtiN1sxJGyuP7B	127
6898	2vbXXWehWVC1qF57w2YRFRKMBxjtcaCHzYUAx4xvgu4gfqSsBfVS	127
6901	2vbnVpiuYvaDVyZfvPBMrRvpVPCecTBXG41vwpc7QsdjKN1feHsG	127
6905	2vaY3qKygoAWZAzidUXLYkUFQMtKsbQuhgCZ5oykQJpaGA52SkSg	127
6911	2vbQ6mnDrscWFX5Yj99RhVKdccppbVwjK5WikQmWx2WaiBg3W8Hs	127
6912	2vb1sGy5fUai9i42vrwiPjWJWvDMutHvC12WxADfhEiknnKoEDvL	127
6913	2vakXKnyWPHvpR8hrXbkBtvsbptG9gVq42ZA6WvZ1KmUrRwyPohv	127
6917	2vbwS3hnKg59r3UBbqAj1AwXvkm3dou2FNJuwxGL66JbcbmjVBGy	127
6922	2vc4arB6cdY3t5Wc6MZf3f4e7aiNeuKcVDc5kDG4E372o8uHo2o1	127
6924	2vbDcuphpYABxuQ1S7eAj2MSphzGTp68RcpzA8bptvxd3ArgediW	127
6929	2vbMrsU1BG82QR9ca1qeVnLVKgLMNy3ZRWzscwJvnnVpbqQffKvj	127
6935	2vbxQVAyt3NVZ8zqzMkQrDgt3pPcXHLrpaHbdeX2WDAuxViji2m7	127
6938	2vah1T7L1HQXKaS4BLGtP2DmzBXzRx4EJzePSa8csDHn63Ugyrqh	127
6941	2vb4D5C8BaQJi9NDLLCHeAKehsTBEqRYxozbLkFVCcQDR847bpmA	127
6944	2vaqJKefH6rJyCLD7X6XuNUAnJsBNrPnDwvEAST29ZZoUymWm6an	127
6945	2vbA4Sc4cWaMT8XtWzvqHrqAFuJVVJnDCcMpfPdpvrBHVF6prJ6y	127
6951	2vb5AVLvcnjhMSWsBYWixEDUXygJ7VoMmco1hWQ7h55bjgFbiJhi	127
6952	2vbDmZzoxTNQCZ2hSmpK4evwKLQk52owyYswEVDn8o2u8uCzoZFq	127
6960	2vbL2tfdAPYRsKh1aoxCuvPH1W65C4Fd9THH9um4LiJe1tEStTBJ	127
6972	2vbkQ69QFx51Uji6rPcN5nZrT7V8RiVc89qYYEthEVBiVgFG86fz	127
6974	2vauyHZG71jNQcLQc22hrwYhDKa143S4tLTkfXYaD813gDiK3Xou	127
6979	2vaAF34PFbkRy1HwcDRVSZcDao3DtonpKRRCZ3YhjwP3X1s1mHGz	127
6982	2vbi42zsifcQ7hMQa7KLVtik5fpHtpPmUNy4rEyShyoUdDJFLJJG	127
6987	2vaFfEveRt9Y7oe6x9mNc5Yh4ivEeanrgyF8jzMZ89JhSR1X5oki	127
6993	2vaHsXRzUo9jwbngibVKtoyaJY2Uve3A3ZNptrHzvJSiH6VSBXCG	127
6996	2vaGegAPE7FTCmFhFwZ7oJWpdtbHuSJXj3Z9vLc7dmvzZ8gbJJEr	127
7002	2vaH76bgGi9wfDPPAjde5TP59NtpHQBtzJinZAXgup6v33X8ocVV	127
7004	2varoiHJbzLfz5KMFWRvEnXTtpErntRRn8CRikprCwRixq7PWtqC	127
7006	2vbC2ZfBAsBehFjUg4egwiXwrg6ZKY3ReqmkbJNNQ9WyqYFpBbu4	127
7012	2vaVM51nGHFfXbfzYUFMd8ugS6yjfq6KjujETuaDb63gFdhtPbmR	127
7014	2vbE53vuWSbBT7gfXRAoChnYhhn6WCCw9J4SEcfrnkjaaqz3Q9Uw	127
7016	2vc5koa18P51ZLGCRnsZVZWH6gx88mrebZ3Uphdqx6zMN5yDTLsg	127
7018	2vb1i88uKaSYNgbRmqeGtBDETz5WksmKfBTEZJ4kTANYbpifPrB6	127
7022	2vb3UNXHCibvkPR7WNTGA6HHuKVd9iYKu4Wi7Yk9mEgzP2jG9xLZ	127
7025	2vaHixczowCjEjZs9nf3h3G8PgWKV6bgbfb1AZjBA5Pc1Y3rmqiX	127
7028	2vaXxskv1PZh3BDpLrJsBWpoU2vSxcs6EjvbsonjkbmGcXa8QLty	127
7031	2vabHckW36p2bBFBb3zazKstXEFTHK3yKFVL8rLNHS81VZcm3sE6	127
7033	2vapRLjEzB1nRhE1jeoPwrUy8GyNfgkHDBfgVDpwhHELjGetBwZ1	127
7035	2vb42mneeKhSzCW7TpYamarLnpSGFopYdSjSfA4VJDKhR7zZRu1P	127
7041	2vbsCELnP6LCswLrWszGAPb1JgcfcmS1RUCaWnY1tq7TqwFWrRPg	127
7046	2vbhrdA5byuc3tBw9W8teiaPnwkGuXAajuYP4VdvnBn3HonSCzzT	127
7049	2vbHLwoeVjwGMc4H5fTZLDifCMVE53a4VhRoDJ58eA1XuZVyCXZg	127
7053	2vbToFRzkgXrqEeZ15cgsbYJhzdz28Fn7hEvN3qiNpmTgVQsZSyh	127
7056	2vbLxsCrqHqU591BYUNajrJEiaALKc3zejSmqDX14iYh9BYW1PZP	127
7060	2vaQGo3BbYWymJW5EjVEuqn1EsAaePUEikRX9heB86LLU2KuA6Ep	127
7063	2vbJWNQUvLqmDfNNGqdJu32bahGr8JnGBfj34Vd9tArYSHPG7d7d	127
7067	2vaQiNXM5ZYwuR2RMcX48tv7FjTCiosiWZ7ZVYRd6oqmyTX71Dgp	127
7078	2vaiV4j9iLKnhJavkb92NXvXxqvxvv8y118CHQ2c8XPdvkPqrPBY	127
7085	2vas1bCF5oh5emESQt9Vz9eNqW3KoQgAssXDTrJuTLdN6Z1XwtbK	127
7090	2vaJ6mqseTq3U28WgUebxjSW46LP16TEMb3jsZrBJaAegZtzjt3m	127
7092	2vbBiMhrfTt1Drgob19iw12DxSePYh5V6GNyqV3YjaHwmMmyf47A	127
7096	2vbjPHhC3irNe5i2Qw7BVVihjxyu3zZZkBeUTcpjkYzBL3YC8pwb	127
7098	2vaQzKFetNhx4uW4dg5k6f6hXfnqYWeqJ1P6CXnze9vnoRK2fM3F	127
7101	2vbiYiQx8ZMR2UWYbGhrpwBgMw5dz9kwBAvy1qNiTayvKdVef85h	127
7105	2varVFWZG6CNuQuCQkkz52CF9MXzpDRsHwsxm92EEmoZXj4GM36x	127
7108	2vau7mZD6xS9LCLdD65r1CCTtKaeZmdYpmuMTWBDbHYPx6Fvfmxw	127
7112	2vbGtEpAj14ZY8SsM2t12pUbzsfV169r4Yzern2nKA2Tw6ZGc1tC	127
7116	2vbyfxMK9ugctm4ZCeEYGDs6Wjafmm6eXv54WGwwVKfdJmZfma3a	127
7119	2vakh8EssBQ5p5SY7BWAsw1Fvdr7x81cTB7fUHyeHkKhyyaqdBfK	127
7121	2vbgZeFXbWCXiLwyMR87eqFeJTjVFxYouF4hLdJH8NJhvuVYtihs	127
7123	2vbpqe9LnwaBHB14dSXNWudw91ZAdWRktTrLvD93Y524FWL8b1Cw	127
7128	2vbwQ99PbW1nWz1yy8w2wLvpkTg7rpn8gdR6pAdKvo3Cvni53y61	127
7132	2vaXo55q6z1uZ8ez4RFFxUyvSSimpBf9tiEJJRKjyL3w7c1Wp6ZJ	127
7140	2vbUd4Lq2yG2injLpCFbD2c6vagZ1FaSFBxByAP64xRJxi5K2GKj	127
7144	2vaCx3E1rvfE2YPsUhd8WMw7YHqGVc94uQ4cGao4qwUcnEezqfoy	127
7148	2vaCumSdaFAFJsUbaiGZ5WZSihNNytq5cRAY2dbJtqDj5z3RTy3F	127
7176	2vbhP8H5aWETFJrJ1aEpbG6pEyxsMGj6LKEQBKqcSXMuP4Jc5MFm	127
7180	2vbEZsLWLsgsyDCnNSCysM7RYNGFm9AfMYZk3UYcZzuMBhBKvKXE	127
7183	2vbKryTixV28Knm87ZNioKEdvW67iELCT1kqzkr3Vb4UQvsJbdUi	127
7185	2vabxfDFprmYrnby6mWEKiPbkqxN9Y8JqWFKkyQBeM89YcyKVP56	127
7190	2vbPmHg7DvkuTFrK4tXfcjkgPr7yQeyvp5bu5hpAV69FjoYm1VTd	127
7194	2vbyMD6aCiYmKQYigjkLEcD92niEBEzckQ2BdUVmgHKFhrYPBtvH	127
7198	2vaxK5ogBy3ZXvRAErGbuozAFZcUqZSJoD6X4H979w4f8HJdgZVs	127
7203	2vaDCkL53pWMr7NuLcysjiUL96NXmUNFAWdSSJT6TpR6gR9rB5uK	127
7204	2vbYaxhyUp72t6Wny11LdLknUkRZcMMSgx8ytuGBhcMZmCys2Aet	127
7205	2vaihT3mjPoW9z2j5V21j364TVLT2vff7eDFjG3memeDRquQuP7v	127
7208	2vbN5qDE1sS9cAt5U58hZYgp4ian9PqrusTYCwynemGSWSBc66oX	127
7213	2vb4tcReLxxARkDVcb3RkmC1yAGoDfiSJpZYxfx6eVnmPCJiyqbE	127
7215	2vbXWZXniahPH9FPLS2o2ShRAfBE31zTuWNERAXjGTSWhGH8KHdb	127
7217	2vbf24Un1Ff1EUXDkZJW4c1pBEgYf3ut8j7MCFDJbkWW6AmCY2PZ	127
7220	2vbq99vDCzH9V9b3GX8H5LicgAfXYPS6M17ZqhrfUVCWxaXLu7Ex	127
7227	2vacd2bmZjvjQB8GLLAN9CH7PFE7FwAbeFDDRRVcFkraujA4MiG6	127
7230	2vbA5SANCTxKPKiccPFbukuVBzJfJSLpQLBLvQWmZ3jmhZbXzZSE	127
7232	2vawSb8tEx9JaGDv1mFer9J2pC1ViVWn5vFMgV5VxM8bShtk4pRA	127
7234	2vadgWVeuDG4SpEEFzWwSvBMkuCgM87A4d1HQzQuQRQcg3AYQxwV	127
6880	2vbKbFYSPCdBudidQ4JCur1N1N3dgS2kqcwmGJjXytteD98EP32B	127
6884	2vaxQubWnTeidPFHoiyeE2wJvv1Cdt9W4wfueLwPaqKP5qdtmwVu	127
6887	2vbub99jEQtB53SwJLZ1NoLycz7DeY3EnW3Hw1JmLNKZD5kmCdYf	127
6890	2vb4Sg66NVc9eAWM9fYV9QpP1yUnwm9W16xMTtL2HDAuJJug6hUv	127
6893	2vb4XFdHhBKBomk5drbmamK8EPWRqVy7RUeYp4rUan6TJYmAW8vj	127
6897	2vbzJaJzawtaLFiYPpkQ9WJ2synhr5gWoFhBvg98cWinQy3EMpv4	127
6899	2vbEBAe8vS7d6sRYTEo2qnWwnQ14gmXnsw3HWB5ymBMGZBZ72aAX	127
6902	2vbZWS12G8WsV9qYztvxqE9MxAvsjtQ5JxwfviLnTiJuUqMXgMfc	127
6906	2vbbQo5wYwg9vqXEeSynX6buPQ8YQdEDkECxKhQetWcGg6E6X9H2	127
6908	2vaht8BbEsZJ5Aeo77T3z19WbMVW43F71MTFxaMDM2DEJzLP6M73	127
6914	2vbVpuPQzAc6rHwzwRBrcfchKfsRcbtRYdqJLr9BgeQ6vSPp8YEn	127
6927	2vbnVhqpi7FwKbA2eoZaor54wycNJLzecNmdGSvWRRwmW5JDd2KL	127
6932	2vbzc2BMxCur2Dmpw1N9TzpjEUA4PCfwcL2Xkgnt3kQrYwVRcLLU	127
6936	2vajzToiFx7UZmMtc11e8k7X5cfsDNupUHjcXTktmnpkves3apna	127
6942	2vbzxM1gxVr5SBQgDkjeumkjxpd7Nfv64JvCVhErBf96yUdHnqRQ	127
6947	2vaMYRZTo9g6j24MChcbeaRSGYCENHPEroWXwGP6PLLijQEPBd55	127
6949	2vbc3bExH68eczCGijGV2ubP2uUUWWq5Kfwmob8WQHkUNduZPawk	127
6955	2vaEagtAVjnZaeHXaoKaRfe3tfH9WLZvCHAUAmELV9fBGGA8YVKE	127
6959	2vbqXZkfNFy77j3BakNrNtsb6QHPGZUquesFPSJu23hBxPMPFHQJ	127
6961	2vadyBPrPAztVuhHtzGMKybFeWsYMQvoqrdTakZuPJwLADobZWvu	127
6962	2vbAGJ4z31LLgVmV2prNcQbDrwHE2phtgWcZPWkw3vpbkjZPLtYz	127
6963	2vc3ovUN968v3fgr59w7qT8JHHMJEUptCaTtVonphFDsDehnZi9m	127
6969	2vb8YHwY2sGSku3F5UmAmqoQVj5nSED6xLdS6wqHXb4CNtkpkmmU	127
6973	2vbtiiCxWJzyb8Rbh6QA1mCfxf9PbzCJeFFzYqZUdQwA6tDHimAh	127
6977	2vc3hcXTV6aodY8UBP7aiDYVez9EHXfUFzsRNsX27eNAV5LPwQw5	127
6980	2vbKzQtJuTGYg4KysquVtAwjoi4aEWfb6Pgp3w1qwtgrRXrb3njt	127
6985	2vaWc6H6iV1QxuuhJUJHFoQu8fcikSU1FrZGWdawQsqF2spdgyj6	127
6990	2vb4gSgeWWDUyy3PnLeVSgype8jw1ca1QcaVnFdczU4DsQbdNazZ	127
6997	2vangpaFJ7VGenaUZ2D5bMvFNyVYzrnTiXit16e4564XNQsZy6cD	127
6999	2vaCXHGD2AN7mQRMpmSCDyDuTuY8nJ6ZYdZYoCBvgP9egBMZsMVi	127
7000	2vb6QxCuwuBCz4t7p4FqNZsMCzUVMhvYRA1WPUJQk8N475z7HF1G	127
7010	2vaKHxgokmJ9juoNbvrHhp1tHPotwC9dtVpTUV4S2jQGwQDEgyo3	127
7015	2vaBKjeaWzMeL3H9uPU9ysuMUp7Wt9iLfc9Y79fnoGCvcoVMNQMu	127
7017	2vafehRcq4wWLexC6RoVp8mePvvdXkXdABeFrs6Q3GePuKLSmUCj	127
7019	2vay6Q54aGSyR6hYcpW4tcKqRj38wkU1Wc4QHjdHxErDQk39giFF	127
7021	2vbvVavBPbEmZjujuMgzRwbiv7LrYuSFTpQoLwjgauBBKqFDNY4P	127
7023	2vbZrktW6n7iLGzgpm7z6NwVCDCAbQVHPGzKXbmSvk2FbHSMm4g2	127
7026	2vaFkEUeszWYtBZgCv66wXndtSghFubBGy4VtSP8WZ63hPoYhpxB	127
7029	2vaEV9sj8xbpVZNpBei2gYTGAhZQKb4moNPWYCMKwkuf5joeUmnL	127
7042	2vbw2MGxuy1EkRvaPtxAniPxQWNH5ibdP8AVY8kkXY1V1zbo3Qwp	127
7044	2vaTvZJQaGuYWtR1W3xLi88vYAtkAeSRcw3bAtYeugbu7G5VvAVp	127
7047	2vbaHZhKMN5sRgQkrSGmzxMS2evMEGJ2mDs5Wb2P44uF19VeRQ4d	127
7051	2vbEJHJs6x6Qoe7cbfUCKzxLtJSLSNqxvwcV3U4bqjuWfQp7PYJm	127
7058	2vbRmUwY1qFVqLP5MN27yj3JwfwZojnDCXVGiQ2V6uyMWQMSR43x	127
7065	2vbMriK4tWevfBhfcus3chVu4Rz1dEtAavnKRfXGc18E9idmgaxU	127
7068	2vbcrKaLeEk25ocPiifbuGUG4zYwV8zuQoYDADz1NhoSMCmSXCFu	127
7073	2vbPwwoLr8jL3amkzNSNAQnJMJLCPZyne2hAW19SxCcNhsW28nBw	127
7075	2vaDpDrJcgkaHZPAWh9c6cUvNTLG418okrn5CGq48ZQJUWUtXCT6	127
7079	2vb3AA4n5jNYJsSuZZaJTRMzfU7HAKXui9LYsPT2XrpA8RJuQEUH	127
7083	2vazTKkBm1R8YLP9avDHERcoCEErwqSXavSWRuLXWyEDShnZhLzc	127
7088	2vaDopjSY6q7vv1o75oWaLwR8MoJjN5oUGk9nVFVFmGjxMgVFBLD	127
7093	2vaixwJCRZm8cJMEWqPBgTjDseFAu2Fe8D8zFgLDRFN5r5FjmqsJ	127
7097	2vaN6tucsXLN7Z8KEebprynC8n1MsttkPQhbG3THw4dCGujCu4nL	127
7102	2vaor2jk35h5PXsXcufLbF8BHCqkgsdFSrhECcUDTLVYRRMY2sF6	127
7106	2vbmYuJbuN6ap4vGyyr552qJSTysefGJ6p8awYgJ55W1JfE92mQP	127
7110	2vaUsC1Cbuq5jWh5Fc3HChxYuzDCv3jzbHQ2r1cfcGdJN3nUzHnW	127
7113	2vbytBW2LhvZHvjQKoFCHVr6aUxzCW5zYLTDL1Gtbs83PvufL5pd	127
7117	2vbSCFyLMMZUf6KJM9qR1KrUyMVGqnNTh2ihJ11QJjzWiwBej3rE	127
7120	2vbTGp8q31q7NAoKBLVk4atjZ3hoY9HrNsm5vQKZ7HrnoGHDhVtR	127
7124	2vaHUTQ98AU8GcPh9mWYGrQWnSGFtYsM46CKBxtHF1C3sM2HGf1A	127
7126	2vbZsQZc7oUMPKQJAKH4hfGSRAKv3zWoPAWEacvGhvpqRmcKmr1T	127
7129	2vc1VKcNZCFC3apCvs84X3Vzj7P9ukNRRwaAFsAkNkMsFhr6MpB4	127
7133	2vb9UnQHjFw1kWm3MNcDETDa2LJXe1m4uUtiyg7VUZwhVhrNNXTk	127
7136	2vb7cxMA9WjPsQdM8kYTcMg1kTLzuB5AKmvSSG2gFY7GXA9Tx9Z6	127
7137	2vbKxh32Mxto77gUTxv3Dt4tfAMvEcTf6kdEYbHDMAg1sJjBuZJX	127
7139	2vbHcGTvk7D4SMzDPX25yWN4whYLgJscW1S7ZNi2CxnnK7StTPUx	127
7141	2vaopyFqEccctST32qAe2BZSpAErG5dZoNbAUvw8RQaktcbnKz45	127
7151	2vbtCjA7BBNj4m9KYmXExgNrjkhCaSnor8oEqJb1zQS1nmKL7zGj	127
7152	2vbKcFB4MA5n2VqVmPK6ABwywWt6PLqwoMyf3v7y7JSiLmidqgL8	127
7154	2vboz51z8cd57jp4nLJbnqM9N3sPRYXfJs5HFzSsnoKpyucr77L6	127
7157	2vbSasTmVGjmoxuUqLb2uw65giYUH1TgxZjv1g1mqfkYCfpSFrtj	127
7159	2vaaxRRotMvShfWP54SeiKchMUSZwQ5LMUnEV6uErZVwGufs8ngV	127
7161	2vbPozJfS8mcJF2tYWiMc8T9X5z6bLmnZ3wDjK1wUTbCouyuuncK	127
7163	2vbmRnSAgBYCegcbb63PosdGy739PuDqwMgZnY3JbsttmLE18CUe	127
7165	2vbCh8FZnkrSqS95dmR6KehsmoSsHsgXkYayvzeo9ukM3zqkHMKS	127
7169	2vbrvxsyvJTXnua7wuL9FzfZUgXJ86mM2gdqyTnkyuVy88qd7MnR	127
7172	2vbN2jUUb6B8SMwpjHAVRH25zTV2XWUtYvXrXWZX6Jse7Huaegnr	127
7184	2vaxByoVJbpxxgA6DYXqbVjFPnugFwWizMD46kx5qVQY18P7dRiA	127
7186	2vaqj8D41U6UCAocq6PQCEuZQ1hLDt9YJgerZprVDxXYVtgARoh8	127
7191	2vaeumYAhUfMC1xbKjax1nipcDbxDJzRypHmWJK4dUYXcgGNgxju	127
7199	2vbLFNgbF8Bq1k7JxzssCCz1pkctiEWk1RXFRwrrgryg6uWWYpMk	127
7206	2vbYufitEHgpY2fL2Nf9g7aMmFJVUTVB6L6AizfSkofPVRfq58dq	127
7214	2vc1wh1F9H9xVi5RrBvH75De4X5wY6qYVbU5ex4K527DDVfmEUrR	127
7218	2vbvWjxGSHf5kpW4KPQmE8vXBpZ5hpNb4mbGfYJhAgKbGKKwVdjR	127
7221	2vbxXjowtqVhDiqYajBFfxPXEd18gJBoU6QdS5AtA6j8WbSMTui3	127
7224	2vbe5pvYMWRJFmGoWhRogQfmSft5egu5QXauDnJP6JwMPb7oQwtt	127
7228	2vaKBgYwT6VdoYbpeTw46kXBFzxNuc2vAeEPvtBFyQ7JWFarp2FM	127
7231	2vbckp6wzRxyCxZozbmykKXy6P7qox8c7Js9n5oSTf8SqZGdm6ht	127
7212	2vafuCEm91hHyPuFU72gbw8UXZoHfRPEYVqXw7MhVm7vAnXTM2XF	127
7219	2vamBzX2SnybFY6xMfJnHACcFcGYwooyLyqkiudn9t96jr1kF7hu	127
7223	2vaeVuUVSEECnLmUcMA2cHRwTfE8a1WyYz8v2KJuDfT9GxGrAtrM	127
7225	2vajz82JtsQ1yj8qBZ4gr5q8PQGTtwgr7cJ8ZB5FTSwGDnUvx5AG	127
7237	2vb4TsTs3epkNzZuaGMMh8VUfAUQ9myEtVYrhW84ushn5W7sM66o	127
7239	2vbHnruMuNKzL4Y6cSSKpsq3GLZomWKyVUpWUeALhG9qYrfFa1jV	127
7241	2vbXSmG1M8xoysxxF3QCnGghg1vdSMvKJzuUEXyWJGkHU9LhXf6Y	127
7247	2vaMK7ToD8owktvUyb2jhTmyoAHZsbBHH6DhNhpCcALCUAp74U22	127
7251	2vc3djRDZuken1HY9h5uD8FK77FBRQ97nvxE8cvi6DWBYziw8iUP	127
7255	2vaoQbfM4NriQcV7kV9P1t5r2eNCfeA28G6QNcE2iDaDFdy8G3Hc	127
7257	2vaKUFt6hodArMfp79TFQfPHjXdHbXuPpJbF3766oPhdFJyWNv4U	127
7260	2vawH1kARWuZkkySrRxTbrEB6F6uV89cCBysV7ZHkwqsiVWBhQqE	127
7264	2vbmErg63xsHHtBdbHr5PCGm5dcQRbmCd5VHoGn7pfeUq5VmfaHz	127
7267	2vamvHvW8kRYCBMq7g2t1PsqCVqDMoZidTg3LaFbsT3SdfzsSqw1	127
7269	2vaS9d9kzF7bStZQPnJcbEEGvjYCtjk2NZFR4ueRhTEVHxoJRUYL	127
7272	2vaZBBDrtdigTtg8JpApzHhG9NbLQUA7mp5JS8CJ8NZsRDjZkwNi	127
7274	2vbAuAKbKt737i3psUGKZDEsGnRsnX8Jdr5PTqtT41pTnqTqBFUH	127
7283	2vbQ8xBR8dy4c59B3NQXJDjuP3SKcb23n9ibPcUBk9jGYrZm1Ecg	127
7284	2vbeiTWmYZFABaSpuwk6uLW5vHLf2E672UMNbm6wU9CQLDTe1vEv	127
7287	2vadQcmobYYKT6YZxK5puAhNXbT6LfrNcxYxXHjiDNtFUJ3j4y2Z	127
7288	2vbTbhX4vWRjxXUuXHd9kz7yaZNSjNRCbVu9TCaG9xLkzVoAgbeG	127
7291	2vbZ9w7uYaZLBHGfYQkUFtwqZWsAv4ZBG2jFgURKfMhf8rifa8gs	127
7294	2vaLELXh2gmFU9F1WCB4RJhMpvGe5ViCPyiwoBjrz9UJMG5Gix4C	127
7295	2vbT5MCondEm2qpu4mQiTxApR3QpG3z4wvt7Z5YRdJPx2qVztTEK	127
7300	2vb1kGyzGGd1XmRSR7ANfkdSeF2mGfNRbgvPkS13vM9vWETxJFsa	127
7302	2vbyKnJQXK9Awp3Dqq6AFvUNEiezwfFqr4DUzoDV3DgrTtvqdZPN	127
7304	2vadG2UoaeKL4xZREd5vdt6M4PQrQz21DAixx3uBKo9h8CeZtS7W	127
7308	2vb9dGfZ624Thd8RP4LReUc3BFr8Tkv8NreMB5U6svYP1YLfVKHf	127
7310	2vangmiXz4HfuZEi99RvgPLWTVj97JvU2Lh3fzWyzqmBKsYNgqzZ	127
7312	2vbBXUSFmnJushULNSJL69gmQpG8uktTD7eA2mfLU6pYUDDxHPTp	127
7320	2vavGXgj7v7zEndtMabgLoRuFinah7wgeS4AMcgaG8dDfjpeDtXf	127
7321	2vbFuDUTYuuHZwvi5vMHcwVdbWcv7W9qB87huCw347TtqVGL7Y4b	127
7323	2vauaukuho1tkwCmJXPSuVk6nb7X75TZYLGmrASdg5nykZ4up223	127
7327	2vaoVE5qfVRmJAeTjmtjpTp3faUWe1EShqrKD72pBoqxKAfXAQLM	127
7329	2vaJPcjE1YV9U95XH4rhJgSg6MFgEvFX73zU4LRg2Wfmt1HnHPH5	127
7334	2vaBuQgc2pVLnHPoNCx2M5rSMjmi2k2muZdeS61jzGA2Lb9cF6p3	127
7339	2vaYk9SGoR7w9JWRQnxwhKJmCn9fstqYar8dyX1wixziX7p5Qzej	127
7341	2vbLrw12bA3ZsRYzE3J5wvYHmFAhPaga6XfziiHVYzSb1cQr6yeM	127
7344	2vaBbsodga3Lrawpo7EYhNo3QQJgzAr11sfyHZQmXkJu5BcFvKVT	127
7346	2vainHjvw6ygB4hPTasomhu8WYz8d7Lsa46KDPx7fKpFDXm6wn8j	127
7350	2vavpniUi5LArU3rTMwLhQ7RD8AxQFUwAXNqrB4NVj3B1NzN4mzi	127
7357	2vakxvzmSWdYTcQD8ANhgEPQ2DpyFCTAAJmp6EkydprE7YqUyvms	127
7362	2vb5PvDkhdjksLvu9dS2yavjbMdDsVNWAcoChLrt5EQkTijHe9Ys	127
7365	2vbGNaDadTUtdcNeQC9dKBdYgxTyXBjY78P9dvV4v77ejdhLzP1j	127
7370	2vbpCiEbzTGZWpkbveS1uRPziMcoGtGhp6EyPLgrTLXm1ro9z4o8	127
7375	2vaY64ySShXni49Sb1GLSpMRCKGTQzZk1vr6YA31Fwjvi6thmYXb	127
7377	2vc48oR5KbCMvGnLw5Pp7yt6NZAGaUPmcdTZxyr65pGyPMrTy5Q3	127
7379	2vaqgrWJKAKE6YB6aAVvQbPRzTpUz1MnHNcXdttGAoMdCxQZjsCb	127
7387	2vb1D92soWB671eac195ZJSPxvFcUJG2eSuHRH4aGs9BjJFF7g3W	127
7390	2vc4MLx69FPefjSWnsc3Y237Z78k2Y7GMtHw1fkJ9rPdkQJMfyce	127
7392	2vby3eQY1VeXzPWz87QYVxN6DNuK6wPh6ZU6njz61P423FUG6id2	127
7401	2vbjbyUeCTSMjVajrrEURaEJNoELBvA9BvipDQLeXBujvpJo12Qs	127
7406	2vc35p9fynaYzsaUrMSC3PLnoUMVVuMjpxN5mpDbey7NenowSHe6	127
7410	2vad2sVPwGjci5ckuvkk9zGZJzLkoFoxpwSnTxzNTgTVdigo8pvK	127
7412	2vajo99CnzZs4qfhkPveEWKQ5b5srDvUECr91VL9faMHzHYQ6Q1H	127
7418	2vbD1KFfVRctciKuaWJfW8DD4tZt7krkHJmrjTVjTMeY8Mffr1zh	127
7430	2vaDyTFnL8XBvUZR3L2NU8apCfhFWeKzvhva6iYXCpE7BAiZFbTH	127
7433	2vb11dSNFAm4b9A8YX23cEmZTCujfUyzGuSHYzDoLsHsn43HoeNJ	127
7435	2vbHNF8sgWSTfVG5KsHzYkD4dLQ4Buu8QSSDNyRh1srwdQLQpQeu	127
7441	2vbqfEJ51xcmZFaoRd4MKqbywN3eJTGZZkX6wUyxsNsxiNMj3YJ2	127
7446	2vaQrQB6aB65HpbHu5deXGmho1csYJSBfk5o5vues3U5kjKcLUFL	127
7457	2vapXVhi1zDPZVurE883KqBHKxC7Ac7fLacTtsb1cPYT3RMT8mfM	127
7459	2vaFTN7PDpHUpZQvRjUSoYDP9UaAyrqX5YgHaXo8W9LE5KVGY2Rm	127
7462	2vc2nnB9LjexmAVRHAeRGQVd5uopP6Nvtp1HfGtsBK3dEiQPCZdg	127
7473	2vbtUfdZYJEq4S1TUqHjs27nYAniWDckW1jQUBwnB23GvqfUyP8J	127
7480	2vbDmULMkV8tWfUfL6xPiEtUjgmZt6YSPPhow8aY1uNF6ZHJc1uw	127
7485	2vaQzQZmfyeMPz7fSijNet9t6dHbdTnCXPnDowBBKKEMKfHgRksq	127
7491	2vawdscVSBhbtYZbambRKcMsRFUh68YbQvojJpeJR4skLXkmWerD	127
7496	2vbVZXgRMMWvvFvwVSv3qrnh41ScFTvogXCkiwj9CAwFixvCT8p2	127
7500	2vazDfXcWL8jRfGjcUCfKd5XrKotaqNkXzhdKotQ5uh4UvRUhyJP	127
7503	2vacV2suku4nRn4EoijKZ3HxrSoiyfqXVzGp5uduwqkNKaxdFoYh	127
7507	2vbHhYnpJbxc3nHFMzWGMxb6dJnKyAH1edjH5ZijGkS32zTkxeCA	127
7513	2vaG66jQDiBJ22RcchUPqskkjija6qJUb4yTE35aLdghTz3VdTLP	127
7520	2vbnh24NCPYbcjFd7ibXuCEDB4eeNfNtqRmuAeD1cx4DpCjbG1Wx	127
7522	2vam6FG6c3TSKcafjQNrf1rxAj6LS4WyvofgdXcmUUbwqw2twyve	127
7527	2vapGhxKzYWTQ1Km6iiRC3Bm8ELMD2AKZN6pVDtHYjQBE8BX6vqp	127
7535	2va9JXnVybomY6cYdWAF2v6XrC43CnVsrtwiRSrTXRww3kg5H94t	127
7538	2vbHrkEFaGbhT8hjdLEyNUhwPQsmLaaYhCs5jsuoFdMoKFQZUAym	127
7539	2vbnB9mJ78QKoBuh6c87pAHz1dUHJHCtqnDow7TNmcKC5qVug6SP	127
7544	2vb8VRoFj3sdqxNGPoZC9xGe2uH8xKCDk2qrpVTNaNDnZvLfMaQu	127
7547	2vbZj3h3uQSixfaUhMc4Bimf7nN6MHwnRsh2zPrdwubDVkXJ73Nz	127
7549	2vam5AywUqEd7Gr2dQyStFhkfxfyNBrAouwX17V7uJufBAb2Xxw8	127
7554	2vbWeTNjDEscD5b7srzoQGPBPb9xpre5Hr3SQ75h7RrgSUyKu2io	127
7557	2vbK5yLU1JUVK4wuDvvyqjbXPHDh557ZB3ocH2gj3DPhDfgubDWm	127
7559	2vbMuQjyTbCeCoopB9ta936VtVnmVRRUADvju96SHdYGxgaweCrs	127
7561	2vb4CYsv4mFE6NKRBjk27akiu8VBcmFpQm9AcwsasyTHf7p1cCbn	127
7564	2vc47PaP55GdQrVKV9xPynPKiphRNnZVNkcBGEQPMG1ozQv4DrbJ	127
7571	2vbZcNn8R2epXNG1SvHNAutmFx5GZGJG8S33SK4G975P1njzbSp4	127
7226	2vae9zq44h2SfdgJMgjZyJy7QuC3f8x2eZ56SP4AsefMtSCMHHzT	127
7229	2vbipmGoRRg5snXWJw2RgxmeyGPu14o9xn97s5nGVq1UNQCfr44z	127
7233	2vaXmuXM9o37FTQJ7yprcwnf9MeHHMoNdMNg5teV71oQkXLg3woP	127
7236	2vbTuaKTa6umGazwhezdWUD5RECLvWGJLBZefTmzhffXpohMiuye	127
7238	2vbtXFK2fnYqkSn5R4WisTjB7HPSNMRQfdQw1tACbKiE4j53NJXZ	127
7244	2vb4uPDTPLH6yvMJL5eWFyKEL7WZBsLP8nLjevet6Bn9Lq9BhNQL	127
7246	2vbK8KH3acEvim5QBG9SggEUtnQXwcd6tPMsmgCTXG1Cu8xQLJKg	127
7248	2vakNCfhfpDiJyYbanA9aJ3dq7pjMbhoMy5KbGBkK8eXAxXB9w5M	127
7254	2vbrCxKyK3TA4WtUA3vCdxTDwzf4J3cHC2hvF1AeYu54PcEgY3o9	127
7262	2vaqdFcG4o1WyfjUXwNHAYh7ovHaKh4GWDiGe7KrZSoRFNkPH8LA	127
7263	2vb6rJRuxPmJEtQuzUXr2EBCLKU8uRfyRmf1RUd9C89XcQDzakgw	127
7266	2vbTBP65TzH4sC4BEqqCSBXuPJK7hyryKWqKFwdYoKGL1MoXf71j	127
7271	2vc3Lb48zKPEPe6a85Hfvsnz8LpncEGSqztozn3454HjqT6JgeSF	127
7276	2vc4vhTPnbqMz9tWDnqYRNcZ6tof73CU5HQbUrFp1pXQ5sJZiWbn	127
7277	2vaz3ut5mN44dzYwUJ8mpSZb3xhpWMJE1E1imLXS3jNYjW1wiEqa	127
7280	2vacGo2PdJpeLwNhqXBz2kFZnUVKGFFUEjqAMTL5sF1vrv2BfQZg	127
7285	2vby5ci49beXP6RDjDgugQTyEwnoCbgEC6paTP5hXCK79yxZVQS9	127
7296	2vb2GTaitBtSXLzoVaApzd7D1wBNnEjFkPS19wuRKcToLpshywd6	127
7298	2vaymq1hKHVaya5BxjceeKSC96UDTQ6Tg7KfSwp8XgMPYA5YwkSA	127
7306	2vaQSoXGSUgU5iJ9MJQrwjnc7DDNy1ck9WWDLoWJXHkMKLF4gmc4	127
7315	2vbavuFPvcXzV7bJWphCPfXwexfSeCKC7eDXZwqY7v7MkscBP2Bo	127
7318	2vbH9hyeyTK8KCawuJMzn3ryFMFE5ep9gDNtPo4ENAcTFJ3BEokx	127
7322	2vbvM7P8Ph3V8r6GtNLJrDNN5rKQZP66m87jRmsextC6xw9chNuu	127
7325	2vaH9mrWshGwvAHZFiYxFVcKzUj2kmciF3zeJve14vuBnHPeAXB9	127
7330	2vbEsRgpy6hEnWa48syu7rAV5J34C3NxQRUeyWXTs5aFmEikJ3nQ	127
7332	2vbcN71VT65KRjfUv6GXrUT1WbryJJoBGEBcL8h3yep8UMzX69MJ	127
7335	2vbAbuHHBtEAPQJ1zcgtSgrMxTPGSR71GpeZRDKMP9UKibuBuWSV	127
7347	2vaN2ZZxLWA1msrtER9XGM57H3jJPq9P3QQeLbuD5NqUtFyhZTh4	127
7351	2vbGLZkTeaupaisPLKmyepAnFsRB89TMD9yc2dCiDWTQQHYdzdoy	127
7355	2vbT2Z2vq2eVULvdMkcwwsD86ZkMkVnLNnRRrvqonSkWWrkV18dz	127
7359	2vaUyufkf6CsoWPsTpc2aRDQFL11N5z9r8HfVVcZtKkwb1q4amyo	127
7360	2vaG2JVSf6ZcxiU4LMp3NiR9uKXEHb7vBeVu9o8Ka2jSy1eiYDLV	127
7363	2vaFURvL446AxSP4jYX54E4GdBfXwbDm2ZcSDiypPAP3wLcrovvR	127
7366	2vbKkurFTrKeghJeXTwPwyQmSFFJfDJ4exGBW5AEeGxJNKG9Gkfv	127
7368	2vaqbTmkn3xMtkpoMJBFF5HVFw7BoEBuoTa1ty442jnBZk2LhxjN	127
7371	2vb5EmXpPBiJFtYwYPAxsYbdAhHXexbQ9TwWEjKZz3oVoMgiGp8J	127
7373	2vaAKMXD26dhmTbCpWeXjJnVNS6AJJ2AXLECNvDbmmc2QriyXktW	127
7380	2vbDuu5xjXnuaTXHvATVLUqyboVJPP7WExRVdHLpkPaZ7m3aEzh4	127
7385	2vbNrLMSbt3cbLTWPiXPuVt1KKhudsmNmvXRaxG9cgTSt7n6ZotF	127
7394	2vaC1WHjS8SYH1x5o6tHvCiurzotMUbi39sGnFaiug2TKG3vxQQf	127
7397	2vaE3UFB1JKZir7XqnuDrxqg7zmZuyjdWB2U6YnMioVJ2F49uqmf	127
7400	2vb692kxpNAWBRYMZPCZdpNHA6rByQdBx9q27shRJTrVfwULFZ2e	127
7402	2vbdDp3EbEQcLcwDM6n25kqtNcUK1xe4z18GyUPF9tSSANLT3qz8	127
7408	2vaSdACQB4FsfuGT9VLskN6bEsRGocQDjksEbCjo9o5PFndGh9RE	127
7413	2vazmViRuZL33L2XLZ3FZkosRj3kcgBGvCkyeHd3xhHymy2E49si	127
7415	2vaP9e3k9AokM2hqu6srHEMo7hk2MP5ypU5Ygy1VguSzAmwFNMx8	127
7421	2vaeSWwdmTQDyeRh8e8F8wvrRfF3MGaysoL6QU1E7H2pgLK4Wwy6	127
7423	2vazgqdD2BhwPGrXHWV8fWdFJVxdntJTSGRCU1UG8cDE7gHRhS1k	127
7426	2vahscBuHiY118F4amuQc9FN6tgWgiQwMKSo5LBv1MH6tCGCySds	127
7429	2vb3Rjv6FWiKH87ex5MbPaK6NYDuLbt58rNkSL39zfdxEonsvRMi	127
7431	2vatZmzDfDNQvynCs7MwQ5qFabmQGaB9SwpQZBMixz587cbC4aYh	127
7436	2vbiW37HomWMCLdmELZyDgGZT9CBdNo54ubLkDZaYhxYoFUppL7h	127
7439	2vbRwZiUBomAYKRcJtRUubq5HQx1KGjpjPAdZpQufxCHhsjW1mg7	127
7442	2vaKPkf7jWnJbxgoXd6QJGhKh2ujDQHdNUvizxGpdZLnMehDQUUh	127
7448	2vbCFJTKPuJMKhpesq3RpzLANcDDFPE7SEVaWmMmzaqRfN3UAY4z	127
7451	2vbXrDihks5TcVYnSQxMgWAYYQwBf8C5gX1dan86RQaiNQVDv1rx	127
7454	2vbPrjPDqfacrAeLp5qYqqzyUNEKxUQXExn3xkk9v4jHMY8of8Fz	127
7455	2vaPyUUhipkTJXUBSLymP3fmshSsacKn57nxWEPxbsuHfwRb5DGQ	127
7458	2vatDXad5wnnuUGiHdnwVJA5TovzuobAh94wfuH5ccp3obrQZhRc	127
7463	2vbaNipoi5gJjGPBJ5v8423YKQySbXFu8FC4QiRKQoxiMNSSWj8w	127
7464	2vboPcUGUdgn8582ptcgXWVLMMMkyn18Y1DUm37Uy3HrJVbcEiKN	127
7469	2vaUZcmgtZXvZcHvKodvaNWKgM6dQdRs5tnCyaJbVw73CpK2xhxK	127
7471	2vb94y42h8DhGyiFFEeQ76L33ps591faEn67UxNPa14Uy7VgqrV6	127
7476	2vaPy3yNtaGSUVkcpc7dPSjCic7WuVL2cKYJqcW7x3RNGZbrteCQ	127
7478	2vadxUritTCD9gr3ASt3t6dAZH8bb4zmFxe8DtEF6mRDjuGZjeJi	127
7481	2vbesqMVTJRcPUAde8WY2MCyDQv92XgJuU3NkntcRhUprZDQPQCx	127
7483	2vbmcR7DGa3iAVzvFpCxnEDbudjFpd5zQ5sTv5r1y9HnYhKc4FRa	127
7486	2vaLbv1yjjUYX8nd3hffJJ4g9YpgPvs6StsWmDcozA1aBfHA94o2	127
7488	2vaanjRNxqX28FvAkgfKKba6s6jBcAxSwaMq8yevev7Dw4z3CdSY	127
7492	2vbdnrUKK2Va8bXvLTyYkhR6QPTiXogxSDaoHtwFvTPLjTvyAUK4	127
7494	2vbqCAu2GWKrSx8vYXRciDumryf8qrGfb75AZpkJePm9rq7u3Y9K	127
7497	2vbmNcbRnjJieXT75auUToN2CYgr6y2ro7ogC4NUb6jTDgQDtUtY	127
7504	2vaKxQPLARQHCUb6PMK5gGr5zHBjkz1S8v1rE5r6us1HAxFckKmk	127
7505	2vabyfs3PXvTnDRR8QoG5khQFTvp4GdjeNdQ8s2arBf1zZMbeM7W	127
7508	2vc5QWYA63h4hZUtTfXfnkj5q9ysCaqiohS6aETeYcXWUjFe4Q3o	127
7510	2vawRLLrAxfhQ5cLXmh2GXYvBEHBGVQCrdhj1V3AHxYPoqfBLbJi	127
7511	2vaKnEraHCgcAm4Wr2ftrDgU5dj32LubgDSUgWNu77huUmaDwk2T	127
7516	2vbQ5YxNAaLMLDQRKjXEcdVs5sv4w1tG1QiyAT5tKNbuZVuqLwYG	127
7518	2vayartHutEgwJi8XMmrWp2G1MGNGB8kXhAK1RPsSt9azoxEUGYY	127
7521	2vaHywXW8Jysh1H2UNaZqeYF83Uxe1rUZErbyRp5wtQtAnJSzxtr	127
7525	2vaQqiXLdJUSSrhg2T6MqZnd9nWkKShcFv8RbvqzTJWAeACJguhh	127
7528	2vbxBxwyAvbVYCDi3mAEPZ7b5aYYPhB6BdGAoYypFXEQZoqoJGBg	127
7530	2vbQjcoaDA3ZW7juR59BjpnDVtMDBj7nFLxZbF61yoEgeuQ8Fgcf	127
7533	2vaJeKMTLLpqMsWE9KdUNmqDRfyf8J2wdhrBTTuTZBHdsU47kovA	127
7536	2vaTzyNBLmXzWentB4BpbsT5CtMq6Akvc2Qojyg25LHPhiSoJVYW	127
7542	2vbshWFAvju8nzLNU6xMVuSmoHXVQcGwzhEoCxyGYFskVPXD58Ct	127
7545	2vazvgj78YdUfEG9yHF6FJoUew5jz3Ee2f93AnK9rThUWtVRLaMJ	127
7550	2vbfDQyE9wVpnYDGRyxDNZv3PNYKa56K9Yfyx5SGnFzfcSU8tS2e	127
7235	2vbYB1KriMzpAo8LVgKmfHPUyqe6MdBawRn7hmeksLrnPG1rTy1n	127
7240	2vag6F3Kemv71UtssrVZZAmR3h4Mv67te9D3Sb8MDaLzZv6eCmfv	127
7242	2vbo8nNqTAiVhY5kr9v36jYhk91oyiNqaRgWQSAVZwzyQVUaENhQ	127
7249	2vazyh3QQcJDoqJZ87tvrdL6SgUuFeRu1o3DgcPwhx5CGsxpjbRG	127
7252	2vbButqRTBX7MGi7n6SdWYMTksrt1f5NbRuLFwETQvQaAw2DUo3t	127
7253	2varzGCMQ5DL7kegU324uPQDirCGjLWhyuGxdctLtP6jYQQLaHHZ	127
7256	2vaj9XL1zZyQerXTA3JAMoomqw46DmheHvbKzAmeLekXaad6FHAN	127
7258	2vbhEj3qDGKxgKqDWkrBgbHKmj31pjWv4Qg8ipgoceiMqeXq1QcL	127
7261	2vbXR23ig99KscWRdSyyGzYcvWvx3s8BXtZa3aiDLuzZ762BvCYF	127
7265	2vbF6rVaVV8ZhbZFJCjbjfqFc4pLakcLD7TKVNaW8RisoA82Bbxi	127
7268	2vbLch6SRKM9pTpe2JyTEWU6JXyUR72ExrJYN1t4DjqVmJZnN8Qd	127
7275	2vbXWiCnyZzjQL6ZPckkmM3FJgxLVH47Dje2N8HVDB2bKY7qecT1	127
7279	2vbtC3YRTxbyDPHxz8ssLNAUfrPJ1oBmZ2u7ccfwdrwUp9TkkYGM	127
7282	2vaFPAHJitpXzeBbv41dsYhya7VwCXG7QXBArQwNH9wwUWQiVuGF	127
7286	2van8V2nbErJ4MAByEV5HZxrY5bhAksbDRLcfsFf5MMu3vhzgWvG	127
7290	2vc4Z21F1eJy38BwF4KW7PSHzXe8k2Phu9yUgWoVdaRBBFkwr6w7	127
7293	2vaZqYXYuKHq5H5Hxg5YstkhSWgKBb1e1zzuyWzuJKoG8UcLg5Hd	127
7299	2vbKd7zKC2AYiGXczwzWxpaeWfJBmM8eXu6JHeRDDX2sieQLJiN9	127
7301	2vc1AWHvJ7WErziZG2gwy8AytpGKsAo9GpyoRxm3uKpRibmSu34N	127
7305	2vbKR9TCYxr6LyyXSBRucHJ6xNQQzkDXANBsJj8mWu3sfqfVR1GV	127
7307	2vbqkiUDaTDvzY2rpN2VNF7HCK4neqgU9CvMb2SK3NdjsuWb5Fjo	127
7309	2vbhbv9k4v141NejMGyJZHPF3TvhXhtBes4dwR3iLQhgzQjphEMr	127
7311	2vaVjiqcE82xeuUGP9QauCkoCbTvGskBLqsjaM452yyYKMXTDEVS	127
7314	2vayrYsoRxa9WPzNKGvjMf7VsFBvpXGuydmoFAWVtchA1zzcYPKh	127
7316	2vb7bYAQtPzxQE5NmXyeK4ZN9jjCucXhYNCHJ7MAviKjYgpBcuKc	127
7317	2vbWhZ9fDiacgaHQ4whd4fErCEJ8qSsXQe7MLuSY7rp9fjXu8ds7	127
7324	2vavdSnhpLajEyFg7QJEpFDsJV1NGNbQQ9YAtXeqwHHX6j1efdvs	127
7328	2vaXH2n9FYQBUwuNrZ7X5ZsS6xc7kHXos29XVVp9SNxWbb6ffKU5	127
7333	2vc4oRGHm5nDvFmVg3kksqcHgPLA1S1U9pBbMSVSuD1twEpNHpEB	127
7336	2vaBbjp24M7dfovXMmAPg1Suj2XXpFuJLGpNbJkWFVSHbw7U6zrr	127
7340	2vbxBQJC7BJde8Xh8ThNZitn47mGAV2Edzj3VPMcGTnJXbs9UnfM	127
7342	2vbtWHrBcenwbMS6ASXw26qFYUhYdmUAwkuRCkn6LyouYy5wnX8z	127
7353	2vbnmPpDKwPDAN4j2DCtDyp47Ko2BwhLEm95w2HGbWP2vyyTrfFE	127
7358	2vazyRbAMVR1wBhHXKCyuiSXXurd1NT4DcNuxBxzxJw3jJ3Fdcgr	127
7361	2vbyj4o2U9tWwMNdEwKTQYH3vRkU9SYeTqLvpxazqqDoRRTuwK7s	127
7364	2vb1vszNJm6ZCHrKBavq3Bcp1tR1EiscBS6envtiNGDMqT8GsDwM	127
7372	2vamjYXUGfkJBns8kLrEyM3NbZvMA6tTFwHmnurMz3nF6Q547mME	127
7376	2vaau8ZZm8zPddRPT9xSq6EW3sQQNZ3guB6jNjmkgub3WkJMFg39	127
7378	2vaYmX3wNMJEbn16qGVJUkpzuGNVu2JfvmRx21nNWWZm6m9a8J1Z	127
7382	2vaMRyBmtE1xjKWSAADWQ6A9LoyhQnuA8paDYZjHPDmWxLU1tcKz	127
7383	2vb4So3bQTaJH6URjFHB1YcaTCW2V1V2bRzHKV5XAdrgRPt4zbFz	127
7386	2vajUN3tQzUN5wp1rxZbAyiE4raFDNaK5VdPEaQGFeuQ7VXH7hQh	127
7388	2vaLf4DW2G496A4Ur6Zok5hkCswPbMrMrijNxgjatXQT7Ew6uFtt	127
7393	2vb8X6S8dMuW5pogRmJ216EPNij4Npim8GRVaiGYTf34pathVF4Q	127
7395	2vbANi1fAKkTLVJ7j1KYSxiJ7VXtD2yQAQSHocr1WXhSQpc5DuhF	127
7398	2vbCLVbJ5WYXUbcApWBTPHF2NfKVm5faVaor8HpE7dZkoUmkPEPQ	127
7403	2vbYeZmPRUTnN6TxmHga7YNSQzoWGBMg5qyNWJMkXejrrHPEgrhk	127
7404	2vbDUyU1TdcrXFsDE4ACaSBAmWuEvu5FNLjWX53iA3R7iVwk61tv	127
7411	2vbF1W2rZZNVpaj3DK5CJu1ctAwrjr5VmFCL7yxWDMDYYtnhFSJf	127
7419	2vbmJ4FGyMuLFcrtVHw4VLrNbAshDwd913bANLW55KHrpzvj8bAj	127
7422	2vbwxyAdBZeuJJiXUcDZ4JmrN8gLUezDBmEnwW6QHBGdmQhz8cmw	127
7424	2vb9huQpd7i8XWDmLEUHDXFxJHDXsFbqrwDmyzp2VVAVa1oagkxh	127
7427	2vbVKeHZmHFFm6TW7RGYQRD99B5N7cmoCzSqMEQ472tpqGkMJELa	127
7434	2vb4XUhug5fggA3ta1qLjiASM3vqnRx8PC77Pa6684KfQZnMVruj	127
7443	2vaCZiJjDukodQPAhmzCf82rbgxU6YzQWpZQWUqXScNKe7y8yyPs	127
7445	2vbUq9p5YWK52Jh8fid47YEwYxhSNFufS5teyX8Vgqmr9o2ujbpt	127
7447	2vbgme34bdqJrgPwKjAD7p5AFb8jnsCTfE1isVk99e7Wn5RsL8Dj	127
7449	2vb5beGeKq3wUgyAX9JtKpkaFZT7e8uffBv3vF2ZBagkZ6JSgYCc	127
7456	2vaUKBy8iHa2gKEKHsmYrmMXkkKQa8VKZC9JQz3REaMXM6szbFbT	127
7460	2vbotUUHsozhBtk12u9PXNwYYdV3xrZXTfYrP1YD3CBHSrEn52fo	127
7465	2vaPjoMtMwu8sdPsafxahQ93abWsEtp1DeM6FaRmZNi7oaGoboGU	127
7467	2vav8okTSD2MNRdjeDdSN7xAiGSAwkQPNGygutRWKEk8p9UTUi2K	127
7472	2vanWPkJD3uy6J1zRuz4huSLHeeH6ceYo64sP8LVqWAkfgMLnGXJ	127
7474	2vbs21tTpJYEKdjHSXrqitmPDbo1WATwA7Mi5SGzQrB6reABL28A	127
7484	2vai6ipBhd8ZeMd5C4yNvBSekZx1AjdabJZFVHjN5HKdyFFsLRq9	127
7487	2vbKaEy1CVuXrTJWSas8qbebe11oeAGq7Ud3Hq7kweooSyc5khqj	127
7489	2vbqSipAXkt3SodfX2xjFu1Z3ZoyjG78F4gQGqzFFYHSmEFcgEBf	127
7493	2vah1ACW9MWkKwffANBb3ChxeZiT5hqyhze4v96UPAGhXc9EZhPV	127
7495	2vaJc8WYAZz1aEo19jZdvJ4kuwAVyh8DPfMGA29w4CmN2UwJdGWB	127
7499	2vbxrYcReuwr4ksHZ2rdE9VkSiH7QrC6oKcaTUV9n5Htfj3KKMb2	127
7501	2vc3NNSvNc6qGSXdDpqSxwioBgT96NSiuqpTR2pm4DAzaX7F7V7e	127
7506	2va9KrTFAxAJ9po6kwZGyfgbmkc7NgamLfRy94AVqr5AuMaXvpcr	127
7509	2vb6xxZHS5DLSJanrGPM6Wpg2YqE7x3q4HZQqfpdhnKX8ywujzPW	127
7514	2vboDaoBCDoRE8iFWN8Es3AtkXetvvTvRFTSKRHRuaZ4F1Vaq5se	127
7523	2vbG7i2yTHohdhNVVAQTWgDQzQ4EhhikzPvHbTVW3i6bTTGKQh67	127
7529	2vaXPcmz4n9g11MxNQCXZkSEcvry3np6MaDrqQ4xa3EW8wGzesGM	127
7531	2vb72tUAxxv9WsGu1rrvk3GMkkkWixZ55s5CBMr8bb28rjcBundN	127
7540	2varzpSqvhH5BwotKWMhUUUxSKX4RWQpcZxKDT39XXqufCnppf9T	127
7543	2vbtnw5NoYzK4DBxWDNPqrSnnVk8NjwbfykaMM2ST1kRodQBT4z9	127
7548	2vbXkcp1pmz9qDrcEt4ZU4epz727tMFJbRYKgi4B82zsnB5KcR4U	127
7551	2vbhsNPP12M9kTFKiWpzqWCUxCCEn7SrTAdxg4wFSRTvkFgEiM5o	127
7555	2vajLw5tPHj7M7YCGocAfgoEQsUSTdLtWbsmFRYcARmRE9LfwwjT	127
7569	2vbP85a81xy7uNwomQe4je5qLTR7FPH6Pjthhx9CUTaMJxk2Hj1C	127
7573	2vaJQ5tKMhPmYNnsk7LHBVWWRbtA5wvYvpMufscvzBbuXD5W1zzt	127
7577	2vbog6QZdSj4w2vZ6gPtZqhnx8f7THABwLasJQ7SZMkCsgZE8sj4	127
7587	2vbeFxznj11Ho2wk1zLpDyhPC1jVc1EuN8PfjypQNWTae3c5doXf	127
7243	2va9J137jUHaAer3ayqTxjxVyfFCkWV644LMn5J3zPzWQJBdjnjc	127
7245	2vbyALYToeq5KH6KotTxQqcw3DzGWTJRRTpGp34ZtjbjdvvRetWM	127
7250	2vbJ3Qvm5MwcqhG1vAR66aV4pJJsUusY5ygCV2pScZp1rFbvXNjM	127
7259	2vbLQGLmxmLFFSKL6AkDGK59C532WoGbkC6h86d8JGYGr3EAdgg9	127
7270	2vaP9z9WwdR7gS76DVt656mgXFaD6eXtPiU3xYFWoW2WQtKsvNrm	127
7273	2vb8bxQj7X3QFusywQqdM2SxCv36sL6ZQ1hTpPyrLRii7ZQkjV3m	127
7278	2vat59n2URCAkYiAMFqmav5Vaj7RE4hUfyXvhTnR1yLJQDHQmkBz	127
7281	2vbEg6Nhoc1jrUryLEFc5vQVohfcauchF527vvu424jSXcv5a7UV	127
7289	2vbSE3NgyMPKtisWu2jaMCyLt5Lw6tHdFDZP3dycEoYVx8bxCi55	127
7292	2vbXkK3JCoDGR56qDEeFs9VBY6AJJ2TXfsgWtXTtMo4DiX5BCwWa	127
7297	2vb9GrSCL7xT35JEWycgAhaK4MUEtQZBrc8BcNZrfCV8uXx733sG	127
7303	2vbUn7HN6VFsn6whY2fq9zDuEkWBUTSgqN12n5rTthNeHgmRM4jE	127
7313	2vbhCrMCLgXC9dexisFRs75iwF6X2oh5c3doEepiS2mUQovw48yi	127
7319	2vapaB9YJwsgerkrSLzNrsXGHn9DRpPNiTgD3QQ12LaPmgPe8SCw	127
7326	2vc4yT6NqtzwsQzQmRwPU79Wh6Z2YDprc3DJJ9PkqNRYj1vEdeMY	127
7331	2vbKP8j5Hdk9pBEpuY6CAENPTrrEycMQq8Xu7JGE9zTs1Dk1UGjk	127
7337	2vaHAEwPSXu84upbhCjXSS3GmhJhwvtmWNMZMtKesqZ235ERsPS8	127
7338	2vawyLWTho5on58r6KANK6rEb5y9eYpkcr8wr4sUS1LoaKdcxLVN	127
7343	2vbrm7JT94q4pFWmBHtAXaRCfapCFzTBcR2ye6xvsFhMGEGywgXB	127
7345	2vaAKvhWcLbAuBzi6S5Wzeot61TRgWESJ449UgU1Xf8Hu98L5FvZ	127
7348	2vbgPbMEMNkWSB24mENJ89PKj8uBtFiRUEuChacBt49WuEnjMD7j	127
7349	2vbHFjrrRMxiucbcmxcyYCUDf2LfPRxuDMTXySCx6SzaB368HPCv	127
7352	2vaY9VVjK2P5FatG8BwYHJ1qJ8sqcAUjFX4NneqCSy12veBcNCao	127
7354	2vaqiAw3jZcx2BGVv2wektNjds9X7jwA2yj4DsScJvwxf2ZyrAq3	127
7356	2vahVFP7Hu6w5weEXrUShiVVJPE8f7FAyAbVqbZZKoziga7csQ9f	127
7367	2vb1VHg3mrMZqfpXBSsirxYoBMjZpudQDw3aj3HMf73Akg4Cagt3	127
7369	2vaLw59z3VdDK5ZQ76sbc4e6Jx6ps37QEZEcxhdbKtUEdEzwGT7A	127
7374	2vbwrFak4kJe9U21c7854xYWrAmumDw6njxYttvY6jkLmZZKxpqR	127
7381	2vatEHdgq7SYVMQFAJEBwHRZt4eiYvaEeuU2sJGkKJM6RJkmFHnp	127
7384	2vafj7izKXHWJMS1QU3HmM3N2vczV7xHB4vwZX7pT2jug5wja1FD	127
7389	2vb1XoAsEqJ8shRMXeGKyfo8XrBLSHtapPg3XPYA429N7E3PfgpL	127
7391	2vbXMSxWPdrX4L9G4btphtkpDLR8J3LvjbzTi5UB57PdJeSMr2pQ	127
7396	2vbtLcuyYKWVtJAsxUXhbZsCmp8rqkZRUui9LjTCpk1d1xzodiKQ	127
7399	2vaygdLY9ZDXNTe6pBPE7ru9DYxkJ2zkP6tqANnNb4NSgdizCLuy	127
7405	2vbiR7JrMQbtQeEnyQe21NsVd3LzqupauWb1vNyBiAx6EBj6s93t	127
7407	2vbPTGa4s6ZbtbdoaZz91D5DGacc9m8u7tYXthirfzG4kQEtFpwD	127
7409	2vaxkXyXYCxsoMCCN7J9RXH6PYB6W3f6dUxVVYLccNYLekeX9kMR	127
7414	2vbpmJCDeNPL3KDdR8xzxDzMaiJi1qHoJuirPLGxmZUyxWX8TNPB	127
7416	2vbfa7qKe7suYrAN5xYoipYhfSvVs3eTdHEBZDyDxWGQfLBre4ov	127
7417	2vbgnvgf64xrEAExKNDsuJacgxQo6EnG8GDX6DpnVwqFU71J9fEy	127
7420	2vbEjiYTwnAB4fk3SK9Lg61VCdjxvxPc9oUtdUJaxkDaDyCfCWYe	127
7425	2vbfMdXnJsVY2f2ENsYdDxWPR73Xc5ULyp6e2ybdy8kcG6eGW9aN	127
7428	2vbqXP5G6ony7W5oWaCGX1zYF3gjqvaA1H7L6R7ozPsf5CBiuXCZ	127
7432	2vaK71WLtWrfdRXhZLpzrF9qanPK68NY95ep2V7tQ1hT1XBuxTw5	127
7437	2vbQNmxEaGqTenqrCf33gVXSi6K1NdErfoU8MVyu3VWhnQwvuerW	127
7438	2vaCu79u2NevURQ9LtUtfjcgaW6obz8PX1ZkXwxYtSJ7hGsCoK2m	127
7440	2vbBG8mUg2t7vfBvyDXqQML8DgZSND8TKtBrtuE4mzxb9F5xBYtf	127
7444	2vaMJLZQMusQQMjN6bnReZdwhYhGYvJWRucmEh2fzfNDkq11y7oJ	127
7450	2vajg9xGPLbnraLaoPBo3AZ7EMLNnKvyc2TqXn1P8RxDJLzCSvdX	127
7452	2vavNZAafZK31yvvV6Ntu8iwpU7D3UgAvz5Bp1uN8jjrn9GANUeq	127
7453	2vbpneMviAJaLJe2jvhTew9JfjEPMu4gerfTezmba5VwWMqvya2A	127
7461	2vaEVgcPV5BQf1AF4r1bckJTwNW9BjSB2ZirKVhDgU2C2rZrn3LT	127
7466	2vaPhpd74V6aDg3ukLWzaWD7tkFFW4gfNtaGhorzjzdo2iM1z8ZX	127
7468	2vaNY8P4hcerz1hRBedkFU26NQmGbrypWGwWSrKJigWhQhbK3rDz	127
7470	2vbpWp6AviNrfjzrAzL7bkC56z7TvVy3tzNfZpitNhjcXCJuKYWn	127
7475	2vb1k1LEnQF9hHcSXEFMANxsLSmNXdwT8cZ1zReDrruuYCAcnssv	127
7477	2vaYypuTQ2arVZ8e8Aa6F7yLzoxppBfh4iEnwNjLkAH2KVUKgFCY	127
7479	2vba4XEMvRRfSaToKAKKD3mVfPVTJXC8JoPKyMZ39chUnhYcjJkU	127
7482	2vaaJNUsMtVXm3jsuM5d3rcBsGGdc4ggD3MQpvBhCabXdjB2aMtL	127
7490	2vbjYAJnVgNaZNs9YftUW1uBgb5bee9ic9yPCudGbAAYeboWD5Pb	127
7498	2vapSgoPHm8ytL7i7LrRHwNjoFjG3sCdQCCji3ZPC2ZwJpUVJcNH	127
7502	2vadLUV51oXcQjYoX99jc45zDougWnfFfKsyYKhY3PgtWMjYyGKQ	127
7512	2vaXKZGskqkc1Y92izrPUXjStwDcdsyCVqvbBMXty6zaNPc43Yqc	127
7515	2vaktg2f8ovG5WGqCx4nFoeQ8TWrkQb8ZA1NRUj1gkBmzEZp1NC4	127
7517	2vb5SmWpJSaYoiBs2GgWEqkE99Q3Dye5ZXiEoZ5bfJMd6VwtVkeW	127
7519	2vaN7A5tdjot2Km2NTpaKyyZ6XUFH2NG53sp2CPgpb6zHgzBNkrC	127
7524	2vapEfgdsEEYKQcbTyvzGGXzWjiRStnPjk8hMXg5LQWrY8oaoJiS	127
7526	2vaGwXQ1FZqzkVZB7teBVPe7mknFtxTrqZCUu3yHYdvTspySGu7d	127
7532	2vbmvqsjd9NYpCT64Dk7zDHfVzobaHjXb8CZar8V45Wj2wJaFz83	127
7534	2vafjeC8djA2iBBUUdrxUC1TcQ1Pj7eadRi1soESRrPW3wJitm8s	127
7537	2vbKVFyyo4NbBq8T7SXBpJLYWVffUaUiWBqF9J92kZNU4jeU2pit	127
7541	2vbPHeFH5KCctREQ4JCZpqqkFL23RXjnEWBwgPNAj7nQcqFC133L	127
7546	2vbFFZqNENrk2UCDAKq34rw959iJMtLSEP4ruFS3URHEUYjJRU4g	127
7553	2vaChqH7JiMGurfmTg5CfRn8kL7moPvtg66RAFy3sn2fLsHtCGrE	127
7556	2vaRj9TieLdepm5ukEcXk95fvqUcmyNUZorLeAGjxvtfdrp46Nta	127
7558	2vbZ6HhEDUUJyi8kNKLBJkr2bo2xhbMc8js1rMtDhHNxyBYZqsRQ	127
7560	2vaifhkTHm14fqqPq83Az7AgkbA6yL7zhjmSWREih92qHRbZ2Qt6	127
7562	2vaBG6y91yPjtkwr4NrXYCkh9Jg27zLgwjXtHUaTUo3HdLbSiVwt	127
7565	2vb5aKqx8nNdTBS7evABN9FBq1wXvkPKieogK6DRAnuFEV4zgBnM	127
7567	2vaaX8zpfGarKumkVYDDHhjwonbDiR5dwZPVkigi5QWowNMkKE8H	127
7570	2var4zBu1j93RZNmtvLVJgVQN4Abgr2TFHRnwVjdyoJEhSbBtjx1	127
7574	2vat26cVmVcBhwjPKQpWuSzv1TCK1bV24JujWNp2XKBbn3Uk7Pju	127
7584	2vaL2Kzhvws2fTRJvRahvoM816WADy8rFRBmngFjKN2QzLV4tEaH	127
7552	2vaVgEM4xxX8qiw26FsdGCL2gyWfL5nZJNxxvy5WvD8ZvJX24Sob	127
7563	2vaD9x6uUW5aRLo9MtALnU6uyeiR1vYWmiGsoJ9JtYCmQvTJU1mP	127
7566	2vbot4WHbotEX5sekNVp8eZSTKWRLbrRybX56t8tBL1zcrqmCyA2	127
7568	2vbMcuGmRZiKWaa136BzVWJKBjVTT6cV2ekptnRXxoJCKN19Lj2A	127
7572	2vaa7UavJ2vmE2TRwgNJDHFaqKibCP6D77h5Qxg8tFmWoUwTB5bW	127
7575	2vbNhU9cYftE16D5qwG8YFviewe5PG7nUbzq6TR2RBt1BAKrL2pm	127
7578	2vb3KS4hYpAXKe2HW4kNhPZg91NJRKfoaJ2vpccUjxhnd5iuadBS	127
7580	2vaAx74QYqJGc86xBfMBzJN2fQ4RiJizMkDXtEWw9eE5a8FERiUe	127
7582	2vbUb4CKBKXN9piragjZZng1SPpCoCDLfJuBGCP5HBQWysuBwpF5	127
7585	2vasnhcnHWj3bVzzdJ6YZo734dsvHNX1LczaRoar93se6HPGcv7M	127
7576	2varwvZPKg3nV4HoF29QrwmzQd9pqywVNHjfQZyY81XvWKwnGsuc	127
7579	2vbhHLRuno3E7P9WuYpYUs4RPzsws3FHbnBrhnJpRWYH1BHaHyGi	127
7581	2vbkUETzDZkU41o3JjLt26sAcZoh1kVxG6DgR4484Apzrx6eH4Ei	127
7583	2vbETYZ5uA4z6X2UUyb5uZXE8qaL6nQZ76az3NDeQsQKSdTeYEtC	127
7586	2vaKUA7vSokMPL8nFssH9FtFZVNtM2wUTYhKwttjtoUKDDz2B6Uv	127
7588	2vbA2crqhD962fnTWVLw3eg8bQv2tUcH5G5aaUGPosPmU1APdUkM	127
7589	2vb5uQ2SdkE3GmsjsVDTXtGNizUEDjEdzT8EfQpS5y8zjM2vP8jo	127
7590	2vbB5SzkZs3rHy53dBQvrCbetcg4cKAnjWZmmmPpnGQogestGx6V	127
7591	2vbjNbdwGk5HL8EqHxStTLfsj5urr4X2oczMDyKdvuzoro8yfPhs	127
7592	2vb8Lg5WM1R3BB82RmFUXeKEvscCqHfvBDLtFH6rB3LPKm7yDVuD	127
7593	2vbuPyG599Scnhf9esdLmG1zj5fdL6Wp8kt7cEqn4bfaHs5tdAXB	127
7594	2vbUht8ngvauaQTZrdaC4beQfwuacvzzGcUHqiU8bDzR46gZdmsV	127
7595	2vbDBHqHesnNSBmjDLKvn4idnXNjSkEAFQFtjhMT44MK2ZiTrHKn	127
7596	2vbmR1VeidibRvxLf6pGjWaLHnYNYANFNpmCDeHc5vACnGKqyubd	127
7597	2vbwijTShUsFaYfqPVvXj3i6GeUxnP4nwrWV8248tSVTd77XTxEo	127
7598	2vaUMcBgrnw89Mq4uHNHHpo34KnEaREGeQAxQWTRvikbY74BU2mr	127
7599	2vbb72kphfr7bgXRecmJh1a2fQ6EZsLqrUC6xtFFHCYp13FS96cN	127
7600	2vaQKozuMJs3QrSKKad1rMXpQ4igyJpa1B4cP6eZNhmYt4kqWuZ9	127
7601	2vaLNzthagzzdCTEtpvsp4L6nXLAvWRqNCXAsxr1rpiqVewhjXpj	127
7602	2vbzXLZqLbx75UZ2r9iP8iM1XSqbNoRaBqErmKokM7ePtTTAEJZF	127
7603	2vbFSnaeP4wSyqb3q5AWwymx7uTyR2vGSbFSFJrc1MgvnLvHk5qp	127
7604	2vc5ZL24CNezFXKSiVfZLyhwV24eGFTVPxr2xXd2vWCcnJWG4h4w	127
7605	2vbGB854MLE6XqhneoH1L2asSy1oTGmX4uu2J3Zc15eK65AC3pzB	127
7606	2vaRzzutPYmk5BEKdUJppZVpQ3xqYn7dY4Ch91tLrApkR97cfvH9	127
7607	2vaVi9o3bYV6jaNgY8SGfXCKzZNNbEiheHM91az8ZryeceYJcPMD	127
7608	2vbMeur8p5Y3EYTABnNNMaqPKU3jYYgS5wQBFd6Cg2UeXyKfjYTL	127
7609	2vbfNWVxrthzLtghmJcBiJBNophiSqTJS2bXvgDq8bhnyLjyww2S	127
7610	2vbhLd19nAokHxLHAGKwn6oppsV16XsncHe8YUJEraxyvscshPGD	127
7611	2vaQd4sYEhGZs3e8ZN5idPkyejG9rMTnyDV8bXVVF1MFX5qtHLQ1	127
7612	2vayShxfXM72SamMFBgNaNGpXj3hYiqCMcxPJ5fwXYUEPDSJKyTJ	127
7613	2vb66aEqX9ckudn5RTt5DjY5y3CfrwRA8Lmb1NX3UyWJnYeJC7Ed	127
7614	2vbSDmXc1BgSjc9w441gwuhvDLb3MTjKUvcALVKmQPNJZG8spzdg	127
7615	2vb1cun6iCixsCKzD5Fb1XQSiTh3SNA9VhoXWdyayVENeTPcAyfB	127
7616	2vaXmxRqUKjNUPJpFCUAAYR4WL3mpC8Voz7XDoviadb7EShErRTm	127
7617	2vajE9f9DqnebcHUMG62Dp11nZMs157B6dcoQ7Nn8cQCpU62LWfa	127
7618	2vbH9fsGza5fH1wAC9LCp26KxyDbaAgREdWAtEYDv1KBZFd4mGAc	127
7619	2vc3FQyssT8yfbW1m5NgJJsjhykgx55a6WkJbp1ejeYQouBpJtNu	127
7620	2vaWAJxWcdPoYAQxp8NWRpj6zR8YLV9MM1dUxML7Y8PUCEmu4Nhh	127
7621	2vbmj8ki7oiKs5PjUyydQZNMfh3tPouHFUdfTD2yZ9fQ5EzFM3i6	127
7622	2vaZWonjEw9aB8S6o8iRkNCSTiYe2N7KuT5ja9nt5AHfrYLWrAWD	127
7623	2vabmu5VwiASt86eXhu72ikTMedof5WfRkh7er4Aq9JDvZuikZrX	127
7624	2vaS5bnRSBe9KHt1xUXNAq2THMtrY8FAdniUB1v942qCjDcwYWGD	127
7625	2vbCTgW2WTGuHevVXMPm31QaFQdHD6u8SdVyHpcjihCpeJfkqYRw	127
7626	2vc34vjbXZqW3RX44d5CGF7txyt6S7sNbheMH6fkqkAFX6xGRAfH	127
7627	2vawyooZ8qH79nnNvyfWBUzHxgM2QNazjQmS2PWZqHvSsaaECQHV	127
7628	2vb9EPtMLurq2dUyfyNPxdW2XToSJCSsmHV4Yy2XTEC6to5VbSLX	127
7629	2vbRdF8McgUnNrrxbtvmtoSTbuck4xLcE7t48tUK4sfmoBbtvRLR	127
7630	2vbEfcBG8aHHNYn9T8CLr4YWA6sS53v5pnv29H8Kc65dbUYXHQBQ	127
7631	2vaieM7v91TTgY1bcYjHKJo8cuachyS2vJ8E6jGXk92oFtEYrQH6	127
7632	2vbGU7NFPpRVoXYpupmzDN1fy9iceje1hVVzc79BpZpprgB1Lyj8	127
7633	2vaWtfJrvHDD3rhEAfDZ5F7z1PnCycfwA1gmreNCgwKFZHz7iwTj	127
7634	2vb7nkds7GBYEnbgvc7u6BKzjEDhsbaMb2nkAxjdU7V6zmChcrE5	127
7635	2vauQ1GUu55TNHZjHWvp2Q6qWDQ7pXMtwVSc7jQ3qeqa7gRGnKJX	127
7636	2vaMGdCySnetwq1uB6yHeWUUtTktJXbj1qtg7txxdc3phZknLCRc	127
7637	2vbdJf9Dx3w21EzcopqE8SMj2TAkq5kWn7Ekb2AnpDxmPHncBqPK	127
7638	2vbrbv3xT7iGMfkTyfzHp44oDTJYRngmYE41VQfrxwVNRsEWBJC3	127
7639	2vatQEX7Q8BeTZPf9HzZUR5EyMEnRK5efevpzSDKHjmoeKsBYBUu	127
7640	2vbxSWPUHaiRCpNeL4eRnmy2vBZPek4LaZ1gchPbT1wSUXZ4vyJ4	127
7641	2vbZF1fo2xG6pRNkFqpf5M7TtRtcVdrfXVpdBxJtXtnY48cyfLdu	127
7642	2vaLVDj5qsLg4xZcafV4KbnwDWhEQfXPuLoQsaMYbuBJQ5CxqMwu	127
7643	2vaupSY121A25npCs2vomVbSW17mvt4iNBdxrqyiSQyRUjcL91nD	127
7644	2vbFNFSwvsqXhToaLwrxrFV2g3DZnHf43zJTpXkrwnLeXWxceU5B	127
7645	2vbExt63XKsfaX6T5tTR2JVB2BDdfHa3o1iGf3RykbHNN78cknb8	127
7646	2vaWGFKz36Bi2UhNiiTR3kv8JXtJEhXUxNqc8XwnBVbAAVC9fyjH	127
7647	2vaNTDWkHZ5sbMjiNaVmc425UpN7Bm1YK5NoQtneppVkDuf5x4Np	127
7648	2vbBRaPgknMNbX9RnkT95vDaxu4N3xtWwhPKezma6sFHjNrrZa87	127
7649	2vaDjJiayS1u9khv73W3FG8Vq9CqcCFM4Jm5ZTaQckfzazoXVniK	127
7650	2vbtc7QwQvqfcgsAg1XJxg4s44sE1tCFSAVGw2qfqQU7WMSzhXza	127
7651	2vaxHC9tR4zWCZZnXccZd22b8mcUHT72cVmELJ4ziaKWEaJRcLDL	127
7652	2vbWqetdi1NExFuA9nUeC9qgFCVSBYHVwV79xp5q9jYuUuZXK5Ff	127
7653	2vaHQg4ou6v2VbCYnaQA4eJ1vo52Q8nTfgjmk5GqJfdeQxpjui7R	127
7654	2vbd1xfpxMAKrtANrWLuVAY9yF9LKb5LKtedxJr241d7fb2gwCq3	127
7655	2vbeSXhNZ2CEbkotWDLK73KHaYbWZJmWYHaRvktnvFwKunfxsXun	127
7656	2vbwQ5nAm1ZcYpVEYEK9TbzhYJ5u11k3TKikcN5ph1um9GA8Bo91	127
7657	2vbaKSYfepi8i8hNTzDzhMGgSFFUHRh38vK2ienZPRjdrKe57yZx	127
7658	2vbznqVJVATuEf6BGWnywtZbf8J4aVQb4j25WyZjtAXeq9kEW6Ep	127
7659	2vbM2g7UgZskauVB59mxBMbcTZxdAaizt6W8SwFpzj9SbCTnZMwA	127
7660	2vbN4DnzYDGqADuWjJQKtkF2UPGan11Eo8qFnf4XpW2RRCjzEQSb	127
7661	2vbG1ouCauy9aqe3tiPnvfSpsW8HNWm46uA6LpKXuAQuH6in8aaP	127
7662	2vabPthYXaR7RBxwXWQDeaSPbJxbQdaTVeuNJTYJkHdm71UVZjQh	127
7663	2vbQp4R645hRbdFTqL65bFetGbGtDgTUWaAPZX5hPTyno7m5CZca	127
7664	2vaRQAUZxnRQwTy6WcRip7KcBmN9jyJwfYEvSKzHPt4NFdkdLXVW	127
7665	2vbsUmv2SB4YGCxJbUcT1ceWHoUFNNL8syt7Pv3yU397GtMbaLxT	127
7666	2vbKY3swfeSc1YQQwwjJH7iFbcVHdjY8mBmPy5yjgRvzeDLurrkG	127
7667	2vaxyAcfYYVAy6fg3vvymagbjHZSF33eNvC3x5KCAdzTgtnH4MP3	127
7668	2vbFhDnR1EWh8rwyFZ8PP53JCVDGN4yRGU1324yBkpktiRjaUyXk	127
7669	2vbWQAMxnJqthtsWqaaMd3PZ2vTpEfNm3LHrb6VtvPmTZvyVf6oK	127
7670	2vabq614W5ZR6Jj7oPzNzcHh7R5jZVShcCabo51DrUDhsCWAWVA6	127
7671	2vbSdgbRirFzUyQDpNERWHqJSLtKTmEbD1BXRNcPmCXCJDQJh1Su	127
7675	2vakDYBuaMJT2qjEDNLyctZGdRqBrGMtbhdpnkumwTd7nLf1pc1s	127
7681	2vagnQ5QepyjgWgDDChaZh3xcigQvASRuCExsPP2roY58ntHhqFb	127
7683	2vbNEasqZhhZNC4R9s1pg1bvwQjtyV9udnJXv5q41mrbaK9tGcTm	127
7691	2vahrFEZjJzeo5Fnn2JyXuYXThG6to1AU8LVEeEFoTNZogGsrxWF	127
7693	2vaQ2sKXbjVH4rDmmvPeJMB5yLTXSVDcytriipdhFCtPhbc6ypgP	127
7696	2vakV8yBGKB5nDqfLxGfQqZsNkxLz3Y2DzTuwBeBDyntbqMfH41b	127
7699	2vbU7rKVKsmgfDhL5nkE5jTkMAq94EWgvdHLS5XYcZVZqXmiEsrE	127
7704	2vaWjq46vWn239F726kG1QatLgrFYPbNfTDveHU9hSQm2XaxMj6C	127
7707	2vc4XycztDMpjgz1NQe8N8cWFRU9QwsSKHbpcxmHL81P2hThqXzM	127
7710	2vaf5CmfQTZHkuVBEPK1GRWcy1BFau9jyaraBJUNjDctSC47aLJy	127
7715	2vboTawsQQzvyRjH5cGDA529HiBbndKcctRaMK8bmwePB5pDjeG6	127
7717	2vbduRYyYkwU6yfFb8cER4C14hawkNgDMVReFjbJYawC59s4kcF8	127
7720	2vbFHf6ukQShQns9KLctEpbYN6oq6WjvBhhbkehLCrdbPasqDLcr	127
7727	2vakNksaXY4noyjpQru75wY5eUgEgcp4N8bDJcYQZNnkS8AiqUQc	127
7729	2vbBDKWXXg3FiGgyoSiMiwsWHshWtSwCGnPkQWP3qLYz1RDBu3Q3	127
7731	2vbWmyTifcGceqNGs8xeT4cUq4tTNxqanA8tm9qtahnqy4Y1bqUQ	127
7733	2vbbuqbvuhjNnwRLiSqvxTX6Ek3TLXiYAqCUMtk7EFR4jzM63z5G	127
7737	2vamTdkp1G7oJTzEgY6A4AivNwpi289cjvWYPtx2aZthhT4ERMVY	127
7739	2vb8BiQLyjW87qNQZEZnh2WrFT9SrTKzVtToBRSXbxmyXQK1uB9x	127
7745	2vc42oTg1csuujYp4zZDcaerPQ3EYKRogQbaX6QwsjxUQ7NpJZtq	127
7747	2vbqN5kZSeWpXcEB8CSUARMVreYBKLVFoFtpR2FdjcpQEcmYsamk	127
7756	2vaHpZEakoSrZNGYrzHyYBuEA5ug4HT1QCvNamnXBunVPBXANdN2	127
7765	2vaLt3VRXa6RcjB6QEMYdsy6apZvuZNvpcCwkVMwc1oBUXvQSSmn	127
7771	2vaDTk9gTo583gQQTcoGDwV15BuEJovgwEbEkGcYFLXuR2TVrwU6	127
7779	2vaKUnT6xg5MqioNZuHkG1ehPxzTqGk58aqa7QfW9WpvoUufaa4E	127
7784	2vaQsv3diT7phjQuJuvQYSef76GLp4cUTL9MTJut5BZ5pbUTxDk9	127
7791	2vacrcx7MHGtodwUgAY7zvjYAuFMpATtWprvMRwWo6Xc7GsG68hf	127
7796	2vaeXJQDqHgyMhQs2K3ojDuZeAafsgSUmur7tH5Z351NrxspemX8	127
7806	2vamnCxLXXW7ywwNXqcvZwcdPSqAW1vSSrEE4o5f97qv5rULz7DP	127
7808	2vbqS9TASsLHr1CVP6h4eAmARgE5NM5MW3F34res6zhRCgGPUPQc	127
7811	2vbiUEFsCRk9UKwL2nfdXKwHcia7xA91Qda9n65WQTSLG1MWBLQm	127
7816	2vb5EJ7BYXvyLh6GHrkn5DobDfWZ9iQRhawiXBLWShKPKNDbJwdX	127
7820	2vaCvCqThxU5aKozLqBRgJGEujprSj1EuLFFaTuF3CaXfnRnLQAM	127
7824	2vaxqncCyJum2ACgHbFpUqAqDAPsw4N7Hb92UPQ456oG9ngMfw1m	127
7827	2vab1bZCCLfUQ9tdkr43mZvTdYPCSpXx9qFaJceMc6LnDN8Cv5G6	127
7829	2vbYn9oKR6shH6XDnyGWsJdiUugMnWmbSrqgwxqLYftsTNXrLsaW	127
7834	2vajDhywuxXq7a8VuAfWUbTzNAkFo8wSQBeq55q6E2xrjKMrtYzc	127
7847	2vauahNJ2M2VrPAi5GNSWpkgji3PFrDWWGzfnFpFf8GnrbSMyAfQ	127
7849	2vasHEeE3Ur48CCWXBtYtUSAEjRDEkuNgL6a4uCawubTskdFcB2R	127
7869	2vb9isZYVrVG3iQpFcNkNkgoTet4PrBLrcqJaoB7yVmFXmuN1cag	127
7871	2vbhSyPsdXghsSQq1mL6iN5dpnv7gP3yD9JqBAHJUHxNk9xZmZiT	127
7876	2vby6QuFrweqKmNnC6jXuPV15iCncKpHqFg8UGEGLihykfR2Lsa4	127
7879	2vbnP5y8twxU7iYVQE1ERZ38PNkBkrrC2M9c2cyXoRwGqZFGjD48	127
7885	2vaKHS8nwGrwQ2Yo6Li1uATijNn1GP8LtihgN9xinfeFTJgFtX27	127
7887	2vaVCC9ssfxH5xa3JqJspRXV8jbCHx73tZ6UyRphDFEi7Drrx7Wu	127
7891	2vbL9pSLMZvaeczHHuGeLYMNSkZUptAKvoDSRa7nifTPds6fhQnw	127
7895	2vb2y3SNTMX7UKqqSHFuF7Cq4NB7v1zBQGrruMWtqzvYxJK1c668	127
7898	2vbknXWTAyC7SNCXj4JWaPqakUtq8ra6vC4Exv7GxVAbsPCUF7Lj	127
7900	2vbMGTLxasUNQy5GhfSyGpyMk8pXMy5MJYutRC9saAZDoGJCBynA	127
7903	2vav9zkdPx79vYd6g4TKTevU9w7AW1jAoBzCWsS1eBZfRPLoH2Sz	127
7906	2vb3SJNsvEuXLWj9ovhAWRBSHGYksAGp5Ue7P8XRCBrbqaT8Bqd8	127
7909	2vb5x3eDUcoJCM7Vfwt2qJBkqd765v8Kb9x764dpUcy4xE7YcJcs	127
7911	2vaxiXtceuLuEXHruJbLGuMviToVFcfQxL59UuspjgnqLit1Q6ji	127
7914	2vahter1qNQFgsem5iLWuV8bbEcfpL1s9kkQ2G4xtApjkkirr8Sh	127
7916	2vbJA3Z5AetkqTJewLXdZPLTCzvQcEhZZGCmx67ekzHfdKVJC8pj	127
7918	2vbohXXQwL9K3hXsLUpThRie2EyjY3vtob71ybJoF4TshvMWWPta	127
7921	2vatMWtz1GtXjbEeMnxzG8vmR18gGRWvkQFnfQfwpkakZUXVoy6E	127
7924	2vbVxbziubtofpYYaM6EdvN3DTJQVAgxHBARWiUyRr6zMnnCAdBS	127
7926	2vc2XyjFpSfYTCHFnbJmX6WcpSyAC4UgptkQyv3wKwpJE3Rtdv6P	127
7932	2vbZV9TaSBcvYwHdkDNBfRcRqVppMN31JdjB8ZWwvbq39fyTB39V	127
7935	2vbQ8aqPzmhL6pcjFqisMBQeCAJ4YSQx39ZyMvwSkeMmqo91WLxK	127
7939	2vbeMAJym6ckhDHoJXp4LtEcy97iBZYdG5qaZGoK5xjdrv5645KX	127
7944	2vb2smJ4UNQdZnswXzjTnGhv9DuQmFSs1qSFUqdKEvSQ27bLUjqL	127
7947	2vagLkXYsfj1bBmcPnsp9Moak5VicbYiPKVqY96nRKd7sjGUM6mV	127
7950	2vaLvD4ouW8DXhpNNhN71fffpLM8WsMmxUZDHh9RX5BnzzNACD6z	127
7954	2vb26J5Cc7JWhM9hzXPMPHGLyfhKKRxoRDXBSLZyq1M9kKdPczAM	127
7957	2vauepyapSdHTo5vaJdSgsuo2P4YrHLoaoSAAyP7XubkfzvEH7Ks	127
7959	2vaSb4B3p5ZAeSQHhjjf6n4K9E52SJ4dHK19E8mz2JKS3oYBzfJj	127
7964	2vanTPUJd2QrGoWN7SpepkQ5sR8kmephrogTMJMHpgyHhRJPT6b3	127
7971	2vapBCKknKrzV9Px1MY2gTEkCbTRDQndgHQRJU9B6yKsLFeRMKNt	127
7974	2vaUmdrQuhNQnr9C6QZtKHKkYrXz7v2wpQBANzqagooXiBsXRUN2	127
7975	2vb8ofTUr9AdUCKjzB3PgaqPdkJGVtD5o763uZ5VLiNrdfubm6HF	127
7979	2vbVYa3orMGYF1qTBRUfJmCwkNiVef8w9f2n6vtodEVkZcL7TxUz	127
7983	2vb5kWGn4XekBSxYvvvMTYzeehhdJAeJ2QbyNkfse4cw6CfNBvmS	127
7986	2vbUnwGCVziPP2xg1GWqxutCbdguNAeYbsUusgAtLDtpv7ztatPn	127
7988	2vbtTzWWfQ4KHFhNgWkUZ2d7LHEqUGxPpETb6vyao2RowftChzr5	127
7992	2vaEwMkxKirpajm9CfHNxv8rNpCitot3s98aJz5xrVxQC3bvbBNK	127
8002	2vbcHPSNhgNmrpZkvzaYzzxnRSnLzgHjqybHTHnYh3siEz64f6vh	127
8004	2vbJ19bEGVYkcYAmGkye1dXy96gKmqAAUbdLYYkM2xMDJpHkHper	127
8007	2vaWNwJQiuJvqThaJcCGM5yvHZKmbS8qFtYXg6KPTSgUUF22HZLU	127
8010	2vaAxgimySMq9MxgEWbtAXWEPJYRZCtQp2seMs9d2RrQuBE23E4D	127
8013	2vaU1yB5zaNzKQ6MzqgENNzy9nYqwEYYF8qVJV9DNAYb8vi7GJQx	127
8018	2vbxrJj58XRAFsM5L9NXxcURqbKWxDk5nhBcdf24suLYMjCutmoA	127
8025	2vatQZGyGjbmRyPE9EA2eDt66Vifx3GNXRTPhehNnaR5MgBQR2iU	127
8030	2vbKDnL6JPqKxo5PBoGVEAfEoPReVCiUgpqiJchnREPMcC9en7ud	127
8033	2vaqnWV5FQ7oJc9xkva4eNKiQFrYpk4z5Q77s3MNtQBbW3hpCTXu	127
8039	2vauoX1ET11ejUyuLziyQoM7aG2G22UioCQt1ETh2XDwmLSZrYPQ	127
7672	2vc2FDSFSFWnV2Z3kQZ1JnnfUgckDbB5ZVZrx69EZm47KaofuMje	127
7680	2vb95tjhz3wgmxAyM7ja9RvLYEwHrna7KA4tvF2sNrVvxZHqrX6T	127
7682	2vacr84UFvGCXPsVWwEBNhpnNZHwYFQggE8oMY1DSkLwt6jeRRrn	127
7684	2vbKTUsbAyVpvoxZbATUmh8F9ewnoAWTiDAfZ6M9qBtFzHUBfJii	127
7686	2vbr8T4Z5SCUCuKKwRwPh32VPgvLYfYPmVyKY1b8BhttBM7DaoMs	127
7694	2vaSWT6G2LQiokGE98tQLyT3AnbjbdPceNnQghGH3CfXJsQ3BHcq	127
7697	2vbunGmDPndGPXCN8UBs1DerGHRbvwonwoaUS3GccMFZAEk3QGPG	127
7705	2vb9SgGgERUcekLqughnWNbPVqPJKAAM7YNdDZ6NokNWatTGmk78	127
7708	2vaGXmPLPquDd44mvNCypX3aPXTZmVBXLZZ3fA6Krb8dUeJmYLcD	127
7713	2vb5H8KmwC5yb9HevCLRRd7s92EHidQQkdx1UquGCHSEgoCqgy1X	127
7716	2vaaBMkt1rqSZQqQWqbzgmDUmFtSphv7JdvmA4eCLdFZah2CTP5H	127
7718	2vbMkZ55BDsTaREshB7hr6AKT7HJVk6BRmRxnCEoNZ8UVeNjcTSa	127
7722	2vb84wkjKdkBK6r7bjH5ha2cRDqxw4BMdnfGqE8Pd3NmTnqNnpd7	127
7735	2vbsE2cfszB3hDu82tphRqzbCyDoMnMU7m8kYZvJ8FzxqJ8ReCrt	127
7736	2vbV9zmHBbUm72mxmoE1qQA23wdo39qbUYoFwsmurqq1e8s8Q1WM	127
7738	2vauC4BPWFigtZfCdZHF2s8YkTW1dcW6S66Pxn3J4DxLhwBdoc4G	127
7741	2vaLGUbWNyyjVAjsvtNKW9W3AtQKyTuEz8SJKSeBqfbFgPDyFe41	127
7744	2vb1g7vz7mAm2F3UadCSA2SaxsAmnYA2jRiXqa4BN4oUhsaTF6kk	127
7746	2vc4wJHpuJPN3q6G3rVbk2XCtAvB7vc5eNzJ1HK4QFm1qcXw34hE	127
7749	2vab56hbisJfv3omkrhPTUrhxBsKzAd8Q3etoxV7r2SW8wchLaDN	127
7752	2vbQEA7dATLXHLNFzyrENVZ9GyLNiKcbSdMyJ9oXWAEQPPuhASka	127
7755	2vbRcQRo5pjrYjQVXUXXPWwChLvwjyW5CEvUvqULBVC7tqw3Noeh	127
7758	2vaWf4gBAU2LKpxXk6zHNcyiVWAWWnGgrhSPDEHUtVzEUim1Yhmh	127
7760	2vahrTsqysxvVW1fu5bUcrRCSvWMmUaKaB9tEh6YNsJLi7rLbuEQ	127
7761	2vaP5qRK7RTQGDuHz1saFDHbyUXUmSAM4DcXU2YQnoo9N3tB51bi	127
7764	2vadkZEQKU5kEUKy97hEUAdQzi94y1YcsM738T6z3aKkq39UUqXA	127
7769	2vaZffvt32Q4JWnTx5LXbDxsVwGiwh981j9jaKaAujdCu7M4DpDS	127
7770	2vaBchqWPKLgPJi2f8KKUYJq16s7sjLr5c9Y5PcNDyLwQs2PbvgS	127
7776	2vakM4qBra2yZV9RkU65fTJvxDTCHqomL1oTRULXra9ZkdyGvBef	127
7781	2vaR6NmL9suCAatMFzgPhqfdYMz6XVZCTVkozACKTi1SvSqXqUuh	127
7786	2vc1X7986GCMoq5AQ9NgWy8CDJk87xL4gAX9ErywNc1vZfeU8dw1	127
7788	2vaaeRsM9i1CSf9Hzjccc9GJTAEeHhgmBmKu6u815a3sqSg8Dy2k	127
7790	2vbt7PCUvbzXy4Uuja3C3w7vP7C9XYPrkcPagTauPPYYAd1R87hj	127
7793	2vbzSQUnfjF3LJudEc4HmBHoBdU28JmA2p3fYYC37gMaedQ22UhU	127
7795	2vbYw3CcSxLW4VKK3hFbozTLfGyX2erjWNjy5b632NGPJB77Pmtx	127
7798	2vamX4wcGu28A6DEMmWTMaaSKmLHBo4BWdoDGBU1sVWMFaSg9p2E	127
7800	2vbXUVuaZshRrQcc66U2RWdrhxdDeyk8hhJgPsQ1iEqmWoCtuAi9	127
7803	2vawu5vH2MQLgT8siAJhpjgxkREFaTdjXKhShQW7sM3K3KSMGfz3	127
7805	2vakhLzmnz8j9XEdqrJSVMkWfBFjeJ1UtmAhUbCUs2ZtKJxKo86S	127
7810	2vby48LdrkRbALMq3q4jE3dfCQRTdzx1vgd82dBnfAxG68SP71qA	127
7813	2vaSMzfDu4y7MnoxhSXbWqySTFPLYt37T6qJAozGSUmH6keCx1yT	127
7819	2vameY8u45pQWa7fjQT24TncrHz6KyUYrkqy5z1RJdJYnyATwfPm	127
7823	2vb2a4SqCijni3x6BpbEHUKKFCzRzSL13xD7MeRcXwHi9wF8QgjF	127
7826	2vbuNWMxnZu3MdF7TUZTxWpDmH3oDe2UZ8QX5zZ5hqQMEifpfg9M	127
7832	2vaBd2RN4PVEPfvA3mgNkce3rntbZKbCnA1KXDrD1ab482aooxrF	127
7833	2vbhZhmwdbiaTXjuhYz2pFYRhouipoejPXFPgAFJB5MPBStfaEVF	127
7836	2vaMD19tBZHriBZTiBBW6LmsrdxTHBM7nm6vSX3gXnfg8rw58WsT	127
7839	2vb5VpepYE8YAy8vAkXaiDUZRtFEoJGFPtCBneUMpWKfQ2xJhjUo	127
7841	2vaLg9jmmpH1Yh3T9AUHtkBsdkJ6zrCcxU52wQFqFjZhkK733bRS	127
7844	2vbJ82MyPQaL18yQYMnzVS4pcP87dfCCJYq155BgiQF9ZD2BbpnU	127
7846	2vb1dJfjQkUW4TpMrvWd7zvhVwGKJonp1TppHxVgcCyCQC1ka2vm	127
7856	2vanMRdH3ibmu6GLYeCwGcry3pnuhsGfbNVY4fvgS1JfZmQoNRRV	127
7858	2vavZDCAFjfSTFLSHoTGEN1hoaqCbjE4B6yoom8Nn39BXt6TxisT	127
7860	2vbtLTwtLeEJpCpDdABYS24CyFd6rddqnHvebyNp2oPLoukfqUu3	127
7864	2vb6grwX5H7pvWViUgK745cDhisxnZrZFCuENhB1nf8AiWXB5z3y	127
7866	2vaEebiNsAcwgE9Pp6aMm2RwTquTdLkGSECnk6X6Ru1LRG9SAyaU	127
7878	2vbdQRP4PUZp9MZxnWYrEB6njmpkctBe1bRnBg6ybx5r5ez2K2tD	127
7882	2vboPJjb4TaPDFaemGJJaS5ptyyZJkNkyMyeFiLbBfQBZ1rzm5Ue	127
7884	2vaTJLXkE6rwLe1meb27HVQJmGbSXo4Csu9zxMtHbKXrDUo8HykZ	127
7886	2vaZXDuLgZaATVRMXHd15oKppRk6whrXkuUhMuzNKuiqPC3SG99H	127
7897	2vaKAusiggbsUcMgu9ci5yzJiVTjCoGM8FktV2bcB3xyiBTBbiDJ	127
7902	2vbXgMWci26ya9ypTgcUiVJMRPZUP9c9P8VQp1FGAn6SQ78oXSGr	127
7905	2vbb1zbYgmFwXnBuhZGDwP9Eb7TjYhwZwk9G4CbP816298mcNURo	127
7908	2vb3rccbE5qvtpQKHxbJ2MU3DJS3kCuzUbnnYL7GYBe1aocMFFnT	127
7913	2vbnCttFiyu5qgAiafLczNjT9AKmCQ97cyknWvgHE2e7n1WRtQAB	127
7915	2vbb5pKTEZwXDtdsZjQxS7AKKgMCystTrTQSmYdqjiLD4P5EADSq	127
7920	2vbQ3tvXpKfFEZWPhnuP8BttFXcKXxcWWPgZUE8P57SWmXu3Mxd9	127
7923	2vasAHfGXy8iMvGrY3UMVowzsYeZo6X2LN2bgJf5LmHQAaZVERjH	127
7925	2vbg2Bjf2f1g4PzNFsGJhzEUbY2mL8QebGu41RHQnLmFa2zhjxaW	127
7929	2vatixtcPtBiLf8x22n9C1Xq5hZmrL9XiGXXQVJMqn3SBS48ZDsX	127
7934	2vbnNqSjWL242uSnzjFiLxw7pvgTbqznop7wcoZSGxApLT69M7Kt	127
7936	2vbyonjNN4zGvTLeMzFFoAyJK3y4ZEycWbnznUiArRZJGA4HuPWi	127
7941	2vbZfpFDu4Nd9BQhnDCXrpqnMgHGsjv3BedCeUxHGi7rU1AvZeXu	127
7946	2vbFYtncTws7PfpndWneHxdLxdhowhYPHqfR5V1hnE7D4xzuCn9H	127
7949	2vbi9Gz3yPFgqfVMiXaf3FzpF15eWZLcwZtimn3rJhJ97kKbxZaE	127
7952	2vbymXWF5wRwtRQz9VSpojTWt8UL2qguvbYUgM3dH65ujjqq6D97	127
7956	2vbprj1mDfRNByTNYii4FcoSVHFH5DfrxTVmMVkJP5E9o4kUGYSZ	127
7961	2vbn2wjuMVRWiqWP4KUkXmKEdNMLakcJ8w3FdfiBPsPiRdJye9qf	127
7966	2vaNRvtc8c4ho6EVVnMAUisSHfAxb9LsX9yaE1QCVSr1q6BxZQYL	127
7968	2vbEtsCqVga8mjdeW56Bs4PMbtPSbhi5mRKYZvU5t2B39pNbmwvi	127
7978	2vafFtYrXZeoPjN8MXkwqFs1xHLyZqC6dyBNcw6nFVBp2tA1cPey	127
7980	2vbW27cmgZJszr7oNV4y4zt3B1sXpVe1hF1gG8m83stDe8VAaD89	127
7991	2vbscG2uzor8JqhPphceEHiaz2EHrb55sjXdxka9TF6ENTjTzuLt	127
7994	2vatUpSBWjGtt6zhB4tHHDahhz2gHCo7awfhjyedaYzDTDVWazbh	127
7996	2vaYVt5GjUMzJjTXCW6qtxsWRm8FSWvqgnbgVV1BboyXkQnkm9gv	127
8003	2vboNEsgq9jDS23zY6Un8vttKUsGsz7vuoB2yacNubnxj24hfi6L	127
8006	2vc5jsJefGjQZ5nbhpsj4UjnurEVNvLbWx5MUFfSrFknr4HNuQqN	127
8008	2vaWoVj6pWVCxGvcPMEeMG4w9km66U9KX75mUHDbuKPz9b7oATgK	127
7673	2vaZ27zLpnLmU3Zw1EBVoieBmDNhHpzPVK4KUiLFADWYhGkQM8xE	127
7676	2vavzsf64aaYnQxaYdHUaDK2f29jercWkYP99FMNE6PYHZpWAUSf	127
7678	2va9um1GmoCkjsqu4KZRubGtyghDSoqtdEBD9BR1reLEBVbeDcxt	127
7685	2vbfrYpK3aFWVQ5Frdyvwbqeg9KE54uXkpQHhZZpsn2XWcKchBHU	127
7687	2vbDEVprxLtHKz6JuXQ59VSVDaMJ67SYuykgtXozYzCHdeTTESEM	127
7689	2vbGadbFmx7VKddyYwJhW4yce3ySS7gNeVYQgek2kBmSeLrMyDhG	127
7701	2vbM34Vy42YyKQyvbRZuVripotR7CKPBJwiokg3sohS7SsPLgRQ2	127
7703	2vbRPrTBX2TWd678rDhYEmxgnuiiDk94ZDYs713T8XgMzLRV52bA	127
7711	2vbfAsCGTbCSF4bYTsy8Sh3KMdAjCUz3oNnYpS8b3gEi6uDt5jSB	127
7721	2vc3HGd28cgVXB7Bf5dcdZSitFig3sHYnDqD5UwRsbyH237VP4mA	127
7723	2vahMmpMCWqzxMCogmVnzwcftmzpKj9pZxhStRRKfETvYfow8xkw	127
7725	2vaJiD1Z6ap8rkLQGsQqjjzkyH5tSKXA4ZPWfVdGidbuyh5HsEHj	127
7732	2vbm2xvr3CC3usGU8VuJEYcN29y7bgmBwmehwJuqzELcTe5djEGp	127
7734	2vb32DxTuirH7T9UNA7pyXF1p6f7tBgpR924u6TwMkSu4VyFTkn8	127
7743	2vaFKBoDfDs4ProVhuXPLWQQRxzeDzJc9HNfSjp4r5SQQVK7pFYh	127
7748	2vbHiHn9YMkK2L5BXvybVuZaaoNvMz4feY4RCuagCkS8WhBB1TgW	127
7751	2vbygmPkmQ62q9RP9d8LmwcftqpTk5ty37G1qXPedfmTezcpnR2A	127
7754	2vaJa3Dj3WwXHVKLX8Q8ZXxDG2vjeisQAFKo5CoRsA9X1AVJnLQt	127
7759	2vaoiGG1H45rxBCbMAMtrBRqXQyGLgGLGUE6LNBp6o9XwX7HLQNE	127
7763	2vbQMniD81Q3uis5oQiw798B3oYTZb3JoW2TFpHFFr4wXnsBYcyu	127
7768	2vav5wAVKjvJ5xEHKDrK8SY6RiuFKi5Yocxs8TnGNqZtHZ2bPFpL	127
7773	2va9FZkkoBjHBZvzLMfBHWzyrZNpX4FBM6MSnQM6tLHVbuGV89Kn	127
7775	2vayJR7sJEtb4SaNoQj2AeRYJtSXxCqobBGKGCJfZPs8oo2kZJHi	127
7778	2vai98MAkJHWpb1T92zVBdSDWoaXciaticTENn5hQGfxrtMgbTwC	127
7783	2vbbJDuutq7BkrH3ukWscw3UmtidJVYtd2HywL2x1nxU6bZvjmim	127
7785	2vbUXzwUmcLMkdyqZ2GAccCMVNuQoqCkwcBcGFrCAJ1dKVfbBTAk	127
7792	2vbQfB4y88xYpbA2XAjB5FhhU2qw6UkKjCAhkSYMenGMK4tiExVP	127
7802	2vaMPkFjcdx3XQSijuo2hPATqri3fBUMjSPWELN6fGb3ajcQiQES	127
7809	2vaWizVPzJ7NCXq7hriL7qBNxMTJ6rzM6Sis5xFF9hqMisbR6qjC	127
7812	2vanJPAeKVv79joSN5CaMGmUxphSxEna2kRWJzgWZcbi3y1PHBie	127
7815	2vb1qdrnvFJTkMKhYp4Bwxnz97DrasU9yuHu5zwAkaQ7gYaEn94R	127
7818	2vbyPpLZPTtBfSxCtYqF6v1MfzxkP8JR1jbrn7g7C7Rc6uvGhbaN	127
7821	2vadsX94YvWD3fHJRDuzefQ8RS58CLFnjXBwYbjhkuiFbiEuY27t	127
7822	2vaazwXqQAjyQ7tEWrHub7ggK8KhDU8tgoWgxMopj4WDEKU7aFub	127
7831	2vbAHCQMWz8LSGGCJtzLXrPtcUtjcKtBAg8ryH5Jy9JU5qhhsWab	127
7835	2vbjFPn12fyz6hWTsxMXMctEZ7NbnnbWXhwuT6oo7onAdUg83GRr	127
7838	2vbacu1QXE4cJyKdBWRbZAP4d3EUr38v8PE4VrLisrQAE4GfWSeQ	127
7840	2vaDrFXJEq4YL8BEeiNbeFLBnBXmkKUmTqAAkZWVKrzRMK3bimdt	127
7842	2vbhGSmi7qtKbBxsyFanvFNJEhdwZWHZLS7uKwMgBiUv1vSaZwHP	127
7843	2vaqxWDnSZkVU3dou1dUcSNNsZpyRu2tkbRrwYf8dpMUcFL83EBe	127
7848	2vaoYnwca2Mid4WiJocLGAJMMq3XK6dW6KmYHsq3iTj99FTR4uBh	127
7851	2vbxp86Bp1C4R6WMc4DP1VWXru5wcdQZ4f723QbAdZUEBnivAYqo	127
7853	2vaTNv5qutFtf2AbifKvcXinkL2umkkduncFyH82HU8vYRhjFpgc	127
7855	2vbFrjeytTWP4gdQvDZLunvAxEbunrcGRM7fmSdJAziHTerneXCh	127
7857	2vbWNh7emhS3TNHLt79xBrYNhxzkFUxkXAneEcCq1Cnhc7kP3poD	127
7862	2vbi5sSzD4mkHpRfM86weNMbR1BmzJRHxkNUTL16zvzb82ZmYBkm	127
7863	2vc2fPjVd9zcXgAG47fHfGyrBJeuGLRiZPz75zsUmoan8tPLzbbj	127
7868	2vc5h2zVFpquCf8uoArsCBP4Z48vs3PfBi7npLQJh4A7jXpqnCGT	127
7870	2vbpvbkYJtp4mnKqoHzfQvJCem1o4uuCbre4v87dN34M22SjUEkc	127
7873	2vbsY256hYHEwJ6hPLresKtx1agge2DPf4k4XTTUJmCKaLWJojK5	127
7875	2vaiSqA1eYLmdc9e7aNjeiu4SHYPpbHPo99EXojV5stFxuCzwjcY	127
7880	2vbiB56c62DZNXJJDNkR1hL1iDB9Ah8FuDUn1x3muFA6mLHBAdU3	127
7881	2vbSDTMCAb6mTq8kXe8tAbvgsKmQTDxVFtQi6qLwctSHgnai7eUC	127
7883	2vbacMdjEFs51d68Cjdy3jXVQPWdUPaMMa4ZZmFDCjDGdv5NZpHq	127
7888	2vbWebfqR1mgh5RXSdTw6rNfED1rDNxrvSuEb3zdh9UdPqDzJnrU	127
7890	2vc1a2nN11vmB5NBk6ud2x3gBEkAjAAXYgrFodXuq99pbnCzrzd8	127
7894	2vasJPAV342AuhqxzM3vuihe8cuuLvnndVu1Qt18rJahnYcXVCK3	127
7896	2vbzueLCofAVxGoXP6GAvAB3fDWbMPdP7hswmY5ooPPdMqees5Nf	127
7899	2vbRFvmx5Xd5pB5GjMK2PsFbZZGEubFaCcT3QL5gDnBt4q2v9taL	127
7904	2vbAbnuLb5ecUD8QN22m66yRXMkANMtNT1GcJfhiH3eghnbpPsoh	127
7907	2vbNoKnMJLSCEKUJqFoWDnpfPHdKc5NxvyPr6LUUrvn1NWYUZYzP	127
7912	2vbhGTL5jby6MJxb2a9haNp4MPnPDqwM1DdHbkGwTEgbAfjHi23G	127
7917	2vaXieheKNR3aDfvyoqFdaGkhKi52KXX5YLLCTNt1pHEek5JUQvB	127
7922	2vaJhrtptw7ssxeZteBY8fGJSnn54jAphZ5wqHhbzKGrdGG1d7bY	127
7928	2vayXM5G926Q8HXsVJBFXkFwjPMECRcF5DzAa3sBX3XFxTLVLqam	127
7931	2vbkm5FBK3A6BwCGuvegrxchGU7b5Av6VJFyAwkPWfFyEofxY6R4	127
7938	2vagzhoxvH2MhbRNqhErjxUgtmzpeSFjNPoTZbFXhMDzVPNp9dgL	127
7943	2vbzuAaQECUZLxcGQYfe6amKHnSDWL6gW1Qvab1hDUx4Sb4LpaHf	127
7951	2vaCrkZo4MD25Kdjy5S5T4tX4KHv6YwXc4bi2CTGLCHzKKaNt6zu	127
7953	2vbC31JZvvs4s6XXCFLr3nN5P2pcw3RHJtRhGYnXcisRthhgKomz	127
7960	2vagiHC2q1xM5LxnoHz6DAw671kcsvcgZBm81SR6N28uNjWzC1Nx	127
7963	2vaDZ9Ve6nUNxTwkBXdcQa5Z2MdNE1GXGjF6ow5zeUPNBxhV3tu9	127
7970	2vb7nHwnUxDdWu8EM1ERTYL8DoXr3bgK4JCVMYa8dCuDV2rtutnG	127
7973	2vbS954cRiMJnUo4n8LMabvjtrRr4SnPUW9dCak56Tmqdinid5ij	127
7976	2vbazhzHuwspu22XCBWfsypA3k1RoLcgqua2x6gqCvxuLPiuB1P1	127
7977	2vap981prtd6n2oUowcQeXxPFjBnjzB4nWvogkCEerr7ZftQEnnt	127
7982	2vaqRd1ANFqghxvaEVwScrRxUS479VtoFPPPrmRVthZTvnCSHNiJ	127
7985	2vbdmVBhBYh8iU9fkLbTBAj6jpioxFJ3nmMsySyMbsdzDqTsyjz4	127
7989	2vb4H2fHTSk9pL9NBQW7Rz73TVX7JzzJHr1Wuc1enCDxU1fF9gqD	127
7990	2vbJTq3dj8StQgH642TFhN9oaJVAMeCXoqeHtT63CZjva1zdKowr	127
7993	2vbi7Ebtx1eKp33LbPKPHt8ccCpDcPUt6SrkpuS6BbVhkoimmEV5	127
7995	2vb78Z2WKPFmQ6TBXBNaLSakupYRTkZ8Ppm46JXsxwtQ8dE7s1by	127
7999	2vaeTA7a7NhFZpGkVkpVWN8C3oqoKRm7iR4ofSvv1unVz6Sqv66g	127
8000	2vamSz16y8npJAnxudtCsLyrGYQkUpYogLPAQxQYDMBAJafPiggv	127
8005	2vbYZcRdLsaz7ZzdCMmq3LuwcHAd8YctExDF6MWaLHtQ7rN3DdYf	127
8012	2vbzUYJp3QDiFJuxvyuEH2dAdt6PNgxuKaCMSs79C5VfyFNJ2SKJ	127
8016	2vaS7aruWUAC9NnVKWDBTRgt4nGpgSomuQ6GrhkXxk5ARCVJGbqh	127
8023	2vapSZ82WxPSFELLwzRBqy6e1CspmZ8LF3pDyXspHFCh9N7kwpfS	127
7674	2vai6uqUq7NfRyUDU3cgphJmfWKT1ubGQw2ooFtvLYgWqwma5uwV	127
7677	2vawWuuQaf5PNmpWDNAs5WrUiGTsWP5qZENj4vhTnEUhaPSuwEBj	127
7679	2vazDLMJCwrKmYFUJCxwKV1DoYf5NWbDcSSv2krMDRhz7bEQQgGz	127
7688	2vbYsrhgLXSo9fo4cjxQxHY9JZNmvPjgStRivj5My7KkfUt6qPYe	127
7690	2vaQPguAfBvrBnB7P8L59iEQ1hfddbSpLNcV3GRM19usv7Y8iCCX	127
7692	2vbK2QoU3u54zH3mksrqEgCJ3aeqqrRT5LyG83Kv3AvdFJmTTvMT	127
7695	2vaozLV3U9o8XwAoF7BzF5WE8hL8mybz4YPQQrJWym2e2RkL4JWs	127
7698	2vb6WLAWUhFSSehyLLBHhmV7YXbu1FLGWhNMgRWGTmA35zQPHZMX	127
7700	2vbz8Yn2jw1Mt7XzC6s3Xf2sGyo1dwYWMSW3mgpK84Jy2woyZNTB	127
7702	2vbBvFFXCQHTcRAEUVfwDzi6MvmTQ75RtnAE5pu1t2PJYncQLJLk	127
7706	2vazW4E2kJd7FVKpk52FuQhi3pF7MWARgUXuAx97anmnsijzSW3x	127
7709	2vbiimjXZNp6LqNBswRco1wZCj1viHASYtT8WcxQ4oiLt1ABxk4P	127
7712	2vaJGEj8wYv8MYcvXXg4oiPtaxXYL7VixtfBR1y5rh8dCscSQb5D	127
7714	2vbiuSSV5FaeBUbDWcJP3PZAznY3L6DY93uq4bNozYgemBjCJqim	127
7719	2vb8rncS4iwKnCgooGWKCpraS2WA6gU1p4DZrMmtxWQVH8DzaTfV	127
7724	2vc4DDGpSY4wZXWLu7xhoxvgi4sbDn8G2x7e4YFziezdTSW7Z3iJ	127
7726	2vaVR9rEdYdrrC1Dn6UW6vXNHuY7QtjMyW8i8aYQ1iHQ1M8jhZsK	127
7728	2vbhA5WpBWFpXXKeHDdHyrLQhsC76UQKR7ofKodsCVx3YE9qxZtH	127
7730	2vb5FtHTrjUWkZU64UszkWgAv2KYtAL13dLrMRtWXU8Q5SVFfngf	127
7740	2vaTiL86pDR2uyAyedJqsRPdh9uDdZ5ncELcRHE7Tx3EPjXkuyqD	127
7742	2vboySuBBPvrgePYTKAAJsJBvQXq3rSZMNHLj3iNckpYkeLkDZfn	127
7750	2vbxsaubuGGMi69ypzd6xxmBaUBUCC6c6toQmGkzXaNKPZMrCj4Y	127
7753	2vbF8iMsCzkHs1V7tohtoLgjwtpBXEek9K9GXFMMTokPQu1T3qsk	127
7757	2vbcp5jFTCMkwBVUDD17K494B1cr3ekho7pTCWV9EExzYG9Nnqb5	127
7762	2vaFCgKYBxBM3ejps3fLz3r8n6MCwtqMptokDfGdJ7H32HubKqdQ	127
7766	2vaaV76Wv1Nev733LYCn9u85UCrqxXWttDsoERjBfjUjsdDCCYSH	127
7767	2vaRVy8ZsbJahGLvXmM5kPpXDaJ9ro1GiPY5xT9SeXMPE1XQrNJ4	127
7772	2vaYWtszcPUbHvyLYXDybzJpcXw88YrX2dwsnVaktX2pfcivbTbT	127
7774	2vacf6KBTVTexNXfyGyFngJXTXhdtVtoznS6LcwkAcpcBV4ChqXF	127
7777	2vaZ2HeHdjTj2fRQggUBduARiCprZt5a3YDEC92wby1gYsDj16wx	127
7780	2vbsLafhqQ6PLiNAjwXG5swT5PFv2HEioWMLaNcLKueEB3GGrFRz	127
7782	2vaMrNCViVSmpBAS4tHNe9KmuGdPyNoNZAP72juV1qm4RVU1hEbx	127
7787	2vagQLTUPQmYTSyGaygXC5KAeen28twBgDNVGG75mvgRRam8vpQE	127
7789	2vbdLRqkFfjqe2hQjFqUxLNSXWn8KMzBpoBjZFy4doxL2qeD8w6h	127
7794	2vaFFuPq64maMGJWrxT5Eqidgzkzj1m7HFGz4TWw2yT6Tug6c8Ng	127
7797	2vamWX56KebX2RVWZRMcrBSLmHc3StKJ5fCKWzdfy2BLj2X18Zw3	127
7799	2vbMTjeiT6z85SGbAHo1MrwZLSHBQLLVtxd8RsS5TDvfyc6axWdo	127
7801	2vbpRPNu7oeDpfEs2FLdH7Y36qWnK8PNtEVg53jdu8FenAdvQgpz	127
7804	2varSiPxbF5HcPc119g4jf2Earjhv9WvGu51nY8dht1NKPPNPh55	127
7807	2vbDXTpbpNWk9NhGAQHPsGpdqHuJkMDKasW9FUq26dmrgEAcvrAL	127
7814	2vbLWqs6DjWGPRAZFZkRgmquF9vBzW6GvxXUQZRgvk4oh4mqHQdQ	127
7817	2vamfpy1oCmf1E8SL5w1VavKY2e3mx9suYkYG9yPQ76okXszjaYd	127
7825	2vaicTxswudwsJuxMN1tSQCtJPgJ4WG1D8tdPkdkD66EMEdgGWj1	127
7828	2vbC9zpXe68m14AM7oCz5Gt6kGFLQun2KLezYpPmbxAociYZMqXk	127
7830	2vakHtWE6Eifa5E2xseqrFSAiTcbEFXN8bomHQmMEcw4dcuWH7BL	127
7837	2vbz7DMn1ouYs9eL9VBRDnqaPLFSLuQ9f3K3yVGXXzcg59bSusQ5	127
7845	2vbNDEKo8XSMJx6y5jcim95pZAEu2UM1aGexyfFHRunZmhB3gCoa	127
7850	2vaSdVi8EXL5MySqHnZQjsvKWWUW5UuvM1yxeCvnKXskx1PbYyWc	127
7852	2vaoBju2hND7g1KvWjXGZy6ZxG7udD5M42YJo1qb6YREehUc38pp	127
7854	2vapujjBFrYZnWM1U3fPQTEbYBfQ3Vx579Kb7XNMAqt93reLZKNw	127
7859	2vbnQBfQoGtx3ozC6bmJUdLfmEyeM3DZA4ZQgVUoKLDPT2jHXidP	127
7861	2vayXG5ackUsLGYxg2JLddacuTo9Anh1jcQrVp8hGtUqGgSRmoua	127
7865	2vaYHUdxjebexPAaxi1J5mqs6ivMgMJ8BURHu343Ebo8gXKTuPSx	127
7867	2vaPZ2vWEU8E9UVpGyeYy1QMKEoqMiGBmaCEPvnEp4JE7qJbHe9Q	127
7872	2vaVNLguiMbXDWdhh7qM1nBaBxp6cRbMkGJ9bi9zuTzENNydThHp	127
7874	2vafzQwhKRsjDheCF7wTatdf98ncsV7CGaDQDJu61RfYaakGHR6U	127
7877	2vbytA1gPPZKhwgwvL4AqVsn53w6wXmjKCpgANyjs1FfvVfNR8LD	127
7889	2vaq1fNtUkuCh5fjQWLcQ62Z3UD8yJPUiP5zUwuUCskfCM35DruW	127
7892	2vbWiE1CSGvXaou72nVDwTtczgcfmLyBs7FdnPPCV8bHiceWi4fB	127
7893	2vaqkErX7nFjkbgQC32kiiuHhtZYydR39kHaja4EEN5AQVffHKfq	127
7901	2vbhQDG4z3tkZkNK83imKqBWqhQGR6r6k9DijAuPLVkBtYng1ygp	127
7910	2vbvgSkoYqsK6QwcczhwBDLjdwdfJrt6Y6aVwVLu6XCDJdxhBU9f	127
7919	2vaSJub9vsbzz7JGg5hsWEf3UaeibSKzb3nzqApjJ429QtaCr73F	127
7927	2vbA6EkY6FrE2Swnj45k2gMYK3JBTwffu6pKD5UQWkr2H9YbEn9j	127
7930	2vai5Gv8AvkDsdgLpGQe2ZdSo7yPzZWJycNSLsVjhZV7NULxbSeU	127
7933	2vaqyV6T7kJ7TkFmsN1NAdKvV6LMvCvGVPkh2SivhgZbSmXiSf1q	127
7937	2vb1ZEMKQCdKJFwrDvicMFysGaPkL2pvAFEhKNXvHNdmJBM4zM8m	127
7940	2vbeVe378GXs9qhPc2QKj2sVTwo8hAnUwDNjPX6Af5fQFQREadDe	127
7942	2vastSvmUJJQ1VpNP4vUXU15TDUAynKda28f3tAW9HeXiKHm4SMT	127
7945	2vbuSqTVrC5GmFgFG36GsRtS1D1GmnpLartJ6B2FazSLcuY7zCQs	127
7948	2vbVnmqVLRXWQDvNcE3FhGAaKF8dDjhEvSk36eLn9f9TWpmjLnhf	127
7955	2vb2aQZTMXNXafA9wDH48WwmVsMnMUhvNfjXXqf64sf5EfDK1xDc	127
7958	2vboniA3Knb2AFqBDKJjQppMywB231qcaRX5iPH82dfZZxH7VX8s	127
7962	2vaqzNZWKnqBf961aQe6nc5DzPcsHwFdw6HaTsC2TCyh1jCQuutd	127
7965	2vbwBMArbfL1pKpHn38Ldd8hZcmhAqvubNVHQ61NL3pJ4GPEucMn	127
7967	2vaSp6BiVPXFwcfkKBYCYGaaUUzfe3dQBMGFBTuAb9QePH8zBwyf	127
7969	2vabGCDyA55JwozGPumtbgchEq4KqjFjn57QL9MwtuoqedVJaDXe	127
7972	2vc2tCVq9TgcPY3grFqaqvG5zUnMUFdMGykwzxjmPJLFwnkdWKPK	127
7981	2vbq51dUhhS1YsrjT9U1ivhku8e5iaaBqMpG4cxbtdxfNahn38uW	127
7984	2vbeY3YLRyB3Tvyw8fEREgJxP7CsVuhXdfHynf15vwutjgoGKKQY	127
7987	2vbQTgXP7zDPxDsA87CJ9TVwAMFcXriwTDcW9vuB1NiKR9XR4QuM	127
7997	2vapqymXq9EEfeakCpbfKLThAQqp3mmj4vVGhKVFmQTw31BywQzP	127
7998	2vaCiopnVNhhkCfjG8NYRMziScMyD9Ti3WfsKajwcQEsjaCAexnY	127
8001	2van5xvgpwHVrMakNMGt24CMHooF5ghX4eNfTXfuPmRxxvd3hkj7	127
8009	2vc2cWNNcTrto2PWvtuJQYVLmTt19McGsxHyWuRFmSFFqMfxVeUw	127
8011	2vbo3uWjuNYCK4q3ZkEWH3X5ERAshL2Hu179r74ophPNfvhyZanR	127
8015	2vbTaJUz7R4EUgZRUSTgSfUtE4onAH8gVSV8g1AyawPrGh9qsF1e	127
8017	2vaKEeCd5QLUpuh2MWoKjNEHJh1v4nRcM9Bh9bHhdrnP5nsozwzL	127
8014	2vbQS5VJ2vQdwgAGSwJ3vuUGJqyF5urj7dMLbKLnUPpbbc246ZW7	127
8019	2vauW5G6hbBw7iaYkVhiCYsshniRCsykGg8meKJXk9zimpX45ovu	127
8021	2vaMMG59NkK5tqo5NxewCAdPu5zy2n6WMw6UHFdbwby97AjC84na	127
8024	2vb1JnM7DBxmg7Gca2DGLRVYjGrFp4CjJPZUcLYvXZNaaaoNoXDC	127
8027	2vamFs39NBeKQnbGgBArq67TtfJAUKDhjnJrjnGZCuY4fqXSrzvZ	127
8028	2vbh6RSzWDLKsHcHEs4rQSYkNjvbKzaA8veXk4m5M1t4DXLSC11G	127
8032	2vbkEedKQurBCusTk6PJMP4jD8btJRA2qHNRTCewFTdtMDqrfrjR	127
8037	2vbNSQ1TFPimHp9Es7f6LxvpzszERC3bzU1zSU6N8e3MHyjreFnM	127
8044	2vaJKrm3bF1ArdGxq3tkuekaea5rYoXkF6YxHRQt3T7k1V9PRjQt	127
8051	2vaR6v5taDmRCjbpxfE2SUZSkLkGzW5YC84wkWLqxz1gedFqZNEX	127
8053	2varvRPF5jPtTrRMT5bAHPFD91nquP3MP6uGcoYoDFptWSnTfaWQ	127
8055	2vbJ612ZfmHaoEAWKYD6HZbKjmBnBxBCz12rJ1kLqBPt49DHsn64	127
8058	2vc1suuxTKYmJJnVVV6SpVdrwazQC1nkYBEXhmTcAd8jr4k2eC3q	127
8060	2vac32LEQGBjJi5xk2rnN5Em56NUs1zook3UmmKbZ8sNrcdmPiUP	127
8065	2vbbFozj49HLRxiFvdXz36rysVjbpTyzDjA8tNRPWMT3N1tdP66z	127
8072	2vbJbRCZNAwaueXgVY2q3bsva449wbByQxjaGjW8wP31o4Yfay24	127
8075	2vb1MpnHQWBZW8vto7ps668aiN93h3W3nZ13zKxetfKu7Z1um5td	127
8076	2vbaDhdzaP7baLMFyjLJheCWTC1fWjECWDDG5vndoo2xgujgY3KZ	127
8078	2vbsQoD1npuE7ytFsXwULDWSEs5K3eCesFAU5nDK3aeB9XbVSnuB	127
8080	2vazQwtStj9wKiLPibpCXgpZjP3Qt94ZkapDBwTPJddok9sXMwqU	127
8089	2vbybSCKk1vQjJHvDyZhHXZinucxRTV53WmT6SgGT7kHmJBL1p7R	127
8094	2vb22aucv6CVTa2PtwLKrcUhLm7oYXNiDQ6EwZ219XWcYmoxwYKM	127
8097	2vasGFtrK3MrfMmUpB4z8pFhNJcFpK9XCZjC1hxMRqcwvTyGq3SX	127
8101	2vbStUhYEkGdTuUW1HwEASJ3DBoBJiy1R8r6anHtgYzAo8c3XjiB	127
8106	2vb2pzFGerLkjy6xGDvY2zQfgaKdYR3toDJeMJSNremdBZkbW7sD	127
8111	2vbFgNcAAKqpPRQ7hQehML5DCXa4BUiHtNYGE4vRpUrV2ZB5fTYt	127
8116	2vc2CnxSXVSUYyNn2yoMWgBDntXp44YjjXoZW7GQTuf9JAtfTiHm	127
8124	2vbRwMfcaaEmGwVDDnpby6AK3Vev5Ma1umgKbG8RGiAnx9fGW6wb	127
8129	2vbGLW8YknkztS8c7VG3fk4Y5RNRNFgwxmxyzWwjVUvL5MGTbgws	127
8131	2vaDeSCjJVi8FMLTaVYqrLqwNxPMH7qfttvyJ51cxro71QQPQT3v	127
8132	2vbsB1LJTxCLEPF5mpqeo7ZFT6xrf9cm5mTna5qRwyEZY9ZFTMHB	127
8133	2vaqdPumHPQPXqJBC3WyZ1Su752TiY4n84eW9wTTmZ5P6gNzeWJo	127
8135	2vbjixfsFyE64CgbUnmPTjLvaoBpYFFTUZewMGVWLXjRoUTdZwfn	127
8142	2vazPjLv83zDCztgxbiowWyTxcx54SHtZVmgb3qKDU1YtpvT5cXk	127
8144	2vbrWrmEzCWQ4eqMhZcj2SuHH9mJwNT8tjQehHrfjWD6ga6Vihrd	127
8147	2vbMbjZ66PeWioX9iiewEVgh1HFBMeFTLSceY3922GVGpDPzcgfH	127
8151	2vbjfDee67MeazFgwroMApykwncKxMgkFHQ1wUwsRWrt9Lf4X1A4	127
8156	2vb7VTQVS99YfzzC631mV5UtSxcnN23HgQEHGgN52ZkmkStZzJND	127
8161	2vagwfwjFUK35uTbJaDxpUhqGXwN1vC16bo6egjBxbaxbPhSpnQs	127
8164	2vbmx889dm4i68c8sPRcS3ud4i2kaEmyz4WGdwj8rCsCzmSS7JxX	127
8166	2vbxCHRiUg5KEPuqDsPZPKG8LsQvyJiTkPJkCbQYAkmx4eixbReQ	127
8169	2vbqA8x7VeU77PdVVXP2NmSkfdxR9UCtW1MbFJEB1qhT6zN7fotN	127
8170	2va9N6ntanEe4ERpeo5ZTY3SGPLjDRzUinRvt8rFcUv9pek1QJvU	127
8174	2vbgTLgkvAhtSLfPQ9zsqWEPAVctHsGisH8jkrS9Gus1YB62DaC5	127
8182	2vbF53B7A8egYbc13GJZzNMW6Sxz4Raxi3QNKAQ7rXaob1F9uNDD	127
8183	2vbHaoR2MX8bYhqBgwVv3ipyvGXD3Kj9Wnyqj2o2xixnBhjDWty3	127
8186	2vbL1JbSWGYqiMHtQw5zEJRAStVCpBCkoQFAAHtXiEHZWMAYwios	127
8189	2vaJM6VLwvWsAXv9ri9juECJA8pgbGfiYRoibzoeZqgANBA1FSUc	127
8191	2vadp7N5N1kNKdPxiZjo1nCY5KD9bxvDKg81ibouPx4KP86brgGE	127
8199	2vbg1o7UnzaD4HTpwd9EoAHp9rMAGNrj6FG1GpXZCbKcRVfPuPZH	127
8201	2vc2vGMVr6X5p3RyuNZHitaTT9EohX8zmhKtdihDdcGDgRqwrwga	127
8212	2vbNHGXox4swjS42FqLDaueyF1iCMu5vQkvHVR8z4pHy8wVRpE4X	127
8219	2vbXaB2VQ2i22VebiZSnmYtRKLN1FJ4kE7qJJjWmkAEpuLZJHbQ4	127
8222	2vbhzi6MLJ8mPPmSsnegrLTVaiXaDW9HRJVHvPziKo2SRqdHmy8g	127
8225	2vaA6HBpzQDHnyaQfLJkShyvrTxasQDZZoghux2Xz59eK1JKrjJf	127
8229	2vaWR6nj2b1NCdV8pvstapx7XEXGb2zT39uhhsLDRyRe2Bck8JgL	127
8231	2vabSYc6MmxnXvidc5Sd2tLMdBvkaShGD5QDutsivkdyWrFnBuYB	127
8232	2vb7o5VRbgx3F8gVkQTb3uchnBEgp6ApvnLFdkdjT8mgNYqGdGka	127
8236	2vaDXQHodVUTLw1VMHPsxH4RZ6E53puhGcBX6JnAR1TnMhzyS6G3	127
8238	2vbcxji2SfHWwNsBuZQihHWixofQjvXkbbyLm6ctf9jy4aQFrWEz	127
8240	2vbE3yYxh3QVJrDsmhX4pJMm8PXCJGPYkf6KCqiSB9yCRnRzqdpo	127
8243	2vbotvzVuM7aqezF5nYJ7YezaS85iUHdiDrJatxokeq4xGB6YnL4	127
8246	2vaJZk1BkChWSWbNDKv6GjAEXWF7KkDxxegFgjtP7y5uAudaE1Ld	127
8252	2vadjEvY3tRWg4YGu4MCuNWVqXiQrDX7L9DBGA2JosVwSg9R9aE9	127
8257	2vayPMvcnr6Yz9m61p7oVdA3KpnitBGxRzrBB9VD1gLwu7g7goD1	127
8262	2vbUrWVrbh7y9xa7r45QpkcrP4XxYvuFpJstprKmsnNpgUiy7Dms	127
8264	2vbdLcS2Cp4C88RAqzxPWc1TNtuKcHBmKvP5K6xShYQYPtytQVa2	127
8266	2vbQpThwW21ty1LQywyq5cwH71RQMiWrmfs1iwrG39qy2Bh3xJmf	127
8269	2vaA17jZE1kEs18WhLBxynKGzsq1beRpKVUSU9okqbu2BzL6Hwbp	127
8284	2vbbTn5YAuKAmu6qvpwKv7M4tWRwe5cCQmmSyG76iKoGQsnJdxwx	127
8286	2vbmYv5ts4xS9Yz9wm6zqL3pPTv66C3ZkRHpjyUfc2WWZwY8i4jS	127
8289	2vaGUQ7yx7nKDzd7k3TwGL6wp5Q7AsvEh8JtfueTfz969u9q6RNe	127
8290	2vbbT2VRwjyZ5JR3opz8owucVdpSUYoep4mT7oDMP5fwbBNtZ6ea	127
8295	2vbLgiXLfhscDYBP47TuQdtKCDNbd5VgFpfFnhZNgF3MnP8sWqq7	127
8298	2vacVKThM2v9bnAtSRu7vdNxxt1Zqa2SEHBiBAcJZYUopBEYEMj6	127
8300	2vbrmLZQQ4tMtiJGhcrtKNwVnTfGJRHLN9ogDFtGnCx86nTwEV7g	127
8305	2vbjJb2VDH3FyQRpjafjMZD2dxyDjXbYRUxXVpxHApSW5nwaNfrX	127
8308	2vauVHDknJG9mNLN64HMpBvk1M4PwDAaHR4FAuhtH4N9WV5uVRMw	127
8310	2vaRyzdcXPevR6v41pHW5PKQMZBrmxFgditSwtwF3M5VyyGWjkUF	127
8313	2vbrVjVNY6h5RCRuWf1nD8W1j5m1xmJMWsryBkAbR4sopXBhxBV2	127
8317	2vaR6fNiedqq2qz9RdQToJkDjCNgAmrC5YAGsRLuxCmnMW4iCSiL	127
8318	2vbEv96ikAG75fgmLXbPwQtuMkxGrM6ANfYmorPZxS9Akxg3PnnT	127
8327	2vc1y1vkMk9mMyuN7XzucUZs4HxJkHCYg8GySQM3cVko1Nzc2xqN	127
8329	2vbkwqDtHaBdxnaZS7KoceK8rnnzRFhzxLzF6Wxq2jKaa4P3AsfM	127
8334	2vbwCH99WRseXZ3G3dKJjFr1LQSRrEXPSELFHWtnZcRoAQHfAz1Y	127
8336	2vaopvnr62t8Tuhi1k6J8AB5QbKTGxkaFUuhvSLX5ijP6BxgnrWr	127
8339	2vaA4oiS9umU7pvgH11T4Nd5LvP39jgLxEJAYCFSmQ2dNBoaa1pz	127
8341	2vbXMFCLA2L8BwqdUhYmYzus5H1fwXHyAjf12TRvMJR4xyvd71y2	127
8020	2vaWimbqqY1MmNQwXH41Jn7JBXFM6vKnYvZyLpAbD2XPgPEr6VaR	127
8022	2vb2D5761LEMsKPC2ypCeEzjjcWskJDjxDUumctmPu6GU9jGQLWJ	127
8029	2varHsy2D11B11MSZTyVE4qRU6sHJ5LoFr88yRbnoKoV8tw3A8LX	127
8035	2vaAJWeW9w7FQkQt41VcVfzB9E38e7dBCKryZiMwhR6KnZHiBfxh	127
8038	2vasjyMLz11dnWSiTGVRhShVJEJVWcGVMgTABifQrJkubQ4U37u2	127
8040	2vaB7wPajARpzAhDk3qFmiDPho45gxNvGDckQAx7idKFVjAcQmKf	127
8045	2vbS3qhHqvCsb3BYhib3JYcLt2XQ8tSXXyU8bB9JipkfVRMvkDcx	127
8049	2vc4vcX9SPtv1usmHWHDiZcTrvTZxVdFmfpR6hAHN34DvN4S2Jfy	127
8052	2vbJdsb2w2HVZ61iL3V39X8xUZuVoKpPPMCFEVe96ymLBanHhyBV	127
8056	2vbtfmDnf5Yku1Vd2GUwgQ9ENz2mVcbUVWQDfhZt7JzYBcLq1Tfs	127
8061	2vaaysKMXa5zLA5TEtU16wc7iZhTvwfnuKNN4w9ckZGGb4GX19u5	127
8063	2vak4gNPK1ejMsfCs3sQNMibd8yXVUtJzowbYXyUb3qRu9zVLkxP	127
8066	2vaYG7hTtwJC983pwW5V4nc7N3QABm7ZLzRVtWRbRbe3fMRoGUw3	127
8070	2vbTH6KkE6EgLk7jADvw2ZhE7cQfB5tXNxxYm1xg3RMtmTkb9NEc	127
8073	2vaz3bcjkvjchXdCShhT2Fk8m9D9CGnXzgy481oMywmorLizyZZz	127
8077	2vaa3CXb6D1eyHVVMg4D6xFgwWeajtrgVAVY6UkkJ19GBT23Mj5Z	127
8079	2vaWPNNtwoH3hNF949ycQJFRbKGryUPDWvLdm8RUMgMja1QdE9z9	127
8081	2vaTxVUvZTFEKkRrbBAd71iNTSuk7yrqZkLjgCmqXXXrS8kEMt6h	127
8085	2vbAnPyiEKeP4Bui2jufb6wSV6D7qsL2CXFsEAxfiobhwUGSGtVi	127
8087	2vbEuNNUZsLb1ttP4CkbLPdJq3bAeaPbKZw7LTX7Hjwem8NySG7L	127
8090	2vatQLiHRHaQAaPwAmB9S8K8AosiaVh5Zou96Padnc5rmixjpZZY	127
8095	2vbmWRGEUurwn2DqATgNugxcgDqAEbXFv6E5eiGRrNTZp4L2qpCw	127
8099	2vaA6V3momfxuh4bEwAueCS6pMswGj2jsp2wBau7S8AvFBxdTr6s	127
8102	2vapZ7NS6B9LTy5pCH26ghHr7hnoXLTszTvMXFGcKmLnCU74eJVp	127
8104	2vbHNEf19mB85vk4UhcYvq2DFfPJWfoz5nige5FAGNJLcHBbrPSj	127
8107	2vbBgnNZkPM9rJ8RBzkF1KRLicHWrZdPYkzgurNk98juFiMLzaqx	127
8109	2vc4M1RgJS71aMGKWjcX2TKZG4RT8QoQ3FtFu7pTcQcHuStbBaYZ	127
8114	2vaftHpHSJg7RAXPD5hGiC9kkcg7YjRPRVeXArEbpWWb6quHqrhN	127
8119	2vbzBAZD8kqZRpbtwE4K8N7d7pqwCSVzP5bVgPnkSkVBAnDJWYjJ	127
8122	2vamVWxQv9Yr7gPEbSYmoxjDkmDo8JCqxdsTrwu8bSb4n2uyMJtL	127
8125	2vbWZzTrXnu6JVw7EbRBofjHGRcbwvQ1nPiRWy7ZqbGSFCCb2KtQ	127
8127	2vaE5ecfo5E7en9xnQbNPJVFqymSUXuNf1FEAtug8d8oBuJvL7qk	127
8130	2vbqavLQMUtQDWTXdXnhdpUZHvcTVL8aRWCq5YbrNQzH6yCmkuyJ	127
8136	2vahUb3dyi9k8Xj4gUNB7FcM7WJPzAKQYPAm1Y28JU3xDhuDuR4K	127
8138	2vbqJeYEfZ9dKB7byh4y21USo3Vo7DTXCPVsZtwdpHHXmfcNk769	127
8143	2vbMmUbgMsqdYiGbxcDhP6kRuRzKYtUjqj9q61LZfsjJfVkPU8ej	127
8154	2vauPwuyLLcfCkhYyENfikgKuggkVDeVSDHF4aqxY4ueHRXjEun5	127
8157	2vaAhExvptUL9kJw8Xk18tfpUcwwsfzVUBFPLHUG85SLiTXUNB4n	127
8159	2vaZzrmN81vfwK9ZNXEfwiUsP95XxzrmDJuNLk4mydT4P3Lo2Gmo	127
8167	2vbhTJcTCEJpCQxBZ9tm6C4YthW7HxAUBLPA5BxzuUSb478SkwN9	127
8172	2vbosWw6nETdicNShCaZdyqWJtXguaBn8grrG3rW8WwdmxfWkz1m	127
8177	2vbcMj3e3mCbvgFByp4kGVBVokyU8MiGf6qZ29GmodgWtHoTrxGA	127
8180	2vb6f3t8V61rW8yCBhrfZ3CH5g6gbBucjvhyUqGNB57Dw45USJ57	127
8184	2vbHHRRHQPcskNyCWLRQQxiFA4BKTp6BQfjn8cV5Peh63qombTjV	127
8187	2vb664DQoK1zN3gjoHExTbu9gSctXfAtmHFQ5X1wv8cqwnXPfJtd	127
8192	2vbHRG9TiC9GfXN9gSeB8gwg5gUXqgQfq59As5Qpasge95Y7TGaL	127
8197	2vam8AFmSM77Mg4r8rEfTV2brM6hPcEaZr5eofv9xgcTGsieZren	127
8204	2vc1tPFUE3Pfqvd7b6T9KUKkbh2BSw2Gd3vtLw74PjuY8i4b7Fmi	127
8209	2vbXCN75urpvbKe69LB8VbuHBYd1GQvsiZGXnorcqKQbwGxScd12	127
8210	2vbnfvNwNFY7grpdYmdQtYQLrkExoEbTuZ4JKYTiHsjp8bweND12	127
8215	2vav8Ash7mGATSehAyyxZYG7cTviYTCnKS6HPKoTivDSE9eQp3gC	127
8217	2vafoemVtLLkeFanHCbSd6mAePka815jnz3gVLHiRs1SxosZJarQ	127
8227	2vbt22pbjFMLafcG8ofteUauXWQNm8TJojkuNUPHiYjwuR5tW37p	127
8230	2vad4gd3TW4vCGV9YbdrK5FJ2ttqcCUWu1nVwppwUEL9YxHgD29R	127
8241	2vbNh7T2rxMqyf1kgQyGzhTSnQAyuraRmhdgepmKwgrHboorkJKg	127
8244	2vb7GpWZUw1Cyh7mRUuMn6P1wcB255XoJKtq9N9XRsSgfKtvBFCC	127
8247	2vavfXS874nDpCb4uAmNqgxrtEtMYGeyDg8fSsqN6hqwvFA3Nqap	127
8255	2vbq2KHwZDPdeu1ckR1KrPhvtYqvxyy3a6T3axVzAsu8cTZxkEkG	127
8258	2vbQ8PPHdiLP3gGpwdG4NgkFmg5TNZ3UKhczVTaACLmDQgiS3K7n	127
8260	2vbXd6reor4UaQNVsHZB2BrLRhLmy3tvK14cLpX8vsNr53wQDdon	127
8265	2vaWbmznZCCncDEG7YA6AFNPPc624kQHsUw61t7GcZG9irDjJw1E	127
8267	2vbwmmxXqrM9fTo7MS5gZSA49vXqRwprP8FhQqYA2wxE2UnNxGJL	127
8272	2vb7d7znbYu8QA2tLqirT4RVDCeisGqRzP6VDo2qH1tqY6Ut9VKE	127
8275	2vacRFfVR5Udo9EYWpmMuAQWSWBzocoZCtte6hwJ9B8Y7jNpkaAu	127
8277	2vbzpT2s8LExBfYnQSyp7TwEbVBzN4QoeFzpRwoPtPF3eMh5pJsh	127
8280	2vbKtBMYgWUAsNi6eVaKx7aZQySmSiRfRSDZkioVJ1csExi4U24s	127
8282	2vaNXJaBU6aZmGL7kxiJtdXBkpnVktCshkwer4KSgoARPkVdBSJW	127
8285	2vbZq2cv8n8B2meV7qorQHsTY6hFQDpcRsWtxm26kcv1Bu1irNwA	127
8287	2vaNMJrYALCToMeXsFpe9H1uJCvxusiFYtGKEtXSqcmo5HVxMKN2	127
8293	2vbCRGvsKA3xHPgpovJsUrz7cmYJw9bt4pjGVi5d2D5d1UqqTc1J	127
8296	2vaKx9vWdWSqbBeV1djgmv2j7w8erNPEfTqRvSoYQCzLdJrifLqV	127
8301	2varC5sHU46XCR4YZ4mJQqG42dXW6d9A6mv5SMgtr31SoUCdSd4R	127
8303	2vaJwPLWZKLKGdzFNUiSChH76ZKPhBVMonJXbHZrhwbFYFyq2iog	127
8319	2vbjYwxuBrenQgGtKSq4eaz2DP8dm1fjSLtXi8psZHtJW5NeQrpy	127
8321	2vb6T1NHAPivF3xVYh48hypRuKLEgXZo8fz8nehgVmNkyZGy3n6Z	127
8325	2vaxyfxdF3hNPDjp3qraugQ58ESaHcsBi543DSAXEUQys5aS558q	127
8330	2vbGEU7EMYxiUF3a2uoSjPprkbehv8PzZG2PMB9M8eafVTjrq8JS	127
8332	2vbs8Vqw335XXTHXyQfVsEwMmNyq3zHGPQdC4QzrJGzjbYVsGxrB	127
8337	2vavKqdqGHrjDTe967ULCVtcGvbmazCLSEmrmLsoqhG7W6ftmSbW	127
8340	2vbxY3uo9b5Wb5hQiqpXc37edgajg499uMTDSefZ7bMqbBVkVy1T	127
8342	2vbtWMZDB3VfPC2rFteT37T4YEsHcPr4VChQwHAGyfJkxDvnHT35	127
8349	2vb5YSDig9JAhz4jqJWcim81wtSDaedqQhSxLXnQzFHmW6S8ASB4	127
8357	2vaebDguEmM6Y3ZCVAqCyj6ZP8h5dwWpnxUd8pWUHGrCdHUiXenF	127
8362	2vaK3sTg7EsXpamdCfugJ5AWFrQHLg2frpJiXNYzu2x5DLXEW5Ve	127
8366	2vbWrY2Roprw2PgdGTW48Y2B98ePMWZWD4UPs5wbHpGeDpMs81ic	127
8367	2vaCdb2ahXfyKA4ieJGNa24svW4jppMSFGRDs11gyJanWGYt3W4Q	127
8370	2vbRVXFPHuSi36p1km2sN656UxM32uZhCqTUcFMR1uxcdypLvpub	127
8379	2vb8Wz5sQ2oHEzFw1oUQ6QFky4WjXNezQEM6wwwxkGMb2Zwhehcx	127
8026	2vb4e7ADnm5GicPpK68zWWudg6GbQ6XXh19KbeucRjybkoUAQL8a	127
8031	2vaojnRkwa4JoDm3MMGEp7egsmckqHKZnwHXkziG2YAbZQjoorU8	127
8034	2vbhe5wB4BoMokPPvSnd9yiL6pmQ8cGuve1FdoNFiCkmHZi3cTv2	127
8036	2vc18ykwa52yJjk7koyr2KN9Vi1iSsC7Th8iPUvVhwtVL8GRS1Cs	127
8042	2vahYXmrwtqTCMMCqp21aixYbWiZmarRmpC8f7f7MuFAxenZCDV5	127
8043	2vbwU3jHTXGLLUDUDxXt5dyPPMWYEcUAX1FYn6z2rWcAB3sWd5xe	127
8048	2vbCFjAhyvRmvqB39mcXs6oKYy9TbaQ6sz5EFzEDj3orDZN2XbVu	127
8050	2vbA6kCDSSoNwz61yvP9jqxXWiXN3ivPHDhSmzUGTzaVKC3j3RD4	127
8068	2vbmz3xvWxFPCBuaFVHniUqwghPQFquU1wD9DZKGryjcfwudEc7t	127
8069	2vc5sTV3HzjVbEjzcP3bGX1Tupsygvo4bxsbq4pvCxN5WarFcuvr	127
8074	2vbea4kre8SXHBeqJgSwFroVMAe17zz9VkF7eacTsWLwZUUaPzAo	127
8084	2vb9bbtFAB5fMYVZTToEAJNvD3fqUXan7CBzKYX3zC7SABmusQ2o	127
8091	2vbW9HqUDbJpgGWEaRTWvKvx8Tr89NXDyUEvjdSUaSRHtFNpCxyP	127
8093	2vbRAYuPsbvcaeg9RARxDf9GTwWLDC3ooRLMV7dJ6TpLUxeYm7cP	127
8098	2vbBk6vpJ2rdkQZpyYKPsUm2YahEXs5cxmtb6KTFjJp3uZxmAAf9	127
8108	2vbgj1by8sS26MLno2TsLk745Xy6pwtWYeJGusSTCGCMhLQQmjxr	127
8113	2vaQT2SEBKeQRJqhG2PUHPJZt5qpQiVkRPyoSv5y2Mp3FHTwixfd	127
8118	2vajnGo1wk2SQEBXZ6Msa2ASXxJxDZqyMzfZB5v4geWiAKM1irSA	127
8121	2vbH9qX7gW74uRx59ktH5B8j6R3EsnnwGdfpGHcMsNLeWzXLKvMw	127
8126	2vaopFHfPBjuWdAMkvbDKBois61uYqN37X8w796rZkvihcc2oVrG	127
8128	2vaNYPLQ27aSA62txDHLUhaEzsPmNQF9XNsFCb3P19dL8cuKCYP7	127
8137	2vbEvpnxP5m7NtkrC8wJTkBGRMEqAYFABLZpuxKBYuFQpZD5b5gN	127
8140	2vbBz2RkV64pstEdJnqS9NvqbR9ce1W86z4qxEMajpEm7Egw2UVD	127
8141	2vb5N6bgJBEgb2TeNQ55FxTZFD6vS6d1FLAPWUWn7Esgzu6odCc2	127
8146	2vak283t9wBNe8AmXuxpmsewLBkGFgSnkyHyMngcfdRJqctWpJCQ	127
8149	2vbt1aCZBVJhgL8axsuBswiUD2VALpUaZqVSFNkksurm46P4vQ5H	127
8153	2vbxAKB5Cw1bp3nudwYsp24voYbquFL4ERe1Qd2PMMqiULKMG9L1	127
8158	2vagBiyeG8LSDTFVUcmLhC3QKoBzXt2MGbzCBZ9BdiRvsibBxrRT	127
8163	2vaVahw4iMXeMTVkitBkWMeC595wF3nFXkMPWLBW783pUfM4Dihk	127
8165	2vbqbssUjygujQaHxoiEGbPicsQDBFy91zq5H3WbZBec1FqQqxZE	127
8168	2vbK15KsdPwCbTmMK5hcuGaBuwVefrtLkNYUWFTFWNMaddEvdZok	127
8171	2vc1nHv7FJFZ33JFKUJMu2FGbtKQ1wv69Fx1VdXLJUY2ndr5ujQ1	127
8176	2vaCDiPc2v8ZxkpCP3K8LJMCAcfThwktCG4f7NVGXWDXpupdjiuu	127
8179	2vbgfdAQS7LzvTMmnYQ1h9dNUR4hHVansHDMFCjUqUHe9YqSbA7y	127
8188	2vbxFh61kUvwSLkeCJvxGyL2CVzRUziSqb2XpqtSF679sfHHnqm3	127
8194	2vaYE5bKkg8m93wGVaJbF31buqeNamijS7pz9QUwTUNt2DeBDNFA	127
8196	2vbX9jMWYsGZYCPvfHPZv2HpTtNpLHFjqj4DuW8eVsBzaGnexyDx	127
8203	2vb2bsoMCtqPQoVBGYe5LNGZQjpHLCEBY6qkRaLn5KpRH74P9ybg	127
8206	2vbycQaMi9fuhS6uWUfGT3pmSKqTCAsX4GeVzCvRZRL5FeWZryKt	127
8208	2vaZtTE1YZthix3EKD9XpquuDYBDNoVWRq9GVVk1AdehMMpYTnEG	127
8214	2vat1ZhmhFvRLHQsV6Rh9bKQBBdN3fFCg7GY8V7H2ZzutJpoBf3U	127
8221	2vaEXN68nhB63WTgwX9826XnnyoJvH2M8k5pJPXw4EQenFAdVNmC	127
8224	2vaj9o7D3tFn2fqtgAH8qo5FXrzvG8WoSTT9g4e11k9MkkYeH5mG	127
8233	2vaZyZ7ZNEtRW2atsqPdRVpodLRCcfcnxe6W5s9CuyXjQvGuXDuN	127
8235	2vamRcg8xzFVeeZn4FUm76MjgXK5zDT5Keu7r8ZfVToWPd1acADG	127
8237	2vbEU7MEyJnDtfCbiAfiLVVAisepDdofLQnB6Szvoqvviz1QZB1Y	127
8245	2van197vAtjzf4Mv7sEnmGfLKja5jVhj3zL2UA3PuKBqV5snehMV	127
8249	2vaZg8dNYskHRujpfZN7ajhbRhk89MRAZLTBUe9UhktjBjZYzVox	127
8251	2va9Pv32mzcA5PhkWdbVqdrwbtgkPCrwcjoykVjdgGZ5BMpVvNHW	127
8254	2vaEGcQxKJHri94LVa7TydFCbzFm5T6V6gX3MWj53thZRA6efJKj	127
8256	2vbKVvhiViriWX5Ewi8dCw4C8skkTvR69wuqDsTajQ7bZxNC92zR	127
8259	2vbap6aoX5eGccVKWTQc6U4V1kbJBwyAqPvhjiirjiCa4Hd7rg1o	127
8268	2vbKngyki5xcmVNYSGBUvPSH9BviHbRPG2joUjTtZZDbvGnk7jQx	127
8271	2vav6F5s2dkFh1sKwGEP52r7bWhnHRAu75e8RsRkWi3bnXjy1AZj	127
8274	2vakP6EMKA76pqeEZDTkvFA7MXA2tNNfa7iQUiEaUqtaK35aPPWA	127
8278	2vbXsFYmMY4HDVrWdZjR1Sif1vM4qnXARpqQQbtNqcdRMPQkuu7z	127
8283	2vaRVoC4bC89vy5qefWH6b9Sr4qVv23zRftaeNur6w1QDALvoGvM	127
8288	2vbPBCLRz2c7QLaYphUhV8XaFrqjVp9PuKtctara26zrLfwHjec3	127
8291	2vbkR7HHzsvigFdTwLNYKc2i3W7egLqTt8H2g899P7AGCtoiWJsX	127
8306	2vbGBQ2oASESgYQtaRYCLxW4MsHC9y9qtnK3PPj1gMbHHAtoCBc3	127
8309	2vaXfamAJFeqQSJF3VXJoqCbHmahQBT5HizX3YJUJXry7eWrocrs	127
8311	2vbZiZE5aWdQtqx1vnpCTgwxdezDPNB2hASY7AVUvcceSDaBMaZ7	127
8315	2vakmZNmn69MLoCCvwxUPe92oc1mQ8e2xmqJ87bY2ujNuf6dPxUQ	127
8320	2vawNpb9z3E5ncYyh2zsS1aTNity2w459AbETk6gXxp2NomCTgnC	127
8322	2vaYZfR1CEuccExkdFercrpAgqnBRxid49La7CY3nwvHeSnWJbBz	127
8323	2vbAKHJEuusaRp4UWxhekAQKPErL5gWs6FPaznkPYhniFZwJLkw6	127
8326	2vbHYKqpawr9JL1wUUSHUgjBipBZ9QfRgLvSAxqCLqoynVHQiouN	127
8328	2vbvjYh8QYT3KzqHQLirzKef75jS8zarYkMcnJVnKTTmtDUoyEgN	127
8333	2vbHeMGXsopPx4wZgPfY9sYSx7DEPmt4JD6WNxn9ZbdT6pnzFB9V	127
8335	2vbkBHUsHZ1VqUXkf1y4qBGDPezfJARvMe9rZc6d84tRo61KnMxD	127
8344	2vaCqJ7wo8RkYeRpzgAK6EzmRQybB1GpBb84xz7kRboVrNP6B9Bs	127
8350	2vaUQg8etxEs7rD8k2qMeYhAdSjqJ6e57yRi8eTuFeDu1pMMr7tc	127
8352	2vc2PxLoJdDDZ3TDVsxq1edHsrZ3mnMs3cDoR1dR45bNzbcmGPxh	127
8353	2vbaDKnuxtTd7D2zN7hggnBsra1CWZxZUNnNZQBx1nFM12w88N66	127
8358	2vahLVXZ7b7XfbcRsgD5AQuQYZS6utyTwaMuExWg2z4BqZqeh9gj	127
8360	2vafyJvFX6jBacfBMSRDCHhC2fpMr7T4do1T2qoEzunvEAETxVLA	127
8363	2vaa2FpWZXfAUXpWP4B8qr5MNy1nRjBSWzY2Hpymc4rHjUSWMkW8	127
8368	2vaXciuNTY29YoPBbGcsFVrmAeWuxyfgENac2qVVXMQTsnXSKRVV	127
8369	2vb99SCixY33P11RUbPRxRSpciDKbYEGwGbLzJ3apLYnSvtYrC5J	127
8371	2vaGaG7FWixs1Xc4wNbAppjquJHuw3VHfACe7vtYaAAAFXxFGCp2	127
8373	2vayjbMM1wPUYdeRSCwjBJmW14ysmaLf2G31KDYjdXU1dxpoq5Wu	127
8377	2vbNWawK2ws3sccEbrLyMTBQMtwsJmWNhLCXE6NX1KyF6tnwxv6W	127
8380	2vc4Ld6gVtivYyjGry8oco6bY2WQ7z9czeNSYhxfye3eKsYzy7LP	127
8383	2vbHfRZZreoXTxJQkUC45YVJ5ifjtwuNWCcRKT3Jv9jcRnGxwrw1	127
8385	2vbmccGetJLY84h52GTNLxAi4WMQ9kApkRVNjvtbJLPKYCeuV7rg	127
8387	2vaJw6Us5XTHqqdKMYHZd3GcvwoPHdW5dRHBGTm6sZGRR8XUsW5h	127
8392	2vb2QJBjAL97mts3pQJZTxoE85iE3wrFGp4yYoMYqUN2ftuvRRaZ	127
8395	2vbMZgRg8VJwCBZ2DFpAbaGLkEzyT1aDATm6QX66USSKTmQqbkvh	127
8041	2vbND832Mce49enufgLepacoDL1beCijQquWSvsgdod74wGESnNE	127
8046	2vbQUnVHWZ5uzo8rtG5uYdHzZMQemzSy94YX8Uto7CtyaJvDqCv8	127
8047	2vaKmBtir4XoWYiLV22SZqUn92UXAt8Je4zHPgeS6A9WKMaqdYoK	127
8054	2vbTPk9PcdxhzbtfvDG6QhnYfGtsLSzZNZYUUx55RLEC3BCxoUSh	127
8057	2vaM8g1i3j13CpyTUfCULxEwdjbFy7yn5M5v5kiZfMxUhDTZkFxk	127
8059	2vb97F1iwifxqT1sAiJcX2YNbK7v6SWL1r5XKjZqW8bMpFuvrstT	127
8062	2vbgAL39jZsR5pyqKZkvDGELrAhS42dk9jodfgvLAwg3aEjNoZJn	127
8064	2vaSnFvaD4F9Bn4A4HJCKTVarJdRf8C5eX74hyK1NP3aMSH4L7ps	127
8067	2vbyAdSfYpwrWumgf1tYgpFQNREiQQeSeDaSLvTUY3DFSbfnKGLz	127
8071	2vab2UdnAgEbddc8eHMSte5VGSJRLjmCmb8sQmz66sLRwRcRdQqx	127
8082	2vbRv2ykfJSRUZzU5irn8xAae1ceQJYhNcyqwtJUfysjHZ6zYG9m	127
8083	2vb4FtiFAxP7ZRcqbAFuRscfx6eVHe4vCv7n9ee2YoyQ4Fhzz59z	127
8086	2vb4Xv9TFaku4jQyDUpKGKkbzqHRgAFMU6tQ5vguso7t3DzqXxkC	127
8088	2vaxXL94g7QtKLhR4izcd4SjeCM5uSakPjzZB8ZUBtiW7cBf7EVo	127
8092	2vbtEipz19QpEGUvJEFyKa9e79HJruPTCRekWTpy6DYBXJbMzVQN	127
8096	2vawFR15DFtHsSmWnoWpjFh6tj2X7HG2YjAPnf6js7P6Uf29TG6f	127
8100	2vaj512LKXWMB8ThDFhkMJdud56poJu5TX5wwTijgjc7Ea4mGAAR	127
8103	2vc2aRf6EBUqf78bX47moJvaMaGGh3uxiXBmwsGXCHzPt9ji8SH8	127
8105	2vbBSPxfsTNU5qFKd4nPH96iGCk6gsjYzxByyFpbVaRaZ9n4XeJX	127
8110	2vaf2ayCFfJpmjNovjtezRKCCh3fioGJhM14WsrJZVWPUdEtVTNq	127
8112	2vbwFtVjTuKFjnDY15NFLJBr3JvfAhgZzp1qBGSXhTtki6Sr6Fkk	127
8115	2vbJ4sXfascj5pazMVUiu4TRWYNumu7HBAbigiPnqDinSLsF2NoL	127
8117	2vagFMb4FjdPhFDEjieE579JJhwBYMymxXYkrtmweheoUARmqv46	127
8120	2vbtqaUuMVDs2FFzHwrDYWt3S2EnQgdgSA8ZNMJwWKKJZjt5oRR5	127
8123	2var8gkwVkgcfaviGZBdnd2bzLkgRiT6Rnw5LU4BKhfygxzyiJhx	127
8134	2vbxLAwFNeYXYMPt3yUXH7K3pZK5r897qtM7ivPmzwPDSDbjX2cq	127
8139	2vbWCuBnJwknzJVvpecKRSsZPPmDY4idLWG1Hx2DucHDbMS6oy6F	127
8145	2vawK63iequHMxsCxCP8CwK9KFfR5hCELEWAJa7uSRQSY4h9qZEX	127
8148	2va9M1ah8Dp3aRVWZGTHddec2GErTmaZQN8kUYLgoWm3EgPivXwb	127
8150	2vbvWGuuLodkaGvXvMUHAFFcE5fBNvxTVFzVyHaGe9BJQBBT1vn7	127
8152	2vai6XuVqfKHkyapL1pArUnKLLvHCUgKB8upLKcdPA7KUd2nXHHt	127
8155	2vbctoDFYeMWzZ81UahWZr9feJHoMSUqALJFoSpD9fFJibJ7c4Vj	127
8160	2vbYXqJLYimdbSQzeWouam1Qd53vMGJKoYM2bBYF7FXTCuQymncT	127
8162	2vaGnCP6s1UXJVsE8T9fW6ymZmG2D9bB35b69fAvqRKoUBUaCeUd	127
8173	2vamEYDLTBpBsodrMU9kkd8ehHs87UghT8vSyGGdvLKyXj8hx7pt	127
8175	2vbRhQNsbFZE7uif1YHqCTYzya1RDSxmF2gBwg6P846gqJuQdiSp	127
8178	2vbMwF4BMY89BNJM1hVwudgdEFV4GcCwazrYMW3hFJKD8ic359uL	127
8181	2vbta8ERFVVALGPGft6pa4HAuezQzM7KXZa13v1zje9pxABk6D4r	127
8185	2vaHZKu2YnbopvoyXtpimB9nyyLv3pNDPo9j2gGi9yPNXqE1acy1	127
8190	2vbt7TViU4fA56vDeVPCPomAgGKusRBAXEXDBVxvRsiTTbpoqfRs	127
8193	2vag5MATLDSkgfCKBKuemPV59oWaQCqTKK86S7KHW4PHnVS5em2Z	127
8195	2vaWUQTAWcaxPrJVBHFom9UaFpjpK8d387jN8f83Lfy7TX9VsqYN	127
8198	2vb6L8Rv7ZHDWmnJou8qZie8u8HiiWe9inWmCQcYTQxydwFX9sQc	127
8200	2vb4EB5AYY8gXGSBwgDcy5TmiMCcLCExJ6a51hm59Q1QQrvTBnp8	127
8202	2vbLUZhL7Psjw8pnNdo8U3G9nFxo6P9m4My8oNoCr1QJ4sf82Lf1	127
8205	2vb7ZP1c74JZpaRijNfsmK6XtBJbwr6Nooq7vjEMUfPpFHuPxntB	127
8207	2vaULhFWNJRPd8AK9anwBrmLqeAuMFcrhARa9YeTmKRdAUz2qv6F	127
8211	2vbW9A8fhvpMP2n2Fu7znPg8QySnQW6ExtKa24RLQUnjVaLJWe7u	127
8213	2vbHKSbxqk5JC4F26mJKseaaSiwmcT86NMXiEmSzqgzNd2ebpzXF	127
8216	2vaZ71hspdDXXBvo9LwCFYv1CogcHhEEqba416odWoL5MvgHhqjK	127
8218	2vbSn5dQ2ekcB2xvJsUsptCP7oMqR83HDEzETzMAZk6mLR5nbYzm	127
8220	2vaHcxuRTTaXTc2QY7MoxzWgwBAaJYTcuK64nRM9nYbqvreFuvTQ	127
8223	2vaBDSMFJCLGKsj3RAHN5fckCY1Ps25D7sVqPHCiPSqXWuSm2E1Q	127
8226	2vbwZ8CHtgDVQybZd6UmvXVCc1oAfjKtaetLyRmW5R2Mpfz8tKKr	127
8228	2vbhmk4m95rUAWCqbNKJnZNuqrGS3Q7dcFdyhyUUE4FvkAcKtnFZ	127
8234	2vbZXQMiUSTY63yg8ZXuiN6Vxc5tqmYnRufrhe8dkSUmjUZVQRWf	127
8239	2vb5XhQdZ7Yr5jDpqcmZiCRKLfqaceJkqEumcX2CZXkcEuabQALG	127
8242	2vbRaXmCXVEnWcU6Lq5MXFx6ifcBe3bTXQkmEM5N9bAHWsvf2Ny3	127
8248	2vaa4jXD8jQsAWXtat7a5VXSDKfmQWWLqLAzAXdQfGKsERLrDeq7	127
8250	2vaiBGmvnXg7ANrUs5hcBciD3HoEiZHeP5QH6jnrgmhcEbcnVSBR	127
8253	2vaV2fdgiHHwFRXoXkLhTYQc44RtGfoFzJcjecUwtgQd26f1bgvP	127
8261	2vbyKyq9nr7fNkiyrqTYQoF5StpFcvj1LRChaBDfgiA3n5Cc9aPX	127
8263	2vbQr2XkcPnPRPnBSYRHFv68kxY1E3VA6Ubjj1g7hRofZek3bKnr	127
8270	2vaitNY9S1Twe2BUxmqfE7VXDFtE4PdZ3MWsjDa6MLPt5mY6dNut	127
8273	2vaxm7PCcA1A4esvbsmMVeaGqdUGXnkg58t1wDqqqQaXUsT2pxqC	127
8276	2vbjYcsR2ruu94RewG9VLGCUWkAy6ab7sHfDcg8xLx72aLcHA4Kv	127
8279	2vb6rJiUBG4UsUe4TL3JCd2BmQAoNCHLUHo8E8KWMsMDWt7wsW69	127
8281	2vasExcLNS48nJGXESesxRMqJcVcfqNUP9qrG9gZQkbnmHFJVFD4	127
8292	2vbpEtW5yBbHv2oqqUdx4MicTdVpUXfKR7rDKiDgvYD8TB6F1fpw	127
8294	2vbJgniGpNeFmkCcLGmTBd9kezr3ge2Ewg5pM3pzpozc8z154oHi	127
8297	2vbFbowtkcbA8dTrZpMzHg4autx7AHwjiqx6SPzusYmKtQAze3MZ	127
8299	2vb2Mtusx4ZrXM3nim8r7pm9bBHQXH1KRtwtDax13cX5iZm9s8KJ	127
8302	2vbzkPLANuSeovxfP6Wu2yY2XKENCJXVpjrfLYgQ4jrK1sA88TC5	127
8304	2vbpDzHjkpucQpRsLv84ksUQc8UPJsWuqDe8J6XBZ5vniCjxDa7U	127
8307	2vaRJe3kpSi9NWNTRr96mXQqpojRk9kudz41tEUxx96mdmTL3eJT	127
8312	2vaDevvdGroqgNqWeZDgKH6e4E6VFwdpZRFGCQSPpPYhFBZXdv6c	127
8314	2vafR8BQ3BaK7Roys91RTZ849YziJHzW8Cwgq4UXqQ4HdRNyN4Hn	127
8316	2vacYbofBxSs89Vd3ea5evMpHYzH6A3FNxqXYZ125FkLRYU8Fhki	127
8324	2vbomJtAa1DBNFHUnSbypkmXniZZ48o9wRzqUKhGrxrTBL5vzLct	127
8331	2vbLjLoNj2XUcfTr21EAkvuWVCCVPiRRYnJhCfVEsw2rg2qssvmA	127
8338	2vb9ExLNrKb1YhphPgSS8yriCLKWGXuKPJB8hxk8UeNPVr5TRoaw	127
8345	2vbPG2xHymVpZ8nrKZj3o1j16fJghytxzgHnq2X7qC7hW5UtCUnd	127
8347	2vbBSKJsyuGX69EZfGCduFV4hpg7xex7byDcU16LLMUDzE8YXCu3	127
8355	2vbBApkwMCfTh8arwfMxHmnDVXWSYtkYxZNz5abHFpRCZcdaNQMT	127
8356	2vbm6tdiVhitz7MVmNFd1rWkzRf7yN6PKsmeiJ8ZVBUHEWKNSvtt	127
8364	2vbpLJ91vQuhdsRuNbKoxzsMRjrVAFkBXRcTFF9DJ81oe6LdQ6um	127
8372	2vaj5KqaFnL5qGfWv2VUAhBKtJMwLW1J6sRLU9hMjRW5JbTHdGhA	127
8374	2vbtcRrS5fnAtzUkT6JHLHebX5CwZZErPcYxdkdvFauyR92HwTQB	127
8343	2vaaDatGFWjG2MLDjk8HxYryXQq7VBJcB7xLm2c8xJWDkQaByYob	127
8346	2vavbFomsycG4aR851VvK9bNiG9pr3V8gFxUhxU4Z7QR9Prc7TGT	127
8348	2vbDbX9fx6ENZFhN7gDxUmMHTx2TzhCPs8t5Qx6XYm3PgqBkRwE4	127
8351	2vbZwYCHNJoWm6evw5wpEAavmR29mKGePuaWtcfympnp1ZYKRthD	127
8354	2vadVtpD4NSEsCTaiCC7F1UEP4hX9PFjQVukpPZCBPygGoJtTBAD	127
8359	2vbFVNdQGaQMdYZ8qa29C13CdkBjoTo41uRJeQNFSe2Zy6fQ4R3p	127
8361	2vbweEPfvQXS5n5xb2xUF898rXdvTcJ4mnFpuD5t4ko5ZgCofBzS	127
8365	2vaCA1WsKka4W8fA7rtyDvbRPsnr1a2XfD6dz9NeBCYiZ6kUaM3f	127
8375	2vb92No3HvJ6eyxuqrXQpX7Jta3fHLWcfSuG6AuYBToYdy3n8bmz	127
8386	2vaisJUj5hV6ciNWK28vMJLoeYVKDbLRMLkfMaYKtRnLhaKkBCr2	127
8389	2vaDb7hztLmfbXPCDQUzGPdPNj3veYgJr8sN1AQMMr9uSJ3xnG89	127
8393	2vaj17ZR8qBP6HKhPrDLZ3A6j1rVhG15LRKwEPCBPUgs4fHoMkY5	127
8396	2vbUVB9GUMvn9oD8hCRko2E1NNr4wbvvEmBF2YADREzE4GFhnLvq	127
8376	2vb7yJwjJYQH9kPGRLQAZieU5ZAzQK8cxtSNjWU36oapYTVcCV1u	127
8378	2vbdJAAKcuh7bosm83kCTNCvdirxXeoESDgcHWXxTuqMKPshePv4	127
8381	2vaM2TU1G9N9NgVogizCamVvdXxyycdgGqGoiUZgoM8zvKmc1NvB	127
8388	2vbJ1nLRmXnTfFtsiWzKZStdywAuBmnqntYwQ7S8A7BkRWQGygpR	127
8382	2vanR9T6RcYW4ep13uqEaoqj4Qh2S7EeEC5xQbcTDuRC25bL6Bai	127
8384	2vaHpqDiu17RHMycn1stpxjqbkQ1xWgv5r2SWWDJDCM1y4E5qxy6	127
8390	2vbeDKNCMs6DRnkmRKRLRaMopXagNzo5AesJLHsFmTnP1gtRW76H	127
8391	2vayvz6adzmig21JR8uYvshxpHkfqBXgxPKj1KFxYdCSaGDtfhVc	127
8394	2vbxZsCaZNcdezeFrCaAjgtwbUC36ucVVtiPjdG1R3VKxAawqW4d	127
8397	2vaoxtRrVpFUMnysAkKjoboqj8crcwRxtJcdc6EEqimqtHzviWxE	127
8398	2vb6apobY8KVx1zjMGTgzfk3H6TJSCwAL72RJqmE61Pu4Mrhgade	127
8399	2vaK59344ykdE32aq26LsZe3ta2iivGBn8oxfXiQ4HEsYGLUv1y7	127
8400	2vbnvBizXkSYKm1a8s66rveDUVc3gdegMo8Zt78hU5tPbPhYg2pA	127
8401	2vbtVS2TGJS7dMyAWo5bTV9jHbmZbhMqQmjDmPe9AdFgkaJRYiUE	127
8402	2vb8gT5VsUwGrVb3RdMbcYiZumRRBHZY2hDKyNWMKcfmNXbABgJg	127
8403	2vaJpzUgqXmZnFNQaynbDNNv8BNRLeNWaDTVBo5Th76MJjUiYwfn	127
8404	2vbbiQGqsRfJT4AGPXLbyvMAavDdZcwUni95KqEr3LuayGUdCHCV	127
8405	2vbVPVrJ4SuA1dQKhcgV9x2JbgB7cjcoWfhd8BpRkqjfhhqhrTKy	127
8406	2vafBJVc9prEFHzWQkTieMPHTuA2i9PHQ7D3VUcw27McL9gJQr5G	127
8407	2vbZZ3sboQN8fXu7P6aoy2C4vo1QyQfruMJfgtd6cuJATYW84fUx	127
8408	2vaRLBHuPkvJ4NSnzLwEeNHoBfMwg1AP57KTnuNH2NoC8X2nR3bt	127
8409	2vbNjNfpZKRuzSirnLxLTk21XAKUosNJ6KULRD5UUZUCSrgQJKFn	127
8410	2vbuQmcPFrTjMQS67ZyjyW6sy3vdUfmVayukwkxULvpTyUv5P1za	127
8411	2vbTYtK8XxeLHFW6gwn4XodSVWJxxsv7aY8cui5uKMb5VxTMzFd4	127
8412	2vc3Bw5aqHPkaTWZHDteyGDW2jWmxEQeW1vRsjEnefzXbCBmpkjz	127
8413	2vbhZv7qrgMycq6JWibMF27kdrJajgM2Nz6USVRVa9Jx18FAf5t1	127
8414	2vatVndU6GPeJt6dHTDMG5rugT4haACm1QCjFJD6KwAzT1RpjGmp	127
8415	2vaF8jx5aEsoG5QR3unxCeb25jnGmaTeMFLoYv5Dk8rpGrw1xekk	127
8416	2vb2JXxAdMmV2WvFEtuB488KjHL396r2v4kd7w73WjkUuc6cNTsE	127
8417	2vbQboEYLYUnEwf2xfgCcHrXx8mCR4Xou8NhsBMXDKL58bF9cZsn	127
8418	2vafbeNUqYKCLKadeYom6L998SkQQoNW5nFmrbipNBoA1u93FEMC	127
8419	2vbNd4tKQcb6wdyZ77XCjbey8MZA6GLe4D47emc5pok1Mgf6t5iG	127
8420	2vaP2yYsiyrTZrEJ4AuN9mJcvmNp3Uwbmea2CRifGz5U9pQPHkUJ	127
8421	2vaQBXTWqbRPSs3ZW3nAcPJzvoPULTGRYH1RxKaLdL628be9pnku	127
8422	2vc31ycUrnhg985imwPqq3tzYnoVRVojYjbYuanBJSpFavSwHK5X	127
8423	2vas6dxJ4dK4iMfCvWRuuQJ2nRbk8fEBTcFUufjXmh2fy1tnD7U4	127
8424	2vac6aJ4sUgQpvzcejvo5pUmRLtBtbUav8aqqN5cHofhvL67nRAE	127
8425	2vc594CxTxayfTCDXHaog6n1SnFfp78K6c1D9bfyHhYBGTPwRbbz	127
8426	2vagC32uErKEcZKTqM1EpnVZE4QyctfjEjhME4izRkB8UT3ocqJU	127
8427	2vb9QGC52rW899Tq1GmxMjzw8ALP6dS6Fc6xFqxrtfVYAPwJtcJd	127
8428	2vb1DAaUG73Lv4bKewoQcWuNk8no2ggp5DZChN1Y1TQdM2hUCA7S	127
8429	2vbvULcVPJoFXgzmLmWdrYuohUxAHMUhBUDcBZoqRjy62PpF4PGu	127
8430	2vbukmxXsBMZQ7zQGqkMhErqTLMFq3NZHcmT8xSfwQNodL3iRjPW	127
8431	2vbdXY7LGmXEwDtgSn71WctE1LdMN6pYyyNxasia82E4aYvmwZYf	127
8432	2vc2hjHViJJFUwYEELDptE9iJR5WhNJUeZUMxskCwJHAqvkWBWJi	127
8433	2vbWJK6rfmLgvrKStupAW4eUCUdbmpgJMmgN8vNVcvnwMkJhUqut	127
8434	2vbEkBGJrhChUcdnpHqSdBjbRETyAM8xhaQHRp9iTxDzFd3JgTRD	127
8435	2vaVbTjxxcaZqiQb5Kmh5yQAxQ9fWe1RyDXgZ7Ti6hbUoof9zxHJ	127
8436	2vbsJVzxuUBnSRVWUqbUxSSKrLbThjQcsyhMmrvwZmj6TvGMw3Ke	127
8437	2vb9ubRp5JoMNUE4dDPxFysHQCp5SCJwN18mAVFaQdaLuwxzYZFm	127
8438	2vaZMqD9tzEUVh6K3foDtyyokqQCCw13QyfxLWxAT63SyT1NgQEV	127
8439	2vbAge3meSkPuQbe4Zboc9HTCHgwLaSMaK2JTWRYiJU75vQEfucT	127
8440	2varnQXDqGFQRQ3QMd6GCjNAKRhQXdP8bAN5KgZcZaUdQPVMsEsJ	127
8441	2vc2Wkiwt3WoSLx3UxnJMebDKTB23hdTMQ4zC1mJQEtbJVRLrbm5	127
8442	2vaG5qNkTNiHVY8EQoLPKrxn9DMT1YkTzF2Jur4mvpnee6MfsYQ1	127
8443	2varqTPcXBVMHYcxYUfwmDSam23XweAac743wg58FHXfKrYyCHbt	127
8444	2vbWcHt7MSA4YSUQSotWCcRJA8z5TB1GJDq3F7nE3DYkFDcvAXkg	127
8445	2vaNBGvjon2oN6w6UbMsKqADbLKpmrf6kGYxTQGhfm7uopeCFJsD	127
8446	2vbMmtArrpspAQNZRZWqf6VorUkdaR5yW8jPcw6wfwhTBq1QVrHf	127
8447	2vb1h5Ls28S2QiJGuf8kWkJ8wvHB3xm4nncsNcA7t3j3mnkkp8mJ	127
8448	2vai7YJsKKo52N9yX79i6NPSrwTgPZ9K8P2aQQ7jsv3NF3YRydLL	127
8449	2vc3hBsCsNNxbS2aMzj939YkKBNtsexvujMqxx8VXLXfQZbNBwNA	127
8450	2vbFtRTrmnSqpkSRfrJAJhWm39PVmiGrSPb9sQ7uceBuWJ7GzSYm	127
8451	2vauwgH3SfdSbdeu4zZxdfYqBZHSPsxfpsrNBisvJPFfduN99EHv	127
8452	2vbcgjX1V3gC9G4rH6nTPzwy29pskvvbq4AccJUbBe7Uax1NHHvL	127
8453	2vaouFbXHXCyp4HLUS6HTYRJEv9vz32PeVP2m84MbbFr9Q2YH6Vw	127
8454	2vaLEnYvMLZUGWwAcKpb2B4txuNo46hb4f6sjPoEAcYKALbrNGVw	127
8455	2vaX7sNFh2GQDdj9aTQijgSXtnbJh8kbSRDhPgdw9zqWTtJi4bXE	127
8456	2vagcxEBFYFQeRMycN4tASVbybzyHv6R8HJeDe6oB481fQuceqXZ	127
8457	2vaW2vbes21NeNQEoZJKsZ2mWYUo72AdsReg1jFD2mCeaehyjSFj	127
8458	2vbTXMUZQgVNmJEGrXfTvugJCjbEBdB3cQtNHy1DKdXBpNsBtRjG	127
8459	2vbC3anvAEU9skDj5CdjfJuM9hbbvr7PSpYQXtCWKpnBN2WA8eFx	127
8460	2vbucce38EWsKsBfE2UBvFhZshGn4N9jnaXBq9uLz367AGXEeBvo	127
8461	2vbizkwFk7wbPNmeimXH2RqVPaXzHXGixc9Qh9g2HLDS2VmSQz1x	127
8462	2vbR4mzMfW9hLphDJVwHLMqVKhx8hi1xNgm6WZ6RUGhyrN5h7ESg	127
8463	2vasfCQeAHv6xcBA5t49deLNy1Zd4WHjZp2YnUc2DsccBTmZ1D7Y	127
8464	2vbEmv9Btf8JSBZxPCww9KRgGBSYy1k6jG6e8E6XnN2RmFfv89pW	127
8465	2vaz8ofgFkxc26GBcRBBNBdWBp9ezf9Ltou4rGVFgusiVVoW9aVg	127
8466	2vbkSeAPKCXcQopkRhGyBpSy2jpHtK9fQmspvpi67VzNQTZrHpW6	127
8467	2vbGrorBCGCPotms971qxpJetFdJUYgv9tVzYQNotDGUsZ9sZGFi	127
8468	2vb8aP8Hr5N4a5YGBuEfxYY5EvAHu4Qg9W87cKqhiQwfGZHzYY3q	127
8469	2vbs3zmKfkeU5boSRSZoYWacxJVfzEbXYYknVuDHSXRCxv9CzQ88	127
8470	2vahmuTMuvuUmAJvNFFhNaCi8iyi1d4s6UvZXw6vqT3Z12YgTpjX	127
8471	2vaHWq5z8N3jXMLqUUQGQdd4c8GfZYbSgyNgab3v4wZfgaQqXK6m	127
8472	2vaCdJvu1x2drLSBik2gs3iPRLpXyTfGXaUYCzbA4TzUhw9CJNSs	127
8473	2vaj3BykHA7LrhyrRFmfNv1n4Qwx2pJU1wAjTBy4ENAcGzaiRhWR	127
8474	2vaR5CKfQNo7PucFbw3WMsWZeiDQK8VxoZfHdVsbBdKVzKwTN48e	127
8475	2vbryPDcvyKNjaR9uojgJqoB3UPaNG6mntNoege1oufdA5qoiqK1	127
8476	2vbRK9cwwUr8kJWGPoTVSAG12Jw7wPKT9jKUEvu7QULH4Cxwbe5q	127
8477	2vbr1FX1Y1GswzAUkEx81t2Z2GP88yS6ShF4LhZL8stxaU796u4D	127
8478	2vbcUX4CKwjJW5p3PJpoQjMhkQ7XTH4aiomcV36p3W1GEi4JKgbT	127
8479	2vaNonPEhjucVuUGH1bkU4RqJg6PCtxQ5wbxBzY2NXuTV6Du6z6e	127
8480	2vbynFeqnhBpbKuEtbuV5ZkodjgYXde71nuszykfNp1snZB72Hvk	127
8487	2va9CVtjnULaLB1X5BvAKb3Tz2Tcsc6Cy6yqxKKMTLmxHsBNLv9d	127
8489	2vbXjgbVDYDhhe8BPMXKg5MggMZGK4vz3LWQeVjEFtHKqZxcX3fT	127
8494	2vbTqbrfNS93VBoxf5a2uG5T6AQwHKBdvW4SKHhqK9cHvcsmuhjx	127
8495	2vbJxMfej49J1N4x2co1GzKRSDxxqRwTF6dcX7Y9XBKsdmscTtD2	127
8499	2vaE8jFhrsmVT3oy7kCT6cfPsafsLXKwFN58376twStFF82hHfiW	127
8504	2vbMhjT83JsoKvFwoL27M7vR7Ma5TkH6X9vuwd1KTXjYwJLZd2tK	127
8511	2vaDpnsUSzNZSGsVaSWXN67V23rv3MgGfpT3mHSrbdosYYMT1DPe	127
8519	2vahesxnYTknWtdkqz1w87xtMtQazvoDoLdGJcQjYrmTqieZXfJA	127
8521	2vbzgLZDuGuNbHVcEfiLYmyR8bw21RJjv4P95FyNtKPPWy36ipXB	127
8524	2vabEL3T78yQjeHgtaFYkdw4iBK16Pgk5LjEdoevtixMtiFY7ePX	127
8527	2vaZ4sbRQz7vekyuVqazvDxeZaY1C2szgU2F9bstGQHFyRwtJiJB	127
8531	2vbWjFbUHGn5efcABXtSjuVakPhqzyegjcQyWpUjUjVVNzr5HFcr	127
8534	2vayPLNHVka1M4HtWqEJe7zsGboaYYCw3fzFapXk3ZAijDAhJrEN	127
8537	2vaSixrAUsht9EFHw8SKYmkuSDPTnQfnVxmBgxAEChr53RNZNseU	127
8540	2va9gva7F9bUNXg3ryb1LfcusAjzcWVrGtLF7NFdHRpWahxmxDhR	127
8543	2va9ekUntYu6f59WvzdXZ18w7YM1S45mUN7RzWHnqA2D3zH9Un2N	127
8545	2vbFrnWUaC7qtDEPSuKCbuJZCEm6kYYV3BjhY2cCpJ4iZXNFAurL	127
8551	2vboPwVkYsD2vq1DzKipbbMs6oc7awCyruHiZnpQZfYsaQcyaSZ2	127
8553	2vbf5jq3X8YN6VC5G6q5zUwMjtX8iq1zeAdowWKVrn8FdFAxjXNx	127
8557	2vaBhXYkSFDoeAQqiRSwj51jteBhPcRJUdMKf1gvWw9RApsiymhs	127
8560	2vacneBHcAeuWcPUkocjJRHp4sas34FYH5pu8nsWMtfBY4Ehs8Wi	127
8562	2vaPGsVCJRRnvKXN27HzcaZWCCuLbbs3P1xALwGDZLhfjhG9HzRb	127
8564	2vaokRJLjuzrGDPVpyQTjKwbsPYouyedByTdsem6YV5ZyExgTqkw	127
8566	2vanTynMagNLrDWWmB3vS3Ayd4SSYUNdTef4uJxYyV98oYBrp1EV	127
8571	2vaPzcMJzP1yR1SfhDsLwbadNuCU63sv332xwkFxUGniE8atdGWF	127
8573	2vbzjVD3u84P7jJA7z6s5c8pQjCU34DaEqufyMSWrvsfMDsMwJVS	127
8575	2vbXfWKonfP5URpF71t1zFT3GbYeDoSE2X8iEGu7CWC9E1R5d7Nh	127
8583	2vbVX83mFuFLUneSJKBtnGZaFzW8XaZPyyDWRPhYVMENRYaxs4Pv	127
8589	2vamtzNCgKtBECH1EqAWX1WJarwvWyt9S2DM3DyZxPqaBBDbjvqZ	127
8590	2vbrgLRxcXbA6btMVhL4ofEcGhWiziHGuSZPBn3fXAkhx3W7r7jc	127
8592	2vbzMrdpPFYMZHC7BjEHPa6mJodZ6wRsktoHbHMMUqMJAKt5sDhb	127
8594	2vaztzUfcFopdozuc3za1jstvKsP69EeRse8oXRFVeGjHPuaShhT	127
8596	2vaFTTPWxqUuDfhSrUzCuNeVQVtFX87TVrKiCfF2VEfTR6Y2w8FL	127
8598	2vbyPVSam3VCSNfuritv6PR9cf3yCYRnW6VcWu8QzCy4WniDmdmi	127
8601	2vaMTX54Nah88Xh2apgABSmf3DePtS9FMc6mzzecGZEjA9DEXdCb	127
8603	2vb7nWtjks7FyTspDfL9kgtk6rwHZ3FGfz7AoevCJkpL6QecEGEZ	127
8607	2vc4vgSUCwNmLmdRWMLXNnKxQmWQ4fH3tRJakFGuX39t27TWYvk7	127
8611	2vaT3ymyPsXVzqEFQ6QFrBbu4CrSU2nsyvKDRTRdhuRUKF1i1zyg	127
8613	2vahF9SdSj6EW8UZa7GQjbJ4Q6oYovzBsoAN4gy4i8XNkUmbUzHw	127
8616	2vb49yAY1z14rBAaYoqdM3sdcjZU8SdhicZztFvvrDf5EhPgG3G6	127
8623	2vbtCm9ynUyUFtSX822My5WmDzY8dzRonEJoeonkxMmoq5aCjcX4	127
8626	2vaPYnSc6Jrnb8csZymJ46VqprBbSsKPNyMcTNkS9aSx4V5otUKe	127
8628	2vaJbvYyzYMaepwnx8oj7NnjF7DB12nYfiKLaHt4FAgGV8vLfCWq	127
8638	2vaegMiG6cpZ2Y2KfX9YDMmaj3hF7DyvfzavCVRGQFTBJ71TBuC1	127
8641	2vaAtT6WEmJ7akeaNwr4HwfSbvmLoH4jkWXYNPSLmczC4BFeUr7C	127
8644	2vbfdaQjmkwBjndsLGh5o9hdLmuhh88wvRCQmPe6H79Wqv1pRDbb	127
8646	2vad9DfLkFeFAUQ1aVCHfrvjGTBoi4Zt7d2pVFEECUfgLTL14vSz	127
8651	2vbTj9sFdMgJH61FbqXAyGJoYbLSGjzW8VSbkMdgfs9ethKkgSTu	127
8656	2vbSYHZJZcnxx6s4g2SKKEgm1xjFsWPQr8dQypA4fafFxmfZh9zm	127
8659	2vaSB1NEYzYrGzLmXapFkW9vDWfpH7oVz3hWAzRMYHP7K2ebnCqF	127
8661	2vbqhv9AuunWVELvnhzg9HHFQ92y7endceQr8xMjxSb2yZukqWwV	127
8666	2vbkCCmBAmGudmbwdFS8FmKku8zYiHJJBbrrL23bkEhCzrL6XWGm	127
8669	2vbEBWXoYpoTHkckdP5NdWEKBGmdgsf5sH3hfAaxzA1FG1tdNKj9	127
8671	2vbUv3ez2Xp7xhPxTkgQbkhQ6Foyp7ki6JrMTRGuFEWBU5Fhhnm3	127
8672	2vag1NdeDq8cKYJAXGCCSbd4C3VsppTJMBvYN2FRM1cLTh65P5Zk	127
8674	2vbhm6VGetU4gmk3gH7pQXVnaPTo2UvaJveuBQj8jYx2ZHLpX6Co	127
8677	2vbsrG1VyJiDNRfdii31U2xBKsguEVWdn3CHbXK95PFVh8iKYouL	127
8683	2vbe41oZe7Dv9pw4da9GVN5Gv3gKpQ1rGcAH5A7AziKDUWaM6Epc	127
8688	2vbA3wm47M4L4sf36tpjqqF5F1Tdy7MTs6f6u7f4LyhN15mqh3jP	127
8693	2vaGVS8zEefS4Kzrk4EHinn8WwYbvVLZK5C2rGBQdm2LN8FjKYWa	127
8697	2vb9D6KJWjfAUrfEE5WzxNJwt7vHE6NZ4DJY65nuwGEmtaqLc11W	127
8699	2vaYi2yP7qncvEqTEoRhLju3FNVm6HohxPrhe92MdRG5zgvKhXPR	127
8700	2vabz2bNdR8j4rX9ih9AamcHsPjcGa4a5of4Le32yv4qHi8XBhU9	127
8703	2vbFGbFs4CTYCPavVZLwvfxF8kpAyxvrGKbmtQsX6QDBKRt1y4aQ	127
8705	2vaaC2nQryMQ4RsiDYT2ug2ht2Nk6x6Euig3Dqu6QCzQWoxCaeZE	127
8707	2vbt85E62RJXnGaELhvtcXyBpRJAxvayg289RC6TizfNQdiZ4svF	127
8715	2vbhHL8wUcD6Xh9RogRAqYop45RitStGZh3XXCrXouajLai7r3yu	127
8716	2vakqnVYNCq49tahAibHhkY8YZoDdHZWMWRWvPCbuDDYpbbwNU93	127
8718	2vayMoSeFYomMNSJUjNRRYPzU6dJBcjFbyLWULLnecWTfk6Mg51q	127
8720	2vae4kuG9L3nMKafVmMJHCPFSWTpUZVTBYfdk9wCNXiSE5e1HNQp	127
8722	2vbcGjPhaaohzFATRiqALsjSAALs6FLvYdFogQXPsW8DM5r5FE3B	127
8725	2vc1bf5Y9a7ocLPNKovo5RsDdSiy1U2RHaupMxNKQVsktUP6YuuS	127
8727	2vbxfZyBZ27nqwCNFqBeKwh9YpfnTGbxS1vDEDrH5P9UGtm5qa5M	127
8730	2vbj73FaKavjBAX9kjBRRDKcvXAeW39ZAmmC7yqA6hTKmKnqkVYi	127
8732	2vbiwwTvZoh91ExzYCpsWq5WxkQA82JCrKCKjLYoTRh4pPAHGNsG	127
8737	2vbp82YgxyRPBo1B59GUwxGEqFiCNKNiAQBax28eoYCZF9cQiedN	127
8741	2vaKCeCifRjm7yXGgspCPeugxGe4msnNe1Gx4ZjjY4XcsXG2Va5K	127
8745	2vbAgYk7foFfynPuvJLc3p4JvDeoknTPqbmnBLEPxqXRbkVm4CHh	127
8751	2vaUcqkFRs1owCt6mhmmQuAq7mBaZUjxcnA2aRCTUqDdM3zWJDEf	127
8753	2vbbRwkBp9Cg7USv5dspRHRG1osAy3YYFMMwPEvK7nbu2L4w6Su7	127
8755	2vbxBdyLTjpZeA4zdD68dGD24QT7LSh5kmiTnBS7u1uArioK88ka	127
8758	2vbsav7j5yxVbsyWdHusseKPkeQyxTYDqYQPZFjtaVk6QRUdoZRz	127
8763	2vbxQpGVoomMJQkRcsSFu4djwJHVfXNswDNpCHtGZaNoGr2buexs	127
8765	2vbwLHyyqSGPqGvwgzz9pPz4VmLjkHpaoTQdZAaxNP6Z1mT58HS8	127
8774	2vaKMpYR2Pxg3BhzFtZjYebdwWQfehueisgDE8KFnAbefpAS2DPA	127
8776	2vaDC69CFpuC6ytwz2sVb3qhTH9C8Vcjj3yNKUQMnjVQ4xnGFiCk	127
8779	2vaTHuHmk7pebbW8sQr34Mie9FgkCEgUGpLKqyHPwtwfmwS3DsLy	127
8481	2vbBXJF8QsBdo5DaEGGejLitwSgNf64U6F1b8wxKgxWpBKY8vGSt	127
8486	2vc5RVLAZy5aro8opaVvFwXCWW8GWeDH47WT8Mhv4F6TTBKj6B8g	127
8492	2vamiwC6ZFNViUCKGZNaFsEpR7hafXXSHoR4xVRMnhAkdE3DfVMX	127
8496	2vakfqjEkF1YKJaGoTbfJqFz4Dr1Tx8H8SXXHUHMmpTKk2Cfxhg8	127
8498	2vc5QamvWkGH3Z9a9n3hQGJeCS7fYDZyRypTssPAGENEhQhMWm9G	127
8500	2vaTRhgJDkWF9RSUEvrK1ejpH48jo4KCon8Dx7xnvosvdTq2862M	127
8502	2vbNB8nbACtjvaJSwsR1h5r5bDCv7TQsS8DHwyojhnst85eiFHVX	127
8506	2vbtngAoEFHK3NawQXD4NxrEhxG8BJYDfFLpHdkUkmbDqz94T7kt	127
8510	2vbPxuK4ETgjtmSt78mNqp3LQ2EXKwBmYZSuCksXuA8fTRQhDiig	127
8516	2vboaiRc6w11APudwJ65PudCrs88XCo4W7B2RVVSYSHChor1D5fW	127
8520	2vaWa3kBQtM4KodtQzGJrLHq6iFZnnjYDKwcc3CtgNY7m7GrtuA9	127
8526	2vaZsqNRZPKrEUfkev9f3MGD4R9yktcUUVSjttcFquVvRweqSEdM	127
8530	2vc19drYQ2pY1rKvhqy3TE21KGVEDytWv9aypTVgkDzJWRhAFi2g	127
8541	2vbQdenmSkB746caWz6iJsAiX4wUtUNWzvSVpPrhWpRE73iMufz7	127
8544	2vaZCQ12Mec94LfWS1j5cNtbXGBKeLH4qT4BFgJYLdgWCJs2ZvQX	127
8549	2vbGxVj55ZVC2LMJLgTmEffLXwvWFYCmQpb5p9LPBJnr5ZJLdbb8	127
8561	2vbnx5kHQxCiCZYDnaQf1DFxEt7ZkKSkeJg9Kp1Q9TewTHvGdj9R	127
8563	2vaBJcSgiNXPrgjHa1yrw1koJDzVJEqi26ZGcj7WutRLVrNjWHk5	127
8568	2vatmjo7R72vSKvzAsYL8taFAruS7gtAXq5pZQExXBLnzjfeZwrV	127
8569	2vaKyiascWBDc1n5pkct7q7NYcqNhhvb2kCrCrHPmJBmiHmHyagc	127
8579	2vbWu4ihushSg3zRBgGKijaw5ZgD9hnF9KeESSfDZ4yXFs7Tkfi2	127
8581	2vaB1nYyWup7s4tH13vfq8aW3na81Qha1sr7etc1vyfRofFf4foq	127
8584	2vbNoo9UrsUDfQeBQKeu3BJmkHaCb4NkkBmBDuiEcf4SSdTVkrbs	127
8586	2vaAWRwrn2Gy6BDfDkSqD7mP43p4avcB1J3ihmz8ppjRyLd8V1RK	127
8588	2vaNvVHCvG2wwVe948J3VwXTsPyhHHkFmCF5CTMiv37PRmgtkxCS	127
8593	2vbdGvqNo8cMAgdQvWxcDuzUC2isWTEWjhLppnRwTQrdrd2HB9Y8	127
8602	2vbpfbSGkDxMppuuPuP1CfEznZ5vgDpZzzas9nQEzKYj9cq4Lat4	127
8605	2vbHFKmdPAgELr3zHVhhhNmiWzTxBzjNXhiBiwPH4Npev7Lkw8zW	127
8612	2vbk47PQSbqtFWvU19cbKsjJP2qD4i487XsaQrfPMWswELoXFf5c	127
8615	2vajCcPrJjTDNJmkUqWFFmuBBMZxodQT8wFQMzaeGSYcZjr83PdM	127
8618	2vbvQTxnSFYeNTc52LFjmDQZn4grwXatWEoyVEEqv6KpjM9zVRZ4	127
8622	2vaeV5KrdVrMzqYbpxLV1qmrDAV9Qxb8gXJJjVDQhcrhcmGE9FbX	127
8625	2vb35pdy2261yNqLCCNGhG8FBvhgY9KYwa7hYLCZfnMzu2JhqnbY	127
8627	2vbKUr7uf3fVwWN5zUm7EWa9teuTAtpch5vdBHH8N5WomSQxjQt5	127
8630	2vbTfi2sSCFM8cuej7PNrq3xBvqkvNZrgYg1DSdBUbERX2Sk1LHt	127
8632	2vaGKQU1iSAkMfZhwVAi6B7QJEsvWPdeTKoUovUQL2YnXXE57iWr	127
8634	2vbjQstgiJjZdjt1qoTiAm9inahj4w5QTtXnsbPR8oQkwXVUxmRs	127
8637	2vbdFYfq5RSD974xWTJ3zXzH9xWKNsFW2RkfqZixW3ddJ2Hjr2va	127
8642	2vbAobZPh1f41aWgYGyB975bQDGEtgHUYdMFcfXJGnjkFaBhhy1x	127
8648	2vbSEt2a75BNNupyLj8dU8kTCrcsSLZLE5gS35HPc4VPr27Y571k	127
8650	2vaPiC5y7P4q4UkzYAsZNRy1iGHtqL2nHByqpKdUS1Sm3EAdUqA6	127
8653	2vbS5qCCCPUh7yZDKhkRY4PHmT8zUTdjLP6ZuuTxGYaACBm86i62	127
8660	2vbG2nuR1RuSEWozNw5yXXiz4LtYwL3rmbjj6Uhae4bSEPWxy69j	127
8665	2vbM136CZKgT2G2c5ZHo1pBT7S863fBWSyacpXJGbHNE4qRtR5G9	127
8667	2vbrNiufYsSk6kSpWQ3fiyfANUSp7QWvbxAEhMfgYrPREkwRXbMu	127
8676	2vbGqFBqsQf1bpkcism3aEDB4dXvWZEeDLb8wYdWQgf3CBw71hiT	127
8679	2vawzAHHLzDMFVKWJ63XP2UXyeJkF1Y6KCEQLdXbBDHVpo8AiyZJ	127
8681	2vbMt9feJVDxA6kU6X5RZFUfVPgGza7v3tqNgj77opF4Z6ur622N	127
8684	2vaE8bv6hyv1KqwcRphiXxzrrsaLuzgQCSsX5YteCk4RQ2aLLSdD	127
8691	2vb1fEeUs9AEM5nERo9z7rL8GvVP3qEq8SHMx3kbREQukYcdsEhd	127
8695	2vajZ1ARv8axtaopibwp8M4CvmZHBZdabfS5UxnSMa3x112wEhmP	127
8702	2vbpCxYXQitjMpkjRdRNXXpgpLZGevwccpv3Kr2NDWk6i8NVSeKh	127
8708	2vaVu4fqMKnav6cxh8Z493x3a1TRg93F4T4tDHRDQ2ZnWGWD3x2F	127
8711	2vayRAwHs3zP8C5quhGx1fb1s9EQdQqa8Uz9xWk44Ru3MSdK9PBN	127
8713	2vbb969HSptRTmyw67GTuEcpxchtKskeGkXAygCUrQ3kLQ2JLd6a	127
8717	2vaAeA5T9cguSXHrdHPcEt6jEZZD5EEF7S484VJM67aVndvoiiFt	127
8724	2vaFGXr7dkWPhSESUbyEHZgn9Pt9sTbj2MZHH1DYVnM5ccKkT9ww	127
8726	2vasKzZEnqAf8eViLtbNQJADf4i2ZR5MWXRDPUcyoqX5HWfyeF5s	127
8728	2vaVzgbjscxnRij7U8CmQnY1ycpnxkEmwXFZXR4MzLF8MTgTE3k3	127
8731	2vb3KCfWkYFABmAwfbsdE311NKWMPH3Mxti2JZ6HqaccHPjJrKch	127
8734	2vaeoN8iH7LAw4Mqr9vrEaNJg6eRdrueb8nLKGLAtWsmFEU2tunQ	127
8743	2vazMuYAaQhanFXF9YuRmtH6hqt3GZvYZ5kRtLNtfVSP1m1sj7SM	127
8749	2vbbw8s2UYjgYRDt96nFemCaJs6p8v4suLYtSPTLyWVPEUqJHB9y	127
8752	2vatak1pXH7iqXmxhpooEdww4pLroFscvuQjTQPGxrUCXVREoES6	127
8757	2vb5wevWvb9YkqbEYSmgnse9ibCjgGq8EZiXBHCkky3opr3qZjvM	127
8760	2vbeQbdh9TQ4xq2tjNjAd2qzBcsnJ8NXEeLiPcDFBQQCQmfFgq7y	127
8762	2vc3Px8xKKcSzuXmFhKNhF5rtguyXYLizcXE5JxESn3JSiUN9U9N	127
8764	2vbb2cizbb4j13cRfCxmn89MxVjXY5GwZJBcKyFQS3riUet4nRVg	127
8767	2vaRxKZF6nVcZpLD6Mp4wsfd6vhWu3ZzNUd51sM3yXnqzRWVb1ys	127
8771	2vaAKX6Y468pNu5p9Rwq8Gc1WETUhYNHDEam6EKtbWZW1DETWSvd	127
8773	2vb5cB29R1eVrFJCXwGRhpoKnPNaWX5J1oAjyPMNRMMxaciG8nmo	127
8775	2vbWtdWUiZZqjvQEUvNxmMT3K2KKurtBCVNicqkQzCirno6wsXPc	127
8777	2vaabULimosZd28F9E1bCN7GmFFeeyZLnT14daAXicFA2BvtbAVp	127
8780	2vbNPLpA7jptSFpEMWUKAoQrToP2j7ciHHC3iLAfCqzqyQFCSgxW	127
8783	2vby65w1Hs742f9CNyTjzqbnTg49bbXRraocULSBXtH4FM5QC1UJ	127
8788	2vbVddZBNGksq7xVzPoc3vE6aJKBG9CAK45DfTRQBxXE1YhwSxUp	127
8793	2vanNMJTGU6fefLB1yUvTQNiJfhJJhC9Km7y5of98f51Jqsko3oQ	127
8796	2vaUq8LjNDnwqtym5QNwLbTSoF3yPHJWvqgeWjEBsJBkG8Zh7JYj	127
8800	2vavTV3uxGobsttXDbz5DZuSzuXp4n4LtmgPSzjR7qiLzVYXraqU	127
8807	2vaLhv6phzjEcoTVBJ8Ncw57hEtb1vhALgcNbWPydK5MCEPdJ3Ks	127
8811	2vbMM7Wt2krNqEEqQ5UvnBmiMKkpdkvVHRMFPNRXRi96FGchexC6	127
8813	2vbVgrJzRPx11Yrkv63Ndo6R7MLcnEHpd4LvhL9nTWuaLARB518w	127
8815	2vbjoQrE5ExukgPS6A4TCX8sf95YcfB56937MaRwBr9pExJZJhPM	127
8819	2vbm7cuCxAh4EHmkSaCRJ32xy3bcL3G7npAXz18iAjq97cuKJ2B6	127
8820	2vbY43iaF9HUZDCs9i624rVNC3JD82h3qLgVD8AUJYz7vK8iAh8A	127
8833	2vc5AMKas3mxJhtFo1HEuQoWyyKivjmBmFKs4YGY7Mw4yUpsBGfz	127
8838	2vbvcdw5obfd9o47ztvzhJsY2Y99Fp3nU4s4sSa7poht12kduKR4	127
8841	2vc58qVbiDX73CQo7hnpRKFkPyJ5NDqm7mBUBFHg8fAn9qALNLhH	127
8482	2vafkUJT9MtJzAsPTyzkDdC2znWSt38WS1Kf6mBR1iTSfSTX7noA	127
8484	2vaJqez6fvwprvAu2NctHmX5jqxvgQRiekRPcMXiTPGJ8B44GZfX	127
8490	2vaugZdeN4mNCBvScDXLBWF2jp4bUMmHi4HrSkEDXMcBJjmmpv8Q	127
8493	2vbZo71vgDVdV4CjbqWHvznndiaJKPt4563574UvxxeuC6uPExD9	127
8503	2vb5LrqPTNNa1ML2htK4KVpjXQDmrbVSqYcfwBidWQFkuPKRrM48	127
8507	2vb9PGDmjnuqjbwaUv8jAXn7t6DdPH7VZkygNMqqfNTgo63S8Uj7	127
8513	2vbMrNy6c85QEUhaE58PABA2WZEmiWVpmz7y4wYBdeCnKiqPtiG8	127
8517	2vbVNQRJH7nNeXuKVoWpyhJfygBoRipMF5iTSu4TTKiQuc1iV9cL	127
8518	2vbdxFUz3iSTsZqEGoaoUHdXVKdC8RENGKoHY6CZZrt9YoSvvTex	127
8523	2vbxKynnGpM6DSKbnRoVfa9ziqT8oACLFG23ffGZ7R4R6WYho5xm	127
8528	2vaFThdLC6nyrSDqe1kp5LzUzAuQ9zgEEtZ5yLocCP7ehKLSJbHw	127
8533	2vaw5r32khacBNn4goAARcDyR5127E13DNDJVQALK7932T5vVYr6	127
8536	2vboXjWvwLeN7epkPV5buuSCLujN6mnavQay34rkDW5RXN2WUqRP	127
8539	2vakXp7w1UyXd2r6ebWzJRfkyJpKdaQt9GNKS6XqeSAVXhgB8NUU	127
8542	2vbJ3Vi1rYzvUgwiJKpe9jGiphp9FLxF2y3Mz6Qznd9SZTy1v6c7	127
8547	2varVwts3HR4vp48jdEbXexeghAJEuzxssFYoA8Nx1EvANufqnF4	127
8550	2vaAvrKSKEjMZxqghwczZoRJrvRkqUzLRmAXM2ckM8tQQ6rp8tte	127
8552	2vbwPowAKs7kdWeUhE7wztQeyWW7Xuc3WeahFcxgHqTD7f1bJDia	127
8555	2vbbLa8BZFmWSdnXPHAmGbLQavVk9M42caXketiKKqVaNjHuiice	127
8556	2vaG4nnhVassdatjo2brZnqkfaoy45Qi88KkK1kSqwzfm6xUYPTB	127
8559	2vbqhP7DbGrE616c5PURm69dr4UzFT7XzQsoLRqnDFcDCKaj2Dkq	127
8565	2vaFy2T11Nx1zvt6ndhvA7gJ1VDz68AxCUgzvzTbUGCpsG4xSfjg	127
8570	2vbVscysPrHGXTrRSuEvZ6ipVqvLuqFWcEgqQ4ASfAkZ1N3KVQvG	127
8572	2vbweQeBrxLeGTya8Hg1VUFFVfr7fzHqFLrxKsZeLPgFao3ugYdR	127
8574	2vbZUNjc74PBjreEnyi3zu31DuDrVEe9MD484281Do2X5ZMLvbby	127
8577	2vaQMhZ6wYf4g7WKWWawvJaXvvVfPnkajcbepAMuL6FLe6hHZFBX	127
8580	2vc1kMUbjzSThHpcc2zrYML4eKYuBuJnjw9o8YGqsvv7DdHjhzhE	127
8582	2vbQgRZkhTEWLq5QFH8CJSuNXffDBktHrorK9xyiH3jCpafDM2Ga	127
8595	2vbt2U5PVjaN8tJCnGVMqGi1PNw3hcUgWnCWmLzQjHwNqaqasthQ	127
8600	2vbXfbWymkXnPnD3CL3KjtkTGoA581rL8NXLqRS75RTeapKuKmXD	127
8606	2vbhr26AbErtdUSN3AmTU1mEr2NF92g1Vb3ybgYY5dK3MtrJFwZA	127
8609	2vbw21DQbWEXoP3uzq9SoAubLL9Fm3pBL4qYzjtZpRFkpNfvnnes	127
8610	2vauXTPGMRgK3cfmDSAekV3SjYHxBtRpc4eazDbxapGkU9z9NWrP	127
8620	2vb2tgcmuB9UtzzS3a5b9G98t2CybhYMGoukc2UizQF633iZzpeC	127
8633	2vaEnK3sYKuWg3QFGmdDgK1QmEGrx5KxsUay1aQLQS9wQeUErLiq	127
8635	2vaJA9A1FvjrNT6oUmBASaNHWbTKtWHg2rmbzRaZQCaTaw5JrJZv	127
8640	2vbwVJA7JBHifayrttYGyctdCuWCtRnB2YGkESEUdHxbXXr9MtB4	127
8643	2vaKELZVtCUyKbZSLpMufjpcUYVZjE3yrPiqGpLY2T3gG3zoSneg	127
8654	2vabXDMbt3eCoLvSUm6PxUGKSMxH9356pv9q874uQFauLss6XL2J	127
8655	2vbuUqUAuNVy6FcZLDC2ZnBqv24dNit6rzmb61dXuZy9MoTdGo9Z	127
8658	2vb9UbY1R9XLx36Q4VWZcDwzFA94kFVxyyENp5B3Q1GbXnsurRNC	127
8663	2vaSCMsmqC1bwwTN1MHMjSptAcPdqtyYQ2QUEsBfHJkXHLB8mUYz	127
8668	2vaKvPkXy4NoL6QmQc9dVDZ93J3SzohYvvsoT1Z9X9Pr4dTQG6bD	127
8682	2vbHwdQcXiU9yfq8hb3qGc1riTMgxrxMtNXGwfs1RT9kz5Juue5d	127
8685	2vbuuPrY9HMSoqqnn5sAJYSS7etXWwFirLVTakw167TZoHCaxQeo	127
8687	2varWYudUzxXQdS12rmWPPeKv1XaWcewHG8TLhnfKLbirsN9PL1n	127
8690	2vbUH9ppnQFCWXmBc4HmgP4yCPTFH6ndZ1ucAGth6T85JVxU3seU	127
8692	2vapg57e7P6iNiHxYemi3h885nUMpkxiVgheCgMKzXnC3jtnwnf9	127
8696	2vb1wExjE9tVCVn8PrYmoX48fPCY9JDPoQSzw8wRyeXm6ksiAUAG	127
8698	2vbXdVv1rUSUJ8tzB5oZ5DsAgAityAW6p8RfNQaKYWESfNVFpvAo	127
8704	2vaV7sNzkkjReSiHaT47eSQiZJeXUZc2Atsgk55sCzLGF3CUNNR5	127
8709	2vbw9axefTDLnBLgAaBNTtk5ywLhyPyzRDaUYPC9MA73ziFfyFHw	127
8712	2vaJgurSdJE4ZpqjXNT36iNgLjiE85YHJiBLoDkdCZjAyj9aTRRb	127
8714	2vac9wrFvU5pnybs6tj6GXowMnN27Z8XShyVL5jrQjnDWb8rdNjs	127
8719	2vaJG3eAjT5ntuof7g1F6cn7abbZR7nnXya9dbErs9Ge7udnoXJx	127
8729	2vaUmC7dMhNPXiDeWH8LxikBVArMV6AfsF2Ee7nNTQsDHTmFHHsh	127
8735	2varzdidGZA5HuLmntWKfmfJ2j19arBetdqTamn3qavZLAGjYKwJ	127
8736	2vavphFfrPFK6vLnZthVm9scFKj3raiJ3k9zep5VFKbPbPpY1Qyw	127
8740	2vbfFd15fJBZ32JmA6zhtw5GKQZn6a9bsC9mmXUhUZ36ZhZuSVth	127
8744	2vb4w5ZZ6hM6WFP44vXCar1ukCZmJDRZuayWQGznYTgrxSUtZmmx	127
8747	2vb8Ptw3F2rGcRtoTnHBXn7RW7pCUsmeazATzfA9sLo9uRCVAr6x	127
8750	2vbazevBNg6kYA23sWmKMRasgwCMuzQmtsDZBtgmjJ3miYURSUwo	127
8769	2vaFJPKnyXg53YBQ5GKNTbeVUuZQ7ByH5aKdvLSPR9mzrdiPjrgP	127
8778	2vbfPKPHVBA5R9qd4xeKAQgJoTk7TXF5EEqSm1o9EEE55zhVMN9G	127
8781	2vbpBzHnRHJvRkpH9gQpGYHfL2nDkXUYhLJosZv9pGe2EU53cHCU	127
8786	2vb4Xwb5gZZJ5JazzUwPbRsavMJNNij5Ca9qKJf8hBditWjWaFDW	127
8791	2vbvWBgV1GKKZuzoY7GvGGCzp2AUXZdUtDsEwx4gw933yDRuFBGD	127
8798	2vbXKo5xsVFvx8tNnkuLC1JMM47NYEufTguwmmjbuWJHAcfG7CxG	127
8805	2vanKMAeoETDY5tGXeT6rQmyxeRRsb1hXtvqmzav8V7wecnax8e6	127
8808	2vbz82HWqVKUhcP6Ysr4jcUbJHJLoq4sJ997RntDDkzcGzTt4gFM	127
8809	2vbQea8FbjBvtidUkPvxMTpJp6biQoFtxNPtq2526sAfhPKkx6uy	127
8816	2vbDLykpT84BoNADqkcvHKkyspH3odo8zQGL2ZUjcqcYvqH15m7M	127
8821	2vbScG9i7SAXNvyEdSkAqR45gmrnFhYRXTs9t83PZcg8ThqaQ21M	127
8823	2va9N3pz1Si7MrGGydwkpJcNKnSKfP6s1ozKA26H7gWGw1NbAfxS	127
8829	2vaRvu2nSXpsNeMWk8uGYi9HaD3ddxvgefFofRzXTbY3EKYdDRkr	127
8832	2vaQLGmrgNdkHjuJbwLjfhcVj1PtFHKoqDh7z1Y2kC5gP8ywS5k9	127
8837	2vaHCXsGRFJjYBWsGR3NRp9bYUNSNtok6PMp25kHnNbNQhnrr5An	127
8840	2vbA6nfbfYcGvn6ay6bi4gjiemkdvJLRKyEL9ra6CBRBBWbV2S1h	127
8842	2vbj4aAhkRE45Yx1MpJ7ZuMQayRKSJPP6FhzDm26WGQeUm6onrep	127
8845	2vaXm82fKjJCM8FSvVxCv9WLqR5No2eHrYV9N782V9nNYuA4hDbd	127
8847	2vc4LGPmHakjzwsfgYwAseRgsRQtiooJj5wPwzbx8uAoge9Sy7DU	127
8852	2vbsp6y3S1LHSMtNAaRjSST2xMp42Ujp1J5kJHWX7uq2F8KHYoeo	127
8855	2vbPc5GM2jJr4EwfLx7ALboWisYUxorXK6LSedAY8ee5SvG6qNKn	127
8856	2vafGa1ZaeS2iAbEgFpm46nmdKh9qJS8a75Q25aJ41xqXsCDB9aT	127
8874	2vaVzeXjKESRPMKodRS5Dv2AbPL2f6sMMfEy2et8LMPM5Y1eoTZQ	127
8881	2vavipUQdyqaMTodFGThJyqKinNgZQEGrjStdPnYp4V21c9uBh2k	127
8887	2vaiDa9sNvR3g216bTWWYZY3WUV5ngTKabaiLmVj1SYZEfZwaxgf	127
8894	2vbbD9VhBex5CKWVcffRotSGNGBSEgj7BXnDVd2kgG46dB5vdmMB	127
8483	2vbD5YZtfDNva7fS2bMUMMS8hVxhBgJduHemJyfecwTV44cCHVbB	127
8485	2vaSKTnJvG67PyENNrM6Xiw82h96bM6cfSvefZGQW5sAXZDjSkPg	127
8488	2vbHnYRqszoen1xV1zVmmt9DYS8VmqPf2jVQuBWDGb6xWUjTEPCi	127
8491	2vaZDupapMSJdWic3f3e398L1QjLUiR9DCz1MjTCEg1X6H3qcTMi	127
8497	2vanCHskDzvqSCC4o8nGeVyP8BHJUaGkHvzs82q6YpcoAapFbRCq	127
8501	2vbhDCkGFohUjifRFhuJt7SVDGi4icBna1gBbCNgn8qw5XeNznRJ	127
8505	2vbt8sFRwbfqt5x9WVeeS1jFfHz5TFHwkguDuSMJbXg9Sf5gvhQb	127
8508	2vbkKVipazmb5qHUtRqv5uCDqPMBz58RbjTyVtWUy2qXv4gPKeQY	127
8509	2vbBZ3SJcAVxCFZWMHPUY9VG5bDSRTRuUoS7V4YnYTfKgeHXo1Ln	127
8512	2vbR3L2d2tkDaxvGDx6tF9vWcRFmegwgMtj1sXYcPPBc7rYsrVD1	127
8514	2vagKZ8uWHJobKkJJVEfTtELBZzksVNbRG1JomodsyPvbuVWYTJQ	127
8515	2vb8NguGkoCjyAVr9KgnbqBFjMATPzFV1kDtqbkRHkadGFLrMUMw	127
8522	2vb4UB3mRUzH8safk6vDPiwDLGivi3YykGxDUkLtn5tEQ6FHvSSs	127
8525	2vaiU1jjYysadr7jDbjwPWfsAWAhbpsGihGEa6Nd3jXBHJTznSoq	127
8529	2vbkpqrQZv1BdF5udpnePAhHYDJxfq2NWAKE3WoddoJQexKnvuUc	127
8532	2vaHLpxkr4ZXQPabdiwJwvYMED5QHFPKNZBmxDvkYM9ds9g5kJm5	127
8535	2vbdmfT1fBvtXyQQaWUQWGjEwkvnLDXzkySgytSmukeyS58iSJop	127
8538	2vaHVxv3469hAdNf258gHooNDNjWSeSkQC7SUgfTWp3dhYKMvmba	127
8546	2vaR83nGcHxnyTynvzYmraBQK1k2WTJ9eDwGniuR6952crZQptx4	127
8548	2vaPfjv3cpEswM1qNTW8C9EPC3oscs3EnpYZ8JKLEG5TZG8rA27N	127
8554	2vaMtAzK6NYatk2qcHhaFAX7WCnYR6BEoy51tdg3xhDSoeoP8xtV	127
8558	2vbeKnQGQsnCzp48JzW9fDA3J4NGKkkwdEPjd5dTpWo6L5CqNXfT	127
8567	2vbAQPZzrJFa23e64m1WrHjaEjvYbB2B4Q4wHhYYvgp7eCjHkwAN	127
8576	2vbndgHiGDcTYkm129mqfGMJxNUSisZq4ZudTKr6VM6CSLo5r29L	127
8578	2vbnLkPTVHguEqLTCQFmhoTGGJHp3gtMrfHLqcuKYMqZCTWbirM2	127
8585	2vbTjXUo1V39NkK4i9mZVguAE4GSx8cZQ6gjfwZkthsSrJsrUeJP	127
8587	2vb9jXcmcyz2UaGBHPCBaHgzQBQdiS9kTMinybrqqSLZumAYZsyU	127
8591	2vc3E7qxtRB44uPhGzE9nDBTqsi2MrLMb2secZKso6S5tFE8wifE	127
8597	2vah3jcVjyKnjXHndfCEF7VFhrqt4nM9E3WBDzk9w87AeE49SF6c	127
8599	2vaW5128voD1CfHCPFgu2xkbTLeSP3o9YEM8M9qrXoGVvKeGJv5D	127
8604	2vbWztskSLWeNYUgvGy7G6bF12Ny7i4oP2q2CNYvdcG3SqEnRkXM	127
8608	2vbjohwnrV6HkvMoTYoSL2HdxuFhy6wqQYhZ4SHoQzA9MeAuRQqu	127
8614	2vaZ1YPFAWFLxfTBLTweHtWcY8RyVSVsshWsBn7Cdvdu1Q5Apu7U	127
8617	2vazgy5iEsjYQzmh1CSfXDtBEBBhBADqzKX5W1Dy29KR5vkbHBdH	127
8619	2vbSdMpVwyAVxbTW669THnRwcULgJZHJsUWyYpcSmwcDLdEbg9bJ	127
8621	2vb3J79MaifAaTHzbjVSikw3oRYv3bw3y66RsJjJ33c3UKVjKUNd	127
8624	2vbxRdSXCn9mSVauwwcK21bqpgZSvVqmHx1A2pWhfEso79z77FQq	127
8629	2vapijDnGtxkf2GkUi1JzMZQDmq5fMHERzrxGuY4QgDsHf7aFgc9	127
8631	2vbcwDDwK4gpx2JbQ3MYFxXwXAX6FMhc9DnqDHTsG2jqpsH7KJ1Y	127
8636	2vaUXPVdjHkik8LPn7A4P4hyKuG5rgcfNfPc7419oGWhotX82rej	127
8639	2vakUo2iKq6Ps4QpF9gqSosjQSQ9WdTDrX85HDUdkrEQ4unaF97s	127
8645	2vbbzVXQXWCtm9dfQ5aYiKqyeHmWokKw3wxG7U16zbF4t8omzYvV	127
8647	2vapLVhU7rHws6hsiDjjJmFtVJggFdYq8gRh8inWVUntrYDWm8bu	127
8649	2vbPt2P3bdERAA9sNk2XetUTwoLYjKRCzQNNE8KZwwrKuwxW7Exv	127
8652	2vbqyBS4yTW9NfXrJY3pEV37YxxC6TRxDW82N3Rbz6us9LLeJJa7	127
8657	2vazL6s4atCzENiLkfmw8N8Tyfpv7PsnXN9T1FWsdExxZm6Z9UtX	127
8662	2vakt4xfhNxmJ9jor6BbRXAwmXkFAtoviiLDFPSu9RSx9Q3e2Khi	127
8664	2vadkMavH8Xx7ukpZH9yxHkjoCatjQMdYTBR8Coao5g3s5RPt5JK	127
8670	2vbQkHLe6ye1KSmnUTJrmfAJ2uG929Ao1aN9XtC5sAjNje7F4Nqh	127
8673	2vbstKjPbiH3jZhMLk5aVrCJcH1CfzQ89hECej8WiyANuPZ2k4ha	127
8675	2vc3KXPcU9oJAvGqkRcJQYNxSEJ7oNjqMzzeKr1QzyjUiGu63Kqr	127
8678	2vbyNBQqaF2MXxLkzwZAa4zHoaDSvdkDDVepC3k9DCMY5nvCKEhk	127
8680	2va9khp3Gjp5ykH3z8xkvEuqdhAyzi4tsZpd4yhRH1LHKfE1sYK8	127
8686	2vbYemsYT6ZMcDiRybBhDSsacxBZD1p3xYoL97BfW71hAckuZqoV	127
8689	2vaUq1zHa9ftjKYF6SJf3HMpVmAFm1rjTeevqB2MZoZyGLBs2u8E	127
8694	2vbxLrcTwFnHLrSC7vzngFqbVcqgwW6bEMGoXyyRWVFq4kw9L5oN	127
8701	2vbFYTJVNRTZongNv2fJ5CFJPLU3tfdToxMoCm4Q7rrX8f5gzUx6	127
8706	2vc1ePyPrV9XhoT2UU9ZNb9gNhnpL22z4baw21NXH2QXE9G5zhqV	127
8710	2vaDij3TRrvrCRrTAbsDoy8ppTMgrhJ12rCNrcxuTuozfrKK7bAU	127
8721	2vbPxq28vMQENFaZPvCnS5tFVFcYMYgoByx866pQ7Yfy7wqdDw8b	127
8723	2vb3bgpys7HSMWpQUixaL9jbDwJSYt3e1VzGjs7uzp64hSy3SFTe	127
8733	2vakA1QSDoNU2GZBEV6CqZLiYynjqfk3pZzwELyQrWFdBeR5i6kh	127
8738	2vag4UrebUGeNVsrb8V6wGABb5NzFtc2dJiEDBXeKH7JjukSAHgJ	127
8739	2vad4eGyU1erQ5dRTvRVgHn72gcbFiJ5M4mSGov7tQ6R7JqZXko3	127
8742	2vbcQ1BbymLJdBp9dajEzK9iRhKfgssjCEC6CmCLuuQj6QpP9wBc	127
8746	2vaooBkpcwUpPV1qm6HF38hV6Qo2hVE92zNs2wuZij9bgTBaFiHg	127
8748	2vbfPfCiAHgwzxzd84suzdYMLWmNKQbyo41BWsKj1jR7HMPy48F3	127
8754	2vbFgjnsBiYzQ1NJVNUGriX9uqFieF4XddaKqgNBbwPEoFf7pHCm	127
8756	2vbHuzQ8DgDPpPTgKkU3BqihyeTe19LrhCFr6yLZCTGEhSTUhVgH	127
8759	2vbAspa1iVEGMdtDPYmXgAb7Xmh6E1xb3ZfMSuHjbk6Uzoj9E1jo	127
8761	2vahgbM7FyuHuSZj7Qh61XVUiCZMyhezY755rR8GaK8Q3aww48sJ	127
8766	2vadNDP73zST1feWd3cLruW5FEEpW1kXmFwcc6oLwXwuLaqT9TGe	127
8768	2vapuofFa3LgYkUHL6vg7UfTsBxg8nAMZUqVqMbJ1bU29dQtWSUN	127
8770	2vaxA2NwZMsY3puMjQzTyvn52dihbFeSLBhRWp3oy2vne7nbbECn	127
8772	2vbiX1yiPJXqkvYUzgbXT9kJvF4m6Hr5WEP7B9JjEpFHhsoCqJAy	127
8782	2vb93foS9GjRQyTEUiF64agkncLKWkJgoUQgtSgn4a4dMFpFBMRt	127
8785	2vadmAWBL9E7e5HwvjxrwmuuCBT1T5EkyhKFg7HRTqVhEXWWAfWA	127
8790	2vaBXcHn9jHYL4yncr6MrRXkqt38ZXTeTETwpqJA65Rzcx2hrz2r	127
8795	2vbDyyJ9orZHBG7Riy9qUpexhtgff8hrVot1E156JdsKAgc8RqnH	127
8802	2vbCd7CgJXRN3eLfRq6cWUgQtBJ9DkEUEPBQscyXQGGjq6ZTe8RZ	127
8804	2vayZm9VAv84hmwa2DkKE69ZX4LL8dMwF67kqdMa9qL1s9duobXR	127
8810	2vaKKJbAHyQA6QBHVTFuKmHEaQ2ueL4ZDQg5gXH1NwYxQiqXajJo	127
8812	2vaA6NAhu5cc8uwNmT5ADiCD7kRPTFqnmHTBWEKfytamWJ42Smv9	127
8824	2vaEs4LXNJ1teaGuCWP2Ewsqoyp2J2DthWyTPvVndhzxZKByA7NV	127
8826	2vauqwRLSW7LGBKvB4GzZugw4Sij46yrQvCw1CVqfU3xSXmTmZD2	127
8830	2vagoZ2jRMk7rFc5Y6BK1VWCG7HStyyATwTpccMbt5HTXTL2Y9Ja	127
8835	2vaTeck5icHV3Hd2gPEnvkX8R3npegcjCx3pDToiyfgpnnund78j	127
8839	2vbY52edkNMWqsaFvdZGpqCYsYv8Zt4SiARmcTzx7au4c9UzpDsU	127
8784	2vacCG7YGBHbai5CsVypF9EZkBDbnf1eKLkQtxFeThw8tJRnLoVW	127
8787	2vaoPeLS1Fq1HrT4zT3nh2koHuss5oqSWhddFyxVPmfjSc4eouQr	127
8789	2vbU6apG84S7VxfdP7ydj2AAfQh3kKDYzF3Bk5mL8PNbe1AqFnTU	127
8792	2vaEKy58RXMMPvQzoi9AMt35iZiNCDg1Xe5QFUx2gnMrNQYFXJ5S	127
8794	2vbvvRP9ADcgAV74HW3B2SZKhgkh4zWJhGfYobLC6tpTt8S4Rgmr	127
8797	2vakVUboDCe9KosYPi8fnNL3A4JBg8ZuSdiPNKe9WBBn1xECFGiQ	127
8799	2vbS9Zcb1QL24Yx6W8YT3Hg5YDL1VoRmx6n43sV1ygMg2MgKZu6r	127
8801	2vabm7K3QMCiw3LxtCZQqwMcZpvJGjSQdQCDcQmSfXsQWVYzWc74	127
8803	2vbUNzx86awtX2SCZdQfxWKwzmamYnaTKZtokexSUafiQ5E62FLG	127
8806	2vatfzGif4VWoXLbjKeX9UMJU75mXJTsS2LTfsdxRzudUUTv2dQU	127
8814	2vaguWpbwhXYEiNRRWqMNSsGWEobKkjxXGqStyCAHQ5meU4b8eXZ	127
8817	2vbfPgKgix5GvhkXLRPMToQruKamsXQopMyMModte5fMvTtR7pub	127
8818	2vaWMHCs1muSoMCMoaV5kk46Z6tc4JsENwoY3iEbEaWhntHrtkJf	127
8822	2vbnqnepfBUGrBnvAe16KoDXQFHRbTGi8K89EUfCQCUjNyq5XEWV	127
8825	2vbAugH85axDf8LDcYoXZJgV5yoFQpkiDZpk3gDgD1JKkfM26v52	127
8827	2varH9naXHUcK5XZAMUCrjV6YYgEWAzn4q48eXam2zdNbExd6NmX	127
8828	2vbpLpBbbFA2fsJE7rDkE1jYRBVDBUZVodARA3jeBU8PoYJTBtpp	127
8831	2vaNfTR6xUVnV884MeN7Crf6KrZqED7qDp13XfuspsX1rdGq8S8g	127
8834	2vbC8p9sPv9jwAZVdoQyKwDa5p4asWd7CeaWBuHyGhPP1Pf9DzcA	127
8836	2vawwNptoMCVCGXNbiuoWGGWXzxvCTAV2tD1cEzqbkxV9yD4M4mR	127
8846	2vaszuQS36UsNhsZUMfDEiddnK52T5pfEmeF6staHtHaMrgL8Qxh	127
8848	2vaUhpa5HY6DELCs124hmHLfzmcXNLy7wqLhgSTYwrBcf5VTjUvM	127
8854	2vaNe9YgnxxbXUyvivVmNQpAgnZ2pri1vKM6qjLdSTTehv2Epm4f	127
8858	2vatKrbRE8WF6VA55oBKCZTGzcvDT7zkMPH8ak7BkCtvc5zkdYxF	127
8863	2vaARrh7G5XVJGKejAxXyRU92fjUSYNKQaBa3XXxpzvU28JYGr4q	127
8865	2vbgyErfgopspCgjhsMPdpQU6Viwo5DWfYALefmiSoHo4BnzfXWb	127
8867	2vbDrUWTCK65HR2tqzppo7HrtcDbW7Uz5ncBQ27Ay1H7KVqBvhQa	127
8869	2vacDdubxSgvjkNiEy2MsXpNXzvmUraUAik471DhFxP1vNujX7HF	127
8871	2vaALaANTacUU5raHzqohp1qU1t9nfE4Rd1LjNkkXEenBprbSRiu	127
8879	2vamMTGmmWk5hnJ7YCvXSVaEZi2tw5Z7ZWPn8Vgxj7E251d4SMts	127
8883	2vbJrSkS8KS5tbWbmagH1CH1S8UgbiAWAHgNx9Va8tS9ajKPUhnV	127
8886	2vb2J668Mhg8E4TUL2YYsjLAnPWpyT4Vd9fakbvBGLgWsededQHb	127
8891	2vaSTDogiUeti26eyMZg7iXMHznoZifsryRAZGvwWCMyG9TPj1WU	127
8893	2vaAULoNEw13XjVRteR76QWhfox7fov7oD34KoW12z5k28hu5QDe	127
8897	2vaJKQyR2gY4cemEpGZgjccCjV11rmW53gtFuihw8xG3Uf3mxvH4	127
8900	2vbvjUEgYoHE4qt8idbTfNXM8GE9GraFr6aUWii1rZ79xRzDFZDk	127
8907	2vaKeFjueku1bPjKCpyPHimeikiKD9hdsiJPXPKj5zDW3RiFGrXx	127
8908	2vb463YxhzxKZowegzNT7dqQM1WyAkMCYTRSU7RtsLYfW3EQGhvV	127
8909	2vbqsYA1GzVXq18ABGQoqDKexnsecTQayS262FoYofFKQddnircH	127
8912	2vau8KY35q66wPF27dbubQC4xhnzG6LDTcoR9gKZwxg4nXW7r4u6	127
8914	2vboVnyobGmcj8KJSsfZZiadu7GcjdBDp8V1A2De7Hh3TwwLdaqc	127
8917	2vbQnFCwL6XYBaPDFb9qgYnTqD8aC7yMpL7M8RmsNJDHT2u7hVSK	127
8920	2vakYbpnBBJVKJbSY9QGJd8GZH9kVebRBMY8BUFUzVxf7t8MJp6r	127
8922	2vaLkPuEwdqxc5SEpu81izo4d5tgRbeceD32vNpgP1Vfk1QM3C1y	127
8930	2vbLpe6zghbvd45xKxnSGa2p2ShrajMNfGSFPnrJwto7A4xxmjYk	127
8935	2vafK7i7Q4Uw1M6tmpLHRgonYL5GHZCKf8wnX3XdWuf2Jx6kraQa	127
8939	2vawgWqFPnBZfRDVDgkCyGyaAqsMo76pQfkEdtozNrv5btf9nP99	127
8948	2vajcNg3H118U8azLSxDmYXQnFt2r9LQCp81ufBN4c5hzXTfeypU	127
8951	2vbtM56HRq9wnqLdXh1mAFqVYwDymmCGFsdH69KiQvqosYeSydnM	127
8954	2vamw2rzGaf5eGhEbvQpCwBKxsW98tXdpWQavah7WXCpE96xQtvC	127
8958	2vbjrmPh8u9PqCwReLZZYQ4L9S6t3dJ65e7B5jZvTK5JEgT8vw8g	127
8961	2vb1apLpf5V1vfuStuymSd6ZqJpUVzFKScpFtBEMV6ZMKVy5kM4K	127
8969	2vbvDHfjvtpbQb5rd2rMszg8bwdYcSC2ed2cutUre2JQgP7AyMoH	127
8971	2vaPEjo4WzxhSEyH4buc62Xd9PgrTyKQbKddHGipvP6Yj12ATgmt	127
8973	2vbujTevtBq2KffphHotma21EsodgCmUjjkvoqenpMNUQ7R5jkkn	127
8980	2vc2iEDrN964c4LmBgtnKk3voGoX6E4pdbeRKiXHp7W2eJicJTJn	127
8983	2vaUt3jL2ANePEzHsChncEWxDw8voBd8SykpDJtqz6mPzWKENcFG	127
8995	2vazQaauzeAJkFRpoFyjZGHYjQAn8D1S2a5fPocwZHxEgLkfdJyR	127
8997	2vaTPbgAxgu2ePuqoheE8L8xzjessUf91jJdH3YE8qs2ZB1iTzWR	127
8999	2vbpTnE8BMjJ3LZVUxakPf2ajucc1s3FKomAaxZpNMYoy4MiQKMC	127
9001	2vaYAt91XrYVj3a2Lgi5hMMPdnrWVt1sU4rd19wWXpVLSBQjzM58	127
9004	2vbtxt59qxBJiauq9bWNRD9U3wDAUe4UqMYYcF11B2YSJFmAdrU7	127
9008	2vbrjBpGEweXaUJqTBdppUHFtm41AEwL2b2U8VFuPdGhaaJEyxSE	127
9014	2vbBcRxzcSnGZdxuguQrkHUpqT162tnfdFa6jLr2Fc5DkB4q1kgq	127
9016	2vaTa8UvkRmKcCpyyTHRLnZ5oXJp11CRyQmmREuCkmKycMYGtzY2	127
9019	2vaMmrxMt5UCLmAcArLi7tN11rvC1FTmT5K5bFaKdFL7pC6FzCUA	127
9025	2vbRqgjbaBuMbBK3dt53SFnsyVeV6bjq3W64mkDunvnHQXZgRZPw	127
9031	2vawzsNoEChMkpkvq1axKtvbhd73NpanDHun9wKALLkTf6x2zzPX	127
9032	2vaMcGNS1CfjLkXy9qtGLVRQPPLaUhzWK7bXyjoyTMsFd5qAjp7V	127
9035	2vaEaGy3McAtduz1z8LLwUeMLCnYxbvGxmRt2LLT1429vagm6g48	127
9042	2vbtZrHFp1jqDFM2NJS2vZAA56fZEnHonGMtZkb5P9E3uxV9rzhV	127
9050	2vbZKGZhkEDv789c9rGPjXG9dL2KsDWHwQkc6eqsfraj4gE85keV	127
9051	2vayNm4vRsUauwzGAVjJUbpRLF9ubGDCywQ3i5yApUL3ECUU4KUv	127
9062	2vaZn2W7skqLszVeUo17vrz2yTvfhqdC7JX3Xjors9B8jt34Lnb9	127
9065	2vbJRFvHDmGQKG6x6arQ5uWbYxtg1feoREFX6HWporz8zMPTEdDR	127
9070	2vacrewGK2VFSF9CLuCmA1VtkbQRkiKMZKFgdXc14kt62QC9kHFi	127
9077	2vbVZUkxrAj8b4VhyKp8Rx9R3rj9VjrKk9EWtMpnmacTAXuDfR2e	127
9080	2vc2epEcqc6t6VpAVBbkptempTKc6ckP2B2T6X2HUqY4od8V1xkM	127
9094	2vbXDRW8jFj2NBuDcSZ7mcGw7bXf2CM6DYXXyaSUgDGg2UecnbE9	127
9101	2vb8zd4tQjZv68Lw2xDt9hMK93zXmp3p6G3DY8WscB7sSwBtp9QF	127
9106	2vbvB6KveoitmJXan727f4SHwtNzqx8xWdupng7YMesdqZ77rP8b	127
9107	2vaW91pYcEUjioQAqGg6mhm5qUCdGz66PgBrny859yUWG9QHG9EJ	127
9112	2vbHMiCBz4NoLTsKKjkeKEsC7117oAnPo2rLHZsHoCN8GsQuqjkQ	127
9117	2vauoaGujJjohwWXsQfHp8fpFStVWpxqaH2D6xkBmaaQwhncGw3Z	127
9125	2vaYz1nowVw9aAsMcnmXZt75cviovwdWsPZMhgQUdUyJHzq23pwQ	127
9128	2vaph8TJHdGtNUAbgDFUG7jhzNfinUx3gpEtJmqMdiJGVarsixi5	127
9130	2vbKj5TRksNqbaBj5kbRpmDmJRM2VL4jHb8zsok6KXfR1ZDFmnKo	127
9132	2vbRrte4NKEYM4dRN7QF72m6wwGqhW2cK9JAWKb3BYc8tat1DP3Q	127
8843	2vafcxAubBM2JZFEZP7Xebd8oaVJb1gEFCUxvXKRuHLr1Bhg28zb	127
8850	2vazugWKQtSECV21yAcK9p9hZtiszAJ7j8AFVM3mhfUU78MfJ3BS	127
8853	2vbeqQCFKLkH9GuoCyzZ23NNSR8QxJFZ3SzHGce4R2WgVHNfxZB7	127
8857	2vaLaNS5d9PsxfmDrwU9t3jJnVkgvFrDMn9ruQMSB3g2orzpKLXA	127
8860	2vbz9DWZVoZfyt2UFX4iF56cHsPbGw3x4v1utdGBq5wfiEBuFqmx	127
8862	2vaGyjNWyex1iPZ7irvgBkxcLwLWSrFMNui77LhFLADbcmdJthqb	127
8864	2vbjGYvAiorqEhc4ZiQk6vM5EtgaLjuGctovkW1uUwk9h4j4yfnN	127
8866	2vbe1uVDZmYwaBmFTpdxukJ97v8jhi1gC1Gnq7BACXWoK6vFgaw8	127
8870	2vaoqjtDMFz13ttXuuVnmvwFjWYaHMHzDqM5FvQgAn6Ld8fsR6Lr	127
8872	2vbBqCN2hCCdYpyuyhWNjSUty5D13fCSpQnwKcYRyPqFHWdwN6Hw	127
8873	2varmCffYB27YbJyXb2kMQHhmr1Uus2WR2UG36RUZmLdbkHHmGLS	127
8876	2vbjeUtobvsrSNtr7ns9ehWwACQnF1Uwr11xKQRnoRUoyMNe7bDo	127
8878	2vbCwXV5zwLF578QXx9pUcEZXiWDSySfua7KwYHrNuyj14oNPDMD	127
8880	2vb9yrDqeBBQq7ujo4UVBxVvuNxv1SoDuhUuovR9vvguBfPfqvwD	127
8882	2vbGeUjHqfYPe6A9m8mtRMuMhju8nnX3TeAVLwff7u3NwYi9AZXU	127
8885	2va9Rssa5ebYsih4Zzt7f8SvPBC9S9jBUcfHWYNrBSn49LieB368	127
8889	2vbWigA7JZSJF9DkUA6crYydAThgpJEjeSYdBqRKeeyFc3MoZXKo	127
8890	2vbfbSGx8EK6kxaKCNcgjJtGirtoRojMDwUMVs8AuLDyH9NzYY9Q	127
8899	2vbcL2fUFtsDstYtxg6Tv8rGnKJKRBNR6yDJfrmrdaD3CGj4Hf67	127
8901	2vbaorSTeYj9WVhcBANwer7KVKseW26D8enSnQDGyzGx44R1hcDX	127
8905	2vbfoVFeTFZR3HUd4vSuBa3bXfGXQeNUBtRnnKxVmGSoWSix98bE	127
8906	2vaBTShc5SiLyQJ3CLq5Z1TvQMWvnqDCKemdDqUwFAGgfbW4abHS	127
8911	2vbWJVJfgxvyaJMSDTyKPmG21uxYsWj65tRAuCbkuCR8HZ2Yq6MC	127
8916	2vc3Z5CFrHWVwUEzdYSfPo59qskSt8zMK69cjip6XGVos1ASg9AU	127
8919	2vbcpKRLo4Uec6APo4k43ZcQERQmRUXtXymGmjeBxUNnQYc3Yymr	127
8927	2vb6yUhRKXPBLqFEudaFgeJWRf4buw9Rth2hohorJsmMbWGFShz8	127
8929	2vag9ttdzf43ZSUDakwQDmUAC91mra3RPi3WZZB6zJ3hPMpF9UV9	127
8932	2vbVwmzjqthkqVsuJ7Y3xzmBRgVBWAsuoHQbEifGmaqQisq5TXLC	127
8938	2vc3td8QfXpM192znjgnyHBf5x6usHpJxLDj12vWJTxGWBnabNL3	127
8940	2vafTBtHHjTU3e5iMQDaisPVFS6VC72N7Pqu6PgDoYr2C1n4oMDw	127
8942	2vaodyz6YzAAutmDDpv3obvuSW5PuT4imyiHyf8FPVpLAgZWsErx	127
8945	2vaJ2cEbUFTyZMG64juQgDGLdqVh3vcKrAutx1qoRNJZqDFiR6rg	127
8963	2vbzu6ogzWfZESQW3WerxhW7yWDfWiLKzoAjfetC8wypnmi53reC	127
8964	2vbo4UPdJLgoGAWTAyWMSYhAmtT72V3WjkYyJ84RcFq3UgabGJf3	127
8966	2vbuS9hBMM8giq899GnFZdYQZivAMipwRaUm7bh38yaxi1NJkiuM	127
8970	2vbfL2B2XRweiMrTH36Q9UFHDcTJuhH58p7gpxepviK92GJsZij7	127
8972	2vbaynhQCAmm4mEifbSFwPTkEy9ZSp5EDZRbTiXPr2noRd9i9JGC	127
8974	2vaiJe9UbtWuy9ZnioBAvvzCqQ9pqwS2Vc6byLuQfChPYA5JcgNv	127
8976	2vaucHbhxXt3avVZD5XuKVdWUwvQGdDBqtSfM7ZWVjPRi54DbGxp	127
8981	2vbpEEDPiCbqEXHxvySRGHRhwVnfWAHqx23ZH8XAoAStE3xShZzX	127
8984	2vbd7WMnFCS2HZnTGQwhrN5qsVzbDmw9WB54uJB4jsrSRZPGEMKD	127
8988	2vbbfms9npskQpKdr8EANTn3f6yktCN2h7wxevHwW5UrBvwBtUUp	127
8990	2vaPJzFga8zhL5HP5WRJREqQwMp1uhSAm7UzYGrNg2KiPFXjEbmg	127
8998	2vamzrZosrzSrSygJmRo6pqew2FoKQA9M62NxnL3FR5yU2G9rJt6	127
9000	2vbPkeDhwjYtS2GSQB8hRHwHzoS3SQGDEqKMSAY72d8CCQkw65SD	127
9002	2vbWt2BJAxcZMo324oAEkE3BZrihETK3FHozi7fhiXQMhuywBYCm	127
9006	2vaRkTNtNcqusixQM4ayBKGNWw6xLBNoXJHLVYNLrEpwoELFE23B	127
9009	2vbHoB8UqQUQ4VxNvXKZXVEupa5nYoE5vYHqBER4KsZ57MjbpDu3	127
9011	2vbyAHiaZQJAoWntCxbfxizBr5tMwvLhjHXxeKbgtCe4CNjL8KZY	127
9021	2vaCNNmP8RNHBbwfZisTxvXQZCxJcbqubLbbTMVtDqqMn1Y79MWh	127
9026	2vaQjD9LJZw59HNAdiFYgdNxUv62RZKpHj8voMyZLjkRTeorkq2c	127
9037	2vb5uQKU6sqRXUQqxpHpLieqxtmSET3TvSpTzzfiZR8Him8xBkKR	127
9040	2vbf8KXBG7NfpzAy9gAewyAZo1DTiVkyCHS8qVk72SJVMAAk7Jji	127
9048	2vbNXag4she6zoNebAMUzFwepjf2VPPUjGiWFNkm99MuFszaESpk	127
9054	2vbPAPnJTiANVMSUz9TPzKVBh4fsQEYahgw5qyEyHBkiPkyitbiW	127
9056	2vajrw3CyjUPoipLASpDYpmFTUBr1uB46YwudA1JkwJNjUFdsLSF	127
9061	2vaWzJNJYeGqicotp6bdaQ5SL3NinrdKKoHv6XERQyYXvArLjy5x	127
9063	2vaZcjAWwtnCcuPJmp4iwfyKmjjmwb97BcEGXWfaku6tJVVgQnZe	127
9066	2varQWcfsQfgQFRHupfZJWen2nY944CLv8gLd54J7kWy13SwhoGr	127
9068	2vaoT3KGKZ664vWZ441yabx7arYBidEwhtGtcYX1jQMw4YQteVwq	127
9071	2vbW6GNLRGnNQ4mbHAxmBeXZbg4WaQuthWMSFgxgdUSYmEjoRVng	127
9076	2vaTLdvFESXpmxjoM72K9rcemeiGaTNSGV2PanneEJMSkizDSAzT	127
9081	2vbRLbezvfRBNky7gnF6sYvCpzz1jkEFjxRucTtAH52TLwo3firE	127
9083	2vagqXj7zWxYuqCUwo2DHS9ZN4c32MnYHagWoETSLqSLoDx9FTiM	127
9085	2vb9JA9EYamdvF7WERQyG4GwkwR3ktwPy6S29LPJTwFE8SZeuRMt	127
9090	2vbQ4ZhJvFmhmYS6PgLvDbuj2goWE4ceS4yiCKDJqyJvMxztFddt	127
9092	2vae9uGLVirWwRiNpifQt7EV8tL7jDXB8kuA7MH7P5cELntNeEMx	127
9097	2vaikPdPuF4ESzZFQSnfrnT6WPejNEMu1TM6MEqDtfTzzGgjuZhv	127
9099	2vayScjdYDRAoiuFteM5sdMqJo4jQr9nx1qCM72KkK3jyCtKhmHJ	127
9102	2vasVnNs7wesDHDKUdmH557d9TBJ5VTAuCaRiFxDpM1yvy1Qbyqa	127
9104	2vc39HXd47SEE8oCF9pY8QEBDwfvBbgaexhC3SbVhwkejyxs7cgX	127
9108	2vbyAxNUhdo3Z2jGrAWduPYASJTVZdSDX6V4LznGNRXkj3xHPEJK	127
9110	2vbbC6zZZZGHJDX79wGaFaQTjVmPnDiAFXr8jn1BoQ2iqjh4eWPZ	127
9113	2vaY2oj9iwA4sM86ACkuiQbgboPXPvW1J8StTSezEPLPzTY9hTDC	127
9118	2vaHhG769Y5FUxbRbwjKA9YD2MCmLeiemPzZkDAsphGQ2SDByCVV	127
9120	2vbPCVkxnCgur8J9kmMB7x99xiEnxsKLFu7RBX5eL7HR8mZ3aB1N	127
9123	2vagcdNWUwaSDK56XRmU4KPAyBFEiWG5brdLtH8wCjFY9RdVAAY4	127
9133	2vbCAvyDxqqXmAkaP8XGRSRHnQDQ5QYpE8dkuvUhcFbGfnzvZQJn	127
9139	2vbzDTAdW8hd1z3hYGxcTHhsXMxeX4mciVAEV3b1NEqHSPfdhoS1	127
9142	2vbfcmzJuG2QSgzPkwNpcw9q7Mmun7easwVLhbCajKthJgnamF7C	127
9146	2vazVa6S4bv6FHpnjumpMWypwtrrisxxLT2EYbzEYJpWoMovDxyC	127
9148	2vbAtKyY9cuJRT3y7qKbqZwUKQdyhLNyv5fVnLPSuohBK6Tpbqs2	127
9151	2vbLdtPhAVophrNsmp82zmMCQFUAQruqc7eTTCZzXcv1o8ZJke1z	127
9153	2vaLhW9bxnSB9uYBETukU2xQGzRr5tiUw6chCzPn9Yy1tLZBfAzq	127
9156	2vc2hDU46pnwfEMq77K5WEndHYMxVezNFYAD6sn3B7mjZ4nphaKs	127
9158	2vagfTv2dFgac4gQ7EC24RNKcwxoQ5LGm8cSi6nqpGxwJq284YQ8	127
9165	2vaT7LWtAkr3L2TM2sLi4YcSoFXes9TwiFdKew8mvgBGLp2orH6N	127
9166	2vaQfybi9P7pTSdsdWEhc9uCcvLFkiw9BUup4L6YZ89DQhhKtLYp	127
8844	2vaCDZzFf4eTjHSS9dqkVdtXA2Qsat9wAZs4FVZpbYqzvZXowJcG	127
8849	2vaQhiZuq2p5d7U5HTdmeusXRyi2fYecJ4wgXESwdTe26ZkMLqNU	127
8851	2vb5mfRiexP2NBoMDmwB3jeXbQp3vkdchn4L6sHU7iQxHrrSL78i	127
8859	2vbXVYj82zwwDJpxkYtSiVhogdQcAmebr3FpMUGE9v9epaSVMgFd	127
8861	2vbyYEzoKS8RgfSzJMXMXyvaXBYMH6Vo5fYpULKVH2gH5RFvpUDt	127
8868	2vayky6GxNS7z6rYqXDpov7g4BDCSyzgZjj6HyQaWudo5CFahxSq	127
8875	2vabmik2gRT6Hs1FiDEGaVzhQA86KmiL2Amg9TFUKQQ8u6xSAHme	127
8877	2vaaRKE11om3EzYfVaR12tjsax8SqZs4JLnSqG9exVxRLCQpdfka	127
8884	2vbpkVvZSMtcPUgH5sovz66KHETfHiWGdnkwmcWT3qSFMmQfzwKB	127
8888	2vaTqHaHJ2U4F8WiAfKwvxw1epMcsBRSdxuB21eqiAtojJwXycFh	127
8892	2vbcqNA89EWkbnoBRbnp7vA2CQ3jVNPVgQDEMVmwdZ8g11mU3xph	127
8895	2vboVExnBhEMVVCcQTPnqciFozozXwRbchWurKRScjo5P7iAPd1a	127
8904	2vakZdHTdzofrTBGcXZ9vxXzVxACuCuqVKw1mGdvBxwj2ChcaER1	127
8913	2vaz1rCGqw7swdaQsiM98XMJPL4HqSEJ8zX8k6CDxVcdU5EwUxwc	127
8918	2vb739DwWcyFXvbxpsBd3WnRogphTX14BQsdwEhURUAspdD2af9h	127
8924	2variK7VdPwj95H6kECsqhXWoB66CwgyUs6upL6hLYUMD6EMQknV	127
8926	2vbeFek4Jc7VS2wJ4SeGNrCbHBA1TxuRk7tUuYmERzvkWUZ2Z9yi	127
8928	2vaRj6hh9mEJojvNUneMywMAPfSdTvFAMDYYkmSSYRgMFpbshzcJ	127
8934	2vaJrbiDbTDL36iyjTkq64Tvqw8PpnjyZf3STKranFjYMVhWxttZ	127
8937	2vbhW9aN3vq6FQSWV1TyhSC2Wk8BAEFDaubZoKwYvBrJ9Qdv9hKr	127
8941	2vbvMZJk1SS9vkbcmAce1ExrcyE5KzD1z2gMLAtt4mmR4AMaT6QX	127
8944	2vbfULWGeiaF5JUqtLdNKKbJa9VeZ4dxNRgn4pFqAuhQi4Vdzc5h	127
8949	2vaStpp5Bq2VxBh57FKXBTzs5apdpbKC4RK15XvdjrAJQD3rhBUD	127
8953	2vazDCsaZwWgQueeQP6UMSjZ1iENFrgq6grc8S51SrSDwwmNX8oU	127
8955	2vasMJrCC9iTWXEkQjJYoqrFemUYFZHtS5Dvfk3Ej38kdGAz7WuR	127
8957	2vbudLJCiJktwViBZNk1Y7ScQQfsmmxfm7fYPHcxRv2qSkPtYAcp	127
8960	2vb2DMXBNQHfjS5dxUx7rpJN4LEaM8XCikUWmZJXiayHwUNQRarn	127
8962	2vatYaddshVC69bCfZTTsTvrFjji5kYUZ51yeS8bBR4H5smyVT42	127
8965	2vaZx8a6UKzr9axMbCiTFoNceULocsnK1jERF1FFZTmGgAssUmUt	127
8968	2vagacm8oByB8B6ztdbFtC63eLghmNcDQmAWzrg4WXkzFYCYaqWA	127
8975	2vbkr8NzLtEALtsNvtyM9PL5w4eVAVVE3avdJmbpkhtFq4JPoej1	127
8979	2vaCpY8tvLqXYF5HY7qjubheB7VQ7iTtcHkzoFE8qB9CjE5YYccv	127
8987	2vawtzS7JyzNPNnyNYrtEcYrR9MGokiWkrjBCU69ReFEfYsmiCAB	127
8989	2vaKntVoHTLxKwj4AaNMbQP4oPZa1dwyZEASTYYkWpoRBo7R8XUa	127
8992	2vanNxz5vnyKKCX8LKZfM3VuU8fYx91fZfurDueW6VdnDDjVdD8P	127
8994	2vbDvuyceyy2fpRdE1MXJ682sS7T52mgU4ge2C4H67WWvPKrrHTV	127
8996	2vaqDUr2eXUYgNk1536mswK9B8cnzP5sZQKC4CcmaTkfKdpHYXua	127
9003	2vaJwzt5oc48YD3sMBWsGroy9p1GJk7GtGjFDDoap37AyqpkyeC9	127
9013	2vb8ySxAUvhXFr1YVB2ZyuRdv3a1Hc86FnvAmNmda3MP5esn3VcF	127
9015	2vbE9zUDqCQHiovaxPdXN8xqS3wd6am4aYFeQ8yxrWSgbT452LG5	127
9018	2vadWk8hWvDp8o1oSrzJLzG7eYYTNkakbooNkko5oGMMAJbQ6BjG	127
9020	2vbhWHMRL8xwwWYzrroE8v9QWf7CVdkzjp16J3C7QaAgLEMnUhJD	127
9023	2vb9JH1eP1E1a6W5ieVnUFzYqbgoHx3TrR8xKP4QdHGbYcjunvkz	127
9024	2vbcwvknfncYuu5zeE5h3tdMPMi7kDDr75QMGiiRPrvneYeLM2pc	127
9028	2vaZvDWE9S8h4JVJfi6RhqYJ3GgPKA9g8TxQvhXATB6D2SyPU55W	127
9030	2varavWA9X7FPKQQFiPoQnqsn4Z8sU7YqGMRs4YUwN42KGCLcaQx	127
9034	2vaNq2BFAqPezXVB5A6emyXsYKC8kU2j3eY74wPCoZpY2w45WQM9	127
9038	2vbs3SWQGXjBezgpAMyoL71uR9aQdiZxcFDZHoSZ419XRQNQbsWF	127
9039	2vbpj2MpC62QNjCsZy5DKQ1EbnmSfkWFKgEA19Gy5paGSgKyTV8d	127
9045	2vavgkprrccyiQqvS9pzwW4NHeo6hZWNsBrS2TsSkptrWB99yM9C	127
9047	2vc1bLwfNRUywzda6hRJRSkQViyFZLNZUD9SVbB3pARrXPxHApqK	127
9053	2vb2GurDdYcCUXFEKkBHZ6oXSZ3MBy3iUsUCdThzW1vm34ruucqC	127
9058	2vbGqKm56fdjABMjXxNw8AS8gLR7VmcekdJg3S7LMCSaGfB76aiG	127
9060	2vaiS25GuMR2KrFUCLPzMBM7ZTgGjhfVYdynnyKCfaL3XyFXjsJW	127
9064	2vahaPYbyhUjUWXRTPKA5M6cqcxLS4u9U3T1tXoicxSMvdX4eLaz	127
9073	2vaLRcN3g89YdkDpinKczbdk3USiFwcQpcxBqewMAroDvTy9ECbJ	127
9075	2vaXoiZsfiDJnMP9uwepo1hZzUune3pqaqtQBBmTLAEFD89z7P2Y	127
9079	2vbrRdqHY3bWmjc6kWwJmQhf32VH9hqjSxSxbHF6ns5qkyqTBtuV	127
9082	2vbKrbT1fqYsw6gA2okgPUA3vbz9Pgo5GUSakbVhJhgvvcsPbvEv	127
9086	2vaCRPCYEcAqoJrLb4LY2ECPykudkpZK3FCXuez3KnRRYcrnj3rg	127
9087	2vb6fG1dhhRNXE3Ajz4Pwicr6wtdpyZjFUKuUa52bZm23AEkEtD8	127
9089	2vbZTPA9eQsKM9BnKa6zU6QxQnpfKtpdXWmToNnPSykjjdCvRbnX	127
9091	2vastztzkdtzcm8YGaxc2fce3JfQtwyuw7TyLmWDAY5Hi5dok9cs	127
9098	2vbn2btn8FRkeAQyKVxgLGtiM2y53aFrxuKwHVHmDoqrjzYvXYKt	127
9103	2vbtCqfKx9w2HGN9VLHxMD1aDiEsivKBHgrc9sVQBfYtiEk31yUV	127
9109	2vbhhD2AZ2i2tR5rjegkg6cUw8Vo7A8Zn1YMLwk1jwegvUvsAHmr	127
9111	2vbSdScdV88sYB1nvSF9xCnJk6GuRRDnnF1976PGE5b6VitBxwvK	127
9115	2vaHGCXZ3DMxpyUbjxV8rTc1PNeMQLCh2FLfA13BEWqVkGVqiayC	127
9122	2vbcH8wV1f9tockVQFD3hUcRApyCP12TdqCNmU7sy4GU6nZtNePE	127
9127	2vadPA5PYptpsm9W9DorrM2p6SwVsDj6JHan7MdMVRVg3eHH41VV	127
9129	2vbwsCVLAKJ2R7y68mGV6TmVdgZdYf4tZcoNTGADpoK3LS6tbzHf	127
9131	2vc5cEGqhLiZeNaeXgHarUQtyN4vPXXgsLnN34hJcfPaCtgERbUn	127
9138	2vaztHCgduZ2jYtfmuoBHuaz1e9atkmUzcXbP8hxX39LzZsC6Dn3	127
9145	2vaGN1jkYo6yFD32C377gbtHBY3FEQR5zaRdzBXBFtiHa6gfxukJ	127
9147	2vboM1FJacru9wcEeacqx2NBxQfU5gicwaNtxyVbTPYsmJx36pKj	127
9149	2vbjXBNtZyakTrxkrqY8HKTNhPugsC2Tp7Z6c7jirnhFkh3rQTRE	127
9154	2vaJyvhSpW7PXpV75VUwa4TeHgRmBz7xQnnayDvAAgZ8EBiesM7z	127
9159	2vbBWkaAimdZtFkLAzSmVL8Lo53UqtVrBV6gTksfha5zoaw5BgoZ	127
9162	2vbazS3J9QxFdXDBQYyRzHFqw8chVPM2Axqfy3dHNu573qYcTdUX	127
9163	2vb5w7gfN9bdeEiGTuwRjT3VUjCbQYk9rA4knQDn57Z2jbWEXDLW	127
9168	2vbdevXfa4FJCuCZ6jwEkmtcY2TavrDEGkavWBnaviWbWhNnmeUZ	127
9173	2vb1CZD16UQt7K72Gt7L93hrA7dwp9vitjyWeG3xmdtaKDqktn6o	127
9182	2vbrk5Ew434BMiUFGqut3qaMNECpVhGtQdQmye3RdLY9zmevdVdM	127
9184	2vbHpzxaSapNqUNgCmgTEng6ZdnvZRb88roGwgvEhwfFESMnGHk2	127
9186	2vaLH8SDaK59U7aH526riX7cpA5r93LSwihFd7z4p12LEPAjJvAG	127
9194	2vc2bvNTpUYeq6XpX5wYzzGHnFmo2871EUvecu7n97wihZC8tESi	127
9197	2vbCCyHhJncAeEXkjaz9h2MWz5aMVGEKA9d5o3SzxgXM5K6Hmwp4	127
9200	2vaSvLzBNGzT7WXsd7dJE9iu6m66QmUt6rQ4Wcr8shhZReF6sZi1	127
8896	2vbpjzhhv7vU5fo31Yns4F7pfsKW24vRfrgafTP5AJFP4QXFZfEC	127
8898	2vaDFakA1nXcv2Rvrxk8adBYmbvxHPjVPvG32kdtYRJquLPuQ43B	127
8902	2vbhNPpUZFoXt1cPThcP39iRSSNJ65XRpiuvK8RYwB6LriA8XZRr	127
8903	2vb2TMxwNJjxmrikhhsnkrBcdCB4LiyJdj4TX9ZMiT7d4HGijcLV	127
8910	2vb9njYTdT2MA27zaHbSGydtw3Xdc19o8GQcquEuPsBVqvssVQKH	127
8915	2vb4dC1bnDVYCcXbyGeppUnUauHaNrpZmQ8vgCppjXxBj2bAqR9D	127
8921	2vbPLWyCqo9WvMGGm5yxMK5dKDCF1ajLNyzffqjrYBFojMA6RXt5	127
8923	2vbqWehhhaCn2rWe3dwvs9TxGid3AFMSmt1whQKAP66NxKwyreHe	127
8925	2vbLMnqT6QCiedzZzkaRuUz8KtScFjRzYTxvN2Miywk58Rsre4ET	127
8931	2vbHxrJ6LW4JSfdWGeNCwRkRyW7dkARyJ6Zin8tKKoQauoYyKxDp	127
8933	2vbwfFeDZwkafi8UtstDfBQQy2R6Q7Y2jEMZEudVWKRtq7x4Rq2M	127
8936	2vasuTbaX463tQsomuJKRitQWghQTcerDjuwQUS3mzVi6CPxMBQg	127
8943	2vb9kdhkhmMUnuW8dNEJHFcf9EiDvaFzbzJBai4cgtxKm3hfnNWt	127
8946	2vaEPwAKe7Rend4ciSC46Hr2LWgAADbhYDEDjBJu2eX15CcYXAAd	127
8947	2vau9dTsLdxhssNYDMLW8H1xPv1SGhaNU8a5JG4L8DbP9AKCA4Sb	127
8950	2vbvvojdhuk3vq6ThdYwDKK1QDSfigsAGvnkcBMc3a48r454WxWW	127
8952	2vbPj2dU59rg9rSvfrnvdkoXE5vLVnUwq9WDzgB2ZXravyH18x5Y	127
8956	2vc1b9Fsv4UwYBAdP2HDTZLFbKGPMr42RACrLqkJ88jxkWqzeygS	127
8959	2vbbf7xKzRKkcgiZACf5W69vQzfhghr1YgVkyWPf3WR5XrbRXPq3	127
8967	2vbPAZeEb9ZpqDYqFBXBQ1ToMAi3UDFBnx1Ppj2ZY1qdecDS9kGh	127
8977	2vb7bN4t2yrECQXVY7c5jVrWwEZLQykmNurL2HtHzziSDCiqSZ69	127
8978	2vau6VTatdeNUoheWE38uYsDSfKE4XWHPXDo97uXdDTjYQ9LNDQe	127
8982	2vaerxWi6xLi86TvvxKjRN7kQMudxbkJ8KKBtHV6ye5k8ZbpmNDQ	127
8985	2vb7QYBABQMBJe1z2KS564LgnmmriwSKzzsry1q4zZDgHLEsZXfH	127
8986	2vaB8dfAMChmCMVE64PMZVAPCxrC8MjZpYoNntD8X1St3RprUxHk	127
8991	2vbjHiskoXoxJzoHqCtSwzymXAYJmmUTZgNjXfjzqmQyRp2HaevN	127
8993	2vaN4d4wkRhY18p8rk4akZd7kF6vbgw2etezcLkUGhEpnWkQnNh1	127
9005	2vb1Gc6rE9bQGSH9GSqTipkyQ8JSTBK68FkGmhHVZ76Tc1MxbQt8	127
9007	2vaoEmxYZcjLg2gLH1WS2XFedgJiAPwSRfrJDG3jzbVqNfkvdyjM	127
9010	2vbUM7TzdDEzibB2zTKbY615dJNp29juDGTFwpCHQh3UoQhgzRdR	127
9012	2vaRCy9tsUapyzZgHekosy4ksKmfjQtWYy6GYP9iQjXzNdo7eVS2	127
9017	2vaNmGx76J5p2TxtmJWymr7p9EJDEuaGtKHDRWLdGcnMxkNJaYXg	127
9022	2vatZxFFUuVmkGXHwpUpQWKCnbCFrdErqHS3xcqtHfSwD4cioHMx	127
9027	2vapB4Zar44kPJZfSY4FwgK9J3CjMoyDdV8wCvG5gTxrmLWtBHUJ	127
9029	2vc4YGXh6NP5uyMVL3ynCPPUUZNPgTVPA8EbrhCtmyHMpFWiznV9	127
9033	2vb4FLwGtBj3uoduyCC4upmLsx2TJyueAxUx5uux1huXZ3CBC3hy	127
9036	2vbTcrVYK4k6FKbPSeccbrfiBRzKVp2Dh8ZdrLJm1tJbGjrEFDVv	127
9041	2vaYKrxEAPfhdvJFaetRhwX3kAM12aZExJbvYSJgHiJAZ7DY5gUb	127
9043	2vc37yjaHArfc1WNV5Mc3RbSw4HX8cxKFBxCzjyGQquB7yHjpAb3	127
9044	2vb95mZ1x4MYdpstFt2SLqsrFbVJyTyNUyc4KTfgQ1rTCSJLzmPa	127
9046	2vaZsdgUtZRFqJRZi1diRxhFSqxKEKXY8i9cmFhNsCAeFHj3XXdM	127
9049	2vb9eAA8LCF5PuTJpVreAM2ByNwLznjZWMuYimJWWxfPjyZU92no	127
9052	2vapVNbUmBpLT7dookczwyaJCSC8jnXTHTcZ6st2mHDLD76Tggvp	127
9055	2vaaNvjdtoLN7qqqLezoUDXhFz6Yp6VwiE7UyWCGCyLrJ8KCXb4y	127
9057	2vaSbKWYWiYPQaWxXz4hMa2RWDSXQ6859PoKqEdN3HWabhb99BBC	127
9059	2vaiHLqefjRx8QBsNSURTuzWE91p3byT9S6gqHrcad9eibR6Q2Tw	127
9067	2vaqD8SQuJdPJUbNaj92mTDjnSQRiFectHiUjchHQhphQfgN6vZ3	127
9069	2vbcsVZrh33679hvVkmzN85jvpSzFMwp5Ero25AVeGbXDjU4QRLd	127
9072	2vamtCw3wvX68Vt6b22MF1wUs1uL43yt41TghcgvFoWR1Xk44QFg	127
9074	2vbEKnhxwUdPvbwZPeghH9UHSw9nRd7qVF7bKoeGG4gTPuW2umst	127
9078	2vavt55CynTZLeKAohGhMcUwANW2KHM2NNckiwsxLjUW9PNLJygH	127
9084	2vauNjgzVW2nvvcbSwP8m6aYLvGi1G73TygZsGx1NeCMesii5rue	127
9088	2vaoFgjC2q9pWzA3nyG9DW6Nhsg3zQybaiGu8uXYVMzXShCJKYvg	127
9093	2vacEB2rzMp4vhbMyeNSvH9SREvNDKmwiHXuvyGYW1ZCH1KnTXiG	127
9095	2vbGMjrAF1T7KwFSamerhX9ogjVwJeKrEGrVxAMiCPyKsd7kvVnj	127
9096	2varhbgFTVqZDj4eUm93PE6fD3Wp9q8ph7QLJqQchdf5SwWB8z8t	127
9100	2vaLVNCxr72AKJESDCo8jXQLuw8goKc9ozYMojwEhyfNphiVNhWF	127
9105	2vbJbGcenFNeE2Kyg8djkeHrPcksg5usRxojFdJFgLxQHfNf9DSw	127
9114	2vapa5Z5LXD742TrhvyZeeZX3sRWtPPGZZ8qXkGVPfcfoZmjZoLt	127
9116	2vbQmTVnsXi4341GdQyKzH2pVVTugq5fPgtAbX11WR7L282Vk6qk	127
9119	2vazNXx6yjrxiQWNjGXDNoFccZjTe5Bx1nEo7r5B13NVZ915uwEY	127
9121	2vbkmtcWrAauzwKjwZeVinoryV4pAXqwcYVY54Qzy4aXAgzDXMMZ	127
9124	2vaeKDAARDErRXY4oat6V5iSW68kPx3bgVDnP2dhR1db4cYzAFdK	127
9126	2vbh3bDYwLVCpS1twRMPPjSqhgpWF9WWgaM6V2eknHEDmW2wrUz1	127
9134	2vbMdwEdHP7BTCSQF2p4Q2LChThRMAZM5vvZdweQdzFobM5VYdXg	127
9136	2vaMUF7VJZe8FVFDjChwHCk5Hcd82QgKjAjnjsdaVqdH5oo5fu4v	127
9137	2vbmGUNn1ZUmrkdL74DnThcUG1m6hy1L7UV9YmPfdPHheiZW3ZMo	127
9140	2vc2JVbPL3X58toTJjBzb4V7CnGDc7pjDyJue6MKBjmXYesS77NR	127
9143	2vc2vhSqCMGC45tLCJWbJD3wgbXvp9UqsBw4E72KVCbYqcNXNzim	127
9144	2vb34CSxgQC23VY4AsxuRmisteL7PLUXRg5sXU2sQgmoKd3t1F22	127
9161	2vbsDcNWQcxPtCrdFekvo9Lu4S1wDoMgiiff2tcTDgecE5mVD16p	127
9167	2vaf7NsNkFwnEdygamEBSYNdsYSAva1QFpMEBHVFV1YTgg2uxkeo	127
9170	2vbVXKmbi7KrZqYBQ3gZgxVoKRd7mX7ahZp1uzkvBLNsGKZGsNjc	127
9177	2vak3yxbzhxiYZBkRwYjPR5HYabQvSDzV96eb5iWCucJbbgY1WRq	127
9188	2vboajDVtebvAXRbLE58aaK35ghs2DViAtANJahLLmwcoVCHfPXS	127
9189	2vbrQGqroUWAiAKeJ2Jzitcp9CL1gEUvqKSdRwHeETek1QLAvUwJ	127
9196	2vamGdEkywaTcmaPnvbm21fBZqRU8aPN3aNqfD4FfYDtZ5YWVoRG	127
9199	2vbaHovGcxfgtAj8yTRMcQRQCveYkxUaMb3Eyn4uBLscd73qhbJC	127
9209	2vc4ehEmAvgA2jWfEjcvQ7nDvzfTp9AaKDTUZtJd5Ly4f1gsW63Y	127
9211	2vbrVwk7qEje1WgRSnLm8VeFX63qTvFapFPobHeKrU3XvAYiH5E1	127
9217	2vbUgmfswRQw21zMpZ2fA6JVXd7wFc61Xe2kmd7KTU1qJbe3HnCv	127
9219	2vaVhv8a8NfoGLyiavTXSmGxZ1WANv5ASuJjwvMZo1UnxyN4GTJb	127
9222	2vb3G6ea8Nd3LREYWFyiPu4rBdkf1hBNX8pCA8vteGmcLtzUWVe2	127
9224	2vary8UnX1MHezLecC39eF7ZiAdn5HdGHWH57vCSgmTzhV6bTNeM	127
9228	2vaQ3NL9Y3uj19cFLj5JHQYj5Z7NFKJT7DqJTP5R5M1kCzKxzDKp	127
9240	2vbWRrjn1PTa9XyS7cUZiopRpdCmdKvis7hBBUKsfkwej562NuTh	127
9244	2va9wRPPC8cv79QZzwt5AA3FuyRZhaDZrbkDN5os6YekLizFuT2H	127
9246	2vbLrBFXdMsu6ajVdpa4zgwjcu7cx8t1dH1imBGzToUwJEhva6uY	127
9135	2vadET6fqeFxsepe5k2HX284vBDD4h7uoe2ojk2NDVMLLh4aHf6F	127
9141	2vbN1kmQnpu6WcFFAaP33XgqBwKmGSCtHvw7Vw37w2upBafMNmBx	127
9150	2vb1HJpF2Nyrsr6XeBPLkPrYmKF4vwcfmS5vJDYtX6ZQN5tni6vv	127
9152	2vbfHPFzmM3RtsbdmDg3NcbvSpQXzTP8AFkJJg5NoGHia9A51oFu	127
9155	2vbo86jr4Zw5PMf2Cb8Pm6Ni8W1sTAxMmxUWQrhrJ3rmCpqjbxGP	127
9157	2vbueVujYUgQ8bFmm2RXgN5p8dsVD7Uk7aLD5EDUU5NuFMvMoT5Q	127
9160	2vbbyt23adv7zbGy1MUs7Dx5ZDt3MP36Heg2pdN8oeWA8kxBrtFG	127
9164	2vbpV2yAKK1V3aahQE5dCx6MLta97QKaRg8SRxzQoHx1E8TLvPWC	127
9171	2va9qkhW8WR7vF1ppDvbYWamxrYSSZJhGT7ZT9FuB4RV2uxLW9ky	127
9174	2vabZT9kgVShUAeKfAVoe6DgL4BDi3h2q8LbkLh4pUBSDgT39gDU	127
9178	2vaWCwc9VXFj1aPbAc2koJyTRxrwWUd9crN1B8Tw79B7sczkdxPg	127
9180	2vastxoBDLZt9YycoZbnbphWTAZ7XEA2Kx7amRn7guu51MhrinbD	127
9191	2vaG2yEcwPQDReXnum4eVdyNGtDAgekUJwS9CCH4cB8YqxG82Neg	127
9193	2vaosRL3Pkhwu5bEUc9qLnqivBqXTcrUjDLodiYissydPZrtFKWx	127
9198	2vaeT6KeAx5NudZxfswTrjf8C4cwm2EtYdVjb1PDSiy2Xn1ZY9f5	127
9203	2vc1QuGHvykUCbpHY5mdQQ9GKGVVrY2JFNrFoT5A7QgJY8RWW2RV	127
9205	2vbrPWKXJn88SeZq6YWLtu1DzwqrkEJ2va2wxEfqf3kg5QKLeyz6	127
9208	2vatJtkjGrYvDxD61AXpnw3o9sSZq9M8S3ptim3HZy3rG7oHvov5	127
9214	2vbcDAB4BFrDkG9qEsNDYRCzdvRSn3sPSf2LseHJqZKqXbrJZe9D	127
9216	2vc1Qpwo9S85B7yA393GAA2iWAw4vHeVTSwe5p1MMkUiXpybRn58	127
9218	2vbgQDWyGk8jwFmE6GPz2XFSvMZxjakKNQVx3EYkbZsPf74jwyaa	127
9221	2vbKyMPAEfdbrGgYerGeNxRTczPebB2uDCjCww4bJhWEQbnYbyiK	127
9223	2vaXWFFgyAD55bXwiBgnycLUodHYLrP7C2BnmubAPtD5NeBUWbk7	127
9230	2vapwdJHDPBcRJPjRovuujPLTfoKjkznmUv3tgzr8Y1AVGbZ79WE	127
9231	2vaAFvTegChYEjHEcRA9y5EywcGp1VBhoTuU1r5F2A5ndmgPG4M6	127
9233	2vbuHSAc2TnhBsgpXNYzWiUYL7JvkcmMRiTfttQJTwbBY45roJw7	127
9238	2vavQuEJZESTdJB1u1huWrUmme4mYvcHEX7ZUTLPKpv5m8JxhG6i	127
9243	2vbDRoLMGE7kuwoTubSpkNxwcqDKU27JDTWxpfMRW9dDDskVu7rb	127
9245	2vbsBPSqFq13jytwcRHervYFdUpwK2feEZaZ3wFKXCWvV9JAW6hd	127
9248	2vc1FeAfRBxpjtsV6sf8yJLuiKaJPM955rietrpxEhcfYxUuNJYZ	127
9255	2vbz2Se5vRqb17ZQPEiDYfDkQixoBX3UEx32dfyrR7e7ggdzNkBt	127
9262	2vbS2DjvXuiN1KZHuPweZZg7Rwznj3bshnEvhMgjibg2PaTzRMqe	127
9267	2vbkAoYJRBSMPDs9ctU48wQwGS6kKB8UeNaYCJPpAjGHReTYTzRN	127
9269	2vaBBg4Nb9Luq1KFDve6BEmhj44Mu8JKkn8UXXBGrtLj9oGKLnsS	127
9276	2vbrztKW2yN4PdeMQUMVZsAMCL2sQDh6g6mRnsnigzq5Um9EsSFc	127
9278	2vaJ4QNKmmrLWeL8qeNV9EoUYsCVubBUptpuXVd2H3n5PcW9iaKo	127
9285	2vbLLGQPsRdoo7TaNxXUNEs9XJTrpqm8XimbdrYGi4TS8m7tTAdz	127
9287	2vaD29wsfpbSyd2Wd9h7SPFGwh7BBdmQXQc1kLDFYouj38vcojKR	127
9169	2vbxQqejW5RCLzzM25uFe75GX6MQKodoVoCodYJiCRVddxMhkGa9	127
9172	2vbU5LhTFkMcgCJMFLwVufFWEQd5KHaWsduJdC2AN3SxCHBTHaZY	127
9175	2vbzXC2U65mvWT3aRHPjuWibmu1NFFRyrnS8wkVFaMnCKX5qr3sV	127
9176	2vbcQoZ6SFVP9F2bpiKDj7tBUtnxBCf2pmrw476JJASaybzEhuvM	127
9179	2vbXVqyTXy9Bns7YBpm4CATF8vTBJnHuy2yMk8dWBWMowSo15x82	127
9181	2vbpduq3i4ge7AvG8vzVcJZwxu6zTp95Lk41Gq3ScYWszU5htCRS	127
9183	2vbzfrLSmtwiXwwvnQJJ9t8v1ERVnfAmUUvp7kdBmqdnN1w2ymrs	127
9185	2vawTJMqZJs27F3muNAboLhMvP88chTERbnc4yPr9p5qoY1hu2xh	127
9187	2vakcry3c723L4TaBtSsMrDRCx4jn4owwX1uxTAWbN69vmFNeaAn	127
9190	2vb4q47fke9EAbe8QGQSLBkwTWWTfKM8ZWqS5urP4zZiWGx5t2AZ	127
9192	2vbKMFarCP4bhsisQUaQgwBRNCUsf9T4Q45tFDn7kP4JRR61juoa	127
9195	2vbRSi6hZepYXjXsvWbzcX1zcQAENvALLuFz9vei1jqmgcj6yAZP	127
9202	2vbPHL66wcpzwWqcdaqwJG1rsHGrGVVeHyhuY4CMXhv7F2Aw1qEe	127
9210	2vazWMRKembC567k5y2SP8spdHnSVAc9jLocBLjt7Yi2uyB1k7a1	127
9212	2vaWsHWoRy49fgkTEivBEEvq2Lz7ycEUuYDu7Ph9TQ8uGHG2LmFG	127
9213	2vahivtk9axr2vEnKMTxWJfZrPLp1J9uLRkdJnXSQERXLs6tTWvU	127
9215	2vbAdJCQkNhZG6KCQyoQAVBDtkEieV4ZsxquHH7PGTqq2hgWK6Tk	127
9226	2vbwFVtS45YwTYtnBcks28hcfqJJpK6REz41cG2ftyE2rseqtswm	127
9235	2vbwiM8VsTsLcctMiZWsiHAaFnYVwgLzUMP9UD8qCMznzJ1DLAQS	127
9236	2vaG9PfGwtm6ikz6ktE2eb1GaDZVWp3uocE4tUTwPLw1MxLS7xuG	127
9241	2vbMVMpofX4TTPfVbctNqQqip463ahuLtT97uDU6pqfVBJThC4Sd	127
9250	2vbqCmnpcohx3NifHbzw6aqHAdXvdn4oP5AEaM2KnwuXQ2yMiF63	127
9253	2vbDUFWPH9DSiFNWEspVW69LmBzqoHqKfv4AVh8nqfEU5UXuASNH	127
9259	2vaCCyKmAsVvnZvLcQjxoRdJ57RW884w5xCsyNG3LSfSEqqSDxeQ	127
9261	2vavXHc7miay7ofY7UdSG4EdXfEFWG7N2cb62cWVLU1VXhZRoS8i	127
9264	2vbUDhCHfATTAeuDBp7TLqP9prwWVsgLGg2ZZ9UTG1VZSzBMzNb5	127
9271	2vad7mWXcQMCdKSDpp3yHW7BJJpzxRCoaK3QkZoC9b6yTht3YFCR	127
9274	2vb7NDMXLQtUpFCt1prbU5RcCvY4TfcDYdgEZrR4Fvu9Vt7aNgsA	127
9281	2vadEVWWAGBLTSjyv9KYcvXZXuH5eJ5YWdTrDh5hx46TAZU1BVu9	127
9286	2vamAXPULVwtGiLCwMmzGX4WFdXMxUtoQhHV6WZnqgvnA8NLgVHQ	127
9201	2vanU3YPHx9sj9C15aKh7a8wWRVdQAadLiT1UUu4zC9nyVfk9yAY	127
9204	2vaf9iaPqJFKHcrtxVwP753kg8VvBYwT9XkcrBsEdEzdJvq1LTpp	127
9206	2vaX2LwfBMWFWRBL6U2S6RzFFtQPTbGFazQZYb6hx1pVTSnwXbp2	127
9207	2vbyuhC6gRfj4ouJ8t7KqhGbbFR5bht7M5sNiaHhwRHHSLKi26eK	127
9220	2vawuAwq3mVZYbsEo3QWRX3nxSKftJjYwraDvb2XPvJv7CEoAHx8	127
9225	2vbBBR1SJvJBgPg1vgimQAsMvNrYV55cRLKW1JpAbDymrYdJANqx	127
9227	2vaUkdbkZZpY6rU2vtg4EKMfNo2qzggdDmggB5cJEp7A8eA7VerA	127
9229	2vaQEBL6zrN781F7y1uFA8GjUbZe66t8yC5YwKHuLohpcgJhymEa	127
9232	2vaehpZfhFWJ8YRvfbBFtVekm8nJbLPuu2SRNkJ2bTQbkwDhWnSw	127
9234	2vb45fm5iroPHC2rudfviTzJudLziaiBYKZauXqjgfSriKo5JmT4	127
9237	2vb21oPcKysFQbP4fvk8V8tjeWKkM4reFha8NqeYBQmF1DtDKm4U	127
9239	2vbL5CcXhCEGKq8uVMe5UBrrLe9MaNHtFXdkf95xABSwQPeNKoz1	127
9242	2vbmQPJATJyppkrL6wNvizFMtYBBRwhejhXsGTckYFHdP43nS6rp	127
9247	2vaXcfUeQtMxfuZZWNagt57ofedLeLrG3BqUgS4UTbmfNKy4kg2z	127
9251	2vbhmBH4YJcuRMTC3UaTi7qK7CHfRiAGXPLWVeto7tCMaszUAE1v	127
9254	2vaaE6i9KHcEVvFnGBConWmmYTjr4kFq7GZxUGgE7u4YqAYJ55nc	127
9257	2vbz3ytWJBXvpESrwhC9tLGkkqscqU6TJFnjy3cXnYi1qRjdqtMB	127
9260	2vbEhTZqeFHsy8GMykmHqSipamDr2nk8rPScrky45yFwxzgVBFqb	127
9266	2vaboh3YU3Ak1XjdDKwCXb2ePPryih51QrTxnwKBNt6QkJUPwtnP	127
9272	2vb9yT3tHxqv5inF1gfr3gDzQvifCELACqzASTUyJtfa8zSWUeXn	127
9275	2vb1RZCPrVe7HwTCdtbyWsr1SzemkGKDrQcxQqckUAJH57mTrJZS	127
9277	2vaTjo1fAMrsiwiKB8M86fegcn4yfQK62rScp1wcZQWMn8krqmVw	127
9282	2vadYTAWFdkj6Jv1tnDbLFA7nMCmg7GY7rC8t2R5NaCrzxrqrasQ	127
9284	2vaCtGmRm1WGaT6uAXtzhYshhXv6oBpDNrrdseggmzHaonaLjiiy	127
9249	2vbZrkWB9icXabpLyZo3tFMnEFrcnLJoRjo5m4JFz3m2Z5KJctKp	127
9252	2vc5C3W8sBzaJeENyXtW8RwmwP4b9ASaXnQemePeUb5y8nZ2oqBK	127
9256	2vaBW2bxF9NqesouacdjB9sgU4jhVNGgUX71mG6125iH5pCEnY4y	127
9258	2vbUa5dyXze7jgiDMKFADMYY1fEdj7sG77Cjm9N6g9yAwrjd6QeM	127
9263	2vbdeV1uYqEe5R5E1X5v75eAdaxAd5NiUmqjJPDj3BkgbUkfDMge	127
9265	2vb7SNVz4jW5wgfDereLEy5ttTZ3ce95g7o6tkgKZPfb8Czz6HWu	127
9268	2vaaSZgSdEYQ5zvLJUUFmzbkUe2rGFpGRMuDoeTstZiSquvMZMLx	127
9270	2vaL4buUYovxABZ7Fg56ggMXsrFkNcWx4oRrhzGGZ7CmunrCWWmT	127
9273	2vb57SqWAmez7xnuj54yDXCWTqvXZ9Z7yqzXbJyhgyNWDDKnUZ79	127
9279	2vb5yKzuZUkZUhUAgYq9QDpSnVpER5CMjtJiFEzXgu4B4BsaRPqm	127
9280	2vc5BB3t8YzGPfYjSEQ2y7Q9G4n5PK1w7pJVcCC7ZDFxo2HqALhE	127
9283	2vbDqmZhdFjtCnqud24gxeL89BzurSBy4pAwobBbkiL7XTa9pvk7	127
9288	2vaSKeSe6cxLAsFf3yBEC9u3PRGAhohe8G6WuXowNY7Hr1epuUJw	127
9289	2vbqpUoGiWBoKeU9ASfqFWWG1RMgYhTZtdgjDrysh4xer36GPhyA	127
9290	2vbGeKCPcFDzD8mjHwHsA8a7ziA26s6wC9MX4RKCbndXqxPReFYT	127
9291	2vbvBi9qK8oSQyHBcGvYQrKfCD9TVGSukfqbwWGvByAkrqTnVgA4	127
9292	2varH8r9npo6DgoCKUAjpnqRMkNJyYYi7w6N28tjr1eQePcbi92P	127
9293	2vatrxmVnmQ6WkrYU9B94D8mJ151cEb4fY8GL5BcnGMriWKgaxrz	127
9294	2vbjqHQ5LQ2TszVm7N7Y21RaixMaDsTgBdjbC9LH9wNbcqTeYUaR	127
9295	2vaJse1FTA4WLfi3ywT19YdmQ6cc8a8WaC62mUmtHfjJ75TN2nNy	127
9296	2vaV2KR4H7LGHRpxeDzqCPtDy7ZBxTfvyxSEgjDDDGFkAJoLMgQq	127
9297	2vbKT4AvKWSk58QvUqd7tTtyjZy6DeJ6BJus8knPCMCh35VSHjPM	127
9298	2vaJJHbstYDHrkeVTkH7M3iykWcv9opP68qUseCjTsd1c9Pf6vLB	127
9299	2vbyFmS7EoqAvAMCc1b2sazRGioGnY29royNAk2xWNXKTKuA2yxJ	127
9300	2vbNx4tNmqSNV997u7L9P1FmhXvSTnbmJAWEnsgpNAqFybsr7bnC	127
9301	2vaY5pzopjxSCMmwkwgxcNSQFSnWyvJot2J6EoQhwqpDvwrCNbNY	127
9302	2vb6Ug76RXX2AqMtMrEEgZ3rLLzV9D4UFepYWscAEGME8jvC2VH6	127
9303	2vbRxXm9opVQE9BfM4XH31bZUoNTjtBzDdDVW8dWLussvZfzVVG5	127
9304	2vb9FWpidSZ4UuDm7wtUjjBAoENz3GQ8S6Z3Th2v38DYjmoAH216	127
9305	2vbEWmoTmsMbMbV6Md2umjgbHAgCo4JNayHH3S8eBKWU43Q7GNmw	127
9306	2vaWwZrYgLHhKtFRGFK99Fzxsp5tbV83SyYn1WmJc2V5cJHz9cDT	127
9307	2vbRtpqu2idx4kENEdBLqBQEZfb2kdmmZj8bMYJh1xkkEu4jHeis	127
9308	2vbKgWmK5ZwfDuuQdHbLGKjqDEHG9GiXTXGeEqwYUchuBq5nAvxA	127
9309	2vbxP9n4WUKDrK4TeAtu4phvSU8nRP7TS5S4pmW2GzJcN3vEdJpm	127
9310	2vbYM2FyYmEQng8NN5r2cyELqFoTF2kiXzDF9gxWQpjGxNgor9z7	127
9311	2vbtw1yBijL7rJPdQTXAnrcby8jjqK62jAKSrkuS2rDHkJ3R7way	127
9312	2vavJ52LrvXm8JohQSY2i1Uwya7jk9nZPqUBrhnMiZpBr8QWbaFC	127
9313	2vbmnDAPdPx3R2ssRy8AJJGLio7Edh94EJYipaMB8ktUAYS9uHhs	127
9314	2vaiaC6JwhumwyqCe456FWTLQyqJo24X2FeQs5LrYVtekdXVhtZY	127
9315	2vawoxYiyjDWte7dYqi74zJvMrBZyVcJgjXfhj42JmDgeYFaWcjm	127
9316	2vaLaNiZgC6R2WxN4RtGvXN8XnqrT1z3gi3e2tFn4r4b8TrziAQ1	127
9317	2vbpYLpMfjFrhgbSsQxnytNNqy2UVqFf5aAHa9L7QcWHMEc6x4CP	127
9318	2vbwgU8UyNqE5pMCepQLbaXcRJrH351UTbVUdaHUuUaQsYYMufAC	127
9319	2vaP2yZftDcs2F3jnkVkwdCgPuufnSaqD1XRsvLmNa4qvCjv7XNC	127
9320	2vbMJXdRneuFK9N64S5nm9ck89MhGrrEw2dpzCFDwQ6sVTdxkUUN	127
9321	2vbYGS5tVjqLGRd49Qnp25Qc78pAn6WUqoMo8jEYMm4vXviUZbaG	127
9322	2vc2dUtzrqaVi2AwPK5WM8b1SJHd9pn3dgtEd3n6v9jKLWt75Sv8	127
9323	2vayT39jD7Lg7EqTsh8g5V2dpFwLzKKfNyERArE4boK3i77BjXRd	127
9324	2vawq2M4YK7kZ6L9DmCtnAFfAAi7E7fUZLpwMM2z69gEixZ6vh8K	127
9325	2vbNGVNaBAk3pvnv6LevPDt47sreqWdXcjT83NgLtfqPjf7zRBmi	127
9326	2vc3HC2RoskUE4S5i4v5C5dweyZ3aaP8wbEqRg5Qu7D6gqGwLdVb	127
9327	2vaPXcQwR1k4up7cc7Y19kaHcYZASG91ZEVUb2Wa4GxAUmyf9JGL	127
9328	2vaZ5E7etHY6vQjVHWYELZazgTYTVpoxY1UyPRzMmLwYFdKbBSEG	127
9329	2vax31bVE7b5g5ob7SxT3PLqG1j4Q41xiJJzcBGQP5jF25Ar7JXz	127
9330	2vaaADpdSJALEiXzZxdVSarG7GtXLPiy8zrvjanXP1w3apmxDoKr	127
9331	2vbJJn7YCJv9djNHVbryFPwHhMwZRAbcMbcqs2Q6mzv4sL6CG2bg	127
9332	2vaNUJ7hhHRzwZbdcR2XVMBcnnVVV3pSyySHhmL6pHnXE1jo3M3S	127
9333	2vbG6EPhyXt5o9z1RVkMtSYEq7F1KuRUB6cv3yF8v7DH2nYgZyr9	127
9334	2vbYHKWn9bHMs8yAzZZ2V45gfbGyKWTusbwqrCnvoeuDHMF6c8Bg	127
9335	2vbtqvQjUXVFUSz8ezRNrD6FjY8bMiMPYtyPKQ5zxDWmN4EsmbsP	127
9336	2vaLQWcF6SWJCTrSqnCb8JZL4EzZmP9bnPs8TZzZax1vYHkjRxRU	127
9337	2vb1Rg9s98cG6nxNj3X1H8D1T1qenm9BUenpTfHbMSuKcNPkWubB	127
9338	2vapu8syCJYwTAiHd7o23qdubT884PBYoB45cispc1cudrffBgw2	127
9339	2vbr4aYG9rW7k2NfEEPGC19pPNvJoxLs4m4exSjzoz1yceXgB7fj	127
9340	2vacJm2kwb9HaK4UGXNfEWwsQ72SGyJ3upsXog7mnv8a9CvGUo4A	127
9341	2vbV1AfPiZaDjYubQQH4uL4gXVubyh3NpCv4G8GgFaVikmno5Z6d	127
9342	2vbGqAzTQjxHjWdQzvSUDEABVyY5BZbnQzzus2r9eYkFBGYKZ6zZ	127
9343	2vbaHkcXhogvicmyfuP5LphxS2rnTresYbmeRiboRcbZXpcxLR9M	127
9344	2vaMEByxaGUmCkz4dcdPShpkVHkPqbH5ADgr6okAF5NxupPR5KRQ	127
9345	2vbjVMxX4GCrX2d58hNepeGuCTHvU2fZTqga91pZY1afs7sdEGcB	127
9346	2vaxbNYZDFKSEWhEgUefQ9UDvRuSpPHbxnh5AETGKZLiyMaZCtj6	127
9347	2vaoBSWogkKGkibL94DD6JcDHnLKY38BfWfWoivc52Z1Kz111xJR	127
9348	2vadfz57hwybQ9ewkR3LqB3VAgPLwAKNMFAGFYvb1JvosFYddEJg	127
9349	2vc4F2K2GwLqRYwymJ2qTqaH1E6wMEGYGmE3XbxjnhyXJd3gTMob	127
9350	2vb7o2JhG7GgWaZGbbPEjUDpMZM2xVLz1QV1UD4z9N4uSgDGtv9J	127
9351	2vbQ5QRtQ3ymAjGhvT7Nh3ahaqXcokapfkQ5tSjJJiSgJNh4WuA8	127
9352	2vba4BRHpamWvLudvyT5CSd2otkYABJyadim77gB3iF115fHFz3f	127
9353	2vbPmuK1n4mjQjJwRF72x3Ky1wzXGGUGPb7oMzaR4AnPyKVCQ84s	127
9354	2vaLdeyP85y7DB9g61VBR3GVctBCp4XcNhSrKp2w15RzVumYeZFa	127
9355	2vbPjKvcZRdPW9cyz25STCxMirFb84jhSA515N2uc45kQeoDg4qa	127
9356	2vaMAUwJXqTX2ZpBfNhgxhATHyaGgPBGUitU4PqDme7LRiKotMPy	127
9357	2vaAeV28S5engDVw9xNXKCX1pYVYQHVLAUXPPsvYwkwM2gAyi1Qy	127
9358	2vaHZbdcqes2Krx613FaQ998oxFToZ8PLgKTEtpJ9QqETHL3RRPo	127
9359	2vb7H46aMAp3yJRtFmTWjP37h6dwFzPFSwXvQD8iVL7t7xdyEzaU	127
9360	2vahMi9vUcBZEt3ybtZPN5iTShQiUnPERvf3Y1ogAS9HRwb4af3N	127
9361	2vbtHaBxwMje3TYXR4znx1awECpJidSMMoy87UtytyCtx8ifWaGt	127
9362	2vazetRAkfrCSuUr1Cpg83m9gzdxMC5eK4oj34GMjkvn2St1MxEw	127
9363	2vaMUxLX7jRckHic6TwmBecT14LLDhTRkDmM1Tghd3EyVP6QjWuH	127
9364	2vbEKW3ynfLrQFkT19PYfAQKxFYaHgb5ir3K1mT2bsEeFhPsZRj6	127
9367	2vaiWDjUxEs5kj7LJw7LHXLvnmo4u6eumvMERB9fb9LHYLd6DGCx	127
9370	2vbkmNPRYSJvwVh8yBPV8b6E25irf1dD5e7DjjVb2DDt6XEPWwRV	127
9375	2vaiT6wGHYp1iaUufpSDVtc4UhDcQWCEZRmAaCGaE7Dr8oDRL6ch	127
9383	2vaGjzuRxcMyVWiUyFsHqDswwd6a5mkqGq38okE6XLwi4yXVShZm	127
9385	2vaVvjCeKmV8DADv7U4yVERNMK4qnatkNkgVRXBYG2G8ocx2Gg7B	127
9398	2vb6sSeP6jTbxeZgYGpHdna2pWaJw4vf3owvdwhSD2pGbH9fYJ5C	127
9403	2vbXDuwbFLKAcGQhi6hy7cyRC6TKjtiW2DwvqxpT1RoGhKTdZNZx	127
9407	2vaCjHFvnR4VghQgUfvHi6D8fuybZqCk6rA3SHwTtf5F2tqN5VNJ	127
9412	2vaUUj4Ggu6LFFGJTq41wksLek2QNfkVdtS9Fji6jDwjyCp3ad12	127
9414	2vbgc7U74kL7ApTuq6A9Q3ajtX9yFxfUj9PPgumTyMSwBmM4AdvW	127
9419	2vbTmr3h14tSb5BCXrgm34tYCf64h4wjM8kCRAeMCbE9LtoDYgpW	127
9425	2vbLVSSJ9AsTBzPKzgB2GpL7GP5uHJpyEpxESVfxKGGBxPrS2Smo	127
9427	2vbuxeTsX4BSD8EfgfS2ovL7Mxo57x3RtN99T6eo5hZAT8mtQ9rF	127
9432	2vaTxafWcfwnYYHp4DQY4soSb2hLmyKR5YMaW42tyrKBgSf3J9UT	127
9435	2vbSZoij8sjWjCHBRmcPjHkwbwXgCeFGj9znNorWrN3HtDDFQK7E	127
9437	2vbA8aGtBCBCBpbzDnjVe1syQE8JJ6BePiwmEnP7q1DZaMdcPNLM	127
9438	2vbk3udU16hLDPzVUZDkzcLJ9PuFia7rNAp5sRwDWRtxeJdzehVo	127
9441	2vaMAvtVhoXpY7tBUyDRwAqMsS26r9Y2byYyAbiat2hjysmnXJg9	127
9446	2vaa9j6q5Jbf4xP3MnkxXt7AsbHTcjS5DEpoA3vtHLqDf6673BnN	127
9447	2vbygT75YHy4jDefBDkZEDGbATxZSEabYdR6WsQajeAb5ZBP3KUk	127
9453	2vamPCveuEFi7sjaquMrLbsUkx189qRAUZWK8AvoNXgyrnYu6TV7	127
9458	2vbLxQXDCneULSTCVLq12CXpUDijELiQSS3Thqv7hFEso3x4UeQL	127
9461	2vat3ViWkgWh8PH8zZP5PaXAj5KNzp4CT7dAaer68Jom7pNJS85q	127
9464	2vaQAUhG9icgj2LL6bR9PnRV9apXPHeEX8XnFAJcDYsH19gT78Fx	127
9467	2vaXZWsZ14zYfdk7ZLPjKqfGyGtaofN94G1g4f3TDSibS13sNCzh	127
9470	2vbFVohgHJkYYinHDsrmxr1mbhqQ82a9oGFChgmm86vyLBfr1xvz	127
9475	2vb1SX17X9AUvLo1EWaW5M1hz2GSLXEWX5pcnFxWJo3y74Bzv46z	127
9480	2vaJxwPRLfidFnphARxXRD6vQQesJ6uR9AHqANGciTGaQrR2Vdtf	127
9483	2vbf8uMtWhVeS4q98pKJGH3dTG9AoEkZN8YtyGcu4Ws2W3U6Gr5m	127
9486	2vbeJgW8dUy4tfiPshuzoDaaKQFQmButXWQfZfHKuVEdXPr8Gcek	127
9488	2vaDL1cf6hdp3BpNTVzmnrBVW5TQNth6FyYdmBDmjMknpGJmdXHM	127
9491	2vbpQXv3QHREFRjhtR4Pagh5RaGNTBPy51jmhXTT83CBjG2SgsBJ	127
9493	2vbFbmgFeF3HeC7zp7Yg5ukFhBjAFVx7oLa6ruKyx8CgJrttXbMA	127
9496	2vbVrh2wCVHGR1diBDvSDDpgcq9a1trkxNKs4J2FMeagRybyCyLi	127
9499	2vaHNZj6PwmNdrsR7ZxUy5d6UzMcL4bUy2tHctRbYDMSaJ8271t3	127
9504	2vb34xM1KKtTyjwYpz4jNDLW6D3F1QRxSmrdSYhKyZQzzpb3XLEK	127
9508	2vaovCZEu3e6x9Zhi87mCTNUJfZJ4LJ9fQsQHzqhD4jAHFuiithA	127
9512	2vbm4J5zqSnZxfP4VQ2J7Qf4s9uVgqLqGEfJp1rassMMGvxjstUq	127
9514	2vc3UVscA87xp6TEbz65CtxJSCPtJFnTRV8NKskufistwHVE8j6v	127
9516	2vbNK6vRx1SjpCXhYfrffAPjgn3bufk9Mfhw6mkUE8pQBgg2wHB9	127
9520	2vaREgyuipDrbFYW1nLDHVurV6aiTWWFWt6jrwPmE7h4mVK2W2h8	127
9525	2vbq62wupGe2vCcpupUWPnKNfEDP4QWs148BKEqoXS9GxksJdSk7	127
9534	2vb8YzqiaSwhMtu3j12gLUHWeZsu1BTYNjK5QCnd6xHALdMnYRTu	127
9538	2varwSGCp4PywDynxrjiXabnFEX57gmbw7ePC9XyTkejnPAgb1gr	127
9542	2vaxhMFw9nxMBFYzVJk3AqwC6Pi1dXYiLqqWy2DnJ3TXL1KhMPZf	127
9545	2vaQHCWENKqQhKdraAq4eyJxi2vA3jRFpZpiaH1ZJceFMggCxp7C	127
9551	2vahaT3fMe1eH1h34XUQNmjcuZdVUKBz3mKbMtna27n96dtueEVc	127
9562	2vaerc8rD5GXpeU2uyowwZkzwhCmxCgdjjFbdQCLqmiFZtTDrpWv	127
9567	2vb6wfuzAYBZ1nkuLJ1gW3HvRy5WLA5AZujhPfvdemwYj4Gr8oXk	127
9569	2vbyoAv1oQyZ95zUMDEZz6RjL4t9EpsHtkYr7J5sEYXU17tRE8X9	127
9574	2vaSZkknNc1Q1D3B7HvAt9iiQHs1ey1UCTiSL1K8Vym7BXZrNP2U	127
9578	2vbwT8ytbmqKb6Zv1Cew33VqKDTVbNqvJLJLWEK3w722UPXdxVej	127
9581	2vbdk1EkZ88kqcx6w4NyrNaEZGW5Mw6ioh1V9AACtGYsjQFTs4cz	127
9584	2vb8YpxPXpoEGGeoGZ3eyNyELxgseUBjs7g2DeuFfF7TAMdGwWPs	127
9589	2vaHfoaz87LwUWBEXcQBUHcLDpEtHeh7W6ReSYFGnRaxMJHu5byg	127
9592	2vakid6qypW1xk2CdVPEXP1pQHkHZy6UMSSBg5gUjdbYD4hYEbxq	127
9596	2vaQ5SL2LDMYemP8ediFHRMx3da3PDcNFZZUdXnkFKP2PAjYUpAk	127
9601	2vbEJUEsVXiYnEontyAXe8ghe8ZZGx18ks5DjJHrh1HTd5F2fPcM	127
9603	2vaTJCag7nxChrp8zCd2egfYt9BVUp9aPf4EcWgLfkr9bbMnPwFG	127
9609	2vbZtseWMUsM1Gwiq5qwZHU5dB77kYYSrrU2yQoZuZyBtfYsAvvZ	127
9618	2vaqhEHg52MaUULf86aUNzjtqPcKWeywupTP3BfMs3C3bsbpuSQh	127
9620	2vbGmuBvHuusaUqdxPNxkBazrPM4eVgHoHcENzzoxyXnT6VvvSEm	127
9623	2vaEjvPZ6cDC4p6EXiKxsxYUYzi2JFp4ai7vnjVuH7xv4tSGVmQr	127
9626	2vc3JQ4GEhEkNuKyDgzDZycHb4V6WRWrv8MNmffveoaCHXRfPCeQ	127
9629	2vaerTS2nD5j79Z1hqU5UZwoy4JkurAHFjEhgXdQF7qBdn3g5JhH	127
9632	2vbohrYPwd7JPbexbo4SziGKV7CN4smXnBSSfU4NfRyrEh9TmZbU	127
9637	2vbFm4e11DL6tnuqMYgr1DK4q1Yup9PztKR8rYx4NbVA2CPkjLjd	127
9642	2vaSxCjp3HXnSTpcWcazMLFQz1PjnURNEMHXe9VuZbpouQKEnzkV	127
9644	2vc2x69xgtHEVrzrDNkTf5rvoRUgazzjtTnLvquLTmPv7FofRzZr	127
9646	2vbQ1K46cdUZi5mptyBtNZFYxWRKqX7oQh9tk9fm8jhK8TV5C74e	127
9651	2vbXGTq5MJiCkEzjChRthCywmvRbAvzfKzpB3wfsXELMotXYxM6T	127
9660	2vbi3dnCsrsjm8jnpd71nvrQxrcrrAXv78pQ7faJaoz3rfWZQWQ1	127
9663	2vayzyrHaHVKYtkU1qze3zvWm5VFyWLvypLSt8Rrxvt6djk51Rf2	127
9669	2vbp2vD1ejhbpVwp3DK6xEQCDJBFpuULZGLWg39x6LDr2VYS4mxu	127
9670	2vad6swM7bCF37nkixS1j1qLFdBArgdZKgzwR8DSL5vj7sh2dgBP	127
9673	2vaHvtufmo4oUCo4fbrc3fPSYpzSeAFw47WnpoCP8ZkkAv6yVHKN	127
9680	2vbga8qfqTsB9PJStKxMYap1wu5hdnLHQUbbzGK6jWTDBbVArmn7	127
9682	2vbnewSA7Eg83CXwnVCt2xXGPuQTTzQBc77qFEbMEWxZjioRLWMq	127
9686	2vbYkw4oNyoZWVUekXN68d3DK2E3bZRuF7bpuaScVZVf2QeYNbm2	127
9690	2vaep44LwDNEJzxmhoh3svFpgfWMhLQEyL4dVXf8xYSCdbqx69d3	127
9691	2vaHwLbRoH2Xw2aNceCj4QzPeobmUeStuevEu46VbrRYpoxxjG1h	127
9694	2vbdDxTbi6ksq4r6SrcGpnWtd685ViX39RLNTBsz8c18yqH5es5z	127
9700	2vbPrRZp8G5UK7kAeQB7GS37bjTbBErQPRaaQ5axsY94AqpMVZTx	127
9709	2vb1Xsfcxe6gJsgBybTe36L2ZoSJpVPeDVbo5h77VhEgLAYUfxkD	127
9712	2vc53cfKeMoCT4eEqewSH8BXYz5Brg1PqTp4yBaNXH1x84hoMs4c	127
9715	2vagRAE7TZjSYaw8RcbZqaFBwrWwgZCUH3gpubXf8KyMjFR9iQ2B	127
9719	2vbhiPpe1R8QMUsQE4pCjHFme7LGiuirGKZui93TzkY5T4ANoYkR	127
9365	2vbDMkoL1xrFQpbCTo7N7GECa8nnRgFJQjfd4c2z5uXSJoMHCo8v	127
9368	2vaExCwyKxM6UhyLXyphMpCfebZ3Tt6vX1QczKww5i4aFecFRsGp	127
9371	2vaPmexon5bztJwNzhbP2dLjSgFXNdKc9cezG484hDWC5dcTFdPc	127
9373	2vbzt11mb1kAukWsG2T7QokbwsReu1DXqXUCnU84Y3BQoaFqbS6u	127
9376	2vawjjrPjtvtr5bJRNoKx68D29Td4ndEBY6W2iVWFLnc2as6yNTt	127
9381	2vbxWERDxzmM1V5Hj4v9boBGUp14C38AGHNYAH2ygbzxTSt4QNts	127
9388	2vbT9J2c3KzQsMaChhw5AtnzNpywc8tZinxnfCWKHvVioCHKrEEn	127
9389	2vbiZB6KE5X17L3tfemoNJEJmTpfCaTAvRKkdwD51nEaidXM5ZEZ	127
9394	2vbZnds2C9won8f4UwRD45jXUuvr1pWcqjFocmgRigoJrkPVVy1q	127
9395	2vaDdyLZPEoouwkUbm3fmsKv2gxK377sd7nRjd7Subf38jxNbGAp	127
9401	2vazkLXNL5eETxYuU3XYVTWfJZESvC9NmpcHa5t8vJyacsnHb7Uq	127
9404	2vakeWGrcyyA4vxHAcfjgnt76W7nWR5crJqH2F3KKSobXcYdCeGt	127
9409	2vbaBcbEN8CRC6uVFpBSW458hNw2CrUtGQ63z4s5WVxLfAVcTtqP	127
9415	2vc5fWqvSMfeaar3HW27AJEp9behsAQgYDzL8m4Qv1FH643mML9G	127
9417	2vaGBPmJp8EUH5dZSECnfsUQ6KhvaRDwC5giv4YsekhyzBMQze5D	127
9423	2vbYudySSsihtrKe1PJo79wY78RJ8QmRbJKrTSSAHEXZ1B9oAfWL	127
9428	2vb7ePkq7S7xtLpRmhRTveryeQWCDPSvT6BBXSJ7TLAY7av2mrDF	127
9436	2vaHRmtEW2GNBYmTS3rqkJVM2rwhegUYYyShPnCVJJEwTPrQFUDt	127
9442	2vbixBbAa9H19uzJQ6Qpj5f2PTHKgjAYUo8iev6C6d67P2E8gE92	127
9443	2vajHgzccDzLqmrvNyMw98y28Np66vCVdDkfmuBuuNNbMin5HREA	127
9448	2vaq3aR9gdqbKg8cyUuS6uvvX8DDNiaLXi9KvzBvrcxxweD4wAMk	127
9454	2vaBy29LB5KsEKmFMYQZ93sc1YZeT3jEgYb9JcXjLwPba2jaoLMK	127
9456	2vbUshj1KcwvDRW9M495iS4gv4iEuwzRj8DUdtyPEhBs6ebfmWbS	127
9465	2vbLpKhZTgaKZy8qhTgPJ7raAZZFYvryMqwQFPs2gxi8w9beJSYU	127
9472	2vao7GhiXSi798mzN5FMWhM8QfsBf3PZ8bAjFvhrHkCye8aPdBHV	127
9477	2vaFcmTBQNxYKu4tTAwEwrRJiLot1oYBfdkh2G2gE9PePGLqBfqQ	127
9481	2vaN3ukucVm29g6k7D38G4xHGPr5BrqvJa6pACFQr3w2veNQBVir	127
9484	2vbyNXpCY7zLToFZYiRvf2eh5gDWnBYdBdp5azmKkhL1Pt6SnuDc	127
9489	2vaCpY6iZVQL5ZRvBB2SmDjgdRK5G6AebgiWLa28KJFX3EJvz3nQ	127
9497	2vaaXt8fptD8wZ8Hdqxp7MLRzS3sNa1LbgX1TRW2bmt6DUTJTzD9	127
9505	2vbz4muoLE91HunvJKavT9siXPfNY9uDU3NdKyWLMqMM8YQqHFqC	127
9510	2vaXBJ5xRHX1KNDetiQW1ZvKTfQNdTMjSvrmwQSJsVUCkukbAugH	127
9517	2vbgXFUxVRFNWz531mzhp9WX5eFBoCavk7B8FMthXx6KQUcz2Swy	127
9523	2vaBWPJ84MidQUuS5KsTpPcp3wMwK5iGjrVbsXq2ZXWyBFSpwGym	127
9526	2vaJisnDaEmyLskQgVCFcp8N22pL5buruWbxUsJUc8bF3hJHdMWh	127
9527	2vbRFWNNToi3pkYX7a5GMKJPcKSkiXrAdTn2giKCCxjuRKnLvNvL	127
9530	2vb2w1LQCXZeWHNtc2BBd2ezD6if4tNHSFy7ZSunUHoirPZ3ty3u	127
9535	2vbobrz6WHkk4dync4XLLRmcdEYPqWogzoGif7YYcr7V6Z8Mc2tV	127
9539	2vaR1ukLR54vcm5shG2cv8TDj1r3CW6jrgnTrKMTLvYQF2WvQYNR	127
9540	2vbMQ1Rzm4jjY2WEq7RspEiZFutjpavHasn6KwnAvykmkj5hijyb	127
9543	2vaeSqqXjfdcugy6mJU9jtsXefwgcwkqpdKgj3Sxe5YXeRH4bpMU	127
9546	2vbLCXX1DyK8gRxUZEqDMJcmS9rbGHCcYrs8dEJyuVQT5NUCqSKj	127
9549	2vbPDViE1tmZe4sbRbi57xkg6JZbCGStgWjCSVJHqyZFem4EMFbh	127
9554	2vbDUHrDU7rMkfU5RL9i4GZrSSKCiEGeqtQGA9obhCh2qk1L5E5D	127
9557	2vbtspGHojVZXbH1UbJArr466259785TYQV4gvCVT79yjhUywtGU	127
9560	2vc1qfbi1b4tq9FKmRK8kfZibAJcFiQ5PdDKCXizBHJ24kMWPfq7	127
9563	2vacJCSsFJNKaRoAg6XVi8vJHGP6jK3yFaHzZojQz4HEqn3fXKMe	127
9565	2vb5QQWKpYMkLDbsCXcd8fVVgY9oksN9wdMmbtLB5Axd1ezGCoAX	127
9572	2vbN4ghVbHrYCCzTSkysUUL79JAnfWrUeoajs96ihPHWLHeJmL21	127
9575	2vb2QYSbLqC4CmoiuxznUBKaSBc9caKm5ZvqFgfoDLouP23vmY6B	127
9579	2vatoUC9CwMjvvRtPhcNHvBqzaSSCEUUD3JSokGxPjjw4ZfiyHt6	127
9582	2vaCQkK1gBi7UteeBzfRwvUcZDwfiU9QRfvfGJG36jk8BFPMHHmH	127
9587	2vaS3iu83wpMoBZ4M6Uy5TirBrjYridWJ5BtnWnqYLYHmZ6EBVrG	127
9593	2vamyK1qa7cCmWbUCAbfqQaMLWSq7LQS455FjfiDorrbW6hj3LBL	127
9605	2vatdjdyojKwbGjB8qARcjeVmH7sVNkP3oxtQqmtgNNC9WjvFZVN	127
9611	2vb3sWUHKDHVwDMh1zQ6Bnnig6cMzozZr9QKM4R2idzKW18ppt2U	127
9615	2vbRed5jcAvSNZjSLy93JBueVJ9eUnjdxh7SEyHW8v9Fk1F4NLv4	127
9627	2vbq3euBbHCpELCJvbGURPRShJ1ZHb9D3pgGJthS5rWr5cpbgUjN	127
9630	2vbK2V3h81PiYQaQ5RQuuQCN2fxTJRbZ3YWfdwa6evnVXbTvR7DA	127
9635	2vaA76a7xQ9S8dREzTd4eQLHdcrjxyYJ62Sw8N9Z6HU7vh59zhFi	127
9647	2vbyP7TSH8hGv7soCx6X8XwtxQA6EQh55Arn3cuh6JKGUqNjicha	127
9649	2vbAUsTDNV85rcoKh7cMpsgBj4y91CyDmxVihMxsMkutsvinC9be	127
9652	2vbDPKgQbKCCPDf4ecb5HpLFwR2hjh3SSxmYfiT4eNjdMRNm5Mk9	127
9654	2vb5KyRv24hJtXxsVoiku1gXW9MCczBbcBM8jzu2CEN95sELrckv	127
9666	2vaN7LqZ67Gtfos93UjgsuVbLrdMn6K75pQuZHFVgpL129evzxAw	127
9675	2vaEJyiTCW7CXUTTshnK9SgfRUJLVrqp2tY5Cb56vCdyu8pMBc3D	127
9677	2vb3i9N9jkM5NBqDwRak2mdEriyi4z55MXiuDEuVikvRXuKgfzLd	127
9678	2vbQeUvf2sNCMrU3693N2zvJqiBxZrMEma5w2NTCUwqgURmqDXYM	127
9681	2vbVRpkFMkjRGRy69mxvDCSnmKRhiT6TmSzkgbfZEqKofLLbLUSN	127
9683	2vbHhUNcndRbyLWBLrMWYhga3Bh9FZyX3grcZCUVTWSxECuQeJcj	127
9689	2vaFcn3tfmkRbuXGSd8E4QHZYNsYKrG7dRUg6tyyLJirboa5BCHH	127
9695	2vai8rwWwuoMpuUjQWCJu54zfcxKhDxXiFcMRnab3dWrfKn85gSE	127
9698	2vbMRiFriUzsWuRfoJYBt7ht426kNX8AY5zPwHSbtBq5NMwBA7j1	127
9701	2vbLJbsMqeUQWpVuQ4eCgs83Hz71vGcFhFRXJ8huh6RkbC95ddh9	127
9703	2vaUMucknZXvxEmQ9HQj1zFK13hH184m2WWgnjBQiLKGRYujTuNw	127
9713	2vbj7jxKNhLzSkEeq2qrRj5ppGkUVMSJeeAZJ8HbcLTrRWcCp1xe	127
9716	2vapQAfsT5EPduEsPkhjjVDZLSANjEtkeBGvbkDngBXNAQ1g1MX5	127
9720	2vaPE7DP94a4ez7c4gavheMerafWejuuu8ruhfgvZAswxykEz9Dn	127
9723	2vbhT12yaZ2s5ujTVZZzCixPqKiePqGszptHf3sM9oAhsqZb3FfW	127
9729	2vbY6vesUp6anS46GZRrBP8Ps5rowQAkMcTtZG37jDkSP6kZybwo	127
9731	2vaWyddPCAHihT5g97fPERmAXe3aJBQvwCUFW6iHDwh6MKMZKTK2	127
9736	2vaiCGkmwBdZh3jtLe2BZLMFMXWo9tu3WiKdH2W3rfYajQDhkhen	127
9749	2vaMHceMgQAub21RQCe7opzrpfFVLVLL1CQLLcV14tptqYwjcnBo	127
9752	2vbcKsDWvUXygwC54LdKj4juyd2A3s2qiKRuRVRpruj9qY8uWBPh	127
9756	2vc5UXo3oW5BxWMxPTZy8zGLGVo1SJjEutaNJrgfG1P3kzGSg8Cx	127
9758	2vbmZg7oSi6AMVBCyLBDL3UByxUfJYLiQ37D1Yq4QLdYtaCCn4TJ	127
9762	2vaiUnmQgsYQBfQ3skz6sEUZYSrGt53AQkFbGRxRfYsQNfLXimwU	127
9766	2vaCarnKQgqCrXeCV2Byme2QWPitnTUKoQt6XRhvp6FUj2BNMqs3	127
9366	2vaJGzCaYW8YyHHUKCszRbuoHWbVULhvWBZu7zaY9cXBwV4291MC	127
9369	2vaaBTyBXt4Mh5V7nKCzixmsbDkxQcu5PnCMoWKzwdKSumSH9pe7	127
9374	2vbMH9uWYr7ZfS1ZX8WugfbrAJ4d15XS8qkiTLUhjSNvLnDsWTEz	127
9377	2vbuCYV48zL4aLef9fKNM99GteN5y3Vp3bmqsrqBN74cipDBfUPv	127
9379	2vadw2qZLQoj5rWJwHSymTPGUSCxkgJFDMtr9sBK9WaBKQSyyM87	127
9380	2vbTHJJbCtx1Xt8FZkNNPYRh8j4y9WPRdMMjiEdLpLYjzQExLxmf	127
9382	2vaa6GmTYHkPiGK3Ub5FMuW1Fj3ZAu6jW6MXRGZRj2pnReUoe4jL	127
9386	2vbuxv5fAeTBJA36hr8xUX5gzSboCvme8HWR3QJ2TijZLmxwN39x	127
9390	2va9osQmE6XcTjkeZEpGnHaPS7EXFrGAeq5q1RwsJnDRhneQoLZE	127
9392	2vaBMMZ988YYHTDC3PVc5pFZEDC14XZ3X9d26yvemaHykfjgdzTn	127
9396	2vaKopbL2YqcUQstrZp2FNDyxLDRUtbW3CNsicMdifdPQ2e6mf1K	127
9402	2vaRrUH4AhuFQ4zNtG7QJt9DwLhg9Xu27cggQwBkscwMmaroxRfi	127
9405	2vbo1VBEyLh49yyq9jfJYbsDgzVCw3eNePPxTy8HUPALNQSU4HEY	127
9410	2vagn1rj7oxirzXVwN53a9GCpQrgnPQQcJaEwcYaJ2jtHhEzoRJP	127
9413	2vaMSkr4eH9pvrJakd4fGk6JfLfxJC9eA5z3oBbX1orG9pUkCbtP	127
9418	2vagS4AdhhH1zpoNBRP3sfa8kV2H9YcZduVD8HjXdKKpKmmz8BCW	127
9420	2vbdWfK82vptnW53GsWEiCkzPC7SWdzhJ1wCxAXwCVByJmduPnkJ	127
9421	2vasG3hUwvGyv4rRrT4Q8hw5aJ49fUsgqXqR7NgopDfD9Mz1te62	127
9424	2vbC6LBxLwx1zFt7gnN9vnJ1TGfb7HGRf4GL4YECD7w5WP4NiqB5	127
9426	2vbqqF5xN9rf2czQ8jumCmhekNZxjsoHj3FUdVsyvgd9RrFEXqJA	127
9429	2vamLrNt1zJriBDcJyfdQ7nwqpEE22LjkGjNSyiLmXvqRcquPwX9	127
9433	2vakZMb7bhqbRH5PHSuA1ZLY5uKsswyQxJrH8vfxc3oEZa1V57c5	127
9439	2vbKHSXeMVuWowsyoE55eFiMsre7Pjx3RvZeYeRrXoTX5v32NXa5	127
9444	2vaaYgw5BzuJip5F3wQm6g4DoxNwYrc7xnL7qKgD74umT89QXvUb	127
9449	2vayyYW8dZCYzHqY2egznPvy3tD3qm32q2EJZdHNAwr46yQbSN9i	127
9451	2vakXAQ3v3t1CQ6MYy94wC7ybqhYqhMPWinrhbjmnuj8k9FB3SHZ	127
9455	2vadfNhZxJEZTPGLqKRSgfTVx6CQ5DpBy1fjMdSjmZyKvRLdhDSW	127
9457	2vbwQdr6brwVESEwuqfuD3pcJP9e4BT8u6xdiP2j16bQvETaaG7F	127
9459	2vaM5dY4YkY9FJbC2RfUAz3ZVhHbzNpLM2fD4BAkANztLiNrPAKB	127
9462	2vb2FSmgPXjzwwUggAoqLJyxhmSaXebeTVpNYFT9iCChhajNPx7P	127
9468	2vbQXQNzKD8qf9kdn5B1gkDFKhEEqh68uniYKEV9WZjtnvCHZcmr	127
9473	2vbpHqpMUvPeQdfMBh2QQwwHzkC63xe33JdTDSxccPjcPjZvYeiM	127
9478	2vbNq6TJrRx9K5DxkuJyHabp1RJZo7mBJDsCcHGtR2TrCqxaCB2d	127
9487	2vaDW27S62qEBCEhD1wmRADudNdRZQkgD2KiBfUcDA7mXTf7KQB5	127
9492	2vaM4gzY75qtPmN98ZfAVXeTTm1StVrBr7h9cwHQqg9uP8hSQZ7B	127
9494	2vc19hG36romwFtYCutenT9qP1v4P1pa5YvoKRHmzawpLqNizZ2Y	127
9498	2vaktnFJsaoFGQ9WP3uHbf1EDRu1o3khguyD5SZ5Qy3SsjWtTX1X	127
9500	2vaYZDAd7VgVdLTmqzHeB7KNxPvuvg1KwGBNL73M8khYgVFszDvV	127
9502	2vaWYG7LqKL2gCZUfAhUTNZXfMoyjXTsr2TgtzNnbC5WSUVmoxy3	127
9511	2vaYeGL3ufsWtDkmQuDLQzavT15J2pphAtPhoqLET4beYruqxK1G	127
9513	2vazskxcqXmf9v8BEokYyyjc1TwEUfP66Ew3ModRgWBoWsyWEid8	127
9515	2vabQ2pwVWHBqK9NEjqRK4ZJ8uj7DkGqYgkKHPRfCi6D9ah5SZo9	127
9521	2vbbUY55pEU6WRk3zr2vPSzXGFJoPcrmrNEWdhF5kdYnKk8QhmuQ	127
9524	2van3CAsvUxykEyvCQS7AEi1F1qh7NTBbgtCFLY132FJ3eM3znNd	127
9528	2vbKzMpfoyf8Em85Lda1buauYF4oyxmhYtdmQmJ75LZSU97MybaG	127
9532	2vbwLD75waeKABLa3PBJNQ29WL6buWGQf5svT44ZVyn9s7xf9XLM	127
9533	2vbeqquUpcCdpGopkWZRqpoh5outn3SkUuuGubmwriKwsTsqUTgr	127
9536	2vaMxEfBxqy87Y44eFqZ7WbkwFabBcw61jtYRtx6aqaXUVTYUW2i	127
9547	2vb48hfr674PmK7j81Msw5qXarMZyMEuTL82Lrw9VJznqygzh7Gq	127
9550	2vbtzcAQjApDECQPqRGBefE6SiSeDxtLNaVco8eY8c82hFbfKeB7	127
9552	2vbLRRBLp8SBhJyTpqAsGKEkhLg9SkEDj2krBf6age8EXHBRaECb	127
9555	2vbEKwKzHG8do1tFB2vDFXpe3VSoPNujZPw1553aQew8ceZByiWg	127
9558	2vbRQUBRwpXD78kza1Vve16iqBYA9fv54eeZereRdrXizQXrsPKF	127
9561	2vaNMqQSzs9FGssxQGMmEf3pjxNMdyWodZERFGB9UryeYo6L8NHt	127
9566	2vakJgw9WFBkBw6LtkghSCjsF3fQX2rDA4kqeGii2wZTbEh9qi65	127
9568	2vaUBzjYQcA2jN27aYdvVhF1CuA1vCRGRPF6qVZj1Q9rXCoQQt1n	127
9570	2vb5ojx93SA7DXB5zjyKEtAPM9Y7JKPNCJBc8DCaAkPDk18YdkvH	127
9577	2vay4yUniAydGPR9jHondhEW3CCCcuXnkpSh21y4NcaZEshhx94c	127
9583	2vb9xa4Cy64DgfZbTeoyUUteiNciNxr3FKSEswf7LxQuPgUJWdvQ	127
9585	2vbZzwk8NmtRyLFhU9AwP5KKnkh5bpQHCScZTinvdnuQGDcm6gYS	127
9588	2vbVhJg2AVVuH8EcLW1DRGtQNoPbYJULnMJy4PX68RVYM5mZMsxD	127
9590	2vbQiBCt9zWj6CU2bEEtwwicV2EKtAheCopKzcmRRmLd59vwgLoc	127
9594	2vc1g7o5Z9rJJkYpbcHjmxA2GxUEJgGn5FLmp6kBD9sQHJLy9kD5	127
9597	2vbdVmG3e3giogkdYDawsfA1Y3CCEgHcC3WD3WLii2UfQJYTppU9	127
9599	2vaZ57swZzj8zK7UbFNnD5LqQR4A9bqrk8dUHusByA7qUjFTfdE4	127
9604	2vbSdvGU9ExEXGaKCMDBYb33Y7KKGTTbHdam2egQ5dfWoFjzDg36	127
9607	2vbmKFTdNC8SSrku2xW7dEdcUjAa23V9SWVoWHitoGDoGyBPN6RQ	127
9612	2vao4jyqVsrfmHVTenX89gB8vHS2qRyTVRbRUWLy3dfJMK4s9Xi3	127
9616	2vbZ3oZVi4VPk3uW5tAkJL3cvRg5ATrgUZoRbJuF2mZ1AxcM1tDc	127
9619	2vc3cDFFQUz2pbkSsF9qKLvwDPvjLyXEaEwK1ByDvFBrwkvAmawX	127
9621	2vaZhevtvL3Kb1kXKQa2Zjdv8LJXNwjAc8m8xezsFBTAMLh4ttJd	127
9624	2vbj6hXLnHEPqFv7KHVN4hZPpXJ7xuBG4QMGg6nTQuJ9DWuAZKFi	127
9633	2vaeAu6se1kSjRLav5Qz1zeevra7XfxDtYuVsPJiJW28dhYQ1S1B	127
9638	2vaer9zhAQDpEwLaLhnf1tynnBJeraB4WhRUxn5mZXkewTjyS72e	127
9640	2vaHrFrLpbNp95WBaEDizJ179kALwxSVp5g6ToU6xmRLcn99uhRF	127
9645	2vavqNJxXd6DjyHKGLXBqMkb47iQZNQS2Fq2mQtv4CyDixcY4ZFW	127
9648	2vbNgxaVLGeiEvw57ijY4WYuLYhYBVU3evTWZYEdSHGLVMNUavNu	127
9650	2vbcGoNizJtRfczMZzUAJHzMtYvT3jjpYWWNNaNkhNQ8XwpiuwZU	127
9653	2vbFX7bzdmPCyxCbYPRSmnfKRFUTrLb7jKtXuyjWHVtBMBza8vC6	127
9655	2vaioVGHvWxxLyhqeRt8yy4gCNaNXxrLBg64S8PmW8deccsU3A9E	127
9656	2vaApAcWxukwJymnJ1THfrLpvhaVTSozF6KsTzNRoGCqDHfCC1UQ	127
9658	2vbXMMwRVrieC9AmNwrt6jrrFgZEq1pQrkz75nVz6g3BewqkSShw	127
9661	2vboRnH3QnUBJjL7eyUjsAbuZ5mrZ7dH62BdVytaiREnAixjX9T4	127
9664	2vbVHf6xXAXqntJ8RKA3rn8MZzDXLwfyfHQUoVEtAJg8CiBbrS4x	127
9667	2vbDJHrJX1PJF769U5QH4nbvQZvtmrfLpgcU8rfuH3dv2Jx34kja	127
9671	2vbDHr4vurE8KtXTsGfHZBKBZcnJP8qp5VqDBtJeuLN4TKVmrgvX	127
9674	2vaS3vpauLAZeGmcsNq9avtSp4Pbn7ufY6FkvWkQf28NQUM37Ko7	127
9676	2vb7KdEjzHUgFJv5zj4RkLyg9Li3pus1otmdg2X4aXzMveyKhNZv	127
9372	2vbFMnBEPAm2kLSYmWz93uTqA9EnEjWZvVHWcpNQjKXNRGVxpJuK	127
9378	2vbUynf6yfCBt7VoEniELEWZPrVJyVeg7SR42FZmbJtfAAEAiEER	127
9384	2vc34wnDRawk3vBEAQ6fwMdN8biuKuK7QdnWz7fU7nEBS8kCdNXm	127
9387	2vbHNGZsVoqhnpHomK51SL6cy9xEPsuSu7dYvDp4rpwRgq2eCNJR	127
9391	2va9EAS9WZmwQJYgjWgPSfsGqmSupT5a5KtfDYrKSv3yRM5zm3A7	127
9393	2vbJceGtpGuZw8VWAEhi9ZCotSc2rntkteCgQnoMTFDTDKn8AYnS	127
9397	2vb3yyNTXSbu9KS52hvUMBkoSzgXb3GsGhG7Q5WPPCyKXZWTHUQU	127
9399	2vbw4LfLL7dtwranTF37ASK8KGagfkTqbBMfnKNsWXH5EwamsAR1	127
9400	2vbfgNSAmUfdbvM5QV3fZgLnDWYiU1JVMV83X5H6xpxA8HK73Nmz	127
9406	2vaAMAFPD5o4d5ivYU28zKMnxoFZ8L22vJLcvjgkzqPGMwSAedEw	127
9408	2vbQ7uztiq5EpUAk4KAj8v2x5BPBv3oQYmEmXhJWHES6Gg9qVTtP	127
9411	2vbCK5QJdJyyrfRQkdRBZXSZmUoc3QEKxnPFwzMF6jfxpYfZtVno	127
9416	2vamMuxKr2eXBz5RQZaiFGcWLpzXmct2zfzdkN1hEAZmNk5T5rpM	127
9422	2vbxMqm4QXNDWK7PNUMmsUVvmMs3AVvHruauRxyXz3GbDp3qz7SW	127
9430	2vbsMx6YCG53Ghc31t4oZuk4vroBfUJAwY6jxFAnhRD8u8KrJkS2	127
9431	2vbH4Z5zAUtbANwJYz62hiDjNSphbAYbneFLheCyWuApsk81nZhy	127
9434	2vb52adddAHJxgKLJnZ9ZH7EcuHcn1M9zFRksYnXjycETH7h5AMj	127
9440	2vb1Y5jk2QkyQJmgtLMrf2iV6UydvZGHqs2dwnMck8J2J53MfvHv	127
9445	2vak2rokpY4GvnqwdVmRi5qjdXX8sSADdsZUa4fX2RGXCQpABFJQ	127
9450	2vaNayvHFvYqWk4Gk4bxyBEoJnWqcZVYK3GEG35xkjy4pjiMewok	127
9452	2vbh23NYcgMkJ5HfH67hSW46En93BtDAG5n7TUY5Qe8U3uquhfzZ	127
9460	2vbSd9ByNW2Q5XtgBEyrSq9mVbeEoWhSFqvmjnaqbh3ZpPi66rxh	127
9463	2vbsmzWWdkxPdYhshGttsgUM3A4LUMnHnKJhoDDCxcHwCYVDNUBK	127
9466	2vaFfgffcunKZxJLLxXtsNHmBJ1BiM4u5a5mSaA3i4wSTjMNZaJa	127
9469	2vach1Tp5KFR931D2UUQnhKPVdYLovu2LFkn4DvvRP5fJN9QuDQh	127
9471	2vbEPHSUtwGo1cSaDZ2atEVvBAoVLsoeuVgS5XbWXKJUQZULAxXo	127
9474	2vbTpvDDQSNMEEnXSaKkhNXSwQQLSna6WtcWfxAZ1mss4JFm3q5E	127
9476	2vau49M2CFAE8Bfqkjeov9FtYi2FVGP1XFrTxUZ9CfWmr9de8NqS	127
9479	2vaKN2ENiBZQNq8AcLfHLeRwhU7gf6hPcBQ4mdmbX3D77uD2kL6P	127
9482	2vbb9U3ySNYxQhKwirsEKsiRoP8yi5GoM4PGRLJf47v8YY5bHCHk	127
9485	2vbLxFBuC1sXKcNmAVUbV4iiba2pvyvsF1Jb6Q1bH8DSq7NGezL4	127
9490	2vb5hstZDR19qua1EG2CbXFTYyaEYNxUN9B5NArXjYF7ayMVATQt	127
9495	2vb7ktoemGmdP6EABEbPWhPzbcq3FuuAdBpUTKTBM3Wu5YWo2PdH	127
9501	2vbiT4PBDxiwQUJmSMEWzrqbK2ZWq6ErJwhJ7R5QzGkY4hF4S9JG	127
9503	2vbJxwQcSTjiUnTdmcTHhPhyTsd2TcuJjtMG5hFTrvjBYhdk4mD7	127
9506	2vaEGv1AZ5CtBDQLCc4C9db18umgLiiey4SbuYZCzg9xC9iwTpEu	127
9507	2vbVtEGvnBywW2y8wdRTxCPFXd9fAoJRKGgBdWchy6WFdpLH9rTD	127
9509	2vc4yLnat2JfYsCjjDMiZRsP2qBtrAXdfwCW4bGS3JVJxpLax5NV	127
9518	2vbjAQsUfEiddph7xVgegeNGeqCs6Gd7ydVNZzWfdLLpH8dD9bW3	127
9519	2vb36nRtS9Dawfyie7GFGKgxR3kjZnbiYtC6zWUxzkaTLPyuCggw	127
9522	2vabpEgivByV1wp6e4CQVPb7svhb5diHCP9pG6t8BzbGszeMJF9s	127
9529	2vbV16r31Zwm9BFqg3ZHCygivEkGTvFaWJN28xTv4dKqgzThfUhM	127
9531	2vaPpzzPAnAqmya4rhsSk147d26QYAUDc5snDhx21veYZ5pNQ2a3	127
9537	2vb9s8EZL5aY97ZzFarAxcAtSXMNh6Ns8wDUPAHF5ojDuDkJhRDk	127
9541	2vbzVoU9XG2DdqKrNLHAe5LkwpmVWQ9XWA13tH982V3dfhMwcZFM	127
9544	2vbWk4KJ8UQKB7oe45CP3HwfcFZY2n1CfYBsyMSM5kPieR7M3vf7	127
9548	2vbwuhq8Zu3ksm6Pn21Wkq38HDp3yZ9CCZkbsgvUUVLadXC7GjXp	127
9553	2vbFxruiA4nzx27W8z5xPVA1eygUXCzNisnTeVwPinxCXxrp4poj	127
9556	2vbbubFjgpw5iUv8ybuRAWBv6JnX36t9pGqhS9nhhuLkZc1tciSe	127
9559	2vbtHyFeScrzKDWFusWe1tyMgqKdFwx5TdsXCHhVGHRusFXmUkun	127
9564	2vbKNuUWzc1gGzX8rxNooKUdaRUQ8buY23PnJiPjkmREDBkq1uip	127
9571	2vbJWWAB9QHqb8aJnZaKWbCkyZJS1d3ZJNLh1svW3snvVL6eie53	127
9573	2vbGRDh3HTqoLMhVVG9AQQ57sMgo2HvTKBw3SFAmny16QKBFzXx6	127
9576	2vaDaKvQixpyhXGfkoRQFnFxsZQJrG7HbdvTGo2mZZyBnSsNo5Dj	127
9580	2vaVu958BnwCdAT7yczrPiANGtxU8ZDNGbnUWhv3TBF8xWPsoBeJ	127
9586	2vazHK8VixZfWydz6uasnbW9CKwKL3nU1jUU957R1D6AeFXKQEvt	127
9591	2vbHrBbHTWWzVGBvR4ZkvjhuZ6rTu2wyoFJHRuPhJMoPbuYehqLA	127
9595	2vaZAedkpcqF4Ur5KLmY1ckyqmwF6TRskcKHELAUqi5x75qCyfAi	127
9598	2vaeegdtEDFmXju1dKtscWgPsUP35QX1zaXTpRfEcj8Mc6RYRBnG	127
9600	2vaJD5gPy6W9jbCkvTNkXgw5QwGAzMvzFZFcgmXvnukDdmDRaqqv	127
9602	2vb34AfrEc7dnmkAERfiyisUKEHUBgH3k9GHppWPLEWx5SSGf9nC	127
9606	2vbHVT3C5MHZJSEo3TLXodoDNXJo2vRo7CEntp79Ssf5Pp2PJhW2	127
9608	2vaq1mZ4QZxFSud19CtDCBRm7v6Qex2doRGRv8zHxqjmSwontX6U	127
9610	2vahH9xYi1diDzak9D6rhFyT9NQJ8DnMrU2Sd7NhLzVZ3QLj1WB9	127
9613	2vbaUuyZpD85ojdvZx26ze5Dz5W55oVLgQVF1Dw9iLXKAwQuWmg9	127
9614	2vapVbWX9pY7Nb8yBdRwmp3ewKSEpDd9djo4RLATUPfLD7hx1rzw	127
9617	2vaKm2sazj6ob7DE5kn9XQxds9RWqDgR6MzuugjMcqvhUXdBnFfj	127
9622	2vc2uwEMtyZcEHwYW5yDzar5nLF32DrKdTUFCW6fGooM3itP1CuG	127
9625	2vbkiY1sKYUiNRRuEen5WgUvZYj86VD9toF71V7n4jn625mqR5Vs	127
9628	2vanKfNP5nyhppPeQpNofrTpUeR3wBuzHYbTM396jpwpKN2ZVLzq	127
9631	2vaSeix9ZRqJovh1HZvwvBUhKBguw9Chi2MnGjPMi4vTYgvGRar9	127
9634	2vaPYxhqKQ8cfnZ5t2bN76ZvL1EUNt1tti6zb853cEtxsVsYAnYP	127
9636	2vbAZN2K6jwbWHP6SFboGd3qJHmSgb5aEgUcFW33hCcD93rmfC1j	127
9639	2vaxCSUKk4fdboUKEWy1VMGRcw4xJkUhhRJNEuALL8S1Ne6Z5G2q	127
9641	2vbgbTnfDsuqFjBy4SStSzEhqDka23fK4MmZdgPQkE66CHdHsXCE	127
9643	2vbdhAa5ihcRuo16vroPuDymjB7m4aqYx3aW5DX37NogzKV6cptr	127
9657	2vbaL2qbwHNCSLWY3uSCQwVREWgQVXDKZ3RW5MVLfqtYWp2yuTfs	127
9659	2vaitMw2vrSFr5K5dR3XUPs35rBNNCXj2TVEqWv2EFcPeL41tjqJ	127
9662	2vawvhPjNDWAfam2aaLsQYUvqNwfrHCzQ2BzgFV5FixxuWMKiVhz	127
9665	2vadcuYUepk28wUHGPGdAYS5T8UqzXejrCZVGWJU2K85tj1JCAhn	127
9668	2vbrNhxGJCPykLw97EfcevkArV5KDMnvXa2t2GieuezmMj1tRMYV	127
9672	2vbWw6VgPkXVhNhdGEUZAtZs83dL5iNS55WRwEEXC23xqsTo6qtR	127
9679	2vc2tZjrEbdEqqtVz3v1UTMaYTvMfro8wbSS9Mppods9bhmvZtTV	127
9684	2vacGdfQUQVDRAgfMyn2PsTWAh5VbJPAbFX35qqhoqreb4CB7sKQ	127
9685	2vbzMBgz7YhBFPLsTnQkuJPEiRX4ZawWFfaY1sXLUhbrpVSx9Y1t	127
9688	2vbraeewYJDnQM3hGFrjG9LrWshohKEvAZnfRkUgVrK21QNDYyPu	127
9693	2vafBKc5cbJd2WQQbvquVqeCpu7HTS8xcJr8eF2Z9oi5hssbre9F	127
9697	2vb2pP4gXvqpsUGsDLrfCSFpUx5TZ65tncLGNsanrFMGNuKKv77v	127
9687	2vaHPkkHhoh8UVYiXhFDM3b4ELagN4QQ62mqgYdfmaj7b98yZ8pM	127
9692	2vaAThf35EpMFisberVTUs7WAp5SbtiTmoqa75PUg44uL7EP4zPJ	127
9696	2vaFx5mbM7xsnMxDPDEDDD3QymLWv8chaxDENZeXerJoGFcfAi81	127
9699	2vbspkiY1aS7L14wvGT1M7FiyXCnFpdUdnVZ9aA7qbaWxfVLp8Gq	127
9702	2vbQvvMv3q7Vc8Pu3YyqDKRPuGb1HTWHctUgwVB6pjfS3LfaP6fh	127
9704	2vbywzTu9sQJYgFQTktx6VUUnYeWt7fSv7hJyktPb9zpZsmHkCeU	127
9706	2vbrXZnNGzDLukWG8qHcgsyVxDgVJdiQKr8z128sadjDMiWCocFR	127
9710	2vaFbt39L7FWvdzbnxeYqyr2YovNXJu1R1bJYEWvRGJKi2G2p3V3	127
9717	2vbJAtkB1QnWFrgJp89BQk9SbMEL3W3zfRPN5xtKFAvBJchnxB3g	127
9730	2vbgzvZcAmo2jTkXPqmAsf1p7LXiCtnxY7xhkNkb2nEj4XPftpUo	127
9732	2vbkKH74mNWRBxAYxjEFEtuox14yzvRMkDJPLogdVd84AHAdVuW4	127
9739	2vbmntvQN6fzh3w5gRgDp3BdBAiTNzCWfWCguMyhAHLKt3PT313Y	127
9741	2vaB5gdv8KeV1GvyvDxyXNNwUndeoZtd4ap4irjYAfHa1EyuUBU7	127
9743	2vbhm7at4VLkYJcCLBVHWKfnAhTMNk8WkwFBjExfevm8WsrxT976	127
9746	2vbtGtqeL4DXvs4tQ4LrbmTYpj3rvcz3Ddp68BsZmNLdCAuVHTwa	127
9748	2vaaRRLRuZ5m2oZENA91aM2Bom8kVpQHHnCZ8qXVnCYu9SsGgMDm	127
9754	2vaQufw373FCGki1WJywaLZk62yPiaukVzsQ4XTy9Tqtt2kXxrP1	127
9760	2vbx7yFRngLrdWGVd8zziGHFsY1B8ebPy8gMDXv8Dc35tc5ztjjR	127
9763	2vaNSTPtDqtGdtzuW7vZkuvGdBAdmACBEN14wkLGJkSNPjoYYG9z	127
9768	2vbC7NDmsn74C5zTnqjCvHRSMP5gvZVK5peQSgKSJuZcRw4sEynF	127
9769	2vc3dPmj2inVT5Sc32V7SxZBj1FrNFw8mFawTw1aNghwedkLQbtb	127
9774	2vbmWq4yydcHMKPNVjv3FGRJ4VbzBPsAX1LM9h5uoixxrCm2ouK1	127
9778	2vbaN9TYDQsFXU57hLnHBvoZCQJVSNjiMgz1GEa16jbts1KUta4p	127
9782	2vbqngB2XSwyrfMenDCLSLXgcf9ctRPBKkVCT28TJ8LkLMsHxakW	127
9786	2va9tZ4BhPdAmWmrFjM1Rx24tB918GYT7dbcUPuryPAEMP6XbjTg	127
9791	2vb9wciPk54EW2ReFcHiNZVY8JEeScUEpNScjsSyoFTS43GFEJzq	127
9795	2vaG27Mb2wCum1fXpXi3dSYPFv5e63uJv3UsPFsySMesLbFNt7tw	127
9801	2vbDd6VQLcK9QANn4RgFjfmaesqGLvFo3VSMxNVfksrNxKhKYr2r	127
9804	2vbY3EpcbA9PECedJidrW89DPDfL7aKxJswWhMrQAznnS1DrvYqy	127
9806	2vc1vYrDni1VZs24ACRcfnSuYr9QazHnEeuWZrzFAJ5WcbxpS8kn	127
9809	2vbcqfYDCtWs2D9RefDtAaCdGHHRpoMApLJmD4GZ91Z5uTKpnTNX	127
9811	2vbd6pM4yh64qzsucpcDehwpN7PmDWvaTGeFh2rxF5KGvAKZYpFP	127
9813	2vc3WTRUoDEVPygKdQ7T65JnPypJqM827e3irX9iDUAzRkRtB1cJ	127
9815	2vakDW1mruR1dRBHLeZnmHE1KRHGe41fTk7JtiwWuJEo6tMebZHu	127
9818	2vadXFWYg26YduWLs1YmqgSfFV8BdhvkvdkxqbYg3e3gSqzy4Kzc	127
9828	2vatdmX9roWh9ky2y6fcjeLDVT7qdE5EGM4fh3hdRxZhPx6t2rsT	127
9831	2vaa1QeeyrrKQFhP3CbFjij6H7yW3iv1GbFXSKvAB1Fz7Qj4LMTU	127
9833	2vaicyNnnrNsNzFcTgGZYdViJumx3FfetrymqWjzwW1KnmpWijTe	127
9834	2vbsxRFZKuZ8fJXpj65mqUAtw8APBGQBgK9TttUWLBWpVU2esDpG	127
9837	2vadWkS8mdoAB3dqKCpDPgtayRmUT1QMs2dXvnE5jMrs5eKYFuYB	127
9841	2vbeuKr2d8EFsT1NJrS8HB4Ed5fgynkJMkm8oHgaW3RstSKWQMCL	127
9842	2vc5WToHMxPcMsDgdo5NP9ijsLxbn2uTDDJGY2R6XigwyRLSXzH8	127
9845	2vboma2gH24wXCzh8zZLtPierwQvnTbmQnmJHQLeJpvDGNQ93Vj4	127
9854	2vagpB9wwN6P56jn524LkPC6MLcVhxqegwew7jy7CG3DqdTST7r3	127
9857	2vaoXrjZRmHfyuby4NdA9zTrvSpzNrfyku9DkcmLCTU3arHfRCZ9	127
9861	2vbS1JLbJfguwP2iKZkFr6hePLJjg8vnESM3X5JHLjDR6Cfb3az3	127
9865	2vbpfXopM8WjgB1nB3gu6rgcsCtcaM5aM1yc59ZJiCJj9rZAJFQ7	127
9868	2vbHY77Ui8Mfn22WBk6YjVDZzjoQZZJRyvh2f1W3NDZGTX9tR4SJ	127
9875	2vbjxFAGdLap6Qb9LDpm2CSKd6aUEaK4ayVe5EUuS7ib8vzqpvRp	127
9880	2vaAXjiyyYCRwKyTyYiAF5J7r2gHXsFma6HPXEAg86r1u38BYVZk	127
9885	2vbhAbdZnh88sDNAarWa6wLtfySvDqKRWCpfoK1NhqxTqNVKUbvY	127
9887	2vaKNvUD6bef7jxg64DNURgaV35jjPGumu33rN35fzEKLWALqNT6	127
9895	2vaSu7B9ZK7L9CCgn1LmrX71KZxdusXQCESV2ieNruvtHyCoKTuU	127
9896	2vbpAa8jnf8xyubmoVrDXfDHZtUmgBbLTQNnKuEhk4RwnduDLDun	127
9902	2vaPzGi3kfF2Sz7z66sjho9Jbd6XeEDMkmBZQxrHoihknquzpUQ6	127
9905	2vbXCFgEELrgeznanoYqoqazV4rhgq1vnLo2VR9N13jiYP1eiNg6	127
9907	2vaRmxagwwMuY4zeVKmVqRNeCcSD9ZexM8mGm3mzTjerYucBuomc	127
9917	2vaHWaCw4fZSJnecmbZnjydcZcjwQwkwD3pw2mZY3jnjrA1msDra	127
9921	2vbyKoCZbGAvc23YjysZJDhvMfUVzhuZF8d7kk4bqGvNWXRkkUEk	127
9924	2vbh6CwNmmygbzkxBW7acdjuMwqb2aSYV6JSD2kYsWe14hP5k9JQ	127
9927	2vc4xDxYVSiLofmbDPxn4mHiENixDnfXwiMKz3ngBVAmNfP9ZbcF	127
9929	2vbUo3jviJkTM3U3UdB9sHSwb3UNf98jFZ6XRd4zTjeguZ7uP4CR	127
9933	2vc5FXqLaah9Jsm6obC5Xzshp1g3PQoBfzT495Q8KNMG3F1dCPw4	127
9935	2vbc45dNyhXHnqbMfwYoAFUSNE8GajrHf6gGE6tMyvCYzKMR4qCg	127
9936	2vbhoiJ8bptVGwboFCyQphmbXWMAxQrDDpL6eKqgKTgYwzukxZXr	127
9940	2vbcQBgF24WUkgSDMMPRUPyFCEZVta9W4ehqiJQ3j38gKUfdRbwY	127
9949	2vbzg77MhJur3qCLbEEH3DzEv87UpJkobnXe3kTBYGdsFrBWW48t	127
9950	2vbY5wkVy6hokrR82UnqrRtYJWoSvb5JvYu2drFYSNe7REYK6onu	127
9957	2vb4doV1DNKanHYywPwhw4yLdau1wtGxuKaWq89aDmwG43CyAeD5	127
9960	2vaSpcNtpib5Ed3AqbXPctVMj12rfRac2hnnN3nQSfJFU4f7RffP	127
9964	2vb8rDZxMkTsjRThD6cbteXzSMVzDQsJjLuKY64iYGm3S8RTeDk1	127
9967	2vb35AtDFc7h7wNdkdNbC5ojijHDCr9zP78scmAete1pspwGrHPT	127
9973	2vbUzV9QKhdn7NumBQLPB2Q2rnmxiVSHkiY3QmFS2qQr7Am1V6k9	127
9980	2vbD37bLLYbjnXMV3FJNnAKrrfsp947AS1V4RDeL2vAtCFFQS1AC	127
9983	2vbfDXxThuHH98wyaahs6pC9xkJ7aV7C2A2STHaPnmXfhdV4krDR	127
9987	2vbMT1Y1cBLdX7bMo5cqEcGj876qL6XwJDcGc8vfbGAauKPcR8Dt	127
9992	2vaKZqtVqoMefKsjcysQjqVXda8nYDkiPYDtNxn73KCEjqwfJgAj	127
9993	2vb11CFpaDbTaBots4HADRaJMC1WDP2xNgAQLD6GBgsF1F4fkUTF	127
9998	2vaGUiZZY97U31w67Gqh2Vut2RztNYbzMq6H1k6A8DpJMQnUgFCd	127
10003	2vbT5eWt6A2ra345oJqTTi83k5noucnhMEwK3kLfQwkbbH4ADDPS	127
10007	2vaBVLSoHQG5hYNQ8eLSPziKFPQs9wN8gscDyBDngY1zERhcyhZP	127
10015	2vc4ZpvCFRwbbqw9Bet8EKy7Ce2wnbDJSZQDXfqDoYHC3SAuHgju	127
10017	2vbF9ZMumNWyZnBQjmdC2ZkCVgEeuu3NcvoWS42jVVkRehWku9SG	127
10018	2vaaPp3p4w7p3YUwpxPx4fRJh9WQmmxh2MWmgPCNhuXY64Y5yfcW	127
10022	2vaxFVDQnpeBp1imxLsryYK5EJtWD2Juq7y6dE5WNeFTmzuXG7eq	127
10026	2vbWcnWzAaLYVZBC29TVpGikEuYbKK2j1D9rb1zJUyu7eQH31MfD	127
10033	2vbqUo2nZbVHwR6Gs8KwVcHBvuGon6pFS34bzqWDE7GZ4DYiUqcH	127
10034	2vbb4xpNozDfXnKoMXh8e1ZNhBnnqxJxCWR5f21v8FRPM7HpRc1X	127
9705	2vbyjUj2iN6HCtEGqPjv5ezRt946SutgB62Sbjm9QhMQGzEoUZHy	127
9707	2vaq3DQQEy3nhLCC1tx1DKaEn7gnwwiaGcFT7GJ8no5TN1AJhwaJ	127
9708	2vabXwRfakZj5SkMqm1U3TbKB8wZXM8D93UWHpnFKsZ15LQ3NnFZ	127
9711	2vborxL48z5GeY8ef27QVzDpdemDnvr4ojWaVVyJdC6VU3FMbx9K	127
9714	2vbcLm2Q2f9SjqcgakoBjLrPGGyjCeHh8SjTt8jidMMhzbTht8jE	127
9718	2vbUJ8HupK6cLAuz7tegWERBQMkSxC2CSzJMYuU1PxmCsDLE5qnf	127
9721	2vaYMnkqnoLTKFqk9DU7Ekt5oJJse5naMSgzQBV5Tkj9E8d6QqS4	127
9725	2vb61f9FeHExrkmBsn1bT3HrCsf1mX9bzewsjTaLMWaqHRiyYVqx	127
9726	2vawRKSekLYrcUjbmscmmKTczrWaTU8NbrDzq1CdqPDUdcmnvVT7	127
9733	2vasMD6hpPBdaMHoupQSPzVZfGjxcF9Ead2y2fBaxFoHMZkpbJTi	127
9734	2vbh9QYUFhNbDbRcBC9sMr6vRMMMW2TGpBnLHhAjTYixSbrMJN8W	127
9737	2vayp5ocy2NdFLykVgkzBdENZeTqEWwUKYHnTMs39SL6AgDLoYDd	127
9744	2vb75dDuhnVnJ9fAtte2HiQ8XSHZc3KV4gjTmvDTYMTcRDjaddfX	127
9750	2vb2qo7eh5fHx8rb831DBu7zjL8bqGCeENLy37xroZi9X2atF9uG	127
9755	2vap3qyEzxHuXrW2UjCjABVDFHAnhBYojSvK51zhFGp3tQ6oZMMN	127
9757	2vaqeDD2JXBkz9cZTdiLMz9WGVGwb8rsfSntfLzAn3ueNC2zSQ4X	127
9759	2vabNKfT4bJLgfwppiKwg3WjUGiEqpSRLE64sN8xjAT4vbTHLNxG	127
9764	2vaPEhGdNWKu61DSmdKuFTrHAaHiTRMa8V4JkjiXGpGPzZLMZXha	127
9767	2vaTCBUkCcwHqBj873MbZ8R5RAZtLxB7vGismsS49uzUQLZjZp3d	127
9770	2vafLB3cp28Zkxc6L4XFZKCs1hWNY7n1F1iJmCr4hAvZdvucqi6R	127
9772	2vbbVjGPUQPxJtdvghQQBz13NdVPZNFukd544bY3AtTnEsHAhoDf	127
9775	2vaa2nvy8Nn7qAnGRo8hMK6Xq8MsH4mqeSW7rZbzn51Bhz69Wah6	127
9779	2vam9QDjYm9fHHkV4A8pnSYvVfty2Zfhc2QtUuj64fC84Ke55kYq	127
9784	2vafAsiBQEg1XaXWKLQqrGY56oFVyfCAhX7ksfKXt82MwP3jutqa	127
9787	2vbFJrE6wjYeVmtwtFPpt1KiJBs1rhXy4uXVnBzMwRr9nSFxJZCX	127
9792	2vbpGuJ3PvuydHLtGdD3kgUw9RNDQ7gfeeC8D2ZLL2ZwfeNT23fX	127
9798	2vaYGCGu7LqftKj8eUMR3sFT1TWseDFUHww3FUGeGm9SoynTKuR1	127
9802	2vbHLvWXCLd8mQdbjNcrGoWUgt6N38zqaBkwmUw4imbJUrmMU833	127
9814	2vc3Lrpnasfa91HL96nMQfFtG7bQt1RYADWY5HLrkgcqKrXipdVr	127
9816	2vaT4JocjfMzbDv9oozHdmqRhLV6ME7ayDstg5uKSD4jmG5DbgkB	127
9824	2vaSn6jauvVWQa7TjbWtBidFJt77zPJPZxFjHFS1trorcfqK1znV	127
9829	2vayCbcefsqXCAUeBRP9gZUXPKaoGgcvFxPqk7MkzHfofgoqbWmL	127
9843	2vaD8BYGqJFDViwb9a18z1wK7NS9d3aLn5YQt5ebMe41HieuKuQc	127
9846	2vaymYenF3gujkkeBQ2j1diZU5KnZYbNgxsC1ypirFeoxZNmTE31	127
9849	2vbCkxuBRWG28AdiWBVS3uKMNH8G2YHWfZD3qE9ZRTmFAXSyQU5m	127
9852	2vb1PpMgDgxzeZq6HZqqLhe6qfTcy91ZE9y8WqJaFxFt9UhpNcr7	127
9860	2vb6VCT1kP56uNVhEaNkHpcTTDeGBmEswW3K3ft6hYSW9i7fBVa9	127
9862	2vbEzPRDABFtt8EeDTsq8NtYcUQ4WeKdEYaeQw24tKtCZfCMHSKq	127
9863	2vbR1KDbBLJeyttT884bAvHputP4A2B21B33zfB2V7PenJTY9A7f	127
9869	2varyJ2EEBqniQoSk9iE2em6SopLRQ7nft1uyQ2c68uPkvqcSLMp	127
9872	2vaAUVnCLqMcYQ1EVaXvdgJCzt97zP4vJEoG8Ksn7tCEEVHwpGE1	127
9873	2vagLTZgrKWqqshSzmuHTLmeAbSKsK9RXCFaJ7AWC1A3mFfyG429	127
9877	2vaYn19Aqsb9jfgZbV2ox76pFgs99KV3EF798BmVNWF1WUSRqVCk	127
9883	2vaY4g5zizC6a9DJzLV43cVGdbPyR6Tw9hpgZDcmdXXFqVH7ucJi	127
9888	2vaF8vNRt6Kky3kfz8JbfLbL2BXVvqwAsb6qxsf3AqSpvf9S7VAC	127
9890	2vb7QZz4i4UpcmeG6uQYudrekUc2BqMsEPq2NrhJz5mqgne9zsRJ	127
9893	2vb1Q7L3oRiGxpgX8aQGo3t6p5zZqK8d2CHwr99AtCk8FgywX59H	127
9900	2vb8WM1oqhck8K8f7jZLXiy4bNnpPM3wgm7wGSXNaCXW4Kz2nMww	127
9903	2vbdUnrB1irC2mnq56zwrwQp6fqaXfjxcY3s4PVZfaug86KS3mjB	127
9908	2vatiggGRZiqrNx7vk9cAXzvsUVWbPbXM5KcY2nuw4ssVJen5qMA	127
9911	2vbhW3W8xdFFuWE4Gez3XHSPP3kJR4a4cmm5atfv9R9cVqmcG9wH	127
9914	2vbJtgP6ZqiTg5W19Srsmd797oedh4xKhSz9LtVWNvpSYNHo74CW	127
9918	2vavAoQcjtHDycTnWJqHkKeoeQU1zTf6WMm1foqCvDBwnVyasiJj	127
9919	2vbVJsvQSGoaD1AXipa78GYderB3xygnwgZP1cgtCEHLtREoK85C	127
9922	2vaoTjM3wDdsyk3t8kfdwdRH4vbK8YU12d1hnoRB3ibudQ5BQ1bi	127
9930	2vbsEqgNBQNXdpSczbcJ8b17r8JPRJxtSb2YJXZhzNG6BeLTG9EP	127
9932	2vaKAbo5SzUuUpREvhVXEpTJQx2E1grZdyBreTRUKfHw1XWQaYLY	127
9934	2vbZTqVbbfN8GzC1iaiM51wtBdgPxiuqrgyRM1uvXQu3sxeutwMF	127
9937	2vaiWA1WYVPBSsT1cU9dTUu18GiykHWv6SY2yhQ15ynvDwUKLpNm	127
9941	2vac6agxmEFxZtFNyG2xppjddrTjeN4LcdK58Gcs3MFEfyfmyzU7	127
9951	2vbKfrkirTRk43PM4KDtnvdLmQjrNDsvShGJRQG4yqqJECSVDBqp	127
9952	2vb9c8c7XgYx1HaJzBWhHJypisaUjsgDGCFRaZfe2EEeYzfLE2uz	127
9956	2vbE1imLxDUW28seUjfkoSKeZKPAoETC42EKyFxqKT9EHAkFcPwT	127
9958	2vbtz9V7KqS7FJrgUXjDCBJ6qKkthDbiKMap2WGFmjjESq3Eea55	127
9962	2vbMJjLben1XuDjUJCrs1ennQsKtEFNpDuwQyy2yr3RF7znJiicW	127
9974	2vbzm5rx1iVqTZrqY8zndMPv5T2gCBr31YaGqWfP3s64481pkmNy	127
9978	2vb4nWW2oj352TjSUV3ygSmG2UMvjhWoeXhUQhJBGntw3P7dmgmB	127
9981	2vaRhooeaeNzrMffta32kd317qWgS2h2tt7LtgTSojjRBEPngWZm	127
9984	2vbuVq8oMfw1yLbgban4R3N29XhBNmcahyRt799N9eSAkVexYgZC	127
9989	2vbXh1UzmFbDTv3RgygAb9gqg94B5pkfK5fmX8y3Nipqo7w4qsN7	127
9996	2vaBYR1EQcxffUFZt1EvY4gbXRMimHqYyZW8N7wixR7tKha4dgmE	127
10000	2vbPPzmLmcHThx49sRPfFrrcYWPUhCVNhYyi8H98zdTAk2rCKRNa	127
10001	2vamTBAv6KhoKfmFDLakQHCtLa1sXyf5Q4Vs2aMLBa4Y2J3havFK	127
10008	2vbF2tqUyFd5gR4dYaCWu2aaYKoTQw7ZvtoECcK8Lb6cWdXFs78o	127
10010	2vahDktHSzMf83HS45XZ58dQVuyyfCC5F2P8xt8tpYctYZBPGx3W	127
10019	2vb7qa4RD4fVrCDN1urEnzvtXeGhmZaQwg43uecvMvmfZ3JEBbnZ	127
10021	2vbcdsWMSvoKWj8Wv7A4dS9yUq1dhLhAvkgGqmyTiqc9BwE8KR1v	127
10027	2vbcXT14itfruXpoygF4yveQKYVbuhphEypLwkFxrT4Fek6mKLzU	127
10029	2vbrp7Y7rGgac7DHawQTaV3KCkfDAKxqTcXf8dZP4YSv3cmRcrHS	127
10031	2vbP5TUHTB2HYkAwkp9d5Ht3JKeUGgup9L4NzWey6QQrJXwVEjbv	127
10038	2vbwvZKQ4pFNrRQp3hVUwRRRs3F6p76CEuyiTMSe3t1iFBNGJj46	127
10040	2varQTSgdPmRzbXRJSWiKEyLdEvu1BTUdzMGhJZZb4CBWWz4ggA2	127
10043	2vbogApfMYGJDqtX6JwTCQpfcK3URXJwCVJkCyVZCMW9kLnQXnmV	127
10048	2vaj56a5QGRKpCcJm4EGq9YSx247qR9aKxPnk7bfhzxMXA6nQHsM	127
10050	2vbtdoYoZCTyTpq6pWV8o7kVPm4TynHJw2DVqc6fQ1gmBds9CyNq	127
10056	2vaLAGRrJ8NzhhQNNLyYHyffAvkBToQgVGNLkWBtHwjTQ863SRK5	127
10057	2vbu6pVTLcxm1tPcXfRTEKJf4edy11nt5WoZF12iRwL4S97JhuPU	127
10060	2vaycLumkWF5khYJkhsy6QBxpxNyt8pV4K97c5SDxLT5jHgwhETD	127
9722	2vbcwbijcFpHWaiCDuADhQgby4J5YbzNZVHyC3ZbRVTcYhRvLYKm	127
9724	2vaCkrKxhWNaMxTDTha9XbGy6Fj1AP39zvzPRyWysX8DN8TaSF5o	127
9727	2vaPzJr4b8NixneJbcQKXi5Y34mhHeHSTxwt4zbRHKLcAWcPBNn2	127
9728	2vbzX7owwBE2D5Tc2RrBrv8QUtCoueBZXDiGcTcKHdNw4Q7wNVCA	127
9735	2vaxFF4MksfR52r1ZDdu6ihQKf4i7kDAtVd7fqcrCaHKcjQHaqEY	127
9738	2vaFaotn2HGLyri25BiH28jAWa6ZSKdxxYoQgxjcF9aK6ob6AL4u	127
9740	2vbTDig2fSTsXkWcgZ35CXx92FB4bouSJFU91C7Yd9DgThoqu5C3	127
9742	2vaa59NnMrisWi9Q7A9j1A4qxPnB8tpnDGupjgVZr7CwTkDJzu3V	127
9745	2vaFUuyDwVNb7GJJiAzraub4M5GZJPat21ttdZkXCWNTrLwH9vhv	127
9747	2vc2xQRT4cne8ZKGphVzDnH4T9EU73a9TBCEv8kJufzsSz7G4VVr	127
9751	2vah9CopKt76D8shdkXkANpjDSyMZZhKhMe8L4YC5mA1q6MX3Dob	127
9753	2vadrucivLcuFVgABodi8g7FZnu68MhMcR1ogmCXwY6NiRUzAe3Q	127
9761	2vbEcZcA3g41wWGKbckJi2j3fM1ZF1aPdS285pLccQxJ7dcQELRo	127
9765	2vbXf5KtP4Wfv2FXj9byD9HCJ66tuESAHtSoGzewGzjACUTQVpJk	127
9776	2vbnqrEThVrqEFTHHw5yAt7KQjtVXeDfmW9bcPyZwcLXmmLKHx5r	127
9785	2vbSaAbKTn228afVpKWXWqBAmRb3DsVHofiRnKRTGYDZohA3kK9j	127
9788	2vaEupe2FviVarKouo95VWdAsFgUfT7iAuB3wgghBr7ZHQ4ofK1C	127
9793	2vbncmktUdinBAKjrx9ht83Kfu5j9zrGu3xYnmhPqga3mLCdL66D	127
9796	2vb253MZ4kkSzGJiQWsVib54xq2MAxrxWMVeeSZGv2f8iSQ2V4zP	127
9799	2vab7TGhQNT77wZUxezqmfDpWRXJPmdXcz52WeWhWgSvkz9YEGEh	127
9805	2vbj4uqWmSd9oZmGAT7fFLTioMCNP9zPoH6WLySdShvo1KHUbdYF	127
9807	2vbsvBDPpQ51MGriM1wsYf4KVqWaBnP4QPVPjodAn38KcddXPomf	127
9817	2vbregdFUkFceDSPnjpbwL4uuS3K2co8S8Gtzxw12xNwNQDgxLoc	127
9819	2vatc7VmihAteXL3haVc32pn2Z6BWcvi8GTgcEpSo7qZysTnS6Ty	127
9822	2vafdoAiQhcePwgKaEBKuCh18gPbSRqSXsdkGHysV8k8b7RMHLyF	127
9826	2vajqkuzfFQnpmu4guBF3G7ptXXrw1izjnxya6KQJVJ6VSiAG353	127
9830	2vazD7sVpRkfD82ypXfsmxyZuosv6AykamSZuN2Fgkux4JhwAMWH	127
9832	2vab8jPFQSouyPcg9DETiWYANtSKypsEaVRRQimj1y1tMbVxQpqa	127
9836	2vacducxRcznArniaf1HLeMnZBHb5bQs1ufoaozqPavWLQSxKz1m	127
9839	2vadCS8RF1Dhi1dv9oXr764FJGGbuovhAqvorzENtVH3byUoCP5q	127
9840	2vaGB5BrfHv1WyHtbjcee8kpdmtV6i8xkcRQJfuiit2ycUAAxv4C	127
9847	2vaxfk3XaqE52GPkfxdjtQFYGZ47LbDKDe4tnvGXNuHMnaVLVJso	127
9848	2vaBLSKyunRmVzabpmKbhgHQ1sZihW7LrpBPS98XyoDJrU1Uy25b	127
9851	2vaQYM5FZHCj4CW82kYXGN8LH2Z6vTdesBzzJ5QPKnermJLP9uhR	127
9856	2vb6zkf6jqw1cQS7yMuXSKv2cL4CQcHjabH21EFL8QMi7hLGPZx4	127
9859	2vabRKVjCh3HtLGGDU6iqz9kMNeEeLB2qREZRroktdsaZ5MfzJua	127
9867	2vb8GzPUT4zcy7j1L89n3btiA8LYctpZA1epuGEuxUmUMfkgL77q	127
9871	2vaYugnxSXh4N19zr9H1zp9j8rQZfHSPkESYSgn7FJSrd2nFcFU8	127
9876	2vaibxzN6f7xyRQjPQxT7sJHeKCa1ct55K1tjPbr9h2Vp6bUmzpi	127
9879	2vaZiyMm8JvDXuasmMS3MFzf9NcW9PrWyytypdxAtj7EEh2ucu2e	127
9882	2vbZc4evgVjszZ1LNZ7MBn6aVqCH6hTTYY5fs4Xq9RHWGhTJMm6J	127
9889	2vbFeL4M6iLnVGCQua3HqVeiDbwZXZyAJfBvvgpR6onA77oj9ZDj	127
9892	2vbFeTWweJupfXRseCASftapjRip7kg6KZZhvCvm1pnZKiDxA2UK	127
9894	2vaYoCC46pmro7qxQEqFYch2n6aEWnYicbsVastPErmpG4ZP5VpD	127
9899	2vasvEb8iEZ3owmQWE41UVAGkFSB5AVB24Uae6RtSReJJsTN2HY1	127
9901	2vbQZc2SYzBScMZkzoSQGfg6wDdSAGVDfQYYysDijbBugsZA1c7g	127
9904	2vb2Tyoahzw11rJNWy58UxhCatpzsvGFfcUScjNZQR4XtkMMyg9C	127
9909	2vbBR6nrPC4XCnQeESvMjCTxjLrhzW2qUZgXrE2rsotNeafBUCj3	127
9910	2vbdent9THKx31Aw7yy6V9oe89vsmsGwmr9LETczkNqhr8B9NqL6	127
9913	2vayueqRNe9DxirKLFH12N1SG3BKfSdgvz21QCGkcznLxn7t2eLE	127
9916	2vc4KtqijE6WokbhcAcxSsVNLxuxasainhPbDZrPboHZAHrVC4uY	127
9926	2vaDtynKfPdQGa2sqNnsxKNVBdbhZwXJKVZ26C2yMKYdKoK8NnAm	127
9939	2vbBhrMZ6uj3eUAPKji1DTwvQYPBmscxRq1qfF63yvnZppYchN4s	127
9943	2vbW6yRb7SUi2LBsWYWN1yeAkjL9thzQPKWGsH2sWgvNgNm5Jf3p	127
9947	2vaKGBzjbUZhbQaic3gxLRAioizwWutveFirDh6esEsG6nBdsDCZ	127
9948	2vbpa2ucqzEtzxxdy3DrjNcu5Kb6bdCQezSCh9p9ysGvfNMq3XWf	127
9954	2vapDwwD96SzShtWzZYi2Q2x7AdCmEcDbvQvXnCMfzfiFMPX8ht4	127
9955	2vaUreHSPWzz2YEELtFzbSgHc213Bm1UKwi3Nvn1C992ricn3ryc	127
9961	2vbfJx2tiC1etuUxf1mjEEF3v1KaxtQnzuXDDCXgJwfE14Fp6EAE	127
9963	2vb35H2mb5CgU85WAJfUomYtY8efAKfgRpPwMHpKXKQHqCo8ThFH	127
9966	2vaKaX9k4ue66WQyT4535B9XLJ4FzGaAnfqWgGShYLonDgc5Lmmb	127
9968	2vaVveXgg3ZuQFtrupMQS4XkHpH8x2jgqBug6VQFu1xM1fUoaVud	127
9970	2vahEKMz3Gbu8tKB8FPq1TwCG2RuA7uy81Dbmz4yRUJXmp2KoUYo	127
9976	2vbEEkL8VW6GxmzjDj5PEaxxhdbMDx2AhJfnx2kwWigUbRwN8avS	127
9977	2vbYvnjRKUA8ugaoQpdAEv182dPxX3mve64V5b2iXpzGbzN4Vck8	127
9982	2vaPWimSCEehfjYwqpcVv1umXAZzZy4rfPriTxpvXnagvQnEtjYV	127
9990	2vbFMw815oh6tNEy6VpmXeVi9V1fGnhSA1RW75MFuShkk2SLMTAc	127
9991	2vbYCqN64Z393v9vFQYEsTQdCZVnktMJKnD3DMGtT1nwYhwyzCiM	127
9995	2vbGDmSSC9nn3twRNS7g7GoznKL7d7JWopmvKpKyfu6ts8WiNL64	127
9997	2vaeecJQbv5x9tMiVVtz1ULR5B9xjJXb6Ajp8BAp8Tb6JXpMda5G	127
9999	2vb5zJzSddAosuB3vo7owNQiuVEszQEN5cq2rfHXXGhUMFkxvJfo	127
10002	2vbRxRKTRHyhxBryifNuhnjAzPhZWsisTipjVCC4Tx91pJYnBZRM	127
10005	2vbnCgHombS6ZrVWaZacaJ7TBQhjEkb9qp9NrVELACVKB9Gw3YFy	127
10006	2vb86ueeUkn1TwDzvjSZGBA5nFFczLGiyTbHRdNMcrkvB1UJ7Pf9	127
10012	2vbzYnDLynXnBKUJ2g5C3kZJp3m6CdxdxmfXbnRGnfirGCDqWuDZ	127
10014	2vbEz4HEQXkiXd9BPtARVFbQ5t9Won78Wjk5gSheH8nahBMFukvw	127
10024	2vbHq5MJ3owo1ycnUa6Fqhqagr6r4yquS8Aj2BfBoLHHShUnxE3w	127
10037	2vbzYFQALDJR58PvYVUAMp1BxoaQqWhrRq66jwF7zfGGaUYgFN1D	127
10042	2vahguvPQ2WwdMmNGWtbdcWyvDzKswxXR199Wfnr35p3FaJSv1mD	127
10045	2vaYVTMfD6JsSCooJ42Mu5z6d8HQFr9XF7AD2rzq7xxYH7LusKsQ	127
10047	2vaVww81UZ4XghC6NpEBJ56fB1RxUgkLYhTsDBfTaPN53JKpAoqQ	127
10049	2vakvv1GeTVLvgv7XiC2RU7AX6FVPDNm3S3tCzsKLbuyBFbHq1gK	127
10053	2vb38TqvWSo7wTg93n4cbJxh8Y6pyTmVbqrWUfPNa7Hwd5qvjduU	127
10055	2vbsp57NnuB4Cg5tDX1WDaSjTxMp7Xw4oZKdoQD2LMpNxeRvqBgf	127
10059	2vbg9tQ3HhenuzTDRB2rYvf6DQMK4kA25d2vgUfJy8r3HKbmx4m8	127
10066	2vappWiGqxJbyQvexe6WWhDAUR4eu6g7UXXgVsPqkru7mKbxnD53	127
10068	2vbK3JEZiLMgB6mCQ7g2r441EkKM1EpVUWFp5LfBSjmjXmtbuPY2	127
10074	2vbXmVbHkMRKUx2Z85xvWozEPXrzxJonmQFGhMQkDYqTvau4DGFT	127
9771	2vaWgQuz7bjmbJDjEtYwhjFAJPSFfe22gyaRULrggSMkYFEL8FUs	127
9773	2vbhymANXDBZG1yavnZToKyuwF99LLT1eKfym9vtx2uHdB1ZtxN2	127
9777	2vaVSpu71sWroZj27f6UTkCk3HuTwsmANMfaBz6svs8ndEC668JB	127
9780	2vbFLhshTZ8KDkvbetitTvbYwhLtS5Nvg1P326FxGof7dvq5hYy6	127
9781	2vbDGVgJZUxF94nywMmBsADMtWEpZjoK7G3KSLXN8JaQJWtfZ36o	127
9783	2vbv4xgXSMd5ttXS9hkPM2xe2ns8bkqrmW6pCH2D47x3V3VdVhWR	127
9789	2vc1rmmLUNpt3phwYbU35yaz4NA8qQYSAKuipygbWwRHSTJMM4Hq	127
9790	2vandPyEeRdxi1zcXDtjaZcf6am163VdMJYy1eyYgiajfnQHzfUR	127
9794	2vaAYCSD1LZ2sD1WMeZ7TUzKsBNtAVYSB4c46Hck1x2jbJCpnA7L	127
9797	2vabXmnojiTYfTCNJiPKhFwEfxSz9zX6L7d2cSf3VCguDw7tQ1xh	127
9800	2vambVeox18xP2id8jnucGYgxGejax7MQufRBWkY1z3ETFoSrYAs	127
9803	2vbcfyYvasWYFF23S5wxUbsQUdcviNpYfTs9UACstAvsAENSTigP	127
9808	2vaUybYyDz9ubGdt6FbGH9ab3EQ8XzPDyKHFzkpV3mfLCNuTpkQT	127
9810	2vbPsbvGtGoLMohnzmcBASpjzEaZjfjPhJ8Xw7SbN5HrCU6zrDwB	127
9812	2vbAfEBKdReSVVr5h7pqyrS1bYQFb1mj1kjcdcBYkgwDhfj1FAFt	127
9820	2vaUbr554AZzqcupbnoPFxxi7CYmKFvaqR3WcVzcebSGbvN64mKa	127
9821	2vbWgXrmuQarQgZnjUV4mUSDiLb64AucWgptDE8ANQJchArdQdKy	127
9823	2vb8Sn2GLvU17nokAs5T76Qfi5UEXuk4q7C4sw6mzLfDCVSDFoWm	127
9825	2vaL9ZT4jCJAmnVbHEqnN66Kzf7URbnSS2cWdc2wGriX3L5aqcv2	127
9827	2vbPrHi9g5oFFk1P46XbWXkAYMwwZsoKp1QEvnN6LUxh344PZ7JH	127
9835	2vbQy7wXAP8yQxhhYgj6Q5k5a8JX39X3tvsfb5gxMrSXD5bGx1ek	127
9838	2vaoShSTX8ewVfsoCQWU3JeetshCKB9Pc87K4zo1hrCweuo5ZxpG	127
9844	2vbG5GfAbkAiry2hPFdCfQZmAu6PuFEJqa4jCK7ipKaT7H5K7Hjq	127
9850	2vbWXp1ysqtx85eimEV6SNYq37z5UQznUq5EZY1BSVw3CKY49Ekm	127
9853	2vb8GvuWxzWqiggpo2rfvAchZJBifqhYtf4KUbr3Q67R939u9bKM	127
9855	2vb74idX9E9r4brwesbc3L55dCPPFbKJrrq17dbVYSjAcTqs4TUe	127
9858	2vbZ18G5n4yuhkf9rD3ENqTUpJ2iLAy2C2nK31eFGsrCaUU3ojim	127
9864	2vbcMb3MPfWVEn74GLxcDYGHzGTMCW3PKhqRdCrXJeMFKMF6N2mK	127
9866	2vaF58zXY9qjmkzzFxEewXtab5caXmnvaLL6Z5ZJnezite5wgkVa	127
9870	2vap82vgw1rVHVdJ5c8qTeSq4GGPKSPwbj2jVPrRbJRMLNDWkJLB	127
9874	2vaZFu9FnnsAdJ3Xeh8heW2tNeg9p9JoPUYYA6FybCbamPbft7Qc	127
9878	2vbJAG8xuwebScJhbnJUP7FBVaLdUrA9aRUV2t99vSoz4kund3wa	127
9881	2vahf2AN6y18MJ3CzfyDEXrum37mz8NLwjX8Fyi7S9dNhY5YyihD	127
9884	2vbfYmdqkRjgcFVhiZutCbq7c83nK9dpq5YRmBoJAyDw8usUNYvW	127
9886	2vaNnSWYMrR8F6ja8fYiyG4nmGxYfCjnkRNN8J2Tqkt3kX3s4RfV	127
9891	2vanJFrJgMDpntahNJk94VonSCq9Jwx7PpG1YstATq2soPEn7SCr	127
9897	2vbQhmhJBrobPNXA7K8UkhdNtzHe7Bw93567qh5ruDHT3nhD6KGa	127
9898	2vbbqX8TZ1v2gjmEMN4rkCLx7gM33iLHthgAcE9eTD1kaVdXZ8Pa	127
9906	2vaAtUKVcLoBxeemuYwzjJNCow17nY6shKQQka8LVdKsUmYZVJAL	127
9912	2vbUJqx2cUsULsLVmr3jf4u1ZWxCLwH58A819hM4GhpeY7ZbyGrx	127
9915	2vb9KRhQKjyK9wrdtUynaxwTTrxrpCrnFgE1TTVZNq4i3yBmAVY2	127
9920	2vaUPyxyXbBAF5x7gqD697YYSCGLQutEpguzgbtejHvS8P7A9jUa	127
9923	2vbbJ9AzRZRvCHNxLTesvz7rQtdLf59VKzv92yaWq3cZ1jqfbrDW	127
9925	2vagSxb6gmYpVEg8jScyK7cgsJBQbbHa5UrCSm1Vju2yDZEW5Pju	127
9928	2vbpnVcbMxk21W4Xp2ej24uzPN9YsYhBN2Y5u5bsZfGkSgJtCk1j	127
9931	2vaXed5sHgA6k1fEx21zaWfRUmovUPtGJWUEg9eDVRVoHGn8orJj	127
9938	2vbRSuPSZRsVpk2meuJUg5gZJCQp7BfoJTFGmFpFcabdgsFM7NRK	127
9942	2vbCVD7E1gTReH4mkAmWi7Lt34tDpzqvogJbMM8XKqfDcG5NEYvb	127
9944	2vbppB8M6UJTDUFmBMwFUnV3oy89EqUp5vRbpFBwfpwRcPEFj8t4	127
9945	2vbFhwiKNN6kX5PxUX7oVh54ob1ZfKsafxJFybdKQcFFtR2WVqYY	127
9946	2vbqro2VQEJyzZoyzjizNBQSsjQCDKCAuFybBU47rcw7xwjwzbre	127
9953	2vawtwxrDot4iXJQX7XDHpE9F3CRWSqBVP8hweKqjPC7PJFXkTN7	127
9959	2vbAKJoDUYQHhwxfzphEHYy7ZhQQhwbpZMpqsb9jLATQ7NQKZZKX	127
9965	2vaZumhtxD65AyWuJpnNhGiFzMLDSrcwPy982TEe4hB2VZsFnKPc	127
9969	2vaWE4vpih59DnhsmeqxiGrrETu1E6AeuQAyQBD5o83dnNs8eMYJ	127
9971	2vaXUKbmqwAtKXTusZPZJ89VUYgjs2WMupVvnXqovn8GpWEDvt4P	127
9972	2vane3Dx4HHVd73yqzcPJm2nHUjLvK4osVzqzF8qB9DfmveqEjsZ	127
9975	2vbPvKPEyrNVBJHoLQLFSv2tc9QNhJUd7Q1s9jH1PgppN5CfxvuH	127
9979	2vbUmFNVwfrgxeoHguV15GtWr2MCrQ6BFdt1a7aaxMTBAeQxR5nt	127
9985	2vb9Gyue8uUhtTzCk8K8CTTVzeaoEtVkWneGteBun72xLA7oopcM	127
9986	2vbM85gnD2BUdemGZ3nCkLyW7fWE3BrqMVezg5FwkAq55fhBEHLa	127
9988	2vb8GCkLQ1XX5JUxym8KttBB5gZf1Y2KMgFqSLPuu6bEVHRAutS2	127
9994	2vbYpSyHpck9YpD5mqromX8BD7pevazf9MQAyWurpbBSGRMszifZ	127
10004	2vaUteirfuEhEzLsJb2HmmfiaCdLdBPuyqyEZYinZGF9HhzEcBKJ	127
10009	2vaP2GQuRwy8gYDVT7DtNtbzcqnuPSeULmJ2wGGr33ekrijfT8bM	127
10011	2vbTHNA8iHzinc5CdC1UNbFzcmuraG2wrnVewFb1ckqHsx2s9XfX	127
10013	2vaN5kCfjKF1TofH3QiQrvid9zpURN7f3TAAH6umRiKFLdgKyKVh	127
10016	2vazwDf6oG1wBVRZpavyL1xgbJ8CbN8HY2bV8eZH33QGyG6TiPwk	127
10020	2vay6JyBEg5Hjic5bPAXb5EZc519VzQATqXgw9FiQFH33F3SBcTG	127
10023	2vbRuJFp4jh4WedTTHmqgDaQj3XPzKioMY5Fordxutn3UdssLotj	127
10025	2vbrkwF6sQ1qhP8jB8Y5C1HNGeB8me2VmVUF8brcYXJYmEhSRHFc	127
10028	2vc26jUjfddGVV8vqLQ98b68ubFTL9i4eZqRxhzobN7VvhHYJMw6	127
10030	2vakTKxDBNemtMGwjK11c1zNqZUi2EZwyHvATp6s9f2DGnoFkDNj	127
10032	2vb3BydjvE6zcrVT8H69mY5sruLtJrnnQ4QEutNEQwRHV3XuXfab	127
10035	2vb3z4mpY7gLDZKF5pdzqG63jkGGrrmBxubdjzqroBkXtpdHPWM2	127
10039	2vafE2qz2W6aqp7VxhvNBTAGDbiSUdp2ER1jwBtBB7Mhn2F1m3Fw	127
10044	2vaFh89hCcwumdbRiWuoDafdzNL7hDPDWWVbwoZh3rqjeAs1YwHW	127
10052	2vbygsweLd9vT1ERHYHUa2Vnz9BZqQMHErDCz7cH4BLwPZpVTLRy	127
10054	2vb4WwuJezHm9Yz2uTWkxHTKgNHCX9ChLgFE8pr2S5gUZPrbyaqA	127
10064	2vbi7cJy79qxxuLmZcnttooBYARF53ZDDHDVSaXFEPeTmbVp9e9s	127
10065	2vaExCDd415avPQ2anKoej3ZHgYKTjtqVQdQ9Tqx2onMDxiNtinF	127
10077	2vaeb7FsiTFiNUhZ9es4vdtXcMwsBw6QDMUfUB73QmVZxa1tADWe	127
10090	2vbMPjqJsTxfyjeJJHfoaSrMxSFCovZFGMtwfraKuiELRvL9G74C	127
10094	2vaqo9smL6HKYdvNrw3nAUSuSU6xzHRbjk5Sf4UagqZi7AQjRWxu	127
10096	2vaCwdsQhSXiWJk5x3V52gcDKSRK4y8K5U135CLut91UCmFYRJhK	127
10102	2vbRQg7n4Wwey44KPJEjM38bfFKWZDD87UfxJ2vh1vKtc9J8N4Zz	127
10103	2vbcW7658GyucQu8hpqAsH9veXqd3bWBHSQCtxVa4PQNsj7DpGMW	127
10106	2vbWvCX5yP43DmkTMdVssko6tEaWbVavGbUQpoHJxzJf1a7JCouX	127
10036	2vbzdBTCebfDpehjPXNZdjo9pK4gcPVHArmzXqBvpLUhcqTzyvkz	127
10041	2vawk985t83y7evYiMrVJVcQKdxCL6at3HqnK2SLUr4GcNZmzcKP	127
10046	2vbvVaxEWAU8z2f9nsonCtvN6TKAQrEFBh9i59d4pAtuJ3ir3UDQ	127
10051	2vaSFX9PMPRUdi6Y2YaMqAdoCJvdz8juqaEBevoA2aaf5SjiP2gH	127
10058	2vbnmnNra73qpiKdVW2LRS6qqzTKSDd7MoK1mhqPUjNTPnCKdJXb	127
10061	2vbNkVcWu6sMD56Sz3nXaQv6mRvJThZr6tckHXhRPwaKZj7Ar7ed	127
10063	2vadYvoRsT1XoYjiVABPwPM8KWXDmnCnZ1ykBLcoNdTKS9gi891Q	127
10067	2vbuVdreRP6bhP2Erq2ZRMrnFpHi1dn9wjBnqa2174hvETtuw3cH	127
10070	2vaYj1bKTwRw24KdXS61F65v4uxfhErjFVmWi2WHzz3HwdtAgBdG	127
10073	2vbAFgiqLTbxyoExXJgsiu4PzTzrfYvWJ8AG7UUCTxFgQAax5Fuc	127
10076	2vbLiMDU5pnGEKpVTTS5uRdNSJX7TXqm2Ki8WKPK5scEVo2qohAQ	127
10079	2vb33P96LWgfxTv2rLhoxcDi7JWGAPLFtpNwkSzkHKQWB3G1VGBN	127
10081	2vbiRhUhoh1k883WJTpSqP4HQgjGQ4vszdwDBTcNnMmBGbdkhUhL	127
10085	2vbgJXhu7QRvEShWtvR3XcsMYXtvwnxu3wKpM1kSGaTPg9scEMrL	127
10088	2vbt4wmq1yxsFxcP9T7FsSD9qR3mgBXHRcdHpyvfLgct28oG15rr	127
10089	2vbLq7dwdYjnWrTVkGtSu9dehCVXQcy9cLgoeMKLkMYKRaf5JMan	127
10093	2vb3nPSDYxcbxAcE2nUSevSM55jD8nmMhaCUP4qLtB4B8XA6nHNN	127
10098	2vbdTYUN7SU3A9zWxx3y7a8ZvZHyfQE12k8QtDhFKLxvspuL7819	127
10100	2vbM9s83Xp1GMo4kpN1ZfwZ1XCGkoRqYa2W6bxoUANccC1TYoq8v	127
10101	2vbvsLe3dvZ3WJN8Tej9ruun78DJKnz2omaVTjFGY7mgamd8aZfE	127
10105	2vaBaH2UGKV3yEshEPXcoEEEg3FpMEZ5HxeN6sqDNv1qCgxZ5SLh	127
10112	2vbBkbir84knkqQGrdiuGzkPoa6gy2YUhGwNRoRBxzvFRJ1CKERX	127
10117	2vb7drPQBBUmsDWu6o9iPSMsdJWdDNeRWtg6kAbmUtd2ACvko5ke	127
10120	2vbnJ4q35xrX3k9ueXkdN2oYb2GfGdeLi6CP9V2APPDvyAgntTuu	127
10124	2vbTJeKvoD6yGNm9ByD9m2jrWyxMuHaFhmvydHcvq1W778GGN2M8	127
10132	2vaB1ENPSmr73TptKNodbjCbAEERpxA264AcSRG2YyisKQNTFfeu	127
10137	2vaKJdfuxLqtEyopk9NbsvGjVAqmfZ8Ym2CTn9MiTviqYKUK9CeQ	127
10141	2vb7dVTWse9dNh47NdCaY9RAU5cEfzQaZ9fvYvQYbYaKTLcM7asM	127
10142	2vbKhg12tU3n68rsnMf9g7ujBsPAbgBqwAk2VzJk2tdK8hintUMe	127
10145	2vbR31cATvNHeqadx36q7zrfP1vzjTPJGkVGWmQVkFPwkrv7Zs8L	127
10147	2vc2CnJ9KFbSqqF8c1Jy5HoBco1YwA4T79ULmenhWDhq9JhyHrUc	127
10157	2vaUG7dLfaN5wgeJmhGZBs8JBwJoJaLHr663oY3F5sS4LfiBNEiz	127
10165	2vaoBjQR3DTf9Lh5NnL9Zbyk9ViSHvLD3aMF48PPL7hJCm2sHcrP	127
10168	2vbsnt72VXsNsacjMSfnuseb4s9GWHqdujLH68Uex4zf1hrc6mWF	127
10173	2vaiQwT8hpjxAHEJbazJh6pExTGTixsZo9Bukc5dVwWVXZBReWLs	127
10175	2vbaGXMUrepjN2DVEoE3YxySft53ELFykmXekG97BcBEj5wZmk2f	127
10180	2vbmqJzn5UKkCojzjECAiqJQcw3TsE4oiHFkCs7awNNSVxitp8Yx	127
10184	2vbt6apfGZNkNEqVBC8miWVDXX82pjCW5QU4pnnVaXTUKf4hYUBa	127
10185	2vaqYazvk72UoSv2UEieTGXDxzKnYtCHGxHN6gVfkmQfvkxCc6ny	127
10194	2vbKzk7JeQGxgvBkiQgLjaCEm51vU8PmKdHhNwgy3Hd81u4R9kVW	127
10196	2vbpPNKJq6Jrg1TvfgPYidxMscwr97cKBvWeRPNQjPMxeYzMkDPM	127
10200	2vaUwTChmyUaRTzYnj1s38yxsFTfuE3NuQoR7DyAN7n3vckegb7x	127
10202	2vbJvSvC1RLpwiWyuZ3Lpu442JnevrNoFGyNYDu45vZwiX87DJAa	127
10203	2vb4oBvB8DXyfXGXNcyuWMGd2gDcbzpgysutywBw87wmzbMG5YV2	127
10207	2vc4ERU8PxUMCkZrXPMSBn4GjxHBtaDE3tXZCL8JR2EirwzJUZzW	127
10213	2vapG8FbK2DrsukJdyW3yznsWXjjvJkJpfNyyovCBnX6aN4X4eEk	127
10217	2vbdtdJsQWQWxXj98tVeaXaoHtBTFV49SLQTTeFyJaabY7cqASkG	127
10218	2vbmiXfUkcuYQhdHDqwPa1fDjbwJxxcPiNzKGajr6S81fgSrUXkY	127
10221	2vbJH5sLpiP2KsEpNMH11Sy2duDDbjguv3aUeSHmSL8bhrUfs1Ku	127
10226	2vahrWY5eacgNJCXTSkNLTspa1dcmV5J9DTv3QYcfFfmATJY4WMo	127
10229	2vafPAsnhhzvRFotA1YvbzfE8qvxe6z66eUjJ2NhRMYa1xo4tpPa	127
10232	2vaSnSZVFEEx5kEerzz4WMh3UoTs7h5rYoWTiVTUxHJ894e97YMm	127
10234	2vaFFzu7h6muKBJ4XApUc2c1qxZf51JHnKA5hK7SqNzo3tVpdvYK	127
10236	2vaFRWw23NHD7avqhn77WCLoFBC2wuN6d3ty2MvHTHsdsWFEg8Tx	127
10239	2vbcKSh4eXskLWGp8QJviYrwXv1yu44EEca8NbwKWdKMTMnGCDBC	127
10240	2vb98yvpbcZtHaFzBer2JBhTGPSkQHm5TH7t9jyG9ArvkgS3BJuc	127
10241	2vaQfNxYYcEc7RthVDQXYr6F1zQCbpmVd3n4ABwVJ2VTLa6QLPzQ	127
10246	2vbRUfcGTaAKbrFTq8ziqBmeS7zrdmRtikUJpKtobAUQ2VRHkMZU	127
10250	2vaYKWwzb3nfD5ZoBiTd26tTgTa4eGAy8pMrNXq4ZJsiZvaJPxaF	127
10254	2vbXxWSdDkKsQoKuYHzd4UcTVrv9wa2osuwLWrieB34FdqRFVgJe	127
10255	2vbiHqJcYdQoFYV7SMgm4fcNEEH1fNdBRti8nfmUhmHpAeo5FmBU	127
10260	2vavnzXpvmHkRdDmRgCw9PVdwKZYZYWt3vaCKRZvox33gsqMX79J	127
10261	2vaKTx2a7Mdi7QtBTH7deHerT8gsAwpx9zu68B6X36ptBboUJHfY	127
10266	2vaKsLRp2ah8mSkYnK63N8FoapxgTcNx4dp2dm4vZ4eFeJ4ZMzcb	127
10062	2vbrXLQD7PHUxTtCnDEt8s9JnZhFQudARhciuEMCJiFWALdnL7do	127
10069	2vaxqkhBP9rERpecYvexQTxdDM6LwiYXtq7TLmZcMjuqWpfWxCam	127
10071	2vaQiiML9eYHoXqc3C5Vd1E7s5RjJYmDwjMcbnyoqvTMx2BtfVFg	127
10072	2vbQbnRDqneLf3ZVKQV2rXf4hB5f6yLbw8wfqNcgfZMop5bkN6Pv	127
10075	2vaggESvTKbwiprGC5Bp4jF2SPCZ82CjBAm3bSquXgBcTn2WMXqr	127
10078	2vbWvrNncaszvAwDdDGZuttAPokRvmfswEXdcWZJAYayQHD68soi	127
10080	2vbYTKEUFrv7aXaRfLHPG2fRLKVrEcshGqktStcDm4nFzBQF2i2F	127
10082	2vavMGZzkQmBC9fAtkG12ePKKudsy9qSoSpZhzR2ckiCJMXVvXh6	127
10087	2vasdksuU4AtFp1q7S6ur8UoZVruYjJj5G14Cz7bLMcDYSJJqYan	127
10092	2vbxzRk8rQpTFoB18ZHkfVymuoZArSZeok9m3fbc1moFQmdoNFSK	127
10095	2vbqsMEZKSYBm8v1aepvqk3R3QFdshB6aYkx8jfPouWF9BNmfV8a	127
10097	2vaRrvLzhwg4HccYQ5L79gneijtvB66jA4oi5sAXM2sJDdqyqefp	127
10109	2vbVmjqr7KZMdJ4EaiCwwZHkx7N2CozSan4LvJo33YPA4cKTStfi	127
10114	2vbsU6Y59ycAg2dvBDijt6r22VP2XJnoD4evGfz5P8webvL15ZUB	127
10116	2vafE1EkLqnm34CEMWTVsLwQLbXp69AZ5JxfF6Tjumtzq7XvA5pJ	127
10118	2vbzzHvaJ3QGAx8t9BudimURhCoV34hrLWkgiUERoZeZCkhZ6vne	127
10123	2varV4RdjYPhsE91TJqMekmS2WkTC1Ag9yG2JkvvBeQbnDfHSZV4	127
10126	2vbpS5HyTHoLH6jwosW4Y2rF1rV1aUuZWjCAkKhE5Jn9dXtUzHsX	127
10129	2vbL5JUewa4QasJqhLcPL3J46vCqmWb9SH9USaCkhC5646dqLfxz	127
10140	2vawmgFvqcSQtLJfCrYKoa1gxuzU9cAuWAN78ay9vGwSq4isvkVD	127
10144	2vaBjzYN3n71FkCXP4tzYFTcjgMZcETfNLy4eP1GPAeVgtz78KRU	127
10149	2vaoWZHChrgQMQg793ywhKatRr8Tks45Lf841Vw9PG186yku6Cx5	127
10152	2vboJZJrupvwSPhhN2LRkLNazuQ7tT5uaY9L3Yfuzx7oPYViQJQv	127
10154	2vaYE7TNohMkrafuvnHvnqKqS83JnoMD5AvhyH1m2C2UY1EdKZPd	127
10155	2vaxQ6LcmpWn1pGAgx2eBeVPmwFq85JVwPZBVifQiD2pneZuu1M9	127
10159	2vaez5PVACcBKT7ZaCms15nBJc1wUsFxnGcwQLouBmL2y3jKL6nQ	127
10161	2vbbHyYGzynTL6sMFdSH6hhp92AHocZWtD4TAXT4DkvL7djCp94M	127
10162	2vc4c7AQMCyNfZZ95XEqMhbdz2Ei3KSguh8yDCjqMoS7cQwyhUqV	127
10164	2vbcRVBTCFd47WuBPi84Un7TGCTSvSBN52pBPMsKBjnnBo86S2Hc	127
10170	2vaZDTWhtEvL3KGKyYHUP5iNFPVSZdZNCFpuxdhrn3aR2efzBkUy	127
10177	2vbCQmW6fLbc4LxZzKoMCdQqxQ8ZiDW5NgNpvFrSy9uJbk9S1qtW	127
10179	2vb9Wk3u1eXFUjmp2qu1UgGqEEGxAHW1q1f71imsyNvfhgkrqL6U	127
10186	2vbmEtE4mgftN3Ktiv94Ey4VcYFQfsE1pgrcQcH3PrS6xaakdsmP	127
10190	2vbEAU5KTp5p1KBD1SNB1H8G5exV2MLnwmWhVY7WziyAYCvnFvnF	127
10191	2vaghMi7povuctqrT2nRjao6Mc9soxniCdJ3ipTcXSroKzHvE8p9	127
10198	2vbrKEqzvarNeNuF4pjwMdoXPTPSDNDuLgu2H2q4EyBQ5sjK6e2b	127
10199	2vaXYzrCwSvVxJRrPdee11SdzknCdpaz5sf1JPURsopGjEiTz9oC	127
10205	2vbNxwiy2g27VdqWgV6ZeiJetAK6cfNCVK7PGS2F9Spx9Zm5vcdS	127
10206	2vbpH6MF7unzW1yJ4UjVTa3NQuo1F1uhAZn3wdkuknY3NJ1UQtd4	127
10209	2vaNmiqe2tmBXHPcdeakrj1Nga9c3ZCfBpx1AzXRnjRsov3Kwt91	127
10214	2vbw9KR3MqGMTfKdn565GgJ5VJDaQCipAz9GJiwJpt2qzJ5veew2	127
10216	2vbMxgw8hWfUv61r86YbBm5ED6EctdhCPv2Y7nnwPE1RoQLrrRYA	127
10220	2vanFcLRoCrysR84TpCMDHo3HvX7aYGUvK6sVDPh3oNaJFWa9363	127
10222	2vbdVNoKWhqMtjLs4DzVczopJEHohXqx7PaHV2rV9Y1DvazWd5YF	127
10225	2vbTVjiVuetvR3eaGkpeNgSWFBN7k5ZcN3zVg6LEZteoFebBZ7yd	127
10231	2vc5XPzVmGHML3LG4XdHHst7nxtBr1rE4VhKErWXw6eMjEyFansd	127
10235	2vbxasqDZ8tiqH2ZSdtwmL2pczSouoU2fzRyhmL1W7amJNRRNSK7	127
10243	2vaipEtj7dkKHmFaGNwo3LqmPzGEwd1Qaq2dokUaAShFWDALzwPV	127
10249	2vagaHJtQ5SRhqxGBGt76bkrQkBpcJSrk9XVsdSqiMA2RJRNShAo	127
10253	2vae2eQZ8Ubg6JLn64v4W4MGZYhahUEM2qSyv79cPrjD5vpkJnJp	127
10257	2vbvAXJpd79cLQVTsek7SfuK6xc2bZtvv66JUu7qK46u19hCZtiQ	127
10265	2vbmGxPDUbansfGnxR3MkZBz44rZeyTjWddVAE9oKTD9QSDbFsMT	127
10083	2vbq7Nm4fpeTfNA6h4JYPFRE2A2sVsSKxgw1tc6KPR3tBuGyfJ54	127
10084	2vbDiBRgj6NzAyLerxeXDff794P5x4QQn5soCRkquYjua9NJ5QSG	127
10086	2vaiTfDfvf6qKFyimxN82tWHiXdp1tVQqSxXdJSoWHSuDZH6v4tT	127
10091	2vazzeN1xMtn85byuVE3vKsSVPukUEMs53AraSphFW4xbe4K8uzr	127
10099	2vaxNuh11qHzsrJzKWX1wgpGY9r4cuxCZbr7nFRkvxffj3NwXVdN	127
10104	2vbAmkEsVeSw5mkBN2HUk1QgkzL9c5wTgvHygNpU759hC9fNTTsw	127
10108	2vbUrR6deWDK2KtBGZshfWhSF8M87ZVyJu99FjjPi1sphduzdGvv	127
10111	2vb8jmxbWxVkipAu4xwpkAMaRKLQbdpndZJ22je8cBdtrdcLtWZh	127
10113	2vbMELqS1NkmfFFoKSU54MbfKAdNxKGDBe3cGaLFPyBCyJmAQeTi	127
10115	2vaniPjukb7Af1PonfxStrv5ssZx1P1vMcMXAa1gkLdQmS3Hd7zs	127
10119	2vaZh8e1ddQ6znBAMt28FN8h4RA6yER7VtYMhyXYZhF1mjemAheW	127
10121	2vasxN9M452sQiF9PRboi9NYbs2tbYMqQc1wC5WD7K3C9aQcsgTY	127
10128	2vbvSaNRFiaK7T8imXF9M2Kmv6dS5C3H68HaFNDm1M8ZFpfde8Ng	127
10133	2vbGGeSTVqc2kdeYN4MR1fLy5vZb14NXgKGnKLEovzy4ccigFjoN	127
10134	2vbz4whvkTzojSSWvBsKKpcP8HkeFGTz5hA5JjeMBi9g8H1ogVQw	127
10136	2vbQp1vv3cV8cxKDNQYbHCBN98dFwVKFufA3Zfe3uWF1EX713DPv	127
10138	2vaUbyXgRjE9rKxKN6bdq4f8mmb2dMFMdZPaXNxvYYLUXDgSCuTR	127
10143	2vbdXBTzAz2abSghQzcfMdapLBYrYc284aTpejzoRD8BWKHZJPZw	127
10146	2vbQ31pz4U8xrcefHnYSvkNKjsGGijX6HJ1r3qqkg4NDy2J1B3mA	127
10151	2vaVWFY24KRc8zSBw2eSJmd1oAWU3cJUZC6gLz2JfHpKVwqBSatb	127
10156	2vc39M5HTdcJhD7m3hiWZre6ESkFX4BbN8F9GzuXeZ2FmoymY6vF	127
10167	2vajddQFvQci3dvfDMVBYMdJFjaVPw8Xn2GvnJpzVUYw53s7Y8Km	127
10172	2vbP3zNvSRaDaXCFpBjxhtHRMmN5iowyfd3dED6wCmwcmpvUYvvX	127
10182	2vaDNPqm7urugRgvCp4KParV9v1JfYHHPcemKhDNo3qonmK3jF65	127
10188	2vb9HrymPsVucoqwPrSfAKFtYbJCgojF3B2FgdjKUF5Re5aBuzBU	127
10189	2vbXJegqL5mLxskx8ezDBodkayGwvgXeEAVAR3z7wyhMhsfFhNtX	127
10193	2vbXhHwPjk2JA5yN5febkiRFGCLpWxmhzYsM8q1vMpZxL3H1LhAn	127
10195	2vaydDjSdbQMAvrki3QUTbcku8KuoGv7ftb3Z9xjDF2xW2GRW6VZ	127
10204	2vbwN4ay7bA4W8r5MkWn7DJKjkTuH93hdLtj2nukoWUT9SsJ7s6m	127
10208	2vbXchcTJv97UwRapXgLAhwyG8zkPDab1brvV9XPKM5jwMLLpDLW	127
10212	2vbfRzguTrqsVcZ4FE4csVijSzeD8ubcDyUsU1CrpSZNvwXn1JeZ	127
10224	2vak14R7WCTRFGFw5neh2hMxp8e9KMgHsdRbFnjmFCyawuHF9EjA	127
10227	2vbwrsF8c8PXEDKfNC6UiPSXwFp2VTAePV6dEraAQv9LU1VGUjTm	127
10228	2vaJw1K6krHSxQ9MMpyGYjegGwAks5Dd5GKgAxKKmd3RFgpsFPbN	127
10233	2vbsHPReNYbGRrWbUywf15JS7qVdtRfY4ZYz7P6NhBdZWv6LabZQ	127
10238	2vbESjyfPi9Qw1sThi3vbEWZq4qUNxeu1ADwLN4dj5XWq9MzWtcT	127
10242	2vaBixboBCBPXXkvxW6Qt7BiSPPqy6jdssj1sD3aBTekRCB8HHxK	127
10247	2vb1TEmck3WD35UX7uCjMS3PKcUy2NkBHBjHQF1DMLcaBdwB6jTw	127
10248	2vbzV2TdNeuFEjPGDBsjuKpzFUcvxRfpG8cxXLtobkgFfeu5mamW	127
10252	2vbHtwJ85KrLm8FdGDrL4BEUcY5nD3GRKPURkyW2sCPhQPGZe3u7	127
10256	2vb1WdkmspbSKPjDwbmu1oJK3jPzWXnt4FoVRWe4a6rb9hbxN9EH	127
10259	2vbRWCBpayibTcjDCVvdLwwCVahAHN412m1rja9jyUmDtjhH1fYm	127
10263	2vbtT7BTkGVq4KWcuD1HnahgJJsgALSzRnPxPNToLA2T1gKhMKTP	127
10107	2vaREyuktY7EPnYNoAY4noxa1pTrY5GWzS1enqXkmQirLVPs9Nhf	127
10110	2varZMRnJ3TQSRu21VzdFnqJz4C79gNFHj25JLYakoip3BXmWNhx	127
10122	2vb22jnbArSroDKDze1v7Hth9gzhbYakDLH57xDnUBVP6qH3x6EM	127
10125	2vahxaG1dJmbfi3QGkcUrCKMSjgy2XfjLM9uDNPSFoKAVoj1un2L	127
10127	2vafoqBFfcSeGCWwL6Ww2nXfyWFeEwMN5NCW9Z6VRmvUKGDRBoWw	127
10130	2vaEg4ATKGZSXCfpPNh8Nk9L21nyKd7646ebZJYLez62JTEBfgiG	127
10131	2vc2K6H4Mm4LU6b4QSaW96VoQDZe3QEi1gPUpgoDfDJwBQTaKp2d	127
10135	2vaa3giVVZVQaabnLcC54d9VYKHAfYLT9CzUtcRvhnZHW3E3mvmq	127
10139	2vaEZBXUpHfgpR8LhCJuGSwtrM3GLGoVGCgGsrUPypVoFgyvozoo	127
10148	2vbMf5at6EaCiiUE96UxtqAcZk7M9jUSFcd91S9b9cYFrAVmPqcD	127
10150	2vayorg8zzJckyBs8bKDhNcufUW8M5ER7H3CDk4FRB2DWw1tXdge	127
10153	2vaU9Cw9CYgCpxnTEzEYTYuuhDV2SjCs11wvxSDKt4wXhk2x7uXw	127
10158	2vacpYty6TqGdPCMVhGszsd6M6VuaJ6LkYiNUNDVPpjxatZ5v7VV	127
10160	2vbiiRJgD7hkRzHGmMvjVZyXNc3yyxosweUPsG118TR9PWoy2Tck	127
10163	2vadqwTGAKu9mryJBkxgmtzS5xdNEnNohDmGHzK7jpd4iPjPsM2h	127
10166	2vbeZQ9Ggg2vGYJxNZveswz2fsokBvJBGQjqM1FX7bpckXsXvGhi	127
10169	2vaqFrGTBEY5X4VsNMEUuiqBXG5e419MApecJbz9rRKng89mak8Y	127
10171	2vazu84eoPJ43KBx6fi5teyWHh7n3rsKkj3c5ykQ2bgpX9BuVC5z	127
10174	2vbb6Kfswzm3qwycpg3rtCjPtHfw9zrisLCVh9iLk3oqTdL3wgeJ	127
10176	2vaTTPkFeiiUUspDcrvSTpV6LDWVBiEHdAHc4T8ZDVzRuDeGG7Ja	127
10178	2vbe26MZberaXB7b666tPH9q1NNbUzFoWgcTpgWNBrqXuzqE9wES	127
10181	2vaZ2cjHqhWLe9AFYfVA8kwMLQ9fcucwDDMBgvZroycxE935sCTW	127
10183	2vaKtrFYjeG6HCDVdFvqo5XkmKTfaVFaSyWbMDEwe8rBG3gq4PmC	127
10187	2vc3CkdAhDDCkZASTUetNmLQkcs7afi6fFD4GmW2x2o22TiBmobs	127
10192	2vaVgwyVmHBzqwYQ4CMiQsphRwgDXnpaDZwgrzSSXEvvre6VW9Qx	127
10197	2vaSRtrmzhGJ6NLq1rLvexUHvGgDZfFU23T8wypzcPPqHpTjVF9n	127
10201	2vbwTUBsifbF354HZW789i24oK3ZjE8JFWoL2yg5RYQbNHwPigwo	127
10210	2vb6bJXc5Qp6jE2AcUa34wCJRGUp6gKZoL7kCDsHoBSpQXq8JogT	127
10211	2vb3kdmWSCfjtiG3EPS1Vr5sfiLAQUNRMTtGBRx8L3B9SHbvwGJ4	127
10215	2vaaaP15cC848hr2SUn5oUndLQBsHpLjErHC8Xfk3JT9EiUByaLB	127
10219	2vahkzKHkipREjtbAxXw25uXL5r6JH8Kq5Xb2LkbrSLnUKgEgegu	127
10223	2vahTPr71Zt7hFfBxsWLm8NiAFxjh51z8MJf5hgU8N3zuTc4Emc7	127
10230	2vbvptbuqmJQEWLB67HaUKmhfPvbRW4pgNgdZHP875qVaXCArGwL	127
10237	2vbcJ8Lckg9x9yAHVMGT5ub9EvUkFwuKvFM6xerPNwBqGAfznEfv	127
10244	2vabCYt43kaHpHxV3sUBjxjrhMDS9x1gEATXSQ7wCtbWzhK9ZWVs	127
10245	2vb2CVZXSZ6ameVWegSKkGEQoTcw8YswxsnVzxgQmVGJRuMpkCo8	127
10251	2vbifAWaabjT5wEFNWbBB3EWvAw1JkAkoPMqsdCiR7iL5UVPjpn3	127
10258	2vbM7yN9kuw1QG8c3mHfskgavDfQPhnSWrrdmitcU45sxsuggHcE	127
10262	2vbyAdLtyGNmFVu4ANm14Vjs7JCsXq9q5gUXW2eXbtwi5ZZEyz8k	127
10264	2vbj66RxknyRyv98JVBHrAiaPaqLVrAYExhZKa3PYeBXs3Yz5d7J	127
10267	2vbscGz8QQYFUxn3j66XWZMnG5w2tfsYXJaWFsWeEfKGnU7LyWd4	127
10268	2vaCS3RY7nbdYE43qygd5yvomQ3hEHkEcWp7pJDgYVSCp5CQfC79	127
10269	2vbwXwLkwMZcULp42aVX7Eee1TvrxounXJynSJKcjannfi35un9c	127
10270	2vauG1HyYN32fMxuxgRT2nLuRuJNvnEXJXJVizmPtU9h2rbYegun	127
10271	2vak47GxbJLUAbqJ4NCLvMtBDUGaht2EotTu21VC6XyAK76CJbgV	127
10272	2vaVdGr5akfJCQPMAMDqYTwonkmNzFJfc9rg9HX56PkGdeb3fbuV	127
10273	2vbYBwaYoTbZbbEGqWSxdZHcXRwPMyvrNijcjcBir5E4VWc2q7Rf	127
10274	2vaQiBHxc3GSiQCEE6sniWfbqfXfvZtG2AdUTwZY5Qym4e4Sdq6t	127
10275	2vafdi5frddDBRSF8xnwnyswJUZXpT7vHGWSFSTtAo5QY6yAdopj	127
10276	2vbUo8yKeKLCPSTcDcmNM21xvophmgWLCNtHrRunNivck8XhoYZy	127
10277	2vaHXdc5k5XSwJsKKGxqY3dSe1Bx5mUPeBbcU7PLYx73zXV4X4v8	127
10278	2vaRMZZEFLVTJJyTFLHjBqQ9DGCFqYqKgxc98SmQ4F9MwU4nLNjo	127
10279	2vb4gLeZNkZB4nCed9tEtqiGYN5cETGiRXxynzcyiRS3HYwhNyKr	127
10280	2vbTnxrvTvgZ4VPGBX1mddk7eeK5vQtvtrzExwPh37jjTEDnimET	127
10281	2vaGnF9ZNsnMfUPM6ZxJwGA4gKmsMJZ6cDVgxGfAbVzLjmN1WoqL	127
10282	2vc5cSFNckFYVRHdvo1ELGtmkd44kcJzgWzZAxLzjiuLdBExHnS8	127
10283	2vakH49dVrgU7HzTEMnW4C7YAAtPubGzbr4jZkdPqmfo8zKsa68a	127
10284	2vb62QHvHR8b6hF5XbwfoQ6JhakAc82xGoyKp7suXXNKoQ9S9AwY	127
10285	2vash7DqH3Az3UoTbzuexWUV91Sg9vgSf3DN1VYci1XzfmxaeNx1	127
10286	2vbuwYCPwmW5KifPADvMjRVetKZhGqnDRS9Gkp1bwoJUoEjxbbYJ	127
10287	2vbLhqL7wtimU28TKUri4XeNJzguXD33QgLrrpjwxqHuTQ8popgV	127
10288	2vaUX5m4kB1MqFJAd57JoLpoYhU6mzQSP6V3Ev3WnenTdWKaTUXR	127
10289	2vbVnPxtnUQ2uP4NRBaRYaPY3UfCPy5oGjDejYWS2porYcNvdP78	127
10290	2vaEn9zCgReZgLFoK3GGNFsD1bpT5Jz8oyiHmsqwP8Rfo47LE2ps	127
10291	2vaictHpTDj71te7Gj3sFcgUb4qWsGGv6SBnjq9a9XpuwndNgocG	127
10292	2vaAWUddqnYhj9m9xVxAxNg55Skvf3cSTXNtV47jJYz6KxWsjuoH	127
10293	2vbeecp18RaHhVphxfQqCK2UpZg2faQoSnuBR7aLKEPjh6TH2dop	127
10294	2vbDarogRPiGHkB4C1aT9eRyMcbsZrGPm29Y1r51oz19URNRCkyc	127
10295	2vbR2KUh113MAn5uWFcQGPWkWAwnZkc24Jofkasg8WfwJxMVh2tD	127
10296	2vad7JR66TM1mufjJyT8hrzyWGjiPnyJGhNA7mYg6njoQbYR2wnk	127
10297	2vaCb4GiZHLoSUs3zFNoPC6hV3QuySfekWvtBXdTHCoHrYTTc5oc	127
10298	2vbZtx5rGGdXFRvDF5cMgyowahGs8DYmwwZB8NeJTu9VZcedgt2z	127
10299	2vbQyAhJ1sw6WdYc1m7bsGPpGTdPgpsE4Mdymxc2b5GSns4fgiv5	127
10300	2vaqDHXYYN5qRySDneoRGzEA3DTu2gWretsP8n9WN1goUqj5Q1rY	127
10301	2vbnkJDz4BE99tmDTra81pBAYK8FDKKwjJA9vrw2ZGnhELQyJvcr	127
10302	2vb6UcZXghvqKaZBrpSVmcxUhL5jxSGjWuZzegAYaXckRr9mKWeo	127
10303	2va9Cbm3dUeVBWJsfU4A24zBHqsY3nzmx6ezHjMzEMU6Cp3KKx1B	127
10304	2vbSpQfSG2JTkPS9ECnqEVhGaXFRfDZUYczYnzdPY63vkmEuiPRF	127
10305	2vbNsf57e8prQCYdD5tHRQkmYHiNdMgvHNeCKHkvuW5oi6Y6m9pH	127
10306	2vbomdizbjPcZsLF3ayACtfwzxDyUm1ogEqMikgcLbhuLwAHJW2d	127
10307	2vb51qp3yZVknArKuHcX7ZayYPghyzbsQi6RYdg2Xmtb4ya5o2cZ	127
10308	2vb3cQ85MoPUxubbEW5GUkY5nvbX5RzTdJ7nxNdubMHwjKzro9kA	127
10309	2vaHeGARnMNwQKR7fJtZ5Pobvu5fPSZixDdsqPNM1mtfSaY3YX7W	127
10310	2vap22xPZ2guxBeHrzWd2rLBLXN97TtYouPJrDTNYdxvUDngDTRr	127
10311	2vaPzs9cqC4dX8tvs1ooCi36FZFquK9P7FBzdUdEub2kzyaxFf7f	127
10312	2vbQkvo5YDHmLSs7D6Jf6VAs6vrWUUkLPeqw3boSVu4iTTUVP4J5	127
10313	2vbom5puzwRTHUsSc5z5CdNwgdZQvoU43kyDTLQ6bkAAFWQtuZsZ	127
10314	2vaApiEFUUJKNyC8JSBDo7U7PNVBMfgiHXtGj2BNeXZzX6jsaMZy	127
10315	2vbVkW1sStjucbVTqTXMgn2ozDJ8Ko1MgJiftsraksUTvWiov99c	127
10316	2vaUQT14VQFA4j2R9RV6aK7YtVfVEpN55skA1N9APy3ptG2t8TAJ	127
10321	2vbd5busrJj4TyYsngwd2f5U848NK1bpei9VDoMLMBtVzauGUsEm	127
10323	2vaNFvougnLA2dfdSxR6tmn6QHp8uBRqwwSATytb2EVvrYDtciEx	127
10327	2vbfUHJbD7SSz41hnMPFczaAobsXoVTwHGxfcf9AgJmKFPqn3e37	127
10331	2vbHXfEnyyBj4LZqcZAumT8NdpsawHGEK5V2ri9C4fzuZ6oUEBQq	127
10332	2vbyoKr89jDEpQYQaBcM3r3GURA2eDiMC1Aqbq1Fo2KK2m3mrkUA	127
10335	2vax8zhRFyDGcTJ2GWfc16tydeKy16kdyqRNRQ95cEJTmGgnsusg	127
10337	2vaJLzznrgdAS5aoKWcjDnCkwYJP4fbCf43TEPrjAFQwKDGDi5hS	127
10342	2vaLzeAY8mvqAU3cMQpxoL5iMyXqoJYrKo24yfESEdqKqqMzWj4S	127
10345	2vbMXhYKmGKxkHskwkqU8kcLFkJvgvSJE21ZNT9KCptvXv498psw	127
10350	2vbA3ydi7WvkUrUASKnkFM1qPDbtdfxSFMAk9rQEnUjK3g5xt54e	127
10352	2vaRbe68R5XDVNU56htAwrjMfDD3CNgQSBhU8Vd3ATux6HwrSQEH	127
10355	2vaRK6kvjwnmcpchqEC9qLdMDKm7HRa1oLgg2Wh8ynBY97syCKUi	127
10356	2vaRrpJHS3VKDbVVFBYRpPFeqN1gXmeC5BPA65Y5cLGmDBwuXGy4	127
10358	2vbS8CDZCpeFEfuQXHABzfmwqoTk2TiJYUNUukksP1kbppj6Bkns	127
10361	2vba5yJsrUeg2e6XkFNMrHdMkQ3iQfhCnsjggJ8ow3a8naukTshD	127
10366	2vaD5gHouaaX8XJ2CWraKApLmTicf7TH6kvooE9YYFMsjaS8Q9Gg	127
10368	2vaFuc5mFAf9HZCqpDg3vU1ijgcxEttGBCQd5ygq9EkE3ABamgco	127
10371	2vbth5XSchcsCKA5aUUvGLdvXCKP5EPRE8Aaju6qkKo7RDzwpZgV	127
10380	2vaX839t4zoYJx8ySyrdjBJhixcd5CSAdHxCWWv2Z1MR92QDoNax	127
10387	2vbPoJMPptRfbXa3N7GLsSdTkeoWKxapUxCQXxctjpXYc5Bv8cDL	127
10390	2vbxGyXf1ScDrVoYnbsWfGoyPqkdzEWaiAACDnjgFq6oqjmKd1EG	127
10392	2vbzb2hAVPwi3DEUH5azzchVj2vcdKqdXiCxJC9MmFdxpkgmkzBL	127
10394	2vautNjBNXnELG29t5pxtiitr4phdBmSyHZTQpajzJSnKdU1d5qs	127
10398	2vaRb8y9pkZ2a6r9SXVpSU3Umw37MeLgaFL6sAzWRdgXpVJrw3Ju	127
10400	2vamSV74oEC6aHdumUUTpKWuxKLmwNeokeTiKyyRm2tecWw15Zy9	127
10402	2vajhbh9d6UFJTj4rrNhcBrohSusyYyDSnQ2tNqsp7A43KVpWJEB	127
10404	2vaTwYN8P5vXEvJrAXvfKdxfvj53mthdLp8iiyopdsid6PJuFzwZ	127
10415	2vbCqrmNhZTufi5N62H7qAZCzMJPwduqyNhSujVFPf5aQxvJbN3W	127
10418	2vadJt2dgqrB35EPWxSJ5pZcXAcHakedijm6zm3TvSSr6Mbp8Da7	127
10420	2vaMZxYtxg1od88LD6jGLJSNxtZyxKS8HbcVrQQRBXU62dZboUGH	127
10425	2vbkyJjRPiD2FArKG3L1z7dfEEtuvt6NhTKnwQZhvyF4XvNPnYuE	127
10437	2vbqKCENnZGT4x8psy9E53kjU9NunGu9msBa3U9q5VDjHPpECT9N	127
10439	2vbBRDVswGHr2XLZ1RcFQPYbgrbxnfP26US5hBE1XqhzkqQSCs4r	127
10443	2vbt9ZaLNHvL2qu71Y4yKqNpyzGVe9EDHJW7NYaGG75DoqVBDkJM	127
10446	2vbfJ7XtKvQkxychoUwyvMeMJro4PM2xr6CRQAHPxCQb1XpZid2u	127
10464	2vasjkre1yd6sA764TKW1jZXABr1oQi4vqyRY5XHEvTg4nrgfEdW	127
10466	2vc2MpNMrtoWSdtMvNm36ha7dK4M7jn89aNexhpMydv1ufELpfXM	127
10468	2vbhcvdBSHHKBG8U7FV9iGZTqQR2sNniKmrVTTaYByoWkQMf7ujt	127
10472	2vacNo3EtDRo52rEdzuUQSyXPsnFbPg5D9xKZ5eMCsrMFpzJvcQQ	127
10474	2vangTU53DH862WSTEC5SrhLhK6oJ3HXbvksEMSkZcXUhYPvcznB	127
10476	2vaFdnpo9g2MsgXAoNfeDp6WgUumeR5bHF39ueefv5fqqRovm4pd	127
10479	2vam8X28FtNkYR7d3A4XswdonD7vM7N3VLcjmUhX5PEmJv9XTQv5	127
10482	2vaS7DsHpGeABg5Vv1d96L6T2KdpfChvzUkGMthPqfy3t1gnLeFc	127
10488	2vb2fmPq4p6Sw7JGWwgL6uufGRdT4ufCAMhgaPEDaggZD3dddwgC	127
10490	2vbV4W7m9zni7cpUFANeY1zZHg8TuFiSY5D4vZRYjbhZ5oB6yxpy	127
10493	2vabe9Jdfg1vkAQDsYeUkTNLwfrwD6Dc9otueQMnsjgtjcwenAEf	127
10495	2vbbizEQxtnWkyMjLA4NJnTSZSYbhjvqg6GszLg56US5P2HVyueR	127
10496	2vbNqaZuHgm1g6ECz4CqMUUJqDu84bpmbDLtz2oWoy4kaNYDwJnA	127
10499	2vabDCCigeFXpMqwNdjLEpcDm6zL3f8s9Na92DvKnHc8f1GzM6MG	127
10501	2vc5gS5XcmbGCRaTjKdn4fuogwNkz5Unv5M8Ai34zXahotpNHHyP	127
10506	2vbo6vPn4y1bMV9HdB8PLiPst8nyBaSg8JhbeV4Ja9bAyshdWrJy	127
10510	2vadsj7p3nF8oSkuPDFxSqjvupNSwKuC44YVy3inoaDaFuP1jBpv	127
10520	2vbj1cAQE1SLqNL5av5CkmoB5MXhjuFkVjEEgou4yM7tYjBjkQJu	127
10526	2vaqRBFb6T5MQzyJDkzqJyBG9JdrwAyxEB1jKWm7xZ4yeVNvdut5	127
10527	2varig7u3or68qtGcSc1tboWUBTjDBhxrqEp8MephVnpqJWc1bmC	127
10532	2vaCq14EtP9HjDEYDGhzoyedaFVvTHY7jtiapSDM5nUzR1ZJBLAi	127
10534	2vb2HcAnLSFPreVkDmZsTrvL7Kt8hCAwkha8EgUyjMt1hF9eckha	127
10537	2vb7yEbtgWtEKYUoxQAbDSd3GGWbcawQXY1azoXqEjBKNb97fXjR	127
10539	2vbedwYpcfYd5v1jQiHELb1Fh5JbPx2pFgKv4iNNykff3ohn2mm5	127
10544	2vbpT2ELZ7Y1xt7qLz8ZnNK3EYNgdC51JorfVMXhdsaUXvrjC943	127
10546	2vbkKAkrgRA1Jan1X6hWHFqVPKrTbeJDQ4f1GBHPACF4XQnAEMfS	127
10549	2vbA39kqT5xDA4MyYzKvYoTmxL4MpgHUFyxJPeDXytgnTNAKNUFS	127
10551	2vbFT9paKaXFGfWTXp4s1JHmT7Fnb4TKzgwgrQMmdPCUbV7Pf8XC	127
10554	2vagUke1oU7gccMTEznumohNPDzxYCDF92b4tEv6L9pDSUyJkzkQ	127
10556	2vaYFUhaLN84B3XheSEBDduR4LxvGpcp6ZW5fW3YCHX1cKsPB3p7	127
10561	2vbUwoVaRzXDF5YKCi8HwNMfqSfQEFeUYyWgTvbUz81odCD6BiFT	127
10567	2vadWAwHeeCQnSFqv6LgcJSpgJiMBkkKbtBszFkAN8M5v3jdfKVs	127
10569	2vbdxidoFAhJwqdPCVY5vv7QEU3j6cdURWHJZ59nRDST8dhbtYkz	127
10572	2vaKNbmKL4qDGFj6LdXe1vpXjbR4AdWG11pTHHSsqJcnXRuZN6EF	127
10579	2vaxzpc3RbHcVLyjjM5Q6hGHWfFb3dmwUDV94XRUkCzttSFVqrLA	127
10584	2vb9vfGrV15dZFyq9ivYJyZtViWvAysjwxxhAc3jzAC6Ehg5fvxj	127
10587	2vaYHLftg1bS26JeLL5QaS5ainFVYSdT8LFWFrqR4EK6LXZF4pwT	127
10589	2vaNZrYLBD6sVAWpFGrcd9ZRCEGRBzzQ1RL2PVFxVfYSZav4epUu	127
10591	2vaAiR1LXpfQMmFFW4gXRcCdtbFXn4d3ZVc9cYkQehe6K2Un5Smg	127
10599	2vbeYiguWKra8HG4vqNCaPfyRk1JHdxtrSAGMUD2VU9uCK2BYrPo	127
10602	2vaKt2VCPvYoS51q49CpxqKx1Gqb8iy7dqHBHef2vzGjpzMCQp9Q	127
10607	2vabkrBwANvKtsbVGGknBXEEtn7odtUeLAUtv6Deq5WtHSdSdV1K	127
10610	2vatpVmT7tEqFpVJLrFPhHX1aYUUkXAh25pxwVCC3giv6NF51Sgw	127
10619	2vbrM4De8bkP9U2aNk7JjLGvBxAVTGuTjnaFV6nB4qFTyYrLjeZW	127
10628	2vaKoxWorxAYdAa9MaG3naqzL24uAJUmXuL3NecAN7BmXmnZ5Hdh	127
10630	2vanhnh9rjHbzhGACuE5rv1JW7a4zmCi5TThaG9q2TVdPLf3vBRC	127
10635	2vaUePJW4EuGtYP7S9qkxEoR67K4b4qJianuRTzYiq6iFG981wkQ	127
10638	2vbiV9ydXcXRMPWoJ3b4avzHbsDtj7Z15HED14Dp8fwrJAMKvfMc	127
10644	2vbLKUXsmtCxYobYv2GqWNQxYkLv3o9Fps9sBVdxgUEYf7pHRVj6	127
10651	2vb6kr2KKA1rPtZspteQnAg5vdZUPK7ZEPFR9ceeGQ1WewhRmXiA	127
10653	2vaxXgkyqKKe89zZJinP6NeS8duCFgG1G4H7AJNgsYBwxQN6oCxN	127
10317	2vbnRjWHodC5VjNoutxufvdRn74y45egvcAzyqHkuVzv5rPCz93t	127
10319	2vbeS2rq9nMSeTHKnva2pX39VvH8815dfTR6ixqoKYBjnsMfLeXk	127
10322	2vaEVYz4o5MdEyvheGg8WMGh9cpSPSXkCKjYFn3AgSSkiVvLHp1T	127
10325	2vaCUJBdvAVWptZDLdtUufptdHUzhaMiQKMGQGeRzhUYxwZ52Rfo	127
10328	2vbwtC95hGK4brpZwAm18U3wP6vgrWzrCRNsgWz718jT1jeSHsSi	127
10333	2vbLxXProrwRugkce9sFwfwAkUNVWS2b52uUdE4K8HDUBvPy9tWb	127
10336	2vaJCdnfBuNGRaNEJyCEQiwiHhtfHCMPcEMHjEXtPgCJmPxTxuDJ	127
10338	2vb1fBKHwoeqaFbkuz2rANZKsv6xa8iukr9FsqwNQSiceCuVcrZv	127
10340	2vbZsQuxLNi6bLFmhvTzo8NsNVFipNmQb21bpNvvULQe2PzuMNiN	127
10343	2vbHF5D8oApqM7pccsfYvdgVyiJ4bvXPUm7wQmRJCznykd7QeKyA	127
10346	2vbv8ExvW9LhTJKLgMdSxDGbb9CTvDvVgFhN6yVaWTPH8wTFnXXn	127
10353	2vbMKkAcxkovJxdGxcXTCEzZkS3jgAyX5Uv7qHFrEvZKSDNcmAwL	127
10357	2vbUxr9B1GuAmNkZ2GqZti93NibdVkU8JFy98pYfFQybs1Nd1UJb	127
10359	2vbh9V4Pj6g7qvSHg5YwwsL3zFzdh4qkScZY8tcmpSGYVyfWsGBG	127
10363	2vc2ypRMpK9B89kJyuu36UNvHD2dUCZVa5S372VMJudGXmhJ5Suv	127
10369	2vakjinibMbrKCcKokVLySxiYbZ3h67d7WVFtCdm8gDMoqsuzEmp	127
10374	2vbg9jJnq84r1DySYsymQwckfyGFcEJPLwB4trTYcJYVsfLfaDJE	127
10377	2vbM1MTyFth6f3ZWtrGyGxgwLCNUMps2qLxZFMf6CUKdrjpapdge	127
10383	2vbryThG7Fs1dPBGdCYitx32AneYDTvjbDfNBV21XHtXfJq417GC	127
10385	2vaqTByz7DWh2VGCLaMdany5rh9gAQe4vDDsosJdSQ9KdGtxp3MV	127
10391	2vbZ6ZnAKCimbPJYV9zxhwCSvHWd8qBQwMk1G5u8F8CVGgLb6nt9	127
10393	2vand5TG3SakH9UGANER2nt8kvdeDnCDqhMPh6fjSBX77K2UG3cZ	127
10395	2vaD6u1zb37ZqC6JJuXg1MC5BBpoceeqaFSEKf52BF84QR2hNjPV	127
10405	2vbigo5jbi6B9yKiZ5pYYCchPLjiFGW4Pqsza5Tdnm8KT54c5LzW	127
10408	2vbmHuTob6S9TaFydiVgheS4zXBsT6V1UnMvujV35UdF4e4nfdsx	127
10412	2vaNoHBabMx2idA8wMx3jYfvi9pvvs4CmgAJVwHVaeYhNi3XxgiX	127
10416	2vbx77hMQ1xcLeo1CFu5MDpKkbpcGeH2q8RZN4KeYfuJTCHQ2PUi	127
10423	2vbtZ9tdKANxpYz8oBnYi8VihMWQ848jgdFG8RfFvSV6DysvXvq4	127
10428	2vbubDgsXzaua96gQyQv9hCRiDPGLLo6zJEMKqHqgVszfFCzAjh2	127
10435	2vamajnW5rpNGW6kQ8rJwjKHuurJYBwLuWYTW4xZ47DKHmfydLqs	127
10441	2vbCPTw5JpokVo86cSAzALEVGEEpHDJX8tbMrJQEihyNhjtAXUj6	127
10449	2vbh9RPYAgoA77p19Zp3wmRYKtzwgWcMGQdoPPG7Jf5iogsgZhH4	127
10452	2vbRQawVRtqAjtGcP41J9eyesqp9gA6ycg82mXPnbWB7d1KmwpHp	127
10459	2vbXpNCW3KfGexdyYPf3wLYkCvxwohzdeizLB2u46iiZAQvACGvS	127
10469	2vaSKRocVqWPGbZVKMuQ3SqD7DUYDgQYQZCW6JbmZz7dwXqg2dhG	127
10477	2vbtXTaXnc7QeKfjxDHXfKKQcGhUbMHBa8ZMY6o7MKuvmH1eqVPZ	127
10484	2vbfvzvpdPFj2Um4fsH8GAo4zFEX5E22J823M7MziozZ5AnRP5S6	127
10486	2vaD6R9b6qBmbfq6YiS6JjLnsQFSHPqvSDigV9ZrRfae1p6idzax	127
10491	2vbmuzWGBwewacMkMJRi36uzKahSN5DMDLyoDCYpMwy3ES8G2zpE	127
10497	2vbgRVqUwLSLN2yb43fh41zzKMkeUBqwXWQmuPdPAnG4fhsmSAGy	127
10504	2vbmgSQzFDJPfFB8TBXzVqPbEAXuRaFWVmKN9rJVThnK6uBDiPi6	127
10507	2vbPjUoR97v87X3TVtrX9bgJAwVLVj5EUVETAt1CaGLHctyuvgY7	127
10511	2vbGzrheK1yLkY1upEr7XFScxQdBQ6GWjNmnUW26K2G1uCSb44tw	127
10513	2vbZRk7aX2QcbM7sSr6Q88EKeNxoHvkkheFKbptPrizZSWkZm4s7	127
10516	2vaSyjQBSV5JBoAqVtiRumwnP678BPPVEMM6bCFBCKaVDWxq1h4S	127
10521	2vb981e1tY5Mrq765QGPKpEA3DZ8YLuXtN5PdQXFNYStZzSCqdE1	127
10523	2vbAp7rnmGqzdXnrfvfsfA3ay7W3XSe7eD1KomkLbSQe4VtnsUdG	127
10530	2vbA8R51EQRttkXQLR9AGRtenSNd1CaTzTb7C2cdXKYVjUkGx7NK	127
10535	2vaww5DBxAXiqCLtE1AxgXHY3Pw5g5fkFukrnKXuKRpDzzb1L3zz	127
10540	2vbpUwPdpXqQxqT6LBJj7gZDiiYAVYNipwfXL3WaP8FyKTSdQzQw	127
10547	2vbnqkhkEcur9YKgAwJLF54GZ67EKfBaQ22nQo84MXYsdgrtVd3J	127
10557	2vbBdk3PCenvwj956F5FytXhC15hfNq5NYNk2ES39shs7ZgwAsXX	127
10559	2vbuYfBPR2cKYtLaUW4LCkxyqTxgn5NaCRFS1w4oSczphWB4kYo8	127
10562	2vbAzLWRkMFTrWL3TjZkbYp2DZaVin1DYzxvouXsxcKQmJ1A6rUD	127
10564	2vaBSUgpSHXpcwUjvkXUUDAYwZaTWdt2K4VFnK5uPS82Roumz98B	127
10570	2vbh2N8MsJdf3kDtfWFDC5NGKLkg1rLtZbJf4tHT7Y1vGnkxYNsy	127
10573	2vbDQHnkFboNXS6T7RDTxR7evQPfF1dBewyZAHCLNVbxLVqQXtaN	127
10575	2vagSSAKcdg48GKopRzFPabZZCfrq32B27pPLWrcfJR9nnSvCYEi	127
10577	2vaUGDcM7bCBTbYwrjY5XFSRE3FuEwEAdVhBvYvym1kLmEHoaY1M	127
10580	2vbvBsanzGUUn5LHUrRe5QHRfYb1HsLDtKjjK7ubAcisKCsz4ifT	127
10588	2vc2RfybLAqEq78g3TMuMpXd8doqR1mQPghWf2TZnGktSw16hp5e	127
10592	2vbGNHByhUkW4Ysf32B88GNnAo3pVX9PFjUPszZbjFbDYiLpkq9w	127
10595	2vbSp6w3QC6tHSJvtJnpZt3wTZp2n8DA3dGr253xztgd5GFhPtij	127
10597	2vaG4gfMcuv5EdPWvhedhj6Mpv1VzCNJ1oEHB2Qf7kvFy11EK33N	127
10600	2vaEEcgUy1ebw6t1SLVqWpJbbs4hQFxbbhzroKxe9c9Zg6BvBfDR	127
10603	2vaofKUVUUSZxmu7Y5qUWei77rvjGaE9TitNcfmDD4rXKB1mUA6K	127
10604	2vbGD89SNfAVKzbfymgusCLheim8ynxaxrYuA2wxpiE7JK2AMmTs	127
10608	2vbS9FiRZijfbmLaJ2YZ2orokSiv1dC9GAtNzPvpqZNuVQ5WTK8b	127
10613	2vbzvmvi1zFEFzXvoHcftRUFF2KSzv82Ee5ydVKvHAEHuJRZjjbo	127
10616	2vbRhgTM33nrS6ru9dux1CTjPd48NFEiLBiRfKbVoxDfFbm7ohvK	127
10618	2vaRVu9CqjipCwend1XgPG4StD6vfuB7SjEtH8g1Ficnw5CP8Z1L	127
10620	2vbeZghHEiANMNzRtqtDjxXdoMFA4NkSAeCKk7cSUHFgzsYaGSuH	127
10623	2vbLiuddGmaDtJPGQLFLFeWsiZaev79taZAdFVji1bgSaRRU8DRb	127
10626	2vaCvRVTZ3TDGvoGmfhS5roZNuVHDrpNCw4epeY5h9kvq1uGyQVy	127
10631	2vbZbNN11xzBFZhCyyJHfZSL524AyJ8wMvNXH6qHSyXU1RVowUTG	127
10636	2vb5APYxmZrX4TmhDBtcjH9xt1y9uaYd2Hs9xPsz6bQhLG12rgCv	127
10639	2vaU2515eYPvC9eUd4LtDiyToPvaBjcfmNB7tSeKwX5vL5xJJuY3	127
10641	2vbGkKr5Zn66ivXjhm44nwLeMEummtRspvKJJ5JRa9MxomUfwUQ9	127
10645	2vbhCGLVzinkTFV4Qk6NeETcekjcWvMNfSJSpp97sLqTPNQ9ct7K	127
10647	2vbbj7pcTRZEydK9Gkt45129ues57M7SvKHxbmhHh9mjwJ6vVFv6	127
10654	2vaHufsygLFT1HcoMdYBibdY4QpoDczfq5U6m3FoMUcz4KctWYTJ	127
10656	2vbLaRtWHhUdphDMp5cmTs7YPzvyAwCWzNb7civuihq3b5cxm1wa	127
10657	2vbDAPtZhXz3kVkVThsCsvbqFgJQMFFRuNg9HM4FsoB7kRPpzbWX	127
10659	2vad6rCokaCV2zm4LaoGVVe5ymZHNyesCdKvxSQhmc7xX7fAAHkU	127
10663	2vahDyA9s6PZivgkbFuUAB7DVrne76rzyzSHLGVM9Te4SUJ7XF8k	127
10668	2vaGJFP22bx4KkGkFkNTKGSdbNi92QrYLGpw96yfmbeQ55okLjZ3	127
10671	2vatSdzb1JuR4WLA9z6tFFmcd4g6nuhXJ25RHRuZfevR9S6XN5TU	127
10673	2vatNiN26Qa4fL4UKYwjcSjj9ZkdsZHiRLei6tDB2FLCrAUzkWVp	127
10318	2vbuayXGLPNkVH1aU8RKcmBGeCrEPEUc6hNgJ7N8aRu4f9nYMDzE	127
10320	2vaMBunne92jy98tbp7kLnjeKVCU2CrUFnaupw3xx8QEb3wxBvm4	127
10324	2vbfm37yHXGXoXPbxQjpyGpWAqW6TejENnNvn4Wn5n1WK7PAibiB	127
10326	2vbR5ca3tuWaYesVp4tCYdXh42oL1pkkMWq42crtVJQxx7n6WisT	127
10329	2vbnSv41E4ixECdx5wXQt16kqoHsT5tnHYfKRB1UKJZVBqC8hWhx	127
10341	2vbbDQHmbjxFrDnhoUJDyA1yJ5PaPBE1MqpN1hhpUPLrniwqhJsC	127
10348	2vaunrWygPbtkrXwAbHWpEXLT8KhuLHP6NqyfxTRfx6RXArQTHsx	127
10351	2vaSQg1zxbK9V6iL39zf1ehdt1EjbybcLWfefadm2bFQzwVadCKW	127
10360	2vbmk9rCDZF4Qf6ykgimP93RqNZLFgCx6JMseNZrG3NW9rdAHQdv	127
10364	2vbwTqc7pc2xg1m6ZVTyeVnPXqgvtj1HY88jwaDsCciodZj6UVzh	127
10365	2vasKfrWykVkaqn3X721nUUHQXXM8M9b5jRmYu3NX2BMgygBNtqD	127
10373	2vardwuyvhzQ7P4TRXV3SyyRKFg3wFarMJXih8NzZYmkvf66Rsc4	127
10376	2vbBTzA8AoWBn9W5sSKHe88Wz6VCiyoLM9dKbJK8djwLjH5aTrpP	127
10378	2vaiJEYqn3t6wpYivfwuhqNpKHnEgr1eLeJUtSPdGorwUxAZUwA2	127
10379	2vbx3ucmm3tf1FnPoYdvXcA1UPebmKdqV4WsfueaTy7PzgPG9Ct3	127
10382	2vbXVbKjTvce79eDoTWyQH9tLXzJFHLUaxPDH5WpY867w3PqWQU4	127
10386	2vb5MDM8vn9QCr6mPajztzB1nerMye3K9FfJMJFos8nKynP3BcLc	127
10389	2vbiyFnnHRG5aetFt68gSZca6b9YkAUNNqZ1Fjho6HY2kfyc6oax	127
10396	2vbp2AhhkgKbune8Q42dq3qmvWLNqMg3CNnSevUcxA1u9yAZHZeu	127
10401	2vbZzYRmUtowUL12bSDFZcxcPKLaznPQ9Umqh3HTaN5bAKHPMrDb	127
10403	2vc2dZbSrr71PEZuKL5uswLugo68J9sHPgH9TJDELpCHQZkx37Mc	127
10406	2vaTgLGsKT1emyfDUQfRt8gNXeAhHfYB3jCDPfVa2SieSkCWdrWZ	127
10409	2vaxNZYnrFsGCJgeDSJWEuYvdgAegDsEwLzjHyZ8mxxfRi2FHDMN	127
10411	2vbFGCnJJA6ASbCGL8ZQEPz4afsn8GXjh31E2DjtoxR9Gd2foHUS	127
10413	2vaboLfb6RDssV4FHDKLDzVDuCNVTrfLrq6aTAL3AkmkjZQdJNSH	127
10421	2vc4hfFjfywWgUgSzDDfGdHgYQ9jRyRier5gMJf46KE6k8msUXhp	127
10424	2vbU5afucJbh5jofNMaQ6h492k2WYxG7BGLHLrmtCsvfusTiVfpG	127
10426	2vaD9Zumgcw59Trf2XJh3aU5MPmWeUVjy4vgWrpfnmtT4bY8wvmQ	127
10429	2vasXJqFUPzAWngAiiyQqyVcaJonijNpCFfuVW1ji3it6NVJMGrK	127
10432	2vbkcsyWR2cdCkFz4kuso6gPNMeVz1HKwfGUMcXNhvTy3AzRW6HY	127
10433	2vaXWnWLQ5c6cxhAwqimR3Bg4mT7FDKyRANmwzBymE5AfgCqt3rA	127
10436	2vbQvQRjRuoUFNAWueZ1Jb4mMUbSSkmNVeYWNnvwotUebYxJxrvp	127
10440	2vaeGWmsLRwPuwpQs8p9d5k4TyPi5X3U48Pdv8WrGoNUtW25PcX2	127
10444	2vbyPv1yzn9UUWzaUCCu8V2kYgVyJAonLLeBhrrtF6CFcXRbdmbd	127
10447	2vaJw7sFyEWF4cNbpHZwkKSeZ896nQ2TbvnuUwTowMps9gNm6Sg8	127
10450	2vc4WrVoejV7Ph42vtNgNpAb9q89eeiYTMi8qSGLXFi5DXcFjW2z	127
10453	2vbCqAsWQngCY62VPryW9PisJ9jdShSS7hQfMGCDmS4uyYYbacTk	127
10455	2vaLbGLEp7PvuDk2Tk3jAL6mDwsFQ2ExNVCaNpnLQPx5dzgnbG1A	127
10457	2vaZrDhARqiYpVPAtwSpxjxwEfpEaoauMo7HZsH7pUup6myhMPH7	127
10460	2vbJfRS3kzgf5SvaRSFg6CByRge9JXfRjpjwjfCMQqWjk5Xgk1FP	127
10462	2vbxyWAZvyguzkwBgD2PQ8bvifV4S5j9qZ4AcheVKpZqMCSqZZhm	127
10467	2vbvhqFfmKAempRtrZyPAL4gaidGJ7ZanpN69GTUJjCMw4DzmqdN	127
10470	2vbGCfaw9SbwHLntKQYPw47C9zAmH7twn98YapP2ptYmjBzaJGrH	127
10478	2vazwuNdqvYhyhv1AuN7tmA61oZKa54zYWBjX89o6URDpKBbBZ7B	127
10480	2vbwD4RYzVo6nVeUXDdfaSCAJtyhMw8qxtHLZFQpQUpRjWBQ9X4Y	127
10492	2vbsiAwWsNj7V5br2e7WJkhfzCaTZPEPuNQaUHRWyNUkLvCJXw1k	127
10494	2vaxMQf6nUJ5Ht7JDv73jYyVtgLeE4aeb9tn3bmpYDUTdgQjaiCQ	127
10502	2vacAPQuHh5ZsecJLR73yGFQgEQ6PapSpJMUBUr4cWRXKw9eSuki	127
10508	2vbRF6ok2xoPJot8ZCMxq9tXfjMWv6rs8yNTQ5pQynjGcZ5e9Sk1	127
10509	2vbN4ZyYgtMBvR91k8iYwKXsGwcTRi7rhSTBQb5Ns4ad1nBERbbe	127
10512	2vanjJn5nVRhJNHxyRmz41KaSs57ps3Lzdivjwob6oxePLBpiMnb	127
10514	2vac9AmFjbgeX1J8ober6RdX4EBLxkeVwQMXhfbpbxE1CQVoGMEe	127
10517	2vbAKo14k1G4xzjdVr8X4RR4Nox4je2NJm7LvnmN36eF5QyaJydh	127
10522	2vc3nzNvqQZ5D3FFcF9ymaLcdVkg5azLz1M2ZdukMcEzu8hRnRjS	127
10524	2vadxKrpPyuXLus68jvJcRYZczLExPHBGHARDt9g1QTSQ4d5AFpg	127
10528	2vbToe3ksDRkeRQLiHVxwEf5i3YMfojj4zZJc1fmGPxEDYLtEMqq	127
10533	2vayxBHBgMQB2eojD9NY3ST8ZEBEoaE4Rfa9D5K9k2cKvmGwRB3D	127
10538	2vbFSRThE9CnrhDVmiHJkjJfpM8y5VKB3YjWi9ZK86VAq9Z1zZoJ	127
10542	2vbmdTd8WUWiWGLfK8NHV8uJV7KhAxMMtGGys28YqcK3jq8bCvyd	127
10550	2vbrv52DoU9kJyEGY3ZQf1fYa6k3nfoCV8Sw8ZQdfKh8X7BcSsQV	127
10552	2vbsnVapGZQeC5yymStqBCNDZarNo5JPDQwNo2gwjJrFTqU8WYPQ	127
10555	2vaD3U1koyRJEatNSVj6qq8ujdVh1AJ8DA6nu7eDVPD7kSsWeJUK	127
10560	2vaUGBFuVx6xRvggr9jJPADPSHus4QGap243R6LQs4BNb41UZBYP	127
10565	2vavr1hvMMUeRqrWpZ2y7gz5DRG9u2s2h6cjwBjGyqfnJbmnxvwD	127
10574	2vbakVkfiJajB69cEDreaxgAZp9JNppKi6uy48cayX2xsB7Eaaei	127
10576	2vaysXpQHxbie9DB4a6eKJmU4dz8dhGWviMtfbHNrj4DXe28CTT5	127
10578	2vbCJuBUpjJ6Efgs3cBXzuQmhquqJtyFBde1ETg3RdgPXjXJgz3j	127
10581	2varNJBT7m1wC3rvw8RR8yvKJzg7B8BkdRuWtLupd5tLiiUKMxLs	127
10582	2vbAcX7KBMbAmnq9fdxEojySzEE6zNUp6cABYFYvbXMK25XHSxae	127
10585	2vaKovZ2rDRPSVDh6PQ3AQn4Re85SKbTrmKf23zh1eaMPiybPuie	127
10596	2vavHhgpRLncJz7tduuTTkGoVX5WT8m6v2FvA9UKFhWodaXJPr5G	127
10601	2vbft7BLSPJdUiKJXdzUFAk7opxyvbMKdzF3wdBD41yeKWx9gsqz	127
10605	2vbcVb7ouwnGoUTK51eKXsF5BcMC5qKW4ArAAYjZQF8PZ4Cq3pcU	127
10611	2vabUsVQiEivctm1cRDzYf7BbuuBjDokScyBDzK3HW2pTr2GpAHP	127
10614	2vbGaS7rXnsyGNwdxVpd1eBydAp7Y1kHEsFNaeq1t2KM2a9p1bwK	127
10621	2vacngTGeMCBiQYYmq3bd861s1spXphs5BwgsRpKnkYwYuJ9xrFn	127
10624	2vbmUkPVxQtmy6G4guNefPqySPPdpBQZM2P2TixHp25Y3vvdaJpX	127
10629	2vc3iZsaNZwY3C37Kbu1s2GjAQwJ5RU9yTD66VTKedPSRGBjnJVr	127
10632	2vbxk5P93kvqrtyvdvRyYz2XkZsNcUuaAmYdTmAqZQkc81SbzmDv	127
10633	2vbwB6nxkAxs8ztauY67eRdwfaTLJ18Tb1kQYJ7NfNoJwNNph6Rq	127
10640	2vc3puAua5kACd9ZxV9GF32CCCbRrZQ14vYFhLKyAknwvm8P2aSE	127
10642	2vbKASjezUMrzKmBux2HUghHAcUpM4JTWq6vpVCwgZ2yKbYcuNSN	127
10648	2vbXGC6MaJFXXhfgn1KeFueQDke8wPVoJ85FNvXWLnFdcCUAhNWM	127
10649	2vbznirFhMgRaAAY9vr4twnYHyNS3YJBaAbQkdUKPaSJ4KisJCGv	127
10652	2vajLsYNjFcm7Lc7r3MKG4iB6tAGNw2TEDiRWW8nVmmLqKLW3hfF	127
10655	2vaYbbM663qzKnGAj9kWaTCSBNXWdu4ErHJZLFcS86UpcYANbRmc	127
10660	2vaNerYZnFQHRYp3MSnSve5pVvrGF6CLXewVnHBmEGrfVstVsctr	127
10664	2vbHYqVuJzxWM1B9G1RE9LRzM2kZPAj6AmxpjctpordMXCDKYytc	127
10330	2vbWxNuPFC4n1srUzVMTi3MSQ5V4Xpu2qAPFhcuWGLsBdYS1we2s	127
10334	2vad94V3ztQC6WF3KSpBQAGZvWVeSKW4RpuuPdX4n6MN6XGsht6t	127
10339	2vbU4UoG9KjNLLaSi3bZnuw4725biawagHmbWcSKX9E6bmgJnwEL	127
10344	2vbPrFjZLdkKe4p4BnJXyig3qcu7cNyVFtrrne9EsQ5hLjxDTPv4	127
10347	2vaP6DP7ZVSUTVFAyfgyyjY4BhavxS8RLQp1z4vFRPPNSJxbZTdo	127
10349	2vbrgGSnzuhrNoBftAtopP7tpcjDQ1EGn8mgKA6NBnwwy8DbqqU1	127
10354	2vagsfbYo155bsLyQ7mFCFHbwSNWRfDKBvCURKnFJ5gpdAcmdXjQ	127
10362	2vbBhZ9crLj4K1SAmQhmti5JnTtJT2nbAukquRisBpDoqeHpAKC7	127
10367	2vbHHgYeCsYqAFp52dj6u36hHov4yPrK9zSbV11P6pSaMgsQ4GEZ	127
10370	2vadWnoobjga3Gi88UMuG3mWxUSp9ZBY72YTGg43HrjTZPLmAshJ	127
10372	2vapYEPSUp2zoyDs1XrZpmRDST9VzJ4TqKSXYGFEQdUXjKFuL42b	127
10375	2vaJhS989U8SPzCRJmLTNb9jfAW4ie51xe5zncBKRuYonq6dHB6v	127
10381	2vbAiwrjQGkrFA2CSNX8pCeqUVq36mf54ytKwLwch3vJ5z1iZxBW	127
10384	2vaBw1wNfAK91gHmNUufN969BHdD5r6EtYnqF5zxnJfzQu3Hn9zL	127
10388	2vbti8sAnocijDNtz7Ysxgci1AiRmDPjpR2LmD862crXrkqzKdcu	127
10397	2vaQ8xaKxb7Y1pCKEcVPrHoB8r2JDQUSgVpYusBLqgrBMkTeFyux	127
10399	2vbC4S687f7ioyrc8fV32FsLHJ4PPk8beYnCw7DwkD83LrXcGyj3	127
10407	2vaHt1ZKTS9zdCAFdZ3KvUA4XstPGH26hAFJrKQ425rPWACK9qQz	127
10410	2vbrm5QneMq8Xux1wmCv9keRTxUF2sKvaaz7MwP6kR6B9ToG8yYg	127
10414	2vbz7hbDcWCW3NKmMpvVu5U9cyVo9h45eU1rTH81jcjGL7T25ZXP	127
10417	2vaJwXuEHoSWCVujyN4PBqoG6x6P3wNPUXcAEhHD1BWWzdLdEDiy	127
10419	2vak18bkGYiND3QjdTTNWtqzsiX2QFZg3VDQwdgVKne6LYQdaTWk	127
10422	2vbdWsr7WsxSZCvG9agyzpP9J1oUjqU312apK7nkCDhAdsPFxTNP	127
10427	2vawS4sKgVfFaRaQaTejbawNk5X5BrHf8TWDL4D5joY8RBCRvnvn	127
10430	2vaiaQXMCF9V3nvyygJP6a6U7v8fGuKni8CYoCGwPzu3EXBp5nAe	127
10431	2vadKDum669N41SEGUzQubfpkJFPDyfDEzMi4ECEx6wWX1F5naYZ	127
10434	2vb73AqtUh1n7Zj5jBDpszRmZDWhWdtpUthxumhJX1axGD8enhYL	127
10438	2vanVcpfHhxTbB2XEUwf5fokLxJrt5AvJVtXg2NpU4uv3zdLp41x	127
10442	2va9CvsjTepCB35bUB91dwXLhEJCTzb5AytkSnF83qeRUix5QGb1	127
10445	2vapxdK2QXN8X1nYR5BxXWEvVGhwgDXmav621VVygC2XCuGTahQP	127
10448	2vb9vB7X4dK9GyZ6xHSpoGPihPgDCMW4p6V9UwymUdTYZBTmxffm	127
10451	2vbfejfhxVKtZFZyx26PoTBrTCaEJW58bCBgN5Wmw46MYdUx163c	127
10454	2vbFLPZYLXc3Xd9NYAxHFuNuSXPXqEPiJxKyA9e74mv4BJSGx18C	127
10456	2vbsLTPGW1Y73NY9TYe1nGCgp4TQMjzePxiUmAZo2dAtNJAKNbTb	127
10458	2vaQx66o1zAAh5hQjwaV6rNhG883RYhV87LUcCJkyddcgoRKZkar	127
10461	2vakcLfQSKWQnMcBWsY6trgo5zD9bgbSfZM7agRrb2Npmc3sdPni	127
10463	2vbbAyjdM8FJC1j2FtdHuoXzydDX8Xi32a4NPGDH5EdMkWsx33qD	127
10465	2vapzxUPfUVJ3J473sryshYF6rjbRHiw1KVAPBLroZWhg2PLZaU6	127
10471	2vbGpW3ZtR6J1dmWZ3yK2sNFT6rXiy2KvWieAQ2iHwjPTumoSAGG	127
10473	2vak8AJVpRH8ZprwSAE69xRvzns6z4PBBmTpHnWqmNMpS6Wfxxex	127
10475	2vbUszojNEMthvL6UcNdVvN9qHeCqmcmod3vdupKHgk1WVuYPE1z	127
10481	2vaG8FVePbUwq4nLhiNWSKhRc7rb3JLbnxdb8QsUBrtAAYcvD9Bc	127
10483	2vag3PrSnzUr3cuGvQidsfqtAssHZUhUEkqhSTFB9sqYV7BzENxW	127
10485	2vbt5RJ93NGrwTX4QKH6DsApZ4iRCXUgcgnkhbRaXhtwE8RowE5q	127
10487	2vaeb9EpZWGbgwcGJi1BnUQ8ybTEvrpErVgGJ17oKBWVWpz3ptrB	127
10489	2vaThfV6nfGBg74vUjbyV7PpUzUXPpq8zZqoHS7uSeGAacsN3N9x	127
10498	2vbDzq18v9SPx7YmHtmagBNhR1r5uCD2GR1Lb4z8j1D98pDwVckh	127
10500	2vb4uLtt4grv58UR6HP2ZXp5pkTHergpSs5icQ49xhBU65FckkwE	127
10503	2vbHkTUuYeNiQnz3kA2oHRDZTBg3hyqejWJGc2kRxhmKyeGfLG3y	127
10505	2vajvCLjMysNtZMeQXEQJ2QBuhUb35RBZ2HjsrkT1CLDH1L8UUqS	127
10515	2vai3SFCB6E7mjh5eVWKJBooVU851ZWNgENhWwSPK9X3ZSGwfFhb	127
10518	2vbzfixEErKxsEpTpUiUEPhn29EgVxc5JbG8ECgeN8LhHFUH85sc	127
10519	2vaf2SnymVJh88Lp8fFCTRUv96c2HvdPwVXr2EVVCXz9K8Roa6aG	127
10525	2vaMqQrHG9vFN4Pkb5XBBcUS6Kzq5AFqKGTH9uqnSJtEDaUrSKZW	127
10529	2vaaenLDbmZgZbHDoXgbX9nw4gknzenRreF1nmh39r99f3VJyFXb	127
10531	2vb8uqFk3CYsWqaJQvAebsZ8QGwuRfo3QD3Tw7XHZ8qymNLM7wRk	127
10536	2vbLYEGWiJCU5AqC7Zvtvr5cBy4Dc9xsBUcobaavDL8Frj1Jb86S	127
10541	2vbbUyNvW2cNhGeqRY7hFgMzPcofHNxZBUu8CYcbTiz3yyC61bDN	127
10543	2vaM26j7tMPXVRAwDyUy619MkMBVcSzXFtMXDW538FmkQt8pmZUv	127
10545	2vc3ec1uem6zA9axTo4QMLovq1ny4QtTqwABnFeYzQnSq3fBEYR1	127
10548	2vbw9koFEw8og7TYoMN8VLUcW23jZCVTV8YVKQ8MjKBWXRq3LtvJ	127
10553	2vaHM8aiDVdfp5xBheHhj5qrHWg5TXdg1ykKpMp2S4EH6WrM8f4P	127
10558	2vaZpS6QVVmcnsbMya8kmVhDjtqMCAgRFS5XxiW7KnzkFKggFi38	127
10563	2vbQXdB8oJGhdfA8V4vJFUALKpCguy8YzqZfGhtXufpWgogXNbtK	127
10566	2vbadVBZ7YA7drDVu2qJbHHrwcbtskDryPPfhXzZY4ffygstQz6w	127
10568	2vaVS5useyz6GL1zHJ17JNz7quCEikTM1nrc1asYzYv4uZtbPgEB	127
10571	2vappj6feuJcaenu64GyqZXH4rszjT2csWBiFM9KALSBkHSEr5uq	127
10583	2vasUuKQ8WqKuScViKUAENtpRxVBU9YAxNNamb95D7AA2GuQezzH	127
10586	2vaMND7jYE99ibD8wPB9gXtqCSA3xuKTH6yRR4k7JJzr8zKwSA5f	127
10590	2vbs87VwMvj44xg4bhexSZeYcxQxVLDJJhdzo5YWQ9tKm2cE1zxw	127
10593	2vabfaEgKUGRYiDad1mxpAUa9bshgZydzJ9hHXY87QBXktaw6Vyx	127
10594	2vbEEtspeoqKh8wkAQUF1GRXC8KDJ3ZAXEVRoULWjGTutciwbBFm	127
10598	2vanDY8qyLQzshuP4sY93LHEFkaGxvUfzCkt7TbWERA8dHcPhtBX	127
10606	2vawiHPNiDGY5o4BXYVXec8pCdmM1nnH8q39iXDs5Us8pDtgjCSL	127
10609	2vb4fSzFo9eyzYtniL5KDmuMdBFVNTjoUJWXBbPQAQEB6Lr7niRn	127
10612	2vb5oE5dxynDfHCZRk4dkszaDSZdy1m1dEpNHCUSc7BMx3ajjw6p	127
10615	2vbxxVxjRPBVzZXeKWa6DenD5yB78CU8jjgEagvQq26j5FjVwSnZ	127
10617	2vbitr1et3uzEazhftmsksmU7F5QdSscoNpcP8KmvysKCHuHvUsR	127
10622	2vaSygoxjcfFY5oHGdFpmemfpujy29Qx7rMrWLrduVyXY8FtMwtM	127
10625	2vbdXtD5WFF3ccgPhR1oM4JST6DnmzfeVCzUCR6gD8uwegBACNMP	127
10627	2vbP1wrKUsBTkJRd8ZrBu93oEz3vaeYWfr3psJi3dRUaEFVfeUYk	127
10634	2vaxKhcijbnXFX5sAD28QBoCNYLW73YEtuVGNLGc6w5FRaP6iM4G	127
10637	2vaUEgXJvcyPEqfFYcj2pcWyQDAPaW6vmsuKP9fB7kpSC8MW6Mf8	127
10643	2vaAznZzW8EgTPbrEJsaEAAzhVXjiPEHE2j7ttgbnQTSHE8qpGrF	127
10646	2vbX6v6HTvBzsMbkDErFz2gq79QJocGVCGjMHThQy9Tj2AqoPRet	127
10650	2vbTgoF5aj1jGfB7DtuNapAyq8ZYwkgSBMsovyXNgzL3TBu6ATGv	127
10661	2vbLyaecBGpQkKA4cwHV4ZoDcLhfrXqrc8Qz5jZsBdLoCDxDbXZx	127
10665	2vb6HuU9NpKo11Qa2PZo6wFAHoeTmz116HUzpqjSFuDA7GmiUUUG	127
10658	2vbAtX5M4fc6eybHesfzMYVDtoDauEdERsWBttx3oDsJbp7amgjy	127
10662	2vbru5e8PKVNoKZo2GTzWEufdvCPb6WGUUn2DKY5QFqCUgHkWLC5	127
10667	2vaEbxfQk4xsBCytLzGgmR4nhZR65v2esWy9b6jAZY7pZW45CW2q	127
10670	2vadfJGw4mWKbBYyEEB7TW2RPSFaFJ2gPxW72MjGVVJqECXc1fwk	127
10672	2vaTzrDrDcn6TNeVMNaVoCcXV9BVZMnrg6XaPHfS6xiWvkQeQXBY	127
10675	2vbj8xWeH9gGYLKBJnFmNKLxeZgVR7rzgeKgKsejoHHA2WnoysGL	127
10682	2vbxYoZ5bo9PJEtubHGa2CtkDjkR29L2WauueJrtPQ69Peia2Zcy	127
10684	2va9Uw786iKTZyyBsPigAVoNQHx6374pSVbHuZSvi83Np65oZyxL	127
10687	2vc285Jc3KGeuC4QUnjbQARYAFwW5xxHQELjE5WEQiczhW4p5Liq	127
10691	2vayWbwj7rMhmy86utFJsyrETdYK4juP2RTFAPSVSEKnx2oyfMsJ	127
10696	2vb4n47sY3FjS1yppDU3JrsfhCsBLQkR3tqdq4i9M5SjdgSrttRY	127
10699	2vbLFoYiDHWj7fFTfSeX9CDrKrZkru9X4JKrJR7XqjWFCE37XvF7	127
10702	2vbQdFfC9PBLd5n3cYo3PPasmgtNLGWjYj69g9AnrBFq3mpatAAZ	127
10704	2vavLVD1VQLtUkQDVLcpLLCzeKyC4KEZwiV3xXfjRw6MFieFZYuP	127
10708	2vbfvRtCxPw15yMYi4PqUQBYeGcbeLzxA7QfVBUvDWLXzsycJGyu	127
10712	2vbxzfbH7jnqnVXpPyzbPKRNNSUv3LDiXKMGX6DZnXRmDJAJnRUY	127
10715	2vaTCWjCjzXG8prrDfRBhzVFbQ7RzMunyDB34nE7aRnfezquGCUx	127
10720	2vbbdZ7L6NjkE8Ny5tTmXSKM74rZFzoj7cAaznMAdbVy1Yj7re5A	127
10725	2vabW42WiM29x4YzbFToWwq9biN8De5eoQon5Jz9p41TGkenZXEx	127
10728	2vaQCJ9JRUpJNq3GcKp36ZD4P7dRPKP9GyDfXDrcG8absnfpfgsR	127
10730	2vaqfpvka8ZGvLK4PQtWuJswJwZUS5VK5NfRyXBUzxuuRTXFaTSn	127
10734	2vaur213pueBRAfpsdFyGuU1XZapVYDRr1AUfkmWtNZosVsK261J	127
10744	2vbiFGwBJbDphqwjTmb2DPHigt62QbBHzSXCT4GsF1G13ABGPhSf	127
10747	2vc4a6VasLJPWKwJcGxDtrc2quxi1Q8LNW37sNzQZeVm1tBGCeCQ	127
10748	2vahU3QfvPeSsG4rWSGN376N8CT2pvVgTkuRY9eKymW4TnqKpfMg	127
10753	2vaphTsR6Gt5grT5XVW7DvbRAN3H3hSU8pgjAd2HmhvKrgczhD4n	127
10755	2vbCr1A2uJ3is1cZE7QjggNtHen4vi1M12w5LAL76zuBWNRFGVki	127
10757	2vb1zfVjQSEwmpNwMB8YTvUF3qStnhdJ3FpWkZM5T1G3EbmagiaY	127
10758	2vbYes5rmCotiStJ9iSzhRAF4M1qZR6NUWzwPkJPyKsKnNeYCLh8	127
10762	2vbPYfgh2j8qezNkFcnJfpC85pqy6PcdxxJEHea9dA65gWjD614D	127
10769	2vbX7jCKZSTaN1UebBx4QDXu1HeEwZs7ScPqubxxbtetQqsE7G1P	127
10772	2vaApXh5WpHfjj2DKwncd6HbGSDM4nMQR4xsHYtmBMbMgNGPpyxV	127
10779	2vaWphEnVgHf5VKXaDC794itig5V1WynFcXJx6CiF4jb1qQvw6Ah	127
10781	2vaMhcFBDCrVxkXR1hjxDtzYsrFffhhfDAYi5DLuRvsZvHa4YDVN	127
10785	2vaFeR3NDQAPuZQVLKnePJbEZwPzt9oDUArqTUJnpyEv8UHnWSGb	127
10791	2vbeRP4vthxqgtAKyDfKSx3GbL7vVBRirFwzSR8nCp5Psgi6iQxR	127
10792	2vavyahcepNKioakxJgDMLq6h5sjpEKiRGyxerJmioFr2LD75tuc	127
10797	2vahDJJebriTx3UjbRirjcxDTgi75UewfHLvRzNjCmLHCkAGjYWU	127
10799	2vaDBpPfHApTdZVNhSUp4ah26A1Pov1Enq9daf1TLmbJWMX59VWM	127
10800	2vaLr3kwrQacBtmrKjF9om4VHRSqL78hwCQ8fkLMj2k4oaN1X7xB	127
10805	2vbyugKKDztepMNsXkLPrTWtU9VjGJSxwgCCgkRiArpW6xDJrzMa	127
10807	2vamjDZhj3WDZEdrFQBmJdkP9dWfMLKJoZMsom6AFxXGuKGNSuZG	127
10810	2vaWnkq3bqujWxM2Cegi2PM83a3F32rBHXaYnAnR8vGwiUsBqLdi	127
10817	2va9RHFFZ3287jmQHEKcb3oBFXAFYe2F5DWQFVKm5DTjN29r1Bvj	127
10827	2vbC6YvTxFzmebucnjEb1zbFtfXoHgiSy7ZjVBawDiXXP8CRL1Xu	127
10832	2vbEhoDFocphNZTzGeoZoESUYYUQy9tgY4vHN8gFk7twwmJfYZvR	127
10835	2vbP6yqHEDN5njSejBqMWrZkiY1LNhG87rWESx9EZXTJnh2N4Mro	127
10839	2vayHJX7HsQLEFbzMdKmwp9aMPVH3x5dQ6jmkmvd8eV5o4Pbk2hc	127
10841	2vaj3mvqptsSmKeVkNMKuPXjrSuVUyByNQE9sBDa8FQqnPpLkLi2	127
10846	2vakFE6GW8q4zfEGUsgNtGzhxjH5kqsKYyNiqvQvPs2nkYtqxpdR	127
10856	2vbHYnyaZxgUwdPMg2zf5nyZQkNqqaHPEiVjF5R9Jv8vSCTizSan	127
10858	2vb3cmVpnDZgK9Qdru9xJng5yR4nR3nEXavSMgUFpK7vm5vzVrWu	127
10864	2vbqWHpiWkLFVysM9fPysy3F2qweS6cRr7NMjUCyWdWtTf27knqh	127
10867	2vaJcrtWZFLo4MrQKJFxorXAnnSWPcw3GQ8GgXuNPKyZVKJkFFwj	127
10869	2vbqLzi1nzFSXjf1EX3XGyhSCG5EYaJUGZ5AsxNPTdBX6TxgtXQw	127
10872	2vaYfYc3c2gwAujokTLXf9tNh1bcU8awJpzXvbt2KmrktmWjkHQy	127
10878	2vbV7mspmifPvWJPzkaPKL4qJR4LDfVZ8KA5m6yK11s8rBT1D4Wd	127
10880	2vbb5RyU9uy5ZMnqoqxeVA6fpJRsCXgM65528kJu5NnC2tJYgmt2	127
10883	2vbYwFMAPrgXw6SsPWJ4Uf1Ych3E8FuRmgKMFFgRe6EJLcgo9EUF	127
10888	2vc5CW63ZfSsYeFwGLgiUpZ7VJJdSMphGybFXE1ShurGweVzezRq	127
10889	2vapwBryUYcr55x6X4cDcPvgUfiz7Wm6KvNLCdoJjSDRH5MyveFp	127
10892	2vbJ5CSZouNL13FQCptTJm5WHvQdTbwTNiJkY4GuzcSwygRtyrFA	127
10894	2vaxsN4Ar6mqkqNsM73NaBhY6MzRWh1T68Jsy7Nkia5aQBS16Bxm	127
10897	2vb53r8rBN8mJigdfc14Uk6Et3shkjbYUJ6cy82Zafyodtm1HduF	127
10902	2vbukJvbF7YcVKMoLiUtbSsZXtUBxH3e94BV3B5LWZB8tEfTXqTJ	127
10905	2vboDMVW9B1PfU3ighpXSqTvjtRJ7mfGoDcFMfxjcJEdbxZiPxkZ	127
10911	2vb7LMNhH8RLaXeCpavQNNGPvbryQPnRhp9djtRCR1dm9AUyPP2Y	127
10917	2vbjgjcFL9mMkQFdTj72wf3HnRUWLZLmkJigsgaSCDS2sWKvDzC8	127
10922	2vbis4Jzeo5XpFJJ69RAMq1J1NRuLQpSQwbMdTK2vhrKhfniw6pQ	127
10927	2vbWarvatm7C6QGNEpNvCKYmP2mgYNErdXeaRLXv5JheS1encHQ4	127
10930	2vbZmxFmhXyPMoWefPtTSUu3KTsWuTVy8SKfTpATZpqTr7Eepf8b	127
10933	2vaceKHwRhxjZBMMNTRhCTU1F5cZdafLjsQAav37bjZpPSWvj5gn	127
10936	2vaKiZ2u98STTxs2Da6NcmP83LJwYSMsPihBwPM56VAYG3iT3cV1	127
10949	2vatZ4sUJTu2w3WHVs4yoAbk9u4iJEacdCD3uLaFpaa7ttnKL1Zt	127
10955	2vaPNztmutSC1TfYgGj7wsTEtvhJdNtokyUtRfb8JrC6Zjk9y6zj	127
10958	2vbkh3HV24SDgikeVjrr4xQNeKmxyL3LszVhZTNppEGJ8XYYHtDr	127
10966	2vbqD4Dc6C5s6sFfe8HfKxKNeuC4vMRTpskKoxxvpovGYNZD8FwD	127
10969	2vaeAGVGsobbQyDJfXEJfJmfPHsUcA4LQ72kGXZhKMfwSBTaC5bb	127
10973	2vbq7z8E2sNQTWubcHAk5wZy7RMwYwdtCwUSxR2fEZ7stvrmJBqU	127
10978	2vaTebuz7c1nvQBUbrrjeWMnYXug5of9fhEXggx8zryBY2sMTd8E	127
10982	2vaKxG8DmMomkHrdd1XgiRvsWjarmhkmFaA5UMkaPtJcuCBmFPNf	127
10984	2vat9oJhkoBy1mBNPRqBoyynBRLHPTRhTLnrAarCNkhU9nLhxqCh	127
10986	2vaUa4fPuA3AfMh4eymBNDKsZT19nMd9wCzZLxyBxm4577pcbLED	127
10988	2vayVF2TzSQ7eq6tpQSedWbMqpVkncPanq6JRqDXmWiCBb2PSiwx	127
10993	2vbmsYmUPMwFr58jLmMFAb7Uo639EramMhETf1wK6Y7p3JTf9rVc	127
10998	2vb5LXoNUwmNE9oaNgYuaEbs9zn5ocnYYFpHevLvi8FL7f5XA9LG	127
11002	2vbimpaXw683sGkwVbpTum6tNEggjXjQhdB5EE8k2cCBPVRVdVsn	127
11007	2vb9Rj2vM451cx8r7p5mCjh2W1r8k52FKZQMYjKWRrxGwVuzgKxQ	127
10666	2vaLDQwaquy25ganWwkSP4CsnSryVjbSF5gHXPW2JcuvgAhPGade	127
10674	2vbUG5KjmYSPtGNtVw9FjdqUusaYoMYuD7szKheqsGrmgwAbCC2Q	127
10677	2vacEan7a7xSoeUzuPFFKeQmqi5UjjAaY96D5yR45QxMu4BR6MTN	127
10679	2vb86MCV41h9Fuar1nfjiRhecZJcX7YL1V1kxQrrsV1Nj9eUgGzS	127
10681	2vb9uVbR63WAuBNfk1ZL3qFvuugzuuaFBqMbDUadPKGHPx6o8ojk	127
10686	2vbZqpVS1FTyJB9nVg1ePZNRLR8tYevueLix7D5bUhNqW8AkfSti	127
10690	2vaWFqw85d6GPaGFkL2QmanwgZTZF4m37hantSrV3TyQ2KG6Smra	127
10694	2vbuUk4eQG8gaaSFaVruQGBQaNcYt8m2z59rLEQLxWSdLdHPzFt3	127
10698	2vbGWMoC41cCKbn3mJn6min25tNdVn2RNvMHw3vLGQn7eobk6JCf	127
10701	2vbi1Bk2v5KRjL3NbrKQoXbkWSkPmmHqJBzp773SeKotCxwww3aM	127
10706	2vbhJzPCp9SV9uLXgRDxkURWU52PsykGAn6aBBbmf2DFHgUJydvJ	127
10707	2vbyphSYPR9bLjcgqXMkNQ39SQhW54PDwqyagF3PjrvQEpGKU2Qd	127
10711	2vbYkhcSoUvFCdRctfh2uDM5A5UeATRLGNh8Bw4i1UDUFK1DE5od	127
10713	2vb9E66KpUXdWAZX3wxGPhDrEFurTghvrTVGs74nS4BXG5Hc4zie	127
10714	2vaFdeJHkQnKUCW1xoBLTTRWPGYJrPHy91DuVR5oxTDDcLnfM9a3	127
10719	2vbNSdqxA8HG1TD49FsPWT2WYDP87zPgq12Gk51V6jH2fF9wRzjA	127
10722	2vaWovgw3ke1r6GpQhkNsz4RnmyvBgYKt8UXFXDrmHKbo39zjDpq	127
10727	2vc43iaH9CSvmACmic1piw12UY4kZmDZYX41A12bGgqCn6Er6T1c	127
10735	2vbRC3xsJ4YBDAvFYXorhoKWyCQJZZGRzyaD5pCu5AjhALo7a4Dy	127
10738	2van4Tu1rrTBxF8qXVEjDQMYhQPP2XYFZjM2Z9WT2STpH6SiLrJp	127
10740	2vbfQX5mEEDKioTATxwZH8B3qcEhAZrr6jh4FzRqpBhPb2ExpBJp	127
10743	2vatTTerWUmDBhvUCa3jgGnbx5qqpdL5TXKeMkLKR4G6sCZmzPDZ	127
10746	2vairKoJ95tnYYMuhEJeeqrNbfVgDo5QAeFK4oLYoJREzwCu8K2f	127
10750	2vacU83MYJvWcnvosM8zg68M9FsZBy1a6kGTMdifNaFZHQB12iFv	127
10754	2vbfjMfJpnAqiex4vJ1E9rxRnBnYwGemGAG6xm7xX4sVF63KYZpW	127
10765	2vaxsoFCBYxStaBXMvXK7329yDrEvPm6RJhrhAwutCNWrMEX3xLS	127
10767	2vbc4fWboS6DYE6GNH5XZbUXq2T7mgXAdK1iJxM2JrGv9476ycTX	127
10768	2vaNLH6iKoNKUgaEbdu9LUjfMURWhK1H4bVBvArktEeZ3bWQADAY	127
10771	2vaNexMMjkJnyZJhERcGto5piWa3Pxaqt1nfiDF7uYmndp5rwuYL	127
10774	2vbsDb7TBiu5EqdX1UFEcrNMSCbXzyhfmLBZivHFfNpg8LJKfKYJ	127
10776	2vaqPjCC8aFXM5q46NEakcQ236vks65xH6aTo6j7uuLVnsXS4xCh	127
10778	2vbEYApHx1eaKyEKrpMc42ErUjSBEpcf6rQSncnQ9rq6Ay8UPP4Y	127
10780	2vac1jhb64eRDXm2ceii6XdSCeX3d2GdAkjTCSHLDWZKvLA5LjWp	127
10783	2vb8eHo2mz2YX5opALS1wnWncRGhZvF5Wz8pf2swVYrmpP5mNC9y	127
10788	2vbBYufr4o3hC93eaeqeezdjwos5LPKABdA6nqMy5QnyrovvPMgK	127
10790	2vbpGUYi8biY7j8B85vr1Yih3cNmHnkfAabij2Rg7fPdEhHjUgMu	127
10796	2vaZUFUSKyrTV3x6j491snDGEWADGhaEBpHQ9KWnhyuoKnE16KZx	127
10802	2vaniKttCFrfZNJT1vzWiVsGfXVW4ttpTL6i96ZPygkvL3SbP9qE	127
10804	2vc18FUF6MsmybqVywsXhJKuzZTutaswNfenR44kBe8BVt6ptwEo	127
10806	2vbEkbXP4SHoR6M7mmVPucH9p4ws1JBrBfADE3BuZd3xnjFkJKWZ	127
10809	2vbx1RXbYY7bGUGV5UkSPm6DoKq54eFKUNvseT1GrW5g6QLiU65W	127
10814	2vaV7bUq9zwfDP14WQSCos123utJnCAmB5hDmK5UqsZ6sztoyesb	127
10816	2vbjL3axqqwfWkF5LTRH9xgNqjgKKVqERPAWogDqHi6UrV9ktVRF	127
10820	2vbHowr12egjf4DvvX3mXadBQ3GRX4MJtMf7HsUAUMdmWfktPqaS	127
10824	2vaRziSMUeR67AiCxbPX67QjddhVj45R3ubJaV7D3poExFuJmcj8	127
10830	2vbuWku7efX6r8GsjpWTWiVvVvGEjzMnr77aNwQncERqedk9VcFe	127
10834	2vaDi3r2nREjVMXzHsFYkuqvnnwb3Y5V4bEcbubWxo82QYM37Enx	127
10838	2vbKexM53bjqzjh3U3RVjr7J4QBXZAt5FQJ9FhMcS4oD4GmoV6pr	127
10849	2vbmkXeyxM6Ra4oXve3NT1Jwn477iNpAhWK7XNZJXYRUjYtBdMyC	127
10853	2vbzmVfoHrX8EMaEDu39zLYkTn4mtzpsu8D2iC8qJNmrUTrPtthL	127
10860	2va9VGvnbUmUGmsKTiFFA8renkpXUQaEoBcqt3oUFZty7Lmb49La	127
10866	2vavMf41i8kDRhPJDVvTShQSFcByaHCXJkQ3MegSs7Xcct5NQrQS	127
10875	2vbWbfdEZTZ2eXaariVmxQf5xXCoV1J9XwkrSCDuBoeoBRe7kjcb	127
10877	2vbEL32qAfLULB22FmARisNrC6cxYw6RZrTsfJbERTLSgnZGNYxQ	127
10882	2vaJN3tE45G9aDDrcSE8uSLqZezqPAcaU85R46Pj9J7R5gevawg3	127
10885	2vbj4KYK3jSRdH5B2qm673cicDfqKhkX8rVrEgqoaSrY9k1S2RjV	127
10908	2vaBPJ2eLJtZ3uCLyRPeVpCx52WifWMYUBfoNNYagGBWQyuyHjqa	127
10910	2vbA9UVF3SdcJJkgQCpASsfqLSsy88ezvS7UZXpG54ixE8wdkjTD	127
10915	2vbr5W6KavwtEi1D5VL1MsASHkhn4fXV9ShznjBUHeC8qGhemH4C	127
10916	2vaBKjLMGYFYiYSwZYztvYhWL5pwd3cDYjyiyVTTT6UZNrEb96GA	127
10919	2vbhVy1h8fT3oxnCcFc9Spj8BVRjkzH8o3fzjroJ9RMAgb6GHzLr	127
10921	2vauHBVbbXDH5LFyKYH7zYnYkBbMh5WmQffgN8KL5dq2PMU3nEd9	127
10924	2vaPo9w5mtkywjMavTD673rA4tCw75eRwZEkm3B2FP7AaR8xtF5u	127
10926	2vaEtBduaSnmZcokPoKwsqAk7paaPUpvE9W4zpSosiEu3WPc1W1R	127
10928	2vbcR8EbTRwgLCZ4tcPNVSieuVhS8rXrgCQdVaZ4MzPF5KxnEcin	127
10929	2vawmkZjQ4KGXyYxmeRciHaL3kBZKxoqzwabALNZ6SrGwceZA3kq	127
10932	2vbGhRix339ggkFvpWed6hpCwUyxzxajE9g67h57vehwJmNvg2db	127
10934	2vaBmtaQw7PknD41Zc18ckNC3wZbjJgVhJ4TR7iw2XeqLFFXSDg1	127
10939	2vbzCtt4ctDVx1LeENRXsoy6q2Smg4LjxPmNWZAYsUQVSzkT6gd4	127
10941	2vaQkRDyMBiRqYvGBFcXGKi3BQziRd3kkKtP26Gc9p7uZ8jRvrce	127
10943	2vbXgkgVrf3ksMzoy8BosXDgWY1EcvwFrEi5Ni4TBKA7gvFAcsVP	127
10946	2vaPDpEfqZng7XbotYoPSSS4LYitm6bfbJhMA7t1neuRxD6SLY5j	127
10951	2vaJ973qZeaTC6uGUogqEoRR1nqezPYNtUPdHPsB6Vp7rmct3MC4	127
10954	2vbeCEEWVtyNdRNBF3FEyJxUCwU4T1oSgMwypPzsncpnfFYe9gfZ	127
10957	2vbKApfSTqALQYqrgU2sQK2fe1Z11twpNYN1oG93KrqHTfbwWR1N	127
10960	2vbsUD1g69hRqcJJkCbpnXPjmpGvCh1VJmjiDVZubxSkfy1E8PLY	127
10964	2vbr4PfbtDUT2bg1LErC3PLpjTbKGDWkkLoiuPaHjC8NVbPdDhiJ	127
10968	2vboXfW3ibDGyEUWztKytNm9xYtuPLMwGz2Xnj7WwXHZghuEkNLm	127
10971	2vbx1ukoLf3DNDFNk3Mb1sVCaB3hayzsrqTfZaAxU7mtCRrVWXeE	127
10972	2vbpWHP8EmF9hmN7kR3fzCP5dMXgVftQqxSm8NyrouBqjUXmNtUR	127
10975	2vaQHqHf1cXb1CvyzYzwbiLMrH1cBcEdzYjbdAXL8wNwYfDFoGBw	127
10977	2vabFFyd5v7sFioavxCJjEt89QicMK6nUQGJUKagLxRbmZgDyiVb	127
10979	2vbDzJjKcpA1orcbTP9MpJz28fNAWQgmHZJqdkQgJdp1fhcdh7K1	127
10981	2vaS1dw6arbK6xUpegeCZXdCS1GN9cLGctPpcj8eiLDAheaqRDVT	127
10983	2vaXo8drTT1CcTxxMwkxZbMFDV2bhXTYvP91NDRoeQp8VMPrKdQH	127
10992	2vbaYwYszLyHNHevACXLVF6dMJ5XNSRY58vNxbxdcNvXdkzxEGBq	127
10995	2vbnd59uCGoH4Scq9A15AdvfkCEvgCKy2S6PwYKsGp2vQejfeiXd	127
11001	2vbqNcyDqAFpFY9XHbpgAgEAectAkMAwyYbyMdsc7dqbKq1NYsGn	127
10669	2vaVQaHtuVJkE6zeVAHi8BghfEqhjLuwg7QYU8DQ5UKTJM9RiT3E	127
10676	2vbhtSFLpKvYbXV7sx6ZnW2M2QT8YnndGP32mFxt6B1UhXoBcBWm	127
10678	2vaF1DGibPnJmHKueKKse4nnGaQEdJ7i4UasyD1zNeko2P9nou1n	127
10685	2vaLYx9cBBgXFMi9CUKtJ3ppEi2PYgA3DMRZqFc4263qA6sexEbP	127
10689	2vb15dJP1Cqhk8NSgUqGqzimDJizBaa4guW5BbhZk2UF98gr1WsF	127
10693	2vbUHswexunyyf5ScLARU1wfPLSH9uEQDc6VbbCK9NySvPJSrDJK	127
10700	2vatqYuidwq8eH5BF1WMsPWch5BvCRPsb3aKk5Kd3fmXCDAVsW2g	127
10703	2vbYEJcgcDoxN2NaaKCKmSSfWpZUdnQjGzToUTCn2a6FxqZLRZsR	127
10710	2vbwA1iCT9GCKSSvDLFWM1EHCW4e6uZKg5qgFSdi6EqC4ZCHbTQ7	127
10717	2vbJ7hLS1q6dpUSKn8oZMWxJRZzx63AvPqLy8EtMvHK8uJvzhBv2	127
10724	2vbf4tBPHkcbs4ErHokeERHhDTtsR8rSV1i3AGr5TnuYcTWs7fTx	127
10726	2vapLjbzEDwhzjHuSdagy5efWR2RwPLNuNBbpi6fF6vH5xFfxpyk	127
10732	2vbv252morFP5cQfvjNMzCgj9xC3nWi15iwZF9VPP3JgqNZncHkx	127
10737	2vc3HyCQk5tFBFu7PNckqrdqVMZp92Njafv9eHc7fRkEgAo9DQke	127
10742	2vbf7g6q46tE6F4PVALWAPS2SHAZKfC6KRneQRpxKJkwc8Qh4G3U	127
10745	2vb16L4PUmWmFg9PV3nZyHcbqaWgDQASiQgcUSuKMLgRkSeKdYZH	127
10752	2vbYAcvqRqU1b1mHqfZvHn76Qicn9MZyVBXLyHRJe9uHH4znHTwQ	127
10756	2vazjxP6SRvtpbEUz8LHZik3ymRUL5jdKP6pJhuwXJKw2mQ3968h	127
10759	2vaPmGoBz4N1EMeZW8xQpn3MveSzgWbzigJ7fJmanV38k23SKeT6	127
10761	2vc5FgwcjTuZ3aGL95i1xnJg6wgHurAzjpshPVtfCtrnpbdyPJQE	127
10764	2vaq3P7K8zfng5Tc7CboBaKau7WN1g1Cxj31WPLdmZKnbxH8Zc45	127
10770	2vaoPCdYNcchngo4Xvc11tTuxNPuf2MKaoSiWzJbLqEaLN7HzUrx	127
10773	2vbcP9DHQZLVjL3gPRP7zQET7WAy4AP49TPzrbJa3Zsjpib1Mvwr	127
10775	2vc2CRTipbLaRLoAsd5q7F3Bq5XYFrqEcPJ9rpvqL2M29PzzWzVw	127
10777	2vbxPjebc1QfRnXEmSiGe5XFZsGGsMqPE8XuYQmR93TKRo1o4rhA	127
10782	2vaqYzJtaVA5QakJSd28bzYZmhCYJKWZbtEdeuoQYHHagyY2RDv6	127
10784	2vbKzy6nzDVvNwyGXeW4rXTbxYT2nLFqemeAVbKjJnLmrZvnFwG4	127
10787	2vaPzdLNakRkHwqu5jm2JfruNF7Y4JA7gT9a9jRGSH2X4oqYtvd6	127
10789	2vaF7czk27vRzy3QXmaFRcCLEAnerXWmAwSrDkpCjffjdkB4kPYT	127
10794	2vaBJbSgQ65WNFox3jekpoxkGjzAoUMAvL3Ue2fqfcuexNwRotxy	127
10795	2vbeT6sKLjNNZUzSs1E2gtWQRNnbV3KGrSFNL5FBZ3WVujwGss6k	127
10798	2vaVPQnSfg6hHmNpd3edK5FzwZ4UUSUbC2dyBMm6iMpbqqifmW8f	127
10801	2vb6LefxKYMp6Bmmp5AqZpocyaCyhQoGKDqPvZ9nDX18FVYjM2Mf	127
10803	2vbqHp4q8JZTdKmPk81ACApDcUaTzUrNjDYKy12dBaSLQ24bdDQY	127
10812	2vaqJquoNcNc9yNWExQcMJ9vRJ8fCWBugy5Zu4dmojGmHSTxrSss	127
10813	2vbX9PgEoq2dC7g3rFC8sKzKdqgEgvwXuMN9FGDg5Bg1E9xoS6sc	127
10819	2vbs51fu5GAzuQgou4Wi7VBG12icSHHL6fCWBxzzMePFJRvmUCE1	127
10822	2vadtPxK1WsYHsd8FZMsJAumtiBvcYpkTur9vnTmqd6VJHHZ6Cnt	127
10826	2vbqXCYw2XR6ceKMgUKNDN4kMBgYi1BjTj2Y7DGb7dcJYqLzahvc	127
10829	2vaYQCNe9HEQ2iW9b5Q5tQm8eeQW62SpzTJe6HaZ5WrbUNLSdjgz	127
10831	2vb2tHXrLitQH6ct8ufaKSm3aHK12mYgSzybJyYsdAUhUYW8PvuP	127
10836	2vbGeZQR2iLb1mNE3aAEwTHgFMhNHsGS17VaxVXG1gXpM3RJpVtS	127
10840	2vbTpjwnx1kryz8aRyPJHD5KGFxrwEeTwb6tpNYEhTB19GuhGyqF	127
10843	2vag5QZvEBoVM51F6eYDo44ucvhbvrysi7gGDXkfpvJrPTuoVtYf	127
10845	2vaYe4N7p9T5gWiRMojc1c9pzdEJsofAaX62BbasV2KtDCP6y6iv	127
10848	2vbQmnMbof8jQCKWzbX9t57vFhqwXCTxYZ4p2eLk3mNuwLhKHV8D	127
10852	2vaQCdN8zZfNXJuqhpS5MnNyQAQSVito53LH3oMsazfHgF9vRc3R	127
10855	2vaUGJ5nu1ipXLWmhzZsEj7tbPVmgvuaQpfNc1mz2seeCZW4gff4	127
10862	2vaXpKRCYzffhoHHFnfW1b1SB2h1K5DZKrXLnUc5v15x2SyANfvr	127
10863	2vbEfD1vkYtPfGhkKC6iExjQi4DRLRs9E5ntasb6hTWXKHvyQ1y8	127
10871	2vbBPpb8GuNdZBxbcPWxbZQMfigZYWbHHbW6HAMVYGqA9rywDChK	127
10874	2vbZwN2d7y7SXd9KziUWmQx3g7VJrKpSfhYT3KQCcyrpxGcEiDQu	127
10879	2vb4wmA2DfKmQmHzcHCmMJe18BDoMge3PLAhT9LHSm5VefYSJvcA	127
10881	2vbansFbn8WxepyDpNwbSC8EHzez5eb9QtzbRjoQ94mqT8PREUu6	127
10887	2vbr5s4gKMq3tHdr4bPHUBvFTETiq31NiKKvZCVNBia7fLGESjpN	127
10891	2vbptJWPnYWAuEvWKxp18M72VgTFPPUSJ18w8wwhJa7ByJjD3LCJ	127
10895	2vaybTcJTRg5X7gbyeYikTeMGVobDBLzmAoL7TisymJWm6MsxML8	127
10898	2vbUWm5zg1zKeUomEVHbDgKggpohvb4a64zHsMSbg6Dz1CVLeUze	127
10900	2vbaB8b3RrPVVSt5NmU5hZwnGgVy3XjPQdunaxfceyzeHQKYWUT7	127
10903	2vbQSSktdNPvgCS94s8G5NrmmM7sTYkpKA4RoiVoWUjhULTfeKLg	127
10906	2vbAhAuP3ZtwiVfrNBVN5pvKXS1YhCXkb1P8hJStcAmk7mqNRxg9	127
10909	2vbYD9WyUNXWrkbB182pGZnwf6t71WTdrjEihguWLJJB854T5q4x	127
10912	2vc5DwS3ZFJLNCTp76CrAP6LMeJQyFUpNfKc9YB9QUbKb6jsKcqj	127
10913	2vaa8AteNV1dBGbu9HEmixHN4bw6tF8LtzPncD1LaNg6HLfrJnw3	127
10918	2vaogh1EFxaP8MsjmvGCq5tdDdDubHacTsVe4ht7t7EhNEpSPuVh	127
10937	2vaQcMJF5gp3cg45wFggtGd9SHBWRoPh67NbjUNYJWWePU15FjZw	127
10942	2vaqJ7uBdTk4zqDi6tv6BgMpfFdKeZhi7d8249pib7gNK85AqSHW	127
10944	2va9Xvue63uyAsy6ik5vV4UEDPhmYzQUnWuYZRUkam7U9e3pAHiC	127
10947	2vaytcHPgqiKcFw5Lx42S6bjXmuZDdLx2Lx9ATxJzEXAEEeVfLen	127
10950	2vaMhan8JvoeSYZSqhRnRH5vkMc7pQqHb4cwvERN4UW6oKXmN5FZ	127
10952	2vbij8cWEiGvPRP7a6cecu6sebtYUGHkdYEnA9hrc9dgTaaYTnKz	127
10956	2vastgDyQ2GxjgqFAgEY3UrdibedxennKFmL2MD3uFL7s58XLo8b	127
10961	2vbUh866Eqqx3ZEcQHT55RyYJehHS6BfmqhuZ9gpUn5NBo5RtxTh	127
10962	2vaF77cX6yJ76yWiWbDufN6TgxwwPGjMGT5VMvKBPtUybn8uzPS7	127
10965	2vbbay1MYym14GHc635XzCGmsj15AB3tPegSw47HUCZQGpoLzixx	127
10976	2vbHwDj4uDVvCQ2MnoY7BPdHn2F7kDv28pFE1fDA8TYimNRteowN	127
10985	2vaDq7cmFyzvZL4x8a65hEpSv5VtsN6zD457DzN2qksTh2xprLFK	127
10987	2vbGej28XrfePEUEBkrJ6dDAwe9AqAacZ42JwaccfY8ernNQbK5g	127
10989	2vb9xeU4xahK4NWYpUwqhX9yoCvAcVbbFVXjGjsoLszPoxh3ts9c	127
10991	2vavtDWzKpoCkC6z1F2AMwqxQMD4ssp6gG8VAnpmrCR1irogemDH	127
10996	2vb3zmx1eJdL7YB2zWXttjvZ26LTnCR2PETbbXU4ByfW9rAqJEvh	127
10999	2vaM3YbJkREe3QydcgSHF1fLh37NAEX9Kpkz8amNw5W6qn5HpxBd	127
11003	2vafwYmgC8qemMG3UkYRPDgyKAcp9nvDQpCjdMqB2Er2QDdzzNAM	127
11015	2vbVWUsEYfdkivX2JkbwMz6p22H6obrGqYRQp1VCHQUXmU6x44Py	127
11027	2vbcdENy4crGzHtxwaKNoALTdiQ2Tk92xUN1KfmnjeXa4Vrkmj9H	127
11029	2vaiB6fx59gNWeJp93tpN8DpqsoMa1jGPxNjiUVou2zN4h4yD7yC	127
11032	2vaUhw6HbfNhN1bCqFpoLnDAgbN5DD4v1f82TAGUeyTtaPyR5pa2	127
11034	2vbFfFKULZPVqh6yewJYJfzCQZmPay7J8aBAkSpuLn5kzVTa9om1	127
10680	2varPbP2i5sXNXQYNBt6jzMCH1Srcwi711AjRayNPMjQPu4CTU4i	127
10683	2vaq1ZWUFd7To2zGH9H2KtvPKoNNQW3zcgbYTR53tVEqepapDMQP	127
10688	2vbhwAtyYP22ffPCBzzdEYzEd65wvM5AkAQYVPTsuPhuvmf1FidK	127
10692	2vb4kqBW4fvTBDm7Wpt7ehgQCJMYb36j6rYH9BMnEM34khs4yxTG	127
10695	2vbvJjUa5gYExAC2TrM2vPiKjLo3932xhD4fdmqF9kPdjc6WVjTN	127
10697	2vbvoNNyEFVGaynqjJSiLoZ7LPdq7NmqL1mqEyMzMRjqUJ8j2BjT	127
10705	2vbWF9aa8JYe65VZ2yM7VLbB5VuySoPmaY6Bvp8nqMWWDB5jrqsj	127
10709	2vbXHUkgYpXsBUVfNMSHShzux41yDqT5ErUDkBHdZxGcBHgFVNud	127
10716	2vaTFGMH9EWPfmJ5QpSRvQSWYPUygCtuyQmcv2fcFifCbm8qQMgB	127
10718	2vbhuERZu5jcoUxDxBHRbCW93yt1FytPFtF3y3RXWt3Wgyngg9vU	127
10721	2vbsS4muVWSA2egCDRtKSeYorW16p9UDVWFhRpBjdcbjBMAzL592	127
10723	2vaRB4kmrL1ch84xg82f6q6Th7G6W1x8fgJsF7uwyvszDrhaDUEA	127
10729	2vbEcgbAw8ybqoeNNkBoQfYXFY9JMPFTpxXEzcki23yK7b4Y6Jaz	127
10731	2vbt8YV7hBmgiVFnpbyPKnufYGADTpJA4YrMcD55vwTpvbM1aNY5	127
10733	2vaNayUqw7jZfeQxoxJs5PrexJ4NBr3vVq1pfzsyzEPJSW6kKJ37	127
10736	2vapnMtsGYWua4UrSBaAM6EQPfv7x7Ap5j66f6B6iZkXn34xR8Le	127
10739	2vbXce2AjcynVTHBpsjXQvsoz7Y7kDvBUYpVDeFcsEjAsx9TEJhN	127
10741	2vbf7mkTnNxpUdsRtSAdUwYWWaCZWvFDK7euDwoBMVEYoJybnDa5	127
10749	2vbeECdM86peoZFGnabTiHgStqXLtFre94Lz1EjdjCSFdS186T4a	127
10751	2vaF7N5LPzdza3bqPmjbumKY9oZzfVtBKZcWaXo6VZSfFaSUCfqu	127
10760	2vasN3JVkADwpxK6KUFC6BeydbwMSYrJYAZsBg9ywfWJd8NkBoCH	127
10763	2vai6YQNHKCts9NQuNKNxVFL3aFeenBWQEbJankVfptrweqW44BJ	127
10766	2vaMy644jopcqmPbsyYPFmCHAbJfvseZwSRR6qQQtBiZ83rAJXeJ	127
10786	2vbyeuBJ8sd48ChFG6fnxyQWQWy3e3k8CT4yrmoejz8Ney5FAKRR	127
10793	2vbMxpHRtSFQkZvuK4egPRRmrfPQtgGixhUpNvPWmhvRTd9MRKLz	127
10808	2vbFezBoWYZXvKXL7wfwEiafmEmHzUD74pKTwwBU28Atwoaxx4dt	127
10811	2vbMgvGedo35kcdz6qtgCnuaUSECcywcovMrKviesTCzbDktAF8i	127
10815	2vbg1Cydp98tNyYP4hbPEtpLtKsgFtDUMSG5etMF5ZC5GwqfJzc4	127
10818	2vaYeaVRE6DyVFYAzg8e7Q1D3R4XDDpNzjp2d4Dsc3o3ooeyVydr	127
10821	2vaZenkEBm1xQ8yKGRDhztokF3ZBEbVGnLmc4W5oGZN9cG1tgTze	127
10823	2varGH8hMzTgQdNAbzvNEXi9d86wvPZ5gDGXRsjkEp23naLCHt3x	127
10825	2vbhBHsqbKXMogZx9TCepvHLd8hfA27kYcg8NXgqz2mFLjnNx1Nw	127
10828	2vafBbZbDNt4ejyq79nJRg4SQL436P46ukmToZoFPrB8ofqnS19k	127
10833	2vaArPum2YSu6A3tpnijYUGHXPcUdzrHW4BrZwquDBR9E8wVXoxp	127
10837	2vaj2v9F3FBPgZ5r2a7Q1vLdGnep58QuRmm8Ra5GnjZaJ98ZmSBT	127
10842	2vabHcgv8bcFwiGcq4cUczLNrZzgF7Yqz7sQ7H1nXTWez55v3XYp	127
10844	2vanfzHZHkrUoDuqdvw6UjdD7yAf9gEtvdeJE6edxDVKQUyftt69	127
10847	2vasecQFmanp8rPZdGforfnd1vypEZSVezGfUBBcwQeVYqECXwFp	127
10850	2vakyM3nQbj2czJbS6Cq1bY1e6EsESBA8UwqRbcxrWbnzpPYfC5Q	127
10851	2vbpb4ogURBeFFeA2wbhmib3ozcXkPRbRvtt6TZEyq4zvRmNqHDT	127
10854	2vb6jLojvz9mo4rVHMqWCBAF1JfwaJyAWfHpeeXhdLJrJvA21Xta	127
10857	2vaWmTns4Bak7iH3bBEikwUSpTkcjWjk1BCVtkTR7HF6YwKgU5UA	127
10859	2vbNGEj3PLBD9e1bxQhkJ6MJ7xphoF1u3d9xY5yjBLBbyDMqNUU1	127
10861	2vc3XKcbWrAU7Ec3rxQw5MP75bLmhVraSk6LtEM51MpAJFkCJJ6G	127
10865	2vaQFtKU6R3r6e1mq2JjFJQv6YmLkUHjZEGtWF7Gx8BokutzX6cJ	127
10868	2vavYjr816rTGfV9VNxHJ183131GCZZYYWwSBThCjAtA9iH7oWi1	127
10870	2vbjVwQyJVVk6iGAgnAkwGTuwbPJF9pBZP9zHaojAZjRdEctv7u8	127
10873	2vahG8dFQntdtX5XfVrEPFjYzesNU6n5Y5VqSGr2VmEJd2mKAsfQ	127
10876	2vaEMr9SH91cqutpfUBrNLuDuASxWGxekZe3GYwLqrWTtTe3PYTL	127
10884	2vavbZDvzBPco2v3Uhy4ny7vmg951aE7mx82pNuUKCuHZ7aXTE1a	127
10886	2vbSwFAHKmhu6tFovvKFrmnP1eqYVsy5SPhXF5Tt8gWV6H1svi5T	127
10890	2vav2g67TdiRy5Js5pNTddn6s3F2Fp5mQ6q1Ag6y8hhfYYk8qJ31	127
10893	2vbK32Zm9a4y5C4nrPVxV6yWefwVvdcQBK6HZ7J4YvmX33RyMVRX	127
10896	2vbsvfz3Rw3hggi9FvZGGXaL4FXCV1sXd9UJGKQR245oFGegTy3D	127
10899	2vb2CeBXXK31JUY8bGdvJz5Zw2ucMGV4xmYE1uYAJDnyPhK2LiYS	127
10901	2vbrkjxrkydCNmdAid8JWWveV3X1QLRorCzwDZc6SfbVv7N8GZ3e	127
10904	2vbJTPMJSWBzxGTdNDQ9MhrXhs8QymcU2LcocmHb55aqwcgfn3Fa	127
10907	2vc4VwUCp9TFKRanRitiJkSFdrkoJE7bvZqq3q8jDku9zJqcEbw7	127
10914	2vc5PpwUarbNXsX89UAG3F5PjKvFWyPhfQ7em9mF4UkHjifcfohH	127
10920	2vc5ar5wQxD8vGppcFL88ocR9tEH5pxA75RcjNEv6d8HtL7ocuQE	127
10923	2vbCPXFf5wiSVyMJKQYwMckHZn3iqNHNkc2g9BZBGDQfEcEqSCEo	127
10925	2vaYUgXNmaixS9rbhsUERjcmAjyqoYxXYzUjt2Aq3yEofECW934s	127
10931	2vbcWvxyevibo4LAQqf8WCY2FTWEPrwjpmp1mbu7uLdp1USDFkfM	127
10935	2vabrNwDaWVMQxqer4GnwNbDtgY6nj7S1EhioDWoEffVEWrxnLYF	127
10938	2vbD8xkZZrQ9jZAShLr6BWjKgZ4ajQ6YsGGjQQErooHjYE11dYWL	127
10940	2vaf5JxvFtyNgjcaaQWE6Y3ZgPv5T9HtfJ15AN3jz5whBCmiyRJy	127
10945	2vbxNWsWcoe22aB7zCR3dQ97cUVCTQ1GdabKniBDYUCiNy1YiCFn	127
10948	2vc1iPBgb8KjqsqgLGpyd6Xei5PSSQkWcpTXJqaWGdguTTmP8hZQ	127
10953	2vbcXK5ecTBGMQtevnxY3vFQKNcd86mYBvgwKePBx1x81asbQEqe	127
10959	2va9MpffkZ24UtPxWtfjB6Gjzr53UWStWvgfUVYj9ArSAdb14yJA	127
10963	2vaSqLSQvzspVb1SqHcjZ49wKyUT7YXBnAgrFxkNQuu7T3N7dfAS	127
10967	2vbWQQia5eeWiyNb9D6Q6i9H9CDQnqQttU5vuS6y4UexWQ3pjnYU	127
10970	2vbB89h5XrVks5MkGHDQkL9xiPrEJCysL27FXr2PB1suJSQhfsZh	127
10974	2vc57SVyyhDXMrGk3ch7UD5WyFraQMCRgJaRL3Dgn6Tcw27Fhiij	127
10980	2vbQkbZCnpYBHrVuoXWG3CeqEEEMu8HsQCsmCTGXCxumKqcRp8Z7	127
10990	2vbgLaT2emZzMNfUJR8MK4SJHCxZyMebaW1cCceJbngRkWEejVNj	127
10994	2vaTZTWqk71PCU6wSGt49YvFqVXJai9u9jCHEjRswpuEmZNT9itN	127
10997	2vbj9B1VwiFWwsmkpAZRg4okZmymmeRm9hxgh2ExtWnJkNPmfq2y	127
11000	2vabknb7WqSFGrAo28SmwTeTcusLbJvqZqi8KdTLcF6qDnd6zXYn	127
11004	2vaw2n9kYvZSJ4tuZchq7tYdUb81NMnJDypSC4XaCwPo8odUdGF8	127
11005	2vaUJW7kf9k8E47LqrpRc6CWNgv1xsKBjsGnucN7vuveMwLvCBVj	127
11010	2vac2ioUdEzWBStNQzFcp7uxousAyruwikJntN3NVsxx4oCAqebH	127
11012	2vbEuBuyQp6tarcfxirQtigmJzge7vQym85qYveDLas9wcpMATrs	127
11018	2vanXaij3qp1fyWwpVzGDVPtFeaNwbUAuipuZ8Q3zeRPXwk7YiBs	127
11020	2vaJi9Wb19gYPU75Xv11iZxrUmZX9tLz9XtBfMJqxVNC3hY9PmmB	127
11023	2vbpGWqpbsspMrMyeDkHzRXfDHNb9N8fcQtw4DUxVmQfMdzK4uc4	127
11025	2vaff81Pnd5Jb47prQK444G91LafWq1JFrHi1acx6EWvoFf2igCE	127
11030	2vbzjVV2qc5LjUciLALgwvtiAcvShwAoppENBB5vNXAxDogFR91M	127
11006	2vbE5XfaD4zX2TnPuLRZLHyD6N1XbPjW4xZQJQJ2QCw3hcNwADxT	127
11008	2vbVKBX8p3FH5xf2Qa2ZxbaUdBCrZ3mDce9r8oYFKZVLSDRCb4w6	127
11009	2vc3zW731qyLycnC5KLDokbMG2xgpNFLkxjq1pdMJdR3FWNxmKLN	127
11013	2vaLFfjyxyPTAYatxsbi9L2nHCmCvkYVQYUMssfhwMKZcms9ZCQ5	127
11019	2vbsR44bBXosuDGXM9g6u6cSZC7WpdosxM9s9MMuvo7TUEb6sYqi	127
11021	2vawJ5M7gCUWMZUUgtKCTr4z9c8ArGWQs26BpTqSLYArmL5xjMxY	127
11024	2vaLDNMkoGDc9nt6nfNVBECxBYiiByvk1DkkNDr1UawerjcqqzAL	127
11028	2vakPXdCmHfcG3N2dtpJfwxU4n4QpkhQM3ATcpdjj1eEoEkpxYxi	127
11041	2vbgkDjR6upT4ExqDBGqBVasDxaQk54sMq3DbApAarJv4i9HVy5U	127
11043	2vaRekZKgheifqzTPKf2ZiDB7Vqu1a5necYrPxyaMfP9xwhfe9Yq	127
11054	2vbVZYoqKLWgCjuboJdFZCqwJsebmPcp5iBHLrHWw2DLenpATGYF	127
11063	2vb9V98XGZHZPBQvEBSnvoXxPCaNV4pRiELJsHEa78P81vUgouAb	127
11065	2vc5AjuoFD6qfkbWbWGm39723XQsZrha1xEALJZ64mDoW4KtSYbt	127
11067	2vbpYSoUrZVdTgXGh2VQMEm4eJNe55VnHaRWem4C7ozVKVDQ99fv	127
11070	2vaAz5cCDxZoV4i5Cir1Gc3JmF1EFDsGY3rdkKKWWcNAVXKcS114	127
11077	2vb46NeMtwiTwfMfyxPcoMsCVDDxca5knF5QwXGAd3LeoAsqJCvm	127
11082	2vaBYAmLMxfkNfrbqAng7o5DuP8hwYf8b4E621wj7xdLoc5kQYpc	127
11086	2vbDFGid1uBA1qgn1rVbWV4ARYawN3dhvEyWgaJBR9HmbFi7JaG6	127
11088	2vakWB7KC8MrrNnBmVQi2RKiWsWqd57ej3VVfyaEL7jqkEwdVxU8	127
11095	2vaV4G9HP5N7pdCqZKjpk2FrsnfsT39BuBNjazTWdnBRmR7eqNha	127
11102	2vc4cDMjBfeyLy7G3B29vf5G8mprTuxTjh6ZtU6QFa3W5QLa3i9E	127
11103	2vanbKjnytybY7rbXjfi5ZmfKNJhasHyaPT6YGSPdmqzsHxvfDHc	127
11105	2vbhsEAV8avJHceNexhHiMrVvvsCfVkR6KBoH4xpbvg73Vn4fJoJ	127
11108	2vaFsjaYVRfCQ9vuwV3bSeDFwiriGzcq8d4gUdxqSZcXzsa4r5AB	127
11110	2vbJybvboAbdS64a4J4gmAsggaDFZDr1ib9xdEbWH5fpok5fdsAS	127
11112	2vb67hQ8LvBhdLaMpttAuWMT9mMa7U4bsxm8sqjReN36Zv5G4c3c	127
11124	2vc1Xwexf4xNMcCzShjEwLQsjGZbUNrWVBWjVcxCmPb85RZDxiYy	127
11126	2vavUCDZgy6QYMdVpr9Ujjt7va4TDzymZLMEWRQcMj7zLt8Tcozv	127
11131	2vaDBrEuiMgGjQHrm9hZQYWPrcgMAZJpqZ91cvTRTmNtvhLP4qtR	127
11134	2vbB9qt7RrW34MSsXRvK66fDBhJUwcZsTGuVDgYFSp2iYXwV7RzT	127
11142	2vbW4oSYWxs8fAFYj7zQPqH8et9MUAdtbhFLWrGz8EjsoXNeyKqU	127
11149	2vbskC9tbr8GVBFVszrdLv4QPr58PCLKCNU4gPE4hRuzjQ3zC8Nq	127
11152	2vaTHBuiPBdZEwWSmNshRCe6GStK3UTjQQ5bTaJuRncvBFdxvtfw	127
11156	2vbGdub6cDnJCdwY7z82X9gzrbQH5u2vshAhhjsem8PCyTZQDfrv	127
11161	2vaoc53By31YZRJqSw9qnnmLFdUWqNhVmGGquaPBVvZtKPvJRY8J	127
11169	2vauMhRMSi5n9fkkZSyxYweffeojG2MSTcqniZcMuZ74nW2wmjsF	127
11174	2vayY88Q41Df4GXoMgggpxA7ZP9cD2PMewr8eVKTRcLnjWuY7Wkt	127
11182	2vbhN25EbtvXV747D2KGH4j3oAQSMtbe6J9gLQ6Mn9mzcXvw5XW8	127
11186	2vbVjJ2pPejmUjCUx2baUd9w5NJSzFAuY3pGwahR1hLheqsChoSz	127
11189	2vbn3v3qXefAA3G9NT5yWhBgPZRpQcnL2WTNk2hR6ZFMYgLdjmQw	127
11195	2vaFqr1TJucQWzaSFdj2gfFv1uRfJrNvXbjggGA7eo8azKzzqnSJ	127
11197	2vax5ZrMJ3L7dXFEz7UCGeS4sKQhtKMcqd61d7SMhFbS4FP3CRkZ	127
11199	2vbhneWSv4DDmLgUPw7uHVCuPxWb99uvA8bF8SZ1d1mepn8vuXxS	127
11203	2vbs41Jec1TfUm8qKKHgffhoda55qrzjdYfmp3G1hiaTuSTFn4T9	127
11212	2vbWVM3wyEXkyiPDozhPto2fk5NYxBeBDbN5hoz81X8PkJHqt9d8	127
11214	2vb1to19upec4Qh7onURqbPMBa3rmxY5w8tSz45rJuRFfvFUEZRb	127
11216	2vaaZheXZNQ4j2iXT6AQgh2yecSW13RCBweBhDWtNtHgY1D1GASw	127
11219	2vamR3pBgGQPJdTu7uenHh9NCVAQDYL9WrCeqZxajSuuodqxq9S8	127
11222	2vc2L17SRnNotcUvetGEyAvorDvmUSZY47tamYiraQZHFucc4jCf	127
11223	2vbLBGRHSPKs7qCqkx4wm1qtB6aAXajJbb7tag7vCjxF4AH1iRYT	127
11225	2vbQZP33UazB2kMNn2RvbAqLnReQUPmcaUb9HSwfiF4KfnvF1SD7	127
11227	2vbfidKMZ4P78H4QTXyufiRFhq3NL3qQHnkBb9TgJzV7bh6sJfZL	127
11232	2vbt8wiPYLazUczJP7V4HkgyMHZtXAiEVz2RGvzS7fo3M8rmrEZN	127
11237	2vaU1pMJ3soQN4eDKKpD1oH9iZavEkmqSqhtk6kuzbkb5ikWGFD8	127
11239	2vbwqqywfrRCsNW9EU23BVgWbYPsS1YcXNTYHASwg4gfPrMQf1rV	127
11242	2vc1kmtuyuc5WZvviE6HNhwPXjxtVDS3eNF9EvY92fHwdVXc2ME9	127
11247	2vbYXVLpqn9eXeeQkYkxUvLRxA2VPM87qPpf9M1a5T74g4QLSZwH	127
11249	2vboFNXN8QvYfKRtzZenPktoM5K3bSVj1cYYDMVPepEDokHQ3iEw	127
11257	2vc5cbhrRHFe46n1Y5catGTc4FGDbt6YS54GJKt7xSDqysM4Jkoq	127
11262	2vbYGJej9AUQV79QkSsrU7gyAz799b5hZfwfa5XocJGiiRQMFJiJ	127
11264	2vc5TVb46fYwNfUwYef1pEULPECAmrG9Vu8dh1yEVq3j6nTeBPSY	127
11270	2vbALr7truGA5we3DYGQpEjQCx7wP4gt4STq5Ywy47q5h1NaCA5j	127
11272	2vakugi6xQbRGUFoNAX1bA2RXGwKQgzduu8SPe2865mZfmqsXZLH	127
11275	2vb4VXi2REMPFGgVDDEe76vQ5Wkcsszxr5icXxFZESFDdib9WdGN	127
11281	2vaJe3zWMgRHPggKfESrKBZcGKJknfKm8YqavFbiN1RQqnH2rNvu	127
11283	2vc1iF2avNy6G4Jo6D2o4ZKZnd2Whrtc6LmXtDTHUUH1EPtpw57H	127
11286	2vbuHHuHgLqnM5v9VNtEbCCZ9Mzi8CwhkmUqMMXxe4ZCCkGtz6F7	127
11291	2vaUxTGWic77Ex4oGF4MdWM1pZ3ogLK6WX3YoNn2K4kbzXFmp9G7	127
11293	2vbqMuf48UugAfaDcweDckxF7yezvuidVVVYgcwoyJgnizFZFcZy	127
11306	2vbf6Vcca1bVom4bsmWeS8UYmBcY4b8xbD9ZTptHyyHHwzKqK8KG	127
11308	2vb1HTMeQbpMFs4DXn2VVC79BvPe1fuomrFuQ5dt8LMKfowDjDEo	127
11311	2vbERNhcVeyVUm2emrAt1m6FXm1d9AhnWpXqGEaprjd7Xv3ZBY2H	127
11313	2vbyDQCwGmngQ2URofzvYebrQix16nk7aZJHovBdZWjVsiPPQTy4	127
11321	2vbDLsHZht8dUtXvKbU17cVYLnZebibANeRfnz9V8sJzPoEqtrur	127
11323	2vafu478SCDDzvsgcxQbxAHt7UuX9hRJ8zcembbiAawixEfWq3zp	127
11325	2vbdGJG3h5eu2maNZrobKMz1tfA8j8DuaqC7odXycyfGhQWTPaJs	127
11330	2vaTSjXd3rW6WTxCpybjSo9Qd9Wyi2Ue5wyFSSSWYsudwe4Npj5Q	127
11331	2vaXo8RYuDuL9SyFGTghM5fTjQmGsWrviVHvXMSZeLAk4L3hEDEs	127
11334	2vakUmfDgFZ3aKybEwnmwV4q94UkwZZBjLUoMupF137vRmeJVB5B	127
11339	2vbLgyVnVut3oddhwJ8K3jcjHmr62WTxeKvKyRNm8ApQYRcoSbcZ	127
11011	2vbQ3JM69zF3csH62n616XcJZFLbt1eDTDsHjZZ4LE75FnFREMMv	127
11014	2vaw1p3Kgk8EwS2DbmCUVio9exMjRmRPvRgAD9NnJAwwbnuC37LS	127
11016	2vbPLPSd1pE37ZUMPXvm1hxK2qHtEeEjF83RVEALj5GPQYeTXKtL	127
11017	2vba1ZLyjzCcZHWWwn1eJknUmQQLVC9xd6ThXGHxRd9JkgcZu51d	127
11022	2vc3yDZmTjp3vmRiBMQ2LbHWtTVB6d8V68UpH7R9ZC1R8sWTeVxQ	127
11026	2vabJEjqwCiXSAWFY3jLWpeKLZagMQFpb4thHcBoCfGZLuQJr3dX	127
11031	2vbb9oNuvCsJtroLfsVnyTXRgXvV2FT3haJpU5Jkt5ZggCtCb7BF	127
11036	2vazr7NuioDRqzmCbe26UCeEFDmDtSpuSG1LgKnU1oJKNP65dCoU	127
11042	2vc5ropNTMfPqzNyCSvtPEbg8bohbvxUHHLCDaq2L9B8hwFBAbXi	127
11044	2vbEjFQcSSjEz4BrGiZ3fN1eFACtKWehHVPw7XVL2RpKfKfBNPrT	127
11047	2vb2858Cnixs5KAF8R7p6Lwr7xpFcXvHkZBxJ1GUJF2sicg5FDyf	127
11055	2vbrNSDGFp1tQZDGsUoNcYVPxaz4w2JAxWpQGihjVimvmacNBEoF	127
11056	2vb5ytHHxxKQcE1fDSt2SfrtKEejsq1woN47GhgMY95TgvKD7i1w	127
11061	2vbnmtuD2ZgsfTY1ypLDYsG3gaFkhk5bL3rnYutAGSCUkVuaNteN	127
11066	2vajsBD58ugPmA76e5mQFCHXw4EZKgugdCrGoYnpQ9HH6Ac3x5Pe	127
11068	2vaxBkvCtWomkGMr8EAeUBbjaHSMiRbXwZgbxHGAugeJYxzrzjyj	127
11075	2vaamoKZF8u7Kw1gHcv5fXJ4UJTL3w3jzDPrcfwksKCi6HJ3i99K	127
11078	2vazpkBsCK61a1bQh5ptaWaMcr55VE3c7m3wkBSbbo58aKr3Thje	127
11080	2vbFe7tuur8PMDFpmcxChSVtc1xJpbqk1MLxzV6AB7SN8dP2Av7Z	127
11083	2vbVE4UUXcJ7JiFBo4Gmmsh5qfkV18BzkT4JYEnhmyEbjWi1Mmop	127
11093	2vbZtXpnsT8CCxZB4a8V1s3b4T5a4BxeVSdJviviusodYdy9U6Yp	127
11097	2vc4zyiGecUF4pNPgnVSQ353JoUfqgSaVPgPgknWevr5ysPajmdX	127
11098	2vaQDV6Es37zYaTNXWpVSm5vvpEhdaoEdDrj4yDSehohHK5P4Bog	127
11099	2vbQKkrefCEKUqGFESMrfcUohc4Vj3BYXek9Js1PvcjXgc74RksX	127
11106	2vc4LPs6Uknm9ZXMt9B6tbD17UpygGzwfgm9AqWS7Nh6oFoa4MdW	127
11115	2vbb76bbsn12BwFT4GzgKotWuqr1Qz9psXaR8nCL9gbYvq8gt9xW	127
11117	2vbgYK9PjR9WLkQu2YYBie7huyBoG8MRmPqC8XKTUAR5rzgPimy1	127
11122	2vazNmxw5DnaLbddtrDR9c27cippsuL4qS9VTgAy4zBK3syPgpqX	127
11125	2vabrF8wzTAHmk6SWAjvYrBbDFWjWof24Mw5TLtyrkE6Fj8rgnn6	127
11129	2vbqSAw2tqgbZub1Q1wGoCiSRuUi8GW5wsngLoCePKecWUonLiL6	127
11135	2vayXiEKPKesSz5oH5tbEhbws2qUTqwmBvS2Q2pbwuga1Yp1yaLQ	127
11137	2vaW7wudFMSHCX93gMjXviYewN5av7x7Xi75rYwr4jzmPzwKJNUr	127
11140	2vaivevxmcU9JaVow2PvfM4BusqqGXnDsygQ33ZQ8cVX8TWoEDFr	127
11145	2vaicFb9P7BffoxhbBEmUZEuSX32vm7abTaF25kb7rrHxh2kgGJE	127
11147	2vbhseT9MT1UKFxUtEE15DKrbE5LH543RPijgaXQwDDprq4MRUDd	127
11150	2vbjaLfaKQxpSAWUa71ZS9UA1UW2jzYsED93wdRwgGa5MfVBFiEP	127
11153	2vaALEUF8RD2YE32EtB27BkKDNLaFBfy6zwLoPW7bLmxB9PjzQ9u	127
11154	2vaAdFSBkqxi2A8zGG7944ayEjDsyjGFbT9siTt68SApHuDgtVDm	127
11159	2vc2v1J71ksf6B6HCef9ZUtYYcwu5G3MPHBHADMi2nq2xsUzLd2p	127
11162	2vbbgAaaVuQ6u3XHjoSJEuLrNruqp2MgMte9DUG14UMh6TincF1e	127
11164	2vaT5fQmoqekHTLucsxA3xcTw3FjDnttGJgMczPRaeG5nhaW5Da6	127
11166	2vbFeyn8kTLLkReTeT4Pj3pagrYXydCeLYw2F6iKVv9YAzEzuba4	127
11171	2vb1kKZSbUK6VpQmTf3hyvAhNkhP3hTA1M8KZxEuKh6CGQKciGm4	127
11175	2vbkwpQhmRUeWTJ1WsDUacPAJLEkzWA9fjMwcEqZgPgQgJzKwiDh	127
11178	2vaRPFoWmcmakPwreYUJnV7CnrnPcji3cLMM3PyxKTeymctKQvGq	127
11184	2vbqhTzQVMh3xg4Pyr46enbcwpiHJFMBY6G7tpMFvi5xAGwkPDpY	127
11187	2vb3FPNGkaa5xJP18UbEGPoP8YhsKAaMdhnRB4JjkGFzmzggP8pE	127
11193	2vbMijzsgMDdcUj4tXByKjXNTSDmBNLEzaTPgo9jmFqFK64fXBLW	127
11196	2vai4ztaKooprSzZUbYWp3WLcPvHH3j6oX9FQyttFLXZUSjvcABm	127
11204	2vacW3f6N1B78dF2aPe9kHp9yXcxGt74rXKWhCWBe4ejK9xRbdL4	127
11205	2vbekBhCtfmUjp98LJ3cHZXm1ubyQaHXPYZkAXfwTx8CdMYimgrb	127
11208	2vbqpAZK6po4x4PQxVaJv8cZyS6RrCNh2ZvQXsWDXnHL7Kbs7mt1	127
11211	2vc217cXaeikhXDCZ25dH1qBCKwQJVGUNw5LXeshHd1TheuTWCjQ	127
11213	2vbtYJ3mQHT5ymq2TeLAnRcSa1BLTf23ov8S2LQaTUa2oX1v3onq	127
11215	2vaHmsrVSKDPznsAG2tkoM972mUZkfqPGwZ3S4i4yUiqbiqbGHo3	127
11221	2vbcGZXrJbEnDcKn5fEKtdUp9pd3HCoru12Fx3GuqJ5cGFiUA7ZD	127
11224	2vbbaLhekQv3fUo5kPz5htdLqBgtZnjCxcCMCm71HkPLQFhNDWa3	127
11226	2vaJjssd6CKEtdn2gTTFmqi6UQCox6PvDn1GjPG4wvXHwctTn7yp	127
11233	2vasrHM7bnbT9igX5nrzt98v3TvxrpzJR4HwwnPECv6hvfoNB4Gh	127
11238	2vbUkAdn8hodTFWdJrogoj2HFzmKgC8Fjk48adqQecaiNRMgpSeE	127
11240	2vb5ri1KuC73BTe8yyavgZJs39qQh5ZaaD3MmL4i6y7LTAV2oySk	127
11241	2vafyxULzcrQuGRvnZrRTsBiKuQ5Yw5ZybSLQ5kVYVdaGvSuXZFw	127
11243	2vc3m9TLAdWFvDn1VBQQm5QH998vbieVthaZHJXYW48mNJk8xS7k	127
11248	2vaemTAd6KiULefuNkQQTV6p9o7m2YXQCdfeDQpddeFKxQ42difV	127
11250	2vaSh7pm7Kphvn5yzGonsxWWNd82raTC4k7oe3uYcsjPz11hpdxA	127
11255	2vbLECKUR5TR9Bp8qHbrEoZbMe4KaGUQBWvMeKjBwgcZ5AXrZEws	127
11258	2vaacnMAHU7i6sAQ3rRyQsWpyp2CoCgFieDAs1C94f6SKVeRWSGz	127
11263	2vbYbDBmh56h7TGLBbSf6zmmRYeML4XSQQk42poUmiJ4zS3nnXVb	127
11265	2vaouDxPWyjEFGBu5YUsfFKrDNgymDyFvCvbq1DDYRQxAWhATmCj	127
11268	2vbSM2Ynksvrm2ahGWVYuj3SjM4K2UEMJJictHDHHFH2mDh8j7Qd	127
11277	2vagY4u81mVeerA1bDgdJYu4X7UrrWRjPpAhyeq2fcDQ3UryTTQQ	127
11279	2vbDDvqjF2g3oscCjdnThrjXFt9Dfbp1LvfUkPuZEvgyjBhVbgYi	127
11284	2vbnEPAj1Hb5Na2FRrXvLhjZWDdNz69koVNGTA7T9BGqaZaJFA3Q	127
11288	2vbYLruJa95NLFVXLE8kGRedNiPZxZwycYuvunEt2c3Y16jsoP2P	127
11294	2vadqk3NRFE3UdZ26WcEVgTUwLSD2FuA6UY69A5ecGHV9nRbBWv2	127
11297	2vayfbT2us3tnJxAtpPxtQACerfapv19Wsw4gbgj8fLJt9P5YASS	127
11301	2vagXvuQPd8yQ3Tda86QpiWmQceQnN7Xcf14x4bjaT17tk5fyJfB	127
11303	2vafD9LF9z3pErQGSvBR62aEVztFpMGHDdzU2Ao97LHjR74ASavk	127
11304	2vbUD7ft9WYC4htPn556hJNz8JvfJtJqd9KWcZtbM4cdNvjkX5gp	127
11309	2vavaw7Agg49VH8BZuLjLYozTY9Hgdt7GzFFBVnTJTZw2hweWfUH	127
11314	2vbjavp5rtq6CL36xX96DGCuuyB8bGgckXoVwM4qVC2FeX95RcRX	127
11316	2vbMsQv9gQQ5UA2pT7VNksQWZipeMwYkXxS6kNugYnMjnRPBKrsY	127
11318	2vaGn6BSkv6wEZ5kgTVZG2znc2gU3owWJ81FZDkPKhTC3kn7na1U	127
11319	2vazBRCKzjT3FfaLCVWWioZJcwoZ5KrutVGZLfHAWw9LXsTY3bnE	127
11326	2vbVNBqHHtnB2UgsHjfZSqEF3nmQwQP5zMTHK6N7gP389uqHeXfB	127
11328	2vbQGpqdJSwUoquGqkkEp34HWA44fueBi5PifcZsoVoMuHbm99Si	127
11333	2vaeieacSEXFQAQu3yvwrouuu22dfRV9gZu9b9sXtwckx6sAQ4ev	127
11336	2vamEfbtjcDEQiXL2xKjyRXbVYz4tktMiJEGGQxrsjqbxiEJF9jf	127
11033	2vbpTXUacG6rdtbFfELoNhAmryvML429cGjpGT4chdDyXnZhaFrE	127
11035	2vane4TS9UHmp5NLxEfugXbFHuc9PaxAZzGMh57xRut7dbAkJP36	127
11038	2vbVxk6pBBEwztXKNhiAbtLzk7KZne8rt3F9DX6dEw9Hm34Amxgz	127
11040	2vaocpi39V4ubhXg4JvrtgV3HL9nwomv74RYaGy1ithSBT3gcVjX	127
11045	2vaEKPmZ62fMWeiF6ge4jHZwrwcSDPUiDqujS3srwNY4QGd8t1RP	127
11046	2vbeSXGqWsQTH7DxMMt63Tc9wAXwAbs6XGJaHARVNv6hoEDk1Zs1	127
11049	2vaPE5zRN5qqPaA21EP8Qit6xyfJzyDHrmnvm5Yk448aLjTcDpUC	127
11051	2vayJsZkK8jAGQG9FGGYPuNHsNMwzQvrfiRBG92pW7uAiq2XdzeC	127
11053	2vbvDixmux6jqAbcFboVWtxrUsZ11sEasb6CEPZjKeWjj2HrSVBv	127
11058	2vaKHesKvrYkSJcRrCUqQ9B6nUoGCYdHCQcvAUo7avutCemXeqZV	127
11060	2vbyArVkF9SM7xSWHyXRiWzB5yrB7A5fFgRDjhnjkayAEvVSkGYG	127
11062	2vaKMiDZ8LomKgAUxpcmNSgTV8iULZ2D15AiqfEyDrpGMyQbm2e5	127
11069	2vahLgnkS5yqcdxURUPoXWxnLvt7dFNuMys4JtvzbuRnYziVhMSf	127
11072	2vaWCduwDbrwNMDc9FbSfw6qZKNW4QqCjo6Agv6QJzYZASjgikdz	127
11074	2vaRyLnZeP8FZMzg1k64tk7vVnge3c5Hixr5hAdgSBcSxn9E53q6	127
11076	2vaGEHTGGmz89utNggeZe1PuM8RP64TenW8eD3mKjXiGCbuhwWSv	127
11079	2vacfhh9xFFx5vpWhixca853XFR5kGnyfnY2PT8y7Q6kCbKUeVWz	127
11085	2vbR52rQNwbWyXL1fjwQLp66eekwTR2TfocfVRGL1EK6aQ7otWYx	127
11087	2vc3jYeCGCrtdw55tsf3nSK19onaRQmsJEji7TXp3z5HQYuycar6	127
11090	2vauWFB4ujcEuhAq51dgJtwhA5mt1THu3CoYAu1i98Yv8B64FB6y	127
11092	2vbPS5gqBX9KpDiDTSoxZzBdaeGrGnCMa1KJixs4TkSXFpGbHDEY	127
11094	2va9EmMz5mcTshaJTLNaQ64Ui1xdfpjqvHRMuqFzjBJm3B1hYaue	127
11101	2vbUhpmv8TyrAR3dxzHAshZTAtcKDD3aGxXAsYRM7pMV6F5abJMF	127
11109	2vaAkwo1XmyvUVNnAXYWNfTRXm3TMwzsiHiXrFu3rkuagE9n48Vb	127
11114	2vbbTrGeNERiJ3HHwQqSSe26rbEnePsxp4ES9oQEAZnjzn7aPSCi	127
11119	2vabJhS5mebEm3rgUCUD3Z57LM148eAxdZAELN41kBDA8qzhSYWN	127
11121	2vbV7RxfN13ojgYaKhFrgBa6HhU8DtY1hhjTPZjVgfuv3s6X4oAc	127
11123	2vb1tQhf1fxAhWC284WbP6TEWy4KvkAFQaXjUGLhebXrVycf43k1	127
11128	2vaox4biYG8WknyWTkHTcoqChrko28fEizmbQ6rS2yYRbGgDxbEG	127
11133	2vaT4jLqybHwisRFvnDqWkUKnBRpZJkBze33wERqudZnLqfpGQL4	127
11136	2vbg25k7o7ao3bojP9Q6oCScFW73bbkCj3Mvo9X9xGwxmwB8ouFG	127
11139	2vaZdBbQZ3grkisNMh7EDK5erd3vxu2LPYxKwPiiVGQFxJqaAsAM	127
11141	2vbd2UNw35SJC14AuFSjkputMsWXH736zzF3FRRbptr6ovWNQK5a	127
11144	2vaTt5AS3nMA2z8ALC4USH72LS6XLSzk38AoYtYhvchh32TT5m2i	127
11146	2vbVXnRdtJ5xgm5NogZNha2ZCv91Ax4gp72XPm5jtRoeYyNWupSC	127
11151	2vaZoRRkeVhA552LZSfLZDFixxxM6E4Tf8VtLSpyGikUyBbYwk2h	127
11158	2vbifqPJuP1URJSKB8XSRQxZjoJ4AZFb8yT989FTuuARt4AataoL	127
11160	2vbgsDGsqsoMQHGNjZfDj6BNdLfbtXAEfCEU6mvoDyFxty5kX4BN	127
11163	2vaA1HXnrHK6ZDuuEvjX8NeQMPsSWfkhLc2XMBvbqsev5tvdruQe	127
11167	2vaAqKDZrvVPreGat3vpfqLvt16kCVC3XHc8YvvoLVkZ5zU8SmpN	127
11168	2vbWkcwje2wZz3TnU5ZNtGXUHfZXHUZoKSL5PCK5qvVUKLUXPdvt	127
11170	2vbg5twwEwyEg5rQDaHsgpaaP26epLJgFTVueLpiKNYnedht8U5t	127
11173	2vaHyMhf5wi8PjbLsvWqapN3pPKhCtzNCGCzrZ1DTZYc2oYUNht4	127
11179	2vapshCeWLyKBKGCEi4EN2g8HroWXjgYav1PH7y5RxBN2ftCiFKt	127
11183	2vbK8RytWvPb3caDjfc8qDpKnMmjUKPWM1Rz7CrJpddB8nKm4oUK	127
11190	2vbmDRVELSjNByQJ2so7HspUAodHU4YcKziFG1JadUhpPWqPGSti	127
11192	2vagX4eBK4YuySynD728n4SZbaorzbmiVM6Rn3gA6gKzNFkxNxWn	127
11194	2vbRjLZVtVXvryrzYuwt6tt5gXpNtRNo4rDApJ22gxpXX2SCUJtQ	127
11202	2vbQNbRTjN5ShvyF7jQ5HUVVq4bWWZVz1gVwQTtPytzuy19zbtmp	127
11206	2va9XGQM4pSntfyvccrYX4EKpjPpAwGkZB2hsKnG2BzkMnWoJyaW	127
11207	2vbBcbxFyr2WHt7g6ag2pPaKWYH9CHKnNDxdbSwLFNnfBa2gKugr	127
11210	2vbLjYKSgoig6sV4jyt8wqF3KJzV7vytao1QM7u9qps36mCPqTgQ	127
11217	2vaqe2UdNcxiG5TjNmFpYY5Fua2cxiB3gFu7YDcPMSFT2aDVCCxT	127
11220	2vbrH2o5H9oR3jqQ2XgbsDLxX9zJD1sDMfB75JxF1hHvJyq9QzDZ	127
11228	2vb2swEwjHiUUryjuUTDD29oUfi3eLQTgUJ4qqCqEP38t1zZ5uBm	127
11230	2vaYRdkGEsCEG1unrWJs13AS3bY2w8FeVj2fsik7aTsq81qZh8Ws	127
11235	2vbWzaLqvT8BpYWs1iAd5FdBvFgiBoqJWSakNFp2Tq3h7X6ufnig	127
11245	2vbBH9wEtia6g35tUEvvJvV4rHCWbFqKFqpsgyc5tLvicgqRX5JA	127
11252	2vbwb4MXVYzQpDY4xT8A8554JwFBY2TovC34VbButMxdyzUxMR61	127
11254	2vb4McMjPBt1Taq31FeNiBD8A6fuBP55ZgDcVN7Gon3rA7aWUk3C	127
11260	2vb7wS58tzFkBDGxn9fsqdKnBBJ9z6Zrarbr7DhjYmeubRYMUReT	127
11267	2vb4JWxPQhF35zraEJdZ3Zagx9Lyy88wCtkQYSYNHTCZkZMhQzN7	127
11274	2vapRBsdmPBuoVhXZhLqYoDajnEGBY6DnJANd2uKfWeREAn2q3fU	127
11276	2vbSgkNpqTWr2SSs2uMBJeR8ZPQgjP9MiZYjR8W5QFu8Xz2rp9XY	127
11278	2vabeJEaWaUW28ThinvTpmYU9qXorT3kcQR9gbojgscfS6mphyhn	127
11285	2vaoTKCyW3nN2Mg1gBzAJvtK5CS5xJAACpZtgmmhKNTgyjeatRCJ	127
11287	2vbTry9QMFuWzwaQp9kYk4MAYhySaV5Pdc7crNpgDg3WgodJDgup	127
11290	2vbUZkcsLBhehS6YYy2dBPtd4nJ2FmpBbe3zcSLM2JYc6x5C8Naz	127
11296	2vasubsx2ignnWi6hYnzoVasJFhy8Ej3sBk7cZSGddnH9CTcQMQC	127
11300	2vbUvEBXhbmHkfZz8wUfLLTPJyymJsMheEookNTnmQhZj9WkvmzP	127
11302	2vacb3qJHLtAzDJ18Nvf5ew3fEQUAFmP2H3cqcXpuWFNW9dy9xfc	127
11310	2vbBHd3hUC5WC3vaSk7mvjXySvzKncHyGkPjJGv5ott8XtE4u671	127
11315	2vazMpHzz8GQR2WgCstkbAKWTUGPQPRyB7TDDoUrqodhjZWAHBQz	127
11317	2vbM23eEqhEkK2cWXvZPRKRVinjwsdW2jFQaS52VKXARFCEtWE3e	127
11320	2vbB7jsYeSvtuvXtXZchbLv3JqxuB3EmpZX5kuMzhKfFsjCipftf	127
11327	2vandp37xw7pxbQDDGbwDR9xRt7xPwVSvC79UFG5Trwxsrep1VYq	127
11337	2vbFWTcA96bM3XVWWBo885UTaT2pdCoJAMgf6TheV3cYEGyLGZ5E	127
11342	2vbQXAfymvms5DYoYujGJe4fMn5T1i1zd4jbJ4Rvv6pu9sw3TvMt	127
11037	2vb7EHq97fyxxmWLdvGpn8aaPcR5THA4hQ97P9YDzd3i5ZBLMFpf	127
11039	2vaGHLxxP8EnKAocLUjJoZi9GmvEAQzs75LFS5H4UsWFAv3D64gN	127
11048	2vaUA5oyYyaXPN5J8pjB6AGC1KQDUN6tNX8VJsA3xYnszDHK2hVJ	127
11050	2vaGkJT7GFzmbcGWHdEwciPAf4f4jYQLL2fnjVJ9NW43nTka9s1m	127
11052	2vaCT82rafez1cyP1Jcw7fYakC66uJVzJLMvXvf3FanLMkXvYP9f	127
11057	2vc3KR2C7YvU67grMGhnZZXHRsv2rGvtgS7sMeVdckDcq6RuscFV	127
11059	2vbzwzV7T26HLe1dw1dE3Dx1ajxWa42zEip13XkHBRgGbsr3Xp64	127
11064	2vadCCebJLJxCrk26GWJ3gHYeMqgLJwdMsdTVjh241k4sqnEfRQW	127
11071	2vbP7Qapmm3Bn3zU6zGxPDbPqZMSmjCCPSmNhrk1Z5dVeLEiumQK	127
11073	2vbgQCHredbCj4GMYMFRbzymhd7jMnB3tZUx2K6qZeXUJ9oErsjo	127
11081	2vaVXL4CZKJXGgo9kdeB7qNpJVpcituDJdozrs7vwGLMuy9UxtxK	127
11084	2vc2o9Nyrv4gXvhxAF5LvySa1mSWz4NbbngwRXuTMSAAfSYs8ZEs	127
11089	2vbwSR7r4mxpuLqG5qKyAaCSnH3A9qxVsdZboBnuvg5SHkb1uqz2	127
11091	2vbUH7si2rsTBYuVySAzncHFj1Cfuw35HNyFfX8RZRkpTNFZRydw	127
11096	2vbVMdZkanDa4apYqZ1PTPhi7D3hfCv3chPk4FoLA6CNKH565ErT	127
11100	2vbkr3tZMTsUoNSgBhiU8tWxtjgkQdT1BRinqkjArdypQ8HVQDFF	127
11104	2vaAqMB1CcbvP5vuvEjSgaEfQLzGgWNARLp3YJedqqbxdDnAWYi1	127
11107	2vaWL84CPCkHS4CPQJo37m5Mu8GNicEJzGgTbh82E6ZjWquJiyV2	127
11111	2vapwnTvPQZiGk8bu896ouwrLRiK7rNDbPRHZgSkDeb3Xbbh1HRf	127
11113	2vbYwPSvVYQYnfyw9TqmDj72HajHV3mwT6KMqaGZcpaeFd16DVXQ	127
11116	2vaRkryEjM7GRSCWwRamYpyk31dKAXicqE9hR6P3Qxkk3stkH36g	127
11118	2vbtUnW7jDCwtSZzojF4HgfXNBK5nLbwFW8caPvKZTqW7aatjG88	127
11120	2vbCDPq3fTxDkQDyaBENQkqhRixmhxBB3oXC4qzh2P6SMWCcqMdF	127
11127	2vb1H9AKjPuGMSptc2E8HpJLbgDU3cXQdCCE1fJj4U1mwEX5USDU	127
11130	2vbd5EiNGCZd9xp1ZAtZFutC6D5ivDFPCumLGnW5KbZGiYchLMns	127
11132	2vbtG9T2R2wy1XG88gYfzB1NCwnSm8NdKrHfKY978S6kKX33QAaw	127
11138	2vbMUSow4M8eHtZXK3Z3aNtgThC43y4vfygHJqPSgp6VUQjG5gPY	127
11143	2vaTRrUsfyYU5KRTP6B8dsVwPftCpmeWmdZhbx71v8t9CMHUc46X	127
11148	2vazj6xEEm4ipusb4XERMj5Uvcs67tGKs164NwgiMDTicyCKAG9P	127
11155	2vbu3VsWJ8tQFWifKyvuZqbmigXQcqaw1LDRKCzKP5CwteUbKo9q	127
11157	2vbUk1dJJk66JCrPfLr25EmRYU6ngJsrUVLLwrCzArYbHHGiDrTW	127
11165	2vbkZi3hN1Ew8Ym42Yw9s4rMQstMYUXQxgmajNcoYg15JGjwwkSz	127
11172	2vbXNdrz2jLZB2tTKtacskY81k1CsAqC2TUCy9yyFbC9F8GaeaLq	127
11176	2vbqDe1qPXSJVsmPUB2LDnmKcVRDSdEHbx6rz8fwv1fg7XcYJEKR	127
11177	2vbMANNauNsF9JtepNdWqvrPyrT86wCRP4drnGxZPSpvL2jQS5h1	127
11180	2vbJe1NbWijPGH9SNRZ6RiR5HesdBfj39UFTRQMv1udck3wsCcto	127
11181	2vaiXSkSrZuwoAnkHpTSZj3GazA1b23w7Qe7YT8D54pJYWJRksNS	127
11185	2vbq2xjgYgipZBDSWahrCf7k3WazDoixbFcv7oBgSGBShrPaZBuV	127
11188	2vaixjmhRqaHTcwFMevUbdZ22xv6jAaUXg5uMRYsbt4NTe7coBTp	127
11191	2vay9CNxQQSBHyzGscAFTtUMQPm5y1s9VcE5RQZFCsas597uCPWV	127
11198	2vajViiMTRQxfKfYh74tWWWHtp1ZQWkZkVrarQZe9mdQqopfQPdf	127
11200	2vbgqJKz9dhwz6tTE5BLpDKmG4QrpUCXTZtM1S9H1eMXGnuLPeGX	127
11201	2vaGb6UacpnkqZGysQ6jnycYHXaVSbCYyVZ5nGusde112XNUFJc5	127
11209	2vaLJ8aEywunfcyTsKyzTCfwAeiZyLTUu5QCDwE1XcqtHSYAM2BL	127
11218	2vbpRjZB2zJw6xLMYNd6yZ3ezKxk2CXUx8rV86N2qDkySXx26puc	127
11229	2vaXC5aBwHSGfezAWt5HtfS2KHNgpH1pwNuWpAEj2bBUo8MVwYTa	127
11231	2vaUDn6qWKKpeXYi1N7kvhxQDB68nNPSTjH2kVGCNK6dWH1GHxeA	127
11234	2vai3D3uwMSnVaRnUg5bNE1F8FpAZVf7pKnVtaDNciB8DZJX6boN	127
11236	2vb5hCPFeSsbBQpKPq1Tzgfsx2yJrdCbnYnyNRC38MyDL3H8Fk4C	127
11244	2vbaA1sHEMhxXvc99MVQnHfNu7TYcbCcMTRkydcvTMtMLH76QSG8	127
11246	2vbBDsu6EP6dZAXpbyPbfbJ3sQXuCw74cHbZucPmV9eFW4QkNfRf	127
11251	2vaj7pp78RjAxzCmc2hyXbQvp2s6PesqVZ7yapA3ZQCsTjomBssx	127
11253	2vbcSpDU3S7vhegGEbCDzWAopHT8UcXY5DDqxnoFNmKPr1sDNcVG	127
11256	2vatsaokmydDMekPEfMRTYSyAJPWwqPNvV1QrQZ1VuLuqJWohGVv	127
11259	2vaYPkxsGaNZrNfee1dWoi2dpTRtpYb36aCMftxBDSQjeggWvrcg	127
11261	2vaK9rsszeiDntoGE8iLUm9GnxQpXf3am1r17B5GfgEJdFdQ92QE	127
11266	2vbLxqRs77S9Y4oKQA9pRyH3KaxKxHHYLUGErThKETtZh9Df9VUh	127
11269	2varrNvToc5JysybkoCQNxacemZGhXti8sMDrcZrLMfA35X62uW8	127
11271	2vaYSDSXYobiWJcDsRWM4vxrhPj1PC8F4b7Cuaib7Dn4GrvGZ62J	127
11273	2vbpZMDihAEvsfSq5vgtnAsYeqKwWc9MVbr4zJk6FWftX68qhu8j	127
11280	2va9E9YyaX5ED1G4Eg3ty6uEdomyK6qP8zm7CshXYgdnrxwxSsif	127
11282	2vbRhpsYnyEAXDz2SuP7bBFYFqKJt8DeFPbgPTTcT6pgBSTiLNZD	127
11289	2vbjrU3ZD71ikTxTaEZmB3exdDVqJkp9Jt4jEM9QguXmQ7GqXtYf	127
11292	2vbfDMm4rvHL5Bdh4Lqz86HtY4vzX1KgAWAza8wBwFxFtdLk3wYi	127
11295	2vboE6b1K6d4ubhDtW33d18CCjCLJMfLGUS18cn5SJdRhL6HTAb6	127
11298	2vbYVkF3nuAH3M9LaFEKwMVACTqE2zirDVaJ8duxaA8oRLSUP1WE	127
11299	2vbMAHC5TgjHPnbab4cEGTQtKiUYot1GeioVh5hM9nCmTgmYoXsf	127
11305	2vaWsEehJq8PZqyZ4P4q2kRzd6NiJ39GyDayiFe6v4oX2nB6QaPN	127
11307	2vbuYtHDK5diAqCzmFB4EmBtyf6NLRomnnoWk3WcHopWcPHwVVzf	127
11312	2vb2dgPciYMME3X5zXLMENKahqHE53tXKcP7r9jyZbQjQjQqtsBx	127
11322	2vc2MQi2icB2R8rcLJZMSZVSX8EJmjPMAejaMCZRKuxn8FJuqLYT	127
11324	2vaB5fd91GPrA5tXPSSJtwKAtJ8J7HNMi1oVQk1L51cipBEmzkK8	127
11329	2vb4RS1CZ65yc42gE58SPxajmchDGB2RvPYydDDFGvy7VsHxzJRh	127
11332	2vbQthdivcMhTLSwWVjeZmJjeqVjTohp4qAHm7pQXCcmzBFe3FfB	127
11335	2vaM8691toDetS6nFcfBADmw7PjWnaD6LE9iwmSRPr8o3tbzTZKU	127
11338	2vbeV1hkk8h3djBtqyCJgVWaFe5erDxnh5Y7rWj7raJdKycGXEXG	127
11340	2vavUCatK2W6t5mxZgCuXskN7uXGY3niqdVBuEV4FRpbq7P9Lfk4	127
11343	2vc2jfsGT4xyzdSpjoLJh4DXTy7FhCnM98gsuk4Naj2QER7TukCj	127
11341	2vbT4yRaYdjtXYmpPNSHEshUYJ4LMvL5WyQx7FGkhrzxdkmLRSRG	127
11344	2vbn4nksdend7t9f86ts9bB22z1fbXLFSSMRmJqrrV4pNnRmVfDo	127
11345	2vb443dQK6k1Sy1h1HoVD6NMKDxkvhd37NsVsP6AAbi2yMtbqVmp	127
11346	2vc3XZv7WyQgLAH2ZNP3FJgRX1jZVPDTQtrdzrhwFHG7GDUF5txb	127
11347	2vaU9dz6Z1WodGWxocG2oVm6VH2uBuQtGytQRTsUJZwCehiJzLBy	127
11348	2vbbL8hSs4KNCg7rKzZt34zfbZbMrjogK5QSZiBAcL1UaoXJ6naq	127
11349	2vbbyenY7f16o54KhuCvWtb51AoUhEeE7iar8rs9xE4PVN8LE6UV	127
11350	2vbu3NRMojiwTTzf4X7uRic2oF2gkkrwVcfxp7srZ3U61b8i57VP	127
11351	2vavnjHTc7HNDtzsrFhw7riAMnNQ7b2UdH5ZF6ya6gqBhpGZL4V8	127
11352	2vb5xUNkHrpKyBvyw4kZ8LWQ3HEF5sTXd2t2yGHdoPYf86A4GH4q	127
11353	2vbnP3WNviPKfdnuW9xJ7go6EVWSBhNFo2qhGUvPffxyVFzY4r9u	127
11354	2vbvdjcshHMWpBXWEAH6MDG2DEknakwyaXgN2TRhBcGMa7em8FpW	127
11355	2vaqza2JPAqBuC2Uz7Xvb7zY8ap5CUHkkRGeS495SMNaSqwRW2A9	127
11356	2vbgvRYNJoGBrLWXUVuEvqV4xBEXbSA8YDeTiuGeBeHsdSrXboDh	127
11357	2vawiuBXiSpCggraBmpCjADD4fXu3MrM9e1nQt5R7nggRMmxKV6p	127
11358	2vbAsPuCn28iP7t4exMUMjzgPkZqxgjkz6o4JZLN2wHvJZPBzWXY	127
11359	2vaydStJdtTDDxYcHoDeUp98qwoeLmTuTx6Xqrn1FCjQyKrDR41v	127
11360	2vbaKNzhZa67AtHWq36QriHy9qryh5o6jkZpPBpEayWTjfSb7snX	127
11361	2vbTA7R57kynmXJrYHQD9MbA9yEsKRropzwuiDa8XhBW1N4TRE2n	127
11362	2vbi7K839jg6HE4wQxrGPY1jw9BFhvr4fSQWZnuZNTAG2aBEx1j6	127
11363	2vbTe6tDMkQnnFrgVSrthghYEbrEFSQDSEiiu485qGSfhp22E3VF	127
11364	2vbwMH6Kt16vUea2rUs1wUGAV3bZw8tBKAJvU9Dqw31eiRiv6N76	127
11365	2vaXd7bxZ2jhtijDaDGWxWwBm9dMyGYuQWG9jvQtBsNJKxwk7xLV	127
11366	2vbvvvHMy1mStxiTexmAohkFbyAE1tkZdvzAyA6VCJVMTFjRgWEL	127
11367	2vbmAfiQ2AKQDH5XJJ9sMY2sMEVv4ADBPZiAJbBndJhNJqnJYQKw	127
11368	2vaUFgNazRdqTKjkH3WdN9k536yLMyuSWAcMu9UdNmS9o8LfRvyt	127
11369	2vbPFUoHjNYb3ckB36LjfAPiKFA4CtxRUubKW8iQFBV2Cybk35wn	127
11370	2vboRE2mXAw8ccUYuVxSswBDr38mCL7A6GmvgYLaijRgq2xsqz1y	127
11371	2vaFxKdeAQzJa3StMN7Ljjfnk63DFdZWfjXWQUW7AwrFhbkMFPji	127
11372	2vbM2wCZswMiLXZr6mf3run1fyCKijWJmnzBypMqeEDWHjxMaz99	127
11373	2vbT2i1Uuw4jC59DgQ8Yhn7y8Vi1wT9qtrV8GvM2dhiB8FftQn2D	127
11374	2vbDVXScofqWayXCus8YWaxAf8pF1Db4yGS6eMLGb17f8u2eZ5VT	127
11375	2vabTrKSrmCcXJY5enDXbQTo1fWQ36pCnJJa9jPzoCQWJajf1SQy	127
11376	2vam6jg9kkdAJhfAsArWHvpahzxPNZ3aBQKjv6WvfLVysBctYXSQ	127
11377	2vaZ6PFTGurG9jx5fZqaNR5kqAyA9sjfKZQyhBjHLESeNNmgj4gH	127
11378	2vb1AJvDnYAXSRMRkkfVGeYdNuWT2WYzenHTDe1vprvibUsA6zNn	127
11379	2vb66m9QNLbdLYRwhfPatquWWBXhwU7nk11hQ7B653ESZn4LrL3p	127
11380	2vbtbAc7DCw9AUmspBENJ5kqMruNen4q4xbPSHQh8qTJFAsgk9io	127
11381	2vaUgysjhikrzCHLQRXpNouvVy255H9Y5toLLi4JTfbNzuQ9Wt4i	127
11382	2vbhfx3w2RUXatpahmqbwDDCk5jzkcf12bmmNJQ3GX1R7Peqdg3k	127
11383	2vbVXhdc6RbQBVXQepAxCVLrAcsTPa1QXBXSu2LrtXXuRYnyjkdf	127
11384	2vaD6ghTZJdV8MeSnrnWSodgmXCypayi3zxxBnDmkqyUHwjTvXVc	127
11385	2vbiejfbm4s7jNFtp5oA3seXjA3pENJGxenpTjTuKdKDhMkw7EG8	127
11386	2vbbLFNKKy5Bh9KhKA6ZrDneLywq9o5Y4ZG3htQdwRH1oCobf5TC	127
11387	2vbrAM3MGwfcj5BZj23wgYv5UcfKzFLPkkBRQrXFMrq57bngYkxZ	127
11388	2vaUB61C3rde7EyZBw6FLEps2LRtY6HQEVuRAieFaZLi78bDq7Vp	127
11389	2vbWXR6hnnCkvEZB33v7MpFpLM1Pp1JKNvE8FvnnMdegDtTzPsJp	127
11390	2vaGYh7k5DX6QkSHtVAGBC6wkXBchyS7aCFtxm3MAcCGTrNzJ1fv	127
11391	2vbyUyTaSm5aUactLnUhJT6Rwqm2qAUpmy2vvGZJchatrV72YJ5D	127
11392	2vantpuN4cvahUrpALLFi1Jj7E5FdK4vomHUrzzHeGNmtwL2QeN8	127
11393	2vbZAW6sbfuEt1bCE6gmuBcHeU1h9WiTm7hogfdbtpsQ2GmGP1vJ	127
11394	2vbH2tsNN8UvVTxCr6ZEU7oHEAaac7UPmDai9ad7JNGwX5rB4vAA	127
11395	2vbxpBWu6ppqXxNwqJaaEX5XeeBDH8PJuZsJyajYsrMtD9GSELNU	127
11396	2vave4Fzg5jVViCoHDawquUXcM16ZrA6qokYsscEzKWEQD1rZ5rh	127
11397	2vc2kDmeBCtVEK5DsRuqKxrzmh9dGR2nUhAPZt7rMXzvA2NjSei6	127
11398	2vc1R3gAE1x9yGpRGvH5zgMvyDPpo5p13W1B6n9b4SnBHFj4EkGH	127
11399	2vahN13aanLU7r4uYTQSEDcDUU6nSmDBJVFGNxJeAtUNNYreEq9R	127
11400	2vbG1Q7z6JQtkycdQd9DhArvHw5SRL7HB5yqr4osrpxq3TnXjXmU	127
11401	2vaZNV1G2VuzMKvsfGYdYdYufJmJ7RgzfLiWMEGek56AJX8roU55	127
11402	2vbuAaef85yLG5zCdtFyYQVSHLJZ4ZhCZ8D5izNvsxYJxvk1LnE6	127
11403	2vbzLtpBPKaoiZdmG9asKCb9dgrDxzm8FeLNFb5J6BcEYjUSh8v3	127
11404	2vaho6jd8pwKD9oaJqkv1SWy2FeUpyLVgtTAMBbhVaXcAetTpfYr	127
11405	2vaBRaVMCVHpjFeNrBH6koH1e3Mm6GbBdaRX1jr3zVDy3dWGGkXj	127
11406	2vb1v5BkDEo675dSYWpbN7tJZTmrnfwW5rnY46Z9iDSM6Rpvanfn	127
11407	2vbr29YeFe2LBF1Vya3HZ59Fnku9pHFKAQSVxD3xa3x4aWQZVDb8	127
11408	2vbdS4632rNsT1MGxiczMneL4HoeKiUNkvHmtWyQhsR5BHmvEE5E	127
11409	2vaQqn1Epqrr5qZKJxSwJr8uYcRoBh67goY4sbcQAaqkiqo5rzcB	127
11410	2vacoK18uEPpY5ZQEJoSER2z25egfJGwGK6JRTPCsGBmGcKQGSt3	127
11411	2vaw9Jg9VK8SBivaJQtH5k6PnCLDiHeHGAYVYi9SaHvr3jXAUpmu	127
11412	2vbHds65EXcteQLgiPJqMaDvod1PpKcknzTmsypVWFqZFNaghpED	127
11413	2vc4gNY8NX8e3Ziq7jRjVW1bSHm4S9ZW2n2esh4RftAVpRmG4FsA	127
11414	2vbSUAbL81R9mirfXT2wa4Np1yBZC7VyZP9KyNueZKCdkF9cZj2c	127
11415	2vbPCEVBd8zaiRAywuY7XitUcDBbcxeRh2JBqz3LN1CYepNSH2ar	127
11416	2vaUvhMJEaCVgFgvAzhq6sRdCrCuX12UH5S7PGTkXeERMbbZ682x	127
11417	2vbeu1FmnTye8oYy7WQnUynkdohxQ2oT4fJPSQutFP75w8aqUxrB	127
11418	2vap4ejSKnWWxo75dPY6efBp9qNfhkiuT9iVVWqA5wZXL1XodBZf	127
11419	2vaWk5ysTVQaigs1aUfaegj67gbgYgayPZQKNBMaGNbDMncA7rcV	127
11420	2vaGv9zPcnrESUqcgyCZH5ygRnyMjJmNcmCJLjPouteBAShGXygE	127
11421	2vbvg3hZvqBsDi99QBz1MvqQWjaKj3pn5rs7gaYmG43JkachZcVu	127
11422	2vbaeE6ap2gpmgja2AJEKwDyTGvFo8zajUPhsnZ7765X94D142xo	127
11423	2vbLp7RAKtrkCVDLh48j9maF3R1U9KEx8zFjj8qNknVX5RxRLaoQ	127
11424	2vaMKgsFGF97LLWxoYcvDf5Bw4mcvRMJyn6e6x13tA2cePRzHhAh	127
11425	2vbTRiHm7MZAp3x9VgV8soAtwe6KK4EQQKtBj1fF5q181aDAHatc	127
11426	2vaMeSV6qZwg7kccN2xGB32bvCm7pPSVDYrm1bCg9u2SJm2s7cuc	127
11427	2vbrkii7ofms4ArsemuDrGw5kdD2u6HvGyeQiGySxND4JQqqNoXe	127
11428	2vaa6WqHKzusRbeZCd29LcML2qzR6PwSjeAD7jdx66QX5op2yBZz	127
11429	2vbFB1AVa38ieJ2SEnPviY8L4azJei2a39XLSixt3mUEq9jxrECR	127
11430	2vbDac4vLcH6HAQuKA8F4BjNVWydQwU7wsSgJijJZZKizefQmy1k	127
11431	2vb8wzCykmCE8a4nzbz3QvrkjWkuu4XSQ3q4NG11V9wa4ccd4WiT	127
11432	2vaZakS3dJ31j39Bea4Ts7bkALWwiVcwU5ZEHUrMgjNQGEeYviV2	127
11436	2va9M5siD12aN7ZCad48oJSRRjVAjXtwQYVHdj6CVFKzwndVFPAv	127
11439	2vb4EDTTH4rVGModdC1rtKBhcswZ5nxJVyujmuP4EsUfi8C1tDeo	127
11441	2vbp84fwUGzUfZ4PM1w1MmRAaZ9x1Bbz7MmNCGxDH9JWcMBBXvrS	127
11444	2vaJsS4GrPh8nChP7KxDqQiHTodiidPcZ7r9FwqkMCSTUUKn9GeY	127
11448	2vbZ66oVfm9fqMtVxQwKYuye7cR99d8BLvyUFimJDy2TEy2ch4rN	127
11453	2vb4EtK7SkhTuRweHzW6PJfi1PXVKFwS53Q38hNWr45xvn12yUCT	127
11455	2vaWzdz9tXCFeYymczkWqrZfEDVKdKzV4BBnrY1eDQi4WHyMHPEx	127
11460	2vaFXo3DBkb9GQuzbF3LdkRJxByQcUFA4jF5TknwxYwNantXf5ad	127
11462	2vaXSRv4KTs8DPcFoo93dS17RBN78h6DBPMU9495rJYeCppieQXg	127
11469	2vbAXNisFDW2FQ8CFALh4wjR7HBRRpbkrTh2FsD996svvLBZKFqe	127
11476	2vamo5GJSxWtUsXr29W8YxGSNWAxou8frUCWP33YbvR7bAezgAYU	127
11478	2vbQ2Pk61eSbYWjBLUxg6B3r7pwLFDPkq9KEGLys1pSeurnsHGKd	127
11480	2vbAePtz6PKugXMtB13JfUXvDU6x7Aw3X659JT4kWVexq9ZiBa59	127
11484	2vb7QXc1tVhJCJj7i2dEd4b96UU23NPF6ZkwPY35LJPBVH2w9adX	127
11486	2vb3Fd6rKSUntzE6arNvcoJzBHFiEDypmmyEa8WyX9TQFHS39Mm5	127
11491	2vbMecAjZWQ2xe2YNrnYb9EieMTirLD7KcrcAs9E8q9UbaC2b89t	127
11494	2vbQSs3114PfeTXQk63hYYSnv4Xm9hnASo9wvS6gnAAiWTqPj9i9	127
11500	2vap1biiS4Fq95aNDU9EUDgDtaVt221sY4DxHUqxGauvitqNJRyv	127
11505	2vbtqRJcY1FAHKmRo9rThCzQxGkQJMHPtXVYcjHgQx3wTqyntEDC	127
11510	2vagKFT46nriFtYior9RMEtA1W4u8nSxP26qUrkUksQErsGHRkYn	127
11512	2vaPP1YmeLaynwDJ1WijaZgoHVkoRqJfs18VNCT7rd9HDWEN2Sj7	127
11517	2vaDnN57xGxmkUtVDFwBPSa3ZPQ1W1wo9Qu7BjAYRWVbY9HkC16n	127
11519	2vb8PD9HGDgJQviHUhKVbGG8BhWKJMXeb9o2ukD9JZ3ABegGhasS	127
11521	2vbqe7B8Q31kzBUdPYxXWX6gQRSMvXx4DJkxGDD6HDNbhoM4J8eL	127
11523	2vbTydDKjepHojgt1oEsPUFhajXFdxYotrHxKQP4PYEdJDJ12D5J	127
11531	2vamcnjhJq8YXdAYFacn2482vq7aVpwXE1eA61bDssF9TKKYo3Ew	127
11533	2vb1AqvNy7qvnHyx2CNV82kqLTVvEtJbk94zVTqXjprYtLqTPebt	127
11535	2vaGdhTH6nbTUhAjFZCMSHZdrfjB86sRbsjPiSwQGzrFJ86eYwhS	127
11536	2vbUWYVyDNkw7Y7oYQ58DaJgeWdATyMZuWbcv1W8K4r254dGDoo9	127
11538	2vbmcoc2hNzK5g19YzUXMi3KM3eTKzavEve5cr3eUNk7jR44duYB	127
11549	2vax8XpUhp1z4w4mLykm2orLQc7ac4XE5vtqzMs9BqvNU5rQLZFN	127
11551	2vbuQw55kQZfLnbUpb1MZMopyMTbegebUKNuCHm3xwcp6jhTkqLb	127
11553	2vahLz4QDPakwAj3EFUapz4UEA3sKxgW44wvhQJinGPL3mA9kqDE	127
11555	2vbXxJnvLQQqBYJAL4eSwFqoDtbJnpwYZhhHPju6RSnugMy3MsxP	127
11558	2vbKvZABnRbVdWCDmtv3V85injTZfKJSqQ2vWN4fJvnsZumy1V8W	127
11561	2vauTCkqLBe59MFWnnb7gTCfqgj17qJgFoUvJPDfz41gQG5Tvg18	127
11562	2vc1CJZG4NYstRNjpCgHm6rkfgAfwebCRyZnR2kNGF1U7yZGXmxb	127
11565	2vbFtfpAyAYeAhGTZtGSPWbyvNpZpu93DnwX2BuwiLonecSPvmmq	127
11568	2vaD3Behg1jmQB2U5a1TCQxBy9XW9vHoE6TVPcyVQvxkr3Pq8yq8	127
11570	2vb1NyC5jdxNrrpTbhS6hEMesNpLBQ1u1sJFtUebhxMnMN6s7MHV	127
11574	2vbN18WcurBRZ7sEVwaXA7hi8U2655mXt22UZEfGziQHK48VTCYT	127
11576	2vbgkjoWuMHd6RxLLcuPBc8YCK4441fvjawtBUmhomqZAnPGnmby	127
11579	2vbuULW1uCvLaB8FJ8kwxmu6HeJWMiYiBLeRNFNzHdbhxi6zQFBZ	127
11582	2vbQfhnowbgcqcUcfMvAWsBaZEdUixbHz75UKSoqr4FU4ZCFRoz2	127
11584	2vbc6U4nsZwEyeudNAA3g7T2agvWgttrNSP8gMaAXTM6XjDNmNMF	127
11587	2vb8muj9kt6AdvJp6cQQfDDroRRwoyfbD2AXw1JKxJWT3dPRQTEV	127
11595	2vc3HtcxgUiDmjkxzmcT5tLGFJWjSwCwnsQKPmHRPifSepQYKx3f	127
11602	2vbwHEXAMQo9gqP4kbJpiKNBPrzvW6TckMqy48DStV65N9pFP5dg	127
11606	2vbjbsgnn1Ff8h5uqNEMJXJyjwb7x5UsbtDR2h8j19pmwdMNgY9V	127
11613	2vaaEyVmkSawwvENhfvRDEXAPse2LdPEkEZQDYwAYXMiewrxWuQs	127
11619	2vacivQ3RaCsHoeUwjCDPpQiXqD1exBp48r54GAmNgGbntJdmrTY	127
11623	2vc16LxuyoRUthKyANebA6K1y8EBTJhppCcstVMQmDweUSCH2etM	127
11624	2vaQHq47CgeEq9MhRAhGmHUpZKW6928WEhLBDf7MkcuyrVVfPMWD	127
11636	2vb1nVsHYG9siY2BVokExNse62DowFZYMkiysPjWHNkYdNpfid5h	127
11638	2vb7x8hkfm8H2zLYzCoSE1aqjZnLSc2ML14EBdUnwNhF7UgUNpgU	127
11641	2vbokiKuKsHjAWFa9Pw7eoSLZY16nkb1Yhi1Jp29LJwzMYnoJ746	127
11645	2vaDJbHAkjSKQNfEJSFwxVqD17RgzjEcqPzL8JrTp4LW18Sprrtn	127
11647	2vbGFXKZDXYz378ak3CegnYmxywZzxmQyq3Fh6dZg6chzTHvPEjg	127
11652	2vambPH5YCgwMZyBqMFVcvkEt6FtKVGsaGJBom2SwaMiWHzdZWuK	127
11654	2vc2pLEsCSDc5LhqHgNoVPu1GGV5ZTLr74SpHZ8oDyiK7ZQzZ3Cg	127
11656	2vbnCREAbKaF667jrtvN4fNZYuy6XYtV666qkqh7ivXZqLTQp2Z3	127
11657	2vboqJvPzehq1hvGDrucDdBJXCFXpLENYebvkbkYR7Ck3uB81KYc	127
11659	2vag7PFtBgyEYJ1zrNnhkspiCGMPs8dNtA6hCXJNHc41b6sbPCwx	127
11664	2vac9du4QS2neS5webykWvuvBhx75XM5rq7uQNq8GEz3Lz1w6nzy	127
11666	2vb671CUyRHAzZfMam3X8rzfYjHE2X7ygmyfYmB75Yxun7A7qqF3	127
11671	2vatRT5bjkc58G1bmjRHsKoxmQyknhSZCxaJSqjeBrvtN4MRkcrk	127
11675	2vbiQKUQFKB4w1wCRZnaAswmBE7Z3NAaeMtExXxUpJijyfguii95	127
11678	2vb7FDCf4JMT1ZhRbWWVEueLZF4q7muC2bBbQ61UZfzJADNxTQUv	127
11680	2vbKR3o822xeWkBt272UtyQoP5Vvi2v1oWymw7mTMwPXXwWrU8WJ	127
11683	2vaHXPnNvkKHcYh7fdMkiUovJMnHfs6pbHMEpgSHNGyo6xCMBsrK	127
11686	2vaAk6SgHFjbrP7qLZgAuwpMuUHkE9wTHCWymg3Bbdkbg9Dev19F	127
11688	2vahdUGhxDF71wxsNE1BBPqn9A7g8vCH5dHULuqJNVSZPUkCkuRp	127
11690	2vaXeS8BmqLZWqQQ88ShbKaR6twJC2rKy1LpQfZF46pwFXFNtNH4	127
11697	2vayyVbcHbzEwe1pz8qC2CyMsSMxapQxbqXeJn76FvKr66941xkA	127
11698	2vbCT92t61Z5r3wb7CQmU7F4xu4Lr5NifKniXyh251cdzu94eN7e	127
11700	2vaJA4yhCFfZANiHgZw7zV6S72oTqtDsqvGD1waEo8qWRBjDeyB1	127
11702	2vbVh2V7GBZZeLbNjnZjmqhVLkari5geTCET7oFz28HQF78ohaYj	127
11707	2vabnY3JUmM7jYDa8uWuinLyQhXKShRzd39cLwuvoGpJcCjDpkrW	127
11709	2vap1kRTYYyHk3Ji6CRfFqfs5VNtTpCeVM5s5v2m92f8qnZAeP7y	127
11716	2vaW827bP3oWUCDuR7tKY87JWRawkgDaYRL71dzAWR2DtsgWgWpx	127
11722	2vagds212EBHcpkpVnEe38qj1gPC5pneNDXuymHQku6FPVjaR7Fb	127
11724	2vbDPn34pJva5sz2McsgkpEG6BfvJTzCHNVFLnMWdCKfAa9BQDyk	127
11726	2vbLsENovt8EfPWAe9zs91d5YZdnzEajTVUa3r8hFrZgZC5a2ie8	127
11729	2vaMkqoUSasAo8rQc2g7JkLzcm1GUo6T11MWzHXpLesgq654skpc	127
11731	2vbRSHKgz1a9DqWgssMK9NHdzPxFn1K5ShPHN8oGUrVQMzRf3CX1	127
11734	2vb9yPXxWQCXeJ5VuAhANpZfNNN5k6yD3dU1VkQSS2Wr3D8TY4jA	127
11433	2vbh5Qk3x9PtJ2HmF3MGw54CjGMy6rncV38kfocyguYgStroHxo4	127
11435	2vaVFMW5dtegbQcUrEMEfkbqb4vBWERMjunD5XQ9Cy899s3orL2D	127
11438	2vard2pQdh4XCsDV3FH3HS8BiJn9jVpmw1Es88HSgKQ797qwYhHQ	127
11443	2vbp8tBL74kycv4vs1Ph7PqQXB642YQyMXrga5pj9wuVB5BnFieR	127
11446	2vaGr9bg4NdFFNosaMaPpFRF36Mf358jvxvgJXcFQFsEtw1CYiNN	127
11450	2vae8CagSUd7UKth973497VbQzD2M1sAV68B9asits74muZgM3vK	127
11452	2vaVaBPkqXXr6bBUWqz6DCzm6wXu3mPkr8GmV8euHytEbJvQtpNo	127
11457	2vbCzCBUwfbsAbPGL8X7Sipg8Ay61gVnoZpVYfFL4zaoR1sy2g7v	127
11464	2vbZrXQUXAdDvuRAbgsajDmoNEZx3t95FrMmrvzUyx1y7s7bSL1R	127
11467	2vbJK7DiJu9Mfi5rV2f2PRGzNxWBqoAt4SjYurKPxkBmpTdhz9qF	127
11468	2vaXTySMBsE3EhKFbP5DbrXpmKQ1GrSEpRVdtmbXFd6YXZ6x55aJ	127
11471	2vbyGziVc7X6DgWDU1hawzaoey9iAdB5JVofv81HcpCaGB8fgQTX	127
11474	2vaD3Dw7JUKHWUMCoMKffF8kpy6KhvQkmJ6W8GQvFTiHeQ3k6bfo	127
11483	2vbp8VmCs1Ri2aJjjoWSwcRur7ec4YJ4Q2rHm7z7Yjed43LUBVt7	127
11488	2vc13GZ6dRCJgjhqD6uQE4a4PBeYKKAW488kUGSCnEpnQGdr4gj8	127
11493	2vbQNcJEEneEg4cgCLaupygKHAtX3ap9SZ9ApUZwkQsZPtzMdBXN	127
11495	2vbUn53qgKRyctFk9uAFhX15hguyLNjmeyqZqDY542b6TzKHnrsP	127
11497	2vbprpYFwQDxC5rf1xU6M1tNT4dBRAwGNdRGYmKqepH11GUxZYTb	127
11499	2vaV34oxyexLetSRfaGiErstkLPVtzPYvKQk9bHveUDxGD66ynag	127
11502	2vaaZdQJgQR21BmxLQZFKa1jwc9aPZJbrKyUaZnaHJ3zVMCop9Jw	127
11504	2vbNoefBHpaVti94AxCjEGatZtskJESzWLU2cpAkykJ6kfAWn5nN	127
11509	2vb3CP9Sio34537SpYTn8UMuwegmsQJ6KcBLWtCDV2Y9ZhTFDgXy	127
11514	2vbWUhncKWBXB9deTxjHr7rSfHtoaMB1SaX3dt2FoJRK686WyPEp	127
11525	2vc2qjCLXiYtFHCRPWVaFrvzyEtdpM413vGs6pHxaq6ZozpZP6rB	127
11529	2vbAeYKHRnpV2MqfJNjKM9fhYJgtNeRPoYc4svApJyH4JECFR8yA	127
11530	2vb3BiJ1RWYwj2m9RLe7jqquQzCN672nSppGXXTUUrd8W2LFFgdi	127
11532	2vaspoVwKUwQtQp1mxvS1FDbZXFo3WvgiypcqSmdWXSgcxpwYzv2	127
11540	2vbHishLFuegdmWxTUr7Rt6h7r5r3H2QPwCxqHXbgAx4LrqRTMwK	127
11542	2vbfpjoUKxEpo9Set6mK1KvKjxHhVaYrhfcMpewebeuUfvuCQixX	127
11545	2vaBjvPdwtppP1gqxiVrC5u3WrSZzLhpgG6NCtpYdHsquoZjCtmr	127
11548	2vbAqiTLviU3iauT6xLCThKPfXwmTAvKR7JPN38oHvuJrCM11X7o	127
11560	2vaWwft56DXJDPWopRFV7tVj7vd4KFubTeg2F4rViuUuikRdcup9	127
11564	2vbwnUMVvwLUw5XSSHFWMsoenAkoFeNabcNB5bBZVERk1fwTQQTv	127
11567	2vbyZPBGPsYPNyooemNcQr5cpUXiX9AcTJct1VW2bDtCFHWDqHSK	127
11572	2vaFH9aWbPMRXDaGP3zh6GsWUCTuUd3pjnYExpi2wehjhRb1sTBF	127
11573	2vaarjgpRxY52NKK62xxaCxfmWHBccpaH6xh865pgxAQ3hftEJbC	127
11581	2vbRxuTtVyhphR3jQtgxHhxde42fCVvkSm1wRLNz2Rx11phe6Gat	127
11589	2vbfSqDjgDWWFZsif1hvhPbWewKPNzBKbr5WqVdb6RGbCTETZeeL	127
11594	2vb21s8dSQreCbub2b5ZG3qWqsXEz4JkDrZjPTBtywbChKqvey5C	127
11597	2vbEgyxVPea584M6dZQAZ5aBVUPG3qya7qF2mqE3BC6AyYuthLXt	127
11604	2vb67cSa14thRjUMj2zxpxYwKPFmdPcBdCx4925Gwr6dmUkVyyPF	127
11609	2var7Y5qCRQDHwy4SarEfSTtE3kZ94PnQVSntB2xp5BEpqTsuTW5	127
11612	2vbVFcSJGn2zV6948JjSZVKS6H2eP7xBB7DTwPDiitNSBCTb3PBh	127
11617	2vahUdcj14joDgV8vCu9FHKmD2rzraoYP4UgjBRUZkBhBcYWveDD	127
11618	2vbWJyimJK1mQWQxV7P8x7NxFwLn25ViQMZsjNDteii89ZXdkn8s	127
11620	2vbb8waJ6tjnYsUeB5msHELqcBmhJydnAL1uhTr7JbMnvReEE9bd	127
11625	2vbddJwjyt15tq8UXowTKhJNQh6iw5mrvzviK9Rwfbg94wk384nn	127
11633	2vc1vdUBZhfmqr9gLSmG6nbpLC7WdhqyPZivjmtyo9j57JCWiQXn	127
11635	2vbm1jDy4ERKyGfGKhcqFhyzzeEC2EnVEecLBwSB7xcArQ6tuWML	127
11637	2vbysPpUyNvBqCDz1mfpaH14yysFRTn9goNfUF4KFP7rYjtH6v3j	127
11640	2vaUuyVKnEHG83y9ZTWgkLGTvTLELnp48yfox9aimEbbf25AarsL	127
11642	2vaLLPqRY9gE9oMzHGHEgVaE1hniAAHCRuUWGubWiarzPWpSewG7	127
11646	2vabhtXFrdb3p9xAMdpdXU4eibEN1wPbp1sDWcx8fsNuGQYBwt8M	127
11655	2vazpaSJ3bvq1rGqGk1JSG1Ppcnj96ixt581jsPwKmN96EsXPdb5	127
11658	2vajJgdN4QiTKf9Vms1Tm8MgZA2dfWALvT62JhEJgiYDvBtn5AWo	127
11660	2vc2etb4gQ76EQjxyXBmViBaFYiQHm3ksC2XZH5becLuaE7ckWsY	127
11665	2vbJGF7JzX4gvBqdtGTiZZue22iMR1aS8uee2k2M1rzNJjyxjyjD	127
11667	2vbwGPbgNLxZuymuFLWXkLfqKL87mP4jYdBWbTwUXmtzjpQbVJr2	127
11681	2vbV8PF1GF4QfPs2RfG2xW84HG22pej2pC39TL2JdfPMwiuQLzWC	127
11684	2vaFUzKir96Qdy8ce5Vb7qvrUu2ugeuDuW1tBFpAJS5gXeBL7nMS	127
11691	2vaNdFdAtXciLF77yD91SxwDnrdvSCEue4UfR8MYEt8DfqwZpwdV	127
11699	2vafqe54gmtJt3BAX2sasDRuMVAEF8WYA2GdJgm6QXsee8E6M4wa	127
11701	2vb3uwUqVzcaRvoEBfnRvy6kiHEUei4oqfDpAPqZVcANJTyL2EaQ	127
11704	2var9pRqj72KEUk6HucMmvsFdJGPZv4Bw2QSS9Wn4DqtXt22mXhM	127
11708	2vbwMoK6Y5N9z2ceYfYVwyGjGFZtXLbVLESpwd7MRQtPpdpJg14Z	127
11712	2vaVQDT6v4Q6Whip6ghS1TLxVo8DnQewNM4a6Qk8n9PEVuH3EPu5	127
11714	2vbYh56LnxoLFWTDzPh85WULa8C97Joez6bMEp7vw6ShfpMKSe7Z	127
11715	2vbTweVkSiKjSfaQ67nUnj2EckT2DsAGb6vw4uYDJvZcdMyxxNFZ	127
11725	2vbgwfwov8P6Am4yszDmEDCHEDsPgyX4JYcsW1Dm28kksNo3tfEJ	127
11730	2vbEp8SPWWmHmEPfU8S4GAMxBMXivS9jigdHxoSmcLUKabhT7nUo	127
11733	2vbVj4RiZSk1FnjzZ7vxHpkHoVwE54PLPEMqXNiE9DrXq8t1rv1C	127
11737	2vbc6urjruFEdjYvUZ4QY9dkqFLr3YBuuYgEH6R3VNV1DvgzwZgz	127
11746	2vb6fkeRnxs7VRmN8kEpNgAr3aSCJtogrEoyKg2XxnfWgSh6CVuA	127
11749	2vaSyQvjwXAxcFwuggHwtrYV75ZCriDSDtouzzY8TrNVy7ucPvNV	127
11754	2vbEnpS6biJ1hMfHX3oAnEJ2WnUE79SBuXE6nvknkHaycPTj1C4A	127
11760	2vbLxPoBxV4T2BBvFz4gY6wpVLq69oZb9ojD7Q6r8TxPXWsNL4rM	127
11762	2vc2P4jziJnmB7uQcfounbRJ9uptvBN2vkw2Sw3vEPYdkYcvXRgi	127
11764	2vb5BRNq5uqfGuor9WayUbNzRw2oKEZUPm5SV19EvVsB7ctrGvs6	127
11766	2vbkEFZZRDHYKtBaysPUoYnUDG7y8ypCNNCprMM2oWPBQUvhCvvD	127
11769	2vb738ddh45L2hTEFY3fyAYpZK92MsEYC2kNBagEKKdNUJfgJ15A	127
11774	2vbCo6FQaHjFzm3rk5ZAbfgV4gZw7s1s51MuuCZPFkV5Bbz2tEXP	127
11786	2vbNTgmRp3R1KGwGGLu3mwqgJYsJVhYUQxtkFXJ7k4xaV1an59Xe	127
11788	2vajch45Xn872Ztz9qMyEVkowUvUoqF1cNXmCau6pmeeECX5chrZ	127
11790	2vagupiatDLhHnxJUVTemdxH85oX197C7GJm78Zfw78V98bBozHu	127
11794	2vaBYVxQhgaJQvBsMAwbj4jYvamnchCCmGKywxyMULwDvJov32jS	127
11796	2vbDy15xyoSF5RJ68vo2R2nthAppkRVDc3cSNrt9FmAumppt8ybV	127
11801	2vbpFhzUVbPsjY26mjzRC3RDY9vqVYjUrHGkodKLmkUcfw9RX2fT	127
11809	2vbUM1wzXuU9Gq2X7qo3wR2TvWYmkA81XqcjL3LPJaSjvkQNUukN	127
11434	2vacDPAqV2BBKJ8HsmNS49BRXCbdZw1PRCMWeDwCF3Q2dKz8MC24	127
11440	2vaKczy9wwUSedt6Aa6vqLzai5oi71gZtxmfrtzkcTKpP3XANrKZ	127
11445	2vbAdvULy7QPAXZoLE9PtjNTGD4k9L88xovP5yE1RiEThN4zwSpQ	127
11447	2vbXCv1Q5CRpDFrJ2KezQS8LX1D5oyj6Ndau9aMGcdjUuJgs3Ajf	127
11449	2vag81748DKxv4DV8ijoPV6GZeFcw6NRDSkaybpnXwHPk78BK3d6	127
11451	2vbiweAJreu13NzqVZ61pTAAoeQG4TBpvjPKak7x6ic4uTMziaA8	127
11456	2vbW95FDngm7T2ou5LzkosfYxumEHDTaVvz2tyTvdU3Z3WaL7Rdu	127
11458	2vbRB2vRk7STRXRibFg7rVHofYjy3RjWrHoExp6QxPNKccxfQqrt	127
11463	2vbXDSK74vdqAuXXh2qo16si4Q52pYdHV2CjAfwMQfF7WNLT3sjj	127
11465	2vaNU1bjHYNa9BcrgFvXbp7te8QeYdk7x7WhF6U97PUt3EXWsKoj	127
11466	2vbVXi2d2cqL2JdRuTDoXmqLr9hQCmFYjuiPXcytKxW2khqqN1Jr	127
11472	2vc5DNNhWMXKHGMbSwQXBMiWfta6zr5ftMwb7aKrzAkYJs3ZeuYF	127
11481	2vaCfnaGgHcazjJWqAfSAhVADLps6QJ7G6QB12hrBLWxyMr1RMFa	127
11489	2vb3uDjqiNnzuQeLfo9i1TDwKBshQSe5FxnLJYwT2fMjdQPX91RU	127
11496	2vbw8DexvVnURBCKMZGS22a7AgH2KSTjZ6zvBc9G8mAz1ptco2kt	127
11498	2vadbWjmkynY3HJjSKZe8Tx7QtYYbb7gKtPMnWt9KAaeCQrM1Ar7	127
11503	2vawy2vAoP5dxNcW99fjrbP4XZ1AdZQYiTwA7mcR8ebdMAkzaRUd	127
11507	2vbuszaQdgPgw4wRAyy16ZnqxmmSK1DVWz51Ti5fKESo6uniY1Ap	127
11515	2vagLK81gsFuwvMPuX4avj29DsMPBzEwN3ZuBHfVevjkpkk3NoAs	127
11518	2vbmGCQTdBF928Hr9amMEw2UjVVkuD19Eq1YSfLq1Hn5Dnz9aTRP	127
11526	2vaik1xf66waSaSPHjmGbGg21a1XxGDyjNV7x9KbXcm9PEdk7Ywi	127
11527	2vbXsRFduTkVX3fYxuvXtZFLGAw2v2STT2uhoqXh1sSUdwabL6VF	127
11541	2vb99d6KWU8DXJsTyH4ZTTnvNAUS1dhrfHCaQZ7BYxYCXDVzD6Kb	127
11543	2vaCdqbb8sfLDeyT1D88evmstzEULM2pRQJSDjsuqyJLewm9ZJJL	127
11546	2vbkQyTqD7G1e4fb5pEJUV1bBTNGBf7eXYnTdrKgvuzvM5Gw3MHg	127
11556	2vaxzeisCQ1Eo8c5TUnbgPLxtVht1oRmf4Asr37fSP2h3CDBYR6b	127
11559	2vbC46X6w56uWSWJxdSaQNXytH2WrVrb9swTNFVo3zmHW7wPDpFu	127
11566	2vbbD4GoJfMUZsAYy8r8XoTADY6iyGU3rANVFTEmFpFCXnzfET48	127
11577	2vaPhKCtv44aKh7Nj4qzSfgJyuzv37DBkKtkzqr1Pjwpe4xAv933	127
11590	2vaM74LD1KiB9Kf2dMFxk2YwNuHi5RJxyfsBz4Q6237L2Jp1Xw7Z	127
11592	2vbiscg1hhr9fHJHPkajSQoqDJLM7dDMrb6WTw4NrFvU1eVS2o8Y	127
11598	2varNyjM8Nb9PE9pxMDMXtaKcjUhYDsHQMq19Vitv7Bs31a3RkGn	127
11600	2vc2osmveaahNBTqUYzadx86DQGNQ4Zxssoj59qSoFWb2RNGeRxn	127
11603	2vbwHAY2rEmJKBex7VMyNiCSg7z5WQ1P2SpcxVtdmHmbNpgSLMSc	127
11607	2vbX8jtDoFk9SDXhMWHrkrPr6thHzuARUDQ4sgu1UX5V2T3ThjRX	127
11611	2vasPgqMvfksnhdHtSDUmrhRB3LLA3qnZN9U7VsbcdXg8jgwdvky	127
11614	2vamnnWZH3e8j1b9yAFw7XXWBSzsz7YcFdWN8Yrgj5ecNrD2zzan	127
11616	2vbNtrNNeBdJtjWMj5mLN3mShFxZv43W4k5sPXJaR2cco3strCsb	127
11621	2vaion2vJY5VYVV3UC4FtQvmA6FBhXYiJ3rFGuoJPECkoXr11TP4	127
11627	2vasqkoY3FuYPabe89ZFYpE59qf8DCBMNEj66dNHNanGhaJJsjzj	127
11629	2vaZeNpbyq4Y5yknvzziVz6pzBjKyG8T5JS4n5aCWG4RWWzBJmyH	127
11632	2vc2LEHsVEoRcRaTw8NVELzbSvWZsEchaXqL4JY163Rp6aYmoH1x	127
11634	2vbS9277DuCYKCor9tvEejRqsTvjn4eFJYB8k4fratyKemCkR4gY	127
11639	2vaeKYXmsjcPxXAjWYFQjj9SvGmMKwCSJZ3pSbP13qQkwSXhWLuq	127
11644	2vbdHK5t8YJmvSda3QTqkVV6tZ382MYxd8pMmZ3PQwvL2uUWmnpC	127
11648	2vbnU6FUZM7fgNy7pze9tJ6wW1HZJRgjJgCu6cjZ4k2P39ZDowye	127
11650	2vaqvZG6c9tEfZWLCnAZYHsbVFZaDsk9q1oqhiTqeqxA65PTgi3F	127
11653	2vbZ1P2iryiWz8ud427MsFNeND4WrHtsp1w86m1fBWEdzsWfMD93	127
11662	2vbE714GeYmb2wT6pw9kmg3xGQriSiMoTu7r85ztGpxuPyshH8fY	127
11669	2vbwKZXB29Hbvk3jscd9LrT8gpsY2EZt2rgw49UKE3ttZPrYyMVu	127
11672	2vaie7B5gwBuuFdKqzVfC3cTwxRHx2cdGZHe8tovi4jd7BeYfkBV	127
11676	2vbaYWUwsBM3xuut7XPGUmyzANsh9kKLcrD7wdrwYMcyvAAQjy7B	127
11694	2vazRfX2EwKNYKQk6pobwSXGbtTpX2TNavXascSgXXWvWbcuEtFm	127
11696	2vaLHPym4rzrBiobP6JrRp6Td3xj9ZiKV79jeATKLkzQAGY8ZMPh	127
11703	2vaLXZBtWzGCdF9mFNjQaB9hDVszyZmSpwDcPsirG4iAkNCHnbPs	127
11711	2vbvqrXhDokXSpNa8PqCDybs9U546KzxgADwBzZdPdCP5gDcofeF	127
11713	2vbyYcPXgMrShWMek7dWyX4Zp4XYVDME26CGYjU4CVRLWgjh79bc	127
11718	2vaPdQ9ekqo1U4BAeYpwsJSFeCaXFwWwbSQvGkUZYKUEqNeo6dU4	127
11720	2vaEcxs72Z7HbcrzF5iMBWvJVFwYW63wopfTVmNDwxhXt3DY89z9	127
11727	2vbfbFLZbWk5ELhsAL4yJH551uRw7mJGtwdyRpnHE6Q6F6FQgjwx	127
11732	2vaVAtB8KuAkBgN4rC7V6v6465xFN36WzdDnzKxWeHcmbkbqDDg2	127
11739	2vc2GkkXRtnNzHwVcuA7LJGPK2Z2dVc4RPS4GhvokuwqMnwCUXbB	127
11742	2vbC5jeTpkBV2i6mPYatJnqLnMQ3NL9XGyYLrFj3VyMbPznApCwR	127
11744	2vas1bXZXv96oRk1jkvS5f5JC4yh4YpxhiFoSJHnmsRLcAKhiip6	127
11745	2vat4Y6nGQaDgZPHjCVrWCwnnkyhVtdsBohr3rXVE9x1Az1nCp9E	127
11747	2vaNnSet4aV7z6RYr7EC6pT8NF6UnZ9t2uSRbjZZ2bWugU8H7MPj	127
11751	2vaPzJgMN12y5miXLyYXo1kSFbpFkQzUAx6fydzdXjDtHdnmzkee	127
11757	2vbCnikrhVUsHVakcikSKuwiWJwvNpE9kMGSHwf4vnfkDW9ahGha	127
11759	2vbeFi3vtfCUHQxVuf6JgEhigY7UKyhF3fVXTy6LeoMuxPb8bLZ9	127
11763	2vaRBMv4PHEv7F6w1bDQL5HXz7RY3s92cJ3qQoQ4AySQVANN1S5U	127
11771	2vbQVvsCYZ4YQB24cMBpXHe21h2eWPod8Ld7TTScYRbDzv7Fd3Yk	127
11776	2vb85jmeqPrL4xLotWpqEQs53GgYv4cPRnDgJtt8AydLTHT3BMP4	127
11780	2vaj1xUprVwSn2TeyMG4WW7msymQN2ayMhbQSxtSZyQa4eaP6SX3	127
11783	2vbLMexmJCshqmkdBs2AU25fag7uzwkYwh4yGhpCXPiPGUkgcZED	127
11785	2vaMm16QGGUNzHpNLThQFuUQ65HeHUG59Toqx8RiemKMKA4KUkFV	127
11793	2vbv2rbC2qzGvwJwgtRtQWcwzNcSk3fYFcatTxniKmpYJEdZgt3B	127
11798	2vaWdzobKZ7jqPqDqs8ywj7zL4mDRAheBCF1ajanZFarK5mmH9gL	127
11800	2vc5V83tekuwU2MkVS5a7CyXDGignyz8TpwrkjsJVMuYN6x13qUs	127
11804	2vbvkSJkHx8RVHCp9D8T5L1CLbFFRMA6dFdSwBVitTJ69Zekxj61	127
11806	2vbUzmzyPWeSYEsZq3AizGoRTFMa7dyNs66oev3cKwasE96KiCXm	127
11810	2vaXieTxcnEgPb22XbsrRiBJQDKtwdVnPFYBa2sUUgbVJ5PMK9ic	127
11813	2vaV5gtyE4q4564vvpHMWUhRcxbmLBgAzxaWSqpMiVaJZNWSPR9v	127
11816	2vay4Zb3Fo2rAyWgghskTbpG4TqVTDXFTF9ZiVHCzGjvWt5hGEg3	127
11830	2var6THR9M1t4B3VxNrN3vJXssgBgh8iLxrx1ycARm3S7pUN3vPF	127
11832	2vatz14i9iZgvKF7P4RLX2DKqpcPuLVKmNmYT2RWmo3hZoGnfMtb	127
11833	2vbHg6FJWS1g1Fr3ACg8hJ1CK1vqHpy3jGCWaNWeHsn3HMMi25kg	127
11841	2varJp4LVAiEkUPo8xE2t1au1DfyZbMuNQgzjUPD4hABEWQRJC1b	127
11846	2vaCVQEsPtNocabTz8E2rqeTUYY8NR6B2Cq4fpmtodmZNUHhGPzb	127
11437	2vaigEYtXNWGBCmqmLFULds9QXtjCDzmTt28E8eWj3asuZHUCM1c	127
11442	2vbWSTeGnegY9xMubHhszhsfxVrNyRup5dqtWPW9Dcx3amosmmBf	127
11454	2vaH4oVushVBHU7cum8wmQDcw9dN16w2jvCy9GzdrSVJrVCm1ZTx	127
11459	2vagk5V6AWQPLDSwyW2YRMy1Hhc2dK3QGgRApmbMF3BTxL4P79de	127
11461	2vavccgLEkAroj7vbesgxB4QU1JJqTcvADXfbLNyVkv5pRBfT7jt	127
11470	2vbtYVBAxyhSk8a2px3Vr8HxDk59rPJJLU5kj9arzavK6jcRAeQ8	127
11473	2vbpERKhvnNUrpUTxniMVouw6ZMimWM2PNsdTw5tkheEN9fo72fq	127
11475	2vaNBJqTw7H4iBsvi5PhNvGK2ageunCfFVRehPDfU2w95hNNEjnn	127
11477	2vbdRDjzVvpudNu7vhERd11TogwMKLavTd8qv3pti7vGYNd5hP7f	127
11479	2vb94PPFMsxx9mEYXcJdxi5pYpty6FR8i9QDuxMBgRXokrspGw7W	127
11482	2vatM9BosiHbrcX2vbUQEtVHwAAGs3h75zfuxo79pPnrY46S2KMZ	127
11485	2vbK1BEw9Rbn8t6m5sqJWKxbDdgjxpTJ9sNqHRjVPW9JNu2pEuMP	127
11487	2vbQgLuf3hs49TsceAPig9ikCJWRjzWR1KrdXihNXssoUmByawNb	127
11490	2vaxi3iv1NJ2dSW7v25sN29niJ8i8wSZmetHBk1EAPWxcRyBSwDu	127
11492	2vb8TLeDU3jGQHK7mPENuaUh3RjT6PFcco28ZZzPkRouCWkeHzwQ	127
11501	2vaaFcJnQsDom4bdWXnPm21GYcjng4Nd6Md7YhvntKrqzRA1Qnjm	127
11506	2vaGvuyZktnvYMF5fvtQ9f2sfB6dWqT7mAdj88M6erdFpmsoZUXB	127
11508	2vbSN2uAc9FmS1g7GTqYD71QEfCEsEbuYw9wjNyhny1qSps9LRQy	127
11511	2vbRRo8dVQfjmyNWmghNLagU3unBKcZoGWbnYen1q8GXM7h7Dby9	127
11513	2vbdwPf62KtrF9C8WfbYPRTxrybGEJR4rM83GM7C6zPjUGvLgQ2c	127
11516	2vb8UDjbAS8iYvTvR8ARKmTZJAACezVXMPCKC2FApbsazWKdtD7r	127
11520	2vbquNakAGWtjh3T35pgYyAiPaeXzZzs7uUA2rymeNE2oEkNTYS9	127
11522	2vagVMYgSE3rxzf6qCMYGmbcXCF9w1myQAQ5XjUCGNrybjghSLEW	127
11524	2vadnLmsx3BpKSxddon7B9YXmNimkmJwm4U4GKoe8xPuzYXsk2PC	127
11528	2vbhS3e99g7vXbcretcgApr9T2eU8o4ojVf8cMCF1vn16fHAh3yx	127
11534	2vafGeSF7GXyWnaZunGghtBAEcTfjKxwDwGUW5Ft1q6RVmCY7P6B	127
11537	2vaFcSnjQBJri3ssGLUU2MQBpBSZVerP8EQpPcGap4fRAEunNDfj	127
11539	2vbXRFVrms8kAdk7kugfuhmmuCXezWmLNmY6Cj1xa9e7RFicLs2D	127
11544	2vaGtjPxSYUoz4xKB26WXE5UBu3fzrU8rRr5jsJggvTiLsYuoGxy	127
11547	2vbJAwC1U5J5BDAoKPGw5hm99PZxX2Yik7iKFiaDgfm8hWoPmqD1	127
11550	2vbLaoR7Zg6Fwy733QQgdwt6JaFjWTZzxjKrqWtJEBePh58bb8dZ	127
11552	2vaR4wzDJ6EKeJkCkEi2SXx1hdsCpQSreVsusSW2mtJdP1SSGSQi	127
11554	2vbdESFmowPQgWwit7iu6j6EkvYjHzJ4RBZAHVJw5JCMBwJpb3h1	127
11557	2vaDzm3PPyMmP6LAnkoPAxzmNwVetvMkYBgvGukudT6jrhJcZrbo	127
11563	2vaydyW4rFiQda5z4cSH8pH1efDi5GrJE3dQqME9cdA615QENEDA	127
11569	2vaH81dmSLHKBwUw2hk2RAPQyvSHctvsymneXu5MjogQKPnr4fxg	127
11571	2vbCurJnanEKYkYrpCnzPfoetaA1jVVj7hXpHBBeJHWWnch77Ufq	127
11575	2vaVysLtVm63UanFDoRSfPmGGdRBNHg3XQ2avuHmPEWvDn3VQG2x	127
11578	2vaiaZGUi3SiJrA4jFm2yaBhfezFctxv8k3eqmYjoKSHk42iyoeL	127
11580	2vaBrcpM9UHx1UcbQuVkBETMdRmwmA2ZsrFBG9xdd7Lxwuxq3e49	127
11583	2vbgq7wPGYMhysSzBBJtcNHGDAJ1wWZ85oX1qVFJsdoP8KdtwHK8	127
11585	2vbw8GzQ8ujr5kRfXP8hUjnFCED3Ri6Wp2HqTtCECFQZtekG7o3R	127
11586	2vbkoNLTLC6eQo1vnmtYe54gHkVQ9NH4adBWcYWRoL3VYKSAkZwC	127
11588	2vbgMT6srBpqws7svYbwAHJb8UCtjnBmGMPkBUrQmHRpMHVUCLZZ	127
11591	2vbnPfkDwCZFu5ZYFZx1WqRS5pSsfdG8tFwvGnBgRWs4KHd7ANdv	127
11593	2vaHUNkS6u67WsTfHYW5MgTU5BYKqQdyDrSY3CuNNZDceA2P8orq	127
11596	2vaWvXTSmPKd6mRHgrvsP1KZDHB5ra17AVcwKTaZddq1UX2BZi2t	127
11599	2vacnCBmMdSYvjxuYw7sAonbsFTuTywRt4z5k2Xat38R2zB6sHvX	127
11601	2vaS9id9ZQybuQpWtbryXrrTRkdg9o2jLyuCMtzm4BKV8XpDsRvL	127
11605	2vbUxicLB64i6SszCg6rGWTU8d8byGDSvh9YaQXPPKC8buZEA4LC	127
11608	2vbSS28qxQoCHRbp24Yc7FkGNTpCqhqEb2y3vqeQxz2z3iZda52j	127
11610	2vaYQ9nczfLbJzQn7TvoJT1uF2nY6CXRWfPz26HJg7kw34wr92Y3	127
11615	2vaMxmDy52VUBLqSsjwN2cn9V1V5LEXu9cBrSHmQU5rV4cuHqXCU	127
11622	2vb7dJinPbVtrJ5Xq18t1nrE7DWnatbBEqUNP8B2DjA1AtFM74sr	127
11626	2vaDck6XNvXqfM79rotPwN7ZgMwTwBiCovzU5dYmoVJRg91bt2aZ	127
11628	2vbMVJJauiSqWb3swQ4xTzojkVbkVyzBTAfFxQ5sYCVkcTVedKW2	127
11630	2vbL7o5z8gUgL6a3kno9posJuQ89sK3kRAmhkiQBbCHUV2UprqKd	127
11631	2vbgSCKJDKw44KednCtZ42ghbZEpatjnpN6Tm5cB1xjjuUqJrj3Z	127
11643	2vc3btnyVNnCg9ER3tcv1hP4bRxfXrtU8oFNvrQTeRWfYPyMJXCH	127
11649	2vbanHSuYLN9hfhmwe2e3hLFnffCdKpYg8Af3wgZvjp46z8uD5aC	127
11651	2var2CpFcou9Fhb8CaDCaHm9Ys5gesVLYHN9uYEGyBtSEBd7sUtU	127
11661	2vak8gy4qanSBz4JkijrjPTQ5AYrqH1rhWgpLvLkmJeDK9yKH3Ky	127
11663	2vaSYBb2xR3o6pGPE1KJVLAtJpCtnVaH3voMD4TFfXKSrSWExPQm	127
11668	2vaLDSRjwCMXzW9S5Hj5BZnyvVeRbD5iam1c5FSFJxCGdUtVLXcM	127
11670	2vbZT1nAqpNJ6WFVyqcx6wT5yKZxLTPnkpem6hUVHbZkgV4kKEyy	127
11673	2vas9srHnvPtjsycisuwep2Y4pVcPXZRfURDsV37uECQfZzVyqGs	127
11674	2vbtXWngTqfJNk7LTRAQsm8JezELb56A1UXQzW7NQQ14GLq2KhNp	127
11677	2vbdvc1Ns46udRduJXLDJwaihcv5HTy7RVb6bCNCcNPnZojwaHRB	127
11679	2vazzxRCrbWDdGusqf9C7ikvtAfTXBgGJBcHsk9XGv1HvmJVuEVt	127
11682	2vc4G6tp9bTDzHRYENzfb2zm19TtXmCUB6uEY4ujHB2B5dvdPbFD	127
11685	2vauunNT6S3r2UzMu4R5fVusTY4TCxroZNk1PgeXK1De3Srxa13z	127
11687	2va9dTjvyLB41tf4KG8bMEpXBXcZhg8wNGfp6deqrrv99yCNambS	127
11689	2vaPnnccso9CZG9f7Nu4atDP4PY6dQMGT6XQJ5E4khsUtkauP6C2	127
11692	2vbo6oDB5CzTd4eFdcfyJ3c8NGeP7JXEoSYp9pRpUKcQcmeLxCuq	127
11693	2vaFNqCcYx23hBwzUvDTnpjn6hcBCfzuaPZBgNtNRfsTShmjGnt9	127
11695	2vc2RA3xtifW83eANW8Wrro6jvJwoPz2c2cTHKm6rgmdb1d5vfmH	127
11705	2vaiXwBYQisDyi5z4YyXZRbMKSDHgrp8PUapjQpzkBssmGY36kAn	127
11706	2vahLFYKVsZdiYZCJwr4Cs4B5JkjYdcWRjPYnByo27TVmgEYKRUD	127
11710	2vbYGvphYJU5saNgswfwuCv9ekqrDLqPtZTRDUdBejTHUxAFJ7Xy	127
11717	2vaDiYu6w84aXto4wNqj97KxTUAjdd4C2tgsXErn81a6GHnHM8uh	127
11719	2vbocCaixejbNzVuohzN97YBzxnCgP1DennwQdPcs5HnTuW8kysF	127
11721	2vaVPoMmXM2VLsqguACdviEQeFvPC9RHNSrhgsSrRqEUWBRNN3R5	127
11723	2vb4MqB6fXrNrCarFdrBghFeMgiGu6RTohBYPuyVDcCRnwn4htgP	127
11728	2vb7SuMEePeBrcpxFDaqAzxryWg5Eao4eofmydGR99YAfLgs1nKr	127
11735	2vaLwvEP6oY4yDWrzhbdZJ5Uep2cKn1cLRR2xffKeac1fH6aeASG	127
11740	2vawz6LqziztgaiGEY28b1Cujx1qZigYQeaBnbNSqEZjouS47tjN	127
11743	2vb13pA4PH6K2nWxEzMjhXfAcPkVtDpCUuu4ss1jgpSLSV2tLiWH	127
11750	2vadM4jTLBN9LUnWBE6F7Yd5DykqDCxYdN8B9TSZdMfM2TfBaV8X	127
11736	2vbNLFc8Vi64RwAnD2KRt44drHB2HuCw4aqkxywER5RN5EWccF6m	127
11738	2vakVypGabJaH3rbwEfEHwRBRxpUdZamUY5DRsiUaHZpFRsrpz93	127
11741	2vb1QeBXeS1J8HwJt2AnmeXpa1ifCLWDorMqWAKEyzKdJyukoGt6	127
11748	2vb5NHraqq8mgAVP9KnTe4gXVRLBZVtUH5BevwRxaqn6ZEUu31VP	127
11753	2vbr1B6XHaHjfs2QrR1f1eVvtTCJu7D2qqcCrNpwoq5wuwVKkevv	127
11755	2vaHBd3ENgArLA4tD14UpBBgQLj3t7NnftB2V1ZG55kPuA145dyW	127
11756	2vaonsHbDFNqRw71ZdBd1TGmKgjfGstPhU8ryBBsyVXfcnkzPqHN	127
11758	2va9oYSb8irbLLZ5RF5v8s1HTzK9ASitckWD8QchjTSz2Xz5jmUR	127
11761	2vaium8rwsnKvnBna6sF8CRU461QLDNNzGr8jREWYqKrEWTFHUMh	127
11768	2vaH5m62ovhCzRDRYVRGD9WSXup3hmB6PwkUaoNRaaGD3pgx77Sk	127
11773	2vaTcLv35GPHjd1e3knMWLZEd2LEoE6Gzh2ttTwj9pUCbWv5bLTK	127
11775	2vby8gLr1HqYWgy3Z7kduJZgkVYnjp5VGnsPe9dRSiXeg5qZf1mL	127
11778	2vbRmrghJckxgv279qVp6XuKBpT2cQG9ZwvFQTmTzczwnhuCyUss	127
11779	2vaZYUNjw7HDr7uarZiBjA9og3KYMRChPrENy7HcCXmbyfW2MZwP	127
11781	2vaQvrhzSj1r7MxWCp6NMasfTygqy7vWDbWWvtrdSZkYKPH75i7f	127
11787	2vaPtc4XRxi7xD385gQBRSCVt4kitpWcLDLLjBHhfuTd3j3rK1pu	127
11789	2vbW8CYfCyTRUnuaW9Y29isNpSggHyHn13qhqeM8vY8qKXR1YGPT	127
11792	2vbKGPpqXJNFzTW36n7syTsJ6d7r5EBPbhtkYnQiuKgcTMe3uNc8	127
11795	2vbxw7Lw7BAr35XyVhjb1ig3tJMmFo15Zv8sbcujzdUE44c3J5io	127
11803	2vaYgZzv2RkQtZU8RipUTu18kB7Aj3aaCgRcuzKdXxmHCXQfzJjM	127
11805	2vaRLCSWbv5MrqXYKZcxtN2Ejfq5L8UDeqWxBiJjTQKTr3qjHyZT	127
11808	2vaRKxQu4qDAa3Jr1x6gsikTnfLNo49FTRfF4vxUTu8XHFJCeojt	127
11818	2vao7StWnmVDZyF9wFwJMccf5ks9a9aYyB1B1isZVsevsaQXHFKN	127
11822	2vb6USPoDk6iPe5VE8c1WxuaybgZkeFWMN1pFDopmPwvkKQfkS3N	127
11825	2vaXxBgQZPBvsCKZYjejs3qVoXvMAYd8umifVw433jcmwfQmFVUs	127
11836	2vc2BpTphgyot4bMVCpU2Rgt9Hg4RKug4qZEpmh3WFvs2eRaPQHS	127
11838	2vabSDY5GQeZRc8KALEaKfpHLk3KRXm6JL9TtqC5EAqYJXVc8V9H	127
11843	2vbFJUAWXcMge7UtZdH6r7i3uwtHDnWkzN3DoaAt8XUcWBTvF2SS	127
11848	2vbYcunhqovJHcyWjJ8F3u3T84eTgpefNu2qLaGyWExgdqtyvToD	127
11849	2vasWjRspZ7uFWXdSr4geJs9mWW5d21H32bTLb2GDBzE7TABBXFD	127
11851	2vbcexrzDJKpHAM6QZgDv8ULMA1sVELGvasybSBs9rhoBE7DkmzL	127
11858	2vampot1Fiy7kNQmy5wu2pUPBGd1pkoaHTyBpBYWVwXi3qRzWowe	127
11860	2vafHy5S1ihcvvnHgoJGnZX2B8XVvcR4H97bx2DEkdBnUzbKovoR	127
11862	2vaY9BVj8cfPHaD3hWkUWjNfoqG7ihBbPEcpDnhYP2ppwt9TXoni	127
11867	2vbToeNqG8ov1a9fJmaUxz1gaQioYqdNukLWEXCFSrZumLm1ADhd	127
11869	2vbFqUTnziVxCgQ77W9hEkLekFAbeQzxmCZmF4XPNdsoEkzYmcH1	127
11877	2vbi5Ro79bdCmKcHnS6MJNZSNfb86kke5b7ptCwgdxcm9A2vMynE	127
11886	2vb7HUaHoytbgZbjDeBqFWmwc6YqvkzuwcwAqogdnfw3GCTRbAZo	127
11887	2vaqw126hqPRs1FrvTFizMB7fN81KB937TB1Fhftq81MAmbBmKV5	127
11891	2vanJNP9PVzjtC6Aij8GNp4ArDMxyzBmDAkjDvXFzdZyQ1EJFqYp	127
11898	2vaoxvFxRF5dughJPe4zaPw2yGwy26gBYEWNugkznNAHMy4T18e7	127
11900	2vahm3kvs52QQyg8Lju8cz3MfJdsb1wWTAd7XZ3tMU9LciVu41TE	127
11903	2vbNCvbwayRVDkbHB7QtMqD8D8QuQsPSi8CGRvt3fmiBXciemQzk	127
11905	2vbtHjJbGvf9KYyRjE8qNoyD6CyUAicPSZRwWbLgadjZDvD3vgsj	127
11908	2vboZTxyENXELT4VaphF7fmMQczHTNriNt4eptNGu9aCv52r6K1E	127
11910	2vbHSctJXkQAjzsYjdUu63CPrMDRWXqsd32ZSnbKoatDkzwFzhRQ	127
11911	2vbrR9Rj9BUcthkdGPGPfMW16MKqFQccy7qH4LRfzYtPQC3zwGJi	127
11914	2vbEAfYCmBY2vxFPQKDANm2MhiiK5wM6F1YWTdhfZCcA2e1N51S9	127
11916	2vavUjiaY2W3CkpNP1gUL65j7gf3y3VpnQxh7esKvXFz2S2peqw3	127
11921	2vbVL5A2GR7U8fB5q8R3KxtMtdKsz2oWNfQn1SENTcCBHo32LJB1	127
11924	2vapRbHU3yA6P5qiguK2CKdTCRamAahk9iYyFo9TdhgDKuP4Anh6	127
11928	2vazN8MtZurZhn278A8Kts1mwBGz3K4qnHs3LvjAFRhqYDuB4T9Z	127
11930	2vaww6HAXWoGkkLHAzKFFFbG6pEyYRALGyrMBC6KeyAD8wimyoHp	127
11938	2vb8goAnABSS1tz2KqvXrZQ3RPRjtJP5GYYCjM9Xu9jkMEr7gpr6	127
11940	2vbsVyugncCBn2BVnRBdCkaLhd59w3xPCsuhABJHcqrxjvRLQ5B5	127
11945	2vaS3h5UnGM7phBjzHauJHvHVcVKph188VJWeQu7AyNRJtkRe4XH	127
11954	2vaUXahYtRwfZzvB2vzT5LjXcg8zFrVa84ztv9MCR57iAoBzG1k5	127
11957	2vbLehJZzFjLFM5iX6WKTJvfLnvw4c588t9d8SwrLx1YDFUzTrSk	127
11959	2vawesuofXBtjzWav4v7ecrEWYVqyUXRo2n2yRR2gudbzHNfKNAp	127
11962	2vboqU852FLVCUspyAqeVf77N9uuvwxKcYGdHzWkRpngXozgEx8p	127
11965	2vbEVo77XfvvoycZzianC4RUBpgu6nhnC6j56Zc6xqf19wnTDx2h	127
11970	2vayg83FgmyZBw8iWzKHU1M7pb2NXxq6Nm4q3iNeAEPsYmNmzSin	127
11973	2vbEPjJsGgHJRojbbFBAQ32t7GpL3ueCtjyg2dWFLfVejbLC4n1Q	127
11975	2vb4CaRLjiZJjtRrsbwv8tCAdnhRsPTFYcdg93kZADWSKC3BxRZJ	127
11980	2vaKo6mHPaCt1UxKXREMuK7FHnQzkUfZLEFzrW4bYedpYssMC65y	127
11983	2vb8coNYARFnoiqTP7mHcMFYvj1bnz2Pc6K6QA7CcFhuVBJLwyep	127
11985	2vawkdLgSLsSVVcPKs1A4wSuWBq5hkPJihLCZmKqePs1qYhdqaSS	127
11988	2vc4U728R96AbHmhV2XzhJSQNxf83nYDHoVvk3tfBYYK2WBcLKMp	127
11992	2vaVVmc4vHbXC1ZMY3R7D7NJUpYqq7SrMhRxqTBnteW5QdGw27fP	127
11994	2vaZBAeUFgZAPG2kZrsPrWM64VFoRC8exmu8TnJ5VTe5kraJwsA3	127
11997	2vaNTnT1nTAgX8Q8SPhV2eunM7YiKrikJwTJxrPrDcKciyYdogtJ	127
11998	2vbHAt18iXFjXFxJkJUkyt48LUrXEDUP22Qr5nwDv2k4Urbs83ka	127
12000	2vbFjudDjicgQVsqKAoP4fCoDnubk5CgK3nx2zLHctHT6TQRYmUG	127
12003	2vbJpxQid9eQrtQLHnL9QgMQpcrqAUSmU8zACQoqFfwp3BW6d2nv	127
12005	2vberQN982hykUjrdgbXaXkcrmqK2Zo5aPkq75wJBtYC8b6sarP3	127
12008	2vbFWhbZa819mt3xTJ54TGQjbYWDNvhqGY7nkFPkjrrBvhKbNXRL	127
12009	2vaJJipwgF5pHvbNVPhaRSkh9Jc6VKLBpC4Pf84h3roiegjd8bkZ	127
12014	2vaqruPVAAZk2ts24X3bGouoFeEutMwqeVNcewkzTXtnkvowkjj5	127
12017	2vboqTmsYhCDDr799dwjRBfbyB64SGc6Wdy4mmXJejfPrKK9cByD	127
12021	2vaYGt4o1Egoep6BFwYD9z2HfroKrmgWDFFdFFrfzcY7kiRcKrxU	127
12024	2vb9aoAgDfizmZazPej8z2dqU6QQoTQQw7zcJVJcX2Se96Yqidcq	127
12025	2vbUYZ7rYXjMNR1pUjJRpwgJQdobVHFXRzs44QkRuQfP3AdqQ6r3	127
12028	2vc5TepgR5H8rjX4VdPD7FDZACsYs45qiFzkh8XETM6uGQxmoHii	127
12030	2vbtYU4GUBw2cMbBrpQV35prvEzoBkkvUCduek7QLVdzYarTKXhk	127
12044	2vbUeqEKvzUeRt2NtBZvFtxpYJS8NPHsPRYQjAN2e48CF1eKmEpU	127
12047	2vb8y6dZGvaM8LpDRQA65tiJ5Gu67MJ4cETVzNfwh5EkyvGWHFQc	127
12050	2vaAkd6pRDr5sAWB53AkfHmwaHKFAtx3YPewC42GqSSd8bgiCdbG	127
12054	2vbGu7VsEDeaZxHbfExFajj5cDLe1Nsiu7UtT8HuwzzkFoC4TPFz	127
11752	2vaSJBJjb4fruDDbP42SKLkBuENmnUPtGLknvFrh6nAnv7YZokpG	127
11765	2vaac9A5MxTdsifDt54PoqVW3oWJgkBJrvtbUY2tWynMEbpQBxc4	127
11767	2vaDdrWZkVtfhtAxcNLTxMbqWSiXKD3x29pkkXWQsxeX5yzZRmeo	127
11770	2vavYni94e7MPZYUAEJNngGxxHCN4GbUQZGowbJceJnvE8xTvncA	127
11772	2vbZPdV7bipe16jCtd9NbgYqWmu2SAqNpdPr9RZ8XvEfdau3zrw7	127
11777	2vbnY7DawTvtH7fkfWTGx7mkX4joiKbarmPGgg63ZMEiSPaQG4Uu	127
11782	2vbgysnAsHL31J8MPjT5t5HYhdednWikve2JPcsYPUf7n6XMBEGP	127
11784	2vbErZttrABubERiKm29TuN43DrqkYKpjpPi77jBxs9efEpBw2Hj	127
11791	2vbygmQEEWebKUTqJGYY8VHvrFp3cgNcF8cceW7mRqg4h2nExiEP	127
11797	2vaqJQmKZjXqZfDiSFcZyruBEHH9qos5uEH4g9PVPhtdHvszsk41	127
11799	2vaCsnAGGvDD2iKHiukWo3v2fuUPNSe3b3UMQ9irrjucxZyBa42t	127
11802	2vc3JZwNasqi1c2bukwhnoK8aKh4Z85iEpYYkfDn5JLR5jCjhnTN	127
11807	2vak2VcTDY5ygyy79UauUAVrCGppijghoAjfRb1mddRvJvz7GkXS	127
11811	2vbKBnf8Fo2KB6RHLAQyq2VbJvHyF9KKnY1K6D3hBrvnNLEQ2szF	127
11815	2vbP5CtzaPjBoSaP34W3G4dzzErSyKkWzbccJbVAGrzpcpuajS8w	127
11821	2vbeXDbCJP5ZQm2rKA7w1oHBkfTuVGy5FMFibv28kPzHXjAJsL1i	127
11824	2vc1Eju9JJgMiEabYhNDpLbEqZp83jpeiuegTfsd3AQmp65NTGZ1	127
11827	2vaEmBrgp36YYfR5LvngTGPjnBLeYDmqro6Wmg7Zm5RBQcvgzkZV	127
11829	2vbRkAtfqfNVKfPvpzkRbcsyZxBPUxEDXSm75JFowcMkm84rrWgV	127
11831	2vamhQyVYYyYGt11YZdf748rboz13xVnt44t4NsoaJ2zCd9b1iV6	127
11835	2vazJEqhRYeBuQtrtfPB5SKsKAU7MH36qeysjuQASpHL5TgGs8iM	127
11840	2vaoMq834XhuTKUK8arhQMU8ThJqmogTHa6pXw5yye8YMSC7JHtm	127
11845	2vbKme7uM5sXXVvNtgVuKWweHb2WUQ3GFLXpzH3UC4cZV5dnPXVM	127
11847	2vbpZLJNcUVdgXXQZFHfhqqjJpxpNn357jni4rUFkDDQdnRWHHeQ	127
11853	2vbkg69RnXNavauE6wE4LT2oj2FhNPL111czXprbPGXjCePFpp6m	127
11856	2vbWSKucTVUYW7yGvooCyRkJqfk4h4BTz5U3XijWE8JYKy8ycrKS	127
11861	2vbYmo2W3ufuLu1AfbucYvcQb8tevGH6UrzHVLaocm3DpgD8zzsx	127
11864	2vaZ3XxBGz8uUgQ32QBrCk7paQ75HCAKew6ab4FPWU4UHiKXBKXc	127
11866	2vbyMz9PG2zq9jbo72QD2BYT8K9BGuWNpQ2cvLJfwtDNGfWX3BER	127
11871	2vaTo795mdoEWUq2PBzq1e9WxaSzjRdhZtCtBcC41GNiKQY5SJgN	127
11873	2vbgUDau3PmYGFB6MgtK4XFKaZjebNUAYpYCC919CKUMeGqsmoaR	127
11876	2vaAQMD7RPGhhJz5qGREz7nhvy96wEa888aLqpf3sw3m87huWf2c	127
11879	2vbPYfpjjrWPV2a92uFQrur3pNVvfgfeTbtT3VvXs3bH6ZfhDyEZ	127
11882	2vaqwsAWCXbmdEqm64vRNFCp4Ytwi4h64oGZEzTN8NPyUM6zYbUU	127
11885	2vbdXJZx8Pyti8G533hjEqzXmiNSXxRUbkU5u55fmeJwcmiY698R	127
11890	2vaq8aYYd2LzxT2qmd4dEM9UcWwb4aiXuyRed8WjxjDhKR3xUUZB	127
11895	2vbg9MWJ8byvEp96G38g3goU7nVgZvi3BAH6mMab1ADuNWB6jabd	127
11897	2vaFbexBWdPhBgja6fjp7Jb6cgPzkMQHy8unJqT6aujfGYfAEDLy	127
11902	2vbNHVnE1Mnwcda37QYvthpzqi3KtJ6Na8qJTRZiB8v2qSiDxPmz	127
11904	2vajEWASfWo8SRD31xkQe2UoF3ocs4AEttW5LVgGTVCCrayhh5V5	127
11920	2vc1assg6sNDteyJ1g3Ppee9w3RwqKDLG7ZiqGjjN1yXMJqnHZYD	127
11923	2vaLam3yAP416HFizeJB5npd3fToP1XfhWwVRy4LamjqnjxznHXv	127
11927	2vaABSJw9y8eqQNXy75TbbmRit4XgAm16DgAzHycYKVcDQ5fpoXp	127
11932	2vbNhMxinr7Q7XHvQVq9bgfpybiLU9uKp1tJPCGFjB4vV1bbxEBD	127
11935	2vbXAfC2kyhBtRTTczisxXhy6ySSuGB6MqKnjmTkfNUWgLV8nZpb	127
11937	2vaBY1PnUTyG8q9ZnLyhwKoXoJTsucLTbvbZvGxgjyYbypkKxqE5	127
11942	2vbRsPzKSZxhhMoZ1ndvKGP8YvfWp8UesqVtM1WcEUVprnp7iPuK	127
11948	2vb2dT2JzZcrihnMepFSDzNDyAchWyUeY2mpnSyViG3Dts57m722	127
11950	2vbbSLo99sg9dTfRYhBE65gbU3bGpcoraMbpCWC8N2LnPwsFmtKP	127
11952	2vb6BTVticdPUWkC2vDypDPczs6CCegkb4JJt12Px5Eo5A4rArx4	127
11956	2vaNS94RMse4i7Wb8b3e4sxxWX8nQ4u8vptEcSrD94hUJujnnk5S	127
11961	2vak4VFeLMXPMHZZUSSWSjSFAXq9uretnoYPPY3irsEiDEYMvzf2	127
11964	2vb7tAHTdfgsLhMvprWeWvKcahCRbrVLWGP3fSRyXk4dKmiTstrB	127
11969	2vbD5LAp7GjqvVQfwWGrJ1dQ2Y3GBJREbuHWomiR2Dfui7VM18fX	127
11972	2vaLqEHhLwx9gi1GGHKuMrQeRzY118zKDTS2R8Aim3viYY8cwe6q	127
11974	2vasB9mShyLagm4wuRJCwohW4VWqvoE2LMabSYgtv6aEVPRpkDUF	127
11977	2vbrErWpq9ufX43CUJDmjw5FzKsBk34gJvm66ShZwt2U2oaDdy54	127
11982	2vaPwqPAGHs1XRPukq69uK5CP1VBr4KynSZTkmDNze4xhTsn5r8h	127
11987	2vaRwKurq2Bc5ZR56hAVxRNFnk4figMtiNs85Nee9NFVit9MfRT4	127
11990	2vaYaZZCGUfCWxHCRzMAURZJaJttgZaAwdEHBMxtxUtxsMUZvfai	127
11991	2vaVFXDZJpCd2QomvzSavzxYgGBJjtDY4uTQcoc37nLa8bWxJJ49	127
12004	2vbE7WeUYHT2jMvQc9Y5iCsUTaBGBXBBVz6o6fjy6zfSfasb8BFQ	127
12007	2vaKPYeJVPH3znR1iSJyVwgvP4FL949gLfGrMveJZqQ7iM9J1KpF	127
12011	2vbk47cbYfg26XMV1UHhGD8KNMd3wiakjC8Zp885nn2Mk3qVLGkg	127
12013	2vbsbS3UBd4vmMYUXUQxCwj5pWNrvPdsJsbJQNiasp9SmWFfULne	127
12016	2vbGWij4k1vFWZA65D16FPuQ7Ck8RDAypVCTzP9ZAACV1RHRe7Q9	127
12019	2vb4DA5sXHPNk3dKpGhgCbJ7CQfb86CCStxUdJMHqoYSbW6w9id2	127
12020	2vbPbKfiYVAikFWQ1bNx3P4FQrbx3Wz64hP8Rc11DqVce1VTcvxk	127
12023	2vaVEJy37CghqVzZqyrJcsAFLCzJzJ5Cni826PqeX9DCKCDnrNpk	127
12027	2vbMa68GHUr52L3P95L52YwaJA3bwreey1VRJUUPvYsR6VgFazBU	127
12032	2vbfx9hHJ5C2Ye1Y3b59g14LvgGfuddaEL138oAtENxm1dmvZYap	127
12035	2vbZN9MkebAgMWgiZowashhzui32sDwkejevfNeqUzx1bboWNNVP	127
12037	2vaEeF6xNspFUp5h2asJPN8VzfMCG1RVMLgxGZbXz1qAVLupkkF5	127
12040	2vawWP6ScjzMSCsrnPseer9SkMEYS4EsRDRwdVcZ2Km9Xytoe3QQ	127
12042	2vbeY9bKgtfLN7dky8dohuoPujKAQrKGVrfBPiPBTcqdG7Zm6CSm	127
12045	2vbQ9RERFVcBoARf8BbkRycg6T7Em6NiKcVLPeqMSVzJS6kVyhCV	127
12049	2vbj4jpRxJKdZtSwBmCjSqYo8FiFv1b2sDmSEHiD8jJKEJVpKB8L	127
12052	2vb7QxoTqBpEvm6An4vXuyRr6RXrTikr5NhN5igBSt2hzKPbfqDp	127
12060	2vawto147EXPdwM5D2fQys3euxZUrvwzKmmpCk7VeyvLb171qPuw	127
12069	2vbA4a4e9VfNNvBidZDs34A36QQc2XybN453bH3VsFcqZfQ4pnJR	127
12071	2vbe2GnxhVzb9PHadJ5ZdxrsM47MEHjJgQC11NX64vqG2FZ6xC3K	127
12076	2vbsYyox5qd13kf31XRZt32PrnTQ2v414AeS1v7UwqmPmdb7ACRS	127
12078	2vbNP9QieouhFMjnHbgtuxoit6sZN5NB8pnrzoVmjmoyEhuB8vL9	127
12081	2vbfxcu9GpKxgzWR87ADddhCDQNASft6WYfb8c2MdZifaiG27qdE	127
12084	2vbwGeumrWi4F5o3KzL9nFuYFxbCs9UPeh6pM6mWptvo1GXwZiA6	127
12089	2vaAh7X3ALEvn1G7Az3su6z2b9nmm4paJRTvMHsvjeZGvQxgH4RA	127
12094	2vbBzZUJcxsfRF4GCJUAZc7HgkCdV1z2R23XdZ1G2KVnbyj1kFKA	127
12099	2vawze5ZhonR7Xeg3DYnepBiSNxsWJ4cSYDjmFUzYaP4W1hypRC5	127
11812	2vaJYy5u5CaaZHFx5qbqUUjEVHsPHyYYJ799qHNFz7fHrKB6f3SE	127
11814	2vajVmfTJLh1QeQUjzdmzrkVxV9o44f9MFFpgZ72fVhQqrbUsDWT	127
11817	2vbMwDUWsvW5HLdgcmsWimyKr2wFi4WjmBqJ3oVWvQ5GRDoDNgDL	127
11819	2vatRRJ2d92Eow7Ne3szdjvANVkb3nYYFJ3rSbtx25p6c6z1Eqzd	127
11820	2vbtTpwKZSazRFy22XncfdBFUSVY8Ri5sxrZZyQERsZ68tobvJfQ	127
11823	2vaaWqD6GZWmguieemmAVRsKdQGZD2XWJ6GLRH1X7yw58rsHKr2U	127
11826	2vbnqzFArRWczLAhZmK33H5RaLm4zSXCtswPosHe9ESXXKHsxcyr	127
11828	2vbEKvc5Lnan9kgAF48ZZPxD5TKZQ6kJmjcatLNHN3kitwDdmK2T	127
11834	2vbx4h9ytwyy3hrg6ZzYBYG18Hfe1S3pyvDnnBggaBu7zd7gBAyt	127
11837	2vc26LRGZXypnLnxsJxPUQiry71F6mdV7BcYeV9pNvYK7r4QhwWp	127
11839	2vahd3TDzzVXhKdM8d2MvvHcaFsMmQZ2SySwm9Ue91Cf8iqnsZsc	127
11842	2vb6kr3RiGj5Q5fSVo8VFjEdxz6WnVstHgcsNva74L8joWRWgegP	127
11844	2vbmmqf9ZXVfqXK6BEJYzfXyy1iHu7TH1VYeWGSLkSEswbnyHmdA	127
11855	2vbhPZzicTRHHKkPVvRK6Vsuak826MtoLwzkPyGZpBawCmtnyqfJ	127
11857	2vbd7re8tpTwkJgANv3iXTer24mHXFyLXbStPvZKQtiUTx8wU3yG	127
11863	2vbCEwBBHTaJUDpv66niXtaMrgYVmRL9bdbpqpADgMNsL7fXCtWX	127
11868	2vbQWdPuLyomLQxEngJpP6UtxXCTr9pqmS2iixaAemX22sCTouEf	127
11870	2vbkE3hDP552UkSdaagCkYaK3dS6MTK1fhsniXewAMehA7orBT2p	127
11875	2vb7DK68JU8U8oHdyxzdEsjPpDkQKgmmFbyZKMF5sARDE7ZVNmsb	127
11878	2vaN4128276c21tXRDp1EtepqAF9q185MJ9HPk3BZThtyKPVGLPq	127
11881	2vaKbcvpwGNtPLJgf4sBRfjQr8QanuqG5iWbYzA2bByfwUqQSyDB	127
11884	2vb2K9naKytX67TPEazRoSbxscXpoU3jBaS2wiakUqzegUmd5G7S	127
11889	2vbNVGB17vHPmomr6SywQfPcKUGJU5AsiVDxuvGkeXNDipEeaAVh	127
11894	2vbGSRoKeur8YSeK3ijsSp3cMUrs4Lmc7VXwQ5Z5U378tLvNLDpd	127
11899	2vbzXrSqEkvYZohMhNEaGGrJTZYJ3oiSbcaLd833gR2C5m1Jhifz	127
11907	2vbnSKDa8FgbzZEvizZ5SHS81mdJ7APCBxtVQoYYv9PQSfYLDLsB	127
11909	2vaXMMhrkrBT1CQXrp34j8zaNsqCNv1qtsyB8diQ5NjkyKmqvWb3	127
11913	2vai9u2kJfmer7PsRkU5ZphoawEt5djNc9Sz55vtWZ8fwTPmVHKH	127
11915	2vbbbLg1U1QXCMx1nxz6AkxHG2Woq6gW16zEN7o4xozzqgfN3XaY	127
11918	2vaPstcLQh7DqF4AiaNVMvbN9yXQeEmNWDoXvf9izScjULaNiaij	127
11931	2vazHw2Xv4Y17LxQEGBbsRkMkcgvyqzbd35CJT47bBR6iZ2ozxLW	127
11934	2vbzT2qab4onFkuUYavn6p7qBscqYstHz75zXhGN8y5Y88WoTCtX	127
11939	2vb39yjvfZkDTgED9PJEwduwWPD9vTMNNTaSrhLu88S5KVchwQm5	127
11944	2va9ENyXxFezMBrf5cMJcjWyFc5sLugksgWvr2UZNAqZVqPPWbvN	127
11947	2vbCCb59ofd7yrHwtYdLUPnENwRqGD8uiUFwZb2dKeUNGnPKNTHh	127
11951	2vbYeqtbKW7eYdRN4Bcy4X3uVJp93PVUvkpGTkmz5w7x7ETmqUpR	127
11953	2vaSaMFuE1wDeF4NpzqTKjGDNjtw7XiLEXDAtxcKpkcTgvJcBQZX	127
11960	2vaCyBAmRzW6PkFTwR1v9LXXBnL7dbvSNGukVYH2bXk5XCMBkQU2	127
11963	2vbwX1RMYMqdiaZw6xAiYXe4jq8Grt2rzGXEKgh9EXVrKSZ4ynFP	127
11967	2vaSojMmvqgBazqoAjArBLzCnHdxApK2Nb5qrZFRuDet28dkAXqN	127
11968	2vb7ipqCxN1R9xJvgz7NTwhmciuZJUZ7L7HYRPZwRwErFYqeDTZR	127
11971	2vbmHzUC12TcdDjaw27hjLJ5Eh4LZsxb5yuakt9G6GhiE9E8tuCe	127
11976	2vbfsaZnGJ83aM2N54SFZH1KC5F54LJbuQEUdwP3YtfHp4Bx8H5b	127
11979	2vc4PhHKiRjapgQsBQUFVyh2653B3sdWWDuUvf8L3S5D5xcfk95s	127
11981	2vbuBDBjW5JfvUgqCHtp31dvq3LgiF5Mj9MUUaZbBEhaD62pYQuN	127
11984	2vbXYYg3cPLVX925XZcrKLp3Tuhqihr7fWyvSkBWesLpyWkgNwPi	127
11996	2vac3Wn9pM4iQbZtY47aoEurqQJG4rapH1xFQ8VKo9sfHmF8AZq6	127
11999	2vaL3ztpW1pwTxpaTyqXSvC79rZbnLHT7uDAx1vRmNz2LpG8nh8A	127
12002	2vak7ijjJG93aPU9KxYFVe6rAwbSFuW8aJtDZnc8EVUPZ9YpvTNc	127
12006	2vatWKWS13ZVs3gDuzV6aNRPcAfXz6w5K8ibxZJADphJamRmDtak	127
12015	2vbUb4RSPWPCojz5srFsWtUYya985cZeDdpUYw7rJSL4v5xo9h84	127
12029	2vb2dWVB5m5JpiFQYPNpT4qbfTKTAvZLoAHRXeRStPc4TosAhog2	127
12034	2vbteEZ76JH67UhtpqXVa25eSgoLSbjDwYs91GBUo1mLWLMNT8eR	127
12036	2vbCAakZAUn7e7fktJmbkWWhECtXV5DNfVquHQsTodPGCZzNC3gH	127
12039	2vc5eNWztjQUQurwzAd4qCTDqzZjBzgbkxpsd7w22oQTejW3Kxnz	127
12041	2vauKf4HjpgoUjSxiWki8rjQyYEuf1Eb1WmhkVru6AaJ13ZSo7sr	127
12046	2vaNozDXR27pUjsdh9jqgTbLU31xSBHcphhBtFDZB1sAG382kJy3	127
12056	2vbjKVjkAyNihYmRcQCTnEpfcjvQjAKThrHGDsUK8vtrsEAV9c3c	127
12058	2vbW3YhkwC6mQMrRCuujjZwn85vdgPNfD2i4JSxXhRnv1W7ERw8w	127
12062	2vaArx9Z6Z3uevAkYvPqYNECbYG7qJvbtqqksaHNRkrFAWjd5sjj	127
12065	2vc4MxVLfiWGL8SM1Hiuk2CD46q78c4A7CsC6az1HAETch2JQPL5	127
12066	2vc1Pcn9EodvtTCEwdrNedkUBk8ajXxAmb28Z5rLhbG8M1aSqeGP	127
12068	2vagCKaLtyajAndp75SmmJdVrLEXFhnoizBYYRbcxAPZZNRFynBm	127
12080	2vbnYQtVKPwpjXWJLsdtErG2omJda9UJbWLB7ZGTSGpgAQCpQCMA	127
12083	2vb6Ca6tXD7QJLFpZYsBenwwS9NxvzHX7K43VNncFF2yZkddM5M3	127
12085	2vb1tqaKC3eASSjcya1eiHvXf9yoonLqWYsKGdCS8shDxtNvLVBH	127
12091	2vasUp4e1ZyXKFySHgr8K3xvF2Tj7W8vggmX69cHfXXVKY4cy1RX	127
12096	2vaNGZY3XvH5EggWQwjifid9Gp91t1paT438oiJbTPwAnhA38HLN	127
12098	2vbxo6AoYFGcmDSFmpaTBYgswZw8yqUx27Mcp1oKLMRfWkTjWB8Q	127
12101	2vbFMGh8std4vHMS4J1q3DhHx3NigCbQAZwmegkg3bcKgXvrk7mw	127
12104	2vadXhTdzCsd85CwBoNv8pk8aCKQvyVgHsPFQqFgtWhTDFeAuaof	127
12108	2vaFsCSpm4TA6B5kMTVGS3BWtfpa3vbWgAZeH7vyQaYg1CkyxQYS	127
12113	2vbvgXzPQk89PpcnGG312LYfurP8Ymuk7rxAX8ihQ6D2h2c2EA6w	127
12120	2vbp9HiwZszuPu2E5iJ7SFUSFPtEGZuayZQvAA9g7N5V7y2SkGBo	127
12125	2vbNX6XbXA6EqnxCdrhkognPzde7g3u4bDUv3vFead5sW2fEyHrL	127
12132	2vbyvrW5XmBHw7xCAiAxo32UgLY2EDTesGeLrp6UYtkgG9EbumwN	127
12134	2vbHESzn5BW2ZsaBtLKaPF6h7tEXBYhsuu8Lu6n2VKHoBippmMQ5	127
12138	2vc58TeT3ts6ARWeAVGW3LydxfUGx8LMsTGvf1v4HpapevuX9N2U	127
12143	2vb2Q48uAuMW6zFfTArGGaah3MBeiSTmC1BoNBCosEhWtuqnTsM7	127
12150	2vaN1MNXfq7DFDHRwootCM3hxmEaif4HWck3YMkbH4Dpx6fsShUp	127
12158	2vaeHZQoVQWmi81Qqx1csAPvXqvtBEFQrWFyvMCbG3Sc6etMmDnf	127
12160	2vaAqQWkTryLdL8JwpvrhdKa7ScVaZH9VrCGAQBcxTpipS1oLxa7	127
12163	2vaLqo9GSxdyBBt32HmLk9QeHnuLkJjWPbeJ1jzDSfAUJCiBhd33	127
12170	2vb5eHQu9zQPb3ZHLJVkbwnBJhJ5eUtJoQ1we3CN9Whfr7MX8sY3	127
12172	2vaN5Lg4etk1NmEyJwdcdBybnjH3BQjSgyRef7q45TuycnpQztEq	127
12175	2vbdJwfJtBHxqg55gWVXqi7uccq8vPxEyzJJNosei7qbk1vbVh38	127
12178	2vc5VjWF7EZGDToAM9J8GoiJ4PknTwhrJk3mkYHXTBuwPmN3qmzK	127
12181	2vbubYJjqBtZpbXocm7JxMckMsjchR4fJRn9PbozzJyDkGG2gjnT	127
11850	2vaRxLxvYkKfbyckrDwK5Lm5y2sTgZvJguLeDNgLv1w19ggsZwmm	127
11852	2vaJiJsRs6RsqzfuqLpLgDMxC44EJ4xx72nMJFsWaZoTEUZLxpuK	127
11854	2vaq2ZNmp6JaKe1FypBfgaTA4f6zg6kDNXK4FPDmhPW8fg2p8iGG	127
11859	2vah5EaS3p4Ydxh8rfnyWcmJhCknQHiKYPYcPmfgLhqHiqAu9pNR	127
11865	2vb4D6dwrzsptwyHHxCcAawWRpasJ1ZhRNrTb9oZbsCUQX4KjSED	127
11872	2vbMqsjcDr4pFrf8bd9yQvMjDuYfCQvxqZSc2v614r2ZGqF6c1cv	127
11874	2vbAMFUWAbFRSsUn1HNto6Ng7RYzG3AtqpHXG9VMY2cvYpTqHFq9	127
11880	2vbBkWSjY6YirG8GZLzb37Dojj9L5HzBz4feTJ4jKdgb27BKNssD	127
11883	2vaDtGaRDsaEJq1FJwZops7SE5sHss7FHFSk86MSHjtvoWLCgaXU	127
11888	2vaL9ZvZt4fxop4WJVy6YaM24B8QhBjmMHZDNn5UkzXAiYFs1XWt	127
11892	2vaNtoCz2NakGq6T4NKNA6uf5Y8wZbVHGXqjR2Y5nYgF728b22x3	127
11893	2vaa8W15WtruK411fkq79fwdnXtvpZciVspy3kYRm3SB7sEiU2ty	127
11896	2vbEWJjbuguFfanf8c477u6N9DthAPPi8kXp6jYBajSVvjsRW3vS	127
11901	2vaLoDdgoo9Y9CaGsdwRJdxSZce1z19BQKTqoLXKejY6R9RSzaFe	127
11906	2vbNnWCkCF6SwMk7oNV5URFPazsNg8ygGwnMmfdbaaaFnCbzfaDg	127
11912	2vbLvCTQTdgLqd3RHMAy4rcXfXKUaPTa3cJgEaEr2umUtzwY9qLQ	127
11917	2vbau4V8gYKXPzMSreQEZ5VKPbpBStjg46vAUZshxgN8ZMht4bGJ	127
11919	2vbWaAeN8MgQvbxMdyoz7U2y8YoMT8iDCvQ1eq5ub51epd7BjZyp	127
11922	2vbjSUTr5sae4FE8NDCzeJxcV3Ron8tMSDC37pmob1zmP1WjDD6n	127
11925	2vbbYM327PRFmqmJtUKUk3AFnGmvZyMAerywHTvCQqToqX1CwZYB	127
11926	2vbPd62PqTHVnDH8ZhdozSDHq8FFqmKtGmuw3ihRp6kG111cU9Jw	127
11929	2vaXzj6KbNZJ7bpLJxH6iLe4A5esu91z6g8asAx23m5WoCd2gT2u	127
11933	2vbPPMJzdNie8EzhADxNxRhTEG3puYhDi3t6mKPB3m4BAESFPVAs	127
11936	2vbYJRjwoFbMWgYXLEJdu7F5Zc9p3hAm3aVo8b7dw4cYcAwdQ6aE	127
11941	2vadmxsVRcCWN82uGtuvGXhkAe3WLEZBeTbmq5wB2H9U4mcxBSbC	127
11943	2vaKCoSouDg9kB4E5cerK2FatGrtHzwfdTaSPAD7orEhXtKxumVP	127
11946	2vaue8mqTMYuXuDZPP8MooF3FtnfmNcpRaC3kbKKK2CWUQtDQxV6	127
11949	2vbxjUEWNAWEcAjXUzjsYzyQmczCsPSFkh6usvJ4nSE8YfvV87Fx	127
11955	2vbs6xnyeqHJqcwWgNFrN135Fbe3mQLZ65JXnabpWUaFX4q1RVXe	127
11958	2vaxWDG7yoo8ByLP4cCy1Hq38X8gthA65qHey53NsPc7PapJiLrg	127
11966	2vbC8U5ySvD2CtrdjqDekBQVTdUPNi8Rek5rhKg9RxrYshxUg7N2	127
11978	2vc4zneoVdj8qnxKx4WC5pjCBZPivP43HwupnFB9MUVcYTQnre5W	127
11986	2vafvrx1GRAtiGkKhJjfB39jW6GRjwyThwn98vubFyAAgg5ZwRj7	127
11989	2vbueBkGh5gSsEKSsHa6B4LxAMd6AEPGzyQwHUZqUi9MZZ3v3eff	127
11993	2vb448naxhAbcnjXLEUg7d1nP4odrJPXLP3aUAJmWY4AW5ej6t1D	127
11995	2vbk4PNSrHbnachMfYHeFoFAhUN4dnH2HiCeFcQAyHRRJnajAnkP	127
12001	2vbqsVfpufs78kcQ1qEEXDT7f8KN5YBgXtbaMsAs24pUWZQkLvoV	127
12010	2vbx1XepqBBe8QnvwPyAnSF4bQyUTyqJCV4Zmos3t2vyYMF9DGry	127
12012	2vbexd2rEKAHwMxogW2KZR3myxXSQZEtf4MKNNf1cpgVo6FGAZmR	127
12018	2vaqnhuEbuh1jc9m5MP8eRwAZiDRKDd1VmEL2qKQJH5YVqAZVMGM	127
12022	2vaeqUaDKJd4Tm7y6JBkHdHcGXdXGFn2b2roJZqHjg6HU6K62QbP	127
12026	2vb6yQzm2V5ePiuo72pNyMaAjWEwNbNqKnAWNWqjvTberGmKsTEG	127
12031	2vbNC6ugFq3bKwpiWRbHy7TCsnpeHeSCkrydnXY2QmmwRoMrc4kf	127
12033	2vaSU6cDdqCBqHfaqznaEuPJmCqfiUEHfMDqQq1vuF1wjzGQCnEh	127
12038	2vbFHN8d2cixzw7CmmYdJBcuibcpomopJd3K6j7zMMzfoEhNdTfG	127
12043	2vb6hHxW6sPxSzBJXPJK27tgZmoYNyTJz4Bwt4BrKPCLpwvnQxV6	127
12048	2vaegVtSv7fA9jncirNYjfBrBv6NN9cyhYPJV98TTMQcaQ2jLEE9	127
12051	2vavRhoeC4F58sioHkmANUHZ9N6xQL5FBMqRF4pmqFuj8FBHZ6wP	127
12053	2vaggJt6FcGJSYzhChQQPsdnrJRXHcFQUgQbvZ7T4HS5QoSJh5Lz	127
12055	2vakxAjnKWW74QSiMzHJPyjFYk2tQphMy8M21zT3HmAhussFwGaa	127
12057	2vbf5nM57Vkhi9xnucwtaNG91RXVj5mrhJBTww6Ksp8ZQe9YAgr4	127
12059	2vaEensJcSdaPcD92a6q9yzXizGU8u8oShqbDayJnN4bwsjGKn9E	127
12064	2vb3dDHZK9oaESok9nEkaGYvq5mLFugtFSk4LCEekVVxPH8Bnn1V	127
12070	2vaa2arg4ezFbVuWymNSpwqQWD9qFzqv2yP4eaDirnW6h5ppD33p	127
12073	2vanZ2J5Y5unHcy6xJF3VqnzkRZ2SZcFzMDmraoDnkppp3U1gBCw	127
12075	2vc1tk21p4HY3TjqQJ4W1aZDtGKbq6paKFoPkP5fjd45GEpVrwLs	127
12087	2vb1vwS5dtXfC4FRn4mTNBb6SQqKQTH96WE9DPCAzV9CGgY9JiJw	127
12088	2vapQP2Sw2KrKpS3UVsBnrQtD7CmTQpDRcUd42VVkXrDDedFnDV2	127
12093	2vbt9D6vsyJUY7SK2TanQZs8iFkmdqnBYUEMR1pZYX4bPga7ARf7	127
12095	2vbLHzZsuSnC3NDtdB4jEbpczU2sMBfSDsrKm6XxGJyAKt8qf4Xf	127
12103	2vb8b7QDzptztqNvUaeKULYsq7Hs2BJqdSraVWT1uw4DzF4jiKoi	127
12105	2vaRFoSRGP4ecQCAojZD2zX6yNVuZo8ENE4gBszW9qtiPiNwkth2	127
12110	2vaCbqUhofNepUBQq3DkFwTxS6m7Nf5oCp4GUWfoRGLhi3KSUkVz	127
12112	2vb1Zr28tYDGRhxW3Rsj4mbRuphRF97GyDqtiqgwtpaRGaGhEZKx	127
12115	2vb7iV3XwK56VWF9xyiwDdJqWXX3UFu5LaYGoy5rBcsHGMgpf4zV	127
12117	2vbYScBgApu47SmgeuSV8EfK4BQcx26GN5LkXAdonHmp3h9foSF7	127
12122	2vaeTNBGy1P55Z48f3iK91BJi9ZKgrJgj4yDHk8LuEJH9h1oHhUh	127
12124	2vbsU5WUxCg1dRXtf4pgs5sWsAuMAyJYn8455LksBM8qcXNHwVwR	127
12127	2vau8pKi6xrm4TNTxeGLzWmgjAVfkzLiywE4EvzufwPmMJ21Nbc4	127
12129	2vbFf4jyjRhhYANXtVGqqHTKwVWCvYnez7f3yW6iyHMFGfL2octY	127
12131	2vb9DM8wnsYQXHDi7YVFQztKwJy29oQjn34ZqZoMSYXcqHMvVLc7	127
12133	2vaSketMfr6jP17aUUcfjAxEfAEo1JsCQL5TL6Qmt5FQuDazkLzu	127
12137	2varUQk5owHytukTrT35xcMoBDQzqjh6sEo1SLkuHNho4aYNBivW	127
12140	2vakCn8DzMBRUNk7Fc1ArmChkRkbMRpm72cPbYEcfshYptxAfp3X	127
12149	2vamjN484MfLpR9aGk7Hn955J1vKuFEmhKj74GAQ2wG3uuk7CVMv	127
12152	2vbxABPDWb6Ppw7kAURWtP3PmcLJYsLrqwrcjQa2CeqCcGi7dHbz	127
12154	2vbz97hRvKZGnU4bQMrcf61RPXNPknHFiH38ymtLTnTFfuAFD3at	127
12157	2vat4HbHnH2ANqrJeoEvS6DVf1WDUGUgtZmwbhy3DHZqKr7AyUde	127
12159	2vbPeARiLqdxLoZapXJvPbW2eASqBKGoTkhvj2umga8ES2FyeH3m	127
12162	2vbyK5XqgkyqvkedjDHerHs8W52FPRqtDvrY7g9TbVsSxuGneRdQ	127
12165	2var1rSxRoTiwMNuSSoWL63mivTuiURogEg2MsEi3nKM3XPMyskk	127
12168	2vbbub4zWBKVWyRKs669anjcnC1zrLFUTWNAhWFHCgjmpX7sPuwj	127
12174	2vbKRgrNA5X6wrKXEdUQsY6jxDoT1piMKCmbtRsLrWDSgGbvRvNn	127
12177	2vc1AharumwH726mA2S5yUFcvj6UqRDM3dLhTDMAZHorD1USKQ82	127
12180	2vbVp4r2N5oRzRd5tKgqGaXCSjB6JvQ52hJN9PtWUyNV98sxAbqL	127
12184	2vaLu43zmL4uhVgdYckCG9NzibQCvAwfjVCaZCod22XaBJjWnbNR	127
12189	2vaLZyM26ThMSkLMAF3sGEtxsve6bzpwP9tUWjpTsj2Sc5qMb88c	127
12195	2vb5NEtvApZSQhZrC2B1zPWqxsMajxpa4Tp1KcAtCQeVefxoDS82	127
12061	2vauJJyTizeEw78wbJ66Q3KgLsT7BmMssrtDwsGc6x53rVe2afXv	127
12063	2vbqCvM4SVcXbL8N5m6YQUCzMGnfuLftboLmGykQUMmwvBTva3mi	127
12067	2vaQLN9eCHxihaTjgUeMeJzuGsgUEu3C49nb3XpsdQN4QdPZ3yCh	127
12072	2vbDDm6N539F4wKJsZyRsYVGJz9Qew7NK9p2KDrK6awxYMEuGf6z	127
12074	2vafwSkCD5zCGRa84rVz7w2VJCTK3p8bnU3yXgR8e13jaWGePAec	127
12077	2vaATD6AzL3VNNjXVuEo3TFKwGFfj9NN2s4vdj25k62oDFTmbgcD	127
12079	2vbu5GzFePdHP5h9xpvYW4aWqZcxrRt1eArqSKQGkwc6ZVTZKdxb	127
12082	2vaeNJCHAfTtvVS2vuikhyc5WY27Jqko2eTrZppRqX5wMk61VWN7	127
12086	2vaBjibdaEZD3AHp9EM383G2QVJtBVRn952Gh5m8SvkAECRPydaa	127
12090	2vai36gyaUajSrJqAz5RcNhnAdceNK9TG2ibEKbzyYBWDGPS2uXp	127
12092	2vaERU4os7vRE6rv1UvRBPuxLxViH6DiHjspKRoHrkF7mq4bQ1DW	127
12097	2vbSCNgqznNUdGMav7wH5USorn8PYeHpQxVJXWZZgrjZDGsXCXH7	127
12100	2vauoAa3Lusfe177bPhyuFSEaEPApiG53ZvcRQfb6GB1q7CWt68o	127
12102	2vaTqP52uMS7eB5aQvTekfukiqynQDpjYCwtWAZ29mWPKmNgt3kF	127
12107	2vbVX1jYcumXuPXn2Wy4aDzFJ1jMSuTkwZGXWnVty9Kk72kUQLa6	127
12114	2vaiXg1cYbUnV3X5E83A7ThF3wimy799zefFnymwsTnH4DLUE9Sy	127
12116	2vbtM6KAHjAuQqe2UQ3ocnC3TSpn5ZccDwkXZVzdxDu1tLJ9Vu9g	127
12119	2vbVDwHqxH5aoUZ4NpVjQm6zbhUMaw29sYUuMfwfPDzaRiHkWcLj	127
12126	2vbdsH6i54yawmGvoLsLV71mSUJUWF5vLewDoz5Vv3REvDmFi6SW	127
12128	2vaQJ2ScMuSh7GufP6c6Yu5nppeT657HohvV4Gid4za5Lg3fVQ1C	127
12130	2vbU8jc7CNPZKzrFbmBHVSkjeBPj3YNvo372S6kLL8TvWJabpXGn	127
12139	2vanWwogsdpYppNn4i2L2Ch362YxXokNXY6SBJr4cBHu7HZn2U36	127
12142	2vc42NUHo9QD1VcNYA9smNUTTF2TGma39pZA5cDkfbSnBT5Y7xRY	127
12145	2vbSqo1ZUSqDhjhSE9LkF4MwGZtg7yXp6jsrmPhQHiFbBBEfDBUm	127
12151	2vbRJbZu4ke7kkMLtBcNpmCHTCopvk2iYZoYmyXzcir1YML34Vi7	127
12161	2vaEGDFgy8uHzK3Bm3utxfCMQk8GUethA4WktYUTbZ5LS7YJBXUS	127
12167	2vbZMNAp11JacEoBksuKAihJFX6XYtXqRf8DhAHr14vjD4PSdQV8	127
12171	2vbg2JqhndeaZue1aYnEZvKVuMHKBwYyh9uP7AsrepMUSktsZCfK	127
12186	2vb5NDAb3DMBHQbLza41V55QwG4xKQYNSAfSWq3UCXw5bcNygsqu	127
12188	2vawmme7nAHn3EB4pTSwcNMBC6gVCkfA1HgLWGNcuR9cNpRNkxBJ	127
12194	2vaJ5k7gc57k56R6Mcfp2qCqzAXTygvfKkeaviWE3dEXgK4WXgU1	127
12200	2vbzg4m4i2FW12DPYX2zv4dJpyXxjq6CQyto6LdxWqT8piqEeKWF	127
12201	2vabo2w7kPf399HGhpbLE6Jv1UxAmxPb7gRAD6devgD8VEpzzwW3	127
12204	2vaF2EPKrHmmGHb227uWQnEsU5YmS1jZpSMAB7VXq6NrgZduUFxQ	127
12206	2vbPpohvqes8x6cQqkyvLT1XQMdaeoPCs3mLw81Y4UB4Wwk3qGC6	127
12208	2vaoJixn5T2FsVQZvPRyHaRQhHSautNdW32M6FaoYUWE1EVc3vEJ	127
12210	2vb2dhY6tyNMb8Eu8cf1nGYngEHeaU2yTqBsdqt1GRBxT14t7vMm	127
12215	2vaWFbsDarXEDL3kvWRN51uPwx4H3vuCURKwBqMsAn7uU1eX8p3V	127
12218	2vacQ1XGQ26KYwbjPgHmY99TPnLpmgS7r5R4wZCANwYQLFhSCWE7	127
12221	2vbzDSGdrEStf5jLUp5xzkLVPZUoitaZvupkQVqDGYUWLrs2xizr	127
12223	2vb55DHRzLaeVQ2CNNQ2kLzJiR5gCDNyKKEz7oUQfJ1QGNvr7REQ	127
12229	2vboNZP7ePNZYqpfCcjDRgzkaaCdEGBDLjFiVvF4GmPdr6PPhSjs	127
12231	2vbiVG72tVCsY5qsedXPGRRS4wwDUr77PavQUtEKo2rfZQXfC8yD	127
12235	2vapjd8oyebe3SAdJSCQWCocahM6JmgzcJ1zEu1cU9bvshqUsYRZ	127
12238	2vapjUULNG2J9sb6eqGaav7eWxgdU7KTvXsRtadbGPbWQUneMsJz	127
12247	2vbtDj2qpZLqB6MetwkzUPnpjDqc4FshAeBovg3unhSXCULVPeys	127
12248	2vbUZa9zYH2uHuozYz9CQ8mqGqeBpSBY5JPJaZMTVn5RiSH1YbhX	127
12250	2vbFxkRmPzggJtKSHfsas9pRkow7wDb6e1DZLr8TZusYDnq1NPJq	127
12253	2vacpQQtjmsqtTRy8rwXdQ9EvBCPz5YsBS22A28iBkdHf7ZGGJmJ	127
12255	2vaSBVhYnivBBc9KQCosYwEqNNbWacbwrJTvFX9oM2EmxL2x52dR	127
12260	2vbYtatGFhhvkMDXiyAZb2WnT7YjqUpxiWVykeRPdUqn9FPnYY1c	127
12265	2vb9mxK24D9WWnd9S1tf3YaGMDfxSxvd1MyCdZQJo8hyMMu5BYo4	127
12267	2vbhzRfAeYtzt5bBydJ2Uk7dF4CZ5HQML2MZDkN5USagzXLJWjE7	127
12270	2vbu6VZvzNxAdDibYwZf3DyVtH3RAVzaBKbFfrAKWm9fv1GNnvvL	127
12274	2vbrQ7pJPrGJiwNryyzHLRznmCJ9g8F6mAZNAsjZ4Mti2HooyecQ	127
12277	2varqhAQoJ3MgiY6gHVW3PL4g7CEA8KcXVwqUZ7Zer9BrwXbQZtT	127
12280	2vaDSDvzPTNNcuquHj4Ur9CspJiLfXCXfLH3eTg1W5egtLGKHT1T	127
12283	2vbbXmwdP1Npdko28wZws8SXCpo1SSY4TkTcgCr6YGyantSYa6oD	127
12287	2vbtcCPhJNv9GEJtcrTMYxtusDrrKQtRZUr2TUkTj4YaXuzCjFuZ	127
12292	2vayRZbU2DHqPGfVNrqmDw49XpeosTZFcJ4pwupuH8YCsRyvCRtn	127
12297	2vbbiudHjWrWU4qEsaiQeotueQniqAmwRiYNpfg3vgLZGG9W1hN7	127
12300	2vaNrDySAXejF8KcfhHCeA6Cu7QBzVFMArMoKjdH5N948ZFRFyP4	127
12302	2vaNXzDRqvWKgkgwrsCqjYrDyL5AXZh7kGQ9yd3PnSKSmHYjSz1s	127
12310	2vbPwBz9WS1kPFtuv1BVUNzWQhqPxpS1eymmM9nmjKh53h16LxX5	127
12320	2vak8NhoeKQAa427kwTGM1go8VucWt6Z1AbDmhXwRUqCwRsJbzoC	127
12322	2vbUEy1gpcdELMk5ayy7zNFt96fqAFkT1KU28hnKDadgLkArCGNB	127
12325	2vaj9iq66notFLg9ssZ3rRAGojSCLVPjb4eMhEQzE6ALcmDHbwu3	127
12326	2vbRRMiw2nrsAmJAUkS1QBk21opZpc2MMDBpWUs17BZ7ReqHWc1S	127
12329	2vb3ncNP4Gu4AAJq3VR84MBTtnsUsHzdGemrSv5L9YPfzWFJPpfu	127
12332	2vaCkURDxhFxzyiQiMVHorzgjcZ4gwLc96fQbKmJPCEUhDVBN2Pz	127
12334	2vb5hG9KxcS5iL8uyKEnETifFqAb7AKpYgtvEe2eJqEdzGMGYPjL	127
12337	2vbEfZwqrQsUvpoi5nsmH1dXfUSZaSsHW36Y6fYvdVYACcTNYWGu	127
12345	2vaKFV1qFLd7EaZrNWqfMsSGfh26BcB6TdXKvmVBFiXKG9yY5c4m	127
12347	2vaYGQxe1Qzcj3yCRjbo7L3zBLEWeAir3BKY1CiM6q75rvo1ySaP	127
12352	2vayGQQntv1fskMwohLFabRbGLTPwJcyV84ERCijff1hmkfMtcEa	127
12354	2vbUQZ3Ri5QvnZfA1oxLhMHQCagqz8YEuvp5HCUnr6rS66nB4NNT	127
12356	2vbJ1TVHCzPiJ4k7wZuK6vapovuSMr7mjMjCPfkq2uxNEsnMNgYJ	127
12358	2vbAydYsKZg7eozN8DvT4vnABa2vDStgg4MbfV3FxHGi2SmReEKe	127
12361	2vaBRG2vDvYfwm9sG3mD5Qsnn5BQz99emAZ6ffcQ3MZn8b5RxjAb	127
12364	2vbEmCC7871XWZxswb3NnvNYAF31k2cPTug4Pgw9dKbJVmrnyCUz	127
12369	2vc1XDC9jMtYtZaAMr8hsE4vCPgmZ2aTy4DzVH5acH6Sc4AXxEKv	127
12371	2vc3Bppk3GaXsSXp87zX93PHfMsewB2W9ReUraqWdup1RBfLpeyG	127
12376	2vaxwAsqmFuremfAKSM2T8Vq6heQCPW9dyWe4GiqCav1nvPsmeij	127
12378	2vbPghQ2vzV3HuVm63cs4ifSEidLdVYT3ndbu3UD9vgnP763nePC	127
12383	2vaVKuGjKFHqbqDzMUxYRUtM1kHZgjDp2RvTnehYWNdaYZdoZknc	127
12389	2vayVyYij4AX8fE52mxwmaEqY85rdq2wGmsJ2DHLUCddARcRRVe6	127
12394	2vc2u3bXNKyWWkJ5cSQRFZtyuntwMr4NhQkM9YdvKpTVXcXy3g2G	127
12397	2vbZMmM1gpuXbsAiEaZ73SLKoDkTDxZx5UpBnkvDQN3YcpBfntni	127
12106	2vaJEX5YoDTPU6X32gnfx9411NRaqVJoFcij2zZfVHCmzHZTTbVm	127
12109	2vaLa9gDQBjG79kMLMz3jKWvuZGUmcnXXb7tSHC1Wp5ow2w8Hoj2	127
12111	2vaimrbehnscUwAdkNRdb3cFAs9ykd6Zo88b7PM6ADabMrpA6APz	127
12118	2vaS3k4K88J6p5dh1zEDZStZiVwU9ode9qXyByZXAHFt27u7WoqU	127
12121	2vbts78TLoZ2rY7Uq2awPybeBSH3T4Xz1HYq1S5VCTRongnVv6qv	127
12123	2vaZCMHx5kdNrRTHAFDTjiXw1ean7xNUtwvs22Tsprm3YdF1nuUt	127
12135	2vay5Bd2xGJqjk8Zbn2BSnU3d6PsmdQFqNTEfVUZ39VKBiTm7exj	127
12136	2vbDydRJJfXaCc9hRHy72sk6UYtU6tGhEWusMEzjusvCadD6X4Fs	127
12141	2vajpBdMdiQXHwVF35tSVffGnGWQVchPwZE8Hm443cGqjTwNTa8y	127
12144	2vbQZkwWX5dXaHgGw8yhZfS2YSb3mdpP2asZicPsqxZ81wgqq7Mx	127
12146	2vbo1ZEoxKZ4fsHY9VhjPuacZ59f8HvsmBTR74obgv9ewt4hwvcn	127
12147	2vaLokZQp59x9iVYUaUp2H7gfhXSockZ5ejddyUDkvkPDHV5Fkz6	127
12148	2vb2N2VB7UBfhgGcgF3ptVswr59APpdMsx5picW5EtfXkmvEWiE6	127
12153	2vaiD3QHsHMMuodqMxzmJiDb2iRBX9w6bCZGpNPyaeVUKLzve5pF	127
12155	2vbKB9sKjFDwSv6MoD6NpQEvcAseJmxNq52hL9tHRg5MvkN8j2Bn	127
12156	2vb2XijCwQwmVfYnZQ6FALroRdubTvNy6WS2GRzvgPBWM7NadLNu	127
12164	2vaBmJU2AU6nUS7hy289vK15iwSGR3kiujgP6YXnyXuHFB6NpA1s	127
12166	2vaDbQgJiJCXk6cqKkqiNwLjmyA2XZtdswV6B9Emw4gG7gsKKNPG	127
12169	2vadkS4efENyxsVVmd9H9wxa5CkYa9u7P4Sq21hbAFDBhqSP8zJc	127
12173	2vaMGwfXVxaNU4AXEYA7ANyzPsFDAJeAbop3GeEThovdCsfyEeaH	127
12176	2vbwXCzw5FhPbe2r6yBNxwRf8ihePBtdp2NUP2pZkGvxxLvm8nJi	127
12179	2vbjxdFVt37P6KRTWANjXXBmB38AJwAWnfEK28s5FiSi8vVbMzgz	127
12182	2vaxcQbE3yGYus8vX2tkHGd9o1SPhPsyjt9CNZPTJxFNpmAipDGr	127
12183	2vac1ZyX6KPLYrPeUayw49zgaK75PPk1TW5JaSP6M3qMV4jqpgEC	127
12190	2vbiAYADrMMVMmRLARCS2mdhQ9TXGyiqXRfLfKunQFd4Xi2SviE4	127
12192	2vbLtX9vqPRVTe4exy369mMzdP86cyMeBU7yB94FNV7SLSbrQcwy	127
12193	2varnYBHKyYxmqwjH98kdFdUPiprQYWjtD74meq8rTcD7hLY8eFU	127
12197	2vadrMDyEFWZeR7WxaVM3XAfAkxJkUHtTANUGsYX21DFZ5MRuLMc	127
12203	2vagWFVEWmQg2s7zULvxYGoFGSjVtNwNeMXhANuXSPHwrJrHRbVm	127
12207	2vaBD29cb6BWuA2y13SFaTiLMfH76MdPxHCRcUXs46LmFoxFiPKz	127
12212	2vb89Bi4bh6w27mtJcwEAZ7oNnaFww1zWCHtrVwyFMjZVfNVoHKS	127
12217	2varsuw8ML8p5XqbS1NA415ZbJd64rsw11kP5xb9Zzo7WHUsKvT6	127
12220	2vbyBxjUsFboFQacQeAs6JGAXBPbkdh3ohQN13cc339xwxZnFpHm	127
12224	2vaGtQQzZt2oJrNNkUxXHCdisnsXYmRLmdTGVYPvCZtqvyvk8QmK	127
12233	2vbMpzHzgqEdvCDX2mFoQWXuHzix7fidtZdFioidXjJmn4dEwHSq	127
12234	2vbEYyEp3hzZq2aLBnxmJ6aTzMtdoZxLc29FYnXvhaRwoiMB9SwB	127
12237	2vaDpXCfCni4Q5hJggXBU6gPFLwLRDidrTLqjMrLpfbjkoCNn58F	127
12240	2vbKtgbUx6zBYdcuNdhQXWZodYSSMm2D91e5gQMjMptcDNjrYwvW	127
12242	2vbtqnhn5Jfu42zte5VgQeykes4nnzAyRgk3kQNhjprq2zyoiAP4	127
12246	2vaGkbs96gRaw8i4obxszNWBbwnkRTG5y2qW2pk8yhY5PVbWjbdm	127
12252	2vafW6coiJVE1oZDzRR4WVRDvZuo9kL3vKFSRB9wp71g1cWcsTUo	127
12257	2vbaYLiGwFgGLipd4bsmysVZYdWDBz5ii8CvCUKMBgPei8WKZf1V	127
12259	2vbvsnPDhUwBktr46iTZb1emKT132zeMhTCCGQt7Rw6tZyVDMDSa	127
12262	2vc3jFAzw4eNhHC9hDSfgAZkx43ZfkmMJFvc1UfruBPkRaNcJ9pq	127
12264	2vbu34wqEEbVZ7bKqPCS7gqomJ3KEPk127iLMoHeSReA3FbtfmYP	127
12266	2vaubagogWt5ifpoPoU8W718nNuQ8GPUQUHLLsr1g2KBkRSbBSfz	127
12269	2vbzU3GzQTSPfnAd4HC5fqAyaaTNsHjQdfMBkJqCAChBYb2AQFRw	127
12273	2vbqof87TRyfpyo86ZFyQRxug9izRMrFyvJVjuRVuHNqYa97ztx1	127
12276	2vbUUbHpGdpYT7ZvAdyaXhQhBJuK4XYg74he3LDg9dyxnbrzybHS	127
12282	2vbnTnysA77Jdixf3pwi8agi9h8reYR5rwSrZnKyNrApJhTPLAoL	127
12285	2vb7ZxTpHHVYQmhLwZ6t5Pb8kWRSWqoizus7mX7v2NfhyPeKJ6xm	127
12289	2vbDRow7538FFPNhV1y8K5JjEMb7P73BaSzwofZQhLdpHoXqRmNk	127
12294	2vaC62X2TnMbvqWYvP2PhK921xNbnDar92gZiD8xNp7ebKDQemEy	127
12299	2vaBbC2nCSJngEmSbVCGDXjEBstLjsFtEPQRZnLi2VwdQwGaCkDg	127
12309	2vbDXz7pMpktSd7Xbp4Ri2LFATZqDQTcFyLgocpDiPu1cHKusVLE	127
12313	2vaW1QfRxr1vMpHYVsjG6VtCrj6pxNDDjPjt7d1bwMaDcBhGJceC	127
12315	2vaQtgGrvvwpxtvAkohGGndK2ABuM5FxLp64QaVb1M3CHpV9ecyT	127
12318	2vaWPtvUuLZ3FAJ6AYaBzzff5DCTALWZn37eaCQLwQctHPRqwakK	127
12319	2vbNAJx7WK53EoEQDSgPr452b6PRM1UNjNraip3xFCXNLxUYhvoY	127
12324	2vafB7HWNDv8Qu5DpJxjTgvdRAPqymDLY9LFpfzavfXfeQpvFKV7	127
12333	2vbjhnwZVEZw61i7EV927dFHxnuR7cPFQhBH8iC7vfsQZ8Tcmr9b	127
12336	2vaczyd2fmWCT7m7LtMeZbavdyB8Ya6hZ8fEdJ2VDHR6djxbAv2Q	127
12341	2vafKqXK56gMan9wUshWwUSBxvCmz5Rq6kFQufPDUaRVt7fa7wbZ	127
12344	2vaTrBgWpH4X1beEEVwAXGTEDZjkCVR2XXGpL14ehgJc9STe6CHq	127
12346	2vascPNX8dnfSMWYKJcPezf5JjSKnVmAnNJiMZUVSF5MvYuL5n46	127
12349	2vamWCFeKvj9u6K4MH1LhWZMyCAXsmVSVcybFmrKzDMiB9RWGpQr	127
12351	2vbHpzB9TPXLfSgaiDjqAEc436F5v12BfbAWt1DbmWg8MCSQDN1K	127
12360	2vamCWQut4J4kTQX5qMapnT53JKNd5QzWGFjKmh2rf1NR8GgfY9j	127
12363	2vb996BdEq4YoZD1r9cNdt8BnJkZyWvkzMsqP2ddbjEFqTUKsGWZ	127
12365	2vbzn7E2XVkmNM473bH6Se31aDJvPhCSpuFMPK4ZWyqgtLGiNTRe	127
12367	2vbUmsM3tung93KLuB2fET5qKF6iLGohDwC6e7Lb7kngQcoFJZ2J	127
12368	2vc1HVCrYEP7cBZh12WVfvqM7TWkVoeGZZxcxHpqP41NwCQiFPm8	127
12373	2vbMvYL9ZA1sA54pq2UkVRyNL3ntrk2eByjC9cDZifDwEXijuGBP	127
12380	2vam4X3pJcrLjehjHxNryyZsDmzZZUemKa59cDQiNYMUQicZ4zQj	127
12385	2va9FVNNzJcZx58UqBd4TTBrJnkWKEPsoiDCXYxniBHt1wbRnKWq	127
12390	2vaUV64PCGqDmuBWcCP3zPCBGtTiFkLBB4rBoWbseDLV4Xqtq1Gd	127
12393	2vbi8C2ThX4WaTmPYzwXYYbBR6e8pK7MU6Ur2HH6vBtFBqBvgtAC	127
12396	2vaD1r8ppust4R9isWQVk6koAwoDRjKAKvCB5NZL7uL6mKLaZdcb	127
12398	2vb13X3Dcc6RByscxT2ds2MeMgyQL4ue5xRhu74btwTXCTqmoZSm	127
12401	2vaXCWNA1kvNRdxAQfgxRZAxxCLVesHP6Jhs39WoMk9JNab7Zxz9	127
12403	2vbyvitcE1QcWNAHkH6ry4Wzvx2FkrMhQFhG1eAWPo3AfahxJdwG	127
12406	2vabznG3LKRdNG3Vh3gxfTMW8YNEmvyJ5jLRw1xWWfB35m4FtBzv	127
12412	2vbXx3q8oEDA2vyZun4iJhCYQ7HJ7BWU7WPyHrqPhPm5AfsGtLG3	127
12414	2vazb5Tw5oQPh8hH5mbfUgPCHKLb5YcLtYmVUW9vKJNvf7qfp7Xu	127
12420	2vbBuuxRvsaBKAAjbodpXMhZKnpL8PBpZ3SYJjEK76NTsoCNANNw	127
12422	2vbZZDxDnR8mWy9sqG6HsTD6pHHRRExU1eQ5BpEGwuv8KuXTsaJX	127
12428	2vbirjpFuuhv6hjbJ8umzXZ1G22vBTneboGLdbWB8QxxPLZNSPqj	127
12435	2vatXA6kp1B4yTZh8pCJ4Jx1GuSiR2mDYgu4js88kpkn528BxrCD	127
12185	2vaHN21JNXsxWhkHDytivw1kVCwFdvyUkxCvgTVi1TSaRHSMV6Y3	127
12187	2vaW2uuabcMT8Hw3RQDoWMQcWK11SE7xxg7H35QzC4wRYsWy92W4	127
12191	2vbjjKABfiwrSZRrtc5L1nTtUtmkdgWtghkusbJKr2Rjx522pzES	127
12196	2vbVFJMLyWyuKsioSbh3xzBsxpbJT1L2P6sYGGLp8sq5p8okiPo9	127
12199	2vbuo5s91q2MmmG5uTzKBdJSrpiMqMuC779DWPDVQC1aqyBPcMF5	127
12202	2vbiH7rb4LVDmh6LWo7TdAexFuvnoxY5jFTaVFNG8roVXrvfuzHb	127
12205	2vb59cR3u867h7ESLvav17bnA8nyqQV1VgytCVm8h2xWou8XjUXk	127
12209	2vbT7GDPrvGqrjP6obsJmXRoEnf2VigqYmJXNDVUK5kV2tENx3As	127
12211	2vaMCrPfGR7W6PhLs7jzEqpzr8oHaM6jR9GsVPX9JrkREzLY9542	127
12214	2vb7fWt4qb6wmD7YJaE57WoyckXeV76wDUfWKY8CfrWnv4bxB3D7	127
12219	2vaCUy55VvGWZYLJX9PCW1WvFbvs7ryNwaQKCXmU2FbUsut9vqKJ	127
12222	2vbZLrLrhpuWizEyH5zNn9j7coxnHbLp2hcFgDHJTeZuojTfr8Wo	127
12226	2vb3suoHGnJvEVCCeDhZVeFtzrxaoWgyUjADJTi3tRMwqPpAyQWH	127
12228	2vaH1CnCAb7BywwxoeQ3nQ98Ct1ZeR25NWWWmLy6g6snkr9zRZDy	127
12230	2vbXTaU5W683agwuPf6W1Tteukp7tU6BdabWC4DKFsK4gK9Su1AX	127
12236	2vaDAyTjQsvCt4uZ9gDKTvzLVCCpFgPbZXZpnfbXyBmeqmVfb5FV	127
12239	2vbsZ9ZdZABd87xnwGqTrqa3ftNByvpNhxEV3qPdbLF1tZMFkUFa	127
12244	2vbr5Ky5Za1a2ZSR1uujzGZJLQbCNdGiaJbK4kCnqPDysRzs4Wpx	127
12254	2vadE56QoG9PmgzQvkLLcYvBm3aeoqNmpCvJCJYFh1Vx4NPhUPgk	127
12261	2vam2VcUwGbRZioSk8G6EgmBwhRFzRJB6dPkAVjA86zcfqSpQuE6	127
12271	2vapk7A8UjcqPqr2frWUtATgWAKDQR7YKRSYYidxWjiVP9294Shu	127
12279	2vbvFRFvugwVeDUH6LsdGVwHaS2HNSgJ97p1DetEoHzKufPXbeRJ	127
12284	2vbQjtXUi8fdRsxsH57m8f6NtMHSL8eTNM3UmMSR3vw4P6ajXBE4	127
12291	2vbsAP6xew5SfnNM1UXRcpvhJKbcidjUS1Rq3aiMf7MQe66usS4o	127
12293	2vaCawo26CT1qnhVbuTESWuHfSYgJ3sti3NxF86UQdN6dH417wtH	127
12296	2vbsZ4Pn6HKmtKxTGz67grbhKJyVjMtM9NvKp6Qn6nUvfSf6Tk5U	127
12304	2vbb6urBgMy1fsZ3KyhJf3W51TdE1zwW7ZGHj2yRPRojiJ8SThrS	127
12306	2vbrTpN2f5DAa4fU6jAxjTbFBz8AB2NpiL9p44LU4GJqH1NBifxp	127
12308	2vajfn8c1qdDHvXSpGq4TBHh4X1V76DLgZRBaxPcRahJ1i4AMx9t	127
12312	2vbCuYLtN14vkTGtWPqjmaXh2fPtgr48rE7YarHMEFAqRQoxY2KM	127
12317	2vbCV3AT78t2k7xMdnErD2yScNGV7drZbKsrk6axTAxbbucoqyu2	127
12321	2vbrtztxjkVXBe9ivLQW1E4M7p4cMKv3CuWCozsAcxmxxkywsLfu	127
12328	2vbKPy87p64UMTknxLaRkF9sFvqYB8jfR89Gsk5Z3z6skDPc9ScU	127
12331	2vbiFnz3hW8b3RWvNbst87jVU8F26S8EN7dSU6cX9MWPxiUtt8ek	127
12335	2vaPSdQn6mFrcybGZ6KK9985vM2sJqPJ6JM8nLMk7V2w5ty5u3zi	127
12338	2vb6r8vfcjD5yAipG7d4gzct4LGmf6sgtANutUxAdKmheMhWsFS6	127
12340	2vb7isW1tKk3DjWJgqnfBDNZ1rAhZtujdphzLqTzX71iKGSqCJ3w	127
12343	2vaDMdaDwaWxUo2hKmCGnoqzZv3x6vE22rsNtQpVTRexY7HDuHxq	127
12348	2vaKGckdtm7kT1CX9sm96eoSQoC9FpuCjdeRQ49ohyKq1PeFfFa8	127
12353	2vbTSszxMKiv6rsZKTp2CQM6Y2hKEmzgy3rNwDZukYB4SDTE2RUY	127
12362	2vbi6sQoTLQpusjx9ZyysoBXBTg7QG7cAs9oZGVLfjPw71CwbwYW	127
12370	2vbd7a6J1m6F6uS1M7Z8bfiQ1M8SwuLttPYhH7xGY4JypPQeaNNQ	127
12375	2vbgPHT2t9PJQxrtwhxVqFmBp5JFnjS2k5pfiUiyF8JEJUKc455W	127
12379	2vbxRqghfJ1729hPR26P7P5TmchFBYvRhVsJyY5menQPWyHwZ5Yy	127
12382	2vbbUcbCJuoD26YD5bVDycLCkKzQeUAyqRL4R4HpLmmQphvr43yf	127
12387	2vaVxUfwc65GmhfjLGwByNxXtw1mcyqsNnQxge9HRkVRNvX5JUuR	127
12388	2vaV3A9S1wej5oVy49D1Wot72hpM8LXMojrpAVLW8HZTSxv7EzE1	127
12392	2vaBZFLwdyUVAjrTXW1ZguufbJDfqL3gySY7DVA19yUK7ZFrNNyf	127
12395	2vaKdz77GQhjQ49wSwU9Xuk4E4FTbdNkndrPgLTwuLvfDFrmQ515	127
12405	2vbwgqJkn6uaNh5FKzcg8C2Bokx3etAsV29uetyHugu4RNBDGcWD	127
12408	2vaUQCBLo63yNUwKzpbUGZX8C38JQohcDQ93ftyVrS7S5hLRr2sf	127
12410	2vbTj96HhAS9isT4HbS9N99wt9cRzzgjeyTxvVtFoWDtks9uB21Z	127
12419	2vbU3Z9ZtVqagT93eWy6FngWcinpyt9TNv96kTbL3WnVbzAsiDCP	127
12421	2vayfm93MZyhryaDDjsuLQeDFbKFxMCpAifkpSYnu94fkW5Sq9uD	127
12424	2vah89unBXnCQyNxwg35JkBNGqofPbeJZbR1CKzbjGGZmuj2DvtK	127
12425	2vbbJtTnYfB5pcE4JQnZyAzmBorV3Xd8jBffX6rHAHCSPBB5qMoz	127
12426	2vbQfMCN9XWAzpsZxgtvKE63a2MZgwz1KwJ58jcZgQgMfzvEdwqj	127
12427	2vbaMWmhSNHKVLY9achdYKMxs8LCpWXYak73YQ1y8tZRYr62JnaX	127
12432	2vbMVeiZBTTWZ16JAVQr3cQZcfhbYpsbMKu3JxNUebx8JRRxbFgX	127
12438	2vbvBPuamFv6nJiXZSsLF5gefUV2F3WWfRheDTZXxK2kUKi4fVWa	127
12443	2vbpepToAraxTyKi1r1B6ep8iZPvPnWqQAP2a9QykLX17UzwGWUc	127
12446	2vbEMrvaVhCPKfS1cMzFfaXXkEx2MXDxbPuiHmDqfkj7P1N145Xq	127
12448	2vad2ADCtYi1G1X24rN1aAJwMR9a7Cs6KcHcKcwgYUCSQx99bgkX	127
12457	2vbPtDPY7DjGYt7mWEGiAHv7PB5aqzk4E13fiMBZbfMiuVUMk523	127
12460	2vatrkngPRvobPUFVeCAAKGUmHpuSfX553kSoKXRdYtLxAcxiDRQ	127
12466	2vaNV19qK7qV62D3bVhJYtq4PQMN6PCSiNVrNB6nzYFvrxTXXhkU	359
12469	2vbWAYKKXeGoQXkZXN64zS5hLYujqabow86p31hqxsLJ8NH7djWZ	359
12473	2vaaCKVei3JoZSPuzTyNTYg7EmfE9nzFMYgZ1wRbwf9hfHrKMTRq	359
12475	2vaQyKbV5EHGrBV3JxtV3bSpnAcdQXNRPySTC8omCsjjH1XHzRMc	359
12480	2vadcrv9arqC6mmBKsxYPfkeCm7TxEFBjXEgxfTkso178KYroEBr	359
12484	2va9tS3TqF2ZjM4TbYkudU14NHhWZzJisgV31Cbx4Ws5cPxFkBsx	359
12488	2vau8ToydEgvdTLME33HvsjMH3SPdHE3izjkkS7H45BHD3vS2xSg	359
12491	2vaw3PW1jEBYHBpyXJqTcKzLamFjsLocYcAQHh9cAKeFi88wfGSC	359
12493	2vbXBZuWbuC8MKkvrLM6fndR5kUbd3ukFnc8bBbKDU4jfRpuQvoD	359
12496	2vbrZ6Z6r3YEvCXeXgiS9k1w4XsugWwp9nqVDux5Z6HacWcVAEm5	359
12499	2vbyFDTqbZxdZ2TWhW2jnb3kwX6GK7e1SGzPTTsMj8wBqYBhMVBB	359
12504	2vaL9bdqzat6R3wB9J4Mrer4sy1CLi4P8bkDh1in3HnrY3bT5X4s	359
12507	2vb2MW31aaPZ4SiEW2EHYAL66zuBCgrVPSSXsJZKh9hhEbBnNy7d	359
12510	2vbdujRu6u9KEResGvjUH8J1TdgeRgWJE13NvT311aAByBdAwphS	359
12512	2vbRUqdFNi7iTfcNni3JLhs1R3AoBqfd7TAcnieE6uPRgLuSjPzy	359
12515	2vaktYEZd8NXhdHJfGDd7jvpfUzdmN31sCfVfPhgij1SAihVC6Ly	359
12518	2vbzvWtmKxEVZdikhvYGRQp5AXgecE63xBpYrmfGZ9MUbnMU3nZr	359
12198	2vbnNatDHVKJgNP6W81yfevbPpmTkWizbobrVCiLmQw4mw4EpZim	127
12213	2vak4kSdVqEmztFm2VSyFxbET41wrMPjRRrV24npRnfpuTvgGeq5	127
12216	2vb92oqfajuNdRNeWSGHkxj55xHY6Cv32ntxFpxRL1xkcGZA8sqd	127
12225	2vbFJEujju5Py9idk4hAdmdHikkivHiMC8S9VwqZg8DxqrNHyPqe	127
12227	2vautDndtdvDjoyQbMddphdgk3mB9vP8YJX7DoXWmXXisBp7QvBQ	127
12232	2vaGydvz848saWVXV1UQBcs36hxtkDUbXZsLDCM3y474PKU6NpXX	127
12241	2vbgdzDmDqfYDtqvqj2PmXVNGAusYxfdbcNxychSio2pjBrAHC2y	127
12243	2vaqfj1gLc8fijHrA6gtmvsq3WY6o2wi571Y6FvQ1Af7Jc612UNQ	127
12245	2vaunn6Za3VNF7bdHg3BRB3h3BL3ikEzMSWYGzhd9AX8sGQLWg4Q	127
12249	2vauyZx5GwDAphTd6Yu5jrhwDfq337jt2EwFbf4FB44JmhTDaG5H	127
12251	2vaqsY1dtura2C9fxS12yRRa59eifGCwShUPejF7rhParUjTpadq	127
12256	2vanUMZL1Pf3moRAhw82vch9npJ1h4XYUh8wAHSWj3k5iw81jUKN	127
12258	2vaMWu9JTDh2rT5iTj9Uw2qPDw5FYgcNNzUbvUcX8Q1oJbYn8bgs	127
12263	2vaxVYvRJ5LZ38w7ym9zSRhU3mqaKayZ6L13Te1eMA8rC1Zhqnp2	127
12268	2vc4G4ye3tHF8CQ3PqKr45SBvTVQUPL4h4N9VFpRCCYZRdhGE4Tk	127
12272	2vbv8zRAhVxDNEGDpHS3gdwksWoKNUekvHMWKi7xYb3jfKK47Dq2	127
12275	2vaQJE3ub9gnUoqhWaNctvJ9edRziTZfaQ5YB7jSU11uV6CmTQ2z	127
12278	2vbMQbyC5mhyLCiQVxJq863wrZKWAg7JHEJfp98j3AxBCRe3GRgJ	127
12281	2vau6dkbcw9BXACrnVEGJx9WM1XqWcZfnEB5rpprCwTos6cSLMfZ	127
12286	2vb7N9t88oArtUFoc4CGtyXpBR9DNSVw5NQPtRBJoYtdEufaefcW	127
12288	2vbjBWV7CHbcrcswS7PAdWcJBfmAtSw1mFxe2W4nJgRpMkWgS2Kh	127
12290	2vbPuEn3ET5fZ82r2aRrT88tBoni2LMwaSwr5h9NUT3iFBBEdGLt	127
12295	2vb3pXnWdoDe3Dntkmj22JMeG1pQYGPxhvnA8HScDuHDKoFVjrN8	127
12298	2vbNsfZiY6NXAzHwrFTdYNadGMx6W98DLX1enZbgwpXUyFsKunMD	127
12301	2vaGQfV64Pw96iDP8wWbsiDiWmGtDnRgPrCJ5LJykZD4j426ECe2	127
12303	2vbt7s4txPcehpLZBHutXSxGUf6ZjuEMbD7XAMLUVNE72apSEpvT	127
12305	2vbdCZs8YDH22XxWjJ8aHvRu7oWsYgtmcyGsGWgoSNN3tu19j3t4	127
12307	2vab3RXFXnRfjH2mRxGukjB6qyqEBfDyCgFR19vmn1AX8Vmv4d8w	127
12311	2vaXToTfMgCRDjYeVmcLrPGYEfhZLXhHvY4KCEjpz3anH33v7B87	127
12314	2vb7E9an7DPrJckSvBSddcpr2hx9ZV3Wh82f2DGhiAxbKcWqGpJR	127
12316	2vaLswcZ2BdnbAEqnsRwV2uUktH1kEyUX2m8Y4Vm1MczyK1hcKJT	127
12323	2va9Ru8o1MHuD26VetHSGbgz2jEJvnVN1HHmn5HJBZHBWqD7G5dT	127
12327	2vaTCMQiGRjdQtwdpBxX6KAKTXB2ehFebDJJaV2QAZn57Bn6Ncsg	127
12330	2vamjJ8RP1hVAK4gSAZaA41jWspdxUVYqvcB65ygAtFPWJJjQeFY	127
12339	2vaDq99ggHuQ6zbvyBWDjudyPXmH88w756TD9u3fjnYYWUWGPiBd	127
12342	2vavsmjirXNBt4jKN5tqWPyhEHZFxMrK9sBRnqeHUXkZqDrySazH	127
12350	2vaTwisQ9WUu6nUShG9LVry62nmSLGJJxLbusoEkj5mkCcCuNjaE	127
12355	2vauRJ74BtTmvC4frbGkX9EaTgQ8UvapnsLtwK24QQWQzMz8s2zw	127
12357	2vbMd2J5wG5uzUZGShcEsSaE2ScPuW3V2niZxXQo9cYkS9J6Bxbu	127
12359	2vbJ5UCg25mLGJpWAGWTWQMcPR9B2TdATay7K8986cBeHbqv1x7F	127
12366	2vbUTyeV21hyc5ZKithkiQ5jPTLm8B5ZBQikHL9SdqDNZ9hWEW1y	127
12372	2vbSQ211f1sPa6TYBP3VC3TGbBfo3MrSQVh4QzXjm3bkaruZc4ij	127
12374	2vb8uTmFvs4vYWSmKMap8KpMyxEeFEvRC3W4sf2wqoYDEMgFyo1L	127
12377	2vbwUhH6JEQM9UcpStb5ooAiSXipNSk7kiAwqFnn35X6EcB5xSmg	127
12381	2vbz6tjwb7NUdoBM6xnFGUFAnqmcdRLsAPsY1rcHC2pgh8cmFw5Y	127
12384	2vbTRGCBo3YBubma1DH7gwdLzVVuxdZqRXifYoXz6eSQ4hoYXdUg	127
12386	2vavA6AwgTwGs8LhE466Yw7H7AdsS3hbmYuzEWrFvrftG9Cfyvxh	127
12391	2vaKTKWbU8nTh2rVkeXTPU8DrJAKptMpUt894tsUtdb8Aw6n6H5W	127
12400	2vb1wEPhhqnuBoEon3DQXWwDACro4rpqQ9auRbwp9o34CFBnt3mn	127
12402	2vbZa9ugpbPm9We1fMAHtcnQccsDqCLvh7PpWgbUTgoN7qFj9sJq	127
12404	2vbBqQLAwtcgZYESMPcUcGrvLyDzJEjaMQvAvuzk1rkYkxtd8cJ1	127
12407	2vavNktX4HCwJf7oe4GSRDawUNM8kfxgKoHGSCyh5bXNE8Dendv6	127
12413	2vbBgojjTsK4ZYfAdNJQ8dqXprfcZhwwBCqfTcZQizHpsezHhGME	127
12415	2vbg4nkw8975huMcumvZF7A8NbSzcqx6vaNhgaMnEPz1yfnaHsEG	127
12417	2vbQviBjm3DEqhEC5XZ2t2V6BPoZRvowVn8CkvFQHnGBEiC1C5ZQ	127
12423	2vaWuiEQjD3FtUZ5BynGHCkvsnP9QHf5Ughsqbe52ZX13kzjVn2h	127
12429	2vaqngDtSGy9UEiWa8brx2tmsfqydfRk6gPEoBPrj56duCc6v854	127
12430	2vbN5QryB6aAnjyVs2UEZxTrHgfauuivzYtUFdtz68GEttuafR3p	127
12431	2vanEaEJeshkL4VSP32QL312wdKU8GbyqMj694wKoFno1CoPMcx9	127
12434	2vaxqpkXfo2QUe1SeW3qKxD4QvtnaVQWETNY1rswaKPJMBQx5DqM	127
12437	2vbAtuXtW6y8suE9PQNj4v92syoiavS2yFgm15iCRr8Mi719i5ci	127
12440	2vbWARNvV7EjWJAcaQUWC3spVmkrCRcG2RuzX9RYmnVK2yaVE5Ue	127
12445	2vbyb4WUP18XKQDmM7GaAwWLpwchCdMH5sYabzKTLDGABrBEK3Cj	127
12451	2vayN21oWp8XYtpZAr37gv8rB9F7YgznuDh6ZRXf6FqKwcAPKDQe	127
12452	2vbtqyRhwwht9jtsqywbk5CiTA6FUE9RGzRWxoUaZvN4rowurCfy	127
12456	2vaPFBHh5x7J15JMBfMXTY68GanyMtaNRVkctvV9HuG1DK8SCBcz	127
12459	2vbm862pkbt3s5gJYvK33ehk61cVWYc84rZ3PwPwZ5hvSEf1pr4t	127
12463	2vaa9Qq8ks7Kv2BhVV5JdsV2d8XN34cJGfCohWMfgJuLtuJaWvJW	127
12465	2vaZhTD444F7y6Sp4rtx1q5hSU2o27b5t2crjb6yEAxwA8fsgKeW	359
12468	2vbnNjvnA4jYT6YJG3J4FQsjpUknAj9TCG9X65KGUxMzDY9cBfJU	359
12472	2vbvNsmD8qReFgmyY5Tf6SzCUMRZL1ZyGwxvneZhr8inzQd24kFV	359
12479	2vaoxn4cCdoigivXihrtqJ87KfaLAyLNeDbuDzUWLezDAcP1ppmM	359
12490	2vbuCLqoG7jqjLDKhjivzHsc6QPwVbp2VKYhb3UjtwhLLDRQ9Q1K	359
12498	2vaFcZe5j1j6XbJUvSpTFMZHVRLpSfZDmvQzWXK6waELUx7jZBHu	359
12502	2vbZxLiH4X47PsPEcK4DXEk7MnZ7Bc23uCR8LKUeiwhdMmJn2fUo	359
12509	2vafPkvkQP9GMHeJZjAXQvyZJXHKMsQ8KkCaaKnmydVfNhL5AQCg	359
12514	2vbMQsC9fCHbmFZXMf4kjzzh7AoHDwEDmZmmpfSHpKWfGcz8dYm7	359
12522	2vbqa9L9uiEHk3ExenocoKgQaCN4hZ3JG57GRw1LT7GTb49yJJPc	346
12524	2vc3yqYc2jSckdjPP4T4cYMf3RPXNfax8X622FKvd6ZbeSVpMrZD	359
12527	2vboMrYhz6sGPv9mFQuD7ApDNztZMCSb4GFMjuAuEH18c9JPZGbp	359
12399	2vbwAsnixHWis7TUZ85gpV9SXxej2CxWt7ZqfRHhFh4TWcz9TbE4	127
12409	2vaay973ScwoG3mjocLbZLJsNM6iEsp3hRfSVv8dFkq2S3oW1KYW	127
12411	2vbVjdBhJEjP9dzgCcHKreWAKCusdhSmVpod2289LRdXunKdRfCS	127
12416	2vbwuPai7wYeqm2DQCqZPzN4aAKCEU7bWGKZmeoTu1ciVKRDXZFF	127
12418	2vaxPvKi8BvA3ApNSuqk4KpQHPZs9c71cAFEsZG5d36bx1U73Da4	127
12433	2vb4nhPwZqHwrZVSEdDsBPjqdzpm7BgVFvDQjdyDPWKBsADPTayc	127
12436	2vaBwafq4dnt6TW2NtkCyc9Z8Q4uACQdUXpqg2P47wQoBkvGkkve	127
12439	2vb1uAYuUbVE4d5w48yuZWznFZtjDkRYn1aounco6U2azpTDCik9	127
12442	2vc4571JS4Znghwd64Et9fhABEZhENZfEf5iwYhT891TWooVJnrB	127
12447	2vaVBHTtFHRuoV4nKsD9S87Y6mTKuWH81Gcf9ttV1yCpC9DZxmth	127
12450	2vaMJpy21fHQ7tPGenWKFGeMP4Zu1xLRR8nxi6TvHoifM1VTtbeo	127
12454	2vbeHGHXfAuGU4fV8PvUmKNbDPvDjhRwPo1RpBw2vqGdPjTFodwV	127
12455	2vamJakcUQh3nox73nsE1TNBAASnfayjyeKt2BBnRXa1aXii2F5V	127
12458	2vavwRVH5GrGD2Rs5fy4JHmch8dW3STFruta8YCfmbh5eao3ysUe	127
12464	2vazWkco48h6wm7EjctzCita3ayRuFjdy8EhM8F5QhmdGxUs6UTs	359
12470	2vapswuxtbbDUyUQXSbJ6ciABALqRXWrQPxRkZ9taQEdFznA8PM7	359
12474	2vaowu6bo58cZ9LixTAAXgwbKBTM47wnaLAY7YLtYFaFZ7dKEtLC	359
12476	2vbzaadYwqNJ2wL1GwHU6KFfittgyMoKMFU7PE7zh9swZVr38utq	359
12478	2vbMz9PvYGdwg6j6rjBWnazHzstdERxhjPRX69848M9A3Xik6hEJ	359
12481	2vbTxTvQvBoiheQxKxp95nZdqd3TnEdXUZzhmnmZCK347KGz1enX	359
12482	2vbDYxr5Kr2UgmxePnPoYWajkjZ4jdsVSenuZYorynuUkSHZoWpe	359
12485	2vbR2tDqgzWcnF2mcLqkFo5vSFj23EPk2eFzv8JMqJXYk6mq3ptU	359
12489	2vbeYn4c973nPCPkFvVoxewCPE7yfEZmkjcgu5AmCp6tHQnnGYmc	359
12494	2vaQfmco4SnM3gfyFtGEb3KgVAP85uZKioPyaao7tHCfyxhmxGRr	359
12497	2vb9JoJJP2EjzhgcC8ywE3DrWZSM73kLLX4LtPw39N5Qs53rE5p1	359
12500	2vbRqAeZKiGEWNrM5JynTz3DjpyKaiopY7bXyBFpEpHAWeh8p3ih	359
12505	2vbKNxA3GTvcfAsV1oGgo2BuHNwPVERHYW6gm6QHWCv9JBzGNbi6	359
12508	2vbC3n9d5vb9NgQtMvmh1j8TtfYYhYBZQmZey2mjjRXxnXSTGZWE	359
12513	2vbaZHhprJNMTxktZwTZcFko5V8yTN9uDYDvRJridEAVf3HChziq	359
12516	2vbTg1bzgRTC6TXEwyjq9v4mfhdVM4uNTQaDnvKHN5F9PuCZ5R7L	359
12519	2vag4qfJ2r4Ht4vHxcaCf53XQwS4Nrw7vGc15gsQicR58x5CRCTJ	359
12521	2vaQVkQp7J87L4XACTdYUyMEu8QrJrhop4VBwT516QZUp9xQfeeC	359
12525	2vbQYNWYVEnbxrZb7xpJPkzWF51NvVbMcvyv48F9Nei7p79awp5p	359
12528	2vagdGgf1YNB5UBzn8i1xKGgk8BGV9PcrK1pgfQQBs1EP7zAzn6m	359
12441	2vbNeRhfZ55tJUJGVyqvpU5ewTq1Popd62yEk4jtMVjS8MaMRFjx	127
12444	2vbATjw3Taqo32PUrkVsx3hKk5JgeDy4Zw49BzEhDzyEFGDHw8ke	127
12449	2vc4JB2F7JtmRB9VkAWVyKjK5jWgwMpQg9UymAac3GcebMSdEfyv	127
12453	2vbctpVPoB2uNetyuuMrXZmWvgs5VAYk3gUTUpWnKt1KcuGGdPH8	127
12461	2vbUA5wjUEC9WprzTfygPgH7fbh6AEirSbX2mc7wQzf3xf3U5rHi	127
12462	2vbo36sN8RPAa8P2ztZck2SuAFTMDynzEm2SCKdXABLJ6Mu9Tyo8	127
12467	2vaJxgc417SE75wxFCJaJUudzLuQosYYFANZMCFeaAJECZvibiMk	359
12471	2vbQwhQfdgL1Z1oGPe44Y1DBPyRM91XD3VT8F8rQ2fs9eBbg57na	359
12477	2vbfLhzoV8zfQkssCU9tG6pTjZYimYFjHi9GeZhFpwV4oBA69CkN	359
12483	2vbtQ7phPUWMB4fb7Ye6bjrj2HnHDBmoovCLnMxW4tzEC5xMG5dP	359
12486	2vaPnv7u7W1RnqJggoghEkSqvqTcJHNzRy569MqmjoeqBFR3TYqb	359
12487	2vaXTQaB8YJuXPmC5TBrP66BVfwdvQHwn3tzurRXyfUQThThPbrs	359
12492	2vasnieFCKv4UHF5t3c1bePChGMACDYhfBBoLgK9hbPDmHn1bBAv	359
12495	2vayQTTmPcpa4TyPMA413qkNyyL4Y325hg5tkiGTmJnyN4uYWeHo	359
12501	2vbF5BX7Lc9k7FyiNTKuwhvMaNxudh5LqDhc5LHAEPj5RYe98F4t	359
12503	2vbPgaX1AW6Acmzf9A5nLcezMDSkXdvLGajiCacooCGyQruVawf2	356
12506	2vbkR5F4K8y1PjgG4ny8CCkesqwwAn7Hx4DXUSP6kgHEMqD7cf9k	359
12511	2vaxaUsYyisL9UNimzFrLJ9Y4nZuu6PTYACUUmSnUDNgiG8Cq6kh	359
12517	2vaQPVhmG71MUGWbamaZFbKoqTjfX3VohjYDMARsr2VBVHSREi7V	359
12520	2vbhUZeMDxdo8Gkid5qrrTS5Px4ji6YmfarDm9PW3Aj7ztpymjnc	359
12523	2vc3ZHt2XDF7zkJ4HCJySwN2KCemBP3m7aJ8dF3uahVFsxAnFAe6	356
12526	2vadjnKT88wr2SBKEAChWgracSYAjhm8QsbacJpLJWp9uRo9Tbo4	348
12529	2vbUUrGv4ZdMpkNxBuSBdrQh2C7zX77TU4YEREYbKZFNX5KfeMbK	359
12530	2vaqziWniNgah5xYTxr229NmGzvFQXSo3A8jpVj943k1AKnM46cC	359
12531	2vbQ8XmJe14kvUdgvgHeujpMQcEDnzSZnSxwkgGjZUo1zYCMTgaR	359
12532	2vap3WhxLCMh48xFiY1CpXd6YDkypy4wEinuis9EnhaWeJN7QPWt	359
12533	2vasamQTf9c1hoHU1FTKAFsHQHLubdznvo4XyRWx2ZLLUx3pdJ2G	359
12534	2vaqR721Vf5Qo2gUymC8Pj7HbQqzJm1KrvSQwrRhn5BCgsdssmtF	359
12535	2vbNdQNwwPJXYG49nD4abiHnHwKE5hCpt69HBvzzfGeLWJXvb6HV	359
12536	2vbAwp64cjfR3bzeUMni3nLSiLR2XtnpE6hhdGYHybMkEcrC3JE3	359
12537	2vaGPZv7bSCXJv4o7tCNLDdLFXJksC2ceSCpS95p7pzY6HBgpWVM	359
12538	2vaBiKr2nGkvBqpg6sy2bVmAoRBy772Pih7n1S4hiNjK2iZNJc9h	359
12539	2vbpEpUotDSE3DFgmhynLBwvggmqrvh3DEZ4pwFdVYeSrg7TovVA	359
12540	2vaswJyrKeKMLTfWYyMqeKqC4x4FuEopDjQpVVDrzMJX3mCCxGpq	359
12541	2vauWPbbhNdWKE3QmiGYsKaT4cvk9SeN6gRSs54bEtUgMTXYypS8	359
12542	2vaLn8GxJkvdmu7Xd6pWATrefErAZnX7a7xTRMMnhB5bjVWmv62g	359
12543	2vaSi5ApzcSUxnEVTr7QRGYe5enZhkaXwfhacPCGs4p6B7TzRpa6	359
12544	2vbcCuWXyczmgVqZoBrJDqwgniMxf6vALhDxwunJnBqPNTWHgTNg	359
12545	2vbz1qeoAFooSpzZqfy6CwELbuxXXqwMVQFevPbMoEZbshGiKUWx	359
12546	2vacN48j19yzMmJhWHU3rSmzWfArcq8xprdKhXphte1fjwFmvj8q	359
12547	2vamdTNuXjw7qVSoh57QoCzeoDvtVGejGhhsmcMgjfZPv8w3hAj4	359
12548	2vbwb45Zy2wZuwDC464or17WxGP6nZi5DuCmESrKKWdBhKRaWrqB	359
12549	2vbysqrzFFDduH5mpjUBHvEMh3ySpEAoJyjMD3XMq3PMM2ctXRtt	359
12550	2vaBYhBoAxfJ8oCnYx6Mx79QGXxLSLLxEHufJ3qAxRXKFco3Re8z	359
12551	2vb5KhDwaXAvDvfwm1aZTMQ2os55EGS14H1YAjdJpwJzBL7u1Znb	359
12552	2vaR9Yt3ma1kxEdnV6p9UprqD5Av3Gq29sdZC9tza5cZcRGitfgF	359
12553	2vbDELTmq6vyjxv4RQVu8z41RxaRgeiXmjZLJFHFvukQb8Syapz7	359
12554	2vaW5T5EGzh4B4cmYFp5UAxjKmShv67W4xG7Erf8W2HRuCtEagBR	359
12555	2vbWCDBGdz7KPGV4Zt8sN2fzEa4gWpfs3EzZhG4wXz74XYjDni1X	359
12556	2vbPwqpmMHcLETyg2pPaU7Ku3Yb4yTUo47p81mY5vxM6j76uXGZV	359
12557	2vbiLLr8gVW2JVbyDPuwYdJDHPcr8cxYfXRx2isLvBFaosyN4ewW	359
12558	2va9VGsBfemtLdSH3mBWVaZ6WC7g2k2kxWrC9F19AWJ464dGNebq	359
12559	2vbcNvq7dHf4r4pp3qhdE2xgh4cpbmciJzwTLBGCJau62Lm2AinB	359
12560	2vc5bsC94DNzRTZfiGnTTWLud4JDnEUcqgMFjQ1ioaQS8Cj9XZPx	359
12561	2vaq4tLWqFPkqzzvL4R6sUSrzJWU8yp7FTCMMYMY6KWFqEA92fWK	359
12562	2vbhmpugJbXz6g7zgqfd5NttxRJL3ov6fohevhwjJh62EXMb61DV	359
12563	2vb7sWvf2LeVjC4SMeHEsshMWA4LdXdPqL8hGGVDB3sGbQ3nveLB	359
12564	2vbtiPU1FWNowQgjgah21fN75BGJu6DpAZBcF5oJ5UH1fDUX1zcD	359
12565	2vbiaSj4qcw6txtxqPoG14TBJUnYXz2CD9RegJkRg5kFtxhz4aLE	359
12566	2vbC56SVJMTjUzL7y9tdxFerUsXp2saC8NPt3aQcoBsrfNMZwugJ	359
12567	2vbS3793bZp54YgVbPvRqi159VxFvfz8oVsmg88cXJjDEmSeFTGS	359
12568	2vbh4o2tpJJZiX3MjNHHkp5TdHeUx4gdYEnfRaWMZUqK1vGLsqd5	359
12569	2vaj34DZVkm3Ke3aXF7pUFwZv2TRYFCdRhY7PK7UXdJLm7PwwsD4	359
12570	2vbKrXRtAyAWDX3qtng2nj4KkE91mC9NxQUBGt7XmhE9doc6tBuH	359
12571	2vaX4L5Ud8JVNVMvaa9t4TH8iRTpnPvxFc7oUPjjSo4t9qFgncPF	359
12572	2vbv1ZaKFtoVNBzUVPzQV5M3hcH1sKo47CKeS3dnrjRSHA29ip73	359
12573	2vbpyJDKVTc5a3tQazS9XSNoZAjZaw6JjxvAaeK9QJFyizjns2Xo	359
12574	2vaanxwT3rGw9hyy3vkbNiuTS3zHYVDwXtAfiLZn3xWT8eYSjVrx	359
12575	2vazJquuGPWgeCpZXsbEnN8iAJiZf9QQhid3pmMtM1Q6nhJFC13R	359
12576	2vaHLcUiReV2LMrA1fw3aFxLLn3FzVjZbUG1ohsSFXj6dY1BkaH9	359
12577	2vaQyDiFNLNsnZ9rScgCHmgHF11aY4EgVUSb2r8vW9ja1LJcvFsn	359
12578	2vbAXY2efp6XYG9BeadF9Gpc7QjJXqocaRhs5C8PtbWPeVXB2SVM	359
12579	2vasve3oe7RtJcvqELQWY1jNq1SMC4Zf92Lx6Bo9dcKSoMAfeacb	359
12580	2vamnLL85nNVyQjpBDD3sM8hUNwmCq8JfFWwx5pq56vVrziFYVbY	359
12581	2vbQExS5znHkStLLirM84S6dVibvtUakw5BmJhHDyLZu1ftPk23E	359
12582	2vaQXihJuGXfPqYKvH9ocRV2EzbLkqhvQWkp77F62EWkkfS78azs	359
12583	2vbhuyiCVU8SbgkvqtpPDWRppE7VYkr47xis2Z9svtzpne24SVZX	359
12584	2vatstgB6PpqFVY91cfLQxsuA2f98xWefdEdbCpcgLPftiL7WZDy	359
12585	2vauEDmeuoRwQewp8xoVHvWzZPBc1x69KXB1YwoRYtKbzvZY3fRW	359
12586	2vaY7H2nt2rPL78Fw3Z6hedeA26bJkPhaP6NZRuVVcHc1Lzywxa8	359
12587	2vbLToj3fW7Af3pCBJGLci7pN45zUM4rvsf1SgAiaqRnSqjuiEpB	359
12588	2vb35WXY3VSh7QVrwjaYcLyB4Cxs5zs965m5sQhg8bU8me9QSiV2	359
12589	2vbatQopPKFxEt7vNfZnQaoTdEknvMoevDbTPYge986U4oBdaSGy	359
12590	2vahD7Y8tNHN4GgazT9ZdPrk4n8d5n5kn1QPz5pz9bkuTpiM3Qqi	359
12591	2vbxn9KUgTPHWS8WmR9tTwiE9c9p5HMVLAkqznmQFzNNMjjbE2gw	359
12592	2vbqzNAhRwHN73pzFqn2CzHpc2DCKoVrkZbKQTDHr926g6FuUiRQ	359
12593	2vbGXWrqnjg4A5rngwP1QByzXpxiU2PQKMVFs41SNodfbSqPw8qh	359
12594	2vatEYNFtsedJGzJgnb3wbr6VVuyPBZDyqKcugGAsVrXscrqkS9P	359
12595	2vbtinXwkTU3ET8gkwUUwcQKmX7ac27ddSr3sUK8zKhyPv5X2RCd	359
12599	2vboSsGjhjTMKLW56jcHNj2Mf4QY66pvyND5LUh9oYbWCRXFyG6q	359
12602	2vbmVgEDERyu221udT6WXsVqjDe6GMga7gRULTfRikKxXjQvDgZQ	359
12605	2vaFGHRq2WsvUDQ3d5kN4GDzBe1YSEpAZ9awaicUbx1vNLkvikCi	359
12607	2vaD46uRL8kBbQN6hSP4Rvtsw8WH6VG9hi71D4cMBzS6FbwwpSUc	359
12610	2vbf1ihrBEUqiA8ftyyDfJ2yYSk8thEaEe775h9DoDVDXP8YdWGM	359
12611	2vb8G5kMYuimnXNL5WNTLMsYJ1cHt4yWw7X45NtbBEBmrz1FS5vd	359
12614	2vb3rVEHPcLdgcrp2vKMCJ4utjSS8CtLbhZGaQ7We28kHFc9Z89m	359
12619	2vbCX5mjBtKKYznzAQnsxDapLyjKutQU1NBbXYv9hGiSohAbVuzU	359
12620	2vbTtfrRCTyTM7fACbpuvLxPEGagdvmCCrhGvsdtfCinbszmLhYd	359
12623	2vbmWE5ecvs3PdLajWhpWPsgps4n5Bh2G7ADh3n71RW7y6nGcQS1	359
12625	2vahAuyP5NxocDgsUdChg3uF55otZBPHtFsy7gqnTDWapgeYr4hL	359
12631	2vaPJeizNrNLKxg5AoaoijcimHbrgiLCa7vGdfXhep6D2Af6QBag	359
12637	2vbSZQAhTajUceegjtjsw4N6okEembQpYhdznE5cTYjCXHygghSm	359
12639	2vbKwy3WgTCfPUcrtxLR3ZQ6xRViAbWZb1WMpP8HMBi9wbg751rN	359
12642	2vbTLXTkKaSrwr6Kr2f5sxDFwy967ZEHu56wgx3nS5p1ZyP5c5ap	359
12645	2vbhbBpUi1kAu1owieEyusoHT4mr5NUQsXdUY6GFEAgLGWUCqYSe	359
12648	2vbSMoXFy9ouWXFT15GXgDv6YqxqdVWD56gPmNL2h9CHgqKH5Lfc	359
12656	2vbvobCY9zwVYkmhMXGFcrY3Y2dXXZ631qFEu1g9d4UG4oWgxYNB	359
12660	2vaaacUTqRi6KrQpQoufyo5zd4SWmia7jRWgtRXLUU3Ty9dBmkA9	359
12662	2vb8xssrMt8t6fKzYmr2wahhpDpXJK3k7AFeoGQpwx9Ch9TUNsQx	359
12664	2vaB6WcR9c8SgKwrWrhZtiWaftPyWcn8DPcFFbgbyPXSsdAx4DkP	359
12667	2vbGQAVpQfHmj3yJCcejQfDtx8kg2odSoJE5UnhrQNE9hSyDjY39	359
12670	2vaHJgU4YzJQpXmPpLXDqTn94Lxxi5FJQNsENngrYwLrW5HjmV2G	359
12673	2vaX7ZqjqXwRfT5FDuanjSLnVjWPxyqDRt3kwu41Jy6mxCwkV4WT	359
12677	2vae4orzYkQuzS7enBqqQZNqewGKayodjqmN1pWARug6v647ecTE	359
12680	2vaPwophmxFMSWZvvqowmAu428teNaFsZtRxet2YMy7V3ZVY94aV	359
12683	2vartGW7KyhtNA3mqeBJ5KmRoUU4mVBW2ZZDGpVWVpn9GAGDDMKb	359
12686	2vamvmvAs53D7gZj5gnGhtRrdLR21gjBE2HuYMSeEnWGJZuiA9D9	359
12687	2vbarzousBc5oqV4yuCQEiAfdgejYnyhsCFk5VnAAsH5C9T4tC86	359
12692	2vb7brUAixc1fcuuY94XaPRB3RjF8cdwur24EbKNfcLgdLQadSPD	359
12697	2vb8UpoddVeVBjNbmyZYN6wBH8EH8hqe8KrM1eDief1zCADwkkAo	359
12702	2vbdE37LbkTq5w56quee2xk1Gg9MengQ5TFvYExc2RjkzQdP7V5i	359
12707	2vaecZwWgVTd2nw3JxQAtq9Xq9YWVj7M5dYiqgDn5wvZ98tNJRX1	359
12709	2vbBpg7WXQCWbGHhSmAgYyjA6YcxszM7zgXg7DzpSJrd6DnsRmA9	359
12713	2vc1ceTiCUho6MCjagLHfpcMDyAifikyg5BSDAJruJUaLk3egW6V	359
12715	2varMiHXA9Rj97QomuZgnWRb6UxLsZBGW1MifEMAUvxujYnhqzCF	359
12720	2vaWe322jxTZohRNZaMvBqhHP8ixnePbeEqPqNS2zrUwEwJsxVUB	359
12724	2vb2TeXn7vT15129ZDR39LWCXBPMd6fefdMcyY497RYbJGwDCfPN	359
12726	2vaSKzGfcDafPNkbry7mBi3pddG7e6HKAiadB99sVwfGZmZrNWTC	359
12734	2vakrC8TUVonxaF1K1TwszDJKuioxtktrPjfUPWwPb5vNj79yxXQ	359
12736	2va9f6J7afsn8CqtzyxJfG6c9GkFVtXMYWeS56XGnQJmaamCTTus	359
12739	2vaHCXkg4q4WgvGzyovBXiWxwhNVPfm2TrFt84z28B6rexC2gqvY	359
12742	2van4JDSDhAVKVnYxYijaDtAFKftjq7qJcG9rhi3UrVE5RGN1c8t	359
12745	2vb8MXV1G5Hx2nmB17W5C45WQu5f4vKjd9ekHoiqCMo2DvNhBpkr	359
12747	2vbPmcEYu6oihRUwfX1q8hAXXctFdzRUo4oGeqAKNWYrowvtvWxa	359
12756	2vagGdGdgzExpacTBDb6smmfmxGrqHSEiMArMqsurnJoE59itbdt	359
12759	2vbfK2KPURFkJ8FYVRNah1NHAr2aDeqmZeGD88kJtGN6QY1WgMEL	359
12763	2vaBquwUVHTr3YxFWFNi7bwM3HT51AE2he8hd9fARsScDcgA8rGr	359
12768	2vaJC8WMFgBy8eHcvwKpTgPyx9zi3h7ukm6EVqatfCBHrwx1JoU2	359
12773	2vapP8PYHgtEHNDdeoJYzhP8h5sQjFYtxWkSNGhCuJjqTXecdgoZ	359
12777	2vanjJdbypi4cpH4MDtf8zmqzDcCY2bCys4zLfdHf4e5QKaBkfdQ	359
12781	2vbZNGKV7JS3rR3EUqnQsDesmG8a6Xf4iR5f8UcrEACaeeZBXi9L	359
12784	2vaR9D3sSzgBfQHfowNaaRh575EMMy8uy31NLSgYj1YMudzb6fst	359
12788	2vaivpG6zE3mMxooGnQ6BfLTY5hYjUYPtYEFHw7edjvZQXeNcWWx	359
12790	2vauS3eC5GPJ5c3rYrpn2FehMHYxZvWB4gdDFYwYxpbm7CX7JJBG	359
12797	2vanHtyiv97UkJA9djKeNnhenBPkvgCnVuuTj9HhYSV4Bt2SEcpD	359
12803	2vaBueJvUmb43em4SFc9ivb4AvsRVXNigM3m3QCdxXEUN8cwH8We	359
12808	2vbLq7xPs7eN6WRUwZZmRjshqaV5B6Zb9ERw8yU4E58k2UEvVowM	359
12815	2vbyKKp7r3Qr5xXbo9V1R7HfJwFNpsUALkuXChyuiBujagKHaH6P	359
12822	2vaSmeqCxtnhkLaExu4CGMcJYRUwfjEu5Ge6DzGJ4KrQtS8U7ZVy	359
12828	2vaQovKNFAF6eqWtsxUhF7EVHKBVqVRfv7cMipz4gHo7qZM9NySU	359
12829	2vbdBAVgphhbya9EtwdPr6Edcvka6GiTi2Y1YWyYk6j9PfEZZUy1	359
12833	2vaDPtQ9QVYgQzANxW2QBYYL3iJuAUQxLPUSYDKX7k1vPU61o1dF	359
12836	2vaLCgA1zQFhKA6ZTvfqXTQ6AzqtkA3KRVgiNTyW9xnBuCuyMZmh	359
12837	2vaUAN3n3rnbRQ8ik4fZ31g9hWscXvwtAyFcKe4rxFD9SYRspdD4	359
12843	2vbJJwChWKTTBz7fBqjPkpp92rS1paAwoFArKXmR5eLveTs3fSvn	359
12847	2vbexuLJuj8q55p5fmJ7SFM6ykUtYoVCz1CUWEaYEPLsCVr2BQR8	359
12848	2vbe2mkggRupZHdN4B5pmSKR8qirRLZKQs1yG7h2UVeHDgUL6jZD	359
12854	2vbZgjkFeyzdFE9wCTFr8sbu3nK6Atw6QFaapjiXz191noZW2UdN	359
12855	2vbUiG4FRLbv8PWUCMQJdYRx21pDGh47vsA7yKiVLgrX5XyVJLoL	359
12856	2vanHAhnMtUdhR7KLKooRSNNiYEaGiEWSaWktASbUuzr8X8rU5ys	359
12860	2vaNaMvSe5EBU8TPkxxrPwbGMVGp1DnC7YHw5Hw8aYKtq6RwKDQW	359
12865	2vbMUNnw2295hF45MDtBw1s17NVP8uFge6eUsEnoSzphk3cS1Uze	359
12869	2vaFseik9Jgauu5WB53HVJcN7J5CQRxhfknf4tDsFQgePYKcLKTP	359
12874	2vbu9C2nopGzQTAMkYQL2w8ugTuYQbD8joV61ontHuuRRVbPE8sA	359
12878	2vaZvRtwXjsVSJTYu8CAs6hGhrRhYSeU9QTeXBjkowzyCT4FhaVs	359
12881	2vbRAKmxiVgtWovsSSWZNVFPQpA27dLuho3renALCo4caZx5dffE	359
12885	2va9nGkwSzQAJ1Kvnm8swe5TgBeHpuUi8uRe8vAxGFuAk6bEyWDK	359
12889	2vbT7yAw5874Q3pQ2oirVdNeR8Vt6aYTcifury4HyU1TfYqTTrL4	359
12890	2vamMt9eTJJYE7f7WxTL967bLvCy3uioZ1t8BHcnyWbhmTN7KpyU	359
12894	2vac7rzfzdccptLVjgLNyKRkgFrHB1xr9RnATLeoTiwdJEH7DfqJ	359
12898	2vaqHU1GdU2Aj7Hu2B9ng4eQSDzRtK2E79zaWe8k1h6VFrXZd7Wv	359
12902	2vaxz929kHu5X718TDnV2jPkTK7EhB25cKGPMooU2cE9K4nsjafm	359
12908	2vaUUtr2f4AjsTbXxpWYYN5H2D8UkF6zLuLYruzBeLTuth5h9hyG	359
12911	2vapBgkfJyX6AFLMnYkGpNeaWb9436gSrosLm7LVVbNYrsH4n1cd	359
12917	2vby1s34Qn7sRdXg9BjTg9wDbFq47rdPHt48qTgBuh4CaqsLBsqr	359
12924	2vatUAfogfS4K6coTCvH44oRN2T5XGWQFdmKrcfPDRYBLJT5YgVF	359
12596	2vbjqfnH2VXPAxDVWVD4LKb5mncrH7ZB6djimbWS5Q5LEkKzLRVf	359
12597	2vaKGYwVh5sraRa1ShBNwo9U4ZW37NcvnRV3fAS5DZVvjBUxZDsc	359
12598	2vbtbdpNsxHFnZHX6buNZrvh3hkBmJjPvdGmtKfcG4GgyrwEqTbw	359
12601	2vaiWvG7cbwNGfB8x6aXHfeM4RgWC16E6BUWbA6sqQbCnFzMjAMt	359
12609	2vc4HiMFMcD481jBxDwEwAddG89sCZ7y1oVK5FR8YEgrC6351xuV	359
12613	2vazfkHcmWeoxjVBWV1Fj6CS7oP5bCuJdh4kU1LtmihnYeERcLBR	359
12618	2vb41xwLfeBAVorYTD4jRLagJcMiKF1XBN4wpXoQPtRg17d4uXcY	359
12622	2vb64MPVsSawAcSVK7JNNA65ruzARhu5PvDumu5hvEpPpVwmGK3s	359
12628	2vc5KEHxXU2jnRN5Dtcx3hfvJ8KNVtBpjDNtJ6LZpGnLeHayRCvy	359
12634	2vacbnzkGnkU5pnwGeotY9mMCiB4c4eWkrnV485T8Uerjaq5VRzU	359
12636	2vasqAChu9FPStGHt2o3vboZ4SEdGzuvTbDYeuaGbCzknGdzhZDf	359
12644	2vaSThPmeSd7T1F3BqiVY8ErNxRbxkVmrwi2bycNvogFemdPxban	359
12647	2vb2LB5WN57vFxhHGuJNTCDsC4Mo4HvJeRkFGb6zrmMvVrRy9xeR	359
12649	2vbq7d57ZKYrGofWyjtpSnRJYbUdaYQpwr4xmNUafVzzxrMoGZBR	359
12655	2vbFUJvUqHsoMBqsWTQjHSvuzTjEiVRdsqNn291obMCPV82ibQyA	359
12659	2vaHatNB58cfxTFbj8GmBExtGrPktRFr2FPcAHYqrPoG5X1LL8ER	359
12666	2vbXKUCe76vpxbjMQvSn1pLcNiBQqUPMsuLFXxGXqkt2eto1xUPV	359
12672	2vc5raTVPao9ANT4YSKaqvBNo2EgRAqvJ1rGkY6Upjze2mnw8KpH	359
12682	2vajA2yTAdTxmMXMReJcfow5sW9FLw9ATenEw6fjSm2B6QkB2TJ1	359
12685	2vabYotihtTjHEjmNn796T13JTxj5ZFfnjRfqZh9hjsX7mNX34ZS	359
12689	2vb8VLmJ8iPGk54PjwTJ4ehWgRXBDAAG4qyk6QikrV264frdqk5o	359
12694	2vbnCz4W1j5VG8kHxrruKaoJoZwLzW9a8GgWVwUd2sEwvX15TX5Q	359
12699	2vbwbsVVyMykEU2EDZya5tiK21fwJLzr6tjuGZhLExjM8Hwpjco1	359
12706	2vaD684dJ9H2F8BgXicd1DauktxjhMH6GkHBPxn8mP4PpNjjZ2Lo	359
12710	2vbYy6ANJ4qTbCTcGsiU6VufsXzTeGWSaLsD69Mrt8qHX3vfoqan	359
12712	2vbngsMjB5HhWY5GPDrAGWBWMHaLe7VAS9AtxnYRm2aze2bTppu5	359
12717	2vb1z2ajP4bj21hxMXZTGVfJQdEGX362q1HBk5Yik4VfcTs8dQgQ	359
12722	2vbuc6YtcpkppaRfcU59557F8oAzRKXxqcgEuwtDspTMytebUqiM	359
12723	2vbNM1CBiBwjJMNCboGw39A8Q62kPomKSRemAusbr2DB6yy3U7jE	359
12725	2vb2QGn2rEtAssFokWy5Djq7JddeEf6R28d5kjKHrCjW6UtSE2bS	359
12727	2vaqYiixYsxTd53HD5aVfkq2wGwpEf9naQ46UX77LMVZ9JCXwL6Q	359
12730	2vaCRrkb8f8HMhM1HyA1X728YDYay3sjSxjqtwnsJNq8p9sxwify	359
12732	2vbn6LoZMNDkQJ2F5GXGVwEb54gKgiLqdLkN4NwLCsbk3eKNWByv	359
12733	2vaqvfiyyAp3s7tXarNK7wNes8BKRkgmYQ4MVhyHjAd9fPekQ6YK	359
12735	2vbtcQtbky5eb9FtUZiKTuCopzNfJwwWAY37Q1a4K85gLrEnBvqT	359
12738	2vbmtobf8pYGgH1BNriGDZfXrS28Kde5McVd82Cgnf79q11DiiVY	359
12744	2vatvCx6MR4wAwCQjdVpTgDehq5KcJqXQnq8NcBFwzRPy9YV3QYN	359
12750	2vbn3QcdrENCd5MYyv1W7xt3H9KThYczFdYpmdgcu4CvyumojgfJ	359
12752	2vb8cD8mJa5yksB3A3EjXYYzc9NdRWgx3Cp1b7dSepWsqxkJvJMS	359
12758	2vbijnQWV5aJuy9GG3CtDQSqLB2r2rMqXPdLZVJECMbv4mDgKVBn	359
12767	2vao9XxPhK36jfjSWgBFGxMhSgDQHwhu6Zu2BeRh929mfw91QuuJ	359
12772	2vbYdNwmHCyFmP87nmf3UGf6tiFQsFgxxSGBZFpia55FYSEFP9iX	359
12776	2vaeVNTRm1aACxYuJpN9cGiBggY45MZg1v8kxgMkEx4uyA3Xjarf	359
12780	2vbZDmduDvoCVQx1XqdURB9Hp61g7U5Z2pNWquGvpAKE3XuEA8P3	359
12783	2vbi8ozmft5poHtX6prvL9Fmva8MYyVQf1tQcgiMUcYxTvsPnyDc	359
12792	2vbveGSgNQsJBk4nr8rzXZKjchePs6hSuNuQCmxbseHdQqHJqsMw	359
12795	2vbtyKnhNneqtC5FcgkUJCJrU4vY8MKsQJKFtaYXCQkutk5LbLpy	359
12799	2vaQrhKDVboEZBarEKXz9yMPz5RGnwzmN3mnVGUzMN2s6K1N8yg9	359
12801	2vacauWFWbXL9vmRha7EgZAZZNmeasWSQB87yrwegS59FjefHgXL	359
12802	2vbrTsJDNR7DSb2j8Cj6xXvjuZQ8bTbtXhpgsQq4K1YXVKP7EBG5	359
12805	2vbFsHBNfHPGQfY53yFSbaAjjajYSaazCPDDy9ZR8aonKHNVednV	359
12812	2vbeTm4JjeYEQNCHg8aM3UAenGW1isn6fXmh4YDDrTP6Sx6hCD3N	359
12818	2vbKrUHApVW7FcBrpBJKUa6eogBb9iPZ4UkJavwMQv4VED1vZ41g	359
12821	2vbHzsuEwtp42QZvgHB7hwYYh5oHJmFGuRRctA8L6QhX4ZkVSo8z	359
12823	2vaj45Bep2yskM7WkfLHdBwPiwBCUc5ZWr1T19ShECY2c3TrVTMG	359
12831	2vaXCpiMxLHXaUwep6ft9eCAGVBv7jmy4N25xJS4mJNnYaxsW2JV	359
12834	2vb1wrLfi2H94R1C1TdEG7C1drHXPf4FWRAmcN7ZUbb29ZCn6mRC	359
12840	2var9pBx1o6iDz2RKqGqRxPKt8kvt9GwWy46x65QpAcR1s3bo5KN	359
12845	2vbe8DsvCE63yF7HyYSPrfnr2dVyUbQ3ctyemnTqTycw73m8b9AL	359
12850	2vb5yzqiEqwCq5gcGBoGG4rc6EgTFSa81es4LwJdY92XUpLZCW1L	359
12851	2vb388CCHyerzykLtF6xuQCCWi6sJ7MDQTGnn2DiF9n8A4oQpSVV	359
12858	2vazTxCfakkDUfw7C8E1X2nrqjdLo9Un2icGi9udLHSF6heeJWnd	359
12862	2vbErqJi481FPUg3CsJY4XP5ocXfXKc2odNXjoXPZbVZobdcFcFp	359
12863	2vbPhkppFCYoJWcpxc1zKRtn8Qdr7wDRBXEeqT23HN2RJNBBZmvq	359
12867	2vaqSMAFeEvLFcyhVaWmg1VKGAkY9FLekEZfzjHaRSFzhj8qSZg7	359
12872	2vb8Juj3Vk9RMEhKXchyBjKz5DWEJuregE39Fy5NmWjQ9djESvDj	359
12876	2vaF7m8JwX1bndqNcnjLoWHofCXJ19qj75YsqVDU4UXxVZWbAiNG	359
12880	2vbdmR8PPdATSSqhPJaZ65VBA5KsANqbbvyjj1FT46TknZzDN2Pd	359
12884	2vaGX55oxD4Pp7mxcEmQthsZsVvDwpMYXLArtBTNamZTGor5xeED	359
12888	2vaSw2EaAz7uaL81QUEQfSC2EAgdGPhEecHSji7u77zrRQ1dLrCT	359
12893	2vc584VU3nddVgtnY1ygmPQf6m6GiwbhBCxqfRmPQGY2bC5u6uUF	359
12897	2vaBuZLGSALUKWQ8EpMeZY79TEkwJE7pxmVEDPj3V6vTHTmw4Nfv	359
12900	2vb68cgWo9c17G8B9HRKmRyWnsmAKKMwq7kAFP7tdQ1qSVEUPd3T	359
12901	2vaNGaN3rCJh3RXr9EHzQJQqbTB1rFiRj1VFE77TgiT4bCVJQZtD	359
12906	2vaqgsLzx66QfzZeLEwFkxVbdvZ38ANnWXKeAmvnrDe4SoqnPwwK	359
12907	2vaZPHmCL71iLLr4ALJQHDR1f6LSMk5iYSwQXBJ8YXLuLuXG4SSP	359
12916	2vb1UwzW3hMzamtM9m84J45V7ZQjs8i6DNjPTXaSunn9ng2zERXF	359
12923	2vabAWXauGPgVKGfDDvogY2JwNrgHiLeNdV6f7C5FfBmPJjenNT2	359
12928	2vagzyb9GmNy6TVnt4nVcbFMBG5L8H7GUNEaahL9XXZ8Hewm7Xi4	359
12929	2vb489YYCMtmz18FT5JL9vntNVkmUebjGA2M7BNdNwJPxhc9YZQB	359
12930	2vbcsyqewyEjPeZhxZ4dRFAHpKTov4BUFsCJ4EaVC8KPFWjcUDhz	359
12931	2vbrMTdJRpg2AxUNBETqRq986S1Lk9dM3mvJ9bj4ShdUQakA4hBP	359
12932	2vaRHE7zhQPaQXLjYLPztZSHYgKszUpjgJjNrQ43bKVXupJppC4j	359
12933	2vbryNzcp71Be9LFBtuAXAZvGrqmyAPfXr3Lk3xu6EYEzNZFEy8y	359
12934	2vaVntVC393uuM94U1fmsV6QauLnGLQm1XqesfgGwMDA3sotMJf9	359
12935	2vacbk56xgCfER48zSh8cbQ3f8BvFd853UadFMcLk3kUQXLFanN6	359
12940	2vaibDLXjLMstg76sZD5EBPEcBk1vLgqMG6GBNCkRs5oNTGUpuAj	359
12947	2vb29w6Kx2qqrdeoQLDyJXsDLDJTT3W3H2zBv4wJHRo7DqsAS52A	359
12600	2vbCGLW5A9zop6JwawdeXY6FsHBcybcvTt7vzyD65k4vL2GfeLBn	359
12604	2vbBkn6aLwJzxJLyk2TTdvX3usLidwDB3yqhadFqkrQQdDAgzfxi	359
12617	2vabDHvZaofEKnputzDAqmz7Bgn6rdvpcxdmXYNJv7XwJBPZZ4PV	359
12627	2vb3wyJDmbWoBHyfNyJLekcFQgGxxPntNApeP1CoVavqZjKCUAJs	359
12630	2vaWifYgcfsnNc59FXpE3xMUo62BJww3qC3ERNJecnfji8pKj3tT	359
12633	2vaNhNYd572tppeaXK7FApyC7Tgpj3PitRnqNe3EESsbMH7LyJzv	359
12641	2vapTcWBmYVYsWVt59DLR6z49Uq7pG7RxiTFQNd8K2Cbvh82U5uj	359
12646	2vbxv7ZDA6XbQWGPHXTA7MHqQRfUELvLimj2QxE6w4wU5DbELJZB	359
12651	2vbawwkPNQhWHYmGFETXt6SFvjdfSZrLWkLt8KwJQ28LknoX8rsh	359
12654	2vabV4it72mWHDu5ujqFGJ4R18GXL2nTuL7YZrdUmXSsgBwePmqq	359
12658	2vbPCmnDBCVDU6jLBPHMbLFhgvJAm3zhx849P6hMpteT8GhqJPd9	359
12663	2vbXgxEZvfG5fHC6U9ezRspvd86LfzW5fGkqb9nh5Ut5uopAxHBF	359
12669	2vb3XLSttYFR4gAJ82BZefJYFhhE5QUucrudQ94UyULfswpnbMqd	359
12671	2vaYHvQm6o7YF2fEwhU8st9qXUB98JjiT5ZmAok3iT61Ku23SPv7	359
12674	2vbHEMfhsLn38HYWFKopDKWsFV5VNsfXMYCAUunkiJ5oc31Z7mdN	359
12676	2vbB2idgzsdrBJzzsRSgyP9BLtPwLF2DTjv4yJ1YNqYfdyXqc4ex	359
12679	2vaVDD7BH6FhW2nvUVQSvVYigGix3JTiNVH8abugpni8uYvtBa6m	359
12688	2vbCWKfMJUo3TnpdZcWZhsdEa99p6kK9rQQVj4JFqqX643oHcjJL	359
12691	2vaBirUT2k9TJzCYdmhJHrwLYnUWYhSvqxqumibLfm93BEdxuQAp	359
12693	2vbSV4BJZnUJQHSeRM1oFKecbvGYFDXyUF8QZ68LUSUuTZczWeJN	359
12696	2va9wdqUw6qUKtwgGv9jhCQmyvQ8wafoov1uBhiT86yvCb9qQ39N	359
12698	2vbo3pndjE4R6qZNwZV7nYF7CpRuaRBJBzoijDkQf8pqo86fnBiJ	359
12701	2vbUpujM6GsFQ9MaFznHdBgqFP7CnHTNUs8UwkPQx35KhoV33zFd	359
12704	2vbZLuUnWBknpXH59c7mCgguD2ZGkqUcFEJ2Rd3bhFw3Xain7tVZ	359
12719	2vaGBWgcQufP9PrKsP6NurwRG9TyhutnoL5uEt2DzP9EmbC1doyZ	359
12729	2vaVxc5fm6p7P8GfuaPdHNBHQujSTSPY3tUEUZaoM4xuuMEB1qaG	359
12741	2vbHcRGG3z4Thyf29Wf4i2fAvBimrtjpF1YD2iq1JFu8bSxWHYHZ	359
12748	2varKnECbMio19iGtSg76BfNhMSx1ToUzsd55Q9saFWSWQ93BPdE	359
12749	2vaRrgFYj1NR5xaiB3x2ykUgp8ZPGPdS7AnrpQMsz72nkKdpinEJ	359
12753	2vaYB9nqUKvMUzDwctnoeba6ZLZ61q5kcE1NabqdRyV9XxMJiE7H	359
12755	2vaMN8erq8EGTcKF6VYZUyryP6y65HF9nCBKL28XTRdnaGbp5Rap	359
12757	2vbyz3oWBbYhmXDAQAv997Wq1dx3gxtqGS2kgLFMWgT8sWwcACbc	359
12761	2vaUuvFSMMT82vUHPFxDDMNMptYPWDEHhQp1xj9Cq6dKULkuNo6i	359
12762	2vaRHLC7we9Mpcc5xgTNctzHMDqzSR3J7Aa65EodTJMLeW7dKtse	359
12765	2vbDgaetT9CQZcimxKLqZu2qB5XXrTptRWLD8qRN6RB7JgxU9BHg	359
12766	2vbSHbnd19Bnuufa859JyYfGoi9JQaDrDtEWSVpqy87vecehUmeU	359
12771	2vaToDTfYbi1AcmamnPyYfnicfVvhzVLUW9B8kw7nStNh37tme5N	359
12775	2vbufsUKWodpjUkqsV7qPAHqcpohirapBE1gSBkwYiQswpJvw2Aw	359
12779	2vbmuUGXFHoquNaoB2trSmsV7j2ZtYppdHwRBCgp9V75QbMaTBaX	359
12786	2vaeKeV2wcoUK158qSVUU83R9Eu7eRHuzwLYURbjPgw5seKaRd8D	359
12794	2vbbmqi2qLRaJWRDwqPRYiQqhN4BVfuEXsaDKBA9apaaHmYmf5BP	359
12796	2vaxMZSrgk3qhnpz3BhAETb5W9CV4r2cLu9JX5iSH4KqP9nDZUEA	359
12800	2vauePjB8hrLW9sN4Lay6wR8JkgYYmaSLi2nMZWYFcdWErBkpDwX	359
12804	2vbV3594s48BGSxUGVDqCeXhtHqqedHERTeoSqQBBWX2nxTsv5cd	359
12807	2vbDS3NFdrKy6LWynngjsb9ntJBJFVTPBYCxA7ATH9HxJoPLnCnS	359
12809	2vb9tgunFUsso32FYUZEM5NY5XhmfS38oMyoVm3x136arLQMhpzr	359
12811	2vaujTjJh3wNNN9Coou2Zq7zkxg5M3rCt3FJsxept5GWS9wWXvub	359
12814	2vaGnJEoVL5RguAqfR9c1iQpcHWZiC2g2dZsxSAE1nzt7B84REMw	359
12817	2vahqc6jW1yatmXUPUktELhudWadHDe91b3qbAyaiyFvQsATvbC1	359
12820	2vbJuMroUqKx7z6NHk5Xx4cRFN6Kga9adi7bvhR8th8hHbeQxS8b	359
12825	2vatGNXhWMbMFhR2qpjKkMGCw1mFz51Q4xKP864F6wYVji9bHfHN	359
12826	2vagRJnpQA6U3VBzpAgbrsAa4yW369vTM85KnkX5Do16sbUubCLR	359
12827	2vaAiKartdXX6VmmowNdvSwWmc9KyJRjmdR95vtAP9zMetQF78K7	359
12830	2vaqr8DD4PiU7HGf44rpmBNXih8qhbnaTVuAfW1owJPwLmgbkTPM	359
12838	2vaJkZ2hyUhoPLXMYWY9JAnZYX9ZDfp62fcqDMyWdUQUSM2XPrud	359
12839	2vbYS7vAJxkdYhCfKuYdZRQBfwj9j469tTc2xh3f1i4T6YBfxVDE	359
12844	2vc3umkzxgzWZPvtpnYTfZENaFTYNxjq2HA64cosv98yxryGQz4B	359
12849	2vbCpEakXbhDYtr8KF1F5t2kkKTCFeCqvKtav9E2YE8of1tig8ix	359
12857	2vbpeUmFJeMbaAd1VsqGjCFdiJgrdsrUquBLwCUZzsKCsFYc9ami	359
12861	2vc2ZuRUbyL3n5F983K19QVYbUcgt2Zmof9CZi3XazqDv98NPYbZ	359
12866	2vapBuNnb14BqPiWyruq1UW1oJEszBw5vezXqBido4KmCKyqgWoJ	359
12870	2vbUYDzGQMhBXzJuCVcAu63vM3cKc88Fi9GoEouZGZt6CG9UJcYN	359
12871	2vaN1hmoSqycGvFoBihmYNyRc57tq4Y26T4yaRhMQm8AD8yRNKEy	359
12875	2vbt6EGKeJDNoUxCaULFaFXTVP4GtYBF9FoepQihzmnqv6Tv2dBy	359
12879	2vaSRr3ukUBehTo8KRKcsopKT7US9wC2qs5pCXx6QGpMjRKZGG8i	359
12882	2vaGA7BJo3wFzTUKDJrgsnPFcofd371CwSWJC2niihP2W61PNcSy	359
12883	2vah1tQ4bGg8wSE4P3BktD8KK2YkAhZtc9uQpHSuFhSW4QvgNUfA	359
12887	2vbxHcqkBFR3ZjYncUfupBpAshHaRKnegkoeMajsoq3nBtYrJ5V3	359
12892	2vaAVKmfFyTqBjMAzn3iXk5cH6rGbRm6NvLXwBgghyozi7bnKRRo	359
12896	2vbybyfVrcvLC7Nvv2ZuNCpwBWY768KD3XY7viG8s8ZkPdYEFZwk	359
12905	2vbPK8zaofTD63xJgaFa7XSfnMuBGDaFetFQCUTKrYReiXNhfYpw	359
12910	2vc3A3AgCwQTSZrGvz6pYbUASYmx5pL4FUfEc2bw6W7w5cobuDKK	359
12914	2vab5E7xEFGb979gRUtLcSHbevLDiVseteZwZCr9iNFNyt2pZkhr	359
12915	2vb7oG6tMiorWd9LDSC2C97aGBxdhZpDdj2tExFBBVAfozJgbEQ1	359
12921	2vbz3aqcNJP5yLxaHfNrU1GMHAfLpdb8BEovVvGLzqtUZ7CGL9pk	359
12922	2vbjdCJY6tRHMo9iGXTHPE2cPVwv8BJcyfbC7n6epGANjmivu1J3	359
12927	2vaZkRdqoqfSG8RxSJR8y9cfKs6wwmQPKKngM21cCAJ61M1BesYp	359
12938	2vaw5er3UFRi1Sae4U82KmG4T2yiE3navpLrR7CrHFvyHCXdA7iD	359
12939	2vagwPANghp4ftzQFrqS18FZPbv3ePmrtYHe66zai8qHt6CfZey7	359
12946	2vasqRWWKuWj7Q8RKvLftKVq5K1gu5mooHQFrL6EcrJnKUcCcTuH	359
12951	2vabyu2gX6Fyy3VGG6wJGiFtrNaT7gDpauEZLZGmLstTB8AYfS39	359
12955	2vaZPWpTDWzDgAH7fGHC7DsuncfTuV4xwsStQjYYY2vgUDZEzg85	359
12960	2vbnsZue3prQ6PXBpZ33ZGGSmTssNJpL2tr1oqa1ntZ11NphHt1A	359
12964	2vadTfRTh1nAkk6AnexLAgAeUxkyfFWrzZCyUAzYpCw99EFuMoco	359
12970	2vbvzAqu8vEyHSeVmakjbgro5yWanrR9QD2iJK91XvhWDY4hg6Xn	359
12976	2varzpfLoUMJH19kWi6bfiWvS9J5HPMWsaaNGVgLFHsepy2kNKz7	359
12981	2vatUNYTzctEJ6A2sWVNpvma6torE9L17Q6cczBKgv9FyRNWULWV	359
12986	2vbo16w7TLnLMRM53xcWHiAa5WEUpJjF3Fm9spYNwt4JkF7UfYaS	359
12603	2vbMUND8fp8denxhHKgtiSyVjJ2Nb6H9w6bXvsAeBAYaxDHW4g2C	359
12606	2vc3HHd7bBsZNDCfq2T6cewxeDucnmEZFyMadVa2RVvJP7ScYfYg	359
12608	2vba94LYdSXHQYNdm233RfHVKxP2vWjzeb2WnEg4F7fg3qz2Eser	359
12612	2vaymysVvVsQDoF9kY9JzBmdQAiWc2Tn3mKEAhMLYyjbWeorUAH6	359
12615	2vbMHTFvR6gnBQdHK6iiM3mj1LZQvMbwufvBv1F8bcN3fKdGXhoZ	359
12616	2vbhNgZRLS1cgSUqgcbbxhvrW951oXFPPJpmRcvmXATD65Acg9T3	349
12621	2vc59ES5eSvWbJA9XAmkwWN55yLQTPL9fxufgbkshXRnTjk9WP6d	359
12624	2vburT7iPJpHZ4r1TZtFcF8p5RBQpjDTe8g4SjzEhZAeP5So27TJ	359
12626	2vaNgSvgLncyCAdwCwLMkVbaE3wHVMdrVxFu9GBeAGzogQ4rDZu7	359
12629	2vbhQai6jN8BKeG24L3ZyAY83MzxdZMMXGqG1Pt4PihpHDnJv6ZQ	359
12632	2vaEVFLW1At7YiwARBxkaghA5aupvDeEwAgjBKveNQAZh77fsFXT	359
12635	2vanFevfcMbQuEVyYkWVRvDUFcuF6mfW49yQbufjcqTz6nfQsPFn	359
12638	2vb2Xymy7dZgAroNR46dSujWYjzDfbn6pv2xXXy5zrZYXxBvyxyp	359
12640	2vbtEgRWZvds12PPgnZQK6qCarx82EKgyLf4MBfmQ9AkypQFwoss	359
12643	2vaw6WWRPuuktKc68VaiNnTeRVfwYxwe4MWQ1bzZeyuwwWb7Uzyz	359
12650	2vapXzS9L3qU6uHT4u1Ykr3UzVgjzawNHYZanM6aKj6KNFvJTCKm	359
12652	2vaXrVQgVCG2svXFEWuVKkcMe434kz8RHwsyd6Jjma9Ts2zPDSaj	359
12653	2vam8HwZLFj7QUJw7T6xXXKLUzCWCFY7ehoceNPnmn7t4DXjcjAN	359
12657	2vb6nZazT6GiYc4Gj7ZKgaVAJ2rPsxFpoocA8PRwWtNWwvjRZhtf	359
12661	2vbAAHzJPP8jQxFcrpczuGTUWGTpLBoHLbxkep3n5fT1xCmvpD1P	359
12665	2vc4r5FxXfLS9aFaFkz3V8V7T2VABKfK4V6oX5ivW5NNKSqFb4yP	359
12668	2vbWE5Dnxoh4tTFquFvmcXTpcCwGHTRdCmLG8tZ1Ris78GmKzwjc	359
12675	2vbpKuBh1CuQ2R88kLZBR8XnPSQwd9t8H5GjgdNGvCWD1niFafTa	359
12678	2vc236FeULTEgS7bViT7dMHraKkHNPoAmZMgkYfULWDTudbZs1NT	359
12681	2vbMpeXn6fPRRUMLZp1DHGBKrBNtgnwuBUucRTNUfR66y9kN8WHD	359
12684	2vbasiaYsx3t9x8kYhZpPu8VzjsxW6xitJe2vy7Q7vy1UzXnTrZQ	359
12690	2vbxiXuCC9AAdzJxmbadTxhfEQj7GMPKJkpipM715t95jAEon6ED	359
12695	2vc1CcMbt33vxUNhfuu6fAJUurzCX68sg27ru23kySMLNAd6z81e	359
12700	2vb5zEKDCGp1WJ45VkNh5fucQYT3ysKS72Bun23TjhubAGfRUe7j	359
12703	2vaVp6ECo68EPxoz1ddDrm36gUWHdDaSWoK3sn5DDZmsvALJ8xDT	359
12705	2vc5maUZDfnpvkCiiUTK2ZvZsVZCL4TEDrFhgh41skeaVom3u4Kx	359
12708	2vbrBXvs4uubEZzkDD6nMCmT5rwbBvVMMPYtFyrTPTUGsEyFhdXu	359
12711	2vbQBzkF24uMZL65UZFi7AK3xpL7Hp1gkz7zxB5s6cd9yRMu8b6B	359
12714	2vbgKocDBEbiZenhmMdwULNBNtNzdTLBqA6SXgEJQcKUt3zjMwzs	359
12716	2vbUTZNEaWP4zJwRPdrMv6Ve52PK9t9STR3nFA5UZhS236uTHBeQ	359
12718	2vbigUkqjjC4ZsncrX9kRnujJQ6JvaiHtouteuiQYAEfZ495oB4a	359
12721	2vai4M98MF8fd9qqMt3sfCddeBQrdBkUSxCreXCx4iTmuT7kbipE	359
12728	2vbWTAjBiUpHRgX5TGHc1yynn1di7MHSTFRjN4VxDVoNkxnoPNZP	359
12731	2vauENKBjoS3q2n5CADQJnL8rYvLgdS9wYveEFey1TDWRJCNxbvo	359
12737	2vaG5pEJ9ycYPd3pG4gPGj2ETBcPgtf6iCCAEuFqTqmaTekeanWi	359
12740	2vbdadBd5htoZN9QLftTWbttZxyj8JB2v6twwtnyGhMbKRu1vMvP	359
12743	2vbLAKRrn39BMXFrNyjeF1U1Ry7qXUYrcQBHJWH1jKFKGmseMTkV	359
12746	2vaiPwBuM6xzDgRQAgmSB7JkFm1K2bMo54WGoMc3dRhXQSPoGJct	359
12751	2vakswXnzDfXHwi34vVv7Qt2b853cgmzjEkerw1EsvyeLBVLNUu4	359
12754	2vbKNqNPCf86Kx4kV5MbzhdAxEFRczYDbek8xUDsvEPMWC32xWX1	359
12760	2vc29q9fSgb3P6KGgi5vfRZbALvKaYfCoufvhZtzCSjmkeCQHrdB	359
12764	2vadk83sn9P1RRVWs4wBM1E2xy8cnGuAxYFAVVNms2MAsuZhiuiu	359
12769	2vaZjmXSuEx6uYXZVXEZwa1Az1Xi3vWFGgSCRyPxLEExjPK2bgvx	359
12770	2vbXqGUcGke8ttnyXxAQHukTSxPHBMxwPhriFofGb4HyxgGmNVve	359
12774	2vajte6oHCf1s9tSKyJAt7zKrZWVFrfMapgDNry11dLz5utdWRaY	359
12778	2vaiKzZiX94EqLjfEVjLz9Q5TyAp6t7dFMvW3MPqJtu5BQqF9xch	359
12782	2vb68vzgG5NKXKkNZRB8E7EqFPfKP8oExNr1EVKjkJVwFidEVTAi	359
12785	2vb3m1iJ6ktHaV7XsShnnush3L5KaDFzZWtPfTpCjzVAaPTXTC4W	359
12787	2vbWqU7rNckHx8eLEaVnXs7XkcdkS9NpEdkWbtMbhpnXCzsTrS3u	359
12789	2vb5nabE2oy5DcraSYVFcpiyF9kEDbV491N3ng7U1NUfqZLe8PaM	359
12791	2vc5WNi6nyenfixh6GC9RS7m2XyESHpstviwohj1DtqTpMCkUzgZ	359
12793	2vbfjUAiRsE5LpEN7indAY5W5VrxbNDLJeq2mZh2ayyA3TBXKYcf	359
12798	2vb2Vj8KDoceAWGBvFJrDAM2ufawbcsof1X117gnfSkutsxrADPS	359
12806	2vc3ts4qbCkMD81BKbxZN5g6g5XSqtM38gZXoddxqkVkdXwrkkD6	359
12810	2vb2T2ZafF7UnYQdZtB2AG3e9Ps1CErNqJNiq4nBxZAms45uYEJF	359
12813	2vbzXR4tgF3rggkKfd28ZAAtKBJdMnV9t87FGfiTCC58sfphkQRm	359
12816	2vaKkRocjQuDBkwKQxVcA7eEaTXAZRG64heeW45mBPGK5PfytHQg	359
12819	2vbBHGBoGswgfBKERWJ8CWWY6mZQyvTmVTTXRjN6ZUSuy73qCk1r	359
12824	2vaGrcq3dCghU2bgqzm4NFiQcujmxr7bcUEWFbWgJfUid4CLqECx	359
12832	2vaaYDSdL1CwaphQ7kjHjXGAfoJPSHwMMXu5adiVUKY7R6kTJfNB	359
12835	2vbCC8YCEsSMwDViU9zsjY48drjFqTtTu8cnZLJ3YLeqsT8j6Ws9	359
12841	2vb8w7cMtiasjHqKMk83NnoDN3KN7VhskExBicE3n1GYzrKjSRER	359
12842	2vc1LpUEELYLHh4oN5WjAoB7HQz8YqDQF9RkrbXrGiw8Tg2QnVkz	359
12846	2vb7Zb4DuWVHsY7XBF4ThezYchbqcnMhsUAueEzZHSR64Zu6SPjP	359
12852	2vacgoYoZ86ZYy9VRyEevkNL8LyLh2ntiENn2PWPSqdzuR49HEts	359
12853	2vbKLbjTsWxWAYk3aaPsAwAqTn5LjDqh4Ejp6VMMzwdyRyvsmxdR	359
12859	2vbTTJvnY6ReDbNcdhVLLAQwpDzhk1nGYu7ibZfmoMt1x6DYR7AZ	359
12864	2vbBm8nHqKc1bBpcTbkBFjunfPPUP6N1ruEvRym6SrG3W6Nsyx7h	359
12868	2vb3LJDdBvi58iaSNHmWsdqS6pwUGRuo47WvVPB3zz8uqpq6yAA5	359
12873	2vaNFt96VqtaA2Vn75iSa74ysSMGjpaYuhpi5gmLrsUVpEz4Qfoo	359
12877	2vbgVWb4a1mgZ5bwyyGSi27t36ofRFMDS9ZLvuEDZrGcmNNVNYxm	359
12886	2vatJWUKmJJbqo86u7dXYWNeFc5MNjCjVYV5FGSxwu5gNaBBb9CV	359
12891	2vc5WkQemjiZ6SQ9f2ZBY2w4pM3ShytkbC4Ao1HYdSt3NQNTNCkW	359
12895	2vaJXUaX3kX3UXBtBE2KBGuzPUQCVrLdYAX9sZapvNPXQsVavKcu	359
12899	2vbUK4KJv3nTfFEC1a3NwidhwRiL5Fcf6NxUta2pNzHLz3f3bfks	359
12903	2vanka5NfYyGgtVpT4PrNpapZauQnxaAmKKWcQf5vbfu9gxjMVVr	359
12904	2vbi6sKqGcvrRbrPB4yupFhpuA7TgjcwJaKgV3hjEEQtHrZJUKMR	359
12909	2vaYYSkxFCUs2JYvGjcRNa9VjRoXgXG93siNatFAgfQFkqYyLZMs	359
12912	2vae5ADMdvfSb2adksW9rUpJefkZhZJoGytByA4i8qB2whUAvKuW	359
12913	2vawLsXfaoZhBhF6E4B8AMNtackJbQJRATV6B4VSnVf8JzxU1kqC	359
12918	2vbBE19Dk5pqssmdkjqpKevFZxJoiseaBp3vvQgmexxtYz8sFKR2	359
12919	2vaUTqukiJGxBcaV4gW1zeV7Twp8Gx75zNUUejapuFLKasSZwftu	359
12920	2vaEPjeVMwzAv2UG3BVSadqpdCXn4VZa8goVR7PJbPqrQwkmhg8V	359
12925	2vb1qodbusA8rqXCHf9zK9S4NAjRN7gAsKvAEbf6VxF5LzoDQ7ks	359
12936	2vax3i4HC4ujxsbq6JVx9WnRpgAEgg2GEqufjAjQmKK2zoraNDZe	359
12941	2vbWRPM6frpAPZuEP9evgu7u1Xa9hS4j2Pv5dcg7r4vYEoMc4iRY	359
12942	2vbdrtRjwhyufmqtCcY8m9gvJAjgrHAo6MQZXNaJFPN7ikLodb8o	359
12948	2vc5dr1Czeo84TLbpVGLn8LTW5djnQ9s8R33KsTXE7sgee26DeVD	359
12953	2vbnuDo4NgasWWPMsC8Do8Epx7ciPYqahbHba946Y5nqL8L8sMyA	359
12958	2vbN4UAcmrW96Jtaw3b5FkG7czL4e91ty3UidJccb8qPwR6deLEc	359
12962	2vbcV28zy1YiNepi4Erc7bg96zaGKGDR4TwN9jNRKnmHW5RFtk5Z	359
12963	2vaXwh6z1yjUQ8NA989yLEWSqYoeWMddsTpRuoYEKdUAnUwgrQWn	359
12966	2vaSuNGGUiSCCA8CpjVMT3KgANk1EYjRxNfNm6kwYXxGGj9oBtqZ	359
12968	2vbYJkp3ZKAixMiHoPVV4zya7E1VhA1fWjNU4gZYRCsy7WsvGSSK	359
12972	2vapyY3rHRvU71vP6f7GaKrcxcAvHYP297StQUpm2wgGzUHuuqqP	359
12973	2vbJcFUXEPdrKwkq8q6vUjhEieFfR6RpEWxSwEdMoPf56XVF79tB	359
12978	2vbFbbudTUM5Qj9XJVJFbTNXwctJgocCmZJkjKAfZci1XTn2wo81	359
12979	2vbX9zhrL2MeaiSXT3DbyVJtuZmdXG1enBfdF48B3JRqAGbKL48e	359
12983	2vavVsXPUgPs63KXHtpMxPeb914g8JAs2fPZ9y78te2ESapVMmr4	359
12988	2vaWtWBYQYukN63Eap4J14uMX2VPySBZTiYYRWCU591DcuUQAjuR	359
12989	2vc4ZWcdNc4wWfAV6AkSbP1y3zZKDD1DynGZLEcqe1kiaeLwxYJ2	359
12994	2vboRKusHqCc3aJXN8LSPJ8njt8o7aPsrePDnYwXBGLBoQNXWyoZ	359
13000	2vars1ST4rBsVgCshQqVMyZEC3ABWeYqa258m5gUor7gthat2JVD	359
13003	2vaHSG6wfpy1CuLJ3C2sFF9yo8yaRShXgFi9tHXAJD2hCBK9pYKY	359
13004	2vboi5cJstWCM87KW6vzJDeLbsUiCmGoapximSbAr1Sm8wvJN2D3	359
13005	2vaVG6jovDkeksHidS4iaMJdL7JumTWLM9BHLMTFE8Umusor8RSo	359
13009	2vbHjdNKh9o4WcWHFgNTgSo7ff7z9LoWbY1hAhLPgrHNuAZjDZN6	359
13014	2vc2EHuUn2LvstUCJkfL6Br4AeCM7K4FqzJ7dEgbHLfefEmks261	359
13018	2vbwEj5vgAVVyu1RqGJ4YTkkKkkfnUzGdCRfpAPXJgk8mSz3cFtN	359
13019	2vaRX1PZdLS9ZPVievbhqv4SfB4AsVRizj2FNWqgFnrs2ruLCBUe	359
13024	2vbiRE384ZU9aWccsvEckyFUNiiJJ6X24ngHGpEZVkiPh5dXPyKY	359
13028	2vbeM5GbrnWzYh39FHRbTpGHZNEMyT2REsCBac8JeTpUYYSmXFHH	359
13029	2vah5YtBYSLEsfpqS44zf2rTJburbPzBLgfUV9JaaFMozGU8Mqkb	359
13034	2vbhopNNXQCSxrx8KLzE68siwadY3tgWZaYgxZqqky1Q3PnSEZr8	359
13040	2vaFrC4kGpMB98SCQSHQvVgGNoWWkdog5MPhHCrnXyNqvYHdgpF8	359
13043	2vbvwTYJZxnNgsfrnwzTaD6SggrZcTAqQ8AXwm4wtAVQErc8UXkH	359
13049	2vbZxoMHE74sRckjjgYokWvG9s4ZzMoMipzavGdq56gDr3KCWbrn	359
13053	2vafRwx8Z1tgijKpazWxB4zXdvdBcEksvY3JdYDVKrvVyghDfQ3F	359
13058	2vbM1c683CPnr2AhsnNspCTpaFES5zPfLBzpKjJgpaKCGxxySCFo	359
13062	2vbLPUsNEvd9dvFGbV27Ag9nd2dNEqibjwrQGSTEYLy3CnWC1kQb	359
13067	2vaqqJFu3AKtELBGBncYX5hBafTVFMajo5TWaCADhiSVc9NhBRWr	359
13069	2vatBskLssDUFH5TwBPam6CfrQfnMTXC8uwWs2kHJWpttJhY9Q7o	359
13070	2vbLJGRdALmp8M426JhKQnajjmLebf149j6UhYrCSgQmc7cT6YzX	359
13076	2vbp6XAMgKF2kAdYF9JurYAeD5zPDhUGfMkTVLLEMLutygbSo2jU	359
13081	2vb8Xt7438z1BxiBmGnJp5kbBhkWkYSD9RzZaE7UZpMh7wzEDNyq	359
13082	2vbgkmbSxBzMbF37LqUncarBTou47sSquiuNwt1Phpi4ndHHAac8	359
13095	2vbubMpYTPnVNJt4EhFvnk84gzNPdWcUqjbJcEokWkPGFMxziMPn	359
13100	2vb9HqRXySozLZVZagKTib3BEGRi2bPHdRsQStH6MzX1N21yoiEP	359
13104	2vaisY7GZzSqBAMuo4VBk6fbCzX6WjcxGx6sk4npiLkM2xjNmWB3	359
13107	2vaghLTU5pBVxvVqc2CQcYhTX1Vf3AHanfpHzifwKrWEgTN55p7j	359
13108	2vbriVtrHyABRLibgqfEGdwtcL9An2NUgKkzsG7mJQWusbnTfzCQ	359
13109	2vbsvdXMzBPgnK8Wv4m17bTQawf8mnMpfGSyh1rBRCsos65tFhNi	359
13110	2vaC7xAdeg6nPLYdKTmuwF6v1bqrpWkP4BFziX8x3TpL4kKxowAm	359
13113	2vaDv1uUtJitc5Y1KaUU8xQpTxGjpZ9yGkucoUokh438WVwNcqUk	359
13125	2vbX9gkn6eLgAAVWLK6LgE9QfR83aqkYySXGvxx5iyZepqQGbJTS	359
13133	2vacSf1sqZj7afKyiqzJ9QFBe9n9GWJr7CjfMEsc8kHbbpmQdMT1	359
13136	2vbF9mENMUYunTG6nz18vmAvqeQwrrNi6WY15ec2D1jew6yHnpZu	359
13140	2vaBhsspnFcKE63CdzoGiXvRtDNtZypLNDq4iejb8Ys3oW6XGGKi	359
13143	2vaGvXoJJ7YxqrniSxSnS5oJ8y68yBvDihCzYeg22e6sjDMTC6Cx	359
13144	2vaLQu7GjwMSD6sGogdgWjFFpZVtTRV249oRR9C1f4JsE94cdhvu	359
13147	2vboaADDEn9AEn61iZXk6AxziELDhFpmcoauavx4eie7WXqWL2KS	359
13152	2vawLLdT5RXX7WyVLSaCHbJQiuHGeomhT6ui3SW3Mu6yMLagPQKA	359
13159	2vaw95GipC6D4Qp2qACMT6iXiHEfGBZwY2zFreJmmJRTVaKFiA5v	359
13162	2vakRHnzd2YqtToR3xwma35KQSipHbNDBHKALiJfMo9GWt1ELn5b	359
13164	2vbbukXjAD3gNse3cUmfaqbHFR1Mf4tuNioTf34zEFtWWc5EZxdb	359
13166	2vbe47yuThBTn4VAvwuJ9pw85t3dae8Lu9GYQUA5ScytBcwx1E6Z	359
13169	2vbvm3bzZfNx8dTgamGrjCSrU7C93PLzorkbXQaWQNJXx3qGeysJ	359
13173	2vaVEP9hrhbK7VSD1mX8d7Ssn1TfyRxMtJbY883W6X2FeneNngiD	359
13175	2vaHkTznF7DLHs5AFHuybK7N1sCXDSUeRpvcFZfvkxFNfdLiodPv	359
13177	2vaV3F4wHb89kj5qFaynYHR4ChKXfavMTH75sEm7TZWJPUbeGhBB	359
13182	2vaGeTe8Q83XiqNAcqzFDBdzktdCKNYqLbbUSLY9bPRuxtnDLa2a	359
13185	2vb37HK1qCmapcD1ddEccQyoFckVtTxRakpz7qaAiU8mHfEgjP4A	359
13192	2vbHoGRGhy8tahfEYSKGx43F4Lmsxnz5HfCjwTqnB4bed824MxmW	359
13193	2vbpKV8YCHT7jSac6kYpbnQVbrTRB9KgQqXfptVaB52kCrb3vNyZ	359
13205	2vbeWvtjpXUR3KVbkZ6cg6L4ipWMmUFaRXwFnE6fSz8vhdNg1ykj	359
13207	2vaNhjuG6UgHkntfKLKa22ct5j7H1LraBh8ThaxRD7MiJkt2XAL5	359
13211	2vbwubqvTcrYwwvTGQQ2ZLCkAsiZVZCLUyBRBRubgaaGsMuQ1gYA	359
13212	2vbcaa6ZsBojWCBmmWMAZmHAG3tBAWzDstKRfNPDRr6xzJyHqZB2	359
13213	2vc4doWymrpC1yA7e2RJSJxbWqdBuHVvSag1TkqAuKwzvPEhMq84	359
13215	2vbnsLTdyaU32gyyj8VqyZFQ9RmhGZyhGMpznze6ppEJiuw8k4hM	359
13221	2vaFjz1cJuDwygmJr3hDQ16469yDieU2uKsoJsMcfzPpM9BetpxU	359
13225	2vaAp8Yr7Q6Wmgs59UBbQ3qFtSdSJvZ7eVytmnLV7jAEKSjikCNR	359
13227	2vbhXkWanZouNrYhXdQnLmyhoHuA7eHLg8z7cWEpsBETwengLAuJ	359
13232	2vaAkNVMvQUGfraXQjUz5DN1pKzcK649Q9kDsDLa6FS79wL2f7HS	359
13234	2vc4t7RkzfYkk8yRM1uvLacQPK9VgdNTytXBhwVryE99tkrLQJRw	359
13237	2vbietGVStRguSkuS93iHpgfprh1GNqah2QoTGsmyfDCBQykBEVk	359
13240	2vc5oG79qhV7BM1hw2C9H73Q491t73JQrizjx75KaaZwjJ2yEw8t	359
13246	2vapXfooepa5nXBVWFHEpyUPUboyHSL6Cm2WFfBfTzG6B7unQRZj	359
13248	2vbkzWwrj4JVNaLt8UADyTF6VmoxPBvMHCPZuEpSfQdGEqVXyo51	359
13257	2vbXmzLZKcEoWxMXd2TDcdiWaKacYJVvBL1CJbeaPFCyhW6PsJ6a	359
13258	2vbQXipztqCD753cMGhV13u3SRdbZof3paNj5UKnsnvVLoYsTkgJ	359
12926	2vaZL2Tfw43n5xFKXhn8qWJ1NRefGEZpCfbZHpJ2ybyuvN39PUJ9	359
12937	2vbFxo6iTyFVxzPiKzohqDkKhc4JoxYMzRsdP12VwnF2m2jgCY3M	359
12943	2vbKJoTFxprHb7S4FAfYqjKZUk12mgTrBroeb2oRHCrvo8MLs4rw	359
12944	2vaVZCrtKW2EYPFyia4CgbGuxM9PSr1iu6k1edtm4T2j9Zfp9wA5	359
12945	2vaDCB5HPbWRNgQGMS1gtN61A4S1ws5MosYBifmH7K2KVUYGafBp	359
12949	2vbPxMfCuKBbPFMm7s79yC9XXQdJWALbxJ6Acq9XcBvm9hGEd16s	359
12950	2vbZ7RD5j2srTjep8AcuB7jwkh721kba5HusZrX3mJKy86xsZ5cr	359
12954	2vbdUpmCB6jrXnqYH2Fcm7BtGacJRMcaUmfVvQxa4Wv7DEcKPcFP	359
12959	2vc5WWWVqBDSgr6ywpL6ELiaUAdaB7QbhPY8yR6FNwFvfJKmxSUf	359
12969	2vad8AzyhzMknGjKXn4MNYRZv7ZLWodrktggep5GCqyTpxgTxQUo	359
12974	2vbeEUoE9wPL4VzzFsYeXyHXVsjEJ1XzXx2Lr3cHktxicY7sDqhx	359
12975	2vbQkrBih9koC6APap6WCHfthnCVn3iU11p2XkdWJD5CDGac5S2d	359
12980	2vb4Qmahr8b5Kbr6eqwcq5TUu65qthFv6PbweeE9WzGWWHYnTu6H	359
12984	2vbmFLibh9dLYSSX3eAEJejQEmi1SFKUJdbabzft7DU7XhMU4s4A	359
12985	2vaBMZMYdVimMZpqdbm7b5KSiG23GpLTyqeQFWrWkyi2K6XRr2c7	359
12990	2vbR4jEXrMmsPU9xJ2H6yKdtdLqf92ukJGe2m9wjRQiMo846uG2n	359
12991	2vauH35bcBf661i3xgtLrWxqGdyEULfyhzT9U6MyF6EVfXcxtkx8	359
12995	2van6sprzHoTA51TGRg721JDkJDyNQXtbUhUTMM46nSTiekhND9K	359
13001	2vbNGvgj2cJP9sRFLTZ2cn8FaoKfL1xWQxJKEPk1rqp3mgkHHGCc	359
13006	2vaVNPGUe62GMta53pa6eTvFGUWAZXD5PV7MycfUni1Krf8JkF4R	359
13010	2vajZqSbU1UJkdwGF4wEEZk1b6hZQSbBNZRAQWNbio6y4FQZYytu	359
13015	2vau7ZQM2qbdF2FuQQGHKJAsWBVGrdpXiRbdt2zJwXfRmWqEzeMD	359
13020	2vahYn1Hj8bqLbq9fTaMmsUchjA8Yqqrh9rEDDqJrKqRMNnVFtvP	359
13030	2vbPPjxDM8tYGdQCkeV2NTqR7BPxq9M7rt25d3MMkChrEaknfobc	359
13035	2vbwaZYH1khFeL2fC7bXyN4qCDSTq3hynwt2kdotinkhGuiZaGkk	359
13036	2vbF2BP1jJHod88tepE6kiAuyo1pbDLeQJfJukTgXSj1GChyUeqS	359
13041	2vbx4GWEJY717tLZxU3FKXdMtVTEzUWErQs29LdbVbTzD9EmH59C	359
13042	2vbdSrAUyBN1BNnyvoR65vDEUSeDDY6ca7H49veqWGeT1CK2jkZf	359
13047	2vaekvgUUqhA7H2evHHprxt2SZHgFaZHqhKkbAqts2m3cGmX1rdM	359
13048	2vaUXZ4ANMBVzYK8DKG9g5jUL46MNhytzBBehwokgqMiweuGJQTp	359
13052	2vbaKxDgzdUYrk3YA6R1ceR9Rgh6hxkhJyTT3zsiFiTx4dWae8Xr	359
13057	2vagwCHm7nqM1x4JamGDNYKTr1uD9Ku622Ao6HUrVJLoADCUp1Zf	359
13061	2vao9YYtaNPEQcLpbsemNMMj9oByjuXSGmw463wBnsJJ5yqtXaYY	359
13066	2vbrHyiVe3HJScA4YuxB1QEtdhrRza4RiK42Mcah9UcqRkLhiEn6	359
13075	2vbyWnf6hSH1cuWtRkcf21gGSCPA6iLH4hzjbCkTAu9UZsgLxKHR	359
13080	2vb89v7DihGbcnRLYUHjidWdjaQotZdNh7ghuhtY8mdNtWYABEfz	359
13086	2vaRU7UQNEVGyp51AofcQrz8L3TcbwurzcDBsovc3TPwEft2A8CU	359
13087	2vbgrte6JjtZtCZBuXWkyCedscWr9Hy1kQ58yvM6TzRhbxAWFtcT	359
13091	2vb6ikv8efLuyKiP7RRZppRXVSSDvuRASDQ7cYmjtHDmngt8xYwX	359
13092	2vaYsrRocmjLDPYAoNcDF5bt7nUi5b8Pa2c8TyNFRUUvPic3eXeP	359
13093	2vbEPUn1dMND96J2bx5Rxtr5vKba1ydwJJEgqRmFDPQ2uG9wNp4L	359
13094	2vau6GthDpVjGvV7iHzhQHbjL8v3ijX3xsQF78yy4jWXVJMEzPcr	359
13098	2vb3Cz1sqxSfumosYpDS172txaFDr9EAXnSFYPx4sui8KMhHvPQU	359
13099	2vbxAMnBN5QWV2n1deLrVaGeMpr1H1dLHmY78Rd6buEJ43YxFSt4	359
13102	2vbcfKqCTDzEHaYoBxeH4Qx2u4BRuKxZPPrmQfLAcN2693uCVgTS	359
13103	2vbRLiTr9fBHKSCM6JGJ9NjdPh36jHV8NY19SPWYEHG3CNg2YaTh	359
13112	2vc2ZDZi2cvfwUTP8CB2dVPYSiP2g9SzukybhisGSuxgFSeYUHcK	359
13114	2vaaAfyiZ2MFTUv7pJHsUMVZaUjZsqKdSMZZkurW1hzniA81mhcX	359
13117	2vaQipiCABCwAeev3jMhHedF1HDCYDWZUR7K5w2YZGYAKAFLfvwD	359
13121	2vaHTKDVJXPty4edMG93Rw7kbCTbLf49DTkSBmp9W1RXCxuj9PAB	359
13123	2vb1LELG749oiM7pHZjgmvw9m1i7tatn3UT2uA66Mi4vruqsrvDe	359
13127	2vahKkKid95LFNQtRvsp3oooZJoQ5Mbg3mBQLRroH9H4bs35ujQ7	359
13132	2vbYyV7M9wo2gouguDRYEN7LXDvJrouQEAPLRxLqJLh6CbuFEa9Q	359
13135	2vbg3ShUQere6nzgNpBj35o64Fu6mCjAoVGPHenj4CCcoFiEm2ZK	359
13138	2vaznSSWuxh7QQyR6SKqvTVy6gpNsinsZSUNYJ55xTRjGGCytSt2	359
13139	2vb1MgEJ8hyD9p3wqQAszLHSxWpoQzYRvRuvhE5z8Wp694rpuLvA	359
13141	2vaCg6FgzDKpTr9kNkmmiPdwcSCuhd2vUqFrZkVP2s4LFjkba3PS	359
13146	2vboeN4UEb4WVAs1Z9XbLdYXKGdoSicHkkKuZVFvPhTFnP8f78tb	359
13149	2vaUZS4ajwvKm7ziHwC9cekXXUnWw8b52zaoBzxPh1c42yxZc957	359
13154	2vc4t8ciDBwMbcpdR7Btb7JDStJkGqdPFJFouMaiixRY7KbQiU1W	359
13156	2vaBDZSEF1y71T68BzqHr5XpUGsGvjXxQK736pxWtXYEW5zeP4LU	359
13163	2vbFRHPDkFTsiuVHtAZ3KjR37kteXHX3DwRPwsSCefWLtRUUyamY	359
13184	2vb6sKLV2AzRGo3V9jkJRsKBUERvjHoqJk4wXg54BC27mEvHP2MP	359
13189	2vbK88DpR4KBkHABhr7rt5BFyJGErFXq9YmwBTQwLzwTTszvnfSY	359
13191	2vayexFUqAGb6dGVDHoSegGgwcWQ46Y59GRTfrBQn1N9skfJ5FnB	359
13195	2vaTQkBK1Z2KNJWJKGWBUop4jNBLN763YG2iajWW8pwMbK69hSro	359
13198	2vbLUhrYVtFXVmZMgp7SoUtyL8LBCUJtRJF4aQRk7vBFzdCQ9aVR	359
13200	2vbb6VSzHe5MNjnLRv3YNUaRtUyaP9TKfBpNdX9MFLUtMKsnq64W	359
13202	2vaVbaFjL6y4fboJnZ7rKsVsygqN1TSg57vWpXerVf1YQwDdaBDZ	359
13204	2vbj85roKXLtYjvVAzrZL4CHK3vGgKsdc6yH1wP8ExEySXN4wRBY	359
13209	2vbru1Q2JjSG5xAn937ywaUWHmTgRKXeZj8VjdtYPbcJ82Eqm8Ra	359
13214	2vc3GcBp4jyXJA2y6RmsnvR66ehzLDYNEvGPopRApLMzPtyoSi1N	359
13218	2vbFvuPTnadmXqJ3JmToyyj8yUUCLr4XofXpM2uPWUvn8hvRY4Xd	359
13224	2vbPQS4GNjYhyxTfPiHzc9tU8RPcNAhknVF9Qs22rDRi6NwuCATK	359
13229	2vbUoK64HY17HGxCHds2LM9WM5wapNzzyPnxthrZPtBc6gbdNxLs	359
13231	2vbWwpm9K2eJFLhfSKnwEoG72o6HFZo8pimaAkEneHFW5ebtdx5v	359
13239	2vbdNR9q9NQZ9UGKEkZwxgatQfhDHvxPQ4abqqixiwMGcYexJVQX	359
13241	2vbkBWbATKyZJdVX7CHdnsJnUMtdjmUzxJRv1WmT7KPCPm1uxMTw	359
13244	2vaTzQ5GWnJPR7RTp1TwpkCC8zdnkpjbNQ64Weph4m89wykErdsv	359
13255	2vaSibnVFYsjVjPzfPpremweTc2jb5x4x9Q4HoxTDbdzqH8Sm8rm	359
13261	2vb2yNZ45FY1xqiMeTmEZWK4uDcVR9HvwmxDdmBHFHpwH6X8Eqvx	359
13264	2vbjE9DAmAwk5jPD3hhf6bU3TtgG9GmzgwstJFAD6uNEu7SQkHwN	359
13266	2vbngvqQiftKye95p3Wh6BNiVRZ9vV7zL9cjU71QQzwETjPtzkmH	359
13271	2vaieuWgQKp21SR3rNyJ16Q4ZTNUGLdv2acLPDDynWKN3c4Ez3VA	359
13273	2vbmCDAecQ3wb5RvMotSzi71YB1fs9uS8zSABCq8M2FwkU8FTSKT	359
13275	2vai1CDH6sVSg19cPfeC5TvQrFUEskjgudZHBms2p4zeupXLD9ss	359
13278	2vayrzBWJEqTawVXpdLQsHabZcPGcLnq7BcCLngSXwPqUXmwE2ZD	359
13284	2vbuUYTRZBXH9BX9zgSmhHR16pUFeM9R9LqtTuxPNyzyTqLtSosQ	359
12952	2vbErXBNdPPS8pnCYkoCsi34EtKGkgo3g8xh7Ui26od4H7S4Tua5	359
12956	2vb6NW8AGwZQQa5VuSNsHy54U9WXwYktcqNZZJs8c2ny6nHnD8Ed	359
12957	2vbpYBdy8nkmjdiWqECS1qjQGedzenrutSHJmsn4gvd3RXLXXsvZ	359
12961	2vaNXFZtm1U79up5tN7FREJDuRxPjjcXJG8M6CMnP7gFGaJh3RZT	359
12965	2vbHe6RZo8BqeKbGPBUsG1HjvdHsBy35eR69Jk3SsaBMFNxufGKG	359
12967	2vaH8Dza6YXYKzLhVqRYEgtEt4xazWL4pdYBtfrv4zhTqKjgkyM7	359
12971	2vaRrBPRZF5AH8ue3oD9M8LCasMYvcUitkN9wFLvNVLsE5ZoLQX6	359
12977	2vbiB89LV8AbwnuUwQNw7DVGPgF8y2yySMrGevVF8gvdPreVw8fe	359
12982	2vbdbRXWfocHMz9sYVFH46RJzF1XS6W1v1DFbaUWtN8Z9eMDaT1U	359
12987	2vbtNvTMchbKbNArD7mQQfhyyuTVP63mSAqct88WEysibKptM8Tw	359
12992	2vazr6Vhc1Y85fc2dYaZdYzimoCAPhnwYB64WYn3ScG4w7aFHc5T	359
12993	2vavqx4H5fe31ov23pi9qDEcnm3UpWn9GbCAKRKgq9d3FoyHizpi	359
12997	2vbPoUDXLkzyjQeqnbBM89f9y97imUWXxr8HkQKuoLWUZTPdcWL5	359
12998	2vbEtLSbxiJ598paCL48ydpHDdj7EVHdDaeiLdZaeNjV7gZWiSXr	359
12999	2vbveAiznbguR2qiUAVoVfGr6NvzbqMUT6fAUa5UXDQWP9M76egS	359
13002	2vc4WqWD1iU28tpN3WgY6WmDpgMHi3kVDPQVFJbhE6qnWyNG5Wub	359
13008	2vbncPXNxgxRQwCmPWNzu3oquwhGPZEnEZcvERzncbvAKuxqefwk	359
13013	2var8TkuFjA6GTa3UWPes8mG6at7NsyYiEZg2qaWDyRMa96UcnU3	359
13017	2vaWbojar8jgQQpySDe6wMqjMSK7GJyzWt2jVLCF1p7mPgeq8ZJ2	359
13022	2vb8iwEYmERf92UWQ6XeL1wssNu6dvrmtStE4fnWH78tkshU96up	359
13023	2vb8ffupCi8v9x1sAvgdBvPsoUMiCUU2yVqm1bKz4H62mNQE69GV	359
13026	2vbJjXzuMdAxTzQXBzZ6eo6nY4ruZH26arir7JpivgeCuU7wTX1h	359
13027	2vadS18c5YgWetexoToRXd4HoxPTxBh4ZW4Mi13BLaaweXgvAuDF	359
13032	2vc5Tt7PoKUaUZL9m3TQjLnkWoqYtHGjL16Hkt3fiQkPejCzRifJ	359
13033	2vbzfxc8igNUZmK7URna9gDcJXHxAuKuLNe6ryaS2dZjFLcEzVUq	359
13039	2vbGh89TCLpgAahBRjFYgGrocEG541TyQtQe7pSnoi7M8vtDNcr8	359
13044	2vaFPgcYG8BSpcbMi9KCfEEtQ23AgVZ5mfVTRFPFb9q1THkeXdrx	359
13045	2vbxR2cowraYdYdwVNzBYwgx3cTFuPwe72xhAtkawgEe8vjtmUWZ	359
13054	2vbLB7PnEJSrTFri77Yt2SKtn6AX3URPd7bs5sh92k4fffuhJxiF	359
13059	2vabNffXmndLRGUUT5uxkTkmXneemSZTSB9Ny2vKZUCKSApGSn2n	359
13063	2vaGWa7TNQAq9fvpv9Xcy85qUJtCwKa62bPKPRd36oXxQqUC75Hk	359
13068	2vau5CJ8kwzVK1B3mpzDkCHU3QRejvcMh8EAVwJjtj4cNxyNUv1o	359
13071	2vbLdpg5jt5VS1pYLjySX61UGiuBcCXA11oWivxB58h228HsQzDe	359
13072	2vbBt35yS3NHMm7EoqRu9YUNrzfhx8Es5FTmGmmnvPZx5vxwQigr	359
13073	2vbe2tiD6oXEzL36feuBFoiYEXdGpoQEBfR9w75MDUdhkr8GymSn	359
13077	2vbkMGC7Q7qT81p9LYK3fnomY7p6URXFv83vhmAATtVYdzkRWPZC	359
13083	2vaaZzzwCR5h9X4hxt6YTJPtHczmPEViEtuukZKZJyDnjK19kwdx	359
13088	2vacwbYXfrmz5AfnJ6sjuNfPfpTWJuPEZMi5u6GAxSFv2YWY5kwc	359
13089	2vbCemkNig8gLMe6TQzGTPDHC8zj2zz6DQAVubWQTmuGHKuAiBsM	359
13096	2vauXzuKcpqt9o22FgucSMaA2fbuz1byMLDxSjyeefgeRt7PtARe	359
13097	2vaj1zUUG18JPQXyycQbsPpUMvWWxhvnpmuWpDyYNBfkacLNPxe5	359
13101	2vbDv37jja1JXGQroJCPpjDquGnwsQRhWgZqq12qhHEPYU88Rykm	359
13105	2vbFDYkZ3vVugAQ2iRqP3BU62UWGnJLSJxhFsyw7cxNMkCGxRKtD	359
13118	2vc2dgGBQhVWa98usFusunprowjtiq5iRZstMESzEm36dUsi7CwA	359
13122	2vaEzAvCNvibcZHJ9LKpgWX1qhXrUP21ny8jbqMicvRJkqxuksrY	359
13128	2vbiRBZ9ZRw7crLmyuicSw136kFG57tCB1uLqhF9kL4NzMSK4MVG	359
13130	2vbm2h6QiuWn4Vh5udWiBDKLbYSApSAHQJFQeKTs2MyynpHehPgh	359
13134	2vc14iXp37zdNjSw4ofmZD5c1ugCyVLWAnYJmVo4tNyVkC651opu	359
13137	2vbabAMhiaTfo1u4V9E8ZUNRiTaWB4jZ5edmkTeA5MiMC5VKfggB	359
13142	2vaFmve4XdGWUhsEDWtHZj8e8KNDArwkzubXmqGfpfDRDgWhcB3h	359
13148	2vbDsxT9K2PAA1gXDe8hc1ULFQZeFrXvGhvUiEbf8ZuFANkWPR2n	359
13150	2vacfBzb16r3YhU6F4wLgRZ4QicjUHYN7LjqpwhpNJRrQg76bFkr	359
13155	2vbVB8kzLBur8mm7WhU5ovwLi5Nn9CDwMExpTBkMJPVniGKZBwvj	359
13157	2vaWEQ61SQ4SzuJKm8FWUH5Bd44DeFtEvDRwbHZtPe6oHppkdAzM	359
13160	2vbANeGAnLYMim5NBuf8fBDb4TDDmwYvPtHLio73XrkRuu9Gvtyw	359
13165	2vaojdNoMRsTU7vnAcTpPaYRqGJKZjF3TU6xowxRXYYVXvsHzmy1	359
13167	2va9LvyA72633dteoYo1N5j4g6WUCwedyqyc79ynVW5TWC6H7ciJ	359
13171	2vbXAuCpevDUnHPmY2VWCQutWjQZL1TLz8gEYgD1cjkvgbbAwvyo	359
13174	2vbs5gaV7tyGCkWmPVsadXqbC3iRSvhvEys2SKtEE4V5468JL6e2	359
13176	2vbeGEGWariko8kEcq5ZyXAxa1Gc4e1tLFW4amD48dWNeEQYL9Xi	359
13178	2vbqxCRMNeA9t8N8uRTJhmPYXKN9TqkdCEALF86iKYJa7QmmY4sH	359
13180	2vbgqqTMy7odviW7GaPRZFcajtXNwBSo1Sj4nty6TDbH6NVkJjAM	359
13183	2vbSPogyHcBiUAJgoxapDsJ3v4dDaPdjm81N35U7T13bd1YEdEUC	359
13186	2vaMWe9HycEQrRhVt18Te5gFJn3erRWY45B9m1Z3gKSMc7t31F9h	359
13187	2vbJsqFxHLVTMgG7TaMbduaYuaVPjFer9LJPNanC1ZZ7PJ54SKgd	359
13190	2vbCit17hCS5qstAG5eK4SHXg1o469xx3hywtbvGn6ZH45TryQX9	359
13196	2vbMZVrnnNb7SUWcezvEzRdWNGe2Rn4fzCWASfSAuDFwzrpM9fiq	359
13203	2vc16Sbj3DHAfTYZGbnbxUmrPNTzkFHpveBXWetTkYLyftBE19wC	359
13208	2vazMwzX42kXdX5FRXjybw1xpfgXnfFo7B1qiKx7sZMSfRGJur7b	359
13216	2vaQNWNxVkDKvSKjp4U8LHiT15BezTMZjVGUCRPLiSoTL2BBfMwA	359
13219	2vc4BbY8gtcgCVHqYsZoB8ZXwYyNM6E71ZCDumYtMryTemtmnEb3	359
13222	2vbGomxMtV1SjQCiTQsC68JeBqKbJzGmz9ayEL1fBa8QyRQJKhkh	359
13226	2vbeBpjhm5cdPkAK1YRRZ3ouawZFpV5Dtdr3mhD3K3VX6XXp1hci	359
13230	2vaqXc7R16HciSen19GjdoG6W435iwxMJgMSGp9Ncto8zbZqVoTN	359
13238	2vc4L1drEXstkytrRz99U18m7vcMxdtAA9P2hkXLHNsM8esS8Afy	359
13242	2vaXqxDnZCAZmpb1MJ7CWPUtNpiuZKZYLtLV8axJtjxT1wYMKwBo	359
13249	2vbbXqPhftgjn23KYsqKJez5AnmZmxtUFN91hvB1BYjKcN4ycn1B	359
13250	2var8nAsMppSqRHvWwWwVBxLxxb235MRXQ2f111Xhi4b7dwqcv9X	359
13253	2vbzHpFrXnMTJgKP8ZXVpebTHmQuLTpePZFUAeH588Wew2GAUSfp	359
13254	2vaM8EkadtnB1RqwJSpWLMX52EXj6gLj2oqpvcpJ5hpDv7Ltjk47	359
13256	2vaZwSGef2oHMtxvGT8HPodCnS23NnnWgqsbqBZVFbnCQTmtY5zT	359
13259	2vaASQmvcP1VioYJ6MZbkEetNSPNb73de7oLvzZKh8465Zro4R72	359
13267	2vc2PnPG1F2DaaAVYu787mLnQMECHfASX9ADYCmTeYPp72n6yqEW	359
13268	2vaMAbHwc5cmP9GRN4PxfvGjreshvd7RHrNLUnLhMMejfxWkBvdC	359
13279	2vaaJ8EzaAYrCWoHUPszVfyLRQdivPzNRMi8SUKsBZkJeLL7CnUN	359
13290	2vaPRcsXGFtXJqXPhUDM4U1uFBZXkyTcgoRNpCk6B6PrjxQmoHDL	359
13293	2vaMB2dH981wXHsJf8TbyQkKMoNTMTAftzTowNn5qZccqzg9gMdp	359
13297	2vaWnQTGSJqC6CUrSAj8SRzLxwvMCHGcLJW14xwhSgC7c8r8UAyP	359
12996	2vbfDRkqLwMccnoMzWhrRsLwxyUpo8EvrzF8Zg9JVptfosKMGBna	359
13007	2vabbdS9MxKYzFMhCxdeGLatoCP4AwGEotuW5ss7T84dP7caPh2k	359
13011	2vb28ci3uw58uPCGpm782MatngSqf4qZGPeB1xsCRQsLSVMkaPR8	359
13012	2vaQrbCY5XGrB7Wrs7tiYyeCZMrtVs68bp5L1eEz5J3KoiGtyBQc	359
13016	2vaghNpZDpnSSCjCr5cbdsAVkQfHoefdnBKjDoqcnEAMfjy2gH3R	359
13021	2vbLyg6U1r8EgAWXLpWaPCmFZ4jJfzEMiVzV2uY6FwUhFf48bXXw	359
13025	2vbRxuVDeohAcqDx4zPGAhKDiby15b7Pa6JcPA9wEXJ1KNDS7B9r	359
13031	2vbTY7Hr5z69Jc1yW5NVZzaWuxbTa8H7JLJS3nMxDRE3U4x9xbtK	359
13037	2vaaFJSpjw1rg2sbftgf5pBmXhRHfLf6K2Hehpj3zH4KyMnxMxKh	359
13038	2vawPbmyMQhin4SUFLU1uz7ttBukNQzjbsqcsEEVgFa86mUid1it	359
13046	2vc2L8WJ2w3ZDfbeVNvntEAmDofuJp7VMCwqvbbysZkVGctU7zyT	359
13050	2vbAvX72Cz6UuRS8vyb4jKB3fH2S69vWgjZLr8eC4Y4WESbxCg8e	359
13051	2vbDNt6RcQETmPFs2kAej2jYeRYjCWYdML6J1y5wsDYVt1akSCuk	359
13055	2vbZNkh5PY7uvcC7yusbefELnP9ZnH4zkKwN4FmseDyhjBRjzhg7	359
13056	2vadNs4tkC5sdyJbbYeLrkydBJrWYnvSvPHT4thkrDce4iwSGXnu	359
13060	2vaqnb5wNfRcC5m5HqaMuY5YjiMUv7HeiCTNYfLrpsScd2qBuaoD	359
13064	2vbXtc8AAKxT2b4aFXt1wSMNMuEDv1aPnivq8aedzJv4rLnMagtD	359
13065	2vaDUiRH2Z9CAUFYDvJtDLP1qPSSQPo3RhzAUMb96Ufga1h49J3u	359
13074	2vb5njxyPkB4TUcWhBpfgPQNvyw8HWNeUTUqugLuFAnJVTVvuorq	359
13078	2vaP1H7CKGuLUhjcXCwxEs4sZhpewBZHj6jckwnrQu9896NxoBhv	359
13079	2vbcHTePuc3MZG5CZMfKix9ZuGniD7vgG7hgvktYAmCDPxC4M8xK	359
13084	2vauXPtQCMRzjpxheGWMt3bS2R72hFn4AQvF2phRRoYHBxgA2hNi	359
13085	2vc4om3c1KMJdfAB7mkwTzLQdk9u1ufDQtAd5zy71nvhfobBcL97	359
13090	2vaeUPWQBj9G7TTN7kgcaQ5QUP8jE3oPyxzCJ5c29gukPU6V2sEL	359
13106	2vafGC2Yr6KPqk3YpP3CVwU1FQfBvTveAtTHktw1nvniTNyYk8Bz	359
13111	2vaBxr39EoqNsx2LgQMrRmNhykegZymJeNpywqfzgH8HuiCk8gCd	359
13115	2vbXKUkgxGZJooMCnu2uvm4MMJPtrNzth47DqYAHzmu3VAjYd2Df	359
13116	2vatazA1GQNuHmHFWG8sEwoy9LAac7zVP1nSbx6o5djpkYCDG5Uq	359
13119	2vb2WbgqtgkmguLcR1ax4HN9AghhYeTxTV8ZrAKsQA5SJPeY5YeK	359
13120	2vbs9WDuBKHy35HtPzZeaTpU3nFt2MyTnNPdj6kfFS2cTjkzJy8Q	359
13124	2vb71XAch1EzWzvd5b9RtT1FXSt8hBVnhxfvixrUqWUdU1egrEmQ	359
13126	2vaL36NEk66peVGqnATJRh5Jg2Whw6HoLwiKaDiDZZXEEy5SfaZk	359
13129	2vaCLmoR2kRbGtNNkF37VLHuMJU3nVTxUGdJdygURT8Q7mZ1wqC4	359
13131	2vab6EPRFKpdtLiPDNsb88Y2NigM11umB5FaVQoj3UohhwAj3NhK	359
13145	2vaw6AuP7AutXaqHTNnyuAEbkakJQkL1NazSrV7G4nYxDhwGRDFv	359
13151	2vbCv9SpJR527gyj7XYFcmqcB2NY3GxSEKvqEQrSRosBMtwC7o5o	359
13153	2vbQdYCyyiTDwRYjNuViHWCZztnzA14yVaoc8w7RFbkR4QksYjqP	359
13158	2vaFYTqsdHt2cYxQd2h4dLvRQ3zPnAjRSPNQDRHT4WEZK1LdY8GJ	359
13161	2vaV7XpZ7pyHnTn4rdUqo63FhKSAxfmDtZaSF1xCZ126hoGgGb2X	359
13168	2vbTqJVnYcKDRxuV7JCWgzQsxyEnHT63m9HkKVjDSyc9LS9ouP5D	359
13170	2vbzNx5QUJN9N32m6vWxsSBYyq2x1b2ZLAMeiUx14qXLhwiviDLk	359
13172	2vbcL74gs8bFLWPJVYJEzBQCPJuc9kxyUpmEqTBsHfJLN5Bn7jBD	359
13179	2vbPH9yWGuoc1ycRoGbWjAatr5NcNEscDwSYXGQgNfbmLLS8j3Zd	359
13181	2vaABKu3LqYb41DtcLCW9D3FrwoYvcRvzQFLKi9DfWoKkcxqR6Z3	359
13188	2vbqMaRt7vSNXuhkrLhHiyvGJjMFUpMc3UH8W4PpvJFiScsXmCTX	359
13194	2vaSGdRRRm7weCqYYGBFtzufHUFyENyEvaV5ZkdFwdcmXCxPVgo9	359
13197	2vb1T5MFkVxduMZJtoHJY1wMWw2GYuFLhZBGd7CockERHcWPoLJX	359
13199	2vbyUtYMrnX935grgewqbd1cN6vJBstYDcHKekBjrwNjtWhP5rrX	359
13201	2vaiV9kePM1gzn4eJCBKMdjBeKfjEadqSYvA3VZXZ33nHMLiYtKj	359
13206	2vb1HVMXV2X57mTungUXT7XVUbTqvTuVX5DKY1nCT2FSBexF7cSQ	359
13210	2vbKP7Xw9LBB9GTciNYzDjK12dzdUkkNw7ZMq8dGSjAukwJFRJoe	359
13217	2vbLArj86hHhCpqDP23jA21aqXgHF77BGAC8rMgH9D3foRDTESNE	359
13220	2vbLxRCXDc6AKY9DQeVupdsSc3jmLy6261WdLnQG1tXas7HxS4qA	359
13223	2vb865BZUcvKUFR5udzLmYtkDsuJ8A31cb1bMSTbsZUY82jh7JR7	359
13228	2vaUyqTH5BGWguzwJciT5Q6wo9wZp8opTT4QKY52ED7wYAKS6P8H	359
13233	2vanmm7BmprhWAFTZ6oXaj7Qs5jXYucoxrDjdhs6yXnCEo6jKPMN	359
13235	2vbX5EwkLV12J9Q6m9u5sJZuTVY1iEDiSym8RYzJiSBTt4siMAaU	359
13236	2vbFAXgCWxxzEGH6vBftwLwHWkZVJPUAoWVoSrumDyeuwke4msQH	359
13243	2vb8Dn59MUkGd8Xz37wdE4jDtZoqB2AcKgQ9aTqK2H3Y6eBfUDSQ	359
13245	2vbNPHr5PkzfC5iGMCd39p88nosPEhpX5JdDAiFYyT5rYFidYRcf	359
13247	2vaTFnK7i2LQp14ZuoPigkeApJTzhbA7iC1D6wAATUPtDKwXJNXa	359
13251	2vbVxGqFEb1wqkmUsJg2LsP7joSYHy9nkpzxEAr7fWPC31TeZ4zg	359
13252	2vb94L1WCVwCeZXv4afEZ2EviZCFwns51LYHkotZzHfCxgqUyJpX	359
13260	2vaBU1huTtjpcp1QA2V9duqHSSKu88FZBn6q7MxFtGWj6aQBfSg7	359
13262	2vc3i8zjN1u3mccrBZungLy6krLmpT9iDwviQY1uCjEN9mEhLgDq	359
13269	2vbvwNdgTAkiKdHkfpfEtecQrSbHcpZAE5JHm3JrK4ABnZTJiwUt	359
13272	2vaoo8hHp2ct9hNJCsU1myEe1bgPUN9hjQmyJLwvMJmUv4s6AEiW	359
13276	2vab7W3ayE6YWSyFZu7CnHiov2LM74XDfLa4yFKMbiLQyLSHt8Eh	359
13280	2vai6KQSZcXVXEqf7ngcvv383BZ26uZeY9uNvhteqRHJXA7LbMy3	359
13282	2vbMZotqGjEKLJJ726tK1JgPJSbjMTpgipLgUUe1DvRcyKgmkKmX	359
13285	2vampHmfnUBYadzyTphBjsueH1FDq6t8HQb3eqeLZkKkB6dRj5JP	359
13291	2vbiTzPsmS6xfJhBzx6tmGBfC2qrtZw3tTZBMftuXD2AVkRZDHQE	359
13298	2vbnMvPt98kHC9Qv1XZvMcQASrRpa78tNVzSBSvYD7zF9vrd7bLW	359
13301	2vc4iKYdFVZh5JXERVY67kwxyJRXkVtQ5k5YqscpiGf8SAaaVHyf	359
13304	2vawDQM7aBpHjJPMv8zxm2kW2KAGE2PpHqHLP5STVUAdmAc6ocxa	359
13311	2vb9S2CbUg9nj35uGpME86ry7YbKsxaGU95wMY6DL1Dw2YUC28qV	359
13315	2vbSN773iFiRnBDiQXsGb47V1gjhZKodnN6zaMwSV7KHDVEkGT4E	359
13318	2vbWqKPR2JCjJncMjswMDG9qpNsvYgAbo2wiaLMCWG3GGLjQdHee	359
13323	2vbchfLqvda4WK8tFctRETYZ4fbTJchzjh1u4pPX6WX42uQPsw9R	359
13326	2vaxnvhC83DqzwjafjEuXegpvUzEn9L5BokXGRWrAATfNj8GbTUh	359
13331	2vc5rwLhVbMXMxewNb4CEUs6pperntcAvwFiiNEQgFDUhnRnUWdT	359
13334	2vaRNBcx1Nx62jxjZ6dX81m1WRtJQLE5H516KA8azQ2hTjEA9hHF	359
13337	2vaJjuRXbvaVD6Um4FMefC86FtCwmVfhkbs83haBFc3i52rEQZBY	359
13340	2vbYKbrVAerEsS4HnWo6SnYU24USQ9W5csUHY42QBeVtgVSSexH4	359
13342	2vc4DMH6fhwGVZ9bp3A9T3qHH2evaAueSm8biAmmnoyNgfb63Hzw	359
13345	2vbPsWA3Kc72FaVcowqgkioPqkodgHGpAQ7dBM3pVZohqupQ4kGa	359
13351	2vakkeN5yQePhUn4ToN4yLGBougyyvwwuJcG2g94EisuCTvrmaGu	359
13354	2vbSabd9y6dHXNPTRww3wus7QQieEK3pJneRTNMTfZxNChLYXfyd	359
13263	2vbNH7UYQmLnaTCXB9NzF3iTxwQg5SkyXoGvrkqannfUFJk3R9Xe	359
13265	2vaHqJ1zxwfafXosDujJRkYcrjFMReqyGnwnq8NMctL4RCZczj5o	359
13270	2vb4s5mxTpECZAyoUoU35JNut5h92X7CZgKUnTvhcaYDYmdPEpJn	359
13274	2vc4bXLETHVRyxthb2EikJj13zyqAXMng9DtsMJEB5R6zUCPQEzx	359
13277	2vbQE6PNTk9rKjmMQ9Xr2zS6Zbd2XbxMQdXYX9jwsHXCqpJZJ1i5	359
13281	2vbjE7SbQV8zaxEbh8mYktQ3Yryr3sGsUvj5YJ7PYrx233FZjeqz	359
13283	2vc3FjhnX64A9BytrkyoJnpK7P9b3Wp4egpzmLA9xPYfz6YBjLad	359
13286	2vbEopojkQFWiaAzDsBTJfGLLvvM6S2Qn3qydLe5qktVTUFutyAs	359
13288	2vaE391p48Z8GEuMw2eLcE6oQU31BbZrn8LaTdbY6HnR6tqXj1ps	359
13289	2vaHGMogGpGRBBycwQqExA4oyzMwGiJUJDjc8Laqm5pBn1b4ww7G	359
13292	2vb6XLMQKYW4gBhHefi3BM67QfnaUAwpWkWRtjNwTnsdvdNnnUN2	359
13294	2vapJ5PYpNVPdDRSyQ3idg5ZBBbdWDVNMz9acggAiJXuXqHw41qZ	359
13296	2vc1os1wKfg52p2Avqry1ucrb3ttzQkAfRd1agCC5s58vjUfb91y	359
13302	2vbjCWERGzVx4AzDDodLq9jbUR4Ri9biCZBfEvx1xMT2HHtq5Nrd	359
13306	2vbz536WVvkQuXcDWcfcrbno8aDwHTP9mxK4mmoa7haF23fCv6BT	359
13308	2vaMWs1fTYfAkyNuP5ML6SiDFtXamLMxyTDXkTWrnu7mSBc2F8j2	359
13313	2vbT1XXGmNiWQJDv6oufgcfS5hgnNHKa59xxHbFR9BesErgnmEXH	359
13319	2vaCtX4j423yeqVkRHRPp5f5Dfm9GvXakxhoinrVrsuYNsR3rQ9J	359
13321	2vbHLvcDuJzrVyC7a9HfuSRF8TRBcX7xAvYNUkwjq3cpSmz1YsfG	359
13324	2vaMVseoSS5mt439GUa8MRYKUpS1rFKNGuNRBFZqJT4twDdbBzhM	359
13328	2vavRhSKVBjvocf8YDM8s78dYPZrCkPrR5ZasLZNs7DoiQNs1K8U	359
13332	2vb1nJHVzkYB1PcBYQEEGscH6GzabAvUhJEaPrrob4eZpRMrkaBM	359
13341	2vaLQU6sKqfBHBfRGsTGHfPRJAqsgnxXsfggZVKykMnnGoM9cvep	359
13343	2vbA5WbBVY1VFjJmSPLvL3pXbg3fVesscfk1EjaJYp9Mah98uh9d	359
13346	2vbCNSWQvvren784KxxxJMmZo1Bz2bCAMikHv7R9viCZ7LtqDyLd	359
13352	2vbdV4Ni38wQEoSW3bEebZnbDAZnVbB2DphHufVyDTwyFreaqFF5	359
13357	2vaVG6XBqXAnG5uveEiFqX9VdyLnQ8pCveZmiNs4GoQbGiZNQDyh	359
13361	2vamvcaC8JRVcoKNWtwsu7Wxci5aK51XfW9e87WTKisjNmWHDNnY	359
13363	2vaUpMHYo4iuYj55CiHphK2VJ8BiMi1HbhKCDHs7HYkJemKZPUDg	359
13366	2vaq33TeVWgZ3viZWpZmXcpAkn8XdqxrnXuEk9mYSmnntKkhqrsh	359
13370	2vaGB92z7WQWBnNshBPdkfGF1RSZxaJBjyZhkFYF1229s9KuUGAP	359
13372	2vbCHNWXMY6pF6fLoecKdu7CHqiSXsKQdhkwADCJGCunWbwAMBSo	359
13375	2vb3b8q211P25DPHyfirFmzV7tWF62SCz6Ft6VuF38UhgXvNsQU8	359
13378	2vbimp2qR87zNfeirwJus1htsUjT9TL1ztmZTUcCrcRVopwvPje3	359
13380	2vbDDdbpd8HHMGfZJ8tkboAMZPpPpAuDYyQzXVUGHBBsJkFsSLLQ	359
13385	2vaxBoaiiytAKyQcNUaao1oZwr1Y9QVxwf1XZsL25eQKpXiggzvm	359
13390	2vaSEkbuHmfuTZwVWVznr8Cw8uQDQfVCLq8iJLSEotpTeeP1Gcah	359
13393	2vaM5jTgP7n5UY7CeDyKjpVzRpEJSBi5kYsheciJNjH8upwfLj6S	359
13395	2vbvsbE4Q5QkCkG8rNEhmW7xK1WexNgjSJdB9aJbtf2VJP2YqYyM	359
13401	2vbTdtpf4dNTDVxoZdXAp5X3MkVYEZoJNbMX2WWD1TEP4wQNsZGr	359
13404	2vbdxgCtS164sEoW6XDFv3c9VrMnCGaTGcCEMVkTHsw11qkQg8t8	359
13406	2vbqetqWno7y1x2quxAptXda8kosLmAmz6jra9nFsfSvkrhSqjTV	359
13409	2vaZncuEjSBtznhVs5FEAf7e4kyjK1cqrfD2SRta9QBYtNn6pLnY	359
13413	2vaAWoG94bJ4LUBV3fhMUReBwYVpkD78pgR6hhmqGuGkGUSG3ui1	359
13417	2vbB7reYgq6qUbXtX4KduzHdPL1dr3mrhj9JrftX1Ab9zNKVAJho	359
13419	2vbavQEB5dsegN7PEX8UwhmM247mHyRizYn519veeTHBgxp3chdw	359
13423	2vaUddGqSnM9PpyvUes5GXstqvEQKjdVmf6Pmh7mkHNzWmvomrah	359
13425	2vaL3qH3PcbsieC6Ky1D2iqBi1TFZkGzm6QMNY8nmo7t3QCyx5Bj	359
13431	2vb17EhHG6nKfcUUvz6aA9AXmDKBnB7bJ72MjbL8SVfTcywUMnbT	359
13438	2vaoDpDFuM22zuDc5JGN3j5Qif3iM5hczN1kKdNvi3zBi9Apbr3x	359
13443	2vaqrtc5FA5eCkXwSZwZTszAjFbCYQYUEUB8Y1qRFrwccKSqB2c4	359
13445	2vbqtn7kvSUZsQgHYNapoKpgtiwW2ZmhQquPuWoYnmRC4GGv5sRU	359
13448	2vbNc49pBiwV9ZR3v1FAqFtWKNBpxCasno51q6ELrmF2f5uCohzL	359
13453	2vbdNdXxrPRmYraZediocyGLoex2oshnN1AWUg4unAQTem6a6F2D	359
13455	2vbFNM6Xw76zwPJFQNprX7sXKwDRPBySdmHzFiRrCGwQf2C5XRew	359
13460	2va9HJzBCkTBGHYAVDZTpWnASM4LaTQb8LTDvnDWgNzvxBqi9P1z	359
13462	2vc5dWmV1o8MchTxWhP4Md9mvpr84sqWpptozngvqZNo78EGoKBG	359
13464	2vaJXai4t6vnurHPuXCj87awo6xDbPg9wnVbYdhSqxkjnbt2WBKX	359
13467	2vbiZZFmxac6xzQoSYeg964BtcaFDuJ3z5bpPsfA1htm6mqUVFVo	359
13474	2vbkKrHgZuR4UePJeZuvyYZeghEHdgMwqfoMXxcMnGEyRJoRid6Y	359
13479	2vbKQ19fZCr5jtTh1FnJjG7LKHSw2CDcRTtkY7cTg3hNA3sW11FH	359
13484	2vbgRpdnX8DMcvEaHsGaYKDdbbQ5fX76XXjiH5zMVBBJ87CMQDmj	359
13486	2vbQGiba7koJszTDL2eFdR5eb16VvLJwTRMBqUx2SxZdUAzGmpzZ	359
13490	2vbtyYT9wDpijbnPEBBa2VQFH122pAqMGmYuG1uoP8zCK1cH1ZMe	359
13493	2vbj2GdUnjxij3gmgtN1RtxuXBLdzHZ5GoUKkqfAXC9VuyzdpeMV	359
13496	2vaKL4aF5aTDeWqUDUruhSRiUvkh1EVeY5ZScKmnv8YkZPzvrPU5	359
13497	2vaUyyJhehP9kgEfhMT4VxDqkMVWZ4rb64VtTFSCDsP7DkcSHnVM	359
13501	2vaEeT2AQWwnAx9A61QY7eMN3fncYw8Zn5aE2bEU9PmrQamfVngA	359
13505	2vbCfDK25ZtHSC9xRb2oDgoLfU128Ls5ZUR7bBTFYwWEczD1ZpGm	359
13506	2vb2hKhqcG6yVrwJkbUUuAK923qhDnjHbqvnV9MPMTvX88okJvPf	359
13508	2vbMCf9nv7pdhDNPRP8PBDPwFFGzaAnxRQ8s2NvDytYp6AUry3md	359
13512	2vbn3qzwJu7yqd4MB4e2DPFyFCtum1z9aQaTseHfiNUqFtF4UdgP	359
13513	2vbiuw2xEZB7GA2noEbhjnC3phPx1fdb4CgHN9Km8w7KNT9d5ZVS	359
13515	2vbdp9eVSMFoABbmMzfnjyfgC4JQfuAwTCaZd9kPG9sGSjSfHWvu	359
13518	2vaEHvo1ZejBPcs4LESpksATCb1dwVxPGRs3sLjjpw9xjUqfi3dR	359
13521	2vbupybyriSS1A99SKX2vkCf5wZDDmGFaX6yqYvV6WzXCu2rXTo4	359
13524	2vaX1cktwNRhLW5Wf9RqCnSCf5ZUUuwSAY2MCxdmqaCDBFtqPuBj	359
13526	2vc1Hs8CybTjUE3gXa3H7S7mLkVp8HV1wksKzFwoPuFZAzHzzsYh	359
13529	2vaJdf7cLUQ4FPcvZYHThGB2EfENm9sy5fpWRnzY9hFEcdwG3r4E	359
13534	2vaWeZinBkFkHEwyHKXVd2fnzWviHGxqHz2s24Boa78pWvmuDrcD	359
13537	2vc3URFACncF8cZZ8mfwR2MomKUephNq2JVBaUmAuFHHDcUsuxAx	359
13539	2vaNUyCWDWzFjJABRx3gw2TdB3T346nYT8T563ZLFD5o1GHNAfsX	359
13542	2vc26mtvXi4yBSmkC8o5yEd3dWFUFpiGwC8BEqEXhNHXoK6NBngd	359
13546	2vatsamCvSKLmjcTwvmMDhG5DEme2g7QoHK6xyxVExn73Kp1iAry	359
13551	2vaHun7rJt9fUtZc2JeuhpFZCidJA6SaMVNAnqx2gFLYQ9o5wJZJ	359
13553	2vaX4rgXgmqSC9HjBBBQTJG4e6ZL96oYB2uRwoTN75tAVDRJzHYt	359
13557	2vbsGmdHdXDR5vxVmagdMzkNLLAdXdRtQoSxfg3QR4nFAimoZfY4	359
13568	2vaHdW8PoVE3DaL2AhJBb85R6ZrFdyoqmKgbnFbbkeGSY6iLx4ib	359
13287	2vbkP5m98oeWd6Fp5LKrs81PJsEFatfMJPmkYs6aFmghsP8qZwJz	359
13295	2vbGBhYYraiXeaYdNp9yA321vMueh9Wft9cYbAijRXKdwJpcLKqD	359
13300	2vbYEMTteBdoLaQH3mpvoEhhDbzjWS5zFkk5B6fH487GCN6xX2wF	359
13303	2vb889J2HK2zND1MnQss27C9MrNCA7YkrFpZiRPr4TXf5gAPSBFW	359
13307	2vbcXYw2Q9H5BALtSfaQPizsGtkBNeyvoeWAk8VmQjteoW63AGut	359
13309	2vb9LYXJ4G8JWDcUFkRrofBpwbGBFSzUGVScubuMN8VAc8zT44kQ	359
13312	2vbHrQHPkAtSRBQuaBgQLA8L3MiHLDCKPyUsFHAUCtQUMqXzy1wp	359
13314	2vavFU56xsgoB1qWvy6ncfGw7cYoGmgPYhuJaayXrV3Fwnyp8VCT	359
13316	2vadf6BTfDJx6MQx3LLcsoy43DWnLUaWSRMAY8kRA5DrZyW9sAuu	359
13320	2vbMQmGpvhk5Z71do5SSKExBqJmTNhyuthLhWEmBcAB8q7Bi3uDk	359
13322	2vbS2H5EYyskRgZB4pTLXDMss4kPL49yFC3qoEx1w2iAiWQYiRGt	359
13330	2vawQZKkDm296QLapnUcGaqAXAh53MJkxt4ukCbn4hcShJ9jgYAh	359
13333	2vbtwEBFWtmeChKpCRmn4E31VZFfqHxBN1ygagGHvko5JqxvipMb	359
13335	2vb19L5TPrDb8UGQsqbqn1YPtBJNDRXXWa7E5m3XypTe3Yy8wNip	359
13338	2vaZDE7Fmt6Ro7pk6TuRCixVTziDwHTqn9Z1hxxWgKb5JNXTZyv9	359
13347	2vboASFXbhYhP6NdimoSBm7N9RzU8yhxCpsMBhXJPxKae5x61DYX	359
13349	2vbXdKPem3ABqGC3e87bNv3MiCDxfMKWjzdgmC73ngNaYS2m5hyt	359
13360	2vagb8jaDGtHk4E16Est3b2SaiaWuAWqDUhY3ddCbCCNodaVJFyk	359
13364	2vbPdaQG4UXG785JGy2rMTFm8EA8pKUNnWV3ahKnL4dwhs6bwQ8K	359
13368	2vbYqw1M3YDjnabjfPqsN7wtXJ8XRHFr6kwEvUdFKabKSTa7SiSM	359
13371	2vaARDSdATmFf7deDXBh2w4Fzac7GAQ2zz8STJPajSdGMdMkYUXM	359
13373	2vbM9YV59PHLAHyaxqp4hvPELWEM6EbVx53CeEpJQnowHfTY5c1K	359
13379	2vbJz5VsPbvshvSTwaSJFLWChJi6khsrPhv5JztYdB8qfoENbbij	359
13381	2vaPS9pBtWY9fdsjH4RjRVzEUSR2u8eaL2emohmbQyipUxfPsvxq	359
13383	2vbByVQnRR3hhKhYavciiTJGVmEPiz52J1NHmFsEFgNdEUim97w1	359
13386	2vbGq6thsaWChLTLHoXs7rHKvSHHQbTeHfhpNuYbCGetw1sHJeBn	359
13396	2vaEj5cJagM6Qg4yhU7P1foJk8oWcAGzukMu4BGGNMKfCkuEkgWU	359
13398	2vaVNYUAn9P1eJC7dymcopHepz5wZKhGhDQgfTViar8r85zNyXLB	359
13402	2vajBrJ5LB7j53BbinPc9F8Fzqircp7HBxNyZKYL1pwkNM7WJQq4	359
13407	2vbvxC3B16yANtANGFt6dbJngJmKMTyU7xQ37G1jNe6K7w7JLYZN	359
13420	2vbiiHxEe7keqnFPHJ9NjrQ2CdPyGzj1cSRssbMtPnsxGh57GSVm	359
13421	2vamgF47PNRf96kb3sHfxBkTQcNxEE7gfV146n6QV88V3Hqurr4Q	359
13424	2vah1HVAKyftb1uio1iakean7iiYrfPThB5jToYXmJn6ij1VUVxj	359
13426	2vaWYNRskSZvktKymAvPJCVdMKu8VBDwC4yMr9KBib6nt5pDgpHJ	359
13428	2vahuQP8N2wz41VT9R4H74q5aUBCtceof9LmCerExzM6GqF7wBek	359
13434	2vaEq5JTipoufXuGVbwuQ2CGpFeYqo3JWYXVuhQAhZ3EyEhGDH76	359
13437	2vaJbhhSpK8U4c7sPPASrrmdtMTzBLDGCxyxbwMcDiWXHV3eAMKD	359
13441	2vaZyox8ohUfDYzNjXTA7rtD7bYPe3D65n6XGY4KnsgpFP8kJPmp	359
13446	2vbHgQKbtZ4TDyEJFubbFiVHQkPVqNyhT6BYYiSzTQ28w3qC4ivV	359
13458	2vbw3wU8MVbFtGVTYQbvGuFNtzgmjJLQ57uvvojXg2rzdgZsnr17	359
13461	2vbnWsLGn1GbLYL4brG9qj6JDm3zzy9ZRSr7gv3JuMFs6EBZMAbC	359
13463	2vba3mBj35KzUDDG6MydM5JRMYae1qUW3v7xUf4igU85HNpkYL4U	359
13465	2vad482xWobT4w68BKg4hoAZdrf2HB6Me69UsoqivLBf22AZj3cD	359
13470	2vbBebeBQXSZF35FTFxnZPNmeWJsiUhY4uzryGu3YfbSrcs3638G	359
13475	2vaR5CtaecEsXG4QhK64QKrfTHiBdviZSiXf8zXV74LeUGi1LL2G	359
13477	2vbRGfsgQnVcwe8HNjGX8KUY2vN9xXr1cc3vjZ6Zv3Gxqy6s8URA	359
13480	2vbWPreB3MG5ptdkGcW5HYouZNqep78vzYs8j7zxAD5Lo82S1C6h	359
13482	2vb7HKkncDf9dAbGKTkiW1DMVkD9cHtKAvw6PjQ1xc7Tw1Hg4qEg	359
13485	2vaWAhZ4PUVVuKV39SzFRksdXKbQUFDoj4NMQPhJhs8YwsS3timv	359
13494	2vbmHkBBvJgVcU49Use5SP8bKPS5tPUfb7mdAVH6XFj68hSiedeV	359
13498	2vbMfM6EiLWVQb7E5pPEFVUDN1AoHChPi1LLpz5yyXmsgDiwBsyj	359
13507	2vbZp5b6Gjkq8cpb2SM1T1wULP2L7N9aNYhJryMDMNj8v6rkRce2	359
13509	2vaGKT87hmX8zf2q9WdEradxkLre1EQFhXGaPECk7AyZoirMzxYJ	359
13519	2vbeVscW6KZvRLshYXY77SECuKN5pQZ7JfrFmZ6G8bxJtdiFiR7t	359
13527	2vbekW2hLkUfBFPSNZLC4VdNrHTJZLmV213afi5z2TfXQZSmiCLT	359
13530	2vbWU48vYT27THGJbtEeCSHqq2YyaM3dL6ydNU8fBsPPwpmHdpqC	359
13532	2vc2FMqP1fxQmc2m9XyB6oV1QkRcPNYzDTQH7rDhH8DiHEm67JRq	359
13540	2vaWqhqeYvgkyQ9DzZrxmVZpCwZT1Kcs2beJVubUFeUMpbTVSKGw	359
13545	2vaUE7pdkez9KGfHiFmvPJBSCdM4s3ZrEKpBK2cjrSxNxr2DnkSb	359
13547	2vbxCdvbUqJjD6ux2atvdh74Kkk9KaaUsKKqqokcdHF4giuiSVWA	359
13554	2vaWRK6vGJ3YPhG56Fr5MqoVt9ntn2VrmEfJ5Mr2nC5zukb6uDJr	359
13555	2vbFhS36Qoa234WaFLudR1FE5eXrX1qcpKwdeDQGQJcpc5dhNxd3	359
13560	2vaC5EUQBJGMCWSRMwieb9TmeEvomgXfFNCJv5PTmrNEPgjvFLEh	359
13572	2vaheq1zx5rnMW6NTYpKNa4YcebG3XyerwT5KfnEpWavMcMN9zyV	359
13575	2vamW3s9yakHx783raUrh2C3LMHe1RzEiQatdYFmPgsEGvXHWKvo	359
13577	2vbr78LJ8j6uz1DqqpHQgTcp2jMn6UxyPMW1JMbhfpYUwfhGsRU1	359
13579	2vab2fwzs5oaaQK2p3n9UVUMRVLy9kVTjR7EnmCbNhaAjL9T2GHJ	359
13583	2vbfHtq4qx69JcEd4VGweNoPjtWCqeRKhqSa9wrpNSLf9yx4ZWX8	359
13585	2vaLxxoqUxLnE6rKgQ6ZBkjFb93LRMtn76ZACJf52zPnE6ZCusjA	359
13586	2vb4H5zzqgjjRmXqpfJWMrJVK5m5reQB5mCrSRCHMaVsTgNH4EAP	359
13589	2vbozd8diLPbqyoEpzwYgzjqEEMYk6eTH6feoEEcvfJe8WkoWQJU	359
13595	2vbBYTwDs5cBK4mv5ud5HgY1Edn8MjgmuEEdJQZBuUggXg4kkcgs	359
13596	2vb9uGfyQyGEW9MRNJrsSMxhfbwg26TxW7QyQBVCFjeSnu3A7zf7	359
13598	2vbd19apBCqcJ9JYnHSVHZfyVp6gjwPGUsZ6a1R8C7Xic5QFbLNf	359
13600	2vbFsJYKnCKLj9npLjiWmcrhiRRjeZ1qoJ2A4UHNzrupPeVfQjR6	359
13604	2vaz6Lb6E7riJnk7qkCrnoJuPXgt1c9nV7kcr1ov7CqpWSfoC3ca	359
13606	2vc5ncCB4QNAvYdKxqP9gaJwENwGuHUcmWzHy5CsrB5LxfVfeSQD	359
13610	2vbFCUDZ96PzBU3Qf57tiZM7toeLeDYht1gEaMwMpkWVpTpfgKc4	359
13612	2vbmegYgCTdHR9FjLdQ87jZg6r8MSPqSwukubpf71U36mjZx624c	359
13620	2vbAuDdZQUStbmMQZcEnEcFQhqhxeeVBFRrfMysop4SHQ1XrN1Q3	359
13624	2vaE76GQf4S64xkVBHKfAHnMfPNnLuM7dBPgirqv45GFgkjcs6v4	359
13628	2vbe6UeyWJi9evfMBRLvFAWCSkj3i1maBMKnAYVTxtp6RKDkF32i	359
13629	2vb4aooQn9gsasLaZWm7zkoDasi72zjaaCgJMifkjFXUT6yYiYwH	359
13636	2vb6njNTDZH2pSkBkefhfe7PZ1dUVv2Zu76z2SgTRkvE61dbbsu1	359
13638	2vbqEtj6vo2JjYdsHcKFimBgXycf9qhGbVjS522pwnYugrrnSFD1	359
13641	2vahpfwT1vmJvHiSqZdvpUWdjt8H7kwtnnMktKQL832CjTib7NPv	359
13644	2vaVYmptYBVAsTwgkvtu6t8k5KMgJasj5RCuZedeYKay6J636FyY	359
13647	2vbL3LaqPV2i2rpdBTVxgYqNQPdeK3jg4BmEyeC1VcBLDFDceKMf	359
13299	2vanZ4dd7KqN1sLbRzKy8SwvtgorWZnXVZev6euhqb45ry4CVbLP	359
13305	2vasHkhW7DGc5Py9v1W5kPFmSRNRtcDWeBgPTwcuVhShf3C61kY9	359
13310	2vaTPKYok9Z5GDU29W3Efb3fQMyqNsyxDqXRpfjNtZUxSxTq6AN5	359
13317	2vbKp31Hv3dRu5W8w3RY5UJUptKnsYfKGhWiQzQHHLGayTRTSEJ4	359
13325	2vaeDALsDBJ5d7GdGiGFZ6gnNVMfQfH2Rev9nFss7TzJAR7REWFL	359
13327	2vbgsCFzBiSZ8LwtQE1t1WqzEiB9k7gxkymok5zErXMw3zvnDnt5	359
13329	2vb3bY1T4fx4WaxKZKFfASpkFZHoRdPSdGHuSJYZDynmgxYbwpe2	359
13336	2vc2r1FJ9MkPQksS5YL9778tEZqbWJUH8eSVgbykFHrXoKvC6X3a	359
13339	2vbL8zaWMbhptbyeXHVnkEqtgxJGhAbpBqMiERyUdxAXgmX1S6Ao	359
13344	2vaxdQ5z6EUSRfkR5X5hLNfeWvriKAc5zU4TZv2fx4x5NN6jrEdn	359
13348	2vbupp1szcyGjbW8pnytFvRtsmLQ3zTX7qQG9TCGiXLncUstTjnR	359
13350	2vaLjeVntUBU1W2gJykaC1RL3HyYmFwmcgsTiGgrZnbRjVQ4udyG	359
13353	2vc1fT9iDhYz8ezHEEo5LTs2z9LjgXMSHnfb42K52qfaizboxxZ4	359
13355	2vbYz5dREqNB6HkQm3bm7Cugrru5VZEy61vJKvMCujCzhdRBFG55	359
13358	2vamNcbLZzMLAy2ceWxX6bSGYUTmCfY2owY352ns9NX4PcDDkb98	359
13362	2vbekcwbRy7w56wkzLAvqmC8wXAech8KtqC6KqBsz6uwfwWPoviA	359
13369	2vaqxcAiNaf88NBuKx6PgsW4cPg9eJCxAzRrqj9V9cid8SyLC7GW	359
13374	2vbQcUTPRqqnEzs2uNMncUKjXrq36SFSPbEkrFhsWta13KxVuZQR	359
13376	2vbcUBu47ZCgQKdkKvkEnGfb93QBSZq26SwrNQy59uryoettyUnD	359
13377	2vbbjFgRFntj7dgsjH1BUMiAGuK6GfjTukns1w5s6AiKbA5JMVkJ	359
13382	2vc5XMAHyM7ndfb8jeMUAK1U9BBerddeHzEbJs9wEScMVUnV4CtN	359
13384	2vaAF6G9cQHUZiQ8JybBPbQBwSniK7w3ieGvxhh4QdCcAFFyGwHX	359
13387	2vaCct1mCzUR7tYmy7gWRuuzPpJdTYbhRGYRnZTKyP5WqWgWktMB	359
13391	2vaEY9uajg125DgJSP4U8BwyakXHMQDy574rAfdMir76BijpNKxB	359
13392	2vbdVvyKW9v2MWta2N8EPHtDbY8vxj8V8vVo9KYv1qQTsbMYpZdP	359
13397	2vb5W5BLXFQ6rt52NPqZTX4F1Xgqvn3feV3A4tCr1H3jqx33im1u	359
13405	2vaqMHj5WcsHW3b7RCuAhZ9ChBW6sG2wUhaHVrv7puXaAVeLuEhV	359
13411	2vbLt26hRJmrU5ydto2DbJkYrSuQYt19t9YUfz2vwFdBHRyFdFNR	359
13414	2vbs63crD8Az93BWKPyL9KEW5RLwUTvzGdrBLhQ6LZw8NM9nmPe8	359
13415	2vbRf7RYVc411bhTCg79VnTzp5w3d4PT4KxdqzmEbWgUxUAnKeiN	359
13427	2van3UoujeYaq5sGZJ68N3FjAmZEDL27ppLDzrgS1QEe3J3Lsiw2	359
13429	2vb5n4Zkiwu3cvp1FD6uk4aespeKhXoGy2bqQQKqrwVQr37pyPvB	359
13432	2vc43zSDRCwpEzAntKf21SLsyBoZbPQEK8ixHyJ1gZebRwLLcFYu	359
13435	2vbbxHnLh44fvQj2nKuQvCpb2o9S8HKadVMECyqhRfhm5AefPE9h	359
13439	2var9offjYmzEHJGg1qpKBjGHgzp5FeEjYQVMEkd82Nn766Z6UMY	359
13444	2vb63ix78uHXSehWNWroLATmxuS3XTkvDtoB6igwfxrJT9EVU7jr	359
13447	2vammJ6njHAwxEP3E6XSTV4rWHZvsRwm39ntxpHWe4tL2rgquNQ2	359
13449	2vbZ23CEqvu8XLPVYT7Z67Zqz78BZcxKjN8fmMcqaGayyzVSYv7f	359
13450	2vadDHZK1XcZDirPUtfJEeMp4b2whW7rqZ8xFW27JHTd6nxDgB6Q	359
13452	2vbWx4JtDMeVaiS8vyxYWjPvXkJ4wuWrVkyefAyVVtSEXX2v5xvi	359
13454	2vbWzAm3vxR9D2TjErAsJEY5FyvKYKovZ7h6xgavP7EtN6jpTbtD	359
13456	2vaDzPQguYF7rQHYjEdYBuG3o8wqfSAajQwoeVJSoYv54NFzGWSr	359
13471	2vboxsU3ZJLJm7EAcBzkDHN4LmsNqLCkK4QyyxrNK1dwXgNykB1e	359
13472	2vavyZT36mNhfwNNKx6CUvNYeaMWbrRnyUVBN1tMonrEN2LiDQDo	359
13476	2vaeGFJQEjH39Ytf9YXX7dnq2SxxXq1NH7quYPQKWRVFVGtc6ZpC	359
13478	2vb7YvriaUPKk4FZ5vofisUjhokTZ1ch5cg7rmzMa91xWhLXynQG	359
13487	2vazgUbbDy2hotaaTNTWEwpVXZhu2KpTwLEMweLDY2ftFLNRoQY7	359
13489	2vaHyr1kBN5XHBbVWC5815EuHRBHveY8ofVegfujYE4AUprQgvtq	359
13491	2vc1G9mS9HgMuzZU4S46xpxP7RhSjHp26dyFE99FZMvAA3Tuag2m	359
13495	2vbdGcetAFJcG48ASteKQ9n8ChEGnzdHDiAsuiZCtV1YQ98zLuxi	359
13502	2vbXKKZNhgDunigiEtxuQqeQGqLmR1mjugGUPHfkqAKsqX8BkhvN	359
13510	2vb2m8xM7XqTaBZ1znnU8vd9BHcnpWsDS3SKvtMqDVPKWkRxxdN3	359
13511	2vaiFsK3cyoCcRABEkYBxDd8pdeiF5xJPao8QnKDVXQzuGsYF2MZ	359
13514	2vbMrXUohsjjoNWeLezD4RqUh9T6yfzJQ2ESjLxzbFZ1oJ8PpuGk	359
13516	2vanRJ76MTh9F6fqgS7599WYc1DXNUymuBKxqbHouxGRnuvMbSRR	359
13522	2vb32ac2bPxawrH4a5CxaAxkTsdztGQhHsLCkrMvJ5sizNnoGTsV	359
13525	2vbGkKLwcBQCjmrye3QZVVEanpLbWJHnyZu7PUwKLYDV4FAgvhQQ	359
13535	2vbHv9GfiNsTmJGvcBtg1TGvEa9oHTWsSn64fiueiuEHwVdFpt9S	359
13541	2vajaqgwJm48EX3goFvf8A1yiBTE3y81TXLcP4YQgKuQgoPGueqX	359
13543	2vaBZqvAJeHZGj43jVfEDdyD6vURaePRA3pPBEZ5Q2REqvCSd4n8	359
13549	2vbU1Uzj2vhv2UowW6drLCsdDKoEEd3ndy8TgxUfRBbcdSSTpN4j	359
13552	2vaAUjowJgAReRMocan7RHv6SMDSMBLGCtKgK4j8RQpdzQuw8c6i	359
13558	2vaxfzrn2iTsjTqQUTei8v2mCNWxVG58ZD1rM2hBxgr8TE3ytq3e	359
13562	2vaPk5a7SAEWN4mhSCodooFyfzVueeJszzLSsnGm5Rze4fYZijcf	359
13564	2vaH6AfD897tuimmgpBuviiSuVdwUEs1ruUpkci889TchQrK9C3S	359
13569	2vabgr1Kgks6DrfHsgrPrNHCaWxMWMogKN8vecjqzduQVKSYrCVH	359
13570	2vbo5YpBiEGTsYKs21sWSRNdNnPBXM2SmWnmM6fm7gts4XL99q48	359
13580	2vaoeCyTbnNg9BkT8KXsWVnPXsbBVt9EtKVzMYqjf7c5hYL8ycjC	359
13587	2vaFaY5RfvbN4XnB2W59dDoPk7BkgTVWZW2SVjuzZcRxcQR4Vk39	359
13590	2vbASKcPwqRTWL9ym9W8cD5J9kevrtiysczkWHhJNUWz7jpLfDwD	359
13591	2vbVktSZMSBymcHDiVyaspmJsDwZfsveExbJrgxanuUtaZCjrPaK	359
13593	2vbdQ6LUGdGRaJx7zSAWSZBTY8FbWTKgDK1zyc5NH64wiUTsVBHa	359
13597	2vaf4KfwZ3dDpfkxQhHBSmMzJBegkB4JNtr1MSvAAfZWUSLZ3cAD	359
13599	2vbf7CvysYAe7xEYK6tdjPd19qEfVPUjLRo8pnDwSw6Uok2ngkaG	359
13601	2vbPWWcg1WtvnQUpCFywhSc8uEUaMemfVHR9kVYmeeCahWs4JoU9	359
13605	2vbzrwviMJpxmtQ3BMTWWpKRRNFPWCk1Acxt3KcdU4bJPiggmEo6	359
13607	2vbQS57W2KZNxRJmkahf1zLVCjVrv7ZR37rSkmbdSe32Lm7rvHzY	359
13613	2vbJLHMxV7a66o1z5XPF2Goy13EEZC7UhVj5DXvcudtMa1Rut5iF	359
13615	2vbf8MdG4YYTFHXaoJZaznVetXoC2FoHfvj6g1PhavLeSY2WddE3	359
13617	2vacgkJPBbPPz8QB99eBywwHhxpEJGWwPR3L5CdNR7QncetRzcXg	359
13621	2vbFdSEJ3gC55jy1fqUtfo7Pk9QJsvtVZQaAUv5phaVFgWiJCT5h	359
13622	2vb9CrCLZz8iFSoAfX5TMpB97QcYhmtavtPMHAy9FLRjUb91iSeP	359
13625	2vawN8Cu4dfebVcqiAmF3dtR3G3k949oLwWEFCjAR5TU3gW2Xr3K	359
13630	2vben3X9HXwgtUhrZwa8s24bmVsBLN1D5JfXUSy8JytDBzVmdSeo	359
13634	2vbW3ZBqtohXGQM3A2hb8Xoisx4iZMb1SzbUhw1oWtcyo8Lw4Nwu	359
13637	2vbBLhwtvMYnasMEQ1HNcdx56Zg1eVi2yUxwa2XV5WaoyQuB3XnZ	359
13649	2vbJBrUzcyZiCkogh3KUTswgRqmChEmzo58doZrKeCEZ6LdxxHTq	359
13654	2vbmFczyUr1jMfUHF5U8KcWj1KCA3gcpF1KLMQShw7rjE2jtTfFm	359
13356	2vaZYjkXYBTTfD6PtL2bSeZdsUBKGyocPNcGp5aC4j2H5sCM8oVh	359
13359	2vbpePFahtc9cXRGJuVFxRLmoMsNg5nAFBtfUQ4BpHXYPAv1wzYb	359
13365	2vbFBGTfxkw4YLKDapDvWLHAUajZD3KFALrh3dL3sx1oLCKfsnUg	359
13367	2vaCNiCxjhmFq2M7oVnsTZLryJHAWk7qQEdKggaL5oMJ3NVGcJmL	359
13388	2vaqUiS7zrUvFS1dMxVE4WBa49UPs3rd3Qb6LRfc7ms6dYCnrdZW	359
13389	2vbRzGSiDKaLfabtUMgaryHVUo5Vp8QLbMVPDeNJN9L3tBD5jJGq	359
13394	2vaWDCjCjpp5ng6K1kCDyckcxrDQWN6fSk7eJbrYUBA1HaUU8Rqw	359
13399	2vabTdfzRbZWwT7AA3RKjZb6mb8uV7g1ZuiVMHCaWoYRXaGJuVkD	359
13400	2vb37MjjuZAqx23X5ewSF5Kk9pR1sYnhMLoWxtspQyL9ht3CP5TJ	359
13403	2vbyrqdbVNWo4cv9tmSsKqncRrsAhCZPGbGzjAxRRsfjzUqo1S2k	359
13408	2vbGbcn789wSf5bqYT83S92Fnh2MptYKuKEy2dwQKx96VsgNgNSY	359
13410	2vbyarwTbTTMhkH2NxH1Ra7ywv9S7i5FkHzhbVNrYeKyR5QuWCNX	359
13412	2vbW8gGghph4DBoecXaKB18wbFWL29Qq8f8sxLbPeeut5fzzey5H	359
13416	2vbvvXKsT6FADh4JhuUULGm3LyEq1zkEZxB2CXui8yBbYJBkGU32	359
13418	2vc13Ddg7WqETvgeDzT2e43Mah887TjVU2EJAahcBvQWTjhMwBzM	359
13422	2vagBdhDrSStn2EKEx1Pb9V7rnSjqhsqDsPViap7FTinQtodwky8	359
13430	2vancKspKDiNiEuh6dmhrRCaZRhX4tLrgbK5dc8UbNTFxf8acGbc	359
13433	2vbPJUAvDzTAFnXCYjTo6ERdsYR7j3vcMvNRAMHkzdWzw4awGJHu	359
13436	2vaE4ZiJwQbSnmPXjYV4WLrmsJ17QcsiAbWPkEdJQoRiAhjRTEYW	359
13440	2vavSNRQUM9AEQqut69Ps3PR5vcorGY2iwgkpVNZcmVTaMoCR76W	359
13442	2vbHX9Sd3RaHXTAXHQrY4MKKVpUJ3yZTR4WKZuvr7Cn5TrLaHU9c	359
13451	2vbDBPkB7daVbXcHr3waH2z9VyWtqi6eXcwwLJGiwHAwbxdkbU6t	359
13457	2vbHU9rDhvM931mqRoFjDDp14gAn86uXPS9rpxNEH1vgiUk9yqgF	359
13459	2vb8BE8Dj8K7BL5LEBGGVVG3vmeyE2be8vUFZzAviqr6dvG8nsW8	359
13466	2vbzk7XcdxjHFBy53vdnVTGj2XhKNCwjdXfqfo5FcxR7zZkodrVh	359
13468	2vbS1DuwFxrYot3Ly4xp8tBfdshNtinVk2gAjprdAgHCSX5chSyL	359
13469	2vaUSgNDYgvr1gjWuY6B88x945H6FUqvjyotuF7s7RpZnXAbA9Nt	359
13473	2vbQNaCd5QBtDbeao1GM8giToiRu6J9reaaAV9tpuDupUwuYjfPr	359
13481	2vbory94wiKcEifdosY48HH5Q2CyXyWV7ackk5Ed4SvSGqBGtwnx	359
13483	2vayCGnPcMQspiPAu2uaEMTRgYTrMK9nYtckcgSKQDGStVcFcuad	359
13488	2vc1XY1LiKfkg6y7qAFayRj48iERpbNHkR3fyPquBXFeJbixzWCq	359
13492	2vazbkCZfxMGedE56PQMJnWbyU4YikjV81SuCzfwwYhQivocFk6F	359
13499	2vaV14oFHavcmeJBwsovNQVAkz99WZK1DHoci5PC1qX2oBAGfZ1f	359
13500	2vaYskfzQUV4Nv19pqMxoNVyw9UJttuLRd4hWSj7CUDr7SbYWm39	359
13503	2vaaVhNUaNHStFz4m7W4tEgazwWDPkbLE121trTkSk1V7mtYexpj	359
13504	2vb8CTVCL2KKqDZFXQeyn4AHXX2WJQHzpAJoBasVyN2tHSjmmvzW	359
13517	2vaWpZo8HCPEJWdsg7v6C9DkXTW46ZtiQyLXn2SBWZc9AuwhLwHc	359
13520	2vbweg945tWvYnyggoYtWydJy1Db1FAMzPZTjFqqGtv89Rdj4dTM	359
13523	2vbiFsg9emL9TYb4B3zpuhpoirk4uAXFnxx2K4i4LkrcRQqbjbhS	359
13528	2vbP8N2s3CK93C45NsvP9S43EmuTguYicdbS7seBUDLKYUSMzXkb	359
13531	2vauA9goLPpSVkCxkGU53bg1GnNjwYaZok5nWnzLrNvxHQNX3oMi	359
13533	2vb7Cp1dYmrENqboQFfL1a6dbNoMfAxajXJsEAGCuYPmtjCUvhRP	359
13536	2vaK9TuRSKQiVZWUThtRHvB4ePz4uN8D9y5VxS5y7LdjSxVXmo77	359
13538	2vbFnXJwVoq3qoNEMo1n7phuNEcPqNdYU8r3V8Ms1Szugd2Kp6na	359
13544	2vaTV88oPMgV1t77fUQRvRJJD2gcqnYD7KW2f3j9dc8YzoQf42T8	359
13548	2vbTANA6wVWP3ds76NzFDma5tJRLd4WrhzzUw2rMtDBY4JeTVSfr	359
13550	2vc1DR76tezCYq3fMzoHBo1arHPzgFLGYscTESQBqSw5riaq7Dr6	359
13556	2vbuW3q9capSBRkxTKvU74VRwepjQ3D8jnXFQozE4yLrVNQjoyns	359
13559	2vbxNwoztbf63T1WkgvzHPZhiV8S8zrKJqG7pvKvAHwp4yX4e4Y7	359
13561	2vbZG7HiydNVUrNc1fdd3UhxSxFTGpYyWo3WNtYouBihvNUHqvuf	359
13563	2vaPnhTporUgBLCTFGAFTW1TjT1xqSm29FuDK3yWeS9hjaEdekqi	359
13565	2vam5wVqaamE69wKBBtPk6xqAFZ42ZRfqQZnuEzHgDZNXTyv4T52	359
13566	2vaE966XjM5nSxRgdtKCYi9hgWtw2zr8vFnt98RDrPeUmDU3pFWZ	359
13567	2vbbzLJxBJBfLAB5i7kEP9J7y8GCs7hPLS4AbcXGhkYJ3f81kDst	359
13573	2vamqgXWZB3Sx3yn8wghRDcvEx365SqmCz4NJxZ55o5yH5NENXJT	359
13576	2vbLdCvkV3CdVibtNtTvsxtUA9Zut1UkphVyM21vNk8HYYsiFGrw	359
13578	2vbKjVm5Q1aYJEdSWY2aywiyjSUPdisNjRWicEe2HQwCvyxqaWa6	359
13582	2vbCMUSPojEPuyAQWPpUaC31SVRXMPkVCKxoYq2PuyaamE3ftF9o	359
13588	2vbGUsYQC4c6xFFNYey4v5Ddahhd86cmUzwfiwgrxbGd2i9EH8tv	359
13602	2vbCtNsz9JzcM6BDQLyLnj89KP73jqUWWGAsXdjRadS86c7mVSww	359
13611	2vbcxrHLkND1FCosAwZ2SeevQCTJG6JoAzMjyUc9YpLbj2Xv6R8Q	359
13614	2vbkUV1254XnAqFF5JEqmvjA8zXLtuYd7NiwuNaEWuQr2AqsnLgH	359
13616	2vbY446w5UqiDbgkzrcET3B4FfQbr2SAEnr2vFz4pCXyjLhoZg5U	359
13618	2vbZYbDYSAGNXxgDqHzc11YWwoDrEFheUxKk5upji4vP2s8pEiPJ	359
13626	2vaZc5TnD8C6aXqmYGbFY9vUdRsqerJ6hQQhBS2yKEiZS85vDpGF	359
13631	2vc3VciREtaFADTF9BFadEh2d4E1CAiLX3QTFbMRTADuXfZfRrhg	359
13632	2vaQZMSeftLXJbbRTyZb6A9TirdjYQAAc3ggQHWnCwikDsDsNrjU	359
13639	2vbjP8p18o7sFWMAf93E914v8GNfEMFsncxKU5gQkfirE5nJbKGU	359
13642	2vbenPDCzXsgMBSCjA9fXJE5iUQMCFTL68ZRfC3EFfv1sMNpr5NT	359
13645	2vbFkkVkeudzw2AshTL2yTRoP3h4GNUAww3gkFYFJhwjphVr4Ubt	359
13650	2vaLFE1sN6pWxAbR9zuUGYCQSGEzMZ8YwZjj8DgRvT6LZy1EJYGu	359
13652	2vc45q5U6GJVDVatb9W3mT4RbJ3G8xbcuTQ7uKJSQgh9hbb1s5Ry	359
13655	2vag4NSrekz9DaPgvD9KxgEYyeRmZAFZCPFVuL1GjGCKVstDikeF	359
13661	2vbjQpxyMFqrhDbbuw48McT9i5z9y82voqfQ9Gymv782SfUR5QMc	359
13668	2vaYsjLF8mB6c3mUepanYiqJvtsctkF5VTQmFd8QWRu2Kd1YGq7p	359
13669	2vaEk474nZW6Bkviq3XM9TDfyFdneW1Jb9nrodAynPwLpk74qNsE	359
13673	2vbz8wUatMwCTvew9bdyThPZD5M85YUDDjc2PdGht9zK1TqwVuvp	359
13675	2van6TUNk96thS9aghAGNsChSv3vyfrSQKYG3dHnmudba6dfN1Go	359
13678	2vaLJakS8gN9VPzugkSwmESYe1eN29mftJ9vKcyXKRhPGaZ4Np6Y	359
13679	2vbtG8x6wgKmV1sLBHGPKA9aG1guqX9fdYooPjjUGoygjJU55tqi	359
13690	2va9w6b2tDWMEu6BJrP2nzwTa2vWwxFHwjVsV3h3sm3gYuLZeo3N	359
13695	2vaKGjtMaJuivpv3TRGtfM2VvcuCfwWDuRnBaBLfJVBDM5P1H3iT	359
13697	2vbbVeiCEgD61Uj6BfaZ7w88UVecTGn7o9k89pSX1gpRhTM1oe2C	359
13702	2vbp39uubeumZCVZkGJ77FP7UxWaUUKiG3nJv3k4qMQKyem4WjpA	359
13709	2vaDDJ9LD1Aq4PdvKu9pSXwomvTFqz4AmShsJd2U3AxxgfwqwGx6	359
13712	2vbdmXuzCWMHv6EhD8BjCYcLpFh3NbEUiK1N7GESZpmCwhyX93NM	359
13714	2vaS45meEtheaSyxYL8KiHwZg3BzPoR3cBtWzk4M9Yo3WnnjfbTd	359
13718	2vbUctwqqpA9CgFSG7LtQLKDCaepoF8uDyAWKv993VF7K8rhJKFa	359
13571	2vbumGTXKSKzpGd2Vx4VQj4BML2qcDoE6rzHqaMqG9pAdBDQ5o7U	359
13574	2vbbNWeb69cxNNXRx5mHWxwpywEvgsNCQ1wr7VjJZQhyzYBEZ1nk	359
13581	2vbTzs2TWXG7wvQfqaTUYWz4kw6vbF4djm9rv49YwbZs3Xy9nuiY	359
13584	2vaGEqyV33NVNz9GDsYG8QquaDEAcUKepXNiQBPMuk3cXA4Gaq6q	359
13592	2vbLK1opAdzDZfs9s1oN27JKb5ZzCEx8DzTnxWcom97raGdpxP6Z	359
13594	2vbG7rad6bpu1GpdTuRwjDJYb4VnZkVDw6LkRYLFeVLNW2bNk7T8	359
13603	2vaCkECpe5NAWBy2cijFv3zWrufUChL1vdAizwcNkvsqHcb6yf3k	359
13608	2vbo7eujyRmW4WzbkKwSVQBNWWQMPGBmT2jUQezYkmPbe5EdvMWZ	359
13609	2vbHmLpeVy3K6PqU3NNUnoDYQLNzwY1Ak3xyFXJzCREmUdJo9Pfg	359
13619	2vauwqWdpcxizpyFG4xWTtPYWdMK5eU9xTLa6E5ynsQuUFAMmQvE	359
13623	2vajfzco8h3EixKv65tmDBaRyE27unbgmvC2tY8jL6GXbJbXfy4x	359
13627	2vat4Lv74gVmXqCiVQfHcyF6XLGQodbHiswerSvDMvSzAwvY8fFx	359
13633	2vaoThLnhBNxN2J2hHgyaWF6tPFz74Ssikn49Wx8kpYASokSRUL3	359
13635	2vb9Zs55yARkMuZQgX5yTB3YuVWaxjPP14Fxczt5KFKETC4v8b7a	359
13640	2vbSaQK53RNuNd21BWUgjLhAkZpPLku83UK7wsE1ReyAsFqPKUTw	359
13643	2vb6iBvtjfZuKKSawdRHV4csiAQMAzXxuzAdr8AhkeU6aKZaDZUf	359
13646	2vanMgSbKsrswB48SiNAXmqxWgWRcR9Za8Yy4iyS5j83UJMvaE6Z	359
13653	2vb71pRkXF9XkcKVoh8TfgVzvJbpym3wTWK8TmRCYY4VQBV3e7QD	359
13656	2vc3nhR3Wg4dgC5n6sCJZ9wvRwoak1KhTR5cvsai3vspnapzX4LP	359
13658	2vbKtuVy33AM44to3wjzzuHZKKMBUn42hpRWA3vsY2M7753Xb6LF	359
13664	2vb3SPsZ8De7Uf3xjq3NYj7aRepF4NVhbRgf5Q7QeTFBMxdHbxxb	359
13666	2vb7wxJXThmGmgj71mm8aBi8yBAK4EaAyYQNfjJ1Ve2JkZqXCgf6	359
13670	2vb1T3zQVUNfkPWTf5ucwYKkcSM5LJxzti9Gz1sTsZyT8NaSh4nX	359
13676	2vaduQ7AFA1NM6fFUWaxwavXReVBr32NonYwaNmD8ZGZctMd1Q4Q	359
13680	2vbsk57aFc7SK49ZPHAtQH4w4Ep81ctUZeYLk1Y7hQNJ2vZ28twY	359
13682	2varCNFqcx4ynHeactk11B8Rfka9mgc8Y7QJPV9X5mJbNZqpfXrY	359
13684	2vbGCdWhTzKXriAt4TF58qgJhxAfYq21BSM9DB5EqgXRH3NiQtZT	359
13686	2vbg1mKfX7q88SzpSek5CUL917K3NaUk8xn4rc8XmpZci12Z7EPK	359
13688	2vaPi8iJNRfmEHE46L7Yi4SwqSCz4Ymt6gjGktKbyJdyLu3T6hx9	359
13691	2vbz3V5wNNUknd1XUHZwZbw9Yk7wYr4SeQxMJ1vSmtvFt5qvDGmd	359
13693	2vaWTMCWsURvFYx4rFPZLuSfpwVE2mtZvWF62Qvj4fRLPpQB1nee	359
13698	2varFC4KceAahgRb7XXsCrkCwrBSoSp1UHtfEjnhZ5beUggcsUzy	359
13700	2vbkAZLWzTe8zPRz9bBETbEar7ZUycPLMZnizsikWVMFRvLW7nmZ	359
13703	2vbz6Dj2X7752KoPC4EZtcYMEgBdwzzDuhSh5UUijwgEbdhmzfM3	359
13705	2vbZi7dbRiddc3DjvoxgiSdPxYYacE5VHGwgR7nSH5abx3wGxQpu	359
13707	2vc2KFEXF7xX7kPPNjqWAAqmd7XwfgZHD4tuijTUDrY6kP4AYoaB	359
13710	2vagN8QVDtKCK63zLjGQYoWUi2CQyrQRryasxLrjC59LEBZBwuqe	359
13713	2vaowDSrFZD7xTcnS52VJrDstKu9o17evyceQbcF2mRkfiFm1ZkA	359
13715	2vbGgue9vxP9ymR2YJffHZkWx8pV67XL8w5bqptKLvbAZPAXr8Wn	359
13725	2vam7BTPpSFuD1472mrN6xjj5A9Mz2nJ3t1YBFLKq3CQMFbBnZMV	359
13726	2vagqdHQMJKNoELbDsFSxXFXgtbTd6xJ15VcP9TZMyCUs6dSWMHS	359
13730	2vb2DZUMgfeJunwgxrGnEFQkCSLBxZy8rPmnuAKknvt4Cz6Ccjqj	359
13733	2vahYkrgZ2XHxvP1LFLjJTERqPkUWMkingvoaaPoaEBKoiRwxfSU	359
13736	2vaTQbGgdb5acQvURe9bLyX42VJnWwcDMmK33Gup9Ygmx3NuxbRc	359
13741	2vb9wtLLP1oAjkrtYaNp5b3moN7VSsMD5unFhbvPQd6GpEsxzQvp	359
13742	2vafh8uK4gSXT2Mi7njpUqAJJPrPQ8n7h3nRqZLqffXDhzExsAPy	359
13744	2vaSoMZuqNWZZGx4ro9U1gtzoMqm5mXkTR49WxQjtb1ipPqqmwCD	359
13750	2vbipKxwD9WJY9yKhog58i4A3eKFJNbGMvZrq3jCPaUstNXpPz6P	359
13752	2vabbDhuDZiCYXqYqYYaYTSgz595h68DRWn5ZeEW1Ns45hPNZWxm	359
13756	2vbcmG1XPyjwEktPFiukENegv3c9zVqLhfN6xzQwoNbwXfRPihYB	359
13757	2vbfGq9882Po5sdZ1w8Di3K26C3pbY5MVWNjQ9qv9iE5x5rpvfKW	359
13758	2vb6rkiTmjCncSBmJt17sELQ6Trs1UbMoU85Db9JtszoymMaB1L6	359
13763	2vbrt5eNCnRXQKuLBi65mUDnJo2P9WhiccPVzhk8JEmbtxyZifQ3	359
13766	2vc2mS6MVHCQXki4ep6AzY6UjY4QRocMh7jkmo5ET5bMPJ5hVGRb	359
13773	2vbUMcpLd5FHdhjfcLTR9P5a9TLDDbDhehV7qHpyf3Mo3Cigqq7N	359
13776	2vaM8sZRvzRGgEwgb1JG9g17U1ys3NMRdxWAVSmg1kYqr9Uz9o91	359
13783	2vbCy4SbtEEBJxNkoe5nXnTwuXmPcDUYSeRyRdVxFvFYmRmwNLrQ	359
13785	2vbdcqRsL1neCAp8km8pk4BrAyq9r97kZMqrM3vA1HXSbB5YTVjN	359
13787	2vadFzgr778nBdr9y584CHpLmYB73Ecr5rPkwJ8rUwLQJYzh7Ysj	359
13792	2vaJC8jFaqzjiBBD3GazPnqUvfPwgYnqXWoAV91G1suRJNKjWw1J	359
13795	2vbpeAnB9wPof7886NrfAVi7ocASNdiFVCYFZGTaziNB8NBxtXWd	359
13797	2vbGegDy3HxEC3WWq6hWPddgskDJkUiVe96Mp5LjZe8wG5Zrso8p	359
13803	2vc43wxxYhXMdZ72JYG66qNX3F61FHUCqxzYBtLigMBFX33hGBzg	359
13807	2vbahFgEPdfCx3bQpK6DzJvCqVoiooSeqReptfBCF7CC6tEoQJeq	359
13810	2vb5mySamJd93oPByrwPQmEAifvPnHMKJ2Dg2ufGnQmnYYLkPyvm	359
13812	2vazKyjJYBE43Uqvxrp9Bi8qMjmqQbFjiZ4jqompmoMEQoWXE1dA	359
13816	2vbqWUzsjmF8bPnWAfiUf37gm49F2w1ekd9ySS4jYxHjP7FAvvUU	359
13819	2vaE21QkUiED8fKUtju34qPdSgpxYq92RGTawrSsHes76jnGubXA	359
13824	2vahtpZwWNWaWipFmi1eEcYnnrSS4erPVHL61dD1pKc2GxrGuBYG	359
13827	2vaba6npL4JNVTE1NPiVH67Wpu63dvYYNLhSc8MaHbUrXtXfZpHJ	359
13831	2vbYvq2pApSsLgVfWybze4pEJ6NSbFSFRPBsXjEKLk8Ead3TSka3	359
13648	2vax55iqnF2tioGhgWjDm6ooYMPPzDfSdrSf2RPtwKtgs5oXof6J	359
13651	2vbvh6EMxMYPyta3Jj6X8FDRe8HjbpJJgLc6YkSidAohJtJi3YwG	359
13659	2vaMYq37shQzGfDaRBQuCgjKHYDh9xb6YQssvCA4EMfpLBDAQKcM	359
13662	2vbSdYL8hZHLr7y75HnSkf3iMBV5qZmF7xs7JfC9vwg1grGw8yhM	359
13665	2vaRT6SWK6wDxxSS59XC6f6EvJ7XRM3j4N4w4vLZRAFF5Hvdsehf	359
13667	2vbRT29EMby6md17rVyqFj7zoLBmJ1m9KpWXNUEcXpAGtKoFyx6p	359
13671	2vayxKTF3P2ixxxb3zxPjETPHDVd7rE6xTHch7x3WMw8XwDgbAww	359
13674	2vbQP2pm8dtrhv18yKHkoqdAmVa6MaJtt41SK8DGkqJsv5m6fQNK	359
13677	2vbSB2ZfxKti8LJWL6BgnpysQrXD5Tu2BsNzMCzznmyZVKuZD6Cv	359
13685	2vahj3cPC7DHMxvDqrf5oMzqvSDPjQGuJbtbJ37ch3FmS3zbC4wH	359
13689	2vb8AbTZx66CU93gZRFXevhSg6v4CmeJgY8mmwhhS7Poen6M6zSW	359
13692	2vauKQYfeG9KDp6WTEjDLbtvmnKwEwo4478MXmyeU6rNwnQ92wsq	359
13694	2vbgAaQCZ3G7dN3mf4gLQix7dkrUUE4viPZneXF3mknv7XrBN4sK	359
13701	2vbqkN9reWDa3uGUaWGETrH385pjpuweVpuBEmbeJ2wFoMsakqP1	359
13704	2vbhNc86DehAxyxoyZhxQCHyD1ZX56BXvNRrKCwhCjcTFvc4xyLw	359
13708	2vbofAM88HpxNXpMDf8Q7JvmwkJdeNEDS6wVQZp1TpmatpR59mcb	359
13720	2vaavRZoJ7dC6Cg79J4HyZrd2qVJrAFSTrRSSFgxr5uP6QHenkmF	359
13723	2vaYZi7owVaVCa2653umApNs6B62weTCSgg6FkdusybCEuxyRSjE	359
13734	2vbjFLDzHVrFCauR8DZ8J64wywBYMYrXMPCZQm3RGU93BGCWQS1D	359
13739	2vb1niDkQrGqmGsVep7uDJDMR8SA6jmJU4kC46KxyFToJ1phTAQg	359
13743	2vbV76EXTcjkacnnqU9Yqjkiqy31HYne8sTBa5EwmpB6fUvmS4Qf	359
13746	2vabb4DVTYabZx8vn7WMoAP6Vb97iDv1gMs7zPEARd5QVV3XHS5p	359
13748	2vbGNcxpxHfHAYxirJs9fqD4mu8RpBFY6u8N8mCN2SYdRK2Mb41B	359
13753	2vb2174CXoMcaF1qn5JJs8BCW2vYJ6nHWfzmZoNW8kVJ1msEm7B6	359
13759	2vbXRpHQR45jpy9RPjQyoZW6ZLfDsorwAM2cHYvcxJWCuajpgqoF	359
13761	2vahf2ZLLRHJX8c6GR69h8GLcVEw1gyWQwQA8pAuLdjoxeQJjqE2	359
13768	2vbPxttHxzzFeJtxNUz6CbX175SrjZ8JgGYU364G4zLwSHDsYch2	359
13770	2vbbgBwsnZ3TNPALV1nyb6Q8gcKiy5y94NQ6ahYkLtuHHcBCb5HM	359
13771	2vbMsjxrsqGjv8aL1zarGdTEUXAZtVU5iMXnWLeuKMWRembRMo9z	359
13777	2vbm4z8STJTKX5Z6DnQCiKVXTcvxKCqiV5up4xkT9ytzeHfENYeZ	359
13778	2vb7urjVgZMepMHsT1jdp46nCWvzMRgVMNm6b27yEDjMjZgfdP1J	359
13781	2vbjzhT34gppEJiSrgfTwYbAEBHenjs2y1YRyXDijP7S68p5EpkY	359
13786	2vayhoP63GqwfNUhm8D7TGDvT5muEKUxGvQu9h2DpGUoM3QB2LZ5	359
13788	2vazNTCBefgRQ2Edco9aHiEQTkj3TbfCxDKeHhi2gduwP99R1k91	359
13793	2vbsHyReQT3UAzjAkjGe3LiZndxj7mRVbn3baxyXdKr7YzfLLr9D	359
13798	2vbmCW66AMZQ2FpE1Rv4eruviH2gfABiF3aqN8BA16bckt6HkHE5	359
13800	2vbJbgVNcmMoabY1CwdZdFTk9u4u79iEAsCFTCoXpvjFkcsuKEFF	359
13805	2vauUdW3yeaWM68qF1rLRV66omxZvj3nfpgvf3j7RKrxTcG3JnGy	359
13808	2vaUmhXG96YnzztDpNnGNetsNRzG5Pmbh2arvgdmJf6GZdKf8zD7	359
13814	2vbHyttqk4Bq7VpjXu6PKGpkBDZYnPCgF384GHEkZFFXcc53gZz4	359
13820	2vafccSRGi72sX7eMmhoGe16VRgSURsX28yxrCrRvFcvnCcJZ9cZ	359
13821	2vbqbgZw12RAW59uocgXj1KJC7AiQYysArf1kasE94d4KgrHAmGy	359
13822	2vajx7Ww1XSFb6qKzTivdWXVyaMrmZKabTjAJy6JwmF669B6CMYF	359
13657	2vbJajkYoH4J1FTUa3wrbxw79iumEUwp3wqK3tHGFxq3SDbP5Hve	359
13660	2vawUxm6CRwKukJRZFsKjTMAVPfzPh2rBFwobRLBUb7pfYiU7e7R	359
13663	2vaJVEiuva9Bw27Hoe6YvckK6h3sCRCm1M3eAUGJeqXS8r7AwFEg	359
13672	2vbUHyTBXFFU7pp5mpHyp4ns56oS8p5eLCpBapedNESaMVt3YteZ	359
13681	2vbCAbCSwZUoGmpkTWM59hnSTV2BwzmVEaBPYdpTrnbJD2wX5sQM	359
13683	2vb2a7EihqQjA2K5bGpqrFn4Kz1SxqLgoDno7gA1XrEfy4tAixdh	359
13687	2vao2bw1SHYDY5auR2VbG3g9kBFkzEHxyQCRK7CwXosuEiTQNwdS	359
13696	2vbVroypj12PQZJAF4ArSLaMByWWsgoX7DcSseuNMvxYvcyi1rqp	359
13699	2vb3fGKBe2DmCXwAJZcwSptpxEYd5vaqKrEk1uqSi6eufjnKgUTG	359
13706	2vc2xjpHyDoEu6VGsCKgj2ZMQTN25RT1tPERPpSt7VCB24voWdPp	359
13711	2vauyhP3wRByQaz5WxCbnnUiZMs9gYGJdz9MCcsCdgh7LPxGp6CA	359
13716	2vbXYkL25hxFuJsKrPhN27Yx47ogJETvnJb6aSgNQnjxPauYaDa9	359
13717	2vbeo8RhfsM6fPcnTkv6jrTzi5x4Ydqhx89xjmbteHfEBEjrVf4N	359
13719	2vaczEaehfK9K73Rn1buetjprjwvdZEj1qvDJDs4whGWzUKJrNau	359
13721	2vbL7BDbK2aThDne4ks4u1dqktEc54PzghNzL2N2aVFKAAn8Bhm1	359
13724	2vbbzy5Jew7JzRpxfq6HUFduAsc4ajC6uEbgLSqBWtvbdp7rwCZy	359
13727	2vaZdRTsZspBawjzwdCU1v1Xn9VoVhjwmYTWSjJAQBGa7fbmuocW	359
13729	2vaVzdqSYE1L72t1LbdZpwJTBu1Y6GR2EpcYgM6yZhZJJiyHLdeN	359
13731	2vboigFM9gtsBSxBLCjSfYSXfZYDS7uZbPwUjZ86gT6mew3XTVnF	359
13737	2vaTkxaQDtkLGkW9VyuKVhUh3rqVgj2GzFQbUWz26smcJBMAbJ6K	359
13749	2vaZvwJt8hjQfAHNcAdLgeH346oZBG5fQZPodbRYPUcThpVXbSQw	359
13751	2vaoRTcCpjXqQPj6mLkDmVDx3fZ1D3ZEF2Zg2HCwZPC2oCHJppck	359
13754	2vbFohbMj2oUxCyLL14Yx3kmFjJTV3roefXmHgJErs21y7Y51tfC	359
13760	2vap5T9pjFiWULZNJo6saahGiN3JfbZg1a6qhuxXQ5r43ANrDrMH	359
13764	2vb47q7qT5YA27ngAMFaHTAk2iycyftFCrydRouNH9h5ujiF2B76	359
13772	2vapq1GqDeKbsxXy8Hhbbs4BegWGnvvxnrJUWrfiJFttZmuuy3Fm	359
13774	2va9c7o4jyXEmfpPyAp5YVLbroDWCtJYF3dpBpE8WMxvB7wmGgBn	359
13779	2vbrQUE9sm477zdUDQFgGvsE6yY2V8YxnTyK7B3XeVKTwA2ZbU1r	359
13784	2vaqEbVT5RSf2F8CNsv6aF4MmWZ35mp6FUPxVEcH69pZmbqpAG2H	359
13790	2vbqSRqyReyisHK5XQgocXtYK1Fvz4mUkAVjj9jNnvfZb85MNb65	359
13794	2vbJebjUtyDuLeVBYREmardJ36qN6WQFpZnnqt8PMjxWjcyAGTTu	359
13796	2vafzB4A84ihZWLVsctHYAJvxZCdswmJ5PJ86wEmh7U54Nv4kxtp	359
13799	2vayk7uQ8jhTeWDAJP1YYYRuSa9mgY8iDAx6KgaFRdvveDQVwJjm	359
13801	2vbZMG4ZyLddRWSG6tz3adxJ8G9JLFFWtYWiBUQLnsERP7uXKVYM	359
13806	2vaWyHKyHmXrs9DvRTktoFMYqy6Pk14PXKEprKUZtEPnZrh7L4sW	359
13813	2vaZ1shw4heAq5PT7G5btkF6f6whFXZ9tXtqz2HG6DFkTHztbuc1	359
13815	2vaSmeJDre2DdFkm5ZigbZnSTDCLdeZUsAPu8eCPTpaDbfAEuvH3	359
13817	2vbP2mPDEJPigEcdEwsR36Gii9F9rix6pa2fzApQ7BwPLdGFAgiw	359
13825	2vaGMEJtFMMChxNvbPgM9cKGb9nMAeQ5ZSGroTQUyy1muuZBJ6h1	359
13828	2vbqpucDR2USYbKss3Y6RAYuogxa2YKUUzepbWQmcGVzXuT2uqEH	359
13722	2vaZ4U7tmU8XuEbkJHWACPfqe75w5nVRHL1F1GLFCRqUB9rXhRvu	359
13728	2vc3x3ZqCbFoijraRN9hJYLmxxt71aoYTSwSwjzk56LMSARaY7Lh	359
13732	2vadSNaDPrJCzZBvUyBkT4Ge5c2YxDxLoByQ3mPyPXE14vDQ82Ng	359
13735	2vb94QnUthkMVGQD7uYMjNNeiAeDEpwLGQXB6xdwZCngoVKCaN4i	359
13738	2vbrUKJAiSThL1SfM1oCD4GiyKP2VPQ4hqTpxN3dbzuat5BXBDQD	359
13740	2vb2PyNR5hM5hmES7EVuZobYEnWBocTB2LbqibscGq6rDqYmJFxF	359
13745	2vbcYyesYJMG1yPWyzMGxSbXBVRnMcjfRfNB3LbzrMYKgL4H4kdj	359
13747	2vaj7bYqSHmfrWKGmYUk4DcDTxayaAMPxUjaTtrn7Q6n6kNaFkr4	359
13755	2vazAnwxTfFiPun1VaAVZtihvCKTwWPSCWofUd3bGZa7pvWPqSYT	359
13762	2vc4hyqvbyEGyVUvZeyaky29toDrHf1x6MWT1KLWZNEYR4Da7xEe	359
13765	2vayFD6amxF1i8u9evDidUPAKiumrQq1QsrJp1f5WoSpvczqDu7F	359
13767	2vbFVyHCnvgU4Qpin7y9q1VGvkEkk2eD6TpqFiEkA4ddTMwukiUg	359
13769	2vbmQCmjod3FL67D8ESMcLFzby4EKrqT9aJbGFx9KAAUa5DemV2x	359
13775	2vaDBPGmnj9exwybsCg96wqPpuEJSj3SLHVxHVgcCuS57s6iVtoC	359
13780	2vbWtFCcHYkNx9byotuUfMLPmUnvzLGvzJfhSXaNRBcGxnUEKqAH	359
13782	2vaWAWy4D9cQto6WEgKTKcZ8s7CnhYnMnf2ejrp5wk9vTDCYsaiG	359
13789	2vaAuQiWt1xPGLodKGp1HxGa5URqc2S4KEdCiWMhjzWLZ78Yu7U8	359
13791	2vbQKJ4F1YyYeGeuTtCs4foPhHa8iZmG9sAxBbB2wApoqTKRwejk	359
13802	2vaNP9NWSFDDSrMu7mNs7uD7KXPWx5ZDAVuwQ3rqAaMjFrVma79u	359
13804	2vaySjB4B2TCPXRmbTVgmA57Hat4vYjhNGaDArH9Je9JmbdrmK49	359
13809	2vbNTNvcQHENNPcTu2yZuX7dt722LR4neRUmeM6hBgCcRTgj6hTi	359
13811	2vb4PA3FLGxcRBHgMsQtg6yHLkXKQLygusKv49Xmw2Ak5sv8vd6p	359
13818	2vbCdGgan761dixszRWoDHJmnrATmgQNw8uipWUpG771QhqES3tk	359
13823	2vbjbV5iN9byDeZF4CYKD4rBQV8aoG3g41AEvsJ8pMobYd9LgQ8m	359
13826	2vbUyr1vBzhu1UpyKeTfVJbwbdb7equENPw6wnHfWMmNUCVLD8E4	359
13829	2vborENrFxFgkMWBmRHYZWJnbcqRxYs5EoVHgMjch51f9JAyoeT4	359
13830	2vagEocAawSUjAJsFFejzMivuTpuKVpGDFrEFbDK6rDGsx5whPd7	359
13832	2vbarokCjnr6V4dnpu84WLcHkFmYKnv8q1CZub9qeSZMZbo3qfQe	359
13833	2vbGgRdBmcYAxNJfAqv4iPksVmBQrRr1qrAPQQ4EknFMn7DrsRyT	359
13834	2vb6PAi6hFsXUAsXxyi87YzEQavgV7Vt9wxnVpg7RrREYhS4cfBZ	359
13835	2vafXciofm4MYNsXdLKKEQe8zvxHdhKaL5P2uco7x32RkWTuG1Ez	359
13836	2vbtBGRmq5ZE8PfLEeMc6LpANwsNeGFWA5LyvY1KPot1etg7Q8eS	359
13837	2vbjjJA2ZgPCvhiFd4TUs35YDT4PP7o9G4fFgq7KtzMGQXWRpH7y	359
13838	2vbZPRcwF4pwbPsc4WS3nh6DVb72XtkpBFqxnYX1yoRzs6XMChXj	359
13839	2vaMDQAwPQrwDcrUnAzeJ99L2YKRKVviNTrEpygS1aW5eRSNdUwq	359
13840	2vbRXmduUwVR3Wqnm71dsjF6UnFk1JSU4kDJSWbVhuR7LNwxsQFY	359
13841	2vbGJ7J4YPm9enSjDx4VGKruo98Ju7fwrtdbY8N8c14Q9oaicVMc	359
13842	2vao2m6tkidYoowWd9RL4bNscTJUMyJfzZz5fGHGqK2fyz1SuNsv	359
13843	2vbNngAZ1WpBda2XpCbkrgqd5gWBYXjZkJfLKNfPCnqorwnZV3Kj	359
13844	2vbiggWzbD42kLuckmvPiSWRs9hQrpkta3FhVdczinYdpyHhpXUR	359
13845	2vanGfjvxtfqCSLofXMbDUWsnNTMgYh4KH1ibXPQu8UvXizXvXYH	359
13846	2vaJ2zSXvVRVLbFbzcwHWsxs13f7PkNvimjyB4CXYr5oLwfFGs5p	359
13847	2vaA51p9ihrXGhWeJML7EKTmHTDHQfZ6oTm445QEso8P2zXJM3JG	359
13848	2vbuEAxXtUDzRa1SWbQY1C1mSeh8qwUGrfMLY4PxNoKS2YixaHKd	359
13849	2vbnvZZUtJ87UTqCJQb5dN7jrCib2yWysRuppMws9GbGiz873xwc	359
13850	2vbBvNcjyT6ZxjT2zm67wA2MPsZxMsHkGCCn7gUE8uzegTeaJYau	359
13851	2vbKzHpDcv2SbjZiPqyU6CNvACXzhEBujr4fFfhQCTj1dsAmue1u	359
13852	2vbTDxfVoFviXYgG4TGLvN1Po75n18QhfNLP8A3y4HaUo3BQogc6	359
13853	2vaTyMMxQ2GCWpb2bP2gHA41hb2QM3jbyg6dLW34jpE3crFUH7rL	359
13854	2vb91QC3eF4JLCGN85Kq2PXoNWrhQ2UUCAr8EGPZkUPK8YHaQx9Q	359
13855	2vbXtgyj44gdGbfr4437GAemtdqEYybtpbgY5Z3biHuokQessZv7	359
13856	2vazYpQ2rh95vr7KfkQxZXdiffKE3xhSkLjiYU5NivUdi4UiHNLh	359
13857	2vaCh5a5QdrF48QrtNkhVAtXmFrdvQfiErYXR7pUJb6Wp2KTicKN	359
13858	2vaopoyrW63HVHwjKNoEUVFeJNoimZoRaM3ebTzCxFchTGxBhitU	359
13859	2vaUkXXv5LfNrWB9kDVEKpA5baUEhLDPC3WLLpGG6UHNKYn7h4gN	359
13860	2vaMv64r93qP3qmGEB8H4EpAJ1SmEtPqcvfpv8wM9wGTQWVXw8mX	359
13861	2vb5EQMvJbQ14N3qHVtfRAjJYySdxTQUFeSpSk1PTTuWRxZCzuLB	359
13862	2vasbo1zyAPDWYaAZFctb6gepxqMaBkB6YPgdC7w1u1sVDauX54L	359
13863	2vaUBB1Lk5s3w26t67XAspNGJ8Aq4a9o4q5qk5chRDqtAg4qdRpy	359
13864	2vbp5QKrhRjZuGDYNbwUvP9d59geb94ar3qDG9KCLk9G2Zg9W1Wc	359
13865	2va9yXKJV2usgtJZqXJDrrHseYGR88wJWzgppviaJ1qRv1zEJcSA	359
13866	2vbhLcyiRkeye3FFrYaRh9MAWArQA2HNtH6iuavGdJiugebog6fb	359
13867	2vb6RiKGJTp3NhuhPvWUMQoSmSQC43aPN1qnZWJKqvfr4npML6NQ	359
13868	2vbAY3aGW3i5PsbEtef4q2QV2ZyLanmmi5RoBYvFA3dEGRPgxJmm	359
13869	2vb59cz4C3V6sBEHhP442igTEZ9aaHcMCXzbHqkSmFvx19fsqS5f	359
13870	2vbWVPMn9xx7oV2QaK1uUGnDMMsHJpfPZSqhTko889azfPZfraPK	359
13871	2vaQhCpQLxfKLnatG35Eqj3LvxnVaiyEiif5Eo8dqPiqhFciSKsb	359
13872	2vbsvUFx1Ad9G99LqxS2DDWvVjwtEc3fKAjR16tfm5i6BegchC4q	359
13873	2vaf2CpZs2gGUVzUFSC72uqjsywis9mGquRmkndreSuBnH6owdtJ	359
13874	2vb2u4Jb4Gm8kFP5GBmiw3DMKEmwxcmZkddDkGkyfetgpAYV23k4	359
13875	2vbZ8wsmtXhWx1YHynkkFuw6gZYUDsq1YvCCobGXpY55thmk7G7o	359
13876	2vaMeFhXUp9JzCxEzqgbpriQG5xTE3ggvfYaaqacMtMYkFv3Trhp	359
13877	2vaPFiD7PSgQZV7Yfbzz8764jDtp3rhdHzoM4u5Sz4gPqB8Xy93i	359
13878	2vbG9xUDH7AFcky4Y28JFUbZTRAzDE6YLcuepmp6Umn7nQMybRig	359
13879	2vatvER6WFYKr1MeCnvZ86CiYkemTBeY6ocPHE3qdv7GiVmHWUc2	359
13880	2vbPuk4qofyipyTr2kNhwEWyos63dagyPwBDhtv1raEUWFHNgZcV	359
13881	2vbHBD4nR6erkEi9F2TULhHkmx9HHgiueDKtbnWS56d6Ms9kehrN	359
13882	2vba7ZDggoeUqhYaaGZHp4ZXSHo4auRnTkwj3pqNhEWxEtQdLb3w	359
13883	2vbRaXWaoHZuFE7sCbgSiHP7qJaen6k4tPUBGw7PUYX1fiLwtZbS	359
13884	2vbQmibRwnSipYWMR9VByZZL1FvSgWDNHEDG25n2foKfHELu9bLY	359
13885	2vaHkyvi9AXoyATZM2PnvphaRc1SPsfdBz7HGJkuDFEcLzyAadb6	359
13886	2vazwwNxQGB6TRTbxdzJ9qcJpK9YhteBLDhRx1VGmMHqAC7zNA6K	359
13887	2vbaSUqLfqwrncHpCmMoDFm2nBZaYsuqq1ujBCQTiJHyqgw8FurS	359
13888	2vas5KBpakWpcZQNiR39xuZQ9k59FZYcdUXmcQLMekzsAvZLqJBH	359
13889	2vc1NCoTUrttZHcanhvTJy6trH8YVkxMSgGCqu3iGZxr525CGDX5	359
13890	2vaD4v1HYFqWCPEv2fAcRJDDfyT1kZBBCkBdZcAaLxTSvM3UdKRD	359
13891	2vaicrJxsfNjrTiWaT5v1vxXUqfkC28sWzdtyViM1Ff6XJPsvWcV	359
13892	2vbMp8nZ8nQxpteCcqMkGFRcYxed9fwHidzYP6go24CXEqy7RYp7	359
13893	2vaoFRexrQAyzwArvdephAgpDP7NA39aA3tzPwLq41MU6ZmH9TRC	359
13898	2vasFgFd4Q6X1n99YRhfw91YdHiYMpFnXwVKKGXk8hJ4QHnEwk27	359
13901	2vbVjGWUhaqpGXpQKZmGiBYzyVS8rm8qJr9vquvHKcdzfZW7xrNm	359
13902	2vb6uUprtnSe9g5mSSaZcqwL8vCUW3rwK5AZfqHjnoeBbURbweTo	359
13905	2vahtsHTcd21DtNBva8LQRChCKq3ak7Z3NmdaQmc4zrFvPfTtkfC	359
13914	2vapWMpcNrTgc4ZZGXpkeqf6dF3fHDSQaxR8EzbFeiBwaTNAapQ7	359
13917	2vbDdaAXzp1J8FU66DDRSE9xRYup9rK4mK5Kjka8PP2ARwP7kHKS	359
13918	2vbovVNobqsH89eXUC2mzwXD6mTrSMBxEkthdrEi2m23aKGiANJJ	359
13923	2vbBTg1WFymSUTJc4et6E9AKmLq5PDbfJqoqKbB4aFueQMXE87Sk	359
13925	2vbJhj3sbcff2wtZeLRzwCFEpTTQbKKA2qR1UG8hC3me9higXnLZ	359
13929	2vb3Zwm9SLaGKP5czfS8GnHvmGcfGB1PrYbBt2xSiqQT5hKdJX2n	359
13931	2vbW7yb3EF9kNyMmmQAtyeuEhJd633ChHk57jQBy2WXDoRtfvHpa	359
13938	2vc4UCY3zwLNzpi8SaDTrgAhTHkvpoR6gJjZ9f8QUEPpHRHhqcGW	359
13941	2vc1ZSXT4HzXdQgp3KgVigobq7uep1cDrvEDFk6RFbFTYp1rk29d	359
13943	2vbdUnoMgKVn319VuHMBYYSiqsTCA9tifZT4tvDTRN3iFsFFa4wL	359
13948	2vbgFQoBiip4nvZ9uchfTFhnrPWvMy3vduwukaCEekVaz8A3KzH7	359
13950	2vbDzx3vXNQCt9NLN4PaQh3LSqSVnuC6DKjrstBnb57RYuoN438w	359
13952	2vb58caz6joytfE543bDYC54rTS7es7s1zFKYfMciwmDHyAp2WcP	359
13955	2vaj2y85QrpS3jKxDsmQDzMojvZpGRFzYgr1rwe2NHaS5ykkrqtR	359
13957	2vc4DthjQHcTz2REhzxXsR26hMbqGzJxGDF3Uu8mDcwsV2jf3LMq	359
13959	2vbr4z7wxBZBwgsKCt73gXohKnKD1faeJ7sGiqfYx52SeFpZH88G	359
13964	2vaDnHYFu3vQzBtbVsYvhFFgpZXEoNUHaUe8xR1keQJ9SQ2fi3No	359
13966	2vb7pSmUcH1K6rj9AxKUQy1m23yaD11WgTHxGAiTQRJBx9A2tsjv	359
13974	2vbSZEDpDLnNFHduFFfrUEExhCphvedyUw4bWbvuNQWYT8gom3vg	359
13977	2vbnNovopp1qbgvswj9q17h62haCmPD1CyA859hdmZeko9oRMyGN	359
13986	2vb5Um2vBYcKNwk9XuEX3jwmB62iqiJaWy4kvYoWYpLKbP7aFVyf	359
13992	2vafRebXvoXBvc5EnWxBi74hsNg46HFqA85WT7R7oStkVyCbfeCR	359
13995	2vbpzUutTyfza6kks6zNTZXQikpBfhXyi3emqAjYARUTyf41m5V1	359
13996	2vbCRLwGLCXpKJuZFQtDMijXVJWjoNK6udjPjqhCwwiax7WwysWq	359
13999	2vaVkpo8SKH2moQe843MvrCKWgGMh5GinuwDinxBRPnQha6mXFWN	359
14004	2vakhp72ntU8YZsi7nf2zeGHsGHJiEXyEa8xhFAGYKPByKchfqTF	359
14006	2vaf2csSwA2xD2TbwRUNitqompjivcanMKFTYnu7bAJg21q3bemC	359
14019	2vbmi96BKqTRDxBAbdxBRfKPwHdZ4Npyo3d8MwVYQdAQqg6HZNUm	359
14022	2vbRG7yEPucVKHfT3fSwjrE4ZSGMa3pRhxcQtxmUpzMWGv6BVZBy	359
14023	2vbufK3QDpc29zaJWVXV6WmkLVm9fcyfTqrDuBwwCFtj2AjweMLa	359
14025	2vaEEksoWcy6AQaaVRL2ez4czkHpXHNQ4HNHA78ii1o1yEkGMhR9	359
14030	2vaJWTyT5UsKRgG5TdxZhYrTR1WoGMwE2HZxJ8hKLonAqehv7jry	359
14034	2vaySRujataLs3QABAn1xGpx9dPhYbfAZtLg5NAhbc2DX9m7YseP	359
14041	2vb67BJwdYoRdQLTCCWzyTb9GSHX3xj5fpKGvPgfnLCquEkFnznb	359
14051	2vbngYAzsfuggAseAcGS9uvYRUG5HgiSH9xHHVVNwHY82maDK5q6	359
14052	2vb4QThx7D6zz4bDdt8b1cPHJaxczte6Bh3T4x2Mcmp1hLwvM7nE	359
14054	2vae84LDVHBEmurqJF8pF1g3PkMBNbD9YnhtZmXFSiwD2dSWT6zv	359
14058	2vaYqvzRWW9xR1U68zypiG665n9dVmrNTnHofWqTFHA6NioWWMpw	359
14070	2vbNgWzE34mh6mh3wYSdAowPAvpn7QRYoujFMmeexNcMRkNkJkAm	359
14077	2vagmFuNrnTmE2zCdoteDWo9vJvJHLBkaAvCHerdbcsavu6D1cbf	359
14078	2vakVn844YJpu4YEK1BnBZGpDKVK9nmYUASmqYPbX7sreLwYhamk	359
14082	2vb2SJp7WRC2L2gbGn4oevLoY4HAYQzJtN8n8K1nh8nCUeMQDvY6	359
14087	2vaeSE4rwh29vbsmmwezMrSbsduCWL4Bv8AGxR332zqLiXbY6ojC	359
14089	2vc2rSBtLmuhQsH34e8qdHHRWmqHUS23LaUDDxqCScfvD7zNZAYX	359
14092	2vaASducw4F3oLPCojEKBLNLQPUdg3s9PfMZELX2YY8WfNGVz4dk	359
14093	2vaEzdiUfxpDEXfzFHBEAeoyrn1EmazX8Wsq7XJ7pLf2gXVQVGo2	359
14096	2vac5BBQYSMBJgnanHASj2E6diPKDD35fCb6pLs2kcmPSDVJcEgf	359
14099	2vbvrB2WMfdGtQogas1XWAq4d7EuXoCkU67ePibRrDUQvxccYEsK	359
14102	2vc5ZA7Aaorjbgoi62fkTNdVz1oHr9XwL8A6xbZvDrMCUDNeo5ri	359
14105	2vbtCUjfEGcArFodDEMRzHnXLCD8jtcBsvur973goEnmczEnqits	359
14109	2vaKpkoYp6tMbBuetMyMUNH4f8L2CWvGqUumV889XYiy2ggwVEX7	359
14111	2vaUVg21hTFDxTU85FUh1ZUsb8Q8KAuYdun96hzgYkZSwas8J4n2	359
14122	2vbfF7ZV5p33ASLiSp73WxQr9uDuQu9fWyQ9KSLwc3nD9JiUw1Gt	359
14127	2vaJGRxtnVY7Fh6MMhi51L5NFLxqWRvMqTrXcJGLsxUHhF6XpuYN	359
14128	2vbrhq2z2KNMRH1qLABC11V2SWEKecW9Fu8HsW2Rr7M3fWwDz98e	359
14132	2vb5PNNNVmocaSd4rAf8ovavcuzXWhWBc9ykcz3AChZ5pDC46xgc	359
14138	2vby2vyGA6e3nqbxUjdKn7FCCWWNcgSHWbKPJ8jsFb7EHUiVfBvx	359
14142	2vazXw6oXMD6wSGy72d3NgdCbbdX8jjtobyAXQbqjbyrHGHyRvMX	359
14145	2vaRYMPHEvw3kC4nwQ9FsLw1gAeBm6BSSqjH2qRV8MGyBQMjXrv7	359
14147	2vaXhDxCE9CRrSEqY8aKFNkjCzVfXrHAeyC7LtoMykUUb6hYiANk	359
14152	2vbECQqjsMxyHp1Kiyg7Wg657gh3ktbKyUPhRdfgpuejWTr1uED1	359
14154	2vbLW56XAgha5HrBPtnSaJrKr2Yr3koubsikwUNsSGmLNeKLyS6D	359
14157	2vb3HUyzgKkh23fHS49zYhH781PkG2BM8oXUU9igN42wHX8szo9E	359
14160	2vbpvd8reqnF8mXXJk33AUDK46v61VJziaGX1t3UPe2Nvb5RcFeS	359
14161	2vbM7Gyjy5tTgmREXpCXRR2JNSLgnfGmvXUsyHS7awzCbuUyWNYA	359
14163	2vaYoYsWiAEUW2VV17irTwJZNXf6Q2P61mAkjzBXEzRUy5phBgZC	359
14166	2vaFGnr3uJkTJQUSUpTQocfbJ5QAQJNzRVp5psTr91Kyz5Zvg7h8	359
14170	2vb8FrBTbBS1y27NLgSUbpzippAHBZMUsH6vsos12fndLbc1hFax	359
14173	2vbmE85QXc15Bz3hDCWVUfSLgXuvwJEcLcmYMREWeTtdnypCfFwN	359
14179	2vaqYNJV7pdfNbChb2efgpAjHvAdoycxLgK5VDAS8ga8dTYJ3BjR	359
14180	2vavUAcvxwwQLhbEH6Fe5BHixZiisvm71caq4c1KoKBpisCJj5y2	359
14191	2vbt5gEZ79b6G2PqJosfrt5jqr8ewYUe4JzmReEjdBSFpGUbyNJ2	359
14193	2vbxxyteAksd1oE35Sf9HvXXVPZf1RcXpfbj2YN9vG8vTydsL4PJ	359
14195	2vbHwx3fUpb7QFX2JEAURneJd2ofcwDJK53hJhSZX1NNA8CXoxGo	359
14200	2vbcGEa9So2W8puuA8yy7thKmkYhRPVoo1yjzk9QbYCSUoxdGgrH	359
14205	2vaw7ckoxSMD4HYsP7vnJZ8UGVeyyZs4QB2xN9yUfbeaAybH8qR9	359
14207	2vaKDFSvzsHKxyrgU38xPPdCVscecRpS8jHduREFLUec11bGfQ8Q	359
14209	2vaHGqHXV6fENRRewJvbuYAVLD3SHtbuvicVveBrbBZYT1ESxNGW	359
14211	2vc2RjdS6JEMkwsqLp6AJbTmfaaAoMKyANXdyHcFKJayZTg9cebM	359
14213	2vb8AL5Y9ai3sAAwQkPvC8FNaNivXjkd7HtRCMfrq5sh45kuERrW	359
14216	2vbzQD8Wfe3ixBP7UqjxdPoUmvYUDEavqyqBCR82wMBqkiFwZh8L	359
14217	2vbMj5LSnU4iRLMCrwoKGRtVPqUXUzzWCYtQmkjumMWRcLsDPWUY	359
14220	2vbonNsvs6RknBUJTYssuj8DPTQMRaycpYPfBC2zGi6VJQDm8dPS	359
13894	2vaGtSLbuu1oB63ZLFv6WbapazHk8jYhsbGUt1j96Tu74EhYesRD	359
13896	2vb21Ja8h7hbacXJbABpuk7d28FSjhRjH3qZ6g1Z8zyHJ86A3r7z	359
13903	2vamjo792zNb9aSXujmSM3T5ycuEroG8pi5wjzMcefWPX8dVCavk	359
13907	2vaVXgCJe3FTEMBb8dEnhv4pMdD6di6bfQ5DnCEciVUZqZjENzfW	359
13908	2vb9kWuKUNCrC9VC9K51AHayTbWoCMJPy7e1JZshfH9N7BhQQRfB	359
13911	2vagKQXNnrVtdcL5XoSEpZjMdsYj2UmUzU7dhh9qQ6eKCEc4wk5Y	359
13913	2vavzDed9UsFaq3kTSBxWB4Ec52dATqDAT7mukb3Ss2gvHwwNVKd	359
13915	2vbjUFvgD6fuFmsiymym1reEjJzz7NzPTA8Y4vDY8aRDf7qZBA8x	359
13919	2vbqTjKoPRu2a4HXAtQpWxJvHkHnn5gvHHuthjGR3X3TXAKPupeX	359
13921	2vb6STfA1Fuqhhjb7v3PsmSEMzNeujW2nFsovZsdchfiu4bsEWMw	359
13924	2vc4G49deRW47PYECFhEPL76EuobY2GLTSSQE4sXpzbj2Sqs1qAg	359
13927	2vazWk4zAhtvR8LrR12TkNbRyhGbrjUZWK7sFS4njb5ENYheerLz	359
13932	2vaYjoYYy46ZjBokSaFN7FChM3uVGaKqTK3t3rJVPA2uCvH88JCw	359
13934	2vaa25szfmnpB8iQJnhGzW5ZvjxWcLPB9huQvtUfMNTHCM51MA18	359
13939	2vbekqS8rrUmypmhfCC1QzwC53Q6uHQjdTMyVaF81JW4tntJLmni	359
13949	2vbazv5jmNsJFMYX68a1nV59oE61Sj26BvaUtHUvxb7tHRGKKWzD	359
13951	2vacPQ6EZcb9YvL1D1Fm7U4mrRtN5JZc24y4hwtQmsiQynoQx69H	359
13961	2vbzCLdLA9XsxgCgD6pPqmJCWyyJAyGt1ofr3hT4nPprWNJMyqoz	359
13963	2vaam5MkwLG86YupNEuyR6DrfYM5o4uBt4oj5BzyJUWU7LQPvjrX	359
13969	2vbVKWoozxx3SuAmMQBhjrFuj14QYJdS1BtgGhWoYiSXme4Ugym2	359
13973	2vaP8BzpAFE4cJfdjZXXeDehHgwhoTXEqxBp6ZkpQtgsRvzJiton	359
13979	2vbHLEfDXw5dPeccectBACStw4Ezu2obrG6xMyMfRKNuFvofgrSD	359
13981	2vaFkVE5jge2hCgDCquBBHomYz9F65AE5C24rfHWThT7vHYoLACB	359
13983	2vbmiNzNsg6gESEK8aAg4VEE6Bis5ozBBeG6tGUzqD5P5obETRmc	359
13985	2vbeL273HZfzhgRvMoyznhsLnHTwwbzCNUWiwMdkBgy5eRCSLkVP	359
13988	2vbxfq9HMnGCMM7MQKY7DUgx2zjTQsN3kzWKHBwnC9ZMecji7Xsg	359
13991	2vbvjXdX4FfdAe4unkedqh4aWrbToJk47Dqc98GRPfi3TWFaaG92	359
13994	2van6y6ip1gYfXoViMeA7udtNjki1q9MGPqR6i7hAQ4VzJPXyZ7n	359
13998	2vaxSQ4627tdxDqC3kSEXQFJZ6ubavtjYFM8HqUgkqeg8UyRiwas	359
14001	2vaeuzEsN1oWQmKpcXQVvVntH4WWXh5irZubPf7kAAPTwTB6RGF6	359
14003	2vbuYwJ3z52KCH6NmdkLiKNYJib56nw3cnKCUo6RQSkSKdFYCBAJ	359
14009	2vbc438Ppm3qZ3yNkPw2ecVMXJWC2Neup5MyPeBn8CuEMeDiHSkB	359
14012	2vavCiXJr5HQjEVn6oFFQ7QFwR3L7zbZTrvDLWVJt2LrVs9zXPDq	359
14014	2vaJAAX674bV2AJVQdKHq8CpD2Kfu5odp6xgns7pJGXXdKCoynsW	359
14016	2vbQtZ6WzG4ZZ4f6MHGKuZvbbJMTKzjr379K2LW5KoFsAGPKvirV	359
14027	2vaTTKuq6LN1xkXXdC5Hmqo6Qgx8sfErUE35nHb5mtCFA7j4rnR2	359
14033	2vbLkPfC3BqruMu9TFJjAjshAiQkfBUz3yqZPgKVA97GCgS1SeKD	359
14038	2vai3VLut87CMpRnkDTsmtNA4UDx9skEuJcQUe3DQtX1xp2umRmv	359
14040	2vaaaMuz1vehJVyhFCna33Qw4sbEKMLN9ds5NUzKW4p69FPgqRkN	359
14042	2vae3HvU6kAgWawuWY8Bo6HJrSV7aLwsjaSvPh5UQjbB1JxsBxgm	359
14045	2vakFyiV4P9nLSPXeZGuo9gmZjQYc92Vs8d7LodXfMdrZE5eXNbz	359
14047	2vbPMZMSX41x2r19ZPef9NucYvcaXVHZwueYkTJon912dKuAsX9E	359
14050	2vaRen1vr3foV9T852G98inDAkN8myiMe6eLy11DQwg792PsygT8	359
14053	2vbXKf69aMY8XjWknEuXP8iegcKrscfpwc6iRtcUXeDVxz9BsM8k	359
14055	2vbtepMroULNAvLrZv73Xdx6kpgSdcVJ8aDKY8VY5XARjT6AhoCU	359
14060	2vaNs9ukjZXG1LMVqJL52iNeiuF9HDSJimxMUitAse5aBjQK2qeK	359
14062	2vb7JZ6gQMGKsTbnu5bywMjcSQNc3X6nitmhkmrBZK1WLkgksKQy	359
14066	2vbweW9QAA231biEJmi5xnWr5FFtyXxiQsnHEX2fDAKvxm94SF8d	359
14072	2vayzcBYF7UZxRGBbFFbDVJAS66DwduMj2osQTPS83aBxbgpsUsw	359
14076	2vbje4S3Pj9zDexdHXjcsmiHRfiEBidU1MCrYiY9YGkrBo6YGKoD	359
14079	2vbjZ1VuDL4B2zu8vqFK4d4ftY3mn96vviBvtWG73Bj5e6HMm432	359
14086	2vaCACb65DL6vCsF6rHcR8gxqQBJysQwkngLdCnuVyh9Yf8fDeHd	359
14091	2vbyzAvt7meJA2VNeD3GP6gQo6KGWKN6mhHTgKMkGD2CMfmrmqBU	359
14095	2vbiB8ABJUo3Nbnz2qtfo2k9FRVbw9x8bkLEAAVKHYjvUUXr3TaM	359
14098	2vahh1RhDm9n85mQTwkpuTwo38SdpkuCTW2VAE4eKpbU8tgt3y1s	359
14100	2vaK6fPjEuNf6jVVi1MTBAsx1XgMoPs3QCU1bnbPu6eYAZgFpPN6	359
14103	2vb91it2W71GwCTuws69dxR972oAH9V15iamaZsF5pq1TiawLvW5	359
14110	2vbD5aPJh9NBkJaXLk7WZ4o9UJdgay2GKhp8hdb6yQZsSWHWvDKS	359
14113	2vc1XycQu57p6fwGmRZd6ktLJqR3JT3bDKXzhibe26BRp21p1GUZ	359
14117	2vbyZ5dwjsDTrKWFrcbEme3tArQpHCTb8hT4q7rVBEpgdQcVxFoA	359
14125	2vbFU1qLD32X2QCmah8RoDdHCjot7G5N2udHKauujYrm4SKWdbHY	359
14131	2vbxfergZv9923U4BNkD1qmCGNgAAii88WhGGreuHLDUE6xjD8y5	359
14133	2vb8Ya3R7CnUkkqw7vdc5SabZkM7EeP79pf4hjiPDfBZe7Q6o1qw	359
14136	2vbVK9j4Zmun8fEB4XfezKkepzLt2tfDREvUeFTv9hTDJu1wfQp5	359
14141	2vbpffVdvkMeihjuVpfmMwTADLjM9NncUqXh7igGhMTtPZzv9c3x	359
14149	2vbAhsXXqTe59QV4P7D13oqAuTkAteeERr2NcHkMepgBNAsHrjSN	359
14150	2vbaXRvR9Cj48YxxEYNuoLkc19hvseWd6G12KikuqjU8bEDAM1h1	359
14153	2vbR7CZysrCcwNBwE1zm9s62L5Gn9ByzpeLS3WPNpUm55dNQ5EdL	359
14155	2vbN5fkLBtbh6Q9NSxr5FZZM7DPYGWAaSPZn8NWZu3A8D1CWUfcv	359
14159	2vbQ1zuvvcuiin93sEBNZjbNxANidGyt7vZyjm653Lkb3NCdXVPZ	359
14169	2vauNsDeRzAuQNEZENddLepobVYmVGXW365HAETmjapvybz7Ut5A	359
14181	2vbJp5YwbHgLqT2BJSJKHFX6K8qeRPhqGTAotrUZzhN9uXZ7hwaC	359
14184	2vbDG76MdB5axHbquxwg6u6PYW4waLQX8SNQNoD6G7sZaCdEJqnj	359
14186	2vavMu3vek3dXZJRLWpmF2Qb1B4kGnCBZYWb2fH6nMLFtMbXKBbB	359
14187	2vbna5ahzJRngASvTC16XgeyXTzrGSovTSQ5NK8vY9er9co5tEGQ	359
14190	2vbaomcm6qvsSZSbQ38CMuFQEBNGSt1Bh4RK3yDK5eZm7o8DFoeQ	359
14194	2vahD5dMoFKQguTa3fSQ7Wtnix6xDec6K1a4RWNASfTPMua2bdBU	359
14204	2vacrQvR8QNwSyEczhijPBEp5DDh79MYJgYeXYrQZphfmxsJi1to	359
14206	2vbrSB39MZAwmxGSsJNCiNVbSfF3T1mDFh4MJAJghz3wZKR6LbzP	359
14210	2vbmSG3DtALUQPAVSzp8ET1Tyv7D362jxS9mkAAWhwropTtNYse6	359
14212	2vbQs7sjocxdNqq51rW4WfC7QaMLmo5uPy3CYtu4eZNnSB5M6Gd9	359
14222	2vb6JfzPtaRcmxAQSAQ9GbzS37459b26Z41E4CPDbGQ5nFUK6DVG	359
14224	2vabfzFxyXcKoUXm8wrwamEv9B3Dkz5B7BGdivrnYVtKpDVH87UV	359
14232	2vb1yHMqhcpX6ecouoxeJvwWveV5G8UbmhXXR3BEUdx9MHcfKjQR	359
14237	2vbRtGU5QYcvBLWmWETn714ErveH9my5henwbrSQ7axrFrqwk8FC	359
14241	2vaauDjVHDrga2uWLvdfR1HfZEx2UvpKWbHN7DexGXpD3fc83hDw	359
14248	2var1WrdBWEoiEewfqUHFsakbo6taruH8K6sPYXuUUJqE9egPy7C	359
14252	2vbiXBLKUSvCqfG9kT493JtQTwzBBVir6PujyVxA2xQiGtMvUUqC	359
13895	2vbRS5YQUNbizTB1PuPCUvmt2LYE5vFXb7hFHqvaDXQ1PQBr65R9	359
13897	2vbP6s63doqLnUhxvzUzA347E3NF9FK3kPu3qNPY4Nj3ev2AzYXK	359
13899	2vbKsmGyNrEVQFBjNjRUeujzJ7NkHYgMb8YyFGvgeKTxRUV8BLFU	359
13904	2vbZoo3bXTZWHqKThS5cVrBSrsjjqbGvQ6QY1php2vnsUBLgGuPA	359
13909	2vaddFDVrdp9wFYjNyZ2zfLmeW9NtfEu2srXKHMQz1hCap2YY4H3	359
13910	2vapXUHqbg3g1kz1BNb7DYB8vivN2jYYLrUto269nK97gRi2X7Na	359
13916	2vbazVELPRqMJoMWDLm4weXybbiPZvRRWx6UWF51nwe9huwcAmtD	359
13920	2vbpdvLFVshHBPGHoJw5tw4ZCAtAcxbceBPv798oc2NvZyjgV2SB	359
13930	2vb1v6DQ96vwQSMMeYJ9ig7d43kyJuBoc5bVpGunE43AZ8YsPLLf	359
13933	2vasMek9WMiK47gnbqZDx78xw4PkXFQHBizyptmQobm5831P8Zwq	359
13936	2vatAfMaBr9iMTAnAMDyxRwu6wnLoAwD9cTw4MEFjKDxbuH2Gzen	359
13937	2vaY5ex9SgfwyGFfhAZ93A3NKUSx38HsuxfP5gYB5FTNdaLXCGMQ	359
13944	2vabQEzj4Xzz2qE15ZJjdm1gonhvbYXwSMcj8MDLDCB9ZQBxsuHm	359
13946	2vaaekdifDvdpWGSfjfrpXZSScCJ1VwvJF21YRXDYtodPAtAJ1NV	359
13947	2vc4LD1GV5LW9gYQNWg1zBe6H2wSLpQQxXTyPBcTgeJCE6CB4syy	359
13953	2vaYShSKDF6GicE7uigCwTKU1zBPvpsuki5VjfiFXTHVoXwqqL9s	359
13958	2vaFn6avni4WyDNXQHxbm81uTDZ7pYdge7CYjeZ4E1jjJdriK1Dv	359
13962	2vaw2ejmJCQWuRns6Z53WxAJ4LHg5Gxuu883gTCyd3H25HhbhUhP	359
13967	2vapcToDAeJTuaQNr2N9DSnUsh6r7opGW4Ucb5x8RbEeXG7GGDMK	359
13970	2vaQkbDPJ3grM71KASUUZ25Li3C7d5k5SEZqnMCzWB1d5BDmnxYk	359
13971	2vaLvnB2EuzPD6WzdyFQgniW3gjqUWnPUczYzaH7CMFcGUemXA2n	359
13976	2vb8XARCQY9i1EybmLkBjoGebuZyRHCsqWMNNUiRtBSezt5bWeGq	359
13978	2vaBuHwywYi5uyhfhHhMCBHNSnuGueCMYKutMCwWEgn8DQLXPBfL	359
13980	2vbXnSnpBx5rHaCesVMnyN1BL8bE6gSMvSK7ds1qgkRTmHX6dxhv	359
13984	2vags7LK3mh4JoL2XtAFbketV5V7pz4nE1iAtL4WophGtxetmExt	359
13989	2vaCgkKJgT6xZzzsnszh1ehhRCAmNZQdiLjWdavMwQzAvxFi7VoX	359
13990	2vaUuUCxT3uahXiKzmkkE2Bu6Yz5upV3AZiuGoxau1Gqf1RFjQyV	359
13997	2vb14NN7EXcyy4iTaHLZrzbwt5LAum6LwePGHvEnKhujzN5MyJw9	359
14007	2vbHr5sYdhPkFNF5MzroHeQLfB8bj2wHz45t8xwidRVaq6HHCTDb	359
14010	2vbQDKBJahdaKq5sgEw18Coeq5BoTvvTW5XJwYM2d2hKtczKikjS	359
14015	2vc18diqwKXNV5mtqXqaLDsDednNtF4PARTR792d7p6NahDs8yH8	359
14017	2vbwaducCo9YWmcK6q34fg2EzpjmFHaMNMXmB76oAoVRwf1bdm5A	359
14020	2vbYd3wGDhF3dKTHD6vnuTBNorQa2FLA9LFKrM6LcRBUmRsTnQV8	359
14024	2vbdbDH1JQNgBBr5Gb6eYQjwmk2hgmeNyTVHAt1Cfk3p5TVCVD3w	359
14028	2vabKhq1nDkfgGKpe8UAjiSMr5pFH5ENXc2XeWmRxkWzikNqBpFC	359
14032	2vby4zzZG3i7pFvDEF9UvkJQ73PX1PHm2QXQgyx7dwxAtSLZfK9Y	359
14035	2vbGS8hw212ELLtxzmKsV9dqYTPPfcxrizM6NQik9KoSqDSsUU9J	359
14039	2vaBF7LGf4ZGJL97wLePfSRiaeqM3UTR6gnKBLsR2YYXExo4WNMG	359
14043	2vafnAxcURfMYu8r4qZr8AqDf4jquYUUdzqZh5YJZNz6msr9hzcJ	359
14048	2vaqQBuupFPui8nU9vvd7nGwkbeGmvf8jyJ4bEU4QqTTZw652pEx	359
14056	2vaexLAPGXEinSFVrFCxki9v9HE2Hqke9upysyu8GiJaN9rp73D1	359
14061	2vbZz1Ma12czwBUv5EtYNyRzwEtBSQbJHsfYjfdJb3NG5b6rekii	359
14063	2vamTxN5nSkbDuy4fnCeTvZdnJxbFcPUzXcpJvHTuRcxgXsmbWk1	359
14064	2vb5khanA8cgJ5xucVZpLb521i2V8WJaPuw3MwCA1ShgXL68Vo6s	359
14067	2vbzepavxb7baN1sumEZeBS5k3bBgLqat49ZfjKY5xHUHFcJ1GMQ	359
14068	2vbrGsrTYL2Yz2c1BTtzLNmncxKQvtD94XJKx8AH81Z5conBipT9	359
14073	2vbj5Ss9iebG8hL7EcuMvMtemUurSh43dfM2UEECUtQMhdobosrc	359
14074	2vbvUW1UTdW9Zx2FZAupZHZuH8oRq5Uex1Uc7FFuZvaEY1sJor8V	359
14080	2vbycUQGsJuzjrAkVZcjw56YFMW31mpdNejgRp5hk1wjywoMQUSA	359
14083	2vaz2J4NAbnUHRy9fTZJ7U2c9Yh52mnr48kEWS2FjwD5Z2BR2Rvi	359
14085	2vbpmaQTzKvYbZxYRpjVCXiTxkjqKBJQJARSVv2WtiTGgP11AuTF	359
14088	2vbSw17Rxf9i6uHrqsL7v8RFNSfA2dPyfNF5m77UgVsQUvGK6Q6Q	359
14090	2vatg69LHbXcAgBiw7b4oKFkbeHFZ5gQrfBNZnKyPAAB6NdqqARm	359
14094	2vaFrQYyD9W3oir9pNp9urVgd7aJHTXTdzuPj6gTv1rPwDkg2DPB	359
14106	2vbxeHGjzEJS8zUMd3o1j2b21hCcr2iEYee5ebUKPARcx15EwTNt	359
14112	2vbV6xmPv1YRZWhbogWMK8w5LPuycp34pSUzScd6YCsauVE7QDpd	359
14116	2vb1yK8uLKaYkVx2Cc9GXhTPS5gYVKFPu1DH6aZFwDpXeQtJxgzC	359
14120	2vagoFH315MYaL77B1jdg7KzUg6Z75gyLBVAy26jS8snfMXkH5ww	359
14129	2vaJc5iAN8eS6HZ5ZM66DT23GBG7aYiEYEu6xEvjkiDcwkZp1HzX	359
14130	2vbqkm77SCC5p5kUa7BwYsacg4Q2mRup6URctS2Xzs5CS261qa9N	359
14135	2vbP4YvYUhXVZjdFfzShrUrJXYUL31GCHHqdSeCtPUTikpsPuZ1C	359
14139	2vbtVMafhTCUkJUow7od1cDo8rufeDkMMCgj5eUuLw8VXsE6vWRd	359
14140	2vbiYAjYmFSHJ9GHcTc1VVVQgPsLm7PKJzYrZaQSd4by8TeJf4Le	359
14143	2va9hcbKzU6QLyPnhGLnkR1yNCZXLZk46J4v2Fn58j1JTq4dor8S	359
14148	2vaymAEuqNRk7tzx8FoPmjPDQQLLQnq7NpuzPigjaY58xyq6DpFx	359
14158	2vaJfZAP7ejmSYwZvBwT492rpBwRt9NLDuxJSH11deewcGMBMmzJ	359
14162	2vbeBRQdyCSp7hH8Wi8MQxKaisjXFbSHRsr2QZQPyCce555pGtq4	359
14164	2vawcCzBHKj38SvmiUhmukeeEw9stahp5i48xNq5iTm2FedcVwsM	359
14168	2vaDbqT2jS2jqSYZaKMSBqMpJqghWA5pnUPCSTJ1GNUrd513eLcE	359
14171	2vasr2m6GL4m1oS5Cj1gJyZC73vZvKNaCw3vCuMAscT4aXwAhdeS	359
14174	2vbdCnLZmXvLgEjfdGe8Tws6mFcyPypw6VmZLWc7XkfhTmVq9F58	359
14176	2vbSRbBJPRLss4EFuvgsviLTTY9NtVdpJgAHDhuuZr1GuSn95CYY	359
14178	2vaDi14rx1XxGaig35SABDTKa991JWGDjYQaXXAjYPMvE5Lx63aM	359
14183	2vaLFC7HGFp5SwL4rbZid4HNXKE6h95R5Gu5uYqWN16SEs6MrNH4	359
14189	2vbgM77KcNYAvVoLH3ugZRKoGsixdCYmNaJmmDFs22MXGKRrYuxq	359
14196	2vbX2KFPEREBftqvTqGu2aeNVfJfp5mXhxqU34JKYkvMMGSRZTzD	359
14198	2vb14SCP3RNDrUdxTArX6ChndCgx8m9zgfnjsdWPcoZ3Qpqx28dN	359
14203	2vaL4odawQsRGeaodJ1PET616PsMQdt6fAxYzXcjrATo5b4vsHKH	359
14218	2vbxYz2im8Huubi3VW58ZnWPLcbmsA91RCdRXVyFs2GmecaRUNjF	359
14226	2vb4HqyfCPz35nfk2MwV4TaB5zHQELsHM6DrLDHBHxW9Q2fXEwfR	359
14229	2vc4rs9GWdvXgryHngRaHC9V3dcK2CC3wNHVT8HsMtNEegfyFa4r	359
14235	2vaWVpVFvmjJS7qVxrcsbu3ck8w2VHgGmg85XPthQobFvbWV6uBg	359
14240	2vaYbtfVA1md1Wn1jpHVNyNHiJLBDCe9puM2J1TLxpLfKSokziSZ	359
14243	2vaFt5D3mQqF2BZJKW2oa25bWZ7hKZNTytwSd3CKH8Z8eBtHSPtW	359
14251	2vaWcMkD2AS9mRqMb2nyMxXCiU7yp7uBxzttfzmZzUH7rfA3LHy5	359
14258	2vayHVyDLVcLMBERRk2zAnCJaKRFrgWjjtPwAHC66mXZLsJWoqpS	359
14259	2vak9hsgHHeVdY7xLq9Hk9bceLtWjk9uvJi3nDb622WDYWPL9CkT	359
14262	2vbKSuVgwex6y2LJ3wfuJvpF89zdUzEEW37LrhvUucsLbDFJpdfU	359
13900	2vaNqhQzGKeSa1phRGH7UFSKJH9rvHywBEw5N9LvcTEEMCzCQUhx	359
13906	2vbVmDfjEdBoqpEBw3A1u1kv94NPYxQdmWM9249nBXjHmgQYWqT4	359
13912	2vauu6KBrrN3Mp6GEnUZVjFBYFFpjmpchkzhvamWGS7DDpQi78PK	359
13922	2vbkYcksv8EHsEnWbSTppQunfpr4yjnhabRwRjLAWU3Gedd1rLeH	359
13926	2vaVa9qFeevRNygpQVUBHteDacmNedSd5pFegV1roBtXZbJdnRjQ	359
13928	2vau3ni9Ty3faPSXyFoXiEgXnppqmMEjSgFs9SQHVQ3aADESXdXq	359
13935	2vbKANDMSY5CKMNxUS16HhW5eAS5sewCwRYnGpMmvC4P6bHbAz11	359
13940	2vaDneYZZ3Q4eFXcmQhhzsp3strxNFiUqRoDzHUixMZ6HHyW732u	359
13942	2vbHiucqYDuMgueV7MKLCmR24BQjLkcmwjWrVaU3JDRTY5XcMyw2	359
13945	2vaSRAfaQP99rjNehfzJgSrCdgM1KWsB683BwJtpS2xBt7Sz3a5W	359
13954	2vbb8toXjhHaz112GagRavgvPeyGgiLyRNrz2GQvxqbPuDTxtnHu	359
13956	2vbTZPqLGp3tL513XQAvZuCRKTAuZ5DqYHkWwPSnyB1vKnjD2VYP	359
13960	2vaFTxcSzwuspcgpSZX78TaW5cqbz14UxZNC59TduseBbDAb74TV	359
13965	2varoyFNTQf7BBnWyRLub9djWMVDCN9Y69JCCs7xPpdcgzkXCSHy	359
13968	2vbgHEcgwTL1CkxHHocTdzr8fLb7TS5nrrqFUd2ncyhfUamT6gqK	359
13972	2vc36Q4wvjGyWsiNhusyWLSkNBsNFxSfzaK4Lw93kZPjJcbY1pDs	359
13975	2vaHzr1sGUx9UhVxSeGJxD5UZs4gSfsLzGHyFgC5m6CvFjPek3b3	359
13982	2vaC59c1wCNc3Mg3LV1eePgyB1oneiQftid19GDppLEQzMd8jPU2	359
13987	2vbZwZGCPHvFpGMostB7PvxNociAhiePRzmTvvFiX68T7PpcNsLP	359
13993	2vbCowKRWaVUekYuMt4aMv7Cno2ToMFdcDBXBBoyBN8BXZa4epgQ	359
14000	2vb83N8NFpherkzc1idatS9Q9ZbX8zrhVATvhyQhZhivzDHrJ1Nj	359
14002	2vaK5yM8wsHJbkNDLrWJbfMRsCPBFBGcJBc4186dCkVbyjk2pNyr	359
14005	2vazDdoD34e3qDAHssVZCQL1mgu4tgJxyPDMiupDfh8hbaGkMUma	359
14008	2vbDmT4UekbB9YdbPVJXWgxwrH8qJyXtPptjiFkvWs4adGi78hpq	359
14011	2vbrWJgwh42YUz1SuyYGiFasnVJQt6CsP4uoWYKynjcidZxuVf7U	359
14013	2vaeN6kN8NXY7CUcQE984Hcu7rmqr8rosNpsPhZwYwBPBy1WP7nk	359
14018	2vbZyZwspoukym6A4NVbWSXQmtEdouHhdiYn1oZa4Jw7ZyFYcspi	359
14021	2vaSmPyzgFxzH5U2PGCPmdWzBM1sTyvq8honhhEJ7nkX3cdqdLHS	359
14026	2vbSAVr4fj2G2sAuVG2WnW6ukH7vN38SErpXV8GW15Gwa4HDAXrb	359
14029	2vbVw9cRgMRtY8EcJgQfWirgDehx492BLNC9cPBier9LS6MQ6Sy9	359
14031	2vbCP8SjBwHhzgqDFAq7T9MDgWiH4qbdhvUXt2GMWrjdK1g27LBY	359
14036	2vaQMpubuMuZ5qU5pd1YoN4TAAQYzdzPkdcYewSvhgQviBpRNzbJ	359
14037	2vb5UWgbWo8m86VoMCPpm1fXZFHRkbVsYNjiDp37vbU5DFugFkjs	359
14044	2vaKpQkHtfx6oijB7sWZpnoN2wjpLpumyrvBmZhQyUktU8fzE1Um	359
14046	2vaKGzyhX3dPEUR46jh6REiXhw9XMuCJn3CTWHp2JDQjKSmXZQr2	359
14049	2vaa1o1QgPASXPXjXZwKTTZGUQJxJgtDeM7yiFwvbJczra6kHbxj	359
14057	2vbzKyMs5fUQjc1yFSfAnmNFzAhvsmzBEAbKgaxdnrdf5TXrWmTb	359
14059	2vaZfqoHrCEd863VbmdFNJKx9Nue9E4fDo55jP76e8fziWK6n7Ec	359
14065	2vaB9RBSMB4bfmQt8EPhaCt4sWGTHW9tFSrXmesF4qwzm3SWbVQ2	359
14069	2vapwTuU9QbLPB5toqt2iTbYRcRUVDj6tf21gAENb7jcpcK6e7NQ	359
14071	2vbcrbd8DMXhdZMhEUcM2RuguYhMQGEDzVaZJqCyGcVPNDABB5JL	359
14075	2vagg8unhZcWRpz7wbVEEujiSt29Rq6nuRP9pRBEvBG9DzUtjZcX	359
14081	2vaATpPh8B1uVnW1ZexmAR1xm18QVhYVP8UW4WonE3Hub4QGcWyB	359
14084	2vc5nowbDT4fempGHYoz2Rez4tzV6YZjFFJN85SWTebr79hRrZ9D	359
14097	2vbrifVnHxfxDBMRXbiFfEvadyevytEC9hBntg276i4JqSeHRAoe	359
14101	2vbVk6qnt6AsbpENyaaRskebYJsewM68BZ1j3acrwuhxTpce8TR6	359
14104	2vbm1C3KkHjrxqyedNCCeaWSYtCyu1hLfhBcLjiTAasdg1WpcmqD	359
14107	2vbKFqbkDbmoGdZEpbpGQPpeYXTaYo6AneS1NpNdw4UoQdGyTpxu	359
14108	2vbkk9Mcz5c68vWWuQXXWDTHMitp938oa8vnyoLEWDdsNgryhVMY	359
14114	2vaDKToHZPaSPU6omtGG4ob6tCkv249fPyjgq3HTWdg79ohkm5js	359
14115	2vc1VMJJPjEdYjd2vjzt2nJQE8CiKgf89gdKH8s8iVAPqGBLKP7Z	359
14118	2vbRh1rPz5JB7B5Qmfhnv7yZ76qDbCupQ4VmYSvaVpbaYMkNAaUC	359
14119	2vb132RxWoJYJYExHZ3hTehoVG3Lz8jBz2ADW1AzShCxdVhivciT	359
14121	2vb7YWfsjjNeGGFBGG3mHJVMED2Gc4NJufAh4RQyPenCmgzA6ABV	359
14123	2vbhJKpQE7oGNZ5zdSyjUKy7Z8ZNvAxQVh4kMRsctqx921m845xn	359
14124	2vatAyyg68owncRhPqwfRcUaGEKhosaYnBsv66oxeadQzxVbt4pg	359
14126	2vbgERqPb5vYWMRXrm7spsVcNpfJbrEmmYXoUJSVBkx7Ws2YC9CS	359
14134	2vbYnkZDJCqbVkgcYD7kKWtmHunUPebMyn13QkeizwZGHFbUB1Bu	359
14137	2vasrKsZDsbVA61duMAA4d46YPP2r9SmSDSVmK9Vhu1ju8VbBhYK	359
14144	2vaz9E48vuQNTKiSwyPYiPawchhvkfS2nPvYVMXhGZuPfeMMvkAB	359
14146	2vbEE5c6orRXqfbbV16nvs4chdPWYWGcHLgTSRUWuiKSQvERC9x4	359
14151	2vaMoZhJDhVcWv6bq35j597zWiCaU2vVf2P4GKLPX4zois3oyr1D	359
14156	2vaQuZBWoEZDFnjTWkNVNu3wntNEGVQ1VW2p3aHo8uvmtvTdC2uM	359
14165	2vb4fgXFEpD892tJCNnUc11QvoJnambQmBCCR1we4zvdPkN1vciZ	359
14167	2vbUGTbD2gSJ13amc3smreJypkx1K1zzDF9ukxaLM5TmuGZNWoNb	359
14172	2vakvKf5n4VUpLaWqqMFvorKBNFN162EnxK2PVEJRGJ6XXZM6VMX	359
14175	2vbBEF5b8DeuK5G51zh2L61hKER8wFtzgttgqvtTU9p9oPsFC7uM	359
14177	2vaGE8urkUqvnyNr9BjZo7C3zAtExCf45spmfXSRxPMZYv4r6wjc	359
14182	2vb7jSzjxU8mNMAgxxjW82KnTq3JubNS6yzRmdB13mmRZCn2um5f	359
14185	2vb33RxzxBp49v6RsubEAHsfMPmyE1HrTykqWhmz8fuvkuxG4ghH	359
14188	2vaLuPjLxnQQC7W8nP7BpgSFuBDTgK32CNRqbYHY9aARPFerh6VM	359
14192	2vbNPutbkQkLaY4rTDV8HSmEuaMnLJmVrbQWFTAPk6os75vzTmEk	359
14197	2vaV7HZHVM2Ra9FLH3CiaYDJRqzv7iaq9JHYRFwy36UgkyWWQjLk	359
14199	2vbg48Aot4K5fhE29gDsLFBagwZosW683o8BpeV1s3LEqhcxKhMh	359
14201	2vbaUV5opUP8tFeAq6bToc6DGFod9wtJfFgwj4j4jTc3vHLSjA5T	359
14202	2vapzyJF2M2RR37exBWhvDFmM6oNTH4UuNzbprraNsyajLjXTz4A	359
14208	2vbgTtynWJGgdvHyhJyebaCPr5mmDogHNPdVQuF76iE8RQYyhPnd	359
14214	2vbBLzzYTuS69515Zo2PrqLB2zmsu4Dsg5wmUiefJNHN688GixMm	359
14215	2vbsGGkNAF5DzmSJcgTmxpU1WQKyzyAUEXNH4o9AVgbCWSnLAfQt	359
14219	2vadi8T5iTiJ51eUmA3s2rq5vQ77tusm47yFrUk9v8KaQ5MMBZcL	359
14227	2vaKMu5x7TQFzz3mtZcnrRvrP16KqaFYPaZWyudst9x8Uay2etSU	359
14228	2vagg85RFVMCpuDZ3TvRJvDpWh3KcAMPHzvJ2FvNpah9pTY8Pwx3	359
14230	2vbe36bDXWkFqGNxASdd8Ksn34v7RZa1cnDd97ECpqnJr6bPZmu3	359
14233	2vaJyypShYiPvZ6vEhEKsBD4uPacUPe3hv32brX6VGi9r5WQQ1Mq	359
14236	2vbBjvMgKCnBQ4YpTJqofYapsygU2QeGHVpWtzZbYVzUdNnoJKpu	359
14238	2vbMfks9uwCzSnHEMRyXeuqMmVDdN4gZuPuegY1iALCEsc7KXrK2	359
14244	2vbXsqj7MVEmGwVxn9Cqcw9Gmvxkn7asDP1W6P1BJGL4CnBNrP5n	359
14246	2vaAEeFUbWZwQg4FncSSQKfsataT7XzkNf1QPXF4SaHBxWwUgK4z	359
14221	2vagkVZ6sEsxiUB6D5p61XytZe9deUTTLyiGDtVCi1GR4L5i4HdU	359
14223	2vbTeYycL5DYHcidEhqBm1bG6aHsWyyQE7LpyKP3Ciyc4F7JszoH	359
14225	2vbsNKbBvugtSwWY1iYzCcYRi8QkdtzhvDNiAv3X3fqvnXrYsa21	359
14231	2vbrv52m6Stfw9ZkrxcQJ7fy3Q2MQdgyyz2owLRL55CpRnjo7LBn	359
14234	2vbvNv5rtKY3WWMrW8EEifkj3vKC4YNe3AWoHcokVVrQMNqRJBCv	359
14239	2vavX6KYfDb1pooaQhfvkYZ5x1tbFxCkvwFowWcNvcg37sTK75gE	359
14242	2vaXNmaq2ZULwwaiijDhEkAT1abqEX2q8MK5Y2dhJLKwue3VwXpc	359
14245	2vbkqTMf7rDhdmAykWJd4CQtfvuy6c3hoYJMPfkLuaYiWgaEfdUG	359
14247	2vaLKWm4PPHKPUtsPLgUS3UFvF9sS5wQKcZ4iUDw54KbchahPDiC	359
14249	2vb636tm7jpw6Vn8618PW9efsQ6dbnyj6aiQfTT62ujBPtMRWC3L	359
14250	2vaCgeNTVcRPo5QWLszyNad8L1bvprZBnatEezLuna1MzBMJKErZ	359
14254	2vbJcaHtxAHFUTbdDaY3nTZBUBL1U3Tka3y87g6EC3JAJskvPZKZ	359
14257	2vakmkKUTF4uTfVeU1uScmsZpJ7aYDg5uRyuRCMs7E25r1P2nu3o	359
14261	2vahs749xKrvmxeMfP2MdiHVF8KsbHPoChHZcNQYetv523sPL9Hk	359
14266	2vasyen9avEezxTTq1YaA6qGm2F6mbhMuMeMxUmpfvVu47ymNGvw	359
14267	2vaKzYUjwmZU45A78TGbSkgMqjPDTMLSi4EHM96MXwUAb2So5bT6	359
14271	2vaaMTcMGXEsU7BtEQSEGMnYreUXuELmQeMoKt1jMs6f4iZiYDMN	359
14274	2vababCvdvBpwZYJQn52ooYzXnYnibfT2ReqPFL6N5B8GcLx14HV	359
14284	2vaCP9ffLdaPLk2dL2CNf7uMSfAtsAzLNh4Mh1W2dr2FyhhRn5jz	359
14288	2vbqnQ4oHtDuKZnqAUnGmyKcpmqsdmEYeFkXmXA154dqApodzNf6	359
14290	2varekSy62tuMPyBDEsPn63E8mFCKsEgZJsZnoTevAA2GCUbVSYY	359
14293	2vavNuogvK3WLy5p56MzGD5BAZvdz12AaR1ChXNjo1umF2EYqUF2	359
14299	2vaWUhBSyKPPSf65Zh2cdJxZnTgFHpd9xnJ7BQYrcyxSNeFT2MYW	359
14302	2vaU42DVLQvPaqVNuGKJVBKoPuAx1J3uo6PvjABBsuiBYE6VmBqE	359
14308	2vbQkEPL8CvuwZPMq2FRkUmLb1eTUQRd9Jkgcig76Ri2itUEZYV1	359
14310	2vagcszA3BR53kzHxAvutvLjFdjkKq9CnjWAz547CTyoSbZrKEz9	359
14313	2vaiGZTCqHjf1th7duRVCzNyxjCMo8wWAbK1ud3ogQiewJwbA5Pw	359
14318	2vbhFmqTRrFXsyhW8A3J4p9J7R5rCPXfZFvGG5cvHGLXeoHS1uvb	359
14321	2vc1uT54wNYQgBMpz6nT1Mp4dkkFycDVja2xNTrxW598LHcpgmn7	359
14324	2vaMaui299HooirL2HgNJFcpBQdRX9wRJmG8nPxFPf3PS7fFGWMp	359
14326	2vbHfSpsweT3mAkajtQzKoxKttC8QwUfdmKFonVXfNDGxAscmY6r	359
14331	2vaENBSLgUF32QSXJyh196i2Qr7hhDDrW2bcqQSVnKwh9gFXoxcu	359
14336	2va9ZqmqNQbUivXfmiysqTwMVyXzZdNWsaAGoP57xLNRBAxZ2aLj	359
14339	2vaBWdPnj834d9QP4Wm8AYGsFJWQ4i8H9VAfz15B4WXKxPaW9K6A	359
14349	2vajAMNrBa97ohFUBYYVnZ4RjNpBzxfs7jvG9PvP8skW9hCNKSVp	359
14352	2vadg2SW7V9M7wywqDdVTsTe5FGTAAN3qaC6qYeXRbG9ihhDwnot	359
14360	2vb2Dhsh4EQ5yyPt7Sv1NVybvLx4269t5bGNLqWXB1opD5sDHKvq	359
14362	2vc5W9EvKpUERDRfFz8NkpnM29f6LsEu4vzken2niFer4BGvKybT	359
14365	2vavCKVgaZ3RghUfGiTTxPayAhxMJsQn7Zwwouuwpqp81jhHXnNi	359
14367	2vaJLEoZftr6YMYUNgAj96QRysrFb5t6B4tusnFViCH1AJppUcET	359
14369	2vbT9fkSaETEzPxqUPK4zcG5Zd9PPVBgQYu7jZYATi1z2UKdF63Q	359
14371	2vafxx7Sz1ov9w6srwkbGXKef6vdW1zidWS7TnLEHkccemzNgfXX	359
14374	2vbu6hXMb2VrepMHk7zE3SK8NFt14d8BGE7SHS2ds6G4ifviZc2V	359
14378	2vaZAvZqPf85kkUCNWkWrEfXGumMweFqzwNSECPAtFRBPZGhYCbJ	359
14381	2vbTGrfq5dmL9Eva5sN35xqCCWoxib2CaLGUJnYS3NyEjCaFRiLJ	359
14383	2vaPZkh4uqBskiEL2PfobT2xt4HuUv6rYvKdrg9Kff7DX4aRJUE6	359
14385	2vap2fzFiUEjKHJZRSBqbvoLHvNvDmF3m2zBaiM8Zvsi9g9yDeXJ	359
14388	2vadZh9Rxc8GsBd3pYhc3u56HEeM3SK45rmWMHnGKfJHPKjYT1mg	359
14390	2vaWecjcPycyMegSjbPiVxnFNarKKJHYFeUMA32HAnQayxAnjCDB	359
14396	2vag6kDGgAChqUChiLJiA3szgxckurGMs265ARygjpKE6BhrxQtF	359
14398	2vbMLzeaaCwYBEm12Wfs5TArcHogrBZqLGSbDT997vmWSZcAFbmP	359
14403	2vbk8E2ZDrnQEKEHMjMiZ7s7XZ4Bs2opafzFqmEu25sZB2Yf76WC	359
14407	2vaFKKPLgLSoJGiYUYVQvb2mGYt6zVd1Dv1daFtHHRsbRxn7SMd3	359
14413	2vaXvcx6MYjG1XPgXg3xQHdgpygkbwAB3ZegbQwR7m3EaHqV2EDv	359
14418	2vb88aKjZRdjfsxCGFHz6kz4X5dUJkkwE6mXUc8JXr7h4hmCNEK1	359
14427	2vaJZ79So2agfHYfscWazgeQNbthyQVvqyaUoWf2Cu4gWMzHh7G8	359
14431	2vb1UsqcXaZ3GKgqUMaathuAKeJpQAECnRuzNLQ6FKsnZGrLGjTy	359
14445	2vb2Bk5QgPxDLEWekxQYXvKQoyD4A1tcFLyMPAxxGf2nPH9iAk8K	359
14449	2vayfNnELbpDV1TZAJB3TN4QUZvTM78egYtFaVivKYkx4KMjyVdU	359
14452	2vbXh6ti1PbTVcaEwQzv15jSQkh65WAmjA42bcH3kfufFuZ7XntE	359
14458	2vbgwzoZ2MnwGrxj38DWvkm3tBnRibgWabXYKrK5HzNT2riX6BTk	359
14460	2vappt275p9nYM7MGyZnncue9LMjZUeeYfm4zmnzK6YFdr83zNyY	359
14472	2vajT8yR78uwSzt43KFGG1J5a31dnARQ9SnkoKGhkbmDi1ytCJix	359
14479	2vbqQ7TTKpbstvPezrbqGHx4ib8iXxFPHPsXsSksjMTYeENB5fHC	359
14481	2vaeU9dikv67zyhFkSnx5gbNFMq3oVPACZMytcBsLV33qYkNdSHf	359
14486	2vbN8JDjRRQaKo2RT5y4j1EpWe71uCm1xkbvR2rVfxkfqMFRkB1X	359
14489	2vbJEZiAhFa5ZgxYwXHMSL6zPDxTX4RdvebzwdbPezzXxviu1yoi	359
14492	2vboXeSgrGarseFhF7Q7dBNJvsffYS2qs4J2fiEzQUCDY4fw5VS3	359
14495	2vb3GY9ADc4Q7iKTPnPqyc6drHSQotRywgR4moicrtAQJLfHc6Jx	359
14497	2vc5d6c8AeeqqJub251GLky7g78ZULBES1zDgCAS7wwAqKWWmxSk	359
14499	2vaQM1oUvmtnTvysqrMUWYK3kJud9g3fytyf33pE4j35MaUYnBV7	359
14502	2vaPTXY7eKF9UXexC3poV8VnZHZZEnqQb12dMJMvbbKLVgra99hT	359
14506	2vaRA2x9mPGgp2T9ZdyvcC4dktVtpcG9arieMKxUn84becJij6ad	359
14517	2vbMeb12owZ8QAaN9eyg6LHU9LNK12oRhXtW8jqJPJsWPEsoBmv8	359
14519	2vbiP3sDmmGaP2FUzcjhGKJGrpmzMNzBCHhctscNPTtzD1DDGRWB	359
14521	2vbSwpULhcZva5wpr5DCSbc2pBE8MpdyQaF2UMVzd7jJhEVVMaTX	359
14531	2vasHVTiZD76d4Qr78AtpVboZ64MVKx16aayheBj1U6Y1PhT2AfH	359
14537	2vaMQ2mszcT7oMnACFNAZ1uxhZsDDsx2tTynBk2WV5JQZ2d54oWw	359
14545	2vaqQ5Em23PyGZaCpEm7ADCUz3V2XkCXkrE8D9aSNKif31E7qiwU	359
14546	2vaUzRNfKUNULWvufUpDzi8vcdFmLp71y2SHLcwVMsfVZQ4KahMG	359
14548	2vaFZU73AEaHqN7R2FKv2XidwABAsAJKJdkcRhQKvHaw8HpGFoT6	359
14551	2vb8eFT3B2BUjNU8rhLFG8iaYXFKwuGvrNwn8xxzWwY27Zd8nKEi	359
14554	2vbhppeoRSxw9xGoCBbKihyeRy6Uq4XzxoYaBmcu7ssBaKwV1yHE	359
14556	2vbeD2zm3m7742BDFcgtzpt5RwuBXuCcqkLjCsyxYc7xMc89aUya	359
14558	2vbCx1kMjjRDBmx3V4RpjfnZVBvV2FFh9Q9HFMBM1ZxYydVT3rX8	359
14560	2vbUqpUvKeGRdWN56GeHNpcaPd18adzw4edeRR9yHS13xLXhUpSF	359
14564	2vbdFjnAZm91U7XeWFDCVCn2jW2nYQUEoZn7xJQgityGhi6616Jv	359
14566	2vabM7C13UwvkEtZwXQatAxBW3McVys7qTC3RkiLeuR9rthkd77H	359
14253	2vbfnSKBcfgA8wnWSDetMj1UVNEAMVu5hCoZ1AaJ3QDLkbUKZb8H	359
14256	2vaLNeEHnd5BMdW3vpJUVHy95VzqHaetK22vGHcWrzj46EQGCs6Q	359
14264	2vbRYvDCG8pFHUejM4zFUZmNrS1tV9ZTeu5n8T7zF65msxouRpab	359
14270	2vaRd3UEMGdskqHvbZW6EmF5RRjXLCHKWGsUdQ2SuieAAAs8JDjJ	359
14273	2vaE2HXmr3bCGzktks8JzvG8naZQMeNYqr2g9iPGNFGRHSFqbKHT	359
14276	2vacixnvRnSfqmwMrVbotFLD2qU5yktWpsWziAZLN8QdiJoc7eUU	359
14277	2vagELKmYTgcBpPNgSnAF3JzwgozxBWrNgE9UMyHEN3ghd6oT2xx	359
14280	2vbZ1BAdozTcpbXerAKwothXzusJzzeGBLWWpoxx13DuTQJf282E	359
14283	2vadQn1Vq3U4Y6p92W3gcNiDPd77jmb4eDsYkui2wjioSxFzn48L	359
14287	2vbGpjgbZinUuze6UuFP9r5QDV1zuj1XrDu4xqkW7dD6viTmGZBB	359
14292	2vaKTTuMFZxcNXUJ4eowEzX8JFVfSXUByjaQRLJ3kfMaZffznBjj	359
14294	2vbmdjJsQ39UBxYbf1un3Ed22XkV3VvtNBMxgzj9ZcZkFeNaaiWd	359
14297	2vaT4ooNLdFtmr5eBF5PDjhRn2aRfCJEraYQYoGcFSuYhi5tDBTD	359
14301	2vbiRueLLoCvJVhSQbz353vZ83Nn5QSjibYdmCSdSUZ2Xx3BFJzX	359
14307	2vbcFvK2ybp1PKzkaXvCP1QVoT4CjbPWyXTA64wKmYkhez8n4yrQ	359
14315	2vasqyr2uSdwjePWwgmmjT6p6FveGdvnWfuHv3hyLdHjVxFWV2UC	359
14320	2vb5scD5jLYXoUMFALWaBCChbhM19AimxioGtXBHGo6TxsK5r2u9	359
14323	2vaPBw3aVbQ2Edvc4BaGkJ99sC7NdkDdenGPj4wxRv31DvPmx3X5	359
14328	2vapBGEWENysEVTR49j9YLTPHg5J17h5hLzqUAa7Wgf8uguqKHb8	359
14333	2vbi9LZyi38Zx8cTcTGr95xBkKseLg9PvMJjx8D3ppr2kYKeppk4	359
14335	2vaQN2MkzvxJKxGcfkgfhRrzGVTxPgBZaYioo15qoUoFTLSVFvuL	359
14338	2vaSb63xbnhVFUiJsxSYPvoq1Vmefd4n4xGox5SL8MM9X23zcTGC	359
14342	2vaMD5xPkyH5rGwAhi1ixDsj5HdprPmDvfTUSbU6RYozKB1Pgu96	359
14343	2vaZ87r4oxPuXpBwpX3dmF4pkaawU42DqJXoiWVc5aiVSbGsMmh6	359
14344	2vaDaANbw2z5WwCtS2vMTpFFqhfEAPDQxcPhfCecgBWG4sLvi9qM	359
14348	2vbChxHuwRMhJcBeGJSZHThjhPaqYb6umLmGxHkLscwirXwV9352	359
14351	2vbgtvy8zKFRwSbVaLxWwZnhNoFb1bHmesaJpLEyJ8WpPVb4ph8Z	359
14353	2vbv3qZzUDiwK1Mr7nqMu126fXjyMhu2yeAUfkrESJqf1CbEco8z	359
14359	2varzpUKNVhVZqSoGPmd1dVAoWqJgvbZPJN5JnaMyX5xwNow4u8D	359
14364	2vavo5uLXqVgr96RvQKiMcaVZCoyxEwvWNhmXyrygWekinoujXet	359
14366	2vbABh7o8yWMzJk8MBZHHopWCandPX7FwAYZiceGEUJc9XLkQK4V	359
14368	2vaVnuNozK2Wk6YnakcVvuy17JAcZoe6p9U8i6z7C5PoTjd9xqmH	359
14373	2vaegZjDTskkhTvmqmyTkfKCCHSvc1iGzRaUzyUMCRqnorve626f	359
14375	2vbxbb3nwsFRN1GeCtG7Gd7KfwHDSgeAUEPwgMq53x6o6VL2LYWs	359
14380	2vay4ANzh95xvPCDNKjjR9CPm6uGqHivBCn6WxrMcHvCuL3mG2bq	359
14384	2vbL4q9xCzZWpC35r9viUJq9w34gHSxkNak16HNhykAGNkqTvDa4	359
14386	2vaStTdgYtDo3nKoYP4GtsTqfcSDzDDbRJNLnqvkxXnG33p1CEvK	359
14387	2vbvrR1CFEUPeJXQqBaFkuKVbbELUm5ifcMyG4MKAxsxPLnT4kak	359
14389	2vbEGBTWfnFEZofuPhEHD9eFCYgdpjKG647WXZMijXghNCEhy1qw	359
14392	2vaiJ94a8dEF1cjRAxCPXqkE42TNc3n9wABHEKzeCzaS87YpC7CW	359
14395	2vbvMWf5QFjmV9B6zkBW5QSGpbJoXHEjQDaPBrf5SHZ3PBN1Ut6v	359
14400	2vbWFh5vWYqGHUGqHQivRZG6V9UmWNGEE8KoGmN52VT5JafEAR8x	359
14402	2vb6oDYtuSJDWoVjrGeNpXaGRxmVdZeKD3oxykEumpgQisKR73Ue	359
14405	2vc2EfHZvoPVXz3WGtSxLikPTPMnuvJcu9MBSZaRXim2hiVoTWru	359
14410	2vbh5PXsmvN7thxVdfvGsmQCAkgQQBUtiCGZRg3zjHLysdxR2EjL	359
14412	2va9RocWvGHSUruSBuYjNqpB7QRg7SCbdVW14zzUhFUrxNcx6vKE	359
14416	2vc4PzjN1keBtKdwUmgD2n957ZwwZ4eT9fJHdAhqmVf5nvzjRXeN	359
14421	2vaqS5edFv8SQK2791sZ32TTLQot3UcVqQ27Wff6YvF8Pd7D5d9E	359
14423	2vbeAnupMyJFru2HUAiVrMYti84dsSpd3DAh5r8zFCTZXEw7rDWs	359
14426	2vawGKYDWapwYGubMsM81iL3asnebdwTbUineA8GSLtDisiZe8UN	359
14428	2vb1HyGTQyerw69hr7RjEYrkZbHsXGJ9ZiSdtyQFQJN9fjmHBsSS	359
14430	2vbA7wkdmp45PRYjXtwXX1ydXrz6vSaE2YV2Nv7UT1yRERs1Ypqm	359
14433	2vbVevpesPiCntGsonMMasimTphvPBhvsvAk4LC5bM5x9QL6Ej7n	359
14435	2vbZ5vUNtUqZoCy91CFidk9iecDfeLKUiFnXURRm7g24XJ5KSsMR	359
14438	2vb48xGPWm8bscK6PjnphyVpM3cu1QF1wJQRfHZufNp86EuBjDij	359
14441	2vbScmGYdQp47LYdCYYxPoyX8PqBqMCgMmATftuVsAxbGat98X8T	359
14443	2vbitksy5SsSLzXHEH2Gkycuy773zCziDxJ22Vv8zVbkBo5MvJkB	359
14447	2vbFaA8kWZeh2j7edZBUBZogXCVn2vCpvhqwnymtqEJC3RegEUoM	359
14448	2vbJengWm3HhRuRT7cPZNNuf21VaKqWzjcZYjjQtTirqNbhfL2Fj	359
14451	2vaVfskJxtV1VtRifz3vgcyrQKqLuPJ5sqvirsW5w1RDFeSvGDRN	359
14455	2vbUeajvQWJfFaQ8uUHPeG7LQKkrF2CPbpuB5TjCQEwvaDU2YeZM	359
14456	2vbFvkA417d9NsWumVomCAx8dXfoXaNqJJkmoyC155kpFpWfUBkb	359
14464	2vatt3isSkCMM7ZiLMoRW5XqNkzmP9oCUJs2twdSUrPEkQV5Mwcw	359
14467	2vaAEaFdiuHDgABvf7QLLxS9Vip5BHxPenpRz5kSNBruHSCPNwsH	359
14469	2vbejPAnr8xKx3t2JUUHVP5tfPSH6q3g9kqkhJEWiLgpu6hrmFzC	359
14471	2vbpUokt4DG839xZSbb13VtwcwpyV3woqp5hhrNPSTeeKL9kQVqA	359
14476	2vbrCjC6yDpo3Bxnr4dqRjm2vuinfqE48TMGynBJZMwtxqAXAVrt	359
14478	2vbAGo88wWymXQRJwuPvY2ecjKuTH2mQpaGMqzYw1m3UURR3Xgxn	359
14484	2vbYZ1P5ikQnhMcPkEAxzbXH4d5h8v7JqqxfWrFVbNMkVzH9TpgG	359
14488	2vbLoip1PY4UuwbHuRc3wSHomVpdoBY5yctUk1R82jo7Zt9SyxEa	359
14491	2vbNN7jhRECvTSneGLU2aT61gNM2hAFMCqtLqciMXNWBvkhgEiTN	359
14494	2vb5NaVJD1ooJoQY4oBwvepB1BNKPU8L2Rvr7GQmryqdoQKP6arw	359
14496	2vazpsB1gzk2nH1d3tFiudWmueXatfpcrzEXmdeVyyZEqMyBWQyZ	359
14501	2vc4gkvnN99ArHcccHKofe8sttnBhdUsHiNv8nHhMX5ZZf9sghJg	359
14503	2vaG8Fc4b9cnoBCuU84zHQyZcqt7C21CGGrMjeVSJVWEMK1pRyuz	359
14508	2vaxQcbXJ1HXcYthkH9pwhxFDn5LtesRRvmRERw9aRCho4Xsxbia	359
14510	2vbjGqQWSNj2AP4VygZvNbiqky4BaPbFE18D11KB7gra6Q49x8gh	359
14513	2vbtMcNiXrjR6ZsPWtLozbYvDhWckJzTg7XdxyyKh5Pk4hxgGRZB	359
14516	2vaQSWiEDQzMcqyPmjS4R6nzN6AA2H4N7cdXVCFUVPv8zCmZoLDe	359
14518	2vb1ipGMVkGERMH5wvcsZj7soeHmyhByBxoeejNLyVWJrPipkrDm	359
14525	2vaCRWVn749mH3CzWpavGi6uk7FdcKUa2xaF2TEwExYhkCBzppNU	359
14527	2vat9urwYZg2JxHHtuRP1MhNYcxcBRn3pafw9AbgDZztreCTSGoT	359
14533	2vc2rctfRwoANjE1BPLJuHTNc1N5XJHLXy79Qsh382GGdo5JNHDH	359
14539	2vaxjQyQhKBfpzyAKEyJTSgmLMJnDMWEx8Za4PMC1Gi1ma9tVdsR	359
14541	2vaZFAWXwyGdW5nFqZCngZSaUG3pqQQ9jUPLBfQBZd4BKQzziiM2	359
14544	2vaU26r6BRnmscjCQXn11wuKvbehychgJYNq7X1dZT59QYMquUUa	359
14555	2vaFTmXymUHxz73wY5RsbsP1RBb7frmoMXfDRTQHd2SoYRA74iPu	359
14557	2vbqWNMybDmLxV1rS8eDS47FqK2ZMnmFymWT3uzRfhsQc2ZnGjLh	359
14255	2vahuGMyMyqS59SmENWJ26QWByBgu82MEcvMT1m3yCuarK6L5ZVf	359
14260	2vamByiU3kCVj1vipmvX16keeHdveuQFUWaRtL8dVeNYug4xG1yk	359
14263	2vbBrTxQBeB4Emx3orRSRVYx1Bm4rPZFyEe3Fe4DQWfCbNN3ei4n	359
14269	2vbz77DcbSYhJ9J4fDKRtJAKzQ6MEKtQTBuBit5YZ7hxPqwvJ25e	359
14275	2vbE3MHGwVveyBa6kZw6tq5aaie1pJTV88VMW5xkByH6VBJbLk3F	359
14279	2vaAvoneU3RYgnkA9J1afkJraTkM3PqrpJiekgsxtcrAE4TTTS3p	359
14282	2vbKdWqwqWLmTFiCFLzEeknqHxh5MBpQAHzMiC1AEMr8xiR2CKCi	359
14296	2vaHWyPrjbUCncnckBzjyRuJmni1ksex6jQ5WFRXK4ebs4U1uXAy	359
14298	2vbuesH5xc6EKdjA2f37e52XagzEpAqDeJ1oFkz4QLiqMCCdxibi	359
14304	2vbvLnbMQxf1kJxKrZ21cKmWeD7Hkh8Pg2qKGdLWSusACCuAexp7	359
14306	2vaSCDCkvRvNkkXNgk7Nb3wMbCgdtB6LLShPkzNhfUn6KTiQDtzL	359
14309	2vaPqLGUyfHWRuivCXoyEmCeAhpnEYVPnoNfVsK93LeFfs5ARgn6	359
14312	2vaVeFUvc1MqHQSow8g5EG9WXyWsC8eTo2zKa5otY8pbxoUywpdd	359
14314	2vbD4p3zaiE1WwmDzaQSGAdwtsEzEGijfeihuZBH7BdwkpS4fTsR	359
14317	2vaiq1kWugXusrLHhBZMTVZD4XLhKTfpHTT9DXS2pq3mMpB16ZuU	359
14322	2vauBZiJdd1k5YDeQKaHgEbP6RKoTFsmSfhjKoeE12489BGcUd4W	359
14325	2vb8hP5W6Jo5N8kcRWu7yEDkWfqzhYXSUGrnkxt9skooAZpScM7q	359
14327	2vbKfSNG4ySEsFSagCme6yhx2eNTMEddeTgUbvCNK4hBagsckFwX	359
14330	2vc1AMyY8TxGyNXeKrSBq1EWaG9Z1XNQREGkB8yQK1BUUhcEhx9A	359
14332	2vb7ywjXSGnXfTfaB5kNvi2UCTXL2mMa4vCJjpXAWMiBRy5nqrgV	359
14337	2vag2AjXG9RRge6D8v4Qmp3uEYAaksLSDrUoa9QhxqpWEQTEBEME	359
14340	2vaFm43U6LyuHvttrWbzU6YdVEQTBUTxhveqDF3upvhihGAB2ry9	359
14341	2vc4xi8mLLMWSbN4RcnKWFx4EPCF7gxxMrsz4uqrrtdJVoxGyvdU	359
14346	2vaGv4raXRMQdN7rF3EgXTW1gXBXfLvjcSEzE7VWBAVHYD5LzBNF	359
14350	2vaDxUmCTexva8yAHAKj6MSPqsjExe2stm4K7etn7hnwXK9MbDhs	359
14355	2vabrcjootaNJj42A6HGbZqSbC7SRKfjZ9QY9ErJSegXozFFXTty	359
14357	2vbjw8PzYWQEvgBVAUoTDnRfxLBVTLnSoaqhJo629PpgD1ZEt9ex	359
14358	2vbCgFgw3nsK6NE7MorQAt8Hg6f3zArbtfTAZ7aRyAANu4Knt8EM	359
14363	2vaMqFS6uu63UdFTBuT2GSZNcwucd9NFJAprNDeX9CSSkNayfzyL	359
14370	2vbrBRKcDL7RXSeZPXUh96vZidmmbcQGDQ8goTNG5L2bghGFFdiF	359
14372	2vbzzufNHX8wtW5R9E3jucXi4z3f7Wu82uVBX2CSuijL6jXQu6tH	359
14377	2vbrkLkGDkNsbWbmZvC4WHEaLg76gKdvpN4Y39xEGrSLEwkBEutF	359
14382	2vbMBQJXB7zNhAMHSNUeU2sc4vQJBkDvXX8Sad6gBkeE8PYRhiky	359
14394	2vbvMkMLqTh9TuvhFiFrKwkm8QbXpqWykojRFut7DbUHVJgmboQt	359
14397	2vaNUmAyoGkVB5J8ezPa9fsvLAs55Ba1RQELNv7Xhv3kkj95Gj9t	359
14404	2vauf9fndLXakwWNivdEa8mDoYLS1EKtpZcQhGzQ1C2xiBRhS5tG	359
14406	2vaxsfYmeKvLcArZWUgeCyxVFeNDr51wwhUGQQf27MuLsVDskkh9	359
14409	2vbbHPxmXAid7eZ5jY2n3QFJGLZCMNpYjQHjHDNPjm9zuiuJSKHA	359
14411	2vbC8r9kMbczZjVernohZ6VesbnwjUAA5koTHnt6vkVuvPfq4QTB	359
14415	2vb23e2LLzX9aaHsYzNjrL2Vwfq2QN9d2GLhi1js9F5Z6YdDAAqf	359
14420	2vaX5sYtKHgyMenwoTxP7YysAj3DT3FQYkVEs6S9MmZS4pBkpEL2	359
14432	2vc4YD7pbbQTnT2MvVKZFeBaS8Xa3h1fKXTxAhG7dgJFr45TgoDw	359
14437	2vb5CsiyvwTWoFMs3UFYERPSfmB8bHgU67EJcRQqjsbK9oonNbTr	359
14442	2vbmAM7XcBzhSHVsnZ9mhJpAQZJu4vYAp26Qu7rYZXxrp1r6mXNp	359
14446	2vaVrdndhHwAkWVosfzpVhTRiQbqeeVFWVXUPTs247FxQhdoDHxi	359
14450	2vaMRo7sspNbCMpPK1adoocNuRfuiRAiT2vdfktbz9esNn15NEXb	359
14453	2vbuvLLLdDWHjQSTw38NdNkpELwKxxtQvasCh1PfdF2cVn5AE1NB	359
14462	2vazG6NrBiKaXZhMyfAbF8wnFdMDCrufy9DdnzSH6aMYjkGFNjoH	359
14466	2vbiAdVox6j7qRwpkBXFbUB9WnF2CDUgWAHXTmd8akW4xxLkcPUb	359
14468	2vb5cimVi9mMsVgKXaATksNf7rk7GsGwqer88VPRi2LsBQgwUe2W	359
14475	2vbAzFaB6QfVk1jGk15enKZkNMBbG3Ca7xLZhX7JgTeP4JegyBKy	359
14483	2vaH3fM3EVTjgivtcPRJH9JEkFQjnsRdWMJ3UF9S3tVXWbBGKabR	359
14487	2vaLY4JpuE8VyFsbxXqwDTGv8qwF6cHyPCk66eJRSy3yDwTS312x	359
14493	2vbDRQzhgPVaCVB4HfzG5S7MuHr4VwnyaaKrW842qtFP3M4oL2G2	359
14498	2vahsHe8dgtqu8ZL5XuByN4SBqvtjtiwmtvpejuVGmftEpWUAFBA	359
14505	2vbjr5FHTWAx85Nx2qD8zH4D556S9qdTZZg7qKjLaLZX3Rtdz8zd	359
14507	2vbuCvPRgEYrHEAkgZWsCXH7rJBmr8XzdbtbPaj11g626pSPS6Tz	359
14509	2vaYdXVRrJQ1JhvHzdp5nMW9FHA7TSXAibZiH1UP1XmLB9GfzeUS	359
14512	2vaaSDEfp2Dms7WR3MLm8iQi767VFPj1bPXS2Uz5hPoNJKUSb3oY	359
14515	2vbGwUh81kBzvVtF7a6f33NryCYfxq1nfV1YTczv3nTj7Kp923mz	359
14522	2vb7Kgbbucjj9RGmPzWVCrwqZZDibee7RRC7VsLz5TJmfVEhv2kM	359
14523	2vbkdMFw7Y4r1LA1Wnm33uKVh6UatpZsceBxwzrn3Pr55VuTHUZJ	359
14524	2vafhDhd1J1GSW2fBvMuykA6LBqK4o14hSzj8xFtxWg2D1G7wziU	359
14526	2vaPJpAEkafyxEtPFstvR7wcj67r5ehLntLJ7Dtv221TjNgLNiDb	359
14530	2vaSifP9cbz8wSVu6k5Sexywe1Pi2WuMydns7TRpwhLDVGahntp8	359
14536	2vaGuzJr43YfAbPStrTjDi6HxsdinDKnWnc8hknrsxcXrjfduD55	359
14538	2vbhhCB48G2pFf2ruFnk9vUq3VZ2iLRBHW1M9kP3j1mnEPDxmRtS	359
14543	2vao9NGkDyMbhjAdKWAjqooHzj2o9j1aBqTKWhXRoy8A4KDyFpWh	359
14547	2vb8ePXCfyymRHba9xFMDYp96JfhyCKGXASqkBtoLsUiq6oZ5Wy2	359
14550	2vaaEwxC2mWgsmSVF3Mp97WW6eDPJihtn3qzTJ6qABMjDg1usgTQ	359
14552	2vaap8zzryUr6zgf4RxY6kgnn6hV4TnfbbjRXf4R3tfq29CCSc6n	359
14562	2vbBZcsNJSaqyXka1pzEAjydM4nKSGpcqKGQ6fV1EAKsHDVQPHZw	359
14567	2vbUdUctPGbxPfLWeDip75iXtakedJqN1gPcRfTnnmStL6cwiLKx	359
14570	2vbvpshLVTiHRcjzEnnZvYCDnRhqJkzZ3cwdzFr7iRBfnoYPWhAe	359
14574	2vbaCn3VWz71fqXFVuvHjg2VBz4Sr1YyjExpKR3uUNz7WTZbGySi	359
14590	2vaERxVn3ykhZ55TzyMYnpms2GSmcRzbgooPo6DNpXiA8hiJxA9r	359
14592	2vc4kxVnwd6Xwt8BsoJPT9xvhUK3iXRiNwnfdvged4ZsdorD5Qfa	359
14595	2vauUDX6DJhAqMwgZLaF1hpaZuTNkyZCYEmBrg71Q2dtdm85dbHn	359
14601	2vaZLYbGSghaTZfCMDNVSahWsBTLJgNckD9QU7xdjpWa73DeKFTe	359
14604	2vbSN6xkQZEDtUqfDXE346BqgW18xFKu9wiD9xGzybfmnx4ZKgsv	359
14619	2vbpkNm9kSfRmF3kM6gFwngB4F9D5ZZSv6jdBH7T9e9Agh6wJCPv	359
14621	2vavQ95gKezJ42mK5euU4azA3MznPME58qxzn6SbBdY2Gq3y4kcJ	359
14624	2vaJzQNstSVp5JbwVAuU9stpmJBZWrsoh25BURWAffyau2WpWkrT	359
14630	2vbyKNXsetLPPfm8XvXfBHiXDJoNQdymiVyUhq19XNKgcxsKcwYi	359
14633	2vaCBCFQbZjQo9b6RQNQ7xiVEeRJ8Qpn4qS2NEoF6rNuNuEfzxHu	359
14642	2vb55JRmoFDsgoMub6EHL3X1k2HnBqjJpn1Cgd7Yfn8oBLCUr35i	359
14644	2vbt2aKDJxXbaVrmuTH3MRWmT6uq4F148PHGvUsa7mhN9Avra7sk	359
14647	2vc2WUL72G3bEaQyvNMD2VtM7gYYnKjX4tJmuD3yUNFwWukx47i3	359
14265	2vbEnfg9VzX3yoexc3vwFhCz8mJMzEHx6WS9KnAx1dLM5uKy9d65	359
14268	2vb5ctrc4meFiy5pAiVfHUmWs9UVy1RWACjDEdkM4juVKwMFjfgd	359
14272	2vc1krqWQbiD5R5hwPbZ1S6Uo1SQfq4HjYXtqK9Q4V6NkDJRmAEA	359
14278	2vc3eY3uR6UYibjTKmPut4xQF1JsANzxPReULro8buGocCrQcj4c	359
14281	2vbW8162HtkXiw5pgbNUGSpQcbbmXNBrrabaaRPZCGvaBCPNCmwo	359
14285	2vaytAaFTcVnryFNJbdJx2HkycYxbayEXjJw48tnANjkgXgvYfrL	359
14286	2vc5WuYP73UzvDkuPaKDhmbFRZYBHbHWnMeXgJy9q5xhK7KfxrWD	359
14289	2vawx6ubCbZg8WPQpD7fMG2ZYnp5NUxVgZz9CjnzUDwwhT2DWbnF	359
14291	2vbJfgsE16RWeHExh83exEMhZeEwJyLi8oec9NvJw7YSd5MPChtp	359
14295	2varFTAHemv8iUKgMcUyNCMV9brd2xi6LkNLs7eYuamryuzfBxPw	359
14300	2vaHNkkZHK7iJiifLNvwUMXbK3AAELnHiPnBm9u7t51kx7AYrugT	359
14303	2vbiph5yUy6EQZS6CQm5UC2kcXbszsenkcr4EyJCtBNAakMA45no	359
14305	2vbpULa2oqNc1vJbNknMYeosUAUxjWTH1zsHxFvznhJesftD3Brw	359
14311	2vbXwSrb5JNmPDEfmxRFagGKA64D2j8AQTHaYQ9KbNu4ytDZYudj	359
14316	2vbRHkTLF6Qoc1RxRE7iseufdsG896vWcRCvsYuVraBBM1fwVAJu	359
14319	2vags7XDakBiUWvN4U19r1AUEFipRW6xN9EUv3GwrxZRt3DzZWsq	359
14329	2vbXF3AVU63mKs34YJBJno84eNnnbT2m8HN6ctn1ULzpT2u4BD4n	359
14334	2vb35SVgftXwVxoyJQUqF49Yd6YqB7PivtvmDUMqjCzggqsZzNzk	359
14345	2vaFiC7csZ3gNLrgunMtTzXzfPxH5USRr4C77YYMy5UJjNP3d8cM	359
14347	2vafTUUfKgksAJdsjrU21Zgpi5nQnbuPUWGCEYHufVNfQ1T8Y2iD	359
14354	2vaUzDZmAv99SZW8N2Nv1iznrYhqMUg9g1mADnPGAaJpAF8Rud5q	359
14356	2vbdDtNWzQvVnr3dqCST2Ay6c9QmWR8Ex84cocsunYt9TvQuX1LD	359
14361	2vaHZMkL2SLihhmrUuwuJqBK8v1oarJ1WjAf5uuD3PqVjkkMnBCo	359
14376	2vavbeApTKgZt4ovGrsBGCRRRunni5vczjh637DxvKFcapTp9yLe	359
14379	2vbCFWRcqM7fKBTZj6Fr6FBSLhcXgvczrrgqSuM11qUGtrsF8tmD	359
14391	2vbpc6CNfANXwNZTAnNkGEv7FeMwpqdG2mVGBmJes8UxLhSsAXnm	359
14393	2vajNBdeAw6UdiVSgWbUR7fCkoUiqz7NUXHB2922iSDPonYiQu75	359
14399	2vb3LrpY6kV97ogT7koca2Lt2k2y8Ps9tqiXvQZGGE3aWX47pP5u	359
14401	2vb677Ec3nyrqH9qa5ZjKLD9pvS6PuXR1jzrd5PzzQZBEXrE9rsh	359
14408	2vanaGHe7zVpLUpyWPbYb2kXFbDZeomJHYfGzDTzt3hptksbEKE5	359
14414	2vb5mS1EwJUUnCxU7X998W4za9n2TB73oDAEfciacMsnQzxDYDmf	359
14417	2vbN5HvqPxPiszLTxUrHRKwBbMHY25dFTJPLdfkWP1sU1NmUxoUF	359
14419	2vaA6K7E4izbwGNcfix6hPeZpq777oEyTfJvvKsrVo7Jbg9xp3Rs	359
14422	2vaXTstddPDcjY4ELvsQ3FDSuAxaTfTLQ6SdJq9THc9hh9f2PVd3	359
14424	2vaCDtEz2WpgfmwMkLV8KdaaPAWSLt4ZuwaPZ7GVHLf2akPLTcnT	359
14425	2vbQ5E71psPLeTLZojpXSRttJ94HuTjtdKB1Q5kgC5okMS8Q8xcs	359
14429	2vagriZB7tDnMNcuiduhD3XPwihBGoAqmjYdcFVYEjUwFevqz2F6	359
14434	2vaApJvQQULhpk5qLzzrnhpu9RTw6PyqErDhe68kC7nCD1J4DcKF	359
14436	2vasqZzM7Nebf5aVody3akj1J5pXM7iaB2DUyuiddLVTjRfB5JGV	359
14439	2vbDhQavd539b3XvmmPnrWjAqirVS8XL77BiSchvaWVQkD1sBsnT	359
14440	2vaQPtN93mFhwCnTptiznDLgrWQTEpnra1xmSYVGjcRPZnDQM47c	359
14444	2vb2JYB4q3EzLZoyVFmwvhGoE2mkV9wi4cWmPRRjddMnfNYSgEuy	359
14454	2vbJbwN5UF7mbdijDj9RQPJmpUYh6bEbYU6SBNvQHQuBRdBoksN7	359
14457	2vbyXA9o6YyYEeU7RMpoFp7Gim1h8sb2iWhbsHbidw42ErPjHg86	359
14459	2vbpq3qHqKdcXQgX248rVBSPa8BvXy4q46bi9jzuXThHvBaF7q3Q	359
14461	2vbRSTPrdL98czY4XSNBbRL4xTWvakwjWLAmZyCYfc578S9oBFBy	359
14463	2vbWdP7kqhFUs7WpikAuVk5hiQyDPvJyBWQ5GBZtsmm4bduGG34t	359
14465	2vbiSTArbWxJCK8EzyaWZivwbr7favs9f9mEczhV4ooKVANcTwQd	359
14470	2vbYx6QAFpEGta8jMy6ePFSAAGeMx3gWo7ZYxfr9Ac5j9Dyvi5XF	359
14473	2vauz9q1xrsSbZt1WoXkxX3Spsvsv7BPV2faWHMrrhVyB9zs8tRD	359
14474	2vbb7L9tNwe7qbohZ9VKRdTL2iA9RR6AjjcfsKg2eijVqxEeU367	359
14477	2vbzVPec6MdjhHTvYHJUwh2ucZK4zTAqLzqVvKvFwxzxqiFNwzKb	359
14480	2vbrHEb6zyyTGqgUvS6C1SBG1BBCTkoYVajtX2BQjdg5bJtCxtSa	359
14482	2vc4js1Vaq92hfZYnoYAFshhNkS85AE5bK6ezx6d32pQvhNay17M	359
14485	2vc25V8oUpQ6ugt7rmNH4qMCmRkWPQaW1Vw9Xedq5iwZvH7Zu9mA	359
14490	2vapyMYFK7qqKcRSJmaYe243hJCHYYyAEQNyQoD4jg1dBwj2gh64	359
14500	2vaUrsmFoLyzXjrdGDFumw4LXbzGxbE6WMCq8iS3dUsA6wM1jbji	359
14504	2vc5jYhMooXbNrEcABZ5fjWTiwMqVWTmnrjSPuzbb3YNA55S1okw	359
14511	2vbBPtebirKs7yzBcpiBc661LV9x7ve5B3ihXMn9qqTHEXmzkego	359
14514	2vbVDXDDtnA9vvQoCVix68Rui6XNkEtJh6AndLec1mp8o63TbW7v	359
14520	2vahRoPL7vEwrwcm1r3KUyNqKdekMqcThSB7Ue4tDV2UPYPzXXDG	359
14528	2vbToLamjKnAgftS2sadKayf5gTCyVdLnWQbPhzXL5MpETCApWFg	359
14529	2vbW6CGkPmzmfG3BrB6ymRK6Ery5kj1DfjKJdgeLfDnNBBJeb45E	359
14532	2vbuK3PqtX8BGK5kUskU83fcoVo7kJGjToUgDFnfPJvvf5GSh7oo	359
14534	2vaWHNKnE8oFB4Da5nXiH8bvqiRDjugmzwUAnhpC6ov6SqLWCQ6f	359
14535	2vaC7RBiYiy7oZDAKWCpyxveHzgkufVbfuYYB5svBS3UrrwR79QZ	359
14540	2vaUA6Cs21vL3fgjwXQwjHo4y9K1MQVTA4ByrbXdtPcVAjQeE2xE	359
14542	2vaKeYedUXtC3ZPeQL6ZhCp7z83u1zX8X4C9i2psn4ZT8N4fY4ed	359
14549	2vaEk4DysVZJ96zoPnAcHrRWgtnr4qYYNJnBuSuFkL9bxgW62525	359
14553	2vbFihBqFgxHiEnibvtL7Hvs8iBjTvjkWPHY4gcHGmK2EukHncKa	359
14559	2vbmv5RehJGkuEqL6cvXhSwXhVPwtL5VNsziV9EZXe5tvCkNSAg1	359
14561	2vbqfvyXyUPQnbGKrcDeg8r1TgKDCGA2eUVxHcy8kHSA4YVCGfrC	359
14565	2vbRWLb8HbNu7RUxYnytsp3rAVu791UPZrKNdGZt8SCS8uGgYQ84	359
14569	2vazYH5Djty6wqEQHjd5bCbpi4KVUokREk3W8EsaHaSN1R6vVBNF	359
14572	2vb63aHy9ZABQXdDF1KD79CMxfjHa73nNj8r6kcSwdeeiZgZntPb	359
14576	2vc5bTboLe861aSVHoHLkPyKKYidANv3mr4igscDAB1rYidcN15U	359
14578	2vbhCR1eLSYVtEHKhhUA1uh7rQqR5cFKjiVQARUajzvXWjeHeXq3	359
14579	2vaEwbQWeeZ9b88vTRxQyPk9kEfxgrhKLr1QTJyeydGE63isW9ym	359
14582	2vbpqKpMGsjBgopSFi1gktz4n8rKtEJvKyh5VMqzrhg2JDFVhwZ4	359
14585	2vb5t5RBegW5GLjwzDgCU1e4dR8j4HxJCtgmdDJAt1dvDSJAfdgA	359
14588	2vas5yKdNezzzwr2cPpHzQrbEjGrAnCKqJuWcWtUug33wjxC62Db	359
14594	2vaCaFjc7Dx1HFRdJQuD8Jne9A6yFbpkSBjjRs5dq5nnKycCawiL	359
14600	2vbPHeS9Yn2L3FGitsVmLEoqRquCRH1ZinsFVTaKaMmV1r4cFqMQ	359
14602	2vaKdsFAPDBLnk8CTGRVkWUsuBzYWcE57TosHGCAhKyfaCv3zdjU	359
14605	2vbd3cix2JQDTxPhauFhpwfXK7Ltd7MWfKNRsKiP3CiwCvvziGgk	359
14607	2vb5MpzQ5Bo48rUw58JCSYCDZGaJAzTEjtz518H4vVXV5Zg6mzm3	359
14609	2vaw1NtUJy1nqiKB39aoCey1Gw3wr1MTgk1TiEfRcm56rPQXxqD8	359
14611	2vbNFW1NwGsZZuMASRXWD6HBNoK76zWqxUm8xPCiyzQDD5uqKcQf	359
14563	2vaDhNVBXPNJL6MyDHxAbuGRD2EtUUoUcW7gzRCsYYT63EXvEjDU	359
14568	2vc1D9GJ6aCL6SHtKYw9ZyxTReLjD18J6zc8vZXdwf5oZf2uAEii	359
14573	2vb4pn5aQHuGdgs4Gf8u5nCLxWBdGMUAc9whC29AuewGUVAVqVAu	359
14577	2vanruR8hL522gAT6ZNoCwmSUbdaY5W76xnXsXs3fDTj22i5fs8v	359
14580	2vaFFHbTb4ciKEvkxYGfa6Jg2J2ew5rEqtUyawMX3yPqeMfMo1df	359
14584	2vbQddNTBhZTt9ABudqpjZwg58UYc8u9tNPmTYyG5swgvLia59Gt	359
14586	2vadZVbZGV5oU78SzrRh6rPFiJURRXfBwPyK5F5tscTYpW1gUshK	359
14591	2vc1nXAB2PkUQpLpeAMY1NbsYrmtUY7etghjiEk1e2H7VVecRbwt	359
14593	2vc3PkGD3iigbSCxN2UwZXGspgYZvuEecMVwkggxnTBFqSq84S7A	359
14596	2vaRJsjWuAPQ8gsaf7abjKpR5vbV8pP6ztRHgM1yuAFacA7XJzXG	359
14598	2vaUbmq94hCY6atYa6UtrAUS8HNyLYsXygHHHBHNVa6mNnnVqZUv	359
14606	2vaePzhQu8mGTwDikvii6WieG2qmt8fsnhb1DGnvvUSePghSpLX6	359
14612	2vaYP3sDDeR9x2kUjXPiLxADo9XMwmEqwkZpisH7gYxU1UcFJxLB	359
14617	2vamkPQK7BGCXAyXDdWYxQi4jUaZ21K8H7E8994WnoZn6uXCtyQM	359
14620	2vbfriLRFp4xL1J9nhsjX3Ge6vYonKPpfXkrPbrQXgsVhs1oqoNt	359
14622	2vbwbveDLAhzxF2wdqLDHhjfFHEsbgfL8Cqwfqa5iVxcreMXjV43	359
14626	2vbdc9wDaHeJ1V993AuUmES9t542qBXCT4Mws2zy1erzzPiGisHx	359
14631	2vb9ZkyUzA6vDxMxdWWytRYstytJa2TZfn6W2DMFN9T5dTYabUbA	359
14634	2vbRdg85U4swkBqK13wGtEU8e7Fd99pNeuqi8ZMrrMf5esNS4Co3	359
14636	2vab8fiouwnvYt8UNKLMJPYfSNEevWWxavo9EqNWKiZeYgnwCZsR	359
14639	2vaeL6G3Ab5rBHfB99Me2hUA5e5i39g2FAZPvV59qB6k1N43aMN9	359
14645	2vc2g4ZEzxgjuRRLPQfVfsDX7V5GDuFMLBBeaegabUsGZHMwT8QX	359
14648	2vaogdMb97KszVW3xLyqnAZAPSUEEG7VPADB1pKQgyXdBuRE2sH1	359
14650	2vbtwJ3GLrqLJWiYPnvXe1cHrhcJWavja6ps6Xui6XsDM2YQLus6	359
14652	2vbKxPJ2oqYwzNacyK9TDcsWbJdRHJHADWH6Rd7U9cjgzB7unqHd	359
14657	2vb9fLHdA1F8ytG9c3qnW5tJJZbK7VNXrgtFnyvtiPF9bCUcPqCn	359
14658	2vbfjvVrkPCfsD3mNzV16TqVivtvEg8kakSSbq5zNMaff1DaH3Bp	359
14661	2vaGF9F8etM2EwrKBSr7pzpZA2TKQGiBBzhgr9Tj3j9V5Em61NJn	359
14663	2vbdsjWyEBUV6en7RNt9caES6BedDncafrVJ1y72pmHvrpxQSs6d	359
14666	2vc1XsVZf4Xo8Khnq3SinHj6Mjkbv1dBop7uykQVRyJmnJRKmX7F	359
14668	2vbKLZus5y3XGHvogmd3DSpshXJP4Ds7kQzer1dJ9kwz3wbSxxoU	359
14673	2vaT9CFuZkSdvNxeF7EgywEegFYgzhw29uPYLpyzkPDNdnPHk2Lu	359
14675	2vaR43V4zaEjaJDpPSNuHuLpUzSARe5ZS3P4Z8ycPR1yYP1Z8LGJ	359
14680	2vaMs6mYonLJWYcKaBSj61gpKAe7VYyRNTsXXMozjWs9LJKxdSmh	359
14682	2vbTMLYAX7JyJNJac5AdwYnPDTfpCwPtP8gh76vYjkWb6UZmpNBK	359
14683	2vc4oMgoXct6Q9wnuyjuuxWFjviLQUH8c6LyjD2DWyyyWex4edio	359
14686	2vb4KoyB42vKARnvfTk4an8kquKkZi322jjyLuwYj7RZZu3uCYHB	359
14689	2vb62iPw7gVcPMkWcpzPdj349bW52bNi8TpFXXYYe2VhKXDQjUTi	359
14694	2vc24TJP8RTYn7yAUYr6ZpAE7KniSwRc6mL1nqDV4fbEmShDh4Cx	359
14696	2vbwvibLBq9GcsyAN8TfAH8hPR7pqetb7w3wZDYx5o93Pk6do5fi	359
14699	2vaewfXxCVrm11hRzMNCFAaWUU15DjktqGKAGKr8tg7SFd5nU37Z	359
14700	2vawCmemhUjNeZCT52gpGuvwTasqT6HBQrWkVhew28tgyq13DE51	359
14704	2vbSTGcGBurEYJVct2cxCeSJMmwrvn8sePnE48CZrzkBLCRqQ3D8	359
14711	2vacnYosppC7qpJHXGvd79nCouUEXcMKxPc4ztQccUkhN9cmYgFh	359
14713	2vaE3VDNy6nHGz9vznQ43AMs81dMUwfwg82gXj2em49waJgyuiME	359
14715	2vamHSaPbLXiy3CzUD3o2Qciy7xPmct8QgYRzYVnhBFY9krxyUwz	359
14717	2vaDfuCfsokisnkeX9mqNQh7khM2E757GpDL52HNcpi7981C4EgS	359
14725	2vam5iXvUySoWWHCsjq6SkbFbwhEL2VcCEk8LtfoB7nigoYvzCgP	359
14730	2vbAH1jQeFveCFe1rxfmz8926HTa72jpZQF3bxidj6zn2syTCrhq	359
14734	2vaWY3B7ej5W88evYLibWCCgL9QbhQ4fNNFG5rymBp8XfvCW4CBA	359
14736	2vaUiajd4no5W7WoPyokQFSEyMcuyLQaj6qAPuKMQCVhSBJa8iEC	359
14742	2vapFNeya9ZP9mwxWLupjFxTWWnAYiV71BsnHGXy5sqpxAJs1s4E	359
14746	2vanRzSmH1cH7a9ALiV9XtDiZtQhwDXU6JqRBqYhwyDMEkJtRzJi	359
14751	2vbeDRFEB2dLBoWhTU7CUN3PRo8s53d911eggovKgn9mLczTvF76	359
14753	2vbxYQGLq5eDk3B4qdwAgmPAKik9tn2LDqKCGi4UKUu2J8SYE42V	359
14756	2vbA1jPnb8aebCYXjvb2Wgihnxz7fXMM6vS4W9r4tMe7ErVjmTbx	359
14758	2vaX55xtEpT8dRQN9dyiPn9fS1eFPx47oDTLVU3ce9VBv9NZdZuv	359
14761	2vc5pFGioSfBXFz4Nmn3GBaXtpU57LysuSXnRrxt36fJ9DqLzUXr	359
14763	2vahPCW76EvRWiLc1b6uZp33WVW3YCzFGRipoaLMjGhiNm5XRTRP	359
14766	2vc55Dh6AGi9qZ4HSqd5xFt5bpeYTLjm6fwXysnzjpEhfkk2zvAz	359
14768	2vbkC1V8D3uVjTrUiw8XuNmRWzZYLH7A81wsKntp3tPkVwy94gv5	359
14769	2vavNKM77Hz8ocP5v3ixLzWBJph8GAQtECGZytcafFqUDzfQRqCm	359
14789	2vbguCCgj6o4fvtXtBnR7UuACKGRGiKdJKJzUp2XSSgnH97pZtqU	359
14791	2vc2P4P7qV7owFSsCYg69EHeL53SBZsWQqwSYmNwYgLPvCwQ4Zhd	359
14794	2vaS4c3aXxk5L1nyqhbEQ8F12ic7JzeLABF27fVfUpFCJxsT38b2	359
14798	2vapbK4S2dM8ke51oi6NER9tBLR9kqxQ1xpXqTstPUKscX4TJJLV	359
14804	2vaMEXZRfhgUHUbMGdquYnGEyvsEzJjSQfK3hPo8KvRREpYejVNa	359
14810	2vbidiUgSTqSvTX7TD7ChLypnDEa7gudtm3YBdCZQTtNxwS77TD4	359
14816	2vc24UAsH8MpKS6C6bsecy8Hj9y8dBoDukd85DycP1CvrekCyBci	359
14819	2vbnmixLnh2AZKAwgm26ByEbA9FvwMCWkLnosrxsruopivGekyT7	359
14821	2vbhVX4wVpU5m5yK4RjAzuEGgBvaZKwZu8J6H68HAibiETByS6gD	359
14824	2vbwC2cJ7saeZaPCBRn3NhzGXXXjx8KGpNeBX1qNGoVW1MhiX4qJ	359
14830	2vac7w46YLp7pG8y1dwrYtuNw1TiYvTYGAW2Q2vTgX3nSP8bY6Sx	359
14831	2vbBbELtTmW67nDvZENLNyGrY1hQ9aGsuAiqBHDtmbBLq1Vi9SJE	359
14836	2vaMU39HrknEEUz4tALSdnYDk7tXy88aXw26XDt97nwFG4wXnuqo	359
14841	2vadPiH5Jqbeh8gJugxyBNeRqM56HincSoZGMU4eMGzCMic2r3Co	359
14842	2vaatFN3nvT5QHXiTuAghcatLPjmgemWCAU5wWvM68fSnno4E57W	359
14846	2vbMSJH7okUWcECoztbbjZ5K4hcLhX95rrWPYpMPn5vwgQ9B2eHJ	359
14848	2vbZyjn3uSXqhSpiEZRDmi8CTFYcskAdJTPnFhpWFsUe8QC1BkCT	359
14850	2vaUiK81FYukoj44Bx3nDWMMmp3WVtDmd5T8X1qJEu6bn4pP1ieq	359
14853	2vaycS29L5vHCr5kWZTF1gF5AfzK1mCN5YqNj8BoHtYT6KdCFFhy	359
14856	2vbwNXhq1fGmkrzyfSkwHXnp3M69x1khX7kb1AqJgDTSQLf4SwzX	359
14859	2vaaZiCsFooXug2fvgMNUi5NTNNnM6KDYGCpp6xF1hPdkfe2zLNV	359
14864	2vbqnUEswCinzWMbr5FjhtwxWvpu7gn7tFt1wxQTbgfAkxkrNUjk	359
14867	2vbPj4J7o4vvHeXD1VruzCPQGmXd4K88on3TFcBidvTNCHqxh8Wb	359
14870	2vadWxQH5bpVE6D1w9DY5tqsFYA3CyVTa4dbCK7eKxhAB3YFYTia	359
14873	2vaA2GVgxaYoLAMtXJKCwybVmqdq1tdMJyeRbTMa4rCssZpRywcy	359
14874	2vbHD9gYbRHnzBAsP163rSh1xSNcLmTwiWxz161YqZYgJrxpxTTJ	359
14571	2vbry5Hz5vFZb459QDyt2C4UGpxmvF6sdT6kmi5ZVJuUkAnRonkr	359
14575	2vawkozkBF4aKcfba8bbfzzVYp336VPxu1o1iQhQgi5tf4yVNVrW	359
14581	2vaZE4Ye3bSNnFAzwjydgxYDNaobdbVKQULRLJwoGi2Pvr9vd8bM	359
14583	2vaD1zvbzj2HWLVhe5xDJRoiNT1AHS8Um8K3Xv9nwprrYBT1oCn6	359
14587	2vbH6EfsJiw1ojbrrUrzGCPf6Rqrs9BauywcWttSYRzpRaVuYZVJ	359
14589	2vbhWgBMDp9W2vvRTTymb9UzCoeKrbYWj4jBmPuhRTqkrKPLCGJR	359
14597	2vbAxF5nRLXD7CDuQbJrF6ZuGUw1ZLG5J3xJZMK9tKEVZPxud3RC	359
14599	2vbvmaC8ffLVp1XpUS3fLQcEEaM2HrQUcmfR7pYrccGGGcPgpt1E	359
14603	2vaVA798KXgvKpKL2jLq6Ws8hpYqnzro3bNK3cW6CgPW19PgtcEj	359
14608	2vbHgpHqcackjqdzYksT2W92RGsK5JdXX919xvNbqh4TmjBQghiE	359
14610	2vbCQtKm9STwgCawbJ4Xa6kzGfV4LfoMjjnU7cCztRQNesLv8nyx	359
14613	2vb46FPR5T8qnxXZW9PYSEatF6fgnroQPPftRtEGy77vGQW8PbTm	359
14615	2vbmadUJ9R5JsvUxqdyaxhjcytuuLX3VjSG8BfEUGH9ZomJHCtFh	359
14618	2vaxnZcjgCN9gcRKkvAp7YL2hoJidU2cie3gffmzcaoUGaT75sfd	359
14625	2vaLg4UGApiVdiPHjsUPcGnRcmnQy2qkju1o6Qrng5MtJhzJPuPA	359
14627	2vasHVzWJVhUYSDf6sb9HGWSHKrgyTes4iExExcb29X99pNboMxE	359
14628	2vc4vGQSkQpEJy634foWbGSq8Q4u1SpHFe3sJsx4pBBRt6UmPCrz	359
14638	2vbBt8cJwjcmqf4NjhaHUDq3S53QzD6SZwRASg47PXb5NVu1dG1F	359
14640	2vbzkehDAqJgi819c5mLHwm7ENkbkqfSUShji3mfyHuxsBpsDFae	359
14643	2vaeuyWeBfmCEgDKTMUjVEP7PbvqG76ygThKt2ExeeG8SaqmJFyb	359
14646	2vauushaMH54nhRC5pyvNokmAVBwZsbpH6cPFCqc818xdMTQMFMa	359
14655	2vaSHhik6zhUWmi9hGqgZdgKnEDPWP97LKXmnv8dhnkWa3xdXsKU	359
14659	2vc5j5ASEhu1bm8GyDYfn4c73W5sbHyFEdch3MQtfJrGXpbLiKUR	359
14662	2vaJ58QvcHNZnfSWPr95uXNXxX2wAwhHVLyEoMecfohy1HBm1swa	359
14664	2vacR9qYCLDqmcZkbLPR4tzABsMvGLKuFiPvQXsN9e6epbyW2H63	359
14671	2varVEjwC2i8mxFdct5UsinAvMkh8k74SkmE3r7zdVzZQGZgbqKj	359
14676	2vaQjeZUQQ3BmWVXxXPJ3UvThYYYYKiGHknfVr6Hqioa6MYRwLdc	359
14678	2vagPJwX5EkasLm9vNoP8Goftm1RaBPP88rKBj1xhYEhc4hP8yC7	359
14681	2vaAX7MGC8sLU1x7qkAxn2xEbwr8SDpEfpuiHmSSHNqZyTVspJhz	359
14690	2vaZxDXqCagLTU7UY3Lut9uZhHGTQzN4FixPfhSUTHJDDi8idHhd	359
14697	2vbxHzovg2KQKJVZxm73LeHqv6tQQkiUSA5wBB2xKnr8wVREzNiw	359
14701	2vboNhc4gLq95VNwZgeRe9YFLECwD32PqF4EPezNXBDVB6wpjCFJ	359
14706	2vb13r9u6fZrgKXtCA8CWkuDRwz5FPLHnbwro78b7W3ovwx2xxdR	359
14707	2vbkDQSd5CgmpBjhXdzRSKscyhTxzAB8LMSvsrnbR75DPXJGCnJP	359
14709	2vaH9bnHwygcYzcAX1kgewi569NxZxqTqiw67eKPTqj6YAXAqPyB	359
14712	2vbXbkFtqtvWyzwoes6FuXo5FYufCvKVKnHqWegE3F4SDG7Hvj1F	359
14718	2vbZVYAfLv2YFMRGy44G3nCnajZd97Fnqth4L5cTPwrtgRHVaLWD	359
14721	2vbMSdM3b7bKCLkAkNKqaMPurjANX5pRvQAGe55FL8P6F8ui7niV	359
14723	2vbMxDR5ypb3bJTxjfMykLAQ2nSrBNxNyakGYpvVk3bQWS5PhY98	359
14728	2vbHgTP48tLKV8AEQfMRb2yuRw7pDaKeduFKe2qZrZBCZU9GrXDt	359
14732	2vbnbrpqk1atjREazyfQXmhrRhxWC85DobF3VcRwNASqdzVoxaiv	359
14737	2vb6U8M2YcniWTHTMxGnqyUu5hF4wySnZYYVuonZrB5nU3qkbucg	359
14738	2vbE6oZKDguUqey2GLuzt177TQ6ofFyA6q4JBoRRMqb1Wgzi7vqL	359
14740	2vbQaYQ8JedNi12P7TEjjdxiCnA2sUxeNgzdYgD9Ko7H6r7kXRJ5	359
14743	2vbTcN5UDW4mxyourWETAeMYhSTLXz2A6yeMF7WtC35F8R2kYjGg	359
14747	2vc5NzRgr2GJrWFHGnPisUxxcy2aqRzrEitFUoADmNXxDpkuMuZ8	359
14749	2vaH5B1trxTSGKU7kyFMTgT4VrzP9j8Z2dArEip4vEQHM1duN1Qd	359
14752	2vb3mT8hrFj7RbGcSutBe8hto4RFyChetgE9aPNUnkr4mNL2fBD7	359
14754	2vaosAVKRPhS4zxBgfzSCpj8YX8wgqosPnrXjKsUzyJBRWygM1aY	359
14757	2vaP1NZE1qxANmpD2Uw6dzwTyaBTrxDqBzqXDtjN4geTS2ipH7Fc	359
14759	2vbapf4ta6fQebodpqcqBVn77MXrRpvwjFXidHThesHKVfZiDKTG	359
14772	2vbLpV548rvnuSkzMXFpbu5UNiCh3SGsnUz7aSNsGi5tvJCxjcZ9	359
14777	2vbTyu87eEHRNT6szpQGL63WM2hTYfidfcjzBWj2MTbFuYnMavKS	359
14780	2vaKjS3fAJRhvnnK8fb4WfKJ89bPSYijg9xshfHxhA2My4KNkaM8	359
14783	2vaPGYDDjgyVxw3hAzqwNtb8kFQsKqzd2QxnwqWLx8n7QU7vS16Z	359
14787	2vaXoBbLAcHw4FDuShk3cBivDQ6qEa7ofQB6R7SeKHK2nNPaqQue	359
14790	2varCm5mSMdTRdV2cjtm5Bh7udYLbEURLZHgb45M5WZD7PbL4WoA	359
14792	2vbSX8QvWFqbMoGkhia3WrTwsTBVpgprJXnhRW1sMTqnnLEHZ8DU	359
14795	2vb4ewt4ovSRxswvbE7mpRCn8qMZDSX1n6uut75t23wF7mzv68KV	359
14796	2vaRTZVGyYv7fAjGjS32hxQPrafduzWC4n9aTzckZKRnUXPSCWPw	359
14799	2vbCDTKhEUT4YsJx4wo5j4JaGsn3c6KRuVwVPXbrU2Ww57Mbp1Ly	359
14801	2vaWmw9aaHXYLz2n3BLE41v6hiKALQxFycchNimfJmUDS9zb4vqL	359
14803	2vaRJJeXoHs79b2Gz8SuwD7Lq476H2oMwyuykUnK1qWHMqKK86Bo	359
14808	2vbVRQXwQHos6KCFLysCwrBcL2po7Gga6GiYH6aW6ZzrZVZUfkQh	359
14811	2vabTuUpYNpTbfGwqWncY917pHa95dkEB1pjYPmFENGWzFxw3Wrg	359
14814	2vamMZENQVGJH9zw2qYHMBivnQTGP9VPNK3UL7UUp3r5AktXjaHj	359
14822	2vbfEVt1d6RE99xLm7EHa93YryFeNFKv92zxrL7inrGqk5S7HNTX	359
14827	2vbk1JvKZ5hwKjUg5nDrj8kaziEUBXRZzgqzacDzvnKTSB8PPU5j	359
14834	2vbDwKbaHySTmtus5Pao1JwfHmAQ1ruMTDwezTebJdRBc8u9FuMN	359
14837	2vbpCEtYR7E35YCp3Zzg3pqvouUaxvGj3C9wVfpofSDKXLi3NqkM	359
14839	2vbH9KrQpwsSoxzgn5U1z9iCQcUT2Z1xQ2z565u3WC1PoiWy4RUX	359
14860	2vavNuxurR1QvgaipA3nCA2tKWaM64nhpeU1hDJKPWvKqtsHKj4b	359
14869	2vb2UUbBdWg7qSHvufACyCnTzGeTrXby4bkh9aK7ETKNApn6SkGN	359
14875	2vb9Sixcrcd36bQZ5zJ8818RUkywq9sisDhUH8tHJQuBUKdE3b3a	359
14877	2vaZ7iMh2fnJy64mTwADEdmoRVYjWQLs11CMRpwaE3oX2ZKngpBS	359
14878	2vastoMySJCPhuyTKxsxDbsvugBUaCSLSmK82kqddmcNmF5aaw95	359
14881	2vaqVPyn4nT4ttAsZfjdxN7WDET4LXTDxeVvJHP7CkTjJQy3dZ5S	359
14886	2vadUCxrvnGTNjr6aAbPRMzkbykUaF3jqidBvBhGYC5F8dEkaUQr	359
14889	2vaE5gfqV6dxYeMRJ8LPT9BhSgCbakaBdHzWyS1LPXbSiJZ7tHaQ	359
14892	2vbgYRFRDq8hKYwNdHx89iaJ2NY93Hyq5UGGsDvCiPLj8NX9pRxn	359
14894	2vbn6QAJEveyKcdvwWHrCuFqtsibnJrvefzXw15YKrdLJDPymoCB	359
14896	2vaVErx7PNSzSMkbWEsZCe59222asxCLUGtzUCZhDBoPP3hLKJh5	359
14898	2vaFUwSHe5yQNh7MHWRBDXngzgNM5adecReALY4aGdhSEPATmbzp	359
14901	2vaBT3z23tgrvG4fiFTDJRiu16A43qgQM1CD2x4NBF55trVYxb7o	359
14903	2vbQmg8NEQh41nvsZBFMTQZYvCTDpNFoLxdiMwUSb4fBSAr1MhZp	359
14908	2vaYYZTq97uER1LaacWntkbqZUCkMiDBmu2gELDXtKeAcpcCrxLF	359
14914	2vbWSyxu8NBnq4TRdHpPshJC8rLBz7E1Zz9oVH4Mh3CLYYdifTBB	359
14916	2vauQEWEmFRCiJwV2N1uxHvxmyJWtCUwBank7zPbb6EFEohnPkQq	359
14614	2vaqjxEnJ57uzXBGV4auCeW6PFHFVCBZ1MTW4oFC7aLQXufCnG4R	359
14616	2vaXU6quSdt9JH5zLgNMBEXqkKE3Ntx8o3UH7VEUzEvyLZASJWvo	359
14623	2vbhRmWnUHjDgZzbgtZjFU1wDzAWPgVv9rmcDAg3aVwBg6gnVYQR	359
14629	2vamFUSkN4Mx6pSnGDCSJyscq5uzVbbHvUby14L1nBws8ppHANnK	359
14632	2vaiuD6vBtcCaDb8LTXQUDDdDAqGCckY3bJBBSo4CZxsiAL84aCM	359
14635	2vaAnHiS1bXCE9Juu5dKJjiXVY5DHGpZuUhtprHF8qLW52V4xE9h	359
14637	2vbsSZEATNGC8mjmLuMKBJA4q6CmVfKA68nLz6uhsExsn8xQ6r4D	359
14641	2vbfJ5GmnJXxmK6LqsZj7QbASy9M7ghZm1aTfCJayE2f1wTJSibD	359
14651	2vbmBzubKDm3t3SgqHGqHhedRY2YwrBZe9hCrhrbecYoUuEjREb7	359
14653	2vbq34iD7d5QUaV3FEvKzY6WUiQPStnapG3DedUUzzLPpxw7LY6R	359
14660	2vaxNdNiMisitiVSRkZK5LKqECQnVP3BnapsewFWyKFKHNxTRhwe	359
14669	2vaLsrbuf43ZQUdgd8ut9P2eqcckZzqZBvrg8kZe6CbPVEwtnR7W	359
14674	2vbfGcQf3GaTqH7e7xwcCpvDXJDWYXW4jHVkq8ESnGfnnv1WPBWo	359
14679	2vadErNisVpszMr1GAmNEv8eFdpqnRd4G2ac6UhdU9RpjPAH8ZwC	359
14684	2vaDxRCKKmLCGYQ7Hk3SP9Qsynbgw6bXCdVYr7cy5M5pekdRaGnS	359
14687	2vaES3zqkAJAgwfdj3W5ypdKEyeH3z7DEHcidFTcbefkobdAFqS4	359
14691	2vb6zm8DX28anZjnp4ybydWXNE9F45LfHsMb8smSux7mug2W6wG7	359
14695	2vbssiqwMRz6xsrJidEAgLZ9YSnthgL8KD3PqegWXZ5cgRmTfR1W	359
14698	2vaGW9QV5UqUpvYHWnRU5FE1Psf3T5Xv79d4XubGu9Fy8Hkui7LP	359
14726	2vbqkX4ZuNNw1VzpaCUHWjxShEkNyrSKTzZJKvn8rbG38eqYYRhK	359
14733	2vaqE2UY5hJiePmZTcuTJ9nZcQPHZ5ypg228d9QCYajFyXK47V3X	359
14735	2vacu2G4F6ewanh3KnBJ8ih9nFmUARUbG5BvTgTccGaVQSZL9xvd	359
14739	2vbLRCdmZ8xLr7NwPS2ZZueNATBcEdvh5WCfvps8hVJN5WKofXLD	359
14744	2vbdwBDzM44ffYjFupUfmJUSrHAoaY2mEBWWUuQ5twVfKfraWtg8	359
14745	2vawcW3zBr8aEnbW57Ube86hBrFtKEVT5KAJsPBmr6MaeSrkd4rY	359
14748	2vb33JbnWrJaDA8KpqkmwABZ4r22bU2cgcjboy22vZgoTUNDK5dr	359
14762	2vb2J6FeEQsFQ28x6VrpR2xgcaHW6HhNs8kYTf5xqZNaG7syozWz	359
14764	2vaAKAkqP6GWhgdXuqfspBN3wg8gdgekfSzU8QV1C8o4WaA3nUB7	359
14767	2vbJ9jUY5QEukdLtW2SijPsqxp8oghS72DGPo9LQXaFGYtHKGCXJ	359
14770	2vbzUoLsWfkPDsRddnKj8xzCp4YK3WRRivAi2YeEdKWvniCgyfw2	359
14773	2vbAnQAFwog2vQTtpUat2T2ezhahxS8cAJvBYXmvRt2mMSa8pyBR	359
14775	2vb35QcjAqvh17TnPUGLDmn4PYRFoF5fG48rChjonsezxb6YcZJa	359
14778	2vaBBtC3Z7VP2BjzN3SgESvJzSiz52zBSKi3NGcd5H9MYUuf7Xpt	359
14781	2vbYnWCqwXQSb5AVGh5SfK57k4FTAkiNxqZdRFezfgYkkRNwPk1h	359
14784	2vaYubNwMvzVzPzQZ39XLsYCLV4TPyAh79JJaZtnLYskxWTJuGV4	359
14785	2vag3itGW8suJsy5GkfXm3G8RiZAsg9E4mnYwvgCrkPYyoyqNCZS	359
14788	2vbq1cpDZ1F1NA3na57oMb7bh1JecC3nGZyDgBSCQHBrnu7e1moV	359
14797	2vanU9WXKmciyTUBXz1DRPmwo2do39ygU8tKEoXkJygmMFBb3uR9	359
14802	2vaVxveWw61i77KTf716W45kYwwj2f5ryz1XLYffu77AJKmaLVLa	359
14805	2vbezN1j6NNRbvMShN8ygKEhZ3BWMqEXTvpivNc8vfVYkhSvwtn5	359
14809	2vaEuQ7ZVNVZwgjXRCfWw7KXgqcg2Z6T8fVqkw6pbfuDr2StQzf5	359
14817	2vbhK2xneypfWb2iDPcPPiw57qTJbQA4n77p1qixYsK9Ae92vxX4	359
14823	2vbBxbX55LFPG9Ck938XehrLc4PdzyXnmfJqLjxmhTXqeLyPLZU8	359
14825	2vamNyd8eQVEnoxF4yyXaZtqKWCKvzKpSwCuLAHJasXj83Trsq6i	359
14828	2vbHYBSxgn29bhSvduJf94LPx9piFji2hhA2B4pNe4QpQHrNT9r5	359
14832	2vbjKo8U7Pf5Qx5VmgcnEXM97HqxpxsKPWpDVYY7pCXYje3bpQnE	359
14843	2vbiftxNDjJ6jUSexaHkTa9fVBnZUAVDGfmqXEpDvuXWA6Bk4UMW	359
14851	2vbckVGwaGGkX7HbFiwzstJEpiA1Tsvmvs2roi2unHdGd63spm1P	359
14854	2vbFXAbvEDg2N7x7pw2VyGu2cRTbAWrYijnjGFFt2ArtB21ytjwD	359
14857	2vaLMHMi8fsKKekfgi6f1k7fGfRJGJSmjAs2nRPLPhQ8jf9Ytfxb	359
14858	2vbbgFTya8iCcBzYGTKip5cWQKizFEDN4C8ZzUMa4TaGyMu6P1vE	359
14861	2vaknzhP52Pj6Fvh3M65u1oifvRVBC1ht3ypVJhFySrYRzt2aDGA	359
14862	2vaHpTjoNDgm7UHEHKZTdQKohcoM5XD8poBfUiTbuPfet6X85Dtx	359
14865	2vc1Y6TE1aJp5nFi4PaUAWCNfbTZbDXjM4GWT5aunjrHMMVN8jdz	359
14871	2vavw7fVvJhFDBcLtSHJg7C3YUJZSQHjhCGa5c79hqAHm4VkZcdW	359
14876	2vbyz5ekX3soY2P5wgDDtkA8v914rZZeJtEKudYzU7xUQQSMTKkN	359
14879	2vbdWSNvAFuAeUZkswu5gZ99GYKd7huetWWT6188h9zVJfgMqnZ5	359
14887	2vbsi8dUJ6rtbyyznRbhyWWMbHBw45mCQmVTHJhYWNtYMdGFT8zY	359
14890	2vc3Th34fRTnzSE4mQd356fNYzEbNpSUbj4KYAwR56WjiWczBRRC	359
14895	2vb2nrmguXr6xSw1j8BJrJ1TDfcLdqFX7UAy6fgDaKVmWk7q2Fyk	359
14899	2vb45898CVoWJHuYoZgXBtTuLMuVJx2SzcRt3Ckg7TEQc4AQoMRH	359
14906	2vbf5CNhwiyjDr3EWoKcNo5oZPPjn3G53m29AU6Cu3pe8hE3gNXw	359
14909	2vbYrP6CkNayQQHCepcVnrncjPgovkEy3jUgqMu8BgBU8yuym3Ej	359
14912	2vaAF4FCyecgxS3n88tqzBycytEgomBHTyQkjtWt6e6BdjHzFV7u	359
14917	2vb8NV5PRJTk7Xm3NyiFAodwNevhB9cYbrZptsu98rY4FMqWBKfp	359
14920	2vbbz9hjAT9qURT5Fxk9Bf2TDFy4BuaxgESFircw5aX9ufgdaFtW	359
14921	2vaid7P6piXZ9gVCRfs7yT1o4SWWTijaskDDfscnXwuKEk2uGYrL	359
14924	2vbPbe58je1geyF7vpg6DsMCLaqqQxLEJWYddLUadr7834AGJf2v	359
14930	2vatxDeNNrP2QKx4iWoWJUEawQJiXKCA7is9iFVS8svrDDLqcYdJ	359
14933	2vc16dZMCKeSK8doG6HHDtwn44qEdEMfrFsP3U4GThDPxYbYzAqu	359
14936	2vbR5vvEWn6Xn4XRnNenALFrG4bwmXbMS8Gzi8Muvo3KdnSyFdN9	359
14941	2vbwBcUzJiSXHUacrb7P2hqfQeGSZtMfFcwbnBdSWUb5URFL5Ksu	359
14943	2vadatb8uDzqxh7XXJmm2tAGgAp9b3PpgTFa6BbfDPoCtLiZwV8Y	359
14946	2vbZ1PcfiwFyMzxrxwtDJi22sWnBM8h8z8JExeyRmf5uvNPvmJ5B	359
14953	2vbnTW1NpzDJaZFr6Hrkju8hDAGsccK9E6GdaKwJKHcGyhuQvn9h	359
14957	2vaRp7pYAu7gB49oqZWo9bkUaD41CNMhKEUwUNJ36kzdhvRtNJwf	359
14959	2vbHpskv1f5rPG2MFcoYjxCez4FUwK3JLTiGAwcoU6PZGQTwtZYA	359
14964	2vboSfydmS2VKEgTxajCix7CXdnjBRGYm1yBYVuYyTeBEjvY3Mvu	359
14971	2vags1jaUjXvUS8gtuTZXAxqyp8VEGEvQBD68DXfbNxgj4ebyC1e	359
14975	2vb7av7EHkrfeJjMngzXHpZQCHu1ETpkSvSFW4WTDVdqLBzjBJkh	359
14977	2vamwPatihaQVLMxd8bTSSQ8x521HSV5rHMpQTeLAFLFX8tF8BtN	359
14979	2vbktJigMGRLApP3UU9FQiXZgtqPzusGWC8K9RpLwU6hr4wmJMP9	359
14981	2vb8JArJ5EjwBKQgNoVWwaX9iZa9JCi3e2dkV18eLs5N1DjCcsqz	359
14983	2vaWemhU8xgz6Dxcqhvs67uyVQEKus48LCa4fXXWSHb7dbvuhrLG	359
14986	2vbdZZoF3ESfRGE1Tb1gKwV4d2tbF7GMcx6Phrh58xMfQzdJrhhd	359
14990	2vbAyiQSrdwaRBKRnHhaMG2xcsiEJJ9eJP5suNgTaq1fDR1hFmSW	359
14993	2vahN23GSoFNqnr1v8cAkH7XqS5jPEvH2TdWfUbFSWjNXEs5TXH6	359
14996	2vaXn3BEqkpWDY7q2PC5uxtgQEwXCiJKcwTWUagQ6dfKs4aqQav1	359
14649	2vb8yohk6NTnQw4oHpX5WvtcPxb2NB5DgHwx7dYhRw7Xpxw4WXAY	359
14654	2vbxPaapiHFWUVEgJFk4389w8TQRXC3uRBMmBuK6FqkcVeiHYCyM	359
14656	2vaffdyuEYceLVg8TnaRfPUCq5j5Yq6Trx3zgu2dV7W4T212Ruqy	359
14665	2varJYbVaAYJeBZEaKnLbcCF5cKUC2Gdz8M5o57XmbwBFuDuSmpY	359
14667	2vakLY9f5AcyTVYu1G1NFcymqofgdzzWg7TF9qHhg1EnipeuEbZc	359
14670	2vanXeqimQLgaEPUAsNvzuFPfwvvW95RjW1fkMSeTT1hyU1HN48u	359
14672	2vas9hzbmeXdYwTjtfkcBeyjGnXdY4EYjfBs9WKBRmCMdnNmuTZh	359
14677	2vbyYQ1k8K2kxpXRNmkDvgrAa4YjrVZtpcRwCk66heF4qai6zHk2	359
14685	2vb4rn7XQaLwPvpGm77oKhxHqvfACB8rBXzZ8CNYxwkLGJhYgLub	359
14688	2vbT2AXn5vxV6zLNuv4qbXr7uMieNk5eUWt8f8pcmWW76WxQkoTg	359
14692	2vbMYwWiKB7F7KwAq1hiHUT5ky9cQT5zvJtVLdjGcfS58Ev5B721	359
14693	2vbvxW1dobaxsiwf9wxN7KiXKHP8rQ3LGZdURDaishKVosuKu3g3	359
14702	2vbHQkjv19npKLymUNcJ3K1aKuMaPhJQqrczgCgDztvK7bkZ8ivK	359
14703	2vc4uqPt6bJDwqqZHkSmrSFAyuDd1y2GwZFz4nm9GBc45ZzTMsU6	359
14705	2vbxKk9BbLcXgguoHncHYdoqobbQYR1VYUkTrrDPfKvsc8ZNW1aV	359
14708	2vb4ZbtiRb1f6cr52oRR7D6TvJqL3o6f9D6mtsBAsUy1vMJC9SHA	359
14710	2vaGeniGyraqvoysjVyrfbsNeJ9TT9xpjPiB9kk2bH3mB94xmuMg	359
14714	2vbyacFPWmZD1mATaV4vZnwHqLx7XrhqPXnARf5e3hPw1gzKkN2v	359
14716	2vagj8Eu9Y253ct3uJFc3nYysyavYtjMHeMf49sd4mDT8jrUvp6u	359
14719	2vb4VxK3RsJDmGwk2A6jzj1EYmjZUKmrmRGP8rTwDcUnT9m75DAQ	359
14720	2vaKxf9zJ12iQDE94R4ooPpsvkwMNCJ5UX3piqyig3ZiFHUo8kmM	359
14722	2vbbsTum8qpkeaAqhUhjWCETTLPh8BLA7RErvzp99YgWxqF7AGT9	359
14724	2vayep6xgmiJmouW3NhuhXP6sXY52k4STDbvQZQHBGe7axtugejk	359
14727	2vbh8TunWwEHbHz2wru9srFz9z3wEPZXispowFibrWs3T6nymY6w	359
14729	2vaitQybRm64Cm4D3qyzetnAKzEUThASkCfXqFrxFdkNHjVkL1Bw	359
14731	2vbdVwh5Q5WtHTmn7kgxDVHTh13MvJoYxLMmcAL6Mwsq1fF6mRhj	359
14741	2vatWr3ZVQTHMKefpbGa5EM4jB5qWZx3dkqcW9Y78MbYJiXAiAxU	359
14750	2vbKBZE362f8Q364n4wZ3oNPiZaxDfbBwUPjadEx8d5WD5DnrDXd	359
14755	2vb6xmo8nUJqMmidZFZW7oZEuRxjJbnhdQdAMciCVA8DjYWdSD7X	359
14760	2vaCVnCpYi8PTj3BqqRQYzhNcRFNh5PJKWerXjoXfAbiAcLtHKTf	359
14765	2vbFC25TPBt257kjoaUXJecQhuFy8xGQjoysemhwGc3XLc7cK2pp	359
14771	2vb7LarnXeqUFz3e9y1RQC4feBe6u1p7YGhCdwgCJCMmPaoAgdpH	359
14774	2vamobEM1WzZPCD7WstTPbBXACfc8yWtG8umLNib6jkh3BmJe3vm	359
14776	2vc4JU1XKbsrdstFDf2VtAjNfMe1TdXyLkZ8KFnEnJy42972ZYjn	359
14779	2vaskDJar1LXN9QQaETCkaBPoDqU7kgdnhENhwkFX1mnAtsznEBH	359
14782	2vamC14X2vgzS75N3m3eDvvXxh21BEqyMXXAcfQyU9eQHwfzQhes	359
14786	2vaLQXuTWgaC11X7Y712vW7UhvLrp9sNrZM7XiwudKCDEdtcUbaP	359
14793	2vbJaA3GVViZtjfGBHk95giPYQLYjzxTos33FJR2fM8B6wRDsH7E	359
14800	2vaY3cd52CLC2XyHpcwf3Wwd2V6G871eC9uiZ8jQMZGXLTDdmsUP	359
14806	2vadXdcNrDKyULJmEPYpjSaA8niRG985cuiHgYAQ3VqKxEmN2Ush	359
14807	2vasdkkTEiXa7w2ZRZDUwv8T3kmZo2FkcU6yz3KadnmAyUCQW7jS	359
14812	2vaXFd6ikwC5pWeBz7bEFLF54cSYzrBdfssnPafsoNEDsDr6YiPL	359
14813	2vaF1wRfQv3i68mfXTLXHzx1Ys86gZpeb8hwsVppxEiqfQQrPByD	359
14815	2vb3nLXf1LCkLfEqFb5KqBsx9TXmJfcoxV6Yp9nDtFixNoimsn2A	359
14818	2vbZis7j1uVDp1ZiyEmUnYuu7eEDrCnefiJuB8t1hGJrGmhwBEMh	359
14820	2vaxwCShpjuKAXoYd4kWyZHoB8AX7s4fmTRLU6yKsqasYcGpz97m	359
14826	2vbXWmgvwjSvFXyc7KD46AsqPrBnRWSsz5evS4smh88FxPRR8r1v	359
14829	2vbhyfvUnSmNwxuW99kBhV9J2s7yg888Z3dQV5nbqK5z6FsemGbr	359
14833	2vbTAckTkGy6179bW8JWJs2azHBvHygfJ3Vb7i49CwF36tQQE4XW	359
14835	2vaYvA1imuxXZMmf6x8kV2T3ZMhFuyi4tw1gRjFc5aXWUctQ2Qoc	359
14838	2vbrJC7PU2zz1qKDzc31SXfr3zp1LNhpGtqgc8TM9M6VU1yrhfXh	359
14840	2vaJHtenLQXfvHkNDsikFYUvC7zLZYCaBTu8Jbuy9ckLch1tE1ER	359
14844	2vb1Z4YYv1rQxH7mjQcJfj6hxF3RYAZ58KvrqoAgQoi5qNY7exDH	359
14845	2vb1HE2nbD2oscJS9aa5M5Cn59UriBp4SxCYiYSNdQBuc3EN3DsV	359
14847	2vadhrEpsxEyzJL6yDsUNqWmZBTGs9wS87ojASwASjwHbtiEAM5W	359
14849	2vbU9YMJwowxy9KPsECvZu7my7nhyBTPJ4TtGZbb32KmuRCPEFJJ	359
14852	2vaYyNRGLEVRbzcRvQ4WVDWpu8C2VPXpvHD4qFE18K7PHwvwZaVq	359
14855	2vbUd7o53d5XSPqeNMujt51X97uuJYR6qUK9r4GMoFC16q8U82eE	359
14863	2vbshczx3cohg75ctjN8ADa2tfcE48aKdqoKs3FkrYqDsPL38AvW	359
14866	2vaFjad1Q4Br5NiEEv8sw3Av2aop6R3Vf98eDxt9HCfLwcaS8U6r	359
14868	2vajeF8xicR9NYjU867qW8qYy6o1WsxMZNrbUQw8x7aBYYp6udkU	359
14872	2vasCnR8AqH31wde7n5TDYvJ8a4S1BUWLtTjSKKFedUFS5FCTqdY	359
14882	2vaNuhoh498DqayHgJSzA6JyYxHkCrsrSVxRNAiSTvWHTRfAkUY8	359
14884	2vbdjXzVgbeiYL6taN5rzsPAeobhAhBDbBRVYYUG3mkErYK21vH2	359
14888	2vaW94cNNjis5i29v1TX9rNeP2ngd54idf1H72YoYRFjDQiyTaoe	359
14893	2vbwysv9HQQPXWFxQ5oYERN5miSHGfTXwoJRk5cFPUuBDV3Up439	359
14897	2vbJyjsNY8jNdX2NNUhNj1fkzCAHbwAtbqhaSKv369pEQ4VBfTpx	359
14904	2vb48WFhSmMVxwt23UoUEeQntJjxXeZPxJJDgF4HeCjuXPff4cdQ	359
14907	2vbDS5z3DoQ7oykioLsR3vh5U4SLB3QFxQu87R8qYucW9KL8YvhY	359
14910	2vbfNtXfy91aYuf2rQnmtd3XAfzEZZmrn6X3H1Jvnxx6GeMMv8QU	359
14915	2vatEynNGYwsWcFzk31gXzu2bQsb2Z6HqnV1W5cgacmiTrJDb2PR	359
14918	2vaXju5sSYg58PEucgm69LPWqsAoqfbGYXKn8B6Sz2bBQy5WG5MF	359
14922	2vbVTxbT1Qub4SEYGiRatkYWEkMeP1rQD6ci5Js54XqV8xVkH2Mu	359
14925	2vbA46sKwnY9HgdUJob4UzJpk1a9B8ShJJQ7eUrmMVhEsMqnqD3M	359
14928	2vbcnut3YUt7QCovCCg96k4cffszvU9i71PZfqvDvRvz2xMc94wv	359
14934	2va9Tr7yqbicD91NutLDfQ7DPcRcJgUq5QZXDvQ8mHJTKz1f2niR	359
14937	2vabXk1oXF4rtTSg3J7fZEBkAc9yEFANtDfNzvwXMqmUHphZBZpK	359
14939	2vbTUhCt1xRg9LpWHqzhpVomVGQqEZz3t3WmDT9K6TGkfkv75G6r	359
14944	2vbjPffLqRxPKkH7g9aK4Pz6V7iJhRvQWDo5XACoap4UmwshWgCF	359
14947	2vbK6pkgLbzMKyWmLa7nxnksh8xakmBufjhBeDSqAbNEbcyQxKnM	359
14949	2vaXthfMgMbTD9rYpZNRzn8eryqYAXRkj2EeAo2wqjadQTj76UgX	359
14951	2vaTeP1RdA45xaVTB6sWeJsFxeVfnYT4949RkNjFafHbjJViN9Qf	359
14955	2vbekMKn7bT3JsHg9MH16Uwvh2fu4VoTC2UmMzNGHXt3x2UuDt9D	359
14962	2vc3rD7tTBamcvoZJ9HGFuRRXMf4V3BbcGcfCNnYVwP1e4ToNWSW	359
14965	2vbUNvr4E3ycErr5DnvZpmWUwuoFSR6SHM7qLcGzFfcyscDydtWr	359
14980	2vaA13feGFdoubgMeYEDwrvCHcbTZBRP6HzL83PLYUEYaTYbC91A	359
14982	2vazdQrThx2JcSss9HjAEZbkezyYKWrifh5XTjKQdeS3EbNYyy26	359
14984	2vaXRGqgomj4S1bWJBXYRTTBQWv5WbRY7CryMPt4CV61qQwHRsmQ	359
14880	2varRLjw8wP2f6RUdtG6syPaaTMTFjahkGmEt5qev2fiXr8Q6vtY	359
14883	2vbcHWjBMjT1XyycCsgvq2bZTPb7WvD619JSYg3jLg8KVs7G26EX	359
14885	2vaDSDTaRcPe1UyAER3zVLZpLmS5tKHtvck8EAWt8PRxjsRGdXTN	359
14891	2vbvUKZMLs49PiPrYNy2VT2QrazyGbiCs8Fwd2hsibh1QKTsfB3a	359
14900	2vbV2CxeeVHjPP4Yf48HhjZNftJHrDvyRGmoaQu783617y5t8RsZ	359
14902	2vbkqJq2qtSaiMrRY9JRr5c4NBtMqRSDsgt4D1pDRpzR1Th6e1uF	359
14905	2vat1scueM6U6JGDTQYb2zLnbQRro24zaqcUbTzjCg16HSmBQpCU	359
14911	2vay2RsL9u3TfcueMDFxJ586D6totZVZPHUPN4k2ZrJs2ayJSaN2	359
14913	2vb3fNXmn1MzfA5gqMWSiUbJnLPe97zUtwREBpUNy9tPkBZx7oMx	359
14923	2vb1KA2jdxjPPzks9WVgwGUb9a6etWkjuFXSqRSrFckBRx8WruSu	359
14929	2vbj4omVVZ8V2VHi5xau51kp11mtQBvMTxsDaKJpCWjpHxAiYg7m	359
14931	2vaUDN8qRZdDJNPxpRMV6asppVnZebiyvKSFMifSSorHbtsJckRF	359
14950	2vb2Lhb2oshrUrggxTJPVYkb6ptZ4oJzRoZFMyVzzkRo4yNtJuNJ	359
14952	2vajwzc3uZwP5y6BaScvX9x49o273NmvKdNgfzNS5xQeTq9zuXxQ	359
14954	2vbpi39EtbdZk89Tf8twQzJYJMCrHpJ4rFfPumG6gprQ4XntD3mb	359
14958	2vb1VLH4G5UZU3cPMEEZ5BqbT3aDYSq771QmDgGKZmzdYckJDG2r	359
14960	2vaNUpX91XGPeYqSAHUoXXARPdnB3GWohJva8breAE8dyiDSPQ7u	359
14967	2vaL6yWy7dhdeLh9r2dchVMaS65MMJ7bhcv7dTqzJWkLhbvWLBfw	359
14969	2vbrfCNoAPvZUF85STdLMtQqvACYsaNPopuP44U2J7dh7hZ56rQM	359
14972	2vbf85ee1gDeixdEGRn6fxtRL9WighQYENGTUBJuegHZ45BgGy56	359
14976	2vbzwcnofUy9kemkTi3FSzQXuERMLVtQFWKX92witDQ7fPSsGFDX	359
14978	2vbLr6v54XrqQr6QrYS2DicV2vUiEFSM7UtMZXmVPz9Dz5KKYr7H	359
14988	2vayZcLQdAkPzHEaVcg9BJNmJKe3nAjjN8QdKUVeW5PHULQdrPwa	359
14992	2vbU5i1XXLCJxMtoXWpXAmB6kbHDHG7G7srFNXSrX9qjCKJbMzRn	359
14995	2vb6MC6AVAEQt5TmCf2jTafmoJ5CZcWBqxHswqakhAS97JFJee8X	359
14999	2vbAAZp7o28jsE34cyZng1TwW9XeEiSRqX65FZKWTMVipHDHyntH	359
15002	2vbvhkvQkf9ZwbVh6u336XaQHSNeinE13vN3nBokpNezQRY3wFuu	359
15008	2vaVUhdobbyaX3m3ECaPWTHhNREuiRoanoqgTZpQyL5ndF2pyE3q	359
15012	2vaTDmn7F6rtVPzGH6ox9PU3BtFgRNQPyxrYm3tCg7vBmQG4ZtPx	359
15016	2vbxeA2H3uFvfjfv65Def3dbhJ3irpxp6NpjHztSobMgJZb1ruDt	359
15019	2vbnVppp154PwVNLnRHfPqTuDo3QC6Tb74VsnneHUBe8nuDXRpwM	359
15027	2vaLPJp2MtHwTnBvuFhbRFPxkYiMaFPrMzGkzEVpW7agAK4X3FiU	359
15030	2vbhypZKGcosufxKHdnBg2cm7uJy1xiiwyJmRAUEv357898M9EH9	359
15033	2vb6XVLfpQevquX5Ehf3hwnsXjD5MiwhTogb4pFRw4nmMyeCKok8	359
15034	2vaqW9VYHD5QNCVUASEoDEVkDgczXXS8X2yU8Pu8s3qQx9NXA55Y	359
15041	2vah3MSyiBu77vwPMjSY8cCGxt5Wm6GuXBRmiXhjrjS9Nhx55NFk	359
15042	2vaW7GZtTS2NsQwHFBBrdRJ63KL9iWXoWghKcJc5Gy1HYMCfKoCP	359
15044	2vbbzFh5bQD4cc4nkcUQw8NG1etsj6XcRKzeqq5qowK5UHCdqFWd	359
15048	2vbHEZwwH44HXCJbZia6tk3mQaS7VhzapfDAD8LutC2mwTAaWnUu	359
15051	2vc3JN2tG23Pv5BqBLD8ttzXzLhzK9VgZPMRbPtwp72iFaJev2C4	359
15052	2vbbmgeqqY1xKfyfcZev42B8pGPpkvD3qrDqo8JptyHizh1ZQieL	359
15055	2vbsfr2PsQYjYY4g4mpvqg1ZvKoWoMMoHWyKC9E7DwbpTZkDZVDL	359
15056	2vbWRJSSkeYoLRPqgYXpXwJFbSgAUdKcTauZBUYwtcNBTGN9xy4h	359
15062	2vaA4MHiqJMfnnPKvjLebia26x5Q3Cxi28KN8vwrMt6PmYCoqMYS	359
15065	2vaHKWpaSvXkFSQdcQ9H8XwS2QiFqNf5XehzhND2pksGJc9i149w	359
15070	2vam81d8XMuW8RDt8bEHRD7V2F17iDxTEVSbuoFKHgjsFQ4uEQuT	359
15075	2vbc9p28y874bbGon3fXjTCNvfJXXHfqKL1d4mfgLTwMcHLJgBen	359
15078	2vavKo2eRRS71UEDRUTyESygohVKtHPkut3ND8JtCXRQioSb4T1K	359
15084	2vawUP9e5ELSACUn7xEyFuvM3g5q86Kvge6CBDJD21HZAFqBBVnA	359
15087	2vbNYh3TJ3iA83eBB17jE7m94xAuFaN6Gpw7AoYrEGGhY6QBcfH4	359
15089	2vaegeooWzKgPK6oUpYKANYQes2EyP8Xd3kifo2aoQ8nXiHdLmXP	359
15092	2vbQbohqzo8DpUBvfiGVn8wEgoN6CPCyPALvWzxBNxMJCS8R8yVg	359
15094	2vaQ1hrruRTZTFQLe6hx7zNC7xfCbKRZVajTLcdnXaRh3D2dd1EG	359
15101	2varPCt3CFc4MUZ939dLFMFefwcozfEhjAKYPoT56om2W5NgN5ei	359
15104	2vbpcXmkSr7SmBMCnHcPmzyjLbZaZG1NfhJwVBP9Q5jC4BhhFTuA	359
15106	2vbjD5FhaHvZhSn4QJZ1ycg2VxAvswxc9qN872twj7Zv4axbdsqM	359
15108	2vbHmXWZdC43xGKPFtvkHiVz5aiMpk2KT86bPHnc9ARXt9Lf9m88	359
15115	2vaWSQMKeGWMcYxCABxYdV5BencLiNwqmrmydRZTaw99HDPhA5A8	359
15120	2vbbtKsf2ArosS39dnSE3Ro7Hgd49Dr4ERtFCuxH2BCPmigUKJeP	359
15121	2vaon4Aak6X51PAvttiS1d8EwLhFHG44BzyNYFNynEyMzsYkEN6d	359
15124	2vb6FJh1q1rZnTLcmz9xHocTRMaUgWyXn8Zha3EKJtcbfekQd5Tn	359
15127	2vaPd1ipr67zh2kr2HW3Ab4bNJp6dJ29xkhBTs4kxvPiox7ZyGRE	359
15130	2vbEjZ3K4kUZaQwsgXDZcA3yLUCEtBXc17jwrEzD8gCnTRJaH9Yo	359
15136	2vbq27CAS5xRhA6fZpCL6MYJPi3GzivQjHUBcuwX6zuDqboxh93q	359
15140	2vaHD7yi23qZBn6uigGGBcXMSkechahmSqdbZhj2Zbw92yFMiZqq	359
15144	2vapRFnt8Boj5mGTar4bfabAH1si5ryFjoVXL9g3ucSWhFpJgBeG	359
15147	2vb9ZtMCGX1ZNuGBRXxhG4ab1UJW3rAdTC5316qZmo4nuk8JRbMx	359
15150	2va9tCgkSPwupjuqhQ4rqVqYQuawAp1qQNzMZDW1xfmv5gCmocFG	359
15152	2vasvvtjPEW8Gtvmn43FFKysY9RNyKQcvMQvMWVZCa8zshFUtjLQ	359
15158	2vb6Mfnew1AzCTrGgNoau6pEXQz5X6dAZNwCaTDfCrEw7xABU4tQ	359
15159	2vaco7iqWBKFs7e8Gtcmr97rHyhg2fBN2jJhU3TrnvKZsnc4zgqT	359
15162	2vahybjvQ84FVNKgoZKtU72z5SyEcRiTxJUQSe3KRjzpjvgXMhFR	359
15165	2vad2eYxWJfHx5ovYmAU6YtDcW3dGmi4xneGjZPFZJjqn4hEtBxt	359
15171	2vafJgfV7hNotQaDnv7FwXqsvBuRSf2z1txJi3EChi4HaYoiyDTD	359
15178	2vc4EZqxQuyREAvRytS5iNAMouSuguMvDZ69PB341AzMdUEwtQHr	359
15183	2vahUdQH8FNAjukX6fMTEA9MpkJKz4wPAHxDpSoxHNoyrg4fNkbo	359
15187	2vauCsQwVpRm7KQccojp1MGS6Mjdv6CVuqq9Ka3FhjFyB7cnQT53	359
15188	2vaNXf8Mb2fYAJUQ7h6WPzRPrGMARH8sfiTkeAH6JgkAG3JZR5K1	359
15192	2vaNqFQJhf5cDWs5BsAkZpKbBhCrwfoUsta3doCiBnRXMzUS5ZXk	359
15197	2vaqqSNBh7xgeSRt9GQ9MHV7cvoVefGzNGhXCc24r8yAC9Czxuyc	359
15202	2vbRCc3cyjfL6hg6TohYc2Ha9cU7uSarwuR5S1GMVFgPjcg1XRuK	359
15205	2vb42VfnCe3xmf8Rtbt4FcYtHKe3URymkof4PVpFS41Vwhs1cFYL	359
15208	2vbFpkLwFPNTDLpE46rRecXUnAW9UzKsaDCTadXavmkxCzzCZ5xa	359
15212	2vbLmHEqzfrTZkUv7qQWNNDJKJdu7zi9F49Nw1taFw2ai6biqR5x	359
15217	2vaRpJ3AWbvBgjngJLtkvUEsJgpTx7wG7zbCZX1mSmPS6mH7JRuy	359
15226	2vbPR6Rrfni3tXqXHwxpsVWMCvSH65zT76muM5URQRFsnHMjenWf	359
15230	2vb8EwW7L3hXEqkDugvR57fLnjABQaWtZDNFQ4XzwdLASmFapp1L	359
15234	2vaMCLEgiF1d6d6edQUUBMvKTuxcCHpBihq9PVBNT2dtgWWYNnXe	359
14919	2vaeHzGWzVV1YceUvXrSXrAR2ofj3TMaua1m4P1XTAFREuWWD1Xb	359
14926	2vaGtwkNn1cbqtTCedNioJ2tvb3U9BeqcQGhm2p5N3frRocYH9Bw	359
14927	2vahq2KTcM4xqxgw53TEBb9x5CA23HXdRg7XGsHT43uLjS3FpreP	359
14932	2vbP7z6fAhqyufGu8vJtdfwfC8Pnp7yA15FhBp5nbcCHEFxg3NCW	359
14935	2vbLvoqik4pqAVnh57fVp14Ja2BwNCNf2J4mbiZgSaVhe4UmfKVi	359
14938	2vaucptkWgei1RHnmHvywm83ZRKQWegUp7sMF9xB4VeNZk81NZhU	359
14940	2vazB3AD8FmURQoikjyjYjexJwfV7gUTKTSunLdpBMTLLVDNfXYL	359
14942	2vbMb9rz3zMHQX7PPAkxPDX1cZdVo8phnwDg5f4jCZDQJKRygnBQ	359
14945	2vbasbcjxe4nh5wZWifroNCxSpGRUCycEQHx2eCR2jtpf92cJNha	359
14948	2vae9AZkzMT7YYjiP5QbVUNk2h7JqSNwQZZpjrw25jGsSkYAuVzF	359
14956	2vaDWMdXcufbk1kjXRCZPTbMWGWVanC8SfgrBx6ZUnoamWd2qKry	359
14961	2vacthwrA7Pjd28GnJSyKNKnLrvaJ5RGcRU93yuz89ZmD6cvaK61	359
14963	2vbQP763LULu92rv8RQL56G868AqnPj8jVZUPrt1W5YBTymFzyPf	359
14966	2vayLEw3sAm7FXQSExuwHjuDNeVcu4RQsGfUNBEau65tvj76jaJp	359
14968	2vb15LmDd8Z2d9ULKmT62MMUc7tvBsnmSGo45vVJx6iqhTNxjiNz	359
14970	2vaMALda8g66rqX9MCnZYUX8vT2LRUueAZkWximWYCB6DDn8ptW9	359
14973	2vbAEwbc9wwXBjXk7aqUGmWAXYyb3YSAJL9TAMdnaSUVMTBRAa52	359
14974	2vaGo55s9ZWAeft21S7aVMaePznDPYcQZSxz2uMxWGnhhtWvJYwD	359
14985	2vbvWfw9odx2zUijULJ4Dy33Wj3RgvomyugYBGT3n2Zobdwwo773	359
14989	2vb824sZBMbrqN1YSj4AV1J6NS14qegXcz3gpkwFJ45EufweVg6F	359
14997	2vbT4iYgWd2sP7xe7kghZN9o45NkVKgmpHiYGuCy8yMH4M1oAsL4	359
15000	2vaTSGVDDSvUt9QuzC23BeaPsU3bMPp7o3t6jx5uRVqf3mKW8JSv	359
15003	2vaXdHSRDy8ZQ38o7YedE1WchsZXPtznR5AKq9hdrSMrPyaHnm2M	359
15004	2vaJDaBLGksvEDU8nwZKYBTRbokhxWm97Yd8GC5AAadGDfQgnuso	359
15006	2vaAV8Bt23Ndzt5rB2FQg6DDtx4LpTJUoYA6sETvGjMnKmMjbE6b	359
15009	2vbQ4MDEmrjwebeUrebB7V37UCEqgfDdqFUPrfbMTknV5ctSm9E2	359
15014	2vb6ZCvz4mysjDHAtXXqnqty3fHZpq31ZSiEq1sVGpddK8oGA4im	359
15021	2vbLQca8ahKHnCGXL8q86VyuVqcVoBSrMkNFZnMjMJcoXcKoLgyW	359
15025	2vbETWuYuHQKcypfp4UWaohZAuHUBkUbJEDYa8rjSQishVTJbU4d	359
15028	2vaTwHrvFAoBofooRCJnA1q76SbxgvJUzzpq767pNBoet4HpgfGg	359
15031	2vao7KqhzBPDpYU55mTeZ7BbwjkeHdqqj3XgpawnwfHo7oQzFSC9	359
15036	2vbE5JVnvmahphLyVP72zNqLmxcvJFeuhPfEahnbo1THZeFkvVnC	359
15045	2vb68dyh3xXXmT4p1eBzK5tFpgJhWNn79CbKNsBEFZNmMkjCvMv4	359
15049	2vaebwkBQsLhpFQU49hmNynoe9tiD37FiyaP6PRNk2Asc8D7ejFx	359
15057	2vaJ3CwZfGJbyU2WfRncztm8aUPJkXm41rbcVn1uBXqUHtfRoQAK	359
15060	2vbSLCLQd81CwXHh9DvYrZ5Z1sccd77Xco4UYkAX4oxCZCsmUvEJ	359
15071	2vbo1KBvT919VdUTncRzVtmzWTtyUd3QQ99oxddJ82M3NcWXvgnj	359
15072	2vb5LZtaE4KYahbNXHd7526w5XvYwCJiTg8NB5SxeXuthWnb54qn	359
15080	2vbf3bYEULfqXAdjjzScGCz7GyJ1std9MLnAqhZxMEJERHi3tHj3	359
15085	2vaSYytYqLGF7NFfF8rvSaF7RLKd3gYLst2BJfmYSncdcdy6N1de	359
15093	2vaYRC3DhHnxPrFCnMfaAuYf5Ts3BapxtNwogy9ARajLgEVuVUc8	359
15095	2vanzT7aoJa7Mj19wdnoABMsgD3Nv3not4RYpZACvnWX4dt2GypK	359
15097	2vajHEAp4WTY4n5NnRDHbHNVhmJhNG49fV5sMm9ZgToUEX5xPuYs	359
15102	2vbDEmooYHGAz2c9TFLKFocVPFzUakeEqnqJ8fgEZoFNdnEXe9pe	359
15105	2vanwBY1qCeirNX8ksJ2W5TsKK7xnMErjgukX28uY2mdoK7kdKj3	359
15111	2vbXu6tyPduDovEFbiMBsRuoFM9KX52f93uDKaH8Vom5iTWQbLNu	359
15113	2vb6Me22p2ZmBFGvzAkfEgpqAWBjEUB4w9wK9g4NUvqBjXXavyKZ	359
15118	2vbJ53CvdYEaGwBTzXRShiwqrs3wGCFVoaXqMcsXWQYrcABMbr3U	359
15125	2vagXLTkN2sixW2H6tQ6y6ZSTgZNZ1nCjXCERrFYdfq1BKPqBePo	359
15128	2vbsTWCFPPUuhWsZcPGqUz5pEPCHEBewbiAEeL8oBXDV2oyZqA4z	359
15134	2vaweKp9M2VXFQyqoyQe3Kv61hNkwWLm1pVwxGFwvZvjqewFDArX	359
15145	2vc3LcYXA83ae9ofUyXK6JnWqHeNBe8dhaiD9phcfi2iMDH8xfo3	359
15148	2vbTwQZT7tpnS7DYbJ2spnRpchQTVkq4yfwX94NPcegGcbReKqLc	359
15155	2vbo2obzMe4pmucoZCsdJryrqtocvzz7AESK16tMVQwqHiSJ3gCG	359
15160	2vb31C8k2UffTR3ChKks1eVWjGRtqryem4XTwkfbQJUs4XcJ9rpz	359
15163	2vaa6VZzjbFrFN7aHK6xP3NFDCySVbg9GLsdjaWxHyhiLxhqZ9sG	359
15164	2vafc5GHCWsWWLqFNG6buDSNVP9Sa76WrNNGUSMjV31r8zJSd9Pf	359
15166	2vajmaiUFc7Lee44z54CYFKFFbsSCdBCKEsyjTGRtpFaNPjiEfbi	359
15167	2vaPpx7eHrfiTq53yKaAEJCdH679A8AxGD1Lz6y9qvvw3ncSzQnS	359
15172	2vb7pn8aWCKSzcPSexTQRUHBhBKfgygQDznW6VSZ2moYTjx9C8U7	359
15179	2vbVfaNe29cpo3h28P9oGTmXLJRyQRRD4HJfytKzWZ1y8Tfef7oX	359
15184	2vaR5WxmnexNYMq6QYkPifwKeTfCHF25mZi8tqZ7vaa9nFmWpw63	359
15189	2vbVn2LYeVm3yYas53gAfbsLPa7Qe5vzyQTmUWSaeRT7T6Ap2XzH	359
15193	2varNNFCudkzVTaRXFChDSLLr6UneziEn3b2qKiQX9tiaCmqt5zM	359
15198	2vc5kRysYGgocvvjyNysYkwP73mVzX82HNtNqSFFQzr96e1erkfH	359
15203	2vaQmPdux7pCTHBb7w1iRTrneK17SciozxT9bcjgd5zY6tnzBRMg	359
15204	2vaA3dLzsCfSJeMgEGJwTRwn31xrqHCNHGJmMbWPDSbwBG9aryG6	359
15209	2vapG7QP6egDS2QSgEcNi7UTxzbCCdhPiJJajb7bsBTdA7vtxMsa	359
15210	2vaMU77cmYQvG5HX8kxwTnZ8FqmrhESV2JS9yN1495wkKs4cPMSQ	359
15211	2vbAaywrR9urseGchJzqg4Rd535A2GJcZPBUEPo5SLy5NmcspY8W	359
15215	2vaeeSNGS7vSBUDfenEs3bjkGuTduMJ6Yv8XNdPhV5C4FSPQsNCv	359
15216	2vbybtnK1TyQbB3xxpCscWL8xV3CE1DuCmmtKgW925AcbBe1DNmY	359
15219	2vbtXWqRHDh49GgqHU4nevLzKAbtT6t7T4Ys6qTva7eM2tyZQxck	359
15225	2vbKR7Ntpu2pJzm352f5kDrnNs2jyXYX4yX5V9ZWKHZVizb1cWMa	359
15229	2vav6EW8tEUY4pDUGi9JPivYzx1LboUGiTGSrH4Zz65X92htR2N6	359
15233	2vbgj1hR3ASUKjjiBRtSgVmQLK75spMd95ZKn6auVRRkPoaixnT2	359
15237	2vbXa3fsdkr8VKY36ZDqrtnJbo3YZeiwK1t1gDHfxv6niSjC9pyj	359
15238	2vaNkCY4At2hi2iUJ7q4H4LS6ct3J8Xtf9dshwp4mWDbNSBWff8W	359
15243	2vaAPuixLjgGPXLirfUDGfysTjTucWNr5xUN8UwMNL8WpuRgxrht	359
15248	2vc2s2SMCF4GDPUB6PztpaoMcDqmoqkSjmj27p4wn1dN88PfPBEQ	359
15252	2vaZ6q8nqUJcz8SXRDQe4HRLV7xgPp6Aw5W7tKZvZqV1ciLZY2Cj	359
15253	2vaZMzBRVkMJFZv8CzVhZrhMsMex23ggrGnFxrLoCDyKpajecXsp	359
15258	2vajNzJ6uvJSt7LBQqE3hCBKgLBFDoXDNFr9by4XoYxcHrPUQfNC	359
15262	2vbK7YLvuZhQBCBst6yLd8hhKvYPn8FUbTLid7UmqhbjkNzj7gM9	359
15263	2vbjMVeXgb7LJCbzhLBVPMktUbGsdbwv1MftSAGMB7AiD3MxCsLW	359
14987	2vbmxrDWQ1RmtNtS7fWKV22X9P8jKBYTjKjaNKhFkX5CB9keWMci	359
14991	2vb86HpMrBMojT3UDXpwvhLmzYDeScFbiNh6qD5Tsi2s99eku7vt	359
14994	2vaYqtvGzYdTyp6hgiy8fwzaTx7k38jcA9Vpy2WQQDtRXy95ui3B	359
14998	2vaHKHnJgyTcybwr2MEUkgswfMX5jTkr15xhyxefpxnDya1Rg2GL	359
15001	2vbhdxqhuz9C8obWamx4AdkwCKaHQzN1mYVTY5HK4Vj5ipshrsCJ	359
15007	2vafvKAr1dHXKooCqbB9kqAAd8dJWy9S6d4fVgji7NJNVKhJAoou	359
15011	2vacn2eFQqEijo7zhVfxYPbYkVWniEqwG59rZEuFaSrGqPYKFmmu	359
15013	2vbTMUSUoKFZ7RwEtw533SrmkDLcHDy2QZFPMsVMrrt9PGPanqFy	359
15015	2vbuTvjC9Z3BbWpqQfbrNQvUuvYWuscd77XwFe1CwRtytovjHDgd	359
15017	2vb4fdy27GgHfd1WXGFcYbDXvjDvKtG2dho8Zc4nwHmMoNWWdAm8	359
15020	2vbY3U7rQgA1qgywSt54RhysavS9sWw4udDNoatwcciEqcFTsAwM	359
15022	2vbP8GfLY2bNPE2Vud7eDUToXnjLeTHbGVWwu3BZfqeaq28QY5BN	359
15026	2vbHhtK7dciasrXqeuwSSiraAFreHDjaa3JsFU9Rdp272UErURCw	359
15029	2vafwf6ksLpN2SYB5ZVk51hmwQfGeJhLVXyb2fSib2qnZbPr7CD7	359
15032	2vab3To6uJJsmUvL1W96hEGp3KQbhns3DHMprASfVcijAeY45Vhd	359
15035	2vai56XRu4rWtLqfhTDdZCVnQa9ZoY9dJJuhzYfdoLB9jWBizc3r	359
15038	2vbRKe2hMVRAQJ4WzJNMhUoo5Ke88pzg5PiEKtrkrDwebkyWqZfM	359
15040	2vbSWCfhziSjBbZG17d7ztq2payZNN2bPgUJ1EDLeAbuzzzGFEBn	359
15047	2vaCzjGRhEaoyhFRfrW9QaSaP1EVhNBUrgkNKf2pcjLLGx1owust	359
15054	2vbkD1vF9VaabchYADfMes4iGQH5mQZjZKnX8J27fJvMiCS6ABYy	359
15059	2vauPwSSUzA1ZRYEieZnMkV89Nqp8uXsVwDMCds8m1NRSPHCYKzf	359
15061	2vatmf5ZPPE2uFPd3yq68wDoLHEtxDTaXGnuZEMHDohDCjAC4dxX	359
15064	2vc2TaJuaddQQykRxc1RW3TnbfYqjArmtEZniPMN2u71rYNRrjHu	359
15067	2vbFJhXfJmmPd3zZMemfeAU78LnsbedLigSTQVGp2D18oi9FSnHP	359
15069	2vaMmn8dMKtXfg5tt9NdniJ2kXW8sfp8unp6ana5bjpweDV1cBqM	359
15074	2vaiPm6AfQ73CRpVdLCe8xxzQEhNhA3gGcMfWkWTWEBqDsicpgm1	359
15077	2vatRUykZHV7P6W2cD1zbdY9Uw31xiVwhyZ6aFKFLheqiJnZ2Qza	359
15079	2vaQ1sbZxTCnpiKUJkpvw6JbJTSNkdgtncVHpwL4quqBymZ6VFtt	359
15082	2vaj9FZdnXrmwfHprtMPMoNxGSuMNjX4fGJA4cazwqT9tN4MnffT	359
15091	2vbmHAjXCtRdfbG5YagNA3AwiY39htePrRaEEGRC3agijsbCHCVu	359
15096	2vbGyEvxgJ9v1xYoakmiWMjxKnhnMsHUvu2E3dwFWwvHhaBBWUoG	359
15099	2vaGGiorgrL1CtLMnF5RHUPAbk95nmDvgmnr8tZWBZyeAd1DRG3w	359
15103	2vbwAC5Qcb2k2beVRS21mHaSJmEx8XZntHxQz7DqmQEuucvLk9cj	359
15110	2vbn8BN4iCjAQoZKRGAc3kVv7KdMe3r9JY4qjZgkXipu8vF8R2bX	359
15114	2vayaciKsjrwsZXJdmfFtPZcQ27f6MEPuzhYrSGhagxd4ME4rm8Q	359
15117	2vc1gQ8XvMtWrr4kHJerwCSVCXWgNvsKti6xg13amBdrXXBDRFoR	359
15126	2vbrPBx91PnDeii198Gbx8QwGFGzeWM3PyJkyBtwQsVQQxPmXoJY	359
15129	2vanDb3Qj8zsJqNy9KVKr3ZzxTimLr6eFKDx6WeE2fHNvx8ghX8v	359
15131	2vbtoHCj52WXMomCx5nHaJV1CgZcqXv6M6HinZYBwvTKva5ZjvWC	359
15133	2vbMb2dgwikpGaxmyU2wntmTqQADCbFuykB8o8RPuvetbx3YjQ33	359
15135	2vbr2nXsFB31cvUk9kJQ469FXwVoqjbZSJazTssNpooMdcS5CAFv	359
15138	2vaBbZqmbUeVRYHZRo6neNi5DY2pa7PevJEdWHLkMLxUDJDh9P2Z	359
15139	2vapmpQzBaGyFd3WCuzn65Y5ERGNQKk3vRhhVB3aXocMX16MkjGN	359
15142	2vbKSznmsDLGwDSAacBwzkqpkqTfEHLLJoTmsW7x35AVKo4s4YNA	359
15146	2vbc2iGWffFn6tbDar9rD1JA52CYnJN9Qo3puNsBhzoCz3o5Jewq	359
15149	2vbcBT4KFEkimKY43DhFZh5QYDNMsQAdLqz15Ci8QskM52jBoewu	359
15154	2vbmqL7raJvzNaxEgzsQYwFGwjSiYrf8MRzS346dPrdjuaERrFTZ	359
15157	2vbzh6sF5zmZqAArnBeQNoy5heYYu2xzNHpCYD97wdtca1jFBeV1	359
15170	2vbWw1eCjEpJhzu7Lar1msuue9S7eumSWjnmhFQddXRxozomUPY8	359
15175	2vb7br4CgJndtMSRRPtJ7VdmSHoAxcP1Q5gQR6LYAss7HV4jCHSR	359
15177	2vb9eH4gKdPbHhHvbx5aFEVxU7ptyJwVW4Mws5o3QKLD5gu9V5zj	359
15182	2vaGfuMRtwkxG2JpHgCTUWUGLEp3Nj3mAPkLpm5e9J75hBVz9f8N	359
15186	2vbRJybJ2WZS7aafqCFJb8gVzaE1LbXwerZdxWzuBcmc2Tw2h3QA	359
15196	2vbe7j4wJKbjmLP6Ludtifv7hA5R7k8YHXJ9iBKtR8Wqzc4538DH	359
15200	2vahkfRdzXeJ6ZvHzkgrX5h2Dnbc8iuqygfiijXoXGpRW9753pxU	359
15201	2vc4BJvV9daqKp1JeCnkJsV8Zwg9ksK92M5JTMfGycBY9UPPdzoJ	359
15207	2vbHqiaDUGZzNcTheb9vUwJyeU29di2sQHfq8kuH2knAmB13obD5	359
15213	2vb6jEJzE8mxBqZsdMo13aaVWj1Q3vxqM4tJHvYFWwy45yKcZAMM	359
15218	2vc3E8KMGQzPLutQxGJKYY813sCArxiRBTLJUAoADAuHjRuhLx7f	359
15220	2vbQ8FCCR7mRxtADPvhLH93fzHV7ZEAovP7dFh1xCCFgjsuadkCf	359
15221	2vb37LAxvBC95gSn1o5G54j84zn6kfmGe4GXVzaen1mND8vUU7kH	359
15227	2vbxgsp51UTAs7RJdZUwa2UMGNLj6ZCDhzq2MGie8RwSV4XrQ97q	359
15231	2vc1V2k2UUNrEVFHHT3WKE419maibYqn8KbsNQYN6tYRfUfhoqY5	359
15235	2vaPLc4F58XcHVroHSMVPBMv48uFMZaqemYEW3bujNFT3Pt6uAQK	359
15240	2vb2UxishAGtwfbvAhn4G5ZZbhtr98AxG72qBD9WMD2vgqnEU4f7	359
15246	2vbLyQrBMCfy48g3N7f1Uu6fbGaBAWL8qotWTkVu4QGvWS4a6uSB	359
15250	2vbVWUmZxvdH6aonc9i3283ASSSVBbdJVh6wcBNTFoddY9PrvcB8	359
15255	2vaQ9p8FFDDzCXNHaeFeQdLtcYDRJvgR7CuBz2SvGdbaSYJi7drV	359
15256	2vb7oT77LJmruD29BovuhXdjp1zzYg7s78SuJUY2YrQBpVPqPNcC	359
15005	2vbzv6BcCpiZx7cCH2ijMaA9FpckRdMwnnw5Rtd8hKKcyd5RMuNB	359
15010	2vc4fM4f3VFUMzJWkReeNAVkkpdjwhgr3DLxRkw4NjNguL1XGwdn	359
15018	2vacHJMuzMuednibQoq1LUMbZ4gN2yacjrpmsRFHBXxkDLzsLXBA	359
15023	2vaZbaqWeB1wBAiDmgMLpTPCzai9Ye541k2duwJKn4bqngPEcoPW	359
15024	2vbEZnjJCPxtSvSVrKckwy2hgU3i4SRAwrfj9uvEdxSywcLMMDTG	359
15037	2vbdhcixxvmjaU3WUjEGuvQKHGEAxVdEAoyuaT2SZzB1AC2qmKFq	359
15039	2vagHLGYcaKPLDzfkzKtpRMbsq5mHQhdoHNNF2pk8sEQmhJ6qpWr	359
15043	2vc3VuzJjkc7iB6F7TGu6rsgEqkHnozyDxy6Gzs4fcdGoxfCHHo7	359
15046	2vbMuUfQatVf64g7586ZuU6oC25WDxuXNnXr2FChzLACg2wZ5cN9	359
15050	2vaty7xhohPsuyydbuegzLnfcArc6XNgDzyg4BPsKs4VDEkBCt7x	359
15053	2vaR49CHFgy9JZsoB5CNe86NHVyAWEFbQGZMwnTjzicA63mAEMDW	359
15058	2vbUBT1cwctFAae7KgjCTLwBcMp4Cf4PFSgt8J6cp9w9msmEUi1P	359
15063	2vaBkPjP6UaJfjbqFWL3fmwrCVVzza15kiD4tGUyTmnVufo3ANmc	359
15066	2vbVg3KDrn746vrXGgcSCLDbbezGFXd35r3xfxcZhT6z7VmcxtUK	359
15068	2vayx9SNjDF4FhQ8csagB5PXLtp48xqa7J2RTg9VVP4PwdrKH8Up	359
15073	2vbqckFstXZoFrpUX9aBv579o2D4q9hXPWgth6ZkLzYkGu5MFVwf	359
15076	2vaNVjJUt9QAchmS5K2W7oRTeV6gNgeqpCkbFW9FvuEK33ujuLtP	359
15081	2vbzdwY1sY8tTDG9CoFW8Y7PPUTb8poWv5ppK7CmLGeyVQjRFEta	359
15083	2vazdBjodemCEDCc7LFjboXCE6DUaaD9kYyNPtCqHBKW9PRvdWQr	359
15086	2vb3hDMjT1XSR1S753w42MS3YJ8hFmQsy6P89trCVhNgw9TyAMoR	359
15088	2vaQ8Wcq8Y5xGmAssu1qsAjTB2GQxGtcgt4eihWiUFEUgykwTYKo	359
15090	2vbGUA4cGrQdfZCdkzBtj9m2m9ggBqU12Ngep7zjfBeUcRsvvAaT	359
15098	2vbcXqCFDtRF4ADogo2euWV6DEfMEF9seNhiKV9kFGp4FNb1Qgp9	359
15100	2vax84kAouhGUQF2MKaor7Hg1ykDGQpQfqpETDvnCWAtpGXsAmpM	359
15107	2vb2X58MMCTWYRcuUq8PLEhTNw5AyYrnWA5eVU1KWjMmGdmcNUeu	359
15109	2vbupKFjcoP8Bsmr9qupjxb3TqKh5s9sE7nqmLRNaYCztBdgERQU	359
15112	2vawQGpERso3aAAT6aAaEwptNwuiHRFTHKDeKDmL76JR9fW64gAx	359
15116	2vbBFc66WA6AKMckByqjtz7QrrieWuzhDJPMtfZvThGk9BN3dAFg	359
15119	2vbgeyZ7Sar8MSaPuMwmZ1AkXT5VDS2vzcvL26xqZ3QKdc7tHqGr	359
15122	2va9UVdCz8BxQJkRnFBiVzGofdg4pfEopRHdZbJrfcWnQX2FhbhL	359
15123	2vb936TMVTcRnDqf2skVMdTCfo5qAetwMKA88WdH62fU4VS6oamJ	359
15132	2vbHDKzC1j5qyGHrG9ZvBaP76z3v5LwwCq7npAVBN4eCcA1Lgmme	359
15137	2vbEm322XtkwiT4h7i713jmuxYQhe4rD6dGzbi1uacPRLycq4rBp	359
15141	2vbnQn6KNE4RscMG1yxj664dtchBccoVopUTeJDZwF1C8rPW2usf	359
15143	2vbBxKZncuKsdB5SVMdQPArsQFHprHbwhTwMHnGt6UfzcxW24pXB	359
15151	2vbuWwuJwMkWBNv2ZufP7YBDgvWE4QPXjpE1mKTW7utmuFurDrxX	359
15153	2vbogbwCnQzGEBvnrFBbuUAbhDRHXXKHBeQ299iCd9zzoF2evQqT	359
15156	2vaBYmWkuu8PJjxYsMkyJJk6KHW6Pk7C4cdUioxsZDGGB7DiJPk8	359
15161	2vbTzX41CB2GZJnRnf6gBip5Yb4mA2jzQT8A2aBkieTyzCy4xZXR	359
15168	2vbcoi2j9oWn6iD7J3JcRcvu1MAXxfaub1ZWLW6GxcBGwhh1BxxP	359
15169	2vawW8mKPHjyLeZF5BpsbysD8gftQ2AePggb8VXcy5KiTNLHRaxH	359
15173	2vay1MQgL6Cga67ZiRdAkL7ckD9CsmXP4DNRvB1HHB39HWMdQ4cS	359
15174	2vajv8wiKHBPHnwzLEbuq4ayWgK5sBXPoo3HWXKbszgriU835Ujo	359
15176	2vbYNVs1ey5UL51trBzrrwf181K7G1wJ2utCESyHPr9iQn17pCNm	359
15180	2vbaVPg36Ltc86uHy3uhP2UireNRZb9JqG6s3ApVGKi4aVLpkwF7	359
15181	2vbH1TRhmY3xPM42aEggaG9Yca9qSDdcRLYiXsNcdehBXgV8QQip	359
15185	2vbXGwtMTipSDT4GexLmx8H91NLzF2afajz6D18yzPfAasMQwb4X	359
15190	2vb5R5qMdQRE88NKLR5jtArNZuccWLj45d5gCuxCS1nEQ63wBheN	359
15191	2vbX3csXfMM1r5Qd2D55EuKhb6gZ2WseDZzjFwE8csuhQBKfqbbk	359
15194	2vaLNEYCBkKR6zmDg3WELZGjcv7N1x9e9B4FZHgjTbYebhSYq3NH	359
15195	2vaxvdUuEXdnizi5jZncjcj57Lm1iTJ41meTMAscpqjRPLceBXrn	359
15199	2vbAVFQFs3GzMAB6zypiSZ3FhnNsHHbbPiuXCQ8mjDfKZj8xmVJK	359
15206	2vbpaU8YBaoJYZD8tUtff2keQY1hsVLv5kSMfa3Ktp6DYGcA46Rp	359
15214	2vbSsH65pQSTJP9xD9ubcXbW28irG7LGcQwsHm7GAzXstkuPH1Jg	359
15222	2vc24RfzVWEK5RRc6Z1FLZa1hw7UVxTkkTzHRgzEgeH1wdsNGjHQ	359
15223	2vbFBws3iyG5kQMR5hWf5hiacPnNaCVXytpdsvav5FJvFTW6Esze	359
15224	2vaosQSoCbsPF1E9wQEvhKR2u2PrruDwDMxLSf3i1g6Njf1LrV5v	359
15228	2vbvrrkS3DcJjTY6UBNJHhv88LnEZRFaNYtJ8ZPnSEy1d6zGV7Bf	359
15232	2vaE9o5BP5GCNvZdDhMcKAvT59C2U7xjyXUW6iRkSB1c191URX7D	359
15236	2vb64nhyYTqkW1NHo69BBF7pPLn7CPMJ8LDDmLHuUwAeEajJXKwo	359
15241	2vbbnZetUwDGLDqojEXVomd9SHwPNQVGKRbtj1znk22bXpQMnj7x	359
15242	2vb5CR2v3g7XsjbUZXvHxARq2UNm4b8rr3ZMBZ4CXk462RV5HDqq	359
15247	2vbdG76CTvDGGvMfEgxyiYCZMxYWRatEGxzhV145QS8aHkHUNzFa	359
15251	2vbNamnMBT61L1nbhR1YbGnv8JPi9qLdeGiUXEEh8YEWi43cftfs	359
15257	2vapLgJueZKGKgHEeZ3tVkDGRzVDjgsq7abxVuQ9NSfrNKEZB6DP	359
15261	2vaHHWBnVLkK6Z5GGRPbwLGnLxM66xNLe7KP4d6aKbZqbDfooyie	359
15239	2vaU9awinzFTGLQ24Ri98XF6YRK5URSLg9VaUrU8Bn4gWRUkwQuP	359
15244	2vc3vHLmDxF28yb3ohqz3Kugozm9HAyZSWS21Lp1a4D21m21ihpt	359
15245	2vaWNy7TCLTmMW6dBqFVzkE6xMwAAWUUnpnW8tdJAei5QqzVf1x4	359
15249	2vahsnnxxUeyTZNc3JZbe8u2J35LhSbXjyv3VV8Yv6beNP5GnUE4	359
15254	2vaC1M5be7RrwWgqa3JkjEpbrPKdoT8DuSgzjaG4p6keYLj9LBZv	359
15259	2vaoxahhpzKzfbbY2mHnedkn3t34spDgZmFL6fAUP7Zi6T3qvSgy	359
15260	2vbT5J7AnrjKnHoH9uuNPSH1oBe9DdfBmaDkbDMyUsfSqxt9T7Xx	359
15264	2vaBqJreGxn7F3BeBkxSvVAg4W3R9ukZWmodY4K9mkoypRqLpfai	359
15265	2vbEESEqYpqgfRoMdEW1pKaTojQFdeDjYQ8cbtMMRAAuzrNGUBK9	359
15266	2vaUYja6GkD74TJ4sq4qTNw2AHTeqnQ7SmMg5W4a9Xbmows5WY2E	359
15267	2vanPWfvHCs1a1tQyyKsNZLCPgCuLV9khsodsU9FqpGEFzVVQZQL	359
15268	2vavvQkDLX7vqPPd2BPe61ypkc5veBJ4vjoS954rdkprH6fnfyfU	359
15269	2vapvcpbyMj9WALokWgT2mKEmHCEntAh5fA7kBythmayWoWbSgLL	359
15270	2vc2TpPj5ZHHcmob7mMeSytTAHKhKL7XvRY1sRB71edSUTbZ2Cgz	359
15271	2vaGsXvg1Zm9yGBc4otuEEkt5ksSrFbfKruwuqxis61WEXcns5eg	359
15272	2vbUVRF1iBMLtLCcjdfy2nu5aL5mvm7R4G8RJnwWNy4tPgQN2KVT	359
15273	2vbTfEQFcaHZ9uLNAV6CzdXJcGiUbj5HgnRQ4NbVf7ix6KH6vqnZ	359
15274	2vbiy9kzftZ8FfAzQTU3W3ciXecwfpScv3xDVa1Za6kN3h3jqBvz	359
15275	2vaKM9GA2ZXopW6ZAGdvtXAkXTwd1MATwCQ7xgcNH9DCm1JLSeNK	359
15276	2vb5TJQbq4MG15skvnXQkL2N6pxmCqLBHsK3oDhVj5Ng1mYfB84E	359
15277	2vauQgkN4nug4hN6pqJBzUT1KZkXmRiHXWALsNCq4FFq4dsvyJsF	359
15278	2vazfadmurTiLUDP8ZxJVEFyfxjocxQZyRdzV3wiVnjttkjr4vcu	359
15279	2vaHa9YKddCPYTX9ZcB3d6i27EpsTwChFn1QL3VUffcesTZ4Mp1R	359
15280	2vajqRNc2czUMggzi2KSqaQ31D5vF8WBim7A2mkcSkux959xGczc	359
15281	2vb7e9AqCqkD1PhUxZgSMufN8gNi83vRJYKFxKkXY3f8aQ4FqYJX	359
15282	2vb2fcnfTE431cxSYBuQUG28rUAX7jv35GT9eSvBUvEWLXnmfXF6	359
15283	2vbv2vrQqvbPZsVR8R9CJWKNxGfcX9LxPhhaxiGKWmGvJeexFKLf	359
15284	2vbsiV9Fax86DL5hDLHvFgqfQ5RoAqJdtpXN4CPDFPU9ZsoSuAAX	359
15285	2vatvY4CZWSB1VN3hyxH9PPx1MP4Skh1HcZj73gpz2U6netCDkgG	359
15286	2var2DbEEf2yTQkXua7T859MU4w84GYZEtPyD5mhjyugWrDyyULA	359
15287	2vaWCGw2EhbcwaXJazyr9Yfrt3ppk2X8jbjZuZ2Dt9Uw4s4mKBjT	359
15288	2vc5binR69VBqjSMoaH6PcfWnKz5QZ7WT3eK18Y4cpfFSfQ4xDjt	359
15289	2vbMpN8ZUXMTcTHhjYdQ5KqjpbEiLsHuRYRVMXtxwTE1fgJtjxSP	359
15290	2vaWLKobDUwME71ter29JyJb1Xqbk3Djb388w8J8NKxEdnpkU27Y	359
15291	2vaZVz1PRUUNQuoGbUy9vqsxDJdY9Ta1tSaBF9rQAufdah2AwN8J	359
15292	2vazmXw7B6faDfVBi72j8NyqD8HZBnyPsAbrwrrdJu71rHZpiDPA	359
15293	2vbMf3M5T1FBJc4mpuQNL5fBwiqy735DevMDkKRjvZPj6ECkZNdW	359
15294	2vamjYEiPzqJezikBQuMF3Bmfu9e1mm2BYWjYap2s71mCiWBsFam	359
15295	2vaeVtW83wTeuN1Lka3oNim18NxbMfdpSY6s7e4dVyTY7eiSi92L	359
15296	2vbfTGDKtmmjNBGene38bmxFRSpUm73PGxy3ptCw8R3gniydSqAT	359
15297	2vaGuDKd5LTetK8emjHPVBpP9CHnPzyTvc2kQMjZ6bM6YUumb8y4	359
15298	2vbAXHB3o6BvwRBQwXrmVDZShont3t55A2xUBgSMxdC7AzizUUHs	359
15299	2vaG1QY91ZWxfHWw5rjLv2oHY1b8aunHXFt32BjVKuQESUGGAov7	359
15300	2vagShw9UphVRFnRwFW3FQaJADWidTwsFP7R85LPXZkYsZhtjE73	359
15301	2vbgCFK2CeCbCedLJAvHJhSA5gKADonZEvQsCJAGuJ678x6zFsTJ	359
15302	2vaak2AuQ2FhkjcTmTV5Smm4TSPfkLKAK7RDat38Y9uMv4RYfYHg	359
15303	2vafib477kaCRyQq9QRMdnfuVnQmQZEa6tUYUCTtfG6H4ZSvYmFK	359
15304	2vbxEkC8UzhohHrFPKqBzrQpvMCAmwwkPnDzw4ffdAZ2AD8H94cV	359
15305	2vbXcQ55kBr9MpCXN7ff13vi4ji5ZU5jbeKNEUNSCMHLM25gro28	359
15306	2vag9QUhEVvDbGKpbMMscVATx48C2V1STF5n7m2kmQEmYHGqNmfX	359
15307	2vay98ZCqHD79rVjSctWjUGS8uKf6NWsixaXr7dpzxedi9ynooqW	359
15308	2vate77KRFZ8DCMvyCY2tBc1TMMtiwbNfViDhgErS9uz61whoMiu	359
15309	2vc4KtaCgxMENmajukHmhafxxHUVyP3hEZBa9yaaJsXYuYDSqZgp	359
15310	2vbZZnqVNUuYpKu1fvb2buz72rSh2wrCwFd4RuqGACfMLMg5v4eS	359
15311	2vaGDHYN7Apw8vHKZ6JnzuE3k6HZJaECTP787jBvFhy2iVy6JX64	359
15312	2vbWySEmMijZzUSHCn9sic1Pynm38ooVwZjKNMdwtJhg2zFvnh77	359
15313	2vbv7zEqo5moNutKJLCrhkPtB1doffQvXRCXe8X3spmDZoWVpoL6	359
15314	2vbLCxyTwmHC6ZNg8kx4A87Byrw525dVqLWdabGCBfKk3YqTuo3j	359
15315	2vbZc1eWtD4DA725BmdrSNskGYj9ZQERCkSddSb5F9vsekXDqwu3	359
15316	2vbBcaqZ78EkALKATNghh36SF7BsoXz656NbcsFggXgtNxrytfhJ	359
15317	2vbGMM8ZVJWCsBsM1cSdQLot9ou8rnXZHTdfMEfZi5mbw5PeFAFm	359
15318	2vaypisJpkE8arCUAr5ZT2bdod6BVxM6iMKZK9kcHcVXFTdmUqrY	359
15319	2vagTJfrzxXPtPLbEEYVRQStbERGVGscfeFpjyMVWBf7RXr9oXLo	359
15320	2vb5Vxab1jjojTVTN8S565fvmo4yFCWttAYStkTNz3wr5YtT6TM8	359
15321	2vaLJ8oKEJXjfu6RvEZnHoauDDRXD2q8AgsoYkCY7UMfi8X4CZg1	359
15322	2vbwzhNFGRVnPquC31WJN15W7Y7GTCjMSEsTcwH9aaESR6D1giPQ	359
15323	2vbC4E6Ly9kvgiMzNzVtq172cBbKNP1UJivJPZkAG46dnr8fahvj	359
15324	2vaa1uxQUN8umggGfKs8qGuFqt4zDaHJfXjVE4qpZBC9sCgRPTqY	359
15325	2vbdEot4aKW5MNabQM4n4jXdxFfJsMzhkTdaWFRE9itx2rwPVAsA	359
15326	2vaLm7wKxn1AH2CM7568vQmXM9Xy75sojNsUqMorc8bPSR7B9Ces	359
15327	2vbS9xFjQuEjLP6atWi4KFjabpwNBS9R8TQDD3LnnAuRx6aan54r	359
15328	2vbStbfayPWCMoBHHfpSTsk36oe7K76VvBkf668rhE8CB1gRNKRB	359
15329	2vaMk64AfPUumSwF69vA3u3Vu3n3pKk1D6aB1asVR1GS1TWfgiZF	359
15330	2vafV1YYctMPwzbQgmXDMXKUYJdPe9epMx68etyNGcDWfgDzmZwi	359
15331	2vatoqsvMCcHFmP6KAQztNRbBXRkfjJKofHF2sXrTAY68qLiLHxu	359
15332	2vb3ZJgbiwyEkfpPu2mC7RAXxQZxzXBGZzWK1copq9pUMweCuGG9	359
15333	2vby1HQK3ELW1EUwcGL33xyXaQymbFiBdfXonHL3uUYdBvCqizMp	359
15334	2vbeYUtkMogJFGqF2QNjKXvQK7EiTtWLPxhjB3pCaNzj1rBqJ8ne	359
15335	2vafwFUrCi54kKkrsPQ3VL5KsTnZm4kpy7uddT2uxnyCq8UxVqjh	359
15336	2vbbZoXzV5K7Yk3HuKyYoDjBVAGmweU5s9Sr6zLS2CcubQBbqftS	359
15337	2vbvsjKUZJZZWixv77BXdD3GveL2hq5NXHkKWS2CEr3FZwSwbT6V	359
15338	2vbMGuJN9KMhZH2QRo2L7A23rYGeS57RhY4Jn5TdP4kKtBAJcS6q	359
15339	2vbRvy94dS285gSa9Q2BnHWb8qxRrFhS3iNigs26HPPgNyPor8Ay	359
15340	2vaSN912ZdbKDC3DjQuonKpJrFPMHnGws7n61RSZcBXHjELZxRVN	359
15341	2vbGr4Xd2Sxaga3vnhBmCtpLUD3NYnMSVmxDLRFRnwvtvBHTqgmZ	359
15342	2vbhXMsx13kKsNLZaCjFT1kyseRGfmgPVthrkXr7jpfMfN1hwvaA	359
15343	2vb837EU52aB7op9mT8FrXC3J4GwvkMT59FA2vD1UhNCXbX7ScJ6	359
15344	2vae1s5KhtWa4y7hrZ7kBoJLi7Khd5aVid6B7AKSYFeKzcM7rx5T	359
15345	2vbMKg3wDDepmbcpkZH5szNzrBjzJuFW3a69UWvzgCqjKVZ193sa	359
15350	2vaR3DQXmkmjqLoERAEsEYCt3nLmxNhaCGRXg4Pz2D8SDTLC7LQ6	359
15357	2vaFNFjLKY9CfH5UzjnjrxxvzaG3wKkAsATQLHZ9iWxZPgZEu2VR	359
15363	2vaAadSPNR4SFDMy8f4LB3b4Ax8jV6evDcX2Mn48SzX1V7EvJq13	359
15367	2vapbtbZBMM8HBPFmb7b5mED9uJbsKwek948v7mox3ehsazCmCrk	359
15368	2vbRj7WBqAHvbQuzD1gBgsjx3cXA5vnB3dinGC48Jwo11L3frzMY	359
15369	2vbeLro6xLvVE43sGkv2pTTVjBrPhNPu4CaGG1CxFdN6iJhLKRcf	359
15374	2vaDDMQtgC47wx4RFKUjkCQKCJcmuaxYY1qgH1PqLtFAbeq8vp6s	359
15375	2vbnHvWHStZjaWZrLTEDqchZNZ12o9HbxnUtmkaAqZZPXB6jaL7J	359
15382	2va9rBK7rfYbScoEvA2x4ztvvfgLQ2CwuvnBX5DqC3L7sTApVUbK	359
15388	2vc4VRYau19mmTFHyWPP3LHMUP7113bxkknYDvnQAE5AbA8yq1Fp	359
15389	2vb4y2ufgjSg8Z35VGi8KpwbsPRtbESxiH2RuoGYrk955TUEDn8U	359
15394	2vb7GkGDCVqM5y8QFKcTKKPFwDkmLLxBNww6HZ4cPajvY2JSeds9	359
15395	2vbYTdbwdv8n4WuZ17gDvriE3Sp1JK3J9Wkd3HEefPthdh1ks1Yj	359
15396	2vc3RdFbNLiVDjnbACUhCitLEtJ2wCquiY1FEwbqyEDxJDXThuo4	359
15398	2vbeUhU7yVHcVQguWipoyqtiLsPqzqefS7vPSPfwfFQ6AGooVrUt	359
15399	2vawbkdZFqZgMZc5bYWN9qzd6QFSGhYHkwhyL1gQ2ppqRA2B6vz2	359
15402	2vbtACgLBfeK5nxSNQuBPQnYeXeKwCfcACBo4zGyPJKdCcPjgPvY	359
15409	2vbyjEnB1BKm5zejatJQpBGL2H4Q4bsduvuGq94iky66wpRUkLdt	359
15413	2vbqSgpFvSp6V1Z2B2rpG7DUwSjYjji974L7w7PqdavcDLZWzeE7	359
15415	2vbgLSL2FreYbqmYeZERpv1nnSXVmdvEB5QorMsapqtFH5kCkMS8	359
15418	2vavWWeQNWA9iWQGZkUg6eNaQH3sTazAEUpN52Aq98HL5MDhtarF	359
15421	2vc2DqyXgMQCN5Ck72tMfEzNAQgpNsUEbKqiahQgt1uii3irhU97	359
15426	2vaq9CAA5uJpS1aQtCu1CfFfFWUZWoeST5n4oCZL1XtzYg1xo3Bg	359
15429	2vbSruMYnLsxK2YK6pgooJ144PuuvcrFnvqLhAKEx8PKrJZC1yV2	359
15431	2vbEntihTC9rQXWz16k3RRFRA8cfYja3pYG7HCy3nnghfytfAvL4	359
15435	2vbXLXHbbFQjFMwRGh8zs8eNQhw5Zy6iijcSPXTfNhVCkffjz5xj	359
15442	2vaMyvLA3seGxHaEy5azbJ2qfb9UqXo8HEcLRL6BCepYKYGZkyba	359
15448	2vaREm3zxo3muFaixm6yuipXSHj1djgXj14U2vCktf41FhY5TLtf	359
15450	2vaqXyhYqjKVUhoFnxA46Y5QY7DWzgXVZSVkvfQapvgPMhB6orVX	359
15457	2vaZ85xjVwngThj2fC9zvZocLgFyiv8qzR3AzRKGLZnnWrDG9iaK	359
15467	2vadRj6fXgWqtw2YosjtX8yYmpEif7kpGJS7rmGh5rrXgTgMam39	359
15469	2vbrnPNi83PDxDHCgfB7vuHYqSJbvXvEuEKDp8QKvsCmmtVDHhAe	359
15474	2vbD2pNLYKkbWxZUQMb6fYe5eeWx42hswou6vNTVkwhX2SQjZnKU	359
15477	2vb4VE5ZfhgnJSgJRXg8rQbshXgFYozmhTWoAg8upgD6rNjpeTmZ	359
15479	2vc3GXjA7S42UJ6L1oukCxWA6oXF5iCHebRDNpM3HmjFgv8EL5Cg	359
15483	2vc3rcEqTkSdkbEPRwhDBADZhFv8SWvhuod3ShhzArJwnp79o2Wv	359
15485	2vaHWHmrdE4Ck129Nvghd3y9i2GwA36uSERVdPJk3h5H7PF7GdfU	359
15487	2vbWDaZVrtqKv3T7tVr81Ho6wh1bXzyPXv9LuEJKbiJTWBm5i3PQ	359
15490	2vaf8nwx42GBP9wUK8rarnGJBvnwc7JAiJ8StgLhbra9d46Cr2HC	359
15492	2vbaZNKGipeJLkck16SdyLq6ZnN9tQAoMehdbxe7QmYN8kWuD5s4	359
15495	2vajJdKSmByWcM1uPNqiEfgccEMivzdjQNS6hJy4tEiZfYvPgeLq	359
15500	2vaCtJsuA7Jg3j2JVfcMRkPsAV4TZsJhjcjT7gaMLCQJSud5znow	359
15503	2vbCjqRCVGZTYoq4LmHAmzQxndkryyhc1Rf2zNvXZ3ktWps7iDx3	359
15509	2vanu9eAXAufpEBxJFpFtTF5Dp4UyT7QX4EyhYxznUAdzgQYzBqS	359
15531	2vbatmuNWpZ9SFa9o8i33gAAZDQoNMiKys9Qr9VyDu4F1STHvuug	359
15533	2vb3mEi8zCC1zEEN15HvsxqXQCjzNmkfs6ayDM7QPNbntMTNew6j	359
15535	2vacudUvEKygAqeqYui7kYYnKi92jzSbFHkq1ZGFG2PMSz4txpYJ	359
15539	2vazZf8LtSWar6v1bMDn2gNVk3rJqthZGhzANxkJBMuxxGPcrDHJ	359
15545	2vbbsRgRsZ6dky5GGTsHCyMSYLWAFk17pJSrmL6NhaE8BXgCbhsy	359
15546	2vc2Tquui3ArUZB6Sv4stHfmpt1m1tuYoxZDWRF5VkMi1jYEc64x	359
15552	2vaK2NxzvbVEjXgMoemEpdTQjBCKoB5ChPaP61PCsgk68QU23KKj	359
15553	2vbMNH4M7mpfFkU2cri1PLBHMpKq5Hfi3dAZJyNT5qYdR8uAHMH9	359
15564	2vbZwR2NUGADL29pexNAv1Sw4UJGLTGuyJUKSB2EvBUYa8asiDLT	359
15565	2vbmrsq7XBMMud5am6A4aUKWrwihH7EKvcjTUgynPrj8SYqKBZss	359
15568	2vc1bVvZnughPjC67pYX1tVhTGDweR8GN6Mz8EKJcJL1Vii8eY2E	359
15569	2vbq5nywh5JsRRdkJE587EavgvsM21FiWRSuhnG1zASB58xpTGfv	359
15579	2vaZn3k4NB6kFxScbB8cM9tBDpSjRnrsu7FzcFGjQncxw2vqGhb9	359
15582	2vaJKg576bXF1FGbw8h8oQfisLt6CUHx6HceeowLByZJMJSEXDaG	359
15586	2vc2TJ7wLufu31MSNb3LHcWDeWuRygZnKS76zUUdZxrZq4preBYD	359
15593	2vboL2uLP6mzipwfAgYxt5EPyeeZwBotkTmtphfCL7kYnnsncP1a	359
15597	2vbVWMqkTFkMdzcdbWpZW6w1TrxJ1ZWhgNv9p5vL4EBvaarBcnPb	359
15604	2vbg88DnWJ7ahceDzekhuQ7XPWySBMEkP8oAQYbP9JhpmaAtsJoj	359
15607	2vbfb7C8QVaudA8mWeJB9e66jpttr7X8r5rimF39zrX9QoToaZMj	359
15610	2vbs1sxMv76zj1NbLgeiNfv28LxQ1PDQjRYM1tuJ1u7bz1fZ6yPA	359
15611	2vbfcAvuHU4GvtgrG61tJU717tZ5BoJHbmqKXixiip2XxKAA4uA9	359
15614	2vbyku5GZ6rHaErGj3xYP6hhehcrqoJtNWAxnRksogeopupBQgJE	359
15623	2vbbVqVdzGv9a7hwXBC4RGo5krWbcQTNEYLonHybaPo1XMHd6mV5	359
15628	2vaGyxY684Mc4XMyLQDHghc4YGidZukqkLKizXQAqeeDBhbtCQKh	359
15630	2vbLYo57ZcFXhQX9NaYzFwWf7PZqA2M6RZdd8tq6L6YLJfJHhP49	359
15635	2vbWe2hagZaBqgsbeWtqmzSS5qdK9WCQ8XHGf4RmxbNmurUjQR7M	359
15644	2vb8ZFCqqFNRbH4mSUjJzAcYY1VF2Tsa9gV2vsQ3EB63QPdSi3hT	359
15645	2vaNkFMCNQVtAXKyuTzEvj65mzowSfocWgXspoSCrHiyUqhKddtg	359
15652	2vaS6rFeNmxPSw6t39rCiWjzqs4UjgvG8FikmV6oLQPZ4gix6aVQ	359
15654	2vbyj4A9ScEgk5V9gvMCZcg9EHbrF8pMqzzoRS2gJXTNQL4jL4eu	359
15661	2vbejGiAXFxKoYNjLJhvvZzWi8HYbj2ofzdQpSnZyCb7noephHG8	359
15664	2vaATJ9uZ9KiZqET7meZKboFjugeFB5s8Ss9LDiDTL8Y5XpkE5zv	359
15676	2vbN4o6vs69n7GCwbbhQw21QVSigP2WrD2eMeJoAvo1Eq3rMfHX4	359
15678	2var5eySbxKVQnwPcFUw9Uz2WhTzi57YMZcyg3rEBZpZN9WTsDhT	359
15694	2vbY76F6k1srSq8dDMkSkyRqkKMGaMBUm1gcFKDLUYdetoKtTBmB	359
15696	2vbXZcSzScon7LV5KmccZC9uauU6uA2fwHpjS4GQxHLy6tamtZ3a	359
15699	2vbygQAMCfGATdMTGhdYqa5nWcbbcbZyrCeREJTJdJzGT33PUZTM	359
15700	2vbX8qbL7o3ikBJSQGjJyxC6zihR6BaUrQzFnTg4cdEunZjjx6AL	359
15703	2vbX7MXJSrfPW42grfeHPPTw5p9vH6o2fSnBc1Nh4ru6RfyTrQrx	359
15709	2vaBfK3ErYxhP6z1icZZWbGhBRpMZJ5cTpob4op36K8ai7tDntE5	359
15715	2vaQZWnmsifxvU6xh4FsqYyeqcx1hBAd2ND9nEcAU1FjXDF6yDLr	359
15718	2vaMocACxLoKhvmsytgT4w3jUGvPCFoYqgVHHjL7gMutEYXeTipS	359
15722	2vaFN8zWwz6FUNeFG8iVEPxmhYTaAhrfWdJhKp3kJcRddznYER7d	359
15346	2vbnES8URMEuKx45bKnaLCW8gRKovfubN2vN6tHXTxj4C3t3CfjF	359
15351	2vaMkLohMVqv6Y4iBeSVwKpWUTLY7m5emveNKcbwsHnBecc4uWAQ	359
15352	2vc3qBc2CTkJ6eFCusEDEr4gjaU9mBzRjA3CxKy72Dy13K8nUju1	359
15358	2vbGBqKkab4rVcEayd752x19bbMRVKKR4rXSSXNovpf8FeUainvZ	359
15364	2vanQyMkBzb84irmpbgSGtrmf8KvfsXP6YJfTcN5o19sfn3FoXUJ	359
15370	2vbWkFf6jMypVmZiwbADaD5mZH2Emao2DKpyMWAQ9hgpo21BCJvp	359
15376	2vakWxdre7xqjut8Fge1ECZWRCcBb8xvnubNi6c6kj575R7WSyxf	359
15377	2vaTCh4nfVcGqNiena7ZS4p6qfUNLPWrrGrUKZoMn42iYNTPS4rh	359
15386	2vazsCeLdcdyKEnAucxHhGQqtTM68Wk3aSg6JicTirrYANhxisD1	359
15390	2vbVfTPQdvNtdLa7ibesgeJS7YTV4zWhGB2VpKidb794MUhz3uJz	359
15397	2vb5Vv4YJzEoUFnovK6b13iL8KytjsC5gTKBnyVv2DZxmt6uJ9E5	359
15401	2vaDDviG3AZCsM5wry9G7js1oCDxFNepPoLAmQPAURoRdaoUzGPL	359
15406	2vbSp71dVZWo4kyPLK2fYwHpz9ZvXVQHi1MwsyQh4BkDWE4tLNvn	359
15417	2vbi8Z3REfzDBqSETCtSxtMTgeNd5XVpXD3H9q68viGrbM7cK3zw	359
15419	2vbkYsZifDCTXyQigatdfDkUTMNt35jat6DQBkTwxZ2sxQe3aVX4	359
15422	2vaSrjVggJJo4A64y46DBeeNoHbQvE1MVZw7yb2CYXebZgu7gTb1	359
15424	2vbhT798v3JVStSoD2TUpQi8KruaGMA6z5AkAyBGFW3YMChpmfvi	359
15427	2vasLVigwj12JajRuBnH6jajigQXWmAtuaEHeiPSVjF4etHMxp84	359
15432	2vc2n79dHzaXzMxxeeaBUBeJ6qLJZZpmexpHuETUGNHt4L82f77N	359
15436	2vbea354erChwUXQd5FJkBLWVhuAMA6QnvrA81Wh9UURvhNDNsAn	359
15438	2vavinEBP628m7MenrP5scr5U2FBpDB3hoyAq9YmVG9HtQGuqbVK	359
15439	2vbx52Y2EPZwH8iBJiiAT4u623WWuVyon7WSAEv12ahTaGCj4LD6	359
15443	2vazneYX4kJb2RU9NqUjMsqSJr2ch1cESE6ENGL1bg8SWo34bZne	359
15445	2vbp92waKRaFWCPT7D4QPePzw1QvJBv38dUKTSgcSAREQ5rgXpmQ	359
15446	2vb6U1AEy5JdRCdmz6nFfkawMTLEtmLDWhiNYSpxdhBPnwJwwPGW	359
15449	2vbJQQ24k92wLpHfAHr2jiBWbN8Qi58zviqzrJtm9ZXHkFQ9Lrhd	359
15453	2vaz6jyHfTugyG9Fq3ZtsxNtCBAqcLAUocPfmiY6UawBntDjXXJH	359
15458	2vaTq8DkWNgoAeDv2yX4cJPYp16M6ojtNnkK15U3wyzDQ8qByy5M	359
15465	2vaNcDhqGVFG7LJW4Kq1hDCHhgTxKNWw1KuqZPJT5yrqjLuHXzcW	359
15468	2vaPaHiMUESRQ3R2Vt7avkxHA7eTERncJWyzNtho2CQnAk5ywKdp	359
15470	2vbYQ5zwBtavqGXQ6fttAMY7c7RkrpdRELALLyL8z3YUYwykh2eB	359
15482	2vaNRUyB1FkZjcnVvvPqoYEdL4NcUFuiQXPRXf3pdtNfhLTD53jA	359
15489	2vbiKxVUwEj9PPcm8YSrw1DVLmmSE7NpBRkUWrWBMHQqM3cHeK1M	359
15491	2vaBFpCqvkiDEaGoojEBm3mAwcPfEJWKyjrCF5yNfqr8GmHdEAVJ	359
15494	2vbtGq9y43WLz3AQsdex5c7zXFTgQpKYsGKvVMbYALxErskveH5b	359
15499	2vafpkTZeEsqTbkc2r2ausyPFCv4H1VbteMtHs334G5M5bmvANqD	359
15502	2vaYjSV1LcQ2PWR4ijSWbqVFQ4tbgszWW9HzUrxT3TMVFGnRxfSc	359
15506	2vbbYviMvkRJzK1wTeEfGuVUqwdrAKMf5VxLuLCEEzyENwPb7stQ	359
15508	2vc2bQhAeS4fgLaXKsMxpDUk1hjSqamQ1GStkTTAa9TzE7KkaL5P	359
15512	2vbzEejpPvd61KSfnpDP62rhB2TnLCu1PRoDb2ejrQH6XpdnycqF	359
15514	2vao4fXEkBNxp6Ws6CQ2mJE2HMEA4qEyBaU1r6Yy1vjt8pLVSakx	359
15518	2vbHPNcuGApbNgX7dAbhqri8BeL63C3v8GRUdTfTFfEpvs42oi79	359
15521	2vaf7kGkoEfUFQjZtpCeb1SSaZvtKzHhYXD7sRPoqE8GkZnfUiqv	359
15525	2vbDQnBYrgbwRCJUzaWknLuQUUxNyj78BvkdfvMcNceYESFAucox	359
15527	2vbjxUB77oFLXQyqJza1zmFKinqL5ZK3UuFiCdnUDfpiWseGq28y	359
15529	2vc2Ywy9xxrcFCibucUw1xnrsEW9rvaDMcvjKBC9hykKZevRqqgV	359
15530	2vaPQo7mxJtMcc9CWuyxvJbwMzdgyqjNHaJFeNoTjawBJJQfvBc5	359
15532	2vc56NcsjybKNWU7kTPWLCyrsEeHh2mngojjW5E42RMQ4SUaB19X	359
15537	2vbuC4RuGH1o8L9fuo3jsyAY5FEgdWKw2nSsW9qUyW2bCQ1aysu6	359
15540	2vb4gcp1hrVoxzzfb3LwyxwGsN9QWqiUPnnAdYrxrg7RyDYGdxXX	359
15542	2vbkUfEFWHTqqWKPBn2WZzaTyZQsFvjoYfEGAYau8rSvCseKrx3m	359
15547	2vbHJXPkufU99og3erCtoULDHyuD13iqkgbhM7uqaG9rFZ9N8gn6	359
15549	2vbD9PuT5EmaqDDDsbJPJXCoVDDMUMDTYD6DVZT4yUW8ScyWLQzW	359
15561	2vaGqooGFrFW6iHgNKnwE6NXiRmFR1LvLYprnwWoJRoYBGqkGduM	359
15563	2vbjPpT1YemiVbzL5e4J5c89fwEWPB7ibxNaHYsRQDJPR1KJ5oEW	359
15567	2vayo3tpjCEQ21W7Aoo5dpsuUZv8Rm9EH3cedni2pbrsDesLYVKe	359
15574	2vb77oAbkKu6w2TWmh4rGQWp5sqMSDcNoUGvFK9AthBgtAvEhc7J	359
15576	2vbjWhaa2rAphnU9rmYmyQejq6RDcGoU59CAigC5QUpoBGExPiBp	359
15578	2vb1AMiUjP7ATx9pa7MB2hGGfYa4FqoD5UqkngF87m7PKMa4mz9g	359
15581	2vaXEP4oKV3uLpNkEWfLDcjs318z5b6rCSPQk9izNFNWJ6SQxiLg	359
15584	2vb9v4nWFtVnrSmZPRsZ5AH3Rf4bWY17mCGjEUZjhzdHpiRDXewm	359
15585	2vb2VyHeZswKqaNirh9oUdB3yHCEBkKz2eure4vGjHye7hSQ2gcM	359
15596	2vaYrdyZohjfT1XpSMmLqwkpFggih3bantjuF1mNQ61eaR5ACkxy	359
15601	2vbwvwjJWjshpNkjv95Ng3VfrqK8fnkdNnM6jzpFFyHPq7zx7Ug9	359
15603	2vaASGjdR4gjjXbLoZcA7EiD5vrLDMuKsRx6aN58xHjpyCoD8RQe	359
15609	2vbc1pemxUh1ZDy4LYLnoTMe59gwhmd7xWQ9ed976qc6vwUb4pMt	359
15613	2vasH3fLd7V6nk43pN3izsSeERjynF4JAPuq7rusCvTsS6HriAzn	359
15616	2vaLFP5Ruyysrkb94CbZdGVXR2XvrAqMQB89bfPWRy6d7JKWXAYK	359
15618	2vagQhZ1JGXq57PKtmDZS2brU5C3i5JPHjc5w6KXmtgGa38Z9ZCD	359
15620	2vauBsB7mTvN2hozTxASjauasznHQRpRNhodGPzaJ62mrpZu7qBK	359
15622	2vbTpkW4Ke5vCTPNDDz2vbvs4MH77LU1vPs21kPNBkNauV1vHU4j	359
15625	2vauB2rEfbibKXmZvktByucPaaJ24MmxxPFn9oWwwhtTmHvZnfKw	359
15627	2vbW7ArHHg7sYQ2ihkFBsja7NeeVgH27MjrLEvqJpYNKbuHcSRNw	359
15632	2vay9MaH7Le81dvJn95mcDrAkjozzkF45qGHS7KQCW1qyBTD6Met	359
15637	2vaxCLv3tfsGMDbBxiSDBUPqaRmep1j2eFwU6WnjASKD2MJGKZnn	359
15641	2vb3Qxiw7tEoJeFyLKPEmbkbJnFhYEXCtQXRp5D6fm5Gg7qp14a4	359
15643	2vbJsZCPpmALgpSVLEfjrKSGGPjpog8zdxLtrWvpFNVSFmhQFHmc	359
15651	2vacauRtYsdX9BogTVSEX2PRk7mEVk7BwjV4J2sHuMHscvcbhsQf	359
15659	2vaHNRxbtqiU8rCZnQvKgdp1kmC2QuSjdHVsmBU3B31yBKt5bUYv	359
15663	2vc2NYCAibzRRCDKT5zErzrAtozzVYTi5A46u7BfpGath9aQ6mAx	359
15666	2vaT29DH3M4XKNegQKhisJ8kojyqVVE1M7LUXeriFczSVELNzGf4	359
15669	2vabuncLn7ZhRQKzAfpkNgjkHLJyLQSY24jpaKxNLEnNbcU2avwE	359
15672	2vaYMUWV8hd3FxhqKhatvjet3aM4SBNYjjuKyNz5Nah4PLDGkGoW	359
15675	2vaCH5GUNQX8t2tjpZJE9SYgm6yTtwr4wCzrnc11orjsyAJCZNSR	359
15679	2vbzBqMQUtYmbdEmb2mUN6MLQ4SHs4PrTy9HZSLkG6AasuBNX8r2	359
15682	2vbTvSNZDPRQayMUSxLr23WQd3hgBYeV2Wf1YMoE6mxtGFJAvg7b	359
15683	2vbBAZ6W8Gkvqkrb6iPFVSHN7ZR4dzHkXU9XGES45siAspMwYi4x	359
15686	2vbzkqngy2JQ9ip2fs8JQaqHcUe6AiFoVpuszMwxo5ZnyTei9D8K	359
15347	2vamZfMVBUpM6MY4f5sFaQLmWbLiaefTJW44awyhJZj4hbTxg4gd	359
15353	2vboeHZnE59Mqq8odqVKTwf2y19wFDxZ2VNcofibaoLgZ7qBdqsc	359
15359	2vaAEFfAzapH47AgvxVocTPZUCEBFYZMrpGRqEZyRuz2rGD5KR25	359
15360	2vbq2gcJEGnq3C2SzYTRXpeXULpVgV87qAsUwvqdqYDmW7oW7KEc	359
15361	2vbFJjbN4P2sdzU78UioFRpNrpSp1xZT57wLeaG9JLB41qZJRdyx	359
15365	2vbUg2HwKE9FqT8Bd1Y8YCjMQHMCRjwQjEFKW7pEVq8pazA3jBog	359
15371	2vbFAPWBjrc9cZCWTUBe79ha84zw2vK3LmgPetHEijyomCsknWRS	359
15378	2vc3aDCiq2pUnpvqj7LZ4ATy1n9s9vMzH7LvaV3HtjsRWB48LpTe	359
15379	2vayQbSZwSURG1sqiEeZWgAH7nyFF2XYGhRAsn7g7ni9R7aYyon4	359
15380	2varwkxvriTZQhoEiQZni4XNKwb4Gepc793uP65PrijHkMJwSzba	359
15383	2vbfLqEdFM5yScRDffkvN7WAfM7aX84m1CeyvJDeCzQMqxpyphPj	359
15391	2vbXW2JSgFjAEejbUZwa7TodiKck9qyCP6GCsSjt8hWFL7hwmZKF	359
15392	2vabQrJ78XLPFkCJGMQfa9hdzidfsjMcJuw2ke75fdGn8YYjRk72	359
15403	2vbgowFPThKizJ2qGv5MoEN7mSRsB1FSYhgswgSeLgrvGdpVZvZt	359
15405	2vbw1DBAKSijEXnk5gZxw1rrLfQZF4Ze6sn8PZwrSKrzuraGeSr4	359
15410	2vaoNtMjmq5VbmzMSPkgDCmLeUva51QMaJDt29D2DhhPqprdQGHn	359
15411	2vbj5XDFSrnfiJRuGESkt1o1yG5kETpnEjRFFQ3Afvn45rKzt1bB	359
15416	2vbxbGrj2yLkiUKpfuXf1xVhrVDStxDkuDnEJSRqbWeGwJfuBQjA	359
15420	2vairaCEFiNbXDGuZ9jETCdhbTtdnBrhSbcGCxD4FrZEyRpU8RM1	359
15423	2vah5xrkmz9C86hgzAjnhQiT4VXyJcbvKEJzKsE89zxTy1ooMQ4X	359
15430	2var6uaadCBYMxSAYKJz5xLnfXSo1569BZ5duiNYjysemZPw26SN	359
15433	2vaXby87U3vE8Z7XGXEP8K8PxX5kqLhicrw442gtZRQdczPEE72q	359
15440	2vap6NjdbdS4oefQEokj5X75nnrrLJMhZ5Hnv6bRWbaSyNxQHFR2	359
15451	2vbCwnTovWijCqjQPYPMRsVaYXRqYgefyrKzHt7z7Ba5WxZyH8vn	359
15454	2vavi4bnc6PkZyFPMjYqUbB79YQ2x88MXXKBMHvUQb8x9MbCu4pK	359
15456	2vbqLSpX51taTJ9T6oNSE3MMxASMACZEZNrfUfTtz3emZP17FYMq	359
15459	2vaPyDiCuyYTHsLNhzcXMLktHPn5BjbcxHmwzHzuL4no2BXEy1c2	359
15461	2vaWjGLWZRsEpcMWdNR1EkNb6TeMxnoUmJVik4zXS1EDkfdLvgHw	359
15462	2vawfyLc79nUKpBbFgpSdzxFcbFffNCgMGQG2wBfprN14SM3gSjX	359
15463	2vbL4XJpv8xHR9AkPLG7WP2RNUrgoV1jzk3SbBnzUqAEYTkx4ftJ	359
15466	2vanWn82aVFv2KtnGjRh2VXXfToLScgfWeAd6Gz9g3nVpm6qjyqR	359
15471	2vb6FcjcAxzq1bboRT5wg2seAnbGXmFdkahLVs8FywJGCD3Kf3fQ	359
15480	2vagmNaT1hC8U9NaXVqf2siTASyt1KoNEuoiBBtFFxhHsphRnde6	359
15484	2vbpUygLiuBtjodW2k54gYDPsBdYJAQR8675ri9dfnjC2hNn6u7o	359
15488	2vbb1ug1PiKWXjzeuFap44pqJFQC7gUaZTvkBPC1mj41TchqakHm	359
15493	2vbdNdfnopazohX47TecnEmZBJejCAxkoTE6utwu6fqqSu1hdpc4	359
15496	2vbfEkaQBv373HRNK6XbMwgdHPqGF2BRWKzJJ7NYi7kahsyDvfNp	359
15498	2vahefZ5KM1HwjLsmbrZeJ54fxDRXYCiCc7eecB6p7dYVyxAhEDo	359
15501	2vb52s1FQdj24onxMPzQbY27jZz8Fj8MfEBQRtKS7MwBsAueKBcE	359
15505	2vbfiWDNT5BofiV1ybYcxiLwvnb4NqWaeUFqovLmNPEDUjt6Nou4	359
15507	2vaWgVgTY6ah2hDRkb8cVioyfEbQyojaKkDZmm9myBHB2Bj7f9G2	359
15511	2vaAUoMfB7EGCqENGZdsofdTxTUMX2vshQDrpF3JxBntAogBfWj4	359
15513	2vbTv2cZ4FRRHkHcoZ6roBPr9C8f9GgDu6Q21LmNt1uGU98qqzkC	359
15516	2vai1djmEN6QX9EDYPxfEagfUFN9Fg8Ta8TT1vS5276DRdVq4jnX	359
15520	2vbJE86DZf1bpbcv9LdN9HUqA3JZMc5FTL3yR9W9vXnqFV1Rqmmh	359
15524	2vaueE8Ep6XfJtj5e4TfuigK4fDpW8qfecEkcBxznijgjdPGDWgY	359
15526	2vaWPzTGeduBouRXQrDsTDZoai2x8KLHELY6yRQ4pZEmSkqJtJuS	359
15536	2vb3h1KMy3dpjoTaC4qkbgd17E65YX8U5Xriwu7oc3GqSvZCLKb1	359
15544	2varrSLtmJbaEfgrnzoVGoSYJ4gTB4bELdxaAk8GEutzhrvj8Auv	359
15551	2vbHFrUMy8SsjScbHnkRhN8KKCAQ8f3HYL3DcxYTgcvPw5WbBfSy	359
15554	2vak9h3PD5HpYLwwv6MP6SQrTEhBpNuRr5GxFC9mfdT7g6XC5SRe	359
15556	2vbGJZe2Aec7Eh2RxSfMD7ZzfE9nvx5pcYP8bJgNay5aqb9UQPph	359
15558	2vaBC1wP2Gad2dYf92taiY1C5Sum5P6MAB8cWitiSGwFohhm2u5L	359
15560	2vbQnkyCFHHk2LH6W18WwFN8QVqWwYKoqXH99jky5CpPkSyemgyB	359
15562	2vbSBZWhWGPh3vqvcCGwVtjC3qDM5m6LnwSdu7m46XVvR4phwG76	359
15566	2vbDmHgad4sY4dDfundi3sEhktYjKwejUg3n7AcaGxLTCnZZmAjn	359
15570	2vbzBFGWmVq4VUGBQYvDi4NaJatUcGvNnLqQwXZvRSVnc2w5i4LQ	359
15572	2vaRzcDhdRK78z6SQH1gASbnRgeMxEMk1EHuVpV9X6SNJ4zT3ER2	359
15577	2vaYegFgBVQyJLWhiCdpQ2jUh9zpJGWj21wco1taahUkrWnexvWa	359
15583	2vbjHh2wEQT9vBfSJoLSiF9BJfYuszd28xxQoWYjxDW7and5zqGQ	359
15587	2vaetWWXqqKYn7JdAjwA66hFoFNjxqzzMWm14wdrBk8V32N5giYn	359
15589	2vc5gg8DTBsL1thAFiAmtEyKVx2Wjtksw1pi7KQHq8VBXMD63igj	359
15591	2vaFMYR7U1sBv7amPYdaVNzb1C5ycnbWKVzWUC16qc6ujPWCR6sD	359
15594	2vbkVn95ihhuF3sh1cvJvJNdpMqC2GcPWYNwts1zV2kY51PCgJ58	359
15605	2vavuJRHHo8SDz68qDHL7tu48Hb11VrbxumLoo8kkYGQRm1hkmbJ	359
15608	2vazEjrrAxov6WUy1JQjvkp3MwNcqUnudnXUwhkjxJize5v1cHqa	359
15612	2vadfzkFH1gtWodFEWUQHp4K7EKeuLmeMni5b3Fe9yDBFbH6pufG	359
15615	2vai2wVhvHFGfqPfEEQeCCuV2aEEqujZgwohwFRp96gHPoNVPvWj	359
15617	2vaGdRQfpuh82YMMtKmg82M7svBdJEKazboQfYtnB1UvZozL2ajH	359
15621	2vakbBwRX4nyhpcSteVjWt4E56C3n8swxQXKWVgwWXAoixStSkNG	359
15624	2vbknzyP1Nb1bVtqRjvByBoaUqWpfPN4VrpzfRy3tdZ5WP9SCgLX	359
15626	2vb2FS2d5Dt8dDuin9EsbbrJ7x5ws9FDG1DqZfvW3bKzp4Nto1Rs	359
15629	2vbF6sauuaqSaza11tKvCiWBXkM7exDqbk9FrvXtrGJKtZT6xR9z	359
15631	2vaV1k2CE3dHiM2ZEikCBQBxMZrzEDeAXzmja85kR7WLq2uvwHYh	359
15633	2vbGTv6hoDFoCBBnaNeNPLcZkbtcYrMG5qesh4CcHsksRw6ZCw8p	359
15638	2vbSyZRFgVRjvv1uqMU5PfGKo5GEPaV42ecToDh4hBEcYZeNr4UW	359
15639	2vbAxumG5Fwm55vqMhZt8eRqkoLVx16DjyPMQPNEUNy8pqusy2M9	359
15646	2vaUmLTs7MA1qQhmrj2GaWRFsFMyszG6fiuDG9R1uaPqSDGoTzvk	359
15649	2vagP7zRqhHWoUPxLpz2K9qZck7ZCKYEf7PWNjUPozT3uzYr7SmY	359
15653	2vc2guE8Y5m8JssCrJwQAJYFdBnETUK7pNZm6j9tAUxiaeWMsnoB	359
15655	2vb1MBgraJabKP6jBjvM3DkwZrF9EvoTnCh79QzP68bQJVSUzUaG	359
15656	2vaGikD2qHnnVAnJuFvdLqhJvth5rQF36qGgv5Tx5cVnYTuXJqLV	359
15657	2vaBcCXChwDi1nukuCNy88r3tDaAbbUU61uvXuJQpZry4dpTjo6k	359
15660	2vbjMuZL8r127Gh3mHY33t1uq48L31ua1VFq8DYf1q7iyMSJB1eC	359
15667	2vbGn9YzvtTN69LWRcJGXidWDvD9urz8AWYX9XyisTDnNtjyEPmJ	359
15670	2var4FisCkFPfagsiQABqy8En5qH7YE284SKwQZaw9SLrsEB5rR9	359
15674	2vbD5bfaX7Qy9AM2PVmfw6WiVSFyKkthnUpUCF7Sf7GK3py8NUrt	359
15680	2vbAx89TcN2RcvqkaBNvddZBPLnN72qUxB93bJorKvPCq2Gszf8j	359
15348	2vb5RRS311znvTGaS99nporZuEJoUqXNXa8JJfkcitQVPddWbTru	359
15349	2vbDB91VquLUx2BEGGWH8y7tuPQBxJF9fe7RbD4Q4SHqovccDJMk	359
15354	2vbmZiLoDxrNTU3kQirrY9iGc1xfZp1dftcTDoXUJMn4YEn4ski1	359
15355	2va9pub8CX7XGQS4tyKDyyFW84EqHqMegpmXGdABmDBdtSiDrBU5	359
15356	2vb1W7KmG7mLt1kSAna27FsjXBe82qcGKtBaAW7aZCD9RaR2tPH9	359
15362	2vaQNuCP3EeDvYoGDRPY9HpSLA6cqo5jcQfz4reGhCQeC3v3547g	359
15366	2vbifjpLUzPVafYR6uDTJdEdyHqPafz38fDzG5srQrco17ZzmKiB	359
15372	2vaE5rwErxak1v2gkParvzLJqn1UK6WKnUdzPAERj4ojmEeMgQwg	359
15373	2vazGTSeUFUo9KW59bjNtUkFH6ijmcZ7HhuJ6h93nc3cCHrAQcSn	359
15381	2vahMHU18u6HngL7s7xd213jBUCGpsvhxGdYQPwmR7J1Nfaw6ziJ	359
15384	2vaguJDDkfLbZMeNMCJbAg42JH9be48MRbB1dqkyeWNRgQJejpkS	359
15385	2vauEVWJUJkmT56H2Ek2aHk85JUYCtuzMnQkNVJEVtxiM7wFz5nc	359
15387	2vakgEt6TxzBnxphMS8Xk7iNFRBC6DfMYZn6N4fosnZZ31BD2NKc	359
15393	2va9d37XYjvVvbkbUpLaApw9ALQKvvyaMkaKJfFBXJJ35HErP3TW	359
15400	2vbywgCdcVKWQH9wTiBE9yhhDJe3B5TKfWdZoxVPwSC1ZUd5s4VF	359
15404	2vaRCLzv5jpXxyFk31SURtEBaKvcrBAT72U7JAHM3PXJjH6t2Ddv	359
15407	2vbBh145AEiFVwEUfQnsgp5NEFKkC1Yyrpv4LLTW3YWnTPRsVbsp	359
15408	2vbegJWD6i6HF7DBbW5LCmjmk16YsL8bgteco8ufjY3urrzbMZ5d	359
15412	2vaKxf3gXtCLzaTuw6u3Lw22b5vU8QvWsV7VwFuEvcQSiyyjer6j	359
15414	2vc39YgHeTmaxmAVTSFhjrTyZG3C3L8VsW8HhuiTWAFJYTdCHVBn	359
15425	2vaiAteocLhLmXnaZxkBsaNPYVf7sShDmEewJj27EmGusGXabQdr	359
15428	2vbkh6iKmq2kHGw1HKEQya3EtBrtwQQDpQW5bYNaXDgkqx71BZx4	359
15434	2vbmP6hKDYPftZ1QVZ2K1s6bYsJnAm5napJ13cijiAb9s9zy6CBW	359
15437	2vaMfeSEdkaMzU949coTZQDViCCewGi48B2Gj58Ncnkud1VdaCij	359
15441	2vaHSTGu6WXCrxRpxqD7XsPw1AZ6KaAt9249pJSZ4oTfRGce3Uik	359
15444	2vaRkpTc3ZTtj3K6hfDkfDUTWRk5CbkurtwbJjxYswyS7iYiYWxU	359
15447	2vae1svuYAERSgc3qgBseygzd9noLdcpmrsXA1cStMmiYqoVJe47	359
15452	2vaB3sZFzvzjN3SYSpw6Sn7CvLozzsxmgkYJQ5kHqNfmQoVt4UEf	359
15455	2vbMUswwyAfJunmhmzTzsDyW2FkjkJMtkZQRjxzqoB12SaoP6ft5	359
15460	2vbTJrB49krMvZ76Wf8twt45sck6dbaraYnp4EC5yVisrm2eJDHo	359
15464	2vaVwzk63P8nvp5J6cYnXNFLn5SmzneRHswnvetjZPRpVftW5191	359
15472	2vaTnmT2dspLUrazLkAP7vqe4EX9xnpWsNzJP8JA2vL3FgQ7VjF4	359
15473	2vaSnFNb3j8sB4CCxXiJJNsVzKpaf7EPhUJYCAuW6uuSEnSUgfCL	359
15475	2vbyWezoRuhgX1C8qz66eWPQSRV7ZwaQJzFHCCb2ZGDyHcmNGEio	359
15476	2vaHKjzkp8LjzUqubdDzT2HoYAvb3BeyvGomZmQxS6xF52DgDm4g	359
15478	2vbsGXoix3MgkfAFtQjYCKtZthhrZYdGB7i8PpL8T1Y44L5s6F5u	359
15481	2vbzypHjdtvkLFwVxka7kUDzsUHTCf8uaiDF9KevHMv7dSUg1KxX	359
15486	2vabuTYdJsqVvotqrASXg2LZqHtsoYfZ64JC8TMFv9ZZFgeJqnrS	359
15497	2vaLvAQ3qDVRyqpCXWJCnbeNJNzkrYgsiup17cFa6Kwf4NmzTdxi	359
15504	2vaq3U8CgxRd6YWrTzEhiDAvsQAKBinTz3UuEunNnPJgkhixSZ3U	359
15510	2vbSpDLwMirC3F9cHpE2D4aDTdnKkJVV5NV6bvXt6u2jUw4uGgjP	359
15515	2vbbE6ZmhktZSjmhtKMSVYPbBBRGr77aFADjGVkAWviVfZQxR7bu	359
15517	2vbU1xyFWS8yANg6V4uhpZuMhPf3CSfE4XRayDeBr6Uho5BjbjSA	359
15519	2vaNbnSZjq3GMjRt9zRb7Tyg4MAFqx9dmPFgRmh1qVyvGgD3sXXi	359
15522	2vaHULsV827QRvd7WmApPPf5MxxAZmKc9kYiudfQYXAaAYQs69QS	359
15523	2vbWpDP3UjcxdH4adp3z7xpA1Y5pkvGq2t7Xk19i9NC3Zh6eWJrG	359
15528	2vbG4HwHkmBQnFedNhnj7zD3sKMe5VWHrLFYNaqVcdAAVheQ9vBn	359
15534	2vabysStD4JCN8nWTCJDnSf2qxrKPCfxoLuK5PoryPnEP4JHyDxf	359
15538	2vbXP8Dp9Lc4XKDDxjSZpXKoHb9GjDEXmDdh9hp2Wz9DYmD7vt9B	359
15541	2vacbxmpnhYaUXHjjTmhmaZfreCdMCjVCqT3kDZYtzijeFS5WLAb	359
15543	2vbYZH5uWS6qApGCnZmiq9GQ7q32mtH32suzzPdKNCxehko3ZmKg	359
15548	2vaQkBNpSDVvBMqMBH4pkwnL25aX6T65SE3QyNuFf6tLUqJ1xmy9	359
15550	2vabe8NQWecWKUMDQkyeBj6mJBv4RoddXfxRZWwpsMnF1vTSFdwQ	359
15555	2vbcjCzDHWNBKLEKFoyde95bL1N9Pt1yTXqsTd8szGfpnZAwvn55	359
15557	2vbmbEEUHAvT9U8eGo1Cd3SEeFKch8yyUBESFVpnWagGLBxR1pCE	359
15559	2vbSnZ5Apvo8nHNwhfowAp27upABs2vJzzJChvbVscy9KGkwCNdH	359
15571	2vb64Cgc383zmeYdW6RXeE6nDojPgQSSCxR1RPFingxdrztUPKqo	359
15573	2vc3UPmGsFsq5BD79Km7cKpKmZSNaEwwZNbXhSuTJoqNepESzTYr	359
15575	2vbe2ykJH1xNMuejQBdV9UHs5Sjcu5MabZASrxQDZBJD2mJZ1cbR	359
15580	2vbrazCVthX4KURDAWW4Z39jbjFnf1B7tjuxxdv7nFCqkWXn82ky	359
15588	2vbVp7VwAv4WcvuB5PATN8LA9Cx6gB9MAt57kWmbdU9MEfXrUPDb	359
15590	2varfmSzTfU6fUJATw3CBx3gTwhqKk7YfXGG2W9u2jvSAhT9TJAB	359
15592	2vbA81HPML9wjSE66CekagRYuyqjmwk4qTmL9ZGvgq7LNA31Nx3m	359
15595	2vabZhRHGhRiDPMGz9Rc7egqfTxkUzD6GX6VpS1n84HrrHLyPYem	359
15598	2vbsXAG1CeUM79oQ3n4x6aG1woKjSLziM7QdgSYUM1MC4qtN91YH	359
15599	2vb63x6RWYsV9owjoZ86iV5FAgQ5s5KvAB7MDd2NfvfPb1d2ChZM	359
15600	2vbmQ863DfSgt2JrHqr5AC1u5w2tzMi5VsSEyyGwJHJsxY2bhgJ9	359
15602	2vaZCTpGiYztquoCSeCHqA3SKkthSFyaKbkC3BqUXXyse6biqEgA	359
15606	2vbe4DTkyDH38kvvFBSPGexYzVdAMYZiCCYoggCKovtYAeofGS7T	359
15619	2vbqYJD2CP7KCybdqQMnDwKbxjnxTdjhnetWzwssQBzECaZJr9Rj	359
15634	2vbqk4zxry22n5yBJ4H3CE58NA5BAkJ4oqnzxnEUkm537gvRe1B6	359
15636	2varYgfzCH6dwNx1Qdf2Y7Za1P2exAHc2Vgd6DnFTfvBG1mHCoMP	359
15640	2vbbpz6h6ZvzCZHKFuMRRPXReQw5yE3FCkAdt7fHpbeAYsF9kgvZ	359
15642	2vaG3uy8UCQaUY6aYE4MTZHnuWeZuCu3PRWxTeMgbZNL9rteq2vT	359
15647	2vaXNbgzFsyZ7TXGTAKcUy3dazW8ZUz8EzHZAXmq7jKzc97BXikQ	359
15648	2vbcakBQjsDYocpJDBsGRdzAQgeTCJRVFwM2iFp7M6RjkFkropze	359
15650	2vbCnnCBZ9SPAVtkMG8LWbTjvLe1oDKmxnGkETS2ds6Dmj7YS7fu	359
15658	2vaMBpDL3XGDQiBXvBPZhe3t4iQAgrGhwFJDYJoYLJ5DkuD65fvy	359
15662	2vbu67KubyEYVtGp4vcZrVHUcJfvPumK6cmvzDjGsyZttZbsPuw6	359
15665	2vbSErNm16vstZPCFiBwSvL8DLwH5rGGcso7yF7a7Rt1dTRKd7T6	359
15668	2vbMAthr28xuQkwR4x7c7Zw6FKENLxNWSMezYPywvukrLpuVvhZC	359
15671	2vamqxdu7bSwRHEV2QhMA2UadEzJEBgpxT55tDytyT4eB3kkoDYg	359
15673	2vbC525MDMdG4jWozUMWoKH1CMXQ1Ugw72dQqXVqw7mGC17Tciqv	359
15677	2vbWRoLwG6QLEGSNBBMjtEcR9s4uoVm7oaXJ3ruLecNUTbSG5Qf3	359
15681	2vakVDoS8yDMWTGSrABtLENEVZLfgFfCDkE2fmVKBafzLvCLjD2x	359
15685	2vbbwNnJwygUfeYkNvMu2N2igaUvD5FqVeF6xvk68CGqXuKdLvXj	359
15688	2vc2urwtLpgYpSP4HeApBcaN1Q8h5mTEvCR2bVgeuMTdWj6rdsnd	359
15690	2vbVY9rW69rGLWQATQDe8R9rpmaZ8v8EYef9nkJj1d2mVEBypd9A	359
15684	2vauvytE1ptd3emRreikutbosKwazYSJqyReVa5utnPyMkXa3jQS	359
15687	2vacX7o9UiX3KSQbp9k6R7UUdU6BDPpWYfKu44hVoeueYuH2mKYQ	359
15689	2vak1hDAPfQJ9gmKCXZemqJfJGNcb8XoEa3SyyCxk5S31VM6Vu9b	359
15697	2vbUtkkfsPaQWjZaYTG9kq4CJjpvDwYvdajLXPshZE2MVXnzLsVT	359
15701	2vboRQjQwVnibwHWFikkVJFXyizDQoqVYsCBzLJxV9QV99fg8Rx1	359
15706	2vbpATxDKcWrx3piLA1cKQmxz26RnaRm3qV6YGyz1vkDRJXv5bN7	359
15710	2vbR22yxuQRFLsG4hxzo1RMUPeLCYjieForKgvn7odXhwcnz7YVc	359
15712	2vc1EcfHDMjHwMgP1RcWS82kyZpGFhGgPxYrSG1t5ptQCtm9mnc1	359
15716	2vbnRb6eURwhaMDpUFbyxNSbpXyFkcUxV1oikpNYzdDhJqZo8eQS	359
15719	2vah4Bmy6RxL3aFG7X5MP1sMzZYxfFtJfZjVcz6zjGS8hdE91e5i	359
15731	2vb6uswYFfDGyLNVjwT8cDEE2gUBVBL4ioGisx3TwAHjhad7Huhy	359
15736	2vatBgRXe2KpuNnuXGZc8972UKtP74BhFWWGAhaQfSdryeyXieF7	359
15740	2vbcUMZi84G7cpMPbB6UnrsHS13Q7yxKmr1bR1U2bG3quj9wFMEa	359
15745	2vanRKQCrYC9soKmfSmREnboRPcrauRytJmqTaCQVzRhPajAKz4f	359
15749	2vb5UxKLMc8AM7xnTViksK4gBQcG4P9wXJjRqFk57dwi8iU8H7Mn	359
15751	2vauLQU3Y1Fijv5tsUTZL9afaRpNSNXCkZio7WCPTbLM2ZfpyCZD	359
15756	2vbgjxLjyFcNSLf8Xim4wi5gjQkZcx5Vs62rWJDpyaS7XFuWSqDS	359
15760	2vbWNc99B6gn3GZqRxWNcuZZxW4q12VLCa3W1Q6mgd68WNxv9Y1G	359
15764	2vb5npjhvSZ44qbUWhS5pCnv4vM4JnGWNrMKMJwYBZM4PNcx6y4k	359
15769	2vacdLLQC8Bzy5dcAoZ4JiKTKsVqfxwdZ5ji8kaYARHgZyub6fNe	359
15771	2vbEJ4nZ3j11UoBd3f71Lb8os8C4yMzzoBn2r3SteZzeyREAeYXe	359
15776	2vbg4HKEhnhAryCrMMWL6ZDA9vXsswaTLJ1ZmuypnbvRbJjh3bGM	359
15778	2vbqTCCzCizYE8H1XV7w5UpWUNWnSix1uE7Z59zd83qDz66eZAbA	359
15780	2vaEdH8ZeTagNVuu5B2XgmzsLcBRS4hryoZg7vFFdkVLRnh7Usuz	359
15781	2vaQG4jYF4nSC3ggzVW51x5i5bBycfhbo9wGKwQJ8cyqejrYUGz1	359
15787	2vaJxDc9ZeUL2eV7cWeHtKyRnvg5NtjTVNfYQcjdmeGRrrcAZTmp	359
15791	2vanEk4fZDpAXk5LvGQYHY8Eo9mMXtvdPsDAr63QW7t1iWUKpu1j	359
15794	2vbPCgxQAvqJ9FnoJ5roJenBLSSEZyaXsvaf3QzG3wo7AQz1zaCH	359
15796	2vbir662CLtPxuF5RXUFXhPK2AcchsPNEF6x6t6Epk5om1bFA9DY	359
15802	2vaGBvcpinJuaQA9CQF6oUz6wtBXQ8Lt1EQwFZbT3JN5P4ZRv1pV	359
15807	2vbJiN8mtDkeuJ5Td6fUs1psvJxpMrDQRxnRU3dseCTbR9sg71uj	359
15812	2vaGydD2Bt1HC59nKSYPvbJF7oQvowsnugMwBxeLSvGykTvipkSs	359
15814	2vaoUkiU2UNwS2eikPE4HQdPPLNYPsj1sy1NGEF3tL9j5dMmK8Bz	359
15817	2vc3zSSVCyGT8sqMb9ayq2PDZpawboRWc1vn4L1QoqoNCTYfqHHa	359
15820	2vb5nYiT7ZMwN2HtzQzYtGkSAfWY14EjWi6Yq3naxthxTjs35UjY	359
15823	2vaVi3HG9WMbHCoAKeEny48b4wZnpzjXmoTEaRUG3T7F1vGei6LV	359
15825	2varGjyCYMCfpu5m2pqJcFAjJWHRrQLFUaaCCUs91qupsT9DV1Pr	359
15828	2vboHogYHML1doTXcGUn8RWdUnvQfNT1xBPWL8L5i2HxnZVBj6s5	359
15830	2vaA8GUm8vqdrcWNsMRNeCPP4x3LH4jrTcTqCLXZMHjGeWLXBG1C	359
15833	2vc2gd2btV4QsGkv7JVszJcRwb3gMVFbwqVdv4n1Yc53NJRQZHfq	359
15837	2vaPLw8iwm3o83AbAXMZHmiH9PdjJ6PsMkbdBMiurAhzAcRQGvyh	359
15839	2vaJDK44AtEsGvAjL6YaaHsuvxHQhDt6yvS2c7mHL2tzgrxPx6tk	359
15846	2vaHGEQmUEZwQLzv3BnpbMWMUPcj1gMFZL7MDezB5nCFEZ5uYLJf	359
15850	2vboir5XAkCkk29W4zS6XwoJj2ef42TyATPyxgpbA2YNyqY2xx6P	359
15853	2vbjSYDjRC7gYiCqerEhjCzodTBUfjaNeARCCqu2HrMQY2f3u4F7	359
15857	2vaoReSyzETczLFp5tWf1aRP4xHjvNAeFv119ZbAum8ntjdF6FyU	359
15862	2vaJyZBNztzWAUc429DWbDnshh6MiGXSnQMTog2WkrLLg6unit4Z	359
15867	2vbbARQUdS4ZXjMbHT6z1ivSzuhfmTiHw8t9WW6nKNESE8WXkVKx	359
15874	2vbQeAKNar7MXfJEUFs1rZWazfEdDrSiua6DLinsvqY51iFkVq1a	359
15876	2vaBhwKS9gJW9gAA3MZySkxxkzvFmNs7jxWDogTsyMAYrZgoDFnA	359
15881	2vaKsHjbEtZoRoHJeYd3NwRy6JtbTAM6CtGwQZ533hkvKF6DtYnC	359
15882	2vattKHu1Bz38D1xHVDH96HcaGgkoh6HgWq55rY8qQX3wjTusRz3	359
15886	2vaD4FJWz3viD4dRRrAMT6VCjWtSoTbfLpkSv4JRpCEHanN18ew1	359
15889	2vbi1AzuffMCs57HxGcRLjjFyDpTQh9W637PVCmjs9u7aZMxbEmG	359
15893	2van48Jpcxh8FNRa1HtnoLbpU3GLJitX8P85NRKSn54R2NsSRv3W	359
15896	2vbmnXMgVbjAu6Gqz6w5hHRW98F3xxBecYRfb5qiQ1fnT5jrsQcf	359
15898	2vbKrtujqHkTWdqMrXMWJri7gBDGDmgraUAZbXC9Zd3cgScq2Vbr	359
15905	2vaL2V8nhsUxNkSA4hbKwEX9QBybwwtNyZ6yqYwyhJmxnP6ni7Fw	359
15907	2vbAw8tDpZxeB7xsrdQQ4uBHY6C8wiHZrEdnBdbqoFaiiPBihpsH	359
15911	2vbnYTh7F7o66VmhyDLqmoa8gQf9JBrJUbA6fWKBwEULTPScwmRa	359
15913	2vbzP2pKjp5X9BghRjDrBVJKUgzTyzenQcwD3P1rT5iFcsj2aSvM	359
15917	2vbdsQb2SbRYG5HtaAth61DXS9ranZpuUdk6cUfEzdLctfGak9xQ	359
15923	2vaYsagdL7ntMPMTHakTuGjAiyHNCbdpkwfxzSuApNKqMWGksC2R	359
15928	2vbhLGEozmPa6C4ttmwVrQ3oXhzYQNN57ptWFmaNdB4smqN4CdNc	359
15931	2vakHJix5yTsYC8cSM4WnQxr3iTY6NRNN8Cs3RgawngFuAiYuLzP	359
15937	2vamqQGkM1nE9QDJqvVCWT3sPn5Bf8GKHiEHQwWYfDw84QCBeJ2s	359
15940	2vbg7BorGNFkDPd1jgVowkGVhvH25Nm8jcpbnVziBUScC3ZU9TA1	359
15941	2vau8Hrb7V88pHvpTJ9WNs8LHUvpZaW5CvfeBKKSXSzPgm8zWbfg	359
15943	2vby32FbeTdd2RvrTteovfoQQJZGigpJuuSac2bPbBQTUkxVEwys	359
15945	2vbKCBWfsUNQp3bitBJDxAu4NUq5LGEcnL2sgiNom5ke6YymPzeT	359
15950	2vaNT2F3zGRoyLBPeABotecokbqE96xhRfRffVQfijr9T1hABSXd	359
15952	2vbcSDXwUeuRdbcsRjPGmfgWhspu1NqCqJV6hJXURekxwaCzRu7S	359
15954	2vaak4yk6bsJdV1moSibDrvxAQro2fwj38gXXHzxPFd5736pSYwG	359
15957	2vanXtYUJ25eA6csnaYTX8RM9G7V9VYR4rzZiZ6vjMuQg7uEEofW	359
15964	2vaSUEa3u9B1VKnZdmTKMTWqtXAE4JrgZfpWhUvFhMD1cMe3LQze	359
15971	2vbKfgpaiqsE4qa76kzESSqRxMmrQLEkomrv1bgw8Xz1HnEs4ZTg	359
15973	2vbJWizr5b7kSCwbwY7xYCdqfLzk1bNMG12WLgdSLJnMXxAQqzkj	359
15975	2vaJKY2akSYvG6kRrjcqP73vfsouKs1DSJ7j31DLkaJadE3GJZ4E	359
15980	2vc1z3MhKtDU8g3jFtuP3XMrTa3qVJMKaTGm9u8EPPEYsYMxZRMy	359
15982	2vbUdaLadCSh4wXiNteS7goPMcRwDFD6qeq1hLDM3nGnNQrNExKh	359
15984	2vbLcuFRE2n8pePHZHAQ6DpUYLsjwDPha7Rvwbw6EYuML4HJopRD	359
15989	2vbzdrL7uD1x7AM4iW8oXuLCJjqpSeYX9dneBTErJEQi9uycXf3V	359
15994	2vbedXAXtUFhGSQpex6DCYUwrpwQeU5qaLjRdHgB6eQyQHGYNtTP	359
15996	2vbDZHR12fmnMhAi8JZi6x7R25n8UwEnPKyc9P8sKYSDonyWKuU5	359
16004	2vbjS4YG3XFau6R7q5ptBCn77oNTp42JLQW2UChMMi6ms84izgV3	359
16010	2vbEbJf97hAgKsLsaVwPbfZr6Q3kP6ZyN6ZoxAMZMw4gxCsRypcK	359
16012	2vaAG6g56E3Xp4b3sk9UsQRkFcaa67q8zdx16LdHt9N4U6n93ukw	359
16014	2vbTXvrezZHPmKd7HdQExw7a8CFRb2FMBUYX94mSqRWetyhs5JZQ	359
15691	2vaZqB6VE7qJ87or5WCubK1qGQjvFNZRdfx5K3nRrF3Et6GKthih	359
15693	2vb3w3cj9FsCs8w8S4fK8maGbtCfimj6rDEN3xDGGBP5TMGncfTF	359
15695	2vaP4RSgAzwXMnz5rG99jUfJLJYFdyZJ2PiJfH1tov84afeaDqLC	359
15702	2vaZhPAGjatx2XqYGpKhpckJXJJ4woiDszTtG2VAXUbvozaJ3VMH	359
15705	2vaxejfz8XJUoJH3ToywKNPz56m9tK9MWVgXS26NnKqeXydroZ4T	359
15708	2vap3Bsizk8qwxTLURD7EevFDxcEeE8Kf5YCsDZuqsKGcGzFN3Ax	359
15713	2vbpRhA1EQTubjtXnf486hX6RC7Rx4n1dzLqQ9xS3gQaRMQ6zV6c	359
15721	2vaWbvJeguR6rkpjqmVZMukeewGXzzjZhqKGvT6KKdtTc7Ssw9Qc	359
15724	2vaPNnufwdTdnSmL1a7N1bERmFYZepFFHAMLZXhxnMTHZUdgmrbg	359
15729	2vbAJFcvH5iHdZYaaaQQpodsvUcYsNtfST3Hj3AbRyrsJX8tH4Uq	359
15733	2vbEaFUdgdLjTettiLNPA4C5ApcWwsuEKVP6aBnKPodFCTFHxX1W	359
15735	2vbvwzAX5EdbUP29zbozTffzMMYTh6rsy3KZqSVr4Hd7RnjithDk	359
15738	2vc4255ZdpatmPdp5BRyjWcjxwtuoyd3b61HXH8TQxB5eFq7ZVPm	359
15741	2vb3G2ShNB6wcC3SANMMeeviSovt21AsAci9pBkLcSp8VQ4AsByz	359
15743	2vbzybtgV3RSof8uQSdgT4r4upyLZmJKxRKz4roJwvrTE13kk7rp	359
15748	2vbcUwta3fAh7w7E9dyUwU73yBYmB6xhadGycr15uMvdcLh6kGdo	359
15755	2vatpGg6meGrAgCSDD3Kn9YxjLUbYQdmmA9fnc1qJgn1kMpVehMC	359
15758	2vc3e4To4jFPthCf6TGa2oosZz8euiDdPEGthM876z2pN8pVGoCv	359
15765	2vbZkbdJ6pFUqHsK9J9rKTp9CiEQFuTRV3Wvs8d9ws9qn6rt49o1	359
15767	2vaAqmZYyushCanBdoduVxwZxct55qLKfJtzx6UUh9g1Jv1PSBAx	359
15773	2vbp8jgvzN4gNLR7LQPUKpp1fvDLjA3Tyh5UbUTJnZrEffmCQZ3V	359
15775	2vaPhkk93GqBcUBaAMtmzJfVFvLd8fmw3axkDR42TRBP36THZWsq	359
15782	2vbSENBEYx4VNewSwjcoTsjfekUJnUggCS8taSGudgNiHGcULQUe	359
15786	2vaPv3Xh6Ci4JE3wCS9CSVd3LBVD2eMZGAsiqgxo7qwrQJUdqRfq	359
15789	2vbdqXXB3zUFxCwTJMykmyz4CKb9Ca3FG4a6dcURNbWb8Hf2QcDx	359
15798	2vaoi2mGDjjsC6uxS6T3zLgqvhsj7sgqvJJ27ZzqP8EqjVYaWN8B	359
15801	2vc4iBGgyZqKtH6gvcVM2WxaLEoxLuotNJ5jwZHHrguPrpi9ycih	359
15806	2vasqHyoEVUGHFcJvVFK23QdeP3WzATW35PbLZrg76nEjxKRBnj2	359
15809	2va9Cr2paCMdpkjZHDrtZdDHNbdPoQ6mjrriELvvZbR7CELuYj6D	359
15811	2vbxYtyoP16Pg92wT7gus8qXjaM6NhLn8cwhFp8Bqdry7WWPqMBB	359
15819	2vbiRbb5AzjbcwcjrF8mmUNxYYmTdx2b2jGXBtpfxzT6RpTo3ps4	359
15822	2vbxQUjRjnZ62BSk27frUoT5MEvbwNs15MgNWBMuZJoQQx3TZBLq	359
15827	2vbw5sib9wr32tdbJzPkcUYkf9wuVkFevgEVdFqs7xL6J5TX6ydX	359
15832	2vbhEXsXHsnLhRfewFKFsii8vbkxYx4uFuUqwurRJU32AJ7AX6m2	359
15836	2vbjopPawYynHGNohoyY9b9QN6nGYreP3FGU5oquasPaTeqRSMha	359
15843	2vaS9BooMwYAKfUU9Z8mN7hRMa5PpRxCKsW41yBmXTmZNA5Weku6	359
15845	2vawP2weXjM41bdFg6ov6k2SEHhTM8iomWXRBnAGWhyBAJFRSQta	359
15849	2vaDchgfLyS7kzxcDQWiqmsGFHhfuxXtBUwohC1S8XvSFT6BmCBn	359
15856	2vaPg3hHU5TrumKydbDeEYNiSttGiJrn1g3UFso8Rc4z7zwBcxsK	359
15859	2vapq3x8B5aJPbbfTzb3BXQr37tqzsXSGcA4gR8bMZfQLAUvZddG	359
15860	2va9FG3wM4LGZVDUJ57nRwu94CvU3Tw5xLFnWF9nksgWzg7m9AgH	359
15861	2vbbZd8xsUd5i9UbW3JLFJF9FvvWtc3863wLze43HowT7nsoCPsc	359
15883	2vb6bpX1eFjSNtQ9fS5FcnkiK439EJgP25vyxi7vyi5p7ZABPni3	359
15894	2vabEqP3weYSCaPXDUdiK3yt1KcZ7rSqwKBxYH4Lb3qu3FqYDdHy	359
15895	2vaf3uY6ZioN53D5D6FNgioMr5yc11pcixnJqQV89V7E7dAtbE8p	359
15901	2vainhCtHvTa7pmKqmFty3rvPnVD2Jg6oivGvpDMttZnV8WcXWtB	359
15902	2vaYFWs7XeLeqjZEL9u773pytgmbdEwkTvnmgWyGPTxaJkV5afFx	359
15909	2vbqQcNTjuCbyWiit95cXM14PetPeL96mZvN1AnHm32MQAw3i184	359
15912	2vbNQeyuurBueHg97HqqUL43VjanVnvzZhAiFP6cz4VA2gDBEm7H	359
15914	2vaBmixQcNUoyRFNkC648fWKM6VAU7iUE7eiZUfNDPZME49t7gVu	359
15916	2vbJnMs6jddx1RDqhzP7kLzbtfNEGcKVac3nSFnoM4TsrVsTfEzE	359
15920	2vaMeKyBxBBnWCycwiwioZ9bcqmgxpymU2bjnwrQwamL6agqCxag	359
15926	2vai1LzgqZdkB2FZL1s2qiSzfczh4LmxYx7XwZYBoSNAerbN8cWi	359
15935	2vbQUy3Tb1zKBn5NbQLEFGZfbQK2d6VuRGaF62j13FpJSFVj4ydM	359
15938	2vbtddVXR7iiHeMKyJEkSuqKAJf2LDKau132QL5cEshVFPjFupa9	359
15946	2vas4ss2zJFgpVrx8rkBXPPBQEUNSWydsdWkbgBHfuekheyyYQ1z	359
15948	2vafi8R8ScisXwcWRf5tn5UR6CYBWwohsutzAQnXBgvK14eTKtJu	359
15951	2vbqMqey9ihiuob7dLMDm5mBfLgo7599szZdxuto2BX8RDfNaRmg	359
15953	2vabeDixTrCqiFQyCgHnCZQt5kUPbeDdi8jjeTuM1e8E2LUw1UBJ	359
15955	2vbHFbaQEDNTwTvRBwPfMEdjZagqTWUe6vQsYgC1XCRNjLDnAKKc	359
15965	2vaKm5MvBbG9MHLerPzbHWvEgYp2hN8Tp32NGXxyihtAckJuSbRR	359
15966	2vaxW5KmSzXfhxAutrdvHMjY2DWge1wwfTUB7w5ZNKU622axk12v	359
15983	2vaF2vB2ViyWwSnv8GGPj3BDvAZ3wyxjNBUUEz88q7uFTFQ39x7V	359
15985	2vbjXWjqhGzwT95mKWsyaKzBJZUfs5uHdnERfsNM18k1t1cCrRTQ	359
15987	2vaAhjcT9yEmqNpAfhd3bN35e2EnRvmF8ym6MxJStq4re1pCjpQ4	359
15992	2vbzfb81BNGCkbbs7rDR5x3sY1CwfKvWuKVjtumScHc8UN5pCv3i	359
15997	2vbJxCCFLkihDjnoxdJoLahWcN6Rwj6mBhQxFSNf19kjyHQabCc8	359
15999	2vaymKWtKHH9iqfNSKKgPbEccQFg4iFf63U8FgCs7bQfhLyWdRQ1	359
16002	2vb1Rs1CmSAfohYDGKszt2fBeUGYwr3uurk9tatw2TG1rZDecgP1	359
16007	2vbvvMb57b56mNtqfC7KdxSETKvhnncemr35UzmZwYkYxB5nCXqv	359
16013	2vauGCmSk7soYrqoWjLQiX7Jy7Tf1RQfh7gmJVjyFiGFBeaTT7dX	359
16015	2vaAuN4yidsqfgLAV5tDCvY8DJcwDaDWFXfduifMNQpr8rckmUCg	359
16024	2va9zWPZmTLsUqQCEVQtNyFX4fMCQS9AvPK4bzsh6Rv94iWJmS5h	359
16030	2varDT5cuho4SLVco6hybzuGbVVECs9h2sDzBJNeGjHTpdfLtP2X	359
16036	2vbz25Vh8SgrSXMDwzKckt1hav83aXhGsqaSTbDy2YpwfQkAvfLD	359
16038	2vbG2f7t76vAagq4HgPJ4pZBFLLVPeh4g2SWCZG7Bro5aBNJxt9y	359
16041	2vaWdUibaZYZxV6cpWfKsG4AxmqmGK8xtH3RMmxh2HM8xbPxvkF5	359
16044	2vawXVRcQDT1ZGX9YJEbNJQfA4E8G4BxZWqmhmLKSchNzjmgYuch	359
16046	2vbnUae677xjZxo49ox9LDQjGhLk4sxY33mbJiKH43jS5ssBWMC2	359
16049	2vb2Ak3kF2anmAMXaEodFVvPdvi7GZoRU1dttGs8pPqarNvq4WHJ	359
16051	2vbYAsNv68VDsKJPp19zAvK1qGpQ24ivxmmFKaVKpmmdfV8moGcr	359
16054	2vbPhZfoHSD55QVqG2Lm2RbtJz4viFY5tw26tAaU9n4ACZsTwL7Z	359
16056	2vaJryf8iMf6TTqMAVsbxZcRtiUyJHN9KC68pga1yBzCnpwj9hjs	359
16069	2vaVRJK7qotAhFqjgpU9fvxwdVMDi8QNfVozswiRbcALkXzsSXme	359
16077	2vapvfc2vjUb86zCNP5y2aweibWLESCp3b1BBnnHRHgYQKtZjtc2	359
16081	2vaUjEFqRa21QSdtTTL5cNx5CHK7DSN1c4T5GVgsbxkH2NHLFrGC	359
16085	2vbZPHdyB5tmTLBW9wQKfVkorM3jN7v5Zc4xFzdeJMXTtMx5u8mJ	359
16090	2vc53gxRG51ejv3aqJdskAA2CnurW1hoWDdKEqjTpzRigPsbJEF8	359
15692	2vaBY9PpRcZ8k2faTuJEKR3xS4UwwbQ1YwFd3XjHf6WLJHfN6rpC	359
15698	2vc2WZJd1ioKzUFfZQmcJZaf1MJFxnTRcZFVywAEUgS7ctkgu2aM	359
15704	2vc4PDvcp1kEqGVMETQKZf5ERXDVuedDqsufBnRTExYrHZTxZVjU	359
15707	2vaWkbwqjEqHPLrkfS9Aa3mPMvZA4u1cQ9ELBhVj13C8h5KXGpmX	359
15711	2vbiEyYe9ehLQXKvV6xNd25jqsaZoZED4aUQAZ2SPmdk7uU25Sde	359
15714	2vbv9L16pCvFNugbxTBqtgTJ4GYu4FNLND9bh5Y87w8g4k7dwaGj	359
15717	2vbHwtsDJ9rKGoPMZ9PUHB2Qeop8QCBKUV6p9qXjwJoeXm22avBD	359
15720	2va9kAWZevamnBaQaYG1y7Wts1jkRopapVSLqjvKm1xaGmMrCeCW	359
15723	2vanG1dxPYxeuuAAmAHKrpygEzkFVSi2eqCHRUmSHHC1JWSHdjkP	359
15728	2vbhB31qvtEPTKj96zbZAQZVXHvo4quP5LS9BRnF9DaAa7sC14VT	359
15734	2vbkarzo3gT7Z9CJ8BgL4f8QkrNMTbQCexxCexyPUeQwGPgPzJzr	359
15737	2vbc7Qjr7kusRojbJ7QRCC1MArWJZg41aivPbXvxn7g5mfe3syjh	359
15739	2vaZJ67RLWMcjoUTy6W4sKCQoBGrv8Y7PisET4QzUdKvYvpyjuNb	359
15746	2vaHTtJvD3ZVBtnNCr6mtdCDrAX8FMGvWBPo7528DrL17HdZ83nJ	359
15747	2vafxxTuXfq9gHbhyv5orTZhbtre2fqGAe2ZL8ymJ5WYW565NS7F	359
15752	2vaKvH8RbjgYyZYUCijSBQ5kaNxdkg8sETgpSseR69G16HmDCmFV	359
15754	2vbot1MEV7yjBJJY3wgV7p2Yar5yFj1dnT6h7acJcNiMEiMvqnfQ	359
15757	2vbcRG66ZhrA3G6vjnSR9rB8JJFpyFGPZ7CSe9Rc5m7N7gNNpCeG	359
15761	2vc3UJsSwiUn8ktQuVDevHvEPWse4c3jcFMeFTzRvNktZVe9xBj1	359
15770	2vabsmpY1ptDJdb9eDAe26KitbYt1KcVe6VbqAkFaG6StH7oMxjm	359
15772	2vaozCeFbK9P3yiqa2QGZLDV7UgKibCisQDSFXTZZmeP4qqRaifV	359
15774	2vaLh4dPVFN6HcE6BzYZe7LnV6pynPHsToaNSKY6dGM4DaJj1r5E	359
15779	2vaNBpsGjpTPUjKGB27bBmEzM5Siyy9fq5W3JkC34WsNKcPBi3Gm	359
15785	2vajUMxLhFVMpiE6c8EHEHxbAY6AMFbcCKyGJ1TVyLDv24pJi5se	359
15788	2varzsJoszs8NhYPomuo8wsM7zyVcP5vr8sF5Lfhkt6pxQ6MgudP	359
15792	2vaZojNXJPqsQxC4hvZwyGGHCqzz1nEB8cXHpiLJR1KgoMP6dPxE	359
15795	2vaDZFQWvjDBw6H4YBPC3JvKoKhz2bC2rQ9gUV4kLex5HhqogPTb	359
15797	2vbENjL86TBA22oarPcozM9RECRAHot3XNqkfTBjouzd2eRjS6RL	359
15800	2vafj6Eer63TtADeeU2FJP3mi1N8yP5AE2mwC9GfxJSLWYrPiirS	359
15803	2vc2htvKxyCadefdvtYDZiu22LnooyyyySTNc2n9i2Z7qW33i5jk	359
15805	2vbgCwwcmjWSXn5iEp8Pn4YBcWUzPkFEasYCwqJ261AxG43uMTQ5	359
15808	2vbhgdFDXH8vyCUJzZxhwNPKicr32brK5tih2tjCu8YbrLh41bTc	359
15810	2vc4xGjyRdmG1ZM22hUU8mEUMdwahaBDEungsciXpKjHdZZifXYJ	359
15813	2vc3bwcbxBvmoyYxNpBCbvmgVE6rXNMt5jKZDL3RtJ2Fvr1suksb	359
15815	2vbdWD72GnTaMR7Dq1WFcnqtfbxE217MT4F4HBnukRBZtDYYduw2	359
15818	2vaRwJAXrH9DGGCYMXyHPzzL3CoL8Wi93MEL8N7qF82PkysmQpj4	359
15821	2vb6cYcE8LuSS1R5HdMMkDBJuBjw8syTCPjXhZk7UHVf8ZtaxAin	359
15824	2vbBpn5mYBsfzpeCMc1Dmt2NB6i95s5HHT1xWadi1YNm6w4g7fuc	359
15826	2vahWud3vbL2SHhwXNqjTPoCCw3TtVBM66R3FyQKaCKHDk7GNSb4	359
15831	2vb8tL94JkN3CjZNxaTy9shyyGxV1yiiSfwQEi4mQTRQUmpecRG4	359
15834	2vbZ7ZjJgCN9hZj4ejH62peZy14ZCfwYybEX2HvLwdY8qzW5SUzY	359
15840	2vbo4gAcx9udMWv4z9r8agPLiKqkHZ2974VJDQE4Um34qKyAuRKX	359
15842	2vbtLY43AukV38k6xyGPvhh46xv8EquWhPewNnGgmFeZ7EygyVJd	359
15851	2vc2iV6NsiQM6asAB8yXMPsZMQdHHaCNsQmDrUhZVFGq5bvuPvub	359
15854	2vaBjaq9qv4Cv8fbfdbjQY6HLBcNrhnhsmeJGKwe4rJzHb4PphL4	359
15858	2vbUq6xAEq7KYHLfs1C3NphiqFKLn2Hw1bfgKrJJX1FG8qPMF8aj	359
15863	2vbhjQ1Q4oA1DbDPiH8hzFnYTS74JZYMs7xWu5Ld9c36yz283w2b	359
15865	2vaPjFr2ynUg1mj2oq3F7XdStCYSqu9yaKKy7NDpfJX22KQf82jR	359
15868	2vaYWw5ZxqyykEF332De4W1Dd6e1pLXybg5hS5gqqauNtnq4wjXY	359
15870	2vassm1YmoESuTxesmBFLaYbPdQNA8PAXjG85pcx5KNt33zHQPgE	359
15872	2vaZafAz8FtViRAoAzhYerAHHF8sU7sJi8KHozgb12HW8iPxZKRT	359
15875	2vbxAg8hWTmEXjyVSoEugmyVRhLvuiVTfSx1LyMK6j8XnUdFMBoR	359
15878	2vbt8QzMsWErKdKGxEYkSQAAmnBusPJYxVkNfcx3J8FhmJhyHgkP	359
15880	2vaPAPamSuS2cxoXPiTthc4iBq55h69EQJNthFxDKRAPftJfP3s8	359
15884	2vbAXE1F1UfFPzgHmE8JuPsr4rp7H6A6WSRjiKToxdi9zLYRrgoi	359
15885	2vb3NC8uMnqyn9EbpWTKuVReMEqZtRgAsndRgkb4V8rvr4aaxmF1	359
15888	2vark5KxJBvzAyCUm7cNfoggiTAxt1ibhGRaepyZ9nETQiCBjKBQ	359
15891	2vbnW4tjXShbisAHzUMPDe2MFox9uNFnnLy64cLdmZ7onaMipztj	359
15892	2vap5L2Afg1MmoYeN8ovXfed7ixAzR7mY6xmgZ2s1rbGiY8msoEr	359
15900	2vadcA1snF6dFx6GGtfsoVUh8UBu6B1eNMaYY1UFjPbptQYjnfYa	359
15904	2vbS66uMK8uZYGTNT9hN3zBx5EatzgcyJFdzjB7r3458Jw2Rods9	359
15908	2van1uktWRG2cVxQFgMG8HivKgfZZnBk7tMit2MkkmBWTqRWT7wu	359
15915	2vamU6EKBrDBxcErVdDLS97oC27Wmom7NZYTcmCL7SSqNjbxNZfp	359
15919	2vbx4y1maUhbXgdiaq2qxUsefHW5DdszyBnHenXGWTZkVWpFLpg7	359
15921	2vb5B8ZHBm8ieaUpY6LKibX9L37KTXcehMFXUhpUTjYu34DkjKvm	359
15925	2vbF7KLM35fthnFDWmDRLH6UgV3a8tqU8eruH5pvK3GqQTzWZNpa	359
15927	2vbHtQPY6nqRBfuG7C4dg3qps4xL5Z1U34CFtA4iYrwiU3ENycmg	359
15930	2vaossGKv19PJvQWNwNA6V1Yw56PvzJrmvz3u5Dv99A849N5PvNE	359
15934	2vaYZTFg8zF6WmQxeD3J4PwuJq75A3PwhJaRAoSeGQkyBK8a95mG	359
15939	2vbppxSJjeQqmHwgaKnoDmSYovLw3bKon9wCmHzDtgv1eZCWsJqN	359
15942	2vaGaKxizUdtJqBXmDyELdXzys8e4QeX17yDNf1woV6W7D7HvZpU	359
15947	2vaavVK7ySGGieukyERN3kYPtpGFtYoGbhPf3UR6bUqNmBoKL4U5	359
15949	2vaa9aJcCpK3rzJaG35JVfEgjscYjKb56xZyA4Z1SAnFDomFN4U2	359
15956	2vc4HYe8DBRtC6MQuYBr6ax4bhV7kiJuquVUahV1qNTqwiPcgyCn	359
15958	2vbEEByEVf57aHyRLGfmUMJR3eXWrGpwRmQtXCHEH7miw8f1xhxH	359
15960	2vbwWsKgevTFUA5R8vzLM4dQuwQidj5J9a2Tb7PJZzNTJftni1Lh	359
15961	2vbeccD64wkANbGHoBnfCdbu8fJmYKrDrwxiirgd1T1QCjVwTTLh	359
15963	2vbSbi2TzfUhmLuF9ieth1qB7Dqgb9MmG3z8aUK27CbMJ1NwDCEL	359
15968	2vapWtuQW734LWumrjD9zdJA3tjsQks7iF4CADFUivy9w9AJLeTX	359
15970	2vb9RUTz4WuJfU8Bp57WVANvdyTjxEv6huMPgqZ4YZjzYBvMD9Kx	359
15972	2vbpSqCwFwWCZkbnnyP2gZqXJbRAHyc6H2ifeUL9oFVgQDiBK72g	359
15977	2vajvsHTvc1BcoMQ588hxU1CtME5Z9BuKJVGVu8dNyG18TYDeC53	359
15979	2vaD8icGxYUKzTmAH9c2vaKzKqAcDecP9W5p7rfWjJJ6DuWwima3	359
15981	2vbjbjragk46LfzkvhFHFFo9aFm5MbekzxAe3FeivcwNNcnHjPoX	359
15988	2vbWfLiyhoYhkeFqtYw8uGjyp8r5ZK2GmTM3RsLhsi5LCY5CtpAM	359
15991	2vbHhLKzdUrnP9HcHBwtae1TMa1UBXLeyvAMPVvFo63dFGmUUTke	359
15993	2vaTfkGCVzAhXrsX1J4zyQXiZ35saNmDNyD2hc2pVDb8aanvscjQ	359
15995	2vagdhgXK4s4iCbC2waYPhNogUw5eju1Ntcz7MWmkKBudVHaEUvh	359
15725	2vbY7rNKj1rwgJABGKGkoCBL2dnHQ8SamjpYS3B5a7sp4gUKZLZm	359
15726	2vbojLx1fZj8KY6NQMmCSzybGWBKgkyCPPBvy6L5ndsa49Dw21Du	359
15727	2vaHhnbVsUNPNAmnAs1TNVPw3DDvmJQqf47AQcyJYmdYyWij9gxd	359
15730	2vaPrMQxjSx7Cj1rK4yxi2cnkdJVrziNq864DYFPmWpsMzAhEAKY	359
15732	2vbAeYXxzt1xZZvtAHusZ2CDb7vpUzLABf95cMnzE84qo2uanuSX	359
15742	2vbHJHup1WnS7u38FoUAjf7xYqMG5adVzC3eoRZ7CzazpoAqf6fe	359
15744	2vb9XmHF324UTQaApRNhjDY6dmyaPHfN9PretLvqAaRxHHrU1k2S	359
15750	2vb9TaZp5txX5ym91D6BV1mSPdLoPQDGd7oTuhhogsadpeA75Wkj	359
15753	2vb4bpuGrRGwPiAkdYDtntF18KzDUTaqHAL3Pc7zLMpgHdR1bkJj	359
15759	2vbUgqaQkNmBC4v7XGgFVv3wfcP3MfKXBnmN6LrBthp7VKXUVZNY	359
15762	2vaHhdHZi4WJfCSGoLHpYJQyKQ3va4fKcjXZGkKaQHvz3W1vxWaf	359
15763	2vamkp3NMC5L8TRfuMn6LZbVjGXkjgW2NZSUGS2zsijZosvu5uT5	359
15766	2vaNRBUnnETLxEDUsmvW4TpCS2Cei93pVU4aoUBBiU4YNWQXdUrC	359
15768	2vbfaUJt2FUi2JWrBPUJ1piEGpcmD7arezx1W6EfqDqzGYdiojsV	359
15777	2vbpa9F4xqMCKZfTeVXRnrVyEveXASBBj5XGHfuy8fQtNMaSAfYs	359
15783	2vbnb3suwvFHYEV2VQN9qE1kz4u2g1HYwcZ5mnBRdYnuTDhpcKyZ	359
15784	2vb5aA4pLmAkV5QgjhyomNCE7U7qYegzYhmWFEE9YS66ZMrotyWM	359
15790	2vbTRR59KoVGEXHXdDv7dvfi2jaMPoFdFcLwNgmVXssJhE1uYsxx	359
15793	2vbmmBEH5UY6Q1ST9k9XVBV3JN43xEUtyme4Ezyte1ipA5EDQKDM	359
15799	2vbiJWF2p9k7bRWmaxTc7pw7t3UwAsADwoHxvjYAcbRYDR3zctr6	359
15804	2vaoPMf2v1otupv7JVHyPVuWKBPaw2dJBmkTKj4V4NEXxmUgvGDV	359
15816	2vaufMEdC2GQYAjfdBYGnoADcj4jRj5o89AizguYjoD9Rn6gpz6h	359
15829	2vc5q1zLMZb3CfRcmdnwMZxd3RkuE6s3WSWYMCkrqUXbSZeA5asH	359
15835	2vb1XjQuUKjLJgMJxxWUV4PCT3yo4nb7zYqUYtZPiUPAg49oDYGZ	359
15838	2vbb85ucDRZocdb8hpQ3KeEZbneCGSse8eQRCPudUBAviMMcbsTR	359
15841	2vbCB3zgAgbtAgJKzJZdru77PsZ5v4EM36bLSoYgXjanExYApA9a	359
15844	2vbs9fmhGYcpiuRcwPLhFAPqHHfBMTv6nkc2Rvd1kaGD6WB2bZ6z	359
15847	2vbZuFLzNktdfh5MCqkSsGAL2foVm4YSzqSeNsRfSX1w5qQNpJRH	359
15848	2vaP37neyVXoXxqeZrf4VxJ9B7oEVSuJgi7CzgQU6BY4iZkRAxP7	359
15852	2vb3saPiBnaUyxhFjwKTM3QeDVv2kKhiQV5VMB8UUiLVBq4L6mk6	359
15855	2vauvDRr6DKfnrb48LTeQehd8zH6acPARA47KwT7uj946u9FgsB9	359
15864	2vaH3C7s75SeEfx5CoY1Trgt36RVqwAs2QVLUdWwU6ZbyhfMLXiv	359
15866	2vbc1ZcJYPhzmsKzrQj46wjWENqfv6xfFnKccmBZjUo4v1uTgEk6	359
15869	2vbm5Mi7cwfNfG13ZBzL8FLFJq2Gj8fAweS7shwYpbWhSGyibTpJ	359
15871	2vbmBEDT61QWbSi6JLnLij87rMxu7B6KY3JtFvAwSVTNBPyqwsbY	359
15873	2vbBZcNMf6QKv8gkr4Tr5pS6SCohNgXJF5DHR11HxEQGaUcnG6KN	359
15877	2vaV2UEAcQT9J1VWVkb8hY3auodyeFrM4bQ7XkkHKGqnD6G7umL5	359
15879	2vc5LCRXpuSLaP9M5QuJCyFq6cpxx9nnF3GbWETaWoYFDBsSioD8	359
15887	2vaiSXAmVzx4Yy7GFhqS3S4c6YLKXtmEFAPMWL29dxzyJ8AfpuQS	359
15890	2vc24D3EYC71omJAbmNV69u7ErMemD2XCNDZXbUTRxp59e7KU82Q	359
15897	2vbkR8c8U5vxnRycTW3adMR9NKAhc753Ddh8Jx879HqifgHywtkr	359
15899	2vbVnnMJtC7AMhYPr2Ypq94PSwcjjePbrXfVj4j3WiHEgJ1ojJHz	359
15903	2vbKYYQYZCvvGdwi66intEmbK5ye4fJNgAp2CV5kvYqVrpW19mf5	359
15906	2vaA14Tg11Gyb2Fi5hyrLS42nLKtfW8EPc8uq5dBPTDbP33kn7pi	359
15910	2vbT2Pkxmfz6NMxex7ENk526WSe5n8zL2Jjikg92RodJ9P4RQ28B	359
15918	2vc5umQx5fqoLTWz546epP3VDKXqvo3x9jm8vWzKBVKKgWQAZgyM	359
15922	2vbDgMXML3nTe7e1PMbX7D6CUdfiWbz2PYSXiRphDFyCJGWxnBgN	359
15924	2vbEXEp9vQoDVb7EYppdcxXJzrcYhUNHbjAmVuyKLdX9rV8VMg19	359
15929	2vbBUkHb9W4QsJ1ipbiivagduMEZWC3jm4T5KKqJLsCxs9A7JYq6	359
15932	2vaJZsNVhKtzXZDaDp3nj8wVQA6LEpGDHQ9tS3wL5pXYvKoq3AQq	359
15933	2vbUTgJtWALz9e4GSi99AsPdnvyHf2oj3UqssBsKhJiyR7gqSNuy	359
15936	2vbnjJiffsmgsmV5cPw7mZvMJ9nG71vjVKzAwWzmwfYnRqpTDGiF	359
15944	2vaQD5NgkW9JhYXtqK91Rg9iV9jYvCGG7iRW5XtxZxqbqyc4c2tL	359
15959	2vbbSvkssQnR37cZxxLZ62ohWbBW2LR4Pr6pk3Zo4nvNosjP4RXz	359
15962	2vbuqmbFoTaTzRrCzD89PggynHa7vWLbmuaxJF2yq6zrqZyfxZk7	359
15967	2vbN2GP7MmnDHxXcc1faZgnoz54iEREGhCnAucoMjx2A3hvfYtvJ	359
15969	2vaTpcLeTyb5QVfRcH8knr67FNSs7GjJnre9EwnqbRR9KEXpGwwN	359
15974	2vaC8viDjim5imdRunuMYvaNvNRe7fmcT2DmQbJiCUJaiUoZz3Zy	359
15976	2vafSHBGD8KQURyeKu5FHeBbn1dMwX7kkdqhVLjc36ckuJxWMDwG	359
15978	2vagXj8MT2adCDdymNxb1YdLPqz5ehk33CT4yzmyVyH16EitTkYA	359
15986	2vb29riAN5qgy5houTkXPXhq1QFXAhyRVLJp5nxhVephVbCq9CaX	359
15990	2vb66drbCeR1AF7V6iPTEUZyfYr139dbfiV5zPYCdxAQ6uYwAZVJ	359
16000	2vaoeqVg35nrYDXrU5WUKFgVSRq5PZKuhcPs4WLgL8kLzcETKYoK	359
16003	2vabLLyDMSn3n7GKoMV7euStz7EBLwsvjFhQXxSD1ngSFZAKdyeN	359
16005	2vbtfdZvEf8HRZmQJnu7guEmfq2Sf2z96VqExhNKPNG9FmfhRZr6	359
16016	2vbeei4cBnKMhgfMwbocw1UBoNygAYkeAWKciPSojUQBFfFaqJwM	359
16018	2vbwFmNuiwSjry1uzB8ppUYDAkkqUx45U4gNX4LWAMN9oUNtHaqB	359
16021	2vbRGZuvAvYBCRQmean52j8pcq6W6RQ1uED4n7P5br3oPadiYBTQ	359
16025	2vbEnL4G5mNVJgNRk1MyDAgaVsJVAXcobgNC2kvQCgxrRmodR2NG	359
16026	2vac2zkiBNkci7QhdJ2KUwR71ZXzBic2rKooA8E9QxBqSLhwJvA3	359
16031	2vbLCw5f8Lx5Dt3YMF1H547PiSr37rz29Uxv7TXBsd6sFqbLcbfj	359
16032	2vaZaCGu1HsZdxnRnY2op8vin6jsqrp9e1ej4wQanXPEgJR4d9BS	359
16034	2vc1PBiHpxYkqDgCwpH5RvyHU3RMYXgifP3ahX7QisHmWK2o3pd5	359
16042	2vbDWLeNbGopd6GqWwu5uLVqv2xM8skQzSug2ue8KeuNB3L6m7PK	359
16047	2vbtSZzntUpqb5xQ9xYGQD3Kbuj9t68TgPX1S76seWms2ueLcyr7	359
16052	2vaSuRTNvRH8FfvpRba5CRB665dYPQ7b2dqF4U1AYehznzSbnCZS	359
16057	2vaJy5JXNbJkcBUj3phwMcpYcJwkbRG7uqpZjD2ZuBnsbrvRLQ5G	359
16059	2vbVGHSAuwznXom7TqLvr7dtedbfvAFEq3uMETBr24AoNZwQA53V	359
16060	2vaccMxLS9Ai6FUpMTnTSTZs4gMWABQ8i4jiKSbkuGzbkfGckBWL	359
16061	2vaYYnEHgQ3dxNFpguKvj229ZiFcvSWLxHNShcef3LdE4cCtV4Gv	359
16067	2varikVCgGToFnvNbUF26J9ySkzCNTFhAYrzDw8ny5e1MthDfmec	359
16072	2vaP491d6P4G59Pa86szKtuYW2o5zg8FJT3dKrVLEcCfM2CFwiN9	359
16074	2vaHAUUzREeoETJT59gkx5B7KN19jKDJzL2AjstxBHZPpJECxJp2	359
16078	2vaRU3xhRo6BqRDEtY6yK4kVZ2J9vgcq9qVS46o2WJ2ffTSLeCxk	359
16079	2vaJjd7UuEia8RSeqyKZPkWEvF2bLTcXkiqXFxgxWbDLMckBtmng	359
16088	2vbBHmpspAJt5pAq3UbdMQhML9kUAPFG6FvCfNwa3GVKDRPvwzj2	359
16091	2vbu3N8xCPUYLx1AWdv7Ks4ecwdNQgurYCyTmi4bKMx9BZkej7oQ	359
16094	2vauVqZ78upegcUjiRTsh4mBjnZmfkAtJ1gcsrZ5gfduvxANTrZm	359
15998	2vbXLkmYZbZz5ubiX5tBHQGdyAUnG47yfX1fxNrmkzVHwXcqWPb5	359
16001	2vaAXZi2CceKRpLduBz6aZQRBo49rNNgjbPQs1rNwP4dmBwqE1k1	359
16006	2vati8d5zvyHxKhUqdqtqW72T6FjEKVxLdQnUig32JaR59VpY2sv	359
16008	2vbwZoDU2Ti5wXz84qy3ToFymzxvhtmezkBjHNZ49maHh4FdpgXy	359
16009	2vaXkETGUqPbtUYYybi7ontKKDP9hwYEo4vehmSatWzqRq4CEvXM	359
16011	2vbnC1WG3GkHHPuE4ESuq7DTfaLNJu2JqHiA1LSpQg9PKYpju7sh	359
16017	2vbNCwoVfe7Q35LFvrtTVoeQrUXrKghx8mLSVHKQNBmafH1H1vJn	359
16019	2vbaTn9FQmsHtm1xKVb1YgHQdHLb5RcmHBm3hhGMz4Kp2BBpcvXe	359
16022	2vaaBK2Ch8Qcx16751PspzrASqH3uVgadaZuEaAK1Av3aYfgxKK9	359
16027	2vbGmbaZkKM4gtxEykZCygvQ4LvmqbNLFw3bgwxEK7VEWeroGKL9	359
16029	2vab9JdpNUxZLZz1SZ2gGmVkh9VvccCyMCpH3AQRc8mgPtw2Qtwn	359
16039	2vaLUoZGtRzb2Tj3P19gWST1Mx3Ynv82kXoAjfLVKSbGBdWXCKuk	359
16050	2vbyzi1EpDwiwMmJ6jAMGCuY6ph9D6QfGkv9Ke7WjV7ukAyhKNeL	359
16053	2vbnXGubi2uJqF1DPKBwtLoXUqFM8c4agCHSR2opQSiYeQ6s8YkS	359
16058	2vbLk7dJp4b2PNgy7DgvQu61AVabMaLbKAeczGu9nvSkgzdAYMzF	359
16062	2vb1i8NnjpToWT6iP6VvZ26Hi9dBymQU761b8BbFiM1HJbiLTFHy	359
16064	2vaNbvq8TywhfF6qSndPhgbTnEVxrNWFQhpNqJtsRTkamt29Z1Fx	359
16065	2vbiXerprgB6jTYvHky75hePKrXfXJQKtJcYXjdWmJgw6ntUXyZX	359
16070	2vb4bh7dMPRyRQi76jwwkyP5zoqW4rZUKgRB6CqPrHFRfqg7x1cX	359
16073	2vbXdYaHuc9J4dBt6WgkvzVzjxFqdWGXmBEGao96NomMUxDCtN1j	359
16075	2vbuyk1pM3DZFCQCGRnvuphP78cMNcadi1R83Anrq2VpFQCjqvTB	359
16082	2vbm99jfhEtdAkgPU2nP69dp2CHUKpQDFrRkT8QKZwYCUUL91Y5r	359
16086	2vc3fWcJyjQEMUtTQCVEGwSmhaKjP6kGgWEqRGPddVASKz8KVjLz	359
16089	2vaLs2kGmCV93caoYMop4wTz7NVvMFD491eZ2VCtbgHRjTAb3ZZL	359
16096	2vaFktyf5bffGv5nAmvks5mCyVjpN8KtNutTYYSmJwuLLnMSWHDB	359
16097	2vb5HbnBcDT6CW2RAieBAA89jSgDYyUffu5FsMoQNAMmn3bBEhag	359
16101	2vbYNdTNFGpiuQVixsVFmMuad66VThLoaB3bQkAuirFZ3M64hBoK	359
16103	2vaKDP2gnQPYSR59HVxRaNZHxxoG5Knf6CxtZ1D15KhGgWbxzWYk	359
16106	2vaKYGcjgR3AyNfQeMkK7HoVxwyu8Qxr5iqDgLtCBam23GHV7eZp	359
16110	2vacdpw4yH2tXwTKBJDoukQKQPLsumbubyNdD3DeSWKYXXgdj9Mh	359
16113	2vajBUW3QZjBYLCK2MJVquZP4XXQamykGanuddbpwAKEtKYp8uwH	359
16116	2vbbA43W5ppcuAsN8jsa9zCGBxN7AtESvLRE9GWENnSRi4piAcBa	359
16118	2vbtP9gKspyWD2TDWzes7A8zEc54Ra8WekFRrh2M1NSMBsfS7cqG	359
16124	2vauFDXfe9mcAGSWveDn2wfA3wf1r9V7VJahNTQ6EyeGzesTaJVa	359
16127	2vc2M1fp5DfDasfDnzjK8gV1HBuGLuSwYsRVBBfXiAnX1QMUMpYj	359
16129	2vb6c5jUUWEJustfGtJWHG1via8eq8kPguQmiLmyJG6HGjVi6Xxg	359
16132	2vaK2ofqNJ3ueYHQEFeQPppVoR8CzkwUzhNmwhxoZJ2Kc5nkWSUJ	359
16134	2vbDaKd3pHJKAX9JszKGqmCzj9aVuE8kCF7MxEefDzpZX1enB8xF	359
16137	2vbKmmqVUXYCpoidLqSS8XaGnEYxTeYkpqYuyWBdHct2gHMAqMK4	359
16142	2vawdr2d1MRUufvtScwEDZ4q4V3FeVzEirhZoa3jTzYxbiqsyX47	359
16146	2var488KhCQ8FGq56LJFgimpNbeFXh91dMXWq7jRbLQHLnE7Ut7o	359
16148	2vbyiw1p5JNhi1XrfykhZX5grUX47iZpB39NnXmcu5R68fh1Dtry	359
16153	2vaPTPGkFpc3dZtKSsQNYtGAB7u5wtYdCS3PoPrgWU61nwiPDc5R	359
16155	2vbqcHjUNK3TV5AdcRZbXtrYS3cPxWtbu9Q5okfweFRfPRRPwYqH	359
16157	2vbyfUPQL57NJbefp5toaXwzTYFLY2r3ZkzSmm82M8m4x6bkxvD3	359
16161	2vak43RsM8etsky3kA7eTpk4ia6zNLYr68rHFgtnmvtg7p5FapSt	359
16164	2vaKAh1XQNS2wDMYHwqWhmrntqLYGD4hJGkcSGX7yCHotMdnu5iV	359
16167	2vbpCQL6RvcjYRQa7RrytV79zfm4SkPvETrKLwF3HSsHcodxinnb	359
16169	2vbmnETDj3EvFwGw1iBcMid6Cbm6D7d5W5tf99TSX6dF1vPfuzTF	359
16172	2vaxwjUaSAVzbopeJSPVcR7BCfseAYw3LuuaWRdgjiPtBBJp6YqR	359
16177	2vaqqczTo5Bh98p72h2Nso6yK91e3sYQAhvkwN23rFjErhRRCZUr	359
16179	2vbGuSGhaj1MD8E1oUKFQFduTQpvLCvwzca4iiMA443xcCZpggZK	359
16182	2vbkp3BihWLknqHfBh92m1SWcR1uiLtRqKiv6AgYCWVZ2VutcSbZ	359
16186	2vbQ7HNeYNWExf92SVL1QiUvUSQYuSFN3AyLmE8QgQuGcXCndmg1	359
16188	2vaqzMJtQBHeTrHAwiXcuZST89mbYsdCY2CLj5xGj97fABFX1teH	359
16191	2vabUqxwmB2RJY2s5ohZCpqo4hk18s92RMNyoQtyDH7XGusJVE62	359
16193	2vaiDQqBgZeMREH474jS4zXNYsarmpsJRjvXiSR2ZEimgEb7U8Gh	359
16197	2vaHcSHvSrKRScQVBiCnMW8QkWRwLeY4EF2RLDEFjm67mvS5SDBG	359
16204	2vaFTJfmKMRC9JNAMwTarJqKHgqrj3iWwrFw2W9hRvqRHe5Nm3xv	359
16207	2vc3uTSxUbDix53acaFp8eNsXm896CiqMfuKfpXNbCRVmbcB2jZD	359
16209	2vbokDwK3RZi659gnjJ4TfhNGrk2VrWWLgr7Fr37WF1v3hw3UpaN	359
16214	2vbRKvSQXWRBFFB4JRDo7WMHgKyK6VEFTqrzfQFWTibV9x32W6kN	359
16217	2vbTEGs8akQGYZJcmHGtjiVimuS21JQEWvEeaajT7f8dguEHWHLz	359
16218	2vauQWrWwexhbUvvDKUtum2AGLA3XYGT5GMJa9SQ3VuWz4F1vuYG	359
16221	2vbHyyTvts25QPBHJZT1DFsg1YDRZtnRgRFFy2s4gtnDY28bKgnp	359
16224	2vbPSeSk2qvP3hgJRBj82Z3UVCk8Yh5S2TPXVK9kALZ1GWjjfai4	359
16227	2vbxWUKm4Spoqk563HMNNP17mEARSjrm6w8NJH5HEfrqbfAgPTKC	359
16228	2vbutUWLuN2QSADwTq34Qo9k59RAHwwQNx9EARcqeisEiGsnysEG	359
16229	2vbUW2FoRQLX2suwGThs3pMTTpryAT91Habxr9CirxvfA7RGZTFM	359
16235	2vaCv4SmWKSSyCLGazoHTNSUGPJBcPvyg4Y6EPoauqgEoa5cyTur	359
16240	2vaiyPJaEWfCmybZkdAPK74hiTvLSrfk9DvFcbY7kTXAx8q3aTpk	359
16241	2vbn9SHR68VUoiovtg5dt1pzQJPKNWHGRGw34okzs6rDzGkLib89	359
16243	2vb5vM1WM6kw9XfvsqHhQdpKCnNR6rk74oqJ22crFyZMKQn4h5Xh	359
16248	2vaDFJZ1v6Fnqx2k7ZAaWSJAnTbGxs4SwA5omVwmW4xsNWoizTdw	359
16258	2vb9YFjYbwagHqSkDUxZTvMMk3VhcJ8YxqYoK1VywpK9AJ14Gqah	359
16264	2vbVwYpwHuqSqcaYN3L2FP5ZSMqw3X1wkr6xHs3kKh6jUsVGu5zq	359
16269	2vaEZUibQkVsnW2iS6ReYPfieJMs7jCtXSZrHmwc4zy2dMsKgceM	359
16275	2vbD8VJQXiKbYA7CRMucsTkSLSV6xELdmGyiBhfnGwMNbcyxmBve	359
16279	2vb2P3gkismTkhiAoUrtE6YtQbfWW5qxqhUaDdr9DtK51veVY16T	359
16282	2vaEwkiCwvM3DrPnrcyKMJorxfwNjBbUzuSTPqcR46BHdV16KkYZ	359
16284	2vbtYHSnyuUrxfVjPqWdNCiTnUU5NVZejScneWrSCqi6MSreyuzN	359
16285	2vc5mwEzma8PhQa29HfFQUE7t5xNzSvErXgH2xZysGkjGk9d5pMs	359
16287	2vaeV5LHoZXJvMS3kfeGYY3qr6b8HcrERdstym8f2QjZKWmqbYc6	359
16288	2vaTKqSc6Cg3kkP7ZRDB6y5dosFj7qJLWDw3AYmghZAoEZM9JjgP	359
16293	2vaQ6yuWTrZZD5xciugFCRKbm2qu2H1jThiDwg5uk4L1irsJgKxk	359
16301	2vbBvcmVbEasCnyASQJTUN1o7Ufyz5pcgE9VK6CSVo5Yj3HpENxe	359
16304	2vbdXVhPBjat7iGJRNrGRAxPToUwDy9SBwn6EYievvi7x5HdKnDf	359
16307	2vaYN3SFXxaSX7KzLKhdudj5qJPJ124y6m4GP6z6scfFHc2Bjgzn	359
16020	2vc3QhVCLAGEy6UMhY319gVqAxmuafNgQTwMYLQNcCpLma6owr28	359
16023	2vaiW71sjhGjaxWcXFkqRkdaNgomsQUejuixjwafnG42icyXLnLQ	359
16028	2vak6wfo4cTLHvAS2dz2nmrLo5Gxbr1Nry3hQRUFheuaMJFXUSN9	359
16033	2vb8ZmUhefx9tvqVJcNjwaFRqFm2iBxzk9Txuc5YcqWAUQ5Z7gEY	359
16035	2vbyYRSzzz3VFWrgPzjzqdyXoXyWA871f2yvGBc7eunYcaMQ66b4	359
16037	2vbUcaapYwvMKXU5a38EayfBsZrMFBtZU96q2NmYYAJ6Siuzfh4U	359
16040	2vb5mGaMVpv5yJWr9i8bbfBD3cS1DecQyVJX7S97H2Jiv4XqQ2vV	359
16043	2vakbibGTs9eRmoLCkYBDNTb6CTb64P2cXAjhAckx1fLqocBkXxu	359
16045	2vaa1YVyz4Jaz7jwRVnUnqEcBo7dP4bL2etiSqGszRaJqtYT56Ep	359
16048	2vagSEt8N6prTWLptWUFbudzAtZRoYLdH7EzNYfWoyUqtPLqmgEW	359
16055	2vbyJ9EGMPf87rXfXoAx6ehcKAF3x1HERNqrXfxaYf7ZLXyzQeTM	359
16063	2vaankRABMsqpy2DX9Z2qT5TYezDxGGpFvGwn3orJuULu7RtV4qu	359
16066	2vc368SySc6cUXPR8rpQqBBZGWbSP65Udtp5GTvKto4LSvEKU6Vn	359
16068	2vbg9tsjrJs4fHx8ii3dMj3zwWEQzfWNhXocRUy18EPBzfjgWjwS	359
16071	2vc2PGHpm3ZNwYogDySGndC2PS7ymdAEeXBCZXFMS1JKqJmrbXZT	359
16076	2vashc63FovkpPZ2qhtJ6LAJao11keVauHMhAFbsWwqjoeNF4pts	359
16080	2vadmVsM1yXtfJVNdEwEChnoD5vRQBJSCVB6N4v5XYZNFQQEJVup	359
16083	2vaG5W4r291rgSFsrm3f3YxBeTCG7xdFs6eUoEVcLYmquNw6XN1u	359
16084	2vatet7vR69LWyWD5fyMRMG53JyVYEFpPN3MUZFx1F1GPNZxGCRV	359
16087	2vbWbExrontbEa7SMJJmJSD85XdHZYsrW6vBuJUx3qE2wycYFBap	359
16092	2vbLRgZBMVNmPyG8GphnjeWJPi5MYDpTtj9XmZGzMMvd5qyXDGr7	359
16107	2vb3n5zGAJ8L4RFzrRKxh3tQm4TzY1FxrEZomDpGhrFN1szEpPkH	359
16111	2vbNVX8MNeL6t4ci7y7QpU8Qf3QtMMpyK8hUQgQndtgtRW2FpSnf	359
16114	2vaSFygQbNScSLN87fFyU9sruhQUsiGrzYfizsWu7waycQJguFz9	359
16117	2vb7rHo6d4xgzB3Dhe838JQURXfNga69tmiXGVpuDBtBpw3EUb5s	359
16121	2vbLqDraBNVxnz5UG8mH4cUpJEiYhG7r1trqEu8bVtrcXj4ky1Zp	359
16125	2vbQx9kSHyG9XdKQyYmY8VEzBmJimva8oGuTnup25weKtGVruVuk	359
16130	2vbDiyk2USuvGsqxGLFHGnbJULVEdDbtGLeJhf3Ggm6CJHJJtG4C	359
16138	2vbwtDW8jkw5NPYhtffpJrqtdwMxzfScaGUAUMnVYHVbs3TkC5Qi	359
16140	2vaxxdxs1QaudtM1bwSSWifZfZ4C2eUfA461aPxEaN9HhStZhHNo	359
16143	2vb9ByWnMcpwfH3nQ8bNZYr6WMvzuud89tM18jMrCWgmgiEtyPdw	359
16147	2vaEYhyuQbQACmyfQXXGw9sqEj5eQp1zYKQSXDZ2sDExLJuWEt2f	359
16149	2vbwqCqfzoo8X1UMjU2igiFF8VNVH3L2QQfMhqJA85sjzUMeoxo5	359
16151	2vbWoR9RhiRQL5b3e32qErgKgXL1MCaVM41VJc22JCPyt5aW7BdC	359
16156	2vb99wMJoGZ2PN9qyfxsjzFqzeRRSKwFfhVfTzYvv9VGNqpFTVq4	359
16159	2vbcA7LxVrEDcrDjkjx6XjrwPf1fZGNSyq45nn85yxqnJs267UqW	359
16162	2vaG1LzFeMCFbXMBUZ1uN5UvCLtzpZ1pybSBXJT6pRyPP9hB4dqz	359
16165	2vbn8jupUUhasur5qr68eqJRWpFWSqpGfSuKnyzPRa4oKwc4SVZC	359
16178	2vaj9HJEW7bSUS9qUUobdoXM57QfRsRxPtJWmxe1KKKHbdgV6Xgo	359
16180	2vbSp2KvDCqSPaejYYk7WnCLBPcf2uWWWNNb5bJ5z3YKLQXPeRAa	359
16184	2vbmYRt2yxmfFbCCG7oSo2N3y7QpdTNL5vZNKHeseZZZBiFy7hQ3	359
16189	2vbXvmkiPeWHSU3xjYKMB8WXNNvtbm4ptUvdSTFnqxUYS7pPMw3A	359
16192	2vaKgwPcX73GYy357osrteTcq2i8cRfKtvNfZ4EUKhEkvJNp2T4t	359
16194	2vaqo42fCTM9VRG24WadgPH4pzj3ckwHhwVN7sFQmJZ6wuEVZeme	359
16205	2vaWyn7vMCS27unFH5F6Mw5pLZmj3bts3cYtS5htoNXY9JvdpTXa	359
16210	2vb7eUh6fk4ZcqBYzGdpveukoFEUp9iV5u36EWWqdvd8MyZeaVJi	359
16211	2vaNYJNqKb8Tz8BiKwQanzgD7BkzvB4rQKTTyWXVkxchyWFJ1juS	359
16215	2vaWbqKoo23qCt8xSxF6i3m4kN6tHvzSzFr3Khx8mHYhWFpTnGEM	359
16216	2vc4vqVW9E2JzRdMvT832c1TTBRsDF15pXicGGHvvp2YtjVDAgov	359
16219	2vahrRgh7ic2yFYTxktx9cwvrwKx6u79WzF8jAr7PJD11w1RXYhP	359
16230	2vbqBSQJKxCvDpb9c3P4PmqoYRYSrU4YeZBKQKt2qQjBJXpjiWQx	359
16233	2vaKpiupxBGTLDtKV6bWuRz1ytKAKmSiSwSZYTy5ve5yUKzfxhDk	359
16246	2vakjxQLA7fNPgR8ToPokwMKkFtrm1jwFbFZ7i4aW8W5Hyqw4faa	359
16251	2vbYSiUtse5y9SnxV9b7ssXy33N5Us6FsLNLNn6LbLYcAt2Jyk2z	359
16254	2vbnU1DrxHj6eDCMTRrRMeFVtiKzAQFBtXzkhvZ3WKPTK5APQivs	359
16256	2vbdjYmKcuQTLz7eNfdDycqubW7Uz3Ps668hkKTnGZrexcV2wobn	359
16261	2vbVzwuFzrbm8aCXeGSGX1pD7VKHY6NJ547USHtdNdmKHSqa6w6G	359
16267	2vaNKP4YWSPo29tttk2DCKtL2GKS8TZGAnUbXRHdaumncMGkt13E	359
16270	2vbyNWQG97BHvZor35GbhaSgbunA24HqGxfzATACQvPLSQPC1GfH	359
16277	2vaoVd14YF2dz1NJAkSDmt9DqywFfbgqqRMnSiMvCrm7Lj6FCv8E	359
16280	2vb1AgtZy6a2pQ67gqLi8MeSruvSBQZnr7dcyhNzJSpWVeoFRxi6	359
16286	2vc3VbW2RLp3Ceeecu81mVkzeM1Az3QR8Fycm854zvoPh5yrYPYi	359
16289	2vbpntUg15uFkyLg4oLkuL7cwEA1tmPAx7JNwcDCs6ehPQw4hddL	359
16295	2vbzkaEPfsp5Pf3VUnoQtPgs6Nh3YGUQGt8KXsyLgnfF6tuP6X9X	359
16302	2vbr2ShdXCdt4snRzTnBA3f8CAbBbKDnYeUSviVDBfQsn94C7ijx	359
16305	2vbwENSm4gZBTveJhssZ3BjfyPxdi7z1sdMWvXMa7sAG6jTEWa9j	359
16312	2vbzvXKCCCwWQdtK7jCz8QXnsFLyjRx6kM5hTP9Mv1QJ5LYPctmn	359
16320	2vbx5zKyW55yL5hgeiNwth2rRjdLhuczMKzmz1wTYS4fMcE1V5kx	359
16322	2vaztqDWd9ug16F9Bz2Fsz7zVV6fQpb1sPW9T99F2SUx7ZVYNxGz	359
16325	2vbcDhy1TjvhLAsEBY5SKrRhhe81KSQGACpUqHEcvMoD1T88ZSDq	359
16330	2vbCFt9aMrTKDRY2UNs5ti2okFLFCZTMSkkkZYnSY84Xd4HVsF2R	359
16334	2vbv1qeKsz4q5YueghtXiGRLok8JnquCuLpot5uN7RoU3BeJdQRf	359
16339	2vb6HrcwPMgowXsGYc5PGpLk7ZwdbYmNGUoDhudADBheA3yDHQLT	359
16348	2vb5zPUnNXxoCALtLLfaWgBk3wt3Z4MmxgwYHsdpPbzKas2DfV4d	359
16351	2vab5qJfDr8keRqAnEToNdDnYmZ7G3RfA5uxVphY1cgwT4MUdwUz	359
16353	2vbWDwjrEZjo2Jr1GtqwmB2LDh5jQNctxWtRJNXRvZYmZ44wAPZv	359
16356	2vasU73BMHjvz7f36NoWSEUyD4crHQqpTWp9uEARRQRVGKRw6nJx	359
16359	2vc145PAEh2A9NqBxbXQa1WkJt3Dsm45ZAUnC8sJszGbVkSt4jGT	359
16361	2vbatzZuPkuN5jfjug8NNkzJf365uPtnx31qXyi9fmdDk9osxazB	359
16366	2vc5qenV1Q8ZdbcHHSKjsAixsLmx3mdUKSj1tPx8z1zShwEDugEE	359
16370	2vac8CASBTdjMXDi3PjgGqnfV7cd3q4oa5t4oWfJ5Q8VukEJTzxe	359
16373	2vbEDwwNs3ZXsvrftQuGFexkY5Ai8qT62Fx6bckLRxKo8Vm48S6G	359
16376	2vbf2FArMTmaxevbPsB1CZyE7d1UfFCQwXLTffdW9sAjMDPac7bZ	359
16379	2vbehB8RhV9LDashSia629h7rG4ovca1ngRqspvPrtKGEZqRsSe6	359
16384	2vbbRqBv8GtMGpMazzs2Le9Pg3CcoSLghTQUarVKnj2mN143yHaz	359
16387	2vaPEvy4QsD3bXKyq4e2Dy7rh1Di45iXqGNAyFbHEaWELDK5eBFR	359
16390	2vbVqF5zEUURcHBo6QcoxDXYm6ywBgo7sYtsFNMhHqUbZM9YBVTF	359
16392	2vamLNgGBP6AhQ4wFFnkNbPfTwF56asr1WR5kwdUyonpBuWfxXYE	359
16093	2vaDS94b2qFq9G8PG4QvhZ2x5BAzKVD5pamnj7Usm3CY5yK4ds9S	359
16095	2vbutUaLsb2h9nNLUxCPrhZXHdyTE7wWcabVR8aVt5uGuNPQ1NoN	359
16098	2vb1MG7ABHXuHeZsZw1yDJsiDcDGTbQcSHKEZeRjASoh3YhFbwvF	359
16104	2vbAHGLMMgMiCFnzMccmXFVn3YoizvTcMSTVXWyncfqbV5uZyvx8	359
16108	2vbVdNQU2qxn6FfdFQSapD9nvz9k2Hc6BJZ1vBcKgNCLhW2nm3kk	359
16119	2vaEhsgdwzGxhVK4NBrA6qs2XSBtVte6Hj83QjufVBEKoFSyPnyx	359
16122	2vbjzQxxkYhTPQdEZK7FUPqdZDkwM6cE7AwmDHWAMeirNbLBxnSP	359
16126	2vbV8uW5nxPAvtqTkWxdNdLMrNPgLAdxX3ymmuwreUs7QoS3eoX3	359
16128	2vaW5ff9tdE49c2qmy1WY4bsWLUJXyDW7J9dnd5QtQUfwwPTfjhC	359
16135	2vafdxqt8tJMyNPqimj84FGY2fu2L3rBnxEcbsbfx6npr4T6Spva	359
16139	2vbtSefr1hfWfwSMpkszw62JbxjWuULn58uK3Mqb1B5SZ6uQad9w	359
16141	2va9YukxBbSQgYQ4ifJ79wJQx1VwDjY3mSJwYckJ8fA7CAnJA2yi	359
16144	2vbQDanmk1ZSMNEQTZizcitkEJdbqNpHfKtZtGojsbf3dJxa2ipk	359
16154	2vaqUzrBTAgxvraTdtWLZ69hZYAC21Eu6fxmzTwLbK3GwKByejTL	359
16163	2vav32JQtGGs1wu2PSKdWHgLWjiNSzvNi61y1CSkeJxSWBeBxvVn	359
16170	2vbGM3mnikYanEFhUSMwdeay88Ya39nQhMY8e9Bs8ZjoDSr9sKLH	359
16174	2vafucqoZ6y9WQKkTA1CqsFBgPgTvYk8sY9jqNwtaGJijSJbHGrR	359
16176	2vabHYfQxkbtP8f7vDN6yXwwad8HCE2E4f8eCSRj8bP2u7ScVY2g	359
16183	2vbtxuFKf98QWsuncQBM5WvKRCrafMdcLnZpcgYcAgbesT6smNLU	359
16185	2vbE2ciRremzKxWM8jz5WRf5qyR3ghPZ2GYxt8MdfJRgiU8BeejP	359
16187	2vaAFgAcsd8ocBdAshvDyekKjyHHeWCZa3XkyCBo6k9JEJh5Hh2V	359
16190	2vbWfQzpjnfaCKYqt5Ptw7ELbvwEvqFqg5ue9KuMza1fqPaT4PiQ	359
16195	2vaTESSVMLqUuvdcVwePfQH7eTg1TAtNDo6VsR7MSx84zWhRyLSb	359
16198	2vaG9LofUoCFKhqnS7db4MMgNaKWGraL3ZCaTZSp6zS3ypAjK3qe	359
16199	2vbe51E71m8EAvcFGQJ773Y212N8gXDv1E8rYFJETnds8EWZpSQ4	359
16201	2vbGjgVHjj8kgxcXbr4h25NtonKKgke7KzGGgSYjqcfMD8uh8aKz	359
16203	2vbsR5AarXQhkVGzvHBSk5XNDNZv5ivnLXyRafh1GgvEcrGtTSFn	359
16206	2vaqT3PoABwhw1buEH4Qkz57668DDKejCms2a691S1xn9KSnbso6	359
16212	2vbDGfQBqpvayN31AMuTiZuomVDZiZmEiggNi4WeYjFEpN9qdNJy	359
16220	2vbE1wy4cecFwGrKYM3eZ7b85rA3hmYfW9zUrfaKedWd6cGv9dug	359
16222	2vbkJZT4yVBQw9ssKJ6iistv2PKAdCHsTUkbyMk5HExbp5vs52Tf	359
16225	2vbcfwEQRTBK23JnKdfbj2Hw3uLRT5jaUyq8MtiZTxybfG5dEahW	359
16232	2vai7g8py4LVAhQDZQhAzYTMDocnFGKV3DsLgwzqP5arRKswj2zi	359
16234	2vaw8phUHo5gmG21mHqou3cX5mKPU8mTb2jUFzCbWiREAAvDzPTk	359
16238	2vc1V5dC3KVJSzTXZYiZYG3LUKFzdXPn8oxMQNtAA9kSogPwARj1	359
16245	2vaj1TEtzBXCvYfvADpJUh1ybo3fDaGRMuLyAg5gX7Xy1MiGwP91	359
16250	2vbfa78d8fY2Q9gTTYocoaoMQhT1cncPDgSSCx7AEGHV4mWuWe5i	359
16253	2vbm8Jy2amsG7S9Es8hEtQrr5TiJ9S4CWyQ9hn4PGkij2YVxLxMf	359
16260	2vamjUUCfRtRfB4dVWs434N7ounV416Q7cCjSzUp4WyGrjVc9LsH	359
16262	2vaWxPZuuyfZ8UjvAJUzgsqVxgDvLS45kQdfyPw6yYPBnAvUBndX	359
16263	2vb12f6WPtRbrdEvmGiW63hEidwtJvArVjwtAMCD7eksPQCbGdV3	359
16266	2vanFiah5yKCUyaFxTsnrLWC5Rb69rMoSLMqe3VxNFPELjeRkeAW	359
16272	2vaJ6dRi4ZpJEj6dsXSSr3HApemxEgFd8x74WWGpiQr9aVMu4zYQ	359
16274	2vaeVeAZxE9Lhfe4V8ZGoPhFBGEWksnfru5x2QazYfJwyCHJiPSS	359
16276	2vbCcGiAjn4JwLLHR4G9NCN6i4GuirtkYw8wyF9Z6Y9EAVdsSFbQ	359
16281	2vbcSyjFTsdAoXCPUXGJzqTvQDLccBKTaSdLjBvw3tD2qim4fSGm	359
16283	2vaJRWuAP4MgUcJUwJBhNk5mK8uGcUr93kW7bzNw1xUNRv712DTj	359
16291	2vb33mfRt8rHGZX2bccQSTzs238doYyLp9wERnwdck91hJACbcRd	359
16292	2vbcKq2MnQnfsim4sTP29CrbfmM66J1Y5kJbj2MgpKCJuPgsw2fu	359
16294	2vbFVj38uiGwVJHa8kLPR3FFKiEaZAbawaAyQJDm7cAL8fwatYhA	359
16297	2vaw5TCaTbQAaGf8Qg7DJqNadc7Exv3vF4EbJvzFyzwdsgvaWj2v	359
16299	2vbQSBiUfpv27tyKo9zsB19CXD287MoDrYRengJY3xFcwSNh9xb7	359
16306	2vb67x3JhoFCXRDAt8qd3ATutErdUmHQBn7NCxxPgwC54ZYS5ELZ	359
16308	2vaTShBe9TVSNYnYbt7DRJtPqB69Ky9kz89vGjVQzFzQWmVmFCu3	359
16311	2vbDjZoWyHpXrVviLkEVi3UkTXc6BzssDvhmU8rqdr7GmHvwJvCs	359
16313	2vc1utt6iwvJSpTYJFwvFeBpEtqv5grwK4AS4f5iTKmjy4RHEcKZ	359
16316	2vbe4262NK1rghdbbQACZsMctd8fzRh8q1YMCv9PR5WdAyTturpB	359
16321	2vaY8xFkQUbBWwW3DYj8CLPM3372DW6FYaJ3k2Vm9gASCuuRq8HA	359
16324	2vbVofTtWHYWjGRUoRWfobp7nfrdpycAXPHBTqpfmn1RWG4M8aLG	359
16327	2vaVH6poPohoPA9updGPDBN7wVAYkxbqGpi2i3ZrbZ5bFV3KEeHf	359
16332	2vavLXiZPpXMhTH8zSUsTLdAbhPHEAd5ZtaT991ZW5a7EE6udbVB	359
16336	2vaC6Em36cvSG3KZHJQUpNJPC5Q8P2isU4GmP9rTErr1UZ8eDuhY	359
16340	2vbJmvBGEkFRb2QHQPgJaxv8nFipXBeUVZ6TaVWyuMq7DHBUHpCv	359
16343	2vbm1CTZ1mGsSsMURPZ4LTHVALw21j5ET6M2xkNze9NmPPh8D7NE	359
16345	2vbfuoxj6FJfqqzJCfLWsCjDfkmYZtLqGC3DWSLB4g8yNcqsTSso	359
16347	2vahw58NPtdC41gLrXL2cvWfTYe9SdUShKRmxofgP19DENVqTyhH	359
16350	2vbEvRLa3WLib6U7mMRoZGVNmnAFgiAQW9s5xm46xUr2BKRmEFTH	359
16352	2vayyQcj1hW5ou8iRQkjH2xwQ6jadSrqd3cmyzGiWC2kg9LPcSKc	359
16357	2vbHWrsr4idjK3CWspwUNufK9RPu3L3vP5CtQ9BASZXYQkZrvhWz	359
16365	2vaLdoCdns2byjwJGj4nsxpnnVxbHK7wxCGsdNnZULQgvkr8QyNk	359
16368	2vb3G5ELT6rMVtTvfHgSPmdX27pUciXoH8Z5NHPkfipfn9LmTG95	359
16371	2vbeV9GnyR6ntstfhNfax9SxpqdA8bKqok9RzSMufU2CoeMD3jqm	359
16375	2vb4j2mTNBNAwVfK97jy9ecgZiQiWJ9bnWoibADQbmFG66jTq7LY	359
16380	2vahkTeKWainRf4mSpxxDgnR1EN8MAFzuV2aqKUmovQoMT1MyDxH	359
16382	2vb5Mm5u2sNvUvdojM17zGHaRsyP69dPBfezAxH9qGzck59i8Pjj	359
16386	2vbM3sVbiE4kdEo1qSAPchXuyVTXW9teUCniUBy9hcVotodKM5dD	359
16389	2vbNW7hM2qEjHTxe34zix9uRmeTm3dCKCNAik7byUZMQ3RrTcG6w	359
16393	2vbyefdecHAQmfH8E1QfWyrZXA5BhTUu8k4KmhTT4AwhzhsMiEGD	359
16395	2vbss8pDqGgcnRPVgdrzK9TkE57aSYZFctdpiDReDshuhMNvdwgD	359
16397	2vbtgea2pLq6cJspXywaTebikvhtRUbXncXmeqZc4ti4ZaR1bbKA	359
16400	2vaPndq7yGMN3WofuGxBFo7hxJrgfVmB9w2C84hCPdxNpMfywVGF	359
16402	2vaNVT9h9UGvQHeDdC5LE5Vd5qpK3ypY7JYKLoKyjkwf12diMW2m	359
16408	2vasvLYYBUhGTrjenNk6AANRvxfSwDLTuFHRLgax4abmEk3aSmn4	359
16412	2vbyysKiwwrRnEQv6jM7nnpLtyymxPecTiceKyDc19bQwaVT5aC8	359
16414	2vaHiGZqw5KSpo6BDKkucZj5iebSrFohKste6gD3wZuWj1QEa1e8	359
16415	2vbQXuzMF1Jt633WyG4DMcMZxbCQUpePHxLeL7XSdBdhb44Hsb7A	359
16418	2vbaAfm4j4WvCsrkbJa5XiUSakUiKZdHstDAkDQwt8GdcqQy7eHZ	359
16421	2vbakMPD7k54wYh4TdBovXudGaSGdevB8wZsd1bPhwtyup91PTvG	359
16099	2vb1bhSiTwPiUaW1rLWqEYxzs6bq6ahP99jkSZBQkSGfZrQHwTrB	359
16100	2vaDTXCETACrE5sy8TojyU5fKTL9cWc75Ns65in3RvwDCgnNAaYp	359
16102	2vacYqXaptjQbLjkASMYqcLxcBYJ9haHKeQpCoWYukWHaQXdz4RF	359
16105	2vanowg4zmKkR5unDeEEgrioeaEzr8978rPPLJk3uWWJjXEEX4uH	359
16109	2vbggMY4ubWAFRdiu8miXngXYaWwKX1Zs21XBPgwh37W6b7h7n9e	359
16112	2vbU2mn6zpy5CnAfajv9UCpJYU4vZMXMXGjqY7AnA8Ztk6qKGi7t	359
16115	2vajKwMCy4qCRxNtS9UNBSstajk1yr2hHgs7LxcyBMCXaDYJz7Wr	359
16120	2vbWoYBiHqt7WcPcNho3vBARbMpAqnGkRA1CmzJafAbWpQEBi2if	359
16123	2vasWJLALhQa6F1W8E9xESLXNV18qV17kB9bpvUmXJEaAQctxYTb	359
16131	2vbApNYksGhCoG7DBStLVusakdvzCT2Yc8u4ffHSdCt7qZ44ffAA	359
16133	2vaBokMz2cDRwoXv8dsXxNcMdFntBGiH8dKcAz9kq9hdg6LxPdds	359
16136	2vajTQmdFCdQrXFXtmzfWmMCmjpaip5pF68Vy533iz41K6FSVjqy	359
16145	2vboV8mJdcRNAHMrnAqLTKfFZvN4rpkR8JsH5PPFEWDjuaJi4D2Y	359
16150	2vaz4XYuqqCWHTguWmSBs96bTsjZzQ343P7TcNk9SdNzreVWVAQu	359
16152	2vayo5nc8aA8xj1m5ER2SyerstMCwm53sFDkJVpWQF6KkinoMfs2	359
16158	2vbHKkWggd1PeG2SFwbp176aursKcAYzhd2LTJV3A1ESoDDE55Ck	359
16160	2vaLsnyHHLfG3ZwtmjGGqwk89uXR5MZ5Ds2ScmKp2RBRwDPhcu1Z	359
16166	2vaqTfcK9PqHJWeSkYNyw3zucRkFrMK8QMApCxKommuTpAniQtU6	359
16168	2vbyLvRyg4e5d4bLWvAPpHXw5QjW743sU78WVfZgcBhWr7jRsims	359
16171	2vaTvCfboDZw4KuvDnJJX87dEx1VGLLQab445N38ZKLoyQFeaSEa	359
16173	2vaz8s8CV5VexibqwpMSwUHNo9Gm16CXKxazFWywBMmCCiaF9ewB	359
16175	2vbgH61n9TUf5Hag3ZAbCnDZPaEWaRaCdXjpeEQ5NxDR5CDoZXgz	359
16181	2vbXaGSFRUNPV4mxyxhYTBczVNEdMucRduStfMNxDqnaGnsQLnXq	359
16196	2vauTQSvJvGDjBGUjZ46r1SiLvrVomLpTt1DCHXv6e1Za7AdVYDp	359
16200	2vc4uVFpjmch7EQYuLC5VaGUgbgubtxE6jM66HDwg42Pn8jvAnRR	359
16202	2vaJ1zKF5dWtws99VkY3UsGu1tqbvEM6NFHa8VNdTWUsBGe5pu8Y	359
16208	2vc1Y3PjzKZj7PHuRBHJ216ZJicPR8cgkNw78stBokvL4w99VJGC	359
16213	2vbrmAuvpwS8syNEZFLXexzQ9ZpuTYoB9fde4ccSqCJoB5gDCyXd	359
16223	2vbx41WUvVP8Q7S4NXJTh5g7GSF87AGxdr7BgPLL5uiYifY9EbfB	359
16226	2vb2pTpeKSknc8APDZ3ufKDMGmeCNWhipeXaYwKLFowtofgw9wmS	359
16231	2vbu2o5nSpUBJCRT5r1jLKB98jVZtqHcXkMeac74zLHsk4Xah3Yp	359
16236	2vajCsd85kuPENU8zhcPRyXm4bwx6y7ruqbinSkabqSspcUqcRz3	359
16237	2vc4Uvn7LMrHov4CCMc1FUfchpPDT3ntwLce3aHXQ5BvxR7u4oZk	359
16239	2vaFYrzySVfrzSYynKPJKSJ4aQ8sGXn69feYyocbZj7CfN3Mujuw	359
16242	2vbeTYxJfdnYrPDa5tsGvCaHByDJktyhLkHJMhpBvJbfoxbZwPWH	359
16244	2vbb14ZwUHzvw9nLUvEeD7hQYv82nAuzj5qTXvBNgNqWuKWuLViF	359
16247	2vbL35UWMSUohrJpQJdog5KDaezYu9v6Bhme7femkLZGFyxDG2Hr	359
16249	2vaggT8rUsYAvAvj28ZeMBFb8SCaV9cQ6EDqGjvmxjeMRAzePVHq	359
16252	2vbiLWBcT6TbzzWD8egMeprQWBkfpLQEr7CskwDGU952CCFDVuVj	359
16255	2vaHCWiFaBXxLJ4vRe8b2eS6CTZ8W94ktut4r5sHq8Tdpbx7yYyC	359
16257	2vbBWvWTcZwmm7GwvZ2aieBqQt78Fyaf4dY3s7Q8rYZpew5v9vDp	359
16259	2vbr6AR8yQiARGKFHhJwErxW7TsPMkcLDcB79r2rQpxtsCUn2s6s	359
16265	2vaYCVXT9pdq2UhMUjATywxY9fLaRN5Q8LERLF5B58dKDMhv4MkX	359
16268	2vbLavZkFgemHsmhhwA4Q3Vp3ememRYyvSW31FD75VE5jbigWEsP	359
16271	2vaSuSw5FizmucFxbPzRxBm79CKKpqwRNfAPspxTPYV3ZCUHUTNj	359
16273	2vbMBEZmr8L8pi9a6eF3x4UzDdzznSBSKRbf1v4jWhkxrvWqkH5W	359
16278	2vbykp1iwZdUmkR9ifLC8Jg5X7jAUUpsNBAG3PBN2Eh5mmCBnEGT	359
16290	2vbHP8iqnEEds77t3xe1akVzWR2tbdYFkCeejsWSjBN1UMKEDddY	359
16296	2vap8VecDcig1rtyUz69jKjfXjUVZDdw1oR9WaG5ZFsFvww1cSrY	359
16298	2vaWCTTMpLjhtuwCPsoYbfSEV9agzEpSdWenNfZFDVqBLw7u5yZq	359
16300	2vaDsjhc9tuN7a72qBq7VitDBhCPHVjgdCgFL1JLfAib1127Nyud	359
16303	2vaFVrNphJiEsVwng1YGW1t5cVEin4VF2gyogmZ3b6G4QV55hJZz	359
16310	2vbVfBAGN1dim5tdNNh6bfuAmpvSnnUygjhm5FSRYGFzp85YKQcS	359
16315	2vakrkBT4bQgUsNmw7VCgCuZdJGDTwbnecmQzhYFgHXSg7yYz5di	359
16318	2vbbb9SkqEHWsnUJPt24y9MDrF3Yyzx9kNZ973hnRUbzbaJQ7Wen	359
16323	2vbQPDtNVyquKEqHbGtxwgLWdULzEXzGGoK4N8fCQS48d42vRqzz	359
16326	2vabUk4cuwmWdZ6YwhAhmoDDWyKLeH1Kwh9gVwwmiiTKpZTZEqUw	359
16331	2vasaZx8AoVwFf2Bb7xK9Yx1EyDNCqN8qt3YoRiitzUUPr2HQkMD	359
16335	2vbSKPRx1XSShysKLYX4RuVDkGtJp2bV18D2SN4XTqRuJmRw8paU	359
16337	2vachJ5DYrMbtKDw8hCNtwvyQKLBEPwvm3egEezwhB88a9D5RVUg	359
16342	2vbHZfuWhTWdz2hkgF7S5otxSmQXVpDHF91xLtd2uArnZynACYfL	359
16344	2vakrTPV9JB9n4wp2hvmCi5jn2wSNPVQLwsXPimLmZroTJcsKSTV	359
16349	2vbbKSJ7a7CDEsHMT6S6nFiaFaxeAjV5NLhCzU6AuhnvDNwSfG6V	359
16354	2vaLMJr1EmaNnApPmJzN6U5y9a45iH5QUEshBKwxp23usgQcpps7	359
16363	2vaZMagQbPMMaw1aDpYwSGJpmBnW45AdXW7jgvh5RGcFtJXdzEwi	359
16364	2vbfCxySFjP2Es16LozRjn6c1fxu2fYwmRVzHWdm2NgzwWywrFpw	359
16367	2vbXKmYGjuYuDZcKFD2uLrF354SzpCVUhWxsXrZHvWYp2icKEtfE	359
16374	2vbPt9pDh4ZaUkJnBthy86jiJVJGbR3i98CdmvNkVnW6WpRs3szi	359
16377	2vb4DePCqpqPqwgsfaQDak1sGduAqsY2VPUXF9v5zA6xs1UAi5fQ	359
16385	2vbVU2cfCrST8t63Goz3YMzyLGxcbEZtdsV7WMHeaeEyiuuLaQvr	359
16388	2vbS8XEPXPG3fDVEgcyUsWebtHMvhQWovUTKpgaWz8vPJRUWjhzn	359
16391	2vaU5hfJPTu46xJbdTRPDuCEWPnhgztocdqGMXdbCuCzJJ3AmiY3	359
16399	2vaRek6LKWc2vvRCvz4Kw3xw4Z6iTPiXqhDXzBVKqfjXQcTEYhtb	359
16404	2vaj4QTc4mZLKbcFhCTvn91D3n15yxGebZa4ohzJXdcseYh43ELh	359
16407	2vay3nbjaSjrSEMuebtz1jcK1apyPdZwGk82jZtfDq8vcMWj4f5v	359
16417	2vbNn3dxWMu84bkokGp8qBydmZvhfdnMVzKGeCA4WS5q7QDNDySu	359
16420	2vbe48QxUgP4HkQbMGVfseC3oq7XKy8mJ27Fv9BJxg4RhSuvBGg5	359
16424	2vbrWyk8TBnHM6vE5aMUnthJttNnMD6kSxCecG1iZM6xaB9Dkj1J	359
16430	2vaXmFGoH6GTGfzQzyXHc8KuRHRUsjSfMRbUA3WN42Z7mmcTNXqT	359
16436	2vbQYvKsudcHeC4hsH8MXUyYa7mUuBgkYnyi1ghHHQ5BQV1kmY2p	359
16437	2vaoRK56gBwmRCh2Lzy3XAnMwSrCDEpXyQiQh8G4wTsFWaFDzYAA	359
16444	2vbEHVqRakhcptcP859qPy57manLhsSJqKL8xTGu9Cc6aLJgxWhM	359
16447	2vbTDyTP3A5uLTLhqKERReipLAhLtrcpWuurV44FnxQ7TUdUdW7D	359
16451	2vaJM9CWkLDDRpEiy1fbSJZYbwtDXLrD4UuMmdewE82NxqhfVypC	359
16455	2vbD3wguA7DAsAMfjuUBxfBjmAMVBtfT3Y8tDz1UZ85J69wa735t	359
16459	2vbXDgaJehd5LG7ojdjvNCyrCQ3BkEJP6tB6v25qFnaWAA3PyWmD	359
16462	2vaSzoqkHtTzHke7qQHJ7U2PSoYLPESdBeTQMrdV4Nv7dQeVNVUt	359
16466	2vanbGdnCi3eSgnHwBiaMyUNQCHu3CDKYxYNLSvZaovmndyrSLav	359
16309	2vapHh3cLZqnZ9w83PWKKDM8W55pYgiHeMGxAH98c8TTJ7B8k5DZ	359
16314	2vbJDPxZUggcBSGpgVJvzgWjN7KdsZkePqWzcTrzqnCnv3Duizkg	359
16317	2vbFwd2wSrGv1AbYyYkMc1RhJbSsdYDytwCkhdSeq2CNA1Teph5c	359
16319	2vaQyiYsMFLPVk2S2m369NvjjaqERWyKMyU3gPqU96EzRdGuRZx3	359
16328	2vbb1EuWXxPUDrTHecwvz1ee2irUoDB6hguMTF2PF3FFE1EmA6jc	359
16329	2vb89kz3KJf5V3YdWtZx6JUqdMfcziL5Jm8Y6caLvusKgXYsZrho	359
16333	2vajL9ZBmsFmDWW8woEMyDXu6MA6z2zspxGxMKqeEjRfbkBfQXSp	359
16338	2vbuma8kbuRKKwCrD1rMEUibK3yUKDkukUxq7WHvTSULoNbxp3ZA	359
16341	2vb673kgU78Sh2EQ7PYcCT1ikdCBJkSt6tYoVVkco2NNcWPr9vuP	359
16346	2vbhh6KWx2GcBsFSgzz58jQKgngcjvganG49RdhQvwDDa5TVpxNh	359
16355	2vah6zBkV4HWek1z3BqTdymQmWEdg552qccAYEntWJCQCvA1QWFJ	359
16358	2vbfTCmMvSCANcXYDfgyVPgsnDGj94i5VRUagBHpPT8EDPPubfN2	359
16360	2vaRNccZvr85Bu8yVqjoFdnc5X2h3nmP11nerdYA1enPDWbHd1AJ	359
16362	2vc41eWzbdv69JmSvywBaLSuhu6bUWCvW2byWwhGFaTk7hYubfgr	359
16369	2vbNLrTaDfHU9A65N1m2DxFKCcqk8RLmTTpzU3JjSdtJ3GmV2Rvx	359
16372	2vafRhLXu3NP3XLxzuoySz5kGaebF12chbMLfmusGEsGyY44x1xj	359
16378	2vaVzRgfzRfE5nTWKjq6E7zof5LqpErvJ8ixyd7dk2ZrgHaxLdD9	359
16381	2vaGfm2eYeFkhTNrybCTpGpBBgUYCHqjjLL49pjDoXnqPkfjS45t	359
16383	2vbhrjDNUxfvrR4ewZRDc61ZfFXCQap9UR6RjxE7ZjDjqiNCYHut	359
16394	2vb4YcKeVrQayfE7KzDJwubKzFurb4VC9yTs9ha8yA2onoikdZtU	359
16396	2vauiCRBrwaWtjS5fJvfV7bjLvuGvBsYQW7qPqpiYU2bWZt87dZ9	359
16398	2vbQtTedZps7TuXYRteXT33fDtdetkMGPrFZY5NAupzFBW18sH7y	359
16403	2vbHdNYUvXRtYGkb1KhEgZWqMt4oygEgUpKVHCJyyNMzDcLTM5DD	359
16405	2vbM4JkCVynjzx1aKkBrtZn8jTh28B1Yv7ouPCVcsyHxWHXDZaxR	359
16410	2vbbKBwwqrbKnJ3VtT3N5th9Gi3WT9JM3c5aXCBzfw9X2SxkSuan	359
16413	2varMGnZcrHZWsEKk8bjaYHrKSLiwgAbVP9y2JYu699ZMc3sK6MW	359
16419	2vbWbBYGdBpVxa9jUda7R6roiwdfiLhFLhiq7fxWRK2jJpopQwbb	359
16422	2vbifyYZT6MFaCBCXGvswXv1x3eevhgrVFCRRTUA3ePJDg6oATRs	359
16432	2vbqyhsNQfN28eVL1SNWAUemBJi3ABDnkwctZo8qr6FhVQzEEyeS	359
16439	2vb7PHZMRbjHbhCJyxXRMiaJGbmaG7B24AzG6p6p3j2qx1q112bg	359
16445	2vbAVJV2HaD3yNLpir8QP7fXXUukJGgeXKTRSZCpnY9bmrGxZ1uj	359
16449	2vaRC6KPYUUAbzu18LRmus8kCtk1DYxzox9rCa7kasxfCssUAw4v	359
16452	2vaiQoRzcXVL37E2XwB3FpZg9ov2jYeF1NdsnUcaTeSsU2FjE6N5	359
16454	2vbLRutuJ8Qa8f5kFLXvGPNcGwAiWTVWU3gTNVBE4XXZBJdmzxqD	359
16458	2vbDQFPCTM6c5HarkUpztSGF1khbB3EbmM97ir88wEanyVNirsq5	359
16464	2vbJM2MJK4HWJRec6KxRvHtkJc9hX8eP9E2sCi7KNizj7Xt29pXN	359
16467	2vadA3vTnWky4JNBfC8utabowc6fAqNncSrGJQ2u4nGo1rBWttwd	359
16468	2vaJ96jE9b3HRWTeG11w3QJzcKc7YwqSnJx8cnqN9hG9HwSSwuT4	359
16470	2vaQrCG7sAn6tm8bibEay1iyTPdhuwFHuLhbkPPVxqEigmbUdbux	359
16472	2vbvZ3Txz9L1aDk6cPs22AKwPcygkaJfdSKbLBAK85FJYLZqMmh1	359
16474	2vaG7TZPueHZNG21XUgtTCiDtGi3WJasPT9PSiBaApMw82kkdvtr	359
16475	2vb1QjeZorbWztyjRsffJyBCCJcD9uiAKzSB4qReEACRoZU6o31Y	359
16479	2vakVzaon8arWGGbLE7tftRSDKZydZJz6aXDXgxb46v289eiq8Ju	359
16485	2vbQFzycoCYfkSBPxztbLysbzPWiK9HZ4VdsSHRJxiz82FqnG2JL	359
16487	2varuYSSGEsAxA5UuB92MoCg9PxgQSADCjopm8zJExs4Z63VpUQx	359
16489	2vaSV4iU2zExJs4BnFgGBNBFNHKd9uCnxs4sv7wUrU9JcXkp1Hiv	359
16491	2vabD7w6SuHf2PELbveXPuGP7uJj6Uj9Cbngba6dbLv3bDLDNc2Q	359
16499	2vbXtEtH4anVeLXzNmt6MPt2LoF6MWpehMcGqanv3riG3WqMEDjQ	359
16517	2vawLxiC7pu9iS6DJnsRwgb2gBsN8KXEaaiH5jK6GqzMd9vZPH1R	359
16521	2vbsQtjkhCagNbXQrh7MxtoiWaT1xEWH8Q2F7qnVxkzWFeeEZfk5	359
16524	2vb3SFEQ9smkvZqioJiPLGf7PfRf75bFFB9MnWx9RXqYG4eEs5Wj	359
16528	2vc2kppimtiy3kjsxU4Q7Mhhge2d42P7tW1SsVpZ5FsdXeeBP2Qs	359
16542	2vbJW3xQMDSFmWv1rs2KQSn1HpNRczYYcrdo4SknfNjuDNpVMz4K	359
16546	2vbCkxrDvriubF31KboSHBgmxXGTiiJGmEUsCbdnWqLBbHRdAJ3i	359
16551	2vbbEcA88QHjcXVTT1Tnj9T5FsXwAjgGTbkXFMqMFcwenwqkNgXc	359
16556	2vbx4gGuCWasTgMfbugoYCnkTEhzwyWxc2cr7j2kXY2Rf1tj152Q	359
16558	2vaVYfJAHbKvRBnb5USoQLvVSaJZs9n8heMacyJi2L9w4iL5wgbx	359
16565	2vb5ijTBPxiWtv8ofUGi9KntuU26ueHK1ttg52MddqoprWvvZebc	359
16567	2vberf8g5xVkfaQidT73UdNtbxyoh2rMAr32aoK6YiqyMeFkY846	359
16572	2vbHxV9W9h44CcbeFHAnXbk7t6C4WdeeDuNoo8rBqNcXKwcRxzza	359
16574	2vbqE9TB6ZW63MkoTyd5MMaJo2De8PS3zw4Rp9yRbwPtkNwtJ6mH	359
16584	2vamdzJvNUYSGE9sENc5QtyKAKNMMiUSg6okcX8iktAqKV4aWpZC	359
16588	2varjmrSUCLRkuxekZkpisYNuZCdDh3HxP3ga4WBqcqZJDXNV4Uv	359
16590	2vbA7nnBX5tWh9ZjE1wy8z7YPJa3mpkj82PsCLtNjVHnjgjhGXNK	359
16592	2vbGNigf41s7ry5AEd2tw5N9K63KWtxrx5Dm4vYQV3hB19nJbJ6G	359
16594	2vaGaJ7n2yiraLbP57wHciGEmBULgFw4ip9SjSuAJgBtpeXQdSoE	359
16597	2vag8Pa8NnMQZrZyff8hCfz74CKq4Wdv6VVfM3YSVRvUtApeeewk	359
16600	2vaQ6BNwi8JaTR94Xn58ByFVtDQgdKtPiLVDy5Xx2i9oEK6eHM2h	359
16602	2vbh4gjBSyHBGgA6ZKU5Qe27FkTWWj5kSnnyGz1yAF3nd3QPvxET	359
16604	2vbbrDctu9VKFBRptTRKG4MT6cueRRUA6QD286uo9gDmnK1zHy8S	359
16609	2vaPicQz2huEcN2gmHPhoqwc3zynRER9jYrMuVw8ky1PdBVoMG6E	359
16620	2vaonstJaoWkUJERH9VrCBGXUsHcJaaQutJQCAUKY93fLBkixk2R	359
16623	2vc288DkvUcrchNAc2kT1vQQ9P24FVDApcTMaiyKQfNAvn24Lwrz	359
16626	2vbjh1NXsMyLwtAS5C7r1veULYNkuGTzS8Y1KQNedWXeugmTb1TJ	359
16628	2vaHcXVYA96cACbgFxprAkDyxmLmkw2f8irq1yxfiPtf7z2epUad	359
16631	2vaJLc2oEVyUJeRB2mjBrHAvyEh7yW6Lhha2aQsNjTqMs2CNHxG3	359
16634	2vad6jWGdv93gP3KfNfEPeLSwfgCjfAtWpKoLK7NxtsUgBBRqYdB	359
16637	2vamTL5g9ve33uvd4p5HBEUQnLHjPnTxCksK9BhUMUADEFCMmm2m	359
16640	2vaHgJMfQRyMCgUD6rQp3nJuBz68EX8e8kKfPcWTPitiejmgyct2	359
16646	2vbGdEfVEfNx3uw1q5h69DgT2EUiaC8Q8h4fU6uxJND7oPT4PvU7	359
16662	2vagCNEN96jwywoZe1q9cajAPzdpT7SXwbbgkJCLk5WVGrUifQnh	359
16664	2vaMhzpLzLKyLaD26vazVfjeYBJMVrWdXYQv9192ynys8f2xPP4W	359
16666	2vbRMhUKkoRQZ16ax1V8vPivgcwDF4xzV3FEY3F6kMFA2yYu7FU2	359
16669	2vbhPdhM6mXaKgf4KNc9gcMG77w27JLLFsCqdNEb7XoxY5uuUNQd	359
16674	2vaCHZx2cBhyuTcjWCFPa8FPtXVL1om9mbhu9gexYV8aeuUdrwkC	359
16684	2vbMWbPYshtYGDYRCv4iZmTgfp3tgJLD9Q5tndVMAogGo6bCPcHB	359
16687	2vaDh6rM4k6auwE2UM39uYHyuuTpb3gDEWNRTDER8ozdsocE5Uod	359
16688	2vaw3y3gYrLUkporXvVYAFKsrUjGjN8gm5g8VVihE2CWMQERfH71	359
16401	2vbdJAvYvjsA9N6hA1Luj43hgN5YfbyX4JtrRQiNqdxn646aWPoY	359
16406	2vbatLv8uMJxapudPYL68VdwN1aC1MWwSGBw5ccv4bZ6fhWdnWU6	359
16409	2vbPfqeMpnCTS2qNStTP9PzW7w2Z5VqdSMniCKo5nNVdrpXdJZ8B	359
16411	2vbJNfeqv9A8XGStNnuinsDRHWHYebFis9XCYZEN81ARPgDEQeTx	359
16416	2vaEBez5qgMTgUabpAZtYHHm9SoNo3UdtM4zdMdLGyMbj12qLfzk	359
16423	2vbeGxAo54eWmEDdMJ74ZVxpkyn9yzmXmUvWNAwVvjywzpuazVSv	359
16426	2varzfC313mP5nAreEt5AjzX28rqkkEPaQGnCA1jszW4SsAEEMVz	359
16427	2vanbKCTyno23XVFzPJ8q39wqPr2rH6SCq3ojwmoLTCGsgekKSsR	359
16429	2vb8FtdPTXDqDSPHYkvckqrgAjwRfdx3J8qLGSFoC1qF5BAtykm3	359
16433	2vbazuYs6D4DTTB3aG4w6XPekpoTgZFnqHG2ZbMNCNFcvsNpQDDM	359
16435	2vaM4QGbc8TnuKdYb3YjazPsQb1hgNJRxqx1RRJMWyS82uvaA11R	359
16441	2vbaDrCxL5vWY4jHsFzZApZj2P3F5mqEyGFPoromkFu3ACKruBti	359
16443	2vacHUatRQcqQRs97mTYYJRfCZHP9DYMeEyFFmosrxpzHjoQE8cn	359
16446	2vadBCSP6YiT6pDqYHFALMwXRTHrNb53eCZWKhvnX5X58y3HzXZX	359
16450	2vbyNrwscJ1WCx5XnNCQB2rsLN9dp26sr5b5eUnvXFt6ZNqZxWzC	359
16453	2vassvEeBiMEH77rffjH1eYXa5b3rT1oaBnDRnopXuvjvTijC65J	359
16457	2vbaCoHxAmsiwpFFhdGecRgChR1nc6EJHQsQCDsRd5ifLD6MaUJP	359
16461	2vb1eaxPo9Aej76kUkX2YByc3qLJKnHCVeaYPZFEkG9mcFBk3P4P	359
16465	2vaXX7rwr68ZVqmXUmw8GqvRjxdb8SNPWa1YdwA3guK7qyB2cERU	359
16476	2vaveNLnF7gSA9cgvLyMqJFkBDRkFa3VHn3C3z9BbhP75vM8LdZk	359
16483	2vbaTqQpuQ8BdJnQjGDbajdJzeBpS4J7MzqC56w8nHDJPKX41rE7	359
16496	2vb83dGkZw9UwDMgnoadFhyTZwHzxC2phDQw4MnKhXBGoRmaCWBg	359
16501	2vaN3UBHP8CSjcwLaAQnt6fgHnWrC6oF22KvFTc2P3Mm6j8Nk8eT	359
16505	2vbreHLkyijMe3toZeLLPtzn49fyN9jgJ5w1jQ8x3PQYvfSHsf8o	359
16510	2vbaAxvo1jVtC8ooi1ZXVt68jWs3mnVRiZmAoDQmAmHGTFwpBb4S	359
16513	2vaXpp8hMe8RKuUWW1eFMBxoLvqge3fReDezQcnWhJF9zqRedYo5	359
16515	2vbUGfPoCsFAVviTi21hJ9U1CnHAuRmuvH2AoCk1yVU4n7DBpUhn	359
16518	2vaJ1ujFTBnM6LMYexa7qxLnXSvdXmXcMwqVfVV5rc43vdehcqzQ	359
16519	2vbSWgrkwR22gYyNYbXZFe2ozuWKhDVXwFawAMRNDsnLcp3whEv1	359
16522	2vbLv3tjT2idxGnQpBt5MGphMr7yTgsWY7QC77QwaHjqZVTERci8	359
16525	2vc1Jaw35bg91jYdTEJTXbUNmhzjAAJWYzcdnx7c8bY7BhYeCqsx	359
16534	2vb8bBZWHEfRQE35fsX2xancQS4hnfPQNsdFE2m2u9n7MHx3buss	359
16535	2vbUc5dXbjjuwJpHFC4ia9oyWK3Qs63e2j8aRkawHTi6saHL77Ut	359
16537	2vbBmF7mTRnejX4FS7P6zoGKuFgxt2zCMA1kbiPVSNrahLBHDWf3	359
16544	2vbqTHCLXnhiQCNi9RPUbdLPPwpF4pBKQwb6G35A5HFRCENAUaqz	359
16562	2vbcyhw7cwrvQWqWvyEiV6cPRMa8BgciYuEm7JT7V5KnvbfwnT7G	359
16563	2vactg1H2p3JANtoULSPjL1HeWkWLRTaqzdwyG1ouBqaHH8ghWg8	359
16570	2vbXSmRkfFNZAYrQchqTQHYL3qwZgJ2FwMkS6yPc4A1n2jwCX2TP	359
16575	2vbwPFPzHyYCoPZhnqtMX6LzqbeMLckXmzCFaLxVCcoykHf6QvF8	359
16578	2vaxMKMzhD3PEPbC2uRbwZWbnLuUBMmSmgZjE4CUAtPTesoji1xx	359
16581	2vbR7nK6VNkpoKs57z5jUfREZw3dj5Kw4yTFGovLpmNh7kUgchKJ	359
16586	2vaqpAvQR56qgFWHRBP2CNcCKsqr9XnwCrX7REEK6UtNbuy8RZpi	359
16595	2vaiXnAd9C99TnGNqeff39fGkUKfkpkUeEFCuRNM1m6fAU1UjZuS	359
16605	2vaog65VQ4v8QiiMYQ8cUm5bxTbwvKdS6LLduCUD5PJL98SGjKeJ	359
16607	2vc5ccbXgSeqHA7xx53ukn9uD6RWAF1QDWPbWEnDzUf5fXkx9nV6	359
16610	2vbEAmc3z7LCjG1nbaaKMkyDqmeZtaKiFWak1X6LLxXyUNsb4Yoh	359
16611	2vbXX1wtnjehQ7P9S8UBqKtJN4deiSySTrPBQqG4q6E3tonN4gNT	359
16613	2vaSvPqRvGfvzygYhtoRdMJFb6RuVW1fWv3HdFoyNojRyPVC1YY7	359
16618	2vaqCvNv4fZVirzF5VAQYaD9STiwUDbuWE4Uic2B2HeXdXG2JTP2	359
16621	2vaq1uebWVJTNE5WAhgdLQ1pZGWt5YvWPqP24M3Fw67kbJzbewuR	359
16627	2vbPQdVDk3ZWkHeAzwXdpZVadbu8fo4SQrg8uh6UrqwA1rnrJs2M	359
16629	2vau3NHw7dctgcrUnGqnVpuMmeenkzTbMy4PueoybTRU3wCaWzvc	359
16632	2vaVG7p2xTt9x65rjhpXmWeEm8wz5BFjxig6jjFKdgRLDDTokyCR	359
16635	2vboYq5WvMmfxpXG6Fd7A3UTiWKeMguJxdWF88hjDKNY2FbHmjpt	359
16638	2vaDBWhCQT6W4Wb74x2UwEftZuQist8UjvPuvTsUcJBhnmuQCzZX	359
16641	2vaWCJCAfiFYuQsFWWxPYScjZnmtWV3TaeiCG8WJKRuWYaRcop5K	359
16647	2vbRvmkuwVLWnENoYhrc244ADoq7cWGBoduARMN5hQuCzVYSSTBH	359
16649	2vateNZ2s2AbkcgqmNiB3vfb1xNsCPbhjdwu9sGHmo83DD1FQVH8	359
16652	2vbHMTNmarZPnSxn9d6UM4ocr4AWFzLVHb9Hemu1vWgnF1irooLc	359
16657	2vacripEKS8EqaaPG6GuT9Ssy2o24uSdkXKoediqpF2QNLTAxrre	359
16660	2vc2G4YhAb99jWNfaiYHZZ4QkQpB87rqSiZhi2JybQdhF9e81D4q	359
16665	2vbY5z6pmHWVpmMy3Kw7Q8HQDB1chMGNs1ZznjRCxE8NZkFmZv84	359
16667	2vbA3nNryepLRdenXpiPw7g3HNM1Z1YjPoJJcAZs8a9i8Mr9Jv6v	359
16672	2vbpfSaAkbTVmWYEUgEmqPX7iTDuQr3YrtewZf6x7P9MUsbV4KhQ	359
16675	2van5PFb883mH2haLfbK43cFpDk4Lfcyeg9orPXWChPwSzjBoWxf	359
16677	2vbBkhF1t3LwJpqHefvL9zyEH6XtPgkDPRDesKxxNFKDNeWFQEzP	359
16679	2vbPi2YRd8j9xYFGyzjK2JadxEyK4dPYq8Dd7N5XuRNX4VyCCaCV	359
16682	2vaqZufbYPVo7Xb9d5oFAiKxxuBSznZCiKemdtM12CxSTLQRaXzR	359
16691	2vbvg1kXtVafWsVzo43dUzAWqLaBsTgJAbcQpL7SVuHDkhiCnCaK	359
16694	2vagmsd4TCfDo8mU8BLRx42AngmUfkHLuiwdD5ZfgBCeSEhoSov5	359
16699	2vc5oZQxDToNb2j1HVFEAReU529xMTYz9D22dNTrnS3naTGxG3NN	359
16701	2vbxH1FE6uhsHdSsnP3NCSkvjhU85VmVZUpYZH7n6RGszDiC9aHP	359
16711	2vaPf5Hj9h4yYfEL8uZ1u4TUMPT9QZ4fj6SerWzLYVXtJq5HdstT	359
16722	2vboyTnmq97UJdJD6uQqmgjexFJu16ouFTgWnXGACWvUEE5425F6	359
16727	2varv8WSHA41ti1NxNo4jJQXGVzGiZb28t92sJ9gDU8vQdpVxHJE	359
16730	2varkBNijwyR6anxda5Wypv9wmKYXMviHsk7BwCQDijsrtRPEVUE	359
16733	2vbdmXFeeTuW9dMbwR3FrgGfvT45fgDjPMoyRUTpSNLopWzR6dpr	359
16739	2vbtkdxwBFBKasrMXJ1uxEaiagmv26rtFZQH7Bxg1K9uPwMvhGeQ	359
16742	2vaEkEQVzsJbB8UptoKW6XYf2t5SM2bcq2BD5cmrJka6eh55Uj8r	359
16745	2vazwp8QrQYAkubXWBDg77t8yB1JAMqMijyDJ3JsKr52SQ6cWkiV	359
16747	2vbH63HM4Tmn4gfFb2DPzBbRmwiGNTwc817KCLmSoySmoYnQu9qV	359
16752	2vc4Cu273oQTVMg2QrSbsPYi5QiZ4TQTCok8PdLUGfHC9b7yCCq3	359
16756	2vaJugwzLSZQzzCPgLD8UZ1oL27A7xPtVFa4TRXTrX4ca3Ujo3ED	359
16759	2vbztsgQmhmCS8Zk76XpLDASen9Dz9n9DQUMTodx1nQ3725tnxL2	359
16762	2vbtCzhWvTdc8tDGKehvTNQjeugHsZd7KTpMN46BCkNJ1j6dFrLW	359
16765	2vc25hLMHXUhbV8USN3Zg2CMF2d4gGpPdHhbAQyhj5fC4DphgiGF	359
16767	2vbEXjLdd52V33KLuAg98TCNk7frAY17E7QEoT2MEtPhpbjshFiJ	359
16774	2vaj6DA3uRNtiFoaurkuF5Jx8B3frGSWHRUW4HxCYceoxPwFt3fJ	359
16425	2vaZ8TYzpcyzNMZ3A7gusZ3juDG8Ex378opSLtkL4vZs2DzqRxnP	359
16428	2vaZ6qahNEPX9gSHnuSkdYaY3fDKkJazusAmc3mVok9inunNVTGj	359
16431	2vbxWtHhV2ijQeAtEbN8sApjW5Nbf2PLypDrUnNWPAkVoDkZJSy3	359
16434	2vbvDUHL6yFYeQtBRJZeXcvS3Hk3QUuBh8BvP1bzVr2Yz2BZyU9w	359
16438	2vb6t9i2HSrk6BwXywRFnr62U6DWYArFE64REZxPfZMSYy4SrRsB	359
16440	2vabNQLEJz6gY5ETZK9BMNe3nqUBKVkYfaJt4EiKiHHCmSM242yv	359
16442	2vc5BKVHYHa5hsKqkZX8tehYxWWDnitQxtJfde4uJZJKXYK7MzrT	359
16448	2vbQrU9WYHBDHjVbmm1SqKB89vrngxwmG6bzipurY12Tsk7eNfT1	359
16456	2vaHCdwG6YGGrgVczef8FAXUENGpNXAP9fnU5yBevgBTCqEpVWWW	359
16460	2vbY7zjf5VyrEpXLj6DXaGzys9TxyJJo5pf3siiK7YtofqYhXiKY	359
16463	2vbybA1hxUUACALhs2VL9RUe7HRMVu8Nnrk96kCP8WbTxYCHhSbs	359
16469	2vbB7PwgWRHcDFEDcRn82t3n4fDU5rU1mqz5jawSeWYXojQ56w5p	359
16471	2vbLwpB6agcewSDPPnPmkxH8xThy9VqZna83a8kePzm2LXiTAccg	359
16478	2vaGidcfJAtXmkzPGXcpJuc3G67kFEo7Ltzudztijhe4zCD5fBxV	359
16480	2vc56uMXf2ZyTK27k3Dugpwg7YC857ctTT6bcGmQWbYki4vJKF58	359
16481	2vb7okuWKNE1UrELJ1yyG83AXzJHri1VzZS3ZfYWyDvEE8JSGyAf	359
16482	2vajwqiDUpfDhLp3dURGtMGDUhxWbpBVoRe74mApvBHKHptrhZTz	359
16490	2vb2ge4853xYSKhJwT9yN1dGZrDe2b1T5zBgzcu87T5Apucw9tHd	359
16493	2vbc2rtSGZDLqauhFCttsXDbwL6ph5f3EUEVjU1yXSpMUqkmFT59	359
16495	2vasrfFq8vdKRKjLjRgJKoU4vLp1DXxFDrZFutRp2fZXo6Rf1VDs	359
16498	2vbAppmtS6bRPQvYi4CMFrmY81W42bRGSegheBRKbbVnbxC9BHQK	359
16500	2vbythp2MKwcR9w7bniCYV9isUMU3ABmU3rnm6hyhqbKDoeTzVbL	359
16502	2vaHXivj4TdNR9hksZQZ3FoBhhg7nTM6oSLJGgoUAnbW7zHKK5b3	359
16504	2vaZbr4uJfv2oVzpXprR4qCt8cGZSC3QGQtayr2Je9Amrbe9G7oi	359
16507	2va9jfY1qZin7cYQeMqXtzEHD3C75MAQXKVFXqsqctxsy3aHXPxA	359
16509	2vbwAhRUY3MCFQ7btxsbiCKhDRYG97SaebUyzM91haVqkdRKuNjc	359
16512	2vbPvZfLj7FUYK87YWL9QyjCUXfjEJvfF15GfRKBj1ZzTFGmJAgQ	359
16514	2vbq75phpyffx4Tw3uzw2YDhT6mkyoywbNqsMca85bzpsZvGMEiR	359
16516	2vbU9yaFExkUZafeaLGV5exTRB8mmThjrPCJ4Dd6R1U7jtUUAbhJ	359
16520	2vbMYNmyWa1rZRq83dARWowcwzfzNT1wyYxSHjWhumk88yk1fMR1	359
16527	2vbnTXK1RY3wCg7AyGgy5Rp7KvXVL2xGCmkUd4Zd94PM8NYEqtzh	359
16529	2vboCRybqbNbZxVf93m7JHyj9UoRG5371gT5B4YE1xiETo9r6maM	359
16531	2vbQuM77wf8JsKxN3Ky2gixY3do98ox9K2kfQiXDbkdxuSkh37xw	359
16533	2vbNzF98xpyyFoTbeQGJyEygVCSCehhAUb7hNpg91upv7SktDH2U	359
16536	2vbHwFQUhXWKCCnn3bX8sMfaUvHUjECJVBbD2QeasYxcVkF8Ruyt	359
16539	2vbMuCZT55RFvo3GyX2c6WCAsHQRqHaZFhD5EsgeRDRD294sw5tT	359
16541	2vaRpaGahYwzK5sKZdqV8T5W6NkYPXVLPRhP1N54Tj6osKsqRmhV	359
16548	2vaaRV3j5ScxD8uqRF3QzvYJe8uQBAkKqE6j7PoTWVBXvyJUW9eA	359
16550	2vab6QntsogHFxv1J9x2xrNJJELX7CU2Q342x4ShVPojiR2AWBEX	359
16553	2vaxReQGD7a6zP6F4GLa4y4GJ1VHaBxrcYJETbrGouPAVaV7z69P	359
16555	2vbDPjK9EZUBNXrb2yiPuiXomM9x7A8tMCnKrKMJBzKBspHDVjDb	359
16557	2vaq2RviYMrX1bpn1h1cDJHv7pbDRnSb7vzf7GXB54daqVoypb43	359
16561	2vaFoijEcByEGWypvCen6ujr3Tj4L6usu99LA4PDXx1xw1a9F4YG	359
16566	2vaXhQELeUKBfbwomLPtnmomd5GuFPvbLfamqG44Lt8WPCtkNCcD	359
16569	2va9oBrop6JriGBvqB57LpHkrMt6u3G5aagjkt65gxNkZ86c2VXm	359
16577	2vbrFf1mwvwuVf7xF1J9yMPedxZxSRmRv7qxmeeusNBY95Xeq68w	359
16579	2vbwwieHRCCd8PGT1dpvFgrKquvf6vxkeS9ePPAWGhhY415qSaLt	359
16580	2vb3fKF7Lr3snqJizJVVqpkrSkhGTRDn1P6eosgGsyndSU4NCzdx	359
16583	2vbtFVvJaR9A9ZRhD9ftxCRizxvr3sb9nCDYsP6SmBDmZSFb4zgh	359
16587	2vaX3fQFn4sGxEEVoNhrfyw9bYZLVJLMD9bJ4URFNr4BWAyw7rc8	359
16589	2vaLMXuh5zeAjWHdiRxJqkcjF5neAW32ReN2J2Nb3FWB7actN7Gh	359
16599	2vbkyCVLamSpVsZU8bM9fL2YdSHQ4Suh4bbA9APS6rGYFkWTNftc	359
16601	2vaD8DHDpqU6F8yy9Gc9pyx2FT91QswycevtSndBgB37i7UC4F3n	359
16606	2vaFHBr5Sb8R3fuY5oKh4ZxRV6JuqdFMdYhQkbrJdoz8AokaH84Z	359
16615	2vatXMnxMN4nKdkMq4RGgb3pF3R2R2Kc6kiu9zH2WrjSvJtLojvm	359
16617	2vbgowrXXHXgCH3XHUNxQPEj4BhFBocJmhmd7Wh8T6rqxD8PmY5u	359
16622	2vbxw7Lwnubx66Spz4yrc46WdM6yADCzrJ74HbT7Dd7j4ASD2Mev	359
16625	2vajBjgHvc4nSE5iK85KhjdrRKrjj3kpRcBPcWdJ5QDkDDXbt7Cr	359
16633	2vagL5kAT91AReg5NBb9asyb9r7UdUqgwB6q7XGGJTeMmAxDai2V	359
16639	2vbPDdN6LX1JZeShgRBztFMtoYAbAJYji6VvLRguNMVXehckFMxL	359
16643	2vbHBmdmZ72DrtHuagLqmBhC8WavTEUcdtq9XptFRzrpBqEwwKqP	359
16645	2vaWSMzauZYJsMbu7u5wTNHGPdkLyPvxR1zaZqjqL9T4jkK6K9q4	359
16648	2vaZZwKoJJx7TjVC9pa2i7bmpZZoNxvo3VbQDeDnTYgBJCmAHsc8	359
16651	2vamBbbTqbLne5iDrHCmX4QPFagdd8aC8rYmh9Lw1KCJVKCem7d4	359
16655	2vb8szWXRf4RtgNWtJnxafjUDtQs5gpshFctZw5L5Cw9yh1YwMA3	359
16656	2vaQK2SJaGYnnZgQzPuHHtjDhtX42PENR76uMSiGcxHMNMeH3QhV	359
16659	2vbdApSnfnk7tfya8CCE3AGEhhe5XkCeME8vNUEjTcTnhNfYFQ7G	359
16661	2vbt8r3CT8qtgQzPbu4n75hVXJNLwSsrkcE87ubz31HRftTGhsEd	359
16671	2vbaFMhUxeArURFGjTpEL9JdbwrgRJnqQy4URJDkfae3bfe3XZRh	359
16681	2vaciokW1iiuzogzon4AK2kiMMHRRb9yYGD1p9QmDeayBewV8V74	359
16686	2vc3Jybcq97bW24WUHTYBhCCdDJmchGyzTc9MQr9ygi4ju5nyfQW	359
16690	2vbbEhEJuXYjTC7N4Lfby3GvkfKXnUeffztb1JEjPzEk7RQqXMTS	359
16693	2vaAKn1qW2rqePBgpFCfbTvWvoGgzfMmAGEGfd9XgKH84SXJ7JBy	359
16695	2vbEJMbaTzkJMh8jLyQAxAQDvMqeCdWKCBgS39uGuQSpg3Vt1xVf	359
16698	2vbbL3iCyLHDDWvpUSLYD9Phguaubx5NgczXmPERFBgEYQvoCApQ	359
16702	2vaBoVT8ykghSoJf1742Z36HCC1svQFNnYBsiTfv6bqsL7DRk8y3	359
16708	2vaLWmg8HTNBkUjDEaJLmjTEGZ6B85x6htCt3q7iSxo1AamZUoiR	359
16715	2vbB3RaaAtDeTS6AeRt8XP7ZBtvNcYdSx99NEeeAmRTvPMAfN8EL	359
16718	2vbSMYR1x5rtcBzW4e8uJ76H7XNscbPf1PhCj41p3Tk8DRkokVnt	359
16721	2vbwBNj6SAf56i4t8xJ4Yw2SRTcDwhZQjwVYFtUwbsgnKWoGLKV8	359
16724	2vag5cWDBbrCFDbRDJULZ4bQJanWBGx2rneB2ACxN7n1SEKLLJeE	359
16738	2vbiuaAXxkC6TYZeNTkLzLUALQZWiKkFACvti7UYM5Dk1uWToNDU	359
16748	2vbmbUdq8HA5RDKWvYyCY85Pr1tu1Yo4YnGLmc5Ha96hZf64dxk1	359
16754	2vc4ErPGbwSPjGSMXA98tosebBUUg8qDAsrjaRFUvnTig7X8D5vc	359
16755	2vaScHEpiWKkXEY3pKBNrhahcmqC1oBUgodMh5z2xs2LVDsqQ3Gu	359
16758	2vbgto93XPmFcxAmXhjEDvhFUNiiQhtxPzeKrLxjSXc3ky9xG8pb	359
16772	2vaqVH9eYt6EZoqhHywysq3vtvdLQUtLMMw51KPowkgwuE7NFn1k	359
16788	2vapVfnWzFyTq6PAb2ePebha2NfKM7yxE3iztAxUM1v2pj1DTh6e	359
16473	2vb2Epep28BSjCYTzoNWe6q15vKYbuAkEsmh9yZmvYGSjiASJPb7	359
16477	2vbcnao5QPEQnUNt96tGJ9Murx5NhQBN891V47349V6J6NFt8ayt	359
16484	2vbnLCuPFz3JQpBFQDSjnxiiBtmcbS3Exhen2hM76iXgyVpm8Y1g	359
16486	2vbhPPeVfzTnThfG3PhgrsFC1ZTBxMaqocSS7LfLG2qS2Cq7Mi41	359
16488	2vafiVpwQ8s5UfBgsSRxYd3UeT8FXa2jQp4TyhzHLby2E92nE5sm	359
16492	2vbDs26jDkNG5UUeCyjkZrYuoiQRiSVxudGkk7vWo19wbXVNBXbw	359
16494	2vbzTz77R2LqbCVrUVSBGkA3zes1kHrgVaR13cNgUPwfxKHTDX5t	359
16497	2vaHWr7SJj7zfiEw6EUbfDviyPccRXvnPzJB2Kn8RbhLbRnEivFX	359
16503	2vbytDXMuzGij95Mi11bGGikSj81WU7C9dHNMRdwLih7UYAcxwcg	359
16506	2vaCtvvbiAG9ZzZaGg2y5RamdmG4YBpfHp6FKwRshgWcDoLkWtdX	359
16508	2vauKCejMo5ZDk26X1gMqR3idKA3vpQRDQyc5iqQQi48TKYrHRHp	359
16511	2vbVHsoc5Jac9aQth9HDGyXh3yh5fT7kjqNrFCJzuy872aQk769b	359
16523	2vbiPSrxwwybUPZjAXePJYH13NGMQnrXGygWUVovBBx1qooQ47ED	359
16526	2vaYD5pZfHQdG49yRW3j5SYmWde8rmY6eFpzQv9R1mT2dcj2RSPA	359
16530	2vbmtgesJVv93vdzarwUnMHQCC6zdqdyXusEY3Y64M6FZDiBTRmk	359
16532	2vc4bv6N66ALiMvsHNHbbsqaDV6uVZbrBo4zYtdW5r2SL6xUQfLm	359
16538	2vaLSLBPtmvGsU5q8xNhg4P8PxH3S4Q2QxxyLn9AEtJYrAdpG5yj	359
16540	2vbeDFDCAmwcgiNmHUorwHa3fPDwAXGLgTXqq7WsTCLSHLBmwRAD	359
16543	2vbAN7xQfTog29DKWGQqWHJKZTc1iwAJNRF1nHVthWjRkEZi2Ys5	359
16545	2vahpmzd2RxxYwSAxeDBacJS94Mc93T6dwD7KBAaBXYfAKZqutTQ	359
16547	2vakGm7Gi27tnVoD9YwQonn4m5XAgfX9EQMPXpDfAT4AihqXe59E	359
16549	2vbvRWgedXAsFo5vSMyuakuLTaWTGVNUi3SvZ8v8pg3JVdPSRKdp	359
16552	2vaQ6vtXFYTzUZA3Rjc5VkcNYdF47hTskyCRudj5Za8JFzF6wUqW	359
16554	2vbygFy9Mq7cA9BewdY381GyRPFgBJ7RZr4JvwFYBV1nVUVjsR2D	359
16559	2vbahXKjWuC66wdzB2CWScNXxFiQpncZ2X7PzwURQXGLgNA9ahQ3	359
16560	2vbh217ZMrKiNaFWd3Zv1SrWuPuG5obq2U3iNZspqmvteB5K9pDx	359
16564	2vbjBhX3R6Rv3xa8x2M6X3tECHvbF7a1P7386ra4vVMFy24kyGKD	359
16568	2vak2KGZb9dwNovTkCwFaSQWyvk1fp8SqsmbyX1r8yWjPEjJZMTh	359
16571	2vb8s3wEwvUKE7dNH1qbaHDASVjcnfsHkBjKJTeWiSHY1YbibQAE	359
16573	2vaJn5bdz6FUVhMd7YWhjX3rgiFojWQ3Dmmbmi1SdY6rYP9hALPx	359
16576	2vbiHQEN5qcLSdexSYQxnNXdzBjPAH2Xn3KJwFQqeCrnem2TmNbY	359
16582	2vat5H9AA8AKtYEDcjo6nZ6D7V3N8ZmRjXNV6HMiQiMnjkST9fgf	359
16585	2vbNpgu5vH9TFaLiXLgyV5298VoEVvyGnmD3UwUWXG7qixP83k5L	359
16591	2vakJu4DkQFhMHAZqcJQfk1JkRoZKH38V74b2pQXhUzFTbmcvF4j	359
16593	2vbEG85gKo2YMNCarzLUo61HkXDiedsoHuZB2SA5FHph5SoBpJtm	359
16596	2vbHZv8reaitPMiSXtjbM8niowsL1a9wDQG2s5BDnLq7QKMJGXcB	359
16598	2vc3UFAbSfJpMwNRvV5xXnoAXZEwwx8xGF9Qj45a629urkZuwviz	359
16603	2vaq41CqmaLVbVuSUEqKug4EMzCw8fAp1xa1EwT5i4YPWdqgjfXt	359
16608	2vbo1yaHcySDvbhZ9k1YRpyRr9cwMckcKGiGcWUhFaMLJhvw9xS5	359
16612	2vaYQ4aGHyGjkHshqPbWcD9yags1RYgtuuDMSjtVhCo2EngdpnVh	359
16614	2vazsUudaCS55rzuyKcLnB1VaQVEAg4siWwPHC9UdBBgLREVyDZ8	359
16616	2vbEFZGcYNLbm7UGYZuZ17755p8xMerzu8g8RMpVHY8cLFeBos8M	359
16619	2vbYfM7wQCcKzhLnLHpXDrBPPbRLkqt94a76BfEUCBYcpPwJJfoW	359
16624	2vaH75ZWg7Xiq8SgT5eXD2gQZDAEeUs7tDC48VE5MpF1ot1W4hxJ	359
16630	2vc2VcDpsfVJPAhiBS6CY267c1Q8jRd14o691BorLoY3d8TSJaKK	359
16636	2vbKhVyovaWooRv6VTrm2uCUGa89VxYoWM56K1vi1hfnTJYHWTdf	359
16642	2vc1DMzfygcVV1US2iye7WbBajgVPE3tmfswjoBB6jiBwHP8SzXx	359
16644	2vanyeVAvRdYo2Lk2gxAUiYCNze1ewvp5agaRuFEnBbFHhoZyngY	359
16650	2vaDg8FbV9y8beZKzmnWrc1qKTVPHi7KnE3noyqV4tgJhQbc2RnF	359
16653	2vbVKFbefnAZTg9d4n5xv3PCgjvL4FpmTqJ9g3rVxKtidubUKvqw	359
16654	2vb9Ubmm8JG5nU6asxPSb3TN4p8kW8hrMyZW3hk32mViPSpyGbxD	359
16658	2vbfXkjoWGpDyx5nn5sZwS1AmcAbr3ZiB7T9ihEx96cM8NTPrKEA	359
16663	2vbRgExzdrTtJCkGSJjwZX6QboeBFv9qQzsDNyoKVTnq3cDRnAss	359
16668	2vb2zdu6vvc78bvxHLRFCMCEGJb2a3TVvFdbqEMeF5CfSdTsxVBH	359
16670	2vb7NjoMXQhgNxGVQiRfBnf4kpsuhHCW89CPfk5Nyrz3dJwXogYT	359
16673	2vc4wKs74uKJos5D6FBKTU41pkhoY9ArTayS9xxMKhBFwUVFmnnk	359
16676	2vb8oCzU8FPPWtCYENUeVS2AoidddPHybwLarWVHScUqMztUztMM	359
16678	2vaf1QWgUjpVb8Q8eYDAPESPvPdYhge7DMbN7UagPcQtkJs6zVWJ	359
16680	2vayYobGTqgagdteUp6Nn8genXGz6mBkY8bmwxaS722XciiYnYUC	359
16683	2vbPr5qnqtYbZDwZaSDcsMbjywcxheLEpfJUs2n6fCvbCxAY2Z6X	359
16685	2vasBwU6DZfBbMBkUVttJAwdw8e6hHAPmwnMGaFfWwfqnh9gecVf	359
16689	2vbeEcnNBQxCZYfrsZAgcrKJA9GhyogHzo1deDV6MtKvAsjzf2VJ	359
16692	2vazoykYVLicbqVmFLppnyjXsuXPF97vLy45gR7APdLCN9M6GWrP	359
16697	2vaiXkv4eirYegnYnJnwRdS9HMK9SJ2XBbvj7XAmMa9xEqGPEWub	359
16704	2vbTcGB8wCJ4J7dLuZ8L6BKbzZ4srCmenPrnMtHmcvs8BhRehc9P	359
16707	2vbNcFzdio7VyduRWotcx8X1p21K1Cky3TFxPvihc7K8fQ7KTdUT	359
16710	2vbLmT9bph65dW9WifjWFrRjPitWmQ2FT61Rd4rA6m1oqwSfa3Tz	359
16712	2vaZAStcstSn1WhBncizPrvU2mRHB4AzJSpWTP4kAEcQq9uXsHj1	359
16714	2vaX99cecVKSnkwMNRtUb6MTK5TT5bgdvBAN5WrGL1v9n4PHNZBX	359
16717	2vb6bh92hkMpDtS6PtLSp9YEDpgZA1Pk1pkDpf9GZtLsG6aiAZMA	359
16720	2vbuB2XP8zQZipQYojQPfeoP83r8JWvtrUmciizQYBadTyDHNGsT	359
16723	2vbcMscxUkuin6KwZw8wUWnmX8BhL777kS3NPB9XnzbXrdzXNu88	359
16728	2vaBs3zH1fjejass1CpR8437Anw7eFEwEBQUzF9m1nLyGisX8EfN	359
16731	2vaauAHG3UqU3P17xiWNwJDC9vWKx7vQLhoooEJfpXcrXyuwHYS1	359
16735	2vbmCufUxxMHiry72M2jHoyqpP5Nf7YjjeL1FUne2bG289bR63cm	359
16737	2vbmdJVvgwrQFcN6rSv5dVmNfEcv9YUpeMj4Wp3ZxvMVCmdDRtzU	359
16740	2vc1ep2Qu2FnRoA7JKGASX2JSpLGep5hyZSmWqcpGCkRRmNJfEUx	359
16743	2vb9c7D3AmT7E4papAJjziS38WnPEnxf3F21dkXeu5xxKGUFh3MT	359
16746	2vaXCsoSYofZADU6wiSzbwCgurXUPdRQZbvWL7nyP5WqwbD3EoAB	359
16750	2vbdR4bckmJCP2RZMaRJqjCVkrFrQ4S86KPHMzuvJunNkfyGqG83	359
16753	2vabGGSyKnyzFUXkef8ZnTuknTXhDqsAeXkbtAh1EWyXdwCiLgps	359
16757	2vb2PXuddLDCqgEzEY1yxQdA6EF9HP3gbKJdJj1RUYMgQTmxG7av	359
16760	2vaE5biSkDZKhtK6TbBWhHFS5BtZQTvoxV7inQk75SNz4vFZxMYF	359
16763	2vaS9RkAYHCUNXckmwk8SBSEQEvky6E29ebt4vwSzx9qk6ge6NQ5	359
16768	2vaXAdYYcCe8kVQqTRiF2po9nJcfHzcQ5asaqqWAMZYg5g4AoLMC	359
16770	2vbeLREzobcVVtGGmW1S3BiFK1nRht9NNmegy3oWJQiyUVZPJfBZ	359
16773	2vaR1SsE4MExAKe47jBA2Mmm5C2NuBVqjYoo5Hh64wvEr8uNAxZd	359
16776	2vbziKUL95ezsTL7jKSoy5xPqbEjTYFP6Xf38AQ2T43ekTcH1Wdj	359
16696	2vbB2wdEyFoL68pm4DH9Z8bhxfXFnKf5xVBh1f7NqJN2gA4qd9Ko	359
16700	2vbs9FD5Jzt7fsJ9mrUjsojbraXAU1f2DCgThu7GZqhHauvz8K45	359
16703	2vbvMMqmGGtdYBQTiUixRHqvn8KJcu9gnpp25CaqdyrQhe2EGUSH	359
16705	2vbvFNiSLhkoRJnxS5gJbR19AM3CbLZc9rSQMXhnuUSbJjqMfLHU	359
16706	2vbApACFyFwc9hxCcVBnkkjEXhhG9gGnyZmNh1cfpoo1gpV21Cu1	359
16709	2vb4AJGTnKYjhVwjFPUXjbsGbC1HTodEW89eeYkDpQUPQVBki9Nv	359
16713	2vbRqu7qpv8exM5orj61z5gNeqs3wUbdSGNnRiC37GNrxM37F2Z5	359
16716	2vc3Ltrap3aeTzh6GQ9yM8aSRas8rHSUvSz8E1LR8JHP5gCr33GF	359
16719	2vbHj9QaCN9EoQtJWTjzDE7hQ7Wc69gPe2JTz3FPSgZ7rJcx1pYH	359
16725	2vabWHjiEREtiCbPA8XnueJMFGjuPErzkqujjCYyeyfqmVLeTfZR	359
16726	2vbi1edbFCvVS3TpbMq3NpUxmX7yqXPfJmYdrLyaHmJCvFWriyDa	359
16729	2vbfWHnNad7fVG4RHUrW9eVh7trLRN74FjYCqYdNxdZ8DXNQxoAB	359
16732	2vbxqKPM6h9YkScGsUj8hy9FEA92syVAajSByr9ikHBzfHsZKVJp	359
16734	2vbVeFk5cmgVP49oBPUMpK9cijLJnvbXQ9NYVkqU2ZunbBzxgBqn	359
16736	2vaszPiW9qz6eTnE8pkMGuKgzy6ByL2LFg49TLoeH2xEpDMnJR24	359
16741	2vbM5T4eBhKQwvAQhkwhRiG2dEi4dfcb3EaUGzXBAm5w9oreDxjn	359
16744	2vaNguB8SR4yj5CQ3Ro3CwyBCxbo4VanwkbdAb9kgJQheV422edr	359
16749	2vao3KgKwry3x74xp9KrASU79Hj2pDWwbpeEA2pBCxahfeiKwRHb	359
16751	2vab3NEHpKBu39zjcxgZpbAfshsFwFzz9xW5Fitk7VU67YLcbJiT	359
16761	2vbHjDWCoH2KESWWQQRDbC67rLW5SZ9r7Npjn4NjfmLFbYueEBtA	359
16764	2vbmZm3KPViRAwfq3wUPmAckx93sPcBziE52E5E1ggy1w57DjZ7E	359
16766	2vbxrt7CeG3evpBnSNvaA3pdGMZ3kURnSJvJtZPb1sbJsMZYpmvK	359
16769	2vaRoRGEUrELo97aC86c6vr1TzxosxhkNnp3wYCYCNyJ5fA8wzxm	359
16771	2vbtKHM9km3ypXS9YiqK7mNdZBHLzVpZXKav3pUngYAzZv9p38hK	359
16775	2vbfjEaXd9hxGp5Paw6jStYqheoooye8WDyW38tRdzMuiJaank7b	359
16777	2vbYGgxt6fPqVK1hhMtcMeD9vWDDzkXkavYkfoYot3nrM6pUPnyd	359
16783	2vbFU9n9GcF4MewJFV4J5BWiBzrLqvSRR96T44gadV3pQaJLn2PE	359
16785	2vaLXBfh26agjQKwShm5o676GVDaraMG3wryaCWScVMzjZ9Gq7c5	359
16789	2vbfLZ99569kvEe6PsSYzsJMRS4f3RknMcqaNwuViTgXcDjnsYLz	359
16794	2vaVD5LKFSX4Xeu7FdwpAenPGNb4oiM7EMmYm69JUREmuSoe7f4v	359
16796	2vbq6VG5gFmT9ZAsfZD2gWPersUAU5hegWbzj2PjqhPPdZF8MSPc	359
16798	2vaNqCjQ7pUP5v7GKcEr9Rk44C8upLruc16EmYCPQD35u6zy8scS	359
16801	2vaxwontLLgepuVuvocFSNoXP5RfSBCzigwixRr1mgJKr8gXrgnQ	359
16803	2vc5G7XHRZM9zigA9d8QXreD6afc4hrDmA3RGsHpeQLeRvnvbqmp	359
16807	2vaN4oLTXdQXikGFitvimLLq2magAASXhUt4gUTNQJMRcSd16PRS	359
16818	2vbApWCiV2nzyYjaXfVsdTjkssg6TfuswqwGjY2ErZPBKv9JSZdq	359
16822	2vbWL25k1N36YhoJNe3DpmkWFU5ezsamKAhgrVTAeFnk64jQqjpw	359
16824	2vaxxxHcCznLSb54gbSJtSxuyCxvUqDECzueLqjZRGiikRvfY8Rd	359
16830	2vaMPzpEmgeWxjmbm8R2FHoq9x6ywxckQdQfPSZZkf5pHThzj8rT	359
16832	2vaaS2Sb5Y3yHVmvFsnx6CK75zjzZj229M7wkarc16LgY7DEexTN	359
16839	2vbVaupebPps1ptqysFaf3sTivffiHcMEtS65kPtahcdxmt7jr5n	359
16842	2vasGyE6XhikWxSymyid1LNY4fZ5k47QgjUdSiPGi9zsNbjHVAMU	359
16778	2vaHpdXDPBmyADVT1sRvB45e694C9Uqir2qpTQJfnWCTbL1MFVdy	359
16779	2vb3BvN3cKvWbASM1CXJXdsv2HRjgdAdWt3rHcu32MKAUsG2htvj	359
16781	2vbRjchXPHPizBDNa8ZwithvM9jLHmQk6cscK1taAQdRLVCxjB8S	359
16787	2vauwGDqdfcN4sraZo7dauddjBji25Ev5ZRxbyJA5Pfw8sHRiVFB	359
16792	2vb3DjsEGLvoZi47jZsPA1PVtw1fNorusMfNDieGYpzTXs2WTaG3	359
16806	2vbW7FUsoHXWCWenQexihsSCE8fCe6pCsET1oFhkVJiG5SoujvPD	359
16809	2vbqhvieztUDnnA9EzE1v5d5PfAzuj2VSnBwim5HZnR6urAzgmrT	359
16812	2vbWEXJFa9Y5b6GmuHG9rLDZpbbAUic8ZML6YqCdHLbLnJjtQsqj	359
16815	2vbVLtXhkZt1rFZdG5s9ZPNNaHQQQWW8Kh4erDB47T28TpXT22ZU	359
16817	2vbAZdkdqwdWVBL9q883UudVzbqsx9jCC9R25J73jYxH9rigsoBx	359
16826	2vaQukZx1bMEtYoySEdmiLYQdbjCYJ6MkTKhYQ5kEV71vV2o55FE	359
16828	2vbAfKKNfECGQrUun3AXMgxEUe6c9rNKJPY7U7Xc8g3gHk5dbzxM	359
16834	2vbFpZwGskPSXfbXMwakVpCFXUjvm7FBhuiRfWKyuWCmrGxpxu3f	359
16835	2vaweesVM9SSAvgiYoAPYYwv13VdWBCiGWhwVYZrYEqacC4v5oAu	359
16780	2vaBufzU8Ev4W3HPv5cXCSaufbPqKLxRV2g9WRmF8Byth1SKStK8	359
16782	2vaGKyKFTKtKGWfaGxPt4rk5YAiPWmxuLdNUyWUitkt4fEpVoHGv	359
16784	2vb8U3MYXD1DsQsw8p3RxSracSm4X2CbwHrxtu78bnAQWbsNA8J1	359
16786	2vaDMuyhnFEBqWhiZXGPBSmf1bCkbD1B7TrrmYGtMW7cTFsf27z6	359
16790	2vaXdL6kHGGNUSCSdxbJ64q6pPpGgn6rJCQNgJTEoyg3396ofrt3	359
16791	2vavWmpiT6EVm5oZ1ytpVs4txS113CyNi83ezumHwx9EpbeeDocH	359
16799	2vb2f5jbGfAjYWDsFu5a6ig21bMK1dQpZudfJxAek1odPLKfLCJB	359
16802	2vbD33XNR9tMyYzbjB9Gx83m3NiGZziVjmp5LAPoSmxWEAa9bFEP	359
16804	2vaTBFgsQN6GTyfhLtUHHffizmGmmGXHCnz8NfwajuKyBrMuLCXB	359
16805	2vaBdniMMJ4ADDyaX97kfm4ip2WjwsbNXAN8YeR9gmaXNV3ZM2M4	359
16808	2vaMpAK3b8XjFEVS5Ume9x5xG9AbbLRHkEf9rcddnf8g6kg1eWFW	359
16811	2vaNwpq1x8rA2XoJq6LCfeYZ8GkJRe7SZEQbM4CewGrNej52B3qv	359
16814	2vaf5dcER9pazPRZ1fm7QkqJnxP4A7cdB5XEKLZyFSPrqcLLBAWP	359
16816	2vaoAEzynsm1UddMiA54wtvNWJVbHF8c1g7k9f4y6UwaLoThkPSR	359
16819	2vbH4yuhxwTHZtsKFrrsuyXSc6J7xCLskk82tJgG9tWTm2hZBhyE	359
16825	2vagy8DUd9vnojbGhqnVGmiaTrj1d8k1fYJhRvHKdg3WBjzLDgQR	359
16831	2vayB294BqUjUrQz4Gfb3LvRGd9UEQDHjvjegyEzrkCu4cmVZDtS	359
16833	2vbwohdaGkk1nWQr7AxDr1NqzBpDKmAFhwt5XytyKAjiB6FeUTLx	359
16837	2vbC6vWMC6151rry1oAbz54xKPyuUGsaJEgyREhyteNvZZZnwr6a	359
16840	2vbro94msSJ5zaaZUFUDpexvcyvsiwTMYxVLz8n5vEkQCPSuWuug	359
16843	2vbKtV6rHhmTnnm8LfL2Hr3xEu2pSmcpciT4JKf128zWmnx7dKUf	359
16793	2vbJfgjsesoSEtPTCH3ka1RETpRKpnsjkgj4T8MdNwvcSuWVvKsz	359
16795	2vahaMkHJUFnsxpLheVkteVhSpUdfpzFpKpgv5WkFWDLoadFHbib	359
16797	2vbRJfgh91NGaGJJiaZ9e41Y4Ff35Rc8rFqdBnvP3KUzxugXWYyY	359
16800	2vbXjcqJwpESr6gTYaxdJYLbMNydgwseKTFnSQLBmgz6BaQ4T4et	359
16810	2vbggQnARxN9kaWPXUeDoemaJ9vEfNqxWM3ukfcUB1YFSdoRD2jn	359
16813	2vb8DNo6y22XAPCWhe19CWsJtsyJKjam4sqhQe5WGRgDqrRSJDSz	359
16820	2vc1zhtrbc8MykzRq4sMniETcST1zfo9FBaypeC7EecNURo6tgwX	359
16821	2vbCZt44cLY8qAUdFGjJoWSJawqSbDtVmGzBnrCNUBBbPuLDM9TW	359
16823	2vbKQPKCfjnG6cRye7hXeQqnhVwbBRQ6XMphzKaF8VDUxTTWr5Zy	359
16827	2vaKxeDSeeVQdNbwWpFCVrHLd3XZsAbWqQXxvauPw3PRJxskeHcS	359
16829	2vbu5koUBdTxtLU8fC8nXpBeCV27U8YLAjq4TKwCDbYZDPM211Ts	359
16836	2vaYyNc23Cm1QzBjvLrxUy2YJQXbw4czHzaKYZavk9R5rM8ovP3q	359
16838	2vbinWhaWGoPxmyrAMsNrbgvPt1uwurRuJeyr5E8WhiHVRBuSPhH	359
16841	2vaSfNWxX67ezyv25LeZfZyKuwcyaoyE1ybCWvEgxSSr3kBoa9xZ	359
16844	2vaPVw9bBsNNNwd84dFuz1rAyAVsAzFz31CRjA5L494harnjqSor	359
16845	2vbs5YMvbyQUDhQaZdzogFgKYmmfgAzWSaDE7ZzV9NBuvrs79FMo	359
16846	2varEj4vG9m4E1R9qZUZ8yee9tosF4pFNWPFNretoQYJzLcS14tK	359
16847	2vbcbCbYE3fq1GqWWvLTnATA3t8w9QFnASsF7fiWrwzwdJseautU	359
16848	2vawsEYtavGoe2faSF8k99XYxatKe5Q3qPHY8HPzVeyfGPZajohb	359
16849	2vbKSA97wvnJUL6hp97jhyV9LqRJYLy5KM2Czzg8pFMyR9ze4DQC	359
16850	2vb91cZLctcqaCZA5hEgrHEabpM3yHfDeCXjSpFiGQHT6nEaLGf3	359
16851	2vc5pFp175xHVfyKRxQ8AVVstuUnEqXX4n4N5DUcvZFQi6UhnaTW	359
16852	2vbAxE2jycZFd5uHaeQnP9pebH7NRSp2nJdV9StX9ojvKkXbbqxg	359
16853	2vbY18DZAFjp9q2jE6X9CwER4FnizokntRCF8mjBt9mua4H7ycRh	359
16854	2vbfLXNR4549zKJs9i4hVrK59SMhVL31rnHoZqJDxgN4iiBtVhdY	359
16855	2vbZAtFApGDSujRMjkMCWToykLwSkiMoMGtMKmHGzQAiKSwz3akF	359
16856	2vc3wZVSQDNn2wT8ZqNN5sZrpeEewodPneaNonptC38gkGwNuAmN	359
16857	2vaRPxykJFmGoAGiAFHVTNjVxdax8HP2d3Qo9fRAXBGSqvzXoCXa	359
16858	2vbW4mHxFCyu6xJ63hPVEe31tQKSkP8ReyqGK7PVWaqra245dvnn	359
16859	2vawYR9bA2tyfJukGhB6HBtyqGkBob4ATuAJAkLL6DhumZCVqvC3	359
16860	2vb95wthmzjHhV7AeGK7NwvEQPQveBjJzoisaqTZXUZ1zj9GfmG8	359
16861	2vbh9b5gBC7WpcmT9deFyNTDYknfPrrMEPkYLzGjMJeoQ5BGj2pZ	359
16862	2vbtxK4fE7obg6eTRUDASWe4cF9U2LhWKME9iTgmv2J4vVDWLvXu	359
16863	2vaDZQowAripws3rUAGD4i1kfcK9zbU2xYgztPHqTeDR8BoPLt9W	359
16864	2vaSVC8wbpDKnDKjEwb43zZmkZcyavrDvNokz17e9b8pXzvyYegP	359
16865	2vbeX3dGf47Njsh8yTyFg3UsbJXcCqQJJPFUbmLLZ7dGckyK6Rti	359
16866	2vbzWJUdQwmKPp9aby3hjf8HQtph4guS967TYoY1LWi8msFu8jBX	359
16867	2vae2xbvB6zMb8enSX2oCYpQoztUK1Hn29va4SLWYXavaK6mPJ1X	359
16868	2vawBfdaGUhX3DPgsne1mHqBPmjLFbojC9g2dFrBWHqymfx7nkE3	359
16869	2vanY5H1REyhcHizJhZ7xPjKyuQ42wgCpEJVusiA9qBM6EFpFTx2	359
16870	2vaWT8PG3sJ5B3AeiBB1RNrmxJuj9619jUpbsKqL4HcRpQKrQ13g	359
16871	2vbtVjk11K92o8mPoVbYgMAPDW7McXRTMQt1baUT9DvspcRiLF4h	359
16872	2vaWJS5pjidXiR6WvoUg96fudUPoso744xn16akdCWZYvBRgL3Ny	359
16873	2vbW3BKHDAJG8RkxP9ttFJrsLJwvE7dSFYTNMjeyEQrZitTWNbnW	359
16874	2vaKJRA9Yc2hHEFH1aa4tJQ6zHtDiS3BZJdXG1DsY1iBJgfWsTbQ	359
16875	2vaXBgqvzgREFUEc3fvu1DNBGszMUE6YjjpS9jedQi2YqsuMyvN6	359
16876	2vaGtRMruKd8a3cquvkUrXmsLBoTzUuuwZe6Pnabt5emf7Nb98Xx	359
16877	2vb6j3yAfLT5ckt8YhWSM7fegUaCvutA7thWevTgZikzma3LsCzf	359
16878	2vbYVtjQjd7hDaaUYz19rxwM3gf3vsEtkwaEeynvVjMWBtk2Tpn7	359
16879	2vbdjvSM7iK1k78rEWc1jt1Teo77i8xSJTo2qNqAZE3KoEAF6Ksp	359
16880	2vaYbYSYebwiAZqQy2c9zxNFDsohdmQErcN6B7WqNYcohMDYfD5a	359
16881	2vaX8Pe7FxG1nsQwk2dhJRgQdPZCrPxc7kHWUeSBNc81M79xLYUd	359
16882	2vaszYaaEkRjbGJdvPZEnhE9K5hn27fXCeM4C5wQDJDpeSZEoC6j	359
16883	2vbGXQr2AvTSKZoQVFdccwvLwCp5XMzkdwNz1CS5J2TzF6U5PSnx	359
16884	2vaqiJ4UyHwxm4n7c9LwrD8wodDqENKBANtiKQWTE3BzruG7zQsf	359
16885	2vaXNj3dpfypg2Qm2SzPnsecauQHDv3tT7cuBDPwsmQNm3oLvr9H	359
16886	2vb9pwjC9gLndBbMUH8gEvKt7NBDtwDBt114ar3pBJ1qbrPetC9z	359
16887	2vaDScWJ6SLg3PgVy1RDQFdHvyn3X5AzYsbhSB3cvsVNjYEbtAeo	359
16888	2vawtj3LwDspf7Qcqgaizxqotsexx5LveqCEZ5JtGU8TQi9iNvKe	359
16889	2vaKxgtXBzS3D5zuaWrFRazRkcZKDj8UE8G9k984kcDhQjUddo2C	359
16890	2vaDxFX1K3GQsRFksesWMNuS6YQCv7fFWfqKUKrrCFAvdbuqnqfC	359
16891	2vbTz18kUGapCuyF68K8DaJnKhAkQVdr1sCDE1kkpyFALbN8N6hA	359
16892	2vaXSbww959rU7WeCdZFdWVHK12D9PFCiXeMp2hZqJcjdUAqb6C9	359
16893	2vaYHYAQk78xt24f9zXLH8ZDeAaXVauxP9abx4BC9jj3gWGo2222	359
16894	2vaQsZy4vwhtQnDHdieyXGqNW1xaSQ2esD1AEYxHzNNJLXxxjegK	359
16895	2vbmHwfRw3HyXBCsDh1bzrYJqZvft1usbHNvgqdWy6cP3uNwHHNu	359
16896	2vaf16m5EUX1szW4tDEHXMxcz5DKoukU5DWHxdm3ZyZJycYZQx4U	359
16897	2vbZ8CNUhp6VwFLTHtMEp7hLVs3dy8CETbg9zqQztb9UEbVkanbE	359
16898	2vbkHJS4PzF1Y62kB6hThq5DNoovhmH6KPMMcS7uTCWJbUgKbhRe	359
16899	2varaVip3TDXYvsBtKFgM852REgLDGvm6JE7YSqNs4yGPDKC2z7K	359
16900	2vb6fECGtoqLvLxRGoS27vmSy5TRnsEVRMu3Y1GYVLy3ccPhRyrU	359
16901	2vbukbij1GJRYT67wU8qRQ3ntZgq2K36o8cF3wdaipX5Txw5T9n1	359
16902	2vbpj1XNmAk4aAyqsbThbdT4dJbAxuTGrFSCTTM2XHBT7bYnf3Ss	359
16903	2vbfKuYd5kuMmSZVWmPDefAKHUKXbJtbVUPBCPskU2yjmftSoV8J	359
16904	2vaQzFXwtMaVZDHSysDQ5VyZFCc941hGcsn2Y56V8Gq9B5CrWb1K	359
16905	2vaSpgjnMDBeq9dWuTQipVEgXGRBhLHCT6MSAwwKErQ3td1uGFCe	359
16906	2vavmoPFuEcAtRXcuDHP6yXGZ6q65seZLKBMHpiCb5KAvQLZ9ZZH	359
16907	2vatHeoMS4qh5EnZyNz8uTSHAzeMdwrWQxTEymhgBuMxjcRbEDf7	359
16908	2vb9DJmmFLZj1MBCaRGJcrvQqF5uFa4sBS5JJikBesVXgw5XsE9j	359
16909	2vbnry2HKGt5vu2JPNBPeFDB8GbwJnxRF9g4Hq9kdMXGWiKSmbs2	359
16910	2vbuJgc9ApaBwq2dRT99MdjVkp5FWaSKQjuDfBHxn9eUTESWAgLg	359
16911	2vbakWEUFo8qEa8RHbNvPUAEQXHvCkQj3wzZWouJvZUprTRGsF6m	359
16912	2vaW6GakrR8zmJiiSSaXpq2iQU3Ci9xbaGCh26UVLEqVr73JLufZ	359
16913	2vb5YbdKBtNJSo2eEctfhDFbXhHTNU4D9r7yVk1v6yGzfi2Pcf5U	359
16914	2vb81WAgwHx6pvFZYBhGbyuBycgSVzukhzCbaNqQbXFM5Yw5vDx5	359
16915	2vaXsRv7dEGoeEhfoPqvG6uhK6aMXZU519tVp38K1Y1ZrGeYv69A	359
16916	2vbMBjiBfzsnSK2b5vDzx2DCi6e6Gj6vskTV1RCXxcrMjBakGUVS	359
16917	2vaDhJsZf1NdqzwP5qAhyFSPvcDXt1bYQpn721JHZas7Rdp3LnbH	359
16918	2vasjnVmLVKJjED1mAvVmbfirnxeUhtUXdsinqSJ4SRhS4wt81Cp	359
16920	2vaztZuTsLCefgcXF3JMFt6JrFBGLJmM9dAd9ZhZQumDUau3twVF	359
16925	2vaRypgLsuDJsPCpwU1umk7Vw9G9HFmuUtk9qg1QvSiBzDE2mUAx	359
16926	2vbu8C81jRuZ3CtdHgxXtTpTHKL4KxDEtGHbkqEHqhVNPbBGzmGR	359
16929	2vc2JYHZnGaPxex65mwu2nzRSrZeBp8xtpvTVMGx8WXdQitpNHL7	359
16933	2vbTu1MuvuVieNAzteTeAdJWLeg2wS9gqr9EbcbGWuPdNta5NPib	359
16935	2vagZpTConbR6G2tbF6sFBRFNLeP24EvNrAJv8H3633NQCkHoKCs	359
16938	2vapP1GZemsn51ULmBxFM29NGEQoaJoGyJo4kejWdUJUucAkoKbN	359
16944	2vbkBn3ZSjRp15xuerqU9G3QAZ9Lh8qyQhuScEqazNFdJCCwCDf1	359
16949	2vaDiAJe7qFSrRKr9Fj8kGpxdpJSauaeDNMeAu56xAbc7TY2w24H	359
16952	2vbenXnVCZqGkHvYYnLBzX5zSvrHEbvy496LxPU9By3Gs6wQBXBB	359
16954	2vb6LhPFrKC4xF7w4TsiQV7A1eWcdXw7on9V5qt47cqjSFSgFDq6	359
16957	2vbN9yyxuXZfWuy2MnVZwniS5tqraHqHV3ayQEwBu7jfE7hkeX9u	359
16964	2vbs8sEFVxBxbd1b84gsJPYexCy6ocuXZi4CmTrGbRCGPFpoQVMT	359
16969	2vai9wYgqa64LbjTPifpvkaDSRKq3EwskrrczbhQe54de6qYTbf8	359
16971	2vahyz183ag1VppNsPRjPbsVLWDvqknitzUH2enFA47BWrsh2f8R	359
16973	2vazz5mr1ZTDf3Kw35iSQUqXG92sVR4sGMjAafHNjrNt27HHqaCT	359
16977	2van1Q7SPqJfZY2mf8UP31N55BoYmm8BXGpZgK3sdvLeDJ4Ye2Do	359
16979	2vb2dEr2A1SzSUEmxTzxgmCZ1m6cLvYpSUUHX3Y5RHwLeqGuvD6N	359
16993	2vbPUsPoJMjDXkctQP6StAnKF3inotz9E8Yq4Mhs1r9xvqgD6cbQ	359
16995	2vbUUMwKhkemoyHiw4TaEg5gLQSmGDDazjEU56kXT9FKP72a1TXG	359
17001	2vbCxYNQUxQDdBhSTNq5rQFZ6Kfq1c4x4wWbvTp5nWo8KXtQy1Q8	359
17004	2vbJjmXpijV9AiFb7tPTzr8jGpWXHqN1GTSHeoSg7ryeoe2QqYuE	359
17009	2vb5MYSJjRcBxiZYihJ17rDVCCwav6iALU3esvDdrVWWttfvMAr3	359
17018	2vbSvkikoR3Gup4pR89Q8Er4NaH4GgZHEBQT1rcDPhRcUJsxWt8R	359
17019	2vaUvCFZVNkUeYhkB3Rr774RezdV7f1mvxUurYkUcu8bRHNuzaCT	359
17023	2vaDGuieGKx9oYjCdbNG97JHuhKzQsohsM29tEQFLHYTzQShLecV	359
17025	2vaZ1f1GxSEeH2qdUCsbo5CQWU5JTqAuNvPw2zFnVWfDWaqVMRmz	359
17030	2vacRyW6rWi9aKiUh5fZ27FQqkBce6euSvexAbfK9ay2xwgyk8ba	359
17033	2vbz4FvwF2cGe5tZq9Rh1NvMCPVQE4gRCqkZqCqHfd2mM5ioUmvV	359
17035	2vbEo3ZingSQTeUAWwUrzN3BWEaA2ZeYyZcLQ2wUiKd3SkDDbS5i	359
17037	2vaZwShAHce7YSF2FVVGxGoVap3g43UBg1YTPDgDMgaDmijhDZos	359
17040	2vc3Bjr84CkYyHaNhCNQKx9c41U7y82JdaFznXwCHy7RarX2K9si	359
17049	2vbAzNcgfjQ2E1jRUyX7CGAjezkdpM13fgPqvq9Tb4k4wUtpEQGd	359
17065	2vc3GSpgeBpWAAvtuQskLJDvzdV7k8LLjGZQyXvgkg7bLrYAxm6V	359
17067	2vaBP7VEs7MsFiWD9P1YG2t9D7dngPNC1MWnbyQ4KgeTvcNpNhHs	359
17070	2vb7h5Hg1M4V4YU9HX56cmQ7jSJT3hAMfjmyb3NX8F3FJZEtWQQD	359
17074	2vaRDXivhu64xac8x2NPhvgBavjy5FSiAB7WvtGWUQqUXDwEanax	359
17076	2vbjU2oiRcSAqjugRRcZNpf4uVmoVojvyKPt6o8XiW1uwHEaLHnt	359
17078	2vbAY663pGTPMpcBgvJt8xsN6JvoSm6Zf7UvSmzXREKaihQxe6Qe	359
17085	2vbmBcNmwVJkQ1ZFNef2gwNotQ3onLj8NiUofVK9W4zkcHyPAaJh	359
17086	2vayAp7SiYWqLCoBkzpYs1Wsaz937ipq8e9WSuEZdu7pHsthf74H	359
17089	2vaQVZjumnnfyAdZjm1euPrrHTQPMLf5odRfpfXgw6nC9Jd7A8VM	359
17096	2vc1vvA4hnBybhbuFXoGmQ7cucJSHm8EVtF1wponKGwC7cBTKKqE	359
17100	2vb16yhdeJJ56VAagkNb32XqawkPqeAFiAHPznRk8NakQnFqP9LM	359
17103	2vc4QEepKz3q8MSfVxoFN1bNQWHrwKhemrqwM2sZ8wcE2QWDrTzG	359
17105	2vaiCgMfKovYuRuQSKM2g7s2ZDM3PYkw1EQQcKz42BxeZGq1WQWb	359
17107	2vc5LD2HqVhSt5VyvZu8NneJmKTUCkUygW3PcL1E5gHoX8fsoQCo	359
17110	2vbutjXrbwKKMp27aaZTTaaXXd79ByZi59TVXmBZxJRqx6nqBD1n	359
17116	2vaxLKc2EHWTd8URXFYs2s47mrn7wLSd8DQXScgpEu1QLQGq6aQY	359
17118	2vbez55SuMsMpf9qGGiFb2Ao6HQ47CuVAsXLjDw8MdMDWHiCDHPo	359
17123	2vaq3wtZP3p4rcZTgBiPJDcuTG1oanqSZD2hsoVMDKQvjMgkMX34	359
17126	2vbRoQ6pSXXoRntehGjmJW4qSvuCHAHzc7So6recWVFxZF2meZaK	359
17137	2vbi2HbN44ZWoSQ6TwcZyLpqgtYv1ADDGLf69ADR1DGWpf3jDxXD	359
17144	2vaTyZ1HLMHimAk3f9cvyxW8m17GAf5McDCyk3SgDAMeh676hFwL	359
17146	2vaVSn6bqpHAjt4taXCvz9EzwZZqksyEicraGEXaL5qzmjUUKBEy	359
17150	2vaNBEjmjQ4CVjG5QYam56BkB6HLYzZc2niTGQofb16X6Ncfddmw	359
17154	2vbyG9EQSVPpLDRt1X22MFTVQGGVGd9j5YUXQYx9AyhDmcdNkqm2	359
17159	2vbFXLYivDvgRRL9Byx9B7GwJwu3JzQCEouot1yC6WFZBWFq76tP	359
17170	2vaawefCVj8TEWyhDG5KjdkkG1Zfkv2fTKbdzW1F6QtxJb2YDRNW	359
17172	2vaaaAKiBTv9mnySiJGjs1ntRtqZkbraHq5knMF7W5onrcadHKHw	359
17173	2vaJ9N7ya1Mebx5LKHt6pNQoXu3Xjm71hguHUUfpFYMr7KgxLTU5	359
17177	2vbYngdATeKT4Eh3DSRxHzTCzCZe2JQRe29E8UsPKrAFCsthG8CB	359
17179	2vbb7QtqpqFXXunxwn18xyyaLT11qNzLPNku5b7RNdQqfqZLrPxy	359
17184	2vc1CbS3J32H1PfGWXuYoj63b1b74QsZuJt49b6fhS8SLhQDJBKD	359
17186	2vakXXqK3RGKZ73KxeUXRnq5n3PgAWSCtuDLFJy9ejpJe48WK687	359
17188	2vaPF3jQ7d8Cqx4LSFLwpkDtwQADdh6QE2aGaQZLTS1zRPkgpAme	359
17190	2vaxsg6RumMupYxYwz4T958JmUHsMUjvFwPHwyNrhoaX2wDuXxzo	359
17191	2vbcapJXsxsGvgzUnNQJqrzZoSED3QXLsP1xUC7Hj8kJExb5WjpH	359
17193	2vbbUhrsjN55q7hduXzg8d5cHTpqgGYAP7DvHkqFESPGdtCT1HSm	359
17197	2vaEhQQLwoBnnn1dJENtvdRJ7QHKb64i8oRYmn1J2zF1jJvauPff	359
17199	2vaK2vevs3T49zxt5DwRtHcYd6kkwBsMZdp7UqVGdo9yBWHtxz8Q	359
17201	2vbHPzzYfy7B7G9YMsN7Twt3PrnTxW7JTdrG5fmRnXMCQaHaU9rN	359
17205	2vbBdu2AME5sMto1Re6NA9DhMG66sDDjQjVVr4JE6yf6fUuLfsCK	359
17207	2vb3Q1peTnLZVq6sSSrguAdfdeDbdkgtRqRDsaFKfDfdBWon1NVu	359
17210	2vbtbEqgETPQ4nwJKKCN9Bon4yTjvU8qo2oCCbwJUFxWqo3BGCRQ	359
17213	2vbfrNj6Dk2xgfrcsVyebgJdg4HPLunqxkXDcpU3A7ZdY8jjZKJX	359
17219	2vbdVEtVoyBmQFett7AvoXFT49nBRFqBB2vUXWuZmYeeNgoqptCJ	359
17225	2vb5tqvVDVDPoAqJy5T2ypH8cvn2DY5DVoJfGumMNTkqWoWVfbsu	359
17232	2vaSt92R9yWJE6fnvEg8KHZB4ExC1xD2pnEgNDi3vcEsJvoBMCHa	359
17235	2vaqbLGpGUrXixvdRJrK7mPPUg1k4wVykhDjKKP3Axi826SDDwd5	359
17236	2vbrsrL24eYVHCtpmVfF3MLW9FFYY9R5kB2wdvrM4Yb7LLtpMjhj	359
17242	2vaMuBKLizTDbouch7Y49bQBWPPoqg3txTabDx14HUPgiV8vC5iJ	359
17250	2vb2ESve5qfLjrcFGReiJkWZUVzxd9fjcpTWBBJkhyCWXEsC93D5	359
17251	2vba3JneF4hHXwGfoiUHixjqzGWmvjC3eA2RYEVYNySd1o3Cbsgc	359
17253	2vbbBwvkGMovTJQeesgo2pwmWwUZBp54MqqiCEbzQJruGiXf6jXk	359
17258	2vaK9KntWEQ3PrJU4wkKoPq9SL24oQFvSqLCrXPecFbKyAGw5Fy5	359
17263	2vaZcwQLwwK32dnYyDGeXpPoQzN1hW2T83XzWXsjcAPuMYaa5dXA	359
16919	2vaH5Y58WKk8P9ojHBoDjQRjYNX2f2hoyAKtp8TetoV4VRe4VN8R	359
16921	2vbHKK8sTCtW75tc57QWfhJS5RKfZVVZhZmnPTYc8kxsvx77nGWt	359
16923	2vaUph1FqDLaBjX2kgDg1ZCGowQkoXy6hb6igRVC6G4QFnEnj8Mx	359
16924	2vbDphHwNAPa3dGS6XNRUiLZwB69KBFpWmbRyfgZorPQDJBLquXP	359
16927	2vbKmFqtcg2LmpAYDVgfRSNXYmVD49NFxvirFewPoUor5cVAnkj5	359
16930	2vc5X3qKmyFcN9kj7NTGaENXMnDAsBGZwGaFsBrFUd65PvJH3Ben	359
16936	2vbSEYoZhDwYqvRZtHHfLCeAvfsm326nLQfxrzUAU7kPZBnqdE2E	359
16941	2vaRZYwnPrqC2dRzAPvkpiC68QhbTqKnKVy9UUyxpzVRizxKfEmt	359
16942	2vbje6DKZRTFb8mZx4cqb2hWQReZthYf8ip3o4MLm5sm8y4isoFc	359
16947	2vb5BB9HPi8GxSQwysPBUt4eEC4FWVXK7k74yHLrZeTaEnEhcvfa	359
16953	2vbRoUwdUw3sFsvN9yykgySHZbPAe8CgWSp2DNQDictCniYVCYyd	359
16956	2vaoZHrRndqG6tENX9rC2bArhFEodMx39ZuKqkxqzK2BFaajP5M7	359
16960	2vauNhAi5QhJiJNR7XXUzv4JPHv7JYfEsdYRPy9obFZiwnEWCnL9	359
16962	2vbkcBTAf5RL4bdXfNLVm8ACSroiVfGQrqwoytMMeLejgfqVn8rC	359
16965	2vbzdCWA3tjvzRsjM9M7XQG5KzseKL8Yk1RPTuAEkvorEyrTzzXh	359
16967	2vbsQWnw4PAMQtkbjAe5Poqipc6A5w3TfrMiUvM3deU3iivwLsBL	359
16972	2vbnKMJiwGuLc1oQXARisfcNGDk6UgmC3u1CAJcpjqXiM8ZyKvDS	359
16974	2vaPKC96d8QE9wFn9XZt2589ZzitQ7zXQNZ4bU42GRjxvQwqtSXM	359
16975	2vbDTTSi58HQJG4xqV9gXvKzks1PYJKxXfrHzLZqKcJXDrJpPDD7	359
16980	2vbGsjrtsTpVMAxEeoQWs4tVPe1i4vJv2UVYPb4NNCYhFvV9mtMu	359
16981	2vaWeSmg5rG5Yet45XpciZYurwPpRQNJNUmE3THfTkFj6grzqeFZ	359
16983	2vbhMXfnFaRavkrWKW3hH5dr5skGPLj6eJukEVZRAcBDmH6mVEx3	359
16987	2vaV9XckWzYT6L7DHE6MZcSH5ARwzNEYAsJX4YAhFpDEr84f327i	359
16989	2vaKoE1doAgiVhkruq1Cn2Usd5U8aAC2J7fCjLtwYnLqH2wM6saC	359
16991	2vaqerd3J7BB6UsE1nWzDPopv33YcbP5oWnTbv4HRomCqiBvJTKz	359
16996	2vavgLA8NGVi1hrQQoizkQnaHnbLQG8F6hafLwAD3uo54j6HzzMQ	359
16998	2vaM9en2vrBf6Bap1pPKcdeRCK3xNz79KadiCfjTVDPydqTmdcCb	359
17002	2vb2EtyXpRmn2VVYFPosLgNtJBQQSoBNT743fU3dTvqeKDjzc6G8	359
17007	2vbVRZYD7bJHcLz9ej3yHxhFVn693oZ5xo79MumP6qmwXPSXUGQ4	359
17012	2vakyhhKCRLGD3xR8zV8wfv1g869B7UMFgwo6t3b9WTZjBKCHR2F	359
17014	2vaCnV6gnUSaHyUPGKv1hVvguT5m1D62ciF7WbF1v3SwZGMFirmt	359
17016	2vb9M2xqwGRTSVLpZFbBB7CUBUEujUbud1tcoCgaifmDWxWbZEjW	359
17029	2vb7yd8dZ9kdd7ZiVMwWYnNVyj4kej2P7Rq1pEtkvPYj2FkWm73q	359
17032	2vavv4yLzMDZzrGQD2WYvcADn4EFXCTzz349mQpqpCxfBQHnNbMt	359
17042	2vaoLWXuv2Q3YmZfUNxu7jbifQhkTjM3jYZ9kcLZJriz3iJLoyaR	359
17044	2vb4qH8Bx9DkJ6zYSRf5pu75xoV2nnmxVkGMdcvGGG9MJB4m8KXc	359
17047	2vbeKw7k9SYTxJHWYri6RSCMYhKamYoXL7F9iSFRFt9SzPQF8Cf1	359
17051	2vaboVdjpMKbLyEoHPJ8iDLZJeLQEH6M5biFLJAfEKHYWCjoeyGx	359
17054	2vbSVPuCFsy2zY6z7SZ4pXxfxvUPkGxMm6ZryYwYbkFTf8648QhE	359
17056	2vahxoa3xUcEfHnzWz3jNaykLj73J71Y4p4mMkzX6yHtfrt8LDtm	359
17058	2vb5jY3vFsRuqqECKME3ovixFhkok46tUdJ6suZ3htmjRewWSxKw	359
17062	2vaa9n4wwg5pqjbt2RHQYVyAQ4acqciFTsQmc9qY3kTwCq2nx4BQ	359
17069	2vbL63Y5yfQUaBhzefCBL3F2C84oPPwQHbFYV9tcwZTSzKehixp4	359
17072	2vaN763qDin1Zs9aHKhYByoZrJigkNZySkdzM2PwBrENfomQ1T2G	359
17073	2vaGU1AtjzWAeAq2RYKgptEq7Ypj79DtWSCXbKb27MozMDU82SQv	359
17075	2vbKxDKWSdhrW9Aimib6FNiJfNGXj2U3CGK7sGkS28xv2uEq6wtL	359
17077	2vbAgqkprz8venkKKeWKv6sptuS4B8CPDJpwegLqvbLd37dyabKs	359
17080	2vaXg3p8E6StHCRktwnrZ81kG8PM8RBehw6d57gMTcHTdXLujceG	359
17088	2vaYbB6AemMuUhahEQgj5VnpmEqdUzMkyLxPCB6q8nWfDsnH4Ji3	359
17092	2vbq4RXS3Vj2hRsAaSAFQg4Ep52BnAyCgwWhXctQc47ZsTLMYEtp	359
17095	2vbcHokmbW2Q3G6profEANKDxSaqwyXdtp3T3uCXXRniTwsoQGcQ	359
17097	2vagvrrK48VAC5gA7JPnNoFac2N7T2bcxN2hwwc9YdSof4gtvGAd	359
17102	2vaiBK9pc44x7q2ySTwxCTvJWLmr6yjgyhNLVuVEZDMQCW9ST2VU	359
17109	2vajqBPzCNaP9ShkCH9w49pYDURsBNi82wpqrhPok124p2KqURnt	359
17112	2vaWDkQBoxatFGF4AnbowuqoJSAP89ay8W2GdcRP29dBFgDwCVbE	359
17114	2vaq2T3J46qchzvbFn6HwE5KMJoaA2DHFxpHsQuGkx5Q2yUQ2Cxk	359
17115	2vbfBNonJgLYBAxH3PYGnadcbwrBayPSB7XegcWBvgZCuXuaJZC7	359
17120	2vaY5W7eJgVNEzh4ebmqawHv2K3zZ13Qc9GZaMz5vxbFAJAUmKWj	359
17130	2vbvQABr7mGDa5G1KATsHeSNAJqtWzHPrgbmf3XGrUWJXBchXNtu	359
17133	2vc3WyTgGsoifZPb97o5pxyGaicDYZHQZgdooVmbeJiRqRsNueaW	359
17135	2vaF8NYdvrJzDUr9cY51rYuxVJUpoW5CwWAmQz9mBYwTB6yR91eS	359
17136	2vbD2bHC7P7cUditR36u1MgK3464XB1kpVRf572XrX5q8ZCVksun	359
17139	2vbatS2ireDADcKoTLfXoreaXwVo8TMhVXdjSu7vgWSZ7NBsMNPk	359
17141	2vawGZ6rGTbLM7R5UD8BjN8wbuQnf9eWTBbwTHqRngnVoyDcMqLw	359
17148	2vaaeTtKUMemg5REa3pDLygao6VuzVmptv1hK8WUfMms8sU6MAk3	359
17149	2vaumQsWi1FkueAfYKWGv8iNMBk8CJYRZCGg5vZHHg1XxbBCZRFg	359
17152	2vaHQhL4csP976VkX2yEr2cChPYhLSt9XjH1KoQSMgZmrrzTQgfA	359
17153	2vbgnEvQZhmkDMZZfMQRufGpJfFoWSZraiqMXRDMt1DT7JwoE5mY	359
17156	2vaV6GSAsKYdEaxjFF7QiUhG28gUnMxztarbsyka64x6fKpqxU4Z	359
17161	2vagUUkGvT4a9fNhcaQ3HggdMBbSAnFpmGaX3tJ21bVFbpGWR7JW	359
17164	2vbKGBG4ZBUkDgyS7PnZzzGrEAou9tYURwkf7n56dCMnsj2p8mMQ	359
17167	2vbBtMGTpA37vo2zRaZTDTnjQQ7ErsCD5MZSXtjQ8hFT3PwenzxR	359
17168	2vc41mv11V2PjrviqinCsgkgfwewJ6rthrHWTQxvvDfocfiND5uA	359
17176	2vaYZqKUzEgqSChMeSVagiEKPj15YspfVfkN3RkJ3vMke85AmVAc	359
17181	2vbhn5F6p95V4Tqb9pHtyUEZL9xdVaSqmML3HeonphqhLcyxsadu	359
17183	2vbLUTPiuFMwZSz6xmZJQY4a7TYsAWmbJmd9ViEaKuqC225uRbqD	359
17194	2vbxp5Cpaa3gqjY6ZmjKSbW9XQi1uzQ9zswBmbyycs9yKp4REQTk	359
17196	2va9EdLLhojHyh9ykyqgALUSoALK5VZ6RcHf8U5Cqw7xEdC3VEBq	359
17203	2vbMZmBkSjkFCdHKpwfenUHNkD5pnEDnKMg7M9XDN6N2AzFbQCvu	359
17222	2vbkMknTqh1umb4uowDMEVJ4y8muQpX2s1PCFRMATbHADE1ANXFh	359
17227	2vbXpxoUPxJ9A5CBUjT1VeBLfz9NNTrdckk85HuiUSH7nshTg85z	359
17229	2vaPGQXZd8BxCGgE3F5oiTyFVgAZU2mLgwXYQLA4JRsXhEx6mmJP	359
17231	2vb3XSMk594XzpLLZFsHQ26TDvVEsfa3FRZAWgKhehCT49VutBQW	359
17234	2vbJj94BiuHgDC8Qquu7X7Ry6E61N4WDgZrrjYrCajZyNHhJG47w	359
17238	2vahP6q3qnCnrCNQnJZhcfbkpLbrmEQmmRhkfoFdHEGKqZ9qheo7	359
17240	2vaEJY7nLuVRbTdLW2WDh2bH2RTtaqSju97jicEsJ3EsYXp9oJRb	359
17244	2vacyVp3a7Ni13qHx3bhaoxcHCvedKwn6nrJRAcHJF33UQNuQ4g5	359
17246	2vc14krNDaPR4JAKSZYmoUJ7boBNnRfjsU9mN69aE3HW2eNGbefL	359
16922	2vaFWhiRjH9GgHZ72CzFZbdVi7abpgotzwztB2Mh2AiKFb8GF9RH	359
16932	2vc5Jh2VBMeSeQ7PvEpgnXJKHm5eeux5GcWcfZTbgPk9pm9e4i12	359
16939	2vbJrAf2iNQLwvtLfUud63NbLoXhuL4RtazDEgRtCKm298p7FXQB	359
16940	2vaEjbvcYN7jGNc5V1nuLMMCAL7JuZ8ntaRRu7Zzb1f8V2yz6dtX	359
16946	2vaJ79CrmAxwiZV21Z2b5PvVExF6p1VpfYa8zq5ogE5YtvKfnpUm	359
16951	2vacUxd26132Ga3HUbgDMEt45WLzxbQAb3jbtKXFvhUHxtdPnfDb	359
16959	2vbUhQRxshLVCcqzZL7QisrqdiuToqqrYPGPtiExteKTdWy5SADF	359
16961	2vb4f8jjWNkR8pKJVmdMh6PbyDkndSSRLLsQFVMUqjuuqqJzMX2h	359
16976	2vasS6ZC5tkcAjNxBZGo8RHhNMLo88E3YgsjGy52NUigC9ugNtUS	359
16982	2vaSGfPF9YGR9TCAo3M2uzxJDSH31fH5WZs4fysmjejVXXuqYLub	359
16986	2vaNsPEq2xttwFQsEr1emG9bQfNbSPBJrQbL3jVSh1f9CG3yv54A	359
16988	2vapF71RZ6nYENLKAezzVebJo8z8AdPBRSWcCURLFsC595Z3rn6R	359
16990	2vadkjVW4SPSAr9L8sCTFZ7bkNsiaMCjJuSF4LEojnBSpzS5nAcN	359
16992	2vbS4pUzmdxsHf1TQT8z7Us95iqdj7VtTMAuGTwfVnoMnL6xDMo6	359
16999	2vaF2QeGeSTsFTswBh5hZHtQeMtip4da2WpHcfFuJDXtJkMknzXh	359
17003	2vbmCciYyyxEzTeShru8vTW2qYqjnhwdrygAo9iFPyxkq3hUDqBP	359
17006	2vbe3KezocMzHoNY4RYf5drqMufxcMy66cYjuyNW2rSLFgkFRQuc	359
17011	2vbwfGEhbZCHuppPPpJ6xXKZgFaBTEHUe6mgn6n5kVvJQDBfySo1	359
17015	2vbyAgrYGpu9TSrpTamuL5crVdLvYtM9DPct4PG65FkC7ra39RTY	359
17021	2vbytf6P36qNEApEasttaqz4ERtrZWAPcatBgJ6dPn8p3er1Ajed	359
17024	2vbC7m7CHhMLhUiKj1X9jYVXUR8t22h3rPzuHqUaHeudfadTbPMP	359
17026	2vb2ciDEoxezYFnqywvfSEqeDrrMW3MeUbqtF4iaGzsb3XXVsfQ2	359
17028	2vbPfDnGNoiPKENEqs9yMDkjLrsPYYjc54NMVv2t8mbTfeakbrzS	359
17034	2vaMx7VX3QgfhsvWTJ2Z2amStaU2NGAPBwJfDaMy2GGmcdcAZX26	359
17038	2vaYPKrWPS4JMYkkUTyLjW8wZCLAix7abPGLK9hMtG5Wrsx2zdp9	359
17041	2vaFoLXCyGnVf8TqDrxMvDGaJ32grX6FFjpQyubEZXvY4noTuLvq	359
17043	2vbRKhsSBuGDbe4SGf8dVTpf2CsJR7kSWWxbV92R33GBsjqew4bh	359
17045	2vb2PHbtg9fhCa4vcKuXUJQMmy3JtBEZAVp7a5chPVFdHPsKstHn	359
17055	2vbUqgdHGajicS3qci7YqqJoLvcjYpLz9tbMayrnrML9cE3MKoHL	359
17057	2vbsC8SZnAQhrF8DB3PTtPWvRX1qty4fFapKyGXVbVEfVx74eqPH	359
17059	2vaFBBYPERjVpg6TPYEoQwdBKzDv5AcUd9fQigW7H4fJ62RXgCon	359
17063	2vbghjK1TsRvv2Vt3e69ZGJzCDzCwhFbuJfpxFR9vpcKCgRrCc69	359
17071	2vakVks4Tz5oh35poHGqHG3fHkXPXN2yRokhs7gUAKYWSzFjCLCc	359
17079	2vbRPkURfCDfrY5D93hZFg1W26f8msSK5HKNG1nXr5jRAmCQzkgL	359
17081	2vb8h95eEgwpv8Spf9zw4aAGVqd8EEYZhnfFYEvSHP6x55Jxqto7	359
17083	2vc1NSLxDZwiXgpT3oULrxdURRpvjf5cjKbsmdmeHSwMtzyYWt8G	359
17090	2vapu5SZWRMN8aa9kQCzH9kMvQjrTgAM3uHZCXRLVrtFmASHrXG9	359
17091	2vakp1b6zsLxhzL97sWMmja5YJtiogXcrrj9EKhgboteE5vhh92r	359
17093	2vbE6WryXVMPcxt5F2YdsSdQWovDHLgdv4jKVy4pr7Z6Bqa9ati1	359
17098	2vbgjY5EDnj4ijBKcP8aC3VePFCuBoKgQKDKcxtezGKEssCjavwQ	359
17104	2vbbgVQB8LLwin4J8xoGLbQvKT5BqkFNaU3qfgYHRNgVi5Ua6XXH	359
17108	2vc1RqF6u9JW1JCn2Jk7e39jRvFn2cxQimX7tH139XaiZvV31c43	359
17113	2vbDfiuxck5YZYynNp7B3uDoS5cMKLf7bbC9hE8VomH8kkhPsQKt	359
17117	2vaSHCW9jQoKRXyn46RUdWsgvDvbDo94VqMZRFoztCp1nPwpkZym	359
17122	2vaVKo5knyHDoyPY8kTF2SZW7mr9Aa51rfn9hUmMgCnQFVFRiiWu	359
17124	2vbWWVCrzJjLJvcYrZGjagY6A4iStuoHZSgeLbJrgwJNgnxS1yPk	359
17125	2vaKBhLD2JSrop7AWUXEwCfF1Xvuy6hHteYW8SzsLdFKpHijjVA7	359
17128	2vbJ2SKtp8bcLTxCQGeUFsgVNFDHXP8SeUjUeBYb2RqpPFw3tcxU	359
17138	2vb3QrEVwmfKuJwkBsPv9ejzzZLU4BppskVTqh2PxLSTsoPio63q	359
17143	2vaNYYyAviAHAUGzUFkDbyAx8uH7AJjxMDY1S8WpzXCTASBVCr3e	359
17145	2vb9EYX9qPd4wj51eQoc1gk6YwkGcTmJs55V6zAmwUqDEYBrzgHX	359
17151	2vac6uxLU6RMjjUAfeqWuH6Sq8Kj7RG38X9giAZ8As2SoFKaPtNF	359
17155	2vbN9EfJHqk22BSX2X54xnjRCMrYHRPmDGooicFbGRtng1mP6pZX	359
17158	2vayJJRwFZ48iHnqrfo5WKuqFgidW4ypoQJAtEfPyqkpYr3k2WAJ	359
17162	2vc4jAmkLxh8gqVLoBYcVZVcZfFzsBvySce5ntH3DfXXCLoTRpsH	359
17163	2vaZ7oVcpaHNkmLCoX4BRaZYdsbbuoNN13Aw6P4BPWmyJ5LjaqnL	359
17171	2vaZeXWTxVyqgSEmW2zzQgbrkmrWqBhWwWXcmWUKPKgvw5xRoYsQ	359
17178	2vaCAmaaivZ4GkrkWsQQ5PjzsGt5KWmGoMvHqAYP7dymWGiEuGZ1	359
17180	2vabYb5BzKrdDSQdnZEdSqsG3UNxVkj9ijFR9CMN3cuZwiHocQkF	359
17187	2vbxdf4FZeUUww6w1RZgsYqdKtXWv5yxCpXZCvbE5xPaRQgHBpYz	359
17189	2vaxNvwEQ1GVhL3SGp7rKeLNrwWcDDo2YdvTZbhcZLuBG1NHAZxR	359
17198	2vb8vU4jLZfxQCwR3LfRJMBGbWvZYUuecisE1kappD8MWkpacYsJ	359
17200	2vbmN8hJ7gNZienfFaHmn5sJ3iHsuhD8eixQFiPirMEKS7sBNsGx	359
17204	2vafWXhJEVaZ316oH5MkZX1xPpthEkVLJ6jnUF7LaS3xShb7zk9u	359
17206	2vboWsrCMNnCNTtjt6qEenkTF7F6Mjx2EbqkwUVKMjuaHo66VMCq	359
17209	2vbWuvqsdJN9bdrfvi83vECML17HoGbAcWDWaVA9iGqy7WmWYVz4	359
17212	2vbof2Lhyh7S27NP9QGejm6XmzruF9ca56qH4pxSccQmfVyzNHJK	359
17216	2vbj8jorJA8xp96CrxAmUDeqLpGJG187cAbmCgZtjwQ5zFtH94Qt	359
17217	2vc2WRoph1x13mh5AuRBPdvqFs6YPxTWwhA2e5gSjjnSy7SeTDXw	359
17218	2vaJ5kJ5WgMP4EAPZUbMdVNSTGPCzik57VFJuRE3SXcAx8Bpq9tz	359
17220	2varbqfyEeSThu3NqZCk2g9YiMLB5QF4x65EfY2i8f5gPZ52SfFv	359
17224	2vbrfQUGQGVdb6PTb9Dp5sQ29jVLEX4ng48J8iHiKFFG3AF2nufM	359
17233	2vbJNYMhbdufpXVWJMVYFzxBeQxbuN5rBDdSmUZLyh8EnoPMNCNs	359
17245	2vb9YGtTwEYTSuV5ia5H6UqzhihCPym7jQ7PW9uEeQJ9hSK9JNqx	359
17247	2vbxZQXv9oEx4oGqYZ175Zbb37CiX7dZPr9SwwjmN4RddgGMYZCq	359
17254	2vbsL7n1ZS8i4jh1VSTPXxMMj8rGncxTC23bg9XCVtPfsc2ayrv7	359
17257	2varKRs3cvuCYjd15XJtTHnSxe2gibUszWFTDNhbpLVTfQzteFxB	359
17259	2vbazmmthoimJaGeD14dFDSJt9cLdoEK5naU646EtJdYScMgWTib	359
17262	2vbXDFPMwogQiehoBkJQjzmDqN9QJRu7uC2SuvDw5P9uwonsm7Q6	359
17264	2vbfyzUEVQT4fMvQE3c9CQCZsjNGw1ASC917N6HWjQddwHLcwHJg	359
17265	2vbzL94umVNMZUDP3hJ5S6K6szvBt1Z25Jqf5Z6vu5rxAfNv3ei5	359
17268	2vbC5PKs4XWjzJqbxfCvvt5pbAMCbcCg9777gCYupCjSGjzGJd5m	359
17275	2vapNvTJE4BXG9ZQ2oQuT3yGxx49dThszHq7xxZmxWUG8cYA7NX8	359
17281	2vasKa7rGzNMtCaabfqaqqFQ85411KJrby3WoHHBdVtZU7XsAADF	359
17289	2vbNGnBdf5212vfCGsY2kz3cKqYRUKCSK9WyhK6UWz3WfHbQkVx3	359
17293	2vbLZBCqLAfuXiRLqxp9udJnUhAhH7E5eXbSFCcLdFrHPtApZ7Uh	359
17295	2vbewHPu96qfDtbXsp9kVYqHdbwgkLyvZVYoM2DKiEcSDknhyVcG	359
17297	2vbr8ELYvye6VzWR41P44aGmYvQtWzAUNS8AmS3a93cK9cdJFVpQ	359
16928	2vbBi3ZfAtSxpBTWCWTBJhf5xbDw5jMES4j11EREiNqD1aEFDCat	359
16931	2vbSExXk6VzML4VwrBriU5P2VwcN6CRw4QnpnHJYi1S2frL6Daho	359
16934	2vaUSyWoLyGfs19UykMpxov1BqmUqFsnV8GSCUjhmAfvhKpnivvp	359
16937	2vbLFnWfp9Hc64PXEFqCLtgKEvKxGCUfTqBDyYkYKs8bTrsAt26j	359
16943	2vatwoLDrQCJkg2Pp1PLnRM9bfQYJ9DbCqrGa3WDqj8Bx9QhLzuj	359
16945	2vag3VAU9sem4cjDcdaaZUgnDmiuJSBhNf56RmAQnX1QKSBoheAc	359
16948	2vb7gp9fkpAUKvzZEnYjpq39KCsSYiaMGPuRSZHEFCNk3X88eFbM	359
16950	2vbXhVHnRy5bn4b4zdKM5oeT1BpREJj8FprKUJAkACT1LVz2cFSu	359
16955	2vbzDxbpwBQiJ9iJTnV7L1iqLQtwF7eNb4xyfC982Zo3kioubNyk	359
16958	2vc1sKdvQhWZmEgpPH6Y4tqKog31KgLt7iSYntm2FeXeWCXAF5y7	359
16963	2vanefq8KkBu5ZjLpqYLbLDkufzuZdBxR9PAqK2iBaX6prTQdwdU	359
16966	2vbqYXuynPtpGVARV8RqMHC3i2AxFNUrhoi1Dg2pHnZKSuDn5jGe	359
16968	2vb6wQhuMScwmCFAYE6aG7bzVHZVak3eJBEhokqa9Yjq8a1fVXEn	359
16970	2vbSaxm7TSxUru8XAm9Uaityj47pDKUNrtDa2pV64UdbakYp9SwB	359
16978	2vb7CaqEPVVYrAWfQ9bfTPg8xWnuvPZpu3S2E7Jh8Eu9QqPgJft8	359
16984	2vbFjbuCZHxx2ciiPeTYcvmnwT9tngcT1ya4JnoaSFoMroizpzxK	359
16985	2vaVRbjN5FQQZV6mvWmXnjwW1TqLnz1gRMj8JwaFuWWSsvqqWJTL	359
16994	2vaxLxQD6knGcSQaLLatBBj21MRpJCK4TFAYzwPt7vRypiQ3LXB1	359
16997	2vbgATAQ2GU3vbyNDebReJLYdoegT9fvfm6x1wJAem2bCHRoTiWS	359
17000	2vbUG1emtcyPESa4DSLrMhaPr94bZJLtV2XZgzte5okB7H6hZc7M	359
17005	2vapmL8iZLaBgPTAWSZRhahUNdgZhE8qhQQVNhNfhqY1mr38xv19	359
17008	2vaCoeQ7b9y1uqWdztVamvRVj57BY6PnTwriVCMCV5y1bZ7rZwhw	359
17010	2vaXsrb1ApDh3xXv3KKFFbE9Zfn4scHfuEm7aRbK3VHsebxaUaVr	359
17013	2vajn7tv4gDRakP6YqAFDbCqcVCa63oZeVwFLMAW1sjLqRDGrWY4	359
17017	2vbvh9s3WXWWf28HYNdxztyDaQGqN5UEDpqK8mAaRbUXtyKanS8M	359
17020	2vanrgHFfZG9BLnWQVmjSKoBR2oKBmsre6NaFptABC56A6Bxin9h	359
17022	2vb4D5PJW9vxkucBTbWuudd8nY1L9tAqEy3suaPN5kYSy7g4RBPK	359
17027	2vbttvCR7LaeraKsrQXBqme9fXDUVaMD4KUtnZf6f3MobEfCfAbF	359
17031	2vbdtr7cMLvT4aDgr9HupYvqrNMY6qmm7LLgU6zyqJi9AkqfVCpC	359
17036	2vbaqySVqYLGGRW6GFhavXh54ih8nZnx9bVNr39cBQSKGH4wAL81	359
17039	2vbfgY9Fi8X7vwFMVPuekNwutyWdbMn5gGxmMYq8U22iBN34HTQ4	359
17046	2vbBrfqHds87j8tRkQi7fj7XLBRCtfEkMQhR3p9ALxD4JGBuSLTq	359
17048	2vaCzdRnMd1TmS5EzTxGgryQN63baugChGFxhhLVTpLmKun3R5u7	359
17050	2vaPdYxo8HittFozZmrGQNyfkJEsQBTbdLYEfLqxugjLJmoPXoLs	359
17052	2vc373qJ4ysk8jhtDbSG1RngonUv1hCv67q7ssRiHCGGSNkzRvVY	359
17053	2vc5pauDAJXCKFFfEyedU7Zvzp7uuoTGFJnNFwZsRGeBU2iKr461	359
17060	2vbHyKuTxfSyGDgsu5KiKe45SPzX4MjJXFamFinY1hKW9WayTd7c	359
17061	2vakoapeEZtebaoGaEnggaeZekPC99e3oUisBB2UyNGChghmMSC9	359
17064	2vbkRGQ2uhFeafUjKz9Q1LQ9g71p3mWRUmL6Sx1NUNgw5hGh5Lgj	359
17066	2vaXjfEEfe5DGhqD5q8dzJBC8K8JF16KjwfaLJHmv4pAS67hAKee	359
17068	2vbFHcE7r4WsooY97CZf4gBjh3XuE8S7hJsdpv7KtTKoDEQ7Zfr9	359
17082	2vbkk8S387Z2ouFf39T7P29PQh3HfsXzdyRxygf5aFxE1LG4WASw	359
17084	2vaEKw4DFz6puUf8LZN4j7pVmzmVGKSirwBaC31oBgK9omZQL89Y	359
17087	2vaTf6rYXLQhzwt3g4XcQjnH5m2TMJ6WWtv2GZ5DSx2Jwnkicjxn	359
17094	2vamuoLLZQVicQSgD3H5AzkLfH9Kv3GY2FLowpdhyTmq2LxFPr4c	359
17099	2vbW4iAFUEAVHJZgBep6XnTerjqjd3rJ9mR1aR3J1yjtVvqNxHSu	359
17101	2vba64ULeqATTETpDNcfDNCPJbjtGqRiDkzHTU2sgFsuUgwtHowN	359
17106	2vajYq3LNhbaWCszfkmF9DiKTSsNrH6HKbQUuCwxk7zNRxE7PHSj	359
17111	2vaUVsTU5KebF62r4D7zruFo74ZwZ48mrGbA6HSC5sRVFPHVMVAh	359
17119	2vb9C67SX9YaKs7bvTFK3PXE7hH1wqe8XGzKEEP6Fndr2Scrqr5U	359
17121	2vbhyNvX3MUqxiQREBysCrDVfhbYVhhcG1rUeY49ucJ2gZWcGE1b	359
17127	2vafATf2KTbKrLZQ8CcF7Hqur71UstpYDaTfXFXrKZF4jdzBmvBX	359
17129	2vb7jsCfroG3hzditjUJcxrdsfxqJoySienTifNE7xCWLV75w1aw	359
17131	2vb23NDQc2vELxAmEQLqYm5UYCFG56FNkNS61X1kUbvbu8XUQWJD	359
17132	2vaNurnQbxyvVL721j5mDygmV8u7X8RDDK1pct1XeB99wuss5rRD	359
17134	2vb6JTDrnGJMze8TFu22c8niuwJpvGm6hCZ8yBBCDjsWWwhL14fE	359
17140	2vajeGqpfW8awHygJDLhgZS5fkVUhnWxxTd422s3q6y1ecLcb5tC	359
17142	2vbUEpbJuk75FAoAJVeyzZgipuz1E1dEDNXMRZsYvkpdVkzqwnfu	359
17147	2vadXyS2841KHx9PStrRCmJj8ef298bNgVRCjVtx1MKTg9KVHEeu	359
17157	2vaGhwVPnfQQHupPjeYKexRxajRX8bUg2BNnQzFrCVsJk7zUTUUd	359
17160	2vbMrFmJcffmKw8nrfZPCEiRpjnSGqS3PzeZ7QHTJULG7sEutj6P	359
17165	2vbqxFoh8HzopBA7L9hSbYWEDAJrniC5yNAw1qapxwXeCoyq1Erd	359
17166	2vazR6fGedApZb5QxUvqwsCzt1UKT66Vv4jypG3swyqf9pGTgQX2	359
17169	2vaszHaidXuL6NF8sWw5Aio214SLvFhJq7vEPDxNPPmsvDhphSZe	359
17174	2vafgadrtzk5Qig58AbFNCnDj3g3Mz9CemK4a3euscD6QsPjQ6Jd	359
17175	2vaafmqZbY88DjoWGcUPch6rAR4uCB7YjTtbFsCcuYENiXFeDKWQ	359
17182	2vab1KfUz7BczFa3VvXru7JNmgpWqWESP2TMnE6xDKbxUgdoqft4	359
17185	2vc39HW7XQvkS3WTudkFTTKhDqXK5RqtyNJeJdNHFHdxsf9p6tRA	359
17192	2vbNPQArBDsneR8HrGwr9hXcKzvzNaU15Ex1KcpxFKLgQVbzJdSV	359
17195	2vbSjSWveyqDZE55W2QESn4qhN122WzGQb3jBaNHpKTreXFegstN	359
17202	2vbEFcrN54EThHCUa63XAsqPNq8kznHNj5Qdbx2yCYAJ7GqCHtUe	359
17208	2vbRjJiFCNctw4ayxuWXAZBEXtSP4JibLb91KT8MHiNo564EG3Gg	359
17211	2vbgDbXcx2USSYWosgSGCuDSzNPrFUkJkWrQeTHjAuUSM4vRMPPo	359
17214	2vatAwsqnfpk6dqYmQX1Gso9R3ZxjfwxXAkdgv69WEGXHnq13HKK	359
17215	2vbpFqUCKDKYW3u7QhBNvgRCczzLtpeV9AsS8zPJtK3ANHH43y46	359
17221	2vapLcx4WymHVb3TG9kyH2fG8NkMZJAym1jdSqKwuGZzoaH5Anri	359
17223	2vagNc35KrEeei1yfmrDZtW7dBFTGvaJaofCLnWbzGyarxoSMoyH	359
17226	2vbZpLjRzvtvoTULvZiNDsvxyTNdTKc1aDHWTXH71nXhqEwLDryG	359
17228	2vc3TGuXh9wHziRsB5oq7NnWJbhJW62aoHKkPUoiZoBjQW6zaP3f	359
17230	2vbxMr2VatewHkNaWPZyvXRX4TPF3d7xWctvjZjVZrWDqgHfQv5Y	359
17237	2vaq5pR46W9PQJmB4uQrbUzX2VKdKSRtyxLnZSKxfbZBeJn38tHn	359
17239	2vaD4vnQgoSxxRxSoywuZ8F7gjeapUsVbM1TQ33dKWHv9SHW83o8	359
17241	2vbcLofhj9UJrowkc62fhHho4kucZG2FvGuiA1XpWRydys1jhbCX	359
17243	2vacSsXuLYm1NAE9zLK42iocVe3b1yQbiizitKwCk5iQu26NQRZt	359
17249	2vb4FX75gw1c3j1WBaRKeEQvww4FfMJkWSptgBiHUBvgJiNBR2jo	359
17252	2vaGJ3vGaEV7vTRyRP4Bgpj1RsE9MWUdUn3oi3AjsEZueGVRwEsp	359
17256	2vbovi4WmqwRjBY95hhWm8ipP6CuEsouQFcCdvmBCbLnhqG9nYpm	359
17261	2vazYUQs3wYXLQvMEdvfARZWZr5Ugbu3dKmvyM3ZphJ8YCRqyCmz	359
17248	2vaoqoJCHSQ4Sqcb93oFfqg56VS8Gxxno5oYDrE35roBhmkSk152	359
17255	2vaKYFzcc1ttGq7ETW1e144PFCapnZhdoMfmtPescbFuc7yXNSFj	359
17260	2vbxkhfeZija8zPPoQhaYzUNwZk68Ryy3GVcSBxwgBYasAdtuhGD	359
17267	2vbAtqo2RHFJQVxffpH2oPCLDdGibFiuUzMvKnLEtP7X7LaRxy6w	359
17271	2vai6yresCaHrQF6igfbQJxJsQL6KVxFBcx7oxvE5tganSzQBinE	359
17273	2vc2A3LQ6w2nTaagfuAwYCP7DnZMfEv6LbvgbPMZY8wxVPn6HLMB	359
17274	2vbtFJTyDUZp69ob3yyeSs7Qbhi7c1CfRoo2oF5LW6s6BPNKs7VM	359
17278	2vbq3biEG93jzkNnsCtD8F35Fwcg89FC3r39akpSC5NptVuy2nSJ	359
17280	2vaBjGRfWAV2ibGbDDSfZZ4uneQbZsbs9QcTew4cegmDh8ei4XoE	359
17284	2vbETDQVykT1Ke7UNkJBWzndSA3EQoN95PJJ1EbZFHtReWPvAkeU	359
17285	2vbL5Q71P5YBJDM3WAiU9ye6qM6YjceDkWEAgdWCekVdMMYNw3fz	359
17287	2vbHyTMQLpgRGK7YtPkLtVS5pYhoG4QAaZn3eSbaUBmsNJSrTeGM	359
17290	2vbLq43arHxd7cJnVtbgRXdSd7CqGwCChKceyBD8wwYU5kS2rAst	359
17296	2vb9GJJCsk63S659nWFD7dg5AJjNzkNvgZtiyt7AeZvhSAhsSq1U	359
17298	2vbxWsGXhug3rp2Y2XXNw4BJ14kLHEMRaJh7qJEEBCJstrJfPL4r	359
17299	2vaxGGomUaCuKTdQteGoH8PcQb8oPXTa4Lk8uJY8YEXoyp6UeeGD	359
17300	2vbuLzwoGMzay4rPaKbbE13tN9Aa8dLjLivHQkYxR2DCooGMSEdT	359
17305	2vbJ1Dr43euoYufR49Rmx1A8dr6Bkg851XzScjNLSuUfq9tH7Ycn	359
17308	2vbQBGndNCTvGt36BZw838nPDyyioykuCYRFEfS5Qq7MCiwBJf7y	359
17310	2vasntB58bHVXakzxtsD1kYXjUMYXHMDePrrM1JUvk9f3watorCF	359
17312	2vaJysCsqZD9aqeL5vKFyQh7uv7AEx8YBGxX496ioZN8ZKe7rsBP	359
17313	2vaiDQogLzwxZ8uawN9eduodiz3gXoo9wEJ1FZXGibN1NPGpycFR	359
17315	2vaeQiJT1dh8J5abDYTHPSU5JyAm522nR56KzuSE3WQche3n7215	359
17320	2vaUBoEthmZr2L1CpoxQvpbQGjL31GQteycw3WkF5SMiVJhaHrGP	359
17325	2vaRbqWz9ctZrhzXwE9oh8JqxAZrnjtobRH2BDpe3vHH4c53vRRs	359
17330	2vao231MvKHpL3dwSa8yDUvGQLPQswAcMSwAU7ULR9BZkv9tVp7N	359
17333	2vbc5kPJXfw8H2vTV7vXpR5Pi3YSGQbzAdUqSwskVucsGHHBmjz6	359
17335	2vbt8P62eGw4GbvUuvpBswfvYeHiQXfZ46ShsHcsf7GTjXNPQdqL	359
17338	2vb8MKQGPUhTDWgAxoTvWY1Ys8bMeDQFJrNr8S2jpeRSbsLgpXFt	359
17340	2vax6cXdFAzFN6bbv511NT5RR4QGZ89zCtse8kBkpaek9AoHHpxr	359
17347	2vbXu3nud1WQk8NGsZ7mxyRjE1MSRuT452pD86xYHNKTJ6u3Nfcs	359
17349	2vbRX2FGBXZG8beLFMDHiUx7v3wh9q6UfsWFvWmU2GDSSawHdjYb	359
17351	2vbwzm7TfUxX5JK1g8cAddjVEYcHDFgXSBaTmDLS7XJB2UsjhBZ2	359
17355	2vaEkj2AXuDcy7Pnh8jaLzVtcyjn5qw44nas7inNirqJ9swYt9mJ	359
17357	2vaGdXrTGVMHjhTa24spJXrMzebD9YLfYPNHspBj1McHDehASmie	359
17359	2vbwV6j2XcNZszxEvrBLxGc3HFY7ZoXmErvCgL8ohBrGEDbVtQY9	359
17361	2vbE1bMNfZxkU9dN7VF3mJTR8zw5HRTpTjPVm9XA72TpU6QzDnhk	359
17364	2vb52neJt5FPWy2FFTqN64895ZcgPTUsbhTjAFQWjhoRyQ78uCyX	359
17372	2vb7qtwem6tGLcs2AYX93nEdiDwGPhkaYA75sUwFT8RM9BAxMpcz	359
17378	2vbwcUy7iu6YwyxYiLk4xDK4DjM7Runc7qwnsDVkkHZuAwyMqx6v	359
17387	2vahvDjh6BsPZnqB7cRwi5NgZdAt6MdExBgSFA8aK7HYmWqsQ4TN	359
17392	2vb3UVMfj3uuWFLDBBF3UkhYsjhm72rko32vpiQCnSoptYh6bJXQ	359
17394	2vbsutCRNFEFRUnTGn5Fqmyrg3WMV2LifGNZeamr8vzh84sddrvj	359
17403	2vaXMcb1JJBy1ZdzkkmY3f15fPmovNTPiZtwzUyUQmScJLeqVY2y	359
17410	2vbYWwtUFekMaB45yUoQHQGgdo8mpaH9HNUjJCB1WQ4jeXRh14JB	359
17412	2vatsjdaYiZuKbUhJ4Qz5nv4QeRH5dg3mgVnM1DtaHyVN9YtTysq	359
17419	2vbp8BtcV6zvBgTsWciskQ1NiuukpqwYZaR7zoR9KMQtHKWTeEej	359
17422	2vao4nv8ueFeB8UQoSLCg28K1SkcTZ58XaqzaN4nCG8sdBqqpf27	359
17424	2vaqQPEChUHYpzFu6XFp6dEsotLQ7qVMTdFFNhZw6B6sqiw3p9ff	359
17427	2vb4ykPRjUFmT9xpKiZe37Lz1ZbvEQKC1kqFuXJxQAUKbLH1nuxz	359
17434	2vahm9xTLifcEfvY7pyLZ3LjLfU1ULR2qWpnX2vmv1dhcqBsDnTp	359
17436	2vahdvye3iaMfMYq8hYxqC1fcqguyqr4kGEv6zwcHmTnznFQS3r8	359
17444	2vbftznjMDTQ9JweqQf8TMLh4Qd665a3iya5aw7dzTGJiYxZoWc3	359
17447	2varamVA89J7WsqYkdhRmGsVAB5ZoABgZHG1msAomEpUFpHae9Bv	359
17449	2vagXHaP8fBQsRSPjG7VD4M3WmXyvq3cmL2QfDmBiNeSn6D1zx3k	359
17452	2vbNcrDYcpF9YLBvcyNqvWVaoPNpj4kiWcofd5LPp852WLbeeRKr	359
17455	2vaaM121u5TXsJdBtMhD3zrrLWwU6d2NtxRRGqky2zq4zM6u99tn	359
17457	2vaoApZC5jHYiMj8vS3cKSgfb6XGA35Jv2hfVTtLYtS2dzsNtLj8	359
17461	2vbKJRqSKKr7TWRj6EUrdf1BXWsjFX5L8n8UY64zNvp8qqHoiCnN	359
17463	2vazNtWpi69hvR2AQGCWF84gcwuKeQ1PsMYzhMkFG1hZqmzzognr	359
17465	2va9dZJat6KCg869YkS9ESGquuDe5BF7Lg1CPfkJStoHANzSDyPg	359
17466	2vbVDgL6hXuBGbVVqUjR1woRq1Udkak5tHYmJZCwj1WVpJao5w27	359
17472	2vbSQ9NpHajfNw2THNfRFkM8SG1Mmta467ZK5Q1k5psnwBNW2RHj	359
17474	2vbYmNKVQqv63XEnJpNh1zsPXCExkxPsb61juEaiWwThYesPVF3i	359
17479	2vbEQqYwS2mTt3SeTvuF4Jy1WJY1Df6hGL9XfZRbipjF4AvGR4QL	359
17482	2vbiCLxehoJYTL7XkzeoT1iDvLGuPhULParxvknJz2EqKpA7PAqx	359
17485	2vaDmztpvgKwFYxUqFvfiHUJsvbuocGUBpWPA2fn5atXR59vnpdm	359
17489	2vaEywwzYUAcyqmvYHQ22QEYoEkyhva3HERa879ZKhZPvRtvPMZx	359
17491	2var57HcnVMGjXib7PDLFU7hgNgVBcoPR3vegniDEWX46FFsXNpy	359
17501	2vbu8s1XqWE4TUGvRixQEis9jomtPt2XvuVdAs9UWp9DGzq8czYA	359
17503	2vaEsCQxWC6cwwYWGMeLhrQKuMJZ68Y3hSLcLrANThnXgR9DfLEj	359
17510	2vaeifCzQ2dgE3oV3T3YaZZpkJAEA1yNzukw6dSNawLfS5bm5HaJ	359
17512	2vbQzHvRp5XNYXyu9UH1p5oSr8tC2WQCijrD5UBgLpT1wymmqG2U	359
17516	2vaCqzAHt9eTip2PJcphSgU6MqSyCFJuNPWL2jGx3H3SsvUmmXzj	359
17518	2vbRPo1M9qr96NWCGZGGGNEmVXqXirovteWRxPSN3yZ3QknwJ4i8	359
17520	2vbaZST4HuEzLwkvZzbvrU1Hmo7AGiiovtSpwgyBG5sbQsHVyyXK	359
17522	2vbeYyqBqFyUBmNBdaqYtV63EUsFG3bbNcc4hubpNqDrVHxg5zoy	359
17527	2vbu3DDg1epS149MnabxcM5bMEYwDb3kew4n5YxU9MzcMhWg76Ys	359
17531	2vaJTdhjMdyAhzx2H3sXMTWFfcR6Ds9FQM7yDbWNEAGHnqokuA4y	359
17534	2vaMxyXnNdnA99ueQ6VCe7yibwyAzg3jagVxJ1wFQdUxai22TuA3	359
17536	2vb6E3CXmReeKym2FwPek1NhUHYP6cX8NQMR15DitcvLWTLFgFn6	359
17542	2vapV548p5nCenfB1UriZ8BZTFSSPcAJM2H6ze7fP5ag3qTnhREY	359
17563	2vbvkEuiW8ZN4SWiuzvrza6KafLhUdbfstcDY8V3M4zgUJRgDvHY	359
17571	2vaSvYfiMqPaDzkmLdffz6YH68hVxemAS9q9B2Jz55saXbT5rpia	359
17576	2vbkXkcbDMqis7xT7anu2UHScsU35opGwH1EaaMDS4WhNwvVoBEv	359
17578	2vayEtyMomMVG3YD1bFJg8P1oWwQSW5ZcyzTiZtQcQM4UEpgGBcn	359
17580	2vaZ3KLeFo4GoZJY4UyjpWDSoaFTX5yfTig4fsmUueSbdd6o7JMd	359
17587	2vbbHcNKM8CLMuk9jZnGwr84xEwEZjAtbm27fUhRe18eqpBxfWAw	359
17266	2vamyHy57EujDMsdmGpDhsR5Mru9rDDNv5pXY2CZL4C4Kp2B5txA	359
17269	2vathtpWVvBqCHAgUm9NKt8LtMMcswnWbVMx3jw9HQTBs7u96aRE	359
17276	2vbSpdBMcMaZ6NRzNdZ5jaSnxsqdDJMVWHm4rhkKGAT18aDabqN2	359
17282	2vbytm1hZHJ8iZKcPyx9StkkfzgTxKtdiXo5Ztyb4B3vKhJXkWeQ	359
17288	2vbs69883vtWfpnSG5z9DwrubvowLqKbqtfEb9Hq1oHFHPZpmuyp	359
17294	2vb6TV84MEuXq9NGNp5xZSQQUwQQWk5sEQKNVZkbMaeiEvhdAaUK	359
17306	2vbUPB2M7QmeJPcoHTve7h3XQJNQQEiysqwEWqFwGuV2WEUmDH8m	359
17309	2vaovyWnSi7Ar21mGwwSoefW6hrCBQifuzJTgPE4YyJLdwanFdbi	359
17316	2vaPGCDZo9MrMvR35dDBdgk2jivzoMyBdEFGF5jcrnq4MJq8b893	359
17318	2vafKAapjq3PYyJppDCUDi4gdiZyDGNZHVWmRk3KFSxs4qCDvrgL	359
17321	2vb6GWsuFEfsPVNMVXDezKX46EdDTJs1cTtS2SAdB3n647keXSRR	359
17323	2vc1dgQR4MCXuS7zsDnWMB2LxQFS5xYFDDZsXA2uSWx7gqDYh7Tq	359
17326	2vaayxVY8anDUyGe3sSbnA6VSmanxsFf1LHBFaBU94PJArACEY7u	359
17328	2vapj9tqrcecJdVFCYoYfz1ogtxi2SVzchmRuxpLB9nM1tMfiWwR	359
17336	2vbTA2tVVa34zRXWWnTq1AUDwRRk5pEBPZ6sAELL6Twmrz2tnPZN	359
17343	2vaFE6UoTrqPU49JL7NydkQuNc5qv4zDMbucKr7tmnjFUocJ2ozG	359
17352	2vaxeJpGpdbtDWudQghRnjZMRhcC29m5aekjUnDwn2cicLVYFV4X	359
17354	2vbmQYaNpmzhwuGPoo3URTT46xFfNEG9JmktfPJHzoKHk3phHqMy	359
17362	2vbRPtDwRs8qsfp7QMA8x4ZyA2CamZ8FYTcoKKhCVd9qgjAy9VZS	359
17366	2vb5qPqF7WTmJ8MKUKDxQsestAvrQc3Lrd5AHTJ2rdBN3p659Ue1	359
17370	2vaQeForfxZtZsB7AtndM8GhwV6gyDqXEBZ9VjgNnbBR3MKQfify	359
17373	2vay1efsgTN67wzcNLBX9DizQ9B6QFbeWLrTiiLMeoGbT3PFbxbY	359
17374	2vb521Xbrgkq9f9nqLE4cqHRYVhAJvdJmWNwANXdMNtHKP6Sa9sy	359
17376	2vaQsMpJSZpJDmgXoSTTs61jwdN3GwwKG9gZLY448uPzfz4A4oda	359
17381	2vahGY85mYyYs9UGr4qG3SJYgn6Xmiet2VVhRooR1YFpB6a4hPqU	359
17384	2vbvd4hVtDHV54MsyNfDu8G2yb8ALEcHwNoK5LdJkNvSEmHZXHbg	359
17390	2vbwxrAfSGN5jzLK5FxKP3ytoPgSJmjHQ9rDK9iuq6PLpxeFpafK	359
17397	2vbfSfMPJSMegp5QHciQoa8Nwfov4KDLcDLpL6r6gij1MF9ZFn7o	359
17399	2vb2QgqJLwRS2HboNawbYKuxSkNNHV9b4SpEjoPHZGkB72gFsZst	359
17401	2vaVYszBEyDupT5Q6dfSWVx6MSNFhMisQNbdod7CdowhmLGstD3S	359
17404	2vbeUiqi573Z71VqKmRYrgtPxb3RZqXTY8UbSgWHUj1o3Jq6Cdpn	359
17407	2vaXuoXHd1E21kYyvR4wJHRZRtdzzUMChi6npVNjnHPB8rqn7UWV	359
17415	2vaJh4yEKs8i5p7TtwTyNQojMUm9UdZUsgXfUS2jDbfh9NJQJAGK	359
17417	2vaDQQUNkmB2WoFcS1wDTau14oupjWw9xm7MpEdUZHUjw2mhJr7P	359
17428	2vbGFRByznXwfMCA6WiZWqwzZK1BUZArvhipG19DaJNGS2Ueut2e	359
17429	2vbW6yKptuRsXBBQCuJzPvCFSKF5rcZipUJ1WFapuF49EQcSmTrH	359
17432	2vbwQmaLZSEkLSsjDc5oC6fqxn8d2P34b56gb5ZV1k6Ve4XcbyzU	359
17433	2vaY2ovdaqoR15RTQeSw9BBfvdAXyB4oJ7wpywSEQMM3ChubWTui	359
17439	2vbWaTw7QYe4ZpYXqsHNDABQQY4us3uA8HGbMURfLki6umddmCV4	359
17440	2var5Kemsvphj4fPdfzKFmd2toDJgWLuEbaWpXaMCmgzdfzMF6TA	359
17442	2vbHUYVvPr3zwebGXx82fdgRr4votWCd2v3EwF1z5JyjY7FRYFi5	359
17445	2vbSSgLB4VSJhHJfiw7VXjeim85CBMo6MWUCgNKxDSJtt7EA799d	359
17450	2vbxhV2Z2LPR3q1Hn5EV66XDbsdhHZbvfQNEa6MWaU1gNtQ5MhdG	359
17458	2vb1daJwmzHkkLDMoZ97c933PRB3kGj2znJCGf7tC2h875oyX9Ef	359
17462	2vbueiS33EcPf4wiDRrywvDXhoULYsTHLcTqu6tMBfP685JgKoJ9	359
17468	2vbESm1Dr4PbgsFhdQmdYQ2JbgoWBzMZaK8U2TEr23GFPkYkjXqt	359
17470	2vbSji2mj489Tu6Mf46oF6fyZJ7vwU9SY9teJgivgbWAC4rwXvXM	359
17477	2vaPEne2di8ybDyDJ1vS9CikaUkggwhJv6454fmYrBMJz2opXQ2k	359
17480	2vboEzmwgw2zf9Ma81SdpTms2aDVmMMh4gT3eMn8wHiRaX6Agu6v	359
17483	2vb64MF2mYRNQ7tpbQPqmfMAUi1x3HNE5J5WjrUYLztaPo782a3p	359
17486	2vaXi7HxcZaryJqFjMQkPGEuUf1L2H5phjjMZnxXzn6MaEwCc5WF	359
17492	2vaSvt8TuywBE7rxuL1XtSrZiWSABCW1w8T3csW969zUpBfSTxdq	359
17494	2vbfYww4fxdhDe5xuH3UtX4U3rLyrRVX8tviAWw5kXLmgx4HaRnS	359
17496	2vbBiND4J63J55ftErybSwTNUXWbXmB6DHvbuiQsuvDsjC48P4ZX	359
17498	2vbcWrMy5zgkvxwLjiqoDLwEhASyW9eADtUeng5sCBVNa9QdWbAx	359
17502	2vainT1b7Xk5HFcnvrBx9vCUztLs2rz4HXivT9mvm87k43YLkerS	359
17504	2vaHaNPWMwTWn3VunbTaaUM23gLqkupSi7rZBURj81SaoZf5Xkaq	359
17506	2vaYebMrF56GemShEtXwt9kW9ReX47hsxPAJgXAfQeFXDM7WkPLK	359
17508	2vbxRhDAWzdY9akffVRavMjTG7pzgZNoaxfMQ5toKVXzapxnPf4m	359
17511	2vbBNTBxqtd1NctL41vdi7enHmUwTZN3DBhULZWdapRpN2cdXcQT	359
17514	2vazBjRpJW8GPdzyxRNHKhNQCxZXZp5UaaUdkFsMuGctYurbs4YC	359
17523	2vbx5eB5qcjSa6sBWUN7ZkLcxP4vegw9f9XwHrwUeD2T2fVg3ZMf	359
17525	2vbeg7uUkznzM8YHCdiZnB7ebWh9M4HuQ6Yw68RuZxFbvrMEiu55	359
17532	2vajU7Zw1dWyb6RmFNUawPebiyScRtX6edjBuxUc2EVjpT6AXbhX	359
17539	2vb8KTmXm7B3fsVWWhwfJXQqjvartTCdCb53496mJmdw5eq657pF	359
17540	2vbfJmdLgUBetwZsfuHVYihkdXCEztaaMSyvp8kpqytENX88kzmp	359
17543	2vbiCmh616KpF2xKy2op6cXM5Y4cmrvr7JN1Zz9QYm3yJR7Tcqj4	359
17547	2vbGCJgshqNHH4MHMgYFLRt3t1TJqxApGs5v5SaiuqQcJMwAFtjY	359
17549	2vbK5YhvkEgBFwxoyTvX6rbZBG8QpWSws5DmpUVoRWNKTjWkfAHx	359
17554	2vaVPNb9DZtP4JBaSMSLLutRAg82xzJTbKioJn3sWqAj1dZ3C38S	359
17556	2vbJp8ibiwPG1sD3H9vmqPD5CF57VmuL3vivQwBaUWE6BmaPxHt5	359
17558	2vbGgYVBJyoNkxLfkKxGzHmEdnX4xNdJtERnmQF63h9YHbLjVME7	359
17559	2vaKGxvjauJBaXUAiUiNpKzQLxv1vHGdYggSUvwNGiYJuUANN8Q4	359
17561	2vaVJCeDX8SyRQL8BGCTtqgEyPeQmAi3CLnbKUE5YQrq3hwWFVX3	359
17566	2vahcqmLxwSnEPXD1ZEPUiZAFUnCYcr3TMV1CvwxQHZsjzD3d33t	359
17567	2vbY44r7CCXcHju7VzY5ipi8kVsfgTysCzQgrGeSWZ2R7Krmjr1D	359
17569	2vbmGnLQw7vh6oBD8FvDpruJEmrLoMa7erdrcmPtyqGWC2nZDT1s	359
17572	2vajMtgwmL7RUvF3WyWdNdnzFaJGFgW9hLKMhrdkt1DE54TkQxu2	359
17574	2vay2WsDo44kqUdPgtuzGtWuLKT29Wk5fA7Dw7Zuqhsxyb1fYcN8	359
17581	2varZSpZgtNCkgGJVcYCM3XNJsadH9KczW1VJJEM4xFpY8AYYk4Q	359
17585	2vbK7PFkWuUK9LaF5zFmm1Nw9GNNNK7CLUVFm3rNscQnK6eKcn4F	359
17586	2vc5QAPNchz6ss5Nw4RpQJKBrsvJLCchpY3M9upxtTuRSSbe6ovF	359
17588	2vbBeyiaq9t5oWXKpnLe86YqGaKfYn8hq4TRvqdjcM8QghQrSnRu	359
17593	2vbbuF97v2Py2vBrh6uMxkCLYo9Y6D2duRKqNoofBjaNgXJQKV8U	359
17598	2vbGw2v6BWVvx9uQYgGqwx7UYb3uds9BA6tQ8RfF3M4uitZmw5PM	359
17600	2vaRy125mFcnQVDgmm2SfJ2zpBCbUTUUYmq1mmhS6VUHfGDLqo8V	359
17604	2vaE4agmjiKb6SmRaU2APXm24qsVHtasvGPAr3LcXRd2eqh7UTxs	359
17609	2vahyRyMZep9mGxPWAtFuc7CcNALtAYgKEaKsWkbGxYJVT5AxTf1	359
17270	2vbA9CgcFzD3mNqRnBXQn1vSyq64z4Tx2dDNYbZUm9jwx1o1ZVQZ	359
17272	2vacvwPQBes4U8UWjFirFKy3Vfrbuu3oSye5HbG41qxvVRcFxRjq	359
17277	2vbH1hEi7YrxaeQXQYu1u2GBv7yE7FLfsAt6YGScxUqDgNK5PfEA	359
17279	2vbdrFT34MTmqFTSDtyDeoVVVGJK5dRr3iB3Fb3Le8nkC7pEJXxo	359
17283	2vbEGn7ZWMGCqPuuKXtL6HKPF2aqEqYcfNrLah69au2t6ysHXTTn	359
17286	2vamBio2HkVHSfhDYZjLxHvATwGrYSNuvXxr72NM2XuGsM1NpPT5	359
17291	2vbeddNr2RjcJe4bPn8K6tpMzipx7T1d5HBiqCiM3CamgdcbP9Mt	359
17292	2vboiBiT6UnVY7RS37czMzioxhJLyCtTo1ygudoiaos2Fs7xEikF	359
17301	2vahQbZqgS9kWRX8mdwVhfPvhiiMQBWHP8rmyTBUn9Ur1LyyseQc	359
17303	2vacu9nTyQtmfi2z2Uef9V39619GpAHokvBpv9TSa6aVfjHsW4XK	359
17307	2vb6cuMYLRaT8cFgpnFLxqjanyoBrJ2M64pFj2fYnXMA9ntT8axv	359
17311	2vauvBLiihssDSZ3ddwFsEHfRm83Lk5nMhcCsditNPiCuvSsGuXX	359
17314	2vaxHtEsYfWFF5kEBDUSv9GmTz1yrZ7Qh2pzi1Gcb9Y6aH4fZVR2	359
17317	2va9rhGn6Dcc8ZL2qDjDqLcqZ1x3BfzhYnhgNUN7U5H8cm76YNmC	359
17319	2vbPNskAGNVAa9BqMAssn4QyRWHLLgusM4wGRNR6fVP8yYvR5Yef	359
17329	2vbnx3mgygkmEpFU4L1jLVYJ3JGLfZqqFnCmebjX4jByLdziNDL2	359
17331	2vapoYduCKUapHG8xE3dFYtYPShnuD7jBGPrk2XLa3QyEL4tXdSt	359
17334	2vaSfxaTGAHVd4JDYjAhC1SR5VwBuKPEjCKWJLMMZp6F2TWS9tZt	359
17339	2vay2w5aYKYLQbTSKK6yQAQ7qSjb8jRRbEmGvGEPBKKuu3QZwGbL	359
17341	2vaJzk79kMXXTHX6TCV6RXnKfo38jHTkXsvMRpEoqP8LGzW2HGAj	359
17344	2vc3kaGACXPPcrhb49rXBJMEAtCxSaXc6k97FXoaiUL2CaxYYkLT	359
17346	2vbfAu8M5yahsiWvwaCiMJoQWnGmwK991HJuQ9wfjyYmFqxRFAi5	359
17350	2vamKRFgCqshDSb26MBPhTHdTHnA2bKMdUAhMxbFqWFRUw5HSGhK	359
17353	2vaCpsTUPNFnArqW2eztFsFuAY2TAEUNbpGu7wBsKS993gjfKe6L	359
17356	2vaZWsnxRrw6ygpdRrsh1V2z6EFyEogdWYoeDdatN5bfFFwEE1ks	359
17358	2vaMNyAUWijREdYyEr4SQwvEYEj9B1n6j2zxyKH38ZVxVhAkRrsW	359
17360	2vbht2zhN2Fvn1KSXeGiLH8rotFY1dYmyMnNC7FhKJzVJUFKdBAb	359
17367	2vb73qfvJ3B4gcj2ScHWcY5tWkiKjyuRePmJeSSdEp7JYLCanEr7	359
17371	2vaPB8CQMZj6KSKCx6gUbofJ26P4F8cdGDYQE1rFktyMnH64755s	359
17379	2vbDAYbSvcuQWEwAVssdYodooKyiuKDHfViwdko7mPDxXuRbbDUG	359
17382	2vbqg8BFEVwVV7zJwBq4jxHG4Pq4R8FFRbcyxKCpqHYFVJB2z9P1	359
17385	2vaJcY2A5QUypM7TnEbdeY8TB7Jx9qUC1K9oDEsdBVHQ7xgqA3is	359
17386	2vbRQ1KgNYS5WG1wLfqFhCcnfhauQtMj1amhVf9wJBK7BXvFrfvb	359
17388	2vaR6zoAR61RJsDEzBvFuE2XMp8zaTc3Piyy4HudLZUV1DRJxGAz	359
17389	2vahSiMoNoAJ1ck7C2VaHsuKxz348y6yTVfM7MqDVCRa9Lc17mXZ	359
17393	2vb9cc7J2uS1PjxdHM9qHRxvPUq9jEAmrE5bNVktURb85h6r3bfs	359
17395	2vboHHEeCrpUhtdBNdLjGePibXwT6dPFeCqeka61HQ8bgbKWQn4j	359
17398	2vbet6op3UxfUk8ggFqwmtAiGXQdPYQkdkZsUcDwhMYcbwxQJD9Z	359
17405	2vc3L9EFNMNdGh4z1zJrVXpQL4UEukYFs6HuitYjwNf4e6UQJk16	359
17408	2vbXfscdgpZZb1V9W41mwbnpFaDxfAesbyNXRq1jAWK9uHotFLj9	359
17409	2vaxXW3ZFxs1jDMqs2jvmhRXTwcXmzFBQ6cBCTQv5CHvfvmcLdVE	359
17411	2vaRGAPkvEQsQVDGnUqNB4JeL7fNeCZCb55eJw9z1sW9oaDoDJY8	359
17413	2vai79b68X8SjvwAmH2wXyytfDH6hmBQpW425isKVG5TeJeDkA8s	359
17420	2vbsCCwRZHJRfPh82w5zzzMkBWpshTgVLks8C1Mj7cEq6YV8Edif	359
17423	2vbHqXyenJKubPkudTfG5LYEkUif7tXvPVtnsGe2KspVvfGEoALz	359
17430	2vayHqZdjVsNErZALCCJLK4SiV9w5eruVvCPGh4NYSrry3XYWzKZ	359
17435	2vb1yJgR7BQGLMRG1Ai9rjmtkdd6wDaAE1iQSRxPHNss7Vx9z6Yv	359
17437	2vaJvjoge8uo2WxCpYKqSxrfE8SXQXDKh5oK8zpgdJp3gJzAN2WF	359
17443	2varYgY5gzUzGjfnspKSs9Ukoba2xVXJxxiETnFuFVjjgALBoJ6j	359
17448	2vbEAuWAVTDbs3MaZJ8WksddAygk4eSVmCbPKYFSwsLosCRz63Ke	359
17453	2vbo76Ja55DmJ8EGa16zSUZipJSGvLTouNYVsixUpLmknZZaErr3	359
17454	2vb4mc6yHAfLPa2G14etB1Aky1xrUTfwvbr3oUcC5nduJpKzAHz3	359
17456	2vatEwicoWACMupJAQLK4Kd4Y9iMM5yXVnRqpMX9H3EyAFC2zxoU	359
17464	2vaev4dWGTUGzsCrLiJiaDvbfDYs9Z6fpSLmCqZj7KrFQhXTMwzz	359
17467	2vakpPfPTW9uSsCrDRkyckMyS6M3taPBCW9gTTEexY96Dgh5X6y9	359
17473	2vc1oX4rmzueCt6WUst6zSnXjj4cnArWsbC35oc5SEKm5xwP6Gkc	359
17475	2vaWhhU49AW9iehhApLeeWKqfTD1FcDTBnDKvzHLjG84omMNk7bd	359
17478	2vb1GWBEX4NLad7t7mtFSatzc7a361EstgFHnnaJACSyg3PdtRH8	359
17490	2vbti6TgeLvKCmPYUDQZKsN7ZFE4LQf2HvkKKP1zTF7xWeWSkNa4	359
17495	2vbUK3RLbRXFFBTCCikNrnj8M53VNzBMR81Hy2byEAVsCQU832LD	359
17499	2vaY8qq6gqtdw3LzT8e8xuDex4wfZVZbyNdjJd4R85LKvcDyUPiP	359
17500	2vbWZcVFwWooPZuhTLSYP9h34ntSiF2JdnsRjbqqqRJTn9piahWy	359
17507	2vbm9QjEcHzL5TMJib2c9taQb4mUZ2RG9TSBWrtz5HjGYTexRQw3	359
17509	2vaoyMLTpntzZkMMv91icHDr9EnJDFLDxmebhmVj53TqN81LPrwj	359
17513	2vc1f9vsjAxtDmQxzPheTW1kp7c1Lft2QoedSxHMMrwrvqGguofV	359
17517	2vbV1A1UGFrTb3n35JSC1iL3GZkhySdzgJQrsjcLGvrUx7x5KzNg	359
17519	2vbnuZpo52FBUJeCdQf3XjsWqSaJv1Z4uh5DHYGZy21VMie6pYA3	359
17521	2vakd8hXMNMsKnuf6r2CNefybtsNhfACocpZtJRQUCYm8XLnvZy7	359
17526	2vc32nbHcUu2WhxgKcsbXEVLcPjJiM7RPsGNta7unXLcWbjsCHrU	359
17528	2vb9BdY85djdhfEShfN1qj75wVd6ih5XPrAN7dkbCsG9bubMnwzG	359
17535	2vaifG19briFAC5eVxcRMp5cBzN3NAoqmW9JT4rf7AZ9iXGYNEN8	359
17538	2vbBaCVSRquYUsSbvZzdk7GasoSaZWmvnfGjr7Bn7gSTaKh2yAH9	359
17544	2vaJXkEajxbFRmQNV7qY4Y3r2UySidUerdk19iFewS1W8Sgck245	359
17545	2vbuWXDZtpSVJkM4SaAwysH7duoJFxjADVr4X2n29hhdUdSXcPME	359
17552	2vaH9iw2Dkt3HhERRJLRGFsf1ccFC68kVLZu5TibgbG5n3cURkwN	359
17555	2vbi49nFoiti6DnjfqY4MQ9DbFeT6umeS6c9HoaR8FEXmpQUrua5	359
17560	2vbRDoitF28PpubLP4nQRm9fKXbhqpcy6XRCMNZw3kSW7Rc4QqoX	359
17562	2vbXbCwwNM6HDRpX9uuKN5mZqic98ZLo3oCycQRT5c4qPPqAkefV	359
17564	2vbj7gknBprfRCihJyawA6XfhWcQop2TiLWSwuKR251Ujax78cZ5	359
17577	2vaJScXmEaoF2gitaK1fgTnHZmVhsCLF1Ep1K7fhu6dxsKD1x5uB	359
17579	2vbwgh4kCDKoB2VKmYPo1E75sBkz5ZmhSgRQez3w7nqCH9srtXwX	359
17583	2vampKhkNyTskPnaK5sBuLcYawms5rP4Noh2yJDw35AtkisEKfWE	359
17594	2vaaMKNTAfhddGn3gxEQCSabqfMrwqw91bjjs7x9u8uLLFpwzXVU	359
17596	2vaegVetwGNYPq2u6EGGYMrw4qa8KCt5Qe8eb9HwDJrae1Gs4T6t	359
17597	2vaTNBhVpFcjx2iRJqaGaMhzZemeaeVk95vJ6dNHxLiFt9v7ysY2	359
17602	2vatAqXW9XGmNcSHrgFMJh7g1CQ1XPjKxhiw8mzrSoBRZ1ZU26qe	359
17607	2vbXkg2yep73JSBQ1XsT26n5LybkbDMXhniNXyWvU1JgoA15RYiC	359
17612	2vapTwgeMcBfJGhn1SRiWdCZE3tMfewhJyNEa27kQwcq5Mc8smHs	359
17302	2vb1qRf7QPfdWaxDHiNZ3K2K2gQM6jLBNSDj2PjkLAb97RbteRx6	359
17304	2vaDtAKgEUpjPJbvtEKLqW43ZkPRVdsqiCt6CLqAdGzr5wCKVqPJ	359
17322	2vaxzBvYNtnEvWMYq4cN5BizKJAjJd2gZSeaXbJfxSc84gwUXeys	359
17324	2vauh4iciRGYiXmTPRz71FU2wpYEVKghvez9VXfVWNtCgC9X19Zc	359
17327	2vaVbheAPXApjTnVF8CfBbQ9jbG6sBNHWaec5TxiY2bauY6TREoB	359
17332	2vaDUrWr9L1BVAFiD3A2RZEgdfqkC1sJXc7wyNsdUr2Bw9DLU6QK	359
17337	2vaNTWnrKafeR3BBrXmAFfqrrdipG6AHV28noFn3Ex1ouBhJogd8	359
17342	2vaejvvLPUb1WR4Hrau1zY8pQQbhSr6V2sVpjkNp6A8JyCg1R4GT	359
17345	2varjZVsCZDNEb1JtwqbUePJj7pKFCEVeniQBgFX9gwRFwkHjsJQ	359
17348	2vaM1qkLxrxu457fykjYvW7w1wpxkSQ6J6w7GMfEyvL3ooV5tsfE	359
17363	2vb2oR3TrSQrsbw4nq4YpSKqpjqN9svNhZUkPzjGKbRcfda4k6n8	359
17365	2vbcreimdVZyAMK9oq6JKLijC99h9ruNcfEDBRjhqZd7Pfd1Q1p4	359
17368	2vbaYAz99d5Ts3hSa4JoUZiTBbm15U1qovbuNiU35WEngyWNkgtN	359
17369	2vatqxrc8MGDEj5yYwF9ahccuvbFT822dJZEMox8JZoeasAtMxWh	359
17375	2vbtg7bEumQfi4yLYRVeTz2rHvFFi776j6h6ekciZWqe1rLM3D7Y	359
17377	2vaocYzKcbFnhmpw6XqT1JysWJX6KAn6dVytX6GuapGUUpqtkrg3	359
17380	2vbN2537uzRUPVwjKZh2FrDnVFsMApMRnYHU377ECRz1qiT2AM94	359
17383	2vbV8A4R5LucbkXp57LW7ymbcr1TTHt2xVr5vCaQijMFfkqxU7jx	359
17391	2vbWG53toEw2Ty1RJdm6L9qTQprGKTNjMmWd7YhwBygm5RL9tWz5	359
17396	2vbkEUU9CBYPfwau17iQLssfyQDKJHPVc96SwDfhMhjAqW6Yeb3u	359
17400	2vaDLb1nZKaoDefndYgvxPySAMng988AfQZXS2BMsdeazYDSxAz7	359
17402	2vbsAjuxwJSqdSUXcQZobMDSW3xV7n3MwPEYdc1LW53xCb6Gxzvv	359
17406	2vb9RhoSEgnBwADxrjyxEFzD2Lsf9EiZyg8KgZg5NnJfESKJGPuw	359
17414	2vb8eCkFAobW4jnGikiQrcfFm474QyB3ArosoRd8MfTfp99cqPqu	359
17416	2vaMnn3V9W8Edtbzdka1f5y89YMLXk96UgrD6yR2xoAK4F3fRV4D	359
17418	2vaP41ycVZDPKVgM9ManxovMnxraRLHFm8tFkwEEnrfAa8fdniVf	359
17421	2vbQpya3mYCEs5Zj2HwPu7CdYSXbu8tMZSD6ubWRB9v95q9Uv8DN	359
17425	2vbqwuAh6UVDyNp4gGFAMnZNdXLYXwraoTLnTYSaq9m5GefHPYQq	359
17426	2vba21BJUEnrzvbpf1nNurpQ84Dzsag73mckxFXmcbSwv12fueHP	359
17431	2vbsDYc8hJRJcpHvDEd5eeCz1gw2m9zmYbVhDpbfE4d1atGoGtH9	359
17438	2vbybCH2EKu7V2XXfxP4ZwpXkszdKpo8z2HirbdAchNnxjUYhWFp	359
17441	2vb4hcAUjub13aicTZjQiveNrmWsCXKVP5aNQBvW7yraRHfPFB9C	359
17446	2vaRT5Wc5y2SvzvGDbgR8kFEGBVdsedyJDndmH8m178N5guDsjXL	359
17451	2vaHTiCbUQqv8P7KSYtMb84ggg9zwsYRjNLoH7EsHVQUCRzGhKen	359
17459	2vaRsWWwqD3hczD9hDSVYdKo9nPEjPnoqZGvCmvnBv8miXiFATp1	359
17460	2vb8Z7HKceJcDB4M4HxSfbgeXsy7EDz7GLHuTMX4CyQFvYSynG53	359
17469	2vb5LKaRjuK2Zqm1eaRxShrcSvA1JWvAPTQqJfyJVP5a2aMCjFL3	359
17471	2vaazVqkgAd7jWYoDAgq1so55QWx4AXBuZuQEwiKVEpNYznB7kGx	359
17476	2vbatpoD23KFe9LCf8Y3GyNALJVXzJM4oc2ETyNTWaZ6G9hNhByc	359
17481	2vbPMMANZj9fnfhTJCUw1LhYSzs4bqkLfaLECfgKjx2a9prBa3ck	359
17484	2vbJ2zunrYs5SiqNhqiJ7zpjkD5DHTSQWurXbcCRNf3pwzEHpLcD	359
17487	2var7LcMQWEiuGzoweQpcquY4kNttB39GcdVmaVyWgNVzEZZXH9U	359
17488	2vaR1scuQt2QWhv5kTnmrWk4nQ2Q9oDka4e1weUw25QjpDtse5TM	359
17493	2vayHPGcb5e7wAKonvrxdvBzkb7HfQt3XctdLC1iddKWDQYDSg3Q	359
17497	2vbWsZeoMMRfv1zxjydPTNuyEecHjjRFFe88t8uYo8HEDZ1sFthB	359
17505	2vbeex5xFb3JazH4JeSXm9jjLYFKbSCNXKAcuixL7eCGLDKbc1Sj	359
17515	2vba314C5xnPRhzCEPTw1bAmNdavjsHqgHB4VM17afhWgXKfE5Uj	359
17524	2vb8B3kSq4VT8rh7hYhdSPvPWo1rFNrH1a5prAcZu7hF1JPDm73Z	359
17529	2vbMnkYQHEDgTX5jt8rrryWFNzjJxcJcDG5uVzMAifgFTgx4fvmB	359
17530	2vaDB7MhStEyr1ShutmmbimoHFyxRtMNyeJYK86gh2ZSJYBD9kSa	359
17533	2vaG9JF6XD1g4CeiuHmWWw34e55kLoe6C1jgWLCsucSfQANnAC32	359
17537	2vb6BeYqHgkzHKicSbQFKaiQrGaExMwtUMZ2Qi8fJsXV6d8rS2PW	359
17541	2vaVtjfjRSrvTo7JR2qnpkLNVCiQy1CePpVpWqNB6MAgRP4JNLG6	359
17546	2vas5TjeNXGUqAKfpNf36V1SpGg89AtWNS24v6JfJFymGJiX7FDp	359
17548	2vavgjp8LKZBBGX7p3WoEKAvzD9GTcauqW1yrg3u7SutyvFiXZ52	359
17550	2vaCbqqzFBt6FLaMvcHnR2Sq3znziYkVovj94wUuG65CpKsw8ZvB	359
17551	2vbzsB8UbSmK11Uip2RLRp9n9B7XbUSonQGmGURyEJbCMtQug6PE	359
17553	2vaP5pZmvPb7YQ6Zs6yAyZrRfUuBnyHYoheKDS94o3LTanW8rhqt	359
17557	2vaUHf1qmtHy9j7iVQmbmTd7aJQ2djwtRvFU3DVWyLCv5oNZ3tyG	359
17565	2vazNGuHDihLcD7wXandDbPFDepEQLfkZRJBihkBhP1YWTY8iz23	359
17568	2vb3GMgDyzVfXGdL4EQ28gUh6MoHYBB6yskS4i8qDk7t4kk5tCDw	359
17570	2vaTMH4GK8Rqowa6uu7VxyK6f6Vohzvkvv2yCbowDqzHhG1wvaqT	359
17573	2vbaidWxBH51zHXQAcTyeGRA9mqDUPWFvniHHi4QYVJf9JpEC3E5	359
17575	2vbFc5Q7RYA9yd4ear4Ht5vB4oNGx6n9n7gVjgU2uYgq3ezH6Msb	359
17582	2vbSguzX8YjmxQR6ZxVv5mUkSwUGQZXNCJtGKDy7MDT4fBHnMEGu	359
17584	2vaXgswa4Q9HRXGTttXXKNsyMnwfQowsm9qGX3peF1roQea54EgJ	359
17589	2vaEfPkqbJ1ffQ7mVGoA8K3FJ4CwmkBXnLPJVVo2bWmXaz8vAfW8	359
17591	2vb3CLD1PXVL6avacijP6WQsEGMYjw7g2hqwWxWTQaByKe3yk3M1	359
17605	2vbJtgranH5oPFKMdBbFjD3WTmoxZK1mQgPoYYYSrQKn8oEiiDeq	359
17610	2vb8d1u1PBHqwJioanLWk8Gw4R8w8qhizqBz3THCtNeubonNBnu1	359
17611	2vaZrSPZJyrfFMt8BgWt8Z6T7U9GAPcEbeBLyFNCLwYQVd7RhyAi	359
17616	2vazqGEtGdTBSqQzwuUu1S3kuf928MRS3cC471BzNHtvfePRw2SK	359
17618	2vbDKoP83ZAN8jGdWdLwD1gvAmeeGSmJHSwe5A8tWffjBfgQTvZm	359
17623	2vbzVeo2otvB5koEjRnBizFi1byi1iWN3hoJHbrwSuifJo6RKGJB	359
17625	2vaWQoZrZMTe1SbPfwVChLPW8xk2pYRWxJZV5Kuu8uz7GMn79xFs	359
17630	2vbszcvNuUE2CcL3fs85qU9omJ25hyLxWRiWQ3D6rUR4XanSUjiC	359
17634	2vaenTXqitBx7NbEUsULAdyDGHBrZtLBy3Hp3LCKmWb5mkE8AW7R	359
17638	2vaCqxwMCV3uecyCbmzcEevvD2FngaXPRPdiBYwxC8C2TMn2beve	359
17644	2vbhycJetjdJXtt2X7n6Y7YAVfhjpdgFhdPkvX82mBVnWvn2StGJ	359
17651	2vaX3jutJ3dX7cvRiKuwGs9Puw24bHAU8tLfKUcENPhH7RmGbiu5	359
17659	2vbYPtR4ibMHF86us9ZWx6CvNu4HSzhXmKUPM9y2HrFHvC7wHDzF	359
17664	2vaKGi7PLwPQsyydb2dYvHQfKBxEvrQCFPpU5jKZSKT6zRB4RdCQ	359
17667	2vb66AQDJgsAxrrGKgDkMCQsbBcTvLvgrQTzXaR9YXju5XkqNsZH	359
17670	2vaLmtxQq9yWE93B3EPHE2qieGB13NBNqVNfiAa4xZ13wiZ7Pdxw	359
17671	2vaY5oBz9HtbRDyHiYYRWybhqv8tmMbQtw3uS6Rm17jvgwdgJkp3	359
17679	2vagrQeJgfJCc45Gi1Eq55HhdcwD4UjoGcekA3GWdPYzF2z4YuJE	359
17680	2vaYyLcA3dm8QFHvHiVXx4wfL45KaZ6EMmc69CRFDSiGj1Mcv2Hx	359
17687	2vaUGG2HaPyqtsSR8eDTfDWE5Fy1QCYrrvhbFRxGA2qBRkyg2sZk	359
17590	2vaAbvqamSyLF4b8Qwz2hteG6KucJjpsgi8vSoLrxsHYkGWjKyJF	359
17592	2vb62ryzqwTHBx2pyUbhASXybSDXrW3RRnnhnGSzYczampQqaud8	359
17595	2vbntHdfYbcwikC8UWAagZnLMq1PM9EdtGrf8GmmBSrphFMXL8HY	359
17599	2vaSaJwNMRThrMXgUb1P7pQYgikV56qDLy9tEnubmjNbP21px9bK	359
17601	2vamhfAzjmn4992JBhYZjRydGpdfyV3ohovrvJUKWMMisFJj3CU7	359
17603	2vbihfgJSNYBL5Nv9imyNsjckEipFFGTMVadrgSy3E2zEK5L8TNX	359
17606	2vbjzsdNbzbyZRvGfw2Dzq6Ma7B3M2Ne8cAXvNR8Gk1uLrbkzHs5	359
17608	2vat2mtM8rePUef7UDQzSqahiaBMwVXavYDQUrME2Czm2iBSNvqi	359
17613	2vatwXnXLDLbQdD3JqZF7b4qtTF1VCSLndDfFc9Ny226KXBU8rmk	359
17614	2vazAvqecyCUso8YzdKWkE1gF9v4P5uhRaGCWCApjKqc2exGcHMP	359
17619	2vbxNZ2JNLExeXZDPPhxmLv5Eoxeb3cN9nVYQdYuwiYSJrnif4qe	359
17621	2vaMiniaVvSnLQFXJBVoQ1hrb4mYDXr2eNRzYf82B91vf6ENvEUW	359
17626	2vacFVR5XrhH7C1Nvz8E6MS3fPPJK4V4RN56LAVZuBXzJAHHhMk5	359
17628	2vbFmuyRhp46fgEMKuYhdom4wmPC81sn9Q2RtNwMaf5STZK9Gwb2	359
17632	2vbDe5RRv2N9UpWjQFKT7kxDpRWL1b75Njuxm21tZYZqvtVGixrU	359
17635	2vbcdM2wTU6xHbpPtLEr5zijinYDwqRwG9W2xkdJm1oHihmn9VEG	359
17641	2vbtWGt6AZpxdYm5eFCADTeny3kyHaUYde4c72wWBXQxZK9sjFSK	359
17646	2vaPpnXtt2DGAJdkEyCMp3UPmj9tTXub5Ja2BGjC1oDRNnHaToyW	359
17648	2vagQfEVnC7dY14BPsY54teRd12P3qVHjzPuBJqp1NVjUN9gd8gG	359
17652	2vaHpKGtRT9Hr5BFdtynboTyVQcTPsV2q4XUAEgWXRyChitDxN3J	359
17654	2vbggWdyM8z8tbQPeE6u7xwMnwu6zH5rQXGV2W2ztTGxsdTPSjk3	359
17656	2vc1vN3XYMhw35WHi1mdDQ6fHzNWnE9f8CMEZ8acSUZ3UaMgb9SK	359
17662	2vaHjwe4XHYiFmQUGNXVmg5hXVuMqjheMu45Yqh7QGW7tLMX5ogG	359
17665	2vba34ks9YsR1uUt13jzMRXrQXsyDZSxMs7jgPpZ2ouFnvq2yPh9	359
17672	2vaCkBxbqhDt7EyRNoWGDt9435Xeik3bqTmHWaZu9aprArLedR3t	359
17674	2vaSJRz5oLMsrUFsbpm4ArgVLLUqXUbMUvXpZi4CoUcbXcRZ5WEp	359
17677	2vbzEAKKxNn5GyNTAuwvnQB6sY3PRac8e8KESZ1mJQ97L3WgSdGn	359
17683	2vb6eNQ7gturLscVBhAkcnMy2F4QbAf2trKjLZJpK2eQyN357thC	359
17685	2vbEucgZwE7nBAKpCyTJAcbX2SVmvPBJ8HwiDWt3roSXdnRKsNF6	359
17688	2vaL8WkgvMWgY5GcmQapNMueRRkAKM3we7Y1fZ5FMZBUpgeDYfLK	359
17690	2vb7qvXAz4p6CMDuwCMzQg5dKqtopofpFhk3XTCAbzFBrSnmsKDj	359
17692	2vbTu1UYiiEfpSV5Fnaopb4U6Hnx6njQ8LuhFL3QgFRqYcVXSwjn	359
17700	2vbSD95wimqiaP78dPXDVMmYmymmAcLn1dK9ZtspEmRnrXtk7otd	359
17704	2vbtDEZJDJ5nmjoRQt9SeKp4CQkA7vxP2hDGVuwn9kpehUCaSmMT	359
17706	2vaUUdQah89zo4YGcibsZym2WPJ39gEpido99ZMFaEeeaQSfyNBB	359
17709	2vbBH4zef1Q9jfDVv5iBr7AcLVXJ2FgRof9DLUZR6PNxusobqrm4	359
17714	2vbxgB8y2iTPU4qGMGdjsGyqBqVE4bYCxXgmT7MvdjkgL3sH2vWp	359
17717	2vaTEFhnAZ1FiULWQuTBF5wRr6ba4ExatGKKfn1ZVEyaQfV1ciLZ	359
17719	2vb5tShdVbJyb1k4hbYNjfnVfgcChYx6K6WVhQcZ2FeMxB6HPtnJ	359
17724	2vaFcbtRRx4DRNraJ7Jt8Dfse7Xs7bBt5sTHavCG7F4HfQQWD1Rj	359
17729	2vbN2dMGr1CxRyMwoX7fJn8FKkrPibMpahrr7sedUQE6AozRyZRK	359
17730	2vbVyVxgB83C2QeMqGZKs5SBz4T5CPhkztWivUdtfDBtB9TEBKdH	359
17732	2vbr759DS6JgJ12sRZbKijCHHayGeG1HCZpW798wz8GCXA4tvtYm	359
17736	2vaCmnXCRUmBkGoTohn3BTDAEQknFzn3hmxBCSzCypejDt2mGRu6	359
17739	2vbXSi8iHCEzMKTq51juWnkirJvymjyb3AGNoyUpU1XeEEP1K7Xu	359
17746	2vbnwVso9GDZ2tXdqrQafiVyiPCVtRnVRZVF4kA2vnWVRjujPR8k	359
17753	2vaMb1gCh5u6fH8UBpFucV5aoEa5cSQWTAkGoMBSxbFcZuX5Mnj3	359
17756	2vbTCrA2mTostBt63XyKoFjrM8kMb8XABmqBin6LemovuHJkr8jW	359
17761	2vaG4xZiMZZfdK5jt76mTrPBqYLjJdfAs6dFJ1D79Ym62EfsiDEE	359
17764	2vbgaiaaJJWxEh8ai7ptdJqS4xfR5mifksWJDH4CVt9gzTQHyJGJ	359
17773	2vboDvj7bxy9WTwRKAz4n3Pkr4C4eUmNekMYVs7ycggL5dg1PU9C	359
17784	2vaxkXAhPc6MsCwQQCQ5dBQnd7r7SAhqZkLBEBjpsJ27wub7De8A	359
17786	2vaH2jyxeThrPzft4p1ACBVRnwRXFuja9kMZYStDnxdm1dPcxAhS	359
17794	2vaY9zDJeFUkuP4LQ9yWJRTERiasTTApBkq9cn63JJvnZLAff72h	359
17796	2vaENdPACUZV7KAj8y4LXhMiHVLkUtoFobFMiVDUoYhaW1XSZfAc	359
17800	2vbj2dXDstwj9sY9LjYaczatKR1MYoHJ7GD4HXCnZEU4TY6eLZ1D	359
17806	2vbscSquGSjcHtRncZ6XPudTMRqrNz4FENtDUggArzMYLxakCcaD	359
17808	2vb8MGXRpTrfdpkHwe6ijpJKUwXcpXVxy5QeNhy4B9zUGkZSzAk8	359
17815	2vbGMR2PjMJgSqwR8i2w5joxsuu155sPSkiqpuz812h8qD1bkVAj	359
17820	2vamnXsgkNdeMJL1Va7VN9sgmHevpB6Fjmv3yF562wE9YiwEEQXF	359
17823	2vbiiCqNnRScfCsaoqWp8HMQMWJaHAHbWjF6ZhoSyFWYnLSQChwQ	359
17827	2vaduC9wVmNJ6689KDTPJkxNt1Xp1cHRuvtcLbT2uQDLmFHgPtRn	359
17830	2vasMiQP3bHQgntRj7t8ArSb92b6P32ffkGfvFezPJ96EsgGDfJs	359
17833	2vakHVaf2fBAcUitzXR2tWPtFKukFdS2o7F3k1uBm4uajDABcGPg	359
17836	2vaHhYW8CgYdNsezrQTrvkJ5PbJg6EdfcBFgkmtocRVr4B1TqhHS	359
17839	2vbyL9WJzoxHGeeQioLUogKBZy6TDTvcsrZvPM4uPfRL5nHVCmDg	359
17842	2vbtn6pdR4QvAAoTh9XKv6cq9arQFTQVxwCPyH5xUmq6eWrTh3Lk	359
17844	2vavKNgadnLtaTMRE6DX9mseXbrUaEmMhWWQoNY7QcYmirJjdAnU	359
17849	2vbzRwEBya2gBNzFeRsVoKZAAYAcmj5u6wt9qrZqeDTszm7MtApg	359
17853	2vboCwrTwwSA9b7HgaxpTgx44451fjQik9s3tvShiXmzShJzLHjV	359
17856	2vb8MraKwGPrwbUCuEHoNMP3oZieFS3C59LX5mxgovs99Xr2h3af	359
17858	2vc5gSP8xpaMaPugPv3dnQCDVc9xhTKnCq9T2bX91VACp1uyworv	359
17861	2vbJcVF9nckNTWu2npXH1cTkSPRDiwDnjEpaeUD6u45FxENrCSYv	359
17863	2vbwN6xk1Ga7tEwYPHyzRTAkWp9EsdrVsWnZYv21ejoTv2W88y8Y	359
17868	2vaJtr95ZwqqDfGFGgcTx5LetCF62119ARWXWpmRheio6yjVaRsy	359
17873	2vamyjcWQaU8H3yB22KNdKyHATqTHY9dTvKktCbgUVZdMGN2GRL9	359
17877	2vaD9PnbuQMb1ArBRbV2TnXHNfmqiHikCqZBAkU9q3iGfN2fABwX	359
17882	2vbYxf5e6STM4qMAVNwSiYaqWyr31o8JLc7RYDSde5Nw6xYRjhYm	359
17885	2vbG6pTYkDmxnuNVtQ1AJFPFQhV6EwCtFKaMRGioiKDi3468KPw4	359
17890	2vbanaLzpiwy4wBPc2aLv1W6jj68A8ZAzHTSF1PDZBtddnZTMoUc	359
17896	2vaSyZYz5hWnYq6rJLBnv3xRkiZVisCBnzq1gjjTipcRkY4CFqcC	359
17903	2vb51LstVwFsPoP5fPTsTQMzx86qtsnJzjm9jX4uChhFdu4XMpps	359
17906	2va9hCF4dP5o73JsrBWvfX8jpreJAubPWGC6TnEgM6ZDSZVqBmbz	359
17911	2vbU8ERbcMkiaFJWnwLPzu7KtEYDQttsrG7E97SEnZccdxa5KCdQ	359
17915	2vaXEv7AexuV6vXd7khAyyXgAHhdpHShfW2YbAimG9q1BJGgeRd4	359
17920	2vaDeY6JrZCtd8RW2SxwX1RFqVw7PZqfEZ4whFBoJnBpn14ifJ1R	359
17923	2vaaM28EJTLsuypi7PppK5KsdpTxRtghfykmRDxsBLFuBLKxaaua	359
17925	2vbNUF94JiUCU16NzsEe1M1tTeVtqxazeBfJotCSXv1DJQAmtYuG	359
17615	2vbCKNuLweoezVH4abwmYzELwkiHb1WAPF4LaQ7Sj8bRUCW7TqXo	359
17620	2vaEBMhVRBRJVXLJoex6B2egcVDjKL2vVHgQfq86XeEGKZiNjo1V	359
17622	2vbKdtbhr5tVqUt9AHNhzJMxt5bfGsmkeZM1j4FbTPRFPi4G8D7p	359
17627	2vbqEsQLQ5sHCtshPztEFeS2p9vbeujEmeRQhgSS5cAeEKNdxdJS	359
17629	2vaNyb1LtXUV3FuiPnrTuw9GBX4UfGFSSi5SqCwLCGHkf2gMhQCo	359
17631	2vaobVqcZQWBzMnVUKwrJhmhasoouSDWHN9XHmvHt9CYDSs2afVd	359
17633	2vbUhgQ2vSz3k163xZcKC1ZDKzUJajJZ8Wko6HW2RNcqsuVm7UPB	359
17636	2vags5Fsmkfk32SLvgER8XANdhwVKXWP7r56fi43sPJPZttVY3Qe	359
17640	2vbVpE9sdwdmeJGkmNvqi9kTLb1T6LRFRmsgXN3SHjaxWMssqe6u	359
17643	2vbd5U7i62v8jVZWvvcCqM6i7pM1Xe1iV5rd2AirGVuBUwND6kxe	359
17645	2vbfEoPQGydqyP4kP7EB2HUxrwB4P97uKsE1K12g3W3XcJMyhe5q	359
17647	2vbJRvjG6dYVrFRdEkuBhf1zWvhVweGZhfjXG48rXxWUz8wSsoYE	359
17653	2varbFZknpYY95dzANXZSz676R43kutf3yToEVS4Gs3VCgxr7S3z	359
17655	2vaCmCSuxPjSGoiBSasmnXpZ3KZH7xeiSJBjn4q1seZ4oqf7Jo6E	359
17658	2vbA3dZYsp71uH5x9qiF5NWdG1yBT84HJHKQV6d94gsgCcMYbs5m	359
17661	2vbFQCxxJsf4Fmbs2Gta5yhhQS6bPwYreuYsMDp1WGBjaRxxhdPC	359
17663	2vbTmpSBUp3qn9rjPjjv49MgX5zfEDdzuFnHAg5xprHoVZiCu9qz	359
17666	2vaTTCLMR4V3BK9ZiVY2VZ3967NJu2to2dzh64CpNgWDM6Tqnjyt	359
17676	2vaq64P5eeNpSYL5A3Wyb7txu7RjArPinpDtD4WEdFWwkvKoFCZd	359
17682	2vak3fCnrky38swUVn9nFttzS4dfhSy5118VHeyL3DwNQqgb3JPL	359
17684	2vahaLEhhePyC6jbbW13QsBDr8hR9SuoByzkLHJ5JgdDeZs1TUg3	359
17689	2vaECJ6BgodMM79Xo6pLHSMgU2RK5QwdD11xnNiwdJSTM5xcU7iD	359
17691	2vbxNYtJH6KLtGcBKT9SNjHfSDktJS54uf6oNeV1XZV5BcYcnpWo	359
17694	2vbe6dVkPnomYLwtrXMSqU5mPyZegb5JciSbx9FVWa13z8o7QPmE	359
17698	2vaZZia7syTnaPhD6m5gzDu156GN6FjKwXkgMhkrfdxseDgH7hNh	359
17705	2vaeDvSw6XVP9C8qYY9dzwfVLRmmPF2UV27gpWP6Lk8TKnxiBkA5	359
17708	2vbzna2nQswFGPQyej3GpHyEDE1pgMjFop7twueJr57uLFGge91Y	359
17710	2vbY7GcpYuECTZE9wX53TFi8pF5peVYbUw9VKDetMyU5fyrhDNgF	359
17713	2vb8xCwhpZkNcrmj6gQckZ3j9W8dECuvDU5Guf2AuDHjxtLFiuL8	359
17715	2vagSsuu2bevdpabToQpBFZA59SHB6sxiTLtJTXWkxPp6XYXSn1t	359
17718	2vavLU24LK3qfH92FjNsPfxn54C48PRgXa19m8scvbYaEzZqwYi1	359
17723	2vbQ7hSezRfwCdc2FhQooyUmpg8zCCWTgriFA1kZj3oCcyte6MLY	359
17728	2vbpFrmKWhbWeUgmNbkmtoGBs42EMH7XiV4q78RMt69hspvUHMSn	359
17731	2vaQbgqocBdUA3Px4F9FUFB89Lohc3SZsG5XvWsKdjyQDJJviGyo	359
17735	2vbAqWqNM9MvVUuYBVvy9Jq98Hu98Xoy1ktH9yYs12gEKGxidUMN	359
17738	2vbDz2JCdyaUDbgrar9GqgYL93NMgkUxKn9v7bZ1MCK8LnuQXZyL	359
17745	2vb9ZYgSSZRJtMHpYt4JPMeDcEFsXeFgp823jwsEyXELfnKDfW65	359
17747	2vbcYkDAxBrrf2uhNsbQSpXURCx95U5pppMyG5QUogfCkio59iru	359
17752	2vbtJhBdYGoQDKPHxGUekv8dHW3HkniFpcbGXS8TSJCzSuG8G6DY	359
17754	2vazqS1ABEPy2fnDJAcA8u8XNomr2J6Th2HbNpMnvwkAyzKbUA4p	359
17759	2vaHpsJySUUDTtTWDUxdw6pJ2LaPqjJtJzCEdugWyCdyPuHQHmQf	359
17767	2vaEvSRHEHh8SS6fbyBnRJb5zbVkmk8JeufBCGovptdnk6Lq5tFB	359
17778	2vaaX4n7NT9ybMdJdmsKXw1mXkp9kZss4LzkAAvcGCLv3byrwJT5	359
17779	2vaGqjZ8ZAwXBHMMMrvbULquPmHxbyeGudrAppB2nGv2JbpzWTec	359
17782	2vafLikmuRqNcKvr5DvFUBmUBRKy7zXzCUz1V7PHLYajq6kQSYxA	359
17785	2vaBGvn6XYECawVWUuVCodzB1YkNJwNuGksMmWEjc8RXKcmfLim8	359
17788	2vbvLBd4Lvs3Pno6QKq2UBVwT7ar4MrQyrKwU7Wz4ASZuRY611yr	359
17792	2vbPVkkMCpZrMVgz7sfVWMZKe8jnSFvFdsxMAkgQfXdxTRP5e3WB	359
17799	2vaYr9W6URbsqac4Lusc1opZMg4r7xP194A5kzovQFUm8wz4jDcC	359
17801	2vbrQZkpKSzxByrc8mF6HmV4FV1wFBxczTdNysbHwpMdq8zGYpuT	359
17807	2vaUL73fanorYQMC37mnNffnLAKZMEhAGSKziCsoLbLTrEkx1JK7	359
17814	2vamnGB4qzEwD6bvjNHjawCMDMTGuQhVxFHdmUm4aXpes879iVow	359
17816	2vbApJJTin3c2okvpvjojHz9J1fpYnEVTCa4kiZW71wsKm3u3t76	359
17826	2vaizyckJi8aCuApazuYBzC2iDwgCqviPKs3DB8Zo5R2ToUhGqF7	359
17829	2vaNFtFLyFt1m7UzvLnstuTuwtWmf64tYa7hNiidHMUGd8B8GTHb	359
17831	2vbtNJ79HNswBhSthz7Dpu2raCNES5LdhXwYGesyzVinLhGxL4qW	359
17834	2vaz415hfYsynx2tkwFFxC7D2Kim1eZx5M6apNnWEvKvratNbRUb	359
17838	2vaxQBabKr8udCFpypp9AeHw4c7URa2GoD9MbycCsrz8RXAuU7CP	359
17840	2vanazRn1sBqMTTNYrAeeSx3dRdDcFUhRUVmKEpUwxnmPEPBtJzf	359
17852	2vaKgD8odFZsWGU6oHQ5zQmgn8FuKZbgdyz7KSC5Mtj8U4JKzTAt	359
17855	2vbkHGiGN1JnoQDENHxBm5ozUEBBF29XQaBjFEiRCvKteps9iaMJ	359
17857	2vboC3gfCk7Ka1pAt9U4i3JCFn7zhD8eA3TQsM1NSwWh7yBBMr5P	359
17860	2vbqvssAg9JHDeRGPW4gshdbJm8gNAx7o1GLWT49opHhRpS2mcw6	359
17867	2vbkyPMyFmrNNVSBCmkysfNYFugXPrK1dz1ek64kUYBESv2o5Q7p	359
17869	2vaRWrswTjqzNnyX9KsuoXXUCoTyjtnpcqmBGpFtPEF4NMjzFWfe	359
17874	2vc5qWzNLwUCHN5Wjm9mJBvJMAgu2dQmE6R4FxZGoZ4UJUwBYSRH	359
17876	2vc5cYRH52SCAH32wkH8m2BoKudx6hdphqNojUd4aAPe7vi5ERH7	359
17878	2vaAvnFV7tHgkDC3nbuzf2GpUUyZob88Mxj22BZnLQYviVhRB3ti	359
17881	2vbiM2DBdKGSLqQXnDK6upBNdSkYDx3aTtrj8NSci7QEUdMnDqP3	359
17883	2vaAyHjir2rB6bNUHjxNtUF6WTkcBCQcfk457L9AzC8VvnteX2Rk	359
17886	2vb6vCysYMc8LVQ9QPC3Ur8WizNS2f4ihzzq1HsezMjuBMNLYgbE	359
17889	2vaePZiRjARw9cU7EWUqeDDEZNWCiw1xhuvzcX1kGJV1xhRkJDRG	359
17891	2vb4mY9Hyazv9gj1TWo2NRZsFHj5g5APrrm6rtoXDK9PRfqzyxot	359
17895	2vbeio7gd13QPYnTJM6mHMdoCafKgZ417EE56CLM5pXsspU1hi6X	359
17902	2vbPkk2Qr4ndK5ynkRnTFAotPVdtFYjotKe7PjjHMpn2Uo5L4S29	359
17904	2vb9TdiWNju1XPmErmLy9j3QFK2aGPpLFeRtGzATC6b7ap9U8KNK	359
17909	2vaXFgv35jssbdDXcM2ki1UkPgeCMhj9V2B4nGzRE7Town67snHe	359
17918	2vbntd1mMJE4hmjxYmwiQNqMC8LrvKQjnT9hds9yyGQY7Kgqn3hC	359
17919	2vbxt4zfxx5Jp8v4gPqSTj8CEr2ycHbrXggJm4i1NmkFLYifhNR5	359
17924	2vaNqra4uyV7Hvs9A4N8QScz4i8MzmwAZ7YJToHAjCpj1MVeJd6V	359
17927	2vaEGDWRwcQuAw9H9GrcrfBW2bs95cebLWXfb7T4WtUsAXYke61f	359
17929	2vbNmgdqCzWivGPQS42DyZ8JBxhD1UYNyLLPpaJ7PuGGw3Js3XWW	359
17932	2vbHaQEP3rMXpgm3sfj3PsR3vfHznz9sAqd7cRLhvd5XYiEcuqs1	359
17934	2vbhzQdhWWn9BpDvYZQEMFGriTtNhb21UQbVBNkxBG5kBL1nv7FD	359
17937	2vaTosA8BPitzuNo9Cnd2zzoRUBmaz5fm2vXcRyWPuyN3zM6aXN5	359
17944	2vbjeFUCvNo8RJM64MzV1MA8pdDeBbyG4iyVCav4BZS4ywFfEq1f	359
17950	2vaMDdYaj42J73wPffKTF8k3GCDY2HYUF2ZwKwHTmVmpZLVn44aN	359
17953	2vabsywWbvYuhfaRQVACA1PFwwzDfQma3KJ1nhXDBVB3Mj1dhRoX	359
17617	2vaKgHCBQvtG2r8vueYf8f4foPY1TFg2QBA3B6QejyHnCGExWZ9L	359
17624	2vbuh1HCT942cB8w3bgJGW6MJ7fAkpRL3sL4CEs82BGiMRrbmTzZ	359
17637	2vaQmsaJtXKXXRnoWQdaPowrVJSMLzWCpXiZP3GkB3TShM8wifaP	359
17639	2vbRHDjgQA7QkfXxTbuQEow3UCoG6KK9vhCjNrXyByabFemUcFZR	359
17642	2vbeUXfbJEHRXfgFWSFXnbjDvXAcXBaovX81NXHKFAmd2WL4N6iD	359
17649	2vc3DfbqEw5XXaAq5VbwdXcJTpnuf7F5wmPepdNywBPWoYmxtNjo	359
17650	2vbM1i1dNRwwmtv6uCJNWMbHbKNxxG83X96Ptd1Xmvq4XUN5ccCh	359
17657	2vbL1AavBK4k6ydeZTSfiEKsHQ8pPV9mYKQPotvfGnm2WJtqHxkN	359
17660	2vbFuX6CvX4ecdVpQ2mvdXvQY76kFkWZxRjtQjjJKbcY6BPdf2sA	359
17668	2vb3LQ4KxUFRrBGYqvkms4cXTjcW9KV2vcP6JYk1ZLnw6Aaw1Lgg	359
17669	2vapycoNTYjFKu6Ye1x6thP3G1LNm4x8ru4rinXebvLDfkbAX3sT	359
17673	2vaYgXzJxJAK7L9DmfPWaLAJhx5VeJg4bYwVE8h9dbsW1bQogacE	359
17675	2vc49m5zbMiivVmbSFSkrj9MNv2UfwWvM3ircm5rWaTgzoDLvbiT	359
17678	2va9Uy3maDFYQN1zo61msEb8bPaFiYEcpd9rkyNPGqLfNGwcudRq	359
17681	2vbF5ZiM9MaReT7pTjSEemRZN5h7SrXCkXGCRcUeGt9DqNuaNuZR	359
17686	2vc3VtFUsRi8EiMj9oRF2K9ca8yL3hqev99n1PLzdnEXVbqcvh8G	359
17693	2vat5FHgbhtdoeZXPesefQVTu9NgMd95vcYstq9s6tdLRwJcU5VB	359
17696	2vby2ZGBBFfSEQ5w1mWfiEEjUm3rXBtJFYiprpWnCkiJvpZvxFrT	359
17697	2vbdEbXzcmVUjTEYmeT7wLw9TZi8WbCGxtqyQisuNQKJty9BZgKV	359
17702	2vajak6tMuaiENV3yVNNKxEowfJomm8tZtFVXTXWZuVeq1qDaJVv	359
17707	2vanSWBMA6uVZFebRLbKJ6u97QpiVw6kq2DhAyWK5cLeeM2H88X3	359
17712	2vbnUbMctAyTkqJ84sgfZAzonJLoyn657c9rVbHkUfBK64gcNZ7D	359
17720	2vbGnejcYn5W1QGuXtMgCyvudHb95Udr8a4rHfegiqv9dXyrssw8	359
17722	2vbrmAGzYgQeVmTCErfTJ6AYqNfc3qj8FbyQUkuxB9YS9Wot8TCz	359
17725	2vamisjDY2BqemBP2ELdQnEDt46A3Y16RzpC3Uj5nh8SzE8c9iZc	359
17727	2vbYvpHnktv4S9imP4PpBM4zjQMCs3ffdSs7vqi5RLKny1diAtX1	359
17733	2vbvo1foFKzMB3RSTfS5hzHPwvMwtEfcWgs1AdDN3RcsNHybDurV	359
17737	2vbqVxRTNNt2quPcxw2Bu9fazANr29CQ8g3kUS2Tohk5AFot8UzD	359
17740	2vas8sGUWjskMC1KMeFKo6TpjKprm22PD5hUqTA3upofFWNvWzM5	359
17742	2vbv7BajFYFQU1PpPToJ37AdPXyedMmSBZdHm7nRkg3sMhVncQYn	359
17744	2vatUjepfaH6KaJZ2pWWbjL8YtQkovz2F2W8CN5TySPsaTDMsfdv	359
17749	2vb9a6RFY6qSgS8JUuDvgSpieL5UiGUczwAEwDf9LPZtdoaeJDQF	359
17751	2vaT86TFmmCyW52NepCDZcLzDXLbiXu7TR23L6WZKRQjfk8rXu9J	359
17758	2vbkWebJUh2EPxqiTBZZcbJf5rVnwGVBPVRUmnwRbm43hUfaTHZ9	359
17762	2vbdwtTbYnTymnsQm35RcWXGEVNd2LG2ioan6wApfPRmzWGf3z6d	359
17765	2vbQ23TuPQwJuqCqFU7aP451W7o36P9zp2wQJUq9JhTLrsySWH46	359
17769	2vbpwMNj4xbP15RDDTm1nmLAk1e7YWLSyezoCkvvYC6XGsZKQcst	359
17771	2vawJY9WJeawtDND44aFzWjzMxJktmQsh26UadQW425akMyKx1Nd	359
17774	2vabPa6CXEPVTTvvS5JoncDqz5qmS56cgC9iyYYxSv122BtDwdrG	359
17777	2vamCzFj5ecLCyQupnc3ux5dAPJ3KnVUXg5gz3XdP5Hm6o8uoGgY	359
17781	2vbpAsvvkhawZW4ykT4zwNUxFvHnZy4HYZtWub3Xw2SEGi7FaJhC	359
17787	2vaiABz57LKasgi2MG1AbNG6Ap3eg6rCXntgtr4C4N5riocYUMwS	359
17791	2vb9gyPSCVokpw9op1AE8kX29p2ZUixRVkuMGLW972mtwFGxRUuX	359
17798	2vaAPPR1t3FXCV5LghTqGiwFeubmrB3phjfmcYzYMt2P3YWcryyC	359
17803	2vaNLtnPg7XQ6pHZjZzsSd1tcqFZo3X6sRzXBPahTongSz6dUNww	359
17804	2vbjsFuXqypeNnxbMXNX1KKocGTmK4HgdRonTeYLSxXaFaJ8fVcm	359
17809	2vbSdooVuGFSWRehnUCMprCb1A5Tz1G2u1KK13UwszABRQU75Zun	359
17811	2vbNBrs2hUn38BUvie2tZ1qvV9wjhJUSFHU5cWYoXBj3dabRG2r4	359
17813	2vanw29tEGB63rgWXzyuNgk8eqG8h3hQCcRc4TRE23sjYoSfgzMY	359
17818	2vbcH3oSjGhMgfMJYn2DZxrj23aLjsAcYWruADYsbZqw9MKyNP8E	359
17821	2vbzEDSkyK6PWJTL6LfYJEVCJLyohvH1UJdomXX7Lcbs2uQuKSUJ	359
17825	2vaZ9wBGFtyzYyy4RNmgaUVX7qxybTyrWrLmUhLP7sBwuyfd1yn8	359
17828	2vbyNamrtcfFr2bUfESaiHW7C7BAnu31Ttopmv4RyGdoqhKQnGTH	359
17837	2vahaTaULYXViNzHJkAa6zoSHamy9njdwAQvh78NG4Cisbcf38Z1	359
17843	2vazEJCVdBqBXBA5ox1FApgBgaWqG8nbLTB1pTijLxrgUVrA379B	359
17845	2vaRqzZ7j8mVKBcyoK3omdn2ScXoPfFTp1B3eYnRvW86kqjnQgyp	359
17847	2vbC3jJfwgBaJMj2pLRiJxWvdYo8gRnML6KgccS4MJY9qQSFr7xA	359
17850	2vaheU3z1ZfMESh3yaeBinjEEsHRdVNDr6YFUoJDqwx8BzEHCTn8	359
17854	2vaNgdS7sJsYDnDFxLYQFYJPEGc4P8dWR8NWhxY5hDrN9wkVysEp	359
17859	2vaZXKR24pBisredrWEUJ1ii5H8HxcwrjZ1ZjGts9Gr7s1gRwrev	359
17864	2vbBnu8Cqspb36H5QgpazeNXdPsU8Po7qSANQBHu7mqHiZCXacdH	359
17866	2vagZ77pTpTt4xiDWPqLkCctTsMSrYMhRJqJCfw3BswjpK74pxwr	359
17871	2vbyn7uvEgCuaSGGZyJDywBX7s1ekm4YEUBdq366W8qDCDKBDJio	359
17880	2vc3EpFPx6Kjxi4CTgSmq5aWMwMuKahviWAYSXem88aWzehcmu8c	359
17888	2vaf6Ja2g4bnRCvk6ekNhmSWaa6UZHh4PEYvrkhM8Pr83Vjg72Vn	359
17892	2vaZgZcaA7hbZQQuYopx7cz1iimvhVK3tq2ZquKWRVU75MncYm2B	359
17894	2vc4iKh2wo9utsmo7tyPc8QBy5hMBy3i7AkHNAXyM6oiKULNhBcv	359
17897	2vbZoDGLtXjufHBVr9Uuv4PVn4woiixJLgn27LPqzHjZqwSedgnh	359
17899	2vaPgkzZ9YVjogBeX8NES9sfubqV8Qrr2WY53d6wYVrqDz5Ydy6k	359
17901	2vbLp1Bb5HXdBLVCK614Kz3FsNbamg83C69GNo4UfzQ3yMFaEZrA	359
17907	2vaV3eu26GXZXNphuapenC8ybDw2McDR9pNyQHjEFmQEBbLPiP61	359
17908	2vaWRGZhjSecJi7Ar1z4Fzonj9EkjgZ1HSXT1kNvFeGK17swyBf3	359
17912	2vbUnjckPFzxL5TCZC3TyJkCK5fs76xNGxrcrvdpVuVMuowMAeQB	359
17913	2vakSLZGjXeAsyBC2d485facdbDp8Tns1j3nsmuH4Js1kqFvHzuZ	359
17921	2vahjbffk96MJqw9aQvNKRMc1qWd1QDiPTLC5d5L1Fr96UBqwZzt	359
17926	2vakq2UhBtm2JGJECPifvcPWtvBC4bDnBtG3RfuRPWFxuVeQ2Km9	359
17931	2vb7s4y9GKWeobtaogY5rZgYDwChkorkD4vTSMVXMnBC4k2R25nV	359
17933	2vaLuybGyZUESS6aGom1p21UW3fqD3qHP3DPWw4f2fr47q4UGzPU	359
17936	2vaWkyArRAwa7FNJopJCb7LgcA4tDdLDpRorCiEKFmqP8HM6Ki7x	359
17939	2vbtJJR5A8xssqv2b6UfkKDV8F2HzFzd4AFBYGhVvC3A9xjn5GHz	359
17941	2vaQMbTEbnXRBLVnYL5nBBc1Kc3coS6V5wU3YAW6skB63rfdx3U1	359
17948	2vb5R78284CubYq9UNWshGxrRfJJRAj6kDnRmpXKDEpVg6aUYti6	359
17949	2vatkwQ6SR5KS2YBZ4zWnePuferYtFuTnAzLY8BwFJpwhezgXMUn	359
17952	2vbcVhiv3h9ekAi4wezWyH12gJxrvMn2cBiZNJ8KzysWTfdzTrip	359
17956	2vamfh9apcZq6wzpDW5ENTApX1Nr3b3ob2DhJiYVUCMWz6YLtaHe	359
17958	2vbcQiXojAo76W1BydUvJrMHWcUherjjpza4ckDXXw3aU1Vg2SGt	359
17959	2vaAhiUmmYnC9rF4JLRCfNd15wRxK9kURkpkKNraJ9nCgQB2MSkH	359
17963	2vbVXao1dkXxNDmSa1VY2JC61aG7T3rcpXA56cbPLEBWNXaw3mRd	359
17695	2vbd1dieVNGGSd6bDxTtfTAoLRYPzABqGtG16Z1Sk5n5R6t1FjPR	359
17699	2vagJHi1J8bh1CbTGVxNBpmkqCaPraFRQkLkPTqnjhPGaXhcZkGh	359
17701	2vbms9MNYheM6vu9pj5vueJZT19sxt4fQcrTQmBrQSAsNhR16Snb	359
17703	2vbxWUNZn5KyTF26tbkWhBzW635irMNEe1E5u5YE1VQQjw4uXAfG	359
17711	2vbXP3jAkHNWPijKNa1j2sX8gL3UPhQKvEfMP7mCW41fucUQgQQ3	359
17716	2vbFmsnmUkZXHRfnwjfTexutTuHPHrygLjviEfYFZqAuQvS9LivX	359
17721	2vc4xgNHvi2ZvCjqpxMPt2iJMZE5Dh9Wz121uT6ZpjzLKqZnPBYy	359
17726	2vbyZgYNFbnRyEnUiirv9Wke9j7YBr8NmX6Y2D78y2kRNp3EJ28b	359
17734	2vasesS9wbmUT7yvdy1bnmYxr3KEdBYeZAfDP7YyZ4M13HcEbJ4i	359
17741	2vaMsugrmy1CyKJppBqBMG7AmRmQMGZQxpsEiExZ3Azj5wgE4DRh	359
17743	2vbkvQFL8jHUds6WDTTSuGuybhaLCjxbYQZB6fGTTDBMqQot5o7K	359
17748	2vbVQxc1Am2dCRLCUh3fjbkRLGkLCZDR6MkpFEr76BN7Rvfy4iKh	359
17750	2vbkHDMRv4BEGYGkdPVKb6hHG2HR56MZtQhqtfMJAbzdjbPwK3dF	359
17755	2vaARbnBWoR6szo6uTQs4pbQFPU5KHP3uHKSkSquGbo2V36Rgp99	359
17757	2vbYg2BdSctC5bT9N5W2McrBc1jE8MrCUSD34QTb4ivUjAatFVrS	359
17760	2vbAQZUrjzUTKc1AQevcgwW5gqQcvRkJM2xYETYv2gfRkxFkiHKV	359
17763	2vb2QTzDkyzdbHNm8AykL67cec7Nym399eyquCTfxSjCeRJ4y6XZ	359
17766	2vaFLdbEgxxDzoF2GreWGXTXgyRFY3qGuzhitTwn9dyh3UGrPak8	359
17768	2vbGAukYa23U1uF6Zm1Dw5HC3Lz663EtHDLnMX7gLg7vEgf37cdS	359
17770	2vb46GsMdhvwBKLUYbmCYvTZHLGfCoP28yZbeDMxhPpFAF54FA7K	359
17772	2vaXxEzjmKNTiojDT9iRdsLyn6DYHkG7visEFE9SDJa5QxHEFX2m	359
17775	2vbbm89ZRXE9pRNh4H29U8NcZdhKTtsvygg6yH1reeckbMgFzewc	359
17776	2vaA2Q6UKzRdRKVPN6J7YaPY2UQ3qhZUCrza3k2H3i1WZJGj9dXV	359
17780	2vaPJYYKDGvb7XUgrGGLpZWCBj1txhWbxaDqchfQdWnrVGdvyM7t	359
17783	2vbwjuD8QVeZ8z7UfV1xNipVobuD9UY9gE9BAuUstnyuoiyuLBz4	359
17789	2vaauC3WN8joEPe8fpLrvn9ihggUuc67N7FttY3EhBEz6MFYxjV2	359
17790	2vayATLdFdN8yEhVZuwZS3z2cdcSUsciqEaURfk1pM3ZGH343uRg	359
17793	2vc3Y98fTiwDu4gk5QrUWBZxoWciMhxwYFF3J5qYe3iP2ijqzgMc	359
17795	2vbCoQNgMDkoUhaJufpFFQdYRhUGnxbnhXEQWpwh1qSeWEJSsSJe	359
17797	2vaZdh84tL89tyHZwZWpmSVPQ14aYvjtLXihxok2XeRxCA4F1rnE	359
17802	2vaxdCC8Ym3FPA8znVPiUujiXBY31PX3MCG7rjBfnwPUhVstAcpN	359
17805	2vaRhFPLC2zLTJFv4G2MnyWcFyH7KdDX2SeSVGJgmU8KXjPAJKK7	359
17810	2vaXSWRxHs2Y3ZWigWwbL9gqY5J4CmGWLqhXCTxRrpvWjPcqAVEL	359
17812	2vb9b76HdEC3Xfw14uYyK5UfEi1f6J9pLHprtrajofVgB59GVdWe	359
17817	2vbK243qpYGURPL6o4iZCgiVqMi16zqWXLzcoTjXX8iyAH2Qq3cE	359
17819	2vatnfwc1CQLafaSPfzgdzos6xf2q7zy7dsr5oSYBj7KbVYBkfMC	359
17822	2vabt9J5H2vQjUWLcqQpnks6Lwf6FnGnAG12cKhhYNf57VW7s47k	359
17824	2vc25ZrjzDf2mbFxsHeQiT4DbF37YP5icRWP7m87djfnyeuCXTbd	359
17832	2vc49aPni7o3dJhwmKBQkJDg3GLda65qug15hRhvghWW6L49H43B	359
17835	2vbHgNfJstK9kEjkPQLVBbJXNjQYFNEpq5D2QP7VexBi9RLdruKS	359
17841	2vbFkSr8DtMXVbHo9jGqoqDUThUVu4u9E1w8wECDBYnWHBq3x2Yv	359
17846	2vayg4Ev6ADKhSrF8XJNrJ53nQEBka97vLxRBWViBmfAW3htTZp7	359
17848	2vaHfKFXYz2tiXMnDejqpN57ht859QnCAoZwc4U3JyqAqPjaE56Z	359
17851	2vaszNnqdc5RXTvDnLjE9cthyZWyAH7YJWq6T6SYp1XXhJQ9ERuh	359
17862	2vc5FyYfABHbPzNifbvXi8xqZRaADC8fN8kprvB3NobHpzMN49To	359
17865	2vbVfATgPB3U7RBX8xjChT6bkcbtiB9fa1MWYxkS9esa3jqkov6n	359
17870	2vb2xxdN9W76kBghNyCRmRQBLpWRZEEES7RKKB5HV4XSuDCUu4pp	359
17872	2vaxpUn33GbCTK8dLpadRiG4TTkUDxgS7bowgqiWHh6jcD4bb4Mu	359
17875	2vb4fNV8giH1BPYYrSZ3DgejWbj1Wvb6EsvMyotbbpzGYJcE3vHq	359
17879	2vbnrNsnrLk5t8BhijhGRuqgwqtuPW5ggS5PpJ3BPbJa4AGg8Hup	359
17884	2vaEKoFAbDcg8zP3v7xipKf9rKbEgxQJ3sLz9iTJa5xi5YN36iC6	359
17887	2vbaARNn4zNyCgvmP4qLsLVT5uVmdUwkEsd6P2b8uPGnQZdDZg7g	359
17893	2vbxBf5BmyyVEFwktb8xaYzjZ5w1GfRnq8QwhG8HsVk2fjfuhAdr	359
17898	2vbY6DmaW62paxyQFRHbBSrVFrptxYvDsXUyaCKSodEg7ybA9uQo	359
17900	2vbKE8iNt2y5GdAqVzUyUwGG15FLHGU47m5YgPaaTSGccgH5bRE2	359
17905	2vc43VCUbcxX9et8thCmatgULWaAqJqA2LmGuF3pPntfLGhGTsNN	359
17910	2vaqbpLDbQHNfpHsaD949fi67dfTPRqCedoM6vPGUW2hzs1nmDzR	359
17914	2vaR3wvcrg3bbmUNEzukQ5z1LeZ6MPMxtbnkCeWXaycSJhxbQTTk	359
17916	2vbBapWQ9DfFnxwJ8sKUBVS6XokbJ3PYDqxHq7K2hUDdWpEuT9nN	359
17917	2vanNVZKqY8tBMxuzq4J5ysWpK7qUdDYQquh9La9ZbZym72jvdF1	359
17922	2vaYSUwvkcJLjo3yUTJq8uUsPDXsPha5WZ1Qmg5iu6uQnudM4Lrr	359
17942	2vaET6pQaHuud4koaVjG5pBqeSV7s9sGSBLEo9cYy5uSLaGK8K2Q	359
17943	2vbWmZE79gb2uHe87a3RgPymjfNPPc7G5vwa3SRQ4w1msk7uBYYi	359
17945	2vbNxcZpZ8Z6pXGm9WtR6WNcMXBv4CAYnURFpcaAusUAnGePHrhG	359
17947	2vbrVpQV5ogQD7ghFh1vLMNMa68jspA7dvevX2iZwVvp1YzYGoYm	359
17951	2vafYNo7tWDaBRYMtzSR4wPrjAueB5eirihpumEH2FPQ1QJibWNM	359
17960	2vbcabnwuUD2D9zJ7mQUJ9Bvjs2g6v8sNetbtJHBFsmjWPvnJDDb	359
17964	2vaK5fVHoxupYavvu9hBkJm5J7VNQjYhQxCryHf94xSsuvBJwTap	359
17967	2vaXGz36Zg9FnF95bsBJnunocYNrPYayo3PYcJWjcpM9VXREjeke	359
17977	2vb8VYAVvxxcv9qun9YzazQ5kCQvW28a9MWD8b4ZX6KYzTQ1xdte	359
17979	2vbq5yP4pqgL1zgwKm8FQ6D8m3FLjTDLNcvSX57Q7An4FnM1yeRg	359
17984	2vbD6XnevH9WedqXPUH9yXN3vffcHxmJjxr38YWp1aBRCQL6B4Uy	359
17989	2vaxwsffTRKsYM5BzWZ5mG2szTsWNDsjzZ4AptGPyUzVr3vBvp4F	359
17992	2vaQFzvEajDw5JLsZyZMEwhU3ruuzwcEcUTEWXAcE6WQmKL9Dc8r	359
18002	2vaZa6xgBuqZiDmeBmazibmSKBzjv89kWMy7dAwtSgT4c3uNFUY7	359
18006	2vbvC7b4JJxgBZx5XhDfnpeHvNBKSSPpfQFpihiPwgLzte7xiVqW	359
18010	2vc3VyutB1X3Dx7WHrBuaLqkTfxwRiBiSgyASejWWp1SQ9NMRhNx	359
18013	2va9cfvQqAwfE8BkbPeuJuua4WTkYt12uGjiV9oD5okkGUxpB1wR	359
18016	2vb4b2qAZrxtxjHJzu9shQGbgS2ehgXMW5xipKm7jAKN9KMHXxAM	359
18017	2vaphYzQDiVjBYfmCvWouRzHMKxp1vAhdstDTtS92PEjLHWAVE7Y	359
18021	2vaEpCDqyehNW3SrUcZkcbNeRvrLatYxtdgRuWB8ZSYrCpNjb8Wn	359
18025	2vbjGsxkqQ5okAAphMLBofStcGvE9YADT6w3othE7v1k5TPBhFMF	359
18028	2vaCaZKpgV87FxzubbvXTLmrKmtRxcJ2713TKopx8D7SCCaupzYU	359
18029	2vadb9rQXFkTWjKd4Z2HaZx3DJEVYLVDQAskhjzShn2t4gYrevmv	359
18034	2vbTKUm77UwS1SqZsej17MhtKEw4DFMb2nGH325XLcHTctVr6tnn	359
18035	2vbmy9UmpLvxTzhvXdPceb2XQ7vNuwKRYXTgmsBKkXRD8PCn8u9D	359
18040	2vbjF81Xj3r8vrZ8CrzihkacgnYCXk5wkaH8sW4gtZwMsVkgr2hW	359
18044	2vbWhDXrR1U3AR43e7QjH3gPZQf4EbtQ8uzDRXEedVj1wRDGJwqu	359
17928	2vb9qYkJoPrfYY31dabHymXfibKB6aRwJBBe69qg2Ccn76pZvLsZ	359
17930	2vahCgzLLThkjqNNH5tLjjM4u96XDKkes8ME6REqR6yDyanKLkZy	359
17935	2vacAXr9LxEo87hsTYd5vVGoPd3Lm3izy3nJafELLcXj7GfiE8qq	359
17938	2vb1tMKvBK3PWYEWg5vxEZ2tUShxYWtd8mhKfnvWuk77MqxdKCWL	359
17940	2vbEi511CUkznMEmN5PwxCKBNGugef1vVy8up9H629q8r6b1aZyL	359
17946	2vbtHEYVwm4tey6fvMSS6gsjNHS75T2YTWZkitie4oCc68szFjFg	359
17954	2vacqWDWkH5gkVD2oTLyxqDN5KYMFa6rX2UqtEj3hdxSSHQaPxa8	359
17955	2vaqMiFBqZ43P83uSQyRFgxM6bN711Un5ysQ1KFqyteqXMSvF4CA	359
17961	2vaMLf7FWw1kmRvXtXWwKcieBLDwgvJR9yKyZpZpJZFHesrVNmVT	359
17962	2vb7GLu9zS7x8a3RLqZPQ7HmNjNA425fKRMNpXYq8ykx1MJu8fMu	359
17965	2vahrsh3MPbMS1adGNiGF6C8X3PQ5iheWx9t4QSprUf4EhVnwdoT	359
17972	2vaxcZCmC7XLViGRYeDNNDHcTnHe3hC92dzZLedr6EXr6qvrbpfq	359
17980	2vbdPhRYB47jyTU55eqWBnGCKis9kgKQ1NSn2bvZcaQDPR4Q2nDQ	359
17982	2vaRKqRYZFr27QKUPKaVwjNM4oDW4v1mMo98DGnQiT4pxBtFKKER	359
17985	2vamevTJWqBWunHs9HS4hqktoyCbhieMnyUfwvEJRF8nJd4fAW6s	359
17990	2vbhrfBnW49Eya95UAa9dYUVedTGcHqxfhCP5swgFMzQRZSSswH9	359
17993	2vbepZqM41gErzVVBkiZa5msozDKWYshy7JAsv962BqWixFDs9Gu	359
17995	2vb5XA3V9NGFpKo19K8gZCLvmhLDqZCCS3VDqYXYR6mhJ8pPoK5B	359
17997	2vaA5zo7WzcPtErGE6YLxWccR2juPmWXzsQ7bZyiLnrRDJnJ96Ht	359
18000	2vbWCGWFx9QPMBU3QGqQnpfGiYEXrZVUrddoVvqBwRh4Ea3G4psz	359
18003	2vaAe9NmHheEDd4UF3jagD4E5AsbuDykxh6wsPtPQvSdkMsUCSZi	359
18007	2vbBQNEuXvsuvy6niAWTG3nkSjogeZn9chm5iEHpjGR3t7c8c6dc	359
18008	2vbL16eGLWnrpMzRrnj5p1hYrkqXJhAo46YRKCt43vTy9XN72poN	359
18011	2vbfDmQ6uydYWL1wgJByrXxsLzCB9TuYELcMpZRrgtPJjybZxFWu	359
18014	2vb8NDWKmjpdCUpPpWA88reZUyj59NrRmeTbMHQPsJDa4Eg3oHNM	359
18018	2vbiA5FsFQZDH39CnNztynhjSfqiwJGVeeZKuc91qoCrcSB4Ahh4	359
18019	2vanuTzbUDamK7TG8NaW1TsJJDnH3peuY4rtupRX2SSQeZcmmoPE	359
18026	2vajsvYiDKPoXhX7jwc27R1xdjFNQiB7mrYUEtnqmHBpSqAZn5Yu	359
18030	2vbYFjtwqfWJdPV9daUUoxJepQbDUo1PNrC69xkN3L7CCcskLyEX	359
18036	2vbuowwFk2HEtP7WDnDMYJZssFD7RJnCQiUwmeJEahL3tZk2iVBb	359
18037	2vaWWZVcLzCUumPgbumjr2u6gaqrcw2ZBXjwMZToZJK2Cd9xcs4z	359
18038	2vaohmMfjn9G2W14wxkRHHyBGwaCk2otmEeg3TdZLSL81zkK7J11	359
18041	2vasgmoSc4eZfzEhejvb9aTWCfNqHoyn29z56s7KkD6RTa6vU7XC	359
18042	2vayEpPYeFRpszxqCtvedFyXh9dq2tfHURwqCVkJ2Mv3s5r6YbyW	359
18043	2vbEtFqJXvmdzqcsvwc6wEyN8q8jA46ewLWHwyqSHn9obFsvWwYj	359
18047	2vbqufHBBA5nksPi9vPJUE38okGJEcJtadJyR5HsJGc7YdKS279D	359
18051	2vbEzsGV7A7UzhUAQCfGz8YHbfPhktCzbAWDEu6Cy649XByzgM43	359
18052	2vbNhArpmWBvAGtszSd1XQzEF9kQ99VKnkQMve254zrTsEfkJEz3	359
18054	2vbVQUcubAKtCMs44ZFYDjHa8wztRxSpmvucSAreweoiCSP6jL49	359
18056	2vc1PQuwpoRAFxxxB6RFSAj9zaJfKd1MYdDngWgVK6aNbdB2UWKq	359
18058	2vc3RVSGeM6Anc97n9tGqf3z2WeZvnY9kDhXrbK34jpGdft6xMQ1	359
18061	2vagbwEMvzL5oeE1y5kLVwHx8UAxpyeA3bsscT8zYraGoid55sTp	359
18066	2vasa7ny1McAVKk3zUZCPr1bRYnT9mNVQ7WEAB9krXsuEFiPd8JA	359
18071	2vbHPgLBWrpTuyzCzsz7pECZSuCT3cUfaxoFwiHZPmPWmPN345ED	359
18073	2vbBnLhayxLUUF8m5W2W2DMddPn1Tp3qK5aB6AjfUpP784ABeNiX	359
18076	2vaYifo7HFUw4Y1Q4DScFsygjBQR4cwpfiAB4mSaUPBFzrRntPSU	359
18078	2vbCkr9vLyvnMVvzDbTvv7BY32gGTZcZHM2ip6LedpTirRHWdEg3	359
18081	2vaoJSEjdEU7zpSwj1ZmYrtPiQmgHewwfGkfXdXuPM64ghPbcNCj	359
18086	2vaQHy2bVDPqxkYVHig3VrzDxuoTLvyNRH5PMoeDG8PdxhHQiND2	359
18089	2vb7qxopCNM5VwHfNgnp3ksnZRAorc1M1BDKBJyKHPAkR3YoTscy	359
18092	2vbPnPoaWvDoE6PMHZVdmG7AwwwoF95AJwanodTbsyLfAa5Pp5Vm	359
18096	2vbBaZ6Grk442JvrBgYUVggomVjBoDR9pP3MtgLYA5ZbfY6x6Ce6	359
18099	2vaTQMrRdr3yuSdFn9PiiPeVe2scwALgCEdUkag7fQJuDq4wfi7J	359
18108	2vavG7gJyKMr96cVAQEqKhPeEiUo3J5tGXqCUaauuvvFXN1QPUWv	359
18117	2vaeGa941Z9kZzxnhKLgknPf9pMawMwfJuYQC9JsUdQwESb7Yvzq	359
18125	2vaapuM1Sox54XzUpU1ERh9QTgX9t1JB8YpT6Dkq3w96VdzjA7zM	359
18128	2vbqHuEUXwL9SGJmuSTE2CpLeCgcXCSa8MnTJVZrrUeC4pTxAPQv	359
18130	2vb3BctdmEy7v12JMRxMVqb48gjDTSqv9SkYBpHfBzaKguMsyE1o	359
18137	2vbPQ8swSLY5XD2xMmj11NC67qzwKeg2qB8SSUMq2xzoAeDk9fbt	359
18141	2vayqUknvLU1fNztZ144Pw4NaMKAGFZ9dmMTBwupYXvvXNTFCd2S	359
18142	2vbv8TNkapMKDEvRdUkdreKnzzHdQbzKxv35vDZ3TxYGZmFAXza7	359
18147	2vapar9Gki3A99Q75v2fkwr28XyhFoGjmCVoQDn9TgzZuc6CQnDy	359
18151	2vbGwzRocgTcyqwSgZx4qdgby7rcEqzTGfad8Nf2miP9KBwSVfst	359
18154	2vbPdgHz9YWFgNiu4esYEs4Ancqsv3a6kPkHqrcX6p8y13yEeRaD	359
18156	2vb6yAY2XwuFV6HdchmK2VFyzCmYxDjHb5Ex2ohjGMJEQbc8nVFE	359
18161	2vbPdPKr1518Zpjuz5ywQHwVLsLZfDTK7JZ7ruwuTr4Y2VwqhcE7	359
18163	2vaWfZLNNge2C3TucoNiiVBNtRG3XC838sP9tz3dUYkE8b8QpdTF	359
18170	2vbE8e2WFCaC1cYoXBuBvS6rEQve5mjSqxWVHY6HPd9f7jt9sUBw	359
18172	2vbngiDbEGCQuZcNHhLff99RcuYiUTbXsE5vt4vY1Y885Vncmqrg	359
18183	2vabNGkQiaSHmFWPfYZ3W9Rw5JLHxes5ybgikPuw6yHTRUzB3gtB	359
18188	2vc4HAeCLXXaNhQKGQQTjakKb3zAVGCMeeutsGfdZbRVrSJvYqfe	359
18191	2vaBxLCpoqg5fWAseSEgMC7B12eS7dXHPv9YzSDRcWP8bhNxjeYA	359
18193	2vamE1gJhfYzkmjrPisbqzcxmJ6hShtDGpoHncNu476PUXrFa6xF	359
18198	2vbvKZDfkXqX7i17KUs1cvRQpEUeJ6umAh4urfjW7DMjymsJh1zV	359
18203	2vbxRWjAcojjXN7ZRAqSGnNUiNQYFmbKEbq4bGnQwri1SaJDd33S	359
18206	2vajm4aqiin3TqDGgbCiG4envdjDqPkWT9J3N8PXWRm1NkeDEHbm	359
18211	2vbaCG8u3u4LQ73MkRemr8yhfQbRGqDU4xoQwYDRPE6n42yw2MuJ	359
18216	2vbxPDBfYcsfkNQsLXq25JipQ3jRKFciXv12Fma6mSi2yAJoMuFN	359
18221	2vb4MyN3xqrmANjSazSDo99oHWh6iezcQSJyg6aeW6pFDiFGqJHp	359
18225	2vbErD5wZQ4iH77Ui78AgHG7rZb6LmpRjMs6EttA5V9LJHtXW84c	359
18227	2vaRWoUD4FiB9hvHBfv2ZNrTjJVjLKaoNyyNpqCfrghJsaCGEfkS	359
18233	2vaw9H8Ci2xFVBDG8nhG1RFByBpi3D3AzPQVesvZjo8AU62tvahx	359
18237	2vaCsmq6cUDSvJnRnJDhTXpGYDhKTfFhnLAUiotAseKYGxrdSJfH	359
18243	2vaXWPbc8PUDh98YCK2A7hxur1jvHxuuAvAdXM1hsC3mZdUyc1fg	359
18249	2vbiRPrMbd6FYrnXkKsREzAJkje66hXACrjJH1eubxt72WCf7rdJ	359
18251	2vaVHHvs5jsCcETqLF74Ro8z3M8axcg9WinwohEDV8LAwr9wU3fR	359
18261	2vairtyhnBPjGcLB4VYskhVbrF5kcafRH2LgbQxWDAH3ZomrvC2b	359
18264	2vb4wSyBZ6yzWT74bjT3N6GKD3ZJfyHcKrijRGQ1fpMKbzNsLE4D	359
17957	2vbUhuSBfeWCe2Z9GxBwsS5Lec79kz35cuAR99UwApFkckqMPA4u	359
17966	2vaRMK4SufocForLZB1FWXXjN5E1ELvXpBSj4uDWjP4DxWuV3pLC	359
17969	2vbvNtxPGVk9rRKsnpEzQ5wF7Hv73fpVmb3dHFcjYV8t5wB9Zs1h	359
17971	2vbGDyZsUZehTkFuMLvFmraZuu6VVDJmqY6coHaeGAbzJT9Rqo3A	359
17974	2vb8EQKtfzvVxV4CMahrxKw2t7qNL2mc3afns7gXZysPeLXuCHjH	359
17976	2vbRkSUmvNhCRskZKwq3gNGmS1tXK3iJGC2Bd9zA6HedLC9nLhyK	359
17987	2vbqyAwLULvb6pKe6uym3a6oH9VyBUqDiLVpyWFym8YPVexcJ2Lw	359
17991	2vbz2VDy6J661faA8koDngsKQdJG4tg6Nx3jun8LM84HXnFkYeUk	359
17994	2vc3rLQzaXBGUbY968kuTzy5HEnS9VsEbC5epgQmYfdwThkxkrtQ	359
17996	2vbvXjKczp1zuvkdLSAHcMh2sZ2jdLJjG2k6QQyGHiQTEEXMCT2K	359
17998	2vb2muLkaoqHtcAmKN8PY3vH9FpB6XsjhDQhgHL7nzEfdzUwHM2H	359
17999	2vaxGReZes74wFQamCjvo3ut2VRhq1JVKNwcrWB42e6JipGRawHm	359
18004	2vaZqV4sWN53RiQTJSmD7uoXFDgKQysPrHiYMjZvYuExYF8Wq3Dd	359
18005	2vb4RRiVzFyejq3KQRKwvhx7sek6CDBjHaqjDXiY8iAzHT26Uiht	359
18012	2vaskvLgR3dMBrbDcL13qRk33Gk6jNugwJUZA6FNAVn59fAsyG4i	359
18015	2vajT83fbCJj4aTMiV2yoVuNEBZ5dk1JHQVwyrR7dHFgtCMQJdFK	359
18020	2var3Zy8NtDyzDYP2nsvNkkY3v5sPD9rvDjZZAtHJsXCBH1XYx1p	359
18023	2vaNhHfGwYY5qp4XZJDZemXkRZF35YyQ2yCLEPDJAXr5iY8fRXPp	359
18024	2vaTWWjxFzwTgcKKvxppKLvkrnN9cavfrLEsnEZDdy6jXrB5Eimy	359
18027	2vaBCVbuERZMbDcofDafbKMSox19w3snW76t3FJeFNyZw5h8cJ8W	359
18031	2vbSYt2wxm3Cf1G9oF8ESavE8s1JbFHP7N89rbVAymGmrWMyxRFn	359
18033	2vb8j3J6UFPrcgjWzmS12u9zUbdk5yxBGquusGpKwNLnwhEMmkgP	359
18039	2vbqR4myZk5UUfnq3yYK42M6aiL4yfPg45PFRyTJe9axD3ETBm9v	359
18046	2vbUu8fRbBk75zqpfN7ZcMG3aAtS4BhG85ysuCsJteqLnG8So6wa	359
18049	2vbNkAgeJgtHLJcavi7pkUaes7EBwY7DwDKsFDuc98YYWCxLqTC3	359
18050	2vbxf5SKvSpWhmUPWeXokKAVuJ67HyWK8ovtgN4pYkxroq4ERACj	359
18062	2vbSC7MQyzm4miQyQPrTq7VSJmRvbLGcuqPJtx4KuxfFptGHTCAc	359
18065	2vc2mtHqxABVGjJWx9g4GwkivDZQ8euWUYsRKLDA9GgvCiUKLUTw	359
18068	2vaqYnw6yjZgDR5nLb1bHSSgwhxHawK6w1DzXmrQ5C8Dnp6UjJmc	359
18075	2vayXZatxmYYgbvzSP62YYLGDciWShr5As1hvCMeLwrqVJY3FraB	359
18077	2vawbDxsUhVSmV4KbuA6URU1DPeLeQknjzjwrL1MpyRcweY4ubqT	359
18084	2vb8AyotAbDv4HxoUuEapoCn8kz6DRkdwRr3kpZno6NQDMaMNnoo	359
18088	2vatZJVU7Hm2bJ2wHtAqPNsvkFNTEhMANSke8pNKAPwDtgNGcrXW	359
18095	2vapL1oCwqw9ZCBrUDKC3cyhSmT4wTuepMuahKKRs7zcoUBN6AbC	359
18100	2vaunp1yHpUSoVqvRfvZHnK8k5WtURT8iGbE1jaXz2b8putC5u3H	359
18102	2vbQaGUwqz2MC1G6C7PYm9u3KhSy4xLVozEHE7xY8jzPGeFscMcz	359
18109	2vaE5LxWZ6bvMYc6T9t8g69XLq3c92j3WbEAC6SWp9mFjhSynMLS	359
18110	2vbfXy4Nz9BfuhVFuiYbN33RJ2kXrxA6rn4s4c7QnLwP4P4UA1mC	359
18113	2vbb4njvGmLZ6SurcgBhGHrb1mtXEMY3C7k5mLr7ag9t2PWcn7mK	359
18115	2vapeYSDa5zxrejzaiZzjmrAXBKZu8atnwNrLTiTu6ZxGVrGCyAd	359
18119	2vbqsv9dQvtfEon6wKfDMNuQ1NTAGYfdrXk2yYKyxr8jm8Ywmjj2	359
18122	2vbAMywkpYhnKEau9Lc7up21bPoxfNLDB6rGRjD8o6B3Aw4q4sLK	359
18124	2vaEKL6q8YXeRok3YaFSQrzd2jzcA1nhEzuh4DTXfo85wqcMTyVt	359
18129	2vb8q1rv9dwQG7NrzQYd8SMtiHWGQy5Dffq8ENFxDeaMdjffFHYn	359
18133	2vaSwLGEyLViLBtejRLAAvSGNGoHPgxe8i7Lm1WAxFgoaJyMjeM9	359
18136	2varvPhBcSZtGEtfUxmrQ1kLsWc4EFJVoCs6AvBAv6GqYA1Y4kjX	359
18140	2vaTonVRqnRKLMwBoie6MWwecqf1zGYHgj3jXz8n3iZV5nEx4fZj	359
18143	2va9mdiVfcvFdRdG2vQ6RXgVAJgQKXjJEx7ChYCxvbpr4UDdi7BL	359
18145	2vaFWU1hoSsLCdEckLbzUre66jTty4j8NFT7LSuMxsBZKVgh2oh9	359
18148	2vbZksJxun9hxHtQ9u2eEcj52YX7GpP3YfWXnSG69t4E5KeTVe1U	359
18150	2vabBML2iMqELS4ATMZbp2tCMZwhn5VyqqRUvh2nwscGTQV1GAua	359
18158	2vatLhzB8nbngzPEu7TMbZMk3WZP6RKSaAJij6Uw4Ha6m5DunxsV	359
18160	2vb5fGjyjWTbQt47bTyfdiENLef3JSyKdyAVjKiYHfxKEHj9WM2L	359
18167	2vaQ2eFmXhseZfvwmUktHxH6o8wavmRLea7ZLdgZvTFeX9WUoeJm	359
18168	2vbrDiw7XyCPbyJvfsnqaCME9bSYCpfgsnh7xbBDqG9AB5P7jXJB	359
18175	2vbFinTFzh1NkTHuVCmGo4CPMXCXxnLy9eduFg4aAm8mqseaAH99	359
18176	2vbk47kBxG6PYYrkcrJJ9Ygr6VbhzchYejePjRqsgcczie2yKgbJ	359
18179	2vaHviWk2x9N6ZzKzboYy2a6Tjio7oTqaVZ63j4TqT8sQcKTpGML	359
18184	2vbbjxvSZrRParJ8kfC372VwdUP66AphTLpsaJxcUYhLb2fyKnLA	359
18189	2vbKKtvd4adZJBPNrF8HBFY6X8wcByGcEBFP9rPYjHvL2M6DWc1W	359
18192	2vbyT1Ve5uXgH8jhdncNF7Go4XvZquYMXH7p5TBa1nMsRN3uoCan	359
18197	2vbGWQWqHm2az5vcU97PCZxYi523ayh76ZCEZnJ8F3LBmQzXQ3me	359
18199	2vba4MVSMimU6CCaQus4vY3t8ctWdnQQ1tai2raicveC9DrJnbxV	359
18200	2vbAjzAj8GeiTNMsNSh7kkqGxu4eMHv7wkhuvfK4pSzrNy5PEMtv	359
18202	2vaTdNHzPyZReFtY8PkVbAKfvmCBXvH3ZJe4CaW9aj4BmvZzgFbK	359
18205	2vbKdiVMv6y6HuWU3vwL7ztkZDgKmt3r14r2sDJ6gSvKimQnas5R	359
18208	2vaN1z3MR2rkVdKxFxxAzhQ16ZfU21q1CNp23QKZrCEXCewP9LeT	359
18209	2vaJHjnsTeciJtzJBe28MDVWphRmstUjtrwrFEXQMyztW7CKDyZu	359
18217	2vbbTdSs1JXNPewGGkSrn4e7NZUVNv8UAUJNhWqJ1DgebgYXzy4q	359
18223	2vbhTo79RWcrhx48dNKQGTQakNpPoeVLhSdvLnaJvMhBieGf82rm	359
18229	2vbmoTesdMh1wBYfpGWAZtLuK7mp5UsW8oACMMNXsKihJJhTTFR4	359
18232	2vbcvEHmtfvrQW7waCQrvhxgKuXKmmLtbwzibBRsMdQXA7sikCaF	359
18234	2vajshYpFxpa53MCqfsmsWMHAvdU9Vmy292oHBhnV2gicvGEzXsk	359
18238	2vbB8NfKg3mxNSGddpvmPTuMkxBLdMNXUXATTb7jDdqXVsLm2PX9	359
18241	2vaNpKqGVNoGokDJBfob6FA1j4fL4C3coLbUFZZ9UgVD5sepX9gd	359
18244	2vbgqhLhgA2d8n8xB5ZwSGPXtPCeNvj8vADsWBiqnfLEVXojK6q4	359
18246	2vax39i1Fhr3iYCwPj1ghDip2JEuNCg1Eutg5aZFgH7hbPJHHENC	359
18248	2vaYT1teNv32UiEsA5RUFTY2iZygHRYq3yXEEqWootoWo9d6YnL9	359
18250	2vbUTjdRYEcWfNBuFXKfKoLwKjwuo8v2yXs4ytWDRpEfTZK9fQNo	359
18252	2vaTzKra7azbYqucv8RVpULqjXuKSCE9ZCFeMSFLqTLyMgVjwAy5	359
18256	2vc2C82ahji2FdbEMcZs8dTDTQq3xma22pkCpLCRuKTiCTMMeNpZ	359
18258	2vaDCATDJ1WUhKMe1zLKv1jaHQZUg14unzRDBLePvbj7ed84Cqx6	359
18260	2vbsM35g84rvQZYBTc3TRVje43skpXA3XeYh1yTfwGUcvVSj2kMx	359
18265	2vbzPDDLUJfFXLDfYGWr637PHziLwioR9UtPJ2FfWDXggdMbhVr3	359
18268	2vbfvwVJjxLEskp8UnR4YRAPRb7kXr8a7PzonHxAqANVsjnA7jZz	359
18271	2vaLEvVYhYXiK7B6Br3uqYsKm5xfe6Nym5ogUpVNbso3d9rpdYAS	359
18276	2vbE1kNAwBwK9qAKomah3BkJ9AvJD498yQ76FtxnyW7FRdkfi4Uc	359
18279	2vboyUEeiLaBQNmgBikVPE7ZMG4e9RkTQPFjSGoMegA9YsUqa4yX	359
17968	2vb9cQHLviLp4k9arBm9kNBUT4ibtAGambJHDJTRJfTQyhsivfMM	359
17970	2vbNSL8JrC9Dm9kKvUmN3ak83N6nKGme319cP8Fj4Xq1CGSFPKRq	359
17973	2vbH8wEUHtMWpjcavFJ5A9C6Dt9pe3TY7pHmrcb1Wmydn27XzktA	359
17975	2vb38dbWZFR3jBp58bvGkHzPrVz9wyi9H7cKpmKqhsKgBTgH5TjM	359
17978	2vbDXb9GsSqPq33x3RtCPqrwpLioUUHB74RbpHZ8imD2dwJkB6X3	359
17981	2vbpamjJJDbpL2MMvBoPuAXMyJkz3cR6TBD4xs6jKu9EqNMDPa7N	359
17983	2vbutsBeu5HGcJmMDXQDzC5x5b9TsdPJL4tdLxHEfzZaKajQ8hv4	359
17986	2vbnmxWnCat4xk3Y6SR1XjtY2ERNycDHFzksSqsuo3dTb2W8rTxY	359
17988	2vaJX7ecGthnfNTprVq7MefLjQNk7d4mWnPQcQA45MYHHwTgTb1x	359
18001	2vc57iXdPoQ9NNzyWHmSydWpVZ3GffcYK3yueTLaRvujuJBYH5j2	359
18009	2vbDLQtHkhANVvcin1wqe98jH31ZEHKxA4Yjy1d9GRauK2SUNEan	359
18022	2vc2VWspYXz8piStGAzaxXDjysedRovB35kLm6YzBLMAV8vB6TrY	359
18032	2vbQoYD6hRBjJcnEizFuFubZYGtmVJr6xZyzzF7j6PF46hKmreTJ	359
18045	2vb7ZQFFtspX1BGbNW7BbRZhxL6cCJeRbULxNWatdeLpnakQKFKK	359
18048	2vaNeqBwnFeD3NF1nydRBA47rtMMFA39LK1PYpXAqA3SAg2FqdMA	359
18053	2vbSR8sgjL72C6QEwDrXwZEyr6JJfn2BaJhLxE5WnNBLNaiNkTzT	359
18057	2vazyD6oACPnhVBe2uE62h3jcnuXpwxfN8bYoWCRafTXu7pCeTB5	359
18059	2vaPTCv1fzab7SwbYiZQ2pX5ay13HjzFVc9oL2NMmQgDZEyPBZGG	359
18064	2vaDJCaGrz44bZ2kFTNnT3YpJ2vpUgGpzD3jKrpZza911aieHQcx	359
18067	2vaEdgSo72BHr2djxbPd5CSickYjsJmtuTyXKtjSZ77Q8CaxQ4jG	359
18069	2vaFWUkXfsht5Bb6HWiCg51ed69rbHSd7BVwk8NKVtAGfa4SEvE4	359
18074	2vbQwKbcqPB9XPjBzJEauy9VePnXVQs3Q8S7XqRQtvV7Xf9hYEva	359
18079	2vb59GUcTNqLfTQ4rjwPWCfMnuoUzpTGa11BA8K367cVPPR9zwS9	359
18082	2vaqHDaj2CMKhd7goauF3sYrgc47hSRUToUrafiVdRJFqsE7eW2r	359
18083	2vbs79s967QGNcTQnCCczGCrjr591pfEA97e6mnmXFwFhK7sCimc	359
18087	2vbyuiecYm53WcXZPTb1QAnzYYWtpD2CbKi2hFSyf6XhSiFAmP95	359
18090	2vafqQYggt1EMRPRYF5hJr8CEQ1RsDByxWQw6dj9YLXUT1k9Cebh	359
18093	2vbMx5QJE9Ja8AT9HeicchgMsQc9j4AygMLiJ9ecZmXyPWEfwYby	359
18094	2vbBeuQmhDCFe3YjzQCmG6qdcqXWRtNRwPG6eEjk2pHwg2Ws3dQW	359
18097	2vbmwnF5p25QCAp7Zfdw6JxzYHv2uTMyPKwCMUBfQQgVCkQahTXd	359
18104	2vaTDVTsurtW9iwHYbDWsoDUuNY24V6GPXPwoNSADQKM8aUsLWRy	359
18106	2vaAQp5idnZUoLTM72HXAWvhy2j4rqsmB8CxGXU5ckGeKYkD85Yy	359
18112	2varrYAogwZeMmXBKAJEQ8uXUsYG5kSgZgrmBV2mHyduuqq7NnvS	359
18114	2vbSf8mPqoPEgfF4cuaeCLXiX1RR8ce6eESrJKu4G2BFRq6Tpe9x	359
18118	2vaio3r4FNpvjybvPyez4fteSiHP4VR1tzSoewLJvSoWJf87XZSp	359
18121	2vbBkNicYv1KtuAr2U48NaqHfkMJ5wx136aSoL78hrebt2GSAqKd	359
18126	2vbCM5K19RcgWneWj8MFXLaM5BjYL1Z65t8MeRJdjHCXwUPViCME	359
18132	2vbTVs9jj27YMnh2nvngLkv9ZwGPQtcquNYJ2ayHpv3CDRSt52NT	359
18135	2vaJpygovCYrYooPa1xXLU9RMk8XRVqKHEm6fXEnK9zGGCvxYRM6	359
18139	2vc2KVPMnuuhSdmDru17QSWdrFgEHQBWUGQ92PigVwjHfykupN24	359
18149	2vatnFqhtRMRdQBpo9gcSUimegK4Gka45uEQYcQgPgzMVxcr4TPG	359
18152	2vc5joQzMGoR1Sfy77pbZUFJkF29zFLL6KQcx68bGroqeTRoTmWM	359
18155	2va9x6JVLvp7jJGasFJnY9gGZNSZrqvZ3VwUv3hCxDtEEY5cB5bW	359
18157	2vaw9tHhA6czQru1YaqZPYagqitBZt43Atag83WzYyRwGkfopWWa	359
18159	2vaTh7ZD9Dhibrjod35AuEm4dkasCuLuNRmCToSJhcHxonaGconV	359
18162	2vb1kTNoA4jL1gdMj7QTtPExgwYSRC5qUqESQykCChP3os4PKRB5	359
18165	2vai2ymUjR3f5siHPfN1Dz4nCikiqgnTSFgYbQmAupUUrfa7aM6Y	359
18166	2vbhD7zjYWL835pxaMPbAaht5TqT1FBhe7EAbEfiGeoU7M6rnnSm	359
18178	2vbFVXk1P74MzRSVA8jxyLwvnJVtSiuTrN1PFA5iJLRjJ4z1wJTp	359
18181	2vbWCHw7162HSfY72yyzPVquxYKwq58BNocVMmtCeN9JPQWGnWtq	359
18186	2vaon9XcZXQRzgqqnP38jt269Y17fVvNyVz7q5MJsr2xLyEWkN6y	359
18194	2vc56sBvkzGfWs91VA6JsvNtGgRWS5o9gYXMCNTAqW99EyGMjzuy	359
18196	2vbtzRnGg3F2k8hqQrGQPNSnzSnYFgK1JZ1i45iWB3QgiHK79wQW	359
18204	2vayMp189mc6xKnadYDpckAEEjshMjgxTZbEBZ73sThiVAJgrnMs	359
18207	2vb83evcb9Wse3Pq4zeAhb3zkUuz2LMRVRktTp3fUg6PGkpyrUnr	359
18212	2vbEqwc7wNLNM9U4JxdT6bEeE35FSLxN4vQPsxYMoywXGXWjxQrw	359
18214	2vaFv8FHiU5q4ENXRWLLZzYntwLDvzFZhqJyxqUB7dSE1fvKfLi3	359
18219	2vb9Y14E9zGgAjEtrsaMjSmGXrT3mmTaWvZQkFLqwqVigKqE4AQR	359
18222	2vat7DRA4CyyHP5p2eatSSpWEEETo8if4n4SdNFu9MUAfmq9pDJv	359
18226	2vaK3ySTajMFfHM2YHZDjTBShHFfyPi1D56zXSXSjBxsjE4Faf56	359
18228	2vbhDe3ENRWpcEBHfuo4H5UYz1BKbFaUoht3EcEwmFvGU8QNXzm7	359
18231	2vbFVPMpmzNfT7whDxKVz6kuBF7VqHJAkN3SzgPfpsG34tEu9tVq	359
18240	2vbYB72dWe1Uff2R51SiQLELmWqdkeNWsDE3QLtiwuA2RM4PUnDY	359
18245	2vbnBTXvdPUeEj6s1WSX7hp2aeAKKzr1hnbW83guzo3nUhVgCZBu	359
18254	2vaiSYx3ZrLVXvJ4m1WCgYwLi6utVtLbsDbWPFLmZEfykZCYgPrD	359
18255	2vbszmjxptpEeZrt7m1YpiVqxPnRAd14mU86vzeX4smRCgUtNpja	359
18257	2vbqHDyoR6y6Dyq7p571wz7wQuQtJ9wM19x3m49UV77kHy7kTX2u	359
18259	2vac3GPHzWsYtszLmDey8dP3RP4irRYEmEMxCwEnv17q5pVRD5sU	359
18262	2vbcCQgEU1vKSXMU1yN5wwat8TMrWPkEseLef2QsW3dGLUXXiAAt	359
18267	2vbhbCbANvSD9xQZxxH7jeCDtPLQv7WsjXv6oAtSxpAGvfYXFsu2	359
18270	2vbEejpjNkys8vc15GPmSZEFN3o8wuJAbRZZE8WxjU3bwjEgHEUj	359
18272	2vamgFxfWhghQqv9xJXPbfxywr1hzu7WeDCNfQoaXipt97W6wyBa	359
18275	2vbpu3iPBdRuciBRXyrThNbZGehUzmph4sC84HUzbu1ZGH11zDdA	359
18281	2vamgYqwQAmb5wUhVyp8n2bWsiQ37Bbw7wL2tuEKbdF4BsE4CTnS	359
18284	2vaJ1J1P35VbVqeKCz6x15wMVCgyuq7L3hmxYpdtRFZVB3eVA6b2	359
18290	2vaGtTe7AtPXaiKEKUVaV3rkgKLAv6RBHn8AgeeKPJwH7gLGp2KA	359
18295	2vaCgudLTWcWXvhy5XVnWX5dgswkyF9r8aKG661d5RVK1i4iKch7	359
18302	2vaRq9m6LnFEWm365QpTHnswzxnzWkwsCy18JcfUEzMXWmXB1GL8	359
18305	2vbMwDWuHLrNU5DpH1t4496szZTxvKWcz4MegbdMHw6RUVtpCXpx	359
18310	2vbNsjgqJKHh3SAqbPbtzAhWp9vXTi716Byv9ACEteuQBBNZHSv6	359
18312	2vaJ88SocCTzSH6WGrNBZ5wH4ptj2gAUkxjTfaKkTC77tffYh6hr	359
18316	2vc24LFvJkSYvwUPyoLMvetASAjZZXvobo9ZBSNhADo8mu2oqi6U	359
18318	2vbzTDmXyh3JKsXdfycE9D4Dzo8bttGnQ56fcERvcSAh1Ncw2hZT	359
18324	2vadqXUbkXfMUPzMDwnrLYgJT92Ecqy3yPMRPV6WNJvXpYAbBKYW	359
18327	2vbXsE3DYcuqFgN4onJt7G1j4YQkiycQLCcnJTYpddDkcx6jxCgQ	359
18331	2vbo5xyktxd4VvtawHW9D2cZn2eU19gsane7WinSgAdZ1PAefXCA	359
18337	2vbGfLrr79jXHDwT78cUtmjgV9rP4nMh4y4LAkcFjiTdH2G3SVQa	359
18339	2vaX7uRFuUUdEJ1mfJ1rUrsvm5bWQ7nV6tagNMcoUnvqj3ayXKnb	359
18055	2vbNyKgdHxHnxQCNUaEBufqvoEC6KjahkwGnxF7ErcxnZU4UUV83	359
18060	2vc3qdLwbdudER2efpAJ7eVaUonrLBoXse1bie32p9d2nnuPrFM7	359
18063	2vao9a5keQwYZuL9aoVXGyxtxydVvDU9JxcqSCiDHN489yjZHSUo	359
18070	2vb9SM8fLnqjQGMWZtpgaTvFj3XdfaHdPMipPbwyVbopmidiGEy2	359
18072	2vbQK7JT9NtsGqBr5L6yMTveenfinppi66214638esX8hHrh2ACt	359
18080	2vb5QqmN2bM3woMpFHnSveGGvph4CLtvBcYPJgLvv5PaZsZaD3HP	359
18085	2vbUFN4ntJ8RybeQ4iTpwaDQYWp7bL7PZSRz7d5F69qbmVqCq7Zk	359
18091	2vaJTfXcTGwXy1F5Vj6WGSBtJffEoMdng5DNvw4id1jWfdHMo5Q4	359
18098	2vbkDGk9z9QsMTcXEGynm7W4oSUyL7VTBfzye48U9Hdxc7LVRC17	359
18101	2vaMXuh4G4AVRG9Cm8eVqCnxFNJcyC1Wxv5TEk6Rg38xrnx2taBy	359
18103	2vaBYidCmDqeG5pSPF3gPtGw2roUoZVffFQ8bWRxihwo7f3VGNax	359
18105	2vaNgRexz7xK7TMxCwRrH3WtaQjfqaSsGjJ9zZ1ydEFZubVhDfr5	359
18107	2vaMKr5uHNTpixKMjoH7YG2KJw3964CAii8MiefQhFECp3YGMTwz	359
18111	2vaJDWSo2HbsyXp24L3mfLp5xHiqYYZij6vvzNH5AWW7jjedEKGK	359
18116	2vaoE7r4b8TRxNWotrvsgdQWMQVbp8pLWieKjagSQTc1J2TbdH9i	359
18120	2vaUHQKYZPZrnQqH8UM1cKKHpjQpRCDAttrHyw7TcEefX5pAzKpy	359
18123	2vbtzu51T8dvxDDb6cjh368eitrbYCiGzhGbJ2ZreDa6oBq832cF	359
18127	2vbWL4PSBWetaE1G3XVdrqctYD2djE3Qz6oyUyX1hfDLU6R1YLfd	359
18131	2vaFWwSRzbsifQ2qh528SK43BBCnvvmQDB7qb5H33EUTF5McuNX5	359
18134	2vbH9S6iZMmh4cDa5xREpPkxwRfkNbrx8S7zhGqsti6ZJVxjJXFi	359
18138	2vbsyK2t8KJiBVTAFcQvzvBsJyVL4Vd8dJgXQaFyMEtRmsz29QLp	359
18144	2vbg6Srio41HrCzNJ1rgMhp85Ge4rFjga3sGUcJshDNXtqYcTPEs	359
18146	2vaUXT9QuYuVzV1RtBD4WYQ86Wo9nVH7KVHnZZAKdibg7hScbXn5	359
18153	2vc5dp6TuS6kwzPTcy17442ZaufWkaJs7P2315bwRhYeB2dn42Xm	359
18164	2vaj6H1wobvWhXkYVVGK3FQZtt3JU66GoP9RirPKA3Tu9stFLHpz	359
18169	2vbmrUmbxSzwhZN6KNuTCQyYGF4FCbp8pkv4pTqddZsQqo8B4rge	359
18171	2vaPkzfba1H9iYEdtuDgAPXWYSXTNSuw6es7Duq8S66Xqr9VicFf	359
18173	2vbmGAFqZycGvpC1EN1qYEaXtTWpGLbikhuqzNSLVgkz4ZvKnFeD	359
18174	2vboLigd82TBn7PdFeVjesw34ZEsQet1Tw3HwqCZiia7T9BgSD6u	359
18177	2vaqKGagsWBDuDvLrnXn75uducLha9ZYFjHpNEqjPpuy4XXPsg3t	359
18180	2vb4e3WgVvgcmaYviXSfmiUFdKrHE51B7cDpzPC9qnnMeEoWuY7b	359
18182	2vb6nZm3foLzvbyik4LHjMimjoM6swXsGikUQxQU88aFH565JyiT	359
18185	2vbmSASDXbpWpMymmryAMjxkRFcAng2gDjHH1Sje4j5LQigZv3FS	359
18187	2van4TkBez7LGhiPazhxRV7YXG18fcZmL8fuwtrtMaKdeuEsyEsk	359
18190	2vbNgf4ys9hXrxhCJhuAqB1bpK1UQViwaNZUcsAkXqsRttkc4vBQ	359
18195	2vaWhtgxrVQwe2xr8nkKmZrACYTcvHBVgW4LojPYKAokB8hVFBqP	359
18201	2vaCWWzbkxhoEKxxDeAH69yFYCzYYUEBL99yr9CbKT1xhSBCU9wF	359
18210	2vaQhh1sMDtT6gzGJsUjRdTtRPhFApS5ZnwjCa2DBNtZiJVYYSa5	359
18213	2vaDxZs4k17mj7zrJQ1mX5Us1QMwnDZY4wLVqGHFRbuoYPwqw93v	359
18215	2vazbZPgWnSWajVQtvEtxdxrrFf7E5FeujQXKMP2Zp5UouSFW6X9	359
18218	2vbnBYE71uhgPftagtx6XjXYMvTaNCzXjEDdkxANwGbv73amBVqP	359
18220	2vagQubnbngEk7MBxn4xSg1cpg7DmeS29XNnKHAbQ9a9nz1pzmGZ	359
18224	2vaEDuzw6joU2SQevrWyzrZJ9V1VGLJoCUxvmvx5P54QqwyBfFJ5	359
18230	2vbzVXudJrz2mHhXrBudGH5uktmfiF1vVvKaQLaqVv9PCErvMHcK	359
18235	2vbwS1cUz7CyHzUjVsutkG497P9SMbTzFH1Jtkn2oD6Qnrzz8sNA	359
18236	2vbAW3N3TwBTXAbmRNvZvzzHjXKtb99ppyyEX9tj7HVAhTcERUGy	359
18239	2vbFkKV9J9D2gubiKxxikKXMtopLmCN6FVSAMDQ5jRMBGAEoyGyz	359
18242	2vbA84gqhzaZvvaAnEnUj9C5rKGa66Nb7kPtmmkCUsL5AZo6sKCU	359
18247	2vaTQtNMRGWfccKgkPGezdFcuJEZNuBWktTNNsRch5p5USyztraN	359
18253	2vbo65xUN1BXeD3sSd9Ub8druFAro14WbuECosoNzZtUJsmMG2rf	359
18263	2vb5CbvtRHCY95DtkoLC16wFwALjcnAHH8ciEjHD46RGuxDPhyWF	359
18266	2vaetL91VEELhKmAQJb1drBhMez9qZHKpXjqe6UbH6R1K9hdqL3D	359
18273	2vbMRiq7ZhnB6yTx7voRcz9q4gYeWkbantkdhZg5Rm8k8pFnqxGP	359
18277	2vbrpEdsHvBG8GRiMosCnnDkBg4WPomTXnu2vCXEy6VF7f6u9hir	359
18278	2vbUi93smHKfVV6dM8MdhY8hCj2gtK7gmgBiZ7xT79oYqnDemh2j	359
18280	2vaBgASxFCCrJyENifwwkDxknhFzVc8ctpcAUMXKtzsbVBo5Mciz	359
18288	2vbqrgAWxwYBfvTFHvHK8dSiYwU9Qk6rXfkYbxW3YFrf83EyD3pj	359
18291	2vbFTGqMohk3aJKHybn9cQ7cnMsAH7zxMFTDis5Uygh9gu86XGty	359
18296	2vbqLioMc4fsVtvUh6PVzUYzjvZNjwZF2wEFtJMn5fMbp9Y1FSuf	359
18301	2vaQhDwzHeDiLhVs9mxWBJF4tY8hcXpvN38hLZARrqDW2DSEasn6	359
18303	2vbnNpNRoT3wvJRELJdfPumx9NQTmvCkrMnErFteiF6dvaL9FwZ4	359
18307	2vaXV5Hq7bSEKFCkbgv2xi4i9hinwxHcVP5PzzM5fsvezUJGULeZ	359
18308	2vc2zJ5J7XW7FHDWmbsUcBhFgLXRUz9CcMRNtCwCom6ePygqUWLd	359
18313	2vaRQq9Ce93kevkDHuDaT5huymk3LaZHa726RZdAdNNm34VZmZgv	359
18315	2vbmq1fdZXqbBeLBAvM23TdefrUwbjk7ToJTsHtHRzCqpNmyL6Y3	359
18317	2vbCoxwV7zL2GnYHy2FBqg2wPJRf1DpJH1neXJKyR2FUcH9t9u5k	359
18320	2vayyQ3vgkD5n5pSu74wiV77Fmx9xYgRPf8neCajyHgt6UzxSaAA	359
18321	2vaDWZ6iCiVXpKQPmaqkmCo6r187B6FtKbsJ2yA6G94F3HooM4mX	359
18323	2vbTjuBDvvcaR3dqbUJpRbRAafYczfHom3S77xe1HKTr4jcByxiU	359
18328	2vc39b8ThYxfgxTJCHJL2EiiHqigSt4FT3TBhTZZdzeUAjVhZMgr	359
18330	2vbtrRqzbedEof9HL6ZEJpjRpLdHd18krPvgrTCrZSWY9pZJcZYf	359
18332	2vaTB9B7F1aqzp8QvJ8k9U2s7JVMfqXjHpCZKWKkoL4AsyJXEZxJ	359
18334	2vbrhhSDAQYWGsNGvctWcep57eBvfUZcmCtkD3jt3PfSjkCzZXux	359
18336	2vajzsPbupyTZrMZ4jiXTEBFwPi9tNGVd4F2r8mSjiuBnzDqpYue	359
18343	2vaz9wVzTZMgAKpTRPbsXyx1fF9UkwnX1NNsWnS3e2qtoCMjQc5V	359
18346	2vaTS3pKUSqyRcg5gJJ6PxQabD9AccdVdJrQoqHMevM4e5kP2N8u	359
18353	2vbqNAjeKC4TRn5eUPgvCf1Cccp9fqPYUcKVt4YsbeiHyEPLxUwK	359
18363	2vapk4kXzHwFtg2dx3A127MoQtsFjMWxqof5JGiJjtu3THCUSduf	359
18365	2vbs7CgBZFiq1PAhWp9zaLvrkXZUa6WmGHjeB9pTMCgeAXeB24NQ	359
18368	2vb4uu1cbvArmYJYa2kGGjybywHgTsoCt4vTChUC6u8aczHbNGVC	359
18370	2vbrVmQRhBm6eNC18CgsrWrdCjP8ypGGLng6QLqJhLV9sTzd46cu	359
18373	2vbmQt2siAsfNjQEdsDrzj9yeC3DptRSpr3kuy97KJKmxCJU54af	359
18375	2vaom1iHRKZ5JEVxeFjH7B3st7ZQputaabRqTSHpCsu2ehiwWR2a	359
18382	2vaTFXSx4M1ao7qJjVMYLiZ22iiFM9egzghpBgk6UFLZS6Hvfo9U	359
18387	2vbDcwa5vXbYvQdQSTS9qyyCcWG4suQGrjuytxuU6WhqsqpKd3oG	359
18389	2vbwwKD5CVSxF5tPRZFkFaUyuuRuM62f1hCSPFidXWUApMaku5aL	359
18393	2vbc8Qey5Tdzgh3HxS8zkFNvUYJLZSR5YAXz2tGbuTR7X9WcpqA6	359
18396	2vaYTdbZTHBYASuAtTMgMw4xp3ydDPu2dYdGmG85JvUTPtsD567z	359
18269	2vaPPtdKV1uWPvKRz1LXY4ZUrKiifNQFoqcrHPHGMGPH1bXHc4Sw	359
18274	2vaZbzuaYEsShUwSHzMa4J6Z3sCLveUzAqrzpxVN5xyzkKuKSbg7	359
18283	2vbpHwb3Lx8WHPwS2gmJLsv8e679XLG4UP6GS2Jo8Q6LSfsnmcNn	359
18286	2vaVWH1j8faxRsiuvH5tkeNCHCsW3GksbBHKqhNCuK8QstUyxGb4	359
18289	2vboNCYDU3xhTzvbjEgWbx4dWdichRz8FGHXkTTX84Em9f9JoNGj	359
18293	2vbtdHav1ei1zHuoEqs5vZFm3DHj5wvBQSr6jfPqkWmgqzLw7RPF	359
18294	2vaGkvXvpj1rn1DH9jWZUpxrqGe56zaP6HhnKcSNk3dtevKmHp9Q	359
18297	2vajzFjBiU9zKDY68UCEEuy5z8b69zc2uJLeJPXnKxnSU3nx2Rrt	359
18304	2vb6EAAyEvGFfXgta9HpwnTo6hYEAhXqcdf4eLHHrxNyFDHihmsc	359
18309	2vc16QHhMAWPf5SLxfVPGavNeSvT9iCsfpJxtoLNvEQrSNsdDhfF	359
18311	2vbdjCWHaCXjUwAnaBGyCmRZwhqRdXSophfbMbNP4qis1zJmVsMa	359
18314	2vaTJ7TNWXooxmg6yiwLK7tdkLaswweBApJFfWmtcPfNyKuehzYc	359
18322	2vb5Tdf4cg2i8BwkoUDSN8B3ZX6AAEvA3a11TtWdcC6zQgkmFeM9	359
18326	2vax1tygvH9RodroGcCEpTa3xFw7RGgDif1d7k8BxzXRG8Ri8rv6	359
18335	2vbwmbMDM9hVGboDCxfNY1QGYHaBJWUoXa8jMRJ5qFLpdkxybMqQ	359
18341	2vbDaeh26tfMyd9k9QZncRK8TE2xMfNPk1ix87bH9KwnEwiAtdw8	359
18348	2vb6dC9M29yptu9ihocGs6VUpkfarvfPNW2oQZPKdutNgHaFPgxP	359
18351	2vaZEHAxc8Vfc759n1x8Df27Z1PcLBDVbD25SBrfRfe1FS9USJZ1	359
18354	2vbrgwtcMgnbg2x6A9DsXXkbxEdYLQj6QEsFzin6rYAcZyCdzV9m	359
18356	2vam4L3LVNp7q5LfzmoWHqte4GGjnoMqAUKzAF7G9XCUM3gppaxo	359
18358	2vaziY2CxVNZSuT6gxwbappcYNHW1JH3dHgdUMBUpmjwMk41ddjz	359
18361	2vbn959dtP45BCJWzp3H4JDizSPTFoKVm2i6YxjYt7BwtpfYdkAK	359
18364	2vboJEmtk4hoDY4jLBefwqHq2LvYRgRvzARhT1fyZaYNRsa5g1e1	359
18376	2vb6XtsCZVhYGkF8rxsSmzwW1VJkCAQLZYBpZbftrk29VK3GkM1V	359
18380	2vc3z8bVcaBgEHMHvJxzyEamyTPEvFzi5mTkBdh3vMKycjF1vckH	359
18383	2vbjXWxMKk3uXH7u9DwnYBzoDGj3tRpcmd45QzzDS6gHuUHSye3y	359
18385	2vbZoyeDRvR9qDL1W3xQBcbqKMchW2K422LdXHeWNYgvLLbXVH2S	359
18390	2vb83uZS8JAgyyzVgjL7hhY5pSd4NLfA9hbepX61xMtYmV35oHrt	359
18391	2vacpvY23NArwY55coctN8oDkQ9J3gm7kL3PzyH6MeYrHMotpXUp	359
18394	2vbi5c177GjiY9CEWqGDoWyngK6eZfYYDMJB9cvMuUZ8CAEJwAjq	359
18400	2vbc6gGXLCLQfB5cpsNJ7Xav6ssACAp7AhaGDZUyT2bYaeDn9iya	359
18403	2vbhJ9CdBQd6mumbSfgAxsTkWRpZdt5cDmAKyt6mdso9Jur1jTtk	359
18405	2vaNQrazPu4PR6ieesXsFBmpLE3QdRGJsvGuSd83mPHg3rUrDmaA	359
18408	2varvZJwu9Muwd2wAQeMNdpeDNNFZbj3ciA2ToPa7my4ZqgWApoM	359
18409	2vb6ZaVCtFe8q3jQ1DrLpTGmnRau6VAaZ6vJR3eu52H3Zxy5wQrd	359
18415	2vbhq1kfgK1bj2KRnoMEbjDBEbWPN2CcBJXdhCuyqZCfR93PCWmF	359
18418	2vbKjnPikxzC1PP6UKwWYhSLSMZTkVHWhi8LTu9mR3SEossWJaMu	359
18434	2vbs6D9b3qZPGqXQgri61XTUfeNL3w6Xqb242SyhwfdbKxZp1o5H	359
18437	2vboXPY52gNFN4ZuhVyvfqygqKXnpEEaq3dFsg5YvXaBt294ubD7	359
18448	2vajZqHK5Q16d9bTofzHPbZcMR16FbHXpzhVNFjZJbMoLqweGxSQ	359
18452	2vbMaYU8MHRhG1AUgBzQaQFpC7TDPZqSySJtPgEfAy2qfXrL8Cu5	359
18454	2vbumti6xwo6bjQoJtqwgTVBmBDtxzmcfWQfNHCE5d4Cq7xEg2CU	359
18459	2vaxNn9oDa1LVf9xLJ6oZ9i9jFqzwgvfsAntUnBSMihax7YVi7Zb	359
18467	2vaeSBwoiN4AM2A968zQy7tXu288BCqNRqiNBKtZWsafb6gQcxEQ	359
18471	2vaozZw4HzXF2YKCTVtPqJkGxPJxBYoZJ6sdxnSSsa31S5MnzQwA	359
18475	2vbFSurmpDNDaoXn9jDy9dcgFdW5yv8TLHukU6VW2aw1ueKoFiWy	359
18477	2vb4cZLzcUjuAzE1UR9xsjGAztgrKPK4cmdHGxBt2mVFuMsmJCir	359
18478	2vbyLAYrkbfJjDokG7m6b6bDKbnfreJyhFmTxZyrci5hoqGhHBra	359
18485	2vb9XrFdTAhzn8JLhTJeqSMpViLejfU6qwiLupD9NAsWVDY6cTZj	359
18486	2vanvaYhK2GxzmiZixDqp1FgH4zfM3WL46Ue1brH65WrthwfEjJy	359
18489	2vafXHixx1u1QEh2Ps9y1415DyKr3faRnQtBjEVriSMmDFREi1jX	359
18494	2va9SVfCLneLaRsYx8iaDRBnQ1BLqgCJS2F9cFRmREyirMZLZyyk	359
18501	2vbdHBC3ECbbj2T3mWHCfrci4NuthVvTdwmtb1mtFASirQtAHAdB	359
18505	2vabpvDRUYu2Qw9wLjB5XToxFgu3rtVvXg3m4pXqMPZcdXUSjpdM	359
18507	2vaew914fMvoHzy83XGPdUdn3qQpg6jZTiTkzd7FafPP5cnr3M86	359
18511	2vbqxkQBGpXeND2GeEk2YUuBdgz5BfcmCiwMBYGnrk6PY3dLEZJ1	359
18512	2vbmCh8jZkmDu51ERBRUHYpZGQRjzyxWbA9x9P7EcNB36fw5Ab1c	359
18514	2varNrMnbjwqs2SCwmWrnhaQeW8jF8wTbeiQZPKUkSXV6GWYVo3V	359
18517	2vavo4c8yjRKCanwPcWtDGbhAJWz1q8s8mZvmyejAo7jhWceDbWE	359
18521	2vas9EB1sviL5SnmGJZUKfjmpQRZDULtEn7NyB2VUzjpce1jK8zz	359
18523	2vbpYYpovv9P1TfYaZzFyzphx7f7KpjTvKUpC9McJwXRHvJiWTzR	359
18530	2vaf3qisbMYqQMCT69PSqWKs383k96La5fr4snBwkRpJzPJYwjNM	359
18532	2vbWMboWHJErb2pmzk43NiiBePAryT2EBQFN3ynqbtKJufAa5uQc	359
18537	2vc3A5kkDe5HNZZQFhzkq3prJBBpvpCrHv4zMSJkLe7ckVGFsM8z	359
18544	2vbZowrUokx2bGiEPR6DwWJG9HkdELzUGH2EfQMw1RCV8ZaWGFT8	359
18548	2vb3bGnKsVPRVxizz5XisFsknGGd9hsSHm5fDnXvKZLYdgF2p19D	359
18551	2vbR4JTnktRnjJqVtfQEBkovsp4PDu6Wrk9akWu3aSK13CE4Ynqx	359
18554	2vbRNbsV55ScDCuPe7gggVQp33shXWrwJWUVGhtNLSu1yrLcVwBV	359
18555	2vbyFAetSXPMBPxHhPdFdNdneQX5xzMNtpoHxu278R7sE54np33S	359
18556	2vaLpwFmBox2K7rdFjKXYnq2GPbd2agafpqZqYH55HPWkGAHYYDc	359
18561	2vbvpBs9HSF7qo91mnPpQkVq3q9WEbfQQXnMsqhXmDHtRZQXGREq	359
18564	2vbgdjRpfrrTvWB4eJBj3eC5BV6YwvMkwYQjgQubAkjc3PfGSxeF	359
18573	2vb4Vq98UBVz3jFLhCNPjX5vEs69tBp47xBt3ZHiuWC1hsJRM5LM	359
18577	2vaqRUEU7n12uY6uyry7j1smUBRwaHwbfRa87EVTYgHvuD7PV7bT	359
18282	2vaV3PazKuzTk2YkcZPupp7HnDbbC4AARqgi9bX96kJzWMAg1hzc	359
18285	2vbnWuY6CWap34koDpHhcyoEDmp3CrdPVK75yQ9YPfXEpepQ11P7	359
18287	2vam5m7Q1E8wGLK2LduB9QoN5V2Hmjt8SC3egqQX687SbFKf7nte	359
18292	2vamyWQnqD2s6T9WrzaS9AVRBy3ZFXTNub8zijwbieUgSh9jEpkf	359
18298	2vbxmbAbaLnnfrbneypxuqp6dqSsknnqv8dcpGLRLPu8jEmPUL1Y	359
18299	2vaVzszeqB6JxZuon9de3kQx7UAokTjuiDZTsB7F2aLSj411msEL	359
18300	2vbKHnF5kqRQQkYVSYojVYvWbT7YJmDm8GPk5cLEJrHDF46Dwvb1	359
18306	2vae3memvKdJkZZFunx6MGesxpZLCGfvNNbD9iNBCjxFbWREeZYw	359
18319	2vc2pvoiiE5cUPLdDqwHvfLYpr1Dr2VUSmRs516YWvWg5nt1a4rd	359
18325	2vbHHZKMuB6Yojs1pWNFW2d8HVdMXxmNRZ5NHZSKfyA4ihpYf7ov	359
18329	2vaT674xj8Uz4bQb7qYG5apptdVjQGqsBsrifBdcYJytCvmeF6Kx	359
18333	2vbPyAPpf1fHmCMoPoMqWKSbruX3RsNgx72TB7An51EaLhyVkkd8	359
18338	2vaZUYht78NUR1BiaFo44XUZ5AMfnsUarex6jeNmAjESfNsKsiiA	359
18340	2vbR6qaDucCWXDVoxcYjkpYG1LV44ZVukrducEtoDhWKFf1RQqbq	359
18345	2vbYHxcsTaZ9uhD7AxQuAzZWJkLMnQQJ844oiAKBcZeF6563zHcq	359
18347	2vacKJwgAh4nB69hz8m1Lk3bjFQxEZxTGVsjvySj2hM6hyK55hM5	359
18350	2vaBMpsfxsXeLMbYyQ22SBkitXLZTDJ974f8DDmW31AMnxTWNQPj	359
18352	2vapAGSXYrZVxviA9JRrDK6VrpgUMzZuVPBeZBBKzea79Ym1usy6	359
18355	2vbc6dotpHUrQdmWpgv3mJUzkw9r436eGnhYJ2aqh1qDhb1fHLgf	359
18360	2vbnyFEaLMurkZtU8aMj2VtLyJxo2xCscG7je13UT6f7ehfAC3Aq	359
18367	2vaxsxampAbNt6TEv4wWqDeUrKF3XM8XgLsEWUbpaR8EGqZ33t12	359
18369	2vc1bgB4Yp4MAP65LH37oZN27SNa1bViHqPLZPv2ewSrVbAk2Tfw	359
18372	2vbo4GPcRPMrNFuor7uBAfezkW7gxbEeTrm1aisoBqRnEnUSN23h	359
18374	2vbqDDYTM29PifVUwpJtJ8BSVEtXdHAS2L2S1EM8Q5vEHmAkKuzS	359
18379	2vbPYUfJ7jF8bWVh1wv7DseTsbN3Bz5ZcSeXwzCYj9VpHbAvPgvL	359
18381	2vbesQPgB5k7CGNs9x8Z49JNAwr2cMkxuPTR8rTXFyjvsxvYRMrn	359
18386	2vaBnjNh6VNcxsR1Epv6dpvAqmZ8rBfSZ3nTc9466HyD66qP4PrL	359
18392	2vbndVkoxPJpiJyru5efXHoKcJ9AApPFRYZWoV8THWvcVnwtWhJj	359
18397	2vb5GZu6EYWvyf45WcotUbVzZFLgfjFUADfDfKSChWL6qVJeYMRX	359
18398	2vbMEcVS1zkQqQwSKdR3cbiYGnS8wZL8vzTrpjdjmrpW4QXvXSVk	359
18406	2vbyhzHwtKuord2TRwp1fkUqmYMteHcLPQG9ct4UFP3bmPEBsNNu	359
18412	2vb2g9mF7u9a3ERrMAnddoCtZZtcfeXqSc3hGyKkoTqEanegRqMv	359
18414	2vaLKLSZaYdnD1mqieR2v8ondMmiM6tULQ7os2cBTAddhB391B38	359
18416	2vavzig9tHXsEfvhGwPMohiXjAEph6nkjW2dsho5WaBUudHCUcm3	359
18419	2vaJfQ8wga4QekSshQMSmDQsRvLQLQ6KYuL7F2GSc1WKyUuZhEM7	359
18423	2vbSf9gHgpQYKWHmLKT7bvDuTgc1YR1ErArsdS24w1WmcEXqUCU5	359
18427	2vaecDJ3vR3aumzJFzSQKzNfxDGkXXozonf8NSm8xkAffXjChceQ	359
18431	2vaDmG559XuzbpnDqzQsX1fgxQtY7onWy7G2M3EBddgYq9P5XsT2	359
18433	2vbtcyErFKPEyjkfFPQjLa3cf4GGyjAsbHZ3gzs3P8McW3NeFNYr	359
18445	2vbtWTJSmgSqH5eBNy3fiTSfrt2J7EsohK3NGdpUq7aofjZKsMBV	359
18449	2vaoqjziH7q9MWXiZuYVGQ3M3wJ6iE5STSMjT4rhYwGmcEJJ9Lvn	359
18455	2vaBjGcSViHh5RdbuTWmeGt5sCNwZaxFBTFfz8GvaJVfG7bdxdDm	359
18460	2vboJxhfRHGxJ52J69JZ3w3qBvvsa5dMGVEj9dMYY9T5VQYWCGG7	359
18462	2vbBZDouhseGeJDX8sawDwms4WvRQYUAmRCKSAUnnRJZrdhtTwsy	359
18465	2vagAToGcxDcxcwT788AqkRSUCp9uqbnWRteUV8fp9bAK7WDnEA7	359
18468	2vaL7afQru3ePMgDhUFFYGQh8763FftWsi9oKkXA5KbS3KkJC9LV	359
18473	2vbUFszRzUm8n82YstdxP8e59nythBph6sN76rxDALV23G2i83Du	359
18484	2vbgcF9sjXA3e1AfxvWuYAyGWVGdqYWLsGBSXT8mt2Nc4PGcCyBr	359
18487	2vc38ZfcJBDYzWbjE9MZJ2RZBpko1gQ3PcZbZDmBmKpc1z78NLCm	359
18490	2vaqaGV31ax2jkz439BTD1RzQ3HedxUzGpghqkFM2iFNGDJt4Tcz	359
18492	2vaqpmGNsAVFm68ktG5B8dS9p4AWDZv413VtTVjPUaGj7TEGvGeA	359
18495	2vaFBsKWpk8CKea1ZVrSczonyTJwo5hN3qJGwFUPvfQmbdnHFvAk	359
18497	2vayJmJMNR2Ags7wXJQDpuXLPopf5msGQ12q7uzy5MyVsSVsNkNb	359
18502	2vahN57LZhauPvqB7hc8tHp7V6zLXsDRHDRJwixN429iUW4p8sYV	359
18503	2vanj31sydcTSMTh4GsYc2xfGHFF4bQ7Rvb4YbdLdfvqwJdeiwQu	359
18506	2vbUSnk9477T5dRjBbsrK9bQLiBcLzq19JpAiS6gZjw4FgAACmK2	359
18510	2vaMjGEJsACD2jt65Qbxt19rcFRaiiJWoh8yZu4G6EJyRUm97CYJ	359
18513	2vbCNecTwn9nxdx9ZjB6xDG7qwbudNcnxCK5ieLErrLKx9hHixDj	359
18520	2vbafEgfb6XDHoC9VV1Hgb3KAKASmMXaWE4ai9Dr3K47JvxULFfG	359
18522	2vbqf4nkwxWL64Cn6bcZkjRFUdAyToekbC8PRc9RRkZRNZXMctb6	359
18524	2vagzx7a5JwiQHxCn6ruwvYpX1H6tP8dkQiCa16UPYAf64Y7VBWD	359
18525	2vayvTSm25WX18hYC8PiP5DqCXxk3FmNwUhQPX7KU722nSXW5bBH	359
18527	2vbDKboFobpnXNU17pY8v64zGcyihADeR5Vd7opnYuf4tiRputBA	359
18531	2vbcSW6S9rX7idLKUNmwoaotWBZZPFVD3JMVg3YK5hjJySCszmM9	359
18533	2vbYzXZgXxSz7iQADpQEiCexfKfQjUNKCNFqpTgyGuXbn6deicDK	359
18535	2vbHqVpBSKEAH8JbNDsmgpojVACyuZvcxJ5oMoUhEXWmfigipVVf	359
18538	2vbuy8p5RZpcv4cUAAP8Yop8NwuQatM8XMnxmLwDZ9Vxc4t9C3C9	359
18541	2vaLPvF8yWSHvMqYshVMEoKTVWHwiFD3e7o1RKjnSh3inr7SvZ8V	359
18546	2vaQ17y2LSRnRUB6s7eVxi1ybTo2fHcmf24ncDVRJts6M6kEUwo5	359
18549	2vbpNYWjH1j3GRdqaDYGj1AscPGuyHihXgE748BGZx6TeBC9ApGf	359
18550	2vaCS4QDMeRUaZxrnw7q44xGBFv21ptmjEh9XYjErx2QQdvcdDeW	359
18552	2vbKLPgYwdPXd3cGGEsBuxQpuVMrjnTEPud6GhgBFarz7mu3A1fq	359
18558	2vb2qNQBVBx4tYMf1UtkPTQ1jEdDbG2nHYpoFkRhCKVEbSPV7weu	359
18559	2vbSyVX3T2HoeXHkM2K6f4X3mYStVgJgCcqnmhqhHw7wpDpHanBm	359
18563	2vbChvWgS1iqfCU61aNUb2ppGcDcBZqoyZqoQRkcKmmFYZaMtoHk	359
18566	2vb4y5MbVRaLGiaxuUSLn4kGJw5SBru4R4KZUeDTvqb16UeG9Z4u	359
18568	2vbwB8zW5mUu4k2YKRCWPrAWuNomSwW9fEuGjfPjHTM6AedJkLLk	359
18571	2vbPJkTKvvuu43QyZtkS9oJWtq1wgodzD7hMQ1CvGKoT83TapWZp	359
18576	2vbUw7Y6LACJvUt95pAGTFdSMk8CoGB7YPzJqLiT9rYoGqyL61vu	359
18342	2vaG7GbYHN8c35Wq6HVDq3BYEgeGAJusAZm58eKzWfAnuUqbb2up	359
18344	2vbchsmtUsPLn9domBkBqGTiQJz7DnStXUmWpunGXF94imqc7NVv	359
18349	2vbvopachBGT8PEv9a8ZEgtt316h3mhV59GZroGGBzEd9Uxw6Qoo	359
18357	2va9aXkgVgD5D5b5ZNVszHGJuwopbxTTWoo6pMfA1tiUqNNidQW6	359
18359	2vaUQPckWMr4fkDWQxmtQry9auJnBuugRWCBdvRbr69Bu9bvvMi3	359
18362	2vatjxHH3oLvGWeXbzqYzmwF6Buquhuj6RQaUaL8VxArNNA9noH2	359
18366	2vah42dJweChN6mdHFyz2Q5Je3jCM5R7urnPYAgn64S9MZqNssg7	359
18371	2vbWxjKDfQkZRB3ymsZ6BqqxYG9SkPbVTgwqdx3LLD14dbxJgtpf	359
18377	2vc1WWbezF7PBJvTdNisYfDNvowH3KEY1x7DW9uCPZ8ofR4w2eom	359
18378	2vaLtm4Dm3Zde3Tsn7Gjcy8hHXgKT3DVCZsr27jdFsBrbAw4SvJQ	359
18384	2vaRzw2MZAY4ttccXAazcc5M1C3VFXNp7ebBJZ12KhZe29gZ7D2L	359
18388	2vbWDcq4izheZfUTqEvZntjfTvwF3EVKRhy36hc9e6ELxi2QmiWk	359
18395	2vaXA7bh8kvNeYUWfWihf4MdXuYRPpmyL5kdVG3sFuV8pqkWhVts	359
18399	2vaG9WsnonL7hF3Bgk6rGue8gos2G9VFnKTuJWzAu2AvayBDqGGS	359
18404	2vaTN7mzsZ6E4canm95uTyQ8BVUppfBZYutYDnjrT58xfTXki5Fq	359
18411	2vbkJ7foxwMXkLFWKtBkiaWzFdmJC2c1afFoAK11kW4JbBa5N2fk	359
18413	2vaTSXcQ61yw2Bfodb26CUvBiAjsUGGEqkg8ax6a1QtRR6UQ46jb	359
18420	2vacJhBPRVKQ6dwY6ZqqAt3DqzbuRYT3gDiCQVZTwSKwiHq8D8FU	359
18422	2vbabs92zKTK6EE4rAwSFAAQg5iajstE5LiRco3feNafoSrKZn6Y	359
18426	2vbhzYDdjn8LKMB97VTQKoB48csck2VRBiXnUe1Fy3BJnNzcAC9U	359
18429	2vaMaCVvktsA23BxEnA4k8yYukYKsZzohKdadqvfGJmE71KJoeaV	359
18430	2vabx9WKcsQEzkHe2HW56NVsSS5RtsetK3TXX7aHxd9kkqKVcXXk	359
18435	2vaao3LGMYiX28tBezVYuvStjGTunm58PcTsrDoxna3DywkaEYMG	359
18439	2vaQNmuQC99n8Ukj62dMqLPDp2ogEzLrR6oZKm3mBDgpwTbgF8AX	359
18441	2vbNaXeTDoK7AUo8AuNn1eQjea3HuCJsskpCViHEibp2j22e53fW	359
18442	2vbGW4772bcF4fTxvRQAgmFb2iV9w3qCVv58hH5kz8ZMB3vZKVLP	359
18444	2vbjEt23Ag11yYmHWorujZGxJfjt2T3T265df5kDoJ5GXsS66XMZ	359
18446	2vc1E951gX14LLny8sztnDmFZh7gFhmMPcFy1FpkNUhZy28msPqT	359
18447	2vb9Acu7xca6ZzG1uM9Hnn4PxB781dGZQ7eLAnmVQ7YvXcngcjoG	359
18453	2vb2Mwes6vS7uigwmHdC7MmfZUWYuPpqug2ZnAAwW2rrrF49r3uy	359
18456	2vbiF3Fv8u7BuEd7AJRAJsfBo4WdJg4pHmcwGHHfC2sfdAPkhcHP	359
18457	2vafc3bJQpfzkRGmCT7QnoqueozqTndnwtoB2icBSsjuEfmpy5Xd	359
18464	2vbfFbMSBfJDJu6Dcm2S4TAz6Ep9rfmtKa4M28Y457dhg9nK3N2d	359
18470	2vahNU9LoLzKeLasntnntgaTbiR9CDXv2jGj7eX9FvGnpY4tmQVZ	359
18472	2vaKnu6nVRb7GuGhhhV4to9P83gWn7tLYs4PxmdB4es8NFcM9iwR	359
18476	2vaJiKGmoZVFBRsv31JFCSS4s5irfX6ipUwAdtGU1Wiru38ftq89	359
18479	2vaK2gMp2r9XV1GHojMbExsm2B6p8UjGvvu33xezzdDqKgDbH3Qf	359
18481	2vbfF2UZS9Cwt7ribR6mqi9Eon3zqnV5awK4h3zi2t2czJziYmQk	359
18483	2vc5G7DvNbiVvPLQHk2S8nQR7F9z8rKAivEBapDXHMgXuU3yvSUZ	359
18499	2vayiqmMLUkPwwP2BWnBU19yWnSgVFAYNVJAm3KqMHdTD8GMQiG3	359
18508	2vbTSorLqMH57JP6Ed248iBxzBRH6vgUfxr6LqeZVgEvEAaBYpTT	359
18516	2vbi173xy6BZSWQ2ntS3fZqWkBxqWfiqnQVbJiHJG4t7b7H6fW85	359
18528	2vbxtVQUwS7HEtpDtjye9UD7bzmtqmDrRgvsvayn2q4U7G5giNtb	359
18529	2vbnVgfs3LYr9s2326zWvmsBLB3KF1EJNHkDpbbPSBZM5gjG6LXt	359
18536	2vanHL2kYwDJcdWj9ReMnEo7frx2pwk32rmAs1zgJzneZfQERVQs	359
18539	2vakMuziWgJzESorZBRxwKigepSyDJ97Xk7LH5Z5iqEoNPaG11zy	359
18542	2vaHVjsced9fUoquhTvEJG7eKFCjjbF5VUkgnWNPYZ3vbSsoRK5d	359
18543	2va9hmDq7SLKgowFyXbDmtDzFoQZdYgbx4RCS4rFWKhN1WPej3kX	359
18547	2vaT9VkkwZ84D1YvvNaDqdV7pTS9AdNohPwu8Z9knnGnXbixbYVM	359
18553	2vac8E21ZazyXQ6LLLR2z7SfqfRMiJndhEEU9mxA2CzTDEagpiNg	359
18560	2vbLyMXARS6KXFAGpTp2vyxNByxvMrtponzWNQxinxmgxTW8e6KH	359
18567	2vbih9mgYLwPaJtvGMpQEXBv1RBie1FfmHTN18oDoBBpebRNzRS4	359
18569	2vany8SWNLkcKMU2KX4MKv2qrhinf1MfdXMhiSNWewM2katmZxRr	359
18572	2vaZtG8nLWX4tAzRoDREBmfoG94dKSLHd25DYMMrhsKaBGi7sPvR	359
18574	2vbCPARn9qxuax1nByxiYQuqTRNwtGAQqqie11AihofvdNXoGtTT	359
18575	2vbfYE1pVDMk6RswjyAMQ3gYVMYMGPsWckua3LHPitPtoKe7Jsw4	359
18401	2vbSvKpBSSmQ1ifETtFkTbqUD9vT5MoE4AFETLyauZ9VAtEqxr7E	359
18402	2vaLW77WVRn2A1454xQqLUoqettM2HgfnEu65uxWXTtrV25XGUJT	359
18407	2vapRA2Qxf4DByf3ry73HMAxMnfsi5rYWWwP3sNFJzmr5ZUW2rzQ	359
18410	2vbbXSLFD6paZg7TTNPnudX7noGNfDuJSWqNM4dugDKheGebqZHj	359
18417	2vaKtCP2ygixcMqJm4eRpRQtf1txQazVCSNcqmbjozsvfHSkBRNc	359
18421	2vak85qr5brBo5RmQWdfTkWiAWeqjk7BzPRYwjzFnucg5Dao5UfJ	359
18424	2vbfvj7FDiAnQixVyJKxHxZi7tQCpxnNgUhPW6GgPyAF1jfjyLzf	359
18425	2vaE7oE9GTUrmfayscc1q66GjiRqMDwDh9VrQfmT369r3e8QK5cz	359
18428	2vbgSGoCiNXWdntVxWpa8NK1GkZDQPUeLfTVyJspvhLtEkPZFMHD	359
18432	2vbGmVUy5t45bPcuXZoMptP7XN5EH7RjdYuWX16FG8T755qArDjQ	359
18436	2vaNFE31CfnG5fzjX4iXqMTEyt3EVZ7wyVug9MrumBPFqnYh8Xbi	359
18438	2vb2h4o3ETLuZjhb1EM4KUawW7LVFw88P9MGGXvMGKhg8hzsqg1c	359
18440	2vbxUb8LBBPmqJH7GyXsRH9EozLiZTXdjjzSPwuwd1Nte7F1iMVn	359
18443	2vbwrXxCifwRexsjgbJpYEmvviYP9nNM4cJn7vQb4hGhb56hnN8s	359
18450	2vbb4GUQTWTkf4jp9DHVEpTmtipuGRWQ6wHECXJmrxVw5vDLYA3N	359
18451	2vbw2ypQhqeGsnmE6q6sGeS3pcsRg5RrBdksKDKEuQteG5doPaTZ	359
18458	2vbBmZ8jwZTTvXQrLUKEwv3t2wXrJTPgaKJSE41SHCtoDJNaPm4J	359
18461	2vbGFMSLMsrTXRvyE2i81RugET7mBjvLZdztUKbGTqNZorFMqn26	359
18463	2vc29fn4Mk2Yqa1yZSLhF8zGoGDRZp4UxJXffNA1RHPZRmKDryo2	359
18466	2vaj9ZTu7obh37sMmZRt8yrFGHpg9jpupt918w6Y9RP6J4HJLu36	359
18469	2vc1K37fKBDVnmWXv2jmJiG3RQX2DPG2GaBvKYmotAptnTkyiTQn	359
18474	2vbeiQvc79cXuWaVLfSU4vjY3vjUmpEkCmYFfq7RQh5JQPoe9NW3	359
18480	2vaA9GwHy8wUygNz9ZUW5kxXsdACgTN1uUYiNC1LxiHkGn69Ysms	359
18482	2vaWm45qLPZ64L7irzbcqssZ8FwVmeuvz8dnTN5kNc1qMCCMPoWT	359
18488	2vb67YKhgWtgwsEePxs5eBDd6bE9kXgZumm4QQKmSq9v6UyseWEm	359
18491	2vapigjdJBm1LJQJjX8hcgMp7X4ADZP3fs9H5ggsewYkrNeqbKja	359
18493	2vbPg8pXL43fKNUCybTRvhG6FPjvajt4ju2d3YLWUb6JKh85jLT4	359
18496	2vb78PdMgbKamyKKuJMB1vFfvdxhRamWxo2e4i8WmjiEM56QgkDY	359
18498	2vazwqXZey5QeK3WYt9y8s7Wh1eW76C77drcKmSjb4AURaKcT6mn	359
18500	2vbFisSDWcHR9NgXm3ipkc4hXqsMGWNiCSK4M5t2LQDjt5phFbSa	359
18504	2vaxNbsrBLKAp239r1Ree5MYXZnpNQUeCozNo4wbRs8GrZfXaLGg	359
18509	2vaV8k5pBGdSjKaEHU7eZrD5M84gzbUaqD6SBiYsT9MEEHLrUZKm	359
18515	2vbtaezcT8YEyUuYKMDKYo22K6ZvjkV6T39e9sTMBskGsLNCSd3g	359
18518	2vbpAUSCjBTdvwdHehVawSd4ZBNgyNQRHC1tsqrZ8GDsjssQChet	359
18519	2vanHwdCaKAfrvVGMgysawpN6mZuLa3CtSWcC2B9xzwvivuJVhsR	359
18526	2vaZu8F8ByQbiRezjvBybj2Za5aBEj6aKrsG3WcNFqXHJ15GxLVR	359
18534	2vaoYteZ5KwCqQKBNLXJArJiYGnwbpuBC66DNaLYDfPZRoLXrBCF	359
18540	2vbgo5aBwJHu1cmLE7D6CV993V8so4PDvbBeVXacrtCvhq4S2Was	359
18545	2vbRSFob7MQQEHCUyDzQMACdLmazdS91CXA57vdDijnpyWQyeEX2	359
18557	2va9F4oNWBwDnQWAznmNBQqqisCHDkhzJyhKs7EaptHwiFuNwUT7	359
18562	2vc4wascshS6gbVapjgTr7ztsHZUWg5t335rtL4K4KY4NnmsmRno	359
18565	2vaBCwgvSBasUXGHj4FvuwGGsDEY5vkGRdMBeVMXAM3jKWbi8EJQ	359
18570	2vbk54YAoGVsx7Wk55GR4Hi7P2rSnEzi6LKHBiT8xtmjNLQMBBfx	359
18578	2vbvVRjMJEAa3JTyVYKEyuVoouQDqyN7vRQCmLUWpjXNZHMSVRkQ	359
18579	2vbNtSzfKPry8zzxBN9sz946k3LYjibDxW6361pzS3AxRjKfCAvc	359
18580	2vbHoFtacJdmTX3jWvhcHQpBoS6jy79estgZF4R3A49wsGfDEf6z	359
18581	2vaJBdYE5KBu9wbXRbC7mV2urt4iHUxA9weHeZHzGbcLa4Nn2kpU	359
18582	2vbxpwgqkD1T2bZqc1cYKwhC2hNeSasBxYkHGC1DTqDZacXamyxT	359
18583	2vbVbChPCjTfjMhrmZirig643mgq9FVTTbfU7HUkZNGN8DsydRk1	359
18584	2vbDY57z6EhYaNtK8npCTY4QmkAUHXWFrS5SkDnPVMFhHmrKGH6G	359
18585	2vaau44U5itTEPfqPjx82PXdvsnYgU32shjKWhGHiQDeQwQNBphe	359
18586	2vaPfCNTcuZHLWrFmC832E3J9sng8mk4KzrePbErK8r1tCmsTJ4f	359
18587	2vbAW54tLTMrcGRaUWNwzvw8iTjwQQKhxvG569z1rQsJDHE1B86H	359
18588	2vaNBWXChEo9hpUm1Vz3Xt3rPzma9i5bf2VawszNdcLWQcbq9YnK	359
18589	2vawDfzqFPuPF7kBSEjdewhfKQ4aFn8WnvZqiWDR1AQEy1yLrz72	359
18590	2vafiV48VYACJXZgoq8qJtZMhPfkgXvxoYgJnrFQ9UEQP41xvoXj	359
18591	2vaMhybfDBuPwS1z1GpGxKpzGnX2YDuq1f8CxVUf4ga5xZcVw4x7	359
18592	2vb9yepEmVo2y2yuTs5FjXSuEwnmzsdn9sSio4q3fGBm6xVaxZGn	359
18593	2vbFyrFYPKUqT2qbFTpFBLT9kSTjWTwB3tiyD5AzoLZQMuFa7F4X	359
18594	2vbeQpP7De5UvYNweQUygdMnYPuqdrG1ADcuvMvUh1x4kLyyvamv	359
18595	2vaAyBDGM9hAzEpbxygtFxVzUrBLcf3rmCkAx44nXqCyftQNzejT	359
18596	2vbnEnX8YMJCsDfePV8ChAqVfyEZr4ZwYn5r2kmeXCj9yhi3adKf	359
18597	2vbs1dzhVDU5UAU9DcoSe879DTRVpY2sHtDM5faoNdFY4XxjqT2m	359
18598	2vaShZ71e4VJEeApuCrW3E9xvowKAMVnqj7FJDseUeNZ8TdaX1dp	359
18599	2vaKm6Sdk2SwRZyjSZGKbRqAZ5tYKe1auG499xAwv1XQz3g3rp6J	359
18600	2vbSbzzWtZkBtL7KhD155qa8xsAyDauCrzur8zndHwScF3UPz7U5	359
18601	2vbaD1aePTq467QqzvfBMEEEirEwYPoPxshpe8WXsYvUq9dQkhjb	359
18602	2vbpC2FAyzqWy1dpzNF77SeApCKnjmUxpg3zRRvAWjSj5cLwAMyb	359
18603	2vbkpu3yCbWfSGJYPNX4SnpRyJiVkryrXcaGjgJ3nzPP9fVNYAKf	359
18604	2vbizArfHT1JtP2xWBZAYzPtR455uApY4ud91VxZEBLxXwrZQBSY	359
18605	2vbjEtkH8EAop5hfvggqAPw85AezJBM1NjUTZh62QZ2f29GxXEr9	359
18606	2vbYDxnEmKn9Ws414bhnYWbL5mRKuHyupdVeWZAHpXtqrQkXFpFc	359
18607	2vbcVJYKTpU7bhFa2rGteHgmWEarvcmDUZWqLMgskEeCQhPjQS6z	359
18608	2vaKh91MPMVYpMPFdJcgNDhwV7rDKutyGg964FmPDHxaYN937MnG	359
18609	2vaUtatBCQ2i6eUmtZHhdjMyQ8rsK7QkV3ZHwLHqQqzkcvTWdUHa	359
18610	2vbgV6dyYo8ZDUp7Pn8BLJE9HV2fsX8yRN8Y4zPAJjDozAf2doPG	359
18611	2vajNyA5xW94giGHsg5VVYZzHhqQaBKJ1NsiKK9HLcYoTjh58j8V	359
18612	2vaULaZook6mFgpTp9n8hmhvGs7jQweasyEfvhRcZce5gN8p2fXe	359
18613	2vb58aAbrw2vhnxfADYnwe4qNWBbG75RTCKQJmJBDaqe8nVLDGxV	359
18614	2vaVBqGbZS7MXRSw4J4pfYW67paWtEe3ySaczpaD4KmB9BDf7v2S	359
18615	2vaHCGZ9XsX9pgdE5MdroDrPu7zXh2ZFEpQe88ZdMLnLgsncscd8	359
18616	2vb9rfafWQHtEfG2VsHTLHvNNMJPsXTZyVktDMjAr2fStQRK9orU	359
18617	2vbvrmKww9f4FMCdnFXEMCx7nzr63hutGGBKfvTSjo1Ut4WybYan	359
18618	2vaj8VFDaamJ7djbWSHHa4p1YyZCBBLGzEpPEhEmLXEYguvBboSz	359
18619	2vapzhavm9oMdQGNEsWGGxkSMBD7XkjztsokmCTm9MduwMoL4QCM	359
18620	2vbpqgw4hGf6QxU8wCieF2Ln55hCfckMP6Uk98mzDkeqzvxBMjo2	359
18621	2vb6DdQTyEm3XUGTzMNvXYuVKmqdgVXVbtixDe45EsnQSe2FkBho	359
18622	2vbExEgUaNebWgLuEg5seUz2BF1zKHuGvWJP5hiu1brM2F54s9zH	359
18623	2vahuEgEZNUJDVmwDfCF3HSyPEchtsoyHfhRjmBQ66zqx5eKCpb1	359
18627	2vaQW7BJFgquF1KTRgoxYgedqo4StHks399MzZgznvwt7aox4gzo	359
18630	2vbFXBacaM9BvbQtxtbJndnqwzYKmHDA24oQfDtrf7L4tUXqcm5C	359
18655	2vaiVzKCnewbgLft4j2Wzgn9jzmwpKbcu2Y5jRBiQzuYAsfadPaB	359
18658	2vb1aikiKRuRsKDuSiz4Qsf2KHffDN7Fgo9uygyqYgGsVG4yAmzZ	359
18660	2vc31HueV8c9FswSw2P48AxWfi4TaCrYb7VXTEUayYvHyF6GDm5h	359
18664	2vaNmSMMjNxe3D3sWwgCHyQpvhn9xVhpNLKgvQHQnwJmBBJHdBur	359
18665	2vboqc963njZ7czLfnspYKbB96NvENYtZ8SVKMK8yWxL8Qwemnqt	359
18668	2vbTVnRorRrM7TcXtB3KPLq7JMuMMu7xNDnPrsWJNkoPsZ8UoodX	359
18671	2vbCLmuduai3nonjz5S4KBMxKa4AWoGMzDKaieKQzbWLiE91f4RN	359
18679	2vacBxFwPJ5tH4nuimcGKi2Ca3JQWPk4F4TmrtGwL7di1u7dcPaH	359
18682	2vaPG2cYraFc98ijse687WPGP4g2J4YzY3j9uGv7goSM996CsJsL	359
18684	2vbtMjsv1yhZZQnEih43Mv72HAPJ5tsfKoyRkXk7ZRpdT1YkMHTJ	359
18694	2vaqJWeq8Zgc7ZqvcDEj6fQg9EmkdavW4WkVweda5tJ51unDJ587	359
18699	2vbZB57uRdEubVttcdgeXhLbWqjAYDKQPnJvBQ4LCQWvKfRkHP5K	359
18700	2vbvAUuxU4ePjmbrNVU4ej3UmP9emrienHr6RDXsrk1gGodgwKjL	359
18703	2vaqJQr36y9E5tadkLiokpBaHw7XABUWgEb3mAZWZBEoJW438fo6	359
18704	2vbHLWur2ZTfPEQ6knem8vepqME1RhHMfYJ7VhX22n2UimuRZ6H9	359
18706	2vbrbyuAf48cXkeHoBfbvy19McozjTnyo2qnLjLqXbV3p9P7xLWm	359
18708	2vada3phad1T4hKLaqnSrWdaoSo8pCcNPr7jPsPeMs2pNPZEZsXv	359
18717	2vaymwekQtH9fvNXSXM8aBti8cBGFrKbKPisp9c4XA7QVC3TaRfY	359
18718	2vakLgad65vmGsYwGMaJALbt2GUVL796dmQ3Mn5h26fFEnfmrGqs	359
18724	2vbV1CfD2qYyYzZSwGvNEXgXRKm3qUonQqfiqa3yHMRVypbETzKw	359
18731	2vby6eKvFd3jJgYQULwb1vPbbRmPujtmxwVTmJSaurvfLvMfp3iT	359
18734	2vadCnXx6mStgyhCUWZZmh6bGVhmMLayNh5PHrK8knLMmSTrVmKT	359
18739	2vaSNQLheF3hHFbHHoNvXQP58zxRRuveLtvU1wcy9YsWNmVXH1Xs	359
18741	2vbk78YRF7xM3Qv2r32HgSDCBMafud67LDUrp4fApVws6fRs2Yaq	359
18745	2vbkV6DjkvUkUAXJuiTbQL54CoFZiEukxuCGMX1eieK14mwwyMwm	359
18753	2vaHjHcxH2nf1MMDYBdie2Sn4qD1Rha1S9ZKWXMs6SeV79zxGjZB	359
18756	2vbrAfsa4MVKir4tZHRPGn6oksfXe9VaHqNw12uMyd1t2a69nrJX	359
18762	2vc1BLWCePC1vR4qe2fu6kbaeeAAAAwCV4MgAGvQ1pPNNun6oGnx	359
18764	2vb6sK1FhUmJHTKzwbKnFuzpJqZfTZ7EDhxWhzdF3PYrGo1tSva4	359
18773	2vc4ut7aghiw9JA2YCbKJzbnYCJ2b6THkgNRbRmvzNkj36YvbK8p	359
18782	2vbXazSgyHchrLRoKZXReCkAAP3bD4z5zVysJzERLTMHbhPBnTLm	359
18785	2vaLm3n8c4uWgLxeKevgBy83jxE81GMywRp9GKBtjMp64w3tAKKN	359
18790	2vbrhYR6r6gaUV4i72sJrjR3o1rzGPN2JPMoSS3B1ZwB31A8BjJR	359
18795	2vaxtGSG4mbRi1f1SyvhjZzDJw8zmoYWozyeAbWGuRtSA3i9a9SH	359
18797	2vay8dF8dxDBxFfWzjAo8B4AEHaWXEh5BFxYawEt89eY86WrWMRP	359
18800	2vb5R1y3Mk3Y23NVaVwaQQMNDuh76Va3yHJRKmgsoY3iTBty8HoW	359
18803	2vbc3ZsNtdvvHyqp8VZM4ZtEcq4p3f4sHFXWpbWs43HxxVembJYn	359
18805	2vbtwWJ9PmthtEF5NKLqoNU8ieqdAcBtvRQrkJJC2JABxH5fm2Ef	359
18809	2vaWnYz96DJQ9sRWpNGhGfZuS1SqmRqSW6X8RtrJLwa8CXei3u93	359
18815	2vb2LRMn43GdDJCLVCiaXh9zo2ZNXFcNiZpeNjHqreGiM8krUE3W	359
18816	2va9ggpYqVJ2j4dfBf1ncbqHz5AZeqmv7FHSCs9CDBt3Md5eHL6g	359
18819	2vaUs1ka57buhPYNVqNuLTkWBEJtoNjJSjthtoudnFEwNPeFVqow	359
18820	2vaGfW5FkMzRV2esvQtKudXtbMkjBnoWjNCuuMgnQ3ssAYFEEDBV	359
18822	2vagZBqPc7u31QcoCqqK7jE9odXzLXthqw4P4UGAJjCwemPBR1tS	359
18824	2vbHNnGAM3S6AZcupfGdqQhzYpL6x1NvafK4LEveV7v95szufkVc	359
18827	2vbtbFUgkJWXa3xXfDqBWZt6rXt1ULnLnb7JXqsagYeNFsSevQyV	359
18838	2va9EX4UBSyEbx1VRHx86cn3A2LG3tUkW375hRHxkzCPDDyZks5t	359
18843	2vaRQPMfTowoUUFxnNXb8weGbaKxdQTofirsQvDo17hsS116oM83	359
18851	2vbc4Ju5CdNSkVLjwGeZEZYhe126xTpDhjhNVs3SXopwR92Gv8Lz	359
18853	2vaxNue4CfcQRDUcToU6P6bHk8CosCuYwgTUvE84eqZijeQoF7kp	359
18854	2vaUkmyhSi9RHJtRcA4Dmx7LZ2fjoacGZsbzS7Ek6FMgfQaEXZQj	359
18859	2vbMwhMLjMqo7ALbeXTZjwuyBkFueMCgfn29TKY3HFPs8fuBDJtD	359
18862	2vc5Dh9SvNNRoY3F7w8tnB1Qm1vxHXZLPYVqMycMeptmRePLzseJ	359
18866	2vaZ8iCRx1sZ4Y57ABLes7bQGGLsu498DkGhns7g9nTpMNLY2B4Q	359
18870	2vaxiT5gRyqDNyvcbx26FbXxDoD8XRkCXXHfBgtrs6zuYrjibeTF	359
18872	2vaQG4ahHRodnjYxRH5ea7Xmnqo7XrcFGacJ7s12XJ8gnu8UK3QF	359
18876	2vbPGHUFYgesb8exXcvH9QevW2XaETaRoGF66fCTu4faAUtimFsK	359
18880	2vaeejM3GQbKcuB3o7RhryXcmNV8tD3QfEviNDBfuUabnounHen1	359
18883	2vaikZrMXLYMMRVix2NaZAeDLQhu6iNheiKnSdE4VVhS8AjCm3vB	359
18887	2vanbUfBJNmTTVuPiJtpLz2ZiuPxwV3X6aeE2iQrxyg1vzidGjmY	359
18891	2vbrTPqz9DazRsNpWYBfqTQTBGedKQVwWpudQfDdEuEZXVUNG2rZ	359
18896	2vaHowoJvY3TNfvHBbQ98LsUsyY7rGm8rewvnvVxRqRHhaZwvSGj	359
18899	2vaFGBJ8idtJpAMrWeGdPo1BmeyZMuHuDo8P1uySZpLFGwkfBsie	359
18902	2vb2SiPt7YjCpuDfAG1T6eQm1tm4uiZHq3Q6oMDkc98t85LVbAtt	359
18905	2vbxc9jdtm4yW83VUfQWQVi2WFZN3xwRitYSH2cfuRYqRtFYr8oH	359
18906	2vbm3nETAynSR7av58Z8e1xm3NqvHBciNpsvPPLRmqncxD5XTDyK	359
18911	2vbFDfPbY6XHhuDtNwNi7PsinZQp8kG2BE3sYTeP1QfWzT9VXEa8	359
18916	2vbJeMUFT1hSuSz2p3d38C2L1oz8HYFF9fvDiURzbRE3itERKZdH	359
18919	2vb5qLzc3VvaDzvM3uu2ZQ8WWNyKk1FbN2pQPHX1b6rD4vYX3ZoE	359
18921	2vbEdew5gGdn5A8p7J56A8HHobGk2HBNnkYHVaoYdkPhgbt3CnpK	359
18924	2vaiNv2A4Fmysu2TLG2nALuNifefsBZM1YLzsCKY6NmRcVsdmtNw	359
18928	2vbmCgY2g1tvqASBZ29nL1CP3XAEQi6dPm7BkydrBM9MizaFQR1A	359
18933	2vabMZh6VizmNxM3HHYEHihLQtHEXU6iqbFxwtS9u53CMnKLV541	359
18936	2vbbYzW9Pjrp9tjRpQawEX5D7th2adbLJQrmhZ1wPm3yrJK2qLC9	359
18939	2vaUMYpasv8abHPS7ov3TXBeNS51yGEcyLCnmT18nR2942bWr9b1	359
18945	2vagXdSEsgi7GZ7qXzVNuxx4Y7y3CKSsMjvc2AkBQPXNT5fV8MXw	359
18950	2vb4UdMCJxVALfetyAc3xQXVzRYfB1P8P9F3U3akhL7wvQAit2Pr	359
18953	2vbVdB3GLgn1srcHcmFYznDJAhVFuKpmr5FvdUQXz9yurbQVtDdh	359
18958	2vbwoeW2n4V2p5Kaek95NK8Bt93cUWYtGSVPL8eLX2FBmYDXw1QR	359
18963	2vaosPjyrAHN9BUxRcapmDu3Y4MX8Qmj4VEvnnGuHrsV2qdGQySj	359
18965	2vahhVHoN5fW2BbfkCFTJKjiyGSfe8GHevbbD2P2AVn4rpHJVGn7	359
18968	2vbW8Bz4HWWK9WNrDo8BHNvFk2KpE9YFZ6itAZJan2BCiUccHt9e	359
18969	2vaNdA2y3qFC98BqotzaQZAdL41hhEzqLScX4TGwHG4zjLt9DnEH	359
18972	2vagHDZmmgKTMV1RuwEYYf283JFKPjb3QrbkdWk8hJLnhYX3gMyi	359
18974	2vafLYumHvDQP49XQScJnPFqh977FdAsjhSrZbrtrXpiPsydG5Sj	359
18624	2vaVGK8iGPswhRm3uX6eEQWTUL3XNSGo8zK4pEiC5Ar2gJ4uxeqF	359
18626	2vbEDJdZkMfaPQHXaESJKbad3YD4XnQDhXJzSmMVWoGmK8L9rCbu	359
18631	2vadMCVzaGjhHKdD1dxRnxapnDQyJSquKWQyJoQdGY3656LvNtHz	359
18634	2vafb3BU9nKAp6Vx1Ei8kBDYESvNC4GWWM9GyVLR2bhut3QJv8VL	359
18637	2vaCCk9tbup3YCyAT8BN4XkQ1mn9w9KRcE2HzBrD4umxF9LxfHrz	359
18640	2vapNfmKQaNArbn6XZgvmEFPEBzZZwgLrTq9kMXBGM3cb6d9J2FP	359
18642	2varbm2pzGh537ZQ4qKke7H9isRoAJWKwt9bdgTPCAeuvHJb7R1m	359
18644	2vawr22srH5AEi2MxwXiziTrNE68Px8jTC74SHvBb9qc1G5vqzif	359
18647	2vaQA3UMNmX92GtYPk3amzin5SKMBnkRcC65pyQwn9XDMQ88Rkng	359
18650	2vbEPt6yzCvJfcSxJvYkkKU44Rp7cZSWCNTXu2fAweZL7BVZNRZB	359
18654	2vbdxnG8QgSThEwitQC54RV6NQEr6FWAxRduhHBZxwDLa5G6j9B8	359
18661	2vbENnppoF867zDHT7sEjovTjfmXaxf95p374TaFcU7g4ypatTDE	359
18681	2vbXaNKGhhyiGMWv1nzMkXwdDqfog1uX1VXA12hKLxSTBpXDRa7L	359
18686	2varfwTuguLGJ13fbYiC7s47j8t1qMZNaSzxAbh2AqX7hH2EiVaQ	359
18688	2vbUxxquTfUfYeuJVJKc3xHKxb8MdjMDPk5WWMS1iGA91pa296cM	359
18689	2vagADLX6cbejBnbwvDNySuwrv6YPEWwNpcBtSNEPy2mfFxQP2wA	359
18691	2vaSeqxQhgN4qn8KRrthPZdomkYsCg8NDAwfycVRvoo3VaxV9TjP	359
18696	2vaLoxs7seTuERB5SvJXNayaxBGTGp7Ss3sP7JS5JoC3GmydqqN4	359
18702	2vaFwiqiosxuXQZEHGCJUzfvfzFsUEqNuPVueDs8fgzkZ2JxstWF	359
18705	2vbAHwxRPg6WYBBfD4FwiDkQn8ooE9jSt4462idPa5BxpZCKchDV	359
18707	2vaQwhPiaGtr6q8ZRxCMoEZwHD2whAeabWrGEEJbsdf8vKNPQoLq	359
18710	2vbTQwu4DjcDYoymX1oWNYDVqkYKWWQwq2NhJnb4Bmut6aJyurRA	359
18712	2vaiHnjHCj6azUiWGJe7GrjoZvyiFAKW9LUP4vE3V9csjrYP38WJ	359
18716	2vbjx4fzUn1K4t9RsuXj2MjQ48Ko6AXwWvryQqGa73DhF9gqWiuZ	359
18720	2vaYHe51bZssWZiNRkFMsMuSAgE9v4t4WcJevn5P8wJZhoY3fzg7	359
18723	2vbr7GAntbBDbX4cW23pHkKMUwmCi7BUKtfi7B9KsSxpQCGYSrad	359
18727	2vaQSgL8VAAHuJTx9UfqpExmwR2EkCeinrADeauz8EtAz7RjvYmt	359
18730	2vasv29jsgnkFxMUZBjrcjY2kvT66tnRGuaPgXHWTseXx2bb6QHu	359
18733	2vbe7xT7v7jnz7b128YVCgHu1kPCw1NPySFCmQc5ZYsJkGSrvUr7	359
18735	2vaEyj5P1UnfAYYhoK8kYLFxLFpbtt2ZERpYyo3yGxEM7nsudesE	359
18736	2vbiCQVZoLPfgmDvvvJnLANzbWiCiNmvR7oYpkgW6Y5futCNnVqQ	359
18743	2vapgHyR4BFqYqvj1rbPNKos5HqnFz3ohBKHb29u1stGnq3kLJw2	359
18750	2vahXcYAfHP3JFYiMtr9YpM5Cxde3y55g2UVzPxEm3aNcu6RebUR	359
18755	2vah5NqdRWTqD9ESQUrZTYutLHvmtQniEZoAv8E3kspWfF1DC9yt	359
18758	2vaS1Z46L6GcpQ2T43SunGSLv4GLWkvXuYDBL3tSNZmhrzqucPWW	359
18761	2vbe4g7qqdfjZHCkiZ7SMoMMVpcsmg7MYscEVRmefdcGaMpavjjK	359
18766	2vbWNJGvva3Tzm2Hx4QCo1ZjkDyVcpYSkKzRjF8znERXKjQQ2kxC	359
18770	2vbXGLxrU4CTg3JmoF8ZhjzJ6Ejkf3MXMskXYGJRvzjy29SYyhRH	359
18772	2vbR9QZZedDvLpaqV4AKsTfwmVJQAdFBd64ACs9Zbigr7gCfZ1qw	359
18775	2vc4skAkrCzMNcNnhP618TrmKqHEmXoaxACkvjUhdPr9fHi36EWq	359
18777	2vbV2f7tqkiKGYHkfdKiRuHmZq5qKg3baBFbCTZEBNjKwHoZjhN8	359
18778	2vc1jdw6vvujPbjPEbYT8wQ38VXEPgNuFtA4dLEB8p2LRqrGATbt	359
18784	2vaubgUKDPaGhfzwnFVsDva3reUPupT32FKbCgfegFNrgCty266q	359
18789	2vaRJAKXTD1C8LdxCTrqvk6MPXVtgmmEnFPK36u5GF5aECN3yDiq	359
18792	2va9pSCjptD2UffjHZDcuXCNJWfzPfjLTm4tjLmxQqdhzgAZRfbg	359
18794	2vbNzJRB6oPCRny8Kbqt7kyn1aFvcN5GK7gxKRfJEDuznCeGFvaf	359
18796	2vaMe5US6vgKzeQ4TWuJU5Q5wKzEzanPQb7EbcKLrEoC1iG8TYYw	359
18799	2vaZC3yJpgsy78ajqkWu8HFBPFRL3w8R6HTyZvnWyjSh2ytPFuNL	359
18802	2vbArx7x4Av5p7BZYGq7uqAx2gGvSsEZjEfVk3HjG28QrMBYCbhR	359
18808	2vbvTqo94x7yHLAumbEKd1F6waj9bojN7GPAoJeX7QjSXfcSTeyf	359
18811	2vaiX18oWYKFqnH2eWF1QPYmUdguodunp4gzo859LMmz4wSRvVCX	359
18812	2vb5kCo1KnopCbS9jag3qDeHPViYq1KrLN2zgFDw4CFC7RFszYzw	359
18813	2vacSsixcKinra4d562jgxVkmcVrrPx8dngnWGYKwG4MMsiLPKVQ	359
18814	2vaaYamHsVkP5SF8GZhhg5sLaLaQC661ajfoheudNRbMwAV2vzRJ	359
18826	2vacZPCkj31qJKgitADyaecSzPQJzxwiY3vAUDLDAcLiVTcnz9us	359
18829	2vak8n1XdA3zanBQ9NAfFmjfk6gxoDtDYSuoRyVPq9pUeh1DT3t7	359
18831	2vaSKYpfU9oH1xaetgTcYHjjAUM6rtCNuxdNmHR3BPRjqpVuEnyA	359
18834	2vbW7jfuSg4uwT41LM5ghHEKsvKdKhhXC3kqK3JqZj2YqDevpR9t	359
18840	2vappqiwU8P4i4PTTCiiGVRa5HnHcqSSMvkg5uxHbEkPWJpgyzMg	359
18842	2vbaPjJ6cC2nFATYPupEtnP9hFavGnzbdXR1nwR4WaVkrQTBvZ5d	359
18846	2vbX3AvU1HjAjLwGjYfM6MLQ76krPNzVMxDDMBVwkA5QtUv5t9JJ	359
18850	2vbuXrKpxVn4Ax91f288GkmnqrGDgvxSF91q9h3WE9uxjWNGSCSD	359
18856	2vaz9aLpdSULFqH1PN7eoY5TVfcuv1WjNraD4Ex5BYDjd2YS9Apo	359
18858	2vaytVkGnhitr1j2Wa2u7tsK7JLJgUfQbu6MUm7vzYafzxcAKB2k	359
18861	2vbumYjdVitdrMaTjkesBWFWUuzAuzZJzuN7AABb4kvUvixYZDF4	359
18863	2vaWNTSwByugdSk3fJYuS8M5xqgjFs7DhuVvLKRjgTpoMPFhNNq8	359
18865	2vaAny2UG35jTARCXTn55r2Mvfa3smD5E3KmZFx2B834rf6m32Kk	359
18868	2vaYL9Nz6EE7TzFwntjGDNq2KSp5rjtsRBATXJfYBLS749k2HfLR	359
18869	2vbSJvBJTFVA6udbZPV2utwaTKdDfHQoU4DAsZu2sEe91JvQcZKH	359
18877	2vbvaRAjKC19KKhdFYrwNXsor6nifUVgfoBjVhmAu7kbypzr3nkd	359
18879	2vbkrzUZ2AR8KDAXTNaAAB3i5fYnBMwvPgPma7UFLfTFcJecemCK	359
18884	2vbMDrckTV5dDPKwJM5XCU2T8Rc1nWfFaeSJqCSAaxFevfSYMDfL	359
18888	2vc2BfQsQqypRRs5xrztgmZKHN3oa5i599tYiZL39u8kEHTN63WR	359
18892	2vaT27rnbXonm3Z7pmDHc9wshLRPbuanv4Z25n1F9wVJ7R2xwh3s	359
18894	2vbwRXfcn5aQzimPWdMWTJuE8VQcmtFcVeipAXk4ZrWLa3sxkgfY	359
18909	2vaJwb1tsBBGNKBLK7xNLyeYk1XVcsXfSxXDjiRLwYL6XZh7M862	359
18912	2vakUaA45UrReWPdu7bsKr7EyrJAeXNZo7Pw2DwkNhyNWiEWvjJg	359
18914	2vbhk2Jr9Vh4hpA3huLT5uAFN8TpiBxY9BYz5pcoe2iozxL4w9Ft	359
18915	2vc3vUbhVgjy6Z72MTLGTum2WfVJoDXGF9SwkizHDjHsLwH6uaRN	359
18922	2vbEPnLgN7LHgKqmRejABq3YNDFm6KiDXVH1raHpZPoYquJmUhxU	359
18925	2vasxbuH8jbgdpknue9GkFr6Y25RGxuVmMMaUEm659Vdqm22XTeV	359
18926	2vbWgZF1wGbvjpu4sH72MahMgVcnJ5cD8n3Eh3BRvYXQgfZcgnbg	359
18931	2vavHJafmNyFXbrKbWoYp8gPhnqoDZERN7N612kwBDtCHLKzTQ8j	359
18934	2vaGKN3kGpZXve7HSDL3HWNZ6ZPoXEUGZDsAF9KqwywZP94ujK7c	359
18942	2vagKugdr8iH2SvydUUXLyC44jUoeXvnSFgefWnZWPNw3e5VJuzV	359
18948	2vauPoRL9PgkcFvmQdEvLcqEh3pMoqmvasM2Lwun4fcoX6oy2W4B	359
18951	2vajLoemEUx96v8j83NzkSv2NB337shLxNhV8ADTxHYyxnrDaT2q	359
18961	2vbKJPhcxqXZtbDsHzqSntpAJGQAA9G1jH6EGMjSxwZrHfk6K2vJ	359
18625	2vbX6EKsHCbfN5EUG8anJGRdCbpHv9u6r6m39mYkVJZbmtx4f7om	359
18628	2vaVcvwoURqwm7vrARGX6E462SNJUrAJLJxFWDREcozPkXQoTFT2	359
18632	2vbjtqG3fkiMCuouc8QFzPmgrbvuvHWtPwyNrk2fEtajUjawouDG	359
18635	2vaUCrtaRjyLyPyd6AP1W5aWYHqqhqAJq7K9emvJi1toDYvBULJA	359
18643	2vbxxNvWiWgGX3sjpNzzsKnscsN3w1DvQdZc8ycfAFqBMAB4hMVZ	359
18645	2vaRzwzGa6ZGXexGcxe3eFcWBcNyM9fJFKE4yz5TffV6uiiphZAr	359
18648	2vaAkpnbBcb7xLeHgtDg7aZt6uFCzbPf23jjUqLWHNEVuY8TS4Ed	359
18651	2vbMg6CLiNVZQ4zs4pHfAeEZwFDsZeVc1ELh5F9myNy5JMAjWz82	359
18662	2vawWfqzh8A6MEVRreK5jeGsyuWJBe1ZRD6QgrunwSeRCVUEnqMH	359
18669	2vbmHLXj8CyjhPW7JfdcTr3P9kSpJX2ekiahzVNLoVE2P5z5HgNY	359
18675	2vbg2ENZguUWBcBqDX3bWdVgs7ZNQPivKSnBFUTezfU3VMsHjWVD	359
18676	2vaFYxmkCbn7tDf92WBkjxA8wwyQiUiRkD2CCWCFxj64xQEFtfwZ	359
18678	2vaUmRxPotbEdTrrwB59BKXGSwpiWbVGn1NNn7tYjhP6cPhosMnK	359
18680	2vbxeWePJyyK7S6jj4DEHyNCMLWpZ7pNqoMn8o1JjRwHvn8xzibL	359
18683	2vbWkpUDTt8Dw36HNeKpHYUt29zBnDLSfUAGt2PMmYb9SXEWPmYH	359
18685	2vao1AqXc91eSZSu2P8mTHxfRshjhnd7TMHLfPBjFMQ4JZDWKS3h	359
18687	2vc2KQYy67SAdwKdSZDbWXEyEHyTTR6UL3Ap6E7XbQaM99XuA2F5	359
18692	2vazcJiNh2Rp6UXxXp43zskQrC7HGgm5Aqo4NfKtbGcwXLcSRWyY	359
18695	2vbiHkVRjz5MhR866YGqB2D65nYazJc2NnEvuJcS73trGBCt9VaR	359
18697	2vbSoBKH1b6MbdETpM8YqJueFNAzyiHTNzwSQ4SXH4hbEFQUJ4bG	359
18701	2vaGcrBbfCVrhFSdjXrBdjtmd9FR91efSbBKgEjLr5XWfn189y8j	359
18709	2vazkpcx83ueyBw29n8VWrL8iedtXssVX4FAgV5NEpQcKbwWoVGA	359
18711	2vbWKKmgWg7rn5ZCmgTT9oJpN5i8iB6BjQdLPk12GUjNiGsg2Soj	359
18713	2vbfxSTngqj15W9H4WYUyPVyzvRfR572EBzHFTFakHGh1Viny4zh	359
18714	2vbMXxF8Jcht5rghukGZvW7owrUX66StdqCp8r6pkvYPU9jbd224	359
18719	2vbDeFwriWQ9X6v4A2Yi1ywCTsxs3S5PtZ6vTqm1EpVSVxmLc4BN	359
18721	2vahiQfyVSa6VFD8s7U2mGA3x7HYP3nZdc3Je6txrJt98udpZgDx	359
18722	2vbm7rmrLfoohZH8yK4mdeg1kptRnZibgEo11Q3997XD2Z1nrJBe	359
18725	2vbthCA7kbZMfo7f8uCd8JGU9vfk1vUC4BLQ9sDRE1BVUMA183WP	359
18728	2vaqRHFgcBAGeVEgpo5e3YgaUkPZZ7bHa9M4Yc1YCv3K2iZ58br9	359
18737	2vaaU2vvSPDQ5CSZEXMHnSSUR6Gnfzq25BpamvsBurHRxkApWB6h	359
18742	2vbwkYQV3WYiyexRRigM5mxRanpLswURkn4QeT6nJFLQhp57QbhM	359
18748	2vayWKG4D5d1qz9aTyZn2qKzRNVd5GKbT2kxHbTm9hCbfZPvs2a3	359
18751	2vbqTqcyB11AjadNk1M1zcgHHPGLfsCSuSK3p5TrrbGNrnrf96FP	359
18759	2vbM9DyFTzc62aim7qkcusRc6xLiia2Fxb9vNyx928rKZPuWdvnd	359
18763	2vbP2jmniMvQu3YhS4CjUguvDZUonoez3TckabWTDYArX3SXWGFW	359
18767	2vaYmR7Us56ajMU3Ae2TeYC3G2q3EfBix9cPVEzazjJexpYTqKBG	359
18768	2vbA53NpNL5amwpzyXJkxw46poBK8pF3bauGqqkjy9QdKLVKhiZS	359
18776	2vaomHGdePfBtCiubD52gQwufTn8DL7q5ZGQCt9ZhRWiuySA7Shg	359
18779	2vaRmm9YqVfpVDMJohCtnZ6oBMZEZszstAt86bKu1Ltqrz6Mx8Vi	359
18780	2vanL7hGJaDkdua9UWB3ikQqQhNYuaKqxNynpAaYRnEicwFoU3pH	359
18783	2vb5KppnHowtLLerGi6BBoWbHeaD3kP5M1TWzYcyUi1HFmbewxfs	359
18788	2vaBCrircmuqnHbDoZXUrsZJmFJw89QDhPukQgwkWxF7Xa5a9JcD	359
18798	2vbmx7JFkpPvqSUwuggVbR4pmu3FuZAPuE1ocqcKb6bpkEQMsWCg	359
18804	2vaEVqZS4B67XouAAFqoypXRrHG5TqEf1XTa9RQsVie2CvTAGbTE	359
18806	2vbopB1GRBdjex5NZePE25XB18H9kD2YRZD2faRiHyyLAthvSp3i	359
18818	2vb3dp7SoWBcqgVNzTzFKRgHRdo7chCg4x4jPkFJe5rP3WV7kEVL	359
18832	2vagjr3reoo5pCNNLtaSmcdviEa69L3UcCzSsjfvHstcurRjqPGp	359
18836	2vbbXUQLNur7DRS53SH1PgtTeNcQQGiWzrEuSbmnfjHgQhcWKpjo	359
18841	2vbYx4NPdF9oqis6JoWqULrXqhUUk7BZBkCZRcuSTFtVBy2Wh4f2	359
18844	2vaQUTgVDnaeUW5JEuPDZgUKsziFafyu59MWx81g8T6wSa95XxeL	359
18849	2vaXFBStKHs6SwthZAna1NTJjdptgzR3uMvtaxwHesw7SNBFc4aG	359
18855	2vaX3Pr9ehct52bPzryJ1aUY2hDkXRwsVKVN3uG7nSnE9H6naadx	359
18864	2vc44XKvpUGNyRtLarmRRnoS8BGWv8oGQ4Nik5uNqUtxCrbqskMm	359
18867	2vb2VcZYtYzm9Zokqa6NzbjJXbAnqB95rP85iUQnbedAPfRseG34	359
18871	2vbSwas1oTzqW2cGjicNmhDZkcTDiww6F6oQLJU9EULzJbgFQfc6	359
18873	2vc3RQXS83kUWqQT56q36QyiLXpFjKEjnF3uRmTGNUbkAzPqMnD2	359
18875	2vbLoDZyg2ugDoeF9RTw8ntrWCnSk3hkz92e4BcZzgdkvthmCDoK	359
18878	2vb9unmx7bhkDcctMwqHR41Pjcd4tBNJFbuyvik12aVEPCPXPRRQ	359
18881	2va9JA9WJ9sMJ6YqrVkckLPJUMcj4fHrtf7aHviSYsMY2Q5A3nmP	359
18885	2vbHrTACMdpLEK12AbMu1LWJQXq1jWHVANKV3LYBrNdLKmHH42zQ	359
18890	2vapjrugippA4yMBRCbP6qL6Woc9Wa3ZVSoVcFo9Tk3u7WUHqR7M	359
18893	2vb46Tg7Vo6o1sFi5ktTgperoMzyt7UksZPu3c8NbAx3agQcaT6F	359
18895	2vbukWpBZXsQ6ZAKowrg8ftx7TBGdTWuP8UuhVUHwFjUAX4vdVf3	359
18897	2vas46dDUReNxkzCxqjyPZJWpeFv6daLW91dRxyEEUPaqQy6GGf3	359
18900	2vbeua42Zz3Q6T2NfTzvgo24ozsJXcN8SiEPAKPuMS9c2fqv4jU6	359
18903	2vbwXMBn66vVW8YWP3r1J3mnT3fJS6tkiodWNCQ5oyn6HBdvXHFR	359
18907	2vbco8SQc2FZQNdCjdfzBKoGjQtat8tauhubo3S7gGpZNR2mze35	359
18908	2vbKRC5qL8SsQsgyzRKXWPJi22YXritzMZwvVwMcLTo2R53mdZad	359
18910	2vbzxRwM22MD41xx6Rk7jFPheTcNt4GpQXsMJuZmX1fx4AuwEQtp	359
18917	2vbH4YN2Mwr65BuqJ5LekxxGrQtWPVwK3TLNJVzBSpjnEMsVztev	359
18918	2vbqQm4tderEvUVdoHJP76rwCXNLpBTg8P9km2LJTYL9EjZnqyV6	359
18920	2vbzT2RMvDG7dYGDaax89WJHYJmKSXSjecDGK3xmyumtG4DmPja6	359
18927	2vaqswaqM5o9QCA5vfPEtvHDQjBeqxmtmUybzvPjE5N1WC1VrTnt	359
18929	2vajq8oWmzVJ1GQ2XnGxo3UKZAyBPTYMLrtgxtVibgWkjB6WFrfY	359
18932	2vbaJhv37J4ib55qNBzKxq9h8zRGK3ywwYDf35rRV8mkJn1Y95F1	359
18937	2va9q1LuNAFKTLUTa5Fru8LMgbSZxbmAZ3NMoLhHHA512wCDyPeV	359
18943	2vauyF2ckkx2QGJY3kGQq4nHK1mTBH98beiF79wg9DhWbqDLF3Uf	359
18946	2vb7kQeQjLAmiCXVdBB8GuN1SLkoRqHgn2uzV21mAQtKV3r7ZxEB	359
18949	2vahMWGTgRb9uHdGoL8FfJTJ2zXv2K3L6gzMi48Z2uXXriADLDtw	359
18954	2vaxdMXRioc9s3Z6nsQr2othqmDCSU2pB4sgCjbgC7nAMWCNHUDJ	359
18955	2vbiyZkoJ2H6MbwNPtZv3TkHpJSsSG14C1xwPq1kWwaM4TMNNezt	359
18957	2vaA6yHdmRTcajQve3vGkk5NeEaqNuLEm94ZfrUw8HNcT8rrSVUd	359
18959	2vbfQgvuUjNGKV6sco5sGoiMtwNrMzF82ZArj7tKszBgVVBLK21k	359
18964	2vaiXHtGnLncePrpDnFnc4LVLY5pbU79drScrhYbygCSMc8SxFbr	359
18970	2vaHRe3K4RF4HB9qyTaePSTskiHzky73yvV89pF75dhWSCNF4pRp	359
18629	2vbUdmNyFZFn5jzgnqJJYn8797px2mBfKDhwtZDPDtqHCiepUEzi	359
18633	2vbX9dPm1mMN2QtbXT9moiksVGbKbtRvE2Gd1oyUYEzwkhxVSeCp	359
18636	2vaJGVnHezCftvDNZSzhH9fRCwHbaHdCiFZ6GARsByDZBHKGeN1W	359
18638	2vb3PvYPw7f1HqsavwW1vG55TSmp8kPARxFGttVXvyV5sSqjPzRQ	359
18639	2vaU74HebFpvueLPNSH1RvZh8nioyTwyWwnzpPq3xMt2L4VQAD2x	359
18641	2vaQiJaahxtaEkqv2TowKE3MyXVtKjSzB4iSMxPRncRAWGGpfJz7	359
18646	2vbfWdETDNEJK2ASXdRYJLTNJmobHsqiSi45qZ71MELW7LAF91bm	359
18649	2vaXStYehtZajKkuS5kE5ewYNCSFdXnfu8zUUyNp51oxAGdh1D2e	359
18652	2vbyM1c21gZJa8FoSYkZc9iArJeEpJb7vcYWKosxvGwg2WX9GD3q	359
18653	2vaKywPS7eLG4A7acBpFAC78JH5BHujfcVa5Z39UmMyrL1VMPwHp	359
18656	2vbDJnx31Kw29o9q5kyoPAxoSdVSmMJWxTE6TnUyXLV2BSwqiEpM	359
18657	2vbiReeFimCNibGVQ4JbqWQC9xD7xLNzyVk79UktcZ2KTvemASGG	359
18659	2vaB6VKtSc6vtcvbsFshScAtG9pswE6NgNRhMbLYLu8sPhNSB15e	359
18663	2vaHC1szPkb37VHxNgUhDf1MgbtMTmN8e1ip8q9PXBD3Y1E3eEsQ	359
18666	2vbFv6tdDiwNsJovEbtCGRVKZbk799yicKBzbVqMQD6hGyGhqNvU	359
18667	2vbNJQxW7zh2yggcUUB58HTMUJ4gJeWoh7QM2rQSjhyKWx5AnEqL	359
18670	2vbpFzMpn65w3knGYZKHkVwXZYJWaLBBURFmyYCBzMop2bNede3d	359
18672	2vbYdm3g8KCKNPDtTejygdEGMJikhqbhetXpEGmJqKqAsM2A9vFj	359
18673	2vap6KVMtxEaRU57GehcC27jHcheoyjXtn9PQXvontCdaWNkMBxw	359
18674	2vaLDw3P2iwpFD2AgXxESg4kd6CxtNnKNSm374SRkXbciob8wVwX	359
18677	2vaM9SBNpCvYtDuEEC4fRXYo9p9NgWDaZVFoC75ozJRTsNk93hA7	359
18690	2vbQ7BscSjDVyWpFpgpuzVP4VGAsftQvd2mdVUPQ4uKTtjPyotAR	359
18693	2vanknRWfscJnjyv6aydxEcnDBX2VJ64Csq4kSdUYoRSbdN4B1BH	359
18698	2vbGMg1hruvj72SGYRYN1LiJ6GWnQycZn2J72djxf1Sx9vcguaZj	359
18715	2vaEYKFZv7cpagZmfgDVizeavCZbAyYGux6ZADufNwAbS5w4VrrB	359
18726	2vaVo76EF6NeaPpgsAYRHdrjRGTHP1Ma94Bd8ySBdYEguaLLG7iP	359
18729	2vbbeYTj6nNAuFGwSLF7tRpAuDUvo5LsxXFg9MxEatFYdbb91TL8	359
18732	2vbJB6g6raLAFz4ny39tZur4cgAQdpzZBSsC2CUsAvyrpg8YhmBt	359
18738	2vbdLSGvRqHN2H9ZYEof7UAHtZyoHb8SWGvMnN7giJ2cDu2iNC8r	359
18740	2vbMpvNUufJMSugVzzbCwD6Ump7ikQUhmS9q33V3bgoZYtnn3p3b	359
18744	2vbmoxqrHevmwuDS8qLTsRotkVdfcbuN5PkzDEJgzwhma6e6MKH4	359
18746	2vaKgNQq3MCBWX6Lu2rbvfgyT1n2fmRbuzY8grFVMYsXc5kGajyy	359
18747	2vaWoJbttE2ftBRZ5G3xvPkaK6gfEpMDnmbFBZntzUDshrxPNxtW	359
18749	2vbPRugb6AKm5vScNwTjQeyhVy5TDZ41moxM865ZzMyyRGFmriW8	359
18752	2vbJnP8woy3WxRyY1PfEZ9xK5SqpKeDCUUqJTjLfPYnvxpCo4Dg3	359
18754	2vbd4BUHt2e365na4qKTNtMgKUKFvPGHCwPcn2GQX3bu6PW4rMyJ	359
18757	2vabvmvJ8CX9JofNM9aErJpegBGZgSzCoj4rvrMEPbKUcmKp5PtW	359
18760	2vbdLR6Zg7wjDXSxLU7B5dbWvBd7B9dxiM13aL62jYNCXhWaxHeB	359
18765	2vbXZGt4sJRCMH5YG3gZxtXyvnVmouCFPRVqA5uAZatr3WWcXiaX	359
18769	2vaxwo1mU6k4V5mwdsv8ex6dqFCtNb4ZTtGGpYgV5hVNfNJe4EDi	359
18771	2vb62g9tdrWFbbzVAHYA9vSJArCTmxMReJuTMrDXkFgTd7AbkQPy	359
18774	2vbCsUDzJxvppULMbvst42pi7EuMrrrt3LKmem4AMgGVcpNiKW2E	359
18781	2vbZgDbePPB2Yu7Agy3TgUbABAGLcVSNYqKKeJUsSNSarp6ATbhA	359
18786	2vbQPqNrnekVuy8DJYME1bgsgEBV3Xy1Tx15SqA6D3kwWhEcSZbP	359
18787	2vaffJZCuMA6GpRytar94agNtzN6Se1TUd2iSdP4DgJ3mbJyVR9E	359
18791	2vb4TKeivEp8UVPrnvvgMToDP5wKfVhRUJwfv1V6tc3efrHP3DjH	359
18793	2vavqsaEkH4AYfWaonCukg7PH3ESvf6dd6TqF1zS4dRTPGBFdGmC	359
18801	2vboockkoVaTqUKThT26SP6ZayqZzxnr7oEd9WknLCohS5FzBcUp	359
18807	2vasUwhfyJHvt9uu6dnwTSBhdhXoLwRyBReorgQxyUBNk4813XWf	359
18810	2vbepZNG9ffVDdfJY8UhenxyirEnvZGtQ7vdzX7BCgkMfvUtPSag	359
18817	2vaA46XniDi1DyDXiy59PVCtRvkHjyuQxjPNQiVL8p2xt5ags6aP	359
18821	2vauqw3Fc25ZBfqU6jwCFRcju2KzgPUynNdC8AgGrKsKLbdPm4Sk	359
18823	2vaQ1uiNo8pptYPwFa2EDsdSREYYshBJAFyuKjvYyr73KSXZN6ob	359
18825	2vayMLRSLMMhUrfzfMN8KTuNZMsPFGFUqYYcgDkV24eXKLjnJ9J8	359
18828	2vbyv8X3N8JoULopwiKkScnxmj1RZexPuGVH2rcAbq8UVQX2uLG7	359
18830	2vafCZ5725HNQuFn1C2GUXz8Sde3fko8XChsPsm8swwZS891tvgb	359
18833	2vaRFoAk2FTm7Sdq35ceiAGd7hx2cLN6oVL7jzcbJMbuJ7Uupb4z	359
18835	2vakmRfeTeoPh6bgHar4zjHwQfxw2dstV5mJFJUDeR9nHRNTKLPt	359
18837	2vaWZ6maRLDDxhCDhP27mKVPV1P5BXTrYBJpa9MkECQ45FN6u1JH	359
18839	2vaKzqbmYiHdGDF92KQFvvKiZtNCmQE3CkoPAnzYPMcw3heBaq24	359
18845	2vbqjzAUHXFrN1sTgZHqzS6UXCWCB7XZLSs8d3UKE1wdcsWuCJzC	359
18847	2vbon39RbEqh3PepC6udMpzxiE6BV4UrMnajyWGpGyWW7Dyo4YnZ	359
18848	2vb1DTqBhBnCYVf1hchCFHXhfiwBzj4U2BUvpt1f9HM8843t4ycB	359
18852	2vbbfM3hv3CqATaUc6R6QL4JkNE71q3JmXMy8aRxkQpsFU6apdoz	359
18857	2vbxH21U7h24sqzN6VCpvkkxRNkwLa1oY1MbkHkRRm2XFi7jRNRJ	359
18860	2vaNZc3m8S8TwcdsRmvnws5uD9vbgJq2XvWobtwBLdxYMpZYihuC	359
18874	2vbiNdy7RE5K8Ri7N48mBDNMdq7t2X5schSUunCit851LVc8Lrvv	359
18882	2vbw6v5tcUP1v1BPfr4Rx5n4NfFfWnU7HCmgovzc3hZBXMcQQccq	359
18886	2vard4fZEMiu1oYnMF5Kar1UAFFPs7z4YbmV64f1LmC2ixziMT55	359
18889	2vbuQMU4cKnbsvtLZdyztEj29dkcUHot1UdoxUGuxGhSXc1eHkyZ	359
18898	2vbPrLtw4Tt8JEZdNevijEW5JpZj92TLebJoxjWcKTKA8BccGqHG	359
18901	2vaNUy5XsvnaFvUgmAwvhZNYgvpqumtxFP7mk2C7bJPny3kUCwb6	359
18904	2vamJsRU7a8PSSYtQBGW38S4HqpYHgjVf3EDaJz4pr9LTdUrLgaF	359
18913	2vbjRCoSwbpK3b1zjrKsRJ99Q6GwxcKhAk8Py4HCh2h3vLp4h6qj	359
18923	2vbGNjEJVuMgquKWcFATsa1uPd3iRZ9RVYKU3ysZ6SfFioZF539n	359
18930	2vb3mJsUKhk3EPQ2zPs4yxsxV2qBAAq2kchwkDX8yfLtgWRXbbHz	359
18935	2vb32HTgsj2ktnNLf99qqjSSANFXKmANJj9Thwq5yTQquYTGwAQc	359
18938	2vakdQ7rEBKCFW3Ky3zGD3E5kpZNLbCkEEBx8NWS6D6VeTyuaw9A	359
18940	2vbDWW5oUNTyHtbN7QaH4XXQJfg8WbsxzEsQJw9NGU8SqjS8qaaH	359
18941	2vbh2VGkWyQwE74CFAtHM6Zs6cRxTCftyG58JA2iMATAcSMpp5R9	359
18944	2vc1GG7Co7EYAcNDy4kwxr6G7ENfBvNMvSi9zm9pjfN3d8sacj51	359
18947	2vbw4gzD121aXUguQZuJcUsv16nBzGLj2teZGrzXsN7PUpCFRMUF	359
18952	2vapnTj7YkFmiVeKpBFt8yUBY6P9b2JwVKjrpyCQmyY8EpwBPQhT	359
18956	2vbMM4HuoPpCvx8DUGrAwcqCbe41VwLuXryjyWn8kG456VkjofPo	359
18960	2vaBvdk4c8itkd8d5n6t6vRsm2dpYwabwYuG332WFzvxiF4HyG42	359
18967	2vag2CTL5t9pwTiMdHbgVaLaBpkceEzxF9YGCeQXMrg2bQtdWsZe	359
18971	2vc4YBWYBHwoxADnWkaSb7UrAeZq1itFGH4Uin4MWL65BND1HNhL	359
18962	2vbURfTVqFmspuNh3x5svgFrXPswDzur6bzyp8aTLLktgP5Xpskp	359
18966	2vaBQ3Bw9e8icxqVtZgaZ34QcrkA5xL6tmc6MTM83adfDFpCMJwZ	359
18973	2vbbZjsujRDu7nEaRwwimEkijwTxZbL4rtG2MMvkSmzwUYYhYSbH	359
\.


--
-- Data for Name: internal_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.internal_commands (id, type, receiver_id, fee, token, hash) FROM stdin;
1	coinbase	1677	720000000000	1	CkpYRmaupHUoLHAeZ9v6S872Au2A32aY7R5jWB6bZXT4JYzX6ojbr
2	coinbase	1679	720000000000	1	CkpZNfEqaC99KyJVtUoh3JQQM59ox5w9o8q9V9CBEP8KZuXFVpuv6
3	fee_transfer	1679	120000000	1	CkpZTUHQiw6akH2nhGgq2w5Ha2CeKZmxYBPTRsb8W8XVmUWHCw9Be
4	coinbase	1680	720000000000	1	CkpZS1xXfPHw1VfUy5mdwZifcRLLz2pGPjo6o8zr8ovV3zFwsKXtn
5	fee_transfer	1680	60000000	1	CkpYQnxp4AVgRiaj625gG5Kw54ayD5Az7ix2BUCdWrEDPZuJeFYrh
6	coinbase	1681	720000000000	1	CkpYbrLChDdJ1fAFJLToY5BrkHD19ijqsaVfanQyrQTHn44dpgfF5
7	fee_transfer	1681	70000000	1	CkpYT9wVjnDxawQDkVJKR15YoErUBz3HUqshpiE94F4gfrvpSwSFq
8	coinbase	1682	720000000000	1	CkpZ42VHSG5wN2VCkWCXnwusT1D6V9Yc6nrRePViZHm6aQa9oK3aG
9	fee_transfer	1682	10000000	1	CkpYXWcQFXRVwML28uuc48azaLEPzkqWrdsV91L57Xoo6nRhjAE9K
10	coinbase	1683	1440000000000	1	CkpZMUyZGCwp85AwdtWyZnWXJ8HV8GNjq1DuXeXxbeaJbiJ8WGnem
11	fee_transfer	1683	10000000	1	CkpZPBZwJ3rr44wztQa3QxRtDzqEmbCrPuCxZwemVMFKX3QYJ5f1n
12	coinbase	43	720000000000	1	CkpYVKiPtfvfcGvbc91coZ7uCK2bK8ZpJBAvfve3XsF7AMgsxPKmp
13	fee_transfer	43	10000000	1	CkpZAUHEnzUvRsw84yHSnhxHJUBJtE3PqvDc6qvnfZmHwqn5zL3ae
14	coinbase	1684	720000000000	1	CkpZ321LdgDeAQ47VCbE7MmAfhmVEceENUJ7dP8iy5u4oG5pSzZeE
15	fee_transfer	1684	10000000	1	CkpaB6EvDeAhSarwTayqYUmjGcKY79BHpavrx6bCwMozKr3oB2ErB
16	coinbase	1637	720000000000	1	CkpYoVviYZmJQQpRuWo5EK7uUBm6ikRKUDLzAjna28UmtZeRQF9U8
17	fee_transfer	1637	10000000	1	CkpaHvFPHvPjPtkoaKZCoYfbu3mfPd4JrZ3oHNBq3xoCDxQzqXYYY
18	coinbase	1685	720000000000	1	CkpZJ6Wa5Q2qmnUvRvZdcm7kHxWT4JekwogLMD8UCuzr8AUnnohDs
19	fee_transfer	1685	10000000	1	CkpZdGSnmmKBANmTRHdvXCkrmcMNgKKtWmxAKeKwS7jYcjB3kfCd2
20	coinbase	1656	720000000000	1	CkpZznpTBzmCQ7xz9KvwojYbxxVG2qHV35XzfbtWnrWU8ECU1uj6Z
21	coinbase	1652	720000000000	1	CkpZAmsR7qBY8W6dfQvyxjWyimKKthgo8JnB4LDAYWv3WdMZCw62j
22	coinbase	1577	720000000000	1	CkpYxF2RMBZKmGfsrZdtUkjawpV78VaWD9WMMv8bJhvCy6jFRiCcc
23	coinbase	1686	720000000000	1	CkpaK3o7APCaUfMJzB3nfwu1rn77SDAxCuHEnN8hvtLnnsrWVDiPi
24	fee_transfer	1686	20000000	1	CkpZnaJymMZjvjAq9kZWi4znz5jtvo9nLQHTKEV983jktjPhoUQ8R
25	fee_transfer	1680	10000000	1	CkpZRTWf2y8n1K2v64vtvawE8M6PyYC9BNk39vUS3rS27EWgC2hvU
26	fee_transfer	1679	10000000	1	Ckpa5N98xk4KD2T3SpkT2iiTtdhij85Krg7d2YKqC58Vv4Qrz1QQ6
27	coinbase	1687	720000000000	1	CkpZhyJtUC9cknLdDCrR1rcbty7PC4X68Sp7fRiSyUEgwXkABNh2w
28	fee_transfer	1687	10000000	1	CkpZZWHTDLuWABEZMWzGtHMLmQvjqz1ndBduTb9TWZW6Lmek7y7Ua
29	fee_transfer	1683	20000000	1	CkpYw63QB3hUqZrrKi83UG6EHgKVAVXrUo5RvehP22fBUCRoZaZHt
30	coinbase	1513	720000000000	1	CkpYYm4mKS2ADerjX1NwbzbFsSCP6KQSGfo9vJrSUrYCo7MsvoB13
31	fee_transfer	1513	20000000	1	CkpZnLPHQpzBMJocZChwvCzEaYrD2Yh5cyXPZK3deL2t8PcLNbLzA
32	fee_transfer	1656	30000000	1	CkpZs8fza9Lzw6mg92bguPz6xayNPd8zn5NNcRngKRxd2wFuMqmsE
33	coinbase	1671	720000000000	1	CkpaFKiQPNuRLDn2kCiEC2u2q3QT6jrJXofcyGwU1LKrcHhrA26ws
34	fee_transfer	1671	20000000	1	CkpYcoyHXAX9tmkdHdGuUN6V7CkgPH2bSjC9cpMxCbs9nCU8U37fz
35	coinbase	632	720000000000	1	CkpZHBQkUJrBg2M7w6M4Tq7fKvgJPRsjMGN3jQCxD8H5AgLWbTEx6
36	fee_transfer	632	20000000	1	CkpZpiAUvBLppenHEddirBiv9cviSzax9NKLZ9V9SQWnpZ9M9fgZg
37	fee_transfer	1682	20000000	1	CkpZLeLtRoZtSSVSw9FKTEqBYsR7T9JgU5m4KDNNNpx8Eb2AtwBBF
38	coinbase	1476	720000000000	1	CkpZUc9u1aGuGZ8XLjUiJchza6JrW9E2fixjvrxUnwq9RBo3wrCkL
39	fee_transfer	1476	20000000	1	CkpYigm4SURwqqNk9wC3oTSLGTWFxQBDd9e19MRWigxhaRceoyTeS
40	coinbase	1688	720000000000	1	CkpYR6Dtrq3ijrGBvg3aCzBdVPqcMGPYkUbLDSzqNETThje1c2pzk
41	fee_transfer	1688	10000000	1	CkpYepfPk1HUY8uQbQ8hZtzBWYRAr1smndMZjGq6qB5ivy4vEvrmF
42	coinbase	1634	720000000000	1	CkpZcmzdi1hczBorxKGs8ucbivSRFwUA9vN4JfAyd9Vb35hqoPoig
43	fee_transfer	1634	10000000	1	CkpYsKadq247kLMbGPTkQauj5JKZCwTVZSW7bL82HA2ts5AGQuqo2
44	coinbase	1474	720000000000	1	CkpYccAdSrsTWkhBSh8JFJMV7ZPWWZMnN8gxy8UvRvdUJYuRdzMFA
45	fee_transfer	1474	10000000	1	CkpZVQ3gFSgMBNvmwRNwNvWTepVZcNcVFPBbBHnos9PusqSwW1vhe
46	coinbase	55	720000000000	1	Ckpa5c4bqc85ykDeLGJRaYimRzwTpcRQfHfWcEZQbZVVDCrdKJrpa
47	fee_transfer	55	30000000	1	CkpZYfpRGdijvssN3Gsv45Rq3bXg2ZRwHn1nPsA2tSFczoyRqfF8R
48	fee_transfer	1677	30000000	1	CkpYePgBvpCnC8mCwXarBfGTH7JwHa5nTcE9Luk9YKbQ12W8iZG3c
49	coinbase	1607	720000000000	1	CkpZMUxWtkFnyyMLhYgjnxC8APXN6Z95TZPA4fXAq9D9Kji3CCXVK
50	fee_transfer	1607	10000000	1	CkpYVsJBRMJn1WEVPUZVAwJtVKCNHFKFyLG7u77Ez8dZMor3FxB5J
51	coinbase	1689	720000000000	1	CkpZLviNqbEcY6CBcZeqkg6hg23mq3BiqNohjByZhndXQ2dNsPRpd
52	fee_transfer	1689	10000000	1	CkpYSSDuerTQiPw8jj5fxgafrwh6DrAzVkHJWTQjfXtphdmQ6XFAi
53	fee_transfer	1677	10000000	1	CkpZFyqYoKC5XnPHty4qufMfPiJVE7MLUQVG12xo3j5tcrKXMv1g9
54	coinbase	1654	720000000000	1	CkpZupKBtwGYReqXUarM2GUsmpD7bszhX1kC3cGETG1NhZKHRxizb
55	fee_transfer	1654	10000000	1	CkpaFKFVZ3vNpUpNMtoEnvNhDeo6h1B9MFg8yHm7zK9547RSpQuCd
56	coinbase	1690	720000000000	1	CkpaCVdn3toUFsxtEud1nvSowYaS6kdEBDsWsDFHSsdooFjmZ6XHo
57	fee_transfer	1690	10000000	1	CkpaKPzhon2Urf1kuT7cc1rxLDVqpNRMfNfUZv8sZdbAkfHJRx2cA
58	coinbase	1447	720000000000	1	CkpYikAUgYcx8CZX4ZCDJm4AjPhFEgo2nimaTBCjRTahvQGBd28qU
59	fee_transfer	1447	10000000	1	CkpYmU2nn5SgdUTE943yEZpKgxqNEZCK96arBSoP6zHdDJKHtmSvJ
60	coinbase	1546	720000000000	1	CkpZY5M7cjqSLdP52B51yp7XhfDA6oPWZMLjT9q3Yn6bJie1VsZ3x
61	fee_transfer	1546	10000000	1	CkpYeWxFEKc5qE3somTTQBFjWREN55kzNTVpCnrPxQHbCKCKQGihw
62	coinbase	1547	720000000000	1	CkpZ2QXE3PciFpJd5C12nDceFnjrWdE83sNhBdmnm5xMmWqaTB6Dy
63	fee_transfer	1547	10000000	1	CkpZhXcNSydLVBpbnZZSa8oYwXWoT8xRinAdrNws1oTD1e35reK6S
64	coinbase	1559	720000000000	1	CkpYTj8UjtS7XsuT7efnrCjy3AbPtFbkrFrBVMhK2aMSEs29ymKxC
65	fee_transfer	1559	10000000	1	Ckpa2FUBoNw7aLJs5EUc5Mh1rvcABrF2DJwS1uzRbngHRWKf28otZ
66	fee_transfer	1688	20000000	1	CkpZTeeEQw6UZ2aK4b7SYWk6yrZ9yvsUbNBxDrGnQXKax5hnJTZvk
67	coinbase	1573	720000000000	1	CkpZXFjbL2S73aCBoQSrAzktfBe4HNjQYUCd4hWwXaGt8VTpXN7dQ
68	fee_transfer	1573	20000000	1	CkpZtRyg943nczQEetLYb2gRaF6Ex3JjaHXgxmJtW1jVuwtezkKpV
69	coinbase	1602	720000000000	1	CkpYz6KdoVRPNh4SerbvoDz3zMbUj8wpoGejshFHdHHkSYfHhJLt4
70	fee_transfer	1602	10000000	1	CkpZMuZmwrtPL2DXDtA6yij79oTjR64qY74Y8cJqgJaHB96dkHZ6Q
71	coinbase	1691	720000000000	1	CkpZoNx7owPQvbtNGeebFzmCK59BhoTVaWFyYpJEexCv1qJ8Gg169
72	fee_transfer	1691	10000000	1	CkpYjcVLyPcZuxzCZHCUf6856c7FmUGGt7v18DXF7kEP2KyZZrr8t
75	coinbase	1692	720000000000	1	CkpYaNYP3EwSBniWemtzEGDxrRgxTV8Mq1YqZkNYNAP4pxFRy8dPr
76	fee_transfer	1692	10000000	1	CkpYUReTqqiRcKZVnioUvMFvx8Ly4xVnGof7bqw9nseHT3uJ1NVqL
84	coinbase	311	720000000000	1	CkpZ22NfKjciYxHZX5MhXRo6m3HmBPUGRD8o2xt1qtVTHV2tqKWGh
85	fee_transfer	311	10000000	1	Ckpa3k42RyDKq9bLn6YR4D84yU5928jWBpGcBdETdWuJdVUpq5Bpm
92	coinbase	1458	720000000000	1	CkpYVoEhMjJ7C2eKYsg5SNrGL2F1GrWtogKVLmptGBk91owXepXWp
93	fee_transfer	1458	20000000	1	CkpaEERJDMc3rRLSoiD5CQvWqwKK2JSeff7K1VoatRXVqgqEePnAP
98	coinbase	1504	720000000000	1	Ckpa66P6q1b7L64bg8YdhhyFWSz6xMbbKbhNWYieUvfYMaiYC5uyH
99	fee_transfer	1504	10000000	1	CkpYeRZSMakCSf8jFADw5CL1bQKMDdQoajJHeoMWCCvvj6cGNycJZ
100	coinbase	1695	720000000000	1	CkpYy9oXU6GHbGP3WFVSHjuaDFpVGusLQWkQjDsoqBkieq4LjWWk1
101	fee_transfer	1695	20000000	1	CkpZ68VbK5odNKwGRLTk1NrGK1GKYEm9FmhLDrv4RLDk6S2csjMWj
106	fee_transfer	311	30000000	1	CkpZE3prh3zQAfnEJg7uexxshaKdN2pPqLqe17MMnChj8tdmyn87F
107	fee_transfer	1623	10000000	1	CkpZcLTq62EVBzHLfEhETCjhrySPYfzfq3M4Cx8c6oE2M4HVW7kZT
73	coinbase	1587	720000000000	1	CkpYjFDSJDEZEcyYeHFY53FPQau2XDW4M3YsjTNZf4Jj861ZcKAM9
74	fee_transfer	1587	10000000	1	CkpYUXL7suvVuSpCxkg6hohvmsKfjjU83XHqhWLVahKNQzJRoJ6w6
81	fee_transfer	1693	10000000	1	CkpZDhe1DigbeQiH6kd8dGynCjedSsgeBTPrSE7pL7jnWQUeeCtet
86	coinbase	1622	720000000000	1	CkpZZWqdA87JmPxHA5NmFEQ3qh7pUmqXi9GBWzf4pADtPEHQAeH7M
87	fee_transfer	1622	10000000	1	CkpZ1WriVr3Rmhg2GXafYcCT7LzH8c8HaXaYTSRbdSTLatgp4sSEk
94	coinbase	1623	720000000000	1	CkpYTGN5HkaCBms1BfHBnWN9DpuTRSt1ioJAcKEvQF26CbD2ZWbYc
95	fee_transfer	1623	20000000	1	CkpZxSTRZ3bEym5UFZs4pcxwWzqtgfUvcJ78EU3YNNjQVP9DeB9LD
77	coinbase	1444	720000000000	1	CkpYfUsRh4hP2VmGWd3raFHNigJ2pNeXcFZNC7Pnicy8ZYrrRHceh
78	fee_transfer	1444	10000000	1	CkpZ8NXzGJGdVBS2YhiRapGHbSiMi4rwPgoe3PbrbtuxyPBHQTVcM
79	coinbase	1693	720000000000	1	CkpZA9YnyBFKGY68a4mPAmSC1vp7oZgSU9hAbMAbb5f9XuPbwMGs6
80	fee_transfer	1693	20000000	1	Ckpa3p6pdWkCWTCwHMqA7FrSQvmkPhF2o7MMET8ghie9L8mtiHzBW
82	coinbase	1596	720000000000	1	CkpZoojAobBbzDc7Aqogvh7w6e7qvaPXSFMQnYoQeTmdM7xb1i9jQ
83	fee_transfer	1596	10000000	1	CkpZKGMWrRoDBjr48i3662bxyGEC8UVbRR25kk7C6ZreYyA3nk1RU
88	coinbase	1694	720000000000	1	CkpZrCfgWDrVLq2KekZgwc64wTKs55PBJa7A5t5er6AxAqRov2CLQ
89	fee_transfer	1694	10000000	1	CkpYW5eRZHdM866PmCnDjBnSUvHHEaPJj4Bq3dw1y3GfSJyqyNhmV
90	coinbase	1613	720000000000	1	CkpZAveZDYnTDDt2Tw1n28tW3v36ncuWVDHB76kRKTVGXEnxzrtJW
91	fee_transfer	1613	20000000	1	CkpYc7LA4NetwkwYsSktndd9Gahyw6LyYC8yziKdrqz41ioZkXKeg
96	coinbase	1649	720000000000	1	CkpYn4J7oPNWUi4b24ZxEhLLg1FpcAtrAzmJUXxK8SgmNtWZdbS8q
97	fee_transfer	1649	10000000	1	CkpaKoqZ6BMX59nsXood3bWVQrsCdkpxkZfRb2CnApi72JWYEx2MT
102	coinbase	1696	720000000000	1	CkpYV9kHtTKdgbD3tWp1jJpGLx7PrgLjvj9ubX9BkFJh8MpARLihL
103	fee_transfer	1696	10000000	1	CkpZBbgKJ8rv9Qxij3KZ1S1qHAu8wWLdDuEBsvjxEcLf9ppJ5v5Lj
104	coinbase	1624	720000000000	1	CkpaFbDotgK86ZmZ9rcEnqoevd7RxcUCMP9yPEaQnyv259Vo1SeiW
105	fee_transfer	1624	10000000	1	CkpYgijfhumP53Gw4paqrsQkoyKTcmZdS5MXC4RV8XoLfMwz9hCc4
108	coinbase	1422	720000000000	1	CkpaBANiMpEnTXf33Eh9njdR9DVML3FaPFxXiCfePbSCywbAZKs8Y
109	fee_transfer	1422	10000000	1	CkpZMTAPdzVu1517FzjW4w9hiHC1GrmG7hhGiiBsbYp7MFiRzYsfa
110	coinbase	470	720000000000	1	CkpZV1FjTXoVMpwhf9YJ4TwdNpVBeBxYdvxN3UfCWpa67CCVYhFYN
111	fee_transfer	470	20000000	1	CkpYmkCozCG5jqv7qshM337s76JjdeL1vFQiCZnLH7PxtVf3HtnvX
112	fee_transfer	1677	20000000	1	Ckpa1jxDhdJZ84YauWD6tumigM9N6pQX1TuwqjAURYNZMdaBw7MAT
113	coinbase	1698	720000000000	1	CkpYawp6d3aYSBA5qbpmpkUbSKkbiABWT8xiBvVHXmhXHHCsAWuJ6
114	fee_transfer	1698	20000000	1	CkpYt2bVCWQGMxNXVRSWtu1pDcerPkBzwCc27hf1FzFHn6xoWRqAp
115	coinbase	1489	720000000000	1	CkpYhzeVC6Ak6yZwwqDD3gec3wniTCd1BzPM5FHpZwBEoxjTJTCAL
116	fee_transfer	1489	10000000	1	CkpZA4KcGh9hbYMqhoqsN1HtYXrjuZxGXq4CpQFqMDkHP8wSrC5Vm
117	coinbase	369	720000000000	1	CkpZR5ZznctzKKKryNyQkMPxP3dYRk1VpSfsaUtmNaKhxKjNubBRX
118	fee_transfer	369	30000000	1	CkpZBsNTJeb9Qvi6fzbADf61LxeHNKUoc9Nr5HMkAUDDqmKUDBhwb
119	coinbase	1699	720000000000	1	CkpZ2Gp4PnQshCXBQXjCnADn2dxySiZcL2Y5cjTfrhGWyueAVtnK2
120	fee_transfer	1699	10000000	1	CkpZ3kG3zzAjqeV94a8gz9U17tsx5zCJRcX2HSatTHBzwiwbTja4M
121	coinbase	1700	720000000000	1	CkpZcTMV3k9d94Z9gUcafFU892F1BmQpViTwN4EtrSpC6Bw8BioqM
122	fee_transfer	1700	10000000	1	CkpYbHnhnP1k1tinic3T4MvDcGCAnaLPaGpSkUJmbcm6V25Zj5y9K
123	coinbase	1440	720000000000	1	Ckpa36xKcWrr1ascDAax846ST5qzbkqYXsuTs49QUmkVR4Bmg1ugM
124	fee_transfer	1440	10000000	1	CkpZiiFnRUhnfFdVAjFjadbZw7BdkYgv25udySJKJzhZCPqyU3C9C
125	coinbase	1701	720000000000	1	CkpZB4gGUhgo8S64mH7GeH1J4truRLcdp1eEix8gajY6eeVoZJxdH
126	fee_transfer	1701	30000000	1	CkpZmVXM9UHYLSFLoGuPgT22NmRNPkcB1VYPVLAtJCJJeUttFs9Ne
127	fee_transfer	1685	30000000	1	CkpZ52FDVADisscaEXq3Wg4xa8ukaKFVp1gvYQH9c59TVHr62jjjv
128	fee_transfer	1688	30000000	1	CkpaCwTa5wuGdPaRzPWrEgK7M4sMzEk7qvVpXPWLQ24XDdz5jvXLF
129	fee_transfer	1699	30000000	1	Ckpa9944nGrECvtijKH9XqRwrFqYVx4BXwaAjT917JGJavGMm9Ga8
130	fee_transfer	1559	30000000	1	CkpZ38ooMCV4yY8meXxcmQDNiQjW3Uqvoh8meFP5HCuYesz9Y3UmZ
131	fee_transfer	1679	20000000	1	CkpYgcv34nYgivALfC6GcuVkG78Ljo4eASJXioJasq8QvqBJ9vNSr
132	coinbase	1419	720000000000	1	CkpZnh2wbk1AfovQz2pcazFnusPf1j898bfHj4c28oQTXDsKBaZng
133	fee_transfer	1419	20000000	1	CkpaE5jzWY4W1vSZBBKqWnhGg7vroAP1zAdR8m7MpEkpuc4CpzyfL
134	fee_transfer	470	10000000	1	CkpZ9fj6GRtR4dx8jhrrXMAkRU2zHjRF9xfBSW74yDxRKsDqqFM1a
135	coinbase	1702	720000000000	1	CkpZUg53zPiwB9pEgNPmnAhxmPHrD6r1fVx4xfRoq3Rn2ddcxC1Z9
136	fee_transfer	1702	10000000	1	CkpZ1gwbchGJD5fpT2zoJUtDNyN4cSWZCiUNKfYCQcm1Dztw6EifM
137	coinbase	1703	720000000000	1	CkpYwc61DdXYRoBj8PMtLZRU3g6PtgkgZSyHYEBn1hxYfDbHkp6bY
138	fee_transfer	1703	10000000	1	CkpZmoZTtdQR2S3yR89pFDDpFLb7oV15xs3fbDzbQP1HGaamGMHuV
139	fee_transfer	369	40000000	1	CkpYQf7d17F4QuJDRXVuPR1RTRK8U7t7wkPrbu621TWW7QmNuxddh
140	coinbase	1599	720000000000	1	CkpZEg7qUBUyjkAb5EgmMSAs5Vq5DjJxFJfH61yd2CQny8A6VqA68
141	fee_transfer	1599	10000000	1	CkpYeViwpDK4BrjHtfBm1rzhnYxFcYBtqBAmTTDnaVHx57gYoBkCy
142	coinbase	1522	720000000000	1	CkpZzSguK6EmTLMYMFJzp95Z4KoYJnFyoeqbaztDWmZTqGa1sEqYd
143	fee_transfer	1522	10000000	1	CkpZtAYQZ2Zx8JfdR9jvQRH1HRmZErqdRUEKqRkSJnk89iUPdnSHs
144	fee_transfer	1656	10000000	1	CkpZJcfzZSseXZVgDXofL8ArtS4TsSYG2zXyoQYcUzDBj3m5mMsMa
145	coinbase	1571	720000000000	1	CkpZqZ4ciAxMpjKsgXjPeLnHptqCfbxNJc3Qvb1niWqX5rSvPD73Z
146	fee_transfer	1571	30000000	1	CkpZTPwoVa15gFRvNZGfCGN19Deum4Fzar2zKiKdEhAaEGjnzb2TB
147	coinbase	1704	720000000000	1	CkpZmknvc36vhqUpJ7NccbmP92inro2xPTRExhkYvX3sL5ATsBrAp
148	fee_transfer	1704	30000000	1	Ckpa3AGDTk36ovU8jEHB4nLAnoEWKj218bRGVRPQ3jL3ywwRVc8XX
149	coinbase	1593	720000000000	1	CkpZd2tYMiD3sghEfQahv9QG3ib9NUV1wVCMshkX2g2EybFJWH3xi
150	fee_transfer	1593	30000000	1	CkpZTDNtGb3zcUAnz4L5ZLCyQRg1bBpaoJ1PNBWud1TTdNT2TGVCG
151	coinbase	1657	720000000000	1	CkpYz91hnUKbgvxEAFybzxHVohk2tC9Sovj7s64drwG5JDjpMWLqQ
152	fee_transfer	1657	30000000	1	CkpZ9NiVjed65YWbsAWozD1L4y8o7LQkureSeWemNP8B3cVKvu8wy
153	fee_transfer	1571	10000000	1	CkpZvyaKMvQg1YtJ87Zh8xm7fQgb3aGGJ4QwfzXBTinXaTNXRmfia
154	fee_transfer	1694	20000000	1	CkpZiMLjHbjjkxFdLzTfCiTWN6rMnXWYnGhx44xTFuGX2PLZQWUHK
155	fee_transfer	1637	20000000	1	CkpYyhCN9FFHWVgebj2KU1ioTKmaiHBm6FNtoJ7ZBxeSCjpV8QFqE
156	coinbase	1705	720000000000	1	CkpYt8xGkkXf3gJStBt7QpUKeAtSAJWRTA9XuT3AvS1BRJ4hGjdAu
157	fee_transfer	1705	10000000	1	Ckpa3bQALVaBsNnQ5fMTQ38eYd5DULGvQKTjz5JZBReLQxRF3S8rX
158	fee_transfer	1696	20000000	1	CkpZsG3h6WpNRRT94rn5SSfP9KhAjwkpKYYKQ3ivqoQ8dpmEC8HvB
159	fee_transfer	1692	20000000	1	Ckpa9qn2UDxPY4NCA4o6rs5Y8FPGSVsc6W7QLzF5VGSwj87TWcxTM
160	fee_transfer	1695	10000000	1	CkpZLi9oqHtK9mWxVPYPVWsD71dw7Q6DAqYznaDxdhb3wiHz1QHAr
161	fee_transfer	1474	20000000	1	CkpZzH8FPywJ5F6TskGbffP8iZunEUo5SkjAQ2S9qnQcsC6JdQFYm
162	fee_transfer	1559	20000000	1	CkpYeWfxC5vMGE1dfZQm7iCYAHiAs8VyiX8Jj1kwLhrP8Nxj1YGjW
169	fee_transfer	1690	20000000	1	CkpZbUpC2WYLdnw4UcUiCKyihwnxg97tGiV1qwaLxwSifawJJHPZ7
170	coinbase	1706	720000000000	1	CkpZjSKMAi72Fp95hDvrgvpmuhWctiB8PUAUQoBeJPD5f5oBh6ZHW
171	fee_transfer	1706	40000000	1	CkpZVyNHDbSNc5Baa9tCEopLUDn4hPq7FRMp4sGhuDo8PStkD9LmP
163	fee_transfer	1671	10000000	1	CkpYu2tLcNFSvGe3mshvJgag9Z9m2nVbaNR8GihdEeZQJME2RsqNn
164	coinbase	1560	720000000000	1	CkpYjPQDpoNUpo5um8eMDfeg9jvFfD7uPVfF8LMockeGaGMVuU74C
165	fee_transfer	1560	10000000	1	CkpYWmcAs4rsYPNg3KCmKKcb6CvzJvKPy3TfKVmKwszsBx4qRt5z3
166	fee_transfer	1546	20000000	1	CkpaDisr8MMXxin5PYFLupqsWHYYxD4aPJE1NKcTL4n8xuMyNRPTU
167	coinbase	1509	720000000000	1	CkpYWg4yzjGo8QEtuuJoU7QrRQG2Y25vSqMM3SiPEN3GrZFiZbhGE
168	fee_transfer	1509	20000000	1	CkpYfUSoFUxfMwSnyRbGaLYcTtV575rQFkFjgCRfCL4BMjMJCrdpT
172	fee_transfer	1692	40000000	1	CkpZcsfJZ8YjZeVf6S4UV9uEErpj6HMadGXzGVsDUn7LH9CD5Krey
173	coinbase	1457	720000000000	1	CkpZtdruzi2qzYbVVWQ1Br7yxcAEeBbWbSTs89zFfWAt1dKwDSTYb
174	fee_transfer	1457	30000000	1	CkpYpVvqiojj1nVCxgAuy5KgbpYLKheAYeuLSJPgdc1wH7bGFCDbi
175	fee_transfer	369	20000000	1	CkpZG98QXY5ZHndgCuvNZV5hihrXCmBSegqhRWax1jXzT2b96HbmA
176	fee_transfer	1652	20000000	1	CkpaFyGygi65vF8QXixp51sWaNbiLY1AmzdaVeMYPdHfjVvjxS84d
177	coinbase	1518	720000000000	1	CkpYpox13MYoDkySZ82WzKHVzi6bw7qQ1oeUkcp2HPsH85AqUcuMu
178	fee_transfer	1518	20000000	1	CkpZuYDocYTu6hE58W3JavMAWThtZTtUW6nXbumvUTWpZy5JNJ5b6
179	fee_transfer	1681	20000000	1	CkpYWnvNiCigVNVoHCatob4oyF3sMea1vtP3SJqoxeS8LYZnc69SV
180	fee_transfer	1458	30000000	1	CkpZ7M8QK4Q8qDQu1B4v3xPpDCdL7ebLeaczx5VB4NrMxQJwuwALw
181	coinbase	1708	720000000000	1	CkpYTCLpBWPvYKRPhA4droSWhL6a6Hwvm3N9q3CDeUYoUcoatzTMC
182	fee_transfer	1708	130000000	1	CkpZBK2gJK2g6MQtASzkFJXqkwjwwg5SEyfK9fbftor4QekzPv4S2
183	coinbase	1396	720000000000	1	CkpZ4Ps5ngGdzJVr4W1Hoiu11vEf6WTHBvp9keWZGJ2o939oGHnns
184	fee_transfer	1396	130000000	1	CkpZdasbx1GBx9FyhSAwaFEakWXi8PqjfdaQgHJB3nUAB3124SM65
185	fee_transfer	1690	130000000	1	CkpYmo98XfCh4zmT6Ur4VFJh1bppseMJaX9ibavpPuetbQiLxTu5Y
186	coinbase	1709	720000000000	1	CkpZFis8DS4dYHreLDFMgxt5jWyB58NXTs4hS1myp2HiYwSaNe8tm
187	fee_transfer	1709	10000000	1	CkpaChAEtgNiFjPwibZBNELwwEhLnbRAoZAbWeQhMSCgj6XAkuw3q
188	fee_transfer	1701	20000000	1	CkpZTGGkmqr9TEYjxx2EQK8Jc8btr9KyFhq1XbQEJvWW3NUE9eNCY
189	coinbase	641	720000000000	1	CkpZkDYcumuoCUwz4vc45Fvmx9tFCyzzWdqXjvSg5gYuKtY4A26qz
190	fee_transfer	641	10000000	1	CkpZUYKZFRFbCf34qQRHaDxVYPjg8wBx1VrtGbbhWbshokibdijwm
191	fee_transfer	1458	10000000	1	CkpZ67t2YH54zvmEDwGPeL2poXsRcd7WoQFt3hgd2AyBsYcbTyty6
192	coinbase	1467	720000000000	1	Ckpa93BgVy5sKHEBAgoSaPXUHMNuAjPg5Jx85Koo7H9nqRjVZCNyW
193	fee_transfer	1467	10000000	1	CkpZYhiPaRVKTRcHHn9arXf3i3k1oCpsYrHyVxrRqCb9ziEHTHovB
194	fee_transfer	1681	10000000	1	CkpZLEC6jtYZWmWZ99uoWsEwHPdBGajsV3MxAg3m5JRD79ALujzuy
195	fee_transfer	1701	10000000	1	CkpaGgx9yjniN8w9WhdEsFbQzM5GqWSY1VyRW87QsotQquXWey5B4
196	fee_transfer	1702	20000000	1	CkpYjFpYqQru1tX3xShCdWVhxNJFQE3wE1dHKPo3wpg4BKJ5MLMLF
197	fee_transfer	1703	20000000	1	CkpZ4TGGZ7V9ZsBEYigyFNtcpX241DoQZP5Tur3gWYWgJTL5koUQa
198	coinbase	1549	720000000000	1	CkpYeWDxHaJdPN7t6qhhGytZKT2tCvuJZg5sgY624FDZpuA5sKrcN
199	fee_transfer	1549	10000000	1	CkpYSFGLQfPYLmiFL1a3SareR5ozfXnXL1LMqcwMuxnf2iNFZpR5U
200	coinbase	1710	720000000000	1	CkpZgU1f1wniceFmFnyKpNQLnByirB5DEeJyMawn4KoSaX7fHaa8C
201	fee_transfer	1710	10000000	1	CkpZ8mZ67L4RWYbeeqrybvZ4GkBDK8v5Bvpu3XqEnSXcV8akMz2UP
202	coinbase	1668	720000000000	1	CkpZGsfn2WVtveuoJ2hERLB38fJ4u3LdU7tsTyXst6XZxVfSFArZt
203	fee_transfer	1668	10000000	1	CkpZ2hPj8ygH2NH9j85WVBxUrLcVQe9jSF195VtnsApSpqqy69ncB
204	coinbase	298	720000000000	1	CkpZ8EFtjg4iW3wUCdMrZuhCRPrkrrVGg4dSefTZcovJZyFnvjkVk
205	fee_transfer	298	10000000	1	CkpZE2ke3tc1KvL5Y32reijJJCDk24LqbGJwb8tvhWfuz3hsAi9jB
206	coinbase	1611	720000000000	1	CkpaJxpzqYCv5tVMimh5JXpZ9EA5aRuE17nk4ty9ZQjTNZGmFaqUG
207	fee_transfer	1611	10000000	1	Ckpa5Jr2sDfouW7nYyda7ifuCKzRmY7rsbfvi1gGWLKGd62hB7n1d
208	coinbase	1541	720000000000	1	CkpZr8Bdx3pfYEMH2Yp94pqaif5HGEdivs8iBUBLZHwKNXq9j3CiK
209	fee_transfer	1541	10000000	1	CkpZ3Q3Lr38oobcsgiaQii8pYG7UtxpRg4payV9MfyBapiM5271M8
210	coinbase	1711	720000000000	1	CkpZLrVGLifUZWTXzPseMJv6BQ3hwDiEWkgDr9ypRPCoaNbEFYEBY
211	fee_transfer	1711	10000000	1	CkpZSZTQwXnpeeMtoRyNhVC821SPZh3T2FHYkZxPJwRNjPsGvmuh4
212	coinbase	1506	720000000000	1	CkpYkc2PpDoL3i4dpYBzu4KDUU7Ej6Qgkwkhqu9jBVpxFFfw8gqFT
213	fee_transfer	1506	10000000	1	CkpYSNFyNtQeGkc7769RF4UQ2n8S34sPzg7UjzoMM4n9zQJVQ85Ec
214	coinbase	1601	720000000000	1	CkpaJrQGpn5sheuP1ciZj1963Mv1PuPVtzpptxpDApQU14CJh8S9C
215	fee_transfer	1601	10000000	1	CkpYrFSwF3AN6Ub3XKhi6jCy4XW8jBzgi24RPu4mkmScsqAwvBaWB
216	fee_transfer	1444	20000000	1	CkpZZty4UEC4aVyDag2fm9Eia8SRL25z6n1tBnNRxuZeqBMZfRh9e
217	fee_transfer	1686	10000000	1	CkpZTcFfN8uMGgZX9Z715mwgXCqMNbee1bFwgdMXvNV4PuY4pmEwU
218	fee_transfer	1685	20000000	1	CkpYoJsHJpX5dXW4d7APhiCXByizWDgnP5NLsRRftAJpX7dvVUERp
219	fee_transfer	1710	30000000	1	CkpYqJbEDvNRisWsE9GwAssCoQnWU6SYnrMyPnLW7MsFP1TES8Tjw
220	coinbase	44	720000000000	1	Ckpa19UGNenWSz8zpH77LuTNa9AzogeWNDuBAu8HDcCdwKKsw15oS
221	fee_transfer	44	10000000	1	CkpZbescwCPkhMj7ZtVX6KVxy3CQJpnrhdhaoRdLXUZFF32Yvk6mZ
222	coinbase	700	720000000000	1	CkpYs2Pgsf6ieDn1MLxqmrjXXQ6PKaueZsRHfVj1M4V7qyxoWeJA6
223	fee_transfer	700	10000000	1	CkpZux7xvHjTZrcGmqBk289B2Bni7gc86R8VTbDZTEaDA8odxyL11
224	coinbase	1610	720000000000	1	CkpYoX8GCF3f3D5v1VzXFHHKax6KUfZVgp3vSgjiPC3rvETmMGuYh
225	fee_transfer	1610	10000000	1	CkpZzAYy4Z3QdC1Rey8E948HkdJ334vKEii2A4ie1eoqQP5x5r1c3
226	fee_transfer	1560	20000000	1	CkpZ5771x7cxKcrUDUV4aUMB4GUZwdfAEBrQmucpqjq9cYkmVLjtj
227	fee_transfer	1601	20000000	1	CkpZ8qxakVWoQAf28BFYLsd4NvmLLkcArakCUsLc7ZAeAD82roTnz
228	coinbase	484	720000000000	1	CkpZT8skEse5aQpL7P3hpFay7KWPg3qVuQs4qn3m8codZiT8TgvHH
229	fee_transfer	484	10000000	1	CkpYrfiq4boyuxFgofCDT4znHWtVofLTyA3FJY6tRUENhXQWQEBFU
230	coinbase	1672	720000000000	1	CkpZNUuzpReQt1HATgTgbBB24zntNjR4PViHjdSZtnrvYqQjnhTk1
231	fee_transfer	1672	20000000	1	CkpYbLpVZXMHJFzr37712i2vzzoAjQfnV7w4n8fK3EFsXZpLjhd8o
232	fee_transfer	700	20000000	1	CkpaKMpoUurxdNLb6y5B7F2dmiYtvLZJJZ7CNaeMW3R7iBJ5xfhrG
233	coinbase	1448	720000000000	1	CkpYj9btdKFpPXqUN8qsQS3uy1g9SoEEGvmRRBWYa3mK18S5k7YMn
234	fee_transfer	1448	10000000	1	CkpYyEu9QdVmvCRZHHZ5aWwpwptLjYqNT1JBJFzjM9MeYETSZJ1FP
235	coinbase	1471	720000000000	1	CkpZ6nbG6uk2cSY4efuJkKUftDqKBwXx77NV39m4TYPWhXD9rfBZh
236	fee_transfer	1471	10000000	1	CkpYoVjDsCPy5RRkgt85aqsXEP73JPYsbnwZ4QNvEV3LAf4f51vnD
237	coinbase	596	720000000000	1	CkpZUPmTdz591S6EwQ4FWUJza7GiEoVGsQBSmQnQ6YcH5YKEBbbGV
238	fee_transfer	596	130000000	1	CkpZ7fB72LY1Bivte2q5QE4SPafJyAX45aY17GVwuKzgL3B7uriHd
239	coinbase	1456	720000000000	1	Ckpa8emzJFzAZDLgF2ySyqTSKhUn356NFfeHzN6U7E6g9N6bxkcvz
240	fee_transfer	1456	130000000	1	CkpZjQDHYWiTGsa1f14UfLfu2x7s1JLneegoAZzTv4JmXm5jFse2J
241	coinbase	1555	720000000000	1	CkpZLuBtucY3VjRrXWSMSWEremZ34Qci3CZkuD9GCKJDtL71dp1AN
242	coinbase	1714	720000000000	1	CkpaFEh3uvUMAcSCwJw5UuH9xwiQt9H8b2VzfNCizmjCLGLbYQyQ9
243	fee_transfer	1694	50000000	1	CkpYawfmqtHvRMkjhWWdre88zeTJZaAqa83hG2b29Pqu15DpDWbHs
244	coinbase	1633	720000000000	1	CkpYWsb7Un2L7DWn84MQeYAQrCGkLpJ4tAZ2LPvAQpxFxQcmdVKCb
245	fee_transfer	1633	10000000	1	CkpZ7o6NyPWyBxE7x4QSYjt77iUw2MAKm4QXR9VxGEfp8iVvz4N9Q
246	coinbase	344	720000000000	1	CkpZ12EYXeP9isuJgPb5kp9nidByVhkuMcwDAnF7T4c4hSwi7JCJq
247	fee_transfer	344	10000000	1	CkpZ4mKFLXYR35sHPp1qmuG7PuGh4gbJQvNkWxD6FX9bQK37BucTv
248	fee_transfer	369	10000000	1	CkpYkzyjx95czyaV8WLBx1qn8TZ7vdY8yJaZcKnWVUyTiA3N1HEZr
249	fee_transfer	1694	21000000	1	CkpYe7DtSbpN2XDuTWAPu8HG39q5DAZgVy6b29xed5MwAoz4g9c2A
250	fee_transfer	1695	21000000	1	CkpZ5JeVq3gbrDaMtZx7wasWjMXRZ6gBZh3AafUPcKHgnB73qae3V
251	coinbase	171	720000000000	1	CkpaDcfS9EFVyanCZgN8HsV9RmBtnZNuHWSt4BgXDMG5wm5pkzChL
252	fee_transfer	171	10000000	1	CkpYkwFNz8zR9paZv2u1ypKJb5tmFn55Urtk2ZZjJ6KfqYWwCxs5T
253	fee_transfer	1714	10000000	1	CkpZ76TyLttbw2sXz8vLnrAXm1QGuKK83a5vhhBtqxx1e7ehkkWPQ
254	coinbase	1576	720000000000	1	CkpYhUePNZ4UKkMMjuFQ7mx5cRt15C26E6UPgytfdNn6mcwR7s7Wt
255	fee_transfer	1576	10000000	1	CkpaAn7vH1wvn29hj28Da2eu69a6KAp2UHBpS2SJ6d2qaK98rNTeK
256	coinbase	1445	720000000000	1	CkpZspfJYvYpMA6kcg86aXc6q9LAR8TTA7U6xcDmsYkLeKFwmCPrB
257	fee_transfer	1445	10000000	1	CkpZS3NMZyY6t4L7NTJ1na6YW7uM5G2Wtp9fCEVZ3rBvkkf24QUiQ
258	coinbase	1455	720000000000	1	CkpZQRdFXJMyNWoXHF88mmJ5hETC85qm3jZhV1ZcECayo8ofMyZy6
259	fee_transfer	1577	10000000	1	CkpYSsiisNq7g2GEoCzCnejnm4aszVctdnL8hNkSNp1mrXiAp5fb3
260	coinbase	1715	720000000000	1	CkpYtESsr4UKgugEiJmF4nMMheXQumAtX3ZUQiGpW1aCBNC3cfQQX
261	fee_transfer	1715	10000000	1	CkpaLdEURsRawSu7pzvzkAuvVvy44df5pcn3Gm2bdRKVWjERYzmXz
262	coinbase	606	720000000000	1	Ckpa4ZzQBuW57QhMQsQxLreatTgaSvJdEpJ9qo3VEavDaZR7jTaPS
263	fee_transfer	606	10000000	1	CkpZyWRumBjUJGd1NBo9TK4dFyqyuRvc2xsJ18YJQLALMjQa4J7Tf
264	coinbase	1594	720000000000	1	CkpZhs572MwVhc6oD4vCT8btBHxRzv2ygzp1ZHCi5sE4qFCDBMf9H
265	fee_transfer	1594	20000000	1	CkpZSLRwDRWDcUjEWTnMgkXAbFAWqgt7UqY97QrWYpWWohdUnSJiS
266	coinbase	149	720000000000	1	CkpaJYeTh7ZURFsrM7Py9gqsiUCriew5rKNb3BJaek2dbMEfopDvq
267	fee_transfer	149	10000000	1	CkpZPHTik8shYWaWwj9FzL22JpzHTPijtAkQ54VfSvJPdN62Kqg9h
268	coinbase	1716	720000000000	1	CkpZ7xGLs2NxbZNvxqTiGrjqCnHN6vNiqERKPzqUsRyELmKBqkFeB
269	fee_transfer	1716	10000000	1	Ckpa2ycGLCxfeFqD6KeP3eNqcyBZMJxw8zCeWZV5pCGstHaAFGuA1
270	fee_transfer	1594	10000000	1	CkpZN3opqp468KmS8B14Nepe8X3LSLU7Q2jzQVA5Lz2UKrJUjHRbR
271	fee_transfer	1715	30000000	1	CkpYxPWt4xT7M3nNQvkbi9o9DHqYVPnT3qxYoVkZWANEQfjTeb75Q
272	fee_transfer	1693	30000000	1	CkpZFoyVGUDTcwhavzh9xvMT5PxtYkpJMAtgibVqQrv17TSwKezrV
273	coinbase	1717	720000000000	1	CkpaKiHsJmgFLEPgo9EKFxsPgx6AJgrXHtdDCdT2zbNZGRDUEkoXd
274	fee_transfer	1717	50000000	1	CkpZ4RzYNrWwnUVUajwL9SpBNL1aa77Bt3kRM6QVAHgrQM1JEgdie
275	fee_transfer	1683	11000000	1	CkpZRcngWLNbgsPGZFKvEmAbxBavG6BA4izkKvPNxNg4JMu8isX4T
276	fee_transfer	1710	11000000	1	CkpZQm3v7wXtcmQBYdtuByV8dmQLfsnLEWrLWfNLMzkK93pc8Fbps
277	fee_transfer	1559	11000000	1	CkpZm2QthQPeZg8qVMxELJhZW6Y1ztnW1nvdXnh6cWgfoWB6wVybo
278	fee_transfer	1682	110000000	1	CkpZw3m5bmYQEcuWprbEzytAYa3KGkY7ncR9fuQoLRkMYBHQacumR
279	coinbase	1718	720000000000	1	CkpYpVuszyWTa3Vbqk2fdNV4QPmH17jAP7ZXfr3MnTMokKCb4Nbd8
280	fee_transfer	1718	20000000	1	CkpZEKhpUs8YkpMsJQS2yt8CPKx3EGNn7cHuCnNK9n23b9zzg93Uc
281	fee_transfer	1555	20000000	1	CkpZPz4EUQzYKQM2tokfGvf7tva9iBSiLuh9JgVeuvzLEBsVmFtdB
282	fee_transfer	1688	11000000	1	CkpZXxPscR8v2c9BLophTdqFLjc7Li84Ef8CLJhBXK67Gb3S9pQ2d
283	fee_transfer	1677	11000000	1	CkpZd2ryWbKyFuu2REpR8iUVCseove33D5kquke3WSfUxE5ND6Ceu
284	fee_transfer	1692	11000000	1	CkpYqkeQo6hKbFadqCxx6Zc9KTzMWpF6XEQrddKK2haVxJSX59thq
285	coinbase	1719	720000000000	1	CkpYYC2u9EZixbs6P23p4A5ms7BdnZZcbheLMSSHQect54QcHWDwH
286	fee_transfer	1719	10000000	1	CkpZRKBTs8vedburKZjmrf8WCExDLpwxY1pcjQaJ5EGUsCTpevSZM
287	fee_transfer	1672	10000000	1	CkpZEW9vSrZ8rXRhKEDjJaG7DmeAa5vJaBZJBQcLeub1ap8Sb1reA
288	coinbase	42	720000000000	1	CkpaEQPKv5yQn52tLURmDsKSAxhdQ5qTGHSSmTEPz3kRKJSKu9ZGK
289	fee_transfer	42	20000000	1	CkpYcQVo1XKvxs4caLPyTvF1z5kwYveAArKck2jHbkyNT64UDL9ah
290	coinbase	1536	720000000000	1	CkpYhL7RUsgnung3At34usiGPqGXgb3u98w8EhE5u1cfLUkXNFpnH
291	fee_transfer	1536	10000000	1	CkpZVaCrpJpp3ZVf5Y36NKNfBkEJKy9S4os63b4EFtxhE8z75rqFc
292	coinbase	1516	720000000000	1	CkpYeXu6eFPGMrMVzCufzLtht8VtYu11wRRQ9aQWnftBvKr4PpckG
293	fee_transfer	1516	10000000	1	CkpYhw3d1kE1XAs72ihgBKDcEtDcmWLxUZiASenbGynSXpdbtDd9H
294	coinbase	563	720000000000	1	CkpaDU6TcGa9P2LyxpmW6UnBrDmsHJFyHCw6aYVh11SH14pnLWniv
295	fee_transfer	563	10000000	1	CkpYhL25VyqNrMx5vWwDvdbyWsgmiPqvYVADqe3KydGNvWpgzoKxQ
296	fee_transfer	55	20000000	1	CkpZxuCRiPQDpi9xxTznoVm2SbKSkYav8KwgrfMiS7Gh1rUdooHN8
297	fee_transfer	1683	21000000	1	CkpZgUmUWk7oEAji9KcsH5PrpKK6sczqRP7Tv6QGiQeRa9sTn8ezm
298	fee_transfer	1679	21000000	1	CkpZokYsqVxJ415d7uPymxWbB5M2DW1deXS7VjCfZLS7kQGAyRUqh
299	fee_transfer	1448	21000000	1	CkpYWe26vNUUCd9mgntvrTWjXPiziSTgwyMRYKEJSKqJLMi53J4gn
300	coinbase	1426	720000000000	1	CkpYy2s1GggXiy8bYszcQrLhGBZiC6sDL9naTnQU2Cv78ShhssbZk
301	fee_transfer	1426	30000000	1	CkpZXpUoeWPSAKt46QnAvTGEfo7n8AviwWtn2siebaZvaqyMzmQjF
302	fee_transfer	1657	10000000	1	CkpZ7zWcb1zhWdd7SREQYzc9SGMHBkamjtF9bKvyuQv2KhKLwqTgc
303	coinbase	1463	720000000000	1	CkpYbzcxuR8EUn1EyxZL4XCKZiV28EL3wDbptEunB49h96wTD34Kw
304	fee_transfer	1463	10000000	1	CkpYg91gaRpHsexR8buu14qZdetHejshKZhoNa2v3W8wjiZLJY82D
305	fee_transfer	1448	30000000	1	CkpaKihuy2ZX7jSwx9shkgQKdr2Zbrw925PX3fMdfwhJoYTDsbgNo
306	fee_transfer	1684	30000000	1	CkpZXJgy9tQUyW7qhUd7HV3SyTT4EZeaEXpC28VL33nxWK1tiYMJT
307	fee_transfer	1560	30000000	1	CkpYpXR5mwCUqsxKm5AczsyhqjNAo5MdoXA6FBWg594pQ2Kid8zUX
308	fee_transfer	1689	50000000	1	CkpZyqn16zqGhQvfdmt5P1Y8QAztkttQZzPY7D3DXEQVP9JNyr6jj
309	fee_transfer	1455	10000000	1	CkpZQesBSZKd41br7KMabhKjHgsqaepCt8ipxmKZY6ZMkjU1bjwew
310	fee_transfer	1396	20000000	1	Ckpa96YhXuhC9YjJxueXrekPB2jUJX8XbQV9BiUPBknzSq46hPe4R
313	coinbase	1524	720000000000	1	CkpYqYGh5yUGVQWz4ffPSNeWnKUxKPcD5wg75FzoTeuH42ebDyne2
314	fee_transfer	1524	10000000	1	Ckpa5KJvsc5fMbMvYKJbzmPLgN9ddJH8cFr9urYtK7qiKqvCLjKhy
315	fee_transfer	1679	40000000	1	Ckpa5TBZg9XHCLhu6VqCLZrjzVYHppDBwbcAj7FNa4LHvXoEF1sHm
311	fee_transfer	641	20000000	1	CkpaAeE2sRW38M8N4JPKGHKghhdo8WAKqAXeL8PqTz4U22bieGKuW
312	fee_transfer	44	110000000	1	CkpZLALfcvEZsfVXtZVL1QLftccB1DABvo1tvikCCfSS83d71hEFn
316	coinbase	1723	720000000000	1	CkpYvVBSUMpzxjVW58Lg5dS4bEjyqQQkRWYRgPM1TPg1aHrYkS3fV
317	fee_transfer	1723	10000000	1	CkpYiFeQYoQPs2LrQYAN72wMQA9poTjxFJ1XbgasFbSiuo3miNAq2
318	fee_transfer	1716	40000000	1	CkpZiBrZijo1iRExp2BqPvA1frBBjo9A2ojeYBaar92q81zeY2cRw
319	fee_transfer	596	20000000	1	CkpZnyPJ4wP2aPs6Zg3ib6Byt7qV4xLThsaXEdT5o1RZ7nVgcNpw3
320	coinbase	1643	720000000000	1	CkpYtrrWqe2SRMLcEqs9TCypvQodXieigbQC1FcsF2fbV8TsQ2kEb
321	fee_transfer	1643	20000000	1	CkpYgT8q6sVqsxPi8sZyMopHhoPGS7WzLNgWUvFWrX5hssdS8rLd8
322	coinbase	1673	720000000000	1	CkpYWhbTZZjRZybY2BVHDpQp444XNTXcjcdEDKgZzRqzqG2T8senM
323	fee_transfer	1673	10000000	1	CkpYtXEC52cfg4pwYifzh6T7NT7wYqEa9rvxsrnkLRv2gxoTjqGRF
324	coinbase	1724	720000000000	1	CkpYpx1P3c12rqvoADvK5FNRb9jAmiHoNQSVWBMSa4GMUMvdE3rXa
325	fee_transfer	1724	10000000	1	CkpYfKHaKL2DbWGeFcPRLuPLRBWGdit1AVABw2RSLNzE26RU3iwPM
326	coinbase	1508	720000000000	1	CkpZNscpFaXDRfqNaEVjjvwtXNaK5SD9g5R3mhua2ZjVsbfXmVVSf
327	fee_transfer	1508	10000000	1	CkpZzWeEq1FcSGqqeY1S1HV22uaKMKvnsZoERzV73oCJEqp3dtWbY
328	fee_transfer	1607	20000000	1	CkpYkdYBuazB6AxsLnqAvwwc4T9GheuLRCD9FkmnxQ7MF3wJ4WaCq
329	fee_transfer	1689	30000000	1	CkpYrpKbzakSkJUpz6ph5MrjwEwZf58bbpjoimLedDSG4tiobqgTQ
330	fee_transfer	1601	30000000	1	CkpZjhSpWQZucFfbBz5oPSS5d9pWs1tzUkvVNrQFHX2QirR9PnoeR
331	fee_transfer	1571	20000000	1	CkpZaA2mU6DSbPH7Nq69QByB6ft99Y8H8GoyLg6DUTTvYNgTdStRu
332	fee_transfer	1723	20000000	1	CkpZ9GnNjDxiYc6zk97EbC7LSiX7SwQ1yrJ4HiYKqbBf1U4gyeqKs
333	fee_transfer	1555	10000000	1	CkpaDjqtf5iYa3SQXLCzXb699FfxW3nVcsUn7X91FJG6mhUUZKAT7
334	fee_transfer	1643	10000000	1	CkpZqGTsQZFpVWwDobEgYeiEeXYJzqVj9XSwrvrdpYfEaKR2nKABf
335	fee_transfer	1445	20000000	1	Ckpa9SpykLmMPpp3gm2upRLDPUh17enxgrcANuJwpDHg5kEtRkAVC
336	coinbase	1588	720000000000	1	Ckpa9NbCvyjBVvCMxqFDRnNqN3cxgfkDF3NTE82X5NqzHaXtcPt7A
337	fee_transfer	1588	30000000	1	CkpZR5UGskhi4zJ2cHwLDZKE9mvCyMdXUKpLsFhHkSNEAMKRshMKA
338	coinbase	1722	720000000000	1	CkpZiGPQzVk8L2hYVS9CSUPFWxQrsp92sNWJFQgSLu56dkD3GdemR
339	fee_transfer	1722	30000000	1	Ckpa4N3jEMePatm2f5dGh2UPHYVD1Po7cxYYZpSYXquVozTEG3HHp
340	fee_transfer	632	10000000	1	CkpZvZhcKdxVPgAt49SMx7WrKp29bmwrWui6JdNiEjcjdJiYSdXL6
341	coinbase	1502	720000000000	1	CkpZm2hRYqCmUtD4gJXhc6howj6uM56W6tQtK48sFhSBJL9uQhkqb
342	fee_transfer	1502	10000000	1	CkpZL9rnqsJ7vmfcLFSxVbDDTNmikxKqakBD77RP4SQQdQxL92AQ6
343	fee_transfer	1596	20000000	1	CkpZm48CcNkUwNjHwPy4KiTQoSAX4KszBYnvHugr1B3suQ2Vr1M9Y
344	fee_transfer	1613	10000000	1	CkpaAiZXgjSahyNL4uPWQWmRXJ2HEBL1H4dfzLebYqLXESQgsskgz
345	coinbase	1616	720000000000	1	CkpZomsCcMCMtsYkuPop9Y5P22LoSuFoApcyVUUTK5qukp8YgWpd9
346	fee_transfer	1616	10000000	1	CkpYeAmfDHZqSCd9evzCp5ufScFwTQF9UKo7RWwakwT8Rp9hTjhH9
347	fee_transfer	1683	30000000	1	CkpZaS7d47NvTcmgsMZfR4q1rtn9w1jFeS48eXVUh6XoeujSZdgmt
348	coinbase	1428	720000000000	1	CkpZ2vYJVD3L614JWi2LVGkmCcVFmoWcgJxv37r766pSKhkCJfWkN
349	fee_transfer	1428	30000000	1	CkpZq55ThKe4bATmwTnJzMJzHeu9XooBv6rQchCzcQRaJtK1U3mnn
350	fee_transfer	1686	30000000	1	CkpaLic28hv2aVjD2woErrc6TWwieXrf6rV7nuqeVNZhQkZmCZN3J
351	fee_transfer	700	30000000	1	CkpZesGiPZEiwHpESk34bjEAKMk8goYn7GoA9xFiguR3hLJf4w1iS
352	fee_transfer	1456	10000000	1	CkpYv8ApNhSEC2nDsDck9XDGQpSmhGCwCZWH5PPdwzJaYV29d5p8T
353	coinbase	1727	720000000000	1	CkpZxZipdWfiWuKLQVFuYMKyvausm9dUnCo4UeL64WEWy5Uk7ZPj8
354	fee_transfer	1727	10000000	1	CkpYx1qEpwmvZnXoyypDkUAnpxRCk8ftHVEqZeRyZ9LETCxiawRmu
355	fee_transfer	1426	10000000	1	CkpZWyroAfJbwy26n7JEVdzBpBX8qZwhrYyoCMC9rPXEwHQ2J7LrR
356	fee_transfer	1588	10000000	1	CkpYU7gHmQVdhzXaqgGjCVn5mymzmw4CeMgynVHQy5h9W8E12RcXx
357	fee_transfer	43	40000000	1	Ckpa4QYr2FgXCXMesPgYfi5oerUmKzBKhqEVTBP6C7GXQn5oQfBfV
358	fee_transfer	1613	40000000	1	CkpYRXhYg4KGGwExAK6qkM9DyPGhC9pozTDXLJbEWGdTGB5B7rXRW
359	fee_transfer	1637	30000000	1	CkpYcayW9PQXHofmLi8b1TS4SSUX41g4wagL4SFauAiG99A24ZBXH
360	coinbase	1670	720000000000	1	Ckpa83REBQvi8rPQNXJzb2mvaBNUcf8k35bMkdDens1d95ELW5iDL
361	fee_transfer	1670	110000000	1	CkpaEozgM9fwsint9dWGoqk71cBQaxevcwHZnWchaMD7XfXn1BWWh
362	coinbase	1729	720000000000	1	Ckpa2APCcT9eFg2oNvopqnjAKkDZKAQ3VTCxVQLyuVVUdHoRFnh5V
363	fee_transfer	1729	110000000	1	CkpYtKu12Zj6ycXJ53s6RLmqXJLjLY2U3PoNHkJFr2nwstJEfgq3t
364	fee_transfer	1536	30000000	1	CkpYjrE4Knps9ix4QKxv651w3ZuqnEFj3Efc4FuyH1vVjNxa5Qbde
365	coinbase	633	720000000000	1	CkpYmk3ksRhDbszjrwqYADyLTbpxGXL52ZvwY9Vnr7rjzswbQ3ZJb
366	fee_transfer	633	10000000	1	CkpYy3TuYYGmnrjVe5oznJMTD2GFP7i7QnvRk2Rorm7UXpXErjc1g
367	coinbase	576	720000000000	1	CkpZ4pueynQ7R5e7JynvnXYkwCy2HCpMDud5Z2VmbQRSn6piSdtdn
368	fee_transfer	576	10000000	1	CkpZuxpg6qmVNrvZkgQqxpDvcpYjN8mweR3rtW98HPYPWVbkseCoz
369	fee_transfer	1656	11000000	1	CkpYiL7yaLyj1G1meuY1CjGkPc7pprTVy7ZuX9vwAGn5JAyXobyRm
370	coinbase	1482	720000000000	1	CkpYRGC8imyALhU9WVAwYqUbQC7tATuZ9b49gcKQCHcZrMXQEZEQg
371	fee_transfer	1482	20000000	1	CkpZCKrQuCUhR6VHb8MCYypXk3kDtWUrJp7afbhUm2AAy8mEDn26U
372	fee_transfer	1688	12000000	1	CkpaJwRGFVA89xja6jY9YmuijpzjSJDRrF1yTWvqzCsuGVpZAL1My
373	coinbase	1271	720000000000	1	CkpYvzTwMaWDmXZ1H7tUFVEBNAadp2hk4uTfFhUg3epd38rV1aKQR
374	fee_transfer	1271	10000000	1	CkpYkstfgTXDn8Aw3G5SLSMAMZc5fbESZGNoNKunCbiaAD6aB2a4M
375	fee_transfer	1623	30000000	1	CkpZ731ZS9kuT6RdMZqDECLDqLbiXHukBuv7mfFx91waMN4YX1ZGw
376	coinbase	1517	720000000000	1	CkpZwWPxiqscCieXQHSwqx7GSyMTzCfj1bmkdUyXELPBzSftJY7sQ
377	fee_transfer	1517	10000000	1	CkpZQTiS5yiDSAH4gft41T1WZk56g9Vz1roZ7zooWk3GS1YaqpBJY
378	coinbase	1733	720000000000	1	CkpZXiZdSzBwQ5vgAXpRS3VJ5PQjTfa1uHbgwAGZXmGaiMdS93x3F
379	fee_transfer	1733	10000000	1	CkpZGm4RRUYu3hD6YdAPwFsnKfgnu8Zkp9f1V6jJ8NYaVQREJBNM5
380	fee_transfer	1637	40000000	1	CkpZDhNSYgW5JFgThmd4Sz8vSpdHo1V4CdhH4guekH8K1yTz218JT
381	coinbase	687	720000000000	1	CkpZiscDQE21yo65yG2TpTcEx9aupfqzghrSFgLzSmdNsgy1Np1Mw
382	fee_transfer	687	30000000	1	Ckpa6Qw85p8iPyKpgacGk9dA9CqGeagoDfMX4MbUKzJkT5nCfdrG4
383	fee_transfer	1684	20000000	1	CkpZ672Pt1KfrGmDbEK5rf3GZaQxHAU7eB2LDpyHG5cWWhuiT27G8
384	fee_transfer	1440	20000000	1	CkpZWo2q9yNzzCbMz57QVZiXctezWFCrBug9dMnuUwqSEMLrXGGyu
385	fee_transfer	1688	50000000	1	CkpZqLYKb8a4fYo2xv1wskSR5MmUoPEM8xNRbXVA5WbFAe5gJupnk
395	fee_transfer	1729	10000000	1	CkpZQHHmJgMiJ7BxKKuX4Pbh8MrAJDJDNgCzM2nU3KEZou8atJXu1
396	fee_transfer	1457	10000000	1	CkpYRxFfbpBYvneMsvUp7JscmExBzstLHMuvivwCGpXVTtM1KUvTQ
397	fee_transfer	1691	30000000	1	CkpZNZpmUmZX4knBoqHrCevuURVNdr8WpZbYGo5TUSL8rroemUgC1
386	fee_transfer	576	50000000	1	CkpYcM77WAZPKRKyF1MF8yhhTBuJQWb1kFFxeyhH7pprvrJK7fPsb
391	coinbase	1402	720000000000	1	CkpZTnPFYe9RDokqyKmovnnyFR9MtcswuYPaQFtPZdh9DLWkdH8f3
392	fee_transfer	1402	10000000	1	CkpZRPjunDxY31MDJMhPu5P8FmwJUnKqq5865CRKPCx4foNA8V1nL
393	fee_transfer	1508	11000000	1	Ckpa4MNiNHiMYCKBT1bm8rnDE5jyJ8zgpCNmomhUkVMcP1YkGK1va
387	fee_transfer	1610	30000000	1	CkpYV6ry5fqHvMmXuEk7kPNpurX9wUZMHZXtV4kWkuhARCnv5BZVK
388	fee_transfer	1637	11000000	1	CkpaKC3pvVKfqHLHRQ7guczz8aeY7fYjDnBE6YFz3DL475uSACE4q
389	coinbase	1735	720000000000	1	CkpYyYFVN37ScHc2QxMQissEhMaxTQgLjdt5cgGMCMoCd4kFLUtSZ
390	fee_transfer	1735	10000000	1	CkpYV3cQHHfvH9wnUc7HdChAL5V6Z2GrWW4Z2e9UmYfdfVhMeAY34
394	fee_transfer	1573	11000000	1	CkpZxSnPE754xaWHTSvuJwSCZaZEJHb9biFzynm8PTaEB3UpKhAeb
398	fee_transfer	1706	10000000	1	CkpaHkGZLRs7tt2G8fk3npubRdb68WQVGDaGzheYmszkJt4br4KMc
399	fee_transfer	1476	10000000	1	CkpZMd9ciTodyoVfUFTiqXpX3ossvFTf1nkSYFAw3zWaxu317zLYJ
400	fee_transfer	42	10000000	1	CkpZdxtycsAEkRaQwqJiGBP2vMeWukEcyJqJnsfrpew99QW3T79sQ
401	fee_transfer	1691	20000000	1	CkpZD568frUxVDd8P7v2HS5GgPoGs3vq9KknwfFaig5CVhKcAUMDU
402	coinbase	1451	720000000000	1	Ckpa6quPBNRiKRWNhCMuYa3weK3mv5ePYu2zgZGgRs6ZRUYJ98tF1
403	fee_transfer	1451	10000000	1	CkpaDb9xJ7vsFHWmG6CoEaDqb2uNV7nY9reFsoFdSx5yeALdzJy1t
404	fee_transfer	1599	30000000	1	Ckpa7fUgDAYhWmxYfX49vijAnTM5ZLhXG3g1UdPzdmKz6F9GoDZz6
405	fee_transfer	149	30000000	1	CkpZ3FWNTcmMCKgX9oevBFsEr5TW2Pj64u7JeASf4nvxjv3mSUTUG
406	fee_transfer	1402	20000000	1	CkpaJ2u5HW6Dr2Bt96fo9cCPDBQXnwEFKJRnGVDjargduTmwVSy3u
407	fee_transfer	1705	30000000	1	CkpYgJdFaYJFHKBsB1ZUGMTZhxbqGmjgXEvm1YgxyESrYRUUZde9q
408	fee_transfer	1637	210000000	1	CkpYvQP7yEoLHJPT9rYGXeDcLAPr4vcjT7awQGeo6fa11wBiFRdKK
409	fee_transfer	1722	10000000	1	CkpaC4nFH1EYqbCQZAYAgpf9om7MKE51VmAk7X6LK9WfTQQov6umE
410	fee_transfer	1717	10000000	1	CkpYmDrkHfUs5fMpVs24kTvH4ukcnaV7aPX4KBVWL2vcGi7h8FDrF
411	coinbase	1608	720000000000	1	CkpZqNLvWWZ3vSmkDFsKqAcCwHX82eE7Xv1yahxc3yqhG9SMMNoxh
412	fee_transfer	1608	10000000	1	CkpZvPaVTyKCEYiQhusU1bruahvE4t5hPid8PDbGm7xg7M4t1PY22
413	coinbase	1519	720000000000	1	CkpZJfKyhLQ6ZMcTFmqLdQpEzfu1cE9SoGHfwrrMiE2QYxa4NKEGf
414	fee_transfer	1519	10000000	1	CkpZm5PaTqWB5vWHX6AT6gjCcYQCJHqt2R4LSWMHHaVQUVnnHzjMq
415	fee_transfer	1722	20000000	1	CkpYybgj8a8as1KGGYoHTGFvuFk2GY3nvRFB2Ej8ZVWfV45SJiorc
416	coinbase	1738	720000000000	1	CkpYhzFPw7fPoZxDefA35fiDLZnmUbXrJHrrv7jGRDq58jF9Fghc9
417	fee_transfer	1738	10000000	1	Ckpa4aTDH8njQirXWWeo2iyPpt3gEpEr6XjHh7YmQ9YeRpnQknzmj
418	fee_transfer	1513	10000000	1	CkpZm46sPhXJH8bvYufaDBaeCd89bpfvPQcEwz4VQbsE4oSzTeK9c
419	fee_transfer	1715	20000000	1	CkpYpDECjVjM2un1QUbvzHdVgDG16Gp1UL5JReyN1yGFadBEMU1aB
420	fee_transfer	1729	20000000	1	CkpYjENA6deZ65up1yJUiC5HbmzxSmtRpPEyTgXjChgM3A1hVBFH9
421	fee_transfer	1516	40000000	1	CkpYYNv9DTYYwViFwF2iRzLhhz4rz4va6wmmfjMZaczmb8vmQTVUj
422	fee_transfer	1677	40000000	1	CkpZ9E7z7s56YKdR7ewPyk6Ejp76qocApPHpSeWbD4RVqeiPq4iVo
423	fee_transfer	1699	40000000	1	CkpZMskeHGyoUV64um7MkUDbFu463Fo3ezfx3tiVT5MnARwE24X2B
424	coinbase	58	720000000000	1	Ckpa7F7XBaKNxLtimQv9RVgj1pQxy1YWe3yWD93DR4t1xRbcr2kHB
425	fee_transfer	58	10000000	1	CkpYxokaMWD9U8EBHC8NHFSZL572wqVShXVCPYmVktmCyvWDo8PX7
426	fee_transfer	1683	60000000	1	CkpZUM9LNZ8XB5tq2zY87fwQj8GgK8znsyNVxzyBCsZfVyPA5JAnt
427	fee_transfer	632	50000000	1	CkpaARMPvypb39hTppqPSPHiovLv1pk92UdvDbh5Lbd7a3c82kSw8
428	fee_transfer	1448	260000000	1	Ckpa5HrCZoji55Zx3ENKKV7xykrgxTZki1hoxVdANnNRbYqhESHFP
429	fee_transfer	1692	260000000	1	CkpaHU5LdzTNSJKbUfa2Lb6ua6J29KxRoHXGywGuoxwByCuRM7yh5
430	fee_transfer	1673	260000000	1	CkpZ9NbCd69obrm94DE3is1WAPekhr3fV5AT27YgAuzLyY837T6kH
431	coinbase	1678	720000000000	1	CkpaDmGikdqaVePLJfyL3cXUipn6ymF786mtLZfvsMQ67y7ohxubw
432	fee_transfer	1678	10000000	1	CkpaAarovSU6h7GKCcovnm2K7kuhnEnStMmW27CsdqWCauZWAsAcW
433	fee_transfer	43	20000000	1	CkpYcxHhGfvNJRzcCBPzqoMFA18JKgGN4PuuneHqLqiGL7eCNwAah
434	fee_transfer	311	20000000	1	CkpYdTrj7yvN6rQR3ejU6Ke3nGGn8XXZX2CxyvKz2yZbCfGcHrTUW
435	coinbase	1739	720000000000	1	Ckpa1qfXAsE83VzoNSDKpzHgd77XBJTRHELdQYcQxs5Le3vJ8FMJr
436	fee_transfer	1739	10000000	1	CkpZkAerEFYD6tBDkDhqXnNToJAfzT7RRtBxywe91uMPNSxrevDCW
437	fee_transfer	1698	10000000	1	CkpYdM6hpgfFZdGk9NczqJauM8bE2KGqC4x5zHRzj2yd7ipKDLa8H
438	fee_transfer	1633	20000000	1	CkpZCbWM6Jic7haa8Ya6CMSY48gPks95SDo16QMJNi1ssyFRpejsU
439	fee_transfer	1634	30000000	1	CkpaGyGAAXzeTVUc3WhdY7ay9DDWD4hS3HTKviZoMkCWgETTo5TeU
440	coinbase	1569	720000000000	1	CkpZtdWJ6ydzM3h6o5BERKVDjk5ipTCvASjQHuR4mrDoQPVUzh8y6
441	fee_transfer	1569	710000000	1	CkpYWo4Me7gXVukywTQAmXgu7Dkz36uiEgFGyZLibqaJZmV9iDgcj
442	fee_transfer	1569	510000000	1	CkpZJGdTjxpCWGXFTAa1uwRy7cygJPGz5K4pwwzg3ATYcr5u6pUh5
443	fee_transfer	1569	10000000	1	CkpZR6AwqHzjN9UHu4niM7xAPU5evmtvScvjmANoMMKbLURRjg65o
444	fee_transfer	1677	110000000	1	Ckpa2f51VC3mBaNDSiN8zJ83gM9y5C1FBEABwdZNTeGfRcDLievWN
445	fee_transfer	1637	110000000	1	CkpZNgxoyqu9sP5Joxd2vxNEvoamm46kxH7XmntPVGXr7LW7mEQKS
446	fee_transfer	1516	120000000	1	CkpaHXUuN7k8sMk7QUHwQcMYBARYg43TfKBEWRobstUCbpEtsJQhu
447	fee_transfer	1671	40000000	1	Ckpa4JJgjYmnBko2SW1AQYfknpHfcLBaTyMXhJkqtgXygSRexBz8Q
448	fee_transfer	1695	40000000	1	CkpZJRSuQT6xD1A613Yk8pjMb4meVZZa4oCGFMH6Mppw5E58s13xL
449	coinbase	1650	720000000000	1	CkpZ3kuAb3iUkL5PXCcs6KK23fTM3btXKaviWYE68LMRr5nPYsHc3
450	fee_transfer	1650	10000000	1	CkpZuV6XJWyi8mYxrgsY5BZ2Pe3BPoaQapJk5RW9VNrYg2fovK4FZ
451	coinbase	1740	720000000000	1	CkpYiEdAHeDKTwuk9MX8FyxGWRcf7ZhoyeSzqruf5GWHQ7gedioPt
452	fee_transfer	1740	20000000	1	CkpYe4FXcUxJu1DRNneRfW19g8egopSm7t8tcz5wvQDqhf4vH3s75
453	coinbase	1675	720000000000	1	CkpYiCxULpT7Z5yRoVGEX5pQz9DP9NkYCinNAsetvBoDbd1bXvRnx
454	fee_transfer	1675	10000000	1	CkpaLHkhdhxe7kgxLQHsR7VCMbquUoudcVLRLgnXU7EMpxrAKAC67
455	fee_transfer	1419	10000000	1	CkpaJHFouRETY7rRywz8hY8GGwqKopmFsmUNdRKLDdYWF33tUssNS
456	coinbase	1446	720000000000	1	CkpZ1ry6FWY7aDq9oYEEosAVyMf8qdWf646jFHFbcN1waMq8bh3aG
457	fee_transfer	1446	10000000	1	Ckpa7teccMSAwrj6GX6Pnm9Giw1AiCdTQHDnqgNxrvvoZnAkBY2e1
458	fee_transfer	1711	20000000	1	CkpYmeTzfgvyuXBUba9zuh8AE1NTMj8wgv3cHQHATEMwBzQi5vaCS
459	coinbase	1423	720000000000	1	CkpaDrCRYE3qMAFa6YP4qoanAb23pWG4AvCsvQSQEWxVF2Ty71wSp
460	fee_transfer	1423	10000000	1	Ckpa2qsZkhaKK123KKYgVy9LKgt7p85cUggMiMKiqgev8aCqJ5iHJ
461	coinbase	341	720000000000	1	CkpZeRFhZQCcxsW2nZi9XLjThQCJkR77JRpYJ8SSSfcqNsfFVLVM4
462	fee_transfer	341	720000000	1	CkpZrkrHqqVKUcyCGGC5ZwptVP6rxWonobuD7e9zM3nRi4CfaFKpB
463	fee_transfer	341	10000000	1	CkpZig45J5e1f8cFqKw9SwQXwwszUDWLfvb3B7PjUAG8p8VWyyeRM
468	fee_transfer	58	30000000	1	CkpYquuVBKHeM24jbQuucNqYdgG93wBoTaqAFXjuVNM4jRJjaGtWF
471	fee_transfer	1679	110000000	1	CkpYvbfxtNgn4Hf5J8Z712w7A9gxgYoDRHPMPdBCtpQGdBUoavAL2
476	fee_transfer	1654	30000000	1	CkpZBNbKjSo4vVMuKSawm2KL1yAFQchBLobjGwKxBJ3vpLLZUrb3s
481	fee_transfer	1739	20000000	1	CkpYkyoX9kyjppoEHaWiHDChxPpC7yUVf6dRPfAngzjNR85bS9EaW
464	fee_transfer	1587	120000000	1	Ckpa8bPfvFrA1U9G4aJX5imLv66C5WczP6QSk1z4ZtFPBa5N3gbNK
469	coinbase	1434	720000000000	1	CkpYxpoPGBFNE8zBvQcpqsT2yABVXMNyzvzU7huwmi5PNKNb1jmcd
470	fee_transfer	1434	110000000	1	CkpZPRZz7MsTRgK3BkuCKaXdN65Wz1Lsjif2qou5cJBgm81xXAsAL
474	fee_transfer	576	30000000	1	CkpZsiCPeC5DhwDoAtoXAeiL8FKxorm4qsdrFsi6nfLUmLuHTsduB
480	fee_transfer	1457	20000000	1	Ckpa8Yw4woDh74shCQGH6QV185hbLyep5mCZER5ahgDnpHRSAoFdL
485	fee_transfer	1654	20000000	1	CkpZMKS6ePVESJMzkk75KxSRD5eV6isAqLhgtrFY55Vye23sVmr6q
486	fee_transfer	1724	20000000	1	CkpYe4AcEgZN6Qk9eiEUaErSDAJHxREVwRPCVGaH5Xosdco1QGoAN
465	fee_transfer	1683	120000000	1	CkpaCB2WSE5uWwoQubDHnhDjis5X26eDhszigiTqj81ThG6pL2uUc
466	fee_transfer	1685	120000000	1	CkpYbGQtXNYZrVNdycBQ1zjtUJn1kFzwupofiBSpT6h6NAzSHXPvL
467	fee_transfer	1670	130000000	1	CkpZrXzrmHaCoCupGiwK11wU2BjB1pLf4FDh2wSwaHTu3HRS5mukr
472	fee_transfer	1693	110000000	1	CkpZqiNCUYi7Jn8E4MJSNU6RBNtLvSzZ43PV8HNZbzNBAurQgG9rg
473	fee_transfer	1718	10000000	1	CkpaJGjh9exJe44zLEEjk3kxFsZX4hJDHgEE2LBPXQzwddMUZueUj
475	fee_transfer	1690	30000000	1	CkpaCGZGLVx3vYFBhqPobDb8ssVx5f1ii5TQuDPfxVZ1eCEGR1rKg
477	fee_transfer	44	30000000	1	CkpYa75MfKhvRxDSPbGkMxcLnJiEjNyRK3APXqQT2YvxteGFV2FEH
478	fee_transfer	1573	10000000	1	CkpZqjbQxGKe2XJLk65bB9RQioLmFfVEgFTinGwNSPZZLsp8rx744
479	fee_transfer	1670	10000000	1	Ckpa4hx1v9228uTQXgXxJWiSajFXz83S69HwJZwvpNB5amrrpkU8f
482	fee_transfer	1649	20000000	1	CkpZhyfhEzAuvisuwEXsH2SYvqZHowsjJGkvgGnTwc7X3pZ6nsvi8
483	coinbase	1741	720000000000	1	Ckpa1ttRgYZsQeNUBZRJScDFHSLWW9WPJXttgpVRfgyrdtg5gUDDE
484	fee_transfer	1741	10000000	1	CkpYvigB41UCNJKtb73XYZSvcJQB5Wv8nS5xPD7Z5CWLGswALySkV
487	fee_transfer	1599	20000000	1	CkpYp1LdnGSyhU8rEwnLvrCmzg2pHWeMMTAeBSN2yZHiLaeTMkwuj
488	coinbase	1564	720000000000	1	CkpYh3wbPj7BzZuTZEQK11tUtSDnjQpu87VndFKDUCyQJBzLbXW8o
489	fee_transfer	1564	10000000	1	CkpZQMZSWC6jUzNbzDrFg7tV6P92BVANQ6EmmChMu5FnhQjwB2rjc
490	fee_transfer	1559	40000000	1	CkpYTrwbu4Y1uWdZQJGtzrBhC5eycxHBe58yfxGCPZFRwbo3RdkHZ
491	fee_transfer	1541	40000000	1	CkpYRQFxedx4ekUf15ncwEePPh5aQMFpr1VVnpHLAizteZkGbFnq8
492	fee_transfer	484	30000000	1	CkpZePZ8cmpTQRj5RJCmS4hC8nwMCtxffnRRTUsL2gvaFyfihYQuK
493	fee_transfer	1476	30000000	1	CkpYuJqR6Nc4mqidVt8hVucw38zwphWZ6CqGAbd9oG3tcPaKJz1io
494	fee_transfer	1723	230000000	1	Ckpa8nJAVrpU5bTXm3vpjT7Jb5DbZWWNR5kVGPvNgfBbY1BVgSZHe
495	fee_transfer	641	230000000	1	CkpaExf8NyWDyP43bfzZRqmb1VQDn6cuLuyPQr5w6LdHuduhQzQj5
496	fee_transfer	1451	110000000	1	CkpZYfxpnRjUH1naf9kP2NzNt77rKonDUZMYiJMK5BoMTjQN1gU3K
497	fee_transfer	1740	110000000	1	CkpZ47gEbxBQ28yEGpah3MFPKBqA4V81BbGmmeB1LmLRCFcf6675o
498	fee_transfer	1518	10000000	1	CkpZDFAF5eoyxd7KXKxZwnM9k74CgGMCnM5hAmegQKZzT7gigUHkc
499	fee_transfer	1593	10000000	1	CkpZNn8jTKDcn1XSktJ9ZTcvHestyofEJdJj8hWcVWQpYaBL6VsoZ
500	fee_transfer	1602	20000000	1	CkpYhpuoPENd2C9sSEFCeJx8qboJthUbk8vz4WgV5mZkrbSnfJqvZ
501	fee_transfer	1422	20000000	1	CkpYuhVN9dN6v2NHPj1NXsytkkEnJYTHCQ4YMkbpbxckGHZ9pt4MB
502	fee_transfer	1516	20000000	1	CkpZ4tRvTof5R3tjiu5PLtQWkba54PWrFi61dL5CseHUCZgHbkSan
503	fee_transfer	1402	21000000	1	CkpZP4BF6nnFFQhcL1Byths9naVp8zAwnw4McLeQy5qWXqPcZ7YGR
504	fee_transfer	1536	21000000	1	Ckpa2vqgpWR8xHaXV3866Wdy8fFr73QotsFsqHcH4gx2mKDXDCfDj
505	fee_transfer	1715	21000000	1	CkpZ3HWFFqT7u2zJtGYxQ6rB4LdaDGpQbU1QVouvikRkfZih7QCCu
506	fee_transfer	1706	21000000	1	CkpYyS7Yjm6ythQeSKLWrKhyWvuhJBHHxHgbXGK6RhSJb8rDCkRfU
507	fee_transfer	1448	120000000	1	CkpZVBxrNP6DAxR5d75W3H3UiMpUZjzdNk15tzKd3VQ2cHCcwAoEE
508	fee_transfer	1610	20000000	1	CkpaJuJF5zr48iKij9gH4SJqDBbuUQzTE4P5AXDxDRno8L5xeXoUW
509	fee_transfer	1622	20000000	1	CkpZECNHQ5pV1PbFiNSaDiGS4sKQS61Do3BWzBB1pcEoJXWidWimc
510	fee_transfer	1670	20000000	1	CkpaDSpz9pKEMW59h1TB7v9JL6emzbuQ4DhsS5Uw2UNVG4TXaYkx6
511	fee_transfer	484	20000000	1	CkpYtz9agAZt9Au4q5J2iajStXC4zQrpMShZLV1kk5fGayjRua62u
512	fee_transfer	1560	110000000	1	CkpaA7VPJBwYdbG4t8wk5bsHbHcDRTC4c3knk6qCvkUrJ778tF77H
513	fee_transfer	1549	11000000	1	CkpZuLJRyM9rPdE7mRaztb4PRtPGKsr4XWvbYQ3Pz5ADrUMNnKXjN
514	coinbase	69	720000000000	1	CkpZrm1NpN5tao8mBMXQtpF9QnKsT2YdEGEw1cewTxkVMCd5NA5cE
515	fee_transfer	69	10000000	1	CkpaF93Stn2PwA5zNtLiVcDBS7ET7LGBjxNmfAAwRNRLTXckuCXhg
516	fee_transfer	1704	20000000	1	CkpZCuWLPC72jSKToDSRokFqX2J293smZZkWKwRoZYSYiUqvkBuaY
517	coinbase	1566	720000000000	1	CkpZkFZEbgeaiU784TS25NFM3t8nFMdRnKPvgzutqFeVR7KWGnt3X
518	fee_transfer	1566	10000000	1	CkpYdPvix3mF5sdPJrpYXjpWDS7X892Lxg4y5sdDhnxQxAmvJLzdX
519	fee_transfer	633	20000000	1	CkpYvxrq57131GRjYmBC856E3z1aVbXRKzuRKaSUNuqs4jvtcNShn
520	fee_transfer	58	20000000	1	CkpZhKK3CukkqRELQZhMsM5hvWNZiUxcGVfzHdM1DAfjUJ76DWdYj
521	fee_transfer	1509	30000000	1	CkpYcSBfQJy2izDZTuSQxECoHJLkFMHmN3boNfP3G6XMEnnnH7QZ1
522	fee_transfer	1688	60000000	1	CkpZo7gkaC7GyQKPx2EErQqJoDsaNG8koFh5q4WgJrUDomrMzRVFh
523	fee_transfer	1677	60000000	1	CkpYtDRJzBECjpn8KiYKCyJXpJWRxy8CsvTXfzCJb3ND3awtJS4YT
524	fee_transfer	1689	20000000	1	CkpZ9hCtWG3C5wswR886sR788PP5tVTFXxMuPkCNXsr1H8c2BFzVN
525	coinbase	1640	720000000000	1	CkpZ7g8KHPHkm9TyxjcuqhCEf367Eoe97McxnbyTsVsR4bzJ672b4
526	fee_transfer	1640	10000000	1	CkpZR7HJqTy52bP2R6j9MqmSxRDoyUyRKs2SAnZ4u3SXNqied9qxd
527	fee_transfer	596	10000000	1	CkpZYo8vqc9QWFUXUwhCyjHZEnD7KSnaXwyY5XqEPtp11BjchUyu3
528	coinbase	1439	720000000000	1	CkpZXsvc9EVxxgxjk73SuTdCRnoZB2X3rsiDkorH2GMrzS1NF8QmW
529	fee_transfer	1439	10000000	1	CkpYvPiNMXx3bGPdukFEutytnzW3inXZQCfQrs9JFo1fDPh5wdmcm
530	fee_transfer	1708	10000000	1	CkpYnCceiJvDf4tpu7Qz2cvpTp7EeDPrtbNScdAYvAKDjczejMFFs
531	fee_transfer	1678	20000000	1	CkpZvQr2cYKw5XMo5fzGYq6M9fttw34VokA53RVHJZAMfwc1BhLF2
532	fee_transfer	1671	50000000	1	CkpZBs6qfsAj1hhwLhtC23UHYpH3ZFe24ppL2dEEoVfKXWy1HjKxx
533	fee_transfer	1509	10000000	1	CkpYeM4NxQodFo9G3MwxiwKP7ShWxkq2ts8vmiG2eQQuxHKf2Gphj
534	coinbase	101	720000000000	1	CkpZqSyMp9LH3DNWWq6duqSwkL6t4MqSoWzE7cuhHsooK3gytWFsJ
535	fee_transfer	101	10000000	1	CkpZR6gucdMqCthjwmWDFPfWGTfD7HT8YeUkFDerNz42H9zvyf1Xq
536	coinbase	243	720000000000	1	CkpZjxkzALLuCXVFkGKnrAQvMRNXxJY966pNjPeP8BbmqZPJRhRv4
537	fee_transfer	243	10000000	1	CkpZZaUZDMGtPAgUH8hWGkEqddnMgJXso9eDomB1Zw8PGDpUHiWJ8
538	fee_transfer	1715	40000000	1	CkpYhtGTVR555J9ZMKHMXdbgpJCbFe6qkhSo4DAadtPJ3ttZaaZ3Y
539	fee_transfer	1402	40000000	1	CkpZAqcSeXdUx4kFyXqNRkhJf8CpyHnkjY1bGqDhsbajFF5qjz1UC
540	fee_transfer_via_coinbase	1449	24000459	1	CkpYX42ZtkXjpvnfdPwe4Hdr3zqwbaKq3X5ZyJudGnLq1CjGRACQx
541	coinbase	1683	1440000000000	1	CkpaGkWqpXU8aQ3Qa8N7rxhKMWBZ7viDJL7atKBz92XMX69RauLpS
542	fee_transfer	1679	90000000	1	Ckpa9JsoSz9Brv3PCAK7BPNbKEnTzjmoZbFySLhjhVczwwYts2vYm
543	fee_transfer	1685	90000000	1	Ckpa8kCQYNN8hS7NHXjRxdHfFA1qJxP75dPWgWHLsiVCKPq3h93VV
544	fee_transfer	1467	1350000000	1	Ckpa5qHDpcUuyszetJDzZtS8t7kYysWwzoYKa7uV7rsWXJGZwjKWu
545	fee_transfer	1622	1350000000	1	CkpZFGL8yvZpPjwSnzmD4E2vVghW4dJCTAW1ZMJrQxBpYvviSFmB6
548	fee_transfer	1677	170000000	1	CkpYfSWqEjgeQVFP4ZHe2o8uuiz2rzh5H3trLjHeVTvUbZCgBoZQE
552	fee_transfer	1690	160000000	1	CkpYr3HgWimiBgTVRC4NanrBUFHvyFBQoQJ2uURLBzpaZbbcpoa7d
553	fee_transfer	1439	30000000	1	Ckpa9rKjBqLtuzUJqi8A7GQqJaa91YHvsaaSERDWN5GoMQAwuLBJ2
554	fee_transfer	171	30000000	1	Ckpa3z7nntp1ceK1gJnvxjZUe6o2YLyyeC7JzfqtD4SQwxesaUztx
558	fee_transfer	1679	160000000	1	CkpZKkgNKhJg3hT1nWPLoBFyPDffRBBmHbAvfX2Vu32HR79DzG5Qz
559	fee_transfer	1489	90000000	1	CkpZQTmq7e99asHAcYEumRsrPRRrx3jLpth1iwnKvXk3a6e7sqwj1
563	fee_transfer	1700	100000000	1	CkpZPzfp5AeRim8RhGJ1DNHfsTpEFXXGiPbi44EG8vUdFPcEcv2bo
565	fee_transfer	1711	40000000	1	CkpZCYSwmP18v95vwaRADvFnmyBBYSeL5zoFwGbwJQijRGkh3AKGg
571	fee_transfer	1705	20000000	1	CkpYybHefrua8Q9c3aJVRLCYwaGTGih3vpJg68W8CmRRcXJeFaaSm
573	coinbase	363	720000000000	1	CkpZEuDVd5o6Ryciqmz7KD2XhbFGaUPPpdW6m4vWzLg1aAyBQXE4r
574	fee_transfer	363	30000000	1	CkpZjKKrrQfbJcR8aHbJEZzKTeGCHLK4qij4Bqmr6VENGuhoK8jcL
575	fee_transfer	1536	20000000	1	CkpaKn23pAmGPBFVnns5vv78PECEJRkqqrDQCRnbgu43DETYo2ouB
576	fee_transfer	1657	20000000	1	CkpYwdBZ5xzPLVkx348QS538jhrFZUV6iH24wtj3s8zSx3iP9TFSB
577	coinbase	1552	720000000000	1	CkpZSq47YWigSjV2Vvwaezm7GrDgy8GJ7tE31aNACCeZz6wzKd8Px
578	fee_transfer	1552	10000000	1	CkpZKFeGHT7CQbB7faBjqDYGH3sZFo1oN2Wt4UxeENChd5SJPYdE8
579	fee_transfer	1680	20000000	1	CkpZRsanTMxfsbyU8ijvEH662ZXMYaRyFGAEbZrQAV2qVqB45nWi5
580	fee_transfer	1694	30000000	1	CkpZhbiMsVsnDx7nNsP83XH1y8b4TAt79pntSkQy8FMXJirq7vZrD
582	fee_transfer	1608	20000000	1	CkpZaYpyPugNEcDfxLRoH6REvDVFDYDsiLeADxV6ybBmiry9d5Jzi
584	fee_transfer	1740	10000000	1	CkpYUwvEPRwbnKg54xoQz2mocFrBSJHwPgiE49aX9oPsSissVhqZp
546	fee_transfer	1686	1350000000	1	CkpYqx2iRN5ex3HjP4nwWA6XKFPVZ3oAGk7aYWZALZJMSJeEymLqU
561	coinbase	1531	720000000000	1	CkpaEEUiYcw2qduKhJbRYi9FxWfKJQMicHP2wPbZu3ZWxAtYgnL4E
562	fee_transfer	1531	90000000	1	CkpZR1UNykkWjSgDniBsHia23UhaaoJfwD2eheL7xhRWd6XaRDBor
566	fee_transfer	1506	20000000	1	CkpZ7Cq3XKXwQxBqHymZKpukkmWCVJqvEjNA5ZbUJRKonrMLfhp3G
567	fee_transfer	1680	280000000	1	CkpZD7j7R2jhJmkPpfCJJhAk7wxeHShMc65qck54qoVc5PK6nQFEg
568	fee_transfer	1680	420000000	1	CkpZFFXB7fsE6iikadHM277E46hdsBKmzMhkq7oCWW3hSmVd2Yqpz
570	fee_transfer	298	20000000	1	CkpYinGotE5Z7oEMHBdn1xUtZpNVPiUuY5LdibrmVccnzZA88cSWK
572	fee_transfer	1679	30000000	1	CkpZzphHLjy8mb9wnVrMayD9fiEFnND6L8ch2anRXbz2hWWkGosdK
581	fee_transfer	1402	30000000	1	CkpZBJuhKxY7VaA6D5wPV6yYGQ7sN239Y8gBjDoc9CeCckm1P3LVp
583	fee_transfer	1650	20000000	1	CkpZY1jL4C6kuia1BYMmb2zeNUjYvrsEc9Gj7AvkPChNvbfdCqt5Y
585	fee_transfer	1455	20000000	1	CkpYnTwQCSfs6aSf7VXN1BYZSFNA5rdHCEGTe1AH3xBHuRqgvXaMe
587	fee_transfer	1471	30000000	1	CkpYpS5wVCPnFwcZBARydbG8PMGdnY1wUTjvKFXVjrJbGaXLe3XEX
547	fee_transfer	1704	170000000	1	CkpaGJSWsUeNMtZfAvA6Pb2D5MqnQ6C3ZQCDZqkypJ5cqH3SztJax
549	fee_transfer	1709	170000000	1	CkpZFNHMj4B6jkApphbmcfRTAKzMKSYewY62PHEundrvyMyKkxWKJ
550	fee_transfer	1704	1370000000	1	CkpYv8dtsML91cWudYbt8F937AHX4dRqbq2imeUtVprp2e3UGDeeG
551	fee_transfer	1704	40000000	1	CkpYU9MeVfFMuetbRCRw1zpLHfdEoGexcG7pQqUkUavSj2iRdhmdx
555	fee_transfer	1723	30000000	1	CkpYuXJkDVEnRcz3vQaaGUT9MARtduN4S8pG5RtX2NK6e7Q3vz6iD
556	coinbase	1495	720000000000	1	CkpaGGziFaDvMaE3mzmBTHSogLMDdiFuT9YmdsEkLAkWaAUSRq1YC
557	fee_transfer	1495	10000000	1	CkpZADRzkTg1Lvi52aH26198phRNBESAQTnkwmyv5xTKugZk6R1mB
560	fee_transfer	1489	80000000	1	CkpZRW5jTt3Tw4NvsEC2bgWp8bjtLrF8jobN2rn3tubkG7iEvSohc
564	fee_transfer	1688	40000000	1	CkpYWm2k1aDjGkVygSm5HVT5kuFvXWqr4aV5oryUydiqHNci7LotV
569	fee_transfer	1688	110000000	1	CkpYjFazSU6EGsEpzgazygEwYrPWfQ6sTuSGWsVpfrHe6VfojfAqC
586	fee_transfer	1717	30000000	1	CkpZumd1n8bZTWp194wQ7o1jfrLpdEboePWu19HWCW3ApCrF9VxQK
588	fee_transfer	1684	40000000	1	Ckpa1L2QBe2XCSvwqqBCwXDhrXraCFNHQSrhddXqQDzKhq3CCyRR5
589	fee_transfer	1693	40000000	1	CkpYxxm6xG6akSMRqwGf8WTesodoQdrafuWyWxcmwdZDyDQWKp1Fj
590	fee_transfer	1685	40000000	1	CkpaDMgrwrQywPFM8yoZ7rXxxP5zvateEqgwcXwxwYPNB2MPs8hw4
591	coinbase	667	720000000000	1	CkpZ6GMPY81GHk2QfmtsaJXRdKPSe5DP8fnysM9TamtunmQk3hfDd
592	fee_transfer	667	40000000	1	CkpZ7a948TZjHghPpUzKVjogUHEpYwrez3ifnoRCEiZhgi1NsK9kE
593	fee_transfer	1690	190000000	1	CkpaAW5y2mMtPACmAGavGcFtRGjC7AKo7fUdGFzjPcJgAraRpsMBd
594	fee_transfer	1602	30000000	1	CkpYevSy9H9Nipzaf2xkK7xUozNSZwTudi6DFRr1AtNzkrib9jzQy
595	coinbase	1746	720000000000	1	CkpZrfMwxNhxqh4YQEWheGxDuXJfe29m2HSuy7W7ZzWc7UY9kJJGa
596	fee_transfer	1746	10000000	1	CkpYzf777XSXPbi4q9oVWgtXfgbmGrsFVH8SjjF77EJR4pTdn4nJm
597	coinbase	1747	720000000000	1	CkpZRJ4R5PhX6hKAEkPpJ2CPfTYjXrhMVUhfHCpr1Nq3D8ZKRyctW
598	fee_transfer	1747	10000000	1	CkpYVwBreTPZxnYTdZqRNLNE3dwEgkypqsQv9zfUVxGwdnhjpJwfg
599	fee_transfer	1704	10000000	1	Ckpa2Jnhhz5SFBm5GhEiBQ2DJpGm9oPnF7R8ibYhUZkjo57Z4ZnJa
600	fee_transfer	1683	40000000	1	CkpZN7uf3TgPDNaHB3DQz3j17WkQGyGLjohzvC5VRtWY9zxmYKxiV
601	fee_transfer	1694	40000000	1	CkpZoLuK3dSpR3BCKBHmEz5gNFhKpbbVPTNGrXs9gq621Drfr5QBa
602	fee_transfer	44	40000000	1	CkpYw21RW5D8xyLYLDGrWfYjrkLniQW18XFD4zNUc8aggp5ZCXKZQ
603	fee_transfer	1724	40000000	1	CkpZz3ZG4aeuu3R7NvC78AzuKMEPentZg3t7AMas1cKF3Db2sfpiY
604	fee_transfer	596	21000000	1	CkpZB8G6QfBkfgSjJwaVeMA8mEokct3BEtCqRAJ7oxotuXKAQ7Apd
605	fee_transfer	1649	21000000	1	CkpYnFHL7J3QUidP9HjcHq7zmK4ZpKdzECbN89MmQRL81j5T1UDZg
606	fee_transfer	1516	50000000	1	CkpYdk8sVe9fcmXNkM238ZtNSaCAdYzLBWvw6jyAVUryCjJTXjFfR
607	fee_transfer	1489	50000000	1	CkpYpyxUBSvQqcixTotSf4XfuzahqHYcxeYpZo8HnwoATGc3xKEAX
608	fee_transfer	1696	21000000	1	CkpZd3uQzGg8bFE5pmfVkHSun3TSZYcshnP7eniySnLozbdQoAnU6
609	fee_transfer	1685	21000000	1	CkpYQAJ9vqCUQH4NL8wiSEfPyZJtKsiB3TC3m7v9aD5da3kVrSggx
610	fee_transfer	1716	30000000	1	CkpYbBNkbkWdxdrurPKtwYhxL12HskzrwTEAVHF9rh1pWFRVoZU5q
611	fee_transfer	1690	350000000	1	Ckpa7tdCDYcTPaZFGuRE5rjU52KWhUJd8Ht6kRDyQdVZe2wJLMxcL
612	fee_transfer	1690	163000000	1	CkpZSRdSRRGw2hrhQW4k4PqYdXDdCqUe2cx79DjewQnVGgDaPTKM7
613	fee_transfer	1439	20000000	1	CkpZZvHxEYguWenfL6dreuWouwF9Kocav1GEsLkc2KSt6C3wHetXD
614	fee_transfer	1402	31000000	1	CkpYmuP2ho8tr8n5ta7WXvf51J7Jv2C54HRJBWoovjtNtdM8K514m
615	fee_transfer	633	11000000	1	CkpZHTWcaqcdfW2HweETgFs2j2jSBA56dyYwqg1RjDCMjxNUphfVu
616	fee_transfer	1693	11000000	1	CkpZRMMvZQBB2TsHWLFgKWo2WKWc2TuLFhpAeFx8uNNzj8eWGM3tU
617	fee_transfer	1724	120000000	1	CkpZqVA1ZFFh2JFBXjc3BhnzFVj7uz7vC8XSqf5Pmxncsjf9N8qfb
618	fee_transfer	1690	341000000	1	CkpZCXmuQFqv3NGhNHVhuML95w12nBacxcL1qkVg9yANJTGTot5to
619	fee_transfer	1687	20000000	1	CkpYSsGAtG68kfDGPVqmYVhnTYSo8QLbXNaZZUShyzkNB23pzwVLS
620	fee_transfer	1714	20000000	1	CkpZNz7VEnUcRMRruo7ZX7oUs6WjZgbXxhEswx8CcRkPoztRfNcG6
621	fee_transfer	1709	60000000	1	CkpYf7rvQAcBXpD4S4cHhpYNJfh8z28Gm9yjedxxe8Rv9yG8x5AQu
622	fee_transfer	1711	60000000	1	CkpZQ947hpEyCsE7gxpzvFi4rpg2dL93vQM1qdjaP4abEs9W87dzE
623	fee_transfer	1694	60000000	1	CkpZnZ2gtUy3W3521xSkLWyseYNjKaghnQh5hTSWmgiZwmEewwuSt
624	fee_transfer	1699	50000000	1	CkpZPXJ7dh9pqL8MNhsH4eYuNhPWwedQ1QngkScXEEY3N9dTGteXe
625	fee_transfer	1700	20000000	1	CkpaBkgRfJmtuvJsN8T2rA6jPBtVpdHUhJ7Gvbq7Rcjp9LbP6n4KJ
626	fee_transfer	470	11000000	1	Ckpa7ogmGXDP7UUJRrv8me1DrSgUzaDBzuu5JGS3GgDxpHjUJFHdz
627	fee_transfer	1467	30000000	1	CkpZoxs1h5or1EWwp2aXeff8YEfU9oqkugiXpJZk2NEk9S9G2PRKY
628	fee_transfer	1690	541000000	1	CkpaF6yJ2kBoqRDgPogJWuAMDSbbAGeM6NAZ3nhu4ZVv5c5wwBiwJ
629	coinbase	1486	720000000000	1	CkpYo34Kan2tJWycvhSbT1czWdx7hkNCrXFcsJzT6txpzHqTCH8W6
630	fee_transfer	1486	20000000	1	Ckpa6hjwXsMsxJp9RriGPiAqyDntbFhBj2fSjWv4tRdpg9AXF34S5
631	fee_transfer	1623	21000000	1	CkpaH6ybgnKFW6RWadTd4zhpvVH5unm1vQa9DsFCHgkUV8bHj5xw5
632	fee_transfer	1694	45000000	1	CkpYuFQZgd2G8hKnxJAVU49hvfqfZho15B3AewFdX8e7D2WXdQJDi
633	fee_transfer	1695	11000000	1	CkpZFz1bnVDq38z3qGsQtpYFwK1RAa1koCvkZqDEeir7ELC9XLHbe
634	fee_transfer	1555	11000000	1	CkpYW2iqrn1N9iGFPWQCDZeTqh7krNfiCZUYQKgQGx8vzAZ4adTXZ
635	fee_transfer	1455	40000000	1	CkpaGGAk3SJdgKSmRCjJz4kZW9j47b1YYDA76ymaqnuXYx77erGoS
636	fee_transfer	1489	20000000	1	CkpZX3a8rthyoBvKi9Tsq8JA7HnZpK9N76h7qX1pZqXdP3SM7zREz
637	coinbase	1751	720000000000	1	CkpZWXvbme8k1pG21UpbgnVdTo9nGQM4W5w2xAyZw9fxvbXWqQXM8
638	fee_transfer	1751	10000000	1	CkpYRucXrPuiV3hGZspwiueSBqsPapWPGJbVVRR42DQ1aV82oELT9
639	fee_transfer	1690	125000000	1	CkpZtk1KHcmfsp46woiGWqw4FkSs62ymXb2DWRJcTPqR4t1kFiKyR
640	fee_transfer	1690	121000000	1	CkpZKv85iWPRAEKVAJBfej7kLq5kFm2UE5ih5UUTvbLomFNzcnjgY
641	fee_transfer	1693	50000000	1	CkpZF5b1Dz6voWKvroimizQPiV68kSNuShKTiK76vwpN9bKt4wWqC
642	fee_transfer	1716	50000000	1	CkpYauVJVj6PQFHeLZPeg8kqfV6Z7NcXLtgnKytMR5fGNswjbpCrL
643	fee_transfer	1546	21000000	1	CkpZkzZqmVbR2V7sTQEfRhxP41mKNBeDhtcdrFCdyLqTYk6sePic3
644	fee_transfer	1722	11000000	1	CkpYccq82aZSFbbcj6F22RzdFbp6Qi9ApD4VBQKt14FNRpm1VuFRm
645	fee_transfer	1687	11000000	1	CkpZj3VsXRfHirAyvwjcy8gi3v65H1ZXQFZ1RbBG6KGEafFAuAqWo
646	fee_transfer	1650	11000000	1	CkpZcnRDBTZBJ7yJdxdHGrSitUmHVu4jdMptjRya6V6sBTyZg1Wjs
647	fee_transfer	1690	250000000	1	CkpZFJcceCCWjPqRgXYX7w1qwhzc2aUq38SGGFmABRgYgpZthSqws
648	fee_transfer	1689	40000000	1	CkpaFZ4do3bJ1Aescq8dAQ91CuRZnTkjZ4bMhYCERdwWfEQQXNoNi
649	fee_transfer	1601	40000000	1	CkpZF6RMFaqSUk9e4hvLDhRGoVumARPGhLxSCxswQ3m2ztAVDpJpV
651	fee_transfer	576	20000000	1	Ckpa7221vbbyA94uDxmCx9RoMo4o6iQmWp3RGEFNcv5gmPFxZRMcJ
659	fee_transfer	1541	30000000	1	CkpYpUubgB69DR14NVkBfiukr9xvhGQRdzwfXAv6EHnktzPu1wvBj
660	fee_transfer	1422	895000000	1	CkpZ8jcCDTtDo4wZwSMVoJkFGRrztUSrbBKgWSS96DkbdfGEumk5k
661	coinbase	1422	720000000000	1	CkpZpWCbjbHBYj6kZ32MUmWUNnQZKEEv5QvBemnStnVT8FKHoRynL
672	coinbase	1597	720000000000	1	CkpZ5jsyXdadG2cU4tbT3Ssv395iaPav47DycCskNVaDjJtchqinU
673	fee_transfer	1597	10000000	1	CkpaHUnZwELkCQak31PgeQRQto1ddnC7hPGoLjBZsYwPhkGe9SRbi
680	fee_transfer	1445	40000000	1	CkpZhAyPCHnFsi3AiVQ7sPUbbPdmhkjWXpsYLPJiK4Vsn97JQjLoP
681	fee_transfer	1634	20000000	1	CkpZsZH6ivBL2HVaopceVg4AKHCZ9wwR4TEWYdmdKQXavmMZ89kvY
685	fee_transfer	1656	40000000	1	Ckpa3BHUGoxB8nxRi4KAyMkxpWgo61CPDLTKPCSKgwtcaVQoNo4rz
686	fee_transfer	1555	40000000	1	CkpZyynxwRcC8YmH3tUV2N8fqiPbHYV1kTTxiqVbDedeJMCRncind
694	fee_transfer	1678	721000000	1	CkpYVfGXMx4rgB36soBm5VpxcxqgYazLR8MCJFHFeMS2w2E49ujn6
650	fee_transfer	1686	50000000	1	CkpaKmLx9qEHTHXR4ucoQgzK3zo8A95Lk9JjRhHotVCmWmhcRwy45
652	fee_transfer	1690	400000000	1	CkpZx43mGqAZMQGCKHHXwepQb1znA1o9bdFkDVZgwKG3UYoB6PhUk
653	fee_transfer_via_coinbase	1667	10000000	1	CkpZeW6K2z1jooq4H9Cn7jZusv8JR78bGrqAbLoBrzrsXi8WeVDGY
654	coinbase	369	720000000000	1	CkpZVy1vq2AjR2ZerW9meBYT689UnDYPpeT9qWVCfFqNee6WefeZ6
655	fee_transfer	1711	30000000	1	Ckpa42pCRJrxXJHLUvDSxgrnitrNgRvFzeDR6XCmuPSiRtFWGsEuv
666	fee_transfer	1684	110000000	1	CkpYWtVJomqAATg2fucmZwJEWZpwH8oESzUZyoc8BYkjsi3mBYxdc
674	coinbase	404	720000000000	1	CkpYjuzq4SFfch4czFuy5XigSATEMG8A2sw2s8EMtyJWHm8EKMvRh
675	fee_transfer	404	20000000	1	CkpZbjccXq4qG3dLkfv1r3KBxMJ15cwwVn3q9c3rJAFhPjMij6BC2
677	fee_transfer	1690	50000000	1	CkpZxBjfUedQzLxRThk2ohicaaW3to5CruYFaJ2DcapnKDfTQdotn
682	fee_transfer	1724	130000000	1	CkpYey14CGEyYp9wzVDAurWVJ7KJLTwP99XgDDwBcKCWkEAgf2uFc
687	coinbase	1420	720000000000	1	CkpZCiQ6g9kZxqfpVcKSmPTDqom8mbUPU9NHPdac4tHEwNMjKC9L5
688	fee_transfer	1420	10000000	1	CkpYg4X7XZJP6sZc6dh5FwVGzthzAQsMkqPwhLdTSpJwywCjsYXGf
690	fee_transfer	1724	310000000	1	CkpZcB9nS18yMjEeGKC2wm6hX5LbSc2Morn65yNV3rnNS3mVYrD4e
691	coinbase	327	720000000000	1	CkpYfNwpgiDGDZvDv2Y8eE1MSzdX6Z8w7UEexX49qYGkAwu3X8gBL
692	fee_transfer	327	10000000	1	CkpYQXrYJnK1HCEMYrrTKJsjkiSZdP8nugUPRDV7KqWpVNnaBvA9q
693	fee_transfer	1611	20000000	1	CkpZuzrdkbc2uL3ifC81i8noxiy6JUt5dLt363983GxMxxcNcELjh
696	fee_transfer	1709	20000000	1	CkpaFm9ujU5g6EMcUTeuDcT5bDw2dr8bJXtiRw26xxiHMLcoX9oCb
656	fee_transfer	1522	20000000	1	CkpZyQMbARAcJQVTMuNee5o9vUXpamwyBqpP97YFRpLWaSLagBTCx
657	coinbase	519	720000000000	1	CkpZcy3XW1BPi6CGyYJpGYVzYt1zf1ab1JHdjdeq1ZVob1DJNufh6
658	fee_transfer	519	10000000	1	CkpZs34gLt7n3EwstLU7HRjPhUeqmUhoG27vyFNrNu16PzePvha8d
662	fee_transfer	1560	60000000	1	CkpYZLQnVmfzKztMLkTyawNpiScqKvucVo9uL13acWMzg4SMFJCBS
663	fee_transfer_via_coinbase	1440	10000000	1	CkpZiiFnRUhnfFdVAjFjadbZw7BdkYgv25udySJKJzhZCPqyU3C9C
664	coinbase	1560	720000000000	1	CkpZzLAuKQovxLe7D8fm5oBufzE1g8JEpNgkc3x4KVEq9oaSEYqzT
665	fee_transfer	1447	20000000	1	CkpYtXCojr6LR8WEPGypkCoYcjz9FaG77Dbs6vr59ZPtyVbGDGeh2
667	fee_transfer	1678	965000000	1	CkpYu2Ws23rcwzzb9ivwDBP7m5qRBUcCVPSRgJm4fSvZedkJNdDxw
668	fee_transfer	1678	300000000	1	CkpaCrZRtnBSPDC5RBvvosxMimdLixQCooZV4bo7mqjL3wYrzuKE9
669	fee_transfer	1422	40000000	1	CkpZQmaCuTMbequfkYFpHosx4YfaRhnuKnD639GpAiWqNBzEUy8xa
670	fee_transfer	1681	40000000	1	CkpZdcM3ZA7eDLnxLGJfc36yCwUZh8yaRYAKxuwN15YmSN7a3ACpM
671	fee_transfer	1690	430000000	1	CkpZRu1rmVnJpCPLaUJXvxGk19zbRQ49Yk12dmiQd9oFXSFzGM3dF
676	fee_transfer	1690	120000000	1	CkpZtSRHAo45XXfU16Xn5QVgY9PHNLSvsVdd5FHQ4FdCcjH6oFwkh
678	coinbase	1662	720000000000	1	Ckpa99mQMNuW7rMPz6FTZG1dPrN2zpyKnE1Z619cJYrv6TP3gEBm5
679	fee_transfer	1662	10000000	1	CkpZm2RM56v6jJaQHAanDZnSZHmFav2B4gyDv3yhmioNmXt25dq7d
683	fee_transfer	1547	20000000	1	CkpZNW3KyKPH6bBx7XpHiaRxUTbyUpoujtPvLFyv5BMB7fBgG7sp6
684	fee_transfer	1680	40000000	1	CkpYUV5PEAedDvLxFPwydUKZ1ovZY783BwBYBHQeji4Dta2m25njH
689	fee_transfer	1690	80000000	1	CkpYa3CsKCRS7ZPeMEELgfRph9r8UB4DTfmuvCTCdobi6g4XKz1Pj
695	fee_transfer	1536	40000000	1	CkpYY6pjBL78ax68ZtctwZbVPX5eDWXHavdXnbZcQStUQkKWuxksm
697	fee_transfer	1593	20000000	1	CkpYWQkUFAArsMZYcySz9Btmhj3LxnGfw15Txwo456M3kzGhAA4hX
698	fee_transfer	1724	110000000	1	CkpZceKACPStVgTEyhviAFegrgnXZE8GqTPecjZrJTVzR8tQt4FDm
699	fee_transfer	1698	40000000	1	CkpZ1Ed8Eg8wkefx9x4Yj77jZ9GJna3cpSLK1KX2rbqhUqutyxF5p
700	fee_transfer	1724	90000000	1	CkpZD9at6Moq8Siyfpsvw7jWg3VbKb2Vkd4iQ1F7Qg3zwUsELht7U
701	fee_transfer	1735	20000000	1	CkpaGZ56YgjC48V3JiDqGZYXuLAnq4CUcww7zvWoPn9LGAqJzXR2o
702	fee_transfer	1656	20000000	1	CkpZZECzGW7KfsTEZUKUsBnH9xnP1ArBAkZYzninSwtYmDMQUZUcS
703	fee_transfer	1587	20000000	1	CkpZzU9bXMcht3BxiZ3dmdC5KZMZjKgtXE89JbfNwupt4DWhUsBmu
704	coinbase	1755	720000000000	1	CkpZeA1E97Pdgkfup2ssuCZqbSbvyB1GGUtE9GtEmoZNQty3ww2SJ
705	fee_transfer	1755	10000000	1	CkpZDUsUgccF4dwbBhBYDT31t3ErvXyotEvfwV2VjeRY2tHZdpX7a
706	fee_transfer	1426	20000000	1	CkpZR2x2v83ew6hSW2ZmCtrp2Zzmcx1oV1xkPAY6Z5x8uS1jd77rS
707	fee_transfer	1637	50000000	1	CkpZebfb3szQhLm1T6oiS8SQqM8a32Y4yqE6CogE6eEjCkpb33wJe
708	fee_transfer	1722	260000000	1	CkpZHrrFNW4xjP24Vfr8AwU8kyM5qHV7BRzCH64SpD3VGXxha7vYx
709	fee_transfer_via_coinbase	1505	50000000	1	CkpYWGaADPg4nrxBJiaecaiV5MTRNP9pUSnM148geYhSn4Gn89nvR
710	coinbase	1722	720000000000	1	CkpYYbQ3GSa3HtLzD448pVSbJBFRp61fT9uXPnoCegVYGHXThin9d
711	fee_transfer	1677	120000000	1	CkpYyXTHLjYB1vqMXBH24jeRB9SAo7JYqe5eZsnDqtCbf7PeHjHpp
712	fee_transfer	58	120000000	1	CkpZfQCMsHwvyyynQnMmc1BNLAXCzjUfbhcAC1SremRugVxVPWQaw
713	fee_transfer	1692	21000000	1	Ckpa28imjvBrD9qXch6H3J26vPmJpx3qgutho2VHm4XbY6kwx5VPR
714	coinbase	618	720000000000	1	CkpZz8JF2sWFmWR7Jd6xstrzesAn4TeLncnE8EVuj7jVNCj7mHZdC
715	fee_transfer	618	10000000	1	CkpZmgv5JPepfUbYbuEMrageh15y9jVtKet6Lg33vpuVwqxARxkYX
716	coinbase	733	720000000000	1	CkpZDSGJRSmBCVvGds2EuWuhUCz4cHpdfXf2gu3fujZPjcSALngFN
717	fee_transfer	733	10000000	1	CkpZr8jUQFoFpHT8Qem6SBpP8pKHyHpQCEbuidBxjXhpozuKqwoEo
718	fee_transfer	1706	20000000	1	Ckpa9oiRqbyizqzgLmreaYpYCKCF8qcPZHecFF2y25qyBRsejDWFm
719	coinbase	676	720000000000	1	CkpaC1jFLHHnhxi8anzzYYbmq23mGgPTWZ9o61sHakxtkb6KLHRXd
720	fee_transfer	676	10000000	1	CkpZR9B1qTF6hPzDn7Pi7W4js4mxV5RVT5fEh7FXA8W38r4ByeG59
721	fee_transfer	1622	800000000	1	Ckpa33WtXP3hyS3mVdBeVZvangkrbvbNaeu3EVACcN8c3VHDtASNY
722	fee_transfer_via_coinbase	1449	240004599	1	CkpaLe8DeJao9yaw1ZJZG8kXpQqMZZUcEXENEXRZPmFv12pGzh9H9
723	coinbase	1622	720000000000	1	CkpZ4ZDsXsDSXVKTn9qY3JRaPD2bA8S95ZzcwrvfcWro3aNxeGWXr
724	fee_transfer	1708	30000000	1	CkpZjFSCvZLvfyZg6AikRVVjFKeYRfBv5NZ3PHf3CmaH7eioqLjnU
725	coinbase	510	720000000000	1	CkpYSefkaBnP3WgCy6yu6jqWUPyA3f6ytZcVs5PBHDpQkkaL6t4ru
726	fee_transfer	510	10000000	1	CkpYhiXtghPxJeg4HMBmywyR15sq1cHrLiJmNgB2f79wJ5h7euNVm
727	coinbase	1429	720000000000	1	CkpZYewPeXVCUS9y59r1cFqZdMWVDt2UYh68HF2DHpvmhhzoLtz8i
728	fee_transfer	1429	10000000	1	CkpaKbv6yAqKiVYMFwxMiXFrYKGGbpkrzrYBtHaqQmBSNiRhFKXoV
729	fee_transfer	1564	20000000	1	CkpYtycbMmCZYGsMZaF93zvtcMKz7aMBpuswb3kx9wvqR4QEbYhrt
730	fee_transfer	1719	30000000	1	CkpZ3fgwQvtXb74R7Gdt55h46jESUhfbLU79GpKVuC62DPPQA1Grz
731	fee_transfer	606	20000000	1	CkpZwy1W3GkPaCDQpp7caH1SoaektQSfc9UfaSPcTuuF42Szbm5e9
732	fee_transfer	1489	30000000	1	CkpZpojdS73WMx2ciiyFWiGhmPUTqgMsk4ccZDHDeMScUvmaSf2QK
733	fee_transfer	1522	470000000	1	CkpZb6FRkZLrckhgEZrVpXkCfnvfdZiEpXJYDWz6ANzCeVQ4aT7Bo
734	coinbase	111	720000000000	1	CkpZPfWbkh26khpSruXKR8kMQF7qy333vVBAVDvqunsREDVXTyX3b
735	fee_transfer	111	20000000	1	Ckpa5GxcBeCqARz6121ofW7ugpJFWWCZPkBZ5zg1xQJAMb6pgGLac
736	fee_transfer	470	60000000	1	CkpYh38f5MEWKpbZA9URzna4iEoZRgvS9PdLtnADLWVp2JLCFdwyR
737	fee_transfer	1724	420000000	1	Ckpa9y5soAVh2QyEqZ3rqUeVbyW2QkRArR6qsrNUurjpfARbq6KoQ
738	fee_transfer	1724	820000000	1	CkpYThnEdGFifCUwgNoVcY6bVvrFmiKRp8YSdY83Ukbece7R1bSd3
739	fee_transfer	1682	30000000	1	CkpZmpPiQNETv59ahKYbQAcQVmu8AguZq2SfYbna36Ci3bu2Aqvhe
740	fee_transfer	1588	20000000	1	CkpYvDaoKbwiotns4QgtNiuCE5gSX7dwWW8Ym5sYFdWWRiashTcim
741	coinbase	162	720000000000	1	CkpZgHBYfZCkgGzr8LXb13QH8ofFJBEYdZSoX1tmE6ZiXJKaUv13J
742	fee_transfer	162	10000000	1	CkpZXJNwWPviKWT5oya1NLqdnH7JATbXNtk7SW5urjtun76wCYftR
743	fee_transfer	1643	810000000	1	CkpZTekkfRb7ZXx31sFJiJYv7xavXL1KUXzZ3X86uh38CKYu5fYX8
744	fee_transfer_via_coinbase	1737	100	1	CkpYWUTrd2YqdSodDUHTNVU68SMZsjYWqaxQ7Bgs71Nbix9UMHUhK
745	coinbase	1643	720000000000	1	CkpZghxqaoMgWqZYmL4v1RjGukSQtfGgbUADgQVvjAg6ASYdEQ1xM
746	fee_transfer	1549	20000000	1	CkpYitQzAw3FBfiHBLxpQoNb3JYynVNQUApndLjNeWQHRgw8nEb7m
747	fee_transfer	1508	20000000	1	Ckpa4wCS2krPYYbiZE1uDpBjd4nMr3wAYiryaomwLAPEpFfnKVVBY
748	fee_transfer	311	19999990	1	CkpZLUVZ2tjf4vJtfqhb96RPit6M8aybGCEn6WWevcxMd8HrUKrWE
749	fee_transfer	45	10	1	CkpZb49YGQyQLnwpo3oNLc7nqu8zTdbPPKJ56eQcSV1j3jyviFrrG
752	fee_transfer	1623	130000000	1	CkpYQHSXdxA4R2ysJgamK3vg1P27uA6NKtiWKbuJdkfhHCnvVSTcV
753	fee_transfer	1623	350000000	1	CkpZeauVJQkW8mmMuSWkPs1uFu7MGZDSxPJQ4vRUbxrsayGjm2FYN
755	fee_transfer	1727	20000000	1	CkpZhkwnBCsiWipWtahmEQXQriZcdzfZiEYdzanEaKUufB2TPxPnt
756	coinbase	1757	720000000000	1	CkpYpV7b2mXKS49wmhn2xaWTTLmxxMGsB19RewK7KKPW6xHDT7NDi
757	fee_transfer	1757	10000000	1	CkpZS3o2uRJ7vznrN8fep4bpmmHByoabJPF2RiWSiDsp4LimqUijt
760	fee_transfer	1456	20000000	1	CkpZbDAGje8XDF4yNp4buP3Twd6jRJDLrpAHtGfZAEPfnV6SnqDwa
763	coinbase	1466	720000000000	1	CkpZT79s72bEwERHrmu6N3XzjWbGSpUYeHAnwgyNAdqtdo1WU76gJ
764	fee_transfer	1466	10000000	1	CkpYiUqyxHT21yxP4RPsFNWk4iKQE7Mbic4vQFMdHGv655WL1QN2m
765	coinbase	1521	720000000000	1	CkpZzFxLR9X268Pq4ReQqfQrr1JEmGZe8Fyh2qGz1c6hR1r1siYNE
766	fee_transfer	1521	10000000	1	CkpZMdBSysJgrLQeBq492g7irQY5oaHNcHkE4oFRvdn9smMEExCN3
769	fee_transfer	1708	20000000	1	CkpZ2Qf3kEcz8srGrh6yBWLF8K8xmAUCvTftrV72PinM7EAp2tR2V
772	fee_transfer	1746	110000000	1	CkpaL82DChBKHwYeEErY8W1dLZLiHhh2vc7s3DuZFE3gS9bFecbeT
790	coinbase	554	720000000000	1	CkpZVKuyV8PSaPgEF58oyA7b71WBXnEDnuYbhmpkXzq5vhYfzktSB
791	fee_transfer	554	210000000	1	CkpaHGoHoLSsjpfqPUJ1wjjmC1qcD6qtgqvyTPjXCVEeSSXjkyCP5
794	coinbase	1643	720000000000	1	Ckpa1gGWQbUWgFyKghTjV2sQyQpszrGrFY8xMWRwgbmstxdKMsGks
795	fee_transfer	1450	30000000	1	CkpZRDD8DqfMRWkC3zRjb2sbS3GbrFHgLwp1y3qJ2gTUCYVbJBKYR
798	fee_transfer	1675	40000000	1	CkpYT9ikxvynpc2nPkvfPqjMwDR35C9mNVB9rZkDgvadmfQWCxAr2
810	fee_transfer	1596	30000000	1	CkpYnvCgrBhNiaxMNrLLRGr3TKs4XTdDnQnVGY2qGgsbe5w8vnge7
813	fee_transfer	1746	30000000	1	CkpYXhn5mR15Hi91AZSDT2CfUmvhDEc846NvXpwz6QGmQrcazbTQK
750	fee_transfer_via_coinbase	262	100000000	1	CkpZNc4AkYUbcXXg95bAS6Y3kniqU4mex45EJrWZvJwZ4JKMPysM4
751	coinbase	311	720000000000	1	CkpaCqB1N8FpcahoyXnsyafLvPjdRr8wtpAfdQCAAttVP6o2dBZwg
754	fee_transfer	1506	60000000	1	CkpZHBYdPekDytEJgpsP8XboHe63Qqr3Po4L49CbW44ZbQ9MJQKLt
758	coinbase	336	720000000000	1	CkpZ49nPe3vUp9U7Ef9MkojZUhZY1WTP1bYghXpkVew2c6WMf9o3S
759	fee_transfer	336	10000000	1	CkpYh97GoMMNod4nYqv8BAZ2AyopCTctUCyT5UuWRx6wMXj3gRwCJ
761	fee_transfer	1740	1010000000	1	CkpYSZNWz2sw172T7RKYFaTUdRMHh2WpUyhe7QFeWLydqhw1wrSxX
762	fee_transfer	1740	240000000	1	CkpZu64FHAGvYm4vXGb8MPgmDDugvGbCdC6gb9mmHkfThax7ZNoQT
768	fee_transfer	1746	20000000	1	CkpZL88iexUXk4dcFJ3ApBUPLTEXUaTgsfjbszsd5cPuQmd31pyjL
771	fee_transfer	1747	110000000	1	CkpZ6ojMmj9jAg4hsHM6UdyBYShKTRAUKLUhnT3P71Xzoe7xS7iXo
773	fee_transfer	1423	30000000	1	CkpZzqAgBcv7dE9ijuxdDRCui5wsXPKfADzaHLAMU2NQbX8eFuELs
776	fee_transfer	44	9995100	1	Ckpa74jZ5q9Rr83BJ36MaYJQBEWY2wKN59jVpwPnFMCnjQkQQqo7s
777	fee_transfer	1514	4900	1	CkpZHUpn7Miyk6QV4STSKUt4AYrSTcuBGb3q2MiqHV4SzBGYguAX5
783	fee_transfer	43	710000000	1	CkpYjZwMMvdJ9memQJFCFgKZGwTcaweHWQ7GFNMCG5N4mRfRfKQPP
788	fee_transfer	1722	110000000	1	Ckpa4oqf5Ztqqat1VQpb54ariGy6rBUur6dECv4sZAPoEYP71hk1K
796	fee_transfer	1450	10000000	1	CkpYQUpsnVNEzYx2KMxiAwdzzPkLfQ6oG2znvKkCXW2UXMn4HDjxk
799	fee_transfer	1737	300	1	CkpZUDdLv6sZdV3bRfkMzgo53nAysyKgfzUxxoaa6fvmFVkXSc6Cg
800	fee_transfer	1643	84999700	1	CkpaE4pRStHTx6sVdzcn8fyYbwKkj6SBvxH2dV4eP88csiZJ2rp5P
801	fee_transfer	1650	25000000	1	CkpYzG34pdEmD6E29M61eTwx5EHMG5CvBDNFwptDybjRmQ2Pf1Mqc
803	fee_transfer	1643	40000000	1	CkpYhS5MuKmsosAC5yfUuGzWysZpCsrRDzpcKg5VKFv7NG41KvAs7
811	coinbase	1622	720000000000	1	Ckpa7kedpeM1eC26Y3KvZiGqzsV8U1LHU9U5zTnJD5Fun4de1ZRXR
812	fee_transfer	1668	20000000	1	CkpaJJNwh8GvZyCYPUNASHMwBkvYJXcA6H7CqYiEsQbDfahn2gvzC
816	fee_transfer_via_coinbase	1580	10000000	1	CkpZ1nf6bXbhKgf46UJbrkFQnUxwFmWd9xHAPBAz752hbN9geCmcA
817	coinbase	1679	720000000000	1	CkpaBLFmpyJfYsk6LwxVHBFTMfHr7JwTKWEbi6a6kS5HUvZoVEaCc
767	fee_transfer	1747	20000000	1	CkpZUDk7ztnFQpHNkguvaRPn31kMNwLhQYam8Ra3RykPvcQiVWTZ8
770	fee_transfer	1704	110000000	1	CkpZXXuvwkmoMQdYNeL6RhWUZx7UQ94p6pFQt1bUMf2d9rwAdBtE5
774	fee_transfer_via_coinbase	1537	10000000	1	CkpZVTtLNUMe3MuB51TSVPZ2Tnq5wQb31VcVYPb9E5NSuEaoWBR7Z
775	coinbase	44	720000000000	1	CkpYqYkx5WL3bxFLAz6eRXK1jT8wqpNLbMK5ZQDRNsnm37M52WEjy
778	fee_transfer	1698	30000000	1	CkpZtVe7RjNPV2sLR3ezeCVn4kGkWEw2zToA9b2BGyhDW7DmyH4ds
779	fee_transfer	1737	1100	1	CkpZHEQA7hgWjp7fS2xY1Sj4Pb2W6PXic7Y66fJVfNeHe5QW7dnf9
780	fee_transfer	1643	119998900	1	CkpZMJmEtNPZiDCeqtDJAsYrQZggnWuN5a3M7pAq2txCkgCUahe4n
781	fee_transfer	1650	100000000	1	CkpZtgopHKfMHjfNzoHjZ3oujNKxM3NX8qARRFCZhamd3i4z5efDg
782	fee_transfer	43	30000000	1	Ckpa8cPVa2vP9j9kqRRgxAMLAU4FFnXM4yMj4oY4rBK6LuhEuNzxq
784	fee_transfer	1506	30000000	1	CkpYRKf2WbkJaB2jaHwt8UFQsVGeXR2To3Khd2H5eNMpGpMM5pLfu
785	coinbase	1618	720000000000	1	CkpZS9qY5e3nNjA9b1gSuFqugvYFhSCHNaSiLwPYypew6C6M5jhDm
786	fee_transfer	1618	10000000	1	CkpYicUmLYcsLvKCq1KhThdocJhiuh4BB4cB7UJfv2cyBeyyrnDy1
787	fee_transfer	1685	140000000	1	CkpYqxdpBVuJZAmDa5bTL3WofB6yDx6kegN3MnFxRazGfQYqFbPMK
789	fee_transfer	1607	110000000	1	CkpaF68sVBk6MrV5hnHMw7kppNQKvewqpYxuKDJGqNSDgGA4ruWaR
792	fee_transfer	1683	110000000	1	CkpZzEoiYzzSfdjKtbW24uHqzEtp3LX3aYJ34XMJLUtVfyx5BqX6y
793	coinbase	1759	720000000000	1	CkpaDcN9Yp3LHpXYBtXg3dcFq5RAfvmY17kX6KerjaEtfRE2xBXFX
797	fee_transfer	1643	30000000	1	CkpaCAXF6Rd9ot8cA6aQpoUk2PtvaRVDXqtUUT6YQ9YkJewa17ZE2
802	fee_transfer	1521	40000000	1	CkpZ6ZL5Ks8isBjNTL4CmXun4KgRiMDzhJP1QbWoSeHb37jTVuUPy
804	coinbase	1470	720000000000	1	CkpZYz4QKLX2qpFtnoTikjbBFyjFRLM4jEquwXMJeo2R65AEyRB2z
805	fee_transfer	1470	10000000	1	CkpYmUCLcXZbDhF2RDBrvcT3zzvjjHZsiFaJD7Pcs47Br32qHtBYH
806	fee_transfer	1555	280000000	1	Ckpa98xWbHPTvazSdW5xvvcGQyxowQMeyUgr4wgkB7f3uM4pFZzKq
807	fee_transfer	1546	1030000000	1	Ckpa5DTh7pDo5qpRSncFkmPpA1zw5zXRuwyPWMJmo4FAL6Wk1kxvx
808	fee_transfer	1546	400000000	1	CkpZLWwson1sgAgXam2BQXGC3wrPGdopkDhTJ8M69oCCi8htRh6jD
809	fee_transfer	596	30000000	1	CkpYVprkqHgC7fZPGX1m74HBBRDUbZA2KuEnMZCF65JCpP7xK6DrG
814	fee_transfer	1419	30000000	1	CkpaCcysJTTTFzx4eJ5fTPNgToSh6WtrNNezyS4uWtaWuELUtjp8a
815	fee_transfer	1633	30000000	1	CkpYr9E4co942X6N4ADgwW8g4WLToXyetpELQhqB4pPSMmcTuCWc1
818	fee_transfer	633	9999990	1	Ckpa4sSidr8rcjeZxJ6ZQSzvBBUBvaGRaWLQtvSnbBAZSK6yBLbfp
819	coinbase	337	720000000000	1	CkpZ3UjkJ5iaGFGcJQ5qDj7mrLvRk1BTcByKGje9YEPuu3HqRzbsT
820	fee_transfer	337	20000000	1	Ckpa4k7v8QDELKRPpmV2Z4FvE3d61r9rWVtH4VZgm6sGhHH9pjr7p
821	fee_transfer	44	20000000	1	CkpZTDnwv4p7dbSctKai8Xp1D6Zmx95GmGEytuxbKBSRL2gXonAP2
822	coinbase	441	720000000000	1	CkpZzFmgTKw7ccuToJwtRYi3gBEoRcqRzL4ar841g8tYLZVEKZDcm
823	fee_transfer	441	10000000	1	CkpYQ4pLUgHepYtoEZQd7V7tz7j5uGt2GGRqhNAtvbfoFuk5amkGC
824	fee_transfer	441	490000000	1	CkpZWKV19HrMTD6eeLy6M74XjUXnNfmsFzCoeQu6XFTcqiKKXgXrf
825	fee_transfer	441	940000000	1	CkpYU5yrpoR3xmrmeiwkMBetqJ9F6vhQBS1UsDvwxHKvzFnpbTqmN
826	fee_transfer	1740	30000000	1	CkpZxCuSGvNAKTZapaWFWnGASHLQaJEL1Hq7KUnCCkoCtwDE5wGtX
827	fee_transfer	641	30000000	1	CkpYSbJsnwP9JhGQP2ieZKrfviEKwMpdESvLievjnbgq3ipjzKHGu
828	fee_transfer	171	20000000	1	CkpYQ1XnVDrPJsCaq1C7XZ3mkTRCUaLkBPJP3GThDRZfLYHvd2FNg
829	coinbase	1606	720000000000	1	CkpZwCPX1g7YrcxPzarNoaZUZ3ktnZfZDRQxtGq674E8kssUVwV2o
830	fee_transfer	1606	10000000	1	CkpZ34dtWGwPXVqw6MHty9YCiucuCM3XzW53n8EArEHSBpAA9NkoM
831	fee_transfer	1700	110000000	1	CkpZ9b3GUhGCDsyyPVRi5PnfEAKnSzB7USqSLmu8SDfakNKaMP1Ej
832	fee_transfer	149	40000000	1	CkpaFC755Qzw2bwKBzv2YY28DxF9LL5S2gPHQLWPACfiPBePijXnn
833	fee_transfer	1673	20000000	1	CkpYknsY9a2yzQFCuDGXZNEYEot9GvqE7tKeo7YbE19QMQu8fukes
834	fee_transfer	1649	30000000	1	CkpZ9rT656dg24CjPvCMXfBcJXPBqFBXab3XrmbSmQEzXB4igyync
835	coinbase	64	720000000000	1	CkpZbu2RtcixeKaMkbEbFSCyEkbUKPGm8QnFnRE7k8GP1dCoZqqL3
836	fee_transfer	64	10000000	1	CkpYxkddANEzmK2FTbVmw5RxpRpQkiCoYrDvk6hamtquDDqJZYeBv
837	fee_transfer	1422	30000000	1	CkpaGVMSZ6PsuvP9Hsxwb7DYDvsviQdz5bojZr5zayfsQ8MC7kLyT
838	fee_transfer	1467	20000000	1	CkpYiNGAPHznFzGKxLswbF3beppNiyFaEaMK1bmhHe5cowL2PpDCF
839	fee_transfer	55	10000000	1	Ckpa9YFqijJT6JUbZ55SgLB9JJ5b1dvhTjtQSMFjaoHdJ5tjFUJ7X
840	fee_transfer	1715	50000000	1	CkpZLMijajX1c7UHzTyzmtb4smjuMU46WsSaQ8ogEGydsYAR3ekjC
841	coinbase	1762	720000000000	1	CkpZwcVempV65ZvgsRh4UJVJoJtvsUxYxcEH4ea9RbHtyoDaar1oY
842	fee_transfer	1762	10000000	1	CkpYrHeQLkzyfeAb59L5ktqgKDDKWQGru3scHw7g778zy2tTN1fdL
843	fee_transfer	1716	1070000000	1	Ckpa6E9LjUBRXaCiNwcU2PmHqEKyPdzSRXEEighbRqhYsFgi21VPB
844	fee_transfer_via_coinbase	45	10	1	CkpZb49YGQyQLnwpo3oNLc7nqu8zTdbPPKJ56eQcSV1j3jyviFrrG
845	coinbase	1716	720000000000	1	CkpZ6k4JGzoWwP4zejvUPLGXNyUgJwa9ysp7Ex11dPR6XeGSRFZzu
846	fee_transfer	45	280	1	CkpYT3t7ygQNFEdjkBFJvR5SWRkz4U5x5aPHEJ9yeW74t6aMEskdu
847	fee_transfer	1716	39999720	1	CkpZkkkFPaNBfTaeE1ufugKRGHYB42fomZAbka7bvrqmViEYc88yb
848	fee_transfer	1700	40000000	1	CkpZAcJqJtqqoWomeneUpU56Lmrq5sn6systS5mvQ1nFF9NUvvrFh
849	fee_transfer	641	40000000	1	CkpZuxX7mFjaLVQFfmRRFZM2hqGrjQoadD6fuKhGYoueyRs3HX2oE
850	fee_transfer	641	690000000	1	CkpYnVR8gmfd7j8CAK3XFFgzk3TYZpt2uPekGLMPttHyZ8fmSQWAf
851	fee_transfer	1719	70000000	1	CkpZrkxzEVpgGJtXRAXHwAJeuS8TzRhCNDkX6Av1GkjqTNarLHLee
852	coinbase	1764	720000000000	1	CkpYnDwsKXZb3Naak8PLgoGiLU9Y4a9JNZWLwcSVwT7CzABwDSGUV
853	fee_transfer	1764	70000000	1	CkpYUm87AnCxEFviGzgK51vnGKQCmvLw2NK5RaunNVvE1BdgWagcx
854	fee_transfer	1541	20000000	1	CkpZxVQFZPWKHTaW7tHUAPehfhoPwY85nJeUJHBHUCPTFRDGnwyov
855	fee_transfer	1717	40000000	1	CkpaKR4yEWcuGjkfBoDjkqqp78tyFWqqMPuhTga8WuRUPCF6ChvVt
856	fee_transfer	1708	40000000	1	CkpYsj4AzbrhJ2rtpqxxmyvnAFS9bf4Xjq2PDJ4qjiQ6Baw8pLUH3
857	fee_transfer	1692	30000000	1	CkpYjmeWuUJ8pUv6kece3ugFps2oNbru8oScJCZm7yJeZMzg2f7Q8
858	fee_transfer	576	540000000	1	CkpZzoEevjo4D5hbjE98QDA4Ypi57BXBehp1Cru2aT2Qro7Kcjov3
859	fee_transfer	1737	200	1	CkpYVVQPjb9FMKFbmPriTCLadziyCzKuSp9H7MkfLqDA4K3JDsJaC
860	fee_transfer	1458	2798540	1	CkpZUFqPfAppMBEjFvTYqr9QHDAweT7snx2i58VWLvEAFUtqFPtKg
861	fee_transfer	45	660	1	CkpZfPYaHTcHsJAGVgxgXmUjxZqyr9AU3y63ZACK8ESRr6XLLRk4u
862	fee_transfer	1515	4200600	1	CkpZ9fRxT3xUN5NKxWX2uCPVh1xUcsfC4tB7UoRUEM3ZWEaLLN6X4
863	fee_transfer	1758	400000	1	CkpZG6naMZhwYm4QAxzwbJ784vqTbxvbWRpoAXGLXE2KqctrX7dLX
864	fee_transfer	1492	12600000	1	CkpYcH6kCepDh7hvcfiBgeNWnoeCSAYkoPbW9cYrHFhbdaYtWjzgs
865	fee_transfer	1702	110000000	1	CkpZ4TX6ufYVeyWN4wxseLRYWs5nSdfsRHGnEmVdrfSfG3CfUKCT1
872	fee_transfer	1518	380000000	1	CkpYnp6GGqdaNZypWdivFsF2xsiHDujftn1ucGYTUhwgkw6w6yMiD
873	coinbase	1518	720000000000	1	CkpYXfXfiXcP4dhT3bADrnVbpcPKpUQZn82APKzL7hfV98RW64FTA
874	fee_transfer	45	20	1	CkpYtPAe3YC5NEMc64nTV44CqMhxNKiJxJVG6M8FY1qwZi6XLLKbt
875	fee_transfer	1518	9999980	1	CkpYfRtAJjkzc8vXTDx1pVy1KoHaGZ3Z49RDc2nXVCvJrWdhmD3rE
887	fee_transfer	1710	20000000	1	CkpYqdhgFB1JfAwLG3HTAopWdZrWPx3R9NoMdefb9Ch3YPUY3TEHV
891	fee_transfer	1699	20000000	1	CkpZD5Jpu3KpbqQWifcqh6cjvh5SPj1FDM1cFeMRAMCUKeLyU2aeQ
894	fee_transfer	641	50000000	1	CkpZFLUSg6GY3EfMVYqcQ9Rpn65VrXYFs1fTve35DPPepo4uyZW4N
899	fee_transfer	1710	40000000	1	CkpZKPy7zCrUsjSnugcbDXwsy3LedtdJ7CNmp6R9YnF8A9agU77f4
905	fee_transfer	470	30000000	1	CkpYj9M2RRgZtzg6nt5CKhKsTGgTSvr3CAwxGxpKUP8FqHmwsS2tL
908	coinbase	1768	720000000000	1	CkpZ3X5ukCrpumLawhUNWJDkWW1vsUuLCEwW3MjqhGFwzMUuuKzax
909	fee_transfer	1768	10000000	1	CkpZ5QAhamjFkrGsA9J6wJoS4se8BzQ1mxKVG5pGd2pVLGk9a19VK
911	coinbase	1639	720000000000	1	CkpYjbutz3aHUcrigPeBDDVz3BUZWWcg9jMPYdXEFBPg29kg9PEGe
912	fee_transfer	1639	20000000	1	CkpZwJehZj3BN3kD3QpRQ8q3ZAYgvSCYxryLETSaQTNdeuZWv1CtC
927	coinbase	1540	720000000000	1	CkpYkGYGHnJn6hGTGrzxar6Jyvv4CsSFLgRaoqRww9GEoUPpnHB5A
928	fee_transfer	1540	10000000	1	CkpaE8XeD998fD3rqRJEaZoaW7DokvqgmUEfXXpaesnxeMfWDS551
932	coinbase	1716	720000000000	1	CkpYfLuAnz9T9ZcgoKkauontwyEtqZUAMCY85hYQfXWzYHy4hgRKu
934	fee_transfer	1656	80000000	1	CkpaJDZ6Aammq5Z631VCuSY7bR1LZsD6jW1bUDvpNGq828ibH7rcN
936	fee_transfer	1455	21000000	1	CkpZLZ1KWLdyGQk5c45RjDJSm9swwbwSJ3DLPQG57eoiTBEzLSiam
938	fee_transfer	1271	21000000	1	CkpZWhAg9SNBqYYsRtjg9cTrRahain8oMUxqJX9hAmNyZAHAeKp7a
939	fee_transfer	1724	1000000	1	CkpYQyBDCaUkzQN9jYkfk5E93JNANekQ9vut3TJXZE1RNE3m13iyJ
942	fee_transfer	1687	40000000	1	CkpaKdaUk9nPUQsujPNEUpjShTaYiwbHdWFf9a1zbXc3rXraNLgCQ
866	fee_transfer	1703	110000000	1	CkpZVE8CJqhJrTzA1kkpvkcGJYiZCkrQDBsm1QGkY9p4N6izkoGsF
868	fee_transfer	1688	800000000	1	CkpZbHjDm3VZqx17Jg2JCw7ZkX3jBd1WEcQBGXjiUTMfYxkC6mGFw
869	fee_transfer	1688	120000000	1	CkpZU4REREc3vYaZJdVQx2WG5j9D77tfZ5Uz9ekyqq547tuEEeXZt
876	fee_transfer	1672	30000000	1	CkpYnXRcsvLb4BZKQQyAL1oHgLAx3ZPJkhqEGmN2SiGRQRk18c5Ms
882	fee_transfer	1737	900	1	CkpZ6LHwrmu7qRsJFCdMN6tBdw1rFtzns9LgXqRb96QFGY4BxoBGr
883	fee_transfer	45	380	1	CkpYh1fXu3z28MtaSCpwPh7U32s4CLjpS4BETc4WB75QJ8CYCLZwk
884	fee_transfer	1515	8402800	1	CkpZG4DSWF81FD8CDdgYnRR3iWVeqNmgPCRSDzmVc5eh4RdFFhyzV
885	fee_transfer	1492	8400000	1	CkpYrZVHXEk8xvEUyKUh2ChQsrD7Kgpec9XxGrLCBSafDdx2yFPwn
886	fee_transfer	1681	3195920	1	CkpZqAxtMB1tzKeH1g1jk61zNHL4pvgZtVdditNbtkbMN8AwuWbdz
890	fee_transfer	44	50000000	1	CkpZMuoGLsYegcHjgTHZN1coY6gxeqZ9GBLksch5qMxx5Pb6JcBg6
902	fee_transfer	1675	20000000	1	CkpaJumJXdnfwE6ttWAtCqgCSRoinHA2gHtwPbD1jsh9qdvkQgM35
906	fee_transfer	369	280000000	1	CkpZpQQLKbxt7D8T7ngFnhoAWfnYrQPpHkrFWtUH8EzJHub9T7Cs2
907	fee_transfer	369	640000000	1	CkpYUouYcWmG5sjQRoegvcS8ArehLXCWQvJciuxr3WwfLL19yE9E1
910	fee_transfer	1448	20000000	1	CkpaAAb9Ej2PunQiLHqk4tL27xXAXSbfkTP8v1yMNGGY5tMpav9eV
914	fee_transfer	1686	480000000	1	CkpaERe2ipb36wqeYoMVdeMpisrJ4DrA3Z3pvVyu6aFWbELGReyr8
915	fee_transfer	1686	220000000	1	Ckpa7ZWdKAhS5VTse5vH9upWXf7xvhXWZ2HpVqre5LRfP9KjDqjwR
916	fee_transfer	379	23000	1	CkpZfFWSC4qgZTY8et19RcHQwc95eqrRdxt9rqpimmZr2MMmizaAV
917	fee_transfer	45	110	1	CkpZcFiEBisnHBhzmtXXCze8fb6fbEr63faRBGK9io4pTmXWbVzFH
918	fee_transfer	1580	160000000	1	CkpZuqaEajTofHmxry3pn4T9Xbj3xBncLPabDnUJjbqtKd1UYW3bH
919	fee_transfer	1716	471396690	1	CkpYdgVoLjr75az192yufLnPLAt3g5ZRbj5BZ87osSZSvkY5ynUUi
920	fee_transfer	1725	25180000	1	CkpZpdAT5wGnzEufDwsMv3HMo2LkhuKtDre36Yo7meyPYUbHgRrKq
921	fee_transfer	1531	300000000	1	CkpYUzGwGi71SA84Nm18ZLU6LBvoWvd6i1wUEPPNsntoXisTEX6uM
922	fee_transfer	317	325000000	1	CkpYx7hHs4nro7wiyriHbkY6RANF7wMEunXX21a29VJbq5capL8kD
923	fee_transfer	45	50	1	CkpYTeHnpqCUsSqgkzYkEufqXsGFMMTwZheJ6RPo65feLMFMLMqmU
924	fee_transfer	1716	39999950	1	CkpZ2MbfDd5qjj5HhVGVYZqk63ozSpbLaRbxyEEUgCDJNt71rbpgm
933	fee_transfer	1649	80000000	1	CkpZjdeF67ySHVyd5frpgoDxZCJHovK7wv4UDTmSMP5qFQeEARTvG
935	fee_transfer	1679	31000000	1	CkpZAnLGj4QgcPF3XpzxGUJZZDGC8T9cYj6K15CefbKbRzKccGosj
940	fee_transfer	1474	30000000	1	CkpZLw6WgH5g3u1FNrbcJSfWBz6Dt2JzxhduLrmGWLDBDCrcU8zHe
867	fee_transfer	1686	40000000	1	CkpYix3t69Frxr4yC4xg5pqMbjy198q2sTE5Jx2BtiLfabh89gkaL
870	fee_transfer	1698	500000000	1	CkpZDcCLuv6rW3u9YAXbvWDbNxp1nuVp91YR2Ri278956zhue7hTa
871	fee_transfer	1698	50000000	1	Ckpa6yZVk8Sm6V8ZpmTCyr82UWAbow172dzGv95brTpnz2zc2dBxc
877	fee_transfer	1613	30000000	1	CkpYbRSkKJBq1Jp8qZYMiABq9XLSs6RNLQPvaMf2gqpekjhjGzTzf
878	fee_transfer_via_coinbase	1766	1000000024	1	Ckpa7c4HKWLA3V98wxthtGnd14GoyUXJc4SSSSWN8ryXfEm2BiiTg
879	coinbase	1518	720000000000	1	CkpZrwScpvKyrsMX6wBASzcQ7qzegCviWHTaQJ1RWomohRGLLHqjv
880	coinbase	1767	720000000000	1	CkpZEjfNA5sf7SLEPwim6C6mrbkxiEWNLrafXsQtXzSkkMFLzZS1Z
881	fee_transfer	1767	10000000	1	CkpZWdsTvivnBoUQBPf6qBuPtfoxbAsqRQGqq9QcLvVdvXxhihrdF
888	fee_transfer	1698	310000000	1	CkpYzeKHn5EbrLftFA7wcrCm2zZkq2CC6wL6wxvXQjYbkquB8rUK4
889	fee_transfer	1599	50000000	1	CkpZ8c9dsDghiyodTvW7hznzUZAoXycULLJWkPkn16LYqvDFis7nc
892	coinbase	525	720000000000	1	CkpZMvnGQYydsYEXPCjCSCWoYkwFcLTovC4sBHYokRoNFFoWMEcM7
893	fee_transfer	525	10000000	1	CkpYjd7pK7SG7V8meFkMeTUHCwWy6cy9Pc35BoagSdQA22B6XJ38v
895	fee_transfer	641	480000000	1	CkpZJtgKbGtLLbDg5DjJFraVanNKanMCG6xZXm6hzVdYxrdzmgALc
896	fee_transfer	1721	180000000	1	CkpZzLZPYC3331VmKAq24GAPs5135AKduHp31N3rZSAZ5tDLbT1oR
897	fee_transfer	1420	94222222	1	CkpYyR39W1isdxAAUywCmjZ37uhRtzGXccJEJLV87e9YS8J8Buyc2
898	fee_transfer	641	225777778	1	CkpaEeRaUMt6G16JcxBvVUjHBgpptVNRBjutAe2yLqgrNGG9dW6fd
900	fee_transfer	1762	40000000	1	CkpZDKvwzktfnbiBjUiL4wUF5FZ6NGwmUv1cgqZoVtgM9Qk5WV4uh
901	fee_transfer	1643	1060000000	1	Ckpa3AazdFG5mjJZXVRw59cBoLWtnLnpLDEBXA5CPVEeaz9C78dbM
903	fee_transfer	369	400000000	1	CkpZLBnRrigrrMwSbfqV1PQ5ZsiVzz778rg552cwPVbFSngcoAMqs
904	fee_transfer	369	969999980	1	CkpYyGb5PJRgLkBmQ9V9YiwS1BFEEJCcwz16aRgYJor5MNnK9mZHL
913	fee_transfer	1764	10000000	1	CkpYRmbiaNaZ6vCNAgGCJCXkhsnnDfcPFfEFGuwxyrkpjH8WGY6jT
925	fee_transfer	1482	10000000	1	CkpZEoEhPtdTBVTuk3yitvuvnyuVLioZb4er5uXnrG1xLd1jfP9fQ
926	fee_transfer	1673	1350000000	1	Ckpa9ikvbfvTDy8UQodDrUZejfm6fHQXhRL4EsNFHZiX4C6YMdxrm
929	fee_transfer	1541	1300000000	1	CkpZKgPpRZtEPc3gZZ8YiFEh5w3FR8GHjcPPNYrmXH9vC2Xxi6r9T
930	coinbase	1598	720000000000	1	CkpYhsLb6qADiXkDH9gXPRmXUheH5XEEFX1J8j8ncT4kPddhRN84Y
931	fee_transfer	1598	10000000	1	CkpZcz1bYDfYWetW9nguCvaWGjPqazcvkuBNDUA26n8jgxaJMCCGF
937	fee_transfer	1724	21000000	1	CkpZHdoNazcfG9hYZH8qrJhGRLMAmRKc7pwAnp8iUvnqMMT9S9wJX
941	fee_transfer	1467	40000000	1	CkpZfU1PAqMVHLUAFLvkdEhyi82d4nWaoCqQE6rEeED2wZfuXAWny
943	fee_transfer_via_coinbase	1744	500000	1	CkpZSY788xXikyiLqUX3qZdnTzEBEpMABxb6XmtT5Uo8KsUuxZ52d
944	coinbase	329	720000000000	1	Ckpa8Fg1TmduuxNmw9ERyF74RHj1bCxpwAGs6qgPzgToq9qTQfTzG
945	fee_transfer_via_coinbase	1744	500	1	CkpZNsBRmSTf2f3xNAV6VeNJRkJRuY7mAqQBsnbqPLX3CTw5CUd1y
946	coinbase	329	720000000000	1	CkpZzy6ke7jbqCRmkinbdiQfq8VAndqoJJZybo2CQPSyhoLt8ohek
947	fee_transfer	329	48499500	1	CkpaAttPkFVm5xdMXRchxNAk8HTgGukxAyeN9kTMAandzEQJFYxoB
948	fee_transfer	1744	1500500	1	CkpZoayG5DT9PLSA9Mm2MoeW6vCBTbD7ZroGiqbGgKZXvuPW5SbQB
949	fee_transfer	329	510000000	1	CkpZoyriRtJjYJQrCQ4BmSrhSujmrSet9h9iXaBqt3beQTVejeaEi
950	coinbase	329	720000000000	1	CkpZwpku3DpX8Eu4K8RNtfZiRFbHSm1eEv3Wnx7FbZTLUprWEdFHM
951	fee_transfer_via_coinbase	707	150000000	1	CkpYQay95eM3JAgdDhd7udPmsc7vGkD8yHAvAd315vBPm8u1qBoPG
952	coinbase	329	720000000000	1	CkpaHK8DemzuYqfp7TULVUhJdX1c191dzXheQ4JQCbzNTZLcoSQ4P
953	fee_transfer	329	50000000	1	CkpZdRpkvCXNqmhbE15WnvZzFXALAXuE9T6gheUUh14UdTQ8qp9Ek
954	coinbase	329	720000000000	1	CkpZJLcSig95mMrrRfQrFjCqNnaP6vdejpgtUAm6U64BepUuXxGTb
955	coinbase	1509	720000000000	1	Ckpa4Zw5C6LWCncaMKQTY3qkN6V63eX3cSwFsSk2TjQKGkprWvbvr
956	fee_transfer	1744	1000500	1	CkpYk1tXfVmPeWzKa68z25yUcfZUeXzorCy3eoEqbYiytcyXBTSPi
957	fee_transfer	1509	8999500	1	CkpZHExJKcYCFnjJsrsUuDV4hpzYCitiZBPXhPavtBo3EmnUCu7ZB
958	fee_transfer	1705	370000000	1	CkpZgfVe1Dj8qgFGjKt386azFNiWPEzBYFny6rSNzw6U4sdn74sJV
959	fee_transfer	1705	880000000	1	CkpZFzsPZho1MBERSKH7Ge2ot93UmGvqUULyM7gKSEEj4QNu3hR7Y
960	coinbase	1462	720000000000	1	CkpZRwsxzvUF7ejQzTZkwU8fHM7UKhMQJa2CNNHbZgywh1xcyhreF
961	fee_transfer	1462	10000000	1	CkpYTgvukhdaoLRptWR787YRGMiBwgU2NreWSiwo9UxwshpDboNpq
962	coinbase	415	720000000000	1	CkpZkt8QUZqNiERzoUV1RkEeHfSPchpTquvB5YPkbn8hgu5mKoPaP
963	fee_transfer	415	10000000	1	CkpYb3w6c8vTJNb5FwGenspXJBLeythFQj4KKxKcYwAdjSowPfgqV
964	coinbase	1496	720000000000	1	CkpZRSseTJskKSgdTwhMbCtea4gKWv1V6Bha5ccmkVM7Sk4nNXxN1
965	fee_transfer	1496	10000000	1	CkpZhtn6Sg3VhFNdGJSvm8wxQLrPvwhhTLzqzRh6Ldf3knPkRJ7p2
966	fee_transfer_via_coinbase	1501	100000000	1	CkpZe617QLPENDSJCuVdxm6KdS2WBZG7pmCnsvMAoAqcs8VSjzgdX
967	coinbase	1677	720000000000	1	CkpaK3f3Yx8JHSPMfsRWpJVbCsc7JTKGZXgcnbF1Hxf8i82TcFdsn
968	fee_transfer	1677	100000000	1	CkpZHXBcheNNqHYtJxCq9ngEU6wALciAPqYxzRaKV6aiqdUY8bx4K
969	fee_transfer	1708	100000000	1	CkpZDdSE8QLTcm8y7cCEVtVHtQySt4wb8meNd7c96PhFikJG868By
970	fee_transfer	1706	100000000	1	CkpZ8ydbAaiKKw9Dbra5NZha9wGu7KopSZeJitSrkw7uxLWfcxZ14
971	fee_transfer	633	430000000	1	CkpZLDzJoYXNX8cN1ejij69Cs45fRSckmHRWxuwL3deQYsmJDfxSt
972	fee_transfer	633	339999999	1	CkpZaYLxA6SvX3E5zJyq5TphoBmiqZUZqopyTJHhML4XqYKuw1TUV
973	fee_transfer	1520	1	1	CkpZSBcuX2QnTZ5WpGyk7jHm66gMxZe8kzZ9GJvJpdYLX8Hconco7
974	fee_transfer	1703	160000000	1	CkpaJVmQacchCSdNB7k8krfxbt1rrB2fmyNKr6yPDwcd2rv9urLVR
975	fee_transfer	1703	270000000	1	CkpZUVthA3k64EfyWCbJrE2veScXY1oYnBKdxBA9zaHwZGfEYCyr2
976	fee_transfer	1594	120000000	1	CkpZ9n6wPG9Eaykk8srEzVJCAAixRvbdNxubthGcGkae7Xa21cMaD
977	fee_transfer	1643	100000000	1	CkpYSui91VuikxSZNPUb7LakhHb8vHLa42wtMRN71Mqxrpvm9QWb9
978	fee_transfer_via_coinbase	1550	10000000	1	CkpYm9RUmFgZ4G6DhQQcvNLECyyex79chhxyBgwRXpbeQev3fp9Wp
979	coinbase	1688	720000000000	1	CkpZDARbrDfn6YVYHwULVkzrUugXyJ8vQ3SYE717mEvJG2yF5mUdX
980	fee_transfer	1654	420000000	1	CkpYh8JR2k8YNpbSdkPpqiLWPSyGpqd6eYieBSUVGFpR5ThrSrzE6
981	fee_transfer	1654	1010000000	1	CkpZwxf4ywRokvVpohYe9gPpVokGH9Pvdk6e1ifsKp44GyeMsCexy
982	fee_transfer	1703	330000000	1	CkpZxykMUKdaapgfXNCTNW6Rb1UR7EgUnKmYMwj8DNEYPXErHWy14
983	fee_transfer	1673	1440000000	1	CkpZqP8evDF2vueS6W4ZWmUqUhHQeEwdwzMhj8LesxMHBojuCxoAa
984	fee_transfer	1686	80000000	1	CkpYgAehH4Y8ejHkp5qXS8czpD4NAACxRzDFZK6dYJFjicq4VTX7j
985	fee_transfer	1467	80000000	1	CkpYhfHfehsBwsXm77Wv7tZwdLM46dT13y4ku2V9cqZVddYXXPuRv
987	fee_transfer	1668	30000000	1	CkpZA3jD9PR7NZVwkN1NWMiTBNLf3ERtyR3RM8CG5Sbf6qZHD45iN
988	fee_transfer	1768	20000000	1	CkpZ3PwNDcHBf6XxLfGcuApADtFcFGuWkpHizv13AkWQw3zetCSYM
989	coinbase	1568	720000000000	1	CkpZF3kQNWwFP8BcwYVmj2J48dgXKVL48QxZC2SRRi7kHZm1q5Z2R
990	fee_transfer	1568	20000000	1	CkpYugFNB6uFSSesj4FgZk3XGEKngAkrfjnYmA6ieqTkS4aixBbLV
992	fee_transfer	1700	120000000	1	CkpYvCk8gSZVyfV1iyK5iqgd9ozJmnfRTEYrhKDAF7npUGDg9nk9D
998	fee_transfer	1683	50000000	1	CkpZyHyjMY8GMM9CGAXVpi1vknh9fLxspBtqyZakGVnbjGeL4dPtT
1000	coinbase	405	720000000000	1	CkpZcgLHBhSdrM3CsMj7EJTzrxKh7KqK3AjNxe4qbrXUqN8EETu3f
1001	fee_transfer	405	10000000	1	CkpZ8J5q35jxWwpW1ikn7q1tBCZq81Ndj6to2Xi6YtevEzswdRCk9
1003	fee_transfer	1593	70000000	1	CkpZzMFSx77419B8J9RLe4KFQKGxaTEByHggKMd895JZUUUuCnYhf
1004	fee_transfer	1703	720000000	1	CkpYT6BkqC8AJzt6SK2KSb4nexvfFfMj3qyx1Y9NscrwKkdWrU1tB
1005	fee_transfer	1703	530000000	1	CkpZExecBxmzD4dsgQaFGfXSPk5hF3NYaRntN1N357E25dGLn1QtX
1006	fee_transfer	1739	220000000	1	CkpZdb6mFc7NvWmeVxbUSViCzpdyBvgpp6fNkY7heEvTUWQiYzJkg
1007	fee_transfer	1634	220000000	1	CkpYghn7GVpiJ9YAs5sdXJSpytA6wT3hiQD1bRLEXD4ZQcdRWMTrT
1008	fee_transfer	1706	220000000	1	CkpZax14v6uUidzQMF3m5kx5uzEJKKrVKA2QN9T9RuTPo3HVMgcaM
1011	fee_transfer	1509	40000000	1	CkpZjS3MorF67DpaNLoNXMSFke2g4QfqqRfMS3LxUbFrd1c393hHa
1015	fee_transfer	606	40000000	1	CkpYuSKepF9sW1FbHyZANypDQ36dhj9vPuMcSCikhDW4f1ZurXnoW
1016	fee_transfer	1677	180000000	1	CkpaHgY4X8cnXtZoKpBsucgmyVpB2EwaJeDfAxHLKftTywtcR6Z1U
1021	coinbase	1756	720000000000	1	CkpZ8b6yTW5mzJWshrRNGcqkGDzrW77fRC4NRarQkMFoRLcfBCEqD
1022	fee_transfer	1756	10000000	1	CkpZApRr5816QqtDVUzovUXvjaJLWGgeQybicexG8bTYjnfwogBbq
1024	fee_transfer	1723	40000000	1	Ckpa758FQjFu6UJGy2wDXCDjSoJ55TJdTSze7ooJzU4Yv71JLMm21
1027	fee_transfer	1768	80000000	1	CkpZw4jaKf1DeBhzYsrBAVVkCbsWrBkfVmyyfWBcidF7mkBPvcKqU
1028	fee_transfer	44	80000000	1	CkpZU6fjkckdSvqHbuUpxMzMPnerxg84Hou7C8XS235sZyhoRMd6Y
1029	fee_transfer	1555	130000000	1	CkpZmthYTFybAs5s4rJUPzJn9UrHp5s5e1nxVWCpa3wSppdvfkTcr
1035	fee_transfer	1587	110000000	1	CkpZr75tvWmdth6pzTvqb26pYGx6JQe2LDP3Ekf23YrU1Rjh34F1e
1036	fee_transfer	1677	90000000	1	CkpYc3d4BXUY44jZx9HnsrweC2hp4wtTsuPRYHcEX41BCTERoBaq6
1045	fee_transfer	1637	21000000	1	CkpZNSDEXFMakyW1we42vyqKxfSc73pTxheU3VsGPySyfEkzZsQwK
1051	fee_transfer	1701	41000000	1	CkpZjM6PRtWQJ6VyUDFgFGxtriwX3cmagX6K6bTGFhV5UTnZVAwhK
1057	coinbase	1653	720000000000	1	CkpYZTGCb7rjmD7tRGsqJBADmA4XuBKcGDvvVHsbWMU4amN12c4mN
1058	fee_transfer	1653	10000000	1	CkpZ8fVKfJQn73qkewdWf5Z1hRc4f8n2ib6B5LbCVwM9A3XV8XC5N
1059	fee_transfer	1476	860000000	1	CkpYXwSotkK92JxsYasgBp5z87ha2WSvB4hoEwaeV6AaVGsFgmvjg
1060	fee_transfer	1679	50000000	1	CkpZqVBWa7AUtn1cN7QjcGSR9yM1YT2sGr41iD54pR7rzgYipNLZL
1062	fee_transfer	1506	1060000000	1	CkpZ9qhw6erDKsvirFGnG5ZKuYz4DQ9z2ZRVigTrxQ56ghNEyP2Q4
1063	fee_transfer	1506	550000000	1	CkpYyRRHgcM1vLqCkkBhiArTryc4jD2J6bNkoWuie9AQkz4p6y4Yh
1068	fee_transfer	1764	30000000	1	CkpZGYPjA3DCoyLqax5KHHX2mNHmzfhUPQoiup3P4av9izNBVkmtf
1072	fee_transfer	1706	1000000	1	CkpZjMNpsrTJZbHGLaG2ErfSBeM5wZJkWpAtGmkPUnibEXaxEzWcs
1077	coinbase	613	720000000000	1	CkpZ3LC2GHm9YcJWeiFYmqVRXfiCX6LBEGHcsP2PQctYj1vNttp7S
1085	fee_transfer	1677	1000000	1	CkpZ8p8omZaBpN6pLD4fZamW3kdeXmT7fRhbAt8CWMxdfjiFzqbAz
1089	fee_transfer	1686	1000000	1	CkpZsST3aHrzJW5roDFNAX96beEKKDrPxW9nxnNnss9qYFUGmvZdq
1094	fee_transfer	1682	101000000	1	CkpZ7T9Hc93ZVvVnH32kzYY3iCd6XL3DJ74LHmEKPtKeKXC5V9wFn
986	fee_transfer	1559	80000000	1	CkpYaKbcJxpPNfDSY77wNzB1ELEPid34kCDfna1GDZVLoW2VxePVW
993	fee_transfer	1587	30000000	1	CkpZPj9AM1yT2g1DBrs9CfQ6D12JVE3GLtfBnxgs6PP4XQLBHkV6S
994	fee_transfer	1610	40000000	1	Ckpa1mRwesBRqyCDJZbXrEdCtREhKf41LBqjBTK4aap261HUeB4jz
995	fee_transfer	1643	130000000	1	CkpZ82F1skgLoeg4oygCWbFzs7ujEBn16Upj5CAGj9BokCauB4r7g
999	fee_transfer	1611	200000000	1	CkpYwbVxdBLNKHSgdEm25AftMXhfMwBv2a88NGtR8pRtRPJpetdBq
1009	fee_transfer	1634	130000000	1	CkpZfVF4aqgKNysubSSPemSzcbTuV6kip4frhCgKM4jGUHZnQDcct
1012	fee_transfer	1271	370000000	1	CkpZnW53M2y11hLvZqv1MP8rF4CSkhxqDzmFpnW5LDZwPGM4k9BMp
1013	coinbase	1271	720000000000	1	CkpaFuP85tupP6QJHkMN6kjTouDXQkMVbANxH1MPagBtcvGDqBHfZ
1014	fee_transfer	1402	80000000	1	Ckpa3oyH3iqS44sRgFHhvojHrRs4DxoGZEfuvzZskw8VRR86Qv6Y9
1023	fee_transfer	1643	590000000	1	CkpaELD2eMAv7Q6qyJP1qyZTZoqRABmSbTmhWCpQQqJ6MkGwthPEG
1025	fee_transfer	1650	30000000	1	Ckpa4m9y39t52RbwULo93VpSmwGNoj5vwSTJ2xpisACkGSrnWDKtF
1026	fee_transfer	1711	80000000	1	CkpZtLGyM5mHt4fnEFByDgBRFbCSX9r6nv4g11f6cJfEYqmnkvekW
1032	fee_transfer	1768	40000000	1	CkpYiREno9xpBRC8XiCKG2hftk5AHNnCCB8SW4PUM1rHGFKEkUWZ1
1033	fee_transfer	1683	230000000	1	CkpZ64q4T2icHd7xiisovJ8PpiQdxgkizcCLhKMBHpaehpKkNPpuk
1034	fee_transfer	1489	110000000	1	CkpZqkiTywexbR8uBdSDhH8oG5PFKNY2RU6Tc9WhR6NH9RaKs7BmK
1038	fee_transfer	1637	190000000	1	CkpYc7ffyxpkj32PXWWkizBWknn2otiTpSB1G3pHm4hTWS87RiSo5
1041	fee_transfer	1440	120000000	1	CkpYcqDqd9tUThBHn1XR5ZqzCsCFsTSnMs4uhJ6Xt2E4Pny4JS4aE
1043	fee_transfer	1444	30000000	1	CkpZ3WFHXRMWHLRmGhpjVykYVgazVbdMq2cCR7JiqQ995qPBcXztd
1044	fee_transfer	1522	21000000	1	CkpZ6MMhpg17wBaXifrfbBRTbhYx37tvgQqhriRvtUmHoG74pwRVt
1046	fee_transfer	1457	40000000	1	CkpZMH8WHcXwbPXSZVDrdP71zJPpQQQs3iPhi5pB4k8Hj9wrMBDx8
1050	fee_transfer	1740	41000000	1	CkpYtMYPfwMrP1cZgRToicJXK6XpfHVXv3EYRVoXfeMPKcS2hod1S
1066	fee_transfer	1426	650000000	1	CkpZhYpAKshRx4GZKLBNUvzKhmCK6xB2j48uKUDF5pDroFv1Q76e9
1067	fee_transfer	1704	80000000	1	CkpZkjJw9LzzCVovW4b3BbW44WfSpoNByVGXMJfxtCZQh8qo72QYS
1069	fee_transfer	1735	30000000	1	CkpYRzjH8KyrofQZh4tX2X9uyhaNpV61nGbgvcrQpEbXrTJKNTf2B
1079	fee_transfer	1650	1000000	1	CkpZ3y8MWgKj6xm9FQRJJJJNjQ2MsbJtKBCiNUaETkHegrmEGTQhz
1081	fee_transfer	1709	140000000	1	CkpZetNG6r8QPFTrR9tg7Bker3faVcq3LF5yKDgLnoXxjcdFbcBNg
1082	fee_transfer	1515	1	1	CkpYaHA6Q8zU8QHpyjw5wXQzNRceTJ1XfwC6nfh9aDvoAev5i6GGs
1083	fee_transfer	1709	414999999	1	CkpZmNb7K9N5KF7uqx5tRGSHrHLb3xH5HT4F2WdWnF2Wgg1wEruc2
1084	fee_transfer	1645	1000000	1	CkpZntEm9QqBGNnDHKVSRcx5Q8wPzjuxSJ6t3PHQsDrjNCRDGqQbn
1087	fee_transfer	1637	1000000	1	CkpYeC8bG6ZDM7KYWUm1BhNUCNjKVAWNsUS5U4RyGjz1SFtaDQBXX
1090	fee_transfer	1634	24000000	1	CkpZhZrhfF3D9yynX8kLwnDF8XrtXe3dppws1W5J5n2WTwK2fV7EX
1091	fee_transfer	1679	1000000	1	CkpZVUH1HKze47UFS6hBorLYzP7TJ8TB6DmnNXkdUyYCBHYgxYjFs
1092	fee_transfer	1727	1000000	1	CkpZBJrPzbTkWfMbmvQMw6vy7AVzgQquFQPxk1nRbKrZom6rRrTjC
1093	fee_transfer	1439	1000000	1	CkpZnCmtQA58oNYEm7jeC7tkmv4bKvqNd3GEyWajqCSPLfa22sv1w
1096	coinbase	238	720000000000	1	CkpYSdTWCBgZzwkw87637Q19vtMwv9US6NYSWbbtTtVNQmfL8dZk1
991	fee_transfer	1717	120000000	1	CkpaF7Dbk8CpGbWbupou9EmdUUSy8VTVXB1PjQ4dnAyTVdiKyDLDw
996	coinbase	349	720000000000	1	CkpZzVevAdcLpbdk2A31yabBkuGp43sYom1EYpvZVKVUnKsYjVEKj
997	fee_transfer	349	10000000	1	CkpYorTFdQzkgGiEbCJTJoLmkQVU8dLZGPaDNLYg2b4qyTZHtcG8Z
1002	fee_transfer	1694	70000000	1	CkpZCvWVrbb6hkY5LYePRtCdcKW3HDRbRZX3RRvZDgf9G3mDMnQF9
1010	fee_transfer	1637	60000000	1	CkpYwp6NJyQV5UwY5XwYaW5Fzuj5uvWQVhe4XYcn9462gNdHyJsAW
1017	fee_transfer	1637	180000000	1	CkpZoB9hTFbtMQDTGM51A75aJ56DFXf8yQVDMs9TTa9ogSbEFBaNa
1018	fee_transfer_via_coinbase	1571	8	1	CkpZkxg8YXLMotkXUsnvn2dNuYsYxGBRR9VZiF6jdxffWsS2otmsK
1019	coinbase	1649	720000000000	1	CkpYVAg5dxzA5BQd7SpEQrUvhM794sVb5xR7FySDne3sJ3RVnRkd6
1020	fee_transfer	1709	750000000	1	CkpZVEjECrWRwYyPycQTT2TMuxkXe4iMMhswGsSDUhRZMqfMGthGy
1030	fee_transfer	1467	50000000	1	CkpZG4ohoY3mxL6QVGeuKhVm8zUUF72wonLhCUTmH8RF6xphEaDmv
1031	fee_transfer	1678	40000000	1	CkpaCLvA8dDUj1GeomN4z66rZ2XHXm3zs1Xqc8thf63LgBjBLJgRi
1037	fee_transfer	1698	190000000	1	CkpYerbtotGZJF58cd8atbRMUd1fe4HPqvgMxjtc8Q6BBa4E3JtPH
1039	fee_transfer	470	50000000	1	CkpYac5D1borQEz5LoEtF874nHmEQqyr7cognzLLTSM7Cj1QntPbG
1040	fee_transfer	1679	70000000	1	CkpZXn4vofcY6Tp31zTRVbWdcT9YGdbbUtJS6DuaA21WVgq9At4dM
1042	fee_transfer	1513	320000000	1	CkpZhEXJZ2PxxSKs8UQcPjAtvryzbZnpeVP1jMSASrGStjRKA7DMm
1047	fee_transfer	1756	40000000	1	CkpZ8bobGrGzXjWg3PYUKy6URRt3j8QScFZLHwLAVwSqn3yYGBWha
1048	fee_transfer	1756	20000000	1	CkpYzYeeFbjvHFN6znV3Tc6uK1KGbHSjLVxnqbtvLdhT3qKQmqPfE
1049	fee_transfer	1607	100000000	1	CkpYXS1t3jJtn5Dj3bh2DfJUqAfi1zuuQy5BaAxbFh2dJ1LnDUaKC
1052	fee_transfer	1611	1150000000	1	CkpYzfFK3gW8x4DAZTLHsP8ouikGimVfvzZQLx11aFA4JSLS5CVDC
1053	coinbase	1611	720000000000	1	Ckpa7cim5omZjGgRog9pbGgLr9x7qoPVF8K44GnLTXWoRXT7VRaKa
1054	fee_transfer	1504	270000000	1	CkpZnfaSq1WAAKQGd51H2oMEEehsjYBRUzFre77xQ4y1pE42w3BtZ
1055	fee_transfer	1458	840000000	1	CkpZY77jpAq4AFkkiDTXLw4xXxvMiv9vgkeGSpLX4aaG3yXZerRxC
1056	coinbase	1458	720000000000	1	CkpZ2cQRLpfNa8PDgUFiumzWuNjYG7y7oiJ1bZFtgYQDtzgvtkKNG
1061	fee_transfer	1471	20000000	1	Ckpa5yttEJgRsniKJ7Q4WRevJ19oHvjL9RShqukU99nCVEPRFVKAw
1064	fee_transfer	1704	300000000	1	CkpYpc78FcUPvtBddmNSZ6xP1Gn5cbEhj6ojcYHGHPcqpam5WyhAW
1065	fee_transfer	1506	700000000	1	CkpYXNx5eZrWscEqhqx7ESkfP1JLr7M11GY9Tw3GW2sw7z1qc3XeE
1070	fee_transfer	1709	410000000	1	CkpZRP4sgJwSL6nNwHqjAtUNL7yATK7otsoXLTXmLSgLL2WGgefTZ
1071	fee_transfer	1709	1110000000	1	CkpaEEiimUfU87i8MyT5NEeQ4kTvLg7eTnACBtgkTom4E451AMawD
1073	fee_transfer	1706	950000000	1	CkpZbr3TVPVmq8hG4gpjWYdcEC7ggy1SXR2NhNptEEQfHWqUQyhRp
1074	fee_transfer	1706	159999992	1	CkpZm5B9pVqgP1KcqL6MvySSKp2c2BTi7rPhN8AZyxYGrCsc3W2Vy
1075	fee_transfer	1571	8	1	CkpZkxg8YXLMotkXUsnvn2dNuYsYxGBRR9VZiF6jdxffWsS2otmsK
1076	fee_transfer	1506	250000000	1	CkpYRwDKCCCCmR3TKRq4ryGpxv9Yq7hq7s2An8VLzjjH7ESBe9LPp
1078	fee_transfer	1458	1000000	1	CkpYtGAycMGtU5M1b9tiN6CrAG1rfQv86WSA5n5AMHTyXK3QMeESN
1080	fee_transfer	1709	1000000	1	CkpaG8KL4d8jkmmwg4NLKJyyY3hhc9hfHBbET8KhYoQZKYham4LDH
1086	fee_transfer	1607	1000000	1	CkpZX1xsVaADds5swuE7yRiTWTjQ72XEJPRGf68y6tHupzmRm7XsD
1088	fee_transfer	1690	1000000	1	CkpYiMLguxUavKX27gWKMYMtwoRKvjgpUETiMijqpYYpXyrTAag1H
1095	fee_transfer	1768	101000000	1	CkpYyK5zXjuzTt8RZK86g96PJChKHjAw72uDPurNbueE46fzZS7et
1097	fee_transfer	1513	153000000	1	CkpYd8FHUooAiW6Yq4MtWm9kCm9YMVyJCvsFUMvNSSki4BtmComeo
1098	coinbase	1550	720000000000	1	CkpZUTzYCpGgwHj3zVtAXcwTuBzL7ThYpNh1HUbBhQiQhTevbwcLY
1099	coinbase	1614	720000000000	1	CkpYUZWhrDDwJmvcnS6xXaRmyg1S5LEm11zn4hQmdGsUgbz9fSmqu
1100	fee_transfer	1634	100000000	1	CkpYddV2cf5M43HFt7y2JKNiD25URJ98rMA7mXnGj1YitiJVArJ12
1101	fee_transfer	1681	2000000	1	CkpYn2CcyAZKxQeAFAx7FiEoWPb7rcjcVeKt4GWPynPwkd7ta22Ht
1102	fee_transfer	1698	1000000	1	CkpZwAUPd8ujSYcgLaKafN6xDnVSKMCk34LE51DFgVH4YsvtYezRR
1103	fee_transfer	1564	12000000	1	CkpYWcscAy17GFp9isR9gtNNMmrNkvKU2q7tbhcwKkhYZPKKnmza5
1104	fee_transfer	1682	12000000	1	CkpZ7LgPBnMsHCep3TSGzUWTEWdcQgU66hcLujrfrhWsrvPwofYkx
1105	fee_transfer	1673	12000000	1	CkpZYuP2et4wCznD1ghaX3zT9BSzM13tdxmxchVKynQGSBCSG5rpB
1106	fee_transfer	1513	14000000	1	CkpZY8oZdpmbzs9NZfkD8VND4tY7bynK9sKJ5YG3sQBEZqWzN33HE
1107	coinbase	1544	720000000000	1	CkpZWstZnjxVSY3qZP41h3EbtNkPKtomK2jjffRgXCqVY6vrumaeo
1108	fee_transfer	1571	11000000	1	CkpYVcYzsHKuvtpd1i7hDBXJ1FpXo4mwqB7JSV2BvTmaBgayP59Qe
1109	coinbase	1749	720000000000	1	CkpYTzfKzmAETmwDjrj65aVFLFNxtDi3ahXRzyxR2GkeeL3MYfwS4
1110	fee_transfer	1601	21000000	1	CkpZ7iU3tUxrbMTErUqxVhS1yxWLow3Y8eqsrrP2R3RxgGu2S1bZg
1111	fee_transfer	1749	10000000	1	CkpZGYHPv8XYnsabWrcLCfyn33v4CdPTMmG6iNR1vRvgy2mPCqhr6
1112	fee_transfer	1703	21000000	1	CkpZ9Wg3aygXhmiNTqyAYDTVqTLXXLSCdXL1nF3XrbMFdyHSFWgdT
1113	fee_transfer	1702	21000000	1	CkpZEKpDAtCNLFWidqtKNJipBs5sHG3MV9MThHfMGTBreyQahLXCC
1114	fee_transfer	1677	21000000	1	CkpYjBQ65wN1yizGJLWR7pqMJ5AdSjZyfNXt14SqhEThvCXurMyS7
1115	fee_transfer	1489	21000000	1	CkpaBcKkZ6RBkvYqmyGQQknYRv7JiwmuUesMTfjxYzV6GBEbfi6uS
1116	coinbase	1458	720000000000	1	CkpYprFG4FDXTSQ47DbcKBYKaQ79xP13K66P5sK8YT9fNVmmUKnjp
1117	fee_transfer	1458	6100000	1	CkpZ6mT548g4XSQV4oS4euFFn16MSZ2QshDWwedxk8xeSGxgiR6de
1118	fee_transfer	1460	3400000	1	CkpZBxG4gjWCPwNKH1NjvYNmRBjtTcanJuhLGpvwc1tAcM4tiPn6D
1119	fee_transfer	1744	500000	1	CkpZSY788xXikyiLqUX3qZdnTzEBEpMABxb6XmtT5Uo8KsUuxZ52d
1120	fee_transfer	1672	40000000	1	Ckpa1K7c3qVLSEL8BaPergRHvhgkjaARvafjHGcErArfGKtFxgVcq
1121	fee_transfer	1706	30000000	1	CkpZ9vdF1b8TTx3LYckrfkdtH7DaHyB2LqAdYdUNVgzMtiYk4yRFA
1122	fee_transfer	1706	80000000	1	CkpZ2UnqfDyHMcZaYoweavkrJhj7u8uQZrFLGo8HSumrCYuAxsgha
1123	fee_transfer	1428	10000000	1	CkpYYSy6Z3YQg3jgb2PRhN3Y5U1wvEGJMQKGv983Le2inzeQfmk14
1124	fee_transfer	1560	11000000	1	CkpYheciqTEKPRhuWKviJisdnDnsRxLf4TR8YTMNrz3j6ASZxUHjr
1125	fee_transfer	1691	11000000	1	CkpaBUiiMoAkoSrZ3zPuD6Spsia3WbVBMRtgw68c1P6rvvupB5Hcx
1126	fee_transfer	1693	1000000	1	Ckpa5CedTyemD6ZPhK17rUhusnvJ4j3hmYzE8SXTejhxxiZkWRwq9
1127	fee_transfer	1513	11000000	1	CkpZQnabWpRVihtQxfejt5ThTZ2uKLSJ6iGhSbfmBW3HzG29gk2aD
1128	fee_transfer_via_coinbase	1506	10000000	1	CkpYSNFyNtQeGkc7769RF4UQ2n8S34sPzg7UjzoMM4n9zQJVQ85Ec
1129	coinbase	1513	720000000000	1	CkpYRcyN2itUftJTATxsHATKdMNqgo5c7ChamDws8s2UXyLNEeWGf
1130	coinbase	1780	720000000000	1	CkpYZuBQxoxCx7ZcYLXejJuHAdRtrybKGk9G7vmWRc6zDq9VEbpc9
1131	fee_transfer	1780	10000000	1	CkpZGVvLG28fQiAriaSp1rYc35ZzhPgZ1FEKiby5mbAF98eUn57wk
1133	fee_transfer	1440	40000000	1	CkpZq1pW6Y4i48X39QYtjcGkT1k4ZjnayJQZok5tKXQfPTNk6P6rr
1134	fee_transfer	1522	30000000	1	CkpZm6bbhkKxopq7MCZhgZ3G9684SdkcWGAsPmidFpRcuQqjBWKZz
1140	fee_transfer	662	900000000	1	CkpZB8BDCgXVCsWVgjDvf8tUWSvLg6EhZ3VgNgCkE3VqRfrDeh9xx
1141	coinbase	662	720000000000	1	CkpYe8fPCGRUcnT7XmffQzBipT2BeyrMrWWk86HFWFJvdr2zKL4H2
1142	fee_transfer	1613	250000000	1	CkpZQFowFbX62oy6qUa91mbcbobVH8G4zF2YRrHHcGU7sDUzYkMbG
1143	fee_transfer	662	50000000	1	CkpZL3ycrNHVXSPJ8qqJFVJ3aW8cFezDSZNtZkQi3Av3XyFu5TaeU
1144	fee_transfer	42	110000000	1	CkpZHFtPjHbzWs9GYgJeXSQovGLTqCqyr3nxaXtTeL1sx5JPNL3Sd
1145	fee_transfer	1690	40000000	1	CkpYhZe9QrZ9pAxgTfEHqstDK8ZYySVLeTsc4CTfMzoy3o4raTYQP
1153	coinbase	1605	720000000000	1	CkpZRCxEUmF1vrVhSev9CkFwt48ZpPLEHnX132CcgHASy5xYGap79
1154	fee_transfer	1605	20000000	1	CkpYbnvAxQMnqgF1zdsX8cQVdoNNk3hQM2vQ14G4wpQ7daaEp5Cw5
1157	coinbase	1449	720000000000	1	CkpYxAdC78vnnsxRSpr4G24VwqAuGYWXNMECDW2HzXxyC1GuesNW6
1158	fee_transfer	1449	10000000	1	CkpZ4CDfoSqiDZbxVthcRfHPKvtU1FVZY72gh4xVTZx454GEtFfvp
1160	fee_transfer	1643	584000000	1	Ckpa9J15FbXU9bmfezeFJWthcAzKXBoeTnVhfrLijGTjg8h6149eo
1173	fee_transfer	1711	110000000	1	CkpYymiRC52ngKf58Fj8F3U1F6FwQz5WGAGTLq6ofLDLck3NcsvyM
1176	fee_transfer	632	110000000	1	CkpZFBzq6nbvdpfDLP3eALTR5MDvxDJe1CMxDiuhR28B2kYeHQfZc
1187	fee_transfer	484	21000000	1	CkpYbppfnBTL6DLVzRgoVU4xRoMmoJWQSDn2W7X4MJUJchkewS5vk
1192	fee_transfer	1688	150000000	1	Ckpa5GpQ5obPEPe3LRWm5LtK7djPWuvMqZ7CAm318TabqA9KyeiCY
1195	fee_transfer	1688	130000000	1	CkpZ28UVGQB5s7FS5RsfqLcSMjscVwtJZsRJxLJ2LzX6gnk5jPdZL
1200	fee_transfer	1683	450000000	1	CkpYqWwo5s5KdvAr3Fn1oSXHLwmER7UtYBD71ShnfnkuWtwBGdqWf
1202	fee_transfer	1445	140000000	1	CkpZQBwubt7y9WKb4B7qtUmKLcmWMZQtDRcbpkcW8mMvS4dUViYjf
1207	fee_transfer	1706	130000000	1	CkpZ87uuSfYzFagUkgSDEVFGZEj5wAuqcJ89EdHYynaMGhX8W6fPA
1214	fee_transfer	470	110000000	1	CkpaGXbfL6WdjAeJay7HnW3CsYsfJ5gKLibrqrRMNuQyaKaxjRzWi
1228	fee_transfer	1695	110000000	1	CkpZf7hJstfpuFutspg7MkjSgKxX5PDzNGkEhkAEy5xv5TRdbDnyg
1229	fee_transfer	1426	50000000	1	CkpYf2ESGCvQXC1pnwBCaEUexyVjxDtbBPrqcTawwZ2qgFfv6C2qS
1231	fee_transfer	576	40000000	1	CkpYsSPyj649BtjZ3v4DHJagjUVCd5WeDm3PRqSRXoS1xRaiFZw4x
1244	fee_transfer	1688	100000000	1	CkpZUzJy19e9SdMMCtvCCKXHrPx5BXQ76BhvVETmVLf7EytiB4Gro
1245	fee_transfer	1692	100000000	1	CkpZpzNWBFLSUhiC5CyNfbaxtLEX9BvtFqTdkEb6nzuXqwTbSAEqJ
1250	fee_transfer	1759	110000000	1	CkpYSgGM4EpYkTuz5pzXqmSKSPxQ1LvgjoLrPK8K4gVuncPJGwoff
1252	fee_transfer	1729	130000000	1	CkpYpctamy6Kj68MfNQ32rb5aMANH9U7KL9JwK9ueyeneBNwffaEa
1256	fee_transfer	1573	220000000	1	CkpYRUwZNp7HW5hwveKUVjyDgChRQQawZd4gzAX9GwzqzRNqF5AQP
1132	fee_transfer	1444	40000000	1	CkpYqAgKGr4KkJTGEfFwLejxzw4adFfcJmnJdngn3L7SQePLigwEN
1135	fee_transfer	1714	30000000	1	CkpZVfB1Ciq63pNfrJoSf7rh8S5kKus9P5yMB3U2fqhureknoRS3c
1146	fee_transfer	1643	900000000	1	CkpZrHYuKfRnQV1jvQ197B5qn7kY5nmfa4jnqHSsE1sxLB7DtPp6s
1147	fee_transfer	1643	439500000	1	CkpZif4we8rai5L5F41CrWTZYfjSxn8Sisfgr3L8KJQR11opaLqRn
1165	fee_transfer	641	105000000	1	CkpYR2jKcpxZmUmD6jPYv4uMWn7UgZCdfVd5yvDosSviTDjG9cCpM
1168	fee_transfer	1693	21000000	1	Ckpa6rrsfYrQRGn873qXV2kJ1BH5CDtQUr9g1YHy3dJxrsZkkzBR4
1171	coinbase	1615	720000000000	1	CkpaK93VhYhdVMcFF2ChuTCf3fyKHNNCbQ53VTC4h53LffPJigPSZ
1172	fee_transfer	1615	140000000	1	CkpYZPT8QfkJPneiqDRC2Vyy2x6KnX7jZ3mo4f6eQMhyqRKpdYgYX
1174	fee_transfer	1685	201000000	1	CkpYt3fPWthiyjtg7d2ZkgKNQXmkuCCrb9ZVbMZyhorFhHgs2SukL
1184	fee_transfer	1710	839000000	1	CkpZSKaH93q9asfCpapAb9Sds2cdyNW1phe8p2NadWRTPYrnFSKfn
1186	fee_transfer	1685	415000000	1	CkpZECSisz5oRkYAin3cs5iALHERC313MTS29tkyovjxgZweyEDUC
1189	fee_transfer	1688	220000000	1	CkpYugqch7cc2bk5XRPrK9zrty2yzQRP3Qco3bDe9GuQy4W938xjy
1194	fee_transfer	1677	130000000	1	CkpYmT92qNcX9suvUAtAqoz6AULcqJsKermww6XEoHVA2LG2JzHyW
1197	fee_transfer	1700	140000000	1	Ckpa9EeHuoMvooHu4mHJoEM9X2CTw8riegypQ58kfPiohBZnDd7Do
1198	coinbase	1431	720000000000	1	CkpaJKo5Z6S2Vpnrbw24kvv2JB64rGrfx3bNabJi9Md2nRZLcZgsF
1199	fee_transfer	1431	10000000	1	CkpZkSDRKGiRoGVVbEZ5avwQy7dvNLV17xPnqxKNG6qXJyjjvXPkt
1206	fee_transfer	1444	130000000	1	CkpZr86EA8TcDefXKPeZfR4JcpwmtwMYnDyXWJ3Piw2esizHpGEvt
1208	fee_transfer	1716	130000000	1	CkpZksMHAA8QdH4unAowiUJwBRUhqfCh5DKRmo67aW9AEr96GNMTt
1217	fee_transfer	470	120000000	1	CkpZ8HysqAdSX1fvQWJUJmsQ9Ga11F7bziDWHGm3QqAihE8od8ki6
1219	fee_transfer	171	200000000	1	CkpYy5WsDfpCsvm211WV28RDAuoU2w3ryNkVUmWkFtAHMw2GsegGA
1220	fee_transfer	171	2039999990	1	CkpZ3mkgB5ua67v9XqPUG4UgwqMq1CZVemEuZDBZj6arWspBo5MUc
1224	fee_transfer	171	1230000000	1	CkpYd9TVwEzJVgysJvk5y5guCrR2TLz6T2w1cLjajXoEZju6UaX9o
1238	fee_transfer	1471	100000000	1	CkpZUFQXB2kJYPyjGSBP7YA5YgnibzuyyaBHnboEr8DuzvryQ1Whs
1241	fee_transfer	58	100000000	1	CkpYdoEBJpqtReZ3RwW74TobDrX9kCD1D2pSWsFtQts8y3M1nHyWS
1242	fee_transfer	369	90000000	1	CkpZyuTvMtLbPF4Y9JNeadEHxz3ogUaWgdLWAnpUStRnYvaqvwNzK
1247	fee_transfer	1677	63000000	1	CkpYaKMTSM4iBQXBgSW7qbWJKK1Lk6yaJ2v7i688tBzkb1r4RXe8f
1249	fee_transfer	1759	940000000	1	CkpYpGBv1iBfK44SvQ8qEv4UNkxnMsg6w5bue68JKvymS8YDSP66P
1251	fee_transfer	576	803000000	1	CkpYYxB2fBQDQ3Mszu6MBPQetYUHQGejNrYXB4gWikBYPfZrWsGNs
1136	fee_transfer	1759	20000000	1	Ckpa2b6Hj4J8DDuK3GWmoxBpDRE1ufWBXzNWMVSTGqj8u1AFM87pX
1139	fee_transfer	1549	110000000	1	CkpZTnkp3USZ2HHoxHJpEazaAXMEkc8zzEX3wgm3tTkne9VbtyQAZ
1149	fee_transfer	1668	40000000	1	CkpaGAheh9y3XLW4UWndXc9g5VEiAWwyfvrwkkPtDcpeJNLPYMbyn
1150	fee_transfer	1759	10000000	1	CkpaAguob3AmpBMCcPdotbQgM9gir5ucZ2P7iYXyBGWppwcFEQpwP
1155	fee_transfer_via_coinbase	1603	10000000	1	CkpYhsw1Nxnd8UvyNGXmSgxs8GoCExG5zxGBoZbsjpJdrxrcbs5Bk
1156	coinbase	1610	720000000000	1	CkpZ9ZEZjMzEHALMYiyDsm6twvZCWm3aDBYCTTmJqzitFkYRPmJB5
1161	fee_transfer	1762	20000000	1	CkpaAvtdkU4TVyV5wnpFyQzsTjxU6HPfQnquoTKQkUcXgKjgZNebF
1163	coinbase	1666	720000000000	1	CkpYkRekLj2uEVJ9R3PgrmWRSsDxxwQAvjtYkABJyCKAaFKS6hzNd
1164	fee_transfer	1666	10000000	1	CkpZdKJNhZ1J1xEQ97ebp9LhrS2mxDjtznoSANoauArRebek5GDe8
1167	fee_transfer	1616	20000000	1	CkpZr1RFRZb9RiTD6FL1viUzBUfRqCPkX6xiSN2NT7ZZFaoKs8uwR
1175	fee_transfer	1555	110000000	1	CkpZygNQCpAEw44czAHo5P9ztiAtBRDprTpv4MhNMDd8Q1ahcbarG
1177	fee_transfer	1710	1490000000	1	CkpYujMHNkEPDXoW7kmryFJUCSFNkyRyh4v8zJeJPwxKXV4btcMxc
1178	fee_transfer	1710	120000000	1	CkpZtxCxnvyaywDtzWiVRJRm2g4uVYz1b844QmeXQYW6g4Jvjm3z6
1179	fee_transfer	1729	630000000	1	CkpZDSmgLjdkSmQq6NEGAv6nZnEkhH4uyrZDBfwSKBMxGPrYmDNxx
1183	fee_transfer	1607	11000000	1	CkpZVJ86aQa6vNCrvMd4K7xr6ECQ2pUshoGMddjLz2DWqEBHSq6HY
1188	fee_transfer	1690	21000000	1	CkpaKJHNC3cWWvhSUSp9A4SNNrXCZDMb5esMi5ZapxxDrPRSq5e9P
1193	fee_transfer	1594	150000000	1	CkpZfpzTWBPxBybjNE3RzjBaANPNjehTTiKBFEXPPGdtjcZSA5GRU
1201	fee_transfer	1684	140000000	1	CkpYVVQafN9BoCQ93xSfhmg3qjLrZJV3gAXjWw6AuSJ7peXbs1ENW
1204	fee_transfer	1599	1100000000	1	CkpZC9HDgZonqn35jdZh9rFdnzw6gHQn7FXDxnntNNKScw6JBS3HN
1205	fee_transfer	1599	105000000	1	CkpZxZyR7bWQNmmoMqfdagmW6sEW3YFpwBHqsRpF6d72kRzuXsBbU
1227	fee_transfer	576	110000000	1	Ckpa8RCMvzH7igysDETgqTD8z4fmaJRcDspyHAYcLzyTPTf2P2bfw
1230	fee_transfer	1476	1220000000	1	CkpZ8xNHytQGxBwP6Xdq9x3YjTd9ZSftcrcmsu3p87mkZXSVLkvUx
1232	fee_transfer	576	80000000	1	Ckpa3j5NfqKCNCFpF56hwDmhh2btTK9f5EgAgrhwhVjanFaoqrPhV
1235	fee_transfer_via_coinbase	1443	100000000000	1	CkpZAhsUSLvEGnPjEt1ZDnjdrneNVuzNvnajEvveqQdMfiSxK9zUv
1236	coinbase	632	720000000000	1	CkpYc8NfvoTKccGEp8uwBjzxyzdsN65eS2RKdT3bain59DfCT1ZPk
1237	fee_transfer	632	100000000	1	Ckpa3QzyFCJTawawj1gujxq6xja7TVqwz6NEF963zgLYso3tymbgd
1246	fee_transfer	1756	490000000	1	CkpZNMQ96E9tcmUDcsJtZVk3AHPfCDjYcNTYjSxysWAkNVraZaK6Z
1255	fee_transfer	1649	220000000	1	CkpYqxoLdzndgnJVy9vuh1nZUhBwFK5GNv9SQZVx5uHTFArsDoK2S
1137	coinbase	1630	720000000000	1	CkpZwoVAWooFvzv2ZerF3WWhymfkhx7bsrsSakyNk6uW5gwkvqPmw
1138	fee_transfer	1630	10000000	1	CkpZjEEX3iCSWGjxXjRgxGPd8oXZz1HeY5qjvcjhJ3nYkaUFkosGb
1148	fee_transfer	1451	20000000	1	CkpYYVD3qPcp24B8yuL88Dhu2hrwzSy4XXd9gMiLrYxpR9sqSnpMa
1151	coinbase	686	720000000000	1	CkpZVcicAoZUTZi2NZqo55hJNdXivZA5y1xCyvcv5dhfCe4umidFB
1152	fee_transfer	686	20000000	1	CkpYVgSgSPjc1jjzJp6m1f2k9mKXSKPm6NcYC1VeHXGDF9WxyWM8G
1159	fee_transfer	1717	20000000	1	CkpZW76mnAakQyo3QhYMXCiV6ezkaVETXRHzwRBL6jF5goudNTdAZ
1162	fee_transfer	1677	14000000	1	CkpZLav6juszhg2sDEsPiQZpiDqZdXxbnRctfUYMa4UKPYGmctE9Y
1166	fee_transfer	1602	110000000	1	CkpYx4GyU8ytPNtPacfrkRoNfn5CTpXPn13ek8uL8mdNabaDP4RRb
1169	fee_transfer	1759	30000000	1	CkpZmb7RPaPfZXWH9vYWb1SLWFi8gxB3fL5FoctyEY7FeNdfqBcf2
1170	fee_transfer	1673	140000000	1	CkpZTZbSHKJaN8hCQcCpLYQD3yhGjyPxRkHjhctsr6sKx1H9QjkCb
1180	fee_transfer	1671	630000000	1	CkpZGzWS234Bqi7snYp6ZxCKmZiFRV5MVzVFTQ6Jh9zDGYkDaUnop
1181	fee_transfer	1522	110000000	1	CkpYifbS6rjdNNid4561T2xB88YTjAUbSk218P8stHmwtn8XYWUAe
1182	fee_transfer	1509	31000000	1	CkpZgTRat38ZmxuZgjhtzoLqF8wrVwyE8j2Txu57wgpJKwf4HxrR6
1185	fee_transfer	1701	1000000	1	CkpZv4WSwyd5UUsejwf9ZYbz35tZ7SHK2EtRYMPFYPXmxkB5tXxyq
1190	fee_transfer	1683	220000000	1	CkpZSQh7xjugcJ4E68ygF2avFLz9dJRJPAj26PXhdYWYXfPemjaFb
1191	fee_transfer	632	11000000	1	CkpZKCnhav4JnJdpg9bcLjhLo6XBYTuJ7vAvX6nfcuVXgmxMcdG5z
1196	fee_transfer	1688	140000000	1	CkpZ9ArNVGqyr2hHzQpGUTuMemk8ZWC5284aK7p2pkqpzPHNo7cXH
1203	fee_transfer	1685	410000000	1	CkpZTVzPZSiQuBm3vdc3UzKHGu8nnnBNS38dNwWJM41XSSY1wRcr6
1209	fee_transfer	1687	130000000	1	CkpYj9NoVuSYoE14P6D2ks3ddvXziSfBouHifUWXa3vvGxcQQ2BsP
1210	fee_transfer	1559	8299999	1	CkpZzWrT2BKRm2Wp7WobcYJ7S1mk1LXnDtCZcDFamdQTJ5xoBHUGw
1211	fee_transfer	1761	1	1	CkpZ6kevYPJhaCkfgbr9JuNzJHVER9pM17zw3CwmSkDeL2goSCiYH
1212	fee_transfer	1460	1700000	1	CkpZajbjxw64jYd2PKm21PiDpq1TAvuHbmHzhqdWVwdMhJbn5oym2
1213	fee_transfer	1426	110000000	1	CkpZCGbPKb2Mgvgx37WGLYisuwjRcm8mSXxPguJwu4v89u4Bm8Ev4
1215	fee_transfer	1710	820000000	1	CkpaLWQWj4BFfJHtcgPbpzAMFr5uXezqs48VK6ZrpyyaY1uNtrPqP
1216	fee_transfer	1710	393000000	1	CkpYTAPhE7WTSCX3n7Q2jgzubSkSZeiouVKSDaFxE7mUFQ1VHq5Uh
1218	fee_transfer	1686	110000000	1	CkpYckPooc47SnYpJ7RobSRdsj7KGeJKZvE3VaYvuB86FnJxePCUg
1221	fee_transfer	1434	10000000	1	CkpZDBTjP6vvA551yNGTqQSJ3bZCyoHD3kiUvPQvGva28v8JMeZs6
1222	fee_transfer	1685	110000000	1	CkpYbLtghaRMdwT6YNkhbgWQLrKHy8taZyFXQhZwSqRtHXPSYktwN
1223	fee_transfer	641	2856000000	1	CkpZ8xfSyrHDHyyE6i6Q1YNeueHRTS2CRTzkrZ9Qgyqq33WBT5Lgy
1225	coinbase	1801	720000000000	1	CkpZxWfZ59L4sKbz4yNz18wZFfzAGMaHM4DRFHC2vr92hF2JhKFvb
1226	fee_transfer	1801	30000000	1	CkpZyERbhN7FXPbpjUXXXCC9dw2uENdB33RcWAzC9veFcQusqRZGJ
1233	fee_transfer	1677	50000000	1	Ckpa6sx6ADmmU7dT7yXTzvmUPwMRxDT9VfiCnoFWuC8yDbvb5rK1p
1234	fee_transfer	1686	60000000	1	CkpZnXxZmmAquPNT2oFDNveZZqbGQUSvVjCA42S6Yy3bDrPwAZLmA
1239	fee_transfer	1683	100000000	1	CkpYTJLRRU5ZBHbAwAs3nkQv8sGawLdRJEoHRH5GcAkW28eBaLi4E
1240	fee_transfer	1672	100000000	1	CkpZWCNMXbQcEWa61Gjqf4z5TZGyKTaEnc7VtbxFYpFQPa2PAv5xV
1243	fee_transfer	369	1760000000	1	CkpZbJCjWK9212tgdwzZK26PaWzKJ2ukpdBecMJc28BNb3CYcvpaR
1248	fee_transfer	1560	63000000	1	Ckpa4kKj4B9v2yw7aAZz5SVivD4sxyLPph6jqnHs6cDo6R15JkWyJ
1253	fee_transfer	633	130000000	1	CkpZWsjAUUt8rtXz8qxfNhn66HpeoVwfdC1Cc8ihkEX7Pns4p5WRe
1254	fee_transfer	1677	220000000	1	CkpZSRyX2FD62BF41qo1Nj6iL8h8Lbp1dfjaHttuLfvcK2FNA5sMY
1257	fee_transfer	369	11000000	1	CkpZYaoDKibiSKWfie75kjKAZAnpRSW5byjGFtyyHM9iNfVRpRk2m
1258	fee_transfer	369	1050000000	1	CkpaGHxwqAkMfwQAjX9xs4ytexVPqxfWnum2CybZjYiQbf877J2ut
1259	fee_transfer	1601	11000000	1	Ckpa3rkhAkXtsQ4YTihdtvZBctqcT7ZJkBevto6p3ntXxZwAY5bhj
1260	fee_transfer	1689	11000000	1	CkpZNp67baT7FCum3NzhCMCti4NVorFTPk8dMYPXtyx9XgGKMPGjG
1261	fee_transfer	1649	120000000	1	CkpZ53mkxRwdaEcJ7cETnAXBeKog5qUGkvAMCJ8MkCsNsvkwP8o76
1262	fee_transfer	1440	220000000	1	CkpZxbEqw7TdAYpG7KhtnRYEdEDajKH6nxQaNHCzACTJ22Uqnipov
1263	fee_transfer	1708	2550000000	1	CkpYyDqsDQLw4EktQywoywsNc7T16X7SPaf2dRhezKdjHisoGHRYC
1264	fee_transfer	1708	500000000	1	CkpZVM7VbB8XXoawmQsR9hKBjJn6d24TJ5fUfA629Eag1kGGubZBG
1265	fee_transfer	1693	120000000	1	CkpZAW2LyoRe1vFTfqtXM35DZC5qstNMDL1Qt6txndKnnpQNNL2oi
1266	fee_transfer	1599	120000000	1	CkpYVdkJdKSiNwZhwQxAs5Rr4LMHgt5z3VpEQepjKfFnDPF7pNH6j
1267	fee_transfer	1684	60000000	1	CkpZt7Ccz3Q3xix1TMxedR4Z2xFzRGWcXVWDTxZNySY5i9ps854eS
1268	fee_transfer	1727	100000000	1	CkpZeqikojZ6G3bRUuvFLHr9a1872w6WxS25opyUGuCmtmyFi371b
1269	fee_transfer	1474	100000000	1	CkpYnbcJiAFPrh6gLARNv1qzV6JgX7wxisgz2P9XfFPXKrkEiFrGG
1270	fee_transfer	1687	30000000	1	CkpZYcmCbyE6huEK8qLqQSuZD6azhPWUgHwKKgQCsMHxNUwV7LzJe
1271	fee_transfer	1476	140000000	1	CkpYw59wSYhaP3sS2poNCH1xpZ3DpJk4SDKnyRguHhDeuRtJyxYWx
1272	fee_transfer	1675	140000000	1	CkpYiQi48KVb2pALR7vPJafJ6njme2kTYfWhk9C7tM1H13xRGaa85
1273	fee_transfer	1613	981000000	1	CkpYqFD655zHhWhh2SX4Ki9R85uahaC8SKr5nsc2US9FahCwyu6qU
1274	fee_transfer	1613	50000000	1	CkpZDkWvneTeZMLiMzDEZAgtwB7611tUS5QQZvvifR9jZULfpapPD
1275	fee_transfer	1613	80000000	1	CkpYtwQLVAjx4wwSTCBEhh9sdXPrKYNvpp5B3wECa5aXigkbAcW1N
1276	fee_transfer	1719	20000000	1	CkpYe9LPkQ9vRtVw3P2TQsDzgUJrhZRuceBixEqHGFmicoaWhhEUT
1277	fee_transfer	1698	110000000	1	CkpZAsXS1MQPXdc6virMKPjKLWGV6GeC7CLA9g6dprTSYRZf4bhHp
1278	fee_transfer	1623	110000000	1	CkpaA8A1eA3vDnuAPogWDPZRjPP2M4UPydjPpjUVYWkC4ZrSxa3HK
1279	fee_transfer	1623	500000000	1	CkpZVAEF7mFtNSQkqtt9vU9EMjA6xSVGLa6GVkQyzaA5nYXxdVkXS
1280	fee_transfer	1567	101	1	CkpYc4t1WEmE5BUJvhspyFMn4W5YrvGkVVTnDBhpQiTmGJn5B8Dks
1281	fee_transfer	1794	100000	1	CkpZDQ8nq8tRnxCowvDqVLx1q4Wu2oSaaCvLsnzPDsk9vYxfZiRTG
1282	fee_transfer	1623	629899898	1	CkpZw85mMRzWnhRhZRdEvDLxK1Ke76zyc9PyqCg2YRbT1MrDM1W1D
1283	fee_transfer	1587	500000000	1	Ckpa2odQfpsiFweoECLx1YptJz5VGeBSzTyzZpT5yRhYA2nEDoUsz
1284	fee_transfer	1587	630000000	1	CkpYcm9j9ZhEyNGQEzCTXtinzmkDBHouGG3TeeNSd38NiBUwA4xUJ
1285	fee_transfer_via_coinbase	1420	2422222	1	CkpYdcBUXTCyQBX7y5UkLmH91JLFtWBPky772aqxA6Buk4hJ1kKiV
1286	coinbase	1682	720000000000	1	Ckpa3d39b2pbQx7NTsQEEMq9rkXRa1H4vJLd7mnuQ4F5bMKDYso9L
1287	fee_transfer	1693	500000000	1	CkpZUWQmAZzJsaBYK9VJbo5FUz2qdKmu3DTx9hGkx3u5VZG9yTeKu
1288	fee_transfer	1693	630000000	1	CkpYUQUcnQkFdgCU7C1xHMNBwkctRAuxmAGQ82yWxNAZwEuRfexyb
1289	fee_transfer	1682	500000000	1	Ckpa2cjKtJ5Zh4wgAkVuvgQVEU3xWXJgHYbN22nXhx57ema7gPJ4k
1290	fee_transfer	1682	630000000	1	CkpZAfksWvNZYD9196BJALqKUVkWzJKnRGsmYzdFMzZKJPqivRw8E
1295	fee_transfer	641	3560000000	1	CkpZKokvqpAaGMD1VZUtqcaVpPfSXrHFtbsHvnrmsH5U28cXLQbqg
1296	fee_transfer	641	390000000	1	CkpaGieRKnekVz6yNe4TQGQNmVRJR67e3Wj5JDYUHnH8qZAxDdj84
1299	fee_transfer	44	140000000	1	CkpaHgDGWQF2dh6qZxoGvK9qr5hNufb2eWM11ApUAorwCjj9uLkYf
1303	fee_transfer	1708	1943000000	1	CkpaAcKz3gLkJq64E4eDWwvJ32w7oqx74jqyCdzaE63thqGxCeT6d
1306	fee_transfer	1541	120000000	1	CkpYxfFQ9PdHYDQ1xZ6TRjmxnNgrPaxeRKeXjmbARXGCQWYc3CFzi
1308	fee_transfer	576	2870000000	1	CkpZV2ag5EaF4hzn83MZCbhCtQjk5wxN4ueozLowH54if5wo9GiKs
1309	fee_transfer	576	450000000	1	CkpZ4Vcgk2SR8QdCWajFp3JXCStanKyQww7BTdhQFdycyVFYw8zzV
1318	fee_transfer	1708	230000000	1	CkpZxR4cFHM7KcWGX5U2jQKsfcbNzd16tT5WGfzoUf3nWKCboKrKu
1326	fee_transfer	1695	1280000000	1	CkpaCSsepmLfW5XGqyBV5a9xibVFVqZBjMkvUx8DVT5UTmihGbjR1
1327	fee_transfer	1695	90000000	1	CkpZirk6NHseCiXrmgZCpAiYC12XAHzBux2N5ZckE8nWjYqW3cTKA
1335	fee_transfer	1692	110000000	1	CkpZbS1ZxrLSm1J6RVX5h7Jy7DBJoKx9bATQPzdeShtqyGZoDeq8D
1337	fee_transfer	1719	1780000000	1	CkpZjsSq1pLYvHr8xUbWVNUeSbsrpxkWMSByxdyHJnrFEtJ6Ayk3H
1338	fee_transfer	1719	230000000	1	CkpZRSgP4ate1CPSVyxff1Y2ReFmYZLd5bFzEda2G91uCmFBg8Www
1347	fee_transfer	1549	30000000	1	CkpZxZeo681g2AsPqBrM1H77CQK9opAKupu1EoL6QLyYAw9JgzHcK
1353	fee_transfer	1670	30000000	1	CkpZ4bpZ11NKeQkKQ9mrg7fWNYUoiQDraH4cSijccsuvEs9f4oPnE
1358	fee_transfer	1447	50000000	1	CkpZESBFWWeczdotHVqCdxHDrvRzXN3vHmpUWtsmRBuBqh9TKo8nN
1363	fee_transfer	1709	40000000	1	Ckpa11Fgk3B22mob3dQRReoiD5cjU3yEVXDJw3H8VNg2ezVLzCoG2
1364	fee_transfer	1608	130000000	1	CkpaKA8joUhhu86LE7uxsQ6KpUBJrY8pxL6GY6M6GJ7y5g8M4ccRf
1367	fee_transfer	1402	110000000	1	CkpZ6XKRX2PUf3i1ZgexaPABaogRFK6gqfwZvvvfuy5D5KEmDoRKo
1378	fee_transfer	1451	40000000	1	CkpYrY7TdjBoawrdQ78nKovy3bWUWbcZCo3kQ3dnFnYZhSJakazH6
1381	fee_transfer	1402	11000000	1	CkpZ4UL6B1eWsn4G1nvDk8mueT8Ue6wso3R1WDSfWBpA6ZgQBhzXc
1385	fee_transfer	1688	750000	1	CkpZsPpkN4jtiPVGmyBYn8eipZ3exzVhcgMsGV6sx86BbAAog7sWa
1386	fee_transfer	1646	9250000	1	CkpZ4d5TwDXqJeLqWe8Y1WdETfcwRAywUud13KwVx5MmNGPmw6S1n
1392	fee_transfer	1668	110000000	1	CkpZZbBzgLi4sxNkUJChZBGEuEdiFVW8WoH2KL5JqL8vpufpeQda7
1395	fee_transfer	1786	1	1	CkpZLNnQ8xdi1kbyzNHtTWnwj74Bn2AWx5LfXZmiHbByQ7DAE74g8
1396	fee_transfer	1706	1499999	1	CkpZRRFWM3wQCdg4dH7xd65QfEuPP4yr3mZ6QZqwPf4sC2EL4s8mi
1397	fee_transfer	1646	18500000	1	CkpYhiVrXcp25ZV8ndFwfKfHMTNi5qTgnUZ8fYaDiMQcbaJGXqruh
1400	fee_transfer	1673	30000000	1	CkpZsStkGW728Lnd8YAsUW8vnd2oxME8AhcuwdrPJtQcrVLo5HGyL
1411	fee_transfer	1521	20000000	1	CkpZiPhCu2qk3Cwy2Hg3g7XwaD6cGBgA3dqegKaQNioQpzYYFJ3C5
1416	fee_transfer	1683	1000000	1	CkpYomVM8uH1HV57uuFjSZ51Cd3Evnfqgy53XLGjafjqrj5NN7Tkr
1418	fee_transfer	1448	1000000	1	CkpZbWeriaCYqcAG9gr3jEKpTqrZrb1DcZzgdfdYQYo6zRZKGYGxo
1420	fee_transfer	1402	1000000	1	CkpZQC3CrRJiWP8PnKghXiTfvQDLa6mrUX5eXA8txyDwx9hQQfeWf
1421	fee_transfer	1684	2000000	1	CkpZgCMTgYefejqEVV5mD7XHSQnqBcsLEqnPQDyyLmY1FGkf5msi2
1422	fee_transfer	1716	1000000	1	CkpaCo29yAr66PXQainP4Uz9nUvqv8Jb1tNJZcu56wVaqFxWfW9o4
1423	fee_transfer	1419	3000000	1	CkpZAQYiG2p7UbeBEFXQ2qAAZwcBHRVtRyMuZD57Ysydr7WKgkVYk
1425	fee_transfer	596	1000000	1	CkpZ4ifZxqyDwpsBJyW6k5jbLVWxecvFbuxp3nUviNeGnDptw5PZf
1427	fee_transfer	1692	1000000	1	CkpZnwSpEtPQTh8GCFV2XEVa47nvAsoV9Zwbb5MzPPJAsvogeCeaU
1429	fee_transfer	1677	390000000	1	CkpZieGeqpUZzYiGLQEYx7ao98X3aGDsE6azNoMyh9t58s9FZmpM1
1431	fee_transfer	1715	700000000	1	CkpYTCLwCFNVQxA7NbRZtdEzwKTUX5SMTqtbr8pdVqeZS2GKXaZvB
1291	coinbase	1493	720000000000	1	CkpZjp7q2YLiBsv3RYAN2ZgRX6v4CPjfZqdxCx2MWJEKRrJd6cVH4
1292	fee_transfer	1493	10000000	1	CkpYqBgERgEkLwbenyYzyzB7ju5umHjM6Lirq3cRqJvzDKNvx4NDN
1301	fee_transfer	44	2500000000	1	CkpZrAbrGZjM5eaLcVhXJSh6ep9cYwBswsv2AvnFLUsjZrx9xqQx8
1314	fee_transfer	1444	110000000	1	CkpYwPugeKgLxDtgkXusyvi3ccX1aPqipcRwt9YXkDA9YK58iSDYt
1315	fee_transfer	1607	2850000000	1	CkpZFuFtrHr634fDaCaLARzPVsmPZYsAzAED5K5B5vwN1Pno4riD5
1321	fee_transfer	1458	31110000	1	CkpZkqrSKW4fYFkYq14sz2vxnQfEpGw3jU1pjN6rp2dXJfugE2VCa
1324	fee_transfer	1564	30000000	1	CkpZnHLepBwgxqUgRaLV6HmK5Ezz5P9h4BQqnFFMzpEHtmCjcFvaF
1331	fee_transfer	1650	110000000	1	CkpYx8Zy8ngftWARvWzEGUpKZJ3tnUdzvN8nGDJR8WwyGAqn9jhmg
1332	fee_transfer	1768	1790000000	1	CkpZfrpYfK9w3ScmkRjUdU3goHSZHABnB7UTcUWCddbB6AM4dguj4
1333	fee_transfer	1710	110000000	1	CkpYhMHfuaTHwmYRGTr37AAJrjM88nNGRegJGpRTcidj3SqVBaUV6
1345	fee_transfer	1607	1499899898	1	CkpZTRZfezeVnmBpWvwVKKpX4ZKoG8ZhvWRtcxEYqrfe8jFtoULUh
1348	fee_transfer	1671	30000000	1	CkpYfyu2BGByiwQukxCZjaPakD1Pduh5H8a8VbHKWTDfnWHBRbRRa
1349	fee_transfer	641	1040000000	1	CkpZuFG1SUHzEVggXD6o1HjHC7Gv6pW46Cx8TzFUcGLi7NypvTtuw
1350	fee_transfer	641	170000000	1	CkpYcHmDFB933Dc3ZucsCgdF94NSJYrQULDxbqUCQ2ccbLeB9ZFku
1351	fee_transfer_via_coinbase	1584	500000000	1	CkpZ7V9obaT37ZUTX7W5JyxAUu3DVcRxfsoWyuwseL7AGMT6NxG66
1352	coinbase	1740	720000000000	1	CkpZbcoZ4xwpDyJB2RtRidK7TtnPMJtj6BHQipnX2rLad3PRFV4RE
1356	fee_transfer	1768	21110000	1	CkpYTUZk5DCvDKfLSgzjViYq8g2n2hMGpt2McBDYKYuRh4MPuyt2b
1357	fee_transfer	1622	1201110000	1	CkpZtaJnotw9j23iL7C8cjxQCACG2fxbprQAaQWGb6nBagXXuwdkj
1365	fee_transfer	1684	130000000	1	CkpYU4bqTaAmnX9zyka3GXnyBw6g5bWoepxjTgYqFFegBwYjfDrKE
1370	fee_transfer_via_coinbase	1613	250000000	1	CkpZQFowFbX62oy6qUa91mbcbobVH8G4zF2YRrHHcGU7sDUzYkMbG
1371	coinbase	1711	720000000000	1	CkpZcgZGzinKqdqFmzLY1PZ1diAaC5mvuysSbqLwTJ6SrAbsF73LH
1382	fee_transfer	1601	1000000	1	CkpZ4UiRSZDYT86eAkTLt6RHAnWpp4jw2VjzJeX83czhVzCQQK76t
1383	fee_transfer	1688	1000000	1	CkpZ8e9AXs33DUbLSm6rdzhutpAPEmMrn1pVmCdKkx6CkbMZAL2F3
1384	fee_transfer	1724	30000000	1	CkpaAR1hXzAhmtWTgFu8j9wC8r5U4pRUvZRzFw7oTCSwJfNKnqoKM
1405	fee_transfer	1560	120000000	1	CkpaGswtJJrCFgcPKwKsNjdBdQzfdVagvvYAmfniqmow9ZdYVdnHq
1413	fee_transfer	1717	11000000	1	CkpZiqYLeGKNbJitLHUthstobkxcVwTB2rKWFuxedQBZqyMaBT2kK
1415	fee_transfer	1694	220000000	1	CkpYqZAmosBQ4xDsfNJwcf4b3L1PgAyWaVnHDJVvTxLDPsRkMKuRE
1424	fee_transfer	633	1000000	1	CkpZaFtxybwq7v3LgmCi2tnpf7Ha2u7w3bXvuNXGctiuUWbZDfktN
1428	fee_transfer	1559	1000000	1	CkpZG8sgCEbKyk3oFAwSHhjrVYATjo2aBLeUWksDu4RFEgk4VjHuB
1430	fee_transfer	1607	700000000	1	CkpZvjrph7o6cJMWGYonHsycaGJGSRJ6vA5LPW5YK1SVL9TLTsezK
1293	fee_transfer	1610	210000000	1	CkpZrPS9aRi6xSWwwJECLbQrcJu4z44HCiFnpJ38NSKkiFxXs7ai4
1297	fee_transfer	1682	140000000	1	CkpZMkP9q2eaAQYSpjZiNE4j8FZ1j2BLqLTm72p7z4Nvfig79acRF
1300	fee_transfer	1710	140000000	1	Ckpa9Jor3fAKdk23CvfY77WXF4R69ZnUDG9uDF4j6gbpwaqLfH619
1302	fee_transfer	1489	40000000	1	CkpZncA1K4jVa2QPPG1dRkDByFJvHk3ogNGRDeU2KPxTaNH8i2f4q
1304	fee_transfer	1598	20000000	1	CkpZh5U7Jv4K2UioPRJjerkZP6PFd2oXb5TpbdPa7ahUXDev19RZY
1305	fee_transfer	606	30000000	1	CkpYkPG7cbqUeeL27FdVM7N4k4XhnadeJjuAKyVy2EMSFyuDx4CX8
1307	fee_transfer	576	120000000	1	CkpaCnXxgns8zZx7zckS54bvicfZTZaThjjvckirzPCisoanFkuwe
1310	coinbase	1665	720000000000	1	CkpZwSAxBvDkE8wB6kVL3rEJVZ77nHnJwSEmaVWpkhqJJdjqkKtpg
1311	fee_transfer	1665	10000000	1	CkpZucs2j7uTgAUiJhkqih2m78tkVKb7Z9mxosiiHHj2BSGU7hjVB
1312	fee_transfer	43	1800000000	1	Ckpa9ezmsYdLjvTsz4HfqcsHD6AEC4q9A16YWAv6URG58mtYTGCCr
1320	fee_transfer	1762	330000000	1	CkpZDZjjj138Au5QbEnAWDrmDMENzuC2kGVXxah2TDymNoU9QH98f
1322	fee_transfer	1706	31110000	1	CkpZGBo9Z6qAVM4XP9ujJhL9MjYJW3pvB1T1N3G7cKLug9BwqCkZf
1325	fee_transfer	1764	20000000	1	CkpYucKJ9ecx1VRKowYFaWJ4sECmRquJb6v7rjvESTX2g9FTMy7PA
1330	fee_transfer	1723	610000000	1	Ckpa22oKTZ3aUnyrnnVqtQZZ2PiSdQ1VNEZf42jP5qFfy5iBqwjXo
1339	coinbase	1632	720000000000	1	CkpYneTx2VNEfHKJEDWiFuxoQAYVdhQVEmRbL7ZzZbHqTsVvgogdK
1340	fee_transfer	1632	10000000	1	CkpZ1eKFYX5pmX4quFtimmWtcezEM9xWjfs42Kw4Dn32WGUt2BUuP
1341	fee_transfer	1719	210000000	1	CkpYmUkDaCiSTpjFRGZpA9FXrDpnqqbRicizd2BSxKTwfEQxKXP86
1342	fee_transfer	641	1890000000	1	Ckpa7CYU9gsNoeriMx8vs6si9ykt91V5rpC8d3wQgujpi2vQZJnyB
1343	fee_transfer	1608	2010000000	1	CkpZCESLJNnGqmBozxorZmRMRqXK8AswXN6ghtYnHszJSqagHoz9F
1344	fee_transfer	1608	50000000	1	CkpZ6yNJp6dpB5JHN7kyPLzpvmyQCxMbfoZEdPqVJaz2x6LzMoEdi
1346	fee_transfer	1700	30000000	1	CkpZRoxuTyV1AbJj74WQGBsMQqRbtXmun6PYg1HY97wopWMkoxSnj
1359	fee_transfer	44	120000000	1	CkpZhMYjNd1PpX3YrsYQLh8pmZp6tqBpBojWM2A38v2EYFjQcjKjf
1361	coinbase	1629	720000000000	1	CkpYtcuwTNCGByJVRHb36Nf98mceZcyExUV7Z9HBKcxQRH3jShGfu
1362	fee_transfer	1629	10000000	1	Ckpa63eDbpGLyArfXfZ2WHSoErD61a6YKQeWs3rB7LcTEtUNXNiWw
1375	fee_transfer	1508	30000000	1	CkpYUCYqpK8UeRHCwRXQexKy2oTEZXpcgN2t23DQ8G3YiE7WLmch4
1380	fee_transfer	1706	11000000	1	CkpZLTFDkm4cgdM4UMG71So7LA1Gu5DVgf6AcR3Q9LNx2JBQzAvpf
1388	fee_transfer	1696	30000000	1	CkpZKAdNiZswPUxteYwm35pkBhkBNEajvybUj3CLY3ieC6Fe2gB84
1389	fee_transfer	1749	40000000	1	CkpZPuu6FSxyT3Afm2izt4PtyBuXVZPRxx96zh58JSsPjhjMyXG1M
1390	fee_transfer	1696	110000000	1	CkpZ21gA3i3KxgC8VbwiZutGSe43PX6NyKcTkwBpF1da4u454v6RW
1393	fee_transfer	641	110000000	1	CkpZAZ75VMN1rs1zbbxFeshvRU9BhpxcxkJazrHtnYcb7Hvn6kdAS
1401	fee_transfer	1675	50000000	1	CkpYWPQYKKnrBBRKfVXBcALCTYrzoVH963okxVxq6na68pZ3mp1wL
1407	fee_transfer	1634	9899999	1	CkpZj9FuzPBagGQrZp9Pup8Qrno1b5hGZ8ccPi4XL7sWnmMPV9hWS
1408	fee_transfer	1791	10000000	1	CkpYnp2ZYLubStRMik5JCWzUT1yoaCr72JXc6ofEsPvBYaMDtXeLR
1409	fee_transfer_via_coinbase	379	1000	1	Ckpa5m7NTE9DHbbd94yZtUK5K56TTMmoUUVWW37GiMV1ku6NaaFQU
1410	coinbase	43	720000000000	1	CkpaESyxNhYi77KVmAyvm65HXVGWyBH2Rif7aEfedkTNKYgJiAMYS
1414	fee_transfer	1518	1230000000	1	CkpZ9yAERDxttbrn3qgEuWJ5pFeXR2PZ2gacX7DWA5D16P81naW85
1419	fee_transfer	1694	112000000	1	CkpYxmMRyKETAb8cEezzcNHJXYanWXgTaaXpw3LMZgy1YdSAaUJmP
1426	fee_transfer	1685	1000000	1	CkpZCB3kRZGWFtoMnKJ6zm72QP9WRauR6UJSK9Q3xJeodu67y46b8
1294	fee_transfer	1610	110000000	1	CkpaJKMfaXVcJJQGBLVLZdV9sXYGAZXRmdGES35q4KNUExfNoTz5y
1298	fee_transfer	1683	140000000	1	Ckpa9tyXNpxrcZVfwaz6eK4jCL1suEqQnsfgdDUbUP75RDK6zsT3a
1313	fee_transfer	1705	70000000	1	CkpYVsXamZRaBoAkcmjWmeYHKDi5xRVEMwFoiBH6XXfWF9x9y4bk6
1316	coinbase	1580	720000000000	1	CkpYZUq9MrugB5L6vQkwN6hKnimiJKh3C943a2NACqNmAhBSpwzjz
1317	fee_transfer	1580	10000000	1	CkpZ1nf6bXbhKgf46UJbrkFQnUxwFmWd9xHAPBAz752hbN9geCmcA
1319	fee_transfer	1513	30000000	1	CkpZkHvukaEreQipGzJSVhK9iGAe9PyszZoYqkHszJdYZkaWcMZHZ
1323	fee_transfer	1489	230000000	1	CkpaGpah68gCqZSWqYmiq4pApYf67KRmxanZUz3t6wuraVh2NLSnW
1328	fee_transfer	1451	30000000	1	Ckpa7tF8ept9MsLV2RAEyD6YFWmHNDTSr9NqprLtW6q1bfYQy9Wa6
1329	fee_transfer	1518	610000000	1	CkpYZc27xrjx4KPjbCpefr4fV2sc9vPoSvUn8vESbRzrNQDNEPaVu
1334	fee_transfer	1694	110000000	1	CkpaJ7WaQw2A7AUF3Ei1oYbtk2aNNmjrJ23iW5QubKezDzBY72QBA
1336	fee_transfer	1677	70000000	1	CkpZbSKEwcGyLr2fTW6CkPPDJSJ11DqhEYyHCKa9chQk28EmFMgYa
1354	fee_transfer	1698	29900000	1	CkpYpqfAEzufPuPwkk6FgS5MysBT1UgANouR8c9HNoy6viUSJPix4
1355	fee_transfer	1568	100000	1	CkpYxVj6WKEG4BcaQaNriGdJbKqEmQ4yQNaTtDnHPf2EyCdTDtB1m
1360	fee_transfer	1463	20000000	1	CkpZ86NF52AiCNXhnbRqM7jaFJKQJRZrM6xAG3SAyZqN3ErhEYvMa
1366	fee_transfer	1657	110000000	1	CkpZsDn1obj1Lr4VXoaTkGnfaZNMBs1kjkRcV6gJvFrw3XsBmUryD
1368	fee_transfer_via_coinbase	1791	1000000024	1	CkpZAuM1ECDYccCtnTxqSDXeQfQdesiBjBkYUBdmFkuVrBv2qn3rz
1369	coinbase	1622	720000000000	1	CkpZoPrQcCsFqsxmnDjWyameMNFFBjNuGCCDow53s9WAG5sSUwzN6
1372	fee_transfer_via_coinbase	152	10000000	1	CkpYr3VnHM7TWQSJh2cVpvVqSUp9BXCrzwg9DEWHKaq7CPLFXbz8S
1373	coinbase	1671	720000000000	1	CkpZDSXWBQ2bc2UiuvrV9bEKLmabLfA2JRkEHov9kSitSKV5Mcu4i
1374	fee_transfer	152	10000000	1	CkpYr3VnHM7TWQSJh2cVpvVqSUp9BXCrzwg9DEWHKaq7CPLFXbz8S
1376	coinbase	1511	720000000000	1	CkpZpYcYb8jRGyAAUWiut1dpd1aCL33Z4jzNekT6TVAG7FUGfKFoa
1377	fee_transfer	1511	10000000	1	CkpYkwfsWJxPsFZGJLZua2qvZLbXE7LEHM4NZ5UXNEC3Kvd2E6d6K
1379	fee_transfer	1593	11000000	1	CkpZAgHwXxUjg3rh5aAp9PHXBZq6FqHKxKcwmrv59NGvoZM8yaJKv
1387	fee_transfer	1716	20000000	1	CkpYXiwjKKQWmMkLfCJg6qjEuLrbHPqJaBpTi48jrTQxBKoCN3mwQ
1391	fee_transfer	1457	110000000	1	CkpYxccNgATwNGJwi8NK1Sgq5oMXeREATMtTU5DhYCvaDp8BX8uxP
1394	fee_transfer	618	20000000	1	CkpZSyKUd1HP8taRUtSszazxRSs8gVRWeAi639q1SpqEdr7cy9Pe9
1398	fee_transfer_via_coinbase	1527	250000000	1	CkpZ88s4j1NqbfHRJ6WVEYfnWWXCxjj7GMuffkNDP6yNiGMKTtnet
1399	coinbase	1427	720000000000	1	CkpYuDPtFqgvH6CSYFE5LeoTTgqxwGTyypixdA9rY272vzxxEUNKp
1402	fee_transfer	1837	10	1	CkpYqfoHPHdzH7qTQcjZmHfCqibNsYzEnh2iPHcsNcxzBGFyjnYv3
1403	fee_transfer	1675	49999977	1	CkpZSEgJqqXggTxa5LQtShCanYeSJp73FmtpJisaZCUHwpiTMCiAe
1404	fee_transfer	1831	1	1	CkpYdopUpWHsmih8GAmiZxdmMa3s18KiFNquz5oPQyTZe3tDhy4Li
1406	fee_transfer	1747	30000000	1	CkpZsMDZ2LDgcHeBYPvyZpVfshkrTM8ep2j1kLBTtzSjM1coyvXUA
1412	fee_transfer	1749	20000000	1	CkpZM1GXbGsdjpx8ADet5B37dVrYJTWhiXs9F383cA4bVK3pzA83K
1417	fee_transfer	1717	1000000	1	CkpaGodGetnVQHLuBEFaDTBMbY3Mq3nFeHenmUkocHfERKQR9fhsU
1432	fee_transfer	484	1000000	1	CkpaF2Y8TpVVnTBiVFwTPRcvomV9vAxjeSVLW3EXFdDfH6pnM5FCp
1433	coinbase	95	720000000000	1	CkpZmrSH6GXrtnyva1JiMpsBj6hWkCAQRmg9d1YTv4fkf98yVkmTr
1434	fee_transfer	1693	100000000	1	CkpZWHY643QkDH8V2bLqxwnVqoDcx31FDu1oUbv8X2Rbsinu61eAk
1435	fee_transfer	1426	1380000000	1	CkpZ2eghpSLcvsFVJa8s5r9YEBW2SRYTSXjguTFtFrJH1jCXJe7jA
1436	fee_transfer	1637	100000000	1	CkpZXdqdAgvrujw7YPeceRGwrMKmYAqrKJWVDAQrgmU5Kkq2y1MBq
1437	fee_transfer	1762	100000000	1	CkpZGD6ntNJupV7hB7fsZQDZsbBvNMVtUKXK5AQEyYvG78psPUAZf
1438	coinbase	1562	720000000000	1	Ckpa9mee9JScDUBqH9Ahsvs3zkNtmZ3KJo87DmBf9eSMcJrsCGJ4h
1439	fee_transfer	1727	911000000	1	CkpaHqvcTVj5TjsUaGnZ6abs7d16rYzK3WNNskgvJ7KDmK6Rqzokk
1440	coinbase	1567	720000000000	1	CkpZakdbCwy9u4qKQRyJg3DWaLcPZmGcB8je9BmE5w11qTH1Zy12N
1441	fee_transfer	1419	911000000	1	CkpYRDmDcsQHQPzCVQBMSic2FG5hVwgfjU6QjvWtWkBTq5ww954AC
1442	fee_transfer	1419	900000	1	CkpZL7xZMsP7MCDz5fVjMr8zKRRRbp9UwRZ5WjT3HeTmFZydeTdCF
1443	fee_transfer	1735	913000000	1	CkpaDyd3owuxrwsFeiAPjuapGbeqHaB4GBMQEPZaXbZLZq8AQdixX
1444	fee_transfer	1509	100000000	1	CkpYpmxmXzy5ybN8FtSdkXgZPjJvLo8Drh7JcbqaCb7pg8jU28MPC
1445	fee_transfer	1727	130000000	1	CkpYuh2pp8EYCLFN9DzvvNPqHsN3mAtpyY7kaVPK4LiZ7H8GS5hV3
1446	fee_transfer	369	200000000	1	CkpZFa6NRLUKHCEzXCsCk1PBqijr3mw1BW8S26JctBDU8ffh6H2rj
1447	fee_transfer	1637	200000000	1	CkpYxM7zvFaRZNSCKEKwQS1ddvNZBsE5WdipbNvN7Z8EVSKgnSKGu
1448	coinbase	1528	720000000000	1	CkpZRQsV3kumTVwsFDNcUk7552nSBfixT3KUJh2TrtEDe7MQ6L1sC
1449	fee_transfer	1528	200000000	1	CkpZnDRFvdDWWtBD1pcWBEtyC1tJcSRVbYfBCfckgwDMYYemcA5uP
1450	coinbase	1419	720000000000	1	Ckpa7J8UXgniWJQA7ssNdQxi58PD24UNsssudWPDdp5YBXtZAkZP9
1451	fee_transfer	1546	100000000	1	CkpZrAK8fAMLNv3mCDvnxas5dRwJPdJPbLZhjY1ttTMuvpdv2Ndsg
1452	fee_transfer	1675	100000000	1	CkpYnWLumAKsLKxYGo2qqqD9YYPht7jJKrCkQaP1fyiFYAQvpKHZh
1453	coinbase	1464	720000000000	1	CkpZ4ozatRPAj6f1Vg89iikwygfXQbDrQpqgiadUBu5ZTShD3W3GV
1454	coinbase	1398	720000000000	1	CkpYpNm3iMYGgZYectJEy2yj72jt71jMtnvXNAF4jMvtatnhPqMRh
1455	fee_transfer	1398	10000000	1	CkpZY6zR23z66qvoTYh6jCMG3V1WyQQLv7hukSSB1T33E5DHs6Jhy
1456	fee_transfer	1739	30000000	1	CkpaAuAgLePdSi5wwAjdwR6Unr6CsS757tbETfUthgMQ3rbTodmVx
1457	fee_transfer_via_coinbase	416	10000000	1	Ckpa3ASG7G8K8S9dqrAv377jF9nNiahkJupx2w4Lza3TryKSaqCLD
1458	coinbase	1739	720000000000	1	Ckpa8DvHCR8FGkv8kk6Nch5P5GwSkFXzVCLGWVoffsz1qgV4eRvqL
1459	fee_transfer	1805	5000000	1	CkpYVrXoY2Sx62QUtokkby5X9PpbNh3Tuca8tHR6fPMQF2DWymHkH
1460	fee_transfer	1470	4200000	1	CkpZ3Bfh3j2QedtJj9jNxLicZJWco1xCka6RVcgcfNY8jTHA7vuoY
1461	fee_transfer	1794	3	1	CkpYtvLqVAfuRzvuRewNAXFtBHN2Xz6VmN3Gf7AzMnj2LHmXJyLUy
1462	fee_transfer	1637	10799997	1	CkpZVHhEEFeSgyqJd4iCANYJfUwMe3oXE4qRGS1xoN39sXb3J3RWu
1463	coinbase	623	720000000000	1	CkpYUL2MXHLJjtp695PYswue8kieGUG7cq5GQvNhKFpdXz83TnRY8
1464	fee_transfer	623	40000000	1	CkpYvpvL9Uo2w2LYXyh1fSUgJjsFYvM29CpDuAJBroUFbMMa9ocoM
1465	fee_transfer	1724	900000000	1	CkpYafNERDwPzDy9cxPqNoADUUzHDTbfiNnKv7vsjv5ZemD4wZV6N
1466	fee_transfer	1679	210000000	1	CkpYrViMDX2TzuMX3PeokgeHGuGqhPZ4vuYi8siq3mNDAMaviN3hB
1467	fee_transfer	1688	210000000	1	CkpaDDmDTdaWwX4nooSHxCTgoBmxKp1zqAzP9XDeVhfJuUZEcgMpT
1468	fee_transfer	1402	210000000	1	CkpZxZKwcWaAT19a6WW6NpRwdoBC3bjtxk7kprLXDhFmPkFnrtFGX
1472	fee_transfer	1726	6	1	CkpZM3DGAXPctBt6x67VEZB2gpVp9xVvkVyaKVtymUy6VUBKhjmBs
1473	fee_transfer	1688	28099986	1	CkpZAPW4hkXK6kAnZFub4bdBQHfoRWzXqxTQr8STBwqupikXienpY
1474	fee_transfer	1758	200000	1	CkpYTyyUSC9anuxrPv2EpSDe7mCY5BtXgFwmqgRA4ctRCNsaf9xsu
1475	fee_transfer	1831	1700000	1	Ckpa3HqfQEMytBMqxcyN1jchUJyfBzEbkyM2ciGqcWjrpLpNXkQ7d
1476	fee_transfer	1794	8	1	CkpZ1K4KC2nwKmz9XTAQGDbuBMofz1kWAWPLr6u1GaCfD6EsanQVK
1477	fee_transfer	416	90000000	1	CkpZofPBpxBiHpFeCHEhXdodZmQSEbbYqW7nKmwdjohdGHZWb7of6
1487	fee_transfer	1678	50000000	1	CkpaDEFUhFUnSoXNPHmaNMtZmiW4rggV2ofAZ4E35Nt6fT2MrPGH4
1490	fee_transfer	1611	30000000	1	CkpYz4wxDCmK6cweU27uDoPYaUyBge6ZfVDvd2WwA4F4bacQKwMh7
1492	fee_transfer	1451	280000000	1	CkpZazpHVReQwMs44VKx1To1dzhWSix9kg1ZUn6L8bDqvjdvBB8cR
1501	fee_transfer	1662	20000000	1	CkpYSX21yBNAU8WKL3ScCxc8WQtaPALzKXhg3hfm2xWwpdA62DzHw
1502	fee_transfer	1687	160000000	1	CkpYmq1qggBffZMzTmqrWRZuqtqAYyBzugsTSj9KagvFXrZMYUpEC
1507	fee_transfer	1445	130000000	1	Ckpa2QUrChR1G47kF1yGr5YBvv4TDkSqtrt92YU1agGcwSE3j6zpu
1511	fee_transfer	1402	50000000	1	CkpYzxde8w24h42tpPSqWsMV8uKcPyFzsY1WMZbQXk2iLgKMUQwL9
1514	fee_transfer	1703	210000000	1	CkpaCPbfYyeNi4hFQRjf4udTMKf2gtsdXyV8QHCfuvVropRaQdfoi
1521	fee_transfer	44	130000000	1	CkpYTNxVsbHuBmbWNPnMBC64yyHKpVR87guoA5CnTDpTHaiQNt5dX
1540	fee_transfer	1571	2020000000	1	CkpYnzHgkvBRv7trioBMWBMXiN99ejzqJeKhjsuYdKNqzTqhiJ3do
1541	fee_transfer	1571	670000000	1	CkpZpBn3428vPADKrftnCdmXJC6H7oXFYa827Mky6WzbG3gyNPnE4
1542	fee_transfer	1571	580000000	1	CkpZZmncXoY7YuNzWQGoCVAJ5NkkFwqRQAvrFofrWdBdtWDbAMP94
1545	coinbase	1871	720000000000	1	Ckpa37BbjgZUXqiheQXrt8k2UAjhQvi38dM4RpQt47CD3HTgZr2qR
1546	fee_transfer	1871	10000000	1	CkpZvpGV8MdpGUavkgDQ52AfNcj3RCpxwDZ9WjP6E5AJ7SARaY96A
1547	fee_transfer	1547	110000000	1	CkpZqN1zhcBfmPfjjKgyg8ZXCjBSdLatGRHP616r4nCeHsz7Ebgti
1551	fee_transfer	1849	1600	1	CkpZxV9pCgRn6XKLLo9d6kGVype6Pb3fdkDerf2SjMJocR1jnYLqj
1552	fee_transfer	606	24898389	1	CkpZpudYkJcJhKLukeAYadqDTMZSi4Yv7hNnLDv3ZdUicD9sQJobM
1553	fee_transfer	1831	11	1	Ckpa1bwTHLnfGxyVtEdn3QpYCpoEDigTGXnmsPgMQa64gXqsgTKTt
1554	fee_transfer	1460	5100000	1	CkpZrCtRRCo4KuYmPjGhPHUWGrDmX8uCbKvP6AbN5nGDd8Cu8w14N
1557	fee_transfer	1704	60000000	1	CkpYc6T2RnBsVb96ScvXwYkAZbex6Bva6UKWGb3qLD26es7A5GFpc
1575	coinbase	317	720000000000	1	CkpYwzGZMDqxKfuCCqP1hU7RpZZqsQ38FACAS898DhjsQMWqgrEki
1576	fee_transfer	317	20000000	1	CkpYqnrCtAnGjtwYG3psCz5Rdac3fq8Fgwxs8NuLhGsKMu8ra2JU3
1581	fee_transfer	363	20000000	1	CkpZWpPnc7zQmWGxdZbqhfYi2y1vmc4t9TvyZhfRP8vEnGJdk2XmB
1583	fee_transfer_via_coinbase	1509	10	1	CkpYZUFS8fEG9Lc1mo2JeBCER9G6iNqnbcvpGG68jb3w4DdJXs3Jc
1584	coinbase	1692	720000000000	1	CkpZkWbfPVrxFKPyQQYk6n4QcwCzswWzCnHuhA44nqg7VPeUYWpyB
1585	fee_transfer	1692	39999980	1	CkpYVKxgSswSa9oJ3a2L7T8eyPG7SUFinEUXknku549bFzdt4LpLm
1586	fee_transfer	1509	20	1	CkpZejZDkJYxZNvTYniyy6rWQTZ2G4JFGLSHZ83PxKn6tJJ4CPTpn
1594	fee_transfer	1762	60000000	1	CkpZfGGLKBEEyfnX3HjFj8Y4r9oJ12JqG83UczqvqEwi8jdkD4yxk
1597	fee_transfer	1444	70000000	1	CkpYkrzXhByoENR9ahsXKXBervvoPCqYvXuFdAmbZF9cicvui1ATt
1615	fee_transfer	1647	20000000	1	CkpYYGr6QoCDa58zYnMaA9aeHVyrjC4ekVdy5KnTWb7xs44BrZDYK
1618	fee_transfer	1685	25000000	1	CkpZYn1car2b9JFLcAmHjUZL2Gz931toMw9Z3bRirJ8XHTCt7kFx3
1621	fee_transfer	1623	2320000000	1	CkpZ9HM3CSJTRNnqP21YLwQqLA9FoeYCubrRsr875PXR5AUWTioad
1622	fee_transfer	1849	300	1	CkpYfYyomSdRk6Jo8hX8Fusx5BM7r5FyziC7WVJC84xUBhurLYxJd
1623	fee_transfer	1831	5	1	CkpZvgMqSRTyMKVAW6A8sAiYPFVVZehXuANop5zQh6ang8in7cwuT
1624	fee_transfer	1623	199999695	1	CkpZ4uHCutDVuntkWd1yzUx63tutAAnFSybGqhkhsz5a3SrgFdQSh
1469	fee_transfer	1690	210000000	1	CkpZm12GcWgZaBx1QMF7hWtJDzdKGDWm9gG5Ltsd6kDABGpWKmW7X
1470	coinbase	1850	720000000000	1	CkpaBpzjJB1vyHNnZMc87u3oHWEFmSCbWiXetZXzZJqgptYU7tTJy
1471	fee_transfer	1850	10000000	1	CkpYohf9SHxQ5SxSkZHpVSPtYBBNKt8BEFsnwV7XMGXksKgNFpKaG
1481	fee_transfer	1474	120000000	1	CkpZrKHwnrgRQHBvDwSzKrB66mkzZVUADNaiad3v2EgdU72EqjNTg
1483	fee_transfer	1677	300000000	1	CkpZCgYHBqQ1bHP4NiDRm2FrWChZxJYrodWMR4URbLF6YCok6Qe1a
1486	fee_transfer	1611	50000000	1	CkpZ58SdAj29KfGdJCw3LzLsoGpuTWAvhMBsriuzXAdUvpduNddTt
1489	fee_transfer	1573	30000000	1	Ckpa62dXsJULQvfcbzmMjhRn8fQXWvVUt4r9VZMhS87zHj7RoftEX
1494	fee_transfer	243	20000000	1	CkpZdjy5U3Vz4MPjChNyGtYgUQbFpFudUcxc2u62qqrfxMN8zript
1495	coinbase	1563	720000000000	1	CkpYVShZdBoauBVUHvPfSnsoXyuyaZkzNrzb2Jyn9dDE37bcww5JG
1496	fee_transfer	1563	20000000	1	CkpZAE7pBS5K4U8QuCYCfVNAyhdzUeyA7BJGgFm5oPhb7ZS4WWQaY
1497	fee_transfer	1541	50000000	1	CkpZPghSY2619P9AqVkF3B9L1TYV6Zkyiyb7GbqxQRdA5vN1CrWrD
1499	fee_transfer	632	30000000	1	CkpZWyRDTeDNdALBE49bjXFFLTcm1eupXnt4VBRpQhfxpEEyPGHxp
1509	fee_transfer	633	30000000	1	CkpZJbz6N8FCoE4w98nHF9fghBvAVeCaMQZ7xPQy4TpkuyB6ddY1j
1513	fee_transfer	1685	50000000	1	CkpZnZw2vMMvZyQYCTapte93ws5uHtvffxMDP5Mway7kjhY2qaZ2o
1515	fee_transfer	1702	210000000	1	CkpZjgsD6Q7yddMjdH3kvSHAxyyWEkxoFoFuuN4KufNesjLWHxqw8
1520	fee_transfer	1522	820000000	1	CkpYj5iiLumXxpWH8FSsHfLZakUEdzaf3Zuz4xt2qbopo8KUzK5Di
1526	fee_transfer	1476	560000000	1	CkpZQMPMchxwmnEFjpbbZjcgtxbBmKCZa84xxe5Rh5urHTS66mQsB
1530	fee_transfer	1746	40000000	1	CkpZeCJCQ3stVkQkN96piwtSrHuzbMzxw7MBZWA6UAAJmzttAfBwj
1535	fee_transfer	1649	230000000	1	CkpYwHfx5HYEZ5rcUAyhaQwT6QLZVT1SY35S249L3ukHjjG5bvrkK
1537	fee_transfer	1601	230000000	1	CkpZm4ZGSp4bRChHWSLfz7GrKdhMDZeTEGaa8Wtf3D6zde8hFy9Sb
1538	fee_transfer	1680	30000000	1	CkpYhzyMsu72q7hmRuof784mS1Ggpn5ntyFn9MZc1JdZ4NULT34Eh
1548	fee_transfer	1705	120000000	1	CkpYw9U95LP1mFWGx8pHr2R7dmsmKdHhJukaqCoeKSwQ5a8tLrfBg
1555	fee_transfer	1623	200000000	1	CkpZ3JHPtAGPhjdSuaT6z1XqMbvHgC8LJ15Uekxdyn2UqbfsostJs
1558	fee_transfer	1756	60000000	1	Ckpa38xGEuKsDpJ7Hn7vkq9gFbCf3U41uLiMsw6Ak3m1JzexdNZ2b
1565	fee_transfer	1850	20000000	1	CkpYwqobE6Q2XcMEVbpv3MpVDX16AKwe5UTq71GFhjEZtgaCLewWg
1566	fee_transfer	1679	60000000	1	CkpZYjmXXGPVX6bk1GzUaQxwrVWk6YNYw4tYNfaBSfJFAUM8DvJdd
1567	fee_transfer	576	60000000	1	CkpZPZS83SWaDbaEE82F3nGE8Vxxtu8Xq9iUfFgYWiKg2KSqf5M8S
1568	fee_transfer	1506	40000000	1	CkpYsyL6zjknEeiGNj5Cq7P1yufWzXNjf14Yn1DRhzWkQ2Xd3hwQF
1570	fee_transfer	1727	40000000	1	CkpZUc52XCpbWrH317f9LQ28MVtrxK2G5Mn8QqugUvoNp5wrX7TJL
1572	coinbase	689	720000000000	1	CkpZNEr69stkLiZCCs5yA6pQwPUS9uJSdBAnUyDQYPFbUVqz5o1Wu
1573	fee_transfer	689	2180000000	1	CkpYafbQBBRfCLtY9Z4b6de5FAdBQ8kP7vptJSNLkDyehG6LFR2n8
1579	fee_transfer	606	21000000	1	CkpaDh7zj2rv7W2Eq3cVKhM4CEgjZL4QCYQLLLhmhHFdKePAGsx1y
1580	fee_transfer	1739	1000000	1	CkpZCK1rFA67y396FvmFBtQ9CYqEbZgn6UjYPNZc3A2fMWwfK4qmF
1590	fee_transfer	1506	81000000	1	CkpYYNfUgjRNpfAPztLLzQ2eS4ejgaoVkwu8BadiHtBhicx5NopsD
1601	fee_transfer	1564	60000000	1	CkpaK59EKb62wRMdjPqZbuxBzzYG5iEXrvEnQEZHnfuWYnFzzTahq
1604	fee_transfer	1654	40000000	1	CkpYx7P1oMN9omcUNi6qdjT9GCqLTwYzfCh5q69Rk467ttC6dKogN
1616	fee_transfer	1673	40000000	1	CkpZzzUdYLWvaJCfSR8PPdmDjyJmHu3nEhsWUJ9L7ZNSVnKfubN4B
1620	fee_transfer	58	40000000	1	CkpZrDS25m5ad5rRF2ZbTwjnWt3N52cm1xiLyqFtWeJ9A8hVmAnhE
1478	fee_transfer	1726	1	1	CkpaHpypi6h1EnKhBdAbjQ3bodpKeDo9gom6kfQVycQ2tteUN4E71
1479	fee_transfer	1474	119899968	1	CkpZHxbwwrzd8LUXdoytCcp6976iKGAc6KSadrBW35hWFDe8hour1
1480	fee_transfer	1794	31	1	CkpYargY1HWPjqXou2bSAaX1h2Vw594Yq1kzFbtgXwfWisCBPWCBH
1484	fee_transfer	1708	50000000	1	CkpZBQHVjSJ8z4zYCYv3xeMacx6PUb6jhGsMetiDotesDMKw9ey3p
1488	fee_transfer	1445	30000000	1	CkpZ9sivwhP36fZPhSKorXjp8dcQuSqX3uSSX5FZ33G4D1jqZnJ3C
1491	fee_transfer	1757	30000000	1	CkpZgmuW8EbM9rTD2oLs3meML5QNeXfaw2473N8gwV7WxJhbjTC3s
1493	fee_transfer	1546	30000000	1	CkpYp9NBKo3cSVZ8k3yHpkzihPBHom51mkU1EKdPcnbPJeRKpc63n
1503	fee_transfer	1675	30000000	1	CkpZ9pryaZM87u2xUsxdH3MxwRXFhPasbT7ZHRMAXZVtYUYpPGNbP
1505	fee_transfer	1508	50000000	1	CkpZZAX4wLoV8gsnnwRo6HG6ve3PvJET36pcTZ462VqHfmVMVecDf
1506	fee_transfer	1471	130000000	1	CkpYxu2g9h8Di2Rp27c6mvaZ3wAeAQsUKSP8BXJRPKwLfescuTc8S
1508	fee_transfer	111	10000000	1	CkpZAUde6VovcgY5bERP7DhAAsfpQri89VMx5VifqWPvVLeZCVQcb
1512	fee_transfer	1656	50000000	1	CkpaAWG2mKMy2F6v5MvM6PsEwSVZwy7GmkzZCy6xLHGzsNQiMNRWo
1522	fee_transfer	1683	130000000	1	CkpYgLWW4PHGfxGccWvrYRbqRZe6Edrx7fxUqubcFAUiMC6HLeZ12
1523	fee_transfer	1588	210000000	1	CkpZ8i1m2iQ6155pYNX8pFKCin5SP4SzPJPCTWLRTcTezcKYar33x
1525	fee_transfer	1695	130000000	1	CkpZk1nmwnhj4AcHcRRNttpSKAtKKvmYzQFHGWAco6vMkTooRbKUr
1528	fee_transfer	1508	1010000000	1	CkpZzH8u8qKHHTwrfR573taziSLsDNzhr3o3ZRdH2TZ7q5z8RN7zK
1532	coinbase	1408	720000000000	1	CkpZaBjxcQKzRWYS7TKVzR48zSitwd7XY5XR2GyJPnSvDCyTSde4g
1533	fee_transfer	1408	10000000	1	CkpYcHu1hp5ZUNkSz2kgqGqZ9vgnYtuvm1ZZT1KQjxRwENF4SwvUY
1534	fee_transfer	1508	1000000	1	CkpYWqQkdd2tUfuFazMFRLcqDiMPDhWivF4u6pRXHcy9HY4FC9Eja
1543	fee_transfer	1756	30000000	1	CkpYrU3AReVUwKpKm54F2DKTBAdLp31N6HQML2kw4Xw8VvFcFZtKu
1544	fee_transfer	676	1001000000	1	CkpYxiyET1YXK1eiNbfZHVPMwYyoPNz6mU8BdXzZM7EmESMV4urSZ
1549	coinbase	96	720000000000	1	CkpYWByK853BYYGMsqZGjrNCNMXtHLYiE3yRyPkQ5BnJkmyqNuykJ
1550	fee_transfer	96	10000000	1	CkpYg1chZgmqNKpshXZf5VZKkXLF9T6gAGGtCELUrTrDzAgqQ1Bcj
1556	fee_transfer	1746	60000000	1	CkpZLzGqaLnvrwnKwTeZRNEej5GYao5G1ci1kwxvju742qeqC1sri
1563	fee_transfer	1623	80000000	1	CkpZN5NJaAYCW9vqMeBqgySEkR3ybqFRULNNdJw9qjJH4QzQSiN8R
1564	fee_transfer	700	40000000	1	CkpZMbnkcvf6gRC7Kuq3uwVGQrjdzEXJJk64NbGD2ZU3Nu8rENkNQ
1574	fee_transfer	1650	40000000	1	CkpaCFqTYZDxAgiucB9nvf5GW3zk3fPcgk6uEsshW3sztavs7NKjA
1577	fee_transfer	43	60000000	1	CkpZmDvhGWWjSao72AscWZgfb4pxBfEp9GtFHWJ3yuJjauAkp43S1
1578	fee_transfer	1458	21000000	1	CkpZdmifZ8fDmN69brzRjcKC6KufDKkgxYpnBC4ju9YcFVGc47LmF
1589	fee_transfer	1448	50000000	1	CkpZj9gTqjSyfrWGbb5LPno8us1LFpcpto7CDqhx3oXYrUjTFRYDt
1593	fee_transfer	1489	2000000	1	Ckpa1q6DWhyam3ceYYqETD9EyH671VZVQzM32dhssqmd3rz6pjP6o
1595	fee_transfer	1607	40000000	1	CkpZF32ttf2RKSE3pGacaLNzSYxSjRHEa3CiLaWqgBAXNhQqn3ZNG
1596	fee_transfer	641	80000000	1	CkpaCHy6P4YLXyYhneQNdqdQ8i9CLh3Wwx7jKEpReMFo2k5EjdzHP
1598	fee_transfer	1611	70000000	1	CkpYWk8E9nGfmHXsp9KBo5QpHE4JQPBXMnuWh3xKZfHiuimKq9VVG
1605	fee_transfer	1457	60000000	1	CkpZrqHjw5xxTQ6Mxck7tjuvFHvz35h6RHpTKJp4ZDrbpsae1pE5S
1606	fee_transfer	1547	40000000	1	CkpZhHg4uCoJKsZtDpCdW9oAwYH41vgETCW21qqpLkbAYdBvYsDqy
1607	fee_transfer	1470	20000000	1	CkpZu47SDWd3AjNAUYWSLNegVwHf4cwgrK6rsHiMGYXVb4atYbHfz
1617	fee_transfer	1670	40000000	1	CkpZLTwF5Nq3XDmkBgJuv56fRZnxvUzCEpp4JrWPaNJfDNCsW9LUB
1625	fee_transfer	1650	400000000	1	CkpZufMM7Br5VKwcpf3mQ29hfhSmroQ94qpY3mZBn9deGQ8ZzGmte
1626	fee_transfer	1650	813999990	1	CkpYq1LU1ZVwUroUwgxq5DWghQJJgQpjaxGYh4XwYy5izQkcUWH5G
1627	fee_transfer	1854	10	1	CkpZqBSFC2fBJRbAyRjkkbVpTKeBxvhkN9YHaBNdPNW1v8CC3jdFP
1482	fee_transfer	1724	880000000	1	CkpYj4hpv1Az5nTJcWyG4onmJoEamfoRvSJpd1DSdmbzLCdY3C6K2
1485	fee_transfer	1560	50000000	1	CkpZYpXiBodK3MrY7FkpC5sqNmiFeYzr3UovCQ7eDTkKAQTebQuQy
1498	fee_transfer	1508	640000000	1	CkpZGSYPYh8AdJiG2CyLZpyJ2dJTD3QnihzNQpvv2DvVewLxRkzxm
1500	fee_transfer	1440	30000000	1	CkpYxaxJJz7x53HVATCjXmZN1SujH2vBQcuXK2xACmbEw36UNtZPQ
1504	fee_transfer	1271	20000000	1	CkpaJLV9NWN8Di8Rcio6bqZEVJk3mJKFpq7GPPEFMsN4zafo6rU9n
1510	fee_transfer	1657	40000000	1	CkpYZpN2DNWYdNUn8cwV1H5r3fQCHDH3gvSU4c8RLNfTfHk7Uy7y9
1516	fee_transfer	1573	120000000	1	Ckpa89CUtUZmRVoMwbsRuZzq9i9jgXaWKjdoJVKbSW2sh1f6BXdHx
1517	fee_transfer	457	25000000	1	CkpYigtBtbJnDSTiavQ9R98ZFSN991nJQQnQhzyWrBFq6KkaEf2P4
1518	fee_transfer	696	25000000	1	CkpZgzyYokHxrRkAvZzu4o6nE24affGePrwcmx1e4BSaeBiFkF1hr
1519	fee_transfer	1683	770000000	1	CkpZeUAzvBAraRjgsMrq93ULVhmqJSiwStJqHjGU2BnAXkz1X4Zqi
1524	fee_transfer	1683	210000000	1	Ckpa597KqphbacjFUo9khmFMJqC1SKgFqU5MELZz1xt7LzKte7W7r
1527	fee_transfer	1727	30000000	1	CkpYrGf29hvzwRoTbqPfegpa51FmkN6z6Lty7NSzaRQY3eNKL2Hid
1529	fee_transfer	1637	31000000	1	CkpYVTWqig78Pi1XKwM5yTRBQFNpXsX7ksZJUYrRgGTRJ21Tj4p7G
1531	fee_transfer	1747	40000000	1	CkpZHq9HZvZsJAM6o1Tgi45366B4woMsrVSBiRrVm7qQ5GYTXRbrm
1536	fee_transfer	1610	230000000	1	CkpZMHPQRUwYK4PDTKTvLcfkD6DEEQYdYZGsX9FecBPoDBVDJCCpp
1539	fee_transfer	1508	200000000	1	CkpaCvr6s6jeFnnAnWRqw29eA54Z2RXp28oyg4BHsfy8JUMWz5BSy
1559	fee_transfer	1747	60000000	1	CkpZZDakQBgQ1ZBipUYMKaCPYrNw4wCQV4a6LdpuvEa4pD9B5G7Xi
1560	fee_transfer	1571	760000000	1	CkpYYHLtU1T6dD1PUmevn2NwgyrxmK3EywMJzLLWsBJCFZy5QauDA
1561	fee_transfer	608	10000000	1	CkpZTzUJeUjacprjpATk1NMNRfvTLME82WR1Ni36UUJYYr4KQKWSP
1562	fee_transfer	1571	300000000	1	CkpZcJmjemPr1a94z3mvYi8vThJsiMGK4AMW9tDi2cMvg1TSivL8Z
1569	fee_transfer	596	40000000	1	CkpZ7x6PtNeS3XVcWDSXVsarvuXLpZaHWdFjRaswBmCYFzBAfeQLq
1571	fee_transfer	1740	1220000000	1	CkpZz6aWLxii364EXfPf3oir6YmoCRZZuu5Uqz348kUrfV1u1YhsH
1582	fee_transfer	1560	40000000	1	CkpZzs7B4RC4PuPVJzJ5cGfwVzQeyx76HWa8Xa52ntTP7gNDSRZ7c
1587	coinbase	1877	720000000000	1	CkpZmSN3Mz2s71McL5Qk7Yp9X7j2rYg2ZoBgo7iFu7pRE2CUJCjFN
1588	fee_transfer	1877	20000000	1	CkpZAwDXC2aXEG2wVzTXcWHGMvHiZnfzmyrAWGWRR2p69v9AoEw6M
1591	fee_transfer	1759	81000000	1	CkpYn1kLPrup3Ps3o8jmBGDm1gQxWPWVcsqiGFgEUXVigaYXeq1hU
1592	fee_transfer	1622	40000000	1	CkpZJrxNekmB5xV8xDRcBkKRLnq1FXkBzT729A63asDm9Eqfp69Ns
1599	coinbase	697	720000000000	1	CkpZYe6aKqVHXkn7C82CrpnVuqsfcVqdx5v6h49qTDLwbJe6T3UJ7
1600	fee_transfer	697	20000000	1	CkpZmE6ZkHeiZZboDKVyNdd5eu7oxV5B8pbaC4wevP4tDL7nt9pkE
1602	coinbase	1879	720000000000	1	CkpYcjeR5SSFEEDhh5w72w7pjK1Va32bB6YQJDiMja8aaWpuhSn2D
1603	fee_transfer	1879	20000000	1	Ckpa3kuckvVxsNHmzH536WvstnZB57tfMKALRssHHzsk6vzyyW19K
1608	coinbase	1667	720000000000	1	CkpZEWCpS4YNHeXVgqMo7v5HeX4h1zpsQ6cwsA3vjCs5UH15J2g57
1609	fee_transfer	1667	160000000	1	CkpZcL3xGrHb5Be8NBwZKYL5Q7SdEQzjLa8W62anLdnX3oh4bbM7p
1610	fee_transfer	171	40000000	1	CkpYqfP4GpDHNQbVbzBoVr4YAVGshrXur4L4eLhMjguUGqWY13pix
1611	fee_transfer_via_coinbase	1867	100000	1	CkpZ9esYuBfzgogM5NjGskWV18n7E49BaeksPcSV4Zz9ahD8oC81q
1612	coinbase	1687	720000000000	1	CkpZJrcpNUDCANuY8esRn3XAoLgbJ6VztModU8eENEEefdJvspQMw
1613	fee_transfer	1867	1100000	1	CkpZkitQ1F7kB84ReYXzNDzwkkGNQJCqjs3Q3fc88BnAYc1emozfy
1614	fee_transfer	1687	28900000	1	CkpZgWvLQTr7BxHuDEo2okbh1qSVYhsx7AEMXfHNzEPbGUfv5dPuw
1619	fee_transfer	1683	65000000	1	CkpZXq6cBuWVoBAdwcyKMb81P59rW215yWDFNaNFSQVj7aBzZQYSp
1628	coinbase	1565	720000000000	1	CkpZ4MhpeffUchdu9XSGrf22mdB3Y6otH4L9aE8nFBhEStWCTLZc5
1629	fee_transfer	1565	40000000	1	CkpaKnygr6jie6z2RffBsTfMhTprMmKBP7TjcNEYRNSvps3e7sJb6
1630	fee_transfer	1714	60000000	1	CkpZG4FNyM3Brec8EJi4uMdMSHxJDDvNgbGXRqFY7649WPwbcg4zt
1631	fee_transfer	484	40000000	1	CkpZ9vEoZqPgKitk6crNm38XgiC1uY3dEyUmXBynhZDhRK4aPmFiJ
1632	fee_transfer	1724	1229900000	1	CkpYXhWQEKxQV1vykLpTQNkBSbXYVY79UEmHchW2dwAdrhXTgjVjb
1633	fee_transfer	1673	60000000	1	CkpYsHPxoPKHebKCms4rksZqBTviganVCu4de2KUmth88FfgRgt9p
1634	fee_transfer	1739	66000000	1	CkpZVCEYrNvMtbNGDzcqZ8RXUQSFxTVmLjL316QyXrLBXtBKAswkv
1635	fee_transfer	1419	40000000	1	CkpZZESADev6nEhYejtNL8cLFq1PG1EfwMMHaehzbTKkA3H2xFu3Q
1636	coinbase	526	720000000000	1	CkpZ1xdw8gNdGucDsREooWJyyaWFnfx3dyb6V4cCykr83piAg168D
1637	fee_transfer	526	20000000	1	CkpZrGZFyY4wYrJATyXi9wGsesYJqENWyGM5UVLXfs29NVFNHHonV
1638	fee_transfer	1508	40000000	1	CkpZvpgWEsXSFn4urMNksaZ5CfgRnmm5zRxtp4NAFrRoWLzDkhT1j
1639	fee_transfer	344	40000000	1	CkpZC8eANgiodJbq18kER7zeiDSrx95dTRTudkbFsxoz9qaQYjQgT
1640	coinbase	1644	720000000000	1	CkpYe44FrhrsRk9jnHG4vuvB4jjMkBRLrtJ9hnMBqnFZMnv3tyn2b
1641	fee_transfer	1644	20000000	1	CkpZQT2oh4CUETyro8YVL7qauViSS7GcNURVgrqem2Nq57DTqnfaV
1642	fee_transfer	484	80000000	1	CkpYUcKUY7fDtfK5RdgRc4awSm9AfY4An2qiVXBURcy48qgTMDe2r
1643	fee_transfer	1672	80000000	1	CkpYofbsLbd4qMJyQpVCnWsKcSeUHsotV61gKnxRGrAtCY72GQD2N
1644	fee_transfer	1764	80000000	1	CkpZuUQCTb3JMP8JXADypRnUoRMXXYzZHJa4GPksYjAQcshAvYZXm
1645	fee_transfer	1683	320000000	1	CkpZEX6QujDgVFTkhW3tAG4EPzpBsvCYP8QULzGUFFGwacio4r9Ah
1646	fee_transfer	44	320000000	1	Ckpa7QijsRch4DxxRt2iLcr4d3PEAhq7KRaKeTqZXAfsDnHbBzMAT
1647	fee_transfer	1764	120000000	1	CkpZ7Utc2a6CvMJNvtCpE8eP62GZC97SdDVaMFLBGWpFAAA8H8c1z
1648	fee_transfer_via_coinbase	228	10000000	1	CkpYvrSPR2UbLP3mqVgmX6fukE5X7dRwdpueNJBq4snfx93KrkrRh
1649	coinbase	1688	720000000000	1	CkpYU8Xgdbp6MoLzWmUQ1qvBdtTPLJe9xSU65kZ4mRzLaumzRicSL
1650	fee_transfer_via_coinbase	1761	1	1	CkpZ6kevYPJhaCkfgbr9JuNzJHVER9pM17zw3CwmSkDeL2goSCiYH
1651	coinbase	1455	720000000000	1	CkpYc29ANpLC5i3FUskMv1Bt1f1EKZYydV1eQuyyPrXGRG4agQhNR
1652	fee_transfer	1761	5	1	CkpYxa4zzL5zfX8NjftpnrrVqgxkZcp8FcSAeR73jxar189jy1hEA
1653	fee_transfer	1455	39999995	1	Ckpa2ZnWpq5syoZdnT6KchYTmbNbsBHeGWjSbaT4kFVEWxWG4U2pm
1654	coinbase	115	720000000000	1	CkpYarge67rmGXbcR2WYeC5g7ngUcNjrGgTmfuGavrCJ9zniLg6Ji
1655	fee_transfer	115	20000000	1	CkpZ5C2MaXefA7237PVwstF9aKZx5tbeKcoWxxgt2LdAA72oMfRR3
1656	coinbase	1499	720000000000	1	CkpZeojcgddTbteLinaHrLRJ8nUmv3UV3kQJLkv7jknfkX4r7f6TD
1657	fee_transfer	1499	20000000	1	CkpZx8TbhJiRHdjRdAYFWUvYCccwL4AUDUvuRW8iaskdfxv6XeM23
1658	fee_transfer_via_coinbase	1884	10000000000	1	CkpZziyQn3rHBmpHbkqfxLNZJvb2iQ8dXk6ocnKHMk8VZJV9kCJRk
1659	coinbase	1623	720000000000	1	CkpYigYnC11fT9jX7sQ4XbEu3HSk5LQ2p2u6buuCLMKzS3mNeFnBo
1665	fee_transfer	1608	40000000	1	CkpZfTNS5oQkFGXqxifuCWXEY35C5pKLTpig6CXwpd3vHuLbsN6Me
1666	fee_transfer	1723	220000000	1	CkpZdD7vWs4YHwgtNd7hUBC39nFdx5t4QaPFTR2C2TcxpkzKAMUte
1671	fee_transfer	1671	60000000	1	CkpZu8XorGaXjonHAdYhiiTVfuyootva9FrxxUpev6Y1D3G7tUZnW
1673	fee_transfer	1649	180000000	1	CkpZpTDV5utVfE49f98hGQDRtx62uFoBzjLjm2sAq7DwCsaDgqBSU
1678	fee_transfer	1654	21000000	1	CkpZN3iCn3ZfFwgCqY6W6iu3rYjBjvW5RWtWML3iPoaYiPeaQ2HtC
1680	fee_transfer	1747	41000000	1	CkpZ3ohaukwBwRzQKbzv5eA6vPFVsqysMKyesXDTkvhvVWdkYLLWx
1684	fee_transfer	1749	41000000	1	CkpZjas2HZC7g7XxBnn51ViHK5b7hZCQ6DDBh9hxn9qPBnSzR4thn
1686	fee_transfer	1564	40000000	1	CkpZRAx61JQneBRQuG5a3G5HJCqtZG4Xbr6kCNt5NZ78K16FNwbaf
1690	fee_transfer	1637	120000000	1	CkpYbFTJx96mKFTtoM1uyYwP4wmwomu8qpW9RVq8u4YCQSfahx3Qg
1694	fee_transfer	1680	90000000	1	CkpZYta7MStsRkq459s3E3WeUG1GjeKwx9U1vmSs6YFFuPbfBhFJS
1695	fee_transfer	1639	30000000	1	CkpZfvck7ZR9mhwrCCX2R2iFAvdPaNFXUFd9rKV6XjoMsav1czGsv
1705	fee_transfer	1692	41000000	1	Ckpa6dHorPvHnueErRLdPjMUEQJsmmAH1RFGP1NZv6Mv4dzUjx67a
1707	fee_transfer	1610	60000000	1	CkpYY275dTuZwhrVZGjgTSc3Rf9CB2jG3xNXsihE7wQ1AP6SBsZEr
1708	fee_transfer	470	40000000	1	CkpZYnuyKgftFdvYT14Zr1n3Cg1EMKuhxbu2ZKBqS1rLpHhp9RCrc
1712	fee_transfer	1426	40000000	1	Ckpa1a2xeRCJNMiuDgqCMELuxaNsshhcp6DJNLsD7Bgx1sDx7GPUQ
1722	coinbase	389	720000000000	1	Ckpa1WrPdfgXcmHBXuyJ5cyYYqH7L2c91f62dGksEUApF9zmf2KNC
1723	fee_transfer	389	20000000	1	CkpYvPPdWKRAinudhaUSreHijqkirVgABJ1Ds6smfdrAVoMw5qPeD
1727	fee_transfer	1764	40000000	1	CkpZd9pvXjvoVzVD7rddCp9mVCXxk2JtVbnxaZDb8NJNxthZhbu1W
1728	fee_transfer	1768	110000000	1	CkpZkFh23LWUtDLixuynFBAvFRDsraHZjUUE3ZA9oD6aM16FXkvLZ
1731	coinbase	1663	720000000000	1	CkpZ7pigjog7rE9rqJGzPcuLB9dK1PAganuNZgkP9NohPwAe5BTXG
1732	fee_transfer	1663	20000000	1	CkpZP7sVLVcrm6BMAaP7Mxi36jnGSXqsNT7qgurNCn68xSqEiQGuX
1734	fee_transfer	1656	110000000	1	CkpZGSWce6Y9jE7qzzoNJvqgKSGKGX3Xtw4MoUDTotfkmQj8NyXCU
1735	fee_transfer	641	1240000000	1	CkpaLSfY9ihFYbaMGhmFEZNukhDhDq9cDpGMZwo3g98mdNj4vjDWr
1741	fee_transfer	1567	10000000	1	CkpZRkd43PTX7aFLLnNLKQP4SeVs3ZffDMbGrUJJGXca7rkoNsNTc
1742	fee_transfer	1593	110000000	1	CkpZZRdNTDThtDzX7ZTdudiNq5QHDvmRLBrQJMLfS1XVKSGeGsDi3
1749	fee_transfer	1696	50000000	1	CkpZuhRU6qYiCyCXLjntwgVDbkT5xY5tSW3WNm2rW9kL55QTaZyt2
1752	fee_transfer	1703	40000000	1	CkpZnJZoTh7Ay9hNmkZ6wj8vtyK7HdjsZtN7Efi9ercCggq8qzycS
1753	fee_transfer	641	150000000	1	CkpZki87haMNJNDkxNUt1m3YrfcdWDcdTZ8EVGazW78oEKtzP1Bka
1760	fee_transfer	1739	80000000	1	CkpYxD26QBZmS5RzGuehZaMgySV8qLfnot9EMnL76EnYmn9PDY8qW
1768	fee_transfer	1739	180000000	1	CkpYrDpQ279pAdFLKTjHeQj7qAu73PuuNB3avPubZy1wbNuYhjfN2
1770	fee_transfer	1536	90000000	1	CkpZYfQHjz5p2JYeZaLCp39hVF6fVqgFSkABaoJaS47aid9ji9NSy
1774	fee_transfer	1451	70000000	1	CkpaKxspgpdkn6FmCVjZiXRK75tCFhTrDzc9tJKBCij5qyDYGu7Vv
1778	fee_transfer	606	60000000	1	CkpZFhyn5dt6hRvccQgoWoxkQPQKr2Z78MqhYqDy692wJJR8UY7yp
1784	fee_transfer	1717	5000000	1	CkpYaFGXTPjtY9Hg2oeYyWPkRNcPdHQUBJfs1ABSFwwRVQEmH8e3x
1787	fee_transfer	484	345000000	1	CkpZAeELJXkWZLJDVR4Tw6D3UFHhum5GKi29WXcPs4ahhXwXUTXDR
1788	fee_transfer	484	1100000000	1	CkpZQPA5fiW3XXq2sRDw8e3tTSp9ve1zEyR7AnAigeyzyrtrhkpVH
1789	coinbase	679	720000000000	1	CkpYYwfPuH3A1B2hvuTBZhxwVjTK9bUCSMrVnsuizNoeNPnTWsbxp
1790	fee_transfer	679	10000000	1	CkpZprSC7YRRkHcNbBCqV9XJAaXsM1b7ooF5mVCHT56aprNdXhy82
1795	fee_transfer	686	10000000	1	CkpYehSYcksAzzSWgLgV1K6khUFotcqz3swVFAgYkytpVX1jiRSRC
1796	fee_transfer	1423	20000000	1	CkpYvdDquxMuc6aiB28fHDQkF3spKtKpmxQASN9PPAzMz8fJRBGVg
1799	fee_transfer	1607	750000000	1	CkpZN8bT7EHQCZ3f5544CBZiRHtJjf9Bueq5hLf9dWBM1SChKkz8S
1800	fee_transfer	1607	562000000	1	CkpZSuRrn7LexHHFW79BmAS4bbJK219mya9mByeab6PGKKsZKqPba
1803	fee_transfer	1633	445000000	1	Ckpa2MyuJJT6K1VfgFf559cPbpABdBvdQn8n4HQirnHmcMPDqSXUJ
1804	fee_transfer	1633	820000000	1	CkpZQLS5TkwtMxk8MviTyycXvZHgQcoeeAVbkAdAyApB6dvdTCdCC
1806	fee_transfer	1445	11000000	1	CkpYXzCEMDdRSpMr1hK8QJKC3TfDCiqyFSN8Pp9MYAycTnRM2ZafQ
1810	fee_transfer	1654	517000000	1	CkpZcvFc6Ls5Uq3FgJFACN9TFyV4g935ER2o9DeCyUiQdQ9XqzCSn
1812	fee_transfer	1716	250000000	1	CkpYWG7HMf5qLNRujmZTLKc5fiCE43WeKamdFjQQjQRVGuYPEfvfQ
1813	fee_transfer	1607	732000000	1	Ckpa3jqV4avXeKjJQjKgNq7i7SZmaFVTW5ptKpnQNqM2RMVZ7UYj1
1821	fee_transfer	1518	21000000	1	CkpZguUhA5hopQ9uKJHvoz4CqQyumxhBQFA1nYf4mCXxzNiWD3mTB
1831	fee_transfer	369	50000000	1	CkpZmzkVe9vA1wnK4pHxcwsxVRnrU2yK2tMmLKDe8MdfQUsgriZNu
1837	fee_transfer	1444	35496980	1	CkpYSTgXje9Kke7Xe1aCJb8NeV6ZweEhRpBmVq556gkPzzbyE7MeD
1838	fee_transfer	1881	3000	1	CkpZgyp6XwpdSbiVfEaqSwrvThwE1TTdZUPgNaRGPoM4m4JVpDJWs
1839	fee_transfer	1817	20	1	CkpZ5fKth5bxT6zLMPoAB639zgvNdjBb1XSw75UWo8kziTDKnnvdZ
1840	fee_transfer	1744	4500000	1	CkpZmn2ms7DfmUVVFp36MbopA8x76BYveydY33y1qV9EWh3y5XPKt
1660	fee_transfer	1447	40000000	1	Ckpa5H48gqnMXpwu8fsfsvfEcvTECeH5w7poyKAg4tJqgqJpCADfG
1662	fee_transfer	1714	40000000	1	CkpZmMX4Z86qcZdedtpTS9pRRxcmybNgu7szmKyeN1DWhdYfSAr5F
1667	fee_transfer	1513	220000000	1	CkpZ1wUTsbChxK3WyuAjzoedRq8zcD3NWNvbTHJcRR6otCK3ntLZw
1669	fee_transfer	1696	80000000	1	Ckpa7QrwGbBFhH5awugxSUic5RoTZsM5J5Lk6ZQTaLzE7mSKKSJTu
1672	fee_transfer	470	70000000	1	CkpZ2K9t9HYCiNfnTegH2dzEkoUw1BwXyHNwVNvzf6hgtZNKmymix
1674	fee_transfer	1679	180000000	1	Ckpa9jkAWtfmkHatfqvVvbM16gioKtAD1bAuH35i4RHXvPbb2fDPu
1677	fee_transfer	1650	1570000000	1	CkpZLdH9jnP8PXdZMJZ1y1dLviHrtj6Enn1t9pdWL2XHrffxBVF2e
1688	fee_transfer	1729	40000000	1	CkpZdyome8xBpTejiZXjE9sVzwdkVrxUapKMB8LRdcxjtGzTyMDRr
1692	fee_transfer	1541	70000000	1	CkpZk2qqVDNDvYH9rEEHYEc7P561w8kpiF8Qvr6QrKz21KQ8VDN92
1693	fee_transfer	484	850000000	1	CkpZQneHCfdBWM5YzDpu1FKP8iGie7NbozMDiwk6Cw9rp7Z8rDX3k
1697	fee_transfer	1790	100000	1	CkpZUPEtZMYjbe7s4Ye9s4X2Dc5YBn7k3AiDWRe3m6Pz1aHkUcfim
1698	fee_transfer	1644	176300000	1	CkpZY6WsuwEyrpT4E3cPCYMkcateqHUrGRPmn3aosyJLLjMoWRXHV
1699	fee_transfer	1758	100000	1	CkpZLXnwXYPZwEZB8fV4yyEbm7XojvBEBuQzoR9wmqNJJGPBttLut
1700	fee_transfer	1744	3500000	1	CkpZhUFX1c7LWn6nKN34edCimzS3LSTNAQFWEygrUE86WFTouSNFv
1706	fee_transfer	1623	40000000	1	CkpZA7vrYAZk89ua6vFHMgDvgDCrnhRzEsDRf9oXTJK97X1zv6YWu
1709	fee_transfer	1719	40000000	1	CkpZpQ7Qon1E3P6SMMe2KSfRTwxhAVezuye722zc9ADNug43iWach
1721	fee_transfer	1602	40000000	1	CkpZCE5P821s5qkswLWgWsvuKD3dE8cDaE5dzosiSioDvtW2BW66f
1726	fee_transfer	700	120000000	1	CkpYvm7n93VuZmxS9zFhy32VXm5fnayEncBBr18PmkmfbV777zH6m
1729	fee_transfer	1513	140000000	1	CkpZgaC3tmmPDzTgGWocWqWZbTJrZLUBL5JmFT2ePA72sMFpMYm8K
1730	fee_transfer	1599	60000000	1	CkpZexCojYUpoz8v1dvUW6USuLTziFcLcTZRNcpmxYuX2A7MH8DTL
1733	fee_transfer	1850	30000000	1	Ckpa1SqfBsLxbiP2XJFDmFVXQwdg6LiBp4shjzZd9JPgXD8bmM7Z2
1738	fee_transfer	1701	120000000	1	CkpYuhPgnnSEZ4DecTA9irzdRTjfX8v7Mn3xM4HWuuSr5guukLz8T
1743	fee_transfer	1474	1020000000	1	CkpZLr61SCfm4NC5ymB53CKBQxNpbzCASdTTpDmumm1UhbS2t9Gde
1744	fee_transfer	1474	400000000	1	CkpYiPD6DjdDcbNpxsq5avFs4NqT1G6tb4NNL7iPCr4kuRMPP5Fth
1745	fee_transfer	1749	30000000	1	CkpZpi9krN73VgZaXhdFiYS9fr9W923ujYwKyJrhHXUsYYnAEoz96
1746	fee_transfer	1633	700000000	1	Ckpa31DksJ9Fku9GuQkp7Q5co4q1xMpLSRheujbbmfYBtDSCf8j5c
1747	fee_transfer	1633	910000000	1	CkpZJiC63qqJ57Nkoumrdt3t5kuA8NqqNCeBPtTixngY6zSvDGvEU
1756	fee_transfer	1672	61000000	1	CkpZrwZPzUpTp5nfoXTfRWyXmvE3L9Z6SzTE96EWCaD91YwXMUy4V
1758	fee_transfer	1694	100000000	1	CkpZ7GuDPm1f3YHCrumcVvkhAyfXQpPRhc9PRmc7rouV9uc9363JM
1761	fee_transfer	1749	80000000	1	CkpZDdrWXTkqP3DKajrXM8fymj6HdLXTDTts7X3fYD6wkBmogkLhm
1765	fee_transfer	1402	90000000	1	CkpZcSBzG1TNYmAoGTjnhBeweWs1dnd184yVjbz3wSwpjwgk2zNUe
1771	fee_transfer	1711	90000000	1	CkpYxjq77pw33f3JqMQrjAuqY8hGRUnKRqhXybcB2SnL9PfuDDuiR
1772	fee_transfer	1683	80000000	1	CkpZW3ZK3ZeojP1kSZtxE82s3DADCTThMfYSRm54xv3KRVsqnyVdW
1776	fee_transfer	1683	70000000	1	CkpaJgpxcyjmXYidBgHzgZhBbUXoSnNkmyKtTV48U5f3ew24BYzCT
1782	fee_transfer	1588	260000000	1	CkpYvsaZ4j45RwqD7ThHMBjDWXpPhLSfN4BwmooQRWvdaCTqwrXCF
1793	coinbase	457	720000000000	1	CkpaAP4QJcNBWbFZvtm4mTD7rfVkWG7q3VvrDdtVgq4nLL5EaaonK
1794	fee_transfer	457	10000000	1	CkpYibdYy5MmrZ5Xe1YDMu5d29RYozexnomdsx8Cbd3QU6og6Ss6w
1797	fee_transfer	1607	35000000	1	CkpaDFqHkwpoMtPTkCnygZRz93Z2LxvhtVaGUv2uQdzMSCsB6QaEz
1801	fee_transfer	1677	35000000	1	CkpaHegQEkXimjfdhcBm6o4G7xeT31EZLFLRT3zDUVZTa8r5bn8yn
1807	fee_transfer	1560	21000000	1	CkpZ6uMTPDykBTZUX2kip3RfkaG81JtHSeRikFm14MfQTfWQYjGZe
1814	fee_transfer	1683	170000000	1	CkpZQJkKa1PjyXioY4nTUxjn1aiLoUNxXuu55sQWp9cLWnEPxNKYw
1817	fee_transfer	1702	30000000	1	CkpZYwqSDaK84cG2fAV9ioqCbytEpyHmTxuY6vVKdgYid2EYwDCxE
1825	fee_transfer	1476	90000000	1	CkpZUYriRDhyrATAWQhUNjyNo3DY9L1qcmByqd8Qstzmc7iRV5rN4
1834	fee_transfer	1709	30000000	1	CkpaCqvdmLwRuMUtwPKQftg3uLCt6SPjXHruoPzxLydWBdhWtMUAk
1836	fee_transfer	1448	210000000	1	CkpZqLnhMANt9AQ68WLeqr4xdo47LdkE1yd37vcyWRQQ55MRuWPTa
1661	fee_transfer	1599	40000000	1	CkpZw99KPsKm8E32kaHfday9kAAi2krJcS8rjRXQZEEq8diCSah1W
1663	fee_transfer	1683	150000000	1	CkpZWWiZWFyZhMDRgTpExjf4yJth1Z69XkYJiG26R2vcv96eAoHYD
1668	fee_transfer	1714	120000000	1	CkpZRsUdWw6e4G5RMLNLqWa1Nb2J5k9z7CcSP9EZpjVY2gjpZbgu2
1670	fee_transfer	1419	80000000	1	CkpYcVUfGLeaz91mMqMAiC8XkNLqCePuJmNVZR2kSVMjRekxtdBvB
1675	fee_transfer_via_coinbase	1817	10	1	CkpZtTG2Xj3Zc1rAk39rTYu9tUWY5dop3FS9ianbwUk9dUDBiE5J5
1676	coinbase	1740	720000000000	1	CkpYnwFN8Z9e59wQhGrUo1xNgaEdifeaq3ftu5qx76YQuYyTGiTzo
1682	fee_transfer	1746	41000000	1	CkpZrDrLx7fnHNZEuT5tdtm3CsvgbvAptZW6WT5mnyYe1s6K5f8kZ
1683	fee_transfer	1749	21000000	1	CkpZEUt432q3SrHyxBfT3hAcTrhWnZmoNCmTKn2kMxRicGi57paVR
1685	fee_transfer	1685	11000000	1	CkpYxC3yEEPXr4gQFBaH42KeHnh6QBKcNN7qXziujGNUDKhaLBenJ
1687	fee_transfer	1546	40000000	1	CkpZoy7oSYT6ZEkA7oqiddsAwSpguceBVPFevooeFvHJAFqtLRgqw
1689	fee_transfer	1448	40000000	1	CkpZ32iagGxWmQG8keUkdZfCjtePMYbMAQgiZP5hxoesnHaMn7okM
1696	fee_transfer	1587	40000000	1	CkpZh4Zq1mPJGHgZzVUEMxxbJWPoBC2wJ8y8eMWqYMHCHU67sGfUs
1701	fee_transfer	1644	180000000	1	CkpZtrJtKUNi7sK9muVp7YMrQqYmrSCKsitSy5qBvtrWVxsp7tRpJ
1702	fee_transfer	1649	41000000	1	Ckpa2teowzEA4X9heGa5bXKH7dNhKCTF6TfcGMJLDVp4YuG7JzmJd
1704	fee_transfer	1419	41000000	1	CkpYgZNUCenXWQASJ6pa4aqm1PBvmYqExWGfs4iWbxqcCpLx1Puon
1710	fee_transfer	42	40000000	1	CkpYjiphakiTsBzE8Bmom3dCYfEdKL1BmvbJqCKSkuwddKkbrmwVt
1713	fee_transfer	641	120000000	1	Ckpa4B61KKVwBCTCLgs5zDPebdU3CzzfKeCfKj57U8mGmanh2H8Ab
1714	fee_transfer	641	620000000	1	CkpZy9MCUjAB1L1yFr7zCpA8byKSYxA3QRxi34scssNH8w8SdhPTm
1715	fee_transfer	641	280000000	1	CkpZDuoKFbBX3mhzdyGAHiRXCNS2P4V4wtPdN8YNSEfKRe94M2KLv
1717	fee_transfer	1447	130000000	1	CkpZu9YyqfuVPYqDSqnLGxqfQSqrDE6itYMh3kjsWwu3ye5vSvqt4
1719	fee_transfer	1474	1220000000	1	CkpZm46Tw7NnynLY5Vb8SfDbbUjXvcGxxRw9ticcQPLzJiiMYjVCK
1720	fee_transfer	1474	261000000	1	CkpZ9MXcwM9BHAE1sSuwoR9Gdpu5r7wZgwLMqPDXYpjEznSPzmas2
1725	fee_transfer	633	40000000	1	CkpZpxh1LibW4qRE7iDzMZp7qEfaqeqyMMWqf4EFaq1K1hbj9ytx3
1736	coinbase	350	720000000000	1	CkpYReKdE8H3tYgCSyL3BgHaF5LJ47yKsNxis6Bvkhi2BhpYNKzWY
1737	fee_transfer	350	10000000	1	CkpYWtQVga9iEQi5HwpttodZ1RW5WTjY7bCg4ceKXp59CUQUgnLdD
1740	fee_transfer	1607	30000000	1	CkpaDrXbbSgDgeMyXXBgXcPKwvdokvw2u3WYXF8a643yF4w3HB6DB
1748	fee_transfer	1594	30000000	1	CkpZk8xB4VWFrU2VcyD457L243VZiTvuqUX5r5p47ma7ZYizWRBsz
1750	fee_transfer	1623	50000000	1	CkpZWpqhPBn4X1kaCHNjERzoPbEeiBBSML2yX5kVWQddrcmR6Aowc
1762	fee_transfer	1426	80000000	1	CkpZ9u6bkxJpDDccZUuJY7zT6sV4V5pmP8uRTh3mW3XRTcVQyuRHk
1767	fee_transfer	1708	180000000	1	CkpYUnyzYMmbCPx6Ju68UMoNjSNwvbq8Yv9rZU8YW9wgmET76hxbN
1769	fee_transfer	1684	90000000	1	CkpZhe5uKVXsFvQX56zGKaBfC6UDR1eKWrkxjqvV3YqLNpGU1HjnW
1775	fee_transfer	1573	70000000	1	CkpYeHpRFacsE5JVvPXhjLwqpnFVUne7pYVyBMmrYCHh9eh1N6UGa
1777	fee_transfer	606	70000000	1	CkpZkpCsbk6W2tbXJELuzsQCn2gjFdcCSi6KbqkqBKKnos8hF34BQ
1780	fee_transfer	58	305000000	1	CkpZytGLKR4eU8jCyS6DRBMATZcuZYVQkPg9yJWHumh7goDLqfw7q
1781	fee_transfer	1607	50000000	1	CkpZQyrB7KaTKnoXw3QLVsng2xXUH5K6tT2udz7gE5eyZs1upz5B6
1783	fee_transfer	1694	5000000	1	CkpZZePvUoWrxmiAx1x1rakJsgYr92u3vXi3ZGwxHf2EFCbgbDLqK
1785	fee_transfer	1684	11000000	1	CkpYr2SiUFgBafG2E8nzhVWfV2quu3kRa45U5VZ8S4bXMAJifH2jP
1786	fee_transfer	1684	21000000	1	CkpYSVp5V2n36UeuF8Ew6kv4HRv9yU4oWKdiGxLMpgvwfcBCGV4aH
1791	fee_transfer	1673	215000000	1	CkpaAHo1FqvpswGQs6S8bNtggHyMbEw1CF29ze4NTddkYV2ynqH2F
1792	coinbase	1480	720000000000	1	CkpZfHpj4gHvEPHBaPeHHaTd6L8EvK8JuEBN9VE6EkKF244phjkQk
1798	fee_transfer	1683	35000000	1	CkpYXr78kYCP95GoBbKLnjRCZyk9hLNBweRTYPdL9fuatRPg8p2sa
1802	fee_transfer	1573	35000000	1	CkpYfCHQixjqoVVRDfruBYv29X28iALgnhXBXG1rjMqAGY3Z1m3aS
1805	fee_transfer	641	865000000	1	CkpYb1CbmRiWmq9qYy352PeoHUYaFFiskc3mnzPGH6UkE5nPZGLxa
1815	coinbase	1543	720000000000	1	CkpZjBNHfcvZBs3Zpp43hfCc4u1JCt8qjzaKJj2ajxNzJmGqFec3C
1816	fee_transfer	1543	10000000	1	Ckpa5uBju9heGAGBZMjxu5MksbrfBdH2X1XV5JfG12RzRZtE9o8Ux
1824	fee_transfer	1607	90000000	1	CkpYXgMmGoVwj2JaM6W7KiqoztCh6CvGs4i3Z2zwfh7GHqx9jwwzZ
1828	fee_transfer	1607	80000000	1	CkpYkVz7bGpABd2jDLFuxmTP9h77UtquSP3CnprrjRohUhskczPJ5
1835	fee_transfer	1439	280000000	1	CkpZXbJdZBJaHL8ivpVnzKGjfwAjSKkxBGuLJBAQ8FJnrgo5P3P3N
1664	fee_transfer	1593	40000000	1	CkpZyWYjWXW8Ch3y54oi66SRt5gK3mxB2fkRiggzRKMbMNjWzbz1g
1679	fee_transfer	1654	41000000	1	CkpZaNJ24QRxjp2RKwGmngtXuX9gX8it2qPBvn8Nb5D89q5aXVDbL
1681	fee_transfer	1704	41000000	1	CkpYxn9N4RrzD3bR3Zyuqman2W6PXxwVUzBLqsUcdT5nBqs3MPqHi
1691	fee_transfer	1402	120000000	1	CkpZinZ3cWhWL2vec4EZK6DicuuRPts33nQmZJZ7WcK18SJMTcC4c
1703	fee_transfer	1672	41000000	1	CkpZwPsmersjWuYhNqHGgVpmqdNtjaDVc53PeiW3gXCdn1361rRBv
1711	fee_transfer	149	20000000	1	CkpaFV4jaTsTYera5NDdMMwuUepNH2CCWWK22QDAcmf2i6LHkUsMQ
1716	fee_transfer	1690	240000000	1	CkpZ4w4pjjcDFpfGZ6kthS3grB9CLxh3p5A2Qe9MU5L3ugUPeT5JK
1718	fee_transfer	1474	130000000	1	CkpZepNHTyTxg3dDyG4P6uk3KuBs6N9JhTdDrmiyeGsRoqj4Jkmok
1724	fee_transfer	1755	30000000	1	CkpZzXYQoKDoaRhxrWFpx34yBJiDnDajicXP7qq55aP1mH2bShe5k
1739	fee_transfer	1593	120000000	1	CkpZacD1jj62iV7Kmmme1Qaorg6odBLu6oiLf56LL6fitw41zrzXm
1751	fee_transfer	1678	30000000	1	CkpaLAb4634zEmgKbewaqsQEFeTn11uoFraXhVWVzJ4CEboUQq3bA
1754	fee_transfer	641	1030000000	1	Ckpa9meW91p1bKHoD8Y6jwoUHE8GewevgdC4xDD5x9XaFCe7244ff
1755	fee_transfer	641	400000000	1	CkpYqkzNZNWWtzkMeQq9R8RwHSm276aP81R3K3qE4ZNqpasGMjgnP
1757	fee_transfer	1457	61000000	1	CkpZyBWu2piks7wnxLR48xP5FW8GSfyk9fn4yvVFTVABkuHhBMwtD
1759	fee_transfer	1709	80000000	1	CkpaLKWpE6QeYcQJEmF59VhnrfvsHBr4BXGUTgUvt6wGbaBgdNRUf
1763	fee_transfer	1426	440000000	1	CkpYkyBsG8X2DRdPK1a3TVMRQcc6E7BEpNx88aMwF3R7fRXRXRUMq
1764	fee_transfer	1426	131000000	1	CkpYU2uaqciDurp3TkmU2faz43wcU6ahyd4DZN9b6Xe9HsYFUP2G9
1766	fee_transfer	58	90000000	1	CkpZpM4noRXvp4EQbCV5U6TN6WSe2roxu3HY7QAqaLMamWSaVqFEi
1773	fee_transfer	1687	80000000	1	CkpZR1m6m4kWW8hNFPDVToH7gjCKT6XRs5xeuMqhEBAPNMz5UFmej
1779	fee_transfer	58	315000000	1	CkpZxdcwL1gStJ71PXyAr7K4VngiDi4jqV2xoJhdaY8pyHBFzRhjF
1808	fee_transfer	1560	31000000	1	CkpZ36x1F4RXpMpYmv4uiyXMcLCeRvSUkrSokCg7K3dWJHrjScFrS
1809	fee_transfer	596	12000000	1	Ckpa4xDX2dkjt8fC8Z66dpf9iL4ErVXXT9NL5qfas6sbrGMajBEfV
1811	fee_transfer	1489	250000000	1	CkpZfv4oWZ7aiHxk1YWq7m9javhtJwTHz6spCima7EP3vWCMkbmWt
1818	fee_transfer	1703	30000000	1	CkpZQpAA1Fiv7GDtLQ4VkPFwkNx1jd3jd5rxDv3V9aAUfRWVZVDAc
1819	coinbase	748	720000000000	1	CkpZqs51FYmfNG7RmaDufDxCaoCe8a7tfXZDQHgfbyiUwgL8QWXh5
1820	fee_transfer	748	10000000	1	CkpZurzru8zhZu78scmRBcQJnX87jswuvPZE8j24zYe8jFGEFUaXm
1822	fee_transfer	1610	46000000	1	CkpaE4jzssgUx297f74ZAcPbbbj7nVegSC4Gi2aoj17VkzrqBV3y4
1823	fee_transfer	1850	90000000	1	CkpZ4ojBgAjDugZWv5E7PUk8b4mnDTyWtm8Gnx9dfvR8fBS9F6QeT
1826	fee_transfer	1607	190000000	1	CkpZ6KuzXJ1TYEJNfQe1cUjdE8PsrV8ChUo1jnBSFDye6mmZEsm3t
1827	fee_transfer	1607	351000000	1	CkpaCgZWCsXvpHACt8ZbZntA7Hx1kAvkAgMgQoAyw8nZYiMsHECYH
1829	fee_transfer	1596	300000000	1	CkpZBP2akHVMJw9fcka9Da3emvDaCx39v3RnjZuTuVuzcjMjdN8A5
1830	fee_transfer	1705	50000000	1	CkpZDtQrinV9Ve8TkBBEqjBrLQRqMi5x4SZMeyPNEW9419S4XpJTC
1832	fee_transfer	1692	120000000	1	CkpYiERLjX5abruX34sQDRkzyqoK33M4AJuTmxD8c5x41E2KJFYYv
1833	fee_transfer	1613	120000000	1	CkpZazwe8reEvcA63Jt69HkhW5LM39vR6NNBVwktk8vRNSHEHch8R
1841	coinbase	603	720000000000	1	CkpYvgqe9xsDo3iqRB1R1mwgjQvHMSwWBkfBdD46EyCsxdQJWnCqj
1842	fee_transfer	603	10000000	1	CkpYQRn1oxVhBJqqzFZP7JkU6gk8sNjWaE6MwSwpq7v8FoDt8gqk4
1843	fee_transfer_via_coinbase	529	700000000000	1	CkpYcsaDoKQ3X4UGJHK2hPHWyao7MtjgsNgRtPbTgei6abQVVCqzZ
1844	coinbase	1724	720000000000	1	Ckpa9fu6jbbyCfXKnFy9VZ1jBXVzGagEJm222F7pPGZmm7c3tZTxi
1845	fee_transfer	1702	60000000	1	CkpYzsa3A8bRKEtZvSumdwuHhdA6L1k6au2SRDMztqc4PpKgPDZ4n
1846	fee_transfer	1703	60000000	1	CkpYr6CsB1Js3jC8ozrJ7v72jnSnSihxwuXsTw9qZ39GVEW8PVy6U
1847	fee_transfer	1696	516000000	1	CkpZXsGT2YNWQwsPt1DGfAcDwzi9ULVCfHyKtZ8AGbY1X5uWqibAp
1848	fee_transfer	1764	21000000	1	CkpZb21dEo8DGonW6t8j4tu72vyQH4rR4fVmiZjx9kXqqKCL8SG3i
1849	fee_transfer	1448	11000000	1	CkpZfCiPedQpbtRWgj42iPgbzddv6qxLNHqDtQaLSUS1a3knRAbnq
1850	fee_transfer	1709	11000000	1	Ckpa9pHJ4x74snvM3EoXKcB49dWApD5gyWNrEQXPoGJ8GBzz26gj9
1851	fee_transfer	171	11000000	1	CkpYVGt3WGXnCwEBwZo1Bzyg6dSfxU3vyhUWs9c4qzYm3XWwdPy7Y
1852	coinbase	1430	720000000000	1	CkpZ1Luogmbt4Pra7ThY9ihtMSVAXZhDKovnpFqyHD9JqEoHMrGoA
1853	fee_transfer	1430	10000000	1	CkpYV2TsdQuAF27jWY8Q6xE8t3mAKLQXk8WVKihAKBA9NWNP55EGz
1854	fee_transfer	1727	21000000	1	CkpZXTJYDEPu1rpvpCmprp9G6zDvczPn16yx21myPGD7kwpN9gGS4
1855	fee_transfer	1439	370000000	1	CkpaGV3FQ9Y4n4Gm4nyv9mzwGPb2BaMm4ZHf7UnKECWoKdp9kvmWK
1856	fee_transfer	1439	1060000000	1	CkpZofGSHkXkRjxbQJHiEaokRcL2wKLvSXCTQwmpa5nDpD67HUw8t
1857	fee_transfer	1476	40000000	1	CkpZrfFgBJ3oMAPdQYiXJaCjBfDQmm8qRwEH9AWzMoxJWX3r1WLp7
1858	coinbase	497	720000000000	1	CkpZpcNjwbQ9GbjD6PjyF1hRGHA5zojurz8a7CmT2niiBWvPbfkMT
1859	fee_transfer	497	10000000	1	CkpZrunPy18GEk9jfKNUzhqj1dtpdeR6bjkvxZg2biKauyJkfE6FW
1860	fee_transfer	1439	292000000	1	CkpYku2Xp1Epkb6VfgAmRHLGLgP3cqotF6GJ22cUfY93aYFZuZPtN
1861	coinbase	366	720000000000	1	Ckpa2CQ6eeeuGUajcCEwHFq5JgRevRaUeWhxSQss3Yb5n2F1JnG3H
1862	fee_transfer	1559	50000000	1	CkpZvrsxoWgEzg3EeuVKf92MN2nkMhyNGRXxUUKBkEtF1eMZcMGSF
1863	fee_transfer	1684	120000000	1	CkpZRY2CgGRSQ12phqiTcMuzMPNJNjdMqTqxor43zj7EmzQJWTubD
1864	fee_transfer	1756	120000000	1	CkpZSpMniDdkvnf1LykuMVaQ2hsHrqYCfS6X96zTcFscQEb9d3w72
1865	fee_transfer	1780	20000000	1	CkpYvP6Rai9b2LaTeDNZpjqwGZSfQWNCDmsuGW1xDNo3guzfhKYxr
1866	fee_transfer	1673	11000000	1	Ckpa6fuxWThQfguhPuj9TSLBP5zam5R345R4GzNngheoQxMAzKHRg
1867	fee_transfer	1733	11000000	1	CkpaF1pvELzJKivQMaMGjBbNeJYzUKr9kKqXa5o4egtXgiQKqssER
1868	fee_transfer	1440	11000000	1	CkpZJdfbSjW3AHW9kA8pLb59QWGJDSpocfvTbGZm2QK47yMRhPHLd
1869	fee_transfer_via_coinbase	631	500000000	1	CkpaG4ResueXZmF2RR6yJ5mHrbqrmQgvyRiXFMP3VkPV1ChsDLo8m
1870	coinbase	1747	720000000000	1	Ckpa8nuAtpDE5samWXej6JmemKcwppi7ZXjHopRptD8REKtL2DbUY
1871	fee_transfer	1677	660000000	1	CkpZ48LL1uQNL2RpBLTX4Pa8VtSe6wonwM4crffKRDrAmVx7dq1dX
1872	fee_transfer	1402	660000000	1	CkpZuej2YxAjHMtJjX3HnBg2BGVUR37wNgS4b16f5erVEAWD4Rm5K
1873	fee_transfer	1508	660000000	1	CkpYaksDQemZNyh56EuNHXKi75CaiA6VMM4D4ymQcSczjksHNSTjC
1874	fee_transfer	1711	11000000	1	CkpYf2QoH3khAZQ2FqtsKXqAbiXRaWofRndFW9j4RHEuM1cPkebaZ
1875	fee_transfer	632	22000000	1	CkpZny9xoZtenvK1XyCk2QKudvWSByRMZ5YVtRug9d7mYmG1PSw9a
1876	fee_transfer	1657	22000000	1	Ckpa5X4gK7cWtHvnHW9CThjyZfahwyqBJfzJNTpjgAcNQZu97YEBu
1877	fee_transfer	1444	12000000	1	CkpZYho1Vc2sern4i6CZAYvwU6DaHV7XAPEnU1LQEKrjQFjBNKoFB
1882	fee_transfer	1692	121000000	1	CkpYiv2QedX6KbxqFgfXEsZztZ4Fc87FyRNZh6SfARZRbtJuWstkk
1887	fee_transfer	1271	130000000	1	CkpaCHF8MVFXfSMHapcENWrQv7krdGx8GZTsa9SSR4LbcCXMaqyf7
1893	fee_transfer	1699	210000000	1	CkpaC5qvBCrdKiMeAAaMoyAW4rYcScn56Jxf1DwwZ1FCkZia1UuyV
1896	fee_transfer	1850	110000000	1	CkpYQwdvQMZ38SrSatPokQahBpMUyRVMUrrh816sjVuVi19JdsfUq
1901	fee_transfer	1684	150000000	1	Ckpa6F2us5UYFRWKwibZerFkNP1yFavVMEtg5retr2RC5tsSud67Y
1906	fee_transfer	1717	21000000	1	CkpZDBdASP7oXrjW4S1wMX2gryWEB5NyqChEBXrEanDLhNdFxkRvX
1909	fee_transfer	1536	11000000	1	CkpYgvTeaHCEnxyWxcJxzW7rqfEasQqyN1cTP7zYEcTJWvkQCKzKd
1920	fee_transfer	1680	1170000000	1	CkpZbcfKJSADWPCm2ketqsX9Cm32DTdXjUHr6zVbTCfX9FXik8XPc
1926	fee_transfer	1684	1000000	1	CkpZKJKS94GffdkK94LFoD55G51otx7Gfp2TnTqAXYo4GRzyGdNGD
1928	fee_transfer	484	120000000	1	CkpZ9d82EK95pYZsWr6paM9NXSnXi16QUpVhVhtc2pfaCdknRTEtY
1931	fee_transfer	1656	21000000	1	CkpaKxQoQRaJLrUcLHUpD1BBidEMvbEBY7FDjxw5YEGGCErfqEbay
1935	coinbase	1592	720000000000	1	CkpZ4fqCTL6pGUbktBW8VPXtgdcTVUTgeQshXN3A5FoSM6EnN1NLd
1936	fee_transfer	1592	10000000	1	CkpZS2DfvbW1DBCTKKd9pAsNaGVPKdmyJ7rnnRF9oKotbuG84yTUD
1939	fee_transfer	1711	229000000	1	CkpZPky56oTseeGzTFGw1UH6MHoKtG86qm732Vq14rHtKA7J2niWX
1952	coinbase	1943	720000000000	1	CkpZdGFprzqLscPByRp2ze8wosAvmWoEomHTE2d9FW51eajht1PTN
1955	fee_transfer	1596	120000000	1	CkpZfU6jtvhqreqDTVRuvrVa4cpFmcDLyH7QfGG69bFjFWqbkf5Rc
1956	fee_transfer	1850	210000000	1	CkpZGSrxY79Rz4LuWhmKQJaZYcR9eZ6zUrmeSzzCtrJzhFCevwNus
1981	fee_transfer	1547	41000000	1	CkpYmjnSqrsDHbZF7pAHDFh79ZmFsujfi2CVyQsiGkYSTpVXDtpcZ
1983	fee_transfer	1755	730000000	1	CkpYam9bFAJeuuKo8s145S8KrixsHqY22tfUjSyPEoescFGmNcv2Z
1984	fee_transfer	1755	820000000	1	CkpZv5rUTxyErCasx4hkTNsRSU5gGHMgDQB2HWWx6XP8WXpgBH7Fa
1988	fee_transfer_via_coinbase	1520	100000000	1	CkpZdwcENb4jL2CKCVXUwBCzD6djix1QrBCSKiGdhzLVhu9wqgmQe
1989	coinbase	1546	720000000000	1	CkpZPSXD3p2zTehP4ANxmxBgciwhRgPxunvURDG8oqtqSQZSMYcpi
1993	fee_transfer	1598	60000000	1	CkpYd7KwRp1gp36pZqUq7HQEehYfEK5yryU4z5ugVg1sjKezsid6y
1997	fee_transfer_via_coinbase	255	1000000000	1	CkpYzkmzN2BGedbdpMHEf8U9dTojJ9NgLTckviENbrPe8XNVD47zs
1998	coinbase	43	720000000000	1	CkpZ2xjh8vibYteuXHBrkaWHkPC9FAPUsZu1MqBKuoUyW4MwudhJR
2004	fee_transfer	1938	4	1	CkpYbfrjPgxyWg1rMrR6HnCjNvfERpHwXzfrMcfvkfknzFfbgSVou
2005	fee_transfer	1474	19999308	1	CkpYXzqCYsMf9VUdFz2NRKknPU4HnpWGmx1UUnmWqfVhvHTq758Xf
2006	fee_transfer	1571	688	1	CkpZhsZi5qrmaAFf1HkxxhATmBRAaN3jY7oPQX1g5TrgNrh9eiibP
2009	coinbase	1690	720000000000	1	CkpZCBgbDnfyH3NVcymZfgyRZr5RWkrX3YGXyfRwyZanxTTYpWcYh
2011	coinbase	235	720000000000	1	CkpYnUm1YB1HKKtrEJhcTJZcMrBViFDjZ3xcsNPS4Ae1wCMCx1HdQ
2012	fee_transfer	235	30000000	1	CkpYuFbQZVi9y5Tz1zWbrR2AhcXvnYNZvxx85eovyMVBbqtKEwdiR
2017	fee_transfer	1691	60000000	1	CkpZFPXZZecHaRiTbkjnBfNVE151ZbYsUuk9xYst5tv3bHmyvA3Jv
2021	fee_transfer	1677	285000000	1	CkpZpEJkcABGLMe9gkLoj11wnxfMxEvbYkUknzamWQW461cLpbjPb
2029	fee_transfer	1419	60000000	1	CkpYQ7xRba7VrFbbkF5PVdapZFbMtNB1SULxCSaeKye1bjvoy6Eao
2032	fee_transfer	1933	20000000	1	CkpYfMPMb1i4pWYYq82wgrSREzT1xdZha7dWXqXLCqXsp25SzXN1J
2035	fee_transfer	1695	50000000	1	CkpZccXdt1pPu6T4NcTAbnw6R6rvGTBJ7aQ9kV1NTUepWxUDssQwy
2043	fee_transfer	1623	2000000	1	Ckpa3c3MnZncAhq4T5vWXMb1nq73Edd4d1zymmiQCtQDLqS3CjYPR
2049	fee_transfer	1709	1130000000	1	CkpZphrEQhcxj2PxajXyLwbxhAE1D3JeSwXogxnSYbfzdWpPpsh8t
2050	fee_transfer	1882	70000	1	CkpZg22Sru45Q8xzZhnr9wLHKWcMuY8tNCXXUumbp28spLZkLtMQv
2051	fee_transfer	1709	579930000	1	CkpZqk56qafSTjw5ZNuNKgdaoqyMDTfNDDfS2NvmKNMoLRbrkkDev
2053	fee_transfer	1691	41000000	1	CkpZjmDkvSyku2tGJ36YMF5P8EXfspviNm1wmJnDvrT7JJNWSYuxJ
2061	fee_transfer	64	20000000	1	CkpZUKPCcyHCWYmKSagTRV41z8YYd4Ymp68eHrGgC4Fa1P4PLUUCV
2069	fee_transfer	1948	5	1	CkpZwkUFBAykRGUpnCAhbcrkiFQJEc7ySc2XpvDMhCvkd6QyHqEcZ
2070	fee_transfer	646	40590000	1	CkpYzHydnyd4bx6VxsPmibzMXatqDG3zJzhLyP5uuSt5PW5kyrira
2071	fee_transfer	1687	309990	1	CkpaErANm9SBrkkWinnD87vD1Tg7iXEp55TZT3FZySEMf7vKyrtJt
2073	fee_transfer	1687	41000000	1	CkpZKK8DwhFhRv1HLF3zUUHdi6UufMAzuneFAZqfXhTq6CfsA8rD5
1878	fee_transfer	369	62000000	1	CkpZ3msYiYsenstJSXQght6tdmG5ir4DV364BkazPF3usTbC6TWyt
1879	fee_transfer	1699	11000000	1	CkpYwxiwWtx3r8Dsgo6gfEqdp7wwDdXy1fdFjQ61gX6KTxBNgYEsL
1880	fee_transfer	1547	2000000	1	CkpZuh6j28Rebo5iFZYjcQ33rNQpNY1QNg7ovBgs3irCciQEbg1t7
1883	fee_transfer	1879	10000000	1	CkpYYVxjdJqT3SzRpZFgNbhnQj1nvbJve9d52xQsmKyoFtVvbF4Wp
1888	fee_transfer	162	130000000	1	CkpZHH6sBAYZLPrX2kmtciNHeEtaGoynkLKXSw9hQ4ucmRv2Eg91G
1889	fee_transfer	1657	611000000	1	CkpYRu3aUnLF4MSev1NDXuTPBPkZAhJEg4YuHYVAqgvNGdwbxr17H
1894	fee_transfer	1764	210000000	1	CkpZL3xyA2KEHfm1VCCDVy4TA4BkDd2TUXgPm2VHRQHiQRkvqts1P
1899	fee_transfer	1698	11000000	1	CkpZ3aFJ9haDjqhGth68uMPLzQuFU8tfB2ZsErW5mrKGjFvFAciUJ
1902	fee_transfer	1637	150000000	1	CkpZeLqfPq5g6KCfJVt7khWbD95wH4zTeDN4obrff8E4GdJJ3bZFB
1904	fee_transfer	1715	1000000	1	CkpZXKF85CZLTNdq6QEo54Jxd7CTzhnHQe5Q2xFewbskr6TfvNx1k
1910	fee_transfer	1474	11000000	1	CkpZKtgR4ApsQs9UzT9k4RT8kmWTA7aWCLcC2jNTCipHdq1T9DQWS
1913	fee_transfer	1607	21000000	1	Ckpa1V4egfrQbBLjQnmPwkYnT8qrgJnztDMGuBh2M5db2FXUd44SP
1914	coinbase	1933	720000000000	1	CkpYx1PXGztqZLSJKov3nfiyBxDKZkPQKGyFFSAWJKmbEDze74sYr
1915	fee_transfer	1933	1000000	1	CkpZJXY9QmfBqtC9NtiXwqpEGH4xek9DFQNeN3hax2rB91KAacNKw
1917	fee_transfer	1427	10000000	1	CkpZn4aCZEWhFHowXg4RYbXj3rBnQVTxfW2xbuvjAzWbeK9JFn7Gv
1918	fee_transfer	1680	111000000	1	CkpaL7Yu9agUzHUUGWQgj6s5b3SGvTXbqFdGfZM2nJNCzyuzw434v
1921	fee_transfer	1688	21000000	1	CkpZZXoxEXKncGH1zm3Mpt73oztuvnnes8jvfYNXBnEYBGhkFyr74
1924	fee_transfer	1691	131000000	1	CkpYZ3B2Wd9TigKorEPBPfsxfunwrAKP7d698YtN6sqDoxCaLWfDA
1929	fee_transfer	55	120000000	1	CkpYnnJdfj7fTtLo4ejHVkaEn8J6q8TtXNXVTCyGyWiCXRkmFAm95
1940	fee_transfer	1699	229000000	1	CkpYog6x4eRapRpPEj88ihhzV3D4dCGwQUmUQ8Xk11akJpFtHfAJr
1945	fee_transfer	1634	15000000	1	CkpZQmkW4jbqTogc2obkyaA878XFtFUNG79gJCaz6Pka5bqVW9Esd
1951	coinbase	102	720000000000	1	CkpZfYQLQxuuqRmNgNPiCMAxH6DtF11YJJzzNRjotNb43Mcfby6RR
1958	fee_transfer	1587	21000000	1	CkpYm89ASu4YZvXTj5mpdqtCzvhXkyZsdiZHMVNypC1SMG1kGTwGm
1959	fee_transfer	1708	800000000	1	Ckpa9bn44mB86BshyFLu7qpgUbqcJVbknnxpsFirQY9je34pDLBD4
1960	fee_transfer	1708	562000000	1	CkpZUm1vxfAqqa5Bq9DSHrq9ws1R5rACquzxRHvgo68Qheoqrzb2t
1964	fee_transfer	58	410000000	1	Ckpa934CHpJe4G7cy4uCCrEPnJ2vHAsBUZjKvgMoV4gFARxbRFkj7
1965	coinbase	1882	720000000000	1	CkpYQed18v5wBkBLiRrVuGf47KGPQvxgWNjBdRuKxTcmMD6jJBKrH
1966	fee_transfer	1882	10000000	1	CkpYZL4YKWxdCoKeSte8Sv2sws4M8vycPhZ5iPSxYf2RwAJbkGQvx
1967	fee_transfer	349	20000000	1	CkpZUychdPwiBSGDJrouza8zrkRHBdhskurzkpwhS8kLL5VHFgftD
1974	fee_transfer	1729	1040000000	1	CkpZpugsUv8rdYCH6SWgxoj7ybHyafabLaThAGTBUDdY4MFG4Fva7
1975	fee_transfer	1729	270000000	1	CkpZz2LQyrNdJBDZ7yZwau2DVSBR99VxSx5V3uFQkqPu7Zi2vag74
1978	fee_transfer	1690	112000000	1	CkpZhF552kkryRjXpUQqjLtrkBoXM8aEnLe8MhkhgRPech179o9ej
1979	coinbase	1690	720000000000	1	CkpZ6AaTDy5ktnkjVkNqozMXC6hQ1BTcb9f1mesHSP87GHUGpn76t
1985	fee_transfer	1755	20000000	1	CkpZ2F1UnYDvR8Q4pQS8u9TfZdj637aswwhy956zfGGsFMtCESHy9
2007	fee_transfer	1474	14999008	1	CkpYda6tgraqhRSE3qciBteWkLb1whefE4nnuYDWqvvqfFv5BJtAg
2008	fee_transfer	1571	992	1	CkpZPsfCB39mG8t1XAfSyG1yQvvKcg7ty5seP6vaDRFzuE2PEXn55
2010	fee_transfer	1718	40000000	1	CkpYWxZc8XEQgCsL7w8rMmQReZtxWHLrd3f8zXvgyVBizwYPFQi1J
2013	fee_transfer	235	10000000	1	CkpYkVx6Eds9m4LpsG9CYZ48vf8LF2wvKpPs9qDaDsxHb4QViy16e
2014	fee_transfer	1608	30000000	1	CkpaEdyVPPrBgR6DCBMYbbjC99mpfV3NkpUEEAxkwjuu1K3XSNFNf
2015	fee_transfer	1447	60000000	1	CkpZBV7AptWrgRUPhU5FUuD2SgnhnXwrJ6DhcmMDbsP2NkN4jxpVu
2018	fee_transfer	1623	60000000	1	CkpZWjKNcXE79pu73FoAmzk5tCAZgksdgTrtUX6HHSqh3CBPnjtsY
2022	fee_transfer	1423	285000000	1	CkpZTprBJCNFBsfZ2U3qWLUMAfKZZt752MDQLUhTW4GtrSruoLURo
2044	fee_transfer	1668	270000000	1	CkpaAwdHbkkHLmdsRLVdFmeS52KdQtPnD36E4hYVzxN1XkCoD5mx6
2045	fee_transfer	1559	100000000	1	CkpZfYFEWEWp1MEHSvNuVi3vCJTP3keUAjAFenFdhdSApaFye7whK
2046	fee_transfer	1692	140000000	1	CkpZypNdk76AgJs24SP2ocaNVNHFXeYJrUGfV9Mw7tPqWqchV2e82
2047	fee_transfer	1683	1020000000	1	Ckpa2qLiRR7GfuEX6kH4t8sGXXv9EcKyM126gr82JF4CK5qsfwFEn
2054	fee_transfer	1623	1000000	1	CkpZ2THWe6TqdFHtviZMtKM8oX2tejeYraakGasAohVAFawCHspja
2057	fee_transfer	1683	45000000	1	CkpZUP8maA48DbRuSKvHrMvamLcnZjNHfCh8Ux3dGiNda4hqSqC1M
2062	fee_transfer_via_coinbase	1831	1	1	CkpYdopUpWHsmih8GAmiZxdmMa3s18KiFNquz5oPQyTZe3tDhy4Li
2063	coinbase	1850	720000000000	1	CkpZcqRFg6kLJBCoNpuTLiSkedsannpaTJg7t9PcoCFnaw9miKcF4
2064	fee_transfer	1515	100000	1	Ckpa51arquisKmidVKEHj2dZq5SojbXhadJkAexyDaGJJKePL3Wme
2065	fee_transfer	646	5940000	1	CkpZWWqtJeNUg192YDgvnE4RD5usxajBwiFCNHMyj5iGE6BXD7JKt
2066	fee_transfer	1850	9960000	1	CkpYxGEAscWdJEEkWpyHbYbsQDbfD1JdWss3RcfPF9Vbo1ecRFNTL
2067	fee_transfer	1543	25000000	1	CkpZHsPDLXPTAR8niDUr6t5z5jHMaZdPr1ZDHkxJsYYHYwFuyE7n1
2072	fee_transfer	1685	41000000	1	CkpZQkiSnYnPrzQ6VzVSBFZDyEJui9SMDK23wgvk32kbvJr1oGoBo
2074	fee_transfer_via_coinbase	646	990000	1	CkpZSpPNxQkTqeqrnm26gLPgt9BgXdks4UD9xdVkH4p2WYnDY7h82
2075	coinbase	1637	720000000000	1	CkpZdK24uTBmEoSK9oihTEFiiNFdWDXtvb5VSFp2DK8HGfnuv53HN
2076	fee_transfer	1637	19010000	1	CkpaCp6mkZ4ktsGbiwuRfjf9fX1zUUPBkbWjsLs9AVDxWXvbKQLnf
1881	fee_transfer	1683	121000000	1	CkpZvAEZZ8xsRNrDWZz5tLe7PXugyjU4mUttJQRiSjZN3JWbqUbVL
1884	fee_transfer	1715	61000000	1	CkpZpc1SAj8WqX3x5N4RdhUdLU2A22tTzMFodzSFiD5Sis3whdChh
1885	fee_transfer	1610	140000000	1	CkpYWkyY7vpzNVmtiuU9USRg32E8Z7UykvVFRTAi9Kdcz8VC7bEpN
1886	fee_transfer	162	101000000	1	CkpZAP2xad9Kz1vLRLmMGVifMqzovdgqYCEQUPhGTGXE9j3iBN19u
1890	coinbase	1432	720000000000	1	CkpYQZe5pe9dTX5JhtELCSiRHH7bsQ5Xo4v42jwhqJnxN1uaCmk6M
1891	fee_transfer	1432	20000000	1	Ckpa6NHYq7kPU85396xTydEQgWcCszEHobWTmSjk9y964WFdW2Xsi
1892	fee_transfer	1654	210000000	1	CkpZ96aAZ5WU5VZzEkMPSsP7C5QssJpdLNJjkzRJ5SQEXhkDMxzJt
1895	fee_transfer	1684	830000000	1	CkpZn6Xnndjd5oDWiPQAnjd9PBJXGAkyMgGkQrwifRxN6Rajn3pYT
1897	fee_transfer	1689	110000000	1	CkpYsGfTUTPXR1HXKXYjCxhQiEPKEgKgDxeb2CfzpSNhnYXSG4kyq
1900	fee_transfer	1723	11000000	1	CkpYn4s1CbgQWZH9cFUZtXNm8Jmx6UzuyFXdy7iGiXbHfKzmPzMXJ
1911	fee_transfer	1679	15000000	1	CkpYUZaimVbXwumfS5ebvP92CVKLHph4zS4fRs4BzbRhH8Ef8ATVe
1919	fee_transfer	1727	111000000	1	CkpZNxVGhVw4zYvhQ5Lwzky1Vf65BdZWTtb7YfXpiEG5UjfsdackV
1922	coinbase	8	720000000000	1	CkpZehWKf6Dn7cxqJZMHQwKwve8Sm4EHDSuV5b3EBUHRCDd6iFqSJ
1923	fee_transfer	8	10000000	1	Ckpa4pihWrwHkZAs3FwNLPDeGL7SUntREPpphX6wUKmH48ssQ7AZh
1925	fee_transfer	1559	131000000	1	CkpYxij4bcDSBV6VQCgvpaYowKTt4HSPiQycnbrCE4DVTjYoFavya
1927	fee_transfer	1457	1000000	1	CkpZoR6GG8Ac75D78XquL3XcAZfn1NFqAwr1VCQkPxmDPyABSDBeM
1932	fee_transfer	1513	21000000	1	CkpZxCwfwymCJWtDEmkPg653qPCrR1Sm2t1hRBBkzmVD4bTzPkRCL
1937	fee_transfer	1643	11000000	1	CkpaLVwa8uRa1kvg82ViEe1nqJtqwGeR6xsFXo6BrHDGX7eqLuRsZ
1941	fee_transfer	1649	229000000	1	CkpaEcXjf5ep4jVg1qBubo63ks89bog9k17LTcz9h9Yz8HZGRevsA
1946	fee_transfer	1683	15000000	1	CkpZTnKntzq2KYuUfwvWTBmw3xPLm82Wub9dt8zykiLfgqWWVdogY
1948	fee_transfer	1677	15000000	1	CkpZYxp6TdjVbuQkTUeBX2aRpyQ55wqk3LDpGzkZqaXR6G5yxXZQB
1949	coinbase	303	720000000000	1	CkpZjAUVtvLzLpyNY5PdsPDR1JWpHd227HKfoXMm8Q64YDpA6dVDp
1950	fee_transfer	303	10000000	1	CkpYrt57GZrWVxa3mKEnbdeRjwrtjkHAeT42BfjbcjiQ1nQ41s9bX
1954	fee_transfer	149	1000000	1	Ckpa62fWQ4vcFBjTFTUSfJJyP4RHe3WzpmX9Hs3hsx2zZ3fxgsqpf
1961	fee_transfer	1740	70000000	1	CkpZWNJ1V4ww8EJbyBu1htgBwUQvcw7zYRFxhp2tmcaQ4N1rvUbYL
1962	fee_transfer	1740	19999999	1	CkpYie9LSD3zXZ7NNPFiZCGqpXQMe164y5TKKKqgRd5mwZMXVzdn7
1963	fee_transfer	1708	231000000	1	CkpZ5gWxoUW6iCXvEMSArbANmnt68Fw8CosL3Bz6HYcJ8NWLJVk3h
1987	fee_transfer	1560	70000000	1	CkpYcD3x98nw5mQ9NLm683djpbrgDvJEzmdNbehLP1Lgh6sovPdzz
1990	coinbase	1677	720000000000	1	CkpZFNJaxrqyr1ofPEieXjce9i4AoRwE65LziFL8T5VjzrVkvSYBk
1991	fee_transfer	1677	19998100	1	CkpZwt8UNsCm8ANXMaNpaea27smtHi67KyRyr3M3iciyma1oaY2ZX
1992	fee_transfer	1514	1900	1	CkpYcUjpecYrqh2QzBiHv1SNuRuzhAi9QTQx8XBK3DgdxFBupzKMC
2016	fee_transfer	1474	60000000	1	CkpZAmTtteCECnkd8YLSmoiHxaHCQxnbQyu3Y4iu3h5WtT2uqaDEj
2019	fee_transfer	632	70000000	1	CkpYbCeAE99MzA7RaK7Y9PiW5S8CsAan76JDqyetB54PP4MoXnX97
2020	fee_transfer	1611	60000000	1	CkpZUg7K4yZVs3WfzAg9rQ1zmkhkfFoc3uQEom66wyTu74JsZ4f46
2027	fee_transfer	1692	39999999	1	CkpZGG7rK3TpsuSwysww8LQDSPMNXWrrbZNdQPkHET7uegf9itT5B
2028	fee_transfer	1934	1	1	Ckpa9ADeMvGMpUv1H9zwHFYXpo6QvCYkoGFkA5jMayuGaMCMAC4c8
2030	fee_transfer	1633	60000000	1	CkpZfjB7JxdRXQgVg3eszUPpBzd8JKieCuQ4tcfD7mXpck8KMJvGK
2036	fee_transfer	243	40000000	1	CkpYSukXF4ZaeS38cn1otLvYtCByBEuixhhDW6wfN6WPGLc4e2xLg
2039	fee_transfer	1700	80000000	1	Ckpa84n5C2xHGjb6dHWKfZa8ierv1AqYYi82txH5owtoiVZspY5Ex
2040	fee_transfer	1509	41000000	1	CkpYvS74BPh7NwCLuXyYA7H16FWA5wFojpiTY9KTQEEMdBDw79KnU
2042	fee_transfer	1683	41000000	1	CkpZZPtKhaMNmbg8aZzJf4jXNzYrK6KBKMWLyYBPq524cqmfYGmtU
2052	fee_transfer	1677	41000000	1	CkpZb6LndLoMfeAatEaWJiaHiA8PWFkxGZNGQyyUtV216MMhZHN8A
2055	fee_transfer	1649	40000000	1	CkpZFcP1Q99CVi2u7uyYiNoxu2G7oAYS4RGxD6wyos633Ta5QNg5y
1898	fee_transfer	596	110000000	1	CkpZztRnuw6RqwdiQ5MEdyUokuJbB9ze1WykgVJ2WCrB3anvGHEWu
1903	fee_transfer	1426	21000000	1	CkpZeet9jfzEgj5zsiV6Tw2dXTDk8pvsgsk2MxMjfXPUbzCv8xu2P
1905	fee_transfer	1689	1000000	1	CkpZo4KpSbCRNwJZ65CX9f3oUR1nFszsMRc8enGQPRgYvS3Yyan5r
1907	coinbase	1427	720000000000	1	CkpZJUpwCGJ5BqxN4EFYry26wSRckEkech3LnZjztttpuJKqXtrGp
1908	fee_transfer	1427	11000000	1	CkpZuVVWNK1V74HPwmBqGiEfuRgt93KNv4tKHiSPSvGKEtpYtAVvg
1912	fee_transfer	149	15000000	1	CkpYjMUBtTQDR2ntkxP2LDSS2isKCmN7bhgKnwAUrQpJGh7Up9yjP
1916	fee_transfer	1933	11000000	1	CkpYdjEZNnN2FJ9fkRMjTD6Xm6RfZTopZTHyxXBYsC2L6q6PxExnk
1930	fee_transfer	1694	510000000	1	CkpYYrVWXSXMsbKkv2hcK2vNUx66paRnqjx7XhRuWeNfqxAQDuTtj
1933	fee_transfer	1677	31000000	1	CkpZjNc4dxdYUFMRpXQqASU4wKRXSx4wBa4BVregGCCJCvFd1C4Gg
1934	fee_transfer	1511	11000000	1	CkpaE2mBxfYpspz4ymUTqbUVmpkd7tmh634DQvJoFJoxLx3yCGYKu
1938	fee_transfer	1683	229000000	1	CkpZcy1xBice1zpjPHXFM5ZBA3rYMA7atzhHyk7e4qAjaGne1wYXq
1942	fee_transfer	1677	229000000	1	CkpZc9TTwjnU779Wqwe1J43RmVub2ZAxMqZx7QTvHXh5e42jspJhb
1943	fee_transfer	1549	45000000	1	CkpYSHJmafAu4EEb9iE9ew8fCbwyiRC9MqDYUkMwuD6SoERaVa7ux
1944	fee_transfer	1613	1980000000	1	CkpZjHkCW2TqKPS5u8ZgH5PLiUd3EBi93kdk1oqRSt8PA62oGbBmi
1947	fee_transfer	1402	15000000	1	CkpZ2XMSc9Ewfpnssjc5e4t3jeYHLZEdy9qd5drJ9nMm2SwQtZfJW
1953	fee_transfer	149	100000000	1	CkpZBsPBkqiVyS12uKRLYi71Na1ryLmCxCr8jomk854LBTDHMFsKv
1957	fee_transfer	1686	210000000	1	CkpZoDtBxAQDUELPw5i21KbEqg267u5TyCoyN6xcx9xkHd7zTrDJx
1968	fee_transfer	349	280000000	1	CkpYxhwqNG9TRoSwC1f2MK1eGkvbXtgLMY5hA5ZWyDR74FkMxCD2m
1969	fee_transfer	1938	40	1	CkpaB3AEGgpsLZC6642aEaftXQoRfQUuSwQKfu1TehgCyKLzSiy6G
1970	fee_transfer	646	990000	1	CkpZSpPNxQkTqeqrnm26gLPgt9BgXdks4UD9xdVkH4p2WYnDY7h82
1971	fee_transfer	1761	2	1	CkpYdHU1KnR3THxR4g8PDu2cxyqfHfgJn9AocjiA1fcW4JuQgKfiY
1972	fee_transfer	1855	1	1	Ckpa8f6ofwucHZLMcCvuUSCqDtfsJrTWaF113XU5uz2YAd1QoENPb
1973	fee_transfer	349	1309009957	1	CkpZH3RUoLoWCRmnCnDfgk1jtNx7bmNewyMXPn5dy6TdiZDtqqcsM
1976	fee_transfer	1768	420000000	1	CkpZQnV29hoYaaZhRfcDtWrL9bau2yEWwMQVZaG3fXLeZfUvw8gh6
1977	fee_transfer	1768	351000000	1	CkpZmqhK5eTyr2kofYVjeDWeFPkg2VhimbGz1gEzMAdPNN9Qn98x6
1980	fee_transfer	1422	41000000	1	Ckpa7Xb4fuonfiNUSgKTTZx2ZLJwucVqVM2nMz2eBdVBjhrtnWYo5
1982	fee_transfer	1677	80000000	1	CkpYfLdPooqvAphrQHk7Xm5ZNjShsZzNWbwcbw53qozoun7rZPvEG
1986	fee_transfer	1759	40000000	1	CkpYeW2WsGPt6YrfW4k7AF9nR8ezfx2KGkeo4wA9Bz8rk8M2C8Fjo
1994	fee_transfer	1689	60000000	1	CkpZXRoNRFsUp1jRkRKcAJEEdstbXLxqoGFCsfUsV9QHwKMUz6BEp
1995	fee_transfer_via_coinbase	1420	110000	1	CkpZpobAj3wFYRPHEyqTv8iFdoM9RDjSp2Ljmt4TWar8CZXHvYz4a
1996	coinbase	43	720000000000	1	CkpZco1GXckzH5ZermtvKHEGY62AraiVBLBaffjwz6SvuszzgbTJ8
1999	coinbase	1718	720000000000	1	CkpYeP4wg94WEawh5MfLLYbYjTJzXas2Un2GwWai5C3fCj2xXHsv1
2000	fee_transfer	1420	110000	1	CkpZpobAj3wFYRPHEyqTv8iFdoM9RDjSp2Ljmt4TWar8CZXHvYz4a
2001	fee_transfer	1894	5000000	1	Ckpa6GHrrPikUNF69x8qG6PbMfHu87791C3zVCdr2qi72bZLm6ftb
2002	fee_transfer	1718	14889016	1	CkpZjPTUdBJA8rmUw5vXFQNTUnnzQFvMEnBGGK5z9MUCWn5sfiW5N
2003	fee_transfer	1571	984	1	Ckpa9WgytoJopiNubFKsNag9EDVYgg8Zv3oz47Qk9ce6BCqfxw6su
2023	fee_transfer_via_coinbase	1938	4	1	CkpYbfrjPgxyWg1rMrR6HnCjNvfERpHwXzfrMcfvkfknzFfbgSVou
2024	coinbase	641	720000000000	1	Ckpa9WUqwpqf5FUV4VrVJWgugwv93Wxd8f29Lx1pJ21rn39evZgZo
2025	fee_transfer	1938	36	1	CkpaKw59yABSUawC4cP5Lj4qY2DTDVtgupQ9xhVLMViTtohnv9jif
2026	fee_transfer	641	39999964	1	CkpZwjor3xJNcXb5V3rNhXGrcuJYHwpsc7DKhgq6Wj12dMY1J4zY9
2031	fee_transfer	1933	10000000	1	Ckpa8Fh6FBcwpzgtVUkPKHA4a2t7tZ4tRxFWNCqrkGWJV3zCiPEYy
2033	fee_transfer	415	20000000	1	CkpZ7kdDSFXyQkpzMnP4Z9XKQQbjbSUdc438pyo6Jykiy6x7W1XF2
2034	fee_transfer	1623	90000000	1	CkpYXUuQvAwN32ugReH2VNqqwcRtCkFhECjM3aiV5FVdnMas5gMz3
2037	fee_transfer	646	1980000	1	CkpZJCZAxvc25Xt3kcwV4E2XnF8DaeB2K9c3MeoSLJUuJoJJt6cFw
2038	fee_transfer	1692	38020000	1	CkpZd36QHSgC4ogLrT1nvpkusfjvP4P1UdFZyP7EZK7Bn7WnbnyZD
2041	fee_transfer	1689	41000000	1	CkpYYSnBKnJfdXc5YbFMWq1CHTjkw8nHnMXLd4616VUA6KeDbXKDp
2048	fee_transfer	1623	1100000000	1	CkpZnXnaoKPbRwGLjnuEy9PNDuqt45RkodufH1GLMJaLgxLTDxpuN
2056	fee_transfer	1596	40000000	1	CkpYqgudM3ooeVKstP8oe3CuppHRjCEePAyZXVqKfZaHkq6jow3mv
2058	fee_transfer	1519	45000000	1	CkpZvPbPuyuwU8QdRkFFWGumd4XsC1WoU5hPHbp3GS7PymCZvz8he
2059	fee_transfer	1675	620000000	1	CkpYuks9sYzhG42CVL9FUH6aSAcHKuVPD34MXScZziv11esPZi4z5
2060	fee_transfer	1675	420000000	1	CkpZKbQU89sG2swRsYRCteNibiNHLfmLe4r46yGL7NKETaYrJ2KNA
2068	fee_transfer	1850	41000000	1	CkpZXjSsgsa3wgw2UUFEJKJJoLtwVyuK2EgboC1D85FN18ab4ZDF7
2077	fee_transfer	1684	45000000	1	CkpYeWRMnNWZWepwGyxVtSW3DpEyrTugCbHkvDQvN6LJkhYRLHAGF
2078	fee_transfer	1599	45000000	1	CkpZJJqEGeKqfiuojXUvJpP21ZGN54qaz7vyXE9XsvmCh1CVGCVBQ
2079	coinbase	411	720000000000	1	CkpZqcnHbfvaJzrtkQ2iC3vDyyWtPVnScKGpfHnhGBbhNs7LXHmwu
2080	fee_transfer	411	20000000	1	CkpZZyQQYjctEDmJbEXFtQ6jJPhSwYWaGKsRxzqcVZvuWVapqQagH
2081	coinbase	1532	720000000000	1	CkpZNiSUsbwMQH9N9dVfBQ7ZT5cCdrprmd5De8HYjWejxnbgEEhZk
2082	fee_transfer	1532	45000000	1	CkpZ7BExR9vaBCcgfVhZCPuaA3xHN7RU5hYVag9jCq4hDz42yCyNa
2083	fee_transfer	1762	30000000	1	Ckpa7u4PB13nBm2cphsVPfXe72qQTdsLGra7crrmGvDTRmMD8VkWV
2084	fee_transfer	1467	100000	1	CkpZXqPa8YxA9rdhcFGjCL2R1D7QNgTjT9M9Bxb7gXwnivdUuWsaQ
2085	fee_transfer	1893	9900000	1	CkpYtVfritR4P4fodJiRarUATuJJpiJYeg9cT4kAuACRcKX7nNMDg
2086	fee_transfer	1696	41000000	1	CkpZERum2xhkf945cUgrEtAajSk6WVn8ebhxkevJjCjAjC94sxvK2
2087	coinbase	1690	720000000000	1	CkpYuiTWz8o5ueEPC5k6WjHiy2URy3gCyQB8TxZNGNtQuwCAAUj1i
2088	fee_transfer_via_coinbase	341	1	1	CkpZqs1gsC1dGjB5RuwNcenmbXwHcVhjfSTugyAHibs2dDwHn9jhB
2089	coinbase	1690	720000000000	1	CkpaAzdAt1bwCYDPzBczUFaNYrMCHvgYuasYXRY4cpBeW2MhPUxuC
2090	fee_transfer	1501	400000000	1	CkpZHDeLqMhdroGC1T9gpBgzi5duGuADwDQS291cfrpqQRrzhLVGp
2091	fee_transfer	1439	40000000	1	CkpYzTkDGQZCPpHAHTgLStficCvrFmpDEa7NDXsqstKBtBm4tjHbw
2092	fee_transfer	1467	121000000	1	CkpYSsqMpmsZPvzWjRRjVhpcs8jy5z8VrJx7eKow4ChNq6kx4FBJN
2093	fee_transfer	1677	121000000	1	CkpYcU4zVtFCvh7iryJa4u2482usv2ZpkwXtwYHiqqaphkCSK4ANS
2094	fee_transfer	1555	121000000	1	CkpYtW4nUUCrGX7TZT9HrDAMuqocwfEf6dMqprVArER66UEnmw821
2095	fee_transfer	1474	41000000	1	CkpZ1U29XAFLK9h7UrnvHy41rH8Z9ewMWwMXdFDcfbfyWRsUoYQbA
2097	fee_transfer	1508	41000000	1	CkpYZhJHYZW6yNB6skigfaYkuqz2SpyxHf4zEmj46QZktJ3m4D8j8
2098	fee_transfer	1457	50000000	1	CkpaHN7SYguaYt1boCCxBxFz37ZbfPtjHqrL16xqdKXk8PLtCTNZa
2103	fee_transfer	149	11000000	1	CkpYhh9FQB5CEFTRUoJGksGRgWp3hACvtW4LaJLcNHtTRcSjPMPEH
2108	fee_transfer	1654	92000000	1	CkpZfiN7Jw3r8C9wMwWEPoeDQDFLDixKmeAMYcdYJtvX7UgeBLcSQ
2117	fee_transfer	1643	50000000	1	CkpZ2ZMxGeMBFMKbSLJiiPX8nW6WmoWMskmRU2HvL8EpTvVEdTY82
2129	fee_transfer	1451	41000000	1	CkpZqiM42PUnH2VRA1gRdTDgRnuw1j8ebtqu44KykgwTDkcCN9vHo
2131	fee_transfer	1709	760000000	1	CkpZfTSPCSawUtTh1WHhj5XhJhkA1W74MCaNy2aZfd5d6hawJowe9
2132	fee_transfer	289	50000000	1	Ckpa6cvSrykrBtbtvZzkdjvbDnDCiT9wW3DaBPCjnaGi3wU5WdKLL
2133	fee_transfer	1447	9000000	1	CkpaLhTWxLW15sreXU71FGm2KQEgyQT75hk6hi39cNh1tQAWEjan1
2134	fee_transfer	1709	511000000	1	CkpZmZ42MAAvQJw7csejsGDv7TSTzaLYXT3G3bB84g8Ev6prS5P9L
2139	fee_transfer	1634	40000000	1	CkpaHXFkjSLbzpNjHdBSxz5ANubv4zNhtCWA3cTXmCdZCVGcrreWx
2141	fee_transfer	1677	200000000	1	CkpZ65ZUSWnUJKW9h3Z36GZWMPdUbKmKU1vxCX99xMP3sEAv6P2GN
2156	fee_transfer	1685	108571430	1	CkpYtSTu1hvjkoUF3UHB2F4zPmH6ZqWK5SXe4aVqSKBuasp8Akm3B
2157	coinbase	1689	720000000000	1	CkpYXxYAL5pcvJBCtFnkgm5aai19mepybrt2a2dwHBVZ7LLPataFM
2158	fee_transfer	238	20000000	1	CkpYwbg6m7PA6H4aMxg3jUpHsbZqVWFAwS9LFtRJrxa6putQwXouM
2159	fee_transfer	238	250000000	1	CkpZUTqRXwZabr7dJxBfooPdAFaFBKqNrNkLCTUjFiVSWjt2hbbtU
2160	fee_transfer	238	1090000000	1	CkpZ1t5rotCp2YuqGaAQM7hNjv7EeLpbiERXk4TU9LZNW4YTUBYEw
2161	fee_transfer	1444	21000000	1	CkpZSQ6JpYdrhDFeK8WKjjnRp9kY6JAjdPY3sruFzdUDCbdukmVfT
2162	fee_transfer	1705	80000000	1	CkpYUyVRtqmTbHhkzWp9Ug7PTs2ZgqTibQJxRkyHTjYSYAF7fZh21
2165	fee_transfer	1740	31000000	1	CkpaBmv9ENqNQ7K433Y4HZP7inkwu99fHPq1qxo4EQPWq6dhSZvGy
2175	fee_transfer	1693	31000000	1	CkpZ94rcyaXVMzMRNAxa4us72LWkrN7Zj8edPcj2YrqkogfVKBWf8
2176	fee_transfer	618	30000000	1	CkpZKC8ZcB7fQDBq4fv8NDLe3xwktRNSZEjcw7BNN5xoEQaAJoEHJ
2191	fee_transfer	1547	11000000	1	CkpYmmrmYgmWyXuKrscEfHHTgNhVZqh4vXkw6BHcCLSjRNhKntP8D
2201	fee_transfer	1688	160000000	1	CkpZnfnM7Qx1gTkUbsJigbXkrJfgXZnDHYPNpo7eXSvJMwL6K7JPF
2207	fee_transfer	1677	270000000	1	CkpZXZNQrxiGKgYxPJojQhXMAED3kZaApW7BcebVGvLjYjKb3fUQ4
2213	fee_transfer	1708	41000000	1	CkpYTuaLXhrZtnjCo4EakEjY1smTiJLdzyecCsyE1c9rzLdEigxiF
2217	fee_transfer	43	120000000	1	CkpZ7td6bAfWsNUZ2YCz6ZusReP3igrEq6V79eQkjVKVDcWKT1wgu
2227	fee_transfer	1749	90000000	1	CkpZF214rJi3NVw7SZFbBxHbMyCpRziQmkLyjdELddQmcRGuWiWgC
2229	fee_transfer	1688	310000000	1	CkpZAT3PoEkQeQzDPpAX94rPpLsBkfB679PLJQd5jCZjbbQRqtGMQ
2230	fee_transfer	1690	70000000	1	CkpZVJjWpCa9kAebyTTigEonj9MY25FBQtypmQqfPBfzY7hhiW9Vn
2232	fee_transfer	1756	100000000	1	CkpZAoCdGdFiVqcPQiXxC3PsRV7w3ehiqr8kZyXv488gWgmSrNoeD
2233	fee_transfer	1471	40000000	1	CkpZ1VjujkQ6A77troVndeWNidsKJPYfj341Umm5J7BjoGHnoR19r
2235	fee_transfer	1402	41000000	1	CkpZnSsy6PrPe4MUMG9A19DJ5fujtEQgmV1mURtr9brttsDjj9sB9
2240	fee_transfer	1643	320000000	1	CkpZQSbEGbNxpziSx3b77H6eTaM1SmogqhNRJvqp3a1ixTxJuzRXj
2241	fee_transfer	470	140000000	1	Ckpa8QyiSURcwSJxSx55V5wbGA2uheAvmAhiH1YkRRp4vsqbfPwrT
2246	coinbase	529	720000000000	1	CkpaG7xpxUiu197ApaBenhKFv19jviBKTvFQt2tDt8fgdVF2bqkvv
2247	fee_transfer	529	30000000	1	CkpZhCu2URAkNKms5vkJjbMELVpGbDAmpchNPE7i4Gnsvq2F1VuQu
2252	fee_transfer	1677	51000000	1	Ckpa2eHBQMy9hh6ZumXvp3oafCjwGUhijev27ZJuoHkTSutsc14Eo
2253	fee_transfer	1559	51000000	1	CkpZgqer4DALv3frjeAB3Tc6kPHbjWZkJHAUSAcUzHPo24KaKcGS1
2263	fee_transfer	1677	162000000	1	CkpZxEuJsQQxJoMLo3XK47oNGwdjdFaQb9bsrgB9429VoCL7FYpnu
2266	fee_transfer	1717	400000000	1	CkpYryfxxsxPnQeG6b6x6N9GMXW9zXHpqhqW4MpcnWxuTWZq79iii
2270	fee_transfer	1729	61000000	1	CkpZwy9nivgAP3KciSLyscWXewMTFKbFosZfuQkPxuFrbCqC2bugw
2280	fee_transfer	1704	65000000	1	CkpZuSWLctqjZV3MiqEPxRnQhEpKyxKJFppSbUgdgi8kxmQAWBxEa
2292	fee_transfer	1656	22000000	1	Ckpa3eatP6YfN3NkCviDhwYbVAJp9wBbhjneWynivfmXLiL3DKJ9o
2296	fee_transfer	1688	51000000	1	CkpZPjCyjLxLBGXSKRvebJ1sKgg45nZaZA2pKrTEpk9TB2C2uVDah
2298	fee_transfer	1679	51000000	1	CkpZADfDNk7NonzBESMxJk1vpNA4SViDwviZsmMshsXj9iFvnPCzh
2301	fee_transfer	1685	27000000	1	CkpZtnrCNfBr77229WZ1ZeT1tyWwc8jYm4kwQNWkRXWfZ3HVuAWRP
2302	fee_transfer	1685	13000000	1	CkpYUWQLGjDSabxoyVHjAJb6vQ9bYVQsHzNugJboBw1fwDME3z8RT
2312	fee_transfer	1943	20000000	1	CkpZYW7VyUQsByvVdbSVNtFMAacetQiEWhHTXcVpGJnqKnwYpaEAL
2324	fee_transfer	1549	60000000	1	CkpZfqBvTWmmBWzv8YNbnXPd6yKqRGJU7g9eo7M3ttNcUstVvHu6R
2330	coinbase	121	720000000000	1	CkpYUWoBNBAdagFHFSihEPo3dFLafFAzb7oPdwr7vy7qZSDW8s6F7
2331	fee_transfer	121	10000000	1	CkpZ3zBudVFVUWEia8mRtn3o3138LCSqUuHeYAihZHPYdX4s7WAp7
2332	fee_transfer	1623	41000000	1	CkpZsUYSNkPQCvx7ZW7NZ5AJqXqd4mn1J66QgEq6ABpF2yuCV6wfb
2096	fee_transfer	1559	41000000	1	CkpYuhJ9fCZtSXSVFiPdfzWpnC1pNUQxDyxSAmR6mu2a9JzoYQVMh
2104	fee_transfer	1611	440000000	1	CkpZzHNNCxyb8cx91yYGrNFN8U2GpgGZv54EE6otoGow9UaGXVgyw
2106	fee_transfer	1536	92000000	1	CkpZeRBCRLyFG1XZetiKMPUUEU3VFDpZ7whBNFzrDLxiPBYXrqVNU
2109	fee_transfer	1637	92000000	1	CkpZngFUC2KLEVCgkLqDvYGmZNVij4HKBN3rcmJH5fPiog8LJQydb
2110	fee_transfer	1623	206000000	1	CkpZoDxvTcMesFjM3GXdVso7VTucefKghv3nm3pufnxLhLGBCBgMX
2111	coinbase	621	720000000000	1	CkpZ3nFosJ7R6LXwNpbNQYkicMMQkyMpRHFmY9kRrYpruKKpYAtrQ
2112	fee_transfer	621	10000000	1	CkpYd842SLsnfSKGkx4XtvrpPiEFyjB7iy9R6PVfWkuRm2aBcnDwF
2114	fee_transfer	1679	8980000	1	CkpYfGgoqSjVhkdQUQmE1QAbJq8JQNw7ZHEE9dYsM74TdPpyY5gAU
2115	fee_transfer	1804	1000000	1	CkpZPmQdN1qATNjpnM5GUVTJJv2RZEk9eF7MopK7hA5fTRk5mj5Q4
2116	fee_transfer	435	20000	1	CkpZzZDWaQqr51XmD9eUxVU3SjbfihyLqSmMWXuN2iyEBUPhFdfM7
2118	fee_transfer	1719	50000000	1	CkpYYDrzd2S21W5bckfeoiiDh6VCYMVNWeyvvnua6PXuLVBNCUVhW
2127	fee_transfer	1691	40000000	1	CkpZW63eLtVgGgUHk7KXQtYoM9rjbWpFQe42YWsCx7cRMRotKvWUG
2136	fee_transfer	1650	80000000	1	CkpZGTviG6x97AtWF1ierB8mfyH6Rhng26FauwxdYjPAfTBjUWL3J
2137	fee_transfer	1594	40000000	1	CkpZbMkDkNe7rJTBo7NDvwzyZgqv9N5c2Yzc8SLrSKWYtatENdtRT
2138	fee_transfer	1601	60000000	1	CkpaKPyFNQGu3bjsoYyHQ5YJkgtkutbjGQWmxUYHkwndfVHWy8Nfz
2140	fee_transfer	1681	30000000	1	CkpaFvbinz8xMTEQnm1LUJRSry3UR4kkfEKN4aNbn97FWbbiZofU9
2145	fee_transfer	1683	180000000	1	CkpYqhs7tSSGS67JpevRFxvHo69K21kjrhYUgaCyo3ZLi3yR4XUS6
2146	fee_transfer	1719	430000000	1	CkpZffWrZViNYChdZBPEuruHXmJRv8DD7FzMDcgM8swNWpf5v99kk
2147	fee_transfer	1719	820000000	1	CkpYrmQYNeK6V1adyLMhpJEccJsgEZxew1t23QocXoHQYjbqbN17T
2154	fee_transfer	1698	80000000	1	CkpaGmaXLnmihWmsj1KUChvGGBZsLjsGd7xmedjeNRyaNkEXXTuFD
2173	fee_transfer	1688	61000000	1	CkpYieYbTx4RNUp7mddS26AQ2GSsYAz1CjzxYjrUcXkfvxWsvbFN2
2174	fee_transfer	1623	150000000	1	CkpZwhUR5e9KPa8twFFoR16rDHn32tunBK916nAiazfYjtxhmjouR
2177	fee_transfer	1719	520000000	1	CkpZkpFsFADkZGzGguKTC1vc2iBgqKfSphaPeqJfk9qhGZXcivGJk
2178	fee_transfer	1719	819999999	1	CkpZ1rtvB4D4zSvasRZPv35RWRreF4YjydwZombAuAANgiYy9ouC9
2179	fee_transfer	1870	1	1	CkpYb1NzTcRYNgE9H97NqC3GfJtqRtTUKjtpA4k7nASgjojdGiJNN
2192	fee_transfer	1688	41000000	1	CkpYQCfGAFciCZquFBM4x8BVg5jNtKHWqxEcaYVRNVqNiRrnBKaQ8
2194	fee_transfer	1440	252000000	1	CkpYvFx3hwxkkT3mcP9uWEtqB949on7QC2PtGhb81gegjN2zdeUAR
2196	fee_transfer	1764	260000000	1	CkpZuV1nDDcwKvtTEk8kErffniTCzLmyJDkDXKD3JDEE6vzDhTzNN
2202	fee_transfer	1683	160000000	1	CkpZrdXq4M9nottJ3zuSPfguHcdV4ib4Dbc8aViRDv2rv3xPfirRu
2203	fee_transfer	1447	290000000	1	CkpYkkHdgXC2Cma1NEbuK4MmB1mJkEVqiYK89g79w8qyKpeF37Lxz
2205	fee_transfer	1746	270000000	1	Ckpa2sNFd75qh5FFgNsNknHg7GouNbp7VERKSLdYu9S1ndQtSTVN3
2211	fee_transfer	1474	150000000	1	CkpYZ4jvqP9HUnML8fz9HYscZPmAdoYv6ZxFFxy7BHPbmVomBQSn9
2221	fee_transfer	1688	42000000	1	CkpZp2FrBYyqLsyieNG4B4hcqTPE6fcrXBvavvQUSg8fRkBQJk4pZ
2223	fee_transfer	1727	23000000	1	CkpZWmq7HXT64fSKmLhA4qS8sXRJR6n15tSTHndpp6mSikPXMkCwY
2225	fee_transfer	1705	90000000	1	CkpZAQuRFq7husN6kZ8eWAT7FC3VtUQ4HqSCqBgyqCz7g783te2ty
2242	fee_transfer	470	170000000	1	CkpZ1LwawAv48DKgcn2wKxCzszoZZxciMbqyB89YXc6e83oQ2wKQE
2248	fee_transfer	1982	1155000000	1	CkpZsBMjpeycmipSdFmH3n3VHtdDWht3sN4CDmk1k9WFshJRLJTfo
2249	coinbase	1982	720000000000	1	CkpYSrTskWYC63GVtq9pZuK4T3Bc42VZtBvH2oC1DcBnNEyLTUhjd
2250	fee_transfer	1982	41000000	1	CkpYkxGZCKnuSBENGFmW8aL2YFMP7B5JoG2LcfpVrvKqxRgZLUF4H
2262	fee_transfer	1688	162000000	1	CkpZ3xJ8pj4D7kWZMGLuzAZwNE9nW28x9zgUfznXp2tCuCRdNrq8X
2264	fee_transfer	1467	162000000	1	CkpYxeQcmkkdxvVN34zJZ319QcKouEeSD6KHyavUGESrhB9YcDUr1
2265	fee_transfer	1677	400000000	1	CkpZZrfgEfb9BhSn22zNnYz7ysyWeMT1RiDs6KsKYTxfrpZA8zj7w
2272	fee_transfer	43	22000000	1	CkpZLPbME1XihosC1qynpvHTfGXNAA6aUL2zsqtNdcY2H2JSV7QUs
2275	fee_transfer	1440	1000000	1	CkpZww7pQUCGWDAqzQ79hg5HYJwa8DyFCeJ16VWuRDJPBt2yAnrkh
2278	fee_transfer	1747	65000000	1	CkpZfqDibRZzNLAfVLcEe56wPsRuKfjo47q3tjsUQgecKQLbammz5
2284	fee_transfer	1587	13000000	1	CkpYYWXUzngKEHGEVUMESWuyJEMm2dCd3fwjnQpLunv2JrdYXrq4H
2285	fee_transfer	1588	40000000	1	CkpZtMssUA3Ue6aReu7EqnA3m3yviMx7rK3v9W2uJhzNZJvb4JDdW
2286	fee_transfer	1933	30000000	1	CkpaLAfHXosZRu4QNbjHr5Z929HpwqiZ7aWjctMeQ4rakQApP3pUs
2287	fee_transfer	1933	40000000	1	CkpYhTxruPKcSowSzCrdWxM1RCZJxmcBxdLNGaR5NPhv5quLgSdZE
2291	fee_transfer	1684	22000000	1	CkpZr9txZrXnoELZkABdMzqDbprcUmPwGeKX1iB3HhUFzYPQi4jfp
2305	fee_transfer	1692	14999999	1	CkpYw2fbATQqCHBW13hrck4qY8Sfhm2q8tsfvb9HDUYUcDe1FkHYh
2310	fee_transfer	1692	70000000	1	CkpZQUXajC1Y3YfdThMhMGFFesJvaVnfhBz6aapq265QS5XQg9NCZ
2314	fee_transfer	1688	70000000	1	CkpZfXwFvWEyFoZwrm3UpYnYo71Lx618v6uBM13NqSWsz6S6sf8ck
2317	fee_transfer	1700	21000000	1	CkpZzxpvinNYi1uiZJEVE9YpgLNEe3CchnZUYbQxMztFAgJb98VT2
2321	fee_transfer	1594	320000000	1	CkpaLQWQLA3kvijfSZiXPsMJXP5boXJ1zWtPZWFt7UZnRZiVBvp5d
2326	fee_transfer_via_coinbase	152	100000000	1	CkpaFBMwPQF9hQXmh6Kn7BUAQ2erwbWGXy41feW9M8DwzfTv83Fsh
2327	coinbase	1637	720000000000	1	CkpYXxABhQLdAA8SsP7Vn7UaWTKrpTfDNdp5rpCYqFSMN817BzRQU
2328	coinbase	1584	720000000000	1	CkpZNY98Ct4XWaFBhhwiCe4EBKS7duas9KcsXAYMBuGTA61k7VptJ
2329	fee_transfer	1584	10000000	1	Ckpa18zD4fh29pRXYDPS6Mue3xXczdAvmYF2e6oVU5uNbEjkJR1u2
2333	fee_transfer	1637	121000000	1	CkpYSbFKKECC2tbZmKzfomjPX5ih7uuD2g2R1dYUDXbfR18kRaeQj
2099	fee_transfer	1467	110000000	1	CkpYmEMbvD6Ja9u8gw1P9sePozkXGC8AbVxUfhw86Dick3SqkqjVg
2100	fee_transfer	1728	9900000	1	CkpZq8c25pnibRDc2vxJZozGnt7NLT9zG5wVMV2hMVTqyBnmjPGq7
2101	fee_transfer	1764	30100000	1	CkpYbVuA5FYVoVM7f41NYiskmbz1HDt1fGY7XCic1HU6mX8WKfZTs
2105	fee_transfer	1762	70000000	1	Ckpa13Fqb6dKtKweYHYAPWBmnrWG5gfb9FnuwXbodhvVkcigxdXUF
2107	fee_transfer	1683	92000000	1	CkpYbdNLCrDqnvUDYbyKmh2czaAK12q7JHg7wWwHc973mrngiq41S
2113	fee_transfer	621	20000000	1	CkpZJrcjgSjFY9sq5FKaw62HGFjqt2yiPauRKbmADo9MTjnnJQbJ2
2119	fee_transfer	1684	70000000	1	CkpYwTkUENufLrKeqCqnFzQdiStGc6hrwHpW3TQaYoXUamCTvNcZ7
2123	fee_transfer	1690	60000000	1	CkpZmJy9VGYtNHM9otP8ifcdTzJKK13FimEp84kMsqsdsPsPsddbQ
2124	coinbase	1723	720000000000	1	CkpYmxZj2Je6CSBj6wQZGurQQVkNX5VVuzcbRzhtwjnR79uLGquqw
2125	fee_transfer	45	230	1	CkpYRagbgvFL9as7tdHSYN8NA2hx9jSB5N2MyrLGzZvESTk1RjHMg
2126	fee_transfer	1723	19999770	1	CkpZxNZ4pjmYAE1EvKdD1CueAmymiyHibBpvZBnqjmZtTmbV2Ai68
2143	fee_transfer	1608	60000000	1	CkpZwPqbo6xDWw2gSkbpWU36pLs5VwEJJjuPsB3fC6RFvVqpvZCBh
2144	fee_transfer	1608	180000000	1	CkpZokpg9E3TwPjiso7P8SNFeZctoY3Mh47KmpJd3xDqGagGvv6Zz
2152	fee_transfer	1654	80000000	1	CkpZ3KY1ZG2Tx85FGK1iKM9wajXtzJp4Wa5ThRnVYXRp9q8Wqp218
2153	fee_transfer	1685	80000000	1	Ckpa49d2TRkED1PoDuou1LoHS1t2adSXo9DdztuJYPumNNioSXq9A
2155	fee_transfer	1686	90000000	1	CkpYRKbSbtgypGgkvSWd7D9Fy9oBip8gSdCQHNYiKwN5uZTeGvuMd
2163	fee_transfer	1643	80000000	1	CkpZsqgYHgr6ApyhDZq6zaatFef2u9BjLUmi2sqH1HxzvMDmSdBpP
2166	fee_transfer	1440	21000000	1	CkpZh9GtAtvkK3MwKMcFACochvsrzuS2PWkprUqXXPWTutk3tokVm
2168	fee_transfer	43	31000000	1	CkpYfDirbWnkTxGdUcLTpDgCSgwbuyuhz8poreJ3zZtBJXQtfAA5c
2170	fee_transfer	1759	19999999	1	CkpZwBHe5FtHWdwqrA2yvidL8CPNMTNS1Y87V4dVE2bTPMcjn93fP
2171	fee_transfer	1807	1	1	CkpYrsyt61uavNV9VdZrNjQMA1rboe7fJvCngkUsAMncgDM151BUo
2180	fee_transfer	1739	40000000	1	CkpZJEYrNuNCZJWMLN1VSN78wTzNyZX3Ev3tvp8Jkhte4iCmdCPe8
2183	coinbase	1625	720000000000	1	CkpYhmXAf6MdA2kBN8EkkXB9mbpfEJyLNFGEPnxCtykGBH136Ao37
2184	fee_transfer	1625	10000000	1	Ckpa6LCQyJ6Rc7hnjmKarnyj8hYD41PRwHpe19njAKLq6rvVHDKdS
2197	fee_transfer	1715	270000000	1	Ckpa9rTaLxNMSkXjHtexi6YeJoFfavysbT8HD7mHC5b5aZeWmMXz1
2204	fee_transfer	1611	290000000	1	Ckpa1k8UdUPGWqhsBx7Wti4D1Pjxs6JPUVQDMtj9DjNzneWeR24Zv
2206	fee_transfer	1680	270000000	1	CkpYcpNUb8MNeq5CauQmSuqQJKunNM7Tdh5efKyTqLTCzWuhvTBJC
2209	fee_transfer	1747	270000000	1	CkpZAQj4TyZ7BP4jS1wxbfxQNWpwEePtu718s3bR1cYr4HVNc9BWN
2212	fee_transfer	1768	150000000	1	CkpYxhgxeSxMY1QfubDEjH7FT1nbxjtxT1s7UhHdb1iAPfBmH2oNY
2214	fee_transfer	1672	131000000	1	CkpYkF7tiFfCZUPHP1A7SaQGLtE5FQryGNhsgqqcz3bfzSpEYmmH6
2215	fee_transfer	1451	140000000	1	CkpYQHEWCqUL5eVeeAkTPvww2j9V3YTVWy4rfKuorgh9iTkSG7snR
2220	fee_transfer	1611	81000000	1	CkpZUEvPAMdSgiPuH3TxayEf2P6nnho4AfeHNGesABEbapAX1Gt9G
2222	fee_transfer	1596	42000000	1	CkpZvRxK6rAUvdhMMn12L7NDVKL2q2BZ4WdTCR5C6No3crjchx8ev
2224	fee_transfer	42	23000000	1	CkpZ4ocQJVuxN38Cqq8D5eqisimbNm1vktEAF7oxoW2r52rsbaVcd
2226	fee_transfer	1474	90000000	1	Ckpa1CpQSfuz1N5dugngNvCPUpb7MD5jUjSgDgmXKRWhgRUrn2Vi2
2228	fee_transfer	1623	70000000	1	CkpZ5AS5eQrk2A5rPz9E6wuSLihmoabDYQhNqDbhKcUX3qYMstjwH
2236	fee_transfer	1759	50000000	1	CkpYxUQXQbq18g2PHM81U8maiCC2vDdkZkaHR38jysTrC8QWe6FPJ
2237	fee_transfer	1708	60000000	1	CkpYiw3SeHvRhwpCv2aCynwGCRbqepfSTbtFyezkUeUm2Pb7s7vrQ
2238	fee_transfer	1749	60000000	1	CkpYpniirh9EyBGfKkKmypkLLfW8uN12aVxHhcboZWsZCQSMDmHpJ
2254	fee_transfer	1467	2110000000	1	CkpZ5GhgHwhx7uK9kvZQ6xQbkrkncJwDy4ARYtCgwnykxun1W2hB8
2255	fee_transfer_via_coinbase	1949	1	1	CkpYbZWmxfHTMPuTgqxwMivgmQeGwyWmBaHoJ374N16vrMEa6j93H
2256	coinbase	1467	720000000000	1	CkpZPCgYtBTM6o3UL7qVnE3vEJoZyNa1sehk75Wxy26dtTQse5rac
2257	fee_transfer	1567	13042021	1	CkpZMWucNfYMkSQbmi92ngBPywZLUj8JwXicXbvVt7bDH5B6fDfin
2258	fee_transfer	1467	3957978	1	CkpZX3PHPTooomgCZg6tdwQu4KUkpWNCJn18hn7rGEcPxpqgTx2iQ
2259	fee_transfer	1949	1	1	CkpYbZWmxfHTMPuTgqxwMivgmQeGwyWmBaHoJ374N16vrMEa6j93H
2260	fee_transfer	1509	2000000	1	CkpaJCX9cPPUqL3zbQTgJL7EVZ8er5mKnXwRmKTDyJsL7Tpwaet2p
2261	fee_transfer	1681	1000000	1	CkpZJCCUy8CHSsNimjWLWVnXnc3QkAXRxqYhscoCopWSboZGxDJrU
2267	fee_transfer	1594	400000000	1	CkpZWLgZWwhkL1ZHbftJzDnp7SSnH6xuT48jGqE9KZSHdix61y2gE
2268	fee_transfer	1656	121000000	1	CkpYrdNRFTLYJv47B6dqDiTSEHNkTe7Y5ZuCCL5pJctQHkCMKNcUG
2271	fee_transfer	1419	61000000	1	CkpZuqRWr2msgCUjpRbk5jBJXJNcoV88wpA898yoAA4EWuPoaoRBq
2273	fee_transfer	43	61000000	1	CkpYSY8AuqgufDtWdV7zuXjy866Jzvs2FKg1X9cTFcGfZDpPkdSsd
2279	fee_transfer	1746	65000000	1	CkpZ5mma4Vx9ikrqZdemqUP6it4s1iXjrUFuK1DVvSzG831esZY53
2281	fee_transfer	1637	65000000	1	CkpZ77JR6JxMHaDf6E2D74r2RNL9WjDmB5expsJhmc1FytZxnnfi2
2289	fee_transfer	1637	590000000	1	CkpaFdrwW4gnZRgmEX1Z5ziVEsvg5LQ1QLJ8G8uuzeobgerQbhMQn
2294	fee_transfer	1440	27000000	1	CkpYyHRuhkYWqAE8kxfLgXjvdjro9x2kCFrHmiaqbqbwctnUyhJfy
2297	fee_transfer	1402	51000000	1	CkpZdiDcPpBksfuwmYWaZFsNNE1F4yEeSAdoyiAy7eEvTmkmP8oX2
2299	fee_transfer	1439	27000000	1	CkpZeemX9bcpmf17Xd4DsifmBdwrZL5os2WMPHAaUvwrxx4b7vtA7
2303	fee_transfer	1439	1757000000	1	CkpYyvPG4z5Xzzn8qKkQKmAnXcsXQcKNvSPm8FHeJ1aA5CoDSpa8t
2304	fee_transfer	1439	44000000	1	CkpYXWXsbNmhHMqquSyqhJGFUZrX16AFVSQ2ziTopRSsH5heLGJR6
2306	fee_transfer	1688	149000000	1	CkpZRoUNGcBAgosrWfcvSb5Q2XZkqCMXR8CJXZWfouGRKm9HbAms9
2307	fee_transfer	1693	161000000	1	CkpYp3MVy2ZS73Ri7EKMBoMqhuWpbyc1gQNZVhcibcUfqendKNtoE
2308	fee_transfer	1724	1286000000	1	CkpZJaFwUpbhwdJDgJHhkSzpVoyaBsFb5qNwxJD1s3e2NxNYGQaW2
2313	fee_transfer	369	70000000	1	Ckpa53goiBHbYhpX4MRCgURkxUCsNeB1y5hkCGo8ja98KLgB2QiCt
2315	fee_transfer	1702	40000000	1	CkpZxRjaoUySk5f36THMReLF6toxMK25gAfxszP2t5LPxJJFoVaZe
2318	fee_transfer	1564	21000000	1	CkpZecRTwMsVcvsweTRd3XUmwoG82SzvZwU2coYZQNS3kjs968dmo
2319	fee_transfer	1762	160000000	1	CkpZFD2zWLWHaup639GVRxw7w127ZSXwQ43MnqCYJ1W2FcN848FvM
2320	fee_transfer	1596	320000000	1	CkpYRgCyCkhpeRmPiFkGj8JLEmdGoEzB5dLrrmsgNcjqLfyvsLzeD
2322	fee_transfer	1670	70000000	1	Ckpa714idM9wfrSr4cFNyXQcgzWR8K85NLZv6PoW4rJ9TVUwjM7bm
2325	fee_transfer	1715	60000000	1	CkpYscmiDVvRGaiTgM1Aq1Tdu9NHA3aWmDVPvHMi9XnSZqPvKhV4h
2102	fee_transfer	1457	11000000	1	CkpaJzWHGbtMbZA3ZfSzc7qaHNn1ajNGyngg4gVYjL8UigEk7MpRL
2120	fee_transfer	235	20000000	1	Ckpa54pjRnnj71YNgabswJPoNwVe6ZEDCtxrffGkfh1qmdV3PkSW2
2121	fee_transfer	1723	80000000	1	Ckpa2ZM274qsJQK2tHKS8GHoztW8tB4w92C6Pip7K1EB8mzaLa6Vz
2122	fee_transfer	1555	22000000	1	CkpZkKVV1w8Rm1tDPKfndjtscR1Q65NCZm3rSPVVkHBrQ2uu5D8rL
2128	fee_transfer	1623	3000000	1	CkpaADJKZkdUuRpBc4WzkYsVEXiDRGvZSpWxXyR5wMAiufEMHhLWo
2130	fee_transfer	1709	41000000	1	CkpZpwNrZx4q6qav2Tcin2zeJnGRGugm9M6UcwRFtySEHcsTcSFPF
2135	fee_transfer	1434	20000000	1	CkpZB1wDGJ7V6h3sqtrrYD5QyA4mUUyWP4fPEPCEgFNNS4aq96haV
2142	fee_transfer	1729	160000000	1	CkpYTaHvSRRfsjuAZEwVjJmuPgBTfTY2UbYUwLGa6n1ZfDDpjkdkv
2148	fee_transfer	1719	60000000	1	Ckpa78o2Va3nzgagyxJWXNe15dpdD7WBC2eL8BFN9tLYfAfjf9pJD
2149	fee_transfer	1719	180000000	1	CkpZRvc7D1kz1V8p8nwwpEEnipquyZ4upfqVSdRAUeWvjeL77WtSW
2150	fee_transfer	1700	70000000	1	CkpZJLLrCuxFFtofAek14ejeW6wy2b26Fo1q2uUdBb5LuzcqLdtwt
2151	fee_transfer	1679	80000000	1	CkpYUdwA2DSsc5Vrq6BywowF9oyFVectVPVQtS2sAXp2vfUBSUEs4
2164	fee_transfer	1607	31000000	1	CkpZ29QkZziiaM2b6BLfszoPy1Kv2VcUxX5SK9TnkDBug1pdqNzy4
2167	fee_transfer	1688	31000000	1	CkpZd32AxqeCCNaJvHrHC7V59SnB83MQ62ApJ9VUqMYzzEPktY9j6
2169	fee_transfer	1449	40000000	1	CkpZMiZqu2skoFZNMejnAdgiuK92FVRss2warS6zUQMpUSaV2re3n
2172	fee_transfer	1708	31000000	1	CkpZZM419xGfrjxU1zCHZ7VwQ997Q2SXA3KgDeGd3Jf8YjuYT75Es
2181	fee_transfer	1633	70000000	1	CkpYdpgWsJxY2FKwcTHAk7rnguMQNyouPGvr7BukKqtMLbK11qAcA
2182	fee_transfer	1685	100000000	1	CkpZPet89uBGXZCebVAWu1ojJDTBWevQiiGLz4bZrRwZcbuDE57Pu
2185	coinbase	1603	720000000000	1	CkpYoULdbBei6hq984xGMnYjwt2aosjqPQxSp19nGNf72Z7Mxi3Lq
2186	fee_transfer	1603	20000000	1	CkpZXH2cBqXckLybwtsTqXGBiPNbtsPcMX1FshzRt3w8G6kp2Umxk
2187	fee_transfer	1625	40000000	1	CkpYQGmu1WQJNWG5Rx2iyQHNBRVBWCGboig5U7Gp13KJnvxiFFsL4
2188	fee_transfer	528	380000000	1	CkpZVNXaSVrtoFg9mWmzWeHcbW22Qb2fhXbq6EmfxdhXr7CQQN7iG
2189	coinbase	528	720000000000	1	CkpZmi4a55HhssRyJhhaQVY5kkzqQCQJntC6j745GsJgJ4FZGyuaf
2190	fee_transfer	528	50000000	1	CkpZYm14WUD8fcFfxcCxSnSYBbnD6ju38hyKNA37zp8Si1h49Qizu
2193	fee_transfer	1467	2000000	1	CkpYfJRZ9v44Bj6ALt2reykdXVPE7We3D3o9uA27qutZr3rQhdzc9
2195	fee_transfer	1764	270000000	1	CkpZPwcYPgNzU7wYgRNYgN215czw6oibSD1Rm1WdmtPsDajBfvPmG
2198	fee_transfer	1513	1000000000	1	CkpYZn4PXvuPmZgLmJw1jWEBJyP6wueb3rjZkFPm9FgxZVowdScSn
2199	fee_transfer	1513	580000000	1	CkpZSYub1TJmzgoJZr7TkyYZmuewyGC17tAfMhaQApEtM6pKqsYJ2
2200	fee_transfer	1718	30000000	1	CkpYsBQLrCFtDYXFtDHAqcRuRibPuqLAQGTPM7GUKutHaJhRDdChL
2208	fee_transfer	1704	270000000	1	Ckpa38wjbdF3yGJxUAXRm5tfDzciENGUSim9wroi9LfCohroVny4g
2210	fee_transfer	700	150000000	1	CkpaEc2wRgmXNvpMLnw6tsubKRsAc6NmfP8kA994eombye6cEhdqm
2216	fee_transfer	1447	140000000	1	CkpaHTGjxqL9rqRbZLXzsuNEzrSFDC4GP1jjK5GWRkZtSr8jpLB9D
2218	fee_transfer	1688	230000000	1	CkpZ8wpRcG2jGt7E5wLK8E5VwUAnxwg7KfZgnqB5oCrvyTBYWeXSJ
2219	fee_transfer	1422	81000000	1	CkpYWsi6oasPiYT9vjsTUNCs7Bn19fKJVP9BPwZkt2PNybo67VBmR
2231	fee_transfer	1650	70000000	1	CkpaBLADvZN8en8KTa793A52Bp2BaVnxegA83smFG8PfgUygG14XB
2234	fee_transfer	1447	30000000	1	CkpYRtb1JtDktcmE8E2Aw6GwjukDuuyywHrFD9aERB4m66HezVKVa
2239	fee_transfer	1649	140000000	1	CkpZm2gihMJDFXU7poqirMAaRoS62xRoEcGroVRcwePkUst9VD3Vi
2243	fee_transfer	1634	80000000	1	CkpZ5tRj1cWSjwoDcmopKpUiZp3AEPgmL8Q3o8VEgGvBrDT3j4XFX
2244	fee_transfer_via_coinbase	1539	1000000	1	CkpZppxUkuN2QDiQ5Uy9Brv6egDzu8y8M6gJdy5ErgWdTS6hY3Sof
2245	coinbase	1634	720000000000	1	Ckpa589cREJkFaWZNNH2DNzi8bzBRyFNi7VbWzwQc8SbHByme7CVE
2251	fee_transfer	1719	51000000	1	CkpZ8i3JGTKYibeQw6jRrFn8cWLN11tWS3azXjF4tASZTSHyafGaW
2269	fee_transfer	1564	121000000	1	CkpZyfdS6fVu2mFELpprhnPe44M6ZEiwWhbQMruzCK1qjtJ7qRaZQ
2274	fee_transfer	1683	61000000	1	CkpZdLTHCEmUD4NjTUnc2JUfzeNoqHYnwaTBcXg8sgfTWjxCnDFWD
2276	fee_transfer	42	70000000	1	CkpZxgTiAtK8d5QPb255dEYzCf7pKJdUCzosDKS138Tmad4FmsFX9
2277	fee_transfer	1608	65000000	1	CkpZdoTNAz8sG8FeNU2QJeTTrAsLgLWgNUzWJXs7mqoK4waeMoSu1
2282	fee_transfer_via_coinbase	1500	1000000000	1	CkpYcG5jVGdPQfnRunWd12PvisYcjr5X43C49UCABAfNTkHsZUyqU
2283	coinbase	1467	720000000000	1	CkpYQHbcp46f275tb4kZ8vruiTq9UhzKtCbDQCj6wR5dpLtGtGrGR
2288	fee_transfer	149	80000000	1	CkpZy2CJ3cVJpwbK9Td8kBewcGedfwNo3YDqw3QPoFrJiPva6KkNc
2290	fee_transfer	1672	21000000	1	CkpZahwB8N8bRHvF6vBjwZz4rwxVGU73NZcpdsUKZWJayD4baSMo1
2293	fee_transfer	1668	22000000	1	CkpYtdbVBY4zTeoVBhqAQqaoxLyDoUvkPwCSrTKujnyzQbm22jhrt
2295	fee_transfer	1692	27000000	1	CkpaF3NWb13GTdmu66kGYGcT37zHy2ZAZH7AQ853k5TAebBQZvbCT
2300	fee_transfer	1683	27000000	1	CkpaD5AkzwLJQMg2n1FjNxnXzdJAwxFhFy1fKHNnJK4FE1WV8uH47
2309	fee_transfer	1724	81000000	1	CkpZr8b28LVgwjd7p17ztMLMdV9viaGYzkWGNKf7tVdKr6eX2m9fB
2311	fee_transfer	1680	130000000	1	CkpYQTKBqzzsz1MgvGnadJWGW8A2mE1AUegSyWcHY8N1i7ML52hNB
2316	fee_transfer	1571	40000000	1	CkpZPUEKMprbnyV2un8mbrdqUVFJ2ku5BnWmVBNffYYx6jzJgTXfQ
2323	fee_transfer	1546	70000000	1	CkpYVS6V7ikV8ZM4kUDN2Xg7ZKTSt9YB2LDzJ7mWpAsLL9vfWdv4X
2334	fee_transfer	1593	61000000	1	Ckpa7a9frjWcwQHK9BGwUenPVbk3Dh3KmxbPM49uCdBoFdXM2jAvN
2335	fee_transfer	1593	71000000	1	CkpZSFuob5g4M6FMVUDJnLjfhhPWsyf7JPaiSJ1HjCwwp7nihpFHh
2336	fee_transfer	1714	61000000	1	CkpZbtJ3LVcQ2NhLL1C49n1h2TxqbQ5JCDkhDZY13y4ndsGWBTWPV
2337	fee_transfer	1508	1335000000	1	CkpYfbr2DcwAzCeSyRV1E49YLBG4HDmRH87XWhFEcqHwHpyx8N4Lf
2338	fee_transfer	1601	50000000	1	CkpZZRWTTgdTL2p6WxuxYh2vLhYhFZUHbr3huacUksgHbiJ4mtjLa
2339	fee_transfer	1637	262000000	1	CkpYZ6g7qNvCaECrWZGbU9tSsAZt9DYBgYtTiyV8vLcenpm9m7C2e
2340	fee_transfer	1693	60000000	1	CkpYtWAtoXRqE91Kkj1vm3gNVMrNttgfF4PJS77RnWWFWko6dRTJT
2341	fee_transfer	1701	60000000	1	CkpZRp9oGZZ2rfAhcwnETmBb876PJL9eS8SQnHcgtoC6eioPM9e4Z
2342	fee_transfer	1685	60000000	1	CkpZe29YoSHpZ6HMP5NDZuRVgDTEcQZxYp4YtYnYWpTt8dRJq9sA8
2343	fee_transfer	1654	51000000	1	CkpYv1GD11qJMrz2wsftDDm6YUgqebw85CkwWQXTN2EZSBoRmpNEW
2344	fee_transfer	1727	321000000	1	CkpaE6LaZPPf1bSR7cmhdrFPDhywraG3sHeA5zPSyCop5iuwKt64S
2345	fee_transfer	1643	1710000000	1	CkpaH7pGEMRkfsNPoDuHw77CSuHtqVQ7MezNW8dLY3AhkRhTrLj6L
2346	fee_transfer	1643	1030000000	1	Ckpa9bWbxUgj8M3aMYc5jJwKFpqcxvmAHPhX9W1c9f7Q6VxsgdKEQ
2347	fee_transfer	1649	11000000	1	CkpaFHmFpLzSntEtehFXJ6t3iXcGZKfLF5yLdRa36fLGLkjjktq3X
2348	fee_transfer	55	11000000	1	CkpYybGeK4ynEM2Fr74jz4zAqzg5DSmMmsQBWbvu6u7mw2suBDmwV
2353	fee_transfer	1656	60000000	1	CkpZ1Jkdm5X8ggWpseyfsdKFNVW86RF1ubJhFCHNMh2bFqmtXRKWE
2356	fee_transfer	1708	22000000	1	Ckpa7X1dxEGcSaTm7cpnRjZUPXVmgeUNsDMrxa5mkqhxGKdCFPEJG
2365	fee_transfer	1715	23000000	1	CkpZGcQEfVvSCa5PjEmXWBYBvnKoKG3sveJzqgJ2cesLAkuUJwLev
2370	fee_transfer	1599	140000000	1	CkpYoszhtuPGmJbwxbVJ3ygzk6bUYZq5K8nt6nNa5kFKBQKD6JbHq
2376	fee_transfer	1398	121000000	1	CkpYUGKCmNejGThexukZPTQch7bS9JzH47Vn9AtxJupT5eC1xUwPv
2385	fee_transfer	1448	211000000	1	CkpZfroL7icKBnFpFdUQdcjWkAKPkFut3tkuqU4R4iectFQH5upSa
2401	fee_transfer	1706	50000000	1	CkpZpxupE6r7W2gaqbLR1TFf1ktv8RCQ9htRzP393RkE9wwUvy5hG
2404	fee_transfer	1593	74000000	1	CkpZw41ykDimAL7Ssawy6isfEZiHFr4rzWkAxLdmyMiVwsPN5ngUr
2409	fee_transfer	1764	490000000	1	CkpZzdKP8Ut7y2fa8g711MA1AC3pPdfnSbyPg2DZ3hRUfNnqE8Xpf
2417	fee_transfer	329	20000000	1	CkpYx29VPQ6BE5v3MynmRpi2kzwucbmk4Wx2mBkgUhDxtFHbAJZSd
2422	fee_transfer	1643	1480000000	1	CkpZk1kyu3eHyhQ11EVVnCwyJinXUzF2HncPKihmiZQcAPm8k2qn4
2426	coinbase	2009	720000000000	1	CkpZVCUAoRbW4u1x1CmNsP5ZiPqWXwpaPQAWk8NnzKNiTRuzh8Pgm
2427	fee_transfer	2009	20000000	1	CkpaDFqavSdXjpPbhEhSFwVmQAiCMdZv8XmF8dKG4MWboyDFxSujD
2430	fee_transfer	1506	120000000	1	CkpYeNmCycFAL3DmXFT8BnxxtMEZLe6WXQVzEe8Ra7tDJVjZSEngz
2442	fee_transfer	149	50000000	1	CkpYdRahdZaGXxg1jyju92chi1Ph3QcMX8sizmQz9cPpr6nStW26a
2445	fee_transfer	1692	60000000	1	CkpZh5sRXG8m5p23JqYrCcuZJKa3BVxdhmhGkmTBQq4YnAfDWYNpj
2454	fee_transfer	1467	230000000	1	CkpYVpqkvdURdrRbyodX4M8B7o67U98MPPSDSrRvwPoLkwz8WnJZx
2458	fee_transfer	1672	50000000	1	CkpZzyt2wbtFpLSpdoyP4DzNBGMAbEiXsAdhjoB4cojFAHSwtinTT
2464	fee_transfer	1705	37409880	1	Ckpa34QFrrzwukTEg3VTjKvHLYpftNAvmA13BwPztmFF2PbNwoWQ6
2465	fee_transfer	1571	120	1	CkpYyRgD1vQg7roNSYEgueMzCFh1ci9aBUnDJwNgPJjxW6Fwamsn2
2469	fee_transfer	1718	60000000	1	CkpZir5KYvsJ3q8Y7GAr2kq3yo9T6LWmpC3L6PexSnuAD2xdieP7N
2473	fee_transfer	1602	60000000	1	CkpYiA2QBUKTF7iBPCcpya6Ytgf2Ybn3t15pjLbPhLQYbMjKGbwNk
2480	fee_transfer	1444	15000000	1	CkpZankdYAYp8mknPCHtVZG2bPvxnUv2yYe72TkA2qqhcpPoTpdux
2482	fee_transfer	1559	320000000	1	CkpZ6g8bmYhTiWezeKDWt1hFYuqWQkLt6Knpt8w6Tg5SdXcSVNb3T
2483	fee_transfer	1671	70000000	1	CkpYxYjdUhMppM7M79Mz5AenKRMfBfqcrEvU28KME2w3dUsr7Ukq1
2484	fee_transfer	1549	40000000	1	CkpYXmfDboBwmvrpSujkcniZMxBxpE5NHjVdLiVNeEkw658xK3PWx
2492	fee_transfer	1564	1040000000	1	CkpZoEazZnKkPK6TZooSqsUaG87E2xVQiefmSQXZc71WbG9s6zehh
2495	fee_transfer	606	460000000	1	CkpZ9BD9tzX2RNz1ZjTko4L12eNYwJVWP8spea5zrnApFAsTQor6w
2502	fee_transfer	1677	9000000	1	CkpZ8HMSUF6nuL7VUAEz9wM1UGDMvbKXJzi8DVYhRP5dTKEfR2oGy
2503	fee_transfer	1509	1000000	1	CkpYUJpEm6yxj3mhYaatef13bK1vUadW1SjTAkEnK913AfJApZaR1
2506	fee_transfer	1685	70000000	1	CkpYV84bRQjDabZtteuW4skB97n3RiV3F28p7YqzQka6QRAAUt6rv
2508	fee_transfer	1706	120000000	1	CkpZ126RAaLcMy4kioNZ9RYGc8iF1s4qaPn8v3cg1dfYmcVtvheRk
2510	fee_transfer	1522	40000000	1	Ckpa5rJgWdBo8rJDFSfNxbBgwhjTqyKMpCs491WHCptsg7S1PJZur
2513	fee_transfer	1489	190000000	1	CkpZfP4Vs7LdgFC2zuuz45QDMqreRq6Mz9MsvYofB6bW12NoavxTQ
2516	fee_transfer	1696	120000000	1	CkpYU8NY1acpK3tSQ8BZuEzxEAnFHSiSdM6Ud4S83wvJpu7imhpEC
2527	fee_transfer	1675	70000000	1	CkpZCkKpgMixPBZTMEw5mTET5hJyhZdb9aJ8PTXT69GJ65DuGu9En
2528	fee_transfer	1701	90000000	1	CkpZEfPQYo1GXLL6vHsWXu6JrtHA7HiG1SbTbKKq3oprWrHreAicP
2535	fee_transfer	369	220000000	1	Ckpa91cebm1MGXLecACG4Mf5ZF8HFwhPKy6vjMCyM31ci8o7JKv2Z
2538	fee_transfer	1691	90000000	1	CkpaHazVNW5XkMvERMqVhHF3ZoQSd6hmkFNSp6SsNwaPDqXayB75M
2546	fee_transfer	1633	80000000	1	CkpYfc8sxHGiFxMwQTy9uFkR6ZYJ4sRkEckYPt6vVinVbzwMNnWp8
2550	fee_transfer	1700	31000000	1	CkpZyvrBCEhJugKdAhD2oH3wzPnKew647MB4jmBuW9Dbn2jqeSJoW
2551	fee_transfer	1610	21000000	1	CkpZRXVPLZY5D1L6DudsXCVrNeFTzgLHkTHyhvhuq7yLCakrP8YaL
2572	fee_transfer	1471	50000000	1	CkpZf5mxGsw8xQxgir8nKu2vX9Erf4DXqe9eHfj6rBoMwhxcDFPFw
2574	fee_transfer	470	80000000	1	CkpYz3ZsnxLi6nKhXToK4AwtTK3oabo2sj5twMuFYYev6AGRvvMxK
2578	coinbase	1980	720000000000	1	CkpZUVEYjGLrqQRRQonjkGzweqL9A1Ggnd8zkJrkXKRSE9P6xBY6E
2592	coinbase	1472	720000000000	1	CkpYirCVW2e5dQT36mo6Yg1KA4qP7e1edMUzSMZT8AY6FpFQLzj8F
2593	fee_transfer	1472	20000000	1	Ckpa3KxHKhqhtAT99u19xTxWn9RZqsfPWY4sjuZGAm1MafWssA35Y
2600	fee_transfer	1690	31000000	1	CkpZ9pbAmi8hDAVApYdYCoQ2KzWsU2oaTiYij15Rqu4oWJe5meEfU
2610	fee_transfer	1692	90000000	1	CkpaGJmUFt1FyW8KBmYNK5PbWKaPBU1widoYh1hrqfswebv3RA3WF
2349	coinbase	564	720000000000	1	CkpZmHKbaK9jYMsDPa5e6Aq5bE5ffvJeaccD2zq6hBPiGRyf3AB5F
2350	fee_transfer	564	11000000	1	CkpZ34wKyLi2hYjJGPtxFjgKjapnjbLGVt5YTJaTyJSRCPaBnXr5E
2359	fee_transfer	1447	57000000	1	Ckpa5NhGHRm38ysS3m74Cxow3o5UD3MNxjrpBtPD7YJTshs8KpWGH
2360	fee_transfer	1689	22000000	1	CkpYqfRRwnuKpsDGERL162fdZU1pu1W74JZebvwdvQosyZoFZmBgv
2367	fee_transfer	1729	30000000	1	CkpYQ5jcokiiTns51341a9Bpr2K8zHTPb16uBqBsxZmDEXb43aFUw
2371	fee_transfer	1402	140000000	1	CkpYvzy2As6TNGRYhFDNiFL6egQw5yCfG6VmwBtSfWvVPXcJ81mX6
2373	fee_transfer	1593	170000000	1	CkpaKFfGjYExc7kzequTDrr3rDp8wo3peRzAghzohMZhBE9wBqj79
2383	fee_transfer	1426	260000000	1	CkpYfya4PEuoArrFCwTHmbkLs5nkQYzKum8MU4rEw5vodyRTMqrXG
2386	fee_transfer	1677	211000000	1	CkpZfvQ4nGV6fmtdJdqiB2KiFVtc59HXJRfoK9ndQRrfhsFoCKLZW
2388	fee_transfer	1444	210000000	1	CkpZbVqcwdq2bAqGQq9znKZsrXX3d5g4nyxJMXYKnefmcYVymBVF3
2391	fee_transfer	1518	210000000	1	CkpZNnTReoxRHm3MstfkZtBaR3e2FA7srqstopvSNrLae6jfKxbZ5
2394	fee_transfer	1542	100000000	1	CkpZQhcotkix1BLzUgtJuyTuEuzmK1KN4vfYCvmrg5nzF28tUgvEH
2395	fee_transfer	1696	4000000	1	CkpYfnvJKFqsUsb3TrqGhC4EB922V9rKXV16XZUMBzM1H7yvS6NQs
2396	fee_transfer_via_coinbase	1425	97400000000	1	CkpZJCcyqCUS5v93MKocrqCXfT4fm96ZA5gbjPDRaFbzqGhNuBkLK
2397	coinbase	1594	720000000000	1	CkpZnrN5sadWQKWPiuLfGGM2R6PorJCHU2Ye7yXWP8XJoShqnnTc7
2398	fee_transfer	1594	310000000	1	CkpZL5pxp2Vs5VP9pCTPaUqRAm7qtwNfgtxtbfbmrGQv4CcQXGugW
2399	fee_transfer	1622	190000000	1	CkpaKLSf65Xgm5spQr6CJK3Un8RNNZ3VthdguVpvFw4ravo6P64Zf
2402	fee_transfer	1706	1770000000	1	CkpaKrL17pQqS9ahobDQjyUiqo1YximYgWhJeeXLzH6Zk1annE7pt
2403	fee_transfer	1706	110000000	1	CkpZxkBD4qnu6dHjiLv6cm1f8MqotD3ExpkQDMEheqRcqoh5pi5U6
2405	fee_transfer	1683	74000000	1	CkpZHCwkrFheBMDL9xjLn8EWwn3taXaT1Wx7kHK25CobEjECbbEup
2406	fee_transfer	1688	271000000	1	CkpYhzauab5VdbZ7hs4p47pGrKj9urKnFjAR5W37E77gKgqKSDSTn
2410	fee_transfer	1683	490000000	1	CkpYZTfWFuq4HkVnVoWJv1WQo7bygmUUZMAhC2tJMdxgZf3f3wuyF
2412	fee_transfer	1761	14	1	CkpYZfBtLaFE4sEQwb4iqCvhG61rpdYAvYJKptQMBfVrX7uToBvox
2413	fee_transfer	1706	11899864	1	CkpYxmLzz5KrHnzP6jkmC3LHLWAQWA98fuBP2j2BAzhmLEv5tJSwf
2414	fee_transfer	2000	22	1	CkpZaFy5NXYqaGQqHVuvzu2wDCfZJzw28KCwDnSJVow4Uojedv4Gq
2415	fee_transfer	1935	100	1	CkpZYLUiwgVeNW32U2PCYCbDY5tk8ZLuiTJbNAoRto8PRPqNHyr7i
2416	fee_transfer	1804	8000000	1	CkpZykPm8tccaXWcSTjwK5qQjWhGicJzEbSxU5J9j359C6k1SDnQA
2423	fee_transfer	1685	150000000	1	CkpZjHwrKB45KgdYoWhUCqFrJ4W3bB1HzvB8wY7LVPScDQUpiLz5v
2431	fee_transfer	1690	44000000	1	CkpYq1QKXLwvZ1VeRheNxu2Ejg5hQmRd1ihsYnDco1KCcpUxJTzWP
2434	fee_transfer	1790	300000	1	CkpYZAJvi4d1EfqE1XYyZLtgT8g4HjK31auL1gFd687wjw1tvmwix
2435	fee_transfer	1796	1	1	CkpZcg4RcygGnCMeAksTYzXfJ9zmPCuVQCBp8ekFYBBKpAViP9Dac
2436	fee_transfer	1567	39126063	1	CkpZxomNga8DaYJJpduTzjd5y2HpyShzi4L54wUoaqPQXJqSgHky1
2437	fee_transfer	1761	40	1	CkpZipSNQ4hXaSAHieL9mudXyNsAVjhJZ4jd2KQLh2RBeLZRYa2jw
2438	fee_transfer	1508	573896	1	CkpaC81G3q1LAkCUy2qTYZBDFHYaiGJMmwmWn8JEjAtrYDGAou2Pa
2439	fee_transfer	1508	15000000	1	CkpZbbZytu3tLj2KfUoNk45ifLyTPd8LmzD53nn4bnVbapMEGCAE9
2440	fee_transfer	1508	29900000	1	CkpZteqv6ScQ7VuqxCqBuJibdZ83dUnBnX2Hmo7wceTyh2F2mpj9N
2443	fee_transfer	1573	40000000	1	CkpZ3JZ6EhiBieD1uvLAiVrWeDC3Q8RRF3v3gbLnt9Kd1qUU89hYX
2446	fee_transfer	1643	310000000	1	CkpYuquNjyH5DieSCRc4s3AuwHx22zZFp89mVgqy4hotxb9gLEVrA
2447	fee_transfer	1643	355000000	1	Ckpa264Ww2apaA8eYokJHyqJXbvuakVjArmyrg7reRJMXq3xyfGrs
2451	fee_transfer	1656	120000000	1	CkpYpZMwGz1tYCCN9Fin2rfPYC3gZSmrtJeFdbg9ZYtLTjtC7mdRK
2455	fee_transfer	1698	1720000000	1	CkpYuBRzJ22pYyTCUMNLBZZhDMpg77FRVqwWeUkr2wS3vG1L52FPD
2456	fee_transfer	1710	70000000	1	CkpaJCmwSaQFUQWviRpbnxFRZ9PfApnkscegkNjPcgmEknETWk3Do
2468	fee_transfer	1703	50000000	1	CkpZNkPKBv3JYDHQmzr99qmF6iw5ysX2DgYhSWSkoaXZzJXz2hEZV
2471	fee_transfer	633	50000000	1	CkpYXppEQxEe31pTYSyhH32aFb15UX86DQ4ZnHktQ6Wreg2yySRsz
2491	fee_transfer	301	10000000	1	CkpYdk5AVH1vkBu3ZsNTCsNaiGg8c8TJ8d4U6KzMgNudjs4iVsG2E
2499	fee_transfer	1615	20000000	1	CkpYX26EQ9XS3dEwsf7YL3UAYnXXtdhCdmbo9XtubFj5tboGWvgEf
2500	fee_transfer	1440	60000000	1	CkpYSZcDjucVWF1ytDa4XrMCB2XUFaRufuuY35im5MxMaJAnWZitW
2504	fee_transfer	1604	800000	1	CkpZPdaX13vWjM98PXRMu7Z839m86MRxz52p5pHYmt9LE53MLSm7X
2505	fee_transfer	1718	9200000	1	CkpZKdBrVbbxymV5fNWcUzjW8yktgmJwSUMhTtdAWzdgkHfeCYmnD
2507	fee_transfer	1622	50000000	1	CkpZPc7RZKfBhz1S9g3TUEkTgjZhYgSzR3C43T546sfi7YoDKY3em
2533	fee_transfer	1447	90000000	1	CkpYZVKwZWepwJ2x1HsDbue1urVAgcRiZq78gWHFY16ddmCiDabc2
2539	fee_transfer	1717	90000000	1	CkpZwz65rodZSnfUsEyuyDJiH7HdwMMejDQg44b482ThYUijd8rDh
2541	coinbase	495	720000000000	1	CkpZW2Z5Y2K7ndoZmqjkCDPK3jaUkBA96qABMKGMQFDbihM1AkTvm
2542	fee_transfer	495	20000000	1	CkpZpgFjxfqQkJc96wvdoNpqhwengiGmSbfdZQ1hngD5uLRvoBdEw
2543	fee_transfer	1705	40000000	1	CkpYvXLVDWpioG3EV6g64fwxwphCNYBQVjtVuSEEXbsjtta2unzsC
2547	fee_transfer	1587	390000000	1	CkpaBq6YCDvjTg4BEebFuA3Cq5fzrWKQydSBh4AiYSZiEzJUCMXqW
2555	fee_transfer	1549	70000000	1	CkpZjJYxosA5q9b5PGmpiQRRsS97rQHRhMEkxFakpmrx9rLAjcZS4
2558	fee_transfer	1467	280000000	1	CkpZ6BfoiSeDvpynAWdtZRdicDw52NH2CartWD2mPVz2fEDj2hnHn
2559	fee_transfer	1467	1150000000	1	CkpYrJEn5622TVKWPh5bys9emBrMBW7dwEKhdrfEc6Po3hbicsYww
2560	fee_transfer	1449	20000000	1	CkpZfpe3YPnufVJ4MaZjpx7JdpJpYrDtNeeKL8p7LdsVc12veidgX
2561	coinbase	189	720000000000	1	CkpZ4QZF9cyAXd66rckFKQv5eb7DXUisRqXPMmY7uZgZW8JZWLUcr
2562	fee_transfer	189	40000000	1	CkpaFureXVZ6NTAwyr6TGitjqcjoCjsfB3qu35miPZaBtWbajaBRG
2565	fee_transfer	1710	21000000	1	CkpYoMesXwja4XQ5jCiBkh1L66yc1ubJtsidCdcAD7NMc6ghorU32
2570	fee_transfer	1654	22000000	1	Ckpa5jVrg5cXFjv9DwvspdVjoaePS8y55fAgcqVFCHyXArHV4eCnY
2577	fee_transfer	606	42000000	1	CkpZjigGASPbaJQWYZGj5ZFsuQTJtJdjxZGrbBVdPzVxAmeXujdJs
2580	fee_transfer	1448	72000000	1	CkpZbg7XAqhTLARw1AKr85pxJNN7qfBfmwX6tGBzZDhreQbHsAvD1
2582	fee_transfer	613	500000	1	CkpYo2uG7hqpT2f1X4mtqbNm1NUK57TGTHWhoLgxHDEkisGJz5BEQ
2583	fee_transfer	435	10000	1	CkpaKm4kqfUqZ617qQ7695GM9wZaXw5Pm8p3EiRuyVGd6mtq9mLSd
2584	fee_transfer	1508	69490000	1	CkpZ41pzNDuRqvHm5n4MU9u2WysXFJaw3WAqze71x8jA2Wgn13jmD
2585	fee_transfer	1508	81000000	1	CkpZW8XiuyTVaQqqCdfso2UEAAiiQ3Zj8dqc6jWpAGWSpB7p9kXGu
2351	coinbase	1992	720000000000	1	CkpZJfixYTTmxrG2XJHbELiquSeYJvsAhneEB6cxHXBmVAMM8V4kj
2352	fee_transfer	1992	20000000	1	CkpYhC4g4CeC6JTH89FfnXX78bv4dK6pSDHff5siYc7gX8GFhoFN3
2354	fee_transfer	1739	23000000	1	Ckpa7oLDun7CaDmhACygqUUR2pRoJSiyv9EkmpqVwHWLYkGARDQ1P
2355	fee_transfer	1637	494000000	1	CkpZ7DAysPGWbzLyu3Wc6exWHMEZ7kJvyUwrUsx6MFyb1oik8bQd1
2358	fee_transfer	1677	57000000	1	CkpZUsR6isLMGQg85M4JAANBj6eEeLv26TZebYfzEMSruMdDALZDp
2361	fee_transfer	1508	149000000	1	CkpZBn8aQ7i7P361T9g2aqNTJeGb4ybNHiPUTkbGZ7KgMPwNqoTmL
2362	fee_transfer_via_coinbase	1509	1000000	1	CkpYUJpEm6yxj3mhYaatef13bK1vUadW1SjTAkEnK913AfJApZaR1
2363	coinbase	1508	720000000000	1	CkpZNestvAnpkiaECC9f7H9PVUiPqZwEtmjUdmcD8baqN7iarNhS4
2364	fee_transfer	1675	23000000	1	CkpZa4PP1Hv62LbdGfsajEv4dV6qBHWjhALd1ZzSCwyr5LZTzXZhD
2366	fee_transfer	1729	60000000	1	Ckpa1JLD5cFsZ1ri9qS9Uv3Rm3RE5DtK5Kns4GgkLMpJeACDgHvjF
2368	fee_transfer	1726	12590000	1	CkpZ97UeFyfFPYo3Gr9LkC2DQB7ztNaUdjcWKQBb5Jrgc3muaguxU
2369	fee_transfer	1439	850410000	1	CkpZQFcLJw3jdxtDuhQYMQb83qSApu3gDrp1LYfZWCSVTFx49Q7Xh
2372	fee_transfer	1679	100000000	1	CkpYygnCT6uDyipsotv3J6uw8Z52PcfJNNVQKrGGnqed6Wsm9rkqb
2374	fee_transfer	1593	21000000	1	CkpZxbXwBfFtBRTLBvHanVCKtRkMqpZSQyvLfoDTbnKZRB9j4Fp1E
2375	fee_transfer	1657	212000000	1	CkpZpGQL2jU9iuRCTUVVNuc5pNja6ZEf6zbzh7Tfsypu71dp8Mkey
2381	fee_transfer	1685	51000000	1	CkpYYZrQHdfTJDy4uv1tadfRyKRULsPwVt1wewweFNQeHyoMFRj9v
2382	fee_transfer	1677	23000000	1	CkpZspmKLBfmgtVMSYhtWYKtpgH3GSXH7ghdkbE8wKbvdv18w2FCm
2387	fee_transfer	1685	211000000	1	CkpZ8xGYfLnEiWKio9WUSoZ9jFT6XCwScTHsnQw6ThPcsYZdEkKTy
2389	fee_transfer	1698	850000000	1	CkpZtcbscXaWvQVXP1M8tBhL2r63HQ5Nbq5TS3M4v3w1umzQZw61Z
2390	fee_transfer	1698	280000000	1	CkpaHC5yhTDE5R6d13kwMjp6oYr4YBBXB1HuuxqLYtLCmfj1eN5ym
2400	fee_transfer	1444	60000000	1	CkpYbdryBVtX3BVu9etpq6gCHBTpc64RSHiF8yqHzKVQUgmLZyRgS
2411	fee_transfer	1706	1680000000	1	CkpZjK61RrB7xsADVfB9Bk8btUW8Nn7A62LjGrbD7xqWUQ72Ue9BN
2419	fee_transfer	1426	130000000	1	CkpaDEiRPyo77SN8xGAmLXg2FDUS1hvJGfev7zDqGS116ZsQpriPs
2420	fee_transfer	1727	150000000	1	CkpYVFK3LJgrF7TCwCY9UBGfbJX7nmMkyDbzb5fnMneGCaAY2Cav4
2425	fee_transfer	1698	1700000000	1	CkpYf95FuZEMJyj6kq823PPn3D5MSnpQo79H94oUbji7yuNR3EQTr
2429	fee_transfer	1429	20000000	1	CkpZAWwAqxxdH8c9EYeH8D6kvB9SjwnkhkPkHsbnzoWR5PmadRnjy
2452	fee_transfer	149	120000000	1	CkpYc5F1Dyydvtpd1MsrSUxT57Cg6T83hBjBfo79dw1fuugZ8gTth
2457	fee_transfer	1607	180000000	1	CkpZGwpKJNZoVJxqvtoxpGj1JkCncmejJXURKJY955mde5aFFY77e
2459	fee_transfer	1547	50000000	1	CkpaKW8XpMzLpvtTuabDwebTDdPHcTNE3XkZh9qsKtxznFe7HJBYS
2460	fee_transfer	633	440000000	1	CkpYzBZVxcjHfZsY7PwaewvBF9cuFtXNwgynYbj56EZ6kVsg2xAfL
2463	fee_transfer	1458	50000000	1	CkpYzL2Bma1sGRj6f38QsaFbcHXNPf3nLHBTr9mzAUzrtnEqZRKGL
2470	fee_transfer	1593	80000000	1	CkpaJ12KWXwJ5GbhguA2FEuzvG9D78dW3gcTgtJrLGdpmYW2Zohbu
2472	fee_transfer	633	60000000	1	CkpZXCE2tirki7ta8UxXgGzfyayXYewxD4v5pbDPcK6N6MhRRViBC
2475	fee_transfer	1458	31000000	1	CkpZufYEmncAv6zEscEHWGv6kC5PiwyYmrLk3NvtRfRAZNcmsnJcT
2478	fee_transfer	1560	39999999	1	CkpaGUunFgbzYnsAYGWj1kmVgV4yYVoqxingwSVWGHHNQRvdf2EJJ
2479	fee_transfer	2000	1	1	CkpYkBk8E1QkcW8TJrpzdFgU3iBYGg3sDvXZ3Tv1ohiBAXDDJQpy6
2481	fee_transfer	1679	121000000	1	CkpYb8qnAHJDtzC7V41vPhDyBsqC9EcGiiuWspAsZMApz8eHm91QC
2485	fee_transfer	1850	40000000	1	Ckpa5YEj69VSwMkakofDmhGkESGSzEQYBjS9aWvgdncfdKcer9f8q
2487	fee_transfer_via_coinbase	1604	100000	1	CkpZWGJEFBU3RfvRLpgff7JDfRMyh2okFeqTtUQkFH69RPMZkWhaT
2488	coinbase	633	720000000000	1	Ckpa5M8y7DPjVYLywjhCyTt3fx8rpmUngypXwmU14tmLXUeaDkea3
2493	fee_transfer	1690	81000000	1	CkpZr5eqYEZuUn78Nid3REQxZmw5dNinqjvUUwGPZ7JaVrqSHqPUo
2494	fee_transfer	1657	460000000	1	CkpZe7ZZXNJJmRYCcR42k93VhkfSkuSkHuT6RdmrvwV3sBm48ceuP
2498	fee_transfer	1700	11000000	1	CkpZ1B3LRQ7JaB5eZxkpvNRMq3bPjE8boo6gjV5tsbvNz8j7vnt5X
2501	fee_transfer	1633	40000000	1	CkpaCk9AKdcDimwbNNzZ9J964cB9PkMqXN2wZdznXFJvZHvcC9B4r
2517	fee_transfer	1696	110100000	1	CkpaAX8mkTVSDtdz36a7hG5WbkLqrYtsN6ztqrBw48iwNajjDXsRN
2520	fee_transfer	145	10000000	1	CkpZEZ6KMDsn3R17kXDQaizmdFGz2qSaajYGZbpN6tTHLjiayQS2q
2522	fee_transfer_via_coinbase	2021	700000000000	1	CkpYpzwQr3h9DzBcaLZGui5aLg1z8t2bMeb6marjNVqDqAcmmWTeY
2523	coinbase	1457	720000000000	1	CkpaJ4MGH1xnDNjV8HxbqdTsngGL122hZnZ1qytLYwAY7e2y1jyaf
2524	fee_transfer	1457	150000000	1	CkpZCkthDdqHp1c1g7uWmYiLACAcMkYDTakCmyxPjBU4aYyY1mStL
2529	fee_transfer	1683	90000000	1	CkpYcrJUVqYYK5PQHLoNVzvok4uc2oaYZBjh8L2tB9kw1FMPjLxzw
2530	fee_transfer	1693	190000000	1	CkpaJ7AVAZL6Too3x2bFKtKhf7voKJa6BEPuokgnJYfq9K3WXP15C
2531	fee_transfer	1650	21000000	1	CkpYj5EMi5X4tRM6SLXKU7vxpBz8bkecCp2xsLdtnSoVhZi7SMAU5
2534	fee_transfer	171	90000000	1	CkpYoxANYcWJ96nEuHFjz4ZrUcd7iUnSZQtQYeV7rVnrtwth6FsMt
2537	fee_transfer	1594	110000000	1	Ckpa8hZadCnvAai5gzUVf11gwp9mFWJGycK9bpAFCGxchr1HxwCW6
2544	coinbase	1556	720000000000	1	CkpZuMQVHXQeeJn61sdT7ywoZ6c1o8q7tcdqhUeVQ4DajYjYRp7CH
2545	fee_transfer	1556	40000000	1	CkpYbwV7fgQ6QbFNjgjFxVmNE7E85jk3CzwhV3FLVZ8bqyiF2MAzm
2548	fee_transfer	1451	22000000	1	CkpZjMru7PP9vtzoMZq6j5K2xNJZvqMnkip34NE6PdqJtVYPQEkqo
2556	fee_transfer	1587	70000000	1	CkpaFApYAPjvbwWShsd7wscyPFJDR3G52cbgX6gwhgzqJk3RpU8gJ
2557	fee_transfer	1688	90000000	1	CkpZHJRPkca12bJ98gRgtGkd1FRZzggqHVYYKMk5GsXwAzujaQ9hy
2568	fee_transfer	1683	22000000	1	CkpYcqapQdnBTM5vkHJHD9HTPNxSiu82FvDwHsMJD6o27MHeHPhin
2571	fee_transfer	1992	40000000	1	CkpZDLeY6zApWP92EAeQK2mcXLJWDwUfbPhm6rN3AJ21p21zNqmmB
2573	fee_transfer	1739	50000000	1	CkpYgTCrtzagkx5SuXX7wshpSKAG122WrpZ4F3Ku5uESTVHUEVMAx
2575	fee_transfer	1637	22000000	1	CkpZMk5eRXdgGveS5mDew3KRmwgidi9k8c3aMUEskPhfbxUnwCsro
2586	fee_transfer	1555	81000000	1	CkpZv2DUUSmrifg5BCJ41nryTXT7d7jdWGsD4WCQcK3HvByHLCd9u
2596	fee_transfer	1622	30000000	1	CkpYtXshmrjsNvn5UnhHtAgCQvKusmZqq7sovc2tacRQbN9UZ1RKt
2598	fee_transfer	1633	1160000000	1	Ckpa9yqtoGtmXPceougiB2G5vU3Acg5bAw161VL1KRegfJH8pMGzo
2599	fee_transfer	1633	130000000	1	CkpZqMoqJ24LzwJyXVudfU9y1NDuL6Y1UBnhPZMAJv2gB7ZEYHvoP
2603	fee_transfer	1633	1210000000	1	CkpYi51jhX9gJs4RVY6xLMxn94rJseHpdF8ZAGyDrtmxUfpxSLaKG
2604	fee_transfer	1593	350000000	1	CkpZRhDn7Y4XNo935cuqPbbVNuSqd4VUY9dMPqkUX9J7pJDBzN4aU
2605	fee_transfer	1593	1020000000	1	Ckpa4XiTB66Na5jqYoRS7VcYRQW1ff17W4EgSKK4m13q2wToKgtsp
2357	fee_transfer	1692	22000000	1	CkpZpNvr746Hsya7ktTnLeUMbFnYYdmLrBaux2VH1J2vjC4FGKF5x
2377	fee_transfer_via_coinbase	1515	5000000	1	Ckpa4A99ncx9JSyWFJdpxbnbPWhfmCv2Y5XzhBLbT4L9v6q1pH1Lz
2378	coinbase	1677	720000000000	1	CkpZKfYou85orEkq735GJDgUPxqySF8vVM3tWdKkpg9JyquhZ2maS
2379	fee_transfer	1555	50000000	1	CkpYeFJR324AHoKCyT1bYaUj4MRMoJFiNyjPq5xuhsh7b5ApTKdkc
2380	fee_transfer	1673	51000000	1	CkpZbfcY6EdaeuwskpJYBkg55rWhScQzejn2hePacvUU7Wzesx1p6
2384	fee_transfer	1679	260000000	1	CkpaDjkagZnfXynbXpUkdsLupJCtSwaaJJS8FTQ9StHsUzSfNAa6k
2392	fee_transfer	1696	340000000	1	CkpZKyrV1xibVYusmqiSma3fTDPFHXBzYDYduVfzNT2H2j9pN7xCx
2393	fee_transfer	1696	104000000	1	CkpYn89o4QHKxMq4VHY7vbAVM7TS84YguPb9Z4S3KHxPwFhfyHm4D
2407	coinbase	1660	720000000000	1	CkpYzjP4AFQknCn62mC4mfWcJ3AAKcT6S3HyVxnS1y1hUpVK5LhzV
2408	fee_transfer	1660	30000000	1	CkpZQtpfUYTM5MZfR35VwT1bAsN74xvT2CF69mwbGfrwbyw2fVb8Z
2418	fee_transfer	1426	120000000	1	Ckpa5XQkYwnhxgLVinj2f4tquU4ZLCo8CSrD6YuUVim1XDoxXicCc
2421	fee_transfer	58	310000000	1	CkpYRUUNTH1qDguebwyM2Rvpb5RA1Rdvk316ZPpusjkXAHFz2YpZm
2424	fee_transfer	1678	310000000	1	CkpYmiotHM8cpuWEzG2UFGvLJkS4wYPTaqfyNhY7LrgLiTwDrVcDg
2428	fee_transfer	510	20000000	1	CkpZTJ1gKUFLSnT35gvZjecG8KK4fWzog4i2n5tEC5n4C7h3NZomK
2432	coinbase	1435	720000000000	1	CkpZXJrBwExWgftmY8ewAz2NrxwWDFV4iQhohShx8D491VKEdpnon
2433	fee_transfer	1435	40000000	1	CkpZ8DkpbWs31xKf18uUaxdVNPukHXP5XAjq7xASb8JTKypLdKne9
2441	fee_transfer	1593	50000000	1	CkpYXmjZsNDfYGXsTif45X7xPEyKTjH1CLQyG2rs8Bzt3r3czeLV7
2444	fee_transfer	1699	60000000	1	CkpZLzAeNSg32aD6vpqMSWYQ8TyyZS72wTQsT4S6YADtF8tq332No
2448	fee_transfer	411	40000000	1	CkpZ94ZUF77ZRVdLjPYuyi9C37ht47Nzsd9e6bZw6xqv3VNKHqpEe
2449	fee_transfer	411	1800000000	1	CkpZcbrZgVNvzWUm1wFycsNt8PFtqLMHHpK38cCpL7i72PLbLUATe
2450	fee_transfer	411	1790000000	1	CkpYuoBvrqKB7yL67wBfpKdNXY3454dThM9xv7eZHJ2uRqj7DLuYT
2453	fee_transfer	1759	120000000	1	CkpZ4i436H9wAt8B9biPjontNQXZ8a1NqhdtSvdtYVXhCGfsMLYyX
2461	fee_transfer	1688	440000000	1	CkpZFjWGPhDtDPnHRHUc9L5nBF7yCxMS29Zoq2J4i8yomSLyJzJgE
2462	fee_transfer	1559	170000000	1	CkpZd5BCdajf7cqchHkNRKW6JFNGxqh21NKV5em26Jst2Amj4Kr3v
2466	fee_transfer	1423	25000000	1	CkpYeH8gz2bsBptAEY3NjFRvoxWtdjrFza15Noxtpn4Ksq2LE77Br
2467	fee_transfer	1702	12409879	1	CkpZ8AB1Q7sbTTB9u1HNUVjqyuQyQGSmsNBFYMVbZUdrPx4mvwqH6
2474	fee_transfer	1602	50000000	1	Ckpa5gVe5nEG8y38RAobwwtdi2zaDzdJphkVYhzKFgi6MsBpJPXkv
2476	fee_transfer	1699	41000000	1	CkpaD7R4d6p9nc7MdA9DJtbXTLfGwymXjq2Z1a2VJySDUrifsmQwG
2477	fee_transfer	1700	90000000	1	CkpaBNfjFv3iV2MzCnkbd6AyfyYyZd8XBsD7cFwfvrJhHipf7K6vf
2486	fee_transfer	1687	110000000	1	CkpYkKuJKKCeXGGQ3RR5cNWGY8yjwtZw1SiPMuNETgbm65wfRdzxN
2489	coinbase	301	720000000000	1	CkpZ4SofHtisjeD1VuqfBhdAkB5YtUuJMKeDokCs1PvvuXvvjsHpm
2490	fee_transfer	301	20000000	1	CkpZQNhtE6JqGiKp7Ak1MdqYkbQRgs8jMuG5WAg5tTvmdjzXJJ84C
2496	fee_transfer	1467	1940000000	1	CkpYxsHoM3SruQfxquT5KfumK2W7UbA2GFzPK8syCEt1Vc4M7wQGs
2497	fee_transfer	1467	1739999999	1	CkpZdYHDau3589q9ySowq8qfpM1HNELTxZzS2xEH3bWTZkJjEm83n
2509	fee_transfer	1419	150000000	1	CkpYkoDWCfXTecgySBMX4zVKAJkFyiXtVGWtoHNFYUvHrM83zfA96
2511	fee_transfer	1657	50000000	1	CkpZBxWd1DJC7E33NeowPfmE8QoCCjutJHxKnvUUZ6MPm5kW9YhPu
2512	fee_transfer	1602	190000000	1	CkpYfahziA2QFuguf7BE6PbzchsFp1gE3fMWTbtrRc7MHWnjhfT2g
2514	fee_transfer	1489	4340000000	1	CkpZgncgMfHHDGiY5W599qbDeRAYxANLwZB7FC8SEfNDGNyW4u9dW
2515	fee_transfer	1489	510000000	1	CkpZSjP66PEBhekZaAUMvFFwcAjNNVKQt4S6kpWxhfYmFBNkkFvHW
2518	fee_transfer	1696	110099998	1	CkpaDQeLgKizopGLphYTxzqPZpMb2Zn1Q2z8PLRfUxfjiWQc286Fi
2519	fee_transfer	1964	1	1	CkpaKj3hTProVFkshbNMSUPYhYDR1nZoaiFoxT95sQMcgv7XuikbM
2521	fee_transfer	1740	120000000	1	CkpZmFTCPF6Q3AMjwUcUhNCfBGnjDN7Fe2bdWotpFopNdQLpv9tpx
2525	coinbase	1719	720000000000	1	CkpYw1VZzKKj2jVnuWfzZbn69cUEyAqQdURtdU3uvEfgZpJBqM1xq
2526	fee_transfer	1719	140000000	1	CkpZajvacqbt8vsJprFFiZBfqB9se1LUXjzTUtzWWTyJ9KNpMRvBm
2532	fee_transfer	1654	101000000	1	CkpYeNxzwcAiqAWyAcb2U7H87ST8FFnfq4phZacNRSpGqBwRKPSgf
2536	fee_transfer	1611	220000000	1	CkpYrwRGnzPpA7ru4SXyfUkjxzZykRECYStXfYGunDtRKcC52KBS8
2540	fee_transfer	1690	90000000	1	Ckpa2piT19ijhucJSqkWzHzNKUKr4eCeNKCNysW188j96SdWvBwVW
2549	fee_transfer	1696	31000000	1	CkpYThjQ5BropjjWCZddrd7PGPDJwge35yhdsyqHBGsLJaWhgYEyf
2552	fee_transfer	1678	41000000	1	CkpZDaZcERD3Q7iu81qJzwTEESuXhGq8Pcz97Y16DXKTugvx5mmH1
2553	fee_transfer	1587	320000000	1	CkpYQuqqEMDRD7cHuZeCZ8KmuYAfkFQCqSzbbBEdNowG1w1NkzQbQ
2554	fee_transfer	1587	46000000	1	Ckpa7eatFQGkq6Zes2A3ve5M46fFHhpMLeWXLBmSfGxxXkYaN244s
2563	fee_transfer	1467	100000000	1	CkpZnhqkk4pR6kFE5FsaissukULZSDySDehHCs3EJF22zCa4ZdqGZ
2564	fee_transfer	1467	240000000	1	CkpZB2LpAdjkfLhuxpBuc8bWjarALB6FRxaE7bNQB8p45eMgJXKka
2566	fee_transfer_via_coinbase	1655	25000000	1	CkpZyPRJVsFgBBG12Ltg2FrSRyQVJkCwkRZvWMq8gjm39aveQimHi
2567	coinbase	1457	720000000000	1	CkpYdhaJ2scB7PKphw4Nfxporw77vQkGxNoFK5czeRqhnax6BjfAP
2569	fee_transfer	1654	202000000	1	CkpZ1uy5o7qxDVreF52XemmfNbzSR61AGvzAHfbkEvYJwJ7QkNvFy
2576	fee_transfer	1622	22000000	1	CkpZQT19Q63ytYjeeYhfiLLf5WjmTt6Fo4JKe8ikCVcA6oeCufVA6
2579	fee_transfer	1683	42000000	1	Ckpa5EJHV9XjK5M3LPfpYnqF1cyUPTnEcecvvLELGAHbWF9mPHpwV
2581	fee_transfer	1508	72000000	1	CkpZdLxSjBG52HiTNLMHn2mnBKn1PBVE5VbKxQLUpk6cRurty4fs3
2588	fee_transfer	1690	61000000	1	CkpYkZ9pMD3MKDU7chPZ5s1RY9pUHRLE5cQNizeyG6Mum32L17DC7
2601	fee_transfer	1672	140000000	1	CkpYwgE79qNqpk87WiAEbtZ4i4SGZm5mTWmj8Cz7hXWoWSBFdUAMp
2609	fee_transfer	1675	90000000	1	CkpZgWh7xbuUxwo8HBUF8KvJZ9YnwApvdQPyraE91c7XTFJGcvKuP
2614	fee_transfer	1623	131000000	1	CkpZhhwPdDaugBSQjioKs5o3VSHwxASv37CBJKDxQDZcoL8xr2Sam
2617	fee_transfer	1670	50000000	1	Ckpa1ouCynM2BdyEaF2oYSGkBqrRpVxKJ9iCbTAXo4sv9rCPiNVb8
2587	fee_transfer	1518	61000000	1	CkpZLsCFgMwgAUNt4pRXUjtdrQoA797GzE1dskekUks46RwuwmS1x
2589	fee_transfer	1593	240000000	1	CkpZ47SB39vbSpMFRdUq73tLRXuYGyDp51VNVXdNZeVsiqNUC6WNQ
2590	fee_transfer	1593	1019999998	1	CkpaEgrU3kH2Xub1AsuAea5cgFE32yFCC5MtkHDtG3PGUQj3Yyy18
2591	fee_transfer	1683	83000000	1	CkpYULHxWHr69XAiSq5VpUZfGRuZUrzRzPrfjkzGXZV8Fnp7TkH4k
2594	coinbase	2029	720000000000	1	CkpZB4z5pxAMfGLGDPo8fekBN8JohdCfEhFXqTdhfEA4uhdRwfc3S
2595	fee_transfer	2029	10000000	1	Ckpa6B2sgfEFMpq2vepBe1WC8NhS5kLAxhA4i1U5ovZieBwJ5tndR
2597	fee_transfer	1543	40000000	1	CkpZU1jSMz7MGMceWN8mrohphnAGp1H7oRXQQm1tJ6cMhSFGHLQ6T
2602	fee_transfer	1564	140000000	1	CkpZxE4WiYFuC9Ng2guZFZbfrUGWwRRM9STnkzWeh6T1HH9rKtQKj
2612	fee_transfer	1711	70000000	1	CkpZL6fvYmYjidCe5K7Tp6YugeTZdAdPdmdQNhTM1yUWc2UhTQguJ
2613	fee_transfer	1603	50000000	1	CkpYcBnVa1hr7ZE6QLn1ACzG8PkYBFRZ5kfCxRu3vgV2KMGv5Jo1X
2618	fee_transfer	1670	481000000	1	CkpZbmf7vUMDZ8BaSdNvAfnYoKcaQkCs4dN42rA3h5Eoxd6jaPaCh
2606	fee_transfer	1439	73000000	1	CkpYpCnmXDGayHawJuky9DHmgGBo5ygVK3UXbBTiDvUh3en1N5Vy4
2607	fee_transfer	1458	40000000	1	CkpZVXriYzGyYoo91fSLTkzXq2KFeknyDgYMfnsHwo5CHVToVJJhX
2608	fee_transfer	1850	60000000	1	CkpZeHa1jrmT7DmuPWsigeVo4k1RghnWm6EHLf4LZPZVXkENpat4Q
2611	fee_transfer	1402	160000000	1	CkpZHbbszJMeu6JfnDhHPJrHXrPkNkW9yyr78vVX3LG9DwN72KD2J
2615	coinbase	1575	720000000000	1	CkpYSZPAx2BXQgvPszjwLAe1tjk6QrRDpduE4XhS1uGRRBwQH1X9H
2616	fee_transfer	1575	40000000	1	CkpaKdVqeTWKe6rMMQwgqAaqHD7xEwBs1i8VSYhkmfhmahBe4ETKM
2619	fee_transfer	484	50000000	1	CkpaA3XrX4ibTBbxmRFZZDCYQDqBUgntUTWirf44BatjzE4yhj6Yw
2620	coinbase	439	720000000000	1	CkpYW5fETQLYbiDRpxoCaJ4EgECw3xpgyzkKYFu5LU1mme127wQ1n
2621	fee_transfer	439	60000000	1	CkpZVMbEaZzkYNGZUQSGxpz5bPDj7TiDm7QmkegqboXRJpXAQZmJD
2622	fee_transfer	439	50000000	1	CkpZvxpC1VK5DmnjVR18PEY1VCrEEhiCyL8DTsdtc5q4bvA6oLAKx
2623	fee_transfer	439	40000000	1	CkpZBQx87xYVV4bwCwGqmxYZBwG7PSRD25s9JWZTnPtnVR5vGe1av
2624	fee_transfer	1451	50000000	1	CkpZ3BtswVJfnmKE2MgjC4YUtovSzXiL4bGu6mGpqq2m6xTVNNgUR
2625	fee_transfer	1685	460000000	1	CkpZnaHrUhUsqBYgMCABJfCTpjFRcYharvNapVT4WX5KoxEsYBhbc
2626	fee_transfer	1980	70000000	1	CkpZbVkWi3iWe6BZPbvafUZDSx1gsvmPCQ4cK4an5AXDWHdPN6Cwq
2627	coinbase	1638	720000000000	1	CkpYcWTDh24cEhsnnYF2E5sCRVZTjd6KUWkhyLLbko5cLPcvV9Zda
2628	fee_transfer	1638	70000000	1	CkpYd8umoZCzppFNhySJgFTvfcxAAvLN1HpbAV6ifEuswUinzQ88h
2629	fee_transfer	1657	150000000	1	CkpZnKrRwtVtXhQoWbpQocWQLn4RovEvBmmcGhZFbG3etXbNjjfcr
2630	fee_transfer	1690	270000000	1	CkpYZ5J3SewL7kDfcAo6SgJgzArVWDJCCBxwZfM4udNqUZLWFeMoQ
2631	fee_transfer	149	380000000	1	CkpYyvzCnc1kj9PxEESruc7efG9kj7sarmDQSf3AKQ4H28TZowTXG
2632	fee_transfer	1546	120000000	1	CkpZngibySfoFYyXVqxHe4xeGHQNxT9tubG5CBL5gvFF9TnZKw9wS
2633	fee_transfer	1685	240000000	1	CkpYg4FgHZyC3wwz9Z3dDwDoXJ92e6qujj7jWng1PrqEQceLgu885
2634	fee_transfer	1685	850000000	1	CkpZNNVN9VJ3Jsidgf1inMftSrSDHsxYp7Q1Axp9Mowrc1WSog7ea
2635	fee_transfer	1513	80000000	1	CkpYwDVYQXVtpfctbTCdMDcVsNVEC2dYnm26DzYyQ75nNbnd9bfB8
2636	coinbase	1991	720000000000	1	CkpZRfdkiQP8Xru9MD5cJwnc9BnFfZeLz4CkWxLNcWeeNEK6pT898
2637	fee_transfer	1991	20000000	1	CkpZBsLaCusha15DknfjPYUjCgMDdvyhcGwvh7JKbCzE8JdKk6eU7
2638	fee_transfer	1559	19999999	1	CkpZZbsq2hXLUe21DQmcP4rZ5yNuie3pAbjNFWj9D2afaJpYRZrwg
2639	fee_transfer	1759	999999	1	CkpZSXB1HGASKcLHmbo1iVqvoULbptaghc55UtL2U4AdZiU2oSVsQ
2640	fee_transfer	2014	1	1	CkpaE4NZmqC96rx6TGqJHuAfuQtkA7KrHr7ZgsjpAM7foyxBCJ5yJ
2641	fee_transfer	1509	70000000	1	CkpYbxWiZC83H6s2W8kD1jeGNHTxuLUB9Kbv8HTydiQQmUknjCqGB
2642	fee_transfer	606	71000000	1	CkpYdqaL6sKKjG2NEs6bxM9szcJbzXaUTP2kGHzz1uhUs2Q8BaTFJ
2643	fee_transfer	1702	19000000	1	CkpYrUaKnUQCLTWrBvHyfNyX3CNbE7MH21yzoLG7NBp9E7VPRFTmv
2644	fee_transfer	1759	12000000	1	CkpZYERWqumFJG4ojgycAJt88tTz83y9TiCBGEYXJXbcGe8nMCRHf
2645	fee_transfer	1509	8000000	1	CkpZBNZDG8SdRTaALtTJfgz7Fc1jsL3kjTuyfE5XtF7jLd6fbGv8b
2646	fee_transfer	1571	190000000	1	CkpZVKpQMmVDbmbmUi4TdDUtJRcmpGAE2fUUZXt1kof231YmiXive
2647	coinbase	2041	720000000000	1	CkpZdYC9mMjMA62m14TxYdKyZTTE4tPwAa2ZetKo8pUwfN5BPM2jJ
2648	fee_transfer	2041	340000000	1	CkpZ1jWHjFh9cYXRQVgxjWXGpg2q4NwbgeSWfmEmuNmkk76KFnToR
2649	fee_transfer	632	340000000	1	CkpYkhfTD6duNBVEijykWJpHtGUzc2Hi8xVy3Kc8hxSYa6mQayKbN
2650	fee_transfer	1705	31000000	1	Ckpa7hd7Heyx9TzfMoUh7HKo2G1z1sfXeefNsyistX4RiXPjkmcRP
2651	fee_transfer	1685	782000000	1	CkpZkGf976bkimxu6xJYtbBcwKhzokffPVemqRccJJ1K8pZZWFhq7
2652	fee_transfer	1687	120000000	1	CkpZSToQvyoMgFNWwACe5GennBFghuseTZ7PAaGswSCMP2DhAXeiX
2653	fee_transfer	1693	650000000	1	Ckpa82mds3MWwzXv4my2hYDXG8buJ92UYmk3NaYWZA4T7M9ZZU2xV
2654	fee_transfer	1679	650000000	1	CkpZysis9A5rw1jhYJJSYmXDEWRxby1bbTQBgAyXQtZA8ur3GUDBP
2655	fee_transfer	1714	650000000	1	CkpYjoSGm7io1eboDkDRNkh2hoHXLzkyj99PVYKSjRHrUBhMYmkvZ
2656	fee_transfer	1688	320000000	1	CkpYjp4F6TSBUd7YyxZtjwNovVmzdYQNCd11R3tmoHRPJ6zJ8KbyL
2657	fee_transfer	1673	21000000	1	CkpZpeWm2j7s1UL7m5crVyDD3jkARM87ES3XiR9o8uNHdKNrLn2hp
2658	fee_transfer	1705	21000000	1	CkpZCxCaQ5otKRPzAKYvoHgKPjjM6Mdee7bpkRX8zfof9BLpU9zL4
2659	fee_transfer	1992	990000	1	CkpZAN1DPTp1KZdMyUz7KJretCzK3xws9vRohou4Ec2ZmU6va2QjY
2660	fee_transfer	1449	10000	1	CkpZs8P2RENWKuW1DdysDzh97PzwBuKQS8XvjEgXmnsXRTsKENDmQ
2661	fee_transfer	1509	39000000	1	CkpZwfXAy8gXjXiKzt13X1fhEfyJvpHtCMfyMCYMbAvxWM387EKvp
2662	fee_transfer_via_coinbase	1567	713000000000	1	CkpYRdeujztMvqdKcukN4NFyPn8SnZ4YcyUeVNNQdrFcFd6nCPdgA
2663	coinbase	1762	720000000000	1	CkpZzWCxyidr16jcJtWf7HfTUJzY8hB7unHWCH1t76toFn9VgasGz
2664	fee_transfer	1762	994000	1	CkpZMcaNxui6w4eqPJkfb8Z7mnu6gEkCYZFdPgKwhJFnL9kdgBrvN
2665	fee_transfer	1449	6000	1	CkpaDDo1HWZzzMm5Fk8zJ2a8YNxo9JdT4mjLQfzgd9K4qmoh9qCdy
2666	fee_transfer	58	150000000	1	CkpZaWFYNN6w7mkk6UEFFMwvAJR3HhzMPEFoeZkEexGQCeZgPzdPG
2667	fee_transfer	1458	150000000	1	CkpZjmQFJZjkqcpCR3riAHU988fqnEEg2XGNMFPk4B5GAxMGRDab9
2668	fee_transfer	1536	420000000	1	CkpZVXpPuSGR4mVEFNKoJa39jxKi79eSHYvQyyJZcXNxCPJ4VS8Zf
2669	fee_transfer	1683	580000000	1	CkpZTdVRSEvxWwkxEtBkYirEqCgi85Yxms1qb31tgkMjxaQnPexsU
2670	fee_transfer	1711	100000000	1	CkpYVemc1eZdCK4bAhtyCAntc4sWAB7o8ugJyHUG4UCNPrk7dPGVf
2671	fee_transfer	1506	100000000	1	CkpZR2b1E51G4MYryFFpYBkKSKQwmK7Rekk1QSF8V5nNVnbWH2zST
2672	fee_transfer	1723	100000000	1	CkpaL6Aax4qxeN1qUazxs5QXDwJRBc1eUNcbokuBiwYtE8s1fpxyg
2673	fee_transfer	1685	1630000000	1	Ckpa19fy2aRjaPCK24fKT7m28quZ46iTmfVB4L6QMnJPerXiQc86S
2674	fee_transfer	1485	1000	1	CkpZeYrwAHDTNfvSQaSb5cBvpxXHdwGfN7qW4i8crbp8RN3i4dXNv
2675	fee_transfer	1685	759999000	1	CkpYQPB3aUGBm9RRhoPzuGwUAZJKSjuA7CPqD4pTnGgPePLbGSvsP
2676	fee_transfer	1447	420000000	1	CkpYX1dcJdbudzxrHGmeo8Q2frcUpvCA5pS86TMbdZ2Ecc5WDiRT8
2677	fee_transfer	1449	1000	1	CkpYypPNFQGdbFzAt125brijCKACZCEhzGoeFy1zJhDpWgJeRMYku
2678	fee_transfer	576	39999000	1	CkpZFpi6FRfk9XMcztYThZXRwUvkWsZzzhcBAkpRBBwExUupHk5uU
2679	fee_transfer	1687	60000000	1	CkpZb9owY4D53hZUhcHLnGkaQQonC6Lo6TBfyYXAKbWH7k3PC913E
2680	fee_transfer	1402	60000000	1	CkpZi7DVzjD5LhVS8r78Lt6er1qUUULNHmRAuicGScruMSTeqTCws
2681	fee_transfer	1695	1210000000	1	CkpYnkCF9mh7Mw7FqozrD6whMrb7xbg6wFAJ5K66YySz5TdcyGD7z
2682	fee_transfer	1695	780000000	1	CkpaK69AWpDuhCvxEr2P8ccFr1bNpLAqdUJe3uBSvm5RENKyVamek
2683	fee_transfer	1455	30000000	1	Ckpa6XqXHxj9zUK9ce9PaJ89CSWdC59C6NSk7v2BMs3kiVQf9YNqK
2685	fee_transfer	1602	90000000	1	CkpaL6s2CjXuCxtycgGr7pscLnrChqkrWdga7vHtepGmte1fZWa3v
2689	fee_transfer	1684	50000000	1	CkpYycsaDUGLygyUaLPiDsbTRcvYRWDUHQzDr5giqXKLYtBpmNmTq
2692	fee_transfer	1740	40000000	1	CkpZSQ1Nk16s4MfDBZPgoWVHTLo9hma48Wjinj3DZXdy1FcHsB3JM
2695	fee_transfer	1426	60000000	1	CkpYUbKLm2RTfuGRsV5EfCAQMD1L7J7Q2Av11aXUygHyRGCC9kzEh
2698	fee_transfer	1629	20000000	1	CkpZ1C7FbsoCyuBb2oLqhsivWtK7HJg4u7xYtsRjXdkUiJxgk1AiN
2706	fee_transfer	1704	141000000	1	CkpaKc5GVqWT2v7Umb4rKpgACcTBDzcAoVe1o1V4SZfYmc4K38uFb
2711	fee_transfer	1719	100000000	1	CkpZAhdxFww9dCAjmKj6EEqXZDypVuQDrYdXQBeD2HFfrwMV9tCDJ
2715	fee_transfer	2009	23000000	1	CkpYqcKwUwvToay8W3hXGdayaBVpqansMmS4z7sgNcSsrviR7boiw
2720	fee_transfer	1684	33000000	1	CkpYjstAhqLBVG7b53z6FvWKQxrdmRKLKmCQbKEmfwqZ8Ht9cosB3
2722	fee_transfer	1702	11000000	1	CkpZnKDUUcBrnaPye1MA8zMhxKSeFXviBahnT5nZP4h3dyJgr8pb5
2727	fee_transfer	1690	41000000	1	CkpaKnk3cFs3pQgqNCdUhMxcpZjy1gZHvxpHZdYJTZMyLjyqec73a
2729	fee_transfer	1402	61000000	1	CkpYcMTJVvFgFLHwvnGtbzwWN9k6PT1VsDctxHYNreXkx8Gn37GCi
2732	fee_transfer	1683	213000000	1	CkpYsNBcvWjXK5PCgghoYzqa6UgBaGQrhcVGMxGWHDM1WcqePzKu4
2736	fee_transfer	470	92000000	1	CkpZLEmy2cNrMw7mVH8n2KbaciGQZXk9XrdNXLUwrEJBxqakofsVU
2738	fee_transfer	1596	61000000	1	CkpZdNnaXPkV27D12UgAq8m2ijC7An7mc6MDUQPi25ZAhguS4GvUP
2740	fee_transfer	1402	71000000	1	CkpaHBggBPBNwN4ac7ueMzodX8qD4cDUTcQGvMPwUUuEe8v9Gj52h
2744	fee_transfer	1695	559999000	1	CkpaBjVx2bEdNSV9rjm5CzcDA6N7byKj2AEwgXUuho9Zx6huYxFbm
2745	fee_transfer	1695	360000000	1	CkpZRtpx7sCyDmLd8WLMoBg48RnvPAcdZSQz47DNRsa829vYJCBuo
2751	fee_transfer	1680	11000000	1	CkpYyvs1FBSietxU8z1R1i9rL3cxHLdp3kDpbhXw3MExaLjdQogzN
2756	fee_transfer	1419	11000000	1	CkpZEvXuYrjLQg3GZm73aBHRd5vkWEaHZhicnK2BJBjnYj16unbtz
2762	fee_transfer	1474	21000000	1	CkpZXPwkRu8T8ZCDAwpPDPLDHCiWQ3s6gyjChSL5iA39JMSNT94m4
2763	fee_transfer	1458	11000000	1	CkpZGvwpshMuB2EwQYC5QXAvSAedENLbAGcDoTmCGDFVAP7hPTKxU
2765	fee_transfer	1439	11000000	1	Ckpa3B3AjB9wuyarUC6G1mwxZX5acxChhrGpUhBprU4D14u5Dsdpn
2770	fee_transfer	1683	23000000	1	CkpYubppx7XCKqe4JgAihtgee6igUr6ZT1X6KEjJc3SER3iLRUCqn
2774	fee_transfer	1762	22000000	1	CkpZXdE2EHQWAzgGqX7UC2u1jucHeDESbDZ9NPrZ6bD4wRw3yP4Y3
2776	fee_transfer	1691	22000000	1	CkpZraiT3VtjFXZmgX6rp3ZVgBtoaPpiZQ8TpaENfU1gALV4pN3Ai
2779	fee_transfer	1703	33000000	1	CkpaEq538rRWmX4h4PHRDyqcjkCCEPKYAqd4QRtGXjvwSsxFP8MwC
2782	coinbase	2039	720000000000	1	CkpZF9abgQUCCA7eQUhJxfmuQKBd415abFRmMC9a22uEydEsvttS2
2783	fee_transfer	2039	22000000	1	CkpZcKd6oeYw5CM6ozsVshmMousSsb5YVTZZX6N7TW8a4ir9tC82S
2786	fee_transfer	1426	11000000	1	CkpZrZRbBSoHq29BGDYQhvrGzmCYtwQ62eBxmqKm45rNLZ1x9Tkvu
2798	fee_transfer	1850	22000000	1	CkpaFPUrTWGqkvMi85jLAHB5XHV39FSkJBXyjegTnYRGQ5RQzADMi
2799	fee_transfer	1694	11000000	1	CkpZERT9dA2jNKP32ifkCpaPDfbB4uknXqetnCBF8MtDW8YuHsiF6
2802	fee_transfer	1472	11000000	1	CkpZNE8oz189BEMSucoJsWthkJ291gLV4zz6bcBe5RyAi3eDreLnV
2806	fee_transfer	1608	22000000	1	CkpYn2uvU2pEaSz5TxQcRCsmg9DYh9nPEnSeHM9HRUJEak5CwaFD4
2815	coinbase	2049	720000000000	1	CkpZDP2u8CLCCoKcr85YKqaWccgXD1tjk1mog96dD9GLutc6wX32x
2816	fee_transfer	2049	22000000	1	CkpYY5tBMJQ8uXksEzvWZBtNfyuauFhSaKQDfthxuEEDFfaKTXNeq
2820	fee_transfer	1656	32000000	1	CkpZPkUkwBGfpGzR4meDsZHiFz3fGyfqx3dDjb5n8dQ26XNH94tXG
2833	fee_transfer	1768	650000000	1	CkpYrkNScSfdMUnyiKquqRt3btR4BYSQJiCnckUUTG2Gw36r2Yb2q
2834	fee_transfer_via_coinbase	1994	250000000	1	CkpYcreWZuJY64hxXzXEu9Fk7JGfjH89EwkNjkZhQfcgo9u2dq5H5
2835	coinbase	1768	720000000000	1	CkpZkBcAkk5ivxgyhUEUaoLXGnJU9wqVbA2cn9yDkQxYPqkyECPkH
2843	fee_transfer	1705	22000000	1	CkpZtGtXzZdMdFLw3msQUnNrFqhhLVQM6kGN9L1cuxuZEFRcUrJb7
2851	fee_transfer	1509	23000000	1	CkpZRy6nnoPUge5NeGsmtJfAgFeNqDbdjqYD8zPji4ZVwUXMpFeqv
2853	fee_transfer	1447	11000000	1	CkpZQ1HeWBbVDHYuNSX2ah5CY8GDzQLTzfPaWW6L74KsL1XfEJmKD
2858	fee_transfer	1679	25000000	1	CkpYemqDiU5NVJ5TmkopftLFA8kYHraBe6nc6rg4kLL37YqL8UGiW
2860	fee_transfer	1699	12000000	1	CkpYsG52gAprQX3v5jxuB1t6nKa29j1zJP6z2CPB691XygfkMu3zL
2865	fee_transfer	2039	23000000	1	CkpZdp6LvMeRfUhCRqHEMUqu5rnR1jv7RyD15PcME2pJdjdvEhuXR
2867	fee_transfer	1654	44000000	1	CkpZLM8p2QnPEgDT2KTXDFjMA29czkDVDQkM24rbNH3Ea8AWheVZE
2873	fee_transfer	1729	11000000	1	CkpYtv8hvSgtPLqnTxQp9Eah6tui8nrD63fFAV11acyeATuSDDg9M
2880	fee_transfer	1711	43000000	1	CkpZKTptPqtKBZrMRwW8Q4QVy5HmpiSkXdtG2akH5b9MU3Rn5h55w
2890	fee_transfer	1622	2000000	1	CkpZcHxiXU69z6769zgnyHtnyyywaHzBTKfYSvMCRPHyM8HhyrQ9j
2899	fee_transfer	1649	1000000	1	CkpZUEokAAXxGTXLyHy4VNKCX7AMW9FFZTXuVPXwyG9eURX6d3gYL
2901	fee_transfer	1476	2000000	1	CkpZLDYu4XMSFfKS3grYSQLPftN5kHqpHiGWJXXUdsSz52p4raLCC
2906	fee_transfer	1476	1000000	1	CkpZS3kujGodbYvL2kYXN1UqNVgLdgv4zEWnu861FeaYtXn2deN7i
2907	fee_transfer	1762	1000000	1	CkpZqKX5qf8E91XdSjB6mg1J89bsXiq3PK6CSSHDa9QHo3kHHFPVC
2909	fee_transfer	1426	2000000	1	CkpZo9Qf6HZSDdi2i4NbDt4NcZZqSC52rbKjgtRkep8rEJeJiJvmA
2914	fee_transfer	1690	2000000	1	CkpZJbaXaCgYUPpGNTr4NYMmrA5YZm7R9ktSJtM1fYd9YvoS7JymK
2918	fee_transfer	1695	2000000	1	CkpZLTPeCDLeyCtYpUmdq9Rw7Fet6uBjvT6D7hgwo6jnttJZqSKzN
2927	fee_transfer	1419	2000000	1	CkpZPcTgdfvPhB2WgrdkDaEEMFL98pB6qCqFxgZ13rLy35anuzaPk
2929	fee_transfer	632	1000000	1	CkpZGXRVPmjFTU5whhVVATB6xNEj8z1qVybDpcLAzCHVSSV7jqbAB
2684	fee_transfer	1657	100000000	1	CkpZgCxUudqdA7bCadRfHkCHABERbYA2KMyNrxcCj2PKUQ2hmKiJM
2691	fee_transfer	1588	50000000	1	CkpaJPCMvBs5GGjZ2URVKAxkuD856jZ2dpPjjDFN3hL5uXxKCSiSC
2693	fee_transfer	55	780000000	1	CkpZpR1xg6Jz1oUL5o3iALa31boJKSm52fFLD51jqxaHNoFgFK2Nj
2708	fee_transfer	1701	141000000	1	Ckpa3apqYY49sBPdcQHJxvBvfEp18zdSxyuJcA79c9eMLnMKsmaUt
2709	fee_transfer	632	40000000	1	CkpYVX3aanpUdiRCmxVbc43LBn6Lat3SkGqCDh4ksjBNbTrD7k3Lt
2712	fee_transfer	497	20000000	1	CkpaGWMegRBSKvGs8gc4cdWFU1vwN9n692YJHyypKbSRRkF1yLDUg
2718	fee_transfer	1683	33000000	1	CkpZGEb3H3p47bPZCMLBBfXwV63FZpavrdDnHRpYJegXGqquc1uwY
2721	fee_transfer	1703	11000000	1	CkpYqFFewD6VDKxWk3dnC1fnSYfDrTwYrWog9awat95XLJEaoZ1jD
2726	fee_transfer	1447	41000000	1	CkpZWU5UDJBNaJByu7cJ3wiqgUUVqxPJSpFyu1v5DLXJkvawF8ac8
2730	fee_transfer	1688	71000000	1	CkpYgyb3nChiuF8pv5baxy2jkUGz9DaM4HhB6d6poWkSr88N3r5mT
2733	fee_transfer	1564	213000000	1	CkpZ7fHddkvdLJ4ickTL8nVv7Ueu9fQSyhJFzWrK9sw6nZyK1cX1t
2739	fee_transfer	1693	71000000	1	CkpZbtjk97b5zrup5XW4g67JnC8aQHk6fwdgn5JDLvtapSwE1anQL
2742	fee_transfer	1677	62000000	1	Ckpa7DwS9QqaFiLgFDN47ah6xaFnP2A4aQxcDskHgMMDbD9SXeBM9
2743	fee_transfer	606	11000000	1	CkpZsr3DYRXxVnqFbNyUPLbGQfKeLzCSjsxefzgQ7aJmwL27tmAwu
2750	fee_transfer	1681	21000000	1	CkpZedsB1aUuX7o8PhSunsGrsVWd4jGCQBHUVhUwiDoB9X1JNAdyq
2755	fee_transfer	58	11000000	1	CkpaFfBC5HnDS799uSHpndTpTFtQD2LRmWeP2iMn2fWvypwXgwq3B
2757	fee_transfer	1471	11000000	1	CkpZb5wPshRjKPRQFj6kG18otbxPUpEy7NHtyBACspiDq8ZoH4qUT
2759	fee_transfer	1536	22000000	1	CkpZisZkK5AjWnP5kLWcAw33nBVF2odnoGmc6v6r45RDVzpjHRHvt
2760	fee_transfer	1451	11000000	1	CkpZcc16HYGNq5ceyLXykEmCrXJNMAWihx5svFf1WRMWxAmgYUnDQ
2769	fee_transfer	633	21000000	1	CkpYUH9hPReQ4nfG4ietrsvQw1JFA4WL5BW1yoogujqzeVRbJ6DF8
2773	fee_transfer	1611	11000000	1	CkpYZ8ToQdweBB6oaFrusK7kMCuA3wcdsXhEz3MQNsZhGA15Jkjyg
2780	fee_transfer	1594	11000000	1	CkpZz8eo4Ls4fsrX3czjwSZMfB5yzNYFvCGiRMdyb9iSpK17MQxAA
2787	fee_transfer	1694	55000000	1	CkpZmwTVkePy1xgrdAUZSshmEiemxSKdd92AxhQBKW21hd27B6xNv
2790	fee_transfer	1723	22000000	1	CkpZaYennLhKqiDnJxHWR4KKF8p4euE64ezm61fateMLz72xX4JMj
2792	fee_transfer	1599	33000000	1	CkpZAiAC5JvPxqeoFEJWA13JGxffuk56aVTznEx7ZPsABXJJc5rpW
2796	fee_transfer	1688	22000000	1	CkpZnJ6BWp593EgHxtcGVyG7JZbouZL49oDFVf8W2N3jmFFvDp6k9
2797	fee_transfer	1489	11000000	1	CkpaAm9WFk5DR1Ea9utRYfht9nge7RpPQPZNQmGb2RSAYrYPxovUC
2800	fee_transfer	1716	11000000	1	CkpZvCnQZGcshnYY9WN8hivvpDRnv9yampiK44aoKReZ9qWQB9MHG
2801	fee_transfer	2029	11000000	1	CkpZbAcJXoY7yKwBAgeAWVCWrajiCx34h4F2ubNUfu5doAJvhvjXW
2803	fee_transfer	1649	12000000	1	CkpYZDTXBt6TgVYxcVsu1TUB8eLARqCYLJDvkDTpiVokCWz6RcDQm
2809	fee_transfer	1749	11000000	1	CkpZRpAuFXP9C2mXDEharZEWSDenG9TkWY5jZZWnQQeGYq1Qhqz9r
2812	fee_transfer	43	21000000	1	CkpaF9G2V9pSYRTSTSmk8nLoYbJcrKVJa6k8SpTFk2dzsHJvsjjKc
2814	fee_transfer	1677	22000000	1	CkpYpuoQPYtrELRgUcpQszugF1kyGQmGCxEL83jDf6iEP88Z7Erkx
2817	fee_transfer	1699	180000000	1	CkpZ584oGHs2dGSv9Tq6DVdp6C9mBE1MEYE62iWVNv5aYtbBpb5Gv
2818	fee_transfer	1699	889010000	1	CkpZUsh6wFMpShi35b9KkVJUcLDKZgYn61rMW73AGU2mCGTGtS6n4
2819	fee_transfer	369	32000000	1	Ckpa35pc8XbfaAwMsPQBpjJutN7VTu83TT4F8QEWivZd6mxMdmLr3
2821	fee_transfer	1634	22000000	1	CkpaCREjMd9uRgpKzZRHymkVcPcngjxu4nda8Hna29noUUSKcybem
2825	fee_transfer	1657	678000000	1	CkpZ5JjYV6VyVHb4oeJHhxaHymBW8ZHWGFyNCZcwCZbg6QreUdH64
2826	fee_transfer	1657	41000000	1	CkpYYAiR8fVZP1PNzSahJg2JDDCvkX4bnt93gJxU3pTsYoGwTeWNv
2831	fee_transfer	1435	21000000	1	CkpYiUHpCgnP3XnPNT1V9QvuULqvuecRNJoy9bVrqU2JWzQtaGBRs
2838	fee_transfer	1675	12000000	1	CkpZZ4tb7c3gWyJg1qiYDXvubCibASL9K7ee2rE2Ta8PeVb2VwoVu
2841	fee_transfer	1402	65000000	1	CkpZdFcJgX6AgN4UagFT2z44VD7vkwu52a4mEvS2Pz2wkhySRmCum
2845	fee_transfer	1992	12000000	1	CkpZUe421exLkzpzJ12HhmVkcD3uTJSZraPGzA3hz6aHvoRbQZCwY
2848	fee_transfer	1723	21000000	1	CkpZ7vmVpuKXmwxiUQjMYKBUKfuUXNNkLBPb12PodGvbreJK9f4ro
2849	fee_transfer	1723	22999999	1	CkpZvQj49jfAX4ARBNcwnnEs6wduGKgWysLLMZ7oNMLrQ4gZp6dtM
2850	fee_transfer	2048	1	1	CkpZrfa7Jkg2wKVHD7jDgjbRT7dFRzpC5wVcvNGC2NJobKszbkHux
2852	fee_transfer	1681	23000000	1	CkpYkBHhmUu35vhVJeWN9rJ7pk4XX3oUBhM4ahpbz32wFAzorLDrN
2875	fee_transfer	1749	31000000	1	CkpYTx9K19TLy8b1avUAowuoqq3hQTRa9q9MJRxjCXAs1FRPWgThr
2882	fee_transfer	1518	43000000	1	Ckpa2apRUbWs86eXBoMLoLj8uAc9TigyodCPivGyRZ1U8fozvch2f
2884	fee_transfer	1727	11000000	1	CkpYQtqzRUSUyzV2b9NCWv9CH5PPQQ14FUjCBmipEvWgMM27ws1Aa
2886	fee_transfer	1670	1000000	1	CkpYSR3GvUbAuE9ryBGB8MXCtLutYwD4JcpjXLACAivMWyoW3njmJ
2887	fee_transfer	1683	2000000	1	CkpZwKHNhbodgkbTimS44Qi8r2Dx5ZjLXDrhho5gWVs9U83FsMisH
2894	fee_transfer	1518	1000000	1	CkpZwUxDAQzZBjE3MDqxcT6Duv7kugRzZujjm6qDyYWHWSjy3RtKQ
2895	fee_transfer	1695	1000000	1	CkpZu8MN62angNqzZx6Wpbg64oAoc7b1hgGhoVLVpr2J5b2tLokeJ
2898	fee_transfer	1708	1000000	1	CkpZc62WyMhq57RZmAUWLRrxN6UnYBCUA6Uhf1S7EH9LE3r5NyHRT
2902	fee_transfer	1701	2000000	1	CkpZQj31XeHwc35fikTYNhc3yknzDP99ra8sbxCSDEk2Q2bNVAzLW
2903	fee_transfer	43	1000000	1	CkpZLZSG1AZrmHU3tSDGEMb2q7myDuntPwv2rhikqxaFroWrC2n1b
2910	fee_transfer	1599	2000000	1	CkpZKntsaoNk7YdB57Zi4rouvhZsccfavXYgH6BvuCxpJG6caxJ6B
2923	fee_transfer	1555	2000000	1	CkpYUFQ6iGfahDpLdF2jvJjsLjdxhFsJFFWmw4BiZ4LcVPTENYV8s
2686	fee_transfer	1657	90000000	1	CkpYdmdKjLsCSXW6wCPG7GujudwFgVYoFAR2n4bYhUAmQDZNzBdpW
2690	fee_transfer	1692	50000000	1	CkpZoR7bbE3CDFTRHHzDaNKkc3F7c5vpsZLLLbhdkxbdF2rHUPQxu
2696	fee_transfer	1980	20000000	1	Ckpa1wCYq5992NY5Z2mm1mNrVZp3A8FB2SF6jonH3t6LPSh8tjdEc
2697	fee_transfer	1455	60000000	1	CkpYwX7ZZzCK2MNyYWiTE6B3tLtsfoZahSWpAwyCEzCaazsKzYR4m
2703	fee_transfer	1547	30000000	1	CkpaJ2pJ3kHcbNnnVAyZCSvWLVWftNPfBbhpWHGyBo2zwBZ21C39P
2705	fee_transfer	1747	141000000	1	CkpYziAwtoVj3GpwBTgiu1YyoBCDWEhKmouYP8JLsrTRMQeor9Eqx
2714	fee_transfer	1688	23000000	1	CkpZDWiwWNXyD6kVo7N8Co8cTwaHGgVu23e531m6SBzY6Uxu5sYAQ
2716	fee_transfer	1429	23000000	1	CkpZ8CTYYWvpAZFHrjXDrbBJeGSuv4Kvg437xwLP82fbned8brHV8
2719	fee_transfer	1513	33000000	1	CkpZZyobi8d8EvcqDLvc73CajA7eSeaHNXm9xr2RFy2ceVyG6Fr4L
2723	fee_transfer	1677	33000000	1	CkpYwsFvCSaNFNPFxS64aPjCJYyU5cKPrUAURSBSosrE5Z4ES4YmL
2724	fee_transfer	1727	22000000	1	CkpYZekp275p9ervJR9BfyAF3rE7CsVtDEUTzdVXrfs2UbHkJxXYf
2731	fee_transfer	1677	71000000	1	CkpZJWsTqncMDN6qiRQuFwv1Qw8iEJmm569j5vaMzso5qDUc9uoFb
2735	fee_transfer	470	82000000	1	CkpZkqrqgzh3QoedA6cseYGAkZqkd9TyTr48PxwzGiLo1QnWvzJJU
2746	fee_transfer	1420	396000	1	Ckpa73PSocWaAxoPRTxAiNqF9ZqcySpSDCVUpSWuPCY14driRFhEa
2747	fee_transfer	1604	700000	1	CkpYhacjLam8iokwAaDsQ7DPW4XGtccQ1hrmbE34MFfVA4a9wbAAn
2748	fee_transfer	1560	19903987	1	CkpaHggyaik6s2MdbpAGKb9GycQtcWw3vSjYigFtbHYGWTabag1GE
2749	fee_transfer	2000	13	1	CkpYp4jNrxZCRtMzt58b5epdtXhuKFWgCgpTuCqGobFXeeWR9wz3T
2754	fee_transfer	1992	11000000	1	CkpZaS4uN3UreXf6HJBpYMDk9yDwjrrKdoAmXDQK39w3QXnFRetze
2766	fee_transfer	1587	11000000	1	CkpZegQHumZgHaHr1rrayrBhcZowUfnkXT1p55bBoogufx9mhP3dd
2767	fee_transfer	1670	11000000	1	Ckpa3ukGtGppJ5sxBM7xeDbY9zSFiBWYBjiRhM3sh5xknUS1HZaHV
2772	fee_transfer	1678	11000000	1	CkpZHZWZcefJMmAiiRgZ9DbUm9q776a2M4PPAFPYHHDMp6eYmBfQU
2778	fee_transfer	1702	33000000	1	CkpYtZjJfJxFHEabsQfVoiwKBD7KPC4Yx8gBHJL97ibAJ1CxrXMyM
2781	fee_transfer	1447	22000000	1	CkpZWayA1VfSt9u8VJLG2UN7kDdXbkGafY7EgU1WNzauGecnpHfNa
2784	fee_transfer	2039	11000000	1	CkpYzCH5rGetiqbaMtBGVdJDXvERe9wBB1PqzcsJbMmijCFWrBLh7
2791	fee_transfer	1564	11000000	1	CkpZPMYPAchb9eUdyS1PjW5KLY23q6W4JKPBdYugQAviGMbXAFh6k
2795	fee_transfer	1690	11000000	1	CkpZCwZpxUUTKnuWnU8FWHZckYtouAwN8gphw91eR3fJqy2ruqaQz
2804	fee_transfer	43	11000000	1	CkpZ1xd2MW7VZH4G7bt4TPXCisE6uUry6hAdaQgydVGD2PpfP8Ykq
2807	fee_transfer	1729	22000000	1	Ckpa4G9VKuD4wUH4MS5vRzdCBKwusn5fBc9s49Yrr8xs7RHPQP8t6
2808	fee_transfer	1724	11000000	1	CkpYqGzr1GAZPh1oZfWjQL429H1vA9tF57LYXGBbGGp7tmWUYDCT9
2810	fee_transfer	1739	22000000	1	CkpYR8uFWgEBSf99DmH7MQx9fR4KnwL74KGB3SXL8eLW5VJdbhaXd
2813	fee_transfer	1610	1000000	1	CkpYmBNvRSqStZtcnvEPybMRKzQfwP4vgKcEkN8cLUEdSLZZoJJJK
2824	fee_transfer	149	22000000	1	CkpZmhzSpfTkFV19rqUtE1PiczdZMSciGCy3JDES1tR5X4YVM9xch
2827	fee_transfer	1587	22000000	1	CkpYSFhQVDH1pppTYJdM9n9rjytDWU5j5Cce6SsQVc8WkYyv77pPo
2829	fee_transfer	1549	1000000	1	Ckpa5pMWDtJCYgS8VWKR2Jffi6V5haDdVFKDZUjTcpevDWTMTYc2c
2836	fee_transfer	1991	11000000	1	CkpYQgLaTCZuRHvWbqpvGbT3Sbjemv4V7zp5fCJKDMZpwQu1AUjkD
2837	fee_transfer	1991	12000000	1	CkpYkhkaBYJkeWcjJScFJ8p8W7k45QRYg2nYe1zGDWnkL4eDgxyAy
2839	fee_transfer	1714	12000000	1	CkpYqb6PrT6Z8GTo1DLtZfjV8A6rvnDNcKt8aVTQ7dQR4FXZwaXeg
2840	fee_transfer	1980	65000000	1	Ckpa7BiBqfZG2iEX4sMdEnKU9UPRY4ppz9R1BKunxpY7VBEX2t9MS
2844	fee_transfer	1656	12000000	1	CkpaHUyWukPFNRuRwcJuwDDvWx53CxULLgfkki78H3ybyesK4p9f5
2846	fee_transfer	1701	21000000	1	CkpZJpYiKg3gQKfbTr1Bzs6NGgxV7vCyuk668fFwPae4sCURfXTMw
2847	fee_transfer	1701	23000000	1	CkpaBMnVQwfMGZYUSzPUZTkJwutWBtQYBRtTvpyKTZTeuPqFzLZYW
2854	fee_transfer	1657	11000000	1	CkpZMZ1VQbk1w5ATqHQgi87fB3JpMhx1hUPLDtSwt1rLf76REeSW4
2856	fee_transfer	1440	12000000	1	CkpYQGbxpLwHAA84tVYwhK52dg7hcgVjVMQW3d3Y3V4BPkJeaaHzJ
2859	fee_transfer	1692	25000000	1	CkpZVmQJN39AnkLbXBYo8PckUnPutZdtZ3SnPnYWsceabJY3wLiG9
2861	fee_transfer	1699	181000000	1	CkpYsY1G3gX2XXb74TCqTmDGHH1u9AWArwG9KE7K67VVRDhXjpcQu
2862	fee_transfer	471	100000000	1	CkpYVjZbHCRV2gCzgkeiELp1YUj4eLqfrMSRACwgWESa746jN3rAt
2863	fee_transfer	1699	100000000	1	CkpYXCErsyBSwKcLCVY3DN1aLJEvJFhepeaNw1JxndXK1mvRokejZ
2866	fee_transfer	1458	128000000	1	CkpZLf1LKAhX6htxHbSLGWdXPBxqPAeMHpGHZEBujZtr3heg32XuC
2868	fee_transfer	1654	77000000	1	CkpYeCyw1w3QdeMtNgjKZ9oLUS8m2CgW5JqmJ3gyworbz1FKvtGtS
2871	fee_transfer	1601	33000000	1	CkpZtfq6fwJnZL7UVz7qYifmDX8mVbCHpuUNBts1GERQ8zVpCrn4q
2872	fee_transfer	1764	11000000	1	CkpZp9R4Tn8suRuDTfJyfwg1m5SBXEE6f7cWuCAeG9gFEFEcfp2bR
2881	fee_transfer	1677	43000000	1	CkpYt3bBV47Det3ybhmFnGifQKJ2mW7ng4RutHquA8UYESymY2s7G
2885	fee_transfer	1687	1000000	1	CkpZysL25kC9TR2AcJgD1atpyviW7eGHKDP19nLGpEfxhsLQfLJba
2891	fee_transfer	1673	2000000	1	CkpYQcztNNP98JpuskKuYsd91S7CAmDruqyJR6HhQUCn4EZQWM8xj
2896	fee_transfer	1694	1000000	1	CkpZwG4hg9R393DAeMNdnh5KBxB6jVUokhvxhH59DkCCVnKKJ1Edq
2908	fee_transfer	1489	1000000	1	CkpaLM9ULaMHd7cGiiPaBvQR89K11FJ9yufsxVEgQspAuT1AuUg2H
2915	fee_transfer	1573	320000000	1	CkpYmPzoBUqVmUpGDv3d7dQfkmHTXRKrGgxy2YiuZ7ZWs68VpJnuq
2916	fee_transfer	1573	919009999	1	CkpZLJRSVb3LpsttxcSbF8t5VdtiBFa8uaNfMEGqi38Lb9JXTQYDe
2919	fee_transfer	1607	2000000	1	CkpYv85qafpxJtcttcFPTuj28Eu7QiRqBF9T83Btndhq76NhjFso4
2922	fee_transfer	1509	3000000	1	CkpYd8HiCBRf1rwxaUUdx5RrVxZydU9KMacmWgSK3F8Qun5XG7d6k
2925	fee_transfer	1992	1000000	1	CkpYcYeCCrg5oK7sLKpj5pG2wB5mS3kRoff9M3PsF4Cp14V54DP9y
2928	fee_transfer	633	3000000	1	CkpZKSNhbjjPZvoyqyUaLouA7z1L8tebUxwitDqr7EDA791pGqDq1
2687	fee_transfer	1685	490000000	1	CkpZ4Z47mEnhCxFdQFg5eQSUZY1j2rU6AYCAUFGXFeYJMCVfTBaz4
2688	fee_transfer	1685	290000000	1	CkpYVLgbim3Dcu2zA829xf6w1rZaKy9CxSWkCa9j9m3DVMafp8JWp
2694	fee_transfer	1714	600000000	1	CkpYQzpQC59KV1XmStizQt4eB7qbYR8EfoJHL6FZ8sVT3F7GWTqqL
2699	coinbase	1479	720000000000	1	CkpYYcG59gejhJg5rhmLXnNP4GfHnyts2p75XvsCDg42eC7S56SVy
2700	fee_transfer	1479	40000000	1	CkpYS5oyefcwDHpPXjKuxUEc9NL6MBojrXhZRkAyr1FbDtUKe4XST
2701	fee_transfer	1756	3350000000	1	CkpYZYRs4nXFguMwJV8rjTvzpBpHw6PFdQaj8RNuwMpzUVqWnsoJL
2702	fee_transfer	1756	170000000	1	CkpaCESuPvfSCbfybghGvTB3mt16XXymeSUeHefW14xwGNvUym3U8
2704	fee_transfer	1871	30000000	1	CkpZeajc97ssNmeLrpf6Q8Uq9tsm5xGWwvgC9aFhDcUESa4ZuahrF
2707	fee_transfer	1746	141000000	1	CkpYn39BG99rM59ty7br77WCkETUcF7jyJthZkyaSgdpC543rwHC3
2710	fee_transfer	1729	120000000	1	CkpZbBd75byoTZNZR7YqaMheFkrmG8m3zTxRFr8YyFRzuYzU4wNwC
2713	fee_transfer	1564	41000000	1	CkpYY2zuUQHMDtKeT7ZsrRFghUB2jBBvy9Hh1xf56g51TTWqtzgcD
2717	fee_transfer	1419	23000000	1	CkpYrgheFYmxGJFdoZMqTssu6Zw961vfhSRsjYA4imVxVLfrkjB9M
2725	fee_transfer	1455	22000000	1	CkpZWwdRyDdc7B72hEiJxd9hUU9zBoZ2eFdLvJSMp8wRAi3tN5VTw
2728	fee_transfer	1587	132000000	1	CkpZhsHjHLVqrXPhC9GMeHRBE4DsS9unoKPMjq2YPfeMGmbEUd7tM
2734	fee_transfer	1650	61000000	1	CkpZsxcYPrKA2CXHUxwHcF3rwsT7eyReFJzhRLVVsX6ywwDqdWhw2
2737	fee_transfer	1509	324000000	1	CkpZhJaaQLx6hvLwfx4fNAgWeGiJXHsK9ocZ5RZs8idSvFd1VPNPS
2741	fee_transfer	1611	21000000	1	CkpYdczfGp3d2EjxUiKch6MEA7wvFkigfd8C6jpMqvdv8bSKMArsd
2752	fee_transfer_via_coinbase	2000	1	1	CkpYkBk8E1QkcW8TJrpzdFgU3iBYGg3sDvXZ3Tv1ohiBAXDDJQpy6
2753	coinbase	1680	720000000000	1	CkpZLchQkYrgWBef9iRFm2BXzLzsZFPNdynRkpu5YMF3Ct2qrYggS
2758	fee_transfer	1693	22000000	1	CkpZNPiLQxhvNoDjrA7tj3mfm4kgSAaCKQAkLFfCVyKtwJ5kHSsdb
2761	fee_transfer	1467	11000000	1	CkpZWj1H3T63zdnf7EBQbPCFBVXFYBeMNJWMitGc6McXoGM1TCqSF
2764	fee_transfer	1668	11000000	1	CkpYeZGuPdrfEfmEeHVKciH4dE5E6Gzms2bZzLduEfoFYAF3PDtAj
2768	fee_transfer	1714	1000000	1	CkpZAZZFo9cjXo14GeUaH9fk1aoRzBBbEgB1HGofK6zXiGMdRprYR
2771	fee_transfer	1546	22000000	1	CkpZbUijDh9XKA9PmQEbkRuie9mK7jksegv1NWG4mDGpkSBQrjTjF
2775	fee_transfer	1587	1000000	1	CkpYccW9ZsZSpRW9ZvNimMBZwsGraHo2CJUSpmqN5Fm7GbUyyCuMb
2777	fee_transfer	1688	33000000	1	CkpZ3txvk2FPmCVrNAWQGMuPYi4ido2oS7q5Za5z8dq6Qfez6seet
2785	fee_transfer	1710	1000000	1	CkpaFyjgMBMPAMncpmChhPsr6M1b2xCspF2X2Ucz69Hxj6o3H8hGA
2788	fee_transfer	1402	55000000	1	CkpaA7grXaUFQA3TZd4YfuGzqf8UwwoakYXpR3FpYrG7xNKWZcCYH
2789	fee_transfer	1679	11000000	1	CkpZ9JQaM6nDwdCnBu4eap2DyMNBdYChaUVw2foQLkVb9rTBf5nQC
2793	fee_transfer	1673	33000000	1	CkpZcqE1SdMPoTKJ3TAQTQ4DbDBQRS9z2f9sKWB95X6a84sYuJcgo
2794	fee_transfer	1623	11000000	1	CkpYeEwPaWiwQitUpkKM5HuUjh7qV2Kpk9sR1LGosCWUDckU6PPsd
2805	fee_transfer	1681	11000000	1	CkpZNu4b7aeBxSB2NdbpNNvWvSLxBR6BofmLN75DdJN1AmZc5Zgz4
2811	fee_transfer	1710	22000000	1	CkpYw3xDkYZWpc7nS4Lkxq2ZfTEKHmHLdWuh1H5w9ZYbP73VWotoQ
2822	fee_transfer	1671	11000000	1	CkpYvJdTb2g1yiSexLEMfrvicWiPkBpyTc9y1wgKXrqU9NoVAYnMr
2823	fee_transfer	1634	1000000	1	CkpZgrcWeD5X7N8azpRw1tL74gGBG3LgutbSLSu3CqLaurFbPKqFv
2828	fee_transfer	606	33000000	1	CkpZfkH5dxcTQrZ1AJ14SBsf3TjCqAwxUuFHZZMnGAMXb22LCP7UE
2830	fee_transfer	1679	22000000	1	CkpZr49ZWzgp3R2wxecjDmfDvi3oaPYK1sjiiGJkVtQPBwz5C6pbt
2832	fee_transfer	1768	11000000	1	CkpZqQZ8uX87EfAh8Jn9DBYaK6XqCz4wVC7vwTmvCd6h214gP79ts
2842	fee_transfer	42	11000000	1	CkpYnCvDfFEqM1Y5TARrDs1TG9CMqVBcfzqDr3PFqM9LHvqPzFpoe
2855	fee_transfer	1657	478000000	1	CkpZRTimoWe7ZmxHrnBYpSJXStizudpppc7ReVVZe81nQ32FLzRR1
2857	fee_transfer	1673	25000000	1	CkpZuB9Y2VEN7g4Ykxha1xtZLnTEzBEJ5E29kvyLtSwyJYwA5mtQg
2864	fee_transfer	1623	12000000	1	CkpZrgi9Gruvr33LNvPVvojKbeGcpsuNxa6dXmh9suFKRX3oddJEv
2869	fee_transfer	1571	2770000000	1	CkpYeYiMyUk4uTgGWipeTj8yS2LYzqwSzTdksefdpXpXYChnyZs5n
2870	fee_transfer	1571	270000000	1	CkpZU7dSSDMXsVSEr5Qzvy7KoczmA7NLyZHYmukhr4V97eu3M8F9a
2874	fee_transfer	1608	14000000	1	CkpYyMpx5VZkL6tWf2d2QrfB3dzJbUCKmKV5oo3KmfwurkBKEXdcQ
2876	fee_transfer_via_coinbase	2048	1	1	CkpZrfa7Jkg2wKVHD7jDgjbRT7dFRzpC5wVcvNGC2NJobKszbkHux
2877	coinbase	1711	720000000000	1	CkpYyQDKTDAVJV7hpY4fEQfx154ZosUqx3qRvKMaVaUjt95DyGH86
2878	fee_transfer	1711	42009997	1	CkpYagwZ7LFw3T6XdPa6T2CWx41nhUKcde3FtSeuFLENikXvVqjHc
2879	fee_transfer	2048	3	1	CkpZ2ydhyPP74JjnPzUN8DKhUyF9HRoj6tdEY2eGQQvxfz7ygbwDt
2883	fee_transfer	1564	43000000	1	CkpZvSqAt7zFAV43DLhEu3yKFkq6r9PoZxi85iC89szfJBCj6oRGF
2888	fee_transfer	1271	2000000	1	CkpZ6WRXwYcfhATLD1497mrRCVkstttYLE7uKZ2dCguQLHTeXGKj9
2889	fee_transfer	1451	1000000	1	CkpaFt3W3RsBsW48doeSWes9ZpjWnw2kWz1QFb6s1EmVc6MtYcqnU
2892	coinbase	1525	720000000000	1	CkpZ9W4pwneAkcc6yHnT4rkvR67ccpw2tZA8kUCdAX3KvuJQqgLQ3
2893	fee_transfer	1525	2000000	1	CkpaDtQC25nnTmdwUQQ2ZpNzc9tSYryfumZ2tDjzC8bsiMiDbc3m1
2897	fee_transfer	1613	1000000	1	CkpYtFq2xKQw6aVZBRTujJXvMovKaatucQEvWzBHuzJ4kfzMe8WLk
2900	fee_transfer	1611	1000000	1	CkpYaoXntiDvzavZG19yNQg3MX3ccVsEFnLNz3Qap8hpfFYaMQtvP
2904	fee_transfer	1471	1000000	1	CkpaJgXHV3uaa53FVoDnwcyBtVz5dp3BVizCzDe9Qzmy8Ntu8Yx3r
2905	fee_transfer	1767	1000000	1	CkpZUHrKYJLDd56n7fQFova2bdqK9bH3DTbVjd5ysjWkHwUQ9JryJ
2911	coinbase	1599	720000000000	1	CkpZp6cjZz7F9y9GfZzrRgrjxiyHSe7ChosjPct7LjEMe3sC2QaFC
2912	fee_transfer	1599	1996200	1	CkpYoASNCy3u6B3tHy2jTuUaaCVGCqAGiFfnZLAcWDVNFSDnKVv74
2913	fee_transfer	1514	3800	1	CkpZkAVi6i8Ljh3PxUGEeRRvVm9yT958Bk9H5CvdFTwAgor6K2duo
2917	fee_transfer	1683	3000000	1	CkpYwDed5QoBMzXDWFD9hBEEGFv8g1cHrBrswW3qfr8tKMVEvBnZx
2920	fee_transfer	1602	2000000	1	CkpYUM8QFkCLQU3AWpi41gcfA8M8MapidupSTSSyXSH4rU6TdF7aN
2921	fee_transfer	1637	3000000	1	CkpYqLzw4bU1umuCm692tWsxDtsLUTyxmwTa7cC24HHG16JRn4cAp
2924	fee_transfer	1723	136000000	1	Ckpa5MikeAm8tfgfJoeiHJ2siFnaYUjDyNQnN22xVAJBGdbEgVA1D
2926	fee_transfer	1711	1000000	1	CkpYYYTbx3u94icJoF1xbJhBrUcCM4SSxM5vVEZfYwP22twahgtfY
2930	fee_transfer	1677	3000000	1	CkpZzfC5tVejTuVSXGDfPHdJRLadQZegeHJBbn6kVJwTuYTnCmwKR
2931	fee_transfer	1513	24000000	1	CkpZHBDF1XbcUvrTtXBGWBSabcpkXQj9p3gEKvrfGkMRt2KbEDhLf
2932	fee_transfer	1678	2000000	1	CkpZgxdJyTuiaYXYexsVMoxaKjHsPtoRjEAJcRtgxvi6hWopPsWyH
2933	fee_transfer	1668	1000000	1	CkpZN3jSzUYzquoPWk8UsLdapko3WTq4Qkcm23TDjWxhaV94DJR5n
2934	fee_transfer	1444	1000000	1	CkpaHuao5LeZjJz8vUeDSCPHDguV96AujZbqLw4WvSc2QDYq7fqmk
2936	fee_transfer	1447	1000000	1	CkpaDyF7ktuHmRSBwTqXAyaFYYY7MCW2n1VqkaPhWNPGQtgpBc9kw
2937	fee_transfer	1458	335000000	1	CkpZQv4JV4mSnDFLNkHNBspAr8ozoSXWMFSoJg6DMnQRNr592Y5kp
2938	fee_transfer	1458	28999992	1	Ckpa15KnYxzrB9mobWZ8DjqNXw9PMXBQ9L6Wya53btVopojSH43Lr
2939	fee_transfer	1508	4000000	1	CkpZ9N3JA1Q6YRRd8Wc13JL4pYHuZHpeizgs2P8DHr14VbFv42jhE
2942	fee_transfer	1649	2000000	1	CkpZS1WmL8ocyPaKgw577wP454i4YRMYRXeAmbiGNi2ZatYwESbKK
2947	fee_transfer	1747	2000000	1	CkpYggzWzpNsSvzKthGN6smLXF7b5VXCLh1cv2vCxv6RWCuo6S8R3
2955	fee_transfer	1508	14000000	1	CkpZqnEqihthXFz17xSTSpEKjk41Zo2FwCPpaqno3fj3NQUscxzao
2962	fee_transfer	1588	144000000	1	CkpZnsNcY7mBjAGeiJcjbwERS8LaJFHAgvqbRQwzg5xAimAAHepbV
2966	fee_transfer	1402	2000000	1	CkpaFLQCMx5x9gXJChfZFtXeT9JW8fB1aSRiaW8wWv8isg5wnYGAv
2967	fee_transfer	1622	1000000	1	CkpZDx8NmWjaydMdSNFncDhH4a1QtyQAgPwtaz2UdWJFkappvqfKg
2973	fee_transfer	369	170000000	1	CkpYRdC5hSFpVd72uGCYRFwbtF7Lv6D9VVbvnmv8PCXYopoWd7Efb
2975	fee_transfer	1656	1000000	1	CkpYhn1M1jLkV9uRNBWN5d3jy4nBuKxWXXX5p6imT2CVkjkn6TBfo
2982	coinbase	532	720000000000	1	CkpaFXBn27BcPQynUhJtc6gkhetyLgg5M2HnkLNR1M2iCqxJiKaUk
2983	fee_transfer	532	43000000	1	CkpZ2szf3xDRzkMaehXv3YaETHHaUest8MAao1XZ4upFBt538Rfci
2990	fee_transfer	1679	2000000	1	Ckpa1AXkGMB1iYEA1MBSFVnxQPTaZp9XFYAe7ivKzig7uJYmXgP7w
2998	fee_transfer	171	1000000	1	CkpZTPpJG2bCRH9qnpCKvp8AmFijgXiV6PyjoHV3zn3PNNTiqLATh
3000	fee_transfer	1724	2000000	1	CkpZSkiLvEFsPC8PPbWQR7Er68KuAdig7cZQPQMNgVT4nFjb9Nh5R
3004	coinbase	2055	720000000000	1	CkpYTHpGtixXmkpE9JjJWfrjoRwRGgBqUduV4p7cegTHFm7zqvsxZ
3005	fee_transfer	2055	2000000	1	CkpYgektAuG7ERjSafDdfnDuNmeRZY6g2RtA92HRVDvnKxxkF4H2N
3018	coinbase	365	720000000000	1	CkpZjjsbc29cxfz7RrrmBk6Le6tsGNaUgTGPXGxteoPZXzC3MfScv
3019	fee_transfer	365	1000000	1	Ckpa5KzbANLqzbBrMYyR6WyeGpptT7GwDEQDUsxtQheVNP4McT8MR
3023	fee_transfer	369	1000000	1	CkpaCgFcoA5fUhz7g1HffgpYpzH6L9LGbeEGvv4AihTaXsxnbXxuP
3025	fee_transfer	1768	2000000	1	CkpZyDGTzdewoBXMyoJZAfHrsvouwfs4L82YTMArb4qHNZo79M9BA
3039	fee_transfer	1613	2000000	1	CkpaCdYDrQABiTeZ36EcCNgZTcZ7TJXNozYK5egN81fuUodVV4V8y
3042	fee_transfer	1654	541000000	1	CkpZpW4A5YR7B2NDMzBMTR86YY4aMfimUujXgSgo2oKvJFvE9Uxax
3043	fee_transfer	1654	97000000	1	CkpZXzninH86gUWhfSq9BzwUogh3kJNeB6Aw5JMbpqXa8CuXfE9yz
3045	fee_transfer	1610	3000000	1	CkpYjAg69kNuqMb5bhC5aP1KN8LTnFavMmKiiWh9HjrmzXsHxzbCe
3057	fee_transfer	1455	4000000	1	CkpZURkJDeo9m3z3HHGSSaMjCGvXVCceKrode8MgfhGF4vjEFEckp
3064	fee_transfer	1755	1000000	1	CkpaJJvEkiHcggsuWycZiewvahiUGo72TWnh7wgXkoNgFnLFMhz4z
3072	fee_transfer	1593	32000000	1	Ckpa5FcJyNHHzvbBb7TaveCJnR3JBpQiX5Ah3hCDMtk2DB6N9Qs1B
3076	fee_transfer	1764	5008000000	1	CkpaDec1NSKqjUnyRbwqr1LpxeCb7ieS217YxtbRNpJKZAV51a833
3086	fee_transfer	1422	20005000000	1	CkpYeCqYoW1zeYDGxjvQfJts8Y3PdrgEZ5dTNn8W2Y6ipPEmGv3LN
3092	fee_transfer	1560	1000000	1	CkpZ12R1e6xeRMqFP4ehMmy2ZGPgTg7bFwdG59XDQ52mqvJkJeURA
3093	fee_transfer	1705	2000000	1	CkpZDrkx2myKq8AwChWwuvCeKZjiro2XQg2qvokTMGZu538KXF8KK
3098	fee_transfer	1700	1000000	1	CkpYWBeEcbD3ZNiaR1Fo3dHBuuycc6SaKiDM7Si8CKmTAM63RzSfA
3101	coinbase	360	720000000000	1	CkpZDnQH4NeUoDw9nQb5fGPMmrUHPViiXhAdrc9qurjJwNLkcF9Uz
3102	fee_transfer	360	1000000	1	CkpaGjDGcGksUoCxKDqbWCkL8y81yAUknLNnJH4UX2V8hZFvSoqwi
3104	fee_transfer	1439	20077000000	1	CkpZuwnHJu5zvuHoS7Cf85BkwJTCzDE6pYDpnm6ewAHwST6pK4RQU
3105	fee_transfer	1439	50999992	1	CkpZA9q3ZnkvwtSz6VkT7oHUebNX7Xy26N8rT3eYM78bonFYLegH5
3106	fee_transfer	1439	20033000000	1	CkpZKLqyrGn2hPp4LxEsQdw1DchCsVdFoJexdv3iStLwrJyq5ZsQ5
3107	fee_transfer	1439	45000001	1	CkpaHF2SDRgovunqRWvkhBhfnLBDRdxsuJ1C5WPpkPhhJtFxJqA6P
3108	fee_transfer	1527	999999	1	Ckpa6J7EqmaDmUbcuamooAuWsv2596tSsAVuq3ypcoFskEdnNq9wR
3111	fee_transfer	1656	2000000	1	Ckpa28xasqY3i4ZsxyxV3cAJqgdo1RSSWauHB1qdgPaqThxDvxewy
3114	fee_transfer	1680	1000000	1	CkpYbhhp2ME77Kgv8KCpNU3PcqCKnLpPj6vrdSe9dDk7XTtRkvRfh
3115	fee_transfer	1723	1000000	1	CkpZEyGztzgpWWdPCv3t7JtVLt6ZajmwPco856TmvfNCNjDrVCiYb
3125	fee_transfer	1593	37000000	1	CkpYUNZHbrKdTfBmS6wxpP8zMtBG9w2UA4s7mSe9T49TaXSRv53Xp
3126	fee_transfer	1593	68000000	1	CkpYauiKQLGBSuemwhAJDNFLY3Ag5YVRnLxzxdU5iHm4p4eEn3DDe
3127	fee_transfer	1690	13000000	1	CkpYgehVxcx8wRKSYZaL6czY6UzZJy3DqYVLwAYxEEUJ3hKzjYyvE
3129	fee_transfer	1679	3000000	1	CkpYR7kJrDebG91RXxV9ZRjnT5T7GUzTCvXK4n6g1JFmkRzKMWL6x
3132	fee_transfer	1723	2000000	1	CkpZNz1tYBDJ8zrrioNLPeqEtcRTAZUY2ATFMG2jaWAYWRD1udXJi
3135	fee_transfer	1556	20256000000	1	CkpYTrm56ZSKKQE85hQsDsPkRvh4Abo8BvfAXyxRR7xDSeJJnmv8S
3136	coinbase	1556	720000000000	1	CkpZP1yCx1iy1Jo7U5kCx649mTwMuxxf49VFTfJ4MWVgFhPsR2osR
3139	fee_transfer	1692	3000000	1	CkpZNSs3LeUrApcLZURRo7Yw9tBnR4AQSi9kfJ9vD1jp6ogNqkMgV
3142	fee_transfer	1654	1000000	1	CkpZNszfT7YhyPmbtyFYw5h43XEKKX3apDPpiift72KB2qQe9uWME
3145	fee_transfer	1420	198000	1	CkpZ9CqixX6dL2z2JUBMk54voH4hSBTdcFkkQqUkNL8w7ckhjisNZ
3146	fee_transfer	1716	1792000	1	Ckpa3pSL43rDiLN6HY3oZP3b6kmGvMgByCWNGoPyue7Tct3A8tmv1
3148	fee_transfer	1683	5000000	1	CkpZY7e8WeudA7SjScZ7zgbAcisu4KDvXmfuankLency8Kavnvt9n
3151	fee_transfer	1629	5000000	1	CkpaKj4xEzFfmBzmhBGNcZwRHNdB7w1JM8bgpMegF6HcBk1CrcBdk
3156	fee_transfer	1739	2000000	1	CkpYuxkQKerTt2cqNR3k97bFLk5yJbFXWNKVFH5tMkZPCQgukCR9G
3158	fee_transfer	1546	3000000	1	CkpZdi3A7yw6R4sf8VQqKcHjkEZQ4A671cZPp9m7TBdJDpmRJtcSu
3159	fee_transfer	1607	4000000	1	CkpaAfuXNKvtu7NqkSCUKDzzHiysNYGLUKxNhg4KBUvL6hM5uEFEq
3164	fee_transfer	1687	2000000	1	CkpZPiy94zA1KgwzF5TC7V3DCbHsK91GdBkcfXj1QYijo3DzVqyJ4
3165	fee_transfer	1716	3000000	1	CkpZkHEUgQRvU4m3kTFwaZ3BFRbVtRR4VYGY2hwkHiibXxAycJg4V
3170	fee_transfer	1698	42000000	1	CkpYp2XrVVj9owqp9kRrLnzATXnMq53znDrM2WRdmirWHjYDcLDT5
3183	fee_transfer	1599	11000000	1	CkpZmnCrrQ5VE5k2VVsNQgx953UgQ1BkfR32xynd8vSbbmXvN8wHU
3187	fee_transfer	1692	31000000	1	CkpZkM9PnteeqyErjNb2Q4oioD2xVABzKj1K5q7wyF8VcWLwpfbUU
3192	fee_transfer	1457	3000000	1	CkpZGaqEZCUFup8fLxM1wDyyNtqqiePbZnrcT3KYXi5ikDcghBzGV
3213	fee_transfer	633	802000000	1	CkpZSnd3Ag7QEkBUrBQ4eJ1jEFdm8BcZRvNNzwPjwtBqvSa2GGxzs
3217	fee_transfer	1448	101000000	1	CkpYt6VMVq6ypqsgkM8Jyhjm76meMnmpbkwAMxiiG5JaLpbaFzey5
2935	fee_transfer	606	1000000	1	CkpaDawA4iE9sgPdexHUBJrSV8gMkc26xiSwHmSG3ipZLu6APA6jb
2940	fee_transfer	1718	4000000	1	CkpZXitsRdsmHejc6KXdsZPgSUVrDyCZMsfbJNXqeouQFN5xeZ2mC
2943	fee_transfer	1670	2000000	1	CkpZpJ2dmBz76Pn22bF3T9peXarSGg4L96RcC6rAmpugNq4Uxoz7J
2944	fee_transfer	1467	1000000	1	CkpZXdd3HVp8wAvgPWtXqG5tckkt8FsctzYmwv1U5R92Win1nn64W
2946	fee_transfer	1729	1000000	1	CkpYXfQJffza8K2sQ129hNWfTGuotCWVezSZJHRJLEtX3L3UrzAxh
2948	fee_transfer	1704	2000000	1	CkpZPunfFcMCqfnbKtfCUWYx87NdA6HkLi7DvFXHoju9wstdxqDXW
2949	fee_transfer	1746	2000000	1	CkpaE7Vm5fnPecRdeABmt2TLwiWDaeWxV6wPpyrYRH5oHaywM4cHe
2950	fee_transfer	1677	2000000	1	CkpZ5Ab9XXTkGsrzmTcXnax5V9JBfBw9MZ67weSXJXf4cKqxdPZ2z
2951	fee_transfer	1596	1000000	1	CkpZ4aXeCTpQZq2p289fA2gWhKTr8oAcvCePDxG26rfShsW9embC1
2952	fee_transfer	1536	1000000	1	CkpZV9gQ2P3bk5kEjr6hqufzWQwQ4a8cceexEemsgQjZJ6BA832Tp
2953	fee_transfer_via_coinbase	1485	38000000000	1	CkpYZvr94EDPUufCpBBdHAbwYEihJGXBpgi1mAPmYLBuFQKuAtK6P
2954	coinbase	1458	720000000000	1	CkpZaESx5CrLb4hB9gx5edg8BidS47JQxBKry1ib4rW2d4FjruS2W
2956	fee_transfer	1747	1000000	1	CkpZ6UintEU2VF24njGR3hzuEvk55VA8AjTBQrvBk6suq8GgV3Qy9
2957	fee_transfer	1704	1000000	1	CkpYnBF8yckQn2AyWdDqhvBPsKSVogUP1gNjYySYCwrXskWzNhXMW
2959	fee_transfer	2039	1000000	1	CkpYiPg89vJuzdozSrHbWHqkmVHsvYBV5dsPEJzArpkYuVt95Ty5Y
2960	fee_transfer	1633	1000000	1	CkpZxWo8J9GTJSB2q2HusZeorDuPdKYFn1gzTJk33gNNBmCStshbY
2963	fee_transfer	1593	144000000	1	CkpYno9n98L2UgukRoJZk2UT8LwAxczmZ9BpuFYtUQeZeKZGUoZtP
2964	fee_transfer	1705	144000000	1	Ckpa28sGpiGhtqpBDBXBcC9v8qzF7neCM62fhDhfRxGinXYypHcPk
2968	fee_transfer	1673	1000000	1	CkpYozXb3oUeTujqiLpSzsqtfpytKC57vB9ahEAchrDEtZHiRQAgJ
2969	fee_transfer	1608	1000000	1	CkpZ2bndveuVPWNWYBgHyS3XCophv2g65jnfjZamVzny6JfYeK1XP
2970	fee_transfer	1588	1000000	1	CkpZHqBXTeA3RCWsnCAeTeChuQYaRtfpLFtCnmLpvHmZQign4hMnR
2971	fee_transfer	1749	1000000	1	CkpZa1Bi5fe94ekx7f9dFPVyC17wxYdMQrwqSwe7Vf6fkomE3jz7u
2972	fee_transfer	1759	1000000	1	CkpaF5zvu13stZqcr7Wn9khW451a7wYfnPH6BcUQKBXUfqB9AbxP4
2974	fee_transfer	1637	2000000	1	CkpYQS8angrRJTx9SuzNrJgKX3d1KprftANVs8FsPsD6XKSxZLdXg
2976	fee_transfer	679	1000000	1	CkpZRVdn3G2YU6XNnEpgoYvTHLSopHaQ49vyQzJ5Es3SNpWonEk4V
2977	fee_transfer	1506	1000000	1	CkpZC8aBzYKNuDrzxr684c2J6jwHhWmmaTgEm8zms22sEt1YKJhZ8
2978	fee_transfer	1693	140000000	1	CkpYuUhpzkuHdFB3kqzU177CJVLujt9QEfuJ8CLE1bypr6q1di6g2
2979	fee_transfer	1601	2000000	1	CkpZ6uTVNxic4jbCDYjEW8BNxmsqun4CqTfdQjPguwxDQazPqWPkz
2981	fee_transfer	1724	43000000	1	CkpZoXiTeH1EzbFcxRd2oP6mCvgbaioaVYdCxb4B73HpsUWY6sBKX
2984	fee_transfer	641	14000000	1	CkpZ5JnC9Y1a6YptQ3sSrnG11k4Lkk3RXGcpeTZQE5x24uBi5wVAP
2985	fee_transfer	1593	1000000	1	CkpYpM5zTTtVuv4UjkQXU4VYF9HnHJTrbwyNQjjivSn6aZDzYXiMq
2986	fee_transfer	1706	2000000	1	CkpZqwwRnayhXktAUjHsTtWdNAT8MwjDvZvm7SYyqVUFMKLuQfyj5
2988	fee_transfer	1608	2000000	1	CkpZFy6BF39tthZ9bBZsRvhYTJbHvYCciyXfr2XLhRBLpGhK3He98
2991	fee_transfer	1564	2000000	1	CkpZXQG4aMFkyGJ3LxwCodt6Sx9QHGURk3oHhi2XuwcxAR5G836aB
2992	fee_transfer	1426	22000000	1	Ckpa2NBVXXVc8umLMda3af4fw6ybXN3r65UJVGFFfFDhv2FZTWNru
2993	fee_transfer	1723	294000000	1	CkpZooqdHMQcUYmtXniGm1tr9NKbv86AjuL3ppzTPUhxdbQo7Cbae
2994	fee_transfer	1723	82000000	1	CkpZq4BDDrmTXuhtSKnwxt9FfpbPuVCofGGUbaeWJGR51USrc5wW3
2995	fee_transfer	470	12000000	1	CkpZ5du9cKJJxTaL4211RLsgSwP33drPnkMETYsy9SwwacFPTi7hT
2996	fee_transfer	632	2000000	1	CkpZTXGh58eksB3RQAUDFjyvgVHdbFUWn3se1YuLydxx2mUVvBPCn
3001	fee_transfer	42	306000000	1	CkpYyp533BdtLqVdaLDBxsSpEqUmLm9GX4kpZZUvN1WWdt6dT3k6y
3002	fee_transfer	1501	50000000	1	CkpaEkoR9h9umgTksqiBfKTgFBPkUZQvHLdNPQAXzwmkSmgK5pcAt
3003	fee_transfer	42	12000000	1	CkpZVac41ePfDumwfSqwGnkimScvVCHfvgKUy2rie5NQodyqosKnF
3006	fee_transfer	1672	2000000	1	CkpZbsHDU9kVrX6WXhePTEzzNjaKtmhrLjMKMaE4oBND7UwBRMTvR
3007	fee_transfer	1559	410000000	1	CkpYgsVQ1x8reCxJCTJmNFLG1yVutQxAqA7tFmZuFmYDnk3myEwuM
3008	fee_transfer	1559	282999976	1	CkpYqPmzorEMpC9xmJJjGsN4ZuUsvif1a8dg9pddpkYvqiYhQLGba
3009	fee_transfer	1571	24	1	CkpZ1vsU7zdm6YSGC5ZtmjnZe2Sn1tJN2gAXcKK38Adat6adsJf8f
3011	fee_transfer	171	2000000	1	CkpZzyN5kj8txJvyD2yEGZ9PUtC31DzPxLWqycT7E6srikzzdwtEq
3012	fee_transfer	1705	1000000	1	CkpaAEoVJFHTJ2xGtprHNfWvwmUyhysCxrtse6R8faHQkcxZQviYs
3015	fee_transfer	1656	3000000	1	CkpZz9GCP7kWyvE4EaKFJYwg3JFx3LWZ6NiYhPYe4ssJYrR7SsivV
3016	fee_transfer_via_coinbase	1988	10	1	Ckpa6nEbJ2nbq6fY4avp4CUNxvtczEtYLaUKA7XizPRPHyXVMPmXC
3017	coinbase	1656	720000000000	1	Ckpa5s2eTWG7SHBp2wFcon8gjU1JFjDNz61YJryxVpUB3oBqs3maX
3020	fee_transfer_via_coinbase	1919	1000000	1	Ckpa8TPtxUvofZfNjwxiXsGEZcKh64G62KXHmjVjMqD7rPpLmputE
3021	coinbase	369	720000000000	1	CkpZvm73GDnPbDmJyi9kaNjHkpGEuF5KTSrPGkbSrGLmZDHmGM6uk
3024	fee_transfer	1610	92000000	1	Ckpa3asyEJtJ8V7BSa7G5fYvj3ssvYFfcCVQkPk4ouzWHArvAgBFa
3026	fee_transfer	1594	2000000	1	CkpZiR7eYg4dcsewpAgDR6ybD7PLH1h1ZyRg4rHLYxPkoHqrbtxE6
3028	fee_transfer	43	2000000	1	CkpZ1tzENEYru4QT7Mdra8opSXPnkpihZxXW73YvFx1Z9AXqjRie7
3029	fee_transfer	1679	5000000	1	CkpZoFsBRK6wAebiaDzSQ2ZTqPzk6CeBtPgeH2F7bzHR84H1SYAdh
3030	fee_transfer	1467	5000000	1	CkpZEpYUW2ZsZGNMFv3vrXkmZfHEdQHdRFPGrsT6KtVf8CBFX5vyF
3032	fee_transfer	1683	4000000	1	CkpYr9EWDuoGvxgEsFujz3GyRgUP5w3LSRjR9zkxZAgdzSz4qLAmW
3033	fee_transfer	58	1000000	1	Ckpa2m1rAhJSHqHK5RoDmDxid96VsZS4kMHcXprHZbf1Cj35ZKAC7
3034	fee_transfer	1688	2000000	1	CkpYwZa4dWW6ERok469rSUrsoaV4aaQqmnLHx7u1RaXHqWqVMhogj
3035	fee_transfer	1691	1000000	1	CkpYt4sTD3rmg4aEfNqTZCDvTshY1nBojLP2pesQfdhAR2HvdKfya
3040	fee_transfer	1587	12000000	1	CkpZmjyMgERzp5JH27yhak7kMZBFUpsUtPvjd3KGZc2okFYGuqHpv
3047	fee_transfer	1439	100000000	1	CkpYnaj17yJdDApdciVwUYJJfNGjaLeGN7WiVTAwEm6J8dmRvMBdN
3048	fee_transfer	1786	10	1	CkpZFdMSgmtgntnf93Nwf6AicaADPQRMiCzTUt5BKCweKW4hkgVvp
3049	fee_transfer	1439	92999990	1	CkpZdL78ynDi93eKFRLydTNTxXPwDgNtYpuokSeFurstz6DRYVYrp
3053	fee_transfer	1696	11000000	1	CkpYUBRSrQVdHy7P6Dh5HwszD6vVBi5KNmpvqbzzJfWSoBkertaxX
3054	coinbase	1696	720000000000	1	CkpYSLmipbnGqyX2bbv4Lf3nkfrfiMSSNAa8ZqXM1UcVfXKx3HpQs
3055	coinbase	1689	720000000000	1	CkpYrZAPmCjubgXqfnqTspAr834EAzWDjv5UgXXLDxbgFGqVowsx7
3056	fee_transfer	1689	4000000	1	CkpYeY2M3cFVtY5CwLLFS4T9JsMp6f4Uax7qs7i8ChThYAtjXdtD6
2941	fee_transfer	1594	1000000	1	CkpZkA4iUoCcfeC6UermTy7Bx8WLVzXfxc9iYvtdo33fGuyyFDHZx
2945	fee_transfer	1764	1000000	1	CkpZL6CkgRtePC4LKN3D6ZSEut2xtHKbUwBrApi6UsS6Ke8eTgV8C
2958	fee_transfer	1746	1000000	1	CkpZ84WPYsrPm6BWZ1FkjrSZyWEGmF834yfay1xQGfpSh1PQTE6DW
2961	fee_transfer	1749	3000000	1	CkpZ7dLoYxr6hTVcz185yMST5Xmm3xw29WqAzL4332EeAnpTBoqSM
2965	fee_transfer	1677	144000000	1	Ckpa1tcEA75CGH7ac72TuqxGnHgxsC6n4ibPzcK1u9WkN2RJbciYL
2980	fee_transfer	1513	2000000	1	CkpZFUyoB8Fv754F8vBwTUaoAa2Gz5fHgdwfMjQHjs5ggAiy2SzBt
2987	fee_transfer	1448	2000000	1	Ckpa9uPzGs249tiQgGmCoZmssF6BsDjpFqeYDfGUQAZSUkGnuQpZj
2989	fee_transfer	1692	2000000	1	CkpYv7kSPYg7ed4ZTaaWqjo2rmYW3ViuTRX1idHyqEDsL38kepUZo
2997	fee_transfer	1474	1000000	1	CkpZBXTqZjTjKmYR6abKhKVqZsQTBgVJc6Hrwu5WvNzrMyorRPtnZ
2999	fee_transfer	532	2000000	1	CkpZaDzVeJpoG9E4t6v3e3NmN1tvFkxiFuwVvpXBbrJxEvu6gzten
3010	fee_transfer	1694	2000000	1	CkpYxcsPJW4GjQPbWiyW5bo4faUFLyY692S6RzBcHRbf2G1MMMpwy
3013	fee_transfer	115	1000000	1	CkpZiZZnDFE57bTA3DLjhQaq1kLmrHFVw7S9SAFWB6zd4RYbKTxMy
3014	fee_transfer	532	1000000	1	CkpYQKemx5SwUddcdZNccuHkfQmLz6Bq3uH8mNkCCwsufb4MT76wZ
3022	fee_transfer	1422	1000000	1	CkpZ9uayqu3M576eqpLBn4ffb3oqm7cfCq3i3xxR5jXmxbyChDZJS
3027	fee_transfer	606	2000000	1	CkpZUAygrUQykehA5j7LZYUQNGjWSDfV6hx3c9ZVpi6HvEbywEkqt
3031	fee_transfer	1637	5000000	1	CkpZbxesYPEu9bxf8QHdZzFJPitCA6X5qh2Rw9FFVwc7fr12RAo4C
3036	fee_transfer	1719	11000000	1	CkpaHag5y585h88KFo3Fe86AxyrriKtEuErdMFfBJh8USL1dvBE6t
3037	fee_transfer	1992	90000000	1	CkpZLkduFSxXeELjDpe3Jdsxd5Zc3v4PtWBu7mcriRTSULvPZpN3L
3038	fee_transfer	58	2000000	1	CkpYsJr9qyJcvi2hqb3EDRTDGfML7TNFgY68ebiajQvoBYAGNRQZC
3041	fee_transfer	1654	12000000	1	CkpZixdTRL6N8XYQXnMBmrLMdzsTRyaYSx9a8NajWqAxcVRkG4j6Z
3044	fee_transfer	1741	1000000	1	Ckpa7FABjZo6pKQ33n5UH9VuyF7LQYZBg2tSdWwGoiq2qbMHU37L5
3046	fee_transfer	1657	12000000	1	CkpZCmfWYXM38p38Kdzk4USTCUE3emi938hSwp22yNdjzTcQphuUr
3050	fee_transfer	1696	60000000	1	Ckpa8vgC67Dxs5aRW7oaCmK6K8kCx3VTqoNQRDYEuUNFise5Kd2sP
3051	fee_transfer_via_coinbase	2052	1	1	CkpaFK5vyLsQssc8m4vznii2FYRHXvKgHPjAfbqMUDN1n3kqW6ZXQ
3052	coinbase	1696	720000000000	1	CkpYTArjnijaujfvyKyBYVtXp45PB2RWFvrKgCR21RpSw5P9G7evi
3058	fee_transfer	1643	1000000	1	CkpZ4ewKF8NibNC72m6YUtVHjSL7SUATEApbJKQ4fKg6de5pMGE4N
3060	fee_transfer	1458	2000000	1	CkpYisQ8PTivuAN1jhhuzZCKZZAUy7qpg2jELeESrzvyofJhTvwBy
3068	fee_transfer	1709	2000000	1	CkpZFGNdunCt9iB4uiS264PZpJek7C8kJZTby639BmhdE7GbfwCeJ
3069	fee_transfer	1599	1000000	1	CkpZwKW5vnQhJY4oXVLCcNRd71RPUB9yRSAhKounn1NYPX6pvGw8T
3070	fee_transfer	1506	3000000	1	Ckpa14M3Ystx83cLeqLyMsKfqXqo6yc9wWsNA3BRRqsheVW3ZFAJu
3080	fee_transfer	1593	20020000000	1	CkpaBxh9PfB65atPi6bnFtRvsjsAYrJjLqhKPjCJiQh5yjjx8Vynt
3083	fee_transfer	1610	2000000	1	CkpZQXyZoGpdjgpZKAjmUrFSMBhPbVrm6u5cgJxhQPJ84j2tNboja
3084	fee_transfer	1549	2000000	1	CkpYkJQtg8GLt2akxZvc3UZg7347ELo6Jutck7muudzzXAZtrEgnu
3087	fee_transfer	1672	1000000	1	CkpYj3Rv6Fuf8UBsRshrF22xEgNysJYUpQrF7QL3gUWeAcC52aix9
3090	coinbase	607	720000000000	1	CkpaCf3iHe8re4GtZoDNR4ZgdyvNj88UWdhddWwQNmZVXUnKf8WCv
3091	fee_transfer	607	1000000	1	CkpYTqWbiLMjKarZq5FXzpbn4GNdCwJ5Q8hBYCeu4zE2qL38ETy71
3099	fee_transfer	1522	2000000	1	CkpYmCpVXV296u8EvytTxYfKHAJGuTqoCduefpDi5AGACX6YkrB2w
3100	fee_transfer	470	2000000	1	CkpYRDyPMT2Y4KXjQMmwdHvfYbEd4e5Uym2BTDmKa1ru93oSsPPF1
3103	fee_transfer	641	6000000	1	CkpZ94Kps6GpMttjba6iYVVoHg8jhDzsYZuhuuWuUCbP973ahJh1p
3113	fee_transfer	1422	3000000	1	CkpZZD9ZZ8Tv7Su9hnGDfs9fZLorEXYyrmM77KY6dFnsGK8xxVDNv
3120	fee_transfer	1440	65000000	1	CkpYXQX4ticDe5agG8xNLKL1ECs6jjd3pdeNjLkt62Px9sXb2Ww8X
3121	fee_transfer	1440	6000000	1	CkpYpV6K6ZwgjvbTj5PADK2MzwQgPs4DYgiwCfuCwtMcNMGoxhNDn
3122	fee_transfer	1440	20123000000	1	CkpZZqgL1WFaiuBxb69ro3rvNRH8tp35prbf2rs7AvfyXGmoY2SLG
3124	fee_transfer	1623	4000000	1	CkpZ7BioSeiTUkz1PGbeZUsY4Sc8TeBAkcbseoB3CBMBJ5Qw86y7e
3131	fee_transfer	1649	3000000	1	CkpZCm3pbXvJimL7TwMtAyPHVUkHn2yajXkAtQg4LuEv9o9j1uTLw
3134	fee_transfer	1727	2000000	1	CkpZfzcrraciWmQVJUAQKueHxBV4upjq1v2kS275wXJ8ja3zREEHk
3138	fee_transfer	1556	52000000	1	CkpYnhb5WoRtBbbWu7ivAkkHcNhVZywNZiKLqWbZMBwzyUD4Ttj7k
3140	fee_transfer	1455	2000000	1	CkpYfKDXPxnoRVRbN8zDXfKhko3YtHxd8iZGvyoe998fCjkzxtcCf
3143	fee_transfer	641	2000000	1	CkpZQZpXLkvQAdFFxSZHh25nSKxt5p9457khF6w8o88YJ9K1KxQ6T
3147	fee_transfer	1716	1990000	1	CkpaBBpy4f5fnhE87xU7upM37t5Jjwmf4pzjFC3pYgAwD1S7RBo4K
3150	fee_transfer	1610	11000000	1	CkpaFcKyNu3DVJtTB7iuUB8CpHSRjRSanN6KGd69oSkiF9EbHHXMh
3153	fee_transfer	1623	5000000	1	CkpYWjUepvh5V71m5B97pKnbfAjes4NCkH41aWYGjCWxd5NdUF8Qr
3157	fee_transfer	1622	3000000	1	CkpYfVK2dmp92BemZrUyhQY1tjB9eRenWhNRBDJvryfXS9DvZZCvf
3162	fee_transfer	1593	84000000	1	CkpZZV5d59cKqbg4zMwfv3KQvGMs3wQqZZuVaJ44Ej3vmM3P2oaHg
3163	fee_transfer	1593	45000000	1	CkpaBS6v86hDpYRtfTJvm5JXRV8wrRGg2evYUwBcJPtToh529aix2
3168	fee_transfer	1426	1000000	1	CkpYXpPeAZVoCSz9jt7xtazo2cRnQPmeJyFx7a9tRAEZfwDQ8arD3
3169	fee_transfer	1683	101000000	1	CkpZYtqiXWanpbuY6u2oQ6Z42uUm1r8FsQHyepV9gaqZWq8gouNu7
3172	fee_transfer	55	190000000	1	CkpZkiuYe6eExCmNQcfsiWL69zG8ctSux29UMahB2EYrYHPNAfgyN
3177	fee_transfer	1423	20342000000	1	CkpYo4JfcSJm3jYiScCbLXZG8BRDBN8qybwMbTD8BNEJiAnZCV13g
3178	fee_transfer	1423	12000000	1	CkpaK9z1tjdaJaCzdkuSJheRWaLtHPBeSo34Yi1tmnQH8CwYGcdtT
3180	fee_transfer	1693	2000000	1	CkpYmvfjUVHPxAdFAqvcikR8cGpXamSumP2DEFXCMVW3zo3p5SiJk
3182	fee_transfer	1513	3000000	1	CkpZiWrrYyA1ijuKv4svPkHSCGoX8X9Z9ymhtrEoTd5MrqNG5W1DG
3186	fee_transfer	484	12000000	1	CkpYXNh7bvbLE79skrJmGWudPf1pqav7EfHRWvCUv8j1XixF4DYKG
3191	fee_transfer	369	3000000	1	CkpaHSVxXPrsFfHGNTHbkfVoUET5bLagMy38vYKki56eWQrKxPMxo
3193	fee_transfer	369	312000000	1	CkpYgzxYNo2P5UVBqNcHpp9TnBwTgnCP16RqcJ8aoehZXQd7LTN7s
3194	fee_transfer	1799	10000000	1	CkpZF4hhukoyN7VUYLz7vt2jUuxA5VL4xwhYhBKH9VateiepH9QPE
3195	fee_transfer	1420	99000	1	CkpZqc8s61NghH4BkxdXeb3TWgnxbT6ATN4RVU8SuoRUcyNBtnxA4
3196	fee_transfer	369	93891000	1	CkpZaqexcfiNK27Ra28NraGZaorWsgXDSmbFcqNuxRJHr27tfLMJq
3198	fee_transfer	1988	20	1	CkpZW6GEngKzHZ35YnyZwuJpPvkE1D1DTLC7NvFGZnpBzT5Ykb1Ty
3199	fee_transfer	1447	9000000000	1	CkpaHFU5vDP36s3CM1fsMBpdd97Ge28kX2ryPkUKELxHPyJtGARXU
3059	fee_transfer	1564	1000000	1	CkpYTfCh8AtAAKJDLee3nnJDMfSzNtHTy9mWVda9cV82ZjqWNDwWJ
3061	fee_transfer	1458	453999991	1	CkpYaXfqMSskLUu8HwUXb7rKoDRoPUBncnkvgr4vdFKCqGN2k3pL8
3062	fee_transfer	1458	39000000	1	CkpaGQTHf9LzaeiArg13NwAvBJupefBovTJFrQtp9KCySThFms3FU
3065	fee_transfer	576	2000000	1	CkpZKTq3o99sF7Vj7YCFG2biLixvRH6qMDoRPycq5b5kSSFLUh6to
3067	fee_transfer	1693	241000000	1	CkpZXrguT8xe76GhV4AkVtHkCnQ1NHZBZ3gRR5hLApnEWzmgmebQt
3073	fee_transfer	1657	1000000	1	CkpZRsPJPi4Uuif9Asn73TfbwdZVmXNAAvqnSbwZ57B1NfkewgqnU
3074	fee_transfer	1689	2000000	1	CkpZdhdc9rLBDKUR4EJKmsqaYLcJL5ubeeRyKRvycC5Uj4uioxotg
3075	fee_transfer	1688	5008000000	1	Ckpa9ScoV6hw62UckGVkd5nr5f1YVSAksHZHLoXbykRcEt1FXCoct
3078	fee_transfer	1458	19990999992	1	CkpZdc5Tg8EZyCbAu9yJDcP5U7skBcKaLYYL6PpDgKUoZyhaKfAB9
3079	fee_transfer	1655	25000000	1	CkpZyPRJVsFgBBG12Ltg2FrSRyQVJkCwkRZvWMq8gjm39aveQimHi
3081	fee_transfer	1649	4000000	1	CkpZVcAb6po5toLtEfZaoAZwRocgH5EZtpMgF3gMZWkw6b3J4zsYj
3085	fee_transfer	1560	2000000	1	CkpZMgwRjk13qbCEYKfwtdtwNpXBeeVpayyN6esaKsDTRLE7SCFcM
3088	fee_transfer	1702	2000000	1	CkpZMe8GqkFYYyTXPRo7VhdrVfNMNzHviQouUiBeA9AoK48hsyZDQ
3096	fee_transfer	1678	1000000	1	CkpZidsgS2Kxv8WFYrBrZ1rjBB5Qrkk31A9baxbp6iq89Fwekwpas
3097	fee_transfer	686	1000000	1	CkpZ4Jn5h4SbPb9WqpN94gZMmdUpsgNDKk77SpLah2DcNNqRTrxY9
3109	fee_transfer	1710	2000000	1	CkpZzk4w7kzbSwEeyfoAZVz6yCD7MeHJVPbQEtQb5m9U7VhPgn47s
3116	fee_transfer	1419	1000000	1	CkpZnhpcCUK7bZV4n6jHhGhi17AcMqMMRRMa8AspLK3envMgUXHqU
3123	fee_transfer	1402	4000000	1	CkpZqt1CSE4dNywESa63sB2suVWwzcezTPZZs4zLqbZFFtHSAeAMD
3128	fee_transfer	1699	1000000	1	CkpZCXYahgnei4LfK2QdnbiaYDzDE7JeJzo1D9gyahEtNKP7mptYZ
3133	fee_transfer	1675	2000000	1	CkpYkCDsMu6t6KNuXZS5MZSZU7LjFdXzqewk3zAAdMdTwr5VqEw1j
3141	fee_transfer	689	1000000	1	CkpaDsYwH4TLfAXomLDmXAMA7LZthH9UWY5oAYt9yn6PgA54LUYsg
3155	fee_transfer	1596	4000000	1	CkpYzfSkYrNYFKfaYYLvdCU79Y4oEsmphtYmWcQjsMd5WRkKqP5ng
3161	fee_transfer	1426	4000000	1	CkpZyqh9XZpbg9JKEjcye76NLJRyanR7cG8ne8KNCtRLmdL4UT5PA
3167	fee_transfer	1518	37000000	1	CkpZEVAJT7RGTHGLjYLB8WYgX2a9owRBRuXuWtcS4gYFDNm1mKSd5
3171	fee_transfer	1513	1000000	1	CkpZGR8u8x62e6eVykPgkjCKrJf5m4V9rPiEdNZ82M8zdwUbEFSgn
3174	fee_transfer	301	1000000	1	Ckpa95igpGPfMJrotMf28swXqeZnxzv8cagXyyGRPMsEBcKfzzSrJ
3176	fee_transfer	1536	2000000	1	CkpYmEix8zVXc7yMk3Ls5ExjdYd4Th1idNTXW3DQvY6GE4EeYoavf
3179	fee_transfer	1457	2000000	1	CkpaLPed3DGfJLYeqi3qEZS9v9ex2ucMwdDB1xUyewCrtsxwVBDLd
3181	fee_transfer	1549	3000000	1	CkpYm7ncT5x1RVGMxqmDLNWSkrCazqWGSfUpejReMLAv5edBjR5Xf
3185	fee_transfer	1992	32000000	1	CkpaK9fcd2aC7a1K7Ryz85oUoyLYbW7kPJwjKKenZddKcX8pcP9gJ
3189	fee_transfer	1686	13000000	1	CkpaBoY6YyiQqRGhZorRKkWdGHeLt679NLTmzBT5mFD9KJ6zZD2rW
3207	fee_transfer	1991	1000000	1	CkpZrArsZqJzrc6skSwQkPYHjDpz6yfnP599yGpnjKbfTMeh5djsj
3210	fee_transfer	1458	260000000	1	CkpZHifesLxW2M1GLn72FgqKJciJSC7pFYMnHpTcxiKbHhCvvxRc4
3211	fee_transfer	1458	80000000	1	CkpZ9mEeiX7h2kY93bMuwf6rwcqJu6FZ8pTTMsCThHxvoaD88F3dM
3219	fee_transfer	1522	112000000	1	CkpYaQd1YF4aWSMqU4rf12yY1g4WDBWWrpR5gJ3rAmxrFq1wgxFCC
3224	fee_transfer	1980	2000000	1	Ckpa4JfMqF9ne4hsCekYneWPan8Csv4VVwCTYCeD6ipB3pr3rnCCT
3228	fee_transfer	1447	2000000	1	CkpZ3rheWEFJ4dtGEqag2jMnhAfCjgdaVTbQpTLWm7pn7hgEvXas3
3229	fee_transfer	1679	4000000	1	CkpYRwALxb9t1VZRxH4jxvKRfk5Yh3KTj5G4FjW9BLygKvemo5wkv
3238	fee_transfer	1439	2000000	1	CkpYrNH3KdKzMLbXpw4NAi4r81y32Hqhh7UNHCDNy5d3mr549MUBQ
3247	fee_transfer	1688	3000000	1	CkpZGFsSLnq172CBdCbw1hC4CtZomLRmV1kfQrAQQYrMwUPkv1TPz
3249	fee_transfer	1518	3399000000	1	CkpaELDFBd6YFb7Tjhsf81ZAAuyQ1q8A9JZLyajKgxDdxN81GhRuA
3258	fee_transfer	1447	4000000	1	CkpYbooDS81CrrKUgtyHP4NwMDVBTQK8FXGXWXaLbnE32S2QFS9KF
3272	fee_transfer	1717	75000000	1	CkpaCsC8EPD6UJCUViW1BKGFraGAASvBY8829Xisz8csH2hM9hoMj
3063	fee_transfer	1546	2000000	1	CkpYmaqGXucVrtyeudEu7nrm93DhFqGJX4s5uTLaNpfbmuraHZJLE
3066	fee_transfer	1573	1000000	1	CkpZvCb2f6VUagkq8zsUUYYWeYgChmPtKQFa3MkF9e8P6bSxLBCZh
3071	fee_transfer	1673	3000000	1	CkpYnvfkn6AfnDpJ1yD2Qf6on18tP8gBDiRCLVhgpAmoGJSjUN2de
3077	fee_transfer	1458	20005000000	1	CkpYaHNtsesez19wsbGfa38KggL7Gu2CmpZwfp2z3b4EfqLJCiHNq
3082	fee_transfer	1684	4000000	1	CkpZ579kEEbS8yWt3KE6wGiiCBXnDWDBsrtpFsqBdoBBu98KefcBa
3089	fee_transfer	1703	2000000	1	CkpZ3qLnbMdqKX2151QpAfFFWrXS8rtobkhSBYMkY6zmWnP5SoZoa
3094	fee_transfer	1555	1000000	1	CkpZ5n2npb8ZUh3Pn9dhaesmjT8KMGLgNY94ZoBBdFT1bRXAtUtc3
3095	fee_transfer	1675	1000000	1	Ckpa3uQkj48SUPbf1yhbk6UVVFxMMGxodMUPLacK67TCDNfXUv4Pw
3110	fee_transfer	1718	1000000	1	CkpYxfk1Bg1RLsfNtYtYk3PbhiRR8NPpWUt88McSxqAGPFcg2M1Yw
3112	fee_transfer	1719	1000000	1	CkpYu1vKfCMm95JJ9TPhTFNsmYXo1PKAg3Z46rmbZrSMwHXQNAfsN
3117	fee_transfer	1522	1000000	1	CkpYcWdMv46Dh81aBVCvxKb9mSLPi8vzhACPcXBTv8XUnGbAFkGgn
3118	fee_transfer	1637	4000000	1	CkpZLytyquQNaPVPuKyBgeHfjLqKNj3BsT7rEkrucJ74xQLUdKCpR
3119	fee_transfer	1671	1000000	1	CkpZFXHtPDbpZ8gQJxo4FzMemXd3ufrWGXBU7haZ9RGmuM8xVWShw
3130	fee_transfer	1547	1000000	1	CkpZZ4AGstAJLZKCcusazuyGTXphbd1MJKWVfTK1huGruSRZNDJVc
3137	fee_transfer	1556	2000000	1	CkpaLaPaxg7NagfrtJHGXtwVPJVAe31nyxiSuUCTDqL4wz7VUD3JQ
3144	fee_transfer	1698	3000000	1	CkpZPBYetvqZf3j1R1UBdv9Cmkh7B1VwfFAZJ7VarLgfn4Nq7Z27s
3149	fee_transfer	1768	1000000	1	CkpaBWMRgcgXWDAveqHkXsVXpiNb7n4gkKUgNYLxZGySaHwPjUsnV
3152	fee_transfer	1705	5000000	1	CkpZrpmpRMnUYkA44CWHUqSX75iXoFfLGcCrBQoWjXhmyiPyeeadt
3154	fee_transfer	1677	5000000	1	Ckpa12p64d3z1T77EQKVFckco9YdsJZaKqq9514Ky4jjmeNACBekD
3160	fee_transfer	1729	4000000	1	CkpYr85nQjAEgVNC5EgaBCBe9Cm5ZNNo4hvPvHgUjF519p3sP7nPz
3166	fee_transfer	1518	3000000	1	CkpaFd1cwBzbDCt3iL5Fkcu6AmQRenPkMf14LxGn8Y12mo3Hw4uvA
3173	fee_transfer	1683	12000000	1	CkpYt569LAVqaowLSv2EK169mgWMWE6QndN9Ed6PHwESEdCk8KvJB
3175	fee_transfer	1423	2000000	1	CkpZhkLb5pg5EHKcW8bBrwjg9S5XZrdkj3b6XMBXdcgtjhe1w7YXS
3184	fee_transfer	1715	11000000	1	CkpaDL3CDFNNZzpKu9kpUvJxq1HqJonRkgpVdPuNJXJcpzPEYyHdF
3188	fee_transfer	58	13000000	1	CkpZGRVrm7BUHrgJWUzHw31aQaUR9Vd25zW2jVrJoPoPmrMz7quR5
3190	fee_transfer	1686	71000000	1	CkpZDSdTfycwkD2DUovV2LLT6FXjooVam9xaft9MsYU4VFqHAwvr4
3197	fee_transfer	1696	1000000	1	CkpZYKBRJks4yQWYSfom1UN3N5LQnXtWxyeCM5NxQdfJcuVwNJ3bZ
3208	coinbase	1520	720000000000	1	CkpYvkyc1jmnrhXeC1NZrGri7WVxjoshqmf7ERQ98AbupVTGXYLrR
3209	fee_transfer	1520	1000000	1	CkpZmBa2prkqwMgxt6kiNATXwGVJ3qgVnTrF4NgfduridydK3a2K3
3212	fee_transfer	1623	102000000	1	CkpYcpCyhif9WtwTL3RXkwwA6tZduQk5co8xQkPmb7B5uK39sNtDU
3214	fee_transfer	1672	802000000	1	CkpZY55aJWLXw4dvVLi78EMkVSoanV7XWu8ygLkMDxmQoyW5uU8rP
3218	fee_transfer	1419	101000000	1	CkpaAEah45fDSJj4EwxrPo5df91SHeWdwSstcQFchknCuxiiJJGgb
3223	fee_transfer	1560	101000000	1	CkpYkmod8qMRgKxs4EQB7zRPqaHg7VRRxur7iHmdggTiX3V1HCpA1
3225	fee_transfer	576	1000000	1	CkpYqD7t8Gfie5AhEbnQY36iXbBZqJBaKgE8wMNp3ssWTvkKcf2Zg
3234	fee_transfer	1692	1501000000	1	CkpZjqkZ7bHgXeVJaAowFzJ3FwDWC26oayFwBz3wtQTtYH7qeuoVq
3235	fee_transfer	149	2000000	1	CkpZodynZDDGadVqmW1nWg7egmBADPA1QxprNAyfhrhw8W723cLX5
3245	fee_transfer	1708	2000000	1	CkpYo8WWbAYAUL5aFh5x3ugc3T8Zv2vJtfGnGNi49CfNtAVsmyB7a
3246	fee_transfer	1991	3000000	1	CkpZPnycGGsAX4fPGVaL2N8R5KsDNUTtw8rCopmQqs2KorszXEN29
3248	coinbase	75	720000000000	1	CkpZ3oQynB2Npvm5NRRVWSbdEvLYVL5XCxNG4i6kjqP2i8ZvC5h59
3250	fee_transfer	1458	1600000000	1	CkpZLL8c7uPQqWKnKqXpEAdrzt6yM7BnTHxk1hs6Gy57HDa3BaGUG
3251	fee_transfer	1447	1000000000	1	CkpYtpPvuaQC8Tph13ph8fLfeqW5dW1u3YtVLjGFYeLaQrfpczM42
3253	fee_transfer	1546	16000000	1	CkpZkYQyM6ff9wMF5KJTnhLYmi2Bz6MSeo7riAwfU4CWwXqhn3BSV
3254	fee_transfer	1546	19000000	1	CkpZFLUQ92LmT8GZgUpgXMtPvj9fhthWfRvVf96NoTNT8pM7ypitG
3260	fee_transfer	1740	1000000	1	CkpZEWhNnz4dqXj59hSQbLorrT4tqdZZZ3H57YHU156SHGYuVnigb
3261	fee_transfer	1703	1000000	1	CkpZU616oQvkLRF41BRT8Uema4qsoN9yddNsJPJd56MhkBuDQfE1H
3274	fee_transfer	1464	22000000	1	CkpZzDb3NNLQQaZnzeKjHApoUcPRvNiWMkPtMA1er46c3KSXYuGr7
3200	fee_transfer	1696	10478009978	1	CkpZKCUPcPcY5L1ykUhc3M9ciCYLsPqgGNBQT9TJRBvJevexG3Dma
3201	fee_transfer	1996	500000000	1	CkpYYVnNK1xttpWECwUJrC5vNdetFxyPKUNSerKoqce7ZTVWmAWkz
3202	fee_transfer	2052	1	1	CkpaFK5vyLsQssc8m4vznii2FYRHXvKgHPjAfbqMUDN1n3kqW6ZXQ
3203	fee_transfer	1460	155000000	1	CkpYopP4VcXACjL2ikVJS5UDzFy6F8jsWvnjmUPmoXfyg3BMVwto4
3204	fee_transfer	341	1	1	CkpZqs1gsC1dGjB5RuwNcenmbXwHcVhjfSTugyAHibs2dDwHn9jhB
3205	fee_transfer	1603	1000000	1	Ckpa7at3vaQWNHMDvdTdHQYAEAwoJPjZRB4VbaFoqdS3xHiarYeDS
3206	fee_transfer	1692	142000000	1	CkpYdMuR2pUvpuxgdrV55Pv4nKiFQY7PY7WsHxUVrUNMWDxvU8vii
3215	fee_transfer	1677	202000000	1	CkpYfkXZCwxqDWiJE16CDKpe2zZFTJDK9fEGQcD4yrLbigEoZH1gA
3216	fee_transfer	1690	101000000	1	CkpYxWoPcKW3RF5u2fdHQwhRuURGQQPHec4dkYCj2wgU1ANNdAdVU
3220	fee_transfer	1596	101000000	1	CkpaJPZYVU2VAAcqZ7K3Et5A22oBB5uuJMXtwh3PKwpTUsJa3Qek6
3226	fee_transfer	1686	1132000000	1	CkpYWyTXVnC24bDNJpqbiMqDV62ibMSVFcywoAapzKwcfjcRQmsym
3227	fee_transfer	1686	5000000	1	CkpZ8nnRmW34QLkcUocBJNRXmbQXj66mAba1d5pRckp2tppbVrdPv
3230	fee_transfer	1768	4000000	1	CkpYgWhomSV8jnAs9odxbQWtJ9SPsAFooWyNT73uELix62r4FJydT
3231	fee_transfer	1422	2000000	1	CkpYeUrDEqzS3cocnbdUMDtDaLpa1BZWGcWyezqWG9fDz77cqYnbW
3232	fee_transfer	1991	503000000	1	CkpZJRtWpJY8eDWZMNs7bWNcnS1tkx7DRz9pZP4bH2Y6dvYYEXgwX
3236	fee_transfer	1759	2000000	1	CkpaDAiefTZ6sypGTsEUEn61xhBzXuTQimmK9AL6Z6CSE1Foqpf6u
3239	fee_transfer	1439	3222000000	1	CkpYjzznSDuNGUSvyk6H8ybwgtA1ryBGGjz2J3EhM5uSgX24cUt7x
3240	fee_transfer	1439	64000000	1	CkpZgWdxXmkjL3S5gnxgARq3PQRUuhbiTVGEG73k9dx3m7oNtYBVS
3241	fee_transfer	1455	1000000	1	CkpZr2eVdugrvs9ie4MoDoLT1DkTWoyATJ1y9JhkxtkLGy7q2ZzYb
3243	fee_transfer	1587	2000000	1	CkpZXm3u3sgVGyWLUKXHK9iVm1yF9caP5yfKyikCoZStxiG7RG3rU
3252	fee_transfer	1692	61000000	1	CkpZ2aCzfaC1q2iWmnt4i8RCLWZbqHhk2GSnA2sJF7SDxgtPg8yco
3255	fee_transfer	1422	21000000	1	CkpZ7MxU7zQLSUik9DNT7UNksu7K2pFpHLfUeDZxSCywPpRhKh9ya
3262	fee_transfer	1702	1000000	1	CkpZri9NXJPr4KvQrU97shWVUVQbE6yZWrUE47wGa573L5sJzfqMh
3265	fee_transfer_via_coinbase	1527	999999	1	Ckpa6J7EqmaDmUbcuamooAuWsv2596tSsAVuq3ypcoFskEdnNq9wR
3266	coinbase	1688	720000000000	1	CkpZY6yJMy2VqmMCjE7bTq1nnuGqrJ9ZEFVubtqwPdnBRp4rhHtUv
3267	fee_transfer	1688	9000002	1	CkpZJxKyPoykpS6rCzjjvdfTNgC7gQuNA8rRZiuptUfLequ8f7Xs2
3268	fee_transfer	1527	1999998	1	CkpYU5gUEy7vSk6FuhhkibyZdzy9RuLhNQFRYKYzk1xnNe4HUS5a9
3271	fee_transfer	1700	45000000	1	CkpZ7tPTStc8AYPikfyvwhxe62xv7aLCjfVPdP5di4i8YMv2mgaoc
3221	coinbase	631	720000000000	1	CkpZf8gaxuq1Y6gPi2HqLknzXn9Zt7YpcEFcNDPZNeCWYnZvU32Xn
3222	fee_transfer	631	1000000	1	CkpYgqY7e2qT92HcifE9MRqBiumhpSpcXUGn7FjP1uBAn5X9arHVH
3233	fee_transfer	1723	503000000	1	CkpaFRfvGDjbm5tSYScg8rRuTu3oCV5LRXabf56MM4D7U62fkEgh8
3237	fee_transfer	1594	3000000	1	CkpZzBR6pB14Rb66UVRXu3yZAsPS8xJjwViuKT1KSKRjMrMVkZBdz
3242	fee_transfer	470	1000000	1	CkpZtPnmbKtScheNk3V6vgtfMtN48gX9cb6oAStmxPAXdHpWpCAFE
3244	fee_transfer	1451	2000000	1	CkpZtYMiNfHUPeXz3RX3GJtFmB5Noedp6on8m8mJPWn64Tx2GespH
3256	fee_transfer	632	21000000	1	CkpZaG1jedvQsR3Wt5JuivnQCjsNiGyBXZv9b8zJrVxta4oTKKJ1L
3257	fee_transfer	1759	21000000	1	CkpYU2kd3yPtHQHkEhZmS3DwPc7UYy7ouLV297Vj4EvXAWoppjjXU
3259	fee_transfer	1690	4000000	1	Ckpa2NEK7Qa2aQJWdzunLxZdzJvWwKk8VR3nit4eifeSsaneSJP3z
3263	fee_transfer	1689	11	1	CkpYxRNK1LZ7nxWa3N94fwoUaNNg7PQdsoMqHumexkLP1xvxy6q7H
3264	fee_transfer	1527	10999989	1	CkpZYzHSAXzZasMPURu2nkg94jEpLNVCo1rLzxw6Pk5no4CFYKDfr
3269	fee_transfer_via_coinbase	1895	44000000000	1	CkpZnxC2N2bb9KV46G6dEUFmP6U4XjdeMNyvx7EnRdNCveffFxMyw
3270	coinbase	1700	720000000000	1	CkpZKcnBRvQc9zYA17Hfqd13oRznUb6dtdyCxKpecigubaqZmUVs2
3273	fee_transfer	1549	22000000	1	CkpYhpCRGt1UmS2QEz23yz7VKZbaU1jAXAAcXuYBqYfHP9pbQHYWu
3275	fee_transfer	1455	11000000	1	CkpZw51hXK9xEQFFLVKddQJfQw8bF3DgaCCCCzmgqjRZYHrpuSYag
3276	fee_transfer	1476	33000000	1	CkpYoGPwbcaciuWUVoYbVufyyiDiCkjnGsFFA5Xr3Qf92gmZTTf4W
3277	fee_transfer	1623	33000000	1	CkpaLZ4dGcESmhBfDSPns3TGcFMNKKsqbtUMQA1wDEDG8JrKC9diN
3278	fee_transfer	1633	21000000	1	CkpYTyEA9xBkLDJjEg4jWXQVWNsaBSCHuhbdh4pDQ3m9sJFBPVq7N
3279	fee_transfer	1605	1000000	1	CkpYtJxifSDihZVGruGBGJQ8cVwW6PNZW8d2g6AzHTcFNhiTqceCK
3280	fee_transfer	1709	23000000	1	CkpYt29Wt3pLzPJriV7WRMZeHrVuEkBLHkSJeQgP7iRWtnHyT15R6
3281	fee_transfer	1610	22000000	1	CkpZNzvfVvzwS9CT12RDEUydxevQfeHuNGKwbZbBDgRr8VHTpbBFD
3282	fee_transfer	1615	22000000	1	CkpZsV7ZFqpEcw1qHwDFYBknZ7jhhQbBG6kG99K3AQ8p32S6CrvNB
3283	fee_transfer	1588	23000000	1	CkpZQeKhp8fmLy6HcCLz5qsxk72n8EBGxoHoTwvJrqWX6im4TUTTS
3284	fee_transfer	1467	23000000	1	CkpYxasSBKmw1AUAUW6eb3EENLd7BZUJBFqq1e7FVex8szvy2S9Cp
3285	fee_transfer	1746	11000000	1	CkpZbHhEqtNnbYSiCo9csSxZ2qXjBF5wzirhjnXysEBBrLtt55FFj
3286	fee_transfer	1747	11000000	1	CkpZtLY8joHJznM4wjWZ4gqxCiRwBbBG55ggrMBNQnyxUMeURXzys
3287	fee_transfer	1704	11000000	1	Ckpa7h6v6D9WHJb12H4VvkvrcZ5s3PTaXuSQtX93aRG32sRsnVscD
3288	coinbase	748	720000000000	1	CkpYowa7keb5gBmMRPQtfbDkxt6DVD4RmUJwdttiSDuKQH2FuTiU9
3289	fee_transfer	748	22000000	1	CkpZvHDMiUXroTemwSgWABw7KGzjP8kbVozj9jyJNZUYiER9Ge2Pb
3290	fee_transfer	1613	1500000000	1	CkpYaV4E82JQos4SVLJnwrw4jcDtiHkT6c3GWWxiD9egaYWhbwBfV
3291	fee_transfer	1613	1017000000	1	Ckpa3aUy5TVk3k8EM1wBPRPqrxJBbRVLkNLmnGzd3fnqeihNjRZAN
3292	fee_transfer	1613	33000000	1	CkpYgLAN8C6inTcJttqvLko6SRESafZN2qYTaYqcyb6XZjx5ExfaN
3293	fee_transfer	1419	22000000	1	CkpYuMyebrQvSBJpetwBTqjRofudNDPpQ7Epxg7acPna8bCo8PNbZ
3294	fee_transfer	1675	22000000	1	CkpZ6xFik9emEasyweS4rmRGTANYvaTNavm9VvhraFiXERAwLyZiN
3295	coinbase	300	720000000000	1	CkpYcM4ji3TomyvQwuWTruzZhwoGDG16JUv6btyCha6BZ3NCiq4jm
3296	fee_transfer	300	11000000	1	CkpZZJx1pD65jTyDBnJxfKSCxHaq1EDudYEAFNVRGFVWMAnzZMzoc
3297	fee_transfer	1701	11000000	1	CkpZwEa1ffxsZkGsk8NCvcer1v4cdRudTfcrutKZyE6E8m4qQXCsX
3298	fee_transfer	633	22000000	1	Ckpa2xF3yjZ2ZaT8tXqbrvn4wcGqrKfkpkkg9sH3dwgT1jssoCsud
3299	fee_transfer	1686	51000000	1	CkpZ2jTevZTB8hoDZ1pGumxa9QgcijRe9CdTLfjZwgjsNJ2CVD2xz
3300	fee_transfer_via_coinbase	1472	555000000000	1	Ckpa4fz2xmRYPPawVAUmaEUw81VAMVTq16XUErrvMB3SUtzNVyWZp
3301	coinbase	1686	720000000000	1	CkpZK9hPzHGAsAD34mwJLZj6Ctswdv5rUMV4CbWiY4N8FjKzhK38y
3302	fee_transfer	1687	15000000	1	CkpZ5t4ZbMxs2Qz9rqfAwM9hAY3Znjz4SaHARj7Y3PdwQhUQciMPy
3303	fee_transfer	1692	15000000	1	CkpZyR3sD88H2h1e3J4yaqhWoJxeL6hJtm2FC3745xDbGcLGK3vUA
3304	fee_transfer	1723	44000000	1	CkpZoN3GjSCLzKfXuv9fBcGuTPg3GuPTFq9vc9JVQPHvtgq7tNFV5
3305	fee_transfer	1643	22000000	1	Ckpa8w58V2nSppJpycM4SdWHAdPsHKSq3XB8jpAEYaL2tihVcux52
3306	fee_transfer	1672	88000000	1	CkpYfzubjYtyRs8Q3goPTDnvVN1WowqWywv5SSw6xj1eRm1M9SK1J
3307	fee_transfer	1672	11000000	1	CkpZjLjA1TQGhpWQYM8db8tBX6JKVnsrmj5oDTfjrGCREXjNvfSNr
3308	fee_transfer	1633	11000000	1	CkpYm81jbjPiFAvKUd7Q2sx7yd9n3DQtxbhNWo5hwwQnfrQYjQ5cf
3309	fee_transfer	1719	21010000	1	CkpZ8aTXeyZLi1AAr4mcwo2gzrJ98HwnCBfc7t3Mqp3vZ1f7sow6R
3310	fee_transfer	1634	11000000	1	CkpZ5vUL4Ak5WSSWJyh7PvxqQDK4drYrmTM4xGYgWuWeYrgCCPbcx
3311	fee_transfer	1634	10000001	1	CkpYToPPoAUsk6ykZYc3fhQB8Vp524JQNHycq9XHWicEvywsQooNZ
3312	fee_transfer	1506	44000000	1	CkpYQ1pvMF2g2GZLafwbACdhFu71xnTWAjiREEyGosXwyAie9JhuR
3313	fee_transfer	1708	11000000	1	CkpZWM5YAY7hwa2rXzEdQcxahr5jrAGMULivGRFfqpvGZW74DUm1p
3314	fee_transfer	1509	33000000	1	CkpZP4QhWENs4vhCfTTZtuKbkybcegBGkzJ5v77m6MKVcZzgvCSh5
3315	fee_transfer	1564	33000000	1	Ckpa59J6sTZuGWmtasknLfc5MJhnuVe1U3oUse7HFx45LFMSf3b6v
3316	fee_transfer	1762	11000000	1	CkpZ71jSyHKNebD2m17vTXro93LuxBwNm5uPHwnVwB3YfaZ2maUoK
3317	fee_transfer	1740	11000000	1	CkpZqkDtUDXADaGXLXnnXDFBtseUTAMW1WXXxH3d7jKPe5hYSeR7M
3318	fee_transfer	1716	35000000	1	Ckpa6S4Dee3D7L6r2CgdH6xeyRUQyNosjwBNQ7KRiPNhzdpee9wLh
3319	fee_transfer	1764	22000000	1	CkpZtpiYfWDWqW929TNbUJv9Xo9BUKyKjY3YgBRU2CAviDksRC28v
3320	fee_transfer	1681	33000000	1	CkpYRub9ZbPTvPeWG3MTWR9W3L9m27GPoWVdEcd5kMv81kovvjQAw
3321	fee_transfer	1622	11000000	1	CkpZJKsVocEY7PXc9v8eYi3baBwmAkFsuzYZx8Fn5b5p55NPHpuvC
3322	fee_transfer	1509	11000000	1	Ckpa2bYME1MkUpKDdcTEaBnSAPfzeZD8VqSkTsSETmiiN3qbXWYWo
3323	fee_transfer	632	33000000	1	CkpYwMk4J4X4zSuq3GQVsvN62mXQTxuK9cRouuyFGpErafLdJz1dL
3324	fee_transfer	1850	33000000	1	CkpYaGCJQ5h2uKu9bR6Qh8umzAQkP7nypzdw66hm2hkZnKJJPYPJ1
3325	fee_transfer	369	33000000	1	CkpYhx3AMnGm68jxscdfoX42VrWNvYq6bduAevmEPPVeMenFHWKHx
3326	fee_transfer	369	3240000000	1	CkpYve4ZwKDRLC2VzehvQPyy22JV5VbwENZ2mxQ8BftGsfttnk8pv
3327	fee_transfer	369	870000000	1	CkpYhgJQka7iNSEoRvxYJTiXAnLwKSBh5q38KKhzQ4kqDa3sKFKz4
3328	fee_transfer	470	21000000	1	CkpZy4SETPf4pJRVb9oV1RTgCkvbyas3XhaL4Rz4J7TQHN2sL2vqR
3329	fee_transfer	576	11000000	1	CkpYuRfDeGn9ro4WVBcswLL1HQg3AD7b2MnSnp7HiWzXeonWm7psU
3330	fee_transfer	1677	34000000	1	CkpZzPdvzpsC8JVcKw4oyae7YPFaDuWHsuJaqKJeXTtjjzBwz4Z1s
3331	fee_transfer	1692	34000000	1	CkpYo6hBi66BYVZC9aCn3ZbJUXBnUMZgNiTn8cYikZv35tDDwcUFi
3333	fee_transfer	1699	34000000	1	CkpYd4HmrhQLgzTs2dYnsi54qSrDysDgR8FeZZez1kzg8xyydskWS
3340	fee_transfer	1422	11000000	1	Ckpa5y6LLa8hLhNErfA8Q6BCBSCgF6kVc8xPKTQFiMif6qfpCvbVt
3342	fee_transfer	1671	12000000	1	CkpYZFwefSRXnpzMzXXnLUrdYSFw3EAzKDmtXawqCLh2HHUmHsJT8
3348	fee_transfer	1611	22000000	1	CkpYYoaWyEwfwqsoK8DD4Vi2wSAMgeMzeW73jmkakjFHWF9Qt2cfr
3351	fee_transfer	1654	11000000	1	CkpZx3Jbxymah25h8RFc8bW83Pxb4d16Tw6cEHkMYWka1ffQFVHxv
3352	fee_transfer	1402	22000000	1	CkpYv655CNbAbUVQQdjcHS8i6iRTNYakF1EvfabgniePvYha5vsSn
3356	fee_transfer	1701	22000000	1	CkpZXwxdDdugccZtQYwZ6D5QKaKDGECwoEyXRsMasdat9j3u8VBnS
3359	fee_transfer	1675	439000000	1	CkpYkd42sroq3woYD3gLEu2PCUnGq8kJFmBFCsBctBRVBorib3WuW
3360	fee_transfer	1675	64000000	1	CkpYiYythRgKytuo9DKw8GvaZP3HPYf2Y2mbd7z3pQiiFS4LBsHwv
3365	fee_transfer	1729	33000000	1	CkpZLYpRBqcw26dCFj4E8eK5GNoheYDGbwbcUrVhXSHWYVN9kQKXr
3368	fee_transfer	1850	11000000	1	CkpYRtaB3xAAwZvGtMjZqkBP7KAYGqQCvnxCj2WV7LtZQjMKEnKj9
3369	fee_transfer	1637	24000000	1	CkpYVxRo4YiRQi9xi8R5wYicepsBD51pUpRnq1eVhAb2BFUoUqY9w
3374	fee_transfer	1850	31000000	1	Ckpa942sm2APaXvf35nKivX41gSe4kqZhuArsZSZxfmq76AexWwKz
3386	fee_transfer	1672	13799960	1	CkpYpSn7gBkVxibswt2zRj1dTAaF6MRAoxdCk3ubvihCWtWWrgJrq
3387	fee_transfer	1761	100000	1	CkpYv43ubpcggJGpsF8raMSZYTAiE9EwP7Fvo7j59MfgDe8p9NVSq
3388	fee_transfer	1571	40	1	CkpYSg16hcFtRzfZTHGvCiTe52fPVATt2RbtKACjvCuYATSgaaZqt
3395	fee_transfer	1762	45000000	1	CkpZGJPLEDY9cRkf5goL4Rxmjhs36pfhQfcVoK6y6TNQBjbHmrcYh
3398	fee_transfer	1690	15000000	1	CkpZjHSkoGPFsQ17UwqookZwnyDY378Y9s2bKXGxwkzUEUWGWXQQB
3400	fee_transfer	1588	12000000	1	CkpaDuhdrDLwvYdnrnkJNyWU4kCjYicUp6yhQrMrVGvmpxpdBHniH
3403	fee_transfer_via_coinbase	1761	100000	1	CkpYv43ubpcggJGpsF8raMSZYTAiE9EwP7Fvo7j59MfgDe8p9NVSq
3404	coinbase	1471	720000000000	1	CkpYZ2FL1RXW4Zj78P8PDgxRqeXwkXEMUxDovkPasJsYfJoGoRzHb
3405	fee_transfer	1790	1900000	1	CkpZ3QEpPbz2hb4KFp2kVyRBfzNWLVxjhAhyUUCmtzTMCZawUk5TH
3406	fee_transfer	1761	8100000	1	CkpZesd2XAQCmmxzCw5BFix8n1DD9RGz4qnUao51WFVsY7JVfjzCv
3411	fee_transfer	58	170000000	1	CkpYXnKWgb5DR6utUuWiQT8JCcDtjNPiVwhofLa36eS9q1aYSDkAy
3412	fee_transfer	58	405000000	1	CkpZ42cYXGd6yd2jbMUb67Mr3wMBixYLxnjQDorGTA8wdfNXeNatp
3413	fee_transfer	1739	11000000	1	CkpZyGANETjttMDiwvfa4SxjoxctJxfZ1Ue5nNXwdvV8YM7Xihc6b
3415	fee_transfer	1690	45000000	1	CkpZ8jcHamwfCtxvHku97H9ijgMiqcyKuRLqU3hR5mR5NXZDnjam5
3416	fee_transfer	1447	43000000	1	Ckpa2mmt63Byq5469xySPX55EXLGYSjktcwScRJwLHnp36fLp6ncE
3421	fee_transfer	1719	45000000	1	CkpaGvVigNrcizucLhmksDWiaxVVjH2UKoXHtiBxzzzxuz54u5v8B
3425	fee_transfer	1714	11000000	1	CkpZhaoaPUm9LwR4vjoh49DzWfhkgy3Dpn37PjXjvbRTZvPg1aQfD
3426	fee_transfer	162	11000000	1	CkpZEcNdK2mM3KTuuwxWQfJ8eQAEQHroHSxDnxMpQZ359eEtE2JDF
3429	fee_transfer	1673	22000000	1	CkpaFAWkHYjtyRZ3N6MQfZ9brSURGv6uDKLzi4eYbPEvxZeAtcK5E
3431	fee_transfer	1546	44000000	1	CkpYfvrPaNVRw1Fsg4ToU53vDuVyB3UYEC69AQ5PmZNV6KANnT1Uv
3440	fee_transfer	1634	2000000	1	CkpYzzdFFrcVzRS7WFEHSArhQssXgNSY5TG2fsGE325yis2HscKy2
3441	fee_transfer	641	11000000	1	CkpZWCpT4VFJ8CuSncWGrABSfu2oDWmtyYCwQrG3eyeAQcxDemcVJ
3443	fee_transfer	1686	11000000	1	Ckpa3Ne9uLPp6hykvCw1nMQ3inTCSetFMrygBXjWsoftNtwR6REPf
3453	fee_transfer	689	11000000	1	CkpZW2KGNj7mLeKPwSvRZZshzambLEmv7qJ2HpjEfoPNyUuby7xTL
3456	fee_transfer	1638	11000000	1	CkpZvhqUek7JAF6BdfJ7Cw7ctFYhUWLktto9y3MgDHQMGGZePwYig
3459	fee_transfer	43	122000000	1	CkpZcCLtTXArt5zXHGaq4Qp5SAfvfgw5zVUrivbsm3sGnL5gE8t8z
3468	fee_transfer	1688	81000000	1	CkpZg9nWRQCBoJ5o7u7yQDMVH5o5UJijC6q3AYmfygndTW9AUrMLf
3470	fee_transfer	1546	53000000	1	CkpaBz6Nni2ECX5C87ndi4gSH4sseLeVVNc23s6dzMpct4RP83gfU
3473	fee_transfer	1710	62000000	1	CkpZYRanFxzaNoMHVXVDN3agSPcYJFHgPtB5gjxR11AMF42iZfknD
3478	fee_transfer	1547	32000000	1	CkpYRaQb1rfCa5ao26NszgdCWUUQ9dciMm4NJUxA4a2GsYVUscoWs
3479	fee_transfer	1746	124000000	1	CkpYpvub32W9VcReM8JtuGyYFZDStcd56M6q4ARfVDQSX9k1msBJL
3482	fee_transfer	1637	124000000	1	CkpYa7hStyLakULfy2hAPJ8XEbQo6Eofu9shRmW2Aws1L1C9tgCmG
3483	fee_transfer	1489	12000000	1	CkpZ8NUAPAPEDy2nJsYjfdPpvZPxsmA737d2LSkSsK9dHPNJgzLZx
3486	fee_transfer	1474	13000000	1	CkpYWGqz4WtEKfUWB6bVR6F2L5sRCn1wDqhgV21yqEzaHpYpCykmR
3490	fee_transfer	1683	125000000	1	CkpZBHHMuWh1cG3rN3ZLMHXwUQcEpboy8fnvHsxVLPeTXquxaoLdt
3510	fee_transfer	1679	13000000	1	CkpaBXMoae1kV6Y2SicYTafobzH5TGnuD4FYtWCck4vKs1ChB25D3
3514	fee_transfer	171	12000000	1	CkpZgsCH8c6btUXWd74dE8HHjAWaFhq1rnw1sHFhM9QJiLXwdgH4n
3516	fee_transfer_via_coinbase	2084	500000000000	1	CkpZbe4qVsia5WwZSJXXbvmaVLe7P9S4XKGBJhbg29JpLGPDga7L4
3517	coinbase	1455	720000000000	1	CkpZZYNuCZuGJbvc5NweKfu9jQWoYAjxRY1rUSkzVAZz7K462fuqZ
3529	fee_transfer_via_coinbase	1790	1000000	1	CkpYUe94WYD4UYQcVhRfSBqRdV8C1BsHSv7btFLG5BhgUYKx6wAqL
3530	coinbase	1739	720000000000	1	CkpYhHvoan4WNDUQ8Lwt7dLx3hT6wMSobz2EapExaVqbZuGMyXGrc
3531	fee_transfer	1739	13000000	1	Ckpa9FtSX3bxVyXBDMBDusdDHv38fWYKKrUULA1S7p1NdHzePrfKF
3534	fee_transfer	389	26000000	1	CkpYkiWdPf4izWKcL8P3YmdQ3QQ4v7kvYhqDiLa5Gio9YK4SjMQv5
3536	fee_transfer	1711	13000000	1	CkpYx3gLMbvNMiuNDHkaTSztM6u3tLhfvW6TmcUMsjguR5sPfiFX4
3537	fee_transfer	1420	39000000	1	CkpYxAXUuscV4dEkmg7C3K1MSy1pNbGiEEqjszKit6RSveMpWp3wi
3540	fee_transfer	1710	39000000	1	CkpZxF2FSZrNncjFk33aL7HW5RbRBveVqHnHWeDRk9iEy6np7QLA6
3542	fee_transfer	1690	28000000	1	CkpYzb7QssbpfjxRjgpFwmumVbLFVHZr7RQJDdPdQneP4udNJYe4K
3544	fee_transfer	1513	62000000	1	CkpYcR6Btkk5vFgtEebesjBBarfK9xXH8wC3fBayRtwvbPL8Zimod
3553	fee_transfer	1402	54000000	1	CkpZNKeNMfDUw2zKeutpm838k3EL5RfTEcNdkZfXE4Qy689uhVRmm
3558	fee_transfer	1402	14000000	1	CkpZy7bpf1YXETBQokfj7LrDTftAawsnTbU8VfjPu4KNQqK4nG2Uc
3567	fee_transfer	1594	55000000	1	CkpYWgo3zhwbAxBrfMbwrCkx7TXP2z6fzy1kgnURYP5tb94JSqh5y
3575	fee_transfer	1447	24000000	1	CkpYxpZeiuAHjJgbHZCeDqhGfC9XJSZgrMudfLCrVLc9Aow2NpXgB
3576	fee_transfer	1594	16000000	1	CkpYqHuEDtPKoTenJErS1acfavWZjND2YYvLteRUJa5xwaCmDFEKS
3582	fee_transfer	1677	6000000	1	CkpZR47GmrA71x25vxfxMxPKgM8MgFuLqurn1B8AddX7xc2Gt1W9C
3584	fee_transfer	1739	24000000	1	CkpZpPodTH7Q9LsM7T5L5uBEVG8U1XzY36ssD147GzhCYYizSzAXB
3587	fee_transfer	1698	24000000	1	CkpZaTTz5nQCZUhdnp2je9ctwXE7XyPiQEvUTSoSnr4gXXk71Yphj
3332	fee_transfer	1588	11000000	1	CkpYsdBHjEuDGdjCFfYAMTH5EymaGextcG68MpiabyzshrVgUgJto
3341	fee_transfer	1693	23000000	1	CkpZFeeDR7RjhY8a9LQspfvn2mejrjcCL2yubfiG3UPqHxzLLFVTk
3346	fee_transfer	1703	23000000	1	CkpaLEbGUAsk5bWaMPXSY6qeLh3kfxWpTGs5xqN5qxTZxaVMbvSFA
3349	fee_transfer	1677	1998100	1	Ckpa1TdEzgPrXP9dVwqiYVHe737y5KQp5WcjddaGTAiYfmKqKVAPD
3355	fee_transfer	1601	22000000	1	Ckpa6pYLafJJeDaFCDDBBLL1JTYff8kSPUaSNSjgS6dEc7QAFsZLo
3358	fee_transfer	1675	33000000	1	CkpYqTV9T2m9KYiS3zMHSewJDBXsaSxayv6uPWu3SWXiRJKECzkWx
3361	fee_transfer	1692	33000000	1	CkpZWXM94HmnD6xb5cc88n5XimMw8boHbVU7xDpsvY8b2L5W8oiKk
3367	fee_transfer	1675	86000000	1	CkpZdLpVBHhFqeJG9QWchLwLHukBcT2TRCjQNqT1N1vci2vuPfjGt
3370	fee_transfer	1608	11000000	1	CkpYV5kwCNRBh7yzsfQzuN9ryNhXaa7YgdNBnF3MY4btGSXTTx38h
3371	fee_transfer	1729	23000000	1	Ckpa7JLEKyp6YuUsEQyaSyBtkMxyDprJ8iWw33GUdKoBPkEn7G2wt
3372	fee_transfer	1729	21000000	1	CkpaHxeWr7JxzfjKwkkbEW1h9BqtTNV3asKUZxshXm99hjvURAX8M
3373	fee_transfer	1690	32000000	1	Ckpa4oihHicatpsymbcMYzvhDjAgFqNxT6wiMJhwi7quQ9qTbDSef
3382	fee_transfer	1451	33000000	1	CkpYoR2q4Z59XG3m52WmE6MLFteq6bnhqP5EY4gBpZN5WwHZX1wdn
3383	fee_transfer	532	11000000	1	CkpZPbFvN8vy6vJ99NQHrqxMM75hGMajaCPGg3NH7aGzm2ZiHJj5x
3390	fee_transfer	1717	22000000	1	CkpaCh4aScfjLD8vvJYZjtPyp971v1itwKAUmuGs1onyB463egn2Q
3393	fee_transfer	1677	12000000	1	CkpZc9UpxU45YPWbLiGQGxaLTEQTxSUhZQ2bCcZeZf3pMEJMNkMNZ
3394	fee_transfer	1762	41000000	1	CkpZvreMDC57unHpcDwmJtj32BXzgK1jc5Tv18MmCLRhpc25n9hNR
3396	fee_transfer	1680	16000000	1	CkpZDJiDmFiSmwvRDXAhfrBvkaeCiQJyH8qUUcVrcS3qJYPUdJ7Yu
3407	fee_transfer	1471	9899991	1	CkpYe26WsjzdPhGS4aDot5PxhrDspUq6oK9gwVKJonEPV16iv8bd2
3408	fee_transfer	613	100000	1	CkpZ3LvijTudrLMinkbFpc8PGzNukYdLhqNUFFZ2HPgJUj9MKgsNK
3410	fee_transfer	171	31000000	1	CkpaLY7gZoPUr7YG2DSvPMCiNGv82Wh3K4bETWJ3MbyHnZNtAuixS
3420	fee_transfer	633	44000000	1	CkpZrdxvjHeqTD76eKs8d8uiaovCjqmC5FNqmx7hFBTrAMb2SxFeQ
3428	fee_transfer	1509	22000000	1	CkpZEdNL1csojZ1s9bwQFr7kZHK7ZeKdPC1UvmvpXT2dfCmm4aynE
3436	fee_transfer	641	22000000	1	CkpYrSfrtzGbUqxK6jitKwFUWQuB5yvrrTVyGHhTyPnELB3eTpW3E
3446	fee_transfer	1522	22000000	1	CkpZviFEBZnFNGS4o38VLNdZ7AyWtBJKVJ9Cta9HM7vqi1Ag9182C
3448	coinbase	1536	720000000000	1	Ckpa9vUhQUtdPnTac5SpMRYyB9ZtTpCrcSUy6WMKAbuQcNFTjFKbd
3449	fee_transfer	1536	21999960	1	CkpZiophBPGtbSNCkQsNeuBJqJu8VhzoDtsMXWxztQk9i6D5HbGjC
3450	fee_transfer	1988	30	1	CkpYnjbxojYqCvPhcTkbZXaaB8BTTWZtPgJQYPMh9CdcYFyFvJMNB
3451	fee_transfer	2052	10	1	CkpaGNzRQgxEHPKqfAcgxTiCAvU1NiQGNcoyv7x9uJa8mDoFkPKDZ
3463	fee_transfer	1992	22000000	1	CkpZpByQVFbvae7HpLhbYqpspgdr1wLijmFJ2u5t9JWgfntuZ7sQx
3469	coinbase	1402	720000000000	1	CkpYXD8mRKtjKxtdHu9ksiGecbnwiHsCdauVGimjujMp8cDvgr1pp
3472	fee_transfer	1688	123000000	1	Ckpa7mvkADasAqXtMiDiuTnskq696QVbRU9h1GWSSvVaqRgjyceHS
3474	fee_transfer	149	12000000	1	CkpYsWPQ7w2HFM5W4LUAE1yAQ6CAPZcVrLFxbfYSrq7pzeaPSGnvd
3475	fee_transfer	1402	32000000	1	CkpZb84swn4RWCQ8HQS7Ri4jVrqvyt7JaN3aoFheDtsnNDhfhgzaA
3480	fee_transfer	1747	124000000	1	Ckpa2xYgTCNr61pwEuuq61LyUCqxVxgcWEuFJZdc4yhGvP7qXt2Md
3484	fee_transfer	1678	145000000	1	CkpZm2EK9oXGgaZMMfLwkfcsym2fJWhTQAFVojUJJgsaMidzmmj5P
3491	fee_transfer	1654	125000000	1	CkpaEwhkiphmzfniibpJpAKaX3qjLiX3AjXiahP2eBJbuo7pit54X
3495	fee_transfer	1749	12000000	1	CkpZijhS3zAGmMRCfdAL9hRP1WnnaA8d2g7afZw1p3wuwkSYnxEUg
3497	fee_transfer	1686	12000000	1	CkpZg6Ucyhg8cDjDPzE7GBe624pP8VucggDPUWnXw1WFe4Yww18qK
3498	fee_transfer	1684	13000000	1	CkpZPyLHDi8wp6A7o9p28aVR5BT6YjzX251umuvWFekU2dxyJFrQF
3501	fee_transfer	532	13000000	1	CkpZCS9KVFA9Jt3LQqskkSLpvbKZ6nuZPJPqhbSjHxE1Kbq1yqiWo
3502	fee_transfer	1718	13000000	1	CkpYys2an6uwdKWNuxTNRzaDYfFLaPxk5otFWdR6hWX1QwUD2pxzi
3505	coinbase	1895	720000000000	1	CkpYsKtmbMRQGQ7X7ER7iKUJLAtRfomtHUAXr2S1KzAgSeRd7EoZz
3506	fee_transfer	1895	12000000	1	CkpZeKioTWc4Z9anDfSsYr1AzPj9MVeBci7ogutN18pNXrxYPxRyC
3508	fee_transfer	1596	13000000	1	CkpYdcp5rdLt9HPGt4oLrbqErt4fB264VmodaX8BJfjTS8n43KPVR
3515	fee_transfer	1649	13000000	1	CkpZdNbVx7ifG1UH3yKZNaYKUqB7ZDzS3kk8tmsueub9ogTsudYyS
3518	fee_transfer	1699	13000000	1	CkpYwdd1kJTtJYwaBDxjH1YZqprL66nuWs2z9cuaijy2AnDAbmMDh
3535	fee_transfer	1610	26000000	1	CkpZHESHgaPwoz3QWpwYkVcLRot5QwiUdb8pwgy9YZXYYgZxGWc1U
3539	fee_transfer	1711	12000000	1	CkpYa2MLbAx68Kd2UP5gin6td8LDnLGi5LEoiMk6mz3mpX8FzRBeU
3541	fee_transfer	1679	39000000	1	CkpaK6P2KRygBCFJwGeBMYrtoyTiVLPEZBhQXw6SnoSLPWd6Sv3HX
3546	fee_transfer	1637	13000000	1	CkpYbPnHLQ5m47uZPVWWdM8kDrsZUmGfkazJNffqB6Wopy5g3dou2
3550	fee_transfer	1685	23000000	1	Ckpa7LxmUfvMRsydayo7NF2hcYRr2Fgaqhe5opPZYrCSgokh4tgLS
3554	fee_transfer	1506	24000000	1	CkpYwgXnM6N16ddkUx6trsG58VBMt8v2M3E4FMR1cGGPgZNc6oKRf
3556	fee_transfer	1690	22000000	1	CkpZpJ7QkrtfERLWPSMDU1gG87iFZkzLjXA7rmHe37EduZBKpEHLi
3557	fee_transfer	1471	46000000	1	CkpYyez1aJaYBqPgvh99xm1hLu2f7epxes7gkBexAe1XawB93Lag7
3559	fee_transfer	1458	14000000	1	CkpZLPUFdednoQatbeWS917qm2TnEa9fQtPokCFYV1UqVsXNfgjjY
3561	fee_transfer	1509	370000000	1	CkpZJPBCZr3A6d1XSaVmnAdmsyn3cs4W19E8UNEHpwMhAdoG9sUfN
3562	fee_transfer	1509	303999992	1	CkpZQK7zHqCHTnAneFzvEYp6JWEufQewnydXjX1TGKjXjnXn64JnP
3563	fee_transfer	632	12000000	1	CkpYU1D8YJWiG8Sg6shtHLDWFaHTvkwtnHN1tEzQuiUyrWDsNZTwZ
3568	fee_transfer	1588	36000000	1	CkpZThYD4jnCCUZHfvUP3wqXZo29uCk5PLBcaCeCN86gDFQuiC62p
3572	fee_transfer	1696	13000000	1	CkpYtNGhi9QSsQ6ai3QnpGoYhcpzHUQgdjxCUo43i22voGvUnW77u
3577	fee_transfer	1729	24000000	1	CkpZqb2aq43eNnTDwfo66QhxQpkueEP489t4LhWiLXCJ3MRVNUDvu
3579	fee_transfer	1749	16000000	1	CkpaA7eTKDmnaGGadczrSqZjfg8ZjTws9eVMmaEKVcnByJ5bJhZTb
3588	fee_transfer	1657	24000000	1	CkpaL4yjHVwzw3G3bqiq5u7Zh7L1R98YMzzfyGcCAAdfiPgj76cRZ
3592	fee_transfer	1683	14000000	1	CkpYxm6JT6FiWEYuN1rDrAfNGedgRe7h6NsdXZXAyoVgVcteXeCyW
3596	fee_transfer	1608	12000000	1	CkpZnhhTE5EWsYBQsVm2uRC7ZvqDFHzQktJqJLSh2uQFHyyHhmUV2
3599	fee_transfer	1683	24000000	1	CkpZE9TzNMXtrCPR79cAYw7PeB6ceWvxuoURC5SM3VdQcFAPMg6v9
3600	fee_transfer	1593	16000000	1	CkpYWQjB4K1VDntA8Pmb9yDjwt8e8A6t4J9YXXedtvJTK3mmXABVr
3620	fee_transfer	1698	12000000	1	CkpZF5nNYzUsJdSEWKmAtx9pv6XgZM1euGXRKmZCGycLktDD8q41L
3623	fee_transfer	1723	24000000	1	CkpYZAePKCaJNagwEHtBieWEUCGNP4Zvu7PLSH9zEc4TMuX5WvMec
3334	fee_transfer	1402	34000000	1	CkpZpq4qN51EmGLAb7YKacXyKqhG9QN9PnS6qJeGYg4ayid6Nek4r
3336	coinbase	1510	720000000000	1	CkpZros51trcmUtZtqXWaWWn9D8ivCF6ga3ynDywQVY3thmV41KB7
3337	fee_transfer	1510	12000000	1	CkpZi8MkbUFm4bhbxmxvC4VWJGD9qigGKvEvB4tP6HTh9gF7B7Nu7
3339	fee_transfer	1508	12000000	1	CkpZ1vpYPRqim8kmAxzq4mHgNJ9v8ZnkPy32Lnw3pDbsQWQRatoQT
3343	fee_transfer	1471	12000000	1	CkpYdvxrLHPWwwNEbPaWFCj5WeKWPaiiYeiS2RQTdWcKqkScQezJz
3350	fee_transfer	1602	11000000	1	CkpZGGioVSJWQpLsEJR2k6YVJtJozGtfshmq6rDNEof8d5AZsAjKN
3353	fee_transfer	1439	22000000	1	CkpZ6omHmjk6T1Z9QePgyaq37zZohXt2H95RTPfXC2CdUhAeuqvXq
3362	fee_transfer	1508	22000000	1	CkpaBAufktDY8SjieiQzhuw3i1QjYxtjzGahf2p55aU4Ms91hvtq2
3375	fee_transfer	1850	37000000	1	CkpZYeo2BkfVafCM1cktPJV6B1h28aMTJ9NbNpM5srZ3NsZyJMC3h
3377	fee_transfer	1677	65000000	1	CkpYjT2n3Wx49nCaAkJDRuuxiRvsVfnNsNsH9esBQ7B8hxnBMqhbJ
3378	fee_transfer	1588	22000000	1	CkpYe2YeszaeqQdKA6MAjQmP2NEPwg64cTYTvHNSLACYoD5sgaUB6
3381	fee_transfer	1688	13000000	1	CkpZgXFxQyMS4tMPDSVn4kW9q9bjCupYByw9yNfUJyCeWG2KR5SHF
3384	fee_transfer	1877	11000000	1	CkpYStmza41CNiF8XYBLwxqpfL2YZuF76wyNM2G3aSdwGLaZv5x75
3385	fee_transfer	1560	12000000	1	CkpZK5KRCKc8ZX68wxwT9JY6Xpy9zdKsQgfEvdSq4gV4g9dffKoUg
3389	fee_transfer	1672	14000000	1	CkpZHwg8ZtRYHkEepn4tyMBbRZ1XPNoTxzbjRzKwKPUr5qbmTaQKj
3414	fee_transfer	1596	44000000	1	CkpaFDtv2RfoX7gLP1b9QKkc9BSH9aQP4McphRa9Fv3ntqAW32VdG
3417	fee_transfer	1723	43000000	1	CkpZGC1ttJWojTC3DuRnwdS8AJp8UxVeSvciaqhWSrfTz9yqEip2U
3427	fee_transfer	1666	11000000	1	Ckpa6LcuJZ9fnfBkbtqRsfegFZzw2P56kQLZEpLN5UyDmcMfyH21k
3432	fee_transfer	1677	44000000	1	CkpYwHyXnbCapFFHdNWukuoGN9JgaZsWv8meejWurRbSWa3oV6KK4
3435	fee_transfer	1613	22000000	1	Ckpa6RnrMBczxJNfLikXKk9ooL5SSTZAVyiqokzq7mPqvbSSCQPLr
3438	fee_transfer	1688	44000000	1	CkpZoWS3BEqdrD5EKQvsSxx7ND18fsG3AnerGsCbtfA6xDUT5QLfV
3439	fee_transfer	1692	44000000	1	CkpZvVNNqF7iE9Dv4vdrSJpoh2yDKHhKNngdYfrgYcfbieMdXiKrh
3442	fee_transfer	1613	11000000	1	CkpZHJUcpsmkx9KSmcEU2QsLqbrxUjojb93PqcGuzdZdTodmfSvwT
3444	fee_transfer	1671	33000000	1	Ckpa7Bt1RGCGFULMLKZwxxpmftcF9HNoSi3fM8FCQC4Z4QoAo2VF3
3445	fee_transfer	1476	21000000	1	CkpZJjLzk7AJkksULqFXMxtRRu6NKhNG8ouj68ZBNrUiM41DjJRtr
3457	fee_transfer	1476	12000000	1	CkpYjpQfgEadcFsbFgaHsXr4DqtbJxbRsSSh5C5vh2ARdY6ApFg6Q
3460	fee_transfer	1601	123000000	1	CkpaHRY3Lww6GkdTfScLUKhCD4V6SpPoWAMBYuFmf6UAvXSCtUEvH
3462	fee_transfer	686	21000000	1	CkpYaQNVCNB65SC4idPU9vUdpEgbG2YPGSQUGGqkELaubf61rXroD
3467	fee_transfer	1455	120000000	1	Ckpa22rfdEcmVJmocbY2Vx6rv4a9Rsa1f3bXt4GNswLpQtPZiCepX
3471	fee_transfer	1677	53000000	1	CkpYT3W9sRSJG6j1vzb1nKxCh5sYS1BUpHfqyra1shPGVhL7h8w2m
3476	fee_transfer	1991	32000000	1	CkpYhjQFwwEP6y5rooj1sW4Hvjc3TrfprmPZtxJXNA8jErq9HXHPU
3481	fee_transfer	1704	124000000	1	CkpYdCFjvcrWfbP2GwkBwnHDgypBgBGHmT2kHVPmpJjWJCbP8ygTT
3485	fee_transfer	1654	145000000	1	Ckpa78yJVCkTtuHE1HT3iGrew7Hs9onX8GqzYZmL766HxZMickMqy
3487	fee_transfer	1681	13000000	1	CkpZNgKck98HAJCbsPBP1Q4RVx4VSBWjThrFd84WYWKTjHDB9mgQw
3492	fee_transfer	606	3000000	1	CkpZ8nHQmvGzTSqU419zwEPcM1Jn5Y8jRpC8279wEFuKZjHu6Nfn1
3493	fee_transfer	1683	13000000	1	CkpZA7diEMhWYUtFBptqRG26yDc82e1vuNivpHW2dDLFxT7Asfw2U
3496	fee_transfer	1601	12000000	1	CkpYtoXhsYnH7Yd7Gq1s2CfHLZwnvhaP6qsDFMKmudzSa818hYs9P
3499	fee_transfer	1657	13000000	1	CkpZF2PD6pnhS4QoCo6664nGeHePGf5gcsb3sVQ4dcU88WXdh5KcR
3503	fee_transfer	1688	35000000	1	CkpaHbE3pUZqXs3zG71Ac9WW5UibTR3nz1AEKgys4vCfBz9oCaYm7
3507	fee_transfer	1654	15000000	1	Ckpa2FgvF7oo5v6fmQeKwLyrEXD1iXtXooVnS4tSCrrNj17L1PaR2
3509	fee_transfer	1768	26000000	1	CkpZz8rmC92LDTrLEEtAAMNPKjdo9TfmUzYc7P8wF6heC5aQcrjUY
3513	fee_transfer	1670	13000000	1	CkpZrfynbbfP2294hBZZxqjQi5SU8c6aWpkfiTahwhX3ktQ9SSESM
3519	fee_transfer	1508	13000000	1	CkpZq7gTbKLtcUKyLe963J4sZNeTrRSAfFGLRxFGNixtLJYFoxmFm
3520	fee_transfer	1740	24000000	1	CkpZW116go6cyZYPTvzsWXtAAKUAEX6KWvkTPUWSHZU5impB5wQE4
3532	coinbase	1689	720000000000	1	CkpZN3UANhBJo7tJZnzE1heA1KQP5jtkBuvDTRfZGiip2Z8sKToAE
3533	fee_transfer	1689	12000000	1	CkpYv4uhjZ9i8e3FfP12PvYScKzxiCTwy8D8H3GC6QiiAsYeUSZgx
3543	fee_transfer	1690	16000000	1	CkpZcRNWvDhiAPmevFR261D9m3zsDCUQhDESxEQJfARruEenUa77G
3552	fee_transfer	1768	34000000	1	CkpYeeiXbZcWiNbrp8nqW8eCyk1tC3tp9LN5RY1JT4YNyZrmm3otP
3555	fee_transfer	1768	24000000	1	CkpZNXL7Jjboyo8zERAxsBFkvZ3mHkugp5n4og7B88MnN4HRHcYLr
3560	fee_transfer	1671	14000000	1	Ckpa9UXqmTXEsqqrhv7CJefd6AmAnx6rNwqqKG6ETBXZhFFJjpsPy
3564	fee_transfer	1602	22000000	1	CkpZoB4m6nNjViQbxG1wkf88BUJ4vU6L5DLbZBFSEC4XARXhYMiJ3
3569	fee_transfer	1622	36000000	1	Ckpa8gLxK3nFEXWRJ3Ey5HVn4bBvitLm9F8po57qu3ykiwStvWAub
3571	fee_transfer	576	36000000	1	Ckpa7su99wnjLLYwi8ES28zK8RzkLASd3WX3Xn3QNeRupyYphKdqh
3578	fee_transfer	1683	36000000	1	CkpYzvktkmko9U1McXHgCHMUM4m7pjbPJHqJrtvHj2FAPhKJngqi6
3580	fee_transfer	1749	18000000	1	CkpYeJtPzwtYiEFoV6TqH4AXjfXndoRpsgJfjsXk8aX68RzRM7zA6
3583	fee_transfer	1560	24000000	1	CkpZQmvp4bpKku2H91BxBBfpYogVj7nt6kB4raGE65fsSgJvbAUsq
3585	fee_transfer	1546	12000000	1	CkpYVyVmuF7EAxgspE2JJbZVmQxGCHpD2T3nqSSt3oLVY7DWXdMXh
3589	fee_transfer	484	2000000	1	CkpZYMwYERQVPhXXCWtcxht1QD2taH1HM8XMgupjy7ZpvHYR6XKXr
3593	fee_transfer	1447	999000	1	CkpYUNJ4EJqM4hiatjonN3wqSWBFD75nyMtuer1FaZbkn9w5PiAUS
3594	fee_transfer	1677	9001000	1	CkpYVoaP6BbUQmZo5GLWfCjiacMjBdB3TQe33vwDdEd8HWEfG9kpT
3597	fee_transfer	1696	12000000	1	CkpZ6iM8cbiwQmuhGMPrELWLMcg81nNYrmmuZFrgXCbe7UYQmQAdP
3603	fee_transfer	1610	12000000	1	CkpZQEMBpmXiz1AppxrKEAa4zptvx4ADjkUVvHpMeqWj9Zjgc8A6Y
3611	fee_transfer	58	12000000	1	CkpZYEZJovfP5siQ4meYKQLaS4N4J6xpBzfGfDvFjH3257JoBiq5k
3613	fee_transfer	1555	12000000	1	CkpYaQJMxR2tS5CzPVK3Y3WA3NdbkVCGSvraokrwyNy1X4xbyVWcs
3622	fee_transfer	1471	24000000	1	CkpYtcS7wppU9wmxb46BVgxhS2NBhhSkib8szGj3VZ7GejrrX4Vod
3628	coinbase	2087	720000000000	1	CkpZ6PbX7YYg3zPidB7rnQuazyJBn4VUrQG93wg6aNWvXZmsMU9JH
3629	fee_transfer	2087	25000000	1	CkpZ5WG2JrHLFRVd4uUTvgFK7TwJ2dCqcgaCd7Fe6MskYcyBg5g5s
3631	fee_transfer	1474	12000000	1	CkpZvmNRUpZdwezvfwSNbUaHj7SaWzyAtSEEE9FRxC9aj8netSRN5
3638	fee_transfer	1717	12000000	1	CkpYyXdBdMdCQ98qZrP52qodbQb3MLbtVCLgWzmF4ohX52kjCgq5p
3641	fee_transfer	1718	12000000	1	Ckpa2PN9z8n4X83WU5DiSMSKUGLeTBhM151hb9dTjdP2psdDMVBc7
3335	fee_transfer	1683	34000000	1	Ckpa1qfpkrn2344GGDALJR2iqpPj52gnRmihHkH9jTEQ9qbMWKVti
3338	fee_transfer	1710	12000000	1	CkpYUvpBSSTU3QA9nnYqPjVxhV1rWQCp14AQCmo8Tk3sdvnG1kLti
3344	fee_transfer	1547	12000000	1	CkpZNHjb98oAaEV53HMygM48TuabpU4FCEn9BhR9kjG8jdNST33bh
3345	fee_transfer	1608	23000000	1	CkpZ7iVPJ34xZkCvVnxc4jifFs296voaV8pU5xP8wLmyYEXcRPobG
3347	fee_transfer	1702	23000000	1	CkpaJHNKK6TvpwPV6HnvmdDWHz418AVFMHfvL5XtqU35Dy1mY4VUD
3354	fee_transfer	171	22000000	1	CkpaEmQguwn5HYbTqZTmVHRCv4PWtdaCYCjwM87sxoEDz2CW55vos
3357	fee_transfer	1762	33000000	1	CkpYQd6sVMAmXGciGUvKYgMdss6ZXnMDcygUQmA7gxtSz2sbXf4ja
3363	fee_transfer	1696	350000000	1	Ckpa7YYxtW7PfMCWbjAfazBTeBmYwwThDsQUUGvvEp4q6pqVteHY1
3364	coinbase	1696	720000000000	1	CkpYhwzgzDhmpRzKbpJTKAiWhWLy7GaPQEHtjhvQwtvLdEgmosDXi
3366	fee_transfer	1675	11000000	1	CkpZ8bZxuc9Qv21q4QFTcvJsD6B8YgX7igfGotfvTaJoH7ixYvL3f
3376	fee_transfer	1613	37000000	1	CkpZDizJ3SXPqTw7HTFi2pSCA4yLRNWV64RjFhQLhJPxLgZpfgeQy
3379	fee_transfer	1687	22000000	1	CkpZmMvzBePpMrgpipZnhWnjg5xMoqaCtpd1nWbTfxbT7Q2UQxHAt
3380	fee_transfer	1448	23000000	1	Ckpa4i8cZT534JiXr6mN7h36TkURi9EfSvs2jBDx3HA5zRzYZkupt
3391	fee_transfer	1740	22000000	1	CkpZim2SNttGSonycTGkzKD3xkrc4JRWoiTPLXPrPUvFZBpCL5mU2
3392	fee_transfer	1596	33000000	1	CkpYYRqpV4gEsEJDwmvUb742XDF5qEkF6PV3rgBaTU5t2izfc9VkY
3397	fee_transfer	1715	16000000	1	CkpYfKP4ccshP4LhRxshWTmLXmoPDRnLCeTVqj6u32qLGRiPxZNfh
3399	fee_transfer	1715	12000000	1	CkpaLXNPEqofJnM5kKw1qhzP7Sa4mNAJk9JT9owScLLUqfTu79yvQ
3401	fee_transfer	1596	11000000	1	CkpYhmMenAZ8Wew9Ry2d6MMeZin1meXTgfj16j95Cu5vBWkgQ1HzH
3402	fee_transfer	1657	21000000	1	CkpZFk9bfvHyRtFeUWG9q6oLpj3gwLs8gMYA6Hxej3Nt1c8QFSMcX
3409	fee_transfer	1451	31000000	1	CkpZDdkMKBopsmagacWenZYB2PEZjWxhxPcsDrqdMQ7Hu9EUKWutB
3418	fee_transfer	1690	33000000	1	CkpZAoB3hnoA8mPFP2g3xx4A8qMMNz3555CuhRjRYirFPCsY4wqz4
3419	fee_transfer	1467	44000000	1	CkpZ4B33evv1XDjqnHbutbkDMWCgMrZ1Cm83j5dvRXSSEhJkGAhXC
3422	fee_transfer	1596	22000000	1	CkpaBKUoy4sXXzpoNkcZUXppi6Nyo54tywt6cxEhY9rSrrWmb42KJ
3423	fee_transfer	58	332000000	1	CkpYWXNZb98DCEqVZDRAWtuWQETiDRdqbvsGLGyZ9CtwUeoj8UeRx
3424	fee_transfer	58	9000000	1	CkpYUAKZB2CfBPCjqgwKpRUZQDpKDaoTdGcDcFYbk3iATqRa3VCaS
3430	fee_transfer	1718	22000000	1	CkpZaVp9nnqgkPbnECp9kXtQBKpFVemBmiEzPWsPnuibVHUR4NZXy
3433	fee_transfer	1560	150000000	1	CkpZMxnrJSah1oGDUJjYtUMkNCVhgWvLB8RBske1jEZkKnTLfvtwY
3434	fee_transfer	1560	82000000	1	CkpZr3JhuXx7XBvzXK9vXFRsaL8T9eUDuTdDmechNRNRucZXAPcyx
3437	fee_transfer	58	331000000	1	CkpZ82ZYof8HGCcX5Ukpo7bpqFXvBPjyENWz3vuKLDmGUF16s3iDv
3447	fee_transfer	1633	22000000	1	CkpYQKkFtM5k171seqtGuxZ6qeN9ior6AfF7XKttVkd6jco6QeyE5
3452	fee_transfer	43	42000000	1	CkpaHubFyTSUQMR2kCBmFnvzMQaTmC3FEgEPrPrb2qAs3tPUmAuhL
3454	fee_transfer	43	32000000	1	CkpZWSH7ZMYbJ3gAkFm9xUDeFtbxt4Q2e6vQX2e5TeCN7Ysa8p3fd
3455	fee_transfer	1637	32000000	1	CkpZuYVLoWzmtBg1f5Vbvo8wAZZBGZsc4woga677cJUojxt39Xfkc
3458	fee_transfer	1588	122000000	1	CkpZj5BHGipiPWrk9WfHcDYXwoQbG7DtPDRHi8kKg4rjzgNfxjPp6
3461	fee_transfer	1711	21000000	1	CkpYi9JrhkR5QWeDqk22LFJ4XmnaQzDYYAe48tKw5qrVhxXVkLCzR
3464	coinbase	555	720000000000	1	CkpYz3S46C9Yz5XnoWiQ3zDvpNrDq3HMK6Bay8JZdRPEcAE3LBSue
3465	fee_transfer	555	2000000	1	CkpZkPnTF5fPujQe6NnXwqetqQirZm5gUtsrh1kKLXNBxWRWdS5LB
3466	fee_transfer	1467	43000000	1	CkpYiUDRkq21aeYJXV3gETcmSLTBTk9Aa69po1hfD4hUm8FQkNLLy
3477	fee_transfer	1683	32000000	1	CkpZcADPiMyPMk9h5gok79sqsQjq6THzA6CTViJTFaNHKhi6xqKVE
3488	fee_transfer	1768	13000000	1	CkpZ6ebHVmRKB3mzAapLbybxSrELCrMPMF8CVj8TKfUfaygARbTba
3489	fee_transfer	1684	125000000	1	CkpZJUmNdmrXY5fT12CFb5FVTncERy26mpcqjyyLYdTN4FV1EH3sb
3494	fee_transfer	1992	13000000	1	CkpZxbYf6XpUkEYLqvWiAbsxnMStjjHEBySxPW1QFLbGS468Bb43h
3500	fee_transfer	1724	13000000	1	CkpZKvYiZeMj4mjD4TRjBpWHy1PtKYC17QazJ4LRTDX98nEPHaDEq
3504	fee_transfer	1739	12000000	1	Ckpa6rJtdiyHEvu2wNa6i4KXd3KzwR7hkrp9S8NScDyuNG8SVwkSQ
3511	fee_transfer	1611	13000000	1	CkpZW8ZvLmi8mcP3mBJYJHz1Xq4Pn3iaWCZZsWJmYyieyGPvUPhQb
3512	fee_transfer	1714	13000000	1	CkpZqnmMsb6pPi3gPoXP7pVUZr5JzHDQyJRpHEgGeDvN1Qj9rRpgD
3521	fee_transfer	1402	24000000	1	CkpZg4maqfXpVpGw2GtFsvdLKBDcjjhaKjkUwazLP7vfqXB44DCDt
3522	fee_transfer_via_coinbase	1964	1	1	CkpaKj3hTProVFkshbNMSUPYhYDR1nZoaiFoxT95sQMcgv7XuikbM
3523	coinbase	1402	720000000000	1	CkpYw9nmQdfDtWEuPxobHVaKDdzyd9dbBaT6x4dEcVEz2BaSUh2cW
3524	fee_transfer	1402	1999958	1	CkpaBMYYiu7FQJrN399ffzjn1qhMD93HvK771YXJwwUquVWUPp8SG
3525	fee_transfer	1786	40	1	Ckpa3ip7oUgfKCX2HEcjhyS6rvZzq7SqV34vLkqExgVDRnJoGfqip
3526	fee_transfer	1964	2	1	CkpaKb71ZR9GLPZMdMtGo2LE3MayCtnUkVrEwt2BUXGxk6CxjiRzT
3527	fee_transfer	303	24000000	1	CkpZh2A8fXDmK8S5CcvLM1sybrijzVyUDDjkEQYj5HcK3T7uqmFaL
3528	fee_transfer	303	2000000	1	CkpZP49jrpGCrkgSANLh1d5ZSDaYsvUoZMwoGXzWzzg5qtv9VwyCk
3538	fee_transfer	1518	13000000	1	CkpZ1WRyzH5ehcRj7ikfReb7rqoEmx53789ecdYzkmjxm8DsFWEzg
3545	fee_transfer	632	13000000	1	CkpZ8eAJqzSgWS4MGtvU8ZWtCGup6ZfqMonsVMG1GhGaWN9H89qao
3547	fee_transfer	1759	16000000	1	CkpYhBu4pprnHBtrt2dF3DdDmzqw8NyJLfHNPupW11xdvwx6fubkf
3548	fee_transfer	1679	12000000	1	CkpZdR9U3QmuZf45qCZjjpPAcCPHXaoFh4wRiXjse3FctYuBAj4pe
3549	fee_transfer	1690	84000000	1	CkpZpyoyJfPvS44YWMQZQ4YtCioetikiW333qNtkWFpZmbTB1xTpk
3551	fee_transfer	1690	23000000	1	CkpYvTAsg4WDhyv8RERpHyhvBSMd3wP8ZHL1o4jPt5TPtbSWw8xHK
3565	fee_transfer	1678	22000000	1	CkpZyuu9nY3eP94A5PRvpsjKuqgMGnCbtBRne7PekZ7NkcHmU4Vc2
3566	fee_transfer	1688	55000000	1	CkpaKMeG538P5wSQCbXyHvkUhVHftKaBZRCUKSJLWnS9sfbctwVj2
3570	fee_transfer	633	36000000	1	CkpZhrfrbW7AENR9ckBr8q3qMowv455bcpiuAZoGhSfiZMNho8Srh
3573	fee_transfer	1696	780000000	1	CkpYtXUNMFoxw91QptHW5yL1zqfEvPfjbqE8cLY1MzzXmmXMLYx6y
3574	fee_transfer	1696	2000000	1	CkpZXFBwjzpc72gYBqVweWXpo3Z2NHyp5WxjJLcE25z3KhUNsgtcR
3581	fee_transfer	484	8000000	1	CkpZDisiaxp9pFpkjKXHM5PLheiCBwpZtqV16qTHs9xDTDBNUjY5s
3586	fee_transfer	1670	23000000	1	CkpZurQthqNqkCH7mL7HrUsqdrbDykyozzKBRCESRT5z37iLpcUNt
3590	fee_transfer	1271	12000000	1	CkpZRErbejbYG4DvB6inFKYr9o3kH1MW3aH7RCqhNrkhFetncRfBj
3601	fee_transfer	1549	16000000	1	CkpZXpPXwd64TJj9kq92ETiFyPeFv7YF4k5S4vBDPFngjsRMzRniV
3604	fee_transfer	1762	12000000	1	CkpZjFfLa4mwEsQozxodNYN86ytJg1ak7mp3K49Encwqoa5yGFAv2
3591	fee_transfer	1768	12000000	1	CkpaDGxAfLf2VQ6Rc5GeSfWWfoCm3Wx1FFXDggHs3UJ1hvkTBJiut
3595	fee_transfer	1688	16000000	1	CkpZEdDDiSgxTGGjhJbw4QQnX7PhT6vRDj8V3Q2MQjFb4X7UqVNtv
3598	fee_transfer	1696	384000000	1	CkpZgFksTQaAtnL7GG5CgkYd5ewZDpY8vSGposmH5AbKGXyFqXncu
3602	fee_transfer	1670	12000000	1	CkpZPJNef4eLpfv8yVGeG41wo3QNvauB78qLY5uewohmPUJRRYqit
3607	fee_transfer	1573	24000000	1	CkpZcLUUzymCoM1DTQtMaWvW38NhXqdiJbfkGqyNCgxfdNKsoc5D9
3609	fee_transfer	1696	99900000	1	CkpZEQ9YsVRHVMhoTZ7VmurDDD3paceYAEshx64JYDLXSeR6yWykX
3610	fee_transfer	1599	9110000	1	CkpYnK6HMXHUyBfLTcDuNNBUq8gFgBtBhyuTc3o1Kmyf4ViKEBAvi
3612	fee_transfer	1764	12000000	1	CkpYirgXd5BxtPErwY2hvsarLYr5cwFKt83p9UNQhKoyfEFoaDwTB
3618	fee_transfer	1759	13000000	1	CkpYvBkNt9sexETnw3hgkFuSRygQFvPmnXhRTX4E61zV9nTL1GZBS
3619	fee_transfer	1444	13000000	1	CkpZCQ24cHFFwJyzpYM9z4fLRYRsJ6giRiRJH7Td4eag2Bb1oRsim
3624	fee_transfer	1679	23000000	1	CkpaFN14M7PqBkWHDTdi4LtbedAy4pDa5M1qJqdZKcUiqetKKNkUd
3625	coinbase	2086	720000000000	1	CkpYoRteMjW9wCkfMrBpPhELypNehtvgZxRo4XKEdbKjzDJZQxNRw
3626	fee_transfer	2086	25000000	1	CkpYTTqjrTWNe5HcKTs7vqk4heJVYWSGEyoBML65porriakpDXA2y
3633	fee_transfer	1703	12000000	1	CkpYZ82MYyPdApEcNhJrsnRZM2vrz3nwDe3gpek26TPLLDjhk7ygS
3634	fee_transfer	1637	12000000	1	CkpYUjoTjGowe9KqvdJTYfXLB6sFjL1WJL9nYfJiHuCug85DJJJVd
3636	fee_transfer	1637	36000000	1	CkpZuWGXW3KT5C3vfX7hfQG3jicFD6EdwYTtwTonLQ6b2z49njrcv
3637	fee_transfer	1933	12000000	1	CkpZoj6iB9CxcUWgYR2U5Cuqdw8RiYdfvJCSpGHvFf8zMymgFqK67
3640	fee_transfer	1513	12000000	1	CkpYb4rRxbBvNxyF6ATkuhSoSLQhRWGa1i4K2WdXZeyMPdxrqcYNR
3643	fee_transfer	2087	24000000	1	CkpaJ1iKFL6sdf5Z2QxygaHs69PapwB9XqFMjvdxSpqHkAcWMCLXq
3605	fee_transfer	1610	690000000	1	CkpYZwQ2LHtFkGuBhvVd8gg1ZbxWdp5xsKufRHP8op38CDt1dWWsv
3606	fee_transfer	1457	24000000	1	CkpZKjeydp81VtdVkagMhKcXK8gBc1L4aqHykU9t5TDo14QaTqKFS
3608	fee_transfer	1573	25000000	1	CkpYg2KpxhNw4bJyKcX8GqjAYKfakj8p5VuhnP1f7VW4sqyy3KQgJ
3614	fee_transfer	1457	13000000	1	CkpZgWpBJ5sX9c7ngiNwQVTanrip5wJQtrcvAuRSQNkrvvTmbhrow
3615	fee_transfer	1471	13000000	1	Ckpa3pBEqNRXvt4G5BGXBtTeZTgSbCvS951hSTnMu4b9ysGiRbXcE
3616	fee_transfer	1506	11000000	1	CkpZ83qwAaNm8eFFYuoZpsikTbxYZ27kYyf7EvFZoKQE2CKz6deMj
3617	fee_transfer	1991	13000000	1	CkpYrCZ7yvu3nivsMCHkNKzQkz4AqrVJH9hknokD416uMWzcnsdzw
3621	fee_transfer	1685	12000000	1	CkpZBNtRz54QdWVy1UCxsCSHdoc8RtvNbaa7MhUd8evyBhPga4xsp
3632	fee_transfer	1594	12000000	1	CkpYxE8sJqcAuxj3EnvUpUhf1LaEgTSkZHUngkZgCrX7X5EzcftpU
3642	fee_transfer	2086	24000000	1	CkpYeEK4SLYupGRd7U94cD6ypHpcsXQAdADhpVeehHBHaeD84LQtY
3645	fee_transfer	1634	12000000	1	CkpYnXcC78uU5Kn9zSag7vCE1Sb1dgG6etZhncm1F7cCQYhwoXjzH
3650	fee_transfer	1679	36000000	1	CkpZCH2deqweQyvipNfRMU5Yg4Nc7fYe3r4Dxgwo6ABsJcao8LAQL
3627	fee_transfer	1699	35000000	1	CkpZ2yN628WCoc9BnXdaRXPBMApKKYDSiw1wxqRuhJNMcL26jYAWp
3630	fee_transfer	1702	12000000	1	CkpYaAtSsGYf3c8PQqHbtcWky9m8eJqk1QJaWMXYKqPCvQouGviDA
3635	fee_transfer	1536	12000000	1	CkpYoWNLcHzQHA2AezNHjkQcmXNDKowPVjSmVpuTiJhPoXrzQAb6k
3639	fee_transfer	1506	12000000	1	Ckpa7RMnyuHbhsMHGQXon92xG93Uqx5JCXsLTEY7n8VRcCUPitp78
3644	fee_transfer	1699	24000000	1	CkpZQCZ2NDiMqNnrwFQip48tHDdpBx4wZZhLshCrk3VsVYQkH2FEs
3646	fee_transfer	1607	12000000	1	CkpYQNqeJnqguYZPyZmLepCft9xgAkLvX3fopPfwkNrMdvC2yPVbN
3651	fee_transfer	1458	24000000	1	CkpZv43mFQogRoFoETfYAVUNvGRTk9PVvhYsQLKdpMSsmrwG846M8
3652	fee_transfer	1693	12000000	1	CkpaEnfMVdhqusPkyyh7PHZukoD8HF94zLKuN8qvNSv642AbKNvXk
3647	fee_transfer	1458	70000000	1	CkpaBFmqWqB7bAoceGFMadYFRYJZUoYt5bWQdpiRtBNiHy331Sa91
3648	fee_transfer	1458	339000000	1	CkpZiNBbC1HWHnZJaBaonYv4dzuhMv2ULevrv3ZezRzcivT7Q7qUt
3649	fee_transfer	1715	36000000	1	CkpZxnkGyY1YS8Tp9EVVtKW1UdKk5vRY2dbghDhuhQPeHfHTiLkGH
3653	fee_transfer	369	12000000	1	CkpZNH6WHCoo9Bk5r4JcgJfjFadFyjfwD8w1JAT2xFc57meRu7psW
3654	fee_transfer	1746	12000000	1	CkpZkatadfWRj7TL1cyFg7c5xBMBDbg8HXpJy114CrxksRV1ZgNke
3655	fee_transfer	1694	12000000	1	CkpZD296GSNHPMkuobk4mLJNwNYjiZrY9XWQ6xf3ewzSQZg5wrfbP
3656	fee_transfer	1747	12000000	1	CkpZVjKxUSe6izPSn2ZUDa3p3fPMYy8hJQop4n2CmtGH2hbb3z1vY
3657	fee_transfer	1704	12000000	1	CkpYhmyyzoYxWxBeCuTVmqvLV497KnqavPuvF653agudzBda3yX1X
3658	fee_transfer	1729	12000000	1	Ckpa6W9pHgMLdfsp7JtcVQbonjB8yjm3WfmmS7Trz9eukGdkY2E9t
3659	fee_transfer	2039	12000000	1	CkpaK3Y8vtD8Yah6Cfh8tzu1j9h6AAcfwGC2DhChbqHsmgibDfivc
3660	fee_transfer	1402	12000000	1	CkpZZJjuyEeqjUTfUB3LCr46TX8Bbunbz2HWkbLdqRyiKUmGqBisy
3661	fee_transfer	633	179000000	1	CkpZ1R7pFdEME4g9n3sKJNHBYhdLnaJRp2txEP8uhBLzouK1wqQEc
3662	fee_transfer	1402	25000000	1	CkpaLWCCx5Wzzt8mPPG229EEqLaf1KV3pytihuYBnSGXzdT81vYWa
3663	fee_transfer	75	100000	1	CkpZSaoFr53WJEbudFWwnPpbkvHN8PQ4rnNTDr9nnZyz7qL553kRt
3664	fee_transfer	1690	1063800000	1	Ckpa6EMLxN953W9T6bWDCE9AmxWxQsF7hCqub97YVqKw233Sawu9r
3665	fee_transfer	1447	12000000	1	CkpZB65on3pQYHivbic7hjhYck33N7gaLBgYSvA5mbsBEEpZEK6Er
3666	fee_transfer	1740	13000000	1	CkpYVBg6aa6C77uacVkEfv24zSzte3m2v6ynw5hHp2thYJ9UCecfb
3667	fee_transfer	1689	32000000	1	CkpaFBXLoF4zi5CWmQgU1AMEni6rsLPggPVDNXTa6FJoRspt8Y26g
3668	fee_transfer	1602	21000000	1	CkpYoJDrvcnwcvMa1xScFErMkbNCJJLf9iz1U9sDmDu8T52HJgAgR
3669	fee_transfer	2086	37000000	1	CkpYp44Fn82FBiQMVpd5A4ESPebSNyLGuNhiyj24RWRbTtrw7LeTF
3670	fee_transfer	1699	37000000	1	CkpYx7iMHyUYMZCW3xZrpeJVCdooiSfck4RWh2ukK1ETmqJDhrhx9
3671	fee_transfer	2087	37000000	1	CkpZQ9znrCTJBVta6kTUfSzgXrD1yKJEVeQKWENgkmghw9Uv3myjb
3672	fee_transfer	1602	37000000	1	CkpZ2kgvDj2mEiuz6jr5AgRFrSLNKFRVKWHkBiLYxmdtgPsW1eCFv
3673	fee_transfer	1668	13000000	1	CkpZBR74VMtJJ9VANqjBgqgukDhow63JDjsCDz7PSpCeWShFwNZ3U
3674	fee_transfer	1719	13000000	1	Ckpa6ySLQ1W94vy2LBxkDQmQ3GFpdhcTGfND77dS82gKmovJnTwEr
3675	fee_transfer	1587	16000000	1	CkpZh1U6hNHoeJy6oWhQEtkzhPid2RPGGKCPaCRnpHvTwvseegjaz
3676	fee_transfer	1683	16000000	1	CkpZaweWgS8zCqT529kbMtvWBESp1JdWEfcGA3KKU4EugVrXK7kvq
3677	fee_transfer	1698	13000000	1	CkpYe6QFyb4YVaj7XU7ANQxQu5tzJUps57HpPaBMwVxjQWRUjQiCM
3678	fee_transfer	1693	13000000	1	CkpYk244W2iUmU3vZoxfD3s46o1qCrAf3Fe6y8DBy1bhqFKZbPhoG
3679	fee_transfer	576	13000000	1	Ckpa3deGVB5Mu4yNCAiT6hxj9UepPpUZHQhMUx9i2ZvhXzRaQaGKj
3680	fee_transfer	1724	14000000	1	CkpZ9pRDm1ManDJ7J6RhFPmwrCcBVbTNmThnJQHF9RfXaH31s4VRY
3681	fee_transfer	532	14000000	1	CkpZY5LHFdC59LdVc45zbKocAgVb2RJQmVABNpwnkfqrQT2kqx92P
3682	fee_transfer	1693	16000000	1	CkpZUEwm6oNyQVF5e5Pm9tmvY5pd5gcQbpR2uSb66PS4WFtARaNHK
3683	fee_transfer	576	12000000	1	CkpZPc9XqWc923KVD3L8v3vNiPC3fteYRa9ozoKhm2J4obYpG3dgw
3684	fee_transfer	1594	13000000	1	CkpZHWEn1XbZdo6GmtwaVjdwd6RDP2qqJ3pq4wYRG3pFToymMLUYk
3685	fee_transfer	1654	13000000	1	CkpaDDVwmz3JKEU2avvcHk2Yss8cx2XnNphCxKpGojZdpuf8JXv25
3686	fee_transfer	1708	910000000	1	CkpaK1s7K6sw2HQ37EkrsQcuQHaahdqGwNKZJEaNCDdLLVvvZCn8R
3687	fee_transfer	1708	340000000	1	CkpZeZqD34K9kzLeHNU14kM4vpS6qw5eHHcxBiGW81mkaHJ2V1eFi
3688	fee_transfer	1739	15000000	1	CkpZQQBatJp6FbLjMJ2x5cd94o3hAJK2yTfSPd9UMvz54SSNYw2Gc
3689	fee_transfer	1569	85000000	1	CkpZJ2Fo3CRMamiVo3Y5ZttkUD1p2gUU3jYAwytYcikFWEmABkNZN
3690	fee_transfer	1588	25000000	1	CkpYdgqmBQNbJ5ztk7D29X9k3pFXnSGK7xKGmhJjswGFGmEA5GLYt
3691	fee_transfer	1569	25000000	1	CkpYrHmyzUCvjLCpf8XDjqeXJLfbZeb6mdujjXgtWJnm1yeFnErhQ
3692	fee_transfer	1623	26000000	1	CkpZBStH7qzqApsKWiU2n5ZusAWMp2EWzsAvX8wq2rx3UbheF6Kc9
3693	fee_transfer	1447	1998000	1	CkpYg8Dtuy5n5ZN7cqriyMDy4UD6ivyx5cWRkqDoo6Vft2RL4CggL
3694	fee_transfer	1690	38001992	1	CkpZo2jcBi41bFG87dcDGZYAvkjax2EXhNSH8GpLRcGCwSGfz51Yh
3695	fee_transfer	1687	38000000	1	CkpZJmJVgwrarSCh797NUrCvof9WnUUYbfkcKwv2on3cCuwNMiPDN
3696	fee_transfer	1702	13000000	1	CkpYuECWafXxm8RC18w2CjZ4PaT4xggn4NhaM7DTSgzBjHkMXVGyD
3697	fee_transfer	1703	13000000	1	CkpZ53zxin8Lm6q29LwCDk5d3AdAvMRGonfWGznbc9WwYVoC95EAb
3698	fee_transfer	1649	15000000	1	CkpZXPPdfxp2hdiSAXY2YTQVJK4YcyqtUhNUMa65YoJi77otQjY86
3699	fee_transfer	1457	51000000	1	CkpYdYWaA7DFZLLXPC7MWrFd7mHoZwpdd6CkNCvEeDAhh2LwR46Yb
3700	fee_transfer	1991	26000000	1	CkpZAX1KtAYJ9btBPdR6Ee6nssLVZjPaYxiGdeMkZDMYNuYkUhYkn
3701	fee_transfer	1693	26000000	1	CkpYikxj8SgwZUa1ac9dBrqW2Amwy41igVTUZGeGQH718NuD6c54r
3702	fee_transfer	1439	26000000	1	CkpZq55moi6ySBYpSQzzHdaddiCdQCeauAW8rfY1WpYsAsLifvHsF
3703	fee_transfer	1518	12000000	1	CkpZoiHeeoyxCxpFEfu12qcn1mJtYyJqX8zYnQs8WJ69j4K5SRp6X
3704	fee_transfer	1448	12000000	1	CkpZsUXKMc2ChTMJeJanuvE9ZYDvUNV8d6PRP4BiEeUtYoZec89tk
3705	fee_transfer	1683	25000000	1	CkpYSZyuCYp7TkaGAE3tut2eqES9i4eE4o27z3Kb31s8XcSenCH6e
3706	fee_transfer	43	25000000	1	CkpYiSiqs3vC4URsbL6M7d8AxZWYzGVJgu7CTJJwn9PxV8kp2AAS4
3707	fee_transfer	1718	25000000	1	CkpZ4xsTNZSVcvJsaNwH8FHS6rt7oA3d6snJFWiMm32AF1zFM4XFB
3708	fee_transfer	1518	25000000	1	CkpYnT9R6yqzWtp9NVHbpP9G7ucEUwkgvcuDdGjjSDAMh3WuXiNGr
3709	fee_transfer	1419	25000000	1	CkpaHcvk8mGgvHsTd14bjHA5iD25QuDEfsfJxGK1qeHBS6okkSbE2
3710	fee_transfer	470	26000000	1	CkpaC8mwqt5A5x5Eu1yaTXEw9CptfTe8XgjKeERcbVRjW7NBJYpRQ
3711	fee_transfer	1602	25000000	1	CkpZoKujcFXRDBgvTX841e5xfSYR3Rgshg6HUf5QUivvBU2r5Kwe9
3712	fee_transfer	58	24000000	1	CkpZRSKb9TvHf29eyLMXAASFGz8W9nGhM5HogWfvJorsFDHuJNVVX
3713	fee_transfer	641	24000000	1	CkpZLLwHcFuXaY3D4giXpGMfD7HtNVvTC9S4dFB3swxjHYeCwkkeK
3714	fee_transfer	1687	21000000	1	CkpZX2ABZZ1fJEMFt5JaGxrc3izPX9H8znJH1NnHf5D7ZZN6pbENP
3715	fee_transfer	1687	24000000	1	CkpYipMqRgD8Fh5LPnSdjtJnvST4L494JVJekHm6cWaAJUEU2Q7no
3716	fee_transfer	1419	13000000	1	CkpYgVwqWg5GQiBhmpMiMCTZMWQ9uZFLMB3FW7DRNDaBLRVWVKXr7
3717	fee_transfer	1687	13000000	1	CkpYfra5vxhNNVGGD3YgNjnmWtWbbohccF2vxSHKLGovLQUv1H8cs
3718	fee_transfer	1688	26000000	1	CkpYyGXjoNiBoRrH8jupv3GA59kAw3UXs8VWG7wVJ6cEFBVzW5dkn
3719	fee_transfer	1759	24000000	1	CkpYttSxT7g3We5aMnCbbqLRC8YsiGq4ZkMNp63wMtukFdJdLnUeJ
3720	fee_transfer	43	28000000	1	CkpZwKpmgy3Uiy6D2eWLF35t3f8FogCSJnyvjtk8i1k38tUkXDpBs
3723	fee_transfer	1447	27000000	1	CkpYTCjD97SjJdRN5kpSzdLn89S5by4b484dm3vqAuiwcLkkdBYj5
3725	fee_transfer	1601	19000000	1	CkpZiDRBvJbNBu2EPBytjwDUxRC1ZpaqCf6v64afenAWgJW3PRNDN
3731	fee_transfer	1613	13000000	1	CkpZvRqMZVJjVJoQSwCFzyuDsYWfQPRck8euXsDWUE24T21Bmkbpi
3737	fee_transfer	1702	6000000	1	CkpYgyin9kmiKbwm2x5UVPTDEoAiWQrNcpMnusvLjJ7whsfvPbD4Q
3741	fee_transfer	1768	3000000	1	CkpZRQbv5x2is3snfnULdoPywJpsW4JQskWXWbUposqJjRNoqJb68
3746	fee_transfer	1622	12000000	1	CkpYuyA3my482zM6P8oajACYEAB14L8xJwhaSJcoNqEZj2GPSkFkg
3753	fee_transfer	1724	16000000	1	CkpZE38PsZz85V8ppXR2xez6xAPqFrsVuocuDhV87ZXgbiZBf1GE4
3756	fee_transfer	1673	36000000	1	CkpYUoRZzYQcz41dLP1Nf8Ph87pCLnAqgEKR1EqfTK2232wH7yafA
3761	coinbase	1687	720000000000	1	CkpZeH3uVPXQWkcQX2No4FtpBhTejBsDaznkzHt2A2cjzkMmfy88u
3762	fee_transfer	1687	10999992	1	CkpZXe5sChGjmT3bgdRfWXzzNyVS1cvJEBx8j4kZ4KnRDNY9sYY2x
3764	fee_transfer	606	36000000	1	CkpZrrB5riUWHNvioTgujyhX2JxoudBahby4U9t59gtFER4yEsfPs
3766	fee_transfer	1727	12000000	1	CkpaJgQvV6fNaZm1R6DWnybpB1DcSJK7LwNrDaNCAThF9P67DA6y9
3767	coinbase	407	720000000000	1	CkpYWKjn4VD86KP2A1K4454UZ7jJvge1Dz1eYBtAsHyRqcHsyTY8v
3768	fee_transfer	407	13000000	1	CkpZPh1Rv2HXyZNsWCqddUvxE4B1eZzwkn5BqJtbDoKZh7N4vJbsk
3773	fee_transfer	1768	431000000	1	CkpZVDma6jgkdFum9H73uqW7q6f3TDRK59QAahYrmd7pjfDxb48f1
3774	fee_transfer	1471	3000000	1	CkpYr39PYr1Dnu4WRKFvUwaXaTE9Zu7avZ7VhXK62wj2JcDB3J7xv
3777	fee_transfer	1717	13000000	1	CkpYVM2ZPmDcghF6ZNuBVyaXxee94AzZ6WHy6eNfSun8rRYv2T7J6
3794	fee_transfer	632	62000000	1	CkpZG7NHMf4HgMxyZ3scQ8THoQw68vquxrFCbuF2XrK5vktcGDH1u
3806	fee_transfer	1610	13000000	1	CkpZvLVBQ79mFXWW6H1v3FrMH2eA4EQYfn4HUTHCKiLcy24BNFqtM
3811	fee_transfer	1723	90000000	1	CkpZJnCJJmmrvKuokbzvL7NQUhMeNbZb86iRRqhpsLr5yStsBHhuR
3824	fee_transfer	1643	13000000	1	CkpYzR3GVXAdKj2a81Hcn4iyjz7QoppkfPhgcVgcPDeqYPr3oU6zX
3831	fee_transfer	1419	32000000	1	CkpZrHazyn3c9kGb7eba4E67Co5Af2sfQDHwz9vynVMgPrdgtGq2q
3848	fee_transfer	1727	58000000	1	CkpYYPBuMREwo2ZzVKmXxehyb3kCS7NdLhGhLHwhxNpMVGhwh3FEo
3855	fee_transfer	1692	12000000	1	CkpZFbEnvzqp2dE24GRXdDMCruVUDDZFZi3wgiynzmB8HM7jLtgpg
3861	fee_transfer	1471	134000000	1	CkpZ2GDucEsxeCAwbBRpk7JqRKiB1Ua99Rk8sXvRz2a9SCwvhxgAn
3868	fee_transfer	1741	13000000	1	CkpZGDpiixaeBSzpqXtG5xoDTyhmjqYxtbSn4YWH8s5hUHoCrMz2V
3879	fee_transfer	1670	65000000	1	CkpZuBszDgDFqefeg2BPgioxxkdzzLAVg3mvZu5YjV3Nef1sRauz2
3882	fee_transfer	1684	25000000	1	CkpaDwj4jWawFrPsbQ2GqHLjjaG4EmkkuVtTedMGRD3ycP5gPSoDX
3887	fee_transfer	1691	13000000	1	CkpaAYGtyccf2CdREwD371hc3uFsz47gVrNTw5k1cK676gdYcfCDs
3894	fee_transfer	1546	13000000	1	CkpYiW5mjUBn5Z9yEd8NwKdjHBPd88ZctjtdcN2kecj8ms8y4uHY8
3895	fee_transfer	1467	13000000	1	CkpYmhiTwHk1qAn2L6GPSU2Q9ZXNqVvMDw6qvj7ubk8HrKQVU4217
3912	fee_transfer	1719	14000000	1	CkpaHypv3oXY7EdbGD64DkqG8sE4PvZK1KRSVSZ5VXTUaqQvboyWv
3915	fee_transfer	1677	46000000	1	CkpZDx4EFCYshwCFrWAVgWmAVa3zSy1tnJwPfgoschBFTGeJKYsVK
3920	fee_transfer	149	23000000	1	CkpZbfcC6En6kbUMhCG6cZcZ7yMd767oio7dzRmiyUGc2NaHNjo8B
3923	fee_transfer	1727	26000000	1	CkpZwRtau1Hw6Eskazk6a5YkuVqdbn6C87cSYfrvPGo8LzE5yYY8p
3924	fee_transfer	1714	3000000	1	CkpaEppjr438RVKkGpghSgLWPu4o3EaMuufpDJkgnS6mbasC53dqk
3933	fee_transfer	1678	12000000	1	CkpYQ2XjHR5jxsLeau3oorfLFr8Vh6itn8PFG6HZfviEkXHRyaNes
3940	fee_transfer	1560	41000000	1	CkpZrWBRaL1J5cqhhbVWaCTFmGUMSYajN9LKcMffBtyAGT2G9Jf27
3947	fee_transfer	1588	13000000	1	CkpYwhedtRkgTXoJVmFYXym9zZQdCF3fc6MfgcroY72k4CbUEptJs
3948	fee_transfer	369	16000000	1	CkpZKv8Fa2E8TaNiM8jdPRH9rT1Ffe8d14yaYMefPkGhNL7nwKC5Y
3949	fee_transfer	1723	19000000	1	CkpZkUg3Brx5sgiHVmYkHMq1fPauytBcfXNsFb3RUDd6fcjDTFF9M
3954	fee_transfer	1672	13000000	1	CkpZTRVez1NmksuzpQ11bVsxom4vVUs7U5CmjphLSVnD7dEHNPosR
3969	fee_transfer	1702	76000000	1	CkpaAiaWZMfuyVZ6XneMaPFYTCV8VEbpvDggPTMDyJ3h9PRRxvYZi
3975	fee_transfer	1689	13000000	1	Ckpa9NCJ2KnD53qAp8f3NUd8dHm4M6GgLkVXwKZGBXLts1xqkKBqV
3979	fee_transfer	1458	13000000	1	Ckpa66fRsXzVdNV69sNQqztKN7js3Rxxqfm7u2Vs21X6habNeEvL1
3986	fee_transfer	1678	39000000	1	CkpYYocjwXJHVt4oNmjaPPEnW2Lz4XSLyTsweseMMYD7P7tVSHWF4
3987	fee_transfer	43	26000000	1	CkpZbgqrucfks2SdyAxpxAqsQ9gwW2Jo5YFLtVo8ApyhoxXhaR9Zu
3989	fee_transfer	1474	31000000	1	CkpYkrLuhCwe4LwneTobm7rw6PRvGd2igVWL897s7rFHSFZGg9k7j
3991	fee_transfer	641	38000000	1	CkpZxBKAqhFhHr3SUjbNxknddcnbz9WnZcM62qSr1EZb9p88B5ExN
3995	fee_transfer	1656	13000000	1	CkpYn5AxzBRmyVikwMw2Ej3DTTBY1BVG8xj8W9w9uHqmoN32KqdfF
3998	fee_transfer	1607	17000000	1	CkpZFzr2fUdP4jgSPPKsxZsUzA1SSwujsqrSiiAk7YHwoJ4WiQzsM
4003	fee_transfer	369	51000000	1	CkpZyfLryCNpe5WUFmfF3yoUXUoXYrnM5GVjVo5znpEgo2vR4TbAV
4006	fee_transfer	1593	15000000	1	CkpaBafkvEbCLgPJEkXXkNJFyJdkcEfnYcVndxDNVxFFBfRBiYJEL
4015	fee_transfer_via_coinbase	1796	1	1	CkpZcg4RcygGnCMeAksTYzXfJ9zmPCuVQCBp8ekFYBBKpAViP9Dac
4016	coinbase	1980	720000000000	1	CkpYX5RFtyVkGUKmLL4veoe65ZtXcKKyiAgUnY1sPHgQ7iTxJV56w
4017	fee_transfer	1796	3	1	CkpYWVgNhzsWp2Gy2TuyM7FNhMJCXhZvY9sFzJAVndAo4vDaxTaJZ
4018	fee_transfer	1980	995024	1	CkpZrwaqvpS19DTHesDL3npcNLBxcuNhZepXTt2iFfTgjUfsfoBsu
4019	fee_transfer	1449	5000	1	CkpYsuVXpFy8CkU5usTctA6X7xwBuMe4AR5q25cWj6rcQV5NSqa49
4020	fee_transfer	1527	26999973	1	CkpaKDTbznxaFQEcScPdjoFUzsho6Ga7QjTxKWkjZf3YCNncXhFKw
4024	fee_transfer	114	28000000	1	CkpZbdQGxibAeLQ31s9PTnKZE7ZceuZH5viBSHr8Yv6hSYvPGm7Ly
4029	fee_transfer	1692	26000000	1	CkpZcq6EA7dPdndpkqzTrr9XeeSGfNvG9zTCzRasqcab9da1uTvyr
4034	fee_transfer	1692	14000000	1	Ckpa49AKgCUaQxW2j7mdisqG98ApwQQwSyQG1NrLdF8J3fiyRRLFe
4038	fee_transfer	1649	17000000	1	CkpYqxEpLvqjvXvUdS1PfWXrhWM5HN1CvavCsQtQqnp6qUSLwpVnV
4040	fee_transfer	1593	13000000	1	CkpZgmNYoSxyhRCDLR7DUD6FBqMU3q233hPkCefbuQXDGCAavUva5
4046	fee_transfer	1764	36000000	1	Ckpa5387a44vqnLSvcJHEk4TMM36dVHn61LByg8xNHaX9a4v8mbZM
4049	fee_transfer	633	13000000	1	CkpZ64At8oaPoEfTEegs335FLLnPeeG8vwpFYbjfyAtkQGpQkVtMB
4050	fee_transfer	1677	18000000	1	CkpZA4ahFNWH2VH21pMCA7398sKKqX9JyQNfBAB1kzLbnwnjjoQoF
4052	fee_transfer	1622	13000000	1	CkpYYvXuE2BCYc1LMHHoBpbFeLDka7usDVcSrUkDXp6MUtirPi71P
4055	fee_transfer	1650	15000000	1	CkpZvZSrgSXABzXzu6bd6C9U6f6HQAW6iYZEezhKNcHnZDH5tEsow
3721	fee_transfer	1711	24000000	1	CkpaEMPrnmNsekxyp7wyZWG9BacHhqq3kWC46hE8mGMhupANR4ASV
3735	fee_transfer	1597	15000000	1	CkpZJgQrg8xmkhV11h8LJH6c7DFBSbwwQvGcigM8zGyYa9K4nwo92
3742	fee_transfer	1762	23000000	1	CkpZbwpztbk3t8Sxz8Cxw7sGgHEwNsbu1HgUoCVthSaQJ7yKbMABv
3744	fee_transfer	58	26000000	1	Ckpa3w8Hfw5R6oMtWZjWEvxMHUL2e4m7amfawiJcJ2cRZxhHrvRXf
3749	fee_transfer	1573	12000000	1	CkpYQzVLX87P372QRi8WXRVUiZxB9gk78u4NiT5pwytmERnKhAyFW
3750	fee_transfer	1649	25000000	1	CkpaEDDqEUVCm4wkxCAb1FUsUzcMSuoqnkYKp9r6z3AXyjqomAirF
3754	fee_transfer	1634	63000000	1	CkpZgiijq3ZbFm4FiBGKVkKYVfuYrGoZgKtxfbXkoiRni8Woy6vJr
3760	fee_transfer	1709	1999976	1	CkpYuip21Gtbv1QDTA1TWv1kuZ72yCgCTVcztE19AxbwSPuSuuP9x
3770	fee_transfer	1691	12000000	1	CkpZyU1xEQvSrGzEGiwaHgUJoL5kFxyuvPZgLnYDrUN5GdKoxthSq
3771	fee_transfer	1547	46000000	1	CkpZqUeE4UpKyFAE12SCaw9CSw571zDvn1SffDc4TKZJphpfRm6se
3772	fee_transfer	1768	70000000	1	CkpZdwym6uQY1TkQFcTPGZUeVXpNgrxXBWSnkY2J1prEp7s95C2pQ
3782	fee_transfer	641	12000000	1	CkpZmGw6DpcyRSvCZwo87xtyRDaCPrhvcaUAEvKbCpaFJ3UJy7UgQ
3784	fee_transfer	2086	12000000	1	CkpaCLdgcisqyfwRRgFRZ3ovBtZkuRF9trHmY1voTWaUSrRq8ERFt
3787	fee_transfer	1654	14000000	1	CkpYme2EVrV16xE4s2cazSqeQ6cLjXRgxuxY31hAPiaYvybpbBKLD
3792	fee_transfer	1683	62000000	1	CkpZZxGVPQz7weXcD3F4Xff2zxD9KKtCAb6TSEpEwDG1dd7iVVXNg
3800	fee_transfer	1649	32000000	1	CkpZzL2d1JGZBSY7rpZi85BNhApMioUGnnTWkdhRczj1bAhKn1iQQ
3801	fee_transfer	1649	7000000	1	Ckpa9sAbm6g7agBE2LbkLhwkrtqCpFJcHRkVu14bv3PEWUhXvw3S9
3803	fee_transfer	2087	13000000	1	CkpYQ3f3vbqVuapsazX93JHCiToiMDtBFwxLhkwkAGS53vFVFXA9p
3805	fee_transfer	1508	24000000	1	CkpaJ9tbSfb8JBAPvkVqsrijfwFgy7k6yMbDZpYiUP6wJoPpVTr9e
3807	fee_transfer	1601	13000000	1	CkpYRPaSYvibwcB1u4rqfELemZgJeQkBBnzgEtQWDyttSyjTsmUy9
3815	fee_transfer	1716	12000000	1	CkpaGLTnjaXfLpPr8CdFa9qmazb4Q9T1fwDkj2fNTSUKXtwPjZKAG
3816	fee_transfer	1749	13000000	1	CkpZJrJnUjD6o8Xr12m3hkQZpyoB9DhXUxsfXtWi6VEcSVqkBtJxG
3817	fee_transfer	1685	2000000	1	CkpYWphZ8JJtBZWeJcjsjzPcRirHnEE3uX2biCY16jqrwejBQnUJh
3821	fee_transfer	1599	13000000	1	CkpZyPBsup2pkEdZzvFWbHivRmXjpcWhRD43TjBj7WuyitGtwfCgp
3825	fee_transfer	1696	39000000	1	CkpYtSb5sPJqoqXENjvUq8SMsCHwyJfho79H4yPdDBjDxFoPXXG9N
3828	fee_transfer	1694	52000000	1	Ckpa4n5vxXvMeMkmNE6EA5eiavwwMg7ukUYLUv6Dz82ECF2a4D8P1
3832	fee_transfer	532	32000000	1	CkpZinBWZE98PDwuDrKrBtWhQQ92GThxaQPW4uCjz1dFQ2dZDReWj
3836	fee_transfer	1695	12000000	1	CkpZAGYvN2mE7kHMbj6MiN5fVvR5qvsesSoUrnTuMTEkNYYWgZRPd
3838	fee_transfer	1850	12000000	1	CkpYj339sgJpvRtRR6mgJ3D4V4KvVrqiAReJ5Ed3Hp3GeAf4vc3WX
3840	coinbase	1677	720000000000	1	CkpZuQf8d8iMg5AwqEeDUujuvMGJRPNwrmquuiDRMsJ7D59P2oHFY
3841	fee_transfer	1677	1999966	1	CkpZgDgBEg7UN4iYThKoCRyVk3HpvUXcqt71TX4t9EfywrQAQPdqa
3842	fee_transfer	2052	25	1	CkpYxawXGXd1quv1CcBqtpcwek36RuM44Wp6J2QrTnswVkwwWoRLC
3843	fee_transfer	2004	9	1	CkpYy9JUGPrcVPQWR29mDenGYzfMXXnZHpc1HuNqQ7TD5wTzgKgbp
3846	coinbase	1646	720000000000	1	CkpZzCC7SX2MZJTGG8EtpNNJeJhCn72V1oznY4ECcnniFjVfoZZ8x
3852	fee_transfer	1670	88000000	1	CkpaCRcTdN4a1otzW1XwsTYhw3Mb5KHCkPXjdegSSMmnqMQgUTGAD
3854	fee_transfer	1466	12000000	1	CkpZcBA6njyLtv5S7gcaCxM5c6gzcAyaNDccVqQru1Gdpq1UumJA8
3858	fee_transfer	1564	502000000	1	CkpaDFo8pe1WfAD43bQqwvzUGMmnA5jqooGiv9gcqcJN9qQHJmvWP
3859	fee_transfer	1564	470000000	1	CkpYsV61K7HJLsV6ocLJRcVbGGaQ5hhhNW6NMRUcnXkcK8Mvfa2sN
3860	fee_transfer	1423	11000000	1	CkpYbm4yG7gsEiyLa1nFtz8dtkzP7TtJbfhyEoiTyYUpKsm1SH2nx
3864	fee_transfer	1467	126000000	1	Ckpa8rP3S47rGHzMuXKuZntQe2s9g4m8XRtJ4PCnXNh4u3cA1T5rz
3867	fee_transfer	1571	13000000	1	CkpaAhmzwKuQgUKqKueoB7iomJYypiNBHiK5g9zpU9gJDc11b7TNx
3869	fee_transfer	1423	13000000	1	CkpZ831oZDu9xeF146Adqqzc1WX2gqQbCJkQRRsZHxoitW8tVoZUx
3874	fee_transfer	1599	16000000	1	CkpYwwG7d9zaa8GCZ7Az3VgGEbVACsDDeWLp5gKKZWvF313iKK2T7
3875	coinbase	1591	720000000000	1	CkpZedRd1EqaMLfpEMXQo9D8swhpvqXeVRNDGkrfvxECByqWTokAU
3876	fee_transfer	1591	13000000	1	CkpZmsm8mZXQESuaKGZkc6awUig1rcHVJoPxtvci4dJsTcf3ZSoUq
3878	fee_transfer	1746	13000000	1	Ckpa3VyFDKpqANXu9oqnhM2vDgAh2tuuHdFqsYb7pRwVN63rsuFKG
3883	fee_transfer	171	25000000	1	CkpaAEAxNdLTsNWErW7Y84wR6PEETmTVqrYSFLxbFVnKWssi3y29Z
3884	fee_transfer	1696	16000000	1	CkpZzKfVURBaAuCSZsEmNdSdYUBA4mLYHJn4NvRtq5zLKTsgATS27
3889	fee_transfer	1683	26000000	1	CkpYgcYkjjVXPeArAUVfwtwc3mxVezCdUeWeDXsMkfS7FJtwhSKCn
3891	coinbase	114	720000000000	1	CkpZphJHpoCCt8QSb4T5PMQ3YWknvhe1JaXSWL2KLPoAm8cC7ht29
3892	fee_transfer	114	10000000	1	CkpYtJkg5d9ogwg3349Uk5RtzP76qw26H2AV9KsfQZxffiBvEjYPZ
3896	fee_transfer	1634	13000000	1	CkpYUzq695o9BjYyjWzQ1DCANnYChLQkuuxbgkxDop5zBz8cMBfzd
3898	fee_transfer	1683	52000000	1	CkpYQSVpCmjz6fDKwL63a5ETaqguaeaUUBRLPUs1LpEDXt1piDueB
3903	fee_transfer	1719	24000000	1	CkpYgE8GSsVfnSNHF14f8uBkLA2xu6v9nrLEi8BzLUB2e7SQLHT5k
3907	fee_transfer	1694	23000000	1	CkpZPuDsaYGjAMY8QiBUaFeNvmuybufuCyN5YoFVkpNoNGmTWVdsw
3911	fee_transfer	1559	13000000	1	CkpZtL2oNgnBzTepxZxoXoJ5rmWYhFJeeRmHuHpmj81QFyG3dRFSH
3913	fee_transfer	1402	13000000	1	CkpZaA7wXyQKTdgaJ9ihFtmzaFwYV84AW31siXpWgvQvBUi1a6QL2
3916	fee_transfer	470	23000000	1	CkpZ3sbHvWznJV4Xb7CVPTe1xgKgRRF5NLLwnkupAFiHVTVVYx1dx
3918	fee_transfer	1649	16000000	1	Ckpa87FEmGWMfeQEbhaCDfzN7RaiaiqVHQ4haKpGDnHHDvCgPVdrQ
3921	fee_transfer	1633	23000000	1	CkpYT82B7roFaaGNhj27cPQiKn43oWWW95VVrcLDYTPZTWPfMJyPM
3929	fee_transfer	1740	39000000	1	CkpZtt9B8Cbdep1uQrG9g1V14qtBBafhCo4ijSHNKSGwxazNK4Tf6
3930	fee_transfer	1690	52000000	1	CkpZExQ9LY9XgrhnDKafrMNF8q1xnHr7HCPMuqw9Vr5ghAUc9Vc4x
3941	fee_transfer	1685	52000000	1	CkpYbhtHJzNswhoHBkUAcusPmDmD4ZPc7nXic2wzHbfmHsUMJQ4ka
3943	fee_transfer	1458	16000000	1	CkpYRTSLR66o4kcVybbLknh4mqYSfvTkNZ5sn9LHbZFZPmt1UPqDT
3946	fee_transfer	1677	26000000	1	CkpZUqABAbhgcT7AR4Rta2c13ZM9sQQoVPdV7rwf3gav5hy9MWinQ
3951	fee_transfer	1677	16000000	1	CkpZ2kXdM3FP1EfD8if8LhX1U6M5LFau2YFvFt9qh3FY2C8WR8EyT
3955	fee_transfer	1656	26000000	1	CkpZFJcHsBmxRfMs9Q1G4nFZEfo4KdE25YEb4V1CeYXuK9SHDqkox
3958	fee_transfer	576	31000000	1	CkpYQVyZfuc4TngoAF5SKnUHG1Ro2AkVfUpqD9EQTPuDh9RicY9Z1
3962	fee_transfer	1455	32000000	1	CkpZu9etUFwsVZWPniNP91B45EWbD6uXg9M8UXJShCNcVkU7HAxMw
3966	fee_transfer	1684	76000000	1	CkpZ6xptsrTk9RHA2stXFUZTZoPTexdoYo6s4HnuxGKqFnBiCE7PG
3722	fee_transfer	1709	21000000	1	CkpYgKCiRR9SFU7cQ4VAAbznwbtAnGmsdAyQQoaBwL5EzJueXJDKe
3726	coinbase	506	720000000000	1	CkpYuwBCNgB1KpySKwFK29giBczpB55AGFtVWhBGQTxYaMDvCWkX3
3727	fee_transfer	506	10000000	1	CkpZavKmaJHGoJTMLepMMLKfSnF6GDxZkRyqCbW4rGn9LC3XrxPbb
3733	fee_transfer	1747	13000000	1	CkpZKLrQPaeBniwaB5kjqZZsodKwfv2krDjabTkUeqRqEF4Xgv9Lf
3734	fee_transfer	1683	51000000	1	CkpZ6cnwiNSXTUj4TSf4CpoqfN5oWo34vVnE4TeNJ5d1XnK9uXv45
3743	fee_transfer	1740	23000000	1	CkpZZZQZGRKrPuNJEzJdkwZvRy66dhRK39csanqseRWJwUw3bXTrF
3745	fee_transfer	1588	21000000	1	CkpZ4tj3ojHax3tVDRhWtWAP3mgZPqybr3KC5iVo8szGNbLcSuLhv
3748	fee_transfer	1509	328999993	1	CkpaJ8EtJWWtKwy72N2M5UnVS9pZvbzihZ3xJKBZ82Gfkr3EyidQF
3751	fee_transfer	1607	13000000	1	CkpYvBvBUzzLMAE7UR6v1kyEXX8HdhKQxKRDm21AKbwmw2u42uR2Y
3752	fee_transfer	1448	16000000	1	CkpZVCKxkcgcHVT7hehno5u6c6iCW6pcJaRmiiL6fHGxDmP4h5i6H
3755	fee_transfer	1447	36000000	1	CkpYuDCxhvWwiaw2AVHSvGX3gqDKESB3y6B15EAf9EroaQoJywPfo
3758	fee_transfer	1693	36000000	1	CkpZDPSEUhNmFXHzDaftv7VzPfsFc912ZFCjhkQF7wL9ZAF2Dtn25
3763	fee_transfer	606	32000000	1	CkpZBJM7wnT4BTuAqwMtdPBjXyDaL3FCnFRPv63yFD1QBf4Wmta2m
3765	fee_transfer	1474	36000000	1	CkpZaoyokvvGx4KkRGCdhW4dkjcLFRpRgBzCNqkSexb5TLtJHyxr2
3776	fee_transfer	1695	13000000	1	CkpZYuGJgNPSJnFPuvnVgXxWN2c71fEQbZBGk7ExJXbGXkSNV1odQ
3781	fee_transfer	1522	23000000	1	CkpZW1sXxbJYYnas1qEc7o1KQANq3hsD2LVj8CJ1RsNbqoa1qHrUV
3783	fee_transfer	1696	14000000	1	Ckpa3VNG6wsFduSsnndBBsLnyyjKT7GbF22mnKm5BCFD6xcHtwGjA
3785	fee_transfer	2087	12000000	1	CkpZcycbaPEv4qgSFn9pL8Fi8AMBo7cVZPd9ZnG2ShcECvGcCCQn7
3789	fee_transfer	1747	16000000	1	CkpaDqLTK2YXFFemdAp1NTrEmtfw6cKA2kGqzhLdf3XuqzxvdRUQp
3791	fee_transfer	633	37000000	1	CkpZg24vpu151o7t9G6cP7YCVeBuRAUbkddCcgRsQxy1C6Y3oAqn7
3793	fee_transfer	1695	62000000	1	CkpZ2jWuVX5nUrozHJLaJs5BModisjWXmrB47ickaTKssQRya98ct
3797	fee_transfer	1768	312000000	1	CkpZXDxBPrwscbpx6H5U5NvNQQR954kGoKC4E447dW5MKMnHc7ie7
3798	fee_transfer	1668	36000000	1	CkpZDaoBZpgTfVFBVyFuasbG9uFLfUbaNuViFenBRpTT7G5wzatyq
3802	fee_transfer	2086	13000000	1	Ckpa2kb3fsETyngzk6EruNe1xE5UmauHdFZ68z9pE29xjBuqmjHn3
3812	fee_transfer	1671	26000000	1	CkpZwtmvN3HLWrzV6Z3pXGnTUvHzz8N8FgRHiFz5ybNSPHQ9pXvpA
3826	fee_transfer	1419	39000000	1	CkpYW7dfw1VvGyoet9FrhoLLxUXnALVPXPb3i6dTyx1C11peNeG7j
3829	fee_transfer	1555	32000000	1	CkpYb8ZiBX8Ro5CZ3BPz19wzrnrutR7zBEzCnprhzxVmGAyEnHvtd
3833	fee_transfer	1708	52000000	1	CkpZtHGRTUbfez7a1nYFHRmGUTbUq9kF6LyHeym1izv8MUcWK4YEe
3839	fee_transfer	633	12000000	1	CkpYxV7PxnKjw72LNbZs194U5FRWqcLKg31oyoaWSejZHorAu8Nk6
3844	fee_transfer	1706	772000000	1	CkpZ64WhmCVFrVfxuWNQMrBBiP9JVzo7CfxwHKiJtfTFh2nfG3hjf
3845	fee_transfer	1706	570000000	1	CkpZnwKuiccjRxYYSq248U9EbdURuPgMYpqiw8G48d2c6CBzTKsRB
3849	fee_transfer	1616	46410000	1	CkpYxt1HEwfeowYnGJDwyq8amFJbku5RYG3pWRGJkbzvtNobfBFE8
3850	fee_transfer	1670	89000000	1	CkpYc9pgTk8maiAqTTvgpuS4hX6krzXL46V4uZSPRA8vsgWoh736Z
3856	fee_transfer	1683	43000000	1	CkpYWFE3Wx77pDwQXjEMAF8h1zzXnBBHR7Du52diT72jLz7WE11uL
3857	fee_transfer	1457	22000000	1	Ckpa9bG7dRz2crq98YLHchWvd48NxAVDJuNpJRwf9wwf2RQrfSCmH
3862	fee_transfer	1649	126000000	1	CkpYpz8eJcgPF4n8JMp1c7W65HEDsiG4aAkiregZX8usMjPe3iiKs
3865	fee_transfer	484	27000000	1	CkpYud4Rbhb2CjwNorktowVnxiaQrRHCNWSirYSQ62zuawbPBCYy9
3870	fee_transfer	1670	14000000	1	CkpaEwsULyuUm9NXmnf7u7qioea56v1Z6sNNhSYGr53WgfDBEH7um
3872	fee_transfer	2039	13000000	1	Ckpa9AnuJPmGucTv7Ejz7UZUBUyz2JDJFCVuxGDgdEA52ZM53TxFV
3881	fee_transfer	1646	50000000	1	CkpYhUB13LaY6VoWTJSFC7EwBy1pP8thDbZ9ST7yZmMaDJb1Niirh
3885	fee_transfer	1596	16000000	1	CkpZMu5mb2v8UowUYPjd8QXWvJAw5dM7pypfKCQowqdVCdShFpgcn
3888	fee_transfer	1587	26000000	1	CkpZPJxbRh7RPfqSwt1yqFA9GmwybjfnenrRpDK99q7Xm8ERi8NNk
3893	fee_transfer	114	13000000	1	CkpaE1cEMjScbASTLR2c9UhEY96JJk5PkakPvtp1HtUKBUwHUWUfc
3900	fee_transfer	1980	770000000	1	CkpaJj7QU9JLGSCXKjQwez2SfFBXiMisMzmsJHTmNe5FxYar5NSfR
3901	fee_transfer	1980	192000000	1	CkpZpfrJHuNjfXiRaoqpp5y5UNeCte8SuowEKUgJ4xE5RWcnG3HXX
3904	fee_transfer	1706	26000000	1	CkpaKiMgZX8gg58JSWDQqBnoVwQpUBXoyUm6VVZAegXGqcHQcuTrR
3909	coinbase	1583	720000000000	1	CkpaAcJ63EktpZ6K1p9emeow7k4XMzwRPYzGLkvLFb37Y9nTZp6KE
3910	fee_transfer	1583	13000000	1	Ckpa8cNuaH2yogbbsFpTZJxG6VmDdNjbj8fysL7KNf4hr8dEvYDxd
3917	fee_transfer	470	24000000	1	CkpZbiAFUrovxRj7HgKHHuePBo46BHu2KYGua1xkU2sHaiSS5HYYc
3919	fee_transfer	1673	16000000	1	CkpYyGRS5v9jWTQsFXoCpE5pXPcq1Ka5S8VMnZh6DT63hXJ6xKUz5
3925	fee_transfer	1673	52000000	1	Ckpa8kKN6vo2XW8zGQhgLVy3yCs4iavXtbSrNdmgKtNkcyYxdroCe
3931	fee_transfer	1702	68000000	1	CkpYngCrusxMvJuygrruq8TPVXb98EdSJsgrQyb1dBVJYyzDTe5Xn
3935	fee_transfer	1740	567000000	1	CkpYgS82n849J1myg4tgw7iC1C4TqRdnW8N92RMFiudE48KRsuHA8
3937	fee_transfer	1685	26000000	1	CkpaAfumLxqaaNVZaf1WJNgrpYitu5SPsmyGDFA62BjNuo8Em5f7x
3939	fee_transfer	1560	52000000	1	CkpZhqJbZPUg6wohoncdma12Xwbnbrn3PwW7c5vPzB1qtfWiEK9ao
3945	fee_transfer	1692	19000000	1	CkpaG9M9GNFmCJMFGiWPTXdFxtYBStcgBrDi3NbFZnrHSp7EPfHhn
3950	fee_transfer	1522	13000000	1	CkpYrNKJvXyZU1Xzwi3FZ7Wr8Z8Smzz8pj518Sy7h2xXoHRqMksRp
3952	fee_transfer	1672	26000000	1	CkpaGCCaYdMS11mYgd8cbfv3WsuPF88LDF5ZDK7PskqUivEBjD29G
3956	fee_transfer	632	26000000	1	CkpZMeRkhfB9tY96XbTrSuo2eVuyBiV9ZWeGKhPwXZ3LwqFSt6BYM
3959	fee_transfer	1692	13000000	1	CkpZsJmTkqvJGd8DbUFVW7J7QHY93iboEDSRTTSYvmu5kswsPGr5g
3960	fee_transfer	1643	16000000	1	CkpYx8cVidhesnGJuZEprRN2v149cpERrYyTkStFigrPG3mSEEpQL
3961	fee_transfer	1672	32000000	1	CkpYqUoJ3xa9hpRSPQ8fw4JysvQaWVnhB7yY2iEe63kxYNvfz7LfS
3964	fee_transfer	1685	32000000	1	CkpZFWrEX2C1UDmiV631PymRXijJLhWHdAPphr9pCyP1SJ1NUo9eA
3965	fee_transfer	1677	76000000	1	CkpZDLYcZNxy1trC66Bo1C7SvHMv4bcgtmRob9dhPesizPMDHn8rd
3968	fee_transfer	1696	76000000	1	CkpYisWvYwEQ1pyuwbj292mYJymwAoXLkL7ryfQWXydf7DnUjrSah
3971	fee_transfer	1608	26000000	1	CkpaCJkMdgmNyFXpSWHLSvkLCXWQjYnwxYqfeuFh3LJpajg8YQM2H
3974	fee_transfer	1683	29000000	1	CkpZBZsexdHXBZ3AtzsWqWv4d4eivAVJeJZ6yGfhLjc6MgwQmzHdb
3981	fee_transfer	1571	16000000	1	CkpYwXpzK7qtW17g2eypAqGyEnrLFo44Y5foFY9EHLt5u9wtjGDfA
3982	fee_transfer	1594	29000000	1	Ckpa8V3tFqri4Ew9dAj5ZSBhoVgSeNhW9o6rss4A3gyUa7Cg1yRFv
3984	fee_transfer	1991	85000000	1	CkpYqfTr15EVfs4Mg2VCayjrkhSaqt7g2rfRvtG2RFxrBKQeMgAbS
3724	fee_transfer	1709	27000000	1	CkpYtDwbxtoLfSfir3Uy5z1GYYn4JqZHsrKkw8zbnBELzgrpXaL1r
3728	fee_transfer	1715	13000000	1	CkpZxnU7XDkbccZNdCv6ThZLdchY8RmE77ZwwTyFbk3KRBnPKjS29
3729	fee_transfer	1419	12000000	1	CkpYxBS6pr4jVzKdebfKNsrUpSmt5xyh63fnVm5YYmCQcLtQ9WUca
3730	fee_transfer	1683	39000000	1	CkpaJw4ZzConXqM2J7RzyJiowZr3aYrPs1TLLpAq9yB2mB1SegPpu
3732	fee_transfer	1506	13000000	1	CkpYekPSKYWiQvV9BBifNhHMD6YkkxBVBQ5E3XYtHmaeBR4GcQNML
3736	fee_transfer	1729	6000000	1	CkpZNq9tnnfw16P7WPbJarq1V1smTSVQHaZYKniQxgJpxX3XLyCnN
3738	fee_transfer	1703	3000000	1	CkpZ7n5fHbucvDB4AsbySHdLQaMQvF8JErxRBhphzfgRGybbfXSJ6
3739	fee_transfer	1703	3001000	1	CkpZcGtoiVD4sNuZNkrfYbzSC8hdw4MxAbEfbnYnAM3cDma37o1ME
3740	fee_transfer	2069	1000000	1	CkpZ23MbQpwudLYnybwzBENFjKpnTc3gRGwF9Wo5u4pV3Fxty89yN
3747	fee_transfer	1426	12000000	1	Ckpa66MEczsQFkQF7uvWzESHQHJvJ3LzDS6y9oprRc31PDVfFCTB1
3757	fee_transfer	1506	36000000	1	CkpZMM9WK2BzDnFiuddS7evHpyzQhYEZb1YHpL27cPrdzx6V9QVb2
3759	fee_transfer	1709	24000000	1	CkpYywZoPDZT8XVfHnSNP6zqzwQo6bz6a2K27km1WfyUA96oznVd8
3769	fee_transfer	1762	24000000	1	CkpaA7EEcXyUANy97mCoHfyxTP6pyZ733BuKJ1PhK9AC5FvCQsgjR
3775	fee_transfer	1448	13000000	1	CkpYUpwxwdB7jRoR6pcTBZczdprQ9qcmVUdzCAXTunrZYuQsq3Px9
3778	fee_transfer	1633	13000000	1	Ckpa8DT9NkTVzQZoemfe4edgMTgXqRwLAKYvrBBdDqWQNyoBUcvFK
3779	fee_transfer	1685	22000000	1	CkpZHZtQ5J7EnyPknyLVwHzCo7SRWaWjFNEWM3NH6cmfZa4hCK7Zi
3780	fee_transfer	1991	23000000	1	CkpaKcTof1fq96WDRwL4mGJMSrz4wRUiiP8TYXQMdwK9LvvW4e2dB
3786	fee_transfer	1698	14000000	1	CkpYtgPtA4dnsGxtZEHFznxK329VzmvhhuwhGiwMXaEUFpPt2QWC4
3788	fee_transfer	1704	16000000	1	CkpYXTKEYgA1EeJNQBTD1XxQe5M7YPWzkNUNEeGZz3SNC34j5jFU3
3790	fee_transfer	1467	12000000	1	CkpYskdiXQcKRqLs2stBsrj2iToWUDdRGcJsZC4TCxGMpPkJvX7Th
3795	fee_transfer	1564	382000000	1	CkpaKrrkHidaKVX9R7JqiMzuRf8dWYA4h8xURUriibajcYGfKdeEL
3796	fee_transfer	1457	12000000	1	CkpZghB2srYKDdiiGwrTKY1S7yMUekHgtH8yBXpju3dNJA8bRNmra
3799	fee_transfer	1764	25000000	1	CkpZQLxKRZfbnCP15Xyw5CTuPGBLJnGXSmS8GNLqwhdEohQVcxLh2
3804	fee_transfer	369	24000000	1	CkpZ1TGfjQAoCCjR1hx35KuQpnFWyNQcsL2hCmThMjupZY42hAAca
3808	fee_transfer	1593	23000000	1	CkpZgVqzpotYFMSFJukyqQykMqgN7mhw5pnUge5gZwohx3Buh8r4y
3809	fee_transfer	1694	13000000	1	CkpZzPiWTYeBHQ26KWBNQSP2QJYPEzASckjKFnG9woEkWSKfgg5Em
3810	fee_transfer	1426	90000000	1	CkpZwPkozVd6fztpokU8pAiAQu6EEvN3CrBGRinQNqX54qkbP3ogi
3813	fee_transfer	1850	26000000	1	CkpZ4wjXdgqdZ7fQiZcNbTpQASnLUSjPM1FigSstc3SFdt5KmbjL8
3814	fee_transfer	1656	126000000	1	Ckpa6y3xurf8nEheCH9DqJAsQnEneXghYz317VaojbwVDLbFW1JHU
3818	fee_transfer_via_coinbase	1423	25000000	1	CkpYeH8gz2bsBptAEY3NjFRvoxWtdjrFza15Noxtpn4Ksq2LE77Br
3819	coinbase	1677	720000000000	1	CkpaKjn1QaRqNv8giaraLTTUcnA5HRm8tjaQUquANdCz8YhyHufMw
3820	fee_transfer	1677	13000000	1	CkpYv3LxbRaUremKWtpUW8KE2bm6uGXGbfA6R2HDUe8jgJayTyvaS
3822	fee_transfer_via_coinbase	2069	1000000	1	CkpZ23MbQpwudLYnybwzBENFjKpnTc3gRGwF9Wo5u4pV3Fxty89yN
3823	coinbase	1692	720000000000	1	CkpYrGSKqUcuMnVUorZoTX5LNejeruaP9C4MTJGSXmh28prnJM71B
3827	fee_transfer	1685	39000000	1	CkpYxJUXRAZxVhABsgoXFNAYFu4bkaLwvZedHgXNFs6S6Zwtn3UUN
3830	fee_transfer	1724	32000000	1	CkpZc1mm5uLAC2V2CUKrQFBnYjkiAKpPm284Ha61ez4yRXhqULkAm
3834	fee_transfer	1677	52000000	1	CkpYjAav3YRqfWTmNCtBZWTWxwAX237K8pr8AuRzPFp92KrtLYQEL
3835	fee_transfer	369	13000000	1	CkpZYduZacEzKZ9uxcf7gnoC38dJDua2hnCn7FWw4mkjxQzUNcy3K
3837	fee_transfer	1680	12000000	1	CkpYm8FfMn1PGPWsx3VrQdx2erPBjR9U9YqRUASWCvzP6SmEFQsh5
3847	fee_transfer	1683	59000000	1	CkpZFs5L9f3UqoQpr7VvQa9LuQZw8nAh34pu66CNYNZ6bhkDWeHTA
3851	fee_transfer	1727	89000000	1	CkpZVVXzn4CkFgfcQcHi4JgEdzjTKSN9NZcztiDAUsmk5oLSxtLGH
3853	fee_transfer	1444	11000000	1	CkpYuRUX4EPoqydbXktqYWcHh2LhRtncZ2o6xynGZY7rM6Mo4ETSS
3863	fee_transfer	1701	126000000	1	CkpYTwJNzkYCDQSQN9N66J8iaPnyYdy39J92wfZaVjG3QuYpufJDS
3866	fee_transfer	1723	25000000	1	CkpYVUUYoYrnuU3ZpxnZ7gyfAVJbtEdUizy62oJ93aVXmos8ZfXF7
3871	fee_transfer	1467	14000000	1	CkpYhNFBjNwy9941LJmqKUGcesepHe3LFuieugvZuHLJoAMHHNbJN
3873	fee_transfer	2039	10000000	1	CkpYSxDwjZMMwKMXS2ai9yziPaysW3zNvmrW1xwc5iqDhWyHaP233
3877	fee_transfer	1704	13000000	1	CkpZqHXvZUnrE766BJ4oCMEvjLbKZ9KLG3VV3wVo3j5jyGXDDRRw2
3880	fee_transfer	1706	65000000	1	Ckpa8eLbaVBXBs7xyMMnoCS56rgNv3CYj7aAUiZkahU2WHawkRs4U
3886	fee_transfer	1762	13000000	1	CkpYQiNMdEEjyGXc9KaxY9sgAvBdyB3sGixzP9JhdUFB23DXL26yZ
3890	fee_transfer	1560	26000000	1	CkpZPEVtnDEFeEdQCtUvhyQY1vx5tFDyzJ7RuAeFSTeFyaYNK7YnS
3897	fee_transfer	1716	13000000	1	CkpZb3R4jGCTwKBVqQv1V2n9bvDFXVCEFrAAGvjei2C3VEqGZtzUh
3899	fee_transfer	1522	52000000	1	CkpZTaiDncQp5Vrxv3RBmwR8LxvJwKapUEAFMdQUmAFqfa3Vehr4y
3902	fee_transfer	1980	13000000	1	CkpZBopkJMmGuCaR63axoo29TBjFwastYvHa6aBFAwP4t7NXP9CJ3
3905	fee_transfer	1622	26000000	1	CkpaGEdMysEqFrCFu4aNf6mWmy93T33tCnRs8n9naSrMBsLr7gPsW
3906	fee_transfer	1633	26000000	1	CkpZJH7FvZJjH6eB5iZc9w6f8xAu4J82ajv9xtTEBMZGiZozCACao
3908	fee_transfer	1440	23000000	1	Ckpa33DdeTY9mV86BMv5urXWiENv3vbctcRimBoVaF3C3m98cWxDM
3914	fee_transfer	1679	41000000	1	CkpYiTjh1kvdVUALfDPN1tvGUCCN4XtgQcfFo7oXXpBzkFk3d6CvN
3922	fee_transfer	1402	26000000	1	Ckpa1Q2CC2KPxMMuPwxP3QUGT7P5waYjyYMJxi9835Y3wDQeG5Sd9
3926	fee_transfer	1440	52000000	1	CkpYewEy6fDYt56yFAa2enmh6UUyNVTd181wZUVTWrWherTUnvuVj
3927	fee_transfer	1402	16000000	1	CkpZH4V3QF2jaLhjkUDCqkAraT168J6Md4yRK2wLMaRELtfviTVZ7
3928	fee_transfer	1692	16000000	1	CkpZUWkUQawV8PwmhGa6H5vtsSuwDhDn2HzUnA2P3H1wkBCfYvs4j
3932	fee_transfer	1703	51000000	1	CkpZZez4jSuqUpS3hTkoH8nWTshkrQARSYgke5CaTAW2Pbam5QxvM
3934	fee_transfer	1740	12000000	1	CkpYpwhyi67Cn66Tzt4GUAt372CDr1v3e9YNeuNx2ZKksFg3Zxtww
3936	fee_transfer	1474	38000000	1	Ckpa36vH691RZJYsipyFSX6XWfH4d4sp2txU8XQGWekwPWW1p7V8U
3938	fee_transfer	1605	6000000	1	CkpZSmaaeLzYuKUXNGzTyxH9Rx6nBnvDfvW8xDM9x1cyXsw1Pz7wU
3942	fee_transfer	1513	25000000	1	CkpYSE9vhFAGwLAxEDq4EWbWXhGPzPnhaGdUbx1JhHreTN9QLYCkr
3944	fee_transfer	1610	19000000	1	CkpZU8BQ8TySJWJ8RNYvzMG5pM9PjDY6ZPVAcuGZ6H3esEpUFm1GB
3953	fee_transfer	641	26000000	1	CkpZAFYtvqRjmHvwHLTD9KyQwPrDzR6oBwpuRKSzYYi1tE4X2QLPg
3957	fee_transfer	1729	41000000	1	CkpYSYHf1n16Vk112kauUQCTY3zYo4K4ofdZDfjrMuuqFqPmL17mj
3963	fee_transfer	1719	32000000	1	CkpZ9kSowpmmF4MQasD2vH6YRQe2YaAVgWQirTfPVj2jhjM4B8GwS
3967	fee_transfer	1684	62000000	1	CkpZBnEEfcuEXsesH3Z1dmwgVyM2g2CLTMd5aEd9sqLNDmBQXwUFV
3970	fee_transfer	1703	62000000	1	CkpZc1iBGzq9JNYwvzDCPN7RMDK4wM9CBBVnK8sLA57YMgUAYwyRa
3976	fee_transfer	1643	15000000	1	CkpZnkJq7yMtZiDg4at2JQ9oozN46HMW88ZTUVkcFzny8vbMtxuEm
3980	fee_transfer	1991	10000000	1	CkpaKoQfuH2Mxw9N4Bw7j1sS6m6FUNZDkhga4DNLAU2MnLfE3efAh
3983	fee_transfer	1991	101000000	1	CkpYXqKKNMKhE63EGuwUwHTEt5kRg1rxWaCDfopzU4waS9YgqEozF
3988	fee_transfer	1271	26000000	1	CkpaDoZ28EqLoastLAae54KiAcqXpxLg2W2wpCCyoUmfd9otruLvM
3993	fee_transfer	58	21000000	1	CkpZ9FgUhAkKe4yKTaUV2Ft1122GM5eEjAi7nJnF4Ba1D52UV13TD
4001	fee_transfer	58	43000000	1	CkpYbBgcLhEeLn32ixqDaVZj48Mu8TmPkxHAcxQPBrApvYnA9C5XE
4002	fee_transfer	1749	42000000	1	CkpZ9RhEwzMeXwE4Qc4Seot7NUaUCdW8y6585TTDukwmbKp3t5mVp
4004	fee_transfer	1513	22000000	1	CkpZEGLnzLa9fADTQDk27FeTaaWrWqi2ZXKELBULUuBfDQqFqQnHS
4008	fee_transfer	1476	14000000	1	CkpYWpvcRCkXaHrLWdT3winNy5oTVixKCZ5FJsB3LyYWrDYtBk3WK
4013	fee_transfer	1444	27999999	1	CkpZkmtD1ZF4bSDWxMrEuUArH7UcPPmJfJUPV8Ho4ujMPc5drBzvU
4014	fee_transfer	2097	1	1	CkpYah1WARoVEr4sUrsEZzYW7DD1QF3XSi1Xg5w5g6xsa7bitWyLn
4023	fee_transfer	114	27999999	1	CkpZbqZzG3614NdYip4EH24DgMA62jXYhFa2EKF47namfDFTxnCkY
4026	fee_transfer	43	15000000	1	CkpZC6KsABKpL6xWvuSWunsGM6FE3cnRAAopBqMQg5oWxJPjbgwC6
4027	fee_transfer	1560	15000000	1	CkpZMHG32zKPnq3yqydJ4QUJYVFWnQD5KzWEWLzDsC2hUffmfH8g4
4028	fee_transfer	1509	12000000	1	CkpZ7xqzJxP1q5tZWRMwnT1dVXYEh4TwZDKbjGyZLzfTyKpQKt3m4
4030	fee_transfer	1513	26000000	1	CkpZEzf1avsXf8X4ASzM74P1UN9Stp47XxPRurdF54REgHRQLGhPS
4035	fee_transfer	1474	26000000	1	Ckpa4k7YmAXDMnxFPihgPVqHz8YhRwvGVkT4e8ryDXUzWU8wsbz52
4036	fee_transfer	1719	3000000	1	CkpZdQSDSkToxW5UGYvzBRfZSHBxhAe7MNonFyKFn4t255SmwUoz8
4037	fee_transfer	1587	3000000	1	CkpZ6BzgqkVoHJwP6L8F7hsLWZJPrtpjzkoeZdhX46gcdwVpNYXh1
4044	fee_transfer	1764	33000000	1	CkpYkk7auLJ4FQhvh5cCnGug3MyTdYcMGhUmRv1tnmVoMypQy9ypj
4048	fee_transfer	1509	13000000	1	CkpaA2aJzRWawcfZiC23LgmDK6jHMhLX1h72NAsxVtxkRzMxGTCom
4053	coinbase	639	720000000000	1	CkpYS7zLWn3bBYExjs1xnngPkwmM3W9rWiDBRbR5aiWwaVhrpiprm
4063	fee_transfer	1693	34000000	1	CkpZjj4X1CXyri645mmCKNJfqBYSVYJTxcZPBepCpqBZrf8frGQ5h
4064	fee_transfer	1693	4000000	1	CkpZZ2USJDfV1tMVEDFPkHzebC5rNUyf6A36E9qYCeZJnXogWmZZj
4066	fee_transfer	1749	34000000	1	CkpZWod81v46EWk3e6C9yNNu4BYpoKJoZaGkSXapbH69C7TRqpqZH
4067	fee_transfer	1749	4000000	1	CkpYWDz7A9rWMKZmiD5jxjQx8A83DETcoHYvZRxnbn5u2pkkqkeCz
3972	fee_transfer	1444	26000000	1	CkpZ1GY5K9WRzgVmCSmQbsjjhWRJSRc3mCHWG1UJsDHhuiR1NysuY
3973	fee_transfer	58	3000000	1	CkpYjFSykF9dp515E4xXAN9tbRingdBQqVJePMfDKNZx1HUgexPwH
3977	fee_transfer	149	38000000	1	CkpYvXzMCPLaZuFywZDT4Yk6gyNbRwcAG1EgDG9U6SAPP3vixXLzW
3978	fee_transfer	1672	16000000	1	CkpZbMsy2SS5LzaXmAPHStRp1yuUevkt1jHyceBF7sbTqD4dmES3S
3985	fee_transfer	1654	85000000	1	CkpZBefnLYWrcFAaK5iSqyTnBmGyyKxCrpzaCUAWnLkr1UcaZQdrD
3990	fee_transfer	1513	34000000	1	CkpaFKFeYxQANexzjyHPAGkdzAviWkyKjJNuieEqjmvWZQVgnjEhY
3992	fee_transfer	641	13000000	1	CkpZAsA1T6pvgHV33kKHG3hKqRbXWRPCPhjq4Zo3FFNKnfJpBF89R
3999	fee_transfer	1688	14000000	1	CkpZXzcLGz6Pvde2qg5CgAhMjq8aWEBnnHC7WCdRTPrSbVqa45Do1
4007	fee_transfer	149	14000000	1	CkpZLy9aJQ8Ufn8hu9awRSCSdHiYeEeMvEW6rfDdJqNvMD97QcSqA
4012	coinbase	1634	720000000000	1	CkpYWpb7T2at3GjeodT4wZQWYKzZkd47b6QprShWeYK5ZdiWcskjb
4033	fee_transfer	1691	14000000	1	CkpZRTN2zaneqHkhsMrt6QouD5vktkBtp96NG19BdKwMxYn6exyKY
4041	fee_transfer	1602	13000000	1	CkpZ3JbrwAZ4ZGXaTwq5RHiY5z8g3y8Vn7Xqo1eDNX81GLwqJBEJy
4042	fee_transfer	58	44000000	1	CkpYWYnCMN2WmCihbJE4XVhHvw3dQubfcswKyNUreuB8KU8a9Uyvf
4043	fee_transfer	43	13000000	1	CkpZiiSJtE1Y2mvaqQifAbibhT3PE6gPi66MTMYaNUUQsQPkrSkTL
4047	fee_transfer	1685	36000000	1	CkpaLYxee7TU9SHmARSbW7K94usznKeYtoVb72EVHHhvcMbKnpVMT
4054	fee_transfer	1594	15000000	1	CkpYthZM3UeuLFjTzkeK3KEzsoW8acQJ4CdGPQeRUvmHcqJoXJQvi
4056	fee_transfer	1701	13000000	1	Ckpa7TwxYKGGaQ3TWtCS9pw8vTagsW2CR3efJHRCRGULxbWz59d4v
4059	fee_transfer	1547	13000000	1	CkpZAnTaBRXoozc5ELeUmymLMpBvcjfPJ7NhdTxV4VeqQrCGwp2Yo
4062	fee_transfer	2039	34000000	1	Ckpa7ChzjmwgfnTHSi8UhVNiEvpDMXqwpECbLmitead44iaZvHXUN
4068	fee_transfer	1451	24000000	1	CkpYTgmKxFfHHXFz1xLffoCd1Q4UGihoUysDyahVCM25VXa8Nob7V
3994	fee_transfer	58	15000000	1	CkpYzcX9no1cT16P6MgNrxYRSnAcj1CF4Q1UkucPfB9ZQtGzo6tb3
3996	fee_transfer_via_coinbase	42	100000000	1	CkpYjjJT8EkvTBuMpSU3bHnsbQbvoeuFe96hfSjvGAUNe5dnfaR8j
3997	coinbase	1670	720000000000	1	CkpZxX1dKu71DNNUukxHBWQcr1p8Hdkc7HpEJSNrptgeMHumXVm6p
4000	fee_transfer	58	5000000	1	CkpYyDQ9xfgr8HeKFS1c9zSpzhVQW5Y8jFPERFjUigGjKJ3pfhdHx
4005	fee_transfer	1709	14000000	1	CkpZ69c39xPAe1HFBLRB19pKCq4j7ofjaeW8uNSnq6v5XHrvVkWZ2
4009	fee_transfer	1476	11000000	1	CkpZqHKzCkmPK2WtvibDPfXaK3sTj5ELzFWVKTXFzptZvwYJVP6am
4010	fee_transfer	1685	14000000	1	CkpYckoiETSv4MNHLfdMRY9qNyKj9A3xxGoL6CVbLXyzTufhEcWDs
4011	fee_transfer	1650	56000000	1	CkpZdqrxMWvhwDsdphdZKj8BDbfWYfwsp2xYStRRV5jLnAxX85BVv
4021	fee_transfer	1796	6	1	CkpYaSfZjfAgsEHit2VhxJeuch4KNfY3spzgH8fqFrbgrREuFd6QV
4022	fee_transfer	1980	995021	1	Ckpa7SZaP4qMKthCZgQ82YdpaTo9atERUFx1wr54kP6vV2gNpgtg4
4025	fee_transfer	1634	28000000	1	CkpYRLbPDW6hmqwDSX3Rj2PCQVgaK4qRTzrECXAmvPizSLc3VtsE3
4031	fee_transfer	1506	26000000	1	CkpZvEsTuHgVFm9Ba45B5b3h6zZXUkMJcRErQMdVLPATeYoPKW8bs
4032	fee_transfer	1634	27000000	1	CkpYdkSqtdQn1tSUwaFFvWrudLW7W6VDWquPbixwNRRYsL4YDHqdg
4039	fee_transfer	1522	17000000	1	CkpaAfjj6zuF9F8UQwYbQne9vpAL8YJcVbzDeKu4MJSvXNQSLSMCC
4045	fee_transfer	607	36000000	1	CkpYVA9mjmNPopmkoYTFQQLSHa7DyJsEF1RspZ2Bb2k9RREggQEhx
4051	fee_transfer	1683	18000000	1	CkpZW4SF3DBHdskzNqS3uS2tVpi952xWmccDwFnrz3h1GyGvV4xCF
4060	fee_transfer	1422	13000000	1	CkpaBibygoo2yzGi2wdqvfpVsrVELUAKSgumxaUF94pN9kGLnw395
4061	fee_transfer	1683	106000000	1	CkpZxGjw9Ci9MWR7tCi8rp67SZETTVZc5Sw8CiYpDFrsz7SrfojmU
4065	fee_transfer	1677	4000000	1	CkpZiUh9shneJVDnpaPn5bcvx8YfqkCgMh62AwCQayUhGHPWmo9ZR
4057	fee_transfer	1559	42000000	1	Ckpa9EmzgRn5pS5N7CfYN1rDxEWoGs3evNXT1hJnS3afRMASNkiSN
4058	fee_transfer	1708	13000000	1	CkpZthbBmgN43trUxReypm3CKCyJ6frqFDVUGewUpANWG552BubCi
4069	fee_transfer	1451	834000000	1	CkpZkHBmKPXGeHtCb2cV22qeeA3Cj4r18uRcqYBRLqiHRT1CfWA9H
4070	fee_transfer	1451	420000000	1	CkpZ1Z7YuQuDsLsNdgqWHLbiAzga1EAHbdQg9UBs5QsRqVRnhrhgv
4071	coinbase	1539	720000000000	1	Ckpa8RqSRHcNNvE68Yj2cTb1ihJ28YLnPjsVmiuiPypFE9Kwjn5xs
4072	fee_transfer	1539	24000000	1	CkpaJ3dtqGdHyKQoD6X6H4bXpfMw41eVZHbt1YsmyiPSMhzfuoz8f
4073	fee_transfer	1508	36000000	1	Ckpa2dRKPBRtvYVb4wdkRmzTPinMxSQiCQt6uVPA7fk1r4fzDC1ps
4074	fee_transfer	1613	12000000	1	CkpYpEUux2EhQhzfaGft3HpScj6AaTGEmLRrKo5gBzUBxZaRKEPxT
4075	fee_transfer	1633	12000000	1	CkpZMVaayYuRXp7e7ER7YmfdXcrcbEmTosSKcJFhVgTL4MAnRwBfq
4076	fee_transfer	1759	26000000	1	Ckpa2HZmHmeMMP7ZibEqMyDgv4qndcEA8dRBpQkJHq6nfZEQ8rgU7
4077	fee_transfer	1451	12000000	1	CkpYkuJYdXouHaMskRymVBFvmB9zUzvfp8JgV439HViLyJJqbhJfi
4078	fee_transfer	1768	25000000	1	Ckpa1pckDnwPdkd2PKMTHVwKKx6ozddqrPQ7onWEsMfbajeiCPde3
4079	fee_transfer	1668	24000000	1	CkpZmKwpasUUKJsGoDFjv6NLwQSkk2zQcYNX4FkoBUN7R3zgDC9Jw
4080	fee_transfer	1689	28000000	1	CkpYRVP4MKQeBpCYh4UMfv9uutK4iFsL1nHcYrXpa4X2xm5vEjYS7
4081	fee_transfer	1524	13000000	1	CkpZRo1HDNbTMwb3d6KmDLX7evAN4Sf2BFvGfqFWAoeSd6D3EvfCS
4082	fee_transfer	1549	23000000	1	CkpZqNogAaCYy42EVtxrz5TV7cV2BUTpinn9uiQuZu6m8Aim4bSba
4083	fee_transfer	576	26000000	1	CkpYahSV6AnhoPA5tu5RnyyvdW2VcXWQzKbe7AUQmqM556QpW7eJU
4084	fee_transfer	1602	24000000	1	CkpYdJtVWHjhn4JiBuUnxf6uaiZQFCNvy7mu9p91Mc5he7DmhnsZg
4085	fee_transfer	42	24000000	1	CkpZCEE1G1BztxjP2i3FP2YkkKjD1L18m2Z9ivX9jVcaQZbNuUGUQ
4086	fee_transfer	1599	24000000	1	CkpZivRUvQBF83d9qPStojF6vJqn1Ppp5tqzpbjGyJ2xTB4LKrwty
4087	fee_transfer	1476	17000000	1	CkpZCcrjqxDxqkQ8pi7V8Sp6v1CNfR26wTsjSKD8q5fDMEHeyUFbV
4088	coinbase	2106	720000000000	1	CkpZjoqLSE2ha57puxZkRg2obWHNngwfhZS3vsJ9ZsaTzVGCGfC6M
4089	fee_transfer	2106	13000000	1	Ckpa6shVC3aBkP2EwK6VzLxa7yWEYeLfqMEvKkUkGstmr8aPmGXTw
4090	fee_transfer	1440	13000000	1	CkpZe4e1hYWdhrdeJ9PuDYcMVK2wad9d1uUFKBhAcQyYz4tbC6BpF
4091	fee_transfer	1675	24000000	1	Ckpa1h1xh8dg1wDx4FyHwfuqw8NFQUd7wjGUS2rZkn8HNs1LqQBJi
4092	fee_transfer	1678	15000000	1	CkpYcYaRTjzM4AZHfjQthUaZaF77bcFGZreFnKnmxXnxRVuWmuvJa
4093	fee_transfer	606	26000000	1	CkpZ9FmW4jjfqANU8Ujt9HeipWyHRyhpiPT5TZr1WLmXTJV1mv9N5
4094	fee_transfer	1723	18000000	1	CkpZXBsQ2PciStkXcH9HgSTZjQHjeREd7jr1tDbNnaHigQep5u3uX
4095	fee_transfer	1513	13000000	1	CkpYV3VTeDsi3MznjP2n5LZpgNFxUdqSfMh6VX6mqEhvTJ7fZjMwu
4096	fee_transfer	1444	89999983	1	CkpZT6bYpUaZWqYpoXkBPb7T9exDRKsDmK6wUYXPhxNwH1BvoBekp
4097	fee_transfer	2004	1	1	CkpZw5k1WxfVu6dT8KWSme5MUkQ1dPH2fEuRWrCTAMEpzMdP187Fm
4098	fee_transfer	1571	16	1	CkpZXfphHvePbG5Sm78wjEzgPG8PjNTXZU3usB8E313fRkCymfrDF
4099	fee_transfer	1700	13000000	1	CkpZtH2SdAFV3gYW7C1dBFbjcbU8HFs4XUZizMub7ue89NNMxCZPQ
4100	fee_transfer	149	13000000	1	Ckpa1F9uGBBzv2JjW7v6gcNrDhg8xweDtGfpkBr4VFZTnb6fMfJ6F
4101	fee_transfer	1683	38000000	1	CkpZ4tatKJB4FFjyyHZZikpwAvvajEC6U3EnNrWL3gpwyTuc2MFcK
4102	fee_transfer	1690	3000000	1	CkpaCzTeVPYCouTwKcBWbEQS7ajTc34KXWXmTVELrc6B3xnSAYUjR
4103	fee_transfer	1637	2999999	1	CkpYbXNg2Y4YuzHfwzZkHydvPJJwiLMYA2Qse4yWH33zSnck8mexM
4104	fee_transfer	1688	37000000	1	CkpZJ2onGovxtnAPDZtPQnJPw9iH9n5wD2nayA46CQ8TU1s5ABKqK
4105	fee_transfer	1506	16000000	1	CkpaCtWniEpX5aUn9feZSJrbCgDnQd5cZe3CtqUCqYy499xQ8PyJ5
4106	fee_transfer	1593	6000000	1	CkpYnELfVetcLQJ9gdggrnSAEQWdJrHwtw6eeDGnrnsruFhz51Afd
4107	fee_transfer	1402	36000000	1	CkpZRnaKTrNtjGzJAZAnMRQ4C37KvodEdyDBGSU8dUEqjkDxiWKJn
4108	fee_transfer	1675	13000000	1	CkpYos3ksLCGmKbKYxaAgqsGMsa9d3u39WDYdXt5mpgufEpyoig5g
4109	fee_transfer	1690	12000000	1	CkpYr44fkUS4MWgYcYWTNDSXDpXVrAXwX1rY8pL6UgrenUAxYUzGd
4110	fee_transfer	1518	26000000	1	CkpYw3EQQr6XbtiAjaDySnkUuNXMMXKMb641YFQPZsjaVRwx6V6Lb
4111	fee_transfer	1687	26000000	1	CkpZqzsu2aWbJmSnDkzKcUzb3gtQVtxDY1isny5UN7E5aY9GU4qZn
4112	fee_transfer	1613	26000000	1	CkpZtoW8G1fbpSjJDB34NnZuhcR9vToF8WYw36SZxmCKqXrYDMU3M
4113	fee_transfer_via_coinbase	2097	10	1	CkpYQm1dzx7T6n1ri7SPwnxDZF2PUiPSBYFEj1ycM1uyaz3Xciiqz
4114	coinbase	58	720000000000	1	CkpZ1rL9w8bXWBh4BciShNg5ERuhDsGY8eSbDNcALm5oKSPiFRuwy
4115	fee_transfer	2097	10	1	CkpYQm1dzx7T6n1ri7SPwnxDZF2PUiPSBYFEj1ycM1uyaz3Xciiqz
4116	fee_transfer	58	999992	1	CkpZoKZC6Ak9kLfgC8mUpPkWCxsm3xGJBbmNU8UWU6eZENwX1fPny
4117	fee_transfer	1680	13000000	1	CkpYdDnsaZsZtc2ZQC3kmNz2Rg92FNkGi3PUAHibPLYdfWmgcWtMS
4118	fee_transfer	526	13000000	1	CkpZnFD2Z947Xhbgz1cRpQzdzdzbhac3GAXdJKeVsE72uxv2f7Z4x
4119	fee_transfer	1474	982000000	1	CkpZvHYNAapmiWcHSmCBRD5tjupK6Biz6fzc2TteETrTPxFjCb4An
4120	fee_transfer	1474	16000000	1	CkpYqXY3DFdoJ2ozhf5TmU2H4Htw82Cs31AJ5humBWZ74eEd8WXRM
4121	fee_transfer	1426	39000000	1	CkpZSNuFnL1ZfduxZBSsAhN1WhEbLJ4GQvjkyWPL87eMYp94zLYPd
4122	fee_transfer	1677	39000000	1	CkpYSPHsdgHiT41JtLnXbdPrBDqXdQUa3VMFmmuKE8VS1r4gRCsv7
4123	fee_transfer	1422	39000000	1	CkpZFpr2bQnfsFzDCvyR1G8kNQiCGffgnnV7AP12q2EWvDj1Bqugk
4124	fee_transfer	1711	26000000	1	Ckpa2mBxD6XVhGsXZRGBZL3v58sFYjJXqQwLY5auMsbKzFTM9TwZg
4125	coinbase	1534	720000000000	1	CkpZsGbbfJwJ65dARdiKDcw8g8jYzCL88V7EJ3GyFgm4Rr8dm5phE
4126	fee_transfer	1534	60000000	1	CkpZcGupPPYa5h8oEYLszLLpckWT29KzWbteozDig3CRCpsx3bQ3i
4127	fee_transfer	1694	66000000	1	CkpZ4NfhaQoTJ66k29ELu5kwJ9uepWo59MgpbmVBSvHryNNGjK886
4128	fee_transfer	149	19000000	1	Ckpa3MM5rXagrptzMN11H12mrV8fGACFJ4QScEV5Z6r8QDU3ZZYZ4
4129	fee_transfer	1599	26000000	1	CkpYzb5YPGnsaPgiSwFQ8kKb8eXyS1mKM7wdroLqfPPrH58nb2qTb
4130	fee_transfer	1637	26000000	1	CkpZz4vHcdFE32VhsGQU1vL8D5L62VBqridNqnd1oACcqBZMpEXtV
4131	fee_transfer	484	950000000	1	Ckpa9KJvkrfa9burfYGWFKUbGbqwvRJpEddspwvEcpYosEMLtuphk
4132	fee_transfer	484	162000000	1	CkpZ8izNsp768RMjiDS3xF3qu8eCHfs51f8BtzxDiihUTcdCUKCQD
4133	fee_transfer	1729	32000000	1	CkpZyMQwAZsx8dfJcyFrTLYef3G7ciyddRfCQPoTM3kaRJSGYcURv
4134	fee_transfer	470	13000000	1	CkpZgEDmHF8UmLjNP5VcEryi1Jb57VyMw2J2KyAbVkoFBCcYWCCKQ
4135	fee_transfer	470	15000000	1	CkpZ1iPqMda615QdPAFTvymdDjA9mbcszifqZrBBGMzja8BtKE81J
4136	fee_transfer	1677	25000000	1	CkpZyqRFcZRrYBkzbXaTcvWCQYDvoHLiA7W2oM1SxGenP46Egfzea
4137	fee_transfer	1708	25000000	1	CkpYa6xpd3CfSKhBvow8E4XpHVNH1ovaVEFB2N45Wfmf4XUtHw3eA
4147	fee_transfer	1509	25000000	1	Ckpa2VDduARtq3FHZPFqPnwMFNq7LUf8aozkptWm81JwRL72ZaiCD
4148	fee_transfer	1706	12000000	1	CkpZfCP3BMdM8pR3NJ8552xNyieKi4dDFnTeua5TwUC8yLxHGhFzJ
4154	fee_transfer	1729	16000000	1	CkpZrbFL6Q1AEaxqmHtZAnSayghXWgz2Ho7MnbNJSWTCbVJQyfwgN
4155	fee_transfer	1536	26000000	1	CkpZ9AMs7ETnqdFvuUaZis2uDAaVC2MFizH98oWbKpH2Q9j9TuL2W
4160	fee_transfer	1764	51000000	1	CkpYxfthWyqbzXfNf8MkoA5ixjE34rMf88RvYAyCnJj6ttncLVza3
4162	fee_transfer	1764	13000000	1	CkpZV8AiffVNxZahLsSUW4JD3b4CE1Ruabn61NuUp5ZB2jxYMH8Pq
4171	fee_transfer	1422	12000000	1	CkpZRBMobaReW3JxqBfoQUCSPUirDJuqgiJBP1oVAaaBy1pgsn4id
4182	fee_transfer	1672	24000000	1	CkpZ3KFuVGjWmUP9WXbLNwaMCtX33x9PKaVUiEk8w3ZdhHGhPYyrP
4184	fee_transfer	1708	12000000	1	CkpZrQwwznfWaApLkRpGnEbnfx7EMXNoXEL2sFLGfdu4SoE545Uia
4192	fee_transfer	43	51000000	1	CkpYvzwujLsmELGc3EXgyFJbNyLJs8ojbZk2vtaMUG7TNPsbTc1nt
4198	fee_transfer	1715	31000000	1	CkpZr1rbinBX36ht192gYsaMtWnxPgxgTMja5a9ZJ7caVii1FQWQM
4200	fee_transfer	1534	12000000	1	Ckpa7LLC6u5MX7sDfzHEaXVaaLGfVxBxe8HPmSbGBAEnmMAUUvozA
4206	fee_transfer	641	450000000	1	CkpZ9bDjv8WH8Y41N1Gdbxx3oJ88sE796mWSTud2kHGyfokRNHRhe
4210	fee_transfer	1426	26000000	1	CkpZKREEFvscjB7JZkZbcafYYCEcKA5QvnHjdmtCp7X7F4LGNfw5K
4216	fee_transfer	1671	6000000	1	CkpaDULgUbL1p3WASWry36ZY9wtukXPYTUWhJYtZhdhAGg5CVzfN9
4217	fee_transfer	1559	12000000	1	CkpYwsBnxgYiSC76yTLGawAd5aTmEbazCuZRMp2HEY6tjj1VfVdeC
4221	fee_transfer	1613	52000000	1	CkpYddcKdJL291AZcRBJhgmDBKPQsebA2TCbuYZAgev6etJP3ZdQV
4225	fee_transfer	641	41000000	1	CkpZrVEW4y5PxSfJSrzRrWmd4CC8SYshLdk2hjQbuQ3dzxRvTXtRj
4226	fee_transfer	1688	39000000	1	CkpZDxW8YwG63cvzw7a1GnFbMJVGis72hMq5JHmnQ8LpNT25TLw9o
4230	fee_transfer	1555	26000000	1	CkpYWXx4rygMm4iHx8gLyvxgCfqeqzSgfnqao7sh7DUjgJDtMGd6G
4236	fee_transfer	1764	2000000	1	CkpYpK5BpNfPi72JKMJyYKQXyKyPLe31GCWuY11uycafoDJrPNtpe
4238	fee_transfer	1693	35000000	1	CkpYsei11e6Pwns1dep8Z364cvH3JfhnDNBsepyaFrkyS2wbWU5jL
4244	fee_transfer	1622	15999991	1	CkpZGDxCh9Ra14y7J7LVaKm4AeBjurc84fZPqa7UTa4PvWJiKdzNQ
4245	fee_transfer	1448	24000000	1	CkpZTtJdTaisHwfVACNifFG91wtBQoNzxyWJ1G3wVMKbWCAXoUwrn
4247	fee_transfer	1394	11000000	1	CkpYRdwWfa8xHQdst26UWRtAqE28WV1RStNg4dMR2em65cPZC75PL
4257	fee_transfer	1587	24000000	1	CkpYeukM1qLcvkRgVNuwxMfwf449sq3ngg3ivgcPZ272ifBPTqeDz
4261	fee_transfer	1555	136000000	1	CkpZXA7FmouKZoZ4u2gFttLh3nuuh7qdSUzQSHB1zGnkPxFiUVBRw
4268	fee_transfer	42	33000000	1	CkpZkm7FPfVfmtVYaZsa4NSSFnsAH8jJ4FmWSVUpqDD5nk8GWm4fg
4270	fee_transfer	1534	1000000	1	CkpaABrTtULYVRcmLC3sVo57uQCSXCvWVLwx1xHHVWuFoezWNfrDF
4281	fee_transfer	1740	36000000	1	CkpYfVtwB5Nrx1MKqWC4aEjpRenG1vX7YA5dgT82r9xk5PEU5rJcH
4296	fee_transfer	1644	23000000	1	CkpZN7cntqyZfvdfutr8teHkXAT3p1n4g4tCBLR4QzUmLY1sTLWvQ
4297	fee_transfer	1394	51000000	1	CkpZPVGv9ScTngz5PdVjqwq3ByMohJ1FnwVbqxnpbZY7pHgvZuhnZ
4301	fee_transfer	1649	72000000	1	CkpYvs6kvbQuVjoK6GUvnyM1fKffSdi58HyhErBfmxBxfmza63Fm3
4303	fee_transfer	1419	213000000	1	CkpaK8ZMTPoAdRTN1ZGkmf5mtoyfmqomxrSPLzKCvEdb3kLLydzE6
4313	fee_transfer	1675	213000000	1	CkpYyLH4bp78axHEqvn7At1NHKCnyLTRcHAsizzWNMBTS1gZTCyey
4318	fee_transfer	1394	72000000	1	CkpZHdQi57PsSZRoURUoA22XHRfT7fRFiiEdjjH9v7VMqfv7FCpum
4319	fee_transfer	1444	61000000	1	CkpZ4thPeZUBups7m6VntQtd665nePr3R1tLn4Qkm9HY8xRBaZgcp
4321	fee_transfer	1727	51000000	1	CkpYphjvW8MKFiora3ZRdEx8kUhb4Ch9v1BkbYmPjzMK2bM5okFdL
4330	fee_transfer	1670	22000000	1	CkpZu8LiZboBxj2cMWtfoFbomhbaLvRmCsD8izuVXqCMcCZeEN4aa
4333	fee_transfer	1394	32000000	1	CkpYekgfsE3e6QWi9uuBmpLUjVrwTbcQ3AJacLGarx9w2Pc2zhWqM
4335	fee_transfer	1634	320000000	1	CkpZMFDdqYzAujjefcJ8bBfrz1BUxufnv5qTVsnHMq3AgCmQ8PrxL
4336	fee_transfer	1634	1020000000	1	CkpZi2CaJuu7ocW4ia8XzqmpkdWfmK6az1FkNQQzNRZg5vU1ZnbgH
4339	fee_transfer	1675	55000000	1	CkpYzkFAnYYZuNeAckLFm9mS1FHGogM6XaESTFNYLha9s1PkGyF5Q
4341	coinbase	414	720000000000	1	CkpYqJUDEqvzYaC6AMX6eZru9UERavmRbHrs9LxHSkk9xDg2GEAeF
4342	fee_transfer	414	11000000	1	CkpYbcvMwvJ7MWA9gAUaEKNTbCSWh8Vrib6CmnjQofuHfL7Viedmv
4344	fee_transfer	1716	22000000	1	CkpYSxQ4BesMr9U7oXkj4RGn5sts8sGKkvnq2YkoWgNdVP5xT1CeU
4346	fee_transfer	1671	44000000	1	CkpZNFed3VV27E1WeQf4xzweYG365pcurgyJW6MtEVAxyGDDVbAu2
4352	fee_transfer	1703	22000000	1	CkpZc2KUgZ9kimX8eyNXG6skKGegks2A1UmKTocFuy5HCsw5axHnv
4354	fee_transfer	1623	540000000	1	CkpZmFPrMxQKXXHVjLKVT4pxgmBkJ91B2taDpwNEC9Ny9if4eh5ng
4355	fee_transfer	1623	549999984	1	CkpZzQiHBn3Wjt7v7oW9pwnZJ8LZgViDAiYHDEnrEKLwRpQTBSRqp
4357	fee_transfer	1756	33000000	1	CkpZzrs3Ft41ZRBnBpJB9c9xixoLwfPt4Ut9tmEWvoC1s3HSyorw2
4365	fee_transfer	1395	33000000	1	CkpZPpKkaknXBZwECAWa48ZNP9bWimhW13cQPyBjuFUS63uKCSQ32
4368	fee_transfer_via_coinbase	1886	1	1	CkpYum9kj2tV598ZnWkxLVJWHy1eWkTD6VK7tHzzFLvcRfNqVHmon
4369	coinbase	1534	720000000000	1	CkpYgHvQDqu9iPUfjPWt6VaoaWYhqB6pFueV1BThbU8DnDWZmxZSC
4370	fee_transfer	1886	3	1	CkpYq1QgAgbL1n2Z434eyM5ptHYRcArjHPgbSHSzmRWhnGLhc4CUu
4371	fee_transfer	1534	19999997	1	CkpZkM9ud55Cz3eKh12v283DgMqTsTPD5s1nxKv7JR3ETm6zWiH1X
4373	fee_transfer	1699	22000000	1	Ckpa3Eh1KFZcUmSjwsPpWGFYU74KTPpNgZG54QURmLdjXQdrWGSDc
4377	fee_transfer	1680	44000000	1	CkpZJkfhjaYSCQi9EswDHWJgWB5A8RDYdYURuY8rH6nxh38KYgKMy
4385	fee_transfer_via_coinbase	289	10000000000	1	CkpZrwKKuzBjHKena2by1DnkVvz63BSW6vNQTxPRviV2roduZykSq
4386	coinbase	1419	720000000000	1	CkpaEdjKCo5v9pqoQJPb79QyUTvBxDf3a4rfczNJLB5CVJCsAUEh4
4392	fee_transfer	1689	14000000	1	CkpaBv422e9Cd4P6jJaj3m29mqQ7xFukEg4ms1ezjf5sA4dMQf7j3
4395	fee_transfer	1633	53000000	1	CkpYZjNyhSiSmQmDJWYMRmY55L5ZHCMVT1k1tTn2gGde5Nkt9Zndo
4399	fee_transfer	1727	54000000	1	CkpZ3qq5Z2ry2Pa9vPoxjhNQViczYjuLMwSTxHcCaddFhPQMVr4C9
4404	fee_transfer	1685	6000000	1	CkpZnEHvJhs7kxuDKPRUBsWQDUXdJGPC3dtKEsF8Uw8GaPgC7pKUz
4405	coinbase	576	720000000000	1	CkpYdq38ALhjFwxGroG3uTradYiDPCiHXT6wVjQsd7NxunQLxs7qA
4423	fee_transfer	1738	12000000	1	CkpaArZew4san4W43TCvpAPgdz8ZsCFmw6K9msXjZFUxfhG9yzuSg
4425	fee_transfer	2112	12000000	1	CkpZdSiRZEEHpqZAcGzuZnCKZs3a4JeT4CryCLqCxVq82HAVthfkQ
4426	fee_transfer	1673	32000000	1	CkpZsDHYdNs2LhGaXPL14qKoUHMfT8LsLKNosQGTd8h7PwrmEH4qN
4432	fee_transfer	1756	11000000	1	CkpZpr7EDo3hDAZAe5xu7VCDTgsunQiPEKy8PZRvcpcRdLtFsQNAy
4138	fee_transfer	1694	3000000	1	CkpZdSSL2QGwCq6aVyCNewE9BZ3udRornzKmk2utuNzRKD1ug16j1
4143	fee_transfer	1474	397000000	1	CkpYn3N8XqQp7oUeuh2B9HqfoZwgxhBRtZjCB8mVqe17D2Kxsv5bY
4144	fee_transfer	1474	25000000	1	CkpZsUpthpNZh7cUtMyUMY4kJanzH13qgsdzgqk6rucbX5g93AE6k
4150	fee_transfer	1690	35000000	1	CkpZFW2zERj2NMAYnMirDvcPecW5pLk94EhRYoKTuGRddmAC2Pd1C
4159	fee_transfer	1476	26000000	1	CkpYqEcSKX3ytZsB6BTa9BXSY4o6q9MkecWd3AFgWzmJUL7wK2kWr
4164	fee_transfer	1549	120000000	1	CkpZJYTMcr6RrmH4mtCpwCqDsDFMJ6bztGPF136HFewHVDtJ5Lodt
4165	fee_transfer	1549	1130000000	1	CkpaHjwCh1jNLcL1qQZSbGs1YD3rnJzBVcCwq9rByRhKVs5LKvfV2
4169	fee_transfer	369	22000000	1	CkpYkQQhP8X2pCEXav9LzKPiZoXF4Qj4hErYUeUYWjET3cUDs48Pt
4180	fee_transfer	1685	24000000	1	CkpZaazCg3YpCjVSUZFEwCTbHeRG4k2dphQ3PahVu3ySek4Z7Cj1A
4183	fee_transfer	171	24000000	1	CkpZ92BFu5NCTuEEt4CUaGT3zD9Y4AEzRV7cQmYNkAmosUcjG7HGh
4185	fee_transfer_via_coinbase	2110	1000000000	1	CkpZVeaAcYq83YffThayznLpUK3rsyfPcppgGzT1cDVhNYwzRAcVY
4186	coinbase	641	720000000000	1	CkpZgzUEd2BK4bX2VxdfKCL4ygoUoRWonvnx9Wf8u4s3gUpmohH5P
4187	fee_transfer	1650	51000000	1	CkpaGua9WkcPsA6SmWpTPN4kbhiLmuc6ADEz4tZT8u9pgJuy4JUXt
4196	fee_transfer	1395	56000000	1	CkpZf7ypxpr89C4NgtfeBiexj7ukj8DihN3D6hWbLvVAbxzqCd6WU
4201	fee_transfer	1395	10000000	1	Ckpa8zdsdMEjsUyStbfuxSCuXg2mDsayiXdBUPcR9hwT7Z1bTTRYT
4204	fee_transfer	43	12000000	1	CkpYvdwohreJzkfmUg5vdgDAsg8VTRuu6bQoncKXM6JLxCX7CpYFy
4205	fee_transfer	1394	13000000	1	CkpYWjFPKjbgrfFmMDSqrXM2iVNcr9ygnye5UkEVrdKR6TVKc64q9
4212	fee_transfer	1717	24000000	1	Ckpa7Le389pmKmN2cbpvQssD8Qxey5SqnmnEuCvxTFxVPq5G31FbV
4214	fee_transfer	1455	19000000	1	CkpZboHrzr3rfbMHJX9BAY9rEL2ZrPFaRxmRBT4R5fPEzG5ko1jEX
4220	fee_transfer	1695	26000000	1	CkpZoxAtFxUkn41JZPAWuLwSFWPZpA1NRNJbypw4JdmLkjLEg6ukA
4222	fee_transfer	1701	46000000	1	CkpZuacTCRDBmRqqTqHhbPDMzomfxW5GD2A63SbPpoMiM5pDwXNH5
4223	fee_transfer	1701	5000000	1	Ckpa3wswUqvRB8pcKkL8XsBcZe23UCCHhFQKJHVLgjoSLLLoHjVGf
4249	fee_transfer	1723	12000000	1	Ckpa5EXPhKKeU66aGFgS5FL35rTj1zLgp8WT4PH8bkgXCoUgy7BB3
4252	fee_transfer	1395	22000000	1	CkpZvMps7jktnN64JEuTe4ifTDC51r4apG2dnqAfHb4w6hj9nYnCN
4255	fee_transfer	1688	24000000	1	CkpYd4bjgCrhQ8qB6pJqTn2EtR3cxzq2EFxf2AaB1wRVajrFjRBru
4258	fee_transfer	1672	48000000	1	CkpZcttVkejHi1XDiQCBuDb3XaSkMo2bjwMbRW83DjhrA4xRoM28P
4262	fee_transfer	1439	12000000	1	CkpYxuJEkcjSD4Tj83Fx8zk8KYjew69SawjtQuzejP6byp6q5FWum
4272	fee_transfer	1684	12000000	1	CkpZHAvPuPgDhD3GTPzHnpWi4tAJmaX2jk8aezrU1PTiwQYNjHqeg
4275	fee_transfer	1395	12000000	1	CkpYSaVmecCsnPynzC5jCyjNQ9Y2Xo86SFisTpiEDa2mKiDoHicd4
4278	fee_transfer	1594	47000000	1	CkpYZPGQSw54QgzmWqTko3N6HNUkJ7gApxLKss1QxtiYkLfF4arYe
4279	fee_transfer	1723	36000000	1	CkpZ4EnHQ45taBogPHKFaX1aYPsE3j6Zhgy8VnniM5ZTTZhYqYxmB
4282	fee_transfer	1719	2000000	1	CkpZLVXfa5Hv2zqTYMMurzDBu2DmeekfWX2GaLxTmdGdZsUNDnJQ3
4285	fee_transfer	1395	2000000	1	CkpZyHFeAoXvtwR8ey9m5QddgFBpL6NV9qTWTvL9uq4Y173GNaunT
4293	coinbase	641	720000000000	1	CkpYR2CMhnHyybmdDr1Mxt68tk4nZcEo53W1teYwvW7P28EWVAe7h
4298	fee_transfer	1394	71000000	1	CkpZ7ocuZi893at7YAVaADHdtWq4XtbQT5pB8PxJmYhUPeruUh1aE
4299	fee_transfer	1394	213000000	1	CkpZksDR4pZ2NyyG6PgXwsJs95Zzky6NnymDDzX5q87G55zvkxgRk
4311	fee_transfer	1675	330000000	1	CkpZxjycNN6TaT1sUNU1RHmgta2TXjg5gGE974TQxwuzpMJ1ipg4U
4317	fee_transfer	1729	72000000	1	CkpYyK9mT1XZh9JKwEf9vHZt7cMDHRLTMjww1EmWbJHMxwdbhC2jU
4324	fee_transfer	1739	51000000	1	CkpYyamgVJdmh8dJXrHgbBnKbcy82yQS1eVnAGbuQnA5bmG8fgNZ3
4332	fee_transfer	2106	11000000	1	CkpYoBBxKTZRf1jQemaKzfrzydk6urE5wjiwwEyPpqxPw9xupBLFo
4334	fee_transfer	1634	33000000	1	CkpYTeVZdnvft8kQVAn7WndpxhqFBGQqqSTwzAJbmhvQDt35WT4qD
4337	fee_transfer	1455	450000000	1	CkpZPY3jsAKCaf415Ea4qjfSoGQPFJrSUoJ2W2pe1sWX1pcBreTdB
4338	coinbase	1455	720000000000	1	CkpaGTipNcEuAGu7BLiDFkfFCt4cSDni1D16pSdVmLNm7LUptw2eW
4343	fee_transfer	554	11000000	1	Ckpa3JAPFxqgWyehA5YrNWLLFBvJv6NaEamqrKvmqp8iEUPstM6gZ
4360	fee_transfer	2087	11000000	1	CkpZjgnWpxCibsAZqvJSi8ami4eMSh1gDXqw4iCS4git6SivLexcS
4363	fee_transfer	1759	11000000	1	CkpZ7XZPBRQFFHzh5Vx9maS5ZCQ1xy44hTcJ8mopzsRuN8fiu1BKV
4372	fee_transfer	1534	54000000	1	CkpZQp6ZTjMYd8MfaNorNmXafUKP6K3sXVJHzNnLrJqwHyEFSzM9E
4384	fee_transfer	1419	14000000	1	CkpYQq1KYdStzPLgBGXhqEuVdyx1EnKbY1q5FAJnAioaVKXE6Dhad
4387	fee_transfer	1680	14000000	1	CkpZpBXPykf4ojmMthiuTRvTaF1P4E4UGxmkse6gc9YdpyX9E78XE
4391	fee_transfer	1571	14000000	1	CkpYTQUj3FCmb9jvT2H61PSwPqwv9EEu21Y7YmdXSBSjguphDj8tq
4398	fee_transfer	1422	54000000	1	CkpYgeXiWdgavxJZMw9Ksc1EM5bdLkx2ioZPMw1Sz3jNFstEqBXJs
4402	fee_transfer	1688	66000000	1	CkpZdAS3S31JUS3tb7tQN4tLNmxbmdijXqxLhVvnfduf3TZeVjtdF
4409	fee_transfer	1455	13000000	1	CkpYrayNU3BdUpZs5rkfMpCCxKSe7Z4oFgQm5P9aeR9kxLbmCbn8J
4412	fee_transfer	1678	23000000	1	CkpYXRXzRQ9Ukr1J5S7kCWy292j3AX5drLCp4xqvkPPiBJ2qD2wV7
4418	fee_transfer	1522	11000000	1	CkpZ6NGxxp6oPsi2fkjitecRzXy27LSfg4qUiJnCqa4RHtDKZyhDj
4420	fee_transfer	1764	23000000	1	CkpZXYTmd6shfvQv6wAd2R9PQCdbHEVKUHtkCzSBugYGWpbRPiaim
4421	fee_transfer	1718	23000000	1	CkpYSz5dV46BKr1Kt8oUppGPMfx7r1VqDpdK7LTUGKhLwp4yV9hYk
4424	fee_transfer	2112	10000000	1	CkpYS4gBArgFyb24uxWkAXv7uqJj8dUhkyEVuy7u6xRm6idHR1kmr
4428	fee_transfer	1740	1270000000	1	CkpZrzLGz9U3gNq1qDj4SFePbxL9aX9iom3t8ZbvbQuJfQmcnrXPo
4440	fee_transfer	1395	21000000	1	CkpZn5HmWMjMfnUz4CzPnbC3xhseSjxBMmhmFYpbAikNzPBedBuyS
4446	fee_transfer	2087	31000000	1	CkpZDEc8tEhj8u1igwta6eyTKtCXCm8CwGhpJ5p8N1mRcwex9V4iY
4448	fee_transfer	1756	32000000	1	CkpaEotErZCbbwGgay2wsog5fwLtKhBXKU9ndAL4Quqooo3WpEojy
4449	fee_transfer	1467	21000000	1	Ckpa9jnPnoFbSrbobbFyjrJiq4Uw5c3y4yKbVJt6hZj6kcyphfmvA
4451	coinbase	1526	720000000000	1	CkpZR62xfhrenSvEZQrz6MyyHYkRuLKnfMY2jYH7E4TcJ3NZrsjBZ
4452	fee_transfer	1463	1000000	1	CkpZ3RoP4LdZjsPR5TtK5p6dkAnazNg2oepuGGbQ7S2kPPs3qpwEy
4454	fee_transfer	1759	42000000	1	CkpZ4Y7fKoW8JJsLW9UEoGB7MMRc4VNiTEHvVnjdg98To8a1aSCjF
4461	fee_transfer	526	23000000	1	CkpZyVvjJXaC5RdJnSw6CmJKijtgWkmYGW7fHYoMH7Zr9bF8Y8rHz
4462	fee_transfer	526	1000000	1	CkpZwjcNGpyCPQXCGabryLeGVnQTG8n5NtXxjyEZLgJCFa9R4qUX4
4469	fee_transfer	1602	100000000	1	CkpYnfxVh13rtrjv7fEJNbDpT22QhFwq2tEUPVYcTeBQQ7VXUVPPR
4473	fee_transfer	1271	51000000	1	CkpZabx2tzFm15FnxSVLxz72MhE15K8d22teiw1ubqGhT2oVyyZMR
4139	fee_transfer	1673	27000000	1	CkpYZoEhhERRobpHXbJKBYeEAC5XLwVAiG55r5iTCgUHnyRauFx48
4140	fee_transfer	686	40990000	1	CkpZCfBB5MjbegdfLt2hNPNsfYxHUfwoLKWqSLgSCDdgfRk6EMJiY
4142	fee_transfer	526	39000000	1	CkpZ2bWPu86Rb5LqkoLvYiMbkMhDXefb8wMFHLeu6P5sfX54FfPcv
4145	fee_transfer	1749	25000000	1	CkpaCoGHL4gDj8yx2svbGVYEyv2psTYCTRGZFiZJ4CguNPcAMztTX
4149	fee_transfer	1599	12000000	1	Ckpa7LPUN4NXsw7Dm6Myn4RcoKZ79QHDoS4qEacm831UWwKdiR8Qb
4151	fee_transfer	1573	26000000	1	Ckpa5AyU8xDqmb1x5kyXmH4jUhQgQx9t6LWgFKXn3f9tDmajEk229
4152	fee_transfer	1560	13000000	1	CkpYe4LdNwCPyq7urxpaXUtK2WthSkrKuDAqV2UZZGRyzQ7zPz9Rq
4156	fee_transfer	369	741000000	1	CkpZ8r5pcpotvD8ku1iyQeQrgH8N6XRyLpNuAnixPDnzb6p9SatGx
4157	fee_transfer	369	510000000	1	CkpaDeFWn7RB1TsQSERH5cqYoqA7uEr1GcMgKCbk2jrmrddPK7yi2
4158	fee_transfer	1540	25000000	1	CkpZuM2sJjkEqXbiegMHexPoXh5hshvMuZXdeMViiuc5t9Z7xUnL3
4163	fee_transfer	341	3000000	1	CkpZd6hQfoAbHXJWhuhjiPJJgbJbLcBFpYyt9ZvJmkfs7TBGpNeWJ
4167	fee_transfer	369	614000000	1	CkpZB24KmwY5brw53qJbwmyh28h6Xtju13LKjaZE9cnGeATpe5fE1
4168	fee_transfer	369	78000000	1	CkpZFQmVSaXwvxYrYY8UTgEzWPuQTcSjBEJJ9weGjArEbiYYmcxbr
4170	fee_transfer	1701	12000000	1	Ckpa6K7vQy1tYUQPjnuxdc4bCaJTT2hTs4C2FjxHPwov5B3L1wLC4
4172	coinbase	1395	720000000000	1	CkpaAaauPgRtoogqNqesZc6oPoPWKE4N89oqR9ALsmRiAVLYXXvTB
4175	fee_transfer	641	384000000	1	CkpYw45RZnRNP7rMRENKZUzfn5Dc43m8TdwKDCVx8htrGEpbn2UcG
4176	fee_transfer	641	279000000	1	CkpYb3PnVnTF8nGaz3Yu3ryw1ZEtoHs1rBrxwwgnVJLQNG1Bx8MDg
4177	fee_transfer	1919	1000000	1	Ckpa8TPtxUvofZfNjwxiXsGEZcKh64G62KXHmjVjMqD7rPpLmputE
4189	fee_transfer	1593	12000000	1	CkpZm822Eq8vDwWPUmB7sUjzjZNVEgkx4nzuErvohqUDwTwLGFGN1
4190	fee_transfer	162	12000000	1	CkpYjGWaVMR4Jfh1T8Eo52Nm2iyj1y3WCioPq8KpLG6E8YBK1gorq
4191	fee_transfer	1395	11000000	1	CkpZteXzfKsyax5XZ4yFNQWSCJDS1ucPpbURcpd9TpDEFKZ2BJGim
4194	fee_transfer_via_coinbase	2111	2000000000	1	CkpZ9Hzvyka4zkRgf5fMMvBWL4EtxoFpMNkYJ4e4YdsxCs3waGZjZ
4195	coinbase	1419	720000000000	1	CkpZX17Jtqnao6R671RAs9KXfAQfVB3pV89V9VXGcS1dAn1UL4snw
4202	fee_transfer	1394	14000000	1	CkpZr5SuhGYk819wrJEd3sU5QfEwVGLDhBQgaVZQurCtD2KxSrC2n
4208	fee_transfer	1687	113000000	1	CkpZ5TZgau3VCmt2hcppvu73pGreuwvAuiGZZf8hPhpMwrKKBNP4v
4209	fee_transfer	1687	112000000	1	CkpZ3SfeBZ9N46icYWyW3xUctp16JQkrsrd9F4jDcU3dYGwPicQA1
4211	fee_transfer	1394	12000000	1	CkpYYUFiWZ6DqrCYgTaR3y8JLBrsAWdzAkw3XZ6MJ6yybRKxpDHc1
4213	fee_transfer	1447	13000000	1	CkpYRB55hkunzPhR5dvN3LuHfP7Z9XfGKhp71T93JDLJthcQmy2PC
4215	fee_transfer	1711	3000000	1	Ckpa3vjZHcWLha8uLsHjwBWikFtFm1sVCzXUeo5TahbU9U6DmRMCa
4218	fee_transfer	1394	26000000	1	CkpZCyaN4naSsCgr59Ny46nKc4FRbioqeWRFDpBR1Wkv13WBsVVra
4227	fee_transfer	1623	53000000	1	CkpZfVmGpFCEadKs6LmLoPg5vydNFjQeymg12uWq3NuBFJK2bDYQd
4228	fee_transfer	1727	52000000	1	CkpZE7JUXwm52wVZBeyQbokZRGUgJFPSjQdxrPZNBGeCsH517brwt
4233	coinbase	2112	720000000000	1	CkpYvYUuAiWK7DroU5GVVKc7stuyW4JUzJn4nDoHRjXCAVKJjCS2b
4234	fee_transfer	2112	13000000	1	CkpYmhihreGA9TWVPCYDfW7He7dSkcsM4YPMzRi8MCbKKzBa7i4T7
4239	fee_transfer	1439	55000000	1	CkpZVP5KG87Y5tgnEzQGsGkvseR5HyhYRKLHtqTZYRZptPwTikcux
4243	coinbase	1622	720000000000	1	CkpYoEUmnZS6zZrg1soVR2oxQz8veiNgwNCHDuEdsT95ZSHW8DUkK
4250	fee_transfer	1394	24000000	1	CkpYoeqAepnNCdso2GSqMy2BkyZxqGh5ywQFrcdN67DFaUytSn2Hw
4251	fee_transfer	1594	22000000	1	CkpYr7vKYmQxeT5Yz7jpjh4cKgu5RfTGY2fUsXF66d3F9GsKWDFPD
4254	fee_transfer	1522	12000000	1	Ckpa68jKG833yds4QXKMiyhXv9ZDFab36FeLM7sXHUnxHdDZRWvwa
4266	fee_transfer	1506	33000000	1	CkpYzDMu4g6mrdYahWbr5UH9eLh2FKf95t2MecBEfwtGbaQHEGn9R
4269	fee_transfer	1646	11000000	1	CkpYjYepShcbhMk6y9yJhD4MkC2V7bHH6uxpG3yZf18UtLytTpKs9
4271	fee_transfer	69	12000000	1	CkpYub1zSJm6aYUBDLc7FBucZRRXeRkzBDuga925UMxJs1kmxb9zR
4274	fee_transfer	506	12000000	1	CkpZeTVBZGc3KUGdqnqc2x9zQE7b3BUVMyzwkSh3RiR27fRUYmSdK
4276	fee_transfer	1764	101000000	1	CkpZsFo5c4XRb8K2bqRwH6KarUcKPwczYnk72WVa3R3xBELE5vmvC
4277	fee_transfer	1458	47000000	1	CkpZNPddf6eM5Wt3bN1XSQA4hYnh68dR4wUV9Gr4PARnaiGWy1jTK
4288	fee_transfer	1691	23000000	1	CkpZDQ7U92LFEMEVwR5sDtz2VKUT6edg59JxuFUStse88qHFRurW7
4289	fee_transfer_via_coinbase	1420	9900000	1	CkpYjCFnDzidN1MuxPXLcsXSpNuePPTJPke7MEv7rwm6GAKi1oLpS
4290	coinbase	171	720000000000	1	CkpZiGVGyNejsSrJW9avpTVdwsRndosf95QLj3DNX8xk48ZJNZy47
4291	fee_transfer	171	2100000	1	CkpYeA86FcTLQPgzUYm7hiT9mSQtZc263S77xXjq78EGpW5qxuPtL
4292	fee_transfer	1420	9900000	1	CkpYjCFnDzidN1MuxPXLcsXSpNuePPTJPke7MEv7rwm6GAKi1oLpS
4294	fee_transfer	1709	12000000	1	CkpZCzLUKUF45Px9sLMQr2SUcqDjdE2Z5FKyuNEzkAzoZeS87pqxN
4304	fee_transfer	1679	213000000	1	CkpZ61ggfqUAXS6j2MmM1C1MQuRLDfkm58Psr6iYCYvo6fwpTiw8P
4307	fee_transfer	1796	2	1	Ckpa7x7ovXvm4qR9Tmb48TUZpvdJyEmdj2Snq8VWWUWPmLrLYJbgx
4308	fee_transfer	1654	112999798	1	CkpYTQKfpNvbha9JNpXotU3PCV1UrTjKsnmL113q4bcA6NnYCoDjy
4309	fee_transfer	1596	100000000	1	CkpZrJkM4wK1jUygoWd6e7LRu4MZ3UWq8mgGehaabb4UYVe2tpCkB
4310	fee_transfer	167	200	1	CkpYrhUrnZWAkVFurYmUMwceYhEyc2X95fbhJp1RjgXSd5cEKEetW
4314	fee_transfer	576	300000000	1	CkpZPBuajVbf9Qic6aTnPNtCiZnH7ecK9MUHoMicp3RhSKJAgG7Ay
4315	fee_transfer_via_coinbase	1996	250000000	1	CkpYzLDqHfBWdxBzM3sK3AS9fc9R4M6eba82hZNzQ9j1XGSWBaoUQ
4316	coinbase	576	720000000000	1	CkpYtHLa6WiPcP3br4eNPgx9txKCdBndUAAPnKTsPBbbcF5pGDXBT
4320	fee_transfer	1727	61000000	1	CkpYeKrY9j5jAhj42SNi3WrmGTwruRvgTRQRjkSXMCKmc4gT6ibsb
4322	coinbase	1535	720000000000	1	CkpaCX7PWzQyHkXa2Z6ku3kpoa6Y6y78S8SSyqBpy8aC9krKQEJdL
4323	fee_transfer	1535	51000000	1	CkpZS7BnCMk8DFNLuQBi7dznrdipgW28xgXWo3wWMRULWokHKqrkj
4325	fee_transfer	1980	11000000	1	CkpZ8dBme3aQMRbJfchYXHT9HBTpQBv8LqNasBhfrhgicJdLduyn4
4326	fee_transfer	58	22000000	1	CkpZtwFfSgkkNaY1yk1pveLycnPhiLoxVqvdxGYw1PS5kMBRcj4Km
4327	fee_transfer	1764	680000000	1	Ckpa6hT8x76pWLNWCHrLu69gQodzZYP12mLENRtCcFGCZvFf18teY
4328	fee_transfer_via_coinbase	1791	1000000	1	CkpZEy9EshhqB34H8skRCSDEA8h8rXRR36KSF3Aw3njWsekJjU4QL
4329	coinbase	1764	720000000000	1	CkpZfeDS4KHtxjnW9ZwRfSwviZQ5UDcJUBqcHNYdw1X916NLYaftY
4331	fee_transfer	1394	22000000	1	CkpaJVYQGkTziQibaVxAbVGbDZp3vjgG34LrTmPVoXG2P6quJkNYT
4340	fee_transfer	1547	55000000	1	CkpZymMaqAtP7ggH8XjcsBXCxWoaaUo6TkGhHqJ8ZspGiL8DW7bVR
4345	fee_transfer	1560	22000000	1	CkpZiJ9m4pxoSRMpL7T3T8tvEJr3TvdQ24tvpwL6A3CNsoG986kWn
4141	fee_transfer	1716	39000000	1	CkpYQ46TmXMb6S751auHWgTWkrW7DmDy6mUNxbuCCPx8GuAEuebTm
4146	fee_transfer	1686	25000000	1	CkpZGuafJScb6dugYRoGtYXcVmVVpVGetZAohW91p6YBSo8Xn2g8v
4153	fee_transfer	1719	16000000	1	Ckpa1RPH9h7uFSpzAec7ZBq9Ym5KQEiLLuvRvdTNGHJTQLRmkg9yb
4161	fee_transfer	1549	13000000	1	Ckpa1bVFogaSDyXUNkMW1Y2Xoo6gBqw7xvYMt3aJTU1gzxUv7Sxwx
4166	fee_transfer	341	13000000	1	CkpZktqs4xonuif1pazCZ63YnmzNgkD7WUhd3LFtR7mRGySRYC2P6
4173	fee_transfer	641	1160000000	1	CkpaGDQz8kbDvbEe6T25ZnXZUq3DKTNiQDbUHvGxxmManUq1ysnCY
4174	fee_transfer	641	90000000	1	CkpZrX9UaJka1faFVdtQmpE7MxwSiNpLmssTp7yQjsijNWB8YQcCX
4178	coinbase	1394	1440000000000	1	CkpZ5jFtkyuZ4oMnCnDeHMnF26YccAjkqahBMPEv2UUCXqEjy7YvT
4179	fee_transfer	1394	40000000	1	CkpZBzhQtS4Ny8fwKj9289kteaz3wNhjetTKLFzZeNZZKoCJ5oPij
4181	fee_transfer	1672	12000000	1	CkpYSqM8CHWoX5atbAFjTHo7gZYqPmsGxCvGUFjzRcddFKAniSkSp
4188	fee_transfer	1673	59000000	1	CkpZvd2gPM4ja857BnAJ7p9AUpqh9PbjFiTmZML5t68RSJKgvnF5u
4193	fee_transfer	1506	2000000	1	CkpZzZ9V4eChaEYmFY8rmJYReeLDqokeaaddoN9yY4R3jquqRWQAx
4197	fee_transfer	1395	24000000	1	CkpaGE92c27eqU1ZxLuNR4ggEGTk2wgiBsBJGZ1ZyyP7t6yWYsrhr
4199	fee_transfer	1708	19000000	1	Ckpa3hzsvWHnJpLHF8WVvuc2Y8qv7pxftJcEyv8hrM87q9tJXiUUV
4203	fee_transfer	1687	14000000	1	CkpZre89xv1hj4N5yfUKuhepZR8hnHgMUDiLk5vR5UjKLsMKq1bHP
4207	fee_transfer	1692	29000000	1	CkpYTfcUH34qSgHTb6pEYEZDvyu1p18fSDknaPaHDS1kYweeT8U43
4219	fee_transfer	1395	13000000	1	CkpZqwkpkeccxv1b5Pz34jNtggNk4v76hfHmenEvHDCLL6S2Ufcoz
4224	fee_transfer	641	100000000	1	CkpYfzu1tDhvoVJKaPj7JdFLVGoyNQZHyZ557va8FkcdX9wpEDPAY
4229	fee_transfer	1549	26000000	1	CkpZj6HadWLpYjrZuTyHpzekuwPUjztt3X8qDVQbow5oJA7E75uSd
4231	fee_transfer	1549	210000000	1	CkpYdHXebvnBsCU6SQRooRSxDBetHhyEKKV1CjZFQym76TeWW6nzQ
4232	fee_transfer	1549	330000000	1	CkpZwGHj4EpZT83M8FCY7N9wntBi3kuWMBKd1ogewwwDSTzV8RjiX
4235	fee_transfer	1764	102000000	1	Ckpa3htqv5BRyoiGe9tYvTaAGPpzaPWFe7MwUTsmE4Jz5nb5HmdNE
4237	fee_transfer	1394	35000000	1	CkpYmwHvhVeReK8V6QEDgbM4vMY8xiqyTX7d1fT1h1JEjRm9mn1RJ
4240	fee_transfer	1637	23000000	1	CkpZyXepxREpsuu4G2t7B2KMrxMraskMDtni2DgyGYsgJX8QU27NE
4241	fee_transfer_via_coinbase	2004	9	1	CkpYy9JUGPrcVPQWR29mDenGYzfMXXnZHpc1HuNqQ7TD5wTzgKgbp
4242	coinbase	1637	720000000000	1	CkpYzRDAJ3QfneRNeLc2WvBADUdtXvqCnBtBQGMYfA5rCP6HW6XxT
4246	fee_transfer	2106	24000000	1	CkpZ9ZK5guxpmTxHMweFGGHowHRUo4cpKKfgu7FUo6ekMZBCevcix
4248	fee_transfer	606	24000000	1	CkpaFK35sF3xWjKebzAGu3isfwtLjyQoUfibNRGaDEqkm7diHB6gS
4253	fee_transfer	1693	24000000	1	CkpYojNKVvK2nC7ehNAC5URebVWiPPQ6kXm1PqdBxsdre94ss1KUp
4256	fee_transfer	1708	24000000	1	CkpZy6JNSGsYsBDqRpxDiFwxoE3J16ESkWmfmgE3DK2itporPq1i6
4259	fee_transfer	1690	48000000	1	CkpaLUkLY9hs2rLDtpX5XYjfbn9rTS1jr4RJRLdS9ivtAy6vH3f7c
4260	fee_transfer	1546	136000000	1	CkpYW3MTJ34JMLE4cvpXtrkg6nZjvwoKi3M1sYqXFQxzvpRPNg57c
4263	fee_transfer	1549	12000000	1	CkpZCQiKW6zqz4yqdMPNkBNscASpNVXsCNV5Mzdhpwp5k358CXdvu
4264	fee_transfer	1613	340000000	1	CkpYfG9CGXgyLDQkKDT9yKEnEj94jX9KRvb1QGEuWpKTD8RAa9rnN
4265	fee_transfer	1613	523000000	1	CkpYhk3zwVwd5CqqwSyB9ob7XUg5zveQbeP7ggaMP8inWQitC1oRA
4267	fee_transfer	1588	33000000	1	CkpYwf3MLJ8NUoD8xZosLBsxaWwqXub3mJnt9Bckp6VhGba2DxSZy
4273	fee_transfer	497	12000000	1	CkpZpSr3BjPNFJNPEjmTJxrjRE67oADrAJtMuqM1Xyj21GYPanv1J
4280	fee_transfer	1439	36000000	1	CkpaJijP1PCTUj7qeymAX7dEektJaFZmt77tgbbCqDHB1UkPX9jYp
4283	fee_transfer	1601	810000000	1	CkpYTE56ZioUzcWBBhp3mzPLH6iCsetWB7pBDRsMEwT7USj44MdAQ
4284	fee_transfer	1601	620000000	1	CkpZNQAAgPts6tXxL7AuWh8VYJACbiae6WKXG5dCjXnevVN7vacWp
4286	fee_transfer	1601	261000000	1	CkpZvw767rVvWLttc7DbbcsXSgQFUoxXq9Z1mAisULPrFRqJiAoRb
4287	fee_transfer	1601	62000000	1	CkpYj4rVZFnocDcJgvxDtUgMj1fJXnmUJpGQAk3XL7WAKidyCFarh
4295	fee_transfer	1705	23000000	1	CkpZLTH23J6GP6EyHDJjK6WGN89zSMjGWMVYmAjDjYHR6bBUsnfyx
4300	fee_transfer	606	72000000	1	CkpYrU8bDtcuCzDz4ivfFi2seevmCbevNoxF5xGygG2DQ1xNWCE5g
4302	fee_transfer	1426	213000000	1	Ckpa8RVSmRrdHxLXTxudV6rq2k4PNU3NnZcGcG6REW7ZKMUrWjfY1
4305	fee_transfer	1451	213000000	1	CkpZ9RxeHfpGmbim3Lg89yEZekgxq99KtbR8W1tW7MtVnA44vKSc9
4306	fee_transfer	2039	213000000	1	CkpZWZGYMcmFHU6v6jdtiiej6hjqdg6MZdvLJyDAqfNViYKKYfC9J
4312	fee_transfer	1654	213000000	1	CkpZYJnHXaBcYZc5bir7zSWfBomdirEDhFmf8YXWcX7n2NKpSitbV
4348	fee_transfer_via_coinbase	1596	100000000	1	CkpZrJkM4wK1jUygoWd6e7LRu4MZ3UWq8mgGehaabb4UYVe2tpCkB
4349	coinbase	1455	720000000000	1	CkpaGCYjs59yJUHMxgxEYUVKuAbPg52fp65KvNsYtF3pSvotT1j3j
4350	fee_transfer	1675	44000000	1	CkpZWTk1jaGA99np4iDSPRdQ4fyfDkbC8cqU7qKYVPjzkgdf8f1VE
4351	fee_transfer	1534	22000000	1	Ckpa9hyjQHec7vFmUNX3zu9KF3VcMPDbcjmJkGiEYzLFTzhAG5WDj
4356	fee_transfer	1700	22000000	1	CkpYzjFEn9M8gYRyjrHmjjMB3Fx3WUnLWUaubTc2iMvJjoCzBa7ZG
4359	fee_transfer	2086	11000000	1	CkpaBmuT6V9yBSWPfcYxcreCfZXEBovyaB9XHWceJRLGdwkJAgRK1
4361	fee_transfer	1402	33000000	1	CkpZgMA2SFhcyE8Je5CpFMiz1Vah9CSdyqrA5yeFtRFQ682kkv4CN
4374	fee_transfer	2086	22000000	1	CkpaDfvSVsdoUo5GYHVTxXYSab9N7Y5WGQKgx71RwapgkGC9ZNfxC
4376	fee_transfer	1602	94000000	1	CkpYRLLiaTsYa2yq2pTKDaTL5QVoqG7vfatXDupnK6B7gKS7fHeje
4378	fee_transfer	1756	44000000	1	CkpYaE7mSAwsLoiWBBDuz22T94z4JY8PBYMMoSCkEWHxjRsFjNdEh
4393	fee_transfer	1467	53000000	1	CkpZDsAVqmiWzk3yACtrJJ27LfhREXxUcK4uxARiFF4f8hfAAN3K9
4396	fee_transfer	1394	25000000	1	CkpYqMf6ywFGFsKqUPsjykTdqH3KJtnjunmFvAeZzUTQizGkCFv5C
4397	fee_transfer	1688	54000000	1	CkpZqYuNogZNmpuuatmzDHjkWS4ShCh17mcz29qizNdEt4CDt1Hyz
4411	fee_transfer	1394	68000000	1	CkpZHUnqZbDNYNQRiThgJ3LcigKxStwrB52Sj5Hcbr4sKE8MavFN6
4413	fee_transfer	1711	23000000	1	CkpYbC8Acou5CGjPsJWdewEhh6DbEVqgZV8pd2ryrfEmnxdPfX6we
4415	fee_transfer	1395	23000000	1	Ckpa7j6mjVgTBcYR3XGsanLwWFn7CJFbxGsXLWLy9ae3PUZHEu9m7
4417	fee_transfer	1611	58000000	1	CkpZcADCG6BzSwNtTC32ucJNWTBqA4KXtAzT6VFPt6pjL9AKEpAT8
4422	fee_transfer	1547	23000000	1	CkpYqkmAs6QgXmqqLv29ZpN5cSSVptENiqtsG9Psio59yQ7wmd2WT
4427	fee_transfer	1440	32000000	1	CkpZLBuyKRPZ4XngTTSvWHskEr11i1irFNmc9Yj3vQmSmKrgMMcnt
4429	fee_transfer	1394	23000000	1	CkpZgQ5qt1ketLNLmNQPM8BgUt3qaFDs54vp9tvDNHCLHjtzSNBba
4433	fee_transfer	1685	46000000	1	CkpYvGu6a3KWGr2wTRXzETmQBLkd5Qn92ZihS8RHcAeJaDZvtQbrh
4438	fee_transfer	2087	10000000	1	CkpaKbxbgFEX1m3qvb5oZ6NTNSNbZZQ2qjvUUCRTvkNruxvtmCm35
4347	fee_transfer	1395	44000000	1	CkpYZZJakGSBaSLCch8kdev47V6RZ6SHoLocuVu4uQipvuZjSU76R
4353	fee_transfer	1702	22000000	1	CkpZeVbPW7cKxJTzR8Z4L4pR9HjXWsAQ6syk2fqgsmfJvCD2jaxTN
4358	fee_transfer	1394	33000000	1	CkpZdKs73WjCQvTj5Hsz2TddRBSVME66JrUEAuup8JQwmUfccqaVr
4362	fee_transfer	641	33000000	1	CkpYejerwCfVdGFpJvFoGFYRaF5eNtPs467CKB6yzUXgUfaNcNhL5
4364	fee_transfer	1714	22000000	1	CkpZHgwi9MtBd5FGBhPc257HNweBEEAy1oZNMGkytEGgoG2R4cqpf
4366	fee_transfer_via_coinbase	471	100000000	1	CkpYVjZbHCRV2gCzgkeiELp1YUj4eLqfrMSRACwgWESa746jN3rAt
4367	coinbase	1455	720000000000	1	Ckpa52R3SeY4NrEMnsee4bvmVCPDy5oYMWmCDkszYquRUq6wXgxUt
4375	fee_transfer	2087	22000000	1	CkpZ55cnnfCMLf1D2x48J9VCtBmr2ky8PnXpo9FpFfL8dutW2NX9J
4379	fee_transfer	1637	44000000	1	CkpZnRQxKKqNqRAQqAjdKGwHkw3xwBoqY1AQGk9cKivGD8dpvSe9B
4380	fee_transfer	1508	760000000	1	CkpYb22rJdcDK55a4ueb3HtA3hPJTMZmc7qrC2JkYaj5UCBAi7BLU
4381	fee_transfer	2067	5180000	1	CkpaC6KqGHq69msgyK4LcdmXwpGQhVYXbXL1UnykvtSPkcVxtCrKq
4382	fee_transfer	1680	1820007	1	CkpZqY2mxi5RX7XN5HhmCGXpobagRJxtY6tRW3MCSUe8AftygTbBS
4383	fee_transfer	1527	6999993	1	CkpZWnGXYSYSmqv7732SpYqzYnyLtX4FXKdPQwAG1UuCDoXx1UpTg
4388	coinbase	1689	720000000000	1	CkpZDoegzqpR4fHDTBXqaoLGu3F3F59bwGfx1EuJB4NzsW1F1qUEZ
4389	fee_transfer	2067	2590000	1	CkpYpzL7geNswz6Q7N1Z95sSTbWCJQuiaWCwrsA1d2d3p6KSgPRNr
4390	fee_transfer	1689	6410002	1	CkpYnoy2wYsygczeuJaR4EEob5VGVaDuGDt8FpBicSaSWUzRTXyPd
4394	fee_transfer	1688	53000000	1	CkpYcT6xvCMjuQ611jW3uighXLQPnF7Fx6tD7KUagaPHgWzEksvGz
4400	fee_transfer	1695	14000000	1	CkpZmv8kSTfixvNjN5BmGhqtmodf9y6LbeWkHxLggrDzY3uB5iexA
4401	fee_transfer	1455	12000000	1	CkpYjFJz2BFfqSE2bSXq8ZqNgsBAfHmM3ACSoLNaQau1aVPeEt5aS
4403	fee_transfer	606	6000000	1	CkpZRvsNhsF2ZG2yX2Ptjf1mdmq8LSc4kHUDtK7z8xL4UfCBeW9v9
4406	fee_transfer	1758	900000	1	CkpZD1wBf5kearHjrRjoWzM84WUYfGG1erXnQz5GwykFLZytWWjd4
4407	fee_transfer	576	2100000	1	CkpYb6LCD19Qa1YHKoiJvPz8RXyoWbLaPTdKJEPD9Ss8rA6oear2K
4408	fee_transfer	416	10000000	1	Ckpa3ASG7G8K8S9dqrAv377jF9nNiahkJupx2w4Lza3TryKSaqCLD
4410	fee_transfer	1458	12000000	1	CkpZhNBhXLaNKqKrp8B3BKFFtRDi1ieM4YDeMmvVsamVeGUf2EgaT
4414	fee_transfer	576	23000000	1	Ckpa8qDWtk5uccPQkHCCR78FzYYSijShHg1fybL1T6cBDTjoReQpB
4416	fee_transfer	526	11000000	1	CkpZyLoDdMpWV3i6kxUjSsexnhr2wGEsqt3bKBBQYJsztDw1jszhr
4419	fee_transfer	1610	23000000	1	CkpZmKwAGQizECZP7XvPGgVhDdxCa3ZPVKPfU2SNESWkvTje2jEu7
4430	fee_transfer	1700	23000000	1	CkpYgmezzWuxuEia9o9jxzjT1w3exyuEMcsrRN5a6MELujVMKWMXQ
4431	fee_transfer	1980	12000000	1	CkpZVr7QzTWvktZH777VHJ1LHTN96wgv7Lstzzbhq2gMygvzdx4ha
4434	fee_transfer	1633	46000000	1	CkpZY8ESsuSSwbhPZaDotx2jogjqd5dGhJr9gEtrhYBHcpq27Jbih
4435	fee_transfer	1593	215000000	1	CkpZa55NoNJBnJBiE2q2797M97h3PFgvfMhceHf4KgF6EwEyxKFac
4436	fee_transfer	2106	23000000	1	CkpYeH2TbpmSj8BwkzasGG3SvWbMaB9TBP2wZxTgCfnX9WwmPcR6V
4443	fee_transfer	2086	31000000	1	CkpYk13VUV5hZiaex6yUbTQrALSiLyCBAasGbvgLSPDBTxFoHBYtU
4447	fee_transfer	1715	32000000	1	CkpZJnzMMyDYSsYDkwemnKVgkbsc8BCTgzqmS5CjzwvBTgBXaNzQz
4460	fee_transfer	1394	1000000	1	CkpYkV28pw9TGEtrf7WKJxVfxFnEa6v79nSyKmYcYtay9MjPbo7FQ
4463	fee_transfer	1474	23000000	1	CkpZ7LVxEcToWJWhVazmp1Di2DaUSFN8iCWodM6D5sv9azReZxS25
4468	fee_transfer	1394	112000000	1	CkpZ7CT8Ysz4FcGWDtcDdVtE8GcVYZwCyxpTqL4BfLPAiBGGxUZsT
4470	fee_transfer	1729	13000000	1	CkpaFq7u3xxambG6hYN6sDM24DVKWMyXxoPK9opwcMmiex3XKQmLk
4472	fee_transfer	1613	51000000	1	CkpYUoASPfCZWpVTAuh2x8pjGWmvMCJAXLXiudgz4hko1Bp3rRZsK
4482	fee_transfer	1699	23000000	1	CkpZc4WGqDrmvLj6dGfAzWXyAvAUtSjzykJq2i9QEdn5pVTNZ7FHL
4484	fee_transfer	1692	23000000	1	Ckpa4zPo6ZU7h1TuRzs7VC7cma3Rq8w3cAknsPN29bMPheSN9gpWk
4494	fee_transfer	1395	46000000	1	CkpYvthodZDSDQg4G1TBayjepkQHP8cNmoyUdHoPzu252rgDwBAgP
4496	fee_transfer	1719	12000000	1	CkpZT7Ct9nx2YAHo4S3aWQF6G6KxinjURCyAqZxSob5bvHmZ6MpNQ
4502	fee_transfer	1509	35000000	1	CkpZmhWiiDBtQq17rmfUnWhAM7zx8GXeNSd63ibCs3qjHkizoHAni
4504	fee_transfer	1637	34000000	1	CkpZYgyicLvFxYsfvXAKyHL1HcuhBhevj8qtSQMLbqXS2AoANo8aD
4509	fee_transfer	1394	34000000	1	CkpZvygxVYeVxPFhovjSSBiDuwRqr9qPEZtN6jGZFUJw7JdBz3iFm
4515	fee_transfer	532	12000000	1	CkpZ3qTw1NcCzsVb2pofixkrpGW2SiMWpCTdwqnnbCq5XHwKDvqX4
4516	fee_transfer	1724	23000000	1	CkpZNTTUCcC1UE4LxxFGg1RHdRt8FEaVyG2W4YnLTeDwHu4qrwjq6
4520	fee_transfer	525	24000000	1	CkpaL5tTitwCHGo6opQJSB2FT6vFG3AuzzTnY4P5yNiTkB4MoydeC
4521	fee_transfer	1680	34000000	1	CkpYnAkpkeXU7jt4TrgJZz8dMnU6MhM6r5gpnL2TgPjPudhxjfMG6
4437	fee_transfer	2086	10000000	1	CkpYTmizstDNXwqRwsFLzMNU1mC5XfHAeeymKr1rrVZj4F4AKcPR1
4439	fee_transfer	1687	382000000	1	CkpYykjiLek9jiYBfbLDmazbxikwBKRQWAPS8aQn83mr1RxrEkQ2Z
4441	fee_transfer	1394	21000000	1	Ckpa2np6jm7GFycfwuZS9HokPhED6v5nPx49UQdAbN1SF2ccZRmrQ
4444	fee_transfer	1671	31000000	1	CkpZAxDHgEtZW7mQNkRMu5dbWF3nm1WtyZ4HDukBgX2z2t4Jv6sGY
4455	fee_transfer	1599	42000000	1	CkpZ4awJPvos1GTK5CsLSjkveKmqG5L74s1AJJkMQkWBQ4912zCRP
4456	fee_transfer	1716	21000000	1	CkpYjqoUa8LxCyjwj8ig5BbwFGvbhWsUNB8JJFn6ScJYfpDmFrn3A
4458	fee_transfer	606	170000000	1	CkpYykuoKDGY2A8bXXR661XowWRvY8FgUwE1QNzvjdGfwDAhhUTSD
4459	fee_transfer	1685	43000000	1	Ckpa6BQydmr3Dp4s5Xw5nu4hYU39ZXs6BRib2FTFhDLTXsGeb9cwn
4467	fee_transfer	1534	11000000	1	CkpaCZUS9CE3ZcF6gWcoh3CDdUtgp1WCCmAd65fPZo6Bjg6ksJa8v
4477	fee_transfer	733	12000000	1	CkpZ5KFkkuCa878uEBLSTV152jbpwZfp7cyU4fkXTiD26VpQsfwui
4481	fee_transfer	2086	23000000	1	CkpYfJPJiX3c2Yz7rv8b3s1q6yyRGawT9GmWonbsP8AsGobrj4BRq
4483	fee_transfer	2087	23000000	1	CkpZg6EBW49oJL797VUBUVMkUoHxP5AkfiBECtaFjun5mCe1KWbXk
4490	fee_transfer	1541	12000000	1	CkpZtf9SZodCcrFPusmcJ5By2skRnsL4h8eX8tGDtEJ16eT1krJWK
4495	fee_transfer	1716	46000000	1	CkpaFjLAP2FnQtha834TuiWC3dq3ZBDkzKwRCuHDDXy7zG7QpDss1
4500	fee_transfer	1395	35000000	1	CkpZ9HFiNLvweaxRtZ4tS63mgeNFFt3AjZTww41ptTFk2ZaaJRnPX
4506	fee_transfer	2106	12000000	1	CkpZkkW8CVZT1WajD2ZsV9byEjdD1UZKzyvHSFqbVrdjCHYzUQCf9
4512	fee_transfer	1690	34000000	1	CkpYnPHZTvx8fXsAPJ1A7a3Mw8mo76pbVJecWGjngeEcSJSed6nMf
4513	fee_transfer	1696	9995100	1	CkpZZyKzJdcL9mWcNRQzeFnRGrUK5qfD8yjp9YtBrRHxW38tK63xb
4517	fee_transfer	532	23000000	1	CkpZjTPnzUfm9VY9G87wGvJduhb4CegrQpdmgx6UvPSE92R9KnZcd
4524	fee_transfer	1541	11000000	1	CkpZysEJS6KPLecMmnYaAynPrji9cb4KsheTzJaRWh5ccC3evkUBM
4442	fee_transfer	1699	31000000	1	CkpYm3aye7mtiNMs5kUQ6repNQHgBgmut7TycxkECgorxvvt3Net9
4445	fee_transfer	632	31000000	1	CkpZ8VyvYDuymczQiwtq8dvBB7Ui5wkQVVe8hoff1mme48QPSVX92
4450	fee_transfer	1394	10000000	1	CkpZQqoYi7USVPHBXxdKPQ7wdnCAgNR1tiFS8StpwYSJHV6UPQ2gb
4453	fee_transfer	1599	53000000	1	CkpZSPVUPoZHkWy6q6tcX46o2FJzqdwzK812qJspuNXB2kXRxTaA7
4457	fee_transfer	1489	32000000	1	CkpZpWGhXt2VDK3B8mtVfSEjvcyqsdn6PBeZnmqRedHrBCEXvoVMF
4464	fee_transfer	1601	8020000	1	CkpZQnVteB6vej23XoV7zDCz9mymGqLGFFP9RXXAQ8ezhxtk4P2aU
4465	fee_transfer	1420	1980000	1	CkpZgXGQ7ZuCXc3gEvLR9vAXddutLksseYNNJRMtdScgggeB9rsKa
4466	fee_transfer	2116	1000000	1	CkpZK2aVmLvvzMFDgAERuNbXq4GBWzgAv4DomQkeq7fYjqTk8CAkj
4471	fee_transfer	1700	12000000	1	CkpYYQ8Rj8i6RuwuYccSaHRkCxA7yNwtHbCcci1bBAtJ7FwZcAhSd
4479	fee_transfer	1471	22000000	1	Ckpa675TbzP9iby35qpWWUkihYMMi6kaLJXWhqGGpynXKkWk8pbD2
4486	fee_transfer	1673	34000000	1	CkpZ9qYkTt22tg9UkQYGH21zCt4BxeE5MYV5APejZNW1o2JPa2eJe
4488	fee_transfer	1688	34000000	1	CkpYQ6aWGSvY3L9quDifprWVjHEgg2gSPrSF1be3vEq4jqAypigQH
4493	fee_transfer	1739	35000000	1	Ckpa44xUMWtGUyQStNgfmtz7riXG2WTSt1p9FvP6wvTZrES28AbF1
4497	fee_transfer	1588	164000000	1	CkpZJSuqLFPs1GjyeaiPxKJbwkjyQJbFZoQ24oPrSX3TNxj9co6PC
4501	fee_transfer	1509	227000000	1	CkpYmJ5ep25NUHArK52nvHfiH8ySojrxA2ehjsLWLRwHMxswdtvK3
4503	fee_transfer	1717	23000000	1	CkpZdFQ73UUGqdkksKCB3ZDrJSJAMWmuGAJGefk4xdhAE9gk9tXz7
4507	fee_transfer	1440	22000000	1	CkpYjiKTAMfk1hNSA7r6WBTGVwGKUaJEocEmQkxCg7yTtY9GXXs1D
4508	fee_transfer	1691	34000000	1	CkpZU1goaGhgPTFgSAbSRQ7FqeEgXPfjcgA76NVBqnd2JgEcrGf4A
4510	fee_transfer	526	34000000	1	CkpZ6X9dF6pDvvVKHvVM3vfhE4U9kZgNmfd4bRRCJNsrW9Qvhb5ez
4514	fee_transfer	1724	12000000	1	CkpZ3TPHtnqB48WXdAwCBBWXvPBUAXgJdpz5xQyHd5kQvQ3pXv2eh
4518	fee_transfer	2112	23000000	1	CkpaHmn4rG5Yu9rrUUUkDhnj5PnJkcvzoVCYg6uBVbjF2adSGisji
4519	fee_transfer	1513	148000000	1	CkpYzsKvugzpCDPMuVvjQYRGhaXpYoNui93PRTBijgrWqX7Br4kUb
4522	fee_transfer	1680	101000000	1	CkpYqPEjStroJjLsojCDjCEzzvF9jjBs4kcEQzmutAbRQ2sZjRaKn
4523	fee_transfer	1943	11000000	1	CkpYmha3d7qfmkWSG7CByBwnVZV8APrQyAeR8VjSXjU9feh6cw4za
4474	fee_transfer	1395	65000000	1	CkpYbmcndPqVWLvWGg6YUTKg56VFcLLU1MqUCMJ14ZfFgxYqsjbSH
4475	fee_transfer	606	440000000	1	CkpZzqRgnGbcB5qH3zLe7oEFnNRiM6UrjZiVjvxSrHs9igdtttztF
4476	fee_transfer	606	59000000	1	CkpYXX3w1bk6g3cT2BZq8p9pLhguEkQVVUqcQTpCvr6rVcfR6J9fo
4478	fee_transfer	733	2000000	1	Ckpa1jpL3shsaSESK5UTtijkhrq3rKPdcUgozBcLuuYna6ogxwXzn
4480	fee_transfer	1696	23000000	1	CkpZbD3D3hJkmVkVR5UE6qrrpDz56FbLWuEktpiZFfoy7Q2j4PAft
4485	fee_transfer	1705	11000000	1	CkpZuAej4TfZcWKaRU1BeBsG8UyijHrCYnCb6nTiZnPV2S9p8Qnw1
4487	fee_transfer	1451	23000000	1	CkpZdUVtqYoXMJnrXp9CZ4g9hGPY9wD8PShAP3kywTGgYB9qG2D9i
4489	fee_transfer	1762	34000000	1	CkpYfuraJkX9RkpT2gnmHwqYACwi5q9n57gquLMi6AidGvkhj1HHX
4491	fee_transfer	1719	1	1	CkpZPndv8Tt5NtKLGF3yfTDmwqpJZhMSnAUTVM8yzQc7CcARNbNMP
4492	fee_transfer	1671	23000000	1	CkpYd5d5TDUy6kbhfro6DXfFfLZJNHTP6pGgAosGPpUWuUMwUNfCY
4498	fee_transfer	2070	100000	1	CkpZtfoEirjjrJTp2nqYg6b4PCmfFDFjuRipnhdz6xA3Ff4STF7fj
4499	fee_transfer	1509	30900000	1	CkpYjqoQfzJnQE2QtvPyT6hZYKQScmqbMW3MG13DAYcQeSzmaHcse
4505	fee_transfer	1596	12000000	1	CkpaBpRPqtmV2svcJnCMBJimPXWouKAPhiwRAJ5ZDV1mFyPCy716Q
4511	fee_transfer	1474	34000000	1	CkpYSuCYnBoqQcegiaUr3oCbuKXytfne9LvwLUb7DKPLJuvYZvAmq
4525	fee_transfer	1718	11000000	1	Ckpa86PkbpHCEQxysVPGVeg3rTY6MdK4qC6spU68czEf85xvhzRSE
4526	fee_transfer	1602	23000000	1	CkpZVxFZNuAnscp3zUK5Z3yeBXKZM6mtgADrvyax13rdUPZQjH5Mf
4527	fee_transfer	1394	2000000	1	CkpZ4siNyVR1tCbR7GkYaLSSvk89mogWTcW6nKurXQsHWCtHNZWCn
4528	fee_transfer	1643	2000000	1	CkpZZuCPFNRfLi1ZmNwo1k6dMubHdhZbzKttW9RHYHStzjKcY9nQB
4529	fee_transfer	1476	31000000	1	CkpYteaKEEFrdjveq1dNKVsXJv7JWsdd6KJr2fAvSVLxnyLRvbxUk
4530	fee_transfer	1668	31000000	1	CkpZwWwNqC2TowcdVxgzHCkkvy5HQGv5NN1snnaMQEJZRhwv4ZMiX
4531	fee_transfer	1723	31000000	1	CkpZianGmXZPF3xMw5G88ydYmRyW6rz6JMpxY3KWdvFY1xBFxKdmG
4532	fee_transfer	1675	31000000	1	CkpYipQzZ2UuoFWw4xiDef1sYh6TGDrwhRurY9hU9yGWD63BG2G13
4533	fee_transfer	1680	31000000	1	CkpaEUPRt2nHysckTKWuWuPZmzaGWVZByfxRTmRHm8AjWpotbEEWs
4534	fee_transfer	1992	31000000	1	CkpZgz9xH57FHXpPtp31mHjaSrLgy4yzBPvDXBEd9yZoSvUNVuQeN
4535	fee_transfer	1749	22000000	1	CkpZPDwSSuxNkoN8JN4Krsj5vJcN8yhfHoeMZhSs57zesjnarNbD9
4536	fee_transfer	1602	12000000	1	CkpZvjFFTrHLhWvfEyiPq1fnuXt1Sf8d7daNw7W8p5fRgoCfVQMn2
4537	fee_transfer	1395	34000000	1	CkpYV2c3Y56DzMPaaEhMpCtaLfbj1kVapA4oPC8JcswgKL3hPBKr1
4538	fee_transfer	1685	34000000	1	CkpYiJ7AmivshS2Y7JPEYHWz4qB6VaK2H9n3n82ZJrLGcWMdoDFVr
4539	fee_transfer	606	23000000	1	CkpZsttBEwXy8nRoEePCy6nq9hSsvgWVnHsdHMs39CJwydaP4UuTD
4540	fee_transfer	641	23000000	1	CkpZKuKBYH4wkQAqDekbNzteARCiqtAR3e9FAQGbD5pF4BEvpNxhD
4541	fee_transfer	606	136000000	1	CkpZmkrnw7jtvWca6MGn9x51EJiyk5EupqZuiBL4wqb3MNxPFAvED
4542	fee_transfer	1439	23000000	1	CkpYsVqZ55AB33TevfKN9Uw8FYAQP2xCnYwmtANzE1VobwXNU9aZm
4543	fee_transfer	1668	34000000	1	CkpYUydjUvsxpqCXjNvSCVUEsbgbMVewZCywpuXJSfn5Hs3GAmTWp
4544	fee_transfer	1546	11000000	1	CkpZaimCXSCCTLJmKMp22P5qHUBPBUFDCjgB6fR7CajLbDDBGLA6v
4545	fee_transfer	1509	160000000	1	CkpZHE4NpXm2t8zpKm28mZMPfBWBPm4DS9yjfez7KvfsWwBNcbUNj
4546	fee_transfer	1509	919000000	1	CkpZyBqE1WKZMzoQnfdkcwwtP96qN8KPXYGn9Fb9WvPShmfs14M2z
4547	fee_transfer	1623	23000000	1	CkpZWYKdHqbB51c5N7aUKTez64iHazy7vvuJeAoJdnqPWEWCqH22i
4548	fee_transfer	1749	24000000	1	CkpZHt3Mi1u9sGbzYSw9NSd6odtoFjiouxjiSGP9bPqQ5zvQwisBY
4549	fee_transfer	1672	33000000	1	CkpZjHLrM8mpvZALaN92zZuQSEjUcrQMpJNGPkdNmwJ9XgBPMN5Bc
4550	fee_transfer	1679	33000000	1	CkpZCqJDL2HST2XdLXbpghHLr8KrStDi638GWdApYN7BZB7wLpMzm
4551	fee_transfer	1756	12000000	1	CkpYf8PUosZxMjckSUvxD5SSXmajTSbCoYyzJnUqfKjAjf19BnCnD
4552	fee_transfer	470	22000000	1	CkpYfKaA1brP3LGX5Xfj1oyxUqFxbv2a7g7fyjArNbchWeNUCHN8s
4553	coinbase	1715	720000000000	1	CkpZzcSJKvs5hVLfN4NocvPe99L1fMNcTnT7TvLWokKd2LYhVF3NX
4554	fee_transfer	1715	20000001	1	CkpYwsXhAaqr6AaK34vG6YzjgQ8jkdrv7dpbG78Z1TbKRaSuRBS93
4555	fee_transfer_via_coinbase	1517	100000000	1	CkpZa1kxqWLqK7JomfF3rHPH1DL37ZsWTQqPaZpdfqiCnTzCydZ66
4556	coinbase	1670	720000000000	1	CkpZyuRf4QZGguMuHYeLWhxK1TgD7ugJY6ydkdjbpVEKaEZXmHfTJ
4557	fee_transfer	1608	34000000	1	CkpaGmbmVoGHBTvhpiP5iwwiRT58t6hfS4Qupb1bLi5nK91bJ8fun
4558	fee_transfer	1711	34000000	1	CkpYpjbZH67i6NxMyZ1bP372H7eZMDB5pWAKr1M8cES3PJhtNCBZe
4559	fee_transfer	1419	34000000	1	CkpaB2589DeetunnoQJ1w7s7K7VB7BnQNgaDPUFmcjDAdqEy6HUSi
4560	fee_transfer	1670	33000000	1	CkpZAKr9F1qhSVirx94yFCXMMHnzxCX2gnsic8ARQEoNTvMiJjwRm
4561	fee_transfer	1723	45000000	1	CkpaLiPdMdfGqPDksKNicSdfKgoGRP16kwjez31YaEJ5TcKQrZaGg
4562	fee_transfer	1714	23000000	1	CkpYXLpx3tU9zZF4mEqjBMBYVimHJH22fGX81pM6RWjW5pt7rKEVN
4563	fee_transfer	1395	18000006	1	CkpZRXbsn2tZmbjKPR2MYjDoD9CJ5C164h8mazG1Rxp4de2cdnV87
4564	fee_transfer	1686	23000000	1	CkpYXK2AJP9jvMf5BFnkrSmz5fjvsbdNnMwTS9AW45PoG2pdT8dsG
4565	fee_transfer	1684	42000000	1	CkpYofmexyNB4vfdAboHaX9rKeDmhQSuJvW8xAUVivNracaa964ZL
4566	fee_transfer	1685	42000000	1	CkpZ19hXbgfTqE782ieV8beS4a8Q972vK4gMzN8dY6tYDfo1Yb4Ty
4567	fee_transfer	1555	42000000	1	CkpYVmKF3NDCrVv9NZ9GPZdx3KosFWRD84oPjuYXGPEX719EA6hve
4568	fee_transfer	1710	170000000	1	CkpZZzG5Zu7obVuyYfJG9q5jqMroEnoaXhaPcLNst1JyteC8pdV5V
4569	fee_transfer	1710	1054000000	1	CkpYgvbhte5xMxiomMZD1ftGYrdYEYXLXbV9txdSHUuMLQBLL2pct
4570	fee_transfer	1394	60000000	1	CkpZLdmK97etXMEiAPumpoL8cWuU8uuyekFHu9wGaxUiTF291rpK2
4571	fee_transfer	369	150010000000	1	CkpZrUHWvfCaBAMBNmS21BbwhHTxC4H2V37HRFqGc3yKqjo6RH2j7
4572	fee_transfer	1426	52000000	1	CkpZM52U8Tt6ydKVSK7nxUpBWaBxhsAfWXsGuqJA7XUfLzD4os5sz
4573	fee_transfer	1457	33000000	1	Ckpa1M4uRvocG2vgaiPLCyG9U71RPmR5Zv43WEbs92QvHqFLGebCr
4574	fee_transfer	1506	22000000	1	Ckpa5jffUzr3RzuH8QHZVpyQvfRsWtH8ADeuELRYVcfFsuRmQhT3N
4575	fee_transfer	1646	2000000	1	CkpZ9t9ByELRUtQTvrdsKXJNRoiPfTzdv74gbryrbPcPjep7V6hfe
4576	fee_transfer	1714	2000000	1	CkpaJ2Wo8fNy1TaayZfYTCmJB5iMnS34QwbZfUNqcUmU6UJjXqvhX
4577	fee_transfer_via_coinbase	2097	1	1	CkpYah1WARoVEr4sUrsEZzYW7DD1QF3XSi1Xg5w5g6xsa7bitWyLn
4578	coinbase	1395	720000000000	1	CkpZYjXAALGg5T66FTNMMAAQ7h41uR9nF1GMyEAhEMWnVhMgtPgcK
4579	fee_transfer	1395	10999999	1	CkpZqr5xH79twTt1ZKPMVvCZiWLM1NVpqjTiUXGqsuDAavc7BHsxh
4580	fee_transfer	1506	23000000	1	CkpYqKE5axh9mt93h1UaPxAuZhXdDBc1sDYqdZFUmnzph8J9GkjB6
4581	fee_transfer	1569	12000000	1	CkpZi8UtrUZNUJgfEW1ZvvDWiq1QdcsWBwtMxFakLTcco1iMq4fwU
4584	fee_transfer	1611	12000000	1	CkpZFTCd2dmCQn1JDkQvh4FXBAmZXCy5qtjHvK3cBiRR9263V5Tyq
4594	fee_transfer	1705	12000000	1	CkpYREjiyCjUYGeoKP3DCQ7PUMaAKkc4phB1G46TGyFVXw6bhXEQL
4605	coinbase	2135	720000000000	1	CkpZP7WKZFigo6w6zNd8dE5ntH8HGaufWvtkYJgyYSuwRinyahY15
4606	fee_transfer	2135	37000000	1	CkpaAFrvFq7p24tAqo1rmGW9P8HPV5NcTSKKzqsgfPt9BGbZJj6Wu
4610	fee_transfer	1455	35000000	1	CkpYWNdE7hXPXBHdQh3yLKtmGfbxPgzAfFroKJpR3EnsLYxU5qpKD
4611	fee_transfer	1455	3000000	1	CkpYyzKbMohAcDyMLP1JUVy6VW5GMgutsgbdJ8gK2mXSfjDQXmYY9
4612	fee_transfer	1711	111000000	1	CkpYfeGXbtoY8hYWxc1F3d2DdGF3jZeTPxmpJxw5yd63tV8FmWj63
4619	fee_transfer	1696	149000000	1	CkpZMH2s3Sr85L9SFrRc1xCqHUac4BZNwKTvNu4oNSWd6BGUcdUxD
4628	fee_transfer	1692	46000000	1	CkpYZhTvEJLNZMBREUW7uN4CxhSpWq1fTXxHvTK9wfUqpx4ht1r5d
4631	fee_transfer	1740	17000000	1	CkpaDnM2FGVrvQebpcPQeemkx6oSCeD85j2sAghozpz76PFLrwaUv
4632	fee_transfer	1686	24000000	1	CkpZdehHCd31VNQrVM1VUHuCN6ZnAfCjUmu3t56h3E71BWtgqTbXK
4639	fee_transfer	1727	77000000	1	CkpZLoFVXUmNY5wNfwdAqqBf3KtwWMpUWho8Tyua3xJahQ1fHcuqu
4640	fee_transfer	1719	77000000	1	CkpZktnTkAvrzUHjUEiGm8967p6W9HResNxe6XrXdjZzNjh37G7ja
4653	fee_transfer	1727	57000000	1	CkpYqB9WnDYAXaZDRqvk9tPThE9zw3saSCZSD5oyLjsNzEJxgJ9Vp
4658	fee_transfer	1688	43000000	1	CkpYdcdRLqHByGHBQbC4o71xemqCSnkUwZ5kEQZgz46TPntqZkBXU
4660	fee_transfer	1594	42000000	1	CkpZ8P3mee6Wd8CPhjjcw4raBo1ur4XLCcwmYL8LJqrjzKYePzywJ
4661	fee_transfer	1637	89000000	1	CkpYnXCKu8TPQS33EHwBHyg4uRiii4aBr49qBoqsmzsDUhLmHuwCQ
4665	fee_transfer	1394	37000000	1	CkpZrEjcsbbJu9yf8EiEYcpeYwJjScFcEgxsNhAujT45SGahwmksT
4668	fee_transfer	1703	112000000	1	CkpZkfEx9FSMBpwVbp2cwkt2oyvnxMKNvFrVhQunqD1vGVdMb8EcT
4670	coinbase	568	720000000000	1	CkpZxmE3Af1tCYRMk9NFQP4Rut4R7qNXoGppqbPUP3QUok4XE2mrX
4671	fee_transfer	568	12000000	1	CkpZic5KMuK3QL1MDAkyxKTMYb5nLDtpWdv1LFu7ya65BfBDLiswU
4674	fee_transfer_via_coinbase	1489	10000000	1	CkpZA4KcGh9hbYMqhoqsN1HtYXrjuZxGXq4CpQFqMDkHP8wSrC5Vm
4675	coinbase	1801	720000000000	1	CkpYZ9YqhcjoWMoAjXShQzki66D8ESxmb4e3CpAHRgEtHRRL1LtZz
4676	fee_transfer	1801	13000000	1	CkpYk5ptZKhHE6AN8rm698rCnsX9QYmPie4ALxtDQZcQ9ZtDKra9h
4682	fee_transfer	1394	36000000	1	CkpZDimxKWrKv8gFbdCGAvxCyRroyeuaoTdUxngvWiAvkssM298R2
4689	fee_transfer	2135	24000000	1	CkpYgfi2JXCQ9CdLdU7VVVETdaqvBQAfZHsQSX4BCLn8ryj8GqUvC
4695	fee_transfer	1504	12000000	1	CkpZQKHgcetCSwrbMXKdVbm19iEhgNDoq5EnpEusyf3wBTyENx4bf
4698	fee_transfer	1746	24000000	1	CkpaKJ9wbLKDCqT2Nb5J9opGoYvuPQbcnd2BB34haNnK8zihQBjty
4705	fee_transfer	1702	46000000	1	CkpYdEhbB572sEEZTbab1WgRcBA9nZEH8R4tU2Jx5rvdFzFoSHJXg
4707	fee_transfer	1693	37000000	1	CkpYUSrjN7XmhNgCN6MmJfcggpEtD3g65K5yvGG2yU5nGc8FQrT2C
4717	fee_transfer	1688	15000000	1	CkpZaLvXVSRonH2ugjTp4tpjk72T6K4p2LPmMbY1pEon5tyLE7zk8
4720	fee_transfer	526	25000000	1	Ckpa97ViYucNKPkKtz5NwUa3PiqpwnURgKH9qSzMX19y24SeQKNjQ
4723	fee_transfer	1637	25000000	1	CkpaD63DL7fTcG9QqFKehq3psTueaJJdyyLeF4GKjKBpESFEuuBgu
4730	fee_transfer	1685	49000000	1	CkpYmiLas6DGzjS14ycwB8Xw2adtpqkW8Y9g2H1btRUSShGEMLzJH
4732	fee_transfer	1709	44000000	1	CkpZBfbVMgzWSM21aTcGuxTZFrYeB8RZszoLKvbyKrCqsZPEioQhP
4737	fee_transfer	1593	24000000	1	CkpZevqy2pAHcmYPeXXYfKjCAwpLo8gtin4mgVjPNzVV3Ke1nt9tt
4742	coinbase	2141	720000000000	1	CkpZHUDEmG5qR5JXsfSA1ywmh1Si33aJhwvcXxUTaFxN3x1ACTNcQ
4743	fee_transfer	2141	13000000	1	CkpZ5VbgEWk3Vzcnc4NtocXxRQar5MiKWPc8xsqay9LrvLxgjWDkK
4745	fee_transfer	1695	480000000	1	Ckpa3fuq5oUgd5RegirAgmz2JhAQ72HV1RkaiQQh6oaV4Mm7YSvxY
4746	fee_transfer	1695	68000000	1	CkpZiTv6NLe8RAwpCiXjZL6gcyE6kpFEoaa219PMgxQ8sLPPnbEmP
4750	fee_transfer	1598	38000000	1	CkpYf8enPxVQZ2U5gYqUADXA6pScBrjx6EguaZkkprxb3wyHzka5U
4752	fee_transfer	1756	13000000	1	Ckpa1p5J958vwnrmiSKsxCzSrtPBEt9MxVrovPHHw2PkZMC1dV6x9
4754	fee_transfer	1727	33000000	1	CkpYx7juTq6nJox2bqWr2PPcNpWcaACKKdfo9dbXq7TAJxTdnv3kp
4756	fee_transfer	1719	56000000	1	CkpZRFPFMnNdWp3vcdtJADSH99RyPsc4pcaAELc54YEzPjyhtLGyV
4765	fee_transfer	1447	37000000	1	CkpYcYkQ7VoUCMvTiEegMcbPKABg9BLdKFFRPfeGtYjkgW6QSP17i
4768	fee_transfer	1511	12000000	1	CkpaJLamZ9p7gpRrqM5qNVFyvtyzQVm3YQV7uVpyjWgLeiW8MejYW
4776	fee_transfer	484	11000000	1	CkpZhTz8U5wUswSKTht8g6EojQYxk54YTe5EtBBMT3BQNTA6RedGw
4787	coinbase	2148	720000000000	1	CkpaFDQK3tAgoU58cmfz65UaB2tmyzyj16GrCUKs4APhRq6DLyWZM
4788	fee_transfer	2148	12000000	1	CkpYygyoqReut6ED7zGF4v8gyFHcZqja4y2a3SJqvSWgmZPzR9pTk
4791	fee_transfer	1690	25000000	1	CkpZ6o53fRqVeFcmC7ADtV29kcyb1PNQDcTMCirs57boVcudzssbx
4796	fee_transfer	2106	113000000	1	Ckpa97Q4ApUoRgu98fKFKzqNM69VNpvkb4oQn32sRjtPxwMcQwDUa
4799	fee_transfer	1448	113000000	1	CkpYe6aZEbqP9GdHNiMBG35PUQDNkR9opGf5RdYaPfLgfkDGpVqj6
4801	fee_transfer	1716	24000000	1	CkpYiDY9DVyWSgQvSqRoeLsM3AeBbsrac2oAAAzroyAPBgSq2zpex
4803	fee_transfer	1395	174000000	1	CkpYdLSyMyAqqzNiKTxUhx6MWx4r4aupgBPyTDxJvLv7x1tB7uz5V
4808	fee_transfer	1740	37000000	1	CkpZNBAyFLSnpb9jFYzYiHBNKypF6ySBLbBeKg4W5Bn9NBrXqx6uf
4811	fee_transfer	1941	13000000	1	Ckpa31cdsR9N7gtd87kqKtxyRFq37VDWmGQhnjVCdBWHZo91qTLKr
4814	fee_transfer	1599	326000000	1	CkpZnubwwee3aMJcZ3HCR5Hser4z3hvoS77neiFuLq69jEQ4yru4D
4821	fee_transfer	1643	12000000	1	Ckpa8hpY5w8X6XYKFw1s6XcVyExskFFMfA7RzutXmSUHB7ZYhXMZH
4825	fee_transfer	1679	24000000	1	CkpYmfxfyohc1nsn5ohqzs3Yd8rkKgUMt6xkGK1iG2GNx5HhRZmmL
4826	fee_transfer	1695	25000000	1	CkpYj2E1BWgS9k59bVqTGtL2rwNXcVtb9E4j7BDDkWQqsBSKvucp4
4828	fee_transfer	1694	48000000	1	CkpYg96vY89NM2F2ckcaA1JmPpQSgSFTgTqBwSw5Ds2p6jQaLGyJi
4831	fee_transfer	1402	35000000	1	CkpZge6TouGkZmLnqvCwtkwe2GiZ4hSNnQyRY4Lt1G4gqt2Uv8qpT
4833	fee_transfer	1708	310000000	1	CkpZQzCvV2evVZHDb3K84byHMRwb18sAwT2VKHjyyYF1HGFWBAKYB
4834	fee_transfer	1708	211000000	1	CkpZe3U5R4UkAfsshBFizGnUqshyYcpv4XqVYXrTPWAENtR3CM9qc
4844	fee_transfer	1489	13000000	1	CkpZbEjjfuSJFNotespJg7CY14qB3DWpKgM6K4viV4fp85FD2Vbxb
4846	fee_transfer	1618	13000000	1	CkpYcaspjucMw87hbnYQ3hNCuX54mR8whLmJhBKr9Jo6g4qKKHhdA
4849	fee_transfer	1613	25000000	1	CkpZLbEvbZk73knG4kZFCaQAGeTDruVDeDN84Ni2EvME8Xnv2QjD9
4856	fee_transfer	329	13000000	1	CkpZJzN7U6ZAzr9smDBv321PFUgjcHyDzFawXJid9FtrTzDmGq5tj
4861	fee_transfer	1571	25000000	1	CkpYqc8GNhHV6M2kHz1S8K9usfDVFkF4yHxzcraSqATzR6FhVFBP5
4582	fee_transfer	1555	13000000	1	CkpZTxgJoya3KZwTu4GAgw7TDzBEGgQLyQS4PkeJGTXouykKTUxuo
4586	fee_transfer	1555	23000000	1	CkpZHFJhmfqiG4Mw9hCimTRPgkTicexvJ9YpEEN3JrqDGEGSXKqUn
4587	fee_transfer_via_coinbase	1786	10	1	CkpZFdMSgmtgntnf93Nwf6AicaADPQRMiCzTUt5BKCweKW4hkgVvp
4588	coinbase	1649	720000000000	1	CkpYnBkPgN85sLym5T5qEfc4fNsFd9E1qLseBeXxQzwTVDxLzoeyN
4590	fee_transfer	1759	25000000	1	CkpZEZnPaSVUD4rD7g5wMbRwswKKNavwjjFTmzqWGEDKGaCWPRjGC
4595	fee_transfer	1709	25000000	1	CkpZsBksLkdzHCJzjqJNHcBemz9W9z5DUktToAS5T25WCCB722YDL
4598	fee_transfer	1724	15000000	1	CkpYbshHQtKbZprm788jZxYAvxrUmgdw86MU4TC8fy4DgzBs5APsX
4600	fee_transfer	1637	15000000	1	CkpYruWD4Bx9N6GeP6heocPRjMABXcpN8L1rSh2w6r6HTN7jhmySu
4603	fee_transfer	1710	160000000	1	CkpZhEQ1fZ8gyhqRsnqv3VYpfG2HxE1pX3gze8TrpFnYct6CNdmw9
4604	fee_transfer	1710	838000000	1	CkpZ3Bfnw5RmZi5gZy9iru9sgJ4V2k2ndqALJo3Js6JebL3znqdqi
4607	fee_transfer	606	13000000	1	CkpaGk4YG1F8o6LpwK468HdbMwULsECw3Xi4G8kgq71kXysCqd24i
4609	fee_transfer	1668	26000000	1	CkpaGAyNtiT8fVaqutSL8zPULNTJqtc9Us9fgQxD9AkaeGXQYkUAv
4613	fee_transfer	1546	25000000	1	Ckpa4UosjvSThgBktkriq2FrkegR5GAHw9kv17B8bnTXj6GWYH17G
4615	fee_transfer	1444	112000000	1	CkpYn3dNtBqRfvQFAUYAR1xcvPjF6fmhDZdh98C1wauCRsFNkEX6Q
4617	fee_transfer	1518	34000000	1	CkpYkvKefxUkJKbJvVRwCAWqJbny3dDUBvj4iAyqoP4DmF4hGsMLR
4618	fee_transfer	58	149000000	1	CkpZqWWAu1xFNbK8jtGRKUdbzwAWfYoynu5SFFmkekbRuqtcbytSa
4620	fee_transfer	1633	149000000	1	CkpYecrrtmVm6gyN5ZwoczuL5ocfxUXkVEzUDDuHs2pKHYLv87DwB
4621	fee_transfer	470	25000000	1	CkpZC2bMCg7WAnaKD7YjptJaDa6qKH9H36KBssC1zwsRgg1t1GDwd
4622	fee_transfer	1587	36000000	1	CkpZwrCtNkZZH2V7KkFxbJfQMRgsPXT3s53g2uoH6NcAohMYRf3H5
4624	fee_transfer	1599	34000000	1	CkpaAegNR2ksNDW5zLqeG7hLCd1rA6WCavkStDwypmAe9rStdXaTq
4627	fee_transfer	149	46000000	1	CkpYs3oGZuKyDBCcqVXTEjz7hPXvED1LMCmYA8pV6YJNfAgAA4Txz
4633	fee_transfer	149	21000000	1	CkpZRaUQUWKSK7fwKgiLV6LN8H878vfWrun2X6Pao18uza7216d4D
4638	fee_transfer	1746	77000000	1	CkpZhCZCceF8MRvMWgeUMWSYyeUFdJv3vW9pUMPUgfnKRujX8wxDm
4642	fee_transfer	1719	74000000	1	CkpaDiekXj9ryESBzYYDGKQzLEwWMxaXiCWh96yZ6XnJ7N7r9e1p5
4644	fee_transfer	1395	32000000	1	CkpYbtaMsnC7WYCfrjo7hwqrHhG2ff9kyVQgDSqYNkcp9w2gw9Zfw
4650	fee_transfer	1506	70000000	1	Ckpa6u2btKU8ATskHA88cAzU2esPQ9SXKGiJDYhHXKX66jjThzWkf
4651	fee_transfer	1506	57000000	1	CkpZgyCUJyMtjFR2npyXppUHpPUzSmCB5r7U7j39R1o4hwH6cnyJQ
4656	fee_transfer	1685	12900000	1	CkpZMAeJLagcau2gARRe4SAm1Z8KoYpeVkZbDLkBo4SvdiWAxiBEm
4662	fee_transfer	1689	37000000	1	CkpYuGRk1vPPB4PBuEfCrqDf7TUu91KKqRNmFgKUpr4MfBPbE2Gun
4667	fee_transfer	1714	112000000	1	CkpYR3B5wTBAynWteVUKkNL1az1FYtfpKQrH7e5joMNLkRwWNK96R
4669	fee_transfer	1467	24000000	1	CkpZeCVYnBqEiD3gWzWFEuwCCoA2Q3ZHkFH1RK7CzJsuh4dDQE8A4
4677	fee_transfer	1623	13000000	1	CkpZoWmkWiySzqbFCfUc5f4L3SpUZzSEWxijN2vvQrM9khynHkg2c
4680	fee_transfer	1706	13000000	1	CkpZVrXj24CXXU4q99J73gAzw2fyt2k92ukHCRfFGyp1m7asJHLUs
4684	fee_transfer	554	12000000	1	CkpZYU81xhAUBKowcRKywGksiAWznxy96uhiMyboDC22n1zdZpaYs
4686	fee_transfer	1700	24000000	1	CkpZmzXWJsw8oPGqqyunzogngfGtya6L2PV85VkU9Hqe5Tu1kvCf1
4688	fee_transfer	2135	23000000	1	CkpZN83AGUYHXMVsgWdi453Y8fKRCsUEqEUocF7eWrhoJEedHzS3b
4691	fee_transfer	1756	24000000	1	CkpYePF3bMEdBptea1e9qFkWCpA8UXsQGstT5iR9pBxAB7Qfbd2os
4692	fee_transfer	1694	36000000	1	CkpZBEcbuqw2YEc1zAKN4kXDnytXBgw5W4fsPEHafB7CmKuKQJWfz
4694	fee_transfer	1692	24000000	1	CkpaGtctcjS3D4ou84UBMTJzPrwyJQKa2UJLskiqUyS5ExEw9oD7M
4702	fee_transfer	96	12000000	1	CkpaBTNEf8ncBP1ARBXb4aieXbsTTxogx53X2efHEUVH9izogVaTu
4704	fee_transfer	1703	46000000	1	CkpZnZsZ5ryrLJgfztruz2pfTatZweaRzqTC8iJqNFV71yfexte4E
4709	fee_transfer	1451	61000000	1	CkpZ565h2Fv83vJJKeF3Q5NNcT3NifCeDtrKuCEMwSWfK5FZNGkfh
4710	fee_transfer	1603	12000000	1	CkpZGZKCtaSQmzLi3Qy1KcpsSitEzqYXUtL56bT6SLLfy8jf55P9q
4712	fee_transfer	1688	36000000	1	CkpZ2LZAvnQ3uQcCsmxqrVEWNrzSKK8UBs9sytq8YZEhahe2MjpL9
4713	fee_transfer	1467	25000000	1	CkpaBAs9BDTkQDnSayf1qQtV2uKuiJhF3oMZzsXRbT9LL6fAq9ymz
4714	fee_transfer	1656	25000000	1	CkpYVC7iKZhX1jesdPP3GBCRZnTntQYB6Stz5pXwvNRiRbrqkRUYx
4719	fee_transfer	1701	25000000	1	CkpZMCmY9gtqE3TVZ9w9w7dxVfPKG4z4pbyNYNtGxVaHppqEgMA4T
4722	fee_transfer	1703	25000000	1	CkpZNqbyqKQHx9CfSB2DLcxqsLcvAQ63ApmXthqZUqpfKdb5V89iz
4731	fee_transfer	1451	13000000	1	CkpZoyv8ScqucL6aJhqDhxHoFzjd3Xm98iyqpCgLgivcPMebVs59f
4735	fee_transfer	1271	24000000	1	CkpZu5yq22QPJvmMaiHGxL1C2hTX4evuh4sr2mUBJv2UA3hRgyWUG
4739	fee_transfer	149	109000000	1	CkpZHA1jcqwzZ1mVmAqEF7eQHXn9vizsYoN6Kjz9mn98DBsiPEbEy
4748	fee_transfer	1746	38000000	1	CkpZ63wMjM19RKqdhmY3YNrtHBEHJAPjdd4msdeehULs2g57gEFFc
4760	fee_transfer	1650	12000000	1	CkpZL8ERMCNrPqhRdULAPfLm5Dz8vJ95XvWHwfBuigGwRS31H8vSM
4761	fee_transfer	470	4000000	1	Ckpa1U2nATcP8Abuo4kKTUPVHBPcbG31edNLZ3TE5i3FGr6hjxViH
4764	fee_transfer	1447	25000000	1	CkpZ8j2Dban6pN86vbLnCm4BrTHBjvXRXbmV22cmp6FSNK7k1sWbj
4766	coinbase	1941	720000000000	1	CkpZ6ezRZR39zCJ3utiN5TwGZXeJNNwWDBvuHpD5nDnx9QHuYPCn8
4767	fee_transfer	1941	12000000	1	CkpZWgun3UiGBpJ1zXizdWQt7dUJcw2pjyvdiXdApchV4WJYQPGGr
4769	fee_transfer	1455	64000000	1	CkpZrQhZ3Mh88LwAGvkJLkg27HgkpDkSMUswXVYjot5FmmpubCyMz
4772	fee_transfer	1547	19000000	1	CkpYf8SP3yvMa75vxUgH3ANUiJr85diywr3Tv2Stp6sqAgtJq73ws
4774	fee_transfer	1476	70000000	1	Ckpa8igyoe1FeZkegbGvNqj4yvdrYAvFHvpUfqah6Jia3brbSbWzX
4775	fee_transfer	1476	85000000	1	CkpYnTNqAAS75Y4q7CiDdMANdd9tAkSJMmNtpNoYSdcHazWMBeNAK
4779	fee_transfer	1740	540000000	1	CkpZR6twDh83GPRBKVT5iLBjfrZcnJFnZywt5PEXP98EQUhEmzRcH
4780	fee_transfer	1740	710000000	1	CkpYvcwDS4GLQ3Ap7M4g4k9fBihgxq1jNcDNDz3hNdMDfGoMJQsm4
4781	fee_transfer	1547	25000000	1	CkpZVQonrQSA3Nc4xrvsvryNqcGLbjzfECQDJDwkxSJQpH5sFntAD
4789	fee_transfer	1613	230000000	1	CkpZYPXdyQWsimSXsdKF3Xpw2YPUbUDBhJ4yrCxkgpHsFzmisxCuy
4790	fee_transfer	1613	126000000	1	CkpYUJSMYQ3gQpPzkh5Qp3Q7BLJpLDi3vu2P52G7PkV4rzGK7naCM
4793	fee_transfer	1691	25000000	1	CkpZDKXreW5k52FVwdj6YQYLBFjzovry3QStiMT7yDTRjR2brWBgN
4795	fee_transfer	1980	24000000	1	CkpYdQznQdvGueNivUSba1Zrx48vucpjjvtZfkixEHiu4y48TYm2c
4798	fee_transfer	42	113000000	1	CkpYo8uDztqvax3tcADZiHwZ4CQkcSc1kP4FUSW5vhioWkNoDVH7G
4802	fee_transfer	1394	174000000	1	CkpZeF51Np9DyRyXMLqCDY6T9hQM5Fi6Gb6meTGwxkpPtwpDHb7ii
4583	fee_transfer	1448	62000000	1	CkpYm9khKXvsouxW7eWWaAoxqVjo7TvhaM2x5uLTRbGVhJExBBGLB
4585	fee_transfer	75	13000000	1	CkpYWzqg6hNHuknFmMYH8ETCBTfyrzN8j6dZK3mMEfRSXHLuNhku9
4591	fee_transfer	1706	25000000	1	CkpZus2kd6k9cUiUzoDGgWFkYh3veVAMijZKmymbNQqZj2HgkgifV
4593	fee_transfer	1646	25000000	1	CkpYmouWkGNsZvzctFYc4RHmJApdjkPXkUvxg5b9mDiJsq3bHcSkw
4596	fee_transfer	532	10000000	1	CkpYsYLHE4QxvYNW4qBauymQGi2ntpwpjCzZ2YnrLqcWEPfuTNHgu
4597	fee_transfer	532	15000000	1	CkpaF8WCT4gevuqPrsZXDc3pjtDwSfJMrMS9gp8fzBJTeD9CUvcnh
4599	fee_transfer	1696	15000000	1	CkpZLeQ4X2DcVpBfDra7RG9ne7wjRbgoLHjXQM8yeUkaCLAonzTWa
4601	fee_transfer	1696	18000000	1	CkpYyT1GsmajkzA6VqxQGV5LHXsRN8oNE2omQfpKraDfx6TaRZYRV
4614	fee_transfer	1395	25000000	1	CkpZK8iXFaV3zHChszfFL5EtCS9PfpTKRqQh6uKhSknYDPo6encZs
4616	fee_transfer	1444	34000000	1	CkpYTVS5yZmMaETiiYjxPGhm4VcrwQcXqhaihwMT4K7fD7xY5imtK
4623	fee_transfer	389	12000000	1	CkpZWjBpHw1Rx6LQAdG6C4tZkF3U9Cd7K1JP1usozMEtoGy5Z5D2V
4625	fee_transfer	1686	34000000	1	CkpZwHPbcjYqCZsVPzxYu2ALovTYJMU2Yc5UroiDsZhPCyHz5W8C5
4629	fee_transfer	369	17000000	1	CkpYyd16XGVCUcnoZFzmFV9F6bLqKPkcjgAjbZpK4naqxHtmgu3TE
4634	fee_transfer	1395	14000000	1	CkpaAFAJViucnGpmq3uiA9h2KTDZP9RFLJpFc2cZp2ELaRg2TiERy
4643	fee_transfer	1980	127000000	1	CkpaEQzbQ3sGVoAw5xgzvr168x53vEXhmyDvb42CAkvCzzRkoSXmQ
4645	fee_transfer	1692	32000000	1	CkpaGYpQFdP8wMYG876jZ1Sq2fiBp82pZHVefcH1yw8r2ZtH8XeU3
4646	fee_transfer	1395	67000000	1	CkpZ7CXrjtECr5aPDjYFBJgEJVj6sWZdaxVFPqYEDNp1GecxjQqPL
4652	fee_transfer	1688	57000000	1	CkpZsrecQTteNEQ41frKoc2GuwkX6pRikk9iHYX3aKhx3xeVzDDzY
4657	fee_transfer	1623	32000000	1	Ckpa25xgTDV97X3a6pHUmbqSxU9TYuAj7TCtcyk7YPrv7t5iariDo
4663	fee_transfer	1395	37000000	1	CkpYzNE9VMBN2uVFRAkTKHdc2oUhBZ7FW9Bcn7DJN4SSsysgMJe49
4672	fee_transfer	1705	25000000	1	CkpaJUisUm1GWHTrcerowDDzbFFnBYfNKYyyM3izu3vy4a8vn2aVN
4673	fee_transfer	171	600000000	1	CkpYpPDU257atgXkRBJ8qs4CDnXrEykuotThNcsZ59U9AhE9qAn64
4683	fee_transfer	1710	13000000	1	CkpaA47shL92u6jSy2Y8CJJ6rESmko5Gv6jFvFseWnrzfLfdPtVKs
4685	fee_transfer	1692	36000000	1	CkpYRGvUHbAgPRzaTmSqFNAN87djEEcqe4AQxFDWFEcZhYpsCJ9zT
4687	fee_transfer	1764	24000000	1	CkpZTEh3vTXC1ucdLTDsQmC34EkV6iUGQrFu8gheR3GxRtDXdqqWn
4690	fee_transfer	1419	24000000	1	CkpZemTcAK4aizYg1Hqu9mj3wpV14YztF2GisXTfbbpJYS8a1VfcK
4693	fee_transfer	1489	24000000	1	Ckpa6cJ2xTa8vFh3rCG2moQwwhjdURifNcQ39zNqecbdY5qX68jN3
4699	fee_transfer	1704	24000000	1	CkpZMatbfdBnTTJhAj3FNk6JJ2tHHc8JaQAYaJiVm8osBTx7hp7Dm
4706	fee_transfer	1451	36000000	1	CkpaJgLJjndcJEhTji9Nd6dPdjq6KscJQGZPY4THNtLyn4qEao6WV
4715	fee_transfer	1599	1098000000	1	CkpZGBxvLvj6am9Bbr21ZpLgkhMNsU9t1HUKWBYryCdR1ykgcETG6
4724	fee_transfer	1727	13000000	1	CkpZ7kYVvULs2M438SaZcSj7zxbmCuUgEr6a3gL9hy7SQZR771oVw
4725	fee_transfer	1394	76000000	1	CkpZc6v2fogeMgQf9Psqqpffp1wNQ2b6rU1oeVWn4qV4g12Zzz3cr
4744	fee_transfer	1567	13000000	1	CkpaAUubP5rV2ETJZGUtfJcxKkZgG9htEkJW6CYg3AenocHCCtfda
4751	fee_transfer	43	38000000	1	CkpZMAvP6y873ai5a2sfoW9mgQYbKQEptGFMQRmC66YJnKTZvAsAw
4753	fee_transfer	1596	2000000	1	Ckpa77Fus5Ph38JrDFYdsnvESpJJmuviEqfNCAiaifsLH8vKneBQJ
4758	fee_transfer	470	34000000	1	CkpYYjdfKS1vYx4PF8Dx8D8aewtPywnLZ6JUg1osGVcXKTKd14uUv
4762	fee_transfer	1650	26000000	1	CkpYqNAC4z3SPMK3sCFULqH5JZkMcw2ZTN1CXojWPreWY7MqNKpDM
4770	fee_transfer	1426	18000000	1	CkpZNybiPC24oxpk5uaESFJyocC8EPygBgENtwKGRXqQVDZHpE9Z2
4773	fee_transfer	1547	431000000	1	CkpYTcnuq36gSf6b8LWJiqZ7TJZqs96pVqrBPEgjMFejna1MMFkBV
4777	fee_transfer	2041	12000000	1	CkpYyNEVmRcLnA9bzzfEohzrBgJhXeZZ2wrutsDhse6WsHHpDzbRo
4778	fee_transfer	606	12000000	1	Ckpa7AEExiDqGH8zqehB1F2Nd2sjXMpsyfrw5vYdJ1VZK3XXesS3Y
4783	fee_transfer	1519	26000000	1	CkpZZwyWtKuabKFmFV6zXC4cDHFbyxQ9GabdRuK9FNUJH4x4ZbpLp
4794	fee_transfer	1740	25000000	1	Ckpa2aXbRWWyNcungxhbokuMRRjHsHPsdrnMUguJGfB765GKnJYuu
4800	fee_transfer	484	13000000	1	CkpZwRbmdbDVD3kDinTNcZCv1mphRoozRqDsFQobFcJUsmUqZ8XRd
4804	fee_transfer	1394	123000000	1	CkpZUBbCJ2Pa7n7TrvmGj7SFMnfwFvqk4mXDfWUxKXsF28oQg2DGx
4809	fee_transfer	1440	24000000	1	CkpZfXqjSkuXuUAaF5Hy9cBLMtJsDhCXHmp785dvdUEq5C7qLrUDm
4812	fee_transfer	1680	112000000	1	CkpZsrKMQL8qyaaJsLWqpsY2TcyBrBPABwWtuhbBvJz6eiqRvAERa
4816	fee_transfer	1513	720000000	1	CkpZq6sk2MTkSGG4wGt56LUXrwJfHxQVdmAcRhxCPjJtP8LPmTteB
4817	fee_transfer	1536	38000000	1	CkpZ2U1eLG7sz5xjiFiJtMLjhaMxxTSzeZLuKSnoJ8BBZZytqy4JK
4818	fee_transfer	576	37000000	1	CkpZa4VqxZmjjT6Mj8rLxYViE2rcAvtBe7yqs37zvarkBTR6wjJmn
4822	fee_transfer	1597	24000000	1	CkpYowaNxHhDYtmPo337hAaq5Ci2SkXTca43YRNUGkeEht7v8tspV
4837	fee_transfer	1580	12000000	1	CkpZEuwpsDj6xJUSN4nk46Aokh9KrYrevwyQJYsKnfqb7Uo4ZKeKz
4838	coinbase	1515	720000000000	1	CkpYoBtUwT9WExCzAf65mZhLjQihXU4Q9HRQztZ4kV619XAvEBcxj
4839	fee_transfer	1515	13000000	1	CkpYpj1YvvtSMS3ot31Km8kV26tNMuQ1jMQTvgihYj1x5Wc9dZXbq
4840	fee_transfer	1394	30000000	1	Ckpa7Cqr5zfy1ntmkCKauJ7JpEQx6YzhZo2xZhGeNJ9yS4srXBPTz
4841	fee_transfer	1394	29000000	1	CkpZhEwaaUfYwt33B23GUmWu2rSWXQKFsWhwwyHZUWv93FMc7BCEb
4845	fee_transfer	1610	49000000	1	CkpaHkcMrwPhhSocuzGgrF3eUmZSuv3wf6zEAtcnGjD2RbaTGmZRF
4860	fee_transfer	1634	23000000	1	CkpaHQZQrXjjDQAmUNjvYZazNDRPRPkMmRLMQuLjjiSuvhp1cpPtG
4866	fee_transfer	58	59000000	1	CkpZNwzFnv6cvP885g7deLbnrT1ZTTSV21rz9oC64XX6L3BbQu4n4
4870	fee_transfer	1616	24000000	1	CkpZhXwwn1Y5b1sD4Azyf47NVJEF6sj9t1nVLACheF6x7GagX1nTW
4871	fee_transfer	1688	59000000	1	CkpYUGPg1G6yNRZrQMghu1LjP8nTKQQgo4MhBfCC6qkWhyqhxq2v6
4895	fee_transfer	576	257000000	1	CkpYpex3aB3qRjomcrj6TMKg8jE5cg5EPmxs5vEyJ3vKTAiwjugqo
4898	fee_transfer	1668	25000000	1	CkpaBYb3LAbkbZRRy3sfWrZbNZKKytz5gxkyfew9XB6e6y7nhLeLL
4900	fee_transfer	1547	37000000	1	CkpYQAmvaLzqx6atutuMnAfi61ZLhqi5ZiHxMsYhSEfFhUHM78ikM
4905	fee_transfer	1422	25000000	1	CkpaFA2d8V7YU3eVVfpzd9zUKm9xbpZuDPBbGRPB8NQQHD9TambxH
4908	fee_transfer	1571	12000000	1	CkpYeKfQSK7RsyLEXhQJ7Vjmto72CWU7bCkfsDv2syQLpRLLS8uio
4909	fee_transfer	1727	25000000	1	CkpYZgaTNsHvcCNwqUFtSMiMU9x5gtPF5Cr3mAfYEJW85Yo2qFoJ1
4922	fee_transfer	1654	25000000	1	CkpYg37VRcto1vDqai75ZKVZuT2BkMNWnyotvGd7qsapXTXssDzvK
4925	fee_transfer	1717	160000000	1	CkpYifGtSsFbW74KR3mkz2QQUfqFTkf6C57HcCtMd6P6krAcz65AU
4928	fee_transfer	1689	23000000	1	CkpaF7tViKK4PHoJv3g7BrGyvXTiDDNekwMA83MMEXw21T5MtLDkF
4589	fee_transfer	1715	25000000	1	CkpZTSV1SUhun1fJsMvfga9rAYpNqGVYExyCAaRAar4dV9TMfND1e
4592	fee_transfer	1714	25000000	1	CkpYuavwaNAwaypVGBbiH4UHFthXyHX4LxsfrMCBAUCYjQpo18252
4602	fee_transfer	1690	37000000	1	CkpYeRA3y6nP1DwaVedeptoK3nngVpzGHKscBq3M4i5V8DZYJo258
4608	fee_transfer	1633	25000000	1	CkpYaJ1nLic7vcJzhUNnGhyBmu3KdoLxx9iYV9WZGDmZ67gaSxTgE
4626	fee_transfer	1560	14000000	1	CkpZS16AHqN6hawXk6xf2k3kLrcz5TtVnUW1JfKpQsq84YiGyedcX
4630	fee_transfer	111	17000000	1	CkpZep6ZU2ma8o6CwTzymr63mb52cByoLCkThgMgDpJt2i4mQYF6u
4635	fee_transfer	576	51000000	1	CkpYiwj6RApRoN3TFPzpBz4svap29whzgPFgYDRsbVH1WxbgaXk7V
4636	fee_transfer	1687	12000000	1	CkpYe4TFAQdNhR9pn2djmf3vLjDpu3MbjJM5MYu5ARWSqqpAfMwag
4637	fee_transfer	1747	74000000	1	CkpYdF8HQkMbzpSnERegG69uLM2ty2t4RKT1REdaoKt9ZCePbLvgy
4641	fee_transfer	1704	77000000	1	CkpZBVSvWLBxbAgip4mwaQRypE2cLsexTtCry1EnMYbKqAzHBY8n6
4647	fee_transfer	1727	70000000	1	CkpYZer8GDwqeiZXc5C5UcSaqHk7yN9B33KgwPj61irawQToGGo6p
4648	fee_transfer	1727	12900000	1	CkpaGXRtDkHA3YPWHS5WvUKho8vYVNRm7yfUCDbpCfcGBdYXpZPyb
4649	fee_transfer	1509	44100000	1	CkpYtK9XPg3hvJNkMsPwtqqa8NqcDSSVdCTQuYM8kkQbDQSyXCT9H
4654	fee_transfer	1508	70000000	1	CkpYTBE8uStBSYcU76zdyJkdkQjAW58EZ97TSfCmitaAgDEde1iXt
4655	fee_transfer	1508	57000000	1	CkpYdH14xC4DQ9K6tS2QL98WCZ5yP9vQUJazfYgJBPqU7eu7E4Y4L
4659	fee_transfer	1394	43000000	1	CkpYvviRwF8d8Nj69zKsiU5xccpUd17mPM25rXpT4xtiHCndBXvhK
4664	fee_transfer	43	37000000	1	CkpZiBXkbNR18qLsDYVHrawUG7Cc1m5mgP7vALLftQ8S6iDcjsojG
4666	fee_transfer	1702	112000000	1	Ckpa9iEtW1rpzHbVLkcrShux1jnqbM4XHSFN6izm7oC4yxTiEtBXD
4678	coinbase	1918	720000000000	1	CkpYgEVa9kDJdGB65EKnYuw7f7aRVLGJEvmXs7cRTfo7xLABXpwhm
4679	fee_transfer	1918	12000000	1	CkpYetMctvDhskCMnxrHwdMGX1JCzk7cZgKXB2s5L7UsW8aJ82hik
4681	fee_transfer	1601	24000000	1	CkpZA5mEw7LSobhffbHadZypsMZq67JNbu44eSjcfPbKvrEV7u4EQ
4696	fee_transfer	1623	24000000	1	CkpZMnPwxy4FCsQK7Tqwmfy1owFXL8mnREKSkWfsT4APeYrQDgQuU
4697	fee_transfer	1747	24000000	1	CkpYWmGj6mJbNECt6KAuJbSzz7358p86h625Z6uhrBgdVdaqtMswX
4700	fee_transfer	1573	61000000	1	CkpYdCmFtvGH3VcNRKzNc9RVdurfG9o4eNcrmKQBdVFoqjfHyeAFx
4701	fee_transfer	1710	24000000	1	CkpYrnFRGPGwyNLpJQNRtgurtFWVGsfa7Zu28UEtMFFnDW2essv51
4703	fee_transfer	1690	24000000	1	CkpYyNC6tkvST9NkREK7RLit96MpsmjDFcjbBFjSEFrjgXoj2Egk9
4708	fee_transfer	1394	61000000	1	CkpZNvBPPten6PGgSZa7fGNWCR65YcaqoMYNgpaJ2G7En3En2wfSg
4711	fee_transfer	1992	2000000	1	CkpYSpDHsbumWRDJmBtfzUVjzSYSqPHuFmzRj492UtVMWvHRhsqBy
4716	fee_transfer	1680	25000000	1	CkpYsAn98UV7RfGwqVFiWDDKK4wWogCnA3DdgqwMimstKaZxF1VQK
4718	fee_transfer	1688	25000000	1	CkpaLF9tYaLUMCuwTABeXCWXVL3RuoKBXMaow8DipuhY4CkNn5i9j
4721	fee_transfer	1702	25000000	1	CkpYiqAUcJ4eJJE8dWZx3SsFmbM628s1rf6F7mg1vNQy51ybgejJR
4726	fee_transfer	1980	76000000	1	CkpZTYhZC4Lxn8HsDuLurpdEsFCfW25HoM9bxTz3rFPUXraeMybHn
4727	fee_transfer	1695	570000000	1	CkpYtghxU3Ny57zFt57LKFJ5JscbyFyMj8upNnsfC6BNx7MyLLgBM
4728	fee_transfer	1695	140000000	1	CkpZpYcDTnn7pgKRH8GnhWBo5UgTu8DY1rxRVzoM3TzTALwwwE91n
4729	fee_transfer	1564	25000000	1	CkpYWJVRyfGW4oh32qmuTw6JYSubHCZKdpXSpSRJa2PyRsVLJsevk
4733	fee_transfer	1709	13000000	1	CkpYrkZxY52DvGXmVLjJdYKSFSko2VD2a9pES6zPqXazTu2Ym3g31
4734	fee_transfer	1689	25000000	1	CkpYatkij6zxgbS93xWd39CqA9uM26tJvrWmvf4vj5KbEYjJfw8Yb
4736	fee_transfer	1552	12000000	1	CkpZgbNCTsbs6QBinPEpaWP5RgMqGHq5bxMQhtAmRuwhKvTmQqJjy
4738	fee_transfer	1691	24000000	1	CkpZuowotRpKMMbXihhrquvWQBv8CyfMQctakb8cNcRBrtGkK7mWJ
4740	coinbase	2140	720000000000	1	CkpZuoiPEkJqzcHHWgg2fz9Hh93Dv3kNfGH5QHoEZYKb8MusvMGWA
4741	fee_transfer	2140	13000000	1	CkpYR3KuyW1vRkwyECE3LdmeXNwYMP9pFLp16eL5Yy8BFcDVCdx6m
4747	fee_transfer	1747	38000000	1	CkpZvJdSTmnxYzWXbVnMx2YQ8Qk3xZaGpPByQLgDWeKkUSrxvzhyK
4749	fee_transfer	1704	38000000	1	CkpZ3mz2XAa1wFKjJVa3mZ2o7txmBEfmgTmMjKixVNf3UJqM3Lqcw
4755	fee_transfer	1489	33000000	1	CkpZFheAAL6LnV5Pq91kSDYcSdD5RWwe2n6rSGvmYSU6oevUgbBhW
4757	fee_transfer	1509	55000000	1	Ckpa9eXHj2jGn5bkHCZXYy9TxvjFxcDbqgXuyABoFmQe1f8tUrUeq
4759	fee_transfer	633	24000000	1	CkpaBKjTjNCe1uhEZR19wCdz6Epq9kxAVmSwvx5sdUCyxQYowV1rJ
4763	fee_transfer	1616	12000000	1	CkpaEUN12pYJhVzcwC1wje3Pc2LcstMHNe7PyHM8FoTZkvXuw5uCa
4771	fee_transfer	1476	19000000	1	CkpZfrbdx49rRbJwQyjq7oFF6xfL5Tgj2pzaKsKSry77Ythzy9r17
4782	fee_transfer	1394	49000000	1	CkpZKiZrZCVinfGz3r1y5dt8FiL7WPt5qV6QyDp7HqSCVJK1gaW9r
4784	fee_transfer	1681	26000000	1	Ckpa6s28b3QyGJBXhK6fb8WX3AQYpfRswM1wmjj8cvjrub2ZPdXGF
4785	fee_transfer	1740	388000000	1	CkpZpkh199eXSGchyFwfhf63DpJ8YbB8NqMavqkQ2PKavgxgERPm7
4786	fee_transfer	1740	71000000	1	Ckpa2as2mnLCEDtS5Z4BGUYYCjFUKN6fe4Z95fGa68iEpZjraCmM5
4792	fee_transfer	576	25000000	1	CkpZBrnESQRCDeVmsW1YsmG53RkSZyBEjFjrxDKB24Zvo4NuR71oy
4797	fee_transfer	1457	113000000	1	CkpZkY7t5s5Yz4w5EBmMQEKhkLCSK75KWK5rYUBGh8z7xuZx52bYv
4810	fee_transfer	1511	13000000	1	CkpYz3dPcP5eEAEz3PTv5dgqQiZQ2oDKnYXwHwBbteop8s34oddbi
4815	fee_transfer	1700	2000000	1	CkpZwQNHgPBe6TcwaD7F7YkNv3ZDY79iPi8CF24wKieNFCUMby3qT
4819	fee_transfer	1611	37000000	1	CkpZA2insVP4d9mp1cMFTwSfdR7h4EsmSs4NVfbPT6L2z38QTBdCh
4823	fee_transfer	1681	12000000	1	CkpYivW9d4EzvFoh4ZknSvpfKGQGyb5ccFkaf5LMKWNDnDcWvKL8k
4824	fee_transfer	1439	24000000	1	CkpYRJqX8Y8RqCXHR4bSqbrHZWyCUuue4rzAE5TDmkdZQKdiiihv9
4829	fee_transfer	1549	37000000	1	CkpaBneyoNxhwpbAtJHrxsMKL8HRwL2ivJRPbfkGTQcxVDQnmyUAV
4832	fee_transfer	1555	35000000	1	CkpYzxBgAnDX9oL1Cjwkdnb5uFzLM3jgN531xCBernVNCaDEW3X59
4835	fee_transfer	1637	37000000	1	CkpZpH1pUXUD2qyi9hHgjoYcgCHAQMUuWfXiPFd4CAXqAUuqgjJwk
4842	fee_transfer	1849	100	1	CkpZe3SFQCfrjB9rRnsniSVNQDtvrvVjbiEAJxSGTnkWbMwcF7UYz
4843	fee_transfer	1850	11999900	1	CkpaH33aFDWhhTEaNQCMMGgsrQRvPxvPkQ3J7abrJiVAMQ8HqrvbE
4847	fee_transfer	2148	22000000	1	CkpZSS7Gz7shpx6zk41P7Uk5QJ6EM8rHZjUAtgP4jB9712T3d86Zv
4848	fee_transfer	1633	47000000	1	CkpZcYQzV1vnPK5toCf9irTavy6MUbkRK4PiEFJsjUjXn5qEJy7Rd
4850	fee_transfer_via_coinbase	1849	100	1	CkpZe3SFQCfrjB9rRnsniSVNQDtvrvVjbiEAJxSGTnkWbMwcF7UYz
4851	coinbase	1693	720000000000	1	CkpYxrPEuox2cZhT2bB2jRbnvHZEUmhPwwK9CkUUfN3RDakvXmVtG
4855	fee_transfer	329	12999900	1	Ckpa4o55vVmFDQqeXCjq2st7PjjLyxAmm6i3CRRuftLf6zoB1Uv6D
4859	fee_transfer	1513	27000000	1	CkpYatCrVtTujs2Mqn3gApFNrsUDkyUR6ykfbsrDzyrGKaJ72tuKw
4805	fee_transfer	1394	87000000	1	CkpZ67Dd6HYDfCEV4kgaTfxeZHYdK56yiQjkiaFzcWpHQxoDMnyts
4806	fee_transfer	1671	13000000	1	CkpZYPRYU3UaTvWuKcV7mKheatW8GTSsTb6zFyCvjBPEL1GcEGo9M
4807	fee_transfer	1701	50000000	1	CkpZvPappPUdh9i1RAnkXLcMGwu1pdFfvfJw8jjybzKLB2DpevuVk
4813	fee_transfer	1688	326000000	1	CkpYW72fRE5Z7RdFZGjNjAUVdAvRtpfBWfXcyvfUpSLSZjrTsRmrC
4820	fee_transfer	1447	35000000	1	CkpZ6WJRae5Tk487SGA6C2Z3VpMo7hx9nyZErfAVpVRqUgNbgXkXK
4827	fee_transfer	1643	25000000	1	Ckpa6KEHH7hh9wbSRKPHpNBx2KqkTe2d5Y7fcjvB6gkofQZkoZkXo
4830	fee_transfer	1687	37000000	1	CkpZozexR73XEBmhhSTya6tv1MWdnQqLBJbgPEQZzveEwB6rvT1YR
4836	fee_transfer	1580	37000000	1	CkpZyLwJgkrbpDM6WjSfJNVDLbKKM4QyHwvBeyRS7P2bXHECdeg2p
4852	coinbase	329	720000000000	1	CkpYaPbYf8WgFxgktWYkLmZWxedhkJTBmG4t5f8U8uz6T8ETqoioC
4853	fee_transfer	1849	400	1	CkpaJkcNvNF8n5hePb5xTbKEW3J2CQ7X7X1KaEMiq48SCqaNR2QPJ
4854	fee_transfer	329	12999600	1	CkpYYvUv2uZDL8jNSdpGuNSURYPfB8zFoq8hkLyWvfkQKe5AKitMy
4857	fee_transfer	1668	12000000	1	CkpYrBv5MqFuZzEqKbGHADmMx6e6PteWt4Hhn13Y7VXY9QHFy6jdZ
4858	fee_transfer	1608	13000000	1	CkpZHr9PHjNpJtrcJREpgYo7Hd4Z3EQtSfGnRorVyCtYvU3wCgUNz
4865	fee_transfer	1451	59000000	1	CkpZgctirFMfwaFk5dKBKxr3LRaevNFTarR7fx79KxTGgUe5913mn
4869	fee_transfer	1508	263000000	1	CkpaD463M4CuhVNstLT9U3Me55RDK79TbbwvLhW37WMrLDP91CFsQ
4873	fee_transfer	1455	906000000	1	Ckpa3dU4DWDgUCxkVTFW4LHX7coGebNc3yMuS5r3kBKtHkqqtGBHg
4876	fee_transfer	1727	24000000	1	CkpZrDGYMxtwQKyNrkKewXFFquKF5PXQBMEWrTzb9Hm7acggk52zP
4878	fee_transfer	238	1350000000	1	Ckpa3YCCR5CC7Q9QzKzmdbVFGz6i8Y98DEapbbiTGQZSmLRdCThVg
4879	fee_transfer	238	620000000	1	CkpYn3kauMG85jrUdv8DZfCFBDVGbXpBsPgL4voSVuLasY4iicohi
4881	fee_transfer	1455	80000000	1	CkpZZ3ncxCHzPNo4ChHUezQcqQ8DStXdoYcEDBiV69SufU2W4U9z8
4883	fee_transfer	1727	203000000	1	CkpZQdezHEnFEUdvpRmBewWYyr9pTHxaArT1fPKn6syouuX9Sp82y
4887	fee_transfer	1508	539000000	1	CkpYTpRgJjaxW4XdH3nnrRuHRzvMYMuDMWdcdHnRbj6QXsKnXAr7K
4889	fee_transfer	1571	72000000	1	CkpZPFEmDDpbL1XBSzyQMoVpRg3F1nzwfawguzT3ixVnFJtGLTgMi
4891	fee_transfer	1699	25000000	1	CkpZftTrjyLe1hHhZMfcxuBbzqS2QQvovu1NHfVXkEo7UUziwFHs7
4892	fee_transfer	1718	36000000	1	CkpYh3UabjHrnD4a9Yb5NaQsboBqiah3zhGqxYnUBEeamm3EG5MDF
4894	fee_transfer	1643	36000000	1	CkpaHscAoBX2PQeAP15RLzpBUDxpXrfsQwRMEa57mkbGv78pNqbHj
4902	fee_transfer	1457	23000000	1	CkpYaU85EJHVSAUwASWDeiE98idpGuRqvjJtQRN5pjqNMjwze2XSC
4917	fee_transfer	1471	710000000	1	CkpZGQ9E5TqqEcbfJU8DpcrMgZCb81JRx5TxH3fzZqduphoCk9qv3
4918	fee_transfer	1471	377000000	1	CkpYV1bJTLwNGebPgQudVS1iRbwFGbQQJJALAeShGQTW4hXyNRgs3
4920	fee_transfer_via_coinbase	1886	999998	1	CkpZFCiqi1F6FYyrvA3wsRmjeVrkeUGDCWHVSGNqTNug7NfvcTkxv
4921	coinbase	1560	720000000000	1	CkpZyDcp73ka1sMEE8KLgziM276YxNpyQn7QGhWAdmMkABMcBB5Sx
4929	fee_transfer	1747	23000000	1	CkpYzJZy7nPXg2TP7WThYbAjnYrXQmcyUGDAfw3jsmTC4T3MtygMf
4933	fee_transfer	1715	35000000	1	CkpZUTQuuPSDYwbnk6Hk8fad7pc22uKPhY5RbTqEJwmoFgJfmhQDf
4937	fee_transfer	1564	779000000	1	CkpZ77e4UeT3CQaayKP7axDqaFvbrEwaD7nryxWavSQYvgSx4mDdV
4940	fee_transfer	1395	3000000	1	CkpZJ9zG2RjQyrCqYxK8RjA4id2hDA9EpQXEASftEUibg1928KRAB
4944	coinbase	651	720000000000	1	CkpZdHGrsifM8zRDiJg8FZsjsXGprb6RQfEFfYnaTgYX7qiGcWjkN
4945	fee_transfer	651	25000000	1	CkpYfLmrL45weXemmm1w12CPgYJoF5Xrrbqx8ysJms79n6oBPrkGP
4948	fee_transfer	1694	49000000	1	CkpZwvFaBMnv61YnAFfYdmJtELCF3icAqh5P2k1GbDAA816dxhDWX
4949	fee_transfer	1694	25000000	1	CkpZFPaVotgLTvF7ict5p726VrFZgv7Yw9ix7A83zc8tGy35imtFA
4964	fee_transfer	248	70000	1	CkpYnaTaKbXCMgcQZduyfNxiSV1QgjR3rQgy7WheBAN4vizsTRhu8
4965	fee_transfer	1749	37930000	1	CkpYg9NCXj9euQ6UVsJ3aMGCj1hUuiV5Wc2zVTPxE1nLm1L5rK6Bn
4978	fee_transfer	1696	38000000	1	CkpYsGoMC85jJCPTb4441KiunBUH8szCp1BxL7SqZWybE2Vr9JSaG
4983	fee_transfer	1992	10000000	1	CkpYSxDJVdQkBJCbHkzKcXpM8nXDjEXADgaTP89T8d5TTYHNHkT5R
4986	fee_transfer	58	25000000	1	CkpZ4Rr4VEvi1YiweGWz4dntALqMZw3Wgq6VknQFJnpRRJtbWaDM9
4988	fee_transfer	1513	48000000	1	CkpaKTVjV1LR1YBpxoBeWaCJfKC1Lie5MqwJBqJJwuuccJKW87V2Q
4992	fee_transfer	1711	661000000	1	CkpZRCPJEDJBa5gRMj1CPmjCCUP7dfnGYMQpBrVEBoNbPts4tj8ye
4993	fee_transfer	1711	22000000	1	CkpYyC2CpkweNp7QrqoPvQe6ozBAfHEQJeQ8jnWQnGsFEKuzewrnu
4997	fee_transfer	1693	33000000	1	CkpZeRJWc3Q5Rf1mhUr6rVnvAFN3bps6WyTTYt7nF49vBaavbLiBz
5007	fee_transfer	1489	293000000	1	CkpZEE7pnqYTphbRQkV8bKrKhAiuf5CdXeuD8qd5JDUUbYpAdPHiL
5009	fee_transfer	2039	24000000	1	CkpZR4TWsBGZktxa6j3wPWZL8b5774r44ydKRz3B1R6jHrZcd2ifg
5014	fee_transfer	1508	339990000	1	CkpZomsFrVw2jeEb1CcdJ9V4CkvM3df2uCUfv7WAPxVzUgdcofT9Y
5020	fee_transfer	1727	38000000	1	CkpaKtz7oxUMyPMrjLn4y3AtVxTFnGLrWbaB1Brxm9bmmbWv5EZFg
5024	fee_transfer	1596	23000000	1	CkpYsecn3fzjB9fgE6MYEM8wXp9gMUGZXZP7ZSb1ohgXSpQGX7qwX
5027	fee_transfer	1489	102000000	1	CkpZ1nD15pniGTj5GVTqrrdv5jXEFR73uciKopNVMgJmPXXPMSdzJ
4862	fee_transfer	1440	2000000	1	CkpZLAVWAiXaMUM3rhxvFkv4F8ViusyzXGm33NFPf5oB2WzLQsHCM
4864	fee_transfer	1394	59000000	1	CkpaHpuEVjWkCtu9df1c6h4JMtY44LMPefa1mGzhVqbghNR8yjxaA
4867	fee_transfer	1611	51000000	1	CkpYyaJg25RJ1yac74JLDU2bdTm6zExrms2iL2PHDDb91RSSUtc3E
4872	fee_transfer	484	35000000	1	CkpZ3CSEppDadL2NXBXpRwSAGDUtCKCQrmr6HxbCmeF9r6bf45gtj
4874	fee_transfer	1692	37000000	1	CkpZPT1p855Fp53YupNFkJEzx55L2YuQcpFpZyK9yAw9zXo6wSvPN
4875	fee_transfer	1426	24000000	1	CkpYaN4454cieEcTW7KbLgB5BP64uWYikNUHdTjZ27BK7fPhycJQN
4877	fee_transfer	238	26000000	1	CkpZbxXV6MpHmZkzTfsUqCxsZb6TDFmcaBrskmMr7mKT8FrKBhkZ4
4880	fee_transfer	1719	52000000	1	CkpaBfsuf5Q7LcEq1RdHqQWmjCktxd79tM2StpQ38pZvonCgLNZFX
4882	fee_transfer	1649	33000000	1	CkpZohJ9MgC94sDoRg3zwFwXZ4HZNjaputR1WWycUTMXepKj47vm4
4884	fee_transfer	667	12000000	1	CkpYo1BTivL4i3a3pKZnfQAUoxQMKCYLD3GwFKPwm5Fxp8gGJQPtS
4888	fee_transfer	606	34000000	1	CkpZzikTHnX1zisvBY94MRkQPr5DSWmpcBF5rzuiJecGpKneQn9bD
4890	fee_transfer	1637	48000000	1	CkpZJBsGwJJMdvpVYQC1EjJoDg3evRgR5miHEgeG95fZgqZjcRgYV
4896	coinbase	1635	720000000000	1	CkpYmqmuYiSDKW1SXgvKXnuAe2UDFnj9Tu5ro5MeHHSXvJQmV3WzH
4897	fee_transfer	1635	12000000	1	CkpZdVthpbcv3QSx3tTVkK83zsC34grinpNrcu8QQmXaJDiLwiRim
4899	fee_transfer	1439	25000000	1	CkpZa2qHbQQX4h54jFbyMggJxVPxLWZYkB8kUEBQY7ttCqzh6U154
4901	fee_transfer	1395	1000001	1	CkpZDSRCfKLVPtpQV1RrCwib5dkDKr1vBjWPcr6KsnuWCUUEQRE28
4904	fee_transfer	1933	61000000	1	CkpZpZoVEPQMGt7spcuimrTpWT4nBrjJQnoy83T2WuF8yVkD3VhaR
4906	fee_transfer	1698	25000000	1	CkpZwhBKffZ2Ziba2k5SjSQiR6BrnDGCpZbaPBpxZzHd2RVd2fABJ
4907	fee_transfer	1555	27000000	1	CkpYqHVcxgvchDa2izM6Cv46zLvfoXLDm9ubAB3NbeBefbW4u8zrD
4923	fee_transfer	1654	640000000	1	CkpZz5831YbXXcuEpEUkQ7k1KjbweKUbsnszFwh2V1aUb3n5vHXX6
4924	fee_transfer	1654	690000000	1	CkpYbucZ7Fj4KH36zXgDSf8LwvVczDmsGpfVUjCJMLesduC3675TY
4926	fee_transfer	149	25000000	1	CkpZEQC82xf5fuX6jM2HhfTMtpxLNvunRNYmGZTUGuhvfHMwrLVwP
4932	fee_transfer	1704	23000000	1	CkpYtCEdWPJ38DGZkNtCydxkGTDnJP3GrcFzUKBxnkXeXrgzvWrnh
4935	fee_transfer	1430	1390000000	1	CkpYQx5T4bJC3PJqaj3ZyAKwbqXztpAmgihWaxFaXBBmm3TFd2dFf
4936	fee_transfer	1430	570000000	1	Ckpa3FtPXB6juQcoMBijv7TiXQ9WBxom25WGvunLQWhLwv9wDN2cY
4939	fee_transfer	1472	3000000	1	CkpaHQC2BXShgq5H5LGxXJjHeN1tN8MS6gvUSJtA1nP7NxqKdD3Ji
4942	fee_transfer	1564	69000000	1	CkpYfbUSP7TF9fGA1n63i2tkjvZhp5MfVx2ppAxUWsHGkQPhAC3ap
4943	fee_transfer	1432	12000000	1	CkpYRv8faX3or3GjxBwEWvpN7QkU9ZrW3ZWfBemd5oXvPT6YC5ZxH
4956	fee_transfer	1680	164000000	1	CkpYUGxQ7XDP1tJ4QsJi9sZpuoCfpqCZRemz6j2ovKnpERKHgbmDT
4959	fee_transfer	576	152000000	1	CkpYogqoTHp1NkyMQFSQfN3o2ayosjgVFoQpyPvQ5v5uYzmLFVRjM
4960	fee_transfer	212	1500000	1	CkpZ7EcsEgTt2JQLpGuYur2E6und8LLXNBQQkPSfXje3eQGm4QhSr
4961	fee_transfer	248	210000	1	CkpYgmm3vEwbJZVcMxis79VSykoEo2x2P8S5SDYZqwoatNSXMWYd2
4962	fee_transfer	1749	6590000	1	Ckpa5kknjqcmoqBVHke8akjwidJ13FgKaazAt3W2xcp1K2x6jeR8Z
4963	fee_transfer	2143	29700000	1	CkpYZDLzXBR8KrYKJ7RPgTXJJ4puFNEnf7BpcdyRBqsigYrxihgcA
4967	fee_transfer	1271	11000000	1	CkpZTT79gNXnhS1NV5X5CcbxM1aPH8eaHekePCdJ3mthHyEJmuf3h
4968	fee_transfer	1706	1214000000	1	CkpZPKRZpEE9kJ6W8cHJeLdJYtP1Ev6DpN7vFvu2ftConcykAog88
4973	fee_transfer	1471	720000000	1	CkpZsgZzBQgUTKTnEQgbmaqWzEbKMvSn4yvjuTtceMMcUp3AwRmgW
4974	fee_transfer	1471	341000000	1	Ckpa5vWHDtMb4x1ttWLMNLU7BsBY3LVb6wrVGYTy15tN7HWdvtL76
4976	fee_transfer	1471	48990100	1	CkpYSDYLYRY4EKBC3tDn6WE6XdVQDJCxX4nwY9www5SfKyb61a4eS
4991	fee_transfer	1601	3000000	1	CkpZCWfJYTfpV2UyDBPTgFcWFVWxj5ySuf2z6jAFv6hE5Uq9BSruf
5001	fee_transfer	1573	22000000	1	CkpYmZqYVEEzLpH3kCU251cpQg3iFmLJwLJADqXDBTdML1AkDR13b
5011	fee_transfer	1980	460000000	1	CkpZqQb2Sz1G6ZC46WgD4EKTJambkUvj5ea6B8XN3Lj9ugVFbDg7i
5012	fee_transfer	1980	502000000	1	Ckpa5kzPsPpZZ2hpMhdJ44sxvkTgvDXsZMF5wGEFKQxadaJ4WesW3
5015	coinbase	1440	720000000000	1	CkpZDk3w4Aur1yVbGwKEaPRAciQk2rCdnu9oeGrfSxHAweDS6QWxt
5016	fee_transfer	1440	999996	1	CkpZfT5Njtck4niej27HFeWhrZwN3j6X5jX54wqi9GM932HLEB9WB
5017	fee_transfer	2052	4	1	CkpYbXxvRTNNWiNe87T1kTiyZR3cVdW1vtZrsm653dZsXuC8DZtf4
4863	fee_transfer	1444	59000000	1	CkpZGhewoYhthyiwRD2Qwr36FfFtnXtEZfzFGwSst1DvJiqFVpDtg
4868	fee_transfer	1622	49000000	1	Ckpa13zgo6qmaigbhMawaupLDZYsLLZJHAKQJkWRyz3WqNW313SSY
4885	fee_transfer	667	880000000	1	CkpZp2CCgj7yYZ677u6FWG4351vw55P7eDSVh62ytQKy7d2Bq1YCc
4886	fee_transfer	667	80000000	1	CkpaFoXMRzYsv5oCSrWrpvj9jRSaouYmHKarT9ZZhBr3Xd9sfAuSm
4893	fee_transfer	1541	36000000	1	CkpYxsN7N6xLmB3cU2qmLnNgRewGmW7aiZDAKcGS6cMS14x7hMeDx
4903	fee_transfer	1564	1270000000	1	CkpYrHRm54XCTU1RYLLjb38wZTcwiEwKQFVNpMn5i7MgQhnQ8QB3B
4910	fee_transfer	1727	230000000	1	CkpZoVjbbyo5Jkn7qdSftZnCzm25QX6uK7qjoQTfFYhXo6rB2xN9a
4911	fee_transfer	1727	443885200	1	CkpZZkVBLkyGiWYZ6QBW28YFCyV1GJfydguTn8u8UDUCe7acCjXpm
4912	fee_transfer	1420	990000	1	CkpZcpeG3j2hTc5VZUVMA9TdGSXboUnNpSErmDdD8xr9Sb7mHShad
4913	fee_transfer	1447	4995000	1	CkpZWRpERbXXW9WoTEpFcB8GMxCM47EGxUu8mWYZ8SKf79qbM73r5
4914	fee_transfer	2095	10000	1	CkpYzZuc8Cu6jobUUGDnrLLCpWMHKe6p1cMTRmjGyBobXpc1qbbxC
4915	fee_transfer	1514	19800	1	CkpYdt4kS3An4v7UyXsieNiPXaz73q2S71MgWZZFCwPPsSQphpHSc
4916	fee_transfer	707	150000000	1	CkpYQay95eM3JAgdDhd7udPmsc7vGkD8yHAvAd315vBPm8u1qBoPG
4919	fee_transfer	1685	37000000	1	CkpZKHp6UGUuDsUEg4ngBhD12zuZoGXk8Rbpjq9xUvNaMp2d8Lq8q
4927	fee_transfer	641	25000000	1	Ckpa29w1bY8rCRZpPn4LpRHHU7VKvdEfvwxCvA15WTd3RP4tXRANu
4930	fee_transfer	1746	23000000	1	CkpZiwxpf2955P4vzU6Mr2qagnu6yJWU51efApRheosAUEguyMvKB
4934	fee_transfer	1571	35000000	1	CkpaG4kWvXimWff7shFmJVF3KW41PtAieDki6K7XyCkeFeDPb1XnG
4941	fee_transfer	1394	3000000	1	CkpZuxNB7H95rXrdpCtRFWSrRSXUFoJU9g2GvQymCkjRsJR8CvtVy
4946	fee_transfer	1508	25000000	1	Ckpa86opamAcB7jXQk8fVidTLQoTG2zg17gXm6sCJrWUQ84x2aApv
4947	fee_transfer	1508	1066000000	1	CkpZsQ62R5QxpmfLADSdDZUyQctKPmFdMrRvxapnLRmZVQM8RiUu2
4950	fee_transfer	1727	10190100	1	CkpYvLipSfWJXSXkhyxpy11TyVWBiMTKHz2ZRcyX7cis99pdF929u
4951	fee_transfer	1420	19800000	1	CkpZAmHoG37bzXhG8P35vjE8DVyVV7EPMbJqRBdhTsszFdfEzQ4er
4952	fee_transfer	1514	9900	1	CkpZv4n8kcxVNjyd6URr3kyCayCsuW1YCaXAmJjutNuCYaRcSHwQ9
4953	fee_transfer	1727	305002000	1	CkpYgdXazmWa93TtXkXrq9pJeZBW22QnHMvX2bThp1ELXVLLNrJ7J
4957	fee_transfer	1394	164000000	1	CkpZP7vvu4dUVBWYusUpBGi15FsTBHZPvsdGUzErU3YsSEuHSSb4A
4969	fee_transfer	1706	430000000	1	CkpaJHfLVtpzQeLDRtynCXSdzRGVqqZtVAmx5FEsC8QLMoECUXAHC
4970	fee_transfer	1670	25000000	1	CkpZ67fa9GjFjTgX21it6agGq5e8CypC1BAZYguq5G39vUKCbaqtL
4975	fee_transfer	1471	49000000	1	CkpaGdgM7GdLhDsVAkiwyf9CE6vCVNPrmdw4YYrFd2GkT3d11SDrG
4977	fee_transfer	1395	36000000	1	CkpZL4LZchsVEpBpG9q64YFKGdk5S1RD9j9zU1VpNuxUouiXxE9b9
4980	fee_transfer	1711	1120000000	1	CkpYrqqNMQsvJ4AFdfbYK7eJapf7NzwyZ5JLSWVh7Ea5VWy7JUr6X
4981	fee_transfer	1711	220000000	1	Ckpa3wNu6dmBxXvWGaZNZvvZyMAY7AEjzCkGhzXCGNVB1xp57CZSa
4985	fee_transfer	1709	37000000	1	CkpYkuGdUJW9ZXniWVCrqoWUTgeGwi1uRrUaddsovvQjkNv85WCmN
4987	fee_transfer	1555	25000000	1	CkpZ9LpcVVSbwyw7fcWo6RW9ZD9vfbCRQrqtkniDpJWYKgncP5Qjc
4989	fee_transfer	1458	48000000	1	CkpZPqf7j26VbKtV7z3UzZYoKbfs5xVhamBHAMovW97xABWef2QYp
4990	fee_transfer	1601	84000000	1	Ckpa2q94q41wTL9GXGiByKnzfnAsS5F4hwBcsD2JGk6Y5nPkQ1ANF
4994	fee_transfer	1560	23000000	1	CkpaLG8xDLPabc88WPH5iLWMXL1Bt83evpitdaewrjmCSiAzcRqtu
4995	fee_transfer	101	33000000	1	Ckpa94tTNeLd9xhQgejGRw6vjjT1jtgNW2t7c9c6KHw56Ay3SdU6T
4998	fee_transfer	1571	33000000	1	CkpZ4tqU76MeGybkpQLFKEBrmnsgChgZuAooPdg3oHpfMR5X1nQmG
5000	fee_transfer	1599	23000000	1	CkpZcRiiRYKP7M9NgHDReFt9miBAuj7TqhQYwWPxh6Frw1vvPxLX3
5004	fee_transfer	1395	1000000	1	CkpZfJMvoAfpZgUmrGgZYgcMd7veYDu8LKFCxBsRGHNRzvBBPXRsL
5006	fee_transfer	1740	2000000	1	CkpYzGCMjnzyochb4GvoGX5Wk2nUoP6XcbRW6uJ1ygRprz6SAqWx3
5010	fee_transfer	1611	2000000	1	CkpZ2L34wa1aLXuhB9zS1qoAShC6mUe1NPP3r8sm7Kkh7dFok291g
5018	fee_transfer	1440	49000000	1	CkpZpTvrNXEokc22yB3LP2vLvaewg9bU1YnHiLyrG7PP41wcsC1XJ
5019	fee_transfer	329	12000000	1	CkpYotTTM2ah6JGLFEsZgxgXg65FzezDQZ4Dxk5SnGs5UPRkinh6f
5021	fee_transfer	1564	22000000	1	CkpZcStxa6zejFy8zZ7ycV3NYJe2KLecyrufXXiS5U7Qe4EQn8Xfd
5022	fee_transfer	1489	390000000	1	Ckpa95n3bX8tyPDaqG3UR57gVh8DuCHmwY5jr6d9w4TCktncC9DBa
5023	fee_transfer	1489	122000000	1	CkpYXEfcUJhgY1v9kUBrGs2q647JJMjBjD5Wgr1vMzQffrBVvZ1qF
5025	fee_transfer	1489	23000000	1	Ckpa6Tu1Vk9NfiGC4iWmeuVscsECvWaoLbZHfvm7qoJiG28jeUDad
5028	fee_transfer	1513	10999999	1	CkpZPQ86dS6i3QBjXT4HkCQiEFr5zzm5Xh472LmFmhXPUykkqt3Rx
4931	fee_transfer	1587	23000000	1	CkpZvm4HRWodYDTc2UFKJx3WN3KcWaZG7mbzvfM8dpbtkuswp6LK8
4938	fee_transfer	2029	3000000	1	Ckpa1KDUPXYRh2b959hfjHEcbYYhRZFxiS5iNycHJWLR9CJnR1gr7
4954	fee_transfer	1513	224000000	1	CkpYSJ6nxXy2grFhDb6b9pZa6uoqN1z6feCHTS8WE1yUM2R9c2RxK
4955	fee_transfer	1693	112000000	1	CkpZJNih9RdCNDpDoBGHoeheJdLxkpp6eTVB9CYbSYp39K14pWiAN
4958	fee_transfer	1690	164000000	1	Ckpa3VA53m9kQ1x58gsH3RZmDYcg5SYov85cmH3QzntQV36GCUSVD
4966	fee_transfer	1749	38000000	1	CkpZfctGVmo7vpWWCVCZ7HPqRf5Yxr5PV24CwyUqErjy8FLxJF4br
4971	fee_transfer	606	190000000	1	CkpZu2hEehNTG7LPyLXV2nswd9TjYF5zTPqNqAhJsZrEVE26eK4kQ
4972	fee_transfer	606	124000000	1	CkpaAhaFQKRhAdn8DXRaGLuUst9BuM4Ut7jcGsYbJC4UGcNvWrPkL
4979	fee_transfer	1717	1098000000	1	CkpZ8VJtdHi7hxpo6iTtwCo4FHTZ2JZsusw6WyQpPv3MDQyQX1RyT
4982	fee_transfer	1457	34000000	1	CkpZCCkrzx7viQqJ4LEeaV5F3vF877Cx22nZpgkMD6dRc5wcYQ9is
4984	fee_transfer	1992	34000000	1	CkpYQL5ApNh42jchMARxR9DpM52U6p3tbac4fZoVdRKNeARkeg8XL
4996	fee_transfer	526	170000000	1	CkpZR7k7gRWY5uewqKBqfmNqR9WdhdZNsRgoNcjm2ie5iignGibW1
4999	fee_transfer	1474	33000000	1	CkpYwhKm3ErnPqo7HX2zJoGfcaR3aVfvxGtqTEezXwYLw62n2CT5C
5002	fee_transfer	58	23000000	1	CkpZ4E3HWimh4ZQUY7ipSoh4ob2NF9cgshvtoeyfivjJ4t9Szwie1
5003	fee_transfer	1610	25000000	1	CkpZcWGcrG8azCTXBNw35E4z3dQvH1MBrZc7XJyqQVcWfwjRiB1MA
5005	fee_transfer	1623	25000000	1	CkpYxAqZm5sM7ZypTdBrhG9XGSRg94LQHqZfHpPfX1Wkmib3L93eX
5008	fee_transfer	1593	2000000	1	CkpYy8M1Xe18GW5FSgU5mQ5dcsfMbU4ScKCGLDwViQHfqivSRykpM
5013	fee_transfer	1696	22000000	1	CkpZim1Jz9SwkbF2wccibRBte53bmCPu34itfC8Fx9PZRqhJaJ96s
5026	fee_transfer	1657	23000000	1	CkpZvFpPXPuzh5ZX2snMgy8beLiinjNCH9Jcb8hQQcSvphFRSTSBw
5029	fee_transfer	1695	31000000	1	CkpYhmvDSiEhCSLKwkQChMY3TZbyXAfn4AgqerdzwyPuUJB6QWZXv
5030	fee_transfer	1719	22000000	1	CkpZvjvjpztskHBCDVNgRpKzWxTj2NCp5pP6MiCvpuUV8zSXv2yyv
5031	fee_transfer	1695	22000000	1	CkpYTFnfasdoUdkhEM7LXiLUV4XJ7JP8QN9DnCEztjrSPaE3P21Qi
5032	fee_transfer	1633	3000000	1	CkpZHRGZxN7c8vmypvkv9bf66QHYgiXC35eB8NpL5SmERcjsV2zxE
5033	fee_transfer	1610	363000000	1	Ckpa9wxGzYcMjjbcKuUcwXtmjCZGiCCUs2L2Jy479L4XRjsX6zenc
5034	fee_transfer	1489	70000000	1	CkpZqgqya44vmeeLVMbnS46qnnjaJ8C8WsFMCNrMjH5pfHWFKuH37
5035	fee_transfer	1489	100000000	1	CkpZaLhmU5ugseK34TEu6t4HbKmyUWnAzRFdK3x3CWn1VodG19dKz
5036	fee_transfer	1850	21000000	1	CkpaHPf1ZiFxNNfqcctZGSZ3WoTwZRngtSvMysre8hGLhfUZNihck
5037	fee_transfer	111	12000000	1	CkpYRAitV7xZv493UFosQXP2C93SWZvKaHtqmCo4Vt5hMaaNYQYUw
5038	fee_transfer	1689	21000000	1	CkpZ2GU5sXjtvd1xeciDeAdnwzNo5kGiDxpnW4XNxHQdX9Q2b15zw
5039	fee_transfer	1608	36000000	1	CkpZWkXsHhcmToPpAw7EtSRx6BCUczSXPcTYoMZq4MyNrNvCcaHnH
5040	fee_transfer	1749	23000000	1	CkpYmmhPovTMHn5bJXiaGfk5KjXLZmWaCT1UkeVqrWUdWmZLZWrZR
5041	fee_transfer	2148	13000000	1	CkpYfbLcMLPygH7Q9TDviRgTyHWgo3B8PVcLoVx47SGyYhzGtZuWK
5042	fee_transfer	1471	1010000000	1	CkpZoUtfzAmC7ebY6DxMbEq9tLWkNLomqn63Z1Yd2rr5zQ9LvnSy7
5043	fee_transfer	1471	195000000	1	CkpZHkMRjnwiXM5mKfZBSRRh7MTyYmshPcQdYVXGc6L1kUtaAnYkw
5044	fee_transfer	1564	37000000	1	CkpZAeHsSAHJgdiar7CPphwPuccpvQDPV8HD5xZQks6DfMEaCy28z
5045	fee_transfer	1455	37000000	1	CkpZjXxr1pz9uSsaLykhrPAiVMfhmULokQiU5TmZNogG8ziaQWRMa
5046	fee_transfer	1593	124000000	1	CkpZvVz2vHv4k5tSpB4Gw2EKc9rLQPJGUzBbLc5dyKpq9MfvLgMxo
5047	fee_transfer	1711	124000000	1	CkpYyST18ZzXLXQSp5WR56n5ho1MvWEb5nSCff8QuFedr56E72STj
5048	fee_transfer	1448	124000000	1	CkpYiWsiZ5KYcmi2BPnWcvxk8xgCyyWDYrYxDEeefjpAb3wvVP1Yq
5049	fee_transfer	2106	124000000	1	CkpYUwY3K5KqVCu33dXEp2qZuZBC15Rpfupq6uFjua5h3XwkuJAK6
5050	fee_transfer	1419	37000000	1	CkpYif6GGdVyQaNjosZN2hJNPBnwChLYhrkWqtJXPQabyJAzG4WJH
5051	fee_transfer	1571	864000000	1	CkpZdSTvKtzEzKBV98QUz4RppknjW7D2TbsF4DGQGAc8wo5pGkWCu
5052	fee_transfer	1596	37000000	1	CkpaJa5yJ8oQLMnNzw2k9iLBgBeYvAubkCay6kqzPigTqBjeXtM1G
5053	fee_transfer	1426	92000000	1	CkpZJWbzvAibgJws2ybW1kSxwV5hc44HEVt4mJXD1hszJd8634e4K
5054	fee_transfer	1426	25000000	1	CkpYW7LNoDK4ZdLj6bVf9bNCkGUdF4wZpka9ZJieryjUZQW6xLrSh
5055	fee_transfer	171	13000000	1	Ckpa6ngTkiCW3n1MZGYvHzrhzP5cLrzdQ5jUSTMHa9wy9FSfxMAdx
5056	fee_transfer	1599	15000000	1	CkpZ1sQrs7gaysdYLuDdv5E5DrXMGFbcwom8n9Ge8MFgZXCtm1rVa
5057	fee_transfer	1698	15000000	1	CkpYxqR9Aw6NsjngzZYDrsQnoffn83mrrXXD9eLkBpbkPBSazVhrk
5058	fee_transfer	212	4000000	1	CkpYuLjKKTtPw4AuYArw8TTU6Y4YxEG4EnE7o1rRKvQGQ5SYYaVcG
5059	fee_transfer	1440	49920	1	CkpYwtnwXfrDfTfX22yTR2Y3GMjLQzELFVuKtrQ8tv2mV7Gs7T2pM
5060	fee_transfer	1420	21780000	1	CkpZX5kdNRr92iHbLqCNCF8L2qnLVQWbV33zBYrsACQZqbnian1Jv
5061	fee_transfer	2052	80	1	CkpYS91HvSMCfxUQXfr81mJP3mMboowZoMB86geETMcpBPFS8VdXs
5062	fee_transfer	2095	170000	1	CkpZZQc5kaY4qCaAZxZFauDDDZnsnaMkS9UMokuaP3XhBottvChF3
5063	fee_transfer	1440	36000000	1	CkpZ6Cy7U5HfBixDor8wuUiveaNdPRzTJvJzDD6fE5Qev2xjM2RN1
5064	fee_transfer	526	83000000	1	CkpYfiNZHexY6PWUfzAru6jhaTGtyYdWMiJZ7u6JxTUfSQqXonTNL
5065	fee_transfer	1762	25000000	1	CkpYyNzWmwcAtqPd5J4w5SxwmtFPCp3UKqNZgzMbRVP6Sk6Wfp3Zn
5066	fee_transfer	1509	24000000	1	CkpYrA4GLCVTN6AyEToR19TTZH4H8WbeCoiw685j2NR9uPDJSTX9E
5067	fee_transfer	1681	24000000	1	CkpYcM7Ght8b8kLyeMfRqbBwwdqbZTdMTrMe6QGUCXCwZE2cvMxHL
5068	fee_transfer	1451	5000000	1	CkpYwA8cB8xcFPuEmyU5kKF6ZXqaGauLPnRVrBW2hJt6xHyTxH6nd
5069	fee_transfer	1395	20000000	1	Ckpa7g1niqYm4vFU7uazm7V8w5QScVKRKtbrRxSiZKS1fnnVC8pKY
5070	fee_transfer	1395	5000000	1	CkpYk63edStrCqEbkam5FoC4pN87Ev4JmLpMYuzUM43BqPqgx3kMq
5071	fee_transfer	1476	25000000	1	CkpYkeSoYZJHTHL6wQ1bJNyfY75hMvwqaPCBtmFEt4uLkPdA6p831
5072	fee_transfer	633	2000000	1	Ckpa2fG6L4eEj8fJ8uQdxPcNp439sX6Ernvp7XgzdikCvD1PkQRi1
5073	fee_transfer	633	1060000000	1	CkpZHZD7vDYGJhFJTDdstcFo7p216RmP8gBJRDekSuWY2nn25kFWF
5074	fee_transfer	633	190000000	1	CkpYrf2MMhrYBuwiq75YCWZ9EqkifBBrfZMPbwd3rzeWPLyAMwF9F
5075	fee_transfer	2148	24000000	1	CkpYTLvXvcddh7CsLSEni7Te1Cc3uxebqq6eyGccfV21eUXEpdLx3
5076	fee_transfer	1768	23000000	1	CkpYZYokr4nd4JRCx3FJJU92pCvATnTDqqBPaUgdEPghRZdnDMNwC
5077	fee_transfer	632	25000000	1	CkpZwBXShzWn7pde9ejQM6mpvbM8WyNztGBiKm4szGLUeMz7y8yRm
5078	fee_transfer	1649	24000000	1	CkpZVzvhUz4qkpsrmdtUMvpTaScQJKdr4VgGnqzsexYx8Mp7SSLn7
5079	fee_transfer	1991	36000000	1	CkpZsWzY3g8skFW3vncyRhn1ANNwt3aJaro62GRTZWcTaeNdGHfH1
5080	fee_transfer	1991	24000000	1	CkpYjM19mhcDyFxqCXaEPoWCVQshhMgQ5zqrRQ6oNK1DPoaD2itFN
5087	fee_transfer	2112	1000000	1	CkpZFpPaks7jokpozGc9zeDBJzcycX8ahQq5mdkNXXGb2qn4b8dZy
5089	fee_transfer	1394	124000000	1	CkpYwfp8fj13GBN1QbxiC9f1p8Wakk5ZpjhAJv6kcsMFF61ESS3sU
5093	fee_transfer	606	377000000	1	CkpZBn6ngSrjRyABJFfqqGfjigUVPsNP4pnxpVgWkE9r3DqvUxq9n
5094	fee_transfer	606	5000000	1	CkpaA2d4ba52jfsMqHMAt416KcfF4jFgi1vxg9evXCQVXhAigCRHc
5096	fee_transfer	1740	812000000	1	CkpYkeDpMvALopi9d5qVC4psLtv77brgbHfMpM3nNtXzhVDiv1GMq
5098	fee_transfer	42	22000000	1	CkpYTa3LuckpgCbdw8fAMgcHtcEpApZ4w2qcoRmdAKnNWw7omCSEV
5100	fee_transfer	1764	35000000	1	CkpZutrHVqaBo3zwMY1JrcWnxQdzi6G2GiD4eTfGG64mb4CBy8QwQ
5107	fee_transfer	1588	180000000	1	CkpZC3iPCFqQ8vhNDvDWdMYTCYZsDz4YNKpFzia6koZ53zkGJa6Ay
5121	fee_transfer	1489	324000000	1	CkpZW9dvhVzVjcVrAyBJmzS1Tc3wRvFGjuHrP2hEHL4cj37RR7inA
5122	fee_transfer	1671	22000000	1	CkpYTUf9jpVNKkjtVumy5atBbKHQHVDTx6yhC5GckSZ7cTrbh58PJ
5126	fee_transfer	1395	111000000	1	CkpZRTKzk8Exk7qav6NcFLAV6LgpqYNb56X4eFAv1BvW8gWuw4JFn
5127	fee_transfer	632	234000000	1	CkpYQEVKzxXij5kaLbqp9q1RGS3X2PrbcTAbNknzD3eDuUCmCBehR
5133	fee_transfer	1476	62000000	1	CkpYg4EDcYoMqFzhSLidut2Qfv2NZy7FZeT1cRhU1rmdGVwn386Xv
5139	fee_transfer	1850	72000000	1	CkpYfVeT9qJxXsQof9pNnUCSuBjxh3kdrPHtWr1S5Yd3F8csJKvUK
5143	fee_transfer	1759	23000000	1	CkpZNsSgxnJKVndZJpsRGaX1ohWYrNtYcTNUuPxvWYovDesnce5sU
5146	fee_transfer	1471	82000000	1	CkpZDfL6BrMvQoGpPCv1U1bPVcWSbrQY3ueaaUxY4yY8Yz2p3cV9y
5148	fee_transfer	1508	236000000	1	CkpYTX1jjNdpR3Xuy4Ht9UU4CJsvsYrUk9VDmA2peyXZpzRdBiLVE
5149	fee_transfer	1594	236000000	1	CkpYU49W21GbWqiUvyVU9fQ6dLUXnMcoX2pGDLMirwZ14LJxkyXp8
5153	fee_transfer	1573	62000000	1	CkpYvpRoRa3jRpJAf5b816eoHJ1FKpYgvA8yTCMFF51vsPXhpyqrJ
5156	fee_transfer	1747	62000000	1	CkpYQMrReTKtb4GFkFCSENSBrcThMnTMfMQW8vh9Gr1kZPx9Ly5MW
5158	fee_transfer	1704	51000000	1	CkpZpFp3wHBZbrXJVB4k5dd7SkUAXGQ1FHPPLXLTZwCMNqSUB1irZ
5162	fee_transfer	1402	63000000	1	CkpYgYi9K989G8CUCHzDW8WKrixxtd5o9P14U9tdR31YV4SEogsrY
5171	fee_transfer	1509	36000000	1	CkpZHYU6gFbobvxCr5YmMUEwaHwVqn365tAFsZbKrLgS3tQvY2ybL
5173	fee_transfer	1690	36000000	1	CkpYfDESCNbisfZBJY9cTHQwVLFyS74v8qNuohs65unhfQVjV8FfS
5175	fee_transfer	1637	14000000	1	CkpZDCCTcCMmhXoeBNUYdce3tTMRy12RQtMWximK3cf7ao1a8dVdN
5181	coinbase	1740	720000000000	1	CkpZ46d1NfeyFkFDCc64XX3WEpFpHjfogrsVQMserEzqXzA8qZoCr
5183	fee_transfer	1559	24000000	1	CkpaDL3fEkFPtjHQdXd19oZCASVnLCj53Go3nDshdibn2tJxMwU5L
5192	fee_transfer	1513	530000000	1	CkpYaRhcxMSdjfHsGcXKkpuGfceHRggdvrBAmq4dJu6fmAxeN5yq8
5193	fee_transfer	1992	910000000	1	CkpZgRsBxgGWxxAuGtEGG4yLcZ18xPugJEAUkeCziTjsGmgJXUqdD
5194	fee_transfer	1992	430000000	1	CkpZSSYi59fPviDgmyMiEUWuxDgZZW2e23Y9TKa2iYE2yS7HbQDRj
5199	fee_transfer	1695	530000000	1	CkpZTJAvzDFKeAVu56YcyvePdH3GxHYSFoRSNfzq1Bn52TQdcsVKN
5200	fee_transfer	1695	900000000	1	CkpZJ7jQ5aaNtBuvM7gvdw2cTpur8XzRetq2VsZoeiCYm3s498seV
5210	fee_transfer	1394	52000000	1	CkpZEgjkGUpwJs79BCEhLjMvu7ie4JaK6Kzp9dYifFKT6Ty6nS8Ks
5216	fee_transfer	1695	350000000	1	CkpZp2F1vyYvzD8dRNaZZNBhwAcrgq8K2gyG4VEVuyz96Bfdr2Kti
5218	fee_transfer	1933	55000000	1	CkpYru6rp2ci5MyvvGSH5UDaGkP97m5pTtXjASqwxdcNPvc9pLeVi
5222	fee_transfer	1564	88000000	1	CkpZPxgKMuYXjAA6A96apHVwDJuYiUCrQ118TBbgTSrHDj5kftDff
5228	fee_transfer	1672	34000000	1	CkpZHWWsKivp85cA6mHrRMXfvaU5vHkvfH3Dn7Jp82MdvahBggHzV
5229	fee_transfer	1759	34000000	1	CkpZTxJjK71u8YpvGuorQRUZs14y3X5CLzPbDvKFN9ytRF9EQdx96
5232	fee_transfer	1637	35000000	1	CkpZdnJATWFLnajeNUbeTuB7QnkHZz8FAJMqMVYQ2rFa9QnrJ3yo1
5235	fee_transfer	1692	47000000	1	CkpYQqS13n55tXkJEy2khKzfpKpnDgUDvvWK54xhCQi61JPcA7jQm
5238	fee_transfer	167	500000	1	CkpZmSPV3w81FqFiZubvR8Ms4zAtcF9ue7gKZrU7B2HJuBhJ25Dob
5239	fee_transfer	1724	1500000	1	CkpYSANKFPKJf9iZGMuygFBfKw5P6xnHsTL5ZwpiCFd86Pn5iLxbS
5240	fee_transfer	1724	23500000	1	Ckpa1Jye6w7VZbxZmovJhsPpuEmSXzYAoE2epzEasMkzZJCqhuknm
5246	fee_transfer	1602	48000000	1	CkpYrbUX54oeete35mKV8EdueUKKmyEoWcpEEsBQ39Vjg2aG7XBC2
5247	fee_transfer	1455	25000000	1	CkpZf8J6ZrWqhA4KaXCdpKTvdzbpWRePZK9yRTu1PcYYNQuBjV29J
5249	fee_transfer	1395	51000000	1	CkpaCZitFxwzs9NvQwmMwc3eYM4FJbxBLUak7357PHjnN36VXt2LX
5252	fee_transfer	1608	24000000	1	CkpYRGpfgtetc33qy5wLpbqpxTksjnXq4UBCAxbmzZTxWJANFLNEK
5253	fee_transfer	1540	12000000	1	CkpYoXaw3PdgDmxKV6jXZhkdYbwKJ1gmH4G42iL3N5oDvTgY3C8R8
5254	fee_transfer	1716	25000000	1	CkpZn2PyCdCpi5am9NT6gWp7ARvqvfxxHB15PhQZQraqJuHozQjZv
5257	fee_transfer	470	16000000	1	CkpZ8Ys8oTijKLv5xoXyeMWV8HovLMRMFF1DN5ri5s1EMS6Jovmum
5276	fee_transfer	369	25000000	1	CkpZ8FVPb3K5oVVCjiHuc2Uik1VvuWRL7KpdmnfoehQgwcQ6bgeQx
5277	fee_transfer	470	46000000	1	CkpYYcXhncE1KNxaYGWJ8bAXAMo8jzCfhRizvX3fTGrmHsymabPXB
5278	fee_transfer	1395	15000000	1	CkpZY4EtGc2ZcCXfdxGbD62pbYTkwSCjeaCafcmJR3UpcMbkezMYo
5292	fee_transfer	621	24000000	1	CkpaA16Kffj7LBPeyrccXvQbTrwz17vH13W5jHpHQwfrxsUjnDcoi
5297	fee_transfer	171	37000000	1	CkpYeUvnGffqS7wCYiEAgWZNFZPmy9w7bFEszE3iXVyWdjFpfv3DL
5310	fee_transfer	1696	25000000	1	CkpZhb8p1w9KcjcKxMU7uFxi193zqLqKmeYhZpGBb5h68VeGabhzD
5319	coinbase	599	720000000000	1	CkpYr1Di6NSeqEw3uHyM7uByPYYByoMTbYi8hVBycxSuuqi7dPmDP
5320	fee_transfer	599	12000000	1	CkpYQSMLh4UsfGdN4PryKoTCF87eMhDbfqevkzn3qvM7qFDM66FBs
5325	fee_transfer_via_coinbase	2123	1000000000	1	CkpZgvxQAZZvbguKdK285pUUXgiro2nPQgVaZCniyN6HbShnzdAYe
5326	coinbase	1637	720000000000	1	Ckpa6pqRf4hvZXpcT4fQXFmG796cEiWQfmvLvDMTmC7qjxFqZmuXD
5327	fee_transfer	1560	79000000	1	CkpZub9UkTzKBh6dWsmDPgzr1SuPzFVHsb8AjDwVqUuKLGa8EAJK3
5331	fee_transfer	1555	454000000	1	CkpZ5bpJS4yQZfGKza36NQAVyEGCo8TUPcKLR99KaUrtnqVvWS292
5350	fee_transfer	1688	21999992	1	CkpZd9ap6jC9t1ZPmNyQGpQHSkcUXovpaFNHzcu6bJtehauPVucwH
5352	fee_transfer	2145	1000000	1	CkpaBbFJg1wYbdq3tTCGEfP5qhEe2en5sL9QixoWsr3JofeZ8bHyL
5353	fee_transfer	212	3000000	1	CkpYg2BtXny7FSnNq6ki5VQfQXjuSo9mVxYasZZSTTuJ7acYS1Xdp
5354	fee_transfer	641	13999809	1	CkpZRp14WqDQ12MCAR1qYTukrsn34M513pgQCPhLdiT2qQrLJZNey
5355	fee_transfer	2116	5000000	1	CkpZ7Kx2J5iPnxHJmcj39TB2L9hv1jAKZAgr4cgsmjubETeuSHApV
5356	fee_transfer	2097	7	1	CkpYcZiZ5S3EdLVQCXADmRoTGAweKSJGfey271uUpQRk8PTKU8FzW
5357	fee_transfer	1964	8	1	CkpYy1hj7mbh9hV3iXgKPd9hCfjhArntAvADKAwVpXUVJcSCnoNUL
5081	fee_transfer	1455	36000000	1	CkpZtufHvKvrPEFrhibYeQk9Cx1Y8Qz9ekXXTeiUJE8ZCHK7F8pAR
5083	fee_transfer	1394	48000000	1	CkpaLHMhTviLRGYXz6AUBxLiJJiTBoTbg7Cnc8MwgpFE5mMtPtqGx
5088	fee_transfer	1546	1000000	1	CkpZVjqJqQNZDkZ8cqLoDzqYjkr1zk8EnFwvobxZLqf5dbkHFBrJK
5092	fee_transfer	1749	124000000	1	CkpZ8XhW3XmcaMVZZYfzaYsrvVH3hLvxJjAp2gHFzBz19h8RHduBu
5095	fee_transfer	1419	812000000	1	CkpYkueXbuehRDBrpgrmmS7WL8RxR3YheZUB4FGqoDtR3NWjbMDz9
5103	fee_transfer	1719	23000000	1	CkpYgroDKEzaJB3yonEMGvnqA6UCCS7Hhjq1GTrn8LFmPMyoTqrFM
5106	fee_transfer	1588	55000000	1	CkpZAuBYwE4TQN3kP1eR3EYWYkJRwZ6VaZfqsqtCH5aCT9BmUpV4H
5111	fee_transfer	1727	32004000	1	Ckpa81pNdRRtAcwq3WhGyYQTkYcKCaiK33Q8dXR1ePxDF4LoLbEGe
5112	fee_transfer	1447	3996000	1	CkpZN71WxwPpAYQ7HWjPLscHddQrPVuKBx1VQLYuKFgDJYnUYuxe1
5114	coinbase	498	720000000000	1	Ckpa48uHxXFgkDb3ii3f2eu6XC6fgdmGhRSYwjXSPDd7TuistqeKi
5115	fee_transfer	498	2000000	1	CkpZLTe6h1JVrqvnWnGtnHKLY4wFQcpUkGcoTQBthyo8ZK4fdXP2C
5116	fee_transfer	1559	2000000	1	CkpYiotrAS1oL6z2fhF3aiM6rr1j26pzJ3bwhH3tuyLPaMC8r4h3N
5117	fee_transfer	1718	24000000	1	CkpZ2P15Z7UHww9k7CSPUpK8qoUGSzPbz65zjSWWex1AR8wBYD2mk
5120	fee_transfer	1508	211000000	1	CkpZckFn6X2jcbT1DMhfdyUSx3SpurdGD3hCRf3HG75s26esZi5J5
5123	fee_transfer	1671	380000000	1	CkpZi7XhjgoAVQXru3UDM98ZXoAg5DrHSYMNKgSMi1RC57Z2q2eVX
5124	fee_transfer	1671	625000000	1	CkpZ99DmmAAMrvrniMgX9uTjPsYk934jCTAwkXMnWBGa4vtrGTzuN
5125	fee_transfer	1656	111000000	1	Ckpa3pPtV5gXBSUHUBRsEu2MW7WZwr2qEfnjLXVUBVFy8av8J4czu
5130	fee_transfer	1593	51000000	1	Ckpa4NbQWyPjahLTh1LWqsLCXYJgCSx5BkhK8eZQ8XuCaizJxnEks
5137	fee_transfer	1679	288000000	1	CkpZ1KwajTDaZ3s919HDGAsYjV3Pynjk8DNgaDoWxoMBjvDmyDgqF
5141	fee_transfer	1850	196000000	1	CkpZm8JFGaMRWg3mgGXdyqb3eCaNFvui2ZkHtJSbAp6YEnVzL5Ws9
5142	fee_transfer	1759	90000000	1	CkpZeTKoFagA7tnHTkJZLETaRbN3pVTrH9sJdBA58fQLyPfCfzmS4
5150	fee_transfer	1679	54000000	1	CkpYkj4L7B33vUiZNEXhxJ3wKeuDFBqifMMAKfHAKcNc3KfbjiUq4
5155	fee_transfer	1704	61000000	1	CkpZVGUFd1T4SbRcaaLwWWNoHA6V2XL4ZK4DKPNYGJisu8Qi1nwoG
5157	fee_transfer	1746	53000000	1	CkpZYxoZf5qm2nkwc6AMLccSuoD2rJxveiyfG3p4KWqjhNnq17XjY
5164	fee_transfer	1687	62000000	1	CkpZg57YW2vEnRCYmiEVGYehy8CvyqiLu5WiEDhnZSrxHix1Vzqmq
5168	fee_transfer	1650	24000000	1	CkpaJ7yUvivEvFmj4SpPeckiL6BdtKpvcUvKVuU6g371Sa6mWP7H1
5170	fee_transfer	1850	59000000	1	CkpaAKTtcr5S4cyBq2f1hsSXUCGGyuduWCWbMDH8E2CQAA4ZVHPFv
5172	fee_transfer	1686	26000000	1	CkpYTUNCGm27xM688uoGzTJDxNaGqdNnEkDEw7kfTKxwK1932E8UX
5176	fee_transfer	1672	43000000	1	CkpZoLPQDDfJGy6nXvWk67oXauoHVLxZPuDug56bDdJQ1RqLYNRmQ
5177	fee_transfer	1672	5000000	1	CkpZmejhkTY9vPuKjiqm7sKcM4u5XYampodvkRfyx4UKytTQWErjo
5182	fee_transfer	1541	23000000	1	CkpaK9617K814UsJ8H7cPAYKhtyLnqshvCnNsNQNVDSFunuDMyh9Q
5184	fee_transfer	1871	12000000	1	CkpZMozcU6PqGT84L6D7CHsfNtD1sHy5mcQG86o4JSae4VZjcjZLk
5187	fee_transfer	338	154000000	1	CkpZiX1VVLE9Vndq3s2QSG9uChxyPvTnHTvsiPNEUkBHYxF3qi4rm
5195	fee_transfer	1439	29000000	1	CkpZHkaXu9nTBSzZMpkLTkCRYRx9tnXNHksbr81gmAnrgvxLRETqo
5198	fee_transfer	1673	120000000	1	CkpZ31JXQEv3YpjTBq4tt6RMH4Fucg7xrV9i7oM93gKpY6FF6zJoc
5205	fee_transfer	1611	24000000	1	CkpYrrXLqfRDA93wasbToxxG7FzPM4TFq6AW74dW5ufgN5d5UKSKV
5211	fee_transfer	1457	52000000	1	CkpZWfoBWCoSzuGKhe7eZ5qqp8Mq1m7T5253C1gpMMFZ3GqN3EC7V
5215	fee_transfer	1474	22000000	1	CkpYRzFzWkt3BNveGmjp92iG2YgdXz51ijwaZththqWDM7iNR8jHm
5217	fee_transfer	1727	55000000	1	CkpaCPsS1hTdD2deMqLqv2ELdF6fxJgNB3PyAZXW5yfrJB2pBD2z3
5225	fee_transfer	1759	999890	1	CkpZhfbzACur8XCAabQ2PuhwEbJvXQXp2St7dGH5MjKqihLLnTr4q
5231	fee_transfer	1535	25000000	1	CkpZAGvnPb5xNowxNM3JjTJMh3q11EG77Yx4gSFNki7ASnRNqWuws
5245	fee_transfer	1649	48000000	1	CkpZcPgJ2ZbouUnxHM9qc8NrCdRRjHTrZnzN1sMHUHKCDrtVGgJN8
5251	fee_transfer	149	37000000	1	CkpZvVo8Emh3FRXMXuX8tb9X22QpprfDDoEbs642E8CFCpTcQrFoH
5255	fee_transfer	1593	25000000	1	CkpZBbjPDR2FbTDx7vJEuEPtJHDB2viaio1Qqe2GR4V1iDpmvzAin
5256	fee_transfer	470	14000000	1	CkpaG75ZHbVzUSvQD9xDAWyDHdg4D8qHPHtUNJB4wpzUUcaE7StwX
5262	fee_transfer	1694	22000000	1	CkpYoKPuE2G4xMTVd9rmGPomUCMMR7b7oUni2eTHLgNcfBx5hUjsE
5264	fee_transfer	1704	190000000	1	CkpYbD4XZobnsEtmiZfLW2eLqm6JDxwyyCbv5KAedUEHy1ZtsFEeg
5265	fee_transfer	1704	1060000000	1	CkpZVCBq7P6GE67foLVomY55Zyi4gVAHyPkZzW5UifwUQkE4magyC
5272	fee_transfer	171	15000000	1	CkpYma36DE3xGWdDjaTsSz9pYjYPVnc8BVgCedfDje4eefEB1XiPv
5273	fee_transfer	1740	563000000	1	CkpZZwyqRinkq1MYutrg5kF8PsPcxPaLw3ZDP1k7GLdBPLZRd348C
5274	fee_transfer	1740	21000000	1	CkpYguct4dz2x4KexabjaznM5LZWGe7VtNtXppMsm9JixfxYHyNDM
5280	fee_transfer	1623	15000000	1	CkpZ3Yqbx1SqGmZiZip1eGuuJvWjgD8dp5kyNbCBAvo986KAsvAis
5281	fee_transfer_via_coinbase	1460	155000000	1	CkpYopP4VcXACjL2ikVJS5UDzFy6F8jsWvnjmUPmoXfyg3BMVwto4
5282	coinbase	1513	720000000000	1	CkpZZyrD7mURNTzKXmMszeDejrLms92Xztcjp19Hpi97WgFLMKd3d
5283	fee_transfer	1693	12999999	1	CkpYxj8CFGUutgymd17SFtRvGRhtBaQuuoKYSrpMcYg5ZWnbstysM
5285	fee_transfer	1672	25000000	1	CkpZaZjSX3aVTgUvzLnHyQeprrR2684EWpkw8xhcprWaDioqYzhRV
5287	fee_transfer	1687	620000000	1	CkpZBAKnNtgFoZwxnsh5us388fPGiNwN4kvAAo9XRURmswuuh8ZSy
5288	fee_transfer	1687	207000000	1	CkpZ3gzJ8cTctfy2eWpzt94ZE7PNVXXmjkSfAH6ossopvKzEoVTfc
5298	fee_transfer	1602	17000000	1	CkpZQLW9HdMWJnGc5CfWCFhWBCaSqQZQtQLJgZPtCNaBwM2Eyy9Hq
5309	fee_transfer	1675	37000000	1	CkpZYj2gB5HeRAoDwS3tspwhz9csMLywWZmwc8VE6KnFCRooAyAxH
5315	fee_transfer	1462	21000000	1	Ckpa7XwyQJc5yEztALnKuR9fE9gtK9JbeV1xQ28hgTKxMVVuhFh1p
5318	fee_transfer	1685	33000000	1	CkpYXCZLrvMtWrSpycnHyYwyoDv2oeySh752jiWtTc1TyTcawPrWS
5321	fee_transfer	686	34000000	1	CkpZPpd7VuckRDSum6hSivtJSQDqf7JiYdEjHvSX3Jm7Rt8Foknon
5322	fee_transfer	1547	34000000	1	CkpZ6JSLxNeueRsUNdxvp5ikVJ3EAXdJzu3dafErZ6E35xsgk2cnJ
5329	fee_transfer	1690	56000000	1	CkpZ81F6G5dmdUDuG8C8KduH3fwyy5RXLCLDATC4H7zMh2pdxRxqC
5333	fee_transfer	1709	220000000	1	CkpZfwCp7ttdj9czGgcWW3VvwDwT4XW45wzVwGf9hBV4yiyYtucw1
5334	fee_transfer	1709	71000000	1	CkpYR33sKARbgjVhDrrMupTMJwdN2Yu2szoA4uSg2DfqyMg5xKciZ
5335	fee_transfer	1564	23000000	1	CkpaL6vjBZSWCzCbR69CgVHZW9udBf54vTotfRJveT4ZMfFn7RyfJ
5342	fee_transfer	1599	51000000	1	CkpZcAxZAePHCWDiDuU1czqY4crzkoyU4PVF2hzzYQfJbaewt8zn5
5361	fee_transfer	1625	11000000	1	CkpZ1AKp14EonQo2WPySyKMf4pV2q4hMrtufHZiQV3Bh4Z5U5kZ4a
5082	fee_transfer	1684	36000000	1	CkpZPHEDZtVRuyPhiM3uQo89M3jsDAkJ17MRgVTpqGCUGNHn31UK6
5084	fee_transfer	632	24000000	1	CkpZpVmqDfqsecp5A88X1ZXZkKgut6uZZFZfGTpK7GqHQcVPhQH36
5086	fee_transfer	1696	24000000	1	CkpYaCCThSNtJip6YfdLCSadgNZBbFTQ1XxzWCEs7LpFWDqNHbi78
5090	fee_transfer	1596	124000000	1	Ckpa1QaechphpEfPZXxwdARpQMYhzNCGrwprhcNoG2bsYGexnj1Wr
5097	fee_transfer	1715	612000000	1	CkpZwcsnxrSKrhubSBfUNtTxgyw8WJJ6mCQ87jag6b2K2BdzGebPS
5101	fee_transfer	1439	111000000	1	CkpZwqK4j6d7op8LonZdFXMW7B5QaewSedLv9T38f6bgYJPYRH9vp
5104	fee_transfer	1587	34000000	1	CkpZxRSrYTi3ECsYMQWyZK2ZVqASfnqG4RGPe9FUEtgYp95HNCw4p
5105	fee_transfer	1588	680000000	1	CkpZF9NVzyaquaNniPUJJ6k2sXbgpxuZDryEcfvcHGWhhAV2UAGKW
5113	fee_transfer	1471	23000000	1	CkpYyL91pCgYL7TDVC9qjqokddwErz2GbBS2NekT859hsQXK5eDqX
5118	fee_transfer	1541	24000000	1	Ckpa7HZCHPV28MeYfdZJ4Qs1eybz4Urn167nCecrwe2FHfue7TuvC
5131	fee_transfer	1546	61000000	1	CkpYet97Jn8iQnVmKDSTvjwwBptx6U1rXL991XgxALwCrzVr7yohW
5134	coinbase	1494	720000000000	1	CkpZxhYN69CerwL5CzbEdpx8ZA6Eaf4iihj1BvDDRu6Jaq3peY92d
5135	fee_transfer	1494	154000000	1	CkpZ6TKznpZ7iBnja3hP3Uqe4wWUs1DeShtgxPhfPNykXEhkdfBsE
5144	fee_transfer	1759	530000000	1	CkpYiz2GbcZnZUTJXKMeDuQRiA4iJvt3drqDLnYKyLwNvQZFjDLH3
5145	fee_transfer	1759	900000000	1	CkpYwcQmuEbBWNom8LzLfXujVRxUjArfLkVToBnQv5GHS5AncQxJP
5147	fee_transfer	1471	204000000	1	CkpZiBYQQksa8KyfhpAX7zkjqATRwJXMaUJP4r3p4L8q7RyjrcRtR
5151	fee_transfer	1678	62000000	1	CkpZ5Au9WY6y2tX9D7RYSSQme4XE9X2NxaWuxd3p2FF3sdAx9whkC
5159	fee_transfer	1747	53000000	1	CkpYWuNqyNoCjwkmX5zRpg6RjimvvdJjxeWBBK5Du2tjtpNf7fw3T
5161	fee_transfer	1687	53000000	1	CkpZcNDk6b7pA8i95HLkvSsjuS5ZQB2nHeAGa1WFu6x2UNZnwZ4xh
5165	fee_transfer	1395	62000000	1	CkpZcfPpUwocyfpkT9tgjcJ8FUeqgwTY7156sPdfRqgCoaNwuY1Kg
5166	fee_transfer	1692	4900000	1	CkpZL7s584hH21E9PFfDk3z4ocTE3LCxDry91ChRo3yY8Ywm4aR82
5167	fee_transfer	167	100000	1	CkpZym2xgwptN8CHJ6eGKuLaEqxZw27ieLmGjAdVFpfk6agVQQWsf
5185	coinbase	338	720000000000	1	CkpaJzRGufBaEU7yiSs6AymxbRHAhe9USBNyP5jeCC4C5K6X5Yd7X
5186	fee_transfer	338	24000000	1	CkpYuae77X6fPQYu1RffrqMPzhYBWBq22Dj1dTcxorpCmmTMnu4hM
5188	fee_transfer	2148	36000000	1	CkpZBHmb3RjsTAjjETquUxrXq9Dbf2yrJsetxvgxj6hSgDFBBnft5
5196	fee_transfer	1695	270000000	1	CkpZWsiW7kiEJMdQQm4JuvBd4FE1qjM2ZLGtsaZQLAfM6ZiHaEFSq
5197	fee_transfer	1695	30000000	1	CkpaBNFBY2esX2zdyZ6QCaFz1goMTTH1wwiLAV1CigxYakK3zCf7w
5202	fee_transfer	1394	41000000	1	CkpZwchxtkovX2CECKULzJ2AqeP2AA4Y62UWZGcP98b32TSzWQRre
5204	fee_transfer	1654	24000000	1	CkpZaY81yvfWjjAda9WpFKWd51tnXmWtiE7vaUcUqYyRZbqTpFg5V
5212	fee_transfer	1549	52000000	1	CkpYZdj2S2CfzcqXHHQhdHUSzX62sCRmhWPyMN3kB3ZWKEZbnb95K
5220	fee_transfer	641	72000000	1	CkpYts936TyY4ApvHJQGqZoeLc8SjhLkjbfEMkJU2Xtg5o9YotRQf
5221	fee_transfer	1571	71000000	1	CkpYUbYDvGY8sNePJtjkPiLqUXy7vM7SvtgaWT9ouKRJqPTLcqZqz
5223	fee_transfer	1705	88000000	1	CkpaB78BEW5zv36EfKuTjW7vPtZNeooLwuFNx94USrGjVw1ULFYJ9
5230	fee_transfer	1271	34000000	1	CkpYRix5rnUtXpY1GKrEethaq33g4oJ7XQmGzkugTeuuS7zA2DqBu
5233	fee_transfer	1850	34000000	1	CkpZKFSVVGUMiwFUiLEvZ2izBZeeG1Lzi3WHoPk4VAsG2rE5tiN6F
5241	fee_transfer	1724	24000000	1	CkpZ5mqrYWubv6YBePL31NTmnTmy1Zungxo3rhxSQBReVjyhfcTu6
5259	fee_transfer	1476	3000000	1	CkpYxYPxuUhtXiXN728WzQodADadWRSrJxXuKjhfwpFL3R9nnohQK
5261	fee_transfer	1850	25000000	1	CkpaHdGiL8scHx8McnTweZyvFwnK9YYGw3nwPsncwu5S5ehYJqjRf
5284	fee_transfer	1671	25000000	1	CkpYiYydDmU9J7Smtr8Y8yxvr17trC1Hntz7PiMCCaUkDKsRBMLfN
5291	fee_transfer	1756	113000000	1	CkpaDiqJPRMwobvR8AkVgzmVZ5Q8tvNnj96rXH2YZG13HJFWjXfVM
5296	fee_transfer	1679	37000000	1	CkpYtCzTP37uxkBEGv1fsam57BQDEPwhsTJMeWVNtZD5bXRuEUfTC
5300	fee_transfer	248	10000	1	CkpZQSnknL1DS7RxeqtMBTyp1Mv4AzjZP5bgJtBazqusio7bANv3E
5301	fee_transfer	1602	16990000	1	CkpaBEGTR2iomwsMyy2PxdmRstq3FDFH1r7f5bfRkY4Q8ooJGkozn
5302	fee_transfer	1692	35000000	1	CkpYiG1NhvGZ9YKCZUX8vfc1PiYKnM8LAxQGFaAJFiyWYzZ76dTdK
5303	fee_transfer	1623	35000000	1	Ckpa3wVqQTnuY4iLLqDW7LP3SzUd5HxFzReVNATeWxjJRqa1rBiNQ
5308	fee_transfer	1657	23500000	1	CkpZK5hGvVFPtfycnX4im6BrkGDtSnE1VW3mJvo2xo2BT6aiacDmQ
5311	fee_transfer	1715	24000000	1	CkpZ4feqeMxptegNcF8zJDffaPJAz7wU5tgEGZU1V79aZx5FQH2he
5312	fee_transfer	1740	105000000	1	CkpaBJNb2QjNBw8Ywpsf9a3tYYTUFjietDGpr9u4noZwdHc7cYc4a
5314	fee_transfer	1991	21000000	1	CkpZMmHYDYcKHvLh8GrkzSiTjDJQ3M7HywGqsgZCoQoFCZM22RhZK
5317	fee_transfer	1654	33000000	1	CkpZoRzjLgvw9rtDLxMXGP6z4NGTdNYYWFZadt5pgQ6mRRDcncodn
5328	fee_transfer	1474	179000000	1	CkpaBaw3CvYbv3dwgoCiX7pgsGwpHfWM6CjBv1DNhJEnve3uphjrU
5330	fee_transfer	1402	56000000	1	CkpZ2kqkFig2fcRLg5noFfY8zY1SQqeK37mYsGUN9jnkJ4Zf27LSc
5337	fee_transfer	1419	558000000	1	CkpZdpV3TPtsa5cgcP4wg5j1xg8Gnmi7oDqRtjSHTQVGE5B4CjJ2d
5338	fee_transfer	1419	62000000	1	CkpYrRLna9giH6JgTvrrmPqkNrHMTBzovuftDB34cPFwc6SKAXBSw
5343	fee_transfer	1650	13000000	1	CkpYWre4STkM2e2m8VoTHQ44Mwib69Nb5iaMmv3YoxaKprnv8aZGq
5346	fee_transfer	2148	22999923	1	CkpYiQR5qofDF64xgm6VGDjd6XaJGEK73tnZ3GeeC5iM5oct2pYbG
5347	fee_transfer	1964	4	1	CkpZ2kRCiXE4M2Ni7u6LSCEUuLE7DxmebjZUuZ7ASu5rwLcuRjPMh
5348	fee_transfer	1571	72	1	CkpaEThrRD43gfHsKWGKAkdkYSCKU8EtDCxvpwvzJD2qGUZw8UsUp
5351	fee_transfer	1933	23000000	1	CkpaE3HkCZ6okiDw4tCmHwyPXaBWtsTeYPfK9c1ETzkZsu1Wxhmq2
5364	fee_transfer	606	18000000	1	CkpZr3Y6io6bC5UxouqXEM8HfN1GSJwVy9WrKJM4xkGur7kaBrGvG
5375	fee_transfer	1705	34000000	1	CkpZiwRcZLvW35wPpcsJC1Ht1XXBwZYRqXtEmk3ZzaqZBLuopmTAB
5379	fee_transfer	1599	135000000	1	CkpZGuLbXTLBrFTzr5BTu7ikkfkibp1jaMNLFDQnxN5ZBS8birJai
5382	fee_transfer	1710	43000000	1	CkpZEJsfdEZ3QLdHERpp5JX4QcwNjUpCe28hRzRwaafMmjaBYPuoK
5394	fee_transfer	1596	31000000	1	CkpZwJttuzCkZkAjYmiLuEQyuSbk2kuHdYssmQaq88Q7Lb4BpEohA
5396	fee_transfer	1746	34000000	1	CkpZWcctBzzuuqgYCREiycy3M9d8NaG1a363sUJfpgooxL7fognGc
5419	coinbase	1548	720000000000	1	CkpaEstbZZCNyGEiNdN7fgV4WDoB4wca4fnUiC6XKUaBzoTJeoBPb
5420	fee_transfer	1548	12000000	1	CkpYgaEGnD2aE4VMaUKVM7XMQ6WsTWReYcAnHKgo3sBxN7Yr6KAyi
5422	fee_transfer	1649	47000000	1	CkpZUgakNzRu4LQ3seZwemgp5Fz4CYdAuTuaH2312KPuLCdyMpGq8
5423	fee_transfer	1649	26000000	1	CkpZa3Ru2hCm2JVouTZHVKShTa9LAm4gyqTBy1zTVPS9k81WHVHaV
5429	fee_transfer	1633	45990000	1	CkpaKS4ygtvc46KXZHUDSUgj7UPNSsra1wAg2gqxK2xpFueKxGx1E
5085	fee_transfer	1696	63000000	1	CkpZkujUrAmfasNHn4d4GTWW9QZJ8ST9o1TqwNwrFeytkXZjv7u3j
5091	fee_transfer	1634	124000000	1	CkpZjdaM5hubbzPGvzc4JNiN6rDkh7fJafMHajdDwg5jHQidy7HRr
5099	fee_transfer	1672	27000000	1	CkpYpzCnSQvcS5XrVk7DHQTiwts7dS3h9i9ZHBHnFkNgB983YCNSV
5102	fee_transfer	1706	23000000	1	CkpZ2SB4jNAmjzxEBkfptfJMrupWdmN3EywCuvgTy2Tjo3mnk5bxx
5108	fee_transfer	1678	31000000	1	CkpYq59w39quZy2KHLkJftDezoLqka75G9EJjVsmdvRypZUJET8gp
5109	fee_transfer	1678	5000000	1	CkpYbmJFioesWXUCGEgeHouxE7d3tqJVt94aa8Yj8FdPkL1Yt6Xie
5110	fee_transfer	1727	36000000	1	CkpZ8ipqL6KsnbJcDSdojJjUAMFv9mtCSoKrMjaVB6e3ocGGCnUK4
5119	fee_transfer	1689	211000000	1	CkpYTapDaQsoTcrfnFBftXUmXRDFfTMTXqDZsCVY8fvcPQzi4bBzd
5128	fee_transfer	1980	640000000	1	CkpZe1vLBdtVaSYVnqAD2oNg2MHbKYdDqu1PLLWEa2opE8gYhaRKn
5129	fee_transfer	1980	790000000	1	CkpZ878QWWLZcmxAYYyvVZ7oExL9D2M9VGBwpPXH9LeYMbEp4Yq9H
5132	fee_transfer	2039	61000000	1	CkpaAwDNvNK2cwbAxmD1CPis7ZfFXHVcjxiad1GdXpK8ff6MJyCHN
5136	fee_transfer	1711	288000000	1	CkpYyZ4drjiUodWYbJ7cVeN9WbWgbDQfvBnixdZqWjcsdpQRumUUY
5138	fee_transfer	1711	134000000	1	CkpaCr7n3ogu2YuqXTVTsSCtYP1KyV6gzsR3187bcf4JYRVXbzaJ6
5140	fee_transfer	1850	186000000	1	CkpZVeCoeTNhTxCWwMfQas9CrywVTkXiv5ZEkzUVvEDc4U7DP9V54
5152	fee_transfer	1608	62000000	1	CkpaDyZ9PrWPLHxuLoE3LTkqUBhNashUF32BaBNDZTUFfCfV7YSCv
5154	fee_transfer	1746	62000000	1	CkpZf8iAtKeZZbQuNj23Aw5ZWSs5fiCo7k6jRR34zaovRhhPNktf4
5160	fee_transfer	1394	53000000	1	Ckpa6DcYnpPtKPnWgzvaEqFcAsevJaiCTUyUbm5KRKBFjRoD8XRD6
5163	fee_transfer	1688	62000000	1	CkpZwzpi8uwgnawz1D3X8M3W451gUNbJZ99xQ3aGFXHMTer2bQZhK
5169	fee_transfer	1850	36000000	1	Ckpa3CauVh9vLcTn1ACQ3aGdp4xDnazwmfZsfPkKwvqBwVvwXJX42
5174	fee_transfer	1423	14000000	1	CkpZ3m96a5e1TBbF8LGmBGvEDQwAgZvWzJndWDo8T3Pq7MG6rRuti
5178	fee_transfer_via_coinbase	1660	597000000000	1	CkpYx1Yz9ApGkrWzvRxMCNCfaRzeQxNJBTFNLvMw9iZhsQKhNxRFe
5179	coinbase	1933	720000000000	1	CkpZvHTVYMvhTooLJ2fANdg1BgH4qmiuKvwtGwzxwzNKwaknv2u9k
5180	fee_transfer	1571	3000000	1	CkpYu1Eo7Qm7doFt9bzmWSpadFYqrH5AQ6bTYd8QaxLJDjVujank6
5189	fee_transfer	1702	36000000	1	CkpZn2kynxUhKCVFGqDL3fxvrnS6psaW9CkYJaXKHAMGbhJ6Rv3JM
5190	fee_transfer	1703	36000000	1	CkpZn7wU7TzuXWoSRggDfA7U2PH87fB2kFnJEivYynidG7q3To9Tw
5191	fee_transfer	1650	22000000	1	CkpZ7KhBNPgynr9y5CuA53sbEhdbwZsXGuES18XAxh55JDbUpiZMv
5201	fee_transfer	1719	36000000	1	CkpaCo7xJdDj5FfrKrgcGML7X3PEEpsBhJsiwb9Xrb3327Lhj812P
5203	fee_transfer	1710	46000000	1	CkpZJ2DxGjDxceRHJX736qYCsVp2XMAZhGAjy4ysh4KhvhaNRwvHB
5206	fee_transfer	369	680000000	1	CkpYokyuau7bZbnKFrMXqyKDcBhRzsXTGR8C5oFYp9q9JprHBXoFt
5207	fee_transfer	369	750000000	1	CkpZcuAuhbWeUpMvP3bpxi4bQFNHzamYaZ8JmsZeaz5r46EQVcMpM
5208	fee_transfer	1613	200000000	1	CkpZTabsKYc1wfzAJpB8U2kLVd5QQFbGrZsLAfv3f4TFpGUPrQsjv
5209	fee_transfer	1613	1050000000	1	Ckpa4vBrbvFZfzw8gg7eYPhGxAgpjWkDjB43G77FHR22udyqxQrQ7
5213	fee_transfer	369	500000000	1	CkpZDCRSPRxFgFLFnkKSn3uXtnSomw6Uh7VGE4Ak1upzCDMFEDPhS
5214	fee_transfer	1756	51000000	1	CkpYfovTguonfZVryVPqH2VK2QgxMTUYpCQuurRD3aRU1dx57mbXA
5219	fee_transfer	1709	51000000	1	CkpYstyaoLue86FK8CSu7fdvrLdjjDS3SnSVLotigJEMMpHjbkezH
5224	fee_transfer	1759	10999980	1	CkpYvuZpkWyzvkrFQvfWEALuW5FH7nQx3aJ1u85zya2xPXcQEWiic
5226	fee_transfer	1633	5999900	1	CkpZzzfCqztohK466ho8ytLUzKXRcY2fuZkU9Q1NDmJiA4MkCybz2
5227	fee_transfer	349	5000000	1	CkpZZuxH6WBeo4sQ7vcDCBWJhCvbPNMcCyeoMXNsJ3bmf7rhL8kSC
5234	fee_transfer	484	34000000	1	CkpYyRcJQDDqgSzPz8Ba8fmag2tx8v7fnqVWHbXeb75YJ9kPCFiBP
5236	fee_transfer_via_coinbase	1633	10000000	1	CkpZ7o6NyPWyBxE7x4QSYjt77iUw2MAKm4QXR9VxGEfp8iVvz4N9Q
5237	coinbase	1764	720000000000	1	CkpYQrmfk5cWGcjP3LcCSP4cffBxAYBH6g1xcqAS3wAknd1D4erjC
5242	fee_transfer	1673	90000000	1	CkpZJo3meKi8bw6wPG3jQFH4wMJVBZNjMGBdWiCskHm5zYDD2ss8U
5243	fee_transfer	75	50000	1	CkpZW1Bgvwz1wDXosu5jdUPsewFDRquhsJVjQnQFuC72PyRWFonZS
5244	fee_transfer	1673	599950000	1	CkpYtL9pnCusGAJ43VrxSxuXkg5hkiQ3L2Nz6xvBJ58R2Q5ssWgJp
5248	fee_transfer	633	25000000	1	CkpYaoFVswdYGuNwU4sFVHvXCgZnXsP4d9jiVbsKuXspmks5ZBKgt
5250	fee_transfer	1692	51000000	1	CkpZeFc82uEPFyudqKtArFu4rAYg2vi9AGd49RKN7jpb3N7vjZgWV
5258	fee_transfer	2148	2000000	1	CkpZ73tm1Gw4LdSvrHDeQKfGE9DVkBPxAL8kikhc7T2aSfcrx4pPW
5260	fee_transfer	1708	3000000	1	CkpYbr3y3mopBZ2X9pzd8bphshN11muxJegBZFdQeftC4Fobdmu1i
5263	fee_transfer	1694	24000000	1	CkpZyVqyJB7pLRQABdBFotEXNTMrGMY6y1cn9A14DHhqWFpR83Wqz
5266	fee_transfer	2055	12000000	1	Ckpa7F12NmeVM2d6mjpGNUY4mw62Nkup1jsmzzFu3Mn4TkhDDLGiW
5267	fee_transfer	1573	13000000	1	CkpYrTQhT3UENnG6GibFdYgNdsQvZRBPazZqEZntR5mxorZ4otN4s
5268	fee_transfer_via_coinbase	2171	1000000024	1	CkpZDQXQjzXi4yScGgm67bbDUDUxR567GhFud3EKoefUTPhVGmSCX
5269	coinbase	1571	720000000000	1	CkpZoKgeuLomyGPUTx4tvohGLHSGZWVSSBs8gCsDose4pUYN938pi
5270	fee_transfer	1715	37000000	1	CkpYajo8GatbbYyLU9Y6qHM9SrkcUG1A6LsPxJDyxDwPXJeu8KXqi
5271	fee_transfer	1670	15000000	1	CkpZtn71EFoKUGTX4Jn9CrZLvitvoXndHkForZovEJQ59UtfxwRz3
5275	fee_transfer	1668	71000000	1	CkpYXEJHgBenASrWDteLTGdS9wEQtBqk2nV5T5oeMSkb3YLe4TNCA
5279	fee_transfer	2039	15000000	1	CkpZJjGcMWU8GWDtkRKdU3t9N65vTqUVC4vfcs61zxpR3mXL3zqVo
5286	fee_transfer	1559	25000000	1	CkpYibPHzYAHx3RhmPzEYQXXzQyBPjYuyc2tnxDigXFbQTcV5hfFy
5289	coinbase	2176	720000000000	1	CkpZxwNvSeqPD1fcKWy8JmAvGEz7EmFHMNtEJ67eHUdKfag1Pe2So
5290	fee_transfer	2176	12000000	1	CkpZshpUJALqLUi1QnxwMYou9FyuizJuZwz9cM1538iTpY7m28QxH
5293	fee_transfer	621	148000000	1	CkpYZpmkLYeXKktTNud1nL2EKZ7k3xn8KJeXjx38oEcL5ZPRt1qx1
5294	fee_transfer	529	25000000	1	CkpZptUrWY4Mk4KonF3KKtn3vJT8n8xuSksipMbLCWZpFiaQcHCXE
5295	fee_transfer	1991	37000000	1	Ckpa4CugNW5GWHt82dkbfjBRqeJaiagcrm3HqQHZHW5Lqu72G4oCg
5299	fee_transfer	1698	17000000	1	CkpYcSveFmhYasVX7ReBDMkZAv2WwZ3TsgweXLgo1c1crLiw1oczV
5304	fee_transfer	1394	57000000	1	CkpZmbzmX3qq7PWX8KSrc8uxgV7L6PvdgJQKKpXmSSsy7wgRGSUUR
5305	fee_transfer	1444	200000000	1	CkpYqCbKAyaSzoJ1wagGE2Yy3gjoZfTFZU83d7VpL4paEr9QFBaiK
5306	fee_transfer	1444	221000000	1	CkpZhHQLmQTpXTc8bBNe5LKPiH1UCaqxT3Jm6ydrw5LqGu9VrT3jB
5307	fee_transfer	1657	23990100	1	CkpZ9nLLW8SLsYTWy7qTSEMfnwwBKcdfwp5qJs3Vg1gRiWWavWTG6
5313	fee_transfer	1739	118000000	1	CkpZ8kt9cfhsDtbycSdYSh46LHgGCQ1AnZPJtoa5orLQ16akNCa39
5316	fee_transfer	1271	33000000	1	CkpYuMEh7G1GNSjUJFYq6Bb9HtVHWxMNjt28VCrLQsAhcSAaKr3tK
5323	fee_transfer	1694	34000000	1	CkpZm4eVr1dPhVs4VBX9cQPTVs1eWsCQyBWoBXhQTgwo1aj2wxXMH
5324	fee_transfer	1687	414000000	1	CkpZK5GtgoZWirdD3gMNZJa36zaWFVjAK4xHvuJcQnYoVHEEYx6sM
5332	fee_transfer	43	34000000	1	CkpaGXQ3TQfFThbQjV4Cr9pvb2WZDBaQZT5d8maEAmoqGT7JEbALj
5336	fee_transfer	1675	67000000	1	CkpZGMRrXUWAzRhD9thRAhiV6mUJgvKFVTJ1ceMYdoHyvsKfTvsSW
5339	fee_transfer	1419	67000000	1	CkpYUKZMJ62U841wvCWN4seU7SXPuqrVtQerifmd1wqDKL7WCmUDh
5340	fee_transfer	641	149000000	1	CkpYt288UNJqDbKucAGSApg9DDWzRUwoVZjbBiGPKX3Paw5StUfnd
5341	fee_transfer	1571	24000000	1	CkpZ57WfQnfEBcMEWnGS9K6bp6XWwnC8WABfYXAgr5G6jrrhmXDkZ
5344	fee_transfer_via_coinbase	2102	100000000	1	CkpYjvg9CJQWC96EDrpkhuoeEURELBoHQmFKG1qANKgHhF3741KQj
5345	coinbase	1756	720000000000	1	CkpZxXJa4UdwtEJczNwuXd67JEFpvfkoHHPFpFDM8EzfdtvKdoqzi
5349	fee_transfer	2148	23000000	1	CkpYn5LSaakFwc1R6doQLqu4paQQosk6XBstnF5iWMMqjLTPWdivs
5366	fee_transfer	1719	55000000	1	CkpaD7k9VkpeceHL413U38oWx4xBrqKJGQ415pnsUkFnw8YPnoVnH
5367	fee_transfer	1740	55000000	1	CkpYt55nueMGYJXHzVruUWnaiFNR8gdgaNeWTSo2CmxT126kkZ9WW
5383	fee_transfer	599	11000000	1	CkpZ6wVzDx8dDoyqUiWtkXsA474ytVk3huV1cfc4yERPrj7FGEurp
5397	fee_transfer	1447	16000000	1	CkpZZSWAbto2GxZ7hKNDZn7az1fcwXDJ7VhgsnZM3CE2QMzJbS2Yf
5401	fee_transfer	1555	1150000000	1	CkpYZMFnfCBWEasi32LGzYyXVsH7pYEPS7s2Rni7JYmsFmagfFdXV
5402	fee_transfer	1447	2997000	1	CkpZ7c1QcPxH8AWhp8dExmDnR3WVw7bmyHc5k2BVFqopYewHanyni
5403	fee_transfer	1555	806003001	1	Ckpa2XSgQsFXjUaf6AQ7Noo5aLcDnX6UVGqHdrbDA62kuq6FjdrGk
5411	fee_transfer	415	11000000	1	CkpZ5oXDC3fEnpcVyM6vumQSvrKQ7PDfKq8eTtKJNyMmb8gAUvfu7
5412	fee_transfer	606	37000000	1	CkpZo6ae9JD39snTofFCXJhYQZnpT3msffAms4Nw31nKPTYaJ6wfM
5421	fee_transfer	1719	514000000	1	CkpZXsdSq9HBdbVRtiwtHSp22e6eeJ3CyRxsxb92KkqDGAB9z48Mi
5424	fee_transfer	1699	26000000	1	CkpYeaozAyWVqeBzaTke3onmDA1TB8dP1ZZfq8ph6KF9XKLfkQ9VZ
5431	fee_transfer	1695	17000000	1	CkpYztuURY8bod8guKozMWonJAWPHg1UtHmqDgoaHsbDT1ocVzDcw
5441	fee_transfer	1395	61000000	1	CkpYxhtcmmnUNUxa4CMLHTPS7XebnxyZkHU73s6RJ8ydXCAbWiC4P
5450	fee_transfer	1536	112000000	1	CkpYwFsnXLccAfj3kNYSSGEqqRD9bHkf1Zh2yFvgHtdSuFGkANdrv
5451	fee_transfer	1440	112000000	1	CkpYfZDEhjkqBVNiFaapAJXzDr9K8wZ7sMvxkPJL5wLv11fGusrVi
5459	fee_transfer	1679	115000000	1	CkpZZpGmDPRgC7Gn6QPRRyCzaVbZ8bfCmyZrwJyC86scbPy9shnCv
5462	fee_transfer	1402	23000000	1	CkpZieUSCdxZaCZJb3JeFC5TvfjwQpNTVogDMKn5PAG3hjjuTwNrq
5470	fee_transfer	1593	89000000	1	CkpZm3NWqS18Q2YJNiC9pFS6kJL8dt6cEaMTK9Qw4dqBVx3MCm68S
5473	fee_transfer	1546	23000000	1	CkpZM3rUfx1ExrNQjypXYT5YX2bA8DqaHSMKsHhUzbZRWaWGFBNUg
5474	fee_transfer	1549	35000000	1	CkpYkcWmKgnkKqiAZ52sz29pXjB3C5EzfjumqM3H4kYzPTFihFFZu
5477	fee_transfer	1596	223000000	1	CkpZ2kskC4ZWrm1vnY5FyHctVRTj7g9PMGb2q4eyTs4mRJfh16y41
5481	fee_transfer	1692	439000000	1	CkpZv4GngEFDUuqjU1ZnmrHg1UAmNwtfyYEbYVPKyBba6V6NwjDq1
5484	fee_transfer	1547	21000000	1	CkpZx2h9fBG918M76nx59iXMaTdPiJ5jvDSqiETA8eLMHWDf9NAQp
5486	fee_transfer	606	56000000	1	CkpZMxD8jmZ5KuZ34c1avGJsSLkpnc7ywEsnWsDm1D4DPfBZ7ysvB
5493	fee_transfer	1610	34000000	1	CkpaCRSSjvcgXhocrhRbFvUTsKTNkHgFoUyGDcRwDdarsdE4WNPo1
5505	fee_transfer	369	23000000	1	CkpZ6qPU8iYYpyTEWWasCoQdgU9vk4UUqjeo5GTSroT7L9QN99jhJ
5506	fee_transfer	1688	111000000	1	CkpYabsVYa9fQfr1Kay5ftQNTEripTr53oTeCMf5ZumTRaJqcgdaU
5508	fee_transfer	1687	5000000	1	CkpYnafT9DTUV81sXo3NuEHi4HEfCJWC8MMxYhtxvRoi9J5JakYjd
5509	fee_transfer	69	11000000	1	CkpZtRc7Ne929PTt2djZv6tuEwXdX8qJTh1zsgr73WjNa4RG8wnuj
5510	fee_transfer	1759	3000000	1	Ckpa77gnVJMwGvyG8nXCtbmf5iu5VUhS9ii868gAAibuqoJjuoZZv
5512	fee_transfer	1637	73000000	1	Ckpa5gUmTnJWnZGfcPa7H8GctHecpN3oysvpJyCawzBbfxkx6Aa47
5514	fee_transfer	526	12000000	1	CkpZMZuWZDkSXX3YDumBFS7aaHQsA3yL1aKpAXFWpFEoNCacTQDHB
5519	fee_transfer	1714	21000000	1	CkpZFfx3RZEKhbQK7uBSRu9vP94ny1GAxamsMmmVRm9kwZFCfQm74
5530	fee_transfer	1560	361000000	1	CkpZ9Hh7cSZSqqgUpugSvd9XCgRQarht1HbM6uHe4HNL4F9XmNiwr
5542	fee_transfer	1623	42000000	1	CkpaK65rsbGAHJrqGTBJn8HDb6bQaXf1mgbpscqrjcteB13dmrVDB
5544	fee_transfer	1717	41000000	1	CkpYwxT4X2KFUMjFonEdUatUnPGhaiHxvFm8YX9RpoCHt9cbKm5Rs
5549	fee_transfer	1395	110000000	1	CkpYvwhgS8By8iqquziSrw22Fo8vFZQ915wTMTS9PD4Zgepc1hcN1
5551	fee_transfer	662	120000000	1	CkpaCXcgwZYsSFVgNP2HMMVfBxzm668PqDSdSKkJJ16uJcGq3Z16J
5553	fee_transfer	1723	62000000	1	CkpZGJbNgawMzYUUuPEojzMzR8bnJJmu16hpwuUKBM28HDq9eBm5c
5556	fee_transfer	1740	123000000	1	Ckpa2ctXpHr5WZAPFFkdMu6qKssSKRs3iraZFBFAZLeWk98bSkPRZ
5557	coinbase	340	720000000000	1	CkpYTHDLi6WvnHHUPE4RG9w6By1JaF5wk8zftgrZjLuc8ons2oxXv
5558	fee_transfer	340	24000000	1	CkpYTt2UjVUBnbh1zeJznmmvKQocTM2yZ1qjNQ8tabRiVEqci8Dd3
5560	coinbase	2211	720000000000	1	CkpZ7LRtHMsTZ2c95AhKAgNk2dLuR6VEQZie2yrcapLvipBxi8hR1
5561	fee_transfer	2211	33000000	1	CkpZDVmqWanvFhgRpRghhD2sHzYxrZozQvFpSKuoVW6Bw2odPzkoU
5563	fee_transfer	1762	144000000	1	CkpZXbvsWrQbnSvwaeHkAxpTKEQzzZasg8FoX77ua4KWyswX8quiQ
5564	fee_transfer	1571	143000000	1	CkpYbQQin9uvqTEeFZKBhb2RwUHBjLSJ2HwJNjJd2fPCKFfZaiL3g
5573	fee_transfer	1706	470000000	1	Ckpa8oxvqqdAWtQrpGZPdrEdFwr6PSXZsdAk2vQUstNEu7i15tVM4
5574	fee_transfer	1706	667000000	1	CkpZPKfSBsdibAJAeKfMyEnWDjidjABrJNZAU918CMJXKBfG8f51e
5575	fee_transfer	1509	112000000	1	Ckpa2RryigAjo37ALv46tcAg9CVGKHBqLaNCXQJVf9RjvmGwWy8tJ
5579	fee_transfer	1688	125000000	1	CkpYziqaQ51PiqETTf4EPqiFTFfoueaoFiLSQSgbxpJikAnwPT8KW
5580	fee_transfer	369	760000000	1	CkpZSpS2Nm6tg5n5GVSfH1D1ZzS8VpK5tacG9u4HiZkSbhohWWQHv
5581	fee_transfer	369	670000000	1	CkpYd1xFn7y3Z9cx8B1fTMEJsss2wu1ny6cGSEebWvb4tBautKvWc
5358	fee_transfer	1571	176	1	CkpZbm9wHPDvrLcgcFmjeaAqCHqCrEXBv9cukgjLsPJmcjMc4yp1x
5359	fee_transfer	1693	22999991	1	CkpZZvzEpUeERdnDKdUjz3aJptuXA9iHjfvhnhkkk7QbYCmFyaiTK
5360	fee_transfer	1693	22000999	1	CkpZC7ubjCb1pZvhaJNZ24iZGWdpB2K6UpM6TXJ4Bux5PcPFbREsj
5363	fee_transfer	1698	18000000	1	CkpZpNY7oa8q1U3vLH7pNV8skAfxK6jNtRp55v5HTftfTHNvsJfAR
5365	fee_transfer	1395	18000000	1	CkpZ6fn1tVw7xnzCfs16wEzf2oZkBZ9jR7FGwnzpbvhuWMHLfmtTx
5368	fee_transfer	1717	14000000	1	CkpYVBLnVjHSdt3z5nW2ZuCWQD9SQXVC8QmFQ8npfV913qBHCduXH
5369	fee_transfer	1739	71000000	1	CkpZGqXvHKGoERqsahyXFxdHdiXm3HSMeMgurbAwVXYGkyPf9qZxW
5371	fee_transfer	1850	130000000	1	CkpZoGo2tnSb6m7eYwskMD2cTn9izbBbn9Aagkpeyzg7LEzqENExN
5372	fee_transfer	1850	466000000	1	CkpaDP9cBJ5qnsiF8dHftfXZdbCs35kFkfWvSfPPQNCn3DMc3MvF2
5374	fee_transfer	1668	23000000	1	CkpZmnEiUYwjGHY9v7QtXbmKkxM5VGftw5AUsbuvj1xnrNVFj5Jxk
5376	coinbase	1679	720000000000	1	CkpZoh3PtNxiWbgN8H8Nu9Hvx2WdzdGVVL363AGN3s69xLxiqVUyT
5377	fee_transfer	212	1000000	1	CkpZJDjD55M174i7mTPwvYS32orCmuQuoFevfvh5PMqGkFmiuWtxm
5378	fee_transfer	1679	9999992	1	CkpZjmiAXpoTvhbmovivEXrS3WXfDLxgZ5tqKvW28JTidmkN8QLNV
5385	fee_transfer	149	460000000	1	Ckpa6TPMh2h51VoKGAwGtvtKeFhpNhypum3ABbScU25vqSHSEbWL2
5390	fee_transfer	1715	35990000	1	CkpYtvitXAQULuuL7d9sn5Q27yT6SEMGtjeJ9fQjNiWiuoiBJAkRq
5391	fee_transfer	1693	10999800	1	CkpYrrfMu4QSSYzGybEuN26TGd9R3bBuPFMpbTVT9xY2rS79kRypF
5392	fee_transfer	1849	200	1	CkpZ4yayMj79HBqiwsWuwAgSZU5JRrziAeyPiR4r4Synwp8ktVehg
5398	fee_transfer	1476	23000000	1	CkpZPeAThciYGUubN57jRYKSu6P8jPVvcrRP35TTTbTnyqKwMMZfM
5399	coinbase	1425	720000000000	1	CkpYQCjHoP3DbkhUghwwfqZzL54hdhR9oDhQ5rduHP9e72kumLgAQ
5400	fee_transfer	1425	12000000	1	CkpYwA26XdpoA6cndiJ8s1L7dAxYJWRfCGPGv1Kr6cXJzYL2pXdVv
5409	fee_transfer_via_coinbase	1447	444000000000	1	CkpYcJnVPwg42gUT7zhCaFdH7vekYbBdX7VvtCwau71a4D9M9kEAe
5410	coinbase	1739	720000000000	1	CkpYiyDQscJWVgQ8JMLoWzMU88bWy7cEDTZtdrqvGW64eP6gmYT5g
5417	fee_transfer	1419	1440000000	1	CkpZbLhukU5JAXri1Wdhv6D2nss8sEGT67CXyZam6UHufxzyH3NPr
5418	fee_transfer	1419	620000000	1	CkpZj1EvfjRvL3nQBdEfn7NwkPw5iPkm6seu2xUwnPA9BceR81rBq
5426	fee_transfer	2086	26000000	1	CkpZvrmwdCFYB3MEvyapXBgAWboARmihq4Cnzhfco6yBsURr2uZ97
5430	fee_transfer	1756	17000000	1	CkpZdfZHxyxMtq2WDt51gXookfjjTsXN9pvoUJKm61gVWRR9ok6ZM
5432	fee_transfer	1718	17000000	1	CkpZooFcvmu6AmFoC1PdZcaXfrVhfU3MUYXYNE1Rqy3vL7cyVi2Hq
5437	fee_transfer	1723	13000000	1	CkpZUzDGzv18yKbdqKQsQyVjLTMZpCHvsiQofwpFatEqKpRZ1efFU
5438	fee_transfer	1592	25000000	1	CkpaLQ7nu9nQfpJ9Zc2Bno8xvJ89cXjt8hi3bABggJLZGEGxzEZ92
5445	fee_transfer	1710	25000000	1	CkpZURSiM3jmoiFhiSb663n6wXeKgNGNq92ShLRssFf6tgWzHR8X7
5447	fee_transfer	1673	13000000	1	CkpYVujKdVyYz2axSzHwFedEVe61N1EMA9Cb5pCQjNJwxm5KxASeu
5452	fee_transfer	1623	112000000	1	CkpZJ1sWnvck9rkaGzkAUTEup6SFDBnBMUWvj6kCNFXVwBPp5F74C
5454	fee_transfer	1395	49000000	1	CkpZrH1kPjmXqdYDmugZrKxTZnNPsuf72W59uBKcAhdmG7G6Z29oL
5456	fee_transfer	1395	112000000	1	CkpZk9MVusw95wk4QWP8EFYxCxCF2iSjLovbPnQD1njwY86J4SQwc
5458	fee_transfer	1719	115000000	1	CkpZE9X7v48ucSUUYXjdgVgmgG865KdatwPofkJTnuN7bS6GS1m4f
5463	fee_transfer	1679	34000000	1	CkpZbkTaTWWNRnPaXPLteZK49AAyDLiHtwYa5igYAV57BBoSDTxa1
5465	fee_transfer	1622	21000000	1	CkpZcEaG7sFyvxfK6JjsKsJfKJbCj1g58YnjkWtpB81CJrYf6gtah
5471	fee_transfer	1463	12000000	1	CkpZuro5vqhBk3APP3Q9BcSEdGWdvmWHWGjm92MVa8Vh5t1L2Vmno
5472	fee_transfer	576	22000000	1	CkpZ7HSo9dqsQEz8LVCoNynCZXkvwMBtLaX23THpVv4vpVT5BsgEn
5476	fee_transfer	1395	211000000	1	CkpZfKwhFJ9686t7ZThKokHd7XhPhdRogx85dhiv8sTn8EhauKuhb
5479	fee_transfer	1686	22000000	1	CkpZ8jhJa6AGvXp1WNh6srbvxQ4UXKHQFSq6zX9WhhiboLu8poZ1u
5485	fee_transfer	1700	41000000	1	CkpaEexRjqdnWGKhMU4nSnaMbMSsESA1uYtDw2tGJemt9owhpJjmG
5488	fee_transfer	43	999900	1	CkpYro7HcGB4aaa5WQccrcCWe4K8NPxXUu9iYGA92rUDH5GZsKi3R
5489	fee_transfer	2052	100	1	Ckpa5yYFCAzwHq2n3X7MDu5wr7euHuow3gwbY6HUBM4JkPKrLDkhQ
5490	fee_transfer	1610	7019950	1	CkpZkHnK4T6vSN8BzskXnFvqnBbvJWGa7MpkzdaSeFmxTE9PUT6Ut
5491	fee_transfer	484	25000000	1	CkpZYnQjLzVecyYTBBSB6gDmAFNDjmu1XxjKhnEDmx49Q3NRheNLV
5492	fee_transfer	2052	50	1	CkpZgeNaMZ7Em5EC7k8fadqfBQ4q8GjQgyHkfGk8gHAccvuEHpV5M
5497	fee_transfer	1444	22000000	1	CkpZ68Qkg4naqtE25vvTuhsZxoP64GhFe3HTVzE8XX42zJk3tVdEL
5501	fee_transfer	1768	30000000	1	CkpZ5CnxcUb2PWgBG2HKi2rgWVmPoh4BzJUiyJBdYRGvBVFSNYcbM
5504	fee_transfer	1649	23000000	1	CkpYvFrFjSGcN5XCmn9ychK3CC6A34eBKLmpgKXKpZkwtBfGA4E49
5516	fee_transfer	1419	21000000	1	CkpZcRk4xUrGbdipcf4Y2e5qYyyrtcCjMZEU3XopKCdiUTmB7cs7Y
5527	fee_transfer	1603	600000000	1	CkpZqL8eyLqvEoskaLBidEQuWWkn8xhDMWgUFSF2HJnT41CfvSSk6
5528	fee_transfer	1546	41000000	1	CkpYdcPieW9q8hyWj7CVuBx2QCnoNjh8hqxv6utYfZm2BNC5VL2hf
5533	fee_transfer	1593	31000000	1	CkpYSfT5NJCrXNJycYAFaseN2MCV8coGubvuZfib9UK2ZctxEg3p3
5537	fee_transfer	1587	219000000	1	CkpaKV5KrqxMFYp9uA6Q9oSQHntJBLUhXEyeSdVHb8cW1ZisT59eT
5539	fee_transfer	2112	21000000	1	CkpYTxgkuCVkbHb6EMq3Xc1uyWMaAkDUXvnbSRQUWPLcvPVtrdExY
5541	fee_transfer	1690	42000000	1	Ckpa8DRd9Dmrw3Mz4Wks7EBoDGwX6P3PvN8CcFMy86yLxFfvh8tUH
5548	fee_transfer	1688	95000000	1	CkpZvePyBVuBjNZ9vWcQz1YeVKH8H2doXzSqhTTgRMRG72yDwZYXQ
5552	fee_transfer	1680	62000000	1	CkpZbsH7dW2AhtzPMz8WaJ79YY3L1eGnoiSVvmNaGsUEvVu4HPNML
5555	fee_transfer	1895	24000000	1	CkpZyh5v1daQVLU6MLPwea3F8nJ7hpocdaFP2dLDRtLE2X8cAcsV3
5567	fee_transfer	1508	64000000	1	CkpYRohYBuahrWe7mgigv4ef47JZSpfuh4ZYwieVCRcr6jJR753uB
5578	fee_transfer	1395	125000000	1	CkpZimJyiWHbP57M8pr9cbJ1bdZwpfutAi1F93VS9pvFkrnvsh5vZ
5362	fee_transfer	1564	18000000	1	CkpZSGQzf9bU9JZNfpKftPRXJL5zJsB3C43S9JjZPFTDiv3RqnCWp
5370	fee_transfer	1560	600000000	1	CkpZJVNVKZkUwLEFn6m1egEs9N8zgZzfLdM98AZoysyWV4xUC46JX
5373	fee_transfer	1643	519000000	1	CkpZMPfKReuZ4fZxHEnYdnokWyiJc849Ni11ywopwf88SaHHewd5V
5380	fee_transfer	1654	310000000	1	CkpYvkyikmxE6rkPofp79h6qMwTE6UTbwNnokCG1zGf2WwTXwJwRL
5381	fee_transfer	1654	83999992	1	CkpZRQhzzh3g41bsqo77uMgifdss7SVquhgYXp1uSGnj7P27MzWB6
5384	fee_transfer	1688	460000000	1	CkpYfQf5neeY2VKaByZdU14svQH5mwREDWAAr9ZXUxhAWYrybbqW3
5386	fee_transfer	1634	460000000	1	CkpZdUpSwKUf5FzpB1CZ7CenByKySpHt4rKVyG5bX7XCKW9ge1uj7
5387	fee_transfer	1654	641000000	1	CkpZyYb2aRQ728AxXNd8nt38abrrX7f5rYw1SVjNtqp4Zg1vwGQeb
5388	fee_transfer	1711	423000000	1	CkpaHrvBGsSjzDeBMqCPpHcp39dHzk8nhXHKBgf3aAWRiB4zTHN3C
5389	fee_transfer	1426	23000000	1	CkpZzzhf4ZjnT8wyHcyG5AdpCTzS9u1ewRUAXmc9j4P2LRQmEoofS
5393	fee_transfer	1747	34000000	1	CkpZo4nEieLe6jcYdE7gEXtq2VQGCv1bBzbSzBexL3v7AqFB2xqz8
5395	fee_transfer	1708	34000000	1	CkpZBDvmq7ZrZ9UhQKHSU5oiQZLY1rHd4iTrxg65Z28hbmuztknin
5404	fee_transfer	1599	820000000	1	CkpYhvn1LZrqUHxuaE5xeoLKnfuXbmuJ4H8f9DJSqh1nhYHAfzxcA
5405	fee_transfer	1599	907000000	1	CkpYnmSUBpoSXbvwxgzr6wPySmwCJpjexz63ayQTKfYrRskt4d1mg
5406	fee_transfer	1599	82000000	1	CkpYpmx9hjHUwzQv6QjsESa65buPtfKPWMts1kj2M5YGEQuScjXZY
5407	fee_transfer	1599	107000000	1	CkpYjyHQP1d3aKTKW63xteESvYUHAMQSZMB9qD3shnazJ2rDD2HLq
5408	fee_transfer	1508	23000000	1	CkpZLtnrgCqSGWsAYNnjMJrMhi1BJWKDQqMG9G1iUpZaXe4cG2fD4
5413	fee_transfer	1675	7000000	1	CkpZY4zqcGRVu5xcyHmC3vSxDDZDMqpkGADuPff2se6Dmb68EwSYq
5414	fee_transfer	1716	142000000	1	CkpZco79pNLvF1jfBZkptEuKxjrXLTuUfUMmBFAUbZzZram5nUafv
5415	fee_transfer	1740	225000000	1	CkpYrzGXKDNgm4shSSc8TcKmqDXFhT2qUz9njtriJvPNyBwuMj3fs
5416	fee_transfer	1549	25000000	1	CkpYXiVA1Ce65jSeTdTWRvhj9pLmk9jhsapAyo3MpQK9LL9hYdNtb
5425	fee_transfer	1708	26000000	1	CkpaLDYYETdhaohcjhnD42hmtbMsxd2yWiBzaiR5TQny36s1J1sX8
5427	fee_transfer	1724	26000000	1	CkpZoFzemhhWWkZhCsTwaNMbo8LJ9obJyx2NGpBwxGtLoDzpySAdm
5428	fee_transfer	2087	26000000	1	CkpZZdPmDT1N2RMAUjwbBYb79W4YzWexWWMWaA8Y5LriS4BcP2c9J
5435	fee_transfer	1850	850000000	1	CkpZJLycgBSRRs19UfJcekouQ2HdRymy1vDbVd3LodGrFWtmtUstw
5436	fee_transfer	1850	1120000000	1	CkpZBCKXY9VUDgswaXpJ5NMRaTtBMF5CydBH3PHPAx9fqf6cvFiJZ
5443	fee_transfer	1618	25000000	1	CkpZ3eR8zpZ5JBHR7M8zE3TtddpduEk3HaqHY3eequUun7R6PQ9J4
5446	fee_transfer	1637	112000000	1	CkpYdkSLUfTHfwbuFBUwCjaUQkLy5hqmKDs3D7QcBy5nD7QkzsbVL
5448	fee_transfer	1679	124000000	1	CkpZ7sTE9uq8mKmSFvYGPJnHxsM7McTGffur7d5YohQM1vaeeGqhh
5449	fee_transfer	1634	281000000	1	CkpYYtWATgp62VBRg85Sm57kMY9yt4AebBaD2U1HpmrDVVAxnVKx5
5453	fee_transfer	1688	49000000	1	Ckpa8S7WZVNYYKQqXexnjndcppVwvae8vtHrAbQpmThjhEM9bSquq
5457	fee_transfer	1719	111000000	1	CkpZf6o8QH5favsp5sC7gZ4YKj4unRXewZ6qh9aYcwTsKyTH6hBB5
5466	fee_transfer	1471	21000000	1	CkpYa2Df3hN4SFe4VdMSXeRRrgWVUUYsJGiy7nMqnUFTxFnjZzUrE
5467	fee_transfer	1471	2000000	1	CkpZrZN5xtPPCgUEYhCDfaPG2WBUy8BfRgKBFYUG84y5wh8L8kYQx
5475	fee_transfer	1571	211000000	1	CkpZSDoc2QKHN8RQ9Ktu2DT9iCChifJheiM8xSrNKzP4j3UAdPFNK
5499	fee_transfer	1684	46000000	1	CkpYyerSGGozfCXnc9Ff59iCp2N8xcHK5f3hs9jbFXTBmqyXbBsNP
5500	fee_transfer	1593	22000000	1	CkpZww2jsXBWgq61B2Uj1bK7AdxbKcBsR6kpAsbd5Dd8JPA8iFbyH
5507	fee_transfer	1394	111000000	1	CkpaHaJ2bJpqpK1Xg18G8R79TMbkvjhKjy4YGNjYzkUQpEJWNvNMu
5511	fee_transfer	1524	11000000	1	CkpZfSrsTEjTFTfzMGJFTVJp6Vnvec1auAKWyacxmDyH5u5VeFCtN
5517	fee_transfer	1508	21000000	1	CkpYWKFbvf3xWtBqEd6bYhmSMxWpkjfUNZZLeHVztuzH5jZaF1VmX
5518	fee_transfer	1980	10000000	1	CkpZyuxqw8kr63tn2RtkZJbBZsw59Cibp51uBnyDmnEpzU9nvu6Fs
5520	fee_transfer	1560	350000000	1	CkpZkC9a7P2bx5f7M391Wm3KoPkerXKXru89r9ToB5BwrsYMQEPDK
5521	fee_transfer	1560	189000000	1	CkpZuHX798nKi8oDNtnxKazaHNJyS6wE9dsU4dVkTN9ens7vLeXd9
5522	fee_transfer	1762	21000000	1	CkpZFwtW5PUn1jBE2B66oXRweGoZEcCb384xbJAz9phiJMc27YVGz
5523	fee_transfer	1765	1000	1	CkpZuuu9Ck4eRBLDhmnT6PGYoGaxpWw9v3HW5pnpzRcGP7qDSmXmE
5524	fee_transfer	1695	10999000	1	CkpYRLi25mCfMrAtyDw7WydqCEccCuaAcvWYbCF22RQ5xgyrH9foF
5525	fee_transfer	2112	20000000	1	CkpZ6ceBevJGnVYPa6wYVAVqd6QHr1uzVZs1oq6yFAh5ERjpUqopa
5529	fee_transfer	1394	20000000	1	CkpZFLZoMXPQapzF3BVVkvFonBmTqPSzmm7tASt1F9UDpbkR3puT6
5534	fee_transfer	1395	31000000	1	CkpZnRGuj15EFHTp3b1rRYV2jx4SBSmr8n54e5rfi1ksT95PVBvon
5536	fee_transfer	1601	41000000	1	CkpYcpkqo7xqiS88Qm3ABtvQYKP6NT1Go34zhn77XacS4J6b5HFZc
5540	fee_transfer	457	11000000	1	CkpZL66TxE8j8MKw1jQiveD5ArB24LdgSAhw25nWTcq7J6TJT8yFF
5543	fee_transfer	1739	31000000	1	CkpZT9NYmJ6TtunHCfrpxefqVkA44cSJJ9AenxYDop3yenDfoTEKw
5547	fee_transfer	2148	95000000	1	CkpYcErvxNsZMSFUgaaoqqDDyvT3CxVQfFLzMb4868fZaKFvcpNFB
5559	fee_transfer	1714	44000000	1	CkpZiaytb757sFsJVVeRA7F2baCrp4YXektgGvnRKbRkr2d4CU1YR
5566	fee_transfer	1462	13000000	1	CkpZEzEsZsx2BxdfDtuDhgsFnJHpZBaufpJgX8BkeQESDrKGtAZSB
5569	fee_transfer	1710	3000000	1	CkpYnhdFdbretE1wekUuvp3jsht8PWu6eABthpzxZQuJP3cfYhaaP
5577	fee_transfer	2112	11000000	1	CkpZGdy3UMun2vt5q7jWSu5ek8G4eBcZk38RASeAsPp7mDFkadxHb
5433	coinbase	263	720000000000	1	CkpYezAsokKZLwsZ77vkb1Km1KxHx3QkdqvnzXctBzSKyAC1f2AxZ
5434	fee_transfer	263	12000000	1	CkpZC57KWkoW8i5SUWp4rPywkvb9GZc9hSVregd57dAPWj9tV5xsN
5439	fee_transfer	369	2000000	1	CkpYcXomUc46yVZigw7T9rQq9AKUdTbLXk9jgVKXQm559JNMGhQU3
5440	fee_transfer	1670	61000000	1	CkpZVkxG7YFeCVD9212HYydgevgpXr9fahBZPcuWiyZAbnN8MzeVP
5442	fee_transfer	1675	132000000	1	CkpZmN5pHkMmn9imxXUxVJY2yK8aUEjA5ynj26oeVfaznx63bmXzD
5444	fee_transfer	1675	4000000	1	CkpYj6ihsWg624Q8DXnhUMZyXih6HdTm9JT44znu35xpWvwwMciin
5455	fee_transfer	1610	112000000	1	CkpZpwUnWAjzfozu2KfbDDibM6jXXu9mQw1WEtEgpaFYFEkZFv1WT
5460	fee_transfer	1637	111000000	1	CkpZ7HMqY6kcXxFX69EYMJwmLvMA7jpfgpSDrcfCo1y7HyptDgw9u
5461	fee_transfer	1670	112000000	1	CkpYW5zgG4MdQBLfSMfYc9qaWq8uuhYWdv9Qm6xrVpp9bjpZPExnp
5464	fee_transfer	1625	22000000	1	CkpYVS45Wcnw2d8ksHxxitxPzwgj9yKWw6Q9WbmD2kZtwYSH39NLy
5468	fee_transfer	1596	21000000	1	CkpZkJjUTJ7jDx6MRFR8SC4f1jcHSnwq8HBiHidA6ACnYF9mTz7Xh
5469	fee_transfer	1509	89000000	1	CkpZXodzKUUekCHtaHZ9nvLojEeC66w3dX1cebULn5sCakmpPaEr8
5478	fee_transfer	1650	223000000	1	CkpYfBfocjMV8Yk18TqQf8afPbKHaD1HTGymL9HhVLyV7WE7rnPkT
5480	fee_transfer	1594	24000000	1	CkpZ3pCj1H6EpBaBW339kqLU32JPptfXwa9KEiqm7udiHX8kcwiVZ
5482	fee_transfer	1506	1880000000	1	CkpZF4Fu25BaeUttRDMPWsLzjdSMdkXGwvRaox1ebJmeYgSc3tMr2
5483	fee_transfer	1506	460000000	1	Ckpa8oAVfnVP87DmrK9wfZn5N5VB6V9BuLj33xbSzcXit9HrnMMSS
5487	fee_transfer	606	542000000	1	CkpYvwXEnB12yfMqWLT8R9TPy4wxPA3eqvGgRq4w5ikZABeDr5PHU
5494	fee_transfer	1563	12000000	1	CkpZzz1BVuu8Mc1TfEkD9fZVDnNXFqqfdcyRmftpR3LF9ftMWLaTZ
5495	fee_transfer	1476	185000000	1	CkpZgqnbe6xn644cYaMusGgmhfUmN769FCcMzSuZk3Rmq7gaXf1ik
5496	fee_transfer	1476	5000000	1	CkpaHNa44RNiKeHuo2BSAD2ktbg1M2tcYKWXgikLRzGFNnz63DNHS
5498	fee_transfer	1634	1206000000	1	CkpYkCCPDAJZej8fe36ihu6znQ2P2zoDCbVPvvP5VtapnYmyW62AA
5502	fee_transfer	1601	34000000	1	CkpZE5XZjMKdGSGcf3N3cv5g9BkP8A3S4UGo1ANgiDmMFLe8ftvmb
5503	fee_transfer	1691	32000000	1	CkpZtopTbhmot8DgYs316TsvjQnaNP3td2fPRxreoqHdbNgG7dwT9
5513	fee_transfer	1623	73000000	1	CkpYZxNi8cZg7YMd9D4j8eoDxvXEac5cTccysPoHcbnpN2bGZCeAk
5515	fee_transfer	632	32000000	1	CkpYhomJdEY9M3NKzipuZnzLtgdBt6LeEYdbZJcWiKd2wVfqGjria
5526	fee_transfer	470	31000000	1	CkpYuqLY2GxJmJ9tn6BFBp4nDuri3JFUvL55vigEwN4jSsD5AZcZm
5531	coinbase	2199	720000000000	1	CkpYSVr2AppdBx9mbJpAoEBee9zJ8xA8S8xhbmr4fQiNnfATVGL3b
5532	fee_transfer	2199	10000000	1	CkpZ32wtUFTtA7GPymD3y8nj4m9cRNwvfrrddWEGfXHY8DHDMTBzD
5535	fee_transfer	1680	21000000	1	CkpYns8duEsdFKAGvap9ghojyK5wMsCJdMMnunAxPAdnwDRwEMFXf
5538	fee_transfer	1649	22000000	1	CkpZ9hpHHzhdYN2wyxzmDzaJuEKtdJ6aqEyvGLTT4z7GALoXWTuY3
5545	fee_transfer	1513	41000000	1	CkpZtcA1XdweWJRFJN6gzvTEEVbJYqTwarYbi1pG1jf5KvetRgqb3
5546	fee_transfer	1422	51000000	1	CkpZTdmUpCP2zLz2ZeKgnPggcXnyr4QasCBp2SkB2B5LxPp4Uxpzi
5550	fee_transfer	43	110000000	1	CkpZbVQuctFRxP1eagggLnpbSQSwYvE14U3iHFSmoCnEHaSa8SUss
5554	fee_transfer	1895	308000000	1	CkpYU8hNJVxrjHoHqdJaifYyC1yxdvetDRF1hbVrjBVXBs4ntE125
5562	fee_transfer	349	11000000	1	CkpYc1ttQvjyTFCvShh2FASvA8zGwuS6iYiw5CpjqMU443NgHQqAs
5565	fee_transfer	1549	24000000	1	CkpaFTHbbBAzbC9GeF6LbDL9SGMXALCVuFG2LvB1N6zSfX3436p72
5568	fee_transfer	1444	3000000	1	CkpZzJEpNKxos1JFPPWLDvvdsUKgiKHmFDeAZ7SQYxpSriz8dc3QU
5570	coinbase	302	720000000000	1	CkpZvp2zdwVgugbnxDY3k5MHZQaMTtVvV7DSEw4SzwPGVbaj8ymFV
5571	fee_transfer	302	12000000	1	CkpYfRXZP7r57BwrDUAhPteGo4K7jQnKBxmpE8mmqCQQGZ7JKihaR
5572	fee_transfer	1708	77000000	1	CkpZj1wR1tXG1BjbseGmb8z1ttUYUWnJRMm2tEbPKfpvh2NNpTRkF
5576	fee_transfer	1560	112000000	1	CkpYmxgymXUy4PnNfGn1ugJhV3g6pPm4xrNhabW3QDYoYS6P5HFXE
5582	fee_transfer	2112	25000000	1	CkpZRCjryuUQfZCYBQyrUeugk7rwgmyohZdEpnQP41TBMUDWry5ey
5583	fee_transfer	1455	24000000	1	CkpYx2jSDJL8LMgFGLqVsGs9JMF9kNcaL7M1ejXsiwwh1ELw2ThXu
5584	fee_transfer	1587	62000000	1	CkpaBM9s4WUmcMzgyH6ff2CTB22PjSKu8DRybP4URTyH1LaAgxHBD
5585	fee_transfer	1489	74000000	1	CkpZ8xNCwxWo9tUJoMGqUvdkEJf2xfdM7ifmyYboJzAyKactmqr59
5586	fee_transfer	1489	68000000	1	CkpZC6yH3us5E6erBRo9Fnbwq2ro89jz5FhbjS38SBaAM1SQoJ7PG
5587	fee_transfer	1688	74000000	1	CkpZBBcsrj4dEikcq8yxnTkW6H5MKZzN9CoY9qe4o3k11DKhpqqDP
5588	fee_transfer	1536	34000000	1	CkpYgCiEazLP7ZUPbCoX1nnKob2ovpSPkSDD4iAuNg9gDN2NeEc25
5589	fee_transfer	1536	3000000	1	CkpZHEQCeT8nZs6UPjVVuLRKccb7qm6fdc7tsA859zSemRmd4nyvo
5590	fee_transfer	1724	34000000	1	CkpaEwZDWxyShzz5jCoB99VkEA8BmdpkBHvqyUKntP4bUSQSx7vCU
5591	fee_transfer	1724	3000000	1	CkpYXqRerUTH3ZFf8eZWfhGcmDQ6wriayZoyzfUsf8FfdcXqvQNvy
5592	fee_transfer	1991	211000000	1	CkpZhD2aJM7eVLoBVYJEMA93tNKdbUHQKJBcHt8CjGQ6PcbBunmKr
5593	fee_transfer	1718	2000000	1	CkpYkRYHbkfiRp2ntFqt1fBDQhXTaj3Chqxk3afoxzWN8YYQuTsZf
5594	fee_transfer	1982	12000000	1	CkpZaqZRQ7VxmMhy1sw84sv75bMJvA99LgnoeEnz3Td7uCjHLARxo
5595	fee_transfer	1681	25000000	1	CkpYT1HoYyfadsdZtypU9RtvjjzPXWYMv5LM8xci4dbhp6MJhUUfL
5596	fee_transfer	1673	26000000	1	Ckpa4ttxDjM61Cr8j8AQxvvPrrRnSY2Sf73GCxsgR6nSAHP14cxwq
5597	fee_transfer	1643	26000000	1	CkpZWaiF9g4FkPp3y3Gm4okdqJMxrfjyjzf6BbSCwMGDUjMdNoS7G
5598	fee_transfer	1271	438000000	1	CkpYnKqMDHAkLLwsoc1yP8FpiZ6V3smQVXFpkNyAAZ895Ff5yyQbP
5599	fee_transfer_via_coinbase	1855	2	1	CkpZ6AWdYHxfHXdwNeKjzSe6kToUUgxSa1ZB42bmxk7FF17M7koQW
5600	coinbase	1271	720000000000	1	CkpZ54UugAFwxjTr4xH9j1h16Fr2ENVBLyR7V6BFq4hN6uVLJUdYs
5601	fee_transfer	1988	70	1	CkpZhuVptEV82nNWyN4ghhYEszWC1cb5enDX4XA3ky6iTH5ZpbAsW
5602	fee_transfer	1271	5999930	1	Ckpa5xGKdsVRGN6FYE2xv7GEPTaud2fAafVDbakohpGvqGGQWEmcx
5603	fee_transfer	1992	37000000	1	Ckpa2Qyv94uC7vo1fRGcfK8zyxz6HKuc3f5SyVKQKXw4YYRkDkPd7
5604	fee_transfer	1439	37000000	1	Ckpa29puLSEGEc7rmgJKGHw6FfQtxE65CHCkmgs9APcJQA1Bjz1mq
5605	fee_transfer	1749	61000000	1	CkpZvgWVYChyBrC5coagVEeZhY2raSxQtC1KQwQPfFumTbhYx9rMX
5606	fee_transfer	1564	13000000	1	CkpZxN66ciHgeTa16a79uKNRn5x3YiW1Do2e5d6XsvsfUpQjBuPsF
5607	fee_transfer	1571	22000000	1	CkpZrRsCXBhZ9MX4FmrFjkDfmReffKCS7D4wVqWQ5pkH8wdUMmadG
5608	fee_transfer	1623	34000000	1	CkpZWQhsFVEibuxr3zA8ubqKfQxhjZAnqEFtqsnX1LGo6c91Jd3cu
5609	fee_transfer	1599	62000000	1	CkpYsbS5igT5yHPsR7MB5kLgTDk8Vat8Fbku37rpeTb38zbmUTAE2
5610	fee_transfer	1394	62000000	1	CkpZfi6QqUtqxHNxk9PRbH4mAauCF5QzCBp8m3txwrEusrWbrGyzk
5611	coinbase	2100	720000000000	1	CkpYQr2Fgh7zSiW7aacSt7a1dC6mKEVNEm5KjBAHRZykGf9LKNit6
5616	fee_transfer	1696	62000000	1	CkpZ34T9Cq1DQvJxgP7ZRDec1A8TnAHnjU3NtiNVS4TqiwXi4QxiA
5618	fee_transfer	641	519000000	1	CkpZJTqqXiXL8aBe1fYiknxBBHNPcg4ixcSAwBz7sB4VXFqPhhKSt
5619	fee_transfer	1613	115000000	1	CkpYz8aFuYx9vhPYCN7VxBakfhRCW5By1n5fGeGzu4UxK9deb3Hys
5622	fee_transfer	1394	63000000	1	Ckpa1bM2JBVtC2c4LueEYNzn9RsftrGVSn8gDf3YzyWJvJx3xnc4d
5634	fee_transfer	1451	28000000	1	CkpZoUKUkL5rVs8rLLv8TaCbc5ZEYidUjJdB9tQ41cwq4JCs1CG91
5636	fee_transfer	1637	28000000	1	CkpaHH8Etht27g2pxoaAFYxVxzt1APBKHoLZ7AoYLE5YZ8ChhkKNL
5645	fee_transfer	58	78000000	1	CkpYkzBA11bceTiMixKqzMXRRV89AbhGt5VSv4c81tFjdD15xDaMD
5648	fee_transfer	1684	23000000	1	CkpYYysUGpUw4Q6fhVd5T9G5H5jm2p937kMB1TjQ6SD931C3Na1FC
5656	fee_transfer	1476	13000000	1	CkpYnWajhXjo6VqstN9wC6Z5xX8XJJYd5Dph2SMucB54k6XTt2Hrj
5658	fee_transfer	1717	2000000	1	CkpaA5A5PMRWmHAky2sVVzQgSrS44yCEc1oLTdTB99qomMcZ8yX5P
5667	fee_transfer	1394	136000000	1	CkpZvAsxaAgiXHyVrBeMB1Q5aAmytJMP617eSZcPBaS21bU2vgEis
5668	fee_transfer	1522	26000000	1	CkpaCWrKodqWfqgzm47D2RKZTwndSFPe8DW7huAHQnddQNseqjvsr
5674	fee_transfer	1422	14000000	1	CkpYYk79LgmaQG2FUrzxxs5NxKF8fogZW6Jted9n3C13ApxUwiEsy
5677	fee_transfer	1444	14000000	1	Ckpa53kRJmBRVDUa1vcApo2eRCDLJbkxnWzGEHuXR2uDduqayPi7z
5679	fee_transfer	484	22000000	1	CkpZJ8VXA8iQCMRB1HKTrHEiSqHw4TENN57E9LuwmkqNx8Ta8Z7Uh
5681	fee_transfer	1687	25000000	1	CkpYm2AjoMQDvAKp25NBb4JAg9n6n11zD7zXo7FDmwCYYrzPWLycY
5683	fee_transfer	1672	37000000	1	CkpYzLiNtYRN2xYHNA2v1L9P98xETeHxS7jsghJf28zzgW5PdYuD7
5684	fee_transfer	1693	597000000	1	Ckpa6thFT3FJL88v3S7M8miCpp7RK9yPKf5jRoY4cRcU8bKfjXH73
5685	fee_transfer	1546	65900000	1	CkpZrqZaZLpHfM5QG2gaBCchUPgQp6KXpYwRFwLUfEAoaxrm99KcB
5690	fee_transfer	1508	37000000	1	CkpYS36zcB3aeTkchBG5Xh1k3mPLKDps8dpLbwZ7VKcMYPvPGcHpC
5691	fee_transfer	1556	137000000	1	CkpZskrMNBK3EK5fKM8PSedwS37NRATfHHfapjrsKwnMfStDuenUe
5696	fee_transfer	1687	36000000	1	CkpYtLCfQMxjtKrG6dTFb5usiaDEwZc33u3P7RF6H4MaA7Ldgpk16
5704	fee_transfer	1546	6000000	1	CkpaDXKyemzp29tZEZCKKVmnmfQsvmbCb1T6ETY8QXsXJCqdrwM1g
5705	fee_transfer	1546	473000000	1	CkpZp6LX6TkAwDmR2UR79uzUCLpeJ1oM8a3zgPaunCkZnY9CCA2MC
5716	fee_transfer	1489	82000000	1	CkpZqdFd4xSPa8rn6TN84D5BYnjgw4m9jqfvxu1CQEY5f8N6MMWJo
5719	fee_transfer	555	41000000	1	CkpZRHr7Jun2NiAZw5e2tCJhA8ffz7tPRqiTfxGQi1fgjhG2SwgiZ
5722	fee_transfer	1560	144000000	1	Ckpa6nzggsEDEvBkNQehzo3RhHvBqzqxGw4jeJ5AkVWUUtwpZ16qQ
5728	fee_transfer	1601	71000000	1	CkpZWraNnCRoTND7MndoQHDeEx3bTVs6XD5zy3ngAAcdFHRYVAKEP
5735	fee_transfer	58	72000000	1	CkpYdwWjjaCY44SbSoaFENY8JjWJysmSqf98GKTNG6SFFuQL9fTYF
5736	fee_transfer	1680	72000000	1	CkpZS2Nt8gszde5pMkiJ17bKoAEbYtBJraVUJ5xWvyb4XRmw5PQ7w
5744	fee_transfer	1419	72000000	1	CkpYhUbLtMuzzAdn28w7jPdf31aJok8tPPd4ViNWjkBaPRW8GeLWX
5751	fee_transfer_via_coinbase	2128	1	1	CkpZT8eYQsUVtnU4TwvyF6SNUPAwAo2CuWyUd6377c8SDSYcdJ6WS
5752	coinbase	149	720000000000	1	CkpZeuWeygQBEw64Yso2JvPhadbCFvr8f7CHXnDPaGEaNPZcPPFoL
5753	fee_transfer	149	11990000	1	CkpYa8Nr28xunT2RYwgyqw9a6m8zsg3BerunKeTny6DJhATH9jREs
5760	fee_transfer	1694	310000000	1	CkpYxj9DFzzRkKxFo5dsmGDez9CwL1Ss3EtodxYsrkjQ7QPqD5V5H
5761	fee_transfer	632	345000000	1	CkpYqNzLm1ZCzwcmkJ4kpAgh1pMJfhLFXxzi1rjeRuHXaG29in47X
5764	fee_transfer	641	347000000	1	CkpYkzP57rkjC4dhqZJrvZK1FaCsPngR6wR7cCn4FcstjJs1RFpw4
5765	fee_transfer	641	7000000	1	CkpZqcm55z74b7nKyabtveiuJwtyrVaRFJWr6jR1diva1D5Z3sqcm
5766	fee_transfer	1476	36000000	1	CkpYRu6QpaQw6VBWKbPDz1srdETWD3c9tzuUDarEHjBp817tng99F
5767	fee_transfer	1622	25000000	1	CkpZN2a2xbrHNRCbdZyjwVgknUnqE6HnCePbPdJoeMzA2poAsJnMt
5771	fee_transfer	1593	413000000	1	CkpZPq8zcuucDRBz5jaqZuhXq192R3AD8ebsWJCd6h8VhyavkUJR9
5773	fee_transfer	1699	413000000	1	CkpYV2aR8YkStZKgxx6FyAjmUgDKM3kEUxPYUPmh6zri7tpQj1gR4
5776	fee_transfer	1693	46000000	1	Ckpa1auwgqk9awbNXCrMLJbNs7KghrqziypJVoyhh848sJ8zo1S55
5777	fee_transfer	1515	22000000	1	CkpZneaZWM9M8EZUmQ1sw1KaVfNp29tYSKrSGrR54EAB933RpqBtW
5780	fee_transfer	1555	401000000	1	CkpYa2GjCS7NMcTzhvH1Y8ebVhA4s3CdLesE3PiFAhDKSGXhxJ3J9
5789	fee_transfer	350	12000000	1	CkpZAV85SECS9FNBLqVMSfUYgCtf8oysnFm8FAeTK9jchZZe6ECay
5790	fee_transfer	350	2000000	1	CkpYZoaZJbmsSzxgmVcQRWsLj75PfcTn27wHy3hv2EXLCbyc9BzDc
5798	fee_transfer	641	142000000	1	CkpZgg3njeGHo6iBshuNGGaoHLnNekuwy3N82TUxVVRmcizHt4Ljs
5801	fee_transfer	1694	65000000	1	CkpYqGQm6HVk7o59dBGtQSrgcyqsVssZF4HnxJkX7Nt2QUftMGLNP
5803	fee_transfer	1850	213000000	1	CkpZJ3K2CqYAMDvj71Ma1MCPsBPbQcCdz5HtD7TJKSQzEmMqCkcrc
5808	fee_transfer	1714	34000000	1	CkpZxgmfB6mDqR6hRWjepgbFpTGJu6omxyWcmBoAh4j4NQq5ToGSt
5813	fee_transfer	1717	87000000	1	CkpZfSbJnvgDJJ1o7JFjDGdroT2tEetpKZXthdpkeZPTV7r7WA7Xs
5815	fee_transfer	606	49000000	1	CkpYWvZhQDfYscfkSKHQadQF9HH7tBj8eDJybH46sv6NxME1qxBAv
5820	fee_transfer	1747	25000000	1	CkpYa7xrVjS84AtCCR28J2EDRLoA9oLWiZcuvrXQgD14vyApB3J8Y
5824	fee_transfer	1680	36000000	1	CkpZow25C7J1vZc8apvAYmuvjXH5bUdjvApkDNVxMHu7tu14rtK11
5828	fee_transfer	1394	122000000	1	CkpYymi6cPEwZgiyp78VK1oXtnUdhBkwgMzYPokS1FzfmzJ7pWdXY
5830	fee_transfer	1675	113000000	1	CkpaDVGX6dWakSt4pW5pCMu5xobyE5yGv57aGpAm5QgFoK9tYwZwh
5837	fee_transfer	641	122000000	1	CkpZcbEVGG8fyP3wXYEoQUebYB6iw1wSfYeuntoG2A8Re1uZQrbz7
5843	fee_transfer	1549	14000000	1	CkpYXQd82Vy57kbVf9W86mY9ymMwT7e5hnkpSgEBfYucyy5ywDoZc
5851	fee_transfer	1690	548000000	1	CkpZwTdc7nwCDAiwEPdqaUsKvia91iFn1Hzxqhbp9CrB3tMJMnrR5
5854	fee_transfer	1394	42000000	1	CkpZqoLYVLY1vyfLZoHK1chRQ7k9sinFuYQ7SLMGqdntsVRZDxEsy
5860	fee_transfer	149	318000000	1	CkpZ8U6MLVERZFjoaNEYcAzQFq1AgFnxKM9pu5xPjxGiCRqGVjAm7
5863	fee_transfer	1691	312000000	1	CkpYUxebppULXyhwYnXvSUrQWZ7yZ3ccqSP2M1yL5gN2r5wRwRnog
5865	fee_transfer	1692	163000000	1	CkpYuYvy2R6mUYXJZ7tUuiur2iWwaJduD5ZjLdWjQJMnkaAtae4GN
5870	fee_transfer	1692	5000000	1	CkpYZwebJY3fuVw5h8o15oMeiAeZ7sApPgeQVLWU1Wm4Ycd1Sh5ki
5873	fee_transfer	1991	74000000	1	CkpZaUvauKnMikLwm3pnLPXcMejaryFrWKDqH9bTZcgdTTSVZRvJv
5879	fee_transfer	1536	13000000	1	CkpZXsNTMQpZZd3SAdUDqec7hGD2mtMkBV7f82zDdeQ9ZBVfQK8r3
5891	fee_transfer	1764	137000000	1	CkpZDG82s8Ad3oX4oD4JVamPNS3rsz84FKfB3xUrqTmnCBTaQcKeG
5892	fee_transfer	633	24970000	1	CkpZMCRehK9Rhz9Nd3hsYqFeWcgLWU5hFhuRLQTFPwnsHvuyLL8tx
5612	fee_transfer	1634	106000000	1	CkpYm3919baFvKbRmqDXyVmzMHfCRfmbseUmnJ2NchjWPwd4xq363
5614	fee_transfer	1690	106000000	1	CkpZ9mM1VuUxg245i3NTTKMcMGTMmD8xiqoSYHQHuyvrDgigiQEFN
5617	fee_transfer	1455	62000000	1	CkpYztoALZHz3yjKko7aCesV1MYkopudGmGoWytQ2i6GR9e8HjzNH
5620	fee_transfer	1613	36000000	1	CkpYadwWJKyzAF8wxSqiRkXRcCpYcWRZCnnj2ai9qsA5KLp4mcgFM
5625	fee_transfer	1394	137000000	1	Ckpa64exPAiAZStSqkzgmGfqcknGQhZPNXfeixjxZEaNEAA8d61iJ
5627	fee_transfer	417	40000000	1	Ckpa1yf64gXEvfGnyjos7B56uLNvv1NLHGDL7tN2uAb4r2LNKtVxK
5628	coinbase	417	720000000000	1	CkpYwdBAcumzWq26KJMiRXqdH2B39zNyegZe3xrWmRS4yYR8iiBuK
5629	fee_transfer	417	33000000	1	CkpZsoBGYWNxpWnfWLdpoCuQeZvTRp7WSAVmrRb58nJJLhBdDBhZZ
5631	fee_transfer	42	13000000	1	CkpZmpFcZa7NeFxyDuWqie9q51EB7eWDT8TRa2C8snAXBnTwWZkbt
5632	fee_transfer	1692	87000000	1	CkpZeCyxVCMNDhymVuwMqXZxCtdPX5nSZEjZfyjZYxr7C8udFvzdT
5635	fee_transfer	484	28000000	1	CkpZZVPDREM5wrkt5JfANMcBaJn9eay9cvxcXLHKvfwN5zBaQtycV
5637	fee_transfer	1394	28000000	1	Ckpa54QhnYQMZLQ6zzGSmnwVGfFSwXfGod2ywkftTDieVhwefTbyj
5638	fee_transfer	641	180000000	1	CkpYrecVLJcemLdJa8Rkb7CbvBecvfzhPU2srYqPGhiKRt3mZWw9a
5639	fee_transfer	641	74500000	1	CkpZNjxxsAH2jHYzmJbbv5gLxoCamp7CmndkvvAm12ABGRXLQjcbf
5646	fee_transfer	1700	78000000	1	CkpaGYCUAL1jE9RKqF5PcoqgboYyPAYsxKqweXKfd5PkPSie3mSMz
5657	fee_transfer	1455	23000000	1	CkpZADMGWwDd7NjocwANBfdF5UZufunWx7rT3myXCehNr3G2kaGAq
5660	fee_transfer	641	10000	1	CkpYmdHUJEezhhMHko57jPEZyPLA76kqs1H5jQ8MDa9UDaTCSa3jx
5666	fee_transfer	1762	3000000	1	CkpYngBiMF4Vq7bML27PoNyXcf7YczEsHijLNYzr2cfuZGSZs4Uwz
5671	fee_transfer	1476	63000000	1	CkpYwxD8cLvTBhLZiYiQUfGQrJipKg6u7A22qGS44BNPpu3ANB1Az
5673	fee_transfer	1727	22999999	1	CkpZz2mGTy2w7t6bZdH9HdEQgRFaCLBuXEgcVqMjHQ5gwCro9rrXq
5692	fee_transfer	1556	25000000	1	CkpZN328xhTSZykFkxA3CZcFXYSEq9mHg2jftvvsRT9ZMV2c4SaZi
5694	fee_transfer	1555	36000000	1	CkpYg8AwkcRYpJo7KPj4uE3PcKzmTEaWvfPrvNKCec2vSQHGUXnvH
5697	fee_transfer_via_coinbase	1855	200	1	CkpZEJYrpJtt8ZPQRAd8H2EnJtoCX8bAr3hX3haGRS8PPPx5wqXTG
5698	coinbase	1688	720000000000	1	CkpYWxegKazYXB6tP6n2FZ9AvU4J9UwxmazhUf45Zr2qxwueq2cXd
5699	fee_transfer	1688	5997400	1	CkpZaVZC89PuFRVWjFqhfBpNKsrt4ZYRpEjXPXFzBiP9JTmHPWVXV
5700	fee_transfer	1855	2600	1	CkpZZbs1vRDVzcjL782TvdUWiVHjvvoPNob2m879BQjxvSiu7JweB
5706	fee_transfer	1693	25000000	1	CkpaG6ggHkZ4kSE7pntCaosv9M2EQTrwgu7kD8Jfi616MfgdPuh5N
5707	fee_transfer	1613	49000000	1	CkpYi9Yi9Q4Mtg6vrEfUpGnztqqh6u3P8mVbAN1F4wWLyChLwoPGQ
5712	fee_transfer	1694	320000000	1	CkpZBwMv8RNVYJRc4txtX6kbWtC9UuD3c3KTeg9uC4aLHoKLNLibM
5713	fee_transfer	1694	84950000	1	CkpYhsuVcwpXX24uXD6fvN9BiQyik6ACP1EHKrV1Y3gqy6rq4A4f2
5714	fee_transfer	1536	41000000	1	CkpYoqWfSrAQ41gUuEDjhTmWRaPSsH27LJrVASsrNweZowhhJ3dXR
5715	fee_transfer	1691	82000000	1	CkpZ9WoPK7gHtuA9VQjgTvgrJDL7Jdy8VM4ubnGcgRFfALPqLPB22
5721	fee_transfer	606	144000000	1	CkpYtuT6wSezNaxRmmCem4VHELPf9TM3nG1dMSoqkjkHma8n923LR
5725	fee_transfer	1513	60000000	1	CkpZcZqTGcvfrYaJYsdaaXQP6R51cfZGukQR2d71E7snFt2sLdA7G
5731	fee_transfer	1690	72000000	1	CkpZTR5yRx152zhhMasPLEHaKyW85UPo8oBrLvfsDfVa4Bp6rTdB5
5733	fee_transfer	1680	82000000	1	CkpYiSEsa1jfFd8dCZC9xQZNaoW1AEvYNFEtWHFTeUNXKS7sNrDHi
5740	fee_transfer	1694	62000000	1	CkpZd5dxs41ifA6qvSgpaZHqWVEKvR6s8h2tmMF8vRjBCUCy6ro4m
5746	fee_transfer	1448	810000000	1	CkpZ2QAY32grzhAVXCbG8LWQ456ZqU7foSdHuWYLCdh4GeMGCDbMP
5747	fee_transfer	1448	440000000	1	CkpZB4Ayq4LG1DvhUr6SU3noqqxJGL4RisWRz97Hm8yo9Z6UUd67h
5748	fee_transfer	1422	24000000	1	CkpZ2ZVTNJGoY58Pgfjv4uWceYbAjfuAjkcw1fyivwsQRbLtCoUEQ
5750	fee_transfer	1439	32000000	1	CkpZYGNifMTBicNJNmSDMkuAVyz1Tz37ZGeEHEsARqDzQkfExwr4s
5756	fee_transfer	1706	45000000	1	CkpYjigby1MM1PHnmKmeskBSwMJLashK8CacxncXACKTFDpwNa9c1
5781	fee_transfer	1696	3000000	1	CkpZkgW8Kst4irRSJtJyZJqyBrBPo5FdyoQDid5QtN2ZSqMzqyVHj
5787	fee_transfer	1695	15000000	1	CkpYo4HWbzkjxrDw6UEK3SXhuzLE1BSfvg6hfE3CdjXGHS6fjSQ96
5795	fee_transfer	1759	92000000	1	CkpZ2MfQ8nmvYybkpV1ykWZWqcQeakUm6gsCoUPAvnEofBg6ozvtA
5797	fee_transfer	337	11000000	1	CkpZyrjxzjrJk7e6u8uJhDLdkvDrvD4zN4PiGVc2MBtwt3HtKDaWE
5806	fee_transfer	1688	32000000	1	CkpYU4eWen85fc3VooHRHdnbyrUGY19oYeMpzX7N1kXvssvpLiue7
5810	fee_transfer	632	1250000000	1	CkpZaL9S9o7BqL82EY8uysg5P9Djdyyf6RWtk8vfBq8hkjkHPd6sY
5811	fee_transfer	632	900000000	1	CkpZ1XvdeXjcRXWesAn2e2kUuF5bUFdx7airYjwT5x2zxcNGHK1ud
5814	fee_transfer	1690	87000000	1	CkpYnYWDfF8r5p2AK3pYHZSMdBXi5puew6hBk5YsLr3ybf8k12Jz5
5816	fee_transfer	606	41000000	1	CkpZiQ58aafjykdDEWXvtvRoGbYQeW44uhCcF67bUd52nrEc2t7op
5822	fee_transfer	1471	25000000	1	CkpYzKeGuj1SVV8vYWt9S5kCwYmpeWCuogtFBiaSWv1AiYLh8nSCJ
5827	fee_transfer	1768	135000000	1	CkpZn4ZzZdMD82oZZxc6QQbH9qqJo6RoZyntdFTpNn3uVN1mMTjKS
5835	fee_transfer	1684	32000000	1	Ckpa96wjAdh6mmjsoGow7YjRjhRMaf5bNPuM47jT1HReRETexLfPm
5836	fee_transfer	576	122000000	1	CkpZCpSf6kXwtdBeCzprow2pReiH76iDe95TRy18dYQFvTADU6pXd
5839	fee_transfer	1764	122000000	1	CkpZosGQTcYbYR3njJocTNS1jhCZiGVH2h2KgoSaZKjms159RxBw7
5841	fee_transfer	1717	15000000	1	CkpYiAfGvPHBkbp9GQr5WWJtWsUYPQRVgVGXUrMAvtJjtsqpdDWVJ
5846	fee_transfer_via_coinbase	1607	666000000000	1	CkpaCVLhbrBs5b6fqThuihj2aD3x5K8ZCZ68W1XKuTKLArTrA4eV5
5847	coinbase	1560	720000000000	1	CkpaGziiN2YEWaU7AWctHERGvfskHZAkDrZiSRtHeET1nuHAzWJRF
5857	fee_transfer	1850	63000000	1	CkpYw7YCJDDsd5yNyiEwq8Shp9GXCcHL4nwAs4ddRcWmasGrVs3EN
5864	fee_transfer	1395	163000000	1	Ckpa7j94DKAsrYGtsPUMcwNAMHmXRDn8nGx8tFuPCCoKqNZutjtM7
5867	fee_transfer	1547	180000000	1	CkpZAvLWhKaiADDMLpsovSAHpxNz6Up6bEywDXU73CTHK8Kk1h6y9
5872	fee_transfer	1439	347000000	1	CkpYdRN2qx4u8Vq5gkTUFNw5BupRvJVyFbTRGtNSeKXRaXeuArePB
5877	fee_transfer	1440	63000000	1	CkpZxQVeXmrZWN1HqfTSKhqDocWHTnkaBDc9UYLmbbd4xfn36ad7T
5880	fee_transfer	1395	43000000	1	CkpaKM9o3Kegi77DRbH8euRc7NNgyWJG9dbUaBjeX9bEW65od8TtA
5885	coinbase	2248	720000000000	1	CkpYgTWMHnyJRxr5ZhzLT6w4yesQGwbQxWfKaqAkUUHS3URNu1224
5886	fee_transfer	2248	240000000	1	CkpZwg3Q8uVtFrJNQdih9g5D7mqyjagEZ7UdEXiTUX95HvwyYa9wf
5906	fee_transfer	1689	24000000	1	Ckpa6atwkmW2kmu9BaRtqXcBP85pfzYNWXw11Mj23K5t8j6bkKZTj
5908	fee_transfer	1395	54000000	1	Ckpa5RebHDY8q2nSAcDar2KdV7Kj3C8s7E1cnQBcGAY4CmHnY6Hpp
5914	fee_transfer	1992	46000000	1	CkpYfS2J35SCSzV5rFXb2S9KEqzMrgjdPUvqjxf2zLxrwA3SYZge3
5613	fee_transfer	1681	106000000	1	CkpZ7cvU2f66RtRF6QN7WpDnfQjBgAAD5rpRu15AXW53uS4iCnPmD
5615	fee_transfer	606	65000000	1	CkpZBDWBUQ2vM6qeztGUEcZUYwzBNqzpUv3sNaP2cQ1yJPNjGcoPu
5623	fee_transfer	1395	137000000	1	CkpZJcaeGDdqp4DNYU1X3bgRQUC1qhNJLJZuh9tHR8xHrCmdeFK9Y
5630	fee_transfer	1573	33000000	1	CkpYsxngCjypcFUcaFomejBRBs2P9iD4Y9sK56ebfVAuQHRocqJEw
5640	fee_transfer	1688	48000000	1	CkpZ2xC5SeQckK9rSBn5bp575cMe3aJw3QjQqEzaTa69QXyKF3PaS
5641	fee_transfer	1444	78000000	1	CkpZQq5Lw3KCLM47MRL2VTx5xrDr4aYdjBcJtK9qFkeowzLuq5kmi
5647	fee_transfer	606	78000000	1	CkpZY24JHcgEnr3GdRw1xTLUeXENWPoEtBGpGqz9uELdEvqcjoM2q
5649	fee_transfer	1672	1798002	1	CkpZCKwKd8uX7nYr9eS1vKCy52LeeqiXBXMjUfVCR9EWfZurZ3ymM
5650	fee_transfer	2221	100000	1	Ckpa268bwoN3fsGH37PeRKWPuCGMTHdtYJjh9kx4otqBDmBD1Yg4q
5651	fee_transfer	2097	1998	1	CkpYuzG8Ux6DE7H15jSgdPmD3xDdDP2Z2yu1ZDsmiDHwBkxHavnQ7
5653	fee_transfer_via_coinbase	1447	1000000000	1	CkpYtpPvuaQC8Tph13ph8fLfeqW5dW1u3YtVLjGFYeLaQrfpczM42
5654	coinbase	641	720000000000	1	CkpaDw86B5iNHABFs9o1LqKi95PfNfxfFDL3obXNWhsVDJpGXXJES
5655	fee_transfer	1850	13000000	1	CkpaGaAUEkRJRJhZnjVffm9md9P5qL6YGyhv7X12VpxrSa7yZcRnj
5661	fee_transfer	1694	1170000000	1	CkpYY2AhiXnGGZsqMbVBroP6x3oYwKtgkM4jh5PCtka5DopZt6cUi
5662	fee_transfer	1694	270000000	1	CkpYnXLHwnLoJP6wQ24CyeNAUHf1F7ckdZ5YeVete6Te5PXPDfDSU
5672	fee_transfer	1419	63000000	1	CkpYwATSmcPvBpWJKrpQD7UfEvty5dMJJXaV2eN8WfN3mgAvy3ABX
5676	fee_transfer	1489	16000000	1	CkpZtmo5iwdhr1n4Skc5nMMBz54XRWs2NSrBWDdkbzEbwhMeiqKpk
5678	fee_transfer	337	3000000	1	CkpYSNf65gfQA9ASN51hKFqEeHBKT3bvki9zPA2LuWAGXRtkKnXRk
5682	fee_transfer	1546	135000000	1	CkpYkp1JQjtxBaP893uscmkpHWE3ZetX91ZRvWS3wc3wo4Ee1551P
5688	fee_transfer	1759	22000000	1	CkpZm8ktuLfheghKnWcrVQCMYuaazbmCaRgMEY5e8aH2VyZjwA5tz
5689	fee_transfer	1439	13000000	1	CkpZhJozaT3EwLawK8dojhJvEui1weje6Msfumed8nr7t1rbQaQzD
5693	fee_transfer	1556	154000000	1	CkpZPbK19JRQsrLkdXENTuRekoZNXXrEVncGVy1f5oPPJsP2TnrUo
5695	fee_transfer	1489	36000000	1	Ckpa9EK3nZND6M3327J1KE6Kmi5ZNpLHFANqG7byJVEtLWjy7DfMS
5701	coinbase	1546	720000000000	1	Ckpa3yCrvBbi4oxJyXXDSnX237Lqnk399D9hBswxJP9qB27Fp18Di
5702	fee_transfer	1546	5996000	1	CkpZZJCYyuoFKvxdNM8Gd2otfQyiGxvKhr4XUdTuJiWBG9mwCrY3X
5703	fee_transfer	1855	4000	1	CkpZDhrT8ufDKK1ecm3ZNtSTQ6REQUnaZdDqx6mxfouNmY4KmHnFu
5708	fee_transfer	149	49000000	1	CkpZt3rgV2MrWHPt19AWZpffLqCk1y3VHDWybRgtaakzMnC2Tqi9N
5709	fee_transfer	2086	140000000	1	CkpYno5zUvQdSVuakmEZK9tQqpSZvQdzGDF5u5v8WQMJo2Fg5awi7
5710	fee_transfer	2086	117000000	1	CkpZJNuc3B47LftfMJfCEhb5R88kLpPq5rEv5S2NeEyZ851VHK7s5
5717	fee_transfer	555	62000000	1	CkpYk7YjVyy1uBMpPk9MQmBvyN6EMarK2K6axoPmh5kYPh4SnirBt
5724	fee_transfer	1759	144000000	1	CkpYb5M1wyQ16djp5HRCwWuonfANe5LSnruG2oc4i1FUu3MG4GxXf
5726	fee_transfer	212	10000	1	Ckpa3LrgFhxpxKfM6Au25zWqmFBkN7hVrUJD6XbmYeV2yeSuym181
5727	fee_transfer	1601	71990000	1	CkpYnQdp3jHeWkBttbexEo8UdLpGNyhKPpY5j9zidQXo4Qxq1EMcD
5729	fee_transfer	2086	73000000	1	CkpZyCiacfsdKw4yrJ8f9p9YnKq66cR5bL6vz7kEybXcxSRDTd9Mw
5734	fee_transfer	58	82000000	1	CkpYmhMvfgG2w6znkqF24Um7hVuLfTMFWXe71G1uqSfPvBfXKM2n5
5738	fee_transfer	1680	61000000	1	CkpZiJ6YVopga6AoQ3YmGpXGcwVHTAJPKBd1mVAWeDqpvz9SacfsP
5741	fee_transfer	1564	62000000	1	CkpZ1T5qQZoXtcdgm4fLWgk5YhY4EefDMh73QHfzEnP83yGwNkJHz
5742	fee_transfer	1694	490000000	1	CkpaCSp4YSci4KaeBgjmMrWESr3FN9XbecBTyrAVzUhY1uPTGqe1j
5743	fee_transfer	1694	481000000	1	CkpZQw5mr531q4SnvfuoeSiGAJp23zZp6Askpu3Dwzo4h7rQQPZcS
5745	fee_transfer	1701	134000000	1	CkpZzW7QC5h5YsbF1UR58q8tPweF5pocQebS9xhtSmu5yS6z5UiVn
5754	fee_transfer	1719	1090000000	1	Ckpa8k6LwpCYTHfZGR1zp6jMGWuxJAynXSSBPfAxQfhnDZrHMgjNy
5755	fee_transfer	1719	160000000	1	CkpYoxkjTzZ9VxMoaJcjMc6euX7oDFvmJtLkwzwRqwSXSaC5SQDU6
5758	fee_transfer	641	48000000	1	CkpZUz6JL6epEV19qVb2sq8vTdqR36QwXCu1nPmErvw2R793QoJHP
5762	fee_transfer	1991	19000000	1	CkpZ7SkFqnNQWyNJJ5ZUfXunrevS8yMGuB6q4Ga2Z1UUCAQMvsxLU
5763	fee_transfer	641	19000000	1	CkpYnb9NZL6nQUHcJp5EUKjgJquzyVEqQVXfFQVXuzBBxfrsbxqbE
5769	fee_transfer	1605	11000000	1	CkpYyL9RkxYfboGrm3JgxtZomMMCCADFZA6GfgC7mDKoyXeobdHHu
5770	fee_transfer	1605	12000000	1	CkpYhZ37uH3rT3SoqeNkHhYKyEGyE44BMN6wNc8pxxDGEEcz2ZnwZ
5775	fee_transfer	1467	46000000	1	CkpZq1rzUpfwj8WabKpe2HQgyV2MxnUMuxvyxmkvP8fPzWnrzFagJ
5778	fee_transfer	243	12000000	1	CkpZaERWfkSqsmFewT9QYN2uPanURA2xxuvmiMNE2vJsnvskvRad1
5782	fee_transfer	1423	3000000	1	CkpZJpKtE7QW1iwqeLrKYHKR1ivv3AFm9ca1iqzDs2nehkRhC4phP
5784	fee_transfer	1724	25000000	1	CkpYkamnZ376HE1mtYP99We8qXDodCBdbBfHvADEPnFGgU68PYCQy
5791	fee_transfer	1440	1996004	1	CkpZaPF68eH8cnnQuBhqSTHPGZyTbmLW6o1PHZ9e86pSReZmwcBRv
5792	fee_transfer	2097	3996	1	CkpZTLvNUKYwtkj5G1BpoFp8GpSqCseEsTFXjvhbw7bfnYvdbM8hT
5796	fee_transfer	1764	92000000	1	CkpZK6MoZRWnqJ7Agi5pmDDNaAF3SANyaA2CEBwSC2VnZKyXMgxwE
5800	fee_transfer	1688	65000000	1	CkpZbcEve36jzsr2fqWKubHyurRJ8Aij3AvtijAZAWMgeRcz7dby2
5802	fee_transfer	58	37000000	1	CkpZKNgoSfGNW8qSBwzSBbm5RNGFGsK2SP7znzqwtgPupxfpe1evn
5805	fee_transfer	606	112000000	1	CkpaAC2CJhJJdqKYF8RnrtCTVmfybndX3ddRAcYKYaAJ1kLB7N9Qu
5807	fee_transfer	1670	34000000	1	CkpYksqSuDuHG7X2cf3EDRmdwkBLPotW4nK4mUjREdsBh6ufSyCTC
5809	fee_transfer	641	582000000	1	CkpZUWd2MUwx6CFxHYtnoEbNqN5FQBrAdN51QzAZojkPZCbdxTcpA
5817	fee_transfer	1547	1120000000	1	CkpYiWkuhSwKoCm6zCZY5LjTgCGWJKqiUYPgoF9QdxHmG9PUFyw3X
5818	fee_transfer	1547	1030000000	1	CkpZVMDGaCx3N8e1qYAQ5DaiAyxF6WUaNwnxsV1kn2gDcTUMtjpHN
5823	fee_transfer	1704	25000000	1	CkpZ38eaRZhRoyNa3QebJ21JD4kHg34bW29Zjcch3ARfGTuprtmp9
5833	fee_transfer	1692	113000000	1	CkpYxKSaLXzGCqEwLizFg36jhoTZv8jd5NGJKMgisJo1BjwbZDiVZ
5842	fee_transfer	1457	28000000	1	CkpZCSsvJm16cPZ7VEytrFgygTDtk26pyE6owRLibaNtc1KZFeDyb
5845	fee_transfer	171	222000000	1	CkpZFV6SxRKWsPhE281awMxHR88X58chPoAqYJDA3E2T9ZGcExHFR
5848	fee_transfer	1610	152000000	1	CkpaDHW82uWdJpGjki8JMHv7jgwTZKvMUBdEgbNBEK9nyD6MfxfhA
5849	fee_transfer	1681	280000000	1	CkpZPcEqVFekMLrofRHHJb1DcuYNuM5cvugYBccTR1FtsWCqgGcLN
5850	fee_transfer	1692	42000000	1	CkpYiY73Z7M6sEa8yFZM832K9k6WgpVmSu9ZU9ip6ee8NRiAunYMc
5858	fee_transfer	1489	63000000	1	CkpYrs5rBJGidZtyJqx2a7VQwMiAfBYg4hteAYDUEoy8hiqkKtEi3
5859	fee_transfer	1692	102000000	1	CkpYacyNL9p6F332X1E95nJWGMvS18dSQhxhju9uLkaQT8t2Fb7XH
5621	fee_transfer	1637	63000000	1	CkpYoFA7kH2FGqLu79JrBFm588CYurueR4hkZwwuzhENDJmZyW372
5624	fee_transfer	1719	137000000	1	CkpZcBnoJ4TTqQn6LuV6AKi1AbETjSJwDcCgqLr5TyWVxFKsYE6g8
5626	fee_transfer	1692	137000000	1	CkpZ9MjTJWs2STcSBkYeN8jWekFtf76ZFStpJxrqsw3Aedj8Ebm9U
5633	fee_transfer	1588	28000000	1	CkpZxqBSSqpRzXPabRwrqoHbjEeCrKck7J17Cgmy3rimyDGSutXp7
5642	fee_transfer	1444	151000000	1	Ckpa6Nx6h7KSTPqxNXBnTVCgRYhr1JsogMAy4MhL1AWpBsQsifDwo
5643	fee_transfer_via_coinbase	1758	100000	1	CkpZLXnwXYPZwEZB8fV4yyEbm7XojvBEBuQzoR9wmqNJJGPBttLut
5644	coinbase	1444	720000000000	1	CkpZD9i9uBU3ZpMSzRzoheyREmiRtyC36EHFEvjPJqzPrWEPP5QLa
5652	fee_transfer	1992	25000000	1	CkpaC949Jd4AgF8e951pBibFjdsz5zbiEWD231yqPkgV1HirmxbWw
5659	fee_transfer	733	13000000	1	CkpZCe3JdyiuzREd1wD2uwyN6dTHNMr722rE5Syfmn61cBsuDBkE6
5663	fee_transfer_via_coinbase	2150	100000	1	CkpZSovpQUkWNSZhPu9pTr3nGhHgFa9Hswd5ecR5YDZdgRRLHBC6w
5664	coinbase	1762	720000000000	1	CkpaBBChHAjoVDEMiHrDqo4HxkDcHRMy9WpiVBNiQV3QoGV4mF2om
5665	fee_transfer	289	200000000	1	CkpZVchTKiUXsX2RY5Q3mPoD7725vUpp7StnVq2M6N15EKao2gocD
5669	fee_transfer_via_coinbase	176	100000000	1	CkpZ4m856YJwhBA7ZXoPYkuJkAnN6dCAxaED63CDpUHv5aAcZx9ky
5670	coinbase	1271	720000000000	1	CkpZiqEmXxb94UJWUZxQ1SV9suKNiePX2TeEUY93ZuZkHMrnJLemg
5675	fee_transfer	1701	38000000	1	CkpZ5UB5cpDhjDZ8SuQqwzh1YcWaotCAsNCteHnR3yRM3cnmfqkaS
5680	fee_transfer	2039	17000000	1	CkpaB63XLLHBWxHyHRpfEj3kfSt6n7782UvddTzHnuSH52GDnf6dj
5686	fee_transfer	1451	950000000	1	CkpaHpyJi7JXNrgTEcb5E9i3BFeqKbZHPbhESwVQw9eMb4Q4gpa2x
5687	fee_transfer	1451	93000000	1	CkpYrG33AJcxfk4on3P9XrGWsVDCaSJsvowG8yWraQAqx9MrmEgdi
5711	fee_transfer	1560	25000000	1	CkpaDwtpKJ99Hmcc7tnffxgCSmeP8KU348QjFBfZ6ATQtfqPfxsb4
5718	fee_transfer	1690	62000000	1	CkpYqFN5SVUzeNaDMbEU5buLxveg2EFc399FKo5qeak55pL3HFvX2
5720	fee_transfer	1395	144000000	1	CkpZP69DvDJbE6NXS77UgnBUEcd9RRjLpuL87fMQdQwhhbWXhQGpR
5723	fee_transfer	1394	144000000	1	Ckpa5Xgz6CcDEzRvLuUz6Lx4ou3nzL9tbUGPfpbawS4qLB6jwmEKB
5730	fee_transfer	1699	72000000	1	CkpYQvmB4pnFPVi3c4d7CAwUfSew81Xbt134xBquhZ6bNwNgxhw5v
5732	fee_transfer	2087	62000000	1	CkpYRzWhSdTbuzNTGPHwqSWps1XrCJxfaFDfjonDsamXZFbwyfLtW
5737	fee_transfer	1601	82000000	1	CkpZYcUQiARRGvKATzcqY7bP37s5cHV9ruDRcqNQN1iF8fgv9Ph7p
5739	fee_transfer	1768	62000000	1	CkpZfRnKMwNkd4zHryLK8SVoqGEGmqkrdksSVNt3zBY2tCgeCt3ut
5749	fee_transfer	1458	32000000	1	CkpZzafDogvqYtoUwsBMBMyPGGzMdNE4wof9WXZQHHEyrDY7Q4mHz
5757	fee_transfer	641	951000000	1	CkpZzrSvk5yrQAdWqfQ7CXMPDkwg3SaqTyEWm4PjYArjBubewR6bX
5759	fee_transfer	1271	14000000	1	CkpZTqW1gA88q4y59Qu9f5FdxLhWMrmfgfprx17CPbCw6k8ppNUzz
5768	fee_transfer	1458	25000000	1	CkpZ9ZntfA2aSWVDmH9t5M7Tws9oa3Bf43CfhncP7vkpRmE3C3ZQ4
5772	fee_transfer	2086	413000000	1	CkpYeCJrV4NVtcsvLWQJQjHNe4jr5L6UdSA1VTPTY8Sh77pycGbMt
5774	fee_transfer	2087	413000000	1	CkpYdGhbixDCCLWzQtvPmzuKDQLBNmjuXKmPHHxXU5eMrUUu547PC
5779	fee_transfer	1698	34000000	1	CkpaGTB9yKR4mLm7uCq8jVGRQW5LTQui84Efj5JcgHT6h2ziB3ocC
5783	fee_transfer	1663	12000000	1	CkpZAUr9BkicwxrCJhCiDAJ4BV1qJdfpvFfyvoCdvnRnHpxdsewPn
5785	fee_transfer	1724	610000000	1	CkpZEA6kMZAyE5cf7hg4EBDMR8TWEYRpaZkuZbS5gtTgiQcxhEed8
5786	fee_transfer	1992	15000000	1	CkpaKZuAfcTaVZYWnzb2mmsGGYHzsqgPR5p2mKahtqsuYtgo7SxNP
5788	fee_transfer	1670	24000000	1	CkpZ8AMqEF5owsdn4v6ZHFZ2LRGfNxuBRL75AxiQqwNUbcUQsUGgx
5793	fee_transfer	1394	21500000	1	CkpZW5RpXQ4nK8QnKL8HKc7ie7m79exYgCSR38nRFiUT23DjufoBU
5794	fee_transfer	1471	92000000	1	CkpZPCwDeuwsWUUjLVdF8S1DQVNkcF5g9a8Kk7EPmfBT8WqS4T1hi
5799	fee_transfer	1560	555000000	1	CkpYzjNF7FgVZMQvtjuvvUvaFMLsHknLaKr6VzN38VDzbrM48bXhZ
5804	fee_transfer	1471	213000000	1	CkpZnmrpKycJhWTVBU4PLv3AqXvHDQgF5jr5RRM1weSaUSk8GqTZJ
5812	fee_transfer	1719	25000000	1	CkpZPWtdrTVQ7Emjofno7eBFMdRRe6ziqo3fLhF5yD17iSsdUFV2L
5819	fee_transfer	1560	550000000	1	CkpYrzQqoSEgGzMZKFhKR79cAnKug6aLaZ8AfEpe5Mza9YYM5UjEs
5821	fee_transfer	1746	25000000	1	CkpZz7ZE9MszCqqAahCyExhw9CBhE4jegmkEvtu8s5KqEN5oGGtrc
5825	fee_transfer	1680	35990000	1	CkpYiTmbVbP2F8Z9KCPi7s4poTrqqmkWKFAZSaTLZ5oqiyAuXxTpe
5826	fee_transfer	1768	138000000	1	CkpYbT6hXxQ3tU6pL3UqTAuGR4PRbsEvL6WsGhTJdeWjshZYXkYyT
5829	fee_transfer	1513	122000000	1	CkpZrhCsQVPp6frC5vWKfNCYpNiJhiLzuUMjrTPPvVpSN67w23ZfA
5831	fee_transfer	1675	591000000	1	CkpYkye1YQmKEcifnJbYgNcCwuN31jHqo1hoirWdcxgyzgFx2Mmmt
5832	fee_transfer	1675	34000000	1	CkpYjS5HQAkTQ6XVQ1EZGxT2ngUM47VMRKTSEozMUbhy7rmT8HMYx
5834	fee_transfer	1679	32000000	1	CkpaBXpEVjwy7p9EeYQhB4hoRL5zB2i5b8UMNagaWRtevj2qzzKym
5838	fee_transfer	1764	112000000	1	CkpYXv1A6xVfK67hzwUtVczYW4nznCuS22MZqzoS6UDz4JMDibd1i
5840	fee_transfer	1740	155000000	1	CkpYRJjuMKEPH8fTEhhec3nVrZJVRsacV6tjwV6MdijnfVLzQa5kA
5844	fee_transfer	1588	222000000	1	CkpZceMY8KVqVhpeqpiG7tHYMc7UxRgh1RLCzqsxX2e2HxUMzZffS
5852	fee_transfer	1756	21000000	1	CkpZpYx59amAYjyCqx4mBYC1DZVibdG9oHCfXEpgDEEXrGge2FAbZ
5853	fee_transfer	1688	52000000	1	CkpaEpezPfspGcHNhoZJ8BLHBeq4gEEE71XDc9uAWEW1Qdui4Zy8B
5855	fee_transfer	212	60000	1	CkpZFiR5pcRU3Ym4oRYGio9jut1MtFEtD5FGEx8k7Hahrv3wDAzMD
5856	fee_transfer	1850	61949999	1	CkpZBcvSW2idwf6i7kRCLbPyTGghnHh64jyJdGW2pXJHRjJCw9A5d
5861	fee_transfer	1573	112000000	1	Ckpa7usMp3qnVkEQ3LyX6YtWDnnqyCx8DeEhgSCd9BwkSW9GuLFkk
5866	fee_transfer	1547	134000000	1	CkpZdMX4nEpFU2wj34JSSx9WKYAzduun73cJuDY2UKNGfWMyjrXpv
5871	fee_transfer	1602	347000000	1	Ckpa4F76cFJDRrBK8KK9X7ow6xiT3efepeKe3iUycYqYxy4ss4Rtw
5874	fee_transfer	1394	74000000	1	CkpZFQKbFSjaWkZGA4Y7b9TzEqmzcgYg1awBXFV8ztryKaFzrS6m3
5876	fee_transfer	1395	63000000	1	CkpZ2Ste5XKGg2txYBoKUMGRgnGZaNJvPdAfGi8muTp4kyVetinY3
5878	fee_transfer	1759	73000000	1	CkpZYgq8vDHff57jubvAQJQdRKMPx3DoYfJbyqgxwbzgmvgmbZEJA
5884	fee_transfer	1643	125000000	1	Ckpa3tVvYtvVhMENVraJVSUJqNQ9kvNvsA7cQsZo3v65o9nJHzn2B
5898	fee_transfer	1637	46000000	1	CkpZK8fJTx6JUnQy6hNoabzbkFuGaNyBgrSYF5jRxLw4HQrR3WGeN
5899	fee_transfer	1394	232000000	1	CkpZRKJJ8QstiPFtU567JMjgau8x1iVxBLtC7fcdXDxyazNNAqRLW
5902	fee_transfer	1395	132000000	1	CkpZVSvBHvUbSQDM62FBxc3wtfAkRhAyHSZjgnADyKn2BLPD2Ei8F
5903	fee_transfer	1714	132000000	1	CkpaBvFPyuUkqwTNX5TXFuy5Q9KWepytyYirr8D15y16PrfQLNhQG
5905	fee_transfer	1499	12000000	1	CkpZwEEm64AjzAT98jb4PAaXD6FNbFQMgWc5tafiRWs1MBq6opip6
5907	fee_transfer	1717	54000000	1	CkpYopnDY9jzwWKCjiJVpAWEw3AoePSBib51tTfsxa9B16fccvASu
5862	fee_transfer	1571	402000000	1	CkpYbNBmX37pX8K3j4q4k7Rvjd5QsvwUnCxZdpP78CSQhGNSxYR8L
5868	fee_transfer	1476	134000000	1	Ckpa1ZmKHubauCvSCpGVDZnmF2bMQ1xgw89Rxhyj5H51r1qHKN9Gy
5869	fee_transfer	1691	5000000	1	CkpZiidAtrkAHqHKnwob7hWysKPD1LydBkm63qqfm9dzH3TanRpEN
5875	fee_transfer	1991	63000000	1	CkpZYG53E3aotQSzLiMbTgb2bKRNoshCLFFMoGDgdsmWCiyACiPWb
5881	fee_transfer_via_coinbase	1886	400000000000	1	Ckpa9y3wS2jGqkagkW8xRzi5Mk8Q2g3qb44miMNBodFABdqVAgFrb
5882	coinbase	1724	720000000000	1	Ckpa8vsnMvJHb4HbC9NcQg4WYYTgQR2vUVnW6MkuTt8VuDC4AxykM
5883	fee_transfer	1394	125000000	1	CkpZjbadjAELj1CxzpQ9QLMq9mAGzjkZjVoBuA29PuRFnXZSacX2p
5887	coinbase	1659	720000000000	1	CkpYT8LCh2HnJy3mpzw6frceXCEKjvaxziBS6H6aD3vjtuuKqLdHb
5888	fee_transfer	2126	50000006	1	CkpaAX4joFywNHwhxKw32KBzwu3bz4Pmg8rUmdCYJKKRYSeNFVS6A
5889	fee_transfer	1807	3	1	CkpZ6vEEtyuoztq9Aa9YG27BP3msZJzcEYKgFEeuYjzM7gKUAhf9L
5890	fee_transfer	1659	83999990	1	CkpZVpdpp4M5RxKYcKwAjCcH9KBaYgCQNb7TmSva3dAVBHSLx83kr
5894	fee_transfer	1422	42000000	1	CkpZRTVRv1VLDff9kQLxURD429LPcFBF7aQBNEcQnMYZFFEV7nqHB
5896	fee_transfer	1671	46000000	1	CkpYfjq9noJGCcCGqA98BxpURFmZCm24uTNVTMZ7ZuPCWM8BFpNpP
5900	fee_transfer	1394	242000000	1	CkpZTyH8ppPZmsvyWpo1u9ZjXzyLCWtWZ561QPKcNrD3FTySjAyn6
5904	fee_transfer	1714	1300000000	1	CkpYaN9V9g3wrqQbJWkcn1YgybBfEYGsPzZ5Zr3gFCAVKfP9FbgSS
5911	fee_transfer	1693	76000000	1	CkpYkSDi5ThKoytsX87nJgqZr2KjeBn5U86sqEFhFr1vZKyzYRoh3
5915	fee_transfer	1768	5000000	1	CkpZQ5FBAiNnY333inC6E6uE5SAAVqeHnmNACBipVw5KB1273u4UF
5923	fee_transfer	1549	33000000	1	CkpYYzj8GEstMib8ysTnXi7tR1mhgRXzwyabE3jsbYj8UXsHWS6Q5
5935	fee_transfer	1705	13000000	1	CkpZs7ghYTx5qDttLuaAEXMt7kABkc6eFg921qVfHi4JADjWMGwcs
5939	fee_transfer	1943	24000000	1	CkpZpAXUHqUcyC7d4Hh4ALkPJtNRYUswxzsbbXkSrKYrMZfv3SA7Z
5948	fee_transfer	1448	25000000	1	Ckpa8yxKXAhymGc1119Da3taykvitbLNvpdzRBc4JZzZgJSkDWZGj
5951	fee_transfer	1601	25000000	1	CkpZdgCCdpfkpRin5Vca4FjFf9kM9BToSZYz2Vbuni3Jqy9QqxZmd
5958	fee_transfer	1762	15000000	1	CkpZjcXz5LC1gQksuX7QnfHrTHayEZFTraNjodxtN6EpqAuDXmAuK
5959	fee_transfer	149	137000000	1	CkpYWW5c9y7se5Ji6rH2vHNxvqL9tDTNvuvhdk1PZ54a2ELCYWWYo
5961	fee_transfer	1395	499995	1	CkpYQPhfGGeKFcPrTj4XshZmGQ5uC2eGtVKDJrcuMjnHAVF8jnUX2
5962	fee_transfer	1520	5	1	CkpZf2SP8GZevWU79PDktWZg8kz6wyUTBnkspe3YnzyCY44rKDb1g
5963	fee_transfer	1509	1500000	1	CkpZV1HsX3KoPPBkfyW4dTbS8rqJfpd9giWfNiaKRA5RxaWDXQqFR
5965	fee_transfer	55	24000000	1	CkpZBN3vB9cTbEiXkPQgagXw592cFZ3yJKeV37FoRazxvypWn78aN
5969	fee_transfer	1739	27000000	1	CkpYchWiEqB881Chpks61suxGcnZRAooyJBzuKMfNc7sertBepHhU
5982	fee_transfer	2148	15000000	1	CkpZJGvdobAYP3bYmivAgvQ2hwwEKHZauBB1UxEuvUmNnGKv1vr8r
5984	fee_transfer	1396	43000000	1	CkpaGw1rqtonUXd86rV1ccxdT7tXos79dLDDRvkUPMjMxYe3KTQVP
5988	fee_transfer	526	24000000	1	CkpYTCsvesSn82aSwSz6AcoA2TKKc6njAHp7f39vvL39gLjMdispS
5991	fee_transfer	1709	26000000	1	Ckpa8Cu5iYr3cieCcWXGJB9Rx7q93uBwNEwUPLnMpogudQRqrmfad
5993	fee_transfer	1693	14000000	1	CkpaBU1ro3rKW4ZxiTmv1ne2Wuqww7QHTQ6PY3d4BZwQfdeJ9fkEm
6002	fee_transfer	633	165000000	1	CkpZLLRnxA2U3LvJkcNFnumwmzCwZkwftXunNxZqL6TRwUv7kHSpC
6004	fee_transfer	1451	178000000	1	CkpaDWqJyUYXoJrMSDLW4x7XbfXybgCgJG4BJ5tEkEd5eqE4Pd6XM
6008	fee_transfer	1675	240000000	1	Ckpa279ziEELGB4mjLMnK5deqSQWk5kp3thbYTd2sdo3ox8yXC6QN
6009	fee_transfer	1675	1050000000	1	CkpaGqrtSx1BWarUrs8RmcHojFyWJ1FQHjTrtaAhbZainPfL98Nxh
6011	fee_transfer	1394	56000000	1	Ckpa9aWoToDM4UERs5o3gP17wc9VR4xJHPhQtJXRjbXDz45USSD9P
6013	fee_transfer	576	24000000	1	CkpZUyVb3tYCd7VGtG7BBd53Cmn11PJDdFG1eGfiVhQzNb9NZjNi6
6015	fee_transfer	1685	35000000	1	CkpZdm9czyHow6PE8M74AhAvugBrzYJTZA6t6PPtnULd38kLZDMJz
6016	fee_transfer	1634	32000000	1	CkpZwcFD3sQdrjo5bBFiNrahN72JYTyDt7tG5pQcAzxtic7Cqz993
6017	fee_transfer	1756	52000000	1	CkpZtd6ao3mMfNLhwem3mZEkrtWauaucgbtaGKbKyJK3jiB9AZ4ga
6031	fee_transfer	1394	113000000	1	CkpYzpsyi4CaPX1RXamcUPPZzs9T6kd3ZPA5uVhTFnJ3AMd1CFhLM
6035	fee_transfer	1422	35000000	1	CkpZGPeVMt54XBnSKdbi5koECxts9aZtj8CN1XgqXVLxsK4WzqMsP
6042	fee_transfer	1455	112000000	1	Ckpa5dcWHMqa1Hp4ZYwZaWfZ9YAyqbL1995WWZyUuQevFpX7jGaCV
6046	fee_transfer	1419	740000000	1	CkpZdbKYGeytPZ7aYUw7Uz9jfqeLwsBHWXjrV2JVNZErKEXWxStSS
6047	fee_transfer	1419	196000000	1	CkpZsJ6RSFut7y17m8YEYnxeRK8fe9hnT3GQukPgENrzU1ERA1pHd
6050	fee_transfer	606	82000000	1	CkpZnjniyafe61FAUPHRPY5WNKQ3AJbSQXo24dSeMgSD9rzL7q59M
6053	fee_transfer	1458	22000000	1	CkpZNd75NRU6KB42tJmZrka8tBStUn2e4jxkooQ6iyfY9bF94qj7A
6056	fee_transfer	1673	37000000	1	CkpZV8cVvJgJzmR5kZhZNAu9pERshDZZHVbLqNhufKsnHK3iF42Bn
6058	fee_transfer	1555	16000000	1	CkpaDKbaFeuF71ADCUTyy2v72N244XYobvN4LtecMiFncWYdZ91rW
6059	fee_transfer	1698	5000000	1	CkpZwfDKWKcdxdMfg1XmEikV1CktCn3XW6ZTVogP5zKai3Kn6Ue9J
6081	fee_transfer	1918	111000000	1	CkpYdyX1Bt3MTszgUN2Enfacm7bj5cbKHpVDKGA6wgH1PER5WJAXg
6082	fee_transfer	1918	11000000	1	CkpYXZkCZK1JVGUro5C1q7gcUukemnq75iBHFd4o715zvWoj53dSQ
6088	fee_transfer	1693	372000000	1	CkpZxjZFR2c333Qw2gWvMg9eTHmtfNvfCsCpH8Un5BBrdYeSZ5uSt
6094	fee_transfer	1474	35000000	1	CkpaHDWMufoWofbH9LZQJjvMGvGjyBs9iPhjvrDjJdumdzPhtWQZD
6102	fee_transfer	2106	37000000	1	CkpZvw9iFd3Hc2jFaeFvUJs3hsNVsXzKwtcqre5PR7XwgfSH3Qgyj
6105	fee_transfer	1613	64000000	1	CkpZxCQgVQ2C6xw3PxPjTZpQGFU9T7QfzoLoD9iv4T9CtWHdAQwgV
6106	fee_transfer	1705	43000000	1	CkpYzVtrZuymvvjWXJmeqLgfvKoWiANQCEVaYfnEc4g8Y4rnkEYfZ
6111	fee_transfer	1506	42000000	1	CkpYoejugSjiVuHDBY1M3Yx7C4cSeZPDt8nM4W4ynpJCrwPvGzj3h
6115	fee_transfer	1536	14000000	1	CkpZcH8UqRP4sd3QzYPZCX815Z6bJ6ev3cTb5fwdKcntAbyY5zHCS
6117	fee_transfer	1638	717000000	1	CkpYRtjoRnBkPihK8tgYNXuH1s9DrCS98Y767rfio9Jw6mncqLyc4
6126	fee_transfer	1638	174000000	1	CkpZ9JGNwWchnCA9XvaDiCaXzVFDfMkLRC8bYm1qXtkXQzDWMqRAE
6130	fee_transfer	1439	21000000	1	CkpYzcePMm43HgHuaxm43Ap8NxMmJ74gRs2B8iU74cev9stPd3gBp
6134	fee_transfer	1474	183000000	1	CkpZpJGVHzvXCEYYfNM7cykBaiEbhLCaV8ywjDErMDSgveEFxpkk4
6138	fee_transfer	1549	42000000	1	CkpZeEKWwMJzgUJFbx4WwhBkLkuEAqX1MEy7ch3L4j4Rovix835Yy
6140	fee_transfer	1508	1090000000	1	CkpZqQeQjC4MjcDLN45Av4Fb7xvU3GFZb7c6fvABSBMVBBJun5CPc
6141	coinbase	1508	720000000000	1	CkpZud4kbj5KW9xzSQT9b3fvCufyGSfayYqfYD9kpPFiMY6yDpCBU
6149	coinbase	1574	720000000000	1	CkpZySTFHBbfotXnk69HCrS5DBicL563rLwbr9CRfVgA22mSg4eTN
5893	fee_transfer	212	30000	1	CkpZb12nSyhEqtJiVvStWNnooj7kaYcjLdjJrWZ2gDk95d9ewgVS2
5895	fee_transfer	1637	42000000	1	CkpZwfBZuKG3CMnKuaU1za68tQvkQ18vb4g2YKMkppMQMU1A6GAtc
5897	fee_transfer	1394	46000000	1	CkpYiPWUk9JojKiWiaGu9JxbjzEY6RFYDb4RRHbJvrCnnxDsMHuiQ
5901	fee_transfer	1440	132000000	1	CkpZQKgYi8xoyUzo2jWZ4qNPcCihhL7PQNEpNgZ56ARCDy3BtxBip
5912	fee_transfer	1602	76000000	1	CkpYckaxDeoRqfxhGkr2H8CxN1UiVMA7MGiDjEmLnYspXYwGXkQsm
5924	fee_transfer	1698	22000000	1	CkpZD2qL9TLDt9NoUdFMFwEfmdyvXewZqe6UBgcH8qVv4xzBrSjvz
5926	fee_transfer	2248	12000000	1	CkpaCNJBzYaPvw6U7bYttCP6J5nYdAhoqD5iJZ3gL141XNsY5Cx5k
5932	fee_transfer	1717	37000000	1	CkpaBEfSyCQaj5LyHpVYyc8o7PT9tmE276KW1dSZY8NZ51T82N7bX
5933	fee_transfer	1656	24000000	1	CkpYWBddbkaEKmCTdf15MpghMGwW4vDX9e4iaW29peq8tihBLsUZK
5954	fee_transfer	1681	47000000	1	CkpaH3o6m2CGoP43fSs9NXTFHKk1zabkygKUuivM6eMCm8hqAVxEC
5964	fee_transfer	1571	2000000	1	Ckpa5cEWNPTzTURjshLb8UM7fRDhAhC4Qw5Aax5ZpXYN5a9Pwewe1
5967	fee_transfer	1691	17000000	1	CkpYTuioahtJkm317UXm3bAL7Pgxn1eQh2RA7YZNR1b8LsrZqVxw8
5971	fee_transfer	1419	209000000	1	CkpZ9aT9uLue5YHy6uWxfREU4sRTsdCKZJo2bbYzPtUAeLLEtTopY
5972	fee_transfer	1509	53000000	1	CkpYk8dKfhU5vPk3VscdcvMKvJfH4pCuJVCUHySCPbnNEpyQTM4ik
5973	fee_transfer	1992	36000000	1	CkpYQYTfVnW9vrMqR5vvz2WjsG1PzXo6kU2dhTGBo8JFCZvc7sFNb
5979	fee_transfer	1698	48000000	1	CkpYvAMLtCFdvpWNJB7BdSm9QyePgmVotNkUHkNydZCAm4AY9oryU
5983	fee_transfer	1671	15000000	1	CkpZmj9gd766j2QsgpmFvPoReE5tLUHgNbUGhETjtGwAXDLQ1As57
5989	fee_transfer	1474	24000000	1	Ckpa6bgU5Erh6bvBtvp7f3ZTgit2bDXXN3f6Qbkf5HpLVCSPKhFhi
5995	fee_transfer	1540	20000000	1	CkpZt9mkg5aqnhWj6P5wbN26wrwdYTxgkNneVCyKR385ygciqVEAm
5996	fee_transfer	111	11000000	1	CkpYygwTqtpuguYurPcrB7tyhQfMyoy2FXdWhivodbqafCpz38C1G
5997	fee_transfer	2248	24000000	1	CkpZy9LwyNU1jnbgVEs4PWRJp1Yev61KBVTmRTCDuZngHY9xkYz33
6000	fee_transfer	1419	579000000	1	CkpYRA7r2NU5qxHnd4itPpRXqrvjDjtTRiUgk777KRyh4Lisqk34A
6001	fee_transfer	1419	59000000	1	CkpaCaZmNTAuhgdFeZ4evuy97qa2PzuLhZqWpcd9xUp6j4fFm526n
6006	fee_transfer	1476	4000000	1	CkpZrwMBAha7Y3AVVfMkHGHoVbXqbMg3xgHa7ouErGUxgBdCUTnaT
6007	fee_transfer	1681	36000000	1	CkpYaGuFQPeoZwWVFNaj64uPEmevnTze9og8HhESpYsxfMgJmYxt8
6012	fee_transfer	2086	56000000	1	CkpZDxh4aSV7iDxWQjYvXz2q7xjVdzUoDJhdhApJG9ouHYJtpzGfF
6018	fee_transfer	1657	52000000	1	CkpZDnHmLfq7nvEMMDbPVL77dtznMhVkU5cQGGxnShUd1ENiSMMrx
6022	fee_transfer	1444	25000000	1	CkpZHzgzko5u1FpjG2o24KzAGkZvPJP5SYj3PyTWsxoR4nbXwiZSq
6032	fee_transfer	526	2000000	1	CkpZJsHgvGy67AAYRfjoCn2YDySMPDrCXuJfkiSUyiY2Hka2d8xsD
6036	fee_transfer	606	35000000	1	CkpZj6JuJctT46upZUNcMJXtvjxLqPR8aQB1YSKC8CviWJxodZTD5
6038	fee_transfer	1700	15000000	1	CkpZped5rNf7h9dRaJCPiA2XEGFiqgcgYbQnpuvQpx7Y9sbqnaLCi
6043	fee_transfer	369	112000000	1	CkpaLHAxiaFmqYiZAdTuWy99TvgR3Uj8hLVfvkrUL1ZSMrRbVk3ec
6051	fee_transfer	2039	82000000	1	CkpZrAYRB1LpJsWLeyW3gRD39aA44i5b28fegPenwvBHTfExfzspY
6054	fee_transfer	389	33000000	1	CkpZCcztk2wZeTQwP1uAWNE9187Y5NYzJRUhpDHUfYqESEKASXakB
6055	fee_transfer	1593	719000000	1	CkpaKgX8ur1VhDoXVfUKBWXiaTb1esKH6dwR4cwqqX3z3zcWSqyAn
6060	fee_transfer	1698	158000000	1	CkpYYsDQ9k9YbGsCpqN3XZrbywnRfKy1cHNbZs3enmkGejozSM4Bi
6064	fee_transfer	1419	16000000	1	CkpZjRvbkcSCWYyQzH8Zp1gtHntJGkvtT3qyRRTsK25fbv1yaYP2n
6065	fee_transfer	2248	14000000	1	CkpZMaDmeEYzh5sg7TNA34XTobx7ofpSXYCxh4G3DpQhTXTpFYPQn
6066	fee_transfer	1687	39000000	1	CkpYwc6Yt4EMzL6ZYEpXjEaNJTGPaCiuTxGgNB3xrCfBSTznb98R1
6067	fee_transfer	1943	25000000	1	CkpYkRSPVhqYzhacawpNqkn1fbkbuXZHEMznKiNwrpWG2WNF7FjRm
6068	fee_transfer	1395	423000000	1	CkpYxFpsurycZL6yB5crqcNF3Tk7w3jLLonzMkxVUFm5ph4BzpYYv
6069	fee_transfer	1685	174000000	1	Ckpa4DSaZj1NStus4bmPjnwsiXKzHGPmHgNpV678rUYpG9S7VxfaL
6070	fee_transfer	1671	353000000	1	CkpZqo1ayGLJcU4TCkqcmXnMAByyy53fhkmpZeT9YUkogP7MB15Km
6077	fee_transfer	1699	49000000	1	CkpYqnt2hE1EU4pYvuX6xku1Hbrg2pfKocczzBWo3En9pWZdCSnRB
6084	fee_transfer	1395	145000000	1	CkpZYAxmcqSTwKGDBLbjhKZrMb2ujapWXsMqN7jvUwC1VR9ZMvTxe
6089	fee_transfer	1654	372000000	1	Ckpa9LN1u1yKcDQy9jJwnRiJpzEE9bCav4YFPXiaVn3CU4y4QW4um
6090	fee_transfer	686	2000000	1	CkpZYfkeGXqZ69eJ3WsaBobNAF2oy5sNtsCoyMti5RbGzFRjiKYJ9
6091	fee_transfer	1691	35000000	1	CkpYeCxaHhRsCWxTxTzCruYndRywvRZuctBAcRsLQkytnr5X456mr
6110	fee_transfer	1740	43000000	1	CkpZ4vkY2AxSeuYU4pM1zoik9rchrLXLksjrkaqtjr3KSoDr9EhJa
6114	fee_transfer	2086	14000000	1	CkpZpy1tcPw9j3tR2Zsb62U6GxWTZgJLkd7VDLPQApcpu8xpNCSQc
6122	fee_transfer	1633	320000000	1	CkpYs4d6MC8E7Hc8Yx22kwNsgVgeUuzP2QtsZxttAQaWzbgsk7TX2
6123	fee_transfer	1633	189490001	1	Ckpa7dDw3bZURyMSvxNQJKhoWD4vAKRppEq7zZrxcRg6YwQnX5pZB
6124	fee_transfer	2097	9999	1	CkpZ12Lo2AM2XsX8cAnAKv64pQmVha7S5jT1kbYr1JtdPPGsG31v6
6125	fee_transfer	1509	22500000	1	CkpZeLPd9daHkmkYZv7mYncct4HH1z8M5yz9hB1vu9M7HBkb4uYnr
6129	fee_transfer	1633	284000000	1	CkpYq2NkXwUp3xY49HoHiky6P3ouW8uXh5utcew4dVfG4XbcezXX7
6133	fee_transfer	576	183000000	1	CkpZM9UppTExxbsfZ24gDeNYaLgxxaWRJn5TL8njXjoMAhFUxKH9y
6137	fee_transfer	1943	23000000	1	CkpZjw4mZdN4rvHhBL3E3LmuL6ZyV6XSppW8AGQUe3Vfx5ad9UGt5
6142	fee_transfer	1422	22000000	1	CkpYU96eVHpvuR5ajPfWXHG9i4ExA8m9oH32gJrZXus6CKFerM4me
6163	fee_transfer	2148	32000000	1	CkpZ82wdWKzkJxuNMA3jX2ZhWNA3r8u3EjU53vTt2c3CGsF3oTrEz
6165	fee_transfer	1587	42000000	1	CkpYQx5SxWC9e9bCdA4bEcQkvuNxgdAe52WxgyTKFkh4yUGzyXRTA
6170	fee_transfer	484	260000000	1	CkpYQF7Ln2Zme7aBSEnGhiRx8hb1Caig9oAsiXfy1xaa9PHEXBL4L
6171	fee_transfer	484	248000000	1	CkpYRwNytPnaVi7DbwQqGzLdZY5BSrnsP7cY2Z2XEUBrWcET98xrH
6172	fee_transfer	1467	22000000	1	CkpZba3kDNbSC2i8mbCsNC9FnJ15ugk4ZjPXZnFhxdHGXZwZaASfb
6182	fee_transfer	632	103000000	1	CkpZdvjAs1ERrRChewqzuYBtf1fa5vua2qe32jcYGJwHsAUd5VVkg
6184	fee_transfer	1395	131000000	1	CkpZgFuv5GLUaNcMd1CBcGf9PwCjvswTDfZoji4JLCxnELz81jeS8
6186	fee_transfer	1588	212000000	1	CkpaBYT6VgMBkEVzffKoZ6PHgRoSAkf6314jFdBXybV5BEThmyr7F
6191	fee_transfer	1489	41000000	1	CkpaD7kyG6o8VaPj9NdSCTkh4tPmB27for5c5U2qvqmMJbhz5dZDu
5909	fee_transfer	1690	2480000000	1	CkpZHwworAD1BsujMRQ8eaUUvDBp9c2RAahfw5W1P4cz2iEsX3hgs
5910	fee_transfer	1690	149499992	1	CkpYxvWXLGnffcFgTf5EMwaq2gCGRw5EaL9jp7EAoVKskgYJwgaqc
5913	fee_transfer	1675	708000000	1	CkpZE98FXeKjCPnJQZBQ6NX4CysFmnVYGzysRyXHfYhzp3wnZak96
5917	fee_transfer	1690	763000000	1	CkpYxd3amnWLd8wKBFhaFcJqwhcoPnii88ogCWkXJrjvc157fiYwY
5918	fee_transfer	632	2540000000	1	CkpYeWQiod1aMEgxa39f7tf6sngZNEcT4wQykitXkNbFb6oTAgkgu
5919	fee_transfer	2128	1	1	CkpZT8eYQsUVtnU4TwvyF6SNUPAwAo2CuWyUd6377c8SDSYcdJ6WS
5920	fee_transfer	632	889999991	1	CkpYtstnZvXwVVWyKCv6Cv7zwBVM9M7fzoD5kkzAjVW6g2AJU8KS3
5927	fee_transfer	1439	309000000	1	CkpZMuZ2j2pi9Uh8dVUnqoSfErbSAQpWWGaxR5JsejQjYZpmarLYj
5928	fee_transfer	1395	26000000	1	CkpZ2avbMGieJ89V185ppxL5pmXxh2TfVWTcEuTPt4C8SnA5Jgfvq
5930	fee_transfer	1710	37000000	1	CkpYxuCnnny5HSNJwSas6SgRS5P3ixbKVRwpQL6yRhmhs3MK43BzA
5934	fee_transfer	1489	42000000	1	CkpYqUPR3Lw3EhWG2BieZ1dpkf8cMBq3zAAUsSbkvDwA4om29j4No
5941	fee_transfer	1695	49000000	1	CkpZ6RBCZ1ULkmQLaHL4yW5LP5wuj17TTUg2k6Jy2WFac854kbPUg
5952	fee_transfer	2100	11000000	1	CkpYtKsuCM64VY9mYa52P6Y197yD9ca5dqnMHeaH6RfHZ35fk58V4
5956	fee_transfer	1643	873000000	1	Ckpa4yWokots221ckSdFaQiVy2F8oJnuNYwWkkcUCV1Z1wLeWAcya
5957	fee_transfer	1643	34999992	1	CkpZbL3Cb7hF9ZVZQQqBKRPZGZb3Rianw9Hchg2BC15WZrBRycDwx
5960	fee_transfer	1457	36000000	1	CkpZSpLbYYWX4ct1pf3BkuL8qepLsymqHLsT9pxvsTksUkaKW4EYB
5966	fee_transfer	1419	190000000	1	CkpZtwWWxHB2mAXjfNYptdiVcEy1WnggvhHjV9TqezRamx6cprc1a
5970	fee_transfer	1756	25000000	1	CkpYzFy6v8yDvyNpDTtt5N7ytw3HTjbn1ak59ETH3VyMqVTvGbrJS
5974	fee_transfer	1701	36000000	1	CkpYtyd1Wx77VEci8xNe6n8ts4YuASkkPvLZy1aUU3isGvk5qr1C9
5980	fee_transfer	1596	48000000	1	CkpaJ1fNTHnMsTD8tbg3casnEdZiZeriKuGtisyFsUMuyVPPhzLC8
5985	fee_transfer	1679	28000000	1	CkpZaqyrVYEKnv2jSQdeuz3kcrwXYxLvAF8Kn7heeLujQZQkCVbrM
5987	fee_transfer	1701	14000000	1	CkpZW2Ut7XdAtMfS3GAVPAhWN2fGuKLyiwBuUafnZ4ckG7eJxXHjS
5992	fee_transfer	1693	15000000	1	CkpYkf1oDtyGbACcAAB2FxiZBpBrWALVYiwTWRgWABLECU9VWAYLJ
5998	fee_transfer	1521	12000000	1	CkpYsHBAQfZs3j46eZCqT8hqFreJVJFEKgesLfGnwKyN5fraThcHi
6005	fee_transfer	1476	24000000	1	CkpZ7GLBA6GqCS8jECxAgU4TK2PhtP1hGbKBLuesSofxAbJYabWuQ
6010	fee_transfer	1699	56000000	1	CkpYxDDMEMH1Uu8my6hCHBLyeDe3dB8E3uypWXRrLLAuvbdHsB6Fg
6014	fee_transfer	632	76000000	1	CkpYuByo2GPwNYc4jML41Rz2XPxrdwruMDiGMzNX9uAEa7RHirTrN
6020	fee_transfer	1643	290000000	1	CkpZsDGwaF9pT3KEEMkactKoDqxPUKZAVVsWobxtVfdsSDgDZwZmT
6021	fee_transfer	1850	45000000	1	Ckpa4Em789Mx2PhTaNyAzPKjyZCuCQu6VjtdiGjqDenDnT3j8AFPL
6024	fee_transfer	1509	220000000	1	CkpZLVPERr1Jzk6u4NA2VYkX12Ho8ZfCAa2Ypiv3NXKLq2X8Jy5RE
6025	fee_transfer	1568	25000	1	CkpZDJjoBNJmBBpMqx8bgkoz98aFa9Y17WT3DnwjQVDc7ZReBonX6
6026	fee_transfer	1420	2970000	1	CkpYnLFRzafw1gACgwhhpfANsAEaQuUm8Hrc7F261dFR53J63kWCz
6027	fee_transfer	115	2000000	1	CkpYiXitbRd1f3Cr5jMcHKySLttQPcNbJRoQPieM1cSQfYGxjEwXP
6028	fee_transfer	1814	100000	1	CkpZqAtVNstD92hxSpFJvQCTT2D2ZGvKCLiwaZxdJoQATZaosR4TR
6029	fee_transfer	1520	4	1	CkpZhD39vDTy5ixHTR1AaMN3HdCP6dXJ4G2DurhfyNNMgc7hCUw66
6030	fee_transfer	1509	149904996	1	CkpZbMeBdTQbakaPKxxzHmUfHfkbmivNg4cP2owed1nYhwvDkaj3V
6037	fee_transfer	1451	35000000	1	CkpZd8iKdR8MW8zswWzR2LuC4PQW4ZePsQrfhCNAbGEb9KAGdyjZ8
6040	fee_transfer	1451	777000000	1	CkpYTqg7vvb7c45meRdWfqMm6oZH3hWGzxAJUkgW9TpVDFnqzTPpj
6041	fee_transfer	1451	9000000	1	CkpZJ8RyrFrcNHhLoy4nCBk9W6GKknM8tDZjhAinXoTDcfvzhck8A
6048	fee_transfer	470	35000000	1	CkpYpB1GRn4ENH6bG7cfwogfQ8FxTV7ZZ1wSHkhTrWAPTBtzTxzmr
6061	fee_transfer	1657	5000000	1	CkpYpovMn1Y1bjDDBexReVKeSFMEmLkbhsfihNK4nGCWK8zcAurTB
6062	fee_transfer	1708	16000000	1	CkpYwhBoyaHR6V5JzavzhhRgGN5Cfv57gJoddse4EaKmo45ooEwFC
6071	fee_transfer	1711	353000000	1	CkpZxzyLYFBMsRdyFf4QhtHzEBTxvgmvtNGxHHWEULiexTRmCPtEs
6078	fee_transfer	1426	49000000	1	CkpZ4vmfjGkmKuVMyvpgaeNXjM9DumLLa8YkbYPFaCcoNsidwvvhc
6085	fee_transfer	1690	145000000	1	CkpYeGpBxwcfioNRaiYDHgaLSWzui6EEP1oknWxCFgeCUmrhJLtoA
6092	fee_transfer	526	35000000	1	CkpZ51SCQAgkiC6REMTeYcKvwg6aZnDfTniyG57fibNzo1e2qh4JY
6095	fee_transfer	1705	26000000	1	CkpYYcd7LEV1WYuXU4ALqn5pvFYc4jEqNVco55WAvNqnAMFY5LsKp
6096	fee_transfer	1480	11000000	1	CkpZ1Gmse48GAcMcTcsP9e8wRUq3ihAcyYnsJ9BQo2j1J7EVETPNu
6099	coinbase	1458	1440000000000	1	CkpZpRpvofaU54ZxjWEdwVndmG35f4cQXEbQbdcToTemdmv26N6Pn
6101	fee_transfer	1448	37000000	1	CkpZWh1kCzNGaVhouormqiX9pV7EjG9u4VDcqoH4ZzHPbbuXDBee8
6103	fee_transfer	1457	25000000	1	Ckpa9oAssjCVHji2D7CKEWY2xLkZ4gGw619mZKLcn3Ku91UNscW86
6107	fee_transfer	1395	42000000	1	CkpYqKeQR9XcBXWDDPrCKkag9w5jQa8KKCN4qVJiauYVCf9i6hKmp
6109	fee_transfer	1610	43000000	1	CkpaJQW7LK7qpBWaJb1Vq8QHKrHCZsXzDtFgEBqvikvFVgGtBquvd
6113	fee_transfer	1699	14000000	1	CkpZM2AgZrsgB96tG7PTBHFbEPTLjkVQozbA7LtZYrdw8Smg2NEMr
6120	fee_transfer	1708	1170000000	1	CkpYctrWb2uMPcd75vk8V3WkKrcZrkVUEVXUDHHy3mhv1WjgghtcT
6121	fee_transfer	1708	99000000	1	CkpYp2CfSB4YxjBfauRTL8LSkRBebxwqTPErD3Ni6tJDwJnpg6Xfq
6128	fee_transfer	1587	41000000	1	CkpZnRnfgHsaH57K51pHPXCsccNfffKEaphwSmqggWb2BWGccAp5P
6132	fee_transfer	526	183000000	1	CkpaCkXo1Lmz8HzgRxrxyERrnUoAPfKoNeP28yLc2ErfsRU1HdTyg
6136	fee_transfer	1943	33000000	1	CkpZtDUS1jGf3MoZuTrNWDVPpuhLY6wCWHHVM8aprm8V8ndmS2qDz
6144	fee_transfer	2112	42000000	1	Ckpa9PM1xWDqD6t7t6yKCBkiPkzdmajnefccn6hqjPdaknXt3ZsMG
6151	fee_transfer	1696	1290000000	1	CkpYaC2C276eCpWLNCd47gkACnaqHkDR5jZbeBVP88Cpz4e9xdmei
6152	fee_transfer	1696	217000000	1	CkpZV81biU6iXmr6cXQdCeFoPfqPFQkGZqkTefMSFJantxtX1kDTY
6157	fee_transfer	1717	32000000	1	CkpYnDRSZFRL8WyTxuaATXFinSXSNAXi11eNzB8oaH1PpNYVzxGZy
6162	fee_transfer	1699	32000000	1	CkpYwzN1sohadRyj2ru8L2xBB7kyF2jR8Cy53QEwm3pdihsVR8xpU
6164	fee_transfer	1394	89000000	1	CkpZcSPRL1BH7PJoKR9QEDY5f4mWLbCTj9fpWPr2rCP94SKj8cGaj
6166	fee_transfer	1687	587000000	1	CkpZG5Jb9piJpEsbf6zY8DLFvwKdRt8tc8mxtbusy32329hprBK2g
6167	fee_transfer	1687	19000000	1	CkpYuysA378muK5wqmKeDSZ7F4mmWycrMX6zSgDKnqoQpMkMRKqvv
6168	fee_transfer	1671	530000000	1	CkpYfiAZSssiq1Raszs1iyQRiA5xTkidVxpcfLhMcZoCXSjQ7YV7Y
6169	fee_transfer	1671	53000000	1	CkpZrACLxiXc33K2kf1YUK7woqcEszwJ6TZHT9H6cFE9mrB6NKxhv
6177	fee_transfer	1762	32000000	1	CkpYigEGRaSgDczvnwc9zLS5zb2dzTAA8ucPF5heygmeBt27sWECR
5916	fee_transfer	1700	1602000000	1	CkpZSUy5NRoT5hsR6rdKReyfqxbPe2hLPFLv7tPLFmppxZd6WsYkN
5921	fee_transfer	1719	37000000	1	CkpZiwbzhgC4sthuNBcgH3ywT4aDWPGmjrkbQ2N8iLXC2EGpocBP6
5922	fee_transfer	1654	36000000	1	CkpZaV7qEZ59NwNgyMgRwq6PJcsMGtNwYAi4AquXKQS6oyyZCfdgP
5925	fee_transfer	633	35000000	1	CkpZiXarCuJ9GJYXPkQPs6nZGhtWQR1Tfc8sgWJN9YyA3vwZGVE51
5929	fee_transfer	1723	23000000	1	CkpZ5eYRbCKT91N34kCaTkW8tNUSb3GCv83kcWANiPMBv18okWs3b
5931	fee_transfer	1560	37000000	1	CkpZeNjZPjo92wcfFz5vYDBChe5gAP5J5e1hdQXZMjXZLxMaWHe2F
5936	fee_transfer	1439	208000000	1	CkpZKBxMKWWSGGHu4bUpRjaZc8KJ4sUVxjJ5ssCs8xtyM3d8prrWY
5937	fee_transfer	1439	16000000	1	CkpYzqCXLYFYGQmrVmUr2bTkajiUfMtwBmYPDgeEGt3ZZEJmRaz7Y
5938	fee_transfer	2248	45000000	1	Ckpa5gzWuG3XCThYSDZjJs64c2rPF1bVoXrof4WjccmwGXEhLAFeP
5940	fee_transfer	1711	25000000	1	CkpaLTxpNpqYsDXRk9yXb4fowQLLoFXuLsM6WnBEhvA6dN9b296uG
5942	fee_transfer	1694	14000000	1	CkpYQwSLjN3e3ZoUhga6ZqhhXzdiJhzsLeAFDqJF6XwJqK8r4oepn
5943	fee_transfer	42	3820000000	1	CkpaHf1jxKNW6PUEs2f36wv97zExf8nMKrNRGPBjR2cz6ShKxoxZh
5944	fee_transfer	42	520000000	1	CkpZJF9uz2gs1kpu6QvDQRFLEftVZq4Zsqwc5aouMGXowLKtLBnVT
5945	fee_transfer	1580	24000000	1	CkpZ3uFQ9wcvJtzQcheRqLhHNdxHKz8ogg9QMTsfS6w41eahEUq5F
5946	fee_transfer	1685	3000000	1	Ckpa6txPPQtie4mT6aGnqbdLuiQnsHeZ25r4wQkcRVTEEozeN8WWR
5947	fee_transfer	2106	25000000	1	CkpZmr6yndBrxKkHRrvvySnaa6iY1PsdZgqYjt8XM9WSrgvX6WA8j
5949	fee_transfer_via_coinbase	1429	555000000000	1	CkpZ3eKmVTpMqDXBnpwYsTCQkAoTnrqPjZ9bjsxF7srerJm6UGjxm
5950	coinbase	1448	720000000000	1	CkpZWcPPfiwFkQzZZenvqNfnvrDRSKtDeQGtx6ZFmA1rJUDUVWx26
5953	fee_transfer	1681	44000000	1	CkpZuuBNXwmCDWVNJirnDTam8RbS75QJ5E5sRcgDurSgY4dQtfb5A
5955	fee_transfer	1458	23000000	1	CkpaEfQBzkP4CYeDuXBLqq8WL82WnWrn1iR6ysrVw1BWhgWELMs5v
5968	fee_transfer	1560	27000000	1	CkpaCN15SGXix6mqqm8mN2Y84QyNGPurGmDCGLfHtL6GWj7pqx4v1
5975	fee_transfer	2215	1	1	CkpYXiNGCEasbQdzCWYfwe4U2mBQ4QqEPC5RRwdCYHboCCsXqaWsN
5976	fee_transfer	1643	572999998	1	Ckpa6ALpscBkXhnsMXTArQL7VZpJZ9VBt1YyeNFQaGGcdLcwQdbfC
5977	fee_transfer	1643	35000000	1	CkpZDCmJqJ1Q3WHj1SEzWjrVm9VcsbneD5eaeAk7cWPUraMZMhfwm
5978	fee_transfer	1422	193000000	1	CkpZXRxoFnhSkXGonCNC8rkBrVkpm2sjyWCJcLk3r3ApqoJK5SH6V
5981	fee_transfer	2148	14000000	1	CkpZjsZw4Mgk9RkFrkD2eQ3LfKXAK3d8WibF2RprYXhXsSLcg6sDL
5986	fee_transfer	1476	28000000	1	Ckpa5KwEp51sgkp6rRVNQdTLCP5SdYb69m9p6HmqfZhDEbYzuXXkK
5990	fee_transfer	1850	1000000	1	CkpZKLU3Sn4qjQfD7EzrMABE9uqk9nmrZZFgmaaNViF1bNo7FVuyE
5994	fee_transfer	1540	19000000	1	CkpYhe8krwTGm4sTC13dXyqCEmgaoZK624SXzSGX8dhQGFL2zX69c
5999	fee_transfer	1695	442000000	1	CkpZxGYmHgn1PnS5Q8rRMjpgZ6WuMWS7ok9Cw7eZDkuYjXARg3kEw
6003	fee_transfer	1673	23000000	1	Ckpa3LW7kw691mtqdLELioUR8vdHD9eedXXCRs2YLbG48M3JEBCSH
6019	fee_transfer	369	52000000	1	CkpZBFKeUySbfKGBECPQC66ixk5LF79MznvifBr11E7wq9Z3NzSqk
6023	fee_transfer	1509	113000000	1	CkpZQN4JSGX9yjmRcpuufQHHD8z81yBBrUzvPKZ1PGs77CDBfLcyB
6033	fee_transfer_via_coinbase	2126	1	1	CkpZQWWkgvdt6js5FLc6BwKE5DPuHm5UqgkA8VsVyp5EDZSRusA3B
6034	coinbase	1422	720000000000	1	CkpZRavcZoYc6AHUVFFQVysVaY7hgU3nFSodbQUY1AEycvWDXoMrx
6039	fee_transfer	1700	35000000	1	CkpZaVZUQbcEvq6rA8N3KsLV3XE6pLcjzpuwVRttA5q9zgJ3z4Ua1
6044	coinbase	2261	720000000000	1	CkpaF1XH6G6PhqwLFLgcrr8Dx4GiuJaEuAM4zhjgo8w2pgn3b2x9g
6045	fee_transfer	2261	12000000	1	CkpZPkxPNPNq1xwgM8xDjQ36Vq75NVVibMM8NPs1MwFR7ZqLXriRG
6049	fee_transfer	1679	82000000	1	Ckpa6y4E86pQf2UZzUqJ3NMybeMq5s4cdCkvDuAyUcVxrr4bp9ULu
6052	fee_transfer	1458	33000000	1	CkpZ91TQuSZQ2mwhZgugYLMrwb6jy3MUJ39NTccqszL1e8U8tRS2r
6057	fee_transfer	1426	14000000	1	CkpZCnbQyYK5LLTEVGBpp3xpPWyXDTDcf3mVJ9RJywuH51E2nW5HD
6063	fee_transfer	1708	234000000	1	CkpZTD5nm96Ho4K2WuCHe217Szh3E6YeMc9vuSx51wTjWL139p2Xk
6072	fee_transfer	1508	1100000000	1	CkpZz3p15ZSgTEak51bWk2ToKcpqyyeuJJ1MvjXH8vavCkrR6iKBr
6073	fee_transfer	2179	100000000	1	CkpZT7Di7pVJ9xFrHYpnpBmCYXXNrMhRC7eLSpuhbLxDspjxBd15k
6074	fee_transfer	1508	156000001	1	CkpZF3VgHPx2orihYkP6hfH2wV1adrvC21V6Q9AmYCzCUkX3GnRvt
6075	fee_transfer	1764	1500000000	1	CkpYZA5gSh6VNPct5XAU7ugdVSjpweE5QsgM6SWmRaaqPcmUBDKHQ
6076	fee_transfer	1764	510000000	1	CkpYS3yYxb62FJ8fcadFyeCv8eKGSUzYT6WDrefPXgfxwTQjdcEWX
6079	fee_transfer	2086	49000000	1	CkpYyJ7AUBf1uqrBP96X4sFQM7zBLNVro67hz1TMxuKGSBkvYJ1mm
6080	fee_transfer	1670	36000000	1	Ckpa9pu6Z47csTa8t6kh9JmVbeJhDyvmyGJYe1WdHBindSbknQ6qF
6083	fee_transfer	1708	1279000000	1	CkpYpnt1PncEv5RZFLrCuEi5eNWrbdZ8V3GGrEouhHjtK4zT3gvhf
6086	fee_transfer	1654	1470000000	1	CkpZRrXs3aRwyGyYnJdXFeHVyRYiZinCXTjLuPFgVnYNWC61BhmTA
6087	fee_transfer	1654	9010000	1	CkpZrS9oSjfs4xdGDcCmxpFSbuYRPas53Nmbj14kBL1udK6fBV3TE
6093	fee_transfer	641	35000000	1	CkpYpkDBUDD2EMoxr7WdiJ1LjFD2Xa22xATqGG5abKpvpDCgt1maP
6097	fee_transfer	1643	819999999	1	CkpZbNRyg4G7ULwmm3cBVyr8HfT7g1GtkfzwLw4H5miCxnvjV6pdt
6098	fee_transfer	1643	109999999	1	CkpYcoPrMsBcHTWHfLQ8ED8Q1bR4qhB8r1EBAca5Fwm6yxy2XvYtt
6100	fee_transfer	1458	976000000	1	CkpZfXqAH2TndFtUgu52ydFh5yskWEDnUKKdZaQocUrriaX8eJ5Za
6104	fee_transfer	1395	64000000	1	CkpZeWeQKHJrJM2XtPGrzYeyC4bu7cQUTnvy3x2c6aoxGN8hGWZmm
6108	fee_transfer	1768	32000000	1	CkpZz9feDmMUik7E6cg7mZLiMbbYPU2eJasFDbH6e8EkR6dquemAT
6112	fee_transfer	1850	62000000	1	CkpZNcfsyw1CxWHwkuApzXsy2PskBsA5DaEjcFPSDzt83ZdEuVipV
6116	fee_transfer	1650	42000000	1	CkpZWCagT7eRBpZ8fAxf1jZ1wRgFwpy8zz95sahHdJhrJGRjFGg4B
6118	fee_transfer	1708	275500001	1	CkpZSjrEGBZLpZHffFSWBhughnyzDQ9Ax2ySZ3xKb9xPd8M8EpYoz
6119	fee_transfer	1509	7500000	1	CkpYbMy6nxnGyMfXx7udJgK7sv8grwfU8R49AGg3u5PtTa8GyFKaw
6127	fee_transfer	1395	151000000	1	CkpZMvK6hWoHGxeZJVFSH9svAn3LAioGAPFKofM5wLBQwC5B4zqGv
6131	fee_transfer	1394	183000000	1	CkpZ741hpEhvrUfEUfe9AwSdpyX5khgyS1eovbRu3MkoxXh1RNUkd
6135	fee_transfer	576	123000000	1	CkpZS7ZcAyfRCp1LwkSyHJpgr3iYmFGx3MrpR4tgLPVo7pJTRZw2Q
6139	fee_transfer	1762	42000000	1	CkpZAQZDtBdLwnssZ43aqs3MThrnimfEFDAx7WairjFBrqzoqsQvw
6143	fee_transfer	2112	43000000	1	CkpYeVVy1xPHv6JtY12R5jFNoJeyiNqnY6yavDniPFStZUyfN3PnM
6145	fee_transfer	1634	34000000	1	CkpZft3qMS1vGKGMjKUCun4DHn4XmHoStEBPwZmbV9jX5k1HYmiZ4
6146	coinbase	364	720000000000	1	CkpYawsavGoG4x8DfmCKMkHQZUuiyvJoh5pdFJbfim8favqKdF78d
6147	fee_transfer	364	12000000	1	CkpYy5Qawr3dNJ8hY9g8mKj4YmRCZEZF6jnayKYoZc9sV2LZvKhCZ
6148	fee_transfer	404	11000000	1	CkpZCoBH7zsgsyop9sBTchQ7MgiQHjYjmFzxNmDd5mXYU3Zo7xdvh
6153	fee_transfer	2261	1000000	1	CkpZE3BETYochbX7XgvjjFU3SjdKQWfrKaVv8sPPkavdVKjPDJ4vC
6154	fee_transfer	1633	274970003	1	CkpYUuSCGuv18sCUfEAYPxDov7NqLT3w9BBPioUmimGXYov11c6dt
6155	fee_transfer	442	200000000	1	CkpZ4BsJfVPuyXbHQf7t3katRkDsvNx6DG43n9eZd5QdTSoEix3sd
6156	fee_transfer	2097	29997	1	CkpYmXvxsRdKKY4JFtFZcvqDsn1gw85vh9DgYRhbmD383NuPY5pYh
6158	fee_transfer	369	21000000	1	CkpZfWdPXdSLzYrkBrfF3yupW9p2e8zu5N65QFXVVJoKDo619L5XF
6159	fee_transfer	1633	32000000	1	CkpaJkZ8EybuZRjLhAwjfgXE5RxLkJknAjz4qJNMPRCJMGAPmhj4F
6160	fee_transfer	1426	65000000	1	CkpZshK6mAKBbBNxUPCSdGf6cC5382q5ysQR8QCXfKtbS2XajwMbZ
6161	fee_transfer	2086	32000000	1	CkpZVjEEMVk6e41z6XucZ69QoVqimpa1zLJvTBdKGS15BnLZDYQJb
6175	fee_transfer	1514	660000000	1	CkpZ7LtiXfNhf85ff6xHTe3968p1CWGt1Yz38DHyoJfFkhtpWgJG9
6176	fee_transfer	1514	190000000	1	CkpZ1FZPCFqhBBN58nbPe8aSCqsgr7YGLJPJMNh5U3rJtpMZ3yZnG
6180	fee_transfer	1680	103000000	1	Ckpa6bFaYr8cPUbpjvDSLdTTDePoPrHosv5hVmzdJUkceY1UhD2NY
6183	fee_transfer	1587	33000000	1	CkpZ9Hj2HuT3SSx76V6L1VnJWvZg91MTEnsC2dyhR2d6rrDChswqr
6192	fee_transfer	1764	41000000	1	Ckpa4BS7fkHot35LvfFi2WgKsishrFCaTVDSHdxiAKwL7jLXC9h51
6150	fee_transfer	1574	11000000	1	CkpZhsWvBsqmLk4ehN3t9fZe2YLehuw1HbAXojq6KiHak8tv4xVKs
6173	coinbase	1514	720000000000	1	Ckpa12QgnpezgcZFnWL8EpDosVb6cKMaGQe8YzN5K39WEtTPtCkVY
6174	fee_transfer	1514	11000000	1	CkpYV5VyJbd87JtC3y6LdcmVucERAvzHx2zjTvVgKqcFZuxnVfGJ9
6188	fee_transfer	2261	11000000	1	CkpaCPAUGMiw9UwdbUAH4ocG4XAssW4pJSZhLWxBWd1x3GLE7f8aL
6189	fee_transfer	1657	34000000	1	CkpZuF3tVWV8TasAcyNu8Lv5pQQuGkZP4PaqRFV9i64sDRUM3uSS8
6178	fee_transfer	1711	42000000	1	CkpYSH1Nu32tDKRrnQDwxt9DSAuu1Rvo7X4fVhyf7tWyMwuYmXXp4
6179	fee_transfer	1711	2000000	1	CkpYQWp6SeCfeaUs4bYzcEKwgR7wZXKmF2UkukFAD2MdCUsNQTVJk
6181	fee_transfer	1850	103000000	1	CkpZiCXoFL3aqGjhwTvov9RGMvaYhB7drxsHqCV8TDojVJqDscDCs
6185	fee_transfer	632	212000000	1	CkpZ8R6bhCqMDaCaNWJvPbkZVoHupTDicjsXYUisn2Td3KTvYvKTg
6187	fee_transfer	1594	34000000	1	CkpZmYb3EpkJjg2QSwLY7xpTAiH5rBukGkFWNFWG6HYq3GWGNpGyd
6190	fee_transfer	1768	41000000	1	CkpZpG8SWNSLMD6CDMoqWatFCMyaFUNXaKxVmMjNp9ewf2i1BUeHE
6193	fee_transfer	1650	41000000	1	CkpZjVoiQsYNk8UbCzjvXHtser5Z81V7BUcBjMaQc8RWtsDfPvErd
6194	fee_transfer	1457	330000000	1	CkpZhLiVysWuhMFbTzunPQbKgCAKoZm1VgVkZDRULwCyK3Q6Mvugi
6195	fee_transfer	2221	55000	1	CkpZY3D628zQUKoo8v5yP1mHV8wo8hw2hvw16o73gHNU6UYp8MQPk
6196	fee_transfer	1814	800000	1	CkpYWPx5PhC3uKwFUcv3Mz8tE1hXdusvPK3zEhcVFKqf96Pce7xxy
6197	fee_transfer	1855	2000	1	CkpZZbTgjHa1PkCnn6mzipumxzGYG8bfkEByimCnYaBi3N2gs2JkW
6198	fee_transfer	1719	5142829	1	CkpYUVA8hmHr2WqRPYJ5YNZBTB5E39ibzatbwPzUyTBBKouGSqEtJ
6199	fee_transfer	1527	4999995	1	CkpZYckTYZBnJcDke1MNrFKzurSaSzQfThfCbkgwWXobEEohYJ9Ua
6200	fee_transfer	1719	10999992	1	CkpZhaPWCNxSmUeNvDdyYaCWeAJACnL9WFz2yyxyL6DCz4WvxhTgG
6201	fee_transfer	1696	160000000	1	CkpZ6zL29gSqqrfJUMRCRBtXZN3TNkRGd37UGg8DDd9oJVzs75L66
6202	fee_transfer	1706	42000000	1	CkpaKx4Su1BBNjHB5emXnnXj54nSzCbUo5pAA5pEjPfxvYzvVCTT5
6203	fee_transfer	2039	20000000	1	CkpYduhxA5XciRfWewTMRAzJUhSnM98zfaqeJ489G2bbZhgFHntW3
6204	fee_transfer	1547	85000000	1	CkpZb3RJtsNZFtLAcHzzpJP6pDWkseufe4DxLFLRFcFQVC1sRLWfa
6205	fee_transfer	1703	85000000	1	CkpZHvS9SxW3cQpZVtc64L297ZnDSn99JoKkCjCQQVfZfWeEDmDEp
6206	fee_transfer	1702	85000000	1	CkpZkmNtQxL7R4Ye5JjS9jKu56f1u5bZFdHPu93VBbPUsuboUzz6k
6207	fee_transfer	1547	530000000	1	CkpYc4V6pDE4Truuuea9dJbfY128UJpceuMcQepY4MD22YMM4SgAJ
6208	fee_transfer	1547	485000000	1	CkpaAnBf8Rpc6WhJ93EcejwLYRaBKHcWDQKEnR4gSuG9CfSvzGgXW
6209	fee_transfer	1458	1490000000	1	CkpYqv5SoNQqbVvLnRVXU3rkaxVaDgLZRrS4fx5bvqR3tNURBbeFP
6210	fee_transfer	1458	300000000	1	CkpZKmwmHCf28wZ3v9zXbgieJhYg8oZXghdUVMgb4xo7SU92LZUdJ
6211	fee_transfer	1571	52000000	1	CkpZBkYjw8qro7ontE6KUdWqb5dw2dAdNrw5BkZBecjkAddVDB3PB
6212	fee_transfer	2248	23000000	1	CkpZ4S1mrpjat4QFQ4urwG8RXpV72KaE3gv6g3GHwp3jn31ytvSux
6213	fee_transfer	2112	33000000	1	CkpZeThKCxMBgWAQKXhefmugqrMHLeeuVCXwNjoD3Fxq4t7pGa1ez
6214	fee_transfer	676	11000000	1	CkpZevdA7sS45Ttjv9ViSszvVW94WjaFHPh8im4Jy8mzkxyndz1Dp
6215	fee_transfer	1444	23000000	1	CkpZVDP9ENUXkrax14WnUWJxkUWose45JNeuadnrgayf1kX5oR5SE
6216	fee_transfer	1688	121000000	1	CkpZePV7bBA77Q1sjyqJtij6rjxM8poKXKVsJ3HPUBzZy1yx78fRR
6217	fee_transfer	1593	642000000	1	CkpYsK6ZRi2aKtxHqHXSyYiyEpNBLojVQhBmZ8StzJ7fXH8RCRzhN
6218	fee_transfer	1593	172000000	1	CkpYXyjGZxVL6pni9GGLnZAdpN9JvDK69us9YgrCxAnQhT1mi6Zi4
6219	fee_transfer	484	830000000	1	CkpZsXRCNx1zhRiwJRYPrN7DpAhAwVaB6eL7B4r97yauR74G8Ua9a
6220	fee_transfer	484	680000000	1	CkpZm719df1R69rR3Wc4AjghnwM7pZ2zjCsjho5pyEyu2LVEiFU3w
6221	fee_transfer	1637	33000000	1	CkpZKfqx1sK7ZCms4i2dwR9ue8pgyLDpJ4y3LmSyjuJgr87WEQdVH
6222	fee_transfer	662	23000000	1	CkpYxE9zckMK5Gmq69Le2y2c2HZjqTB5Zbz1J3c7DpHMVP7w4F5YH
6223	fee_transfer	1451	150000000	1	CkpZDiwDwPdhErR1En6nayhCb2XBDMreejLz8Pz8squVk6QxT4kPA
6224	fee_transfer	1747	22000000	1	CkpZbSGUTcWZfbPYBrJ28LPCFkKSocxUfAYphq1PMStf5UgFmbxyw
6225	fee_transfer	1746	22000000	1	CkpZj43u333aMD3oNk4Rt53oddFT2HsXdtByHWSRHBXP7bn3TNV26
6226	fee_transfer	1704	22000000	1	CkpYmcNdWqMqHD66Tn6EDztWgU5iEmPzyUHoY4uxyG4Qytw6bbfzT
6227	fee_transfer	1446	12000000	1	CkpYrcBei8aE8hXpykGpozvQ4eDTFWp19hrzz1ktm6HpKgYsSbPG8
6228	fee_transfer	1681	22000000	1	CkpZwxhrAN9r49ZmWreo1iZk2BgQatKQmEojoZtFVWv1anRRon6Lv
6229	fee_transfer	1705	33000000	1	CkpZNoNXTmhPnt5h4EWxB3YQWq3f2NLYP5HQawjnRYPogp8jWrkh1
6230	coinbase	247	720000000000	1	CkpZbA1zduPjSttajLyDkhZrzNpJv4wDN5CjNLVKyu7VLG91TuMPr
6231	fee_transfer	247	12000000	1	CkpZ957UTvPy5bHzYGSk6mrAyiHm2BEX8NXY4wF9src4Ct5DtXDM3
6232	coinbase	1441	720000000000	1	CkpYmgzHWfuVtjNgoPCSD6X32borrDWUCFN37s82MxqMKpjwA7rTu
6233	fee_transfer	1441	22000000	1	Ckpa4BirZzQZqJ1EcCEzSGi5vatQRwNZchmqkPRzJ4cnWqUdhjind
6234	fee_transfer	1671	980000000	1	CkpYchtYtvXkLggiMnwHjUATha2ELehrmBAgE9GQvQ3YYbAxUxyJK
6235	fee_transfer	1680	162000000	1	CkpaEqChpcVLBiPFVqWF6se2oZUn2vJp9kNEeVapUCpR7kQFSkseT
6236	fee_transfer	484	570000000	1	CkpZF4nssodhU5wKK6FpTRxY8kGaX1kZBNQSodhXrDbp2i3JA79Su
6237	fee_transfer	484	500000000	1	CkpZAQjTiSagrFtWEjNE7h7XmdMPHZqbeQtmMNK1noM8DGc8cdidu
6238	fee_transfer	2135	850000000	1	CkpYjbNffhTv84QXZPkzDAkqDF2QVyMubsvokYYD3u8qShFz8ULSC
6239	fee_transfer	2135	490000000	1	CkpYf1YpTsq9aCJxVNSjwnJh8m3oVBViURRkB2PE8E9zFCxpw59n9
6240	fee_transfer	1394	44000000	1	CkpZyZ2nxcAu5Ri6WBi6UuV6VUh7n3DnnpvJpSm9VeKtbBA3eUxLN
6241	fee_transfer	1685	44000000	1	CkpZUZG7yVPkLU5X9zDyHUYbNfQWpYA478SLE85bZpoCPgrdgXtkd
6242	fee_transfer	2248	13000000	1	CkpaEuXLMQgH6VwaNA6HhPesUFnhvzDRSCvH3eVEqMmBzfDs3xJuM
6243	fee_transfer	1687	1320000000	1	CkpYVMiwu8r3gC1ntERwZMoVCHe9aiHbXXw4L9jEQXXUgCkhbitMR
6244	fee_transfer	1687	190000000	1	CkpYUZvYnNghFZQHVvNBUn31DY4VQ6BtciF9kcX89EvRdVB6aqjJm
6245	fee_transfer	2148	11000000	1	CkpZC8ZBEHadfobc5davwE1vg7zhiNcTixERR2in2euhhV3DxTf7X
6246	fee_transfer	1552	22000000	1	CkpZ8m7nZPE31m5xPMmiuLJpSpYYT82fUgEWpp2r3wFQzHZjnYNMT
6247	fee_transfer	1680	47000000	1	CkpYRznh2G2BzrZeAi4YJ21txjxyiRUG8EuZMReXNY4mkbhxQCR88
6248	fee_transfer	1680	55000000	1	CkpaFwZdJz72NXqUjXbDKwF8GVQHdgrD441FHnHpnGENBu9YeQfLk
6249	fee_transfer	1764	55000000	1	CkpZj6w4HgrJYijvp3mW3twMfXyihLyEYC6uds5DkWygVQ2esRQsP
6250	coinbase	1688	720000000000	1	CkpZcorFbsYZF28n3HUwEjF4dHkfEYcf5eb2581412xTNtuDYz8f4
6251	fee_transfer	1688	999950	1	CkpaFFTGTEDt9jPbiorELZM4R1X8vYkAXeRFwMsr8vt8i5pFXC9wy
6252	fee_transfer	1817	50	1	CkpaDKzGoMLciLiBKFpvRHzyukDTWoybcmhfixGhKe2M4YZZo97Hs
6253	fee_transfer	1740	209000000	1	CkpZ3MXvP2VKBU5dmHCojwWdjqMKDf3UVW2ncFJQNuh5u5oMm6wG1
6254	fee_transfer	1547	51000000	1	CkpYzd6oLmgGGJnEBU2vyaAba199wy7xiWJm44xs4J22WCCHbaTaa
6255	fee_transfer	1672	62000000	1	CkpZBx9ShnYXJb8dFHLzwP8MmUwgma2UiiBpaCToC7zwBKLwNpMxA
6256	fee_transfer	1724	62000000	1	Ckpa23uMHE4Kn2qoemzB4uVqtM6uepxRPaaa86zpmkkRnFtQQqq2L
6257	fee_transfer	1670	44000000	1	CkpZCgt4u5Y3ZRTuxN5nrsz5xuLeoLRHTmwAZ81UZ8PghPCpFvQKS
6264	fee_transfer	2261	24000000	1	CkpZta3k2RMZhBFuNCLp1DsdgovkwY7FCVKf7PKx4ZK2VSKMrkxuh
6270	coinbase	1740	720000000000	1	CkpYS7nTBrnSyjzu2ZGvFx1tmSBBufP4KdDXMji9S46eBUG4pxCww
6271	fee_transfer	1740	11000001	1	CkpYXBXDMvbmFF4uUFjQXN6U444Ug1V6QZkx565WUiYg3okDpVCDZ
6272	fee_transfer	1522	213000000	1	CkpYQ5pbQKWsGmDXb4T4wAKZNzJTEQtTjKb1CoR6vauELc519MXVA
6276	fee_transfer	2199	238000000	1	CkpZXFuuwDueSPhTTKsHmr63XDJ7DQBWsYX4gJNS8Y5VnnJuCRrtf
6279	fee_transfer	1402	73000000	1	CkpZFni6AQGLWuyZ95xfaiA8Z8Lv9DYx2x4RkHMoJ2adzdzpnNCMZ
6281	fee_transfer	1536	1059000000	1	CkpZjtwL1iix99Jb2mKgoA5QqTdgfPitQz7JMXygFqy1NDr2EPf8m
6282	fee_transfer	1536	12999997	1	Ckpa5ipiRDTC5Xdn6eLhXw7surEibH4Ayk4Wvh9FTY4XeGYZHeiFz
6283	fee_transfer	2221	2	1	CkpYSaznmKdNyhQw77kpTSjN5XagspGUbqpNUU9n71N1saN2YXxGD
6284	fee_transfer	2039	57000000	1	CkpYcU24KL8ZjBKZfY82ZBzXqi59uKMfNUu3zEt2x4p8H4TtAbacf
6289	fee_transfer	1395	52000000	1	CkpYUqXMcTUCt2oHimFpMNbKsitKz2DJtUWQJLxGNZm9BH1zg9gWQ
6292	fee_transfer	1549	64000000	1	CkpZ7zR8wMoYFq3NsNswxFwTuG55okTLrMPFWcYiAH2D288hPkphB
6300	fee_transfer	1685	213000000	1	CkpZynmHPmGNgiDRU58E6ivb6GnBgJG2QsHZAP3QKR8qPXzPYcPvb
6310	fee_transfer	1608	33000000	1	CkpZvJ6UTvLCMbTGtUYUPvjJm4sfS2PnobvfGNJRdUaghcS1qEKyq
6313	fee_transfer	1673	24000000	1	CkpZhhRXeEW3pH9sPsT8yzrjuahUH9T9wESB1GVudGw1yupKQtXAB
6319	fee_transfer	1568	200000	1	CkpZ6ffvWT353MtHVSR2Nj2Nd63ZNbja2EbM2JWwXExPpYhXcwqua
6320	fee_transfer	2097	259974	1	CkpYjsLhzGmKFQ4bXpFzmktuqryFN38EhjJdW2bXV4tKYq4dBrtpS
6321	fee_transfer	58	6539604	1	CkpZYYTPLLxrtaVbmfqjFuRS6oQbsWrC4QehKWD5W8cPWYxsXSxcf
6322	fee_transfer	1571	424	1	CkpYrxSWsgCHo9f4ToBC3UC4AD6oFS62UU11YJvWKiaVACbEEHhBx
6325	fee_transfer	1613	1254000000	1	CkpYVV3dhKss3FiSR84hq7GSAySCwaK2Wu4nW81uNQ4dEHgWqMwMa
6326	fee_transfer	1613	17000000	1	CkpZMnHt5NCdBfyzYopZZsqSn3C4TjbDD6M4s5L1sVC2FBpzCEDbg
6327	fee_transfer	1402	7000000	1	CkpYvnnt2W4zy8i8XJYpR9RzYmcYJsjyAZSxXJm91wC9mmXVSzBS3
6331	coinbase	326	720000000000	1	CkpYx386aARKDmKtxusjA7hsEVTqMQe4Hfao9kE294KnMaLUyyHhk
6332	fee_transfer	326	12000000	1	CkpYr5BEgiGfpKpxZvK9VgL5H3r6ohZkBjT4MvziHXCLXZGXHJ57w
6333	fee_transfer	1458	29000000	1	CkpYsdo8HZzjSS7sko9oYCbWziQeYPb6zg47mtZSUpPzS7V7CuBFn
6337	fee_transfer	526	1880000000	1	CkpYpKMXbT74X7cNKDJf9Xe6ZYhjmSaYvZqsCPEafb9Vr9pwxSAxG
6339	coinbase	1443	720000000000	1	CkpYetuHh7CN42G1ZAK1g4uHQqdrnd4QrDWQLhWdhepdFhYmf31WN
6340	fee_transfer	1443	24000000	1	CkpZW7UavKQF7HvKiFKkPTVqzWvrpVLPpwgQJJGzN2ZQkTWFktZdy
6341	coinbase	1536	720000000000	1	CkpaFAsh7CcgBDC31VpaPaSNejQ5nDfCKdkBjJZXoyAMbZJYNHWaw
6348	fee_transfer	1593	41000000	1	Ckpa8SgwzHk2SSQwG1VmNFcyNvrpNLNaU9hkvcFCu8wDocVtGTHB9
6360	fee_transfer	1756	22000000	1	CkpZ2tpe3GCgwbx4Q8HVRXoj3LnD4Gq2qi8TUEZh42q2er6gJgAHG
6364	fee_transfer	2112	24000000	1	CkpZad7WspCja2RKmeDuFGXdMLyL1srqHnSPRCYKYMKfDimmwp259
6378	fee_transfer	1693	125000000	1	CkpZyqAyhWahwVZi7ocm9FGuWJNjPCA3YHjUnx1bErLReGReXWZ4m
6379	fee_transfer	1536	23000000	1	CkpZfqwRaBotQbP2n6erQ1YsjH96nrKtkFkC9k6chkePW8b4S1qi8
6382	fee_transfer	1402	482000000	1	CkpYciiAqqk6LGZWKnw1azAHu73wB2vVc4t4LnyQbtHEeafP4GBQV
6383	fee_transfer	1402	85000000	1	CkpaKKG8pphmqzswpP2EGA6bSxqJuXdVaeVaB8z3ZKSJ76EWiFGFh
6384	fee_transfer	1599	9000000	1	CkpZywK1AK88a1wcoAYjGrUyM1J8cntPRHVCrZiRBiz7tXn8oqCjR
6388	fee_transfer	1703	24000000	1	CkpZWX3vyUUg1yMhpkGagGbJWV9qb7znRkeuhW8VGApxSq9MQUpht
6394	fee_transfer	1546	24000000	1	CkpZnfXAzWEecLA4KHtCj4987vtKXbH4nurmtceXYzMmHkorStS8x
6399	fee_transfer	1394	16000000	1	CkpZUiL8PFtGkpKPt6hWYvmaZAas1DQRmdkMKUo6qbfdnUkAQJhmP
6401	fee_transfer	1623	16000000	1	CkpaFuWy9jocAtsQkrNZ48PioLMeguazHK2qs953LUAN6x9bQbjqo
6407	fee_transfer	369	48000000	1	CkpZ78Xu8g7BsFuwSxe4C1bWUp3WiSY3w36iSYUkz1Kp1Ea54YkXc
6412	fee_transfer	1555	24000000	1	CkpZzicHdLr7C41ZeXTsyR9aR7j9MqSwj1jy2RSUKskDJ4XuV91Lw
6416	fee_transfer	1634	688960082	1	CkpZHMgS2UvpY1NVcDyPUvN4GLfMHJBYV8szdBwkiRV4HD9EogMo5
6417	fee_transfer	2257	1	1	CkpZSMQoKfJWPRZDqyhjBCapkrs8kssicfrDNfjbvYLZtrM3Wab6m
6418	fee_transfer	2229	1	1	CkpZwSRfTQb3Anqqv51ucbDCzDrXvgPGqHij1psPguj4iBofirB9U
6419	fee_transfer	435	30000	1	CkpYUHRttuVcCV51NWkTDXUycJDzfMm5XcqGbFhpCkpLJrSvruiSZ
6428	fee_transfer	1423	22000000	1	Ckpa53hKGcUsMMtcjKJ24sgt4JkdwNT3k2dJNTo8HEdwKsuZ1r4oP
6432	fee_transfer	1686	84000000	1	CkpZEKpSNJYixjQj2Qv6vvduUUxGgYcc2TyyX3Azx3nEEbwqxh2Vw
6435	fee_transfer	1724	4000000	1	CkpZBGzUV4zKq43i7zK18sB3dZiWhb4FeLdVmC9tmrke8VyKMtmWv
6443	fee_transfer	1638	13000000	1	CkpYfEhWr9gkHDhy2hoRMb41t3ppLGyeNMMpPUqnz17ape9Bpmr8H
6444	fee_transfer	1980	50000000	1	CkpaGjRycsnnSnbNSxNZccmxRjzZsmREnqZG3YUKvVcGVZRX2D2Z3
6452	fee_transfer	1747	42000000	1	CkpZTaadh6i8hqWmiK1rkFU6nvphZbiZkw6BgJ2ZXGYuHfmpGxXnA
6462	fee_transfer	1690	378000000	1	CkpZY6gVjeVUaXrqgpFV4p2mMLiCc3rdCfAtph34s1cVoLoayNs85
6463	fee_transfer	1690	14000000	1	CkpZs4xsJHcG5YAUoG9d6vtGn8UHqtqQFMHD76Qf9SxZMtQGey3TR
6464	fee_transfer	1474	37000000	1	CkpZvMdpUJpmdRX3eyY1eZxeK8G9GKBHKcnC5A1hmq2gSW2PKqRt9
6466	fee_transfer	1547	24000000	1	CkpaB6djCaFFRpQLTpngW5BrtUK7eJykBktNRcda2GCehqRQ9qLVx
6467	fee_transfer	2292	13000000	1	Ckpa8JvP7KyFQ3m2bsSvnudefekLmfEqTc8ECNN7mgAXAVAmtKTuw
6481	fee_transfer	1611	413000000	1	CkpZrsyaezmBMKrX2SPGAkMxMMHDhjFXc3uBZtQ2PbdMFxABLTnAZ
6483	fee_transfer	1991	25000000	1	CkpYgKXes9qVpU2qwdhceWvNAgE6dQVi9421A3ezXdrUdeakY1C1n
6486	fee_transfer	1611	5000000	1	CkpaBXEamAy7YY5yswD2YtJ6tCbLwMTAL7FZWZDsuQj8dbcxwLRAN
6487	fee_transfer	1608	25000000	1	CkpaE5BDTm6wihwyCY8i4YXxiD3LqoCKGPUgv6PdFHNmvGbaGcphg
6489	fee_transfer	1756	54000000	1	CkpYknscDTfN1E18B7Wtui7SbQNmmD9UNZE4j4VkyjSeMWHtZN8oE
6490	fee_transfer	1698	36000000	1	CkpZH3oUYYCD3Wd3U7w3R1RQrY5fLxZHEWrUk7ZKf2cwX9t4X4uXf
6493	fee_transfer	1611	112000000	1	CkpYvkjurEFbnm8TZ7dEkVxgMEUqSVCgHyCUwu2L3MyUVpWdH9Q3q
6494	fee_transfer	1587	14000000	1	CkpZRzkM7sb1cL5SVFinKwMM8h5Ue4Zi1CStHKUX5V3jxvmVQYPAf
6497	fee_transfer	1619	14000000	1	CkpZw1v1tLiSHQkVnMkb8DzH4UwYD6AHactetAbXVX3MzFdBBmKg8
6504	fee_transfer	1522	25000000	1	CkpYhSyMjdK5ULNMEpA9xhSeL7bV9iarUEdbippkjHn5ULxkhjA3K
6508	fee_transfer	1506	1660000000	1	CkpYx5Arhj5nxhz5gfGEfJGv7bocUb9Z77osLdzff8jDZpoVRUtVk
6258	fee_transfer	1522	44000000	1	CkpZinP1MRKEUERSbcXCw35KAWxNc8BfTEcfxJ3VN4Z8fUBZZ8sRs
6259	fee_transfer	1476	22000000	1	CkpYeLTLmnJbtxMwZVoiVd6AB8d9ffq3ciJPH5gpBXqt4DsacnVst
6261	fee_transfer	1681	54000000	1	CkpYhUoQ9nB8YisKenAHK659Qx8c6Zx3T1ELeBHzPeAPEQrtgrVnf
6262	fee_transfer	1680	113000000	1	CkpYdStA9FcRJKqyhR4jnSqUMYdVFB3DT9j6CSEPUrN96tJdHvpzM
6263	fee_transfer	1451	200000000	1	CkpYdSyoWJsTWMNCJpc3GwRC8SNkHTCr71gMzDBsTDUZFRHAvQhiW
6265	fee_transfer	526	1150000000	1	CkpZTKZnBvBtRpCZD1kqbEKT1fyEJMG1QGrrZtmjAt3FStuEK9gxk
6266	fee_transfer	526	190000000	1	CkpZvM85J1NgLJzopdYFLD26mvWGMGWovsRgk6896SSgyDQT6f9d4
6269	fee_transfer	111	2000000	1	CkpZpTEo3ZhpGbee84P1xFc23rh8D4v6gbVtyi2GUgK67EmUgwaSR
6274	fee_transfer	1594	212000000	1	Ckpa168euE6faPVYk2iH6NzWMwmhNwEZ5k4acngZLhLqzQkxpqWVk
6277	fee_transfer	1684	24000000	1	CkpaGWqrpx7eRysBYgMsnAjgiTuzmA942dUFJbjdas14womowL9Q6
6280	fee_transfer	1611	2	1	CkpYnCnx3aPqfGzGG5216VtEKQrZxmsNr75pzHXw49YhHDHMZbmTX
6285	fee_transfer	1471	57000000	1	CkpZMa28PyQYkABUFNmmiLC1L9rkkZrfnTyAXSTDA5fKzzYxBcbLp
6290	fee_transfer	1408	52000000	1	CkpYofrXx8EoJ4mP5YYpzFFvfW9jSue2KgXwmZ363zbTvBuZ8M2Q7
6293	fee_transfer	1657	64000000	1	CkpZsHYRiWUwRbTGs4ATpwXYd5JSAAZygXDPp3HhxbqdfGuCguT8v
6294	coinbase	1657	720000000000	1	CkpZ2WxMkoZbhCfmW6s2GfiEiXeMh81q4NYHQKQHQL3M54oGvNGZh
6295	fee_transfer	1758	3000000	1	CkpYvMBqcxfLiMgrL1cxzNYySLRqZHotzHm1CoNz8c46rRcFxV6sn
6306	fee_transfer	1402	37000000	1	CkpZZXtFe1LF2nkc2uXn8Z63RwGQGKG7r9vZcPrRboKMuDXm8sxtz
6314	fee_transfer	1440	1662000000	1	CkpZoLS1UrJePyB4bMcv43qYtp48tHayg7B1i9hrBRBoCCGMFSoMZ
6315	fee_transfer	1440	16999864	1	CkpYW6uwyfM8XEB9yXBNKdbDA7tjMWwgs4eAZksExy8kJmr1qy5as
6316	fee_transfer	1571	136	1	CkpZKHart2mobeA9SMt9wCp35WfTVoqzJACg1k2gHeTZsGiiWGNpa
6318	fee_transfer	300	12000000	1	CkpYefaxZW1oigPZ14FvFDk3pZ1pNyr9XpZbf7Fn73KrgvTettcWq
6329	fee_transfer	1602	1150000000	1	CkpZ4YBMiMb4PwCfoccVHuDXuWagoc3tAMdzkHWgCZU87xa3WAxPq
6330	fee_transfer	1602	160000000	1	CkpYskWgCjcQbNxDGT9NjoMopinoYbSSFchRqutQzVidYL82yGB23
6347	fee_transfer	1419	35000000	1	CkpZNMUKd1ZAwCeWeAWbb89mCPY8mfHUxVuUk624kfi8Yp2kWuZj3
6349	fee_transfer	1593	42000000	1	CkpZ76JeBXf4WtVTruCj78KsGWpfXaaD622q4433mUHFaNwo8amED
6350	fee_transfer	1426	13000000	1	CkpZeBSBBaYqQinW6iF8hpfskP2YQy49qd55Yy4oCHnhGkded4Taw
6357	fee_transfer	1739	1730000000	1	CkpZrmd5jutRc32qRe6Z4Bhp4Uc3Md23KnzVzLqnnzyTa22nD6HfK
6358	fee_transfer	1739	340000000	1	CkpYhPvnHrWR6z4NBoyAeGVii4sbjLWtHWLwnPrHtLKAgY5NdAPnq
6370	fee_transfer	1675	32000000	1	Ckpa51p8Kb5kELi2KhrbC6kLeaooF4F73K2et4NBXVTpSuSxSZ9Fm
6375	fee_transfer	1634	54000000	1	CkpYm6HPXMfFgqNsDDxg2LXGUJjHz2rcbH3Q4d1RHv6hc35rGvuTc
6381	fee_transfer	1619	2000000	1	CkpZG85KDULrn1KWEfj2r5RAKhDG5XTys5UxfgbQvN7SEEjtE2VQH
6389	fee_transfer	1702	24000000	1	CkpZPjeH557ZujV5TqjGJLoAqrRBCTsjV1NXEC87qmStEBtdyucwX
6391	fee_transfer	43	161000000	1	CkpZUQ9W277kNattq19xhdaVpL915HDXRDzjfS9vjS7DM5ip1tmY8
6397	coinbase	1613	720000000000	1	CkpZfnh5KEdKHTS8tUKDj9VK4Mfi3TrAjBMxyDZH7uLfhWAHHvvqt
6398	fee_transfer	1613	11999998	1	CkpaB6o7dfBzTUgXkBVo7SSDks8KddjDgyHTpHDCDZ15ggUAgAUdh
6402	fee_transfer	1695	490000000	1	CkpZyUWjBGLDPGzcxbES8LV4dXxnCoLfEVRP4CSbRdHy7oZtMiJmk
6403	fee_transfer	1695	707000000	1	CkpZJosmis8ciGgxCEtpx8UNQpE3SLH2M3UvzQ9g9H3UgrF5ZfAf8
6409	fee_transfer	1850	24000000	1	CkpZmnweuZ8kRmNRsmvcwy2EDaJGeR4A13dkhrnhV7TLyB6Bspunf
6413	fee_transfer	1739	1010000000	1	Ckpa5QZiG9K11Qg9WsnCLbARBBJLsJEeRNn8kLq7iZEdBhxhLS73E
6424	fee_transfer	1471	35000000	1	CkpZFzmdSMEhapjjAVaDuvqN5WM17JTijKrH9UJDm4EnhYRNhtYjH
6425	fee_transfer	1749	72000000	1	CkpZBxEeYe268JswHL4UPbx9vVYtoJxuwuSGDtBPztMDNoz867uCD
6431	fee_transfer	1762	4000000	1	CkpZAQBzCJeqXuBp2BbepJLaT7wk35uKcuPRpBa139ohYCaGxM7Ne
6439	fee_transfer	1701	636999992	1	CkpYTW1Faax9xYcRaqjLgQ54NtzwRYt17k7n3HrwChf1HXgkQqKq3
6446	fee_transfer	1550	12000000	1	CkpaAjYNtVQTeDrzfmXwGVaV2JwoDNA8VpnvjHwYQSquLUqw8MikU
6447	fee_transfer	1656	37000000	1	CkpZch4hg1aP339fv3YJrktZPqirDkExbVJbEYsv5ZxEs86yy8v59
6453	fee_transfer	1673	42000000	1	CkpZ8WB4DXxh7FUYxqNFX2oQJZwaXg447d4eea8pafiXhqdqkjjRc
6454	fee_transfer	1690	285000000	1	CkpZj3wk4EQaqCb2ksFT6WT4gycYYFwHNWEFUtAW3nhrdj499Pogx
6456	fee_transfer	1686	45000000	1	CkpZZEchcJAz19QQiuFVckM1mceDLaPeoxpjK4yJGDjqBLD7hLYAm
6458	fee_transfer	676	25000000	1	CkpZR8oj8fMmtFURRuLXU1U4n8RbgcNpK9VHLkrecNC2BAg1Qqm4M
6471	fee_transfer	2049	13000000	1	CkpZMAoZQT1VeDSzusbFMDcXT7G4wyaKooQq3jTzxkei4H9fApzSy
6472	fee_transfer	1654	37000000	1	CkpZ9UtawaM1miGXq9xyDqA59WRLLHZdzc9iGh8gJP7UbPWwq1FUs
6479	fee_transfer	2148	49000000	1	Ckpa2ekt2cEPQEUpC1HfWP6KHZhaKFyNHyCGrPBzCBu7DUNo4GK8R
6480	fee_transfer	1457	213000000	1	CkpZDZLzRm11DPjFav1pYtg6PcAF9LqXvBaba7K6XeXDAueMqscGM
6488	fee_transfer	1756	704000000	1	CkpZFhN68qDuU8wFgGyCzobDEBq71RpYNFNLtBUfAwy3C4TFQqAw8
6498	fee_transfer	1705	24000000	1	CkpZjDaK1c7Y8YCyCYneXgLneVWjhKZGkTu65SQoo8C9xBco8YUZR
6502	fee_transfer	470	52000000	1	CkpaGP5oFXKm1YrZM5zCECJUPLPdA8qv1HhEzMQgBUV3NzPGgFKga
6505	fee_transfer	1686	38000000	1	CkpZZSDXuUhEJpXuqjLL6w5ufAgtKWgHek6nTdzkjoYUwEv8FxFSA
6507	fee_transfer	633	26000000	1	CkpZrHfYbgNtVVhqhgoGtum24u5W2wbDY56qi1amTUQ2KAj91MHVr
6516	fee_transfer	1394	4000000	1	CkpYSBabhCAYJ178txE9EscwoVcYhSS3gQ2rpSTsDmBz8SpBEs2xv
6522	fee_transfer	2112	350000000	1	CkpYo5fYrf7bjFqV9hvzrUhKsSc6s6BjnSFm1yNc6qwzFxV2Yg6h2
6523	fee_transfer	2112	32000000	1	CkpYa6afTm6NmXH7nDsy4uGtfckaZM8ejVrUsWAY9UuwU2yTU5xrR
6529	fee_transfer	2260	20	1	CkpZvg1e1eVsb1VcLSSKsZdfLJnzby8fBKZZVdvJtEmeaPyeRcbWL
6530	fee_transfer	1501	3200000	1	CkpZX3hyC81JsChqgrSA6KJamAb752YGTrcFRkWHWyrPEd2rthqeR
6531	fee_transfer	1688	799980	1	CkpYyhFBPA4kQqHLxAzD8BGGgBjSGvqbHqNX5oMiGiV2yAY11ZJxk
6532	fee_transfer	1501	7200000	1	CkpZM5xySv1z1gpHjJfutHtRWJkRYjup1XS6vo2sUjPJrXGU9Kgxe
6533	fee_transfer	1681	15800000	1	CkpYQrCHRfv3DQUjkHGK9vCoo4eUXNC4Abuj1iZPyorH1uoAVYAPR
6537	coinbase	1649	720000000000	1	CkpZie6dJacUtwkU3KT4dtuKcyUh1S5TuEbwvJcEBBkNZSpjYiaUk
6539	fee_transfer	1701	28000000	1	Ckpa76sNhRGFJ1BaSuG4jgDcJVDWYfQxERwx7q934VVe3GRgiZMmQ
6541	fee_transfer	1708	37000000	1	CkpYuMVBtWHevwpv9aEegG9o4Wo1s1Q34tMfBSqbTKt8DbxSGFPto
6543	fee_transfer	1700	34000000	1	CkpYsVzGFE9czetksi6TSofB4ZVQjqPR6r8jMqGMVZXXgJuWXibQX
6260	fee_transfer	1740	28000000	1	CkpZu2DhqSMbgE2oKoAHSi6jHJ7jw2op34Zc4PSgHAY6rCYnF1tPS
6267	fee_transfer	1506	720000000	1	CkpYmK8bTeDLApQ6CksRCnnmd4HmHmv148FkpzsViN85xjPvFCJR9
6268	fee_transfer	1506	790000000	1	CkpYt9y3WTzeuDRQg7BerBvDvN8kG8a88DUddsGR3pHNjatmPm528
6273	fee_transfer	1522	3000000	1	CkpZwR2iB9QCD9LmHnEni8JtpLX9KcmeXKgConeTU787MQxjeSfev
6275	fee_transfer	1690	412000000	1	CkpZsNUP9Jhii4ZJgmoui4SvBjqknEke4bUCqXRfp5JB9fw3Ur5HR
6287	fee_transfer	470	57000000	1	CkpZyvPPmME7yYiTgNvyq5JiJLzqB215phfLSMPqG36d3Qrx6NneZ
6288	fee_transfer	1402	44000000	1	CkpZfeswtRk66hTnQ3FjEaXnEcqbHhidwgzag1AsTjDFadQwvRQA2
6305	fee_transfer	1599	37000000	1	CkpYS3wy7gooHCP6WYxNvFUmig8Dd5B2Agx6QCvHG4aUeEy8ADxbW
6308	fee_transfer	1544	11000000	1	CkpZmFVvYzWyKvJAWRY4cLdV7pbvcThNNkfz1QQGUxRWYDF3RKX7s
6309	fee_transfer	1696	33000000	1	CkpZDiG3vgxkVGQka57wb4CJiwPbK6zEKDdQVZprgoA4FGbz9CPC8
6311	fee_transfer	1541	13000000	1	CkpYb6PGpJS3EPgJJP6heMftPtYpQUXE5vyqQbP1q55WBXAYkJbfN
6312	fee_transfer	2039	25000000	1	CkpYiEiSR2r95kRtTyBmXaRjzWoyhknNFvt5EHQuGogf8xkSgvsmL
6317	fee_transfer	1506	1280000000	1	Ckpa7DNe9f4kt1NiNwGyRr5HFgmSPCJXYtTawhEfXVathsavW2LXh
6328	coinbase	1536	720000000000	1	CkpZUi2UHheF1SLAaYUtou3MLRcJxH5DqGCMUJbsgDmuWMpkeHvEp
6338	fee_transfer	1474	3000000	1	CkpYewavJaj5KuzzTxTLR1f8zkgBduUhWzcbtBcZ4LEynqND7wrXm
6342	fee_transfer	1714	14000000	1	CkpYVJou3EVhuEVgGLbSXkZNT4gAQM1Vxx3TkoqPBT5QJUgjwM5KC
6359	fee_transfer	1708	36000000	1	CkpYttfdxHwZ5tAxQnhkHf2DQNFgQnq5bNjw8rG9FFVC2K4RWNmet
6362	fee_transfer	1560	1710000000	1	CkpYz7znoBiM5nE5r4RcuVPz2rb645jF96VFGng9b9szAwN14M5gX
6363	fee_transfer	1560	360000000	1	Ckpa5VzeGHjhwPMcFW4XZ7sXq1azaupadnXXadHMRfxLYNGiBhK6p
6365	fee_transfer	1402	400000000	1	CkpZE8ciQW1Pm243J3fHkQnWA2qykXNYj8bKKqgcGk77u8yrCag9u
6366	fee_transfer	1402	310000000	1	CkpZXS8zTxNajbkbxMK1ceUp6W6qnZcFpL43umG2HknaXzg1VssJC
6368	fee_transfer	2087	32000000	1	CkpYpg6aqMvoGmTf1cBV6UmCqPv5NKVquThhNnX6taxhNNsAx2wyT
6369	fee_transfer	2087	44000000	1	CkpZGemRwopoPSoPN5mW19ktSHuVzamhscehQmyr3gtJH2wxJX5aD
6371	fee_transfer	1593	54000000	1	CkpYRv2kA4iHeUosMbByktXc72igjrJ2XcjUwNfm3h9QxgdcscPp9
6372	fee_transfer	1593	1999966	1	CkpYZTRdApjWLek4dTKJ2hs4drUTKw648b7Z5tp7up1QQMXoFVtUM
6373	fee_transfer	2275	2	1	CkpaHrG9fBJsYuAYJLz4VtVc41CM517pNVurdwAQXsjoiAJUmi9vk
6374	fee_transfer	1571	32	1	CkpYggGkGsagP6gdsPbkvQ2RdUbpE2i8Ut7oGjQ8r4ZKYvUE69UEq
6377	fee_transfer	1693	122000000	1	CkpYu1zGepfNqfzzN33ins81WPQKRE8o1oq6qbBKwaNmE5qEYZsqo
6390	fee_transfer	2112	460000000	1	CkpZi8EkAKfpMutTtHJSMZzE1m8mtu8T9ypjjrbpym9eF7rbuxAVx
6392	fee_transfer	2112	36000000	1	CkpZ84rnCT8Ud3ueqtcwdTSD8kS1H1wXtcceRJT22pqiN7ej4F8hp
6395	fee_transfer	1402	238000000	1	CkpZun4E8VTUtA32ySEhTSECTxGoaywQmAQsApJkn4MT49WXFKL75
6396	fee_transfer	1402	29000000	1	CkpYv1oi47ARC2W3iPpfWMtXoe1AMqZ66CZjBPcsTcDpMMrpBwd7e
6404	fee_transfer	1695	296000000	1	Ckpa9Vy7sjPzqD9GxYYBWcCAYubfjokKmwwmvXc3MWQVKe2PYMLfL
6408	fee_transfer	1395	48000000	1	CkpZrUsodsmdNxZSRtFGujpqLWgiddpcdBt4N2rQrnLLwQPF6YyoW
6410	fee_transfer	1476	1021000000	1	CkpZ7HoojRuvnWFf8RiNzmRxmvJddZ4Voa9sDpWn2q4h99f5cgJSy
6411	fee_transfer	1476	5010000	1	Ckpa73Tib2rU2WeENHkwJfVvcn7HBgXvaUhghaNRCC6TxH6y7P8uM
6414	fee_transfer_via_coinbase	1438	99999999	1	CkpZGUTYQipLzZ6RgEFSGodYQFYaK7BbnvtKptWuxXjhSHyGNeyzx
6415	coinbase	1684	720000000000	1	CkpaE48oz3tFaWp37igszWrZk6Ybo4ykedmLeQutyRrE3zsiBnmiE
6420	fee_transfer	1634	197975001	1	CkpaL3bCrwtR5RrhZ8wd4fZsGjake1c1Au7ZRxYuRHJBqXutN2spY
6421	fee_transfer	1634	209999992	1	CkpYyEqcDt8cWHdNBtgDZZEizj19G4qV8f7ZcU6fU3an4vb61qacB
6427	fee_transfer	1671	2000000	1	CkpYTt8VYBFcKNBFUg2ZPkM7TtRFxWsSQXeGMVB1DrJYURSQGDN37
6433	fee_transfer	1756	36000000	1	Ckpa7HJUrrNe54NjNwdazA9LEhndoZaSCGYA455mBaabhLnN9GR2Q
6434	fee_transfer	1714	36000000	1	CkpYw5hy1TccJz32L14neH5eHzQqvWzWp4ohCYLrKd7DihKzWzG9T
6440	fee_transfer	2248	25000000	1	CkpZ23rXgiz82QM97zgWjJ1afd8Twzfiy76hVJ8yLpwmpoanbzBvy
6441	fee_transfer	1670	1170000000	1	CkpZtMbdJ74caivL4upaVL4y4gdyxJdCc6fzaqpQkyayJ1T4jE6M7
6442	fee_transfer	1670	180000000	1	CkpYrU9Qgcd5TyB7E5aVVLZbbfS2ztPsk9uRiF4xt6W9ZRuvpXrj6
6448	fee_transfer	43	49000000	1	CkpYTea5UTe9QBFHRk1hGCB3dhzpT8GqZjRP2dZEqnPUZgLmqx9rk
6449	fee_transfer	1746	42000000	1	Ckpa2Xqmp2ydX5w3UVR9FKVepQuuMMcdkhuJotiS1ytJb4guAyucz
6455	fee_transfer	1613	23000000	1	CkpZ7TFjTd9hF8THsP2AoJRaZnmgiDkaUtwKQNHZ8cSsqH3PQMRSh
6459	fee_transfer	1509	37000000	1	CkpZ1sGp3VDvY3ZsURekCiCTPXxtiM7iMEzYepaEk2KtGueaGFVTd
6461	fee_transfer	1679	122000000	1	CkpZhGKMLZjNzDWZLtDCdznyg9LYmw9uwEzr8gEzrqmEUqCthsPZJ
6469	fee_transfer	1850	38000000	1	CkpZPFF37XPXmzcnTkowQHK6F8X3c3MBeyzw84UVdU8F5jFZ3ZyJv
6473	fee_transfer	1664	10000000	1	CkpZapi8EXS1H1zPzMYLsDCoWJxb37s7iZzkga9ze2UiVsCbRhM8Q
6474	fee_transfer	2052	10000000	1	CkpZY8SBKu8BdnDTBt3eYxxWM4GhgkDM5R4KHbp4wNs8LKHVeGGUp
6475	fee_transfer	1555	8000009	1	CkpZ4roNiERxZgL4kdngjhEtVXvTeEUrcexv6VPbad2rbVD42sa7S
6476	fee_transfer	1527	8999991	1	CkpZgHJeipkdzEnMXqUMen7Pyr2Q7rpnVvHh1ZwYgzQBvgR43WShN
6478	fee_transfer	1555	37000000	1	CkpZWrLst3Yw6cbH9f8V3NMVQ2cqAvFY3xNeeBxpCXq8CRyU2KxKz
6482	fee_transfer	1717	612000000	1	CkpZokefm21sMSui6ovhHM7Sgstk3H7HEEREx9PAKbe17niViPb2i
6484	fee_transfer	1756	1000000000	1	Ckpa2wX6XdKnvJMq6Htwkg1v2uRDcafxLpJRwMmSWQ79zY7ErDLGv
6485	fee_transfer	1756	1460000000	1	CkpYZkXrtXz9ZhbuUbVstsJ4bNkxYzYDqaZK3wpsBjfQjirEZbdTX
6492	fee_transfer	1471	5000000	1	CkpaJ5QjaujPjxiremadesgC3vnNF3iaELcppmaFnjKDFdidGnZBq
6499	fee_transfer	1701	44000000	1	CkpaLDZUjYEwcEkHFcgsd7h7TjJ4rTvYx1PPUsRXgTxG56TSRZwbj
6501	fee_transfer	1764	44000000	1	CkpZrH5E5PLKhDyeQFKf4dk72n1LCGw1nLc8gRkXejK1dcu9oWAZi
6503	fee_transfer	1705	62000000	1	CkpZRWjePEhCDDWZY63yM2a3GXyPqT6JKNo8BaGpPtaEkzAuriATw
6506	fee_transfer	1980	38000000	1	CkpYcKY3HaFnxvXdfKc7tXqjW8MiNe2TmTfdfLGDEkTikHMJukZo1
6517	fee_transfer	369	4000000	1	CkpYVzAzCg6SXyTXVuAU1yREYBtU17VsRiUGX5FegPatKDyn5Vghr
6534	fee_transfer	484	17800000	1	CkpZmHMMQ8pquF2iod6HMr1LhX9nWZb4bwBLQEjUC1SSXLPHtvV8R
6535	fee_transfer	1735	25000000	1	CkpZMTfqTkRNCGDAZ4kEJmyFgwv241qJYSLQqoY6D7RQa7hFXYEQ3
6540	fee_transfer	1536	25000000	1	CkpZyuxUsT1DDc54s4Q4wVxNPMhuGLXegQLbakmtqVBbGT3joYfMn
6544	fee_transfer	111	25000000	1	CkpZN4mNVRtM8xAQdrB6hqQ2yfQUehxZc7iwLPj73y3M3aDzHTjUT
6278	fee_transfer	1685	803000000	1	CkpZDdJzq7ivWyg4nZpW5RXogteSLfYoBvgjx8q7XU4Xf3DAmXHF1
6286	fee_transfer	1724	57000000	1	CkpZQ67qm9gVN1PwucwqdZnyy43t2f9tQEtyqjPEHnV3Fh1zjQhFf
6291	fee_transfer	1687	1860000000	1	CkpZ1ju4XVUfwmc7gTnzYdXRfmD8srPaMBRWzWJaffcVHFivkox2m
6296	fee_transfer	1657	73000000	1	CkpZiCcMnEytHEAtFvZzz5Lgjz9hh6AwHKcqxDz7opDD18RGZudsX
6297	fee_transfer	1657	4000000	1	CkpZMSk4jtMihD5g31uet33cJrht2bZtVqQq299s4WnYNXmaoZYdr
6298	fee_transfer	1695	33000000	1	CkpZ5vwjUunz2WCN4nL4hSAGmqPWwwhEHK3byBFtpQKvQW7Sxg4yR
6299	fee_transfer	1719	92000000	1	Ckpa4UaKZNJM78uErq1uQt5pvyGe5uYWJ48MUsC4EhjHToG9qjQpP
6301	fee_transfer	1680	1042000000	1	Ckpa4T6mfKpWnrQqCYBaWVDf5bmsCHPivZmKPzjrDFX8r6JVDuq9U
6302	coinbase	1680	720000000000	1	CkpYq4rmq6RiFid5wnm9xSgtCUmQUA39KoJYRDKUUJPzHFxgrU5h9
6303	coinbase	1619	720000000000	1	CkpYV6fVnhY46TeWKsux7DeejvQ3kHUv817AhVd45ufyA7aVVfohZ
6304	fee_transfer	1619	12000000	1	CkpZmRrg1RhtBjx8tToGT1TGLsdymbjtofNPWtkj55TM7wcucSgqe
6307	fee_transfer	1698	32000000	1	CkpZU1L5omZtUtcnP6KxsVVtAr1GRcnD7e5EJJynAasSUSQp83oJr
6323	coinbase	547	720000000000	1	CkpYy5FoJfYPPyFPLHxqJZtJSctEQm8Nfd8xCDhnwbkYLV8ueebbU
6324	fee_transfer	547	10000000	1	CkpZVUGVskTNrP4B6RA4h7hAphQ4nb3daezc2hPdDaKCs8NbLNGbL
6334	fee_transfer	2148	29000000	1	CkpZW8R4KCW2bh4ZMVkb4suYzD63nbAHwC28UHPsG1ZxuCkCgsbXp
6335	fee_transfer	1568	50000	1	CkpaGqtoB3pXy9zkKqfc68rwzdwXEhq4Z5trMYZs27BfJDoJ6eBd3
6336	fee_transfer	1395	449577	1	CkpYpxUnx7W4wwckc3YA2L12dD3KXs2NgTfoae5NNfhbUEakgbKQr
6343	fee_transfer	1564	680000000	1	CkpYu4cS2mk9EBM2oPoDFmeVuTZUsCLsKnqK9PEEBhNivM6hvikrP
6344	fee_transfer	1564	630000000	1	CkpZdEq6nDN1VrwfiFM4n5uYYoRmNxjh3cTyPsYwCE4xBnt9VbYT6
6345	fee_transfer	1670	656000000	1	CkpZepo2CCUvW6MEgno1GBPbEY54VcJ5M6E3wfAC4dGkDpaF4QgJt
6346	fee_transfer	1670	18000000	1	CkpZYNtQ9ZDyjJ1vPhU5hdUqcZWUPtR1fBddEmQD6RELYyVdk9Eyv
6351	fee_transfer	1684	14000000	1	CkpaAyy2Gnmro4FWc3MuDK4ie8rsMz3TLMdRbjorVExJCsSLuzNu3
6352	fee_transfer	1444	4000000	1	CkpZUb3RHoYe1kqRtVBGV99fypU3tArchvFZ2iy2VqDrHRW9P8eHA
6353	fee_transfer_via_coinbase	2284	500000	1	CkpZTU7SnT6mqNxRNTJuvaVFHRrCDZ3f49KGBADjH3poBjFNMwAj9
6354	coinbase	1696	720000000000	1	CkpZtVXBc8zj2gbMX2AqBSkSDhoDH3assXEX7NT11Crey9ULUHVbf
6355	fee_transfer	1696	8000004	1	CkpYiBMYYh2zyssWixxRPLvLXSoE6RHi4HgSxwtytc6dszB8NMKsR
6356	fee_transfer	1527	3999996	1	CkpYZKEEYFaKdLg24EsmG8BjSQhZ1sPKne45EtmDmNDkyMicCyXLt
6361	fee_transfer	1680	22000000	1	CkpYWyqbGuyASAN1FEj9vgZGxBWzVUGniv93bkxuthKcu7sQoopLD
6367	fee_transfer	1686	32000000	1	CkpZ2Q3bjbmZeWdFED4Uto57jpqaq7HnS1XAYgn4rXS73YhSYH1Vw
6376	fee_transfer	1679	14000000	1	CkpYTFJfuGg5RBb6k6bWC39Y6DuGH728tqMBvm3jvxNQubcd3v6UM
6380	fee_transfer	360	12000000	1	CkpYWdadr7AkN81ADG9BBZMUWX1hHFXjCCVn4m6dpn6sKQDkHV61C
6385	fee_transfer	1594	9000000	1	CkpZnNmxLS2zHbV63AwQ9jraF4c5nqfG4Ah3BzwGvUpGUFEnx7Yf6
6386	fee_transfer	1564	720000000	1	CkpZ5AS4PdQdzsU5mUsyWDaVZsDU98nwbhYkwxakxrE1ULy19TKS7
6387	fee_transfer	1564	629990100	1	CkpZqKTB1jDhK5LvJrpZfrxjTxni7gT5WcUq2LGxn4hFMhhoogiyn
6393	fee_transfer	1428	12000000	1	CkpYo1ddKfx21zMPGQwHq9HankbARFinPJhhS7DPYdtzuqe1AcsrB
6400	fee_transfer	1701	257000000	1	CkpZP6Sw8wAr3sybZCmA7Bb4zJkN9guVCdKUXSbjHa4QQwUpn1L5z
6405	fee_transfer	1560	175000000	1	CkpZs9jmDZEPoW6hvtoNEk4rCyXFRiMUq92Gnrdm8R5YAYffzXdee
6406	fee_transfer	1633	24000000	1	CkpYmj4dLnfd9jfo1VHBpdewfcTzj2w8ia8XXWvCs4GRFnueycgF7
6422	fee_transfer_via_coinbase	1567	130000000000	1	CkpZjBqpaYqijEDL6ZUwK9UZmq96FQC743SHaC4BFsYJwSrPPnxUA
6423	coinbase	1634	720000000000	1	CkpZPmFi1bLc8CtdqZvHiW4wRMQ1AhzeqaX3MxuA8USmfgWnkbqAy
6426	fee_transfer	1666	12000000	1	CkpZVp1igh6WLkm7yfMpbzvRq8LzPi3SEv1uicBDNzhwXefrBEAkb
6429	fee_transfer	1701	769999992	1	CkpZ17Z7tCrgTWssPQu6DRAudX48djt6BDo9P37wXf8YpSY48KFJ1
6430	fee_transfer	1458	5000000	1	CkpYtjmVDiwRrLYjWiL4vuLPMm42f5puSfGYvi8ZzELCinMVq2ZQG
6436	fee_transfer	1522	740000000	1	CkpZ2QqxPpE93QrceDMenFEo75GVvfrqEbqTcAvK2pQZHgkGpt6nV
6437	fee_transfer	1522	610000000	1	CkpZ4HcqBEeopknyKo399LzzHnwhJ3RjNgmwUmhXnVKifMMHKPVWT
6438	fee_transfer	1619	24000000	1	CkpZ842cAiA6BSnk8Uzh5gUSSyvM54a3EHsHNr52bkH5SJtxtGAoU
6445	coinbase	1850	720000000000	1	CkpZ3RYnSnaNwsAW5MPg4Ji6ESqCUnu7r3F4Jvu5GLNwKXr6iSyHp
6450	coinbase	2292	720000000000	1	CkpZPTbUUHpxmXyHDnq9zQyj7uL8WLFbyCHYBFPSQEAHJufvVdeB4
6451	fee_transfer	2292	42000000	1	Ckpa6qzegx5HtbHV9HDEqaEuQqnvC4e2YGfiB5iExeKjssP8Xo6vk
6457	fee_transfer	1980	25000000	1	CkpZbvXDMJgQRb29soN7fjnmBw5GnBiP4EAzK7sofdZgRn9Bx1aAo
6460	fee_transfer	1705	35000000	1	Ckpa1oJCmrHo6n5XYDLrGJ9eJ3WfyLVMX2sqePmkpRPsTY3XQQaZL
6465	fee_transfer	1432	13000000	1	CkpZYMvaeRbPPefhk1XKyQmwxCy5VV9d2ocq4GwgRz9yXeWUCDMJ4
6468	fee_transfer	641	37000000	1	CkpZPUhdDYpJDYWKLYRXK6CKpSHyQzNh6E2RGvcM3w8dFEXaqFFVC
6470	fee_transfer	1426	38000000	1	CkpYyTaPKveZyTXguxd1JgGyga8KGc64mpuN493qRpdM6NhTgFQcN
6477	fee_transfer	1615	37000000	1	CkpaAdCpCjGcYx6Nn4iUgiMFLpEZweP977gRJQMN9kftKdrSXY3CM
6491	fee_transfer	1599	17000000	1	CkpZcUVGPgaKGt3QtTqh6HyN8k2K1wNLgQbTpywg1yWRGGk8xuUm7
6495	fee_transfer	1619	299000000	1	CkpZNku4pLsPVQCqzRY2m5Myb1UCWYYDpMsyvCwgW31drT78Pj3pq
6496	fee_transfer	1619	22000000	1	CkpYywF742sQaZn87Qr9X56HWHoNTmkKwbvVpU8zsnqtNRs77J73r
6500	fee_transfer	1422	44000000	1	CkpZcWFVPygDEnu1hpJhgpvMxBMQanWVwwLhsK5XG2W8zeVQ2EjnH
6518	fee_transfer	1509	720000000	1	CkpZA4xEMChnsM71anRYHqyHSg1QfC9ELZTi5g5YxktDs9AtCZLC5
6519	fee_transfer	1509	683000000	1	CkpZswX68YHt4AtRNNinAGPjJDXaQZtvwETth3zyd48k5GXwqYL7H
6521	fee_transfer	1467	47000000	1	CkpYxV5WruxAkzuTJd82pioaWReHJEfaxWasQhvuhJVqBt3wtgWxt
6524	fee_transfer	2261	13000000	1	CkpaC14iToeF2PGaWzYSLZTxj81vyoMjXwjtx8vA3VR7PhdsU7DM8
6526	fee_transfer	1706	48000000	1	CkpYeVyjMiGZ3xtYVngJFUp2TfKgT89JpBQGuJkumgbvc5QZhJPju
6527	fee_transfer	1420	34000000	1	CkpZ9SuoSVELwGxWmBpkJ8eTYC26uZjrnuDiTrKK3vMd7uUvdyWCa
6528	fee_transfer	1420	4000000	1	CkpZ3fqpMFS6Lowr5hYH9VUrEA9hKbNQwAkjzfmUCARmnmJNp9x1y
6542	fee_transfer	1700	37000000	1	CkpZ6fhRBB6hXAsUcThYaHgAZwqtHcN48DMdPZHFWweyx1Vh4yddQ
6545	fee_transfer	1588	27000000	1	CkpZKc3MaEZDSqe2nwkVFJBjUkK3xDkiZerXZ79sfSYbv7FVfjwKv
6546	fee_transfer	1764	235000000	1	CkpYp3HCAzi1ZDsKEY6ym4cs1gMHjg5ZUcxKfACTvwzmcXesBrbtu
6561	fee_transfer	1441	12000000	1	CkpaGT3EemhsE83QS2VNM4uZDxzhNiZEdMZVGxd9qYpmMYCcTvi2e
6509	fee_transfer	1506	800000000	1	CkpYcxVrrZBP2ywcSd2Tw9411MRCpGJJMGMvNZydTSZ8kgz9xv6UK
6510	fee_transfer_via_coinbase	2260	10	1	CkpZYasftgrCqZSoozP6gAosnGQYrZJ9KkZct3oMxbTQDVywWy9yK
6511	coinbase	369	720000000000	1	CkpaG8MvrXRg39XJyjMMRC42coCxg4xRj8wUzVpWQqNNyUXkGcJW1
6512	fee_transfer	2260	10	1	CkpZYasftgrCqZSoozP6gAosnGQYrZJ9KkZct3oMxbTQDVywWy9yK
6513	fee_transfer	1501	800000	1	CkpZmoFxstwb6ALzy9NZ3eGQnC7kAFTj8tSyxZhbsBkaxHWH5PvYG
6514	fee_transfer	1604	3100000	1	CkpaEcRMJp129o7d2fjo26JJuVcvQpM2bfJob64YXX8t5SYPqxYQX
6515	fee_transfer	369	99990	1	CkpZi7rArWE5hPss3KSKSX96QSmHMPPBcMmzHfZmkTaifpDXg7nDX
6520	fee_transfer	1571	50000000	1	CkpaJomgx1r2F5NWSTznr4SNrb3aWxVwGsfKxKSg2ePMkmcZRoX7q
6525	fee_transfer	1711	35000000	1	CkpZCbG3R4KhM5soR5q7f8YpAZadeFvZ5Vj7CuqMTX4ea7nHX8xdA
6536	coinbase	1691	720000000000	1	CkpYVXwtcTvSCCjHRP1SWK2kQS16w1Ynqbmq8FVxciK1q9sA4jvJ6
6538	fee_transfer	1611	38000000	1	CkpZzDNoFvAhdT1jcTxfqgpdDqTgfkvhs1N6uvp7hyrwoHAWwE9Vf
6554	fee_transfer	1696	37000000	1	CkpZGp3ieE4naYgNibyfnkLiCDWtLLDHdTZCyMADB8uttuj4k3upG
6555	fee_transfer	1714	70000000	1	CkpZVXKGk3YRoZF4PhomRWADBEofX1zA7DhaZH11dJXPju3EqHw5B
6558	fee_transfer	1601	26000000	1	CkpZKaTuY4fb78kHjRYnGeW3x92TjoL2JonEPSfUvvnr8pQyqqqdE
6571	fee_transfer	1394	73000000	1	CkpZ1vGrt99RH8P5zC2mdHKC3WAhYTBsmTAhgyqG87SPo5WiJkKNt
6574	fee_transfer	1681	72000000	1	CkpZjaLPowoXAofFPyor9iV2k6Er8DjHfEcMHfJKzwBb6e4ctiYv3
6581	fee_transfer	1718	72000000	1	CkpZCQodaTpo26h89oHfjBnFHPyoGbkqvftBZVLr1wTGwv9eSL79H
6582	fee_transfer	641	143000000	1	CkpZZ4RWe3Bd8yZyKwaoej3UL9y9ysuKV1MqVThxm8meM9oCCmJp3
6589	fee_transfer	1394	103000000	1	CkpZy2nMczEwaD5SLF5ujr3MfzN1u52sonWs4oqvv6ScgJe7opiHB
6591	fee_transfer	1685	72000000	1	CkpaE76X195GenKgjnTcgFRyR7z51dNPFS7ENiZnSx6c7Lr5fEKRd
6595	fee_transfer	1656	35000000	1	CkpZDcz3amvx3DiMeb6tgr9ihNCegVesZdg8wiQBwABxieRNsSWXk
6596	fee_transfer	1685	57000000	1	CkpYvihQtuWzCy4RtsUcJEvi1PrPSAahARamehK7QKE3R1igbsLkq
6599	fee_transfer	1670	49000000	1	CkpZbmmYsqbM6h4eBuXeCH7cqMX5H5BfcEvCN1pX63g1Fnt7WEneC
6600	fee_transfer	1444	24000000	1	CkpZQQGA33gKfsf4Fogh6YpyE4A3j1sPff3hVG7u4QVbJQhFV875z
6603	fee_transfer	1395	73000000	1	CkpYi9KR5bQqGBWcdd6SRFm2SDDcuJ3nZoGW3SamSbgUPn3yqDeGr
6605	fee_transfer	1596	107000000	1	CkpZs5gPowncBSzU7BbPebS7NxASeWja1cWNx5W9UbJdr2pgau5p5
6607	fee_transfer	1714	38000000	1	CkpaHXHagMEArzRbdP42CCsQn2JU5QuTNvf4SNSN5DrT4map5YWPG
6612	fee_transfer	1543	612000000	1	Ckpa8eqzrQJECwNUpKHeXWHWmCxzVos68xDWQnLZyREvrrX9poNWh
6615	fee_transfer	1691	43000000	1	CkpZWqn94kwjkK6ZTNJgTtJM1J4M7GzcfmKTwBoJkyrsWstRWqZ1D
6620	fee_transfer	1639	60000000	1	CkpZcBMCC5CZYmGYYpj1yD3B7utSKmyUhGNu4LoDymA2VqFwTaKQK
6628	fee_transfer	1395	16000000	1	CkpYhi3mJ672KchbtYrLnEQV6aWTcuCH2caEFwDrnwzkjEY4g2mZL
6636	fee_transfer	1710	53000000	1	Ckpa8XjLa8yECkc4Kd2osyEd4RazJ3TsQHqeKN69YABjoiubAkDbs
6637	fee_transfer	1458	15000000	1	CkpYZM7jUzU2o5UosFR9tabqPPRtvABSf52SYNZDtwFpGEC2crehH
6639	fee_transfer	1394	45000000	1	CkpZBeSECEg1mna7R3LJY33uLdqBWh9chXFYhS7KWkNh4FQAbZqsc
6641	fee_transfer	1681	15000000	1	CkpZKD398SasxKMKiG3xRC7vG9WBKNN21pqpBaT33Mj61Zm5EsBFy
6643	fee_transfer	606	22000000	1	CkpYb36Zq82kjBVFs8296NYCd5QHrvfL5X8K4cXPVL58hhdBgstmE
6652	fee_transfer	1440	14000000	1	CkpYfQzgeg96zMiVJNvndSj6qAnboafzgwSvUzNBPfZud2WNLtgVc
6654	fee_transfer	1688	75000000	1	CkpZXg3PBVfocCqken5JWXjq48Y8LyKncTQapvd9LUwAC55Bvj5d2
6656	fee_transfer	1685	75000000	1	CkpZuqL32AHF5KLkRiLpg4s4myVDFSHMxAMnjGiiqtR3iUPM7xqXW
6658	fee_transfer	1716	34000000	1	CkpZqYMM6T89RyS61iD44mEFGo9jXwPrQE3Nrf1j8ygsH22LbfjBG
6661	coinbase	413	720000000000	1	CkpYViSQkk6rbfJLxaNr5kGSXj8vkHVWQhmG1k1F1R3KBLHYv2bGe
6662	fee_transfer	413	13000000	1	CkpZ76nosWRPJDvsYyh3ST3J5ZTnZc3payDRB4Xzz7Dwz2JCWmxUD
6663	fee_transfer	2148	1000000	1	CkpZEPEU2q8EyNH6uingHBYNvFpTwNprpdifNoofVhHHyjaC8hKvC
6674	fee_transfer	2248	22000000	1	CkpZ74QA8fLax2dhYfsUnJYWia92SW8JncPpo7FzksuQc9sHc5T9Q
6676	fee_transfer	2039	14000000	1	CkpYojGTHEXdcNV6588tY9rwEwRDykJE8N6ZPL7MEpXY1Wc7cXPfc
6680	fee_transfer	1715	4000000	1	CkpYqhMDU5XgFYvnhbhTvq93G9bsgTS5cuXmv4DTKe1y6GKrPxUzZ
6682	coinbase	1686	720000000000	1	Ckpa388YyboD18p7165jFP8gotq6cjkSoPFA6D31MN5sgshEbKLU4
6683	fee_transfer	1758	1100000	1	CkpZETmMjMUp36jmEMMzvzmMAx6JBACasQVH2vZvuTk5qTdoNBgte
6684	fee_transfer	1686	1900000	1	CkpYicpW1aMHQWpN1CsW5hhMNosDBzazV4eWSet7hQqtExvjiNzzr
6686	fee_transfer	1474	2000000	1	CkpZLALnw7yqVVUSY4ozbachWB4eQPiwFVZDAQDBFWYccMJNH6YMc
6691	fee_transfer	1501	6000000	1	CkpZvdS3GtW3cBN9rp66x7hBNEueQDLXa3nMjgKUhTAhsRb2m9qS2
6692	fee_transfer	2250	2000000	1	CkpZRh3W4pE4E69yhxA6orpQyacp6BsKFEZZBmat18ptS2F44smdg
6693	fee_transfer	1520	9	1	CkpYfnNoEjPSTv6mFizMFvgq7YYUyiia3pEiHditUDKnaW1GNGdPf
6694	fee_transfer	1569	3999991	1	CkpYbWwJaLNe1iR9SqdnSf7cnRsCsUXDUFycdGZ8K27qNq7piXncr
6695	fee_transfer_via_coinbase	1520	1	1	CkpZSBcuX2QnTZ5WpGyk7jHm66gMxZe8kzZ9GJvJpdYLX8Hconco7
6696	coinbase	1569	720000000000	1	CkpZRSFNy97pj5CCWsRsNV4QoHPKtmFkgKDHhVyZtU6zqKotufRVR
6697	fee_transfer	1501	1000000	1	CkpZhpoWivcFRr2LBiDFkfPiF93yR4kGfuHgzVYnmc6XEdZhxstgR
6698	fee_transfer	1520	2	1	CkpZ5qkJCpH63TZ8WkgRtqsK6G5QpNQdn8GxjUoLmEtciWvLyffr8
6699	fee_transfer	1569	8999998	1	CkpZ5A9mPuF3tFzRuqf2ZNMnhjvAi6Anephjz5mfujW5UFxXobC6y
6705	fee_transfer	1560	61000000	1	CkpaA5oZXp65gHfeezkHWvCpnrtjp3EHcKtrHvR9mQAXRQ5PdBeWi
6715	fee_transfer	1566	11000000	1	CkpZAaFm6edhwEALx9QNcx3V4BVZYxUT1ssfbUS8STyCDasELA6Pk
6721	fee_transfer	1467	32000000	1	CkpZ3knzmz5f9QAFBhNiYxHWsaAaoqCFwsAVzQYabD7Rdumaxir79
6725	fee_transfer	2261	26000000	1	CkpaEFEipyedp93Ze2XzzGJfEMnkAvBPT9zwPWpmkTf8MBjb4QxGF
6728	fee_transfer	1422	38000008	1	CkpZYxuD3Qb4hUNLMpDG2kjcMPiabkRWsDwrenCFqbj61JC5wgbb2
6729	fee_transfer	2275	3000000	1	CkpYvahnj6H6vhSq8MZbLD7xvdL16QCsJCuw283qEypHwqi6ba3hq
6730	fee_transfer	1527	7999992	1	CkpZP3zAmNrpSWxd4s9XSWy57eXMnorCGmvVys1UGgh6VdkM58Ugm
6734	fee_transfer	1634	37000000	1	CkpaG7UambvU8x1rBP4TKRptmaZkq61h32qKrBSgoJH7RFLFFwbdL
6738	fee_transfer	1751	2000000	1	CkpYVD5d17R14mhtkcuS48MiPg2JWkpC8gCEYSUSVaxAMUerNumeo
6739	fee_transfer	2306	13000000	1	CkpZbXGLycSf5jU8zRKoGEsFHYmnqNmB8WcyT2WTK8h7P3wuV4oPH
6742	coinbase	367	720000000000	1	Ckpa9NMDtmWqwuxuEfgoejXXDBhbTYi7JHzqWddyVY26X4LpaHtgA
6547	fee_transfer	633	46000000	1	CkpZQzLPokTQ1jNahMPQcp5af36hsiYwh3DAardkdLzVYcdPQTUFz
6548	fee_transfer	1419	36000000	1	CkpYrHmQVjwu9m6yDxLTNXSRTZj8jLJvyRSK3WYfVn3uoAav9RCRq
6550	fee_transfer	1608	120000000	1	CkpZ72du4UEmfozDYxYcjxv49BCaMsp7fHWXFkJgdFbjoa9pKYMsU
6551	fee_transfer	1608	186000000	1	CkpYVg7owHPQTyNhYpQ7HYu3FSDG6dvmCFpEWHJZSTD47uXB7x8DZ
6552	fee_transfer	1680	24000000	1	CkpYuau6jz4Th8XcrPWDXbq53NtdynyK8enu5iQ9pVw4gS7CdKwhe
6553	fee_transfer	1608	98000000	1	CkpYzRgjMD5rpqKKYaUPckSUSYmqcVwNb1WceHyLAjuhvhWpihDKU
6562	fee_transfer	1509	630000000	1	CkpYhPZhgdo2vbGbTy2PgUCizc6Wnf1bLjENWUvMQVF1p85wfJsCF
6563	fee_transfer	1509	539000000	1	CkpYo9FLF9X7B4H4puqZSsQgMNqP5aBZaLcWMeY21KuRR2k474wmg
6566	fee_transfer	1723	72000000	1	CkpYgpqrPsZmFiQmxnewuVGn9Za9JR6xB78SPv83qDhzk9c9jMa2f
6572	fee_transfer	1541	144000000	1	CkpZe9M3RK71gP76gQcq67Khuy8BddreNpSqQQuF3NohAcZFV99Sx
6575	fee_transfer	1670	35000000	1	CkpZjRZQMeDgLs1jwoMGKvthqGomgtMozjXQCoQdQgKaixvpVMCRo
6578	fee_transfer	1439	3000000	1	CkpYekLTQqrMUGvjSB6RKwisPATXrMKWzJeaEGr1vboTbdjqRdwpN
6583	fee_transfer	641	145000000	1	CkpZ2hLfPyyeQG8mef3BYaephWnEnsYkzxo667kmTawYrFEh2xsSm
6585	fee_transfer	576	64000000	1	CkpZtQWZ7KSj7AysE7mzpKYcWnY7EPon8GaJoEVfz4XpbaSkUoR1y
6588	fee_transfer	1395	72000000	1	CkpZ8onqMV6jTxk7TWCrhH4dq3yz9TdKQHuwamz9ckBUjVqcfXVpV
6590	fee_transfer	1637	103000000	1	CkpaCBjPYHQ66YssRWM5s4DxDqmfeywzRmAZdBG1xzfx63DL37g6F
6592	fee_transfer	1394	27000000	1	CkpZVMsfpaWzGQNQuC4ckYLmSVXzwLtLEtBbtuTACTkNbmC3vsxrD
6593	fee_transfer	1703	27000000	1	Ckpa2DSY5rT49nyEvR6sgMoWsgzSVveBW8cxPwtDhkJDDSgyKzfpf
6597	fee_transfer	1759	57000000	1	CkpYanpakDV7SXmWvVBxggx3FZuCDF6xEpKCnzUWtM2jUMYNciJtY
6601	coinbase	1669	720000000000	1	CkpYUshAYiZjfHMeqxjm8Gw7a6X2dPyZrMgV4knVP6BTLZJ3JQauL
6602	fee_transfer	1669	12000000	1	CkpZzYWj9pRYnJPwEzuiJLM8GDXwZmx63hcNGdkeRFN3Y6LvyZn5A
6604	fee_transfer	1555	73000000	1	CkpZv3WmJn4VEgfvq4yQTL9ffYvLFQHrc3TNkFM4HwvgHYeXM9EXF
6609	fee_transfer	1601	580000000	1	CkpZV8wW6zSD4Vq9mbBTUjiczhu22PSh1fwfPmdweCK1XzUkcAvpT
6610	fee_transfer	1601	760000000	1	CkpZb7yE18ZRc7ukhNVJaLVG3yVnP1w5BM4mkUQryF8HW9yJ7S7zB
6616	fee_transfer	1451	203000000	1	CkpZveBEh17DanP8nLmkZVUEHeDZ8C4fzdJPqnquqML5VRNvq5xp5
6617	fee_transfer	1451	1999728	1	CkpaFegdEg58mTN9rLRLUg35C2z2bKS2i4jQpuUuWemL8kF7PyTjd
6618	fee_transfer	1571	272	1	CkpZLdWQtYt6gYHrA78izBcSFHEHb4nKQRMWbAY2tCbPuzBKwAXYs
6619	fee_transfer	470	32000000	1	CkpYivYKe2CDu9geu3Hk5xas7aEBoCg5GWsEBoiY4zdfCCCuHWWpD
6621	fee_transfer	1639	56000000	1	CkpYc1BNcTwZhaK7BxH8WngqJRfRJBotECAxw6roQNuFKbg3qwLpP
6622	fee_transfer	1613	15000000	1	CkpYUjd421rZux9wZU3PgxXCa1s9f77kn7BkkyH1TvSLjrf4unpvv
6624	fee_transfer	1706	34000000	1	CkpZbLu2cxZKPF1koPzjiByqxZXAnKbCLQoT72t1swiQ7GfnzDgQ9
6626	fee_transfer	1850	15000000	1	CkpYe8S2dKLeigr8hwFuydnFeq6mxDmTqQiunS9EMqmuBZR9qYqch
6627	fee_transfer	1991	15000000	1	CkpYp3FDKtndShxnxcnRfabMYnNjY2JRF2tFqFK8pPfbzYfYRvm9k
6629	fee_transfer	1685	16000000	1	CkpYYxK2otNouSS2Au23WSGDdbaMcERrFmNhMCiVDFDGngCJ6A8sY
6635	fee_transfer	1587	25000000	1	CkpZwYj821Cr3M52SQ3BxyDe1E9TFzTZH2SD9DhxM4tcMAtDfxE5r
6645	coinbase	1551	720000000000	1	CkpZBBdsQqNkpeqRo8CSiT7WwJXTPBGG1ADNa2c4qrR4bcwcNVciA
6646	fee_transfer	1551	12000000	1	CkpZ5Kbs943FaypYZfCdwDjaFezzRHiEKxFpEjffSBUPhaG2u3y2T
6647	fee_transfer	1513	50000000	1	CkpYoku1CQTTJEeZasNnGsiTr2HGQrVJeZCswQJ2wS6JgYF1Xsx1Z
6648	fee_transfer	633	810000000	1	CkpZasV4tQTuD152riBpdcX6qVwy1gmnuqtUrZvm3Eef8tgCA2omQ
6649	fee_transfer	633	390000000	1	CkpaGYJeoHEX3GWUKRa9kXowxQ8KjkmJRALhXPgEizFBEDs61QvD2
6653	fee_transfer	1740	14000000	1	CkpZVufVWRgrj6nXCKmJuhaB4yrNvWfki97Z9T8v236c9xUiHUY4P
6655	fee_transfer	1394	75000000	1	CkpZwr48MHzhT9C2QzAMiSAXCxMjy2EmDWJct5KHXyXog5pp6aZ3F
6659	fee_transfer	1675	3000000	1	CkpZyNXHHtkWgyGxAuntohHT741KvuvgvNSTKBG1HBNS3LMbkq6Y1
6660	fee_transfer	1394	19000000	1	CkpZJTnXrmFNt6BcpYZfJub7oNnATdaeBYbQcnH6Gfjocsaa5gV6X
6664	coinbase	2299	720000000000	1	CkpYccx93UNxUQWV3ZUEwCdHcVtUjELnNrogWH49DaBj1hNeDn2Ma
6665	fee_transfer	2299	12000000	1	CkpaDCAqvCTt4PUM5QG5QBDw7PZF7G11vstXV3xVhaH4AntLX54mw
6667	fee_transfer	1546	9800000	1	CkpaKpbaoi1uUHZwpZBRkMJbtDWgeNXnANfmktpXwmCUYvkFW7wjG
6668	fee_transfer	2250	1000000	1	CkpZnr8N5cDR8w9QgAgtP2DmyENa6PzurQv79AA9XAvhZABDi3yej
6669	fee_transfer	1758	1200000	1	Ckpa1pC3u9HyKB485kMm4JWuEhbH8ojGwM8tTqKpq657sfUTH9Qty
6681	fee_transfer	1768	173000000	1	CkpZg2TjG432SdT4N8jafuGMfnRCJb4b8D7xYLjDo4mZZPqRrgLbw
6688	fee_transfer	1593	101000000	1	CkpZmPuQT56Jjd5awNAJv2Vf4uVexKmervafiCpenonepqLg54nsa
6702	fee_transfer	1675	340000000	1	Ckpa2kQwDqkcTsaLhovGi9zKyyMbypXuLPNiQUmJCT3G36EQuhKY8
6704	fee_transfer	2112	6000000	1	CkpZe64A6ucuRR5PLRzBYZnkVYXTUMT8QXKTXTdJjD64uH1yapkHZ
6719	fee_transfer	2112	46000000	1	CkpZWjFzM6hZGeisNRNkkjR53MgiF9J7rmJxveLPbxEhfJ6v9c8Wv
6720	fee_transfer	1439	33000000	1	CkpZtTv4gQRGLZyUw6vvfsYv9xs2CkEro1nMj8U7fhLUHEBjUmE9Q
6723	coinbase	2306	720000000000	1	CkpZe5rkSjaw4v5MpzGXvDxkcCbUomUVzUAjH4y9dMw28kgtGVvPm
6724	fee_transfer	2306	12000000	1	CkpZxznhPbe8GSbNj9nep7jFDhHNNVyFcTRF3dUwpbRQvGkqrK3hs
6726	fee_transfer	96	26000000	1	CkpYqwKzKhCDisZdoYQx2kA4qfsdzuTHAwPNgggdsHLq6EHj2bjoa
6731	fee_transfer	1422	49000000	1	CkpZA3bH4gv8q9npkYq8MfZaYhbU5wRRxAXJ2unVYwcapJ3aqiTfr
6740	fee_transfer	1623	270000000	1	CkpZzasErXSoG31u5JYP73cVqbouZvps5vPHQZQqbLtmnaSZjEhPS
6745	fee_transfer	1602	14000000	1	CkpZnuVZ9D63Ega3jB66VCd3zKXRegVUmm4o6cVGVSKerZ2eiQn7m
6747	fee_transfer	1758	11200000	1	CkpZiHDudtUmcrZxA8j2ofVYuGR4D6WeDkPtGJeb4GU3cRATf3GRS
6748	fee_transfer	1686	118799996	1	CkpZPHv8BqjmJnbi91nL6vMujsEChEpU8HAAVfPwDWr8aWZhMRqqq
6749	fee_transfer	1686	1899998	1	Ckpa9ZRmzKGpcLXAMbDgsfGNigQgpLznfahLFtvymRB2F7CPsZyCK
6772	fee_transfer	2275	8	1	CkpaEyPAEgnQQ6NbFGX7Hk8dUDhTNq4QHW5v8fw9oWXWCYDsas5iv
6773	fee_transfer	1684	11999664	1	CkpZrTdHcQ1nvMMHsYGMXqT5NWpUmkLk4DSS8uXyExpnyQk1iEin6
6774	fee_transfer	1571	328	1	Ckpa8Hxo6G458PEjWxgSSQgJEGzj8qCWxGorMDwfYjzARSi2DegQg
6778	fee_transfer	1680	880000000	1	CkpYnxveqnLMequhhJPxZmi1DuU3oBiS1gSRM2j9xAHU4Jq6F1iLC
6779	fee_transfer	1680	370000000	1	CkpZbv8kgTqAVmTxxW6xFZCGmxFgz958znGom7NmANSp1dn7mypWD
6787	fee_transfer_via_coinbase	2275	1000000	1	CkpYfBZYbBZPsX5716xXMfS7YWy7K77qV74kwY3Nz7ANRK32nfZVt
6549	fee_transfer	1425	24000000	1	CkpZC8fYqwFTKwrK35CSm5qh6U6wF1C82uz8QoULqqMq6zSD6EnPx
6556	fee_transfer	1850	23000000	1	CkpYknj5UBhvfqeMZpEcDRx3amkJuXiWjxCQndN92QvXHsEUUKArP
6557	fee_transfer	2112	894000000	1	CkpYwmXHYPJY6JUeDKxMjKqYWXPVeubCCxYoXCN5QyJZN4DmFwcRL
6559	fee_transfer	1601	200000000	1	CkpZZmpoSaM4UUo4Mh9s6LMy81MBHMhHhvgdpLT4r33LN5wEqx3Uj
6560	fee_transfer	1601	157000000	1	CkpYx5bibcCvSD5kkhyZEKJMqhz9koaTiAjTxbr2C27grgrLkbXBV
6564	fee_transfer	1547	71000000	1	CkpYpDfhEv64xDXYg7MRvJNd6TRHe5SWSMQHRET9j959ZjwuWfNck
6567	fee_transfer	1513	120000000	1	CkpZN1CDdBWxV8bhQHS5DN6gRy2mRoUT6BPLBd9KfBN1LuhTHjesw
6568	fee_transfer_via_coinbase	2296	1000000000	1	CkpZVQy1uBzmz9hVk4hGySrPAZUxp7hRKfaAA9w1c67RNavDy9gqJ
6569	coinbase	1688	720000000000	1	CkpYje4Ks166vnaBCtfRb7vDTQ1CqigdcoZywRg9dCAGVPoWrNkyB
6570	fee_transfer	1688	72000000	1	CkpYpzWXUwsG5Jfotuuh9Qg3JH1KbaALnJ6ut5ySNvi62AacT7WAQ
6573	fee_transfer	1718	144000000	1	CkpYuXkD7ZsuLnaMhDmPEN949oe3brd2BxuMHuhjnFohRcd5Mz3e2
6576	fee_transfer	1991	35000000	1	CkpYzvMfJEE7QEpTqU7Mr12tHh461vGUsHbmLJ83HqVfApzq8AtNH
6587	fee_transfer	1657	51000000	1	CkpaKx4ZbPVwEX83defjNm3EFPbAt6nZK799a5kGcEY8Fzq752CHw
6598	fee_transfer	1710	14000000	1	CkpYgcTWPJBM9XoKrFva73GNPHtKyWKMFJsJSGkpMcUFp4x9PiHhd
6606	fee_transfer	1444	38000000	1	CkpYW9sxL8CKmHtn3CrcY2p74hSJti5BYRUYwSz6TSCcgeUNie8RV
6611	fee_transfer	1395	312000000	1	CkpaGXQXCYGewSomSYncMJMYzBTNBtGv53bDJk63museYwuYq7avr
6613	fee_transfer	1619	612000000	1	CkpZCT1d5scPkZV8oFcGn7xTSnXLnnc6YYQKau2mj47WNhrunyYAd
6625	fee_transfer	1706	37000000	1	CkpYuypupyyg6ZawYn6CPYmuMQszyZh1bEB9wD4FrJJHv9E8KZwvx
6630	fee_transfer	1624	2000000	1	CkpZZQnwDUBwG4Rm6UPfY48SxEnyJ1kp3kWCVs7EsX638bkK8q2Zt
6631	fee_transfer	1656	23000000	1	CkpZA3WrghQhWsJs6QSk6dANpMrXA4cxdU4mzuCRXkpTPhEHypqNS
6634	fee_transfer	1422	36000000	1	CkpZtGXQ972T2X3pRMWbz3hFhByvVcfQHD1mhx3WjEkLd5BSr19sX
6640	fee_transfer	405	13000000	1	Ckpa2aVhGsuU5JrTy1KKUpZ38rmcy1fR2nFNVQbx9C4G7kuGZw3tj
6642	fee_transfer	1521	34000000	1	CkpZG94igESxdibx385NGcP1zN17giSh99wf9war5QvoLF8DV7TR2
6650	fee_transfer	1758	700000	1	Ckpa84XQcNzsKh5hcfDtPAHzy9YXHsDfUYwGp1e53xLhw9NKajD86
6651	fee_transfer	1637	1299997	1	CkpaAXJpLdKbxw8CMGf7C1md4LmdcYo99qKf3Wmy1imJZckgzXmvq
6673	fee_transfer	1716	23000000	1	CkpYug8oRCQkzigiTBR1mSSEpxXfrDs7oTVrit3BASEA7QK3qUo2c
6675	fee_transfer	1506	14000000	1	CkpYjV3kGdx39jLPRXMTHgRukK56KgGqtxx5grvU9s36RwFymT43z
6677	fee_transfer	484	14000000	1	CkpZDUir6PM3QGxvw3YVyFQHZUUGNnAeWbKEd5brtkSz2Lvsyccgt
6678	coinbase	1818	720000000000	1	CkpZmGdHKnUPRR1mQoWyChKMDsqT9MLWsWnzbukRuwT6T2JGEjEHB
6679	fee_transfer	1818	13000000	1	CkpZuEEjp5ys8wD56wiKvHrUJ4F8dipSezujq6hvq9RQcFrQrHhUm
6685	fee_transfer	1419	42000000	1	CkpZD9MacGyC8dcm1byHSqKy9Jr4J47tDm7RP7WFLn3Ep5qFC8b5D
6687	fee_transfer	1271	13000000	1	CkpZ1bSJXqCT5K6n7oxR6YFvSCHjdFCePcajxm1Jhi9j7jJWSkBDA
6689	fee_transfer	1569	47000000	1	CkpYvbEw1KNarkapgwrnvqNPXZv9KkvKX5tNKmqsp3DTkefMMtTRp
6706	fee_transfer	1508	480000000	1	CkpZVymEP7cpBdbSUEH6DAV6DdAMkFeURx2gMhwTq4wqjboyzcQNG
6707	fee_transfer	1508	770000000	1	CkpZ8MxxeLturUq6Gvk1ZRhWEVx21DzDtEiCJK2b8uS3deH6Cen29
6709	fee_transfer	1593	140000000	1	CkpYvofwRPfCq3VpGoePmfQ8A8t7k31Fe9ziiEdgSMe6eLjBte6Mp
6710	fee_transfer	1593	38000000	1	CkpaBTHY2wecWHkuoHwwVQDBRj5J595qgUeoz2aKqpNXzivBAPZyk
6711	fee_transfer	1675	112000000	1	CkpZnDXT66mzXfr6GEwqPDQVq9CgiYkdSxxfFKMCCoy8H1nzWZDvc
6712	fee_transfer	1675	17000000	1	CkpZpSp4U1JmungXdxGNMPtdC68uf5qZSEMRsez8Xz9iaBEKSKFFV
6713	fee_transfer	2112	2000000	1	CkpZhESAtRQaNPUxkL2CEj1kLkYgycjbyMTuACnsWKL5ZMU1S4iNL
6716	fee_transfer	1706	1002000000	1	CkpaHio3pBQ9s2rJcuyFzvbvrEcKeeRqDjrJtZ9PFFTGz7nPrjJfX
6717	fee_transfer	1706	18000000	1	CkpZRj2MRu2ZSoY2xd6vB61Ju9xfC2obY96Bu3z1uWcAyJXsB1eL6
6718	fee_transfer	1650	34000000	1	CkpZvHEjWv4fSSv5nQr8UuwxFQAxYPh6ArugVSTWRwu1c18xfj5au
6722	fee_transfer	1673	31000000	1	CkpZZspk8uhkvAJMcQGEGpJpkBVosJbcgLh22oQMY2r32KEzU79wS
6732	fee_transfer	1593	499000000	1	CkpYx7H93hf7ZdwfA5PZr5xDtYg4W7MQeY4GWoH6xR6PUGAPhpPQh
6736	fee_transfer	1780	12000000	1	CkpYq5KubF9fPAGVszRdxdXxaqgQHWGB4ViChRQ92o9mEcVDZwRS1
6741	fee_transfer	1637	62000000	1	CkpZWot8eaiQPuzjZDQxNuuzdSmdjDqR6cAc5NuPbuGEr3buyLWNh
6744	fee_transfer	1764	37000000	1	CkpZGLzzoGo9QAor6tHHtDdtt5EwYEMYSxb7PqhPAGMaB25sJbqVo
6746	fee_transfer	1686	14000000	1	CkpYrBnvUQoeTp1CYMMsuPEvPkkG9eqm2TyPdyHffkQEin7kutw2D
6750	fee_transfer	1759	14000000	1	CkpYWnBviHhZsEKzyq1RTAyr8Qtn7qhds1sCpjETCF8Z7zgRufyCC
6751	fee_transfer_via_coinbase	2252	100000	1	CkpYbMT4Cx6D28XW8JZppzKKWKKqATbefc1aVGX2nDtfgCJBVpZ9o
6752	coinbase	1684	720000000000	1	CkpaGHYz8CQFcLMFte5VopVJMm7bsrgQMMLyg3n36AJ4EeDsp2tfW
6753	fee_transfer	2252	300000	1	CkpZyBuCax4SeSCuRzatBiT9RMThGEF5ckp2yhHFiHrGu2MP56T2x
6754	fee_transfer	1684	1700000	1	CkpYe81GKvkCQNG65V1vtnXHphFHkPwgaifY7MPJXFNRBSjbTawUP
6756	fee_transfer	1444	274000000	1	CkpYQufr2egPrtHtnhmWXd2wqzRu5jPdWhaVeeDAxfWKJ1Rd2VQZB
6757	fee_transfer	1637	27000000	1	CkpaJrvaN9vKkyoD9wgptFFaKVNPnm5LnFaVoP5U5KennJpwQP6DU
6763	fee_transfer	2306	11000000	1	CkpYUBELmiZERyeACDwPqZaoo8HVn32GCaWbUNfEwwpCZZ2Tm5iNG
6767	fee_transfer	1520	11000000	1	CkpYzqujprFbb7ByTMytU68vYQdKvZShEqGfTnQHjLLdhyu11Bzat
6770	fee_transfer	1518	557000000	1	CkpYmfN9idu3tN9MJpMxrJaFRU9ARfwRXjnzL5AgWQ8Up2fd6uWwd
6771	fee_transfer	1518	27000000	1	CkpZtunqmTWfeNTXgrHpYUvAeGEFTyG68MymnMpNwN4ZdnUi6Fi22
6775	fee_transfer	1684	17000000	1	CkpZDuCVYvZpjaErvVzTJNH91rBE1DyZsDSJ3wVxHbeknfkfSBReP
6780	fee_transfer	1679	16000000	1	CkpYZAfJZAAc1sbLLvJ431P1LNynwmJ48JkzNxgPmGsXjpJmdJGVv
6785	fee_transfer	576	302000000	1	CkpZfQ37zsnxXaBczmZ5CC5yJ2dZBHArjv4rfnfsYwALpAYekYzRk
6786	fee_transfer	576	35000000	1	Ckpa5eg1q8G1WM1aaZGHA26zG1bP15Cj5aA3KbeDukSJZJAinkcJ5
6790	fee_transfer	58	122000000	1	CkpYtUzzbKtPS7CKeLxyUdtNYFXvDc5rmwZrwrCpFQkQ7r3WRVmJC
6795	fee_transfer	2266	30	1	CkpZmvVLTGAf1KcSSEAVio3mLG7qkE4RoD939SKKW8bxurrKXJReE
6796	fee_transfer	1656	10999232	1	CkpYh58ho8xXrmKaGFfSjRA6VyNtov4Soq2yVtRT7KRZ2ixF1qaTM
6797	fee_transfer	1571	736	1	CkpYbnQ72qsVSniAWc4xxTPyCjY4NDxdeYQ1Mhsmcg5iQn5xyRcKf
6807	fee_transfer	1680	970000000	1	CkpZ33RUto6yNQXA7Gutb7MDTKJc2pKLEL5TTQb5t6EPcQZuXkaat
6814	fee_transfer	2100	32000000	1	CkpYuQSTsR6F5vY9XdnV3jWN24pGamu6N9uqB5S2kC8tBaU5vj3Ht
6565	fee_transfer	1547	72000000	1	CkpZqSQzRXZzf9hvUyerB4uQ7Bwy5jwHEUDNnm5BpGHChjvKPKR8d
6577	fee_transfer	1684	35000000	1	Ckpa1uNTBFHuLzPUKkGbhPWd7egCenPX3pkm1Mr4mVZ6rsjKtnVN5
6579	fee_transfer	1395	217000000	1	CkpZLXL2c8qS3BFzUoGACau9hXS3dXUDyuLjUq5orcM1Q1Xw4Ht2o
6580	fee_transfer	1541	72000000	1	CkpZzgasZh1WLD4K8jQyiLXZYE3A724QBtruoRxCBb5LckRU8YKyg
6584	coinbase	1688	720000000000	1	CkpYoFmhzQQbzzLmYzm3pS4wxUxRY9JRaxfF4FR558LrbUbHbhqDZ
6586	fee_transfer	1555	137000000	1	Ckpa5xnTpfgyMctAa4c136Vdr16gm1FCyvGW5vDjwbUCuArQ8uBXX
6594	fee_transfer	1679	85000000	1	Ckpa4rN2FGULiEcEhf1atp9YnWobxXoFkgw3hwf5s9jzZr2ny5HoZ
6608	fee_transfer	1601	112000000	1	CkpZvjpESJ8xDVTQ7ofVBPG9K8Mf4CgsvJtisgB3WpqZC66jxPdRd
6614	fee_transfer	1693	612000000	1	CkpYVWsrM8Wtzhw5m7ca2eYfDVdAWebudGEq8juQ7EqioWtENFpht
6623	fee_transfer	1394	15000000	1	Ckpa63uzh8YXo3xL9kg16tYHC2SAq3e8UWZZpaBd73K5HeqFdTwVn
6632	fee_transfer	55	25000000	1	CkpYoor4d9BrcftYazHi6p79GxHrtTALqjBWBkGJ5WfNBkXgA5v2n
6633	fee_transfer	1649	37000000	1	CkpYucPgmeKoyw8UMkadzUqmFZpdTZH1DcqqK2BozX9rmRVudQ4PU
6638	fee_transfer	1685	15000000	1	CkpYhhoNhaFtwj1243finPQg9zbxTvsKtMb5kU4WKWG3vxB8GKtYn
6644	fee_transfer	1623	22000000	1	CkpZbvUXjpu4yKPCWZr5YopFee6ziuph4WNU7aENJgK84dspJ7NyC
6657	fee_transfer	2248	34000000	1	CkpZmXFEKZzZG6vgZKPjBRunT3vDz4ZGyeh55sPz99Zia52qn9bZE
6666	fee_transfer	526	37000000	1	CkpYt8vb1d1EmHkPNkPP6CKceVJqdRiE7oQnEg6KBv7DCnVjhRfgd
6670	fee_transfer	1546	9599990	1	CkpZzfa4jDQ1AXgicAyPobkm4f9TsLuitUgqk8QQAExNMcyN3wXtB
6671	fee_transfer	1758	2400000	1	CkpZkMigwDmWwafEgU5vfqfU84Fg1meWbcgToNb7fKVVYzwDogjFj
6672	fee_transfer	1768	22000000	1	Ckpa48LSF669iWZxgJQs5EZ9WwGbADf68H5yahiva92FNSsAkQFUw
6690	fee_transfer	1569	216000000	1	CkpYQDFNXiWpek26hf5nDv6b6VMEuDzqM7HBrJXopL4XvwGaPe1yx
6700	fee_transfer	1520	11	1	CkpZQhePChJZDNzSbcLsrzeLNqYR7Xy5xAQzTcuE8dFx2fhCbEkAp
6701	fee_transfer	1569	3999989	1	CkpaC9xxSS6JevyBBJ1GUiV4Ngmif55PEwhHLWkye7wwaYoQzDYqd
6703	fee_transfer	2112	26000000	1	CkpZd8c1p1Bq9K87uRusksHVJW3Y678NJzdM9p9swk8rKpmGfqVc2
6708	fee_transfer	1690	26000000	1	CkpZWAmstQYwNg75qEEHyuaBqoiK93RhoUEg4fSd9ktFc35ECE2GC
6714	coinbase	1559	720000000000	1	CkpYjnzeryAMi9wgRCZLfiC87XDyNYms129efYZ3ZyEpYhmEHfQ3G
6727	fee_transfer	2261	25000000	1	CkpYSBPd1jsXd7CafP8yguGf3Gye4Z7wXA8VMauaD3foDQd1eBt3z
6733	fee_transfer	1701	37000000	1	CkpZA6oYdaZkf8vr7yj61cTfrcMLdksjCXrS6iQzUjEqR3Dg7bQvm
6735	fee_transfer	329	37000000	1	CkpZjWfdhKLzAf6xvhw3NpLvjZ997LnT8CuLDnt1cWGLTMtzmY52V
6737	fee_transfer	1522	41000000	1	CkpZSmKaAU7pRKBaqsjem4iqndJC7tG3QxtwGaxL894eLQiqtEMoP
6755	fee_transfer	1684	5000000	1	CkpZ73QsXuVaydhoNx139sKzkD5VNH7Q8bF1YKp5T1YoaQ1Q3hPyK
6758	fee_transfer	2261	27000000	1	CkpYsRd2ycrUrkcHHcRYVVZXNkViw1RY6oAg4FArcSjhYxR9hTxkT
6759	fee_transfer	633	323000000	1	Ckpa9rgUKAod56MLNydU8YjDxnczS4PgHASHx2rqYpcoH9yuj8mK2
6760	fee_transfer	1444	157000000	1	CkpZhD3DG5UTSjpQVXoYq5GQPR3Db7MzvWJny6QcCjYwTP2dxUzji
6761	fee_transfer	1444	16000000	1	CkpZ1FXeH5b5nvneG8RbRSWCsnvRLR58f9g4sLRkvnFCqAbj2erzZ
6764	fee_transfer	1513	23000000	1	CkpZzxx1NZnUXE92UWf7ZRDGWTpd6M5uUbh6VKL1ZWtBbn9s4m8pi
6765	coinbase	2307	720000000000	1	Ckpa2MA5ym8gyktrVJwhmqzfQDQBMG82pPuoFkCV9Ew7vNLh2NCuu
6766	fee_transfer	2307	22000000	1	CkpZ7vUCnZVADxkvXVKtCQwh5jDSZni6L9byS68L7n3GvmqpbqA7p
6776	fee_transfer	1394	17000000	1	CkpZ69PYjFmiF4tArBGaMWfCDQWgGGRRQzYMcVxjPUB9CyPT4oUJ9
6784	fee_transfer	576	21000000	1	CkpaKkgm7uHmyh1HXvh2Zo17QirANv7XEUgu1Y8dsKy1YZZAppXZr
6789	fee_transfer	1547	122000000	1	CkpZ274yYJvoG46SnXQG9catpxodCiiK1DjMTbMaviC1LaoyJ7RWe
6804	fee_transfer	1716	33000000	1	Ckpa5Db6iPCvdGVnJ8RdBgS8T6FujQemmwVqjnPdrUEoHkrtfhKuJ
6806	fee_transfer	1672	22000000	1	CkpZR1nP6DTx39hrUBJHyeLmFg6mK5hbUnZqA5VQiyQo2eeFQ9nu3
6808	fee_transfer	576	675000000	1	CkpZvMzMh5BdrWQ2Bd5RbzewAxZUXcFcnRGmbiu1Jo2f8PdVZxEh8
6809	fee_transfer	576	19000000	1	CkpYna65HhMtyRy4L6q8tZk3BVRapuNUcPkcuXAXshbsCyHzYmZST
6815	fee_transfer	1680	26970105	1	CkpZS78j3gEA4gC3PZ9ktJkMoBhmDiCApe9HgqNeUxwALLZicNzzH
6816	fee_transfer	1520	100	1	CkpZ3Nh2YCyJL9MjhtQZLj6G1hT9BgfZruVZz8sq73AahUWkUbMc1
6819	fee_transfer_via_coinbase	2223	100000	1	CkpYzxXniv8jPTEuv8ddE5q1pg8PB3dUsRzvGeG3apas2nwWywmva
6820	coinbase	1271	720000000000	1	CkpaHKxp7t9J1KfhX26VFfkGLoNca2JWjKartam4kbKXV5BLU2fzk
6821	fee_transfer	2275	900000	1	CkpZgJenJQE6XmuKzssjio22FZXJPnFSysaZ5FfFYCPVKSnMnCj7L
6822	fee_transfer	2223	300000	1	CkpZhRFx1R3ai2wTKQgSEZb99VZZTyPwTEAZy6oMYNVzyT8XbonWA
6823	fee_transfer	1271	6800002	1	Ckpa32X7ZC35nXgZgtmF48UZ2xvMQLwMF6CBikQ6LFfqKsTh5zLCB
6824	fee_transfer	1547	22000000	1	CkpYQHKrr7FMGGsL582Jf9bZyJPAyE24tus1WooVb3gWe4MU6qHWX
6826	fee_transfer	75	66000000	1	CkpYQ2jh78hXkc8CvpEaGpsNrjbmwHyk6R5g8aGs2Cexc1nUcgGTG
6827	fee_transfer	1599	22000000	1	CkpZNA9ci1ubEWYG7g5xaTvYbJFvxTUWbMPNLXfmmLtaEwXUBsAeA
6836	coinbase	1587	720000000000	1	CkpYZSqjLe696TW8kS6N6LvVJbc3AxvnKyghZ6oa4GXkYNam4oV4p
6838	fee_transfer	2248	11000000	1	CkpYcMdSD8WLEJWERudmuy8fMCoaNDfwbBaptacP28uk7rhQnTVoN
6842	fee_transfer	1693	79999000	1	CkpZtTXJuzWx6Dub3wPZwP2vrAxzA43njzKxNmzbNpwDEd4f4owSp
6843	fee_transfer	2076	1000	1	CkpZmheLb8e2KHseeDFYaNEoT8apvsf4FkED8dcoYEhpr1ti6xpno
6845	fee_transfer	1444	629990099	1	CkpZe7yPEbqtpDvmABwPzhjAYpjqNq9znEshNbtydaXPxdsQiesw5
6846	fee_transfer	1444	3000001	1	CkpYbT3AEE6ZKf55HeqJQFrruav7rjAaBjGKk79TNgyU2nKgRt2xK
6847	fee_transfer	2292	12000000	1	Ckpa1DAWgUfubAL3ppj6xMhoNDHymUNGhDXLwrJmuxZt98EhAVkt8
6853	fee_transfer	1634	25000000	1	CkpYbe2wyAhCy5r6f1Njyzhvz1WPWVP9r9VAQdpxSxuiyx7LwQALj
6859	fee_transfer	1749	87000000	1	CkpZznevKzEGTyBsKJQ7vcay2nnitaTxePv1qPa2Z53EiaEZPdbBt
6861	fee_transfer	2307	25000000	1	CkpZr7KjoaXfpdQKbeXs7D9Nmo8VGBEfoDURvKiCPEoEi2DudHp1t
6743	fee_transfer	367	12000000	1	CkpZ92r35annJKdwRKQxcYwfrA73FLBgXbDu9hPEQE25awWLHtm4N
6762	fee_transfer	1649	34000000	1	CkpYYhp6pHG3KKe6Dc8sFubQK5P5cfHeKEgw5opknZ19TL7EUhFP7
6768	fee_transfer	1588	670000000	1	CkpZterARNQtkGhNqTxkPd2SZDE2Wi3hJpMJhCadc94e2RqCQg2Lu
6769	fee_transfer	1588	580000000	1	CkpZp2bKm1aeXLTJjbgR4W1foPEPYgUkX22KhWJXX2LmYPNQqX1Wn
6777	fee_transfer	1680	17000000	1	CkpZfTsSVzrZXccyKY8DrvchXvqkuTGefEtch2E121tmBXSG2EGy8
6781	fee_transfer	1734	100000000	1	CkpYToF8NVhw346CyxbRnUenwBiiKmvA5aYz7HeyPGjtiLGsBUqVa
6782	fee_transfer	1623	227000000	1	CkpYr7agfD2u1HK4e19HCbqhhr8eCCxQf56Esth4jpDnXb3YPw3mr
6783	fee_transfer	1749	14000000	1	CkpYX82bpWTEMrstAJpzF4xud2SsDMpfX7AgMF4pFCoawquQMSa3F
6794	fee_transfer	1489	22000000	1	CkpZopeX3UrNwrvGZNcpCELco8NmHmeFtEUHgaVc9jn97djKCEYmN
6798	fee_transfer	1611	115000000	1	CkpZBGF1SHtWyv7SFDnCtkssmhNenPPEmM5ofCC35ZdYcLEnxucvh
6800	fee_transfer	2307	33000000	1	CkpaEx1oyPUVBxFLyvbf5oBy8mt8GZBGG4BWoBKS1YT5d8hAtiDKN
6802	fee_transfer	1623	482000000	1	CkpZ37Xvzgbt9ujVjxwrEhsctBW1MrvEhB5FL7difsLnoZ5AbrQT6
6803	fee_transfer	2248	33000000	1	CkpZc725ChuNRz6z2mnfJo4tmQXpKHHfhCyGm6A5ScWHptZkPq6hs
6805	fee_transfer	633	863990100	1	CkpZywieeMY7Q6opWYMv2vg6bLpfHDLZrQKn6tgukfZEihZumFpYD
6817	fee_transfer_via_coinbase	2076	1000	1	CkpZmheLb8e2KHseeDFYaNEoT8apvsf4FkED8dcoYEhpr1ti6xpno
6818	coinbase	1679	720000000000	1	CkpZHf1covhLavwYp6EzqdGrNbGuo5vByuXZLLS9EDEcxqx15DZyB
6834	fee_transfer	1444	1180000000	1	CkpZKUGXn75DKgDV9WAteegkbbtaKVefaY4b4x9vfVG7Z1nfQW6nJ
6835	fee_transfer	1444	160000000	1	CkpZM94SPVapAF8rbsKTKffD6mMtKihYiMjC8dEvBdo1CZKuPhjpq
6837	fee_transfer	1457	176000000	1	CkpYYyhndpoVFgMQycUFnMxcvMzJjAqGmx1fifQ8TZMuZ2G2rE6QZ
6854	fee_transfer	1447	14000000	1	CkpYRoW9Qg9imDGCpP4DgG5DUnXbyZHT9888SpvgobJXPRwpLjmT1
6860	fee_transfer	1708	45000000	1	Ckpa8AUuB92AMUBtLtqwskLmn8UDGUT5zJoHC53PqH5xx375Tm94v
6862	fee_transfer	1706	15000000	1	CkpZGGMF5a1umZZhQQhDLc4NaVygDwAA7myXbYscy6jgLRzGFxLSp
6788	coinbase	1271	720000000000	1	CkpYvEQ8VjKzVxZnkqcqNW3jYHYiJx8JTKQuBFZhEwyrPZafpLgMB
6791	fee_transfer	1547	1195000000	1	CkpZ6enQsWKqCRryd4yCh3h7Jf2bfreVT1tpZoZ1U7hrZN5JqsfgX
6792	fee_transfer	547	11000000	1	CkpZABANmF2kqTuS9Ravtjnd1cQmW4N71ojLYpBkHBtLWUmtn68Ug
6793	fee_transfer	1685	114000000	1	CkpaDWcjVDp9mGP9ke4ViYD7hUCMFRG12VuPqRwPSoTCBN7pNGXYw
6799	coinbase	1637	1440000000000	1	CkpYo8BBJf3H1z17hFxm7auBY523pdtAYD6EkQoSe4QUZo4Y92WAE
6801	fee_transfer	686	11000000	1	CkpYqjL3CKs2Nw8NpvpyVHMfdZLr8peFQB5P4UMgxNGnnuywG1x3G
6810	fee_transfer	1458	950000000	1	CkpYsUyUV2mqQBVGtQ4AmMFP4DLxbs56iLXMHeJWu23W2X7ndBUXG
6811	fee_transfer	1458	120000000	1	CkpYxnv7riKqj6G8VM6e3aQAFt7oVzB6pcNi2sMNr88JXWJpSK3gA
6812	fee_transfer_via_coinbase	2044	1000000000	1	CkpYqrH69kFB4dC25A1e5BqZCpkqLLEAze5k8pyE8VgwWx1bUhQTJ
6813	coinbase	1739	720000000000	1	CkpaE1DpHi9x8XZoTDuukFLYhSV5fLGDUeTCNGJet8Z5vZ17eS6mH
6828	fee_transfer	171	121000000	1	CkpZrfqtn3Zw2sQbZgLuvkW2FYnC6R6zJFqM5FYQBd44mPoADT7YA
6829	fee_transfer	1395	55000000	1	CkpaLW5oousnk8Kyf1sn3VixMJgDFkzX2LosFuHsctEzKmJrjq3z9
6833	fee_transfer	1559	44000000	1	CkpYnNS5kVXnLvZfFhFyfrdPbxhNd8ZQQA2NUCryETdbjMXdRYywD
6839	fee_transfer	1693	208000000	1	CkpYUck1CZL7o1w7phYTzUXY1RVK2JqCf5mTnvQpxHNUz7XA2Do6k
6840	fee_transfer	2039	44000000	1	CkpZQXiPexx8etc9vErnBqn7MEQCxnrK8tGWN43M3dgrKFKN1ySeQ
6825	fee_transfer	2292	11000000	1	CkpZwgTAZxYQGfwGtSj1ESVkjC3GovoDVKJTssTPADrakV7sy9HGG
6830	fee_transfer	633	737999990	1	CkpZRL118va4dWoFy5SVUyrd4qmGH1zqUxpCu1QSgji8ddHfJ8LUP
6831	fee_transfer	633	14990001	1	CkpYSbUvGpYtfqSiyMShn4ATcb7nXkmzyDGMKafssb4WWoCkYcm3W
6832	fee_transfer	1695	44000000	1	CkpZcwBUskx9MVtfi256QvE74yM1SxHVCmCLjAnqejaLUp3UcuZjp
6841	fee_transfer	2307	11000000	1	CkpZzSj6p7nedByCvYUKBbKACg5N4dfv2vaTFciqBc8h5DiehnNte
6844	fee_transfer	1684	527000000	1	CkpYtZYmdwMtWXVE4qmrVWNGpUJ95xzVhm75rDmbentfXifQEEvcU
6848	fee_transfer	369	37000000	1	CkpYmbYnwsC65t3hPRwtuRvZYgjkyfZKRyWrVJLu6a1xVpPQrSVhk
6849	coinbase	2300	720000000000	1	CkpYqKV6vuSYsF5J7TWqiCutmVeXWJZrEeAyqQqdtqQ5zjpvsHWPr
6850	fee_transfer	2300	12000000	1	CkpZnVnZ63uHSktN5AeJcLEPuxhUexXvquvUbCARe6wFWxARbQ7n9
6851	fee_transfer	171	26000000	1	CkpZNxq3UVCnd3zQJAf2ag38j7VUracyCgZVWUnusL5e2cdFa1Eku
6852	coinbase	171	720000000000	1	CkpZrJQe4ojRj3urJbtXHW59NkPYtt5AU26kKcQbL3hdxWwSm1DS9
6855	fee_transfer	2112	37000000	1	CkpYR6uZGF2pvXLdmWU9r5uZ268KPEjJpnEAYfgjuntzfDQQeuRUM
6856	fee_transfer	2112	150000000	1	CkpYrCcy3nDyswM8PMgk4TDdSAvj4MQDnLopMEaiD9Jy7Jx7Pwx5j
6857	fee_transfer	2266	20	1	CkpYXRHdmWjbLGFGLa2UEBKFFPrMZLFDJgH5atCsK8mojtT4sB5Kg
6858	fee_transfer	1749	86599980	1	CkpYph8R7PHcso3ecbwpkxfLpxYR6GQL12y9HRP26oPtrmg4sUeQ4
6863	fee_transfer	1668	15000000	1	CkpYiSHoQ39MhNgwG4E4RFHZuTw5t5Xp79pQJEmDsFFKBn1NuCb5S
6864	coinbase	1436	720000000000	1	CkpYagkQ5xHpZ4Ek25T3gfNMAffNRMn4EL5QHjZfCYd1xhu9qdHDP
6865	fee_transfer	1436	13000000	1	CkpaA4gjPwDXnmW5c5bKEZcuVhi3t3Wjr3XqWLAyaQotgZHuyjazu
6866	fee_transfer	1709	22000000	1	CkpZAQNWE4sugvqDgDmVzKAGZBQ5S97xmM9muS4TDf3CpFgXKEjzw
6867	fee_transfer	1992	24000000	1	CkpYiJdsgSDiS6p818dTzdX9sHrMxDPARswAsriKLj5SVnYJphbNv
6868	fee_transfer	1992	49000000	1	CkpZ4QNLXEt8LqBSrtmPD5Z5rNRi2TTgSZabAPsZHkhcSkycD7Leg
6869	fee_transfer	1559	122000000	1	CkpZyuVsxKaT8Tu7DguWjJtf4WGXr26mEcN6S5aP54YfG2bey6grD
6870	fee_transfer	1587	86000000	1	CkpZTsdHB4DgMn3tsWdGqKEG3P1Q9PRQv52waspU4TB5APW8qmLit
6871	fee_transfer	149	86000000	1	CkpYqXDu3vgZayhFX84CCQDoY3tzvxjaXVKFbtVo3ZvtT1yUJvdc3
6872	fee_transfer	1546	36000000	1	CkpZ6GEgQtUtxPpdzPZ1tSQsNBrUUcCBLDwD8aqB7PQGbeu74dwgM
6873	fee_transfer	2261	39000000	1	CkpYxtwxUs6euwTp5d4giQCmezWGZgezF8k6wme9VdLoPrVH2fLo3
6874	fee_transfer	1546	39000000	1	CkpYwQcniDpc6W2P2aDamgA9J8EaPyYBtC55nC649tVJN5g3XUbPv
6875	fee_transfer	1673	210000000	1	CkpZojBAorpj5B5fE67wtuUJzK49TcMC8H6aYDgAzte1WhdLzSyU1
6876	fee_transfer	1673	843000000	1	CkpZaJP2fU9tM39JNc7Ed4XJUQJy6ezZG6WK9xeEHzm1w1bCuvFFq
6877	fee_transfer	1480	12000000	1	CkpZEk3FJpDTvw6AU23iVuCHrzJ3isQwRw8JoVhsVxTrFb8QxPdSR
6878	fee_transfer	1552	25000000	1	CkpZ6ZZqA1td59n8fSVehQy54dTqpDYjAfGt71GBbU5EvNdwKDFYB
6879	fee_transfer	1549	27000000	1	CkpZNKck2hpiM7DrZpsMdeJi5dUpWMQ8RiarV2C5FDLsSLqVpyi2h
6880	fee_transfer	1633	27000000	1	CkpZsDfYv9P2LKs2JAnQB3wby8aQ8PUhufVnifTHTQL6n1RZknLbh
6881	fee_transfer	1992	400000000	1	CkpYnEsqHGwMycTu3sth2yFTpr6uFZMS4TCv31NMYPS5z9GrEpdCW
6882	fee_transfer	2266	10	1	CkpZ3eCANh6cVfjBcbuxNXJhjXeB8ess2c4PvuiAdmcduSXCrySeU
6883	fee_transfer	1506	11999990	1	CkpZuq1Wkq895kBQmXK8m63BPoFWCRWRc1cavGXHw4fn1iDd7Tj5V
6884	fee_transfer	2307	12000000	1	CkpZAuBg51pdy72snN1ksg4xWqT8b2ThVN9eKxXpzQPAKs31h6fHt
6885	fee_transfer	1685	402000000	1	CkpZf9HyKo1jmcQSCqMThkUirwQBbXmLpMRM1Q1X6nGxoPF4ENhZd
6886	fee_transfer	1780	13000000	1	Ckpa9m1utgBXmX8u6NHZWmJz6Tvt6pgpUdTob46ZyoHxrDSaqaXxq
6887	fee_transfer	1571	26000000	1	CkpZdbULVYYh1ZFshNLGvooneuGqwUH68SLRQ1KR3AQtASENPCfit
6888	fee_transfer	1458	26000000	1	CkpYeu9DZrqDLJk4xEErv5f1J82JBUepkTQ7DdHhsTDkC29UfeDJ2
6889	fee_transfer	1536	27000000	1	CkpZyuf2F73382MuTCoFXQh9asMXQvnXcafscLGVK4Krgd2H8wCpU
6890	fee_transfer	1678	3000000	1	CkpZXxZ5mMKGeg2YxgaYXWKuN4hZod2ULMM9ahLUPR1PQB7rcbMQT
6891	fee_transfer	1693	38000000	1	Ckpa8eabVyaQPRKxvASabh6PaB64RHeMq8G9SwLKxxsNa9c81DqZn
6892	fee_transfer	608	20000000	1	CkpZXwfcBcWq4e9dP1eCQZuWBxq3GsuMr8jmR5TcnkJvJueBN1tgc
6893	fee_transfer	1602	28000000	1	CkpaEXTdvn2xVhqVur1Hw4GRm1neCrx97CjbbjwcyQwh1YTkMkJDr
6894	fee_transfer	1471	26000000	1	CkpZjyXzife1WB5ioJea7Z5UAEPaczgDaQfVhMzMfetjbgnnc81qy
6895	fee_transfer	43	24000000	1	CkpZ9udYrkXrfrNMkNe7CPBuE1P3KWfL74FJD1zDueJmsHAspYMy4
6896	fee_transfer	1675	25000000	1	CkpZBBh6K2yifL6jT76bzRSHLuioJQ8S1d8yck1kWcnfvBSH17Bfc
6897	fee_transfer	1588	24000000	1	CkpYjHhxhtnqDQTFu6UsqxVpknyBDeydEcqz9pUZteEUJQB23rmzU
6898	fee_transfer	1455	1160000000	1	CkpZVrCCVyHpJizsiJXksEJ5ECt6gN2vdFHPTJa7oBkoGVGKxytVg
6899	fee_transfer	1455	344000000	1	CkpZMxpWsFs7q6Vp35U9sSnz8iGZyMWbYRgn2zjUZV6yKxA4UAqe4
6900	fee_transfer	1708	14000000	1	CkpZKnSh8ACGnKyvL5B6h9zdkF8sNWJpVJ6tkBoW5XBYSJmxHUnYM
6901	fee_transfer	1448	15000000	1	CkpZbmeVfthsYwhgyDfL6pUBP5hpnPVwKoDerZbU6Kp9heK8XpzXA
6902	fee_transfer	369	15000000	1	CkpYwHSBC4L3ywpPQ3AjWWAz83DaT87hHAXggTAyPFTPAr4q1xxPC
6903	fee_transfer	1458	86000000	1	CkpZxe8u9v1vseo8FbnNVNH1FGHejSvPNv8YwoiyUvf9WMPNzaqL1
6904	fee_transfer	1762	209000000	1	CkpYfJREeGKjFcZpab1w4Adf9CFFpvB1fxQoX54bjw5s2N47CmUcC
6905	fee_transfer	1698	961000000	1	CkpZZkF5ZgY1z3eUKFR86EeJf7oybJNkMGPPagb3adD7rc7tdoG2F
6906	fee_transfer	1698	342999991	1	CkpZSSNbuFs2KR7taSrv9kcseEfcY2hgCQXyQcmirjmJpjKNXQKg9
6907	fee_transfer	1455	215000000	1	CkpYV3raSvB6BeabNvi4V9k1Bd7jiWjZ7iCe9w1yXvk3ifJ8VEQ1q
6908	fee_transfer	1455	45000000	1	CkpaB9W9snis2fGW1E6LHHvQSfbiCkwoJ5Rng22WBXNhimhFi173J
6909	fee_transfer	1593	772000000	1	CkpZjRHEurzKGEcdYtAe3adqDBxz8fHiUhLmx1eTii4Hs2vzf7ASU
6910	fee_transfer	1508	2000000	1	CkpZbbPxa1yLEWhgCnjZXbQesHRRQR3Cnxaqvp2RnsmnXkJA976wh
6911	fee_transfer_via_coinbase	2253	100000	1	CkpaCG1fCzyAZfwe8qXu4BGivkaaAqg5WDnHs8jmb88kay5i7uyN8
6912	coinbase	1693	720000000000	1	CkpaBFnJpMccCGUx169pGKF4X7wMyfAhKVQAN1GUiJccS1C3yxe71
6913	fee_transfer	1693	21900000	1	CkpZJzsgtydt3Swxfg9jNfjtHDJqEGoV9qtUr6u7QNYusE7SWtCDc
6914	fee_transfer	2253	100000	1	CkpaCG1fCzyAZfwe8qXu4BGivkaaAqg5WDnHs8jmb88kay5i7uyN8
6915	fee_transfer	1654	2000000	1	CkpZraXW5hfLcVMUTWKvP2q6WhQwxusfgDTAH2ThbUvVLAd1A8Psi
6916	fee_transfer	42	25000000	1	CkpZjQYFYJsnQqLmjPzUtZ9Vnry1zTgRMc6LRLE964vKhuuP8fRpB
6917	fee_transfer	1602	263000000	1	CkpYVz9a5YDdqapo3SJh9dxG6Vtzbtp9Gmqra2vzEhvWLAJ6jyefs
6918	fee_transfer	58	263000000	1	CkpZjAGn8phdHzTkAyHVZZwURvNXtB1y566YaDCZcHyK2abKPnP4T
6927	fee_transfer	1457	710000000	1	CkpZxosp6Qh92ywZnuWeKYBR4D2aATXn32G8fp4v5fT3EiCXSFbP6
6928	fee_transfer	1457	1140000000	1	CkpZk3YFSaHTFBWPuwFcVf7oEYbb391iKi4sXTjUSeE9w1ASss2L7
6944	fee_transfer	1599	38000000	1	CkpYWdA9LXCx2eK4o9Yhn3Qpm1rBzeiaA28ej1EycywZw5hmN1qg5
6946	fee_transfer	1394	31000000	1	CkpZgkK2L2YRijJwvVjJwzfTJqoGz8PiCSD67T8DcYDvzB2mzG6bw
6950	fee_transfer	621	12000000	1	CkpYk3EjCNGrvZVAyruXdTGdWFiBqumDjuGDRRk5ZpvHNVUVhsu18
6954	fee_transfer	369	34000000	1	CkpZLXZ94x8U8jgSiyQtLVAV7VKsHrS6qpbRFew5oqrfsjrkyMFT3
6960	fee_transfer	42	2000000	1	CkpYWGzQG2PrkAfKFaaKgoPSoCQN58Twk29C2TqG8Vrc4zHqPRNYP
6966	fee_transfer_via_coinbase	519	1907000000	1	CkpZaZCCcAtwDBynSwixwWHHp8GtR5WKWhkc3Cs2Fn3RK7uvA87iB
6967	coinbase	1719	720000000000	1	CkpZhQ1DbZUWRHzYqwjpNTEJ3DzynEgBVuwehDgnLjNQ5hgM1qCWH
6968	fee_transfer	1719	42000000	1	CkpZCDJc2bYuqUDqb8FPdCbGW7r2Rb4pGAaU3RpijbhZ6bpwzW3Dt
6969	coinbase	1686	720000000000	1	CkpYstv21VggYZ5JdXT3iNvc2jeTxAjiqpetiQB99YzPajpzpC1wv
6970	fee_transfer	1686	42000000	1	CkpZ5GBzb6u3t9um3znrxZR8NCa2XdGuMeDjTejJkqRjpwTvq9RfV
6975	fee_transfer	1448	22000000	1	CkpZFaoTrp9dgojtdfTakQpx6xmH9GZtFSnQNq3xptud8Yr5hffCq
6976	fee_transfer	1434	11000000	1	CkpYr289XFo6awhDhdsUKt5uMKVmn8Ax4c3EfLRpWGB7gPduG9oVh
6977	fee_transfer	1657	568000000	1	CkpYi9Nry6tspsevsRZDd1tAAPGVN7eeyJSm5pyjjXwwt5srsi6B4
6978	fee_transfer	1422	33000000	1	Ckpa1kfvc4sfNHdX8jmtfiCgdUDJ9DF49YLDQh6pSBCD2Nbqd36tv
6980	fee_transfer	1746	44000000	1	CkpYpcFQwj9JiXwSjA7FMCsnNrRacdovBq26mhGj1dLZLo2tP6byd
6984	coinbase	1533	720000000000	1	CkpZr2HHGeh6kicLD7yJuBtoxYzPn9hJqqmURwEVkwYGxzNDsoh8L
6985	fee_transfer	1533	10000000	1	CkpYb9rJnun6NJXBVCs9o9db6k6p3sWSpSAGeCuNWcC8SXasJJMhJ
6990	fee_transfer	1593	1049999984	1	CkpYnSmA9xVS7VVSU758dXje6RrhcdRtKrdRLjJphwFDQtBGRmNtv
6991	fee_transfer	1593	29999976	1	CkpYbVWjK5ZmFuXFWmLBD51RYweibtsVXs85LN9k4k7GWjdkmYjUf
6993	fee_transfer	2261	10000000	1	CkpYUv9gT1AyV5MyNsX3Qeca7ouoAEPvLQdFnp52VGUnqyGvQphig
7002	fee_transfer	1709	112000000	1	CkpZVR4Btzx39FXictLxtiGbFfi1cXCtJ73VWsiqaxzCCRDowBKBx
7008	fee_transfer	1623	49000000	1	CkpYxUpAZghdk414q1s9X2gzqY7oXJUFMiwBaYfwbFSExoLJPRUME
7010	fee_transfer	1522	60000000	1	CkpZm35fdnRtcmmAP1Q6AZ1YTD8C2ZMLMWR8DZcuyAxcBrkmq4mTV
7014	fee_transfer	1691	37000000	1	Ckpa98C2je2ojwu2p48yC93sEak4Efh2WZUMDFEi3aoDr9abPbmib
7023	fee_transfer	1541	49000000	1	CkpaBUF2dgPtw23YrQaZfzcEreUP5zpHnk8wuSC91kuDppfuSQ7ni
7027	fee_transfer	1746	47000000	1	CkpZ1Ag8hQoyUaJHh7Rdop8Ei4m3wfSUt38S2nkJh7QPaazBkUXrv
7030	fee_transfer	1705	47000000	1	CkpZbtjWC2LDWPQhUPUCgP9N6Jkn6oEKZGFWQqXQpJsM4fVPDBhoP
7038	fee_transfer	1759	111000000	1	CkpZ1R2FiujQwAVYVAV46HDtyVgBRSzXZ7QUZ5Q3fx5fG67cq3GUF
7041	fee_transfer	1508	34000000	1	CkpZaJjLy6G3nt5skEq8Qv8oNzjfavp63RpvtgpdiMGZ99nx6g9jF
7051	fee_transfer	576	34000000	1	Ckpa8Qoywyk1q5hPXkBFDDw9jpU1vmxNeS6nAVetEDJyHo5X7UEQv
7074	fee_transfer	1541	33000000	1	CkpZYMecidxQ1r3nnt7jyz19ayzm8mAsqmSdZSKH49ELeojd8iCHL
7076	fee_transfer	1654	1170000000	1	CkpaAwxyfoKfgr1XepqGus5s46sTwahncyffqYmUduySQYQCbMNsx
7077	fee_transfer	1541	45000000	1	CkpaF5HV6y4xmcWibUmCmh9hw7ykb5Nt3zh45eUFxF9MMQRJ3jckK
7079	coinbase	2303	720000000000	1	CkpYhRumDeijuRSJH1xpWAb7Y6ThWducSY3i19PENiJaq4JwU1ss7
7080	fee_transfer	2303	12000000	1	CkpYphpYMZH1tX4bQRGSr5X3JawrSckHUXHTETsweknwoEj3QRuke
7081	fee_transfer	1684	134000000	1	CkpaBmf1FFjrgqe6TomfAUkaC7EEE8fqXJqUhhmqjHkawdM5xzuzN
7083	fee_transfer	1613	32000000	1	CkpZ6YvHHsmXVCRrN1qEK2RkN4fXrPETWXrymUjC3L8f5fqXJiux3
7086	fee_transfer	1549	1999998	1	CkpZ4ifHH79P6zMgSJQaLTfiSpHd4QRX1yyTWXwSMba4vVgeEUqPz
7091	fee_transfer	1717	34000000	1	CkpYnj8evwyDkbN1DpgZCRa2g57CHbK7kLKp712m3uBnqPsYqkNWA
7097	fee_transfer	1693	3000000	1	CkpYbuSRdJsG5PFgpBbUsTp4xstGWADYhxcf3PVfE32ihCmjy7PQu
7100	fee_transfer	1489	62000000	1	CkpaGFw1pXVYtA5b52ZLJF3c8fx5zdEa6SSCeXwoyqZkVajZKUP8w
7108	fee_transfer	1549	112000000	1	CkpYZzHWDRn4p6jry1cmA9Mnk1vKw5VoWWKBhVm2niXUqpcvTzgcG
7111	fee_transfer	2307	112000000	1	CkpZuTaw36kPrT1aKz4B5RCUrSgvFcB7UNMTXwQWMCj5yagocQmYC
7121	fee_transfer	1716	32000000	1	CkpZ2yaxJWLKuKbTfpzBrdFQE8aPgdV8cMeDx5HboaoyPAdWWvbZ2
7128	fee_transfer	1696	73000000	1	CkpZMvvUz2wuduHkR1ankMaxz8AjL71nEHpKkBnGXUTFiEDy1k2dM
7132	fee_transfer	1439	52000000	1	CkpYVtA49Cqvqw5CrNgPHXtmvaRzAraPk4xHsza31yjpGT9eFKPDR
7135	fee_transfer	1637	51000000	1	CkpZbyupdceCofCRVTG5QEB4NGiLcEJ9EPHpBp41mWDdoTyomrux5
7140	fee_transfer	2039	341000000	1	CkpZ89ZgQAmsKZQ9LrPRch7XCJZHnVFxxALg2YXuUpBaFjoqZiJSp
7147	fee_transfer	1588	53000000	1	CkpZuwk8X5bEv2ZnqgtaEjn5H3mrTv7CEJuGUpTX1pZa32iCD89hR
7149	fee_transfer	1671	35000000	1	CkpZ7dsTBSMYjZVmzBYQHD5kHWUVo17JW7nDfHAk2PghgyZQuFgmW
7151	fee_transfer	1544	13000000	1	CkpZvLjgfsjyzRXHz8mqUB9bYgZ1kmuk3rZ1S8jGGdgaYrPdBbDNj
7157	fee_transfer	1623	37000000	1	CkpZR7GmWmjDoK9BijA1Km4KE8nhWQQ73aRTVR38R8C53WKj3NFne
7158	fee_transfer	1458	37000000	1	CkpZYQn376GWLEeezSYpsThXSHHKZZWNKe4XVd15jvFyoqkmDSoZY
7165	fee_transfer	641	712000000	1	CkpYnjtAKrS2eJeabwgkeM3Z5wxnturQ3zHYuu6qxKfhcG1eks3zF
7166	fee_transfer	641	43000000	1	CkpZH6od82MH6uzmGvizZN8ppJg1GcmjNpBDmzJn8r7QQaagbL77s
7173	fee_transfer	1619	11000000	1	CkpZoVeP3hPHcJ4HCHJwkFR2jLuW4EgwLUN2UwrtVH1GWXhm5Fz64
7178	fee_transfer	1395	4000000	1	CkpZKULTyv6yXa9iR645k397z6byer13uTdLgEGiDRJDe7yAdAwSH
7181	fee_transfer	1549	80000000	1	CkpZTfeWQmpZzU1sTpYhhtLwSBGGPmPjkr4FJAQ8MGRNhSFGpegDx
7182	fee_transfer	1549	31000000	1	CkpZTBVtDbwMjMQg7JzXQQ1SkMeuCijY73UoWSSdsT34LxyDuJNWT
7193	fee_transfer	1740	47000000	1	CkpZs9XuFApfStwoGT17VrjYUPDVFLLNZo1VLH15nuHsek1VkN1hH
7200	fee_transfer	1547	26000000	1	CkpYreySb5YAbM5nNXMjFx6ukS44SghVx2GbsnsnMECMNxtPq1cBd
7203	fee_transfer	1702	35000000	1	CkpZtMEYrnEWTHoi8pnUKAY8hbd1LC8Aunu3o8ABx46k1fMgHJPim
7219	fee_transfer	1709	3000000	1	CkpYUA1ohqu5XtfFZBbStQpqNy3CaRQLxfScmSGJCXstG2wfU6pU2
7220	fee_transfer	1756	34000000	1	CkpYnY6gMKbP5dKSSJaaW5pd6Qbocw3CYHJVAZYK5J6eQ4EvQqQ61
7222	fee_transfer	1705	49000000	1	CkpYr66L71XckK2WG9djnM59JG6xoGBJof4xh6LJdbvFK85pWkjxX
7224	fee_transfer	1596	24000000	1	CkpZoDhVWBxGeHtkNh9hUtrmcJw1kEK8Xgo8S6jN1pLwpDjE9dJwe
7225	coinbase	610	720000000000	1	CkpZo71Nd1hasutoRpFXQk6Qve6wXKXhNZnnkQZn69stDaC44kkNH
6919	coinbase	1718	720000000000	1	CkpYyFXvQCNtGmVdhGpRN9RHJAnwMBTYMa9gXKbdZLqpkhH6CGeCb
6923	fee_transfer	1447	26000000	1	CkpYU6jNhjMkUmbMjHVbdxrmQ8fmr2feiNnSYPx33sCrw2FqXxUeQ
6931	fee_transfer_via_coinbase	2097	99999	1	Ckpa76653unPuN2gyNio1avS7gzNZExjQVd35irGTvMZ2VMeJkJG3
6932	coinbase	446	720000000000	1	CkpYgTVsvYtTgM4zLrgDBXEAjKfLTTUyewQmbHoYwftR7ekyiEz5P
6936	fee_transfer	632	641000000	1	CkpZxMQ9fyGMPMQxsbQpZRSxaELaa2pvEwuBz38fL1oT2Lmbi6STS
6937	fee_transfer	632	667999998	1	CkpYw8oxGdJqYr9Cme3x5Csts65VqgucZeyw31f6C3J9MuNHSiVjX
6938	fee_transfer	1538	10000000	1	CkpZ6EkKpE6s6xmF1gQryx4Jm6xdPQAFzoVR2HPBiy9cv2CeN91Sq
6942	fee_transfer	1455	1040000000	1	CkpYRwJ8CvXXGoLFmcXQz4G8vgwbKACtY139z3phSDiYsFRUmtqhu
6943	fee_transfer	1455	168999991	1	CkpaEmzD2gLbnQ8ha7uzcYH64JNSEwec34uGg86X2CCLZ7UT313KE
6947	fee_transfer	1671	37000000	1	CkpZmYLfxGdHt5JPhGxaLP4FB1d3kNS6JumXsULc6pXp4zgVyKiZ5
6952	fee_transfer	1447	15000000	1	Ckpa2TVjbVnWieXthA3QiTfet5GNPKDNWicKAzvqHcFzsYK1c7AZG
6959	fee_transfer	1756	73000000	1	CkpZZXNbRY1DBJnup7DCSMMc6ZSMTxDntYxNH1KEoQgv6TmAiPe1j
6981	fee_transfer	1747	44000000	1	CkpZ1hLCGtn4qnU3ZnZUTBZj9SePr9fX1BuU1Du88esnMrg3gMFc3
6992	fee_transfer	1657	520000000	1	CkpYb9kofLG4Rsk2rtTdGfSNPMFVywsFL7i6PSNivzszrTQuqWJkN
6995	coinbase	1613	1440000000000	1	CkpYVnyYTswoprHbEBBD9YBeDnfUGqZXDYrsR4xqZYd3nPJtFAQU7
6996	fee_transfer	1613	44000000	1	CkpYfDDjvDaPqreqEgBfKPhgNHevSoP5B72ApTspFXP55xftrAUqL
6999	coinbase	646	720000000000	1	CkpZEaJwCKXyD8VVGaaNGzbWVgco3R1LZac82d7ZgMFvGuhfhURmb
7000	fee_transfer	646	35000000	1	CkpZTKJBwL7cTLi9iQuZEbaZiVsqDzkrQT4Koaajf3YaYLMjtYL48
7003	coinbase	1439	720000000000	1	CkpZjHmVwoNZkJzKxYKkj6o5iUgH36vq4Mmr7jwpnAWrzGWZkUJdn
7004	fee_transfer	1709	6000000	1	CkpZvci8mbSwkmYZHJQUaxYz76x2Rvyfom6fdGZuVMt3GTpvfW4JK
7005	fee_transfer	1708	49000000	1	Ckpa6WCmYaNGUmreE9nthKwpJXHNURPHXokxmiVxhWqw1jnwk4HfG
7011	fee_transfer	1634	60000000	1	CkpZygpmJ5Lmzuo4dmkH92EcYxQJvmfbWbJgAfFdErf4fWp6FhbNM
7016	fee_transfer	64	13000000	1	CkpZKda2fwtawomRGpfv2S5ud3A45mhCAf8rojCgbGv3CdYwVZk3t
7017	fee_transfer	1668	21000000	1	CkpYibLzQHzaWS5PGn9a1iEMDDW7mdpzh7joU53pCNwmiTZdRVVDk
7018	fee_transfer	1668	4000000	1	CkpZbJDbB9YdhTsQtWGopJDd2g5nPFq6YfPTg4qsH37PczgJerntv
7024	fee_transfer	1718	49000000	1	CkpZVHMsH7VASvB8Dh5a3NBHYfpxkacwtgUwkAXzV8Um3sdmbmL2U
7025	fee_transfer	42	7000000	1	CkpZXhw7Qxy1NedmGiYpasZzmFxffvLtdZn8sdsE4QFuSkHfYsktm
7028	fee_transfer	1747	47000000	1	CkpZPzD6Mo1LBZEwHHS85vR5kx3GnH3RUG7ZqAaBGtqn1gKhf8Mpz
7032	fee_transfer	1685	122000000	1	CkpZVdgmz6rZ8AkoP3qUaqVMDhe7bgW8NYvrmx5BPvG4ZcqCugE6E
7039	fee_transfer	1476	435000000	1	CkpYuqKWtMMmPhSr6djHbDEPNskHrVwFN6DfEfe5ToTxgyggEkPbH
7040	fee_transfer	1684	34000000	1	CkpaCFgEW8fBqcyycs7XfhiR8Z4W9hWqsoRjFrpFRye6eWkiHoYEu
7043	fee_transfer	641	21000000	1	CkpYkTPT4Enb5hd2vCvMPaULsx6VNb8TjCYkv89MRTWuVYfLjDwrZ
7047	fee_transfer	1559	1190000000	1	CkpZ2RbQ4ZPdpmMnMkBDapLpr7hAvU9iUJX8rm7DxuqnKdsHNZ9MQ
7048	fee_transfer	1559	281000000	1	CkpZEq9GD7NEQ4bZShk27hYVaeuvAmeSpgw9LjYiZv7gBkNvKm84A
7055	fee_transfer	1855	380	1	CkpYkimNVMfyzURWYD8uFy3hEQP96LaeDTVghRBAYYbCpUb1aKiNC
7056	fee_transfer	1419	999620	1	CkpZXseatf3gytCuKPxdr43Wn3HJCX13NAVU7rXnhyr7wM6PFfhyU
7066	fee_transfer	1675	750000000	1	CkpYRnjboZXL1AmUhotZjKYJceG9oURMUsoSLgDtN4A6ZMNa4FmJi
7067	fee_transfer	1675	860000000	1	CkpYuGWFojxmjy4RSQ7sLgzDYTd6UDeip8UV7s8dDNw5cREqTXdBJ
7070	fee_transfer	1681	101000000	1	CkpaB4ufiyxhgYwcFzJta5nvCxcANaAJ5EHFt8JxwvNwwV79n8WSG
7071	fee_transfer_via_coinbase	132	1000000000	1	CkpZ2bFBZzqnWSsqW2RFxkYyZi14HojZ5Aj36RY8XbPVW49vKm8kn
7072	coinbase	1688	720000000000	1	CkpYivYppQrdH5JswpFrJWymh4uDLReW29D2XdKmuSsgxK8Z75eff
7075	fee_transfer	1654	23000000	1	CkpZ4MAuxivhgJFkY3RgmLdyLV1N6jXtotDLuVFu3Bvq4fDok64Nb
7078	fee_transfer	1718	45000000	1	CkpYcWEv4LasAhmiJfD3sWca5SnTvQmc8XdbNA2UN6MrSBoZPEBhb
7084	fee_transfer	2306	32000000	1	CkpZ1k2VFdPjj2uovX6icGXSntWA8W9AqDFZGcLRK4jzYPCQiJVo1
7085	fee_transfer	2306	2000000	1	CkpZsodwHLNy9H2r3U7PzLPJ6hayBuUxyf9paw815qybvUhnAFtCe
7089	fee_transfer	2148	34000000	1	CkpZ2Nti6HwYXrMYBLwHwUYqSEkjUQz1UtLQsuLpiArGbdWgRyZ4m
7095	fee_transfer	1723	127000000	1	CkpZNyon5xJReWBqAEenA6oqC982F2qH6kcHhR8s6X5bmcYEqxXMZ
7096	fee_transfer	2039	123000000	1	CkpYuSiKihzn2vc9Ny3xQprfxUETwyskv79W71GnZcQw3JRxkGQak
7099	fee_transfer	1549	62000000	1	CkpYWd48atejYrJf5TMiDVizWQfxBecexUifLmHcrLX3girbWy7HL
7101	fee_transfer_via_coinbase	2067	2590000	1	CkpYpzL7geNswz6Q7N1Z95sSTbWCJQuiaWCwrsA1d2d3p6KSgPRNr
7102	coinbase	1489	720000000000	1	CkpZD69Z8YoGVAYbvyNhwmxJ6fJkpC8UL3E88f99cs7nh64C2BtDV
7103	fee_transfer	417	9999990	1	CkpYr3LBRKDEqfUT2LzvtzgJKb23XKsbno23jpqMXRyCGLvBdJ4gZ
7104	fee_transfer	1489	52000010	1	CkpZN1FBZ7dApNFqdddmVHNE8KNRXqLzt9erD1tXoXizWPaSDzXCi
7105	fee_transfer	1489	1280000000	1	CkpZreZCvJV525EwBTF49DZNGFP4uWHk6vpwWjoqvRrTkeERM78tm
7106	fee_transfer	1489	600000000	1	CkpZ8cWpn1kgsga7NfRzokoMQkbtxyPNV9Nzh42Eygj8G5n1w8VyQ
7112	fee_transfer	1723	225000000	1	CkpYvRiCtC12S4SY4sYGj54SUij8k1qAuzGAVC8d34LKbeoD4vgVf
7122	fee_transfer	1685	62000000	1	CkpYfeNuhcJFa1kcrQmKMDF1nYYYXj41y6uyweKCRYPujhRUGXZ99
7124	fee_transfer	1394	207000000	1	Ckpa5mWbQX4qJhn1GWvfuMoahcfn3KDTtGKXEpTyTyqZau29YwLKr
7130	fee_transfer	1395	60000000	1	CkpZMXejUCguFjjB4McR75oYwRyKqWTbGwcV3A3tL2odQW7ZdTDTq
7136	fee_transfer	1679	62000000	1	CkpZFKMGnwPeKMTTvm5RGGic6uyYwQ6aAdoD5JuJnF8YEDN6AMiQv
7141	fee_transfer	1395	30000000	1	CkpYmqYs9s7JFSjdyfT33LTE5j248gu9wdx6UiyA1jFYq1RR67cX2
7146	fee_transfer	1471	62000000	1	CkpYcqSptDPohpSk39F5ubaVPLszSkon36h8BTNo5jAMaeqwHi7aq
7148	fee_transfer	1564	53000000	1	CkpZkmumMrKdNHuj6aJBckRKyLi6a2CxDs4q8tGJ5ijJ5WsY2LTaY
7153	coinbase	1693	720000000000	1	CkpZcHKVo1AE63WncPzpCMFoTGptwn2v1nC1AwSC8sCTWXFiy5ykg
7159	fee_transfer	1668	42000000	1	CkpYccosAtmsTCJkK5Re5j7h3BYoXTKisyCBcoiM2eDMX4i8Laq32
7161	fee_transfer_via_coinbase	1966	112200	1	CkpYuXWms9nVTANg1ckQUDdtgvzmdWBXbv61wED5FaCxeRXACoR49
7162	coinbase	1649	720000000000	1	CkpYafV1XzZjSKAV7S4ycGEkkBCegVSUFYQGz4shMMajAjzgMwa55
7163	fee_transfer	1649	1063000000	1	CkpYY9S9VBY1pcRNeJyaAyyFAmPzhFG2SNZfFNTC9GMBCyjq7EEWc
7164	fee_transfer	1509	57000000	1	CkpYoPAG35fEe9x25Yph19Yb3ijjjuG78rH542AwmDahhyBW3bDWh
7170	fee_transfer	1457	26000000	1	CkpYTnw9vuZche7zjaFDzrnVsf9ZTxMCWi1LWsXGQ2K8yBZZ69g7A
6920	fee_transfer	1541	25000000	1	CkpYjx4fAB4aoB2Q1zf4tE9zaepxzAVKB8zB4RizCw8fa3KWKvbFr
6921	fee_transfer	1447	23000000	1	CkpYvbDuQAt1bvXNS7xuvz1UKeCF9bKiLgamB16nc5LcdUb6gN3LM
6924	fee_transfer	1471	250000000	1	CkpYyqi6YHkXvaoyBGZqSDRCa9BK249Uo2bsnHPiYVoefrLvgKKQS
6925	fee_transfer	1451	15000000	1	CkpZhuEkQ5q2fksFNgG39g2AQ3KkD1hc7RyjfmDU5smEPAxPusb73
6929	fee_transfer	1513	1660000000	1	CkpZdf26Rhioq91PcwQXU5CGW85xpgNNg9AeE6hHevtm9kCAJ3LhA
6930	fee_transfer	1513	190000000	1	CkpaAyDkQgUmKipB1TafKBcW1sN6PtmqnHtJCRNXBL4KT3wpRQsBF
6933	coinbase	446	720000000000	1	CkpaDMCJ2WKk7r5a4HTSW5z1FiChdHETshKW69ZMQvkS5PLdLdgHM
6934	fee_transfer	446	25000000	1	CkpZAYejopNPbCdChnQvkg1EJDn74vJMKFA2cUCmikf1VG6xtYpjR
6941	fee_transfer	1719	48000000	1	CkpZCfpUuFhzMbSHtYgpE5VstpQYprZzfzC3DH2MapTq2VsyFh3gT
6948	fee_transfer	1706	14000000	1	CkpZJwUniKvDRmUeBve4aq53LBkN1fwKJ8gfbPFU19fhCrxvyGEuE
6951	fee_transfer	1701	24000000	1	CkpaGA26ivZRf9ATBwD8MmKBnsxY9uJ2xcSx1SDnH1zCTPNpvjuPC
6957	fee_transfer	1394	121000000	1	Ckpa5eARwQVmTN9GdXFFGqNHDqEZBMxU9ZmBmSvcMXZMKGHo6bDsn
6962	fee_transfer	1709	290000000	1	CkpZeH3VkQCvBV4rV7EfBAx6TvH8NrHBNCqZXjEdsWAe5k749Dp5Y
6965	fee_transfer	1717	36000000	1	CkpZdn9kJhDFRRobfkCb2CZFDxjGTDb1PDPhdEPe5ybh6s5jTheQm
6974	fee_transfer	2106	22000000	1	Ckpa7mAqpA7d9Ut5oqzNzq7pp32PN53gmm9c9UKquFNhhMViF5KWq
6979	fee_transfer	1818	55000000	1	CkpZkgwaNzwuAJtcaX6tGE2iQnNXYQves3cEPtfHKAtAujr5xnKkH
6982	fee_transfer	2292	44000000	1	CkpYzUHGHffwLNQa5rftHQgKfikdteCGwwEDWJ1HyMUnJZngLyLan
6986	fee_transfer	1688	46000000	1	CkpYyC1EB2pQs8aPhEmfggwqazwqrm4u4Dx6RhPq9YWbCrWee1hyo
6987	fee_transfer	2307	35000000	1	CkpYbvK86MNWfeMjHJXqBtxJbE6A1X2sVJRp2Gk4M2o5ozsqDmec4
6997	fee_transfer	1687	23000000	1	CkpZMNuYS4KADLr95tECnTEyCvVutkREjCQupJYeovfcwcjBZAwxs
7009	fee_transfer	1756	61000000	1	CkpaJELEXzrjNqCGJgeeJEDxtUJNVDxcok5BJbEYvnxWTXrCfG16z
7012	fee_transfer	1692	62000000	1	CkpaCzSST8MAv8UhRkXGyz9xvbGgjeFHWQXiVjVB8CiVrpcMi24FP
7013	fee_transfer	1768	37000000	1	Ckpa43kuY1F2nnudxPU8DtMRxdgSj4Km9RYmZESdYCV9VTy8LFW7X
7019	fee_transfer	646	2970000	1	CkpaHEFspaD6EfDNERbrKb2HN88cq3RN78BbF7r6bjZA9xKaCbTMw
7020	fee_transfer	1668	630000	1	CkpZc4As7kS4t6KqoDKsXRvYLpCvPidzqTCo5H7CpGBhvUaEwXCut
7021	fee_transfer	1788	400000	1	CkpYYZ8DVSmjeX2eYvimz6MYMVhyuT1F8PCKzoir5H7cjw4xpakho
7022	fee_transfer	1573	36000000	1	CkpZ2t6PAC33KoEpbdhQisA2Qz4pz4159xTXBFBWj6x5aZzAZbzhB
7026	fee_transfer	2292	47000000	1	Ckpa5iZA3Gj9Bwm45wD4qNe8ab5kfLsaAvxnkr8TE4MvzUFRxzRFc
7035	coinbase	1623	1440000000000	1	CkpZT58PapMziwv5y7AmxJpuXQqCprLN9tBTYYQT9vrgGp573sAC2
7036	fee_transfer	1623	134000000	1	CkpZrQHT5yDv9eAt86G3pF3ghrFqgoAPNwcqyh4aXb7mywVvy3v2b
7042	fee_transfer	1573	682000000	1	CkpZGtBxzKQkiVVtHSKiTjCpMxAMRv5EqDnP7RQ6qvDkE6wJ5r2pm
7045	fee_transfer	1559	110000000	1	CkpaHE663ydzR7gp14YvkrTx6tz5UGh3Z78H4Qv61P6U7Xa2fvtT1
7046	fee_transfer	1559	108000000	1	CkpaJggFytXfeYGLPhuvzdsxvBYJZazauefJnnLMJjVMEjyT46xXs
7049	coinbase	1582	720000000000	1	CkpZZn8ziQBtryj5gyF8SBPhrUL8jsaUz24eo7q3VR9NuxsNigiuA
7050	fee_transfer	1582	11000000	1	CkpZrioisnXeDsMXwxPoDRhC6hVSonjxmGnVxYy2i4xGFSfCM9xbv
7052	fee_transfer	1740	414000000	1	CkpaK1EfgxDSAX8XKfE4PrUnXHyrUxsNjvrgFcP4vx3hnkmkEieeM
7053	fee_transfer	1588	62000000	1	CkpZFSGAMfLs8XpoC8uHKBFQRFoYZzG53vhHYQD8NtYhrFabn2xAP
7058	coinbase	176	720000000000	1	CkpYUzCpNYSU61QqR7BdivL5wc8dTqiiFmaGMaVwYzdUMSGF3RVBX
7059	fee_transfer	176	12000000	1	CkpYn8hSzw8NQHDCWGYAHr9tZ2gj9SMo3tfqWNzaDb2vch8ekvJ2q
7060	fee_transfer	1654	1570000000	1	CkpaGCTfAfDdFfWTwcJPGBb7ivN86Ke1q9iniPjJbosiJ1Ft8FzVq
7062	fee_transfer	526	900000000	1	CkpYyJhzmLYkYFxdSRw9MnTm1cLQvS3iujzMXeDfwtW2X4PzpDjng
7063	fee_transfer	526	710000000	1	CkpYo4raWdKxWMniVa8QhFswVMqZnsxwt3jQf4N8q4rB3k6CZopWV
7064	fee_transfer	1709	584000000	1	CkpYifjmg89nG4ckWpfqPFVG6VSuauMfKiMr6bZZSJvzdXFoXe3X3
7068	fee_transfer	1458	169000000	1	CkpYeeN5djMPpzxnv51Z5LTeJ2rVmB3C3dtN2mt17v34Abss9o5BJ
7069	coinbase	1426	720000000000	1	CkpZP4CA7ejqL6qWWkYws1YVKoQimkgansyRPRQCbHUcNc9EzZjnE
7087	fee_transfer_via_coinbase	1501	398000000000	1	CkpZXViXPGhePyGyLTSkNMqJPaF5h2bMFMYHsA4exuGvujABJHNjF
7088	coinbase	1426	720000000000	1	CkpYa64tAM8K3hrrmc7ZycnLXWWRgikrxmrQy8i6VpRYHmbD1XToG
7093	fee_transfer	1402	62000000	1	CkpZ84HgHF6HhatrHRVvPCGg9VFD5F3RUGknhBhHF8cL9ZNy9BjSo
7098	fee_transfer	1649	2999992	1	CkpZVBatwxZ84YVorjoomK7fjAwevTwyAQqaCmbMaBKPogDX9Sb2R
7110	fee_transfer	1506	112000000	1	CkpYZ5h3ky3FJ3GQ9jettQCY3j2e26rpgjqw5bDW3nk8HbxvZLFi7
7117	fee_transfer	1692	6000000	1	CkpZVT9wvYyuWpBp8SUzha8SDzPv9Nm2gF1cGBj2AhV63FUdUC3hP
7120	fee_transfer	2248	32000000	1	CkpZUKyYimyx7dcXBtuJxn4YWVsGiE4f6oAUSMR2JkAUBLWyABxCX
7123	fee_transfer	1457	207000000	1	CkpZWq3gDyMVdAEjJkGnamoq62ZJ83nxSgT3cwrMzAx7pBABmZ3n8
7126	fee_transfer	1716	207000000	1	CkpaB2yhjs5qWN4SwpfswTwuXC3VfxYnAcKAhY9GAgENVsry5MSuT
7127	fee_transfer	1419	52000000	1	Ckpa65xFVRkTFW5x2qRVXcEzDf62DWpVyxUFyuAPbLtm2SUivwTNU
7131	fee_transfer	411	52000000	1	Ckpa1r46qK7kxGvVqZqhwCAeUZwFKsoVYEVzV1frgRxjnNnJAyxcA
7133	fee_transfer	1476	52000000	1	CkpZTkm2rDqv82AtNQ8qHeW1CStjbgoGyr6J4nep4XSUiR4RP5ffC
7139	fee_transfer	1594	341000000	1	CkpZnRS9WQxnoGQ3caEg367KiVH3idNxwVQqUxDZL9oaaa6YWMUyi
7144	fee_transfer	1419	135000000	1	CkpZReYJQdTk2EPKSYYR4ngCFkBTxzyELLsso5HN9hNym3fS1BJgP
7156	fee_transfer	1698	62000000	1	CkpYaGuA9XQ6WehRkvSJwPweWdtXaXhALZKZrUBwCRgcZML545ryb
7167	fee_transfer	1394	50000000	1	CkpZUvUD9ZakBSRWaasG5Vey3fcwjjP3Rnzjj7euvjCN9XKg2sCjs
7183	fee_transfer	1549	98000000	1	CkpYggkQZSJwdhpbHkxo1u7WaaJWW7efjG7qUeffUjx5Lcdfp1VNG
7190	fee_transfer	1762	2000000	1	CkpZfwF3wsNyx61CTinUqNimQbQ8RmaJYTvwEb5a83VKqAovjjY7Z
7192	fee_transfer	1679	47000000	1	CkpZviXysLVoM7ufFaGCt9WF1GeZBmjFoUax9US51vjHTioY1dPKe
7198	fee_transfer	1649	110000000	1	CkpYiqRSVFfHeY9Bc4TNMryKKMyjYxRRC1B21ZMtH7yKrUJNb4mtp
7201	fee_transfer	1588	35000000	1	CkpZ7zUqpKu1nEhbugVhtPYR1Ay7a4ADoZG13EyyxXBZoz9xj355k
7209	fee_transfer	1560	45000000	1	CkpZtaLAepQ7Dq7FBR1yGxiDPhzBFxDR3BSq2KVXaNAc7PriXrC2e
7217	fee_transfer	2307	13000000	1	CkpZiyRDS9aizn9q7yDJsQkpSYFTMs25gvWiD5nMkDpRhh8KaAa9z
7223	fee_transfer	1539	13000000	1	CkpZcYjyG1YCVP4ERVv4ufVnnbtc3vQXeJAzGCPYm2XBQ2LRT1nxT
7235	fee_transfer	2292	25000000	1	CkpYiTmQZ3nBovp9Y1tNc9dNFVqFJy1sx6id5W8QhZ3RTiVA9Bqc2
6922	fee_transfer	1762	26000000	1	CkpZRbs6wZyxaHpKGqRRfJV3FTepdAbgwHZWc1qzSaUH6panGdWj9
6926	fee_transfer	1709	15000000	1	CkpZbX8jepV44ZJoX9K4nZrhjrSwg5YrZpQyyDH5cmNMJcrqsD17Y
6935	fee_transfer	632	74000000	1	CkpYzW76UCPu9i5sRoeomEqLe9q1tG1BZ1JENnKSDDYRYD3DcNZAE
6939	coinbase	362	720000000000	1	CkpYWaJ6GnEbCE32t7soQ3kwTfKxFGhvuk2NdW85yEj4Wmn2V2wj8
6940	fee_transfer	362	25000000	1	CkpZDsVmGweJDQGfdodDejq8mxXWBGpi3TueXtHedTp4WUt4v38HZ
6945	fee_transfer	369	38000000	1	CkpYwVCReXyEDq2p8qL24Qj4Vt1xWAQy8uQhqmmwW9pPpdjQ3gXNv
6949	fee_transfer	1471	14000000	1	CkpYyBYv6FuMV1wX7nJAUgd5Fizfw7iG8caspiNSTJ5boptvEgXJH
6953	fee_transfer	326	15000000	1	CkpZBv6o4WpxcJi9NWFifvL1ivrwZteQruAQYQbNWzryECUDzYxw5
6955	fee_transfer	1593	1290000000	1	CkpZSCJEXAMQwjVoXBJbp6J27BQmYE1Us7g2DaNGSkHKBdKdFYMud
6956	fee_transfer	1593	200000000	1	CkpYytmh68mvSXoBUkf1cSV5uDhEKuVMnyLTi1HkFb5e379KD5bdw
6958	fee_transfer	1623	122000000	1	CkpZn9f1nmoULbxVR3ZFCRb4jyHRvJwYbvzGgin3LYWMMvBmX4bcG
6961	coinbase	1422	720000000000	1	Ckpa4a1nYFdoifUbo8ucqqi5RQ56FtVgciQBiDX21J5EhuRNnGPR9
6963	fee_transfer	1657	892000000	1	CkpZ36YWjZ347QZGjp32ryS97qeyrbWk9HsbSMBukx9WyNMYqs6Q5
6964	fee_transfer	1657	7000000	1	CkpZDx1dmYrLSFSVMM9nUebwhZP1VgGwu9WFDwivN24pPp3ytAJ73
6971	fee_transfer_via_coinbase	2012	1000000	1	CkpZHBjqGTRPmQ8CpyBLZUB3CKTcCbhbnj2KoEMVeuKnqZcjGzks4
6972	coinbase	1394	1440000000000	1	CkpZH8giPvRQYTTkZbzj93d4sRRfjeg2aT34LeEAeCkaXmaGmYWqE
6973	fee_transfer	1394	84000000	1	Ckpa98Qc4WibAjxWwmCLiB18RSXHCqN8fLYoGZecvQteiCJoDFyRJ
6983	fee_transfer	1992	44000000	1	CkpYfnFRbxZETGPLYVbNpWvyVYVed5gXRiH1CmBNAN6u2CvUj9Uxe
6988	fee_transfer	1506	35000000	1	CkpZzY4cA8XaapaRS49fJhPZjMiQoKXNv1sUTcwgJDvwSim9brY4a
6989	fee_transfer	1602	33000000	1	CkpZG9ZDRg9oGNc3ceQPYnmAz27ykyAvioy1fYEExANsG4VdAgXcr
6994	fee_transfer	1619	23000000	1	Ckpa367ZBr6T5PjQegTAvs55jFVofwZhVmYPgutBvtYNQesVv72FT
6998	fee_transfer	1594	23000000	1	CkpYTSrK2SxSV5xY64W3AUvB1ViA8NpdgySLWviNHdRPGAoFzrV9J
7001	fee_transfer	1680	160000000	1	CkpZm5b7ad99p3UgSNFmoA1JDhnS3Ms2UCKwDzQzEoKsibtGwMzYa
7006	fee_transfer	1762	62000000	1	CkpYTFHmFvuXo2SxVLu77HL6UyhbK9uRdiT4zZZqu5rJfFmmEnYiA
7007	fee_transfer	2041	49000000	1	CkpZfMiyUCP1fqCjmbt4GS5KFR4kawg3yqpKntahSbAVZwyXfMLjR
7015	fee_transfer	1594	111000000	1	CkpaCFk64GVNCAH1FzbzY6NibNY4tuBy8RLzqeLs8ojuKvvB6TLZ8
7029	fee_transfer	1402	47000000	1	CkpZ35XYMUvu7femf3B79dvhFpB2peegVhpyA5EsRQfFohvVbpQxA
7031	fee_transfer	1536	24000000	1	CkpYmQ6L2k7aeDTfqyYrxibhA3hM3ivsA3fgcwM5MXYe8KrSUtuVB
7033	fee_transfer	1762	123000000	1	CkpYr7CpLebHvmBeqo3MiiQJNcDuAsncco8QDZZZvCvPUHarSAJyb
7034	fee_transfer	2112	134000000	1	CkpYQVrWyVsxRZzdVFqdQ1SxMszENH3WQzNaXsxEnut3Pz9csSQVc
7037	fee_transfer	1476	111000000	1	CkpZoEmMF2AYF5tDcXiG3ExRAXm3F6YKVhoy8a95uUapC731Q4kc7
7044	fee_transfer	1671	34000000	1	CkpZnXJUdjED3ZC6A1z5cnzmgQjUbio2HqUwpDWBMB13nt9J95zJc
7054	fee_transfer	1980	22000000	1	CkpZ39vrRnoUwfEijDZZuYNtVRqdaw6UJHnhjuFwbH4tgm8ahgnGw
7057	fee_transfer	1695	23000000	1	CkpZ4XhJJc9Pakkk7ttWW2Dtfm7bRhjwSPyKT1Wn4JKPURUEFEfgS
7061	coinbase	1668	1440000000000	1	CkpZPnSBdwoeU4TAUH5yAXbMxUm8AUtBUPyJwAPqzC4Tr1qFTkMEY
7065	fee_transfer	1615	11000000	1	CkpYR4rJMQdZE8sYRe9wDphy9tcqmqwnwDxmiyw67eEsMD7G1PPpa
7073	fee_transfer	1718	33000000	1	CkpZmd16PQUPR5tvoMgWiSB2nmPdZCLFBXpYW72zhiQxLQ1tfFzKW
7082	fee_transfer	1549	32000000	1	CkpZnk8EFh4Zxmb428wLegjkaRn2FPMkKgq8gSQdBJfhrAQ8HzMSQ
7090	fee_transfer	1426	34000000	1	CkpaBViETKDrHDhxY6FW2L57Y8C135rjKrvhZLCvyXXYmXyyTy2GB
7092	fee_transfer	576	62000000	1	CkpZaeZ2swgQjeTkjzwYur2WWa2F5Eft79bjkdVW373AQQFbD5Gwp
7094	fee_transfer	1740	150000000	1	CkpYasruC2d3VUXoiWRkgu97M766kVj1Z1G6svb4KmMC5MTT3LuRv
7107	fee_transfer	1688	112000000	1	CkpYfTdPRoC2N2oApNtxkpSPKNQUa2eCRT5Fos6ajYBRUTVqpECP8
7109	fee_transfer	2112	112000000	1	CkpZjNhuNtm8UrTus7ptF9yuRywSKfpQ6JZtA8rLEScQmwaBDXwut
7113	coinbase	2313	720000000000	1	CkpZ39z8c8JrkVD5UDyJvAoCTEMtnsvhG63WjwV5rJ44U69AXu82Q
7114	fee_transfer	2313	13000000	1	CkpYbb3NUnU3gTyzyyqf4in75ahtaszzFMgEPU5reANV5gkYdLWCq
7115	fee_transfer	1668	39000000	1	CkpZs56GsaeCXgYyQmuj3yniViREKLKk9UryUtuwjNbQSJTPL9K5L
7116	fee_transfer	1395	6000000	1	CkpZhJ26GpzcddfTeiziZEbBP7n5R3phWZH1MZd4y9wztzBPWombC
7118	fee_transfer	2261	37000000	1	CkpYhKfb6Ub595QFKaiaiNGHFvqkPtLcmxoeumqnUWcTDu8UDHHop
7119	fee_transfer	1708	32000000	1	CkpYkVvgHiitMqdwcKakNWWgUL8cNRegwcrmqciq4yMHHG3L3inQT
7125	fee_transfer	2248	207000000	1	CkpZYcaT5Ck9p1aSHwrSA2PeZtyrYuVUikd5bfx8NMrSKun4tsL2D
7129	fee_transfer	1444	2000000	1	CkpYk96opfmYubdhzcYTn8uGqhPcMcycYu1oKsgBsFcDFG3ktiF4c
7134	fee_transfer	632	52000000	1	Ckpa5cwxDQ1bmjSgNuJjBTetQmNsKXsgLotGGb7JWorVe5Vkaqdmn
7137	fee_transfer	1536	62000000	1	CkpYp6cvG1QgFumjP1eryzhyWWSBrD5K29szMW3cu6DCHccGjHRi6
7138	fee_transfer	1693	341000000	1	CkpYyVoVLBt8gXVxo7iuNji36MtaBAwRv3rMzyCTd3eGGTNa1hF92
7142	fee_transfer	1613	62000000	1	CkpZo8SoYrJ3a4XGJpQkaj8AEoAP1Ub42vFXJVA7YpmnjAYWmhpeB
7143	fee_transfer	1601	135000000	1	CkpYY1RMHrvccNLJ9AbQAukAMybofad9sRE2xdRraddB95T42ViuD
7145	fee_transfer	1555	135000000	1	CkpaHSLGH1WrvTv1QUGo8n5vHQpAH8T6gT3Tovvfq21j9nSBrvimK
7150	fee_transfer	1687	35000000	1	Ckpa1VvDkiNBGnamSq1KFwvD6qtwuZKmUcDE3A84i9r7sJM46EyND
7152	fee_transfer	1599	64000000	1	CkpZxXaDupnrq1AGryjF6MsU11N229aSsAN71s1GpfuFiej3RVb6g
7154	fee_transfer	1458	860000000	1	CkpZxiD8BcGMnm643c13xeH7947Rsw1VuLD7UeTcEstL1ZbeZTPzp
7155	fee_transfer	1458	320000000	1	CkpZtQ41fuSpyTo6gWd8mLpEgKrrrEENfmyqqT3UF5GUYG3CtwFAv
7160	fee_transfer	1723	42000000	1	CkpZ1NfNsB4XBuckBDwokesGEvcc9sGR5gZ6PAPCXsbZmjuabgRYb
7168	fee_transfer	1467	35000000	1	Ckpa7DQu4jXmfJW2nYvCKcAi1aTdH2B2jCuAJ2TX9XirtUm9zqmhs
7169	fee_transfer	1671	112000000	1	CkpZF8M5ejhAKakEfUfLkayfGRrJaWhcVZox5Dj5DuXJkAAttXWmm
7171	fee_transfer	42	26000000	1	CkpYaDyFuy3SCtWEgq7zrcbxWSVGe5SCMX8xbudYe57ja2Sh2Rr5q
7172	fee_transfer	1634	14000000	1	CkpYRzobzKgNSycb9QmSKx2xhQs6N6NZghWGpAXKg9tKv9BirU7c3
7175	fee_transfer	1594	60000000	1	CkpZ6EK4TtY1nu6gh5tKEf8JE5sYA9nWKeL8dTj1Z3Lc2YvLMZMe3
7177	fee_transfer	1540	34000000	1	CkpZGdoDBoFooRbsx7ogjnuCookZ3bPq2SNAAik9dCcAgdZX37Zit
7185	fee_transfer_via_coinbase	1855	100	1	CkpZCTgDzvLQUxTMwYinN2keiumTSX9Xs2EFPqXV3W4NKp5YXSnbw
7186	coinbase	1394	1440000000000	1	CkpYd83ubgTGX7gZSLqsqrnX1HEEe2CfoYKgX3tJm1sW1XC2yya3t
7174	fee_transfer	1619	1000000	1	CkpYU3tDMHx5FUYQkYHhoJkheMMujjacXXGoD138uQVaPjYYDAoRx
7176	fee_transfer	1610	24000000	1	CkpYxjM9zMeymhYzsxVxJcptEUQ5iGuFtHcN6TyjSbdC1uMgp3vdF
7179	fee_transfer	1508	1260000000	1	CkpZfZtseEJiTsSycX29XZFgg49C2ZMrbeSKqvGp7MCDhusXosB66
7180	fee_transfer	1508	9000000	1	CkpZdrDDtfYHmnKA2BPReLrqA159ydFL1BW59A7HirzXaeWk6UWWX
7184	fee_transfer	1714	37000000	1	CkpZHpp7JESzZPmk5YvhXQtTvDFSSYs5m31G1KUH8XGPYWnLqJBMA
7191	fee_transfer	1588	26000000	1	CkpYrtgUhmXTTcjRRNyast6DzaW6HmYemgVsm9xvCbjfQucEMgF7u
7194	fee_transfer	1740	530000000	1	CkpZvRGK8WtuKeCBkXMuMHnwU7mWFydjiwx9ihJAyqUa5hM3BSt82
7195	fee_transfer	1740	63000000	1	CkpYczd6XRj5LUV2ZubaMcPbw935WUUx3iF42YFZjcap1hCxFHxL6
7196	fee_transfer	1440	37000000	1	CkpZDuRWe1s3LkTS1nR264coJ7o8tHR4obj2vL7Q44u4bP1VD1B3j
7204	fee_transfer	1594	27000000	1	CkpZxcGiN3WycCaJCvBhGaRUyNc7WPpqnUgYdayRvKq3EhGL8xEws
7210	fee_transfer	1560	34000000	1	CkpYZP1wesuQMPzYHxPQMbFnZo6no25jAyemHMDEx2ZrBUfWmsWb9
7211	fee_transfer	1738	11000000	1	CkpZmiYnUBJZF7uRoUufsfi4ArgqCHL2pMeqHFijreTHLJ7JmG3eL
7212	fee_transfer	1522	45000000	1	CkpZg4rQ8HKmoSskGXq1EK7PKUpM2SUnDpaR9Auzq4JfDK2brCAbN
7213	coinbase	1522	720000000000	1	CkpYs8qA1iG7gJVguJkVeB4VzwyMHdFwHQdToeJ4P9o5jawPPvLxY
7214	fee_transfer	1522	6999200	1	CkpZcbxY987s52gszUiri51wr4bFWJr64YQXj3Dpm37zRVZF3ugWy
7215	fee_transfer	1855	800	1	CkpZ51Vzvtb24CnbH6sVYSqyMwpgCpszyEbPbfpZrbTSEZJNQ8kA6
7216	fee_transfer	1695	24000000	1	CkpaKXQhJtMnBwbLVfPHpaFyb4fjfn3aqZ5fmPSdL4FVa6hDySJ1W
7218	coinbase	1467	1440000000000	1	CkpZaeXbd5BHRU2EthLXwx4gvSZpYS8zMbFEZLdqfHqtEYEzKEZR7
7230	fee_transfer	1680	3000000	1	Ckpa1XKNVnzf3eEL4F8KhbQhvDpxZHbibLVg9K7zz2zUMxkCYkoU9
7243	fee_transfer	1622	14000000	1	CkpZQPmGeYgokV9vQFdRng4c5HLMxxJwJtRagVKFvE1QM9dFTQrmK
7245	fee_transfer	1716	111000000	1	CkpYbbmLFNtzUfrM2v3fo3CbFXb5oJPxnJfjah1ZS5m1nLXSUkCAj
7247	fee_transfer	1716	38000000	1	Ckpa3KjbrAKFXPchxzNDuSgJu5G5kNb4ZCcKs2YT8ktuAieXvhb53
7259	coinbase	1394	1440000000000	1	CkpZzoUWjk5cahpcp6UiLL25kFFKik79AH6T3YkyHamsHkfi2R3Sw
7266	fee_transfer	1657	25000000	1	CkpYvvGF6miTDeFQqic96Zr3vp4vZQn1F7SRAJMbip22eXqBpvfJ2
7267	fee_transfer	1747	130000000	1	CkpaL9e3PUsfRa9Gnbyhh65phB7SNVeHguDym8yGFMZ9u1Zh24ABV
7268	fee_transfer	1747	267000000	1	CkpYbD4QTMzSx9zfAm9StfeVBehh5Ef8Xf6ie7HxtW1yveDKEciAe
7293	fee_transfer	1643	123000000	1	CkpZN4ogvPmGyhgQUoHix5ymz9zzxpxYMpto9FD88cneFroBuBXAz
7294	fee_transfer	641	1000000	1	CkpZEd3JbXfis8gpBX3B1MsAig7VmaDNJJi5FbRyCDqGxUvviETGv
7303	fee_transfer	1602	115000000	1	CkpYzGhFscD3SeUUAe8NHQaQwmtu3xneE7VHj6J8hykSQxC1LLTgH
7305	fee_transfer	1724	115000000	1	CkpaBGkQ1iYAGRo5CPDomqHwKQs53FLftGb4puzJb13CuPgnt6inZ
7316	fee_transfer	1818	24000000	1	CkpYZ7s8wV4ab5q6D7KJ9c3ye9QZ8GZNBwEDxgtehGSdwa349KHoo
7322	fee_transfer	1741	11000000	1	CkpYQn7hJTLXpwZAxBJpkLqMSACq7Gs4BigAQ7a5URvGWPSV6WZPa
7328	fee_transfer	1602	36000000	1	CkpZakyGZiidX1w5fndcj9JUeeSNAFM4bDAtJ9YuC8m9UagFmy8yd
7333	fee_transfer_via_coinbase	1791	10000	1	CkpZsjWRzocLR7TL2XASY8qknGHJwFNPFgziCuDJgWxKBXTJUZerW
7334	coinbase	1613	720000000000	1	CkpZf1aQuP5zE1p8Q3s2i65R2fpy1PAFCUUUh4u45TtpDf3CMu8XE
7341	fee_transfer	1440	48000000	1	CkpaLedWr2dfWL2PCNCy8fH3fUP3ZRqPtfmYqSnPzPsjcq5J1Zog8
7343	fee_transfer	2306	24000000	1	CkpYwExH3wPYSSntu8LbvzxpdXyP1mA7YDfsMWtV57H2p6QRTxgiW
7345	fee_transfer	1643	46000000	1	CkpZA4iCvs2rHbPfnbQjsbXEqBkiCSQfGVtFkPbaHYfjFCagcdbMv
7349	fee_transfer	1555	690000000	1	CkpZJmYJo1ueQ55jc6oazKppeMwJsubb5aMkXNP8JMBFBsZDA5o4P
7350	fee_transfer	1555	25999992	1	Ckpa8DfCWhrRANyaGFpBrZztm99kVLxSnP2b4zhbnFbE58YDkDJAB
7354	fee_transfer	1520	10	1	CkpZajBrum3vSYWmJ7bgcdCq6FHqdfwHzARbnBtR9MyuxrB4g7uLz
7355	fee_transfer	1746	3999989	1	CkpZ1ef8uRJCxfUQ6qcMFx5iRgpX6SdjMDWxXoJ7z4m6u8VrzUde1
7358	fee_transfer	338	11000000	1	CkpZvXXoek9EsxbRAChpyqujuaCiUNemJ2MnF3kggoLDTWLF8Ak9k
7365	fee_transfer	1509	1999950	1	CkpYxrNLczHe5edUzuegKArxpgDqxLqjdTjWrUVaJXXkL2x8w3kQQ
7367	fee_transfer	497	36000000	1	CkpYyZrQAHYW55ecwS668iWqnB47JPjAahz3rFqe2UQHhMy74kkao
7371	fee_transfer	1419	4000000	1	CkpYYurZ7tGx471Xr6ZZdNLHgCNe1LVKGD2x6NsVoB36ELCyPFkY9
7376	coinbase	685	720000000000	1	CkpYXq2jpoobZDjurrYUrLtkQ2DS8eSGN7jvwaZkcbreyhKZv31sx
7377	fee_transfer	685	12000000	1	CkpZ1S562sKWwZmEcPwsAwNsqRfZsWrL6um9Z6qRftJ49WaYAjz3t
7381	fee_transfer	1601	59000000	1	CkpYYF84Zjtjpd2SGQPQq2oLrZXjRVahRjsrrTrEUKAWdG4sesByh
7384	fee_transfer	2148	25000000	1	CkpYsM9xDDiHyRkTpxdL9Ty3mxfCQ6u11bH5eZZxVGqBZ7eUenWvh
7388	fee_transfer	1706	24000000	1	CkpZ6mN1yE4PoYRZA29jXXyeSWsn8hNPgMpm6LPwkT7fSAuPMxKLS
7393	fee_transfer	2039	21000000	1	CkpYYq19MnHj5QBk7Pn6Snm1aoiF1Wxn3ZzTRd8ACKV1Gnqh9oT5z
7395	fee_transfer	564	34000000	1	CkpZZF4tYrBxhxQFkAks9PTZZv235t7DwD3mUc5TTqrPQ1TbsZqML
7397	fee_transfer	1762	43000000	1	CkpZaqMiteQK9uEd15pazfZi5ZEzqHaXpgq2sWgzYw5ZfWBuc7ffh
7398	coinbase	1762	720000000000	1	CkpZkLzvStugF8mVyLXsXdpbKspFhawS37TtN2ocer4KnbJZKDkwh
7401	fee_transfer	1801	2000000	1	CkpZ7qkn56aTkAoja6MpaEwjKFzcxXs2KQrgrkzzkvReGvmx3BhgP
7404	fee_transfer	1521	22000000	1	CkpYwnWtGJEy7LjoQ7pyHYgUFFdMhqgjHUk6JRguAGsFaVU19Q89z
7405	fee_transfer	1573	21000000	1	CkpZ1NtVmh9Esaj59AqiTbKVmjvyPeZZwGN3z4BjVXHHLXz6FoXh7
7407	fee_transfer	1709	33000000	1	Ckpa4gnrGkta3vsjRjZSMNT84wwbYWeEi6dBkVvpF6SWjz7ddxhJV
7408	fee_transfer	1423	850000000	1	CkpZrGtyPCn8CdzSoQsodcqPi7vggc1BX4vDvMy6iaRUR9wc1C5D5
7409	fee_transfer	1423	400000000	1	CkpYoT48E523Z1QQsPhixZJw5Fa63krETDrGNARumfAyjr4cYpVfw
7410	fee_transfer	1671	640000000	1	CkpZUczCFNGg6uhJGpkM5pxAWQ6rxmz487LPzv6Wvyqv1H9LSNXuH
7411	fee_transfer	1671	610000000	1	CkpZDYcRnw96Xjuv9hBCHFLEt5DJTzaw9mkgMmKY23xfYQRh5hG68
7414	fee_transfer	1685	65000000	1	CkpZMYq2DeESFGGrJZnzZszkJnGM6HdYPsvLFWUZCEnMskKzHvzug
7417	fee_transfer	1749	91000000	1	CkpZzotmrqpJMAcmkfNBEin4LFHfsQ8wr8E5DSGvAGLKZGXNoJH4q
7421	fee_transfer	1564	123000000	1	CkpYyT3WkTd9djGrGcS2Z13pfxaK2H9YMJHVdw4SmrtUHN6H5FWKC
7422	fee_transfer	2300	54000000	1	CkpZX3gtKFkbH9MJVvjZsGJHTqNW3G4Gf95sW8LWLYPu5ZSQHNJLP
7426	fee_transfer	2329	22000000	1	Ckpa3Rr7xhfLUYX5LgyQRCZBrh3n3VeVqxXyj7NyAyAxVK1EgrJ1V
7427	fee_transfer	610	10000000	1	CkpYxFJu3LXwsytYVhfvF4CX9V5nBo3Qb82MhpU6BmAmdfiM6Bf83
7428	fee_transfer	610	1000000	1	CkpYb6Pgn3ac977WsAcqcMCzP7sWQaZwmGhipQZD1vp1jh6xvQ6mX
7187	fee_transfer	1855	400	1	CkpaJXjMRRdhpuseqXv6i8wjsR88EqqwjNBTEsxFHRAkVAKTjEmNn
7188	fee_transfer	1394	940300	1	CkpZG87agqQSUn9HA2hVu5QuN9tvmC1G3WQ3zcEwnszvxDGFjA4bc
7189	fee_transfer	1514	69300	1	CkpYw8igrXk7CR24F6fAzKmLTZpEbJKG4ezLh7NPFePn4tujrnZmB
7197	fee_transfer	2306	37000000	1	CkpZjrqZJMuxzpazEURM5tGYG6Gq8vaWzARJLj9J28UBbYAXGnFea
7199	fee_transfer	1649	97000000	1	CkpYTt5813y1CE2Hpys2ByrC2aGe6igYz5GRbSyaMXczV78m5q5nu
7202	fee_transfer	1703	34000000	1	CkpZewA8eCQwPmm4j4whs5qxWqwmn2fYhQZSrRzFwDaeznfWw2jXL
7205	coinbase	1623	720000000000	1	CkpZoHVibiY6BdWBG7TS4k8tjJqPtkJ6LpnU92wcbLTMm2GuGcCJU
7206	fee_transfer	1855	1200	1	CkpZJkdisSbDUR9dChGk6ZvQT4BA4rRqWDLzQ82UDk3pZBSnnX9F1
7207	fee_transfer	1623	998800	1	CkpYwVn4pXP4QUWNYuijw8DjDd9MgVRWuPEsdZbS141vLxofTq1kG
7208	fee_transfer	1439	45000000	1	CkpZyGtnd4JRs9yVjUbDxyvmNj7T38mALSzMuTahMVosL8nzc4m2G
7221	fee_transfer	58	49000000	1	CkpaG5P2F2VftC7eEfMiFfgqNjS2dstoUNSQHj1E1JzhXH9jZxGsB
7227	fee_transfer	1474	172000000	1	CkpYS3voWY5XdZ9w6zt8fmqnm393GRcC2dpZLxZPQfmsbTYe9o1ak
7231	fee_transfer	641	909999997	1	CkpZye4yRgm56qEbfhVs8PZxhbNd1MATKWdroYmcRpSD3UFEArqN3
7232	fee_transfer	1520	3	1	CkpZZpocmFtQot49naKmEGHff4PqZeLQdVpVsKKsJGpiVs9cjMtox
7233	fee_transfer	641	419999984	1	CkpZA45a2UyAFbSZpbKceHk8ES5aeArNc7euPdr9Ny39gGxHeKBho
7234	fee_transfer	2275	6	1	CkpYk22mAyQEQiTLsNkgcBccXTBno327DoLuG3yc7xSqKTa35iFxY
7241	fee_transfer	1622	4000000	1	CkpaKfsHKRJzU3qRM3opMZ6fykjxFwHoig21vNYTGyU4XXNgBn7bp
7244	fee_transfer	1271	25000000	1	CkpZ32twuhMC6sUodykJzB1ieStutAURkM5pqRyw22CZXHJt6khag
7246	fee_transfer	2248	38000000	1	CkpYS2gF8MHMgwYiZ8rgsGu93dMQcBSpyCyNUEzj9YfeA5eN9AgNA
7248	fee_transfer	1714	8000000	1	CkpYohcwZRF1UQHAi9WToFHwYyMzzwPsQspiGa7wwsk17nsvMeY9B
7251	fee_transfer	1670	3000000	1	CkpYT2HfuiZs9nZvc7KV7pybhEcD8z1EqjN86HcqKuNdQ7Ng8ShS5
7258	fee_transfer	1657	14000000	1	CkpYUgbw7TuT3kbeCX4LntTLAxYzHMgUHrtdYBAzCFK2fcfxm71cC
7264	fee_transfer	1471	37000000	1	CkpZN9mdGxNa9JnEvMLS1Zac29GKSohC3Sys79ssDNeMfhRQ7x2Mj
7269	fee_transfer	2292	24000000	1	CkpZK3nwnQXHDwFpkf9o1pmmeXvj6kvGZxUJHtELBsN5sK3Q8nCuU
7271	fee_transfer	1509	128000000	1	CkpZzWzLUiJouyDAYa7puX5QE4zmBCdcXMr7VtJmEpshqinbwT63D
7272	fee_transfer	1464	12000000	1	Ckpa66dXKSnsWb3ZC5oz5AAyrQcyVYmhDubSvarYvA3Ux9MBqyGXs
7283	fee_transfer	1610	14000000	1	CkpYevXpzkGdKW3ePZ2cxxKpEdhzPeb4e3q8nrF8vpLBEg7DyiE1u
7284	fee_transfer	1594	14000000	1	CkpYeHveyC9BXi7a3FXSzx6vBsVhzmwsrthw1VEknUoMykRTaXxqB
7286	fee_transfer	1698	112000000	1	CkpZEYwzqwnPfA9BkZd942TGeL59TenSh1zrhipLxan4EYrp6roR4
7295	fee_transfer	1685	112000000	1	CkpYtnEm6SXYdfHXUqonv9coLAfMDXyC2VtJJWfxQe9wfyLXXXPNr
7296	fee_transfer	1807	2	1	Ckpa8tHV7vwWJGKsPEcuzf6y2pngp3NdDueYYLMgXYKjD6WBEpuG5
7297	fee_transfer	1419	999998	1	CkpYwxT5BhxnfciLa6uowVj7ErN7tNiJmCMY7FfkrKqHRfQf6LEix
7298	fee_transfer	1768	112000000	1	CkpZBQN8p14npNcUpjrNYrQCwdgvhZVyqtiPVpuyVuhVixQbG2RpL
7299	fee_transfer	1688	113000000	1	CkpaCH8wewo64N9FpnpsWSBWXXubAGwcbZBTzknERXabSZtmdvGRm
7309	fee_transfer	1768	202000000	1	CkpYauffA3e9xR3tmCGnh3sjBhZYPduzf83ytc9hMxvmhgMToxFXa
7311	coinbase	2256	720000000000	1	CkpZim83gCrVYgCEwYaBTyCsrvrbUeE2RwAC6Kd69gNkFjZbk9dEL
7312	fee_transfer	2256	25000000	1	CkpZXr6UmFCtqarg3DCT1jMPnzbJT3fVAnV4p6NzrciC3Vh7tm7XM
7318	fee_transfer	1608	3000000	1	CkpZQGVHCc6gdUZBQv9TxCGStsFo25utdKy4scG2ZkhgSAofs14Mv
7321	fee_transfer	484	36000000	1	CkpZPAGhMR5xoLScqrGrxar9ypzgg9S2ubnjGrCvAD9JenFWYxxbt
7323	fee_transfer	1555	283000000	1	CkpYuWzWtCQ4F1xjFDooxpnvHJSb4inycYUoVq2d2romuvvgqRoSS
7324	fee_transfer	1555	29000000	1	CkpZSEVFUPkVtbLS1Ldzyb8N2sPo2361jLxh2Z1BeEfpXVqPQjWiL
7326	fee_transfer	1546	760000000	1	CkpYgzLN5bZtFv8pJs7EU9HgHCVb7jhvcxET15jt9bz3viiPBtWyw
7327	fee_transfer	1546	31000000	1	CkpZooDRybGkFzt2dxC57fdfyipSVq5xxdKvUr5iE538FxGEEzZor
7329	fee_transfer	662	36000000	1	CkpZHZxqUGwA1J78rWZgRMiazS2mz5hXMxVTjJmbhDnvi96efi7er
7330	fee_transfer	1671	24000000	1	CkpZam4NreQZNgdEfJGjYKhAKJXtja6k8ouScop8Q2crw6rEcGiVB
7336	fee_transfer	2039	30000000	1	CkpZUVQvXWnXPLysti2ju3g9TydiPSJ91k4RYzYMqfarsveStingf
7337	fee_transfer	2039	6000000	1	CkpYdVhnsjj5T51gBByKXQYePZFYdPhScwVLqVmLAamojEnUuvZJW
7338	fee_transfer	2096	10000	1	CkpZ5iQKHfB7oXoSKfExkvPokAzg4uv9PtLNKApXFhUZwcUwxs6fs
7339	fee_transfer	1684	5990000	1	Ckpa8z2jAyUadtHakSxB99aJyjScMkbGa4FWH8wiMx9CxEFx1H6rD
7347	fee_transfer	1764	48000000	1	CkpZ7nDhWc5qbQ3Pimi3Kqgj9jjp6ZRSschp5oWBxYejErvDHdpVL
7348	fee_transfer	1614	12000000	1	CkpYQDtku2FUrmBcELmFPt9mpFLS4TdC6hjCck7n6P1GYtvp2vPts
7351	fee_transfer	2292	20000000	1	CkpZqWcD2hcbx8y8nGe1cDTx4rA6fn4yaspF3sDLBe8bMU91SMncx
7352	fee_transfer	2292	4000000	1	CkpYaCRR98isT3wyFJvYtojokFkwbiwsSbdhcpdcLExceHXFdfJPY
7359	fee_transfer	338	12000000	1	CkpZZyqM3t7gHcxDKgybX8EqeUGmo5HoYrMLsYZiv4h2zGAuQnqww
7364	coinbase	1740	1440000000000	1	CkpZ1TYvczppkYGmDrtijMfCghVpEKvU8JLu3fHWJsd1gByPaSMwy
7369	fee_transfer	2041	36000000	1	CkpYm1h3pS2CDQsHDHcBeTPW2WrQD6etuFS2MQKdmAZPWdmA6Mbzk
7374	fee_transfer	2106	10000000	1	CkpZjb9BsAv51cS1Cbq31CStHGpjxWcKhHWua9ZWVSSYJfBqcfJod
7375	fee_transfer	2106	2000000	1	CkpZX6QJMv5D4sbHxjo6bPEg4EpwPT9U346WEX9FxJwMPFDVFhYaj
7379	fee_transfer	610	24000000	1	CkpZxALpdBPv5R5qheh5LnAfU9NW9BQ42LZYxi85riZjdB2RK1ZUp
7383	fee_transfer	1598	48000000	1	CkpZW3pHUuJMt2LqNGatyST5iYTXiuAMtCq7xTCDDurwTmL2hPgM5
7399	fee_transfer	1801	43000000	1	CkpYq2jU6MsLZS7BGWiFgR6U9ykDmvxrwWzVLCjWNYCh72AWCZUHR
7403	fee_transfer	1521	32000000	1	CkpZyLTiLYTwKf5ZZJt7PSGdqrzaivhGxxaWCjw6WFc2VwbJzTJYU
7418	fee_transfer	58	51000000	1	CkpaDKgBZwVra6ppvCkgFje5TBLdayR6ptEfFCPq6KRmVrWg7xtw9
7420	fee_transfer	1509	101000000	1	CkpYh7pCw2dJULciTy5GmeSnFxrb2pZLGxmTyBX4svajHwGbzuy9T
7425	fee_transfer	369	44000000	1	CkpZFmDbBa4cmpPUQbzc6ndWjeLG8ctdwtaBU4vYdek6MKVvbrWBt
7435	fee_transfer	1506	481000000	1	CkpZqzt3DNnBZhSJVs8N3JGMYnwCCjQVamb9Q8UmaQ64HbHHbkrX5
7442	fee_transfer	1593	14000000	1	CkpYmJjLzHabNr6mgJd28zJb83FENPBtn12ju8MKCEZgQGPdxpAN8
7446	fee_transfer	2261	50000000	1	CkpYikSf9DpMBzErGqwyu5VyLx3uCSgCKrGnbDbZ4oBwbLCE1M3Cf
7447	fee_transfer	1455	14000000	1	CkpZKbRuu2HFpLmtL2V8yZTLAUWQAW1DR758dyJNTksUv9dwREW2E
7451	fee_transfer	58	14000000	1	CkpYXwH4kmiN5tDVj2W6kKqLtZcw2xwzzHTfg3NboNHGA7Tqx22w7
7226	fee_transfer	610	12000000	1	CkpZiceJLyhf28LgQfBcSQCJgXDTNkL8ehfewe6yD7D8NHyy9bpBt
7228	fee_transfer	42	37000000	1	CkpZ5tMqTUzdWMnQxhG53m5QPLzqrwaKbQ23CgYLy6tj7RfpRKGnK
7229	fee_transfer	1474	19000000	1	CkpZwRxPtSiegVQPr9BPo86z69p7rxS7sruG61LZN3Tf1aKYUYDS4
7236	fee_transfer	1596	2	1	CkpZeK3Yc4h7Fp7byaJcZEohM2Q8fiNy7W5DEyQrVVjkd17UL2i4d
7242	fee_transfer	1439	14000000	1	CkpZ4o5NTj47D9SDEbukfeZME9TsS4kAMtY7gcZqSZ366mtc8ucRs
7249	fee_transfer	1670	500003	1	CkpYXUNfQxPzcpKDZnXWEf9gb2eDXzfddErqYaxqZSfQeTvR1P3UF
7250	fee_transfer	697	499999	1	CkpZyEL2HANa7hp43yHpchuDD1NToFm4sPa4gkU8gx2Af3a1t7FCa
7253	fee_transfer	1681	112000000	1	CkpYxzwRpgGSHCFQKKbszrWeFMYAu95Niv9KepG8qXNQYSb3SnqB8
7255	fee_transfer	1715	15000000	1	CkpZSAuXNarARJ5xpM4NdUFcZ1MhhKUSPbWt2XHGQpr2oA64mUAft
7256	fee_transfer	1992	14000000	1	CkpZWu9SKVGYqzDVYCLnZsYzQWgQwHSPgRmUv4F2ZLkQHwzmXqiVf
7257	fee_transfer	1623	14000000	1	CkpZrCFaCSu6Mz8ZMSkbiQV2s1Z8F4GQTMwuGs2fgk9fLdXgrb3B1
7260	coinbase	1693	720000000000	1	CkpaAgp99miux28A6bCZUs1U3cTzdH26TQvZHcZqSZUa6AczTH5ho
7261	fee_transfer	1637	591000000	1	CkpYfPsugoadm9FWwXfQkEcEKY8PWE83EHJhEVQe9eSNiUrZQRdcE
7263	fee_transfer	1700	25000000	1	CkpZd6HmzX8vVeEvUVChAF1TyGMbdNqwncn18k5ZCHKCLEeiV7e1r
7279	fee_transfer	1807	38	1	CkpZh5XK2acic1xmGdeF8fgUmuDgUdeBUXYsZ4E6raTvVxz15xhMk
7280	fee_transfer	1594	13999873	1	CkpaFvWXDmPsW7pnRLD69Gp7GHEjVRagZkh9nxcair96Vx8iZ9eRj
7281	fee_transfer	1571	88	1	Ckpa4dJNRdjVnjvRFNbbEFomFq6eDqeT9XEeeEiUpqbBRDu19X6rk
7282	fee_transfer	1599	14000000	1	CkpZTiMDqfWWsUFCbbV4Q3dAka2gaStiBvgm4cotBVSHqQSh3uND6
7287	fee_transfer	1692	112000000	1	CkpZPRDU2wXYykbL8JuNZj3eSHk78fWE2WC1Kv2tbJfNiKrnQ21ZD
7289	fee_transfer	2148	123000000	1	CkpZE3S1CmkMEuPZJ7vuC8zWzHdJJ2kRMKu2LcTUGWnbEZChGoFB7
7290	fee_transfer	2148	125000000	1	CkpZVW6KaJYQWKr9UV2pii1pPRF6odyULh7UKDyBLpiMeiwjby4R8
7292	fee_transfer	1980	123000000	1	CkpZpW2BhRkFPsGb3SjC6tjRE49xZWhZwaYdyBVZ8yyhbJDweFpPx
7300	fee_transfer	1637	849010000	1	CkpYVZCHE8XGqdw56y522tx4cUvSLmrjhPmVmZLyzps2iQ6C3UL3K
7301	fee_transfer	1733	12000000	1	CkpZj7SYK8YieRppja8VVxcRPh7LTwL2nV4YsjJSgyzZp9ZaAo4LF
7308	fee_transfer	621	13000000	1	CkpZE4JmiG9hQcVDimAkLu86kbKy1pWX3o7fysHBp6jM6hUjkFrzz
7310	fee_transfer	1596	25000000	1	CkpYt2r8NWBVLfJD6SY2trPnw1YnHDgLchJmNRBkVVPscq5nonCUA
7313	fee_transfer	1739	34000000	1	CkpZKkTSwmkqncaur2hYiCL9qhAh4E5ibCjdiAsSsvWVEDhfxeAtA
7314	fee_transfer	2112	14000000	1	CkpYqYVngVRcyV1UvxR4en1oUtpVSg7jkAh7QuEftnN1V3YTjwaHA
7315	fee_transfer	1419	103000000	1	CkpZHshyru8VNbviekLnsRxEk5QhfhieM2aqD9a6xkgboJJVKkEqQ
7325	fee_transfer	1564	24000000	1	CkpYbuyodZ5obKFhwNxPRRF9jNwoLYvwtQrhQyqogCbLG4vXh59Gs
7331	fee_transfer_via_coinbase	2275	9800000	1	CkpZ3kde998w5DnfrY5iYt6LDJrgpMtVpbEBhei54RJkabPjERZNZ
7332	coinbase	1613	720000000000	1	CkpZFxscEPMEuHGYDmST3WRz4NAQitTePgvQ8Qvyq9xhpm9AFafdU
7340	fee_transfer	1440	102000000	1	CkpZxTUWnLpXnf3agHxCWbajcVZYbHXLYtQvtoJuiJD5NYjkZDAMQ
7346	fee_transfer	162	48000000	1	Ckpa8KWov1zGY483SuFxVJmFEuifWcXnCULoQQJXEotDKjUyW7jBk
7357	fee_transfer	1622	24000000	1	CkpaA51ks6xq1svTUMZRMuZ2dBXTBT6C2BSNic1Nqh7YBF5CXWu6A
7361	fee_transfer	1686	33000000	1	CkpZqCvD6jmhdENW1Fuy2F3YMoM8tu7YLsc34yPRi9P3GcYi5S3Nd
7363	fee_transfer	1610	37000000	1	Ckpa2RvNNY6wX3f5mDjgfHHed7dC6wcFYSooZVLZmgM3rAtxqVpE7
7368	fee_transfer	1520	24000000	1	Ckpa1Dr46NrYe6MAC5MipCv27k9WZ3T9DxBshLbyyv6m8c22WrUzd
7370	fee_transfer	369	14000000	1	CkpZoxtZHMNHK9DgGzoK9ytPvoZNPHt5vq96qq8BHDiicuRm43KXw
7378	fee_transfer	1506	5000000	1	CkpZgjcRn1CR3L1jEctTvm585L9Dx1zmvYFQnUBL2PqYyZzYKEcUj
7382	fee_transfer	632	48000000	1	CkpYt53BcEXsrriGHw7CGgJYb7o9cmeHA5nFXg5AXTS8cb9RcgrS3
7385	fee_transfer	1513	8000000	1	CkpYXPnvuA9jkyKNG5wa1qMWAoXBfKoftDShLRNxJLasTzjRDrGua
7386	fee_transfer	171	35000000	1	CkpZUys9J9tJuBRFd15jxQ3CyYuoqd6yN1TGGF3cn8VmMdiUi6AmA
7389	fee_transfer	1657	33000000	1	CkpaJ27o7aiEV1HqgJuavcXWUeCf6LGRkHE4UWSsAdExVdeHvYjeG
7390	coinbase	1395	720000000000	1	CkpYtzkyTYuGH7RLQLVibpVsXzAKERoHTk3UBS5ok9DyUHdzmcJTV
7391	fee_transfer	1395	37600000	1	CkpZHGf49PpuLkDsDTTupkq5JGyGSGpmsLmhkdb2AgqpUmUjMRyHK
7392	fee_transfer	416	18400000	1	CkpZUhVoigyEnP7XHc6Y6DFNt3Z6rdP7dd3nB3isLsD8yax9tNidW
7394	fee_transfer	1708	21000000	1	CkpaHp8fzAGGkV5t5PHiS2ERn2DJmEPzLc6ULC3xDxVbwxehEkCrJ
7396	fee_transfer	1715	22000000	1	CkpZdGYoYD1oQRyYyJPhZcUBDnHYm6n44HDE3purNvFgSfkbPwdsA
7402	fee_transfer	633	32000000	1	CkpaEknW9rQTgDn4TVwz6bMBQEvts5nz4t5iSLktkjoLizpaXLdJp
7415	fee_transfer	1719	91000000	1	CkpYRksqYi7WwfPqnmCdWAsYU4x2vEgtE7wAhrJupU57ps6wg7mde
7416	fee_transfer	1439	91000000	1	CkpYWpNzaSCMYWNNpVkP55AmpxDi8tJx1wwMokxPSX1J6gVZDefuK
7419	fee_transfer	58	427000000	1	CkpZhZCbVhjXSg316fmJHNQfooGRJkrx1j1fvzNapVAkHRTPep35g
7424	fee_transfer	1643	42000000	1	CkpZE9ucY5FQvRMNVMoSgNRhcviXnRQqRdXp9Ht2bmsiPnweF8DNx
7431	fee_transfer	1675	920000000	1	CkpYWqPhykojrT6pM77qm2CMEr8UV4VCVKi41qyAfaRjGYxLDqk18
7432	fee_transfer	1675	159000000	1	CkpYvNnLmWwuAgyLipM9KFfhPSuZLwdWoqMu1WqeJYoBNAd6c6p4k
7436	fee_transfer	1991	22000000	1	CkpZjZ19S9P9udmeSCga94CJnFuY2CwGVtHsAwFrXFwfBJMiMJbg5
7440	fee_transfer	1489	10975000	1	CkpYXrJpcZCT2dmv848CmYC9GLZEuyEgXUVj7oUEq84Yak2g6s8v9
7443	fee_transfer	45	120	1	CkpYoJgwwVMzCST8JgTUZeJ14JekeiJeKvkBNB5sAgDF91D2ShD7i
7444	fee_transfer	2261	49974016	1	CkpZX7FdKJnJ6uYtt9FTbu6Wf1J7b6XnacXsmAmxjpk6cLxFu3dcd
7445	fee_transfer	1571	864	1	CkpaHcJhvwNgez2WLPD5FQ1sEm7DY3H6keJLawjrkK7XBvA6DtkJS
7449	fee_transfer	1701	1170000000	1	CkpYybdsTtNEdVLRasvHgRiRE6uRdnJUdNvbp9V2ZpWrkLduGq1YB
7450	fee_transfer	1701	80000000	1	CkpYr59VU1MBjia5ocLeW8tXrvWYjFjgfyBWy9MW8vkgrtpJo5uH5
7455	fee_transfer	1701	819000000	1	CkpZMUNcXLPqnfzaTYKMiBcrYgj9r3ifvL7148QQTnmpeF8wBBrGU
7456	fee_transfer	1701	8000000	1	CkpYrH83aHMYHePW5TD3QiQRhyr7VNJZgJs34piKFsbEnqzpf1A6Q
7468	fee_transfer	1739	760000000	1	CkpZXKNK7W8Fwy41UrheqjxyhtpC47CDXDDDPRu7tZVJsGbSgft6f
7469	fee_transfer	1739	490000000	1	CkpZw4uwDcaqmsRptgBbYYp3PaztNaPv7AEU8ctbdKAYkTqXTCF7c
7471	fee_transfer	149	34000000	1	CkpaLaq4sE34gobHMt9RZ7T1p3Nuh2XKXgNuTx7wu8YmWdUDnfLvH
7472	fee_transfer	1394	47000000	1	CkpaC4xCG8KYWcWKuo4sp1j5AeWHKoaG791QMBr1heV2D3oSRPY4E
7481	fee_transfer	42	1000000	1	CkpYXbu1y4wmYsF4Re8CDJdPvtTmSeuaZ4CFQ7wtkmVsBqWVuwGLD
7237	fee_transfer_via_coinbase	697	499999	1	CkpZyEL2HANa7hp43yHpchuDD1NToFm4sPa4gkU8gx2Af3a1t7FCa
7238	coinbase	1588	720000000000	1	Ckpa52ToCZM82AwXPDuHniHvFMMdd6NDpBdsupc4iTQSyF15GUzvn
7239	fee_transfer	1588	500015	1	CkpZzAXZiZijPFdmmAzCcDtvujUxd2rd1fphJX6tQmVjfdU4cyv9p
7240	fee_transfer	697	3499993	1	CkpaJeSh7RQFHguLE9KFZW4BXoXdEif3bKQJ7d5PgqMURYEpRdhHY
7252	coinbase	1709	1440000000000	1	CkpaEZnNeaNXDzJe3u5fwgdAsL4CSdxvqWbXkkwCESLXgTEnG3Xdx
7254	fee_transfer	470	704000000	1	CkpZKptRf3Nij5wHFZJmGeh7yMaJ3CFa7dd5EELbDFfv8BjmCDZSG
7262	fee_transfer	689	25000000	1	CkpZfqPAtVdCuQP5DrPndayq4HT6xcX8bzAg6Po5NZ1ciKmkQCdZq
7265	fee_transfer	2148	62000000	1	CkpYwDXDUNtds7LU46eq9JUiNbe3P2wUmFaAGKvBgLNWEj8qZk2oE
7270	fee_transfer	1637	429000000	1	CkpaHqqPaiB2vYsFBWHrVEU8S8pLPtvFzjnYsBqGkXvvmHjPUuVux
7273	fee_transfer	1747	21000000	1	CkpZKNziqzt8ssdVvxJ38FNSW2KeXCtprNLgsqVikiPa2SNzvchYJ
7274	coinbase	1747	720000000000	1	CkpYvYKzn1pJadyBXiPkw4scm44VqAZKyxKT4nVbjZT8kKqsNWtZA
7275	fee_transfer	2292	21000000	1	CkpZrNqahxZ9ddP179D6PyT6qbgNcpHf4bUzegX3c9oQzrk8g9Jkp
7276	fee_transfer	2292	2000000	1	CkpZbFc2h3rYxe3nyRbVwLZQv1sCahMCCXUTokcqRGCzdh9SYNapq
7277	fee_transfer_via_coinbase	1807	1	1	CkpYrsyt61uavNV9VdZrNjQMA1rboe7fJvCngkUsAMncgDM151BUo
7278	coinbase	1395	720000000000	1	CkpaC74uoaq7BBof7HNdyf3da38ga7UijJdhoqPnTdnRkGZcQbvPg
7285	fee_transfer	1670	37000000	1	Ckpa7Bdn1krWH3dKsGHAzKwjZL4MeMR2mNs6FwZuybJSAm8gRWiD6
7288	fee_transfer	1395	103000000	1	CkpYV3fd6bMJTyKv6KATB8d2NH5vcggX42wZbx46rVzm1kqJN8U27
7291	fee_transfer	1768	125000000	1	CkpZXmXkawiaA6UYrf5PF2vo7V8xGeam9aHHBXDz7XMJmAwdnHbFs
7302	fee_transfer	171	34000000	1	CkpZEMNEeKwDVjrqMtbPMydxEr9QpG3CvChthSFzNqkVhEq4YoyjY
7304	fee_transfer	606	115000000	1	CkpYWcEZKPdPsu2sgVkGkBX6y4X9AwSBCAX5uNEZQYH56ivRXiqfA
7306	fee_transfer	1724	902000000	1	Ckpa9gUJVmqzwvBzqUqFZRU61y2dX4gqPRmD14xEPc3ZaA2tHZJwW
7307	fee_transfer	526	14000000	1	CkpYYQgEBCYnxDmqJAjcDirBmyVvDndBGY77PYVKDzY7nTZEjYmgB
7317	fee_transfer	1671	3000000	1	CkpYQR8YncHaEKRVbqywKuHX7zvSQqRTZZmr5KZehfahr4pHgmhxP
7319	fee_transfer	2311	1000	1	CkpZWPoQEWbQMYZxj52YPqda3uGQJHMdswS6eV4GDdjhqYMuGYyHN
7320	fee_transfer	1555	2999000	1	CkpZRPZNs7q8uzj5mpmFWt5HjHaqq1TPYn2HLsey9D7GTJuk6DxWD
7335	fee_transfer	1684	6000000	1	CkpaDfPwoLtyyzZxbgDczfRD1dkaCr9DoHjhHxQ5hjiJeVV4aEsX6
7342	fee_transfer	2306	48000000	1	CkpYdbKmdWJkVbyXKWwniLUHoA5oLED3gPf5TKbNbkzA7jF2CyJZH
7344	fee_transfer	1706	46000000	1	CkpZGNuizEU2ayCjAT6zB2LL8dzFNde9fMrYjTxdqkZaL6oXMTVTA
7353	fee_transfer	1747	4000000	1	CkpYsU7DUcrBiDqGkdddB6R2rV9MDdwBeULVmw9vhiSg4HhiRBmTg
7356	fee_transfer	1980	48000000	1	CkpZRP9TuY1C6hGti8NoVsTbxfKKfNuycD7hyu83VXGCgwStmKALw
7360	fee_transfer	338	13000000	1	CkpYSxA51Cfc8nFK5o2RsfisFnnKBB6MKapDNgD499JfsYmdFsEKY
7362	fee_transfer	1686	37000000	1	CkpaCqdZUaFyLzGLaHZGynkMbw166r1bRAUjx2SsPeFVwXM9Yquhm
7366	fee_transfer	58	36000000	1	CkpYpSfZMDLLcNrqk8MNHVkYDC8xhDdjRvLupwEL4MMNiet8PRabq
7372	fee_transfer_via_coinbase	1791	100000000	1	CkpYbjknU4Ab9R2n3vvNHLBuDXnYYwLJFUMcDTemukMQ68MowfSaw
7373	coinbase	1690	720000000000	1	CkpZQHPuHq2ZY6tLQH9xnBTFn4yqJqbXi51DWu1z6X45BuTyA5Rd5
7380	fee_transfer	1608	59000000	1	CkpZyvAWjmbcKQkxk82w3tr7LnPQhty73QbKcazdYWPSFvvM4dH1C
7387	fee_transfer	1706	646000000	1	CkpYz4H1g57uukQFco4GaxzELQJ6KvtqBygnnuLtuaNpHNfRDa7sN
7400	fee_transfer	1768	43000000	1	CkpZ8vKLmx3YDM9d9YJaMM27gj2AMc5UTH5J4jURt82QUghpYupSg
7406	fee_transfer	1611	23000000	1	Ckpa9SWjPwfVpcMqLeY2oHoij2DYrF6toRXwaTYEDdscZb6ikU5Xd
7412	coinbase	2329	720000000000	1	CkpaC8GUxqyYrckPx7rgCUEeNY3UhKc4ygZ22vzd2hV9JWtZAgf7F
7413	fee_transfer	2329	20000000	1	CkpYqkf3KukMcurovbmFkWejxQxW77GiiKm6gKk3m3tPCD4MAz5HH
7423	fee_transfer	1692	54000000	1	CkpaDh7wa1rVziJgu4DCTSWDXedhznwmoWkLK1XnQFing162ShFvr
7429	fee_transfer	1541	1000000	1	CkpZpeFU4PDE3EoJ7bZopWAyxSoJ4bMw8EJQfXST3QqU6L9N2tpjK
7433	fee_transfer	1514	22000000	1	CkpZ4fZMDrNS7aCvzdNcxxXjrxpyv97JVvxgQGFvVst2ZQjdaqN4f
7441	fee_transfer	1992	147000000	1	CkpZLr9fiEcZEcJw4kgqa6E1xDdH7ULCRAJcMGUyc1grQRgMjxjmd
7448	fee_transfer	1992	280000000	1	CkpZy9paMFKhVdSK5JtyP8dnz7PVYr9wJJ3FE83pNXo6hmdwhVcMZ
7452	fee_transfer	58	1200000000	1	CkpZFusJZ9WdW7CZdLGTVHzgdsS5oAZYYixiiEJbRrptM9AfUfQ35
7453	fee_transfer	58	41000000	1	CkpYonPhSDoYWhJD95ez9985zVqrT9PLLxyTDtfabBWnD76LV4KpF
7458	fee_transfer	633	87000000	1	CkpZDHBCJ64kXQ2Eau2r6iPcerYptBhaKesQMCMLx7FV2eKxcFdmT
7461	fee_transfer_via_coinbase	2330	1000000	1	CkpZ3h8G7Gg3HapuCGnWCKzSskEt18tKh94sbdg1dt1CYgnE1rjpa
7462	coinbase	1684	720000000000	1	CkpYkKQwU5GDJavzHQ9xfjPFME4Ey2T8mfRsrAUbMz2b1y9huJj31
7463	fee_transfer	2330	2000000	1	CkpZLDZFRpRspVSvebbV4qHJTuHSPaXbtbphKeCJ9MtAcSHgFTkwQ
7464	fee_transfer	2333	1000000	1	CkpZ8mwmYggPpwmt1etYixsh6ACAtXwT2aZUtCE1xe9ymFMGhho2V
7465	fee_transfer	1684	9000000	1	CkpYscvPfpvVwhMfykxaYGf6vmM6b2CUQLY8n48MLGxf3AqfjY6hG
7466	fee_transfer	2329	12000000	1	CkpZajiYJuuNt644y9PmpBjob5ufU7T6hFARmAfWDFQSBqjCxAKm3
7482	coinbase	1765	720000000000	1	CkpZgwVtCCbCe6AqQ44uFTn3usjJSKbPYziR1jqgd9bU4VpnzVbPB
7483	fee_transfer	1765	34000000	1	CkpYmmHEwTHdAUFQ7MecafYvKpaqft9E2jxjTokiVrt5VeowH6XQx
7486	fee_transfer	1439	15000000	1	Ckpa3epo9GwY9v1zZGXCST673nQbNmERUmkpiD7dtXEKhtdQGzJXp
7488	fee_transfer	1467	26000000	1	CkpZqwifmfoyCAW3hnRQpcU1mMN7aRmd8rEiQE13TtswGpLCLAbGH
7497	fee_transfer	1546	15000000	1	CkpZ3P5LdpBsR41aeGhSojxV5q9JTFJoWAbT1P7DkLFnKcFSaTYTs
7501	coinbase	418	720000000000	1	CkpYVrifoXP8FRjNvZTEJbKtDFQP3gbK9iJ1TiNUcU1sVvR9KrhnH
7502	fee_transfer	418	13000000	1	CkpYkvcFYaWEo3w1VGUxY1QrK59jNAiikpSh7hJ6i4z7ge7iq19BB
7507	fee_transfer	2329	24000000	1	CkpZc5mWvU4yN8KCuJJG6V7odaLEvt73ARC6MKH8NFg4vL7aYZV4Q
7514	fee_transfer	641	394000000	1	CkpYsYv1D8afZWVPrnBLSv9MetEypffgatuJD86kkkzhJN9xjpJh9
7518	fee_transfer	1423	15000000	1	CkpZ2dTbk16QhU36qG28X2qopbWCU1LTJLxe65bmwBs1EehvUYc5g
7534	fee_transfer	621	6000000	1	CkpZxb9xjfUyqb29HDp7EzhP1V3yajWP7MoE2fRycsmiVxwvM2Xrf
7542	fee_transfer	1716	17000000	1	CkpZiTbQqLPeKvewuYyi8GVXRXSdrAiE1mQNfsL7e6B7LuS35FrJs
7549	fee_transfer	1850	2000000	1	CkpZpYrQ8JFYaMQsi8VDeRqcYbCoxttdrocgRe62EUm5HF8YDzdQK
7550	fee_transfer	1746	36000000	1	CkpZ3Zngv6hFcr9c3HRr9T3B5cSbFyukkWkXhGBaLSkMCjYrTmJuZ
7552	fee_transfer	2292	36000000	1	CkpZbzp5EpyDqpwE6bcpBr1uqaqpedGfioQs4qmvm4Dhyi7wtbLeV
7430	fee_transfer	2329	11000000	1	CkpZriePiNeDSr8mP7DCdhLHrNz3nixgnAPBe3EZt2r39S5pBQmBu
7434	fee_transfer	1598	22000000	1	CkpYfV1Gxg3cijcEfhhEJcPctLYjK6W9JKFjWrcS2G2Fe2JRaLKV5
7437	fee_transfer_via_coinbase	1568	25000	1	CkpZDJjoBNJmBBpMqx8bgkoz98aFa9Y17WT3DnwjQVDc7ZReBonX6
7438	coinbase	1423	720000000000	1	CkpYsU2kDCUgs4ncCkemux9pnSRmt2KHpA9Lo2JWByX6G3preNSQA
7439	fee_transfer	1423	10975000	1	CkpZZefyM9Uz7kVrnnVY8SePD43MBNr8sCshyoS7QJhsrRSB4i6LC
7476	fee_transfer	1716	6000000	1	CkpZFVMiXZ9vnLSZzLTpdYxFDbDD6RcP6rsBedxQee4TQ7TkHZ9iK
7477	fee_transfer	2336	25000000	1	CkpZUf68fsBdukK9ob8ofPQH7hTseXCPueR1Wgs8VteSM35g1QLuR
7479	fee_transfer	1670	21000000	1	Ckpa5LQGgQBVzTQvvUyw4iBh8zLJ9tb14Ts57WivNMHCZ7X95ahxe
7489	fee_transfer	1619	13000000	1	CkpaBuhtXjGRXLo1YKdS1xDcVZwmjMaemyUswqETeuTqNaMyGutQ1
7499	fee_transfer	2329	13000000	1	CkpZV7Dx2x7PcLMT8bhDtQfAfSjUuEKsBRwKQuhdYQCwAFLdoAHyN
7500	fee_transfer	1610	63000000	1	CkpZrf1RVNRCYbkV2SctAFFDXLz3kehD1J5VXcnnUhUsgPmBt9nSr
7503	fee_transfer	1694	83000000	1	Ckpa1zNebT2mFx18uuXgw47CKcbwWqHp2137aePqfKgP3GkvQnFpQ
7508	fee_transfer	1765	12000000	1	CkpaAV1ukVeJJ3vJMpACcF18biDLbRMwfnyggRyv6fQi3hRHLMEgR
7519	fee_transfer	2329	14000000	1	CkpZHqJUYWX5ZyZD1tWMGTgBMviu1CJwQzo1zRtHrAtSv6E2dNmpu
7520	fee_transfer	1678	25000000	1	CkpYp54PU1MANJsrv38V4GT7Ks4eLQkG4yJxRA7NyymSB5ov4rNmJ
7526	fee_transfer	1685	5000000	1	CkpZC3r8D8xGgaP8EvoLFkWjqzm97hDgTTCgbgEF2MdXwrGek2ohJ
7530	fee_transfer	1588	2000000	1	CkpZNFAxayNoqjUb7w4qJ9id8MSLDbvE8VQcVm9zZrm9uL4zfSW64
7532	fee_transfer	1622	39000000	1	CkpZf5SCHCTLf48nwAxVWyLTEePGoxFmvKK5iBYhWuZPCm59MbJzF
7537	fee_transfer	1719	999992	1	CkpaKzWrvqx3eWkj6U3CiscbsmRjNqALkdGT8gJkAVNZWmyGWjapG
7540	fee_transfer	1395	17000000	1	CkpYToftkAs83atmRVpQSehwt9Sai9anhHZGd7ZsjE38mUFPLhBxw
7545	fee_transfer	2306	66000000	1	CkpYhNmSeiygH7AtnPKB3ge7r6Q5omu41H7AmA9SKwk7DkNKpXjah
7546	fee_transfer	2306	1000000	1	CkpZdy5BwgHRkFXFZfcCBwTF5xCktCfFGgbv8NchjHWrgTvBoPUsv
7548	fee_transfer	1680	18000000	1	CkpYkT1L8trHLJCqQyBDWQJVrJoWjSbSaVuMpfFsJFmkrswu1k6EV
7556	fee_transfer	2329	26000000	1	CkpZxpYbd65tscwh3VhwedSFRBa4yQkwmHi9xVvvfUjSXJ4HGva2J
7560	fee_transfer	1668	5000000	1	CkpZbYZhwdoHTa75DuaveeTpQj6SCPjq7jPt74FjrJonuSXHvw1Fp
7568	fee_transfer	2329	37000000	1	CkpZ1quf8Zano14iq86UjkQFiscymnh11zvdVEvwdgRMvKCgAwWhV
7575	fee_transfer	1522	38000000	1	CkpZbMA4xUaGg3JCJhBtYaJe4my8rhXg7FEzsNGVudv43uaBFRR8t
7578	fee_transfer	1619	25000000	1	CkpZ2uokXACr5oiMHx946qHS5oX9EWzZS46EJVWLZnTSbM4VExnQf
7582	fee_transfer	1422	37000000	1	CkpZrWCwLgALkwrwikDW6ASr95W8ajRSyXACL4nk7QJGaiKH5w4x6
7585	fee_transfer	484	24000000	1	CkpZdLACrSVBL5ZHhudws4T6QvLQ9L3T6CSxFeuzQmgDciVAcQNyu
7587	fee_transfer	1666	24000000	1	CkpYfu7VYSYwFzUHegcwcmZ5S8MhBA7ug4GCMZgasDGMcD2Tj7kcz
7588	fee_transfer	641	850000000	1	CkpYcX9q9yjqmi4EPP1gE7jwL36uKjNfdivkrfiFa8FpTJvPBny4k
7594	fee_transfer	1546	37000000	1	CkpZUTJKS1ypJfjg7dLNkhpbK5SPufNDEF2JHG6bTsyf57EntwARV
7596	fee_transfer	407	690000000	1	CkpZapiD4VMVPMd2PeWirQqCkwT8xGr3gTBweqfxUthYXvvpfXpLm
7597	fee_transfer	1619	37000000	1	CkpYvWxYYpD9oL9V4jFvRpAstk5kGSVh9T28mV4TUDzFFEXFAHHiT
7599	fee_transfer	2367	1	1	CkpYuDPGzoi3JKrGSMNeVWWaoK96tGyiY8maM3PcR7rkM4BM7iWT3
7600	fee_transfer	1688	24999999	1	CkpYzjzXxria41vTGAyMRAr9Zmwd6FjxMTMg4njmdeKGQ3nhS4Fmg
7454	fee_transfer	1489	14000000	1	CkpYvYzCViMBydU2c8bc9SjejK3bWaeL4wqcW6k2rgtDHTCGcbfyM
7457	fee_transfer	1599	87000000	1	CkpYk7KFrBS9X432k3RdpWpbCxi7CsThLDFxWTTwefUwexJcme7Pr
7459	fee_transfer	1594	25000000	1	CkpaEEhrLbHw6iSQB99CNJbaG14nCr4KoNK58F1MKqJ9iDdauFzah
7460	fee_transfer	43	23000000	1	CkpYbMkBYPWwsVjeoMmYyPPRTUtwmN5ukjPf1wSKwDzNq8h5NF9sV
7467	fee_transfer	1679	1999999	1	CkpYRAzWf1mJfbijHbTQ18s7PKsQp9eZitvXQn3bpLmZahLq7krkp
7470	fee_transfer	1719	34000000	1	CkpZ2zKmLcW2gNigKXdsrvb67RAeqWo6LL2bbHFYZ8WvBpLBX8MYL
7473	fee_transfer	1688	47000000	1	Ckpa8SyeVbjBHyzniM5ZE1J21Bw64TTUVLM1WG2mykbuy1mNWmn5K
7474	fee_transfer	1980	23000000	1	CkpYxrv4sThbUjdfTpWG73Xom6rtXgHeQ99EsP4jzpDVJPDMtwVYf
7475	fee_transfer	1555	39000000	1	CkpYszZNJU3k3BCyuepg2UJTws7mCnsnRBcL2QV2dvpppQGnprwZg
7478	fee_transfer	2329	23000000	1	CkpZw5qWZPWmfzTN4xBbCwwYUJ6s5g3GAUEyno9KUYD9QPY6hmK2v
7480	fee_transfer	1619	21000000	1	CkpYkHerhDvZqthokEihVfZuD8H86Te3Ubi24FMV7YUFPyw7CLgCD
7484	fee_transfer	1694	770000000	1	CkpYjksf5FjrTWnEyL5xieL4Nrsu6iVT2MzivcZmE8LwDUVc8ef6n
7485	fee_transfer	1694	480000000	1	CkpZJ21UvkrLataLEYc7PFLWPVEsmXNgqABPbfvcSrNTdDaKR4LXE
7487	fee_transfer	1684	15000000	1	CkpYa5wC4Rg1rn8nauHXBYbzp1R7oMdFp8tGkZRtkGf7UYrHoC5pS
7490	fee_transfer	1602	77000000	1	CkpZY8aSEkFoSmX4uXfKx4APZ1HVn74ZVAju6mcjomAFLwQDfwfNo
7491	coinbase	1602	720000000000	1	Ckpa7qfbK6mXYXYm6pESNk4UTQbdH3H5b5vjtum7xjB4re84gn8E4
7492	fee_transfer	45	60	1	Ckpa36R4QLNJXnCBdvK2Vawz7ez3o6LqMCRJDosbFvJpKEtJhk7SA
7493	fee_transfer	1568	250000	1	CkpaDmiNzXo486FDuF3RquPH2mRX3MaEBXHRdxdpk9zPBV9GGktGg
7494	fee_transfer	1758	600000	1	CkpZm4nxPtMpa7VokTiEq9rQh6EryCZA5j4bnCHL6Vw2hQ6tYDYAG
7495	fee_transfer	1855	1800	1	CkpZLbnU7m6NMg7ifZck2NeYLKwUTgxHzy3kdHZBfkRUfs7TcHBuc
7496	fee_transfer	1602	37148132	1	CkpZeao6r5VMw6cPDpAaVyY16uJ2znLwSzbZjotRTq2NkBAV3t5tY
7505	coinbase	1444	720000000000	1	CkpZDrftm4FDsVG1i5CJWuhgBysWufaXUAUg9m2rENvrooDWWd9ij
7506	fee_transfer	1444	23999984	1	CkpYSpdsbni97xRjppQWF6RNzqPbDwxxxsBexVQaLE8CPi17CMz93
7509	fee_transfer	1402	302000000	1	CkpaLaBAsASK1BZhEpyJBRrYU2861BbvHgHAdaLAZybSaJZm6n9XB
7510	fee_transfer	1402	19000000	1	CkpYfw9QJ3Uzbamh1FZaMosEYBi7tBMxUZWg3ocg8bp1mgtZUhVPm
7511	fee_transfer	1468	457000000	1	CkpaK8813fKfi8GfSCXfstXs5GUfz8kUZC4mvysn2ekw9ZEAZHZYk
7512	coinbase	1468	720000000000	1	CkpZVLCzyYBSnXg8DXieJHEQdsWav9KqAJFpJ3HrozhY1KYS2THsE
7513	fee_transfer	1468	1000001	1	CkpZMgEp4osT9HofmycBNGL6AVbYd6f9pTa1CidQJcMZCocDoCkvt
7517	fee_transfer	1654	26000000	1	CkpZvQHx5pfychX8H6DRTWdG1LhEGveN5rhH7byqomTCJeWkZyaTW
7529	fee_transfer	2329	2000000	1	CkpZS5aLBurhnM7dBnxXnmZcucP4XUA6enfCR7XoyBc6LHGX2pSQo
7531	fee_transfer	1402	790000000	1	CkpaH3w9HWiiYuGXPP1AHBPoTpTRrSyGaYae1f9xFmojvHECvM3uD
7533	fee_transfer	1394	39000000	1	CkpZyw1eKDMo9BRvgApb7SsjUg8yh6NhTJroGdQZdV62PNHRcrxjd
7539	fee_transfer	2248	17000000	1	CkpaCcQ7f89esjx5T7wvpFyDYMPwk1RSpwNyDiabic6GXBDYysq5g
7541	fee_transfer	1619	17000000	1	CkpYckV93Trx6ju9jRPKLsFA8UhU3tCdRfnjJy9mpFWKpr5NBfPSA
7551	fee_transfer	1747	36000000	1	Ckpa9hY9AkxemuQKcNL4phzfVftmpD8HkSXbdLveG5Vb9FEyCGof2
7557	fee_transfer	1764	26000000	1	CkpZzx67YQHcfyAgAB9m7LPTshHZKcfUGCzGYqB3ZkuKyHdaeQoGL
7562	fee_transfer	2087	20000000	1	CkpZWwd8HCB9PnfyhqgTz3gvqUY5NxmU2K1nXaUdjvSwcuZAZpzBA
7563	fee_transfer	2087	5000000	1	CkpZVVBRr8PR3gHePu9uaTXcRzPtCidzcCBY7vi8UCbFwPJmQVkr5
7567	fee_transfer	1596	26000000	1	CkpZVy7KqsGeVM6B6gJH59eHv7tbibMniobRcX4g6U3hUKhZNMhSY
7569	fee_transfer	1522	35000000	1	CkpaLiD61JyyALjxdSiDhCsorTP4XkoEEtjkGgyMp6TpYAxgE9bo3
7570	fee_transfer	1655	1000000	1	CkpYYRGAPCTWXAfsVRzvNVPscionyKfGWTNjorXRZ3as6ouiWwoLF
7571	fee_transfer	2336	1000000	1	CkpZuFbiprw1NDyN2eTv7qxdsPbg2A4SAbNf2VUvVhvatcvmf94Fg
7572	fee_transfer	2359	1000000	1	CkpZQeuBgeAM6xDxGA9xnmrxALT9m8fyhE6StV8wYFXYN7g2gVppa
7583	fee_transfer	1422	34000000	1	CkpZYuAZJHoFE6j2ZFhqr5cj5zgEUuBdbBEbziMpmHdruW9D4P6Pg
7591	coinbase	640	720000000000	1	CkpZKNHy3godHSY5PbWE4yWP1p2UiNQRs9AGsDdFnBhep2z2JedCK
7592	fee_transfer	640	12000000	1	CkpZMtprfdANUWcQPvhvsaBjUt19GfW9kN9VmHk9UjoL7Z9aNrnPC
7593	fee_transfer	2039	37000000	1	CkpZmrzhKxzoaqyv1xXz3r6qxmuYshGemXYexU9M8j3Vs43HFoxAh
7598	coinbase	1474	1440000000000	1	CkpZj72o7jr5CspvpyucCiQUiTCmzXThcY3BGMe8NJDnwsbdDT4Ws
7498	fee_transfer	1691	84000000	1	Ckpa8QUMg9qhKQ4bhCMtnsY3mnHcqXmCWjXt64SNdwHtCLT873PLi
7504	fee_transfer	1419	5000000	1	CkpZZXkFTBLpC95UTJBhQXEMqFyaTPrY1epcwoL4fsZHxdfikwjW3
7515	fee_transfer	641	560000000	1	CkpZXbUqxUUeDNMW7Spw83Do3Z9vPyCAMDUWyuvSFScAF17YfvoAy
7516	fee_transfer	641	348000000	1	CkpYqbvuGowCD3DSxNokrPp12G6yLU7Kqhiisf81wzx3w4VTCDLNU
7521	fee_transfer	1691	591000000	1	CkpZbtHjdCKYr87NfUVgXEAGfqcpZeFDJTKT2snsDQMNxdCdJw5cM
7522	fee_transfer	1691	29000000	1	CkpZiAwx7geW7pdEKc6H3jKcnNpFR14W5psYJwfzNPNTFeboJsNeo
7523	fee_transfer	1691	204000000	1	CkpZnAVVm6v8qtVzhr7daQiuQ5K8LZDr2LyPn8URTWK6T5tVcxucL
7524	fee_transfer	1691	8000000	1	CkpZtBuZ5z3Ewyn8TJoRB2rs8KXGk8keKYAaf5d5uBhiYpYNdHWtU
7525	fee_transfer	1613	5000000	1	CkpZo3V5Dk7o5FEd1CyUpqib4eTzX1ajpixF9PDdtK71RaxKMJLbt
7527	fee_transfer	1565	12000000	1	CkpZayE9VG3jxBX4ute4F5J1pK2PUf41fAS9ThpPVAff2wXygVhWK
7528	fee_transfer	2329	25000000	1	CkpYzUsZ1cFEaebF1gKYLiF2BYguZLrLurkW18ZFoE8CMa5pBy5eH
7535	coinbase	1719	720000000000	1	CkpZfFFn9Dyan8mnhuRDeLhsuY48Tr37gCUZXarj9ad7ewjw5ymdM
7536	fee_transfer	2252	1000000	1	CkpYiJukQpTqto6rknqxuRUmVjthv7UhDtnTYeEVhRAaAntvvMRw8
7538	fee_transfer	2112	22000000	1	Ckpa3LCN5MPFsBERJS77qRAAq97cCxjAoT8AFomyKE1Q6zbvcdjzz
7543	fee_transfer	1594	17000000	1	CkpYXX8nethWEWSMV6wR2QxjVY43kNRpfSq6bM52Sy76KJg7Dd1uQ
7544	fee_transfer	1440	66000000	1	Ckpa3fA59mMB4rfV3BsGcYa4cPrFkgABZnsK2KAs1FYrxchkpxocA
7547	fee_transfer	1394	66000000	1	CkpYbnFX7FBHAyXpyZdWCaaucdUohwVYKSc8kwAmeKug7QzizxYuS
7555	fee_transfer	1402	629000000	1	CkpYRckYGqvrqJ6k6TNKrGQMtPmUtqouRzcjfGzFPXjzxeBL2uSRJ
7558	fee_transfer	2252	1700000	1	CkpZSxaFQ9VwU3ERvD7erTb9bYGyxUhc2zxd6cEKBS7uWTuXLqpHe
7559	fee_transfer	1668	3300000	1	CkpZRQdErxS3pvrUj3xTqSmoHuh1CqKVgKy69qbqDLr47ddgQvqS7
7561	fee_transfer	1699	5000000	1	CkpYsQ1h31FQrhWB72aWNE95L2m1bndBpD21EE44J45z2pGtBnXbC
7576	fee_transfer	1476	580000000	1	CkpYqT6aePyzJHa6odcipTo1vocqxC5bGo5RcNPiHnNZaFBMeaVA4
7577	fee_transfer	1476	158000000	1	CkpYUajkRZVPbZY7AuCn9qrPk1mHpwf6dwNaA7K4qxyAW3GSLERBY
7579	fee_transfer	1434	13000000	1	CkpZM43w82FwK6qJqdVDKXt5G4hZw8hVqzSA6dCQnKzQYkGFy8jrc
7586	fee_transfer	2261	74000000	1	CkpYvZz5Ar2pB9sDAnVNp7jrc3Kr1h241QNQPBcQRh3sEbjeEZNQw
7553	fee_transfer	1681	18000000	1	CkpZi6CZEqSa3X47SquvooneA9FJo6H1MmitUdGdwPWTHVtYTbJsT
7554	fee_transfer	1694	4000000	1	CkpYzZA3p9wmfQe6MxjctBfKV7GF6kwNVwAfSRz5mauWRMf7Dsiyj
7564	fee_transfer	2086	20000000	1	Ckpa1iQEm4oNj3aS3Lq89Nnr1dkzLAPPoQ72eYnwpPjkVt45WVye2
7565	fee_transfer	2086	5000000	1	CkpZteFZMZ13pywJibtiZeD2hSnB3HvH4yy8rpUTDdbJsTozvUjja
7566	fee_transfer	1602	26000000	1	CkpZPjkPjh86npJ2yZfK2i9drmXP7i1Pn8pjx5ToEnHjGsdwfuFBz
7573	fee_transfer	1522	380000000	1	CkpZW4b6zBuMsfxX9SvMnLk5ZBWA8R3WHkXjfbNJHdZcjLJUWgTjP
7574	fee_transfer	1522	870000000	1	CkpZAiZcQtDKyA58k4EYH8pVcRfFUXN97TSTXZymgNSe1nsLdpqcs
7580	fee_transfer	1654	28000000	1	CkpZvfKRMCni4M2ZaTYaJJdAFgXAwfqMMVM7Wd9sdXdb5qy1FhZJP
7581	fee_transfer	1613	24000000	1	CkpZSsPnuHjsPr2qMpoSuHWwwN2R2Aj2CDMHoWoeFjeUjF9zVxqiD
7584	fee_transfer	1643	37000000	1	CkpZK5YQUpXiEwJrd6JqrtJ125GXwuwY3jU7QJRapbb8ZvYDUjgUg
7589	fee_transfer	1395	8000000	1	CkpZdkAQHbFaW4vzZVN2YJ8pMc2fN4Kg5p3BCoGuzQhbEaUXLFTdM
7590	fee_transfer	497	29000000	1	CkpZvD9cVgrj4t1sc1ywfmVyWxMSRUGdSNYL7hfL2ZKNs9T6oo4cB
7595	fee_transfer	407	22000000	1	CkpZq3p8Y4HsgzJBv2zbcDmzT84YMhT61eS3KdU8XbYbaP2JgvXct
7601	fee_transfer	1690	607000000	1	CkpYW9zaAEmMwYg2LrcAB9CZoJKertMrLiQB7dD7Y4qorkAR3Ez6M
7602	fee_transfer	1457	37000000	1	CkpZBXNCXzX1DjtTBwxQy8zzFuvQ4CdqEeaKDRbpPF2aHZKDNC72i
7603	fee_transfer	2112	547000000	1	CkpZxV5upZcBtRdadBnY7ZgHLatDxr4txbMb1mRzNEydJtN9qZeSS
7604	fee_transfer	1639	13000000	1	CkpYhmswJn8Hfct23EMjpFdN43EXKYD7ivkhTG2SRgEfVQmtaSJvv
7605	fee_transfer	1690	211000000	1	CkpZJ3s7U8EzHBk2x3hMXDmNsqXvzjjSRMb3WeBLacaa7tMB8oEQE
7606	fee_transfer	1657	37000000	1	CkpZk4tB6H2KU7JLTXnH7nLCRJLV27hkpedYgTr35UKJSxWyz85LK
7607	coinbase	1519	1440000000000	1	CkpZxFhQCaqWnc4oj3BzoYHNBAiunX8DstuoU3QmvPJwk8i5Vgmpe
7608	fee_transfer	1519	13000000	1	CkpYVQf7n6FSZg8xMNkthHPeqMW6uYtXdUsRkC9U2nhnqWb2rHVi6
7609	fee_transfer	1678	13000000	1	CkpYpfuLapcRwkjKT2TdqhUvQ9oCyeo3ohx8zgRYjEs4xBr54QcvS
7610	fee_transfer	1690	97000000	1	Ckpa2sdR2FpoY8fJX6szywSHGpRZSHVuCYjQCvbjSyYu1xG6dypHs
7611	fee_transfer	1690	13000001	1	CkpZLADam8ftbU4hBdEpeeiKW7gsDV2enRAhaqZUfybU8GynhEX5M
7612	fee_transfer	1686	36000000	1	CkpZzLMj2YPDcch7hFVr5VYyMK9HxJb6DDDTsQqXggH3Dx8BZRTh4
7613	fee_transfer	1444	47000000	1	CkpaGftyEsk5uVeYCVoxbcfqt2GA8BKk3Y3bouxvjYyCvVwmajAzB
7614	fee_transfer	1709	47000000	1	CkpYecwPaS7UVUhXWdF8HCjyCo3N9Fk8bgfZufEiNpG3QVBEHFoGG
7615	fee_transfer	1690	287000000	1	CkpZdmpJrZKvRvjgHEvkj6rMLxd1CjxrLJUohdnZ5vWsMSQjKsfQr
7616	fee_transfer	1458	35000000	1	CkpZpdGpesJZDTxMKy9K8nMoeJEe9RqbC6gfvih1vFNWhMAyCZ5Z6
7617	fee_transfer	1675	36000000	1	Ckpa3zmpcSbD5fRGHvbjWQGpDc6Vqj5bCoPogwtqvAj1FWr9YbhaJ
7618	fee_transfer	1547	3000000	1	CkpZP4rgFd6yEMQunJZEAxivh2MJYBdKnR43UGFBV1kefeLYgHnEj
7619	fee_transfer	1719	26000000	1	CkpZMSckLQcrs5MjVhodNtWbxKTqxqAhmwZ3adYw8UZFU45sAjHqe
7620	fee_transfer	1708	23000000	1	CkpYqP2SDGw9AnbV9HR6Ni8JVZYFAUHUZcQivXAJ2LbEpGz7vNSaH
7621	fee_transfer	1506	111000000	1	CkpYpLTkM6pVcFego4MQdw7pcDCAGXLHXavj56iM9XJC3tohKj36m
7622	fee_transfer	1506	23999992	1	CkpYwknek7M9iS6iy5Tzdo8EemKdmFDo97JsMMFW5whjV6WazuwES
7623	coinbase	1693	720000000000	1	CkpYi6XSdADHGx9zzPu1jDFeERJS5186dBEW3FjAwBtdYpcWPV1SU
7624	fee_transfer	1559	36000000	1	CkpZoVTD4Df5wtBpcY5kmw1KoDgpWhxsLcijMcSug8eemNN1aY4DG
7625	fee_transfer	1546	35000000	1	CkpYwk9aLoqs5Y3pgtjfinn6reeYHE8mNPkDPhvqNw7KKAxV3vT7J
7626	fee_transfer	42	35000000	1	Ckpa4E997E3YBZGp29hWjFr28UAf9QBJGBtsgtryrpi4ENZ4jLdcn
7627	fee_transfer	1756	580000000	1	CkpZeZnTKyDcuGjei8G9SfnvQSvNNSdAWKNf6PANMZX4bVpsBgmKQ
7628	fee_transfer	1756	230000000	1	CkpZmX4FwxszAr4pCX7ZysT4vjh6PHwaE3MqfPaJJFfVeEVeDfDMh
7629	fee_transfer	606	168000000	1	CkpZXE5EeGjrT4Npzgt5ek3aSUjN8p9VqWweiAEwanF2EKysTVFe3
7630	coinbase	606	720000000000	1	CkpaKdJhExJtf5UhNMRLF39mc1d51BXywY82Uva6r2oKoxJRuh9dW
7631	fee_transfer	2306	14000000	1	CkpYac67JJBpYZ1U2yMFnvQ8xA7GrsGnUhYYu85RtEX3xa99XgNTL
7632	fee_transfer	364	4000000	1	CkpZofMM3qJWGyZHhSFzheeMFmzjg6UNqnP4mYPD9ViHeATuVNHwc
7633	fee_transfer	1690	380000000	1	CkpZ6Zh8eCQ4G5YCkxZL935wPabj98Hu5Rc33RZ28agoQGocQWCPT
7634	fee_transfer	1690	19475000	1	CkpYqSf3othdTdQfasb2EX1SoB4pdfN67bqLqYhHLmtJg2wsufQws
7635	fee_transfer	364	14000000	1	CkpZzq4vRqzdKoHLCjGXAjEVe2pmQRiYL6Ws2AgPhQje7C2MQH2Z9
7636	fee_transfer	576	33000000	1	CkpZCh7xz2D2mxKRTT4W1v3FBygXY2XoSeJC4iCfNCacAmaHSnHyJ
7637	fee_transfer	1670	170000000	1	CkpZDo8U9SP7VQeR9HC2dms1VsswFeSceq7p9BhPgfecrU7vA4ZZE
7638	fee_transfer	1717	17000000	1	CkpZ1yEEkJGPio6fZaho5CYsAe5FAj4uEsDxj2DLoUtArutj2hjb2
7639	fee_transfer	2307	10000000	1	CkpZAmbPZzqeZXmrEaeKMAbfMRXYke6wvQzYC9WgvcphNopjyPYPq
7640	fee_transfer_via_coinbase	1744	5000000	1	CkpYstwLSAPBHSgrq2TXxMySwTYzedsDy3d9nJNJyoF6yZxgdfQfC
7641	coinbase	2307	720000000000	1	CkpZckonpzNbEEhrnvc4NjrgG3c7R4UDHnZZdiVicWhXFGeLLNVDc
7642	fee_transfer	2329	10000000	1	CkpZpELSVn3Qn4M3M9rZtV92HuVQUwDicurv1Y2f6eLinrykbsSd1
7643	fee_transfer	1506	101000000	1	CkpZmDnaJB6jDf9TQ9CmZdfDMfDaZDNSDc8hysBBYWeFxxFGBohwU
7644	fee_transfer	1506	23000001	1	CkpZ6JSfsVDobxmsSvBfDFnKKpTMRcctkEtR5bhxatRigEV7Bkjcw
7645	fee_transfer_via_coinbase	1737	100000000	1	CkpaKQ7EQ2Bpz1h7EEMBtdNVCq5vGYQzX3kXUzremi44Y34G2DvhB
7646	coinbase	606	720000000000	1	Ckpa7zBjgwVfh7ddLSH8FrUZx2Dpq1HHC9p4tPeLxuoFFDm5fM4PM
7647	fee_transfer	1672	23000000	1	CkpZWh3Nb3irQ9qMz4j9RgVYdNkJh4gNW3pkYfS6odUVKEXSbkL3x
7648	fee_transfer	1623	360000000	1	CkpZcFS7zmMS2hxieEsYV4GiAmti4ruoQuvYeCVXKHnz3TDXnMx4q
7649	fee_transfer_via_coinbase	2332	1	1	CkpZstNThnZQnkuuDMk4jhvVHhHXByeo9QnUK2wFx8t2Gpj7gDfhM
7650	coinbase	1706	720000000000	1	CkpaKpEvpLhkMAs1qn1B5sfMertaz3J568gteYo4SpN69FihNvL1N
7651	fee_transfer	1756	517000000	1	CkpZWG7doLZAotp8df2e6LtPbsqgTyZbiZ966vTaeszm135qBdGYQ
7652	fee_transfer	1756	67000000	1	Ckpa9S97p91iZ4jLhkBzdnz3w7StwyGGuNnAS4dkRQg2q6aZekBoV
7653	fee_transfer	1522	36000000	1	CkpZ892DTeTc8M9ruHAJeeub8hstYhxXGJxAGM5G9YBQECTgZKXLD
7654	fee_transfer	1749	2000000	1	CkpZ1oxmgHoj8Brh8LAF9ADs1ejuDfu7EJPNt5AMmGy6mKuqCnfMX
7655	coinbase	1670	720000000000	1	CkpYjNRjDzLMAwTvj57RHARp2FTtDRcDXzjdfaUydQ2HJHz3xfdXP
7656	fee_transfer	111	35000000	1	CkpZjT6UCVJKAZcZLyLtff52zwXgnU5xVvLEmNSUwQm9c2tNd4xPW
7657	fee_transfer	697	12000000	1	CkpZBDbUCwhdnKbQMHHYHW7X5VaAdRFtQtVufo5MLWyyqAabyhjWM
7658	fee_transfer	1692	2199984	1	CkpYc6U1emukaVRLdooBrRet4Jr6mRb4GsPhZiosJkiu68tvps9fz
7659	fee_transfer	1604	300000	1	CkpaEMskUqE4qGioRCMV9diE4iG2CULJ5oceoqCbT3AdBNguoimbg
7672	fee_transfer	1756	219999999	1	CkpZJCwn7YNJTqoAJmSJtyqseCRNaECKytmX8hLQdXcZj7jeMQLvw
7674	fee_transfer	1395	84000000	1	CkpYpWMpadbbkqQyNoU5cdRy3bRePLqkLJJwoEcEBTF8chZ3WjUCC
7679	fee_transfer_via_coinbase	1514	980000	1	CkpYVFR29FTinbQpXgvEwjJ3tXriRvywoihETHjiZjp8kHAn43LYu
7680	coinbase	1670	720000000000	1	CkpYzFvsLNEXuzqDgYcHPDxCQDAxLUei3Haq3vcVcYtBjVts1xmEL
7681	fee_transfer	2250	3000000	1	CkpYSype7wySeTQZ7HhLzGeNdUHzoNNnb7etkvsgnfneV7Tpvc6ba
7682	fee_transfer	1670	9000000	1	Ckpa6YhhAJWEVS3VknfkDq3kT1dCnKTXtbmX6DdgumzzW5FjyYgAN
7692	fee_transfer	1571	36000000	1	CkpaDyQ5zXUqLgheQQth7JAH18CDNmgmYPTZKqmCX1iHk225gvezE
7695	fee_transfer	1271	970000000	1	CkpYaTfB9yRupppXmvGDqHVKzNbW4XVztjiY9WH4fpz3C2ehJYd9P
7696	fee_transfer	1271	134999983	1	CkpaBpBLJnNouzTfQWhChCQxvLz88LqQRryPXdrkwgVGXVLxo9NGE
7701	coinbase	1759	720000000000	1	CkpZxMu6WDUK2KRYE6QzWZKezMsnH1635why91esFWyuzKkRFCwiX
7702	fee_transfer	2261	36000000	1	CkpYpuHfDqtubREMmygZfXhVJhUba11cSzJtjxhwPfBM8jssm2PtE
7706	fee_transfer	1634	36000000	1	CkpYqGgAj1JtKcaGcTBSVWPVp4jYdLM5SgATUpXe6vtkBc4BWdpqw
7710	fee_transfer	1448	36000000	1	CkpYrWJdrWZXCe3FwsEMvrtkVrt1m7ybrUM6pDttuSKfsNiqNcNyy
7711	fee_transfer	2106	36000000	1	CkpYpbNfCNNibJ1PVUa4xgD7SXHDhNHmXmQA1382rXhKpCi9R917Z
7712	fee_transfer	1692	10999988	1	CkpYkbDMmJTquf65ZPnfLxApeBrgRkgDoKTEMovLMFjztr9Q6YzDs
7720	fee_transfer	1394	18000000	1	Ckpa9924QThNQfAdJ62iSZx7R5FR8FUDwZzikA8cEZpgnnwFCLtkf
7723	fee_transfer	1599	6000000	1	CkpYj9kHhBGw7ZBhuTrsbuGUHua8eeD4bt73qEusCWRWkj48ZTo3Z
7729	fee_transfer	1678	7000000	1	CkpZvRSnpaxt9MnA5hhKqEb2Wq8iejVNbmBhbfVsa2f9bGuAaoyyH
7730	fee_transfer	1451	7000000	1	CkpYuUXFTxfbEpVZ6XUePi29DuG7NBT21egKqg4jxhn7GMsxamUbT
7735	fee_transfer	1402	17000000	1	CkpZNRrQLzfjvTYjxPG7hcn2cQtEKDrZDKQiCyuo8to7kYywS13BM
7736	fee_transfer	1649	28000000	1	CkpaHjpaW6GqNcJHNhs71TeSo7XhST4XVJXi4h1PfQR8UPdUo5Hqc
7738	fee_transfer	1693	2000012000000	1	CkpZWKoTR761hgUL4otyrjRpHcBnuzk1qQZLSkkphqxFt6nmissfT
7742	fee_transfer	1499	100000000	1	CkpaJJbNXYYotrWmbpCv1TzeyF1vYdqVDpHu9yj1FaDQhdWynxCTM
7743	fee_transfer	1687	638999999	1	CkpZQ6rTkif21wzEZzEKxUYL1r2Af9ez9tc8bxqrY9AftoiecHTdr
7745	coinbase	2384	720000000000	1	CkpYidrv7arM9FrFLqJoK2e8m5YnVbjLjTTEZsFXT8JFwo594ysx1
7746	fee_transfer	2384	34000000	1	CkpYvhHoz63R2vGsu3wXqnp3wLRNF9zVe7wGXL2d9WQv6UzPtSyyJ
7749	fee_transfer	1714	24000000	1	CkpZKbynKRPfWqACKbMgdte3N6zpW7Bx2jtwBGuWZuqimErSQ57Aj
7750	fee_transfer	2106	15000000	1	CkpZHT7tm136AkTmxN8p5G2CeMK6a4RWPig5Gv1PCsKEQnz8crFM2
7752	fee_transfer	1724	72000000	1	CkpZjg9ZpkfQKn2oUbTYy5vrbYqXPyg7JojAAp1BvvTgk2XNmMbyj
7754	fee_transfer	1740	72000000	1	CkpYUGsrnMxrKBSeATQAaDVCBrMcEgExrNFwPV8ggADt6AyFUUjPV
7755	fee_transfer	1724	48000000	1	CkpaLecX1tELvq9xvmuLHX4JMNaicJm6NJcn2DWNwyf4TBu3Jq9Ph
7765	fee_transfer	1675	520000000	1	CkpYuW43ogbzwBbXxqjnFSwRzuniQe1asSSyiRu8JUQaCZ19R9Gh9
7766	fee_transfer	1675	208000000	1	CkpYzv2gsGHXh9HXWXCXdTf6k18n5iW3bb78phDNdgo7WU4tJLnKC
7768	fee_transfer	1675	196000000	1	CkpZvgkbUnmTGTcnqmAmggD7BmnCqGBQPFcfTMNR9N8iEZpDutP6h
7770	fee_transfer	1718	34000000	1	CkpZZNBxfphxqc5EQG6ZMBJVXiwRamUP8kaSPeF4avJafYVStEuQd
7772	fee_transfer	1611	33000000	1	CkpYoNHvmfrhQJNpNUwAuG7pChMsg2DA5qET5NhjARZNaR7TMP9YB
7776	fee_transfer	1613	700000000	1	Ckpa6LqrB26XduRko49DeZWBcQv8nzWnLLW4AWv8sQj8zez6YHGTN
7777	fee_transfer	1613	550000000	1	CkpYXySwjKh9BWxfpHDebwjTZ4S3R2swvHnTY6tMCLXaya6cCAGso
7660	fee_transfer	171	620000000	1	CkpZnsFVHuY2rrVvDUGAjZHLakL1NH9HGTGrYzLmjYr25HC7CDaYn
7661	fee_transfer	171	630000000	1	CkpZkT7jTVsRaNTMUDu8NUKUq9teoNd9wmPFVMVuj27snXWGVk91N
7662	fee_transfer	1425	10000000	1	CkpZLVh4u7Aasu4d7vtZVPUE2H8mQe9FSzczDVyPy9FCVUof8b7Yn
7663	fee_transfer	1425	38000000	1	CkpZJ2vpGzWGXRgqJV3UrFrg7Frekuka4b5UEkovwuGnqGdGQCJuc
7664	fee_transfer	1394	38000000	1	CkpYcnwbexo7oHKiezJbHohj55jUzKoWWd4UgCEfZPDEDTB9HEGZv
7665	fee_transfer	576	6000000	1	Ckpa9AL1tUBpVf7ChpDsd7E1ehuBDmqs8rLKDVmAVPwbQvcoLYzFL
7666	fee_transfer	1395	13999999	1	CkpZwLQtmjPc3cJYf6PFAd5aKJa9MK5n5MDgMLZA4tp2geYPx9BLs
7667	fee_transfer	2332	1	1	CkpZstNThnZQnkuuDMk4jhvVHhHXByeo9QnUK2wFx8t2Gpj7gDfhM
7683	coinbase	1546	720000000000	1	CkpZ1VoTPGHSHhx1qhTZ4Q5NjJs2zGHLiQ4horkvjUtTBTk6YF5Zs
7684	fee_transfer	1546	7600000	1	CkpYdV38hHrCVdeEKvpp22UkB2DVQv89f9ZbU2CrXUrik1Pk41Qkm
7685	fee_transfer	1449	2400000	1	CkpZYmZPncs1fQwubV6ALe1cS3HuvxdHyCLDq5sg3T2oezLnC28N9
7687	fee_transfer	1687	790000000	1	CkpYUGSFTk8tnNRJ5DFDd9gRZodimk7cMB1sk6ARyYoWFDK4ax7jm
7688	fee_transfer	1687	145000000	1	CkpZ1kPpGmMpKvPYmUTJipmtPKkJCaAPYGNpLRiYBmaMSRPpDtmgg
7704	fee_transfer	1691	36000000	1	CkpZYjWWES6RbQP52uYF87tU6a6H9LbJwv56CV1EDd2VWsYbiuJJR
7707	fee_transfer	1662	12000000	1	CkpaKWEDwkxvHf2Ksrtbjd8Apn9FMruXWJVR8ru8DxZAJ9Lt7RunM
7708	fee_transfer	1695	36000000	1	CkpZZ29UZDQdKTi5v7SZ8vAF1BCJ4s75feTpmVEQShjarrg87xF1Z
7719	fee_transfer	1685	18000000	1	CkpYYoHcW2HzdgvMeaZCxH5zxtFNZeaHYEXoFDXi2baqjw7YmYZSK
7721	fee_transfer	1599	18000000	1	Ckpa8tnQVEXooi5UP9Aohiw4jhWT3m64dThhX1VMvt9UHcXLbEfDV
7724	fee_transfer	1426	17000000	1	CkpZWq88D6EKiLbc5JKYp5tTM4gakwB4BoZdJBz86xcc8bx5Zh934
7727	fee_transfer	1684	26000000	1	CkpaGxQkKfg9x18bKCB1qWNzjeFFTVKUzybxCWJVVTfuoDNrgho1F
7728	fee_transfer	1394	7000000	1	CkpZ1njmW5CTYSxWRUu2tDCvUFZjd21Y3S3inGrpuUpPhBXDZjjWR
7734	fee_transfer	1695	51000000	1	CkpYcVZ3JtYkJ1hSEVytdPurS6GXLjKuFEJvKCAecVrFjw5mGnjGj
7737	fee_transfer	1444	2000012000000	1	CkpZF1eYEghAZNKsavMj3MXZCy2iurizQGoB13JN5TE71XQPiios5
7739	fee_transfer	102	10000000	1	CkpaGsJT5Axts92PLdNCgaYjS4uhRdszvy3GTP4H4PoCGz1oZmZRG
7740	fee_transfer	102	2000000	1	CkpYVNXMiUQxHDSSekAzo8DEpgWsa3mJZsjXHEnKyJXrBiFwXom5M
7751	fee_transfer	1447	72000000	1	CkpZw1KHpBcLA1EA5wf9ghxtZnLTHvNDMTfbKABCZVuCycWqrPfox
7758	fee_transfer	1547	190000000	1	CkpYvDmaLWCWvUq2zoM4JSLeRdbgBe4qBQcL8rRr5TXmV51A7Gdyk
7759	fee_transfer	1547	599010000	1	CkpZayaQ4rqh1gwPH2eXrH8VzMui9FRwJDiWcsmWQfouDzFU4U7zK
7760	fee_transfer	1719	44000000	1	CkpaK4avTDD8MJPYXaipU258NRr5146ktHrTU5MqsNaLCUpdFTA58
7761	fee_transfer	1506	48000000	1	CkpYQgnGVnx5uogKUPCWTAsXBTnscR2f6phXgCxV63kLPu2cxFEqX
7762	fee_transfer	2307	48000000	1	CkpaGAfr5X5cF5bW48bmadf5XB4D2tYDX1HT4owDG3FotXv6nAS83
7773	fee_transfer	2329	44000000	1	Ckpa5XYcoqWBRWKLXhn7rivE4DbSBURHvTRnjLeHsDBYodxPivNey
7774	fee_transfer	1559	73000000	1	CkpZckcyuWrviMQ4zz7jmQj4S7eRNY6YfAY5LFPAdGm5JnmQafmsB
7779	fee_transfer	1499	11000000	1	CkpaL4GiPFJFsjoq2deadQHUKTwu7YJsFcNdxBB7G2WTXZfA3oqvb
7668	fee_transfer	1457	360000000	1	CkpaD7THz5BjQXchg6vBKGWmhAgBzwKiQL2bU5ZkW5DzmTXvnFVcq
7669	fee_transfer	1457	170000000	1	CkpYo6vHE8WoXAGPRRraT6R4VPgPdaDZoJNiQ73wEX12Bm12SoZsQ
7673	fee_transfer	1402	84000000	1	Ckpa4RoSj36rYqL6JS5oQzQUesarVmpyWwVvhgXrshGHtdMfAXrjo
7677	coinbase	2301	720000000000	1	CkpZG65PPVZ4tHAiTEtR5fhJZAiJaYFrezRpHuLyGrBkDCJJsSzfy
7678	fee_transfer	2301	36000000	1	CkpZLdWQKSTjzKz3ZjyjBZ6AkcqoZyCRcV5kFTWx6BYkUDWGZsHpp
7686	coinbase	2261	720000000000	1	CkpZfzKMT9RyNSjfbk5nsfxfauRmUYbhxQqrag8uXohPVtBRn5yy3
7693	fee_transfer	1692	9949000	1	CkpYgZZUVfWhGJTqMGBWyNX5NM9e2xu9aScAcWrDndxGWdrrHenp8
7694	fee_transfer	1449	51000	1	CkpYfg6m3KuYwChsfU1pxE7SruV944PnT6s5MXc5FLsRVHVvp9crg
7699	fee_transfer_via_coinbase	1432	1000000000	1	CkpYZncQsevmhJTYE4BGbeCito7j3AWV6cyR5PpWvaufnr6y9rr2p
7700	coinbase	1508	720000000000	1	CkpZo4C3kdnr5EgMQqPzNSvrcLppdD6Jhg29HGYkuNnSHkzoiipPc
7709	fee_transfer	623	12000000	1	CkpZ5mQqU7xuyD877vyod3XgaKnjymg3KEwa16oBZiokwt5scDvaR
7713	fee_transfer	1506	25000000	1	CkpZNcQVGdLBAiJaPKM56Tv1bHHVQL1c4Cg7BehA3inStEfyvSzNt
7714	fee_transfer	1568	75000	1	CkpZeRHJuDnygRrRPaXJmG937hFK4sTt8J66Fjfdn2joehqZejR5X
7715	fee_transfer	1708	824599	1	CkpYu3CHxyCzftTpZwSQnWJVvTMcQ4NGS7FkYB4BXsUSEACT3Z5Nt
7716	fee_transfer	2333	100000	1	CkpZgRMojWHiryDeHCNt318tBzcnDQUtZfmobxMNN28ypCXnRWHkW
7717	fee_transfer	2346	1000000	1	CkpYSPMP5kwJ8krTFyNM7jNzErTpkniJDiDtc8YNVzF5YkKjgJb32
7722	fee_transfer	1419	18000000	1	CkpZDxXjHkrqChq63HEopvSDsxwLKV1jtBpcATJKZeEDX7WRW946y
7725	fee_transfer	341	17000000	1	CkpZg1W26NcSi5Erasf6eAoHktDRG4oR4MtUzRHVPxc2oynCooFLw
7726	fee_transfer	1622	51000000	1	CkpYRQZbmZGypoY3tQDLfNtKAmWmeHBXWDygUs4VAioWaN1kHFxxs
7741	fee_transfer	1555	96000000	1	CkpYtDGcgzdS1b1sahNqydPrD8QRVeCMhaRjDWJ6LC43kS2ry1ZYM
7753	fee_transfer	632	34000000	1	CkpYXbA1RiSZAo2WBKozUdrou6KVeFBjWNThS6eQNSPzz7ib1sa1Q
7756	fee_transfer	1547	550000000	1	CkpZQCPXUmThcyqHBKqhbCJUEaQbYWrNuYUqjMSzEYH4BHA3v9dMM
7757	fee_transfer	1547	673000000	1	CkpZPZ8PuExagZuncd5Xq5YMttcXvTQyXNFr2Nnn7p4aMbYgH5Dpv
7767	fee_transfer	1650	64000000	1	CkpYuQCGqhex9Vi9VAYBb9zmeJmDhV9rMcU8RacfkkHZEqq7u6q9u
7771	fee_transfer	1700	234000000	1	CkpZqnj5kqtyPpdMs6gRUKDDc9zzDJMv9e5RsbERhFMrLv4xHPEXr
7778	fee_transfer	2039	77000000	1	CkpZnESNv9Qmv9fE9kzrETTnd78NG351PYon6DVGzg88zT83fCYCD
7670	fee_transfer	1633	14000000	1	CkpaCSXioavkS4CY7FBf9u722oJVVD4SknRBc6Y7PaAt6Nckt3Taw
7671	fee_transfer	1633	2000000	1	CkpYippcAGgtX7sugtnK3vMKp4Gwvu3Te7RPKBM1ex73PRNYtdAXg
7675	fee_transfer	1457	216000000	1	CkpZ1kcYBkLBSDpkHUoLoggYM1UfrRrRSJW786xCAsej7eiSMhPA8
7676	fee_transfer	1457	32999999	1	CkpZ8BgNkaLdiZv2h8rL1s4DuiybZxbn51wXcvHywWwn9sLGRBhHm
7689	fee_transfer	1692	11899987	1	CkpYR9MPycJZ54f1ad8sspAv5XocWmJoVnTKmxxeqRv2stmSsErM7
7690	fee_transfer	2252	100000	1	CkpYbMT4Cx6D28XW8JZppzKKWKKqATbefc1aVGX2nDtfgCJBVpZ9o
7691	fee_transfer	1514	14	1	CkpZurEKcD6sNXTJhSK7zR45yYX3P8ryKtRMZFAauscqYFA2TqCMa
7697	coinbase	2302	720000000000	1	CkpYU65Qv77mnoYfYTP574Cm4HzDX1F3Xqdrb1YrqScdTiNuoQk2K
7698	fee_transfer	2302	23000000	1	CkpYqvNz5kqwLAv7SZRAVgTuGCWLgRsdaAP7pf7XYn1QLH2tqmdFk
7703	fee_transfer	1619	36000000	1	CkpZF7tgTg4XiQQaH6AYdv4s46XftodGoe16XftTqVQUutPJDjSAY
7705	fee_transfer	633	38000000	1	CkpZKtR5PyXJb9673YCdTGxPCqpXR9kT4QfyNSEWmsE22g8frMTE5
7718	fee_transfer	1594	32000000	1	CkpZWnvoeWq6gzLbvSBSvQBkp8R7pT9SU1SxFCWNuaZs5JMrLCTsn
7731	fee_transfer	1444	53000000	1	CkpZAFdnoNBifBgcn3VR3GLuJnJ9oThFzZPNfbxvABZyZuHy8dot2
7732	fee_transfer	1610	36000000	1	CkpZowWAUuzkSvuJ9VXWY8LeMP4cux2hM3eF5uPNLwExnCWEH1aug
7733	fee_transfer	2112	15000000	1	CkpZKprVSHbqwJpJtSzGxZxARcj5qwK5iEpZy4QCUg6dhdpcLayqG
7744	fee_transfer	1546	34000000	1	CkpZJs7ibvB3nnPZs8dvqB9mAbrYffzUm9DyXoxuwh9Sb2XB5Q787
7747	coinbase	1451	1440000000000	1	CkpYtNHivJXUT3x9b42SHRLYaRwFVMKAKZaw2o9MUMRvjF3QFb9hW
7748	fee_transfer	1573	2000000	1	CkpaKa1GpgNW9PXuafEMT7rB7x1HVZ9ctLqJ4uxPfPPfTM4CvgVPP
7763	fee_transfer_via_coinbase	2359	1000000000	1	CkpYsE6xdQ7E4QgCcySxWUHgB48MkJKkKsWySgn74JiB4LUSW2piR
7764	coinbase	1687	720000000000	1	CkpZ5mw4ZgdLLiSjBxgYgze5xBQFB6xg8i8EFKnmxjAeN46hunHWV
7769	fee_transfer	610	33009990	1	CkpaHGtPs3Et2y3Arnfdc5wZwVqzMLbX8S9iziUqyBGTviV5LhWLa
7775	fee_transfer	1546	33000000	1	CkpZu7aLSzJRCyLpinzn2iPq62pdJ2GVzestPVQWH7pgzmQFBHozr
7780	fee_transfer	1701	55000000	1	CkpYhyHcBm8L29owHWWLy7z3tjAYLJUNR5wqFiUVPhF8FXQmiuEHj
7781	fee_transfer	1686	55000000	1	CkpYXGGN8fisQYNRr86XtZsoABa9jPrjF4taxSBeGw3HSGLLgcTDG
7782	fee_transfer	1699	21000000	1	CkpZzj5YZ9JjLxMPgSB7kCxHMTBKvH6xA2WFW7to1c73okqhnxuYB
7783	fee_transfer	2087	21000000	1	CkpYpAnqWjHP6zKMpUqAx7fZN3biFz17rGQyeSbTqsQf5qkDKmaKM
7784	fee_transfer	2087	1000000	1	CkpYvH23wagiGFftjxQx3g8PZVbB31EjWXp4Jhbjo1nd4RXhy9yjR
7785	fee_transfer	2086	21000000	1	CkpZ2d9XnsyPN5vhfe819vuTmexSgrAeYW2Grmw44WZZ3cLy69jaZ
7786	fee_transfer	2086	1000000	1	CkpYsuP8bpD8V1vQ6fySZULLKEn4oCangKzn6cjwo49YVDPUwW8Lh
7787	fee_transfer	2039	43000000	1	CkpYmEAz4RRwcR93HNCxPtzyxoaVvxo8CoM8bccSbKTQRfL446WH3
7788	fee_transfer	1622	23000000	1	CkpaGotgo3BjfjwvNmM5XEJWhHM7CfRXAbEGh3FNZ5M8TpSqv4nsd
7789	fee_transfer	1536	15000000	1	CkpYgXPScy4mhg374UG93TAcJdqh6MnSPmHAkiJRQGdDFGz8dDH3H
7790	fee_transfer	344	48000000	1	CkpaKBgdGeEBLzCYJHTTrfGZCL1vF3LQ6jZLQsjQittHRCdu3btPo
7791	fee_transfer	2329	48000000	1	CkpZQQUYNdDyKsSvtE3TpTH42LKsTHH64ok5n2yBuADwsW1rQEr1A
7792	fee_transfer	1598	12000000	1	CkpYTJS5pNpNvbA5H2jrnk1hRfidBnUKkm7vs8FDoLfrSBGtnSzaQ
7793	fee_transfer	1560	460000000	1	CkpYjYf4PvBmzHsqsFhmdYPwBGCRBZwUdAsUuvvyvx9uakLxsU9SJ
7794	fee_transfer	1560	151000000	1	Ckpa22uEBZbQsVHqmUt5UCxYr25dQ1Tk25GNRM5jjbMHiAzXo5Bu1
7795	fee_transfer	1980	26000000	1	CkpZ6efgTfWJLe9A3RWz4jdmwTUkwm7eQxJymY7sazCtqSn8GuPTx
7796	fee_transfer	1654	247000000	1	CkpZWgffHjzkfLfkr7fyUbrriEqVLveq4iZwBoMBf6jZb1p6YDAZZ
7797	coinbase	1521	720000000000	1	CkpYZVP1RJmeaMhLDKMQTHXo9TodXdNPtXJdKCfc68UWjbR7w41vg
7798	fee_transfer_via_coinbase	2250	1000000	1	CkpZnr8N5cDR8w9QgAgtP2DmyENa6PzurQv79AA9XAvhZABDi3yej
7799	coinbase	1521	720000000000	1	CkpZozvRHBPWPLNdwiWH9mw4dBQghH12gNFZimvC8VgvSmQp4HCNb
7800	fee_transfer	498	12000000	1	CkpZqzGaMfjq9xvJELawQFx8353aGJ5GkZnX7eUs4hA2PamRPas4w
7801	fee_transfer	42	21000000	1	CkpZ7ViPW2S5D66oq6cdkbynsTUgVe7hp5gzRhjWbKat974UyAgpg
7802	fee_transfer	1634	21000000	1	CkpaD9zt9BH6n3po6ExnCKKvnNQ9nybHSTTSDzjJfYdc81LYymhVr
7803	fee_transfer	1634	3000000	1	CkpYhoaiwHSGjwSs26x8XLbwW9GsfPLk2hxXWdEMhic2NN1AkRsRT
7804	coinbase	2148	720000000000	1	CkpZya9Ydp1KnCyd1Xeu5eMUzzKKLo9aUik5vLdspNyhbQRyFcvxw
7805	fee_transfer	2329	30000000	1	CkpZEfMSKVNcvfUB4iLVm8KoaxoatiKFEkbaQo9jztnn7swGzFnVk
7806	fee_transfer	2329	6000000	1	CkpZgDpj9mAW4gkLhmg4uwz3AMRQHbLERd5boBFSqdTA4B1L8DX2t
7807	fee_transfer	1395	40500000	1	CkpZcdCPDTe1D4LQB5TKQYKiJsYtuPpM5mRwcGR3kVu5bDamcpMg2
7808	fee_transfer	1630	13000000	1	CkpZYudUJH3TnuUkBBscMRZjeByb5xiXWAXKnsphcoRqBX7xEzhhZ
7809	fee_transfer	1541	32000000	1	CkpZ3wWtM4T5dNzjf3MWyUFdy1zFxLneoHXbkJXBpLLWQs1XZ8eAc
7810	fee_transfer	610	34000000	1	CkpYZZqyAUXKfDEv2YLVgQSMxdkj5HkL3BR9kUSRNMtvHaQjWsZR9
7811	fee_transfer	1633	38000000	1	CkpZrvD8izDbHkZkQ17im4AaATQcV94nJeUo3dLMQFkvhbea3Kphw
7812	fee_transfer	529	22000000	1	CkpZH5EGYuMday9JbFqwj3nWpJJWed2utnnuh8U9KAuatn2TCHVr4
7813	fee_transfer	1423	38000000	1	CkpYSVJVWsicjxtuh5paHjVD38cAWMi9gCYxr59vSJAcL8d8fgPDn
7814	fee_transfer	1588	38000000	1	CkpZ6XXEDLqyF1U8umzSLDAM14MB9z8QzwMKUSPTwowy8xKj8xf5K
7815	fee_transfer	1395	38000000	1	Ckpa6Fgmrd8oGjCUT8DZxVw3Tsr6nJwKMbixMjctQKHKS26Qhq9Ns
7816	fee_transfer	1439	38000000	1	CkpZqrFu2vBTKRrhBMn8HnM58keyeyfRocvHXCP99kt8WwxyLGoCZ
7817	fee_transfer	1560	457000000	1	CkpYVk2v6Nez7cW9zX7D383zLwpD9X6byorzSvQshiyHMaUryfaZK
7818	fee_transfer	1675	26000000	1	CkpZGAv8L63MNAmZ3xCjhniyVvRetFCF4n32h6wEmj8bo2jaBbSta
7819	fee_transfer	2248	36000000	1	CkpZFiYsvHqe2NWGNRfXv8poTNPrpausR4JjMjKg3e2AoaWnBYMKU
7820	fee_transfer	1716	36000000	1	CkpZDKT5s3tnrgRwGHoPxmZvu3uAjfZp5wLJpKmUFvXwLGP1xaEtX
7821	fee_transfer_via_coinbase	1771	250000000	1	CkpZLEuKn2TdUBmtsac8LnyrLMbgNitQDPfrad8Md61vPmsnCXuio
7822	coinbase	1549	720000000000	1	CkpZ2TgCnWnJokUXNVxbWPgpU6iZwq96GfhLFbDiD1xwC9BrUpgr7
7823	fee_transfer	1705	14000000	1	CkpYyBf1Yt4eDkbr4neU4ev6oANeGQpimo7Rd5wBXZVHg7NaD8qRy
7824	fee_transfer	1560	235000000	1	CkpZu8VZumDUCCKaPLWyeLM7eGLA2P7Ubxp1xdNgpg31yr41aEaeF
7825	fee_transfer	1560	38000000	1	CkpZK3Mtq28v18xqw4JMTWc6zsnSWsCsTjkktrMuN3ahqy5Tn7RKU
7826	fee_transfer	1528	12000000	1	CkpYdkh6sHX2VxPUSrRbEKagUHjr647mdadLjzfc43CwPFqxgPNoK
7827	coinbase	1546	1440000000000	1	CkpZGvsRA42jvBa8rEWHxq5fSatBSrbAyy8EMJNd7L1qTCpDpVXMD
7828	fee_transfer	1564	230000000	1	CkpZdn9msHhTcbr7vBhJNfG6Da9PXc9DEtv1CHqNAiKnW6HT6P8KC
7829	fee_transfer	1564	1020000000	1	CkpZ4Brb7aFqKvf185cvzwCCGjdErRPkGavFz4gHZeDeZc6Wfhkvu
7836	fee_transfer	1623	91000000	1	CkpZ4FNKewejywMaEMqidm4ofySfSZHt72HrAE9ezyKfBXhVaWPzq
7841	fee_transfer	633	630000000	1	CkpaAHib15qjuBf8ictvaK5krfKEhvHVzZ5wt7coX7LiSPUjpPcsN
7842	fee_transfer	633	620000000	1	CkpZmcTv7yAwnvpuc6dDmqzvU9YRaYPVYgejf36weujyJzYeKLLuS
7843	fee_transfer	2329	21000000	1	Ckpa2XNAhKoiR8VJKgmaE9B7r3sDMsU91Z4wWZdhQESFSmYMYXCgZ
7848	fee_transfer	1657	2000000	1	CkpYpFJ9PWHBFfmXY73umkrbnJHkoTY5fyZV9b5THguQ8Qpr3nDPA
7851	fee_transfer	1668	28500000	1	CkpZZpo2N6Fu27MztjPVPRfJjmKBjCyzTqUMCnWS7cRTagNZdGgaN
7864	fee_transfer	2306	98000000	1	CkpYvEFURcrGJdy9KmztgccTtTj5vXeNkBaHdbmFp53srXJp4dgjt
7865	fee_transfer	1690	17000000	1	CkpYXfRvLbaF1oRPbyjTXUkCPw2kPExR87TbAvd57FMKPbSLPhyUw
7870	fee_transfer	1509	44000000	1	CkpZZGsYGPLjfFBm1E7C8qP7VwuUQSESgeUZ2uEG8VwEYgxDG7C1u
7871	fee_transfer	2148	44000000	1	CkpZ9YVsnpBQ27dGfDTcgP1my9qVvzAU8F2epd27Gr1bNAmUvQvyU
7873	fee_transfer	1724	35000000	1	CkpaAJa3t6FvNRxv2W3cXt97BCYU7wVQxFdft8ktc3j8pN1tmN3fb
7875	fee_transfer	1508	69000000	1	CkpZBGpnuaB8N9CPwdF42hufCb7gkgamz7j9bNLLu3ZbaRLKGE6v8
7876	coinbase	1508	720000000000	1	CkpZ7iWMhc5tSHGYXCEpq4einFYREk2vki4WmBr3ZLDiwrY9SQZ79
7882	fee_transfer	610	11000000	1	CkpZobjgE8HRzSZXL1XQ15kKKuyQJGKEEQ6nCiMQhcv7jnL6Gc1S4
7883	fee_transfer	1768	21000000	1	CkpYQvpp5U1tVRCtx4kGhhT9xsD4zhKHxiRhb2fVxwLEytpUbf5qs
7888	fee_transfer	519	11000000	1	CkpZpsqaJaB9TDZex8kbjbUrA5UJ9tUpxgf7WusjC17xU4i55f9zQ
7890	fee_transfer	1559	22000000	1	CkpZyGoWaTAqmkgsymuBfaMxowaWFVSoB5ZpxHPNtN7gtNQhTjhAX
7894	fee_transfer	1541	22000000	1	CkpYrz6jYVvW9yw3EhpRBgJzjy2t1pMZdbNj3t3St5jtpJ7k17mbU
7896	fee_transfer	641	16500000	1	CkpaGkmPTgP1y3WFKXXG17bCUfnw22wt8pPUGHyk2BYJCatpyiYtE
7898	fee_transfer	1402	36666670	1	CkpZEJLpBp8H35giW1yyNsDM6VzKGssTWhVVqe2UYK8wQiTTXc17S
7900	fee_transfer	1506	36666670	1	CkpaD81pjGUk7Cb7js4SVXm1vVVSQmLoXr4ByiCn9hpaaSVgmJEWK
7903	fee_transfer	1656	263000000	1	CkpaGDUhY33nh1PpJ2bpy8brN5Dswq18vWM3nYF8jrSXRgZmNWBMc
7909	fee_transfer	1513	33166670	1	CkpYcxuC2qyKe8K7EjpKeHABdwfubjcHpPUf5LjM3io1dep2iwBWk
7919	fee_transfer_via_coinbase	2052	10000000	1	CkpZY8SBKu8BdnDTBt3eYxxWM4GhgkDM5R4KHbp4wNs8LKHVeGGUp
7920	coinbase	1690	720000000000	1	CkpaJv9MYpyP4k2hTYQBJf7YQyUsJafuVyzvSgA5kScPBmf1JQNWv
7922	fee_transfer	1541	54000000	1	CkpYnuG3RbYu8aJXFnBpaSm7t3AMuh425LEgmSBSc2XGM8UEXqYfz
7940	fee_transfer	1593	33000000	1	CkpZ9sBXTvYC9RLwLwTUfM6RJG8MrY8iw1u37mvmzeuCWpsxA6diZ
7958	fee_transfer	1724	520000000	1	CkpYY49gY6fo1gKBVG3NVWgfQohcKE1RbmDEA5PvKGb5szDEcASCw
7959	fee_transfer	1724	730000000	1	CkpYQQBUhgFqcVf5Dsoq6gBWbbY8GEQvjBnFGzHwvjTa87xrYu7vE
7966	fee_transfer	1434	12000000	1	CkpZAnr2UEHyWpFGhgAx5TtHMrXDggRf5BtAppDNZCg5hxNVgRLhy
7967	fee_transfer	1709	122000000	1	Ckpa7ysuDAsYVkwirvUjvfBwesr5FBfWr777R34Z1VR7KGruwkw43
7968	coinbase	1709	720000000000	1	CkpYnAh3VcnzLqAQziJWfidwwEe187pY5TncPvi2nPaWag9LSTAMo
7969	fee_transfer	1482	24000000	1	Ckpa5CtErDxSSaNxn6iAzdaApv3KjeVhBfFJz6thyqQHmftnGUXHh
7981	fee_transfer	1991	2000000	1	CkpZPS1vkVbjZvEetXC4GbJswcE1uFppVBGYv1Gt9ff1n4wW9pLDF
7987	fee_transfer	1395	274000000	1	CkpZQBD9fidqSVFCzwpNattPsgyrzRitGUvi3oWVB4Zow6JNaa5uL
7996	fee_transfer	1877	12000000	1	CkpZW9XT9hjjLmfJkodm1gRVPwigvoeUKXkL69dNMi73TJftjCbh6
8002	fee_transfer	1564	35000000	1	CkpZmX1SWB6Z2XsTmGgismZBxKYvFEaRasyCvuUdws8cPEc3RnMCu
8006	fee_transfer	1633	48000000	1	CkpZivkqn7PxU92GcYH3gC2LkNKfRwzsa9qC8QRbkzoVKqQ3dcGsz
8009	fee_transfer	1633	37000000	1	CkpaB7RBSHTkH5u8MebpLyefao1D8FYh43T1qfUk1m9oUXFN9udwm
8015	fee_transfer	2086	2000000	1	Ckpa17zrQSE38FUMCf48FDejgHae8T8VyDbxCc7yFUVhKVqSriKRe
8019	fee_transfer	1576	285000000	1	CkpZESstEVkkF2McHKL3utYJUv49aFjUdAxnaLX8UAa3B2Nv1bgHE
8022	fee_transfer	1592	33000000	1	CkpZqcpmsNzXriraumyYF35VoD7GFerfY7YL7gpvym9au39msqV83
8023	fee_transfer	1592	2000000	1	CkpYjYQej28RCkHyeR4bNdTHC2oMJQGXhbFhfdaQNv7RtBCbjRuzR
8041	fee_transfer	1717	48000000	1	CkpYtAHyq5WqMcZdQ9bWpBeRve3jtha9nC4QYG9oHoBmQXwp97pkZ
8043	fee_transfer	1474	48000000	1	CkpYSYxsKEvghwYvErJtyYKPYqo9pwverDD1ppKkLPdKRUAfNYQuw
8044	fee_transfer	1691	730000000	1	CkpZbosdRmbWoNYUtJxCb2gjfRpu8UGfsrYjVFkcn9Pr19aoqBYQD
8045	fee_transfer	1691	610000000	1	CkpYcrbpQUdbPZnssoGfFxvu4tYZHc1WfpxLJKK4KXRH9ihRiRBtZ
8046	fee_transfer	1756	393000000	1	Ckpa8fBJ5Z12RmTrVxhN26HjmqfFVJEU3k9PX8bsg4DSqjZWrjvPi
8047	fee_transfer	1756	39000000	1	CkpZKW5d4V6JDEdfNZv4xjJfb6MUixZKTehpmrioTvG7HKnP3dKAN
8052	fee_transfer	2306	23000000	1	CkpaADj4TDYd6VLK7wsEWjox7dCtjS5T9hLLjkQAfLtG13ojvascV
8058	fee_transfer	1705	39000000	1	Ckpa5QWvFw1orhz8p5GzQDffjBmHjyR3UCmsHepF1ACAiZixr51Bq
8063	fee_transfer	1739	108000000	1	CkpaKTh9XPfAyifhDVbSYo8dAzJtJJ7dARaUf58jFyJ824tcjDCZJ
8067	fee_transfer	1587	19750000	1	CkpYsbKEV3hc6yvUxM7qxoiLUKxi2bgMwcxS3tYHUcAo8FjRY5oVV
8070	fee_transfer	1422	16937500	1	CkpZJzGN1REYubiJ1gZxxshUuZYqYtCgeeDHVCDDhHpffigPepyUU
8071	fee_transfer	1445	12000000	1	Ckpa6Q23kzdiAf2QFm2TUzLhiiwUjCkBjGEbRC1EwHJvebVsNB3hR
8072	fee_transfer	1768	50000000	1	Ckpa87ewF9ofm2Hu8kxBQx3LbhctPBbtZzxpcQRAGq9amfPuXiiBQ
8077	fee_transfer	1694	262000000	1	CkpZBM749A4bTXRvoD6f3ZeAXb3ZwiBzdGauJLJXTzjAt1sU4wkoJ
8086	fee_transfer	1622	47000000	1	CkpaJv3g7GnkKs4CSA2vkskpHD8i9PNFJSpqfyfd1PJ8XUqV6Gmt6
8091	fee_transfer	2329	4000000	1	CkpZVTkfqac62BzB2RueAZ3KsLTUyB5BoDdEtkrdWXKmZWx2caXjS
8093	fee_transfer	1695	38000000	1	CkpZMxNRSeBcqzL6pb11vv7Ed4b2jvZbkdeQXL7GmZLQc8D8YDqiH
8102	coinbase	1664	720000000000	1	CkpYuGhKzEDPNuA3mt2Gs3v3KQs4caisF1XHnZ7KB9zX2LRUZbTrS
8103	fee_transfer	1664	12000000	1	Ckpa9v7LWk9VWdSxuPMHzfX33RJWrrYTTVX7rxdmaKGuaRgx9yiUz
8112	fee_transfer	1436	12000000	1	CkpZsHHAPh27cvKi1AC2r9DB86Dvdg92FFHs2VSddtkYENM7FPQ5q
8114	fee_transfer	1668	111000000	1	CkpZAFUBbLrjYqs89f8vpsognVY1mXjbccpRiVXZrv19qVwRy4NpF
8122	fee_transfer	1402	38000000	1	CkpYZaRC1uUoz6bLmUaAFTwo3PBcGAKriGNaXyftCaRuXDUjJuj1x
8126	fee_transfer	470	136000000	1	CkpYRgximwWS2yLjeuURpuCidCYMAzLrq2XFkrjCoHjbW67mfr11j
8131	fee_transfer	1573	147000000	1	CkpZ4BqnMp9VHtTK1cYMEhUzPUWt3qXNJ7fKQfkv5qaGu4t7y889p
8132	fee_transfer	1573	18000000	1	CkpZrwqXHXgNUBWHbuLCVARCMq76CmAaw73t5ypbBZkPL5hXPtwbn
7830	fee_transfer	1520	60000000	1	CkpYvBJBRMwDkyJtYuJySWZ99bP5PCCTi78gATs81sfkfpXs3Kzpe
7831	fee_transfer	1622	55000000	1	CkpYuNz1yvKjUVkxXPETFFf3wBj4pcPXzaVgZFRRpBivfPZwU1Eoe
7833	fee_transfer	1520	5000000	1	CkpZvLJDmV8NAMpDzx6vjpiuY2K9ZEDYNpF9tnEJd4XP1onVXhXAY
7835	fee_transfer	1455	91000000	1	CkpaLcyuJcGEqHmdrQjr9YcUDbZLKN7PoteDzDmPpVXvj23JhUywh
7837	fee_transfer	2261	30000000	1	CkpYSy1BevVp6urYMmyTGi1i9969cELeRnF2MShiMwDTKCmmiPJv9
7838	fee_transfer	2261	7000000	1	CkpZXskHshoxZb2ffVT5pGCxCQQKSoP2V6fMigmtEwoGbxmxZpkXi
7839	fee_transfer	1604	100000	1	CkpZWGJEFBU3RfvRLpgff7JDfRMyh2okFeqTtUQkFH69RPMZkWhaT
7840	fee_transfer	2087	23900000	1	CkpZcAQWAfYu7rmADbTy53Aw1xQJieJJfjCPpKTE47kfEU52V7Hc9
7844	fee_transfer	1271	22000000	1	CkpYSXwWBuWpvHygLCFUJUQF8V8MhRVEaFshogyLLfirN9CnGugGH
7845	coinbase	1271	720000000000	1	CkpYawxShxA6fWrmWDbd7RQyRkQyJqc7FSxRitkzMeMPbx8w5HgLQ
7846	fee_transfer	697	999998	1	CkpZNTgmhfQaRUd51YdkRkNRqLnGvWUVTx5PCpTVm6wBWaQFNCQ2R
7847	fee_transfer	1271	2	1	CkpYemX5WyUbLsKadoPrZsSCxGKtVhbEy1eZ63dTd6A4e81KmBGWe
7849	fee_transfer	1599	21000000	1	CkpZySJSBPGor9wxAoNhNCTZavSC2zFbjvgHq8YvHjvuaU2vf8A3t
7853	fee_transfer	641	34000000	1	Ckpa4Ymdv9UHbqnT6z8WTfGNZaKXvwaXbzbnCnLJpqN8tGgTaSUJV
7854	fee_transfer	2221	100	1	CkpZPSUkPhUESgzwT3NwVUepQNniWXY7dKQDpkrNj7QS4MwkHgK6P
7855	fee_transfer	1509	10999900	1	CkpYTETMCNPRBbYYyC9MWCoS44Q9CwJ1Abx4PBwo9yNDLhaXhutV1
7866	fee_transfer	1532	12000000	1	CkpYs951Su8y22TFELhYtAhmwiYuAsM7HAEfrigGvh7hsqefLNkhB
7869	fee_transfer	1536	33000000	1	CkpZJ1cFp5kQMB6ZFFwHc8gguDxtQrpYKeM5jR4RgtivSsCAsr32o
7877	fee_transfer	623	11000000	1	CkpZa7ob5GzDZohLeew9hTeCxvXCoRWqA8JL4PaXRdUgR2qsMYSLQ
7880	fee_transfer	1506	21000000	1	CkpZrS1yVea69kHUvRPSFyfd7rjsMopxLV7m44XMLtoDSxqrJrEWM
7897	fee_transfer	1633	16500000	1	CkpZ8HYwNQYEoRgptJM8pKdPWdXGpzsnN56i7zSHbZomomJ73mD1Z
7899	fee_transfer	2307	36666670	1	CkpYgbiz6WqjPQ2CQiV3WYCo9CFaUdobeYTB9sULTzpBsY2AjGZK9
7902	fee_transfer	1462	14000000	1	CkpZ3WDdAL4n7zfJQT7trhaNmEDC3uHitPV6jWbXC4H8XJc8JgHh5
7904	fee_transfer	1703	263000000	1	CkpZfpGPgcHJMWdLdG58zETt2HBUzsLNJNjSyt2NvBe8xtTKFxUjD
7906	fee_transfer	1616	13000000	1	CkpYszw4HVQYCtBKgDumnAZ6PfowPeEbVyAQikayYT9Ad7jU4w3pX
7910	fee_transfer	1616	14000000	1	CkpZ3pPtBtxXjmawpg6cUkJzxeLU5daoDRZuCX6X8hcHF4fchCsx5
7912	fee_transfer	1711	36000000	1	CkpZwefc682h149mvGrcK7UAqCTJHAgNkm1sfWXnPGv6QzVgfXSUW
7921	fee_transfer	1751	23000000	1	CkpYS9thARigR9JPNSEJ4SzrCAcL185mxbh2B7wzRJbkfuNERHnMP
7931	fee_transfer	1619	48000000	1	CkpaHPPsZxL9kgCfyTfFqZtS6jGvpiWUwK4i5sKVEqrFsW7SaomLm
7932	fee_transfer	555	11000000	1	CkpYzEQE75Y7yKbCJ1Er12zDrXsoGbzhXubyLnbo6rynC5F1mTszg
7933	fee_transfer	1426	352000000	1	CkpYmYwYgARVtH5t8x383ZeD7mJBAKLTTFyyrVYoVPtD25KFURQdx
7934	fee_transfer	1426	7999715	1	CkpZnnZUxAb8AkPDRD5rMiP4E5Gzop3MPLpjFYnWaFKHfAaB8myBg
7935	fee_transfer	1855	100	1	CkpZCTgDzvLQUxTMwYinN2keiumTSX9Xs2EFPqXV3W4NKp5YXSnbw
7936	fee_transfer	2252	3000000	1	CkpZK7zygfydjBiNMWsMPeaNAUoPhkrmaS7NgiGDBkmw44j4r6x3j
7937	fee_transfer	1744	5000000	1	CkpYstwLSAPBHSgrq2TXxMySwTYzedsDy3d9nJNJyoF6yZxgdfQfC
7938	fee_transfer	1571	184	1	CkpZnCgeNLJHUeQrRfhKE8qAwC2CY8srYhRyVRgJRqyUzeXCJoMSW
7939	fee_transfer	1740	4000000	1	CkpZQFT2Kw2tFwh8bGEELeR6K4wtbP6JEyidPv7hcqxc2FJR4f5VZ
7942	fee_transfer	1740	5000000	1	CkpYT87QrSefqZcgZUJJ6XEFKbT4CK7zyZA6ByZKtDUJE4knrvL5m
7952	coinbase	1602	720000000000	1	CkpYmR5oLaronUtzQAxgD8DcMrG32JWgE2kMcjuzrCVhxuA38EFH7
7953	fee_transfer	1602	6000005	1	CkpZ9N21RubRGigSQEyLQswFrWhc68pT2wBng6DTuoPNVrdXPx3Et
7956	coinbase	1649	1440000000000	1	CkpZBfH4gDtVwn6QDZVTVTC6QeKEvwrbVFQZPskm2NoBWMm9MddJu
7957	fee_transfer	1716	2000000	1	Ckpa1q2nva7xaBpRpVMAveRvAZGUQCn4khr8cG2EbEDYi7iTfXCun
7962	fee_transfer	1746	16000000	1	CkpZzxMZM7Ayt2mrUXhqmrVkYPe69GQ5LsBfrV5FshBzrak485QVv
7971	fee_transfer	1532	67538460	1	CkpZXrASqPN8wA1NvbvS1D7KvSBSS9uibGYyXY64Jcf1TPVkyikSC
7976	fee_transfer	1455	182000000	1	CkpYkhNkAkUvw9mx6s2UVr7HdN6DW6oTctePxecoQVxakFQZgvXpX
7977	fee_transfer	1458	36000000	1	CkpZ9NgP9PUr2tE66SQi9m8Emsu11pQrrCZbs3TWph9YoTYin84tu
7986	fee_transfer	1402	274000000	1	CkpZrakwA6vfS7vdSotQYDo7S8tGXnaqmqF9JpbTNh2Cu3XXYhRGN
7988	fee_transfer	1471	681000000	1	Ckpa2jdw1635quws6TWvFpmL2CMCfPu95fxE212Qcf4HmqQZpMY1R
7990	fee_transfer	2329	254000000	1	CkpZPvgm7Dqx5wnhT9bXbHwBRMnfyHGLo1bwAXf64z9PcFSYA2gcZ
7993	fee_transfer	1522	34000000	1	CkpZ6th3bQe7wcJrEUF7PkKi7fqfQeZ6AExRJWk3PrF594fXcrsfC
7994	fee_transfer	369	36000000	1	CkpZ2XLh5yxcZDHUcPSGCbB8h7DMTB5ZngEL48TZAW4a93btWcvAr
7995	fee_transfer	2148	10000000	1	CkpZ5nyKooX47mHnqiQhDYRQWxHXPu3w4dWdBSadDThWKxUxjeNZJ
8003	fee_transfer	1684	971000000	1	CkpZf32ViWfaWr85AMy1HuTisBbJuxG7gd6VKNTWmW1LZMmnadoUR
8004	coinbase	132	720000000000	1	CkpaGeUew318GDHZR3fkd5JPv5wXoUhgr778kqRpxUZ6XXUJtc6on
8005	fee_transfer	132	369000000	1	CkpaGXxB9hPCGHVcDkvQ1Czj2q6ETkgTQZYmop4a3zKoMNTHFW7Ug
8010	fee_transfer	1601	36000000	1	CkpZi9N3cZ4w6uVyWD3rRUbgn8xbQcPgp1S3seTZv39rCsqaqmran
8011	fee_transfer	1740	446000000	1	CkpYyYhp7dNuGKzxB7tuxmvVfMDovANTLVxLDEg4UhSwkpQrSaZfV
8012	fee_transfer	1740	12999998	1	CkpZkX7wykzUkwJjPn8814AKcYWBKqC8Ld9eYe5ekSWqoDL7rz6hn
8013	fee_transfer	1449	2	1	CkpZvxFgQXmuQdac75S37fgfDu6kQi4UcAjFXifpwZ4zCteZtBm7S
8017	fee_transfer	1546	32000000	1	CkpZRfxQ5LTVMyQrd6JHtFcW7ZLCSVsM8zUrA5ekRtXU3ap4kgcXE
8018	fee_transfer	1668	35000000	1	CkpYmGyxQctjnLEa2QHTE5aqPjeFpX5kF57fR7zAJLx3EFkqqyRWk
8021	fee_transfer	1576	216000000	1	CkpZAiQo78Ksyf9DKkzDz51mEkkSMezvJVsAAFK4Y1KoPYRB5NZPk
8025	fee_transfer	1746	15000000	1	Ckpa8Vn29dKBUhtSV34MaPoeSaqvuzN9Jv1TsyJ8iEhDfeE2n8TRh
8035	fee_transfer	1613	11999972	1	CkpZzACNKrcRSyU5Kq71s7GG6KxeTwkVcP9Vvc22CNEThpF9DWHm4
8036	fee_transfer	1807	28	1	CkpYgN4jStTaRBsijMVTuhHtoVJgpPbDAmpBSCYRiJUgyms4RNcM3
8038	fee_transfer	1623	48000000	1	CkpYWWgKdP2ZvmkVfK6Ru4hgtPWt2HywaT397Cj2ZUZ7k5TGMrpQR
8039	fee_transfer	1739	41000000	1	Ckpa2NazFeNEeayMRWMVTWvjJe2d1ABZk6nZmx6N8282SCcL7RNKm
8049	coinbase	1471	720000000000	1	CkpZTrPd9qnRrXy9Sbuf2DSA5pkUpv4JXko8KtAyVNRgKMMXEZh6W
8050	fee_transfer	1471	1999830	1	CkpYhDKFTbEfxYM5g4SnUTtFk8Y6vk1bmj8f8PegoiYttxxJPMui6
8051	fee_transfer	45	170	1	CkpYUJz7UgmsjrtcppcNgHCEsiQ5ncBo6b9fbjUq7usZFUzD8G4vG
7832	fee_transfer	1622	60000000	1	CkpYo8Xpoz3dGmjLdW23Lp1fHo8hX6kce1wfGJePik8Sdjo9uNuGa
7834	fee_transfer	632	91000000	1	CkpZCbrPGdzm5J7RAp3DYaftCv3zgQMTs4XLKezC9WmFGC3iYcHJK
7850	fee_transfer	1751	11000000	1	CkpZnsaxSn94KfKqYVeLzr3EcXgokoBEggW4uaqyBgsi9j5ZKWo9r
7852	fee_transfer	1420	12000000	1	CkpZxs41THvzyD4M666pPcaaSWHjxKpgia8cp6Hb48WeMb57ucRKy
7856	fee_transfer_via_coinbase	2348	100	1	CkpZTRzX9HuusNYE57YSSa51qjYwxyCX1FzjgC22EuvVPiaLoXBKN
7857	coinbase	1513	720000000000	1	CkpZxin51gbLrXyanckpEH5MvekBwZQGjqc1usYXA4xTjBmpPEySo
7858	fee_transfer	1513	53400000	1	Ckpa3iFL2EwJZxaqWeisrDJX2cigcxocKaNuW7rF8mYVqCh4feciW
7859	fee_transfer	1604	600000	1	CkpZapfHVQsYEnvX5WF5diuWC3w8ewG7AH315FFbwtRbJLCZujr9z
7860	fee_transfer	484	23000000	1	CkpYZjYz3FzaPtfgLzxhp4NsWM7nb71icjjCpfy49kCRBorwkqfNF
7861	fee_transfer	1526	11000000	1	CkpZkMtvfwpWFfBfzw9XMeBtcmFfgnQnnEQk4DAfzRD5Rj3Vvnipn
7862	coinbase	188	720000000000	1	CkpZv4SX1tsjs7UKzjRHd7Bm462ACMo2N6fdFLWyhPvCUEN5Xrffg
7863	fee_transfer	188	11000000	1	CkpZk9Mnhk8yJe5Qm24j2Z2HFkU6zxUTGvAK1uDAMcv22ndd3PFyj
7867	fee_transfer	1698	261000000	1	CkpZP77oiAWZK7zRFhnkPc3YRGrnNcqy58g5KM2govi6FrAXogWDU
7868	fee_transfer	1685	31000000	1	CkpZshLX6Kh18LyFgotPGEZc8oahnRg5ohv3eW21j5QDQBn6DNYzn
7872	fee_transfer	1696	35000000	1	Ckpa8CEc2NWfGqR94H58SQ7EXU1M5on9Hwt5PSas4h1N1zQymibGW
7874	coinbase	1509	1440000000000	1	Ckpa11TaxDRH51MFWee2BepF8KzwJ9MPs49AQgE8mDwYKeiGgfdWy
7878	fee_transfer	1700	43000000	1	CkpZse3xuPDjodpN79sK2zWtudDM533fmSeuD7H3pCdv7Bi4hGvHz
7879	fee_transfer	2307	21000000	1	CkpYtMkEgvBQbP2Yqy3AeNB8n8hRZqdpHAa1DYKfZqbnjdaCf44m9
7881	coinbase	1696	1440000000000	1	CkpZTt5JKgikaWSYYTCckvnm2ddGySo7gRjYVuzYjdujsH5Q2t8BZ
7884	fee_transfer	1608	21000000	1	CkpYuEsEjJGWwCpxnX2u54eCtQJAbtT318fkt8YkyxJurAoURPSHQ
7885	fee_transfer	1509	190000000	1	CkpYoGD7Y5V8ZHw6vP1TFfHaPTyAMWJ1LgYsK4RXnVHKcJhuEZzfu
7886	fee_transfer	1509	48000000	1	CkpaFoL2ihyLyxPgknPFw4Ga2Fz19Z51ZJEDGsv2DB8PKyuVAU7HN
7887	fee_transfer	42	32000000	1	CkpZHD1rNj23TebUN8LqYCJ1R8fM4kbXPzXQjiiF7FDVHzoBqvaqF
7889	fee_transfer	1559	27500000	1	CkpZsLpe3TreMw5JKBQgxGtkT8kGioDCb4vEHfwajpkb4s4n1FcrH
7891	fee_transfer	1693	203500000	1	CkpYx9zqBFk85JxYxEgcEthQb2NP8kV37asAu4V5x9TvuVLeRW3Td
7892	fee_transfer	1513	86000000	1	CkpaEiNM9svpGUgcYntztYJo1jVdNQHxtH2TPYkdpeQ18z9AaLsue
7893	fee_transfer	1656	27500000	1	CkpZPv28qvX2kLq7CJtv7Tkc16SKbRTGZmC2HAuj22GzdkGmxD6uh
7895	fee_transfer	610	22000000	1	CkpYaYJafN1X2hpPexfYFHMXpYJSjDaK8gEXDvDG2PXvU9FqPW6cS
7901	fee_transfer	1426	73166670	1	CkpZEEZB9rcGQBiBpRq8P6y9jYs1bydCCTimvxoBnnKKBCeUbrWKb
7905	fee_transfer	1702	263000000	1	CkpYnAXiNoiNzGU5TNKdFJaVYs661QL77rXJXcGkmhSyj3CdRE5SQ
7907	fee_transfer	1395	275000000	1	CkpZicrnpMh1g3N1DtvtQMU64L1zUipLK8wCdoNbJS6Wm5An7vgbN
7908	fee_transfer	2329	1000000	1	CkpZPQhK9hpbjkhMWQafhmWBGYbQkzbPL4k62KNUSxAu8ZfXQFhZp
7911	fee_transfer	1700	36000000	1	CkpZKcRX3TRL5Kzk1QN9po2i4KJqnxXNpLqEsxKVYEc4rpq32aZfb
7913	fee_transfer	1690	16666670	1	Ckpa6L2SrrR7AEtNrWxifTtPrJHw1CVA64WKzN5UUNHK98ki2g5pV
7914	fee_transfer	1604	1200000	1	CkpZRnV7537HW78hDdiaY4zMgxwoM8MWD9ijGB1Qoi6v93z6feZos
7915	fee_transfer	1964	3	1	CkpYdwieYXadJAUgAeTuU2rwr326Cz9GvzH3r6eb5AFUvQk44iMpv
7916	fee_transfer	1690	1799992	1	CkpYsReXft4oYFkJ7zgD8wZ5rkrBt8CnR7ZQqbxeiSUhjneGa1d9U
7917	fee_transfer	1610	561000000	1	CkpZqBE5dwFgSDSGUxJ6ypmsfS3VZxzxttGGFXJrM3GfHUtAYgDK7
7918	fee_transfer	1610	295000000	1	CkpYWyxK1WQ6fKCZ6VkUP5AGwseFGvVX34pa4RErUqcNwvenzwtA6
7923	fee_transfer	610	54000000	1	CkpZj8uJAzbbvzMYxA7kG6bTeXTGoDhCoLtEcp8dJaEpKB8AYa6eG
7924	fee_transfer	1718	54000000	1	CkpZAc1xW52LB2YkMn5tzdR6EnDh6dtaxRt7AN1sx6fTdpZgTA7UH
7925	fee_transfer	1740	62000000	1	CkpaErAxgwiYAmpMR15ew9hWtizHpBNzkYNy1oZGyCPQQccQc8De6
7926	fee_transfer	2349	10000000	1	CkpZNJVVX4vQpf1zw9RrYUbfCTBvDGpNWURT7WyLYtf3MUcx5xMhb
7927	fee_transfer	1604	2400000	1	CkpYrH1iXSLt81zEwyLJ7BYdGYt93n8wHL8rQKVam1EpcUbkTZfxv
7928	fee_transfer	2052	20000000	1	CkpZdNdMW1mmbRrpjB3cADSJ6N4kosNyVVQWGwxHLJyfAbT2How7R
7929	fee_transfer	697	5499989	1	CkpaHr4SEyYXAH9gBf275AuDUXPP5qmDv7BK17yAbXSBh8EaZL7bC
7930	fee_transfer	1690	2099916	1	Ckpa1jm85ZqtWQbW7Ttbs2qsGKYvkU47cPa9kPKxeXsYoBvFaqgSY
7941	fee_transfer	1719	33000000	1	CkpYrqqXJ6kxYWfoPTh91df4W4hGgvXcs1JWn3wqPhTuS1QhHznky
7943	fee_transfer	1623	118166670	1	CkpZC7d6nvkph3rs5RfjYbv3PLbzbqPGja49fdy8kwbAUCTeRU71e
7944	fee_transfer	2252	3300000	1	CkpZPktpEEY4v8xM3BfEq7GGkKTbVDh6oSNxmzKjsXSwNtwiqh7hg
7945	fee_transfer	1623	282699875	1	CkpYRJ2LbdGMjBaHChXER4YBpWfz6t4DjYEWg5pbDH533LR2nL5fC
7946	fee_transfer	1610	646000000	1	CkpYWz5PPNqDzHZf826eP1CupdFqCcGWLjx1nRUhPADM7C1FZxSVc
7947	fee_transfer	1610	39000000	1	CkpZWCjJTwk3dbhzrpAuV268SZNS3eHXvqG5YCH1VymDQd27zERLr
7948	coinbase	1687	720000000000	1	CkpZ6dto2AC48AUVSJz3Chn6Ts9HKokCEwRSA8u8PqSyCutaYu6bF
7949	fee_transfer	2252	200000	1	CkpZZMiSya6DYLx9KpFjKwnekiSrdWvqGoUrtXRXcEXmhQ4xrRPJx
7950	fee_transfer	1687	799984	1	CkpYo7ABXdMVwVakRj4sLqaWsbwqN3uyQFWMTwW2D9tLwEbmG87MT
7951	fee_transfer	2004	27	1	CkpZCQST4HdinYJ42LQP7Ydpsj5wba2aF8BBmZgkHbHJToCkst641
7954	fee_transfer_via_coinbase	2064	717000000000	1	CkpYfoA6XcEDPmycVtCfJVVbJkQRryCh9PSdCQHqUQDg6tLCEv6Jw
7955	coinbase	1489	720000000000	1	CkpYu1qzJ6pGVavYvyN84DR3QkihXCi5ArGraNjWo62vnofZWMAA9
7960	fee_transfer	2292	10000000	1	CkpZicLDH8fEJqYa6LtN3HHc3KNUiTgpRQh5nmb7bPnxNuPkTLaCz
7961	fee_transfer	2292	16000000	1	CkpaDhKnNGyKqV47QNTtj8cL9gpsbwjDa5v35gH9S5v1MLyidHKeq
7963	fee_transfer	1650	35000000	1	CkpZjoXfqFDLmpx4UciKwDuTZZxpe59wtVLVimb4MzLBmeN8iPykP
7964	fee_transfer	1559	23000000	1	CkpZgjFUWGFWRCwyDWbrVCzfoVCE2zNDqmqHVozoUGYd1XTArd2DH
7965	fee_transfer	1489	3000000	1	CkpZEXTePHXukRipAq4G9ycKDv3sgZy51Gux4UZ6nZF5UP53Svg6V
7970	fee_transfer	1540	24000000	1	CkpZNTmd6xS3Lg5HTdbCJDyHZhvS5ey7eLM15QJ7hgoEYw5ToBS6X
7972	fee_transfer	1395	67538460	1	CkpZuGW53FdTjmTbuZ1FjCkx7GqRJamg1uDokrL9f1zZz8DKW9Dq6
7973	fee_transfer	1692	67538460	1	CkpZxSotpfmYVV7VYKZ1f5S6q1ooF52qcrjoj1cn5YcWRPrnDw7oN
7974	fee_transfer_via_coinbase	1813	20000000	1	CkpZiEHPSBjFgSwb6qJV6VVHCn55tPUYXYfc7N92ma7uWDSfySXAd
7975	coinbase	1394	1440000000000	1	CkpZGesmptCUYtazzX9W66PqtVx1cjdd2yCa14wRrRL3pXU69UP7k
7978	fee_transfer	1650	233000000	1	CkpZSZJDZLey2VKP8DYNa2bPD2JQq2EmP2YFDXMFH3dHsFgBRWET1
7979	fee_transfer	1650	19000000	1	CkpYzi3uH6XCDFKMg4nAdjdA8jddu4bQckGmzDHCVfXRRkyEB29bi
7983	fee_transfer	2307	23000000	1	CkpZ8b7H5opHgRumLrtpNNkseXaBtWiGwDCPzChxoq2pKmG86r3VN
7989	fee_transfer	1471	11999991	1	CkpYSGzFAR8ZesAjdZipqsVXjn9vmozMpXKWCHSrzLVcNMu3sQMj3
7997	fee_transfer	1724	33000000	1	CkpYnXirPhLKJdzjzvSBTgwh67BhWAWZGrYPuJQHAukFcxiXUBs78
8000	fee_transfer	1611	748000000	1	CkpZnVRbHcG7LqfVmPZAAhvHKhsmEHFxjja8ZF37RB7Zp92StTTS2
8001	fee_transfer	1611	52000000	1	CkpZna3dZPsp3kqsiwJ2i44BV9kWTyQtmF9RwU5P3tsrfMDMx4Bxm
8007	fee_transfer	1455	1270000000	1	CkpZr6KZWLRHfZzwW6bSAtyQMeudNjgk6g9Ks6jd9vfJA8Fs44Fof
8008	fee_transfer	1455	220000000	1	CkpZ3Us3cYf7vna4NdZNx7ZGwSbk4typ9ZPeg4zk4srxJ7hVqGYjf
8014	fee_transfer	1455	493000000	1	CkpZRsFTeBgjx7ucCYE7BVHAdFtfxRDcMq2JMuh4unqpon6jR6p9p
8024	coinbase	606	720000000000	1	CkpZtmvdS1M5hBW3gZpBuEonCzw6LVpLZqxz3NPSpq4v9ME2NmjCP
8026	coinbase	1747	720000000000	1	CkpYiufBL4jxcpQEvRMLD222TQTuKbv9w1T3ZdEYAAW83ja77vKMD
8027	fee_transfer	1604	200000	1	CkpYfD8pSSaUdqz7J3M5fSWUK6GfzqcEzgzU9uYkK99h3vFTpDbZ2
8028	fee_transfer	1747	14599984	1	CkpYyVsyGs3Mf7To4zqyXxNEYPG31LPwyexF1W4UkqsgegLkSnZWS
8029	fee_transfer	1807	16	1	CkpZT81zieGZeiXUSpyebqTG4zmjp4obCWY5NRC5s2mnJXy3MFzhg
8031	fee_transfer	1513	542000000	1	CkpZgXz4BCf1xqoypK9xenhr8dYULjWpoTUkAA9yuj6pe1cd43odc
8032	fee_transfer	1513	42000000	1	CkpYy79HcLA4KuekBorGxUzZkDrvxJA9Moyx2W1znUrBE26Qh1U4J
8042	fee_transfer	1455	200000000	1	CkpYeCsp4NMgCnzqubX3ViUx1VrCWiYSQvjKXdu4ESeZKUNBjSJ1Z
8065	coinbase	1991	720000000000	1	CkpZubbobe6uNyFE6vpVyrJp51cwSqS7UFr4s775Q52mgoHKQ8fzE
8069	fee_transfer	1710	19750000	1	CkpZJzeTxCuacU53TeFSQ4y1ViKanJqy82AXkJfpAyGy2CHy5LUyW
8073	fee_transfer	1395	50000000	1	CkpYr9LUBGH4eU9B5Qcm1Su6xawS9sMBjHNkFYnTxKWv7FrAEV6a5
8074	fee_transfer	1698	213000000	1	CkpYZ6PvRTqMU8YdDTp2eRybFah2dsomgXjikorCv6GZFbduWTBQE
8078	fee_transfer	42	29500000	1	CkpYtFAagYPjbn4qkfa2vYFbyPnAcDb7LGEoBmDirwjfNmiySbM6w
8080	fee_transfer	1718	29500000	1	CkpZT11PbmwQGsgRruk325B5rQXFuKFDHWExWEGMSWVEKwLUjbQf1
8085	fee_transfer	1596	34000000	1	CkpZE1Z3fMBKPeaTv6gkCJESAiabpE6vr6HHsg2ktBDA6DwSoBqo9
8088	fee_transfer	641	47000000	1	CkpZCZb4VAsQueS9yoTx3Wvhf3crTVeXtj7D9cnaw47q4GRnjQWPA
8089	fee_transfer	1611	25000000	1	Ckpa5M57aG2BU31XRwYRuLsktZ8N1aybeE34wGbLsBNCDQ4hTqGbq
8094	fee_transfer	1608	1450000000	1	CkpaBVrEcXYSHypM31vGuMrFKVPH6nDPSyffLF6cAH95rwjdj5Dkj
8095	fee_transfer	1723	26000000	1	CkpYvuH6vrxo1hN7bNARqTNYPvbf1EERb2p2VS8kcdNHaotr4KYX1
8096	fee_transfer	1513	1340000000	1	CkpZbhe5L5Hczq9cgfRXoaWhFNoSc69YJgeVcF8fZ6EQdBxEjd2R4
8097	fee_transfer	1513	420000000	1	CkpZLzwvWwMt7NVkSDFdMGivhx4oKn3FUomF7mt6FSa6EL6vzexcQ
8098	fee_transfer	2384	15000000	1	CkpZ3Q4Q2KcLwRYWx1pJZDTACCeyeFumX4u8VYxzkpAEZvuqCgwf4
8104	fee_transfer	1599	56000000	1	CkpZndj3L15AAyNZK5d3vSYRwF3bdUhyeNvruWEsQnsH6ftCfnQk9
8107	fee_transfer	1693	48000000	1	CkpZK7BsnXecKB4JiJWyic9YrYoKyDYcnWj4mNqzyfLYrTYjJSs7s
8117	fee_transfer	1654	45000000	1	CkpZufby6NfLt5bKZ4MFW9GAtcFN8SF6gGwFVYFE6xJtcrKg1gaFu
8120	fee_transfer	1692	26250000	1	CkpZLgtjknGS1a8NqUtRKPW1XzAF2jd4SVPqTDm7aeLPyw2frujyj
8123	fee_transfer	1690	38000000	1	CkpYtqtVqix1ct1LWb3Yb72uQmwCfj4fk4CyUxtHrYh6gkUFoFwFv
8135	fee_transfer	2329	32000000	1	CkpZvYb3ewf4UoMhxkH6Rtb1gD88S7AXfJKTFLHYan5m82uviD6B1
8148	fee_transfer	1688	129000000	1	CkpaGMXmw2Yug7exfnyNaFHZAfcWEn8rGwqge7bZKwJqvM4vjUGZq
8150	fee_transfer	1633	129000000	1	CkpZ6PafCRAbRfR3CehPkotPuS8Pm3bTrSpzNktCy5E996zuXijCN
8156	fee_transfer	2261	3000000	1	CkpYXWyosur5DeZUqupm7wu2KJH5bSVCqAbkLU5J3ndgsm3s5ZUBK
8158	fee_transfer	1509	18000000	1	CkpaJ4Xw7Z7GZi3kof77WFZmgQG2AJsoeHEk3MZ8aoW4o1oyoot5w
8161	fee_transfer	2329	16000000	1	CkpZ2tTBBDcywGR39Ke4fdjpkznSFQseMhRfR99XdxgRP8rD4H5Vc
8168	fee_transfer	1439	18000000	1	CkpZn6LhnwGgm7KgFVzB4cQ6atsMpYb6HnU3C3yuLEtgwCB5BpetZ
8170	fee_transfer	1980	39000000	1	CkpZbkR38uiantZQ2EY4N5kTshVNApVwRW4zNQgbH5C4SDm84Pz35
8176	fee_transfer	1444	64000000	1	CkpYusBPBJ85mJ5uZk7tstZRrFVworSW3jFmU2i2MPeWF73DENFJr
8188	fee_transfer	2261	43000000	1	CkpZrAjHPBMiNoCZ6s9HWH55UXdSwidZxCoqUjzwRUqMyNBLoiTQF
8193	fee_transfer	1703	14000000	1	CkpYjytkThpDwu4fMVpvghRuSG9JhSSanZRytMhiyEXC4Snj6VPjF
8206	fee_transfer	1733	23000000	1	CkpaDGD7srWc5GArXgUfYXbZJtqzW7CeYTbUXZpyBcUUk5odQY48r
8217	fee_transfer	1623	48999992	1	CkpYmYKbA8JZhqi11cuB2ru7gSg2SqfEPnT7bonNaduW1niarMmjj
8219	fee_transfer	2367	400	1	CkpZ5Ct4nuzTpBcQaUVB3tRaQVGqbkqfvBeNwHGeo5bQv1SBFkHn8
8220	fee_transfer	2221	30000	1	CkpYq5fc1c29BiJ9zAhAth5kYwK8aLufhufspMDgxxi2iS5Atuhoz
8221	fee_transfer	2126	75000	1	CkpZ9axZTroyEFtbat8aS3GxjPC1MsYdDZQtbJwp54AZU89cXGJCZ
8222	fee_transfer	1964	6	1	CkpZzkkqg3oHP9gMzFsrHnPTUj3pjq5q6UWZjSG4iGFRCZCvYTvLM
8223	fee_transfer	1419	9864941	1	CkpYYTQV6d3NDkzWkPbd4tVZLDCBBxWn7x1No3q2m9PG2pY1kf2u1
8224	fee_transfer	2332	300	1	CkpZW8BgFAY7XdPEypFPitLsJTYo1LeBidXQxtGxpUDdpds5yxUwj
8225	fee_transfer	2004	4200	1	CkpYec19JfbAfybxe9LwXbCFuSX6WW4tHG2gUhZkK15S8eZ6jRGxG
8229	fee_transfer	1650	9864941	1	Ckpa7ec3UBa4icTBNmZvzsUQES8xZFjLfJLq2UiyZ3abGyJQ5bsCN
8234	fee_transfer	1714	95000000	1	CkpYQX2vz9dxj62jJVTrvbg1KkdCY43ShXPviak9VhfAcwaKcBP2c
8235	fee_transfer	1796	5	1	CkpZAusD9e5v5FQyRmaC8e5Mb33V6bZUzjabxVzSbK912hBWfXBFU
8236	fee_transfer	2221	20000	1	CkpYjD4Wb2KQDBnMNGURqv4etKLKpH4fKQrDYGzLSMMboUtJhdW7S
8237	fee_transfer	2126	250000	1	CkpYWKcUtSYDYnkUmWp1McCGxTZr72DCyckj1mLdkA1JLd3kDfh8R
8238	fee_transfer	1714	9725363	1	CkpYZ3gDDhfNHqx7ZLGrqGv8ekPD3zDjFnF2NfRJFLtqVvMNb1PAb
8239	fee_transfer	2332	400	1	CkpYbvsgxXRSFZqedBPW5gvNQ42HcC4SNoee12py9c42nqxq8RKgx
8248	fee_transfer	1622	18000000	1	CkpZJcL1z9fHCq9XcVj6sHyMcTMxqBvyUrTJtVzm1HjDf1bFLTXBR
8260	fee_transfer	1698	28000000	1	CkpZr2TNw768uvAbrKqfyGRCLsCTuGABS6aSAuYY8HX7iFy2ayZMj
8269	fee_transfer	2367	600	1	CkpaCQfymjS6jTQHRScaDAU2GHeMdLKtASsMTrGARQuGgar3UVw68
8270	fee_transfer	1688	16589800	1	Ckpa9V8HDnDuqzDi5dczwwhJuoPruH5bkySTp2xaaGpUGNLNwTXEq
8271	fee_transfer	2126	200000	1	Ckpa3XWn2RYcs8veo7vCY7kJLFG8QU7R3yEZ2xUqBk31zqqWrwPbW
8272	fee_transfer	1571	80	1	CkpZLVBPtyyfxAhgL3jaanHGq9LrXkWvTioUNiosGEvsCzNzeMbqe
8275	fee_transfer	55	14000000	1	CkpYR4wWr1qWF3QkyUZ3ZvRoLaGW9mPHXMawgmrHFXYhfs4PQ9kUz
7980	fee_transfer	1700	6000000	1	CkpZQVj4U3sPh5hcZnNGrrEjhGiJV93gGSf9A75Bq47NV37EUDdGM
7982	fee_transfer	43	3000000	1	CkpZMWAFy1BFybMmW4MfhweVC7F7N3iSLc1k8x8nYc7FyjyE3KVQJ
7984	fee_transfer	1711	37000000	1	CkpZkrneyAvbUzRqKv1QcMRid6LECcgLD9Pxb5eyqdAgZbaoymYWa
7985	fee_transfer	1708	17857140	1	CkpZ3dJRH5LMTro1tccEMU4L4seSMkWvLVUuPJCPz8NEvcfBNiyxR
7991	fee_transfer	1659	13000000	1	CkpZ3JMygAS7JmK3FZRoZrSxvzWSCDZKG5RmLgx4K4HmFChkjdS4N
7992	fee_transfer	1547	124000000	1	CkpZMLjMt2vskNmpfvSmfmeZjFg6tvWgH7LorsKmHPv223hB757qv
7998	fee_transfer	606	250000000	1	CkpaLbomNCE3WjLU9J28kr2zN2SsKSTuqmp2XRZGGbcLNggxW7cNH
7999	fee_transfer	606	73538460	1	CkpZSt3Kj6E2jPCquTHahgWJAMz9myLyce89vYC528QboGPNcuPsc
8016	fee_transfer	2087	2000000	1	CkpZZeGCQVeLtGnLC4a7knGabKV5BsX7jqRdTLoPogfmjsmSVgTEZ
8020	fee_transfer	1576	11000000	1	CkpZ2ZVMEjhyokPso4NUnqVGzAkQcyMdaYyPzk84gq2UZe5ayMgnb
8030	fee_transfer	2292	15000000	1	CkpZn6kTrPX4x1UDGUeXkELUfjS377hq5fr8KfFQjyBJxP457tMqY
8033	fee_transfer_via_coinbase	2330	1000000000	1	CkpYkkdW6r5J58L33k3VRyUGUwZvNNjLHME29bNXfLzuPuYXiaMN3
8034	coinbase	1611	720000000000	1	CkpYyWNN1sk82MfQAE555xJbxzfNL7whB61mZm1WuKmucDxMuekJU
8037	fee_transfer	1679	48000000	1	CkpZenkF6bCaejxYSRqACq6VqG7E7eXovL9PVwb9m5Q4qPKT34wQG
8040	fee_transfer	303	22000000	1	CkpZ2JvawPH8Q8GKQvDJmMHYxhCFKxouMvGZs3q8oBvUgZ48hMBsK
8048	fee_transfer	1471	1999879	1	CkpYoJVe6z6r7e1vx7LM4qV6K9UGYRA8Lsbu8g47xi3FEmVLvstzD
8053	fee_transfer	519	13000000	1	CkpZNYVREjdBKQ6C2mED1bYqPmmWY1KWrgjsxdv2NZJL7DLe5aKz1
8054	fee_transfer	1691	640000000	1	CkpZRufXsJHEwjiF3d861uPHfXZR4YWUhRrtAWuGDzFcUYNjFGGBX
8055	fee_transfer	1691	295000000	1	CkpaADK4HsUsWr9KqKMoAtMLE7j3FEzxf48mh15uUfs3HHpKxTjco
8057	fee_transfer	1419	35999999	1	CkpaEgZZGo4TWEUqDvQTVm8RAUvLARcqawQYvCicno1Tyk8AgAMzo
8060	fee_transfer	1756	788000000	1	CkpZw8HkqwNgqKm6F91NACP1ArWo3GZyS2jWN8a1W9RovqxjF27Q5
8068	fee_transfer	1692	19750000	1	CkpZDSbAJDCgVss7eUyTHpqznP2FyEgEh1msrTgjeQA3rckj8N18N
8075	fee_transfer	2329	36000000	1	CkpZxkUrBzx74FHaQZyTGWAEHJFureccBA5QzBGy97RoF272cNR6N
8076	fee_transfer	1564	262000000	1	CkpYb2oTr9hab63822nPTwA2DX8xTwtMMdTRis3At73iTSNZsewmP
8082	fee_transfer	1705	44000000	1	CkpYYTzwYgffARZzCpYweaa9VETgSnKNPnunHhZph8ceCxY7SQCbK
8084	fee_transfer	2329	38000000	1	CkpYqRD336aMKnhj1Xmc4dwqtMjmPrBtnwcrQhnpUJxdPQYpp4ewB
8087	fee_transfer	606	47000000	1	CkpYcaDuaPAMZbn5ZQ8iWpvQWB5YPMTzyvjxF81i3vJfi4MJg18E4
8092	fee_transfer	1672	4000000	1	CkpZCTxLDJS7ZG8YPrwbCBWsCCJtqddZBNH3eqwZACk4tWzomd3vJ
8099	fee_transfer	1710	346000000	1	CkpZm3tvVZKMrSBKJSLuxCaQd6x1NBq2dGkjhLqr6RmGJww7k54QF
8100	fee_transfer	1710	63000000	1	CkpYu8uh2dNAQJCVvscTSTaM2kZZL9JwGQFb5wDKxK9Tny9DWLdmd
8101	coinbase	1588	720000000000	1	CkpZZZHuSc9KDGpcVfL7BJNgYvvr4uUQsEpcHP5nLf7eYLLnu3aLT
8118	fee_transfer	1506	45000000	1	CkpZokkUPnpduskhh9rzmLSYSvGSAoADNeeweFQkPyFeBiQGziaMb
8119	fee_transfer	1649	26250000	1	CkpYhrHX4LcpVSH2Y4s8WtjvN4mCCjaSfa6RsXWWjANpwwkcUHjWF
8121	fee_transfer	1474	49000000	1	CkpZuVsL24H7HFLrxBpTyNCQAKgPSHkgrTuzQ15VqGak9NxEdvvNQ
8125	fee_transfer	1716	18000000	1	CkpZkpik2gz4aiifEYfPUNtZEVgnEP68vdpZNofTgJU82zhFKPtTA
8128	fee_transfer	1701	16000000	1	CkpYVZzt6E9fbcoG9v4CBLb6Sxerd48PYYBkdx7aRRyesKNSCVWcD
8130	fee_transfer	1679	236000000	1	CkpZ1Lp6zL9pE6AznHbXDcoCRRs9de792is82agQZrDSgbqu1Lw8X
8133	fee_transfer	171	9000000	1	CkpZfTM5VL5CuQr63ZNuq2Gh4mDTL6wgpjho7yr1g9QsRvfwhLpcP
8138	fee_transfer	1850	18000000	1	CkpZ9QeFFA7DrcGBN24rGiMDVypLoE6pFcDGJYhK11w8PpZ8F8iqT
8147	fee_transfer	1610	18000000	1	CkpYRbBZoynwPkCURRaaeR8sTPCqra2JL77UnLwS7RYP6viaQVAf5
8149	fee_transfer	1633	126000000	1	Ckpa1XWZpniinZjoQtrgTmdT47bfX3EHtKogsvAevK9Xd11iTBbGf
8151	fee_transfer	1395	11999992	1	CkpYQx2gNzHMZxxmxPS62MHzW1ByV7qh1gdjDg1DJrGB2vuzUmyWE
8153	fee_transfer	369	19000000	1	CkpYV1VJ6mjkYVZwumKXrr9PyToyUTwewraqHHv5zyPD8bAff8SBa
8160	fee_transfer	1714	18000000	1	CkpZNfbcBWxufeMXynAzJRM24KChCKrpgfVrWsmNkxL6wTnru5Pzt
8162	fee_transfer	1696	49000000	1	Ckpa1FhpfZKptzmYhjj1PJPG8Ua5DvBCncZ8vfijzkPJNVFnpbWwg
8165	fee_transfer	1593	57000000	1	CkpYUTF1P51Z89Hgp8KvYaDwRhzByrCBPKctDkzivMAuATBpGogcN
8175	fee_transfer	1444	67000000	1	CkpZQqRgKVibSbw5YBFHDqgbn4hVvbtMp4CWgHq4XM7tHsmRJgcqQ
8177	fee_transfer	1559	67000000	1	CkpYtULCSSdrowWCCyWxTmwgSt2vAtTM3PjnnWaP7Wti2UZMtFxgA
8179	fee_transfer	1654	18000000	1	CkpZmYt4katLC4UtD3ZTRZdPrTEp8k5twhBeMwnRSSHhUyKaUw6iX
8183	fee_transfer	1764	18000000	1	CkpZ4WCapMxKyr1gfGnuYhW6orQsHRnemTFYYsMBpC9wLmp2wism4
8184	fee_transfer	1764	15000000	1	CkpZiht6w7XSRpT3EXMCygEgXmJ2RQosL5V2NSh2s1fTRJMRYf4VB
8189	fee_transfer	2261	51000000	1	CkpZqaj6mKXgchZXr7aieorvvc3ChshhsZ5Wb6KKrC54zAoYcrpCn
8190	fee_transfer	2261	32000000	1	CkpZhTNzB7eLbtfdjTDznWqfkPfjuX4KnZtigfWo3qmwJ4c6gZGFo
8208	fee_transfer	95	21000000	1	CkpZ4FXz7EPJZ1QRXprPckbZrLyrJxNfnwGa2B54RiJD8R1i1Juz5
8216	fee_transfer	2211	48999992	1	CkpaKKFMZrt9PxGnjjF5B5sx2KBx7d4cq1xGiZ7yowdQLJ8qi4Qt4
8218	fee_transfer	1532	46000000	1	Ckpa29fnziy49PgDemXkV6DLqf5SoSrNQ2UyGpXejHrp5tJUJox8u
8231	fee_transfer	1419	47000000	1	CkpZ4ZWNbZkRzkF2XdZJBuzzWzXYzHWepQYcWUNQV24bzTSu7Mu2H
8233	fee_transfer	1618	22000000	1	CkpZ6Uc3DRuKWGLU3aYqpncu6iiXGPuEw83azDEbdJau2yert53mQ
8240	fee_transfer	2367	700	1	CkpaDMWJYep8AC1rCM86aLEMnsSTFGjcTGJQnpRaC7FtB6xMmJqst
8241	fee_transfer	2126	225000	1	CkpYU6LsJgMTCt6sRHPRjo3hQG84WbBJKtmnDGvMSnGq2U4AZrFP9
8242	fee_transfer	1807	7	1	CkpZDXUxWasyv8j5W3w5X1qN9mPwfWGaXWw7r5za3zPEKuEJmwKFE
8243	fee_transfer	2004	2100	1	CkpYsGCTfVof8RWxGRPbrawRbtAddAhagVSTsJC1pGbvDQohfWUMx
8244	fee_transfer	2261	17641890	1	CkpZZbNtwg2YUXhiASXyG2dJVwqkNUBnxeh7cYcgk4fmj8V7WjTqB
8252	fee_transfer	1601	29000000	1	CkpYvZUbFfsgyKXXzu8WRkMaizEMtsMnkqBNmJzcU9PYwAr9NMzK7
8254	fee_transfer	1850	56000000	1	Ckpa7oYMtKqcdurf1rQr6XNvxRNxvx5QgXwacZuQL9jrBDpnKnBFC
8261	fee_transfer	1701	19000000	1	CkpZjA4PbMDAoKJUu4HithENQSfQ1wSTZ6AkqbiLwzkeu7p8tdZNn
8262	fee_transfer	1684	18000000	1	CkpYw5Rd5YKs96h4pk1FXXhe3EhwEHupSULLEwuSpeZGP6HhYzBxY
8264	fee_transfer	1699	29000000	1	CkpZHQFp7J4ZEgGtQmtYothjEGLdmmygdotZqNCvmRNCMNYvjdnqV
8267	fee_transfer	1706	35000000	1	Ckpa9zbp5DZEtoW2KtJ1t6V2fZc8z4qPjyqsNg8Q14HEXgR9bXq7b
8268	fee_transfer	1850	14000000	1	CkpYorhg9JrxWKxyKTpih2usErik89jgy61aCodZcyYpqEee6139j
8056	fee_transfer	2112	3000000	1	CkpYgn5v72hq1vqmSbzRTjZafksC7nkhdVk8hNms7wX4W1KGtuLwo
8059	fee_transfer	1684	39000000	1	CkpZqYdVQFsmWNCdSp4DgWVZKqJWhGL75pNZoiVpo3FWNbtY5Au2w
8061	fee_transfer	1678	14000000	1	CkpYxtp9vfdgJLnbr3sXVR9m6ZKBxQunp5acX6xc6ekvksW9rLpKD
8062	fee_transfer	1719	123000000	1	CkpYr3CXkU4JME9QZihxnB6Lbo9kKcPnxFwzUzNr2xKdAcToPKZ97
8064	fee_transfer	1991	137000000	1	CkpYzW66C9VLyynJwHtd1dU9d2qDMZp7zhU4q59rMXoAfxdKTt34C
8066	fee_transfer	2301	29750000	1	CkpZ847sRbspNFPMgiXKmqrVj8eFsSpm2gXuj2d324ormrsgR8Qtr
8079	fee_transfer	1596	29500000	1	CkpZDNSPdTezSzHv9uhVHr4P8ZctCqTFG14CYdmVLTQNhad8o16AS
8081	fee_transfer	610	29500000	1	CkpYhgbMdMDUuvevFP5GJaeZtGoHdqSDY5xaScvHGXR3bSDsAGQ59
8083	fee_transfer	1693	18000000	1	CkpZePqkgcBdbeKN8AwJpm6jBKPod6Hnh2D3KQWGGWpKyWR29EfTV
8090	fee_transfer	1439	4000000	1	CkpZe65vXu3a7Y29Dssi3T8fETKVwEnvYkYsD9cAnrVqPygPB7KrZ
8105	fee_transfer	1513	920000000	1	CkpYoVqeL8eyJA6h9j9rhb4zyJUca7t9Vsx41WrKJSVPDYpXDoWXK
8106	fee_transfer	1513	130000000	1	CkpZVHiSthMQY864CEuMQwRZ77DCiQsxLru2ASEJTW1cGBS33dDdV
8108	fee_transfer	1613	14000000	1	CkpZTLqqzR1vmR8aGwobnHHx5CUj1sTFqSQYWHQid776uZRTgXv85
8109	fee_transfer	1710	539000000	1	CkpZK4NsNy4XDazbRHpvtSMby2RJVd8xpFU4PXLfLRXRJxTgtawED
8110	fee_transfer	1710	60000000	1	CkpZbbcxjKRD8b9KJXvUkWXeehVWQa16v8E3phvLSA8ngZSx3kubx
8111	fee_transfer	1445	13000000	1	CkpZAWF8b1EdP7KoG8CmbhDNeQhrrNTXYM2p1p4bRKTwG6RLcRSx9
8113	fee_transfer	1588	111000000	1	CkpYS3i5wJXCCvb4JpUqagf11KHEn93vEgCtATNqvpMha9ig8vZeM
8115	fee_transfer	1616	49000000	1	CkpaEjyAD2cq2zQArZgbLCNo22CLvL3pDeYyTxR4wNPUim7GPCv3h
8116	fee_transfer	2307	45000000	1	CkpYYqs4TkaMyW3A6MatKKwzcxZw6t5ompYUkVLmZj3pCH2pBPh7Z
8124	fee_transfer	2248	15000000	1	CkpZY2yPE5uHPaNsy4R6ju6s6DNsiAUtWpZ5jCLtMe9oPK6Fz6Xzd
8127	fee_transfer	606	16000000	1	CkpYfqxvSErSXSZcFkKGmQBNfWo9sn4mcgFc3TkqG1cvJEq1NbsSq
8129	fee_transfer	1740	16000000	1	CkpYVuoiMYecgWtVmAEHQJLdD6Yasdes28ExZzBdXGjH89kYfMAjp
8137	fee_transfer	1679	17000000	1	CkpZZ2pwUS49kjFrfPb6JzaPynhCmPWPcw11QtzsrchX3UGRaenba
8140	fee_transfer	1688	254000000	1	CkpZASPWJmruu3WjVrQzaa5HJzekFBsXNUb6SdwjgQuRVEyPqPYNR
8141	fee_transfer	1656	18000000	1	CkpaKVzZbcoSLvCeaZz9DQo66RjsgbgMCGM55L8VHsPYyYNQxSzQz
8142	fee_transfer	1759	18000000	1	CkpYpGChczKbUuWexNJbBwZCYQAURvVDr4f4cKXUe7pSwKBdjKSrS
8144	fee_transfer	1440	135000000	1	CkpYRQPh6ULpJtUujbrxaUBjeewAqRmYATg6uu1r6PtD6K7kqnhYG
8146	fee_transfer	1394	28125000	1	CkpZ1p9FrXeQDuAVKBCEvtgj1Ko7SACuvXDX4Nv3jwTTPk7rCLuAZ
8152	fee_transfer	1679	19000000	1	Ckpa5wsbtkNZPJ86upjgYP73fTYtHHr86C1hEiKwebs6QTekxtHNZ
8154	fee_transfer	369	18000000	1	CkpZkeGod73P56jYCHMCnsuVqYT6CinQYVJofTvSB2WJ7r1cYHM5k
8155	fee_transfer	2261	19000000	1	CkpaBWA2ZSQX76g2R6NTKnqsM6an8Q7QcMT5KXWbSvzNbq9FS2LKY
8159	fee_transfer	1509	15000000	1	CkpZdvXbdxZi2uxnFVaU9XWcYcW9Lr8fhdzjvmPYVHF9M7uBBR41i
8164	fee_transfer	1696	57000000	1	CkpYsYyG3cnde3ktR6TETHmuCybXgr3nBKB3Csw2L2Du6L55AraxS
8166	fee_transfer	1593	970000000	1	CkpZ9L2NcYj7owVgk4pVGpWgVZR5iz16KARvixJj77WFNWaD9kQ5E
8167	fee_transfer	1593	1000000000	1	CkpZi1iEavE68ZDuDViLqBAJVxnMSubFNUevQr9A5jA1PUXKWi2Pr
8171	fee_transfer	1980	1880000000	1	CkpZFdpCtmcdrH6i8PKf3p8rMyhez6vu6gnVLLvTUYhNZwzcTL441
8172	fee_transfer	1980	600000000	1	CkpZqF9Fz2j3g89aa4wMbVCUnfYBQtYWZfVcVtHfyQeuivMyqrS1U
8174	fee_transfer	369	67000000	1	CkpZJrEW1aN7JpdUwXWXZ96HxMLrpVMPk8oY2zLR454DrqyP7qX3H
8180	fee_transfer	1422	16000000	1	CkpZX9qMZ8SgB3PQRpCwksUvEuRERkSGYXnUFvRXRMpoKaxBvk6aJ
8181	fee_transfer	1547	16000000	1	CkpYjRWmMMauVCezrRSWvNuoDS6fq5gmkLdZLww6vLUWyPEs4KcrA
8182	fee_transfer	1764	16000000	1	CkpaC4hNbNg1v5gzAnZVbodjbP1BEL1DGyLX8q92w5KnAnpK5iRqB
8191	fee_transfer	1549	17000000	1	Ckpa6NAyFcBnA6r96hwAKPBgYLsrB8JVCrwaXheS3xp8Fcqxhh4vK
8192	fee_transfer	1588	17000000	1	CkpZHJVd9AFsmA4huU6YAnqzJdKGfYMSsCWaAg7tvbRieRnHP3wzf
8200	fee_transfer	1759	13999779	1	CkpZ1YifQdhtjodyqgNTraWZeHCEJETpSeHeRjJMHpXzjU36ZvteG
8201	fee_transfer	1807	12	1	CkpZEFzKwWb1E4rYJoEvCNvyrNzB4KeknDZ7miHrNSi565VKzNe96
8202	fee_transfer	1571	104	1	Ckpa3fMhyP1UU1ZF3ZSWt4SYwTLA2GW8A5YBNbLHYUc46F3r9Sz5J
8205	fee_transfer	1701	31999991	1	CkpZWzgx1prkT4wu1HiPmivfYUmap9KrrYS21NXJ4dECnGcx798yY
8207	fee_transfer	1733	20000000	1	CkpaGRMcorsAQ4us2m2wyuHUP6BaDYwjpmWwvgUL4mbg8c6beLMHs
8210	fee_transfer	1807	15	1	CkpYf7jmKcLoZcFG7De8fiKEY17vZDGPPTmzzqFqwjTJuFs7eJfda
8211	fee_transfer	576	20999841	1	CkpYn6DWxY95fRyA4AX2DiEEWYMCTirQpvLBHRfAVBwBZjEAEy64e
8212	fee_transfer	1964	7	1	CkpZ9E8vkZdyCEmB4HJzdsMSsXFwqji84aWSbEJfMNxQK6R984aAw
8215	fee_transfer	1467	48999992	1	CkpZFGRxLSKvgA7jYNgN4G5bRPGXUKU2gLYL2Dv3AKUNDcc3nUSfV
8245	fee_transfer	2261	16641890	1	CkpZU7ahW1D8EkS1LCyWxJZbij7UP7hWF8JhtMBAqaj1c65efBVcz
8247	fee_transfer	1622	15000000	1	CkpaJ6YHcKMUSLSSgPy8ndzVPiMQVTgHaTcQstFRx6STvUCYDE2qC
8249	fee_transfer	1768	15000000	1	CkpZ5sfg7YBRejZXbGQwLgvEtZFqR2mXTzh2cJqpsXo5sJqihj8aG
8250	fee_transfer	1601	388999919	1	CkpZfAF2iMF8G6VQCf1iSL5jJPVCxz5ZVDKTp3P6eS2XWBFDnd4yV
8251	fee_transfer	1807	4	1	CkpYT8nz9A46bK6UcAdsfsmz6E6Ktcj5fcAnC14dX9qBoUrFiC85G
8253	fee_transfer	1850	27000000	1	CkpYrQvNPgUaC98xxrf5DG6TA5Wgu4H6cQ7STEjAPzTKqkCpSEBY6
8255	fee_transfer	1476	18175114	1	CkpaBJym7n4kvPWGPEMbmPeQWTN7Y48fFsArzXoDjCzv71CndKsdQ
8256	fee_transfer	2367	300	1	CkpZF1Sd7f4U8Q6Sga2PKkpzvQC8cfL7TeLt86Y4MDwtEXEycPXRc
8257	fee_transfer	152	200000	1	CkpYuRNiV6gjPWncJLRJyomZrtspoTSt7FkvKvuQiGKZ4An9y8XZe
8258	fee_transfer	2126	400000	1	Ckpa3HnpkAMAcjK4CYkKCLUA5Bq8UNxdQ8fpKJdULHRXhwXCyCM1x
8259	fee_transfer	1571	64	1	CkpaDYKLjhbgh8VEYtb6Aq957SDQsBi27bnLT968jzDNYRLHacSo3
8266	fee_transfer	1610	15000000	1	CkpYxwJ4rMHLhXs3qzCxLXcQkWiGf5EaMVjKxpu1yqi9dhQUaSFsB
8273	fee_transfer	2329	41000000	1	CkpZNFAapX57bLhGDusHFKtnCoQgyiheMjP79EaRLV1iDAgs93h4q
8274	fee_transfer	1622	9000000	1	CkpZrM9KpeLYbzxpeQv6ajeHekkK5M3CBFES8ktyukoKSwNcV41jj
8276	fee_transfer	1688	27000000	1	CkpZBgKRZek6WkJznbHmUXFbERcqn3jwU9SAPaHhuPb1Hy1JEpDgg
8277	fee_transfer	1688	32947694	1	CkpZv9EXX9x91LDXtTXvHVyXBjLidQE2erov9Hw1RvnuharHbnPg1
8278	fee_transfer	2336	2	1	CkpZAF7nwyztuULM6wypSiJi9gJxtsE7JYXe8qZtfLWpjGm1tYDJa
8279	fee_transfer	1964	5	1	CkpZNPqnRk5ggPySTPHddotNxXG4opLpnWyKYAL6kUUAsuo1A1iQz
8134	fee_transfer	2329	40000000	1	CkpZ2vGkEaPqcEnpUnF3PLiJNvEcxfLEg9qmdTWjSwJWzewSkUQ6M
8136	fee_transfer	1594	33000000	1	CkpYi41Bx5wJXjqGVzb6omNc4ida5uzaHTtetLgh6juz4vtojNVkP
8139	fee_transfer	1602	18000000	1	CkpZZQ5dusb3Fp6dRsYi8LD5ButbHADPG2erAWJwdg1S8z2fgtuzD
8143	fee_transfer	1671	135000000	1	CkpZHddncSv49j8TA8EFHZHPji2e7KdJqZ12hFGcJvxgC756VqdP5
8145	fee_transfer	2306	135000000	1	CkpZm52Dcw5xEmRXk1A4GhVMYPQXS1dRHimVRsVR75NXyzyZTbwpg
8157	fee_transfer	2329	18000000	1	CkpZQHq6A9SB5NG52rV2ip97eZkmyg6yqu2K9BLsWJ6rKGjWo7neW
8163	fee_transfer	369	57000000	1	Ckpa6QhfiZn2JnSgLZ4Zg2LRoragBkYyqGShf9rP58qMSuozG2vcL
8169	fee_transfer	1439	17000000	1	CkpYcqfm7tcKbUu2jMt3nyYzCQkB8T81TfzTyUNu4dQCeAAkk6ZmF
8173	fee_transfer	1471	67000000	1	Ckpa3UFwzPFSiX5KjupNbrsPDXuXkLcGZoyJ5C8kCnmb4Je6mtX95
8178	fee_transfer	1613	54000000	1	CkpYp9gNmEFQyypPZb13BzJFUY4RpE3UhyeXFA4wtB4bjbLJAm17Q
8185	fee_transfer	1688	18000000	1	CkpZkJovyMxM3Bs3ATY76dGbbwu1XXAT9u4HqXBPwvg7hNakeq3q7
8186	fee_transfer	2112	30000000	1	CkpYbGpDCVzomavfge7pxkxoHi3tA4gQWirqf9jZSpZBZGR2AY9ge
8187	fee_transfer	1623	36000000	1	CkpZbuxhKgpvJLRZjVqfTdhBbs9SB7tdtwfxAPgUzYJEjPiZ52uD8
8194	fee_transfer	1759	13899624	1	Ckpa1ogqyCtqvZAXgZjQWacUEWLioKFZZNrUpkbDEDGbdz9yUAH3K
8195	fee_transfer	2367	100	1	CkpYgF1uLmky91UQiChq4ctjiTViv9JYkXmnJdEzhWFBQJwJGyQ4k
8196	fee_transfer	152	100000	1	CkpZFeug16CXSQCZCifvicv5z7fRo77jKRzGBmqQjFNrbXdHkFRwf
8197	fee_transfer	1807	10	1	CkpYix6hT6AGGi4qRjk19gCiYCZCRuUrvHocZqqQQ4U3NaRzuxDVV
8198	fee_transfer	2332	100	1	CkpYVMiMz21uJ5ABdP8R11Sy35x81dUoFTuzrxiW3EiV2XNSRhucV
8199	fee_transfer	1571	160	1	Ckpa1vjb3PVmVzH9oDLyM9m83GAQiw1MryCVVdU5esHMPQWHjYMzj
8203	fee_transfer	1759	31999919	1	CkpZe7LdHtDR47D2mUsoeTzpJrpNNEhAhRhVD1yb8RbucEw1ejZcc
8204	fee_transfer	1807	6	1	CkpZC3zcoU9854uEw3kdoCqrvjpamt2ZJBabh3VoFzaLeyBPCFxkm
8209	fee_transfer	369	35000000	1	CkpYYDgG16Nr7KBnfJnwssgysSGZzSLWPvMKuzWQhRhDZMbchKE2Q
8213	fee_transfer	2126	25000	1	CkpZrN5HgjhiLFSSSPSbAA1v6SqPGtLbW9WbpLxyH6pKzgA53GAzJ
8214	fee_transfer	576	8974841	1	CkpYajgs2T3GnPdSbPecqcwsVYDCNG7kG4qCdoKWUMpF1Ud6FhrQ7
8226	fee_transfer	1807	5	1	CkpZf1CW2ap1WAkhAE2HJAiHC6fFnAFw1pdRkbSS2sPMMNfpa1jMG
8227	fee_transfer	2330	1000000	1	CkpZ3h8G7Gg3HapuCGnWCKzSskEt18tKh94sbdg1dt1CYgnE1rjpa
8228	fee_transfer	1419	222999855	1	CkpYyWftirTPjsJ5tbZ4epfphdFUKZ2mzpQqMaiVi3MHKwX9TadHh
8230	fee_transfer	1546	47000000	1	Ckpa4eaDF7NDsqfqkN6CbWKKBJCbCrBm3cdwiT4FEfpBYWj4hDWZt
8232	fee_transfer	1419	26000000	1	CkpYY1jskXnmaodjWsexGCBpnv9Jdm8bJYJ1QCskfpPGgVdvEHPoW
8246	fee_transfer	2261	335999991	1	CkpYYbe9cxkjjG4AkruE2ZjnSpf6LrTjg7wjBnqgVz1AMVDuTwCdd
8263	fee_transfer	2086	29000000	1	CkpYu8GKZ7kCRE8ZePexJ3EbsNE3T8HPUB5KFvCp5F9UVkEUZjVnA
8265	fee_transfer	1596	18000000	1	CkpYv1TKbuuhNn4KM4b3gprs14c1Fx86XJ8dxR7Ysyx7oNmuJR1my
8288	fee_transfer	1471	18000000	1	CkpZN76GLDc9dEcTm2vCNMM6JjbusrgsiamLeTTyRYkVYR4MDgM6N
8290	fee_transfer	1992	19000000	1	CkpYtC3wJ75GNUJVfyZJmnGyiPXUZcgv91H9QFXRHQndJDt6EdzA7
8305	fee_transfer	1699	28000000	1	CkpYf1M5tyxkj1se33JRNn49FqwvzpMTJAZw4qbaGCRsR5MMgNrJt
8309	fee_transfer	1439	60000000	1	CkpZ55AvZvDELvYzAiPKQL2FCig87BvJt82AMMqyhqEAU7od4Ui5j
8310	fee_transfer	1568	125000	1	CkpZuw616LVjtoWfXx2e7rBo8U3h8UirimNzyG487b8sPcFBb9GME
8311	fee_transfer	2126	375000	1	CkpZrdw3YuU2DiTbSmGNt43Wx7rRNXag1X3kGkvtwkXoNx3CtkJB2
8312	fee_transfer	1807	13	1	CkpYomBYo2AaztDp2H68ZdjaYiSho3s8kpJfN4Ks6vqoLKyhp2qqd
8313	fee_transfer	1439	427477974	1	CkpYk6i4GUqdi5RQQV7QYpWoxULUiPs1qkb5oGdo31o4eZuuYExPq
8314	fee_transfer	2004	1400	1	CkpZJQZfBYYwWz2ZKfmiEjxWip56Gc8KiKoV3NZPZ32rwQnDmviBu
8326	fee_transfer	1762	17000000	1	CkpYT4upstMPqvSTS2wYNheqqAcvPn57HyP3ydaicdKHqJ1rQXdEa
8328	fee_transfer	1699	19000000	1	CkpYpqzox3vzoZrMctR66xiUDFs4ifwa5gK1rpVCvdAMSZ5R23jeo
8331	fee_transfer	1395	118000000	1	CkpYrZZMaDLqNtTprFAsJM5Kp9ZrZGYrPiR21VqmwnyzF5Z2xVEY7
8334	fee_transfer	1764	118000000	1	CkpZqGJMz4Jqy2KoUz6oevJVxNuEDEQBvhHymQuR7Sgg4RhfSJ8Jz
8337	fee_transfer	1675	17474693	1	CkpZK7R6ETH7FS2qvtskSgyxZH618RPCqdb8GPRE3ysbijwmU5sbu
8338	fee_transfer	1451	4000000	1	CkpaCn7LXhA7t1Kv4ADYEF6sGHhk4d4jC1ZoXogmWgoghKJTCBMzX
8341	fee_transfer	1419	17000000	1	CkpZS6S6vTL2a5JQYFNKmaucheYiwcES7hUvRQffjGFWJkCtCG4cG
8343	fee_transfer	1419	215000000	1	CkpZbFGMTqitarxMuUKw2ZmrYvfsTxPhmmb7xRC6R2Mti9d4Pinvn
8353	fee_transfer	1719	17000000	1	Ckpa2ADwW8MSmg58j7HtsgM1ZMQ9JUihVq1ihPXwXmZXmEraY9T8T
8355	fee_transfer	1684	37000000	1	CkpZhMU4vAYatz8zZEUx5Rez2v7ZbmeyHK5ahQvEA6jW229ufAEP5
8362	fee_transfer	1395	28000000	1	CkpaAhwz1mmqahFyGLqLmsqj9YwPSPgxbBkgizkquBr33FzgE6A3M
8363	fee_transfer	1547	28000000	1	CkpaKptMMNrH1jfKaDEHv9FscPapPUKsmEK31jTkLJyKUrYUF6vnW
8367	fee_transfer	1547	14000000	1	CkpaEwHrNdwMzEzefygx24xEhhdVsVYrkhFmoTyqxPPDVU7mRxNui
8376	fee_transfer	1672	19000000	1	Ckpa7hisQvDSNNJcPjCbB55m7thc9uUspXh9VtRDYvMBoTRCP6LCx
8389	fee_transfer	1522	14000000	1	Ckpa4yJGDKUqvEzSsBMftYzahGdfTCPVPRne8HVJ8PiB1VF7PTesE
8395	fee_transfer	1673	18000000	1	CkpZJkWj2LnHLECxtGAcoShUrhR3NZh7qmoTRimMHehCg3qT8Nj5p
8397	fee_transfer	1992	38000000	1	CkpZEmdobQU6zQVqMAGCmSVmtX2kqjBMfMvt9QkU4tqFMLRzVA7LA
8411	fee_transfer	1705	19000000	1	CkpZt5CnhxhqJSmHK5TY7HzQQCD5PS7ootz4S8PY6NEMtRbsLoceg
8280	fee_transfer	1679	27000000	1	CkpZTYK5EihaQ8Fv6PxgrmbA8hUzBEMP3Cggg8CUwBgMPoFjWsoWf
8281	fee_transfer	1679	27947686	1	Ckpa3oqxsdDs8LQ4mFLEW1TMq97uj5pVgx9xpJnytUbWbzAKrjZbw
8282	fee_transfer	1571	96	1	CkpaGpp1ywNsWNJfiEYcCJiQVwxtYgmWfxkXtKyCkSX5CxRppywji
8297	fee_transfer	1402	18998999	1	CkpYunBydQpKWvfmyq1DbEazb2RLJkZpKQdxKFFhVjHMWC7RMTnAY
8298	fee_transfer	2367	200	1	CkpZn1nXnSijQTAMRSfU5PkHdsyiQHwFmxYRyL3zpTtwZRHSJX67W
8299	fee_transfer	2004	700	1	Ckpa8QrPiNNyoHzWR6JgoyHcTE72mk3BATYg4Jxzeyjwn8izyLASM
8303	fee_transfer	1690	18000000	1	CkpZP5cGMnW3XZAdwL6GaSVjuj3jCVKVE9xw365CXgiqvASDxDgXT
8306	fee_transfer	2087	28000000	1	CkpaJgfPkQstcnFTPSVotMvH6YCgW1pAsXsJvnZv5JwrDvJGWw7BA
8316	fee_transfer	1756	937375000	1	CkpZmMU37vRKg7xxVVSN1mci1R7pqiY46mhBYbq6XmLJ7PpzERBKf
8323	fee_transfer	1702	38000000	1	Ckpa3UgkDXueYz7XdBhxfXh8wRUt2JHM1iPZp1BawdJ8VtEB3Xw1S
8325	fee_transfer	1762	18000000	1	CkpZ6xh5YoPdMBRB2yYeg8EZFCxAo3rtiRgzvFDH5sDU25Co7uo3w
8329	fee_transfer	1602	19000000	1	CkpaJfUyho8V4GLhKKuRjYCjGr5CFwCAfYhMe83mZiTwUgVdZ1Ed4
8333	fee_transfer	1992	118000000	1	CkpYb4BJx2T7vmzwy6RrLtM4kTx7kGRx7FsrRBMugzYQc2ZfGHmSx
8335	fee_transfer	1764	116000000	1	Ckpa1HzSwVL2dUV4pd7qHXoJzB8WeFzuJAxu8fH6dPRG6hvG119ba
8336	fee_transfer	1670	17474693	1	CkpZ7CPaLJwFeozvG6gRPtvi4FnrkcMFXkY5SfV4hEwAoxEfehprx
8344	fee_transfer	1613	16000000	1	CkpZnMsk71ZjCeXZ1YXa4q9xKBTiLdcANcoLsrj9tnFCetLePdRb2
8346	fee_transfer	58	19000000	1	CkpaCHPxsyyjgPKZ2eErZD92Ktmu46UVzRk3688Z342ZN71PueyTW
8364	fee_transfer	2087	95000000	1	CkpZ5too1ZoMu56VJcNLwQkYcfQtKsSC3YNq6Vizse2XL9R9evciG
8365	fee_transfer	2087	21675436	1	CkpYdtKc63eXZAQQksZQaeYU6FBG2y7wA8ssdggS4PXWDkAwQo8up
8366	fee_transfer	1571	56	1	CkpaJTPrRCLxeEt5psMPz2roaqpvBcfWAinHxccTrHNEB2RSdenNs
8368	fee_transfer	1672	15000000	1	CkpZ1roanqArWSMudznC72kJH7GjLoMTsDA6t1uS1q6xXL1sm5S2h
8369	fee_transfer	1710	7000000	1	CkpZmeUX8DfLbPpSyKvWwGuSWfSQDsrbdTwF7bVuzxXQS96yGwkLp
8371	fee_transfer	1670	29000000	1	CkpYoUQBSYxy6iRajPBger4PAFBg1GMpMWivpoqGgnGJ84gjGuzGf
8373	fee_transfer	414	29000000	1	CkpZc9YWkmxh97U9hz4j1axrJVrBpdSqQuj7neurnmnZERqC5oz2e
8378	fee_transfer	2367	900	1	CkpZH2bshN1JaVJf5aMuSAt1HNTPtJhjub19jJEaby6YXH5wAuGwP
8379	fee_transfer	1559	7792800	1	CkpYwHq1xqYMJXNQTRrM2VhEh2seZXYhqUdMDsuiqVRXQMRoBeHEk
8380	fee_transfer	2126	50000	1	CkpZwzhyF4TZY2UppmmH1edp6Fhgy9tRbeRS2d91D5DjDs5wQQb27
8381	fee_transfer	1807	17	1	CkpZwDH8yajFrYRD27JHXs8oDHeUi2e5c6c2wWmQAJwDXwiugvm1t
8382	fee_transfer	2332	500	1	Ckpa4nGMk4y6LdfwHfxev9HaSHJJF7UoEtyfeq9rFBzV7EeZmTovu
8383	fee_transfer	2004	727	1	CkpZe8HPd4ukGPqQjKC8UzHdjhbtUH39yT4PxML3ViuukZzSKQD6u
8385	coinbase	1394	1440000000000	1	CkpaDBr3ZmK8PN76rRcBPvmWvA1JEXwr1qP4xbjuJZvN8tEmndmNS
8386	fee_transfer	1394	14965000	1	CkpaFP1wTLLBsujz5iZADrUV1x9RtdCgMNiKXeD1wM7M5EfZsryk3
8394	fee_transfer	1679	18000000	1	CkpYtTBESSMBWCxGRYfSsmYPJGY72KEz3A327KPvTk1z4Ue8FkJQq
8396	fee_transfer	1560	36000000	1	CkpZWYvNSwcTdLowZDC8NA5NJxgh6JuKma7VMWuWQdXJ8cV88hB2v
8398	fee_transfer	1980	21000000	1	CkpZWUBtusrDtWcqA3cB9wUottjDGYiQYipAW8QRoHDw64ZSuap8e
8399	fee_transfer	1980	15764171	1	CkpZpWopNpAzsNKiE5u6EvSWfv1NEKrCUcSAsUHRjuPhJAQdfEA8B
8400	fee_transfer	2126	100000	1	CkpZKAxXiPCyErBzD4thtiaYbBUwvw1RsxK8nVkmvEXukEFTsvapG
8401	fee_transfer	1807	20	1	CkpZb7KaydcSPe93URBBYFT32bHXXGyNVqWgs3vtaPBNezFNpo3dZ
8402	fee_transfer	2004	36	1	CkpYaVVzLVinFSKCCAjGUk5R5Bd2xRfbjXPrMr18Mqqhi8JbGr44T
8404	fee_transfer	1476	17999991	1	CkpaKuv8CNcMgyvbsjq7vVdh7yuqajEKkDXYdV4HFYTAHw3hXAxY1
8283	fee_transfer	1395	17999794	1	CkpZkChKAwGd5AgeLnohBcruntD99YDoXYB7oxfGaXDase3LP2sST
8284	fee_transfer	2332	200	1	CkpZTr5ZJhD4VG2FjVoEbuQK4sUEVxERhLRhUMueCWY3LGQW6o1pP
8286	fee_transfer	484	59000000	1	CkpaAPAhvx3BE7gyzDzh72pk2fSjTWC9wNLP2Y4rsCYH28YSDvJWx
8287	fee_transfer	1451	37000000	1	CkpZfum7fohamLc5w4HkoRNwQigjhuKfXQULKpcPhutJaeviwJeNB
8289	fee_transfer	1395	19000000	1	CkpZKhMs7DvHYquBJqyDjeDXGogrw4xC2h5ioWs5wkioKXkb3ZEWR
8300	fee_transfer	1673	18998999	1	CkpZ8NxrVEfTpen9mWct6Mx6HDhATLoN933wudYwSY8bho38BPvGb
8302	fee_transfer	1715	18000000	1	CkpZRtAAzp9bFsuBBaqXDydxq1hiJYRehDruHcmzKJgptNNTfdJ2R
8304	fee_transfer	2086	28000000	1	CkpZeFqWzUSeS4fPzLAxgkBBQ2UhtaK13n1yW9Dj52euue6cFyJJN
8307	fee_transfer	1422	38000000	1	CkpYc5FFcy1KcbYd56UY32iDQgbFZ7mechYgHGoC7kVQG3fzy5ehu
8315	fee_transfer	1588	136000000	1	CkpZCnxpD7b7B8gSWn5T3ezkB6DmXGau34ht8AcizdE8Eo6D8UBC1
8317	fee_transfer	1568	175000	1	CkpZXoKJWMcuRARXvuNP24oW8kPyR1micavd2bnu8RTMHSSZ4U2A9
8318	fee_transfer	2367	500	1	CkpZ8tPT5HyWPy1Y8SC3xrtcps3rUyUwG4xah95Ub4wKsYfa2hdoh
8319	fee_transfer	2126	175000	1	CkpYyzyEForU1wBQ2F8szmEiqw4kgL8F6h4AaTKsiTAee5fWREHdZ
8320	fee_transfer	1394	7605000	1	CkpYrx83iXoT75xna8xh2M92hYmhLub2Dt7zYZnYTC45EgtFCWEaz
8322	fee_transfer	1547	38000000	1	CkpYjrcddSgPYNSWAKXfQ21pApMC7B3winGaVxYWQwMmHdaVSvaPZ
8327	fee_transfer	2086	19000000	1	CkpYvGPVQgujnb5vBJ5AyFggosQtbnEDq2mou42yntRNp7ZBi4h3c
8332	fee_transfer	1422	118000000	1	CkpYoi53adDFfbVnwz5WsxNrjz7CaMWBA1LZWuaFBqeeNNR6BujLr
8339	fee_transfer	1451	18000000	1	CkpZhakygqvm1AXHGddySa72EvnjdnSwqUTNndsuFSZ18FL8Gs9p9
8342	fee_transfer	1685	19000000	1	CkpZ5rPe6CmZe8u1vSyYgvAiD1FHvSCwYzjpyvKobt58TwC4vzqHH
8345	fee_transfer	1613	19000000	1	CkpZPcRCXZjmrPKHGLqUZKh4pXgHytD6j5ZjhnoCuAWfepiCafWPt
8359	fee_transfer	2126	125000	1	CkpZNjwZ847TwykoaKa7H6TW62ohaV3voMjKuAEP5b4q8uVkDkYQC
8360	fee_transfer	1684	32675024	1	CkpZKXwJk8UxWCr6tRd4F6UFaPHr6keGYo85KX9whmxtdwqccHxz8
8374	fee_transfer	1622	37000000	1	CkpZKgi8BUhQq2htqnWatMcdSnMPC6iziQNw2HkuwyqoFMbFf8As3
8390	fee_transfer	43	14000000	1	CkpZ3qJXbpKKPiTH1kwyMeyaJVahFWNaFBv2F3N3zizSS1zY4QCnn
8392	fee_transfer	1588	18000000	1	CkpZQ7LwaPkvHi7gZcfGCypWG4PEPF5oxgJGnVoGhaY8hPj3heCP6
8403	fee_transfer	1394	18999991	1	CkpZDR1vLXexHCgf8bJ9gsjf5htyr9fipheowJW8bvsu9etm3LgBU
8405	fee_transfer	1476	18999991	1	CkpYu7dzAUdxQ2p5XVcjwMaJ7JDV8YBx1ydbrPJ6nPopWEfGyNu1V
8406	fee_transfer	58	226000000	1	CkpYv3vNRwrerbksoTcM2b1QuPcFRFoVri7WWeKnsmp9y8nj9JvxP
8407	fee_transfer	1807	8	1	CkpYyB1NpWmjYx9mHrhPZhJJffsZiJpcppjeoCtvuVAryXWiDjxQU
8408	fee_transfer	58	74747634	1	Ckpa93L8ePpgXKgmy7hu4dY7zHC8qi5WuiP7waW9Z7GD86j3bmGD6
8409	fee_transfer	2004	1409	1	CkpZZyWF4dkfQReX8tsRLxnJE7Rf9qdwrTtB8fkXMvNfYPNPdHJ4c
8410	fee_transfer	1571	48	1	CkpYo7xNpuCocXt32QKNKkuFK7QkmxXkEGnMBUVQkWUhNe4rCyg1A
8285	fee_transfer	1394	17999794	1	CkpaE4zCjHbbUpQMViFVrrfxhAwChddMa28FhVpLrMrPjwuPSgSRG
8291	fee_transfer	1426	4704350	1	CkpYReTxrLyFSrm9bwWBHB2QKJEmhvdFCV6Ktc6KtoSX4kgmyZLh6
8292	fee_transfer	1796	4	1	CkpZXugPcSY7Rzh7GudpszR5dmZGYWD7GfYkTXqTZQedr6xYy4nxk
8293	fee_transfer	2221	40000	1	Ckpa5PFbgXJ9kEF2VdmxFUrzENJmnCo5tJUwWeZrGkew3q5MJGG5r
8294	fee_transfer	1807	23	1	CkpZ8QsHxoN2u8JA823ZeJy6p2t2vw8oynMG2KN8zpKgHy4MPeUWh
8295	fee_transfer	2336	1	1	CkpYhWLM7wE3EghTAeuSJHmUdcsQtvk4Y3xfAdgWunadNTePpSJx4
8296	fee_transfer	2332	1000	1	CkpYvXcxFijLvHyqQTZDG2Vjaz6BDK95aCrDxj7kaB6hXJ9gnaGin
8301	fee_transfer	1724	18000000	1	CkpZq3U1dwdqpK4XZwZgM26wD6WvBLrn5Ce1JqPCCmkjwGmDKSWh4
8308	fee_transfer	42	19000000	1	CkpaFPYAZFEYHMRNEcqTVvjXt4YpPtrSjJBGFgDh4LYQtqHGKTBgs
8321	fee_transfer	1559	7605000	1	Ckpa1ZAN8ytWqa9t5mbzvUtbp7CuUYQy8VcbepB3rCBfGg1gdx6sa
8324	fee_transfer	1703	38000000	1	CkpYprRtDwdBrBzBYakuWCHV8BGjxbrP8tj65DrP5LsnZRhUaCG8B
8330	fee_transfer	2087	19000000	1	CkpZuqzVJtkgNJWihNoMDHmphfBsub1zC7mYEQwMpmten38a1UPZa
8340	fee_transfer	1419	19000000	1	CkpZsxvFCrCUxczZvacPTFnDsHur4BufrSfZSu93Gg2GM4dEJgkuy
8347	fee_transfer	1593	83000000	1	CkpaApgXbnwuH81A5D6SMZKfdHUJYqHWtSo5YYCAYXuC1dvMtzepC
8348	fee_transfer	1593	65307906	1	CkpZJ4AE7DEduLv2KWy1pPFw9CtN51yzw7yzSFrMNDwdub7GTMM1n
8349	fee_transfer	2221	10000	1	CkpZ7432V4qact1YKiLJEM25cuLe6qARmrvHmLsSty4Sgv3C14Ntt
8350	fee_transfer	2126	550000	1	CkpZHg45uXgbp4o1nKSquCAkPL59gJ27ZYtFLamakxvb24o2KVxdX
8351	fee_transfer	1807	11	1	CkpYyAemusJUKCZ8Lsc2cyN83bW2gFAQNQky8AAxz6KmJg3u3kaHu
8352	fee_transfer	2004	6300	1	CkpZd6U5aHRMbSDMpr5ozJH91T6MRpcUfxFDCG8NzVyT3Xh3FvMy4
8354	fee_transfer	484	37000000	1	CkpZFiTf3catL2aMcXfdvA4cn1enRj4WpmZhoWwgkAYUoE1JohBwL
8356	fee_transfer	1709	361000000	1	Ckpa4dwyY9kFCis835yjLkNLpMPPX7RKmAqNLPzN4MxdjtkB7ZJ41
8357	fee_transfer	1709	3670962	1	CkpaCe2JFMQPG4Scg7AEBZPRVRU7N359n1eqdPMQJKZxosaPMdjDz
8358	fee_transfer	2004	3500	1	CkpYtFWQrijVmMGUwQqf3GvemokgwLj44ayvXYJtN2tB96UhZUSc2
8361	fee_transfer	1685	32675024	1	CkpaGquLEuHsewUra2nXshRfZ94yyBDmxad8QRAVkuUzF63MBeSv2
8370	fee_transfer	1723	17000000	1	CkpYX9RtxYNj7mTFYQLan1sWPzzMWdsKuz7ynv856aN5iMQs9Q9ou
8372	fee_transfer	1670	28000000	1	CkpYVfAJpUf25v6rHeDEnUybVozFSJqXuH4tkP8L2VNdtjbZgYE2g
8375	fee_transfer	1649	18000000	1	Ckpa2Yuot4jVjDpAZYyXAundNmeE61YsYuYXqzi1NApsbxgoPAQDd
8377	fee_transfer	1690	19000000	1	CkpZ9E4MpiZDMkRfaQrouKRo4yBffKYPy23UfWEJhmCavh9WKvnyk
8384	fee_transfer	1685	7792800	1	Ckpa5U4M3qRRxqHMSpNiAzP3tQLc9b1cu1WB9Lzwk77oZiPS54fj6
8387	coinbase	470	720000000000	1	CkpYVWcuhMqYSQdRx5CFRcesG7PhLd3ANyegGkGkRNqRgV2esw6Vw
8388	fee_transfer	470	15965000	1	CkpZpqJUPK3KD1JzcZyiVkEdViGQc7dwbirajPynHSKoKYT8iW6pB
8391	fee_transfer	1688	28000000	1	CkpZBUY8xxuNE4uKaAZ1G3FYsMdgW9FXJ9AdPm55XjnuCgGmJHiVs
8393	fee_transfer	1686	18000000	1	CkpZBz6agn4FfmEhGLqaP5Q12GN2RSTtwpL3myqyf8LYUB49wuwe1
8412	fee_transfer	1656	16000000	1	CkpZEdLPa5NwtZN2AB7BmhUqwiqKdLFAri7BGrsuxoDARVETddVN4
8413	fee_transfer	1678	17000000	1	CkpYaMCPjhzhGzou9KRUc3dhp7vZnmUX5TZGMcgwggB3hQXB3wA6S
8414	fee_transfer	1671	17000000	1	CkpYWiUipCcaHTJaQpzmHp4Qe5rgsFV5TH9WMNNdqFgaCv9vYuFK1
8415	fee_transfer	2004	90	1	CkpZA6YMwARnoxdrQqK3RVuRhuDkoTCiNMogBf798uH2sMUECmLKX
8416	fee_transfer	2261	11739338	1	CkpYpbNey2BvFKfz8JqBxS1zrQTLGY4ucJML4gKdGkANyaYbr9qTE
8417	fee_transfer	1690	11739338	1	CkpYSjSibZvpZRnTh2hYPMHoZ53R8RqyXNauNTW6jpL9hJYZQmsFd
8418	fee_transfer	1593	18925000	1	CkpZecgPiMoPdCMWpwmhMvQLQz23N4R6m46m3NzzgxxnXgZ62WLic
8419	fee_transfer	1593	431974896	1	CkpYwyhf4buhikGUnJ1kwQmjvBCVJebUFSF5Uo3qnWNTqKpqpEspY
8420	fee_transfer	1593	62529388	1	CkpZMkdZRvB8QF17csse3exQawxQ5ab4SVUNJpLHzEuufTqKFUb3M
8421	fee_transfer	152	1800000	1	CkpYejLLETYUJBphzCfp1bV2UkobszwSr2PtbeNuegSJJrM6zUWNa
8422	fee_transfer	2143	400000	1	CkpaHB17EsbPkuKfa2a6L69hsNwHQMwG1RVZmik235FwWzEypd8TA
8423	fee_transfer	2004	4900	1	CkpZ3GdR2iXKYz8iTmbgRiH9J8KNumRqgjGrD1qVteMzPtPvcseLg
8424	coinbase	1602	1440000000000	1	CkpZzMFk3Jh1aaJshjmGA4uVxbJLikm9ZsE8NoiTXTADNnPWDSkAb
8425	fee_transfer	1602	38000000	1	CkpZwTRFSwzYoXXmMVPPXVN73pJGKFahenyPRwYbBLGP9aSB8NU5N
8426	fee_transfer	1688	38000000	1	CkpZuzpAq42LEgoDCrRn2xhKLHiZ48cz4jMKxbg6DwyXXZYAyveqc
8427	fee_transfer	1709	18000000	1	CkpYgtV9ccJ6HYe6xMCCbafVqH94mFfXdyFMXuUAkX9eMRfNQNYHT
8428	fee_transfer	2329	56000000	1	CkpaDjUbcNBYefFye8s2pf7zp4g96woB3Ek97ir2XgWejQS2MSiVQ
8429	fee_transfer	1807	24	1	CkpYis1ogVyoMd1atuTDVCfZaFwyaqgmtQdD13rjjsRjB3PayYFit
8430	fee_transfer	1394	17734016	1	CkpZYZU6BLeidPEufjUrPGm8YD84d6eYmJoP2gGYAM6cx2AAbuGWg
8431	fee_transfer	2004	18	1	CkpZVbs1Y63T6SFopJGnuL2K6N9eMq6nX7w29AzdijrAYEk5eCXBs
8432	fee_transfer	1672	57000000	1	CkpZBb8ZzxBL5HCLKHs4fXgFvHVgMTtxDthtaXMaQLwe4KVTYhiE9
8433	fee_transfer	2292	57000000	1	CkpZa8KdFZrNKRLHTBhrzFf8YqB7CZQHwrfTW2R2rUDf2hchavUDL
8434	fee_transfer	1747	57000000	1	CkpZunN6sSMSrVW9zPoAodzfnCqXZG9c88sE189oRSh8Fd4TpMJaN
8435	fee_transfer	1547	57000000	1	CkpZeVNdk1edLWcXAMxqmoV1XNjzWLbfenva7e2tRUdKQjLk8nJMy
8436	fee_transfer	606	17000000	1	CkpYQtgJk2EqoJwUqUdA3o3cbHAHQR5gPJn1eZz3iLTzimfkKfYaB
8437	fee_transfer	1608	15000000	1	CkpZKCmiMr3GKpAdzVRRzDy9ShjBA1CBH8QWr8pvybFijJFkisYEx
8438	fee_transfer	1688	13894559	1	CkpZdfkRQUuYjia5cj8SrXwkHyad29xqiQrJZbMBvuScXJCFyrWdN
8439	fee_transfer	1622	19974800	1	CkpZ5jD1bDRnCGuvdSoZ8jC9LTn7L9N8RFrV579dm9Zb65pSTdU4i
8440	fee_transfer	1419	19974800	1	Ckpa2qYsHvkgmaYJWafjthiKGMnKDSiVM7s7uZEXRVekp8sXvZkbz
8441	fee_transfer	1688	19000000	1	CkpZdrdS3DRBWyxFNE8WC46ZH8kMsAoEFUGGgYjgGPitY84TLm7Kw
8442	fee_transfer	1719	19000000	1	CkpYrMPmWJhvHC3fprpaU77eLBAbC6hBXzKdebCrSZ9L1hpmszkb4
8443	fee_transfer	369	49000000	1	CkpZ5LoVhD7HHR5zy8UJG9UCVAJagG486Hoxa5cgdEAtBwwFV4Nog
8444	fee_transfer	1719	49000000	1	CkpZwFcbn6857re9BngFuaWs4vn9hCJE6JQmrEqsX6cFhXMiGHATB
8445	fee_transfer	2329	49000000	1	CkpZrtBfbPGQNdR6vxtPFy7yBFA9EqeNRWx4A4BPHwW46evCwoPnf
8446	fee_transfer	1708	39000000	1	CkpaDLqRCM3d48K7rdnPGzGARZeEXx8cd8iT9DP7gDFrJfpb1HARg
8447	fee_transfer	1694	39000000	1	CkpYZTsh66UhFpAhRpVkahSE2VBFqxDhWokbaAgP7w77xBzEDuHLH
8448	fee_transfer	1684	38000000	1	CkpYmGPcTRjYKUjvDBocFiFeZDnfZgdRJYcgitRUMw5p936UdU2iv
8449	fee_transfer	1723	38000000	1	CkpYp3rxad62cCBqVa5mBsraPkCamXAwNK4UXJoDTWJ31veBBU9B4
8452	fee_transfer	1394	34854742	1	CkpZKKVsFoBpzWVNyASTDv9BEM7c3uP7phyMiKEdjPjDAgkfhbUSG
8453	fee_transfer	2004	45	1	CkpZwjvoiqz2Awf3tWKx1keSeF6tzZ6zErv6zFKBs7oiJ9FrGS7Ek
8456	fee_transfer	1549	38000000	1	CkpYyBcBimcqkb63t4gpKXtKLEfvVDxTJj99tzHsqVQnubXKyDvvf
8463	fee_transfer	1471	15000000	1	CkpaF3jB8gw1V17KxBhQBDg8xHK3dWM4nPqoZrPyvbnHDpbF7LuJQ
8467	fee_transfer	1549	19000000	1	CkpaJsLY33wHbmCub5ME6NfvsQnQakR9wcAiPooHD8yWtKEGBF3jm
8468	fee_transfer	1395	5749639	1	CkpZQDyj1o3TjYHEQX65CetgKXJSBs494Q4FdHcevjfMGgRfdQxu2
8469	fee_transfer	1684	5749639	1	CkpYR1TzimGhWoCJDQpTdwtV65sTC1CnNxN5qQkHHg1qMKME21xPM
8477	fee_transfer	1668	17000000	1	CkpYtivr96GhoPKCwfAZfHaAMAsYWTsD2KDXAQQ37HFj5BhW2XnzC
8480	fee_transfer	1560	18000000	1	CkpYyoRXwAj3MzfTDKBKhNNWHY8w9zTRFWLkBfPwdGEo9SoRFEEJs
8487	fee_transfer	1395	41000000	1	CkpYkCPwka4mf3uTWvk4KoHoxgiDQcF5PEm1ZmANfzMojneTn41gq
8494	fee_transfer	1547	7000000	1	CkpZmgEv8AR6HHwXn4vMPHFNvuZRYfYcXedkprccwCoUNKZ3PDF6L
8496	fee_transfer	1440	52031580	1	Ckpa4nVJjE3Be7RADYhV58DCUG4LQR6C3xd8sfEuwZ953squwfm1p
8498	fee_transfer	1668	55000000	1	CkpYhfBCbfwKvNaYwaoptEmHAYfUdxuEmP2Hf7sArXeh4ovLasKbP
8505	fee_transfer	1608	18000000	1	CkpZAcpbvzQ43ue9HiGCc31DKQuMhNvCotErrHTEbTZnRsNCJXT34
8507	fee_transfer	1509	17000000	1	CkpZCAZ4Ew8pt5FiimjUXUvGp9dqggdjuLg7EMDTj3895W5yXGHpV
8509	fee_transfer	326	17000000	1	CkpZb1FHgDYTS9JiSL26m4r7qZCRAweucMhBh6PFKdfu6Wy8k12JX
8510	fee_transfer	632	19000000	1	CkpYoeNxc6j6dnVhVPG2qh9TYeK7xkVXJghGdahJwY4XtMGBwUX56
8511	fee_transfer	1657	93975995	1	CkpZmbT7WcWp9fDJwpkVqrJLr2zPsGxbAz9cREXikFMkknDAxX66Q
8512	fee_transfer	2336	24000	1	CkpaKRFM6CPEEJdoCC2pMRNh3XNySmBCtFYLHY2SMnZxhxtWijUJ8
8519	fee_transfer	1509	66000000	1	Ckpa3nqs1HQdnUSvWHPgs1xC4AumeJLzy6y6jfULQDoaBhSV8CMy3
8520	fee_transfer	2407	1000000	1	CkpYt87VPtJ8HxpBMAEXA4KUs4UNpWp2cQbqCZk35vtsMZGCyQjDs
8521	fee_transfer	2126	500000	1	CkpYhW2tvZKbrvptyiAFAKgPy6vKZgMMfiu38eqwHAosodpJ7PRm3
8522	fee_transfer	1509	7074796	1	CkpZzShpE1QXTPgpXy1hhV9jVUwmzXcqanVL5NuiUFUbZW82yjW4B
8526	fee_transfer	1678	17449717	1	Ckpa6XzzUsADwUG2scpEktWTb7UBiubqaJRrCrXzqmWgychvjd9c5
8527	fee_transfer	2004	72	1	CkpZmvbnofhkohi2VA7UakpERw2Dt3ag9cJFbBvaiWAXeZjpsmMnf
8531	fee_transfer	1746	17000000	1	CkpYbd9GpAiQuWVxmXvv9VSHeG5zUL1LCB3iq3QBvsZfWpZ5nZN7b
8535	coinbase	1756	720000000000	1	CkpYaej6933NrkjYw5oo1rW4M8ckDu1NdoTsK3ji79ifKANTi5R3Z
8536	fee_transfer	2336	6000000	1	CkpZNwCby37qZ4UEv5VojPhaR1BZfGUxZ2atKkdRLJdZ5T5QYoZkZ
8537	fee_transfer	2252	500000	1	CkpZatroj1qaew1kYATQ5JDpeWQeFsVBkBNvd3P4WWXBggpMyA1aj
8538	fee_transfer	1756	210531580	1	CkpYsgMGsYmDpt9i6NFaAP92iSKx8AuDUJ55oF74guvYfoKz9migT
8539	fee_transfer	1693	28000000	1	CkpZwn8mBTDmWz1Kv1ohW9jYTY2kiYisrNpQ46X5fDNA33e56V2Ti
8543	fee_transfer	1634	1168156580	1	CkpaJh7866RLhaX6YMtYRuqzNYNaK5HnBZ1two5hN79kv8oYiehXQ
8544	fee_transfer	1634	13300000	1	Ckpa6EayKweD2X4bNWgu4Gud6zS4XEnin83Bb9cqXJPzH2Es7Q9oj
8545	fee_transfer	2252	700000	1	CkpaGtFo9vUsZKioux2H4Dw2HXZMEBzqfCzTXtwnjYsh3mRYMxC9A
8549	fee_transfer	1690	29000000	1	CkpZ9W5o6TdyCdasMSdsmAZeYoxc7FKx9JauaPKa2QhskEXWRCyaB
8551	fee_transfer	2329	26374898	1	CkpZBjPDyyDfEdYje24zoQ39RSMuhJieMnuRMzfCpCFunMD4UckrX
8566	fee_transfer_via_coinbase	2443	1000000024	1	CkpaB9zhBa5jcHepakPeUYDoT4nu2rd6XEbqHn8wk8XFnUdzSCujb
8567	coinbase	1634	720000000000	1	CkpZ44BCP4XJFJmxHNk55kCP84mY64VbPfaMhTkXJB1P3nnPPia7j
8570	fee_transfer	1719	46000000	1	CkpZEo3TjRB3T7HhshPKD6hdHUAoeyvNkR2XyyX4fLAs6ttgiFsdB
8571	fee_transfer	1719	11624587	1	CkpZin5pETnWk4uGVBBERTJRBpUi7zHFbUemc4422F8Chx7jnzLfr
8579	fee_transfer	1593	17000000	1	CkpZCDe1kRdmJ4TiZ4Rc4foH8DbzsATN62jHFQqdEtDSv6EfpWzNV
8588	fee_transfer	1693	19000000	1	CkpYp8KY29xuARxmMphYAtkdbnAAUNLtsXFHT2WNWUPEDSPxukLi1
8590	fee_transfer	2329	19000000	1	CkpZnidMnuykDrDJf5tgumhsBwxH6798kVt1Y3o2FmcfArsF5v3Xf
8592	fee_transfer	610	19000000	1	CkpaB8GhUaJejGHrz1ZE9zGohpNsPvNRuyi9LkZvg1Hqgfx4zuJZ9
8594	fee_transfer	1402	9399671	1	CkpZ6jCuNawiyY9ACd9tRgoPkt3PgmbSLQcKQdmiuNHd8QYMwKbBb
8599	fee_transfer	610	20000000	1	CkpZ9dtBWtkbjFibPcGMMJxpV1bWQTKJwTaoA1Q6njp7c3HCXKe99
8600	fee_transfer	1573	19000000	1	CkpZLpktgt7LrJtgtzb8mg4Qopi1VSPYJiBBBfpGK2Amj55hJS1Yf
8606	fee_transfer	2148	179000000	1	CkpZroc68zncsEW7Qef8mjZU9pFbH5L35F2B9oo6ruh1ajhUd8WQH
8607	fee_transfer	632	179000000	1	CkpaGkW5qy14PaxRbP7coQ8BdNpySxyZNxUZyvzKCGKTqyqt8gRiY
8620	fee_transfer	1602	59687500	1	CkpaJrYuoFj6bS8rKgXrGfdZ1CNgnnYhNCdLNbMvsBBc9oXRa58Qf
8630	fee_transfer	610	15000000	1	CkpZMvAWy9344tBkYDx5zcBDuEgFTAhB7k9j84BtaQ9u1CYZQwKSK
8636	fee_transfer	1746	113000000	1	CkpYZXxj6sMRGnPLZ8QqVm82mp5HGBdZvspTQwU111PTcFB9MBaYv
8638	fee_transfer	1747	136000000	1	CkpYr9jdxmWffPqEZxAWh85L628ThuzF1v3AUS9suSpbRDuMrU8CQ
8642	fee_transfer	1690	939967	1	CkpZ32pa3Ew8zUxRQH936qivqyhv1tHgTAszoXLbTsSND4Sk9x4DQ
8643	fee_transfer	2332	10000	1	CkpYrbT9qHtxDNNQ4wSAjyyBPaYiYWgA51mpZXS1BfKpxcB1CTkBZ
8450	fee_transfer	1768	19000000	1	CkpZDdU7eywNkGbKbwwEMkmR5wKUhbixStw8cpyxHRueAe15CpS8d
8459	fee_transfer	2112	1964479	1	CkpZjwV3X8op4yCJ1d9V8L4x1ePg83WcWpUftzYpDmfqR7tHVseie
8460	fee_transfer	1807	9	1	CkpZDsoG99hxSKHH8gKPFoUojsUhFTmeRsLhir3hpwgwJ5QDUjHVy
8461	coinbase	1723	720000000000	1	Ckpa53jdQxXxNM3HxToi3M7NLTcNg7wmYMbb4xUxt84upYFkn3V7d
8462	fee_transfer	1723	17999788	1	CkpZj1iN6EPzZoysKcRa2PipUrkgK8rwmCT9QcciZZ5nK8nCaTPxp
8465	fee_transfer	1672	118000000	1	CkpZg3F7TrmyQBrWBVsY3gMm2MXghg7V5yf9vMW2s41jwoKdrx2Lt
8466	fee_transfer	1547	18000000	1	CkpYWSjNBjS3n1JHEu6XnZMKxnVCjuwrnsBMYbhcUs8Jy7vdt6ua9
8474	fee_transfer	1657	18000000	1	CkpYjkxNSmax8hSXJzuckby7Zyn88x7fVKnFY8Q5eLdozf3xwMper
8475	fee_transfer	1694	18000000	1	CkpYWZRvZswpSATCQZrMUTzsDbqsdhyE1SV7nnCWyCY7Dx7GhwjKe
8476	fee_transfer	1668	18000000	1	CkpZ7NDqV98ZoZo3HxabxsjhjQ8CJrCJ3C2V6k6QX7iQ4UuAb3rgS
8478	fee_transfer	1717	761000000	1	CkpZ7L6UYXCwr99DHFzAXwbi8cqPEKwABgsw6Ues6T5aDWuQUsKut
8479	fee_transfer	1717	25824351	1	CkpZmUwwkiQSf24aABGn3SvyBUVvJRZ47BWUytiPKubhAeUua7yRf
8481	fee_transfer	1702	18000000	1	CkpZyH6rYWCmX63QjcXSENueUobsv2Qo8eQww728Qz6FmFA2xnzQQ
8484	fee_transfer	2393	43000000	1	CkpZCPGZsKRTRgQN6sYVC1e9e7YsGnhpctSiGSEpQt1JF19XYrQce
8485	fee_transfer	2393	6000000	1	CkpZ9wxWWoWjUqSrV8jqmDjGZronkRiw5xay88FrgaA66pTmFPEZn
8488	fee_transfer	1679	38000000	1	CkpZRrfjmwgJcWCLtSUMH98JiRt7z9eNWub78AeB5GudJzWjvErYT
8490	fee_transfer	341	38000000	1	CkpZwf25vhd3Loz1trk6oaaLpMb84XhwmYahoX7cKjDmYQxUEoZ4g
8491	fee_transfer	1905	1000	1	CkpZhgTxujCUkZYy9YaDgxrAwkuZMWH4PMLf1K2FYV1je2mVYTXuc
8492	fee_transfer	341	14999000	1	CkpYiuNPxKbigTJScgMGubnX3CSMMBL2PKbq7EyZGr1zPnxPdZrdz
8504	fee_transfer	1719	21000000	1	Ckpa4qhGrQdJM7Pjx96ezmgi9PGoHCjCwv35JnPmtQJgjgyMXhgiB
8513	fee_transfer	1508	93975995	1	CkpYWtoXQTDhHpRdTo3C7Y71WKP9fWqD9oZwF81N5G85ubJrEni6i
8514	fee_transfer	1670	26000000	1	Ckpa2EMBuzuAsw9Kwc5U3T5B4tz7XmcBuhkzrTueRwgSWFuZKq174
8524	fee_transfer	1599	66000000	1	CkpYvQSrdnbkDY9UqVsmsizEX11Zm6A24QA6JVCQtcyUh1ZfnTe1T
8525	fee_transfer	1599	8074695	1	CkpaH4ta6ytE6UFrdNvUJPFig6ZCKwyHh9Qtz1CbouuN2v85PJ125
8540	fee_transfer	1444	17000000	1	CkpZJdvxQc21k7UH8TD2SLibDqUDK58HQLu9gHYS8HJ1c3yveDdik
8557	fee_transfer	1714	29000000	1	CkpaGyPvy2mDypC5YWvTvFm92zv2XfkTQTBvgzqKbj3TgsWqqJCXh
8558	fee_transfer	1680	63000000	1	CkpYSY92g4qeAjiShpYcFNFdH5VgxWRytHDRirfmY1hDy15fzeZR6
8559	fee_transfer	2148	45000000	1	CkpYbba2t17UhFfZwrmFUhZPStXw62wT2bSTUCNfsYeHCqF6zMuQ4
8561	fee_transfer	2329	45000000	1	CkpZkgCTdNoGAYecvyxVPNpY1PTWusK3eAQS1LTRD6fBcQCErimGT
8565	fee_transfer	2148	26000000	1	CkpZFhucv4kcpqUkMUiPwKgqeng6GLJgvyT1RmDkRGHsdryvQw3Db
8568	fee_transfer	2221	200000	1	CkpZU9CBUoH9o6PL8ekduoBgj1Nxou6yK6pjifVVCnQ7iMaT62hpx
8569	fee_transfer	1394	12624587	1	CkpaHFRmsvcyhaTmLMKK5CC65CwGKNBB3W6NRrxa1Cd4ZZtRCCU6h
8575	fee_transfer	1747	26934869	1	CkpaDnFnaGVkRcSMsg5ryWAY4DVWtkcpeFyEdkJiv3szSWX3ZbC1Z
8578	fee_transfer	1439	26934869	1	CkpZ2DKv8KwV9LZiERnkEaeTbJDzH2oTw6g4kMyHHoRuK9z48xk1F
8580	fee_transfer	1593	570215204	1	Ckpa8t19QiNUagTjXJvRfHJyUkFo18JfAYE7FGbfh9Qy3wZMR4DJm
8581	fee_transfer	152	300000	1	CkpYzW4CEbgP4mBj4e2AurJCQSVuVYxMDvh27XjqexRykoUA9uQ3T
8582	fee_transfer	2143	200000	1	CkpZZ1RLUjkPQPP5PHqzCCSmriCCit6VQpfFaJcPw4S3EbvEHbAkE
8583	fee_transfer	2407	3000000	1	CkpYWknrPMYMCEQaQ6LDiJtq2mvUDgWP5RmtC6GRdRuafGD4obRAn
8584	fee_transfer	1593	322054008	1	CkpZiMe8oPV24SEz1TNQxsn8hxrYQ3icP7np5LuUYD67MuUNdGK6s
8585	fee_transfer	2143	300000	1	CkpZDr918vkgtoo7QqSfQvUnHRj15p3xa4uHGebqz7khrrzgj8Dkd
8586	fee_transfer	2358	13000000	1	CkpZc6pzVB4YHYYJnu4QsSgok3EN8ahmS7kUYA7bKBzjPXBRDQpzZ
8591	fee_transfer	1619	15000000	1	CkpYp1T5cTB2GaCqMrgbdSrSE2qYmtHwz7NqRNCSEceTm74UBErZ3
8597	fee_transfer	1670	9999689	1	CkpYn4KZvXa8Hd8PBx7iJSaitMeHsbCbiTAr1LjBJDiXeDXzF6Uyg
8602	fee_transfer	1673	35504653	1	CkpYv9JF4iKpRFZ1S1J9dA34b13zcFJ6q4pkMduzPpq2wm9syRfgp
8603	fee_transfer	2332	20200	1	CkpYV7XsBnuSfyVBDEyfvEVc7ZGjrTW4eVsTEu9hg6nUwA7gF1scB
8612	fee_transfer	1467	41000000	1	Ckpa47arHbSc615oXHrpZvrVmcfMxaqV9n5PKXGkoAHAVWMB85qdH
8613	fee_transfer	1467	18849857	1	CkpZHB9RyDq9iicSNK4MjREqk9Avke6365P9fBHbJkNM9zzXq4pTn
8617	fee_transfer	1672	31899790	1	CkpZqfAYWeQVajtdzpZuj94o7xcPygzQ9Me9XEj6z3TqfjCqnQ5R2
8618	fee_transfer	1711	20642860	1	CkpZDVki5tJ8zcE8QTi8JvSAL8LUavWDTVi35ffJGX5nSfbm1jSyt
8634	fee_transfer	1608	16000000	1	CkpYaifbx4jdhLWP2oyEDjnTreRkk77vizkp3UN94Yms3LcdXmXV6
8639	fee_transfer	1395	136000000	1	CkpZ3V6tLj7CT3MVyk24ZFSBM7ZySyo6MLF71kUfHg3A2ewsBDyon
8640	fee_transfer	1608	35000000	1	CkpZ5LFb1mpUdAWnCiWUgqhxrALiSA4MrQyCGYG6xB1AcPcs4WZUM
8451	fee_transfer	497	19000000	1	CkpZ1fGE1ahJxn1ezPzFDysima1oGdxLpnb4QybDpywT3puz8Y9RR
8454	fee_transfer	1549	34854742	1	CkpZYd6BkruddAVEEe9iKeWpCTrYiHuUbP4XGvBDka97uzePq5fDu
8458	fee_transfer	1657	59000000	1	CkpYySzb9BfcrLzQ9pa4jSbodEj31kbHQrSrkTWvfhmpxDH9N7RyX
8464	fee_transfer	2329	17000000	1	CkpZU8U2RtBG8d4ovyamxNJC3zAwZhZ6jVUw4oKC3WaaUkrjbLr9K
8471	fee_transfer	2126	150000	1	CkpZbLcC6rwZ7HdYgfxi6Q5VJouLMLHv8T1JVa1TCXMYMRxbCqqtR
8472	fee_transfer	1684	3724645	1	CkpZisqrSFriwZeiBLMo1THYxuQezoCWgcwbV5XtjdvpEPUUbzg69
8473	fee_transfer	1611	17990000	1	CkpYpcZFT9wUFjCfqe6fz7ZBYg4o4hQ6c1nQCRthjzQyqZh734fVB
8482	coinbase	2393	720000000000	1	CkpZiuJC2PZsd7588MhBgytrcZz3a9rYYyaXSqGMe9rDqtpch5ktB
8483	fee_transfer	2393	30000000	1	CkpYpArpQhuJ2WqBscbrntQMRjHxxSxkHpQ93bGqboRE8SbphWSge
8486	fee_transfer	2393	19000000	1	CkpYy5bY95bfXXYpeNxV5DQYVujogqnTTGVcweNRX6oNaQFvaDbvR
8489	fee_transfer	1476	38000000	1	CkpYX2L6qG8jwPoun1Z9QZxko2nKHLXfAg92jBE69DqMQHpuDH8Rr
8495	fee_transfer	1549	52031580	1	CkpZnfRpmFo4pTB7JNS3zPWk8KMous492J2PbbRCq8wu32UZyNJmV
8499	fee_transfer	1395	27699564	1	Ckpa9Pqw6NXDk3yegenVsNBR37kn6XRY6JVVk74MUjLXkuwB35bWT
8500	fee_transfer	2430	100000	1	CkpZsq1JyKbux9S7RgtGX5wEEgJK27QNewH7Uojrk3kGmsovXyAek
8506	fee_transfer	1594	19000000	1	CkpZ7idVW69CRF4C31ew62YktcBtkbVUSNXZQ3zavEyC97M4Epcz2
8508	fee_transfer	1457	17000000	1	CkpZxq6CicQi2Vx6yVxcucrphb6vjKbt4FRFNDFAZP3Py76vyooKS
8515	coinbase	216	720000000000	1	CkpaAP9w6Dpq3hfiXhrzUQW6iKYdPsH1iwcC4i7W5o3qAaA6SamC5
8516	fee_transfer	216	17000000	1	CkpZ9jtGoRG22byXkyirxYDtbzNq7e8GQcdG3wXoe8G94gV15ZZ4Y
8517	fee_transfer_via_coinbase	2358	1000000000	1	CkpYW2ywoUuNj3byAyKShC4EJRqFEoZsxRex6rEa28p9ztNz8kMf9
8518	coinbase	1756	720000000000	1	CkpZzdskq7mqWq1jG1xMsyVKgCuF9hZizZjy6NEwJVP9S6a1weMJn
8523	fee_transfer	1509	8074695	1	CkpZUHFFaQgvAXJRQUtKrmpN6rB8eMACpqsBw3FryxrBVg3SaVf18
8529	fee_transfer	1587	17449717	1	CkpZg4S554nRAKWjbzduHhKeNzGnDov4JsS69QayYCpqomScuxJbq
8533	fee_transfer	42	18000000	1	CkpZDkD6kSu7V9PduZp8AYHuQ2zo4TjodqQgN2MkVzunbhp9JMp59
8541	fee_transfer	1749	17000000	1	Ckpa9HkyZFWyt8YbxGawAGAtTz81854wbMU1K5dVrEfvyWD2ZtAeE
8546	fee_transfer	2261	33000000	1	CkpZqMuPb3VBb8ubMtSRNSevramQe3763c9PK3k4ntGcTChWDaFDA
8547	fee_transfer	2221	130000	1	CkpaCTyqSA1UL4gU7WMBv9eizLPPtATsq93vcAUezABZZrmHdPVNt
8548	fee_transfer	2261	3604546	1	Ckpa6cQuhX9WWu4pea7WFhd83FG2CsjFC7o8ipFCarSRTWjsCUJzh
8550	fee_transfer	1395	26374898	1	CkpZ94e1aFXRFgs1LzGN4JxgZF5VBGmTn6xVkNH7U5j7EybkYf37v
8553	fee_transfer	2261	291000000	1	CkpZJzsTXorSS1tuiujkmuhZHqyP7LHFG1QuR2q53hXXZJdhgh8YH
8555	fee_transfer	1688	7000000	1	CkpYth1swva3YEqP9DAChuYkJDQ56KPTWLUYtBfsckYvZKMzLPjYT
8560	fee_transfer	1596	45000000	1	CkpZiBYXzVF9P2zEFuXpHErx5ovVNEuQjSxuPxuJebFVy8F7e6AzQ
8562	fee_transfer	369	338000000	1	CkpZ4VHFLaJof9hGdZps45gitHXyQGvBYYtBwX2SPmSV3RcN8s3YS
8563	fee_transfer	152	400000	1	CkpZeygMmYSaC8jVTSw3M5hPeFCcoPcGV5K8pofDiAVVaq9zw2KAe
8564	fee_transfer	369	416234645	1	CkpaEg2NUsybw5STu4LyAbBKWTmh54xv7rcPoWf76ZxfZXPKydEYe
8573	fee_transfer	1746	26934869	1	CkpZ17mDqV3q6jdUNzyzpzJm8ygtWuY2PG6KckNJQeNwJAGGBCuvL
8576	fee_transfer	632	27934869	1	CkpZyDzuyh1sezPwSTvSbMmXGdFgSTpUn5U73q9WP894AtJWdipo6
8587	fee_transfer	484	20250000	1	CkpZqZXKbAFNmNREK1bu8UVS7dDLSCJGSJkpHgii9nozSaGbPhhhv
8589	fee_transfer	1718	19000000	1	CkpYVhirHKkwCMihBiJyLx4DxnhrVuZPWSQbY8Y8o2AG5wEaobMFj
8593	fee_transfer	1693	5000000	1	CkpZXGd5sG4txfK4jEtudSXDw7dfGQYdkQEzgKUinavTKdwu4wj8y
8595	fee_transfer	1670	15999689	1	Ckpa49vvyWTsJFM62uPFtcSZJHAW9iCZ3yEqXHF1Bx8EYVnkypkBt
8598	fee_transfer	2112	16000000	1	CkpaLEkkKgNE5cKjxkSBbkqfG51mSupDvttyPoB87XAX8umm3zVUZ
8605	fee_transfer	1394	35504653	1	CkpYrYKXzLQvyFPvNu1vuWMU581CbvJgKv4ZyD35JPS418U8qzKxy
8608	fee_transfer	2148	104000000	1	CkpYruMbsBxWfCZfNK9fB4fmHQ7XLWhzUa5DJoeUMMSWz1oHoiDX3
8610	fee_transfer	2148	87000000	1	CkpYyBhiztV4XkSVEPEX3BqeLzWCgDce9uZeUTF5gJvUbdKr9rxcM
8616	fee_transfer	1672	40899790	1	Ckpa4Pdebp1wGfNaqdAxvzCBazcoNXJZdxLeM5NiV3VbDEQNqr2sE
8621	fee_transfer	1602	76687500	1	CkpZL5k3X89ECPnGLhimfZWHFzzg2WKRF6gkiFc6FqnMyP5H9UjFb
8625	fee_transfer	1679	17089975	1	Ckpa9mycMDTziyCHTMgAVxqQEfPhxX5jsezck7PfMvfNQRkWUZyJD
8626	fee_transfer	2332	20000	1	CkpZbvmn9DjXwpzws4pqdYhWNWv6wxYTjboqjhboCVQ6U7MtCgXny
8629	fee_transfer	1718	15000000	1	CkpZNW3JMRRbvGWMr8oXCNj2DCasgnt7JbqcJYQjBXktg8Sofk67J
8631	fee_transfer	1610	31000000	1	CkpYTpPRQXTw2J92znYUeDJFURfgv7z96ScJedamJjakQaUZrTGW1
8633	fee_transfer	2329	31000000	1	CkpZdxRBNiYRbU6j4AhutM7y3pLbeyASESju1X39mrR4rMWcMMXDf
8637	fee_transfer	2292	136000000	1	CkpZVrhYKGAyEBt2yzbgKxKYFkYQQvmtTvWK1WdAgUXkzMzg8KxvV
8641	fee_transfer	1685	17000000	1	CkpZAP2gNjHwMozc8VHjwuFUSDt2EcdMmDhiX8rS3twLQb2FQHp7Z
8455	fee_transfer	1680	38000000	1	CkpZf9X8gjaq6aPZ3Jo52o7L4sAe9icRm8FfHwxrBUSrVW78jEq8Y
8457	fee_transfer	1657	36000000	1	CkpYqRhtDPFFnGUL3fdqKPKWTG9PixriFYsfwjrYabUS9c1yUS8x8
8470	fee_transfer	1688	5749639	1	CkpZBxP6oEp2GmzmvEFrkcwYWyyb1wyuJFwo15vN2cFYVASwVRWXU
8493	fee_transfer	1476	41000000	1	CkpZ6LZ1bLGqekaT47fsbKJkHoJEPEovtixCnUKdbiYSJcjTqcbVj
8497	fee_transfer	2306	52031580	1	CkpZgPi2RQsDmcNefNUsY4HgauH9a6WxgegCrBvvdRQSr7i4JGRYr
8501	fee_transfer	1602	27699564	1	CkpYswbpXVL8vS6fjvspcJfjJY9HnXvJeopw42Hxa4fMkyRbn6MA7
8502	fee_transfer	1680	15000000	1	CkpYrCSnxekQnNHwtpWyAGvuSbKJVNEYQtSnAZegiuXBv5N5Qh56g
8503	fee_transfer	1619	19000000	1	CkpZnmr1PjgtJ11kT1cARYT9pEWSu5twZyfURxnjUmbHtkhrGzJ5w
8528	fee_transfer	1701	16449717	1	CkpZ3uVrriesGG6m9eKrzWrCS2ksLWsgvrRkojKApENZxkKeXaW1K
8530	fee_transfer	2292	17000000	1	CkpZjgv5WYDYevPFPr2wo9D5RtCqZo9i7WXtJV1LpZfZYeygKKePR
8532	fee_transfer	1747	17000000	1	CkpZNB9GRGSobXqhvwG1n2xbVNNTrjJSXV4WXhyNQjwfMHBNdqcag
8534	fee_transfer	1559	18000000	1	CkpZJYZTw3smeUVQkokzMjohCe8zBWF25aVNQGnZbWiJb96eVcFXd
8542	fee_transfer	1610	17000000	1	CkpYsvCHdtHmwB6z8BU8K4zWWzaQeHeK6xzTKGUpeNiiTWArNHa9b
8552	fee_transfer	2261	303000000	1	CkpYVtzBM34UBYuh4T5tzFCgsxyNRVgeSrrosSooEWVYVYC6eXNfs
8554	fee_transfer	1692	303000000	1	CkpZcxMoah6FUYYAN88SsuAMBZGrfhoYzfqdSEV35jZ5TximifXvT
8556	fee_transfer	1684	29000000	1	CkpZwEeCZhtD7qQbbs2vqyy44GvrU65Mvbi9rReT74QkuGdDruJks
8572	fee_transfer	1719	12624587	1	CkpZ73Zd5u6T3kLwpjfMYTSSYyqE7692EHFxUkH8ACmJVhoMWQwxj
8574	fee_transfer	2292	26934869	1	CkpYcsos5SR6NvaYDDqskPeihFrVArqmsq4NZxSbybz7p5SfjZVAK
8577	fee_transfer	632	26934869	1	CkpZY56i6vNzJh4mfZ8avfvn4Ydg1nzFSkaVtZx5jjKn3Q2MmURY2
8596	fee_transfer	1670	11999689	1	CkpYcicXCE1A9YKTBSD5bMQJapAMudvhwtg2Nvd3aasftEiTCg3uo
8601	fee_transfer	1457	974789	1	CkpZ7cF9twr8WseZ5VevL9HrsBedmpRmhdyESeGeSax1AyS5fuN1j
8604	fee_transfer	1564	35504653	1	CkpZHCdw9rWXx86qrwrBB6tMY73FKWTDf48SfByCBcmW2gVrYnGjx
8609	fee_transfer	1402	94000000	1	CkpYhbZ8jLLQEskynXZRxucDBbSmy6MfiAHu24E2aggX3tm1KWqgs
8611	fee_transfer	2148	50000000	1	CkpZUhQk9ikf4GbUNYj4wMx3BpJfpjLRmY3LYdkWw6RBkcizAE7wa
8614	fee_transfer	43	1585021580	1	CkpZhWhYXoWW98TtmMZikziSzpQJToZ3KV7K87icnhkWtYjfM8FPw
8615	fee_transfer	43	7974786	1	CkpZ7D5QoPokQb54y8eAMQ7qYSrkxVB3DyeSfuXPpvgk1mDFNYDsn
8619	fee_transfer	1623	20642860	1	Ckpa44wZ9Rka5EhjKRCcnc1zkY7jxrnakJRs8dtaW8bpxGDNXJC6u
8622	fee_transfer	1705	7370833	1	Ckpa5wknoPq2iW5mStSWS738rcqJjnTS51FTgjAwQsLzTPy667UM5
8623	fee_transfer	2332	30000	1	CkpZ4pczmHJFBhVt7v6Go8qy3vvGKQd7Ui9gCbv62SdoiAGc6F5bn
8624	fee_transfer	2004	54	1	CkpYzJxweHjk2PiV7JSpb2TYuv56VZQXcnicibRTVSKPeWA2tfttX
8627	fee_transfer	1686	17000000	1	CkpZAHkNBigMGBFMdRoobDSYH5hP57rPtHtEr96axwZbC13WVwcFd
8628	fee_transfer	1716	266330360	1	CkpaHuQybYLbTRpDu7g1hCxpgmZ5ogskqjM43DgWJTwccs3QbpP3R
8632	fee_transfer	1471	31000000	1	CkpYmcM6zBHA6f75tVsEL3PoHLBG9eJvwj85jJ6rdHEdMKEJEs1oU
8635	fee_transfer	1455	16000000	1	CkpZt6ra3kzEHNrTzRyxccz5XMdfqme7Sn947aKKKxjAk3nFktnMC
8644	fee_transfer	1587	939967	1	CkpaCNtYHx55rj2Q33JWEiY8TAqnaLDAQa8cKvUxtWXGkgEHHuoMD
\.


--
-- Data for Name: public_keys; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.public_keys (id, value) FROM stdin;
1	B62qmqMrgPshhHKLJ7DqWn1KeizEgga5MuGmWb2bXajUnyivfeMW6JE
2	B62qmVHmj3mNhouDf1hyQFCSt3ATuttrxozMunxYMLctMvnk5y7nas1
3	B62qjX1zTYtJqCg6c7VHYjTzGTEgzzYxE1ArGZMZQpoukrGXaDFq5aW
4	B62qqDJCQsfDoHJvJCh1hgTpiVbmgBg8SbNKLMXsjuVsX5pxCELDyFk
5	B62qkbdgRRJJfqcyVd23s9tgCkNYuGMCmZHKijnJGqYgs9N3UdjcRtR
6	B62qqMo7X8i2NnMxrtKf3PAWfbEADk4V1ojWhGeH6Gvye9hrMjBiZjM
7	B62qnbhwgpyQzSSo9Sea1wEbEMjr4WhtzeQWRzAfA94fjros6UbSiF6
8	B62qpPsUkaaWC2VPzY9MBnQtUxYRFCCKHf9uXTZri4duUXGb3F3tmX6
9	B62qqwnvUmQNkVWwmz7Q4DEK7frPYMU9wCawjrUmA39Af3FtaVz1WzY
10	B62qqomhidaLc7wbYPeaHkGkzXVNA9z7pqf8nL7UjiSZKmLmVT1mPEB
11	B62qkYyCBSWdRQPkC1C3KdhNxvoVDxK3sUjVBMkV3GZ13daCPszYxJ3
12	B62qnHA8SYctwuFL11w1ZQ6MPyxCE7a44mqG1wk3DQzwkE9uzCGk5iZ
13	B62qqnZWjM68fMq7jVR19fGDnrigtYX9WZ14enXFiLZkE13WDe4aLy3
14	B62qoZ1MjrwCCGgq6AUSxb9dx23FzoS6rABLtmCxKh3TuNaymR9Lsnj
15	B62qrMBmbcHLZbsQsmdt8TjJAxLzAohmMRmoBweq1sXw9oBfQRd8ayV
16	B62qpFzTCTjEyTi1xRsyuE8aJD4oZvbWVmC8H6jpguHZuyoXKHZpd43
17	B62qife4P6rHK2iTnqYDGdnbnLBDHCWRcUBLPt4hiKYCxntRbSggo7k
18	B62qmC9ypxkPz9pgwxvrUPL65b6yNQTUWpUgAkqN5R7UurwuSaUV2r3
19	B62qmoWgbRAE4X5GyD4kMs3CH2wj39tjMATZLWb7zjg4kWn3Pp1QuiP
20	B62qrMi68WSSWpmb3Yfp7ztzAFx6gUyF26VAzPNgYEoYKRASRj2pqZK
21	B62qjWCpSvwkVNub2Cmbwg7s15RMK3WpS4zCyGTjacCcLeWx4JHdCf1
22	B62qpR8BVdV86jgnzCzHebvAcSVnKb4yWigJBrUWmdDUZy1qsHtHUrG
23	B62qnx5hKBFHZFUFjpEXzh2du8wRegCHrp3kL17gY7qxMBFQcBycJM5
24	B62qoGasCeX5M5HyK95AKLh6eXK92tBgAfkVJPuS8A8NkATuMjRxSbF
25	B62qj1zaXZxuRGzYfuq2KBSWvoei73uGZw4yqzRNTW6xiff5TGy6VJe
26	B62qrzgDHmFmnuq6HSLBd7kERXepvfKcoBqTRS4JcBCMETcdFk4rwG9
27	B62qr5Ckko96JXfECA79Vp1TNn6KUYLQ8x6m1QVk38e1uNgupVK1j1v
28	B62qrJBx8f9rpna3QzJwpuFX3Jzb1DmdVJxyXof6nDBLBrYryR8Kh4s
29	B62qkrhfb1e3fV2HCsFxvnjKp1Yu4UyVpytucWDW16Ri3rzG9Ew2cF4
30	B62qnzyWXFmSALrg5E5mSrYo8o1WaYEcFZ2bDDMxNUUyP4y2SCsQtB8
31	B62qpnYDuvSsk8tKgDxnXEWySd5zuyj7tbTc2qzPQ9eU9mjJnZEYkeu
32	B62qnxw3GS7TPFiHydSwH8qd2FJ6tm9j2qk3xUFi73DvP6H6LWteRAh
33	B62qjZD48ymWaV9jra4LyZMhLUiJa4XbXpH5JxD1pFsrg1pjXfbcjRf
34	B62qq8Zswd4JHeoTkWAVs5fSYDwywKcZDnNiZpyHSDJz3HqD7A73Esc
35	B62qraStik5h6MHyJdB39Qd2gY2pPHaKsZFLWVNEv2h3F85T4DmtjC7
36	B62qqfnfVegeAMKRsUaQX4zUrPttA2ZZgZy5fX8uw3cfRMh4HQMbmvJ
37	B62qqrn3yzWRDJrUni6cRva4t51AcnY1o1pM4xpB78MfHUH3ajZu1Ko
38	B62qkUQyaxfFNtoMXoZwa6Ar9pXPzhzeWCEsvvN1Eb6KfDeP5PgXJFv
39	B62qndRjyGhBTS1GJEmSX1VQr4u7zcDXATpgqddoLF9SSScjcMqqoB8
40	B62qogNhfVvpDE2mXJMjJ9CT6DtVAMr6Be71xFS7b7sdNYSfvaQBAkb
41	B62qoB8RRURcit5keJXvq7uXzYkgN4Lsz5GFaVpGYdA9vAiASy3iBcD
42	B62qixi4dP7DcKdTNcK8jobtv9qKFjxf7ZgZVoQcJXVXkeAULe3hT5E
43	B62qn7HrKKt5ia1dvGYHuvuFGLdwNSXUSAERQgvS2yZbZvVaK5biQef
44	B62qijDC2gCTtcqYGnUAc9YgH2Uw4fzr8xEKKL4faZmWyAypgEe3oWC
45	B62qmdsqUB7b3GYTWmCTGSioxMKeSesj4JrcRQRmmPRqwTtTo6xdYDz
46	B62qqiV28EmAXco2BuXoL4wSz3UHCv7zG387FnqYoiCkwNJWRywJ3KQ
47	B62qnSEkCtGJcTD4eJJvSHnZNsqP8aww4kdW3GGfYir4XTnXTjeED34
48	B62qpujwq2HQtwJnjj9vYgjDq8hJyXnTdMWSMyZxHBQQqEoEYfybL8x
49	B62qowpMhZ2Ww7b8xQxcK7rrpfsL5Nt5Yz5uxaizUBKqpeZUqBETa31
50	B62qo3mKb7LGbJhT5f1SqeHThWhYeQkQ7RH59S5imK69pa9WeTMudi5
51	B62qixNMEVEmPMMgt4M4FDdDHdUyj5ZaZtpN5cTzPiWFYubHaUUs7CD
52	B62qmG9DytrgGor58qQaxhSwdCzR5skbZtVWs3GsY5ywXdAoDCqBaNf
53	B62qmAkbNGBdaWSM32cqvKWA2nzySujjJbKPxqNfs2V6es8rXZDtsjv
54	B62qrdiTDeX3AP6aHn62WUsQ3dT7mH7zA6YUGmJ5R9FJDTac4j6DmPA
55	B62qqoBaTeqq6K5kpPEBh22HHq2BJ3ukegb4csDDoyoaFzdpgKLidYS
56	B62qqrTPrFvi3bvcGrM7zCgc7YWug74PhzRBGzBr19ao5teNQNigxSZ
57	B62qj5tVzR8JEoLWYYE95tXaACqGD7ew7vk6TnTCVdEfCo6nUtvggbV
58	B62qoXQhp63oNsLSN9Dy7wcF3PzLmdBnnin2rTnNWLbpgF7diABciU6
59	B62qiW2BLxkiXcjVrhuhvxH8QTMcFHQ5HKs7yfuqwx2pooyZKsjq6Ei
60	B62qoJVEF8K9n5Vsqm3dtuqSzxAFC5ppL5zcdYL8gJJFUuedQoLTLbK
61	B62qpYxXxVozLf4QRhxfKptR5Pz2nJoCoPVwiDjvJGAiijf8aHDoy5f
62	B62qo7F5ccXnDoeH5tazsr32uy6cfM3qjjR6AofCMBb9axfA3EzSgP5
63	B62qrJb5c4yaeL5fDCrEU5tGsmJWbcfnkdW1pMQbGT1rAnnA2JjAP6h
64	B62qjwAoLA1iT82EQQidZDDovQND5PeJtmcZXq7USbNDGEqgYnBbKam
65	B62qmbNN5xihYm7Z6b5sEdJNzAqppJ3jnk15QppaJUCuqMuWfMP3JNX
66	B62qjZfVCSKPAeFp1GZBZFPp6jP2fdAxLQiGr4NrhCk5trGPRMHFthD
67	B62qoUaRmzxG3atakF3bnpHT8enYCCq9UaUyAV4JZXyN16GMgJmYkHC
68	B62qjYqfAWQPikmwLARjwG9vpaNgCYEFT4RaEYjoNEsmXCVXb3HWonL
69	B62qqj1YzdmiHE43B3CYXbi6vU7o4x5ZiwVWnR2WQiUxfx1CNDHnzg4
70	B62qnj6wXxdvbPkas4Fxrz4cbncpE2yMPiMfZT8kmDSvGScYpT3AsFF
71	B62qkvWArUfzfzQYorVPSqKUbv45BHE7FWYgSgaCAFRVipVQjbZE7Ss
72	B62qnEoBEjGFRb735UzzoGAzpQgvUK3umJu4aZZsakkr1E64MVC7ySK
73	B62qmLP83WABda9CceWg5RjbzS6rNiwFg8FzxmZyXKyj5duSGhE8qAo
74	B62qkDvSJpbRh7GYq7jwuKaRCbQ8ifw3syWyVexJRu6KtZNbTpNTR5t
75	B62qqpJCDYAFpFMgm1FSCwvY1E4r4EPmoH7bBJkuGsGJ3hm3cpFLGSE
76	B62qpmq5XCNpv12G125tnrGtcJJnMD5qEQ8Riw9LLEtjxAQ1wNjywYm
77	B62qnXPppCEaxMQYSqYPNq1nYWFSYLJvmCsQmuD79F4L21sBmUoT34N
78	B62qrR8VjjKrijdZ9HgUg5D33CrNCWhDdJr8gvmdFFCizCGgaeANhXT
79	B62qndKQurk75DGcgVb1ZLv9NGfCtAAP9g7JtoB9rAuaT93WkE55rbz
80	B62qkd4tZQGe9mo5tK3wQi5PUoMdtUGtLWps6Se9o1qWdwNwuUtdWdr
81	B62qkBgrQRS47DadYBiGRpo4y9h4wCiYmRzwgCbHbidN6ScsuFViVuh
82	B62qrAJ7wiP6sJwjM3RsZX3Xzp21BpfkF3yXA49TxPNBHAKrjPLbx4J
83	B62qnmxotgbGMHt7NkJBNFBoZC6wtHhBvoV472SfHzR4RmJsRZAtc1S
84	B62qj5TbymjFWUsjHnCDNfzbFbacKzXwnHdgDJDoAZwcs5GD2sacGMc
85	B62qmD4V61qQ6FFGEB4dJ7Nn3VVSxzdpJXRnevBJBMhTTphP2DrounC
86	B62qjM1iHPTCF3MDqhX5xiNhUHYzuxDKsk5ioKGE6AwvhAWSeYF9p6W
87	B62qmYVkkqtgLRvizHiqpQdBqQgiKv2kyaeQKJ2JmzbNN3J7bvACKpC
88	B62qqS5kLArkb787BAJD57Q69VB4MAJp18rrxdZBojPnd2yw1ULsYbX
89	B62qrYkGp44a78p3t6uifiBq2wwctJw3k8u88sKLLAgdAZFK1G8UGcH
90	B62qpoiUSB7FaqZQ2tHTveQ5rCS1phjByQZkTVeZzzRZXcRC8cvB468
91	B62qoWeaz5bDeo7Zt7ckkXnWEYTdNRUGQGgMNofUJ3hZcAG1KKbo4Ky
92	B62qpuQzCRgYUH7Ehi8gsLdRWVc75uKHwTUmsbsqTUMeMF7DcgpEJbb
93	B62qmdgx2WFkeWd1eMchRQUrhW426RFMZ6ZZzgv5itAiQfsjYcpC8FX
94	B62qrYveCMCW2tr5J8gu9T1rh817zsq7j8cjc9mHEecQS2tRMnoNTsy
95	B62qpYmDbDJAyADVkJzydoz7QeZy1ZTiWeH1LSuyMxXezvu5mAQi53U
96	B62qphjuHHaPY37THFRMYRQsVCf1JgEE6k512cV3S4RmkmdutMhzZmr
97	B62qkNThcughFM7r3aaZZFoZEyJRJiQY5tpFCRQZNRrb4AWEb4kFVmk
98	B62qrPt73ni9xPW55gBova4hDKyhXBuBo9yWBT2N94CC1XAfFmXxLsc
99	B62qmgDU4ygtzV5ZueVWgSFjYtkatqjSTmj4z2jbjN5XjfLMrmK9zkx
100	B62qrUCF3rqUMTXxjEWpmLprwJ1y9fyN2UgJB9DLQK36iHfcv4Voequ
101	B62qkqN9V4TQZWBCzPW7QiYh87CTUJBtVxUHze2cWxAUviZtwkWvZg6
102	B62qo23z1xZBR34du7GUtN6yGvSV9sXXWp2VHUNaCQVuasSwx5mnnXU
103	B62qrzTgzDJ6n1UojoypnHx4P1onR61r3RZkFaqFcgQ1mVUPY6cJzSr
104	B62qoK7sfMMxbx63h8Pmn9fCCSDBaW3WNyhniC2pbbB75kYZc1Xsk43
105	B62qrN1MZnXy15VXkh3D5XiNPQVKQLr4UXqBPFv3E4NHNFrzANC4wFb
106	B62qjW8gnXUWZH4zeMmHGgj73BRPt7bYkWQPcw3VG28QvfDJC2gvQvn
107	B62qqoY9tz6C4QafDyUGsxvJTJonnvJ7iCLyzzMLcDAoCAAE6nzEyGb
108	B62qoSqKkE5B4HPxWtidWGDty12o95nicTb81fW6HbUDPycQvDBs1cD
109	B62qkaDe8abFe8HpTgnc85LBxbg5pnoBvFraxePy67YBXmymWeW2BcE
110	B62qpCVgRNPxcoC5eQKDXJoHRRfcNSRjzq2YHymp6AFciH1bsRXkkf9
111	B62qn61vkYgxbTcxgbv4U969wrn97BZCZQrH1tUXFCevt2gXZENX9jM
112	B62qj49ZC1dvWzGNMd5VVxSVQhZv4rzoKd7TdsVSUAsHZ7x4mHXAWjH
113	B62qouDi7P2eXT2fRYji3a9rGCVQ6BpWt2iwb8y2yZnHL6VdhXtDcCm
114	B62qiWir45GBE9PWWoySrVnB8ERdL7QiykkfwjyzytuDSQTbibigSuw
115	B62qqDDZYhfU7mNcQKJfWHDJ3JjVTi6dG32oWiWY3KrrX4mSMLdEuUj
116	B62qnbxW6CVKmmRnwhYXc2EprVZXFBQVJj31W5FFLpSJgELsAkuU6jJ
117	B62qk2k9kWwdJ1C6H7QmxgK9JWkXNRZkssTvaUnNStLuwuo2NyopLoD
118	B62qoimVsUrBatqSRFuzGCWUHHSA6F3pA4hjX2Eb6QKDdrqV6oJFru2
119	B62qiVpQaFZer4iZY5n6TpmquHJtkvNhJWmR41XiWGZbmhQqGvQdUjE
120	B62qrkCaGXGWJC7JWzdg1nJv7Y1opgWDTDi6XknSYwTdrkMpTrg9AXc
121	B62qj28AitWwLTU3HAhtoW34nJ6LkyHU7XKm5wC84q1RtF4ho1yEgGn
122	B62qqb9QnByFcRQ2BGY6LjogXvsbknCxUPbBzhbrB1rpFoKR9Ys5VpE
123	B62qqLH53Wv45FVdA4tP41kqsCaSgJwe367qzfPp7Kxj9fGaQdrE3sE
124	B62qmy9tB4Nf9vVgg4ZJsiS8psBvxoSKZrWPmXRFX9tSQMyWRq39Kyw
125	B62qoSHqhByDDSMj85436DyUDRm1HDayaC95Gh5GinNANJD9EceHQkK
126	B62qoqGCXRr2yJRyRpRGhLZEP8a8B6rpBiMqxdwf2YxwYwpB3RoTGpM
127	B62qmLHunUCqVvXShJD6Qtg353wtM5fvDnJJu3F1AkeiwEMmbrnhVjg
128	B62qr5X78ew3GvKfbUUV3QqYiSK6vgUNCuLSdfMWCQw5pjp4L5TZw9v
129	B62qrLc7FgHVZ8dXyUzKHsL87E7Q2dRZRgjJcD48Lrnyx5FcyH4jLtd
130	B62qrNuUMrV2yBaGCWKqxYJNEihwjYxAZi9w3z2yESK8XxZs58aSB5y
131	B62qipAVcEkYgwwJfGsZ3TBhNKG8QU4J5JuFduWDzAUrUnUTR2C1a8L
132	B62qooos8xGyqtJGpT7eaoyGrABCf4vcAnzCtxPLNrf26M7FwAxHg1i
133	B62qoa7TmS3zdF2fqTsuDzEybrr86HwofCs4aYxeioeyRhQXaJQqK9J
134	B62qj9PPXDZuviJRDYPY66b7Jz58Qn13feGm758GpbQwJLp1S7oi825
135	B62qrYRkV2BKxoH6Nwuz6hMdZUk8U5Pefo7jdRWD8STdi6UL2MMaTaj
136	B62qkqCoR4oFfaEURsoG3z8EYuy8jVRoC6Lz5WGRNx8siQydG5y7Syn
137	B62qmFxVhebAGSspFQMdctwQRynupZH4dgZb3bxedcEumyaA8X9PzJP
138	B62qmAgjG13dd7gH5HZVaFRXZMFsLUVhs6qyqJdzQbhFs8SU9rycSX5
139	B62qjAijvK54GbYNLvZtva5tcDk2BbZAvtF7aBU7cm6bpxxpLAopJqt
140	B62qqqYnBdaqtR9LKfmXiQEdtdaZrFbh2P7YLi12u2JsmL8XHuBY5CA
141	B62qkag9ybmAzG9areQNg5oFNrsKjMc71q6nVnRDRDVo2XBxBcuzrA3
142	B62qmEgp5XSe6jsrJjuTkNS9fpvcUSZDBzs7uqJ8vEg5vgJ9BSVYDXm
143	B62qoX5oLk4m1wDmtJak7FHuEjxbGhpeARaVzkrn5gCHwPS21b1QEXz
144	B62qpRFS35fkGa3a7LEWhN8kZEQecobt1SZueunGXcxffcqFLKzgXHi
145	B62qkpma8whukuHBYjqJy4qNq2KoADVoyxccrkHDcw7332ifwGSVL56
146	B62qkes2AXQFszcXKtS9ZHVofoPRZJXiXzSfYVpH48vs14LVQXPoBfY
147	B62qosavysGuVW49xaiyvA1EaUPEA5zXdQWBrJp2XUtW9x5i49zL7yX
148	B62qkyzCG3cZhEVNvtec6Yt3MHxZkXhrKJeDLrKUVNPEpFZoa2gM5gA
149	B62qpLST3UC1rpVT6SHfB7wqW2iQgiopFAGfrcovPgLjgfpDUN2LLeg
150	B62qjV8B1C3nbRqKXEiREjNQCLuCL4Y75PPpwcFqWBAvFWN3X2iJJJD
151	B62qpxWMmCV9Qgx8EFQ3a6cpofDoX8DVMWrb25SCcRrsMqb19kuC5Ue
152	B62qoVopcNoQPFydweGWUBnJJbrokkebVDiWGmAzYoaLysrFfzNCbya
153	B62qnizET2q8NkKB3JfNYugpzq6Yddpufb5YvwWNgoxpTHUxMpVyrcc
154	B62qj8oSkVyBfVim9JWehGAa8eN43Q9RU5HQdzPSiy4XmS5uVAG7dJy
155	B62qr5UCVcHxSvGikJadNpn2bX7rvXRKzXQppPf2boq3eutzwxnTnkh
156	B62qriyGf54B65U6gZFFYzSzc5goHg381HRkYmgXnRqg9QMt1kZo7ac
157	B62qpk6VZxMqJjpYK89DFpj7SA3aE7kVyNAEw3G4TTxsK7NwEkqeMyB
158	B62qkKecntugWPMLfArv8cQqQsTGU9NG7gUakJzAR1cFTfG19QTfzbD
159	B62qpyhbvLobnd4Mb52vP7LPFAasb2S6Qphq8h5VV8Sq1m7VNK1VZcW
160	B62qktcFUDAniQGBamMXRabimiT3igb8bpbxok5h2yf3cSyw6PDH1BG
161	B62qjqVBKhE7Y3Kb6U1PqFt6vjk1uAFWwzeyDB2WD8MMunyHmBu2s64
162	B62qqvN7pFGTSzQgmwgxVV3nCAjQSE1mTpwHfQabpM3kZvKhYbhTRbC
163	B62qixTkfYwADQSS9SHL9NRBoNKvmfCYxQAPhoLiZDA5RsrzqiRPLHp
164	B62qkN1mBrN8GvxUSLxRHCvpLba6QX9TXgCLh4TcgxD1Bstewfnx8ff
165	B62qmbwRekMF7vGprxsSXT6XEPYVQcYN4dMdRZeZmAkPWwq1g4zV33Q
166	B62qrsEeZGxCaCKpMiHoTxWtT5Z1wrRptdh32xV1nr4GJHz5XDus5bj
167	B62qp6RfHVKvyLaA4Nf3NTQ96cxUTz8yxpTuZWAAvzdt1vbxqzxRGjF
168	B62qjTanvKuhcGC3vY9H4SaMsn6m5e1PGf7td7UAXZbRzVsmiB9oM8E
169	B62qieCpKu6W91BrH9vyjbHGrs8PpuRFkHSh7vorLJnCp4akJecCY6V
170	B62qrXo8soPBcTi8G2EHAUxJk1hpsQKqBoc2oXsHkwczxheJTeMzrCh
171	B62qjok2BD2jB6TArVM1oGDSo16xk1SYGzTwZSjx63WbtZy4BuzPBDj
172	B62qiwhAyp8prsTLatm4EUp6XvDEVAWyhY3YEs5RwTsi4wDVd21SfoU
173	B62qrEpQMYwujaWHNswuY3Gud5i4FLkrRwds5RNYPVyh5FwZJXgsfPV
174	B62qkdWpePqJ8XWogMvzt8kHWG8LGzG9gsYEuK5gbWePbFAZYohAEzd
175	B62qrop8ZLmVpu8AD3a7Hsqi9Yp1D29RJ7tfqWF4rVpAt7bUEZCsWpx
176	B62qjp6bK1jLdWVUXvnrhKmfuAuvLSMtCyysKEKVxewrL315BSPeMP7
177	B62qpFW3CEiqiVi4bRpDKf7ZNq3qNUKbHKhxQ68EUQ8QeeK5pksZVsE
178	B62qjb7gJQvsbEnSTLTft54LbT6YVWTAFL9zizzb8wAeSFudP5j75eW
179	B62qrV2oyYf84jZbQHdqH2TyUndafsL134WMpf5yDafmQ6ZGMxUiTmF
180	B62qqL6UUFFPkM7m3j2mmuEfjQvQdsKSGTu2CqYeYftb4sr5ji9DiHu
181	B62qnr5wwBn5dTuYTRgKobVujZYWLNBYA9marvg3y1e3yfukRmwqZv2
182	B62qpjEJn5boKL7nqM7G49V4zY3jeE2M3czqG8FXJEbAADstvfF9T7Q
183	B62qoiEyq2QHR8m3sw9eLdJxZzA5ttZ8C4EYfRs8uyE4Gc7Bi5rY1iA
184	B62qjyBDHWZfC2WX4sT7n6oLyexjzd7AW3o8r8yrbXFyjJnzwFDrGHc
185	B62qmyp8L897rHk5qwb9XVbwDge9e6q6ENYAH3sPkyvwA3cDXrxvV3r
186	B62qnAkxbs4gqZVnqzpQ6vbuoAD4VQSzYLydjt1d7eV9na7kXky6vV3
187	B62qpkiJW9ZCXtFm9WeY43ajhgwxVn6QWaeQiy75Jhpbv1hiaF5zswU
188	B62qmxHeEYE5fYVUVeLKHV2MfLcRpJMhtpsUaTeXmuGaw6UjTUwpQ5i
189	B62qkZhutQR8e2ijgAyChi7Ba8MEhRnnYfEVG2Tp9qsAff8HFgWgDHD
190	B62qmnmynER4sq7nV7i5YxhbcLaWQcqnZJhriVVaJgsmGzJt7mQq4uG
191	B62qpH4BktZFp5in5jKcfFrUqAYKbpU2RhH8iHmLKdraVWxjdbUMbpG
192	B62qiV4rtGrXstynn9DFMaTmQ9BB9C3kxLHmjsG57dyAKHxoqooMZGS
193	B62qowSjKkwtESnVZtaZpvuPJFbkygn5CZo5Ym9AKTHX7hMjMEhGGKY
194	B62qrJr7qJF5VJRrChgJj9QsskoGdJzVNJoMk6dEtnEBNKci4faYWfe
195	B62qqz5V5wjzg24v7HUCyJUD9a2Xk5gJrb75qyLwE4L6Rbo9XtTZyGB
196	B62qifMfsFYqLJ6Cf1KbwPCxsNwFA4qqcMeqWVvAZi37W6oRDnHRyYz
197	B62qpwsWhvau9zqmWvzXoHzWbpk6dXEx1UXP3nLQWmnFAuZAoMCKEYb
198	B62qrnHPpAF26JphstpLvPPC1L9sZZD4g8R1SNhCQuY36fbuXS9jaEK
199	B62qqYPMx7tRYqSMHzXrEb1HSTrLmsTpdDU4GnqTcP3egMwVH4pdi62
200	B62qjHrPXCydF2R9Vc2Gp9Cmn55eodSKUmhW7fQ83zwkXkMR77MHk3e
201	B62qmmjvVdhd2VBRyh5PJHiQkYkqLDgqa9uq5nfC2dM2MdfWt4ennHW
202	B62qnf4ieWyJWjLhL4GGXE3tLTLofHfgLTK6ZCPrrRnFrS4KEZ94m5K
203	B62qqWqjKKD4BBJVbPG9T56rStDcveAjBxoAWYGTfY75wyV3yQ4rYRH
204	B62qnyBEcf6gcaazmQWCPQCjizwBeBi76398k2VQCQ7mH6QzeLHMyqt
205	B62qp7Poht74axa1BJMWmN6MzAwEAnr2uRhi444YDvE4KAm57LEBKET
206	B62qpymA2yno7Qawq6vaK4aXtnNttAcvG4Nt23tFvbMPyG5yhEKMUSu
207	B62qjwh3KGD68vYySr2V1jcpkZ9uZZSoJJHzNWCgQQiLU3DAoab5NT5
208	B62qmRZKEwHnmEDh9Ywxf3be1AGrkFQnPES4FMKhDR7APWwQ1ouBwof
209	B62qrqi2dnGJeaLjULNxSFRqATdFqWetY3f3d7cHwyi6qdk9Y2MJPyS
210	B62qptxgjmuegvWsWgtjsWGyADwm3xx4sSydnV3iVNJHqtoYnWfr429
211	B62qq1xGN57tke8jJ3EuJMgFmgWQRoip6kKoBsTuLxsGXVqQXMN5oVj
212	B62qkf8bdX6AhgD7jR3Cs1YdWFkQpAaLAjWxqGijXG2memeU9o8i7Z8
213	B62qqVJQeDg8fxvedBP24KMFWcFB9m21V4tuLcJH9UQNdTrXxKrGrvD
214	B62qq9XP15kBmNexCELYxduoLr3HZKqRDQhD3mBx94rYPjjCZU1y9fm
215	B62qmCh5jJAJKgDaNL62rYcQuERxAm1q2bXKAFuCvKNH1ogZme4KES9
216	B62qrPLQL66L4BKeCFeypQHcAmKCcjtEr765o78xUJE335puxC9NViD
217	B62qjBp3TgwngdrKkK69NjrhTFS9KSTriLFiv2FKvnhGfjbYFFZCT9M
218	B62qpXuwSUQhfYfiu3CrZLXGzrCrxzkMNQAUZTu1bmxn8rsGH9zv7aQ
219	B62qj8Ld7mfYLuVramqiG9UWVjeLp5gsNy3pRCc5eF1heDMzkciNpF3
220	B62qjj9qsR77nCaqbQ5Q1XE2321gCYophTf1DfYi1uzQsCQvTFNsExg
221	B62qjwkotonAhcHsdGh7TsshXjdLXZQdJkTY69E5rtG8vCEVePraF82
222	B62qrQTNYpC8xQK2r1APUksrApXnU37YyZFhFtpWip3x17zXnGuPXcS
223	B62qrB51a5BAUn2TDX2y5RdMFmu7ytb1phVdKM1PjMjBPDjdzrHPp9T
224	B62qrrMKTKBGUCPstWDWBHAey3VRkztZFZPr8FfoX7qxdPTpwinMedN
225	B62qo5HvEcc98R9N1Y19hpsvkyvHbgFc2f4Dg3EnDAaFo1N3MG3xWJx
226	B62qrCmbqncUWGMDo7uEFzf4JSE6kSSuEuMMQwxAWxp8wYbVE8rdX5P
227	B62qjVX9MmfxajW5kBPjQgkTcs32MJHtydXfVdtCs1qk28bEcT6ekix
228	B62qjd92F7SH34QN89c2a27G7H9UM7EdFxWMtnmCVKh7jSW9WBq1fLV
229	B62qjzaoqL6ShpuMrpseveR2wpsBe6WfeEpc74evonStZebJg3Qu6jG
230	B62qkEHwUWrwMiToMX7fnRVtaET75RiFHvkFhd9up9bJhneipecEBx1
231	B62qnQsZYqubnj2tQ74m664TQ7CRmARquvq3p9pzaS2dikjxPnpePt2
232	B62qq9WWQBH8Zy6uHEfQakYGRcCAruHRdaQU597WFR5qf5T99Cab3rE
233	B62qoTCCaXTdQwiN3C1JYZkgjP4L8rKQrrrqpnGWhsSHjvSPzYVqTWR
234	B62qiksZ9WSGYb1pg3AvgzoQwqQy62F4pao1X2BNfj8hJFjovnh28Cw
235	B62qoSTXoK57i8UQ8RecMv592EkTjNQcSWpyVvJ6Ck6xgpBzvUFc6CG
236	B62qmNM9wRYRw5MdFfjwHCC8egn6aYayeuhVy4fpqFpahb1Zo1Rz3xn
237	B62qjDdeNBAc1AemCQ8fGYcLTCuqZGimzGUb4pXdzYws3wCmYFCDTQe
238	B62qp5dgv9tGSdD2DJDgJC8m5K3ah3mazxVagMm6pM5pJzX5QuPp8H6
239	B62qnLbQjbgBwQgPuLg9A5syh1Q3hwT8ecsFZ5dvwdtWRbsLfjjUH4D
240	B62qpwAqAJ5HaJT3iJgoFM5vC9gSJ1u2b9tvpRXx3Ns8mVoZTUDgGSL
241	B62qoPXEf78Lc2DG7GA7oU24Cd2986VxsCosABomT46JRMhYAmVfj5M
242	B62qpJwpBqDKDHFvv9uRDXHX2Tczc93zpNhYFcZAVXWm2KrSX7831Hg
243	B62qj7tJG5rxdy1hxo2tPo8xJGN3qDHwQdPqq7UMH6xGfhyfUikyKV8
244	B62qkoKSs9aAJLYPUxeqnRS28DRzTPfLkSonNjViXxM4bWQhVhYi82F
245	B62qprj7x2ByZHbVAf8r7k4fZKR4f745ysQA3fYgZh3gSdPoWXCDry7
246	B62qowREyBtVMpp8RVkbmfvZgxryNUzcJnRnH9LRs5xgAXkHhLyBEyz
247	B62qov9yv8TayLteD6SDXvxyYtmn3KkUoozAbs47fVo9JZSpcynbzTz
248	B62qmr9wnqsmhgThnSHvNKM6JtpWdJM2iQ4GPtUJk6ZjySeNiEyJmvk
249	B62qovgqKTuLjiCuzkPgVS56ex3ygxvGn3m9Wvwa9w1ZUo2EpuGdS5i
250	B62qk1oVDgqaoURSd4GY2KmENSYu8fnx8b7fuZSyVfruQF8gsd28D36
251	B62qmVkhfGqvfYrybuY3pgGjbLifcC1Wy1hLC7VtKHmvypuhancbueR
252	B62qjNN4wmuSdk6sS47Kpfi7CzdSEsf8Qm3HtmNCyxFhE8zxufycgQ6
253	B62qikyGBRHnK3Gsho2LzLTDXUXjVrQBm3StqasyWKsTNHexaxYzpG4
254	B62qmeYkyQGyqcdyjagRt3M4rpyZoJLoBK7Abv1ia4LBDumJfDEF2nV
255	B62qmMGz5dWhmrx7JgKtnmb4mqu87tqXsMr6wcRmnGzHrd3Y43iwhG9
256	B62qpgov22FLzdo7XoG2T7fz2CyxYqQtCBJ46SBscA6Vsv54qVD1oGy
257	B62qkd1a21WXpBc3kUrD86yty2VH3w24vC451CwSPbB3M6vStSBDBZi
258	B62qkMHhGvhdnDHYrwmCZC26VeZWwv18kn69pZzvXCxhi2ZiMJ8fEF3
259	B62qrQD8tyWsVArhMe42biJifujSr3hNpw3tRVtUakuUtRiBLmczChc
260	B62qiVNpFfuhEQyYUeQR82fxe1Bp3RXvc53JG2vedVTNSMR9Q5srxdh
261	B62qndynjUPACSp1Y9T6RppW6CU3K34wYXarR435Shbm2FD9un5AZjg
262	B62qrD4yGS7R7SutQnL4QqG28uwnRvX6hxAbyyAKiNn2HTkAv9x1BYq
263	B62qpnRWfM1SYB3z4tXbobpjQC2Gk8Kr33xQmk1vRpeMsfkcK4ButNb
264	B62qkTvL5o8LqNb6AtVR84smE4qgTJh2uySj8ufQd8cG8Qy4rPP1UDg
265	B62qmERM882YuYsXyGqnC9uLUZ3fS2U94QxcL43n3AdApti4pDA2R2Y
266	B62qm4AZDUA99AekfUfk1jufXR5KnaY7XFNUhd5tdV256voGdvwPFGR
267	B62qnd8XmGgeSWZ35bdbpKeoadr5vz3JV4rgZ9dZqu81o3K1npGUHuu
268	B62qqZxbrmjDz3ERbroPuHrgYZVEbWxoJxhMxmb6U9xcngrN98p5KyW
269	B62qiWVHJ3AxuSqK4hzkYQavBpnHBydNFSrNwyLWXizSnE4vzL2XTmn
270	B62qpNeSeFNHadM5LXXRZbQRUgpKXUWoVond8aoLpEVTnPG9zun2Gm5
271	B62qmcoErjsDd1XNsxpjPC7GUDYug7ersa9f2Si4jdD9Yom9N8z6578
272	B62qivKQokyen8VSDaaDaCKWx5BkBKDgei4yk8c1GTeP3b6C9DgmuFN
273	B62qr129iT5tEPohSHys28XrytPysFGFNXLFn1ETjGuZzTGm9wdHRey
274	B62qkeoF3PFQn7g9U7XNuyCvU8xqNxCA2qDgAkiefRiyNTZ7dzvjLvz
275	B62qmvmCN8qzDBKAD6M89hvGQeundPcDHhq5DrU57orGGKyT8NtrrRe
276	B62qpybcoHEEVNZUUciKrfMMtVV1uWq6HSjbK1jSo66LkMojeTDHzhD
277	B62qr2CgfiqKX2pVNkKTBKnHK8SAwqhHW1KUcszTp5Maivq1inYhRea
278	B62qns26Zzs7njXiz17AbJ9pvz3YSWa6dvXXN9vtNcJ4BTo2ZHSWQwN
279	B62qpiyGNhmLJ6JmBUqTaNJgHwkRkjQJ3PzarAmHfn5JmELY4RNPHot
280	B62qk2EsEpHX55gnZc8iASSekm8QYjh11NjZf4FjZNp2egdLi7bL7np
281	B62qkkWqU99Tk3n7voHNREo9KAtioaaYa4s55tdvEWHDYZj1wxYEvaD
282	B62qjFSKy73vyxJALB8DZLjXky1hqjpSUAMpumm5ZV4mMhT5gs9Mgcw
283	B62qou778MhEYT3qzuUL6LhsmSVMpB7FQn9ZkWPsYcHNV6LgCLDHcoP
284	B62qijd97DPQUp72zs3AiLo4dkUonpZtEZpK18oMK7G6xyX9YQdNJyJ
285	B62qq8itrQ9vYFGoC9orJWspS5TQ1BT2xtQCp5tmradoHYX3G277FYm
286	B62qkXTjDCwsYrDx9k65KEfXEn62ohVWNK895Jm26VQxt8nBhXcgr9B
287	B62qp8mnjoN15msN1LqHYXFUtqRGWjMhoZUysC8Bm49dMmNhhrPQmJr
288	B62qizN5gwSDjQXX1Ef3EXYEwQitNggDx8hdz9mqVCD8PDYvg7q7qKY
289	B62qrr4HsyQDc8BHf875XHizovkMqfXYKFxqxdcLPNahHnz1GZqCmXL
290	B62qpQeu4Td4CiTFU2C8bQXFgCefBc8rvvnG9C6Wfb2cz9YcQWaxomB
291	B62qqyn8atzjXyihkgRc9kMkKU6hnXtthqyM49Yz6FncyHqxkoLNkPu
292	B62qkEp3uw8fafP9koMTpxKLj5dEBvGRi5zWCE4hnvY5RBqHoJJwg26
293	B62qq1agJKStqQZedzMkEN2Bv7sTMHZprd7QJV8b8QAD1VuStCwyj8u
294	B62qrX53T6oax316MjjywtpTERrbRpDMxanZ66YEFVQeyvi5LH6LL9n
295	B62qopUvFqDi7UHtMtJyVsBPGGUKSmsaVr5C7qadxFQB5PJNxVan9R2
296	B62qpwieQeKnhXA8MEhsWAZnqA6qR2X82m6WfLqgAG82M9wnVCCsDNM
297	B62qqnCYD9sL3VjxeDW6z241xBr73bvEyX5TjGnrX9cad445Ut3vaZV
298	B62qns9cPvDwckhJXHpWZZ8b8T8oUgoF4Enpax5zNVBYYMtQwHf4Cmp
299	B62qkDvMb6vPupuP6qXKH4Lqw8fLJui5NcP61sJo9a9GKpQfteUPPt9
300	B62qryDkRZFK5r6DtWFiNhQhXDMWK5158MvoRhH8HSZuBLP2HLSqWZG
301	B62qjJPwZ81Z39Sg2WJ5tNPcCFBqwSeYZd68w8579eggnSyhFgGscuY
302	B62qoZ2J2WZKrNDUvLqKszzHSTYa1G49HE33JYf1Ux3U54LaLLNThhX
303	B62qnoQLkdjimCnRMsFZMA1GSgLA8HZGzBKxLsVWjRoHdtipcqmH9Bw
304	B62qiWSe63weqBN3vpnUyagnMkYmvRwKKQJ4dKckuJFsojUAYY56mfx
305	B62qp3NP4uGMRwBLBcr1JP8yzF27Wsm4QhL6yijJqo3Po1gZXWHiZxo
306	B62qs1fcaLBgAudDzGoTW9DYDw5U3BZ8MwbGAQ2gPazPrxtAemrKCPR
307	B62qksHfcCxo5gstt7aUnChtRTvuaHKW6EXJbEnYrJ6rikiYfLq1qrg
308	B62qpHpeTCVYbnuhZexBqz5tCSAWKT1izgCFHs8n9EqvrLzppLGKXqJ
309	B62qid7mcNh29WVifR2qWQDLJ9dRu94EUcbsgrTr9fdFMGsPQzWv8Qo
310	B62qixmqCUR4GPHbbG27BpjNstYfYmfB1QwEzWVCaYs9TpSugweiVvX
311	B62qowm5zNjGsDzC67eTc4zvjXwdkPRUKHFzeSDRjm6FBojzqmNfNhH
312	B62qjKEsfg8hiRVUEcUjW1RstNtyhMes6hb5wfcgSZizfXU26SLk4cT
313	B62qj2AqXEq6hdzaiFQ7wNSQ9TrzHQKS5WRnodXvdM7w1pRDc4GsgMV
314	B62qoXS5hZEidS6xdqAFMhY9tttfkevmsoZAaKbpJCq427CVGreGGcz
315	B62qitncPRoGgcufdUJdbJ1CooTz7fQuttqxBM48toKiq9ZqHPJyLpW
316	B62qoPwGzCmaAtHYXSKPSFyDU9R2RS9LiAEKJB66KwBUXkepBfMmWPS
317	B62qq3WS7BeAMu8PtfJjrPYNNz9cJpa6EJTfTkn7pQS1pPddapn2yDV
318	B62qrqeuQmW7F9RV8Uuzj98zj5LkYATmSenTvPP6ZmdsXK4scMYW2oL
319	B62qizMCrBRUG9keWLbDFCJBJbDY1tRkeqagsD2bLPCno1zxhPVYFNq
320	B62qoo5DaMn4iZeVijjm2XnoiNhQTMCdWixHtNMGaD9kcGd1z988toe
321	B62qn88ZcEijJNNRAimr6AQVa4jJPuY48dLzuLg7UMcKfmaTQFkeXXk
322	B62qpza4Xqp9GTDcsdjGJabz5M682oy7AudCD1jkqsMWHuzynLMfcKz
323	B62qjU8FUq5CmJ6MWFFEM1KGVb9DfZSvSmDCD1U5vgxrpDxAV3JZDrj
324	B62qksK8pRH8WtH5iNzv9KPVnY3E7KnDHFBLZmC6MgP9DBBJBxtKMYR
325	B62qkfCnyJpqtHmE53DCWQ15KHJXd36GazCaPrCznrmrsXoUjeSyurJ
326	B62qqgLQoPgy9YzsVKwB1KBuyB62TiQJYawDubnhf5gewKJo9qrKdnG
327	B62qj9MASPt6AcfxHawZcwkjFEfQqRVTn6HghdBmtEKvudWuRnhyEvG
328	B62qkNQ8SenMi1kYoHMHwbK7q3i26yLSpPM84wxiqsDvxFBHwna8Vtn
329	B62qr61ij8ZPW5BX6GMs4UNW1Ry29Cjbn2Z2LVyLkGJH3JgXJwx2jiC
330	B62qrCsLRjBPcr7pN8wRaSsw18PvZrzc3W2JAFrpt7K3YuJtAfMe62U
331	B62qj2gPKXJW6S2Q5qZQ2FZiL5jcMMvHdZYx9EWJnNDeRkTKPURSSPG
332	B62qnmuq8SMKR3JFBvkdDEuAGQnCQAC1cH59KJCmqG5NksGmTfxBE2n
333	B62qq3JeAaCrwa4XRtmjxmpXox1XZSgcSUXLPcKtcb4HnN6p5MzzYzj
334	B62qkuJvHscWoTsvtAYfzvGgsbw7YRXZpkFXr4r6QL4fspkZvjjh8Y2
335	B62qnSEt8wbrzWPr6iipnmTuwkNBMGB3e4ayg7hDkGXNLEzq3BMnCnk
336	B62qkkjmwsCMeX42PjL9DNPssKAupBojQT6Wd2ZZYeBq1EF7PTwKV6x
337	B62qid146JcZD6eSrDt2p9iqrQC6eTxRxYB5HUyg5XpTezsqP73WWRR
338	B62qrcpCwQNeFJvUru1fdVBWCfTWae6n7WcAacgxKE7W5gKAXyTV8yv
339	B62qnkCQqXyeXvbMavAG9U9cZ8JJi5XB7fwKMJoSEemzhqCWHQxpe5j
340	B62qmJ9xkQTANN7g1MENQtWFb5GHisESewUGLP17P6gPc1aentpPknd
341	B62qpBAw7SPHqDJyWDxfXCwQzJJ9ddDVxXNPckF4Vz2GKjPEZaXZpHp
342	B62qodJCdovJawjWjeYyttgjqJXfE9cn4UqZHqPtj74N4zrDZB4X7Gi
343	B62qjz89NS8EiPH5dM4HrBEDdKUxn2h3xAurQDXV2rKZoJiizkRt5eb
344	B62qo5tnoVeYMWW7EwNHCeUVvBU6ffxog6zJa9CZemj3XBL3adbrQTp
345	B62qko73kcCQVCk3sZbxjCNeyB7Npxf4NfNdENUdfu93YLAUJ48JYTL
346	B62qm7PZqTRPCJCzxfEhERiT15SobMmcEFUYEXuUMn8w6esvYwbLfvJ
347	B62qo3wqcK4DVFWxGe5tT1eswqQzsE5kbT1PGUXjcenBQ1rNbFZ7GZK
348	B62qn1WvJwssC85DFfCn3ex3r91oHZbaUSZt8npGBZ2XpVdM1LRwpHB
349	B62qjqtLRExnb2fyMiBpv6nC1ckGuBrCY9mXtTTcf5x7GD3CG6sU3Ad
350	B62qrkPTrY79TGSUV3E69gMTpfPjztPzTC6TZxwEy9P5d4nU5EVgxQs
351	B62qjCrpAF3n197SVLwY8UsugdxekMJhjJ5rKPYNsZ8XTAs4CBeJnjX
352	B62qjmwNZgQq5s757XqHqtQxiXWQECqan9bUFAQaRVFYP8tnFKQKRjY
353	B62qodH3aWczywdoKsgixMBcMEmsg3ruSfFjXNYR11du727MdyCDuW1
354	B62qngpchppH4j7gtkHWnZfAzRm2ak2p2mBjNHtWssoEvhK2Ev4u167
355	B62qpJa414g251R6eWAEw1FhEzfR8YjQMrhbVtBQ1kMRz4C7hVeRAN2
356	B62qqu7KbdrtYdGr5f66RvNRG983iKvVXgUUfsRc18ZCPLVw9naVLe4
357	B62qpZ4Pav4t9e6ir4UAuJdi4JEPwvvNfkWMjm39rkXZMDgAidTpS8p
358	B62qmax52Wd2AdXKEatbX1cFYecQYsgpXwzzejAiJUw79x4wAGucDyY
359	B62qpNLG53NfZ1HUJUtNxTCJonDJmj9Q89wFWorsuNszQarxRqdcfMS
360	B62qkpDyPDoGMWFdnvH9QADDnw5ixb8LUu57CDMXQNsDaUdq88Pu47A
361	B62qknJSP3q28HrstZ8trCWQR3DGaSWzYuNQSi1JkZxgbyuxGdp3Fw5
362	B62qkr7ThcgibRwBiv6u556iBi134e2CTnSvQC2xNMLFNTqJWL3Dmob
363	B62qrawWiZbmyrJaB94CVpi8Fmd3Lxw5m3tbXo97hKJkZPkn4dHe6G8
364	B62qp2gg2aP1dxg7FPXVemWcgP5zaPBJoeeZAC3EgHtR4sTibD3Eaoy
365	B62qjgMVvo1JTaG6u1pBFNzvPGivGTUeq6TtbauypeVybojD5JdWjvW
366	B62qqS4q8Lk8uCWBK6xsJcHpXSqpabvgNWm3gHaXAEaFGANU5Eqs3KP
367	B62qoYEmT49GcVuhEpLiU8KBVE2fPENG7qdNRZkDjjBfYoD6XMDwAUa
368	B62qq5F7VB8sSDPDs1PHhmbmL37dtR427EWPmthtt7YpPPdy4fXN8e9
369	B62qm6LvKxET3xCAW5JdNWAekCjyJJFxJdYYNcpGNwvhe15yyddYife
370	B62qjCZxxdKpeTSXzxCUfcVmvDnMeUkebm3XgLLK3AewfawZkCkziZL
371	B62qmKeoHvaJL2MtoQaSUogTyZyFMKDeno3Rhc7VpxRE5kCa4EwJwH2
372	B62qqmgjAjoKRgt1ptEdqnFN8LTmBKj8YdSEVKxnAxcFtiRXYeUV3pD
373	B62qqAmP51fjPJ1FFVXP8i48f4zhEyhRr47v2X4iVfSVtMiMG489HAH
374	B62qqmRRU7WmBLegW368k92xdtgavt2NRKKFeneQN41udU3RJK4RypJ
375	B62qpBhnHWtr4sq1sRcy4Nd1WHA4o47fV3tu21e41vCZ87LGcCQCdW8
376	B62qnYgvJNeUwF48YyYMh2WDpnV2n69sr2KW7jDJQqRtPU4vtchiB4M
377	B62qpoqqu8Rhc6E5GN1McsT6VxL5i3DGuQkt3k23JVKZrNWxqGM4mDn
378	B62qnFz5DTg4Keh5x6P9pnctAzvgiHZyarCdEx7GYRew1H2Kw6G66Ly
379	B62qkUcq8Tt1h5PMXWoc9n4Jk6zsbG1YZoTeB8jQzS9JLrtL2HP6dyt
380	B62qqVDmmLafLcJG6bkXCZfmEMcnupNLoud3sVsxCn96AzjmJKXwqS8
381	B62qqdcf6K9HyBSaxqH5JVFJkc1SUEe1VzDc5kYZFQZXWSQyGHoino1
382	B62qkBMexQj12N8fYEeXMz23qVYpPtXwJYsnmRGsXJYcprgie5onhdz
383	B62qreVP6TddxX5CySuko7gqxVwzRmQyYzraHp85dzYG9g9ixPbVL3D
384	B62qm65cfsaBjb8GkDAmRgBLS6bnypkdUL2TYhEL7eAts4aR7UhtAwy
385	B62qidnhLeB2P7AiF8GtETeM9PEfCvWMajFxDaYWsxkXiajT1T4CUMP
386	B62qmBArXh34ZoJEXutPgSw8N5z3YgDm3vX2Vwfo5k1x4uZvqbQ8TYS
387	B62qoewSfNiLeUQUsmXQMmCGcD1pkXX7FWq2bD3EgsBojq2UaGG2Gzv
388	B62qrhxaun9CinfJobHb3uGp4vEXd3j2kg6iNhsWZnhDYzUyEMW2cdF
389	B62qqy7DHHzo4ryzUYdycH9jNaPYGj1vMUPZxQ2VwSq134EjHKeYiGt
390	B62qpRa7iZ64Ws7aH971V32TRmDAcLBfuxppxx6s4CAvmC3NZfBjxeq
391	B62qowXgtSfrWgMwvP6yxe3Z3JnpRHKZhsWCRLETNvMnT7ezeT6rA4c
392	B62qp8TJyLYVFR6FnQAZ4A3aBKCMkEZzWBo3VSuGkyhBMdFAgjhTtE9
393	B62qogfTBYu9xSbweoUywdPWxEy3wZGhmrv5fGydAyFTXTPnGY6vQPG
394	B62qpcGGx2UxNMgxqM9DrJuzkoB8Q6KrGifTVT6hdq4pwMUAsEtduQJ
395	B62qqa9zE4zcqLx2emeoeCp59f9iKBMiLtcQRDpBsqrxGvhrVciwB7G
396	B62qrUdqiAzLuzFRsBcYEBzvcCtSFkydyNcpyHj5Wu2umSDAztFnbRX
397	B62qikygSmv245hJZQzAhAqxfqeNiyPDZUS9MME4HkP9oFNhij85XUp
398	B62qjdxqhiaRQHExFvnEDGH2prnAU8xtnw5urmWUNsK4oc8AyJSDwNU
399	B62qmXi6YMzGmKhw7CK1M8VAybRyErq7VytkXULkjTjiB1FjTdoYxX1
400	B62qr5Kat2je68ni2TyEZiaPCf5iKPxCZPWjsEgdEJh9g3ZCB7GLWXs
401	B62qqE4CAyjRqdYXa4Q28dA1hHmtKBggmk6ufEWe71tXbM8DWpUwVMi
402	B62qjYZCaRMB7cXWvCowkhEHiHmyhwu7AnDvQhHeDUfuaZ3c6y4JLgF
403	B62qkPMHeYkG7q7uPefcU18CpKPpisST4YUay8dg8sZAKMrxMQpADPB
404	B62qrqVYXRsroeuX7oTLSXEsXg6DziGL1LmJJ4TER4X9rSQHsYBobMn
405	B62qmBNz8jAeKVm3Avkdqs9V796r7cXSLQ37RMi4ECswgqERwn5P7Uo
406	B62qmhWsLASA4x715y2FizsvzjggcsdDkTcqxHu1WkPuoHD2EnFHZiR
407	B62qo7NFdpzFbTyiUj5Uhks5TB9fapKc6jNDNFnFYtqCyyBNiFMhsET
408	B62qrUAu3VZ2JUA2Z8kbFVWcd5vGehomxCnM2LptvpKbuu3y5GNxbb7
409	B62qpwLQcUpYcn7RqDkDHGxAoWwy5AZ9uSab9s5YtwBXcAow81nLhEk
410	B62qnZG3J8PBwNrx4hLsgDmt7JHzFwTSJ7H8peJwRhKcHtsVsa2Ye7k
411	B62qrLFnh5BWLjHmsnrX9ABW9QVRDe237VKXQ3EobeXDqsLyY2iQD9g
412	B62qpc6JFovnLFZAa8JEAs9QQMxh12H2Xj4NFFjpyE2NZpoCQXRQxwZ
413	B62qojCVaJ3dKYgBUieccF3A3qzVEotn4Qd5k4tNU8QPNgVhZTpLwit
414	B62qpUXHbTVzyvZT8cs6fS3h8g74PNa4nFHTC7rhK29geJECWZnj1EY
415	B62qpW3ndQTvtcCkRj5jyPTbDFzM1wu5TiPNcSiya9htTzrZwuhExJL
416	B62qnucUMHz7Dw2ReNgWhmR5XCvPeQjJWPReuQ8GwPyY4qj1otGBiKr
417	B62qnRkPAoX5ruTEcRYPXZgynj7z6eVRcpozaLm4ixXhYpEbZc4jW5S
418	B62qnJ6gLytERFTXgY2tsW8cP3xDPhpJxuQFeFRMq6vz1JbrDz968Qt
419	B62qjRDJA1NUddVunp1iRerMg7Un74E3xPUwFX7NhLx1spgct4REDGh
420	B62qoa7ihzF5PiP66kFYctKKqmBy3JyVFYfHkaXBHJ1xKF3XdjvEzzV
421	B62qjGmBJWG5oP95zVCik6TZJ7HfoZpNLuEY2Ddy2ZBGWXsfm56zUqV
422	B62qjAiHpGkwYMVUpNFWsM5qFZKwcQ3PVch84RSGJLsRqgjHae9ypmB
423	B62qo4K69EgaffcsRf7DzN6nK83h161wYVwcGwxYSHA9CWfdDNCL5UK
424	B62qm8JTDW2YjGCJtsSSxeX64KXzU7V7MsFdT8hQ9oHXQgMfh2Ev3xf
425	B62qne2bgd34Fayvg6JjXtqULn1YyuFYfPWRqounqx6DH9Ju9Q99HRX
426	B62qqUQ3A1c42mv2oZydLGi7GhjWEjVCtkoA2YwvCqsbTKPiEECw6HL
427	B62qqWtL6b3WiAnyFoMHWARZxsp8k5p8UvJekFRc9szrAe3DzmCMJLL
428	B62qm1GNZwmdtE4pzWJxw9Tj4TLrjdcDkckuK7ZEezC1zE8PNaWjN8U
429	B62qmcMWELkk4nXNfMYZo5a2GtR5F12Ucb6NRYwUWEZKzAciTYu8GxY
430	B62qosqyp4hdQvgU9RQ4FjVDuEiLET8NZNqQir7PyddJLSAAx6PGrHh
431	B62qqLYkYxxiC5XKZqH7kFmMU8yULC7ezqGh117ZhGnaHQPuHjBhuJR
432	B62qipdnk7eq72uKjKhGQum7pAuJGGjgxK3XcPBN1LGN2bqLZXWm8XF
433	B62qpKVMtHa1z3CGBHX6JKtnRfYsYn14CqfCuKkYhuaU7mmynGPyGSU
434	B62qkV29d1NensD3yqtkDhp8M2ZuWeShpsvyv9qGy7bsF5oHKkErb3a
435	B62qpcENWiR5VKkrHscV9cWfPwNs56ExFeb94FDiVz9GeV2mBNpMCkY
436	B62qp4kr5TN9dPQcMCXVNCnGf6GoWA5SJnLCJaiYkeKfErLN3iNYKYb
437	B62qjY4qgqZLcD9vJSB3B4We3C5N7kjKa4cfGat2HsenyYuTgPJ6fkM
438	B62qm6XTALQy15eQPvpdietiVAJ5QBU5WGRugAxRpsvbiXn6iSdNqzu
439	B62qjw8HBV8mb1qsvZSA3x4JwyJp5SG2P3cdmNXSUmUhLkzmXi8H2yL
440	B62qphi5eyyXm5wbJ3uLCL18E6BzTdTmi5AE1Ve52mHiput5E5wEH7H
441	B62qnuHogQxCbENFXYJdhyxz6dYCJDVVgjkvGxQyzxTVFN71vAyJGYQ
442	B62qmzaPsEf79D6oBr3hxAK4zYMcCRA2soTFchoPmH3TV825Dd3Dvmd
443	B62qofdXQKEMyb1CzTCHopwZGWQ2etmhwvF66Ukm4d9FkzHB71qPUT5
444	B62qpcAVHZNHsScDZZLkn5KcLVYfAZ8kdVeTPV5t67gReqS7aN3CNrD
445	B62qmsGq63CNGbBjVLdQ2hcTp5UfeNXx7tmxJbNazQaKVxJ371NkJFk
446	B62qn2545en8u3Q1UhBpSABFn1Pq3W7psprDHGxuAxw7tUeM6Veoz8A
447	B62qogRBqMKjWk9cYkCiyQVPC1J1eHBZnVbUWr8kULPmsdF5DzmKuin
448	B62qpJavug1VGCBSttepmXr6nh8fvXY5SigbN44ttYDia65vwbTEcq2
449	B62qrhwf4jRdSi4rgU3B5C5eeEWixBVbfMBfv1sEVPdrMtQsSNEdycV
450	B62qpGALWoNczLHTwTwhgxjj2qjNqdof2wzxFoZgxqyX1uaccnQ4Hnb
451	B62qpQgkdbR33itJqeUBGdyYLyi67rRZBSWTuPrBbn7TQqSaBX1c7xL
452	B62qrKhDiFPNc1VgfVVvmxwTa6oDwv4DPXNwSxC1kvY7nqYDc1LcZXq
453	B62qkmLi1Th94fnNgqKYubXTtdbcXnNEEARgMcTNcyagCm9Dx7pUbHy
454	B62qoUAvnbwKgsf7SjX1dpog1v4BdzxDxgfaVnBPAg8cRyTRvPeB36b
455	B62qmVohHxFPyF6WF5tnc6uvSBvJ2fbn79N8kRzM7DwGwp4zNtuxRk9
456	B62qkc5MQcyVGnZReDtarjR6jYa1w21EET7UfSsztKimSnM8MYdttAq
457	B62qnXy1f75qq8c6HS2Am88Gk6UyvTHK3iSYh4Hb3nD6DS2eS6wZ4or
458	B62qmCvy7LUqfZ6uZYPn6MY6pofWJntJdjx85RQRmL73jaEKpqe1Jv4
459	B62qoCnVDwSnjaQvdnSom57iJxQSeTdQQVpqV2iYCTjPEpgXpKMLFSZ
460	B62qkkmP4vNLCsYej6oSFnDCfoFAL2mwB48t3feeAG56yBKYcUJEESK
461	B62qpALMdDZqjgQEPcZhD6nuCCETJdkdmMfic6wRxJqyMnfq93vVUY1
462	B62qocryrZvDmkE9pCGQU8A3mPi1p6ixU96fgpV7yJ88QoUJbxdfi4e
463	B62qjmEiV5kBvHy2iM5NeGdCArux1dS6G3fYjy1STK1FpnpVjFf4HwU
464	B62qmrqg9A81KNuUy56eKiCQErdX9eFHPysnjZ9aMvogY2DZmGrabP4
465	B62qrg8GsvUv2GTMwrUDrWpYSxPJYFUJKqJeZo2Wf7BCodcaqYr9LQa
466	B62qq1NRi2NFiMq5T7MgAJLRzwEHYewFn4zL7gDYQVLayyZmm2CWooN
467	B62qn7Rmq7wRpMifvvXqyrnhoaajP8gkKTKEH1ippaHCn2ayDpW778F
468	B62qoCaohL5p2QTfDvPKJrPXeyJbgyBWdQkQwbVfEWYQsWAb6GaoWiV
469	B62qnreXhVb5unrPNGi2dxuJfF2NJtmbgiWPXSVHUVvi59nnGCENAYf
470	B62qmWbgvGV1MwxS6rJEG3BSbT2T8b5DP2Theb2CaBduBXGJz6qfCqb
471	B62qrAz62mfgyBUWVYpZ4ufYFgvPRqLv3vCkwnxkarG2dfZ9GCUCHgV
472	B62qmiudinE4ZbpxowZkADpMDziXs3RTgxjmiByrFmXiXBbZpXsamjq
473	B62qmNFmA2jSxynSw2hrrMixh8GYKaSgw9owhXCWo9DgStnDzSXFZhh
474	B62qnEeb4KAp9WxdMxddHVtJ8gwfyJURG5BZZ6e4LsRjQKHNWqmgSWt
475	B62qp7QPNJJxYcrR7WPraAm1zoewxS9mpNNAnYYP5WZkEdrvyaLjod7
476	B62qrjuyRWQZr89rDA7KMCtfjAx1VttWcdkGtqdmAqcMoc9Lm1GULyN
477	B62qpwr7Mc3aKFFLTAvTscaFx4sddBWSDX5my6YEBbmdHgES755moTK
478	B62qq8dC5gi1n6kxEhGUZriFe6VMkQqCqtobSUCb1x9ziyMcB1wXuDu
479	B62qpg6J9RC357VQejtdTGFwXX1t4q8XhttKGk6jMKPm8LUotLjM9Yv
480	B62qjY5YR5P4DdCa5UzCb5MaWdye16ie4ZBudZs8bsx5PJiDzS1Efvo
481	B62qpSsTVvVXnt9f8tPor2fLNZD9bHtpUM4NBwdDVSPoC4HXPaHREyQ
482	B62qmCFFVD6ynjYwjxBCUyvXbio1afrhePpB3PkhbRfu7mQAtyogNoa
483	B62qrrA1PHiXL9VnrezybVjz9CXVkJS625w9ivCmMKzKvfqADVqseDQ
484	B62qjaE41RVyhm1mcLNUwdpBJPSSYAr6MvfnWKCrmEfPz5BPRDj4GSQ
485	B62qrhLkLMHiGtiRnQkr829WuNaZRtka2Q5CxwycN7h9LV4S21kcNKd
486	B62qqx1wg5QZRmCv32jmyjRdNj6yaHYmQL9Qqubkfs2Q5BxSW3zjZeX
487	B62qppuL9myXiUnueDK8E7LNRr7wPiFKSvzb6U8qdCkETuLwd6rAs6N
488	B62qnA5mNFbeETE6WW7tLsxmFYXkJjZ9hoN7Aa4EJBwK6qjsWawpLNw
489	B62qr5FbyEhbGEAZogiGB754Jdh6iGDPcs79p8hPRtNauCt7MynmrvQ
490	B62qpsYZiJXs1fdtFKao17PJWuKJGE27nLXfKqM5jh9oeMSMnUkTi4M
491	B62qj3ZYhcFKf6rTpYkziKvzMKuMnC9QHXE9n1jovoif9rTK5HNHogx
492	B62qoL1ikYHPbSv1Z2DacVb73cVLbhjYzfyGGx4ES3y9nWSCjaTYacs
493	B62qjWj5kLFgNTyThrCdgPrNZ4sLvmZsBYKCTmsoSGrgG4C2A72U4WX
494	B62qo8EBdkFSKqs15e6Vt3PwzeiM786PmPzgCeP5k9jWEqRMYtRxec7
495	B62qn9qnWVHV27xFnBqp5Mj5f3EctADmZXTxTnPXzkvYUyhg5FkjCVW
496	B62qrTTLH4VxCJy1nNYZMV9XhXAtopxnQ1KXZbrBWj8zLdzWSiad3gs
497	B62qnE1JLRhrYRoqvuwkCdNui1LpcRj5H29FptwbUQvau7xNMEAcaf5
498	B62qjYFuUkb1D8xgwdADbiZ6UUr6KA6x61BzzE1K9sgemawDbytmjTb
499	B62qqja2YnsyBoDvMrpkHFCwJpSjEn47biEhm4QKZEUVFBxQZYZmv6w
500	B62qqRtCkFNBtAzB9D82ay94iFxU1RCtTXYQ4miqH6xrTiwEJ25T8sR
501	B62qizFZP1uW4PEWii46T74kMEmd5J26fQgKs3V69CNjVeH4cWk168D
502	B62qpaKdUrK4mw9BFk6YrEtjkuZkg1yJ646XnD8iPsSkV3FFGBjNdvt
503	B62qoj4NpnbGSLV62tu2UbTRFV7Ec8kYcQW6H16BfNYhHstBMiahmbi
504	B62qrP5fybkeKbRpLRf2CFmnAjLEnZf36DT5CT6h8fMtxTJfYCzXqiW
505	B62qm6SbSHyyHBd864eWQQn3j9XPLUGQgM745oyaPBesvQbWAAWZShZ
506	B62qkfbG38SMsrVyMpFb5KkDiSLsgPiYsodKZ9UuAkmNfBe8Gus4Hsw
507	B62qjwMQC1yLPcv6Cyog1j4qFiynFXDgpvFX8fjYaFR3UJtD6cN8ErD
508	B62qkxwU5ePDE66ChRww27pGA5dmtXK7prFaebVc1bJc2ttnTw9Mi5k
509	B62qjLzQz4Sc8yu1Ykv31T63XDCAYLpzQg5tLeHrii9zQ3LcDgSW3fS
510	B62qkzeJK1ou1LtGxq94tY2fTy1E4uoovTzDpSAJzXZLfaDLjUrcC2x
511	B62qo8no6zXZa68SmhqtwtSoKtztQ35oT9S6maRPocuu6jkBr7JWMJg
512	B62qp4H3V37M38xgN2v1uTg55KPn5piTZbfRv4yugp859ognNRd5NxF
513	B62qnrx9HSU5Dwe9G8PopjFBdHf1c6rxG4niY8P4CHfnMo8bJPGo8jo
514	B62qkCj4Tg7CNecRfDryTUBmc6gwFQgvBD7Ea8bz6ELYTiTmuJEEf6D
515	B62qkZf4qaDNQSvA3qLDHhUEUyrPUyB7wB3uNafWc6a2CctakqxQRK8
516	B62qofSBi53zHx4dLsZxh6bcNu9MECsUBdZH96FrDb5kQWNac6nQ9Ys
517	B62qn3eMx3ZxS1FQ46wepgTpX7JG5ponY38f2wovU9xGqDzdnBD5kmN
518	B62qkAubK8h3D8zG3DC33n7W6u2pPot8HBHYA7oemdUGq7o4v3gE4DR
519	B62qriA1rqpkBS338FEgr3Gd8jL1tqxj6d1Vgtr5WH9n4YRBLrstE9D
520	B62qjQ5cHbShm31do3N9wmRu1AVDBV1AaAQnxM9VoKq5aV8EERtnYB8
521	B62qmEmc7wkUTTgcFEN4JUr9Up439hb7QZDPA7wBhHF83fAcCuYkoCJ
522	B62qpNawMqmLVq6Gc8FnqCYSkzqVquRigZUW9VNKPc8CEZxJeus9c96
523	B62qk87DbSD239zGYdh1sTTQunnfirm6H4TjDxUm3gA768H4XSLctAu
524	B62qmff5VshnR73TZ4V95zPUNZbNNnLqsG6o3SYLSAEuoX88TfYdtCs
525	B62qp4Gwy1ZxVA6EhqFPJ7oZphYKhuJYgVdYNkBUQEmwhY2J7d311Ys
526	B62qj74mCpk5sbvHWobuq3Q2ybZYvyNtfPcSiEMKds8HAbwtT3UhiG2
527	B62qrxQZJQq1kgcKC1QhhPYvfJD6rizW9vFc2yL45axKRDnavjpUY7q
528	B62qjohg1jbbiTpQNzAgi8NLDnS3L6H9Wsz6AEuWVdRCBDNKNKYXHmG
529	B62qjJAwwbXg6kXPYHzMTKBA2bG4RtiYggvYdCJVQTCB1ArMerwtzzh
530	B62qo3VjJHcjPh8TEzWXajHfC4pXCHisnHEaAajkHEeMTQ62XYY24KM
531	B62qoXNSt372178kswdiLjr5BQZ5eUTx7dzebbCqKzxVjLKEEEPkqxm
532	B62qq2PGvsoNC4u3uxthhs2ztXzuXRzqoWX9pWUDo5xdC3vdG7DQkjU
533	B62qisVmXEHZy9gjmCBrpLNTPp1Va1tYyFby1xV8hnNQvUZdZpq9Gmw
534	B62qiwepAfGCvyDBMx8acQ2wTwEDLN4ZkAK4VEwtuDqawKfvs2Y2Ej6
535	B62qod4Qzz1215F8LfFz2tmAkWtT1S1rmrfZs8283NYm9tYPuLhPP5d
536	B62qqNTecEPfa49JE3XLTVTvvzDfkqQWCLc8TVC26sGtmwQkPModRrn
537	B62qrfRjSn7Wz1JAyM66rd46Zcf37sWa9tobyXh9wfZubHEfozW3SAf
538	B62qph32vKvKjNDkpYdx1aUGDnM2ZT9qJ8d1vt19EwuL7yKyaLprXCG
539	B62qrGa2DAehUxo7Bhsk6hfoSLWL4kBbXtT3hST168hRyUkrEZwbCnf
540	B62qm8QwMLApni86t94X2WmHuxspzs3cbB9BaBb4dqrt2gzMEGXhjQe
541	B62qm49T1qENZyPSJPWPSc8wvpWMb5JjkChECazSdcxkE5zxXuv2Cd1
542	B62qnqEqsuH7kST9ZrbksRzihXD2tgHfvq9TF73XKAMj47gisT9xsJ5
543	B62qkaumutxogA7B781qgAYaQdXwr6SLp9dwmEfKj8KB3LsDtWhpXhm
544	B62qo463EfezM6wEYX9JVMT787XezVCszhTg5f2Pb6TbSds7jyPg5vd
545	B62qmMd8zb4Wu2MjQSCZvGB9VoiZNTXHqy7aQp58AhpiE6wTRRpAQ1H
546	B62qpu1rQdxNjwhXQtL2BA1JefpMHQqfmhmfh9MbTPVpijK3qYmGK99
547	B62qkYdFy8bJQYJ5JPhpFYuQGPwEzH6zKcpFyKTwQaTHPMk8Tmu7J67
548	B62qjPo8EuvgkS1HuDLgE7k9WWnABYZJXxTsMystpVktR8pDpSPDxoc
549	B62qoJgo3ZwNZJ1CJfQa3czHHnTESM1njEmcwuUzudMspfbY86TkV1f
550	B62qoJBsUJkxSHHhooLdgmNUZS9ihA3NXhN1KtXY43U2uX58MNqRK3u
551	B62qkjHJXHXpqrdVsoM8JPQ9CGjimZzZzx73Wth8MyNyqmdkEMdGAxo
552	B62qjtckRzJvbYjn59snWWakxvuBLTwvEs6YyNxUrFDm5NuTggpXaKX
553	B62qqy81eScdUWUvXiUU92d8ZpBdCKEo2oCEKDqs8yPwKzNUByf1Uo2
554	B62qn5eK8hgYRpkHAQcmfxbbvCsXk7tYAmGiqXBHK5dzRN9k7uL55Kv
555	B62qnGfRHkjXCF25AguH3EUJZzDNXv4xrFM9Z1Kd9a85FovbR25js1y
556	B62qqUbtYZCczK9pF3f3XtmAceSiD1tXwkjwQCT1o93X83tFU7rcrz2
557	B62qrYD5oqNfvrFP84wcgEx31bSDCib2yyx4S7oy1ZQfB7YuhpPeykL
558	B62qkrNfQtiW9XAo2yqscuJ9VVx9n9RquwLbka7KetHEwp7AifQLHqE
559	B62qr34Toyq8idNpPsPBR1dhgjUdTXKAvnCBnVt57eh6wDQ956aSPLh
560	B62qnXGNL44878HmkoTvkmjDHRxReHPFFjBcf4qjWDjUxjMoLmuJVWw
561	B62qr6nJMF7Abm9rsW2motSJqwmuu5ZeAHJcESgfnTXZZKJXzvMFM3p
562	B62qpdPvGHBe2ceij4GEZYAarqTdrWEi97trdZLRBoJHLxu1W2mqBG9
563	B62qrUXUnrc1tR1XN44eVaYVyw64MYD7p841LHsxzuMy6yERkbkzS87
564	B62qrAWZFqvgJbfU95t1owLAMKtsDTAGgSZzsBJYUzeQZ7dQNMmG5vw
565	B62qqom5m5YVX2dGpJV2pVPGQP7HKDCnXBRd47QKeTewcvgAFfjs7ay
566	B62qmTYWQUM5V1r9HT5wVPVYgWpotezECEgciGAXJFFGJKzNZpzH3Fz
567	B62qkUDWTWF6jZ8DxaZZ64JrFRbBgdNrRmfKricno68TmFjkxMGearM
568	B62qqSBUwbUxVdhKvVNtkWT1rkMFkjmd8cGaNGTrgN4mRgUqN73HjBr
569	B62qqnTQYi2ZdDaeePDxmrgcporgoFMcTMbxPmzpwQn31VSXMHawzyU
570	B62qkqNhtDFa5ZDYGrUqn9CEB6aGrgMyj1JLeEPX4tmM6cdWnrH6rRo
571	B62qisRXbV3EMYm4aVEtxevtG242pXpyzgHnxMhMKXdRZkJViRyQ2EE
572	B62qprCAep9orCrPMxQ7foJ6yP2bip14DbHNnzb2ia3aA2mQ7uVhrWp
573	B62qjzTb39cVFyaKmswTGBnGGKi8y8DFGP3KCoYVzq4nSFZPZdjoYqN
574	B62qmnWhJ5s19tza9eASRaFNasysrFKcmWPq9FJa5NYSe9V78FUuVSt
575	B62qmzcyCKrQ99WsXvG5MbvM71XveUkg7jVcoMVVwTbcQWmRx2iYvH9
576	B62qp4jr1PgwK42Ah4HG2qNHigTw5riKFr6RprguAX6ms8ArDcdGv7a
577	B62qnrW8QqY2K86HTyWXWyNzCUggHCbyqcU8DyUSYNoL7TirEFeBrFN
578	B62qjjXbygJnetM7hm8kC5T6rxTCZHzQL9SSxDaQopS6fVLwJUNYUan
579	B62qjvYEMFyGVaHCXbfRXpvr3gboQzQTZUpPQunEJRpgLd48pNX56QX
580	B62qncFkdax9ZsbePo2H6wNB61ZVrEQfiBszW2KGrnGP2QQHj3kJmAH
581	B62qokFNLPLZsP4dS1ama58fuCdqR5eVqSVYhAqixM9V1eS1nfeJmqQ
582	B62qpaiW37BtfN2LF9mnLwUucc6NSERb4g3LwAM19GS2Bg5eKWYRVpi
583	B62qn2cHKQ2B3yMFm3nPGZtjjybLyNV4M6cPJhU5qwJshboM3v1gGjL
584	B62qqn71PnUEPEd5dSVqLhF3ybFkrLs92Zp9vqNtzSChozgQy9LvUbr
585	B62qpfNHqWHttFwaQCoG56SFsTNUkiq8ZSCDh1dUHBjEQydvnGrps85
586	B62qqWpBYarX9Ly3YgQVr4FCmfNJQ5h58tB4tUeWk6ahzUb1JRQC45m
587	B62qjhfxnFVwmeeM2sQS6JFNKqQQjU6vh6aRx65rj2kLNYctTwGNZ6e
588	B62qm1aBGdqZBX978CTRL4nXsZBL53vEVN89nWXNqD3en3GTkBdrVt4
589	B62qnMBhchthufETXtKFcmruhGth4rKpishTyEthEWDstkKpYv3js1E
590	B62qjB47C7qpPBEa9og3QcPj7a89ossecNMkKkyWJSYNLBxEjAcjT5t
591	B62qmN3QcipBRd1izGrZqRHrdCnrXLLGW5RRoNNG2kCFAf2zr9UvDUm
592	B62qjcaDeZdy1SdJ8DM5EazXY7LgFYumPE1yWwwCTr18qhYJmJ7tVcw
593	B62qpGyTotKHjKuT9GNb9SG2gH44RwkdpzfFSpvrTLTNx77onpvwfpE
594	B62qjET9m1YnNPcgdFZCBiacwGAo3nXZY7GdLdvVsa6cNCPPk5FTc9d
595	B62qr8FNc8n4xa9tJwy8jmmahpzzmNxG5HoEt7RnJNw12RGTVVbQpBn
596	B62qqgGAQfpFhX8G1iF253C37CMsj6ypn77C9fr3Y17iU6B5Ft4XjPo
597	B62qqkkHiZBewA4R417fKmS3RjehKszHLWQeMbB82FC1mzaQC8Ug8eN
598	B62qpuwoWLnPxHTvziz5BXWFN1YHEMMsgvzxs61Cfvp86Ug1Tyg8cYk
599	B62qjREKDBtm5KBteU8RibX6P6JLnoQifWYL3KGvaRLJjUTb2WM9hjf
600	B62qieizHWA2zusWh8y9eCzqA6dvgGNSs5RJGHPmAGcBtdgr8BRSfEg
601	B62qnYnbEvsgp6XxhniNMSJWA43S1KhWFTa5yj8eNxesUT4oy1SC7r3
602	B62qruUAtiAwgCWccA8ar6GRpn42XcveALEFLqFtZmhMcv7qMgypXZJ
603	B62qiU5Mc96FNQJQwv8JrE9LB8RkvummZ5MKnWTPCiY2E6KHnVppujV
604	B62qovmdQfDRrVH8M9VcjZtzDBQZLMs4hGUHa2mTD9AqUBrVdhbdXxC
605	B62qqUbgYoUXC8kBedrGQCkJVyVc4dcS83wnvnwfy7hrcKhp6tTuij7
606	B62qqpujuZ5W9uGtEwJv9R9yP8475hjFd93D4fVXoVPi9tmAMsQZBhn
607	B62qqSvXBa1cdTsARTVZrnJreCDdEy162q7axsf3QfjWzZCKfrU6JoM
608	B62qofuCX3tvb3h4TCQtRpVkm48QagKxPduDqGeTerYrfnrqPVHJnvH
609	B62qjbquAf4aYaSDycp5LRghKFgcHN9iqEVF58HDToC3khxeWH4Sf78
610	B62qjVmBp2KcF8ZNwXWrmhLuUPmogYuQBtfHEhdoaPZee5BUTJEWkku
611	B62qmQ7bj2w7PsKUkhicKKYCP3FpaGRExYVZm1EPLrniABscEELzgSz
612	B62qnWVQwpWWygmtRhdKwXqLoKrK3NgrWH3tA4E2EqUxw78ftmeG54s
613	B62qoWWs3NfAPtVKRnZF96gEF3MWbptg9bzC254AQNswpk9WwTFkjS4
614	B62qjsX96RP1X57eLLFWtZ7KwLonopTQ7ha99Hbt4wkyreFHkh7niCk
615	B62qmLxegnngeCpHk3DhZ3o2NKBT6v3oFSYM5S7ZnVHgTx6RMcEBJyX
616	B62qpYeiM61GB1NSuPxLyiqnXQSJCN6tLzkKuD3sr6Vs9qauV67zNiS
617	B62qmMmwbzrAD7EUmGSHJmwxhRBXkDxqRbudLf2p1ediX1N5zcifWpY
618	B62qoa1oVv1uEUUPyPHDc4NHxSb3Lw3XEV7GPcwwuYd3vVSmVV9Jo9P
619	B62qou8psL2pgHjKtNaXneRq8FJWjjvbxHKZVhR5oQiu9ea5MPpa9QW
620	B62qrCS5D3bvY9rJ7QLfkkiFF1Gq3S87q7qa72d6VbCwC1UjwxykHTF
621	B62qji8m9VLx6nomDdE8aiMokRfe7U4CM2wnbsVQjnuVKzjE4rscboL
622	B62qnUwVMUnPEjqLyuzoTgyUF7pXZaYYahrkchgB5mdY2mc6sbq3aP4
623	B62qmHTypp7EXGMJnZXYRpHEmRGyZCTpDgjSmkpmQa66GQqR6eaGode
624	B62qmkCaak2xES3VorJkREWQEGiLVSJJxZp5sCVcRXpvPBzudwcyjRh
625	B62qnhc3Ms4pDmgU4jR1GriwCdWvTeiKcWo1ghvAinQn1kmjqMXFpgn
626	B62qiiCieHKamGw4VWafNQuS9Dk5vRpVV4hfTSa7b5QY8DAHd8DsTse
627	B62qjCk68N2Bru3X2qKnGbzSXeAcaBRKHMQ8AFtjzsV51U2ZeBgsMbV
628	B62qjhoGN4uGjHGV2nuLys5BegEU9ogzk5M93SixvEe9YWju4r93v5x
629	B62qqUCg4rwxdbgHPsZ7Y4CViYsFPXqdNheEv3PG1AYuCtDmp35gviB
630	B62qk6cpqWZJ8tAk8pWJXovNNKaxsnv3vCiTtHSr7SCTfHvYtesLWyU
631	B62qjmReWEeTVAM9btVNBvzs4XPod6SkCAw73t1pJnLddrUg1cP6FaP
632	B62qp6qMf3Do4q4aKqEsLxVpVuXJaRCijtyhsjZBvDSEFUBGXg8Z9cs
633	B62qkbNu6GyDJ7uxXkfYQiVZHfomjtqN71sRcmt16Dg5VdjWBcuvJRK
634	B62qpMndmJbN4GDzfcCs4Y1Qk7Ss5ggB3t5JujqR2aco19erjZuwTSS
635	B62qnYNUymzFsd2Qn2ofpGkK67N6MHySGyVNK6c96nVAtqHptrt9Xin
636	B62qmW3eMFnZkFPEkqz35KvuRfEJdx4U5PydcUmbs2P3ioV8c3qZCuR
637	B62qqqEiUWc6RsMyJAyjzao4Ba58nN7mb2ETjNNWpWCQtEzsd7sJwoy
638	B62qnzzyo6V8Tp2uxgGYJ5DGZ6oKV8JWV4NgkMJrqqCRwqEu5dfPaLu
639	B62qn1QgqkzTVXYqE1XVy24znjMuNgixJyBWQiFzEjPpRYHaJMsQK7b
640	B62qqF2kUvSDw9r4XdukwST3qtqXE1S5oVfMidV4JBr3BFHpGQ3Pd4d
641	B62qjw2PdqLJYNTr6cNDXEmnc9FLNoaqVMHMqiTX7sqLYJRpd3mshFA
642	B62qjS3YrJ3X55jxEqVjC5CbKRp3XF7SpzNvW3VENGMFcXzdEgSDx5P
643	B62qqJ9zVibqkZob87KoGUuXtHjbJav87soLvUWmDbGpRsfYdToqYgP
644	B62qmG9FPKEZJbm6vE7nMNj8pvTzN8Rra1L9rRNhnwV3VJceHzg4SVA
645	B62qjVQXeEbmiToTf1ipPd3c5BDgHuqjzb8GCxdgFuaDV5EGg1yMBZm
646	B62qr2mdhKQAJb3nSwHJsvubaexz6S41PHTtuDbvqCgp7d6Wx9C4A5z
647	B62qptcZgqZFFwkkmbhvjFiwac6xj8ysCbzWkVTYzT6NckRKTpi7KH8
648	B62qoiUvWG5EpEPHTqP1qdxmyteyu3r7ogbjDyAjntWofNGVqfFzznU
649	B62qpqKh6G14cd8HdnXw8xk5kZhRLywjJkPChRBXh16J69dtkWhtw1K
650	B62qoADxfYFK8WytE3RK5vH7uYYpsJ6Dz63wxB9XFJjJkzRBctb4UzD
651	B62qrnPdz8HpsDJfGHirDLpVrN2VeyeitdaTKBaccWtHpeVW9Hgwi75
652	B62qjwTD8QKpffkzNEvtJVqRfK9gT1APcvAu6PkV2nD4PLTbvzx9KTM
653	B62qjJ8mNz65hUKWTh5wYbaHDa9nqfhz21JbY4ts69xBNYhTQxbQzCJ
654	B62qkwXAkimjPGatos62oGuy8hL6SgPN6uwnts6NHMjJt8xREdFTgEh
655	B62qpE5W2YYB7M8F7SPUPG9BZiKMoYXpv1zNFbgUCvGFWXTAuxdFwUs
656	B62qrRKJoUsaKzv82QgkkrVcq1iPCprxMACryScmgFkL4vQLeseoLQv
657	B62qkTNiWzgNBrnmFXVobwrQqASFfWkVxMGzWH8NL1fDc6Ckwvf2oG3
658	B62qkaLCKizSR2XFYFK22jVPuxSjJKXPhm8b9QxsGmW5K15eYFq7ZNH
659	B62qqqhi6Sy7StZaT7FGFn4DQaRANEkiQfRSdnisCoX5n46HD9D9tZK
660	B62qoKgbZLxduRtXiWrfM4zhmkicPQwsNtd4eqcizd7WPwD18aDH5hj
661	B62qneDu6K65UhAuf7YCXADJWtgJh1y9xk4nEtGKggLaTr2M3Fbj3iR
662	B62qiZwdQ8Wdk8PuGtdCNzWrK49zmxLFWmogt2xXNS3y9eKS7o5qwxr
663	B62qrGdW3pGKhs8BRGrjom3WzTFShfAobatkyKwqw7Yrn6NEYDDpH9C
664	B62qmGqivW5t7jsKRooqzAroKYSA8vxmsreEeMgxMWzzjdjUtWY1LYx
665	B62qrotmFVdZMGL1pbSX7PZUWKJirNg33bFURd95e3rpxMZkg8f2T7h
666	B62qjygKzKjrqscEqYNygB5HpDpVHBGP4QQ5uYar68riyYiJfg9FvyG
667	B62qqJwQJuDAUEcB6gjj7cDDhG12G1xwQcNeM8fi4wFG3GgSrz2WyL7
668	B62qqg8tqdhUx9K9borozHQanZpRs7zGPsRZYt3tXVMuuMYjUtaCvU1
669	B62qqrzb7RF35uzzoxN1aGLVmaHpF8MfoD8wrB1y1R8ve2DXZtVHhAz
670	B62qqGW3z7MPqw4jDQrYhUHtq8JrhFWDghAyERWteu5CJWzHkTkrQ7k
671	B62qoLPVcqSf2pKoc9cZnXF4mcLh9Zjtk7rcayvwsgWuJTGxiSWtrhy
672	B62qmGV3ExCGJhDJRH8eq55VsSAJoQPBnMt5rmG1SUa7voPLeoLbBJy
673	B62qrQVEMzZSpnfZsDoTXtFNPcbrAogL22TS7pLam6Ex9sDNAG6pCYj
674	B62qmdut1usji2NFZSn9BrywhjHakYtAvL7Mdy7muyjcbrY3hKJ688Y
675	B62qiZktgNut9AdNXZLcLQSFioiaWH4grePCtfsPnmkcxfg5q2MjZK4
676	B62qpBGfLWyBN24kRB81tZHQ1n8PLgdvABemUDGJU2Axp6WMY2zBYUQ
677	B62qr6SB6kaJAmAiRrWkFoHN9htKh2j7H7UZ3uyTGxtkMXqNqhTEZX1
678	B62qooHQvsHsqfudGFU6wcK2YfCz7EuUd8cUT9qxfkEbt5uvTA4481Z
679	B62qkHSAjmBUWhjqZ84GNX5rnWFyVfdtBtfeeKm2D6ANtdUvfFNWQac
680	B62qqBjKoZYj1A7AAigACJZjwr7Fx2wYLGwc4z7a2WpHhsxfLu15mzH
681	B62qkkAEbwCPAAPMZz7qKP33yZpUUr54QbKs1HLVRkykoUj7SqLdfuY
682	B62qnPR78Ki1fNeANn6BBhEJByghyYUMBDiQbWVmrUMMLezPo3VjUMV
683	B62qqQ7Ucs5uquPTFgveJcN1fnHCRehxnWuVGhV5GjNzQPdWsWuH7Nh
684	B62qs12XTUTSiWuhyF1R3MfXB3p4QaGxv6JFZYoMUuG4DGCEhzn39LL
685	B62qmcuVwrf9CVBf9AfEatVG7PHr4YRYV7LvQt1GDu1ZAf5wUxvG6aB
686	B62qnpPdwJVRbyvvLkPAWYGUbkA7NUZTVdiqa1B5oEd8ABSf6YDhVXa
687	B62qqneFCrrHKdvQg6tdKGjgpJa28Lk3basrGPkyZfBJtjgocd2eabi
688	B62qogWqDwAcZVwXteX11RTtBqL9viVed1Uot55QGeoMx5dUnCVcrZF
689	B62qmf4xKkMvEA2jqAEGe2QSs34KZzSdNHXuRmduMNy8ix1MWYWacme
690	B62qqkhvx6FtK5D5Z7K1x7ebVjoxd28NtSCRacYTqueWCWQERqtEDPb
691	B62qknwJHQU7EwT9NcvUbqwq95oHx8fFMQiGpEeiq2hKkfKWor3zdnQ
692	B62qpXgAyh96eymS5ysvnCMyuQYT4WcGq66NsWgPciwE7GgUYyCibfG
693	B62qnnJz9t5v9qwLnnYg9js11RiHBTZWxg1KkJhmnAJ1iBoU5MDkDNb
694	B62qpaDKrgPfyxZtxMXZF9CpsYcVxCFMofG6dWm5cQtwTL5LzpxtHHy
695	B62qjRjKBtAr38kh8rVFytHcWY2dRRyF23ego9UjKeqkQLX76sB4FAQ
696	B62qp69bsgUNySCY2wEYDCrRN3gdMB6cDSZGBucTzc9vUUH4jUoDSED
697	B62qrJ6V72vUoqTnJUsXwBFbCU2cCk42To4mmRRY19NiGMZqJuYLLJP
698	B62qpczQrxYHA57A2eSmeSPZf12k5uFZhzrkNZgViDwjfnVRDkdnpC6
699	B62qqAq8DqCN342Em3FfZXZV5g2dK3tgtgpt75HvAyc9sRHn3q6wM82
700	B62qjUaGVZqZ8iri5r6rSQya6a1jWqyYAQt7JSicLf1sQs9BRCKdskT
701	B62qmT1gn5equzmv5LtUSR7uW1ST1d2mCvpgeWcN5DKGAJedWFVCSN5
702	B62qnr6wsfZxsxFk9xEZvsgKTLTmFmd9czVieRpEv4YnQmHUaVMMDTa
703	B62qpJPsP9ef7vbgtwcRveQJgAsWKZduzL6BAj3k39qSpfFr2dxB2io
704	B62qopxMBgKZehZ28XCa67puBLdaFJcetetQ5Eqzsov63t9G4frjJQe
705	B62qmiHLHuXxGC5fcy1QqM185VeW8CN3MZm72d2PraRNFxAzzcQ3K8c
706	B62qmfjBQ8xtj4MfcQA5kd65VAp7usta45qmowjMeNuZhvizAxYnoPD
707	B62qoyHpeJHELgZGhECbCQ6tn5gHK5MJY8RYUi4UYaf1B5oTTwjMjb1
708	B62qitBtpsUFVthx4w8pWXTMX33iYm6hRKEjsN43QeRuieUfwk52SbD
709	B62qo758VUF9BH7kdmzxvchdQg1e4DfJNaDaLubdMYTwjtKU48NrTsU
710	B62qrAjwKEug5bXehb1WoxPrDf7heb2VSy8yEmKHVp1dAfseYHhBmfk
711	B62qrSiA6i3HQRDS2boxepfMaXQeof88YLTJBEr3qjCNZerNfrZkEYs
712	B62qrHQbB4jYT1oCtbX3V37GvMSwPSw6oYmYFPYnjYNLdc7rpSdkERD
713	B62qreGujxwhvS7FM3yLHfHVUnkrj5KSWyQPkAz2B5sYkFBacvboE4R
714	B62qqP9XWKj3xMTxXrjpUR25d8k5ocEh8fiGxp8C3EszYHLuXMUPCgc
715	B62qjajZHX3V9boBnG4gNupuR6EYbT9racDtJC1GHY6bThdyHe6GGU8
716	B62qmpK6T59DvNivKs3zDXNcR7FRMQJxJVW7h9QimNjd3yegAPxjknN
717	B62qj5xvECtvu1eWdLWWHkUUULbkazUL2kRJZm1hkgwv7N8KJeE3GsU
718	B62qr7KAAzUrv7hkKDgnSzz1xDi6BuetvDrckQxtz7GNh9PrENkiH1c
719	B62qkoKSrcJms7W8HNvFteypzAYLdGMoe52mGjzx1pvNRLQLX6ZCqRh
720	B62qp48Cwkd7MpGfQBbYkUqpeeRhT5dDfW7MUBYH3zgSuwWQPpBMbSP
721	B62qoSKy5LTX48VRcvVuCfWLMeuHNqsqPZXXeYwHVkxshneaeW1rKPh
722	B62qrBcgyttwueJWQDiYA6r8PQ3X3Jh3Fkn6Y3k6XTDehoR9L5kQ4zG
723	B62qooudywX15CbVbZ1KA2ZVMJ8aWqCvYKgYnE36u8qDqZsXkS8psyk
724	B62qqDvzvGP798vcVLeGczsY3sKypYTfhk5zKk2sNyCPx9kWBkh9Emx
725	B62qj2hYKc8e6ehN7V2x4TPR1M8NjKaJZRR68fHLRh7D3BRNJSXnNKn
726	B62qoYG6v71VxyYiGERuReb4V6etLF3vdzryEXQUHWiCSz8bsaA2qZA
727	B62qpSnqVrNamS2jT9UJRxUTWajt1uzamEb9Rp6AztWiXnMEeooP5h4
728	B62qp8dFx9w5si4QzcPdMmSqFd55MPgNJiAsxtsYCzRYLGvV4XDHXXu
729	B62qmDfmcUqZTwxsomFzMBfqFisLS63VSsfyH8v2ezwh44sZH3KkEHA
730	B62qktozdEL1KySmBrr5kTZVyjcpoi74mzK3tshi2qXptqeuX56DY4m
731	B62qn519rweP51hpDGQYqCZ8JRPkpxHd2JzDoBFQcupGppuwkpGBHp9
732	B62qmEorLV4gifAPeg4GoN8PpTWEr7ytx8Xejazc1skGepEALxEbENH
733	B62qnTdTtkepo2yfBXCeMp9afk77oo3EKWDNWuvLzEHSZz2gkgr5JHj
734	B62qiuqZjBn29vKLHgDffoyYCzvn3iqciQd1LqtMKKii6VJgZfM4cTm
735	B62qnjzqEn9dxzz2e6PtoRKipZWKToySCQbKaMTjuyuTdxdmMCHGjLD
736	B62qkkNzkCjbwhhEtu1HJ7SuEezuEzpkdUCfBrvo4vtCVutiTtECS1w
737	B62qrUS2A6sjnk95D83g1sjAryRBDwjBWhBdzPKZJbgoeMaY1YrHnzQ
738	B62qm5HhL5ESWzGMBRdzjVkRGD5ZzAf8YYErcXYyDbSy7o9EXUXMqnk
739	B62qkwrHj3YCKgQsXRktpwhVFij19RiwYDgMmiwp7iggNBi8712a4W4
740	B62qk2bwhv6KNHyaUjC4ab8XPhAvDDUByaR4dGXqvR8d7duavJVNq8e
741	B62qkx6oy3qGwxaYYTeh3WeUZemaLo1Kqyui9io6Y5wxeJPEWHEVey6
742	B62qobHLtqcoUqhpmpjsJQNXhfUTbKyV4Ug5qJWV8mTqtbZbJAmn1P6
743	B62qmtWtBjJjBoTrCGdTop1uZqmf7b3nnY1RX48hXUy9XkNNxj6o5fH
744	B62qmAuxm3DoE2Mp5doamtmKwmD6TGmeA3SPuh57bvH6LUcZspbaF7b
745	B62qo1EYgARevAzQyNDxhNmKwZAdHg4j65Sr4JnJwtoLGXt6ustog1n
746	B62qoeJgVm3MzkQD8GiHNSFmEcGYRT5WaAQZ16DFYjcE2R38nCsXc6A
747	B62qj4odmzXgncnBCmBQ5CGoaD7y6rPTQC3qNezGrw31sdDqxbTzRab
748	B62qm8BBqTFCc1KKiDU6wuqjZf6n65dasH8jAHSrLZiNyzhQJLZUizQ
749	B62qjHdRfaxSdUkta6Qqa6oiXQ8WnRGkMa3rDuX1e9zZTUHwooQ9wHy
750	B62qjShUd15Mezic2rixrzAfJ9HRDQKbWqSoocLMUqoLrGVv7avL8uq
751	B62qmhF6ip7xWbEoUSUUtuvZno6itX4bTfCPoAfkmjAbv14XJfsUMgZ
752	B62qq5W8QExpM1qgMitciWQghnEQc5Gy6y2v9rEKEbxfBSw3Hh5NgHW
753	B62qjD5F3fYFhRUbdfrvUzuEhouPX8zgxDmRKL39oEWppJMRuhM5uGn
754	B62qkY65gWYLm68fqW4nKj8URcr5BTb8BN5UHo65Dkh35tDMrgPeyeH
755	B62qqdTvDUeXvUSAUiNQ12BthhmgLDpXUrmxzYdbHxLz3dUNM4vEt4Y
756	B62qpeTWsqipUEyG6nQb54SfbDrCrzK5zBwFoVqggexDNrUnV1aXAdo
757	B62qorPGKrHgPAkt2FM16N8JttM8CrYVwL15tBy5oigLESPFYC1SyXh
758	B62qqhmvrqpBEJ55rR6v42AFnh59KktBsXBqs4i2fBVTb7uBqBsUNSy
759	B62qrLdrRjY339ix4YneW5hQwXcaPFYbL4y35VEJUKoUugrv6x1DAFk
760	B62qo2eh5weVKJH7AtwBJewA9rKKwPYeScV9y5QgJWPJqMaYuc6kQ7T
761	B62qpV2bk8Pge5E9D2JrMwg3ZTjZ7G7YKH3k5Bmo1D33yhiYgu92Cn3
762	B62qkL5VU2iDpUgr4rqkGiu1PaYspDnE266618gUVmpVnARaXbd7iiB
763	B62qpW3zh1yMd6n7bkXuT4SrWjEp9bZeDTkY449DMBYBSjEX8wJTy15
764	B62qmfZo5Hbs4iJ2edczgFJsbSnTunDPPaXjR1AtJVX1e9DHuezeKXg
765	B62qqsDZB9aHvRqLGzsvMzC1ZHewLEkActsP3VFRBBdGabAdSrgMrnD
766	B62qnMXrsM3J1pjdiDuwcem1dZeRtn3aDDyr19fTEcAbyaxwyZSWEuN
767	B62qn4BzvXMoAxWPpRf59yjgowibyXBhcUzGZJmCJ7RRUaDwDdxpq7G
768	B62qmQ4WrMAxMV1tBjANXZiH1FbCwhhsR2p3uXWcVbRQaj4bPTH7fGj
769	B62qqoDxUHd2E3g5Ngm3HphxN474YzRwdSVyYoNnUo4um5qGxLxtZ9K
770	B62qmVHYfw8BGCpw6ngZcM4tBo9GFeyRw952N2WB1LNaGZEtGAtFBFS
771	B62qqCFf6pUfES9zA3h3t7qTezP3RJvYkb1Y4szDNkQj9LuYayXtkVU
772	B62qmT4DxZoFZqJgfKYpZaHyV8KBfkmYCuGTKBfioKd9Lddd7HgeARV
773	B62qjVUmgXQikmcey3JHSF6fVqX7MoQGnDfaNu2AQpka8YiKfTmggZe
774	B62qqDR4cmdfXz56KDVG86TDvaa2To1gDxh4XPXEcPE5SEZJTawznVA
775	B62qo76fFxJPC7zGT7NwpZKDVuKHnLYURfnvHVXzWU5zgHRCagRyZfQ
776	B62qr2ingZ5sWoyEPFazcQkYYWx99mLqs84pPYSdpWkRCKsg9Gz4kTz
777	B62qjrj3SdfDoWxS6WvKn2Tvr7mdA3EtbsHioUuXGL73ckHu7iDcfJb
778	B62qq7uLzNiVPAsnAzKjkWQ9dviqCH1FbNZcSz2Gi5gnjoVoVApgMdC
779	B62qjb4fDewKhourt5S272F1WKzrvFVBvCz6dthVErR3bVHpfNL3Q9r
780	B62qj4UFkH3x6rKf8KVcbuPjGQhxDrwcaqUYiMNJk7Ct9DB49X6pMBP
781	B62qrBYNNHZSLNZwaY4FZVNkesEPkFbZfq3YUTa4ZyqRkz1aN86BUFN
782	B62qjuZfx77kQYKa8WxE11MdN8kT62gJcoZov68wTwTn4rizgCLqtwD
783	B62qnnpwVapFcMQmADmxEEP7FLCQJFVsWFoszPa9j8XMANR3bdBpDyg
784	B62qk3gczz73qX3JJuKhovf6kV2F4jucX58P3Jgiz2wLB4THjgGMfAg
785	B62qoj6Fa45LsKrCiGRTFCuUued9GNsRc5yhy99Du1i2ujk58qUL5Gu
786	B62qkHLU1L6hu4kFvewrczukTf5xLuT9nEushCbJUdjiaUUwr8PKE8X
787	B62qpb5mxHwJGQZt9KvY9m8NB9Ys1noCZU9zVjYmfdEezE6dVbBdnjd
788	B62qjy97FSjL6v6WwLBgvkMqwq6GriQqwdcsw9TWGUt2heoxLYn2fc6
789	B62qiodFFAVHuB6jsP6SWJFFqAMK5V56qXtX8FBdgszAzPTspasiVcT
790	B62qne6iiLkr6kCJxrmPkM9FL3BoWzo4Q4ojmPAQTCPfzKCkQ5w6iP6
791	B62qnT12nXfoEiupbqQY3jRgjm5c5ss1QLLwxhHUy82tTVjofqUNDN5
792	B62qpzWsX5GPqtKwr4FUGprtcQhsSnZDTQvBswhCfK8A1YQkFB8dFwg
793	B62qmmVpWiTAeCU2LNHotLGjRehfujKfgSDxjgb5xfdpGzcNUcdYry7
794	B62qjhFp97dHayikjR9DiBKcoXorthYwU55v3BpSB7SLTGd4wrVfx2m
795	B62qkN4gn3hMKL8f7kY2kvL1DkzpTBV9kaFkkpiZD3rdMYER3LhiWVR
796	B62qoYDE2yrQoVJ2kf2N9Nx2D21Q74APsKd6DbAQKekCFEUq73ioHw2
797	B62qnrkfmfeoB1wXjfcTFmF4gkvi9BJRnzcQnsniMc93RVAAiU1HfAD
798	B62qqWTHw1LzB52Z52Xu9TZmLgctX2jWWuvKsSuaPhjmgAmDsjNpGdh
799	B62qphYQ4tY5F8WVnfzXW4wQmE3o2ucRBBtSDW1mp5AZkdUceo49zkt
800	B62qobj3DXHb3w2D9eZAMj8b2axbeRbJn2Xnrddv7AbSky4DJXDVewD
801	B62qnoWdBv77cHsd5ZAuNyAXc7yh8sXQtHynacN5NZNw2zhq3afBQbH
802	B62qnQEfUUDVxUEwPRM99J13n8TNAszcMHpxgSNm9zjfHJgWjgyZ4gb
803	B62qmxTSCY41R7mQT7H9s8SJZpvLrFHLDpAoSwuP8ghWsH1Kg4U98Ej
804	B62qnYZP1LaZ2pXHCRgbU6vUjMH1s2b8pjNfrof11o7xBLL5M2xHnZT
805	B62qrq96Nr4fsJHKr8Xp3jo64JfqrDgD57YmrsPzCb6WWx2K4KjGgRn
806	B62qiUsYoPyakMZx3yPJisMgz1DpbsW34u7XbYrhw2dQ64rjp3CH5hH
807	B62qiodvWNzk3h4hbXkPgWTkJ4KBqFo4VBBKh6fNjk6eeHWsSURBSvu
808	B62qmPQpB7QLG1ozmbPkHY9AfD64Bg1JEes4T7i8WXtXnAVnKgrJNBZ
809	B62qnxnXm4rHZNd3SaPW7AN2m6JWpDqW7pxh7BorXsuq3UL3GFbNesE
810	B62qimDqNEaG5VGaekbm2sa38ig6C3XdRmYAnJMeCPaopuv6WuVPBkG
811	B62qnMo1XRuLgEdTkBmVwP8xG8DuyUDud3RyPeoBoFEgopEHQ5tKrk8
812	B62qrL6wp7iLQ4UzneLFdGas3pNoSXksNJHDUEanWCxfBD2fi6xXWez
813	B62qpgbBf2GU6cz2uzgBzYxt3AjRYTrLDmsu4MyN46i66whUv49LfCD
814	B62qrZCAKA2YwZ3Na6Cv9VdjF92y2G4oCud1JQtWwDoyvfkjZ6PCtTV
815	B62qoY2cuwsNXaBE3yUwSqwEaovhwRqmGWjBhNL2AH5vCeeRgVsaxCG
816	B62qnDczgqibMNMnATpdsv6wXWtF63AdNz2bMncXwxo7i4QcMMhwwL5
817	B62qoUVGV5aZZsyaKyzA6wRejAJbXaRHCxLzPK5B6s8M9Yp9VAB2p24
818	B62qmk8Mi1gykq1A6EXDKWJCe9Q6AGexJhkVq9f5k1yDLxC5Tsb9B8z
819	B62qiimDyKH2c9aMwzb8pnepGj2ySQMGLctdVtLVLd3KC9z4DU8a14T
820	B62qoVwywhEnMWAKegSqMgP8pmdPeF35UARyuSnq1M6CadpcTAs3dbb
821	B62qjFfENgQq2nRqBy5Maok6DAL4J499x3FUn2uJAVn1ngy2pCAj5sz
822	B62qjfxJWzG3iQtzBX3SGYA4YKPKduJdFDwcJFHCQL4JmWsBNbXeELc
823	B62qpmwejvd6PkaFsUmvGN4KwL6vGKMdFHLqNc8ftQTdfnuKD7QqM27
824	B62qjpLh6MJqKkrJxtfVuqcZ6nkPG7oKRaqLcuwLEf9k2SSgtHgcYh2
825	B62qkXRYVPK4uCnLrx6dgo6jSpGTf5F2z1VrXqDvSK1kksEkkZCrFRc
826	B62qnaF9jEEe8pxpwkaU8ij7SjXbm89PQJxKd4zFu8WEutrihCtbU56
827	B62qkehW659cVAECgC4xFWkbAvoApuGfKddua9ZVrNPs727WmG1wLah
828	B62qpw1rpGnDK5N56eG2uxxdM64dqqoWrq7rCgn4JXPNi2k1P5YycAt
829	B62qks1zLMdgBEaVegEfejneFv7apcQ8iVPvQamtVS97ChZaaWzAiKa
830	B62qp5DTw3dw8ipgSCCDBGextDBAo6FBDSWVwMo1xLRJrH9L6UMt9d3
831	B62qneKBE4uvxZ9LN1Av8Mn674J4yemHcob6pPHLCoHwUvrTKGt47Zv
832	B62qjeTDYdaohKH2Ztb8Wiw59HSiTxzMiiseF347BroJaMnUAfpgVUd
833	B62qjeV5Kj59aJM4qCQ8ZoUmoMH5ANqtgdmZXY6FhXdNwUn3y4NnvNC
834	B62qmYYSw1qctf682uNtc5M58Kc8RoXk7V8P6h938gi7k5pbWPmeVtD
835	B62qrzeAiJZQ4DnFaiDypcprKpXgV4vac8PrmP4rotUHRz5U4JbTy1E
836	B62qkKUkxK1Rayys8oTGC4agJKnpZygNK3WKauCJcyzRThdZqEfcrwi
837	B62qrA9qWwACb4LRFEBQsjXnBZPw11D465L4AByNoDunzhCDntgJ9Lr
838	B62qii9M7moTAxxcG26MfdCuhWajNiKFLf3t5cqvy6eWuEAX8HexWiD
839	B62qj4gpC5Pbh6nUDBg7Xi7DbfDBLd4wQaHT1dodjdEK4pLBi498FZ6
840	B62qp3M2wZGawSgdqY4ysiRDnSEVqfrHVZcBucPMaS7EHEPoVeEBXYF
841	B62qqKV2KTVR8Sic9Yq9P7Z1sb819smRBaCqWi7UuzHgiagLrSRmi6P
842	B62qkUgRDxfBF9hMhPk92haUbMkUuiW1mVC9VbTEF9mJupp6uyQ9RDK
843	B62qkpKnTJ1uAR6ZQ7Z7DW9UwjDuzSZJkTPDDKUGHgBdi5bQAUJ1gG2
844	B62qjQ8dr7xNdox4e5xTGK3rVeSSBDSUfwQYCihRePqfRXfUfDurckV
845	B62qqrJBL4dJcHBRCxXRkCbYfBXqhRHRPS6dnPtbumAeKhMmWzQ3c4b
846	B62qjprTZdUaTRW9g2RMLs5LQ37BiHmb6hoh9kFAwq4jp9mrg4fLJvK
847	B62qrN3hZPxTuAhZzuB534ejuF48KtmfXWFqMLa31NTVcuAcui6oTDw
848	B62qjeR4SzLtURfPd9XoYQ6p389iWCZxwBqMasyLgwRJB2oWwWtnski
849	B62qrYufgatwTD8UkM1tLnW5tfnSeWYSPtbBYyYvdQ4dvoA9KBeWfcH
850	B62qmzFTUsRqK6UAQuu1aWdkyhaM29WrCdGoo3wUm8W1A1ahCU5iBsY
851	B62qq4qohsvmTAJmvJ5wSepyNHKsh1wMPf1UjoHLKEuLmgH2RdAa4zt
852	B62qpSarkCiM2BtkyxEYgHXVPVtdghrDRoTKjXVEdVMrHmpe4Yqc3xS
853	B62qoA478cjzLTGH3JqDrNXGjQNGQJeKesjnS6o9aVv875epCMtrrsD
854	B62qj2JEHwhtaq45YYudYUEkcF34xdukLYaHreXginU3ddL9haLC15A
855	B62qpk2BRXnuxofXRU1z2y1LWRagabiSLoBuCJjDSv9ebVkzZE2zXnp
856	B62qqyxmcGrRFNDhE2rAQFeYjse5SNJBvxjkJDqu7gZby56w8gyioB7
857	B62qqhTWoZineudzfT9o4YTdruHTps1yANJz9z1Zw3YnFAMgCky8LFS
858	B62qpsMxKCoRQnr75yfsbHAsGn2Cn9YcHYRvXhgzURkGdYTnj3xufsX
859	B62qpKUqR97dtt9n7CSrz1yPjfBHg2h7yksQ1gRiyB9oABZcXfurTzH
860	B62qq1p5NS9N8D2jGKQDZkd7UrADvK3EeysJMRnT7aXUi9iWEwupNiT
861	B62qmCwouxG2UzH6zEYGFWFFzUuSv9sbLnr96VJWDX3paSSucX7jAJN
862	B62qpoHJA7xwPegQPSQ4xa5vQEd15uhat5r5XRrrm9wUhMPbdF5CC4b
863	B62qn42hMGBuo5UGtLMDvfZ5eBLnkKVHTXwnQkktfujrLVtco34WFqx
864	B62qnbCsiNKmdj7GYaMv3Zf6jTDhpNbMTAQYBZddCctnrxrkG76qNeH
865	B62qrPH1SqnVrh92QART2N8sjmjRqnidtp4my5SAxstpurqQheNAR9u
866	B62qqoZx2obVArX2Azh2D6AduLDv3BpPMzJaBTKNyA8RpQ8xjJYcH7E
867	B62qmtcbMEVVKN2guoyVEqmiPZtbvNhz4VUvUYvxesya3WHPkLiBvdK
868	B62qjdxMGGRmQ8W7tqRaEuVFQgSPqkiYqFDUKPkJ3Ks9d23Mwmzgphx
869	B62qppJosj13spPS9ZvkhqUfqkTRH9LHYHcUZR3Wivayjrs1tZcZxXq
870	B62qr6JLYwR73PNJYVyRgsPACXduQtebRGUPshKjeJB26pHmF3tJWr6
871	B62qpzxtQkkNdCARWbcFhrQnB2cc6ybjDHhFK4zuBm63QgMadjnUTSM
872	B62qr2cpHeCn7XtQA5ktqKMQ8gmi6UT79SoGatfvinNyBih13tr2SuF
873	B62qrQW1u4635tmjLjkz7pdUrwE9QhmYP8rPb13SpaNBeHa4pGidstk
874	B62qkpgRQcmwDPEt25g7CoBSE9wY8HWCzVsmeTbvgZ1757rKAtUAPWc
875	B62qm3hoUHCPWGdKfrSK5Ek9STvGfwjf6L1uewvgFQHCVY4Y48DT4Qr
876	B62qpLv2AVt8zikusA8jkHinfWgCtLnfnZKfxrzitDBoqozwo5pSSjH
877	B62qiX7wCtUbpzgJavPKbfBcLJ6nyYB88cWjfwjWZiyZZLS7weCDxwm
878	B62qouqyiJfmysbVqgXZJy7rDvh2ZT1w5vmEQXqKAkpfvk37xQePyYL
879	B62qiigQwvLyyqUsAL3SmtjP43iGnUB1s1mUYrhvyZCc8PVFaW9ZQvd
880	B62qoQg5s8EsT3wL1zNT3sjbsJkGXUnBSfukzB9z1MnNUo2DQD24vus
881	B62qnbZcyj5U8N4nqGyt8gf67qsGitf3LFfjRsNZuXV6c3XA84V7p1v
882	B62qrAFo1P6wZoE43hPKcRWodZrC7wZFUFGHYwFgh8zyrTyos9ijLSf
883	B62qizxV2Z1Lbf8TFb4Jzf3uJTd8CDBSuJ5ypkJdw9pZNKzW1Rzxrwh
884	B62qqNrAYrDKKMve6ECt3mgBBj8g9M6xKR4gdNusetisrAhUTgpHiV2
885	B62qjUNbZhrc4vYKfib3kfL8HRAg7ozdis2MhTXA9tobeEbwebdBfR3
886	B62qie31VMdCUN9VbJMP2D9EwzcdcF6iYjBzYeTXPiuZzbLaBnYkJ54
887	B62qmru4aEDszwLFvH59BtZnU4QLC52nrSRBJW1EfdAp8cD5drg8QFM
888	B62qjpDZTY6ZXsGSJpMvZycBJqv6VFQTStdrEARwh53qPBfcBVuMSRm
889	B62qpz34iGX2eaRDyHmHbq3v1SnUgzounhudGZRfNUDh79JuTstPNy1
890	B62qkavJuPZs1bqRTdzmACy3Qf1o8FYRbh43qRPvkB6tQconwjFuAdx
891	B62qjUut7tByYkosrfLDC5aKLSLQ2JxTbkBcfF3em3HwiyNkEsQmwfM
892	B62qoFS9tDcqaxcatXcr8jdTECpTXwa1vMNfuDkEdp4tc7uwn1z5ELx
893	B62qoUiAHZZ9xY7BibT84iwMtgQidQByE7tCuNhn6DmyKhUPAzpnJAd
894	B62qrQMPSJpee1NnxVb4cr1qBtH3kMNpXaHVj4oVxNhqadCMBk6wELy
895	B62qpMJkbt6b6n97jhW9iWfvmseaqaiUT2KViBUKUHtE2MbxVGSPBnc
896	B62qp78FJiBUMordLumiKQMewazCwcH1Zee2GuK5MRrEsqQ2NdGHsWE
897	B62qkK29ScnXfTzrDkkfASepKoTE57CT8SA4r43EQCCwwJXAsP5TGGN
898	B62qj1ddvraTFJVjVVTpDCa8Cs7TVhZGjqEomQrpahrJ3hdag54cGb6
899	B62qmEo9HSSLLM3DtUJwcNdeqqQ6zoNUMqXauu9ySWKdpo8W7T9bjR3
900	B62qm4km9z5EFAGe2ByVR97gvnbbx57FQu7VQWEviPQHtaSeApBKjQB
901	B62qnipPgHt7ajPdMko2STLDAxWW1M5q6sZ8V578khR2KMQUbhxtTPN
902	B62qnhoXZG3BqKWJ6vTmRFM192LqvKZYDt1UJP88gi729USiio87AtK
903	B62qibGLxx3ECjWgU2YSJ2LZxXkPriLyPHZEb6FCdMNMPzAphSFZnWo
904	B62qrGcX71YGYbgik6onTADgDSkk4huovAhjzJRZMdUZLJRVZ4wG8dp
905	B62qknoGUuTS2MmtZMrJLX6SumUP5BjKJVhyPTKjSBH5xyenxZ8dTWV
906	B62qmQVRztGMtwamypY858BbGPRNmoJTrqMrq6xb2BtGso81bEzn8bR
907	B62qjWrka3sHmyX9E3LLk7DYwTkD3xpVxJVWeC1jWesvUCw98jzwLEb
908	B62qr11GnajdtFtYHLB25VfR2HisWw9gQTtswLT9UDuBDupwxnP8Qtm
909	B62qog6J6WmV7EG35JYwCoMjXGQKfMzDf882feobdM4XSTvd4TM7o4x
910	B62qmQAFPta1Q3c7wXHxXRKnE3uWyBYZCLb8frdHEgavi3BbBVkpeC1
911	B62qkLCr6WNbmpwmV3zLUM99J46WGpEJLcBbQEbQen2oXV9MKU8f9mL
912	B62qo41tpoLx87ag5BcocFD8QV5jQB18qw8jnNqKGz9KDXna7PT3DLi
913	B62qjFozcCaaeMNaAWrRT21JUsSaq47PYW8DZdySviwath3Mg8nyfCw
914	B62qk8QpsgrR4d5NM9gxiiN2oiZSNznfeDbr1V5pFWa82nZy6iwKhfw
915	B62qnJ58vM1du7EkL83EPtjN8wt1MXKC93Sbe6icpRhfLVgDg6xnVgA
916	B62qoERQaxigi8r2cjyUuQXicjcPbGZfjRkeUn5sedzYisjTBNtEddh
917	B62qpBVRzjqFcbzMk3JAFdjruMAoqdHyHiE9XNyshZ5NjGo2gY7CxZz
918	B62qrr1TdC3LeN5F1Bgjxb1v4Pdxt6btzKL7sGTyLGNcydmagjsYsQi
919	B62qmanR1vreSJgKYZcHSiNrov8jvXShfcjioaBLpCGbr7vrt3DxZq9
920	B62qjCoLPn8iXHXq9ukNMhAfqn39o1MZKsAx3VrWFdu1pEbZZezJhJe
921	B62qkZvsPhMjgYTiXLLGXWaFUCFGAexpR3v2z5ymXKEuZGVhub5ebNk
922	B62qodbQJ5bnuY7j71eaYiiiq3XqYDgsBDJxkAhtzqBNpxAgskKdTc4
923	B62qm4UyivsseKABrgJxS4AnoK4SX8b69o4DWrR9cJ8HRYGrNq65iEG
924	B62qpcJd5eVzs6z4hs47nMQipXJdz3nEaEqbLStc8obzecfNPv5vAnV
925	B62qo8FPFHTQ2J5eaCK74yfsMRBFT5bnr2iPomWLv61iGpaufBop6Si
926	B62qpGX4AkMb93fusVyC7CDNju7FUP1fFVbspw8o4sN8xbmsiKxgy7f
927	B62qqLBQFF3oRGthJGnbZB9PEF8pvoxGcfBNUVtgXtH88VZE9KBoGKb
928	B62qnQ9R4djFcZtgUnEASzipJj4Liwdpt5WjM8qnQvWH9QZZMwPHRJc
929	B62qjyUJF51Rh87LkCzFUrWFBC2oSqL55dw1bHMkPov6oGpqiZxd2Xc
930	B62qq6YfopW3J9zaw9VEjQP8tehZVzewtH8LDrPST9FtLWnnWhnoKJ6
931	B62qojvcsxDKjfx2UKTfrsrQ4XYt3x9gpUfijNtTyNHjMyKigubEL1Y
932	B62qnem3qr442rQCJ1cmj8kLqk48Hpi1PEJwPXrMUNyiSymQQxSJspn
933	B62qo8yt9f1eQAv1kNUocT7jWKcHBTEcMxkSCmK5FSn9eKUfy6mZpQc
934	B62qmXBgmuA4Zo81V5Xmhmr5opdAbbddfyVxsdvJuQutceSHNQe2Scb
935	B62qjYCD9rCC9mqfqdAi929GRuZBmNfba2VomgfRVtZQzPa14YguZd4
936	B62qmSLcBAgGJYa14CUyGdoZywpKuztSKWRJsnKFSxg3oeLAYaotLFv
937	B62qmmvXhqFc4KpY8o78Nx1N2gusT9zC7D4pairouAZHyJmutVqApJ6
938	B62qiWWh6F34fwbZiv5uGKg15vr4C3cxKDBxR4xypdgQErk4t6DBn9k
939	B62qqMhtDSFToxQLzPjZ27PVtSCZR9rgUrjUDcjytWSsDZtPFiQMrnK
940	B62qqUrqjmVerAGWSk1TByCBQxzH8u9PRnKnMu2YH7YbhyS9CzMnYRq
941	B62qmiBiazpFUcs4t2ccJ2vEzh6i4drnyLQfNV3dEfgZfKYYjAbu8tC
942	B62qjYKFSc4DJ1g1PGuyooe8BGXfQEiTUb4oLH1jhntZtQpz9aV7WY3
943	B62qp8no6FregychSQusyD56DkRrqvg9bhBF3R3BQckQzQoUY9piJ74
944	B62qnWqVhYZaSn9xHkpih2rkbZ45MV5Q3CktwGA9EVbZtrGGjSr83oj
945	B62qkeKupTi7525nWMQfWgJ7EhrxhyFdnhANKrjSo6LRCZJ28yHw1yv
946	B62qnNmzW5uoLMPEVhwfL5xW1jCALVRfP6CEm4wPbyuu5xxJEoxBbue
947	B62qkDGi9CVj8Gu7wA3Tm6R1eUa8ZxZSUeFoQUmAjqE1diaXYcN769S
948	B62qmij2xZg5ZLmMUy3Be1Av54misfGR16ywRJAsPhMvdUWpzhKfxD8
949	B62qrYfgf3JNvWRCrWWH7T64ForhkYTSRbu5QM51EFxD1Q6wF1wzFNU
950	B62qpKeaQG8uJxYGdMWkhfff75YrFwoxPwSzhxrWxUf7STrpQMMVrYB
951	B62qnBRYDxf1EG23jnJx1QAMvARTZgdJzYoAE5LoEUJbLiPsUzYfA98
952	B62qqkKscGbufYJ5qpk3GLWenaJCgK5TgiaRwozsH5BmdqXGbttGYSP
953	B62qrgWoTX6rBSPFyo8ffBuQzkkVN1yWi4LD4a1u2EH3bXJY1bTd3Vy
954	B62qoHY9jb2WaBK1t4HgboN7vCq71X1aBGfdaiQdryuyDSfsgCDtd5A
955	B62qrxjaEqDqq1VQXc9xPXU4DiJM4nBMYesWs7whmNyFrPr6Qo4GRzu
956	B62qmFMzdoZMdhvU8Rgvnk6cLieaAMYQbjNumWj9cCMuNVLmDXKta5d
957	B62qkCuaxdGJGKjPvYa6TEFqmBGc7p1CmLwAsYJuVA7iu3VTVZQDR4b
958	B62qkQJjJt3PL89vVXoHir7cCFPgpdJ1JCmhqHrfwjY7zpGYhtC2xHH
959	B62qmnPjiwSKnff1qMUuYcuixn12j251x5fKKaxPtWDajf8KgaQX6yU
960	B62qs1inqycyihVap9Ti1T4WrmqoZ2aqZ49z4peRYM1cC8Gk3brdHk7
961	B62qpJZYLwCjH5Hafi9YiCGGgVhuoq9j6A47MxJG3qzH3nzS3pZZcnn
962	B62qnKSBegBU5wkkYQfKEKPenEsEttY4EVSuizJNrZdsdrkk6xSmb3E
963	B62qoTdpaj649XnqLxGq8oY6j3pBQdujD7ftQpq58AqypTMcaZePfUL
964	B62qrxrrtdZGk1icXvsEes5DBxHuaoifF2MmutXzFPLjsuSPouUbcEu
965	B62qjyY3c1FNPLUir8MBoECUNAP3CiDFE52uc4LP8B5miWe441e1VPo
966	B62qqJXC6J5UXVNW321LiGtwFR2WTGULFwZzrDo874BYi7QGdrkpqFY
967	B62qmQQ84vg6V7NwizyZzsWk4z6P6GdXrpvN44h19TRL9dsa9xZ542H
968	B62qmPfMY7HNmuvGnQQ5kF1UoPy2ipNXAF4MtmZvLipAynggd6EWWBC
969	B62qpqgV3MoZEtfPiceJ7tH9ngz9o7a3EtkdFr2a9KnRkQGaxEuW4iU
970	B62qnysDggsacPKduRXXMzCgbU6ggCSGUywBhhrGX1c8W4nr5oSX1Jr
971	B62qpYG5JSiR88NHKPbceqDDs8MTnhmvzoDWbqbJUWEXGnuVjooaUPL
972	B62qrMCR9BPCLY2ZWMXH7ueNJM6ZCa7X5cW2NboAfpXqaiDadbSEoim
973	B62qn3jFiBMx57Tqw1EbfHPtVqaEntjZR1uihQ4jH7iQLBFS3hSPKC5
974	B62qnzTCuHo79TU9chKbcGLudHS3fU3NhLReJG34MhUVrFN6nA7Pjik
975	B62qrNpfSTjKyBiq9LEU8wNSHPu2YNPiv7sgS2yYhACKjeXWUmLvAJ2
976	B62qnFpSPGZveVRzoABYjsW6dwAXjcGeAnA6CsBjAsG86ZthTGwy7TF
977	B62qitq9vwHhBXHwU8Hu9VqPGniVUs7C74RbYz8v8EtDTnBkcLC5t83
978	B62qq4x5H4WyTJHywAZ3DzPCeUcSz1Gh7TqMP4ydANeETB68Mrf9X8i
979	B62qifDaXL1vTRa88w3w1ZcUUtK8QT5nUF5CEAKNFrftEQMu6afkoDM
980	B62qrTGV9jGcZsxDbahBPPheUd5MpV97yzAn1QrYyEAtzgfbURC3dMa
981	B62qmh665K7crtbKv7JfNQgJcBKh2bZN5vw3mz3ds6vVo76M2K7byvy
982	B62qjUVRD9YVQ8Mt5fmtjCt4aUzeZLDMSop8yg6Scg5unqDXiyM2SMs
983	B62qoTaYnDYrtmver4jnkgJbFU6iohjtALTU4ebf4yCKrxFFHd9Dimh
984	B62qoreEwCN4QMSJBcrEgDLzmygNKgMkshRxKGMZfswK9oNpoZC97ZS
985	B62qjRNvNj7EJCWSRfhKNosEYnjTCZVbMdiyymV2QxiYpr8QQehgYB6
986	B62qnsoomKzFNvmJcWAq59TLtidzYwD2hcUCrrFhBNWys2npQTXpGmu
987	B62qrh8V1qvJhQx9D6g3JDgVg1FYR8B45V7EFFim7aLPLss3kD2aAXR
988	B62qogpwsY84waaousZTWkonka6EoajHey2S3cfi9qzSbynbmGiqaUN
989	B62qiaQboSdk5JkHTNcPWUjDwVZZK96u5tGac6aLA9yCqVm8tZLsZZm
990	B62qquq5R18f5sQ1LPF1MGqwwxy1jRCeMEUsMuvjgJ4dAajdQgjcye5
991	B62qrzN4SfQpxV12YcSW4Crb6PY21y4sgpq7e3v2qh7x5UEd47RpNze
992	B62qnto268cEnV1cdZh2bRS3bMwiAT3tRxsPrfiYruHaxXERAR3Ec8b
993	B62qku85TZbbwZhuYr3xMsUJ7KndwA1wHcCDVvawK24uUtBjQDa9pye
994	B62qm6aynoQs9WmAbkoKvSn3eMDo1PAZi4jfB2MnbUWTHsq9TVKYZVJ
995	B62qri8EQAMZbZiwaYXtuh3fs14MRPJ7x3ePQh25SmR7ggKRtnfJ2e2
996	B62qmq4EksfssuNcoAvFhebPiBry1uUR1bwLEiN84EByVPAcVh2Lvib
997	B62qrFQnjeR8FesCFUJgNmJkfe6uzYMGSverRyDVjfQxDPgkr8mzjSq
998	B62qjtHX7MLXn7cNM3cF7Eb4b7cgwrk6STeUjCtPktusxFQ75T3BMPn
999	B62qjaKD4AAxb8UUQypqysaFx3cYhp5bSjzgkQobyjca3sRJKho3VA4
1000	B62qpDH4cXswwo4YYmdS9apCeRQUXtAEXuCS95ddMCFhNbzxvzZ6Nfx
1001	B62qpJ4Q5J4LoBXgQBfq6gbXTyevFPhwMNYZEBdTSixmFq4UrdNadSN
1002	B62qnNyeNzkyccsgwogTg9jgqBYfE6KnjTWi9QxsVkQ2NKgW2i5fDj9
1003	B62qnsA7W5yWUr8r27DwmBoyHqYE5FMpm5NxhotqppmbL5wxcBDZZVT
1004	B62qn9zWo5HcC2RRRi5P8278Hq5RoKgQWqFvXRYxsbVQeDCsAJP7aop
1005	B62qqsZBMoFs1AmiLxekCDUta2GPHPyZenug2DM4jrVrrZqUHi5PEsY
1006	B62qqhHF6ZZQEQ2dNyjSSMy1uSqy8JjVnoRmN4k2q9VPfAEviRpvype
1007	B62qqSy5saxH3Ago7obP4XT2M9fYkRLMfthRhgCw59jr7EvHitk4VpK
1008	B62qkVtsvZk4sMHJETFDeqzukb9vEbswirZFY4afdKYMqcAEw1bkGej
1009	B62qmBXLrMyUZ7HSTcnSpUG2DFcVTGtVFNR5sSkMzshTjJyk9nrJRTD
1010	B62qiscckHMmaedeqpSokpjidB4WQW74tmWAzXWG8rW3DgTfEfXJazj
1011	B62qmsgdnJagaswVUo1KhnQNGVF1y2wS33RcR4kS85FkAsJ8xTdNuit
1012	B62qpGm7Ubs2exzhPZuHFCmsCRrhBKigUUoY3p4gSBq2koqfYRFNbjX
1013	B62qmm7feizW8hGKBBzvh5gpdDbqhMac3zLh1hVcTaj3BbYC18Eivi4
1014	B62qkwYTYFzemJK9ozx2K2fy4YsvFx4w29PTBdwP3khDfax8tUP8rJo
1015	B62qm4egneDvLXYCwzJRLBQoseGZezZ4LUtJUT256phFLm9TQWGmFYb
1016	B62qo6bK6jBAa6QR4EYYtH6MWeGRfWUWEWXPjbYsci15ecXTafkSw6G
1017	B62qqrMW5HUkhKDPuNLToVyxcc49VEPRMaRFzSbWZysAsyPw8nFAu4T
1018	B62qkTViAbMfWGRFJyvtWT5dBrfBUReHTHsA8PWT1dBLB4ctPHRf7nw
1019	B62qqsvgiixjji3CX7whzuBKVupvwgBS4Dao6wDwkmWPi79TNcwZ1tB
1020	B62qmtxhr1gQ5PUvKnNRVfhuuVs2Wjn4xPBoXMWujaYi5D77gShXH6Y
1021	B62qm4TntJySX6ktHD1SsYumBdvSTp8pLdjMwTVjBrmA3ipkWejBdbe
1022	B62qo1mUFu2xFntFTqPhiff3TEVyhu9ukTKvp81vqzvBUDs76DYTGuo
1023	B62qnfJ6Yqn8FKmFK5YfiskzD1axjxSJwP2jRtNrDUiH9tN59xz2KgH
1024	B62qjVi5acmgHpTe2h7Kqw69xRXtc8KvJANmAnx2tEVUz7pSpfrLFXr
1025	B62qq5MpA1CzLTwC45zADGS7rRGZoQ3kmnf1nrYQzcnETfoJvU5vamo
1026	B62qpJtPWEqXnDcXLugqf3C1m4ftWf2DaXLK8J35Ka7HoZSCxKBDWbP
1027	B62qjbRyvwkiMNwAvamp9wfFoUyhwGsQZ2Np2j1i68HdbYLqviS7hfw
1028	B62qjAbb8hxvgGfpJLULvEA3A5yPXmZu8h7VkEMX8wAwpGWEcAEQLvz
1029	B62qjeQmtThR9HKw3z5oq58RHfCtdvyJb9chiA2R4NReipEu4nrbPHw
1030	B62qn71s63yywMUCcFhP4iCata7HpgyrvmGjpKa1D9544vGW6FBZ6a1
1031	B62qoRkPZeEekdcQWRYCrCTwcYicVyYRCiU22gggFYUTatWBNHt1Jk7
1032	B62qkaYsXdwZ14UoLMtrXAp2Up59uUFZyY4KpD7YbvXaMo3ByceyxD4
1033	B62qid58wzxcQARBwdYmAYc3dVLFirx5SRGLdHUqMkQb6hVsRpUzgiu
1034	B62qoGbqv395zDfi5Q9yPTxLgvfcLtFwJdmJ7nJ3tLKU2M7CjRY8kCa
1035	B62qne8eYsgx4dFc1pBe4efuwamHUuKz7p1Jywyyk5v854eowD2dEMY
1036	B62qjdPSYuVpB4uLp9V4Pw36GP4CgqKWeJExjzHAipL8KbrSa16uvNw
1037	B62qipFGtaHAJpvGSJdYdVxJw6Fg4SdRK6Ldu51o2rVUGJF4JzgMqna
1038	B62qo145pgATYorapx2boXn7AbhhwMTnWK27phLBkYwQJjjpCYXxNUP
1039	B62qnAwsnwgn8okBLuEr63egNYFyJqZAhWwpyccbTZfyxMJgyDGcVGx
1040	B62qniwr9y7XYbjy26rgu3UCFwHBzsnQocu5gnd6agwbZU7Gxtu7WJS
1041	B62qiZppGFZmWNLcGDrPp4wBBcEKCRhSzY7VC6U8XL97ybesV3GECLt
1042	B62qmQ68xVWawcdC3WAXCDiw7JevnocVfzdV5pq3gBiia5RydquLUcp
1043	B62qkxHjXkxWcdnep9neiFpa84Dywf5B9cUNrmrMEJ2hMmw6iUeFieD
1044	B62qrJHuDFWfuWStjyboPejGaP4HZqFRPQxsQtWaxhnV4iJBgfcH1cb
1045	B62qkBoe9qNqxTiXBe5euvRvZi8rCUq9TgHfM2BwmcED7ADJHFkDQJN
1046	B62qrdVeRr5u9kBomM18PQdGh89oTthxgsy8JTjSCFtyzGD8RWwUjme
1047	B62qjpzAChiHvZZqchLWcv9SAc52p23oCerTPPrZzFqksLTgwSBo8Ax
1048	B62qrxhjraNf6uXqLgWBFVAhsZqXAfpXAPm1ASZptnEhLZctRTzykzM
1049	B62qmuzvR64h6vEt87ijpikVsVeoYdnYGwM5NFSQY98j3CSKw2i8GiE
1050	B62qnpc2JJrKj5gash86vodGFsLVQawaLSiJwbUtPgLs8dcp7QyBzYr
1051	B62qmXrQB8jpxHZ2i576MsMCiLNorggtfz9b9zVSwSSo6bdaimLMVpK
1052	B62qqARg6wBwTwt1TQHkDuLqHHyYzPK9APb7vhEdxsUmCKaD7cQLHbp
1053	B62qpYVQWpALzvtXLhBLcftFbSLv2bhDJYwfctSG1DKjE4by2h3Z9Fo
1054	B62qnXfMmiMFkkpyiLejZgMuYYJuptdu2tyXKun1VPCS2xhFrwqvy2p
1055	B62qq4MsguV8i5recmWUuYFWXpPW1MWZBjjjwEuChaFRuTioP8VUctQ
1056	B62qmwgXnydnYAxhFLbyZ68zDQsF2yxDR92UUucBJY2i2Mr3U4Qw2KG
1057	B62qo92C9siz8nua4H3mopoLxbDVV6dsoavd4AoimHAqA3ojM9pfh37
1058	B62qrmk3L8KdNb96SqvohxCKZuhRVGRYYTMAgrKFhAD5T9terBwG63K
1059	B62qin1sCKU7TQbkZ6Z5ka2armpaxkJgrWSWgUmGWG2qWBTPyxtqtuL
1060	B62qp3Pd3QM7HXMYMdhWTjwTYbWZVZe5s3vKxdDvTV2YPSn4GBQ3M7E
1061	B62qr7ncXwHeBXyQP2dThpWNwySjkUDCNagFkRba5jn4LyB5cSUioXK
1062	B62qovenu34m8jqnnvxq13NTmpBHQbTodMAAErSXNzshZiTQZcCtjNs
1063	B62qiUXLM7UrRFZxSKg3pLGRZWnQzyhLa1jvbCrhWUtfDpUCwEdyJz6
1064	B62qkBU1d1gVffSCVvg1hsgFLwfG8WAkfrCQwoNbfLosBQMz7LFxF2E
1065	B62qkPod2ScW1RBFtwUJxA69eNDfE1qKRsj8wc9Q91WQZdoTHorfTfm
1066	B62qnRCUTA8azwS5yrsduiwY6q9M72ghdWeYR1G7hvmmoJk81XPiU7Z
1067	B62qmLLeHwVNq3ZYM7ETt6n53s1YHRv69WHzJ1NBMDGkCVcHbUThqFe
1068	B62qpurNfxgxGDDfhaX4VR8MTU8tEBwRtgWFYUiM7xiLm4Nqu4vHKbq
1069	B62qkTfWwHvCvcEEr8i7zNgUT7FivBjWmE5wQu7yzeQxm1AvPr63g2z
1070	B62qpNyjUGZyRXNpRKmVyPezie8AbVaTVfjHbFbUBYHYfQTynfd2mzq
1071	B62qnQAEgB5zxKCz3icKgpjJ5BZwsTRE51gED6sJgRzzuSxhkdKSMeN
1072	B62qp5Tbn8gW2FKSQkrqhVtGxhhrN5KQsCYC4rdASHjgUxn5vVezMCP
1073	B62qjkpzsDcW4w4V3SS9LFuzFiqpydVvJoJYixgAG8qpMDPpaRnTpHE
1074	B62qkhoEckV1fEZUJwD7ghe22ZGucu1v7jjMxqhCA2AwtTAQHLSFqVz
1075	B62qmDwvqT9xNNwee5gZovcj5E8Vox2STA23x7SYRsiC1g7dKo6UJvx
1076	B62qmg9tWG7RYemfvWtXjAVquUNGuJ2jgM1TkFokD92rB6yLSwLBDJD
1077	B62qqkvZbFoWwAhZiAJmrHGQWY7q6HAnhPhLMs9jeZkDKFRqGgXHrQc
1078	B62qmvq7k39ZHC3t9yBKXs3rkYBPAKXCWpvewjLJ64prmVqJWwDWKef
1079	B62qmfGmXEqtyxmQQUjZS4WGdc7gbB3aNsuo39g5S6mY6VVr3jwnz29
1080	B62qkoHmyjLDFzm8zcz21QWb3g5uagqUZBpssygbitYUMpd9S5sd66B
1081	B62qnBCL2nL6u38wLVqPWQ6VagvCBcaMAXRiBY237h1NJpubThKs4Tk
1082	B62qoWGif7FBbK8igStzUCukF5WMJZCqmFgdsKqHQSBsLdB8vWZrewf
1083	B62qp9ZP47Wxi4v6GCHqVpbAz5PeQ3kYhB3WXy4AJvGZ95gEeveUPw3
1084	B62qjeBcbRunMkcTmKTQ92nrMZUmoFKMccLBTUvnD43TL7e7Z2PMARR
1085	B62qnVUKhkfS6aXNaynq9X1xLgdBBF6RHET4byPsqWEenj1dK1P2LUg
1086	B62qigJASqWfLEfeWU7UPfSakDYrdyAgWHUuyX4kh2nsgLgBeRxpn1P
1087	B62qpH3jQdvyx6BWJTPUgZHf8WXFhEoJRSmAqTNh5XNtBRH1fjkf1gN
1088	B62qk5fAkq5XDDVGTcB741M2pJ9Wnq7srbmCadRWSkC9ne3Nubpgf5t
1089	B62qmQ8ncnhsQR4RqBMcFiwnUcmuRHC9kYJDZSiuJ13tN5aAVLUQX45
1090	B62qk5eE7w3Jqu6wGgXTcXt6ScVv3hCQ1kZZrWANwnbwttmZfYZLW4Y
1091	B62qnTQLp9uHwzmxKuyDa2UP3QHpPZD5KiVGPegB1ZLWEC1DWC4h6kB
1092	B62qmNZb837DtnkPEKo8Ph2CiA8yGCuG1Hab5Zen1AoEWqUjCVXDiRV
1093	B62qoX49KkvYNJt5VQd9rUAgWJuF9UqpbeVKwitzLDC5XdwnbYdHAi2
1094	B62qqy2yhUCw3NFqA5XjcamuUQYXADNU3FQzKbTthSGW8P4Cpnu49Gf
1095	B62qmxTFPg2u55SEbookmXU8niMu9B5vLrybVW2STdKUb5tj7TtvabW
1096	B62qphNw62QBjfwsoSRxeYb5sVyde16WdxkynC2V3pUR9yuMFoqHDUE
1097	B62qrZ5r827VT3if6vgo6UaHy7sfhRvVyRsqxyswrEZ9AwfiWpjy4Bq
1098	B62qmRapzi3nrctTihmaeH3CNbsDkpAAmf5osj9SvucNTU7jteFchhZ
1099	B62qkvch5mqkErUrN5AQpXS3MicaCdUhScBVjHqDfbsbP5i42okjcL4
1100	B62qkVHBqMkm6zmvBE5UHn4591dfFk8d2JLysx7bvmBUgwQt796878j
1101	B62qpWiEcSPE4cf1F7UaWPt4JJZvme3B13e5S39tKNgqu86pszn5scx
1102	B62qmFuBwy5JUZ9rfRFX9YDxEj9xAP8fszK88nYRwxs1zzfVG6hPXmf
1103	B62qp1MrxFnKMUEgAcWq2AJscVJTVzpSZHVJjgf6GGS2fcJTDU5LhVS
1104	B62qo5aeu9qezh2Z1qsKV47jHwgt8MvYLbKVWUSoi6iNaX165bAtmT9
1105	B62qqxHGzvYKYH3nCK9fdB8Qvc53rF6VTDRDz1sSAnNTJtP2G9G6F4U
1106	B62qpNBeLFvo8dad9LX1hp4aJa833b7C8RUnAP4EbQpQ9KhrY5roxWa
1107	B62qrP66ehjMUjSPV4ci8scX7qrLYguLDEmDhQxsq1TS9BvarupCd71
1108	B62qk64MQFspF9kcsU6QvmhCX6knqYRmUV8LGWKfNQWSf1R8snBPaSk
1109	B62qpsfgietkCzKKfqbjdUmWFPjJRTykEabpx5U5A6jWdESh2eDqBNs
1110	B62qmxDvkGqq9HzcPBWMxykMzNHEHuVyP3gWmNSy2CPT4hNQHzgpbxP
1111	B62qp5A9NfjDjtcqy4Ud4FKd9vEs41Q7WPdSAzu78NFK5o6vbhExkSm
1112	B62qoLLCQiB92VKj3bBpx6hUvat4bYh44cPNYWVPRqf8g67D7QPSRqz
1113	B62qpyJsdHDj9mftCE55BX8JAsXh2MJtrHkPusDoMC8fUcmo5EWLvY1
1114	B62qp9RWhUJt949SZKJNWq4tJpCEgEjFHD9H4JWLpxC6CkCgXQumCA1
1115	B62qr874z9GXC4SiHeiX9cikUa2NUf1ZnL8bvmQ3rdq35s3fRYWwLTc
1116	B62qpPFVqxDmJp27sLQzNB8MnkAcFTwA6QS7C46dMyVYcfq4oUyTY9n
1117	B62qkMBqD63AvYC9gcvJLPcdVbNAG4wwjHsqB5wpLiuzbSjXiL9qHwj
1118	B62qoJWcACRGWgcd7NBwnfY388ghN1dwoF6FXXLJtwsCQtgxUD3JXMJ
1119	B62qqdFzNt7f3h5GQZWmHZhRi85r1F5vbcikoFPB14KxsytuukfZ89g
1120	B62qjusyo8pPwH5Ho81j4CPEKkVLQGeQmcGsn2ZaEJLxJzV1EKsWYrk
1121	B62qraZF2Ep3WheJdmtfQ8DG6JURv8giNdDThFV7eNXL8smFxY2RNiL
1122	B62qraqoNtsxAVCpmVSZF3DVLzmM4uo63dvomBSogDHaGLJRqm7aC1D
1123	B62qqt8AE79NdNDBPSrRb8HzpPqC3hTgWRuRtcbT7nProHH3Gcv6tZa
1124	B62qq2iUH5cE9b7Gjbw8pDvuKpEzmqFiXxsDazHqiN2tw4cKoomvjBy
1125	B62qiaGV9Mtk8ZMGmph7WiYPzuZYp5qvbWj1Re479rvGeA672gmRbME
1126	B62qkkvP9xAwiCsh9SqK2nSEQxf6pFG5kkZ5K9Vr8wVzQR4uhynpSFw
1127	B62qoRg8wZPkeTL3bhMkay6Fj8fo1hJF6iZtanxrwE3LektzfLCtSqd
1128	B62qksjpcicN4YAXFsvojtARRNyDHuSJkYS1tVpspWfxPQg8sdGivnD
1129	B62qrey9e8ZsaaJv2KwHHowBhn2KvTcdjSiedqgD6nMQoh6C1F7K7Zz
1130	B62qk5QuT23z9F958QrRcKZ1ZWiXWmwj36uXDdoNGSiSxw1hNgn9R97
1131	B62qifWG83TzBDNSbqsDkmmYybQx3umZSTNeqQ47t6mQcpJhCHtU4af
1132	B62qkHVcy87zYztXYmRuPZ2asSMqhxkpAHwGfcCToB1R7DLHnPAvqrv
1133	B62qph6BZp2veywEtbtULgepSmDvnXz58mpj34gvBL1iQj5stHpavd8
1134	B62qpJdCFAoycomY7LRfNXZDHvULj6ug8bh1huFVGMGzX5jwjQ7JQ38
1135	B62qrXCnHQrSf3XnAnSb1DCUDka3dZVWB2XqH7Axr2vg2KaFXsX6G5R
1136	B62qrnLPoK3bsQvrCM5mFH5SkkaaGBhYabSKb7zUdvDY2F5nb46HtWS
1137	B62qmHpKBQ2FzUQijFi9UMRU2txrLb1GuQMr7vUCzLqnDJexwTdgKbV
1138	B62qpe15stHjxU2pvRDkM9hp6J1hWD4Cf1zmKGCtzsg9awuVK5GxcUR
1139	B62qpMzq4vHG8RbUpEVuGrYG8tJP4fPEbUwosGLpwLQsBFQ7d5WKdzc
1140	B62qmBKWg1Z8cCQoDGXCZSqVopP9yVRfYcSSdWBcydG3f61wYxZJPMB
1141	B62qnSdNzb8icjWPiSsxgKfB1RvD47wLf9aYfVRd3HYTk519fhG8RUK
1142	B62qjNiMHpfrTemjZe3BYDdLfeFP9GGtyv3dnef7Kqx5vmdZo44mbJC
1143	B62qndvr7iZsJeFdeYVGYXP6oJY64T5BHjPBTSrfdHrwkxuEYCfa1LF
1144	B62qovdiupo2b2UxNhASffHV4CKE5abZD4TmSdSJZzf623fkrgLvouR
1145	B62qoFmrHvDzz1H7qztEkvkaqNUbGUCaZJJJjXb8xMmxVotSaWDmyMw
1146	B62qnkYYpjAHWvWkYsy7ANo9omZSQ53bwhKgHXUk8g2XANkjEq4AfNS
1147	B62qjMbmoXjUXSjqiR3z9zn8uSF62kExrbQ1mQq51w2ztVbSgEZGUmH
1148	B62qkMiKSD9HWrAc3oFqYbup2vVXQFDSrSr76zjbr6yExZarEJk5jUc
1149	B62qidGPfiiweETgxgkTrWRY7yPTS7MV2zz8M7RdKhuj3sAJGFDikfH
1150	B62qqEV4oP7w2jLQGckvZzdWjfdLKySKHJ3tNU5niRjpPD7beYumWTB
1151	B62qpTThstAYrb77DYCDygGW7vi1vgQ7mWNskcVRZ6kT7yfmHSByzxt
1152	B62qnMQ4Jd5pzu1XhiCXQBTgLB1HixygpaNAgVXMj6DajQNsEnEJx5S
1153	B62qmCFjyTQ3m7GhCcdJTrdggMvdbxJTiMFrsFeZAdoyWQk9DsAjNQw
1154	B62qrVyhLi6qSyAs2wzdcRB5EMvZ51cn9WQyQtM2M3igu3QKsTwGJqd
1155	B62qrVoMR3KnkvRwWoPhdmKJgegUwBoEnaxSpCiMeeSZxZ2vWUpxFgL
1156	B62qnTX7QhTmAHvbSs7dXa2aQNepP9raeqTj9fVJd6DQb7SJCGsUf1p
1157	B62qmojeHVL8iTWyaXiFEAoN6rbTFCUpP8FoVSW91P3WHgESWepbodz
1158	B62qo7fTZ4RJBJZUeHEBCmNb5jdShrcLPZVs6YFAYvWQxb5VamMHMH2
1159	B62qkwKReBsmE38P1fbWopHTRXBspPRDLXFs7pJEKZKDDjsrYhZAjHd
1160	B62qnwztbd73arnJBo3Zjqw8adn5xvcc2nZX9rWbGRucd2a3rUop2M8
1161	B62qqxBaYdaYHmqEaUvdwGzjiZJsDqySke9FPDr5xBxk5xUHfTv7buM
1162	B62qobkdtpag6cZzbkPBCGMxawPjHcBB82ja854Cz8qS8rmy2GMVns3
1163	B62qjz4dmTHSvMHzDShvrBcq5pJERKvZFqmJj8jUGiSAvNiDeApnTHF
1164	B62qpnWSJDnXHLWU4tSnmsGPLpcJRd7iT1uMvfByy4Xa3D1GcEkzVRC
1165	B62qopfSgwEn28YdwZHh4khMy3KEG9dy8Jfrv7cveUJw2sHzSCnWoqA
1166	B62qrEcZfLWiRe3WuCxvmm7oBZSURzBKNyphXMdiEPEEViq8JjXWHNj
1167	B62qnPhXw9uumnKzcC42zigqB8KS4LXRUzSNKR5EfFc3gs5ZVHmYgTu
1168	B62qni7tpQrD2w6JoMSMKDTa9wXR6KkDMpCXDSh8h7ki1afVmkrnvno
1169	B62qpNpan4tw9yvUXvjN5ScB8Sm8T8Vwf4Vc9n7o6T67jvM2VMTynAN
1170	B62qjDRP6nNDtej55V9tdmWhMtyjXuTFAHHEH5L2MW2nQ417wP4a9Zq
1171	B62qj7rKdAf1JfwV7PkU9gvR7fjLjXuEomU41coasvPEyY6PajPmrLP
1172	B62qnkgx9qj5PGBxiU7e6uHqEbKpW2AncbHP76LbYFd38DQK2YagZ8V
1173	B62qj2xi5jHnwJGFVnB99PKJGHibvd9XgrrgyXh6aRg7HkXsJ5cZemS
1174	B62qrFq66RPg47pcfMTyLFdBYWXRJaSFBfHhW5Q5Q8kzvomnJ6v4da6
1175	B62qqQc9UycySBf3ivyEaFh3KzFvLFjfwnKQsVne6VwSdAp8nEjst8S
1176	B62qnzD7DZ5jci5vHrKCuJhmoHjwrM4pAhuAiKtQBD38h3SRKgixaV8
1177	B62qmQ2n3jXzMqq3rwuqKwJXWYBRZYZoWJP1RCJjJbwxMYBMRNyM2bQ
1178	B62qqbgxBFE8zptNynKQANv4XXahadNZFAFpATzAoQYFZ6UFaKdghk1
1179	B62qiYiBh33hw4cVuP1RW7RVgWwFkLC2Q4DRphdHkaigQSJdneCrUAs
1180	B62qnDCGgbS3RwyV1EqGrktyiirSKr1WPpGHz4kA7EXXNgmaK57QWrL
1181	B62qp1C4ed4d4T9Hjy8ZGtZBoy2a3mubM6Bxf9o45LiLfBN5pbTMu7P
1182	B62qpfLn6rojNNJdbg4CPpVbh2psKRUf63A2UHyy35PxYF5gBAbaLEN
1183	B62qnPXW32xnngFowoZJRQXZviac2QvecUzfTfWdZCwTZthRzURg4wM
1184	B62qpnwuE1EeQHNd3JtJ8HjuK5VLo7E71J9oj2V3UCh37bjC8xc1kKC
1185	B62qiZv8fWPqH9oCUruNLuJaranpRAXeYzBMpVfZWA8Ui4bvZiGtQdT
1186	B62qkrhver9hVfaAU8hDgCqqtk51h4km4LwzSpvfxSpDWPQqk6nhdo2
1187	B62qjS6saLcoHU49juMzdzYahEsVAu4kd1snPmCyJ5yrfu4zzVgixZC
1188	B62qnyMshbjyi4ZrnX8SMKSKeEq6zXMDgnsmfVsoHQvSi4mT9jfpGSu
1189	B62qqoKGQqxvrP3F8JQDubvLednJJs51oJSkHPnJRZPuwL9FT4oyN1x
1190	B62qp1RJRL7x249Z6sHCjKm1dbkpUWHRdiQbcDaz1nWUGa9rx48tYkR
1191	B62qpCFiMgogyN1XAkRiS9R19GBShquY9uv3WK5AhLGhrufvdM1BCvd
1192	B62qisTrSDcz6mEtrzgHN5KxPJU6pf4G1v9vb9PMHAmnoRTWWqrAAxh
1193	B62qnAbmwZzX5HHHWwCaFJRahmBs9BT6Kj79tvd482X9eBAr9M58PrX
1194	B62qmadAHfyiiraNwvXhWC7g5q9qT5bkjA4FU35kycMrhdrEJjguJnq
1195	B62qrcVPyssX2RkRPMoD9PiKW3g3yVdAPaL43UpoT6cvXmNqzdwvLzQ
1196	B62qmNSqURW1RVAaKKuNtVqyrT9DcBD7PUrXuUivfcYhNA94ZVmeSvx
1197	B62qmJMuRKGqHt9ggz1ms66QsgVJT4b5bzA64EPWxUAHhztmNhGsnLD
1198	B62qnTWW4LjADBLy1wZZALkzHrMMGHPLu7qbGNgFpXyxUpRNHTc2Zm1
1199	B62qnz8HG7Z4VxQFhL1XakcCdAmz8CH2bx6YQJz13kcQrDV3W5qag52
1200	B62qnNWzsD8REZADYAEPZrgGaTdGnSBaNDi2HyrjcQSoGfRbBDWhWk1
1201	B62qnSrLh5JauAapgnfjqrB26Vh1BQmddaWpv1vXHkCjRTZFh6p8Qpe
1202	B62qpYqGMW6LJTduabsY8TRVbkmkh1vCNdVuyx58vvTnvJHYSjXV8Ci
1203	B62qpix6rNZVY7qhMDnVmMjCGuA55TGmco7TFuEPuMWrxruhWgu25HZ
1204	B62qrenUVqQeRTNmeDAmwJcvZVFfi12m3nt12PkHce1vgm6MMfoVPuH
1205	B62qp4fLmc3ZAZxUEp1PFkiepktWS6M2UcKrLqhUmLr96BBfPK7DUdo
1206	B62qrSbdso96pKAHdpMTTe1AC4QDGUYvW87vaEPdyAjWLdhryZivTvv
1207	B62qpKBNFBCXaFYFyGNq6PcRJFnkeqt1pBTDv5es1JWy6EFqpDDRWfB
1208	B62qj92oA1YvmddEq3MTSQSMPumQ3PDwhSaUQJQsib6ZFaGpWhwHsKG
1209	B62qjojdRSc4L9z1EpqiHAXgktyzSpL5QTUdJXLHQ4Uaj5hDpScbsMC
1210	B62qpAZLBaYoBqyQ8fqBc1JZgHp1KgAzDPiYeQv9gPpfPFw3hzPdZ24
1211	B62qjNrEEk2fR2T7TjtnFKpQYmZPU9uCNY3Cf5dfcKf2HjzsvPe51k7
1212	B62qoXrSMa8oXoXX1K5rYJuzYNXwQ7wksCgDRya1J57HfcxUdTMb35F
1213	B62qiw6FVYgc41gJJmh7w8CTQH8vd94uVR7L9j88xNrhGvZJ5vS74og
1214	B62qqBvBTSsG368YAxxiHui5KKSd1NYkGjXnCzK6Ud9Spnyp9zoWw7t
1215	B62qrs3r78SahLdnu5RpxNVMY5ZYhkMwmjcsyrXrWbAMMSHjC5U9Eo3
1216	B62qqpnUBrffgQR5YCNUM3L87jLCMJ98oxJxvwkWcBM2efdxjjGgca9
1217	B62qnbYZLVFnvcJQhTUT7moJGfRqKXG2Tu2Ve7jTwZ67xBa56g5pbPe
1218	B62qm2FvPP1X44GPT9cpZSRtmHkNRGWYFapWzeoj4u4XHSm5pNa3iFi
1219	B62qmwy5M5fyZ7BQmu3sh34gzP7nAoQrhqjaQnXd8aRqHHAXk7JQUga
1220	B62qnjNWCVvmLezFUdj3aRCxKp8HNbfbXtU96cWcvNkDTkG1ownsgcZ
1221	B62qnQwyE46zHA8FYGVkuyoDJa1S5sLprfGyNUei2RHs9YU6m954p3U
1222	B62qoZh57V4rNQ3FRv6tD1pc1MKQDmVGwk6R1qnKWNV8H7sygCVC7Gx
1223	B62qnQCf7ccbb8f39jDzKT8kRNq2939EpPaFGpaQ4agUuy5ozytU79a
1224	B62qq2vc7VoZ9vGxze3JfekNZqfJuE4Pc152EsiLYf7xvYBQo57rFJN
1225	B62qiYNLfwY6qLvuKLEAknPH26uTujWagSnDfGVfzsDfk39dmnRRW3D
1226	B62qrnd2kXPYFuVaBEQPApirUvDAGfdswR28XsXK9P5qvAkGkRbxBbV
1227	B62qpUDNRQosRHsfJBsH5MLRkbJ8kRbPUHKQBj8Wu6Z8VUeSRKJT25j
1228	B62qie4xN5VuLntjGz9Fk518D3ExeeDtvhbJcJsSBfTMQZY7sGMDRKr
1229	B62qpdXgX5zgSthWWNGHieRp9oP5R18GS52mfFsCz83tUrb6YgMVQ9B
1230	B62qiTY8rERRoGZwfVDxxRSyFBJCNht61Ct3HpTzfm5754gfPqE5pxx
1231	B62qmdFb6jKiHqzf7h9B2FQsdtdqvJJ8uiWV47YKgJQ6bTAhNWUgGm6
1232	B62qorY2JaxNFKJDSCUUipRSAA9Jha7rw8RzNxj9zRPHsChF8osV1kg
1233	B62qqCh5YcsZgofmiUdHL7GH6SSgKq3xFFafu8B43vE4kBo1ni8qset
1234	B62qoakPjhxKKgXAJ8TPULPP8rQWQFjAcBotfot6Dy89rzsCKUfme95
1235	B62qpVvFhkeTtSSAY7xjWAx4EjQXZsttbNCSdrbPsf9gcuD1JqbRiew
1236	B62qmAAFyvjEEdogSJAU5kxnp4ckdfL8ymcBmg7S8KmtVAaMMXbWGbi
1237	B62qkjmv4ZLSL1nDp3EhHqTvsey8qk8UVb6pjERkhSA1JtrRihqw5nF
1238	B62qppXNdhrxsDKu6bLguRAzrAWaEUYzPZeFrbXAwtGuz3Jb4sHMXMz
1239	B62qkam5V7xGsozwyR3EJoHQzGF9oMrWVryPsyzkYYfeDbg5kEWdpQC
1240	B62qrrLTwkCgPNmVqiAnjjkwfu2CxzQh8dgxH8Xp2TdwjpdsFQqX1i5
1241	B62qjTastRs5hDSMrFvic4sTxKdiQ9Dr72MSg1DnSVpZitcyGg1uVcK
1242	B62qj9YhQjWNN38P4AYCxABa7bYziNA8xoLQVDoSM5ouNhfksQSZrTV
1243	B62qiyrmLzu2Ad316mrmG1zw3wTfAQ2ZaTxA2JTb27kAQHmP1hjvAQW
1244	B62qnXpiGdQQ6athywiijFWVesiFZdPw57Wbty4CfFPhr96NLooSKSK
1245	B62qrKpENNvYAz1CJZbkBTkJGN1WGnbYPRgLN1aPXUPSEcHVfzrEJYK
1246	B62qn1svyav77n4ZvEc5uo1oHBaVVXbcV4vML6pgML2mnSi1VCQQN7f
1247	B62qnZ8ngDoptzYHQSoEMYjefhcnmSPBdEEnAzeztndLELwQQmjKrUK
1248	B62qqntBBqvFYWPJibxQcY8GQ8d5HKvshegCyyioaLcHAAkNT3DeXvC
1249	B62qmLunRmJHYE1N7B1xACrwoYcazR19uFSGLij2xGUqfyEhTQno1ax
1250	B62qm9rEzibmu1XJTn2CceCJhSzzT3nK6FGHkyEhuNUsRkJsCgYnqaz
1251	B62qpPQiXis4sTGj1vHqtwJvRhVWXLZtDBem8bXJBFGUr9nS3CV12Bd
1252	B62qkaxz722NcaLjv5VRihiEQrLGbn7CJMdZe2AKut5mLx1UKRhdMEW
1253	B62qmPGYt6QM5SNTmTfFM4JtQXhdEnMpo9joAe9vsEV1ipSU2t4BP9H
1254	B62qkDDA62kx6nVUJyGh9nuz86wmYHASu71dnrmeBMd99EowgJ9ZRFK
1255	B62qs2A9uHKFAA1AQPv113dReKHduJfQ3Pg3WDyUMYQmgk6pYBYGTfS
1256	B62qqLmbqTN7FkEs8dP2K7gX5pDUHJcwfEeEDdfziXowCrnyqpYEhwM
1257	B62qqvoG1UMgx2rvwBwFX5bGQmt4zLhcfBLB54Gf6YMbhDi2XzzqfMo
1258	B62qryctc7Uq5cq3S3HQfLM98tPzBVU52eF2PpxEYyEoHxDtoBGSs3Y
1259	B62qprdWQZJDnhBmWeSE8TNqSZYV9oYRR6YKwvabSDPJuZGD62gmu32
1260	B62qoGGexxYTFQ2A1BurUMJQAEF1ZbzxtJ84iVCooRTn8Hd4q48MPcP
1261	B62qjxgReuj5FKdrMw3i7d9A4yjwTvu8mr9roy9f6AUAt1orHEArLhC
1262	B62qnGgJ1AmXjzdSWH2327MFSAWKPuB76L7yk5cRqNS3WC5BdiiyLuH
1263	B62qpn33ywugMMhgCfMz13JHotUtq1XJme426v1Ud7DatcRrKXQgGdp
1264	B62qoGveNQGfVkAjvZyjAdQTddvdKVFuS49dndZMzBZLG84jYuLBV7s
1265	B62qp4sJA9R2E7pqCKf4LaC2UrWVrKXAWcdiNZwofZh3XqFFZs3MVFe
1266	B62qkPLhMSTJ3GXa6urmWQZf4pr3387k8cUsLdhDqtcPRiiLZbV8uCs
1267	B62qre4CXp2S1DDnzPdULW8Z8qbLyyNvYYm6jKmKHQmFRDf8rAtm11X
1268	B62qmFMKE2uti9wcEfR5nNAr49x6QeeV2nhZwHAYsFXr53GDqT6faNo
1269	B62qrmRJosdwWKwFXjfLEA7fNaPDkAiSkGmGDLiPQkphCcnC7agyYEZ
1270	B62qjWT9QQ9LGZoLqLoAXjefPKmLFXd9hQgEt4wUrR1Xmqy5oJns7ts
1271	B62qpziYULs5tfkWNdkHcDXd4UL4WCSXwfuDh3pwMFHzmMoGXwUfpbb
1272	B62qri1DwUjHPGLc6XHR6VS7TZE34A91RYQHkH8KocpjJUMRRc8MUhW
1273	B62qpXyX1z8kE8pvJgfDoSsY7r8yimEqWzvvSEw9putVG4TjFrdATZT
1274	B62qmEcfvLuJYd625PHZUov3RiMEt7Mayed7ywkXoByCANpGPWVnCLF
1275	B62qnJfcBL26QpmiTeMx5p2m2zzyJi6CfBnqLbsBRfxqE9zxZFR3sB5
1276	B62qmsYXFNNE565yv7bEMPsPnpRCsMErf7J2v5jMnuKQ1jgwZS8BzXS
1277	B62qkpvmmCAXozUrhGaEXm5GMVtsGb3jaBPjTtVEcNThz3QjxZFqneo
1278	B62qk87jq51vzPGrwafSpPczAYGZJii46PQx362AbqYcDAtG33DJVgS
1279	B62qknFbTU4AAg5htLM8Jm3UmodeZmNQUD18Gh5ZPCpN6w41xhPt1PR
1280	B62qm2wh99cMx3U94SnNKPCo6yPnZM49A2J6ad9i3HX2o5TucVZJEGq
1281	B62qiWMgGFfnWnNS2XvCJhxmaLHvWnHBXr4EK3MopXKzutq4Uu34QXB
1282	B62qkNm8jmhLKWhP5Qr5LL1RtzRz54rhZjdLxCX1nxcgzs6EB21jrdV
1283	B62qmDJvagQNBeQnr4D23Wa68tZJG2qniicGNTEaNuv9tm1ghxJpUYa
1284	B62qkSXoeyA5TxWqb8CFyrBf2yYDwRssGYxpuYzUJSL3ttDgpxDobLs
1285	B62qq9vZuW32TxPcWysNkYdDgFFfoLoNBFhdNsHU8ZzgLToYAbFFYxs
1286	B62qox5t2dmZD2DbUfHLZqgCepqLAryyCqKx58WJHGhGEkgcnm9eFti
1287	B62qp2ZguTDrd4zqZQLCS5ZShQQNgWwAGBn3kbcgjLX9mqtP37aTpGm
1288	B62qr1H1V6usV2pVMP7L5sUzFxFyAfNnXWzGVmwZj2puLdNW68fwEES
1289	B62qmUcnbr7qd6UDdVnZutKPFagDQDyEB7NTbEFJTV2GZvWquyMgoQq
1290	B62qkw8jyHCeBhWDpGXVw9yKpm9BxBSWWqVBWyh4XTHoea8kayfKhzp
1291	B62qiap2uo2Kt8RzoupS8jqCvAKiUZZmiXZUJM9gpmc1zq8KdFtKnYb
1292	B62qnPcQT5LEny2S7LoHpPxQvKfo3Ua15PkQ4tUP3CSteXZ5yiqaP37
1293	B62qqYKsXdpf96KhFvJpeHwDCNE5iUZqcPtxca3WxL5HZQ2HyTj2g6K
1294	B62qqttd6WJbThh7wFrQThWt4PCNKWnAyrXz2Mek6hwz2aT2k74NzDE
1295	B62qr4TM91FYFCk4XqLsgaHrmaNrc5FojZhWbssRsmkGT5zycZhhyUY
1296	B62qpaGDCfgmrUhDGQcdzRGCtCcUukU8bptsDp96fdovy68HnXeg2dw
1297	B62qoBFvWZADREXjtmGvDyyeginMBNv9W68wFZkwD5pfbphjyfo7MMP
1298	B62qkVsDvq1wNSwwi5ic3UN9zxUekQizbXCccoCxxTAJUWJFDCPdN63
1299	B62qjGWAiMSeL4HqeWozmHuVKjhP5ky2iWKv934SeG53jTESBJgg4nb
1300	B62qjtd2hibm2T4oi8yqVtZVt9LZi4KvH1CQX8eArTmJumjpZVogMJ6
1301	B62qpaoBemteDmFY1Usjj1PQUnerArwa2bdpqMednXbuD4aHT1ryHCe
1302	B62qpG8jpefptAeT9en6WoPzaW312rMJLwoL8pRmqcS8FCKiixRjofg
1303	B62qo8J84nSRhYcZshZGDtewgb7R1PyLz9J28PFm8B9ovfh7vu1fE7N
1304	B62qku2Fq2gbLmFPi1JxWxEb5QvX4Qy5bwxuiSG2BoTRgz8MQKEpAUt
1305	B62qmSy1QA6Qbg6Pi9KwudDLFduUGt9dEFkMVuqJwzcherG2fosok6Y
1306	B62qo3N2wRdhBsCqgGYJ83Pbhei9cEvMGrUL9zr6NNbbMq6wiu2jHma
1307	B62qnwLbBcpuP1xFPa9rZte2mYAKLijUtxnhBqNh3fxDifKQj3T3JYD
1308	B62qqMrZUfkMKB8d3i3Wiu8CJzTaFFk84um32QfwuEG6odySYy8D74B
1309	B62qpYri5rQK1u5sjVSh9kNbDRr1AbHNsEQTGd1bEg44UJKByLCPnuX
1310	B62qpXM7C7RW2PsdJz8EEYbGqTXhPvVW9RQQ11Ctc7wY8DbhAjyJJGT
1311	B62qkH5oH847YezFUPiPNq7LbMaNDpZ5SBp7Wp3maPU8DaejgCG9V88
1312	B62qmKY7C4nK2rnjQJcxMFJH9fpPkuAZxUL8opGzqKPrZnrnaH14hd7
1313	B62qpB8GXzKSK4ASmHkpMS8UpvyRB3FbMo8Mjhpzs6SPXaEtGnv5Qti
1314	B62qmq98UH2tX9NiDw2AZP5aGiwKfxLnVTkRcozgbRZ3opPSPkuXvqE
1315	B62qp3kfaMpfr2TB1UizLUBv54BELBovJJWjXjVMfFiJfY7AuEZm6yV
1316	B62qjk4cMyZCGhftrDZh1tQK9w7c86bQ8m7hRULumwhpC95Tz4HaaiY
1317	B62qkV6HMEh7SYKuLzdpCpx9syw9VDVNGR5SBWVTbQJV9bwWZ96iP8u
1318	B62qipscEVdb7J3U8ig46wgxc5jVtaqnHrCQLnnvkthYLFiw4MPvQxY
1319	B62qobGqxagMKDMP2UiKCHWj2dZovDyBtdDiYYiYGSg6TQ8Rxw5fXBj
1320	B62qiv5rWc3VMyMUP8yc1BN7KZFT3MH6TUrRVMHUZkwveYTiK3YnxfJ
1321	B62qmurvwu5wPC4X29DGAnTTys7CXpca3qTkJKw3qh2F2PmdCFkVcQ5
1322	B62qnEjHVb5sFE8Uh8TXs3z7vjdsFr5B63in8kkBkCp5uA27qtiiYCf
1323	B62qkR9hUHJVXxitqdVAF6bgefB2iCAXqMsudA75mSr4VMY6JSEGLJe
1324	B62qjzN25D39t1RRCZe48NuhcmHXGg3t3ZSDUm1K7tZ9cBvkdULmhRv
1325	B62qjq7vHyZM1YdZsQo9C3oW2QfdP1494iYD2Hs3uB5DSqGbk68vgCc
1326	B62qrxHA9WaYLMCMmq89Knh6kbm1uDX99zD2U6DvVAH3JEXYqy6eQuQ
1327	B62qqFY2G32WGjvu4hDDHFzXgJbdvCbQQmFjraPnch4uMW6eFX7qvLe
1328	B62qq99djC5HtNVdiBFZ3UN9a1Tn6THZJUcckEtAJon7jJzQMKDU61G
1329	B62qjKzYp37w9XyFea8TA87bGNK1yXRsrZxNJqir2WTorTHMD9Jkh46
1330	B62qrjUz973gGZEpJwqQJ6MiwWscqx8k7fwiezoEdU7VBnGQ9M23QPU
1331	B62qqWHppuoryyeeigDZu8tU3xbse2sut7o7ar2vh2X6XUnfaDn6yph
1332	B62qiiuXuFzqpRaywDot8irDtZcWK1PY7wBsxHn8jPzqHGMCz6C7M2J
1333	B62qqSHhnQr8mnbZmMnwgPfQT4PZTH9xupA5a6uRKt1Zdf8nRx2U5kF
1334	B62qmQ8943HETz4i2PFsc9EYyNAVrtFYJPAR6QMjCk9hT3DPgQmNgJ7
1335	B62qqLFzJe6GjhBzVmpm4VHvFWwFk4n4F5Ci3h4DHVQgfJvkWoe9sYv
1336	B62qnL1ks6vwcqdaAUSXrgGEy22kZDoKZRFs2NhkT7SuKMzevnCZUVG
1337	B62qjpFbzR6FX2YJzsUcimJCTjMsozchBAyrDgBGUZnmEwCAj5zciYn
1338	B62qq8aDzB7JSJvK4fKAKZpMfeNBkVVdgLW256cFDEWxws2gdCap6Vt
1339	B62qjfpVTExVXjaCDEkK5un2qUWxE7QhD1SiYzMW6SED28WDfXsoDi8
1340	B62qpxwBDbjGQtQHdjBX6SkdM4BvcoS6F1U6hrRa81M4acLoNPMkjYT
1341	B62qo6JMHe2uf5Cf8vQeLRFdufJYxNq3XHW7rRuTVriKNTpWpEkbpok
1342	B62qkcf3fkdzyw4D7GoMVwcEbYyoV2xd32iYfcK8iLWs1o9UD9oHyQ1
1343	B62qpFfHEARyRrdFLowd7GSkw2KTnZBZS8zWkpFMDxAy7X6Y86VGU4a
1344	B62qpoonGkkt3p5B7YqiuaVD4tr1LSoktxLxQd5UmWrPv6qbZ2JvQgv
1345	B62qjduxMjec8JnUk2P5sjLWtxuabDPFvyrbgwvNZ6Vg2T61ZB6sa5g
1346	B62qpxNPYzKkCiXKN7UNTx5MG1Vaf69YMFBmzFCU8r6YwVpbLrqBp3V
1347	B62qjGio44RPhEjYx1btYmPhAnXjromtx3NgTdAchx9BuaVyT4tQieJ
1348	B62qrQwEGGVZszUG5taKCYxdM1yf9sQLiSzNtur3u5hJ53osezWP7V9
1349	B62qkHHBnLpwcg1u4jgajoUUoSXHxMFEfZ9ji3JRbzftY6gTmuYZAxH
1350	B62qnhrUFMCj5n5yiPuXcQYqKh9d22ZWMW9LNxGdF1FkhqAT3B8KmgQ
1351	B62qojV8copSeupvVFup3Etn5cHWkTghYkSDjYzrge2oXQNc1y69jj1
1352	B62qo9nA6D6qXLYC8NP6YonkfaaFHufaa19MJvCNL5vEikJ89WtQ2ZR
1353	B62qjkhkXBPRuQ8eLEvoXzEHegQm7LoRSF1CksjYKU8Vgnzq5qZh2S7
1354	B62qpZ5o59hbZ7oMhTSiNBj1cz4J5SsuHa6hbsgtXsbudFiDsAVrbzz
1355	B62qrtz4HcUf5M1DY1CPyGcRsKmrusriSKEzZtVXJGKCtWPX9AmsMxw
1356	B62qniRCXGwymuWvRKe2WBWNVrx9ht8eZrQNCzGdtW4N7Fqj6iUfNqJ
1357	B62qkRewwZc4NgtjBS4HwQTfLt7t4cSCaBhZ3Y8TQAgHhpWZpKuYxA3
1358	B62qmbZejY2rjWcX4nnk1Nsatx1JnTybwTPTzCBNXkgewtm9VVZR6DD
1359	B62qimSXq2Jp9Fx8HGg3nStk5UCAQNKhpbB8M8QR787RRmpHKGqgZ3P
1360	B62qj6WR4x3YBiqq6mXwxEtg4EWYJ2ELzvWe9bZuuQ1m6sCpjNv68rH
1361	B62qnyqqC5NCsFMRRYyKkhwqpxcmCLUSmpsM9vGQhFRU55Dosnt4ryH
1362	B62qrYQpG9xQxD78Jd9BJfNRYx9xmrcZSnCgY4gC5aRr84hQo725NCJ
1363	B62qmKJxgh6h4i56hTXmkDL2Xpesm94NNm2Ev4ySSA4rCE2Z3JbfZhc
1364	B62qnYqMnurSMbTWdD2BkeQLudy1RMm3eRc7DeBuG8QykyJ8gZ8Gdv4
1365	B62qo5AuWQrpYPUckr6snpnUm2TJxPjMN1wBcJznJH1dzYmhbHsbj9A
1366	B62qkVvzN5z28sYfyr5TzrMhH9qTsnNQLttjpJjzSTswNUZgrWkjbZR
1367	B62qohPAx6tKFDmVTLGepyruaJNjwA2k1mfnhBbQ8Tu6BeH6Rts99jn
1368	B62qiUXwV5V9ptLxcEerkYr3kY9EGmhJZUb1h3ro45BGgForJSSmknZ
1369	B62qodkoaX7oEbwfeCYfC7MrWCLgD6w5f1HXcWa51RZNk1Sf68w3x8i
1370	B62qpDQHkdbMPvWzHgUcrxtJXNsuEg7tpCL9irDMNZngAJJR6Vsnv9T
1371	B62qoNcRg1LV4JqCJ64NWLwPsThRg7GJJQgvBiPAWuMnLDCUXigXV6d
1372	B62qjrMUVbWBQSPL8BgiJe7QQJ6RvtBSckxeBGt4C1YpHdHcTGjEgj1
1373	B62qpsKUHUnJfmEBWiAQLevw9dec5fy11oeoDYvRVrRjrJkjovrVDWy
1374	B62qimoHcDpJQk7onuWv9kco61Uyg2qTridyS3XMsp6DMKAxRq9uLa4
1375	B62qnQ1RWPv6Zu8W1XUSP5tKuxAQPaHaZY4MdTRt6KGZzgvEquz7yxK
1376	B62qrd6hgek7MF3qEb9AbZp9Cjmsd58xSCB1J2but4F1vmsgeQ25N2e
1377	B62qjc2RhgiL8WQomzjsWkwKstX78Fvkwp8q4HLgRvM2tVvxc7nxLvj
1378	B62qkYD9MA3T64UQ3aibcuZyWYh9M5AvWScjhTjxZ5viuY5N6wrG4Cj
1379	B62qig8xJD2GVHzJM1ChEXXMUNYwoUz62TY4CPTv8sf6MCDqgz5Wt9s
1380	B62qpTmo9FwpqAdRGJgQY1kuoSahVc6HwPyPQy9BRYmZL7G2HepTAt1
1381	B62qq2sBv1DpDtFueYmcxw4QP6i7ykKJ8eMQvHHMLxM2D9nh49bxLok
1382	B62qrnhMZtiz2P5AFEjyS8XTn5mQfJLFRQ9NkZTJhDZTAi9ERDDHv9S
1383	B62qmZFJN86FaPewT225BQUytfvncvJ8kwbF4zjbQHvXoa6o5YeSykt
1384	B62qqL6fuqFgufJJ6xU6waiJw1xEQugPsBJR6zhVHLtZ9Hp7R3BriTF
1385	B62qmT7Kd5rSF4kW48L9xnoXTUwW35VhsCS4wKitBHMRCmvywYE7iy4
1386	B62qqqbrKMm1aF2pgeg4YcnCuYTahsR4eMhfbL74fZmo1f27Bhi64hL
1387	B62qk9RQQsLpE1i1CJjkN6SuoRefXg5X17kqvvZV2UMysW4hr9CCoFw
1388	B62qqUPRmvN4SdX2XAa9z1amQJjC5apzwtmwweqVWFxKFHLTf9b4HVW
1389	B62qrFTdexNZeedkMCGSEUDtc14atEyevSj6Bzix1UUacaXmiKLsggw
1390	B62qpFjUdtZSGzXa6pYJuSv1R5vxJPorZLPgui8Gfg4YPrYEeL5pyz3
1391	B62qiydA5hjPMZ8wm7WkmZvcJWGio1A3X91Cu7PDP6WqqipQXEZu1gH
1392	B62qqNHRcLYT3HvUHyQ972BeaZi9Nm4GCRWj4uUbB9iAHhc7ZXiBmFC
1393	B62qpbZkvpHZ1a5nsTbANuRtrdw4YraTyA4nvJDm6HpP1YMC9QStxX3
1394	B62qrusueb8gq1RbZWyZG9EN1eCKjbByTQ39fgiGigkvg7nJR3VdGwX
1395	B62qq8sm8HemutQiT6VuDKNWKLAi1Tvz1jrnttVajpL8zdaXMq6M9gu
1396	B62qopHVr6nGCsQgrvsBsoxDm1E5CEdMkDSN3jneRnxKpR5iiXnTbas
1397	B62qre3erTHfzQckNuibViWQGyyKwZseztqrjPZBv6SQF384Rg6ESAy
1398	B62qoiM41U5gBnjujQRgeewfkK9VmgVT8ifrRRwAsqBUM6pdxi9ywk2
1399	B62qkJJpeGWtxZtJQFXSrM3h8TXMfNNNuG8g5mLaqU22HfWQBNENe8Q
1400	B62qmM3q3Lzur1LyRy9zaw5C2KWQGqpv5epRHFz4t9C9ZNJGZEhAY6D
1401	B62qp8Vq6n4VHq1LUm9Wd5QKjpKb7umoZ2oU9gpJYuHNUc7t2HGhGUA
1402	B62qmFf6UZn2sg3j8bYLGmMinzS2FHX6hDM71nFxAfMhvh4hnGBtkBD
1403	B62qjCuPisQjLW7YkB22BR9KieSmUZTyApftqxsAuB3U21r3vj1YnaG
1404	B62qjYbjZC7DBP78LheCLjD8WRWxku6YzqarNVK2er6t8SQfXyk1ybc
1405	B62qrecVjpoZ4Re3a5arN6gXZ6orhmj1enUtA887XdG5mtZfdUbBUh4
1406	B62qqhURJQo3CvWC3WFo9LhUhtcaJWLBcJsaA3DXaU2GH5KgXujZiwB
1407	B62qrxNgwAdhGYZv1BXQRt2HgopUceFyrtXZMikwsuaHu5FigRJjhwY
1408	B62qndKKWw8NwfxbiQBu9u2hrDr2bRZtULC9zNs9R7SC9k47yGZQZ2d
1409	B62qqvSxj9WncbMkekiXKZscTkJFdLdEDJm2xQGQapDhmDJBXBBGBcc
1410	B62qrg5t4eAupYCF8d3TzVn3rooxCWF7bWySVmnyytjGTPT8ttLMAxH
1411	B62qnxC2WR7YbTg2sDpYudYTyPPJKHDy4PTNEF1DKHJ2Pw6E9YhKciR
1412	B62qpTdEzGyefcZduxfHQxLpvBUqVbxMGDjJA32nRN26UquTxPostRp
1413	B62qruGXezzHqV49J5e3qWfcpcugpP2x4Zi3cGQdCe6txLnLubJTaM3
1414	B62qrgdEGEKerCmJsAdPC8WyfLP9p5JtCboQmv8b6p2xQ2hRZYgFwQ5
1415	B62qijk9NLY7cqcCBA383RqqB52kPF5C7eeZp2NoFmJHZkndD9SRwSV
1416	B62qqXAGfDrLyEfz11N3DrFdHojimo2Hy3g9uUcSsPe7VCJscaJrS85
1417	B62qmFGqsBsaqfYGshobBGeGGYGgB2SjcoxVZZnLRQJdUPZdMvGaYRe
1418	B62qrV1D1bezpJjYrQkWc1QvmWwyATtmuhT5AEeKL9heLztnLbM4GFi
1419	B62qs2Lw5WZNSjd8eHBUZXFYyRjV8oKtrZMFDn1S1Ye62G71xCQJMYM
1420	B62qr9jmNyuKG9Zhi1jENgPuswFRRDrkin3tP6D76qx8HNpjke5aUMs
1421	B62qpZTtpZL7QobzPX97h1f2CNFchXoXc4NJUZL1xdvNqTdwR5NCbkZ
1422	B62qjBpH4zeWgy4d4p59qUXDA3DtYeCyBrRM286sdXZFw4A8SiswfBh
1423	B62qqch9XkiTS8BLUDSM1sayfXNAtnYnQFChktYG1bfCJkDMUqs98Xr
1424	B62qj1B9sNZf8cm44qk8v7LRAYyUVVPeqrMF5ETmdQ5grZ8NM9ingCx
1425	B62qjXTW7dMAWwRTnJD4U8HwN4ii5t17UnGANbhtzenJTBWSDESbQEw
1426	B62qq6FzjoX7GCqDY9aUP7eFm9QdqHpFJ8Aa5xB1YLj9GuPtsvG6Mp8
1427	B62qqc3eKfNYpdRByoN4V3BTjoPRgacLrqtx4WkBQgnVcQ1MHSWTyWL
1428	B62qne38nSn1gwHkAn9vPN5SZntgXg3cM5pfuad1zQxFRuvAQmKkGTi
1429	B62qpwXadr3bwPsV5M7NSTZUGRaED3FPy4Ju517PqTZWWfjS8h2dy9K
1430	B62qrvWNDUE6HraKjMNFDEZ8eYYaiTCF75CVNUXMsL7DTs4DYjfsmEe
1431	B62qqzq7hnj6Bm3pG5PG7ugGrTKaNCa3XBuU6yDV1XmqBffpyb8s64i
1432	B62qngGSkaZCutEntH6Qu7V2g7waodEDfjars9VRf591oAxvpUW9Mzd
1433	B62qnU9faP18C3nQVwGNxreapkp65v11j6JHQVMgZWtEMJcQW4x1HsR
1434	B62qiZi62RK552P54BGEb7saNF5mSVRCFcxULPvGVi64KudP1s7TSm6
1435	B62qooTeMvVnDWWMQW7wdDmpEm9ZRpre4fTYwr5JZE1yN7sBLERbMyY
1436	B62qnGLiPNy2WEC2QRxJq4neyPKScUnQNEV4pRaMgYkgf8PcCKb55y7
1437	B62qrRVMpryecmWaStfobX2dxRLuWxsbd54jfjZm9DAdBycDic8Ef3h
1438	B62qjceYTwKGRigmhy9A1sPZYsvgAxSYmVfkgqC1jUkbpLCsoGWHeXX
1439	B62qp7J9DJWb4y9BsXiixdRQLGvouFmrpyiv1fmF2vPSV1tXhWuTiyD
1440	B62qjBsp2zWgyrbaSqVMcduz7A5s1sT63epFUVGFRjCfjCzy3zwSVaq
1441	B62qpaqLZv6tca6KytUsgkBoQxCRc7cMRVkVYCWjyUFGegS9cwD676v
1442	B62qn8JN3sLVja6GLETxWdnma3hXuUP2WfUARkcLfs8jWqW4FbuGuCU
1443	B62qpsMTL1mTaQUQUTQzVM1qvyGTCLVAhr8whJc7tUfmnPEuZnanzUe
1444	B62qiWcbScnq9W9bhk4oLi53fyH5TL8WxzDG5cqMhbz4SUhz66v7izL
1445	B62qpPqw2hzqjtcqpEwvckfsAENgXUxgJGu8y3Z6Fzus7pRH6UaLLp7
1446	B62qoNBu1CV2UFJTvT7gfG5r7c4C5pAuLCw8yf5CSKs3qkswSQa6JFn
1447	B62qj3Gzxgb4G4M8CwZRXZPtmVwGJtGfVXVbpMrACNDSqQLoXzSQ9HW
1448	B62qny4snW5cBovDvVFLSipUMaDiu7xwYMrfbTscDLDne7enKJyGkbh
1449	B62qjWchpjVwmbEazciy3VSBZhJNVF28RcDQirLFpH2rvfmDrtXL382
1450	B62qqTGc21K1mJo9adVuKwRddiUD5cQxocu2BxaahQGfrQzvWBc7UYv
1451	B62qoRsqqfdfDb3s4nTgTVUQGLep77ZcoKjjWoyxspTn4CEbtBknDek
1452	B62qrgnUUduZy2z7zT8qCV8ngTJfSS1rK3Wh22SHUmrse3Tfqvrhx8q
1453	B62qooQD2NzgGaiHHmbdo4C1c8YcQi5uf3ns75p9xfKp2L9FagTiFcP
1454	B62qkueeFHtVMTKbwr13eWEMZmW5gYgeKZiGoAJM1qTs6oxAZKiNJTT
1455	B62qni2bXsMfr4HnT1RSYob5x6Cz2rP1zUr3sKuMSqrqt9jtJR3se4y
1456	B62qnVMHrtGPVRN3SrwyDzjbgBQhaFSgv16SAAFe5ddm2369KKzRn6d
1457	B62qrafvvcSTkGMpFiprxzDN8JXqoiyHSUQwUsKbRqrvTK1khb1HJyC
1458	B62qoJuLTSJt6fqkk2N2yntcPKSEb45C8HWKr24Wi7atzCzgeXjg5oN
1459	B62qk4VDCUCnX1TV7RrmBnSmEM2L415ucaAhyLBJu5xYNZX4Jx3Ksdh
1460	B62qqV16g8s744GHM6Dph1uhW4fggYwyvtDnVSoRUyYqNvTir3Rqqzx
1461	B62qoEAhsEqJLrLUNapSiS4hKXR6N9onXceLy3ma7JBkFznzXWpyPJL
1462	B62qoZHCPoNTozrDqDtj6vjY7MmD9ZEakVMxTR7btNnqjoKzUqp4EKx
1463	B62qkxZba8d9MWL9nXRvMaGJXESxHbkLhfogtqsCXKs8ueSZkhJNboQ
1464	B62qry8iJF3X2icdxsCzFz2qEXPUiu9HkR1wBde93bqgjvFzcRcFnti
1465	B62qmAok3N8kahogApB18ftPKLjezt3ydrHUj7qjxDVCEQ3YMvei4my
1466	B62qjodMvEfFUfs2ciXUekPF3f4ePhH3uRfwoRssh5hWF1Mr8xHjeEF
1467	B62qqKCmTdo7JJS6hP2YsiMoXvkpo7rcK6EsxBns3etbQytnoY8b49C
1468	B62qkfis9ADewoBbMAsdGaswbNUhAbbjJw91jxjH38aUriQv2dKL4xy
1469	B62qrgTTdsWFGQoPUFgKn64wX43ycCPuBFbf73M4oHJYHJfef7dvdhY
1470	B62qpe129AcY7gPkiNdStKxNtwQC9Y2ZyZCMKGKn6taZGCdTdBtuBYR
1471	B62qnMmqkKptkyQPvYmCAAEnbNxjjRkpFZJSJLBgAuDL2bURwZgXe55
1472	B62qm5ESJuFWe5JypXPQMyuw2BzkVXGHFgNBgeuvBnfiLKRaqYRW6rX
1473	B62qp6HmxzW5XXwCMiyZiJREoJ4b7omkNuCJiThVLNM1P3u1s1a3qzp
1474	B62qmMkbajiY3bdVRjv5bx3yxjp5sBHHQuu8M11sDdjtBy5VdgWdgTr
1475	B62qmPfsVAZ1bFqNM6KAKZ4LmMmyxoN6FhHyMdwSusZV891yvQachZu
1476	B62qpL4ZdJw8dmaD3DJQvKG4Ewt82va36rYK7BkkKs2SnkxzVZR5oBk
1477	B62qnYBehkVZzgJBCC5yhFyF2L7mMRPsVnKW2xpcWFVuQYRVgoqwDCS
1478	B62qjBxeuwxjcC2XRqw6YQnC5BHt8v7H6LS25iW6D4CKFwGYvCVqTXq
1479	B62qj5W8VBtyVC9j5cgGC3NTXGnQzZt5VYBCc7kMC3jDYciuiXYAngW
1480	B62qj4b3yw7bqZd2AKqYFedyL6sx4fF6GgCkzG7QWz394nPMN4EKLv1
1481	B62qrLt9obuWhsVgUsrFyC7AzQXfrsPzYtDrDZi9TJ8cvv2oDPVUZsn
1482	B62qoazqR1ag2hDwjkSSm6qV3eJtkiPvVPKhfVyeea7TehBAWu4dWJ5
1483	B62qpge4uMq4Vv5Rvc8Gw9qSquUYd6xoW1pz7HQkMSHm6h1o7pvLPAN
1484	B62qmHktvgpH1Kbkato9MCWmH4TPKtHWc8DC4FhQCJ5TpuZ8CXazczB
1485	B62qrLf5xV1fdE2RikXzzogaJYhPmWMf75GGSpJSG2yLiE3nM24C2Nd
1486	B62qkCk6fo42qQXowuAuaEjwDhSeJsgw7ZEohNkJacLfeiCikUb5W88
1487	B62qmLRLxC5Fx3cRmHDwKGq6psCbmXAYE1UsS4Z1foqrXCTtJuvTbbL
1488	B62qkXQoFvTuTH7ARfihY8XmsUi5AfCpZgjmeQnf7bj81oTdT4GCsh9
1489	B62qoev8sKidbnw2RmSAJ5w4SFdPvn88UtqvZt8GxHHd3d2P7x2Etgv
1490	B62qidz67vVjRUWi4QWBhE6i6JAs5i55YP1CuRsSNB8CjM4nttrRS4q
1491	B62qouvr8ux8uJcnZ65gLXy9ZkH4qS3a85mBn5kuXATpx6kSdbWfuCq
1492	B62qiYicQcKtuSqdDZwFkaMzMCtkPmmFuaPFy6ufp8MtpG3UsHfe2tH
1493	B62qkkAapgA9T5CqRDNM5X5xPuceWsZNdVYDKc3MgMyBvdjivTLDmvy
1494	B62qkoCsD8drVyoGsd7y31zBPnckxNjhDdiFMh3vHSm9kww82ohpp9s
1495	B62qrC14RL5ASE2Ep6sWmP7mb3dfTWy3AyFJYAduxDnjYYVFiPME7wk
1496	B62qpuNrv6pWhSyvkh3mCQQw2WcjEVRFnyGJGcw8QBZ7BexRCmgR8vw
1497	B62qojbGyQY7zXAwezuZWw5HUAEdsF5JnMeCYZEB33uvUzpenuTQCSe
1498	B62qmM9KDeqvu3TVpQStGJARgg7KppxE8UF3xMdtKV9TDc33kSUGug5
1499	B62qrx22PmRx6jXfvrS4amPCGR22KX6SB7NXvFLTuw9eDZYgVtymid2
1500	B62qik2auL1VbkX6fijdzwT6fGgjpi8caKUH6vbov573DbdT2UbQkDp
1501	B62qkDxbJZ1g7iER3Pv4Gid19m63wp5DKs7Jz7ELxVerWqWeBwrr2dT
1502	B62qqhZioGPLYePnwCFUqQd7WoHu3TTmZVAvwoh61xnC6VcWNqLMsCp
1503	B62qoTASPAqsxJb1kmDZtYhxRAuuegWG1WhzkxqmZVD3BmKLenPa3hx
1504	B62qkZuTU66fez9p4qwx2E68zggQ26etV6WDcnSx1vizfaLt3Xu4ST3
1505	B62qkG8Z6EVvYEZCPcvtNTTguKLnYk8fSduR5q4sTvasCB5k9bqpDW1
1506	B62qjWwDxk5nGMXN32ffuMpMSp3wPa7BLB3AXHH5EYiczcRxDTF9uP4
1507	B62qkxMXa9JorkHdS1iinLn5WwMV4dgn3HT63osBoFgQHYoah1MdzKw
1508	B62qocWXdgZV7hC7bDVbLvM2fAKZTFjVoqVP3ppJhpgeUV37Qem4PSs
1509	B62qj3fTBMfpJvoHTXPiKymxQcHH674jynkqsRjUw1bR12t2VCrW8ch
1510	B62qmgmWNyKRJz6m1h5EnEPSZqiUf4HNHWaPsH8XEUVs9whBo4okwyQ
1511	B62qriV8kQ9FzSRuFPXAjtZx8JcBhY5gmYkFd8VUxPVVSBpSb92V7T9
1512	B62qnUwCFGxywYr6rxq9Zgktbm3Jc5hdTChnwbjM2goJ4XLctZXWwp9
1513	B62qpAmXkj3fPExD9ASLbARWBos7taNoviawGnAeQWgCvNNnvj9Bn4D
1514	B62qnR2AHmcnyb7v3cVvuZWriEnArx7yMkXBcnzpFQXCmGxAAv4nJSV
1515	B62qs2P91UjdhngetBJ57C56HQ8t5V7ECAYWBvpkaC45ovXNgnzqfG6
1516	B62qmXMMTUuKDEwY4THkgX6fvDtujGNP3FMdiaWwSHkMsMM9NzwPXZ1
1517	B62qkd9DEVB4G5AxN2siEXVCgs6VFigNCecmU4gTizTber4hHexwid1
1518	B62qnvKLdq3j46nuQML7govR1gNqfBjHtv86FzmfrAU9NPGd9BSzooh
1519	B62qicXxuEer88smMkN4gPx7WdsUf4dNGh3QjfprXtB1dPs9ZARY1ba
1520	B62qqYv3jnSjWGihWqqiX482rkPJ4MyXDtGF8Uz2zh4UewKapdHod1P
1521	B62qq5YxMfnoC9trqNzXDrM46zheg4Jq7qv9WBUtrqMYedgtCP67XCz
1522	B62qp17siioFbT7ugFCJwtfcSn9SHFsBNAkUAxKjaFtorKqQ2Z46L1G
1523	B62qnSUbgFfPTsZGPhFU9hEy4PerBLCHVcTCYthU7BUN75nHiZQPg6r
1524	B62qnMTo6ii49AJa83i3i2WeG3bJN6WHDYh9K7BvKb42aQHC3Pibvxp
1525	B62qjPDyavWQPQEPE4V1kZo34gvffu1wU76XLrVuUSRMyDvrHxEPMf4
1526	B62qksN97EtNvQGzH2RAgnDR8zLAawhPNE1QzWCgPRcknyL6NJ3CCgJ
1527	B62qkBqSkXgkirtU3n8HJ9YgwHh3vUD6kGJ5ZRkQYGNPeL5xYL2tL1L
1528	B62qj2tZS6SxPMfzFAvVxR6ZMfryVotdhMUwPx1C3EAhgqFEJAAqUXX
1529	B62qrGX6VyP6BmGAMYzrvhyq12JDuCQHpuumme2St5K5nWgPiFKhwMS
1530	B62qrL6Pps4zCkefxTemCQMHyHKYRZ7DiAR8AxLrzhAwaAyJ6mqYocT
1531	B62qn9Xw7796dqjdmPRxzj9BHKjUwtGwovYpWXZ4EsSADVJrBee2pxd
1532	B62qr33YrdZWpUw6eeLji4nKB97VgADHekHjyCmb9oGDrashXMPawWG
1533	B62qphpEdBwSycpN67XFjcXSEY9j18chmttFTXYerhTPMX4JkXubWkd
1534	B62qjhiEXP45KEk8Fch4FnYJQ7UMMfiR3hq9ZeMUZ8ia3MbfEteSYDg
1535	B62qmPATxsWneeArMm7h2JU5og1vJafP9Qt5VFmMunnGZVR2DTC6ztM
1536	B62qipnm2igSVxVw6mqSdhU55kwwXDdE7mbh6FSiDj2zQFKhQ8iezwe
1537	B62qob1tGxx1BhychEzzah7yvdbRH3E7SNSTrEtkuSZzR2UBezMChg2
1538	B62qqhHs5hGXumEBYSAbKvC5edPKT6aUzf6XFRsANWq1XHwpJguYosx
1539	B62qs2JDc3nv4LPr4sW5oW3eAicxp4T6EQbGesAoJrcaoeEiynubHoU
1540	B62qq6ZYPG5JsjZnGJ3pADmRn6hU6qy13EhraTSymjSgyEDwoDR9Gd6
1541	B62qrr1gkgYvVfRb9JjstCcjDTKYYXFM61dD7oqFaEjc5VkFvL8zWgr
1542	B62qn7dN3hhEyqEYLG9Le1KwJpJfcJQXfiBoKiB7sZVrwYvT1NyRfDr
1543	B62qjSytpSK7aEauBprjXDSZwc9ai4YMv9tpmXLQK14Vy941YV36rMz
1544	B62qpZQ7xcNpv6zcY75D2y1V4K1DHXVpkbCJAYpPNHgutXAb6o5QSZE
1545	B62qiariqVhC5xzvUMsvtc3hxNBtsfb34anvrreAQA7t1647dZbyPjo
1546	B62qoG7mge74phWmvLdgMTrewb3Znpkvt3LYbtiKgvhN3v4kjVx1RPc
1547	B62qrW1cezZ24Dn7DMdb7WPVVpCcE4s9BhYDDz49rWyVeMinHb18bg8
1548	B62qoo7juS8X4i59TJ2iV4p7ogHqBwwuMC9VfsQFSNjZgZpNmGw58dJ
1549	B62qoKueAUixdjxSokbUN6LeKRZoXMHEhU6nD1zpZ5EDh7zNTaDQeNK
1550	B62qnxHx2ZXjZut1BnpCRiLinjQxH6yLgwGgB5VyuQYWdeum9p3kE3b
1551	B62qrE1TgV5jegA2rn32gi7FkHbFSvo2xRxKwhYykAiAsLy7ib7Uwnc
1552	B62qn1jcWzM2h1f2HjLku6hjS5dAJ4pgjRaV3PzEHBbPTNtqKafsdhR
1553	B62qjJ2eGwj1mmB6XThCV2m9JxUqJGXLqwyirxTbzBanzs2ThazD1Gy
1554	B62qrPbHUhxVqe17VwkzTyUmEsFwVry8geJEb7zfBVa8kocYAs2j4nn
1555	B62qoi7wVz5NDCYa37usdATKcvMVcbtXYLjn3KiELXSEsG7XcbifC3q
1556	B62qnFs1Hb4TQdDFMrm3LaS6e6dxfXPTXH3WpjyiQQxuRvVtBiZ2fx8
1557	B62qm2o16xqCCqV5vkfqYEHNNqFSsMx6VK835H8uszpd78bnsTbvQHV
1558	B62qpM6uZJgwBf6ahjkYNMD5aJEt3LBHe3wRkNHD5LoxR5EHPKV9zwN
1559	B62qrQBarKiVK11xP943pMQxnmNrfYpT7hskHLWdFXbx2K1E9wR1Vdy
1560	B62qrQiw9JhUumq457sMxicgQ94Z1WD9JChzJu19kBE8Szb5T8tcUAC
1561	B62qqEbM64qqDsLzefbkavB3RJWy3oZUbZ9HikqCKRBTvqbsbR53ogD
1562	B62qoySzFYHZ96RZFFc4CRYeh2gp5xF53XxLXJ3XFmnzBxXsd4KRikA
1563	B62qn9aR9hkH43oXtW7mMcvDqvCBwVguCf5QyN89sHmBVuDEkuEg6yE
1564	B62qqPJmQCXeRmjSj7jJPXvgshHVBfbeXmNW2uRBf7pwVsB7pzbcqFH
1565	B62qqaGu2Hz6122My8Ddxj5WPgQd1tVLmXXJioxa7Wm5m5VJPzoZdhc
1566	B62qrF464XvEDcs5yYa6FnZsz1RhW79HQCyvfQLME7w9NDuqrdAgfuD
1567	B62qqvDf19E357mwCfM6fHRhuBTaNcwnKCJbaNE3waGnQ8uNZZPU66g
1568	B62qmrsFZNeW2ReoHpTafy9hy1oNw12UuR1UdGJEUqTuFZ3LPVccDTA
1569	B62qjWrUQMud5mWVPSeMs9t41mrXdWFPfPA23a3nsEbGWBTEiapipqH
1570	B62qozyeUmdsCUP3kCJXNMDwCENUA6SA7ZtnGWiZbSWaB5yeuMVVJF2
1571	B62qrCz3ehCqi8Pn8y3vWC9zYEB9RKsidauv15DeZxhzkxL3bKeba5h
1572	B62qm3iPXvCBATaBTVt4NyWigBX45JvjGqK9PJj2TjdtdLaipUt1Byg
1573	B62qo3iHrCUfCtxQU9hcHT5kehJsQB32fE6JwMAadSMML8Cg4eTPBpe
1574	B62qjeR6fS4Z9dyaNt1UWPh8bHWm4euq5ksKnctfQdwucSzRGh9cFZV
1575	B62qqK6M9q1eE8MNnmeGytCUhgY3nq83hMxstjtcyqiEGuNMTvjNDHW
1576	B62qm4ueLWLDXXfKCuKXL72rwXtiLsWRAKGJXH7jEGPjjbzR41RqVun
1577	B62qpEMj7NwUbeWyyPrPUHtJDqJb1RkPxJtm6JxHrXUKDFMgJYp1zzT
1578	B62qn9vwCUbefEmPsj6g29df18TmAQ2bSthrRFGvWG1jKDEbi2wJT15
1579	B62qjmUyv9D4GQ35RFSDrXjMqgFYW4VtDkuv1q8TnxosPqxSJcbdvzG
1580	B62qipA4mZXjXaKHv6GSakqhjpoAa9wZnAKV5X4HyFyy6vz6aqCNYeD
1581	B62qqE5R5pJDUjPrKZMtTkPKUPL27kwNZ1sHkZaowxSLosZvLudt3kW
1582	B62qoahjAyUBNcXBn8HTb7Rk48sBzfZnjDa592MqjCnMXeWpFkGS6zJ
1583	B62qkXeeeerxc4YMtV8qBki2bTQc5KBZ5CCZk85xsjTBh2iEQ2PJmce
1584	B62qmPxwf3FTtb62toALY6k6q4HiCWJCUGP8xyxpDFsgwhFCnHBEQvp
1585	B62qpdKVxef96UTWaEPEbGQ7FruwCSbEckDHDGtpAQqxUfDmHR725AV
1586	B62qrJreRSCNusj6uYVanrFESuaaBu13Ri44djV6k7HkYNcarKEJBKu
1587	B62qqMU2Es9QPPYj7Vn54aJbbW5gibDZYu38LhGLGSjccSxJRQ5NkuK
1588	B62qkLn4YDsHjoiRus1G2HmUKUutGbQGTVEtRT6NKaB1RRMYCN2d6JM
1589	B62qnTahyoiqVSW9qbqiTBczA7n1wim9d7PYwGxWZP2s6mgwMn9AoGg
1590	B62qnR6HKx34NCyDkSeRcJ44KATjUCs4xmQYDbwTXPJPQ4J6ebfeQe4
1591	B62qjcPuh2BcHqKMFEsUAshFRVvDn2V9xVrrRpn9Szarx63NBmehJPP
1592	B62qo74q1yCcNhJ17iYrNEpTWEJwBPdDzs72hFDDwm4PDWVihC5jFbG
1593	B62qkoSio33qzxjsAuY4KVYmjw784KuyDSxbRL4d8UJaLXmdgVqb4N4
1594	B62qnzLZyeTiesV9EvUxUU2AHqyWfd7kAWEWL8QqJm5Uaadpmwafrj2
1595	B62qmeKQQvdH15JDyFWYhm8N6mpuV3tbZzqkZSGFsMZnbXNVqmsYvvg
1596	B62qnvzUAvwnAiK3eMVQooshDA5AmEF9jKRrUTt5cwbCvVFiF47vdqp
1597	B62qnAZCj1kbyDHpxo6Lm9yM2FqMj4ffJTQzJeiPhgkzpEw1S33caCZ
1598	B62qmQ5ufDZUTz8tm1GVQvmNrn4Don4hXPJ5GFMJpP8VEXkHJCZ9ySW
1599	B62qkHM9NT3nDefqUvSMe8qnfEfeXipqkzZrvoBXpfaC9m2BdYjWVJA
1600	B62qpXqPzauUXLnsAQFnYHMCiV9pRqG2wqbJ4pL936SVANHa66zkkQj
1601	B62qpkF1Yrd1uQNLpun7d8k12ggHEXjXHknLCKh6Hom7Q3Ba3oZg3nb
1602	B62qmpSNd5voNiVnyM4c1bcbRC53wdkEANwYZaA2iA5rgCv68XezSuG
1603	B62qmiJsasogL3iTj2HhSE5AyhN3y5x2GYuvccCBdT1xYB2bpuSHL2P
1604	B62qjqYBrf5erL4LHSapiuvcX9TMLCVqCuyzYYGC2sGZfKxt8tQ67Vz
1605	B62qpy6sXLwATHek6wjWKqmDukA7m62rtF1ChoTt1ZMT2po3a4hTW3R
1606	B62qnwWiVgFTCEvyo6buKUnexc4LQX1Sbuw87iwvanNmkPyP5zm43h5
1607	B62qrae3PEBj66KV2obWnzVxMjDCMuFWnyzxEzvLkQutaKPmWtfUPm3
1608	B62qktmhyar5294GEBpPfgYrSEBxkAcn52273bdR4CiGELoVpLtaC6c
1609	B62qoQjPL289fYLgcPzDmZ1Dv5kqNYANsicix6v6epSHXUW6H3XUTL9
1610	B62qk5RNZP2c4xbrefavDjRM9wLP63kFCVdd4TRKfmtKLXEimdDrKNX
1611	B62qrVGh6mx3DQBmXobnWidM265mxSD3aisVjR7c9KMyZV5FfXqywST
1612	B62qrJowiiRAYWQUrhyieAdFuDJgQ2MoyCqTzotP2ECRVptb63f7bG3
1613	B62qj8KB2fk59NkV4VuoTkVXHjw8VJzC3ybKrWo7zuDC9xTiWXPygEe
1614	B62qmqprUwxHxG6uGDQe48Xys9diJhunEqQNRuFC5a1KBUNsDaNADgj
1615	B62qkhfgERAi7TUjujZ8gdwSbA9TnJxvErjwfZTeftKmpdjJxWxGHGT
1616	B62qk2ujo9BoBxCs9BFQUsv3efaJDzbJeLs4YJdZMJzJoVj69ShVdKs
1617	B62qoWcd3dUzbjMHTdpjf5Us88x1otEoJmhSVRX7FXf1Dx1zT5Hp3ZC
1618	B62qpzciXjUdvgsKcstj1jKLnyPCtWFFuvtwr54xakf7tRucz3CgHB7
1619	B62qoeKm4p9J6Q3hYWzb82Yo5uP163MqooBX4ZWjp8FpX3N6Y81QgFc
1620	B62qkVjzzRRXe7FA2P6Dv5rJkxYT5u8QWYAfuU2U7b6yZpoRfgQhCSy
1621	B62qkJdU5HYtzLHfc5T8U9SompB4GBxA9Uhjy434qKHRQBbLhPJjWuc
1622	B62qrwBEB3tjGvjZNNr4h8N2iHGvcgRa6bb3V7Qs7Z15EZVWnyJBpXR
1623	B62qq3tqfdj19hqaVCozJFM2q9gT2WezQMaJMKD6wxyvK3fMpHiP9va
1624	B62qrBRnUXvdMr8eGLBsmdpvFnndinDZMowqoMUYRJnmGKpdJv7TMRj
1625	B62qnwfauXg2i7e1CYGdJjztyfdJ8CiESr37hzm5X5HJnYwp22rBpSD
1626	B62qjmhssErdKxMjXuXaABYjTnhWjzbtdm63XSpjNb9ddPNvtfJ2JbX
1627	B62qmQ4pFXU4tyNwdzMY7uCdrALptYp8SnthWJMqPPA3FgmxebY3H2P
1628	B62qnsWWJEU7U7XFNLtqH4bKZAMcPK9mr5CeohEuufkV1fT3wgNSV1T
1629	B62qqvZh85mfqj7mFhKfDnC1n6aCxw8Ey876Vw2z4E4tnCkRpcHTJ7b
1630	B62qn2Ne2JGRdbHXdfD8wkA6PTWuBjaxUDQ6QuPAmggrcYjTP3HwWkF
1631	B62qnbx3HVFsNCd6v7TJT16nxB1UEekBKektHy5WZ8GRotwTEqAtJsX
1632	B62qqjvE7v6Qrf1h7xtn4U57eMq8m7CPpkgwS3aCY8w9jQgnzAoPoUp
1633	B62qpGnZs3EZ8eYuxn8ANNwcexMhYqjjSLKBer8KhsviXGdEDwi63St
1634	B62qorXXHv971Kvnq91TkvWsRAvMCB8yszCX6yUhpyZseKcibSZSDSF
1635	B62qmnouVrbSqDevkjai8WsetJZSC1kR52vmz94WDRj724KyqYJ7MBJ
1636	B62qmTSi7ZMLJLGTNADvhg2NSL7roR2AxPW3JgrkY81nFB56AJGTcN8
1637	B62qknBg1mTvb9uXy9exbBsxs16BXgMQiJ5N73eEFXmWBLaRetqMvMb
1638	B62qpVUF5PXf7vh4eH8cZ3om3mp23bQJPDqwE2iB8BaE5ZUhaCJdU8L
1639	B62qr6owPPGkPVLVFcXnQHvijQxH4TAVqXhJAcMuKWvLXnHCtLZyxPZ
1640	B62qpLeuZDL7PxNsCqsJwWFPAmnixi5ay8Kz9NcNGBQU8jK19VpJQaY
1641	B62qotPF3i34VMSyp3A44ziyME2R7MRN2vH4W2Yen352MW3JW4G6hq9
1642	B62qrcFgyk8u1NPaTvw9zZE1RVYGAeURojHds8WMjEpzHakU7BefkMf
1643	B62qqUD5wTz7iVVrT2axj7tVY3kybSPZBJBDXRgZTPgJJHm5eD5aR1b
1644	B62qj3tjfzAhoLX9ymWvPsTZTK3Pm125SLSSGGfPrvhc3zbPr1D1A2y
1645	B62qp4Xg1zuAkTc1cyG8N2xQrujJaZ9uesm26Jy9sr2w65XUnNaGEEQ
1646	B62qm4QbSnmQWM3x7SUiQeWAjb6iiooWNd8iaxtDvsne7YP4nC8Nh7f
1647	B62qrHzjcZbYSsrcXVgGko7go1DzSEBfdQGPon5X4LEGExtNJZA4ECj
1648	B62qqJXzVcb63kE6zFEXJn2GsQ4DTjygTE3ymjYSsyHRt61qVoUBZyr
1649	B62qr7o47ANtvCpSzdVXXoweGkaZkwWnq2mZ6Heg7KQTCuShF4KeKFS
1650	B62qiwgNcH1uw76xgqJMb4V1nuD91qbxrQGWay96u9TBkgPb4HxRJeX
1651	B62qmpHMDeuGL1KAkneV1RTKMez2ZNcDUJKNAEZgweJna62xuJQ6Mqm
1652	B62qoDCpSv1cmWiXgYvDud8L4dk5oTwC9JkyXyz9b13j5uFKiEFjv9D
1653	B62qq6ceNHCu9mSBvczmHS5JzHC4zw5U9KLALuwZPemeksx82AEfQSr
1654	B62qim7EVe62u3wDsGzAZEMGMaEuwSXYWTCH1WsNvWFgfvz7ysggDxf
1655	B62qq3Lg31BG99W3DfpUNUr78UYhxUEEQdjSURViWhopsNHPUZy5CqA
1656	B62qmRG3THXszPjfJXDCk2MjDZqWLXMoVzyEWMPStEdfqhMe7GJaGxE
1657	B62qmBBEPcCpWqvMhParohskEjDttye1A7iSxwmMncXXgKkgjQ9PA7y
1658	B62qrQMvZrta9QjfQAmC9JsUjyUWDXX3h18nRt4FZm7wNgj9YPKwM5Z
1659	B62qj1EFvWbmmoUw2FH1AvUtRSP6av8MFYTiqsB7SQbHPtqNT2SWFEg
1660	B62qp8PCgNSzawdhooGXPQhULtZ4yhNzMb4UVSd3sTLz5tR8Btdtqn5
1661	B62qnWPnneWPobbir3JncBDVnj9dGvT1RA713xYVxJ9sBYgYHiu68Xh
1662	B62qrzoBfFuUxJg2YvcBkBnziVtAPziP5uAPcCPpQZgtjE4LTxXvVSJ
1663	B62qnr2iUdADcgeYKUVjjvXaPy4qXXz8gmYUYu2WbHA8ZaieWMo2r9s
1664	B62qoQjc9zF7TrVeLP4vUvYXfDoWGFPn5Q1jFjLDWwB6ocA1VXYyTPs
1665	B62qpUXyywHB2yRbgwEfmoUSh3KwN66W8a8QoXqpoTiHJkoQMcgJXbu
1666	B62qpzWppkJex4Hx7Y6rSq8yH9JMaGc8R1b3nkSjH3mk3aYKNyX6DKW
1667	B62qkQCXhzstenWTCwbGqRgdvivBQEE2WDNRWLRo4gAXcnkQKZ1FAta
1668	B62qqKoxyhPfHY9kw283dafk5jztbbKdH78eDXpNCyj69cmckC8KZqs
1669	B62qopE6unCuyENJR7qzj5NuJ8nMfj3dD214AVUpUeYbLyarawUvq8N
1670	B62qpMcYjgezccPk8NfaSto4jyV3uGU8R24D9uSShMoqr8JdpAv4RKo
1671	B62qq9CY1jVwTNjxbqUxNT4qhAy24woM1uzYA2HUo4QEGpkyUDXt3YF
1672	B62qoERu6rA6UUxk6yNYN9CfrvXwNB7tBF94TQucZNRkabQNiDJoMiR
1673	B62qjQ3k78nzaePyXhg298UEVnwbCeqQUcNwZRSR4VK1gVJ6mer6M8V
1674	B62qkVNThXvoXtZERUnkGYSoDbSDwnXntVyE8anpNSGLSQ7DejZMtMe
1675	B62qpFJeY8uiLwzhrmwFGthQS7yjZonyUACq32G4ULkZcRB9W3WVFgE
1676	B62qiy32p8kAKnny8ZFwoMhYpBppM1DWVCqAPBYNcXnsAHhnfAAuXgg
1677	B62qqa9g4CFfkSuX2j22S52z6UfcDcS9tMTgQrFKZ21v7GrEP6Zu5Tc
1678	B62qjYanmV7y9njVeH5UHkz3GYBm7xKir1rAnoY4KsEYUGLMiU45FSM
1679	B62qqSUUCnoC8Vehw5xwhrnaNxhk6Xe3FcBhngoxyXCbJBfvVhiqia1
1680	B62qjZXMHQijyxLPJHNk4QvXwYqgTj3V7X59o82AaD8TqjZm41ydCVM
1681	B62qkiJuTwdJBARAPGAvStuEa37kZVZPyDrQoUCuM7WQUmZZydNBmTf
1682	B62qpRhxHAcWjnWZZSUScrzzKWgP7uXrLi2uE2rkPtapxRCEYhLjm8G
1683	B62qrdhG66vK71Jbdz6Xs7cnDxQ8f6jZUFvefkp3pje4EejYUTvotGP
1684	B62qp5HTeTCHyYuuxEECdDNiehDWuK8o7JgMqNpaboxSZB83sTxzbEx
1685	B62qnXMPtWdK4hRyaemZrvNoDGe3pMQNeubQemMZVXetuEY6MfgYszF
1686	B62qs2YyNuo1LbNo5sbhPByDDAB7NZiejFM6H1ctND5ui7wH4PWa7qm
1687	B62qoBXv2eZ4P1yD4ZMXrAo8YQSfZ92ZAAGKb7cZT5nFa9cN33YD2ff
1688	B62qoSuxNqwogusxxZbs3gpJUxCCN4GZEv21FX8S2DtNpToLgKnrexM
1689	B62qoNMm2MYD1eA9QqhyjXsmWpFwkGUdjpJmxTeivrJWG4m2GG491VZ
1690	B62qjA7LFMvKuzFbGZK9yb3wAkBThba1pe5ap8UZx8jEvfAEcnDgDBE
1691	B62qr73SWPgL3SywFHZph2RbTusZyRCWjJNbwaqizLjX561H2KoweDx
1692	B62qnYVcxiHswuEBZjAkkejZU5ssqemMLY3VZkXXHzqUeEVgoZiktbs
1693	B62qk9WYHu2PBYv4EyEubnVQURcwpiV2ysuYYoMdwi8YTnwZQ7H4bLM
1694	B62qoiQhNWjwFkfCVBpkDTYytifftoYQB9qJ3z6X4d58ocxmiwUQY8U
1695	B62qnFWGc3e1FKvgLdWr2viz7WXsrWNZU4ezXDsQoYB2Zg5hMZL7UUd
1696	B62qppPSnCA3injWMQZ2ExBuYwcQwEbtjvwUUFFAcYNv5xbT8u8q16b
1697	B62qpCegcfvogh9pPzYSR32GZR2vnQc3hiF2uZJmVvJL9xjj2bRWkgK
1698	B62qoTHkMLRXsuSnStQWNbM8Ks8my6BNGbeL9U63aLyQuRMrWdbbnbb
1699	B62qoigHEtJCoZ5ekbGHWyr9hYfc6fkZ2A41h9vvVZuvty9amzEz3yB
1700	B62qmvHQzJmT2rKE1F9RemenGRG8BfXT1Kurve3eT4iC2HMrWiaVG3H
1701	B62qoaMj7u1JzuqXaBByQBL5jzqLguK8e7LHVPdY9LcvvLXK7HPsusD
1702	B62qmVSEM1UXW5pymtCBPhmoXgvxgDXwrfRbCpR8eZCy1FLWgaGzcNc
1703	B62qoUsaSTG3Ck7FnxPrkLVXtq3kLkjCW2j7S6DzW9C9eTqNw5CnmBm
1704	B62qkVjmbmdGDe4LvCwTGRCfTmENWWnSV29NW92WEE5YXrdX8L3P7ce
1705	B62qjx2U3xmfSPai2np8kT8sjiMJiF1QRzULGzCEMSX6BVWFqKk9Cg6
1706	B62qquj9jfmsFr3mZwDGt8RB1aiaewgtnNrpdfmVw469Kbo7p8uiiZX
1707	B62qqbFSAx9TGCandj7LK52rJyUqLYCN46gQSF66mj9u9zHqcrdEWGo
1708	B62qkVTL7vg59YSB2mKvFqPE969EnbA9XBz2JEVfPDYrFHokDhsmGHF
1709	B62qou8UgLnmGbGScLTK7xeUEp6zmHxWqzWZ4YNhZMArNjZPF5EtPWP
1710	B62qix5zYPi2gNqcNmoWJhqPUf7HJoaDpjtcPf3inf3D7rh3qkjdm3A
1711	B62qrPqwpLZ6T16Ce9CbwNC6Vfkzx87fUqY5R9rYhR9DxQHgPWSwUU2
1712	B62qmHf2rpunn72L5ukkCZESk5QKtUcjApxQ3nXsHhRbhe8pvJ4jJti
1713	B62qndJi5mnRoBZ8SAYDM1oR2SgAk5WpZC8hGpJUZ4e64kDHGbFMeLJ
1714	B62qmpQbytpsLD2mjaXmLzk9j6QpaHsv7VXnyZFmW4DmvNBmfrvQ5eB
1715	B62qnH6TzZYc8fokBWAn6h8SLmiQV3DpRhUmGk4P9n8r95Q2dNF1m4v
1716	B62qkwaUeADgrn5zcBZ5gKYiGtp38SB8NtuygtRHxmJ4WM1Zo3ExJHw
1717	B62qq9hV5AifoUy8DSZPVpGR5nNm8sVVjjbq1C1R4G1SSRgdeFAKNbW
1718	B62qmkmSCiTvayykE34nVjvyGdYDvFhx1iHV94rHgkESSNiApTzixj9
1719	B62qmbPb9Jgn25KqNPwhAM4AomUj2LR3AM2U3Jcc5zDRm9qZDGxcfEE
1720	B62qp6E4Y2T5pdEuYWizSFK2Pm6yT71MZThsVSUCit2TJYs9EVoujdn
1721	B62qipHmwhGetJaLt5nQ6ay2mvA3PQi8ic9AZ7XMdLpoRyRzyT8vjsp
1722	B62qieZHH1wHfv4PkSBhyttENUSV34ywjBP1LoedSiaz6sePMqy6ik3
1723	B62qpyX7tTKzTzFaJ6w5uu8PgedH9eftfKzE4kXGidZDPnJ9XLjGbP2
1724	B62qkP2wF1xfiMy6zpdaJEsDojjp6stmpAn6speYW57iaFr2bUthhpA
1725	B62qpvEbqegpNsPLdc1MiHXsKLfm6jDTJPfwRwAwExtsRYQjbZgJyrp
1726	B62qix9vooX5NqJYo8nT6xWqCeQu5AJoS1ng6FRnUpVAra6PAZZ1CU4
1727	B62qpxakXZ6d72APV3AV78Rk5g1aqgxqkWLS5jHEf8WRYSXGvsUyHgW
1728	B62qpJvSB8A42sQjvpz2bbXYvz9kbLH7w7sxAMFQ5eK2LNbMx5NGcAC
1729	B62qncg6H258KhR5RzcRLmn2aGd4V2DowXDLtxJtHkGA9WA5dcEYJur
1730	B62qjn3FwzxYTYWa8yZmsGXfa2CQtKvHvgzME2fypVvDfKxWLG21U9V
1731	B62qroh6RLAVUmepY6oqFFftKzuFM9cCHrzjUCsfLX1onMGQRLgqzuu
1732	B62qqZcxyBkzfuvATNj2YmbvMZxtwefwgBVzArEwzkgS4atocFxn5T4
1733	B62qomQbvXy3uKnsj9xow87q9WD6Q5sL8ByqRzBMRb39M88PUMo5EYC
1734	B62qiUpqtRRwJ6qcou4f37TTjBYFQBsFcTL7o14dMs2KVz6zNZ48Nth
1735	B62qkn8VfJNMwfWooqjWRvFEmMfeajG9XBwejxvQi7H27gTrvgPLB4H
1736	B62qnQYmsM4r9iQh1LN89UYtz1QR83ccH2kkbDDQ4nuXDyhyULQvsUp
1737	B62qr1yLuknMwcNYeqXoqUeQBpuMKVtHiQz62qP1eZDgLTcU9jrYfjQ
1738	B62qksdy9aiX4PGnz8J6FpXvyBv5NecbSvZevSYP5PGd9PfoGuRgWfn
1739	B62qke3BiDQQJHjiyugZ6BrBhe6P1aDHqUeS7EGM3dXH3UMUmeuJjr5
1740	B62qkFa1sHgmFi5u5kW5oG4iPvycp6komoSNLn5TT8uKGfsmh1EnAjZ
1741	B62qknU97rYs4UC3i83Xkj6fJxeNs2Ud2uwTgfxFGQeKaM8dxjhKnzq
1742	B62qou5BnHyuMMsWU7yNacS5dzCPq7HLszHDQUAv1GqetwwLwgFa6gn
1743	B62qkSashvpHk4t7UL2tMtYMqX1eBUxS6ekx3JLbBPKDNKLjV5mHJZM
1744	B62qm9oz1xi85sd3DSuomARHe4eJgiY9XENTrR1uF2XgxsPiggNCUd7
1745	B62qiuAo8eZmCpYCgh79BHpimLZiAWxhoVCzpcSWxkHduHN66UfRktC
1746	B62qqxJbhyZzVyuvpxrHGVfhkBcmF9hrwY2mucCSghVrDdBTqLDV7uu
1747	B62qmhcP6E3NctvZSWW5ZeUGakgyyxk59E285wymE28KeaMTuDynNmc
1748	B62qjDZQUmHBoFPbUeE2Kw7zkrz8nVMoQVgnvQPnAFYtm8HK8rLbHd9
1749	B62qkGVCPGHrLHV9r3G9NqD9du2Wcb5uKBfDvLwbxDKnyjMppHoN6gi
1750	B62qow7ooWaAxjhwA8RoFMFjv1rAetMFe8CD4dgmZGdfKaZsuFzYsid
1751	B62qk1iAMVGJHR2usTsvxV4ehxdrDKYSFNJjQjMSYYDdFTtnyHpB6wg
1752	B62qoGoJ9tSnPehar1UR3fhSSXKpoNXW9ZGottoCeHotyyKqJ1R5tam
1753	B62qmerzAuZt8aD9qFheFQ9fPqtpiNJJKLk5QagP3Lw9M44nniwaKNF
1754	B62qjGuAFtLagXc7qv8Jj9T9kKNNbfQmd5pJXzFfeHrjEavRFnEDfWV
1755	B62qrHXrAyPaXxgRKHg4zfnFa6zxWRo9kPRseenPZH27T5oA9mQwKWQ
1756	B62qkVE61eN57HzwZEwoAgJYJGpDQ7jvXk3ZBsbNWBQQv1NBY5ftoaP
1757	B62qifbvKWjFY2VriPsVoScjJgcQMrkbB2mxZdGT478c67bMvNxTvK8
1758	B62qoYVcxsGQWVuPuvU53jCHFnuJ4FLePM8SwkVYNfxboJU5pttpyMf
1759	B62qnYVJSEPGrVtUvECksn4cRDBa8c4QhLQ7dzoHxqB6kPcAZvY41ui
1760	B62qrPAYA77JESy8138uNfHaGnM6g5PAMptPK1sUVhSpaZrd8S7UfVk
1761	B62qpanxZjnQLtZHQfY8VGgCYyE29aDcG7BL2KwkQJbDzaSxwwZqT7i
1769	B62qoQSggXskw3YQjTCmi24Yh9HuuiXBSBKDKzgyxg1G7oe3ng2r4jo
1772	B62qrYDn9gjvt4PGN9rPjnHiGnstJrYo2oHtJ7tbWYNsLtWk4WLZMXt
1773	B62qpRMMLBrU3TEwtw1Fbaz41LcgX7H8y6JYH14MaiSFWzhbV8wVunu
1774	B62qkDUHnU6bam2V34VKtReoLSQempJnbdtYNLivX2iLCjHUpDntVEi
1776	B62qmt8gdmBFGV7U9ZsmnaGGjpKwCFMR4HCwzh4XPP5v8hWQeJ5L5Jq
1777	B62qmd1EZEgVpDi1xSuHbPnqZroPVG1fbD1GMpsBF7bA6Y3TcT9BTWA
1782	B62qoa5KoGq7G9JBgyRisUuraxgK8DbK7RdxSFFryq1eKSWer9FpS1b
1790	B62qigLWBbpoXjsxDQx4zFQofz3DEnfspxX14wAVEnGryv4jg7sPWcF
1795	B62qrga18YWfHqsEZzsVVWpZetPCRUE1E59G7fgJas9kzKSBHtQ5xvp
1798	B62qpiiHSDjNM7Z9GM3uM63NLmihXrPPstbLA77mJa8cj9AE8bEuPYa
1801	B62qp5ZUGs3HCAG6aaJSH1cfJgN5fXf4giMe64d99FrxEanE5erCw1B
1807	B62qoUaAA4bfUaA7F797qFEwWJTJak5wSUqujHiyevtLYHDwt6hcu55
1810	B62qjhjPvNGyVs2n7ve3gaV2TEheCESVW9JJH8NLDsrJw9QjzkfxPwg
1811	B62qkQJWnnDeWaqmBHsJ9ikLxsZfcdCtNhhRtrUnDfCe2Hzsqsu3RkV
1818	B62qjmomH4dhgPsvLtSXRnrRyRmcBhvM9uCzG7n2kryaMZTunWvGxQC
1821	B62qmaatVU8sTcRTYWr7vmhYjCRWvNoKVf3Te7Cks6iWJ3ZNpjUwcVK
1822	B62qoiTh4oSbWQ2KNnXPCKgtLUio47SoXb6ACx3MYXWwXFedYFvsX5c
1823	B62qm1XMKjMwVat7gQGp18Sk8f9zfiJKYwysELpxWaXkjLudYJ33RsW
1824	B62qjDDf993B7gGCCBW2So7dYAudc8JKNL7ZKXYErQdQPML6awsFuDw
1825	B62qkJehvL58EE6xxrr77qwocrSSKAnDeGtSGNxwGH73WrQjegxsMNk
1826	B62qpJR6R3Fs4RKzDFhRs7BSE5uqQKvaqZ9SPmMhzQ7vCozkSAVcmjS
1827	B62qjbvqk8bxbAxTubszqowtwE41uAdvRkNV3otDTFB37XiepTQndNp
1829	B62qr62jw3FKtZbKfs3MjWuiSw1j5N48BBNiyFusThUAq3X2EygUgN6
1837	B62qitpkSH8U24Zj5V2oziG7Mv3xTyGTyqPkrJ9C4tJaAjKWzLpdyhT
1841	B62qiatrW7byfZQWJRZSkpYNuV5WCywdtWDz867GWoCuMJ7Bp3fnN1m
1842	B62qr5ahww1fnhBe1BCvsJMFynoGfzgmJaCJz1px2AKd9vgg4dHbmSs
1854	B62qmbFAECu7faKPV8stYbMav2QvKLq24Cu9eNEoXaVGNRnh7qWsjXn
1855	B62qigBkbZZ1UM3BpFsuy2qwAZqiNa3WbyHMAVFpQXo3ycEc7K3sRKw
1859	B62qpMmebS9fNA6sR1HAZALfBBdrbWJL6tpkXu61iteBZLsdKYwaAtz
1861	B62qq5SnXbxkXL1ayVR8QrxtxJVZUbFwp1KZRB46rJLrLFxB9xBkdy6
1865	B62qijNcg7kkzdEuXe75gMwUY6GVdwGTVtJaMuvsxMjq5BZsSUQ6Kdb
1871	B62qq2JjD6R8c3zAts7Gj2gifHw6te3qk8vRmk5EciyYGobKAuvBjPZ
1872	B62qprKV2kK47mZWky7qCDWb7AUE3uTdbDQe9VAncTDxpUA7syrPudD
1880	B62qnp1rm2iEEecxrCDPGCt6cu67Yx2gPykXWG13vAEKTgQySnyk2e2
1881	B62qqCcWiBhHLA61zJx8vcYqLpAYLrouAY43GEhEYARdC5j9WBErpBR
1882	B62qnMzCM4N1P9GeXjPRMWegezzqzaTrDprqvrJPuN4vAn555fgtHj5
1885	B62qrXynZY4AKszEybHwcx1r9BkrroueBU6nGc2idCHnw5tQEjvpAHi
1888	B62qpyoNjVz11TTntVphmz8CAqJ8fqUH8uQkHsd4bhzsZjXkXV1YzEH
1893	B62qopJnUq7VZHA4FvgcwN4Jy2uANe9pFE2ejSCjtW1XHtdBCdPYYZy
1762	B62qjDVQZWZi18UGcbpfveJXXDKWRLeDBoUwTE6Q7Lfzw9epEVfiQ4c
1766	B62qosgrkqtMDoDBdKrBP27nDPJWMHToUw9uF1ZyKmCv9bBSYu3Rvh2
1767	B62qnunKkg31CcASd5P97suoz2fsWyyW9udeet6Agi85ESikW9JM28q
1775	B62qjb83kxaq8QEKmCqGSPhBi4fPW6zKmgkvYj47gxzGDyDsGvX4Trm
1778	B62qpzJgthynVQcXLePPDnKBAWc196b7fforhqeHCYncafYZPTZJfik
1780	B62qjCfrQX1KAatpjFj2jAcA4QMiQ3dqJTDGehpJEe2hwts7rmtHmXk
1783	B62qrEREDKjkkLjRfSNixjLH9s4G2QjihNvV7UaMEKockXWdBmoL4Av
1793	B62qrJpTxPME5XzkveWVezqD6nnSUrSuNfDNkT7asYGUajtGPspnDU4
1797	B62qo9HaS9sGLrBedgLYptnZ832WAQPmy5rKTo6RkRyt64oRDBtxgXc
1803	B62qrv4nE63JZsDVswvwZgPqZjGU66DMXZPrGAiDFjuFrLsr5YAJw9o
1809	B62qmXxt74GSt8TDooLdApfBhAwapBTr9Tscee15Vy2WiFEe9UwgMQv
1819	B62qmp7v2GQwFwRRe5xd4rT8RMcuCbzGwRsD11yRx1DGmiMpKH7zACx
1832	B62qqKr6erPDbxSaYY4GchHRnehkjrhaew59zHnycUqu9eDygmUaw7L
1835	B62qoqDEmZYb1qgUnBj3PqxbQYtdi6EbDpyYAq6enrnYJJHGEcpAM8x
1836	B62qnw28YA69bYkQmcw1nyHHvrTEstpanBkMLjDZyjJE6x53CZ5KmUh
1850	B62qn6jGmGFYPSQa6hecPDG5BASrvdwTajzQWZiP1ay8iNymjVYBEXS
1852	B62qkeEkEfUH5NbqMN8xDMsS2ZnCGKkhNLfLuZCRhwUTwj42rGGouSK
1853	B62qjxt3swDrDtuWZHwhERtC8xtpfhAN4m6aaNZErGse5MjzREEaicM
1863	B62qrobthxZn86uChAyYHn3tQaUDLdX1ujpwvdfdchVJ3RRvkiRPFU3
1864	B62qqCQJb1BpDCttZXJ6pVsXvShp1hapzrP37XFo2kgsBzy334YC8W7
1867	B62qnB1UB959Uwoik88ioMqR2rJbR9ALLLYgfHFfU8uZr8PXGMjqvPB
1874	B62qmWdrzP4KE4PB7oj15XYpFYWKBz9KVsj33u4BBzmZDWJKvwDnAw1
1875	B62qrRaX8dHZZH7VjGf9qWVk111X9Xs7Zos2vSGU18YLzgWqqdxqXMD
1876	B62qqG5zRcjj8sSXXPvLTmvF5qsPG2rMkwpa5Lz3KpybiF4meTjLX8n
1884	B62qrSugEw55tMPKuCAoeYz1yFnnM8nHPd2tJZTMneSQBEyxosFufZh
1886	B62qkD1FnaKbN8zVvs6YZT1nxezNv7854YhqeK9YNWjV6f4K5izhjHq
1887	B62qpMuPBNuLFU7DTRzmiLY1L9PEGW32P2wiJR4vVrFySRV9pmvfQgD
1889	B62qmGL8rK6KFZGh3khrqbqcPbYeuuQ4qiZggyytSmrZdmqc1DNUe5S
1891	B62qqc3D8TNxXKi1biL8RXYx1W6aANQHcmiUWhGWcrZnyEfhsaLdTdT
1763	B62qkfkruxhtgugV6wKGnWqx9zjtHCMyyEtwRqQPSEaF11Dc6zUQuFZ
1764	B62qpUpEH7ivz61Sxo3PuTxntUNswmiHo2jwE2HvqmSVYW7q8xoStkx
1765	B62qoHXLV7QT6ezrPai2fLiS2k7eA4dDecW6hkDjXeuKdgjsTDATdNi
1768	B62qkofKBUonysS9kvTM2q42P7qR1opURprUuGjPbuuifrPyi61Paob
1770	B62qrZ1QQd2HezQ8hoD8va7Z2e1KJkc4gSsLoiBqyWGesoTrcCQeGAv
1771	B62qporxUMjspEFzM7uSJzB8PkgEPH5r9yPgyF8v4FWPBqwf96ZmkWr
1779	B62qkoE22CeueBMRBBa6BmjJwAapYsvqB5hZGdYKmQCkFxt8tWHpBK6
1781	B62qoKPWmw6VGiTrDuAmDa5KgLSu6Hw9nUuSw22zUUZJgjXwXB2UfAS
1784	B62qoMDLTNkJ1ksL9NXgKCiUkcEvyAqZb2gAbaboQX77dZrZZ6ndXg3
1785	B62qpuk4hJfkefXwaP342AFE5gztNKuLe2sZ8girbpSHHYk9bztqdrn
1786	B62qpNRrR31Z4VGxwNYBnaHsptu15GRScjFnkMcWn3s9mtb3VLt2i1b
1787	B62qn79vup42ZgTBS9jvrss1CpWQsKQdNAuq6n1eXAgBz9NfvxM2riK
1788	B62qkcoQXWTU6YBbsApX338v1Hzucu9qvKMqtzWBQnPbxoL1HQzgsto
1789	B62qrTWJaYnVq6bgvSqVFfz9hisLq7BssLGDQhwxSb618nqAuDgVQav
1791	B62qrQ4m3KNeNBsC86AW1vyXxEs32NbG2pDA2mdvCq5erxLqftVyZTj
1792	B62qkS7SKGwfD18HYw6rytEVvrDsA1N46tLeqBU54BKr2x8VDwGQktB
1794	B62qjEGSN5BUPT1x6uKJMLngzWFs4p4vZUAHnbPfgsDmg1DyWrrhLoG
1796	B62qnd1rPUp4aBpjVjCJ3XLXk64WxuM9ff3UkfZoRCkBF8vcyFnXNTs
1799	B62qm8vP6CMgBw7CCUchjQDUd1BAiyqGiSmsgDohsnoSV3YfdzPG9w9
1800	B62qpqCBExtxzfHUPkmrrfmYhXZyg3V7pSmwuxHMzTi8E6gBbopauJS
1802	B62qnryrCahSbPFYNkTDM4KJbdpm7XUkS7shFtixFjkfGvawCd9Ycma
1804	B62qmBVAArv7jDvKKcWv4dhdPrqcti4C7XUM93ThCfaHdnfemXfHYTx
1805	B62qnJjx96oDkfA4rcDog7whcyHB19XfG6yYi8fekgXge9N9m9uax6U
1806	B62qn5C7NAV32CFFdETsytiPJWDC4itnHL7CevEV4Ffn6n6ZBTZkGku
1808	B62qnH9tQe9a79hu1YxtDaSVENVznuKrgMtLfXmVdfPJhq5CJjbXFzR
1812	B62qn2nei1YkLnTQJ3N69zZj1JtHdv6LciSqAyu2Uk3vrijc2ph7RoU
1813	B62qqzuwDk78ePpqDT8AUPkpBEjPHB9EaPc6A4a1WehFSURcxnd6j8k
1814	B62qjBK5JNBudTVvXA873aCfn42oUq8HBLE2gt7QAuFx7XZN9mWt6CE
1815	B62qpT6NVZCNYnEw1pEfP18JkEvK1JUdzBF5zriH5YWXyrmdYSdQygx
1816	B62qjzJvc59DdG9ahht9rwxkEz7GedKuUMsnaVTuXFUeANKqfBeWpRE
1817	B62qkpKVXaiug9ERVE4i1CU6stjDYybvkwnrNmLGcimXXPMFT5x36h9
1820	B62qodrktQKGhyUSjkEPLJc5mADG7saxDQiPTJeJMFPUsWHRX17ysXg
1828	B62qqNgFsGp4Yi97PWweAqABovoqkEcJeDjEmHy4TufTqz3mWnwEq1t
1830	B62qrigQeBAmyaG8dWXkmMsn8irrPj3c3SKuKK4EAucQB4hc3DxzpSa
1831	B62qqQSeAh9dG1zmNQY7ngCkcDWDkGH9ykEHBDhE8B1WXexy1uq6eoZ
1833	B62qjba91UL7VitD15oyBMD2XYmTjam2FvZ6qB942xWrCDrChUscLGb
1834	B62qo9y2KRGygTVBiwwJL9VyXKQsya16hNhV5VbiYcwTnaMzvoRfZnm
1838	B62qpHPGtHAy9gFZcur2p6rpDzZVZTWjCUUhU2BFErwtsvukWLkZPhb
1839	B62qmjQw4kbwYqZSsJ1HMgw14f7vzbLaVHxUozyUjeFB3PhHYtUVtNK
1840	B62qrxD2j2XHCMdHT89XdiwnWKp1bwHwfpvZKuWXc5NiaPUuZjBUtN9
1843	B62qkPnVJoYjB6AB4hXg5LA3LDxTGJKJJfV8HZDu3SdJbzDvGUBnhDm
1844	B62qkNJPMFTJdgXDxb9YLgAvGiRSrcoU1TnQTQYKMh8wqZ2rkUynns4
1845	B62qig6vbNg3u4dXZccqrSiXiwhomUKKWcvqTnJA4ANy4aUh1Kgd99u
1846	B62qmkH2Xe7PLf77eMB6Q9UM7KAoUZUMgBosL8JsM7AMHsD4rXCo5LY
1847	B62qkDTKBQD8npu6NZ9ZQyFpqXh7ZKDgnQWzmkqygqev54NrwTSABsA
1848	B62qoQzP5tqAtqvo8n8jfa12shkWgnZ4MuYpayidabVCkKNWfcyXS8Y
1849	B62qnVcbfXr8E47LbyEJ8bYUstdSZ6W8T5aEggM3L12JbVVu4P7nBiv
1851	B62qpkai5gFEuik574QPLgo1uqmSFi6QG7gwMcXEDDsH4BrvwXv3LJy
1856	B62qrrK6nwZaCQAU2eeaTdRhp1196oRX7xTapqRd789AJ9PiRL2Ej9u
1857	B62qpgrCAbHRjU5UxmGp4VHx7NLqCN3NyNqtrwTMPDFuc9kshBmSUUf
1858	B62qnqwQ26uuk3hjG47bWnoscnfcjnRPxFnf3hWr82a8ThjvnSUWz5F
1860	B62qjP5eNaT5Sf7uuQQ2n8euirdJ6i899LMNNcBf1TRpe2gzAteQQL6
1862	B62qqQzbNa5iV3KjHZUZ5Q6xKU34Y7E7Kvb31129G8oE82zAdnTFiBq
1866	B62qkajGVuoMY9gc7wvnHhjgCab2XrCaphS5NDfCgMUkFZif6Q37EtE
1868	B62qjey4q2AVPVgyJSPvXLDpen22V85hfm8nEdcYzEzmLQLL5smbkfk
1869	B62qndsSXgFNxHojXwXjZRmzHRove9ZR52aC6joHs41BNvkf6qZhyKs
1870	B62qqKtG6JZ143hmezSJFLP7Nfrk2JnoLv5hJ6fmWBTp8VvER76ne7r
1873	B62qnHEFCMMiqsNm59WhbiFABS5AUJAD8Qa732xSfkjA3z6ZBDhCWjq
1877	B62qoQRNj6b8RzoRKDq64bFS9f4zU2WQJAMnHyabZQ3BzP8Fo5t7bQk
1878	B62qj5HQ9Vy552YqmYFGvbCeBXf1dTQ1cASDDv3VkK1cpn9eaC3K1sf
1879	B62qkXNpMFSfyonEpGLT3vSfUyc753XcD8WkqNJeCJsfNQTrV4Zn7Vy
1883	B62qkXNkRLUJj91VcFBFgCctdpgwfMXPe8fUHWDQtfL8TqRkR4TkdDT
1890	B62qpubPxC71s7XLrimmnoHcZyzdQghR6xTsPZbZmBUCXaGATHVCA5B
1892	B62qqmBYC9gsGAHL5WEmaZYY2FmW2NDkvbY6Sh7HmCitbqp3eZrGwuv
1894	B62qqyBD6cBATkdAa29tNAEJvJfkMTzwfuWyaJz6Ya3dJ76ZixfUter
1895	B62qpBn1GBBdjCXqr7cB9uKaMrRSfGzXTZypRfQzBedEW6GVvLXxzv6
1896	B62qjjsz547WMz3ikhAFuStcB2Gw1zoS4AKe2zEPa4aGCMRPqbu7PGy
1897	B62qpHGpuK62q3MvPVsDkLX41MVGwRzDX6A5ZY7NnfPraBGTL6ajPuW
1898	B62qjLBy8wdjuCiDpA9psAbyNNZWFi6Tr2UY3YSSYNpBRr3KmMq339i
1899	B62qngnfmiwKuaH2qRCCQ9wmYHXRZnrGuVwSmgVcFNCdC1FN8UwfoBm
1900	B62qq43TNomycQX3WR2v2KRU1xV2HUx5vPQVnPXonR5M5ps9SKKXEWB
1901	B62qkj4gQPZiAu9Dde1CZ7Lh3CnRaSebL9H89AaYGk6Z8reoeRCG2K3
1902	B62qo4g9i5mRxUQ5ix2vU3VW9XWvxDTazihEfuEDM2mTyztTAp4ky7j
1903	B62qn36pXrcefvtvQtX1GKMLYwHfxfUSHhLgD4gyHQ8oCsVkGCs4zjP
1904	B62qrugpkVZoUjrncghWf6inwKjKaPBoibBJQ9D7Trjpn7Uk9wGj54C
1905	B62qqoxMkEPB2c6idJs9crDb3Buezbph3xsnvm8pQyfwRKv5B5TXhoP
1906	B62qjcdMKDGdwUcEqxJtEZKTcsSBKSGAweyUfqGnGAnNNyLjPgXeUdu
1907	B62qqFJf3xdQziEJdPJV7C8rzih2C7tU9tkmvz9MfL9MaSkzkdNKLiG
1908	B62qpBWm2sCAdq7zYx6AQcRTpxgioVH3HdYzpKnnEPBg8DrEAd1kHTr
1909	B62qoS4mwVU76GavYjEd4dVvtEEa43WqwY4SqkyuHbQgtfDNYRZp9zf
1910	B62qmbjCtAeeVzTcZbBawBYMCeHhGzcApLQDc2fTu4Zu7ea3YTGhWey
1911	B62qqrUkE6hrZWRWjfxY7TrLrAmFWDsz15V8jmAAhFLk9HFbCmKyrbu
1912	B62qrrAydGEnacA9LTQfvWuowfkGMHLynKjQcA4XoU94nQ3QzrXSFtX
1913	B62qrG4BUepqBchDAxP8Ak4L2xrZeJ1vqh7Bcr9o6UZogL1YQL1rvqm
1914	B62qk9XaupQV7mfFNN7GXas7mMHza2aDM9aQ211KxuQRckprDNrw8gs
1915	B62qrfuwLpoiN31Q9fsEgokTQFZwExKCffukv15opcbBMU7cLsvik2Z
1916	B62qrFZsgoTanXgborweWdFT1AVWBqJWBGhwj7VtjwRmpmNpxCN8Y1g
1917	B62qoe629ZcWpsrAKZodNJFuqWJLqTTYkeKjAQ28TsvprKMTJwiCTWH
1918	B62qrTMQLpRPF6viYPQnD5ED7yMiX79ZEeUNovxYEdtrntNttpAZHhn
1934	B62qrrMbZwJW5Nka86Q81xwq1Tx21kcLWqqVUPwCzz4GdasN8icD4Gs
1935	B62qpMfXLyzkmkQ8wZbVqHMurvfeQ2CQCUXqofrsBqKvAzwe7Vw1uS9
1936	B62qkewMqcvUbBfrskh6wQuyz5v7SY7U7ExxxLEj59QFcfVb99UtTEi
1937	B62qmkpSUQuLUxDXqYPAXQzPozp7SMX5LcKjEcFrqzx2Adf88Nfymz1
1938	B62qrsfciLho6retD6azKM9F7ZKRwp6LbJGSmGtkewstnK5YGx24RaM
1939	B62qpu6wKspMgAx7ZvmyDPuFThSwadNNoGU94ntDEyRmoqdu1u5GdSx
1940	B62qkccaBQWRbRD7r298fWcuxQAwxtiShqRBxf6He9rXG1tgH7ydvnK
1941	B62qpmNPZ6M7pxHy6tVRkRLGU3Cj9VKPpz3dSxE7J8PSbtGsz2gV4NV
1942	B62qoURK82zFYTpX5aZ7x5LMq1FB39uuCYEmHNwiuJsYsAsLkn6XPfj
1945	B62qj3vGsgXo9LXoNEbhpoPQA6TkkTTxuL3Ly9Vz7UNQyyS61AMweyM
1946	B62qqbKy7DDf3dsDC1ynyiA8u5ua5a7rHYNPhFwNCPUonKuxHqAXM7m
1947	B62qryQ49JRAiGuGeBzU8Erzcvt9ofoZLoP2KZUVPztR7nVssJKbexj
1948	B62qn4WWaZHnG5qMoBbugs1xtEdDw8LoW89zYwiRCRXyfz8wXB2dRaN
1949	B62qqheA3p57XhNRYaKuEyhp6yNCAj3byDPuNPfFQiNkGgTX4e6iwqp
1961	B62qjE4MrihFWPiBcm77JrbrQrycNwTbV6vv9utJFiMhBktnAQY2qUL
1965	B62qquPa5qJih9fH92owVvL6hemZ8C1QLJxXFQy6NraKmo9fhx8dUxV
1980	B62qqvHJKZJwzVXhBTJyRXCLkjQxWcK1k5CmhAVJFkdTHhNxKL8kB7k
1987	B62qpfwHyejtpn5bXsmaqULj86bJYeR7PzvTcrPRjhNc1auMNCzQJHQ
1989	B62qkABXQgQAEvhVmwBwvxzr4ADn9yi3qSGoyHGSXYDLjJuwQLLQ6NM
1993	B62qmK5tj7VajoTdnbh2TMnaiEzPRbdM8BaXyErsBE92WFvRdanncsX
1994	B62qoSsdGFSqkftRo2irr99jWhWUd3k3rixehWtHayL8TGPM4cqaFxr
1995	B62qpvsSnPVqGLX77eVhgRPaEzpk7YB2DDDsyMDAXsWhREbjS64HJp7
1996	B62qmdn3TBoKG3jjkEsokTUTyQG9sWc9fvZZH83irqrfeshbwsDAxUo
1997	B62qn3iManEM84G4sKRoDUS5Faqgrg4rvL8jRAqxz1kmPKqpdzpa1oN
2009	B62qmJZD44acynLzxERnhUkbVjFXSqphiRfT6tUwfACYCaCw1xhqoBH
2013	B62qooMGsVDpjLtJEawrogEkxenNsg6pgnE872ZEeJfz1yYMSJtVASX
2015	B62qji6Y4EEwd2LpyEpmrANFMYVqowux2P35e83V7P9wbkVZAYKN6RD
2016	B62qkEAGKnmev6yy9DEUg1S5WQ7XimLFK5yn24b4NfNMfarBry7hCKm
2018	B62qjR2B9KB8pXNcQBAq9cgHFeuwwvMT7tA2d3K8WEUrktJccU6C7Qt
2019	B62qnr7H3fB4CvQdJd2XrLDNL8nea74GuX1wwnkwaSt2PawxBk5pSyk
2020	B62qo9WtYp8aEPUeDiyE74QjFTPRueMCeRdaY7eDzXYcQ5JjNA5QLgx
2022	B62qpnMwuYfQ49BdvQYKaoZJ6B5iLT5SNj3cK9uZvLchk1mK6wnAj1B
2025	B62qkoam4EsvkuG1dm4tr3AbcWnQ12i63LXRMUvSGcXmHG5zB4H7H2J
2026	B62qpDqowv1aNpxoWxQvUCQJbrSctBTWyKzFHYAonMB993WtK9voDvb
2030	B62qnXJ6tkvQzBYar2V9ovEqSroHuaVHFdkGVHXz4rXiLHyDRFPSaLS
2032	B62qkzPdsWdPETD3PCg1TEK3GpLeHgAoi4Lz2w3oVLUeaTsmGvBLyL5
2044	B62qqD9f8CGy5QeFj1h3nsit3Zp2GDBntjEoVCdfj4SPQuubRW1CYXp
2048	B62qqEXqn2eREKY1748DNKoZdxNrsWAzfcTKArL1QDeuemPrEdifD2r
2050	B62qkX35WJrsGRxD7t6Ut77nth5GFbS9uRaRexWTJjapuxxg2EgZ56R
2057	B62qrNkW23Q3KeiyPDNiyZaZ16FYhg4zmNSvS7zGNzoQ4Fju6hPtFGi
2059	B62qmDpDKCpx2R2bkyCFuBymXTmwss77ejQ9DF7oN1EirAanR2R5pmt
2080	B62qj6sBguZEc5xeNwuQYfHMe3sLav4xNhpxuczSkwGZRgRT9mHwG5J
2081	B62qqgYzT67iGyBudDH5V8w8GowkYG5hjgRdW6xWb4eTyQnTDJQbQJY
2093	B62qpaBQWvAM1AtLABPk6vd7Mf2rHVmdvbA4eVnwenekna99GcTvASN
2094	B62qrziEvMYiHFbNwDdGN6pdDMQi3gRsS7UzztfFUScFrCAhv39g9jB
2098	B62qmnwtz1MHzqLiPgvtTFDeZUAQY433dcz6Fr28BsyxH43BDjg6xki
2100	B62qo796MaenhLn93Mie4mX2LsWheqU8H8DjuWwDt4HHrN62BP9ZEWx
2101	B62qq9TYt22XUS9xHz1pJLyzxpSEbnMCqWgDsLBPA173hg8cvix23UW
2102	B62qrGjLR3RJJEr47shf6rHYPFmmLDqxCvhdBBR3GwSRpoQdQ3nNzM2
2108	B62qqe8M6mPEytJ1t8QKUwR4TnbeNBzB8NY3m3AniDDjiSEhBQW4oUq
2109	B62qrtWfgE7HwWRV8AYNKmMUbjywdQ2Mb76T4wmE5UjsnaPBx9F17t8
2110	B62qpUeFzDgvq2LX4ucHwqLjwBBAWzy2gK5a2BSLF9oAfCTBazW2Mwm
2127	B62qmuSSAvuMuTD59BaTuco7MgpDsCaA37Tui2cL6fMhFsA1YqsxtDS
2128	B62qrdvbJHZw6XSseuwzjRuaSUsmRdm6nvtY5nmZafGU6PRw3VyAKB9
2130	B62qox1MBZiBD59GtFV4HhbKmzhENBH3wRiux3FVAXSXgKjWFXzt4Za
2132	B62qqZei3kq718y2yUsJz5CUsJs1cj96DUV3kM2XPYvhQG6dcEe7jZ1
2133	B62qktYjLR4e9YBeC1LYF2S67g1sxyquh51q13tLuaJTHNxQ5MCs7U6
2134	B62qmMypEDCchUgPD6RU99gVKXJcY46urKdjbFmG5cYtaVpfKysXTz6
1919	B62qm7A25Dq4UQUtcXK1YntH4THoANVbW3NxnubqqmUnDd9riBPreD7
1920	B62qrnTQ7kMaZaVzbsPHmXC1EvT9gfK7qVaaDdsfzieMBtAoJrtMJWW
1921	B62qkkHEer6Je9Te9xQao6d6egM7foGG3NCzysBW4wCUrZNbagDtJrN
1922	B62qqUMmVp1B33YwWcifDGs7fScgU1AKmE9FoikxFeWzctr9ihVUq4o
1923	B62qjq4PiAu73qvvposB9zBtDdkv6k56yeUrTVvgHBifWp2SQBhu7J3
1933	B62qpn3hY83x3acuJ4XTFqZmbYfAim76AXjfduxbrn1uEJv8YGafNz2
1953	B62qpVNZuJkijxcHLbRnwSYv4SZUYRT1HbgzKTRLK2Mk59mZe4MBfeC
1954	B62qoEDUZkBVq4K5YMJU1HRMmTwFc7d1E3KAeX9cmhxMRq6LBmmUMXm
1955	B62qofqwVRXFsHc3qw6n5sMQuukS8fatHXQDoqdopqS2vfS9NeWoWjs
1956	B62qmak9tRyrRdmGssZPuEAnk1YjhrhQW4KSLUbhVmeyzBdkrdhdYNV
1957	B62qkoh7Qx6gKffrRoEWtbTFHDxs4DkJruykA8DP2fYNLZsRWGFenaJ
1964	B62qnzEf9uy89SQwquaNJDQQKKfnwVGMbtrDajie8fiNxeVzgmVHWMT
1969	B62qjie4x6xnW7Hv4xqMQeP1kZEGdjb2zpuu9LVNduXWLuhfZMftWLb
1972	B62qmt4SqMXTa21iWkxfgy2Dd89HSWTkWpdRzWNrUPLQTCBbxtdhw9X
1973	B62qqEd5LmnmtnG76c1GNFW1cHZFqF3VGMe6yGMFG2UggaNoZCTEf75
1982	B62qqgycUT6vSgvqzobVeqfqdcscw9QRbY9gaa538sLSaJKEBceKziZ
1983	B62qnACQSm22JU9bGNcp8JBUt2cGrMLTgn4pitFjGTHJ4WztLpNH1gX
1985	B62qrup3K6XXvHC46n6FdHmhUNJL5qL6MztSMFNptCE2VUCpG7ca2jr
1991	B62qiUYSjLkQuvgouQ1HarLdtBLvwtoueTZvRWP3hm7UDjvryWJydb8
1992	B62qiVr4Wy6yKhxNV49Npnpr2XF5AhsFejFWWQpWKARQpTYsb9snNZY
1998	B62qizhhKAoUxDtcLaR3QkhvPx4UPS1Ez9TDh5KRFins7Q7ZpNZ7rra
1999	B62qnG63BqGxWVvypQ1tDVXEfF9G8rQFKM813qMGmKJBBhi6ie12Zbi
2004	B62qp347ak7H6T1PvZB1s6YPsLLFTUjQ8McwSS4mQxLRLfxAzAt9rhD
2005	B62qogajGaGkDG9PCJj2LZkS5QEGKK1f33ZiNwhDXXGJB5Mg7c9ToCq
2008	B62qpNa9hPxoQpEpzNDmCSef492jfh2epfzps8NSHafDpQLHwCSTwae
2014	B62qoTA6zhHaxeEfKDTLWLbotcKzDR1186KemeAvFs99TjchvcXCRQJ
2021	B62qryLSdV89jBnpGKu7ZAYJuy4rMcWis6QQsoXMi17tnnR5jrvr7U7
2024	B62qjEXVmh3ZKzqc4Va8iLP9YWV1HFc2Bs9fjFCrxZm1Xvtc1eygHAk
2027	B62qnHzAUSe9gogqvj9YcmEtc6v3VrLWCMqKe9kSsfFeXbuPVkGp2zU
2031	B62qnPoTgjcTShzWpHHKWitN6XNroMYuim9QPujJB4zJDCrmwR3MkRU
2034	B62qrdb7SBs3BtZRQcb76ZseASgq4nVCQofJg6FCYfEd98yLvCJ86zs
2035	B62qpNGqChEZYrfDin4vbATAWSQwr8DsRiUSmSNg7jPTPTZXz5GcQLa
2037	B62qmFZntkkSapm3aM4jBgVJuwEG76gNm9izY72RMJ4sE1KZwEJHoTR
2038	B62qkobcfsQdmH5WGXtW3MrwXxmUoexUNidydR1Vpuz6jTzNL5QQ2Ev
2039	B62qjEYFz2EZ8taPdTx597U9dpCfEha6WgTQwUqwN45NrmRoiXrYvrp
2040	B62qnSqMtngvR8yjgNq3hnjwhYPCyDSQysSg1gWW9jAAhcWT3gQwXiC
2043	B62qmLU6FSaYw9VapsQvUt2pbwxiq8NGudTVHP9CEy412timPW7pxgn
2045	B62qotyJNayfi1ohMVQCgmLtutq46oMVzKFW59FVjrABqDRoeA13bG1
2047	B62qjRSQFmCe9oNUPXLBWmkQw7XGdT7xSQnjdno3b17F7LigPNtBBPL
2049	B62qmPbC1i8Z95gJoeETYggkXwMWAnszMV8kSFUNUkGE74hqJaN8ahK
2054	B62qnGEY6nV4JWKQoiGPtNVNEjoceWD5JRGJge2Dtu5pLmW87RLKzuR
2058	B62qismRE8v8sPKR8hPSUzdyHLwXu1nCXZuGuWDWsbb6ZDxMLWAAnnk
2063	B62qk9Vxn44SnxpEh9AnNjBHoarVBb53mCjZq8goiqWRqU4gWJ19qYF
2068	B62qmuke2gkU8hTpm9wst35hngu3pJoyjj9FUCGh2rH54dLXS3gfbPE
2073	B62qj5pJ7ZLKauDhhviYNpV8B6BpmZ3a9mXBjZMVJNNsQy3rpmnudoN
2075	B62qkBLr1DPC5bv9P2HKaewmekeT5TFA96dcLf5SMe3iL8rTNe9kKBN
2076	B62qkAJ1fTysBUA7ZDkCn11H1Uj5yRwqK9SyQkrPrX7egeKzWVT9VbK
2079	B62qn5cKTSSG3X3BMa6xXnQKxmg4kNnR34m3bAWAgtBimwus1uj1TJY
2082	B62qn2H9WhvP2K6EhknZmceV2ZUUyFxbEgDJ4QcJVMKgd8UGCac6b6W
2096	B62qrGteNDjBoYqjwXdJpcUBuL4grFjMRtEbhe3EbhAbnzeDW8jjsMh
2097	B62qjWaGC8zauCVcwvBdzm8wwNrr8t5wxT1r1MXxGi2pq7gUGDwrX7n
2103	B62qn1tpEukmcedsD8G7sV9nK87PHjhBYNR2VsFQ8VTxxJqQofPD2i5
2104	B62qou8aK1NJ9y3hsFhuHq4BEcUsLr3SmoBfuB647gnrhEQH9njbgky
2106	B62qnp23m2yBji2kY8zwH1AGRT8ofdWGM5JYgJXbLB7JJgWNRQ8GnpZ
2119	B62qjrNteTPA2h225Zos7Xr1z8SXBf9GdtTh8NSHZiT24a6YpH2zL91
2123	B62qoAQaeZwpJkyKpZqUFtkqqBLJqkLHvB1A7TUcbDfMp59A2KhE1Nb
2131	B62qja8uuDLumKoP12KJMt9pLJFkiyhXP19iGqkX2ByDDgg1krjusAs
1924	B62qmpXjgcCjKesRueXkM7KsiZNQWDop6LrD37TTQKm44REz8ZuYQsJ
1926	B62qjGXKTmoJGPPZuzYDzJwzdkjeFN8LvWRVKdEiMAGP4UoWYRs7AZx
1928	B62qo4YTTEW25FunXQbgspAe8ppysEnRPzwwKioTy3Bwvqct3sVb8gZ
1930	B62qnb3213nABUCcMzbAxA1o8Hvdim9eWTvj3HFM946cosm56JPFDar
1931	B62qoSW4roeBDPxBSuuK3JjcZCtiaaF5ZQyVNsK2MJ6c64PhbqMuJys
1943	B62qoU3xZa6dzUijFNGWoHnwFXoVtaWHAobbVcbYQLNCp17qqZNSiFq
1944	B62qnvdzEyZgN6HpzeP26fWi2zZXwkULG4suepuwvoNuWzW3Y5u28Ud
1952	B62qo5HSvcyaQTDUBQn7tdLMkqBXQHUkzH9aSV6aUK1YFXXe7ETuMGK
1966	B62qibgmLHgsNEkSnkUUKL2nNDmwq5oF8e6gn52m66XJRbFgqPf2r6S
1967	B62qoV3nXK5krEh4stzpR28YGwrQrJov8WsxAMXGiS1s9hKjqJs2FtP
1974	B62qrwpHTcLUq9epwFLbhu45hUjy7wjSjkwqcXuChbyGSBtHu5Ah5GY
1975	B62qrZc6nnhU1vq3uA5xHpzfBhkDdirPXvgHPqL8mAa8DreziWgh98k
1976	B62qnfgwdc2HDBeK6TFkwvvypCAb7vjCChj5YZJERUBGmkdHn6rFgpb
1979	B62qmW9rZ4wKXuCq4T55CYUviTqYZC7kTWJ6bfxo8YQC8ASuohr4caU
1984	B62qoUFfpadvrXWqmb7EjZpaGt6XsQySA8WkjcbUXwR2vb3JJbJsv7g
1988	B62qpGd5NJe6oLytAypn6gWD5rxeB4TCatLdDfD4k8KQN8NAD1huzMp
1990	B62qoSgA8gPSbooD4BBWXe1hNes7LWBzFVz5ksnU7nWQpiDJ5SaBgAY
2000	B62qnD3BjmwCYg7aeFqBmxSTdg9VA9zFttCMNxfPUEiEfKmgTNqRZxs
2001	B62qqJPhfmmwq41ydS8AvyNJtirRStnK2AppHykgHXYKpizWMeJb4f9
2002	B62qmikeLyqKvHcLwD5ZqwpcnmaX9cAjQuX5iZwZ5xjJpAsNHibcRyB
2003	B62qiefFsu75RVCL8cBjz1iq8d1p5X1wbX8iddmEUsq9UwuDrimPuo5
2006	B62qnEn8w41jaBHwVnQe5dK56L3VH7jLp7oUXFwHxuQvBpKEFmqmv8v
2007	B62qk63gVpxBwMHDmMqJ6aNnN1btL8XU9SucD7zZjA9MVVykMXwpn9D
2011	B62qk72JPz6sXmA8k2R4An2hmC58mUHSq5tmkGy5HLUEurYXM8FZy47
2012	B62qr379zCS1AxEPZbovr7kcGsURqAKqEfpfgF275NNi5WHozWUMFRG
2023	B62qiU9KxfA1LpeLUSckw9Z46RWx5JcxkxkHTUosthJCYuyCJknXVBR
2028	B62qp8qsUVcMwz1xYWh1Ed68MwQVq669CQR288Br7Cv2o3xki3XnPdN
2029	B62qovXrgzCnqtSSLHQ5C8mjyX4gMTkRj45cRjB1osQ3KUq8UHpC8hc
2036	B62qowcWy4KA4iXTMMssHRwS2zBRV4eBsoqi5Yii2mJEKcoPbp9UWiJ
2041	B62qmshRuMHKN7Pf4AMppVbh9SzM8Y7qS95wvAtboneoPjDtgehn33f
2042	B62qmEgXFbK4YS4aAwkNPLgTQMh8HgTMfoMnyXteqfJwRTJk39H4ucz
2046	B62qmka1W5zy7uskyz8UN6B3gvg1pyhX2muSKKVFHGJSn2KSj2KnJuC
2051	B62qkZz3sLuNCNGmAsYLFgs2sxWXFiaunVpM7tgEoaqRjFfrxPJZe63
2052	B62qmxpfA5po66zgUYngBEipPsg8nkQ4HjF7frrJWwUEEuNCq8TTNSd
2053	B62qjyaV1qV1WSqPcvAkFhydLWgmNb4mDqC6DTAwAACRNha7tsMpuEQ
2055	B62qoNRSJwu7D7ZySo4WRbgdqay6mD1B5RyyF5czsdbC23DuU34aFZA
2056	B62qiimxmkKhYAjw3vWUJMxbDyrfT6hiqWY27fgTzatL51wW84tKuzr
2060	B62qjNK63FYijC9cgrBipgMFXMzM3gSJxc4VJ3powsLXFCW6o7vGfFf
2061	B62qmKqDRmbie4VYe7YhezcBcwo4RZDk7Q7eUVe5jK2LXVTKXMQuvTr
2066	B62qpzgkFRzpjhU3EESLYJZ9vX4YM8FXgbkv2sZvJRs1uqSvjn2ffnU
2067	B62qmStQMUHCTiCKuj265mXu3ijynY8Fc2EvD4ZgK69Qr5rXziRq8wv
2069	B62qmP4BesZatttcQcFJzSQbmZLt8JYwh3wV4ZTVYN3ukGFSPgvNSK2
2070	B62qig6zfSb1NuyHkhaMT7UDhddiRoY8boizZzSXcnNzYCP5vvddthA
2071	B62qr6bD1BcXTePnEgGQNybTgS842xRCV44FuqvktDo85Enj7AvBVQT
2072	B62qnTd3svLTn2PtUqyLacFLowZHqhDNCuLnAGCnGxHRA5gDZsw3uuA
2074	B62qjHEuNn6pN5BEzQkGddZxExGqRisRc9A7GindNrFXUE4A8yD7tfL
2078	B62qnVc2wA9CWnragB64ztC3tjSt26CVUmZVVyhvqnNEsLza1Esd8KD
2084	B62qmtukMUNYtYpRPf5PDz2KjVhkLrXNK19YHWMSeRH5DReKyBt6GiA
2086	B62qinpqDF7ongjhpvJLz7QBsExP1BkpceED6GuThYYbSVSbk1nWCvh
2088	B62qjsWBkTwH1yXwjJ4M2KBRuu4aF3phSmTg4MnavyjrV2sRvzHNbC4
2089	B62qkBrcTbf7KRPf5R37waqVxN84Liia4u2uhDDvrJhVvpkFCurXSpb
2090	B62qraUTTo6Wdjgkg5RNLo5AJ7dPbjgJqXGKJaDnxm3BszrhspCDM1q
2092	B62qnimiorrnmwjAfVQZGW6xAeN8M7HPb5Ucxq9rFnUhy32B6Qztayt
2099	B62qmm9xRxV5cui2pWU1dj4NttGkcMdPNvPcUbRDnbqUCF8fG9WYVoZ
2105	B62qjPRhYDRwTbSwUHpQovZBwNK7FG377xSinoeJDkNByKC19z2Yfj5
2113	B62qkWGRm7hdwLb2UhDksGhKuKvumN7oVVNDC7QdRHDeAQftXGaNpzS
2115	B62qmijyoDUqSGdovtao1mes7XzctDs1g2FedJAPQy2VdL4j1eyHAR9
2116	B62qpScK28kE2CfNgwYQAC4MDKFxVBNxK9SfoDDBdTTwtvt6MCXq3m9
2118	B62qkSBhAfNNgJS8NJtbGjnqH17SC7zXyUFJivM8BCDscwRx94JMb8P
2120	B62qoxkZwL6MMq8SpVicdA587f9F6kaKrjrDzV8Vo6Fcjk6tyc6ybR7
2121	B62qkWc6dWa6bYmYStMgZ9c9DXAovikTBgJmScC9y7ymUr6GY3ucJDq
2122	B62qpygpgtwwihqinfPjLMC3u6WzRAZR2JPHwjz8zWy4kXKRmi3o7rU
2129	B62qqA6TsQdKBNpyS2mkAb19eSFf4qmkEaxxK4KayenFW1sCvyYfr9G
1925	B62qmjKfsyWRNVrvDzsfVxXiPRvv5vTQTs7Ym7BACgJB1uHn6MRxpr7
1927	B62qq2Cstm71ZXgurrEkiRsebH8K2ftZhLsxDEULSFEw33kfJVC6mhU
1929	B62qouoMhfitj2CAtg8RZG848bVYoVxpsVrx8yHjjvfUpxveo6rx3Jk
1932	B62qkkAJBhcL3wtXVAEkKj6JiHxzqDYGgM324gxRHrsqb2HeDuSw42y
1950	B62qjt5GzHKrNZNx5gNBn9ebrAhHRQ62BmwvS5BvcLRUb2R1zqch28s
1951	B62qmRtGaa4HisAfEhqRTbjcqDu9jV3cmhXtNyZoWc4vtLkUygc8mm3
1958	B62qnwwPAcDA9TLcjVLoyCcGmf7tWgfRrFk1TTC4YWJJsNQymNEEZ1s
1959	B62qkWFmcKbDwNM35ZRphHJjSBU98jUuWApXc34h6YueWkjADub7cRq
1960	B62qiYvhok9dD1yXQXcmVPZZ8LjB8jrh6WNoWrVBtubcMSXN5Kas8KN
1962	B62qmPxdtJAufkMVG5xtNNmkrFoLH4Z1P3itV1SBAGXHnHexgozX4bi
1963	B62qqWQ1NLEPPP6j2evUrV2CdQfDipB83doTtJVGR4HvLtrCKa2zA2f
1968	B62qrgdoYb6pXJbj5Y1vvuaubjrBge8MVWThQ9VywNMLPF2SehUG9kK
1970	B62qpuj3Gd7ttM7VD73phKsHydNtDEVJBzGzZNcBMDvp84jHhxHE4T2
1971	B62qqUNeSat3jkC6WNoRFKsHNtM14VcuZdrDXVSV3xozDyxgasL6xD6
1977	B62qrjHvWTkktmM645tMtc5NSFcxuVWRSpZRmAXNkSJdHDvTsR92cxG
1978	B62qoBpxByoHrq8v1SecYeDPpRRVF7LwQ8j1F3HwAdWtaT9udkCiwcC
1981	B62qrzbn423zHjKxhrmEyQtFtprG2XdVtsjsJ8atCvb9eqQYy8iz6hu
1986	B62qidMZyFso15bt7Bat5uhfwbwG3cagF7JRwGkN7oRBDSeyRnGJwDq
2010	B62qkvFDisGQD4nJsVRxLbHngnBcQ9Qet4HNZQRH2etUyCNDJ1Mg8SJ
2017	B62qpDBqtnDJT3jaC18ih7SZgbQ3BhNZ2CNg4b4fr2viLuGua3Y6ix6
2033	B62qkJUNzzm4e4ieRMQqmbRPU8qTxidjzNKJppAqsJshUDbUBPUd9SB
2062	B62qo3SDY3KAFkecdu2FE6ir7D4Nuaf4B4iz7RF8tfKJCwia2c7EpXf
2064	B62qnjpQq2uPKSsRJU4ivYYvECnY2RbkSDVsoKJn9nFkq2YPu7XazHg
2065	B62qk6saEVVccC1MfuiyGdzDoEzPHcnKc3LFNzBimaUn3JN2PuUHFnC
2077	B62qqAvmj969gumuo2tWQpBfZwkASi6Wchgi4E2WL8zv1qYEeCtmiq2
2083	B62qo1QzHKFpUkNQoBhovazgHM1D9wVSj6jJB8RwPMsidvK9b4NBnW6
2085	B62qj8wH9YcKdzHu6NXbZpWqyZrYKYGeATh5o2UFZxC45KNYcTMvNoY
2087	B62qqyZ86GsrRV96xuiStZhJW5D9fzFZvasE6aAToRH8PP2bU2TsM8V
2091	B62qkLUBPK5T7D7xWDR1Eu1m4iv1MzfTRN2tu9WZpWhTvSt6uM1ZNha
2095	B62qm4ADTv1iCFMjqAbfWKj5FzThonbsEZ1riZSwqGhAyYjZzFUrZAt
2107	B62qjDdy6otVScKCVycDuRmZDvkgZyt9iG9BFtESSdKDQF5MeeeDgJX
2111	B62qnWWPzcaTPSL8fwMpDZtUohVS6RX4k9FaC51RX5xE9NSeXd5VkMr
2112	B62qkVqyeRwAPfRTRTUTPTvVjP9EgAz9rHA7bP4RcagiurDDi2hsFic
2114	B62qqPQUBA3aWsHcvnFuMbFuecrvvtgBgGLnQ26HhB4QieYRSzx5Q6o
2117	B62qqMiasKjbhhHWSPEQxBsP3M7JoUKocmNzKDsykYMckw2SwKycsc8
2124	B62qiVYm2txgD9nVXbUF5UAw7USSMdbgiwUCAgzTW3xkC6q62E5wCHd
2125	B62qipDBP1XqNb6Ca8KZzx72M51Ge73RFUwj2mdo2CzMs22gYM8ivo3
2126	B62qjYAdgiAp92xRDbR9r8hyddzYZ3t9D2aYfpoUdUCP6LLKG1Dp3BQ
2135	B62qpA8s9wbazMmXGFENyR952kKgCofTGG6QX584Je55A5QrpqPaahW
2136	B62qq9t2nqDfUNL2xUjXpVDQjrf8DHJ2wbRm6Ndn7ALEZeJph2HRyDq
2137	B62qnheJMP5HNzgyfmRksyomeXRzewaxzrFyoUXAESdbdJEuLDBcVdA
2138	B62qiUby6BGwWhLJbGvA2iGy8MP74G8zmFEMSTg3U1gn5Rs1bqYAyJd
2139	B62qmT4iat1MoEWS6jmDrJmZJE9qx3KEXyMzxdx7gwUUHHh2N59qPev
2140	B62qpvkY4ynRcGpa8vs4zHJ7eRD5DDiSBkdmuTcXmJSGjxrJBeABqNm
2141	B62qkkmizJFb6LnN4g9zHHj6ftjptA58oo5iogPz7dyiB2WS8i1ucf8
2142	B62qqCJP2ktY8bZUFr7bRoT2kDpnEPRxuCHaQ9Vqxx1VitXSojH9Fj5
2143	B62qm8ZLQtkMw6k3fATYWaFjeQeie1sY6k2fpqzGpNP1VymSrdysWwm
2144	B62qqfJoY4TdtG6L7TdYXHjTZQwxpLEc6snrkEmdzCXGNViUJpdWG4P
2145	B62qpgsBxnNsiEPAArCNV97SMaFa8C8iEUXzcia2wLfy39j94N4jez2
2146	B62qrkNMmZnBHYhbiRxS8NpwKyo7NH51NC2R1uv1ecWdNRbzys3mQQi
2147	B62qkSLiTdjcqtcrdnKjNF8oTAVnnodQc4PhWmdQ2xu9CYaZDMmE5RD
2148	B62qrLfafrjfvBuGngrJj689ZwuxWHXfTcq6URME9jScxGbZer6ChpN
2149	B62qn9Av22qKuvvksYE2jyMeaUNZtMwd8aodPhwCurJoiz5n1daioQ5
2150	B62qjmbfc7d9NwTnefuPuQ2YP4F7xNoEc6bx7p96FzHuWQ4SrWD1Jqz
2151	B62qptdTu4AQFhgMa4T86bhaFUa9QvLARf5MA3BJRmmZqw7nKXBhAsh
2152	B62qrGxAKDzSoVRTDfq5KBPwaUfoxmzFKVUpWhx1K1ZkaVC972LLqQY
2153	B62qrcQDeAfg2qSnZhdF8wQ78G9QmKNDqpESVt2SL43F97kF3Cyv32a
2154	B62qqndeyJZupbkDyGiBevauyjysafEJimAyFB4Mn8D1N12seKs2LQB
2155	B62qrHykZSUQaQrDz7t2xsWMzSPzKuXNSM7BeVDi9xTnHx96bEPDFTF
2156	B62qitwBaAcXeytS5kMCW5HeDx6BgAYaz7NKRHZeL9ozWTTGBFN1MTo
2157	B62qmYgRXPrwWmtPDBHX4RMtQfuaieKJCb6LonwHZz7WgdhrwTsQiiZ
2158	B62qkVMUsmXF5LVdRQ2CsUgH4GWLDQuPH1gycL1dGHgzkfHLZ3wQBxW
2159	B62qrt6SHwxc1Lr8nkvtRfC7NJ5YFmtbNm1kp2WPbQ8y9PnXMUMkJt2
2160	B62qmi8GmU1vYkjgRjqgsd2NC7cNv63HD5FQ3VdYAMDPcCE835vhmS6
2161	B62qmm6F7tdRg17rVLxpRUZFGThAWFZNYVaeX5uu2pyME2YLbb61zEA
2162	B62qihX4MsXbU1er3fu8EWqbyLBccgropv2kQPtWgLRNpn55t8m5QEa
2163	B62qjZBFstncJwSJ15HQZXfY9agDMs2uWiFo9dATRBYWVGm4ffJ7MRE
2164	B62qkd36WgsePzNcxN5dnkdpupB8H7BvfnZ7XMyGgWEBHVYdHcNYeb6
2165	B62qjNxZ9Lqe3BdZxtCD8rFzRwkiw2SG2qpBteVkeij1VEEbiLHhoHJ
2166	B62qosYKGkVbE7oDMgLHr4qSEB7nzYHoLLmuP6jBKSFjPCuJvUxTFPF
2167	B62qisZkjVZyMm4fkqxVmDRGEjzNjdekVZG7QwrHCZMSo6KmaiochhU
2168	B62qnED25tUNWUkPtDFjZCkUcRw84a8B6zWagk9Na1kyJXZe9YKuvoj
2169	B62qo69iKxuRHiJHnBH648VdvPWs65z9jxg7AQfKKB3MFWAxtsiPUqe
2170	B62qnUuajcSR1W7XDUR1SqGTXN7ZkdSRpSgXCHFJKjwdFfoy6BiKVNh
2171	B62qrokRxhF4D2U69eP1qnQhFsxSw7YR29KgmSJXeFXF1PnDjoEzCgZ
2172	B62qneTvRN68XUGgsAQnXM1PCiUFV3iJkbcAnszmLKPBHxk85DD5ryp
2173	B62qkJuYFFQbGHbXjKYArNRV6MW893K5gmHP1nLarX3FQVp4rA9u2GZ
2174	B62qq63ipcgNiwTq276qynfR84uEc9KvMVjbgJDNjtdgwJtE5qXxmp4
2175	B62qnCVS46VTez1mbVcwCZ33zvEpuodQT3YGV5qf6zXQg4PhtxPyRUQ
2176	B62qnJ1qU15ySPogWTQnT9WJpTxAuSs4tQvaYxhYfNiVrFuo8VgYXb9
2177	B62qnhqVYSaejVP3jYjcFuS8b9FTXeV471XRdbwteb461YvVSpEndTV
2178	B62qpMDo4uU7eJ9maN6exARcHq81oXRBJPPNNFxWN2Hh2Khz2GRZafJ
2179	B62qq59mQV7QPq7QE9hrbdd46kSVciT2otWjfA7vgQiFf3WdKCqwFaY
2180	B62qmaGsWHvxnFDEX3p1eTNetLhRCXgVVmjYjShjsnQjsjipGTZufYK
2181	B62qq7jDazmvSkXj8WWsoW2tg7fMm1zwZXKnNEmMd9qZ4t7nC7YGKcK
2182	B62qmPPaY3aJ5gu4WFzo8G1Gt1aEFWreEq6PcbVzCmch6VAxrWEg2tG
2183	B62qrDtE96Epe5MWiy4uCbNhFCg2cAnKn6HfjsdBXMVDnwCZzkses7r
2184	B62qqSambmB1K4mBW4HKUHQb9e76ipgfMWGqWMA1MVQS2M7tcX1uxsD
2185	B62qmLaTYw79BfY4b5627AxxSqWF4XiRzupEmF9mnfzmBwpwcPE1wSz
2189	B62qmiX2avSMaNqpbE8t1xXHHjLo5EeKDJFNhWduwSZKZ8Ei3uBWrjJ
2199	B62qmXA85uRv9D24vKPnw56cBE8LMGYP1WqoEG5CidXUfFBjkQp8YnQ
2226	B62qmRqAfYV7tUuTDPaPXN8ETtvkWQ3Syqo3bWfsS6utqXdhiLpb9eN
2233	B62qk1TjuW9PjMFf1D4Wj6EsYJmZgtmN3ndQrjvFSmr7YMRmULPV8Em
2237	B62qjSckZssZ9iFJdTm8KJwco91xysqrmwcMibaQu895719sdLT6kcw
2245	B62qrdz9hmv8ACy5NKxn3RBa7vnHZsx8QE6x283GVJRU6YXZiskMdnv
2247	B62qjuURfaLA3oFjSyBooqC1hHQ2PKMBTrYAvhodP3z4vKCfWqXiXtJ
2254	B62qroBzE5d6ZiTu9zCmfHQjbcTyX4SSgAfthhbY2JP58zDVhewfe6u
2255	B62qnc7PeQ5DSthQ2wiYiwtHJDNsTbqg7tVnp7JmvqkrX9Cx3kqhqtp
2256	B62qkUCzCdJzVjQYgBcuzSDbiQkSidXc1axn6TGvRFzhCR1bSeYfkUn
2266	B62qoShNTJW5AsjAc94XHxVGxY4Lii1uTpMvqxdM5nESU6iWkUwWh74
2269	B62qk3SZheQgsdB5Xs163ZeZeNjPGThpbRrtrGNdJRgf9RjwHiP747u
2271	B62qoWwgjebeJNjUuGLhqkswcGA2rLqSjj1ASMYro9PyQrvpA4gWCxe
2275	B62qns6oZnK76hKoTAqbh8WJ8RCaHtJm3LHwJM9PqhVEThwzMsxV1yM
2276	B62qrqpudFHnGhopUVL9m8n7L2MSmfeRCqV5XfWCNpomB1MmS9NWz6b
2277	B62qrQbqbGoX8QaCZtcmFshf818gfk5Bha8vDmkMjv5PpG374HqM3JV
2278	B62qnpTQgwEU3Qn3x5ZgTw1kmXVo6PfyYQZ7iWaehf6jkjY12biyKfD
2279	B62qnJqYbFyZTyE2t89ZCvDA4zcJfk2TAA8gh7QvPNYcN7eEc4zokNr
2291	B62qpoqQHEwyrUrwXjNH4ifPWkzUsidnSaLedqhUtDrkqAsVqnw25qV
2293	B62qkFjfsbLKvmUB2uiXjdKdibs8gPHXQ2boLU4UGLwBmXwoch6mhRD
2294	B62qoEXhyrQGiQRJszxVbK19hKFM4HpAJVMdt6jN9j5CPvCSozv7iXt
2296	B62qqzCefTDcN1AnCrLiEzGD21s6E6pdFrexbjXfuinQTrwCgb5gAy1
2302	B62qkx12qeftf2VCKUKobwJAXpXBbrJSHWJicVs12oMuuwQprK1PNL5
2304	B62qkqrdXNejArVW6ZUEZRUhUxAEMoMeGJLdjzSEDdmvitktc4ZdkBG
2309	B62qjj1M1JdKHyrbTj6Fk2BhG1SpLnBbaKfiQMTRPR5FSxhNT1LLUCK
2311	B62qkkPvTLfyypaVtMNGCiUVfL3Dx2VSZh9R9skGLSDX21yiPBWsX9G
2321	B62qogaPmwzwr3fzD3zd5ikSFTu9Ri1C4nR9PYD4u7DS7CLiT7wwQqN
2322	B62qip1McakBSHpgQt3XbJtT7JqFJ94JgZmtPq4Uprm8mXE6xSDKLg3
2323	B62qoGuvwCnAfSYKpbBWF6MSoHgJ1K1SDa1Jz5t8AmhUWbsCwTUwjiE
2324	B62qqy6iDbg9SR7NhR8Ur7RqyzvUJDyhDbtCkA3ay6A6EhycBkv5qQv
2332	B62qqyvaakwp9QM8FUt1nT3aEXELZjZAJbTTqf5HJz4Mjy1cFQfBVww
2333	B62qmNBDmw5SHf5j76hws5yUJnWxuoLJLo18qKf1AbLEe2bxSBBqSDz
2334	B62qoWJBVBW82eEy5iQzFtVvx8fGovKmUkREBNoDGFJ2HRJvRkXCuK4
2335	B62qoPhH1rdSdsYW4hiNdsg6XGGYd8n4P7Ywkerw8fJGP6dMdgp4Ag5
2338	B62qkY7W1bs87iDm1dgUXDCvKJQWvXg7Vdh3zYfCqRDuKRrjDJZKEHD
2349	B62qnckfyCfbG1THZzik4icaW5RFmY2NhP3t7SL9bHjJMjhS7ZDtdye
2350	B62qpRee6By1yY6McKRDeQFtB7XmTovfphsrxxbkvvTKAwewy39xoPr
2353	B62qj75JEjLmp7GCEN9Umzk4r6sUJ78MPxkf3UygJermyAAr4RNji58
2357	B62qrh6VesZPmQqeHx4NAG8CY7XHUbMfz3tLhQfqF9psUeJE3EPReCm
2358	B62qqqqn8brSuZPwMRAPdaS87zeR47jTvn2DhWh7ujd5MpMN13hWFLH
2359	B62qnaNZ1ruxs4aVKRHtB27FmVW3eDyCPwJQQa586gHtM39j5j5KpZV
2360	B62qkUsbgEAbcqyVmFr8cAhCHswoqXduGEXpxrp6ccJRGfcpDMhQGdL
2361	B62qpw7qJWuvnEXXDZ7EwCs7qrARCLYA84LY9XTKGvQnANkVANNZeNM
2371	B62qpqv3rth3GjZwTshnZXBdpifvfca7RATfVoRd4xwNTusDCWcz3nk
2372	B62qizMVCEvVHqnwvfbWiHBLdmR6twSyfuNc5n24JMTme3LqeBagXS7
2373	B62qpiwb62dE5s6a2FeUq8nKPjXoD2iv2MWQmySQxfEDE7z2v2UXHgR
2374	B62qntdpnRQPJRzAq4eMbj9mfBcN9ZFAdkQLNSAcf11AeJNQbdBEKby
2375	B62qpw1a41EiHs3cdv1Crddy4nARkbgDvKCPAcaz2fP9xxBQXnLefnP
2377	B62qqPyE1kH4rwoHjnviwoKnArqMg9ZPBwVp5scDgqxF8NrPUzVtUA7
2378	B62qqCuuRXy69sKa23xarRnFfvzCsLqtLizYzGzoJNxaZFVyEs1RDq6
2379	B62qqL2n1ZfHXgCQkXmzb77QtgQio9A763uqDicbYy5k2ZnyUFyCqv8
2384	B62qo85u3qL5J3oivYyMRkk21DMCkw5ijRq2qJwMzDZr25BMUNEU7Qx
2186	B62qj7JFWbvroTA3yQvt5C4Xr2xS6RcdkPakojAmF5yNeM8Si6F7p51
2188	B62qnbyCt7LeyHmYJfUuM1fBnXYuEe3R4Q36TUq9UBd4eKuoiQAmd9s
2197	B62qqJwhSbsXxWc7GHhy7JsyHR5315aAzFkA3kLTkJNAcPDVuaNXLLj
2201	B62qq9KRiY6xTPz7zYAXkiJMoDgi6wqJpQJiNzjPSng2vYjRtYkezGE
2202	B62qo9u35famXFh3j31JrXexF4t5XhZBtQoovxbBXhVSH9NzeUE4FzL
2203	B62qjdj88dX6wwcmtMd4auEdv5Ck3GvVeAxmaP5MNnhhP2NtecqWZhJ
2204	B62qnh6aJQ3gDZ4Q899uvfzMS2WqQdDgu9HYZ2ZRJCddBZvNjgprTL5
2205	B62qioDwzFaEihdAh4GnxzcFhp2aE4E6YaypJX6XFx5jxa1gstNKKuJ
2206	B62qpgLV2xuVrt58vz79NEMogTZnZmGRSrD9RtaBKBbj153Sgb2EMDA
2207	B62qje12sDsYBLV9ohN7sUqGNpVxURAWPZjPPvjot1NKoCRZzpfNiQf
2208	B62qpRjbpEJBB5Ks7yvEXoqd2RqogS7TspcTZhynoVkWwD3qoxSCt6Z
2209	B62qqqymeaaTNE7VXn5jgqz71Dk3q2AsChZYnGHheNdV2WuuaySs9Sk
2210	B62qj7SN8U6UckUEmwK8B4DQ8yTA6573F4E9uyhhrS1rsLpsUnAmUuy
2224	B62qrQg7EdDnCR59vRHhzd1kV2QpCqG17wSGAt4td9h5M6otgPAvzQC
2227	B62qrhgtNEPfijQFV4Z11GhzCKtyKRzeoyBjMhr8Nra7peEZnRTTsL9
2234	B62qkbLpGszR5vvivVgJiaN539cxELhn3Eaw9sLZRCG8MwaTCmCaWCz
2236	B62qpToVdsKhd2H5CsNj8g3gwhF1wWv8pueASKUgCqjCwoY3NgkXtDJ
2240	B62qnWLrw5TdZgKjnAKXUjNrXYvHaFeJ5GD8fnbYf9sZin7gp9hfjFu
2248	B62qrcYedNNf4nt9d4RdEXUTRYsQiCbsc9RFz7cABFgVCPgaEau8Y8Z
2261	B62qqwqdGTxj8ZmAoNgSxmAoKHptpdsWAY2QJc5NjGGZ98mDhuQrEKD
2292	B62qoryMTkdMWzGosiUbLUwcyzgfg9WdtsoqkWgHkgzoqwcMossuZWw
2295	B62qoM9SJD7XqPKjW997sUjVA3yLfEhw1woy44CtMuZBm5HnxMPU9sc
2300	B62qjWhNnXqNV9fHC9ipb1gT3SxaeDfquen82epKdyMzsA9UZW7uJ9v
2305	B62qmhUojNL5K3i8ds2p5Dk5TL3SoWRqhA3a1DnKKpUrwSWTGUWHo7q
2307	B62qjDXHqgVsa3Be6Ca1GmiC3wJSWrcLKhev1qNmbrExoNK1t9yJtVn
2308	B62qkZMGZbxKWACT4zzM5u6LrL13pAbCTFscz8VV194m8DK1N68seUx
2310	B62qjuYU7Dhd3DVeWZ5R9mdU2Gb5C5A6nrNueqFmCEsq14Rv7vx2z1p
2314	B62qkGVQSuxQuLN2dJx9JdWFWHCSMLWSq66hfvxxK7gWYYdZdScJb7D
2317	B62qnHNpJznWvjaJQ4VNtDZ7nyDocGvAZj6Rnut9gmCCowJKZcW3NFJ
2318	B62qnP7j5Tsv67MYRGcRT9L4pyJe3LiEH4g7j74qwbpt9xkt3DXGJhX
2327	B62qocNBz2Fw2kQ8wEUvuCAT1PRUhUtYWYvUugwuQuhBZrhREb4Xg6D
2330	B62qrZnqAJkuTD3QVp9vHSRjx2fhE7vnCeL8BzqrXq1ksoJSvJPtHPh
2331	B62qqHASskyPQ4DRyVMz89KZhX7eU5Xp3w8ASBMuH2CGMgd8FotdrKH
2336	B62qoW9DqUPD9drtEE4r66Qxe1DPpTkTrQavJGztFoUY48JjPv6qd2N
2337	B62qkZrLGvi8g3cFPTPFF8NGg1WwQXZWwxSbQ732g141wuGSJQtGjUF
2339	B62qm1zuXxuzVUMBBm3Sw2chbps2EdX1YLzUfpSBrHKJFrvTwnYSSjZ
2341	B62qqyPtNsQobfVGuzVJZjRFjc3uQMESUth3y7XaJQGcKjrZZ7XKQK3
2347	B62qqJPuprJjt97CWibipjJUf7V3QRznbYoKfMXYe4RipyRueJdP8w6
2362	B62qnRkQsuqdSHUG3XWDJdQjpAGfSqsAFsQAFoEwernDAwZ2VvzW9Wz
2364	B62qr6ww8pvwSn8QHAoJAd6BSVzzbL3qGT7RtyWWT2d3DEuqvxPtHTy
2365	B62qoaUNAJGMSArhgKQenJSe9DwouNZjVAk4EymFuNhhfdojNzCD2ui
2366	B62qkeRxJij91bBWJaKsWMAaAhEZ8zhbfLnzuTxm7KiDnJ2kGoE85Nn
2381	B62qojGJ8ruvEzk3qNRv4WfwWxBaFo97PNgNb2gG7yYYMDdYESsogkm
2382	B62qo1mxHoM8zmLWU3fjKEnCwnZip6zkp12TrVRZYGZnWGGGibNubaM
2383	B62qnSKh5RV7gY1Z4pRFqoNTcMuPdFNZefvM7rad6rvA49SAPWK3dRJ
2187	B62qjrTZFZ31TqaastE3ERkdhiBLNbpSyYc7wYu61ah2tVci4af5V7j
2193	B62qneNG41Tk4N7gM62nUGAiK6du46ht5Ujn9EZCdoFkidDShi8FwKX
2194	B62qoRmDPKuSxRJKozbj2nGhtwSTsvozsDTbGNgrmaX3B7iqte6if1F
2195	B62qnnTX3xjXUeZ7wcsz8UjZWexM7yHk7W2kvXi15vryR6AWDwfoCGg
2196	B62qrNqGpoFpyvexkePHYLMrrdiA7ZSbAEGzSHLQScw4aAcoDZvRJ7k
2200	B62qmiabNh66oiBZ7H8WyWrSxW4bpasPzrPWJuTu68Qo6F8LRAkkWim
2220	B62qjYAPVbU8Z6n3JoXPC887xWy1ef4dHHVQUNL8FNqwCuqVfA4JR5V
2221	B62qooYG7rR5ijCH2kuzTaL7h1Zn3jLUS4ppdb9ERtyyDuxGj2hBMmK
2222	B62qoFmU3MbQiGpttbsJp4juN856N6qCPDQhVr2uJnR7A1nSic4YBAB
2228	B62qnnZzhJtPpwc6QZKUjkLcsvD1hFQNEG3xdycsPjREg24QCnKLnRw
2229	B62qngUjXWbtbbPSwPgx6Am5WnbGpajVcMBZAvVwYXsAPXjuDcUebBD
2230	B62qixn7VPgbUTaYmF2R837PzTDjPJUNVCgEtm2kaGh9CwymNBxP3mt
2231	B62qkwFyK2M1tAQekzrfrF33bboqR3DBKo2PfHXL6mgRtzA6sVSSWdb
2232	B62qrAMfKzzYVe3nbao16vjoLLYYNREg2uhfir73vfA2rqjjNDmTrPy
2239	B62qqUoC4cA4TqWWWXP5DcrX4JyYC6B4swg3g32vTBzfY3QRFKtSAwZ
2241	B62qnQqtD7g7DbhnmzMS4iM1jyvZ3bTE9AkX79tBQtNvHRQCMt1j9uc
2242	B62qqNZaLF6JcS91UXqq9S4hJLXzUpknXy8ddnyQTQKnBBkabAB972C
2243	B62qrFSo9NUDpeRBmJXtJHQSshQ6p7U1rCrSn6mY9qgeFiMyUTQUe3m
2244	B62qjmS3fXK1zJtHc95yFyCqMMPhA5XJ9XjqN8nx8a5QmqDMF4MXVuz
2250	B62qrJD6G24muG9aaKmQLynhML1TsJF6bUxnBKkgvEqagpRVXZwrYUK
2251	B62qqvNt7VWgA2Zrpd5784Qe252C9prx738iEbB7nLodbMPZMg8ZRnk
2252	B62qiizumZvdQ95wgdjQSmMWmFqY4rUQ6rC59vhMU7fh3iweaNkbRhK
2253	B62qkxpWUxC5ptZJAgDH3MH3NctyWf3wxoq76Tjanbxka2cZx9gRY8D
2257	B62qnEBktdKjoQzQZypNsBQrEqjnLP6cDy9zKbcyLRwgLorH4udibBb
2262	B62qp1ekNDHr37RMgGyeVXcuDtTAgmcjkeS2SCsvme2SiJjS3S9xjm2
2267	B62qqHZrtdAhUT9jL9BKdbhTD18TfLBFfRTGeUCaeVXrcPBiQA7KEUe
2270	B62qouKQ82drftw9oA494YRGrV2SxRxnJbczFwTWFqezR4ntf98ExsM
2287	B62qqwCPPUFZsHyYZhncvoiWyq4c8FonAL5zvL5qAGReJog6TbAvBev
2297	B62qnmoXDcF4X82pyozed2uo3oBfHiejuUzkNiB9sR7zP2vpKYZSrKf
2298	B62qn62D9WA9C14MMU9vxaE7VspFNeVDD6BtrZ86SzzwYtRqk9Dcsir
2312	B62qp11RxBhZZu648hfKyjYmnBEUTPRrTNzV6VUT6MQqR41tznTAWak
2316	B62qme3NSDUxrb6KU47AQkrCxEp6vC3kMXHi2uXg1z9m8U8cQ84UAJG
2319	B62qmxs4ipP1cqfJPTxfK197se4HpRVP1mXoiaSU7YbECFHTH72G29H
2320	B62qr2868PzqFbRkGYxyh8pNfpk4GfLjdf9TAArMBN44paMFUouk3Fs
2326	B62qq21zrHMrsvJUrEqDYnD4vUnJNCbb8MU32ZCdwuAQoNYYKqEZgew
2328	B62qmX1ypvFvTMdTibvyJudJkLYC7kNDUNsandi3QyuefH3GCAnJmko
2329	B62qqoCMCrMCJ3Maw6RcKz565cJnapjiAXwXXjBYfH1oEuv8xND94zc
2346	B62qjkP9YTQpra5p4ujQ5AYQ9hHxgAmbNTTtwrLSoV5Ewe1vejY2jwe
2348	B62qpPw5Yu4zGnCerh51HWX86MNWz1V4Kb7f8TUZ7y4hPCwwz9UogWW
2351	B62qipZRLd721ajkGwx2cHSpXoAzivYdZvesSBfN4GZmBCExUoBgAnB
2352	B62qmBCYtiXq33YqW2rTTG8qAPKzRe5Zz1pc1aHkMmDLBU4hJSegyW2
2355	B62qnX6nQQuYzgvuvqdxsUpTdrJfXYcGg4CYweeETcRRJ5thVWcDNWm
2356	B62qiXa7zUP1YizSAowgUyBXQ9hZZkofrdFm2GGX7zjUvR36T7HSjwR
2367	B62qpBprcbaz47B4tXk8ouEYT2uWNwWMLUhiweJhv9Uy5tKCZvFTWu1
2368	B62qomFK7HYUaNsNp9M8rzAVfkC2ZinP66AqBw7AKyZ7HhADCRqv8w2
2376	B62qmmnkUhRPfuRdy5F7KZZmBTcyHcMa7CvaySpzd7UjMXeiM8FSsfg
2190	B62qm7KyQ8ocXLuR6nQTDFfwkoEfgmJGTbQoaezi3MfY174sGuX8gBa
2191	B62qoomi9S7pkzDMuyz66wJ2i5NXwnN3Ntm4iYfusP7RgHopjz5KsiT
2192	B62qjziDvun76ZNzXjrwoeua8SCNmczAww9NEWBED7trsWVryxpJT7u
2198	B62qiaMqRUdpSvX632WZWNdEk1xcAS5bwn2XDpHrZVQNZuRfUo5bsGv
2211	B62qqE4vX4yUgQioa6r2Y2xrqz2CHw5DhPK9AyrZs1jqYCwxUbUYgSG
2212	B62qmN5ySG6UAWG58n1u7nb2HQzcRAkHqFh1EquzRPSvtJmNAhrsSyC
2213	B62qqAaqe1ha2g74P5vLpot1HUutCbH2oNwi7JPArC3TXtwWSGcvubs
2214	B62qr3sZquA435QTmyQJW5pYqT5yM2tWJH8tTg59RWi64GrQkSA7yKo
2215	B62qo3DeaoniMhVd2Pdy6NkErK5SiGurGgrNWkELvknwWMX1i3TsMiB
2216	B62qmVQVKoiSNg5dxMMugXHkeM7dBecB9v2t5Leedyqmik4BkrXfZNV
2217	B62qjecKaMkfXfMUb2gvNz72ixLnhK6Vc4PSmHSQgUFebVHMoAtdbaQ
2218	B62qoyCVn3ZvhvWLXX63AoQ2bw7dnu9VrBASDYD2o6vqkvYXPeqvWat
2219	B62qie4QXoRshYhRi81eYxGAdh1UwtB7zk9ga6ec1iEqDKuvdMLeRML
2223	B62qkGT3VBaGQRKfJVhyYf3ydcd6GeX6QKUWrD5vR51c1mLbCV4aDju
2225	B62qq1UvKuyvQJboyrWoSnR3ZxYtdK2fY9H71T72TyvrBkM2CC58xFX
2235	B62qpy8BMXe3tYsFeaTPRNW6yoG8jqaZfqreBXsaDGJ67Cxptn44dSh
2238	B62qru96dEQVY2ZTFVp4dW2KefcZnbPk9PBK6aNjtwK8Te4FfLxTB88
2246	B62qq8xd9W4dxos2sjgAfJE36cW9PYhi2dqoPTAPc27pb8SCsWGPtn4
2249	B62qovoydiqs8rD63Hg3ST3WTKBoUG15nDcXozpnNsDRrcg7MAWHgmP
2258	B62qkispYAjphXDKyx47B4M6PsAh2o7zhkqqoLFbKhLDq7wtLRNkSE2
2259	B62qpDxh64LnSjGeAmmUicPHU5QveTqg5CPjYLZCow7oWWnQdLBBdrU
2260	B62qqKb6hSurPxudgR61HMKsMQytyTyFDvSAWCbNp4F5tVhYuXkARpo
2263	B62qroYMFfTSfRXDkHmcbgXQXEoLeGPWGAfzEcve7TK4ikjcEKc6TdM
2264	B62qjd4aKyDUXvtYfMSxw8CsAEYRQYBENm6aEhY9vvJrgED5CZm1yve
2265	B62qrdEuFq1GyQhzZxTm99RoydSqJdN4b5JyEqa3ScsCeMXVrW1LzeM
2268	B62qq83PfjTpUFGz94teypvTk3jf972WqmA3ZCVv13U3qpt8pxgo2By
2272	B62qmH4R6gq3UhP3hTJqAcFSW8D9Eu4RZCtUFFeaFy8B3RdrzqVaVeW
2273	B62qq4isMY46Nnc1D18brK58ozTbpuCAFUkUAKGK2zVWNnzhjTyUNd4
2274	B62qpkWyVR2wNqBnFPrH8mJY4RkGFDf68xou5NSaS1R3bUCqzTURFAk
2280	B62qm7ozMnKcoBv8rTmDywWVPkoM1Uhss4CqFKWiZbPf8qFF5bEHk8V
2281	B62qp7RmLTgwtp3d468hGZM6uqGGvxg8MgJMMvafELtT47zxqzDPwWr
2282	B62qkAnTYHV4x1kjeHMjj8WQZaMjBeFEDB3UoLEnKwQkv3eW6MkH6Ha
2283	B62qrtc5b8QaC4wTEyXxFCCT3F13sgeeHAnHSsH67qHYfEHFgfuAS9B
2284	B62qnBc3cgaHkndLrzmimXinmXCC5SteAtDcZoPqaHDGYX883ADXPQw
2285	B62qoP7Ttcrt6WR4vhFkGEJzhbGQo6AbFqqiNKYk56QJzdb7XmnwXSz
2286	B62qnHcJVasqwoc1719ooV3vCmDzMSg4GRCX4JDx2mWtCRGPpSs5VaA
2288	B62qj1dzrkApiRonUU3Gnwxx8civRq1pi6WJbEg3Sboi98NhQfob7rr
2289	B62qp89J68LeMpMjZC4aLCz6ezbzbmHqVDo21eFsqjJ6QFv8oohdfkK
2290	B62qq2fw1pedfv49bdfmvJWqiMk5r63uwYtrssRoMG8cXxN3kNbJTXE
2299	B62qjTpUa1bKYVsYhHKC5dqgQQnBNhg9s8sYFLowB7PVX3iHDxcuNj8
2301	B62qmkVBvrfsmwUWpUVVTNCRYpk9uDvCxt2c8wwvg4xWzWRnUDiFUTB
2303	B62qie7pATAM6SLkFMR1HGR1EDUKUEvMKBpgkFV6EZ5ZWnFozx5Bocs
2306	B62qmQGZPfmtoNLPpxnYUiF7dSRVGEjFjHhFiRCFEsu5zZDrEvqx3mC
2313	B62qrkpnPeHN75SgrxSaU1vQBc9dRpvzbdzWJiSgYxoMavKzvLntKbx
2315	B62qjcs2JttjnDnm4RtKz8FAfXpBXh1Go42LXyJMd35smT6aqjYo58s
2325	B62qnKuQoQfBmFD9rY7ytsALXHQH3qbS4C7M21yDTbUX1H3nVFX7zK4
2340	B62qjxpt41fAb1VGsFzLmNsjJBHWJoCz2XonHjJr8amNd7HfrMgy1yg
2342	B62qrTiFQzcQVCgLcy9kyNNhfu4wYRdyNzfRmibbFPcWpMQWWm1fWHd
2343	B62qkMwbeMZkjd48VNKRGdwnyTUm2pVrBie7DjK6nxYmWnQ69eFDaqD
2344	B62qoqW2jhKpTpJMt8mT5pkWATV2rLE8N8CbHnMnS8ecBU2J2F6g3ua
2345	B62qmbmQki4GeAB7PEvAwhuS3TJv7xbdfNZnS74jiERRb8vbaMYr2BP
2354	B62qpGVZXaTqNFF5zWaDHsK6eLJLE95JtsfxWcDEy8MdkaDDay5RFHb
2363	B62qm7ZtBYMaPbEgkiokiMi9VPVteqofXdPiyVGWTt3aRVSw8vxprdd
2369	B62qje3KxyHAVdGG16dhFkMpkzrCziwQ6gMgPMvFa4aJ2kdJRGkJCZi
2370	B62qpX5ArbCv24VVhV26V1jvWjQ5kSEPR7NScFFZHzWYWMYMoq6XZNy
2380	B62qqcxAvY4cP9QE9XtQtHpwbaReY1rvMvUzjRp64qy9TqTSs9C1U8S
2385	B62qisBgzyYKFofg4bhK5kfdUt9eJMrDiCzvPkeDH6bjRZDm3pttwRA
2386	B62qnZdraERndTXCtZZb9BQVJSxSJsDozPWWyS2gADiyTtXoAuuisYM
2387	B62qkNo614WKBoEAUZUfkXBeu6SNppFdxLLPy7WSD8w9vkkMaU4dNtq
2388	B62qqjdXKyj6aU3Q3WMwH6tmJxGbqGXc5uB5ykQVQg5qWwJkt78ZcMX
2389	B62qosbV92skYv3pVsLBKohw4X7HZdTiPTnBTxqiEHRy3TG3wRynNTZ
2390	B62qqJECN6pw3TWgf8u5nnnboGpbuWwboypySnSkkpL9oXYgjXFhYRn
2391	B62qp6nFKMUaf32bY1zMrPftjS9xXRMGFRhKZWxAbHsPGSHKRwgkWsy
2392	B62qmj6Tu9V32PBSV6ULbnCSkohC1QniTzixyxKYFkCWuthkEANH4fD
2393	B62qnZAB7ZKCq75SC7GbrdzBvQZ1drNXUBR7jqKKTD9vWkzugnhofJQ
2394	B62qnD3fJnkyPk5SAB3FgN4nG9dKbPgHcBkrB2gbJG7cHdF3eHUctPQ
2395	B62qm2wYABKcvvNPuY4VNL5amFDM8QQmjzsihZ5UbGGGEgNFDgwYCfy
2396	B62qoa3viqZas6fqFP6p3FRmCYomqnReZERFBWcoWTqyuXEkbNrpdRk
2397	B62qpjxUpgdjzwQfd8q2gzxi99wN7SCgmofpvw27MBkfNHfHoY2VH32
2398	B62qnduvRE55X7FKXSE7ysUCepxak19BS4swravJWD1XJL6yShC9eLk
2399	B62qrFePrUqKrWPz7TYTjqxx9iHZbHEKvbK1KfZbuKcc5X5x8cKgBFb
2400	B62qpQpFH7kareBRGimGy4zQcTRDYs954bzsWNpUkFwWTgp7ThCpT6U
2401	B62qrKsdAwpW33PQxYzfu8JDCzpZUtc5pDMHsVtz1CoNnze6tosomnX
2402	B62qruzbadY3TZDvcBC5RKuXc1RgdY9jgY88AY8jWjrUMyWCwDsKzgH
2403	B62qmdQ8VwCh4o2WFJUtx4behatPR1bsTiZqZMkpfvLL5SBG6cF7TEE
2404	B62qn9orkCADRbYAnQZ3gozzhGncLiTvbiHGXHLoAV7zanPVakzomnw
2405	B62qk7Uft28tU2ZJEpNVD5noG2kCAAytnDjikHYKva57Lefymby2tad
2406	B62qkb7UBS6NfoQJWUxkkmSPK5SyEnGVYHrGYCMXN11sQSRFLbBoUEH
2407	B62qmc2SW2QhPvg8cxPQnWKcwfM1YSsfo13sg9SNStRicH7v7MpcmhC
2408	B62qrYazpXTRcnjKBZSAFAWtYNwUtk6sS7xtKAs8U7pFp6Vgt9JsLzu
2409	B62qiiCYbwt7BhrEsqNHk966fRye4e3DNFZmEA1PNToitrK7HCJT9SV
2410	B62qoBrJRvyqiajPgcFg7tCJwKm84Utrn2R2Df8px9Q27cJKMLzqwZr
2411	B62qnZz9WWq4d8LA2hsT9PZBAsc8zLXPq2ejA5q6zUMpweMVaMxspdL
2412	B62qoBtPZAJ54q4JiCwSkrifeGFbkhDe7AerNTjmyF1yX8qYj5JFjL1
2413	B62qrWhwRATTVfLCpNU7AoTBGc5hyc1G57Wapj9mt4bCw8Dgm26a3Ho
2414	B62qn8rw57DdJcGdR1emNV76TjSXjDQ4W3SQHEQVS86UyrX9as11Vqy
2415	B62qqb1jZ36qMpyuJpLgVfN2vLdrF9pBNC7pE9Z1sDvDcpB4bPgerKg
2416	B62qnLbQbghiGKG5uTHaB1sBYpSXFBaXZdZBfgDDLErQZhgnqi1wevb
2417	B62qnXSsLz9sL8crnJzGMCcFVUfCkfAdRZmbFLEMxBgJrNKvdk1SifF
2419	B62qidZE4iJVC2uyRMKRCQvmoJ1CVLHomZqHbJFuhCFLj12L4P6Fejp
2420	B62qn8VrEwGSXF83fxZBVqqxE35BV7m2d3D87Bp5z9sSauCtr7T68Ec
2422	B62qiisNJwgW38tmdGJ9SYmYUjTr4aMJgeH2Lmb2bUnPNGV3sZQWGg2
2427	B62qnscvS1aEt2BVYvurRMQgMqdkJfqipPFoj4mYFapKDRpWbZ1PRxi
2428	B62qo7b12Z2VNzQv5YFQ4vMcJg5Xgh3z52HCmsaYsLvWTDifAsxuKYT
2431	B62qkhNNYDtcN5ubeD2R4L3QYEBAK4bjbxfECWgUfNMD9wp9V8szhxF
2432	B62qkNjqN5GWWP9BiwiSLspTmeUZ6JAW7WVmkzG9H38WXVxuSQVsNyQ
2433	B62qrFYD9HaR1nbzn6B4akW6b5WqNMbbDyQZSi6ezDo7dYiohtKL2HY
2434	B62qnpXem17QPHHFMQofGhbVg1gVwZBgPDA3vQQGfj1D6sX1E3LRWv8
2444	B62qibmqxC17mK8dyJYtmQWzrrkMqam6hNDXqoXiPuxhnSrFPowoSvJ
2445	B62qrAyzVQgBMu8Am8KKkZeGscCMFhESAKQ9qXNn5ZygFGa8fuTujeY
2446	B62qqZPhjESixzqVtxDXFTMA1rPGxQ1jg81iqAaLUUMsxuhJAqDv3Hh
2447	B62qnRwqrjxFedwmcatVHNPBdSkrMvg1SQGwvGy9Eq7YcNJthkdmyZw
2418	B62qoxNwWSXTTWv7Ve3rGnQ3bhzV42pZy5MXzoGL1GmEPzs6zAbqvMT
2423	B62qnQ2k8rrtV3pa3yoBE6Ko8WUmcvKvVxjMhjoFrLdTxerbej1y2QP
2424	B62qibeug2eKgAB9TLhcGj5n3R5cn6e3FQzcsDCqnAt2svjSLY4bHnj
2425	B62qpz34NSWJAJeEtcfkLQncAzwYGiM4godUewhgxcbEr9AVurDapNR
2437	B62qmPKgmRkWVq7pVKwW5kgevyz1yTT72iSSGxWSuK3gJ9MBkAhJFgV
2438	B62qmNCHxxitxbZahp56Z1t5yX9fgzvSBTKzvw2us4QmfQLVKLvUPHB
2440	B62qkuFfJZ4u9qRR16gicTLLvX9kv3EQ1oRvmTDYmuEJdpKRiorxeZZ
2442	B62qqkDi7RYDuBx6erYqNk1KH4Q8MHxkswMwhyETNzpBiMvswADwG26
2450	B62qq4QHGLT7Lcv5BRLN92iUWeQKSUTLDvNik1EpiaitSAN1XMqHRxx
2421	B62qmkii92EtNN3XBi3Q9tiXVdaU2nigKYbWQE5mzMo7JkPV71BSwHW
2429	B62qjCCNR93CmndMdyUAJE3fqidKDJDWPTf9MDRTXgurmE7489NQSUk
2430	B62qqVZYkZM8b7TkdGBEvmEtbAwsHShhxzVoiDVewzBE3qpRoXwd3VF
2435	B62qmyidDu2VCs8wtD17TtJ79bLCaFkpSXmugK6bqT7Rj2z2GtSZXGy
2436	B62qqysUvMRJ8Pyc135g9dRPj5CGDrcGTpWS4KGgH1Nr9yp12i3VDaa
2441	B62qpUXNBm6Dw4JsTAEttcVRwZfuxUk3ATq5twuFfLhEqoYcGib7nBt
2448	B62qrPibZ4N6MJb1zpH6i5xwv6LDK6T5yhhDQqge32WoaLcdX8dp88w
2426	B62qjWBpvcCTqcC2Poiibw3bQQz8xW7yohaPi6CGoB7273Rcr1cSeYi
2439	B62qoWFzQ1hSxVkp38AfHrRuZnDed9qyXuZMuen5deVNLY9ebeQttmZ
2443	B62qrVAos1Xwao8dhMZozpJQRwHf9isqUMUbC5Bjrctk2a5gEBhKojS
2449	B62qpKcCVGJn8vG9eb5F3HmpMwk68Y7tcPoCv3k1CPfnHr83v86ygFc
\.


--
-- Data for Name: snarked_ledger_hashes; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.snarked_ledger_hashes (id, value) FROM stdin;
1	jx7buQVWFLsXTtzRgSxbYcT8EYLS8KCZbLrfDcJxMtyy4thw2Ee
2	jx5WHVfqJJUk7SpSiHSEeMw3PSKge6rFhvx4AXJX2m9Q11K9rSb
3	jwEPJ5Y6oRmeDzbHQgdkLxzc3aFdZNYp5A3bHz5U2kHvVUnZPFw
4	jxxTSJfDB7uQmjAHFM9UbeieWooMAPVadSVHCSWcBsZmPgPnAFQ
5	jwZq4cAmok39J539GENxQ7Dyw5rurDgPgbQ1HJ3m886omemyJ6a
6	jwdmeRSLYXsrAYLKnPWqd5MBjtwQHY2zUFgjur5DixiETVrBmB1
7	jx6Hv6retXNrMo2qYHLmUADtapezHoLCJ8B7xf23iZ34ea18PQk
8	jwBtZg9nseQk9ZYoKcjFnmoLLrzKECfaa119Bu6t7rY4uH61mkH
9	jxZRLUk9BscdxSpCTVUBabwqMGkDnXhs3w8rjPgV5axkT5Jouix
10	jwAouDZrXuisKvf1tV4mYUfDa7nsnCh51ECe2HmWoDoh3VUAqhq
11	jxRoVqa295hPdVxmg8k6yTnDD8ELtRtMako3pnxc1XgvdNHRhNE
12	jxcnSmcnQ5L1enTDiHfhCBcdfLzGEAYascN66dVdLA1HR49UUws
13	jxRx3BcVBbLGkUpUH6AiPXPVnsYU2kKASmAWemUD2Djg9WzAk7A
14	jwX82KZ496YaaXztWPxmRCYPfWpzkv62ovDXMr1fDK2Lr8vxkYD
15	jwvKjDco4pKLSkqk2NHkBrzZCayCSWGCu7PMuEmQiZg5jYJq5P7
16	jxPy3Xma596nvYpeJmrdhyFJ5bfSvuZw7txZMahKGDyxdPZhaSq
17	jxYyryhGxuU6mApkJU5LCCorHsdmdY97LqUtrP4wPEXF4EVqrdt
18	jxBHaK4Asrw8dx5jQ8KVKmAMnB3JinHZwrJresVRQgr3dm38wTZ
19	jw9hFd6jrYVumkQQ7wS77mjxPbGNMgVYF1EFNFDDYY9nMfXqyNK
20	jw7HLJiXKYaGKfGq8nZJ1wD1kvSuW63XxThBg9nbYyNe1jMTn5n
21	jx4BoAVVBfTriA5cbzFEWuXg449z6TLyyfTdj6BzL4xNz8jkurx
22	jxsee281f8dj6U2DmATvqRBYzaM5Vo6qbXYLoEruNsohMPqQZAN
23	jx6KGmck7UpRCW7tWptrQpW46QsYqixB2XugMj2QHouJ6oiCZL4
24	jwTgAqnE7dqfxP4oYDcTmsegaHFDm3fVoBtftRivdmJYk9BuR5Z
25	jxqumMumVf1asvN6VizbWZAbDQaKKt6kmpv3wEjZbtikNdQpe7L
26	jwAm294RPtb7aZLsGDUrdhAKKy2mFHJDKCrtH5y6XW242bK7sH7
27	jwY4oQaPTQW8x9dx5XbAXn6B7LoM87za3m8i3An9aPGdMWgmhT6
28	jxHUr93rYspbMhCr7WqCpA23Qesbtn5uZ3CNzpyogkZSsfz8x3r
29	jwfALzpdjTCsoGUrW51u9DyPugZsBRRuo7Q4iR8SYZpQbEwyeQ5
30	jwso14Naq3NgXMmyyjvWvgFkYsBXVxpcFB6YDM4GTw4WX61b3yY
31	jwkzvqVj2WCVLfRAd7A3Pmq7d1tUAYGwj4mLjkk99iy4jnWgPzR
32	jxcQb2tMajo84GwkLzmF6sz85XwUGa8VP95epyqEpAiH4mfXbx9
33	jwEMNr44pRjdvdQZRhCbdyk6gyMEpg16FJztEpq1zvvVZNktvcR
34	jwUXvtspmR4AWVgKmbDoRsnCs37YtnZAK6bZ1tVdCoTjA2JgErN
35	jwV6uy6cper3U9ETcsGQXVUiC55L3DmJ71jf47KaX7uBwZ3SJ4Q
36	jxLjcXzML6xeS2NFARN4xgpQxzQKqhC24mfozekvaSh3B1GKm2J
37	jxo5e6yaTrzJSm5EiKjpS6GMfjPt4VGXeZFFwyZXoysDv4w2c3v
38	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw
39	jwC2GikqzPvAborRYJmYhoFtoXiPeWD93XWxnndh4LF61NkvjQ9
40	jwQHnJueTcRxQjsnagTzH3hJJBLFd1xD5Sdsh6FpscSJoJ7hjcz
41	jxbu6AuDq3Hv6wpSwDKbe1ttLKTvh58W8FxAdyAgYKJ7i3eqEmF
42	jxXuzRSDeYsXACDgkM9GszmYChTocLcFFoRQdamwFokbquxN4GB
43	jwjEVJg9yZoAU1VcKYNsMnR7qjdr3qvzs2W7oesXwufNdBoVciZ
44	jxRuY57g6851mTjxoswNoRFTT532L6yZViAhmNZEZ6dyNTduB7f
45	jy2FDWyrutPtxDTWF8TG9yxhUnEvFcVzS8X8uwA9QxczQGpiX4y
46	jwkh4Wuc9jkJZeeQ6ykrYR6V2xm2oGbM8kgvYQLKfdmyFy2RubG
47	jy1GPEgXDPFUHXeYkXq3kzB7ftZnH6HsVLzimGK5f2swcSM4aiz
48	jwmGiaNhseJwVUwWC6zJL3Ec3G9LxsbRQL4Jcy871RAZyQbBsa5
49	jwJx1vrMvfCkMuPnyVVdBvZKMAgPSrWGdUMGpoDxTwwzjQc5pCS
50	jwtQd5jCpvgetVZNRtaoCBjDX7g3ZgxkSAkjzP7UWNRjYRAbraz
51	jwYiXp1nc4DDk6K95h1MirgGhyEBxSvDcexHJQu9uvZiEHbKbJJ
52	jxEMdGKgJfZwHuCJFUBTyggty8qQ1y7bHhaG2ivL8FK89CqEPgn
53	jwhJG3sth238X7Qji9dJT736wicJLpjiDFEgY7wZwqktirSR9tC
54	jwZyktkY675iyZeuti3WQLy4W7E4c6ejP1JMY6sTscFZzBChTRL
55	jx9pR2KpKnbX598quSwxSKmZw12b5KNaUNPNmecW5dieajBzzyw
56	jxPSSofxzG9GGUAFVtAtSGhR9H844iB9EsooHhgjCXZVWe5sEAE
57	jxbXw9NW28dwcTmQRXPEGwho5HwWizBh6z7WQmKPkGgaE63K35L
58	jxAubdnmvjGGQQYVdkaQud79KpDj5PU9Bz4jRNzwrzsRQ9pZo9t
59	jxcwDoWw3KW3MfqDoADqk7MJkQVsyynjTm7dPDwFhKjJCQmNJWr
60	jwDkFMueyu5oLqZtBQSr3Ggarovd7wEpFGb9bBfw33h9QHaC4Gd
61	jxWJYKSEM79hbY9LV1U8gGhtyVc611vVdtxd9XnQ5j5Ybu6qYkx
62	jx9jDTCyogscfyBFbjD38ZEdoCkdmzKuWf6m5KueeFmGKHEv7ZR
63	jxLY9aLNvTKdNaFcUzmUPTr2wpPYJZZDVLwSRKXpPwtq88K9mEn
64	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE
65	jxk6uUELMnFSdfRrfKtxTnkCtNapjNAdGpFLSAxbCNMgU5K5HnM
66	jwXEFEyEHhuP4jZnJdogPCZn9LAJRkAHUMnH4RRvEeebV2veXm9
67	jxSSpfYN7V2eThTeLqW3r6CTSFGBxnUFfb2hbfiSXZhhMKArX8s
68	jwoF9bduQ3X819veVcqa4SdepTPXqgGctAtY34tNUwXHkX3o7hS
69	jwkhTTokd34ujnLC22sV558zNgzkWSXQPBGCvEX3ifqScpUhqSs
70	jwZCziEqoNfqVzaXYBnXkbBck7xxBUxByU33qz1AtNUrGbp7yW9
71	jxbW7v4U1WAcXUixddYex7AfrfPhdkaT8nVbLrCW1xZVkPsqP6U
72	jxnMQVcmr3iQ5xMaZXAAVeMnVCVkBEqdvGdCX6Wi63VJJTju7Br
73	jxVFDeH99NFTHeHhwvuheCZhok2BbfAGG45TaTQBFEVcnEf5HPy
74	jwyiE3BwB7PDuZ6JhcmkP9W39bM6wtJDBVrNeQAdTjARQZiZ6An
75	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX
76	jx7viv7xZ5Snc9tpAayyEDe8YPoN2XTgPZT56xYK9ZQRbusoorW
77	jwKPoUacoovgtp7CiehBEDZjvN1HqtJefgepVuqPpgMr5bXrhw7
78	jxbxog1yv7QMCG7z4dxiz7rP3o1KJQNGB2o1GanBDw15SpkhfJc
79	jwUYtANhTgoDfSzajLQFL4ZTMrms2bLtVTRH73bsUGdi6XWsRkJ
80	jxfz9X12gKCbt3HgHj49BVcrJHghDo6AYyM92ZHYi5aKz8fbMMV
81	jwSiQ13ZCxXbWZ8ZrFeAooDVMJmHtNzJpQ4B2hGEGT3n9QHfUX8
82	jxpkod21qJidPpRgg57d64fRZXiEetPgoquyy5h69FWnFSUTADd
83	jwQMuEy52641hLotBYoTLWm7V9CKR6x1T2TFXngXx2QnPh3Ftnd
84	jwqhqtZx41KLH33ob698gfAisgqgWmgNLUTrzD9nW8xxb1iV9Wx
85	jwgTZYqseFBqMwN8o8bXNeJYtHmRR64hhMPQvVmRutkndM8J5VS
86	jwrfh1wkfErTDCNvdczrrbNYWMcjQkxKNP1KrBgMyg3hjZWid3n
87	jxHKD1Jji2KoCWE7bm7YVy7TefimmzVG8hmmGx6cbUhtPqxXkdh
88	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX
89	jxdr4QW3GgMq9JuvrGyauMusz3SDYDkMrKvU7wjkEkanVAiPo6r
90	jxML9o22Asm7s7UtoNYtrfLxku3nMsPbKUa4XNqoUuqjK1dEw1h
91	jwALWwSfGfEur6NfPz3BJzxaepzpdGd9GzYJGjbmq3n7KehBh7X
92	jx65PksmeU8g4fu1kQ7SddmdPNuo1sYReVfSALbchMtfCejDEFn
93	jwrLfsJF7AbmaYncQyMHKSJeAqQ8erx3jxjx8SywXAf1qEQ1EEH
94	jxp7vEctz34ngxwgref6MocSaYiagod8aJk5Qb1wUkvqwJHE8i3
95	jwcRsaFjtbxd77SixagbegaHuczy69VvrAtWszPFd6oGqtAmXCP
96	jwfS4p8MHncCtFaSZQ6dHsUW72UVcMfdvXiejrAqapCEKGrS9Mf
97	jxsHGDMJ3NpgTHvMvGh1tSLMkPy5s4rPEJE3ytPJo5wXYdjzja3
98	jwndv8sP5dtrtLLcVrzrJhkjhbWZgM6FbocXLTpWkLdbhqBhtoU
99	jxGMNxGZvh1E5Ag24CNtUDu9rag7SUV6oSZ4b52ARne8cHBciT8
100	jy1SMr7sy9QAsforJoPzNJaUdZRbFEXfgyGMdYqVe9fXxaXBo6w
102	jxSxSW2UHURGoeWfD4qwTupPAR2osVKxLXG8R5hHK7RDNQf3Nc8
105	jwJgynKJFa2185bk8qYyvjdZoMjevM5ndknEJcGSCeMHYUASc91
106	jxiRXkLQT2mhdmTM2DoZ1DbJLL1KDRwjYRhxdX3zvpaKjBFB8Ls
107	jxMvVWifAiEAFrwQuFac3x8ThQ6yeUvdYyczpmmwkRCZEVYMykM
101	jxmyuhLuKjYbj33sr3hVBRx1pT6ePmesWdDxzApMCKzB2K1tgSn
104	jwEq5i7Rp3YcYhCHNG4NEXM7HSY9pmppTCqCSPVuh5QPxYVhFMW
103	jxCYQJdNHNPvXpeUiSu5Y7DTh5A5umSTHsPs3RCFbtGcuxVSjvA
108	jwvWterDkuW23iPJfKFdDNNfPZqXWAnyJuvpPMC6whaTtRh1HTf
109	jwvvd6xMoYsh3YCu89hB3Yrn66Yjp6FN4pSdVy2FjJHic4T77QV
110	jwFq9hRwBKxpsL4DduchMFXkkZiLp4xmW8fwGqPDRZcBnt4YfRk
111	jxRB9pJMvJmgj9xCeZv9oQohdKc7MPdRJwZEKiHD3gn3pBQGYE3
112	jwFvpWmZQpm9u35QZSVvmYcPdoVxF5WFTNWdqNG1zTgc3Ad6PZd
113	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN
114	jwZwovJFVmYTDTBCS7RJqc13qgGT3pYbd13FB4qQ4sNRwrpmqzw
115	jwHrtD6xiNdEry3kZ92ykEbsoveEt5DfM7sMBcyMN7eizSihmEU
116	jxByh7epLbUxkc1xUJP2LaiaxzGTt66749pQV1pZiugttZqsuv2
117	jwfSB2RmJxR337XmbG7i3pNTu6KwNxGtNfctbvJ7Su4LfgpNqUg
118	jwCDovxbpptEf37R6HYbxLycUh8K37vdHQV2YouJvQJuBN3bE2s
119	jwzxcYQ1Db3v13Yu7UcRAnKpFWUoB2UUbEHPiRCxoqPVchv3nyP
120	jwewmvsBgwJHWwjkKRxeLkxLrVkzq5BgoKiHnkJdF36Se4WWb9R
121	jx4XcYxdqztHEtseaSsEKEst1TJR3UjH8uxozgTUcqfUtCFMK8P
122	jwM7Zb1ExUNWzjB2c8uHm7L3Hbjk8EnXUtG3ncEJpjpG4TqAQBr
123	jxN9Di8be29XExdxnZDwEkH49CanYHvzqGLdBo3yt67B1HxwhQy
124	jwt91BWz9iobVKWv5KPjNqc6hDKzuG5eXdU5B9z6Fgq4dv4XYWH
125	jxw1QnUV5j3k9KTwRW8EoFhcrHA78ZiZQYe61ucgAQTaXYtKb7u
126	jxnsEsr1u8KK4ecmfhiBAd5QVyFs1ztCxYsNoaWZNyw1czdVssS
127	jwAAZcXndLYxb8w4LTU2d4K1qT3dL8Ck2jKzVEf9t9GAyXweQRG
128	jxrcYVSBxwgHMLApR4hLp43fczsWX447PG2QWSxGpGbMJzncNg4
129	jxyqZKCVo2RgbGnwzjHb72tPkyuJun5PjLMb4rxyqgxatS5EYjk
130	jwP9FtjhryvhVU21M51SjXCjMwBR7g7GDbJtw9kKNbuAF1f6X3p
131	jx37ags31UMf9aUn2yLnQr8K4QrCVkCqKApWmCNvmfKL3cuxhvB
132	jwBD7Y8h2bqcedCfpcwadb6apgvRCHXcyxbsonfhitiXruy5nqs
133	jxrbQRp7eTD3sfe2ugnmwTDRfjzTxEumXZ2u45Wiv5GXGGM4VjX
134	jxCy2bhcdMDTiv1cqq7N1QPKHGfpkC18vkBVKNWapdZ883dKcFZ
135	jxPmh5r5PRmBpVdEfZtg8Wf1W55HKo5tt8qLypqRgy7aJHXGAMQ
136	jxejdCzjBFiaKf5rkm3N3sAzLQfWLfyjx6Qn7C9YqB2X1FZ9t3v
137	jx5BQcjMEHNS1ZMua3Ct2EhVZfEAcEYiJiPBkCaxe8CeP8iHWc7
138	jxzZcP1fagyXE4pT6KJYZi3Qrx7R6WGZpaYNAvKHVwK6Hi5DNRJ
139	jxXNU6FttQ9GSWFSeBurFFQ4Hw2WcUncZfutVBKz8guX8yvakEP
140	jxbFwnM1FXY3DJ6E7NcoxxfT6kpWSGK5geEmFdQMXKrcTp7es8A
141	jxFFfb22dYi8BV4pErH6JNjoC2XN2ejMkwsmR1r32q9PtkgNuNb
142	jwmfNHTGU2arhqPMbvH7fVbG96phw5uEWugp2nCuTBimiqEcezw
143	jwHcMhghNVX5DAusnmSbnUhheraNMFHo9jjVShjyEU1qLCmYgbe
144	jxNPSG6vSCYmNCZ9TBKRvZF6jR7AyUKBXqiFrWwm1syZGdqdpgF
145	jxsbUFkceHDR7PNYkcCqnyk3vUkAmVBvF2JrJ4KFTMBhKSVEouC
146	jxR7cgJfshtT4PXLkqtZD5kPKNe5amE3TERkgmjqFKhxysED648
147	jwhMkMzB1WoFCBPUNChB9jufa4HDTSJxt7L5onzEVNmhRnMNCvy
148	jx4WN9PaKCzHCbacu7rBwBtuQEJW2Zs6b7KeQ768nk19EENoo5e
149	jwmeV8mTD3NP8mdkHdxCP9DzVqwP5nmPz36NuaevHm4f2DjsMP5
150	jx2ABGRdpKJT37cXcqdwtdfC57snkw2GubVth9e5vFafMdSF3G6
151	jxKMpnna7X6Ety5RFMBA9jBfnApwMdybzSbbrU3FnAEy7s35Mok
152	jxuq2mfoAdX5KW4LLbiYzjKwzZFJ3Pyb4nHhsgusU6nxyB61QRo
153	jxfAt6W91RfEQZWbRQdDZk2fXzcxSniKq7aihfgz1rwzXCwm9Wg
154	jx9AErRq4jFywGHq1keMEdcThrmjcrB3KH75yMdSsBTCeEuirjB
155	jxxGycggjfHHVWNs2eQtsLLfMq9jm7AuMiqy6F4ezJymVLxSPsc
156	jxAZuR615zA7jkpwxD46Qp7iGiUfenPS9sQnCoZjTb64wqb5osD
157	jwWpzYEfbJemtVV7zdVkxDfmrsgPfRL4ZjdAc149JGGC8GnxkDg
158	jxgN2X7TBxP2cqpnE85jEPwJ7CKuKyMWJi1wcDGj4J5cwm5K568
159	jxKFdvARqmxKek3K2FgUDk2nKj7obRU8NTWq2dsLUsvbfdt4TzJ
160	jxtgENMyMTpShmGkXHWrFQ7pXm8zrvi4THt8X27JAkUxY9CmVW2
161	jwLsmgRkqjNsibvTwVJdLAhrR17LQGHrq3q9sXXxyZSLJfFcq3Q
162	jxX6cKLm6mXyn6cwawjEwQFjD2TYACZHbvyaHGYB8cboyfSeNkN
163	jxLUfJrG4BTKTGUifio5Qryhj4nhY3Za8UejAqtSDjRWDHETcZZ
164	jxKfvbpz3Pshd3tXBr1w2E2QJzmdi2UzFQcs83xE357qn5bNY3B
165	jxotM8JxbGc2y1tPeZY1A4CxUVuzRyCRb99Z9NX1MmPMz7A3Q7J
166	jwmjAs7NhRNYWoVc348WRem9FaBQ6opg2tZHxEWBKGRxcmBpVGP
167	jy3EtFht3g8JKhCw6PfWwNR6dMUHSfmeRQRy1JzCL1dwVWLU2V4
168	jwcPuCxuPkntFXsuZ3VDopLFnvYyJVsvb7vFGmDsr48mDfvg5hw
169	jxUU9r8MzJMEWKwvnZnHXu1sXX2Wuk1KFhZ1NAFioJpcXKpSK4n
170	jxdczVXwqGvU2zY8xkYqFQY9v59MjuoNtkXQbgivjnq4aeRGXr2
171	jxuHoa5PtECt7mV4GC7Dr6pXPxJ6SmvpFnfoiuj5LqUuQfMLHDW
172	jxSnS3NBNhivi6zEaGJ5FVDfkkgnHbroXhYjHGkjaFrbVXCNmgm
173	jy137qYs2e3hpFidxd5jfMjcnQBDA6oz3F6XcAxmfsCqq72MUaU
174	jxPPCRJuXRQh6XT5yyC9WasJu3cBLcZYG5dwEXPjkszN1UXvVMP
175	jxNrxENJH8KaV87Qo3pMDurz42yhhR9wHUEktx3BLruqR4r8RKK
176	jx2NPnzoKghiiyUkzo6KHZNxuUUGLNTLYaRkFPGggiuESHeFeLz
177	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9
178	jxmxiSNJ9Eb926A5dT7WLNUXHqbTzuYsLre9xeJfFwD8Sbh7mZ1
179	jxWz5mHtNLcbpbJnwqyzrmV1H7EjnxA7KttjzZBxQkah8rNsJr6
180	jxjHffXZvpYikovKPjFAirkdbq7oGr23tJR5G5GSDB9PQzSDSBv
181	jwDRbeSF3bx9fSqNu8Sy3hWC4qV6rWxM5c1CbNXKDYX7QwUahYY
182	jwucVwAmrz8KaP7BXGGkGXdsvCwyi9vKQfsKbH7aRGzCHPfsqLk
183	jwSkxV81ES1sAKNBbNWT21X6GEzuLGkLxFCAUS2svKGfaDpNpqD
184	jxwopXa5Y1jFq9HADQfQyXCAfDML3bXPcJPpP8oeCtm5wJUZpEM
185	jwFZJXJfMQ9mDsBHK8QYGaoYHEQTFzUyW7NyQ9sK3TRHvL5DboN
186	jwvKyZC3way7jyXiDaKo7r9Bp2SSyU2fTJZpjPuEUFdoC6qi1nf
187	jxiUaqZMCu8hWERtvRPv2buxQvHHjB9kFojM6qD3HcBaTbdpXyT
188	jwF4UQ7PY2gMS96JVQSQGjvwN38GMg1zAaTatk5PsCC6JqB23kD
189	jwHSp5SQTSVf2Thaz1mggWEWpW3m5sSnxeivU6yYSWPUa45TeKb
190	jwhXztdU9KiUwm13oASKpPxKj7G2BeP1WMEcS3vSPKdF3eJoZaX
191	jwykZNEvX2ysWhQj6V1TLRc9cVjo1pMNZUymxw7WFpNU8rPpAjL
192	jxPuHWBBpq31Emb8CvupXv4Yyva3hrubntgVDasX2Vmg686tC3U
193	jxD98UrCfY3uqxfMiaKKMyCsiQLd1BBt8MsTrrRNPPunVXEbkiE
194	jwXpb5kpaaxWC1L4oet8UinnNVZ6EAaEq8VKn29JvhXQ4PmxhwE
195	jxo5vjTHJPGzyvq68NKstPhDKTCVBsKdZfM2f6huoLrWmR1BX5k
196	jxtwWNzo2wbw7ZzcqqMZFqSzfp8DBxE6cvJ8RTcKH3t5wpxZ3T2
197	jweyZ49f1aFhG4ass8ePnwxtus9geW2ck3YNsAqRjDiHPaJREHk
198	jxcUyjus6hnrTvifh4owekmBEEMDvfpeVzPFBTMD3ptFtyfvKmA
199	jxdeMDXuP1EMS8phh2Fn2FfHBcExd4N6Py25KFm5CbdiH3Ueapq
200	jxJFmtYaoMKvRi7iYGy5vRyhTZELkpdcDM9rsvdu4f6i58mSCG2
201	jxELg2xGJV6336wuoowa5MZTMFJuptq4rC1yq15MeASny4N1r8S
202	jwWm3aFF8AzFs1fT4kQrmRxJQqUDZrY6MXp6atBAe4PGLftDxVT
203	jxd9X191om2CEZcdTHR2PHd3EbnJicXanVKBSHdkgf6hQfdeJnZ
204	jxF8NiEyUe4rnysWfqFkjY56jPiuvMNS2ewo8KPd4yqg62xRKTr
207	jwKCoN4qCvTGduQdfFKRc3Mkuhzfm54VgDE1arEdZcMY5L8SnBT
210	jxKdLGRzgHaT3fGxPGsKtPoZpssrWbCq4SKmojjMwLoaA2NRHMp
211	jxcSJd6gV4KS8Srgky5W2X1QLqzJ5tW6J8vTrySVY1mNmvu6aaD
213	jwg5jSWCerVtRzSvvYbmJjPRnFrVKUxWAX6VP3vjqpfuCbMppX7
218	jx4F92x5ydkCW7H5kLzhaJC3Jh9o5UHS9xh682frhNut1un8jjS
219	jxbTQYwaobNAGqkKad88pBuUbcs4M5unqFEd9MyeZQufJXiXraH
229	jxWfk9JuU4Rq4utcFqhGKB3oR3zS5ZENUirFYXXPv5o2GsUbsVd
231	jxFpBXHc4b31zSWWhaELCMPTYcmFEcFLFLYR3QmsonEwemZ7HtZ
234	jxsxos26xzmBLRWghFGxcAaQranLcRTVJPxzeE8iYScdW9Dt3Ro
205	jwLQeHUgbrcrKkoxXwvD7NPQe4vixTfojSjL3qSLitFzaQERL1n
212	jxrqkhbbKnrKkqXFcQTMTvQjQUy4ScPR6k8hSUU3enbHYcGUQbB
224	jwPzCCnc1jx53RdmqoXJwqVJMv7ENbgzyzW2KnLzzxv5cJafhzT
225	jwXy69khxwLgZJuKpYyHp3H43GsHn1Cc2vrUXqRtmrsL3NTPpNb
228	jxfhfY7EvYdxuvSP3wC1VpoPgTR62DFJNThseWDkfg9zfQEK2JE
235	jx2VrRkfhsG4eBzKGz7zj2ffKgQoPWocFjXBR276nuhYP2orVdz
206	jwC8Nhnv4bN2Wirs6djtZnfWASYeREPmB74WbGKF2xYCvk6WhEU
208	jx49XfezdZhJaKeNEPVADk2kLwWYsgDHTLifnFQLMn3cVM3pPGR
214	jxaoHScyrzVS1kTGezQzgHpBXBXCiXszX6nzB2DvUUU9yZKNCkL
215	jwpmss25tXF5ZSuRngEaHF7J1EmqPSkJU98YrHF2P2HKLGhvWec
216	jwgfPDzUAmSTciP8EmmCKpp2KEvEWJAbdNLptuRAtDpekYjwKuc
217	jxb8bQLwvJW4fcRoRcpyjEWpLyDgVfi1nhNjywFturzyUxQjH6J
221	jxB3kstsjVTS1TCtjCLBscMvcanRtS24fu9Zc2rxdwcuEcdySSf
226	jxqamFFEEY9xRVarT2qXjbVVNDM4DvmevdDe4ZUWBwzecnQpgWh
227	jwqSb1tZ1BAkEFvFjwVcYLmsynyJzEze75Xdh4kSAUNfsRAhWgS
230	jxFFTDpUByuyvH6ZUkC8Kcps3zcPQ6ybgSb5uBg3CS6YjPFE9Ro
232	jwL5jyoZf8svasNCzE8DC248qfsJ2zTsX9VVDLHKVwDE3CDAMtq
233	jwhsd4L1nRPoX59aoJ4mJDAeVp75TR5mTn6K3o68yv4oX4fqCs4
209	jx73KzUrqoVaKZURspSM97hCWxDvHTVDKA2bwV5isDSi4Xo2sFW
220	jx4j1ZrCpN9sPkzSe4bcmpupwpmGZVWXHsCwLaSNjpVQMuvP1gj
222	jxM3a5KzFxBqoHD2kM4GA4AN3xnispE77EQ9AsoZkqunrcAJdFc
223	jwrkbt9s3fJ6DtP1FDs5fgYRiPBUFfEQtov2ZvwbEYC8YWkMF9H
236	jwwk1DyiRFz4MpKsiAeNcQLtgCJVXt3W6UdTQKYeBFc9byjQppX
237	jww52gyeBpfmGxPHCpC2of2WndDavc5JPWuVz3hgPiQbd7DW2xT
238	jxZbYCJTNzDApx13MSVbbdyp5AgRhMtYKfwpTfDG2XRu6LKntzP
239	jwVSvxN8BGRJTMPJZKqMNfmGXYQjiaritVVWSvzDtTu39YPHikC
240	jxM5zgA26KGXPtJtjn3Qp5wbz3UagoqUBFFsmfj1oT7gxpHJ5Tk
241	jxXHrFcPp2w18as79g56BAso185YVfgwUUKk69PhYKND3XxxfTn
242	jxv8pQnvvP3dHJtjPtRb2G4zpAUiat6SEpfDiANxeXGRz6n46TV
243	jxqvJYQMAKXW2UkbE6QJLn5bQ3X2xMoho8JHpTXAKncPu5A4kGq
244	jxD7A1pmiB7sBDVaUnmD6cigpoxiwiRfqGGyLjWTG6zuDFv4Dqx
245	jwxaPDu48NHmqz3pcMAytnHLex5PjeqfmdVacxTNSzNp7K4pSWX
246	jwpsVgSY8TE7yGPzUpUoR8Fytkz8fNncNJxWtuD5G3uHzxaZP9P
247	jwYqUtsiHJ6i7EVh1yjTX6QvzQVC7fU5CbBFoH9cfWK7nqmvPbv
248	jwH7kayqtTbAqXXoG4YwhEqPWMzsMJUnfGv6jWSPSy9QUEsnkii
249	jxWtjetxXFhybu4Le6pBPKttHBFzeRnBmTrruFJgsy1ufxSjpdb
250	jwBQwqWUD3Y9ky9X6LeHTa6KiMFQyUCeBHh5wTW9dV3SbQBSZqB
251	jxHznJDdVKKepkx1CxpPZfZ4yvL48xjtS6kkhULYTqXLNLh6oe1
252	jwPyh3GvfM7pjH1W2FwFV6QY2osvGydQDPb2k8QPTR2Ccs6iUQc
253	jwrg7qVC1jRY7UPHJEM1YkaAogj5r6seEvbaCShZ7YceNEuMiV9
254	jxikStgrj28pouQ3AhtajBNawT6cvmZ6Nx7oZo6mfcQK6eCXu7k
255	jxb4T3WhEBiWPma2nvtvTK3SSDKXAMqRGUjC9VB2UipEwPQ9ay5
256	jxozNdoX9TEKJh29Kgez8B5PkuoMyTeWf9QC1smLYDv9bS9Lo96
257	jwSbQgdWdrLA1X5Zu2CveYSgsHj5XapREjy3BkUjrMEZcsv4UNk
258	jx9SU9en9kDwbHZng5s7p9vFbRitdvhdBp9Hj9QEVo6ZPBuPRGE
259	jwtduyw1NqKoz8SH2tHtytztUKoRm3ud4Zcok5bqjt8hSLvVo6j
260	jwQ2AXWuJTFpMDCuUZJsZNUmf4omwq8Pj72Rf8nELfX493rQSPJ
261	jwyMcFkPptSgXpXBzNNTZzJhFt4EdFN9WDUBCydRoEDfkbhVCTy
262	jxVDt49MGguHDZpmF6HeNS28LG9KHwRdrEgaQfNLEf6T4NkhSa6
263	jxc6wmJWzychX1jr2xZUk8eZcR8tYhvZXvfwRmFnZxBANKmVaPz
264	jx2Qg5tLSKLWrZjoUCt3BnfVaCyzbKta7fqo5qsUmtWmbT7RU6S
265	jwn4LQzr6L5orsCc8hcuPXBxf1P3MJZ799RuEPcnk8AbpMs7REb
266	jxoMfpoLLFBJRhHwCU5ntBxxUqSppw27xDAFR2m1o8SHnPJEzHd
267	jxfxadVWyaUwc7VhzRoLgemd2T79AVKuAJaKHe9dndrhtdgMWLE
268	jxLfnKKJVhG5Yr99HdqAvxwviBAkEKL3f5ZNB6CrTYbfrHNh86K
269	jwhXHzB5kTLUoXz4S6TKFoJuzaWVUaLRpVURRjwcSzvdscwdjqf
270	jwYF3NJhy15NceW2zz2uZbuhMQHJg6cPX1aVHyYuSYSBMPKgsrf
271	jwnyTuE1yEkMf8qpt7YJSxts28XP9fgY3n3K9PdnotRgKwHqBaL
272	jxoCFYvRbKYb3SgH5G7yjC6p3bmnUrPUDAnYM6SYUZgABegEJjh
273	jwYWTMqe5TGRh4GqoNnpN9TJeNER1DtpDo2mW8G4W6vGaao7LAt
274	jxnx3hsgWtYg18oXJT1LsZgMxTk6KWuZmWPZZ6q7ZdFDo6GLXHp
275	jwpnJwTZkNk92MaF1EepWANdniQ94W8qQgPPGdMF85BtL4m7btc
276	jxQHsF6YYmrwJVvrNnBFnDk9eEQBMdbfKrYgKTS497SnHfNTfvV
277	jwTEJCq72Sbv674A3VuvYSYvoDMCKBu9toSMayD83zXzACTTWy9
278	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA
279	jxQv9DV6eaJ6EN3yrGFBFW6vb1MybvtyRaRc4jG5Cxtohw9bX7x
280	jwiFnexUfsvhdEanc56fkg6XCXiv7bnTUdAg47G3kbpxx5ypNWX
281	jwWpSLbbMwKaNFua7oM9NSofuwNLJ9Qn3SbWRTZX8AfbcTPVg9S
282	jxpkmh9no785SKwYe9pJFPEzt2jbr6ciSjzMAR7r3BjFCXvuCgT
283	jwNiC72AnZJimaMiHzdyHovf9KcZ1kjYL4k5GTXDSiYo9FEm6av
284	jwBqYUh9QUwSMJXranpueULM2LVUAPg5QH12tC9djaAiWvRsbXd
285	jx5X4rKAazitPF2PS9NvkBzy7LAhPwNWpwcE6Q5fLgaKdyVXEbA
286	jxF1jDHXwtjRN7odvK8F7dJWRaZxDWptU6ppn24TghccygQdkoM
287	jwkgjZAP6eGx2EPNfiradYKgH6yssa7gJrLvmiKptJwm425o8iL
288	jwM5aekpEdcNLZ1B4CbKyhY9ax7sjPcYqaK1cRQGJGskN7puGdu
289	jxcpqva1oEmD4StXX3zeMhM3ZFLiLVmK2opccnqqyXe5s5gCb9e
290	jxD9hEGAUtVStHnQJsxyCrfbxj9mgDyRK32mu48Tywh8HJkAbBT
291	jxUuXSyYg1JqNKDC6PoD2oSYjhoDaBJytRRb7uZYmn4yErMgKXe
292	jxscuHSNg3z6Q9tYjSCrG7tpRwHeN3nkWebHfLGdUEPpzV9XnM4
293	jw9WwH7o38VzAgX5rJjQnVeKPWtuMKM8LJCNfZBXCwxtwEgnjjd
294	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK
295	jx6LcyJt29QDxr6j3b59jDZ7NZyY2EBsRZrV3MjoySkz2QUX8WY
296	jxv5TufaJXMvF6J7gYxxrPtuCndnWUkp5NJpws4ZC1LBJdG5RPC
297	jxdUACYFDWV6LMbbWebWXRAyrLstimGmFUXFzg8rHdxqxjKhMDA
298	jwocqMQ5DAFVDWmB1AZWFwQ6BzsbQhVdrFpChFsyx7HJsrJay5P
299	jwHaRj8mUnKkrpxS6uUCDDVpXEjH2TSggz2aUSPgadnJCASko6g
300	jxabV2psGtT8QogGRPdnSkLD4hoif7kPnMduL8Cex2abVczsFLW
301	jwCQN84D9sgr98kQn57PE4wPfemDe73xXUgjvFofn5kQsrKKSeB
302	jwoaNg1b7jfgZkrqaow92xhYM8YBAN7suQkxeKJMuGvQgQduuwZ
303	jxeBRrAH8SQw86mt6mpNSfnQb5XdS5nRAdBEXxmg8av5PYgrxaS
304	jxBmHi8rt1gKhCd6E3n4zsQrEmbwUHdXKFjMaZJoENKNujgGCfv
305	jwWhNiwpKDLm82eUSQfu1jEiH48zgxQD2NwyVunsXMNq56gJUfR
306	jwH6EPqwP5Veefkoriok6WKcFwEWqVUdH4hSUc34HduVceST7Mw
307	jxAJ1Ak3MHH5RSoHKeujJn9ZRpbWXmag6HQ5jQwdZviuJKdowAo
308	jwdqC6eVRFyghxHeVf1Hx1P9jaH9xZTqLU2N3YMQzZiyFvpXSjA
309	jwGnJnHoDRz2DTkD4yPmWisVXzDWdKNVcS2QKHphEeRgfNqpi8c
310	jxHFKFsCcztSoFUiukRtXVugcDMeMMTwDGawv5GbErSTtBwfBNT
311	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH
312	jwfyTP7iQ5AKxBC17w1MkninmzweeEp43ZxjvJd4LT9bLdBgWVL
313	jx63cidp3njevqFps65SF6GhnXKfuGGojHfD5ajB9z7XwXWcniM
314	jw6n3N1hHaAWf9rjuzrEsqsJTgXeqzcrh9T16mk7rWvfCBBMxQ9
315	jwcWS5vxBcnCMYC1MiLdxjAkRDptUcfEDwLRg2vmMrJ75QZbRm3
316	jwgDt6qoBcgL2WNVu4d6an3kw7zAVmkb464MhDZRnJiaHD7AjST
317	jxWMY6NicBj4PyyWzRg7AmRANSJprSYTRz9DuHYzi3a1sUkzuCp
318	jwjSHdzkkZr6fJGcbeFhBdkH9mQY25RjUDvke5nCvujeEN8Dem8
319	jxuhdKZVFV7ikGs2sKtwD2BRyWgUeVHCHvHTyL24gTo7rdXdvB4
320	jwhcxeS9LLFq5X7B3mhkEDjmB3BN8FxLmDiJvznPniJvfPotTyK
321	jwjxwA9U89GUsDYAaNBhNPkgqhajziojctM1mwWkpXi9iPfTmm6
322	jwSmkB577rkjw7c2wuytLttTehz8pgHGdTAwQcLEQjtzkqJbwc3
323	jwkLWvVxeovdQLhLUZggRCZH2EuaWzKaooXfCUZVNJc29uw5Eao
324	jwrX6VhbT8rY9gvPKZVumT4Uio4J8mbUJWxYyimPpW8bMmBg1SF
325	jxW7o5W9TCzqQDFafJLtUDfSb6mJAkS6Ati2QXKNRqU3d4FiLPx
326	jwFpD4Txre54Y3GbPoGFLZJ2kKx72MFeGWJ8txs63gbfQ4kGVti
327	jwJtGuGW8WTSBq8iuguD4CWPfpbD5nEpfZLqPnPNHS5F9JJFc2T
328	jxaoECruUxEDm7uFhwireAzvv5n7MzgR7uNhCfVzQvMiMT6osXb
329	jw8gCoRe5o5ychf2uL1TvrepMxciAFBusegb8gjZeonMf2Btvj5
330	jwyzezaLpnVmXQddgcxfX73rPVzsrJdFCgmkPeFnX8b1yqD8Xop
336	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft
340	jwFFTJzyk8rn3Gav2ofPJz3X1e8c1sQVwfQNCb8SAVuNttVTkKs
341	jxmJMeUCwoWxpZ3CTpdnd7X1P26P9GTxEsVrBS1q7GAvzX9MQFq
353	jwHpe6RtQAYkcTV9gapcdXvT5SWseeWhw9AK8QtruiPCDzVjztp
354	jxDy8tALuKYZdZz3YaDS6dPiEGoDxfxt3es23bNcyVb2RvSwcQd
356	jxTRZH1nYToHqmvsjNCMArWi2YYRqx8HFt5b1fExmW4BQTA6RmR
363	jxFYyFfH13Uzg4CnYDMFVGNSonEG8hnYX276PUVvahzH5SPmnxz
366	jxNraLZJGKRXSJo9Kvt82F73eeKzVyLFKS6vQnJtpK4NLrYPPQc
382	jwB1dsKj5XA559jfiqCDjQFpjvKv5rF2bTzswvL1ek5D9zxiFGC
331	jwdtiRUeT4i7ALA71XmKarMeVvFGpQ7FmYVfZqyxkumdr5sGVFc
332	jxqr2oPKfc2o69HjvSSP2vrj6q4nKYS8hCYYLcpoHYQPpc3dkbp
339	jwZPdDg4vThU5uPF6hwft5oz5qGM8ghCUzEuRszzAod3fUU23gC
343	jxnB197HzYT3XT4RNCNxfvPmDXcJUn9BrTcxVTrh6bwHGNRKYF4
344	jxqxdu4S1XX2XbNyGHw5wpE63ggVwNfxePDEZiPCpHByKKSMf8d
345	jxpYZffaUniBKMPZ7N6NTgKqtiXF99MN9aCprSHgnrGQspMZyae
352	jxcDDMwi95FVzkoLo7kJM9P75oS1uVTGk211nrfSqKCM9N7wGSK
358	jy2jc8rs2S3CpVnBYgkJDEyzwppMYNvujxHneZ2qrC8tk5ncfjD
359	jxRySSfk8kJZVj46zveaToDUJUC2GtprmeK7poqWymEzB6d2Tun
361	jwMbk5jxaTCFMDkywHhjMEonprHE9W9iSdHVHBMr23xRCfngPPy
365	jwq5TcXBfn5pUEL1Yh6CsZMmXU9GeyQQ4s64oNkqr6N44V3XMYC
369	jx8XSUuwehbnEU2B6n4xEAXn8BMjaD2YhsDNcRWfTYpiVGUAU4X
370	jwRdBGHfP8M72dEPRPB2xEr3MMzdEEoaVkeCS5ZK9ZddWm8YATa
375	jwDVK9NP2hnRzVxt2QxWqKfP5UcP6T2coDw87c6LmTM3Cjb98LU
380	jxephLFfNjk9gwh7WFuC5ZLmFqPb4CovhhSujqaH9EBRVrFX2U2
381	jxJWHcvWmpM5n1G2Xr5ZGzAzKhRprSFHPnXKbbeN6RaMJBGQLui
383	jwaGHxKaX5gxmSPbi8ThwPWwF6DEXgPWoehDVreQLFu4uovB6FM
387	jwe7xgZviU3jwoAv8AmyfY5VXZMyuStSNkbnLuhM8qimkNhbxc8
390	jwbf8KYgPQFG1C15BoChphTtbeyoZBBGXR9ndMiBGpcE6VgLWhs
333	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT
334	jxCtRyBjUQFfu1ceEHC73AW7tNFrNiqVczWmdEhFWhqeyeu6RQR
337	jxbuG8fNqRWDmpSoMBH4AkiejCGArqQ69pz4ARD8jVds1Y7HMP1
346	jxdBkH8u8dy9BHmyqdjehSPfbcoSXaU6WfoWXFJZaAtu5gp7Sew
348	jwUPqD4PeuoNbyXDBAtE86YzsqeBMUs9zpufQbbEZDwGK4z7N3u
351	jwcnYvAxpJybHDMJr4UtJ3xH5kYwjKpWjkBrx2rgp1MqJnb4N8s
367	jxbcGBkASp3Z4NsDtDqgdveZXmFXT67kWwa7WUCrEdJ5Sd9ot2X
368	jxUKnTjoTaJgcDt9vH9XQUcLXpLFaKT22ZkyUkgSBdmmJt6kEfQ
371	jwT1sYu75sfKkvHnGzB67ZgLoMBZj7BnFXQT79TTCCTkgJ4Z71Y
377	jwSzmyLYBieFKczRh2ANpu5po47naHFuPggCpufXtfapzyxdnab
379	jxXx318QRMJ1LLnuCwYA6kgntw7CeSqcUwtm1LLoMCv2q4EAnJv
384	jxsduu9cgiV8FVdmXEFh6vK4X761jVxUPdFrBE7FJYb1BNkXDwZ
385	jxBPYnTWLmpg9BEjZDrHdLcJ3ThkfMbsxsFNpX4w961iMHoLFit
386	jxWyzJYF5HrYorzQ2PW8xFtYUZDejBSt5iJKhacDRRp2PMSuaWQ
335	jxm6nZBmmNukd4khYhwD36UdvZR18kS2BrArLSTNtXULpg6Z85w
338	jxkKoJj7X3GLPLQ4aFWcdTNcBk6WCkVJaPNwkfKGHDwfwKUPxeY
342	jwCoXfRK2oSBnjaVivcsKj9GwPdJa9w4gKWGXqNBqDNLjddjVhM
347	jxhugE72JwMnaoFs9NQurfDZHycUF7HdtsRxcupA3DKeHAyEPBe
349	jwwaWoeXLGWbH5FPmBiRaehAWQfx64QYwzPd3hi8h8SmxwSZv3f
350	jxYeLmv54jG2oEihS8CBqhv9MTjnEC89MSTyepcoD5UPc8MaYJF
355	jwneCT4fB34456iPozxxSgLWaCmsxa3Eki5xD9as6RnD8wrSptv
357	jwX6zycCsS9jwZCkSRxCDaj6z1HiCYQddkbAHs6JrSeq7RHX93H
360	jxX3n7Yxb8EoJcnkhxnwGE4QjhWxo951dqe9fL2krh688PCtES7
362	jxosoWszzBnHZtMjDf3EwpaNuBrH1ZRpJq8iM2st5FmoGo7KthU
364	jxa8rNEpLNMfqh7fv5a9LrJYxpHrb9a8CwHbWdqPfVw68cWYhhP
372	jwGQcHUxe6Xfw6YcghCv6PAxwh2rC95A12XiJsyZWLCAWG9NAZd
373	jwaVR17CN6tcUSC8b5ZYYzJNyfTkNdBMbG7jhYoYSDW1CcAUmxz
374	jwLrk4oMDRwoXSV3AUP461gm3aZR7Wycpt8nQscMWBXjdbwifSy
376	jwTAzif2C589q9MAh6PS2sxy5hDUKRWpUcUdHAfaR4ec1Kfwtjr
378	jwtJMA7CFLxa7c1NriHWquPjXeFEqdriCg16DtCZZ85fYZmXCFM
388	jxVnrsKhVwXFoJZxrCt6Mp4ZxGrsqYjBTwMYjyPwrn1a47DxZ6N
389	jwTE2dBJxJGwdrfhtXHZqp9Wqsi6SScZ5cPdnSstnh8n66ppwSH
391	jx9vXVzVge3Wtv9HPRvDFpobDvk9EkgxLAuqmFwC4hW9xtwbizs
392	jxbPNkRG5HDAz8RDxT2QGNjTL3gAzaGZVvcVHyrcs4g9sDtzhac
393	jwcg7ZC6zc26QmB31uN2JvZ8rcwfCKxDeQdaufSuXo1pY3cDNBs
394	jwgGiZypxVsExptBvxDrwDQhDX1RwfQnyzDQiryDZHXDbWQrLJ7
395	jwkAy3CXRgEKGm9gKRXqytrisg3P3tTUbmEZ9Vq7QquE5R4rdaU
396	jwKjec1PmwQYygoq4yB8gpSGbUUJMRHZn6DVULdLzNHMStMbxSv
397	jx5XXQvGGxmmbK56w6C6B3TRS7p4tbX7vT6ZJhVm7Pr7GGwcRJN
398	jwECMnWH1w6fejnTPoo23yQQCazEDyNmjAh78ZUnoQk5Ko4QWfo
399	jxDBMgFWLQTjroix6tfQkxxUvgbHjjQq5cnb7TmK8w2bgQ3Uaot
400	jxTcGmRTSq43YCpJjL4JQ5tu91E8VpgV6d9DUZuF3TUsNZW2T6P
401	jxckBo1PBzgBqufbqKeMSnRu31EbCpRRF7yFE48h1637X55woWF
402	jxzy1FFzti21JFN1SuS7BhMKTKoezUJ9XVQkojhRQb9cHyH7Lyn
403	jxovyvXJTk6GvcWJLjKDosYDQhS9utd7oejPwP7xwy5TexKWoC2
404	jxFwn2a4pHa7uaMo65NfKjGusG8n1nd97hYhgNhtxvPR7647Gx7
405	jxfg1qyM1wozQjrwDXhwaS9kQoK4JmN6gGh4WR2H2mRnwxDvJ7T
406	jxu8A17chD6e6v3qSszS28a5Zw2jd9AtevSJuTdLiE2yDCUqP9c
407	jxWYPnaT4FEFMJiMn4osWLyP7McuFojtRXi9k9rSbWQod1NcaJo
408	jwtoADBG5LHQNgRPXukiCjD1axFB4x4YrQX3FcK2dH4jYf695Gw
409	jxXpLxdgEWPGQFuC6U9dd4hefkAhdBJjaeEto4WzUESfWdTFQ7F
410	jxfseJgX2J1gQXwwKaTbHMVbYNVPLoa6FBwQ6zRFy8b2wXBoine
411	jxoWXdVSYzmC9tVeeMecoK1Chkoe4P85xzzeYczDPbqTmuPvHh7
412	jwFbNaTNAZVbgVyv3Zoss52zEght3TT3cSobUtibxA9S33Yqhp5
413	jwHxEHKTMY2uWBzzYgdrJP9MrduvUXL8VgNZ6jrzFfKQUhg58oM
414	jweqHHq3A5WLdfDfKVjjppMm9Dn1xKWBfyNBqBEAxknZry6pKg5
415	jx3aL8ZSLtr64FYMxXFMtwDSiGEu75LX6x7uLT19DgU2KMrAUtB
416	jxaT2Pkck36mQquUG1p33Danmmvs17igpVVLUHUDZxhj3gRgK6u
417	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x
418	jwTJzwXEuiNrWApUs7Zh6c69VjNPRdNNQYyqUgGtcHkDqUWxUHM
419	jwHiGWnXnDjkmwMRkArhTTYuoZYm119Wvk4RjHTXYLjfJWT3Gv3
420	jwVQ7CZ33fCo6o6s8xDvjKTjW4UTWnYm3ah2oT9iS95ZWE7Uvxn
421	jxdmAjbZy29UGV3gGy6f8vLyAe5dn2dDiR6NeeCeFqirWu6Cznx
422	jxzgf2tUNWWKRkDS8nUweXX9aZfDjjaHgpgmSMbxhTRst8hZu9T
423	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q
424	jwXYewRpjfh1oQJxCvwEFyNAaessWzvxVo2636KuDvAYoHCPGS9
425	jxxvhvF8UHQwCqmZWF1PgS2QVkAypjBfnV9ms6xDtCDsaZjmXzQ
426	jwbHYwGJnjjW6fws5LUxsc3TbNmXH2156cRzAEgpTaaonQKb4DW
427	jxVNyftpRWaaSzAKWwbxNV6yddU8UZMqA2kZREwiT81GfZKzDoH
428	jxAT515hv6R3sDfQgC7nay7NTnNAVvmvjSBjG69mVvBmHLsSYxP
429	jwjyzb9HAeyNnwN61RAHhcd19vWbjLde3rgaBekGB229VGVggfg
430	jxAgjNb7yrqs2jvawZ5qWTeRkxgefgMPypnjLrkxiSMdTG8fzNs
431	jwmGsBYGLJARNhZzb66jNiPCkby8WtjKb3ifn41oDzA4obS4bTa
432	jwSWV1iyrA1WEVVdRNJWx9Xa6XRqTHEjX4toJVKQUuoBEveeukx
433	jwxVyDFog8mgxvUzhhLRGGzYSkFVMCNgpThVTXcVnoLeNMDWKSW
434	jwVLZzk3RJymeREjjETBsDmfHepQ4LhSFVKLw4VyAYXhmN9fCZt
435	jxdoZ3dJcT4Vq33zFQ3Lu3ZLVgaaoUui13AWL4igE1bwP3VtcBH
436	jwMQ3w1AoCQ9LvmmdCMC9w1L2jt5iNYRfd7wSH4CdajP6Ljav7R
437	jwGxaXvVdw3YFQwMAkBoGrDNj5Vjsqf8ryYhX8So2kSDyV9Ur2Z
438	jwAeHi89Pm7yKJTy4PwiTWzGEmJcHfyKW26vXgFxU6JL45iC8UC
439	jxdeEhwLFD7dX88MLU6oMabkj9JDXzCf7emjibLsWJqYDw8CNCj
440	jxa7dkwwFpaG1WfKcCyMpsdKVxrxBWZhT3cpGgaNy9THqspnksz
441	jwvrZH2wNji5xeQj1wFYR1VQd3BbJw3u5mzLWURYvPitc9XSjNh
442	jwTWDPgmM4Y2ZgG57UhxqxwnYYk2JRz8QLFPKQ1CTKascc2dmoP
443	jxxE5WNPkdfP2fjTmoKZbxkrkFFURLq46hD99zcUuWS3adwev7R
444	jwQ9fBUGpujhku4rD8pUKGSz18zhfUcxwY6zSGeANFFQzJ55mpP
445	jwvRo5QKP9vwvp1hjJzMJNuoEnBuqGE2ytL2t8Bk1ztWH6qDvo8
446	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN
447	jxxd2GMHrwaq2BdfNamZ69HXdUXTCoTECJVPiHFwWUjieUkPXZy
448	jxzKV9w2mrNzhLipAsFbMP8yURNDk3N2W6ajJBeCTrEHzdTbWQ5
449	jwsSVqSuLYDnAdzkExDFVKu7frQ785TQkAtHZipb79ctdTSDyop
450	jwZB5zfnXjV71L6PesjEBQhqcawU1FdMej6zjWP7aGnyBxvNWSB
451	jxEMb9mwxhb58ErvwHMi1Mx98aYZuFjD8LBNfLovpaJgS8g1CiG
452	jx8J1EuwCAhknywJyfP8sKLKsdAHyAcSfcayhqCcZqPp7kEu3xC
453	jw8TQmVEi8Yi6GzB3f1diY1t7ULcLDoswm1pJMaoytFqHHFzK1j
454	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD
455	jx5swDXhhtPnirqz6QM1H9RofZvzz6KJgkygtchvxKSczsdm6BL
456	jwxFhwwyttkhYJ2nu4QybrwssyU4L9Dq8DQ1n88QThKbcsqpHpr
457	jxiruQckZJhqsdaTpxgqQ2CAt6CoQNqrUSDgnKEh1WaJS4wai8b
458	jxUfCpSa6f8cmhwRmhc4BggzXfdYQVD1fX76h8ugo2dkcWFNDNt
459	jxbgqpGYpZLxqKDjUtp3AuT5APjVjSjRySjjXUpQ8pj6G4PwSTm
460	jwKHK4X1rjsRSQgkptwFSyzW2jwar1HcNrQkn6jXCz36d9BH3xZ
461	jxCQMjmQLvR93k4rpXFC4W32vmrKyPwRp1T5MXcdh8HqTXyq2vW
462	jxmbZPP7Qqjq4fkPs5zMtHKSxkMscEM5R6kPEy3K7nUR7U2fpRq
463	jwyviW33UJzbNSJ8BdyT2auUr76o9ssT9ZHynSkXZyz9Emhgdqf
464	jwVvtvnhrsfWWSi23bGpoVWeQAZeHDHyVnVW6DrJVuQS3tgSNrc
465	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF
466	jwimWTPJfhrbKUAJ4DegXehCJKBDuAW3UJi3VXFNDdEXjBZdx4r
467	jxjpwsva5u7wesHKsKx5tQnkQs2ByvUr4nQJyCx8VgHuWtp6AkS
468	jxwdJVEzemtVVu9t9Kge3GmRzKyawYDV4ZSqvi2ZpuwGTmaphBw
469	jwki1i3DyQNtypA3MJNf5wLR6Y2hu5h6MRQwkhadWpv5RZbnT42
470	jxfYSaUArqHHPHQjydq5TuyiPi3oXP6WMNScLTmxyRNdwpDaKbY
472	jx6nccfzCQLL2ZVtXiWsNXxiiuqaSPVSUhuYQxETdSpw8kiJ18y
473	jwpPGbzYJMhRpVMv8gtZY6x1eRrFRWMfjyytQiqFuw95rEA81JR
478	jwGRry8va6QfSWvTdihM1QQzby185wUSWNZvyiAAhPaCaHmZGn9
480	jwcekdMhPsLu9q1v5iZE4xAQUJnuUtrWgeEELpJLDFajUX7ukNk
471	jxpXr3JUXudRgXXV1ybQgUH6tuViAmZ3Frn14GQCkvYTV2M3VZT
477	jxHp1nTyXsmK3UYkMHePP86ok7o6mRoQi82Rh7GDnbdXJsBovkL
474	jxnW7VXcdLKYZNS2e2uTnwxWyNyHdTUMR4xAB6kFuVyVWmME3ox
475	jxhMaDmmEPkiaUTPq6TmpFqbkz2NbdXZJTTiDQQrgeVdxuHA1gX
479	jwhYys1jQSC6Rt8QAMDXYzZiG6jY18VNa9ms3GkTN6qc7jsghML
476	jwocMu6bwTpZqy9SPdtehQTrEVm3TEXmqecQQkY4puSjxQZbk8i
481	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV
482	jx6jY1x7AVtrZbdu28sw3sUHRpZebac9ytbLqhCZH51ZtmAYw8o
483	jxR5Cxf8hJLSmZaPf8yoDB9EL8djzZFnTgYWAZRJJteNg9DMnyj
484	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s
485	jx637VFgVtMAMPnGyoVEzTsNzGdT3nsLhHXyJM1WHjyF7Gn6NoN
486	jxEdaNv9iRen3up9sFc2xtk3cdGnKAXP15UuTABxQUXtN9mhfGP
487	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2
488	jwcymvcNNCNMT6eH7UQrgfcdwi8Z7teZ3FqqF7YPJYZYNG5Qfwv
489	jx6WCsq4pfWFAXuxoYadWTJ21UFfBGzNNzWDmwuNhN5o2kuXTfQ
490	jxD4EZ5RZhauz8hmF8MiZVj8GmPKRdKbVVixeeryetb7PCbvFRR
491	jwNBR9XKajwBfYuqJxLFeDggFK5gPGK7iYjHTc4VDwLe3QR5HFc
492	jxHJu7cTdaxJAFQFxRxjCk9tumFFfKLDa9C7CD5NVL6sbDJTWPi
493	jxGixkkdxfXmWn3c7WRCwPhVFzxZkHWmkwZK3D9yG6Qcwn4hF2X
494	jwHzfSo3YrHwExfXjNwv7TJDZjCih8CwNTmyWNdExA3uouNbCb1
495	jwxqJsUvsfPhZtH6Ek1cei7ML6aNRHZmuZEgcjd2hgiV2GhGvk4
496	jwrkUeHxQsatbuEWJi55DJvHS1pRQzjg87SBwYMm2bDEhM7gm1o
497	jxf6PpACu2zLk6VjDjc8ctMRb4DBMaevdXJwhajKf8LrTpUKdPf
498	jwyP4CqWyLSSUH3saKdYqp9nWRCpD93qHVbyuuAnLVt6Up3mezG
499	jxRY6nWteCgm9hk85gj3G3F21gbUdqsx6z5MWaTkVZnfzZ8ip5a
500	jx3uZwR4Ja89fVZaXoJBRQPVj2B2hgnhHbANWm5vpewcZP5qo38
501	jxqpo8tdBC2JGH4UFQnFuW9jZvsmJRP58uuuP2HhtvD6cE4WaH5
502	jwT8n2BZcJbyD4NP63tXwPxubmuhQMmcZKVHW5mTzYAknnNvxoe
503	jwLScegvDzhGqxSVmc6zK7hBE1ci9yfjZqK8ZaupkQycHETEkmE
504	jxUHnkBXAgzyx26MArQ7Gm5mBokGKCzieq42HVDaRYfo39wgtmo
505	jxcsZ94tvimnQFouNsH1QX1HvqwnuN6sUDbxxCE217x1jDubaCv
506	jxMKhRbc4pgqn4ESsbzniDQx3cD2VyAooXi6GUEQ8QQpX5aZ4X8
507	jx175qxCqf3VReRDXeiBqJePuKe1SfEZFXZMbNBupcEaVwKWUNG
508	jwA5isRxiUN9LmSf8bXYDEqrUtAP2wMxG45SFyDnHMD3x1ZmwHv
509	jwru3ZwcKmb64mtEthpzxrWKZDfTkrzRDg52CH7yMyC3xxWQMwZ
510	jwMJAXDhLPMgBc5TYDPF1Nu7EnPcXVPZewrPUMwZRo6Ky6vBsXv
511	jxxpiHo9vj3MCNb4RMqzx8HpidUWijfLXcx6X8psgrqTntpVNiK
512	jwKrz77GAnM5x3uGQzDbBqXMiiAh4hPQgnRik7MAVZuiiWduPpy
513	jwcRY1eukhsMmsSGvbwbeBVry5uPnRUQPVCVtTERtPT8qac51Ur
514	jxXRTGi5t3u2BHe9JJdnRjgEUxQEqvj1vfwnm2T7BBdyDNXEqY8
515	jwQr74P3KNgc94j5LZPufUgs9MB14WTRAfrY9V4FdxkNiRjFMSo
516	jwmYpxsBbwM5yFfbtiZcxEhywFVNbEiqDGW2w4CzvRSSF6xCRHF
517	jwwJCrfWyv1TJRM1j6LdZ5XD8MfZSwvgpats6iiMXs6TVz4XV8p
518	jxiTk5QpdN4tRRVNpfbW1qmhh1UUkoNeqXCo7GRSseckryjJLwS
519	jx42MYsMM21YEVKNQ278gn17qjavTjSbBhc2x9Vwmzz1TVoviAC
520	jx1JWegiStQviqnfHKpLXT6xhvBjtu22VMVMJMRQAeou1awAcUU
521	jwRwmJqNSQcQ49cZwWh4xzw5YkEySf75QL7s8JnnbqpWhUqTKzy
522	jwWhyssV9Nw73phNrzFqQyzBBq3j4Msit64E3hnvejDUNdm4TFh
523	jwtSDyJbZjF1YkNqFbks5JcEsgKAbRGDS1GQMmQRbwWdH8cBkiP
524	jxHc1YZ3p7uVzqP4TWB3yz24GcpZDodsMATKyochFgWLdAQAkVh
525	jwwbPts4kPoj4xaZFDFicEo5yoe4JkhKzXfskfDD6KbtbsShdue
526	jwfZvdWG4B8cB5hxF9YhN9xMQmTbXrYVpTWP9R5d8iVGqxmj1KP
527	jxZxFw8jfLZpBQA283rFx1asbWJ5po7XYU8PtZkCyqWyZs49Adr
528	jweJWuZ17chq9SM5fPxZuiZ7kvGznmqeCBbUwubXgWNF5LQT8ia
529	jxWU7mAp5UCrYMjjBErYQeWE8xiJ8ATvX2YmXAjnTFyqoNqeSPN
530	jx5JB7jvwsHp1cpwHwwrMGtBVPvg9fu5WbeihVyzj4h6EFUzVor
531	jwYbLCVSem39nuwfWyGMji5stzDUWbkHKyQY8pnu4JxtHV31Yp4
532	jy3Jru6zLRaxeQxx6iVzRALJgANqeBJnQ3fMcfwLzptduQDbByh
533	jwbJTQNrAr31KomaGi2TJnMjdAhN4mD9DZSWSsThFUkyxWdhay3
534	jwxKizBwd2tEcZDfCEd9LgbX9x8GZoswHy8F7q4q5F12TLb9YQo
535	jxea5NYDgbxGoPWc48ZdYNQTZuNCKRcbN7Edxw1CFj87fCoNJFz
536	jwH5FsCT5RGgvUbrVM3rGW5k2y3hbLzyMEPAK8YhhzypgBD5PFq
537	jxY4ewT9mb2aQgwq4HczaPmRoYYGzcGSijehgPEsrSdLu55qKRb
538	jwboKaqytxsv6Vi4M8BA5SM5rxWxYyTg6UFHjuwNwV43ZDD5X1E
539	jx6tVznmFXuMkJsRSzh4G2AK2HkhcT6NVys6D6XaGKvwFh9m8LC
540	jxohUyr9CRYbBbZD4BYVEE4dtShg24GoE3A9AQm3hPbZmqZ133j
541	jwEcBYsxr6w9vp8GXRPMYXpgHopVXyWdv7BS9q2uPN9Kv3L5pzq
542	jwmhZ5g6w8YBn8ESymfevfyLLvgUZKKFanS4H2d2pbtN4S1wQeY
543	jwozxcSNgsghYxZUMsyYeGeNECHQrV2BDqze53xdXdMkunqaBjJ
544	jwRxYZ8wU3mEpBUE412jAvqFy5wp5iqjW3uxEUoVcn8nMLiugw3
545	jwLgQKDwfyCoxUBw8PPysvFzr9Coq8zdJmoPfg4ZL8ZvkUz5RR8
546	jxhoXG52PudRq7VCidX1mKsZtcq7cVLh5aL9rJBJo6XdNPpQANz
547	jy1CRmYRHcEtFvCuQK3fRTV6EGDbd6xk4ebMcri3M2jZAnDL3bS
548	jx2QvxQp63GmukbZLXomd1k6UZRUTVsTAtPews8HMWaFipeQaVK
549	jxourkN5WoCAou9XXxg2YqT8c8PbMTw6uUQmym5KTAwejYJ2ezx
550	jwBDyCQo6hhqyF5wLTstSB3sBqzrbwYi5CfS2ew3ss6RfdUtaG9
551	jx4q55HBBqCLnwD3WgrWjMc3UtYugR3Hxu6o1teRkgxK8anhadC
552	jwnSz3BGnjas4KvHmnkwhsbofCJWyLqaGQkz2EskSBm52Fzivaw
553	jwkScH8iydP7jwTbMgjmg9kGv6kyocLRjYqZq24M8BSnDK7M7kb
554	jxzjotVwNpPKEpSu6WK5he6Qm3TN3iQ5iqL11sAPPa65Bi8qDMK
555	jwmhag88GziRyiudKC9HwLv76XvEWyFQTZe8puzhSVqQS6cuHif
556	jy1hNxZXetchwbZvvNivap1hWjayMYMngcFdYYj4b7DX1dnkYa2
557	jwjm5r7Jx9BzsTMVpVpXwsDZiapz6gxnPPXeH1dRRGmwA7WwtXi
558	jximV1akw6tyW84MuCeM28ZY67LKhV8sMAwuq4L1k5FNmKgePWz
559	jxhp8nzVWQzLwSi82xQZed4uHK7VvUgdtrHzWruStuSjPVySd9x
560	jxC4w1c3Cs4Mb2oe9iGdd1neKakKReN8CUWw7brZaTSdhjpLifj
561	jx14VuJHV6B4bA8uYLqGST8UQ1azeyb2MSKXHYcvrgu8cnn2abD
562	jxRqwZ42D8Wtn8zMKA6sccF4bfstBXRBpsdHMus4sGZwoR7phf8
563	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx
564	jwYr1adWuoaUe56xUhmF9XMJJhaScVEn6hd1ZkGZEBgf3QyHJ5K
565	jxFbfi14DokK3ANfJUyrDBNuNKq6CPBaVn4P9g7YP4t32NA34aC
566	jwsHFKzGBsFThMi3WUmVB7rQWcHBifRAccZ8pzg34vNaA2FRyWd
567	jwEPGNxSaQaBfyyLf4pCmynCTPiQ6xyWef2YLYNTZ5vZePN86Vj
568	jxrYr58GTvmvvHrN4ahW8ZbnDz4FywRCpvNTYnC4wZ8FWVG3Mhe
569	jwUrrrvHZRvv3Jpa6DLPhVXN2G95Apcty2XGci2CoNs7pRMdYYH
570	jwnixvANHGUGy2hsvYws8zBDSQT4yyTHA3VAXcDFEQTXryx8zBw
571	jxkx5EQKZgbX3CBnisAZkgRXLBCieh7G31EFLuMNyeRqbqBx7KH
572	jxH2B7BpojpUnQ5mKF2yhnqbVfVm4DxeVgPNQeY4WfzcDF3aDMY
573	jx3KRDm14w8pLpHNvHrRCvCvyxWqHBJPCYFojd3TRWcR1LFBkzb
574	jxZcHUgGyPtgsP8QjmaXMvq6c5WCJpY9zQXKUF3RNcjdXyqWet9
575	jwLGkjgeadoHrG1ReDWUvVFYzsNYNfRGJhyQkGL5rW8B5nd4cxT
576	jwwqrLeZtFZj1GvWAtPmsvYTqwTQUwAtX7c5KY7gqS742iCBUNf
577	jweEuDHmEHvxBk79QaMv2sXr4rGNiC9Ukr3UUS8RwYS2SZidbNc
579	jwTjLNMQ7ZFS1tou5jVaPPeeihX8Xbotx4aupxqduSRe1x1YKEN
578	jwBQGk9PFa2c3MgEDNFgGuER7kbz7WkXKN3pDVDLy3qtxPGJEXB
580	jxNSqwzAQmh9abvU47N8VbQcVVu1EEQ8sxpN7bEb1eNoZjv4Gvj
581	jxyPqW8HhCqiFrJnt4hQEXf92BQWubK3AbzRDoCWYMimkFaVkM6
582	jxXcbhTzq8uVuz44qpFYqkkgeHGPyWVFAWpMbhNJNBSFKybBFMa
583	jxzREivZm9HiVFRe7es2nybPp2b4dFQvmLswhBxPeafLvX1e1Ph
584	jx45TLK6gz6YXm4G52tCFzj2N99QZKAonGt5UfJu4RDjLdyTVpD
585	jwotgPEG8agCS6pe2wbZj3TtDGkC3AU1Nuy75oDuW3V1L4uyYYd
586	jxnGWrPF442fH3JXMGxq1Ccy5LfyKNdhDW6AxrqGXsNZE7oWRe7
587	jxbS4TB3XQSrF4bDRZ1gQn1etM49mDHukjFdmMxqaUJuYFHikmg
588	jxqVKnnHBgmfppBJ8cRDHuTbEVpQiYCytLRCaGUff4B8bB7Tfhs
589	jxpfNJzBCdWdVMwazCtrVMxiJFtHbHWGvDAXQ7ebLQ3GRfZYKKM
590	jxcAPRzGMZWW9GjLfaPVAiNV6XX9cyPWQ2vz3XrHV9rQCQbZyPL
591	jwZsk8NpjVM2A86j1apRb1Kde4bx5FbkAtr3BpVpY2P3jZ1oZY6
592	jwMuKZw9RC31jJiHRYZpkeusGo9TGkX1piEDk3HubU9S6tz32cC
593	jwwxi54FDAzSbDSd1ZT8T8vnt9L9ad2NQbQzF7RiVKSVKZH6m2h
594	jxRo8kEE7QYP8z75rSrpXuY596KnrttdpDgN5gMbqogmfNSXXbV
595	jwzmmbJGie1KuqeXsnRh1wG24MPYeceQe4Q1YPEMXWWoW9dEN8N
596	jwvidPchWb7aoP3J3ghqCanKUJhMecTj4N4mmpEgcjWWh9RWmjw
597	jxskLeizVRCsXQUHvmRKw79XVCPVRjwVLZPEVgF1MArUHnh6VLg
598	jwULV5Sew96RsiF2NLgPhR4eiNrRkwZejprYYLy9gicLzQQurB4
599	jwxPrfAAPoP9RCWGCxYbVrmhVjCWbvBsj6zBG2V2tYGpxqqoMcg
600	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee
601	jxXKUuS3kX1jkLTu4Ejk1SCmBx2QWHp38n2iPs9eBNHJM1wKg94
602	jxrLiTfG2CLF2VzdKhwsbbhY9oAAmK7jj1t6JoyczxvL7Nfkahe
603	jwBxcvAhEP1oSGYM27vnEZoL93Bf5ghH2ckqiruPuKft7nBdbuk
604	jxAQ55SD7uQAw9paTvJUJxCpiYmAxULi4cQTS9MN3CcYcKNU9qE
605	jwzwVyEx3aR3FoFS6ef4PBARzcyx6jzf6oyxanZbfdedandbe16
606	jxwm5TZ99MRgdqH47yirzqXBgiQVuyDxoBrseAu8u7X6ZP28Z3n
607	jxmYdpaC5GoAyKTarheY5op4Qrxik6rJACj74isUvd67CErTweJ
608	jy2MPSm1tANMkCFZa29KiSznsxYWP3mjwgupuKBZmtFiwfq43gd
609	jxYciHV36CU9RxFzJTjeU6tPAVNk4T8SPjNCT4tQkVnRKS6DbRZ
610	jxZc5uLAet4VZDxxqRTBtqv1zRMPJoBB8z2dcHPYC2GkrjTXJXS
611	jxmrA2rf1xEpa2GP621dG7ufJsSyQUFBmadMJ9J6pbUJ2QkJZaX
612	jwP83Y69MkrRoaZXzWpgfZe3t4ZLNtZZ5PiVPSNcExXrEusACAL
613	jxHtaHVYVCw7KHX8ZETHBEAbPTDSLXFQ7eX3tDHUgdnZ83afJxR
614	jwiJpE9ixQLZKZrPSk1LzCGjLk6kt4E9sCV7ti2dcdF9MfmrMkw
615	jxfMFrmHkwtxUwNcoX99sNZocfAzEZzwrLJV9GY4Gtag3q814rw
616	jxB18FpuocHBeXtPcrd1TyUrQg26NBCV2BpGSypwHmGGCTT54rQ
617	jwYZinZPApiQmKStkwCFJRa7MjY1YjjSa4QjjSfdWp4jin19xad
618	jxpxMEn74RyAgLxcDVKi9ZjkZcuD5uvEEoNPGKq2FjNarxkU6aZ
\.


--
-- Data for Name: timing_info; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.timing_info (id, public_key_id, token, initial_balance, initial_minimum_balance, cliff_time, cliff_amount, vesting_period, vesting_increment) FROM stdin;
1	1	1	372093000000000	372093000000000	86400	372093000000000	1	0
2	2	1	230400000000000	230400000000000	86400	230400000000000	1	0
3	3	1	145418000000000	145418000000000	86400	145418000000000	1	0
4	4	1	148837200000000	148837200000000	86400	148837200000000	1	0
5	5	1	6697000000000	6697000000000	86400	6697000000000	1	0
6	6	1	32558000000000	32558000000000	86400	32558000000000	1	0
7	7	1	2326000000000	2326000000000	86400	2326000000000	1	0
8	8	1	10233000000000	10233000000000	86400	10233000000000	1	0
9	9	1	32558000000000	32558000000000	86400	32558000000000	1	0
10	10	1	32558000000000	32558000000000	86400	32558000000000	1	0
11	11	1	4651000000000	4651000000000	86400	4651000000000	1	0
12	12	1	2791000000000	2791000000000	86400	2791000000000	1	0
13	13	1	4651000000000	4651000000000	86400	4651000000000	1	0
14	14	1	4884000000000	4884000000000	86400	4884000000000	1	0
15	15	1	9767000000000	9767000000000	86400	9767000000000	1	0
16	16	1	9767000000000	9767000000000	86400	9767000000000	1	0
17	17	1	32558000000000	32558000000000	86400	32558000000000	1	0
18	18	1	4651000000000	4651000000000	86400	4651000000000	1	0
19	19	1	2326000000000	2326000000000	86400	2326000000000	1	0
20	20	1	26047000000000	26047000000000	86400	26047000000000	1	0
21	21	1	32558000000000	32558000000000	86400	32558000000000	1	0
22	22	1	22326000000000	22326000000000	86400	22326000000000	1	0
23	23	1	32558000000000	32558000000000	86400	32558000000000	1	0
24	24	1	930000000000	930000000000	86400	930000000000	1	0
25	25	1	9302000000000	9302000000000	86400	9302000000000	1	0
26	26	1	49460000000000	49460000000000	86400	49460000000000	1	0
27	27	1	10000000000000	10000000000000	86400	10000000000000	1	0
28	28	1	20000000000000	20000000000000	86400	20000000000000	1	0
29	29	1	7000000000000	7000000000000	86400	7000000000000	1	0
30	30	1	6000000000000	6000000000000	172800	1500000000000	1	8680556
31	31	1	1318605000000000	1318605000000000	86400	1318605000000000	1	0
32	32	1	73627000000000	73627000000000	86400	73627000000000	1	0
33	33	1	10400000000000	10400000000000	86400	10400000000000	1	0
34	34	1	66976000000000	66976000000000	86400	66976000000000	1	0
35	35	1	19200000000000	19200000000000	86400	19200000000000	1	0
36	36	1	30000000000000	30000000000000	86400	30000000000000	1	0
37	37	1	65328000000000	65328000000000	86400	65328000000000	1	0
38	38	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
39	39	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
40	40	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
41	41	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
42	42	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
43	43	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
44	44	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
45	45	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
46	46	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
47	47	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
48	48	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
49	49	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
50	50	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
51	51	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
52	52	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
53	53	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
54	54	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
55	55	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
56	56	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
57	57	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
58	58	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
59	59	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
60	60	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
61	61	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
62	62	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
63	63	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
64	64	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
65	65	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
66	66	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
67	67	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
68	68	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
69	69	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
70	70	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
71	71	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
72	72	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
73	73	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
74	74	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
75	75	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
76	76	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
77	77	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
78	78	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
79	79	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
80	80	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
81	81	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
82	82	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
83	83	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
84	84	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
85	85	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
86	86	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
87	87	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
88	88	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
89	89	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
90	90	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
91	91	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
92	92	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
93	93	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
94	94	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
95	95	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
96	96	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
97	97	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
98	98	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
99	99	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
100	100	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
101	101	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
102	102	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
103	103	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
104	104	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
105	105	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
106	106	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
107	107	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
108	108	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
109	109	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
110	110	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
111	111	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
112	112	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
113	113	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
114	114	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
115	115	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
116	116	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
117	117	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
118	118	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
119	119	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
120	120	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
121	121	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
122	122	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
123	123	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
124	124	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
125	125	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
126	126	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
127	127	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
128	128	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
129	129	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
130	130	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
131	131	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
132	132	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
133	133	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
134	134	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
135	135	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
136	136	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
137	137	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
138	138	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
139	139	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
140	140	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
141	141	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
142	142	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
143	143	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
144	144	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
145	145	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
146	146	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
147	147	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
148	148	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
149	149	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
150	150	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
151	151	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
152	152	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
153	153	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
154	154	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
155	155	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
156	156	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
157	157	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
158	158	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
159	159	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
160	160	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
161	161	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
162	162	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
163	163	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
164	164	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
165	165	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
166	166	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
167	167	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
168	168	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
169	169	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
170	170	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
171	171	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
172	172	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
173	173	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
174	174	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
175	175	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
176	176	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
177	177	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
178	178	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
179	179	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
180	180	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
181	181	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
182	182	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
183	183	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
184	184	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
185	185	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
186	186	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
187	187	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
188	188	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
189	189	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
190	190	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
191	191	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
192	192	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
193	193	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
194	194	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
195	195	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
196	196	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
197	197	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
198	198	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
199	199	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
200	200	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
201	201	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
202	202	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
203	203	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
204	204	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
205	205	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
206	206	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
207	207	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
208	208	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
209	209	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
210	210	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
211	211	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
212	212	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
213	213	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
214	214	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
215	215	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
216	216	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
217	217	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
218	218	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
219	219	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
220	220	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
221	221	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
222	222	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
223	223	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
224	224	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
225	225	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
226	226	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
227	227	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
228	228	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
229	229	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
230	230	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
231	231	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
232	232	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
233	233	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
234	234	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
235	235	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
236	236	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
237	237	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
238	238	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
239	239	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
240	240	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
241	241	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
242	242	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
243	243	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
244	244	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
245	245	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
246	246	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
247	247	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
248	248	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
249	249	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
250	250	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
251	251	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
252	252	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
253	253	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
254	254	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
255	255	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
256	256	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
257	257	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
258	258	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
259	259	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
260	260	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
261	261	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
262	262	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
263	263	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
264	264	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
265	265	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
266	266	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
267	267	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
268	268	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
269	269	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
270	270	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
271	271	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
272	272	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
273	273	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
274	274	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
275	275	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
276	276	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
277	277	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
278	278	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
279	279	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
280	280	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
281	281	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
282	282	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
283	283	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
284	284	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
285	285	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
286	286	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
287	287	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
288	288	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
289	289	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
290	290	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
291	291	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
292	292	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
293	293	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
294	294	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
295	295	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
296	296	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
297	297	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
298	298	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
299	299	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
300	300	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
301	301	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
302	302	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
303	303	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
304	304	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
305	305	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
306	306	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
307	307	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
308	308	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
309	309	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
310	310	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
311	311	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
312	312	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
313	313	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
314	314	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
315	315	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
316	316	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
317	317	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
318	318	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
319	319	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
320	320	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
321	321	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
322	322	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
323	323	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
324	324	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
325	325	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
326	326	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
327	327	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
328	328	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
329	329	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
330	330	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
331	331	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
332	332	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
333	333	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
334	334	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
335	335	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
336	336	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
337	337	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
338	338	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
339	339	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
340	340	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
341	341	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
342	342	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
343	343	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
344	344	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
345	345	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
346	346	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
347	347	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
348	348	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
349	349	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
350	350	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
351	351	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
352	352	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
353	353	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
354	354	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
355	355	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
356	356	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
357	357	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
358	358	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
359	359	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
360	360	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
361	361	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
362	362	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
363	363	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
364	364	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
365	365	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
366	366	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
367	367	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
368	368	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
369	369	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
370	370	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
371	371	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
372	372	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
373	373	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
374	374	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
375	375	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
376	376	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
377	377	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
378	378	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
379	379	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
380	380	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
381	381	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
382	382	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
383	383	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
384	384	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
385	385	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
386	386	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
387	387	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
388	388	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
389	389	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
390	390	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
391	391	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
392	392	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
393	393	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
394	394	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
395	395	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
396	396	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
397	397	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
398	398	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
399	399	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
400	400	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
401	401	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
402	402	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
403	403	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
404	404	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
405	405	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
406	406	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
407	407	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
408	408	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
409	409	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
410	410	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
411	411	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
412	412	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
413	413	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
414	414	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
415	415	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
416	416	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
417	417	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
418	418	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
419	419	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
420	420	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
421	421	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
422	422	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
423	423	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
424	424	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
425	425	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
426	426	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
427	427	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
428	428	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
429	429	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
430	430	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
431	431	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
432	432	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
433	433	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
434	434	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
435	435	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
436	436	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
437	437	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
438	438	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
439	439	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
440	440	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
441	441	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
442	442	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
443	443	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
444	444	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
445	445	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
446	446	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
447	447	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
448	448	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
449	449	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
450	450	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
451	451	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
452	452	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
453	453	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
454	454	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
455	455	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
456	456	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
457	457	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
458	458	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
459	459	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
460	460	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
461	461	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
462	462	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
463	463	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
464	464	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
465	465	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
466	466	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
467	467	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
468	468	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
469	469	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
470	470	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
471	471	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
472	472	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
473	473	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
474	474	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
475	475	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
476	476	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
477	477	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
478	478	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
479	479	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
480	480	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
481	481	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
482	482	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
483	483	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
484	484	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
485	485	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
486	486	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
487	487	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
488	488	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
489	489	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
490	490	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
491	491	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
492	492	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
493	493	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
494	494	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
495	495	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
496	496	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
497	497	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
498	498	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
499	499	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
500	500	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
501	501	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
502	502	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
503	503	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
504	504	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
505	505	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
506	506	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
507	507	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
508	508	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
509	509	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
510	510	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
511	511	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
512	512	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
513	513	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
514	514	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
515	515	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
516	516	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
517	517	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
518	518	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
519	519	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
520	520	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
521	521	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
522	522	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
523	523	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
524	524	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
525	525	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
526	526	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
527	527	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
528	528	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
529	529	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
530	530	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
531	531	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
532	532	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
533	533	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
534	534	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
535	535	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
536	536	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
537	537	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
538	538	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
539	539	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
540	540	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
541	541	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
542	542	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
543	543	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
544	544	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
545	545	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
546	546	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
547	547	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
548	548	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
549	549	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
550	550	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
551	551	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
552	552	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
553	553	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
554	554	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
555	555	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
556	556	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
557	557	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
558	558	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
559	559	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
560	560	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
561	561	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
562	562	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
563	563	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
564	564	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
565	565	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
566	566	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
567	567	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
568	568	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
569	569	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
570	570	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
571	571	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
572	572	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
573	573	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
574	574	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
575	575	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
576	576	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
577	577	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
578	578	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
579	579	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
580	580	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
581	581	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
582	582	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
583	583	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
584	584	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
585	585	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
586	586	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
587	587	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
588	588	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
589	589	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
590	590	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
591	591	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
592	592	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
593	593	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
594	594	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
595	595	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
596	596	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
597	597	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
598	598	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
599	599	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
600	600	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
601	601	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
602	602	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
603	603	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
604	604	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
605	605	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
606	606	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
607	607	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
608	608	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
609	609	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
610	610	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
611	611	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
612	612	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
613	613	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
614	614	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
615	615	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
616	616	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
617	617	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
618	618	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
619	619	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
620	620	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
621	621	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
622	622	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
623	623	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
624	624	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
625	625	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
626	626	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
627	627	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
628	628	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
629	629	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
630	630	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
631	631	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
632	632	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
633	633	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
634	634	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
635	635	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
636	636	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
637	637	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
638	638	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
639	639	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
640	640	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
641	641	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
642	642	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
643	643	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
644	644	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
645	645	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
646	646	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
647	647	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
648	648	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
649	649	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
650	650	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
651	651	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
652	652	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
653	653	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
654	654	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
655	655	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
656	656	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
657	657	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
658	658	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
659	659	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
660	660	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
661	661	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
662	662	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
663	663	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
664	664	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
665	665	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
666	666	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
667	667	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
668	668	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
669	669	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
670	670	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
671	671	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
672	672	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
673	673	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
674	674	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
675	675	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
676	676	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
677	677	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
678	678	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
679	679	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
680	680	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
681	681	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
682	682	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
683	683	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
684	684	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
685	685	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
686	686	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
687	687	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
688	688	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
689	689	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
690	690	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
691	691	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
692	692	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
693	693	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
694	694	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
695	695	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
696	696	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
697	697	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
698	698	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
699	699	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
700	700	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
701	701	1	85000000000000	85000000000000	86400	85000000000000	1	0
702	702	1	44000000000000	44000000000000	86400	44000000000000	1	0
703	703	1	17000000000000	17000000000000	86400	17000000000000	1	0
704	704	1	10000000000000	10000000000000	86400	10000000000000	1	0
705	705	1	10000000000000	10000000000000	86400	10000000000000	1	0
706	706	1	10000000000000	10000000000000	86400	10000000000000	1	0
707	707	1	9000000000000	9000000000000	86400	9000000000000	1	0
708	708	1	6000000000000	6000000000000	86400	6000000000000	1	0
709	709	1	10000000000000	10000000000000	86400	10000000000000	1	0
710	710	1	5000000000000	5000000000000	86400	5000000000000	1	0
711	711	1	3000000000000	3000000000000	86400	3000000000000	1	0
712	712	1	6000000000000	6000000000000	86400	6000000000000	1	0
713	713	1	42000000000000	42000000000000	86400	42000000000000	1	0
714	714	1	2000000000000	2000000000000	86400	2000000000000	1	0
715	715	1	2000000000000	2000000000000	86400	2000000000000	1	0
716	716	1	3000000000000	3000000000000	86400	3000000000000	1	0
717	717	1	2000000000000	2000000000000	86400	2000000000000	1	0
718	718	1	2000000000000	2000000000000	86400	2000000000000	1	0
719	719	1	2000000000000	2000000000000	86400	2000000000000	1	0
720	720	1	2000000000000	2000000000000	86400	2000000000000	1	0
721	721	1	2000000000000	2000000000000	86400	2000000000000	1	0
722	722	1	2000000000000	2000000000000	86400	2000000000000	1	0
723	723	1	3000000000000	3000000000000	86400	3000000000000	1	0
724	724	1	20000000000000	20000000000000	86400	20000000000000	1	0
725	725	1	15000000000000	15000000000000	86400	15000000000000	1	0
726	726	1	6000000000000	6000000000000	86400	6000000000000	1	0
727	727	1	5000000000000	5000000000000	86400	5000000000000	1	0
728	728	1	5000000000000	5000000000000	86400	5000000000000	1	0
729	729	1	5000000000000	5000000000000	86400	5000000000000	1	0
730	730	1	5000000000000	5000000000000	86400	5000000000000	1	0
731	731	1	2000000000000	2000000000000	86400	2000000000000	1	0
732	732	1	2000000000000	2000000000000	86400	2000000000000	1	0
733	733	1	2000000000000	2000000000000	86400	2000000000000	1	0
734	734	1	2000000000000	2000000000000	86400	2000000000000	1	0
735	735	1	3000000000000	3000000000000	86400	3000000000000	1	0
736	736	1	2000000000000	2000000000000	86400	2000000000000	1	0
737	737	1	3000000000000	3000000000000	86400	3000000000000	1	0
738	738	1	20000000000000	20000000000000	86400	20000000000000	1	0
739	739	1	10000000000000	10000000000000	86400	10000000000000	1	0
740	740	1	5000000000000	5000000000000	86400	5000000000000	1	0
741	741	1	5000000000000	5000000000000	86400	5000000000000	1	0
742	742	1	5000000000000	5000000000000	86400	5000000000000	1	0
743	743	1	2000000000000	2000000000000	86400	2000000000000	1	0
744	744	1	2000000000000	2000000000000	86400	2000000000000	1	0
745	745	1	2000000000000	2000000000000	86400	2000000000000	1	0
746	746	1	2000000000000	2000000000000	86400	2000000000000	1	0
747	747	1	2000000000000	2000000000000	86400	2000000000000	1	0
748	748	1	2000000000000	2000000000000	86400	2000000000000	1	0
749	749	1	1000000000000	1000000000000	86400	1000000000000	1	0
750	750	1	1000000000000	1000000000000	86400	1000000000000	1	0
751	751	1	1000000000000	1000000000000	86400	1000000000000	1	0
752	752	1	1000000000000	1000000000000	86400	1000000000000	1	0
753	753	1	1000000000000	1000000000000	86400	1000000000000	1	0
754	754	1	1000000000000	1000000000000	86400	1000000000000	1	0
755	755	1	1000000000000	1000000000000	86400	1000000000000	1	0
756	756	1	1000000000000	1000000000000	86400	1000000000000	1	0
757	757	1	1000000000000	1000000000000	86400	1000000000000	1	0
758	758	1	1000000000000	1000000000000	86400	1000000000000	1	0
759	759	1	1000000000000	1000000000000	86400	1000000000000	1	0
760	760	1	1000000000000	1000000000000	86400	1000000000000	1	0
761	761	1	1000000000000	1000000000000	86400	1000000000000	1	0
762	762	1	1000000000000	1000000000000	86400	1000000000000	1	0
763	763	1	1000000000000	1000000000000	86400	1000000000000	1	0
764	764	1	1000000000000	1000000000000	86400	1000000000000	1	0
765	765	1	1000000000000	1000000000000	86400	1000000000000	1	0
766	766	1	1000000000000	1000000000000	86400	1000000000000	1	0
767	767	1	1000000000000	1000000000000	86400	1000000000000	1	0
768	768	1	1000000000000	1000000000000	86400	1000000000000	1	0
769	769	1	1000000000000	1000000000000	86400	1000000000000	1	0
770	770	1	1000000000000	1000000000000	86400	1000000000000	1	0
771	771	1	1000000000000	1000000000000	86400	1000000000000	1	0
772	772	1	1000000000000	1000000000000	86400	1000000000000	1	0
773	773	1	1000000000000	1000000000000	86400	1000000000000	1	0
774	774	1	1000000000000	1000000000000	86400	1000000000000	1	0
775	775	1	1388891712964990	1388891712964990	36480	1172841890948210	1	32150271133
776	776	1	15277795509265100	15277795509265100	43200	0	1	70730534765
777	777	1	1388891712964990	1388891712964990	36480	1172841890948210	1	32150271133
778	778	1	15277795509265100	15277795509265100	43200	0	1	70730534765
779	779	1	27778216210792	27778216210792	36480	23457160355780	1	643014264
780	780	1	305560111648051	305560111648051	43200	0	1	1414630147
781	781	1	222221235183807	222221235183807	36480	187653487488548	1	5144010074
782	782	1	2444431453699720	2444431453699720	43200	0	1	11316812286
783	783	1	29861135198413	29861135198413	36480	25216069723104	1	691229981
784	784	1	328472200515873	328472200515873	43200	0	1	1520704632
785	785	1	222221235183807	222221235183807	36480	187653487488548	1	5144010074
786	786	1	2444431453699720	2444431453699720	43200	0	1	11316812286
787	787	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
788	788	1	611120223296101	611120223296101	43200	0	1	2829260293
789	789	1	238889081587303	238889081587303	36480	201728557784834	1	5529839852
790	790	1	2627777604126980	2627777604126980	43200	0	1	12165637056
791	791	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
792	792	1	611120223296101	611120223296101	43200	0	1	2829260293
793	793	1	1361806307764150	1361806307764150	36480	1149969771000840	1	31523294161
794	794	1	14979856312075500	14979856312075500	43200	0	1	69351186630
795	795	1	55556593519694	55556593519694	36480	46914456749964	1	1286032257
796	796	1	611121995373765	611121995373765	43200	0	1	2829268497
797	797	1	277777828703501	277777828703501	36480	234567944238512	1	6430042331
798	798	1	3055553449073490	3055553449073490	43200	0	1	14146080783
799	799	1	13887863656181	13887863656181	36480	11727529309664	1	321478325
800	800	1	152766366894607	152766366894607	43200	0	1	707251699
801	801	1	13890433103666	13890433103666	36480	11729699065318	1	321537803
802	802	1	152794630792275	152794630792275	43200	0	1	707382550
803	803	1	16665388062455	16665388062455	36480	14072994363851	1	385772872
804	804	1	183319108699404	183319108699404	43200	0	1	848699577
805	805	1	111110295403134	111110295403134	36480	93826471673758	1	2571997579
806	806	1	1222212182776490	1222212182776490	43200	0	1	5658389735
807	807	1	27778296759847	27778296759847	36480	23457228374982	1	643016129
808	808	1	305560997686882	305560997686882	43200	0	1	1414634249
809	809	1	59722270396826	59722270396826	36480	50432139446208	1	1382459963
810	810	1	656944401031746	656944401031746	43200	0	1	3041409264
811	811	1	107500086714286	107500086714286	36480	90777851003175	1	2488427933
812	812	1	1182499921857140	1182499921857140	43200	0	1	5474536675
813	813	1	500001633334793	500001633334793	36480	422223601482714	1	11574111883
814	814	1	5500013166670880	5500013166670880	43200	0	1	25463023920
815	815	1	2027778894047020	2027778894047020	36480	1712346621639700	1	46939326251
816	816	1	22305548367855400	22305548367855400	43200	0	1	103266427629
817	817	1	55554024072209	55554024072209	36480	46912286994310	1	1285972779
818	818	1	611093731476097	611093731476097	43200	0	1	2829137646
819	819	1	55554024072209	55554024072209	36480	46912286994310	1	1285972779
820	820	1	611093731476097	611093731476097	43200	0	1	2829137646
821	821	1	27778216210792	27778216210792	36480	23457160355780	1	643014264
822	822	1	305560111648051	305560111648051	43200	0	1	1414630147
823	823	1	1725001865185760	1725001865185760	36480	1456668241712420	1	39930598731
824	824	1	18975003957038700	18975003957038700	43200	0	1	87847240542
825	825	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
826	826	1	611120223296101	611120223296101	43200	0	1	2829260293
827	827	1	83332079192342	83332079192342	36480	70369311317978	1	1928983315
828	828	1	916652071128441	916652071128441	43200	0	1	4243759589
829	829	1	333333455649436	333333455649436	36480	281481584770635	1	7716052214
830	830	1	3666664812145190	3666664812145190	43200	0	1	16975300056
831	831	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
832	832	1	611120223296101	611120223296101	43200	0	1	2829260293
833	833	1	400013579074275	400013579074275	36480	400013579074275	1	0
834	834	1	479991629337776	479991629337776	36480	479991629337776	1	0
835	835	1	3199985304837430	3199985304837430	36480	3199985304837430	1	0
836	836	1	1200009905283630	1200009905283630	36480	1200009905283630	1	0
837	837	1	1599992652418710	1599992652418710	36480	1599992652418710	1	0
838	838	1	599989536672220	599989536672220	36480	599989536672220	1	0
839	839	1	2399988978628070	2399988978628070	36480	2399988978628070	1	0
840	840	1	1200009905283630	1200009905283630	36480	1200009905283630	1	0
841	841	1	83287416647298	83287416647298	86400	4627082404291	1	321324895
842	842	1	83287416647298	83287416647298	86400	4627082404291	1	321324895
843	843	1	155277777741667	155277777741667	86400	8626550109105	1	599065472
844	844	1	155277777741667	155277777741667	86400	8626550109105	1	599065472
845	845	1	573333333200000	573333333200000	86400	31851877325926	1	2211934052
846	846	1	573333333200000	573333333200000	86400	31851877325926	1	2211934052
847	847	1	185138888845833	185138888845833	86400	10285502053164	1	714270371
848	848	1	185138888845833	185138888845833	86400	10285502053164	1	714270371
849	849	1	1149647999732640	1149647999732640	86400	63869384413947	1	4435370161
850	850	1	1149647999732640	1149647999732640	86400	63869384413947	1	4435370161
851	851	1	2227041666148750	2227041666148750	86400	123724635987893	1	8591981332
852	852	1	2227041666148750	2227041666148750	86400	123724635987893	1	8591981332
853	853	1	245567177026225	245567177026225	86400	13642631859998	1	947404188
854	854	1	245567177026225	245567177026225	86400	13642631859998	1	947404188
855	855	1	129895833303125	129895833303125	86400	7216440956655	1	501141309
856	856	1	129895833303125	129895833303125	86400	7216440956655	1	501141309
857	857	1	327530402701608	327530402701608	86400	18196148040329	1	1263620321
858	858	1	327530402701608	327530402701608	86400	18196148040329	1	1263620321
859	859	1	144537333299720	144537333299720	86400	8029858273866	1	557628574
860	860	1	144537333299720	144537333299720	86400	8029858273866	1	557628574
861	861	1	452395833228125	452395833228125	86400	25133121952488	1	1745354213
862	862	1	452395833228125	452395833228125	86400	25133121952488	1	1745354213
863	863	1	95775333311060	95775333311060	86400	5320856107296	1	369503583
864	864	1	95775333311060	95775333311060	86400	5320856107296	1	369503583
865	865	1	397152777685417	397152777685417	86400	22064060855980	1	1532225150
866	866	1	397152777685417	397152777685417	86400	22064060855980	1	1532225150
867	867	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
868	868	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
869	869	1	258666499939845	258666499939845	86400	14370372604058	1	997941697
870	870	1	258666499939845	258666499939845	86400	14370372604058	1	997941697
871	871	1	109739583307813	109739583307813	86400	6096648394416	1	423378002
872	872	1	109739583307813	109739583307813	86400	6096648394416	1	423378002
873	873	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
874	874	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
875	875	1	212013888839583	212013888839583	86400	11778558802816	1	817954780
876	876	1	212013888839583	212013888839583	86400	11778558802816	1	817954780
877	877	1	203053166619445	203053166619445	86400	11280740503443	1	783384094
878	878	1	203053166619445	203053166619445	86400	11280740503443	1	783384094
879	879	1	134374999968750	134374999968750	86400	7465283748264	1	518422043
880	880	1	134374999968750	134374999968750	86400	7465283748264	1	518422043
881	881	1	582291666531250	582291666531250	86400	32349562909144	1	2246495521
882	882	1	582291666531250	582291666531250	86400	32349562909144	1	2246495521
883	883	1	89583333312500	89583333312500	86400	4976855832176	1	345614696
884	884	1	89583333312500	89583333312500	86400	4976855832176	1	345614696
885	885	1	63454861096354	63454861096354	86400	3525272881125	1	244810409
886	886	1	63454861096354	63454861096354	86400	3525272881125	1	244810409
887	887	1	267369520771154	267369520771154	86400	14853874148154	1	1031518164
888	888	1	267369520771154	267369520771154	86400	14853874148154	1	1031518164
889	889	1	224442381892249	224442381892249	86400	12469031191453	1	865904210
890	890	1	224442381892249	224442381892249	86400	12469031191453	1	865904210
891	891	1	492708333218750	492708333218750	86400	27372707076968	1	1900880826
892	892	1	492708333218750	492708333218750	86400	27372707076968	1	1900880826
893	893	1	306822916595313	306822916595313	86400	17045731225203	1	1183730332
894	894	1	306822916595313	306822916595313	86400	17045731225203	1	1183730332
895	895	1	143333333300000	143333333300000	86400	7962969331481	1	552983513
896	896	1	143333333300000	143333333300000	86400	7962969331481	1	552983513
897	897	1	64994499984885	64994499984885	86400	3610808443360	1	250750374
898	898	1	64994499984885	64994499984885	86400	3610808443360	1	250750374
899	899	1	38742999990990	38742999990990	86400	2152390610299	1	149471444
900	900	1	38742999990990	38742999990990	86400	2152390610299	1	149471444
901	901	1	116458333306250	116458333306250	86400	6469912581829	1	449299104
902	902	1	116458333306250	116458333306250	86400	6469912581829	1	449299104
903	903	1	114218749973438	114218749973438	86400	6345491186024	1	440658737
904	904	1	114218749973438	114218749973438	86400	6345491186024	1	440658737
905	905	1	418802083235938	418802083235938	86400	23266801015423	1	1615748702
906	906	1	418802083235938	418802083235938	86400	23266801015423	1	1615748702
907	907	1	502777775000000	1000000000	691200	1000000000	1	0
908	908	1	502777775000000	1000000000	691200	1000000000	1	0
909	909	1	502777775000000	1000000000	691200	1000000000	1	0
910	910	1	502777775000000	1000000000	691200	1000000000	1	0
911	911	1	502777775000000	1000000000	691200	1000000000	1	0
912	912	1	502777775000000	1000000000	691200	1000000000	1	0
913	913	1	502777775000000	1000000000	691200	1000000000	1	0
914	914	1	502777775000000	1000000000	691200	1000000000	1	0
915	915	1	502777775000000	1000000000	691200	1000000000	1	0
916	916	1	502777775000000	1000000000	691200	1000000000	1	0
917	917	1	502777775000000	1000000000	691200	1000000000	1	0
918	918	1	502777775000000	1000000000	691200	1000000000	1	0
919	919	1	502777775000000	1000000000	691200	1000000000	1	0
920	920	1	502777775000000	1000000000	691200	1000000000	1	0
921	921	1	502777775000000	1000000000	691200	1000000000	1	0
922	922	1	502777775000000	1000000000	691200	1000000000	1	0
923	923	1	502777775000000	1000000000	691200	1000000000	1	0
924	924	1	502777775000000	1000000000	691200	1000000000	1	0
925	925	1	502777775000000	1000000000	691200	1000000000	1	0
926	926	1	502777775000000	1000000000	691200	1000000000	1	0
927	927	1	502777775000000	1000000000	691200	1000000000	1	0
928	928	1	502777775000000	1000000000	691200	1000000000	1	0
929	929	1	502777775000000	1000000000	691200	1000000000	1	0
930	930	1	502777775000000	1000000000	691200	1000000000	1	0
931	931	1	502777775000000	1000000000	691200	1000000000	1	0
932	932	1	502777775000000	1000000000	691200	1000000000	1	0
933	933	1	502777775000000	1000000000	691200	1000000000	1	0
934	934	1	502777775000000	1000000000	691200	1000000000	1	0
935	935	1	502777775000000	1000000000	691200	1000000000	1	0
936	936	1	502777775000000	1000000000	691200	1000000000	1	0
937	937	1	502777775000000	1000000000	691200	1000000000	1	0
938	938	1	502777775000000	1000000000	691200	1000000000	1	0
939	939	1	502777775000000	1000000000	691200	1000000000	1	0
940	940	1	502777775000000	1000000000	691200	1000000000	1	0
941	941	1	502777775000000	1000000000	691200	1000000000	1	0
942	942	1	502777775000000	1000000000	691200	1000000000	1	0
943	943	1	502777775000000	1000000000	691200	1000000000	1	0
944	944	1	502777775000000	1000000000	691200	1000000000	1	0
945	945	1	502777775000000	1000000000	691200	1000000000	1	0
946	946	1	502777775000000	1000000000	691200	1000000000	1	0
947	947	1	502777775000000	1000000000	691200	1000000000	1	0
948	948	1	502777775000000	1000000000	691200	1000000000	1	0
949	949	1	502777775000000	1000000000	691200	1000000000	1	0
950	950	1	502777775000000	1000000000	691200	1000000000	1	0
951	951	1	502777775000000	1000000000	691200	1000000000	1	0
952	952	1	502777775000000	1000000000	691200	1000000000	1	0
953	953	1	502777775000000	1000000000	691200	1000000000	1	0
954	954	1	502777775000000	1000000000	691200	1000000000	1	0
955	955	1	502777775000000	1000000000	691200	1000000000	1	0
956	956	1	502777775000000	1000000000	691200	1000000000	1	0
957	957	1	502777775000000	1000000000	691200	1000000000	1	0
958	958	1	502777775000000	1000000000	691200	1000000000	1	0
959	959	1	502777775000000	1000000000	691200	1000000000	1	0
960	960	1	502777775000000	1000000000	691200	1000000000	1	0
961	961	1	502777775000000	1000000000	691200	1000000000	1	0
962	962	1	502777775000000	1000000000	691200	1000000000	1	0
963	963	1	502777775000000	1000000000	691200	1000000000	1	0
964	964	1	502777775000000	1000000000	691200	1000000000	1	0
965	965	1	502777775000000	1000000000	691200	1000000000	1	0
966	966	1	502777775000000	1000000000	691200	1000000000	1	0
967	967	1	502777775000000	1000000000	691200	1000000000	1	0
968	968	1	502777775000000	1000000000	691200	1000000000	1	0
969	969	1	502777775000000	1000000000	691200	1000000000	1	0
970	970	1	502777775000000	1000000000	691200	1000000000	1	0
971	971	1	502777775000000	1000000000	691200	1000000000	1	0
972	972	1	502777775000000	1000000000	691200	1000000000	1	0
973	973	1	502777775000000	1000000000	691200	1000000000	1	0
974	974	1	502777775000000	1000000000	691200	1000000000	1	0
975	975	1	502777775000000	1000000000	691200	1000000000	1	0
976	976	1	502777775000000	1000000000	691200	1000000000	1	0
977	977	1	502777775000000	1000000000	691200	1000000000	1	0
978	978	1	502777775000000	1000000000	691200	1000000000	1	0
979	979	1	502777775000000	1000000000	691200	1000000000	1	0
980	980	1	502777775000000	1000000000	691200	1000000000	1	0
981	981	1	502777775000000	1000000000	691200	1000000000	1	0
982	982	1	502777775000000	1000000000	691200	1000000000	1	0
983	983	1	502777775000000	1000000000	691200	1000000000	1	0
984	984	1	502777775000000	1000000000	691200	1000000000	1	0
985	985	1	502777775000000	1000000000	691200	1000000000	1	0
986	986	1	502777775000000	1000000000	691200	1000000000	1	0
987	987	1	502777775000000	1000000000	691200	1000000000	1	0
988	988	1	502777775000000	1000000000	691200	1000000000	1	0
989	989	1	502777775000000	1000000000	691200	1000000000	1	0
990	990	1	502777775000000	1000000000	691200	1000000000	1	0
991	991	1	502777775000000	1000000000	691200	1000000000	1	0
992	992	1	502777775000000	1000000000	691200	1000000000	1	0
993	993	1	502777775000000	1000000000	691200	1000000000	1	0
994	994	1	502777775000000	1000000000	691200	1000000000	1	0
995	995	1	502777775000000	1000000000	691200	1000000000	1	0
996	996	1	502777775000000	1000000000	691200	1000000000	1	0
997	997	1	502777775000000	1000000000	691200	1000000000	1	0
998	998	1	502777775000000	1000000000	691200	1000000000	1	0
999	999	1	502777775000000	1000000000	691200	1000000000	1	0
1000	1000	1	502777775000000	1000000000	691200	1000000000	1	0
1001	1001	1	502777775000000	1000000000	691200	1000000000	1	0
1002	1002	1	502777775000000	1000000000	691200	1000000000	1	0
1003	1003	1	502777775000000	1000000000	691200	1000000000	1	0
1004	1004	1	502777775000000	1000000000	691200	1000000000	1	0
1005	1005	1	502777775000000	1000000000	691200	1000000000	1	0
1006	1006	1	502777775000000	1000000000	691200	1000000000	1	0
1007	1007	1	502777775000000	1000000000	691200	1000000000	1	0
1008	1008	1	502777775000000	1000000000	691200	1000000000	1	0
1009	1009	1	502777775000000	1000000000	691200	1000000000	1	0
1010	1010	1	502777775000000	1000000000	691200	1000000000	1	0
1011	1011	1	502777775000000	1000000000	691200	1000000000	1	0
1012	1012	1	502777775000000	1000000000	691200	1000000000	1	0
1013	1013	1	502777775000000	1000000000	691200	1000000000	1	0
1014	1014	1	502777775000000	1000000000	691200	1000000000	1	0
1015	1015	1	502777775000000	1000000000	691200	1000000000	1	0
1016	1016	1	502777775000000	1000000000	691200	1000000000	1	0
1017	1017	1	502777775000000	1000000000	691200	1000000000	1	0
1018	1018	1	502777775000000	1000000000	691200	1000000000	1	0
1019	1019	1	502777775000000	1000000000	691200	1000000000	1	0
1020	1020	1	502777775000000	1000000000	691200	1000000000	1	0
1021	1021	1	502777775000000	1000000000	691200	1000000000	1	0
1022	1022	1	502777775000000	1000000000	691200	1000000000	1	0
1023	1023	1	502777775000000	1000000000	691200	1000000000	1	0
1024	1024	1	502777775000000	1000000000	691200	1000000000	1	0
1025	1025	1	502777775000000	1000000000	691200	1000000000	1	0
1026	1026	1	502777775000000	1000000000	691200	1000000000	1	0
1027	1027	1	900973465000000	1000000000	691200	1000000000	1	0
1028	1028	1	900973465000000	1000000000	691200	1000000000	1	0
1029	1029	1	900973465000000	1000000000	691200	1000000000	1	0
1030	1030	1	900973465000000	1000000000	691200	1000000000	1	0
1031	1031	1	900973465000000	1000000000	691200	1000000000	1	0
1032	1032	1	900973465000000	1000000000	691200	1000000000	1	0
1033	1033	1	900973465000000	1000000000	691200	1000000000	1	0
1034	1034	1	900973465000000	1000000000	691200	1000000000	1	0
1035	1035	1	900973465000000	1000000000	691200	1000000000	1	0
1036	1036	1	900973465000000	1000000000	691200	1000000000	1	0
1037	1037	1	900973465000000	1000000000	691200	1000000000	1	0
1038	1038	1	900973465000000	1000000000	691200	1000000000	1	0
1039	1039	1	900973465000000	1000000000	691200	1000000000	1	0
1040	1040	1	900973465000000	1000000000	691200	1000000000	1	0
1041	1041	1	900973465000000	1000000000	691200	1000000000	1	0
1042	1042	1	900973465000000	1000000000	691200	1000000000	1	0
1043	1043	1	900973465000000	1000000000	691200	1000000000	1	0
1044	1044	1	900973465000000	1000000000	691200	1000000000	1	0
1045	1045	1	900973465000000	1000000000	691200	1000000000	1	0
1046	1046	1	900973465000000	1000000000	691200	1000000000	1	0
1047	1047	1	900973465000000	1000000000	691200	1000000000	1	0
1048	1048	1	900973465000000	1000000000	691200	1000000000	1	0
1049	1049	1	900973465000000	1000000000	691200	1000000000	1	0
1050	1050	1	900973465000000	1000000000	691200	1000000000	1	0
1051	1051	1	900973465000000	1000000000	691200	1000000000	1	0
1052	1052	1	900973465000000	1000000000	691200	1000000000	1	0
1053	1053	1	900973465000000	1000000000	691200	1000000000	1	0
1054	1054	1	900973465000000	1000000000	691200	1000000000	1	0
1055	1055	1	900973465000000	1000000000	691200	1000000000	1	0
1056	1056	1	900973465000000	1000000000	691200	1000000000	1	0
1057	1057	1	900973465000000	1000000000	691200	1000000000	1	0
1058	1058	1	900973465000000	1000000000	691200	1000000000	1	0
1059	1059	1	900973465000000	1000000000	691200	1000000000	1	0
1060	1060	1	900973465000000	1000000000	691200	1000000000	1	0
1061	1061	1	900973465000000	1000000000	691200	1000000000	1	0
1062	1062	1	900973465000000	1000000000	691200	1000000000	1	0
1063	1063	1	900973465000000	1000000000	691200	1000000000	1	0
1064	1064	1	900973465000000	1000000000	691200	1000000000	1	0
1065	1065	1	900973465000000	1000000000	691200	1000000000	1	0
1066	1066	1	900973465000000	1000000000	691200	1000000000	1	0
1067	1067	1	900973465000000	1000000000	691200	1000000000	1	0
1068	1068	1	900973465000000	1000000000	691200	1000000000	1	0
1069	1069	1	900973465000000	1000000000	691200	1000000000	1	0
1070	1070	1	900973465000000	1000000000	691200	1000000000	1	0
1071	1071	1	900973465000000	1000000000	691200	1000000000	1	0
1072	1072	1	900973465000000	1000000000	691200	1000000000	1	0
1073	1073	1	900973465000000	1000000000	691200	1000000000	1	0
1074	1074	1	900973465000000	1000000000	691200	1000000000	1	0
1075	1075	1	900973465000000	1000000000	691200	1000000000	1	0
1076	1076	1	900973465000000	1000000000	691200	1000000000	1	0
1077	1077	1	900973465000000	1000000000	691200	1000000000	1	0
1078	1078	1	900973465000000	1000000000	691200	1000000000	1	0
1079	1079	1	900973465000000	1000000000	691200	1000000000	1	0
1080	1080	1	900973465000000	1000000000	691200	1000000000	1	0
1081	1081	1	900973465000000	1000000000	691200	1000000000	1	0
1082	1082	1	900973465000000	1000000000	691200	1000000000	1	0
1083	1083	1	900973465000000	1000000000	691200	1000000000	1	0
1084	1084	1	900973465000000	1000000000	691200	1000000000	1	0
1085	1085	1	900973465000000	1000000000	691200	1000000000	1	0
1086	1086	1	900973465000000	1000000000	691200	1000000000	1	0
1087	1087	1	900973465000000	1000000000	691200	1000000000	1	0
1088	1088	1	900973465000000	1000000000	691200	1000000000	1	0
1089	1089	1	900973465000000	1000000000	691200	1000000000	1	0
1090	1090	1	900973465000000	1000000000	691200	1000000000	1	0
1091	1091	1	900973465000000	1000000000	691200	1000000000	1	0
1092	1092	1	900973465000000	1000000000	691200	1000000000	1	0
1093	1093	1	900973465000000	1000000000	691200	1000000000	1	0
1094	1094	1	900973465000000	1000000000	691200	1000000000	1	0
1095	1095	1	900973465000000	1000000000	691200	1000000000	1	0
1096	1096	1	900973465000000	1000000000	691200	1000000000	1	0
1097	1097	1	900973465000000	1000000000	691200	1000000000	1	0
1098	1098	1	900973465000000	1000000000	691200	1000000000	1	0
1099	1099	1	900973465000000	1000000000	691200	1000000000	1	0
1100	1100	1	900973465000000	1000000000	691200	1000000000	1	0
1101	1101	1	900973465000000	1000000000	691200	1000000000	1	0
1102	1102	1	900973465000000	1000000000	691200	1000000000	1	0
1103	1103	1	900973465000000	1000000000	691200	1000000000	1	0
1104	1104	1	900973465000000	1000000000	691200	1000000000	1	0
1105	1105	1	900973465000000	1000000000	691200	1000000000	1	0
1106	1106	1	900973465000000	1000000000	691200	1000000000	1	0
1107	1107	1	900973465000000	1000000000	691200	1000000000	1	0
1108	1108	1	900973465000000	1000000000	691200	1000000000	1	0
1109	1109	1	900973465000000	1000000000	691200	1000000000	1	0
1110	1110	1	900973465000000	1000000000	691200	1000000000	1	0
1111	1111	1	900973465000000	1000000000	691200	1000000000	1	0
1112	1112	1	900973465000000	1000000000	691200	1000000000	1	0
1113	1113	1	900973465000000	1000000000	691200	1000000000	1	0
1114	1114	1	900973465000000	1000000000	691200	1000000000	1	0
1115	1115	1	900973465000000	1000000000	691200	1000000000	1	0
1116	1116	1	900973465000000	1000000000	691200	1000000000	1	0
1117	1117	1	900973465000000	1000000000	691200	1000000000	1	0
1118	1118	1	900973465000000	1000000000	691200	1000000000	1	0
1119	1119	1	900973465000000	1000000000	691200	1000000000	1	0
1120	1120	1	900973465000000	1000000000	691200	1000000000	1	0
1121	1121	1	900973465000000	1000000000	691200	1000000000	1	0
1122	1122	1	900973465000000	1000000000	691200	1000000000	1	0
1123	1123	1	900973465000000	1000000000	691200	1000000000	1	0
1124	1124	1	900973465000000	1000000000	691200	1000000000	1	0
1125	1125	1	900973465000000	1000000000	691200	1000000000	1	0
1126	1126	1	900973465000000	1000000000	691200	1000000000	1	0
1127	1127	1	900973465000000	1000000000	691200	1000000000	1	0
1128	1128	1	900973465000000	1000000000	691200	1000000000	1	0
1129	1129	1	900973465000000	1000000000	691200	1000000000	1	0
1130	1130	1	900973465000000	1000000000	691200	1000000000	1	0
1131	1131	1	900973465000000	1000000000	691200	1000000000	1	0
1132	1132	1	900973465000000	1000000000	691200	1000000000	1	0
1133	1133	1	900973465000000	1000000000	691200	1000000000	1	0
1134	1134	1	900973465000000	1000000000	691200	1000000000	1	0
1135	1135	1	900973465000000	1000000000	691200	1000000000	1	0
1136	1136	1	900973465000000	1000000000	691200	1000000000	1	0
1137	1137	1	900973465000000	1000000000	691200	1000000000	1	0
1138	1138	1	900973465000000	1000000000	691200	1000000000	1	0
1139	1139	1	900973465000000	1000000000	691200	1000000000	1	0
1140	1140	1	900973465000000	1000000000	691200	1000000000	1	0
1141	1141	1	900973465000000	1000000000	691200	1000000000	1	0
1142	1142	1	900973465000000	1000000000	691200	1000000000	1	0
1143	1143	1	900973465000000	1000000000	691200	1000000000	1	0
1144	1144	1	900973465000000	1000000000	691200	1000000000	1	0
1145	1145	1	900973465000000	1000000000	691200	1000000000	1	0
1146	1146	1	900973465000000	1000000000	691200	1000000000	1	0
1147	1147	1	607904750000000	1000000000	691200	1000000000	1	0
1148	1148	1	607904750000000	1000000000	691200	1000000000	1	0
1149	1149	1	607904750000000	1000000000	691200	1000000000	1	0
1150	1150	1	607904750000000	1000000000	691200	1000000000	1	0
1151	1151	1	607904750000000	1000000000	691200	1000000000	1	0
1152	1152	1	607904750000000	1000000000	691200	1000000000	1	0
1153	1153	1	607904750000000	1000000000	691200	1000000000	1	0
1154	1154	1	607904750000000	1000000000	691200	1000000000	1	0
1155	1155	1	607904750000000	1000000000	691200	1000000000	1	0
1156	1156	1	607904750000000	1000000000	691200	1000000000	1	0
1157	1157	1	607904750000000	1000000000	691200	1000000000	1	0
1158	1158	1	607904750000000	1000000000	691200	1000000000	1	0
1159	1159	1	607904750000000	1000000000	691200	1000000000	1	0
1160	1160	1	607904750000000	1000000000	691200	1000000000	1	0
1161	1161	1	607904750000000	1000000000	691200	1000000000	1	0
1162	1162	1	607904750000000	1000000000	691200	1000000000	1	0
1163	1163	1	607904750000000	1000000000	691200	1000000000	1	0
1164	1164	1	607904750000000	1000000000	691200	1000000000	1	0
1165	1165	1	607904750000000	1000000000	691200	1000000000	1	0
1166	1166	1	607904750000000	1000000000	691200	1000000000	1	0
1167	1167	1	607904750000000	1000000000	691200	1000000000	1	0
1168	1168	1	607904750000000	1000000000	691200	1000000000	1	0
1169	1169	1	607904750000000	1000000000	691200	1000000000	1	0
1170	1170	1	607904750000000	1000000000	691200	1000000000	1	0
1171	1171	1	607904750000000	1000000000	691200	1000000000	1	0
1172	1172	1	607904750000000	1000000000	691200	1000000000	1	0
1173	1173	1	607904750000000	1000000000	691200	1000000000	1	0
1174	1174	1	607904750000000	1000000000	691200	1000000000	1	0
1175	1175	1	607904750000000	1000000000	691200	1000000000	1	0
1176	1176	1	607904750000000	1000000000	691200	1000000000	1	0
1177	1177	1	607904750000000	1000000000	691200	1000000000	1	0
1178	1178	1	607904750000000	1000000000	691200	1000000000	1	0
1179	1179	1	607904750000000	1000000000	691200	1000000000	1	0
1180	1180	1	607904750000000	1000000000	691200	1000000000	1	0
1181	1181	1	607904750000000	1000000000	691200	1000000000	1	0
1182	1182	1	607904750000000	1000000000	691200	1000000000	1	0
1183	1183	1	607904750000000	1000000000	691200	1000000000	1	0
1184	1184	1	607904750000000	1000000000	691200	1000000000	1	0
1185	1185	1	607904750000000	1000000000	691200	1000000000	1	0
1186	1186	1	607904750000000	1000000000	691200	1000000000	1	0
1187	1187	1	607904750000000	1000000000	691200	1000000000	1	0
1188	1188	1	607904750000000	1000000000	691200	1000000000	1	0
1189	1189	1	607904750000000	1000000000	691200	1000000000	1	0
1190	1190	1	607904750000000	1000000000	691200	1000000000	1	0
1191	1191	1	607904750000000	1000000000	691200	1000000000	1	0
1192	1192	1	607904750000000	1000000000	691200	1000000000	1	0
1193	1193	1	607904750000000	1000000000	691200	1000000000	1	0
1194	1194	1	607904750000000	1000000000	691200	1000000000	1	0
1195	1195	1	607904750000000	1000000000	691200	1000000000	1	0
1196	1196	1	607904750000000	1000000000	691200	1000000000	1	0
1197	1197	1	607904750000000	1000000000	691200	1000000000	1	0
1198	1198	1	607904750000000	1000000000	691200	1000000000	1	0
1199	1199	1	607904750000000	1000000000	691200	1000000000	1	0
1200	1200	1	607904750000000	1000000000	691200	1000000000	1	0
1201	1201	1	607904750000000	1000000000	691200	1000000000	1	0
1202	1202	1	607904750000000	1000000000	691200	1000000000	1	0
1203	1203	1	607904750000000	1000000000	691200	1000000000	1	0
1204	1204	1	607904750000000	1000000000	691200	1000000000	1	0
1205	1205	1	607904750000000	1000000000	691200	1000000000	1	0
1206	1206	1	607904750000000	1000000000	691200	1000000000	1	0
1207	1207	1	607904750000000	1000000000	691200	1000000000	1	0
1208	1208	1	607904750000000	1000000000	691200	1000000000	1	0
1209	1209	1	607904750000000	1000000000	691200	1000000000	1	0
1210	1210	1	607904750000000	1000000000	691200	1000000000	1	0
1211	1211	1	607904750000000	1000000000	691200	1000000000	1	0
1212	1212	1	607904750000000	1000000000	691200	1000000000	1	0
1213	1213	1	607904750000000	1000000000	691200	1000000000	1	0
1214	1214	1	607904750000000	1000000000	691200	1000000000	1	0
1215	1215	1	607904750000000	1000000000	691200	1000000000	1	0
1216	1216	1	607904750000000	1000000000	691200	1000000000	1	0
1217	1217	1	607904750000000	1000000000	691200	1000000000	1	0
1218	1218	1	607904750000000	1000000000	691200	1000000000	1	0
1219	1219	1	607904750000000	1000000000	691200	1000000000	1	0
1220	1220	1	607904750000000	1000000000	691200	1000000000	1	0
1221	1221	1	607904750000000	1000000000	691200	1000000000	1	0
1222	1222	1	607904750000000	1000000000	691200	1000000000	1	0
1223	1223	1	607904750000000	1000000000	691200	1000000000	1	0
1224	1224	1	607904750000000	1000000000	691200	1000000000	1	0
1225	1225	1	607904750000000	1000000000	691200	1000000000	1	0
1226	1226	1	607904750000000	1000000000	691200	1000000000	1	0
1227	1227	1	607904750000000	1000000000	691200	1000000000	1	0
1228	1228	1	607904750000000	1000000000	691200	1000000000	1	0
1229	1229	1	607904750000000	1000000000	691200	1000000000	1	0
1230	1230	1	607904750000000	1000000000	691200	1000000000	1	0
1231	1231	1	607904750000000	1000000000	691200	1000000000	1	0
1232	1232	1	607904750000000	1000000000	691200	1000000000	1	0
1233	1233	1	607904750000000	1000000000	691200	1000000000	1	0
1234	1234	1	607904750000000	1000000000	691200	1000000000	1	0
1235	1235	1	607904750000000	1000000000	691200	1000000000	1	0
1236	1236	1	607904750000000	1000000000	691200	1000000000	1	0
1237	1237	1	607904750000000	1000000000	691200	1000000000	1	0
1238	1238	1	607904750000000	1000000000	691200	1000000000	1	0
1239	1239	1	607904750000000	1000000000	691200	1000000000	1	0
1240	1240	1	607904750000000	1000000000	691200	1000000000	1	0
1241	1241	1	607904750000000	1000000000	691200	1000000000	1	0
1242	1242	1	607904750000000	1000000000	691200	1000000000	1	0
1243	1243	1	607904750000000	1000000000	691200	1000000000	1	0
1244	1244	1	607904750000000	1000000000	691200	1000000000	1	0
1245	1245	1	607904750000000	1000000000	691200	1000000000	1	0
1246	1246	1	607904750000000	1000000000	691200	1000000000	1	0
1247	1247	1	607904750000000	1000000000	691200	1000000000	1	0
1248	1248	1	607904750000000	1000000000	691200	1000000000	1	0
1249	1249	1	607904750000000	1000000000	691200	1000000000	1	0
1250	1250	1	607904750000000	1000000000	691200	1000000000	1	0
1251	1251	1	607904750000000	1000000000	691200	1000000000	1	0
1252	1252	1	607904750000000	1000000000	691200	1000000000	1	0
1253	1253	1	607904750000000	1000000000	691200	1000000000	1	0
1254	1254	1	607904750000000	1000000000	691200	1000000000	1	0
1255	1255	1	607904750000000	1000000000	691200	1000000000	1	0
1256	1256	1	607904750000000	1000000000	691200	1000000000	1	0
1257	1257	1	607904750000000	1000000000	691200	1000000000	1	0
1258	1258	1	607904750000000	1000000000	691200	1000000000	1	0
1259	1259	1	607904750000000	1000000000	691200	1000000000	1	0
1260	1260	1	607904750000000	1000000000	691200	1000000000	1	0
1261	1261	1	607904750000000	1000000000	691200	1000000000	1	0
1262	1262	1	607904750000000	1000000000	691200	1000000000	1	0
1263	1263	1	607904750000000	1000000000	691200	1000000000	1	0
1264	1264	1	607904750000000	1000000000	691200	1000000000	1	0
1265	1265	1	607904750000000	1000000000	691200	1000000000	1	0
1266	1266	1	606464750000000	1000000000	691200	1000000000	1	0
1267	1267	1	93600000000000	1000000000	691200	1000000000	1	0
1268	1268	1	1000000000000	1000000000	86400	1000000000	1	0
1269	1269	1	0	0	0	0	0	0
1270	1270	1	0	0	0	0	0	0
1271	1271	1	1333326000000000	1000000000	259200	1000000000	1	0
1272	1272	1	11666659000000000	1000000000	259200	1000000000	1	0
1273	1273	1	1693980637751650	1000000000	345600	1000000000	1	0
1274	1274	1	1693980637751650	1000000000	345600	1000000000	1	0
1275	1275	1	1693980637751650	1000000000	345600	1000000000	1	0
1276	1276	1	1693980637751650	1000000000	345600	1000000000	1	0
1277	1277	1	1693980637751650	1000000000	345600	1000000000	1	0
1278	1278	1	1693980637751650	1000000000	345600	1000000000	1	0
1279	1279	1	1693980637751650	1000000000	345600	1000000000	1	0
1280	1280	1	1693980637751650	1000000000	345600	1000000000	1	0
1281	1281	1	1693980637751650	1000000000	345600	1000000000	1	0
1282	1282	1	1693980637751650	1000000000	345600	1000000000	1	0
1283	1283	1	1693980637751650	1000000000	345600	1000000000	1	0
1284	1284	1	1693980637751650	1000000000	345600	1000000000	1	0
1285	1285	1	1693980637751650	1000000000	345600	1000000000	1	0
1286	1286	1	1693980637751650	1000000000	345600	1000000000	1	0
1287	1287	1	1693980637751650	1000000000	345600	1000000000	1	0
1288	1288	1	1693980637751650	1000000000	345600	1000000000	1	0
1289	1289	1	1693980637751650	1000000000	345600	1000000000	1	0
1290	1290	1	1693980637751650	1000000000	345600	1000000000	1	0
1291	1291	1	1693980637751650	1000000000	345600	1000000000	1	0
1292	1292	1	1693980637751650	1000000000	345600	1000000000	1	0
1293	1293	1	1693980637751650	1000000000	345600	1000000000	1	0
1294	1294	1	1693980637751650	1000000000	345600	1000000000	1	0
1295	1295	1	1693980637751650	1000000000	345600	1000000000	1	0
1296	1296	1	1693980637751650	1000000000	345600	1000000000	1	0
1297	1297	1	1693980637751650	1000000000	345600	1000000000	1	0
1298	1298	1	1693980637751650	1000000000	345600	1000000000	1	0
1299	1299	1	1693980637751650	1000000000	345600	1000000000	1	0
1300	1300	1	1693980637751650	1000000000	345600	1000000000	1	0
1301	1301	1	1693980637751650	1000000000	345600	1000000000	1	0
1302	1302	1	1693980637751650	1000000000	345600	1000000000	1	0
1303	1303	1	1693980637751650	1000000000	345600	1000000000	1	0
1304	1304	1	1693980637751650	1000000000	345600	1000000000	1	0
1305	1305	1	1693980637751650	1000000000	345600	1000000000	1	0
1306	1306	1	1693980637751650	1000000000	345600	1000000000	1	0
1307	1307	1	1693980637751650	1000000000	345600	1000000000	1	0
1308	1308	1	1693980637751650	1000000000	345600	1000000000	1	0
1309	1309	1	1693980637751650	1000000000	345600	1000000000	1	0
1310	1310	1	1693980637751650	1000000000	345600	1000000000	1	0
1311	1311	1	1693980637751650	1000000000	345600	1000000000	1	0
1312	1312	1	1693980637751650	1000000000	345600	1000000000	1	0
1313	1313	1	1693980637751650	1000000000	345600	1000000000	1	0
1314	1314	1	1693980637751650	1000000000	345600	1000000000	1	0
1315	1315	1	1693980637751650	1000000000	345600	1000000000	1	0
1316	1316	1	1693980637751650	1000000000	345600	1000000000	1	0
1317	1317	1	1693980637751650	1000000000	345600	1000000000	1	0
1318	1318	1	1693980637751650	1000000000	345600	1000000000	1	0
1319	1319	1	1693980637751650	1000000000	345600	1000000000	1	0
1320	1320	1	1693980637751650	1000000000	345600	1000000000	1	0
1321	1321	1	1693980637751650	1000000000	345600	1000000000	1	0
1322	1322	1	1693980637751650	1000000000	345600	1000000000	1	0
1323	1323	1	1693980637751650	1000000000	345600	1000000000	1	0
1324	1324	1	1693980637751650	1000000000	345600	1000000000	1	0
1325	1325	1	1693980637751650	1000000000	345600	1000000000	1	0
1326	1326	1	1693980637751650	1000000000	345600	1000000000	1	0
1327	1327	1	1693980637751650	1000000000	345600	1000000000	1	0
1328	1328	1	1693980637751650	1000000000	345600	1000000000	1	0
1329	1329	1	1693980637751650	1000000000	345600	1000000000	1	0
1330	1330	1	1693980637751650	1000000000	345600	1000000000	1	0
1331	1331	1	1693980637751650	1000000000	345600	1000000000	1	0
1332	1332	1	1693980637751650	1000000000	345600	1000000000	1	0
1333	1333	1	1693980637751650	1000000000	345600	1000000000	1	0
1334	1334	1	1693980637751650	1000000000	345600	1000000000	1	0
1335	1335	1	1693980637751650	1000000000	345600	1000000000	1	0
1336	1336	1	1693980637751650	1000000000	345600	1000000000	1	0
1337	1337	1	1693980637751650	1000000000	345600	1000000000	1	0
1338	1338	1	1693980637751650	1000000000	345600	1000000000	1	0
1339	1339	1	1693980637751650	1000000000	345600	1000000000	1	0
1340	1340	1	1693980637751650	1000000000	345600	1000000000	1	0
1341	1341	1	1693980637751650	1000000000	345600	1000000000	1	0
1342	1342	1	1693980637751650	1000000000	345600	1000000000	1	0
1343	1343	1	1693980637751650	1000000000	345600	1000000000	1	0
1344	1344	1	1693980637751650	1000000000	345600	1000000000	1	0
1345	1345	1	1693980637751650	1000000000	345600	1000000000	1	0
1346	1346	1	1693980637751650	1000000000	345600	1000000000	1	0
1347	1347	1	1693980637751650	1000000000	345600	1000000000	1	0
1348	1348	1	1693980637751650	1000000000	345600	1000000000	1	0
1349	1349	1	1693980637751650	1000000000	345600	1000000000	1	0
1350	1350	1	1693980637751650	1000000000	345600	1000000000	1	0
1351	1351	1	1693980637751650	1000000000	345600	1000000000	1	0
1352	1352	1	1693980637751650	1000000000	345600	1000000000	1	0
1353	1353	1	1693980637751650	1000000000	345600	1000000000	1	0
1354	1354	1	1693980637751650	1000000000	345600	1000000000	1	0
1355	1355	1	1693980637751650	1000000000	345600	1000000000	1	0
1356	1356	1	1693980637751650	1000000000	345600	1000000000	1	0
1357	1357	1	1693980637751650	1000000000	345600	1000000000	1	0
1358	1358	1	1693980637751650	1000000000	345600	1000000000	1	0
1359	1359	1	1693980637751650	1000000000	345600	1000000000	1	0
1360	1360	1	1693980637751650	1000000000	345600	1000000000	1	0
1361	1361	1	1693980637751650	1000000000	345600	1000000000	1	0
1362	1362	1	1693980637751650	1000000000	345600	1000000000	1	0
1363	1363	1	1693980637751650	1000000000	345600	1000000000	1	0
1364	1364	1	1693980637751650	1000000000	345600	1000000000	1	0
1365	1365	1	1693980637751650	1000000000	345600	1000000000	1	0
1366	1366	1	1693980637751650	1000000000	345600	1000000000	1	0
1367	1367	1	1693980637751650	1000000000	345600	1000000000	1	0
1368	1368	1	1693980637751650	1000000000	345600	1000000000	1	0
1369	1369	1	1693980637751650	1000000000	345600	1000000000	1	0
1370	1370	1	1693980637751650	1000000000	345600	1000000000	1	0
1371	1371	1	1693980637751650	1000000000	345600	1000000000	1	0
1372	1372	1	1693980637751650	1000000000	345600	1000000000	1	0
1373	1373	1	1693980637751650	1000000000	345600	1000000000	1	0
1374	1374	1	1693980637751650	1000000000	345600	1000000000	1	0
1375	1375	1	1693980637751650	1000000000	345600	1000000000	1	0
1376	1376	1	1693980637751650	1000000000	345600	1000000000	1	0
1377	1377	1	1693980637751650	1000000000	345600	1000000000	1	0
1378	1378	1	1693980637751650	1000000000	345600	1000000000	1	0
1379	1379	1	1693980637751650	1000000000	345600	1000000000	1	0
1380	1380	1	1693980637751650	1000000000	345600	1000000000	1	0
1381	1381	1	1693980637751650	1000000000	345600	1000000000	1	0
1382	1382	1	1693980637751650	1000000000	345600	1000000000	1	0
1383	1383	1	1693980637751650	1000000000	345600	1000000000	1	0
1384	1384	1	1693980637751650	1000000000	345600	1000000000	1	0
1385	1385	1	1693980637751650	1000000000	345600	1000000000	1	0
1386	1386	1	1693980637751650	1000000000	345600	1000000000	1	0
1387	1387	1	1693980637751650	1000000000	345600	1000000000	1	0
1388	1388	1	1693980637751650	1000000000	345600	1000000000	1	0
1389	1389	1	1693980637751650	1000000000	345600	1000000000	1	0
1390	1390	1	1693980637751650	1000000000	345600	1000000000	1	0
1391	1391	1	1693980637751650	1000000000	345600	1000000000	1	0
1392	1392	1	1693980637751650	1000000000	345600	1000000000	1	0
1393	1393	1	75000000000000000	0	0	0	0	0
1394	1394	1	0	0	0	0	0	0
1395	1395	1	57617370302858700	1000000000	345600	1000000000	1	0
1396	1396	1	0	0	0	0	0	0
1397	1397	1	1440000000000	1000000000	345600	1000000000	1	0
1398	1398	1	0	0	0	0	0	0
1399	1399	1	0	0	0	0	0	0
1400	1400	1	0	0	0	0	0	0
1401	1401	1	0	0	0	0	0	0
1402	1402	1	0	0	0	0	0	0
1403	1403	1	0	0	0	0	0	0
1404	1404	1	0	0	0	0	0	0
1405	1405	1	0	0	0	0	0	0
1406	1406	1	0	0	0	0	0	0
1407	1407	1	0	0	0	0	0	0
1408	1408	1	0	0	0	0	0	0
1409	1409	1	0	0	0	0	0	0
1410	1410	1	0	0	0	0	0	0
1411	1411	1	0	0	0	0	0	0
1412	1412	1	0	0	0	0	0	0
1413	1413	1	0	0	0	0	0	0
1414	1414	1	0	0	0	0	0	0
1415	1415	1	0	0	0	0	0	0
1416	1416	1	0	0	0	0	0	0
1417	1417	1	0	0	0	0	0	0
1418	1418	1	0	0	0	0	0	0
1419	1419	1	0	0	0	0	0	0
1420	1420	1	0	0	0	0	0	0
1421	1421	1	0	0	0	0	0	0
1422	1422	1	0	0	0	0	0	0
1423	1423	1	0	0	0	0	0	0
1424	1424	1	0	0	0	0	0	0
1425	1425	1	0	0	0	0	0	0
1426	1426	1	0	0	0	0	0	0
1427	1427	1	0	0	0	0	0	0
1428	1428	1	0	0	0	0	0	0
1429	1429	1	0	0	0	0	0	0
1430	1430	1	0	0	0	0	0	0
1431	1431	1	0	0	0	0	0	0
1432	1432	1	0	0	0	0	0	0
1433	1433	1	0	0	0	0	0	0
1434	1434	1	0	0	0	0	0	0
1435	1435	1	0	0	0	0	0	0
1436	1436	1	0	0	0	0	0	0
1437	1437	1	0	0	0	0	0	0
1438	1438	1	0	0	0	0	0	0
1439	1439	1	0	0	0	0	0	0
1440	1440	1	0	0	0	0	0	0
1441	1441	1	0	0	0	0	0	0
1442	1442	1	0	0	0	0	0	0
1443	1443	1	0	0	0	0	0	0
1444	1444	1	0	0	0	0	0	0
1445	1445	1	0	0	0	0	0	0
1446	1446	1	0	0	0	0	0	0
1447	1447	1	0	0	0	0	0	0
1448	1448	1	0	0	0	0	0	0
1449	1449	1	0	0	0	0	0	0
1450	1450	1	0	0	0	0	0	0
1451	1451	1	0	0	0	0	0	0
1452	1452	1	0	0	0	0	0	0
1453	1453	1	0	0	0	0	0	0
1454	1454	1	0	0	0	0	0	0
1455	1455	1	0	0	0	0	0	0
1456	1456	1	0	0	0	0	0	0
1457	1457	1	0	0	0	0	0	0
1458	1458	1	0	0	0	0	0	0
1459	1459	1	0	0	0	0	0	0
1460	1460	1	0	0	0	0	0	0
1461	1461	1	0	0	0	0	0	0
1462	1462	1	0	0	0	0	0	0
1463	1463	1	0	0	0	0	0	0
1464	1464	1	0	0	0	0	0	0
1465	1465	1	0	0	0	0	0	0
1466	1466	1	0	0	0	0	0	0
1467	1467	1	0	0	0	0	0	0
1468	1468	1	0	0	0	0	0	0
1469	1469	1	0	0	0	0	0	0
1470	1470	1	0	0	0	0	0	0
1471	1471	1	0	0	0	0	0	0
1472	1472	1	0	0	0	0	0	0
1473	1473	1	0	0	0	0	0	0
1474	1474	1	0	0	0	0	0	0
1475	1475	1	0	0	0	0	0	0
1476	1476	1	0	0	0	0	0	0
1477	1477	1	0	0	0	0	0	0
1478	1478	1	0	0	0	0	0	0
1479	1479	1	0	0	0	0	0	0
1480	1480	1	0	0	0	0	0	0
1481	1481	1	0	0	0	0	0	0
1482	1482	1	0	0	0	0	0	0
1483	1483	1	0	0	0	0	0	0
1484	1484	1	0	0	0	0	0	0
1485	1485	1	0	0	0	0	0	0
1486	1486	1	0	0	0	0	0	0
1487	1487	1	0	0	0	0	0	0
1488	1488	1	0	0	0	0	0	0
1489	1489	1	0	0	0	0	0	0
1490	1490	1	0	0	0	0	0	0
1491	1491	1	0	0	0	0	0	0
1492	1492	1	0	0	0	0	0	0
1493	1493	1	0	0	0	0	0	0
1494	1494	1	0	0	0	0	0	0
1495	1495	1	0	0	0	0	0	0
1496	1496	1	0	0	0	0	0	0
1497	1497	1	0	0	0	0	0	0
1498	1498	1	0	0	0	0	0	0
1499	1499	1	0	0	0	0	0	0
1500	1500	1	0	0	0	0	0	0
1501	1501	1	0	0	0	0	0	0
1502	1502	1	0	0	0	0	0	0
1503	1503	1	0	0	0	0	0	0
1504	1504	1	0	0	0	0	0	0
1505	1505	1	0	0	0	0	0	0
1506	1506	1	0	0	0	0	0	0
1507	1507	1	0	0	0	0	0	0
1508	1508	1	0	0	0	0	0	0
1509	1509	1	0	0	0	0	0	0
1510	1510	1	0	0	0	0	0	0
1511	1511	1	0	0	0	0	0	0
1512	1512	1	0	0	0	0	0	0
1513	1513	1	0	0	0	0	0	0
1514	1514	1	0	0	0	0	0	0
1515	1515	1	0	0	0	0	0	0
1516	1516	1	0	0	0	0	0	0
1517	1517	1	0	0	0	0	0	0
1518	1518	1	0	0	0	0	0	0
1519	1519	1	0	0	0	0	0	0
1520	1520	1	0	0	0	0	0	0
1521	1521	1	0	0	0	0	0	0
1522	1522	1	0	0	0	0	0	0
1523	1523	1	0	0	0	0	0	0
1524	1524	1	0	0	0	0	0	0
1525	1525	1	0	0	0	0	0	0
1526	1526	1	0	0	0	0	0	0
1527	1527	1	0	0	0	0	0	0
1528	1528	1	0	0	0	0	0	0
1529	1529	1	0	0	0	0	0	0
1530	1530	1	0	0	0	0	0	0
1531	1531	1	0	0	0	0	0	0
1532	1532	1	0	0	0	0	0	0
1533	1533	1	0	0	0	0	0	0
1534	1534	1	0	0	0	0	0	0
1535	1535	1	0	0	0	0	0	0
1536	1536	1	0	0	0	0	0	0
1537	1537	1	0	0	0	0	0	0
1538	1538	1	0	0	0	0	0	0
1539	1539	1	0	0	0	0	0	0
1540	1540	1	0	0	0	0	0	0
1541	1541	1	0	0	0	0	0	0
1542	1542	1	0	0	0	0	0	0
1543	1543	1	0	0	0	0	0	0
1544	1544	1	0	0	0	0	0	0
1545	1545	1	0	0	0	0	0	0
1546	1546	1	0	0	0	0	0	0
1547	1547	1	0	0	0	0	0	0
1548	1548	1	0	0	0	0	0	0
1549	1549	1	0	0	0	0	0	0
1550	1550	1	0	0	0	0	0	0
1551	1551	1	0	0	0	0	0	0
1552	1552	1	0	0	0	0	0	0
1553	1553	1	0	0	0	0	0	0
1554	1554	1	0	0	0	0	0	0
1555	1555	1	0	0	0	0	0	0
1556	1556	1	0	0	0	0	0	0
1557	1557	1	0	0	0	0	0	0
1558	1558	1	0	0	0	0	0	0
1559	1559	1	0	0	0	0	0	0
1560	1560	1	0	0	0	0	0	0
1561	1561	1	0	0	0	0	0	0
1562	1562	1	0	0	0	0	0	0
1563	1563	1	0	0	0	0	0	0
1564	1564	1	0	0	0	0	0	0
1565	1565	1	0	0	0	0	0	0
1566	1566	1	0	0	0	0	0	0
1567	1567	1	0	0	0	0	0	0
1568	1568	1	0	0	0	0	0	0
1569	1569	1	0	0	0	0	0	0
1570	1570	1	0	0	0	0	0	0
1571	1571	1	0	0	0	0	0	0
1572	1572	1	0	0	0	0	0	0
1573	1573	1	0	0	0	0	0	0
1574	1574	1	0	0	0	0	0	0
1575	1575	1	0	0	0	0	0	0
1576	1576	1	0	0	0	0	0	0
1577	1577	1	0	0	0	0	0	0
1578	1578	1	0	0	0	0	0	0
1579	1579	1	0	0	0	0	0	0
1580	1580	1	0	0	0	0	0	0
1581	1581	1	0	0	0	0	0	0
1582	1582	1	0	0	0	0	0	0
1583	1583	1	0	0	0	0	0	0
1584	1584	1	0	0	0	0	0	0
1585	1585	1	0	0	0	0	0	0
1586	1586	1	0	0	0	0	0	0
1587	1587	1	0	0	0	0	0	0
1588	1588	1	0	0	0	0	0	0
1589	1589	1	0	0	0	0	0	0
1590	1590	1	0	0	0	0	0	0
1591	1591	1	0	0	0	0	0	0
1592	1592	1	0	0	0	0	0	0
1593	1593	1	0	0	0	0	0	0
1594	1594	1	0	0	0	0	0	0
1595	1595	1	0	0	0	0	0	0
1596	1596	1	0	0	0	0	0	0
1597	1597	1	0	0	0	0	0	0
1598	1598	1	0	0	0	0	0	0
1599	1599	1	0	0	0	0	0	0
1600	1600	1	0	0	0	0	0	0
1601	1601	1	0	0	0	0	0	0
1602	1602	1	0	0	0	0	0	0
1603	1603	1	0	0	0	0	0	0
1604	1604	1	0	0	0	0	0	0
1605	1605	1	0	0	0	0	0	0
1606	1606	1	0	0	0	0	0	0
1607	1607	1	0	0	0	0	0	0
1608	1608	1	0	0	0	0	0	0
1609	1609	1	0	0	0	0	0	0
1610	1610	1	0	0	0	0	0	0
1611	1611	1	0	0	0	0	0	0
1612	1612	1	0	0	0	0	0	0
1613	1613	1	0	0	0	0	0	0
1614	1614	1	0	0	0	0	0	0
1615	1615	1	0	0	0	0	0	0
1616	1616	1	0	0	0	0	0	0
1617	1617	1	0	0	0	0	0	0
1618	1618	1	0	0	0	0	0	0
1619	1619	1	0	0	0	0	0	0
1620	1620	1	0	0	0	0	0	0
1621	1621	1	0	0	0	0	0	0
1622	1622	1	0	0	0	0	0	0
1623	1623	1	0	0	0	0	0	0
1624	1624	1	0	0	0	0	0	0
1625	1625	1	0	0	0	0	0	0
1626	1626	1	0	0	0	0	0	0
1627	1627	1	0	0	0	0	0	0
1628	1628	1	0	0	0	0	0	0
1629	1629	1	0	0	0	0	0	0
1630	1630	1	0	0	0	0	0	0
1631	1631	1	0	0	0	0	0	0
1632	1632	1	0	0	0	0	0	0
1633	1633	1	0	0	0	0	0	0
1634	1634	1	0	0	0	0	0	0
1635	1635	1	0	0	0	0	0	0
1636	1636	1	0	0	0	0	0	0
1637	1637	1	0	0	0	0	0	0
1638	1638	1	0	0	0	0	0	0
1639	1639	1	0	0	0	0	0	0
1640	1640	1	0	0	0	0	0	0
1641	1641	1	0	0	0	0	0	0
1642	1642	1	0	0	0	0	0	0
1643	1643	1	0	0	0	0	0	0
1644	1644	1	0	0	0	0	0	0
1645	1645	1	0	0	0	0	0	0
1646	1646	1	0	0	0	0	0	0
1647	1647	1	0	0	0	0	0	0
1648	1648	1	0	0	0	0	0	0
1649	1649	1	0	0	0	0	0	0
1650	1650	1	0	0	0	0	0	0
1651	1651	1	0	0	0	0	0	0
1652	1652	1	0	0	0	0	0	0
1653	1653	1	0	0	0	0	0	0
1654	1654	1	0	0	0	0	0	0
1655	1655	1	0	0	0	0	0	0
1656	1656	1	0	0	0	0	0	0
1657	1657	1	0	0	0	0	0	0
1658	1658	1	0	0	0	0	0	0
1659	1659	1	0	0	0	0	0	0
1660	1660	1	0	0	0	0	0	0
1661	1661	1	0	0	0	0	0	0
1662	1662	1	0	0	0	0	0	0
1663	1663	1	0	0	0	0	0	0
1664	1664	1	0	0	0	0	0	0
1665	1665	1	0	0	0	0	0	0
1666	1666	1	0	0	0	0	0	0
1667	1667	1	0	0	0	0	0	0
1668	1668	1	0	0	0	0	0	0
1669	1669	1	0	0	0	0	0	0
1670	1670	1	0	0	0	0	0	0
1671	1671	1	0	0	0	0	0	0
1672	1672	1	0	0	0	0	0	0
1673	1673	1	0	0	0	0	0	0
1674	1674	1	0	0	0	0	0	0
1675	1675	1	0	0	0	0	0	0
\.


--
-- Data for Name: user_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.user_commands (id, type, fee_payer_id, source_id, receiver_id, fee_token, token, nonce, amount, fee, valid_until, memo, hash) FROM stdin;
1	payment	1397	1397	1678	1	1	0	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirFuoLVVab6x2ry4j8Ld5gMmQdak7VHW6f5C7VJYE34WAEWqa
2	payment	1397	1397	1678	1	1	1	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4WE3wDRJ4CqCXqS4dqF8hoRQDVK8banePKUgTR6kvhTfyjRp
3	payment	1397	1397	1678	1	1	2	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG32dVJUjs6iq3oroXWitXar1eBtV3GVFyH5agw7HPp9bG4yQ
4	payment	1397	1397	1678	1	1	3	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1u12zrTuEttp7QktfEy7wosHrPV6r3DJkq4sA9f1yKgEqmj5k
5	payment	1397	1397	1678	1	1	4	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbDiRtzF6AUVrny7VoJKTu1wStBHDEsG9W27UFeoeDwMP8VAc
6	payment	1397	1397	1678	1	1	5	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28AEmzhB8AjsfT6Dd1cKdR5WF2gQw4xqDu4f93ozDX2jekTq
7	payment	1397	1397	1678	1	1	6	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYaPLcM3JKLySyEcPeeANEVwQ3aTNYzJ9oFxqQamW9kZnFuPU
8	payment	1397	1397	1678	1	1	7	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZBvLsgsPnndQKkysZJDJ9gNkSR2oeaTp9grBpcCBamGsg7hV
9	payment	1397	1397	1678	1	1	8	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9pjDC5qqpHJtSaA6WpoT3GQPNYZJkCLxkERqPSb37brMTAPy
10	payment	1397	1397	1678	1	1	9	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxGwdxH2CL8wGTF3B9BgJcc5xyfiF8iyzNvTYMALccvmNcNSN
11	payment	1397	1397	1678	1	1	10	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbNmcxmQq95hZppriz49UQciCw5XybR89Kr9Rna3QPrZwd7n6
12	payment	1397	1397	1678	1	1	11	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME52rRdLoVDUkEx1vK3QUu86WxUQTV5347cUj1vnJaZSovN9s
13	payment	1397	1397	1678	1	1	12	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6rHwLM8iJwBU1ssm1tdMzx9rdyDEhpGU8aCAionzF1k82d5N
14	payment	1397	1397	1397	1	1	13	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTdKUDFM8Nsq6noJ4pP6esqP7FeJaHiisGrXSqHYvidfvukDA
15	payment	1397	1397	1397	1	1	14	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCDcYefnCjZSD6CY8NbMxAZ2idsxeZ3duF5bSKzNT8aZDqwZX
16	payment	1397	1397	1678	1	1	15	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5Pb3RMrCpyRARFU2ZeoHPYt2PfLoGypjAn82HhoAE8FqfYrD
17	payment	1397	1397	1397	1	1	16	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Nrw2npxR1Uqqw2DUoV7n4xSSwmFUkV7NryWUfz2d5q8ShbHF
18	payment	1397	1397	1397	1	1	17	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi83oW6HZWhYrqpkKrpwjGat1VSXRPBcjcTM2jWDo4BWdkJYJ7
19	payment	1397	1397	1678	1	1	18	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WWg2irdypoygyiNWMFWYAurjkqA8MbDwx17zYLyvptZeLxxN
20	payment	1397	1397	1678	1	1	19	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3P9RkHVHoFr5rYFwHwTJqVHQhcix7ZUvhctSHaLmGeRGEG7m
21	payment	1397	1397	1678	1	1	20	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTntUnbcVZZ6Cf2vEgq48XtALb3UWimNJsMbQPbWbxDJuG13Kx
22	payment	1397	1397	1678	1	1	21	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq8tLuUErt6u1RXDiWsBCYsw3VWH62zJZpoA2vVBHj3zMmqF5
23	payment	1397	1397	1678	1	1	22	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyxj3gdR3goAd2uo3RrdeQ7PYx9QNkqDZPWZC1rpwxSM1TAdL
24	payment	1397	1397	1678	1	1	23	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ479vRfrxo6L8pRPEfUkt1u9gd9PPn1yA2v4dDKzgaPh4nsnC9
25	payment	1397	1397	1678	1	1	24	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFyHuoDdSysZzYeAvPm37Fs8YLLgwnVsKUGFRcUKZ3mghCKBd
26	payment	1397	1397	1678	1	1	25	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpDx4R1ne7kzFHjZn6FuJV3hM78EcrTAeFWjme5sdhb4Zfnkj
27	payment	1397	1397	1678	1	1	26	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYUqmZjtnsovBoW1DtWaPbb8pGD68JsWS1ZTPMNPGyGZDVQ5a
28	payment	1397	1397	1678	1	1	27	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8epNgyUiBUEJqm8YQeemwPoKuyZvHSLMGZNkD5FacYEHispH
29	payment	1397	1397	1678	1	1	28	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsccgXvPbfGTsNH73CVS3UbfWEmT6THuAxLntXGx9LRsFoNri
30	payment	1397	1397	1678	1	1	29	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaeHbTYYXBQeaPxVJMk534uCTVg63aUqZf4Ak26cEDFbdTMra
31	payment	1397	1397	1678	1	1	30	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEegfQCrRACVWMXyfq5q96kCgtBsV1ZRFBT11egMwzRGYn3V2
32	payment	1397	1397	1678	1	1	31	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8eiVX1w2RG9B3aRsrgg3mgqfedUwt42HUoQBCQDWLjkeobjq
33	payment	1397	1397	1678	1	1	32	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqgk9MvvmVEPfS7XzWcXuJqDpxQTt6pEh1ykjeUHHrgFfFyKe
34	payment	1397	1397	1678	1	1	33	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Y14bsL889279sQczYbifo8v7y53hpNvmFBXmWF1UA71Kjgp
35	payment	1397	1397	1678	1	1	34	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRW7Gm7Qww46jmWqtjDftVMRSSkE6X4DqWc7QGYk6abveWtxm
36	payment	1397	1397	1678	1	1	35	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3S5mFYeMzsH6F8vQ9ZwStwVQjLAXej1snBM5eZYsaiZ9bUQzb
37	payment	1397	1397	1678	1	1	36	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV9SFfPw85H1VEgyUqEtuoRFMv4PPj6WUQUGvTgz5wyecU7VS
38	payment	1397	1397	1678	1	1	37	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd2QVVvR8v2QjKbsHnmAcUhcVaecXjERkxzUvkSFq27x7rvHA
39	payment	1397	1397	1678	1	1	38	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXjqDHCk6eph6yEaYTG8i5pvYTR6iBgmAezMZX82LNt4z61Nh
40	payment	1397	1397	1678	1	1	39	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQR5bL84VbBdSYJrfdRH3fE8d8ZqcPd3kvwjskn4gCp5RpBrQU
41	payment	1397	1397	1678	1	1	40	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBZLhy3eiPuNe4w7XS3vPoPkuEvk4ZhfAz4RGsef6Z6zcyhy7
43	payment	1397	1397	1678	1	1	42	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2yQheMxn1MAKeGJTcS4PDBo45o5DaauxWg8QTQE6KMpWnnvm
44	payment	1397	1397	1678	1	1	43	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpzCkFEET5AutjVu4dfAPpXstqU76Us55h85qKy6vUewEY32p
46	payment	1397	1397	1678	1	1	45	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gCPQkPDneXRwWiHiqGtKjLT8MocYrxBsdCpMmPZvgAdNLgzx
48	payment	1397	1397	1678	1	1	47	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mSZrVwM84pFseim1aznNuqZdtkqjbaXnnt4hqoQTDkbdvvV8
49	payment	1397	1397	1678	1	1	48	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhP95AnhewK6xzdEncny5mNyLPvPtz6swpoyXdqzqgPoZMG1E
42	payment	1397	1397	1678	1	1	41	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVj8DLuMGvxeDhc2nsHUfZXPoXXbwTAgDbT7AWiec6jn5BoY9
50	payment	1397	1397	1678	1	1	49	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbai6qHEoF53e8pFHdiWqhT34sPhSgbUVdxLmfzAZ8oMpKDuK
51	payment	1397	1397	1678	1	1	50	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEM3sGhwFbWpsdpCLrEJ2ovqnamsvfRfChZ5LM4UUaEBnG221d
52	payment	1397	1397	1678	1	1	51	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFHFBbjnD4yTjcVJ2yD5W8k8rnA9XXbkvnH1r6BmKmbyADsp2
45	payment	1397	1397	1678	1	1	44	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXejdztBNgfhdcx4Z5ob72r6bXmUg9kjoZr2ZniZ3QgBr9841k
47	payment	1397	1397	1678	1	1	46	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJ4NWNGx5tUXQq3BaRWpgiR8kKbcCPFJKmX5GZmjBhiozHAxN
53	payment	1397	1397	1678	1	1	52	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokvqj7UNGKXEX9uqix6ipN8xhAodrecrZPySAnTa1E8JCEgAn
54	payment	1397	1397	1678	1	1	53	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZbjbC4o7artS7gU3ExzJ9gT19mLezWnYM9wEUyLJxMuMTdf1
55	payment	1397	1397	1678	1	1	54	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv92jhjBCvf3T62qvpHsdnCgLBTBQ7BucpdcYhXNbCW9jRdMDp
56	payment	1397	1397	1678	1	1	55	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMaJqfQDZVrWKnUiQyw7DxzCnAze3ZCjiGhk74tkMA684Lo5v
57	payment	1397	1397	1678	1	1	56	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsJsGdprS1KHwU8inFVWBHQkbFzy4rxS1AsNW8ArTp212Aiqk
58	payment	1397	1397	1678	1	1	57	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWT8QzLivh9dDXtibBr65GMRmhVuXhHSuhjvdqZtHsVrLhu6K
59	payment	1397	1397	1678	1	1	58	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jyXACaSTnooeuMLVgQfndNzqqMXAhAHFCLN4zL1f1tpcCAaZ
60	payment	1397	1397	1678	1	1	59	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JaVrVR6HAAmzaumxs8fw5gyJSp6tP2ax4rushuGf5iacPEij
61	payment	1397	1397	1678	1	1	60	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBLFVjvp7Cfw32KLHJsX1w4KfSyWEa3pBhmA7YwJiyYfLrmCN
62	payment	1397	1397	1678	1	1	61	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwy4QqWJpgTg5Vcapce9ryR3Ti87xcWebaD5Zj8sgZuTJTDfJ
63	payment	1397	1397	1678	1	1	62	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXs3jtt6pHqqkGrLPwPjiPpH2gmQmTPT5hLMH9Rg29WjBLwjqH
64	payment	1397	1397	1678	1	1	63	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG82n6f2HVz9iyZoiRmP2moe2awmb7Acb42r5wkZubWcXqFWZz
65	payment	1397	1397	1678	1	1	64	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRRoQeHYM39naDHy31L8VZcV5SPrB8Ni7Dn5sLwzNUmxx9PM7
66	payment	1397	1397	1678	1	1	65	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3byjK85vnhY9CfphuTcMKrSvndjLvAxnwXxSv7XsBiQV2jeKE
67	payment	1397	1397	1678	1	1	66	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5QiWjRqEcGgM9tfczT4dCae4J63g15g9e8vx9Jbf4teK8Gnf
68	payment	1397	1397	1678	1	1	67	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdM83NKsnpVYF35jChzYdUnzkaqH9mnCHGscCZoRuvpEVfZSRw
69	payment	1397	1397	1678	1	1	68	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfo2PC9h6sP9ftCx4fwcfSy8nfJ3es5UUTwvyXH4bbUSg9ghi4
70	payment	1397	1397	1678	1	1	69	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9CMNSo1fgZqGfK3wMVCD6XXssuHqpRpPjDFR6JmFrzQqzSEd
71	payment	1397	1397	1678	1	1	70	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVuXmjEAqDjfjyQURBR6ceg56FpH1qUCmGiPAmaDJkdFEJLkD
72	payment	1397	1397	1678	1	1	71	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaovhbYcQzQTdKZ1Wxw2UwJAwuzaypqWjEcDAGuLJPjvzVSp7L
73	payment	1397	1397	1678	1	1	72	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnN9McUNPoyNkudwEmQ6S8EHdPBAMC8KFB9GybkJyQpm5wjZcL
74	payment	1397	1397	1678	1	1	73	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirE8S8YButq7SXG38LnwQLWrg5JGjb2VocySwoAC35tXmxrxn
75	payment	1397	1397	1678	1	1	74	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVadwtr1CPFvc81EvCgGVJZQ5fWG3ca2JsrU7eMYgsyQkKReL
76	payment	1397	1397	1678	1	1	75	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjNVLadk61ZhYnh9eaLc9g9yx19KqmLjJiZRqtavHsnvsKsnC
77	payment	1397	1397	1678	1	1	76	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudGtrzA6g5GJ1CxY9HiTHwanhMHpqcvDkyh98gYZYjFrUTtan
78	payment	1504	1504	1697	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79MszEYSVADe9mxo6yEWRqxKLs6qwe3kShm5xXfSnaVdyj7jk
79	payment	1397	1397	1678	1	1	77	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfVEHKrSUq7iV5pz6pAe6achsNCWtSY5G6vMqDgGoay2Ey2i2
80	payment	1397	1397	1678	1	1	78	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGEp8AWC3qAkaWX1L3SD6WD29VqoV1yXUmPGen23eDjuxe1ga
81	payment	1397	1397	1678	1	1	79	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NwgG2y7nVzZ2FkMX8R9JvP9ZA2goJkyuucR9uvk2GLXAkJFw
82	payment	1397	1397	1678	1	1	80	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EzeQLT4m3mLUwyKFdvF3cjvvFGUzR9jug14E8bFryTpTsxYz
83	payment	1397	1397	1678	1	1	81	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ7YAQAbXSiRnKWBjY4gWL4AdXTm64swLfSJXbf4AuMf9XrtV
84	payment	1397	1397	1678	1	1	82	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHCiaU77YYMruYqG8u3gv7gHvdYtpD1CGzGhchTLSH5TDg4vK
85	payment	1397	1397	1678	1	1	83	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQEX6ceDWQx5CrHK1HJNgAUHL6SRZURZ19egTp3L3ES4rm2SW
86	payment	1397	1397	1678	1	1	84	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1gMwy5unMRDcPXWw7kycmyosF21fc6dTYSMRjxsBewkPxFpC
87	payment	1397	1397	1678	1	1	85	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvQmjf74636x27UcaTn8MjA3qcmzFQ3jxnyphpQXZvocsWDPn
88	payment	1397	1397	1678	1	1	86	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYax6m2eFX9KNRuRUTkjMTxv8ieMR2765D4vdiK7RDXSmUk99Fy
89	payment	1397	1397	1678	1	1	87	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoehRK6RyCuviGCBXUVjZmu5pAVKCmKjHeuShPJyuP4qwQ3dTN
90	payment	1397	1397	1678	1	1	88	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseHRAZXPDVbNbDibgTcZrWL9nHLk88qhxsu4RyvpxWe9zFvXk
91	payment	1504	1504	1697	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFy25b7aYiLNikXhCfedDCfnr1mhDJ7cEhEDGFs2HCmjC8KpR
95	payment	1397	1397	1678	1	1	92	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpazBm4N4TYp5iu9dUX8zTib5PfwZCeU822sf6qgGGArqS5L1
96	payment	1397	1397	1678	1	1	93	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9cvtGzqRcfwPdxWsn8qFzfR8fAzRffttLGQo5tx1vDgPoGmi
97	payment	1397	1397	1678	1	1	94	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPz9AXguv8wyZSHdGVLhifTNLgjwFgP4BFEDoC7AQQKjvWwX2
104	payment	1397	1397	1678	1	1	101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1yeBvxN5NCrfZFA9L7fa8ZQQG4ngUd3GzXZrvQpCnVRdwW8y
106	payment	1397	1397	1678	1	1	103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitEkdG2fNtdvWnW4h9DKCTUL6AMseqKXWAPTwqxDANuai5kNw
107	payment	1397	1397	1678	1	1	104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvK3tbGYpcY1xEfYpD7GrABoGD8Q5ZQRquH7V8wZEZtDPCU1qc
108	payment	1397	1397	1678	1	1	105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrz9HXkwWeeVggHiM8xbQBztF8LjjsfR7jkoZp8Y9Tuz1kHxW
92	payment	1397	1397	1678	1	1	89	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMkfnnx4nz4qVQ1L5nXwZq27tJgVRpL4seehA6aRXvWRi5ApF
93	payment	1397	1397	1678	1	1	90	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvp69NinEq9aPPdGqsFKhjxWCuvYVTZHxG59D7gJEdehDtnMpe
94	payment	1397	1397	1678	1	1	91	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWMkWEuYm6yZMkkPPFAKQNmqbeMTkTWHovLSA8DqjrQbzPG3Z
98	payment	1397	1397	1678	1	1	95	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK6cUajDKH6Q3CCfCrouj3QVv9fAUepZ8AvjRuwb1XkcAcewt
99	payment	1397	1397	1678	1	1	96	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSmkGqjJ9ass7mWadRDoQSji9CxBeiymAbQMGSh3H2pDtS7Y1
100	payment	1397	1397	1678	1	1	97	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUD79TpWPSzFEhAFnnWm1Cx3jyo4d11dhqDzm2H4hUpXic2v5
101	payment	1397	1397	1678	1	1	98	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrgRwhipA3gAC9ABPnqGnmxzNrWTubvmhhj4JEAtaiz6DtbGm
102	payment	1397	1397	1678	1	1	99	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpyJrwXhEd1wzBBkmcLDX98gyksj2EShK5BGc4Dz8rGHULZBu
105	payment	1397	1397	1678	1	1	102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyYpaBTjYe5HJqu4dFMvtAsZeFHK42zAFdWZ7TYQrzduG2RSk
103	payment	1397	1397	1678	1	1	100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazjAgUFPLbYa5jqtYReqMF3ioMRkf7zbFzbx9DEmTZeZFpetH
109	payment	1397	1397	1678	1	1	106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFFtwJVUraYnUL9RPG9o4n55w5Mckbnuf2U8YqgsCHVNTV1u3
110	payment	1397	1397	1678	1	1	107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXERvX3mUKAPWEpQ2SmcjPsMMhHBZubkNAsGEfh31PnijcPx9S
111	payment	1397	1397	1678	1	1	108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEGFrQbaQ3Ky3HYjpECr6AeqcMCJJ4C3LhGUzJfU5mof6TY85
112	payment	1397	1397	1678	1	1	109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7AQF6muZZTq7gzburSZ2w99YJkUY5Xk36xcoqBBwgB3ogMFb
113	payment	1397	1397	1678	1	1	110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCZ19GNuN2xM3cNYKYmKuAsEuizuLyU2kDBoVxd4ZDqHBKeri
114	payment	1397	1397	1678	1	1	111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTuTZ6RGryWbPHCvrEoWi3zWs8Nw2jiUYAPV77yM4Q9BHDfH5
115	payment	1397	1397	1678	1	1	112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWqwWTr9WFwwQpoR61CZrEhZthwQ3u95iDkXWhX8snGdF5yd4
116	payment	1397	1397	1678	1	1	113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeKox9Uviy168nViCu7bucPV1CExx88623uFUuTGY2WeEsbhD
117	payment	1397	1397	1678	1	1	114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGF6iu6ChmE7RQRkTZzXsRZZeXPKyy1M3rBwb71pPKQnrd2ny
118	payment	1397	1397	1678	1	1	115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQudJ5gKjY6YuUSEt8AxVvHrHQ8kVM2ki5J65k6kPyVh7fqxM
119	payment	1397	1397	1678	1	1	116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydm2vQWu6K9VWFQyquYDpbKeGYV2hdkKMvVzs3XNDg4W9xXP6
120	payment	1397	1397	1678	1	1	117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmZ2GTxvoBzNzXmibjvxr7sGjRfTU7rb79qdQW83BKx5HE5tP
121	payment	1397	1397	1678	1	1	118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDwSf7HximSLVz2zB92TJmxqZvouH7nRXzTEZUfStoWXGU9ib
122	payment	1397	1397	1678	1	1	119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztEzXsYwJkRnsaEX8NBDWMK6nB6vuRj9n9qzRsJwKMFCJzqbu
123	payment	1397	1397	1678	1	1	120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwvZTsoZXzmFZcC9eeSC4F7eVeXDnnwdb8PTqnHJHUJWbWaFb
124	payment	1397	1397	1678	1	1	121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjYcvWV5qwJCnx9QdNXeJhsYJNAy9a9ZKFuPkGj68UUzDHQMf
125	payment	1397	1397	1678	1	1	122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZmSmDenFbUQXYuFPqwq338oXsDNNtsgXQFMNaFLPoqQCcuW9
126	payment	1397	1397	1678	1	1	123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7co5zE4vcUtL7HPofhF6vTx7r9vKtxuGwKXs7rPUp61xRmWcs
127	payment	1397	1397	1678	1	1	124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuKiuZjvJZu82hb1inJshZhLsUgiD32A6FBab5A7ku4f34Fbm
128	payment	1397	1397	1678	1	1	125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNyCbn5XYi61pSZsqZZ8Wm4m7WjitqQ1gshAXn5qN6Yv28yyV
129	payment	1397	1397	1678	1	1	126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwQRDT38ThLKL7azWBTkoctGVSkwTesFsGKigQ8TTvSFT2Hdt
130	payment	1397	1397	1678	1	1	127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJb8GcyrbGYjGeC7aUtwDq3m6yxXSBFhuUVy4Jm8FVvaimbioM
131	payment	1397	1397	1678	1	1	128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkePDRfsrWHxpGMMxVfWMy5xnSCjYTcsqyAqgo7keHwWThb8N
132	payment	1397	1397	1678	1	1	129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjA1drWdBjmkx3QtaxwQG7JUwVwrxAokW75u45hXkz9YKjYqV6
133	payment	1397	1397	1678	1	1	130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqx1g4E4QTHebUjnmstXmNCgAxH4sH64QKB4heqSeBgF4ayeA
134	payment	1397	1397	1678	1	1	131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUiYHwgZ5Fm7NtfBMjLz6b7mY32zjr3LRTPCxteaTp1szAphP
135	payment	1397	1397	1678	1	1	132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmtuzymGdJQZApLobN9Amt69jPdtTrkapiHkQdn8P41zNnDrh
136	payment	1397	1397	1678	1	1	133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpyG22LTzEcvmgaYbeU1pmGRuiH9eAiY8g3eykEMZepd1XkEtP
137	payment	1397	1397	1678	1	1	134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXugYdhYPxdJQybACPFf7sSLSM5FousYHet12KYkjTmq9TSdku
138	payment	1397	1397	1678	1	1	135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsEekr1L99mS5EhKSnquXxc5i2sssPreEACdCHFB2nE2krccq
139	payment	1397	1397	1678	1	1	136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8BMCMgxEajFWhiW27ovvh1JW4ZLUeP5XTzarGdH2yEjuDiR8
140	payment	1397	1397	1678	1	1	137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9KyALF3HiCxhLcpKWZfj7ufReUR3ypyiNr6ZNU5NkwY9fUwp
141	payment	1397	1397	1678	1	1	138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZtaDCDsXCF23bUcytwKxEMM5i9xcKMRTVSUzqjjo2ZM3mqwq
142	payment	1397	1397	1678	1	1	139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDke3de25Peph3L7WShQqXF9hfoZ4bwUq1n3SHiWSENF2f539v
143	payment	1397	1397	1678	1	1	140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBgcbGKGfpKdVEu8L8xfr646VBtYbiYJLjkHwEvPJKKNWPdTe
144	payment	1397	1397	1678	1	1	141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYpHmHTSgiQvkoBPWdAoRFRmvtMCwi3ErHm5d414mR3q4GjkG
145	payment	1397	1397	1678	1	1	142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pfcmCzvveqjsKL3bQyDEa93ich2ajQLe2vRGcGakF2wp9KTW
146	payment	1397	1397	1678	1	1	143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTgbRN6w7vaxRWZbgd4GQuJV3vTqjuACkDNLURyEqhXWbWVT9
147	payment	1397	1397	1678	1	1	144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFpf2q9syHb6dmufSNUii4b5iHvPyakoWgNzKnU7AQ68fzY1P
153	payment	1705	1705	1707	1	1	0	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAYgxDvaZ9Ni5YSkdVGBi1V8fBdz5UpG4HNreKWSjScibBPF7
154	payment	1397	1397	1678	1	1	150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHY7yTfWGdFDdkGRTmQvKfJzExDwuJvBpQCUVG5bViAyuVBD7q
155	payment	1397	1397	1678	1	1	151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr89GcwKuP7F6S8H3axPYyRR1XGqkFqiXNBfauQk7bnoKJ21Qm
156	payment	1397	1397	1678	1	1	152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFeNFxTESevNZhLhahXVcs88YMskmTtriCuMXzT4AkQwQzHda
158	payment	1397	1397	1678	1	1	154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86a8ccHmZQw4UUeNcxUEM1NR9WFzR6MNDwUFXCjJq1Xr62XZa
159	payment	1397	1397	1678	1	1	155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYje1cgV8hQgSxmo9sTkN9t43A4NxSwWAkfwpCubEaqQDoJt74u
164	payment	1397	1397	1678	1	1	160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHVQmyM4nayuk7Wg6UsvSafMByXKtG9swz7mef6nWB9PmVE6R
166	payment	1397	1397	1678	1	1	162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3iQqEF9MuPfptc9F7VYp1yxre5dwfJBnWmRcj6cvrMY6uH3jf
167	payment	1397	1397	1678	1	1	163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTn9HHPL2jijSYPr7xvsjBzCTaPKByQ7xu3Bt4umSVZsssgUK
148	payment	1397	1397	1678	1	1	145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s3dP7qQFBxPUSexYkVGbxRxcJf6HzGuPwX6ncAdeyvhY6VY5
162	payment	1397	1397	1678	1	1	158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHKTN8LAfNkJw9xgFBQAksrSQmCwnajixjNmb9rhbzoabZqVj
168	payment	1397	1397	1678	1	1	164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoESip4xRFBzBdQzPy6Cxgb29rMaUBk7LaaxDJkPGU3gThPif
169	payment	1397	1397	1678	1	1	165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgDnGoiF87esvMfLefUxPRu5uodt5NmU27fQiU8NnHp4EJB9x
170	payment	1397	1397	1678	1	1	166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGgMEetFp8CKNGnxQEdyQW8JVinA2ZC4rDU6iqAf3tv4EHCmF
149	payment	1397	1397	1678	1	1	146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAHbp51HSkoH1GTcxvRQ1A1vgoZTm78yxy4ozgi5y75KT1hgh
150	payment	1397	1397	1678	1	1	147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXdmnWS5rdY3U7hKd3Trf5Sid8L3YMRkry5swftJLHLw7awTp
151	payment	1397	1397	1678	1	1	148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqQDQnwp5CLYW1owhnDLd12McKsj8nFb5JrUoYmuViG4fLdmo
152	payment	1397	1397	1678	1	1	149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsCnm3uFdZbbyPrsrzjZuiXPmkbdhvrzyimcv1zh98uV2p8Z2
157	payment	1397	1397	1678	1	1	153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qpD3iwN3GnE7xXA5HgzNNKfStw47nHwHxvroD939JeSGVaVc
160	payment	1397	1397	1678	1	1	156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZk7pdxyp398FsWxamCUesmbNtfqb38q5TKnLHk97LScndtRrF
161	payment	1397	1397	1678	1	1	157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGBuRTY7emjeRtJdiEPKt82tpXVhsnQxqAjA2MUDA8zrdyR38B
163	payment	1397	1397	1678	1	1	159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLBGTf7xbo8dUNp3b2uX3zR5YkuJzRicncjd9UUtcMpwrtTFg
165	payment	1397	1397	1678	1	1	161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4qrAdLM6Q5idCiDsMhTiDHH5HYLNMtdPeHAZicxpoWxw6EzQ
171	payment	1397	1397	1678	1	1	167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7JBUN1BAbHj986j6dk62D4H9dxkEmHVcBk1psiHUwJU6CnxF
172	payment	1397	1397	1678	1	1	168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkg72JYAa8HiXeJAhMF2jaVoxkh2h1epSfD9YCocvHnUVTPpg
173	payment	1397	1397	1678	1	1	169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKUqR2zMj5zAXGKWZgET4z3dQBu36aNrd3pgBxR2fgTGcdchg
174	payment	1397	1397	1678	1	1	170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTY3nFHZjd9dvZ9huaQX4m1iv2nyxXPy5uCSY69WWjpvkmwXa
175	payment	1397	1397	1678	1	1	171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLS7w9ovaMW1DXeRKME8iR9vh4cjN5CZdw75VmS5srbDkk9VYR
176	payment	1397	1397	1678	1	1	172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NCxcDNTwkRY28D93birxbFYX42FYjHvzWYA61AcbJ2dL4vik
177	payment	1397	1397	1678	1	1	173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXq77ndUnjYMMKshieZgDMpYrh9CF2uvJDX4ZgmJWySPsVzvwK
178	payment	1397	1397	1678	1	1	174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTyy6TkBZUMfpCn7NSb1HZr8UcFkXJFDN46tYWxoS6qeazdJp
179	payment	1397	1397	1678	1	1	175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9DCZstYboGFmnkzGAmGS7otSXriFwyEzZSUaLdZByVqA2Jfk
180	payment	1397	1397	1678	1	1	176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreaWRNr1eANhVYLmi8vzRrwkoEwdNyk2FyUa7M4ZQVnA752wL
181	payment	1397	1397	1678	1	1	177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT6xyn73TxURH7QHgNjAc5KS7scKZX5TmtfxCfxXSn2bHmDyN
182	payment	1397	1397	1678	1	1	178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNzYpyutyebprH1MchZmBB9rg4qt6khmedwZLfQA6nNr8t8kv
183	payment	1397	1397	1678	1	1	179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpiKHhgLeWQyjnx5GsZNZDKsdwYU7jq8AZu7fjopyDkMJys2m
184	payment	1397	1397	1678	1	1	180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJLSSYPXQnLW8UbWeMhdjjsxxoyr7tJhZNZCgKejgckAvdi69
185	payment	1397	1397	1678	1	1	181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCyofZDbSipu7rnAXJy8cUN8wEVgoom8cE15k68JUfEpa3w84
186	payment	1397	1397	1678	1	1	182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrftAKcdQz9SKuzCiBz8RxMEEougSCHYUNU2R3hF4EcYuXUuY
187	payment	1397	1397	1678	1	1	183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnY4RuCJVwZgLfQ7KCkvD687WWmc65e2URMDPouH7hnC3CdoC
188	payment	1397	1397	1678	1	1	184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oDbM89yTfGkc7L3MSQSNbaAKnouDRoUQ8GmEBD7jgei2fUpZ
189	delegation	1571	1571	1571	1	1	0	\N	10000000	\N	E4YTmeovYUFz4uknBcuvjKkhYCTCAFg3U6fUoT8WcNdRWLHxvHUzS	CkpYvcs1BXptgc73YD6KE7rALQFkWAz4fvnAemCYHsLP4Y4ZiCemT
190	payment	1397	1397	1678	1	1	185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1KXtkhg37R1CkWsvh1nzAtmR8dHBSdyBmNoyTLeMwGHi76HK
191	payment	1397	1397	1678	1	1	186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3SjhXwd7g2oLPTzMnn9KRAFNad7nuEHt9Vh6uf6EjNY4Jhes
192	payment	1397	1397	1678	1	1	187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKt8Ev3CtFSfhvq1vDqCjNd7tufbX3r7CAwmskPLAtzeqwx3N
193	payment	1397	1397	1678	1	1	188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrSUZQn5PJ91sx4dz9jYLMEDevBKPRT2eoCKMbb47V68JcprE
194	payment	1397	1397	1678	1	1	189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vtVduWjxncHqW5Hzb6vLBE1ZiSZGdAGqaLVn4RDT2gnwDyRX
195	payment	1397	1397	1678	1	1	190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JYY4xMFUSYpwSxwXW3hPq9a91sxN3dnTdrrq8dKGzihcQs5G
196	payment	1397	1397	1678	1	1	191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sYqHaKac3L15vj8SCs6BcX8r8Ahg9Strf3MS6K5GBi8JpzPv
197	payment	1397	1397	1678	1	1	192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Fvu6VY5fVSuKTPXbdRvijjYn5jh4hfBm6dxCgmf4EYWR4yZt
198	payment	1397	1397	1678	1	1	193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnJS4udzJ2TNpKLqinkhbYM7RzA2npiZRgA7oJZQBPAf9wNkw
199	delegation	1703	1703	1651	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqgr7PK3CGVEPMay1CmartJpFVvetsXeoA8qWi8pw69t2vjhr
200	payment	1397	1397	1678	1	1	194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJ46iGXhHWbhXN3Reitk1544i9Af8P8PwYaMZeCUrKb11tY1Q
203	payment	1397	1397	1678	1	1	196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7awMzrQMYBuqLtgL2weX54J6kqoS2ZVAU3yxksbwE8v6LSpC7
214	payment	1712	1712	1713	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbZnm9nJciSm4Uq3CbWfys6855o3ndMRtN4w7seCjntf4UL8R
215	payment	1397	1397	1678	1	1	207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5wmgGWx16fn3i1o11tqyVUrDKBf1kc7N8bHL2atu8b5vheXq
216	payment	1397	1397	1678	1	1	208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsxmghd2TG3CaS1Q4h7A33gH382zuBDmWvJ6A4ZdtkTQVejJC
217	payment	1397	1397	1678	1	1	209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzqVfQdbbYxUywfztSWXUPfYciAfGgQuWuh71ZsNkDL7NC9Jm
220	payment	1397	1397	1678	1	1	212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5PnbTWfNUNprwn1Mkgf2dH4DjSJX7y62AhyE8xDzUcS5sovc
221	payment	1397	1397	1678	1	1	213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUBpWkFiJxAUZAzDEngyi7zbWdmQxhmuS6FQ5Pig27xac9bfx
222	payment	1397	1397	1678	1	1	214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6qfL7u3fN26vQy7B1uohQQEhrRzDAVufU5EMQYiGmPgcMWn9
228	payment	1397	1397	1678	1	1	219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWp4TwjHbjNn1LWC6aLfKX63ixgYyDzRRnGqiMF3N8FU9S6JFB
229	payment	1397	1397	1678	1	1	220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRSfHmS4dUQuZVgLVDGTBma5Hg8qB3nnkqQVzmaq3u3Cy9ono
238	payment	1397	1397	1678	1	1	228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNV54srTtALjUbVgccowr79rDbpNyKdAxWr22NxcwXNQLuG52
201	payment	1397	1397	1678	1	1	195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEGPRjKgPGCSZbA5wgyjGGxsT1F39QFcNaoQPEDZzxMcdwHuX
202	payment	1682	1682	1712	1	1	0	8990000000	10000000	\N	E4Yf92G48v8FApR4EWQq3iKb2vZkHHxZHPaZ73NQNBXmHeXNzHHSp	CkpaD2Ku46oLfQ6Nmqd59mGH2qqf8emuvQwE8hG5uFK7WTytBxTvU
204	payment	1397	1397	1678	1	1	197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YqBE6z9ghf6DpYNtgD4bymgkvnCVTgRgXzRjYcZ5Yxy2XDvu
207	payment	1397	1397	1678	1	1	200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMokH83oRBPTU5UNQtMM8wgY7Ed71zHUJLdz1ipxjNQ5jS4Dr2
208	payment	1397	1397	1678	1	1	201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpp59vC3eQctYDYUPT6nkeVVDAfMrUpmfv1ZN8xqa3Q4S9qeue
209	payment	1397	1397	1678	1	1	202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNfNEDwq8U24MUGYcQZfndeYyrRPFCNV6r4y341jSJFpH73ah
210	payment	1397	1397	1678	1	1	203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWoQDBeF3vuh3AbjqouTUyYdWyTnoMdaHLd5SLzwtvXnFwxvH
211	payment	1397	1397	1678	1	1	204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTdrSajYuQ8SQzFeXoMiyVLcy5SZojkoeBnvSCjpcsjwpCKBr
213	payment	1397	1397	1678	1	1	206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1QhXwL1pJPXpJAfeQ8vF87No29akteCfsdnNAjcxKCNq3pHu
218	payment	1397	1397	1678	1	1	210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhtpb3LkcF7ZTNrSNDLBsF8CzRxPH1FzuXrDW4ESvuALWEQLU
219	payment	1397	1397	1678	1	1	211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gaQrULDt5aHtdpFGwix3c8k53yiYkvEnL8fefdjhfJdUK4jJ
231	payment	1397	1397	1678	1	1	222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEvimB3dsnA7VUQ8bjCwoojgBZ2mxzaBCBoVaCVDWXLTMPERv
232	payment	1397	1397	1678	1	1	223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZDB3D9WJUyPhuVHPpcgeZbgEZf2t6t2UY3W2GSCqtGbFkPrE
233	payment	1397	1397	1678	1	1	224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRYr2fZBtEv6a6wiYeKEZKJCWD3toMXELbDXmnqzjqXdVLUYy
234	payment	1397	1397	1678	1	1	225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gou1yt52bobezkDWyFjFD8DsWFScg13Aup1sEpCLQn9mPRHU
235	payment	1397	1397	1678	1	1	226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtMtqeVzW4B8qzZcnxV79uV84rxHwct4FfAWZcPTGUnqUTz5Z
236	payment	1694	1694	56	1	1	0	100000000	1000000	\N	E4YhGLt3mKT739LgxT9zRYWkAF164GmtY9trhuGAK2z1CAgpKeZ8p	CkpYeU57LT34kiRourSaPyNWL7aEXZTQRN1d2Bp5BzT5aqKx93Bay
205	payment	1397	1397	1678	1	1	198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkjyZKsNvR28CVKnyqxAv5E4wgaorZy2TgUE7ji92r33Zs61X
206	payment	1397	1397	1678	1	1	199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHqPhwA1ZgpE3vtXQTR9n99jYGGwMLecZpAXo8Ueqq646CFgx
212	payment	1397	1397	1678	1	1	205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVryXzNtHvAi9x6Eu61uXDkxDSHZHasA3ZEijXKHTtLgdT8xm
223	delegation	1701	1701	1617	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dhTGrbsct94vCbPTTWpJsgyMdfxHErZHr7cL6CRcZ8hS2qRv
224	payment	1397	1397	1678	1	1	215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy56KxVM9GFwJmKVwDBoJVsKWEq4eTRssGGMvXzNM8WDiNSkwc
225	payment	1397	1397	1678	1	1	216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H2z1WNJFfVsTnGa9eSUbqtB1XgnruWWfXajekwockbh58egF
226	payment	1397	1397	1678	1	1	217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6j1CnWQc1rCC9t7Vqd1WfGj4bqQTwAG9BV32aetwzzm8fFaep
227	payment	1397	1397	1678	1	1	218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8SaqZqUQRLWv5aaBZ9dQS7pBx27vy8HJyG1WNUNERwMFZ4Tv
230	payment	1397	1397	1678	1	1	221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTQGnFUQqy6nzBMnopqz2ENbZZ9gQvPVXfK8NsiZBbRPrJTQ1
237	payment	1397	1397	1678	1	1	227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW5FUpKFFbWoG17RpZ4dkjTy9KCQsh4vEWZBHnWuPG1p382jw
239	payment	1397	1397	1678	1	1	229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD7deUyZ7BURt7PLoPfHrpMBCtJFpkBH7GdMrKVgrsAZM5bcX
240	payment	1397	1397	1678	1	1	230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUHvpy1ChtzbbmLxV9REv7gCUmAvh5LxoE4arKHqfYKursMWL
241	payment	1397	1397	1678	1	1	231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQNiLZPEktuRXgwJ2nQ1cz61V5BHC3eB3owo2MosQh8coufi6
242	payment	1397	1397	1678	1	1	232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLmRupGshUAkH8CwHNmcQWQtho8kNxQGYkf7vCZSHikkdbUSB
243	payment	1397	1397	1678	1	1	233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFNgAmmo2s3eUj2hG6rC7gd8y6Nsw8x74fg3RsW3e9kogxmX4
244	payment	1397	1397	1678	1	1	234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFpRwag1WDzM4GX5AhGNNUQ1VAvKrJsG6tQpXfo6KU3ED4D5h
245	payment	1397	1397	1678	1	1	235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLcdfAsCHCR2DVvpwnV7q5y6tgWdDAe9TLhmZEXzkPbwmTyGJ
246	payment	1397	1397	1678	1	1	236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZwGNq8uxKyRUN8Qse8zdwnqrHpmLpdDKbmjCpv4pcoRbA2Bo
247	payment	1397	1397	1678	1	1	237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfjzpeRi5NK8wNbuyXriQK7kaNrC9ft1DsiyvSQMMq51AcBF3
248	payment	1397	1397	1678	1	1	238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhokrk31N7HvWXme2e4mnbaCMZAjHVxNYnGX5BYQPDn5Gz5rKa
249	payment	1397	1397	1678	1	1	239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSzJBxK4EG6zdL1ZD5vXwNWHD9xChAxobvWEUUnrULutRwu9z
250	payment	1397	1397	1678	1	1	240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNMubuyjf1d2TaKcGd7Bc5cqYSQhGP9Wmn4mwYCMHyUb6SgmS
251	payment	1397	1397	1678	1	1	241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33v8hpMY5TfaaPhgXuntLW9xMEdD6JaVAgzVRdxQ4yfE7ppVz
252	payment	1397	1397	1678	1	1	242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7M9L6voCbyKWX89ML82r3WcEjqUxDjtH8QwE4Jjd8t2CtUUf6
253	payment	1397	1397	1678	1	1	243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMGzjH8EwFtowcnsGsqQtKCpL1sNbZVkbUMsNFuPzQji8KHD9
254	payment	1397	1397	1678	1	1	244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kznixMvu3Qfqrti57dVnF3cVznEkzsVYK13MzCUiy4wzBoFh
255	payment	1397	1397	1678	1	1	245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2prJkQoxXsqqwRXcTc7DLcEGb2EJajfg6nLp5efzox1T8x4V
256	payment	1397	1397	1678	1	1	246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6qiC5chocYnKq1m41KpgjdAb1mFKHP4CygGBiLhvAJ34J7hT
257	payment	1397	1397	1678	1	1	247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3eAkvFEWhGKpq8keTUsSUHMZRoionKZghMrY1hyjQTb8RkTG
258	payment	1397	1397	1678	1	1	248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SepNDX1gipH1kwW3vRsagx1w4j1T5zSgbhvstS9Dg21DTjxg
259	payment	1504	1504	1697	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxCQvjBPTu6oYcqfP9aXmPMd8C37zcbQiwwok2yWXgjvbZD7W
260	payment	1397	1397	1678	1	1	249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMS69xA39gi8k9vKc2eXVR9jKeBaM22He4AoYgm9GQVeZiap7G
261	payment	1397	1397	1678	1	1	250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6eAsNsF1Xx3MAMyVEwtFZFoxUfHGicFyJdj1SFNYhhDKGC5p
262	payment	1397	1397	1678	1	1	251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRaPVu7FgDQgCw3XR6mmc11VwWTvo3NQW2Ba9JwqyGQW2iCtY
263	payment	1504	1504	1697	1	1	3	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzBGiJU7fqQHRgZUedsMjFLi2UdiE2Ba93TJc6RN5aiSaqxg5
264	payment	1397	1397	1678	1	1	252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2MAheVz4TWK2ZVgG9cKQ1c4yYGHazv2UskPrBfGXNzVCKKQB
265	payment	1397	1397	1678	1	1	253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pf8VwdaZVUxAZU7tMA24Z4uaGfg2yEi5FXB1YMqGt3A3McYE
266	payment	1397	1397	1678	1	1	254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzAbQb6ypQPAkv2qtMW2LQKCobKosHSMEV9SWZmCLXETCjfFX
267	payment	1397	1397	1678	1	1	255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggpJENWTSBawBnWQQp5FJ9zs7VxQZMuNGeW3VE1b6HTv2LQ8v
268	payment	1504	1504	1697	1	1	4	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2MyeMEgLus5ih9s8opge2icEmaL2CSuDNp2mSoftoYrxYqDo
269	payment	1397	1397	1678	1	1	256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NESycoeXu4NGEUEreTVgSxo2h5uKcUWsSdVW1vCnJJS9XPTN
293	payment	1397	1397	1678	1	1	278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbpEra4KQsC5qrytdkgf6nukDSJwGFdNv93ZsUErjU7dwN4MD
301	payment	1397	1397	1678	1	1	285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwvq9gip5v7H4avsFZ2pPogDzdwoJNkxn2nUbm1GMjZ7GBCLr
306	delegation	1682	1682	1503	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hnAeKSC8KwB4WbZRWqgJgs9jquv1nyKf2B3Pr1j2z4eZwffP
307	payment	1397	1397	1678	1	1	288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXerTJJ5pGqbBAVnU8LjFg3WVT1G24h4s2c7TR6miw1T8MDET
308	payment	1397	1397	1678	1	1	289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUStN5DU4tbLJPfkB2fjTDmEqu8AMPDY6CP9GkcFcHeYNLbdY
312	delegation	622	622	1503	1	1	0	\N	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18U31pDTuBMcFgNMgAoBREiBo5ADpXS6S32nkhhTEEn53RUfi
313	payment	1397	1397	1678	1	1	292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpezahNjHV7EY4S9RuzC2oSdPK6DdjcJ3j5Zc9htTf2KLavgvo
314	payment	1397	1397	1678	1	1	293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxC8s8cjWG94yxQCMi1eW9BDgwFFHG4RXdXUbmYnKXiiv2arC
315	payment	1397	1397	1678	1	1	294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5Hfbq1nDNRkyv6pkM97zoh8HpQjrjixzGvqQKD7zo6LZC2hz
270	payment	1397	1397	1678	1	1	257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeXZ8qHQHfEEkahVYk8mg2zEFgg9qgh7NffmkmCU1X3SrdUEQ
271	payment	1397	1397	1678	1	1	258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWoy2PdujeXJrsFgKjRLwBfq3DtPxs3w66uSxRSwVrDThMvWZ
277	payment	1397	1397	1678	1	1	263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymoufAu5CgkypzieDPD1t1GghAtsKSrDk2FWELLrMfhNJDqAW
278	payment	1504	1504	1697	1	1	5	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwY7tBbnqFZVXVz8EEyb7KRCVnY8hGJybFQs5gXuUH99x7AZ1
280	payment	1397	1397	1678	1	1	265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEY2dy4yr7Jcp8BfLSJgDD79Ekmqp9FrTdKGXBiFKxea1TomAg
281	payment	1397	1397	1678	1	1	266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNv7W7nGFCXc8yHLig62QwXnszvtMYttA8PqZx8ktcykLCJPJ
287	payment	1397	1397	1678	1	1	272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrs2mi4q8A2iDGVS1pVG2pEjSKUFyuZHFdByVb9XX3bM2p7mdY
289	payment	1397	1397	1678	1	1	274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6L3eDVsAH6uVCBoS5HT9aTiM7rUmD8d5Y4aN1wKSuUq5jx4fG
290	payment	1397	1397	1678	1	1	275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Euq6YgzfoLqvir4z7Bkt5crcEa44BRx4MyH93PmG7em5RMno
296	payment	1397	1397	1678	1	1	281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FMAuVz3pawnddKzsqn9gXPQUJFdfyiycSN5m8MCxDE88azZb
302	payment	1397	1397	1678	1	1	286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNCQaXiswMue3SDsu3QHx38ax9FbNnmNFgfwqG3eFAb5g6soj
303	payment	1613	1613	1720	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZVuED65TLTGtdydZdtvUw4Bwzs2FmCYmj6CjNrDRGtbkP7ME
304	payment	1613	1613	1721	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkziPAjzEU2AsuRBCVRHz2UDgb1f1Y7CZ3XApXLpfcqgJ2pPY2
272	delegation	1695	1695	152	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsBVvTWjHKPXgxJF5L8foTHDj9rHrkNdH8TZexaCn2vsB5eRY
273	payment	1397	1397	1678	1	1	259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcWt5orCzAPeLGh24goiHy7at8WJidLey6daJ3xi3yv2ZZQqZ
274	payment	1397	1397	1678	1	1	260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5dcVUzCXKQeWYKVLmKyHMHvLJNidVxtKpVRzPQoccrYg3Cw8
275	payment	1397	1397	1678	1	1	261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsLwYwE4ZyVNHbforY7ujSBMBWcKHPLF3fDrhnvMKH9M9vScW
276	payment	1397	1397	1678	1	1	262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuthnGFmTrVnjaCtD6UCrsSPTVqKtEtqSDBjbaLx71Bd5ktAfN
279	payment	1397	1397	1678	1	1	264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimcFKFHR3VVVJ312cQjrLNBDrmxSSoCUn4CpkzuNJS3w1Ns9e
282	payment	1397	1397	1678	1	1	267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCAaVxooVuawvxdwTr6simxucGhCCyuqjdKdizYWp6d6tyHAZ
283	payment	1397	1397	1678	1	1	268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabAa7h7yyPK4VFsQPcfiXc4nB9pFU6HibLEj6iq22B7AZCTtL
284	payment	1397	1397	1678	1	1	269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapNZ9MAzzw23NxdWcdHv4CzghWopayqwnCrJYXQFwwYRHsbzN
285	payment	1397	1397	1678	1	1	270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6r8NBsnTf4hfDgXN8nN6rHR48VZdimcsrRVQMAhnMExDpR3o
286	payment	1397	1397	1678	1	1	271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf9816DevTVTwYjnrpWAMax4wUNKCdk8kSG5TP4Xj8iGhNnxD
288	payment	1397	1397	1678	1	1	273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPqCc5DRtyPQP2YLZZK6KAu8J4yqEQ9YkwhE1wWS1mUvxWTyU
291	payment	1397	1397	1678	1	1	276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhXy9iHjqvi2cCnqUdrz3mhSG4CLijv84QKFZThfBQutHMouE
292	payment	1397	1397	1678	1	1	277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5rxpmX8XegRUF5316b7ZFCLfosMRErw3dQt98Gr4YpZALvSL
294	payment	1397	1397	1678	1	1	279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9me4MsPwy2kznrsLRXHEj9Rj1vjTkusHhCwcGtCWpHQYNnDz
295	payment	1397	1397	1678	1	1	280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeG7q7SrjbF5dtJ2UygvLAzh1NVwqMhgTdyFDUtwTAB42A3nEh
297	payment	1397	1397	1678	1	1	282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTfgsufgiTDFbDZ2bhL22gxF3gGch61J5jP629THvxD5QTY3j
298	payment	1397	1397	1678	1	1	283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfdUSAmsXNrThedYSGUoVHDZJE1Wr14EUscQFaWE2dcnjAqdR
299	payment	1504	1504	1697	1	1	6	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd97kuQP6j2E39kTxEWqUjPEah1eUtS5C11TwgaFomUvgo5tuF
300	payment	1397	1397	1678	1	1	284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2sFbFa35ReJ7ZctZPUQUJ856GBnT47XBbEAf7J2rprZsztxu
305	payment	1397	1397	1678	1	1	287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYye2Ube7YfVUfrTXQ2LMvmp5qciDq5VXhcHfrJfFq3N5PEU8XZ
309	payment	1682	1682	622	1	1	2	2000000000	10000000	\N	E4Yf92G48v8FApR4EWQq3iKb2vZkHHxZHPaZ73NQNBXmHeXNzHHSp	CkpYmzGMKR2PbUgSUjSQn83Hyif6cro16ns4ePq8PpEycAtXKNqco
310	payment	1397	1397	1678	1	1	290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHPKLegzQ86sSKYbCGATPWHZkafpMzeBRLNeyJCAJfGDomzra
311	payment	1397	1397	1678	1	1	291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZja4Wa1dX5t24YJSC1h47y6TUEkKDqMwA1cbV7eDZxuzgLfupD
316	payment	1397	1397	1678	1	1	295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAykJjDfrVXCRou7grESsKmjs1CiBfatySKrJ5dsW1fJSTRaS1
317	payment	1397	1397	1678	1	1	296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegKKNj9SsA6uhKxNAsN6BwbYxBQikkhDkgNKKJhcirNwnvhtW
318	payment	1397	1397	1678	1	1	297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JhJYYgg8tFEQiHEvcL4cJX9JhdZkr1x2FQaiBQSA4t2jwS6P
319	payment	1682	1682	622	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vko1yZiobznkVvBXkWEYad9yykQnQjDDYh1SUfJiZFei33bK
320	payment	1397	1397	1678	1	1	298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmv8LJPmTZJhrYxuKtaPE1sXUUXB4Ppgt889iGissasuxrzzV
321	payment	1397	1397	1678	1	1	299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQYcqojorhFDJPLndi8dDDTwj7mHxYrZUGQL6YmnMUTWBLJHi
322	payment	1397	1397	1678	1	1	300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ovcifeFxJXVK5aETA3RvVogwnVt1UyWRfAQbthQT976FUH8N
323	payment	1397	1397	1678	1	1	301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8qrRc1fKuREUFmgx9vPbKPcw99dabTyLKjNsQR136ZaUsGsC
324	payment	1397	1397	1678	1	1	302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTNeA1QmHHkByQhCNmJMbvmLya1QhZPKUHujfVPvECcFYcf2H
325	payment	1397	1397	1678	1	1	303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7dX8aUi2MNmRhREkb374UVbQTiqZdLWnTwEwMWLSyAt8oZy1j
326	delegation	1710	1710	1507	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYYKbnbPbQAPMwKEkV581ZZFDnrRLYXxjpVnfzXkbX5k88CQE
327	payment	1397	1397	1678	1	1	304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u1netoBqe1y1s8qNgNzdXqrSVrhDPXMpXcL2wV15uypsSwmg
328	payment	1397	1397	1678	1	1	305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFozVfFgGYcmnxsB8ktcq72XwwoxeBySvvExTzK9Ak1A6aSujn
329	payment	1397	1397	1678	1	1	306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWhXeTk5sBPik9szRLPk8ec4FNzgX87RU8i7eHQyvAJCj3Nik
330	payment	1397	1397	1678	1	1	307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJgXWwqwJGiweiLc35T8EAcUFz2NSucm8MYreuByZTHnc5yEQ
336	payment	1397	1397	1678	1	1	311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTPHbyhzypzZ1mot1RbVDXjEcDbV8d4yyjLA93mKtk7Z9HXCW
338	payment	1397	1397	1678	1	1	313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcgTsDPfHuoFqtrmhh9fxkRXDV4VTvsnexF4RjuRau1YRsDKA
339	payment	1397	1397	1678	1	1	314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa3uKaEKkj4LXZyTbZVYXvuqsarPcz29Ttb91k7GPeyXaPXi4
340	payment	1624	1624	1722	1	1	0	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULiQbik7FciQejqPwiuPQnSC9H7cqet7M6MnxocPApzzxRWmB
341	payment	1577	1577	1722	1	1	0	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvznVMVSKJFgmmDtCXxVoenseDbZQRboeu8h9oxjULJb76WFa
342	payment	1652	1652	1722	1	1	2	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZrhDBYygq9TVcytJ3KgujeXzgq4y7Jei7Reg3QergXiwVm8U
350	payment	1397	1397	1678	1	1	321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD6UBhDfvk2uPp6nF3BwjGEDh7iHEXY9b81n3WPhqFf6jyvEB
351	payment	1397	1397	1678	1	1	322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWYeBjTejthck3eegFcCsdMpnsY2rYWn4QCuuPRD6vnKav1xa
363	payment	1397	1397	1678	1	1	333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPfc8fMQF8KadKobt1jdfgHZjgzvt1Z7vtWSPDTMcjmXkp1cb
365	payment	1397	1397	1678	1	1	335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMerX7YLmvBBJQhGAZAFTagE31ZoTpbJjkX9TnMx8RJsaXYP3Q
366	payment	1397	1397	1678	1	1	336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiW1SB3x3PD4pJw6TGxfUNhh2HAHgEwo6o9JLiaxjEpPCDwer
379	payment	1397	1397	1678	1	1	345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M7FqgPQXBtsmTQjthsEwWyvk5oCBpGhnJnFFc7nsqyYiX6M2
382	payment	1397	1397	1678	1	1	348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDjER7QFyZohmJkPJBW4ZSjyyxMwirkxk55wVFUcvYT6XH5aH
383	payment	1693	1693	379	1	1	4	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYUEBUFK4CQhLXeFB1r6B6eEM94Ejt4aHAyDmHNcarzBMjpTJKR
384	payment	1397	1397	1678	1	1	349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaTFENdC2PtZLM8AJsCBztfCMTUEog6LmBGzgeVCm1DYyrcop
387	payment	1397	1397	1678	1	1	352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NaUpUSBcMxjK3MAYrDYQU2e8HRypYSfSHLG3XSiU1TnUbuze
388	payment	1397	1397	1678	1	1	353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaBgCTxkaGwNHdYUa26ShshZuSm8S9GYk5pibypLCLmhrXWd7
389	payment	1701	1701	281	1	1	1	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy3jttA5davJ4zRWE7EbmWbtXyedXtmjxpecbZBQH7NpFQZ49
393	payment	1397	1397	1678	1	1	356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qgtQs9Bktrfja8uYtjtY4H67Tfqdfmy1P2kVSxBCyHR2ePtT
397	payment	1397	1397	1678	1	1	360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rA4UnXDrHW847eiC6HLLVK1PWMXa6NfcHDMJ5LVLtFXSLsi5
331	payment	1397	1397	1678	1	1	308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6GFiEAkgHqj3bMxmwo45t8Dwcjj9Vf5j26AKA59bQzKKp3B6
332	payment	1397	1397	1678	1	1	309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8z5ns5dhpjR9YEn6SqM3N1Y8J4J3ijfhnD1ct6FxLGsMsxVT
333	payment	1652	1652	1722	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpLWuj3ojxcEkzPDxwGSQP6Fz9Wp22FcCBgU4kVYxSycNkJTR
334	payment	1652	1652	443	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z9T46ZyzjoSrktUsDbghpdYog6eT9yYLW7KVvxt9RdWGPWse
337	payment	1397	1397	1678	1	1	312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKkyikhaBStZTYbAX3Tev6sHMmchw2X1jRTr6ugQwWXekjWKS
348	payment	1397	1397	1678	1	1	319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhoL9X131fLxZz3nLNiaaupLcZWbDtEyBUYGymvLcKsK6KpGi
349	payment	1397	1397	1678	1	1	320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNWVMFcXz8Yi3k1tHwUtrVSpbr9i5brTizC2M4H5o6ANkqi1X
370	payment	1397	1397	1678	1	1	340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29YL1mKLFwEFcSwTaG8gTEPL8Tycmf7X8B1aPQTQjupdwGbEu
371	payment	1397	1397	1678	1	1	341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4W3nZmZL2a91z3VwsMpZt6F4WyZtBPkTucrjQpbd6EGMh3i1z
372	payment	1693	1693	1725	1	1	0	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZZioVQcGArFwD2mhBSJbnAnhZG2d2CVHTeGdYJkQGDxs2DsFwi
373	payment	1693	1693	1726	1	1	1	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYYvXJCsVgLsb4KLsk8f58BbndZ6nxkY98VEa7cvSdGBZvZxpAn
374	payment	1397	1397	1678	1	1	342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkLYrsfbr6oz54VL6QGkQHVE8bZEo6hukYF5gnGNghcVQsEQJ
378	payment	1397	1397	1678	1	1	344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmac7V1PnitQL4GuUyxbcbYfMf4ku7qZutSqW8jndk5WmXBSsA
381	payment	1397	1397	1678	1	1	347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGE4etk1J1WzEnNpKzyokBBssxhEh8QXtaZsTyDmMFnFPEmwt
385	payment	1397	1397	1678	1	1	350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfjenx3JrkhF4tmbbVD9ykFnqRMg2d69iRizPSZsBDgdTHr13
392	payment	1397	1397	1678	1	1	355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJEbuMshdXYXCbuJ4vc3KgL6znmMr4NNp3VNtnyavTXq1JCSJ
335	payment	1397	1397	1678	1	1	310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18z7ep7ATNcHqmGM2eCwpoSxCfz2xXPpAoJ9xHR7uiDGbtCVd
343	payment	1397	1397	1678	1	1	315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcvAV5fdsTeKT2Khv6i698ZSkSfcTCtCdY7RvLJ29mkHRL1Ur
344	payment	1397	1397	1678	1	1	316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX2FTPG35qLnCKsVdU5AgrHUvAuh5Q6BP8nMb9sBYsR7vuvrk
345	delegation	1722	1722	1652	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFc2yiX11v1GUeZCWiCGhfAaHqqEntvD6o3E9yGdBRjrWZTW2S
346	payment	1397	1397	1678	1	1	317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCq5PPFBkBQXXGeu828vSZBrcRCqpJzSXz6jGjYhe2zdPntq5
347	payment	1397	1397	1678	1	1	318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bgFNJU3NzN67aTgVb8cbgcMv7JLt7bRTcNcwb3n88CyAmPFw
352	payment	1397	1397	1678	1	1	323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetgHvhB1UZGuvyrNPnfu92dnpUVcw8qvpvfiZz1VXkSf6JTKf
353	payment	1397	1397	1678	1	1	324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtiogHrgRAeTT2EZoyP7kgQmS8LBTEREbhyiQ5HHUScrkXHkF
354	payment	1397	1397	1678	1	1	325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGNiQdcq8iTMy1XEesC7QtFBMzBRQPWhJHa2MGDUK8gMn3p7R
355	payment	1397	1397	1678	1	1	326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dmSRB6b4oeyrht3emNS8CWLHGAQdoZ9UW1t9JcucoacTFznR
356	payment	1397	1397	1678	1	1	327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjzfGX3EUpCfeag2xsWiPQUxDW9JZYNCJi8bNJyGcvwQU24cd
357	payment	1397	1397	1678	1	1	328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBnrZY6oAWyENSVNLh5YPPW33W7WQutRphD65zPffqL7MvjqM
358	payment	1397	1397	1678	1	1	329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AAQ12tQ23SYJvDs69TnCoGyu83nBMVtintTRYUZhwqtLouSt
359	payment	1397	1397	1678	1	1	330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbNjCNp3Hnwp74cqm2nwCYan2z97zMBDnQH5CZD7wt4xHGsmB
360	delegation	443	443	1652	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa35FutJNMUZ8LxFgvYeSYriiq1cHx9cZNvsqtFMNvmaoTattH
361	payment	1397	1397	1678	1	1	331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtAs9jqd8wr7SBd1ykGc1GvPFRJVR4cvrQnYmz9bHuCx4SDKw
362	payment	1397	1397	1678	1	1	332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgEJsd3Q9MLVrPt7xQZkQBYmD2jZ7HBKbnYMTt3gU1st62CVu
364	payment	1397	1397	1678	1	1	334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfLyLF5sihRUs7vW3kQt2kqAuTHQmk4gM8DjBJjpRVKAPTqTN
367	payment	1397	1397	1678	1	1	337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsVyzCv7Z2JLuAKVHeXBpyA8HMNmGYgGa8MP3k8NJRnHtG2AA
368	payment	1397	1397	1678	1	1	338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3Gp1jpzidR9DVneWz4XNNZWdiJ9ZjZejd6Bmo86CctgbqcYt
369	payment	1397	1397	1678	1	1	339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TyWCBA9Q5ChGoKNBcuoUvWycdqZ44AHZ1kbobDfTjiiRxxiC
375	payment	1693	1693	578	1	1	2	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYbdSPmcEQ37vL6AGtpvDPmKuaSZLz6VzcK9y6qr8XeAytL5a1E
376	payment	1693	1693	394	1	1	3	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZ7v1o2P4D5zG73bqYtp5xBjXhhnepTok6tpbWMbTG858TZ2TKk
377	payment	1397	1397	1678	1	1	343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmgVdh34Pcw9AC9i2X4Epo99NcADVPCY6ACgDT7QzsQYaZ1y5
380	payment	1397	1397	1678	1	1	346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJXr1UAFEDqLtKNYm7eCYnycD89HuPngyHV9w53F2R7AHETi5
386	payment	1397	1397	1678	1	1	351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgv9QJQigvrdd3kcgEBhXdtMJohB5UH26KTzJpMraQoKEazBg
390	payment	1397	1397	1678	1	1	354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLDnmpnxsMnmHwXck5DNhCRXa4UJyKJGhFZnYeF6jjuEzqob2
391	delegation	379	379	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpwQD1yxFP4g3jaivdKfreZigYiJN8G5W38yeHqTZPTPmzm2a
394	payment	1397	1397	1678	1	1	357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoVePuqT4uTWE8t2b1wGfVWB3W2PoMEYpmPD8Gk6s2zcxob6e
395	payment	1397	1397	1678	1	1	358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1QoQgNHfUCDTLiLXS913BCw8rLgbDwiaZXp9aMW1LRXo21gH
396	payment	1397	1397	1678	1	1	359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirbCcoGDwawEQ7cRU2kb8tjArNUKAaKpJVS35YvpcykgD1CP
398	payment	1397	1397	1678	1	1	361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8R6TgCz6iwqHrFoANyb7DtUBqhu9zeddwLXgwvdrhupoD18K
399	payment	1397	1397	1678	1	1	362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaBXE22qts82De4ZqmmPMZ49HtxoSyjU2LAY2y7mC899sdjqk
400	payment	1397	1397	1678	1	1	363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyBLwJGqz8RjZonKyiG7HhzKksnqWyQ8HBA3oX1e8Xdr8Z1Kn
401	payment	1397	1397	1678	1	1	364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPq4YB8redmazHwciawzYW9TbX5wAAU3HeS1ytUMSy6TBweCJQ
402	payment	1397	1397	1678	1	1	365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvgAMh7rEffW9eB6A8qvRqiEPEWd2LSPoBJMhFh7EPuKG6Ztq
403	payment	1397	1397	1678	1	1	366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbr9xZoUru58LHhBTgpgYruPij3YovWSJigewtxmt2y7V1Dzb2
404	payment	1397	1397	1678	1	1	367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMpoJuxTzc5m5EcfvRD5pmgNabpUwjDyMztHWB2rkt5TzkAdq
405	payment	1397	1397	1678	1	1	368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9zrNzY8m3pmPyA4GyVeh5sCeY33hfxcutbSMutAEasr8R88U
406	payment	1397	1397	1678	1	1	369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8DaEnPUquj4UtSM7cqRvwhNZsdzZfUg1DEeoGxYxCevhe4eU
407	payment	1397	1397	1678	1	1	370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SdpdEAojfNuQ29kcXgPiFMi7WWp7rZFFP9hmtG7MZHd2BSJ1
408	payment	1397	1397	1678	1	1	371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfNE92Yp5tzJ6HtJHZk3Q4J1uGkwKyNz9eLtHKzfbDxhzTVmc
409	payment	1397	1397	1678	1	1	372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKuSqnnRbWDrSLp2dVpwKPUx7D23eN4KXZKGwd9JynuwoY6UhQ
411	payment	1397	1397	1678	1	1	374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsMkfgkRhftoCkqxxYAuh354Yw3fP93GbkABt5Bm8zk6FUzv2
412	payment	1397	1397	1678	1	1	375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hs7NEc4AzaraRC2DA6qQ2mMwgzMu6K6CMcYX6qCb2tqLuEqX
413	payment	1397	1397	1678	1	1	376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yWPY82C9C6LXEsGuZWVomvt9nNTdyPSJ5LQ6dSYYn8aaCWhv
420	payment	1397	1397	1678	1	1	381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBReVwj1nBBynBHT5FZUoYLfm8PK7Fi5bL9adUNSHUwTQxmn6p
425	payment	1397	1397	1678	1	1	386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCKoQtqjnsMGU8vrduWysQQjWniWh2esw5XJCHVBcjVnwtnnc
431	payment	1397	1397	1678	1	1	392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtN7ab7wUc2q3C6MsanJy5FoNiSRcVkyM6Le94E9zBUZ9VWZxb
432	payment	1397	1397	1678	1	1	393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZah5ZyWmpHBjJMFBgFAyL6ERCJorYw4SkmZdqVyqHEjDCB1kue
433	payment	1397	1397	1678	1	1	394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxWvA5EpLrzrEGAgTYhHeFMSVzGK8usFRmWR66vinikedjg2R
434	payment	1712	1712	1730	1	1	1	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCi7RCYt4sgbf1DDjyq9V1qiLkxFEK6uqorRkiiTiNPYQ2CQQ
456	payment	1397	1397	1678	1	1	414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fjszommkQUarGhyLp842sV7zZFjEnfQDXLugrq7ytzgj6dRu
457	payment	1397	1397	1678	1	1	415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyv1FvhvfK1xaWRMxPAfvfjRzfX4BHurb6MtmQUMcVaEYQ1Df
468	payment	1397	1397	1678	1	1	424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7MGZ7aJHbdvZDoek3JV8cbPHEhjTkPVqrNpeZvgh6oXZHkzg
472	payment	1397	1397	1678	1	1	427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpZekQFJUN6bFCsy2fdKwMM9iSBpKGCcDjVEo6V9CegUKoMvS
473	payment	1397	1397	1678	1	1	428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeY348xeRTqFw4iDgxTHfQ6VtNuoSwf6QytTXkSiU8iHRL3oXQ
476	payment	1397	1397	1678	1	1	431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcyCM2xKewNuTbN2DFCwjni4euPyCuuGaNmbMP3rHCKMMHg1Wy
478	payment	1397	1397	1678	1	1	433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptriBwRmYmiz5YygNmcw2djH5TnztkhfJwq889hf9XKeLL5pj
482	payment	1397	1397	1678	1	1	436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTxLpuPgxnRUozPg648USnKu7vuWchWFvdhEapAtE364tzAMU
483	payment	1397	1397	1678	1	1	437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuEjBjvcj184TQiaF3EWQpDo5xyVvy8SD8RnpZzQmnx27rCT8
410	payment	1397	1397	1678	1	1	373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiW7XAvBFsRX4NASu65MFKBQ4FmqZCrzB7BuEMTJc5UqMtVrka
414	payment	1397	1397	1678	1	1	377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q286Akomwkq9LtenjYhxCf5xymbtHMVNDHz7kTwYBVEqH85a
415	delegation	1699	1699	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTrLM2hz7uPJ34adaTf5r2ZEkT3RAXfPzDqvDyjp7bvhBWaxt
416	payment	1686	1686	1728	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZgoGs8GsJsLwHiHrqx9xrdV7kGiHL6kvnNoyFCVnrZMd7AK1
417	payment	1397	1397	1678	1	1	378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfvUcBBJj4GTSQ8VahqkSodnWdh1s5PVHfUsozpTwUXhzhydL
418	payment	1397	1397	1678	1	1	379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkNpkUk4zNvfEdrjjt8qtk4z5pbM2QJnz3jsHJc6RrT8d14d1
419	payment	1397	1397	1678	1	1	380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzVcW8c8ydKrZ3Qk9qYbXqWbF2dxAY6tRvqZfx3D562rDCvXy
421	payment	1397	1397	1678	1	1	382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoqsWGVTqiK7sqc5yeTEYjZoh5YZf3nn8gCFUf3VYRUpfjHab
422	payment	1397	1397	1678	1	1	383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwGDejFG2Tg778wPeHHzx6S5WCSGF793JppCHfbGE2Ua1pQxu
423	payment	1397	1397	1678	1	1	384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCak6TZXtxJwJTXtBVna3wDEzKKCScqQL5vWDsvrXoBxiiDqr
424	payment	1397	1397	1678	1	1	385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAi27gNFWvpfpR1TV9wG3j3DY99Pc3LPJsE21P2As5Wszfz17
426	payment	1397	1397	1678	1	1	387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswvfVV7vFBk2crceTtNajvewXLuqf1SZ4VXsSxyQBpAixSz4D
427	payment	1397	1397	1678	1	1	388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GhSBYKzNCtuVDSQoBijdqXBRNxENXqXuk2okfd51yjpJG6qU
428	payment	1397	1397	1678	1	1	389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvo6cUMEK8bAX1YchEAAAZQB4ASGu92iPsrzo6HE7XNTkKLby
429	payment	1397	1397	1678	1	1	390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YaGCPZ3UY6DsC2V1awqzFu8yKRXzu7a7wiSehYEniL7tjFoN
430	payment	1397	1397	1678	1	1	391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HLNdRx3kAgqAQjqfHjB5axbCunQNFrMoCfDowbdxjx6M9rKr
435	payment	1397	1397	1678	1	1	395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa8TksoZ35z7Ucg8AjkxdTQtZydLdRHciS8s2NQoT4qFfYzMW9
436	payment	1397	1397	1678	1	1	396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPsBKsvH9Vu9HVcLiNbLgd5XNVLH8a5xv5uWARZktuFwb8grF
437	payment	1397	1397	1678	1	1	397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbCYWeKoXLK3DZGgym5s2fY2ryGpCooHtYXmiLWjNEd6AoT3p
438	payment	1397	1397	1678	1	1	398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dJGh5A2KZy4L1YLuZMs4XyY68FyBuNjBjd8MHjLCYokJqEUL
439	payment	1397	1397	1678	1	1	399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvJfWQ3ZBV6aohhc5NWnhypXLNChMk9iE2sFJrKeZLyzo2S1B
440	payment	1712	1712	1731	1	1	2	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRnYTeTbDwx5o8CF23BA2MdnM2ccFkvkvXyN7k5dAQERWZxBZ
441	payment	1712	1712	1732	1	1	3	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc243YbE82DAxVBhcwLyitauU5Z8QnYAkvhYtwTRdxe49wdhe4
442	payment	1397	1397	1678	1	1	400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmMjeyeeuAjGfpxbDZiDtyAFCuXt6gHN27VNdpiYfacxoELYm
443	payment	1397	1397	1678	1	1	401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13pZ7MgSZ8cGatvd7bZJoTDrjXpvXsU5w2E3WWDMpAM4bnjuW
444	payment	1397	1397	1678	1	1	402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF4pyDkH62W9zPg7CqfBD2wUeiJb682tZUKgg22X8hNNGaSRq
445	payment	1397	1397	1678	1	1	403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBp86cUbsy4Yeuwb7PApVqSPymhtVrHneTvFt8w7i683gZwZT
446	payment	1397	1397	1678	1	1	404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDi3a1kMP1d3UgNddTzY64pHCt3gQ3ueuJUZR6u98G6rbefETi
447	payment	1397	1397	1678	1	1	405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1a7vcsBqp9oCAG4cAveHoTo6bBgAwn4NGsszBRRgUk7QccdkG
448	payment	1397	1397	1678	1	1	406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqGMQxyQ8zvR5ou5C4JJXDrnPgYviCsCg9r2Y5t94sbifQwu4
449	payment	1397	1397	1678	1	1	407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgcHP27LFscCxGdDpaSGNfheaUR7Vp3aqkmbPm1gSCSnesmuL
450	payment	1397	1397	1678	1	1	408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gP6H1AnJawRqdqd4ei4TkMtsNqi757xu4atYQvCTF2E14hzG
451	payment	1397	1397	1678	1	1	409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2WBprEYphUp7bf3U3dxwt69eaW8fiKkh2ABVmvvaUBo6z4bu
452	payment	1397	1397	1678	1	1	410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagJd6Vn9CANCoeS8cjw1zEhZReFYKAcSYwcsqxBz7Xspv4Cp3
453	payment	1397	1397	1678	1	1	411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCX6k4xuei4ViZVSWecDJTQDG6Sj6vGCFE7nUw4kdCDN1t9d4R
454	payment	1397	1397	1678	1	1	412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHA4mR3bxujVDMzAD1HCCnKFg628Sn78BLVrNosZAUiF1okRF1
455	payment	1397	1397	1678	1	1	413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5RRhTiGWVS4Mj2y4UMnZM4VmnQ2hS84FwjS4WANrNWU9MVTm
458	payment	1701	1701	885	1	1	2	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34SUD5QP9C9JJg6cBycawBZFCNZifD71PKE7hQJaHy57fBws9
459	payment	1701	1701	886	1	1	3	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Vm9pR4Wz39Xtjpn9JimDwvtRn6kGgufKxD9AAPbDcs31H6Wu
460	payment	1397	1397	1678	1	1	416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvtV5ATQzJQAiCDX3i9cJMK8dAGJk1XDcDZzNuLwojQXNr5jQ
461	payment	1397	1397	1678	1	1	417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEuGiqd46WEw7tLLgq1PxbRwJfxwxtwo1X7WaFteNaiBfYfBY
462	payment	1397	1397	1678	1	1	418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQmHWwgbbaeLrcY4U3hmtyuUDW7GkJas2MF4zFWmjr8Be9UhX
469	payment	1397	1397	1678	1	1	425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8D1yB3EgQw4Voq9iDQ1MUr6C38njj9yzentNtGBNM2jAV8zoB
470	payment	1397	1397	1678	1	1	426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa8LhsLt6YHA7dp4RVGsz25kgywRtWKB7PkVPCKmrHUVPFQHt
471	payment	1712	1712	1734	1	1	4	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtojnrRAZPFasJx22uyuWrK39atp16wac6S3FXXZkY3a8ZL7zD
475	payment	1397	1397	1678	1	1	430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYfQGNWABT2ddr5iEV3hhXfUMmQc52ccp1ZRgHtBSdwpzH2D1S
479	payment	1397	1397	1678	1	1	434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1A7vB8LwCTNnnc2oWx8xfK88pVhpA6J85H5gYtzZrRGFq1NU
480	delegation	1725	1725	1726	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4w8cvkJXxsUw2pp73oa1cEg6kW9bsdZX1HeVEwjziCJDmirE
481	payment	1397	1397	1678	1	1	435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ4LVY3JQHysr2q9TEobtUHydRZaGVw5CfqVMgKdJ6zK5DwSA
484	payment	1397	1397	1678	1	1	438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUFn87toPLZPjWvsQi1QYe4j3RXqAJ3WqppVC1faB1rdnusz1
485	payment	1397	1397	1678	1	1	439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GoiN9ujmsQhqC8TjjhFcgjN5VWUo9Qiaw5ho9tRM4zvahK3J
486	payment	1397	1397	1678	1	1	440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNnTrp5jijU8iGXLygbtmRH7cFZijohTdsmoe1UvSYWKvuX3w
463	payment	1397	1397	1678	1	1	419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDJ2ADwF4X57XdRev1djD39xZQ8UkPvRqpdHKTrT6dx1ELtq8
464	payment	1397	1397	1678	1	1	420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp43r2maQxQ2RWqw4pLD2fvKmiKCZppbKzFM7FjGduPXN7L6wM
465	payment	1397	1397	1678	1	1	421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxm8RsRwNWCH4WZMqeoJRUufa21Yak1ZfKJ6CPETBfgXG9GpS
466	payment	1397	1397	1678	1	1	422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JwFJvNCTsCDHZnXcd3f1skqw5eV3vm8PrYd6WrGYi4xmWFMT
467	payment	1397	1397	1678	1	1	423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qWLQZzG2PraGeDCXQTP1s8iWXuhj3cvfPrhBvkGPNzsbNcXu
474	payment	1397	1397	1678	1	1	429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmrxSWqMbRBaVCLQ4qckeRwJ7GBCQUoTFSTGw2HTh8K6wcccH
477	payment	1397	1397	1678	1	1	432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpQBnCS2smtWbZdut44mFQpSYD2KZ4XDuaJyRhR7NBp3552Q4
487	payment	1397	1397	1678	1	1	441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrRoywM3TiFHr1THyNLBJgQ2wrrE7FKxNs4hD16Tv7BnkwHGz
488	payment	1397	1397	1678	1	1	442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafHjuf2KZLm3mmfZq63Wdq6SDf8n37WjPho3PgCspzz1SAdpk
489	payment	1397	1397	1678	1	1	443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuLEtyqSEnmvKxusG8QKbxrP5dEtKzTFJBurPmwFhfBwm9SRA
490	payment	1397	1397	1678	1	1	444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VqK7fWKKGio7D8kFMnn5a7tTwpzvgJhun69hy8pMjRhJwuyU
491	payment	1397	1397	1678	1	1	445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASYfLs57EviWC9qqU4uaLPseQ8Y1WnNTQjmAsnSAjYC2hpAGi
492	payment	1397	1397	1678	1	1	446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSc4ZkMXFBnTKsYcMrnqi7KJNHnb7voPXY2vhRMURkdpKnJ2L
493	payment	1397	1397	1678	1	1	447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzA4fyfftXDjiTjSrxxZuEjafhsHyG7TRb4Fnn3VfpkEAJs1x
494	payment	1397	1397	1678	1	1	448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mF6JMabqgrXZ2Sqo7Sn8NxGKKwrqD6zhEAnauruohG3YjxY4
495	payment	1397	1397	1678	1	1	449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6f7iobdGTyaVJHhPb5Qyxut6jNqjcuiBb8HL4mP8o7ABrYeE
496	payment	1397	1397	1678	1	1	450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1euRCMnT9D6hFAoMphYk7hBYsDaWfNgp2ktpR6V9jrCABaWHN
497	payment	1397	1397	1678	1	1	451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZsuWEESz1KZSACyEZ7Bb1ZjVcD7PwveCXL9aTmCeg6Wez3V6
498	payment	1397	1397	1678	1	1	452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbABu3pcDWjZFHcLy5xdKEZpSnGipT8tqD9ca4K81Fb8S8BUe
499	payment	1397	1397	1678	1	1	453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGoHSgNzs6p4aGbtaeU4hkvAJydhzaYS8bR98WG8GjP4PJQQC
500	payment	1397	1397	1678	1	1	454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieV63scAKQ4cQtLxFGZ3SjoRgdSTTJdSvc5Ge7yCTTd3G6t1T
501	payment	1397	1397	1678	1	1	455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrx6EvKQJU6T3P2gvsorpL1wKxyzERtvHQJS7sbTTYH4dEb6TL
502	payment	1397	1397	1678	1	1	456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBnXmPgcJm2oRgdYe4DmgfRyR8EiAiSeHd5WmcCiuVEpumC6L
503	payment	1397	1397	1678	1	1	457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cHMgpaTGTGpno8opP7PiQ8p6B4yTadT8WQTeEj1WhDupEbKX
504	payment	1397	1397	1678	1	1	458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRq8B43ec7PwZvRWMdW6ZrNDKXBqH93HeNyV1sa2WbVzAyVts
505	payment	1397	1397	1678	1	1	459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnx2rKQ7inqFbSxUQuib5koge8HYo3HHfdw4cwbDqrumAw74k
506	payment	1397	1397	1678	1	1	460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuM4ZeMrVvXnzcx4e9PKP6kKdcnPuiaFVQjAJJ5n3PA7gZiUdu
507	delegation	885	885	1736	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7StvcKzLbd68tVAtmJsAmYp37evgjLTfNkAGUrbqNPLoDcL85
508	delegation	886	886	1736	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBipeJqaHhcFp1LCKsP1TSePPpCpVCFaw8CDdFxtSmxhUsgGAg
509	payment	1397	1397	1678	1	1	461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbqVKsBdP6fwt8M6Z8wQwY84A3Ahv9TG2ZWu8vVaq27Fe5Bgn
510	payment	1397	1397	1678	1	1	462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVCf6GddXD4crB7i3mXBYQBT6jFsb9VQHydgJ9vvAbRoJr1Me
511	payment	1397	1397	1678	1	1	463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wFUPvNYv9TgAi1xaMGMGnYDRESEvLbjPqp7E1apEWu783HUL
512	payment	1397	1397	1678	1	1	464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11mCqtaQogvKq8ewrhuRKK6qx4tfSC3BFfjBbzzhTTMavpbt4
513	payment	1397	1397	1678	1	1	465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EJ5uvpM3dvv83Sx7M31a5M1DnF832FFJyxAkjQZFELA9sRJn
514	payment	1397	1397	1678	1	1	466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQKFeGWi6Qe9sJReEsJv4i3RYMLpZnVaGGsY2jUvQEPAKyC1E
515	payment	1397	1397	1678	1	1	467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQduHdsFDPBANTtktaPGVgc6kgpR7UawGo857BnxKwh6KhLQnb
516	payment	1397	1397	1678	1	1	468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMiqG1cDjBBRDvG7EVgZwGRkJnPK5qV4o5bSgFx6Nso64oYhA
517	payment	1397	1397	1678	1	1	469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdTpkWu7hU4r1SPQxx6xk8MKKcxce389GvHQv1HyDyNfCMPiL
518	delegation	1714	1714	1590	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGWe3M7Z769qLJNN9AoXy7H3HPqAtx4DPoULTD4q7vUA3gbSx
519	payment	1706	1706	1737	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAX2nPN8uwDwqeCUuuUKznfGiCMu67QGeHtyinAECj26MWPAia
520	payment	1397	1397	1678	1	1	470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YdwaQyKqvZANzeog5SWArNrSQDdsxmqfkqGNwkxJamfYYXDo
522	payment	1397	1397	1678	1	1	472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXPMWPZYvpG38UYTa9TaJRwtCPoUezJyJGHcLHBxwoukjFxdj
523	payment	1397	1397	1678	1	1	473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoqQPEzpTq8DCCCGJeeoqSoHixkwH2bwsVsv7geRC9YZKNyWX
524	payment	1397	1397	1678	1	1	474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxtVRHyPAkNcFtRDXZkNQGZDiro8amLG1eCmuTu8ZvTEstrQZ
526	payment	1397	1397	1678	1	1	476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8cUxWp7LEfeazxYHuD7gaLTQdg2UHzrSDJRAUdubj4KkGo3mD
530	payment	1397	1397	1678	1	1	480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCsq1pv4e29ce6epXhhUCAKVFWY53rQKpRYvzdzj9jYDbYr1o
538	payment	1397	1397	1678	1	1	488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWRj2YCCZMuKZffpci9j1fRsNKtocSEjMLHSUHGf6w81CMs6F
539	payment	1397	1397	1678	1	1	489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWj5XRm8CSb72TLhwHvrEaLTpBzh8V6DQeX9EyjbGZvb3GRkQ
547	payment	1397	1397	1678	1	1	497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubDeuF51rccom8ExBmrwR4LH2mgyes85fu8qZNa2n8KFVn19E
549	payment	1397	1397	1678	1	1	499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGgdFXkDBe7UonpG32n4XydX9i426ktDtT1HeR2c6drQGjSHn
550	payment	1397	1397	1678	1	1	500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7eFCTzAC2sySFDpf4RmigzZ3ufLsmYgbwo6Nb19BmXyadQSG
560	payment	1397	1397	1678	1	1	509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBVZUh6GnPi7Anj8EATaPT9Gi6c8TuDJw7mfejdmY4JY2Jwjo
561	payment	1397	1397	1678	1	1	510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzh5HE7H15CgLHtLbLHXH5pPSnKK1hvNVVwJN8yBGW6TFpLhB
562	payment	1397	1397	1678	1	1	511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJhtjMQDSSx1D2R5PGUd46JuvC9mSR3NXVyaCactNTUomEt8y
569	payment	1397	1397	1678	1	1	518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1PZckQQG5n8u1YDxusPt6fic1WzGLgJZk83gtWKbt53iLDgN
572	payment	1397	1397	1678	1	1	521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6p6NUkSW3Y8LBt8mxT2aUSxAaUpDDxitdXLbNLcLAS5jmoVo
573	payment	1397	1397	1678	1	1	522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLn7NBVrHkW9q8x9yiy5qpXUmsC56AQKpMvwcJVWBoQ26KMVk
574	payment	1397	1397	1678	1	1	523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKShCZUTTNLYBkPEswcWWSe6iX6XtNnYdEnYzk5dk8r1dY4Ta
575	payment	1397	1397	1678	1	1	524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsJ98Fe6pu1qs7mLjQif6qR2dAqsuxwAobSysXQxQrq6UUqPw
576	payment	1397	1397	1678	1	1	525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnA9QhbeMLM61634tz7EtZBhvrLgu35nLYXFRaQLJsFaFt9kc
577	payment	1397	1397	1678	1	1	526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJcXdkZtBgTBYxLFV9Yrogxromnt22qEwnvcvtmZoV8wuXRV7
579	payment	1397	1397	1678	1	1	528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSu8TgBV2V5vGnFxJdxN55MfN7X8JqdghLL97v36ZpWPag4xvR
581	payment	1397	1397	1678	1	1	530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSeh7eHghePMjeBshWBVNvRdgEYaKtP4WKrjzqiLBRDx9rSCq
582	payment	1397	1397	1678	1	1	531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbHUtgjT21gKkRnrVb6Phqr9o2aSZDD3GDAaAvy3Pps6WoXDM
583	payment	1397	1397	1678	1	1	532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aqqcAr1abMDCGpvc4AJdZQA2CGo6MzH9bpBECP7C4ckwEiqK
584	payment	1397	1397	1678	1	1	533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4tTyGZhHum67Es9nFFNAJ1QnbrQqpE7tPz5dLqnfYdpK9DxZ
585	payment	1397	1397	1678	1	1	534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HzPZZ7PQoNWzXtQqdjdB3AkSpQLMwMQ9VUJ5DS5Rz8dBAWpg
521	payment	1397	1397	1678	1	1	471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHg1p2URuqY5cNsUD86xJhFPYiUxDe3Y4aQMehe1XDRg3V6dV
525	payment	1397	1397	1678	1	1	475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevyTn6KujZWfNZtYunKNqBm5Ut82h19SmcxKP8bRzekqJKv1U
527	payment	1397	1397	1678	1	1	477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7jTzWKmr4adX6mLRVxsavgmTQYs8wVivTPEfuFLcxWahHby2
528	payment	1397	1397	1678	1	1	478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3krbJcdGtxB1ieAPGridsw32qTmet6scPM4Wm9ks5bJQNizF
529	payment	1397	1397	1678	1	1	479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhCaP5Y2cPcTCdLdBbCTiwwdT4mTpbFhy9ERVbtkqqnrdPMej
534	payment	1397	1397	1678	1	1	484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikgWjU94VNaEQPByo9a9kH6SSi8NzMqVUchH3K5MC3eK9y9pV
535	payment	1397	1397	1678	1	1	485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCY78y8P16iNknyB7SQqj7iPvAc4gVv47sgLwU7xcsbABpeNY
536	payment	1397	1397	1678	1	1	486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctWjezirWfzMgrQSX7sNqcwycSVVJk851eu1cRy59gqZc8DB9
542	payment	1397	1397	1678	1	1	492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z28ddETvFDRPpqAQGGSGTc39MKhtXGKxMWhkv48YvM4Dab6a
543	payment	1397	1397	1678	1	1	493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA2CiGemKRQ823uLRbw5p6LAZaKSLF6cP9UM7tW1Rs4RxZQCq
545	payment	1397	1397	1678	1	1	495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTAG4UcX37ThBK1zXAZhh9rVJCaE93QMSL1yTgndX6mhYE4do
548	payment	1397	1397	1678	1	1	498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DnzovKKLLAKrvNQDcsd4xTq2vuH2xEopVkW4DsuhwpqmEkq3
551	payment	1397	1397	1678	1	1	501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXDPV2JL2QnRZgQ55nT6RD3W2ZXMkjV4nieWbxca1S3HkuNrB
552	payment	1397	1397	1678	1	1	502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjx55zeMspZYdGrX5HMaFDQeqDWdPMKYuXR32EEfNxjprgdjB
555	payment	1397	1397	1678	1	1	505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmr2U5G5x6UXwqwvEMQT6nqzTjYiRcBdnyhg6pejQ5f98Hff3
563	payment	1397	1397	1678	1	1	512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzux9xyUS1HZFjDoJ6QLZdugnhDZJeZAnUSExrrT4aniu55r3t
564	payment	1397	1397	1678	1	1	513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnkPYB4d98GYX1wC3aFrLnFbxpQgKedRaJnwFh33KgHmP536m
565	payment	1397	1397	1678	1	1	514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzhHduZ4EviSzjMWJuS4ErNqGYghM2a6gXoyb3aSrpNZmJmm7
566	payment	1397	1397	1678	1	1	515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4mFQV32nxamZZzaBVK7pNqHWYN4Z28KWjToW6upNdeLfnWDi
568	payment	1397	1397	1678	1	1	517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqWrxtjtA7JQ5x1cqRbnEVRStmuh4VdEBwjSnbwGpinjVPYMd
570	payment	1397	1397	1678	1	1	519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweuURkfKRHfMZTSWhacjc95f4vnjqX16L9uFFK2Cn4xvf3T6d
571	payment	1397	1397	1678	1	1	520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzv2ZzTDEFfHAuhrXRx9ZRx6VbdK8oKW3juSAT63SsKArrnSd
531	payment	1397	1397	1678	1	1	481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumxcW3v2rb7PKm9xPNyxBHX9fGnu9GPc9QfaJZW7Lj4AfpVjz
532	payment	1397	1397	1678	1	1	482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnngwQYNhWXssLtmggAzU3T9qCuNCKxzWfJaC37Ez8LAHQQLpN
533	payment	1397	1397	1678	1	1	483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTz9r76iAMWWXX1Qnzv3GCVjs5FKLQpsHya11yoX553Lw5iAra
537	payment	1397	1397	1678	1	1	487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtxjZR4ifdvzs7Z5fNLkECdxEAkzNAgQPJj5VHHNb6RXN18k8
540	payment	1397	1397	1678	1	1	490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWPMnBdPe1c1i2u842bTYGXeVMyhchzz8P6PwQmdpcmqpR9GF
541	payment	1397	1397	1678	1	1	491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQq66NmPgM3BfEAMfVUM7DBMhvxbUGSCGmc8iaBbnrNnm2LAcX
544	payment	1397	1397	1678	1	1	494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZxj16RYYoCShdyRP2vgUk6CnJ4vfBjgrhYoDdp1iq1zEY986
546	payment	1397	1397	1678	1	1	496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuVMmUCgXJaEX3Z8yEzb9egZDyk7Q6rNibCn8Bks59t9imsTW
553	payment	1397	1397	1678	1	1	503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVD9ZRnr7G1nHK1M2i2a964gA8tFKVGT4fnUToRkc2wqRKbpb
554	payment	1397	1397	1678	1	1	504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibTnLfn9JAQP1BMxnSXtoehvUcuGhQC26TyyrhhtS71DNmMt3
556	delegation	1681	1681	1477	1	1	0	\N	10000000	\N	E4ZMqZAYzJDQSyB4rD75zxVLcSGBp45pQC9LYp7EhekNmPt1btodA	CkpZBcS4i5VbxciCoeRMaP9cZM6imtVJtiSTnNWEStoHwfD5JJYwZ
557	payment	1397	1397	1678	1	1	506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKeztN5TqcnTKCA5u6aQi3CUGJyiw5cxRiAVScRvqZ1nMujNQ
558	payment	1397	1397	1678	1	1	507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59JJfHmZM5yLEqfsqCToXdHUzn9TzutKnkYLEC8de62jWngto
559	payment	1397	1397	1678	1	1	508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS6oE4rcbkEmfpRKSR4afiHec71ayub7af6df68RHuhtSYNYM
567	payment	1397	1397	1678	1	1	516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmE8c5jN9bM3vydFphUf6nBTw6frVdZ4mMqxSNHZ2jwiRd7pz
578	payment	1397	1397	1678	1	1	527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLy2HzR7LF3oyFck5T4RURDunoTnzkoMt5LqLgcae3miQGk7R8
580	payment	1397	1397	1678	1	1	529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9afKtnhhCjmHLaDxXBfuYzbYuPxqEMyQRw9vgfGbqA5WEpEKT
586	payment	1397	1397	1678	1	1	535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNNrr6sDXVVjByuisehznAbp7sxrhs6hCVGsz1H1HF9VVBYzu
587	delegation	1724	1724	532	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaYtRvSmH59PtR9wLghA1N1jSTcXb5MDKXgBwirgaRiUAEby9
588	payment	1397	1397	1678	1	1	536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZ4TXF8zbEWQHYeodTLFZWTujEevVa6WA58SxNUDyTDBHnXHs
589	delegation	1724	1724	532	1	1	1	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjzJx9q9mRBeKusWvB7vnd1k6NtoaNL6k1aPJausTcGNGJjCe
590	payment	1397	1397	1678	1	1	537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2476xf5JQ39gYKZhEj6VP9nq1oZdzV8HSiPMtfbn3svbXttN
591	payment	1397	1397	1678	1	1	538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkG7jAHTkwc1EYqTUxZE9bde7br56a5XWUvrPHX926115ntQn5
592	payment	1397	1397	1678	1	1	539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmx6K2wHsFFHx3j4UipNyTT89F55L8nVN7L9mTQtuMVPXuXpjC
593	payment	1397	1397	1678	1	1	540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZobRFZviBbPJXPw371Yk4tFuXtLEAcAFRqzsBp4SvBSn2KAF
594	payment	1397	1397	1678	1	1	541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcj48EMo2K1YpCp41LnZ3ukDZqPRZ1HoHdB9aihP9NTmpsnAG5
595	payment	1397	1397	1678	1	1	542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfUQQcT3iiNhNu7n9mnXyfz9jMpeqCVnYLzYgUCtMwE6KMYcy
596	payment	1397	1397	1678	1	1	543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL51XhrRv3ngopZW9frDqK5E9oQZDZBcLFLQBVrTeA8gUsRevu
597	payment	1397	1397	1678	1	1	544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHB5DFwEBQSKys6aFZXtE6mc8yjUqm4J9Zs9GAA33f6fd5VeMa
598	payment	1397	1397	1678	1	1	545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrUHUhh4ETGXdrKy221SiBTBwxMkowkUApKUCXRbFEuS6kaAF
599	payment	1397	1397	1678	1	1	546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1UjP8nRak5Y1DbfeAcgA3BVUpag5BTLb1iYZvxLek6oeiy1X
600	payment	1397	1397	1678	1	1	547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cChfPoozA9CpTNWpuYMsXLbPq3Yj5D1ndokvyoH918ZQxcpo
601	payment	1397	1397	1678	1	1	548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXqnzsxyxLfaoyEEVKmTRqh711Gmmdkd8drqCFgX4WVe88TLi
602	payment	1397	1397	1678	1	1	549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW76GGG7Sd6447SCMGt8HYDNrnJDfri6adLLKGvALk5FXBhjr1
603	payment	1397	1397	1678	1	1	550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfirVj88XXEzH2UkBqoP8dCT2cZ9rC8mAALYx8K69xBR9fKqpm
604	payment	1397	1397	1678	1	1	551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TZmS98V1W2cFcnuiomjKQHDFVi5iXgZr4qcuaUEcu5tUWyn3
605	payment	1397	1397	1678	1	1	552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRgreQjXXCy7xKGzzXp9BFeMaACqj3WBu4qckf3A4imTVdbXU
606	payment	1397	1397	1678	1	1	553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6cAu2GHF4NRANNrYDQUx8zEXcf1u9i51vZ1WdHkmP3vRohCG
607	payment	1397	1397	1678	1	1	554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMMvTfWQvRCaYnPWAMLBtdckMUD8cRzCRnq82E7GojLzxv3Pz
608	payment	1397	1397	1678	1	1	555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZGpERn7jt24sHLSDkojgHF6DGT9RVoJbpc9BPwysA4KDhdSP
611	payment	1397	1397	1678	1	1	558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhFZr71VMvkxt8d486XsTZzwdFEkx4XNQKJhSwf69jNSnFr8C
612	payment	1397	1397	1678	1	1	559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDhSrZXh1v5dmyg6p2QcrSwKp7JWmmHVgSWqw97dyzAACQwUU
613	payment	1397	1397	1678	1	1	560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPqykRgkCzcgmw5d4gGHdwQoY5XwFb11h17WfmXBvPjj9LiaR
617	payment	1397	1397	1678	1	1	564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBBQMQJwZfz7sftyrEStJag9KKBpxaFKkPqpWyynbdrgYc8hA
618	payment	1397	1397	1678	1	1	565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtPuUWwqZUK2fpt1muREbubTtPCh3qHpFmx4P6G4UzGR1Y5vB
619	payment	1397	1397	1678	1	1	566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PReVmdnsSTpqwcfA6zYWW7cEBf3HY3oJX6gLwhn1zfUzxCTk
629	payment	885	885	1736	1	1	2	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1dw1GTbH7vvZPDE1vS7S4Jq7YFvK5uaAUCHVCZxQjwZuUSsg
630	payment	1397	1397	1678	1	1	573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPE2znGocwxRyaAJ7dQpvcDFTWeuGNgRqcMhi9XrxNLZpJuh4
631	payment	1397	1397	1678	1	1	574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuFssXJ6EHKh7TGnRzsJJ27o6AkicWk9JaESAHggkRUEQM3dW
632	payment	1397	1397	1678	1	1	575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfNXpMY7DAgWcxwcErbKmn3UvejrwCLe392BjetHT69diRX7j
637	payment	1397	1397	1678	1	1	580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2drhWz9HWqHPAwECpNq9N4JxQZvw3DuEGesUfLDYM3ZpoeRD
639	payment	1397	1397	1678	1	1	582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19U6WKTs3BNN6rRoUMn5kAyrRbKPqfFbC4869kATi1zYYThgi
644	payment	1397	1397	1678	1	1	587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQky45cB6f4MJjYdtUcPiMWuuzTXuFHCuk4nECfXPdfhfTRQR5
645	payment	1397	1397	1678	1	1	588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSkd9osw9yLsXrJCdnV5tpCdAqT319wdKQsKZZw2E4Y3uYgr8
653	payment	1397	1397	1678	1	1	596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SbGiJuWQGw9JuQbd5APmRpPMdFBWgN6RTbySZGqbuatFNFHy
666	delegation	886	886	1736	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjtYHKAa6DL25DVNypakvbYnW37oiMXYVo6zMhk4JNYvC6uVV
667	payment	1397	1397	1678	1	1	605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHBjiNWthLXzSRyS9wjBvWKLjhtuXns9nCUhL5KVbxpgfXzkQ
668	payment	1397	1397	1678	1	1	606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjSVT26ZyF7DEzrN6paKCFt9LHMvSwrJkA5jS3HvmEyRT6Rtn
676	payment	1397	1397	1678	1	1	612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfLSVAHJSsHLCJ7n3e1wvvkNCuFBq1Jd4QriRQm9wjgU9QKZk
677	payment	1397	1397	1678	1	1	613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLQ98ZRyKKQ1uTtFqvCWCxh2wiapKra5uXsQJY4jEst8zKaCW
678	payment	1397	1397	1678	1	1	614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nx1YfTt78WTpxsnQUDzjnbzxHu5xi4ubYVqQWuWgEu6bBTkU
680	payment	1397	1397	1678	1	1	616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudVwL6zntPgSvPXTJcbRdvAd9w9tMMcXTJ2wdu14wBpnivjef
685	payment	1397	1397	1678	1	1	621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZErh1aLj6dNxLhgBEHwY7LkwSJa9yG87HcUFbtJUcTTfJgGm
609	payment	1397	1397	1678	1	1	556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUWqn4krrzk9MGQv93u4xWjkkqZcnjmn4SmNUYqou47giX9eV
614	payment	1397	1397	1678	1	1	561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5q5VtgUJ7HhvqDnkh1fMxg59f98PC21yTL6qPNeFUEZtaWG4Z
615	payment	1397	1397	1678	1	1	562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEGKburjvuCoW6AEitvSsuP84ZDmexUeXoYf9y5FnrYNQ1ZNR
620	payment	1397	1397	1678	1	1	567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhB6Ek529pyeCAhEgCo923mHQS4YpvnpptKVLrTxYE1zDB2TKZ
621	payment	1397	1397	1678	1	1	568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEaRiJpEEEqzRsX7xAeiU3STzCPPHE6HokhCdr8Y9xJb8M969
622	payment	1397	1397	1678	1	1	569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLwGyvHLgAHQqFaup6rgcN7W9zfEXCBBB8wuCLQuGa7xPP3ve
625	delegation	885	885	1736	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyc6shKurW25L5dDyuNsZZqNwoZsA7xbQE3suzXvn874RaaNS
626	payment	1397	1397	1678	1	1	571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpoPKkFJ7S6sZ6HLhmax2f8haPQc2SqecTAT7M714SFafjqSt
627	delegation	578	578	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpHpRjzidqX63cSQvFFLWHHdKsQvfRykm2QJowLFbzsFL3m1k
633	payment	1397	1397	1678	1	1	576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JVj6btAZe3pX2bDVEkt8m9XbqEQFz8XjzC8m3zjsxc49AJVZ
636	payment	1397	1397	1678	1	1	579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSF1hLsCvSFj5s1uEEd4jKpdfXPxV54T8mvds7BgZ4zVrAeyA5
640	payment	1397	1397	1678	1	1	583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziCTKcQ91EkxXzTTZ8H7Dv8CZf5g7vQ2RpPPVLMqWLCShM2gt
641	payment	1397	1397	1678	1	1	584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSqx2kHWxvzqoFqiaYJNvqxhV49QXwximCyfp1N3Z3YAaMJ8W
642	payment	1397	1397	1678	1	1	585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFiNyECGPY4Aq67YMCNBp5NkNYA5jNZRkMBP5gfPvWzwHoiti
643	payment	1397	1397	1678	1	1	586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKfSi4Bb7UCaicyYPjrj1dEngfuqVDzuK9khiMV6KoPZ4Fwpt
647	payment	1397	1397	1678	1	1	590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqKuExh14dMivkYR9DHSEK1J4iNtbGySgdJG6PRJaT1ddcMS4Z
648	payment	1397	1397	1678	1	1	591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJHK361VTJ5iNdNoucdqVXeJFzMoQrUF6BnV1QXjeNiXaByrr
649	payment	1397	1397	1678	1	1	592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsVZdEDAbyQ1Q7jbKC5X28zMKkMtyJe5z9yt5J4kbcVqt8KJS
650	payment	1397	1397	1678	1	1	593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrzPujzuxZ4tM8KGuCroHGQV1uZdKcUVxoH3VsqX9snNiiwCv
654	payment	1397	1397	1678	1	1	597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZD7cwSH7LqY4Ggu5pPz3pK4d3C66nmL7DWCE754Xajc9yenj
655	payment	1397	1397	1678	1	1	598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBnrWSkoRsBjiH8Pvp53CzGftgAd35UwvmRfNaoPpWHqwC8xr
658	payment	298	298	14	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYgeaoxCuKYvpC7DfYfW3vTrMkgUr9HDRGGpsPNV5KLwzxuHV
659	payment	1693	1693	1736	1	1	5	1000000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYydXnnWxrWbYQmWmocVhbopzEJi9MfDjDqcDKydydDPFDLYiYP
660	payment	1397	1397	1678	1	1	601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGdoeFmHSQG9fpKF7rjdi3z4y1yzfjBYpzfgWM2eFkp8xZvS6
661	payment	1397	1397	1678	1	1	602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxy4BJMjws7oDNG7hiNhRtFrkdrsQGWNTYZHca1EvuhaVKsjv
670	delegation	14	14	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8YB2gn83fya8aGDXjgwMMEwqX3mCgmSZtQAEM54oP88KRuS7
671	payment	1397	1397	1678	1	1	608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKXTKPBMGhMg7Y4eBJkSz1hTtxSGAGJnpwiiSytSBpt5akqCY
672	payment	1397	1397	1678	1	1	609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PNiGS6rswxmcAwY12Eq8i3yP24x5FS4Dgb6HQ5FRm7yh3oZW
673	payment	1397	1397	1678	1	1	610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEXtPVka3GCZKHQ8wmENYTbaqb9d6fUf1HV4NKDwmtjupQ146
674	payment	1434	1434	209	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUMWZshchBJ4An1kCw5SoYoyWxqhQK37KY159TVN9ALLsGZJK
675	payment	1397	1397	1678	1	1	611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PA2W1aEzLuqDGSABT8rwopHzMqWCMmdqpUQDRbYERB53pDfH
681	payment	1397	1397	1678	1	1	617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DW3yZpGWDCE4m4sCRaDjtVjyQANJk1T8BVfRoL372Cci9dTk
683	payment	1397	1397	1678	1	1	619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsYVJqq3nqwDZhsvqGPTpojTkDnbSHqGSEvkeaAsLruF4ZjFN
684	payment	1397	1397	1678	1	1	620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAi6AZeFcYGVTmgTD678UkWP7pJ4LdSzY46ZBn7m3vS53yBAa
686	payment	1397	1397	1678	1	1	622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNgP2YBWZdfEKQbqMzxrk4wdw2NhSu92Ev4MNjntuU8CyfY5h
687	payment	1397	1397	1678	1	1	623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqwM8ukZ5Ps2WU9kdh3xxm92ActRh43Qraj8MACk1ADGqhuPC
688	payment	1397	1397	1678	1	1	624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qJDE4Xe3eiutAYBwU4rbb9z7xDaT6ncYhNz4qKdHfkmRrfkb
689	payment	1397	1397	1678	1	1	625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw6ahKYYUcAd5WLjQFtZvtNBMnvS2WBP3JwVaRnEvmoDfqN1R
610	payment	1397	1397	1678	1	1	557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TZdawFymGRaJhn2qqMooaukzQKxcmbLHrUTLx1ZVtLSWGu8w
616	payment	1397	1397	1678	1	1	563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWx4rgQumZoYzdMpd99RFgm6dTz9zFczxYuhoUk3Dw2mwmEff
623	delegation	886	886	1736	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uPLEMkDNbcp6GgdymBmMsaDKoYAzY519ramwp5rGMykPdXHM
624	payment	1397	1397	1678	1	1	570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacxvJzHd9K45Hga4yNmgiQDQUN8wLBqRYzPdfea8WDjFRCPGq
628	payment	1397	1397	1678	1	1	572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmNdN1Kbehx4SqEN5bqgG62Zg8dc6GiqERTfSJeyGz9cMnZPZ
634	payment	1397	1397	1678	1	1	577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9pU5Aq6YYP6ZTuxvBxkZcUe6V7b7RGs13ejyeSfmUywR9f4J
635	payment	1397	1397	1678	1	1	578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA9m99LyjLeNqFuf2UXgpuwJPs7LEGw6CftB9qN9Fb5FCCyXp
638	payment	1397	1397	1678	1	1	581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXPSxba1VdzX3fzw5fJGMtG5BVNVJJALVHm3bRexSpCm5nzvH
646	payment	1397	1397	1678	1	1	589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dEfvw9m3VgjYnmXKoG5WRUqGBFJVpc8qRGc1JuvTDMTqf5nG
651	payment	1397	1397	1678	1	1	594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGufxUHFUkEeuM4izArLe2RshFzq4woLzFmadVswLavsy6R13
652	payment	1397	1397	1678	1	1	595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2CBUfJDGKxr1QNciZHqqmyQm4WMTCg4uKjXLk3ARHoASGVRB
656	payment	1397	1397	1678	1	1	599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXysTNrNwRTg9Z8RcmaBAu3PZnfYEAn4Xor4DqbYDri4yeWx9
657	payment	1397	1397	1678	1	1	600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKz5iv6tkgeaDNGqnDDfcHqCHqaeHcW6UfSkYycosXgd3MPhA
662	payment	298	298	30	1	1	1	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdquTViDThrqbM5SBeBw2DfEf6UmSZoFB2J8AiSAZoDEwcX3T
663	payment	1397	1397	1678	1	1	603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPA3Wf6oDMS2qFDtqmpxsgvbEMkR3wFG27finK2XAPRUzLDin
664	payment	1397	1397	1678	1	1	604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzkfBchc5Njgb7uSz6LDhwWSioZcW69P7Y94aqXRLqfNoGjwz
665	delegation	885	885	1736	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKjw2t4ugCpfvte8FiPE8EaNwVhr5koTC8W5dUN2RQUoXMJ6y
669	payment	1397	1397	1678	1	1	607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoE6dDKwFrZ6hG8acZaDxB1wDTvzHNVBP9R8Kn3emuBbdFckw
679	payment	1397	1397	1678	1	1	615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxcqucbTG6EB5pnQLTomqGuR6u7pDkSbBPY9Nq4pDuezwPyK1
682	payment	1397	1397	1678	1	1	618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5Vwkaxw9BP4PxeCcb858dPnJc4EGgpiFdR6BNXewvsTXJi6Z
690	payment	1397	1397	1678	1	1	626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGKH4T9rjUh99a5aVdeDoPpQsPjttcbGai87YWAq4X57PHh5t
691	payment	1397	1397	1678	1	1	627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjk3oeoq7pgK1RyHQAPp7D6RuQh6vfEdCtz5Gn7qho195FPKH
692	payment	1397	1397	1678	1	1	628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTexqcDN1iqE2UJ4szQAEEPKEkMfs9DM5si6cBjiGhGKvKmkr
693	payment	1397	1397	1678	1	1	629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFobAhcL1344VoUPV55cP7oeaLuEkdFb6SMTVsqc4KmxU5jFf
695	payment	1397	1397	1678	1	1	631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh7pj1c8yD5Kenu7jweUDQtgsWabLSqxr1eBAAjoUNbibXN3b
696	payment	1397	1397	1678	1	1	632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvA73ca7Si8AdeFgNdwvW4pnhnNMBFX9Aue8JWKeY8zavu36z
694	payment	1397	1397	1678	1	1	630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYZo7UdnGbevHBhECQbTPQzVQc82GYysoyqKYugRmehggWMY6
697	payment	1397	1397	1678	1	1	633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDaeibNU7GBSEizS6ckaz5nM2LmbHW1pFHw6qrCHFdBeaYidH
698	payment	1397	1397	1678	1	1	634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfDT1bqs3jJfx1sZ3gJStSWtz3XPjDseE2wYaN6kbVdwgbKhd
699	payment	1397	1397	1678	1	1	635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaaj9RpyS9ewXexRKaqjiCa5RzdYDU51is8KtRp6CTWnSeSFx
700	payment	1397	1397	1678	1	1	636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFAh9DLAQexzyFMct9CBvEgs4DT91aZLveCJdJC9gAiFKPWdS
701	delegation	209	209	1434	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZnVKUQVDgJLQ6N2hcKcxLZY8MfeAiVd5u1K82KoFkMgZXZw7
702	payment	1397	1397	1678	1	1	637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyvaspEAm2TRvArhf4XGTETnjQczA4hHMyD16DQ7DWQ4aeFiH
703	payment	1397	1397	1678	1	1	638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsa6d3QgAJNYbuA59JvsY4nLfmQ1i3XGAdysJMqy8T7HjDACW
704	payment	1397	1397	1678	1	1	639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoKxDyD8GtzqkyJH6FXHg1eRca9HY6gZxNusnyPMhXKUH9QAT
705	payment	1397	1397	1678	1	1	640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSk77WPn1SoBVzbirAbVV1rF7QFg5iPSgE5WPcGJW6HnX4AFek
706	payment	1397	1397	1678	1	1	641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uzazWhEzzFDDaTW2bvTEMkqax2254QUrkbf1C2jhfr8EQkr3
707	payment	1397	1397	1678	1	1	642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESsVq9KqgqVMwygj7r22RETqMm5g6iFasJsfHy4d8axYJoAnD
708	payment	1397	1397	1678	1	1	643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4NNm8Tpk6oNs3z9Pzq1uGjLTx5MtCscQMq5XhweuogBiEh34
709	payment	1397	1397	1678	1	1	644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMddfx745UyWwmrAP23UdBqujT2KKYYnuA8HL7tDn9RsWVnC4A
710	payment	1397	1397	1678	1	1	645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkrFgauEj9rH1Hpt3nG4T3nvt3vEcyGw5jnkETnFDcPiVRUyB
711	payment	1397	1397	1678	1	1	646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJVMP1tTubZcS3baJV8eTyqMRE6MZyEDJ5aMfiCqsXyV7DE6v
712	payment	1397	1397	1678	1	1	647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQ1Rprf4DiTTy1HYc3q6AAK5XWw1FAyfG2eGi5n9jK7vtTFxN
713	payment	1397	1397	1678	1	1	648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXT4RQfjiXaGUP3LPjDwjuhfE9y7aYy8Sy3ymNwD1cLkhNFx8c
714	payment	1397	1397	1678	1	1	649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRr3mcWJzWLR1hPs9nrfPPyqpS8zy7qvdWQZUWyqWV62RXyE3
715	payment	1397	1397	1678	1	1	650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSSwb16Ls9zyttwVs6fZoSbfxhg2RPJhu98vaZhsjT5ajUZq
716	payment	1397	1397	1678	1	1	651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhcVNMXzWZLgi6q2Q8Re4UMa1cj32jtn6y1CxbCaPfcEdgXee
717	payment	1397	1397	1678	1	1	652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6SxRcMt3HRhtm1vtYp4Cdr5hGtmhqi2MoqbN25vuejyiDFK8
718	payment	1397	1397	1678	1	1	653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfExSTLh8XJsAhvnf3K67njtjTd3zs1RJiohStqs7hoGZbxKd
719	payment	1397	1397	1678	1	1	654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrd7GTJ7w8ep44r1oLggpSqYCmLYa2KE29HdwqEqS89cKCafaP
720	payment	1397	1397	1678	1	1	655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvkEWwkQzdTPuM4GaRxCTVmeth6hsuCCkFsv4XwN5ssvSMBVn
721	payment	1397	1397	1678	1	1	656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7WByUeKhTt7rocNDm7BDTRgPjUME7AYK8fJ9hdN9MmC4izec
722	payment	1397	1397	1678	1	1	657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpwQosxzBQYQq7Uiw1Dmpk2tu9s4vLwZfLuvhzKKHmehSJBs2
723	payment	1397	1397	1678	1	1	658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHms6EZDXpBtXgVV184KYBUX3589dR5WjFySmbSTbzgcEvsbRe
724	payment	1397	1397	1678	1	1	659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw6bN1RuGTyKsUz9w3ww8qrN4waPQz82RFgW3ro2UTbkJQYjK
725	payment	1397	1397	1678	1	1	660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz8HxJpHMBqMvqykv7FmsGYXsz4v76pwiUsFdgsK7Jx83tnbF
726	payment	1397	1397	1678	1	1	661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJq7BtcukXNEjLmZs34tXFuK32CKuQfF2wpDQYCn9cyamzX1G
727	payment	1397	1397	1678	1	1	662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrMoK8iKwWyXdY8dfTmWQY2RrkxQhjMcKkcPgqp24zeFn8Jec
728	payment	1397	1397	1678	1	1	663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4sA4KhAjPbGDi3crNt3gXiS8P7gsYASc3ty3rvwzT7rrRe4o
729	payment	1397	1397	1678	1	1	664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUo35BuyXSYy7Z8Uc4Wcf3rSKYfP37cDPs25UfBVeiEfyjJWa
730	payment	1397	1397	1678	1	1	665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8m6WG9xRbVVdUshbTV2ruXkEMWePicVe5dpXixdCshhUa8Ecu
731	payment	1397	1397	1678	1	1	666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupVEPjZkBTc7JzamDsEuB1rXt7c9PYWJdVe6ZA2p3Vqi2pyFs
732	payment	1397	1397	1678	1	1	667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJ7RUToM1qVGAjhD6xEqeCCDfuYvXUT9z8BSKSgUCTobChnRs
733	payment	1397	1397	1678	1	1	668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbvhioaJ42ih32BSk1Z9ENTZkvhwD3d1Sy929zRVLijjZgBmW3
734	payment	1397	1397	1678	1	1	669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ybFNvDBv7mKLvpVGQYrUKWLdZLtCUwFJLsqAfM6XH3ZKnLu9
735	payment	1569	1569	485	1	1	0	719000000000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNpAmMpUdGTdbUHzn5rpDuH9oqf3GxsSUadS7QGzEofc43AUL
736	payment	1397	1397	1678	1	1	670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtM15uLbdtNWEaUuP2FbMeM5ZbjGSroTJMzMyikNHwesaSQQVh
737	payment	1397	1397	1678	1	1	671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EEioyVcpw1CMzFNgbDnKomo9cBJaRpWVMg4YG4XMit52SrTL
738	payment	1397	1397	1678	1	1	672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidKmbqeAggyNkj68qZd5otoLFKTLUamNrxu3eMpbcgNjAyT2G
744	payment	1397	1397	1678	1	1	677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDxDdBoz6fvt7eV3kX6oYzfK2FdNZeuUrYULpEJWdhsRFY33v
752	payment	1397	1397	1678	1	1	685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDV17UW1VLfo1LiG1AAwvb6A39ZwcnGynyepq751t2xPwT1oMf
753	payment	1397	1397	1678	1	1	686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sU4JzVqFD3h1XTFTzw96eDBxvAABDMWHgxVGd3Z941Q2thUq
754	payment	1397	1397	1678	1	1	687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbXh3T2hxqyG9ucQVUjfb7J8HaznK1roL5xUzqzRiawdDridq
759	payment	1397	1397	1678	1	1	692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmrefu4Ndi74zRwPZCN7yh2ctdmWpoWmgp619apZNsVbVzgXR
763	payment	1397	1397	1678	1	1	695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3jAw2GRjHAMQkQhafRjH3o6cCo15WqzSTS19TZypJp6rAfH2
768	payment	1397	1397	1678	1	1	699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsjDvH65gASzeS7biabukPojWYwtUpBGHtRfQ3fNNQ63BrneJ
769	payment	1397	1397	1678	1	1	700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdn3nMBJuFQWWyaC1uBA8HmHqBD9wQ7f2X4Zt7uASS5wLi2ahP
770	payment	1712	1712	1743	1	1	6	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCwWcKJ3kjJ1NTwRDrdxd9kVXNazhdgzjtGRVR56Rnj6bDBdG
771	payment	1397	1397	1678	1	1	701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFZFnP28zdiY2y7Tay7fteGnB7e94E6KcDMaQaxTjg6dekr81
772	payment	1397	1397	1678	1	1	702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshNpPdmWagjzJsWnALog68PwUUE548W3iHkAVztZmJhhsMedi
776	delegation	1698	1698	1578	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJDCoUY5R6GogeEEHXV6wsJ8p2mcCpmMogcETFFwMmTjuy5Mi
777	payment	1397	1397	1678	1	1	706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXiBa77xo5ALp9U5oz36dijahdsPiuLhqF5vNM28Z1LBjc3Z8
778	payment	1397	1397	1678	1	1	707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWRUWCk8PpfxpcwvxkmrBVeDSvPYMbp9Z7dNQp1K1HuyJTR2u
779	payment	1397	1397	1678	1	1	708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJnN3mdRn1Qf3UNENdF7poNf59sayzFuSwNh2juJiGLy8kFPG
780	payment	1397	1397	1678	1	1	709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8NFRkUERPSoNbkrMz6ybZEzKgFtDoAQ2eJu2U6rYgJ2Ym7BZ
782	payment	1397	1397	1678	1	1	711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN13aCdwLKqyWob92at9K2pxG9mouXgtmFJtkq8rgyzvmerwN
785	payment	1397	1397	1678	1	1	714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqcG1XGhCMQdBpdUYuhQa9WKyCiUqwrjtxBybCWyTwuuYXyWQ
786	payment	1397	1397	1678	1	1	715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcDve2n6Qi4nEG3Gpmg887zCKirgzmmt4CRjSdq5jvfc9Ufh6
787	payment	1397	1397	1678	1	1	716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhkyna8XbwTGmBJ4hPWYJt1wvY5XyBqprfQ9e2q35P6BbDe1N
790	payment	1397	1397	1678	1	1	718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAVucbjGB4aGVMZ549gGeL4Tcmun5NWABsxrNFa8XH9STshSQ
791	payment	1397	1397	1678	1	1	719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEFwZau4tk8xGHZoT9BPLgx44dePQeCsy7kQzHjiYqTRRYcix
792	payment	1397	1397	1678	1	1	720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNDRvkKP9V7hg5AMhhMU37knAeg6ipT27FZqHxUVWd8keVEKc
793	payment	1397	1397	1678	1	1	721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLas5Ui8Egqz7G3jtKjFkjCCMgM8QHvNizw5DcZRReeKQmqxU
794	payment	1397	1397	1678	1	1	722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzG2mt4EwwM2Rwu38x48wBZoJgAmsaJ1j888o4LxHjK1Kk8tu
795	payment	1397	1397	1678	1	1	723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSNedstvnHK6UrGvYofzHcF5BWS2s2LRw42ZhipnQ6dAaQouy
802	payment	1397	1397	1678	1	1	729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCqckGisJZEQN9unnJUsGjFH1f53B2tvwA9grU3eC7UTpN887
803	payment	1397	1397	1678	1	1	730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAjYDgzctZr2ekfccHEzr2KbgTprcbynv51WDMCSpLKwtiQLUt
809	payment	1397	1397	1678	1	1	736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvVFTcB4rTxScFJJwwNoQWz2b1rwwU87Dx9TegTCSk18YtCAQ
810	payment	1397	1397	1678	1	1	737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkzkCAfHXAhfNnV4Ryq47jboWsA4RenfKZTcowzqT2RGJta4r
811	payment	1397	1397	1678	1	1	738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL92m4PkjFPtSZDhMNgdgJhCSdcNZRW3z4gSoH2sQHMP5QqA6R
812	payment	1397	1397	1678	1	1	739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNi4kP36zchL82xgxBv2XBXU2dTnoUSbLb2ojgditVCbxriu
813	payment	1397	1397	1678	1	1	740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNznzohRjuLpteDCUFcp4mZXyfh2yWX4YMmxoiTwoo9Q7Esag
739	payment	1397	1397	1678	1	1	673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6Fp23oZWdf8ESReFgvYsLeVQnRASB1txA2pcRr84PytrHs8W
740	payment	1706	1706	1737	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivG9vjKmuzJtK8ZvmxGHQJG47Djj4W6m96HgaKe9mHJyZKAsC
741	payment	1397	1397	1678	1	1	674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRn5cKQkiPczs3DYdb7q6N3qvq5XEE7Hv1RhqZfuV2gNaL7EZ
743	payment	1397	1397	1678	1	1	676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEGL2LZG5odKR2aLv2yd6HQBAtgYp7Ma4zaPFQ1ezGpHwxRBK
750	payment	1397	1397	1678	1	1	683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMPNZNPaKFjKqWXNWfLgxuXttNjHz3j5RBwUwbMjqiZyRbrzd
751	payment	1397	1397	1678	1	1	684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMkDVUtRAdSQiR2N61LR4nrBuJNGZapYbNMMU36VQCVuhZLpV
756	payment	1397	1397	1678	1	1	689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ3UQQPBJkssfwykZAW6fp8LTLgMkZ5Z8SXcc3cP7eHKqgJWk
757	payment	1397	1397	1678	1	1	690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkynLDpHJqZXktN8ZPZybDvKKmk7G8UqXBxDw59wCWMJucrwa
761	delegation	394	394	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcqUyLBR6SxxNfTRRLu9YVteu7gKmtu2d9WeA6VVHS6iYUUSP
762	payment	1397	1397	1678	1	1	694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgxyZFb6mxrSKeNHzwbrY5HrsYdPex9tRNXovQZR7gHHrstus
773	payment	1397	1397	1678	1	1	703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggQK3RkJNYDLKmx1kTYi7McBQQHTtj1HFaC3w5XiWAZKJeR6w
775	payment	1397	1397	1678	1	1	705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VbymBTpXoP8GgFxXLAx5TxF4JHChaBatR8LHS9W2j6DWeJTq
781	payment	1397	1397	1678	1	1	710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiyBR9rWbANdNKrpSwit4cS9MuezvizzCkzKHCsge6AwfZ9Sg
783	payment	1397	1397	1678	1	1	712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUERmkiGeDdaZxXHvyQwZDRygVFzsoADbZCKjXkPw5zZQoPVg
784	payment	1397	1397	1678	1	1	713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1VuJ3DVihNChZ5zJGxA2jLTRaQBk6QePvgFf5qrerUxvdnvu
796	payment	1397	1397	1678	1	1	724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6KUk5FpzLpSMTdM8Pn9uK78VLinrMNTECiYg9vF7ywPVEobe
797	payment	1735	1735	1745	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1zojT2Fytn4oEV85YcTGjpupdSTVYiSjkLSu5RjZhRu6Z45G
800	payment	1397	1397	1678	1	1	727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpmvDz2CNCNbfkejT4cmsoaYQsvxS1bCZEjQ6uT8TD4KhKFvV
806	payment	1397	1397	1678	1	1	733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFP9hgDUDhwzLoXzapAsp7CXWoum382WVrJdXenZ7bJBcpsnoM
807	payment	1397	1397	1678	1	1	734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBymLiNmwHJy6W8jgrBJNURu8F3VEK9UxXnqjsZDX9SxXan86
814	payment	1397	1397	1678	1	1	741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9av6gCmEgogWFkiMztjcPXBF4gkJtcQ3M5Eb2mbgt2XZbLUjG
742	payment	1397	1397	1678	1	1	675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuFmRhDhYTq972vvfH5DCRsnKzTBZhXQ4fvsQuHL33va9GJua
745	payment	1397	1397	1678	1	1	678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvYYos6AvbHMcz9rXmVrsSP58ai7S9opS82on1ez2EoGSYim6
746	payment	1397	1397	1678	1	1	679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhWcU43kuSNxtL6miJHix54Y864wBzcLB7PFZye5P9s2fJvfY
747	payment	1397	1397	1678	1	1	680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgw9J8rHfcr7JQimZNm4XvKXGFzXFsYDeLBSH1hxj78j5VL2d
748	payment	1397	1397	1678	1	1	681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgzuXbjs5vzb5CVeSP1be3Ni3Y7cB9hN7fBnu3uf1bvSE5s6d
749	payment	1397	1397	1678	1	1	682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvWTv6Lj7j6MoLdpLrAn6aQTRG8YEX73LPsHpm5Yvhw9KMFe5
755	payment	1397	1397	1678	1	1	688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCT7PdpALdEm8eRiurmuhQyar8pr7J9to1HmyrvcJDbGi2y5u
758	payment	1397	1397	1678	1	1	691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxGbEBS6KjbLbZ5m74wqBUa7FP2zqaHHAKT8beHmYHu2Npx37
760	payment	1397	1397	1678	1	1	693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QgVBu8BU8r7vPtg5DgUzYpj5poJPRAG5ePzmT7eQqSW2WSwX
764	payment	1397	1397	1678	1	1	696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PRhsydGbN5J2Zk1saAa6UyKyaPXiv96oyG4GXbiv2p1uLpfK
765	payment	1397	1397	1678	1	1	697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcWHwo8QJmN9YmUKTXt2ei68brAuuiUEAbALt2X2Rry7FACZe
766	payment	1712	1712	1742	1	1	5	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMpqzEuNV56mZsBhY6kLyxU8bB6hToryqEytk7SqiPHFRgvs3t
767	payment	1397	1397	1678	1	1	698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFFALQfappQYWtT2jahKbTujGu5mpM6Lo7aRuNDSudHR5ghyi
774	payment	1397	1397	1678	1	1	704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zs7KKAiHpo8mF2sh3oVcYbuSbhywnrJ112Qqgp43nthygaPF
788	payment	1705	1705	1744	1	1	1	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLEykMtKJxmAMUtFgYqtL2YAGdUFVM8U8bUog8JnrCtioW9ra
789	payment	1397	1397	1678	1	1	717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWYS4R5TdSifVJNNc2F4dzNAYhjQacGQUErKCVeuc68LztQmg
798	payment	1397	1397	1678	1	1	725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3s6tNMdxtgjzJbncY5c7Lk1NDw7GrAZdnHPbBoLaEYJfAxDK
799	payment	1397	1397	1678	1	1	726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVj9JbPSJR1wjcv39S6Wjan1qNYgS7H6Usmq7JKuCyFonKSum
801	payment	1397	1397	1678	1	1	728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wTYcjVhmcHzewZQGHMp13Lxj5PeM3mKmDbqb4YmxjDAJb9br
804	payment	1397	1397	1678	1	1	731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsYTT56dV8K68uRkDoDrZ8MxToULCpyQaYjK6JgvjktxBFCjV
805	payment	1397	1397	1678	1	1	732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63HkEo6hFMvihQwUPkKa7WEvq1nmn4X8ryMbqY3ALyfhHbSA7
808	payment	1397	1397	1678	1	1	735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LTj87GdjZQCrJ6uvALZPfPxE6zjNenUefhkZ7qmTwMsQy5yT
815	payment	1397	1397	1678	1	1	742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QTmW1p9gBoPcasSRYG3oFTDL3x7ak4E2Q112B7b7dMxbSrHc
816	payment	1397	1397	1678	1	1	743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHVBivzzLh9tqaXQWShg7p44KxfMJKfe5m6bLUM4wM9REynyj
817	payment	1397	1397	1678	1	1	744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhJsU6SuyRS54fGq4yeMmG5cCMYpgoNqBt514eKzzWmhrukTP
818	payment	1397	1397	1678	1	1	745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RdbVcPUsHA7m8L1ktojFGvnnGKqiexKBNyyy115cu95qqQEf
819	payment	1397	1397	1678	1	1	746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnSkwY5JVavRKtzVvCfTajtQoEwZS8BwfPMjvZcuJh3kgyAqy
820	payment	1397	1397	1678	1	1	747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKuEVRRk3zEfKMxsAVjwc1597w1wxBsUipbCw5Skcewj5uf6b
821	payment	1397	1397	1678	1	1	748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyDLyyAPmjK8FCxeNCvS4L4ru54DXdLMBWxr4jj9JSUpPHekU
822	payment	1397	1397	1678	1	1	749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdxyY98PJqZbhahZJBBwBVbd7M84XPiGgaLa2c6YbTtkx22TM
823	payment	1397	1397	1678	1	1	750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyqYZPzYjY2FpwTBrV8GDRG2CcjqjTpJkCPJ7gq2PdD5qoQpg
824	payment	1397	1397	1678	1	1	751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrko4n1RkhS4Lea8RkNJrTemeHdNqQJMdrHrfqNJJQuFajAEpD
825	payment	1397	1397	1678	1	1	752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusBPFhSehN3BRLzHQhiM6By9xxRAR28kSiU91BmCPTwCHDGY3
826	payment	1397	1397	1678	1	1	753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdG8VYqrvi5kz2GLhGrraiXEemNabV9CmjFbKLfNUjQ6FC71oM
827	payment	1397	1397	1678	1	1	754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGbDrLC29W21aPFPhVJpqMZe9tYSyjUJhnU5n7VK1StQJZcfh
828	payment	1397	1397	1678	1	1	755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFrWo3x78uPpu8CY7H6BtU7jXUXR19Cdv3uHNEnkKyCytaLSW
829	payment	1397	1397	1678	1	1	756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7z4ZFKtuT3MbPZMiu7o2cX5pgTV2iV4qwAF8sRN8QxjqTHrwm
830	payment	1397	1397	1678	1	1	757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLiwVWQZQG4e7PQbmG6MEjgPars7vURaLVqYNzd7oU2B8ZxeD
831	payment	1397	1397	1678	1	1	758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvFJkupxQTsEXQHJ51ZcK53UvgHy9Yaswr2ys9eEnyXuk6jo5
832	payment	1397	1397	1678	1	1	759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEfRC8UTPSTXp1pUWqQ2KQ5cQzedPyMAGdywVaq1jMnb1gZqh
833	payment	1397	1397	1678	1	1	760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrELPs8dJW19eWfjFwF5TDWXDGQe5yAhL3Uf1xXCAihkBfzWv3
834	payment	1397	1397	1678	1	1	761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xUa3DDNQeje9AfUYPhD4XfAGVzvVHcjmUKdib9eibc6Pu31i
835	payment	1397	1397	1678	1	1	762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcroB1LYvCv3qbw4eLiu9qcAs2Yj5ksxKSRptWXT7xRfpCyYor
836	payment	1397	1397	1678	1	1	763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHNDyxZH54Avey9rixfE2LU5cQMCvVvL9jd1RPYrLfVYRqhqV
837	payment	1397	1397	1678	1	1	764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEb1CYDkD9emtJCrr4TfuVSh6wnexvi7VQLsQhVbMfSPp8qDjF
838	payment	1397	1397	1678	1	1	765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq7xgc1hibZvaeQDFsYfCNPeNRWnvi84g8tUfvReXeG1oHCVx
839	payment	1397	1397	1678	1	1	766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ESfw7Bd5nSqPZhkk2jVWZWdFqSierBqEG1QjNYK5x7jhVBPF
840	payment	1397	1397	1678	1	1	767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiCQCQrHcwGQpdDuPkcmRaZi4oQgyeydhSbUrUMAyQTGLTxxD
841	payment	1397	1397	1678	1	1	768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCXuogJ7SkDUe6rqSAQymgAawf3tF7jeVEpfKX4Fjc2tdF1XD
842	payment	1397	1397	1678	1	1	769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscesLGFcUZguLXXDhigksDv4SpxBMUf2xdgeyDyci7tYQfkyH
843	payment	1397	1397	1678	1	1	770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbnJTaBYWDA8qbuVQA5jxx37NWseovAfMZYtm2wBb5A6WFM1W
844	payment	1397	1397	1678	1	1	771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQBT3M56ZzV2kdKDVoozDveiSuhCNzGVipqmJ2AousaTCZtXM
845	payment	1397	1397	1678	1	1	772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyg9T8AU9ATGssPhPBuvcWNXoTm1wWv1p4VCkBW9KqtMxdWNEJ
846	payment	1397	1397	1678	1	1	773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumLqTg7UQAb7qLYBoT4Uo9Z8sP3NQdUAjiAwCSV4qiXc8fCFd
847	payment	1397	1397	1678	1	1	774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiQQTd2y68nFp1xs7MYkpLqNwFAEFcrBpuczx1SsoRfETo17
848	payment	1397	1397	1678	1	1	775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59uQppahpoyX6AQQwjHSeWymJh76g8S1uBPpDhLLToZ2MEzX6
849	payment	1397	1397	1678	1	1	776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qno6Uxd7Gw3GmxMiDPWvJZ8Y2i7mfex2CJqQk4TsfwQHTBrN
850	payment	1397	1397	1678	1	1	777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcugxH1X5jkiQVvWuPF3txusGG6b9Eru6nLDahzRkTP6YtppX
851	payment	1397	1397	1678	1	1	778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTX5nD7yKySY2RPZNzDHQaqy76d78QP2qYrBNA3w6GzvKeRqP
852	payment	1397	1397	1678	1	1	779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekcHLC66VSCPFstvCzW1juNS8s2iEfXG19c74jVDTygk2FNpC
853	payment	1397	1397	1678	1	1	780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjoRmepD5SivN8zAqkCeNmhN6xgsrzFWNSNrUUyDpzkCYqA3o
855	payment	1397	1397	1678	1	1	782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pzVBXqzJNEPdYrYr74LRVM7YVukMKoZUED3o5GAjSNW2bAvh
863	payment	1397	1397	1678	1	1	790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo46HDRNHFhHiXVNswRCoek9Yoh9j8uaN3ka75pJoeDCCWVsR
864	payment	1397	1397	1678	1	1	791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWogd1LvJwZT8iBk3RJW1vTYRnaFXc4Ackh7zhn8CdbrtnAPPo
870	payment	1397	1397	1678	1	1	797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm58Aar3KeTSREY6wKfds8vX5PaCxRcsnsS276duCkSPvACSp5
874	payment	1397	1397	1678	1	1	801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWByjDya2LXTUddt8Zfnu3HKc6vJvw8bAsVshAGjmtzr4KTcxs
877	payment	1397	1397	1678	1	1	804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGvKHq1HHBcgB9FJcAhazSMxXkj9KGf2sTRgQybzQ8zvTASqS
878	payment	1397	1397	1678	1	1	805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCDTY4DfjNGHMQx5drVSMBP4TpSrN1UTYWfkwgvmo3Sxx5qWv
881	payment	1397	1397	1678	1	1	808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzQoPD5GHYBT8ESPq4kfBHicFkYeumhAkz4fm1Xjrj4kX5zuJ
883	payment	1397	1397	1678	1	1	810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAF7wTV93ZdhyrVDxhTXWGxVv8c2QcDDEerMKjWWX8Zqg3ECm
891	payment	1693	1693	127	1	1	6	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYqKKCC5m6WrLMqoqEbdpCYzVi5MEaxtW3Axhm9pD6UQMh3F6Pi
892	payment	1397	1397	1678	1	1	818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB9ozpp7DawtbarVjGYSibteEVEt2mNeaP8tddnDDfMypKyKH
902	delegation	1696	1696	1542	1	1	0	\N	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1vQLohBksJ3Va3c9Bcnyyvh199Skzm7hikhMmmPW9gavAB5k
903	payment	1693	1693	304	1	1	15	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ2ykiokk1t61FPXAeM9xrmCFTKghPYTr3JgsbD8tUq8NRE6HZo
904	payment	1693	1693	373	1	1	16	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYcmu7Wxy7zQhkBARffTtKDGX7XFCaq9nfA7WapGRZcKEx3HNDQ
905	payment	1693	1693	402	1	1	17	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa2Eo6GqdXH8vnPwRbqXk4ZYThMz4jybrvXmCrWvJBrvgbTvemf
906	payment	1693	1693	690	1	1	18	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZwvPwBwwwB2bRWFzY5SQfrAfXR3GJTL5hmQMtEcGNfWAccYL9H
907	payment	1693	1693	731	1	1	19	1131327550	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa1KjqCx4goXqiCGBFt3AbyLRcTRRUvHFFUToFjPEkKMeEpLNis
908	payment	1693	1693	877	1	1	20	114859821300	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa6BXbbxd26Dv8SBoDrDQbiGyM2ECAAhogixZgPipk6QgWTikox
909	payment	1693	1693	191	1	1	21	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa9bCakW4WHhntcEhFLZbdVtEjPF3zjHEj7ogbp7edifpZesuXr
910	payment	1693	1693	122	1	1	22	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZraUcEdFuqCBby8gpcvzamvL1gTzkgeT9X4jGYH4QpFZBS6W5R
911	payment	1693	1693	5	1	1	23	3788250312	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiEvBkdhKUPsMMwqbUShpZTFSceBJ9nzrgBhCbXeF2LyKa9L1L
912	payment	1693	1693	91	1	1	24	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYUVNynh1DBbmxucgmeGDpi4JceL3j6MkVjdAat64nPBZM4TPQP
913	payment	1693	1693	99	1	1	25	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaA4HYFgiUK5xLNdGq1Nm2b3yMgFwWzzjM1UV8TUqDGBEDcUJBh
914	payment	1693	1693	339	1	1	26	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYnks3JrjSN11oUg9x4UD7KMHyQA2inRkJiqPXvCPyUkqGvaESm
915	payment	1693	1693	420	1	1	27	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYeZVpBDN7c8TEmuVL3ftKf1up7ZoQjJT8At1Fd5KmZ3MpJffMe
916	payment	1693	1693	408	1	1	28	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaE8mrE7nwNeEbtc57G4sKha7kAF6LFXXZMcJzeCfcYLnr7viDa
917	payment	1693	1693	206	1	1	29	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAgjH7Gtrwba79WVntBGyujunc1QE6teXtP6PaKn48d9NEFyZ4
918	payment	1693	1693	397	1	1	30	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAb8MSMH8pnCnSxmwHcszszazBoZn2YRg293bxadGLBUMffRYo
919	payment	1693	1693	534	1	1	31	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYcWB4F7ejSeyZVvgiseo8zKSWCg1yXHD2mpR5r324v83bUZRE5
920	payment	1693	1693	570	1	1	32	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYSnbE5ioN4Tq8rvAGK6X5z4a6vFXcBiYMJo32nt4Z2ttDV24Rj
921	payment	1693	1693	894	1	1	33	173558610075	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJHJgnESQFv137BJmF93ZWtxEBXDjDL7Y6CrPsSdgonmKpnCib
922	payment	1693	1693	106	1	1	34	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa3wA33hSPRc8UqaoSxAnHbi9cro8HGXPRbLQ4GxkmEm1cpwtWT
923	payment	1693	1693	146	1	1	35	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZnj3isVaCNJ7289q6R8mSSg831R3RM71PPSN25mmKvsKd5pGNr
924	payment	1693	1693	251	1	1	36	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYtX6aQwLUUNFVKJZM78fhLVYr9LW2oKBYouhkY6jkEZckBzH9p
925	payment	1693	1693	89	1	1	37	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ6eU1PdYPxyobC7aSDNpYbhEjasLVxS2YxoH5RX9sKkGDCdnXW
926	payment	1693	1693	29	1	1	38	3959646441	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhfuoAXd92xBVEhbGeYtMpm4Pqu5iKNPd8bhVjsdsfVJDrNrih
927	payment	1693	1693	84	1	1	39	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYdG4Vuxi3kKtrtW4xWVBE1HkkhzaMzDwytjCkGZigdNjw9Ywaj
854	payment	1397	1397	1678	1	1	781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RY9LLkbWZ6HuUu2NYKaZrSNovbPA2Y8yh2gvCcjx1VGwxWZr
856	payment	1397	1397	1678	1	1	783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19LdSQ6FefFWegamXtVKSdVpix5NR5UAxnnjSu2DCj1xMPoRy
857	payment	1397	1397	1678	1	1	784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhzhyVqq1TURUW4UupAHRnMumAAgcrtDpYrr5QDudRo73dDyg
858	payment	1397	1397	1678	1	1	785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTdoUg6iicunDbZGMzrfuEbroH5YycWxXwsdBL6eqetMLLTak
859	payment	1397	1397	1678	1	1	786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUioHJtfXyiFZ3UpTHBguXAMrvg67eg9t5q7a4Yp6rtwR5ENrv
860	payment	1397	1397	1678	1	1	787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5StZPcSfiHM2UG5PgEjcPcYx5gDbctRGT94A975cNRYzarjuh
861	payment	1397	1397	1678	1	1	788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSc3T12AaM21XMWR9gtpMgJ294XTBSQdWtPQchNtG4smxNS8tw
862	payment	1397	1397	1678	1	1	789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3VPCt5McaoJozGfG6bDWK9sg5Pyx87gXN6jp2nX2NmW5LNCH
865	payment	1397	1397	1678	1	1	792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WLRuS7WaAPaQC7DLhLfp3WZ6H3sL1c8GC74qV8ZzduS4Ft6L
867	payment	1397	1397	1678	1	1	794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4aEGgiX5oB4CNZpFwpewsTFs2vzLeqJ58SKd125m1AM8HEBu3
869	payment	1397	1397	1678	1	1	796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZkUXqH2XZr7eTXkxk6nDpgbUFC5mSqTypB7q1bRe7Rk9zN7z
871	payment	1397	1397	1678	1	1	798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7LgdiSc6SCxTMTHpvwLCkEcg2yegp4HJKCo7sUTewfptAWHB
875	payment	1397	1397	1678	1	1	802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XkzrUfGNQp57NnFdLEx33RXXZwM5VGFfrVis9WQEuA9kWQ65
876	payment	1397	1397	1678	1	1	803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacvWNdCAgcxDWjnqZSRcv3URbHba9w8nAihxZCr73zDSaYz9u
880	payment	1397	1397	1678	1	1	807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGPETvoPeDSbZsdamaVcWTFUCsWfJESosSEUbd2NNMKMUtHPw
886	payment	1397	1397	1678	1	1	813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSLj5hQHREeh3SdZR1oqX2wrZq9RatcMCjBKKQ18BvSjqmVXv
866	payment	1397	1397	1678	1	1	793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuSekXb24AMqPR2CHmWPX6bfFetQMwef98jNTpiaB4SBBaDbN
868	payment	1397	1397	1678	1	1	795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76bnPcoZ3DcEKA2TXqQWr1MMdC7vW4xS7fH7gMsr8Jm7Dqgqy
872	payment	1397	1397	1678	1	1	799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJ7E8pfASP4c6EkmDmT7WEYSSt7LSM9MvyAnXQdEMpEEaNs51
873	payment	1397	1397	1678	1	1	800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVzHqdH2L7Z19XoCWfYet7P9qktxuw1x3rkk4LHLVCvMpuRXM
879	payment	1397	1397	1678	1	1	806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQXVnu6cKEYxUu5wSqe5Q14gkrtdztRgMDYFFmySJDLrVy8Go
882	payment	1397	1397	1678	1	1	809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoPdbjqp13jDfKqYWdmDD2GdjnfXQimyzrQiTjNidiUMpwbqS
884	payment	1397	1397	1678	1	1	811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgbGbGLP5iHe4nRYZLp4PyKmpXohwYthwpdetN9LF58gHbENo
885	payment	1397	1397	1678	1	1	812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDXo6XkpjaLufDCjRVN9Wc7YCEaYRMyJfW6cDGaHdJQZG2x1kh
887	payment	1397	1397	1678	1	1	814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJ4iVU1xYqEqUJZ7kUYVNXMQA4dyXzmnxmNzJdXeanmspNcix
888	payment	1397	1397	1678	1	1	815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbPWxhr1TBZA6xs2DgN4oq7HNaxsuoXNGKwrsEuiM7j9f3XuP
889	payment	1397	1397	1678	1	1	816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxef6JnLXtXqoY9G1ynSHmFS1ztYtyE7sunaxsAhw84mY4aqD
890	payment	1397	1397	1678	1	1	817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6A1W7vmRyaG5eMqWTRrLxETvPJNeQHX6NZ35hsCiQbGRXgvyF
893	payment	1693	1693	309	1	1	7	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZz1ZkLqDf676C4bhDqd2fW72DgnJbFLtTaBVY43WY11DjQkDz6
894	payment	1693	1693	551	1	1	8	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZdKtSZtEhQMm1Buc5vdrMAszVcPnkLLLjW1WKMomVSgtUjfvsx
895	payment	1693	1693	217	1	1	9	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZLLz6gC9dYCJ1rafcDQ3xSptmNQkYfiZDDRmjtA3eHZtPH5WS7
896	payment	1693	1693	1030	1	1	10	509630166225	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmftLTAgmZyuiFT6rspx7PDw4gJEuTBhYSbJZJXL7xfCw4abaf
897	payment	1693	1693	205	1	1	11	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZTuZnZnZNpXTnFsiA6DUF3p5itv8um6TGGa7ja9Ue6N6gwh3WR
898	payment	1693	1693	138	1	1	12	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAzaEdVm6HS7PaMHpPKYQ8VvBcxvLcoNcJxQdKS4Rc7TPS4U1n
899	payment	1693	1693	275	1	1	13	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZpdA5TuCG9svQgTWo8NNLV2mfuP8H5JrSkVB1s7iMsLy7h5MaB
900	payment	1693	1693	225	1	1	14	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYijDWgEtzTYtL4tbSGs53TDaXom5YPFG2fW5d6TGAkBL3u4yaz
901	payment	1397	1397	1678	1	1	819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7tgPv3Dd2f1u4DQ1vRsaLvD3pi1z9CghP2xnizNYCqZujmuT
928	payment	1693	1693	92	1	1	40	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYWfyp3xY8bYYmCANfyBwNFgacEu19YSvDzu6dyNogfoxdi6feo
929	payment	1693	1693	395	1	1	41	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZEc6vSjipuyXoFxBWJnpp169W7XmDQTbkm9WiBvgmva7auyNXV
930	payment	1693	1693	587	1	1	42	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYRxZ9ATMuMPysKjQoxarYeb7jXAzdsJnBqM1jU6Yet1xde66eW
931	payment	1693	1693	611	1	1	43	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZt1bndmDWCVrJ9M92476cmAKDio9XhMH71WUQ6T8NBWkM7sPsW
932	payment	1693	1693	438	1	1	44	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZQsVL1j8b424BVXnj9ZGuM8S5krocR7PHzqRYee2dPz8vrLVSg
933	payment	1693	1693	710	1	1	45	2828318886	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa8EgeGSUn5AN9Rt9QGXgUtZhLzAZDacn3ad2BDy1YrZrxfQhbz
934	payment	1693	1693	399	1	1	46	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaJBzUVgfjLVZX4DMfhoaHyUz4NUc8uFNNrS3xbaDQeWsvRoRiP
935	payment	1693	1693	322	1	1	47	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ4yYX4qa4Pio1hr5pGQG5zgNNhjU5WWfKxycKHPFcFkuoDVY2d
936	payment	1397	1397	1678	1	1	820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMnNgm2wQ8NucnjguJETszMFqH1DNtpZKqToWQUtJGXXHF4fJ
937	payment	1397	1397	1678	1	1	821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRU2YpVDMkzEmFLtCySfvacZHmtgxFVYRFiRMDpXrE4vFBCPB
938	payment	1693	1693	910	1	1	48	284393193579	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYx78fdpQAmyUKkRgxboiEjiBvqpfuvM1jsKeDAFuUextmHqoAZ
939	payment	1397	1397	1678	1	1	822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQK5HURJ5ycs7eUsfUrfu1jPAuYMeQeWVsSE2Z7oGkaNGHaJoy
940	payment	1693	1693	105	1	1	49	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZgQqCenJAMA2ZPkWo6ooQDWyYjGmVFwnKZ9tzNvXKakhrBADVp
941	payment	1693	1693	500	1	1	50	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZbcHvfMxBdrK7sh9J9uXa94xqatrtMYCdZXLVtd7dVZZtVM3Cm
942	payment	1693	1693	721	1	1	51	1131327550	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJ5pT48qWoL5YrvG47WXJ7zu7WPbNVuWDNB33C1o39RZ9UTv2S
943	payment	1693	1693	560	1	1	52	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYfxhbEor8cBiX5NNptbhFArampQF8jqFfBdbeaizrp77V9Kk5Q
944	payment	1693	1693	392	1	1	53	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhWoWKnNRikn2o8WviUnGMTbjj6zodp6KmcLrFVVcisfVgdVkF
945	payment	1693	1693	194	1	1	54	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ97PgY5qeGvUynGQ6zkGyvHTGsExSSBB7HYgjiQgfRzRhCAnT5
946	payment	1693	1693	678	1	1	55	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmp1v88oTLtx6KXzoroUEEzxp3NhN3ngkfHFZAGA5NW3mEAVM7
947	payment	1693	1693	320	1	1	56	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaESos74v47t7gwBbFJw9AjoZeXKzNPTwVNGzjZQt76UptPpJqG
948	payment	1693	1693	295	1	1	57	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZCJ8vZGcsSpLhN5qzYR7Ui3xsBtdb3iSTCo9JNf75HXSjAA8Ed
949	payment	1693	1693	78	1	1	58	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZQomq6pJComPqHjn18bPuPShx4CmxmUfRJtvuVbbhQx9jxVseD
950	payment	1693	1693	54	1	1	59	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZaj3QapoFeM3bHwMVFfPgxf7QyoApeMxTXLJm2W3YUEL7ceXed
951	payment	1693	1693	594	1	1	60	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZDQvPsJZa1XfuhFb2YeTdkLRuAeLruQy3Nad8QC48TfmxCJAVw
952	payment	1693	1693	37	1	1	61	36953683265	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ3wDhLzBtU3eyoruYZo6EEfs1ZGuRwvUKnjosNpXKpHzmjUrP9
953	payment	1693	1693	1150	1	1	62	343857628251	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYqjaf6DFuerxMjp9jX4qcL75xpy88oswkTG7uaubdFo19aGyod
954	payment	1693	1693	163	1	1	63	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZwyhbhxvbPNNEDHKQFxzaFMtWGFEGWuXe8aN8e13cNzkVVSqgb
955	payment	1397	1397	1678	1	1	823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZytm9NZHQnVyhv6VsizsEb7FoALWXuiLWCrGpGxic4oNx5Vc
956	payment	1693	1693	452	1	1	64	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZXHDrjo2PzA2bcavq4EaoG1fkWdYxwoUvyURBDVACE4CbzQUpQ
957	payment	1693	1693	739	1	1	65	5656637772	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJRz6agRR7zF8r5VhLNSwticpDQQudBH3Z1ARbDy7wDTGjLigq
958	payment	1693	1693	893	1	1	66	173558610075	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiYx59U6Xs4KAbJgf18ZuWmcTCBCdYxdynpErVDqPV3iF3oNZi
959	payment	1693	1693	150	1	1	67	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYYE5bjgizjRupd7G7QFKeGk3iX5yCNqrwSYLdupBAwXMzky2b1
960	payment	1693	1693	252	1	1	68	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmpVghJ44VAmVu89W1XLtQD2Qt7NwEapczXkpr85ahdu7Gk83N
961	payment	1693	1693	450	1	1	69	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa651C3TNhy4PKTggfJpnZRv4AXVeNMDz4AjicosNFRM8X8inQo
962	payment	1693	1693	620	1	1	70	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZskqfa9hQXkAargwV8AHW9wk4iuHo1nrEX1BmDR1yvDHm1nkvy
963	payment	1693	1693	245	1	1	71	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJNUpZeSzAYuDDfYdQnFhC8DmqBLzP71JNZfeApBje2agWB5R7
964	payment	1693	1693	421	1	1	72	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaDJ6oxJJEXnrpvTKSecWXgyiB4vwYDVMPNSBC3k9nRCY1Ym9mp
965	payment	1693	1693	520	1	1	73	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZWc9fAGdzjorrdmqxNypMzLdfgjn2RDEETbUpwP8hgNTmiX5Tc
966	payment	1693	1693	622	1	1	74	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhNgweQZrMwn7G5NDPDugSYRN4n2x1ppbs5gk1nJGfVH2GUrDX
967	payment	1693	1693	652	1	1	75	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZXswS6X3qT48S6xPCuTQ7sERAZ3HQmA6ZjqUK2LKoyDsFFGQS1
968	payment	1693	1693	1276	1	1	76	958189855230	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaADceDeuoTD9Dt5ZrWG9rfXRVSBi1c4oYr99BMkxyEfnUZ3a28
969	payment	1693	1693	108	1	1	77	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiuhwqowno995tDWqQdkwWBnp9M1X3QGcvKEQ7DkDjJFu7YNqW
970	payment	1693	1693	180	1	1	78	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZdBcjHb5u5DU46fb7oYZntU1Jp9EYmMAXkyQP5bEDFqu7e4UwE
971	payment	1397	1397	1678	1	1	824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3wpMnuge7JN9mbfbASsYspUdPWetXrpLSVvbqC3KuZ4po7bR
972	payment	1693	1693	353	1	1	79	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaL1o7itmqHyxkV9tWJKwMU6TmA8yKGBbFF8efbfN5DifpBrU3f
973	payment	1693	1693	390	1	1	80	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZVaCTxLhMh1YCm1nEvQzC1XcEv3hYUMRFsfSuox4PSGeqaL5MC
974	payment	1397	1397	1678	1	1	825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBYdLrg2reHpXj1aqG37ojZaMY5ow8CuCtNsNsVgBgW4fw2Pc
975	payment	1397	1397	1678	1	1	826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWywUVDB9we89H7xN1CeqcCNRkjPh498e2NtKoYxemqry9RAY3
976	payment	1397	1397	1678	1	1	827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBuZ26kwrhDcRyP7CiCReMWnLVmBU17opkaMM745w1CDhCA6s
977	payment	1397	1397	1678	1	1	828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPea6rpzBMDgtVTEYjdLbXR9rGFHzGvVp2DDRftrDFxpVo6nf
978	payment	1397	1397	1678	1	1	829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6njB6qoAUT8BrRVMSrbeWFaYHeQMbPYT5usLc1sLfYSadLpr
979	payment	1397	1397	1678	1	1	830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZM3hKTiGr9XaLzp8USovn7nYasFvNkiRVwvtMv1jMdz2JhEzu
980	payment	1397	1397	1678	1	1	831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnyyRygzEDfLY18iqdWYzkffWwVqeeuRxsY1ASvsrMNDvJeLC
981	payment	1397	1397	1678	1	1	832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWA9xhLowWFQQvXSzZHe4uUhL5GJJsxPTGGPGdpjeEw3ec37A
982	payment	1397	1397	1678	1	1	833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcN1Jrew96mmRqbf1d5JE7DKTH2fmgDzcGoZGN4qwvvaYjsRV
983	payment	1397	1397	1678	1	1	834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRR4UKA9Bhjc68vnGpatUWDeSSFWTAyDHZJBWJXCAddtS9856
984	payment	1397	1397	1678	1	1	835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRfZDSJSboz1gmNfEt76r1D5DjqPVE5QULYeFczyujkXu9kxm
985	payment	1397	1397	1678	1	1	836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkV6i9arWDKsBv7RNWkp5vWMiYWDypES6vW2ycDZmG5VQqeVQX
986	payment	1397	1397	1678	1	1	837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9JNjTksF8buAWM7Z6NKot8gW8pU7i12uneQWV5CYdiUNwvMH
987	payment	1397	1397	1678	1	1	838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTnJhDJgDg95ZSUFoWCZ8TRSbiXb9Cv61EBk3f6hWQ7X7Yvhp
988	payment	1397	1397	1678	1	1	839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTySKsA7JFbwbScnBag7j65qmeTm546i7dhEZFjafmCh2ueya6
989	payment	1397	1397	1678	1	1	840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwRMySCkVXcAoiQYrqqvGZHhsHrSfHRYaX4FcNU41D3S4ppCy
990	payment	1397	1397	1678	1	1	841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSuZFqvWy8DhVjgiaEb9ErBHKG8ZF5unsHvF3xmeMEoCtLoQo
991	payment	1397	1397	1678	1	1	842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoopfzhK7xadWn5dJ3cdcnL6WubyE3p32fPWrmTSZDa4EaDRK
992	payment	1693	1693	569	1	1	81	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYiziXroTM8xSfwW2oVDHaq9VsDkekjoryy5Gi6zP3juMsj9gGh
993	payment	1693	1693	745	1	1	82	1131327550	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa3DGuLEx8PqueRxfecvsr5spJpkRFxWYDgYHJczymqfD6ib9ia
994	payment	1693	1693	41	1	1	83	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYj486qBz1vUirrqfP5WV8gP58a4VfpQPojd4eENsheC3S6EBTe
995	payment	1693	1693	308	1	1	84	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYzMzAARrpFjL6sQFXBCFuxNbNrM1zty1KcmziLuqZdvoKS5Yci
996	payment	1693	1693	878	1	1	85	114859821300	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZmfDWxHyWEgnzqnJcvPRvLp11ND7U1R45RxY7JTFzRha9kgwqb
997	payment	1693	1693	186	1	1	86	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZHecnpqw9UXYBCQtkJRfZAc8VtkTN9yG1kaiEj7XHGrKQ6fwsA
998	payment	1397	1397	1678	1	1	843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qeokzB9NMpfqPq7xEx8tE3axt4NqCfj5N7gYxyTh7sTtUNDQ
999	payment	1397	1397	1678	1	1	844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVULdHXmKxMdN2yjVYziJyLVhQGaDwRvhwu5Puje8vhwU2Zfr
1000	payment	1693	1693	49	1	1	87	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa9d93AsJQ22iFRJU1q2cijWxiBSsuze7XUa2ffnYpL6N3TEMnT
1001	payment	1693	1693	112	1	1	88	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYq1ExBw43hLZTeV7Zim3RqHGdVLh8Zp7kR6QuMA2xy4AnCovcR
1002	payment	1693	1693	383	1	1	89	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYt48UfcG6KHGB6N1cZiFg2aXjWrbfYfLbTRwNshe8shhnDdXYT
1003	payment	1693	1693	663	1	1	90	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZEzQhuWbMEYXw9MxkFkJcy6SrqkTVuat2ko6aq6svnEnudaKbn
1004	payment	1693	1693	499	1	1	91	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZbmchK7NCFNVkdfVaC6Ptwrvx4r3hMUgR92TbatdcocUuAUMPS
1005	payment	1693	1693	35	1	1	92	10860744526	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaA8CX6Urm7tovRJVL2w5FfphUj21tn8koSiJZcUT3D7ytU9mCr
1006	payment	1693	1693	453	1	1	93	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZgNZHB9rwUuxBQ7LJPTdjHF7a2oP8CVdCpCzXmsWjM8xzuFS3Y
1007	payment	1693	1693	82	1	1	94	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYrPfKHotsyfqni7a7Nd4W7mjTGBo8Y4yMmMbmvQcpeDnoc8SiR
1008	payment	1397	1397	1678	1	1	845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWGTjUyqnoiA5f1PNgLaNHqtvuKT6EwQP21NSgALjpBUqtdRe
1009	payment	1693	1693	201	1	1	95	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaFjdesUBxrpUEdEF2uh2f2Qd3FTTJBaxxGqcfBQHd6ohJ5aQ67
1010	payment	1693	1693	103	1	1	96	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYYhE6BZSizS5UH4nohuamg6rMUpEu6fKq9rHVPMNHfGTTS1ENe
1011	payment	1693	1693	261	1	1	97	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa9PghrnGHza5f3NBbWYfb2pqH2qzQo81w9UeWGW4wpXa4NFg8X
1012	payment	1693	1693	361	1	1	98	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYgBNUvzzzqaAqmFyeoFf2RvgJg9Rq7BnDdRPNj3W1Ah9vKKvBa
1013	payment	1693	1693	680	1	1	99	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZuBmRcSjebVgjd7uRgRuLpuBAaxgNkxZJ67BwDYmgqA1GGfmVp
1014	payment	1693	1693	63	1	1	100	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaCbwSd9pjZjwPdty7uC4uDRugkHLz2osvqr1zCQqkcbDvAVAmk
1015	payment	1693	1693	377	1	1	101	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYm3X1aVxfuHJPA6BQ1NUy7kbSXSTBXyVQhVz3nxpuxe1rEm2La
1016	payment	1693	1693	266	1	1	102	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYrdsuupb4tjhuVGTXoGguevBDJx6RPy5RWXTpY7CnfcJCGmB1F
1017	payment	1397	1397	1678	1	1	846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvkt8CP8ZfsRz23XyrVaFtavUGdQLHQ9XTsh4HBYEewuX7hX9
1018	payment	1693	1693	600	1	1	103	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaAb9JEzqjgmzZo1wkJjotMQG6yqAgbHDzTEeFoSveg3VFyAH7P
1019	payment	1693	1693	691	1	1	104	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZYae4upDjrnYaoSbeCDLTETqdRPc3Cbwpf2iKfUCSANncYEqGP
1020	payment	1693	1693	352	1	1	105	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYQf6JRmTxWahKwwgiBEL7HcXmAqAN3HfPYudtNzLswYLuAXK7u
1021	payment	1693	1693	601	1	1	106	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZwkR2wb73CvZRbC6PWQGQ5uBnjJ6cmzNmB71Cp7mmr7bqgvsin
1022	payment	1693	1693	504	1	1	107	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYh7gbS4T73MW9Nk8VzogRQT5GmeYNCyziJyBQRHUxUVULqiavJ
1023	payment	1693	1693	658	1	1	108	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZuCXAyMC2k9tajmy3ipVxEGga1tiBgKdaDFBcpJhNv9E72xQcs
1024	payment	1693	1693	6	1	1	109	18416881266	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYdLznMum8NSJKxJPEiLD9PnP9g7mU1B5tZakrBEsWiPrqLgVLE
1025	payment	1693	1693	391	1	1	110	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZ3kg54NCVcoXQZuLRd1W3yTMkqTjGbMLqWJkR9LCnKPATnLeQA
1026	payment	1693	1693	660	1	1	111	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYTJoYTQ2B1hohvSNksBXAXEK5smR79SvMoKei5UEq8vqQ86Gnu
1032	payment	1397	1397	1678	1	1	849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfm1QbaFisewPXZ2dchnomVvcHZpsxs5CUuVqMhUAN7Yb8HLUH
1036	payment	1397	1397	1678	1	1	853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZ3SnSouo6isGAjdQpaqEnFxWhK9URCih9G5bWJBwkjuReT8x
1038	payment	1397	1397	1678	1	1	855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Xbgv1vLkvC4QHocrWYnumy6Gr1fAH7YS3Bq3o5onBCMgMTav
1039	payment	1397	1397	1678	1	1	856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFFp1S4DVJKwFBzYa7LERkQNS6KmegcsWc6NXryrAKFEEeaiq
1040	payment	1397	1397	1678	1	1	857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmstVYaSyqMjxzEhXCgZAzQGxeX9qhhGzGFydmh93TXaWTDYA
1042	payment	1397	1397	1678	1	1	859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jvnApWgebRmWf7nLERKvy6SnRo8VjSWVrbauPfeGvZc5J3ss
1043	payment	1397	1397	1678	1	1	860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iPrzmCJFRLkmKcKSNkBjEeBp5kye6aYXaQLVkBvrUp9GzRrq
1053	payment	1397	1397	1678	1	1	869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gsMkXJQVm7Za2xQPbJ4nftMaE6aTRMYiiBuuX5RJEhgC8TbE
1054	payment	1397	1397	1678	1	1	870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFubU6vVXekYG1MXBTrieVp4hn5p77w5LUeJUEeKwDwxdPMhX
1055	payment	1397	1397	1678	1	1	871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTq6ggf5MjKoVLH5QcBgN9fZAXD9BXxZmaPEanBzomZb8z7UT
1058	payment	1397	1397	1678	1	1	874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqA1PqLeowhAjQnWFXr2d4CQw2oDUNAsusGtJteEL7WQJWyhD
1064	payment	1397	1397	1678	1	1	880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBvvNfsFA2RNUSRvpKXTSEddnaBJACxst5vHNa5dByziK6WHJ
1065	payment	1397	1397	1678	1	1	881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1LT6X8LfuXvaNJ273NyqkfTRW1KmLuHzGeUGimykQKrwF5oU
1069	payment	1397	1397	1678	1	1	885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2H3tkeda9pqh9jGrRJpguGXDWpBnqqU9TxAzmEt9X6mNXcgU
1071	payment	1397	1397	1678	1	1	887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoc55TRGprEjfAPztpHjMkVAZME3iwARVH31AUHCGWodtD1VY5
1027	payment	1397	1397	1678	1	1	847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptSZAoox67AhMHSJy9krH8spfi2VduSWvRzR83NfZBTVizFK6
1028	payment	1693	1693	193	1	1	112	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa5moi5j5fhmKGqS6WxqdMoxXsYwmhdPhystCjWBXFir94BJeYy
1029	payment	1693	1693	593	1	1	113	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZ7juMNG4FEwReyFvEkmxAQbE2rZn4zBuYQJxhbnFiqqMkALRtK
1030	payment	1693	1693	653	1	1	114	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZLkoG5YX5gVyJUBQZgk96SNpBdmG1UF8jokEFjFfRRaqY2acVb
1031	payment	1397	1397	1678	1	1	848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjDkT79Pm7gqmGFF2Vf14ESBSxQDFNB7tnEs4tEKQz8iN3bWP
1034	payment	1397	1397	1678	1	1	851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswWiTx5VKSWc5mjcGVigpgNsHj6qFGKHe8K5WLSfbaAcmwWwn
1037	payment	1397	1397	1678	1	1	854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZMzWXE16MGYa6Z4HiUjDZud81fYk71WvbpR96VzuSTyqC6TZ
1041	payment	1397	1397	1678	1	1	858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVH1Z8zEtq8sVqb4oYVUJ8Yp2XM6Ko1ELVhbBNiHNqnArNv5VE
1046	payment	1397	1397	1678	1	1	863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1T26ympX2kvZ7fQ1BA1Vy1waLTV9MjoTw5fkNRCGbZ2wbfex
1047	delegation	30	30	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiTTWbT75wW76qFAsxjGzuAUnxwAPkKgmeq6Ro81Cc6GvrTsq
1048	payment	1397	1397	1678	1	1	864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjXJ33ctVm12bcaoPv6TaewLtTYoN6GDc38EFRKV5zfrtRgtx
1049	payment	1397	1397	1678	1	1	865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXz3cMmhGUMmnBPw2sKbfd9p2kCSXfBk3eTibMxMAGqGxNTM7
1051	payment	1397	1397	1678	1	1	867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbMP2sCY2XW54V2GWvqVLFaTZ7L5XdMh8kzWMiykPuQNv95X1
1061	payment	1397	1397	1678	1	1	877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4z9WXqX7cZvb79WF38YJbnTpv5ZP6PZmg96ZpwD9epdXnVMS
1062	payment	1397	1397	1678	1	1	878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhJUxJCECkgpoBDjpu98piNHZZvArvNkRzy4Uxr79qEr5LXbr
1066	payment	1397	1397	1678	1	1	882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaff33qVbeydF1aqyVwdEpjGhBy97vrcNRJFhouc3Zc3ARu8C
1067	payment	1397	1397	1678	1	1	883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMVSB2r2ufFusbpq3UiGSaNVPVi5ehAPAFfdBeTkCsmYCYM24
1068	payment	1397	1397	1678	1	1	884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqd5mG9dL7eTS6WDCPoqWJpRnvS2N9nKV321V2F1pmNTKeWwj
1070	payment	1397	1397	1678	1	1	886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7xABbYS1L3J7jErCBhshxjgLGg41vUh8keGWgw57NpgLuvSh
1075	payment	1397	1397	1678	1	1	891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gSsSV5anqtb8FSp8otT9apbdk9gRudPpa7SCWqe8b5SPN8ZC
1080	payment	1397	1397	1678	1	1	896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBWezfxqjiLM2y8F4yThfzRgK66uzKc719aFqrSgecdwDDLTA
1088	payment	1397	1397	1678	1	1	904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9U2rGMfjAgp9j5TC22boo9a7oLPGYLt677XM9uhPt2UeDJFZ
1033	payment	1397	1397	1678	1	1	850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8LQnXuMMjronVPuWMMM3MahndbrvKPtWNa6L7Z6j6XEGKG8b
1035	payment	1397	1397	1678	1	1	852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUHPNtrN9shnGGiHVaA7SU5j8iDTvxLNMnG37sirSnC14NoW5
1044	payment	1397	1397	1678	1	1	861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5WoTHEZuiFSznjczpK2EYbHzNXEvXz6q3czYCfNaqPbCeGwb
1045	payment	1397	1397	1678	1	1	862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQsUtmzgrpYQVAbGbYPXqABeza1z4uvCgKsx6FFSQUduVtNSs
1050	payment	1397	1397	1678	1	1	866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7UiYToJBrZ6k8WnVUtgEuoPjd2YZMbHa97RgJ7SYnTYyMV7f
1052	payment	1397	1397	1678	1	1	868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUyhtGmvL94tdhasLryBf9NnN5rX4WKvEGxVfu8rpGfuVHxpL
1056	payment	1397	1397	1678	1	1	872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7E5gFiRqu4iEHNS3hAdsW92RLH7TLXShSQvCiCY99hPDjgR3s
1057	payment	1397	1397	1678	1	1	873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvsCZQAjTUTMT1RB5Tw3qfGDbPt3qPKnaRxhVEFyqjoBrfoWk
1059	payment	1397	1397	1678	1	1	875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcNJYZYfsMPY9f8DWMYhmPnU1M2RtxHys6i72GGdGWJquA4Li
1060	payment	1397	1397	1678	1	1	876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMHhLF52pgjX64YHx4m3YazNDTL4Db1CMkuMTidzvRd1YHb6N
1063	payment	1397	1397	1678	1	1	879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s4dJbP8rCENebTd1BqrghCH7AtUNwcUx67rPpKsdXVxvJ4TZ
1072	payment	1397	1397	1678	1	1	888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1yRTYy45fZE2442CSyNsYtBEScip6pw26rBfsdKVioit9j6o
1076	payment	1397	1397	1678	1	1	892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9ReiGR9t2kaFGPhFkCNZDEomEZkLz1bwToYhvqjDut4fsLhS
1077	payment	1397	1397	1678	1	1	893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm5swURYrKY5xFbrkcq74kqr7iLgP5h8miSE2tRvp9WmC1AxA
1079	payment	1397	1397	1678	1	1	895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWPKbkcipRkMCEpYgbwcjh6Ph5qFdgW8hiZhyKTh1cVheQGzm
1084	payment	1397	1397	1678	1	1	900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy9S2qHdfuoZsLMPjZHs37CVSAca4x6GXSuGN82R4ZMKHAQGa
1090	payment	1397	1397	1678	1	1	906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoQm8iUTC5dXjv6Wnf3AGBs92yWjhF1raZXjCHp3uLJwiQkuK
1096	payment	1397	1397	1678	1	1	911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrynbZfohWYNzYvkfCt2rjYtk2wYQ4kXEdSH1GyjF8oG6SZeE
1097	payment	1397	1397	1678	1	1	912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhb1u5oQAgdXpp1U3qxLfwhUWXrTaDaSoFR1H5ymSqW8ZS8v8
1098	payment	1397	1397	1678	1	1	913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEaomNssVbvbmtmHvG4Vcf6ohDmaVWRB2XKJUePcozdaXw3Lr
1099	payment	1397	1397	1678	1	1	914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6qQYgZ2zBpf6AoLp8e27bok9vm7rAWkTNktagqtc2MSY6Law
1073	payment	1397	1397	1678	1	1	889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxZ3zsHwGSXVDMXeKAqtvaMT2tk4gzqwShkv8N5FDiswfH5Ln
1074	payment	1397	1397	1678	1	1	890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjW7Z2SnqYrWE3GeUM2sg7rJtFLGoUWSf63QCLuiWgdSqfCUtX
1078	payment	1397	1397	1678	1	1	894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoGSYbk4nwRf1JFfbc8iymcJ6ie4de5AjbgA4gF6QiCLFVzYf
1081	payment	1397	1397	1678	1	1	897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbi3XvcmZfXJgEjuUnEF7Q4ijCKSabb4TJFPhcBLycMTFXpvj
1082	payment	1397	1397	1678	1	1	898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZsgS3KKSwXUVKMEdcSpzpsRXRXSWXvK3FatkyJxy4VtCJQmq
1083	payment	1397	1397	1678	1	1	899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfGY2iPPHCZzuJ8dBNSwaPE3HfnyxNckw6mHbqZyU1rpfN5MH
1085	payment	1397	1397	1678	1	1	901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrPtKt7oqtjBS6YSFBN6kmHaqBc8HrsKXTovjZvTKf712xAXe
1086	payment	1397	1397	1678	1	1	902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj7wTqUJezMe6VrsDs5sBBUWpykHdCYpaMTjreCqcYZk5LpbG
1087	payment	1397	1397	1678	1	1	903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLteNSxKnikk5MSnkNaWaXSPzeJPs4BewdKy1UbhVfuxcvyWMn
1089	payment	1397	1397	1678	1	1	905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3918Jpa8CuALbQebRz1W2pjuUyNj3h1VFmTg5JaAs3kAVkbXS
1091	payment	1397	1397	1678	1	1	907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaYt58NeyaSCpuergRwxcsXXgFr2QAfnRKDxgNtXQ371B6osA
1092	payment	1397	1397	1678	1	1	908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2f72nXK9cLakGJ4QLAFUYpTQHLZfHrtjZNvgwHxf6iceAznY
1093	payment	1397	1397	1678	1	1	909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjcb3N7kMtYkrnsV74kD8B6P2QCbwcnZH6cHWfcMT8LXgj7Ue
1094	payment	1397	1397	1678	1	1	910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkQkiGwZeykYamkscNFZvqzPXRTByp8D4WzK7PAAtW8h3d2Fc
1095	delegation	1733	1733	1517	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BFzXEtEXQHMVBvw58iwAp2CyrBdApq14wk4wzwPqMZW4ApaF
1100	payment	1397	1397	1678	1	1	915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9DFBNXBr9aEeEDHwTQMase5mf5zBQLtfo3PGxgf5LJHX8eZN
1101	payment	1397	1397	1678	1	1	916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4oFdvTU5Q3P7pfHbAk6VkbY6m36DKaKnzhkXRV4PBSMXZSCd
1102	payment	1397	1397	1678	1	1	917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQtjL1n4t4SE2XsHQBpAVGsYRuPuRWiAiDK5L4A4n149tT3b3
1103	payment	1397	1397	1678	1	1	918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWup7aByhBDZi26RD27XPGh27QMy4hbz4ojWzrdGLNwPniujw
1104	payment	1397	1397	1678	1	1	919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJhTjPhVrB2MuHDTx3V5dTW87gEyz9Fr63L1STtArkaAceYjK
1105	payment	1397	1397	1678	1	1	920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SFSknTBw51rXgCv1ifegLjFL2P5NNCvkZ9FmXyErEEhyYSd4
1106	payment	1397	1397	1678	1	1	921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLEN8xtfbFymdXp7NF96B8genfVD6fhBSDva7BCnGeq6oZpYU
1107	payment	1397	1397	1678	1	1	922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81TSQCuWVLPxJuKp1fSZmaEBEb2xoArYmWTGQJyfVUiqWfCZU
1108	payment	1397	1397	1678	1	1	923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6kBxv7zyCeDT2B2HHQRVEHLYKamyctGAwTZzFVtjAeTcHWrM
1109	payment	1397	1397	1678	1	1	924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkMDxFV5TVspPLHzgxf2KPHtArnfAwkomL6Ze8TR688T7TEmG
1110	payment	1397	1397	1678	1	1	925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJY1WyMaZbCrMN21KU8Z7epJFQ6SkKLMZeKUwKn2bVegyACaK
1111	payment	1397	1397	1678	1	1	926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkG1Jvowkyd57KXHMWp5GNVS5UA34eSGov6rsMkoRL9h6DnMT
1112	payment	1397	1397	1678	1	1	927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiedxFNncaxS5vPBXM5ypbA9krr5fay3q7ipstnVEJUJC9k4cq
1113	payment	1397	1397	1678	1	1	928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnUUxyuU2sFgQBoCAA1RMiEtpYjo8cLgqRNteRViNQRi1QVL1
1114	payment	1397	1397	1678	1	1	929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRaYCWAc8ZHziucDp9nkSrqv5YadwbpQyn62LFqjLtkcy6s6o
1115	payment	1397	1397	1678	1	1	930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wi42ENFvihR39s1H1UmRr4WuVeMj4TyVchBGvhd4Rs79bnXq
1116	payment	1397	1397	1678	1	1	931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDaYrq7DSkCZuwWPfZB63XU6DToSCYwv9VR4ydn42h5xpT4nV
1117	payment	1397	1397	1678	1	1	932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRtUeBEqEaJTrU72KZNp7z4NJYkx4xaFe4fpwywBKs5tAzPSa
1118	payment	1397	1397	1678	1	1	933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2RWvqDQAm4dS9cSNRbPZkin8bC3hQTLQx1wHMHX1S8FMAqnK
1119	payment	1397	1397	1678	1	1	934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCQAeA8kiCpZidtb1So3ATVwTA73G1HxvVBBrvQi4kSD38b6m
1120	payment	1397	1397	1678	1	1	935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5K3CacZKjJAYgkRBe1MR1ginQt3JVpesyaji5HRNPEwSdeuD
1121	payment	1397	1397	1678	1	1	936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTetsMP6GLNzFrvSVyeYLyiZHybAPoYvGZZHG3EGkwPo3SSntR
1122	payment	1397	1397	1678	1	1	937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6PqGT7tdvxeq7QpHeuAN841fSYWSpLniXyMibQUHwzFCVbNh
1123	payment	1397	1397	1678	1	1	938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtv9ThcPfBXcmvJ1ANgzYLpmJzG8krL6vS9N4LbKBm2haDbxt
1126	payment	1397	1397	1678	1	1	941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqmvkQwabHae5HgcZBiJi9om8CGpC3E5JZY9e2x23dLvpzjLE
1135	payment	1397	1397	1678	1	1	950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKHWBiF8Hw5EqM3DsCdTpLio19VDZDunK1Rso27ZZBvdG7S45
1138	payment	1397	1397	1678	1	1	953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw42VL6HB7tkkSytJcRTfqMbVAEi5FhibteStN3s1WV7bchu6R
1141	payment	1397	1397	1678	1	1	956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYKkyJgbT658S6DoddzyqAgf1qQ1Uzpz12X4b37hHnsYHnxqw
1142	payment	1397	1397	1678	1	1	957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUL34kyjyjksCtxFU4hLTTe3YByL6ph1QpXt8fLccU8pA2i1K4
1148	payment	1397	1397	1678	1	1	963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvvaJrFcSgYLktj7JLzmSHm4H3icHg67P5CBTrJzd3B1rHXaj
1149	payment	1397	1397	1678	1	1	964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozRHXfdZkhZm2kBi13ykhMuzW5duejbCp7Bzbzg7UvqQuxkKJ
1150	payment	1397	1397	1678	1	1	965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbTCa7hka4sDSmN7MMW6fgr5tuF7YtU5ytM6zRqwxrteRpe8g
1151	payment	1397	1397	1678	1	1	966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDsVMMo6rZST7Cpvdb2L45DvuQ8LjwgUqmvyu7XaK5xnoJ17d
1160	payment	1397	1397	1678	1	1	975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuSCAAbJxoZPMJwXZNxkyr25ZtEuNfhwQyJzxc95Lt6qMhuje
1165	payment	1397	1397	1678	1	1	980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Zht25VQXs1FeKo4WZg9ySM9oytE8dQXFRUT8NoFMuZjTSTgF
1167	payment	1397	1397	1678	1	1	982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPgRxkU2syMNc4wKEQA3F9jpo4KenumyZQbNbc1wUwWiPrZtD
1168	payment	1397	1397	1678	1	1	983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7QzXEQK3sbBSzM6Nff6XeHa6Zp84ppY99oFA7ba53y5L6FtL
1170	payment	1397	1397	1678	1	1	985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wdrZvkTRcc5W5a2r24RtkSPGsGepKAziffxiwPF4A1862GB8
1171	payment	1397	1397	1678	1	1	986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v2LZqVFaxM7zrf2AdD1zEp8NSCxVPj3bX5hYBLTwHJJyLgV5
1172	payment	1397	1397	1678	1	1	987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaf7WA7qKF9M2nSRF34ZpyAzC7pgyDmRUNpqqh6fEpcfNFzrG
1175	payment	1397	1397	1678	1	1	990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDGJ2Qtb8eLVE9NK5fuwutGgZzazV7ASkkhMhfDB4DfTF5EdJ
1176	payment	1693	1693	312	1	1	115	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZun4C6kvYmBnxf26cpBCP6R99KM7z6MLTiDsBMCWd1TK9WyTin
1178	payment	1397	1397	1678	1	1	992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqxidjqBoV8iPn4hWsxLHeLfFqkeLxbsJs1QwwEdaXVMhpLEw
1179	payment	1397	1397	1678	1	1	993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiztr3TJjGVByhE2XgwZGw1YJ1HWDSEtWKDaAih9cN6JNpaTE4
1180	payment	1397	1397	1678	1	1	994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJDjWhNRFsoLQEK4iSicYfHycXZo2cHn5Ni9eTWiZtYP6gXj2
1181	payment	1397	1397	1678	1	1	995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7whRwp3x9u9MxBMTYkTsVe6gJpuqzfjWerboEvLbavXGV7sc
1187	payment	1397	1397	1678	1	1	1000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7My2QspHJ8ijHgzJn1AWeMvVQYgykJuXCAoZorEb5k5jPya3N
1188	payment	1397	1397	1678	1	1	1001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1BtxE83eLiggvjsHMvmAfHaYNhcxPmUQZUSofBQWHaB9cojq
1189	payment	1397	1397	1678	1	1	1002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZndFraC6HrehTKHzzQjtQh5FUXd3YJw2ne2y9KNj5k9sAyu6x2
1190	payment	563	563	1740	1	1	1	2158000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGS7yQnL91gW9io9xc7jXw4MdUJBsMKugp4v7UgCjdvvh2jM4j
1192	payment	1397	1397	1678	1	1	1004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjnXSBQFNSnbJ38aiQXBqNFVLfkfQzuPQM6Paxxm62CJHbXw3
1195	payment	1397	1397	1678	1	1	1007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKqzndjBYWtDrd2R3wjJz4LaxhRiJGeEJB9mqPJUb6pRFM9VX
1201	payment	1397	1397	1678	1	1	1013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoSSyPTjn5YhdaG32hxpeFKGE2ZE82L9jEqWWL5zjYPHAHS1q
1202	payment	1397	1397	1678	1	1	1014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQwrv3MftyRE6ecJwS56XUg5Etjx4x3mkEP9cLHB3AXhfTpxj
1203	payment	1740	1740	1748	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6F9NLD7pDHzACaocQAw7ibXAuNfAPPjYhkRjEx5F42phRa5Q
1207	payment	1397	1397	1678	1	1	1018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWFDi6oCkVEGcewCMkGRhic8HV6wHxDrHWHmddWddaaMrkYop
1209	payment	1397	1397	1678	1	1	1020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUapdv7QtFE4qezPgv4SJq3CXTpsDM3ncATXyAtfpX5BsoBMex
1213	payment	1397	1397	1678	1	1	1024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxe1SMfJPSBqd9xq3oNTfUL9aRovNSeb2SiD64xVnx4aJAwyw
1223	payment	1397	1397	1678	1	1	1034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJhd3SJMfmeHN1pNCXH6CoPeVYnm5ZT2tASQeE6F2AGMdw8eV
1224	payment	1397	1397	1678	1	1	1035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTo6XRfU9bPe1hfDyDJcfYfK3K8BcAmZbeqHB9KoZDsT3YaHQi
1225	payment	1397	1397	1678	1	1	1036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbz2dnXTrPiFfW69tkPAa86SnJVfCNU82qhuFvuMFLbPUMM2P
1124	payment	1397	1397	1678	1	1	939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRk3CvUPchu36uuCFbJ2MghFyeJvZ8xkobUrMYKoN5YLRpTNLZ
1128	payment	1397	1397	1678	1	1	943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDb1xr12EoxYZapwuL9DVqF4wmzAXJaQt4LcYpgZrzRi3zUdM6
1129	payment	1397	1397	1678	1	1	944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFRSD7hmuayw2rEwJ2V2cJq8WSUguLhLxPb7nGztGtg2cx9t1
1131	payment	1397	1397	1678	1	1	946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJWShrxTrVXr3wLWoxe85kAzYfiwZJBnxHFy8WRtBuKz6M6tV
1132	payment	1397	1397	1678	1	1	947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeuyTBVBqQzKzuKRidYkmbg8p3k2KaWZQtXMC7eVXCAjre31F
1133	payment	1397	1397	1678	1	1	948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvHKGS6Q77E1aLmjaGUajC7WKxZqnjkHBsWqFB9waztgkvTHW
1139	payment	1397	1397	1678	1	1	954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpR2ArxoyJBWuCAB41HzPE7t2h6STN3VWTGy85M535A6jwk6i
1147	payment	1397	1397	1678	1	1	962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcGsjmxjjc1oLujdF49ACTNexc8EBJPKS1ppkqzcrASNBt7Be
1164	payment	1397	1397	1678	1	1	979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcYBTm5v2sJWRWAGBVscbqAErG98g3vo5huxXz1eMaEbT7JLw
1166	payment	1397	1397	1678	1	1	981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjp3WF5rRin6UfsA5x2FhQ35aNUmSxsA5E7mbyqPWTLnknb4Q5
1169	payment	1397	1397	1678	1	1	984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ999wvg2W8WuBR2qPaEnqtvWfKejt2ZpmEHvsCw43arnjY2wii
1174	payment	1397	1397	1678	1	1	989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHeKzXm74QRrH59MfxMSxuGUyqHcdeY2fSxy8HKtobngVnCAc
1177	payment	1397	1397	1678	1	1	991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N6tQ2YPioeKY4jsA5eZJ9tmW1MvsrmqP8KSRE7i56p4wTWMZ
1182	payment	1397	1397	1678	1	1	996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GDY47TK4zkaYjFyFvvsW7Kc47KG2wAPfEscWQRiQouHv1nqn
1186	payment	1397	1397	1678	1	1	999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVefxLuxneWZsugBojCBR4UZUPpB2hDuE5AAGZ9d13SjiV4Qhm
1191	payment	1397	1397	1678	1	1	1003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjdkQ8b3oUppTu2HKDSkywgpvFxmrpQd83gbvujTLHeuDvmPE
1193	payment	1397	1397	1678	1	1	1005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpGfpPv7CTadNjntCgRKNNtcMhF2K6KbpQik3GY3mzUDwPZxB
1194	payment	1397	1397	1678	1	1	1006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcbfTmVG9kpdWjppzB2iD8yjcWYqSdYug9rTcPwkVSUTXpWEU
1208	payment	1397	1397	1678	1	1	1019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDnCbz4pgrxXi9XHD9V2aZjJJPtkt8uAvGN7aVvpchzAuok97
1211	payment	1397	1397	1678	1	1	1022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4hNXfCxUhSpkXeMnPHW2YL8F2FTnMVTncAYBkzKRPuyH8sL5
1212	payment	1397	1397	1678	1	1	1023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx94W1ztAFVkgRcXB5hygZ3NscT6m3Pzgq73Qgkoq5RVorei6u
1214	payment	1397	1397	1678	1	1	1025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyxCv8fABixUbHQyyaDjSFb1nMQfzsDdSFkKTSm12fFrVyd54
1215	payment	1397	1397	1678	1	1	1026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwt6pF3wx9AZDkvuTWZths6BcM2353megUM5bKLxGhQTXhAYV
1216	payment	1397	1397	1678	1	1	1027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQysnPxVZhuwhXWUKEHgoNVFgbHxPUbnr12HL9vGM8XjnpmPAJ
1219	payment	1397	1397	1678	1	1	1030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLgdcrM9SfL8sbE2MDuHA4Uf4Uw3qQmpCSktVysmw4DHarnFP
1221	payment	1397	1397	1678	1	1	1032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFy9KYrE9uKK7dSHZQdwjXRPeLPDEQs3Cr5AijqwvzYd4YmgKC
1222	payment	1397	1397	1678	1	1	1033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStsi5HQNVetR1RHD4DL5L3oEK5NXuBmAmW94f6ZddHmgPXcpz
1229	payment	1397	1397	1678	1	1	1039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1ZFpK75ReWbfkUz2yMRHCgEC2itSStL5wQr4aM5Xey1EkHPU
1230	delegation	1748	1748	418	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg23M6St2HSiUJyKEZFXTTSCPZ6XAD5p1dfjNH5Sw3kwEJ5GdY
1231	payment	1397	1397	1678	1	1	1040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7E5oPWFtuZ8EqcZd1G15trmDqd376D3fNcU9iDgnTdp6a1bhA
1232	payment	1397	1397	1678	1	1	1041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7pryB81gS3aj9pbhphWGtirFgEuawTnsUVULvkMLWpB5KLe4D
1235	payment	1397	1397	1678	1	1	1044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTbXNrXQhnD3WLQV4LBoNcEm36GKpYkGYoCKvv6XP4NPwHRCV
1240	delegation	1744	1744	1477	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYZiXqP9m6jwNnfHrCaoocZhSjXGPA4tv8HQFAA4zF9PgKHFe
1241	payment	1397	1397	1678	1	1	1049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjqqtaYxdCMTBbLix8yAQnngukjqqTX3AUoirZuCTFzKhW2c9
1242	payment	1397	1397	1678	1	1	1050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN8d6mycAqYXokit68uPZDtKaJLpB7gLqcWx84Z4tUYEK7eio
1252	payment	1397	1397	1678	1	1	1060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUa7dn7SqMRg2nxMqNcSfco6EuapL6Qa1gtebM21bR7N6kRSS
1253	payment	1397	1397	1678	1	1	1061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVh6sumiXrhWHXkxWBSNTh1ziHv7ea113oQeCjAPbYvEe5xULt
1254	payment	1397	1397	1678	1	1	1062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSxJgtT39x5HGEv7U1zgbwWeq8Nk1EGFTwFbH2V6LPJBgibYS
1125	payment	1397	1397	1678	1	1	940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiNgVrSggocoobo5NF9FD5YScfMysiggEz3rVaqKfCjNsr4MA
1127	payment	1397	1397	1678	1	1	942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb4QScK17BRn7oMUca3bgCDxNwH5JD31jnuuz1xdsLFjcHgvL
1130	payment	1397	1397	1678	1	1	945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjMuM9xi5WnmrVVbbpXtJSoCKdHTeMzVBMFoJ2fEEzx46xHix
1134	payment	1397	1397	1678	1	1	949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKovsM8kBP8cbgvk7AyBYtK72jUopsJXQYCdRshuQUv8e3Y28
1136	payment	1397	1397	1678	1	1	951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSXXWELr1RsQFJa7xJthuaZpVfo1hL7N5zFemH6npr3FKuexw
1137	payment	1397	1397	1678	1	1	952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpPkbs5iYKSPKxDHosEBgi2SHH7Q9WyXE81Qep5aQCf5RKXtk
1140	payment	1397	1397	1678	1	1	955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoCHQuobetgVvJ9orGFUTwoZnxCQLe39vF8wrmWSMoEB5YJdy
1143	payment	1397	1397	1678	1	1	958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7SWDYNX3drthwhpBLfBDu8CjxNRmGNBnmNPop5CGQgNEPsE9
1144	payment	1397	1397	1678	1	1	959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJQMu1ugDjwc6WWHpjrj8FKjXTrjPkSJuLq5ehxwqK89jdbTD
1145	payment	1397	1397	1678	1	1	960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wcskpQiEmsxZuzsHVoswz2SMqtp1jAf5qYtLPrkSaGMSWVdk
1146	payment	1397	1397	1678	1	1	961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsSVSqkPcaS2EHPx39YPb3WGRdcZj8FSSkkX5LyhwDek78TxL
1152	payment	1397	1397	1678	1	1	967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HkLderqc576p2749eYU5TuZE8KbP6vXMfBtXjbe8QDuUiynr
1153	payment	1397	1397	1678	1	1	968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcNuxNfs3HCyMj4TyuR2WoiTJKrafH7wqY8wh3fEQxgCjWYnN
1154	payment	1397	1397	1678	1	1	969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kLc2QuSdtf6Cahmd8NzAifpnPtrfx5HF1hVHQw3qqChuBNjT
1155	payment	1397	1397	1678	1	1	970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYe97dkT6tLgnZTAujSXUiM6K4j5o4QVZZbsBhcy9ok8mevZx
1156	payment	1397	1397	1678	1	1	971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVdKaVmvnHHJHaPvwsyjwKWRmVa2frUQ2pbE9Q6CPDFwGqHam
1157	payment	1397	1397	1678	1	1	972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycQ3Bs8TR24GHMmcsuWYKh7zvpi8ukQTUvxRmJdeb1abDB4EQ
1158	payment	1397	1397	1678	1	1	973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzomXpKGFSeMebatgMGbPzNLXbQPaMwJhCpp33VtNMcqwbeuAP
1159	payment	1397	1397	1678	1	1	974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhHdmEfqExjFdEmPT2YZK7CrnvjoxbabCujgkFEuXifXqL4Rq
1161	payment	1397	1397	1678	1	1	976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9i1kTwjqH8k549cMvnh3RLmqYsiusAwq97ekYDmhCpPWL7Kc
1162	payment	1397	1397	1678	1	1	977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokXk8Hydd3zuiPBwD4zTutF12xe8kWdiwLSWNwQ2Hy2zb7pTF
1163	payment	1397	1397	1678	1	1	978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9rcvYrsgP5EEASdMGt76WGFoY7fBvJQ1pw4n5HtgyN9G6ETd
1173	payment	1397	1397	1678	1	1	988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VHJcfAWSTDJrPqUM32iqmnMhYT4gkTtUCnRJG5zSDPTA6soW
1183	payment	1397	1397	1678	1	1	997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthDqJJMUKSWAiYpX1h4epr6R5e1Xx7KoerGYakDgttNcwEBuj
1184	payment	1397	1397	1678	1	1	998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAUaqGd261Xo3vLYiusM8qS6DDcEDrLxng5mTxgMWP4gzTtwG
1185	payment	563	563	1740	1	1	0	1500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7oDqUYDz2yoAZqQFWyAuNeLYrYdvonJcv59TtBM4NpthDWko
1196	payment	1397	1397	1678	1	1	1008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BLaTXKDkxsHQXLzhCPDYUgxoViAsRHXmbcnc2qhn4JzbVcAo
1197	payment	1397	1397	1678	1	1	1009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQKsdDPhVgsqUbx4Ah9bezt6SUJzk7mVvB63HQWTFvRMqj2r7
1198	payment	1397	1397	1678	1	1	1010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEyCotx4o719SsjgLRw4EjuXwS6jaxFovUkaN8xttxY4D76M8
1199	payment	1397	1397	1678	1	1	1011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhvnVMvD9fc6iqJFxt1XUpJSRfqmpuXkESM98dWbeV1QJWQgn
1200	payment	1397	1397	1678	1	1	1012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspqHMMHfxdJrMucHQ4qG8EL8ZsFJ1Z5odXbwrF88JjjZzKDZi
1204	payment	1397	1397	1678	1	1	1015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qNPER6rHCx9fbf5APJ4Y3bkgQrF9a4TXMGuLSx371brWGpwp
1205	payment	1397	1397	1678	1	1	1016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUEKZDbTYKQkpXVwnaw7JWPr8L4nuFKxbtY5Y3t4YFncNDS3n
1206	payment	1397	1397	1678	1	1	1017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBMkYXfUbAmhrEQJtn7uZDKMH2PGUi6x1YsQ2cjt6pSEhWtKD
1210	payment	1397	1397	1678	1	1	1021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bTPoK14UBV51uKkBGKtFrm4MRPwbtJLM6324nXQuD25Pk7g3
1217	payment	1397	1397	1678	1	1	1028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZX1kRmG3dG7LnGSF8UFo1qKUxd5BoJEPqewDgAAcnvgENkK4
1218	payment	1397	1397	1678	1	1	1029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe1SzjXGST11ZBxdXaKS5iYB8RmpkFtTtsgiANgKdRQVB1de5
1220	payment	1397	1397	1678	1	1	1031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadCmLYK5RcfNAKUKiJNqwDuztrXhvZZ3cPG7EdJUgqBKWsBSN
1226	payment	1740	1740	1748	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybJMfg5bMmE27ELbBmgkqWeEuc3PGRrNiVej9M7roTchyxMeV
1227	payment	1397	1397	1678	1	1	1037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJxJLinSBsnF25SiCBBPxQ2kugNDQkdRX59DJ1W5GaigYAQjX
1228	payment	1397	1397	1678	1	1	1038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXPYXRPoWnhrAuwJSdRsiXPo6qSZYgggE9JaXSafHLdujVZbb
1233	payment	1397	1397	1678	1	1	1042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMna9iDg2Qw7AWfpx3tVi7bSdWsWxVDNg94oBN82URjF7t8ns
1238	payment	1397	1397	1678	1	1	1047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpuwVUALEJpSW4XUQNFzWYu11tczdRjFRMFhuFmv9Buv9SUJx
1239	payment	1397	1397	1678	1	1	1048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KAnzGuS6sSUFmHByrZiE6yr8NdS9r5cTRht2eEumfBf5R1pB
1260	payment	1397	1397	1678	1	1	1067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ntGUFMTh4jWCALEf3W8mUD2L7JJsxUbghkFeni3ZkfSPJjbm
1261	payment	1397	1397	1678	1	1	1068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdDXXAMxVg1xCLaGnDFWR5uPhD8AuitRCeUcvhKX28Ltk7FRd
1262	payment	1397	1397	1678	1	1	1069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5JVtvtUKAZWgitDtnHAFQYKj2empt9xh7ttYkmtsLhZxgzBk
1234	payment	1397	1397	1678	1	1	1043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLVU1E3txMkREgwKgfFbJHwGgUV72kwEUG5CHdnokgWuh8UGM
1236	payment	1397	1397	1678	1	1	1045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwwS1Dwy3ibBjn18XGKCq1LaBR178wVcKFQjFjT4159cS1weR
1237	payment	1397	1397	1678	1	1	1046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8zKLTgmKWRv2CY8Epg3prqJhbcNya3HvZGzyPfm4NgmZ7jiC
1243	payment	1397	1397	1678	1	1	1051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjoxd4PTcjaXS16yFGxYRDa9bkZRhaGKGtH7KbtrySKynysvB
1244	payment	1397	1397	1678	1	1	1052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDYQa3cp3RqG4MvfRJYEVfK3hk3u3P93G95EdddnwDEiWr5P4
1245	payment	1397	1397	1678	1	1	1053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yjgFGk4hVGqYtRdDaZJX6zpHgnqfwjfBf2Sark7nT6ACUK3f
1246	payment	1397	1397	1678	1	1	1054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJUHJGx1fukidkV3t1VwYHt1mZwZpWiTC8f76CmZAQpAn4Boo
1247	payment	1397	1397	1678	1	1	1055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uttZa92yFihgn5RRngsuqR7GWWJrPmBU4V1vDFdWCFHgV3UM
1248	payment	1397	1397	1678	1	1	1056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzPZz4XHGr7EedvgpYySgr7RoxE2EbQyY4BfAyHfqoxMWMAZP
1249	payment	1397	1397	1678	1	1	1057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDUfhksRSgEVqayjUvyLKLonuhDLPwqwHaMZiPiU3nqcRY8aA
1250	payment	1397	1397	1678	1	1	1058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFY1YQro4kmqcYKqFy231vKBNGtyMm8NYscvqXgDEPnUEqkve
1251	payment	1397	1397	1678	1	1	1059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Gfa6b6Ejxbde9QTzM7J6HNPaY7MPr6WusMWDQZWyG9fxEZp3
1255	payment	1397	1397	1678	1	1	1063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyPeNJ99LNVn97tWUy8gcYdtvrSdUj9z9hFfrcvZ2zczmTJxq
1256	payment	1397	1397	1678	1	1	1064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsow3YJQZ9GAfCXgcU5zWN4Ah9gmqT3W4ZSwCD6UQoGwpR8Af
1257	delegation	1700	1700	448	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHedbg7uqx7SfwoVdVi59CoSn9AegQZweg75aPfBes7f3zhP2h
1258	payment	1397	1397	1678	1	1	1065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS8fAY7yaqekpXKwvdDzqWoshnP2kW47hfsBnmFAruNvbJYov
1259	payment	1397	1397	1678	1	1	1066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4a7CyuvrVqEEWdvRZTFx7HYHDaiHTpgwtA5jGjsCp6LzuBFgS
1263	payment	1397	1397	1678	1	1	1070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbHsajV3U6V81Vk7CVfTPnD7qNrnC48K74MVoRfrjtnYTz9ec
1264	payment	1397	1397	1678	1	1	1071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYft8KDzTU4LAnHg2A464QNo1g2dgv19GXosxFTrRT2ndv8VwgR
1265	payment	1397	1397	1678	1	1	1072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KwiiaBzy3GhTvtfoUSPRFpeKBHH4nahkFsnTPeRRV2755CrP
1266	payment	1397	1397	1678	1	1	1073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GHu9VaDEBQtATWuFMQMKvaRqqY5aP6azvEzS7WRTcKXJaJSN
1267	payment	1397	1397	1678	1	1	1074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnttkVggyP7TxnLvZrPCgmzN5XRjMsNuMmskdvLdqN1Nx6nPq
1268	payment	1397	1397	1678	1	1	1075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8N9Xsf4TuD5yPZsUfRwyq8dApjzXNd173UMMGGZYGtcpFqJY
1269	payment	1397	1397	1678	1	1	1076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuvKjZiWPL5y3hhKu8yfTcHJV1kqgb7ssQLXpPdoMi6e1ZEao
1270	payment	1397	1397	1678	1	1	1077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8NALkk4YY4Mo8DrtjkXcG2iGriDrNGhaeQ8Y2XUbe1e1C848
1271	payment	1722	1722	1749	1	1	1	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviAFbL3WYkDbsp82bep8Q2MBJsjEjGmq4DiawsKpwEa3tGvcy
1272	payment	1397	1397	1678	1	1	1078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaGXEFhSDC8tLiumrQhnmX4cUQv2cQ13uTicP57z3LTRGt2MK
1273	payment	1735	1735	1745	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6w5K4J8ksUSNp9N9UJXn2dmvocswXg93QMdu6LQLSzfMoiHg3
1274	payment	1397	1397	1678	1	1	1079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kTggTXhJucpoyLDVFsnWJWdTbzCYctJ31aq3KKTM3mJiEgqH
1275	payment	1397	1397	1678	1	1	1080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLgpKgPbLJiW1Mpb1sPcyCfCShMRVKCR7myshvruWbnmBVoH4
1276	payment	1397	1397	1678	1	1	1081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgicj8KPBeDfew3FrBhqdmqG8ziGoEkFR86k9Y7XT2WrG5wX7H
1277	payment	1397	1397	1678	1	1	1082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dPYJkbq3jU9TXPbpdADs5z5fawe4vxrsgdsi8zTpY3A5tEwf
1278	payment	1735	1735	1745	1	1	2	1002000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJKQBm4jkwHpPki3zM2nRaHvB695wSVy4r1PcmhUwGKmXa7KT
1279	payment	1397	1397	1678	1	1	1083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TQ2sCwmuriL8fSxLkZGQ6KgDpqWTFjHuL93EYXFEUrkDb9rE
1280	payment	1397	1397	1678	1	1	1084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgprfJqMkZ8KXbLTMtgHFfpv9ffpwFCypmLvsWZEKit1ca8twJ
1281	payment	1397	1397	1678	1	1	1085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmSvgNxne7GwnDa3ywB6q78utQp1QSPiP31PCsyKCPWAM9LRP
1282	payment	1397	1397	1678	1	1	1086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmT8wqmjNFPgc9qdV49eHrHHYQ25i43SM6uBZ1gm3nzT4RbhcU
1283	payment	1397	1397	1678	1	1	1087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH33CLP9Qe14QPSBt8HXXuvg5fdDfGCDV8ymLCx8tqNVkp7ggb
1284	payment	1397	1397	1678	1	1	1088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjsEA8eCYiLtsCSVbj34io5UFpTbFnRiFowhtSR5ZBm3BLeW2
1285	payment	1397	1397	1678	1	1	1089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ns6fjp3WQop85i3LKybswSbMzv5WCGhFKvHyctLTm3d6hz3B
1286	payment	1397	1397	1678	1	1	1090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzWfLJfgnXYND5rRNbwjfpHxzCd5f9E1vVc7NDB6zfEDyvvZu
1287	payment	1397	1397	1678	1	1	1091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6HTXJEVEheER4nib2DiktE4LLSZYhtwjVu68BLVUWY78yjdo
1288	payment	1397	1397	1678	1	1	1092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAodf8UjL2r6fTQiTMnj9pZadsmQKiToAqrwUMZsAJcYgjgGRL
1289	payment	1397	1397	1678	1	1	1093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB4CFH6aUAS4EzkYfsLWc8jjAuy9Wen8BtnFAprMeRikzRQM3
1290	payment	1397	1397	1678	1	1	1094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkekiznDRFyoPNnNtZoKvTatfS5ypxPtK5sQECLUaWwvp5cCe
1291	payment	1397	1397	1678	1	1	1095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DL39KrdUMh94ZtivsZgfycdbc3rZDahW7XgBLkKCUUZC3Cv7
1292	payment	1397	1397	1678	1	1	1096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMnde2VkbuPpCMBw6pjsg4NWtiU7zXEaRdovYpn8A27vohuLw
1293	payment	1397	1397	1678	1	1	1097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48V84hLgoZ5hG4pu73HXgVEHrqNL85MN1Xf4AL5z7wEqVC7V8
1294	payment	1397	1397	1678	1	1	1098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCywS1DHoT19yQXN7j3RdUb7CQWYXBzPQob31XVXLiFdtdJpg
1295	payment	1397	1397	1678	1	1	1099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13ssaxGP4HZC7nD8TTN3vntfhenJXEKpYkae5rPJ8Bo2N1Z7j
1296	payment	1397	1397	1678	1	1	1100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLjjDvfBTYTUDnDCmNDqdXtMC9wJSUN7mEdheT436o2V7XPco
1300	payment	1397	1397	1678	1	1	1104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQPdNJ9P5yaxaYgeUL7XpPQoVAJWVxraY3ekNJbVJ2wmE8nj4
1302	payment	1397	1397	1678	1	1	1106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6FtQGphjrSCc1WAbnHL2QSNLYQ7qGA99rpTc9GSAHj8e1hXV
1307	payment	1397	1397	1678	1	1	1110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQouWZVXWTBMAGYbGr5YUqX3kc7wFapDhHjBqts31QbwjB8ZK
1308	delegation	1740	1740	563	1	1	2	\N	25000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAKerzpGeHgso7cjWKk1GzKh1Vyjzn5Y6xBwid56RZwpkJckg
1309	payment	1397	1397	1678	1	1	1111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5ERytK9sFz46aVT3fQ315BXTy4SqMjfjfb5CeaGeTvNY8GAp
1310	payment	1397	1397	1678	1	1	1112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJfKSgbdwKeMtJ5NdXy7q3kkrKi9r7UwyoweLYE8JLZjkwsa1
1314	payment	1397	1397	1678	1	1	1115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUcRZ16eq6qPf1f1T84fTwu1cLGfzrh4QVBnNx6Lr1LJLKN9U
1315	payment	1397	1397	1678	1	1	1116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jz4aKsiW7fGMjXDGQBhBsu2nUP854MDJbrsHE4BE6WuzF9VK
1316	payment	1397	1397	1678	1	1	1117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4rhMHTPAG8nVjvU6swbEwQUfo5p7z5zRBMVvaJKrAZKxa1HX
1317	payment	1397	1397	1678	1	1	1118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXgW7XcwgNtPUXfuvdN256pHcZGdRtSjSE9mxW4VTb76F1e3n
1320	payment	1397	1397	1678	1	1	1121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYepqMPZcFaXWkf3MSBcCSxKqT77P7GNqRnP7FWa7brD1rTT2
1324	payment	1397	1397	1678	1	1	1125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbgcy2QX5YT7g76QKMsB5qAUpVUoGkQZkdQiTzRvKTqgvbgdC
1326	payment	1397	1397	1678	1	1	1127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNA8JGJh3e7DiXrc6EqiGGZgyAxQZjbTD1qT7vjHpT8mezPHc
1335	payment	1397	1397	1678	1	1	1136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJMACvCtCy2KUwAb8tWpZSjwgiygfJJdkjDZ4se8LE9pvVsVZ
1336	payment	1397	1397	1678	1	1	1137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDotrMobXoxG2qu6Tw1VQLzXkJxJnXVSTvrFkeU7ZtfCsdsJj
1337	payment	1745	1745	1752	1	1	1	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4u5CtLproGak79hYNDFwcjmwtKah77bHr77TFqcXwiihKmna
1346	payment	1397	1397	1678	1	1	1145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuY1QZq3MRgEF2C2QUEYtpo6BDU6e13JY3WYSRcuNzKvF9KH2c
1347	payment	1752	1752	1745	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1u5S2W6bzPx2AoLUoAcQ8UYN7Ry9JmTHdmnZSNKzidrx5x23
1349	payment	1397	1397	1678	1	1	1147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNi2xe7RGTs6ucRm2YqBn4KcR1kxoX7r8KHkoawmA8xjsHGzP
1352	payment	1397	1397	1678	1	1	1150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTJ6seoULmxqH6PXaxoji67dxHgarxjTiJ7uhJ8PueRs2q8Mo
1353	payment	1397	1397	1678	1	1	1151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKPUw3xQu6GjKvSbb5c5qmVsNb5VLG87F47vBRMZcSSdqrB5v
1354	payment	1397	1397	1678	1	1	1152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLYipwqnAyVd3Ndnx55qQtF31V4RyvQd7pUKKstWTGBcYmNKi
1355	payment	1749	1749	1753	1	1	0	13000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXE6FVupGVRxX68WaXKLwWEvSv45ubEB9M89gCFGpPovi75kQ
1356	payment	1397	1397	1678	1	1	1153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVqhvDcYFKZK5w27i5f9XoP1YbAg86jAFYRSrZ5NLHBeyV9pu
1362	payment	1397	1397	1678	1	1	1158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFskTpys29C3Zuf7Htma9cWk1jmgDFoVn3RHNt85rLYhktPzby
1365	payment	1397	1397	1678	1	1	1161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViERauQyJa7eL2Y9PHsBcDYTVowXjpsiNLJsHVUixeKyvwcre
1366	payment	1397	1397	1678	1	1	1162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYzxfFH74DGbuTfvmU1Zkjjc7PyY2YmNfq7qNMYgahKLNmMVY
1367	payment	1397	1397	1678	1	1	1163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbzBJN2cf8EBYmhMAyjJ38t2VwSRX8ZjiJoNn7VdUmro3xmPK
1368	payment	1397	1397	1678	1	1	1164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGsnS3d8mLZJgdKAu2QLLZRSrHCi7WshomjveZrQzPiy3q3vg
1378	payment	1397	1397	1678	1	1	1173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5jGEBthsnh1K6xUb2Kht24SuevHc1hjs1wJgCsZn8EUJJR1j
1379	payment	1397	1397	1678	1	1	1174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi77PcW1ebMJ9efGQtSRTeA44EzBH1DwrNHku2B1hjkrmdDW4x
1380	payment	1397	1397	1678	1	1	1175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdA1KUzFB7hXN2bBEXq4y31NUgbMPajgHdffEJHSaVfCcKrZS
1381	payment	1397	1397	1678	1	1	1176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3pPJ3k5oXHSGh6GdLWgXWGc5a6ps8sGjfyD3qtWKibLBNZ2f
1382	payment	1397	1397	1678	1	1	1177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKZEUUTw9xGoQ7crpMMKiUwzoqkXDKrXLQckrjFLDKsbW3CJe
1383	payment	1397	1397	1678	1	1	1178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49jb4g5KZspS7ZnzbiT3UuXQxUSqaETrarMdDF8P4GznvPmng
1384	payment	1397	1397	1678	1	1	1179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaNUTTLWCkkHG2xDNM4wcbBZB1pETVE5sVtxFUTwHXDybh8Tb
1386	payment	1397	1397	1678	1	1	1181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdwb7qC9Yz6v8Hqd7FjqUE4UQNuY4VDTkq4yBB7N8se9Uh5ET
1297	payment	1397	1397	1678	1	1	1101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnAeETVReCfnnC6r65X89DdAJvePupxUjHwtEoSLhbMfDJ63v
1306	payment	1397	1397	1678	1	1	1109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZuWdTbCvZE9wVkKSazmeobeVMtwYRmcYPYF1d6zt8RfXHa5Y
1311	payment	1397	1397	1678	1	1	1113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjD3aNNj9S6HZ5MzCJVEFQRuNLYSjmELfEQtFDJezui5rTGEx
1312	payment	1745	1745	1750	1	1	0	8500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqfqD4pFJYBYMkGHs6hUgxhQmDWhwsWJqKEHQifDuZST33Voi
1321	payment	1397	1397	1678	1	1	1122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDCw1MCFfAnKb57Wj5imK1eHQejJfUJszEqULPozLjohxN8pR
1322	payment	1397	1397	1678	1	1	1123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX1iTwSwUcpjhRbGYFM18QQaUhCGE3tembhXiPcMA724N1UZt
1327	payment	1397	1397	1678	1	1	1128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLHqVD174LrefH1daYe2Wsrkxh7BViJ5nHKFEeRaE3Kp1UdGB
1328	payment	1397	1397	1678	1	1	1129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPniA9udxgALFUZNTfDDZXyBnzg3vGpskvhQA2hMZ9rNE5h8L
1329	payment	1397	1397	1678	1	1	1130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNYdjC2apYTZnffvUiFpuZ7ZsNcuACrEmo9JaFTk5S4XRKxva
1330	payment	1397	1397	1678	1	1	1131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmRwLcjvtuxHKo68gysa1yXCvyvRA2CBoK1NXxS2XvdqNzT9A
1331	payment	1397	1397	1678	1	1	1132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPzWXgEjbVJPwJioCKUsGBao7mp62uBcMLhiCwvAUCymStizZ
1332	payment	1397	1397	1678	1	1	1133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ubjjcGGqXrS8XWmrNsGxSWdgaG5vaqVqT7dACUf7Tphstdz
1333	payment	1397	1397	1678	1	1	1134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtQGiqovX4EwxH6WeWP4PKxqkB5KMBKCgEuRZsqHKyzgUeUCu
1334	payment	1397	1397	1678	1	1	1135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWDmzY816sc2GppGvKxfLaxPJMTU2mK6VogauMnsK1AC4Bq4g
1340	payment	1397	1397	1678	1	1	1140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkKEHUdetTjPot8Erh6GWWfQLH73Cpx2NBPZ3Q5qvLnxirvtA
1344	payment	1397	1397	1678	1	1	1143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i55cGSbcjvo1Zr7ckKsiFa1XqyW5dRgAw28ih9xkeTUQsbNL
1345	payment	1397	1397	1678	1	1	1144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7VrS6ezgXYB3iecjKeWXHbHbTLv8m2S2sTagk7Yf4X6C7i1M
1350	payment	1397	1397	1678	1	1	1148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxSZjyjs2dgH1Cnrz1jpkmCzjbd4cVg1923Zd6LhwZ83V8hDt
1359	payment	1397	1397	1678	1	1	1155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaphLtsHjHQEFxcEFB5irAgDyvzeCCQQJTzWcBiq11VMA7FUh
1360	payment	1397	1397	1678	1	1	1156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupmmKqrygXZBbvhDD2ARAWPSCaan8p4CcHeniPPKifnyLm8rq
1363	payment	1397	1397	1678	1	1	1159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxnJVAamXB7LQhmpcmQ83LBUULMnkYVD1fXGAbuSBnYVPJFAN
1375	payment	1397	1397	1678	1	1	1170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLzuzArcNJ9RAVkhgE9RhuPhjBp7GgSoVjGDipxfB88rZmA84
1385	payment	1397	1397	1678	1	1	1180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjdePu7iWshjDb1gH4toYaxvbKERFUvdjdr3QMuCm5rX6LLVq
1391	payment	1397	1397	1678	1	1	1186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWbh2MCeFvV8qKrNaLjXHwvfqrEMT7Hdu9jPeza58JZUAfZCv
1392	payment	1397	1397	1678	1	1	1187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWYHZ7eEnJUNUbWYL6373Y5kro3wXFATYtWcSoLRa2subN7jW
1397	payment	1397	1397	1678	1	1	1192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbM5cbEUQd26HbdJY8m41ZHJr6h5nqFXoDvDUirqm1WhZ9nrR
1401	payment	1397	1397	1678	1	1	1196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF6ou3XS91LuuqCGfSwfMEwqdNUZh8R8XaRBZuKkCY587UPoZ
1404	payment	1397	1397	1678	1	1	1199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaN95ZT6w4PVQXqMmqVz1JxhxtpA5Hacsrut56HgXX1N1tH6N
1405	payment	1397	1397	1678	1	1	1200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPhKwYGHLyuiUSSfvTM5evAF8crG4GesZRgvfDszBN98Nmnfk
1409	payment	1397	1397	1678	1	1	1204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa797F9uvjiFhjwzh1v1tAxdRnMok11HbES5yHfWjPEtYDuitGQ
1415	payment	1397	1397	1678	1	1	1210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS1PQnqwV2AiWEJYpqZPhaYwoRzTmggqzt8bdeW4FEb3am3A2
1417	payment	1397	1397	1678	1	1	1212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxQQWCCbdEnjnzeZrZibp4rJf2x4A5Rq7C1GoNU3CWQ9QqqH4
1419	payment	1397	1397	1678	1	1	1214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgT1iDS5DpEoXdMK4GzqLfHUSPiz9i3PH2AGihHSUbbUKY3Zfp
1420	payment	1397	1397	1678	1	1	1215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkLj9njGeDRTakaS71VZNkgAxrAsozGfJjFRxhZL3L6w9DPUf
1430	payment	1397	1397	1678	1	1	1225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAHcEeKY6UQVBWvCnPRM3fikd5rmWAuLZ2mtPKUKQSNYUWXsQ
1431	payment	1397	1397	1678	1	1	1226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrbK8ED2rMrWTy1x5sfdJtgkPLfskWJFsKKP8fhJah1QEwxfz
1432	payment	1397	1397	1678	1	1	1227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBoBtV6SkxycT2LZbFJWKUxzyqhn6bcw5mGWjTQmpaEr7x4kt
1433	payment	1397	1397	1678	1	1	1228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8drtfZtosiLBQNZ8QySiyi9NNzoXZifrs4gXh8hWqVipRK53m
1298	payment	1397	1397	1678	1	1	1102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkDf4MeNfi2o1NfnmF6S9wkgU1mRXGRae7BGXbJNhgEkGCRHg
1299	payment	1397	1397	1678	1	1	1103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvtUW2ydw1Uxn54ykgCoYaJvf5XgqD613fv7E2QLHKWZDtnRx
1301	payment	1397	1397	1678	1	1	1105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTyTcsbLN3ZyEdU1ENMmgCiLmgpGcUYLeJWdijGQsfFApgVtM
1303	payment	1397	1397	1678	1	1	1107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzks5ckJ23JmJY5WN4Q58m9DgKSfieTohb8dkXvaBQi8DpcWG
1304	payment	1397	1397	1678	1	1	1108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYFx8qv5cx5Y7CHZ5SEY8Bu4oRpvmtGvT4PAV9fgBWcDwGj8P
1305	payment	1735	1735	1745	1	1	3	18005000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEraDePViwbUiQWPXaLXJTpobuuZTL7kTCKfZHUBr5PNy1eSV
1313	payment	1397	1397	1678	1	1	1114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF3bARYSGna7HoP3qbS2zHD5dL185tavrVefL6aJutrPnwLUr
1318	payment	1397	1397	1678	1	1	1119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgMHKkTzW8x6efU4VsywgRnGTLM5H69pCDoFneeK12DKQrDY9
1319	payment	1397	1397	1678	1	1	1120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMs1s8aNk4AFwbL3XtLNxjrWuK4MhMaQ4AjNXixoNoG17QVKe3
1323	payment	1397	1397	1678	1	1	1124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEggYXGGV1Ca4L1yxhuLogVMWrk5wA6CxufgrjDWQzLteLyiP
1325	payment	1397	1397	1678	1	1	1126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1ASGMFzVkuSsnBAPT4WjG3NYNF82VqhwzaqGQ4xZapEDgrP
1338	payment	1397	1397	1678	1	1	1138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZh5owWXjw3Rr7WaPpDjTdNnCpVbtjZqXF9oT3qYMkbWBMEQqv
1339	payment	1397	1397	1678	1	1	1139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwHpY5SLVWQftJMo7SSYyrD5B6mVqf7nD65uECEwA1dqjzADh
1341	payment	1397	1397	1678	1	1	1141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnVRvXZtbRdzZsT3fi9XqActqyZDPKtBFrMCn2WZQJXouG7Ns
1342	payment	1397	1397	1678	1	1	1142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvukgMAbdMuxaSp9MtsEKfYzo6oBWG2WGbZg6QnEuXCjrk1aFe
1343	delegation	1752	1752	1735	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW8rvNzLJzyEEpwup2ZvVXjmZE3LzLWFpucreGSYyVRC9M6rm
1348	payment	1397	1397	1678	1	1	1146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYR2GgamszqhJQQEqKBtsx3bkU2dpcbMiTS65nNRAjuH7fV4gD
1351	payment	1397	1397	1678	1	1	1149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoDEv2NPn3CPTV2Fn79TzjtqbdSbK9QfxLVaRBs7W8cHmPhiW
1357	payment	1397	1397	1678	1	1	1154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzEeUnQquTGc8wEng8LNKSphs6qtXoj26PqeST7DHQvsyuadX
1358	payment	1722	1722	1753	1	1	2	1100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdYBW33MpRgGyAc3CLffW6vnXKh1ABMhrG3LaPneU9Nq7gkyR
1361	payment	1397	1397	1678	1	1	1157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfuyYoNbJVjFbMtJknk59ZLyPeT4Z9JoNfpPRXrJpAsa577mn
1364	payment	1397	1397	1678	1	1	1160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HwkwbYeJFRdjAoYXGX26sHiVgn5Q6XRyVxyzMhkrNbVgjzqC
1369	payment	1397	1397	1678	1	1	1165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdEQxBeputawZQiv3NVF2w9sukXfygS391kVKh8ZyRgyduB3B
1370	payment	1397	1397	1678	1	1	1166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWQNb8YZX5st5cp8NevyguAchXVMUc1AprjAKe4CK9Mghfmy8
1371	payment	1722	1722	1753	1	1	3	323000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3RhVrG2JfxACKV6A58RetnDNm4i25g1PzZG5hEFZanH82fXk
1372	payment	1397	1397	1678	1	1	1167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRGrErwQ4DnUvvmEh2dQbStJ9BJttbU3ThHHpaRSd7JiaZeq4
1373	payment	1397	1397	1678	1	1	1168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHMzrTeRN4eMonxHLxXKszboRdpi1hFFB6USX6TfBjsJTYdiG
1374	payment	1397	1397	1678	1	1	1169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUzbMZXDayEGf5gVxmRdC4yEujiXuuSmHtWBH7FUDKpC621zd
1376	payment	1397	1397	1678	1	1	1171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3UFzyBepyPWvBPpgphQPufZbi9VsA2ybzdhJvb5AJ2ZY47QU
1377	payment	1397	1397	1678	1	1	1172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbupdVWRoMLEmFfSPQnF4RwavyAupZ3MwvrU352JJqZdZ5cM7A
1388	payment	1397	1397	1678	1	1	1183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ35FmwsrzQCoUFDas4iJ4qgnB4tX5dBXXmhjteJFHgD5GxiX2
1389	payment	1397	1397	1678	1	1	1184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGBJtKAYYXxqm8C1fXF5k8JuGKBLKSyhdX3PQwcz6YnY7pkme
1390	payment	1397	1397	1678	1	1	1185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnSCNpayJvEVK72RsumJUJfbkzax6yrdkcW6HNkbuLGK9T4tx
1398	payment	1397	1397	1678	1	1	1193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxemG5ED4JeCBMj3afWixRQaAvWQarXAdDivJE3dtnnpKWHeo
1402	payment	1397	1397	1678	1	1	1197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4UZzPqv12ztfw8yjfo5GDRzkjFKgrc6xg1fb7N2AvD9ti581
1407	payment	1397	1397	1678	1	1	1202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsoNotTSTqHvRimbk5eiRThjwv7adxF3VdqCHQeQmEL7QhJ9d
1410	payment	1397	1397	1678	1	1	1205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SUYmrEwJ2Y6CtFjsykcu7Jhh2L4aMJbHfyMEXDn4qyXowenE
1418	payment	1397	1397	1678	1	1	1213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCpg2jSFYEYV8o5y7KLJdwSTA3Z8kjYMBSn3pbUTc2sGrvJ2
1387	payment	1397	1397	1678	1	1	1182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQpFrQVjWmPV8zznTnXBStMEsMMtZV8s7xYMrJkqsa7qz5w49
1393	payment	1397	1397	1678	1	1	1188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmQMgj7LGgDuNnSqYXMMXet3QehKMTfjMS1prnUQDyAxjztKE
1394	payment	1397	1397	1678	1	1	1189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvkFuBFWimQoPMJ9dhmZ132fu5XCqDuFoM23Eo7VXemUrVmWr
1395	payment	1397	1397	1678	1	1	1190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5E6tXrWaPWpaNjteroG1hUJqNtYbMtEvWi4P7GPycTx6ePHrp
1396	payment	1397	1397	1678	1	1	1191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwxCbDEJyhFzyfygJTRLw6Ba3dyfpd71qNzztQgo5G1NoHFXk
1399	payment	1397	1397	1678	1	1	1194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2iZDoywtkGkixayrPNnh3jGcEsngiGfu67afqzVevYoEijwi
1400	payment	1397	1397	1678	1	1	1195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpNU61U7rAaF6CcfSeYzFbvu5hA1cumE85ujVX2ES7pYiahLr
1403	payment	1397	1397	1678	1	1	1198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4huqKe5s254kNq23tLZsgniyeK1b4usreRjz9wXEFgnNWYfnx
1406	payment	1397	1397	1678	1	1	1201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6NZiuMHfhLGkggDJtPmpo8RHvz6E4MiexiAnwZFu8n2sVJJd
1408	payment	1397	1397	1678	1	1	1203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLSVBQ8uHSLZvdZ7FLYBuwJJjjpBbh1YtMkhZfSQ7ktnGsPP7
1411	payment	1397	1397	1678	1	1	1206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoG959uYW89sr2hCnaoRprXy6K9BfasxEisaqBeiqTrJDXF4rY
1412	payment	1397	1397	1678	1	1	1207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6oov2X3j9uUS5yafqNwet94PEfNyDC2SfCh1zWbSX9s1qx3zH
1413	payment	1397	1397	1678	1	1	1208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGN27ELNXRTuj7zXbBWUtXGzTPHq3vELpVcTzL6mSjAo1PjTMN
1414	payment	1397	1397	1678	1	1	1209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgG3Zg5KayWEpMCGRctYg776i33P5pYhuUXEasr3MyRHrSoE6W
1416	payment	1397	1397	1678	1	1	1211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmTv8ThzuXa7qGRfc3TbQuAPXuc7DJmenwLQRLcrVYeCfRDSF
1421	payment	1397	1397	1678	1	1	1216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Tsxmtx62Ur43JwQZVeczKs4choCpKzkjZWetamWsNBXULPNJ
1422	payment	1397	1397	1678	1	1	1217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHPYbCBayTgYXKnYTVnCD7LNzxhhT1y11DSNiZuzzfd6LZQPN
1423	payment	1397	1397	1678	1	1	1218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepgexGdg1yK76TRVUdTp7P7MoMFpTNypTCJpny3FqADzSaTa3
1426	payment	1397	1397	1678	1	1	1221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjD8TYiitg1zE5Kh4mxcyzNHRvJcbcVzb6M3EMV5KCnyyDjwsx
1429	payment	1397	1397	1678	1	1	1224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEA4XUMC1G9CxbAczLias7kj5WCAPnJXPgUY56RSCa7LSUGni
1434	payment	1397	1397	1678	1	1	1229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgogu6KF1yCQrZyq7Kyryi5TURQKgjfctxapKswsHFmm6sdV7
1435	payment	1397	1397	1678	1	1	1230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hEUWRsbPCCFqc9JBAYWLt1PbKjFjpN9jWhQ9j7fRmhz325Zf
1436	payment	1397	1397	1678	1	1	1231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFD8Y5iWkNqkKeHVjmh9truxytt2Mao48obALdS33JPjPT6LG
1438	payment	1397	1397	1678	1	1	1233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQUWQbVCZtHNq8HjyG2vKGzmgurbeBUchDc8MPURVK3ZT2gB3
1424	payment	1397	1397	1678	1	1	1219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhSYz3QNKZFw4h1Syv2xnKuRknyXZLMAsUcjYArzvd9tT5bia
1425	payment	1397	1397	1678	1	1	1220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnywo5dEmpyVuok8rjAoGdH8c2RTjMwsJRjjXg5NfXHaXgq6H
1427	payment	1397	1397	1678	1	1	1222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYNsbmiLJCmP4B8D9v5GTy89zvNGHQEHDzdgiwuF5ekHRhPfV
1428	payment	1397	1397	1678	1	1	1223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8kYLBEwougAyRHvnJDgNeJgDpzEvQX2X6YJ1QTBzs2NVZP9G
1437	payment	1397	1397	1678	1	1	1232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHR1oHLBgUqKb5EXbKcH1ifPA7CAVdZ7PSKHhVeinRo3zM21v
1439	payment	1397	1397	1678	1	1	1234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4zcrdy1pKoGViCh5NckBYh9W6Fa1ciGPSf2EjnF5riXbuaK2
1440	payment	1397	1397	1678	1	1	1235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdFLs18RriSiKq1WizLXpNytk65oCgE2m7wUvjkP9cKbpvKe3
1441	payment	1397	1397	1678	1	1	1236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD94aCLsbRCyKQRNbZxBQD7tL9RpLdhky4SJkX58SAVBs5W1g7
1442	payment	1397	1397	1678	1	1	1237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLE6NTAe8ps6VzHJSAqKE7aYPaHRMyTQCpKP9EixmoT8TBHg8J
1443	payment	1397	1397	1678	1	1	1238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLNQowy5bvmAviJ2yNuxeJATV5RLrvFtJStwuCWqe8bt1Y4rY
1444	payment	1397	1397	1678	1	1	1239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoWo6pXXkMxRzkhzAhuZntgNeYNayQ8HDGipDAoQtT9iaoo1s
1445	payment	1397	1397	1678	1	1	1240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TrNSjhV8SBFUtub4uba9P6KoCFR1oPpmnxPPvRizvXAtgmS6
1446	payment	1397	1397	1678	1	1	1241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBazwgBKsKRcAKua4kDH9Yz9pd3TfEHzHGVjpsmN8NTcxaF7f
1447	payment	1397	1397	1678	1	1	1242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1umoaJsQHdpTTtYG9PgYAr68EuoegkSrJwF6Tw493uUbAuAgw
1448	payment	1397	1397	1678	1	1	1243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAKSRqsMJdFQd6ouUSHY7zzC2LxMnmsMqYevUBsi5nKycGBLo
1449	payment	1397	1397	1678	1	1	1244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQsmbSNNQw2rhjRASajYGdb4sSY5JXuaYYNbGPgbVJ5aRzRGh
1450	payment	1397	1397	1678	1	1	1245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VnQwT1deXDL4wdooteKUGW2M8ZyaPhtZVZ3FowggMiwwhsgQ
1451	payment	1397	1397	1678	1	1	1246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivJm99GBcQudRhqb9eWoMcNg2W9jc8PEzpYsAfQbkax8Md4rY
1452	payment	1397	1397	1678	1	1	1247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNuSq3ZvDhWYYwKGeGs2t9NGDavUo7EvUSR3gUYj3bcRgarUV5
1453	payment	1397	1397	1678	1	1	1248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPmDyufMuzLJijC3BHXKnn377trJQM12bsjWrabTD8SzLCpZh
1454	payment	1397	1397	1678	1	1	1249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLi9NnTDe8SWJKQkEz7fQgzJvYB9MTWs7cgDr2Wj4J2jnc52pT
1455	payment	1397	1397	1678	1	1	1250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RuWCntxXGukArEKewLGeJzQdv8r8ew2nwGGyyBwCY7pR56KY
1456	payment	1397	1397	1678	1	1	1251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSAKMGSmPBvxEC89gTQGwoA1mRyCTdJZtmrJfCS3EHmQ9JYYT
1457	payment	1397	1397	1678	1	1	1252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThc15DfN5bmTYiEifHV3P2zLzhdpZ15mHQxSFjqBaDswMhgqq
1458	payment	1397	1397	1678	1	1	1253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA4duT8YwEbXWsBQBHoawWLUc892LSQcarFn2vP9qnqAFW8os
1459	payment	1397	1397	1678	1	1	1254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxUg4yQ8H9NdyzjQurK1w7w8W5PGxx4XydcoYuGVUkyyV6PKW
1460	payment	1397	1397	1678	1	1	1255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSX7roPefFzhK1V15Dq7AY65kaTvUTWnkLLwKwHLje8BSN2JGD
1461	payment	1397	1397	1678	1	1	1256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VEgBTLMwLowmND2HmmrGCsV1EtxHdgHH11QXsuDGvM59jyUw
1462	payment	1397	1397	1678	1	1	1257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9mbKkcCg8QKcmnjXpTE27k2L5wrEp8q8835MXvLmNjXr3zyr
1463	payment	1397	1397	1678	1	1	1258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBtniCs5WCZuZa6KmRmUC87UQUsSKBENB9rCMwiHeUFvarhnA
1464	payment	1397	1397	1678	1	1	1259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkPSvTWvW9LWnudx7QPaDgdwNDb1dSyXQURCqs6aU14mKcUgg
1465	payment	1397	1397	1678	1	1	1260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkj1K8VSUzT5jr6cBfnZQvQQv6nr15jJqa4HPWiN6ZoZjP35j
1466	payment	1397	1397	1678	1	1	1261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjeqEvD51DVJGesBTX8GS8GPdAamDEsCMLDd1dCeXg8ZdXwGT
1467	payment	1397	1397	1678	1	1	1262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnuhMfjwDJ9ZB2qxQhhsA7pYCJ6zpUzBdCV71yDeCp9Bm3UzN
1468	payment	1397	1397	1678	1	1	1263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUwK2u8uyXQGAZxANzYCY7i3k1S1mWYHFNQcr6HYh3EK3gwS8
1469	payment	1397	1397	1678	1	1	1264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2ruRrhwJuNk2p4gLgkxw5NZZXSrH8qU96wwfou72M6Zkq3Uc
1470	payment	1397	1397	1678	1	1	1265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKA7hCGsYYYYmE8A1cdQXbJF5KVKp6ubuFmbvitQK9R6rcGN8g
1471	payment	1397	1397	1678	1	1	1266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh8iuFF26PXuWdMmsXGHSvuyHaciZ5TUSbwVS8UJ2u3H3ekWP
1472	payment	1397	1397	1678	1	1	1267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgEb7bzrmvpyg2gcZpHbxPgLZEqbpZzcVLRJXLfEZQLD5GLZC
1473	payment	1397	1397	1678	1	1	1268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1r751mDuqAbePgb1LQS1rza5p4wqyeJh8Z1gu76Z7QehBvpUt
1474	payment	1397	1397	1678	1	1	1269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNz8wKchDp9gXJ14ErvRuVn3y22x4jmwzqJ1iya1XWhyHkHTJ
1475	payment	1397	1397	1678	1	1	1270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC51kdUktGV4kvTbuVmafQKUaXrrKgNWMf77H5sMvAQxD4GxXF
1476	payment	1397	1397	1678	1	1	1271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWe2yHd66zWDXbWsYjpuAocYwcB1j1xfktLTTBXDoR81Rxu9Vi
1477	payment	1397	1397	1678	1	1	1272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiTMiabuycF1MHh3oNFfpp4dGswcCwrSHgtvikZ9qW5BqndSg
1482	payment	1397	1397	1678	1	1	1277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63wt1r4WnjHGFDWdwENf2XDvu6t6D5EygUP7udvHeEc8bg1Dj
1483	payment	1397	1397	1678	1	1	1278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNBKNnQH8t5J7R1bhJAyQAQkEQKWyFgsyqKn61EZ5wTe3PEye
1487	payment	1397	1397	1678	1	1	1282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnFa6p7TzHuuETJjnfgiFhFY4Cy7Z3a5dYbf8xUSCVzcWcTyR
1493	payment	1397	1397	1678	1	1	1286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEGWTG6ncJ5cGCd8ywGn8pQNicJ11kyNCSX8r779Fa5hBSTEZ
1496	payment	1397	1397	1678	1	1	1289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY45g36oRksFGqCav2C4wgTViJn9ktUdCsPxHmnetiFdwUeHu
1502	payment	1397	1397	1678	1	1	1293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJPb8npbcrVK283ZmwKzbdQ9aBrHXpiuqFFkPYDyNvvQGL8p1
1503	payment	1397	1397	1678	1	1	1294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLBPFuq4SpXVr4hCJMztk7NvDTyEtmUFthVrBnutYMBG7BwKm
1506	payment	1397	1397	1678	1	1	1297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2YMeJas9w5ragFuxKFjSzfyFbbnUQA3iVQbUc9viZy9jgpMA
1507	payment	1397	1397	1678	1	1	1298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5h1EpBbTAmMmCmyovu1ySpzwypwJniBbuTr4NRhQQZfRuqHC
1508	payment	1397	1397	1678	1	1	1299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeeQGZ7N17mZ2xvCQhNwYQvBsR4LeYAsYNWRVrjYykPngUrAJ
1509	payment	1397	1397	1678	1	1	1300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9GZDsTGdAN7bzzcLDzEHUSRQtiMGmQSCm5oo2JWcxDY5d9bH
1514	payment	1397	1397	1678	1	1	1305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhpHKm8m65r9kV6U2PmtGA6bdM96jvuqxaZPRGprpaqirq2jf
1516	payment	1397	1397	1678	1	1	1307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABScmjuoEpFgdLceqmaKbNbxwzEvPwoKNKf1chgSMy75ZeDM7
1517	payment	1397	1397	1678	1	1	1308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofpX31mZ1kuFWZygDpvW57Cd619b3x5qv2FoGcJ6ptgE1NMpF
1519	payment	1397	1397	1678	1	1	1310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJB5MT3B84hmJrd93qE9YnRrf4CfHQuUeoj3Xo5Mtwct1sbzgA
1522	payment	1397	1397	1678	1	1	1313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgu2FxfRzymAoXcfLUR6q67BrQmqj91FAyR6Gp3jPYvRbU4FR
1529	payment	1397	1397	1678	1	1	1320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7A3GdatU2sNb4JF7vaGQBjoT3MsusctfjaELENycM82DeywL
1530	payment	1397	1397	1678	1	1	1321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYy4nqCQgjibDqLqfgq2TghNorPKxBKCzohg4RczpQbXLCWd4o
1535	payment	1397	1397	1678	1	1	1326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXxrpRfPCmFCv6FxZJDFLHDynSKWouBmD4igQXPYPMyKkHQeZ
1539	payment	1397	1397	1678	1	1	1330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyAjoWUQovKgz6AqrSbpyJPjzERy17whhyFmC5BeQw2fZg6ix
1545	payment	1397	1397	1678	1	1	1336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejdTHgWD8mEV95zf4GgUoskjQQR549D4PuKYhfT7f24Xq5hYq
1546	payment	1397	1397	1678	1	1	1337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6puDpmrmMtCrWVF27F4VLFtP2xe2Mj7agv6JxmASr7qvFtoF
1549	payment	1397	1397	1678	1	1	1340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kZfNRhhyygGZzAMJp99nR716XFCRRQyrmnQXgjZyVipTFnp6
1550	payment	1397	1397	1678	1	1	1341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgS1A8r3pEt5JEwLDYNZvgM8keDQ7Ng7apVVZ9V6dzBLidnts
1551	payment	1397	1397	1678	1	1	1342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8jbdweJibDNCR1X8pc5opzbxa8TbMarBLAJ3cAaY6wwCe1Aa
1561	payment	1397	1397	1678	1	1	1352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCnkEp3diMNJKU8die5euR7dnMshYvSVPBKa5nic5hTWz8mDu
1562	payment	1397	1397	1678	1	1	1353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ69B8QwttESjaqWpr9MvNF93uqSTpL47asYbTigcmiRTwReJ
1572	payment	1397	1397	1678	1	1	1361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ytAhJrh8h84uWT5mPEpcwihQWKaVjLHfdCofr91HghyqXf4t
1578	payment	1397	1397	1678	1	1	1367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNy5h4H9REbHjax32X1SbUpwgbhpptxUMbofT3KFvGNkADgud
1579	payment	1397	1397	1678	1	1	1368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2nSkT7HYDbsMRJZn3t1vyJTv8q8x485uR27mrUJGHZdHtUwZ
1583	payment	1397	1397	1678	1	1	1372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrq3WcnSYfGCGX72s75BuMjMxs6KkHtwBxqTvKmeq22kZnHWnM
1584	payment	1397	1397	1678	1	1	1373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQMj5g7jyykbvFtAwWc3SHPUassZuB29tAEUH2uoQ1fFa5zvB
1588	payment	1397	1397	1678	1	1	1377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL92G1yCg2TvE8P8DNKViBTyYVhXZix9zrB6QT9MP2Ft6sp92
1589	payment	1397	1397	1678	1	1	1378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi87fnMUhvXfYvQgk2RoMpFPNFTPuJ3BNbfCxnFNKSzxH49u7B
1595	payment	1397	1397	1678	1	1	1384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizYoatnMZQcdM1396urTbaBEtnK79wUjWqX2FNAT7kVaobcNU
1596	payment	1397	1397	1678	1	1	1385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymu4Uo8uUKkjU2SuJuCTCnGEtmPY3hwLenMpq74YNZCNmuYkG
1599	payment	1397	1397	1678	1	1	1388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKo6tkmEa6tEmYpt7rxoi6qbPgQt7z1URYZStwfvDn8LA94hEt
1478	payment	1397	1397	1678	1	1	1273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswu4WNtx32ERA5d5pW9AYnJVF7ytqumZALUpnwiK4ukTT3gXX
1480	payment	1397	1397	1678	1	1	1275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYsPDtbPh4uPJCugr3KFjjcghyRMeKNj6VNuWM4Lg9Qbo6Jpr
1486	payment	1397	1397	1678	1	1	1281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVFzvGqw5qNa8vo9usEYPjb49UfSnxTAC9koqYAZPWLw48dau
1489	delegation	1735	1735	1401	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmaqqMjLhatQVNTzWhtwTeju93vVPWemfAYYusgMund2ms1US
1490	delegation	1735	1735	1401	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cXSGCfmW3DbLxYZtUHo6REGwU8zFuJrjJn3vb7f6KaBLWEHU
1491	payment	1397	1397	1678	1	1	1284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpChDMBYytBrcMKXmZPQHb4T6ZaYhEbME8zzUinRqX7FNGgsYx
1492	payment	1397	1397	1678	1	1	1285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxytu225PHaN2eDChdgPqXSKYunTxLrU9aWN5Yq1Tn5EqSnWiE
1495	payment	1397	1397	1678	1	1	1288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpQ7uRd4cJ1mzPQMBLPNkviwucdGDbW77yWC9eYWAZe3edeJo
1497	delegation	1735	1735	1401	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLXmdZKiXrdqhSg7ofcWsZKDzCgzETESUdCihXEAH9d94EiXq
1498	payment	1397	1397	1678	1	1	1290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNgK44KeLrEBfBSecRb8e28jbuM9prYsHVSf16fH14iN3Hkc42
1499	payment	1397	1397	1678	1	1	1291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4APJzkL4mPDFGhu94sFvTP3ugfLvABGsGuMxFnzeJe2LYBjq
1505	payment	1397	1397	1678	1	1	1296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgtKQ5PgjQiHuuS7BxNjadteoyGGUBZCegLDSEKq37w5ugJzJ
1510	payment	1397	1397	1678	1	1	1301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh75fec3Y8H36717vzCxsnA2aaEnGY15NcmJJ2pB7gg4FDSp5K
1511	payment	1397	1397	1678	1	1	1302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5AE3TR7ZueHL8yC6QPwZ4NH79V6V5CuRZjygTjs8Wra3Di8y
1513	payment	1397	1397	1678	1	1	1304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfoY6BsP4ikqAN4LnzoTwnBafgW5CfujHr7gHEp7WNo7x7hvB
1515	payment	1397	1397	1678	1	1	1306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Z7fkYsg1ZPP2ZmgApJL82yLwYGA7RE2Fy7vJqotr7N3arS4q
1518	payment	1397	1397	1678	1	1	1309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT1oU9fY3LVv5azAM2J3LiLr2XT8t7RCVyXaYBmAHCF4sq4tn
1523	payment	1397	1397	1678	1	1	1314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRJwvUvz5dBviHLQFdDfvZseq8wkhUUwp3vDipJetUGyadUWU
1526	payment	1397	1397	1678	1	1	1317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GiL8M267TMLeWR59tS2Q3zREM3VWXS8LxuCqATz6VFLTdKoC
1527	payment	1397	1397	1678	1	1	1318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDGHXz9r559Wt6qpfSCXcMssvRqunzVToL8nZKHsfPpHceE4S
1531	payment	1397	1397	1678	1	1	1322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZDkr3V5B6JqNh42DQAy8YcY7BpCLsjcR746ZefUX4ZTzU2FM
1532	payment	1397	1397	1678	1	1	1323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZqAdzZwed6FQc5bSjp1derdDeSy1fsgfY7gABmK15fYo5ivK
1533	payment	1397	1397	1678	1	1	1324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQUu8mTb3uTK8tm8o2wTe9fykXcyP689jVn47YcKUqEzAAbiB
1534	payment	1397	1397	1678	1	1	1325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMqnmRQmcUDTbgNVYvE5giTo2rUYydft88jXhmywnjEKAuizJ
1537	payment	1397	1397	1678	1	1	1328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecikMQLKfVmKhQcECxmWxTqJBwMzq1a6vhrYTnuH7t5BgvSCJ
1543	payment	1397	1397	1678	1	1	1334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKv8y571e3A7HcLA6miK6xK6JKqAfdDVLKeaGb5GFoqHnZEuw
1544	payment	1397	1397	1678	1	1	1335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT2jix75X58cvCAWAEdyMByGgENqbvwcH7EHEJTPDMJrCgRnc
1548	payment	1397	1397	1678	1	1	1339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqnRinBpqUHzt7RT7U8Egi6YW7jbsa3ig7W52BTAvqa1tDpqo
1557	payment	1397	1397	1678	1	1	1348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgSxWYxwQzRD9gmfW3psidTirEv3zFFf4NJrVnrDoZZcFKQcd
1558	payment	1397	1397	1678	1	1	1349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuBcGKac5PjJkLpNZDZ59d9zMPrUXTE1n7yY7kp1Py3F5eN12a
1559	payment	1397	1397	1678	1	1	1350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwnWN58ZKSo6DD7AWjYKpqykrE9ikRxmj4UQgFsYsDnAVgPqb
1563	payment	1397	1397	1678	1	1	1354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgeVSH9uJBU5Sm1ZMsRuBmJ7qPKGcw27n7jxrSN7ZeK2CpN8w
1567	payment	1397	1397	1678	1	1	1357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtMdZxk5ox71qm4YjK9AHJKZyTTMDocCyo9XTzvYDaU59qKyV
1574	payment	1397	1397	1678	1	1	1363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXgiPPteAR2gypCiwAGcjH9YBPCyKtfX6XhZ994TQT5wSF6GW
1575	payment	1397	1397	1678	1	1	1364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6gXV3V83fysKnSdZGiXQSDzExuJ5GKYXY2oepXKzbNzMM6nJ
1576	payment	1397	1397	1678	1	1	1365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiC9rwijdtzpPLGDaQbmo5ryyXFN9fyXhcAVsq7NRYCFpbmDif
1580	payment	1397	1397	1678	1	1	1369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4ofDYVQnTD1cFandeFsxWFithXZNfVXm1Yue5JVpiZVtqxqu
1581	payment	1397	1397	1678	1	1	1370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3wtYf2q3HisUMdn6a27CsJee6scXFyaQwV7siBJXXtewh5dU
1479	payment	1397	1397	1678	1	1	1274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvNdcKTstEHyMaeLH6ZD8w87p7SbH7gyStCNuy3k14vvuEdjG
1481	payment	1397	1397	1678	1	1	1276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkuvJhuQ7cSMZ5ZnTMsvEPRRtsA2gYj9i9YiFdWpqEgCBEogL
1484	payment	1397	1397	1678	1	1	1279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1V6t7GbvscD139z6p5DdS11MXpPLFMh5UQUWQxYjZmJtjVnw
1485	payment	1397	1397	1678	1	1	1280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7QAQkuhErvPr8RJi32aFhK7F7CqS1iu7ggBHWpzNXVhkf6xM
1488	payment	1397	1397	1678	1	1	1283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmRNaWgqtWqPCP813kxUpQrW7ir8t19SHztqzM66GnbGC6isV
1494	payment	1397	1397	1678	1	1	1287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzZwehqMc8CghtHRQ13nDnLHfskE6BYAoMQuUVS1hFcG8JLGG
1500	payment	1397	1397	1678	1	1	1292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpgMKGr3VgXhfmu9y41u3S3dorfitTA6hfCfF3mMNWQw7NYNy
1501	payment	1268	1268	1754	1	1	0	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKrgrigkm3dAi2Zk2p8XuVhBGWJD4GfRSqTxcr2Qgj7qKEuhf
1504	payment	1397	1397	1678	1	1	1295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbn3VUtkA93SXJb8YkPSpxhQ8FCB5FgLnc5hgnijGimC9xBveU
1512	payment	1397	1397	1678	1	1	1303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurh3qTtw3rskZEJHcT6Uwa7u6xVheZdsNzxX7qbPa151Sk8rR
1520	payment	1397	1397	1678	1	1	1311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSAjjUsXgFuFXgdX4tJedU9zMgEgbCrkR2LggoW1GKTZb2dNH
1521	payment	1397	1397	1678	1	1	1312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFEozu9rtm9ytT7kP7iMXKY3x3KfzWHWRbHJrhMR3JMFr53A9
1524	payment	1397	1397	1678	1	1	1315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XsgLpxVaqdW6Eg9KMww5ZxAPyLzPeYiZswK525QFQbBEky3i
1525	payment	1397	1397	1678	1	1	1316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjYZg3ps9rXegdvaBiBM4ZPVHwE81jiJ2QZ1cF4ekE4jTqt9F
1528	payment	1397	1397	1678	1	1	1319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZJE8trnCVfSwngHSabQpbtjxiEjbGhaYWLZ8M3A2QyXveqr6
1536	payment	1397	1397	1678	1	1	1327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nhQ3yMjAuRxdZwQFoeoLm2s8pWbbCS48nMvCSMf5zwYzjcXb
1538	payment	1397	1397	1678	1	1	1329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKQ1aGa5A1kbRdQzjeNb2VTbWGQehAFL29iMo37dJ7NDrc39Z
1540	payment	1397	1397	1678	1	1	1331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1nVKxw1Y7ysxdwT1v3G1t1ar3jkaMareBurBJ6wCoptfH7UU
1541	payment	1397	1397	1678	1	1	1332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zR51PrBWnQ8ZLfNmtZgFx9UbniL4YC1qNWfTCvbiQR7Pqv4p
1542	payment	1397	1397	1678	1	1	1333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhB2Y81FEAvy21H4RN8KgBR4aRv4x6oEvc7eyAmyoqJMrPmQG
1547	payment	1397	1397	1678	1	1	1338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkPcFtt4HuDrx6dw2AQxiGhvGkmrQN5mNttkmhAc6rAHFmmKF
1552	payment	1397	1397	1678	1	1	1343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBGnkakp4Nm88Y7AiKCJpsy5oRr3WT4d6hTYfe46FLYXB2ANC
1553	payment	1397	1397	1678	1	1	1344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotUq7T6Jw24TAvD3sxcxRpbLzWmjxMxV2vtWZWPmcvjkRsRLt
1554	payment	1397	1397	1678	1	1	1345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnb8315WvdDQkz2iLQ69tA8Cc82DXTpzKur7S4VS9s4grsd9BB
1555	payment	1397	1397	1678	1	1	1346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9cF2QHX3o3L92wCPqi3rBFZtFzyFo4rsXjmxVXaz6v2VVZ2J
1556	payment	1397	1397	1678	1	1	1347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4YZVonsy1HGDQ8nLyhDw12UF1XDnYtvKobrYBvA9T1ye2GJh
1560	payment	1397	1397	1678	1	1	1351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmmeRuAHnXLg1Ujm37pAZPVmwZ49neBvYx4iqX9QXeDz8vqfU
1564	payment	1516	1516	1756	1	1	0	6480140000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrrqvXWWjd8dkdz7NUmRoewpHSDU3nAtpwrqu6Y8KfMvh3whK
1565	payment	1397	1397	1678	1	1	1355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheXFkzi2rieWZxKtYdrzPp9vbRsaxyKtwTERjFe9FXj5RbXRm
1566	payment	1397	1397	1678	1	1	1356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Mjeht1LdYMwSRJHHoXp6fwUKwqLHjvzj85nA8gLsAYo68xqV
1568	payment	1397	1397	1678	1	1	1358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYpmMz6GzonZ71ytEBqLMAPgW7SFLLsMUSqTHCnxJJoABa9JU
1569	payment	1397	1397	1678	1	1	1359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpUHvEYvuazsRTBi6fhAMpXsiRmgkhpAF25pQSdou4iwL3Yrb
1570	payment	1397	1397	1678	1	1	1360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyErb1zYhYuFCsbN7ADFKm8DiEcFjyqXMDDn2nRvfjyVsybk3
1571	delegation	1756	1756	1516	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8gQZx9gZvKJNtnCDCUn3eQRJiddWo4QM32XUVGBZgnmUehid
1573	payment	1397	1397	1678	1	1	1362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjGUyBm52xGwm68ZsyYAnq3QtwSDFx9GcN82yb8RDmPDUw9Sv
1577	payment	1397	1397	1678	1	1	1366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLghHQvw5bEDWHpgY1TWZdChQoxTTTr9fHEwk1HnUXKaDQ1GgC
1585	payment	1397	1397	1678	1	1	1374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDphiiCDfxSD7WqVq3bugHaJgh5NfD83Qu6jWerJC9f9KoDve
1586	payment	1397	1397	1678	1	1	1375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxAmy1ncrpDXJK5re6wmoMFwvXb8jVqZdSWTuf7r1zKiDpNXK
1582	payment	1397	1397	1678	1	1	1371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaLFaTs3fBm3L1Csk1DkzVExteCoEfL62hNt36bjuVYnZDc9v
1587	payment	1397	1397	1678	1	1	1376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTYaDNa2NJdhvZDPHJKgAjX4jLqSyecHLhUvPXdWnKVXhz4zP
1591	payment	1397	1397	1678	1	1	1380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzTkvW6sVo7DNyzw7xoBapJg4CPkiU6Abvn9KE7ZT83GMDE2s
1593	payment	1397	1397	1678	1	1	1382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVX6Z9jTMkiwNtPGk7KocKFCgCNcF5rjDuRsi1XvJW2hXgrcDA
1597	payment	1397	1397	1678	1	1	1386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNxj7iEKZzQNaUGCcxkq1wn8rJhXxJK2wWfr3NZyC8oraB1Lz
1598	payment	1397	1397	1678	1	1	1387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1YFsFKSeDsLJkcqPuUyxQjpNjRtMLrZpTG3QXztQ274VUawE
1605	payment	1397	1397	1678	1	1	1394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNYgS4yv81d3wCiDP8GbobD6agvC2e8SamapQfHj6qthtLvQj
1608	payment	1397	1397	1678	1	1	1397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZTf4TSfKqHvEqbZA3UerDVf5motdGQFMBwiUgp7yVZYAKyS3
1609	payment	1397	1397	1678	1	1	1398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog7zA8F7VrJFLoFY9ijKFVBycbH7hYdUco6XzQ6F1Asa5Pbau
1610	payment	1397	1397	1678	1	1	1399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNfy3m3hqcx3qhbNqvcHuG6tCQWgAnLakz5c2E2ez1sc9NhCm
1618	payment	1397	1397	1678	1	1	1407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmjeyFCPfZ5onzZR5aMPbLgBXXvdb5FzhzR5PRudGJLi63GZa
1627	payment	1397	1397	1678	1	1	1416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHhgwNTqhJ4n8MU5MoiE2FbFuJFZXRnBm3ywKXLCwfNQKTmRk
1631	payment	1397	1397	1678	1	1	1420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJei1aDiaY3m81KgxcUu4cMJrEw4cdi4LB8SWuxwvyZZDGUrV
1632	payment	1397	1397	1678	1	1	1421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQKFBfcsxffLj9U9HKZ82cHL6iosVMayGzYz4paeCeKZFmwbH
1590	payment	1397	1397	1678	1	1	1379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEV8RxreX8mMUn3fiZg1YJo6o3MRL39jxzvHLfvaQe9qgDUUaA
1592	payment	1397	1397	1678	1	1	1381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eG5BzTbuFNf68qDstKERKfnKMaBjHixMBrnDhhKmz1g8NsDS
1594	payment	1397	1397	1678	1	1	1383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAnQr1Y6yEyboQ33TjYsL97MfyhiTrHy3ccfyVjdfgmDRPRVj
1600	payment	1397	1397	1678	1	1	1389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZityGF3CSpTG7hhkXXeRetpaZJyjt9ik8FBrwX1ZAFBjieUntQ
1604	payment	1397	1397	1678	1	1	1393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYQs8oXvpkcRJB5mgdKAx21i6XumfKauCGfX5HkXkirQbbTPe
1611	payment	1397	1397	1678	1	1	1400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF21MSSGMbKXpwjnC1xPvByZgfsUhrvwmbR8U25afwQhnD6WN
1612	payment	1397	1397	1678	1	1	1401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcWQn4ueiiXtiSbCNXvvc4f7KBJ676uNMMCAF92HZJrczZQit
1614	payment	1397	1397	1678	1	1	1403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwBzg9kkq2T3JRQsmquzA6LZwh7gfAmXpLUbVq9XHUGgL4hST
1620	payment	1397	1397	1678	1	1	1409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDum9oaysS5EYNqdpTr6fppzKc2J2N8ZRfo4GiEtcdfozWi7w
1623	payment	1397	1397	1678	1	1	1412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwDNAEa7LvrZRhZ9rLWYhexKYR1hYpateyghh4xe1Yd85e8w4
1601	payment	1397	1397	1678	1	1	1390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTF3R1pMPDrGD3XavcBuqDUvZHNcZR3dVsza2dTe2uLEM3Ptmv
1602	payment	1397	1397	1678	1	1	1391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniSsKAzWJgit7tr8ViwSYheUD2oHA24BzHkse76QmiQaRaAj4
1603	payment	1397	1397	1678	1	1	1392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3fg19vKfxXZ9BtxvNheE22tLzMBqe87bwzTfa3qbLNL1Cqz1
1606	payment	1397	1397	1678	1	1	1395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGBtEnbHUGwxjpitUw5DLqRdAXubbYC2iA9eQxa6M18Xrok2R
1607	payment	1397	1397	1678	1	1	1396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaiTEtieLxAqXy6xcuRYrbHdoqA3ck8CPV5JT9ATL3zB6xGrM
1613	payment	1397	1397	1678	1	1	1402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTJUkVZCdLNeabMvcVxwfz8schoTvgz7MZdFzhx6e9nDj3Mdp
1615	payment	1397	1397	1678	1	1	1404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPxNfQ4YUM4YuL4qLVKXi82FwtpjD6Wvttb39UAyoWCVY56DC
1616	payment	1397	1397	1678	1	1	1405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviGG1Dy38r78t1CadauVGY7SbuxGSgmaLZpZWEbGE4Uj9mmiR
1617	payment	1397	1397	1678	1	1	1406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMe7grrezy39KBSL7tfCih57iaEBxyfHntT2WKo1B3woTXatNK
1619	payment	1397	1397	1678	1	1	1408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEwVZsBQ9FLtaZwuUGRt67AM53KvV3hNN8VJonyZ8tTY6cm2S
1621	payment	1397	1397	1678	1	1	1410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk39WEX5Nx34ARx9oqkHc8vgsioLtMtwB2MHuTcojRhzMDRBs
1622	payment	1397	1397	1678	1	1	1411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3EyJxZaiog4PfUdF5jUUMaFUSmHdsehNgGm3qgr1w5jAHLGZ
1624	payment	1397	1397	1678	1	1	1413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrW7zWqEtnpTeTYLpNxcWDKKZw92PgzQeJgHzZ7cALn88h4BD6
1625	payment	1397	1397	1678	1	1	1414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhazxkNsPSms5QBhQCJCkhXGCXX3t16GJwgKzcLB6WiwP6Qfnh
1626	payment	1397	1397	1678	1	1	1415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdY8LRAkmxu4jFYDvT33CDgBAiwmm212yfgpgzL1ckgabBxGhM
1628	payment	1397	1397	1678	1	1	1417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8a2QhVX23SHikTdqYVzHz5bVGSfx76KVKqP1rHa79qaiTrim
1629	payment	1397	1397	1678	1	1	1418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmn62kmAa29VauiVmaiT1fctKJmrNB6z59RSKpNfVe8Ut7mJv
1630	payment	1397	1397	1678	1	1	1419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtat12FraUQKrEfCFTNFwvS3N4DBDgdJLGJJ6upw2Xx6BrmfR
1633	payment	1397	1397	1678	1	1	1422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDiVDChyzSbUenmEndV8aijfnKeWGNQXYoYtVCPEa6qKXTMSC
1634	payment	1397	1397	1678	1	1	1423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NJzxGgDHyCixjwNA6gvwLZ95Ux1ssQydiQm6WpfohnRviJKF
1635	payment	1397	1397	1678	1	1	1424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4ot4LGB4m28RjpXk3nm1VeZwRfiY6bdsijVGrXu74Fm6SSyp
1636	payment	1693	1693	165	1	1	116	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYhrvBuZp6AxSKYppmLEPiEriPjGtob6xTBDUg7F2ejDZQ8anBc
1637	payment	1397	1397	1678	1	1	1425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSzYnTzucP9XP6MkJ7XQY7bJdLVWoU96kT979wW2um98v9YEH
1638	payment	1397	1397	1678	1	1	1426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNXvWbkhFrkwuYoJCPAFbutUf8Hgc2idrVAFzMTVQeMxJef2E
1639	payment	1397	1397	1678	1	1	1427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgxhzis9MXHPsQC63PDFJEm5Mq8H6PMfKXDU9P9pEo2vxbAxf
1640	payment	1397	1397	1678	1	1	1428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kLrZ62Xaieovg8KSrVidvYw12ZDGjNhBr8vAMJAWtjHCz8bc
1641	delegation	165	165	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiw82bDb7s8Az5i6i4rGfJYucg2mSuowZuSStnAD1iJesQSgqJ
1642	payment	1397	1397	1678	1	1	1429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzgPhJfjmHckFJ2Z5xfhT9ddRHDti2WaA9Q7dsERao2nvS29U
1643	payment	1397	1397	1678	1	1	1430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFJPqsi4hgYdbJxYcdbzZFUTc8h4fjaMgdbtqx7NAybnx7m4w
1644	payment	1397	1397	1678	1	1	1431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtW5FaYedHHX1iLjF4Lf4HAVdg17zasvVypuvmvEeXtpYoyoh1
1645	payment	1397	1397	1678	1	1	1432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQM7YBkVWAaEUJ5fLrRRaFjBLmMnwzoKpBXrg6uckoCk3Kv9n
1646	payment	1397	1397	1678	1	1	1433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPoepkt5FK6vhZchBMhvTRWztzdj2wwJAmJWaHtJAsV8KJMQr
1647	payment	1397	1397	1678	1	1	1434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1f4fkr1xTaMquKxY4BntUzCVWoc2Bux7zwonxqfzHmjjm1Jt
1648	payment	1397	1397	1678	1	1	1435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5WAHLyu5xPZRQUr83tB5rSA6tpiiAPzkQQRJhUqKpSzhaDKQ
1649	payment	1397	1397	1678	1	1	1436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviAiTRoHcf5UMBWFFFAwCPdwsyE51jr5JVZEzEVCMxH7ChVCe
1650	payment	1397	1397	1678	1	1	1437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMxrpQyMWXHFqqFzowjejpH7K2dT7nk5JRDFud1M9SHXtEb4j
1651	payment	1397	1397	1678	1	1	1438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcwyFyVxUQiMp7Ld5mbnsy998CQMTDeLGQ6Xtft67evuisSui
1652	payment	1397	1397	1678	1	1	1439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVz66iw76sMmRyWNXi3E4mzRsKsUBM74a6uvS9ee8WeKN7UFH5
1653	payment	1397	1397	1678	1	1	1440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibCdrnkgDhbVcJF7t3Wkwtg4FERxFuhXyc86KPnuBnQ6QKRmM
1654	payment	1397	1397	1678	1	1	1441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsMxMGjeM6jSWgG9MsUVXr9jpXp1P29UzLcXxJnNBQHwFaSy9
1655	payment	1397	1397	1678	1	1	1442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZnEsXMnQZupGvibAZXaYxQjjW4YLgWUivERr8nHWkLV8vMci
1656	payment	1397	1397	1678	1	1	1443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv1xUZ6cmeYFnDqps5irf2UhSb9FuvFHvYwK88arGxmuYN3Xr
1658	payment	1397	1397	1678	1	1	1445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8vj84koMucMY55XXhWGJ83PiQoSUVwvG164HP6quKvsy33sG
1659	payment	1397	1397	1678	1	1	1446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3aswMDTYLiAFwxeE4i3uV71znXXQ2exvZnZz11mpu5K3TxZk
1664	payment	1397	1397	1678	1	1	1451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7WhHEp24KDMQJ3KEBTBQzWxdDfuPyXjJF6U1cW9j4X3MRo48
1665	payment	1397	1397	1678	1	1	1452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pQNNRNG6tJ3ZpjqoLA8QANsFs1VALwyipbQ3Mdbrpb3abKeh
1666	payment	1397	1397	1678	1	1	1453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjzRgsWA8xdd5BaRwbtinDhAXJYN2EAwQj5SFoTeycfVeUGoP
1668	payment	1397	1397	1678	1	1	1455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbcGnRCP6MLHPJnCoqnqvwsJ9uQ4G9nH9888F6mfqwjgr8C6L
1669	payment	1397	1397	1678	1	1	1456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwbGhx3FxCoedadW2VJgdfWTs9bbd1UYVV6W6YJD9dC4PGk5j
1670	payment	1397	1397	1678	1	1	1457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbT4g9WSiVxEeQouJdq16VoJGTWH7ofMN6pfo1yZ68Pc4h8GzS
1671	payment	1397	1397	1678	1	1	1458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhGXk5oWGDEeoSJo9e2KqPoab65KURaJinWdErLHmJiCr2SBH
1672	payment	1397	1397	1678	1	1	1459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWSWQLSQHbt8jiPdq5k8dTBZiWwqS7gDDqNsz87swv73jHLVy
1673	payment	1397	1397	1678	1	1	1460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4jvNszjWdfiJ3MtQsRo274z4r7bj9V24wwAyragsKmFyv5dF
1677	payment	1397	1397	1678	1	1	1464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWsnZGwwzXdqBnrtYkZbWVbKQwm7PMxTCKgQaFA6f3gLtBffJ
1685	payment	1397	1397	1678	1	1	1472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmDPypbdpk5jqeAnPArC5k2NxqeePgdkEBF49EQm5sSpmJGj7
1686	payment	1397	1397	1678	1	1	1473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsLRTEUdSvBHSb5M5aZKjq7fpbfFQG2SWQBTb2UawrTTVodLa
1689	payment	1397	1397	1678	1	1	1476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVANb1DK1hECuR6ejqQMRTtdx3pu18Dg1tiexhH9WdFM832Cog
1691	payment	1397	1397	1678	1	1	1478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5d7vcwSTqrHFRPXbwX9CedcqgyXbyzTEFsUSXjMsWHzwjffVs
1694	payment	1397	1397	1678	1	1	1481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqtoaTCXR5WsWVm8doLAvog11NNkyxCmoB6Xbht5GyBuWEMzm
1697	payment	1397	1397	1678	1	1	1484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tkpUFgQN8ALaLeASbfzo35KV6pKA6vh2mWnRg1JdAGD22xP5
1698	payment	1397	1397	1678	1	1	1485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHZfa1kV99uYzYWM16qjDm9BDCA2MqZJmKQfTytWMg9Keehpe
1699	payment	1397	1397	1678	1	1	1486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxutMhJmA1B3r4Wbyerfk9pjgr3w5Tmo1bgfCZ5ZKnAfk61Ge2
1700	payment	1397	1397	1678	1	1	1487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82hxhndnDQ9PM2iXguE34U3xc9D9rnkjoQkgKPVcTzeV7iKLF
1701	payment	1397	1397	1678	1	1	1488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eKofZMAUkowv3pHVRAd1GhBdCTKwTpuR5ZdE7zuwg63w4Fhx
1704	payment	1397	1397	1678	1	1	1491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fZWqzKZtadEv1azh9XqACBYusZoqmNpHKj3ssVYHdgMAHati
1705	payment	1397	1397	1678	1	1	1492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZxpW79qFUMYLKrgFsUJ1pJZtY4jUUTjagDTeXJTsw1fZ6Luk
1706	payment	1397	1397	1678	1	1	1493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqwh4yuDQrGotg53zkLyNCJPvAhK6vcVpP6UnYN4Mq8wjG2sC
1708	payment	1397	1397	1678	1	1	1495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKA5tzx1aiBFXX8GxmcwwhBVxuxgenWkDYb5MoiaeFNk4Yhjz
1709	payment	1397	1397	1678	1	1	1496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUYbMS91WDxvyxuDfsnZ4PHijGcLiwA8DieSPb3kw9tWwuajU
1710	payment	1397	1397	1678	1	1	1497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYza84Ec8iuDa5Z4qeHFAe9uWAfrmQW3in6jGYRs2qWzFTF99BM
1718	payment	1397	1397	1678	1	1	1505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y2AaEDQgSAqAy2A1mYLREKwXx1LEweHoyVR4swYVD2a4iqg2
1723	payment	1397	1397	1678	1	1	1510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCW4ttd6pGQxYumX9iL3frg4CZm6KmNtZfawGKT23xK9NUSi3
1724	payment	1397	1397	1678	1	1	1511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVfo2DcdsZwxJZYo2isWYez3EMyB9X7qoZgFbxAQn8YXRbmvw
1730	payment	1397	1397	1678	1	1	1517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZ8FL3x3tuQXeF2NRWroYuvsDy3n2GduBWoLE4xwttS99UKbF
1731	payment	1397	1397	1678	1	1	1518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSp6aaujjbhcc1cGWZhdErjA2fvJXMduD18QBkQa9me1DQ8rc
1732	payment	1397	1397	1678	1	1	1519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYmKT2r9vxyBq4xbD3E78H35EZSUcofZyvKMfa6U7NkoYsETh
1657	payment	1397	1397	1678	1	1	1444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CZwciJZocGY7pEF2RkcUDUQbBYe8DjmeUNTkgwuLADaBsFXW
1661	payment	1397	1397	1678	1	1	1448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DrvoYNmbqhwu6FhgHnoGspMm1cN7fvN8C5sfWYbdVR5ray7W
1667	payment	1397	1397	1678	1	1	1454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZer1GYC9uVtWoH69LCvg8We9TMFjV7wS3fB8dkyMjCFLxPPvyf
1679	payment	1397	1397	1678	1	1	1466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsuB8XcDd5zuW8XFF1Ap7ACiW1fjNPy7huVaza4mVzEp9L23R
1683	payment	1397	1397	1678	1	1	1470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuijNdgq9ehPB3tmCyeJTUsGHPEaYRMDTLG96R3zNu5qtKr9M
1684	payment	1397	1397	1678	1	1	1471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rZie6cnNCQ2LHyT2XSLiz2dXSLtkGDFpr51GLBEzEQQWVtff
1687	payment	1397	1397	1678	1	1	1474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYshKq3JrSm7NoHoXBZ8QZSNrskJzUqEHzoxQ6bNVEvLxVxep
1690	payment	1397	1397	1678	1	1	1477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXMxj4LGeCh5Q3ps6HMu96UmbCSY3SNF2mm6QgBiBRDiD6Bu9
1692	payment	1397	1397	1678	1	1	1479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpDv976APHn4kZKBLKtL6gEyNvJqYS7FBAVouQQHwnN1NrPfG
1693	payment	1397	1397	1678	1	1	1480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR8i1LtMjzQr8D1yYm6qye2su5urdwDKnLhaTLh1tCWLgadZF
1695	payment	1397	1397	1678	1	1	1482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPPWBkzNmmfHXZwxtS6b2G7BLkTaonsDXhz8KgLexaZuzBjan
1703	payment	1397	1397	1678	1	1	1490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5hsoTbYrYVxKCmSNkYaJAfcwJpYs28kuj8qJP3nviBQZYwEY
1719	payment	1397	1397	1678	1	1	1506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXYMHMVtNioo4JT8cUPGPHKK56DoRi3KVsAe45ja8KR7TTGVQ
1720	payment	1397	1397	1678	1	1	1507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkFakqz7o9gq4XBE8WSbpNHQ3zRFEbSREZaY5jRW8uB3TDiuv
1721	payment	1397	1397	1678	1	1	1508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBgnXqdAJy2WnAHv8LbFuxprtXzF6ixMUQWafbkAceQaQHMbh
1722	payment	1397	1397	1678	1	1	1509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySsfybfL2Rz8tNNKEdB669MN9f4aRXa63qBRtzQDpvvDtTW2T
1736	payment	1397	1397	1678	1	1	1523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4TW4nff4bSdLkRFptFjookbQ8UoZ2edrPoWJhRYppCXF1hjZ
1746	payment	1397	1397	1678	1	1	1533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbJg3Voatg5EHPj3WpWf6LVFpfgBDbdW4kaxK9KiUK6dwCuG1
1747	payment	1397	1397	1678	1	1	1534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrLD7RchsphxML8h4FL8u8b5wWqvMZos6TCqtgK6gXbrWvE7Y
1751	payment	1397	1397	1678	1	1	1538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBeqc5mTLzJxyxqFQbAHSxZ9UN8Cz6BCLo5wfJvRr7HxBqxdV
1752	payment	1397	1397	1678	1	1	1539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqGTiGkXg7rnjzAhdmh7ZX7JEANuhr5Gyo7bJiSuNAt7tgc3B
1765	payment	1397	1397	1678	1	1	1552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxaXnP7gmZc6m9a3dGETEqBvupWhWwP5vXvauueBWrFmdVMBF
1766	payment	1397	1397	1678	1	1	1553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NWiM8BJ467ByqckiZQzEQJRV6NmTGuHmE7RwBRnnEyisNKdp
1771	payment	1397	1397	1678	1	1	1558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBNfcAyH8pNhXYx1WU2ALE2XCnyuAuvZ65w4zfTqm5GdGatsb
1774	payment	1397	1397	1678	1	1	1561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiyiTm2sDEhTFJuNgQqXg9JPNnnW9LUyqyZX2Vsnu5wkfdhuC
1776	payment	1397	1397	1678	1	1	1563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9cbFttCBDcWHpmgb71x4DN74vf6GdDi56r4Lgdwbi4NBubqL
1777	payment	1397	1397	1678	1	1	1564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJTsPtU4uNrhPxVXNwDiPF5jSgzBK8KyNptJXEQN7cddiWh5i
1778	payment	1397	1397	1678	1	1	1565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94bXuxN2dGFvAZUqY2dnUi28wfAJw1F2MgEE7AZRb5wB3CfKY
1779	payment	1397	1397	1678	1	1	1566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHzvpBt8i81L2MUEVbcF5nYxwoCvum74ggS2LjPLchdbwyFU9
1784	payment	1397	1397	1678	1	1	1571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo76LysbrgCoAHCXtkj4oZPii7VuJq6aCF17SXbPw824QpKjau
1790	payment	1397	1397	1678	1	1	1577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwm5UtQahgSF67NXgoksH8ZTyv8WVBMsxVwnC6fPXJY4xNsRCw
1794	payment	1397	1397	1678	1	1	1581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJwe5jGengBnxJkG529UqqSn7RtMEJt41gXo8S8jq6mBXHKC9
1797	payment	1397	1397	1678	1	1	1584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefryshbpo66vHCPLDiasMMQVg9Mv9fMzXWLXFrD2SzQ31fFMo
1799	payment	1397	1397	1678	1	1	1586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnDdjc3xv6eETNXGfnwD9SvB4JC3HVJsPkXXGDFurHX3f6jeV
1800	payment	1397	1397	1678	1	1	1587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRLxCknK57GGG3LMDYDzfFWZTnnjL52UoyZeguTC75tQFkEpr
1804	payment	1397	1397	1678	1	1	1591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bFD8W7S9ujKVeTxP4Q4rd9W6dtbjWwVqhbTifFgnUAzXRyYw
1805	payment	1397	1397	1678	1	1	1592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8qN4bzSLsSVxWSs8dURZrsZJa4j15phb6nWxcxNUGKXKoUfZ
1806	payment	1397	1397	1678	1	1	1593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEDuE5gfTyLD9aPNRKCdjndrFFtE6fTFzo79q7C9gkee3qYvr
1660	payment	1397	1397	1678	1	1	1447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2woAEgXUPvCsVu22WzfPGAm7cJyp2EyDcbKEXxcXeVz1Np7L
1662	payment	1397	1397	1678	1	1	1449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UTpHUcYc7YJ76sMGohNT48nSfdQ7D1kd8R4rNjkgkw7Szv15
1663	payment	1397	1397	1678	1	1	1450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdDxo31aJbmmih1f8jBbYKGximeyWvLRyi3PNFKtt321Z5b3Q
1674	payment	1397	1397	1678	1	1	1461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNdbSREXNRfeeSTLm7WdoEaK9qN2somi91NDAa28XzUX6u4BS
1675	payment	1397	1397	1678	1	1	1462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTeXPXVBCVrXNn5GujypL1JNewRRLqRuaq4cdDJcLv5jb8tVm
1676	payment	1397	1397	1678	1	1	1463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXihSUGNUft6mqup6eSTKFEdkiBX22peDVtzKA6ZRwp6nxwhe
1678	payment	1397	1397	1678	1	1	1465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzd2TKTt1deqacu4z8pCsEvzAfk8pZaZrn4PXjDA9KN2qjqvCX
1680	payment	1397	1397	1678	1	1	1467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJeTEad1tXgG2GbamQAvzxCZyruFSaAxM78VPujpvhkzsYXUz
1681	payment	1397	1397	1678	1	1	1468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtgpBmtiYmRyKkqpAbQ8bPRrKC94zyWWu1w38tbQBoyEHRfrN
1682	payment	1397	1397	1678	1	1	1469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysiuiap3zZuEbPiFEJzaF8xYeRPvHwMvqV8Mh2pzB16xDeHzU
1688	payment	1397	1397	1678	1	1	1475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6Wv3xHwaYtDtvmfwmLkVCxYgRcEcZdzqP5TupfiVHiNwCq8x
1696	payment	1397	1397	1678	1	1	1483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6rw2kwzj4fEVhAjUFdfSxvr2b5hPNTs7MuUMtnjeAj7CyAzn
1702	payment	1397	1397	1678	1	1	1489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XQ1M9L2Y1E5gj6M7h3mXt8DrmsMLzob5TxiscdRG4XV2aFE7
1707	payment	1397	1397	1678	1	1	1494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyS6oNUqdsfY6KH3t7nTzC35Fg1PjcjGdTjZUdx4wgPmo43HDr
1711	payment	1397	1397	1678	1	1	1498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxdUwpr1TVoacDRmXrg9WSyhvBdfgDCaSfg272qGTdT8JGdGe
1712	payment	1397	1397	1678	1	1	1499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MesMwFEa4DGAkf9H17B6Ju9qYT7CGfV8QdVc5NVTn11fuzyc
1713	payment	1397	1397	1678	1	1	1500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtLpVcGGQkt7NPzE2TQ8FmXq4pDSnNDve36J86W1pfZQufbhz
1714	payment	1397	1397	1678	1	1	1501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCArfrQNb4cCqG39shcQkYS4CgHtEkUuX5L6UvWj5CBev3La7G
1715	payment	1397	1397	1678	1	1	1502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv29Nj5pN9DMfCa1cBbPHW7Gu6gaFfXzDTA5AGwuew7mRfPe8G
1716	payment	1397	1397	1678	1	1	1503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7wP537QEbszPsHevRc7uWdQtNNAvcoY9XsurfVPgaKEL5eFA
1717	payment	1397	1397	1678	1	1	1504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddjDS6d413oyr4uNAwHff8sjBfb4XFr6zuXNxXXSchWtBMpE6
1725	payment	1397	1397	1678	1	1	1512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPohmde5TRioNWXftQ769cDWhCdLBDA5oCWGscm2ueVs7wdwAt
1726	payment	1397	1397	1678	1	1	1513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtBqmdFYYe5MwnxuF2owKggxyFyHLwZPBcjfstry4WtSYr3Bw
1727	payment	1397	1397	1678	1	1	1514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySamztZNiYkTrfXHWWTqo8x5H8Qx6NMSefwyRkbYe8Wpk4SGW
1728	payment	1397	1397	1678	1	1	1515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXHVM1aXDG4K4UJ3md9oLhRdqvwv5dsgEQzS6m7TUkYpVyqRu
1729	payment	1397	1397	1678	1	1	1516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxZtzPQAuYPKYs6BppZ3V5rwQwCGnEyWUGyvHEMQwp6uRSWCq
1739	payment	1397	1397	1678	1	1	1526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUqZ4NHLE925kkeurSuoGbLHeDB6vyng9u2qwU7BMCxaFRi35
1740	payment	1397	1397	1678	1	1	1527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRA5dzzX6oy322V6bhhpeNaTHm9eWQEc9tTeybHz45XAMvFa6F
1741	payment	1397	1397	1678	1	1	1528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwJrCwL7gRUWLYjfQWr7x2YGdyJbtPTEnoz2qhrQ74TAuamVi
1743	payment	1397	1397	1678	1	1	1530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kPGw65aG1Fk4kZNMGA5czsmyTZ3CpXwfVq2MFEA3LHENQVSV
1756	payment	1397	1397	1678	1	1	1543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJfSmR5NLja7VdVXAqW98SWCxNixkQvW9xpNds43vny2KTUfE
1757	payment	1397	1397	1678	1	1	1544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SSRoMcuyMX65CytnBse6hjKfw2D79SpgdpAJL7vXQLNzXkm4
1758	payment	1397	1397	1678	1	1	1545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz7VEpMkuQTNoT2q81oAK5rWninkV7DpzAv51s1rfgAkejb5j
1767	payment	1397	1397	1678	1	1	1554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAM8EVRiNYwMSZFh1gjrCRXunDtsDmTe5iYFfMVML9NvAc4er
1768	payment	1397	1397	1678	1	1	1555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tRnapQuFncchRjD55fgomzSKj6BYCqdny9KrGbkZGpLd5aRC
1773	payment	1397	1397	1678	1	1	1560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDobT6gjX1pdci7aCqrRVwLKGNfPQTajdvux57bBLhraGCpnfQ
1787	payment	1397	1397	1678	1	1	1574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQRHEPuQEZwdNMy7e6p3iiHcusd2F3aSPMJBEgJbGqVr98wHQ
1788	payment	1397	1397	1678	1	1	1575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7g2wjcDPCSFYrTFBts2zp77iWaAu6yUagB4MHFVgSTNs2eH2
1733	payment	1397	1397	1678	1	1	1520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYnebdDP9f5nsPvfaZFDhJTXR3gEThfRoP4urRUMrvY4W4Mh6
1734	payment	1397	1397	1678	1	1	1521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SFca6S5Yxbyxs2yzRbwXjbkejPP4b5JeMt7uo1N6ZyDagcgJ
1735	payment	1397	1397	1678	1	1	1522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwEUtsmEB96iU9635hBBSCK6wMq66qV9U5L8G58s9tGXAk6yG
1737	payment	1397	1397	1678	1	1	1524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ8FuNWhwvrtZAAF7fJEa6WgPzUd6K7hZtzqVx4mS3KXtqmuq
1738	payment	1397	1397	1678	1	1	1525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvrTPpyDht5z9ifNvGgjyRrf64wPvAiaP3vDQNLtuyrY8Grgw
1742	payment	1397	1397	1678	1	1	1529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMHFHjd1Sjq7RxPKn7m2SaW7RMJKC44As5BVdQJfK7LETLwqS
1744	payment	1397	1397	1678	1	1	1531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHjsDAjqcQrnH1QMKgVt7kiqiToLUf8rHh3YXfcqRBmAjCes4
1745	payment	1397	1397	1678	1	1	1532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjonz3CLAnmznwNXSSb93Stn8CQWkgrPEDnmnE1kkLidshpDw6
1748	payment	1397	1397	1678	1	1	1535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p7DPozpdkKBs8RnJ1QoXsoswY1fdnEdsTkRqfGnFrZpLSniY
1749	payment	1397	1397	1678	1	1	1536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvdqisixZS9fXbRn5v8oogoAmjYtTGkodh2KiNhMZf3MoNkk7
1750	payment	1397	1397	1678	1	1	1537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTRfM78EYYbkP7yQSxzPb1A9qF1CjrME8qZeCu32WVMJ1u77B
1753	payment	1397	1397	1678	1	1	1540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4mPC4P1fqpNfo1Sa5qoyqPdZv6cHoCmCgQTNaeMUDPdrueE3
1754	payment	1397	1397	1678	1	1	1541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrgXjow9Nn9jZj2aLFfTscD7pBuCoeNCaQtuADTE8fyhxTovp
1755	payment	1397	1397	1678	1	1	1542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvDQpvjcatwx7UhKPpPRBMtJSNYp6CMWECmmxmvXRNCETjXT6
1759	payment	1397	1397	1678	1	1	1546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuxFjPMxXuzHmgyvp1CTUrqt3iMyeQNzgBDdY9Mn1VaXEHErD
1760	payment	1397	1397	1678	1	1	1547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEFCx1bBrzEiND2Qo5yikS2HEKymu5353SURQSZ5HkJWQXEn6
1761	payment	1397	1397	1678	1	1	1548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YgrfC8Dfyxwxt8WtctUhPW3jTUQcyqjhppPb1txNtLM1nxye
1762	payment	1397	1397	1678	1	1	1549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYievMTeE1dj9dQbUK1947yWEFfwZzpfDKH2FCH2D2jU5RitQYQ
1763	payment	1397	1397	1678	1	1	1550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuJtpGM469tQLeY5JHGNgyWGXfYxRux6NoxXJaq2QJU8R35fk
1764	payment	1397	1397	1678	1	1	1551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UcM6XZszucXPdYNMzR7e6xsXgsz1W5sfcobo5bKFavYiidTo
1769	payment	1397	1397	1678	1	1	1556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaJNss3wnRyLQRkws4QwiiHzJDWzJioJUqoBPazM6NNSR8mqK
1770	payment	1397	1397	1678	1	1	1557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YnTzccG7uaQUru68P4sHvekRKtrzckmCdCH6RW8n6KSKqHmr
1772	payment	1397	1397	1678	1	1	1559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a4ivZX3JkJiWKUpnwbWom2sPzLJd7p5vLfuFSeR1RvrYYfXR
1775	payment	1397	1397	1678	1	1	1562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PtFsbo2ARjY9bMYvvykBiRMepJGFYutwNNi5EcdBVntRAaf9
1780	payment	1397	1397	1678	1	1	1567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKLgoCwTf49wtVQegcWzTJWBZaMFEJWafAvb7i11eyvKBgwDv
1781	payment	1397	1397	1678	1	1	1568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASdwc4mSQkpuPffePyLU9jseVC1mjD4vHj2FVMhnggdPjLQoP
1782	payment	1397	1397	1678	1	1	1569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMAcpudbcsmWRUPpeAzgE6EysxxW9jBqP2w85ELXanHT9u8p3
1783	payment	1397	1397	1678	1	1	1570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtKzE8wdtUL1xrzFaVoFesDTf5nYgeTEThaKZLDw1Add1ftBr
1785	payment	1397	1397	1678	1	1	1572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DSddUk4FY8nodMpGqhB7X93WcXGmXE9UM7j8EtNW6WerDk6F
1786	payment	1397	1397	1678	1	1	1573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3S2xFk3REqEKbEnc74ySNoDvYodUQnJrJ9WT7cfk9BXT7TAj
1789	payment	1397	1397	1678	1	1	1576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxT8LinkncmgYXjovsmwwRLFApEPtke8e6VdJjWwVBTeWAfCy
1792	payment	1397	1397	1678	1	1	1579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpZp2U2YLnaUbsF4MJuX8sgQftycFTxgeTSFb6Jqa6xWiSFZH
1793	payment	1397	1397	1678	1	1	1580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8ZG8vCgZXnsCso3sT6CJJYge36vg4kL3zy6ciedhkbfwmXr7
1796	payment	1397	1397	1678	1	1	1583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnn58A5pFsRtZsSUTivYgSEUg63n4b8nV4Dx9sirdsgwSqrA3
1798	payment	1397	1397	1678	1	1	1585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qYDgfgr9voKGsFX4bfjNsiBR1LqTM6mGYBD1Ye7ujzSHBnfU
1801	payment	1397	1397	1678	1	1	1588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6UMVPSDQibJpgpgR5419AQwhpTLrgm1PSA2PqXKzPpxbX8nj
1802	payment	1397	1397	1678	1	1	1589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxWmPyQhrb1t9HEWPxiw1HQmLGPbQM3FggkbFo7js5KpW3N9k
1812	payment	1397	1397	1678	1	1	1599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfPRXqs5bvuPmMVwT9jPXmxgSEjd2PSbbvEZqijZE8ZvxWCgQ
1791	payment	1397	1397	1678	1	1	1578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguRZVZKJBiUH8bdjzRRDsNp2YWcmsixuiqFXTgNsakaHcHYwX
1795	payment	1397	1397	1678	1	1	1582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFmKuWhD1EYgLWEjqmpHXqWSPzAQWKChMjBF7SjV8Rt3iTWL5
1803	payment	1397	1397	1678	1	1	1590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VMEGS5LJ7547HqUym6iegMSEFEa98kLxw1zQMYjB7CRzptc8
1807	payment	1397	1397	1678	1	1	1594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBLqkK95Wb79XM8Q7PGAydpYqBHLCKvY8qpvE1Tppfru4b37j
1814	payment	1397	1397	1678	1	1	1601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcWDFVUEc3TcDRoMFNoD5uWQGswnBfubSamETmoEPumF3TUPV
1815	payment	633	633	120	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTa1KxBb4nXvtpEu6NR7PUf7xUdJD3naLAr1A8bX3v2ApX5ZCE
1816	payment	1397	1397	1678	1	1	1602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQX5K3QVHZfT1w7pM52HWGeQiMNrpVs7MwT9aXp7zgBvTuxaW
1817	payment	1397	1397	1678	1	1	1603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCjQHGoukSq68pNnD4M6Hn6M2FPmKp9dnCDL4Sp2qTsmPWY9A
1823	payment	1397	1397	1678	1	1	1609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJz3BzcEA99FTQq3LmXNXwFVzv4DYTnGnRDTu9cPSfBvx1h5J
1824	payment	1397	1397	1678	1	1	1610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PEoA9tL1yRWsRjCDKvEZ5achpxvhud9Bx1RZ1qrYdQQejbN3
1825	payment	1397	1397	1678	1	1	1611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZma8eHQacWtRKo9r4aX4RmMi4XAVFuJZi8bfb3n3pbxPFsCCAk
1828	payment	1397	1397	1678	1	1	1614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzPEvJhB6ZH9AnWXnXbHiU3oRQV4mm6hnt4CPhtCMK8hWjQua
1829	payment	1397	1397	1678	1	1	1615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5M1Wc7USRR7A4AgwiWTXynhDarMy4x482KhbzZKthV5gSaC9R
1830	payment	1397	1397	1678	1	1	1616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPv6yueVz91aGKSzchSYScFCmgkQVsiZCaVz8ZF4GNQXNhV8nU
1832	payment	1397	1397	1678	1	1	1618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MM19eGssGv4YHLedf3uq5vR6yXfGs1ni2dKswmTW4gCsGZ4c
1837	payment	1397	1397	1678	1	1	1623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP3RPj7x667vRsLtAYFeY2XNCtyuZMJoi49u8SU9cp6AE3xGTy
1838	payment	1397	1397	1678	1	1	1624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpZ13vYGdJzzTzXWN74H2DUF8YpHCoRRiG22vbdX8ZDu4Tg39
1839	payment	1397	1397	1678	1	1	1625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3CryjtfF2rETeSuNXjRjeJMVTKEivd8TiwNeW66ZToyXJpto
1840	payment	1397	1397	1678	1	1	1626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMY1iVKqAF12Mcav998P2RGTpFtapfSXURdcS5hfySyNsDDgN
1808	payment	1397	1397	1678	1	1	1595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiD4iuLdvhiFihmdPfCApncr9S7rS5KshDY1gvG6Ce2KY8Uyw1
1809	payment	1397	1397	1678	1	1	1596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVwdM7aGjqS5QiMGAc5KnDtge8hC8jGCJEpiqveqpXHC7Rxws
1810	payment	1397	1397	1678	1	1	1597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzmvEmjdYne23ZuEtzw4Xa8RF9o2qR6KUa1TXDeii2ZgAFQ9Q
1811	payment	1397	1397	1678	1	1	1598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERGpKenJFGuAY6stiSPzwPBN4t6EbLWxACsrL6cLiMZbdVuYj
1822	payment	1397	1397	1678	1	1	1608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRmGcha5WocFivAUQk6rKfqZZSUc9Lup6Fcm6KwEbvwiUCkyf
1826	payment	1397	1397	1678	1	1	1612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDYNudGApmtyPhFVanQFh2mey6MonF53HqJNRehKm19VeF6ZH
1827	payment	1397	1397	1678	1	1	1613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNd3CCjsGjXWzQMaeNHKV1QGJUCRKfQjrvrkC47pbJVw88mc6
1834	payment	1397	1397	1678	1	1	1620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3DVAr6WDACCExq35Da7ULagWLtq9oeHA6HgTcG8TzpW4C7P9
1835	payment	1397	1397	1678	1	1	1621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkNmrFz7jNPTiMWZBXf3Mw7XJuiPjEkKJ5NBstqaNsZdsLWRk
1836	payment	1397	1397	1678	1	1	1622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1b12Qn7vTHjdrVY7UFx7Zebwuk3kZo4SCvr5SU3dmP85yvkt
1841	payment	1397	1397	1678	1	1	1627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwckRvWWKFpb9yjCoQdkjEF2vmn5oEkE249UAScykBSfRLGG5t
1844	payment	1397	1397	1678	1	1	1630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4S9TGsLUNwJ174gF8uG7LfM9WJ2oyFCfMgKkYM3Tp7dtpkoX
1813	payment	1397	1397	1678	1	1	1600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUy3dUD3W1PTL7m1CuNeTtzWpwARzdVFgdsUomQPLWcd221id
1818	payment	1397	1397	1678	1	1	1604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1kywkfTJD3mDbCvAySoM93pQfdkV6cfQ3VYuUKAMz6Wg9hD7
1819	payment	1397	1397	1678	1	1	1605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmh57rWAGzze7bt9zLzFMtExLpoXEK9h4oLyGpQZVwQJV7aJ2
1820	payment	1397	1397	1678	1	1	1606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYem5jfbatLWxPd35BrNsdmej3VjX9tAofkJJBcT9VCV4sn82kj
1821	payment	1397	1397	1678	1	1	1607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnbJzbpEcjU6Efvqx4vK7gRBxAoDrwznudnPJPg2HoRziQgvx
1831	payment	1397	1397	1678	1	1	1617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4WBErjdhm9gmyBEmiE2bd6o4KfJvy4Q5TAUa5VKQQJwsLpeN
1833	payment	1397	1397	1678	1	1	1619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDv6YmRZLUFnAyBeSqn7VAsReB7MM1Gq36LrBCRrRZkDZnJGy
1842	payment	1397	1397	1678	1	1	1628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EyeXRuDgFyZy4xrqMUy7YyCwmXgRE9mb3YajDmfkmG8rYd2H
1843	payment	1397	1397	1678	1	1	1629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDRxpRoKBtG7WDefMdLDFSiE2AWBW1dF4wP2T6yxmB7TptQbv
1845	payment	1397	1397	1678	1	1	1631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJBATLJYqG5W7b1Sgh48crxEBTxVTpnjrG8EvQZM9K2KH6sn1
1846	payment	1397	1397	1678	1	1	1632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdsnAgdcdCp9YKZpf9ycWsBzaVUc3JG2E6HKe6Chnr3KRBrjX
1847	payment	1397	1397	1678	1	1	1633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1mnUdHUmYNruwytzhDeqYdzcqagf9XWR7YxFYa7pFMP8fDnS
1848	payment	1397	1397	1678	1	1	1634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24ARhLTEbKN8nfrxq4eZZfFuh52cUiQZuAoomVLnNnLBjpsKj
1849	payment	1397	1397	1678	1	1	1635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWQMB86MKPXChJdGnvuzTNp9h295QeM8miF6cFpHpTuRTQQq1
1850	payment	1397	1397	1678	1	1	1636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xF4eJ8J2HSeRaGNNgifaaccb3kdzL3o1w6D8vMTNQjDxwyuc
1851	payment	1397	1397	1678	1	1	1637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDoBz28ZmkarxGZxe7YRgwNgcCJsyidKFWCoWiMJKZBNdwUxVB
1852	payment	1397	1397	1678	1	1	1638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9c4HenxB7kn2cQe4DeCqbKhLkdbev1fxYWe8bxjF4i7TKjv2
1853	payment	1397	1397	1678	1	1	1639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiE9e6PkFF11hrMy8WQBUyzbTh9F1FsxGrNeduVSAXgkH9QCRk
1854	payment	1397	1397	1678	1	1	1640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTCAMrz1P4QeN5RXpwB9oK3Ni8jywmsK5crFn8xMZmkKaE9Di
1855	payment	1397	1397	1678	1	1	1641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvoa685jFzvU8MsB9CXftHyzqEkpTsDpE2sea9bESRV8HW7g1
1856	payment	1714	1714	1590	1	1	1	9900000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13LNBf6bg9SRCEZiZTKKdGuCT4XpbwXD9thHZMH92UFbaYVyF
1857	payment	1397	1397	1678	1	1	1642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFF42DThMaavPizXTUrKkoRHrehgQpakvZWs3VPFesLBhR23B
1858	payment	1397	1397	1678	1	1	1643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqH5UEkVbxEVfqaWABtKsTT6Vou3o3vzESf4GbifRpK1Vqy61L
1859	payment	1397	1397	1678	1	1	1644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HCjwVbSxfY7swsTj71aetyNQaW2DvWUvywsAM2WCg7VXQNA8
1860	payment	1397	1397	1678	1	1	1645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwpLQnJZPPixc65KCZMZBggjYwXiP2sixpyGqEFbkdvBVrYxF
1861	payment	1397	1397	1678	1	1	1646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fbVmnvZHh3zNEt3yqSyN1S6HoLWkq2XJZupU6SNfGnsoMkTU
1862	payment	1397	1397	1678	1	1	1647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9xyoDfx5tEQNXmBg53JRfan2PsEKirmWgJAZ9NAdVVYy1rxd
1863	payment	1397	1397	1678	1	1	1648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNteBvtgf9tqTNEfYqhsJGUQg36CPRKVtXtTJUYEgFGwQPBvu
1864	payment	1397	1397	1678	1	1	1649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJcSfyVmgtdTbDd95HzCLW1xb7r9DMkmW1iHT8bHYv48gyYXy
1865	payment	1397	1397	1678	1	1	1650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8hsd1NyU4paNXFmkpstmoV2cAr5iX51RLcx7PaosjLLJ8gRD
1866	payment	1397	1397	1678	1	1	1651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bdnvU6YsqAdm7mFvz6pXFJro9unfupmagai4TcxNouU1YMuz
1867	payment	1397	1397	1678	1	1	1652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1kC4UeM221dmGLbELj4TNHUZFwtRefNDki89vT411L6dmt3t
1868	payment	1590	1590	1758	1	1	0	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSAxLydc1XuqhxU7YwDog1MZZD6WMeaCiBQyxyouY4SRkub21
1869	payment	1397	1397	1678	1	1	1653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuo6T4iTGspMBga4xusDFVYdjD5Y2xPUzgZKA992kJPJsDh2z
1870	payment	1397	1397	1678	1	1	1654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rR4zbcvMAu6mE8Px32YKKV1obf9ngmu99Lz7AE36tiHQrZEj
1871	payment	1397	1397	1678	1	1	1655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJJT5VzyYfRtgDXr1cauU8rW3vMPdZepqj7pxWRwjix1WkQ7c
1872	payment	1397	1397	1678	1	1	1656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiQsvwFX5CcgTE9W194z4uaXERD9tUgmiLFfwrLjPWfHzBLWa
1873	payment	1397	1397	1678	1	1	1657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRBwU5yttumEAobwasoxYRp4QiuQSMkvy1YgFkFRK7MGT2oAk
1874	payment	1397	1397	1678	1	1	1658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTZmLevYv3wAiPDNELjEU3zwTUzPJA6dwNSJmd7RCumbCAjY5
1891	payment	1397	1397	1678	1	1	1671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6NrLMznBD5deE5ezP5zTW2nZb7pnN9njpSex4gty7eRiTXLS
1892	payment	1397	1397	1678	1	1	1672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTpbZkeSA5MZvwugSfqehZtx31W2ueL1nuvfH8zjoG5DKtRx8
1893	payment	1397	1397	1678	1	1	1673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgX6tioZBEJi4MmD4HwNF7g8jXaZzknPSzvwsvWmcqPjjmEUc9
1895	payment	1397	1397	1678	1	1	1675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbgYF3U9xwjBPFawnTEmTo4qWJbQPXLwMxSCcBSQkrsMziVm7
1898	payment	1397	1397	1678	1	1	1678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GjDRv6sjTNRqaM6H34R9qbFVSxLYFi9pxMPmeuzMy2Ysu5pe
1899	payment	1397	1397	1678	1	1	1679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHKpUAPan8ofeSS8FUT9Y5DFckCLkhHo81F5rE5TohcVxtqbk
1900	payment	1397	1397	1678	1	1	1680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL8p9fUd7YY1EVN8qzqeNVuboC6FhdBfwFe2ScGu7RdkJgK76
1905	payment	1397	1397	1678	1	1	1685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimdywwFpebFvomYDhypdAd834P6EhoV4aKW4ftSCsHfqu14uD
1911	payment	1397	1397	1678	1	1	1691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53VkVh81NgS66b1cX6BAVjNW5zFGpYSH6JQ3q4HwPbAGSXVaq
1915	payment	1397	1397	1678	1	1	1695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScn3jNXLRQUgS77ZTq1JPJTCcsUAoPNyLjuAbQNwAJLtRzyST
1924	payment	1397	1397	1678	1	1	1704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhj5641qaRWcu2tXPjdDTDvVwF5uh7mDcX4LZzsq1SpdwH2oXt
1928	payment	1397	1397	1678	1	1	1708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS9rRSiMamKtm9FkLfyrA2r5aQmFhkRPrbyEStgDtGp7GE5sC
1936	payment	1397	1397	1678	1	1	1716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYui4xPjFHQWYju5iSDCGwtpF6z7vAh2nvmG3KvUDW4hSxeA7DY
1937	payment	1397	1397	1678	1	1	1717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRswMCZj1URjfC6BEQibpNfUAQdrfkc76pMckJMDrmFPXkC3Xd
1946	payment	1397	1397	1678	1	1	1726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQNMxaRspcPQqxLiK75NkGeY6Ax8ahuCqGSoj873hTcfunqpM
1947	payment	1397	1397	1678	1	1	1727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvxFz2KzUz73Rzx6x9M8NPxYrGCcHep8La7cGDzYrdF3xEDJ6
1949	payment	1397	1397	1678	1	1	1729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkQfEhN2Vc6u1pY5ibwvMiWRWbFcovdVLsddZoAN3mNDeLj32
1950	payment	1397	1397	1678	1	1	1730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6XLYQaQZB5ANrMWvWX9T2LYjQPfKE9GDPMADNxx9jx8Sp79Y
1952	payment	1397	1397	1678	1	1	1732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhf2qj3hCCCeMY55QJzHhYf6nLFW4qBxH4ANNygQGUt7SKyfmq
1958	payment	1397	1397	1678	1	1	1737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoE7A1XoXSCQm2oF5pbqfKsBECtqmGxb7LbYNjNE82N7g4YMdJ
1959	payment	1397	1397	1678	1	1	1738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB1VJxyT3jZSjJCxqaBtbenVix3CZCobtxFwFmzSbuqoWESai2
1960	payment	1397	1397	1678	1	1	1739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGG9hqSiuqBN8SvpPShdNrFWhPrk2vbY2DavQ2edEVPEFynxzi
1962	payment	1397	1397	1678	1	1	1741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUE4r5QnQQHFRV5tEAZfWPBRvxxV6MuKKzVUDxdUiDa7azQi6
1967	payment	1397	1397	1678	1	1	1746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJrNa5zp2HF1YViSPAAUhUETZRDg2vWygbpchGtV3VBtbPTLm
1969	payment	1397	1397	1678	1	1	1748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqnamgxQL8swPSKzvUQj5Ue8nSZBwyK2ebKkszxytNKLYn8nP
1974	payment	1397	1397	1678	1	1	1752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Q9nnqXNZuiZfTXCKeCU6hBnMQBZuXoP9DzmgetnwmiRNQHuC
1980	payment	1397	1397	1678	1	1	1758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNw88KGJmpMnfEK7bFc5q5jD7YG1ZQdTNCQNqfLGzxTwhZ4ZR
1981	payment	1397	1397	1678	1	1	1759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4YpDCabAnRhD5GxjZt6pXZECnayds56Hv1HYEy4XUNyqv8Fs
1990	payment	1397	1397	1678	1	1	1768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRtHW3prg6pdjbTcqn3QB4FozmiaJ9VFRkTDapYdKZEkQC2XR
1991	payment	1397	1397	1678	1	1	1769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkMyczZ6ZTZiTNacUFLS3UV8u7uqkJ12spBNqRJwNGpUcPrs4
1993	payment	1397	1397	1678	1	1	1771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkA8hehjR1JZh9UssJFtiDLwWSUyRCZARQ3vysH6QX2HojukTr
1999	payment	1397	1397	1678	1	1	1776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Dn8JQq8E3DRKybP2cMF9ghu9Gz9JxFVX5WMCzf4gce3DTNmR
2002	payment	1397	1397	1678	1	1	1779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmm9pJdF2rDvrvv2xLp4sURrN72eLqBaPQN5YFzGrTn7v8xoU
2004	payment	1397	1397	1678	1	1	1781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTcyUSRW857vmgh11aTbNzVcRx5ms7wnGWWEuKS44ce361PcK
2009	payment	1397	1397	1678	1	1	1786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmGvCvTVPCSy7Gr4jnfT9MFC6GryihAUTEb193XgRRf32Gp9V
2010	payment	1397	1397	1678	1	1	1787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDseVU7nd2MqWyGnWUrJYBiYTcnuKjN2xm2vszKTiofa2MCLc
2011	payment	1397	1397	1678	1	1	1788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbo7GdNZaMjNoMPSJNF57U7cQgVnEezYaMdeiGcwZqeW92XAH
1875	payment	1758	1758	1713	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngiGqqr9GPHLvPg1c2iJtcfFDA5dThbUxGu5AUZNNxCnqTYzD
1876	payment	1397	1397	1678	1	1	1659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiWDaQ15pL8ej3SEfZEFMM4XXcwdeRuAHBo57tTv3EG2z9a48
1877	payment	1397	1397	1678	1	1	1660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjXx1ijQjtDJu5fm3w1Yqq36fENcGRGo8k3SgRME9skBdgRaG
1878	payment	1397	1397	1678	1	1	1661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyKUCXqCJBHcNLgiLDeztXQweBnJewzt5qUMDGyMxikSDWekw
1879	payment	1397	1397	1678	1	1	1662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXnkQgQyC9bg27rV3fAmKk3HDoEGAV4HL9aqhinpwpEmgAcMA
1880	payment	1397	1397	1678	1	1	1663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAheahNvzKw8cZbszKUikc2PnNgsK3cYaRQW81V5RFa1iUyxDF
1885	payment	1397	1397	1678	1	1	1667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXD6N4yYBFBxve4iy4maZmfB6JFKdoHGF7CSyS1QiqNxmw7JL9
1886	payment	1760	1760	1761	1	1	0	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XBcrxUaXxbD7iwq6Ab3GRf41DUGGzvxYqCiURR8Bo1CvotTk
1887	payment	1397	1397	1678	1	1	1668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyrbzXjGNGbYJZyLUtqLvssa2Uj2v24L9jFpHcSjuEvWHdd1W
1888	delegation	1760	1760	1761	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupktFkX66VHffC59GnamXpB5kQ2BKhHzTN79wx7vUNvR7ivLz
1889	payment	1397	1397	1678	1	1	1669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuZa7cnHRzup7zzZhhWKtQ3e2sP1hhmjnTS1fjbfw9A95wPsc
1890	payment	1397	1397	1678	1	1	1670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSVTPxknwRF3QqkVhjwSRUSQkR9gv2Fo2hvyb99CWdfcR9K6C
1894	payment	1397	1397	1678	1	1	1674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1r9BdcTTLcdXn5rKib5mS8gUAkfYbum51yaJUJeRUbSneNW8A
1896	payment	1397	1397	1678	1	1	1676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVQQzt5tfbJAqwwMwVGv5H4vR8pMkXpHH3eoPoTDfxstJZwZt
1904	payment	1397	1397	1678	1	1	1684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CewB81hrhorCLD5y9ivnHkZWUbJHoc5Bi7c49zJyQGYKo7yA
1913	payment	1397	1397	1678	1	1	1693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYrujbWgZ68Uz5TiJ9Bdkk4nKmrC7145vxqVTxeVjiS3Sezbh
1916	payment	1397	1397	1678	1	1	1696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz9LfLHiHW1Cf3LCNG7koUr2V5AmYurBgJMKjTTR7n5qa9FGh
1917	payment	1397	1397	1678	1	1	1697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNqywWm3d67QefPxzoXYQfVs1bw1dLsYYrDgjzeHD8v6c3qB7
1918	payment	1397	1397	1678	1	1	1698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLTTPc3dKHPAoVkRKZaBZ9rgRMHMxSYqSYxXpxX1omWw9gnxE
1919	payment	1397	1397	1678	1	1	1699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2KjArEJ2BrKESXBQpA5PNvkv54g16vnisSMJWUFgvnEUQWW4
1922	payment	1397	1397	1678	1	1	1702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNdrZk6y5ifw1XBAKDJjeE4yhafgAiVjQooFxkF3Tq92dnrBe
1923	payment	1397	1397	1678	1	1	1703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbt43NwG8tcFujdT6AXzE9JuCz5CD4MpBiwKtKHjbT5Q8RKxF
1925	payment	1397	1397	1678	1	1	1705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBAb6Sx9zUEKtbFYGh44ifBcfMsifBEqscNAXYpxZvnUvUPSf
1927	payment	1397	1397	1678	1	1	1707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZxEgx58Fd5zt2CapLeRByyLzdtj8iT4G8iaLHCEHRGEDDXus
1931	payment	1397	1397	1678	1	1	1711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqPWLXPdqEH6bN1DKsadncV7oncGJ8Fids1Xv8u6zc7G4ZrNn
1932	payment	1397	1397	1678	1	1	1712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYExgWXWKeyuJuc6oQ9FFaf7YtJEGJ692eMsogH73VQu6odCZR
1933	payment	1397	1397	1678	1	1	1713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbgEzBsRiLiS5QiEMkLGk1ubiL3Wd1jVvCVrhmzdY5aBoaqbN
1935	payment	1397	1397	1678	1	1	1715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo3Y9i4bYPdpTx5sH7mbNYpQ7t2acjCtzNYUP8XjgT39MvGSE
1940	payment	1397	1397	1678	1	1	1720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QzrN3ex1SE8j9PW4j1DMgcsr6YFVMAvz5TW54K3nenLEKPgc
1941	payment	1397	1397	1678	1	1	1721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57ax2cubXSccaifWgkBcZUbA6yJkycn8YU1Lj1mYUA9ZznESV
1942	payment	1397	1397	1678	1	1	1722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ4MeRkjdyrcPFaKDMsxHkZJdhcjbZ6iRbn4xydhh8it7YE6H
1944	payment	1397	1397	1678	1	1	1724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKhACRu1Webta7YEdfkAYCYNBqufyJH8NiF34Sc1wKr4y4yd7
1948	payment	1397	1397	1678	1	1	1728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgBMeCE1MironDLuhMABbCE64J7LETKwenRWeMPfFcT3SteYx
1953	payment	1397	1397	1678	1	1	1733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFHj1fCkwHver4u67L8fiBb4AdfA4Q7qiPj61x2QLvTvBHpyr
1957	payment	1397	1397	1678	1	1	1736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHFtU7AAk4rfJAmrTer3faARm7ZtQzZugdEmRjUvma4RyG8ET
1963	payment	1397	1397	1678	1	1	1742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tZGBudYY1wEfSfjoy6tdpaeJ9WuzgNA4U3GBSpBttTLxuySe
1965	payment	1397	1397	1678	1	1	1744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3YpZRWnKuwXSb5zT4uwuh5hfUsb2yN6KVgHN4EHoUzpHRv7m
1968	payment	1397	1397	1678	1	1	1747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZReaNqryniJC6S18UQ6rMEQBKM3V6C5vKMvZukYz9nRH18bf8f
1881	payment	1397	1397	1678	1	1	1664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVVGNwg2yjdiX32HFnSR4u7g7aJTP5GivNUAkbN8mSqUo2hqH
1882	payment	1397	1397	1678	1	1	1665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHK68UG4d32nkadpYZVzsLdDWa6pbsqqzXqKhR6amT6Ud5n4i
1883	payment	1397	1397	1678	1	1	1666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUcuKSEuvEpvjTu2BQ9TGbBvzDdUB6sGSjc16pR2fXNwAMfu2
1884	payment	395	395	1760	1	1	0	3020000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNJcyzHAN4JyJHPYDhJkB2kkhj2XckgAeVvnLm5YrhCHqjceY
1897	payment	1397	1397	1678	1	1	1677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1EWWn9mgcAkMasrY9EUNQizk2kk8BvVPGgMAkAQgcVApVj4r
1901	payment	1397	1397	1678	1	1	1681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYAj8WHUKj4Re39RYo83V8KtF5KrBk456rwMkdPD15rDLGWEe
1902	payment	1397	1397	1678	1	1	1682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SP6uGhFNLmubkM63s75BRPNW3r4jhDsBpmqSymW15kfx2mpm
1903	payment	1397	1397	1678	1	1	1683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3isPzMFtMw3LSFegg5r38rWufqorEWiFQxmWWUVMozP4w6CXZ
1906	payment	1397	1397	1678	1	1	1686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKeJDmhNdziJu86RPEo4qsbPEiXaiK2ayAunJW6S1zkmhA7Lt
1907	payment	1397	1397	1678	1	1	1687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44PULUD3FSofAvHv6nRuFuG28GZvY6Gg2UtT9kis5M3FjnaGn
1908	payment	1397	1397	1678	1	1	1688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9yaD6is3DL7RYV75Lqnxkgbwujk1SMGv5ydTM2dqcstcBvfh
1909	payment	1397	1397	1678	1	1	1689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhHL1diMsUt3o51z5YJzCsJ2fLC4VZk7QVPPH5vcy1A4HhGET
1910	payment	1397	1397	1678	1	1	1690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hRBhpaoyR2AHf6VPyTaxjEJ66zu5RRwRpJkfuE8kBjL2Sf2V
1912	payment	1397	1397	1678	1	1	1692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsTqmgnNqkHY5vPqXGDDnVCi2B7JDmHKy7LfKFMUn4o4W57An
1914	payment	1397	1397	1678	1	1	1694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBNDYpY4GbfFLs7T9bswCqzwaqh8H5BQotF9dp4Mib6U2XgKs
1920	payment	1397	1397	1678	1	1	1700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoigap47972b2yUy5SLEZVdu3jxpVRNnnUaR8A4JZoB48cLZey
1921	payment	1397	1397	1678	1	1	1701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthVfGEWEbD4WrxXzYnC2hJXvq8Ar8Gy7hLyb6yeUQQTGdjMVA
1926	payment	1397	1397	1678	1	1	1706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkgWKc84hofW4stf2JivrmP9yzzukMWWFWoj5wtXQBaekVEAd
1929	payment	1397	1397	1678	1	1	1709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9wAbTuRZq4Z6vjhtaRpFL8Sq1YF7PWGrJ5GgP8b6aUk8pfok
1930	payment	1397	1397	1678	1	1	1710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofdiVXuHGptnAzHQWFno2A6X2zSN1xAxTtPSB6cyNzMBpziZ
1934	payment	1397	1397	1678	1	1	1714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BhTRnWvwqhbAJ8ehERgpXdNE4HAuyGhETz5AtskAtXQ3NxRP
1938	payment	1397	1397	1678	1	1	1718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJedqkicpX71nRdTfyhnvbYee83fJTTNibGnrEw2N1anEj6wj
1939	payment	1397	1397	1678	1	1	1719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsV19EuMZ6QPkHBpjM5HmV4TjSX64uKV8wNf38TSZ7ZtJNCN3k
1943	payment	1397	1397	1678	1	1	1723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhkuGruNoxyeWQTBM63ePTdmtQeiiq6nhYKsJF9GzQ6Gv81GD
1945	payment	1397	1397	1678	1	1	1725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNqQ1GJDkHmqHNw7KRfHBwjjjtkUrcKqCNDHsGiAB9sEnkPL3
1951	payment	1397	1397	1678	1	1	1731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uW7aBXnDqnaDg7YAVDmgRzJuej8MC3PACq2AcQnaZwVwEsxY
1954	payment	1397	1397	1678	1	1	1734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6xgLjTwDFMPk4fpwdRfZxdocWbdLXXh6h5PjwCamwqweTfss
1955	payment	1397	1397	1678	1	1	1735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRM76xvGxN84kvVqQksNnWqPgm1qQPacFabxpiLaauWpossfHa
1956	payment	1429	1429	510	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyUV7aUma6vXKijrubmkZ31mdyJaTB8W2vUUyoEQfmhVP1WjP
1961	payment	1397	1397	1678	1	1	1740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96mEaL4TBXiqQpDpZ85XWqD4bDo1Ft4zm2R4badZtMusa9RJB
1964	payment	1397	1397	1678	1	1	1743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuscN6k3V2bu3Xr3nh3Uy1CCNFZaDQgkx68Qu6wrrwCbYxLwy6
1966	payment	1397	1397	1678	1	1	1745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h9vR16gQDBGQ143xDbBzUJiVVWaotna8hE7rEHmFGGAL8QeC
1971	delegation	120	120	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfaFA7Q1h6qqUuTFu4odQTxWyAiwC4GyW3zpBrEWewXDx8UZx
1972	payment	1397	1397	1678	1	1	1750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf4N6sNffMZZ6vM6cLKCbf4Pio2TTS6pX9BFpYpFtozzDN2Kb
1973	payment	1397	1397	1678	1	1	1751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhJoeq2iLUGVNrLnpLxotpYQwkvrFHABbuYuYVmycU3j9bQM5
1979	payment	1397	1397	1678	1	1	1757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2Vk1HZ7eWYAhiz2oXxpcRTutnnU566xzQDAynr2CcPq7jG18
1985	payment	1397	1397	1678	1	1	1763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vg6h3yPBduYDLHZ1f5hhbBnrvikQ3ETUh3caxR8NBrZ6tZGz
1988	payment	1397	1397	1678	1	1	1766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhso4AwnBNMgp1GqnvXsuDk4EoeYbXVM7BRo5ti5e6m5Gc4Zwd
1970	payment	1397	1397	1678	1	1	1749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ibVhmLJP4caJsJqgKi3nzAbULSQdckJeEZ7A1cRY62vmDjkK
1975	payment	1397	1397	1678	1	1	1753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytWQQxfrabZCdHVbvJkNkaUiAzgHRiQxNCfc3NQ3KhZqsR23b
1976	payment	1397	1397	1678	1	1	1754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuJnLDCYPANKhwv2KZZWpkXWei5RJrFjh4VKbD58wzWrdeUGU
1977	payment	1397	1397	1678	1	1	1755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnZyTvZQKbdRxMVdfeAdprXeuUU5Cmjy2U1BNcnazjNnQTCSU
1978	payment	1397	1397	1678	1	1	1756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagzDh8KKqoBE646FxoWXo2E8pWmgxKDdTBYC5iku9obR61EdB
1982	payment	1397	1397	1678	1	1	1760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm6qcNnB85mz7U8Dkqehi3Sm483WVNHZEPfETeWg2oxE2oNN3
1983	payment	1397	1397	1678	1	1	1761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsG4ETXSaNsSoc3z95pQtBGgX3XSagj93SPjwNnBbhJ7TmkJP
1984	payment	1397	1397	1678	1	1	1762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rE6wJjDCFn2jQLwchpVbjN2U3dmCRy99sjebJw9eqA5VXSNQ
1986	payment	1397	1397	1678	1	1	1764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kvcYQ7gedC4Aa4h27RNzc4oiK2kvFVt8RN4DXEq5UKTmjsa3
1987	payment	1397	1397	1678	1	1	1765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoagEQqdUjJzyz1wKxQmtRjAHGSqoaZgaYhtKdZYNUVGZAbqax
1989	payment	1397	1397	1678	1	1	1767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAHPxehxs8BBBqhhYDMct9sq4AiHSRD5LaLDq2wz5ppTVmWNP
1992	payment	1397	1397	1678	1	1	1770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdqbUz1r7Z1mTiUAxAzyj1RLKSk2TXv8nSU4CZwFECfeWad8G5
1994	payment	1397	1397	1678	1	1	1772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjboRtV7jR79zjt2ezThgWGvsRcJnuqKQQ7tbsvH2PAjBTSisM
1995	payment	1397	1397	1678	1	1	1773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hMzUcwUGnMXy1xwzvCD5WHErGhQwmuVwqRCA6iHPjKwRpgRx
1996	delegation	1687	1687	1647	1	1	0	\N	10000000	\N	E4Z6JzsozEzXPaqqQcmLF12qpTgnQrFiGxdqtrfHfQcpd2KX7T27b	CkpYQw89wmnK1EKE6itnz5z1PAhW65J6LhdbHwBcbs6rrAPzZ5ySr
1997	payment	1397	1397	1678	1	1	1774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH2Y3cpYXBvS9dMEPE9gsX6Dy5AN3iwuPgeG9xHbgAFtuESBR
1998	payment	1397	1397	1678	1	1	1775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXjPdtC75CJyU9euecAzFydFckUY5hkjGo9CvdSHGH2rim9SR
2003	payment	1397	1397	1678	1	1	1780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ggzV4YozP6sQfnD3emFRX4bXai9TBs8G87sguRfN1u8fh2yJ
2006	payment	1397	1397	1678	1	1	1783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58udZWjWqrihDtfqpvHSJ3rocqxTb8sdw8nGfrY56b3NxypWB
2007	payment	1397	1397	1678	1	1	1784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwG8Gp522q5W4W1htyesCBXrQrUbu5f6Rn5EiCFLudzrzj1Cy6
2008	payment	1397	1397	1678	1	1	1785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXCbyh19RJdAkZmxwRSpoA3QAVLPiVaNarGiZjpdfySW2dB4Y
2016	payment	1397	1397	1678	1	1	1793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxK9E9AkQEnB4f47boLW1KVhUvZfBm11vyHZxeShK8rf9KeyR
2022	payment	1397	1397	1678	1	1	1799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73QWoDPsRuHDEzhma7bw6Qb2hVmpXiBHbdMkf3yoQQcURjh1e
2023	payment	1397	1397	1678	1	1	1800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMHBpvUbwwr7YdmMjW1ThEzZUYyunkc73t7zzoLRjo1A7uhvZ
2024	payment	1397	1397	1678	1	1	1801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpQ36HjAQBAyg7V7H4HeWHaMaGRxKqqHjtYdJgMBjYx1ZajeB
2025	payment	1397	1397	1678	1	1	1802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5AU6KyWwoxGN9NfvJHsu9hqNc6yC8fQDdQwWJFHYSzJ1mtwv
2035	payment	1397	1397	1678	1	1	1812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GfQoR34xbiDccB5BE8Km8bHo87oh824h4JZDPnVcTWCYjAyY
2038	payment	1397	1397	1678	1	1	1815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnH4akZseVzH7TK4x7jw1LjkKA8VJ7JLJy4D9pgWULAAbH5heJ
2039	payment	1397	1397	1678	1	1	1816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fRXVEWjFy7eHQB874YGfp51pUoCpHDNYnwQzprU533GDbr81
2040	payment	1397	1397	1678	1	1	1817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEg5tR4KciBvjG34V4AacAQDrTq9n9MquDo5GRXXhaE5d7akN
2041	payment	1397	1397	1678	1	1	1818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjk1CwqN7ocFBEw2UBzMLasvnsP83GQrab1DZUPwAtjCeAR2h
2042	payment	1397	1397	1678	1	1	1819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4ne3LfCzm3U7YVyNSA1ntg54i3Q6ALegrWeTB32BmF9PSAw2
2044	payment	1397	1397	1678	1	1	1821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCv72oL68RSUZFuSpVnYbcLucZon5oi2ppTBSZmcwt218gDSFp
2045	payment	1397	1397	1678	1	1	1822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktB4eu7vS2EUcxUdGAuRgk8n13s7P3gPuQhjY2M4ZMELmFVzb
2046	payment	1397	1397	1678	1	1	1823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNJXXEgsoUUWp3bQ1hsZymtVbMbrQ1aYsx1DKpXTje3J3c1vv
2047	payment	1397	1397	1678	1	1	1824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfG3xPZLJW5vuTWC6uKm2HC1NFvFnYm2DFF2goB5M5w1t94xU
2048	payment	1397	1397	1678	1	1	1825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUC8jpMFzLymrz6kgw5ng5kC2DcahYzGt3BqrzoSY2WXHp9xAt
2049	payment	1397	1397	1678	1	1	1826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhNmyirP8eAGE8cLhPa2ptYH1LRuatUEFrxH6GDkcPDJ5Z7GC
2000	payment	1397	1397	1678	1	1	1777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutiFebxm1TnnAqLHB1vGBnPrQdALgVGigCjesY8LC2wfwMMrC
2001	payment	1397	1397	1678	1	1	1778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3PehcznywTZ533BvuS2RSNwavFTvnMDRvCtCa6CaQ8n2YQPr
2005	payment	1397	1397	1678	1	1	1782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ9C2pBVryBGnLcuDXVHyBvF45D2fwhiWysehyhuoyJQTnNiz
2017	payment	1397	1397	1678	1	1	1794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjUZt5QJhCvSFzVyWARcRnQMk8b3YP9Byng5WuATzRHAWnQMv
2019	payment	1397	1397	1678	1	1	1796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHi6NaDTrGC4Pu5yAT3XZ6uumaWVJN66z13SoSqakjoYrpknL
2020	payment	1397	1397	1678	1	1	1797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAQr9WfM3tRgRTJzq76BKvnMELKgiu99rMqqEPhpoXzZytCcN
2021	payment	1397	1397	1678	1	1	1798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntEq1GyaZhyzyBoJTac1vPUD7spR3PkM4n4m4TRfvwNLSjAGp
2032	payment	1397	1397	1678	1	1	1809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LrTaiLQaxvepopoNSuG65b74aE7XTc7VztEX3bLZmeuTGvQ7
2036	payment	1397	1397	1678	1	1	1813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQF9TmuuFXye7D7btwkRU451QjPESW6r3wbaG2DoARq69Zkt8
2037	payment	1397	1397	1678	1	1	1814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxstqvuZxi7dpLT6Qrj9KhpFUE67QKLzh2t7ZR6SR6XLPAH1t
2043	payment	1397	1397	1678	1	1	1820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1K4EMBVaWGr6EHoYMKaSRncyQV78WyxmrPE5CCqauvNV93eSD
2052	payment	1397	1397	1678	1	1	1829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzw7JGQ85n9DZGHMimKxDSA5RyemCt8ytuj73j8YgZ6kQH2M6
2059	payment	1397	1397	1678	1	1	1835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHJX4jVTMwaCDiKPS1hLfvZMTM4FuhdqDDirC4ocE7H1SAteJ
2070	payment	1397	1397	1678	1	1	1845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbFNphEK1qarFpDdJwveUSnxxoseyxhRHdYDqbRYWfWgf7ENQ
2012	payment	1397	1397	1678	1	1	1789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfShGts63wj6pf1sccdRHXuYzEFLk3eiSzHpzw1dqZkx81BGLZ
2013	payment	1397	1397	1678	1	1	1790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdzibRKM37g9aNwwg9N322aMn9fRRHzBBDefZfyUybGfbYHUJ
2014	payment	1397	1397	1678	1	1	1791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XyuaRcwgNgdwNBt7eAnCcRCp2foWp7Fvh7Vv7rouoSZsZxgj
2015	payment	1397	1397	1678	1	1	1792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXK9ZtgjiTML7osHA1VJRDmjnAYR6EfM2U7EkouNs3AAi9mrAp
2018	payment	1397	1397	1678	1	1	1795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhthoNi4MYtvCpeoAyC8bcFHwTseLzokKzxv9E1NPpFYZSCpm3
2026	payment	1397	1397	1678	1	1	1803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCgBbzmVPkznCvyJbHHmRZPTvqznJnhk5kLj3577pQANW75pe
2027	payment	1397	1397	1678	1	1	1804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiAtsGQLaq3VgvMiRGbmvE7eTCTTLcMoqqiRML9QpZhgSC5JU
2028	payment	1397	1397	1678	1	1	1805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ApjdoqU4XRqPdid4oavipfq2XXi79wbu8UYoLwEQW5izrEMi
2029	payment	1397	1397	1678	1	1	1806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5dQ6t21bDFJfSPQjDH9AT32KSfRry2WxGcnqzmqg3m5mNTxG
2030	payment	1397	1397	1678	1	1	1807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVe9UDhii9vfkrqYALWYodJ8kfBz2YMSDJ7fix2uZxAn1tBDD
2031	payment	1397	1397	1678	1	1	1808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RzuNP3BfQJKY43t8m1c8YH1Xw9AdRTg7HThRf9FWJ8nJRTou
2033	payment	1397	1397	1678	1	1	1810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWqFyCuKNNiJVkhsgrMYUaHsxYwaJA7VB2CmcWcbYL73sjMZR
2034	payment	1397	1397	1678	1	1	1811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQoxFhCY9ZUfLgHSEmEPVhGj4BUSKYXXkNjZ5C2qjqbPhn4Py
2053	payment	1397	1397	1678	1	1	1830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdWjHnqbGEmWdLdTgKFNCBGMV1vMqUi8jVw4W2tMQoEoQYima
2054	payment	1519	1519	1763	1	1	0	1000000000	10000000	\N	E4ZACwNkrDLQv1JveNwFncBqGyn7yZwbiR72sfnpZ3roGqXQJECzA	CkpYqFRLyjZVS2ArrePvVXKe4wHg6S54dgLNXQ3r6SFgLL4FhXeFo
2060	payment	1397	1397	1678	1	1	1836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ThEUqJVh66bWqyTPYJjgsuT1AYzGSBEm8xJjFbq4JBm46jKQ
2061	payment	1397	1397	1678	1	1	1837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghy1GwuLQfJkWqkgQAgn8UJJXpBZWD6Tys5uyXFYDF7wrfkKk
2062	payment	1397	1397	1678	1	1	1838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkPo3b4d9xkRogQRV3cKAfjuQT4sqvg4uSn5fAwzsMVuHYgQu
2063	payment	1397	1397	1678	1	1	1839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxTqt4yLhdBbXcRi1CsaJPipDryzqAqRB2R9KeAdErXwPFyfA
2064	payment	1397	1397	1678	1	1	1840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeb4XaieiXdnRiRQ1WZ4SWzoVLeKPRk5fWLLGHrqu7h3yoSdB
2069	payment	1397	1397	1678	1	1	1844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenWTzoyHZSKiYhqD1Zf8N2dJSDUp4HcbbLZJgGYhenWMyKdKz
2071	payment	1397	1397	1678	1	1	1846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJii8CXmYxfsjsxP3uLbx3Dz7S1AuSj73zcGCpHtpZqBQWRmY8
2078	payment	1397	1397	1678	1	1	1853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3o7kJc9rZB4xMxYKkdA78waYRc12aEoCsaHKvmTk63qsJNbt
2079	payment	1397	1397	1678	1	1	1854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvP3SFK4d4Q25eeTngCbpjRqnHJuSEiKdphzoB6cgCF5jUdQKo
2080	payment	1397	1397	1678	1	1	1855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCwgD7XhyotbjhRHxqXpokL52Sb2SUR5U7R2iTPQjFDj1iAHt
2083	payment	1397	1397	1678	1	1	1858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAahEWqxwpYD9HfoJbVaUeamgcCid1K4zc6P2hYGWW4W14gckt
2084	payment	1397	1397	1678	1	1	1859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLhFcmjFBgRE41FptqzaEFe3BEDKWgSvxeJLozzPaXh3jG763
2085	payment	1397	1397	1678	1	1	1860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu4S7iMJwpuLXLni6a5wuWJTZpRp62PhEXYfgxUDA7Jtkn7CQW
2050	payment	1397	1397	1678	1	1	1827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gtyRhw79dcfvz7gJrwQXH6LArVB7cDWYYecsQcaxKRnHo7Yh
2051	payment	1397	1397	1678	1	1	1828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgRVtUJDkxwYb8djxwz4MieNWuhWEYVZ3KVpKLYjm7PGgzPxF
2055	payment	1397	1397	1678	1	1	1831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRuQVTh4NdAkbnjkLCBZfwvG577mtQtui9ZiduBzMosBbS7MF
2056	payment	1397	1397	1678	1	1	1832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6kpURj487cM3WwaF3CSrh2Ehzga5mEGUbstKkZPZoGg2WceH
2057	payment	1397	1397	1678	1	1	1833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Jjmob5uQXZR5yBRQAPE4sQzkoKiVS8wTQSCJBGkTGXs7X47r
2058	payment	1397	1397	1678	1	1	1834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3W5KVJd1BnPjnu3e4VUfBhVPWqpCS3h9DWU4TLZkX9KoJFUg6
2065	payment	1516	1516	1756	1	1	1	1440000000000	40000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqQY2Rj9iHQ2fFdopVkuA4WrmbwSxDwvAAAxb9UDHayQiziaa
2066	payment	1397	1397	1678	1	1	1841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvosQ5qECFGfwzn7x1wBVwd2ezKuGK4atbE4r42pgUnhZQofS
2067	payment	1397	1397	1678	1	1	1842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgErU7WezfTm2dmZX7zKKu31XdxGPvq2qS9ufwJbZM8fef36sx
2068	payment	1397	1397	1678	1	1	1843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZcfmLc592zUabUv8zddA8Qr3P3LYD6v16TuhgbsG65LNh7Qu
2072	payment	1397	1397	1678	1	1	1847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnF5Ts9FNvmXxWQ6563w9kcwN52W3ZNpCwaio9KEUWXkvk7UH6
2073	payment	1397	1397	1678	1	1	1848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnFucfoaLUuvVHzZE5QujGF9VpneyP4D5bwSJDgzwd3FkXrRD
2074	payment	1397	1397	1678	1	1	1849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXW5gtPoMkG7iymYcDNqsZDbXZj5LqgJMCkByrk74kq4pcUjw
2075	payment	1397	1397	1678	1	1	1850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCa5uj9yK7CxzHeQc8EeuYq98P47xDp2JnQi4k2Jg96PVFZc2
2076	payment	1397	1397	1678	1	1	1851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVxS1xucaPfqtnd8sNtSkajam8vdWDrxzft5gKqkCjkYKpbFW
2077	payment	1397	1397	1678	1	1	1852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEUd9HirUXCFqBtUkMFyvAEiGNrm4HFjYEqbuMeUyPWjoe4DA
2081	payment	1397	1397	1678	1	1	1856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB63Vt8FVQPEEw4DGuxDhyjthGjDq7jzmxVdMVg9gKMNi3SxML
2082	payment	1397	1397	1678	1	1	1857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ1BEuTiMv4FYS5wgcyYZjTRVAWuLQPnddQ8xGyrmjygvCHUS
2086	payment	1397	1397	1678	1	1	1861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8yiZxeUCdbGfvnxa77xK2Ud1U9SAx1EQMEeG8mA9MSdmdMHN
2087	payment	1397	1397	1678	1	1	1862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bC7BnaKkMDtXemEwBAPeFPFNu2UkgfJQmwxdJurXwPMP7KXC
2088	payment	1397	1397	1678	1	1	1863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo8LpCdkSVZJhWLasXRWqxxWdtjBwL5majABmoCjjHkffoPTR
2089	payment	1693	1693	1765	1	1	117	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZYhz3TFL6FSJHqapTEyZ3zgWAujviYJFou9739GqQDo7zU9jxp
2090	payment	1397	1397	1678	1	1	1864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3si3u4A2MaffTYcAzTaJQzkFYRGjATCttP37CZ5Dzv6RdXd6
2091	payment	1397	1397	1678	1	1	1865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JiME5ecSnkmjYrjiuPemmK5pquSjPXo2MNFxJzTDjQE68niU
2092	payment	1397	1397	1678	1	1	1866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZ8Yd9Sr8qtkYXZ3KUSoxRsu3xQzkvp8djYT7SFguceVuFVko
2093	payment	1397	1397	1678	1	1	1867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijbmE9mtYiPF8fGC1J2vRuxVE8Exg2PPZCYJTjpsakc46mae5
2094	payment	1397	1397	1678	1	1	1868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScCvVKDM9saDuLXsxvsQowxkJ1U1AHJtAQJ1ZLEQnR8LUiAZH
2095	payment	1397	1397	1678	1	1	1869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfCkJpZZrqQVCGcHp5X9Gbspy6BncD9PA7rNxDekdzvwe6oN4
2096	payment	1397	1397	1678	1	1	1870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD65M2sPtgs1VrmhPAMyvYnGTD6XkpkinLEYro2xZ7NjEDb7v1
2097	payment	1397	1397	1678	1	1	1871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdvpavdmbztFRurs37qsbvhCsAkPz1Ky6XDWBhatiXzRYiKiC
2098	payment	1397	1397	1678	1	1	1872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UNGJLM5FAxTzhSoF9gAaqudmfvnGv82TgESqgK8WeX7C4MeM
2099	payment	1397	1397	1678	1	1	1873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGihWQ8TxJbe4aTWDVa37EXhuTjs5U9YDzTkTrzmHxUeN7zyq
2100	payment	1397	1397	1678	1	1	1874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CewKMjQ1Qx8Z6bZfaX41UPvC63arESGjQtykCf7AhmM3zWaF
2101	payment	1397	1397	1678	1	1	1875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2sGuM3FZAcWxKuNDMPjoAooBh1vU8qGLUDAKMXMj8RQFpFjn
2102	payment	1397	1397	1678	1	1	1876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjURvMkSL4W5byCqWzsXCTof2kYdqLJ2oTTgkRbymFYan1jWTe
2103	payment	1397	1397	1678	1	1	1877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYY4wCMcKDwje3CqvNxeTsT6eyirSnLTARr8zGHpYd3zigMoy
2104	delegation	1706	1706	1646	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApBonfQSogz1osr6ERxK3HVsT81QmXX9FWbNEsYnjz3B2JnyG
2105	payment	1397	1397	1678	1	1	1878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1BN2bukecWP2ikn1QSA3mbmQoFGBQG9ASj7zLohjE5vSGBT2
2106	payment	1397	1397	1678	1	1	1879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtv4xvp2Y3yyMypMFi5DYZBoLCw4ffepwMFz67cjXPwQrqsjD
2107	payment	1397	1397	1678	1	1	1880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SwEJS6wRH73srgoRcDsg126w7yGVXLSEB64EXQfbVtusxi4r
2110	payment	1397	1397	1678	1	1	1883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAtwMd9GfHmWtxn6JvW3vfjX7VVTY3PAnVHF8FgAPocQqFqpg
2111	payment	1397	1397	1678	1	1	1884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QGrheeNTEYHasUYZS67FRXFFeqKWweyGX6UnbuveJbmELo8g
2112	payment	1397	1397	1678	1	1	1885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtq2WDg4Mb5PHEWcHo6uZGyRPnDWSyHsSnF3VFecxAvtzp7R2
2113	payment	1397	1397	1678	1	1	1886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkH4CS5Ru66i9ZWVThZSLrkX6uUaGmcpVVfUigRGJjzTUd8m5v
2114	payment	1397	1397	1678	1	1	1887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnnx9UDh8fNjha8kg8ANbcTCgqexFW5AiAzpZGAuAKWhsgFby
2116	payment	1397	1397	1678	1	1	1889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuEZ2czwU5uAiYDb16CrJiEZXE9YBtC1qTctPkWCKQ21hDpmM
2117	payment	1397	1397	1678	1	1	1890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkp6Q7Rk1u4cBPfrcfqFNivGiSFDvBpdFrrb7RJ1zz8iUdkbgZ
2124	payment	1397	1397	1678	1	1	1897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hYwb2rRM2qnH3eRE3JXCV9q4ZQgiS1DfLj78Ms8N7v59tM7Z
2131	payment	1397	1397	1678	1	1	1904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2ArXMDG5t2xnPDsRDwaZyZnmxtKR7vnQ4SGwFFdvpHraEkxF
2132	payment	1397	1397	1678	1	1	1905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkoS1QqXgi4vSDxJnrgZCdPJEwErtCrMgvrbiAvF5pK6Wychd
2137	payment	1397	1397	1678	1	1	1910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcvwNxku2YLYv1YNpnjJiLQUhVLjU9nWvdJzfDZePEWhcd8eZ
2138	payment	1397	1397	1678	1	1	1911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjfjRkbosbs9Uzr8H48CgSEWXySeEcYaECTMfnEVpzN1d33ex
2145	payment	1397	1397	1678	1	1	1918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8W5LXQeFSgtwGs9cN7Qxgz6boWTDCb62zA31JSvRWbipPnDh
2149	payment	1397	1397	1678	1	1	1922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6quZiiHwk56G1dUS4r4ReS9s21YJjXdVQtPjV2pceEmzhKaq
2154	payment	1397	1397	1678	1	1	1927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZeL56PcPSFXP84ivQzyDtK89DXHfAwcukzSPYFgKPLsmuF1V
2155	payment	1397	1397	1678	1	1	1928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPgAZKtCc2gLVcz8ocvktkWemFMJX9LedKR1iGBbRguuxakVn
2161	payment	1397	1397	1678	1	1	1934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvJpzyMtA5gte2ycB7ak3GxFi2YQMguGkL8Hbq1rZFQeBHnYb
2162	payment	1397	1397	1678	1	1	1935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqxmX3nTi9aCyqmhNWN9HiaudDxsVTxgWizsmyCuy359inLMP
2163	payment	1397	1397	1678	1	1	1936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZzNjpyq5JHjYHBk8LhSDKXGidcubgK2ecaQNhPFvpKfoFkf2
2164	payment	1397	1397	1678	1	1	1937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtxtAAWFF9L6ZBo5qp9fdwTZftgVzSqD4HLtzw3Yc2QWfToKy
2165	payment	1397	1397	1678	1	1	1938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE76kHj91KvYsrkdVKRjAx8QktWjib9hzJL4e3NGVhVQTTRoe
2166	payment	1397	1397	1678	1	1	1939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNyogfoibUL2r4jLmR8jVmNcutBT58LPzxFKyqjXfQt2VGpNr
2168	payment	1397	1397	1678	1	1	1941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPP5dwhNkQg7dT3bKZorudXYaCiuPXfzZ7eR8GDUGVEsqVx5L
2174	payment	1397	1397	1678	1	1	1947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kZNgmZAjHkizPRVzhbeDriCTZGTGADLVNeciy12mRwaqKpsA
2175	payment	1397	1397	1678	1	1	1948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYto7p9WnBNwfAukySH6er8fHw7L3Ce2sG9rBGSu19ogyYw4iYs
2180	payment	1397	1397	1678	1	1	1953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnfDSLkWnYAouj3s3cT3kVY9WCVqeJ75ExZrTbHxX1eQawfr8
2184	payment	1397	1397	1678	1	1	1957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDRqxNfG8qTX9hv1hRUdsJtBqoKqFLapxv4ydnptZFVHtg55D
2185	payment	1397	1397	1678	1	1	1958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81NaYvcxQDvB4fPCqPvYBTx36Pm2zmjcCfbAzn8XP47n599GQ
2189	payment	1397	1397	1678	1	1	1962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbiSqvyz9C8pQKQGFHFX7b5wg6TCTDWcDJoGZmAcLW43MsHij
2197	payment	1397	1397	1678	1	1	1970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszA3Ap7os2XpahHyR6giHTUo3citgJFQXsHHUPCK2Y1WRomAW
2198	payment	1397	1397	1678	1	1	1971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbLFB8QhUDVJNxGx4hPKK23GNoiqnXbhcT8hGzu92wRfXfoAx
2199	payment	1397	1397	1678	1	1	1972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3aQ1aCnbXjPrp9jZChF1KdKMouP2EZT6VYvGSESaVGdAKSq4
2200	payment	1397	1397	1678	1	1	1973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioV6hMZ3QoVYfZgjKoHdSiXoWDNHJjH9PmbAtzQbefVnFoQti
2201	payment	1397	1397	1678	1	1	1974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTbP9BiTzHBn8JcpRizCVZwQDo2Sso7rUZNvg3Q3NQJz5F3yM
2214	payment	1397	1397	1678	1	1	1987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJmvcwfepEFXUrtmoLXFEnGzk6bo7KRpHZXJihc7djFi21nrU
2217	payment	1397	1397	1678	1	1	1990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hK6c5mZvUudWy5PxpWGmEkPVvmgBmHtg5AEAHzAm5VMtCcF9
2108	payment	1397	1397	1678	1	1	1881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3679HAuLCwMPgBxvA5PjZDm6yKPZ21qzvp4YrBJZa4HQfuqkZ
2118	payment	1397	1397	1678	1	1	1891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8SB5nNpKdNLErv4uw4R83MrCMjUeAEFPNqhj3CCbnpmUTo6w
2121	payment	1397	1397	1678	1	1	1894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQXr1U2me4B2i27FfcKNd6kZamLB9J8X1ktjfPR9EyrMGQrXkx
2125	payment	1397	1397	1678	1	1	1898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePLqL245RcNLnfm5RDEyiSKUUCVvRQ8eAGcV6MG4ZpEDsXA8y
2128	payment	1397	1397	1678	1	1	1901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HJS89GWkBZGQDDjCTWJgKeb7UpcbhanTQ19aetLD4FTB1pRY
2129	payment	1397	1397	1678	1	1	1902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3toEHqWw1Ta12Yg54sBa36V5jYL6EjyvXJkbUAmssp5QpMXF
2133	payment	1397	1397	1678	1	1	1906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hgyDWrCcYxDXiuVKHrdZfGuBcxAqoLCFQXq8G32cBYZ9mzmn
2134	payment	1397	1397	1678	1	1	1907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWDpThgg87VqhUkmwdobStjfF6MqWrsHVEfV3yMj4QtzPtJ57
2139	payment	1397	1397	1678	1	1	1912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes5XuCjdJbjSAXArjezYSKUjT5R2BU51ao4LB3FKHKdcTxm4z
2144	payment	1397	1397	1678	1	1	1917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DKkwpTtE1FUkwEAN6MkxNaSp2v1wv1FwnKCkRB762QVzYSgC
2147	payment	1397	1397	1678	1	1	1920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1UvQtYQkMZPViCGgxLmGkx2MWUftrZzLvtZy37vqPTs3hfj6
2148	payment	1397	1397	1678	1	1	1921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c4AZY3nNKragkvhRKhzbYvXFkxhVBATnfzW1fE5zNNGyseps
2150	payment	1397	1397	1678	1	1	1923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzL5PuzxPQ3MgNyF4krumRr2UAvcs4AgqYVvRH9wGkdL1pjEM
2151	payment	1397	1397	1678	1	1	1924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4SP5FNBq8LbWdyPxV4GussmGq6Rm6fzThgnekMbDcZTEKSR4
2152	payment	1397	1397	1678	1	1	1925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fcRvvoBWadyUHg6dYE7cd3B2Ukbb1gCaNw3rZ6WdnZWwwicA
2156	payment	1397	1397	1678	1	1	1929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo896mZ4QpVu8WiWdehCgQXGakZ1eg6Haq8tC6jg7uVC4WRCVV
2157	payment	1397	1397	1678	1	1	1930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAR6QxYyoVW5vTXRW2zkuKnsCTg7YYeUztdSUj8wcvRaGxVU2
2159	payment	1397	1397	1678	1	1	1932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLy2mkBV5rz3XsUPoauRvsG1MbRMrY4XtAxR1B34P8zHFGEbr
2160	payment	1397	1397	1678	1	1	1933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJAgRYPHBMqjytpqL3Hs34hs8gpQTX91RkvEy5zXLic5i3Tph
2167	payment	1397	1397	1678	1	1	1940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN7xvHdmrN2wnE5yT7uKkiqtt929CRLA3YH7E4f35D9onmB45
2169	payment	1397	1397	1678	1	1	1942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrXRLADfU2GhMNR1SvJu9EopM1mYoaHAm7BNCQv77SxGxgbJg
2172	payment	1397	1397	1678	1	1	1945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnDRMYFA63ShF7uXKLrjgGTH6qk2UnhNnouLF6HymXfsuVbfhg
2173	payment	1397	1397	1678	1	1	1946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYT6UqnPFFVTVK5amdsrt6F7c4mP2c9ESw6jg3JFfvagNamRGW
2177	payment	1397	1397	1678	1	1	1950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gWX2MHRh78MgvLJ9zq5ytHGrWUzAun3cctc7cKBKydKDYHK6
2178	payment	1397	1397	1678	1	1	1951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBBrfbG33X4DdsNX3c7HS3qyXo1iFFsUMgLhAbzaw47jhcWFf
2181	payment	1397	1397	1678	1	1	1954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEYqPejKKm2xpUezwg8qE3kmVpoYD1Z1HwqFfpD5oUkaBdQyW
2183	payment	1397	1397	1678	1	1	1956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq2bqkCTRt6hny5zr9eeiP1YgvEsoAUvGYqErMx1N2rvSYrQE
2187	payment	1397	1397	1678	1	1	1960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBfAZxLViiNTN5FYAdiH39iRkEHGNhMyVC6B7Ara6Z1XSdZam
2190	payment	1397	1397	1678	1	1	1963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkf4Mru7tVLxCQrs4unr7unG9LyQq1DNpFcz9Pfu3huQSEBfxZ
2191	payment	1397	1397	1678	1	1	1964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzEcJz6GNr2AjQm6HyzedwoDQAssogTCki3GThhmYySBoRNPG
2192	payment	1397	1397	1678	1	1	1965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68otQx5FEQ2UGh1X5GPy6PRsDVcD6Mac4EDEt5B86qcYKJTMB
2193	payment	1397	1397	1678	1	1	1966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpt7gn1eKyXZ9XPHSLyn6gDLCtWXzt3ASjRu9hXPtg26f5rhve
2194	payment	1397	1397	1678	1	1	1967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GpoewPb18biPn15bHsvwLoZf7JQyqXMUdwKdbPDx1HWCk8xB
2195	payment	1397	1397	1678	1	1	1968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sbsPqKAu4tiGdrvFZS2h7awGmbk6LQ2EiYdZidqZf74jFVPq
2196	payment	1397	1397	1678	1	1	1969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5BVioV4mpZiCBnYSUdY4VCEUWcYqZRiVD7Tjun9VNP9kXmh5
2202	payment	1397	1397	1678	1	1	1975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZor6HpUmcXPWgFeGYbxmagaAPqTu4BPVL26ZRMRayrToMrEgAg
2208	payment	1397	1397	1678	1	1	1981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCD8iW7756gWBZiCqPwiAGVrnQg8cYYMnn8G71BDyKAwZYQ3Av
2209	payment	1397	1397	1678	1	1	1982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJHb2igpJP7Ni3ZPDeEd3NEqRyjkLnkNg5CS4LcySDeFX88Yc
2109	payment	1397	1397	1678	1	1	1882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfyVQVy5pBH77uLaixSLSeJvENgznmQraDdDLhLeud1DS5p4Pq
2115	payment	1397	1397	1678	1	1	1888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cmY8fSWxVf7MY7GS881BwmJCtHRDUxdu765oGnQXfwVVMm6p
2119	payment	1397	1397	1678	1	1	1892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNxNsvJgWfBEJfnXfESWFQUKLdFw9GfSaqi21wTkJ51dUXVy3
2120	payment	1397	1397	1678	1	1	1893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipcPwHya2d2G1KgjL4bkpktiVmQUkjP53EABBqjkHM8Gc3RNh
2122	payment	1397	1397	1678	1	1	1895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrWL1SEvU4CQg7DYuf4Fq3vxYeuCbYMMfp9J329fqZhY9yLw2
2123	payment	1397	1397	1678	1	1	1896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvLssb1A8bLaxot1zDdWrYNMdFGUbQ6DEHYaa4fNJQMdYJWax
2126	payment	1397	1397	1678	1	1	1899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoso8rMDsp3Y2XWqzbJfPo49jX4RCCcmSxEUiCimYF6Cd2PGir
2127	payment	1397	1397	1678	1	1	1900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QAMTQAT2h4BxKKdrqdYhBACfvZHJeFjkdqWRoeokn5wasWzJ
2130	payment	1397	1397	1678	1	1	1903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLJZyVUYwCS6B4R1R2uW86DuqWVNqcnH56VxpiWS9bp6N5HjL
2135	payment	1397	1397	1678	1	1	1908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uoVxmnGXCu4QeMhthi6YdMUeb3T21NfxWSHUv2hZ6G3VGZVt
2136	payment	1397	1397	1678	1	1	1909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPALLySKf6D7UETvCmjLdBUgcxeYC55tkKLGLJJHMJ4puoMBUJ
2140	payment	1397	1397	1678	1	1	1913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qUVv9cTXDuLesY5Tvz8DWhVTkwgckeU9WFjJctWwphnDUz2k
2141	payment	1397	1397	1678	1	1	1914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoAmkw2usWQ4Maq717pw6HvbRTGiYzFA3im7JmDEYc9RH79ZY
2142	payment	1397	1397	1678	1	1	1915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUyf4EUPG9DpPFi8vVLYtekBUTDDgpXmAt67cMSbzxCSaLsat
2143	payment	1397	1397	1678	1	1	1916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPs1HwvRevScJVU4ZZFBrY2qKU6hmtUZUQxtDD2G3i5CJjA15H
2146	payment	1397	1397	1678	1	1	1919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VnWcVBw3aZhi9vG1qvW9VG9kh39PaUuPtXpp6xX4oWXnGqkM
2153	payment	1397	1397	1678	1	1	1926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJz8rzuKvu99U8NRRY42aquyhmmghQ6Us7xqSt2rGNwMqGynNx
2158	payment	1397	1397	1678	1	1	1931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNXXGgZAbPW2CNTokcLb917dxQBj8evH8yaRg33bnQFdZVqvQ
2170	payment	1397	1397	1678	1	1	1943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL7kx6UHowUGYmfvSyeRWWfPCdGyCJnPx5MCJJD4RzziGtgbU
2171	payment	1397	1397	1678	1	1	1944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCedCtjqBoFtfk8YCqYSh6MVqgJJj9FddHUQUMKoJbnDcoMeB
2176	payment	1397	1397	1678	1	1	1949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjXfgugn6W4MGKrzjCWj6s3tzPLtRt4i4RGhf2r5DQzZd8ypa
2179	payment	1397	1397	1678	1	1	1952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrESBnBEy3k4d555mQfZrJyPfbB4A5zu1uzoCBWiQXvzBWjsTR
2182	payment	1397	1397	1678	1	1	1955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYune2vdzezu8p1oe7uDQUygxSfjnsfPLUdBbFzeq3JNDEYo1uE
2186	payment	1397	1397	1678	1	1	1959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA3UUU6BAzJvvPqgu6EwE9Gqf3ukupZ5Sm9oSxQc44SUrN6Ga
2188	payment	1397	1397	1678	1	1	1961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcu5YimNUfJS1yDLPkwFuggkLFb7Rk49NPfQtbkW4ifQwJcw6B
2203	payment	1397	1397	1678	1	1	1976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCX4ujpvEU3haHuWdP7khXi8Q9Pu4DwFPJCqaDWM8FPxuPH1H
2204	payment	1397	1397	1678	1	1	1977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HYXu1b3DJimHFXWZWrKNQbuW542sTsHbD6fj1WVHgCPBAPfc
2205	payment	1397	1397	1678	1	1	1978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZxx91GDTZaCjxsmYiQfpT5jCgvvM7g6eSyo8Sxr8b8adi6G8
2206	payment	1397	1397	1678	1	1	1979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTER69ZSEfawmrftwEX4LgJ666hJw71RJfYJAMYqPAPcfszVj
2207	payment	1397	1397	1678	1	1	1980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5amLKXrSQ7rxKXeWNhnc1qYo4EXf1k3pNvVUq1fkWkfDwAt78
2215	payment	1397	1397	1678	1	1	1988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoWyJvyECfmQiWhNtZh78uFT8Jr45QeUyd331K48San7QTtzg
2216	payment	1397	1397	1678	1	1	1989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3R6mJuRfse7HWSDJSyeBkVjSSYRmQYGeHwnMMVKJKuZbpM2n
2220	payment	1397	1397	1678	1	1	1993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kvh2xxjPewh1CHwNym8oaEQkD3DR8Aw4zgJm6QfwetYu3Txp
2221	payment	1397	1397	1678	1	1	1994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jaVDuxvhH8DyKoRDDWZh5Dhh7oM1ExCSFjdMnkXAk3EbYbpg
2223	payment	1397	1397	1678	1	1	1996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTuKjcMiwQNBDibjTztVxJP8Y41QQfkazn5YDzfzCDrmbXyAT
2224	payment	1397	1397	1678	1	1	1997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQZ19c76NsqfGF5HoMNb59gXDQytJAUYzigdDwEoGRaTEU36g
2228	payment	1397	1397	1678	1	1	2001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXucBs35u7Y9xzdKNcqZh68uk6fa9rUd7da2ZKWinxAhU39u8t
2229	payment	1397	1397	1678	1	1	2002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMZaUGAZMGsZkBRAERts5eMoavRN6e9Hp96gr16zkfNc12G7f
2210	payment	1397	1397	1678	1	1	1983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvqguKJLT6Hqb5dky2Pvd38CjU7qYkSPimoZcY13FPSA5eveV
2211	payment	1397	1397	1678	1	1	1984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDiXBueCb8q53SqydEyH5UE61dEBdAoH9PhqRtdn6e5r8TZg5
2212	payment	1397	1397	1678	1	1	1985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5zm9w8fDPk1f2Vzoyi4abFCTK3w3THfHnTem7soXmKMWiN3M
2213	payment	1397	1397	1678	1	1	1986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQFpMEpUVV2untB7b1kUFtnXNsqAXv6PZkfxeygCCKUVzeP4f
2218	payment	1397	1397	1678	1	1	1991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6f5utrb3xUTtQVLiAtNSwQysiCQP3NTCodimWAhJ7TkmdSLq
2225	payment	1397	1397	1678	1	1	1998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZN6SQrX7CvFvxg2yuBnfKaDrJijTG15HWHzDMSVttPZRw1G6
2230	payment	1397	1397	1678	1	1	2003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy69qNt7171RK8qrpW7AYTW6XcLV2mFnN6q4QSeGUX2VQuKvj5
2234	payment	1397	1397	1678	1	1	2007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4vswERRDwJVXcyZMbWypiBh2z3sXBe3f9Y9rBQy9q7wBW3YV
2239	payment	1397	1397	1678	1	1	2012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pAaMTqvgAknCZSi676xiwSP2Adhvc1m1N56xNHhKHi8jYxUN
2242	payment	1397	1397	1678	1	1	2015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ipCHN53QFAaunuuFR6jUEQhbz9wVvgF7nYunHBeE47mLCEk
2244	payment	1397	1397	1678	1	1	2017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ8QeV1uaLsweJmGAPSfRvrpEngASZVo6xummLNFd9xLYfQYf
2245	payment	1397	1397	1678	1	1	2018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AQZorXMCqiDkPigKbdqACYBPdJzRjfJjQgyLaBvGm2WZZ57G
2246	payment	1397	1397	1678	1	1	2019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb13pJpSo5yW3CRCCUNLqEYaSzvU7Qko2LtX4j9mM9ovacydaJ
2255	payment	1397	1397	1678	1	1	2028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9mA2tcUzVYhayZinVmUdTJMXs1hWCRhz6PJdBWmqR8aEwTG3
2256	payment	1397	1397	1678	1	1	2029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipkF6Wiq9dgARZzrPmWWusRXXVEqCL9itKzfobuwR1FR3pwaN
2257	payment	1397	1397	1678	1	1	2030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswNJW63Y6vWiGK8mSEpqJRWtH3ojxZ5B4Nu5eoFao5WNaYhXN
2259	payment	1397	1397	1678	1	1	2032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyyvtzF6ri3NRZfT1TJNBx9FegzAod7W4WTrqXWvu4vXgpz7G
2264	payment	1397	1397	1678	1	1	2037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2q5toNXVagQ1DDuhnAbv1tko4rKt4rj3GiwXjL4kJ4XLUJm9
2271	payment	1397	1397	1678	1	1	2044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREt8u3BQVXpGRvtnUpggSR2auM6j7xAvSdDJkCvCJnQkmdAdq
2274	payment	1397	1397	1678	1	1	2047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKfa7qHT2W3Shw7PbNyU6Sg1xcX7WKa1mhN6pNJNci2k5ZE38
2278	payment	1397	1397	1678	1	1	2051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTA7G6K9x7BfHVpxNpQuPfYZLjqbc3HDQCwNTJYKV5AnpNCfZw
2279	payment	1397	1397	1678	1	1	2052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTNK5RdbGwwNM6nfWwguJPSi5NDgdQpibtqJ7kRozmWwwmjBu
2283	payment	1397	1397	1678	1	1	2056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNwnmi5N1hN3AUuQkPNyAdTqRdBWaq5mRNJtW4WNXsDrbvTK9
2287	payment	1397	1397	1678	1	1	2059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MEom9GMxExiN87ZiEZmFnfinUwm7CppkQVKV8ZtxJ5nBSy96
2297	payment	1397	1397	1678	1	1	2069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXeeXHJqMjWC2fgxZgnkyssrBQSNvna7UzbXggQMEGf1yquFkd
2300	payment	1397	1397	1678	1	1	2072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgLNdKezarBcK3qia4VUEj9J94pTZawxewtLFFdhfemwUtGub
2303	payment	1397	1397	1678	1	1	2075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpFVwm6BiftkdaiXJmvKkd6tQYd9nTUvrArvoDFZvUSNVv7Fi
2304	payment	1397	1397	1678	1	1	2076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9ttDCcyM1qaRfL5eNg1sfAjGb64kSJR7vCKGrDmU9jQasyTJ
2319	payment	1397	1397	1678	1	1	2088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYTEywYtH58LbFWVhxALRWtbBDPRkrWZYTvYQ8Uo6CCi6TSTg
2320	payment	1397	1397	1678	1	1	2089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNp6cXibi2TdkXqcmGKDigxdg1EaiC2HxzXVAGjfsV412RAZUZ
2326	payment	1397	1397	1678	1	1	2094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUcYY6uVkr5iMh1ZtysEKueGK6z98NwzbZcYUfMacjMNQjuoc
2327	payment	1397	1397	1678	1	1	2095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfNiHcw3TC6qbA289L4h6ugEBgPyT1tYjjr7MASFNaMrkyW17
2328	payment	1397	1397	1678	1	1	2096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8anLz1EnV4PYWqoAAi3FCd9ZkkCwx4jTGucBmpd7H11K1Zze
2330	payment	1397	1397	1678	1	1	2098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKZn6nxhb6x15SKgkFg4Deng6J69JwU217Z6shpJYfom1Krrq
2331	payment	1397	1397	1678	1	1	2099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc69y3RS58BiPUngY6eN7kR6fv8LRf1L98bs2Dmt6jM66dy8jT
2335	payment	1397	1397	1678	1	1	2103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFmcfaE8witP3dxqE649azcQAA9mfYn3noJfV6kAXvSvNkpXm
2337	payment	1397	1397	1678	1	1	2105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghFLKvzoa1myFjW18yxmQABaSLc3ZakP6tkWZe94T72iRxXFa
2338	payment	1397	1397	1678	1	1	2106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXCD2Vfo42vRa9Cus4VpKqvWY8fFfpPgefUsa2zAtyDR7KYuh
2219	payment	1397	1397	1678	1	1	1992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8YSKjLseHfbzti3dDUPafaMg9Y3X7MYdXrUfH8pz2te6dKWr
2222	payment	1397	1397	1678	1	1	1995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuM8x9UhnXkkGEcsyK4Fqk2zQqGPRgn9Ai9qNiPPs6nMf77Uv
2226	payment	1397	1397	1678	1	1	1999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvijn7FcoP6P6g5ksSHPcQWSeSE1wNrNFgnqKaAgBVfanQQai
2227	payment	1397	1397	1678	1	1	2000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfotHcGDrvPZAUGp92PVp6dGepa8GULjgdzz1GWEzqBfFidG5H
2231	payment	1397	1397	1678	1	1	2004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhD4mqmnGXkDA3heVyZYsz1bRuVVHH1fGPK2vyLV4yp7u4U8Pj
2232	payment	1397	1397	1678	1	1	2005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrqiKiFjE3EA3hb5X2vXiAWN1KzrqW4MA7M2c3wjKHGq2Si6s
2235	payment	1397	1397	1678	1	1	2008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYiyztZRyQbCBQQZ2WAES9B7TtdMTUafwyiSoQdRbM5sinR5n
2236	payment	1397	1397	1678	1	1	2009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPzJm16hua2i28HBLKb1eau1bxczX9N5NBXjtftihHsXsAQDP
2237	payment	1397	1397	1678	1	1	2010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6zhhcxUdpXJnpLXZ3fnrueRJzkZxUk6p989N5ortxYShCxC3
2247	payment	1397	1397	1678	1	1	2020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AnCixcwXQ6ZDDxqM7gocPYpk8MC2axs2FgD3eY5LhuuKoUAr
2250	payment	1397	1397	1678	1	1	2023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju5N6TLMaYH72v6Nt11YLW96hE2TKS4yGN42b6BWLAQDW2eYn
2253	payment	1397	1397	1678	1	1	2026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLyTt4kB7XZ79WK3LmqeF6rD4DueAHF4npUpMLCitVnMoH6Q1
2254	payment	1397	1397	1678	1	1	2027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo6jjrdFhw41Juct3GerkQ9tDCw5T3Uqar1xnGYiA27ASfbug
2270	payment	1397	1397	1678	1	1	2043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjhFV7FWNdtsx8vFig3Q16dG7mLkmUkfEB17pjRb2dizCoMK5
2272	payment	1397	1397	1678	1	1	2045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEgzHGCGgV7sR9vAHVQiaW7afC9CgSqfbQpDyhq6z6bJdnDN2
2275	payment	1397	1397	1678	1	1	2048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVokkFfJcF9ErpC6a9BZ4ktQB99Eq7dcViXVYv6hWGGoAvxwV
2281	payment	1397	1397	1678	1	1	2054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkQ2uVvbgc4gd1RagmwfamC3BYt8T3VmGv9Q1DQhHEwej8nP4
2286	payment	1397	1397	1678	1	1	2058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7tAWALg3Qrn1PMQftRAeKjfmoyGpBsyF6MHkmeEPyb9j5jom
2288	payment	1397	1397	1678	1	1	2060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjo2v9B1X4LMMjGJLBKeFe1abwzApAf2F2GH5rX9seYnpNY7W
2289	payment	1397	1397	1678	1	1	2061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnHiksz9mJzUd8drieHvUwuCcWyufXntTdBt8x5DD8ueWEx7N
2290	payment	1397	1397	1678	1	1	2062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQoqpCz14ztHk9iWPjr5x9NWTEtUMQEV2cGycQCZcFbGZagCK
2291	payment	1397	1397	1678	1	1	2063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK52kLj8DQYbBuXZSYFeYva9fDzuodKe2jcDyVbnmXPXpQnFt3
2292	payment	1397	1397	1678	1	1	2064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUiZ3vPKZb7pa1wM757SrPvBnwA1pKzX3TPf6ah7eVLyfhBTA
2293	payment	1397	1397	1678	1	1	2065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLzN28ETDeM48MTndFhxYcAngh8buj32V54mX5BnphpQzDUDB
2294	payment	1397	1397	1678	1	1	2066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kUxvZ2wMzF2NHJtF5jRtQwxmdU9vgf6A6rpqXaCkqohno8ut
2295	payment	1397	1397	1678	1	1	2067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1V7L3sVNcj3QjYAyDHQxu4SYhzUxHmut58kJvUZWtCoWbPb4w
2296	payment	1397	1397	1678	1	1	2068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDffm6Ueoz3TqCYrQk5sh1TUZ8LFrYbcBpfmxB33DaQ24c612
2298	payment	1397	1397	1678	1	1	2070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjrCNm5ENgX7SkjrYRKDwqBiYbQB2cqQEHiX4DcNicpSDeRHY
2299	payment	1397	1397	1678	1	1	2071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMKUatkyGKUfE81dqrgXResTU2DtfQfXWZD65y41Q8jaiZH6K
2301	payment	1397	1397	1678	1	1	2073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH86yq4xEx3YgYizkUJEtxw9fmNUCt22aVmFzt4dCfYdMh5VAs
2321	payment	1397	1397	1678	1	1	2090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ey9mqHxu1nP2j8Tzeqw4aY9i62dLgcHqVZdCchHfAByipd2D
2332	payment	1397	1397	1678	1	1	2100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PZmZgUrrYxorPeaM4pYuE2eWzivjEv3WMt7ghnXVEQxZp7FD
2333	payment	1397	1397	1678	1	1	2101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJfjb4iwnDchxy5eg3XPfAv9G5HTe4FULbCC8nPBWJCKCbhMD
2336	payment	1397	1397	1678	1	1	2104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuE4Xo78WjHh9FDpibe31QaeWAqqXNnv7GHmB6CoGow6kH6PPr
2341	payment	1397	1397	1678	1	1	2109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShqtEDvhLsmYuA5M9dYV7ukgQBJCyDUagYFqfah4RXMsjoHKj
2342	payment	1397	1397	1678	1	1	2110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxJj3GJKpjdmg1Z88752fy4rf6vHeftXjAMWDY28MsRRAMWRk
2233	payment	1397	1397	1678	1	1	2006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UTU74vJ5JXbmWdqRoGEMm61KuxJPWDYy5gjBPxoL7hAkAudP
2238	payment	1397	1397	1678	1	1	2011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLkA3zptNsGXQ9fmiMaa9WPKQksUweBiJ5z7R4DhYYhPb4qkp8
2240	payment	1397	1397	1678	1	1	2013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPyaUZcYUGxHm84jZfoPd4JpJoxN9V8eZg3HTDEsGazujhh4m
2241	payment	1397	1397	1678	1	1	2014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpGeDRFCRrhjnPBEbAxoCsQ56Y4XAhGGDzdhRTKgTKDxUQmuk
2243	payment	1397	1397	1678	1	1	2016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgyXq7mgKTAc9PXT8mdFdeSv4JWAyPbZz393gnBraqs1ZT1EB
2248	payment	1397	1397	1678	1	1	2021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4q5xDCNxSHoCgYx17H7N1EyN1tJ37nG1AshcgLDYMjhq8EMbq
2249	payment	1397	1397	1678	1	1	2022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2B9zJ5K2jDYh8VKEDX88V1cNPRfYw1bCn3rjqhf3EynXmujE
2251	payment	1397	1397	1678	1	1	2024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQP8sMnaCe3R5VrmwNP7cnpqeB1hkbxiRkBtQbb24brCT98Ja7
2252	payment	1397	1397	1678	1	1	2025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjaQSvji4QE1iQ57qmoH2TtJVEvCny659ddaWneZCJMzLb8mY
2258	payment	1397	1397	1678	1	1	2031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchmcKeRQptfTKssHBVgwVBfh9iorLYwkSb8GJbLDsSoBXo6pz
2260	payment	1397	1397	1678	1	1	2033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaFgcKMHnGx1dBhDoNDsjPY89jAVVWLYbqqyLHHf7c8zKaRWj
2261	payment	1397	1397	1678	1	1	2034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLDfv9eNGjiLrdjitzkN9JVN6Zrnhx2hUBj7gRhC2CUdoTx2q
2262	payment	1397	1397	1678	1	1	2035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyN9P7PVy5cWQJ4qqm7qPfvbQp9AW6AG8vPMy2o5uobvk4Ebd
2263	payment	1397	1397	1678	1	1	2036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9FDZBLYxjdbq5tkRD1GJ4rYLnj1gh3BfDbiVYVaBvh6CSM8i
2265	payment	1397	1397	1678	1	1	2038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQ3y3gFd4zUdvJEM7nQ1xJTXaDanYF8ykDKxzhE4iFjmTDbBe
2266	payment	1397	1397	1678	1	1	2039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pUCBRRCC8mY6owBWN1rW9mrKTSQPGQpLVVQXkEJDCn2BzxGz
2267	payment	1397	1397	1678	1	1	2040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeFtpCPFPUGKWUPeWhyG8AD2WRerjj3AczRxq81yGjHcoqq9n
2268	payment	1397	1397	1678	1	1	2041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUv6Yw6pRpP4h51Vzh6oiXfUysPtsemhQnaQRp2NkyDBseLAzZ
2269	payment	1397	1397	1678	1	1	2042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UaF9heu6Gb5EihtwdamGDKAfYMJJrK23Dhu5StRwRSokR1jH
2273	payment	1397	1397	1678	1	1	2046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSN3jEXpLJReitLsuQuTpUpDCc6bh42Bi3bRB5eK7Ja2Spwus
2276	payment	1397	1397	1678	1	1	2049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JQmEBrrHkcbFw3H9nxHfVJ85mneAKzkCf6ctWkZoj3UKWQEB
2277	payment	1397	1397	1678	1	1	2050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbknVyDZRvbQFU2xSEmqN24acHgKuLF1QnrUvAyfzYBYdMB1F3
2280	payment	1397	1397	1678	1	1	2053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6Wg8nnvFuMMcZSFCTjhUvqAivxbsUymr4HLZkF63mK8Xwfna
2282	payment	1397	1397	1678	1	1	2055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtG8oSWDw8iKgbzqFtmrirA3BFF6eZEXsXq64PxkQLzN1VR42U
2284	payment	1397	1397	1678	1	1	2057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoG3JfWrJrqFZh8ZL6emx7SMnqjTowLZQwYpw56o6hJgyThT7W
2285	payment	1474	1474	528	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVFW9TJXAFJaEoWCLxULTwWiwiyFXLc3Pb5C4WDrmLS3Xt2kv
2302	payment	1397	1397	1678	1	1	2074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbzAbdCG52n54b3E56vGHdz1SnNA9quz7oZ39gtJea5y1D1L9
2305	payment	1397	1397	1678	1	1	2077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzyi2a91pt9ERw4jkiG69Fvs4y53wNqJ7aU4yXEQfuSwYUCM7
2306	payment	1397	1397	1678	1	1	2078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YG8Pfa4vBZGmkDKDcctv9Mzvsx39oFNyyp71qoFdW4kDRqEc
2307	payment	1474	1474	1769	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAB7yCEiWiAbyWdbHP98c2fqm1X6Nttbm2DPtEPwJ2Er5bpBKL
2308	payment	1397	1397	1678	1	1	2079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVvzZibSuC2uM5ESxkaX83H4Cm5XdGNZd7siDPVxHTUiAxzbu
2309	payment	1474	1474	1769	1	1	2	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnk9ujN7A4jxvcckXboFK88R5RWYzr94gWn4YEwPEJ2M7VEBK
2310	payment	1769	1769	1474	1	1	0	1000000	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ2hpoEspVMeSUCX4Sv8zuww4uY2HedR2nT6JJeL6pzrQDR7Cs2
2311	payment	1397	1397	1678	1	1	2080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpCeUtYsVAvq8g6HJMeaxP5HpBdXVk9F5NB2vH4TQU6tjc5vJ
2312	payment	1397	1397	1678	1	1	2081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZKrc1Y24tfoNeePpU3wBQynx1kZwerDKeqmWZZ4TNuxJaiJN
2313	payment	1397	1397	1678	1	1	2082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1JdD7tcPhzm5CmYAPMzdYSEVUVzpZQEi3sBj7vcbkGbXsCJ1
2314	payment	1397	1397	1678	1	1	2083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHFa9Ky8kJLEmWW9rMFE4F2eJJfX4thN18tr8Njq4spzKqfVF
2315	payment	1397	1397	1678	1	1	2084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XqwiNj2kPJBgFEHrDtim3F2qBfj4SD18kfb83h723nZvD4SF
2316	payment	1397	1397	1678	1	1	2085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAmFFfCZco6CPAgXLWHK9kAxqgdyd8qgnup6tymP4SuE8EWf4
2317	payment	1397	1397	1678	1	1	2086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksoLNt4A5PjedRt9Jufy5HetwBapaA3KHELxKDpkjE1Z5FKh1
2318	payment	1397	1397	1678	1	1	2087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJDSjFEwdxyCdHZaK7Sp41P2HKGxhFH5ModvjJoshQHhfx8kn
2322	payment	1397	1397	1678	1	1	2091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1idZ4LAFg68MPNimjQs8FVjDAKkzz2cTaxAiTbFB134bpgezY
2323	payment	1397	1397	1678	1	1	2092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmpic98fkZYdy6Cpv6G9iDU2h1efrsJ2SUj3KBQN36HyoRhEz
2324	payment	1397	1397	1678	1	1	2093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwi6Be9jmh9LqhA4G5e2GHnho82HqXN2yBk2NBi9XJLtYnz6s
2325	delegation	1769	1769	44	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcRW2SsJs7RJjVVeuxqWUEWHyKrgGGYE5QiduP8naWhEgdjKh
2329	payment	1397	1397	1678	1	1	2097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP6b5y73qrvs7wghsccvNCgJfbSmHg3cccPp8jC4Pg4uMyNPr
2334	payment	1397	1397	1678	1	1	2102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ512DeSVajeyK3VaiKfRbjYqVdEcwkfUtJ2KBKgnBvwnkq32qS
2339	payment	1397	1397	1678	1	1	2107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfw8Q2qmtJkZ3smgDYMcZNAoLjETCQqVBxfxa45U7AgSUhizGc
2340	payment	1397	1397	1678	1	1	2108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmBsVqjDPLtqPB4tFVH1qXXKVWqADaHQgdVNJiN3WKg4Q7Eq2
2343	payment	1397	1397	1678	1	1	2111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgZqTQRiXjYVGGTqVtf9e548RMnnZe6HbQsGzn6Xj831pD3yn
2344	payment	1397	1397	1678	1	1	2112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSEPzYZPPiyYCa46KefnHKjrvKRtoVq8VZEvL6bCMSqcXrBC5
2345	payment	1769	1769	1474	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktpbG1Nn7jFbnWnx5vgj27QwJMrDBER8g7MMHTVy8sZjYzC85
2346	payment	1397	1397	1678	1	1	2113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoNMWM2bHSPJ7jKwqznjkBT8R1hJD1npyDmBSoZDWhNXT4myQ
2347	payment	1397	1397	1678	1	1	2114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fG8pGFC4DYV5uuiTeAr7jJxmzTjs15QmjEzmf76HV57MLntx
2348	payment	1397	1397	1678	1	1	2115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAri3UQKtyjGCHm34xV7Fx41dEbQwAWJiFWzRyKQ2XdcWswSK
2349	payment	1397	1397	1678	1	1	2116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cjeW8SL54rHCr3H9cDeN2wMREdYeUMNcqLeGzu7SwVSkqwX7
2350	payment	1397	1397	1678	1	1	2117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsp4Fb9TG6MdsVFQtyfuSNJCN5H9d6ddg8ZPR7ECPPT6yQiTjN
2351	payment	1397	1397	1678	1	1	2118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7krh7yHYvxfRXzgJpUw2UxzvMtss9uXkESYtjgc62gHM1KLP
2352	payment	1397	1397	1678	1	1	2119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9vodhnBiJAnKkLmWnvV3FE9tvSb9HAjDLQQXu1MKgkNhXWCA
2353	payment	1397	1397	1678	1	1	2120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAyNgNC6K68NKe5ZYw9rfpUEu8bQPjvTNPBFP8N7xyJokLSkK
2354	payment	1397	1397	1678	1	1	2121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxMop8i9RNnoXbus84y2td2ygpHPzcpQcJZKJ3JefdkSXVDzM
2355	payment	1397	1397	1678	1	1	2122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zL6vt7HpAP3Ktm6uMt13DnsZVDE6ukWj3NWCwpkAKJoV6wZt
2356	payment	1397	1397	1678	1	1	2123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNKw4ntaSBnEJ4QGXSFbgVSZhdMLP86u1z4QNXkUpYbxyfrAV
2357	payment	1397	1397	1678	1	1	2124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvYGr1c62yeBTTbTKSdn2Gs5KrWH7k7RNjhB9c48rAoDe7EZG
2358	payment	1397	1397	1678	1	1	2125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhzcNRUVPCsDWzFJBvbv5qiaept8NHkKxHPJvBJrmv3L3ZCaE
2359	payment	1397	1397	1678	1	1	2126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYwWNdWNF3yptBmV7rXHUZCQBWJLwwzf9CR27GFhmzSxCBPpY
2360	payment	1397	1397	1678	1	1	2127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPPiuRoaGdBYqBaobdD85UHjxmg6dAUSRvMisH13WwopHP4cf
2361	payment	1397	1397	1678	1	1	2128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxWH8YBTop7vzTGZqPttSyUdoTTbNDtCvorx7uwjmUYiQnmoh
2362	payment	1397	1397	1678	1	1	2129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZrCagXp4dA94dyNspLU17C1Qy6GYejFiXXcAdopaDKFaSBVJ
2363	payment	1397	1397	1678	1	1	2130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWSb7ZvE9D3goYvSade8ieTYqPmRo39g8aKxyPycrDxos1o8x
2364	payment	1397	1397	1678	1	1	2131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cYKjHzMbJXRpiYSxWkDGZPPvKGJxuRyiwMbwBDL2acqaYcL6
2365	payment	1397	1397	1678	1	1	2132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NQPA6kDmtoppRC8twizu6op5ysTziZVSeWoX3DDWeLDVYayt
2366	payment	1397	1397	1678	1	1	2133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFqQZ4fuqbK1KKoTJqiqm4jFUVk3BovKDS2EoXXM5Ac92H1SH
2367	payment	1397	1397	1678	1	1	2134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aaCGB6cdKYwLnCebVXpBk3Ee56TABMzQFN9refYKvu2YioZb
2368	payment	1397	1397	1678	1	1	2135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32abaB6MsZuGfQCbfRaVhLT6H97FGDtfTTNjvqw7b6anYKndf
2369	payment	1397	1397	1678	1	1	2136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNr8hrPhujy1bmkHFfdzeSx9nUyhM96hXBCUTBPNojpqkjBg2
2370	payment	1397	1397	1678	1	1	2137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhUJY34YYdEjaSbazLCo5GdwsyXc9GdAi91s4MzCzBAZGHWLr
2371	payment	1397	1397	1678	1	1	2138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFburKHUvGxyUCZELx1szQKAQFpzXReZwFhaBRv3QYEigUKqG8
2372	payment	1397	1397	1678	1	1	2139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHTm4rqNecmW1n93tvF93wC5WhMP5rn85zYsVujSS715jwojm
2373	payment	1397	1397	1678	1	1	2140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEt6MFDsjCSHeDssyDyuL9yqmWmiXhNCjCYcwXGLNTHvfoyPR
2374	payment	1397	1397	1678	1	1	2141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQ7EDgpN3wWzXLPib29wT3ocqRQZLcGRHdSmXEkNnCq6Hpxfp
2375	payment	1397	1397	1678	1	1	2142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHnEZsGLXtHsrjc1BiH8sN6gXc4RHHB9tSCDmLBbkhJxQkFrV
2376	payment	1397	1397	1678	1	1	2143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7f5on7a7MVWDtiivfwY7WV9jJodsmcSHS3Uq4S3SoinTyXkzn
2377	payment	1397	1397	1678	1	1	2144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjFXeZvrPviuYbYmhAWd7DW9ibEBMYQibjE6qPMFix7NoCK9v
2378	payment	1397	1397	1678	1	1	2145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgibLBNYcxMMPentiR58qqjpCaFNq9H2zo2iGw3omJz5p6FsW7
2379	payment	1397	1397	1678	1	1	2146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uVxvhg6JB5E8oJCAYuEyCwbBMGy4mpHZApsYepAujhCbLKMJ
2380	payment	1397	1397	1678	1	1	2147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDLSB7DGfHgUJE1GjZrGMnTPJ9DnVha5t6kG1p1qFHyQaM2va
2381	payment	1397	1397	1678	1	1	2148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bT9ZCdP2rELeLZRb5Je1sGPEY49K3RPkkW9zkrRsmZxD32xo
2385	payment	1397	1397	1678	1	1	2152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvx8bSjfZsCuTGePkvNZ2FJcm5b4pbgkmLumndmdpyjtBgLnnf
2389	payment	1397	1397	1678	1	1	2156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tR11bXxbXhHnEzCR3iXuFZixV1m7o54MA6Lt1y9MdPjTzKvx
2390	payment	1397	1397	1678	1	1	2157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8CNnjw6uwNnNiP1Hy8Eo6WDf4BmMbEfNh7RxuVSXTBri3rm2
2391	payment	1397	1397	1678	1	1	2158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTUPAVjcLASbNCqqP9UMRAAzjuXRXciL3wxKsWRghDhYpdjBt
2393	payment	1397	1397	1678	1	1	2160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXMumA76K5paEHZysaoMMWq6yikjC9mvXcYsoWHCTSvT6bMHA
2395	payment	1397	1397	1678	1	1	2162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKi2oTvGbzyWpuayzbcdwCHHMw7uux47J54PFjyUuWj1KoVVv
2398	payment	1397	1397	1678	1	1	2165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjUmCMfXcW5aaUmEphaHRjsyqFSgGYK1Ytqjgrb8Qt2NNcKvB
2404	payment	1397	1397	1678	1	1	2171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfhF1tY5xgTvkdbjpzaU4CVXwhEafQ7TaCvUVkZE2fvunVBZL
2405	payment	1397	1397	1678	1	1	2172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJns1L7h9NcfcPQCvjPd79trpHfCYoyUukrZM7cunhNxjsJCi
2406	payment	1397	1397	1678	1	1	2173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4UFUJQgBctjg4nYWoMMPTzKuMnxg4PQxq8kpU2mtSRFHaQjJ
2407	payment	1397	1397	1678	1	1	2174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtXJwFg9j6zXe1XAJR13u7CjsbS8tB56HkVfPoatPWDkeaLss
2415	payment	1397	1397	1678	1	1	2182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tSrVGQY2qBd1FG5ccUupK4AWnBKXGMxUejo2Zi6KjDV99Bvt
2416	payment	1397	1397	1678	1	1	2183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXjpv1KEhU17JbJgcvGB1nN59AQ7mAnZ4vEj1NQxF8QZvWux4
2417	payment	1397	1397	1678	1	1	2184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQ9DC5QLwjPYsyaeiJffKk3Br6AV18QGpWEMvUCPmdJ5ztVbn
2423	payment	1397	1397	1678	1	1	2190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiENGUpjktzdasdpjPKjfCdWkWF5YneGMgFkzLCwAKKETdarLq
2424	payment	1397	1397	1678	1	1	2191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDeYWbKeCzT7ASWi6p9LZbSvvCmSgyBJcayHcorF1JydTW3CA
2428	payment	1397	1397	1678	1	1	2195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpw2v1AFXZjhTCb4LNZLaqTwNgsToxj59mUZ2z2kjsVgPBWmw
2435	payment	1397	1397	1678	1	1	2202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCvU1oq1fLRcyATHQaBKWt8mhqX9wQgtbg6gajKhFk351SG6t
2438	payment	1706	1706	1737	1	1	3	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxdzRu3qyT2VcfDiV48Gas8XtWCg5uru26yxG1tL3VP6AxZH7
2444	payment	1397	1397	1678	1	1	2210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjisQan5iKuYxmk4eTP3PP6Sj1vHvKxa9e34Aenq7km3S7L82P
2448	payment	1397	1397	1678	1	1	2214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUtV9XVzud7n2GxNE581Q72DJKEav9k8GieWzkcN75df8UXyA
2451	payment	1397	1397	1678	1	1	2217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqme6dFy889wUZTxfTQ1JHgidqFU519KpPjiix4rufkdxaf4P
2454	payment	1397	1397	1678	1	1	2220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAVR3E6Ka2NNH9Ljqy7pb3CqWwegPoma87eUMXZWVfHVnr6t7
2455	payment	1397	1397	1678	1	1	2221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrMs3vpzptG1UjNBAnRviYq8o3hD5pzw9x7S73aquXDEmNZp4
2457	payment	1397	1397	1678	1	1	2223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtPr443GBThkdTQ81qF4ooDqE3xdojVPZu9NifLeKUzxTDmnb
2463	payment	1397	1397	1678	1	1	2229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbiUn4KfZfWxw6uy2nHbZqdC2tNTJPYL2bv1AnbToHkZvhp9a
2464	payment	1397	1397	1678	1	1	2230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpK3H6SbzqwUrNDxW3TwnGxi8HDs77HziCqdXe48a37Z7uwNZh
2466	payment	1397	1397	1678	1	1	2232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvPLMSSAyhuNyCj1ofVgJgF9qYuWgeDQMrRb79V9u3uywnsoMT
2467	payment	1397	1397	1678	1	1	2233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2ekMr546rjHwjEywDVQEXE5jBNEm9KCGLt8dNqhhgxLyXiAm
2468	payment	1397	1397	1678	1	1	2234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1An3gaUs6ohtHuymBQCfEzKsjNAsxTcw4AddaFqJkGk5JHZSw
2472	payment	1397	1397	1678	1	1	2238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsZDU5qCRHSiDkZUY6CEq1kuWj3XtDGFd8iEwRFdQ6pPn25pe
2478	payment	1397	1397	1678	1	1	2243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn78bsvRZeNtYwCeXUMNCbN1rSoyJMnvfnK71hKe15TbVzbD3G
2480	payment	1397	1397	1678	1	1	2245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3H4GfHdnVqkKMbkrotnPoLWXD23Z89LgUBSTHBjaE4Hmiagq
2481	payment	1397	1397	1678	1	1	2246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEWaUjcCCKVQZ6je2Ad7Xjv26X9eStb32UXYWrSPLh8otibX2
2484	payment	1397	1397	1678	1	1	2249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuX32Lo4TcgHaJgPwaF3Li4etgx7aL3X2pEgQYdYBP9CKtDFD
2486	payment	1397	1397	1678	1	1	2251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yp7Vm17rcm1Xo1MmeoejMfYffui6QjZkzvibvegQ3Q46wkuh
2382	payment	1397	1397	1678	1	1	2149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFZreHNb3JZaT8KG5jkhHdVscYu8QYHTUAJxHPtHJDgyifLuj
2383	payment	1397	1397	1678	1	1	2150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfihjkvHSMWUHQfJUUecs1Q1HanXGa7Znu6ivUk2nhEJ14PpA
2384	payment	1397	1397	1678	1	1	2151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPoFWC23EUWdpN4i6cYMyFym5M1oFysCaNPLDguKcVFLvUUtp
2386	payment	1397	1397	1678	1	1	2153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonZ5tWsuoPxoeX9KZHUifCpwEjp8PQLiEWzGSb7f3mo85W51V
2387	payment	1397	1397	1678	1	1	2154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKXSfX1BRjvek3atriuUdFVqjovpr8QCpoFxZEFggQw7zC25b
2388	payment	1397	1397	1678	1	1	2155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPDPNBcEsY1D5dkY7TEvgLNXbm17okiKddHPHZewmiULPCNYQ
2392	payment	1397	1397	1678	1	1	2159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpEXctMxPFKz663QqMu6uhrVpWgcDbmbbsTpQP1TRt1VV46DL
2394	payment	1397	1397	1678	1	1	2161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41EVTa6uM2kLbxRhshqSk9aMAqkMUamqvRd6H3FChybSY5A4o
2396	payment	1397	1397	1678	1	1	2163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXMW4jhrSG39JcRkEGompeVKS76NJV1m8uUnYwRC8LuxXNtu9
2397	payment	1397	1397	1678	1	1	2164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbYjTxT1SusSMUEszDpNTH4DQWJKFgo6NuWK4VPFVahaDtrMQ
2399	payment	1397	1397	1678	1	1	2166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG47QVCHzm8LhJdpNQAVRxNcNuqwfiBiWowE9mHw9rwQ7jZjiC
2400	payment	1397	1397	1678	1	1	2167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbFweUKgPQ5zP3MCwdk2JU8DePzXBCRT2usj3fyoY5TXV19jC
2401	payment	1397	1397	1678	1	1	2168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGb1uKqNyGhrgVepwMF7TkpxrK2stnYZNy62KpWGCbNLMsSGw
2402	payment	1397	1397	1678	1	1	2169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp58Uc9SgjoSQexBc4hxRAX4BQyTekDTqY6bRPKASjekTMKfs3
2403	payment	1397	1397	1678	1	1	2170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zUStXcC6pyyoLYriSUxC2Yw9q7m8MLVqJrU9EjpAQfivZXj8
2408	payment	1397	1397	1678	1	1	2175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFiRvUyYuuiNcqz8xkCpih7QcYkQJrqQkZxhKF5dhhcBsUNou
2410	payment	1397	1397	1678	1	1	2177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHbBfFuGcipqa1h1rnPD31zvtedueRYy6xrjMAaz1mJoXz7vk
2412	payment	1397	1397	1678	1	1	2179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCe5HUj3P2WMXXJBqhJADsPvYadiMiLqx7Sk2HRkdm2YwFVpjj
2413	payment	1397	1397	1678	1	1	2180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnN5DodXp5qTQiMibfdmpw7AhuX7DaUzRt6ccZbbtgjrWo5GST
2418	payment	1397	1397	1678	1	1	2185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGgWAvYekhvc7eD1Q23G9Q5yx7BRCnBzWG4e5xC5bgrevJQ5c
2422	payment	1397	1397	1678	1	1	2189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTNh63g1So2CpK933cvBCmK2ts9mpucWCpnLRY4fjBRuZnC9o
2425	payment	1397	1397	1678	1	1	2192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT4pFA9oEPutkvxuScgWecQA23CWzU6RrDbjviXaBEySS84mE
2429	payment	1397	1397	1678	1	1	2196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQndoqHgnPhTAH1RY7qjSaVSfjepMLpW1DJrLwMnm2GcnbVcP
2434	payment	1397	1397	1678	1	1	2201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGGX62xWkyAkpuieuRS8y6ydHstWgjpxQYQ8LUT7wG4Ka6K6T
2436	payment	1397	1397	1678	1	1	2203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjKzrx5eusZm9BDdd3LebsBK9cYbQJx2WtF961SkjtDVmyAXH
2437	payment	1397	1397	1678	1	1	2204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8QXdw2Ah65w1Sm7FimZmxTY7xV31BqVfdwNyH5PCAipTjdxd
2439	payment	1397	1397	1678	1	1	2205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAREsApShM3AbYetaYfrUQWKx8hn83nSnw7qTCeWzZtuFWhC8
2440	payment	1397	1397	1678	1	1	2206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohB6h33RvjdbD8GfG47KhdgZZwe1FDXXtCMrYfeNW8Bj1c3hT
2442	payment	1397	1397	1678	1	1	2208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPn2JfAH1Zq5spiEFtFGy8L8QzJG71u7LQnL8MXoiyp7YYs4oq
2443	payment	1397	1397	1678	1	1	2209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWEn2TH6A3Yzh56ZijbQ1iGp72ksPHgvQdw7M1s329Q6tTdiY
2446	payment	1397	1397	1678	1	1	2212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVh9tkL6iiFDRiNnBRW1BpdzF2bA2jWytcMPy9Bjfb9VJ8dpr
2449	payment	1397	1397	1678	1	1	2215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx46MhtGFfw35PvpXPtqmAamd3L7ia7jUBnfqAGHUYrmuZrTfc
2452	payment	1397	1397	1678	1	1	2218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxpHjxu4isKwNQ4BfEzvQ4siLFShRX8Z5hDjZsLQKA2QDTgcB
2453	payment	1397	1397	1678	1	1	2219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F4CzMFKaTdNDjq1zEC933ofDJ9JHEDwZraVh78eTb1FJB3Pt
2456	payment	1397	1397	1678	1	1	2222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdjcr3mu8kvgQ6gnUXis21iNsjAREx8S9xuWCW6UszZr7mr5z
2458	payment	1397	1397	1678	1	1	2224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahdSx56Ky115tfGAJeX7Bvg8fAtHrx9E5bXZD8DrFcvMPC7Wt
2459	payment	1397	1397	1678	1	1	2225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvXnzD6rL8g5iyg6yNmxsdVZV8vAsaVeQGdBZ57fC9NZcFH4T
2462	payment	1397	1397	1678	1	1	2228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScsC7kis19hK6xy2wZaLXEGwjRgPxKfsUuMueqKRHVLZfd589
2409	payment	1397	1397	1678	1	1	2176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvdUszkZ6drVHvMy4FtHNFQrdFsSV7SPvqvQPr1mPktWr5M4U
2411	payment	1397	1397	1678	1	1	2178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaWxrbH4F5gCB4z77uScWTjnH3CE7XGv2g7qFNxocgyxbY6HS
2414	payment	1397	1397	1678	1	1	2181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVZmHFQYmSzn2hhnSJ47LTh33Ke8cj6UfVbpDh4ULwn2B3vKd
2419	payment	1397	1397	1678	1	1	2186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCCiDm12sY9yMoefB2GJRENCavttJ4yAk7t5oMEBr1HWZR1Mv
2420	payment	1397	1397	1678	1	1	2187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMUavoEW6uswwwZu6FAs3RsARnsSJKya4TP9uaYVeGB1GMW13Q
2421	payment	1397	1397	1678	1	1	2188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwj3Kz49UFtsCgUZPCQNGcuT61gnnjDvegyFAuTUHEFTs94bY
2426	payment	1397	1397	1678	1	1	2193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYLpKMH7KipuETDB9m9A26BBvrjRCgcUbjF6fXB2PbGYwtKXx
2427	payment	1397	1397	1678	1	1	2194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWxzKzxgkZoX728i7cwfVomkVpE9PjQVoNZk68Tr2JeoR4KPQ
2430	payment	1397	1397	1678	1	1	2197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79BFJ3p6W3hi6CD7gno9qGvUELt26P48cGmTwU3DThGzBcUXj
2431	payment	1397	1397	1678	1	1	2198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3MeaChc939Yo2oNGGb73tkQjMm6ZVB3pmDAAwxEMsKZ2TAEH
2432	payment	1397	1397	1678	1	1	2199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUNbPFdRCvkePu8gUSwJkT4ZyEBRZfaQSQEWh6TPevNgvAqwh
2433	payment	1397	1397	1678	1	1	2200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8KoV45HjVsT4QFA7YPBkeRgqpvqGm7u5JBNnjN1Q8UUgmhKR
2441	payment	1397	1397	1678	1	1	2207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcgi4ddWvYxxntixmr6iaQvND9CXWY18ea2XgSZvD8WzpjdaS
2445	payment	1397	1397	1678	1	1	2211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLXpWWafZUzkGAHuWRi4ui1Wgs24nPUyWHhFheewFC4oSp7YJ
2447	payment	1397	1397	1678	1	1	2213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdZJ957sG6d55zweq2iUksbhi22BiPsT3pmdS1ZFRXmN9gwj3
2450	payment	1397	1397	1678	1	1	2216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAWpXLcjyAjtG55KLFPztK4NSWHqxfJg9WBXyiWNcbRzpisdu
2460	payment	1397	1397	1678	1	1	2226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsSUVKgPD7iFegYo52JQRnjNTc9Luf1GzVF4a4AC5wKoNmfRv
2461	payment	1397	1397	1678	1	1	2227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcDJ1V22vxa1DVP63eTL1cGa3bNR6N72677k2JwCL7r1s3nzL
2465	payment	1397	1397	1678	1	1	2231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7gfdHwUnMJp74YSGmsJK6me9MKDhkebF14ssbassNWfchohu
2470	payment	1397	1397	1678	1	1	2236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcS3Jjc9bCZDLW4pD7XbnsnRPxxUw6pHSL5BVs765w1kKUe4pb
2471	payment	1397	1397	1678	1	1	2237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBseeYqxf4PCXZBEg3sLGNYSxTXRfcPaxHp3pc7CLpaggPpNr5
2473	payment	1686	1686	1770	1	1	1	4106104499987	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr49iE8H2qf6fK1qKXopSAGZP8UA7igcBKugrqkFo8revryaKk
2474	payment	1397	1397	1678	1	1	2239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBKfxHkke5u18HfKJbKR2kxxHvUbRiEDDMDdtVwLJ31EScfBs
2475	payment	1397	1397	1678	1	1	2240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALJidrdd1e3MxXW2RP8TpvzyAQu8hbxDwpo6gbirN5ZYJKR6c
2477	payment	1397	1397	1678	1	1	2242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28anL36p2okyWAqJry225UQdY62LfxM29AbrmfY6tsv1sNikg
2479	payment	1397	1397	1678	1	1	2244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMvWg8iQzg7MfMJa6VvRS4r6y6rm14EbdhCYM2sRgWCdSmsrr
2482	payment	1397	1397	1678	1	1	2247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSn3d9SpP37aoFs3HQbx4qFHvTQ5D6avV2zTw5nULjuhnipTfb
2483	payment	1397	1397	1678	1	1	2248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmvtKXbEhF8gNo9Guzw8t6pPYABndV21t8RTQmAc3z79oyGTZ
2493	payment	1397	1397	1678	1	1	2258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH8KnC6ReQWiG6vb4BRxBBHCnnwxG4QqRYxzGeUTi1Zdiu6dS
2494	payment	1397	1397	1678	1	1	2259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuxEvXChx5y2faKDqubko1K34SKbMRgXiErmJccrDsayvSXRX
2495	payment	1397	1397	1678	1	1	2260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJsyj4of42pFLXZBph86SC17148WFLvejRNJmG9eHFhNLa8XS
2496	payment	1397	1397	1678	1	1	2261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUbm5uBie7hC5PEqdvJERVHXdSogEEbc6qZSt1ttJa4guug9V
2497	payment	1397	1397	1678	1	1	2262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauRrubqgzMfsWkXzP2GZCxE8ekb1YEQd7sv44K9AzbVmFWdWm
2498	payment	1397	1397	1678	1	1	2263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZH2iTUPknkeLnuuYNxfKTsp4mBwN7YGaq4rUci1MqJevP9DQ
2499	payment	1397	1397	1678	1	1	2264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWLBs14E9sJsJkE16bx2DKivrZSdSVCha3NkTD7ZSKjJhDB3T
2500	payment	1397	1397	1678	1	1	2265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnY88jmd7iovGvH3dijk9uPSjghcMNaPRsRnRH4ms5NGqyTp4i
2501	payment	1770	1770	1771	1	1	0	70383739594	10000000	\N	E4YpWTjbjkMvauQBbyKqu4kUFKQ1oEu57veo7MvAjocUsQvL3eyRn	Ckpa5mMihxXDLVVKo8K5scPYdd2E6XcsxVazytGa2zarq1DJzdVty
2502	payment	1397	1397	1678	1	1	2266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniFNNUiBEm2xX5X7tSN1sEZ5NQo9pGikrBkx48Ugwte4vmFXc
2469	payment	1397	1397	1678	1	1	2235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWBTS1ptHNszoxJ8LJ3Q4S2VYMD2SDxguvqEAULi24d3dD5KM
2476	payment	1397	1397	1678	1	1	2241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLYtw7dWsmjqTYfAcZVU2ZxzHTVRhp2iFgPC63G1cHgcmrfwn
2485	payment	1397	1397	1678	1	1	2250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUt3aNyx1cpgiaJNmGVRJExMU7HtUYxee8NMwZJf79LuuKL8c
2487	payment	1397	1397	1678	1	1	2252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZntYM2wMk9yr6DhCZ4467grZZWpAgn5ppL5QJaS7gbhgbSRab
2489	payment	1397	1397	1678	1	1	2254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokK3FyQTH8V8zJaKS9KcRqYKxJ5NjYux5H6UAp31FXSreB816
2490	payment	1397	1397	1678	1	1	2255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x77fcXqdZBMYTN3DSFNpfBAge8ZWEi4oEfyTBHhXC1FvSjR8
2492	payment	1397	1397	1678	1	1	2257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAMvdswKxAkYS7HD7inZwK5EWtYbFsweKtdgjeyhRV69Kw3TY
2505	payment	1397	1397	1678	1	1	2268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u1tfPw2H26CqHjh6zwP9dDZCo5BhLRpustSQBiUpGHuT89VT
2510	payment	1397	1397	1678	1	1	2273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSdK8jcKf2k2nTMZmEyoYWPwPLzrQZJJNSFPUC5mfWAyEJg3k
2511	payment	1397	1397	1678	1	1	2274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq1muUyEXGCmcre3rSkLmiARaBpoPXTUkkKhhqGNa9taHWHuX
2515	payment	1397	1397	1678	1	1	2278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDCbBjds3EdkcDjWaGkGYB25Dk1jtyLjRALAyuqmF7o3J4xvY
2516	payment	1397	1397	1678	1	1	2279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TVYMbujztin4FKBft5AaYd2Rbfoby1riTncwBX9zus6dHZ65
2517	payment	1397	1397	1678	1	1	2280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9PUexv3KFcQ7CRVDTYBBij5khezjpnG29YFtZWHX1dDpAvXzt
2525	payment	1397	1397	1678	1	1	2288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiBKXnHBCHyiVfQije7UywWGsVDcSVSdovxrTdHwEoSQs5CKB
2538	payment	1397	1397	1678	1	1	2291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmy4XtprKXEMFLR9QmRsymVht33S5LJaK2ueT1CU2DCAniQ7sW
2539	payment	1397	1397	1678	1	1	2292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWh935QhmL9p7bdSaG6oypX8VqKGhLhJ1E1L3CxpNs4Wqj99GH
2540	payment	1397	1397	1678	1	1	2293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu41LmExsfYuw235PbjGWJ9u5z5Ad9K5Dk6Xg4YKWrUBrT9XEF
2545	payment	1397	1397	1678	1	1	2297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72baXJ7WhGHkHgugNd1f4sUGgoTuQYpXG7CycFsrvDFQqfxoA
2546	payment	1397	1397	1678	1	1	2298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gNrHX5Jcxu79WXGTt3Tcu4GgpGo6hMLT3sexMsGcNaN8V1SN
2547	payment	1397	1397	1678	1	1	2299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLGPBG9Ey5WcBeFXD7e4cQGKcJhYWo3BQABAwKokCfS898jGG
2548	payment	1397	1397	1678	1	1	2300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySnPwQgKzhcAHsSFthK3tX2uooUKVxDRoDLxoudgLj4JGv8r6
2549	payment	1397	1397	1678	1	1	2301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoz6KfBWBvESthgbQcVukQfqEpsScPHZP7KPR3Ezdd17gSXp2b
2550	payment	1397	1397	1678	1	1	2302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pxL2Pm37He9XWTBREWW6hbB76xQsaxY95Atigtc38k3AaQaS
2551	payment	1397	1397	1678	1	1	2303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKm2B4qcwusgakTmFn2r9cj1CsSamRWo6RWZrT5odV8d7nQbqL
2554	payment	1397	1397	1678	1	1	2306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp311UXnMajGQ648hj5B6y5vHmipCzTMNhn671tUci9LjfN7DN
2560	payment	1397	1397	1678	1	1	2312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg32GSi2ji4mBKzMHAjcbosSyiuSE6JYfsow3LYVRSWPPM3L1X
2561	payment	1397	1397	1678	1	1	2313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJbLEiouUAM94qKphwT7hGqcN8HPt7esPH6cPLnG6P8xoVpPK
2568	payment	1397	1397	1678	1	1	2320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAZYd2isVxWfMtKy9bbLYZFXjsJdSMK8pinknAaVTphUTkUqE
2574	payment	1397	1397	1678	1	1	2326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVohuqU4nkkpv1ZtSRu87d27fMbb1YQgGtJazVCChiwzZM7UnU
2577	payment	1397	1397	1678	1	1	2329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTuXUUMKseH56vQcPSuuVCn29LzMYCMVC1SqRig8nmqN7LMoX
2585	payment	1397	1397	1678	1	1	2337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGL5maaWyG6rUiiSwDTVSCNZLmji27PaY8uCt9guZXhFcyxpt
2587	payment	1397	1397	1678	1	1	2339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLh4Q6juFw3Tkn1VzV22mAWhhna7A3Ra7CiQT8vk5r8uAEWNih
2588	payment	1397	1397	1678	1	1	2340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC52RgfxUUfU9GJLtTHFb6tGU345soeu9Extn1DE4vqjBP33zJ
2589	payment	1397	1397	1678	1	1	2341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRSUYUHBzkpnCQyG98pAK66YG7Vouo8uU6UdBp1GVbiwyyUGqY
2590	payment	1397	1397	1678	1	1	2342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGW5DUdA5BtcVkS1peXjkmNn9Rzw6CxZXusix6ZDHUvSZCj1M
2594	payment	1397	1397	1678	1	1	2346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqHLPjQ5DUVvhhGqxcopLiWCZBXzHLmv1LuyVvm9Gs37iPR4v
2601	payment	1397	1397	1678	1	1	2353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaYisc9RiVcN68t3e8X9ENJ7xPbvX5aYjijJmV2GYB1Gf5Utm
2612	payment	1397	1397	1678	1	1	2364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiYy39bfGgM5NfqKPCahBPE9NBN61EKeijGiXaiwF1bkcfutE
2488	payment	1397	1397	1678	1	1	2253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5wfexGfoxExHFgaLZrALqKvgegQjsLrsM7qBJY3QbXbUeyfJ
2491	payment	1397	1397	1678	1	1	2256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmgsNvwo9QSQwQJnX8utsfBGZJXYd5yj1nujPkPLtgpF9DXzK
2506	payment	1397	1397	1678	1	1	2269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86WSqKETNZYd5iCSPptxFqUV8P4k7d2CmhYY7XHC54YQmj19B
2508	payment	1397	1397	1678	1	1	2271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyZ13YLVZmrCrJSWgntPhKS9unDn9sf78LKSPCDuxNcHiBGkp
2509	payment	1397	1397	1678	1	1	2272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK19gJjjCCmHHiDR9NdnqkYDp6BAoLSkvZ49xHPNg3dati9qWt
2519	payment	1397	1397	1678	1	1	2282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiQErfwhRMnPLEF9jgbKswjBrqxHaRefzN6mgjHZx3ZQdJCU5
2520	payment	1397	1397	1678	1	1	2283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYpimXPKU6pRZYwvSA8WQjkus3efcdHFaXpsTxDkTMfTikHqY
2521	payment	1397	1397	1678	1	1	2284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4rNWj3k7HEehA51tMwSrrsMwQxtmLrNikFK1YxAm4xwbtJU7
2524	payment	1397	1397	1678	1	1	2287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnNWvgF3VsKYoLKYmheduEecp5vgPX7kf2bQVQ2BTdrcEkWKe
2552	payment	1397	1397	1678	1	1	2304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESDVQSYvoCLANuNF78uYumGBmVff43NZeP1GpRf9D2So1zyiH
2553	payment	1397	1397	1678	1	1	2305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ab7VA69sSgCDSZRvMKWJAK7PzYVpguTW9xJC4yZR6553xUMm
2555	payment	1397	1397	1678	1	1	2307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmyhyk8WSrVrygLcMdMFNArQ12WQEdPxJKqRoXF7HDhYEteXuR
2556	payment	1397	1397	1678	1	1	2308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaUj1CJxheZTdjChtj2KJDDgELg3N4qbXwNRzD9gVg9Ckv1oj
2557	payment	1397	1397	1678	1	1	2309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPE6ihdz7zaDSUofFY17cqq8QRynrsi6R11iv3DYvSMUYJxoB
2558	payment	1397	1397	1678	1	1	2310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvtKyH26exsLvM4wSiWZaC6VC6pyzMB9bnhJnrn1jJYfS6pQf
2559	payment	1397	1397	1678	1	1	2311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuqgwUDmBEWPQjQNAXuuxDZa4WjV3gL3PKk7qsQqFKVeSXs9q
2562	payment	1397	1397	1678	1	1	2314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQnSkqU3XM8fXNsZxxXYMqS3rrp96RVExsa7uqh29zExmLcDA
2563	payment	1397	1397	1678	1	1	2315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7dJQYk6dPuHnvmGMigpArabgr2Fi5LMG47cf2poKeQAi4NfG
2564	payment	1397	1397	1678	1	1	2316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPb2qJKFcjKGLJx5Kj3Y1agFo3J7p97o2TBWvXUB9hBQygv5W
2565	payment	1397	1397	1678	1	1	2317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRhyUuHAxAyBLJx9ZbpTyZpsXw129nExqEkVDd5JRZ9RivW7H
2566	payment	1397	1397	1678	1	1	2318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokc845fZ11qzyXTPRLUavYt8bc59EZP2EL4NP8P66QP8AtP88
2571	payment	1397	1397	1678	1	1	2323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCckxD4zqQ94KmkNTUrJNoQJiGxVpKHsNAJLXAwMj66YkSyTPu
2572	payment	1397	1397	1678	1	1	2324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXHae7F8bArLDq7jUjF7YYv21XX6zhzxBVB2Q4KWjM6Z9ugFc
2575	payment	1397	1397	1678	1	1	2327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpSHZjti8z7q5Fd5QzmadEMcSpS9DJsXFK91tN8xMjEuP3Ex3
2578	payment	1397	1397	1678	1	1	2330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUdatotriS9oHTfu7z24QF3QkFAM5YgGYnmDtGSXWFAAgNwQj
2579	payment	1397	1397	1678	1	1	2331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYof3nbUAtdA2rEsgZNsGfv5XNPP75ZdBiMXuyWcG3CrEuWfw7s
2580	payment	1397	1397	1678	1	1	2332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxNQuTh7QaVW47LkLDqPQ17t3kVfGZLiw4xqE8QMPt8nc8yRu
2581	payment	1397	1397	1678	1	1	2333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqkpNXeywpcPbYdEp1MRtPeijUTby9VXij2JpRbVrBMmnRaV3
2582	payment	1397	1397	1678	1	1	2334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeQ1jUGr4pLh1Ly95c9XuQF3TaaRnzAfkz1tYgLzq8ZgoqEYf
2584	payment	1397	1397	1678	1	1	2336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBfdn8GgJ9DqePdZSqXSFcnb3YN6Wg6i29cZk1EwHMeHHPToM
2586	payment	1397	1397	1678	1	1	2338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBufzzXp4dsPdpB1q32ihddcn9kti5uk5NkNxRyJaBcYeo9x2o
2591	payment	1397	1397	1678	1	1	2343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshgiRrFc3ZBXJrYZEt15RadchUyB7p1FSrtfpepExDbrwJH9N
2592	payment	1397	1397	1678	1	1	2344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkG7NVU1HFyXgWGWnDPMvosr3xW9qop9vkTeGB9wZqdYZv6sB
2593	payment	1397	1397	1678	1	1	2345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDUGU292skYHwKWifXnHZV3ZRvQyy8jYgn7xtjAdDwWb1iUkF
2595	payment	1397	1397	1678	1	1	2347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkBxnfB5DjKhm9LK4adyTD5s1kf6qFB4F9FugHHozKTnhMHML
2596	payment	1397	1397	1678	1	1	2348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7B9A2rir4o868F42eKEKnvbHx9vxavcN36YPxEE6fJQoUmKd
2597	payment	1397	1397	1678	1	1	2349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjToBd925ruTcXE67bbA4jBxFrq5nKJJYNmSVgthjdxQPXtTYk
2598	payment	1397	1397	1678	1	1	2350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHUYjW15VESGQ7z38p2oNqT3zrvQDcDjmudDL84b8LuM61Teh
2503	payment	1397	1397	1678	1	1	2267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbNVGTRCdh2iABoh1CXTxYVVgrL6YjBXgpzuQDb1iymktYb6w
2504	payment	1770	1770	1771	1	1	1	395940	10000000	\N	E4YpWTjbjkMvauQBbyKqu4kUFKQ1oEu57veo7MvAjocUsQvL3eyRn	CkpaJjmdAhyx55MNC35SCZdLei5Em155WJBbYeR6djZdfVfLENLDX
2507	payment	1397	1397	1678	1	1	2270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMthfhaWthp17o4oYoRvazFLwVtDhSq8NQe1ZodqUNJXYBPhnH
2512	payment	1397	1397	1678	1	1	2275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoEEYpAQT3zmdF6ckoC4uFoE1gSfKaXpk9y5MfezTBzPxeNWc
2513	payment	1397	1397	1678	1	1	2276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCCrmB3e4vcrwpWFYsvvJB2UCueALmccm92pY6NZjxfw2QkMS
2514	payment	1397	1397	1678	1	1	2277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU19cQvA7zCijxLPUaLLXNGVhxi77tm8yJWDtvqc9u8rqbNseV
2518	payment	1397	1397	1678	1	1	2281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7uTxJdHiDfLTfgNPpEK8a6m8Ap5c4nLZFctrG1tdPrGdmp8J
2522	payment	1397	1397	1678	1	1	2285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGp8faQJZQ12kABuobPFg8gy893QsQfX4F84kRhE5gBrwdJsq
2523	payment	1397	1397	1678	1	1	2286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7Znq8KUJ6HeyVJrEQcvZ9hBTPRrsPqEUupnDr2XM1E6dMC1x
2526	payment	1770	1770	1771	1	1	2	940	10000000	\N	E4YnwMUzajBu5fpZSNNLNjzhmTUFGHZWQ2KBKCTdWikvYtY5gcvh4	CkpZ1iuEauUgHXBwA1iXBZ58QEMQSzNAKagh3di3Q1rkrZPafDHTx
2527	payment	1770	1770	1771	1	1	3	940	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYoAjugGXmATkNUPSLpqfcEc5X1f2pZLsESjAoaXDbQLHDb82kt
2528	payment	1397	1397	1678	1	1	2289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G5ShdSsxcjbVsobp4PDogGKX88AZHsMiRL8hkaPb5HuJYQP1
2529	payment	1397	1397	1678	1	1	2290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdkEdRfK7SZxe3Vf7LbsUb2pVByUQwFfiYBge6cDD2HgvEtFw
2530	payment	1770	1770	1771	1	1	4	940	10000000	\N	E4ZG9mxEsB7rYqi3aF4T4k21de4tDmAuASyPMdXHMHNM5R2J6E9CE	CkpZTtpjgeK63giUH1AvE4JadiwUjzWfkicMSY99hiWSgtpxWDupY
2531	payment	1770	1770	1771	1	1	5	940	10000000	\N	E4ZPvkfAfJXZFkFKu4gmYjqJ2jjLgdmiXx7we4VvwB9jYRovKiFcT	CkpYexmXXBctCzptvLJ5uTb8UJAmxb3mNVHGmKd64butL31xNwJiB
2532	payment	1770	1770	195	1	1	6	69405749490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYxTvwHy7UbJh4UHY5duvu2SGt8GQvF7TDaW48pHe2fAJVGU3vM
2533	payment	1770	1770	291	1	1	7	69405749490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaCJPyPH3h54Lt4RuRToC3uu3tKBSSfXUbcMoL4bvUDPRWSFbZk
2534	payment	1770	1770	1023	1	1	8	528458132568	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZw1pToNcX4SqY7wf3Aef4xEokAuJmGx7LzrchqzzoFMWqCKTdk
2535	payment	1770	1770	1143	1	1	9	946992445734	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZLcxJpkG62C9yDdfkHPDybA4zXSDQV1CUFUeRF99fmAqazAsMa
2536	payment	1770	1770	1263	1	1	10	638954673294	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZTP2KUrvhW7mrQ9vk716crH4cUNfe6Y3TSHNVpzJ2qx1WFkXPp
2537	payment	1770	1770	1389	1	1	11	1780504009818	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZXeKuzrq9rdQRBgZC7Jx2cxWJhkvWByzpKh5frkZmWqoZre7Yg
2541	payment	1397	1397	1678	1	1	2294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhRPX1VaCS2uBrLSmGgbSDKehKHzFHax49ApWL16CavsrxzLF
2542	payment	1397	1397	1678	1	1	2295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKAMuuxteCPBTHYEJ2ijMARpoGH1TvBfaC4hg2PbtcseoYx5Z
2543	payment	1397	1397	1678	1	1	2296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVAiJxe8DjubSZHGdVMcYWmrbn4erJKX7spfRRRYX9AYvqwhD
2544	payment	1770	1770	1771	1	1	12	869600299	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZVwRgbQYGgNZa56NNaccNjRXw3ZLdhge12fTbhhZu7LJj4BNdV
2567	payment	1397	1397	1678	1	1	2319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaPcKGLW1UbqVGGNFNSenndNsppKpg85xQhACGA7FKPixuCLz
2569	payment	1397	1397	1678	1	1	2321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXh1zHwZbeYyrRsfDSerX2XPYC41GxqZYbXmgwxj2GWUtAbatV
2570	payment	1397	1397	1678	1	1	2322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2o5CBJKnW6afZx2MApPus3GtE3k32jvkudXQDAPQDvrwHr5Xt
2573	payment	1397	1397	1678	1	1	2325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKZqv4xmAwCPA8eW8Ghhf9FhDRSb2zWysMvcib3GWRZDBD54R
2576	payment	1397	1397	1678	1	1	2328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPfEM8LFi2Y7VqxRWfdv7Wd5RwAiByLkxRWWFyS855ii51XLW
2583	payment	1397	1397	1678	1	1	2335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaCJrppxDQ9hAhPWpg8xtqnZ5nh4kLWmuYe5sxjteDY3HeWY4
2599	payment	1397	1397	1678	1	1	2351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGq8BJwcYxJK1rJGDu4UfSstUsatwJqCXdi4G7Sqi2y57st35w
2602	payment	1397	1397	1678	1	1	2354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUToYSQad8RLasdCkWmjn9yDRivrZG5tmbF3CYzgQcgeGbRKqq
2603	payment	1397	1397	1678	1	1	2355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq22XHCmjkJUDkggB5BSMBEUtdAiFMQjbH9LTjmgXnnih6oyPJ
2604	payment	1397	1397	1678	1	1	2356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhUFso8qskZSsGX2Hyrma6ekRZZqJdHRpFbUKmSp1L5WAJzv3
2605	payment	1397	1397	1678	1	1	2357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2KETHQbR2SXva393HAHfUZnUXUibZFtiKYySvLeHJHSDzaJd
2606	payment	1397	1397	1678	1	1	2358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mFXn4TFjcyBhYzykYNumwX9DU7CguxZZiN2F32DiQCobKiBF
2607	payment	1397	1397	1678	1	1	2359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FHt8H3kPsDPzu1B1TnMe5NhKzU2Ru2W5kzUY8VUgDAgq8nM9
2600	payment	1397	1397	1678	1	1	2352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6VKSLtYq7k5RStEepK9TYGqFRSA43tiQySsXfehMBmbzeB1H
2614	payment	1397	1397	1678	1	1	2366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupMoiSNp2JjLzNhw251TLLRAMVDRxYYWQLpQTYvysXySzfRyU
2617	payment	1397	1397	1678	1	1	2369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzW9957FBaNUXEmQ28khXLBTRPnU6Fcxr99uDW71ftSK4LNoux
2618	payment	1397	1397	1678	1	1	2370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfY9t5iEvP6XkjjkNEitjYsRcHfvSAsWzA1AGfRxGNR2PUbZL
2619	payment	1397	1397	1678	1	1	2371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr856A48KHRK4HxKMMTLcgUgJAR3a9qgTVzMhcVRRwPH2TvCLM
2620	payment	1397	1397	1678	1	1	2372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3s3KZszNqwoDwNMPJcb4ZKq3tJRnXhPYYK89kAyHJGMSuE57
2626	payment	1706	1706	1737	1	1	4	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRa7ECpfo7BYaL6pqpjFkPXm1LV3HV7DfTekuS4MjmbVCAvdPp
2627	payment	1397	1397	1678	1	1	2378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HTXoHyPyBP2RAJ3PWQezDccERz5tQp4Zpzvb1PgZJSFfYZqw
2628	payment	1397	1397	1678	1	1	2379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HGya9vS6rMkmdMg5s2cFUhaohx27VieDDFgpLfH2ojV8ZwvV
2629	payment	1693	1693	41	1	1	118	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaKE6Jm1M34PCXA6upW8PeD58dZPpyoptHZuSmh7ZNqRMm93RVY
2630	payment	1693	1693	225	1	1	119	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtsNXqR7jqoZ8n4Sf58kUpwwG4E34YaK4ALnT6uktzHPSuiNYW
2631	payment	1693	1693	304	1	1	120	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZjJCo8Tm3goytvE3e1y7jsEprCk59eyVXGxA1qK8qcL7HUipsi
2632	payment	1693	1693	308	1	1	121	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaDyhdLp2Kwo2qYybHaQrBtDpisejCRW6wwRWnjwwrHEjbGpS8o
2633	payment	1693	1693	373	1	1	122	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBphFGhdrQkvarz5dPkgYkNFDZSvu29SRkCRfm8iGYfBpPvh4M
2634	payment	1693	1693	191	1	1	123	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYegowMG8eGbP1sVfdr9YGA5HANCTq1uyFX13vSgUxr8erVrrxr
2635	payment	1693	1693	877	1	1	124	153145890887	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZy7Pht9L5gWXDPmUDHXjuJm4RZCErgw26TYxfyqppkRTSXRMa4
2636	payment	1693	1693	309	1	1	125	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaAF8rzEXAmAWrchMiQPouc2di8y72c3vubZrNG8bpJXkShKHXr
2637	payment	1693	1693	731	1	1	126	1508431437	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYwPDav8u5n4uTjmkUj2aFvey2m25fa2tq365f5yHkvaP78Lfch
2638	payment	1693	1693	217	1	1	127	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ3z68W4uE8EmKcyUd5ooaQD8DYT7tCPwLBb5ShuaXJMJfzUu8r
2608	payment	1397	1397	1678	1	1	2360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejaet42zPATvmgPbPkDskrVErF7nuL4w1fKsp2gokg3n16wB7
2609	payment	1397	1397	1678	1	1	2361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYAEqw7nBESRworDBs4Pnk5K4PmiUk8RAurHcouZ4p4zv7mUb
2610	payment	1397	1397	1678	1	1	2362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShSBJ9nXMHZaJTv3TD2zToLfJP8FueQj3R3rgLXJgLdiAsFwV
2611	payment	1397	1397	1678	1	1	2363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHm6eUupc7WRgrPA8s4eBT3JkmDTRjhUHFjJ3fNQXrgtq2ztCs
2613	payment	1397	1397	1678	1	1	2365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3rR2yRBf4f8nXyut5jdxoRYb9jLVoM3PUDgJ6MvQWvWchmGG
2615	payment	1397	1397	1678	1	1	2367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc97DAtyzagDWGhontpuxpBS4bPbHHJJqg2KzW9LUkZcJZnaCs
2616	payment	1397	1397	1678	1	1	2368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGJtXxFk7uq8bBVvFAznqADQTiTjeSBYMh2x7DbXwdJbAPjZb
2621	payment	1397	1397	1678	1	1	2373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RGnDG6u5xaEJm3K58X1QxFJzAkUUTgcCZh9GhUpGnBeba6zY
2622	payment	1397	1397	1678	1	1	2374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqze75PyLduwS1tEHSPKnC3zmRbBoRVqVXMrL7ihbmXV3qg4rU
2623	payment	1397	1397	1678	1	1	2375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDmWDTV5NQHwpWrwFkt95xdL183Xy1Ba1fmVx3Ku9efUCKPFA
2624	payment	1397	1397	1678	1	1	2376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SwLybaeLGHYLMV1KhXcc17GgNCfCCRfShtwGDSX11r4qQT5y
2625	payment	1397	1397	1678	1	1	2377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRL4EKHTsm5bz44dts5sX5dq3E888b9EcVyp111gaConZe5duS
2639	payment	1397	1397	1678	1	1	2380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZda1hes81AWLLi65QfXw9VufcfEYw9qo1SPZbZM53r7XbyCV4v
2640	payment	1693	1693	402	1	1	128	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgJWduHU9gHeZkv5x9dXoRBZ5msftfcwvg4SHdUZPDYxRKDnVg
2641	payment	1693	1693	1030	1	1	129	679506888300	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYcTw7Kuvkay9pciiSqSxzRsNVpJ6ZRox78G53JjiavFheGctQ9
2642	payment	1693	1693	205	1	1	130	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa3qiWZNjf3zFqqNyPGpbAzdv2iRHsLpaHZnyCDCqdMDKaMwzzz
2643	payment	1693	1693	138	1	1	131	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBvpoEUaHTxkyFui4NZUQVAKQCNhRSoCrQ7cBteuHYMTwKDM4e
2644	payment	1693	1693	275	1	1	132	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZF7TuQPXGjCoo4rKdCnXpZnxK7jnnzvHWBEdWxBkW6U2y9dJWq
2645	payment	1693	1693	397	1	1	133	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZsLDVjmMBS5AN1Sssms2UEG6kNC4UYePL9LGW1mK5B2aHdnP95
2646	payment	1693	1693	690	1	1	134	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYfecjHjddz5Pjb8zfzAxUh37FDfzbbRgQ74yC5A3rG3uAeh723
2647	payment	1397	1397	1678	1	1	2381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAgZEnEhrvq5GGW8Dh7igEQTEyvpE62EpsUdKpFTRpZ9PZfji
2648	payment	1397	1397	1678	1	1	2382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUFWGceFMHJSdkySXGYvdWNQSJho53EbGZBhYdxadUfCDGJvc
2649	payment	1397	1397	1678	1	1	2383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKR1j47CX2X43hTWDdMbtxvuZYhRprnNs3hYX4VYP7CPufBeD
2650	payment	1397	1397	1678	1	1	2384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzgR5pY3uXYn68682ix22i6bVGmJdftoEYP3LYiXbREYqtiyx
2651	payment	1693	1693	106	1	1	135	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaCn6oF45nesQQwfkVyZWo3ft7a4AiuyiAiNpsxtG3shcL9TmeP
2652	payment	1693	1693	894	1	1	136	231410667894	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJzFbZpqsNzXtc8LJBbGnU22gizgnzZEGkreS8mMSE66dhC6ZY
2653	payment	1693	1693	5	1	1	137	5050982688	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrCERMP6cQcnF4hvpqynCYkTCoc6hLgWfz92A6JoTzgEMHVdXf
2654	payment	1693	1693	122	1	1	138	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaC2u4gc7syGFbVVQup3qPEhMNoRx67ooauBT88DBE2VB8jQtAd
2655	payment	1693	1693	91	1	1	139	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZXpD9NipMHtD6TgwvkkXHqQqnSyQgDBxUzHgvkbAPqXFEuMAPm
2656	payment	1693	1693	99	1	1	140	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYRLvxCbi51SYNecXVjKV3KjW9LCu1Vt68P6m7raDAEPA9f4bwN
2657	payment	1693	1693	339	1	1	141	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYbLNfU3WQxTzakL1nq3GhF7suHgDnDXTBkaaA9k6YkfTNunedD
2658	payment	1397	1397	1678	1	1	2385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkGJ6mvVUHa8uNEV1pc1a5HMFU46pqNg81BUmagMuNCFt7x7s
2659	payment	1397	1397	1678	1	1	2386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ad5TXbNaGJLfZEvTVxXM1ZeNHoHTtLsTrY3HBuLWaQF1qC36
2660	payment	1693	1693	420	1	1	142	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa1jwP8qE5aGPpciaHWfgb6wxkHrkiTxoNQYtmcEruffq5fHaWC
2661	payment	1693	1693	206	1	1	143	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ6nsDmdooWSz8T3fieR5d1sdSUGy3Tj2rjKSDSMjB5pLy4Pp7t
2662	payment	1693	1693	408	1	1	144	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgX6heYVewNy21saETdDbXB2BVMLJK55hhCqG6j5vtBPJzcFHt
2663	payment	1397	1397	1678	1	1	2387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZVFWvzzJ33an5KyZsdpTFCCd5WABaxsUtWkd1F1ahEvFX9sV
2664	payment	1693	1693	438	1	1	145	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaALcBKaDDTr93HrYyqp5HQYeHR2PRxuGqCKjucdBSrv67Zt1RZ
2665	payment	1693	1693	534	1	1	146	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa5Ptv7vDoSw28SiB34tiS46rFAPYbt4efxnfCU62SeYBWEWBC7
2666	payment	1693	1693	399	1	1	147	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZRhvQzETCdXdEjnGdrcBxeS9bZnVXqwBFtPA9e8xK5oEHcrHG5
2668	payment	1693	1693	570	1	1	148	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrY5DmfjugXyweVFzdeuGC7fxM8axjwUtRm6aeXQh8oiXBPQ3j
2669	payment	1693	1693	910	1	1	149	379190924772	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa4Gnp2C9WvUGcHRKkEvSQxQRZ4WcSepAJvfWkddvWiSMGgYNch
2670	payment	1693	1693	322	1	1	150	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa3CHy43oSNjGA2dS2XHk2bHw6FjiKYry77Re3GHanihR6m7CpW
2671	payment	1693	1693	500	1	1	151	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYoE1GQwMVZzXPtKRH5RN2p6aH7rnozxnVmwr48YF31uji6NwJK
2672	payment	1693	1693	105	1	1	152	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgcKddzW3QZ4m67PmwqtWBrDdbqtNz9prFUUnwa1AN8bcjY3DT
2673	payment	1693	1693	89	1	1	153	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZpqBT95HT1Me8k1ZLW187i8mQzt5E4VGtvFJzyfce7nikodivf
2674	payment	1693	1693	146	1	1	154	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZbCsHy9bzH8uut6HSwQwjkRo3sbkRpL7PQe9Mdn9gTKck5mEws
2675	payment	1693	1693	92	1	1	155	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZWcets4hDVtcbWsYZKvzdz9UazDCw6ViQBu6E6syLvmWoGf3vQ
2676	payment	1693	1693	29	1	1	156	5279510058	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ8zijiNA7jHo5aQHPsDYrdwug9g67DexpNGdDFFBqsqAAPPVNR
2677	payment	1693	1693	251	1	1	157	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZqSTj7HkDcpMW9ug98br1KfHgkAwHLWJFRzDNi9qwfUzqF8WXE
2678	payment	1693	1693	84	1	1	158	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZPxDFqzmu69wDzxGiVyTxZ4HpBiC6FipJvVB2fdcLKdU2W2xi6
2679	payment	1693	1693	395	1	1	159	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtYekTeVt1uqjkyXoyFnsVtXQaS25em186RvSP1ezNr3DHRGKy
2680	payment	1693	1693	587	1	1	160	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtRh9eHQBQ6fDCQcQ1rnN1zHv4oKJxCJSTjGoxgF1AyTu4t8cU
2681	payment	1397	1397	1678	1	1	2389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vhfqfk21QsYistkusFUjT1LEJfcp5gftYh6UX8Cy5hGVRq4b
2682	payment	1397	1397	1678	1	1	2390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ntXEDNLbGRH6wieV29FUnpf1jdz6Nc2JmfSXSKjXuJvQBzqr
2683	payment	1397	1397	1678	1	1	2391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimt9Jopc3FFMZm5gYxFNcKqX2xmFrQZbJUp2dyXRdmGozBmic
2684	payment	1693	1693	611	1	1	161	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaDGeHGaeZPoGnaSTowTRJTxaeN6sQe7x4zgCrvtrdMgfm7EPRS
2685	payment	1693	1693	678	1	1	162	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZGaWGbdwNL27DFviDEb7zgNEYgAxVoHZT8ciX6id79SLEFrH7Q
2686	payment	1397	1397	1678	1	1	2392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjefeHvMme6PNrGPiZrHd7Kxi6EDuCtUKKwP3ByT9kTXRxSpEa
2687	payment	1693	1693	320	1	1	163	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZiRXzeAKz4EHkW42fMbPBPtm4FRobdbvB1nnVSQsAzhqp4PZFb
2688	payment	1693	1693	710	1	1	164	3771078611	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyF6fsN4bgwnTbWWnTrtv5HvVUs5bAii5LAAUA1WyZdjZWEZst
2694	payment	1397	1397	1678	1	1	2398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2yuDgSxABfyfoRi2S7XCjX5kyNKbzNMoyBFkFWqAcEbwTpZt
2695	payment	1397	1397	1678	1	1	2399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4uQED7bjgDmLAmoU8crKPFvA52h4YD1sLqrJ1rV4U9p54WHu
2696	payment	1397	1397	1678	1	1	2400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iLG5FgeEbVZAV9yNLuQWdH7KCw8f6sRJSiEHSAajNmgfkrTf
2697	payment	1397	1397	1678	1	1	2401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZps9Tu2mJ28hEga68PpT1QxdjUKv9QrT9GZJAbuxv4nVNf7LXo
2701	payment	1397	1397	1678	1	1	2405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPk2avfi6bojWwtbWjD3j7JU7Zwqqrd13Wm68JAmeFG69Q35ft
2703	payment	1397	1397	1678	1	1	2407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGuEsi6v8LEw8hvknw883zAXDutzN5WwJzZyTELbEySbPMo7B
2711	payment	1397	1397	1678	1	1	2413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pdUV4FFcQVcFpHPcx4gaUsK2AQJnAtPBXD9dmEUzz5JE6S2L
2725	payment	1397	1397	1678	1	1	2424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdaFhmTCNBxzHno1As3K4eqtYpTCHUyrWjKUDWXtsqutRZZju
2726	payment	1397	1397	1678	1	1	2425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfnYaZS9en2BL6aan9UAyTGqqPnkJiXTMz4rTV4kPXXM1XST3
2727	payment	1397	1397	1678	1	1	2426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3k5JgePjmTcJ5fM63zcK7RdGRGxJBnFByesMdTJBphWsjjTzN
2728	payment	1397	1397	1678	1	1	2427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXdkuURDAN3t8doVscR3SZsnxvzSEAsTWC7UpMYDZA4xTi5nh
2729	payment	1397	1397	1678	1	1	2428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsAbb4x9LChDm4w4mrFN6pZEtav1PDMZneNaAiLyA53AHiSqP
2740	payment	1693	1693	78	1	1	177	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtEX9zTYt7kpv2AakAT35iYfCxxie8vz8xNsJJTLdTyArZajGL
2741	payment	1693	1693	37	1	1	178	49271404754	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZZkUaCa8pyeZYjBgzh41ckjtNH7Niqedq99tev7rdo28Ycy7XF
2742	payment	1693	1693	520	1	1	179	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZQV35QVRagu18qPAP4Eoh52GF7LcDpPkYdwCNZhGUJTKCub2xM
2667	payment	1397	1397	1678	1	1	2388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASdM9oTPxiztUWgdreNSnZXy6sN6d1gMgm6bKDgN9zxQ5xMZo
2692	payment	1397	1397	1678	1	1	2396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtYuqt8zBExb9DSnXwaK9MaGKfyUKGXhxoGorhetM8XF54uPc
2698	payment	1397	1397	1678	1	1	2402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEGMv7JmFo1A5LDBGqyS9rSkGC6cQ5aYM59XXbMp9YYtqqs73
2709	payment	1397	1397	1678	1	1	2411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCosRfGQpatGR4oUK9ddgYtaN4L3JcSFTVuVWKZvFFL51wvpPA
2710	payment	1397	1397	1678	1	1	2412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbLz7ELRXRj3phfkiGuSCgbusGjoZ8gtqQFZNq2xCQXCT3Qkq
2712	payment	1397	1397	1678	1	1	2414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8VuYj7HQo4CHmJVmZ6X13WL1BW3tTuegxXhSXmAxx1ZAay4K
2713	payment	1397	1397	1678	1	1	2415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxd2LZteiEWqNqqLADfkpAcNH57weXV6ZJ2njTb1AZQrpg1q8y
2714	payment	1397	1397	1678	1	1	2416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvLefVbtTx5GahGniqHyNYYjF87Cq5VRG7HuYJb63THvfHt9o
2715	payment	1397	1397	1678	1	1	2417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSEUVQcVKy7qfQz17jF2aZgPArXkbNH5CmH7CaFMvZKbBbUc4
2716	payment	1397	1397	1678	1	1	2418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsM4iNRuwjcht7FUZ63hDHo9Wh2dToRTqzFuJ3Bhww1agGoKyi
2721	payment	1397	1397	1678	1	1	2420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCohcrk3fc8k13Ywpq3F7HmwZu4aDBr9CKaMeod3J39XaPywo
2722	payment	1397	1397	1678	1	1	2421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33KYVPa829XdzGxt8AvRCsmJwbN2rwNX1qJQTvyrfmWE2R5Dj
2723	payment	1397	1397	1678	1	1	2422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLeFFLqznemMCHqLEKk2ysWXt1wJ47fYDAxtFkjWuf1oZ1DJH
2724	payment	1397	1397	1678	1	1	2423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yB5NgEqjzMjS7vVAxmCAUFF75HfmVkZLR1jGjeP56MxRbkLx
2732	payment	877	877	1772	1	1	0	260000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXx9PavjXRkWrpn6oVwe29qEMD3PYvVu4N1yExCerjNzR63Dp
2733	payment	1693	1693	150	1	1	171	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZftY9kDwmPjrZD4QdCiHiVehm5f9DPZaEf8NbM93Ev1g3uz75s
2734	payment	1693	1693	450	1	1	172	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZdVSQFRNVsD8P1frn73G8QTkNmAPiAMWG1aLZbxXGUj5yrhEcG
2735	payment	1693	1693	620	1	1	173	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYugYL4cvfPBZWULi6upkFDEgWRzbtmcDF54K5w26xq5C4uV5VU
2736	payment	1693	1693	421	1	1	174	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYx7GcTEsZGx3LpUF6AL43b1Dqu6Qu9ByorDL5LwDGZzJb9ekf4
2737	payment	1693	1693	245	1	1	175	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZWotYm8Sjcd46dj6MQCNVC3RVvvujkviR9cW5SSuy9FffwiUFp
2738	payment	1693	1693	54	1	1	176	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZoeeSzuCEiACsXpNkouHe7ZXsy1B1hBxajA63T4DCSCK3xzdd7
2739	payment	1397	1397	1678	1	1	2430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdgQaLvSz79YRLqXwfSxXU4m9n9aBkNNxSds7uMed4or3Qs3t
2748	payment	1397	1397	1678	1	1	2435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm25PUU7yMx5L1bPH6VKKx3MdGERSBTemid6ppbnrJXfXYmfE
2749	payment	1397	1397	1678	1	1	2436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGrW5fVCJzXu9WYTJgSdJUcsjJY8aM3j2SMbUy3ZC9uhfyn2V
2756	payment	1396	1396	436	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9Cj4LCbRxHCNh2pyca2uGvJf2fzkTKaCEUAB2GjqWytRnCR4
2757	payment	1396	1396	436	1	1	1	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHEVhFEZRdfRo6b9yPnkoARHcAuZ9FBjMf3MbiQZCQ2GBCxkQ
2758	payment	1699	1699	1773	1	1	1	8893278499961	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ74WA336JmCrc7vaJhAcwoAfAfmnns9Yx12fKq8WEqNZg9vfm
2759	payment	1397	1397	1678	1	1	2439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYfcN1emenv4T4GfERb27Cw3zPZrtR1Jx2qEwCBLjNvLk2YrA
2760	payment	1397	1397	1678	1	1	2440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR654n8y85pats58m9mCHg1g8MUmTGF9ogi9mYLUpoQCzX2qM
2802	payment	1397	1397	1678	1	1	2451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobFcEneSmL8SUYVsHjYx6BXv7KRqGxXN6q6Je9LDSfMkPDfyp
2812	payment	1397	1397	1678	1	1	2454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMSi2p7cq121ftVotpW4uXqgRyfAeiH9hZtepaxEPp6arvGhG
2822	delegation	283	283	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqtbQ8CaW9mVmAQpijgnPrgZRjZbYZUghjE78Kn73WmowRM25
2823	payment	1397	1397	1678	1	1	2461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjBYLRUR7VJ9yrEtQi1yww7pXzBCvjfTnsAqvYCYgPLndSdsz
2824	payment	1397	1397	1678	1	1	2462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wfQSzkbQYmmVc7jreCa5CG2NUjRMoPokVnKRKxEZrzcj7JpS
2827	payment	1397	1397	1678	1	1	2464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYa3u3L21EoBUvsS5BgmJL7XnndZwgXkB4SWac8K9cB2YEqLYW
2828	payment	1397	1397	1678	1	1	2465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAbbY8UMChhNB2289Y8KsvXxTtvJYLfy4Lb6z4KLmwBarrJRa
2829	payment	1397	1397	1678	1	1	2466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxt4rQA3EqJvaAdJ5fCpPkypFBcQaNiEnU9rwuShCAp94dXDgp
2831	payment	1397	1397	1678	1	1	2468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbtB7iswVsQShUkfbmXb9yyc4yQFWxmYGPXN7qJY7A7qTBfrq
2689	payment	1397	1397	1678	1	1	2393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Fromn2BGhV7aCoTJZg98YadiSnfzx6fiEcmMmo72wBUvGfKu
2690	payment	1397	1397	1678	1	1	2394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPz4bpQarzcPdivDWSsMDesuPXCirrzr6XMqQU3KytzD6udec
2691	payment	1397	1397	1678	1	1	2395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4eR6aQhpQJ1rPn4X5J1M4cRR8eTr5omNvNEyF3EBoNVSys2g
2693	payment	1397	1397	1678	1	1	2397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3GvVqv86JKcQfJaWWXGR2qava18PpSia2uarAYBQ5dxeNTYN
2699	payment	1397	1397	1678	1	1	2403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj98ocheWevnXEjRdktGer4o2Z9xhAjrHn85fZ6vQZ7MCsgef
2700	payment	1397	1397	1678	1	1	2404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxpnYpQXD6fYKH2L6UxchkPkr7eSUwpd5dTkYqhmGhagW6oXC
2702	payment	1397	1397	1678	1	1	2406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1XgtaUhDZvUDGCao3xh7zFLfc1QmeYtwfzz1qQqqpfDwW3Af
2704	payment	1693	1693	721	1	1	165	1508431437	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZH3yN9xt2dL5QQ7fbeyoEVMKkR5f5Y3tK1rB4nTybC8D6ywBGd
2705	payment	1693	1693	295	1	1	166	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaA2xMpvDrFFhNJDuwUXbcw6pN65nxVCtytiAdqiFzM9mjTf8xa
2706	payment	1397	1397	1678	1	1	2408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4ZyPuCUNEcTatDDi6unSsLJwDS6Ty5Z9pqQtG58Fd1UCHNS8
2707	payment	1397	1397	1678	1	1	2409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJyUyb3ReEfD3jR2yH1FzjN7norEh6CLhM6AwwYBNSAcqKkPh
2708	payment	1397	1397	1678	1	1	2410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9usFtraythcvzE5VAiH1wqhTymGSdXUyQHhBsBPDoQuTtast5
2717	payment	1693	1693	560	1	1	167	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYoPUb251XE6BrFKYE9UD5gaGDXYTQaaa3L7Ba1CzdLknRHaDKq
2718	payment	1397	1397	1678	1	1	2419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMh1cgvi5KuQGQZx9QBLBxoC2raK4y2ZnMyjppdHLm91P6BSdU
2719	payment	1693	1693	392	1	1	168	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa96MSFcctBFzowR4wN3WMib1qneX59KoNvyRUWTuXahvShiJVd
2720	payment	1693	1693	194	1	1	169	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaAkzCf7K41esqSoauNdHnP4QWPWaMBjTAhUsgzff2PNAKzzKCU
2730	payment	1397	1397	1678	1	1	2429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVr5GuWYcEJV93TbFnjCRYM1YvFKTsp2PKkiZeC314w3BMCkE
2731	payment	1693	1693	252	1	1	170	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyurbNYgZrNFgnuVkRkEdhqidWh5Tt2PNuizuwSJUaK12VxU7Q
2746	payment	1397	1397	1678	1	1	2433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLV6DfVv6aYjBJDSHKW9RLD6p2KsRND7os5KcBg7Gf2GV4jxo
2747	payment	1397	1397	1678	1	1	2434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcmtR3pZ8mA9YFqrDMfpd1Rna5VaZvhk8rUcSDa7CsrVujSPt
2750	payment	1693	1693	1150	1	1	181	458476837668	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZLDhMRm2gZUgFKLNtpAT7uo5TKpvDkFZsssdopv1HiLbR75KC3
2751	payment	1693	1693	452	1	1	182	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYh3pMP6qfAVpEEJ1WuqbXbKu8s1Gs9VTQG9is1z9bZ8pXPgRVN
2752	payment	1693	1693	594	1	1	183	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyaVgMpAaKN7SN4sf9EJRqFfPfJgjCZxrGkpJxcsEqJr8WSr19
2753	payment	1397	1397	1678	1	1	2437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8JVyvduJyWcQwuKkB1PbEbgBDS4MtmP8fJGfqohwaFASFdLU
2762	payment	1397	1397	1678	1	1	2442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKpDqYf3WwsafGPCHLPQgXRt3q4EFZiC31KdU8jTPggp1TX9y
2767	payment	1397	1397	1678	1	1	2446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWb4QQi8DBGzkCBwGGfF9tjRMUwne3sgS9URNnjsi5FqUKYcAX
2768	payment	1693	1693	391	1	1	184	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJjASqZUTzByYP894fzNGGWmTp6QeUMVWJY6EaRvLRjvXBo3tX
2778	payment	1397	1397	1678	1	1	2448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBGDHdpeS8mqPWnZcRyVFv2zyp6JhZaJMyMYmnJ5pKZcyMrmE
2779	payment	1397	1397	1678	1	1	2449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSWEtDzztazncBCJLWm7xcvzvbWuHP8DbeDexyk2oq3qQyaywx
2780	payment	1693	1693	660	1	1	193	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZazdoKsHFxbZwSwG5pdhwAeq29XAuWwnp5bxy3zT25fWhZhiJ8
2781	payment	1693	1693	1276	1	1	194	1277586473640	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZftcmoiJmkm31iQMSwef6iDTX5mkSjMXoVUYJUBVM1wXer3E5g
2782	payment	1693	1693	180	1	1	195	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZqTHQbmMAdcqfejV76guhpVcdqHWidUmCh8bJoxE7KHCzsKNSD
2783	payment	1693	1693	353	1	1	196	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZJm3i5guZhH3m3kWayjFupwqacdJSaanPkWobWi2wT59YdJ4WZ
2784	payment	1693	1693	108	1	1	197	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZTF3W8VrJongfUMxBNwoyQ6UuvZASxNqvTsM7traVXPsGg9Vei
2785	payment	1693	1693	390	1	1	198	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ9nzcKQ7a7nehumPXgQ6GsLkjdy6LY1wHmJ39qjzdMysdTtrnC
2786	payment	1693	1693	601	1	1	199	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ128RFm2K7dcqB8KdqJGEc8dxhbY2KrMRT2rCEJdkvdBECCYXQ
2787	payment	1693	1693	266	1	1	200	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYxYjUqpgZBKV2CsfP6vRV3PXsWoakaoVY3GHcKuKf3rqDTdd3o
2788	payment	1693	1693	600	1	1	201	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZimW4B7Bq4hMi68nzQJWrJVSG3xL6EkD7hZ89guM94v8dnep1F
2743	payment	1693	1693	163	1	1	180	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ258ptW9ur8xjvbBmMq6PLqYxxhKEPPKamYH6WEK45ANKZHpPX
2744	payment	1397	1397	1678	1	1	2431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UiXqDenZ6e5vdwrNUeBV9QQrNy247ZMNgxPNFHF2zHtBHySj
2745	payment	1397	1397	1678	1	1	2432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPTNhSsimitVxF5JenhoEfwMyhrerJKDM3sLYhom2Vrfzzs5L
2754	payment	1397	1397	1678	1	1	2438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmj8msz4i3kK399A3jFuUhZbS166ARkK2zr2HaMhfH7yvTh7r2
2755	payment	1702	1702	114	1	1	0	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdiTpTvyv2CPSP5nLobcFqm8Dg4kCBV5dwxxRrujY7sN6Uavz
2761	payment	1397	1397	1678	1	1	2441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFvJ1R1PVchfA3iq35HyQxiR1dibFxoypjLe7NHzyzhvnYEyL
2763	payment	1396	1396	436	1	1	2	716700000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjhSFuiw4ACPjVPPmNLy1zEQH4fLYdZKA6ednWaw8GG1xi2r3
2764	payment	1397	1397	1678	1	1	2443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQhdGPNutrbYbNE9ZyZ3vg7a9Ux8W9CoA1cvY7u931UVyNNbZ
2765	payment	1397	1397	1678	1	1	2444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5faib9ymsEpwxfXEMBUMtNqvmfsZdxszEzJMxJrzap4yJCZ5
2766	payment	1397	1397	1678	1	1	2445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRJ4f5e6KeS1WNPt6nmFbQbQVkpEeCjvqNzHYdraGsoA6Bof6
2769	payment	1397	1397	1678	1	1	2447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPKoWpHeFtYDDKBoQYW5n65UpbS2eWeaJLNvPf8mfBPBei1q2
2770	payment	1693	1693	622	1	1	185	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZi9cRVcNCbr6HKe3JKtK1qUimbkFAWHVMN9UCi9fbgfAdzgF5H
2771	payment	1693	1693	653	1	1	186	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYRAUjZKQSnEcRFmNN8vhTY34Fz8eGQjgVjNSF5dmhyzofksGu8
2772	payment	1693	1693	193	1	1	187	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrEfqKHgGvutL4K3VJUAbrDJ5eQZEmu4UR9VM6AJA87oeNwcs9
2773	payment	1693	1693	504	1	1	188	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa6UyLNTxzeg8rzCBL2PFiSxYfHb9gb7PQZENeR8QLiqLK6UPAv
2774	payment	1693	1693	593	1	1	189	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZK6v2bW7GNXwHnYfDdJHKQXzpbtAcs2cb6UKX6zbN7B67chDts
2775	payment	1693	1693	658	1	1	190	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZev2rUHXQqyGRZtuGULRCdykgtPGbLRUu7GbkWg241pSEsqgmJ
2776	payment	1693	1693	6	1	1	191	24555755502	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYjy4yE8r5FPZF5vBDFfmvj9vdiseM2zDPVfwMEA4pNh1m34Trr
2777	payment	1693	1693	652	1	1	192	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ3wPDKBq8UMVoSSACz5Y9Ar3NbYckgi9ALshtFRFogfNsmBfd1
2797	payment	1397	1397	1678	1	1	2450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6rNchxJqbjd6nTiw3XUWrMByRmKQue8Zfo7bccuyyv3WZp73
2798	payment	114	114	10	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtG1NDdBRtttmyaRyrSMvE6V71i8nb2FEh34CM5hheCzRGMT1p
2799	payment	114	114	10	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSwe73TbX1a9RUFTEGnFjoibwyY9ywbe8BaASfB4Nydtsd6pK
2800	payment	114	114	283	1	1	2	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5q9DCct9Gnhhk4bHKYSHPrRe46KMLppxui7mZ6uScFd3Lbsh9
2801	payment	114	114	238	1	1	3	200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbwR5EXYYrdTArpLBm6Po7oburUHAkTkgk9C8yUCYJdqCHCpL
2803	payment	114	114	301	1	1	4	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3PyzDhPuKtP4vry56jx2DRUv7PRgKvgXRCJU3gdvxs2GZAtZ
2804	payment	1397	1397	1678	1	1	2452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnGBvSFy4rYAowa8iVCF1wJYdXkPp2Z7TVJrZfYEAtahbgZbT
2813	payment	1397	1397	1678	1	1	2455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSHjhy7CtgEte8NpZYPgesBtk2PegVZS7ewwGeWe5VupTo8kv
2818	delegation	301	301	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMJnyFDNu528pV9ULkfnhJkHXJ758y1ivFotm6YfuKwWPmdab
2819	payment	1397	1397	1678	1	1	2458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDk3drNbBWYZxQiYpRnYJQoTnt3qC2HfShQDZZefD6gKM54FQ
2820	payment	1397	1397	1678	1	1	2459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAwFgqb2kApXTRfQzLjFUq9ExiMeFLb7rp9kFaptHuitswQUQ
2830	payment	1397	1397	1678	1	1	2467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXn5LZCQkt4xYLpsNP2mUU5RFQ1NG3BenS5tLGihJX5TcAjxCj
2856	payment	1397	1397	1678	1	1	2474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHY5EBgSEjMwqpA82jgKkLZQDJqoRTcirL9awrFnEguccetALx
2857	payment	878	878	1772	1	1	0	259000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYJsK2wVBUtuUm48c8YB8fCnF27VKLbaNvZUNRzuTLYUbog3C
2858	payment	1397	1397	1678	1	1	2475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvXKpViv7R4y3X3xHPJemvcoK1U53iW9wBMHsCjZBSygHxEy7
2868	payment	1397	1397	1678	1	1	2484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6taHZTTAqfPpPQF7KMG5Uu5DHHuCLa1eTSTJAzoHQvHU6f2C5
2869	payment	1397	1397	1678	1	1	2485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CUSvFsA34iF92Q4WKTWSUqD5VZrdVdfvsfVBN7d9YNTGwAMB
2875	payment	1397	1397	1678	1	1	2491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesmq1xLdgjxdWRhMiQBCL5bMj57KkgJ7JRwdCgwZqQJtJjV8K
2879	payment	1397	1397	1678	1	1	2495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpM9dUY1UMHDjcsVaEXgB66WcH8RE1huAVnrc4bz5CMQH7bGi
2789	payment	1693	1693	691	1	1	202	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBYmXjt2CrRFnbUhnEra7ZnwZrsqSp36FAM3GPdan2qiGPhGHY
2790	payment	1693	1693	352	1	1	203	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZfGbj5x6JjWPGCb3omazniJ64cDedB6a9F7FPnS3teUTThzahA
2791	payment	1693	1693	63	1	1	204	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ7TbkJStBmJm74yi5s75QWakZHen3XEszSn4x8L3JSaTn5Rgjh
2792	payment	1693	1693	739	1	1	205	7542157223	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYa1B9tLcZwqgzgucGYBnB9C4nEBhMd9XNqtVmCZSpyFxqmnd7m
2793	payment	1693	1693	893	1	1	206	231410667894	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZDeF5QC2DqR7CaA94cMUR2NbchxCW2sccjYE3BzZ9iNLyoWRZ6
2794	payment	1693	1693	377	1	1	207	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJZ8K1UrUhjSkb6waV4nUpmPcPGyN1Bn462u8A77vGFpETcn12
2795	payment	1693	1693	103	1	1	208	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZz5PFeZh7Wwc9qCSSrfJqSMSANSi5YtVLNdcEZTFrFEesaXhJ9
2796	payment	1693	1693	361	1	1	209	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaL7E9NRUfncsPskC33WPseiCYsnX87PW6Zi28c9DaKASv6mXHM
2805	payment	1397	1397	1678	1	1	2453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkmKUfrkPfGMYnUUMr5b9ppDHpRZBVqrQ7SBXctP6EkQAPuhL
2806	payment	1773	1773	182	1	1	0	153938198848	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	Ckpa1MjP2ZiLn2hK9rZ82QyTdmpoZDFEtCp37xJrFy3Adnu3wGyZu
2807	payment	1773	1773	702	1	1	1	102625465903	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYsbEMKKcVNe11akRgbHimbvbE9BzgQecreuB5QnWJUjnrcyFTU
2808	payment	1773	1773	927	1	1	2	1171678650623	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYyiUai3zNgZFPwKvTyyMchd6CjYbvaA6cweKDN36p8q3U8Jqpr
2809	payment	1773	1773	1047	1	1	3	2099638102978	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ29XF7t15GQNUAJbvvLywz4eGZMd3RFsfKh7ShoLhk1xCZnyff
2810	payment	1773	1773	1167	1	1	4	1416667666323	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaAVams3BJAsn3TMRYFnVXSv9AtZvLbzQbERLUyjFpNvrwwPYBD
2811	payment	1773	1773	1293	1	1	5	3947670415286	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYjkidwZXAJugWJ2K67A8NKk8mM5rVPk76dvgRGZv5difMHb5qQ
2814	payment	1397	1397	1678	1	1	2456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwvAYFJCa6ZcGcYf2rfUVyR75Y9JcEkqAW8f3umZpsRyLSMvB
2815	delegation	114	114	1483	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKRivC3FNkczHTgXxzzap5VskQACNKp6upVNzSM3r6FnXAcVD
2816	payment	1397	1397	1678	1	1	2457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCm91qAtcfbK8onZ2mz9DSRGSN329VceZGWspN3Ge5Hb7XNBoP
2817	delegation	10	10	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhnVc3AsZ6m3jijZeZz9gSAaCNQwAe6syXdCEpRuG8yjCZSaA
2821	payment	1397	1397	1678	1	1	2460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGn3SLsqtWQfVWdazcam6rbKzgu3puxNV8HK29q2SmV16MNQk
2825	payment	1397	1397	1678	1	1	2463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjn82FgYqQMxFXWtRRgxHEtyvchAsswAgiVHaECZgKxMH7TMC
2826	delegation	1750	1750	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDHZh2g7Mv9CVpKhMtPco6izkfC1CpDgLYHvLvnekXT8HxAzk
2834	payment	1397	1397	1678	1	1	2470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetdxWecNgSjLy6bSzoQiKKUHL2SZ8rrVivPJGf7XDUZX4L2s8
2841	payment	1397	1397	1678	1	1	2472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjy1sVx6sAazpR64Qv4wUgH28VfXhEVnqfBvgKPVPeprfjWdxw
2842	payment	1693	1693	499	1	1	215	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZvXHqivERgWpW1JCYKGpco7kFttanGxbz3DSgaMDDSkBHfSMRA
2843	payment	1693	1693	35	1	1	216	14480941877	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZyiW8RPCpvX5B81u4cmWkfxTHEZ9esNK1BWGTgxMMcUPtaMCbR
2844	payment	1693	1693	49	1	1	217	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZdco8M2Tb2nsu5XL2wPJuSMnVHKwqCCcthLfxUg5dCKVxijrQQ
2845	payment	1693	1693	112	1	1	218	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYezc2qjsfEEJANHbRYDnkG6HwHVKrhxsEjWG87ApDBToN9o7s2
2846	payment	1693	1693	127	1	1	219	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYeEGwTPn1Vw3KQx3JP8bM1N49oH2QMos18MKPcfoLEpagbWhVo
2847	payment	1693	1693	186	1	1	220	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYnBQU5sxXvqSzXPX64TMs53VXTgeo5pfc8zMVpX3NSPSePQuTk
2848	payment	1693	1693	551	1	1	221	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZzYcV3x8vVNHQ3Fejij8WPr9V68kzAAY1HCVDvWtdSQTuNhh93
2849	payment	1693	1693	663	1	1	222	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZDP5gHV8sPWua5twVVBxebReb48E2aHkv7JkSbYQgRDLYeAJuf
2850	payment	1693	1693	680	1	1	223	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	Ckpa5KGkBwfuiBbV9MWXv22ba61WX24UoijahKkMvEnuH2oCE8Xao
2859	delegation	1772	1772	1483	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3miRYR1sY86YUEJZDrJyp6KZHaCLzQH1zt5ca7sk1KWZMWkhs
2860	payment	1397	1397	1678	1	1	2476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfQFhPY2vzuwW9oqDuyYpshbFJbw79nL771EdTP4Ky4tiWXWv
2861	payment	1397	1397	1678	1	1	2477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTc1ksPXRKkqMjTAqgh4rXHpAGiSuMYzQXKdBMpVSP9etdwFMW
2865	payment	1397	1397	1678	1	1	2481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDyZ8tu7VsGhEZDVxUVUkpN1bv74aSvMuF7H4dKbmFUX7VFzN
2870	payment	1397	1397	1678	1	1	2486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6qvvPHpHvCm2SMVzQA2EZcEp7gEiHV8CvKvbE8iCeycN7uqc
2832	payment	1397	1397	1678	1	1	2469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiCQGVvC5F8HEvu8n8sexyQDcznzrSuEhNhyBtDTawXwNy1uB
2833	delegation	1750	1750	1745	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPmG36HvTopyxmc77yGtas78nAivCLeqy68yAmMEtY8JaTt4V
2835	payment	1397	1397	1678	1	1	2471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDG5Qjez95WzmXgjAdxxjtYDwSxMnmMMaDJ2KmsKtLALcfej6
2836	payment	1693	1693	453	1	1	210	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZDFt8Pc3VH7uqqnmDE7ciioD98qAq2cDu7PSxKdb3FKN9Gpj8B
2837	payment	1693	1693	82	1	1	211	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYs3Nz1StdDxRt5cLATAizeUaRAM49RBHEmKPaVozePE52tovmm
2838	payment	1693	1693	261	1	1	212	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZw987SegjacdHgp2CLSh84SwGhgmTML3dwYA7F9uoCQTGqREyr
2839	payment	1693	1693	201	1	1	213	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	Ckpa4RVvHPJ9NJw88cBJf3RQQJQAbLX12rhRjdgCSK1L9DgxzvAjQ
2840	payment	1693	1693	383	1	1	214	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZ7MWkwAzgU9qK1xwELEKUbf1N8zkR8FWQDqK1Xe4VUVmGDcutK
2851	payment	1693	1693	878	1	1	224	153145890887	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZyAtk5ToSm68JC9DQ2qkNV4QC443wPyzqhnri5URS5RkMsP9Xr
2852	payment	1693	1693	569	1	1	225	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZUfwyrXxUsKLgrUvNGj6QrSHQsTKfypmPQm8ASvKistABAPouR
2853	payment	1693	1693	745	1	1	226	1508431437	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYZG1GifiA29dJSacEpfhAWW815WuXrgi2USSDMwRKvD2Y7to7s
2854	payment	1397	1397	1678	1	1	2473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNPWhEMccai83NHSjG7371RYcyGxqkLfX7puJpELobskovyYp
2855	payment	1750	1750	1774	1	1	2	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacZcEawMU3F8WXkHmdcbGMrCkbDWYYhSzZ2voizBqpKG3cZBZ
2862	payment	1397	1397	1678	1	1	2478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzyP848EF8qGjeFCJ7atnsaRjUF1PaUFR93zNYhCTCm1uuQcB
2863	payment	1397	1397	1678	1	1	2479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAkc5U9JnoWgVLFQzQe2sPczZZhR3An8iCrgJowXAg4mCiHTh
2864	payment	1397	1397	1678	1	1	2480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnK3NCckXuz7yfjtyHCsJFpHWJKFcuUpLcVVfUfBGTgBVvDqd
2866	payment	1397	1397	1678	1	1	2482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYretdBEdjPMSXYVRPG8G1qdTg6NvoKAWv8qSpeUC1k31XAKu
2867	payment	1397	1397	1678	1	1	2483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QP16PgYj6tqv1sknVjnwjnDugqnpDaa5muNjgJ4TnM6SkqRp
2871	payment	1397	1397	1678	1	1	2487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQhReUzYZ88m3f8eXBr8v4hXzsXK7r1iYrTAJgKTEWfBUh6Sb
2874	payment	1397	1397	1678	1	1	2490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54SnfULeJpfEP8udr7xPeKtHkq9YKhK6Wi1smdBC5EoAcMbNV
2891	payment	1397	1397	1678	1	1	2506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJc4BGC6uZuW41mEHghK7Jch9RtaqghcLBwL73nqYcwQ6y5iK
2895	payment	1397	1397	1678	1	1	2510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9k2F1oEjs3VpMApJ85sXRBdhdtonevn6iNEGNfDB4fWKagsv
2896	payment	1397	1397	1678	1	1	2511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGJZDrZvPtdvTXLBWFCp4Sj7e5ax3i373v2mgNAjihATHmZTG
2897	payment	1397	1397	1678	1	1	2512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSTa8UFnHLVNMR2G1U2NssTLu6Z5nxQE8J1BwVvEtxPLXAnnk
2900	payment	1397	1397	1678	1	1	2515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rDr9Gb4MtGqkx339f8xQRQgeP3au4CnjM6qRPYohJvi1wWyN
2901	payment	1397	1397	1678	1	1	2516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeou5Szg7h77EER9W8Pkoxzrkr395xBEip3fZF3D2ovc5MJPu9
2903	payment	1397	1397	1678	1	1	2518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWzizBXP4bmhvewHUcDXagC4PmwWVtfSW5aP1aWcgtzoQxkP5
2905	payment	1397	1397	1678	1	1	2520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxPo9SSEujoDDb9ncCvbjFwNNaaLnDhsqrje2gT7kuHD9BHiX
2906	payment	1397	1397	1678	1	1	2521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa98DPyif6o3ijnccBfrKf9ZcDQuv5T9LHL4GkNrTEonNA51R
2907	payment	1397	1397	1678	1	1	2522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDseMtxHyNQE5LurLpPzP5xoEFJHYXeNofXRq3Wmf73L3kfbqb
2912	payment	1397	1397	1678	1	1	2527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4Lxh8XRkpYn5731crUWrVZtgChNJ9hNuqNURZ5cbCYxiw8mE
2920	delegation	1709	1709	1500	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKyWkzfoy4goeF8oSdGTSGm2sXFySrBbmTRtLFRNRrujV6KR4
2922	payment	1709	1709	1776	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6QdmMMmsTeMkDyd6mh6hHoxmMjKBFNrDK1wooBgDbDu26Yxm
2924	payment	1775	1775	1605	1	1	2	10000000	1000000	65535	E4YfGXnruh7P1EnUejuaBsFBhThYTKgbMEcPHYXCob6WvFN87mmWP	CkpYthAVS5vGkqMAV3nNAY6ZveY7tcnkscEV1BWKRv4HtCuGWYpb7
2927	payment	1541	1541	348	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxBVXtj3Zn1jKXdu5JiApECX5a37ZGetiy25TTc8YNmJs4uoT
2928	payment	1541	1541	1777	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1U7hXA6cw6Hgn6tfvRWhSneenV8SyjSD7rdAHEefixRyCVRg
2930	payment	1709	1709	1776	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVZWCN9iP1jXzojEuzgNCMu49C25qbiy3yyxUmiuzNKet4yZR
2931	delegation	443	443	1483	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJM8CBt8T4dpsXCYEErn1bS8dGtVkYC2U9J6adPZgwr1T95AQX
2872	payment	1397	1397	1678	1	1	2488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTaKKbjYtdytyWqnanTc2UpQBadJnYYcZLCitZJQtfUSPdSuE
2873	payment	1397	1397	1678	1	1	2489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPxv4pUZtZoUxvPDKJBdDSWp2ozJ1LxdXPVjQZByrzrz2Fc5B
2876	payment	1397	1397	1678	1	1	2492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnJHcdKfZFaE7AssB6JhH56doW7Sj6BDhDjPqcnsqVS99r3Y1
2877	payment	1397	1397	1678	1	1	2493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJbRybWfrTMAzxG2b6RWMmvmhwx8zGPRmuqjMTGgMP3jWo3UV
2878	payment	1397	1397	1678	1	1	2494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpprp1pYjkrU74u5DnXyd3SdcYazhFS6pjD8hRifPMJANsFSV5
2884	payment	1397	1397	1678	1	1	2499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dh8Zc5NhzVcQCYrggX3u4f2GQdSdj76mM4shv9hkWFPSYaXL
2885	payment	1397	1397	1678	1	1	2500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSpkHeqoT28FMU8Kw8Ygwgc7d4vJL8RdCQAqQB9szApMPUsc6
2886	payment	1397	1397	1678	1	1	2501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKktFnvME7bbpHGcUvDkHdu38frMao1ikYz8i6xkUGinnXzXo
2888	payment	1397	1397	1678	1	1	2503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUtbordmyW4T6qHb9qnms8sm5LYAoBK5cztsQUjeBJrmzvBTF
2890	payment	1397	1397	1678	1	1	2505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnvHbz3anSzdNfXkNbDkHCcYXY8qqQ8Wr2BjcRiEf3XfnNCoS
2893	payment	1397	1397	1678	1	1	2508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvUdjo9N2WjPeT2yDiMjEuNpqCaMwUePqKLxcL6DAHU2GBE1s
2894	payment	1397	1397	1678	1	1	2509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1tp3s8ogChVyTfu1jAYV92Pb48go4oivbsU9A2RnvfczWD9r
2899	payment	1397	1397	1678	1	1	2514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeFhUHw8nYvGKRYD8LqpRkiDoPKWrFurGc64jLbM8usGtfsDU
2902	payment	1397	1397	1678	1	1	2517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75Xwir1Dd1zbwogpyEHqY3cpvowLjRfhE7o6s9WQbU2cy1zxg
2908	payment	1397	1397	1678	1	1	2523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUQ8WvsSiyqxXjGx2hFQ1J1GsFru8c6eQ7ig6miKpHNYhaE5o
2909	payment	1397	1397	1678	1	1	2524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB8eUukauBHrjXe6Af55fiWqkCqS8CFuf9u93SmXyq7YJQRZcP
2910	payment	1397	1397	1678	1	1	2525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHitAU5RepjXeaujB4sF136kWwCpVkqKGThxnVY6eELmpNJmk
2915	payment	1722	1722	1749	1	1	6	3612000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpVzpQNZaUeJZr8T7oqhbK47in7aVYiZ3uFJSzL94iRxgefak
2917	payment	1749	1749	1764	1	1	1	3612000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXa3g7dLspLFSSZP6b4oCBtRxGYBc3tRHLzT5LbSmQMJQdzZX
2918	payment	1764	1764	1749	1	1	0	3611000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHqC4kfvUKe6ExQKhioNfquaFTwr6FkknZar4aqg7PZ6kq6kV
2921	payment	1775	1775	1605	1	1	1	10000000	1000000	65535	E4YvpVCiVwvnR3seivfBM47ez2CLg6iMEVfyE3qJVfLMivzBNpn9W	CkpZjvKUbvqAfPmYaM6mxMDsqDuPVtXv2b3ryBo755Zj6tAwBBiV4
2929	payment	443	443	530	1	1	1	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96mEaW6uwttgmNv8KE4Y5nwmH7QU4U8A2AcEZmMkJ4zb3xvHv
2934	delegation	1776	1776	1500	1	1	0	\N	11000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE3Q33sgbdkFXTxnsTKjUT5zQZvzT8dVoJJUHP9NvgZccMH4F
2945	payment	1397	1397	1678	1	1	2536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzMfC1QQTwV9pd1cdrBU6q7ucyJQEsBvtsNTVbrqKMa2DtFbn
2880	payment	1397	1397	1678	1	1	2496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNyhyJeWRMipnvPRgj8mNssjmt3JCFqPybyVykHfWy4RwL8S9
2881	payment	1397	1397	1678	1	1	2497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRYqCKBBeKZ5gXa1TRjz97GjiUGj11PCLqag1tBPm8yPTMoz3
2882	payment	1397	1397	1678	1	1	2498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPFyELggdVcVWRwXGovWMmXARq2mqsAZGoYaQjqc5wHQFNYcf
2883	delegation	436	436	1396	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPwGeb2sNPkM64dr3PxThFXjyJDkgx96E4777MthPeoXdqtCa
2887	payment	1397	1397	1678	1	1	2502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5ELszhvQg8CjxynTuwTaa44H8T5Dt1mEYfc6cPVynaUnzf4f
2889	payment	1397	1397	1678	1	1	2504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6aSwxt6m5DYbfwKb4vv3MZTaQ1ZaAgothjB1sWFMeiT6fnf1
2892	payment	1397	1397	1678	1	1	2507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2k5crgz43J6pE1JxekQG8kt7emMuGbqxhmabMNA7r8kDKYv2
2898	payment	1397	1397	1678	1	1	2513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznNutifeX2Q2RLudZGkXGb2CPZhdewri8UaLH8RPHxCtBizHL
2904	payment	1397	1397	1678	1	1	2519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCZ5HSuczi4QuzCG2nExaUqGNckhdzqtk5Qutt6REFPiwQ1Th
2911	payment	1397	1397	1678	1	1	2526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VhWcihTHchGZC4YKrJZXWAy4mYjAnTvWFrbnvtLkSa2naRBP
2913	payment	1722	1722	1759	1	1	4	5761000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQUqmj1DevfM7YZvjVzDrEtfUERmMcGh6Luj1ULiomSVr7wux
2914	payment	1722	1722	1764	1	1	5	4320000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZec5UbEHeC9s65xV5oV3KpeBH3cWnqZJzfm1DiWCpDmqJ6JkUX
2916	payment	1521	1521	1775	1	1	0	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtNW6v4tNvoHiL2HamFVPb2647WufiN641S833h7pMUQKRbmz
2919	payment	1775	1775	1521	1	1	0	10000000	1000000	65535	E4YrvzrFbtDw4bc1ZWr274D1kVZ5JUvRrqYzmttAqXYHeWGZZTrYJ	CkpZPGX4sXTRir6Q2cPP4pkrbE6QFLLYbrnwmEWxySYGxrGKUeKiL
2923	payment	1722	1722	1749	1	1	7	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZetchph7tfqAbagHpuT3uTbiwUmGr9awgpvusdMrQJFLPkEr
2925	payment	329	329	11	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXbkRMeW3nWzGLU7H4cZppWbs56GnU2nQfGZk98rA3qJfqmh3
2926	payment	1775	1775	1521	1	1	3	20000000	1000000	65535	E4YfGXnruh7P1EnVFLggidb6QqVWw4rCGTxfPbwJ1NZ3KvY7emduK	CkpYV2gGPCayCf64ZD5cYXDnEqQNtAGwJYRZ4htHRpGW78ey2BJTy
2935	payment	1693	1693	1778	1	1	227	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZZk7yWrxmfVyPJKbQ8yWUqmkCCxZSFkr7JmH5fSPB2uGsc9L2A
2939	payment	1397	1397	1678	1	1	2530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRWgpULX1nvtc6oRFmtKw9NJuBi9KvPEebtZfh9jZ4GWL9sGR
2943	payment	1397	1397	1678	1	1	2534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgbF5fRhXaPyNP5py7uaHyYA5u75i4oarojSeT2STbrEgu7Y2
2947	delegation	1778	1778	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAxF7MdvvabaE1zNKPDcUn8YTpNwkbpQpvqDnZDnYFkVo6FLa
2948	payment	1397	1397	1678	1	1	2538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaTS2iBWePooCefjA2qF5ZcZSeHYb5Dc8sYpNaS8jZYjM9uzm
2949	payment	1397	1397	1678	1	1	2539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjcj323zSf78WFH8adHrZGwMKzyt2wBKET1FtnS3Ci2zJDchz
2952	payment	1397	1397	1678	1	1	2542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4bFUxNzczYsfchY329gwD26ALj458XqrBm6JHq9JnPSxhHPs
2932	delegation	530	530	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwynTCYS5Ny2c5Vu7DrXLeyrLFTsGoJpJRfQLKv9VGN5Adt4Cz
2933	payment	1709	1709	1776	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3nSgLHwqBtYYfFoTB7UaVPmmhdTPonBJgjaiyhp7YPYCyaii
2936	payment	1397	1397	1678	1	1	2528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxokgKpfpkAebV3QQ2Ni32tV72Bgsozvk1aStA3CxZRaS2uXFH
2937	payment	1397	1397	1678	1	1	2529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz2BbJewMbGsCBczXo8oDfa4nn1xY3ykgyUTsdTEdiqRJV1pf
2938	payment	1754	1754	1779	1	1	0	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrV6qBHRvaxV6d6xs2LCZz9HzRJeZPr6wxfeU7hgsSK6PtJ2p
2940	payment	1397	1397	1678	1	1	2531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2EZFgyz8enpre3aBrudDgW3SNGoCepqtD3SuKZvSgroqGNvw
2941	payment	1397	1397	1678	1	1	2532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKwRkBMf7HzS6AGSKnnLdjxbcPtFuKGV2QpwDa6jACX2RhTWQ
2942	payment	1397	1397	1678	1	1	2533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qjHBHWrb46KPQyTpyjdLXh2bundCH1CHqzESwX9VQYiAqmd8
2944	payment	1397	1397	1678	1	1	2535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9R2NrWNKghcTsfwugeEMTWpt1Szr32QSwPsgQAC52emmGd7J
2946	payment	1397	1397	1678	1	1	2537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ5vvuJQQGA4kAYQAVNmv3qmrbU8Aq6Lq2CHSrz6JSwFgVJN8
2950	payment	1397	1397	1678	1	1	2540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyss25ohVV8tznmZEYrdYj3TyNHEBy8aoL4e22Yw7F6eDea1zE
2951	payment	1397	1397	1678	1	1	2541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j8WitTRA4qg6gCf3LkGRineNt1PQrWdN9qc2uFEKoYoKRX6z
2953	payment	1397	1397	1678	1	1	2543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmWVEM67XtNNCmk96wws3sLM9sEGQeLzrkRTuGgBAwGiRhEii
2954	payment	1397	1397	1678	1	1	2544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSA5qb6dUnqnK9kdSe9vTMXdYc1Uo1HWvCHWstWc8cn9pr1Bo
2955	payment	1397	1397	1678	1	1	2545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHAfi1NPBVamxgRUwRHNCrMvtKQcTp32QY3cTM9P1qedEWfRu
2956	payment	1397	1397	1678	1	1	2546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcvsmgNdUnAMN1tyj2vDxAeCB3AkViq3EoHNwmMKKBVoQgvzZ
2957	payment	1754	1754	1779	1	1	1	200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ykdXhyxRAoazGAQTRxDsonbR9ym1jdbUPbGb9m2e9NRjR4so
2958	payment	1397	1397	1678	1	1	2547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j7huTWRm84RRE78qKdK9fNnLUDTJEfv58eBDMqGemFWUeRdx
2959	payment	1397	1397	1678	1	1	2548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE9ARbUN4wdBYsveG8kgmDuPY7KD85iLoFjtuf9mSSqdDNGc9
2960	payment	1693	1693	562	1	1	228	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYzDYX2BLMcywfiDhz52Z3qBPnzd89Z5XSgFutPz8CMsYTSvwyZ
2961	payment	1397	1397	1678	1	1	2549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNgt4GCwCBTkAyXhz8eR2viCSXoAyRf5wkApEExHB4egKMJM1
2962	payment	1754	1754	1779	1	1	2	123456789	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRjGRQzY4wZDQpdekTbDr4mUEyGkQWjNgNGEJ5vKdezwkqjpF
2963	payment	1397	1397	1678	1	1	2550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncvaXtaC5vf3icg9VMX3ugV9BDPxGsyBhmCxEVjPRkYNDAGGU
2964	payment	1397	1397	1678	1	1	2551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvMPnbbG1QBQspYR6GvCGERshEmmSLtZURkFk5vp3QXSbw1WH
2965	payment	1397	1397	1678	1	1	2552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FvkimhcHjvGwQ9kMouoa5K2H1VHUSXgRs7itX8jEEYJPPemo
2966	payment	1397	1397	1678	1	1	2553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNwRaykNZKGV4u4Y7nwdtQFP3wreivxAxVNAjrcWqAm192FwC
2967	payment	1397	1397	1678	1	1	2554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGd1sxcdzxLxzhY7bKkQDnuJQ8BNzmxGdnH1S8SpaxEdwgdejJ
2968	payment	1397	1397	1678	1	1	2555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezsLuorWbzpX9krr2aVyRKk5ASwvtpbcC1w6Z8k8QUdKty3fP
2969	payment	1397	1397	1678	1	1	2556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaYs1G65fLVoPBYYQf4JUG9ukTk4C826Hj6mEnyrQeNV7USRS
2970	payment	1397	1397	1678	1	1	2557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8X31NYQeTTVtGNjybkzA21ghqGrm9DK2RZ6ak5eRW58LDNVFj
2971	payment	1397	1397	1678	1	1	2558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7y7dRkM2zpRPyqbJnN1rsSFaqTzPTjrzHVTd5Tp9GdT4mEcSF
2972	payment	1397	1397	1678	1	1	2559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARVLxUoggj8uoB2gAMBACa8XjmGrjPLzreUHzy74xu59WW5XJ
2973	payment	1397	1397	1678	1	1	2560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBn4c1CzLEcnRHYaGhtssbTGNr5kA8xprVmyGzR2ngYbuypMa
2974	payment	1397	1397	1678	1	1	2561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDqVMAtsAPBkPrn5w7kDk1wMTjRiqPirLPLM7hkFxmv4o1fAd
2975	payment	1397	1397	1678	1	1	2562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1w5gRpcagozXaimhvd5e23UFFWbYbhUcTe95E7iWg9TH6PT9A
2976	payment	1397	1397	1678	1	1	2563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMaxyLoEQzP1mrEixNeMYtQwMY4FfMjMg4xJY7WkekqnCosHL
2977	payment	1397	1397	1678	1	1	2564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqRdyY3jfaJCYS8hbdR3b6icEpEfyANfGhhrJemkoGkpsKk7N
2978	payment	1397	1397	1678	1	1	2565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5XGX7WLFPHJucRUuYPjkDx9DY8774uoEJQuoq7qcKLrfA3Bk
2979	payment	1397	1397	1678	1	1	2566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8dNU5iaY3nqZzrVkaHdUo5JhbLURXjE9M8GZbWkNXbuNhaBb
3000	payment	1397	1397	1678	1	1	2586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVTM9o1VmchWLFAkKRSVgY8MGh1jyikomdbYiWCgUKM5jCCTz
3013	payment	1397	1397	1678	1	1	2599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjL4nMnkAhWaxEw5k4shjvZ5ADtMct2DAMU1x9fCZLzwVGF9V
3014	payment	1397	1397	1678	1	1	2600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqE1gJp8ZkZNJjP2H2xnV5gV8qRYAypVkVcjyLPpPQ5E4F1k3z
3022	payment	1397	1397	1678	1	1	2608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvGzmJNZzRaeXjZMQ7AJbG3vUj8jfV1HmLASfy84WpBBpyRs9
3023	payment	1397	1397	1678	1	1	2609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rpU2uf8i2BUpoQn6TLBDPj5Czn1Pb2HkzynVfP9A8cYCnneD
3026	payment	1397	1397	1678	1	1	2612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiTxn1QHgBB63SaAys6abz55D3t92npNmKMp15orfdy2agXYs
3027	payment	1397	1397	1678	1	1	2613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSf5MLkCrCwfH5gbpUP73K6EybUvCsteY8nt1oQ9soaWHysnk
3034	payment	1397	1397	1678	1	1	2620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMCxA6kX6wumdf33hDioVpgnp1xhsaRRGLQZXHX7WwREPiMJ3
3038	payment	1397	1397	1678	1	1	2624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fWHgDbtshaKbtA2aARk7YAqyyRLBiRpnnWsKkHcst2LWU6gU
3039	payment	1397	1397	1678	1	1	2625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJQn4og91qeK29xsAaKPMcf1KFrsrKowohbwtQNz2FiBVU6Ny
3042	payment	1397	1397	1678	1	1	2628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhTk7buYu9VqvtNEzKbqEL64ard9YuAEmRLcyNqnZNhbSXfbF
3046	delegation	562	562	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoABGJdRpyt36UDuj8Bx6EdhYVDeXEBKHy6tauEn2G7yhUeen
3047	payment	1397	1397	1678	1	1	2632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjd63or9ejscWGb9wCyLmwLpbcw8SBrERUgtqNSSaNNejKqXRw
3053	payment	1397	1397	1678	1	1	2636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBncmikf61Tv53KaUhoE5rh9ixqGgaN2FYctsJcebDjYpcZ755
3056	delegation	871	871	1765	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPsXaHdvP4E8aG1sG5kq17rqvPE4YPfVciYsYgrPQYkrvoDKo
3057	payment	1397	1397	1678	1	1	2638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61rod7NRfNndQzgJ6zytBdJVjTHAu2NXmBDjmJJcxmqroizze
3058	payment	1397	1397	1678	1	1	2639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEaxdMEgpc5PTjBfj18dPiNzgMYUHtRLHi52iXSmBtKes92pY
3059	payment	1397	1397	1678	1	1	2640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXc4qTGcwX4ZdAvnWeuJ4hkZG9dDWU8yMDEZx4t7egphXcqDte
3064	payment	1397	1397	1678	1	1	2645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV17EfJVxJC5cX3C4VdzBzsAoTjECNomFo1L5RPfKjTx6db7sT
3068	payment	1397	1397	1678	1	1	2649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraMbfThp3Mn15CAWXT4tUt2PiHQ4QFvagLjWQ1j7Y4aNetsbr
3072	payment	1397	1397	1678	1	1	2653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrQEEmivDuKJzoXf5CgCvtanhxYQwXTQWUbPsoGpfqrMR3cK1
3075	payment	1397	1397	1678	1	1	2656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXHqVKQ1ieR7UaWhT2gMX2B9r4f9GuoEPWXWcFVJ5cbNYYiAP
3076	payment	1397	1397	1678	1	1	2657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfYgGWtDNsMX8i6W7RGufgmgoh66ybZXSk77sJVeKxMHs8UaF
3077	payment	1397	1397	1678	1	1	2658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8AdJ5UFgmwzA18ZLQxU3zDtKSzPqhFsdkEhLCT6oLCcJWqGj
3078	payment	1397	1397	1678	1	1	2659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbcFh66GCzjK9tCejsaBNLMNq62RVVPfZcXtSqJWitW6E4GFq
3079	payment	1397	1397	1678	1	1	2660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcEyx6x6Am3L7YtUwEG4kPnfZhQje19MMRe96UmegYBYSbmcx
3080	payment	1397	1397	1678	1	1	2661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboGpafCNjB2J4LmCxuVYMA6tMhjHhj7sirucJFzJ73gXajfuk
3091	payment	1397	1397	1678	1	1	2672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpwu5BHXJMAAvPLjzKZp2gpx52XJNfDBd4yPfCXkdt5zD1ZPy
3095	payment	1397	1397	1678	1	1	2676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPALKRSyf8BE2DwDYe6w9Vt6ktpZq8hGJjjGb9UhNBFvdo2Sg
3102	payment	1397	1397	1678	1	1	2683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLANc8R7ZzLkL4X1MbpSryY9t8hJ9CQfhDaME7W4B5xDFqrKp
3103	payment	1397	1397	1678	1	1	2684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbkGFpivJ44To3x9WM8f7T5bVprUFANoUmGjeYbtyn5devpHE
3104	payment	1397	1397	1678	1	1	2685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEb7Mmrf4AYuHAPdisaxHwoiK2N8QEpNDTzW35FCU7qF8qnfN
3107	payment	1397	1397	1678	1	1	2688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDdHtu4joQMyEB2Qo2g7naJ8YHWzBWvaUH3xVbVCK5nXyXnwX
3108	payment	1397	1397	1678	1	1	2689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwsUZvjcUhrKN22YK8EvjLpXGBwJkHDQ8Cbp8GZRfVVi5FvrX
3111	payment	1397	1397	1678	1	1	2692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofjkDWTFRFcBDGN46T8wJ74QZDrAbpMj5eJeThsKL7ZtxKBZS
3112	payment	1397	1397	1678	1	1	2693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJ1bXM6S2pNrBJjduNjXrzJhCeowqXDTm6Ky9aiB1mf746h66
3114	payment	1397	1397	1678	1	1	2695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgessmdMM4d8TW3wLqLd99hVBijvAk1znfnLgGPx9x2pS8Hhva
2980	payment	1397	1397	1678	1	1	2567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeMpjhrKMqDTYinRUEmEJxikyM1zB5hobe7SEWE13KNKmbPu4
2982	payment	1397	1397	1678	1	1	2569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Th8dnL33bxT5T94pomxAQrsH6v8bbQwGWHyg3T1itX2Ju8Wa
2983	payment	1397	1397	1678	1	1	2570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme4emRsVfpEyiYiY6bNMyUZko5sDBM3Yd619jynG688KiZgoJ
2984	payment	1397	1397	1678	1	1	2571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZordEPncqn7FeEJrSHgtjWoP87B4fa8xKmfsHEmza11r2bUHxo
2988	payment	1397	1397	1678	1	1	2574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGXpKxRrdE8wDHdQRuHCgoPhBsYKacW3UXeAy34hb458ngQ7N
2989	payment	1397	1397	1678	1	1	2575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqPgvdonztjgTVJM6hD42u3EtsFfR4j4HzqDb9KvjLG3bbp3o
2991	payment	1397	1397	1678	1	1	2577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLAHfh2tvyQyJ4TNaXrRQ5fq3wBMwU6mfbbcdhCfFq8LBeWvu
2992	payment	1397	1397	1678	1	1	2578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzv7gxiViSLAYLxcCRFJnmcw6rsyX4RYxnrBDB8yZgDg9oDNv4
2993	payment	1397	1397	1678	1	1	2579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6hhMhLiXuAtDXio9vjE9XKHVEmZKG1BE96jYstrajQc35mpS
2996	payment	1397	1397	1678	1	1	2582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFDJNgAmJAvCtohHBTZDfmQ1xVqVvrbYVUVhHJX4iebXjuHcp
2997	payment	1397	1397	1678	1	1	2583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGd1E7i72qpHYJpg3hzbVKynYo4h9eXNngGbJXY7yGeA9tayM
3001	payment	1397	1397	1678	1	1	2587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCZmGuxVCP3v4DKLQk639WJtryAQHgvBRKmTfJXrDFk3Yq3Dc
3003	payment	1397	1397	1678	1	1	2589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesxXRwQFwFChCoKKomuSJ8h5exkhSBhbRs9Yu7SfKKaWs2Ph9
3004	payment	1397	1397	1678	1	1	2590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbWu2ft6p8X8JQp7ZoxVZ4irDersykaeZZ8RGPWRwGQEU2MJU
3007	payment	1397	1397	1678	1	1	2593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LCiP4qMuHD62EPo9bVuekAjZLCq1oJb4KSzSis8c5jfjzcQm
3008	payment	1397	1397	1678	1	1	2594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkenRXe3kPYemPNffy8cdeYfCGbLz7hehxGmnujtKe9ghiHwF
3024	payment	1397	1397	1678	1	1	2610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjKaA8Ah4QFwcSaiDne8thfStShKn8cR4ujcuTBP4hRQ9Rduh
3028	payment	1397	1397	1678	1	1	2614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFdPjGqApd29AmtKW6Bhh3TrxoXwSpNsFymMAxLSP7HsjEHAP
3029	payment	1397	1397	1678	1	1	2615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CW49sccKcuTiVj9yXt62Ksr46BGwasX5XAuDWHNVY3Krbb7z
3037	payment	1397	1397	1678	1	1	2623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThR8Wi1Z4AMadWTDJp9LXDiwkgity5qk6A6e9pfRtXUAJ6cZb
3041	payment	1397	1397	1678	1	1	2627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3Prva2CfQHAmjBVJAASuL6TKibEK5TiJjjt33fKkHAaHr1UC
3050	payment	1765	1765	871	1	1	0	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZASqxxnUZ6p2x4rw1V1L8CT9cruzzUuFEMHcvQ6Z4RtdRxYt
3051	payment	1397	1397	1678	1	1	2634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpp7gX31gqKQht1zKq2ioopoBcp1pea5GTrz1yxzzX11akznAP
3060	payment	1397	1397	1678	1	1	2641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32SQwgkfZhLQPLePBjtkUUbVgFtKfKxcThMQ1UqrcuFSHYFKW
3061	payment	1397	1397	1678	1	1	2642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bVzZmyj5hD1ffAXRcgbbZE6kUqnGbV31WevZQL5EQK7VWoUd
3065	payment	1397	1397	1678	1	1	2646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMUATziyMTTEn69tqJKiAi7Yf9eKWhuj5pRKYz7C8PyrFAJEd
3066	payment	1397	1397	1678	1	1	2647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E3DDGzTiKAvrxyq5xCV7Rg5uiJpbWYnWgJxkHSGCRMA6PwN7
3069	payment	1397	1397	1678	1	1	2650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAkbWZQ3zz4hQMDKkabgdWoRkZaVXi8GQoTKYa8An1F6a1wz4
3082	payment	1397	1397	1678	1	1	2663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJLDfGbPBRJReFFpP3ACajEPKkdfEY8ZoKE3diBHYXtgLFc15
3084	payment	1397	1397	1678	1	1	2665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNtdmcBoktszYJjJbnwqqAPwysdvcawfxJhMJHXU9dhND8hzj
3085	payment	1397	1397	1678	1	1	2666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDynBkZFNHSVzTF1Aihdd7vB9zPpAapgEzMADipMpQYARbYTB1
3086	payment	1397	1397	1678	1	1	2667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZk815pt63hwvdfgjeZHfS52h2HvD9UyrKQXJ6ynbkUVkvSkXG
3094	payment	1397	1397	1678	1	1	2675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPA3so4h2BdJDvKdVcBmhauwH6eij2dDRCk2p7B6Nt4KGocjnR
3098	payment	1397	1397	1678	1	1	2679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLQXWMffoQDnziibGiocSR6JDhuWhPiVx9p1tErWE2ZV19T9g
3101	payment	1397	1397	1678	1	1	2682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RpbeAkTAAagtYSBKvmHgwTeyWMR3EsVqv7A8kHDPbrsg4GJM
3105	payment	1397	1397	1678	1	1	2686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBtSSKEkMgSxZqk6em3Z1G1jtGgkTwA8sxsNNgvhehypZo3f7
3106	payment	1397	1397	1678	1	1	2687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG912pScqJALm5pCAbs4coaUJfiawJyRdPiR8aSwpSQYYi4991
3110	payment	1397	1397	1678	1	1	2691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEzJQDvrUc4kDkJN68Pb57yUXh4eak54Ugrwr67DBhoHju6YN
2981	payment	1397	1397	1678	1	1	2568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTsEVKtZbHRc3oM53JqoTxxSGEeAd8TxwBrJbSi7VKSS4tYV3y
2986	payment	1397	1397	1678	1	1	2573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmkGpJLsydt4PbNiHNitPEns1d1whv3BohqVfDegkPYRe3tkC
2987	payment	1266	1266	1754	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5PYMZdGLdUYBF9PE3XWHSfrX9WJDW42nEH1zz7KsuDCg6JQf
2990	payment	1397	1397	1678	1	1	2576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfwD88SskfNCLE6tiZGkQyU61F8bNnZP4fGNMXoPJ3i2VuZsZ
2994	payment	1397	1397	1678	1	1	2580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5aQi5WhevfNU5VHm31LLJnrrCMZS8eAdqadDroU4yXCsuzva
2995	payment	1397	1397	1678	1	1	2581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyaccUEYrQUbv8wxTkMjEnrBHXQ6HKVqa842GqJBYwNx9rKtA
3009	payment	1397	1397	1678	1	1	2595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdtaBAcRBQER37actoMsh4f5zMzZDDERmRBPQyMSD3zPzPE6M
3012	payment	1397	1397	1678	1	1	2598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dGW6YpjsxiURpZrwc5i4W4hCVJiLCPdBnF36833T9crxyZGP
3016	payment	1397	1397	1678	1	1	2602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ39x6z1qocfDWci2bxTQoGS6iZbB7RxbFrYKWvsCSbLqpXK2
3017	payment	1397	1397	1678	1	1	2603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtACuLaBw6AbDfLZwhMRRaR1YC74kvBsmiNu8PAm8V3yvgoaaw
3018	payment	1397	1397	1678	1	1	2604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgLq5SjG6hGHPx5wBVJhCYWCXazjf1KyLZg8Dff6y8KkAEc2t
3019	payment	1397	1397	1678	1	1	2605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdHEhqUrYBYGAHDtmfN5DhyZt7hJLuzahB1g2XqWMyaR21FM1
3020	payment	1397	1397	1678	1	1	2606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCR2fMQJLK39JL6f5CooPwaxoQfkgS4mErf8zhoS7nPh5RDc5
3021	payment	1397	1397	1678	1	1	2607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUTuMnL49XckQYtcAjmKThKKT6wwFr3kf8FRAgxPFHrxNMBkS
3025	payment	1397	1397	1678	1	1	2611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6siRMb1JDHn8zpAn7e3kwHmsCd5zR2FntBAoDfTJrAjqbh9u2
3031	payment	1397	1397	1678	1	1	2617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWghJBhtwgRBcYph15Nm5dCxAavPXHRBpV4bEjJCmHvuVWAqsg
3032	payment	1397	1397	1678	1	1	2618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwzpPSt4HVsojCWcQM2eN5cXaPu8e4Uco3FPY8PVkg1arwgCm
3033	payment	1397	1397	1678	1	1	2619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEvmQJzEPWTXAsNmDrogTPWevFTjR3UQQcZnrr1NxXZN5gKwv
3036	payment	1397	1397	1678	1	1	2622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FovBBvJJLzFKCV3qLCxsJm1nMfttsb7cwbbXZE951ERBqxdA
3040	payment	1397	1397	1678	1	1	2626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaC4uH913tF2y8cmLe38jvawkXLg42VpK4bENAK34FWD2BJcmS
3044	payment	1397	1397	1678	1	1	2630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZasNJAVbN9S2aNCMTJVMacsQqj71CFVDKAvy57ysg33tW8p4P
3045	payment	1397	1397	1678	1	1	2631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkf2rVYb4UvVA4vcapC3iJXZaSW5QxtevzQDKCekRwJFicoTT
3052	payment	1397	1397	1678	1	1	2635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUfU1hNrGRSKpu52wHh6sQYDAYLqtY1YMNhsPhJgcVRpG3Yqn
3073	payment	1397	1397	1678	1	1	2654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmqwXDoYenWaoqSqv3yS5pH2AG5VCo58NUqSo3868M9r7NY4v
3074	payment	1397	1397	1678	1	1	2655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9F8EoDawwRa7bfiw15qtaazWDZwTBRRG51PiWAXnzSUGd2BbE
3081	payment	1397	1397	1678	1	1	2662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUAWyVwpWw3RrZMzLtvkJM44o7ERnX8psJimeqozz4JoJQ4wQ
3088	payment	1397	1397	1678	1	1	2669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgoiaAKEwriBDhtfPtBn4nZET89R9vuDACuH6dqg6D1bXKo6t
3089	payment	1397	1397	1678	1	1	2670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJeDRjWDDbpAczE4S4sjh2vCcHKeeYrwJD9PbAMYL357x3Wra
3090	payment	1397	1397	1678	1	1	2671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYTsDztiCNMs8Hfsq911dEJynHpQ2yAsbpYC9TZgheBVorpNm
3093	payment	1397	1397	1678	1	1	2674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQcamYWwbPw565rQEAqkkjBojpSsNEbAcyyAwytimtCFyXWpy
3097	payment	1397	1397	1678	1	1	2678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1WCjb46RTG5zfyDb4TCrxCpbJdkCRnVHHfhR4UJ5h9s5sk38
3109	payment	1397	1397	1678	1	1	2690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEw7ZEn9m9ai41NUWuf1pQYqjuiaHq3zy2fxrR9XJNfEUts7b
3113	payment	1397	1397	1678	1	1	2694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53xzk3fTnRxRAy13rkJn6rzcppkYhsLzmySDNngLiZKi6RRzt
3119	payment	1397	1397	1678	1	1	2700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJc2iPhTACzLDjsqQj1n6oNRpQhuVb5UKqjqywojCC8WzNJ7A
3126	payment	1397	1397	1678	1	1	2707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXRLTNuMTebP2LFAy6uTUEn43tkza6emMEt7YkG2bwUD7eyvB
3127	payment	1397	1397	1678	1	1	2708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2anHWahBAce5yEAAWrur4tgSBUyEmxVr4mE36SfriFwFeSFZ
3131	payment	1397	1397	1678	1	1	2712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDBacNnm6cXfyuVQcsmi6R69zSnMRcFoU4YDWUtxbcWrTgsyy
3132	payment	1397	1397	1678	1	1	2713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaReeKczkHd7SRqaGkdEvfQr6psih4xNcTRmmFkRiW8MrKktaM
2985	payment	1397	1397	1678	1	1	2572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxaBUyU8nDZyd1Lyuws3y6Qru3gBazuyzt6x3NpAPcfufowqs
2998	payment	1397	1397	1678	1	1	2584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2AzvMKZJQ2RHTzxFvmM1x81JRoCrwSHade7BAVGocSA1iq35q
2999	payment	1397	1397	1678	1	1	2585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiC6dYbgzscf7NzqsMHWink4EmCqMWf7AM1SkzCQkNsB9btwn
3002	payment	1397	1397	1678	1	1	2588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJ1tHKWchBL7giWNTRF2ZicdxANkfZV4wjfYpGds9aLjZmxut
3005	payment	1397	1397	1678	1	1	2591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe94H8zfTXP15ecoDyLkmJ6NUx9BKAyjvNERT8vxgWXUk63qEw
3006	payment	1397	1397	1678	1	1	2592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZS8WGZskBAmV9e3g9wDPwCVS1VeofTKUVWnUSkgn1i7jS28Ud
3010	payment	1397	1397	1678	1	1	2596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HpbqCGtQAcBxM7qxUHrwiMtLMNeGepqMjJ81BSaEkyfPGhiF
3011	payment	1397	1397	1678	1	1	2597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ625AhYdn7evbnLGkdBW4WxHQAuWr7JFomNwwi74Ckf8T9MVfk
3015	payment	1397	1397	1678	1	1	2601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8VMsX8VqMpTGPqXuXpnk59impoairJf44pQ5QLXYCXJX3eW6
3030	payment	1397	1397	1678	1	1	2616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwt7WG1PFmR27VVPZYj3yBhdnz57rLHv2v4fKrJ7YQ9iHPmwa
3035	payment	1397	1397	1678	1	1	2621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ2XEhV8jaT36vWPDMJWAK4pBSZfuTx8bZsQLR9RSRsyDwh1y
3043	payment	1397	1397	1678	1	1	2629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDC2xbf9rVHQtFg1S66V1fkNC3hVMDbuL72XLTQCymWBmS9Yp
3048	delegation	1780	1780	255	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcKs1xuohBS2tukrv9aLYwC6CVL2CbVDKyHC4AwzepAVCNU6W
3049	payment	1397	1397	1678	1	1	2633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuHQjaiWJSo4cd1wpqTVy3kxgPez9EeU6kaSTfrF3YkJZ2uma
3054	payment	1590	1590	1781	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8QBewCRwWcQeGa3PZvNnDX3snsLPQvS35THKsm5Jfhcxo3gU
3055	payment	1397	1397	1678	1	1	2637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c1vcXRfhYxePM6drxfuQyyYGGYpQpTAQeYz9LraypzFZPGxd
3062	payment	1397	1397	1678	1	1	2643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zAKdFpErvY3ZqSVgPCp9ZGEjrBQ1XpgR1Gzi3qTSWEauFhWi
3063	payment	1397	1397	1678	1	1	2644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDGxq2qxkRw65gYWSp9TSu2YrnLQa4TPBjsGgKNrVdgtPBC2J
3067	payment	1397	1397	1678	1	1	2648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFnTnTQfaEhcJaNtWsUchMNjZW3BiS1sJsLkN3Uvn5kgsXN5d
3070	payment	1397	1397	1678	1	1	2651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9BqyuTT5JMp1oDb48gAJdHnavcRgfVFbaAUwLjwCCVvnFwKq
3071	payment	1397	1397	1678	1	1	2652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9PiUU4UBcEC2WLonJqrbn1Jan8CsRnXfaTrT7NnCtsnnv97C
3083	payment	1397	1397	1678	1	1	2664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe48cvh2h5LGxJPFuDjE6AFYPvsFitKPUknCa7jir6ZbHJZzUt
3087	payment	1397	1397	1678	1	1	2668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqdvDREGwYL2ExoYAk3GkXXf4Dbi6nChiiS6DVeZDB2tDP4fo
3092	payment	1397	1397	1678	1	1	2673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFsrBKEpKhpmRmWsyUkJvUyvwP1kTtJrJSWqZtqE5N3jjLhUu
3096	payment	1397	1397	1678	1	1	2677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qomVdoXqSmHaZUnN7NiPFd7fsdy4LoiiKU4sL8wnPyyZubrE
3099	payment	1397	1397	1678	1	1	2680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqg1CJKvmDqnJjVNA2pmZH4rci7UoskMpBv6mnxmaobMubVgw
3100	payment	1397	1397	1678	1	1	2681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15JXRboeaS7XDap42yrZ5NkBSK52FXTESsDiT5KxH7WR9yVwC
3116	payment	1397	1397	1678	1	1	2697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiTL7jMhKJc6FayTL7jX7Nr2fZRJ1FYnwPRZUZHGCNroxJeoL
3125	payment	1397	1397	1678	1	1	2706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7jR4BkvLMvJNc8R3id1EZDfvkeR8v2e4PEG4GAxcYHNyTdib
3130	payment	1397	1397	1678	1	1	2711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8JHtTWkZjChZH6uXcdFWWZjFTYgY4vwrd2Y6uv6zx5mYa5VT
3136	payment	1397	1397	1678	1	1	2717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1AsTVR3SZ54LZh8Y9wkGoJGc6QAMVUBDrjcGdwCVxp8oHvSe
3137	payment	1397	1397	1678	1	1	2718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mm2a82aDSWvnyoSoESawfxTf41zQLE5qA8iZjFUnCea52wBz
3154	payment	1397	1397	1678	1	1	2730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TwnGdSX6e2NVX1mfUy7N6ZPo5wkWeDetyH7SuQ23661TU3ix
3158	payment	1397	1397	1678	1	1	2734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcPFJxyk4tcQYD4c9G8xFKtnvuqzhu1Ese1feUC6naVAEHx49
3168	payment	1397	1397	1678	1	1	2744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8cvMngEdCCCvTxw63kELMxrwjgngHfV882trR3dF6cJx5Zqy
3169	payment	1397	1397	1678	1	1	2745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtocKqqWtZyQbvqw8cZBWeRjkAHC3igrF2zocrn7SLXxXBa6k
3177	payment	1397	1397	1678	1	1	2753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uF638M2RuVukqDZm1n9z5oUgokse7j9ofKn9xdj4Kd67QvCF
3181	payment	1397	1397	1678	1	1	2757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GxMjqwE6rTGe96Z6W1cmBg5q6VwT8CeVo4LgtfvSPWdHxjZr
3115	payment	1397	1397	1678	1	1	2696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPw4rCHQHvUj3sVRB6omcoDV9RbsbPhkqVBzTLXgxdU2vLEKRA
3121	payment	1397	1397	1678	1	1	2702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEBkDVLJfc3b2yJux26AM28yDC5CFhj56MPZPevVuCNcGK6SD
3122	payment	1397	1397	1678	1	1	2703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF6SoK6ooXGYF5PinxuVmSPNEsMTHKndTHfPJ4caFEDKWUXed
3128	payment	1397	1397	1678	1	1	2709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2y5MNVnFPrVSkijTwU26rz6c8jYruWiNZhp9US99HdKj2cx3
3129	payment	1397	1397	1678	1	1	2710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfULqTfgwTvNr2nnSgV7drQ6jyTdnoNVbia1nKQdZU2BH2y5i
3133	payment	1397	1397	1678	1	1	2714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRP9guygjubek8XtRvy1arYzFTNgKpYMbkMEeis5irrawfjGsf
3141	payment	1397	1397	1678	1	1	2722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhDJ6Ykt8HNYPDEr97sZWVLUsLj8eGncxz7q1fyskuqmZNiJ6
3142	payment	1397	1397	1678	1	1	2723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpViFRaCsydEYtdqqMRPeTDcZidmCQe4vrMy9ZrqmjvhbBNzXm
3143	payment	1722	1722	1749	1	1	8	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTh8oNWXjpunK6FdBEaudveQnh6Sb5BETWLPPdJsb1rZouBRhX
3150	payment	1397	1397	1678	1	1	2726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzxBKdH6Vqhysf3xK3RZp5FUw7GxSEE2TgfH6qPhxGh3k8ooe
3155	payment	1397	1397	1678	1	1	2731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx8Qk6mDifihTt26GbkRSS3fdWeBrWgP46qJRXvNpNiCfzgTo
3159	payment	1397	1397	1678	1	1	2735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TzaW6vrk3SqSNE9vkG6RxSxxqneZ2GzJ57tyayxGfyrCqVgC
3162	payment	1397	1397	1678	1	1	2738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxK85dwY9joR4XVcJwbTxfNknHkdW5vsiVDZyDd6ShfxK2Ntt
3163	payment	1397	1397	1678	1	1	2739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83s8k8WeSNE7qCDo3mWDfaaHhXCNrTfokjEmDivDgkr7uPdFq
3166	payment	1397	1397	1678	1	1	2742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzxirJqHqnd8mABR1eKAbqCB893apYRSoxz8NNPiGbdfcJWjv
3170	payment	1397	1397	1678	1	1	2746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYV56mec79s6ojSx1fMRzAzq4NWWRuHv8kLaoKvZHP8S7r9iVe
3172	payment	1397	1397	1678	1	1	2748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhsnLfxQDHNn8199oty4Q4pW8kypr6ysgjGEZtCe8b6x52bvp
3173	payment	1397	1397	1678	1	1	2749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkmPxYDJEBwmTNHkk8oYHY13yMyPzoQDorwxo32JDMVj4Ui2d
3174	payment	1397	1397	1678	1	1	2750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFmokgfhW9LUsRoVwG7VKrqRqKJxGw7WidgfRS7TA36CgynVP
3178	payment	1397	1397	1678	1	1	2754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSo6xg45vM5Co3KqvncNPpxXhQwxgiv4L3wmu6h5SEPdC2tcP
3179	payment	1397	1397	1678	1	1	2755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYQqjh3Jvjjo13LwFwXvkExnGjwb8ufCdo4UXmsLmZ92bMta9
3180	payment	1397	1397	1678	1	1	2756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnY4F3BnU3xRGGRVr9RHKY8TQiJA5SafoiEnxchWUZgMgCmef
3182	payment	1397	1397	1678	1	1	2758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rs1rZPb2VCBxXYBCLKVyVCghQYExrsFhHouuFXuH58kj6oZv
3186	payment	1397	1397	1678	1	1	2762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZSZfGfbjiDfob26dMLja5gbHWyPpKZ7Za9btUjfwBabqE2fP
3199	payment	1397	1397	1678	1	1	2774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8341SA1GFQSPvSUNjU7vhETf6ipiYHxuxNjEyLfbKb1FpKbX
3202	payment	1397	1397	1678	1	1	2777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7p8g2ywWvNpakdx3ZrwPgZCCtZig4HNxjwE1X11iFaUa6YWG
3219	payment	1397	1397	1678	1	1	2794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhhXN2A4cP2pGPYduRjaHYoiNxqymmrnrSNF2wMq4dUuBQxZh
3220	payment	1397	1397	1678	1	1	2795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc7RsPFiZPrfhZpcFSuTNNf78AaWipd8BVNf75DT3iHJrsq1L
3221	payment	1397	1397	1678	1	1	2796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1ujmwrkMc87quxqnjvhcjH4SboZLdcuZT1BArH8PeCgeJsAF
3229	payment	1397	1397	1678	1	1	2803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7JdbP5LqhyDnC6tptpRgTnjz44ScEyo7Rc2Q4M1SGmGBH8EP
3230	payment	1397	1397	1678	1	1	2804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZda9p2yCJdb2Kj56EHYXmH8rxm21H3wxop87iuaCj3Rhybx4zh
3231	payment	1397	1397	1678	1	1	2805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEz6nVY847Nf1pmpHMjhRmsNZwWiFViFtctFQeysCrRMqeC2K
3232	payment	1397	1397	1678	1	1	2806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBuQ5NvaMyBmyYg6jkrKGwnMjJudXTgvQ7smyLqRxaY4RsK3Z
3242	payment	1397	1397	1678	1	1	2816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtd8Brr1CvZnnqH1C8JETChkAdokyRkhFrbeC6wRhyyMtx2vi
3243	payment	1397	1397	1678	1	1	2817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4SmsTRYrNXiyzLYRVrRG7Fk9AmadhcHqPuNL9K4pBbjouCob
3245	payment	1397	1397	1678	1	1	2819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEZzsj3MEc6kUsYxDTL18CaqeKDUdjEuYgCuoGY5nn4xCai3e
3257	payment	1397	1397	1678	1	1	2829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdqMpHwnCVx6cNit3YTcTpx9QXNUeBavvmxnw314nGLCmGMtg
3260	payment	1397	1397	1678	1	1	2832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9duhTcM3ykqEpV7cgmRpH5oknmzmXfFHS6NVxsShd6qFPeGj
3117	payment	1397	1397	1678	1	1	2698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21SfF4wYG7C5FMcT5cDhgujYY2dUZeCELvgoaaD4WZXScpLzx
3118	payment	1397	1397	1678	1	1	2699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNE5YcHETYDsfMB81GEZgzqVGMEXupjZtF7oiyDWGwhMYKxUD
3120	payment	1397	1397	1678	1	1	2701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyBoYSSC4K5mr3azagdLwqL1r8r7LYzwPKk4YupGQtUKmXzmZ
3123	payment	1397	1397	1678	1	1	2704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wKBsYnnYyEc8nYep2SYZ4yujueM2ZjsSZxtosNA57WqpngFp
3124	payment	1397	1397	1678	1	1	2705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TZZxfGmVLU276mr1aKYRUEL2bzmYFCKF7np1N1R81HZuwVcH
3134	payment	1397	1397	1678	1	1	2715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAXvbE4mxmmgph1XYTYTcxsFVfDt74FGBYKtEocKnrr1ypz7q
3135	payment	1397	1397	1678	1	1	2716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4w28mhTDTFRBmVyEAxcxtJKWV3UGmqs7BcsiVDi86MuKtYeQB
3138	payment	1397	1397	1678	1	1	2719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHMmBV9vSwsjretoU2yjiUsfHHVEvcYmJGFXU9rryKWDsNh4p
3139	payment	1397	1397	1678	1	1	2720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLV6cWHq4avXy58rDjfA5h15xAnLTdCWbzEUXgVC5DAvJrNAR
3140	payment	1397	1397	1678	1	1	2721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGZHChmxSNkkbg5C6y5LdSkN1LZ8qXx9qscgxchbHMco7DFya
3144	payment	1397	1397	1678	1	1	2724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9WtcJi2QMjQrwcTqP48XZzkT8kK6xSqrgAtRzStKcqm2JzUa
3145	delegation	1749	1749	1652	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FVPKoMyZZ6rq8Hqcv5gcd475Yedhr1vhoy42SykeAu4hLpGq
3146	delegation	1759	1759	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2aBdrtdJcgxtHoJqgPXW3X1jLiYRpQ3PeUa673KHh5Gs1LA6
3147	delegation	1764	1764	1652	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLEmYdrQwQsXZN9fnhJYALcoUgjFbceEcCVjk73Qkba18q1a8
3148	delegation	1722	1722	1652	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDZaPG5pWdFxiv48ueqbvq9MAeDrhbw1aMQ7NzQcMzUgKVwJr
3151	payment	1397	1397	1678	1	1	2727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPED1S4E8bNBEWdF5b5zHsyE3LjQPGVx6J3dBzRxVHYPtFCWC
3152	payment	1397	1397	1678	1	1	2728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuo24KqagoySnjANXBU5fV7y3uUdggPZhQGQ9nF6H7ZtU5vtuD
3153	payment	1397	1397	1678	1	1	2729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajkV6c7eKp9Z16u1PMaCLoSzcT6DUdktnDECu7wwMFHJ1EnbM
3157	payment	1397	1397	1678	1	1	2733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5gNJVFpgR8M84nBFNM3WB8pmtjt8toU5Z3h1kWKQVUzNhkKz
3160	payment	1397	1397	1678	1	1	2736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLXaKpQFXiJ28PWZr2oPgSZv4J7fCFW6BsfHS1Hzc6St6v2ss
3164	payment	1397	1397	1678	1	1	2740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsM5ish9PGoWb4xa88Q252scKdiCtAw8wk8a5sJ8A7YiccNrpA
3165	payment	1397	1397	1678	1	1	2741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdE2kBTPyj1z8GY3YzW2rEnhczxwSv1mavc9aedYZw7vFi9Su
3175	payment	1397	1397	1678	1	1	2751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7KLwZBtJJezXvjQNgwGaEcCE7Tovgsbu6rVeNdvuCp7GVHp4
3176	payment	1397	1397	1678	1	1	2752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsM9DEQnZa9TzyAirijU8tLVG3R4J83rURScWjkGdkf38HXVV
3187	payment	1397	1397	1678	1	1	2763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxthZSenZAYPUhV7GEUcN2FZWmep6uPq4RVD8JPgCZVuxn4DzW
3196	delegation	1738	1738	175	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iycnoLwzguGp2qZECgN5FB5KSSDumaZ8RhEWhC62pGGSumHe
3197	payment	1397	1397	1678	1	1	2772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUPyF9yjq825KkSJGPNXiBRaATh9P4UCMcyBqeR465t8FTM9v
3200	payment	1397	1397	1678	1	1	2775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipFieEB1YWLAa7MyKXkfUnwKC7F7ziBqDQ5pnxmyco4iWZoRz
3205	payment	1397	1397	1678	1	1	2780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuDoE9FB9TB24LfLwdFfMUvSSn9GL3y366HAVssfhFK6b4yb3
3211	payment	1397	1397	1678	1	1	2786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJmWiyHMDNSin5U9XFmWeZmwJ2XXvy6pUC3se9FChfLnfpeQL
3212	payment	1397	1397	1678	1	1	2787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DqbE69fbuuTnJ7hzydmpph1JsyDbby8btiuPaRRyTz7JwmvS
3215	payment	1397	1397	1678	1	1	2790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CVBs1vnUoZ2PZCNzagGJn7pwrYfaHUvvKTFCBftwXEe99C5R
3216	payment	1397	1397	1678	1	1	2791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsVnEd8DycPq7VexSKTQLq2FpdTXUvfZJ452eTV2fDxLEBjFD
3217	payment	1397	1397	1678	1	1	2792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBgpvdEWyS8ed7dSDqL1tjw96z7B7tA3Qxqcqusi52nirqhKs
3222	payment	1397	1397	1678	1	1	2797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBf6HFuPFtX18QT2FUYzi6dmPcN3Fk3aKW8P35GUogtEFtWJF
3223	payment	1397	1397	1678	1	1	2798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtDYcsvFqASxpwEUAragyXZvYYRQjnXrTEDiYJDTqWcV9gccV
3233	payment	1397	1397	1678	1	1	2807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjAPQHEW2YxJLaAzBvVLbBJWzBUgBfUBMMVCXGuDMgRrraqh7
3240	payment	1397	1397	1678	1	1	2814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YNb2KWSsFjGMqTo4BB84dbcLRE7ADHUFnaoEpJM3gz4g9sjv
3149	payment	1397	1397	1678	1	1	2725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65dyca3wsktYYxVbbccX7qQox17om11ASBszn7d4AJzAbnscz
3156	payment	1397	1397	1678	1	1	2732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPy8sUnUCqhvb67Yc2oDLtgnRPFU7ay4aFwGz4srdfX15jPLA
3161	payment	1397	1397	1678	1	1	2737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuUh8K6ZdPUZSEnUqN6hV6oizfJCjR41u5ZbnewNTqeMNEN8L
3167	payment	1397	1397	1678	1	1	2743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33SBFSqyJHvnpCmPgRYnWFqiC6Nmb9GnZEnFsWYKUNGW1rseh
3171	payment	1397	1397	1678	1	1	2747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvX5SzZwQP1tek4vKhn4UXKMgqnSV6tcJYDZSEueAZYJLiQCax
3183	payment	1397	1397	1678	1	1	2759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FVcXvXcPj9vZAA6uAVtjVcTzhGQpx3sT4A2Ee9UV1GaMZEAu
3191	payment	1397	1397	1678	1	1	2767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmzjtK2UmDbSaGQgge3iKkanNau74YUb9Poc7fAmNzXkmCEE8
3194	payment	1397	1397	1678	1	1	2770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTqwcF3B1aGq8wQQuieEFSEo6pJhK33ZfDbzmMUYPbR623eXx
3195	payment	1397	1397	1678	1	1	2771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46hdBjsy1R8nfPzk8np6s9Ss4uxuVJYadSQnbGYL6YWBrAvS4
3201	payment	1397	1397	1678	1	1	2776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnM2vGeb7PLjwHmFxPVJaYnww7ETPH67UG1MfNgTddgQeMp1Q
3204	payment	1397	1397	1678	1	1	2779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevnk9epwdUDmEvu9hpdB8G1YmfHCnwA6JxMMnTb5sRXnKtzUn
3206	payment	1397	1397	1678	1	1	2781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfnmG3Wt32jBVgcf1k8WNwoJpCCv3XgyVukFhHqVuRXVGKTYWE
3213	payment	1397	1397	1678	1	1	2788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRd9NN5HNynDCFnVrdqGoMuxUU8jKEpbSbyhuTNH4crWe61g4
3224	payment	1397	1397	1678	1	1	2799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69Htn4KQ9i6nHF4z1KwiC7jfReGUUUj9RkJ8JHwrHA2wqZxm1
3225	payment	1397	1397	1678	1	1	2800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCo2gCGHETNc3Z5zJAnKUSbD8HAQjAzp3WwwQryCBSef1sqiS
3226	payment	1167	1167	1726	1	1	0	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhYATJATDRi5hC1EqtnM9Ymm8Pp2tbVpQeB3LhZcnMiZ4xRhs
3227	payment	1397	1397	1678	1	1	2801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmePtshqLUZfJ1AXuUhWnpYQsgLKtyoQymwZrtGacUamTS2KcH
3234	payment	1397	1397	1678	1	1	2808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozBCvkrfJaDtG4uMm6LBCEUbmuEvN72Q78sKh59tSVzJH35PR
3235	payment	1397	1397	1678	1	1	2809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2U3ysqAZUG87HrJZ3Z2CdA6uT8r7q4meKJDS7ZtJ32yTEe48
3238	payment	1397	1397	1678	1	1	2812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo25VRrJgXKZSwCVhoTj6fZntcSePzMJTLAqE4cEokvKXrcBvz
3239	payment	1397	1397	1678	1	1	2813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaxareFSuMrcuvKoreHxWReRf25BobKWB21M8C8g86fCensMF
3244	payment	1397	1397	1678	1	1	2818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7fmot1G536ANnJVdcW3jr1QCXp2tgXCaFmJNq3qoaCocv2xS
3246	payment	1397	1397	1678	1	1	2820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3Pn88Nfq5qy9FxrRiW28mz8BgaJcFqU9njoKezAZE5NLohF2
3248	payment	1726	1726	1758	1	1	0	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYcY1BMapjL8Hsy1Bw3uRdWAPAfDTjA8b8LDgqEpM2gxWWKVsuV
3249	payment	1397	1397	1678	1	1	2822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86GBiuMXKs7KF1tGgYwnoY3kQFeGuJbaV5JURwEuTBa1Z3tpe
3256	payment	1397	1397	1678	1	1	2828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eiJz5fXGhqWYWRRbruH5SU8QtXnF6LmXXUsKvD1v7hKwhKgB
3258	payment	1397	1397	1678	1	1	2830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T2A2iVcUz8QKXXUsZvjR2gyLACseVvgv3DGDjWT1r6A93DbY
3259	payment	1397	1397	1678	1	1	2831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxeo5xtKvjh6wP7CMR8UtHXFyqvuv1FuimaeqQRqJcrNAYhgF
3263	delegation	11	11	329	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aycyiASq3RBJyqAW8rGDV5uTTTghT9m62rv9D8sbbpu4zdSp
3264	payment	1397	1397	1678	1	1	2835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAjdB2LSRNV6XTERFDfsDdgotXQFeQ4F6vBAHvujwZL4cJpQy
3271	payment	1397	1397	1678	1	1	2840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wsm82o6ESXXecv87Tm7Sa4eP6ABcAoCVRc7bjyifuCjJyWCK
3274	payment	1397	1397	1678	1	1	2842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnJ4sFUm8UFu773D37mh5L11gpfmiBQeefCYsTQMmfpJWwhXq
3275	payment	1397	1397	1678	1	1	2843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDhByG3s7aH4o8dL1xyFCNZhgFgzrnXbDb8rzs61wsB9Ls9LE
3279	payment	1397	1397	1678	1	1	2847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaTk8kfdhV7hrvLybDo3bRatfzc3j2Yq8331TDWWtHrN5BLsy
3280	payment	1397	1397	1678	1	1	2848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32oocHXHMnG23TmVFzCXdMMr6navCHtRAqTfqN2pU1GWQi8UD
3288	payment	1397	1397	1678	1	1	2856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkdb7pCVfUAwEdr6SuYS4yUqCUAcoyeLctxcB9F2VJvqpbxUp
3184	payment	1397	1397	1678	1	1	2760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoipAdiLSy82sgeg8UqkPJjLAMXF9KsXQfQ362yptLp4hNZGaJ
3185	payment	1397	1397	1678	1	1	2761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbt1hLPPBM2YFehJkucSBqFnbVotrtt5XehVf37L2mQ9dRato
3188	payment	1397	1397	1678	1	1	2764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCwFbMNsNjUhiiH12nVGLTQtNYHjLLJBdhrNogtfMvwutHQqp
3189	payment	1397	1397	1678	1	1	2765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1HEaB33XRRA4GUUqFsQe49hEBDTMLGZEgeAdoj7oHi7TnqdN
3190	payment	1397	1397	1678	1	1	2766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXacnjn9FRuwFmPXDq7gWK87gijTCCphmpkfZfM72KdXFTqpzF
3192	payment	1397	1397	1678	1	1	2768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTj6yLQ81fccvK1An19B3HNtNxqH5Aqed13A9kcbsEhTxTBgj
3193	payment	1397	1397	1678	1	1	2769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohhhZSKjTU4DkRMVxYixrfXjzbpCcS5jTaUgWkapsJVEM5xkD
3198	payment	1397	1397	1678	1	1	2773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMZtZTUSAwjcAMnYEVKYPeGqAnsEPxoUGjtjVDx11VP1xVz8R
3203	payment	1397	1397	1678	1	1	2778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8CmkzRZvnS5t5TXJzroK97N2GASy4oYYeutfrYx6fkX4hv9D
3207	payment	1397	1397	1678	1	1	2782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkpbsk43t8t9yxwNTPwStTh7XMJtVCieFANuPKYGBCmdkHPmh
3208	payment	1397	1397	1678	1	1	2783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeSeYB1wdxNtL5gWt8XmxQcAqcQJ8DKx91sDf6WZpv1oUrBDZ
3209	payment	1397	1397	1678	1	1	2784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTzkLieqBFS6gC5RjuNBkeC3QytLceNBgywWE4vDAb4vYZwoY
3210	payment	1397	1397	1678	1	1	2785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucLQukUp4fsFizcMq4jknGHwk9ZyM63pjWeP7z4D2z44wyrhB
3214	payment	1397	1397	1678	1	1	2789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRW4qV1qNuDei32AiXV4e1tdCr5mN9qfcxXT7p8ZMxDCir5Py
3218	payment	1397	1397	1678	1	1	2793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQBw5SGwxKGSBjVVyv5oUm2Gf2BhKP48ARgEkivzkJJ2bgUA4
3228	payment	1397	1397	1678	1	1	2802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStJK2FJFBN4vRJXSLQgMs97SptVGLFjP4jrpUW5hqFx3fBiTz
3236	payment	1397	1397	1678	1	1	2810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3UTV89Wvcbsfw9YfiFNbivyvwP5FedMsAxfEYFijaK2EA1Vt
3237	payment	1397	1397	1678	1	1	2811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBFL2G9nepJDQTxp5cC5oRCzb5MSJkYjfMkYghSNsmLF3qgtp
3241	payment	1397	1397	1678	1	1	2815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxuPYghDDztCoaEcbwzELzHAyf8MLffaAc4yQk8uB1WVxyJd1
3247	payment	1397	1397	1678	1	1	2821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYfJfimV99tmshpeUUrgoXY5swiYkyREZsVsKhjnai4Ka7fbo
3267	payment	1397	1397	1678	1	1	2837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHa1c3mexwpVehLgHZUA3dZVSEQ1Mf42yi6LcJf7aUSYNp55E
3281	payment	1397	1397	1678	1	1	2849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfaj2f9Kebn3jG8Hxy5bannsdf7zxKb8B8WQPvnuuGrxsgxqy
3285	payment	1397	1397	1678	1	1	2853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnchgLysQfnZVF6F2hLX7f2oMH6Vv2S4zqsgdenQ6fpxVvLsT2
3286	payment	1397	1397	1678	1	1	2854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH15vLwrzF5r4TTAtfuXjZT9YwNaeTyZGsF8gAXvEWmtrf7mKg
3290	payment	1397	1397	1678	1	1	2858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8CqQ4zp3GkRa6sccEEJghLDtUnjNamzTyrsAYfwJHZkQm1ZK
3291	payment	1726	1726	1784	1	1	2	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpSwxMhbi6YKn7PzPEyXqcvVVhUJUnSV4sWk8xDceHqdtGrWCy
3292	payment	1726	1726	1785	1	1	3	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZjdguhyUdQb4N1hrRdifak6ktHK9FDrCQ7hz6SZt9zCE4RTkvN
3293	payment	1726	1726	1786	1	1	4	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZy1XDghyGwAxEMWPDbPWPEtbJsCeiuqKWyWXrqBqXnvzF2B2ub
3294	payment	1726	1726	1787	1	1	5	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDd5Agh3TjEsybs8xHv1Yh3S6Yd2XjsCyngiVbTD4zLpCi1zpQ
3295	payment	1726	1726	1788	1	1	6	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZomZD4cSEj8zpWkLGZDJCDaAKEqZyGvi43Y9TmCWV23RN7xB2j
3296	payment	329	329	1789	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK854kgfPGqbJFs4gp7tyHFGGFpb9bDqMhpVYvS75JZfTxWooC
3297	payment	1397	1397	1678	1	1	2859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDgEKcRVFSW3AtWoPtYyNwCscyQUv3aRYtyMjHQsNpKRmxTMz
3298	payment	1397	1397	1678	1	1	2860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBMM1RcvRqGaYYXANirs3aiV1wVMZimpDW5LXZ8pXTzuPbcAh
3299	payment	1397	1397	1678	1	1	2861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHjgFxHiTJgBo5wzDKvRx9boEkXarbEtvKMHxTS2GjhC9SPNe
3250	payment	1726	1726	1782	1	1	1	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaGNNSoaRfBrEMqYPBJa8YTyia8JbosCdXGjdEbz31GFp7c4Hq3
3251	payment	1397	1397	1678	1	1	2823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoT2CebtfFxRNVFUqhdwABnXAgoiYfU772R8a99k2782idPSC
3252	payment	1397	1397	1678	1	1	2824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7VK1GirHFvsSRDPJHv8FY7csRzwXa8TrmRKLD7yKDyH6SkiK
3253	payment	1397	1397	1678	1	1	2825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUa6F2GvXoJxi6x8p5QhDSk6KNCJC1ah3uFJWVAgo496Pn6Mz
3254	payment	1397	1397	1678	1	1	2826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPcM3ZihQAqjLwdZbqwNcsKzzb6YUVEkkHr4GeVhCvdZG9z4T
3255	payment	1397	1397	1678	1	1	2827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwG9n3rRrVTChtJubdBMiwzDGhXFAujHjGTTSnzQEYMXRmrFX
3265	delegation	348	348	1777	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQQASif16AGKjH7GVXUxPgH7mQr5UMfdUPBUkXt3n1NoKc7je
3266	payment	1397	1397	1678	1	1	2836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJXzhGCjeAxDKgy2LJqJbXrSaC6b6YHgrCWdbjKJsnzVJ2pSM
3270	payment	1397	1397	1678	1	1	2839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxgMeuhVMUEQCj1eiL8pXywsNrkKe35oH8v916M2797hjkBtF
3283	payment	1397	1397	1678	1	1	2851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WRHoKSkcbAoR9yeb2MoWg31gofhCsTVAS5w4429TWxbNJ1bf
3284	payment	1397	1397	1678	1	1	2852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4e4MhR5GGCaixPKCtWReAN814qTqFRyCc1bvJEwSiyQLnZ27u
3287	payment	1397	1397	1678	1	1	2855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiWAt1wKeead8wDp9VwvEtoCzBp1osdPPvv4eRioz599BwCjd
3261	payment	1397	1397	1678	1	1	2833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirDkLq6Do5iFw6PtgaSAmN7Hxi8hPPeKhjc88p84Hhc5ejfsz
3262	payment	1397	1397	1678	1	1	2834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba5R4G7erk8XhYCjxhHYqDakRpG6HQVE3VftghUGU269fFF1W
3268	payment	1397	1397	1678	1	1	2838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bBKooqgzPzJYZCijyaraiAY5jBntL5dAM7HhD8BMfBK851Fk
3269	payment	1750	1750	1783	1	1	3	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhygPFtCC1bkSk1XJm2reywuzWZZ5tfHfYA4pbrHtFRageruL9
3272	delegation	312	312	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtW26N2VYjNXwspKz4ng8LWyML2UnsA4eTmxh1hApkioTFcow
3273	payment	1397	1397	1678	1	1	2841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYQwPjjNx4mab1QAJGG9ywQ7ZQgLFrvG2mT3A85ED4c1bVG5W
3276	payment	1397	1397	1678	1	1	2844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKAKk8v6gLa7uDhhEknQ7pPBNwWUV4jFuRpQKtvmYcp46EMsj
3277	payment	1397	1397	1678	1	1	2845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBptdmdfZFKA5PLBV1LZ4rpVgfZE49zmwLLEMQLDaQT91mTcd
3278	payment	1397	1397	1678	1	1	2846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnSGqumk82hFNsQRjg9YvDC3ipvo4gabFFC4nwjLbxUXN2iFh
3282	payment	1397	1397	1678	1	1	2850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpUPJWUyuAGSZD9kNm2vV58pAK2sjBxuFNCv5rcSLtFeZbGnk
3289	payment	1397	1397	1678	1	1	2857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqq3me5G4RoxCBbMgTBBsNKp4kXjjJyRVSaMXXaFgcXQ3QyFMx
3300	payment	1397	1397	1678	1	1	2862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mk9pgXBrNQQMmTzSPySPDuK3kbYjDgFG1cacB3YcdF99F3Yv
3301	payment	1397	1397	1678	1	1	2863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQq971rSGj4HFDzHXLyzErzjWMXW8fxggL8kxMMPzkZukDiMCB
3302	payment	1397	1397	1678	1	1	2864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wS5Vz2kwWGv8Zkc2YWdVL545Jj2Z27mxAh7b5cXPKmHAqswM
3303	payment	1397	1397	1678	1	1	2865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfBViAPACFXJV5XRZuxAi4ipRnuiktubPt31myc95v9JED95b
3304	payment	1397	1397	1678	1	1	2866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLnngchaP4PsFUd7szKozgwG7eELHrRy1iUBVJzgUTXP29Sun
3305	payment	1397	1397	1678	1	1	2867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgXU4E5uyxdHscVXJsXcEraaojcdDCqXQcdNjEGthcozYHQKx
3306	payment	1397	1397	1678	1	1	2868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdTUNuHfSpCjc1YcTU5C8Upx4SgwiXqobTZuVMxX9juXWnLNR
3307	payment	1397	1397	1678	1	1	2869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqkakM8jCWL1Jj1LUoe1XWXNzwecHUH44egBjaYKB6iCJNtJv
3308	payment	1397	1397	1678	1	1	2870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyXXoTTtGMGA9CTvkneNJCBZoSfB4ruxJt9Y7BqEzFG8RB8od
3309	payment	1397	1397	1678	1	1	2871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDRmC4UJoekPoER8CTUGU3ascn5TRTmbx63XPMgy1QCCeXpsw
3310	payment	1397	1397	1678	1	1	2872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD33f7HHabqvAxcu9e7pZYmnw4G3dSsGAqwJk3Am4vHbg5zfRX
3311	payment	1726	1726	1790	1	1	7	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmeZXqfsDMUzzBP3h7SxpbnNFGL6zAcMizVSgyzSk9owhwZQBp
3312	payment	1397	1397	1678	1	1	2873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkG18Ywu7xvcmSPfYGP1UySmsePSxVmEEEpMz59CGUPmtcwJJx
3313	payment	1397	1397	1678	1	1	2874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEW29GjtrK85HPS1G25Sppb2tPe6zmK3cebMbjbuNKE9SBMqE
3314	payment	1397	1397	1678	1	1	2875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuy54RLPBrdxdrdD9ecmRXWDyA38djutz9Hg1c2T7a3HiMAxJ4
3315	payment	1397	1397	1678	1	1	2876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPyUriGFyG4GAwXw7C8ywoeve2T3mShPRgEmXut2diZH3kYBy
3316	payment	329	329	1789	1	1	2	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqe7tJGsXEYjypBoDRw7PoNdeEPnXEULPPkoG9WXbUTUVU8Yh
3317	payment	1397	1397	1678	1	1	2877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43wSt36GFmyziP6U2kkgkdDeNpfXstiLA2ZLnXeuqEYPsRXYU
3318	payment	1397	1397	1678	1	1	2878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26U9BBmNG3VZGw8qrVWEEqJVFdzu83e3rZTcski7YTumojbfD
3319	payment	1397	1397	1678	1	1	2879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXDTWXXnFF6EEBqTbe58RQancLNTEAkxcmH3ryenBCBMM8C1w
3320	payment	1397	1397	1678	1	1	2880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBWCHaxfMFDnMsDMWRaH3dcZY8BuCfmFaD1L98gSa9FXzjnuX
3321	payment	1397	1397	1678	1	1	2881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8AegjDPNoN46vU9dSg7KQjnQfYntDa7JfbTCo923ymUjGSzn
3322	payment	1775	1775	1521	1	1	4	1000000	1000000	65535	E4Ym6mKZFnff2vCd19EWYbgAwCegoKCnaWkkFbXssMTxAi3RC9ixz	CkpaDTwYq2ST4KVZnig7kXjb7SKxDP5KkUEGL8eoiTUKaRmMuSQwc
3323	payment	1397	1397	1678	1	1	2882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ygmYYJRp5eZd1cqrhWpGbgYr6MtFqGfxRd7KmTvruu94QVrS
3324	payment	1397	1397	1678	1	1	2883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWaDhEKdgfmzBdHSkj4mz85vQmXQzfcuCVFZvXuQSKkKGZkAm
3325	payment	1397	1397	1678	1	1	2884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8fAn7F2wM81PUerwivVDAp4LXyinz8byfaJMPSDT3smyNmEs
3326	payment	1397	1397	1678	1	1	2885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumqbwjang7QxzhaeWpKQege5q6TZXymp94vypXCpxXjsi9ap5
3327	payment	1397	1397	1678	1	1	2886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZeJiL5DWUiUjhg2vFU6HiUJ7DZWqzHDu2y9xqgu85BQhzEB7
3328	payment	1397	1397	1678	1	1	2887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RFE4swf8PKqiNXFrt8pZe4PxBuRFQ951WBfkMBK2Y2iTpaRk
3329	payment	1397	1397	1678	1	1	2888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVj4QGQYUzyYHBiyAkeApnpm6UjzLUNS8j3EAvcEDt1jJk1kr
3330	payment	1397	1397	1678	1	1	2889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTkoTH44cu1qSyeXxk31rW9dKNM1vk8HjYm4Czgfhos2PWktq
3331	payment	329	329	1789	1	1	3	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6En2BrNVGbXWAzkHx1yDP93LexPqQJH8aRrgJzitqgk9D1xN
3332	payment	1397	1397	1678	1	1	2890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkCyDLbr7RY4VhAhPJNRkG7bJE3qVwVZxdzzVBsHWcfb2mnXb
3336	delegation	1769	1769	44	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDxqVSZJetyb7YrzDxjmfecMnNvrPEsVEm518qkUo759Y2bZF
3355	payment	1397	1397	1678	1	1	2904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MVwZPefGXAvX2ESyeSKXVhdpKhCxJGGGv5xgVKnsy6Msd411
3356	payment	1397	1397	1678	1	1	2905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrqHuC9iWgdrruMpRrNTuisY1CMYdZqxcWCpxVxw7GmAe7Ttm
3362	payment	1726	1726	1795	1	1	12	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXazEsMCdDEvE9y2oSNCoH4CTKvaxKdiSWAwnECex5kPG5DAQU
3363	payment	1397	1397	1678	1	1	2910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5m13rEKgAqCXQ9MbYZnuQiKuinhFCevLW2MKgxAd5umH191kt
3364	payment	1397	1397	1678	1	1	2911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2LmanrXXUhBVjsRT7Zf7m6BeLvzwEUWcYbggQcSoEYtZdCMw
3365	payment	1397	1397	1678	1	1	2912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQzaSqW6AdeBQvss3hZnZAJSYvy8JVMJK4AbmNHTox9Mp2Kgu
3366	payment	1397	1397	1678	1	1	2913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsMaouS95BYmSvv5YXBo33UzT8411mihPmqjwP2zUg1ZgCfr1
3370	payment	1397	1397	1678	1	1	2917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3R7FuJEX1rMKxAXE1kXndaGzVHkdj6bgqQjvHAuvoQEgYsCnw
3396	payment	1397	1397	1678	1	1	2937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5hkmdLeHkFQpv5QX6DueUS11J6HvNR3m66URYqb6xgVzbwVW
3407	payment	1397	1397	1678	1	1	2947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwguv9fTJyLWu6KNBTybXfyAuafzfw4avLb76pe97f1yvU4VeT
3408	payment	1397	1397	1678	1	1	2948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6QHxhhdJnmJZBUhpD2pWLnJKgDwhd7GCfCfTYZcF67sYtxji
3409	payment	1397	1397	1678	1	1	2949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6yiwwkqo7E5f1ND5gsy7gPfARxqTBCGgcH7TYJ4mFtUE73JbF
3411	payment	1397	1397	1678	1	1	2951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuvXf15MPof7VE2yUBGzCGpSYzRfZWS6Nn8BPhnTpE4Yatiek
3413	payment	1397	1397	1678	1	1	2953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVA1v1AEtFr3uwWS5mLdMQbqYqkrkHtJdNV4XMpiNupHyVEad
3417	payment	1397	1397	1678	1	1	2957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnSVk4pdkK4hb7gaPwgHrtoWiE2PapMbRiuQ3E5xqDv475cEX
3422	payment	1397	1397	1678	1	1	2961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahsGMercERnY7R7QFjn6i82bqWUwJrLk4rRR3cUnX7riWNCvD
3430	payment	1397	1397	1678	1	1	2969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8zT7MzGM6nC6cXaSD3KiBFEfhJMr9E7jyurdMrcw6STNAJ9d
3433	payment	1726	1726	1798	1	1	15	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpHMDQ1tU8dDLUr52PxhbaSXpRNYDenJJZ1EgwyY1rW7zeyj2Y
3434	payment	1397	1397	1678	1	1	2972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttwqj3RedwZ7bS3aDCXgZqYQrZNUyzjD7jqFkj9ZA5ou5rCUE
3442	payment	1397	1397	1678	1	1	2978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocW75xpnvAm9pX4A1kBRYnVdgxaq1ydwM6xwvPvxqcjxYyHA3
3446	payment	1397	1397	1678	1	1	2981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpetRHt7mtXAFEkLnpkdjR5XAakuUnvyF5YKfwtDTjx9R7odp
3447	payment	1397	1397	1678	1	1	2982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TnLk7CM9vrTD13LNVECtcAc6R2NC4sr2vxvaJdBDiQu7ZpHA
3452	payment	1397	1397	1678	1	1	2987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPbkLvxp6k4JJKbiQycDEU9kyhGMoZTWNzUnjGQjee3G9a6RB
3459	payment	1397	1397	1678	1	1	2994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BorRDgb3fJTfhzK25MbF3TDibiwYsrKfhUa51FKc3MAkgK7p
3460	payment	1397	1397	1678	1	1	2995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4N6ySz34KLVjXLXBovXtEwaytja7mtDeaadPyQN1gV1PKbEW
3468	payment	1397	1397	1678	1	1	3003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8SzDDW8oE5Y9NP2vWFKYt1ffAhPdwALN5xra8CACn4CfAQf8
3469	payment	1397	1397	1678	1	1	3004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U7daveVFseJQWPkgfVqxcn675VrcncyQYTGY7Mgn7ufEghPD
3470	payment	1397	1397	1678	1	1	3005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8G62auuQQpeDVY8Td3bHQTLb7BhhMkjvGPUyPH1duXN4p6J2
3471	payment	1397	1397	1678	1	1	3006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzw9BjZ6AX4YbYXdpVuXSiBTN3FBJf6MnxRLviecUYuUqdP5HN
3473	payment	1397	1397	1678	1	1	3008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43FKUcbHFkSYzQBPwVnMX36wRxKXRKj2JDQXCHVPgaWVH6cTc
3474	payment	1397	1397	1678	1	1	3009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFL8VxmLRg7memAwrRBJMYejxZ65BP2iog9kyZpJ7ouXj1KNe
3333	payment	1397	1397	1678	1	1	2891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkZF5k4Tj192fRFHZys155L3XSx2nWdnMqKJGVyt1rwqCRws4
3334	delegation	1769	1769	1483	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWtKsNoxZrbBoywRpGPSuKNMuvaUxYgj4Pg1BuWdQUue1ZGEn
3346	payment	1397	1397	1678	1	1	2898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rbGJF2ZNBvnxGCaxcLCz1DrrVvFsAp6aWoQUNkuGPHaBYj8A
3347	payment	1397	1397	1678	1	1	2899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KmT7bHKnoq8jh1FoN28n8eUK19v6urVZ39YCjrpyFHUVVZAi
3367	payment	1397	1397	1678	1	1	2914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLSKw4mk3XenVxnKT3fHUCPd2fkgGZjQzMLVm6soeb4u3JNMU
3372	payment	1397	1397	1678	1	1	2919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1s4JCS1yoGraM1BG96VFr1gFf35ymvMSkkaWBn5otv7LKpDz
3384	payment	1397	1397	1678	1	1	2927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTQrCyaCchzNgWY3RDYZk3sVTa8kBv6XEwTpeiWn9jzY9qZqc
3385	payment	1397	1397	1678	1	1	2928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsnQs24YE9vbiiYxh5GtK5VnWS6YULndCKzfTsB5t15fCJLbs
3386	payment	1397	1397	1678	1	1	2929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnPP6UurTp1gMxYzDhRxG2zGAhwoy8PFpZN7U7hizEZr1b3kM
3387	payment	1397	1397	1678	1	1	2930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDkdt1eAQzK3e87UZC6Z3QjaXDSXcLhenS4TmRZrZPUsRDvLg
3388	delegation	1643	1643	1643	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggVAhytLvNcPVnMQhVCHggvqDv7JE7mKrgx9VCrQGAgHZV3Fz
3389	payment	1726	1726	1796	1	1	13	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6SWJ4VU9SoKR4y5W5hsS9BQitg4WJnBtsp5sJRkYCruEvhe9L
3390	payment	1397	1397	1678	1	1	2931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22u4Hzwcpq6T3FLAXgBPueJyQbBZp1pUQ9XoWXUkGrKCg9xAQ
3391	payment	1397	1397	1678	1	1	2932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdPxHTykpH1bVvpG592WWCqs8FJjg8BAnTQFNFHyMGJ2WxLCs
3392	payment	1397	1397	1678	1	1	2933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1E7Me6hfsg4XjwApUUeUCyu6WWgAUoJgBMChe75mn4cxqrYr
3393	payment	1397	1397	1678	1	1	2934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMTmi8HXm7tpKfvhLTm35Z7wt4DgaXB1Wc2bjVQmnPArd9Svk
3394	payment	1397	1397	1678	1	1	2935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQXUGyQzsHdmibyrhhnwU6tQv3Qwkav5wsvFDz9mmLXgoP74i
3397	payment	1397	1397	1678	1	1	2938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FJc1znUk3Yv8TyRz94roLCoVPztdkBQsx3AocnkeDxjsQfWL
3398	payment	1397	1397	1678	1	1	2939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N4hjNbuFnp7PEVRRHNEMXYwdzGZnULdABo235uinkMUDRRCs
3402	payment	1397	1397	1678	1	1	2942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4jLuAbKqAib3X23U6CZyzH6Mr2jmFaYQ7ZeNgr5k9LC5JXTo
3403	payment	1397	1397	1678	1	1	2943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYkCD5GYnnt96SYgvDxVhsBubNP8crcRp3MzfZU8FbCXxpoKg
3410	payment	1397	1397	1678	1	1	2950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUYWxGsDEgrp8a1VMS5ZUdcdUzgnQpq8PxYW9uhQJwhNjnwXy
3418	payment	1397	1397	1678	1	1	2958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR8UsZgaHKsaGT7oCwaq3r9pkeDrnwPf3hy3w7rdKawgkWbujj
3424	payment	1397	1397	1678	1	1	2963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe21TC3zsKA6REPkftWTgHRwe2UmdzkdAvXu4GzuN1674DT2bT
3426	payment	1397	1397	1678	1	1	2965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGePjzA18TDcvmoDTXaMbqmghNZZ9axwQD71UQd6xJUi12HNRg
3427	payment	1397	1397	1678	1	1	2966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgJtXWE9kRswdQotzNVx6vUCdupUXF2zMmVMfTUYk9PxDrj2a
3428	payment	1397	1397	1678	1	1	2967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGPQqTgpijTiTBBas32eso6KiM4XN3aNNTYzL9tbwZEFJijaL
3431	payment	1397	1397	1678	1	1	2970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLscYhhyqRFXuVzdij5GabYcLtZwvmSEz1ZLT5KKAWbmnVhY9v
3436	payment	1397	1397	1678	1	1	2974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2CQH8RBJS88GrjvPZS2k3PWC1vF6ZxeFJ1xrr5usUZ2A5Lpu
3439	payment	1397	1397	1678	1	1	2976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmQwb5oCf7eTHofx2DQTTjuyYzRgZKg82A9FDg2iceJ6RKetv
3440	payment	1726	1726	1800	1	1	17	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSv1mHsHKgvcffNPQKaZgvq6Q3ch5dFYqxgnuCfDU6hFQ72qLU
3441	payment	1397	1397	1678	1	1	2977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvpPfCh6Rg5CcqsbeL5TGXNk1xHGqfHdm7w4dzVGHiXv8HWzr
3448	payment	1397	1397	1678	1	1	2983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9ihWdFCpYDzDKtWzh1yswwy2kny5d2nAToAcMTEGUqqP9WtT
3449	payment	1397	1397	1678	1	1	2984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1aSjADVa4mUfaXfFyLYzksAKXqnKuXLbw63XAeCVXp6769pf
3450	payment	1397	1397	1678	1	1	2985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hPHtEWtuP6hmQJMLDFi6ySkv25swJYAnseqpcQgBrctUAjhB
3461	payment	1397	1397	1678	1	1	2996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtkdm82gh7VqPc4Rze8dK7MNUnRLF4U1PokLiyALgP929js57
3462	payment	1397	1397	1678	1	1	2997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagxhdQTjKKNr96nyM5dpxUNDtyvE3H3LymQdBhwYtCwQDmHav
3472	payment	1397	1397	1678	1	1	3007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwd2Ta6P2KtPhCxbvwd6Aa8xAMqXxj2LAHSSiB3X6Wpai2pVdb
3335	payment	1397	1397	1678	1	1	2892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwK3qK316YhDkAr6iH26Xe7bUPnEjTiwf4SsBo44NeWchF9ZQ
3338	payment	1397	1397	1678	1	1	2893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBP7jkNn1Zksqf2JUaHeFh3Bxzkut1VCAVTTD6Wz1NQoLKP2B
3339	payment	1397	1397	1678	1	1	2894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzcXHRXhzPsCqi5y1QVSpmsEghT6Fye36JmUnmWhq29s1UwuW
3348	payment	1726	1726	1793	1	1	10	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKHBZ8gpraw2EcGEccgFgGsdAYSJYSZDEN4YBkD5fGGwS6Yv3i
3349	delegation	1769	1769	1406	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HNGQEpamXgAUYejDaFLUUbN2FfGMd2fn6CEmbXRzXsV2d2zC
3350	payment	1397	1397	1678	1	1	2900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZpTL9n4i8XjTrUdJaY4nwXav4LaYmbRzp5PpcTtkKkqnjbBk
3351	payment	1397	1397	1678	1	1	2901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgLc45jJy61VosAwgjWZDShbb3c3H1eoJwWeNvUA8517NRsKiN
3352	payment	1397	1397	1678	1	1	2902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcqqVDaJ1DevxrikNgMiPUMPkeDAGgPv5dAZuLyC9kFMTicj5
3353	delegation	1769	1769	1406	1	1	7	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXh7qyoSA6MW6R2bxs5y1nSGXq5VHNycvT8cdeovFJyActf6U
3368	payment	1397	1397	1678	1	1	2915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppbKgurVomm5XnvTV7HekPJAbQfJfKRoy1ijLpiVzXXqz9dyc
3371	payment	1397	1397	1678	1	1	2918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcv8go9LtawaWzrcoxngkESKd9JVBdDDzp6MHo5a7pxt9Yki1f
3375	payment	1643	1643	1299	1	1	0	2813972737000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs3TgbRfjNKJLevVnrUdvgwUAGN7r2Atm7FzYcqgeAey2mkeJ
3376	payment	1643	1643	1053	1	1	1	1496558242000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGvA1AZqMeQuXWKdBHjqmPbA336q9muGe8pybyTSSAsyy229L
3377	payment	1643	1643	1173	1	1	2	1009607370000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y7v4ktcwR9SVrc43ZzEY5oGgfRDWSxvd9bQyA2zY7ZvmEWZP
3378	payment	1643	1643	933	1	1	3	835388537300	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAnDxgqNVUqFZhB8wUxdmiFU13bmWd8HUstUE7komUdHjcuZ5
3379	payment	1397	1397	1678	1	1	2922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCteJxrsFHQrYsk5fdSsvPAqe3PA4FLEFRBjFwnzqkex9DP9b
3380	payment	1397	1397	1678	1	1	2923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgckNWUs6Zr8svxMqJi5XZJXj1rf15qRer5owiHtFbjf1L77w
3381	payment	1397	1397	1678	1	1	2924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEz9YDtggC2i5yzGqw24qLAAiRy9VYSRZkPCubSKkxjNk7VnM
3382	payment	1397	1397	1678	1	1	2925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5e4EEFhu2DLzvxRTfkk9tBxbr8FCtzrBK2iKAgfUiJv3jAqXo
3383	payment	1397	1397	1678	1	1	2926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZMV3rXnueaLuCD24pb2hmCLeDEceje763aiqTY57UMQbq6GT
3405	payment	1397	1397	1678	1	1	2945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxv7psTPUpRxv29YUYJZ3UBGfv43ttpP7uGsZLYWza2wthyNw
3406	payment	1397	1397	1678	1	1	2946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDi3aZXVWBhtQmf6Mp5W1jjZwTA9y7pcRLXYTKcNmq1fjMVcX
3414	payment	1397	1397	1678	1	1	2954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TpFxTQPPhPDGBSR2c3zJZKJ2JycysgJbJ68E2CsubvJ8cB2a
3419	payment	1726	1726	1797	1	1	14	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkEhKWz3MdeDnf45GCCow2ZL1HbtpeZqDeJFNgmp3ECumsHycx
3420	payment	1397	1397	1678	1	1	2959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgrTqxXMB25B1mXCCRcMYpFqcHkMKiZNaz5QUMLuhXN5HSVqR
3423	payment	1397	1397	1678	1	1	2962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ojtwZhYfZuPkssexp5T36SRD78SivjS8syqzJQNkeDKz4rKL
3432	payment	1397	1397	1678	1	1	2971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwHMhqVP4nwSt2FxRm8hFPgMCCznvvyeM8pvA5EavXWPKEKPJ
3445	payment	1397	1397	1678	1	1	2980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFVkog6qFjwbVvWj9oMY7RrCZ8DepeQFGUpE7usRwwm8PEpDV
3453	payment	1397	1397	1678	1	1	2988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4tuCnGYGTmsDL1XuUK4PSLMw1Lp9C4pQQqp6eACwLuZ4dvPB
3454	payment	1397	1397	1678	1	1	2989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19PBmRDLz3ak68ii82K5MnpXyX8qNUUwCNoNkq9jP26qZnSZi
3457	payment	1397	1397	1678	1	1	2992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVFxDfE2aXNcrLyGXZ9JjNHtXqEMszRj7NH2AVy6AkZcpy9p1
3458	payment	1397	1397	1678	1	1	2993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNvwAqT1RkK8GDnPKxhXH3cFE85LCNmrGRkqd1A5wek2jN2LQ
3464	payment	1397	1397	1678	1	1	2999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNMjnddPeAKFKZKdmAvkZxe5DkfkhhowcmHepuL3AUUMhx6k7
3465	payment	1397	1397	1678	1	1	3000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfjPFZW4axrMhBKk46UDfVnAi4wSxVqFnSnE7gAQxvHtWxTas
3466	payment	1397	1397	1678	1	1	3001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTWKXaYQZVxd3d8AWLg2QRuCQut8vvVsii8yS7vtubtJkAz1i
3482	payment	1397	1397	1678	1	1	3016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTLZVeKAdjihwZq7ehT5VFaSAnTxMtGUeGeFsevqSA4jCJakA
3483	payment	1726	1726	1803	1	1	19	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcEiq3WCDFXgNv3MxERttZ2a2iLXPhs7uhian8U8KMw8FDigir
3484	payment	1397	1397	1678	1	1	3017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDW1gLy9W4EPRybyfmw95DgHemLwUMy7sWZEpYnFQooKRS8MP
3337	payment	1769	1769	1474	1	1	5	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhwuBY4RWEarRhCxcLLBspvTrHf4rzM316yPMY3BFumrL1D4C
3340	payment	1726	1726	1791	1	1	8	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUgRgyTZYwY1jx1CsHgoJJiNNMi77NMA8k3DaSn3wsVB3XuA3r
3341	payment	1726	1726	1792	1	1	9	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXnoFH14ECU66zHCLaqoeAFfVB9YdSWWUQvFXQHkm6nFHt6J9e
3342	payment	1397	1397	1678	1	1	2895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8XGH2CcCXSUVVvRbdinrBPKX3GoBTxgo8kMfg8LujU7Z84vS
3343	payment	1397	1397	1678	1	1	2896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2ksnCrdiqhsHDiiDFakfka2NN5WjggR3aLxrQweYAwQje3kk
3344	payment	1397	1397	1678	1	1	2897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYoZohSXemb6H8mFe3RDtqoZsYf23mLGcNsce2qnMLZQE81rkY
3345	payment	1779	1779	1754	1	1	0	2322456789	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4U8322uv8Xtgwdqj1UBeAvYnZurrA6hMMFQzueZfymmYM3otE
3354	payment	1397	1397	1678	1	1	2903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPaoYetAvbfqWxnwuWizzVDijBtFU6fTbN3bTLb2PSfBwV8To
3357	payment	1726	1726	1794	1	1	11	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYqeMvM2TFAqNBN45UkHzyBHieXH4CARkyQYjiQLKVKwD9YTxfD
3358	payment	1397	1397	1678	1	1	2906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZig3NFPSVBAjC53oNw11wgUXZjUCfSg7wcTwYt7pR5hQxxkygH
3359	payment	1397	1397	1678	1	1	2907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeun1RVER8HuCpGJvUSQxhADfK52VyTRZvQLsMyCaSDUUuJZ1w
3360	payment	1397	1397	1678	1	1	2908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazTVZmt427b7ieTgsVTMwmo4DDJ5Fi7hTFs9EgzjkbvrHCF8o
3361	payment	1397	1397	1678	1	1	2909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnb74mhgNabHUVCBzpFHBHs8dYsMSwxDEwRenN7CvMVASRXEx
3369	payment	1397	1397	1678	1	1	2916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YaSBDFouV8PPgRQmf9JPuJgPnbbUNe3C7tvST425VHzW8MyH
3373	payment	1397	1397	1678	1	1	2920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqETcCjsSTQrdCWoHDU2bJuWFhSH737b1WQpjPjrgaXnQbdDoE
3374	payment	1397	1397	1678	1	1	2921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWxMyy9Wo1DBwn5UCo8x44HCXY3z5t868nQw2RGcBSYda1ZAL
3395	payment	1397	1397	1678	1	1	2936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzaHF3HNtfKGKLyyze2r1dNZ813nf9zKzRBTKTysTusYbnfJa
3399	payment	1706	1706	1737	1	1	5	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8BVMYb8bsa3JyZVTsfDPqH3VFXyshtYw48JhKHYoijU4pXfF
3400	payment	1397	1397	1678	1	1	2940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FBEbPgp66rjW5ZLstaJWSb3J8admq5pYX8HCR3JR8EKCgZJR
3401	payment	1397	1397	1678	1	1	2941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttK2PFaPvf7CPZmDDDtnVPM1heqAXYwxkHhJ1L4wfVEeNGmuc
3404	payment	1397	1397	1678	1	1	2944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQb4Tm7e2eHgvQ2pzC98SP6n33ED1y4k3tm9yCjiam6bmx2Rhh
3412	payment	1397	1397	1678	1	1	2952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCEqZXo46T6sW6uKGRSFo2N8kmge7v2Nf3ZRTQdAbpU2sqgyg
3415	payment	1397	1397	1678	1	1	2955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8GtwJ5C8GkSZ99VZgvXbox38oS73U4L4W4cFTm48eJ7YLZTw
3416	payment	1397	1397	1678	1	1	2956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwNqD6bMwF5cGzRug9oQ9U3AD96UHtdvUYEaNWguysNBC2aAE
3421	payment	1397	1397	1678	1	1	2960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovTLCxzKs7jRwuv6jbbrmCQ9b7y4PkNkWNAq4KRxD8doWGYct
3425	payment	1397	1397	1678	1	1	2964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hEb2R6G72JxqZ1yR2nvAkHni3nwjArDAZUsXpoFPWb4ZJP8x
3429	payment	1397	1397	1678	1	1	2968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaizc126UzphYARQTL9ztW58XSesMfX9P5jijezPTdCPtkA7K
3435	payment	1397	1397	1678	1	1	2973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhXh5yWwkHX8UzE4BTdrs73UL2Va67i9ca2g6FyBwvZdKUgcN
3437	payment	1726	1726	1799	1	1	16	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZs7aHfEH3byJb7vzMspgTKj7C6r8bFAbyesp9fEGbLqWHXTHx8
3438	payment	1397	1397	1678	1	1	2975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSCsfmf16jJiiHmvaGkTC75ut9t69DyUCXewG8MVhRkq9pWd4
3443	payment	1397	1397	1678	1	1	2979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfASjFG1iV3vagEUKbVM6e19cvL1B4k75GgH7ehifnwjkAsPiK
3444	payment	1693	1693	636	1	1	229	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpaCwCRhjNseZwXej6A8ZbNj9RvKA5Jx3ivVVtLrpcBQHCrEWYXZ
3451	payment	1397	1397	1678	1	1	2986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QLfyUPQwdz9ov7JWwCuhJABPMbfwHFKLa2S81wRuN7fkpkxK
3455	payment	1397	1397	1678	1	1	2990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ62ipZWJB5n72HDStCKQec1nYRYWXmQVocujUAVLxd6Qbi81
3456	payment	1397	1397	1678	1	1	2991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba8JytSuvcNgAYbF2GUppAnAqPWrB99rNi4JgYToLL6WLzyb1
3463	payment	1397	1397	1678	1	1	2998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBcmZFt5Bf1R9UFLhG9VDPijB7rEmW1h6NdG12TGT8g7TUi7Y
3467	payment	1397	1397	1678	1	1	3002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9DqcrBkjfTEJmaqbL8CEUzqfTSNGiBHGgNwCN72WLBEroymF
3480	payment	1397	1397	1678	1	1	3014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxm9sdKsTaCiZJrYk8kpTBFD5pw5JW4SSB8nMRQK47fjxPTSU
3475	payment	1397	1397	1678	1	1	3010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnLjvL2opGKbSmmdy5CDg5HXxtii9tiAsPrq1pVdCJ61GCbrhg
3476	payment	1397	1397	1678	1	1	3011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRc1tNnrRmVdUrH9auaunjQ6daJrYtMfezdsJquWEJ5UGpmshF
3481	payment	1397	1397	1678	1	1	3015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbsTprZTBSjr7Y9wTzzEC5AaYjxqiD85spzVty8eWroaDsyGK
3485	payment	1397	1397	1678	1	1	3018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTryBZSHsLSLjBXYMfXCRxzsQVCXMEK5hso3EEDKjooQrruQ7
3495	payment	1397	1397	1678	1	1	3026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRW1md5bB5UQLdhMBJi9ERNj7BpzyQA8e4vxKvVg2MP4NKhTPJ
3499	payment	1397	1397	1678	1	1	3030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz9mNZ4934m6YCdiP64pXrHYhyTwTWrE74qyqcdBdbd4MzbYD
3503	payment	1397	1397	1678	1	1	3034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRyH9Bi9zCrmiGVqnM2xYbAXGcvm31SiLzxWobaDCaM8H1MJ6
3504	payment	1601	1601	1601	1	1	0	10000000	10000000	\N	E4YfQtEE5riQhULZebpZhunzgAL9Vabysd4rjkzTS358sDUd1dYN5	CkpZx9pYW49dDhqyhuYSda629gCpQ5WpxSczK4wAXtmzYVDZeMXBj
3505	payment	1397	1397	1678	1	1	3035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwYUANid4kfDqwXrwbssLDfdioF1P8AaEuJfXXLDvzbc9GCW9
3525	payment	1693	1693	205	1	1	243	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZBGJwvnANGyWegsCx8BSp7HQgUn5vnMrPoLqqpLViqv5uExqFh
3526	payment	1601	1601	1022	1	1	4	928188100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZEqinHKXx1uQcyyu4qdjVZ41x9nzw22pyzo9WNshpTTcpuFZ6D
3527	payment	1693	1693	402	1	1	244	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSUK2yupSDuQDdrCZLdJvfC2jWQKa3YBvwuokQA1X5PazQMiTf
3528	payment	1397	1397	1678	1	1	3039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMr4DUs6Ewu3u5631qPwwQsfkkhPh44KAxdF7vSRcXbzwXw9J
3529	payment	1693	1693	397	1	1	245	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZxbw7LYDZKsHeyQs2sGUySorVHvtzMx7cPCWKXf2Lb118vmjPa
3530	payment	1693	1693	690	1	1	246	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYhAcs8DhhmqA44j2TSsb839mmUJaWEysNXtUnyG7yw63EyQbnF
3531	payment	1693	1693	894	1	1	247	308541912361	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa5DTV7hw8dpYbq6B7UWoyqPNUvXohvUjYVXPdR5YsJANHxzdEU
3532	payment	1693	1693	106	1	1	248	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZKkfJreakgdd2SrB66TFCQp3F6qrAz34RK3nUuuz7R514zQ5Xr
3533	payment	1693	1693	534	1	1	249	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ4rjwWaXEnYN4YqoWKU3gRvFUQCkfwf5F9SnVginJgkR1ttc9M
3534	payment	1693	1693	5	1	1	250	6734520375	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkqkKdpkrkbWJQzuDh8ffiphuJKTKSGisSguY1LovkueDrHJwe
3535	payment	1693	1693	339	1	1	251	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3QbX3A1mu7PN53gkBDUxfvkYZsy9cMqocSbh26yvSbM9ApuaG
3556	payment	1693	1693	395	1	1	270	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ9hoLxFWmu4Gbbz5K4Ci9ELiwj9JYzj2cgFjq1gsufj9by3AaL
3557	payment	1397	1397	1678	1	1	3042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgyk9sScvo6BTXpSPPswBAUMU95cDgPujSVXU9FoNCsc13X1m
3558	payment	1693	1693	84	1	1	271	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaFYEDPGg3SiMJLbuud6LSssExwtLSKe2hVoxyhx9rgghNvLiL1
3559	payment	1693	1693	320	1	1	272	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZXCSFB7TQNZHg4SQNwtDw71kqiQ1HNNnPnLEuQaoytK26D3RTu
3560	payment	1693	1693	587	1	1	273	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYVQujNM3rfSxw8kD4HAxBRvj7XSqigJNQo4CttTkhhaDw3ZU2R
3561	payment	1693	1693	611	1	1	274	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYz9J9LpE5Fv5ZtKnwtBkXcNMWuPqAN5UYrVZCiLvecEkVK9Tk4
3562	payment	1693	1693	678	1	1	275	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ19dgutcoXof4pGepeaouNVuS4RtfCLM46wZYA4bhCzHNu2PcY
3563	payment	1693	1693	710	1	1	276	5028012826	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZz8BfiKoVbwMPdHNqXrC76kqWq6PpXChgBqMsfZFe9dD3YM3d5
3564	payment	1693	1693	295	1	1	277	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYhRVLcRYgeH2HmvUKtMAJinXAWPH6UJofymbMQrjaZaYsmhioc
3565	payment	1693	1693	721	1	1	278	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYnzsJkyKmj6byrkLXNAxVVhLYsbRxFt624zhkUo7mv3KkKw9BU
3566	payment	1397	1397	1678	1	1	3043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe93RJEvQnaB4yq3GDJBHj3c31vki2c4ethL9FBGUDWCnCMU7a
3567	payment	1693	1693	392	1	1	279	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZjke7dGmHppm2HHDFaQxMcejTXJSKDbZBiFJJsKYRwT2yVLMj2
3568	payment	1693	1693	560	1	1	280	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYaX7BjShfmSd2KkUe76dcBWKdtyV7MYsYfXJbJQtLWkYGYpsir
3569	payment	1693	1693	194	1	1	281	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZneMsKVFNh4Sxu7T4nwK6RzAY3VaTF9fB44g2xx5mTWzSJxtAH
3570	payment	1693	1693	252	1	1	282	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZA3q7iNyx6taraJz83EthBi4zyohuj7zg4ZdqSRPYnkbbVDAT6
3571	payment	1693	1693	150	1	1	283	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaGUHo3KD4YH5UQdFJTFPJFzXhcY1GgfzbLwuJSDjHfgRrqfmSp
3572	payment	1693	1693	450	1	1	284	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYzbtoYHk2qr2khmukLkRE9gSyfTvkfZGGgovCGyXPamP6qKXse
3573	payment	1693	1693	653	1	1	285	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZeViNy8Kb5PvLJib6jN9qvEv56A5srEUJPshLzcv3WjWdMkbZp
3477	payment	1397	1397	1678	1	1	3012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ws27dKYirCdbH34AMBBdCo7gdEiQtDioz6sFPQftakpBGjE
3478	payment	1726	1726	1802	1	1	18	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyEKrw1pzSJyxAGEtKLLNGyMB9P1zAZ34o7SrrTsFnLcid9h69
3479	payment	1397	1397	1678	1	1	3013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEsGLeEayxGsPzYfQ2kVVDrXBJA7RooJ2LC8uBhXfpwK8iQTQ
3497	payment	1397	1397	1678	1	1	3028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDButeUZYuVz9xzdFYAN5BarHZGSo7yVjFnc9hGt54GNruWZ2b
3502	payment	1397	1397	1678	1	1	3033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qDXpZbg4KFBAunfn57e1f3eA5JzxtJ1M6NGjoGPcwZwzUSjD
3536	payment	1397	1397	1678	1	1	3040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvFmhcxLooctHVNk4zTE79MvNbhoU1ibY8ByyYtrJTdJA6buz
3537	payment	1693	1693	206	1	1	252	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDfxH2B5FjPFGwc1eafHdDnzFYegipnWS1o5ZMorhX5uPS8odC
3538	payment	1693	1693	122	1	1	253	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYcdgdSVcck7M5Juxo8KTXZiDMeNnxPpdUKq2c6TA22T6S3dy8S
3539	payment	1693	1693	91	1	1	254	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZvKmDTdjZnFaQFV7MRrmdY2Mqbr3vE94fRXXFFzrD56Sv7VgSq
3540	payment	1693	1693	99	1	1	255	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYcH2aXRNV5FcUGkntrWsuHe9PpjcN3GY8Lv6uC2HeWkYdqTEpK
3541	payment	1693	1693	399	1	1	256	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZdFqgianzaisgQMRpn87hmDAx17emPMdSgAW79wzZFYCc2obex
3542	payment	1693	1693	408	1	1	257	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZrYDrLLjTp2tdCt7XwBhW9vXKDNRaDGtKs5fAivZREfhPyzNHn
3543	payment	1693	1693	420	1	1	258	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkwn7soy5LGLzeNiBHNjTJDGwePHBwLCtD8U5dpWJu2bnXkDcs
3544	payment	1693	1693	438	1	1	259	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa2KFJB56ykdG27xoZjYuY5a4iAXNw76wH1KDvy6UkEMXFwanaw
3545	payment	1693	1693	570	1	1	260	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYV1N8eanSpnyux7D6XzD9LQv14iC6U37GduWTrVNYjwQp36dWp
3546	payment	1397	1397	1678	1	1	3041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsW8BxeH4EeVs1dwGRBJLFKSwmimHUKoubcemZUL7XNEBNpEd
3547	payment	1693	1693	105	1	1	261	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDPKfXCghuZYGz9ruS1EGMQbDGVPEM8mpwNqKvtajvJSJzG7PD
3548	payment	1693	1693	910	1	1	262	505587899696	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZTHU2MV8CHAVY261yZJJnqtHQnVtRAfYkNzpGGAhHd8ysTtBxU
3549	payment	1693	1693	322	1	1	263	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZpARaYPQZzGcLSoT2DZpYHgRS6yLWQB6ohBrHNN4foRs7oUCY9
3550	payment	1693	1693	29	1	1	264	7039217960	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYc1nbwVRb2JYFJ9f5FECNTx1sGe5SjoQQuyXyF2WnN2DsjgUph
3551	payment	1693	1693	92	1	1	265	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZn157R9gmtmLao5DUDQJLaZmSYBrKdctZ2da9bdyaEti65wkFV
3552	payment	1693	1693	89	1	1	266	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZQCBff7CH78dofUuYuNFKXkn6BygpPrNRqCtB6bQTXgk2TMDkf
3553	payment	1693	1693	146	1	1	267	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYep3WZdDwWrVV5irRUSserSEZvB4DjgTpw8npJRapHN2NZDoDB
3554	payment	1693	1693	251	1	1	268	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYsKJqWVUq3afCSoM8ghW5pGyxxEvbsaUVG8nkQ7Nuq7TpQToX5
3555	payment	1693	1693	500	1	1	269	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZZRG698yUFYB7sS4kA71QPgbvKymSTKii1f2uAVJGV5ebWF4Bg
3575	payment	1397	1397	1678	1	1	3044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqr9zZniWkmkcDic9HXDH1kUCeiED5VqCVxDFvhhYQfNZRW8Q7
3576	payment	1693	1693	245	1	1	287	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZxLG6ZpwZkfemVxzmcQkj3isfwEu8kuRWkcdCLbQDcarVvgYyN
3577	payment	1693	1693	520	1	1	288	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZDpsdyPKNYtGrGmd4RPhaUwW8f7778FP96vaPcN23qu6jGttg8
3578	payment	1693	1693	620	1	1	289	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZj9c2YFc4mm5g9ayF9k9H9HSfyGd7fsvzrVqm8xKriDT1xW7BS
3579	payment	1693	1693	37	1	1	290	65694004451	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZAimpzfCpBvoWFzC9VyqrJuhLzJLtZ9732FJQsqeoH2fmZQ6B8
3580	payment	1693	1693	622	1	1	291	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYaL7mpnSH8Rpz8qQ7p4wDVYtjZB5cN8MiujeZjEKn3uwgGnkjS
3581	payment	1693	1693	54	1	1	292	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZg8MhHM4tic3xBQgYGYqeP92xUJwALvqUf4SCkjTb5YoUPNXhp
3582	payment	1693	1693	78	1	1	293	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ6L3f5sPYCBExYcqV7tkJ46CyGctw7HmgEJiM5zBbemmHDrqAH
3583	payment	1693	1693	594	1	1	294	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZAkY69LaW9z5Adqfxcsmkhd4asuTqTZxoqQK9518BkpqZnUjxb
3584	payment	1693	1693	739	1	1	295	10056025652	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZztA9Kh1KEjpQv7DMTKg9ZkJYmUfoBgxzYhhFKrApiwYbYwJQp
3615	payment	1726	1726	1804	1	1	20	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgw3t1xdL9ARwnC1QE2KdKm129h2hbG7LjErHuEFy9asXWfqSj
3616	payment	1726	1726	1805	1	1	21	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvWrydwUiruxD4bWVA87dqi7X2GS9HgsF3S4biJyvJ6HPwnFP7
3617	payment	1726	1726	1806	1	1	22	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcmXWtCcxBhDFrU3DpbA8FBPEy7DAgM5LNP78FvdPVjNwxzBnu
3486	payment	1397	1397	1678	1	1	3019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8nHqsonogPnUYfpKqXLNvsKSbmgjnxQseP1ENbhBiKzjHFdH
3489	payment	1397	1397	1678	1	1	3022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVQb7HCTyEp4VBCDpPXqj7jViXm72sGWquQe25y2N3AyG9AYo
3496	payment	1397	1397	1678	1	1	3027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWfaHNrqXCPxK3CRsq4bhnnphuhA7dzch4UyUZFcbpuUitK21
3500	payment	1397	1397	1678	1	1	3031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBHn2KcP9TrHvEg7KVNWKwAq48aWmV5MDhRhRwi4SYxySfUDV
3513	payment	1601	1601	1142	1	1	2	1662804100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYx9A2aHvQM4qHEEkckUHw6RXBsdK5izZsdg6zy8VJXwoj1Hjdn
3514	payment	1601	1601	1262	1	1	3	1121760100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYe9wbVsb33uQUyzMg3xf1fJNX53jwm5jzFxPzk2vTDAAY4sgjr
3515	payment	1397	1397	1678	1	1	3038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAG486raGHFAvHtKCVzsPfJUnyZSuvKnv5DzChwJMtkNeppey
3516	payment	1693	1693	304	1	1	234	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZiLHNKr5BEmAzB6YxY6ojRvxejVSBHqcNvo8EHz74Nq4ZqMGTW
3517	payment	1693	1693	373	1	1	235	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaGaGVuY7bvmVLkKd5uueg7CUYgRvE8HbN2k3jVEcXjKMj6Kx1h
3518	payment	1693	1693	877	1	1	236	204190785475	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYyT38BBKgtL5AeLXx9aoyz22F1a7LYC3w4kNswkzHQvP3vKrQX
3519	payment	1693	1693	217	1	1	237	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZNmwyCJrxRTRu8UkCRiMsQs4sS9tL71Q5FLm7XU21WwfaqABud
3520	payment	1693	1693	309	1	1	238	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZcKBD7MQdRoQDVqMYEAwjKvaj7SHMYuYdmcMkskugKB3xgiL4L
3521	payment	1693	1693	731	1	1	239	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYa1gjkxVX5BTdbQCKYqbKZfszYyUBKTEycAR3Cu9grvCsEP825
3522	payment	1693	1693	275	1	1	240	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZgtrJzmrmzMVuz2zxxJs3CVkCXPq9Egaxa9KAuJxYqtC5uw3Pa
3523	payment	1693	1693	138	1	1	241	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZWVP3FCL4VAJ5ADECpfbN2tF4scyFCppQSYBHUbf4QSzDB6LtW
3524	payment	1693	1693	1030	1	1	242	906009184400	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ7REkqHALjTcvs6Xg5aDsFbe9LrXF422irwoaV1Wav3WLpTKAm
3605	payment	1397	1397	1678	1	1	3047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9k51qBd2QjCuZRZzMTayVsmECo9ShEpXA5f957GahYSNTkwZ2
3606	payment	1693	1693	352	1	1	314	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZNzRCC1easRM5Yz9Lh79QjbNM13c2tJp9LcxMBpseupKbKJkfm
3607	payment	1693	1693	266	1	1	315	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa5fEyaFf8zGbrQJEFyobpLeywgoUQ1aWPEoERhB2e2FSb2aBMi
3608	payment	1693	1693	600	1	1	316	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZhFjNYV6W3Zjd4dgGhQgwBmUxpSKoNpBTMj7TALFEQY8EwBmy4
3609	payment	1693	1693	691	1	1	317	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZuLXvDXcdNn4K4eTjgkDWAqHDQJRUebZjJFFwk39fdJWHySZoD
3610	payment	1693	1693	377	1	1	318	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaC9bJc2LHmmaN7BTyCEs1Z1q8vLS5EAUYb2aiTbPy4UkTjr86q
3611	payment	1693	1693	63	1	1	319	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZoTKSe71p4ZfmPypadggJ63U5z7sV2JRaBvb1zsiKa4ePFmN9d
3612	payment	1693	1693	103	1	1	320	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZEmTU2vrgvPMWgHSqRi5vjpeVjV4Jve4evLmBXWsfpNY8pMT6C
3613	payment	1693	1693	361	1	1	321	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYakbUboMuaYnzjAuM4ZbpT1Lq9gWsANjxvaQ9RtiYYQK6zD7FW
3614	payment	1693	1693	82	1	1	322	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZT1YjmjFTbdNcLjbupSmSxnzG3SsdLGkFRmPvnwaeFLKEnYkaz
3637	payment	1693	1693	878	1	1	336	204190785475	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYuuR8ccDCW5geQbBsdsPYUQfiARaQCAyiH3bZJi2qLqpJHFwZd
3638	payment	1693	1693	41	1	1	337	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZW5VwoyRYe46hV7nVhHZqwVFS9b7jVJV4q85NYGAvSsgXNaHAE
3639	payment	1693	1693	308	1	1	338	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZkG7x9UFzrzhPbSThEdyqKcAN91bkksQAJJbc9Ek8dt3Bsr2Cv
3640	payment	1397	1397	1678	1	1	3053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCx8eu7J4fpLZqLGQG7uybkMn5JRV5jh1QZsg1Upcu35gPu7c
3641	payment	1397	1397	1678	1	1	3054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBkhtLow2tJihvbYu2TSyS97vkufbXMBHxiZK3H2m7tZxdzXV
3642	payment	1693	1693	237	1	1	339	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYecpwJsRXPTVAuATdbA6UyTGRQn1tiPoyCegfbQijCwSgFmfjF
3643	delegation	1769	1769	44	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYrh8j6T8P7V5ZXyGYixzXNAKhqYWMg3BvYj3di5fLAX5bKNh
3644	payment	1769	1769	1769	1	1	11	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3qek736KTmJxg4hDCEULnA7eBhJ27389JVZtWrPBcU4YqDBU
3645	delegation	1769	1769	44	1	1	12	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN3oMXuTzqKP7Dhdjf2LoGMWi168smNDCtZ4GNB5BwEPyjFaZ
3652	payment	1726	1726	1808	1	1	25	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4buYuLnqgH8UymfP6d8bf3Eq9Pnc7h7s6kQyLrXhqdfqqp7fZ
3656	payment	1397	1397	1678	1	1	3062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8tNHAnJEkafAyu5LSY7oXrJEutSVf9u3GosPXb4jVuXgaEj9
3661	payment	1397	1397	1678	1	1	3065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXY3RbfYV6Fds3GQWLD3HsHxeBCz3JKxjVYrR3k1Wpg1zGJ6Ey
3487	payment	1397	1397	1678	1	1	3020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJhinT7Dnqux6jYDhRcR9n2HgGpaBM3XFyeeJPe1DbHwLDZ4W
3488	payment	1397	1397	1678	1	1	3021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdhwtrsWAF1vWzNDHGrfTrMwLabgtqmSgieaYLRGdHNBD6oWk
3490	payment	1397	1397	1678	1	1	3023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1nf5f1qTfzLfDpr7FrqJoy1G6sxc6E3RYxxP6XGpqvZzXuLK
3491	payment	1397	1397	1678	1	1	3024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsTDbvAj5itUxhbJ1E6GbwyDJyfrnuywFsLGjgk1ydPxRyqXH
3492	payment	1769	1769	1678	1	1	8	100000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpPmxThyKMZNLnQtGJSPN6PaaxhNtcL3pmTgEp2A2oztVbd5N
3493	delegation	1769	1769	1407	1	1	9	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3iseWsyAzHKQgAejtJTmx3tSxLj2XU9SnCEp8WGLKvinmgLZ
3494	payment	1397	1397	1678	1	1	3025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9c1i1tx7tkmVHfQx5pCWTQB5aivxs1kv3xKFywpZwGWKxUJ1
3498	payment	1397	1397	1678	1	1	3029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXMUpkHsHXDBuovwF3fr6cgGvqPNbVmae4UeoKiA5CLDB95Rq
3501	payment	1397	1397	1678	1	1	3032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUxAqDGtMiGXAod9TMfNPeECnCkkE2Yf58eSZ3R4caoKiWmhU
3506	payment	1601	1601	1388	1	1	1	3126564100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYTwqEsoTcYmXAy5EDQsthn4MREoRDdTozgSwRK6EkreDPviF1a
3507	payment	1693	1693	569	1	1	230	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYYAVbq5wk9nz6z3oPP9WF39DHG42Qat5xAHLrDGvLq33Ab3RCm
3508	payment	1397	1397	1678	1	1	3036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSdqyrMtwyXfzH5C4S3DU19fQsEB16NvxF6tRuGGXVkZp3CT3
3509	payment	1693	1693	745	1	1	231	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYTu7BxKJvSU3dXAy2EKRZuRyns9d8qAhWLLmCYUwcz2eittnAc
3510	payment	1693	1693	225	1	1	232	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYVVoMzgbg7ugR4fy3w7bd7QCAvGZwfa19dQtyN3617JyhnjxsK
3511	payment	1397	1397	1678	1	1	3037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Z95FVgmVBjBZCZMm8zCtrcYXwquzXvmgw62DF7XVTHWYGzfP
3512	payment	1693	1693	191	1	1	233	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZz8amXMzfSuAKncz1tq9ohmunZztfYdNZWo27RNQcTZj9vFXEz
3585	payment	1693	1693	163	1	1	296	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYr9fVWaaT4aAyQpGQTpfV1noBx9HFPiEtcrFsxghoqog9uk2N8
3586	payment	1397	1397	1678	1	1	3045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKtrFYANVbXqzRDWTANYka192rPH9ok8tFPf36sycPgxs3Uxj
3587	payment	1693	1693	1150	1	1	297	611302450224	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaBAsH2MEGHDHv3YMfznywrMcPioh2jfMRGXj27jfsX44c4GepA
3588	payment	1693	1693	452	1	1	298	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3UjZ8FvCDokJruEiA6EMPUnN8idouy8ihiyYovdg5rTSyRrDm
3589	payment	1693	1693	193	1	1	299	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSx2GGYrFw3iD7cY9xu3bTSP6FchswSYZGii8vCmFcDumWaEsE
3590	payment	1693	1693	391	1	1	300	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZTL7JgYBuZyiW8rVVTVmxhxKhVEtb7e5gQ8pN5hRTMiBXVRE5u
3591	payment	1693	1693	593	1	1	301	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa7yCSEymLUwmuQDyvTU33CmfPtzDRYXrA68r9o8evnWpep6Hj8
3592	payment	1693	1693	660	1	1	302	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaJHpuLChkPHxWJ2GGpQvzeipG2pMAYBCrYN6Q6nFjrLTfutqTw
3593	payment	1693	1693	6	1	1	303	32740408344	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaL4HJQw2HTRpvwA8SUigJnEMZK2oZmR8sxh8CSdiyDKH7bKnxC
3594	payment	1693	1693	504	1	1	304	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYWrW5RvE9UKwVww28TEyN7PfwKabyyqvffrWpJurqLZuesreMi
3653	payment	1397	1397	1678	1	1	3059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTum67y7pA7zzR7ooa86C9hd843iKNbLoeEvnZQKqaMzCowLR
3655	payment	1397	1397	1678	1	1	3061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSp2Ymwc14CztTv4gDqQvR4gJaBWddxhDmT37xQcRzS8yy8q2
3657	payment	1726	1726	1809	1	1	26	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyF9gyeTqRw1fsCGWCNKPQLqGBQhRJz4pbvAfZk5ZKAG5wWzxA
3658	payment	1397	1397	1678	1	1	3063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXihw7hgfQ3rdm7vsjSF7jPsvJnyn1agLQGJoiMGk4UcvKpdzy
3659	payment	1397	1397	1678	1	1	3064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjVUsL97EnGtSoqnPWoo6derqZrGWzZcGopdABVYhgcyV62ub
3660	delegation	1801	1801	1537	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xXNexoLWbo5xsbp9gX2moBEvVgvWqFVCauJdVZ5RVB8Eu2UW
3663	payment	1397	1397	1678	1	1	3067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fuk3tibHSmTEhybPUafTSR9ppTtSQY5SxPKTdg9HJt1GXNv1
3664	payment	1397	1397	1678	1	1	3068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79NGU9jYWjDCmBLnX5pEFdkmeJJyneyV3xtDydBwk7D5CXpfd
3665	payment	1397	1397	1678	1	1	3069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqQZfW4efcFVuKn15mxgZGRFu42Y2UMkbyk9LDBi2pkTJKBFS
3679	payment	1397	1397	1678	1	1	3077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsBSxbLzamYrtDAcC18MXKPkDAyfLTBiK9vRprsqQ5p7Z7NcF
3574	payment	1693	1693	421	1	1	286	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZP6GVDxuDQQTRQFnhA2CjFYuuHoymAHES4hmwre7FgfKStuAcF
3595	payment	1693	1693	658	1	1	305	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYeRuvftuQWRf7UjrAeQvmQrNiuXcW6ZDHR4EkwhUnPuo9KxV9Y
3596	payment	1693	1693	1276	1	1	306	1703448631520	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYq38x45DxL56C3nTPofmRipwggK955q8SibvrjCcqHNnPvprdc
3597	payment	1693	1693	180	1	1	307	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZeAPwc4cfAZszHTSyReaf9VLZUpR8t5HD8WczUpn6WQqyFFWPg
3598	payment	1397	1397	1678	1	1	3046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgfeqqy9cesncT4wpA6xgbJntfH3YjuLwiVpwh3qczwgKEyZz
3599	payment	1693	1693	652	1	1	308	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZznm4Bhs2KM8teMdaKwezcjhAJwGDGAJ82sHT6oJddJup3KXm4
3600	payment	1693	1693	893	1	1	309	308541912361	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZEaEATm435Sf7W4eXziQwgtUb6t33VKZjDMCE3WgndspWqdMBV
3601	payment	1693	1693	390	1	1	310	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSAmjajMuTcvFmt7LR9BUg1PSrYbAPDn4WCWrJborsGje9FWGy
3602	payment	1693	1693	353	1	1	311	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa1zKjSdjnhrjozTeoqg8ri5frCCrMwFJhcAaB68HvPQxaHnXUj
3603	payment	1693	1693	108	1	1	312	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYtKPsUCua4qhH5iQ1nhAvzp8DtBYoQ4NznFYYLTTk7KuVgnQG3
3604	payment	1693	1693	601	1	1	313	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZqHxxDidzEHwCpnYSamCPLSSy8Losoxgypa7bLb2R1swWaapF1
3646	payment	1726	1726	1807	1	1	24	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHfU4UX85fyEEzxd5CcBLLQt8bVYzEpz9bJLwgkK3L4YAjcVU9
3647	payment	1693	1693	1778	1	1	340	1000000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZrKCHRyMLEMAviAJdQMgCyVHzueusUiWHfrswpW592Kdwm5FMM
3648	payment	1397	1397	1678	1	1	3055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3jsLpTkjXGXbtw7t19rKADCrevLH5UEHuXySJ9SocEh9xSyX
3651	payment	1397	1397	1678	1	1	3058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJAdcRpUV8Aq6wyPN74bFFjXts6L8Ktd82N97pnwumGwghAjp
3666	payment	1397	1397	1678	1	1	3070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqD6ksLZgNyaTv7pvCynXgjiTchuU2NSwkCX1BxrccPA9TiQn
3667	payment	1726	1726	1810	1	1	27	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwYcogQzpEdXYULErga6vZJgHe5RwaE3YaNCK2UUL8j1BSndu6
3668	payment	1726	1726	1804	1	1	28	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhsgSQZNX1LW5ArqexFxxvTjtCSB2gevg17RRDw8cL2x6upsgy
3669	payment	1397	1397	1678	1	1	3071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLRW84RnePJsFhof6aWN6dcCTMTAaGR2Q4js7hogPQ6k2cCL4
3670	payment	1693	1693	1811	1	1	341	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZkasfDoz8HdasvqfDuidyuYLLiwmBmSDTbcmzJaggiT9MyJqDZ
3676	payment	1397	1397	1678	1	1	3075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWYUzhTYmr1bWmFDyAk4oWFZJQ3uV9PCR4CdXy1PMYdu9PHJi
3677	delegation	1811	1811	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUGLxyNqaS6i7s7EGAsQgBF2HoTwRMsuCh68EBjoXMXEDfRjh
3618	payment	1726	1726	240	1	1	23	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6LMCdSRe8VsrJYo3xxQqdYsuwUYG5KBPcXAkzaYXdeRM6fR4L
3619	payment	1693	1693	261	1	1	323	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkkzjCPEbQcDuDzxy54BhRhbjT4BdP3khMtA95nuSoV8YX8ZdV
3620	payment	1693	1693	201	1	1	324	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZj3WAVJW6byPMyzdFJmd5EnUJbKNp9bdKvPCxeWcNELGi7GdSU
3621	payment	1397	1397	1678	1	1	3048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WXNU35e5X5ZwhbMt6d4Gxww1jDMSFz1xVjRGqfvQhUXHmqdj
3622	payment	1693	1693	453	1	1	325	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3aMg8qs9WCq1vkc6Qd6uXvgKZvKHsjjbG6pmP6JaFVHyzmRAY
3623	payment	1693	1693	499	1	1	326	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZuMJgJUARVtLhgJ3NzXxgwJFQZMcB4oSNiDZV6C5DMoRCE2XWL
3624	payment	1693	1693	35	1	1	327	19307569271	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYS2oKXjUo8NTtg2T56dBo2bJpmKP6mjXFSViZf6mMBqrw9QCmd
3625	payment	1693	1693	383	1	1	328	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZGT37hJRsg8K8whBBh89SLX3opgmb5ii7nPfAJ38sFdmweSVBQ
3626	payment	1693	1693	663	1	1	329	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDPASB285wXHN84Ywp1ym8Vcjr42DfaKVg3KTxKrtMbXgZg5tx
3627	payment	1693	1693	127	1	1	330	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ4rPmtGJD1uYPn4kg32QMp5Bh8FoXUuGyMtfPjSivWSnRSKJvg
3628	payment	1693	1693	680	1	1	331	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYX7MuZZLSzNEX6ubtPR9XQycKg4bXvuSmHJW1cR9JuiRowdCr2
3629	payment	1693	1693	49	1	1	332	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYtRpCzt14hjqHRYsUxqWKTYcNKSY6dQiTojV57zZ8eTm2WELPZ
3630	payment	1397	1397	1678	1	1	3049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2dN5nSMGk7q1Djcytx3vcSoP6ZU8i62P7cjsxAWZyxbndTa7
3631	payment	1397	1397	1678	1	1	3050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5j6hVevYWg2TxecxbYM81ej1pzp5qssNz8fMSoP22xBW7dBi
3632	payment	1397	1397	1678	1	1	3051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuTQf6Xv4zzCf6f12GVtf6qJFyo9ywrrQvFcafnsN4qEn9Ac8
3633	payment	1397	1397	1678	1	1	3052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcZqsQw4wTtboSocBLrd6xzpHLpmFf676AhLCUZnLwkZqLrCG
3634	payment	1693	1693	112	1	1	333	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZrq6BSxjakdkfakhdERP54vHK9odkE5FfxUfRLEovbk9noiGGp
3635	payment	1693	1693	186	1	1	334	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYf73pokqB1jFfnmgvMGXjCqFrWSSmUXKZXhLzURaVLPCh6nehM
3636	payment	1693	1693	551	1	1	335	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZarqWsMaFQmPpjgRq2QYSv4fqBnZ3B6BinZW9Bxq89jwrA988N
3649	payment	1397	1397	1678	1	1	3056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKqaGgYPwUXNbHuGFebDbx9iAoZB4QEi2wiwAjcUfDjGxhXSi
3650	payment	1397	1397	1678	1	1	3057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRA559ksEj8NmbEs2jjCuZxbXhbjG9yPnpR699kRCSYuuX9vw
3654	payment	1397	1397	1678	1	1	3060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6q9euP3pWdG3iCB9vZFo6hiDjsiw7PyxpYLAqX3RB2uQDBQg
3671	payment	1397	1397	1678	1	1	3072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cBBMiwNCsZR6a1kKutqpeCyvgU3yZFMsVkrbHph2q6Kt9kE1
3672	payment	1800	1800	1812	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGidA2dyRS4yVL7BRaGjU3KoiXdJB8DH4gUEE4DLpkmw29HbF
3673	payment	1397	1397	1678	1	1	3073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36EfhSZavLMupsZqLtuWYqgcagmEifTKwZ5Vt9ShgdZmUr4ty
3674	payment	1800	1800	1812	1	1	1	0	1000000	\N	E4YoBrw9t4rJ5G6hA442bnEiuu5TJB6ppmeZjydc16D3BurVR9kzq	CkpaAQTEzK1kHK8wqsEVW7i7Y3dzSPgtth1x6FTEV6zsAYQftzGxx
3678	payment	1397	1397	1678	1	1	3076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGsfbaSS8XVVQ7JJWXstSUY4dE4M4qxVoxmGQUQE6WXSiMDNs
3662	payment	1397	1397	1678	1	1	3066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFmBvuMeRmts8MAzGGb3Sb4A1QGFkfbwYDyQ8gc5KJsArPLpW
3675	payment	1397	1397	1678	1	1	3074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYgtoE2eP8CsTUDAZSpefxwp7Vnj41VuBUybBtvy4TjpmAPbX
3680	payment	1726	1726	1813	1	1	29	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCScZ5G6LTPkmoRs7bYC364bjAKm4Uawo1t9EYLarojzziN3Xa
3681	payment	1397	1397	1678	1	1	3078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBu2QrcP66p9ZdQ8TU61LXv4NzSuqJptvSD2detVRtPQVfSZNE
3682	payment	1397	1397	1678	1	1	3079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtT5r5H8AfmVoAwgWA6ihuE9EWiCeX5aBTeoYTAGTVDw7TwcF
3683	payment	1397	1397	1678	1	1	3080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6PJBKQFwDQkz1oqKkoEHD1XobWqorvLQR7SLBoAJ5xKEd7Un
3684	payment	1726	1726	1814	1	1	30	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm9154YuArToRXZWSYK3dUwngR8CBtv33CrcAbczqh4gRgow1Y
3685	payment	1726	1726	1815	1	1	31	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2N7q3Z3w94V7MLAAdnFU6ziTTJamtfJU8CunsM4mydbMZjGxt
3686	payment	1397	1397	1678	1	1	3081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaw3fbyfnuDqQ4NY5r3iou9TLXRAirrj4tx1RoPLg3ed41FTGN
3687	delegation	237	237	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTK6DPEiGh1Zz1M8vVvQaE2EQaz1L46Njoav9FXkmNfqpSeZi
3688	payment	1397	1397	1678	1	1	3082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc8toDn1dF9tjF7cU9c9p6miu5d8SGX88iwjqjviADvQkxaJy
3689	payment	1397	1397	1678	1	1	3083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMAMPxEYNBhosZqAuge8pMdMTAtPz5LMigsyuDbuY9b9xM7S5
3690	payment	1397	1397	1678	1	1	3084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBcA1etydpybh9i1kkPKHvgm8Lz1kTTQnsEwwGGs7KLrvy2c7
3691	payment	1397	1397	1678	1	1	3085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbTwLsmD8vnBNCtnrXnQyHfooreGn9UKvMrc45xg2FfzFZoBq
3692	payment	1397	1397	1678	1	1	3086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHVpFXL5QkyT1PLqrFj2oj7KirQsurpBKS6hrGMMdCytEHxQo
3693	payment	1726	1726	96	1	1	32	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZjZS9aq19qGoT2sJ7Sy8YH4s9HMKz5xswwj6BnK9rnCZ2G55Ex
3694	payment	1397	1397	1678	1	1	3087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjRqFTFB23mTrqMFkQ7jLY1KVifZXQR2a9uzFQajE9x3c7hbG
3695	payment	1397	1397	1678	1	1	3088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtR1XarcTfsczrcKcDQVhDQRjjqjWaxJH2dGCmoRPq3MBvbLN9
3696	payment	1693	1693	1816	1	1	342	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZ79G4FVHbHHvVri6JY199VGLDtSMKCnQKeFmkRcC5Dw8vj1RiN
3697	payment	1397	1397	1678	1	1	3089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6hgg6TLRuyRxALg6fjAondJ5EeLev1ywQn4VcFCmEC1azmn5
3698	payment	1397	1397	1678	1	1	3090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XKxfXtx2FRTcDJT4GwCewVyrU7o1Lwjnzf4EKB8QAPPvEQ8b
3699	payment	1397	1397	1678	1	1	3091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXU5gJqrJ7AGbqU197pmETk5Eh2a8HLn7jBWxgYYQ8MkLNDTS
3700	payment	1397	1397	1678	1	1	3092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbva3DxxMCNLcZmg4zuJuyzpxijZCZBUGbAbLyrpckgxAqHLj
3701	payment	1397	1397	1678	1	1	3093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDN6TbJ2RGeYqJatLZrZ9GEqXNJKKrjacZ2EXT83efXUFmu9wC
3702	payment	1397	1397	1678	1	1	3094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsE76y7Jdnqj7wMa3b8Wnoi4KBVeQLFUGcT9HAr8kpa59vasK
3703	payment	1816	1816	1816	1	1	0	0	100000000	\N	E4ZPtX3pWGqoSdgMGBFQRoA8QzCXi2QnvvNKr6GGRoqmzNWLRiYnu	CkpYnH3dow9qYyzqfAqKVqeq7vaoUXNcUFZWzBnQa8sDTzwsREbVX
3704	payment	1397	1397	1678	1	1	3095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CSGLM5vHcTwwSL8KCDzyfKHKm1vsA3NHH8WYedkiG1C9m6jg
3705	payment	1397	1397	1678	1	1	3096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfodPdVE9CQPE9DJ3P51XS6xUH7UsktgVKPam3YH1t4fCH4por
3706	payment	1397	1397	1678	1	1	3097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YRrNXFq5vAEBMsWV82q87nHZQZJdThTtg9wfs5M9iGr3b2xM
3707	payment	1397	1397	1678	1	1	3098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwFJCnW9pSAYwYHB6KAf1DPAbxDbPaDEidsQc3GxUyCeJ9rvi
3708	payment	1397	1397	1678	1	1	3099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYhb8vSdofkxwbbpbAEeHv3qo59Q6EjED2NkUMyJ9DTHuYZkN
3709	payment	1397	1397	1678	1	1	3100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWshyfEuxrqqcNU9XoY6xsAdy13Pdup4AFkhDc3TrXiPNLDZks
3710	payment	1397	1397	1678	1	1	3101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UGp3ZASzCxw8n6Ay5Uv36Qm91iCmwkprF9uzqzpSoU4xrMqT
3711	payment	1397	1397	1678	1	1	3102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gz8VxtpKP4uVMSd2nZDWC5BPRZhQzCKTQyCFo8Wphc4WkNdU
3712	payment	41	41	1811	1	1	0	153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpjAi3qr6Q1s8xf3CgUQP1ADmXKq65XrARZNz2Akp5tKzubXP
3713	payment	6	6	1811	1	1	0	75000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3SxroH1A3P3BnAqk7CyXY3h6cG5me7RZ2p6pvga8AvszJiaM
3714	payment	1726	1726	1817	1	1	33	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3G2kNxDbAKyjwMuR3r3ryxPbvypT6hG6jUvJo1xfUE3y4tsaR
3715	payment	739	739	1811	1	1	0	23000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKqmo4U7fvGi9qdvrrvV7sdmHrfAUoiUGKXGRxaE7ewkinHdY
3716	payment	1397	1397	1678	1	1	3103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZfUirjG9xAff5XizZE7XGTjjLyb5w484a8D3Mkv7ZTsFkqP9
3717	payment	1397	1397	1678	1	1	3104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaHJ24Dihq4TXx6hbWMdbPbBL2PRc6qGMovYPpTs4bBBr7b59
3718	payment	5	5	1811	1	1	0	15000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkjvHgAamTmSSbirs3MyvDZHhMdW8Zbb2H9qtv4sxtWaYiBy5
3723	payment	1397	1397	1678	1	1	3108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZizWDakTp5aUXje3ievd5dFKbD34s8NSqUEvEZ5hGE4ZQUzf
3731	payment	1397	1397	1678	1	1	3116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqiCfEQu21yH4GaBJdJWNqD5gastcKmasc3WtkbYE4PDKF3HL7
3736	payment	1397	1397	1678	1	1	3121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAw2mpwm5b3d4XJtVTGb7PskQkCXgCLRECcmuh5q9wyNwaf5Cf
3740	payment	1397	1397	1678	1	1	3125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgh9UFxbnBP997jXGZeygmE8CfhQTDtyw4RFhRNxENiY9rN4hC
3744	payment	1397	1397	1678	1	1	3129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRew1QY11cRjX81HpuLfdprwU2oftDqgiTiAuY4pXZCeaY1TJn
3746	payment	1397	1397	1678	1	1	3131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfCa4Z8GGZwU9QmU2xHm77U6fF9N7G2mrUoABR8sT4eDkbAMR
3747	payment	1397	1397	1678	1	1	3132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkdjDmaE4qjk1G48HkkHSg4HmqLZeWgTeDa8HjzXz3VD6n6St
3770	payment	1397	1397	1678	1	1	3142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyNmVLHPL4tmFhDxCYH2MGu9VzYED86wd7paqjVhtB6VhbxYF
3777	payment	1397	1397	1678	1	1	3147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKFg6KK5awMk3DBaomRwo2fZLD77KsgSbqHjoiUuEKE11D8Uy
3780	payment	1397	1397	1678	1	1	3150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZmsgcDPw3DVqUXhcD6ZcaNTLoGXD9Gp3DXJPTbTi6YZpnRXR
3781	payment	1397	1397	1678	1	1	3151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLc87Mse7bXz7pKPTwY3xkd24wT52q4fdGxG7JSkQR3H2ybET
3799	payment	1397	1397	1678	1	1	3167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcSBmehscKR57mej56MQbH1efnDNbNWmEYaYmXASQki7taPLZ
3804	payment	1397	1397	1678	1	1	3171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWWLCeSaUUuKZcEMGwMoh4h7MeZAE4jMJk31mNfLp8XpuTmii
3805	delegation	748	748	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGLEe8xDqTLTweFAYSxPDBNaXQwGWJXAq6kDWW25zUU6kN1ik
3806	payment	1397	1397	1678	1	1	3172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvPJXTw81zvg84LbQnVwtvAM6drKYYM6KDBqB3y2RXnXjKS5d
3812	payment	1397	1397	1678	1	1	3178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTm4etsAAfjpJQMjLSqhoT6c8ByEijd53qUPVW8CTaGZXXpBK
3813	payment	1397	1397	1678	1	1	3179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WGPwgEt79pAPZRzrDiY5Hu5T5sej8zchX2UcrWizBRkdBCJ8
3817	payment	1397	1397	1678	1	1	3183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F4deb8Q8aQvmjf5RzTiHy2N4trYgqhM1an2z1DrnuYfkRNi6
3821	payment	1397	1397	1678	1	1	3187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPQvNrqQm6aqWxatRmYvM5Ah6NvNX2rijMrTDqu3LfcUzqz51
3826	payment	1397	1397	1678	1	1	3191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfh96W89ZbxxzYqkbLNNna9NwUVpogG2tR3Hm7em9cLm2eETG
3828	payment	1397	1397	1678	1	1	3193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25NissukEWwvNVu556kS1AW93ViYuSVFcUG5m6a77ZbXUJH9B
3829	payment	1397	1397	1678	1	1	3194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zT6Wi3UcyEJs3SB7FmrewmpkMJBSQbyjLVwgepu3MSepccTC
3830	payment	1397	1397	1678	1	1	3195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84osczkmoqq3BKCbeHbpGB4eV7NNpuxqeDPh2XP4YrqRJknQu
3831	payment	1397	1397	1678	1	1	3196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ94Uom8F8H61jcgf5b4fKVfCoME8Q8hr3kMwkveHLmrETpw5T
3838	payment	1397	1397	1678	1	1	3203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPcJmZfiovTWNXkufiE1Kw3DBwhfe2y8vbKxWZAkNNvQV7MsN
3854	payment	1397	1397	1678	1	1	3212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWewMYiALVgj89dQGKDvTa9XNYputq6FLAvZhq6AL3ZHdJbYX7
3858	payment	1397	1397	1678	1	1	3216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYRYKxTCSgm5Rdj938c7kZotwRXqmTpNYHYLxJWRzk9rcW6ZM
3861	payment	281	281	1591	1	1	0	400000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ExXHywvubT2qHyh5rh2VgH9DPf2Xeba2Xd5U6Lcitarf8Fdi
3862	payment	1397	1397	1678	1	1	3219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHpsd5ti6BwiVy1t2BwxPr5gtz9Tc3or97K4bneaTAimUxzzA
3878	payment	1397	1397	1678	1	1	3234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjSMYSisQQAM7Vgrko4LgWhr82j2rvhw69LHk98PVYjcX9sU2
3879	payment	1397	1397	1678	1	1	3235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjTe9CrUfv5dPSYTNVtQnMnD4GQcmidgGLwwRqx4JHWz7wWc3
3887	payment	1397	1397	1678	1	1	3243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1UUEpJgdt6fhjM12fPxfvepRbzM53Gvn8VtVpfkDyQH5njEH
3900	delegation	1818	1818	1492	1	1	0	\N	11110000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjBhdxdDdCSPq2ywCUbi9zEbnkfuE1JxTDRPKtzZ332EdHS2G
3901	payment	1397	1397	1678	1	1	3254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGJ6o2hUSp9VDePZ5WFGESgFKUtf4Wkb1ok2NjkRFXgCn1Gn1
3902	payment	1397	1397	1678	1	1	3255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsF3i9d52rAMKfdBpdacnozyT8McCBzpSrnrTXqWV2Zdvnh68X
3719	payment	37	37	1811	1	1	0	150000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq6fpe1jegBRtsjn7kmyF5TGfy6AYSomq5YXJocddiYqX1TWz
3720	payment	1397	1397	1678	1	1	3105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NSbuEaEvWTbagG7N8xW4aTmY9Rp7fEq19NfYTpvXtpDWyUms
3721	payment	1397	1397	1678	1	1	3106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCa6tNLB1AprfYvVDpDkNcZvUgjfS9ptVXgTcKq2ofgda2xUn
3722	payment	1397	1397	1678	1	1	3107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkctgi2BYv1LLWRGaH6zoT2YixYwdHf9DfmvQyXfVgd3g7ehyY
3728	payment	1397	1397	1678	1	1	3113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yh6Q2dCYFt16YYPFLY2Co1sNjDywh3Gi9TqEz4cUp8UETcxZ
3729	payment	1397	1397	1678	1	1	3114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9i27w5R7seYEiJArak8dvhWSRqjg9GDrXZUMn5HDFFmg9h8U
3730	payment	1397	1397	1678	1	1	3115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdcPAkTZdE3JBr1sAnwREDfzH83EvcwTWpH821apesXxFvirm
3732	payment	1397	1397	1678	1	1	3117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHQjAFT8UHpB6D2DPXkhTXPJy8a7fffeLxHpB5ep2q8R7SkL1
3733	payment	1397	1397	1678	1	1	3118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynrbEx8NVHavVSbfzRj5sYosXLogNtSinBqWqvZRBfNxHHCSz
3737	payment	1397	1397	1678	1	1	3122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5JEJjP2uBy6d98TtUZHR8cmVvKWWeQtH3tYWwWCG5xh5Jgys
3738	payment	1397	1397	1678	1	1	3123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJE8XNz93F1wTWgnZFwYTombJg4PtPtz98SttCyKd2fvXvuVz
3753	payment	1590	1590	542	1	1	3	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4BYa2btM5kQCceWBN2Z32VVrKnjinirUqM58Yn989u8mMEc3
3754	payment	1397	1397	1678	1	1	3137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTpGkg3RumJdrRo1GDk6aRsNFv5oMD7NchdRz9Un6wLPVANKc
3756	payment	1726	1726	1819	1	1	34	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqPvbQtJsuRthikeX6zMvoqPx3CDdECWXABt2smxWqEpQCF7Eo
3757	payment	1726	1726	354	1	1	35	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZemZGYGbPprEyAupCzCdzqQ4hhMP5tcZufTjeoFe1o7Tz1qiYp
3758	payment	1726	1726	354	1	1	36	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbBB8yfsj2HQH1SxzmWZbtzcjtuuxbmSbmEtMLU5JMEv6crjx3
3759	payment	1726	1726	458	1	1	37	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNWjGdiHYNtji4xwW8oZv7Ymzq6mJS9nHBybL8uYoJi2tytbvc
3760	payment	1726	1726	458	1	1	38	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdHApNuDBuMksyxTmJrf4AwDwQSexCrwHkBHf4rttbtHjP4Zhi
3761	payment	1726	1726	711	1	1	39	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZPEH9hWsebfPUWVDDjg2FZNHodfujS3GpdpWsKmYAoMHgvRqo8
3762	payment	1726	1726	711	1	1	40	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaFQnPRvZCi79bk7bfkJetQdUWPkGD3ycLg5qhPPQuiZfoZALvt
3763	payment	1726	1726	748	1	1	41	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3AS5qR6rQCB8thhujARJ9TSYXqbjGG18heW7hZRf53pae1iAm
3764	payment	1726	1726	748	1	1	42	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZothZvHMnrNpVmZYL13iG8YuvbrrtaLFVDUp1ngZiXv5MhxVCB
3765	payment	1726	1726	1488	1	1	43	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUcbGwf13HNoBy6ZTiy3VDgmdWbSqnirWWEb2f5rK8z9kZeZUx
3766	payment	1726	1726	1488	1	1	44	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZN9RsgB5VZ8H4qNBBpnGy8Gav1kf1byQjQB51YGYtXa4BRCXG5
3767	payment	1397	1397	1678	1	1	3139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t8MzC4UU1VBapyqz9ivhPwHMNVZad9iA3NScMYPhRdivkjan
3768	payment	1397	1397	1678	1	1	3140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvvr7jCwmyVRNpDdJsH6qu1nC3EFJXQX4vug2ngcMZJkSmCXF
3769	payment	1397	1397	1678	1	1	3141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Acpdi5cK3zg5ixy44mDwPTxJdua67VeUV7AiiR5SwE1o9Sxz
3772	payment	1397	1397	1678	1	1	3144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbitc9szeQjG18kir7DeAf8bxpJKBYzPRqUsLjXcVVyfgPaA4X
3773	payment	1397	1397	1678	1	1	3145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHuBcbJs6ZuR9ZksBSnfPq5SfzP3Vgktw92YBmh9tja2H2xUL
3784	payment	1397	1397	1678	1	1	3153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1JzDn4MW8i3sLJ2kkjLPCaDPqpFAhySoYAEh8c6tx7rXc9m6
3802	delegation	354	354	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHyaGbz83ytHyxXpKmeJSv91osNb5eJVSK3vcjhJXhCZnvWEa
3803	payment	1397	1397	1678	1	1	3170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds8hJUwb3C1mz7gneLoTjFP5CieRbT2wdYUWaL2D3te9C2cj2
3811	payment	1397	1397	1678	1	1	3177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK5UXYGKgJbjxf2nEiB7mc1risLCYHFrx3pFvSaV6EZzjkabN
3822	delegation	1803	1803	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1NbdQMETRpurLJftPiWnwWpkXTGHhaUGCuGnzMBHDquPyZ4W
3823	payment	1397	1397	1678	1	1	3188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidF9BzMZZmYnjU1L5p5npUWJCcJRjKPmZGrHAgaGiYRNRYxp4
3824	payment	1397	1397	1678	1	1	3189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXSdZ3KZwKmTaWmzFEMwcMDKj89R14nbniQMzY5oRtYE1rhyJ
3836	payment	1397	1397	1678	1	1	3201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpa92gB6LvhxaiSnUwFwqmrgv2o6tZfsNEM9vBW75jo8kRNro
3837	payment	1397	1397	1678	1	1	3202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQr1bU3jvjbbKv2wWsCnzL93pBKRzh47TKiktK5MRQ6Fm9KhS
3724	payment	1397	1397	1678	1	1	3109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmpmvapWYDEfxBAJenb1cjRStPN7cWgcRHoxV2f1Ro2V2bRRK
3725	payment	1397	1397	1678	1	1	3110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDNUEtJnJCjmFtupTefW3ALqQtra7QVYjB1WBn3f2kyZ9tiuJ
3726	payment	1397	1397	1678	1	1	3111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyGQ7TtBRKfUG2R5vP7Fh6WGL3DCaVC4fDsf3pETREym2q3c3
3734	payment	1397	1397	1678	1	1	3119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ovEMVREiGqdnESZaPbd7NvmnAJpL6Qnr9mLTfWgFfEQQL1VY
3741	payment	1397	1397	1678	1	1	3126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLmw7DrMT7hPTJuQDBAT9BmErXk3ALDtSr1en522uJL55TZwQ
3742	payment	1397	1397	1678	1	1	3127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVspYMYRwhwNBeMb2AuG3EhAKCdRAvRtEGxt5JeYZhGkGh78T
3745	payment	1397	1397	1678	1	1	3130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9moXs26PW8FmzniMXSyrj4qDBKFimX3k2oQKkcqMc36zrYkiZ
3755	payment	1397	1397	1678	1	1	3138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY1UjgemaFdWehW2BwEqQG6zbXyvxnJxianitDRcom9Tshq9x
3774	delegation	636	636	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRE7rSvJAiT1Vh5nQRpgaffCmje6PDUFURzRYQVePpwouYydxg
3775	payment	1726	1726	281	1	1	45	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2kTQCE36j8JVf7jjH1VZYBtfisx6H5waJuiBCZjKhq8bP8BiM
3776	payment	1397	1397	1678	1	1	3146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR6p9aoLoNWkwsWDAXdbPKGZ4XGwEhyGgkryrZHQMiQjsS4tR
3779	payment	1397	1397	1678	1	1	3149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVGsf78gBJWzD9xqHPV2qPxWMdjjcfnAkx9KVPqYQU8E81MS7
3788	payment	1397	1397	1678	1	1	3157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ovpMDeZonVUcE9evHuLerGDMWScRyERn3iPPbyf3z4ksFRUu
3789	payment	1397	1397	1678	1	1	3158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7uTasTqUM4LxNNt48qrNAW8PzAS1wHPbu27n5JiHYm7ZFRVS
3790	payment	1726	1726	1820	1	1	47	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm1n7e6KhUYs5E5kRTysd3gXoRzhKT6Tbo7qjwpLy2hDJaGrRJ
3791	payment	1397	1397	1678	1	1	3159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrg75qMDaZQXyuZPqB7YtLeRSTcVWffGWZ9cfQcap1aEzc3Va
3792	payment	1397	1397	1678	1	1	3160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetkDgK3i5EbwZRXFV6AP2og5WPjFiycBEdiCCKxxW5UonwvsF
3793	payment	1397	1397	1678	1	1	3161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFatjkeoEjJnVRrdheNP5dudoNR3VRiy7p5ercbEJMZS9hU1p
3794	payment	1397	1397	1678	1	1	3162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EMLMKf4UcoKvjsa9CRURPRirk7kG7CY1QKmkNhh1uFwrnXNV
3795	payment	1397	1397	1678	1	1	3163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUagEPiqpjbnhKj9Dns1Hey2KGcwsNSVBB1h6kiVufxguxL7kE
3796	payment	1397	1397	1678	1	1	3164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5RHH51wBmizPc6STr6jpSKwUmm9WtAfJGUQzmf4fNiKVkHeH
3797	payment	1397	1397	1678	1	1	3165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWnkX3VjypSonbe4LoQg9sTRaWdtuyQmMpyYPFs6rmJdgdhXe
3798	payment	1397	1397	1678	1	1	3166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ygLNpnGrY59HCeNhcgDMq53SvDn8aL3RgMWpvu59qb1xvACv
3800	payment	1397	1397	1678	1	1	3168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DXGaSL7HZyGbZjM2j2H5W3vc5tnVnp5UAEkrcue6Pn2XkWwH
3801	payment	1397	1397	1678	1	1	3169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZL2zwXsnyLry2Zi2TSN63rjXJKGqjjqkhXVh8ujLAFL4dGD1
3807	payment	1397	1397	1678	1	1	3173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGE4C3rjCuVwF2LDJ2AfSeiepn2L6TLopAXsEfzxj6Fet3Yyfv
3808	payment	1397	1397	1678	1	1	3174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74PCYmhHhEHvYrHCwRe7Q6S65xnCsa4Fbt3So1HVKjxBysbc
3809	payment	1397	1397	1678	1	1	3175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvqgaiJ5xAZJSXmYEbgBd58qeMbUYPfnPgN7iXPD1uEoFth4j
3810	payment	1397	1397	1678	1	1	3176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4K3grKj2fh7nQQw5ZUwaLAhoBEjmza3WPSKvEKB7RHfBswAH
3815	payment	1397	1397	1678	1	1	3181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8d4arJ83yq9LHoEsbtPv5ABYiUViH37kMGVWf4QuTci59cBz
3816	payment	1397	1397	1678	1	1	3182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XWo2TsnQzRUL73CszSWp8iVmXd5SbqXc2Xd6pSWH1k5MEyiM
3818	payment	1397	1397	1678	1	1	3184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2kHr6KYc1coz6Awjb63ozidUniXUeXGe9tp7UD2JhfeYAA7h
3819	payment	1397	1397	1678	1	1	3185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7orfZvGh9RsQzdr431qn9cEf7z4bsh3xc5DGKDTF27vN6qn1
3825	payment	1397	1397	1678	1	1	3190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GkG1NrHomJS6UQokNZuhfAkLdNRckBnwrrEvWTetCeuHDYsY
3832	payment	1397	1397	1678	1	1	3197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaxsKaFW4kYePcyvKVu8tMtnWYZvtG8iosYe9iij1Nsu4Znpp
3833	payment	1397	1397	1678	1	1	3198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5wZ1DoSBJFoNnMvaHDtNDYCJTPtvr8sQBJ9LmArAj4P4NuZt
3839	payment	1397	1397	1678	1	1	3204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopF41opNoZTc2gewUp5EujAtiE9PT6hTR5h17wbS3uYuoZkLL
3843	payment	1397	1397	1678	1	1	3208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpdisPz6k1qmkwwyrT6sWigrtQKqPbfRxPYDKcGiaRQaif6kJ
3727	payment	1397	1397	1678	1	1	3112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3CSPmPFQC8Ytb5EBYR4gREkmQYpvkSEKT4dGAHx3yytR7XHA
3735	payment	1397	1397	1678	1	1	3120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyMvovjKHJcgKyYHcF63a7h3A8jVWm7YFSGqHD8t5Jx5JVnzC
3739	payment	1397	1397	1678	1	1	3124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRhbfzabNoqpiy1fqNgibQkzECZf6TPMdMZw8sZAVoHSFY5LQ
3743	payment	1397	1397	1678	1	1	3128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQuRXxb2zzg7SUpjZMXqfvujRAgmKRTnozBTWFWfQZPq9gxS2U
3748	payment	1590	1590	1818	1	1	2	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJCQKFkJZPhUHmqcFBMWaNWFrLnpT67qeAmFEWYep6GskkxW8
3749	payment	1397	1397	1678	1	1	3133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos2ejy2Wz2pQ3ysfq8J9hpK7pZ5Ar7tnDH26wRsSDSGwGU6GJ
3750	payment	1397	1397	1678	1	1	3134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaxa7Y89c3Fd7tcRm7CwtYXeX1qxktwXhpMGCwH8Sj89bV5xM
3751	payment	1397	1397	1678	1	1	3135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvbX3oakGWfKmWAwyjn6SmEkx61o8GyECd3K9Tki8V3Lzzivp
3752	payment	1397	1397	1678	1	1	3136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCrca6Fh14NRzDCrLBLjcPXnXV8Tq8N4266xU5d63ffAvVoor
3771	payment	1397	1397	1678	1	1	3143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDA35LwBCfGjb9HnL8Hnh4iLHpzt9Uo6n2swj3xXBVziWN4NB
3778	payment	1397	1397	1678	1	1	3148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQk5rbftYwPdGd9vPgFpQiPcakFwe9VuC684EuVj7xKVh2M9M
3782	payment	1726	1726	1781	1	1	46	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYypqQ7fas1WDt66eUosT1yCY2QibSn9spWQEGzQpugiqYXoNgs
3783	payment	1397	1397	1678	1	1	3152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMiVxDwCahUNiexSoRQKxMhrFzb8HGgSJcBy3PE2LeSmdZums
3785	payment	1397	1397	1678	1	1	3154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFMFaLGsw1GPWNUXvnAF71PcWwJC6ZPEUHgL9NAHfD3yigwoR
3786	payment	1397	1397	1678	1	1	3155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgNuLj59fyCoCUP8K4s26XbU6RCtynt2nmMCSKvjRzKC7hqz6
3787	payment	1397	1397	1678	1	1	3156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iDmHgczGwic8WmQ8gMumpJ87fcEun2HvKiin3mbAmS9gy17H
3814	payment	1397	1397	1678	1	1	3180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqX4hYmEdWjjZXVbQAsxiEddr9LLuWuqfGSSXZKdeDurDHMep
3820	payment	1397	1397	1678	1	1	3186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2Me6tr9d8aaqijmR6g8g7ab4umCbj8zz9ZSWZ99Av9iMQEUz
3827	payment	1397	1397	1678	1	1	3192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvN9isQyCtXopWPD1Kdg1AXpmxZVprf7Xf7ZQDgukSQ3RKT5z
3834	payment	1397	1397	1678	1	1	3199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcG2NWiHHZzcsZAJxvfvxAeRzzkPVEGvWJ5XDsKVPJtkM5tgjq
3835	payment	1397	1397	1678	1	1	3200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDz9PeJprkzudsXofXAqtDYpELEWCiW6sN31pVgEQmXh3Xfux
3840	payment	1397	1397	1678	1	1	3205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy8h3YEozpLYAWLf3BERX9J4KUMmEB7hWByPmiPSPFLotZCzF
3841	payment	1397	1397	1678	1	1	3206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyxDimStVcWyKQ2drYRzG3nsat8AmgBYCnwiQxHegnBCBmS66
3842	payment	1397	1397	1678	1	1	3207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1M4HV1ojaSzea48uPKeQ1ZR7xpmBms9uyWhbH3NuEMEXM8QmJ
3846	payment	1773	1773	182	1	1	6	47348061184	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYySNTo1JmVryEQCcnLtkJbc7EKESQQmXia8Jor6EKdweQnDLuP
3847	payment	1773	1773	702	1	1	7	31565374124	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYoVpTwurndYk3d6BV6cpeJfcpeYjZfHGfEaGVNQ6mKBqrB9psL
3848	payment	1773	1773	927	1	1	8	360516507884	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ9ZASq5gNJRCRtQWdhakckstUnZEmTb4G1dV4GNbqf7RhAfHkJ
3849	payment	1773	1773	1047	1	1	9	646042493224	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZT6mQFKUduAAaCTnNYyeGJnA57N5mfP3gExJ9B6TgYfXDJtLuv
3850	payment	1773	1773	1167	1	1	10	435897743484	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYyUTvVGBFBMVBP4tff6RX6SNmN5Lbgg747NEytmbkiYbWBbwyM
3851	payment	1773	1773	1293	1	1	11	1214667820088	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ2kNzWBCG9UKG3FrnBPyxqbVUXMpepSjxC4A5qPvfLUaWX6gqt
3852	payment	1397	1397	1678	1	1	3210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8q9QGFMjFGdFdhgnfjkbYDbGPss4Kbu12VCwqCRrGbZYw8Qxs
3855	payment	1397	1397	1678	1	1	3213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fRrbq8duNNAiB1zryByDsKE4iEhQ3aDwjP9Qe6uFLxspbyne
3856	payment	1397	1397	1678	1	1	3214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFX9n4AFnoEfz9WjjSdQE1hEioe3zDzam8MmQjW9BXxpvQ1dC
3859	payment	1397	1397	1678	1	1	3217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMxkScs1GohTRrrGTvmC7DPfk9Jr6MRbufM8bRqV8QZGS2A3j
3860	payment	1397	1397	1678	1	1	3218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkP6Zsw6BsT1JehYaEuhD7wAuJCi7g9pfAFPmsuZBkYXaQNFN
3865	payment	1397	1397	1678	1	1	3222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqkXc4FtmgWihP8XModyVkHBrdYsn6tqWv7fyeMYTgCM5C96F
3866	payment	1397	1397	1678	1	1	3223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89SbK5MBT5s3QwQvPwgQ7mYRFqE3ynTa5TR9CVc52hQJ4WGZp
3867	payment	1397	1397	1678	1	1	3224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhY8sBrt3kRgdcwPp8o28o689P6m3iPdH6qWYuKJF79XHdTqp
3844	payment	1699	1699	1773	1	1	2	2736097999988	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwV9qK4svfEE1ETGwpRM1g9SstdVJHVDsQbHJiZ3Bt2CuKPj73
3853	payment	1397	1397	1678	1	1	3211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncLKkCRG2iywsm3ewiojcoRGy9MvS9z7hg22asqWp67EkdFLc
3857	payment	1397	1397	1678	1	1	3215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwVGbFu1MJgfsbeFVjNyme3KVWmAzKkvRuUi2M7Hy6fCRRJa2
3863	payment	1397	1397	1678	1	1	3220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxybxLTLhJWRUqes5PfDz81jcdx9tG2cutpbz87ToojUJhv3hQ
3864	payment	1397	1397	1678	1	1	3221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCpim2E1FpRPnhFvzExfefet2W9ZxTL2njuYca8k7vutPRTCd
3868	payment	1397	1397	1678	1	1	3225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRauppidFpBbbF69DrR4a5f7hQto8dFgVkcc1ZP1cz9ovVmtw
3870	payment	1397	1397	1678	1	1	3227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65yFG4P5D4A8HFav9CRaDnPX1SHco3PMdGCAzuKbKDmz8RvUi
3871	payment	1397	1397	1678	1	1	3228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNwMNrxgvGceu58WJnZzdXrjdeGJftF6ASZ4hwt8tPjTeSfiq
3874	payment	1397	1397	1678	1	1	3231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcripBjrzd9GJVQuAt8a6edeeBcmsm8aMuP9TFq23rDsbACYgR
3882	payment	1397	1397	1678	1	1	3238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgaM7HNSmH9Me1WxEe4WPhe3zdpyzPczj3Sq31AwBG7W1Vn44
3889	payment	1397	1397	1678	1	1	3245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAUmFu4KFvVSJT1cxFoV2QzKf74aCi7SLLUKS2UpXrW6hKRxv
3893	payment	1397	1397	1678	1	1	3248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejuoobQY2McwHsc4txDAym3jGPMRkferTN7r8Ez6ASLkNbouc
3910	payment	1397	1397	1678	1	1	3262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSivW4AJ3zEHRERayUmwGYmR1VMSyDwiKeNzi67FVwmd745hgA
3911	payment	1397	1397	1678	1	1	3263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNFsDQWkNbPmAhoayqfVqqyHQKfQi6gTXqjedJtkw2DcZ28SK
3914	payment	1397	1397	1678	1	1	3266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEQHcBKVojd5tWke189HRrGuXQs6sxuXZXwpmzMCsoPhBS2LL
3915	payment	1397	1397	1678	1	1	3267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9guFZqejGsFziKcmFkuYbYuTNTAK828gbkKubsQq7uRmJECLg
3916	payment	1397	1397	1678	1	1	3268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcW21UtmT6TL3PiLLDArtyPqeFdp2UwDKHUq7tu9kizexTtr2J
3919	payment	1397	1397	1678	1	1	3271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenJAQe32YBF48c9mnnEi3pGc5n6SCJfReKrjUvDAemBsAi19C
3920	payment	1397	1397	1678	1	1	3272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatmjQdm3AUqfWAWVW3WZyJXYykdF2EB7sFfR55NSBfcBawptM
3921	delegation	1821	1821	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnthVLxEuhKBAYcY195TJ8MpkEk64QycMSTLrC1nS2iMx9xX8
3925	payment	1397	1397	1678	1	1	3276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rka5i3Waxuk3QngwTRjDPDQbTHeQamsaRtZ8mEQwbgdCTHny
3928	payment	1397	1397	1678	1	1	3279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrKrN1u5kspjRzQzFgqPgRTwgeApmuPjjRmHGdS8nyct9pNQu
3940	payment	1397	1397	1678	1	1	3291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopKxNsu8t7Z8hjb6VjVAWFAwdheDhHugBBeFcUVeWG4YWmA43
3941	payment	1397	1397	1678	1	1	3292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwNdbAET81T4yUSuWQfHQ6J6nkd6D6nbSpVRd5D4wHiSJxLHo
3953	payment	1397	1397	1678	1	1	3304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mQioQxXEbQ3ZiBwAqUi8r9TtDpQ6joLZcmQJmKbkXqjVTubQ
3964	payment	1397	1397	1678	1	1	3308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mXSdHWGwaMF6KkUY3byZhRnsqncwp4GwsAbFdL3q38nKHLxs
3967	payment	1397	1397	1678	1	1	3311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGnN93QQcq4a4YCFBbb5vsHVdfMi9memurXQLp3a9ozpaAKRX
3969	payment	1397	1397	1678	1	1	3313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCyjD5RKH2QBHCuVvrQn4f8uEAdH7bCtWm7RB2DWfEfBHWg55
3976	payment	1397	1397	1678	1	1	3318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzicJc2TwWDP92fx3ZNh6y8HCngjniqQ4bmYmkZ7q2emrgquhY
3980	payment	1397	1397	1678	1	1	3321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcPHUv3qBD2ZCauzgRjcc9AiiNU4H6iD723xoSQxPAbdnruoJ
3983	payment	1397	1397	1678	1	1	3323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSBJAo8NaXMfAtLVURgcDgXqDk7taQ6e4zDTECKP9S7XhGjWe
3997	payment	1397	1397	1678	1	1	3337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmvTKusGGinzidTzZ6aYXVRz7LkJBwMxuLuzgxeXxDzXdrgpW
4002	payment	1726	1726	1831	1	1	56	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZ7M4ryrcLJKCWRPJnC3f45ombjfkT6mukL1vUKtNLEcQb3aEC
4003	payment	1397	1397	1678	1	1	3341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mGEbEG7J87J8vQ7dKse4jzNsAtiUzv11CCLwKH1E5sHNjyKA
4011	payment	1397	1397	1678	1	1	3349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFx5Zk76zJhiAKahSnD7sD6sLKU5GncHt5mTJURyEB2j3eEbXG
4014	payment	1397	1397	1678	1	1	3352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pd7HmK19ssgvHoBsLeVgaeXvDUP2ejtxS7NjnjoZR9TDCM2x
4022	payment	1397	1397	1678	1	1	3360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAnaZt2RLSfEVXeEU9XiSpvXzfxRb5WaLePEk3nYScGr8Ge14
4027	delegation	1829	1829	1396	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7CH7SdhGdrbp3iGhJ83qJPrKQXLfzK7kfMBUuMnnmhdMAAGB
3845	payment	1397	1397	1678	1	1	3209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehvvy7KWW41nvoLSLXbMbwMgyeTMH37JMV9CDz8RakdzwApFo
3872	payment	1397	1397	1678	1	1	3229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NXPPaxJqUmcXuSCV1GgsAfpbwZ1WM8p8gdsgutDTSZVZwDPC
3880	payment	1397	1397	1678	1	1	3236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjW1s42wXV9BDJBabB1YhBrgqxJFs42gnWd6ZQQ6wA3PcZ1TET
3883	payment	1397	1397	1678	1	1	3239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ51jBfpRS7KyhxJnwUfFTHMPr4XMvYJDyg6pZpo1bUHuk1yKY
3884	payment	1397	1397	1678	1	1	3240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWLbHYNGHDS8cakjDd5ZdoAjyqUmYwaPncGFCH56ZsASYUoBW
3885	payment	1397	1397	1678	1	1	3241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBSmaZwEpyJMHseamGPA6pgucEJEc6ZH9sJ2BgB7ywwmyyDBj
3891	payment	1397	1397	1678	1	1	3247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoz3BEF8UUKaTjW2pzi3CVKv7nsoZKvru6DSGiyAMqa1eQcDT
3892	payment	1693	1693	1816	1	1	343	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZfSaqH6CBfesiirkvjvuS8XApHFPC4u918E7DbmUeCqCD4XYhC
3894	payment	1397	1397	1678	1	1	3249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxKjPiHc8d7V9w9Wm4cgPDNrQLTeo1gyyyWaUseKZZ3SmoX1i
3904	payment	1397	1397	1678	1	1	3257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2UmCGtBL4rp79phR9yZSNBTinsuHAucfFWktSZY4wghorLWq
3905	payment	1397	1397	1678	1	1	3258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Jf2g7zXuKwSSZgLRTTg6ZuS2UTfY1bfumjp3owkz5LWPM3c
3906	payment	112	112	1821	1	1	1	150000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8sYVU2KpsqQyQEWNH1N5RdZSNyaKrda8ceJCDDfdLmU2PVUj
3917	payment	1397	1397	1678	1	1	3269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43anUqxAph61KexCFPzBtK9dtYxhBLPvxP7mJVzyHBR7dqXwn
3922	payment	1397	1397	1678	1	1	3273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZSvdC1HNLzPfpXFjzjNPm631kUJcQsBnW1Xq3AtRpN5z7vaW
3923	payment	1397	1397	1678	1	1	3274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcoQP1SM38ZbttirVGQPZ8XAa7HsNy15hokQ1bMi43FHZVVS4
3934	payment	1397	1397	1678	1	1	3285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsyEcvMKuaANBjngDNtM3Ps8UpvWYL9G4uziDzXKkFEo9BJaa
3935	payment	1397	1397	1678	1	1	3286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XhvTAwXnDcLWQEp1mhB8281xELofTBQLpuxHV1rY7AZQSR52
3938	payment	1397	1397	1678	1	1	3289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrp8Br9gFKpTbEox5b6P4ygfqsWETCnFsLE2L3cs8AbBBirqfW
3942	payment	1397	1397	1678	1	1	3293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVKvWaXXVfyW4viVEgi1NUsZeccrse3JZALeCrb7hmvSLVMvD
3951	payment	1397	1397	1678	1	1	3302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwmRGX4njxx8uSHXbxnp8CE5Rtw6EzseAfacgEzoSu8AZEc8a
3973	payment	1397	1397	1678	1	1	3316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYDcVJNk99ZQi5bBj1sFg4zrkPYBvbEFWTbPvyrdx49onL6XR
3984	payment	1397	1397	1678	1	1	3324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jGs7cCkZqAvqTuTM37VQVv5uLXqTZnAVV7eM4UWJeYqC6kYV
3985	payment	1397	1397	1678	1	1	3325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbwt66dgZkGU9tVuhJTBSogEjLLNbJeEngRZTEHCQFjKRHTqS
3986	payment	1397	1397	1678	1	1	3326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKHQ3FPX1zTSPSptwufGgw9M2kB4KyGFz9y1u7Ua7t6irHFEx
3993	payment	1397	1397	1678	1	1	3333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAr1eGHZ5WNdSFeoTYe9eDPRHWpKjY3nAM4nsb3DXFxFSjRWP
3998	payment	1397	1397	1678	1	1	3338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jTWLVrpdP1HkFCZt8Hg6HkXyop4ef4bTb8AoHbzCdCjdyzp4
3999	payment	1397	1397	1678	1	1	3339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aePcpj3j3172nMnKoPsBKbV9DdZ8JTASXb4oDWhx3Sf58vG2
4004	payment	1397	1397	1678	1	1	3342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7EDzyLeTH7w9Uk3pt5mFbFMRotFBw48wuiGKJf6nuFY2yx7b
4009	payment	1397	1397	1678	1	1	3347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4gsBbbLBvmaZbQKjLPrVJkcf6TmT7Gg4ZXXcgoMNkw5osVSa
4012	payment	1397	1397	1678	1	1	3350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadrVj6APa5XjhvTkprRuZYsoorTn2zWt3uU1kWYUs7rnZXrwR
4017	payment	1397	1397	1678	1	1	3355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbifuqW447N9hPuo2yJ8rjhNgQmsfXRD8rKQa645rjv3zTQ2E
4030	payment	1397	1397	1678	1	1	3366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjGyMLqRUa9ZLgaMy3pqvcgiW4Kwk3TcnsF1brTfva3L4ufyQ
4036	payment	1829	1829	436	1	1	1	980000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdDsC3d4VrDgT52x3qWnY23stvzYnu4sZd682DYRNBSoWr2de
4037	payment	1397	1397	1678	1	1	3372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBgewNCQKbjGZ66XXHuQLotwPS3bRiBbrCPgVNkmBZtESdMAP
4038	payment	1397	1397	1678	1	1	3373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxSfaigEvHwApFtU7YwB1LsWuXjJ5RoQcWCv7Xo1YMNFNWR7Y
4040	payment	1726	1726	1832	1	1	57	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRKmM9XwayGjFSLXSVp994B3bJjaFjjanRtNTdnx7q3eH281Zp
4041	payment	1397	1397	1678	1	1	3375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtLvrbZzr2g52fh9YYjygNahas8uBT7NGFfdmrr83LjrZE31F
4042	payment	1397	1397	1678	1	1	3376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8LvzCrc7SAjjdsLcYR6nN6Ys6SZhrxS51myKMst4EdMhGx5R
3869	payment	1397	1397	1678	1	1	3226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeukZ1cioSpPUumtWw2b3R4tA9FjXHaXwFXFU3PKNg4pE39Ls
3873	payment	1397	1397	1678	1	1	3230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaEBJewrcB9DvnUUakBiU7sJjDtKYHdVHqcXs6ruRVAG85qub
3875	payment	1397	1397	1678	1	1	3232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfspW19S9JTpjj9v9PqV8mJjJSp3bft4soibMGsRKW8yRg3qkN
3876	payment	1397	1397	1678	1	1	3233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB8My6ucCDjhrrcYWGzh1nSmR1eUrmGufU2TEfdov43W8Zu2mp
3877	payment	112	112	1821	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dPgUdL3GT32XX6AAkzq99Qf1sJxU4zXw3r3ThmFcQfZsCzRp
3881	payment	1397	1397	1678	1	1	3237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyw5VHbA2Vk9ekCqhkdCa1NgoPdzSz2KqQtJF5UqErnJkNCL3
3886	payment	1397	1397	1678	1	1	3242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXnTZC3Tow52sY4drytXxtFJhYjUTLu3kSXErJc2Fk5sAkJPs
3888	payment	1397	1397	1678	1	1	3244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZAfKn3PMVYCqBu4M4sFoWwzJ4kBqL44uahwuCd3YXtUBsp83
3890	payment	1397	1397	1678	1	1	3246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBYMDGxyL77EsCi5rFCvsXJWWxwFVBzxDZNAPLoiCktoAKtcK
3895	payment	1397	1397	1678	1	1	3250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuqWMLA2s8QZKDmpUWck8oYnAYxBcU8XbYo6PEd6buMuyEE4P
3896	payment	1397	1397	1678	1	1	3251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTRX3UCm8WduZuinpgWLVyVENffDAuJBjuejj8DYz73aybTR2
3897	payment	1397	1397	1678	1	1	3252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42WJafqpiRkpqERXb7YitRpPE34Uzq5XzFB7qRj1Vxh6ZwDUc
3898	payment	1397	1397	1678	1	1	3253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzS8SyfJg8gwq1quhjHAmvkCZzEH6UFTRdifXw4QTjgNwNHNe
3899	payment	1693	1693	1818	1	1	344	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZS65waW6j42nWjmEehiJoq9BUepjtChJ448ouGy9eKQ6h8gD5S
3909	payment	1397	1397	1678	1	1	3261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZazhoBAwyFwdqwmepAtQS68C6NbuevN93bPDAW8zhL65KW1n
3918	payment	1397	1397	1678	1	1	3270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2naPCa1DpLUptGFQMNgGRf1VhQRxDRfK8Chuoq6nyyZwwFT1
3926	payment	1397	1397	1678	1	1	3277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6JZtHiApYfPySSbSXkyBFVjRAQ75Sib9DrQ9fqLAw1rjAppb
3927	payment	1397	1397	1678	1	1	3278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6msbfVz2V8XbiuVR1g3YWGG5J1Xa1FE4Womvoe1xYLDwigSf7
3939	payment	1397	1397	1678	1	1	3290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBECipxeqmDvPBgMxRzUfknA2W5bimJDM5jqZHFVx7qmqvAtJN
3943	payment	1397	1397	1678	1	1	3294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYuo5UWaLPDscoV4d4JydHBHgqRPzAb6t1pndbTzWXKP9hUxM
3945	payment	1397	1397	1678	1	1	3296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6HSU3tgiVxVZLP8a7JWTNs685BSUiSdkkjopBmoL5hjkHAjj
3946	payment	1397	1397	1678	1	1	3297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpck1h6DkwbV2Wy5VZR4CTg61R5s73YfmWkWW6dKcdHHc7Y2s
3950	payment	1397	1397	1678	1	1	3301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsj36iQnmhTY8njpnKYKCjwcv9p6gziP3Ev7Y3WNf79meTzsg
3954	payment	1726	1726	1822	1	1	48	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqgXTML5LVRf7m8rV3sNCDCqaobVfspB5EwXhwjHGK8qpHsfPW
3955	payment	1726	1726	1823	1	1	49	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCK9nd3myqrZPFTMAAnD2rnGsA7dUuzTN64k7zxCGXrsJ3vBts
3956	payment	1726	1726	1824	1	1	50	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiBcAd4LxdJQ8D4e7D4DeRSf42cnKxiZTp5sVcgsq4EViwCLxt
3957	payment	1726	1726	1825	1	1	51	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgYaqfhFnL18iZpYCe5Yr77a3SJRDJc6MBCRv4PftR12S382Gu
3958	payment	1726	1726	1826	1	1	52	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEfESnZPQmUfqEP8PyGDdfBcJtkYMAiMwVEyZ1jk8t1TU6uFfR
3959	payment	1726	1726	1827	1	1	53	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYsuakcDyLZwXZM3bZJiVDprYWadpc19ZnzzKHPFBAL2TmDd8RY
3960	payment	1397	1397	1678	1	1	3305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX3Sos7etsj8W1emPrgKweJRUf6CoKLeVKp1st1XKbWpsVsSn
3961	payment	1397	1397	1678	1	1	3306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhszVkReRyB8CWgKLVLrTtEySHdJf4qs5Qc1kBFcmMoSnB7U1
3965	payment	1397	1397	1678	1	1	3309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Hu6n2w6PHbpaa3hGanG515bqBynHxcjq7MxGxLGUsQt9256r
3966	payment	1397	1397	1678	1	1	3310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXfs2Fqfi9dCGJsFdXfiR5BJJJQKg2jg2XcJf7qQagVQmMpJJ
3972	payment	1397	1397	1678	1	1	3315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygs7LR9brMtt9o4vZJyoHmv9BX725cYbZdbKBDYgN7djBvWwV
3977	payment	436	436	1829	1	1	1	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3snu9ywVzaGpkwKqm97TQwruN74Q3V74u2PNTw4eMxxWf9szB
3978	payment	1397	1397	1678	1	1	3319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqH7fCHL6JqYbVTGvjpX6fgF4u7KGCRsTfEzFMrs3j1XU413Q
3979	payment	1397	1397	1678	1	1	3320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrbHUvcEpmiMWcyDXLjRLpqvAUhKCTfJ6ZHn1AXv35XqG6YMC
3992	payment	1397	1397	1678	1	1	3332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7ovXeZJdAKBfhj7tNurWoAMAMhWr2LrQrEQAFi9xiXD8h9CN
3903	payment	1397	1397	1678	1	1	3256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRpG48MmStbSq7NiqdcWXuAoTMXDkqn9AghfQPar9rREcPPav
3907	payment	1397	1397	1678	1	1	3259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRfW2j3f6on4GVC1knJUa2XQamrTjfv3BcXBcmsq7pv6bgApS
3908	payment	1397	1397	1678	1	1	3260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3NAAMTQEPbsQJukiUHmFmK4HghsYVfr6PKkRSS78hnA9VY6f
3912	payment	1397	1397	1678	1	1	3264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Ac85M4nN9VgZvYg4rBY4NBDRzUYbFFYqm4EVs9XmLH5Mha1i
3913	payment	1397	1397	1678	1	1	3265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhGYQyxw68JSpF1qhe89s1JvMvWh2CFFeskhbdkV1ZNn8PzPZ
3924	payment	1397	1397	1678	1	1	3275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLoDFuDd59bDnMqCKwd5u1mwRJLxjV8qrjRQeQ1qunxGNCbjX
3929	payment	1397	1397	1678	1	1	3280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvvomx4SPBdNGDW4AdJhYhbwqXyFYSHekUTTsv9iSgvyJ4Xcv
3930	payment	1397	1397	1678	1	1	3281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9WNdd2f3srGmUzy4hxYCbB2F7gbXzZXzksTmnphqz6yEhb7w
3931	payment	1397	1397	1678	1	1	3282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBq3wtaCgnt3bCQM2gwa8mWjoywP1fi9MMfzZocynuijCXiHM
3932	payment	1397	1397	1678	1	1	3283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2osreZQoKTme2msLxArWefSkyr9U9gSRRhLGXX3ep7fGhCroo
3933	payment	1397	1397	1678	1	1	3284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtcakJkL6Q7nwpt8vXNuhjPKdRGr1BXqdWRLYf7iHy6cBBbk5
3936	payment	1397	1397	1678	1	1	3287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUkMSfR2BossFU2xXjqQJQS2qgTEoTdi9d8ey6m8eFqSRkpRy
3937	payment	1397	1397	1678	1	1	3288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy464mgYcLmjwK3NPT4iJ8sDuHqwftnPmYVD4FHT5mDWMA7TtV
3944	payment	1397	1397	1678	1	1	3295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnNxVeUzJngZj2US8GECCqwerhXafenrCrFqBTP1PKtAvAW3i
3947	payment	1397	1397	1678	1	1	3298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPevTmoakFnY3LQhxkk4xYZkm6gzaCXRPewJjfXvGxyePzCsN
3948	payment	1397	1397	1678	1	1	3299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFbDhg4QRFHpNFHiGutx89YuPjdtCVtdyrGamMvafWdbJTHhC
3949	payment	1397	1397	1678	1	1	3300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWGkCv7JJ1JAuETGCEJ8gamQwoXkmHBPLzwHqPbbirKTWAkPU
3952	payment	1397	1397	1678	1	1	3303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eX4JqvmQqdbMoMs2tFsbWJZLSUaK57JEK6Wfap3tNScALGxT
3962	payment	1726	1726	1826	1	1	54	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2VHb3as8G95cpCmnTrNvt4FHekfF3iMkAgwawbSaqct4MCE3D
3963	payment	1397	1397	1678	1	1	3307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsx9cZjUJSZT9xmkCjNvYXsVcmPDVGuDM7pCx7kYbzahHzirt
3968	payment	1397	1397	1678	1	1	3312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97zh5hWpC6TrbUz4zjDW7GaRRvN7crey1EtkuZXxYnhcJYeko
3970	payment	1826	1826	1828	1	1	0	1300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJZfv26cDMNeAJWfxZU48nKJ3PaSNYE3DAULaLSgC3kRwwTYQ
3971	payment	1397	1397	1678	1	1	3314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLX3CfSCWZwnjmptvwZYsHMU3p1QZ5XTouqCTnQCchNTNZxxJ5
3974	payment	1828	1828	1826	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnZEgofydBshhJMwFMhmJwctB869aVdR9zYLTG24sUNiQdTQs
3975	payment	1397	1397	1678	1	1	3317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MxGvNz12HkRzsud8CoYoTJ6kcepbtyRZNL1NeGEwKihNVkDY
3981	delegation	1805	1805	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm4o8VVLLa1kqdMtnBTQpA2MkXQArRw1ckNwaDRc32ujAHAHu
3982	payment	1397	1397	1678	1	1	3322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Zjk2QbdvR5X6QrSMFKx6stc3cdCBfUPnno5DhTWLrNeYMiJ2
3987	payment	1397	1397	1678	1	1	3327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9qAAcyNDvfPhmCfg8TT8YG63gyw5XpnepJuJjNXnV65pYR54
3988	payment	1397	1397	1678	1	1	3328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2u6483HE8qJi9sJnaoWzXeDxY6HFpXcpSXnac7p29Gwqqxj6x
3989	payment	1397	1397	1678	1	1	3329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGcMfQKA64zQgcxYXFdGP8ZyiDQV1M5HzrBi94ZLeUgS9xTLH
3990	payment	1397	1397	1678	1	1	3330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSyLbkx7z84BQQ3wMBQyfAYJJorwJrfQk2XKRsGTmrup1d7Bx
3991	payment	1397	1397	1678	1	1	3331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNt9R79v59v3ZFJc5CKKvLKzEkrLqdByQPh7t8KkJ744Ja9CGa
3994	payment	1397	1397	1678	1	1	3334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iFnhheHS6cYmtQewxJkBsb1xEnUVktWdqqmasVs4Xic9DhK7
3995	payment	1397	1397	1678	1	1	3335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt13c1bkfrpzQzVsrNRdgfEYFvHj4knteP1EmEun4jKcSv2TcE
3996	payment	1397	1397	1678	1	1	3336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAX9yNChJmdcBUXu833a2LS67LqQ2eCHDvMdbAmb2Gee2UCGZ
4000	payment	1726	1726	1830	1	1	55	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxyPjbrKwGA7nhar96WSn1ZN9QDPHFQChozEdr19xdNZP7J9Tf
4001	payment	1397	1397	1678	1	1	3340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvN2F8s1wNFcXA5TS2bpFLGh7izH4vyvhEtP3pAwWwf4DL6V7
4010	payment	1397	1397	1678	1	1	3348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwjbATJm7ZFWMRyHG4t2rvrRGwNUihVNzPeTJvaDmMMVKLFEW
4005	payment	1397	1397	1678	1	1	3343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnFhP3pCw1d7X2kD3rMtMozH8ViUKphHJGsUb1RS9nbxiC5T1
4006	payment	1397	1397	1678	1	1	3344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaLvpCW5atTCcCup7LYmNt9Mz4QThFJFBSq6nL6NUhYqhP7U7
4007	payment	1397	1397	1678	1	1	3345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAz2tWEPTfDPhG6QiRPhReyQjzXeGTfiVMi4Eu7hU7yq3TZJDS
4008	payment	1397	1397	1678	1	1	3346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzqCxXoy5vU5F7zKK6z6Tmath7stebvwBv7WBRmU27RjTCQhJ
4013	payment	1397	1397	1678	1	1	3351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXiNMAdvZzBFkQjGZakrv7GeCdbACKmq37YC3mtNkNP6wSV2P
4016	payment	1397	1397	1678	1	1	3354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMX48RQMXuT8v1XeqXPBuCKLKCCigFA4g92rUSDipqffKh4My
4019	payment	1397	1397	1678	1	1	3357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK2q75qvuDWLY7JGbyG1WcPBxs7tHLmPbQyHSTPBQ69vefyTh
4020	payment	1397	1397	1678	1	1	3358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekvsmbNKuiKcvDdDN4errhK1uiruJETGvv5TwpXXezLwnKHqa
4021	payment	1397	1397	1678	1	1	3359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Jh1QPf7MwM6jRh1iUDsJSttZwrQKMeNop4xwtY99qH1oSERe
4024	payment	1397	1397	1678	1	1	3362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkvPXdjSYBCxApmxDm2852RfmNYZrkY5xoRvvjkSnzbDpFSRo
4025	payment	436	436	1829	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLj93aUpTy25WtZ5y8LrEwJkvfVFTu61YyBwEZpxuQrH9ZBf9L
4026	payment	1397	1397	1678	1	1	3363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMiZ9SMQAecKm4QKN3zU1K3FN7wMbPNVrvCt3AuNzvo3BxtXw
4031	payment	1397	1397	1678	1	1	3367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbWF6iGHHVbekQwYt8CFTr4QdiMFbVPz8FAycNPqM1yqwAvaP
4033	payment	1397	1397	1678	1	1	3369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHKG8XCSBmZ3XehhjL1YnY1N36VsJYYVHR5ERW8qi8SudmUB1
4047	payment	1397	1397	1678	1	1	3381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GMqJaoC5sQwWtTaqjuB85M9aLCjwJzt5CYVQzRhimYdnkwJ2
4050	payment	1397	1397	1678	1	1	3384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhv5GXFmgo8d5a2S92rbM8uHwjtdePcTuHM51LD5WcW3YC9oG
4052	payment	1397	1397	1678	1	1	3386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5tDgd7hUsgb2vkGJoc8zgurMhEdmZBh61ZcZhUaoa4B82PMr
4053	payment	1397	1397	1678	1	1	3387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovnkBYPkEQyWAvoLpFBckvMtGd3uMynyTZcFUTDJg16FYYE9G
4054	payment	1397	1397	1678	1	1	3388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bzargKhMpChrhNVesmC8W7cesMVUJHrrHm3gSgZnEp6RYDPN
4065	payment	1397	1397	1678	1	1	3397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eMEwan4az1MT6uHWLiReQeG7U5sEpTdeeB2EfdMznks9LUw7
4066	payment	1397	1397	1678	1	1	3398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLUDscTTW3ksNbdfmFR1uJ2o4joMN9UsDszzP3P93XnNxFefC
4067	payment	1397	1397	1678	1	1	3399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbVGNr77AUBiTvMnkTkKZ6WBMKugXR6yVeX8YWo6kLJ5AtqJD
4070	payment	1397	1397	1678	1	1	3402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeZEB5H95tfwyk8mVEVJeVrUAgkW3YqJKKpjVjJijJ2fdXH9t
4079	payment	1397	1397	1678	1	1	3411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDip9LjWz9ASSmQiD9XrdseFxi2eWqa3nuMxFJtNHVUKJ9RHAX
4088	payment	1397	1397	1678	1	1	3419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Vr5iMVYkGroGD1P4vxKRj8RoaP2pgSRaPQUrxEgCFyQ3pQ8P
4091	payment	1397	1397	1678	1	1	3422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75ciD16ZPSPHUKUW4N7gus91jokdbCQ65gMiMPJx2uPf7MGec
4096	payment	1834	1834	1834	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeQsp972Pveo9LLBuEU9uF3ANki1csiKSD6VirHHMGw5Tnknz
4097	payment	1397	1397	1678	1	1	3427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9gz7oib3h3sBh3AcVLbeMbRWmqYk588nXd7P3PWfj76z8aGJ
4015	payment	1397	1397	1678	1	1	3353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSKhmQj6rHHx3bVTEPnSCb98xj9V4mw9KWXQCBEjpdWrvEykt
4018	payment	1397	1397	1678	1	1	3356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C978f8U1KKCYQqoU3DA43APi93R8efroVXyvRnuREgjgMYdV
4023	payment	1397	1397	1678	1	1	3361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBxs7bEWK4w1TEXYdG4L4CJ9e1LPdG96n76dFnDmqcpRLJY2z
4044	payment	1397	1397	1678	1	1	3378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZwFQY65qksj5tNAYt2kfmdsPUd1f6xhdWdYKyn5uKVsmPFXE
4045	payment	1397	1397	1678	1	1	3379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ425MYP6ooZ8fTfCxdqDFQysY8A19EvST8wkZvv2wWcggYh12A
4057	payment	1397	1397	1678	1	1	3391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCXseRHyViXj8rTPCg5PBGJSeczcXesTTah1ZdVpsm4vxHck3
4058	payment	1397	1397	1678	1	1	3392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7wbL23ZUdLxdYNSzfjAQiKtqL5hYpJnEWEZcLFfpEYFzWKsK
4059	payment	1397	1397	1678	1	1	3393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNBGLyN3hL7AT6ASnjSRGkD9yV2Qz9zUAoMmJ1p1HpMfxJXU4
4062	delegation	542	542	1492	1	1	0	\N	11110000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcvyD9RFHm5p8vcjDJCQNQGzZaai54Kz2tuiJ4pHyPnbR6T8oE
4063	payment	1397	1397	1678	1	1	3395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wTJVAS4gDukzWxjCTipDn6g8eYyHGiCpZFJP57VaS8ogNRgZ
4068	payment	1397	1397	1678	1	1	3400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBzobdmVZFnJGkMbaKHvvbaxnZ4ESLmH8dsWbucd9X74CZwdV
4069	payment	1397	1397	1678	1	1	3401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZjH4mRdmeR4JMkYFc28EwonwE5VXedDyS7GGc65Er9fwUx5s
4076	payment	1397	1397	1678	1	1	3408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvF1wEsLD3nV62wYtcXLQbQDQhnvzuvtzj5oM8Ls5RUYZxxnv
4080	payment	1397	1397	1678	1	1	3412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZks4pWkhK7b5CV1pW1MzveSLr2ZZRMeWWLGrKhnKaz4mMNkH13
4093	payment	1397	1397	1678	1	1	3424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9M7ZDofrdREnRQjCqZqHh4aDnLUqDtciNuVsKS8JndvfkZXQQ
4094	payment	1397	1397	1678	1	1	3425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LdRExDuQ4xetiSbri1BcwEa6a4oEbmVb9yk9UN3TthyGCo7F
4028	payment	1397	1397	1678	1	1	3364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74bNTRD1x4nmEU3wgUEoRjfnizcTKXsLck9vx3hQux6aQvZo
4029	payment	1397	1397	1678	1	1	3365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRf9J5oon44gTgv5X2A7KviaarW1B3zwbrnQLYWVCcAkre3HY
4032	payment	1397	1397	1678	1	1	3368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswz1RBb6cGyMgW41CT5uXuKkn48Yunq2pLGJGYm3zEBRGuQaZ
4034	payment	1397	1397	1678	1	1	3370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUNESbww2Z8KBrYxTvxK17uVNMbwr3tnYgFXpLnuyZ5NjGfRH
4035	payment	1397	1397	1678	1	1	3371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oGmUUkNPLUrjZciq7uwoEMYJUu9Bctu5XWdnLMKmdrnnkgVe
4039	payment	1397	1397	1678	1	1	3374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLy9kJws7XgeKgjGQFmsUXTt48eciQdTmYYtXb7yxBoFvUdr9
4048	payment	1397	1397	1678	1	1	3382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYFgwp6NeotjyMauYTmqXmYmkTDJHMsZQLyKie1mW768dCorA
4049	payment	1397	1397	1678	1	1	3383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3igntTL4wdRJymZBdsWERHW2icCj1Efepvxrwwp8waS8mVhn7
4055	payment	1397	1397	1678	1	1	3389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWQq4EGm3XP6armcHuM5diU8KZ74KQ716gAMPComJXRtWahNr
4056	payment	1397	1397	1678	1	1	3390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhp4HRatFMD8YVMH5UojfAigKHypt1qnym1RqDoxBpG6sx6JV
4060	payment	1726	1726	1833	1	1	58	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDaYfZszm1kBh7dWHNVaoTmJAE1TooQeUnWR2dLYCcRpiiD5hD
4061	payment	1397	1397	1678	1	1	3394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3NwpNgQgxsfx4HDQBibFPp3PVimpatKYGS7SniAkReEUpht4
4077	payment	1397	1397	1678	1	1	3409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5STfuC8g4m6J2UFKG6NE7QEu7FhrMCfBGV96hKckFhkBxkauk
4081	payment	1397	1397	1678	1	1	3413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnhTsiY6XnBVmrdJqJDN5dQxLpkenkQXs8NBj6GhThS5d54Kj
4083	payment	1726	1726	1834	1	1	59	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrrro98cbkZRhKQ6iTy5Q387XCz8DybVMjF1nYs3dVXqUwywhm
4084	payment	1397	1397	1678	1	1	3415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwDitFdvjD45FU6BhxZzyPZ5bJ3Nu6fc1cJe5mVAW5wAZJJzP
4085	payment	1397	1397	1678	1	1	3416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnimHn5hKGVT3uVkM2W99UXVYMkADJdbFExJU8mfGCebPu9ZUN
4089	payment	1397	1397	1678	1	1	3420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5P6xjdCpoTCeDi7qYgxUp6oYyoZeFmB2xxbUo7R1f6PDALgtg
4090	payment	1397	1397	1678	1	1	3421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT7F29AJRcfgm9zEeWbYJd91qWWZh8ujDdishu7mdhuDkQFmS
4092	payment	1397	1397	1678	1	1	3423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zGJ5PtuwX2WFjihz3F71eD5tDhAVhdMFBQKMNRP2TqEaTpKU
4043	payment	1397	1397	1678	1	1	3377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMsDYpDTsEVQbmULFBHiwfpkbXmNUNFjGh1dm51pS4hw9Xtfg
4046	payment	1397	1397	1678	1	1	3380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZca1zbi8fZUjB81Eo6xcApKzUj91EykMpt9HSQGhSufnmfqd
4051	payment	1397	1397	1678	1	1	3385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvRUSdi4Gnpy1JKhn7DfYGrGftLaW29Pua2fnCWjApJcGyi3D
4064	payment	1397	1397	1678	1	1	3396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFwhiodWagk2dRKbni8aSYwkYZd3SzkpJnn26UV1Aj4BwBEp7
4071	payment	1397	1397	1678	1	1	3403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWcTisRy1Ks2a2ds1XbvUgQDh8ESmactiJsoGDkm2SzrMufPE
4072	payment	1397	1397	1678	1	1	3404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNeghFZwZE8VQWssUF81ibTTfhrkbxJfbrYzDEuaMpsi6xH4s
4073	payment	1397	1397	1678	1	1	3405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhedkvp2ZyKMcNnAaJGh6KD2JtetpbWhnjvU3P8cnz5SFsmUa
4074	payment	1397	1397	1678	1	1	3406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wEi3iai8bM94MLvpKq6hCNVaZx4vY4JnQzuPiPk6WmC4KoFt
4075	payment	1397	1397	1678	1	1	3407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa51hTtcFEoAe9CqaTMf4FsTVjhEwU7JK3JdrZbSoHAVnfgZnc
4078	payment	1397	1397	1678	1	1	3410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnAP5YpushCHLLCW5rzQtd5HpHehLCw8GVA7fNwaDqUJZqu2R
4082	payment	1397	1397	1678	1	1	3414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc3PcKaXuQeAC6qVF4tKd11jpHaLr1mQKu11XASTYHvfAEg6U
4086	payment	1397	1397	1678	1	1	3417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStDxMRfqtVAhaVHENUfJLGPd6KqXnxMLhG8rYsRRFwvXNmwnN
4087	payment	1397	1397	1678	1	1	3418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEzCV2PT7DJk8R3TvNyvu3JcmWd1wZwxC8bDV9RkBkoTpeJYs
4095	payment	1397	1397	1678	1	1	3426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxzDpCx8C2xgV64xDEg6qdoByCbtXi1GvrnBk8VzPUpHGUhxX
4098	payment	1397	1397	1678	1	1	3428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUD41W2fVL2wk8eb4R3WkQCFrMEwHjtQFfk8L8a1zTPutab94d
4099	payment	1397	1397	1678	1	1	3429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwykBGDxWaWcsn3Fd4Ur6jQp8GjkMRxFhTNtWnB38MyHvb9zz
4100	payment	1397	1397	1678	1	1	3430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4hS7G1nhcw2vUXqBXBh5azjY5hSZaJcjin5QKGhDV4dT572q
4101	payment	1397	1397	1678	1	1	3431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmxfQ1zupkGgZHBmeMb129AGUhBMAhjcimkpK1GeBcMebVera
4102	delegation	1834	1834	1834	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjRrjENnVsAqS2iouhdpbBJPs3a9VUVRxCQvKx5re3bUnzn3Z
4103	payment	1397	1397	1678	1	1	3432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVLJxZtdTUizUixDK5ek4Twg2H9jNjS7nqMRTtJVkNxZXRGvC
4104	payment	1397	1397	1678	1	1	3433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Z418PUGxXp12mKqhLE4Ytpv9BF39jVsgWcYnYEBt8zXmUFKs
4105	payment	1397	1397	1678	1	1	3434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaTbqcc3PM5ikBTTmsCGoTHRU7zH4GciDPreHTnUi37tqj7Ct
4106	payment	1397	1397	1678	1	1	3435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jrF1HaMstv2qXwDopFo2V75jHM3BknNUYJfZns9KenKJUJdp
4107	payment	1397	1397	1678	1	1	3436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnGpDPxXzzLJtunvSSjijoMncQSF5XCkAiuZCZpyMCgG75EKJ
4108	payment	1397	1397	1678	1	1	3437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQuV8YffswUgrD8eVP9VaVR9neaw62fHTX4A2D6sewV8DGAwo
4109	payment	1397	1397	1678	1	1	3438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscFMChsYf9pHQSQmFr5qFcCGgadhB148U7juakcpaCTBkVQ5Z
4110	payment	1397	1397	1678	1	1	3439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pHJdxMNoEKP8yuhTHPiJpYbHxgzesGeGMbzbXsH7pdxrY1m3
4111	payment	1397	1397	1678	1	1	3440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreeucw9rr6n2A4kMaWEAYCTGaCTVPJZqF6YgFtfnoWzubf7VS
4112	payment	1397	1397	1678	1	1	3441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2munbNzZg5cpTVHaWAJoYnPdTXbB68EdmrC1mrvaRmp45MKDX
4113	payment	1397	1397	1678	1	1	3442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkAosoLhJtHKq6eF4FhehMp7U8f8J8DCTBUZBSU8c8zytXpZ8
4114	payment	1397	1397	1678	1	1	3443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SPTV9F1PQ4hRnkqBiap9PGTVDZqZXGh2Htx1PAoVZUt7FZnC
4115	payment	1726	1726	1835	1	1	60	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEMFKUW4MnVm19XossVTEhQ8LuK7WuT25s91DbqghdQ1CHx6v9
4116	payment	1397	1397	1678	1	1	3444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bFpj66R2e9VPK5SXZmrrYVe2Z91JCYM7cKFy73aZnijBdQ4k
4117	payment	1397	1397	1678	1	1	3445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tNKQ4JdEsLEnUEaSm5oHyVAmbpdNSe4BZ1rK2sFYUMJeJYb1
4118	payment	1397	1397	1678	1	1	3446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaFWaSTzBsmoVqpQpL63fPNjLYwGNba24ky9r1VcVDf8DuHSB
4119	payment	1397	1397	1678	1	1	3447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUbpnTass9v14YS3wvBX2YRkgRbYsyZJ4awRdVNGBavnrwTnr
4120	delegation	1803	1803	1803	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zzRMqJ8NBWijoRS4DzU9tXYVHwyqKtbLYF7MFYUZPd4Fvxtc
4121	payment	1397	1397	1678	1	1	3448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1gG1Gpjp1wsiryvBQhoiz7c8a56Z9JNrX6gJTvUgprCKeZfk
4122	payment	1397	1397	1678	1	1	3449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzW42iHEyYS2bu2fsv7bx4BMcS9qRxC88SmXZSN4WuadaXR58
4129	payment	1397	1397	1678	1	1	3455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtd1y2Hua6JSe5A8Wq3yuurn8fcPRCD9m3AgdCD6h8TYCFKvJ
4135	payment	1397	1397	1678	1	1	3461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdBLzFvotTm567HpzUpoMSKb8c3o3LxzYfLRNt4Nt7bmqtvUx
4136	payment	1397	1397	1678	1	1	3462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41s2XcZb4gfSyG93n4nXZL7cLdEGbQiQK15NFgwTEZmDVmwR1
4138	payment	1397	1397	1678	1	1	3464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJz7bjEQRawbYtErFeQjErKiA2A1YbLAGiGS7b1fLDSRrbij3
4139	payment	1397	1397	1678	1	1	3465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NL32MeZ1JFu3WfYbJY3gKrUCCAGnDAngfHfVWQtWGRn3CQz4
4140	payment	1397	1397	1678	1	1	3466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z5QVas3WzVXhqR39wpXQEPSu6AqUE8jSHybqPLVsprCJEfD2
4141	payment	1397	1397	1678	1	1	3467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnaLMEVw8hFP19sW6oM2djAeBvdYsYfEUeYc6rQG7DyhrfKjA
4142	payment	1397	1397	1678	1	1	3468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfTh5KgDLtx3LDjWuZqtqCwo4bYZ41Dq72ieTWPzxHS1UyHbU
4146	payment	1397	1397	1678	1	1	3471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLYn6MfdHzBFsoJbMyaNgtAP68cx7KbD2yn2nVowoDXsZcK1M
4149	payment	1397	1397	1678	1	1	3474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhinuccbxmYwfyvdKh61HRXA1Symix9DmaYY53D4ttEMiGVNd
4150	payment	1397	1397	1678	1	1	3475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLGz36ZCSpNCUaBm9Pr8H2WpZsNwdkhcv8YBm3tM7BMEVaHUN
4151	payment	1397	1397	1678	1	1	3476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dGntPaNoCLojHn4y15wa5tUVviAa2Eiz94j3oeM2RzouxV9E
4152	payment	1397	1397	1678	1	1	3477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetB7swqCZePuYShbKyTAXayancLKAzjBhnmvRtX2VbrFoNeKX
4165	payment	1397	1397	1678	1	1	3489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6RXrz8ZmAc2EjTCEQE5hekSxt2SBsSS6UwL4mD2TGuLRtbXL
4169	payment	1397	1397	1678	1	1	3493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsy7LC4XFgb1wzNsNBnwk6oiVcq9HFKvg4246n5KabfUHbmK5M
4170	payment	1397	1397	1678	1	1	3494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNtpJsGGuJpN4SsUfrNLSMSMj5y5gUBhG1ddUHFk5FVg4edTf
4171	payment	1397	1397	1678	1	1	3495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GWR9wP3fG3zDyz9b7FsvgXum4CnmgHPnLEXBxNJN5xdMmfHh
4172	payment	1397	1397	1678	1	1	3496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCTejUGnwG7m6PEmfzg6ZWDoFbbpdRsQiLQPYMXr2ezBSN5zE
4181	payment	1397	1397	1678	1	1	3504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCUy2SeMCVoKVnTKTgTohsG5oRrhiwpiDFofYNpAXfGu9PeMc
4182	payment	1397	1397	1678	1	1	3505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELPBr8ReDtHEAeyfVRH5sSvXq54PZ8KWMUUTkPZLJkQTUYdjJ
4186	delegation	872	872	1765	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nTpoMp1BvfDLWieNXYiWXfVjRJ3KzREQiiwJV8PyyFPdowyB
4187	payment	1397	1397	1678	1	1	3508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGkiirUwMVcptaqKWxXYWCPgwEJ14o7x1cmbeiojbwTSfgVha
4197	payment	1397	1397	1678	1	1	3518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRU1kiruuL9QxqEisGdBVcdTXgYMGgXnoXqNA6TMKcfH13bpu7
4198	payment	1397	1397	1678	1	1	3519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3jWFXos7oM5kgCXFunYVUMULAjGvh6gRH1FgUorPk4pNUB6G
4199	payment	1397	1397	1678	1	1	3520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAene84deSf4Mmjjm1JJPXv5GoxJaej968AcmJBee19Ja8ZvNA
4200	payment	1397	1397	1678	1	1	3521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MNPK1bY2RoG8u1Vc5jxj16ou1vvtH5b8bc4pp8vB9RaoLnYD
4201	payment	1397	1397	1678	1	1	3522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbjzfc9Stv8Arnubk8ja2CJomgZ5e3hgz8WnnrasVcZSux1xs
4209	payment	1397	1397	1678	1	1	3529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHQ56YwUgjc8KDGYfpu4JnkLnK9VtxHmiGakCLGxbiRRfNwWw
4210	payment	1397	1397	1678	1	1	3530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwyy3WT4eH4eBXdEWXJ5n3nh4NZs6kEnHWNMDjHRw51yH9i9f
4220	payment	1397	1397	1678	1	1	3540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2L7BpmjohN7C2rjPht9Ve5LAiCmYAkYxF16LzKyJskMcFJbJQ
4225	payment	1397	1397	1678	1	1	3545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJb8mLYUE4RL9Sxz4dnX38g5JFrqHBWLo84KtJbr5tqH5FVJ8
4226	payment	1397	1397	1678	1	1	3546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgQh1eowSVir4pR1k33uQckz5mvcjM7wWjkQTMfEjgmZAUBWd
4236	payment	1397	1397	1678	1	1	3554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrVXQ9fb5CFh1vwk4qYLSibQsNj8qeYMBugiMnU6fQbPejQKu
4240	payment	1397	1397	1678	1	1	3558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29GEUCBAVsgSMPiyUs65ms3m4N8YQ9BxMV3PSdneX7wa631Cx
4245	payment	1397	1397	1678	1	1	3563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9C8EzujmphsyjTMDRUVabW1eSGzpRxv1FguhxEL8mtquFNdq
4246	payment	1397	1397	1678	1	1	3564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGCoPT2rk15ZNLGwwnGiADFDgSkfUgGyyVTiKn6ZgDUug63tE
4247	payment	1397	1397	1678	1	1	3565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwjxrThHiouEN6BxYa7K27eRLp7GkXbUS7JfR3gDzwCDCfz5f
4123	payment	1397	1397	1678	1	1	3450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9yqZ4y5EmX8SbmeG3yfhzHM4dnE34uuYFUwiZvG99UQX6LVy
4124	payment	1397	1397	1678	1	1	3451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2q6Wv3CnhqgqmnzSFbLJTvh5axF7HV41atXyQjWZetGEj3MwD
4128	payment	1397	1397	1678	1	1	3454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TRu1QGcRscpEKtocmRg25k6bDsNNA1ZLirreSKcXfamJpVPf
4130	payment	1397	1397	1678	1	1	3456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGj7qG6M3wjD4XddYRBgdSymyAXYEWVZKyQjtJD9cSrvSBZt7M
4131	payment	1397	1397	1678	1	1	3457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2nifJKQrypxtgSBapCrX6fYSQSe4xaJAWgwsoTggqyPVSaU6
4143	payment	1726	1726	1837	1	1	62	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRMwetErPrkJxckgRiez9kFTxbEn4h5sy48JFdts3rinZycNnG
4144	payment	1397	1397	1678	1	1	3469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiorxHR6MnnfjJCFXbxLRWwwtATidsZ6jK9fZAdh17ZsHgmw7J
4148	payment	1397	1397	1678	1	1	3473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwSftLSTpZCXwg18XF2HXT8NtbfgZyVrozQa7qopY6RCgegFV
4153	payment	1397	1397	1678	1	1	3478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFPkGTg1KMrnBoHybPyRHZaWA8en63CdqHC4KpTEh5Rt6irFe
4154	payment	1397	1397	1678	1	1	3479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNk4DcQVnJ8boJx3VE3AFsoH4CaFaLqwqbMcDUBU8FmfNkBiy
4155	payment	1397	1397	1678	1	1	3480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AA4pKiPziyADUz57p1tszZKXc56dWQHXKUztEiFabrsX44MA
4162	payment	1693	1693	649	1	1	345	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYqqPshwVdy4HX1U7q4pCdvfz8Rj6g8Muf1YCkztWpXbDtpJ27M
4163	payment	1397	1397	1678	1	1	3487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGAea7Nn3FXjJ7d2SwiaUxiYH9MPCiQ62sSiPCwppEm2yag64
4164	payment	1397	1397	1678	1	1	3488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57PKcRWjTKyyuq2WiBy4SNUovs22AjUWR1nn1mquxQS1zTfbE
4166	payment	1397	1397	1678	1	1	3490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGYzhEw9NhAcWFTUCbaBkP9ELUmM7FHdw6TQoJMJNZnupt5Pt
4173	payment	1397	1397	1678	1	1	3497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxBfpM8WSgE9jgB4XmHgTkEJPohpv2YTpeEHT3XxfkVCP9Cmi
4174	payment	1397	1397	1678	1	1	3498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qaqy7KAPfXmNQiSPQGTFgMxsvaavJ2CQFBHd6JHLByS9jeLm
4176	payment	1397	1397	1678	1	1	3500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFiULPy3zbJMh6hPnyjzstbc4r5kVpnMC5U8UZTZ5KRoFsNSo
4184	payment	1397	1397	1678	1	1	3507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQJw7LFeNkd7U8xAsSWr3hbZonSbsyFxfwX8gWYLhhrf5Ms7u
4185	delegation	1769	1769	1406	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4QMFfTgGTmapTFWmutr3ZvEnV3NzktHmCZFVd78wTay2pnC8X
4193	payment	1397	1397	1678	1	1	3514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpin62ghLPiXKh3RKLD2LMDKiHWJinNcJYGBvENwot2oWKze8m
4194	payment	1397	1397	1678	1	1	3515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVa2VKgcg64nAdSMr4UQSdhGHH3HzyxbEX8j39CNFyVxfKzDs
4203	delegation	649	649	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNNbtrHhQLDXjrFzs6aHgfBZWRCCGeH5zFy2es718VRC5TwqQ
4204	payment	1397	1397	1678	1	1	3524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBwCCPu2GLwPfEP7c1DZNmShXfou5Zbu3Ncj255yMERxPBVt7
4206	payment	1397	1397	1678	1	1	3526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiA5D1iK792qAiQ4R9sVMnJ8mQq8pbGJz5gF8goCwsYnZx3Dxj
4208	payment	1397	1397	1678	1	1	3528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLFZuekWQc6EcKdBrHwob1iW24bEvLivDmtfRXiDXiPDCESHt
4211	payment	1397	1397	1678	1	1	3531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEzhszwGNg3FXwwPnXt3qB93uRMTNnJsGbJB3sobwSfmCRAYE
4221	payment	1397	1397	1678	1	1	3541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGLXNgcej88T7skSN69i9zoFrVEwrJzdv5WBBYb9DLiGsgwY7
4222	payment	1397	1397	1678	1	1	3542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVNmFUn6UdHN9YpbMQ3MqWAHVKG8CJ2yTqq7eUJEDfSDBFxxF
4233	payment	1397	1397	1678	1	1	3552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PMZdWD9h3kXWe65SRS1cMSpqTTgBnn6CAWv9Z3xDu8g5xVu7
4234	payment	1397	1397	1678	1	1	3553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptRwVyz1MgiAAqLFYW5X6zVx8Aiw2FNEv4sTPPw3eJwaJNtoB
4235	delegation	510	510	1429	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVsC5yw4VqMCx4n7cDFxgKJJKQtc6AGfH9E4LLDiGEbxb5Dcj
4237	payment	1397	1397	1678	1	1	3555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo5AZ9ZacXhxh5kiXMycaJmexiwPaZAg2iVmcr9hHc7CFeuDf
4238	payment	1397	1397	1678	1	1	3556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskzCaeA8jEjW2fwG6p6TrTPQGRhm92ggV4wV1o8JacXvBaHhd
4239	payment	1397	1397	1678	1	1	3557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2ecvYducUqhGDwHcKnuuf87HaLR4kkBEhDsVBBD2ZgZVpQp4
4242	payment	1397	1397	1678	1	1	3560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5EzWUMhxx2uDC9zc9PqUaVBNXttarQT8pdHZ2JhJr3CNCjLm
4243	payment	1397	1397	1678	1	1	3561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRsv4DbdirieLGwz3TXqnwDupS4Vstg5yTrXbSxhLHbfazzJQ
4254	payment	1397	1397	1678	1	1	3572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7qnV4LMLkT8mkL7H1UmrXDmXjPoZcxiAArPPEHTD2C7Jf7oz
4125	payment	1397	1397	1678	1	1	3452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2UYFMVBowbUqPFbDHQKmppgCZoh1Ta7srBD4QjuRwT3VoEzj
4132	payment	1397	1397	1678	1	1	3458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFesiVEFwsZ67idxSEe5kM3WR2cuJpGJw1WVJ18je5XAZGguoJ
4137	payment	1397	1397	1678	1	1	3463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvQTJ4ZPN7W6VsQUqcxd4qHzyGF46ufXzrnzU4eAWv5VtfsaT
4156	payment	1397	1397	1678	1	1	3481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhkpXpQMtBUoQa3jcrQ7yE6po1fnif6AsiqEhjmJjA5iG1bmp
4157	payment	1397	1397	1678	1	1	3482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLBKNCB9L3K9teK9bRPy5B9FNMMWxCaE1YhxRAa3xGbboeVxj
4158	payment	1397	1397	1678	1	1	3483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8u97xXHqNmgEsbYNbvQJYDNoCCCzaiHLHcYmpaJ5yqq125yd
4159	payment	1397	1397	1678	1	1	3484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx79aTtXXHRkYWaVAJd1s5JRqyjiZQWEppeRdmzNqRAc2Xi6B8
4167	payment	1397	1397	1678	1	1	3491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb39cf5CkSre5baKJ3P8mEqHUx9xbM4aao5NGPXKRYGFbLtRFH
4175	payment	1397	1397	1678	1	1	3499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwciYZw8z4PTsXfzn9CEcuQCAB7KEZr1suA3KABVviHWeYHKn
4188	payment	1397	1397	1678	1	1	3509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr9rTdnT3ywtmuKq6poVVMzU7tvPHp2FE1uM6xg2WJPeqdaYw
4189	payment	1397	1397	1678	1	1	3510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqf65hBwqogh6BKrbZ3fHkuBKXHwrZ61gwgkmhGPmNEsgwtgF
4202	payment	1397	1397	1678	1	1	3523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XvxztgqjUs8ZS23sciqz4CAm8qXp4TkSGawPJfzw22NxhcFf
4205	payment	1397	1397	1678	1	1	3525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyYaceBm1nFkXd7aEpSQTNmpTftUg5NtHCtraMWumqsyY3unB
4207	payment	1397	1397	1678	1	1	3527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXQdqQknUujnZRmXEfYkAeJq9yAhNe6kRJTJ61CzLUDg82Xpt
4212	payment	1397	1397	1678	1	1	3532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQ7p39dR8ta5DBWmL5bhrKVGWp5qsBEfv14XutQgJtDgpcG9k
4215	payment	1397	1397	1678	1	1	3535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcUh454iLjegeyTS8NJLFqyvHQiDW3YcPxsAL3nWi1xV2ET7m
4216	payment	1397	1397	1678	1	1	3536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yJJ4FfDH7TjfnFKu8KT8ukG7uVJWnjdNCpVancxTdJDTg7Ay
4217	payment	1397	1397	1678	1	1	3537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnXeATZ1XGus6jXf6eNUjqCwGsHSJh2NHLZQmQUKUnNjAEkeH
4218	payment	1397	1397	1678	1	1	3538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaDZptf1WBpcMhVEfzg1g9L3MoEDzW6n3PUGYoCSamytmoFwD
4219	payment	1397	1397	1678	1	1	3539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7ME6bSLWYUCSGK7wCjzZRiwSAPAr9QvNTxR321JLQfe6FHTr
4223	payment	1397	1397	1678	1	1	3543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUo8Fp4BFnC6GRJ16YvrK6TJj6EBxrXp3DTX1A5jLuPi9PRApq
4224	payment	1397	1397	1678	1	1	3544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAowco5R9dn2JdHNrfQnxhAkUUeKtTJ57GkjaWJKXZRYSsT37
4227	payment	1726	1726	1838	1	1	63	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkjvpzjHuBZNJExSNxzeimHgF2WsqZk94puRRj9KBhR453sru5
4228	payment	1397	1397	1678	1	1	3547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDy2Qn9ouzJoTFdcsJguCXuxPHvRXKy2BjaWhwtwtD9ryqMX2q
4229	payment	1397	1397	1678	1	1	3548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcpfhiGPZn9kz5rfWhBgCtmk2LYjgtvWvuU6LoE5tqu8QeHVY
4230	payment	1397	1397	1678	1	1	3549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuoHZ4rD7wk4p1nwj4N6BZeeSHzyNCy6EagyajvJrXnibRAMr
4231	payment	1397	1397	1678	1	1	3550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aNWYqm3m1jnqerHPhMRVpju13eMVxxPDKXaqEv6jFMXPyjs1
4232	payment	1397	1397	1678	1	1	3551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofuDL9n4zDuv2NH2eZ1xuL9hQKyubrYxFtaDDpb21yA4pbimG
4241	payment	1397	1397	1678	1	1	3559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREVqW8E6EEPyvh7vyLHmbWmDQPnETdYsfh1iqvyfQ9GCU4e8s
4248	payment	1397	1397	1678	1	1	3566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvATHXZsDs2rE9H8XZjwkH4Cy2ZvtAX66wJcUdoMUP1zyyaPnj
4251	payment	1397	1397	1678	1	1	3569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenoRJhoNS9SSCkPaVc1oCJECuewAWDVDGMMrMNVfdNHAfsvbn
4252	payment	1397	1397	1678	1	1	3570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JnstApVaWanN5FepQatURCPoZbzUQxTu6SSmR6H7AizNGF8L
4262	payment	1397	1397	1678	1	1	3580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeabUuV6Pgw3XAeWLH8zM5Bd2nmCww5kiUHzpQHUtJTX28duY
4263	payment	1397	1397	1678	1	1	3581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BGv92aLqVULXtrfHB9zv87qfjq4woizWa6vMLa3FkFb5nTtU
4264	payment	1397	1397	1678	1	1	3582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGJnuEdzxcGMeFievPxBQJYyCT8nqjTrJp6pWUSwyCGGHWU8y
4268	payment	1397	1397	1678	1	1	3586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUu2eYG9Xh2uG4vPHwf99D9HJRKVjBk3nNK7pv5msGNKkzHt18
4274	payment	1397	1397	1678	1	1	3592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzvPpAAPmPexxbV48KWPZnxwR5cH4XYFt1KyoQkuFQCCSAWVD
4275	payment	1397	1397	1678	1	1	3593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeGgDe9g6dtBfJyzJwRqMVUn32qkHq2i9omVbbGFw8kRCvzoJ
4126	payment	1726	1726	1836	1	1	61	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuRJAvu5stBXY7iiLRRTVZz3zmsQs7fgewbF91ocp79z5BnvXf
4127	payment	1397	1397	1678	1	1	3453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUeqVsc7bE545QhqFRSQ8NXDEB2VJTPmfSeevWknVxTBtpj8b
4133	payment	1397	1397	1678	1	1	3459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uoUWGhknc5JR3FNmmtkafuXSP35qB3d59GQgn1GkzEYc14Bs
4134	payment	1397	1397	1678	1	1	3460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKR72oB7JyFC2vahUQzAvGC69hh2N7joQK5w3bJxsJkfSamq7
4145	payment	1397	1397	1678	1	1	3470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJiYYJnPcUskj2iZi5ZwKQfBV9Mz87Y2CJeLfPoUX813iXZra
4147	payment	1397	1397	1678	1	1	3472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhETRYjBet72aP8zGeCKkZ5eL47UfVS9yDULKZWTpHj7ukASwq
4160	payment	1397	1397	1678	1	1	3485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2MiKgDYGUmv4TDL9qzYACsX8aKc57qLowUKiD1UgmpRcfcFd
4161	payment	1397	1397	1678	1	1	3486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CwQ32jfDLC8aL8wueoKN8v2Tza8naJ5TmwKkbox6LfDVSgsp
4168	payment	1397	1397	1678	1	1	3492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oMR74fPRzuEHXbnE3emqeHZRWA1RikX5DyPyGELqrnrtxaxr
4177	payment	1397	1397	1678	1	1	3501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNb2T1JxEMaLjB9FjFp4uXkm1bu8q5zk5cJC9r4EpFMR8jcqQ
4178	payment	1765	1765	872	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhE763UAA2fws4Qqk9Bxd9aWFZxG7rCBpGpP1ckMNPnDkX2YK
4179	payment	1397	1397	1678	1	1	3502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE98KehbfRRa62FFegqjTaSyzor6SUJP6u4SdwzLnQW9xNetK
4180	payment	1397	1397	1678	1	1	3503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDLZfrk4u4a32fo8V2ttdfprbygejMgrLFH7bAqt9WQZr8PHH
4183	payment	1397	1397	1678	1	1	3506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPi84vvDsNKbg62DhyjvgSSp8sJgTgohfi89kvjeBcwa8Qy1L
4190	payment	1397	1397	1678	1	1	3511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ELiJgY216dWQ3yH5xPQgfiYm7na8rxFTcjPYz1jGgbA21Lw3
4191	payment	1397	1397	1678	1	1	3512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hojBseVrPbRmE6AAPX2foye2tN1GckUAFBqArWfYsKWhv4Es
4192	payment	1397	1397	1678	1	1	3513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPqQiN9ZWZi2ZEncaeLGornsvFdoYTBYaUvi153Fph7sEDKVX
4195	payment	1397	1397	1678	1	1	3516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7DYRx2zoP76BZxbyD5vkmK42PsuvZ9tZKaEfkjr1dCtYyi5P
4196	payment	1397	1397	1678	1	1	3517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUM29HPnUXzXgvGazJGSDZqwMzzKTTXBiVQksxYcHfh1YMv4S
4213	payment	1397	1397	1678	1	1	3533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdgN8dQFKM85H7umD2wRUzAuuHzULacbLmv6n646ZHjQxPnxV
4214	payment	1397	1397	1678	1	1	3534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrn4zudEkZBhKYjv516JWDjMoB9muXyxzqDYqS63pif1DetGE
4244	payment	1397	1397	1678	1	1	3562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnomP5FovQf1N37gEuhzb8MPRXZUKYQsAGGnNehgyfRHwXhtES
4249	payment	1397	1397	1678	1	1	3567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHY4ViHuEuEbnT3c33Q5zxdc5yBdptiLwJ5Tbr5Q67TVBBFo1
4253	payment	1397	1397	1678	1	1	3571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3vvNo2qBVCCPeLuCTNATfNwgniLKWPYG9HQ1aLYEcDK4zR9J
4255	payment	1397	1397	1678	1	1	3573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ979nE29UAsdrevLfhFtS8tEf4hULcR8Zbu8fwe8zuXYryXVAh
4256	payment	1397	1397	1678	1	1	3574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wRSGJmtnpCzfeQjHmbMMs8GDcwuSjUQbWBSndLnywdYadY88
4257	payment	1397	1397	1678	1	1	3575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93KSNxYBs3eCu7QjjBBrn7kfm6UAA5hJBzhVPjp5bgo6jTpmD
4258	payment	1397	1397	1678	1	1	3576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQenKtUL1a7RQcWZgKmcr931H7KPdhc6P1zLVmf3sxuSqvj3E
4261	payment	1397	1397	1678	1	1	3579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTstayFyT9oXpg5AFGBmeKNf62sQSGF3YjMbDUcHLELxzX62RR
4270	payment	1397	1397	1678	1	1	3588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFDAZGYnEx1pNwdjD7rjGGmnEgN8w1zZEVy2DhjiFWwdPPYZH
4273	payment	1397	1397	1678	1	1	3591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWHQACpBFqN3DGaRskU29AaKXiosZ8DfeBhGo6mQUonANxwYN
4278	payment	1397	1397	1678	1	1	3596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpHf8BQ62XKoWNvUCZukZsSR3v2QijxQ8VQatNcEP6Fz1KcH9
4281	payment	1397	1397	1678	1	1	3599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPbLYw83tNm1wnmfRZUssbKnoVixPFaB3hGVLpuZm9UeHtBFw
4282	payment	1800	1800	1816	1	1	2	0	10000000	\N	E4Yj1dXBXdoHw7N1Fe9aPax1EgRNFLPLvmThzjEVesZGLyLsbBxSU	CkpYyMV4jDtgKfbz6hCUVB6J8jYfJd85A7mvtVw7ydKLuoCK5GS25
4286	payment	1397	1397	1678	1	1	3603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uoTzYPHFEWNzgjGkywAm3KLxeGzufbRXJ6U8GErErzqYD3be
4289	payment	1397	1397	1678	1	1	3606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6cxRZbz2N6VdGryXCJkq5BY8EExwd68mZ8xtYXvyQ8WVXHxN
4290	payment	1397	1397	1678	1	1	3607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCXt3wVtLkSsvoaqx21cCqGrK9FbCovzg8krRhLDHkESbQbeH
4300	payment	1397	1397	1678	1	1	3616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ426E3RyKoBmWwKL9pdwBMU2zUZ2ewwQUM1MZPL79JoWtJEexZ
4250	payment	1397	1397	1678	1	1	3568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyashwsn6nvkazgmnBPLScDpqmapuEhC9H6U4XLDvQVgvUqYF
4259	payment	1397	1397	1678	1	1	3577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGVwNzs6vnsw5EGn4hyGotpUXTmBAbPf4pUur28A8qw3VVRCS
4260	payment	1397	1397	1678	1	1	3578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6Kd6ttJrWdf3Axp1Jj1Gm63C6Xjmv8AkTAsn2dLevmfhcpFR
4266	payment	1397	1397	1678	1	1	3584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAUy8nVn5XkL3Qex1qqgGYJtzFVieEQPbTFsVHSRdRfMCUtJx
4267	payment	1397	1397	1678	1	1	3585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvpGMn9ggDuzHLeKWkQwdLSFM9eqs3hrCzPy8qPHwiGtvYW9X
4271	payment	1397	1397	1678	1	1	3589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurav8umbhmHKhss8fHQpuihRaXvyxNhrQrxZPFjM8LRZ1RuVS
4272	payment	1397	1397	1678	1	1	3590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCfu4jhCso13zVyvwCpHvK7SESKX54a41xVjyKPEnNfgPoe1E
4276	payment	1397	1397	1678	1	1	3594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVfLK2PA9xgXEj7cSgyJ4jArJKKdcYsaZv9wZWsvuDYaGBgMR
4279	payment	1397	1397	1678	1	1	3597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76tfRBb91Gq1qSYQvDjJq9QJb2GouhQfkezuWDySkvkqgNkj2
4280	payment	1397	1397	1678	1	1	3598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Q3EKPyxZgGkr6NypxUcHM5xwwjdvSv6HNeRQ2bq2ETRa28yK
4285	payment	1397	1397	1678	1	1	3602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDsWSYpiijMYFzrFVE2yUAB5ejFkE6DJbaoWeGsH84thYcxrh
4288	payment	1397	1397	1678	1	1	3605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQPWMEsKBwBkkKSBjV5f74f79tGS6xd1UKpLAKwogXSexJwzv
4291	payment	1726	1726	1839	1	1	64	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcNvJ7rPUn3LgFaXnHiZAA718UkiA1ZY4RCJDXoQAKYVmm5tbD
4292	payment	1397	1397	1678	1	1	3608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZhqaFXEinJuJYG2YQLcsi5XeMc31h1iccnoGv3EtPU61DxNa
4293	payment	1397	1397	1678	1	1	3609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxp4oStE6JuP6nPkqniAfUSiBYCV29xSpi576a2xyuJhLtfKMs
4296	payment	1397	1397	1678	1	1	3612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtEMtdhiwCgj9i6XEFcZ3VZT4WNLR6r4dEnRQUDsm14DB2Ryfw
4297	payment	1397	1397	1678	1	1	3613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECuSptgu9sJm9BDgnSHhn5Grs9ZEbqxmiCBhoCZUL2S2h9h1C
4298	payment	1397	1397	1678	1	1	3614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNF3mJiBTAotPdcHrvpDnQdNJLz6u2bihRUSyrAp7NxbzSfME
4309	payment	1397	1397	1678	1	1	3625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawjhesziPUTqwzpPhU232WCfKk23RJmXwdo9GPpyKMXp8y727
4320	payment	1397	1397	1678	1	1	3636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUxBoNrkvCsmf6JDksJezfstRh1R7ENEEVVWUVPgfLUeqYVTS
4321	delegation	458	458	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h9XbrQJS13T58zaSrxzPULi2Rb178siP88KDpEPyEzJ3Tyhy
4325	payment	1397	1397	1678	1	1	3639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5hxUsRDwBSQecTPPvDNNMvPNjgkFVXy9k1K7GxrXmp1JDCTa
4326	payment	1397	1397	1678	1	1	3640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZYPaxZXLnApDqYz7vvHjQQJpBrwHUgA8x6prLTKqKUg1E3FE
4327	payment	1397	1397	1678	1	1	3641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe23kgvUEmG7PoQTtidrWgWeA1NxWvyNPgUp9eYQ67U1YXoaLb
4339	payment	1397	1397	1678	1	1	3653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmEdwuybXNzrsD9wSAwv1FGw2cV6S2gKGwQVxVAC8yb5jZrtK
4342	payment	1397	1397	1678	1	1	3656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAf2enuYLTetoXsW1Bv6YTxZFXiVjXiBuvsQC6vMJ2Vbjd3541
4343	payment	1397	1397	1678	1	1	3657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmde5LUyWRupvUqWP5d4jbyX6vEoLVHAvex6mmf6UyneeRZti
4346	payment	1397	1397	1678	1	1	3660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4J9qGjJPPqm3KN1j8KYpxCjhraFr2uPnVdZ3p5HixEKx5d2ML
4349	payment	1397	1397	1678	1	1	3663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupqn2Tz55cKpdyBjJMmMq37nxyXzF3Fxg1YtvK69e6tKBLT2t
4354	payment	1397	1397	1678	1	1	3668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUcn75VeAMiXmBtvJSUqQhXauDDWgoigTaKT641V4shqwbEDK
4355	payment	1639	1639	1840	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tm7AkxVCCwCvpszD5mGLdguwtzTgmcF77oRYkrCwUXLpopqw
4360	payment	1397	1397	1678	1	1	3673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswXmqvPVFcu69h2Bbv58pQV7AYAcJhvTK8ie4b3PE45p1vyT6
4363	payment	1397	1397	1678	1	1	3676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnjEi9gahy7ZXfXb8dt4Uhmwr8jTadYBue2YZGnqth3ffJGqi
4373	payment	1397	1397	1678	1	1	3686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxT6YPMLFmy9XeGetuj3RWXuJRZCNwkekjnmqLKrjXqEuh38h
4389	payment	1397	1397	1678	1	1	3702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU8EyxRyZ61wWQZ8Q53k4bxLwDE5AxuRjhf7S6ta8EHPWsECG
4390	payment	1397	1397	1678	1	1	3703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSj7Rri5kCfH6bD4EEdRtgq3kzYAgMmfKL2PuuW1YfoNHzkRd
4392	payment	1397	1397	1678	1	1	3705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZUyUK6HBHWpcFfNwUKVLT434zfzbKEyFR7hGCya2sjNLzzYv
4393	payment	1397	1397	1678	1	1	3706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxEhof8LhoGFfRuLA2mTgV6zHFjYhAY4CbftMXSJ19uSDFKfy
4265	payment	1397	1397	1678	1	1	3583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerpwEPBzp1R3vsWQFSGP66zSELVcCevtjFwvVJKXGetytkQxy
4269	payment	1397	1397	1678	1	1	3587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkMb6DEH28X6fKedJfbwt6722srpMHAgpnBRm19nJ9zoxeCQv
4277	payment	1397	1397	1678	1	1	3595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHkgJRp6fdJvXFoaqLoqGmsr41KZiR2tume8S57gnU4YThChs
4287	payment	1397	1397	1678	1	1	3604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLDtEBkp6AxG5TGNsXF2MYeuEioaNrSEgbA9gu1T1RXx29DF8
4295	payment	1397	1397	1678	1	1	3611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeETrb4jXiuXCZXTQCZaRkZQ17TVwaUx5mnkyAzyezCGumsRJj
4299	payment	1397	1397	1678	1	1	3615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLux1bN4QZwUXYLGT6inNzJ3BRsnPxMCEpYM9hBtqVzetnoZP
4302	payment	1397	1397	1678	1	1	3618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvQ4muzdDQSCtJPEZDyTybnDKHTdyHjPnsxdFASVNMdpjoQuq
4303	payment	1397	1397	1678	1	1	3619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7bX5dYALT2YXXhnrboB1iFCZ9Xcv9bRFgPuhuJAZtASxBymA
4307	payment	1397	1397	1678	1	1	3623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9fwv3xShhSm3FXWcsHAnDaT9LXBHEPeyZNhkx8Kb4WbLWxLP
4313	payment	1397	1397	1678	1	1	3629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHSyrVfZx6R8UfJRDLSTZVbUEREeYmJvYmsQD7LZMbuJ8dNYw
4314	payment	1397	1397	1678	1	1	3630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMkZAHhZ66WM5dsdvv8M2A4zfQS7QTn6ZyFnvwzSzku2XtXdp
4315	payment	1397	1397	1678	1	1	3631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p5LuwmRDdyPhRa9VW4auy5D21CJpMBn8UU2jD29hetSe6isM
4318	payment	1397	1397	1678	1	1	3634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrM24opNSrZkEEjPeMbDop4Cse8KgTsLTiAxHX5oeSy5eQ8WP
4319	payment	1397	1397	1678	1	1	3635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLULkB36pjySrqFPWjBt4uyTgaH34jRfaUigxunfeCdWo7YhQE
4332	payment	1397	1397	1678	1	1	3646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijKLGj9jc6cNhj6k7ssLSwV3KkhzCZ2ensVgLya6kUotYzVL6
4345	payment	1397	1397	1678	1	1	3659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8J4jgV2BmtgDDh86ZZSrRuuRjQmsLar3QpyvMb6zojNQkGPQR
4352	payment	1397	1397	1678	1	1	3666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKRoYHey9paxD4CJ9R4XM3c7ivGu5AGdtevaE8BvgKVzHW8cm
4353	payment	1397	1397	1678	1	1	3667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRcLMyo934hFrceLBtP85954ExkrmY64DZhFaoUZHjd3T8hNu
4362	payment	1397	1397	1678	1	1	3675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpD2PYyqeyFpHjUFrR6UimhZ5JPyZgfkjGymQKw2wQA9Z5MNpH
4367	payment	1397	1397	1678	1	1	3680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc7t9o1CH4reobpdQHtnGRB5gRmZC4HmGN5BZqAHUhHGzAHJ4
4369	payment	1397	1397	1678	1	1	3682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3D8MrkDpV4J96yRZat7ZSFy22S6xatecnZowbSHeHargJAko
4371	payment	1397	1397	1678	1	1	3684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXY6pz4s9BoMyaGBLoEqGboJdMuxsSo8K27AUvdyUutPrKMaW
4372	payment	1397	1397	1678	1	1	3685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpV33FMDN5bDy9KvMEomfmu5TX91BvBreNrt4i4dL5E6pDiw1t
4376	payment	1397	1397	1678	1	1	3689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsBRVAC5Xywh8ozLidahef6WKg26ipqLGejBBRrPgH9vEZTeH
4379	payment	1397	1397	1678	1	1	3692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWhSzJfL6jWcudqxMa8p2JiVGt55ZVrBrHWe4qJefXR6JGsNN
4383	payment	1397	1397	1678	1	1	3696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsquPppx2sdGhY5pchz5x2pU8qzUgTWL7HWVALxTfu9h3uiUiq
4388	payment	1397	1397	1678	1	1	3701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMP1c7jdiNt5dWEVfGG7FEKQcA9tp2b1YxQz7mopuRdvjwisGE
4398	payment	1639	1639	1841	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAByga69ikAhofgi9Fa1y3dDLYKnaxp6yNBYZmoZf2z2kC5Vm
4403	payment	1750	1750	1842	1	1	4	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTbVbQxumpRXNzrCtY4mjGEmEfN9m5VXw9iLofdNjSJZHwVCy
4411	delegation	1769	1769	44	1	1	14	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGiBrDJf4qcG8aAEbVkfCcuxZR3gLSdU6wHYJJ1qQLrirc8AE
4414	delegation	240	240	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kkLvsCT53DWmoAJzCyBVoES7wfYw1eNyGkCYLoLXcTEXS5hW
4415	payment	1562	1562	492	1	1	0	719000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmv3KkkKa6YXXgGKkZEvJvZgxkeoqL3BSujU3nCsskWCkXKKD
4418	delegation	1702	1702	1651	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDpRTKtET7rVhpcjaH32zqdySuNA8Uup3MdZuPhq9cAVDBfV5
4420	delegation	1844	1844	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9H6YKLqwWenN9oxFbwb6XzF4Ao3zLyW2P3Wh3GA67z3TyKbh9
4421	delegation	1844	1844	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDkPk96FmtA2HS2qcap6DBoNXXxJVB3uWAkVZMVGMXjjPp5on
4424	payment	1397	1397	1678	1	1	3711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7usTr8Hvvj5LYzaEtCW1X5t44191dz22B1xHBf6uoSSC8GHGM
4428	payment	1397	1397	1678	1	1	3715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZsVaoF4KSMezpQSyJnEFAEdWdpWhpCJopNGoGLMoXSNJi5GPj
4436	payment	1397	1397	1678	1	1	3723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCmZ7YuKgUKvFPAnVJAz4E2CiMT39wm9sgb88eLQ39mrao1mV
4283	payment	1397	1397	1678	1	1	3600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aRpPsDSNZs8hPUzPACGM4aSJdrrbvAGpz7hbdBs2Ayx5QKXC
4284	payment	1397	1397	1678	1	1	3601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9VDfKyQwSa5xZfJcXb4EMtDHAGc1CCNHLjt1aB8Th87XeHg1
4294	payment	1397	1397	1678	1	1	3610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFBbH1K6m6cyLUWrwQpnNhwuRAf1fJAgdXjnc3K4mcLPm7vMJ
4301	payment	1397	1397	1678	1	1	3617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9yH22JMosjyt36DU5HQQbCiuMxZHn7gKmnkkWn1EPbw3XMYL
4304	payment	1397	1397	1678	1	1	3620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGbEC4GobEFgQQ8gznXGAEDNrKaQ2RvJcJeBvrb7SEVwfE4PT
4305	payment	1397	1397	1678	1	1	3621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54DCboULhmfGrvKQAgH42aFtA71ajrWTwa9pTBASE2e5vtXDW
4306	payment	1397	1397	1678	1	1	3622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzyeRxnWpz1mkYZDFiJXtzmy7t6pRVZhAyfuJGR5cA8MPRyBF
4310	payment	1397	1397	1678	1	1	3626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHc85a9QSba6LWjLuLDrLFNLAVh1Vprbdvoj1UbpCajAgxVqsZ
4316	payment	1397	1397	1678	1	1	3632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGuPgXxNmXXJbjUtoYMwYJfVKKbqMjwS1ojjQfSbBBCsmrLgX
4317	payment	1397	1397	1678	1	1	3633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvonbiyXnXNv7V9f5WzZcYSjchQK1p8JeCYdq9X7Efeh7phnz
4322	payment	1397	1397	1678	1	1	3637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN14LqdNTtXTJzXqN435pLDFfF9hWosf576JNYSnMZSbJumw9
4330	payment	1397	1397	1678	1	1	3644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCDiUxsxeT5fah2kTVjyZ8Xnhn42QHgnvzea56vgP1fSYBnkx
4331	payment	1397	1397	1678	1	1	3645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACyTouYvDHWRFCuAvqDAzJ2CaxrJCs8Fggqmm828AKkKQhMWD
4334	payment	1397	1397	1678	1	1	3648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXFQQg1jZcMvxT6vHugdgs5NyEF61EHTRa9pACpLHEzUWs1Qs
4335	payment	1397	1397	1678	1	1	3649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcGxw4HjMcJ2yK7cnUJyrN2zi5pYQ9wgRfydV1GyaCuWkCuei
4338	payment	1397	1397	1678	1	1	3652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCMv8g8Sv2sXKCQtRGKxwbHCXcYaDBjKJdsyvKG7WwxH1aWfz
4350	payment	1397	1397	1678	1	1	3664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5pQKBkUhwGKdbt2ZHkMZMJn8ciLvV8mtoGxH5Kz6AYzwA95H
4351	payment	1397	1397	1678	1	1	3665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5BSoYD2k6UFto1d6G27Ach4RdxCydLGFvEhQmF7fTaQd6dNz
4356	payment	1397	1397	1678	1	1	3669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgeDKybkTn5vLRYsNQZdRKWVfsnFhDwSSuTYJjwo2PWWmfV41
4358	payment	1397	1397	1678	1	1	3671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzS175Y4eykZhu42JaBuoNaX4uPq5Mm8FffB1vx7BZHUWMwXD
4359	payment	1397	1397	1678	1	1	3672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1sx5PxRQsqdg24JuVZVJWyDwEHYLWavF6Btukmkdt81WB6Dy
4365	payment	1397	1397	1678	1	1	3678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWv5AThQ8WgkB1XDmTnrkzDHfJMFGuLzZSyn8xu3apvH8YFbzt
4366	payment	1397	1397	1678	1	1	3679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCG9hL7QgF9FRadhmuZEBFGN7UhwGxxceZX3UVFkmz6313kZKa
4370	payment	1397	1397	1678	1	1	3683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwez395nK84SGRdcN6qWtY9SVqdfzqnF4UiBKDGpyxaBRHPqd
4374	payment	1397	1397	1678	1	1	3687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEiXf1y7bhkUR6zWWGhSKdaUZcBqbLLLar8EGY95udV6vtaNb
4377	payment	1397	1397	1678	1	1	3690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxaNX3DFkiJyBVfG1NbvUkdNK8vZptfQTLaqNEqShbZapLNes
4378	payment	1397	1397	1678	1	1	3691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ275tE4At8kgnkpU8ywopsBNNBitsC2jLH8VKYh3iwbUKRGqpJ
4381	payment	1397	1397	1678	1	1	3694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoAYVCEBdNJes5g46QdjmXoKZgeCXhToRpjXS7tRojMe424mZ
4382	payment	1397	1397	1678	1	1	3695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqedPWxsRSvvfNZmRLDryKSMCaoCcaM8wcMgG7BEvn1e2UoE3d
4384	payment	1397	1397	1678	1	1	3697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrViPpQ9bzc8QS2nowJxAakdx1NpupVDe6aeb9BUJoEHmubeZ
4385	payment	1397	1397	1678	1	1	3698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwVgAqyZf377gtfJtEaphQr9Y9MquAv2vPttPzCJc5YpGHKSQ
4394	payment	1397	1397	1678	1	1	3707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNQPJ89S77wMTxbjnrj3cW5aWhH87ZPWcN913TtZoqxRvxpnU
4395	payment	1397	1397	1678	1	1	3708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7QEswBpxmEaEywrGEewVmf3uGMYoGz8wAtj65qKX2sMpw86g
4396	payment	1397	1397	1678	1	1	3709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfgLAaqREPMTWLiWNefTe4KzkYqdFLvWV9kibMj3YAKs9V7Uk
4413	payment	1802	1802	1833	1	1	0	190000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaJenUqFp6ZFPTLmz8ravXKikMGBQe9F1oY3rXmYgfxyJ1Pqh
4417	payment	1682	1682	1850	1	1	5	8624000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGkBQDSmaPb5pjVZWNeMe2NaCW5FmGuKpZev6tH1MxqHafFST
4419	payment	1726	1726	1851	1	1	73	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJaNMqEPgFbRuD5RAozfTqiRXi8oxkog3UhcytDJ5DHfcU7Zym
4429	payment	1397	1397	1678	1	1	3716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4K6op1kzHfGoY1t9vW7E1XPQwV6BzsG8cAmnZw3hsV7JjbQB
4308	payment	1397	1397	1678	1	1	3624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhR85AU1gxczUK4WF56PRpCXanZLHohdCMMrAiQtvHb2fLcqtf
4311	payment	1397	1397	1678	1	1	3627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqvENCwRPjDesaPovqxMHrVHvR2d25zbHT7bfgacT9bEoAfih
4312	payment	1397	1397	1678	1	1	3628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CL5Sibu2TU7BemHLpsE9Ewo4hGzjW1KYBWkuNho2RiDGy9Xn
4323	delegation	711	711	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtQyAE9GwWRMb8oNys781iLnkiFNmrFWVfL9GyVPgUmVSdsQB
4324	payment	1397	1397	1678	1	1	3638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUa6WJHqQWYswaa8dvKEnydDX6WngbxFwfAqMsZftFtderyXd
4328	payment	1397	1397	1678	1	1	3642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzptv9ubGDj1TRv462gyE5eTgUyKsBaLo4gZomfzx2nDqQcJZ6
4329	payment	1397	1397	1678	1	1	3643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvKmEYLNg88YvXjjzHzkA7GHrzbmTVN6xe9AsLnTT9CHuSKzp
4333	payment	1397	1397	1678	1	1	3647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56naf4jJWwGWHRZgPkcaDaUVinRaQKidT6qHoMKKuro1Dzt38
4336	payment	1397	1397	1678	1	1	3650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYtn6hyFUBYbn1XnSQ8SLrQw7SC4tHeWMNU4nV2vF47D8ZBye
4337	payment	1397	1397	1678	1	1	3651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFpLd2DGQk8VrgzUzoHiGovSjXQvUwS9HMf3vRMx25C3UUjXM
4340	payment	1397	1397	1678	1	1	3654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1siSAqAVWrmcKQeuFci82WJNRFWebF9DSkoZpoW4mSp5Fn1Zw
4341	payment	1397	1397	1678	1	1	3655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydZo6L6CmXXXNPEku44HnBmd4WTSpnePyy5eDDDZxprtZDvQW
4344	payment	1397	1397	1678	1	1	3658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbtipgScvAxW3C3PFbTZAoS6CWxpsvGQYs4dCGvyBx979eU15
4347	payment	1397	1397	1678	1	1	3661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5kEWSKwJscuKQYk3dGQFiuriN3jSksWmnZeWn9hXduP7GMCQ
4348	payment	1397	1397	1678	1	1	3662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hYtb98ZMRbZ1xUCgwnEaVTMb1Uwa3AgU875AwvemNiADq3Kf
4357	payment	1397	1397	1678	1	1	3670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMkNd9ciw6zoYAfBVzfZRg5btg4fbrDQw4NeoQxMc5cMPQ3Z9
4361	payment	1397	1397	1678	1	1	3674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU22GxyKcpaYJStharXngEwbKXtijvPvCd8SfdYmkVayriow2E
4364	payment	1397	1397	1678	1	1	3677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5Jt7PPiDbuNgHSNFeU6gcgW4EzGoMXKMJaTuiMMXBgJosFAY
4368	payment	1397	1397	1678	1	1	3681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxMjWBwHQRyhBwiohuG6FVsFtxTRudgFjGWRpGvbHsu4i2tHz
4375	payment	1397	1397	1678	1	1	3688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpstA7qYT5er8bCG2gBD49FmpXt2NBwwoYzex5rQPif7KbTZtv
4380	payment	1397	1397	1678	1	1	3693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs87sA2U1yLGeMt65MotxxxKy444FvLdb97LUC5xoTTV1uAMhB
4386	payment	1397	1397	1678	1	1	3699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kLNK9KSVN7g26b1GfCaR2vBD7fqgvdiGi6eC7EST3mWv9BBF
4387	payment	1397	1397	1678	1	1	3700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NMBXL9pqmjMRAB7dk2T6TH4KhSciJmSU4sQprHncjRJ7Rb21
4391	payment	1397	1397	1678	1	1	3704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbSGHEXBEfVPfs2vdBbL4i2qwPaTJCXWmANcZLv5Evmqhc8fWN
4397	payment	1840	1840	1639	1	1	0	100000000	1000000	\N	E4Ypt5Zhf6VAojcJk16GVuepGUk75zNQyCJvyTz3Rj9LCfj4Sh6id	CkpZNjKYvmbaa1mYZZiKDCKdhyrtzzkjdLE5ducGq64aCxpn46JWV
4399	payment	1841	1841	1639	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMsEhoG9fZS2H5KecLswF46BeatJq4edTXqxH6CKow4CVxbFF
4400	payment	1840	1840	1841	1	1	1	890000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcGnkrGv9agviDRBtwpfk4NRYD1m7hxrR2po1wbnhMkeCHeS6
4401	payment	1840	1840	1841	1	1	2	7000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCQWkjdBe9a5CWjN6BSjwdv45dkGRdiMnrcKkXFNr8SVLLpXn
4412	payment	1726	1726	1844	1	1	72	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYurS1pfBYaJwz7La1PrDYk6DPddQrzGggUfpgar2gug4rxKmyR
4416	payment	1682	1682	1850	1	1	4	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMVMYeRYEDU476kbbq2MM5c1pRk1PKuwtU239hc2xWKcfxaJh
4422	delegation	1843	1843	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEqCDiYX5u2pYJYJUG8WQH2qCECY99qRmYvbiVHyyYi2bBwTi
4423	payment	1397	1397	1678	1	1	3710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfciUdosTb9Cpj7n2Up1458a3t7FGi7a4929yj2U5gGs9MiL7y
4425	payment	1397	1397	1678	1	1	3712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHqAHaPiViEzRmb36CzX3tgucguqXdzKvGpjkJHP6LBaBvsuL
4426	payment	1397	1397	1678	1	1	3713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwEE9Qib8Tv9tMNgTArXHti95YcUBUi2nJRYXijMV6VAaBpA2
4438	payment	1397	1397	1678	1	1	3725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnNoi7QPayhzHKqruinoDVXwCWwBxKwB4kcZYjsmHYA24ii8b
4439	payment	1397	1397	1678	1	1	3726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBasS1eFukQNUUWVTPGtXW564R3Fr4t7bBRbdzKAEf8W1oCQe
4441	payment	1397	1397	1678	1	1	3728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoYmRXUjKH9rtgQ1Eru39gowPPcQr8qrPbgX9KN9M64XbuB91
4442	payment	1397	1397	1678	1	1	3729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgbBT1rVC96uLK3qk3nHfHK9VqY3tLUtYys5RCfKjoYHBsSu9
4402	payment	1639	1639	1841	1	1	2	716217000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81NjxKRUBj4GNFmqKxJCMGpBqNoqL5gMHNf4Fq4keJ1yUMVqs
4404	payment	1726	1726	1843	1	1	65	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsvPq1kWwCmAzTUDhcjHmnRFkG5FoLAeKUPSWKTVbhqF7DBH2E
4405	payment	1726	1726	1844	1	1	66	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJcXPv4RWLSJW4xXaRFm5zG8AfKx7kBwDtdwmiqzaRzz3jsiV8
4406	payment	1726	1726	1845	1	1	67	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJox6NgkMZydM68cHqmVW479GojGYuWKdzWPNtUJ8XhXUCR84u
4407	payment	1726	1726	1846	1	1	68	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZBEMnXdsXXKbtVREotc3K6GKaGcke76W3NAKET6QvGDrrH8bRP
4408	payment	1726	1726	1847	1	1	69	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoKLASSWYo6tzoLQeYe2ogb8mkFudATo6cHL4UNPVQWwUYEJJv
4409	payment	1726	1726	1848	1	1	70	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZowetyuQTSTP32BJH1eoBLsyTv9x3DfQsVDx5XgVSGii6f21vk
4410	payment	1726	1726	1849	1	1	71	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXdz4yg9N4qQigtimcWxqQjRCTsTh5z7jZqtbVBNTKFBfYwdaU
4427	payment	1397	1397	1678	1	1	3714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHzTozo5kcp4Q7oJAXHLMKhnQLvcv3cU5a2rqijdU1TmofXK3
4430	payment	1397	1397	1678	1	1	3717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRU2erRBj8wnBHWZTG3hK21xQVCbQAS5ZLc7h9DzmnkC5VorQ
4431	payment	1397	1397	1678	1	1	3718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaW6eLd7iY71Y8h4UPyDYqw6yWGhpjEB4JEQgiMRkh768XqA94
4433	payment	1397	1397	1678	1	1	3720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BgerNbDjJUAcg66cF6Fa3rPuGijRzzy4NLBr4bF5QtJ61AHT
4434	payment	1397	1397	1678	1	1	3721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvG769b34nxcukFou9baoRJC383HHypUvXV5BfHjZAEohLRp4
4435	payment	1397	1397	1678	1	1	3722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjE6sz3kvgpcm99duUkfQEsUjeD7FKRVZNqmSRnV7HYyxgywE
4453	payment	1397	1397	1678	1	1	3740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU66D1R4VHwqAkhN6MWYFMqY3bU3Ue76Wu5Qpwax5t6Awpm7rE
4454	payment	1397	1397	1678	1	1	3741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB11xfz2fbe4ydCabLX1cUM1DH6eqfmPqxrNGk5XMYuDPDjWit
4461	payment	1397	1397	1678	1	1	3748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9HC6V8aFgEZYLKTfwfPvof3PjiUA686NffP1HnY8oTPFpHw5
4462	payment	1397	1397	1678	1	1	3749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xv16pg4YzTYj5VLyDwrdBRhehxrFDezqBppHyQjmxFj8c2p4
4466	payment	1397	1397	1678	1	1	3753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFaBBdAHYxVu9GSbgmTDn7JGrZugcz2oanw6Jm9fH49Geu6P9
4483	payment	1397	1397	1678	1	1	3768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKjKRd8wHCXFbHNdbCcyVUZchEZSYsj6Ly4AoYWomJ9CxTGJgs
4489	payment	1397	1397	1678	1	1	3774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6miAv6wMAptBQtDfLBePzUuVspdSFUqzSfd9SMTsVEsTQ5nGH
4490	payment	1397	1397	1678	1	1	3775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjedVRjrZujwg45RJu5YbkBR1J1DsamxwqUQ67aGXsBrh9kTjd
4491	payment	1397	1397	1678	1	1	3776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9kJys6DWVetENbvwJNV334HeSJD9g28vkPiSwKXAyny1owXE
4499	payment	1397	1397	1678	1	1	3784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XWzpbT2JP8hZ2je6tev337dEye9RteF9cimmX6TkxujTPTjL
4503	payment	1397	1397	1678	1	1	3788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBVkFf4H2yrVaKak6yuNxLZ3a4RvLUgX5BRdpJVLnCwky2Kdr
4517	payment	1397	1397	1678	1	1	3800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgnHKwtwq2XVn1kkA3R3GjibAoni271zCDjwaMh1TVM7XGitP
4523	payment	1397	1397	1678	1	1	3806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDmnuVzuUH4K6VQLcJJUDTP6eyhR44pBG1MzfKDLKtnxTPiv4
4524	payment	1397	1397	1678	1	1	3807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgeAc324fA9XUYDioDjdRapNzZuERqZ2noc7Qahv3KiGeo7c6
4527	payment	1397	1397	1678	1	1	3810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PVvRL6Rr7teaCgEL7cEdnGWG4v8PP7XuihoJajNEdwu8ipzo
4528	payment	1397	1397	1678	1	1	3811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7GExWHrjdxL92mpd1vJBx3uX85hVLyc32223zKW8dzBeifWJ
4529	payment	1397	1397	1678	1	1	3812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8TfKVsTt3vVc8jDkCSqLSVaaGMRydMTgBDJxG1WLEaugXGTG
4532	payment	1397	1397	1678	1	1	3815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb56RixxueRM2sVy3Mnxug8ydmTMhEu9A9c9wWpqZXU2WtipgH
4539	payment	1397	1397	1678	1	1	3822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWAHy3aqLxWKZ9cmgRZen5XXxsUZggsPcpwbRRhfX2NUwtWgm
4540	payment	1397	1397	1678	1	1	3823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveBJAXznhfGHZKjYjA2xfQEXc95c789Q58pL4C3YYrxf4WNJH
4541	payment	1397	1397	1678	1	1	3824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnW6EaZPz1QH7qdG1KGDAqDtHTgHupkPHiJiuyH8sxBdHS3fTR
4542	payment	1726	1726	1856	1	1	78	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZPfVXnfrKymkoPbJP8LDFGK9xSpWTLwWnPDadeb2UG8uhkTFZ8
4543	payment	1726	1726	1857	1	1	79	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYx5zyk6sVqrNU44mbVEJq119LehNN1rXskFLGzNNvTotKhKmiX
4544	payment	1726	1726	1858	1	1	80	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmcinNqWeF594WxFL2ZTU43tKc52MNCBsjsn46pifzUju5R42P
4432	payment	1397	1397	1678	1	1	3719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUgSaQoPSzN8YXLhApTEXsskudiVCQMrsjmiU4PxDQb7WASVn
4437	payment	1397	1397	1678	1	1	3724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPUUTpJu5C6P3xvW7YDkinGWRdXUngNG81RJVpCYutdBqNcYx
4443	payment	1397	1397	1678	1	1	3730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8oUvDFfk4cAPn3Sk84SD8z45mUqjBpwBMH2GE8K3phn2bQouV
4444	payment	1397	1397	1678	1	1	3731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfdFWsNMK3bJ2Xi9uY4a3BSRQtpzapBUzZDCRnwpGTnnJ8BZU
4445	payment	1397	1397	1678	1	1	3732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6PFo3cALEEoQbveKwvKdDpsBqYsa5yxe7BQ7qPET1H4WALYf
4457	payment	1397	1397	1678	1	1	3744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8KtX18U5YqYFSSQhGsKHJ5hjtBFBd37dRT1jUVCeVXa1awjJ
4458	payment	1397	1397	1678	1	1	3745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxpZ4UkWxs818UJbeDcJTD9z4AxSEM6j38USfw3RKMD6zT5Ld
4459	payment	1397	1397	1678	1	1	3746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVUWn4Eizjr4KqSUVn34mV2C9KCxEHoJ6nw7bR2fVvvrzx4qQ
4460	payment	1397	1397	1678	1	1	3747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRP3QraXFbBQ2rEArKBkAb8zTuCS5Mg77u3rKHEsELY5NVRrxY
4464	payment	1397	1397	1678	1	1	3751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBfHpmdehvLGQaLbuMUCJc82jQbu9GTV3ZPCHsVVM36KJ4fdb
4465	payment	1397	1397	1678	1	1	3752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEX5H7RFx9NWmffzo88ENWMC5ECKh2D2Yt4NYLajxB6ZXGu6p
4475	payment	1397	1397	1678	1	1	3760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHxhep2JJoMY8qvbecsc8dbXbYN3VMb3wdxaW1d8udCMXcNDr
4479	payment	1397	1397	1678	1	1	3764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7e9YN9VcR9Z8RAijBJajkQat7ZioJLYKX68gDicaL14697SF
4480	payment	1397	1397	1678	1	1	3765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMuWWX9zrTembJPRvqirzwmAKGCa5AETbwsY3HzyDq6JVht6b
4484	payment	1397	1397	1678	1	1	3769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhBJVSmNtsHbs9KY8thCb1FEqUiQwAMoyacEQLRhV27fm9RhP
4488	payment	1397	1397	1678	1	1	3773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM48fQrZKLqgHukzexsav1M5uruGazLdpxoHci4Ag1HUD9RzT
4495	payment	1397	1397	1678	1	1	3780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHT4UdW3KgQaB3LGyCBhq5zusD2trh526TTEeedMQrqmbVdwU6
4496	payment	1397	1397	1678	1	1	3781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofX4xr3ocTuWZYYSGggnaNEdwtMy2Y1WDLQkeYC8dfrW4YyoJ
4497	payment	1397	1397	1678	1	1	3782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tZLBQbQXNSH23JPrEM5utKfLjJDzFcePecHhgXxc6oKYid1L
4500	payment	1397	1397	1678	1	1	3785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQ15hQq1mykC4Qd5Xw1NzNX339abHk1zyADrH96DQbxtom3op
4511	payment	1397	1397	1678	1	1	3794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4pcRoNJhfYVT1RyQeGZYNpc1ZBcYjf2qr58NTsoK8rj7TjR6
4512	payment	1397	1397	1678	1	1	3795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECLVswQ7XgkTStDRziqHkyaHsZMpvoXmJFCJm47JT7A1oKLoj
4513	payment	1397	1397	1678	1	1	3796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjw55arwXHHnDBzeS36w2jVPDruMKSsqnEiDonSVsdabZEjLD
4514	payment	1397	1397	1678	1	1	3797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qY8oGQNsm2L7S4FDAV5kk9nepoNMYUE2biCwFHsdXFn8FeDi
4515	payment	1397	1397	1678	1	1	3798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSJVuRfiAaVv9p6ax2wFFT246R3kGxHEATDj1ZCQuVGpoyWtY
4522	payment	1397	1397	1678	1	1	3805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8mKSyxXKaLYDjqV63WitRtbF4seSJFNfHjc9ecDtxoPxsrwW
4530	payment	1397	1397	1678	1	1	3813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnE4vsZrYvGrozj8hPx6ujvmYofu5GLqxqiPp4vFN17dBrWq
4531	payment	1397	1397	1678	1	1	3814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAQDVZYjyrzqRt5SeUcsvGEZjzNCGoQXMseh4MTVCZ3rJSNfU
4538	payment	1397	1397	1678	1	1	3821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi39WNRrQDF2XevsNkMPqZwG9YeC3EHdgHc2ScXt5xN9BbfKH
4556	payment	1397	1397	1678	1	1	3836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtW8RVnC7m971jahgr8aUnHYXQARNaU6KsgzrdrGmGPr5Q6sB
4440	payment	1397	1397	1678	1	1	3727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbjd2LMGnLwZkDGTqkN81f4q4Ho7MdL7QkfEHrU53VDcfGTtS
4446	payment	1397	1397	1678	1	1	3733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZoV8QLDSGMovsbaofz6XFJ1ciThaSDF8Hj9tpLMpV8knT4eZ
4447	payment	1397	1397	1678	1	1	3734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwrtZySEVSfS92K8ZPi6jZfQeVCKWfvnTiw3NvH4t2sQaqLaF
4448	payment	1397	1397	1678	1	1	3735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qUQAQ1b1sBk49aoRn66THPAxBqMASvZZh9NQU52yzjaAo8rs
4452	payment	1397	1397	1678	1	1	3739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfjyy1FXpr7ycptHpv2hTsPjCCgt8H6A5rciedMqaDHPSarF1
4455	payment	1397	1397	1678	1	1	3742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5b7zFqDhTgVJSFRUDZMYH4FjdNmjsRF7pnntk8CvVmaxt8vs
4456	payment	1397	1397	1678	1	1	3743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZKk55jZ5gdfeQqsE7MZKVbvgSuWHARqb1BqyaiyesXdLyzLm
4467	payment	1397	1397	1678	1	1	3754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CCj9kzWUva8uS8Trwp723WqccyKWYcmg87aopuExj2FbzTLV
4468	payment	1397	1397	1678	1	1	3755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdmg8rn6JuwHRtTGt6YBbgdqnk63VEXGKSZUZUkZAn1VowW3H
4476	payment	1397	1397	1678	1	1	3761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEA4Y5fqbBMS1uixCf6McLx29dESVeXbvPTtW62ChRDtRG9pER
4477	payment	1397	1397	1678	1	1	3762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaLUSetU8fbo44E4fACPpLgfb72HvQtQFGLt5pRUAHBF9t6Wa
4492	payment	1397	1397	1678	1	1	3777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54w7okpM1WSrektkNZ3iG3ogm68GpdWZQme2ocDAo5Vvw2SKb
4504	payment	1397	1397	1678	1	1	3789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtySCFiUhJfg4Kcws2EmGCsBdRLtU2oSevzPUu4s8EAxuKPbs
4505	payment	1397	1397	1678	1	1	3790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAhGk6BUpjDS8phFijXhg6kKKdQaX8jUnRyzgbVoXJUFogqu1
4507	payment	1726	1726	1854	1	1	76	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZado5iYmWKJEoJSVGgustP3aByKKVwK6z2SijedZK6svZASMRi
4508	payment	1726	1726	1855	1	1	77	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxGywmwPdJmyg5oksQPrLqDjAwYGS43QyqpQzaoNaF1TrvvPn9
4509	payment	1397	1397	1678	1	1	3792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcb7krbybrFeF3gtCP8nBTzdpSXrYqnaHeeVfTie4hz1hy2TcJ
4510	payment	1397	1397	1678	1	1	3793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwKKYbCcsCZdZY8XrjSVpZ9NKYpqz7rFyMf1qvZKwLCV7i5Yt
4518	payment	1397	1397	1678	1	1	3801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkMcykpt13U3dTiKLuBRqH56YWWPVkchfzFxDFnZEcRD2eSjh
4519	payment	1397	1397	1678	1	1	3802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZKn1AGAbMhkv3FZYA3CZRc3wj3HgMvjh1SoQrfsA6QyVBujy
4533	payment	1397	1397	1678	1	1	3816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoquJS2CrQup35Df9ALanpPKKNwAwSdubw6DgfLgfBScp8BD1t
4534	payment	1397	1397	1678	1	1	3817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MmqQR3rthZAgoyQCCaRoAxkMBoYRyACURLY1auB1Muqpfk9B
4551	payment	1397	1397	1678	1	1	3831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQeWbSWf3QzM5KP6xsMAASL1caznJv1RdheygKPmNnrNeUttZ
4552	payment	1397	1397	1678	1	1	3832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpmK9aRgeqcMWQQNvPDxFYCqSLB65nsG2hpsYbnWsBXYfXW7M
4553	payment	1397	1397	1678	1	1	3833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRERF5xmQhqjZpgvQTpvsok8EKdqe9aoMRBqUr1GWVLWHYomU
4554	payment	1397	1397	1678	1	1	3834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHFW5osw9S8kUWixEDCjADC4M8auAb2zd1QZPApkJ4mpt15uH
4555	payment	1397	1397	1678	1	1	3835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4s4JypotFB9TY4DjF6zTHHFd2wUDJRiSpwd83mfAFX3jn1khV
4449	payment	1397	1397	1678	1	1	3736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1zbvcK7ZYvpBJmvhxkkAaL1msNLT15z2AuJCCqqvRLHUzJjH
4450	payment	1397	1397	1678	1	1	3737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUheVsSt7ZyeDj9C4MvU5ezwxB1999tq4gzpzfqEnKQMveNTy9
4451	payment	1397	1397	1678	1	1	3738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNqqP79oeRdRkuQvNE2VtArNj1hikhLKe9k2UYa1UwYjTAfoE
4463	payment	1397	1397	1678	1	1	3750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsL8ibBFhdZXurnDexx9uCRecffC9aGnccP82YyuthtiAonYLY
4469	payment	1397	1397	1678	1	1	3756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQBijMZmGAv93B5xM6mdNwfviN2NayFrjCy5bm5Tc6fVKDgEG
4470	payment	1397	1397	1678	1	1	3757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmB7vHf596RoT8XKGjRmQLb1o2CJm4Bkeew59GjU51P9Rw7h3X
4471	payment	1726	1726	1852	1	1	74	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3efXHumpr6VDmiEV6hgv2KgWVPpPVmfvWHZa4eR5XkyzF4GYj
4472	payment	1726	1726	1853	1	1	75	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6XEff5WXEmGp9AabgnktcUWBNyM7aNEqYFYehL7sFvmJzZTiC
4473	payment	1397	1397	1678	1	1	3758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyKzWqTcg7dsTNZfVDhJTmvenvsp71VJvJghk4ZRCShrHFpFa
4474	payment	1397	1397	1678	1	1	3759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6ftLcMycsCC5CJdwUAEQwRmLVjQiaCu8cb8L32aq324DuADK
4478	payment	1397	1397	1678	1	1	3763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5SS3M7xeG9MmfNUDJh2nNb2CCY3woPshCpZXXzyigKEyo54a
4481	payment	1397	1397	1678	1	1	3766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUsaSW9sbRnC4XpiRskU2zAWuyRLWxThtrQrFE1fdFfc75Vb2
4482	payment	1397	1397	1678	1	1	3767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVaaX9ZpmNHrHGFk1CtVyhXGxGYWFnGZYp9rFdnjhknnkwif7
4485	payment	1397	1397	1678	1	1	3770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieDK9eQRoJEjBtQKqS115bM7xApdbkbWp4sA4sqbpfyboSYbQ
4486	payment	1397	1397	1678	1	1	3771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAA1pDoueQLRF1LSJDGJWUPGu5C1ribRC7US43ex1oPk5YisAz
4487	payment	1397	1397	1678	1	1	3772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRCftyvLFPXWFy16ZwjQQL2wRDj48uhsjQDXhLgQknRGJArbn
4493	payment	1397	1397	1678	1	1	3778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZz1nHe2Pr8M77sVuLM83NfkDcktnzkfhzYv1AQsx1YXK6mUH1
4494	payment	1397	1397	1678	1	1	3779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxudarmARp9TMcjtkRjgXi6U91WsaiG23byvD95UkBqktmSLg
4498	payment	1397	1397	1678	1	1	3783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqmLS6sVTAatGdHmE5iChXFodpCQ7nKsYeGVHaNrjwPGHHfwr
4501	payment	1397	1397	1678	1	1	3786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMg64gEzQmADBdHFkR6ddjjLSetLiB6DR7Aq2CRwmXqnaGVYAJ
4502	payment	1397	1397	1678	1	1	3787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb31uxBZig2HZf9H1EDpiwKy2Zc1ynT5X184j6MoKoWgS7ZTLZ
4506	payment	1397	1397	1678	1	1	3791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEi9DUpeFL6urpXgfbUiXcTK6mzQckRJfwygW7BRKzGCrSEBsu
4516	payment	1397	1397	1678	1	1	3799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJq6FkYcZXYkDmd5AEryVXPF4ZdU2pJes5JqH1Z47jvU45xrQ
4520	payment	1397	1397	1678	1	1	3803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgmiwge4sGwTVkgduWGFoLfeEoZ75SoS9GAtP5pF9De9yfGAf
4521	payment	1397	1397	1678	1	1	3804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYL7W5t2A5bmvmC8APYsHtgS1984CKoTbAFsQxNH13kyg3YYD
4525	payment	1397	1397	1678	1	1	3808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkHk2yHDg2YR3aFZHb2gioxEFdd3nnSDLN1TT3s42fuTBmuco
4526	payment	1397	1397	1678	1	1	3809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs29wwH9F7uUKi9QLQbR2cZcuGaxRvmzY46Bpv7vASedkdAYUD
4535	payment	1397	1397	1678	1	1	3818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKzeiMWn379SUYUvamc5jTqnZhtfUmKiyyCAVatoinvPBcEAi
4536	payment	1397	1397	1678	1	1	3819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1emr4k9wNisRQ5odNoeqR3dZWfNid8xygHuN5ai1SEWTwLXm
4537	payment	1397	1397	1678	1	1	3820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKh5vjPE8bGv9BDEVJ1UbMZENTJYEQXBRXQevPqq8AfVn18thT
4545	payment	1397	1397	1678	1	1	3825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaZbpNcpuGY1ry8mMuH3zt85aE4ZoeDHsuGxT6n8QvBT8fgkP
4546	payment	1397	1397	1678	1	1	3826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zwgksQob2zhwbhWKAoVMjrT7H9PN2121gwMwmQF1YWGkN11T
4547	payment	1397	1397	1678	1	1	3827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVRD7wAxSM73oLgHwkC9oxbs7uzTmRWv4NsN7z9LXJhxGC8RT
4548	payment	1397	1397	1678	1	1	3828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8FTtSLbHDiP1xZfo9Ys9BL2H8zKCd8m61BKf21NWEJxqLofX
4549	payment	1397	1397	1678	1	1	3829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN1DRcyCDwhR8uQEtb8NUhY8NXfRYNVq2fHLrV3iduU6cSq6S
4550	payment	1397	1397	1678	1	1	3830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHs8VnSnt5T7CDacH3zKWdxg2kmveHK6gR2mHxuz3JCLsXNgh
4557	payment	1397	1397	1678	1	1	3837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiUbXo15zBFEet9HSKiThbAQgfh3cPqpF6uNZQu3vRZJRwt82
4558	payment	1397	1397	1678	1	1	3838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LtZPTtgUYe4UPX2BdZeGNjwRARbZ7j8icjo7i5nkrrZ7UGsC
4559	payment	1397	1397	1678	1	1	3839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4Q9NF9rTqFgSNc2BLWEeRg7kZ2Cftvitfjyu4xXGkUUHZ9w9
4560	payment	1397	1397	1678	1	1	3840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWwKpLciBLuoKH5TFm7UhsbQsVUpCGHPxe3AHfTnDWGfoXB7m
4561	payment	1397	1397	1678	1	1	3841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHksHhB1zCotYFcUtmQk31k4DV8qz99epdKrY6D3yat7UPauV
4562	payment	1397	1397	1678	1	1	3842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYUygS6i3jfJrk5PsRRae9r5LASFZstUz2q6ijREBxKEvyAQ7
4563	payment	1397	1397	1678	1	1	3843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pjd5YRctLEsyPSVSagBdQEiXFjoCPwNAthqhqBJM5CE14bDf
4564	payment	1397	1397	1678	1	1	3844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Erp3uvbigtaaRFLbAEnRxRwX5W7qSnghQrjySAnGQgk4Fqja
4565	payment	1397	1397	1678	1	1	3845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPTnae4ssM2jq11DskZDSZ1XAQnTAutHvovDKf5rnDpMbdgrH
4566	payment	1397	1397	1678	1	1	3846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPSknj7hzuPmqZ3ua4N1TyukRSSTozez88vNDtT9TxZ8sDgAR
4567	payment	1397	1397	1678	1	1	3847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2nf1WHbuJ9Rgq8KGS2oqQa2MVuk2dFCgC9BBQzCRsxjLTc7B
4568	payment	1397	1397	1678	1	1	3848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeyYgmU3bo16p3sVQr6nfPRbLD2cmRxQqoMKRCsVJ9Ch6CNoV
4569	payment	1397	1397	1678	1	1	3849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8GEGnF4QhdKoDbWhvYw7RcirMtr1yhbfUQghb81vEwipjPa2
4570	payment	1397	1397	1678	1	1	3850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8dhFo1GpNYVCqmPX3S4dCdUgNgrAZx9J7dAqZWGqrXVjEbQh
4571	payment	1397	1397	1678	1	1	3851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNAWpAxjgwyu3dncx2aUqB8982pejrLues4oXZ3kHQkMP3tdX
4572	payment	1397	1397	1678	1	1	3852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jiFAPdyMjKZMtS5cJpoMPEYQEcQi5UFbT9VG3PehMZRCtA6J
4573	payment	1397	1397	1678	1	1	3853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEMofbASXiPf64d6qPw2FzX7mHgsXfyHXj6JrJS8ojfVYwX97
4574	payment	1397	1397	1678	1	1	3854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUVetqjGQUv229FH7KdVxkyjtxsoFbFdF1sMb3LRpkF8zHwdP
4575	payment	1397	1397	1678	1	1	3855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpBsejHzASSVpd4eNQBAuARefSRGtrNsQeNiJW37GF87crBxu
4576	payment	1397	1397	1678	1	1	3856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6RK5Q3BnjzZ1u4JRo5YwsYkZNZLepsmzKpFCBfZjxnBoEV9d
4577	payment	1397	1397	1678	1	1	3857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnokFM1tWLBEebpiLecsrVDMMrxDQJAAu6CqxDsPiKdz76vwM
4578	payment	1397	1397	1678	1	1	3858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy44Ld7mwZf5KoJeLTmrXWR1WvwfTcA7CBfcyssoCb3D8Ngpg9
4579	payment	1397	1397	1678	1	1	3859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zoi3gFsACoDfRszc8aVreuaM53GbC6ZdRQS7CXX3uNcCUWbM
4580	payment	1397	1397	1678	1	1	3860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2ASS3bau7wg3z98qQkdWDhDv56htoaWVbU2DVLwMVJYR6JD
4581	payment	1397	1397	1678	1	1	3861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosmxYAQhFz59iKqdKvKrEuSDocXJQgvSZjg5Tg7A5yxUm32jr
4582	payment	1397	1397	1678	1	1	3862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeqf365c65E1QztAn4XhmM3XqBXfEn9d8UdnS95WeoMqefroz
4583	payment	1397	1397	1678	1	1	3863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuuxp3jsB2GJYtvvTgdvZbR67RzGznJ7y4WKHwfC5yRUU3aco
4584	payment	1397	1397	1678	1	1	3864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauF5My2WneBKjQcofE51nit35xR3f1B7vFdtbaBbqxviNGenZ
4585	payment	1397	1397	1678	1	1	3865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvps4VosTGU16vczmTFA1uNPGc1w8Dw1Qd71XAqz68hEUngdeg
4586	payment	1397	1397	1678	1	1	3866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBs2HYk7SPH9W9BxxRzjqVbf41aokKv7LAbrsoHMWCyhmJCxo
4587	payment	1397	1397	1678	1	1	3867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfc5LN2Y3obzPvCXkqZ65MFu7LtnxPZs7bNqED7D5xSbPYsYwQ
4588	payment	1397	1397	1678	1	1	3868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAb2aDQ3YGQHFPntw8jA9tphDjEkZ18zDBFA3ccV3kHcvBgfpQ
4589	payment	1397	1397	1678	1	1	3869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6SNpQEmuvzdGDxfSX48XCtjhrPqg6tajLtfsWzYMZY3fpngV
4590	payment	1397	1397	1678	1	1	3870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDu965gGYJgcrXGoakwwCyXfoVoeFr5UTP7iLP6q19FkurHQ2J
4591	payment	1397	1397	1678	1	1	3871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2fQzQBSbTXiJiUCszuTmg9zcZgGJdk3JkzTaDQrKzYw49U3x
4592	payment	1397	1397	1678	1	1	3872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpbRAfT6XntwAPZmF1A2TwBCMBhGVfQhUrLAb2rDKQjpD9oPz
4593	payment	1397	1397	1678	1	1	3873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANtE7UWiC4W1cAeLPu6yfqs4WtRnWFoaXpr9PqxoyTxq1PUxe
4594	payment	1397	1397	1678	1	1	3874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisnfKJ2ZjsJP29buQk6YK3YVoiZP3NwHJUGzTTLz1yXSuhrvd
4595	payment	1397	1397	1678	1	1	3875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4EKBgte8YQg3eSif7awTG9iBk8VKPFtzPboucYcmJ4r4oBYq
4607	payment	1397	1397	1678	1	1	3884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYJNVkR4r1xXyNuYkhF5JDb4muMfYkX6rEnhWowuZepicgHFx
4609	payment	1397	1397	1678	1	1	3886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaUPoJscUKQNeYiqAxfQNmoEq72mb9zcZFDAYabaushHcKq4B
4610	payment	1397	1397	1678	1	1	3887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDRJkN7d5qr3wtYaH9LeCoK4heAg9EphBsdxudNhHrpdsMGbr
4613	payment	1397	1397	1678	1	1	3890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwzqpQ5xb5HQswe541t5Az4xWq2s3AVXoz2uwD5yqR6XAW8pm
4614	payment	1397	1397	1678	1	1	3891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCswi7vqnnm6tX6UU1C72ou46nDFMPVXpiij97cZ4LNy4BrMS
4615	payment	1397	1397	1678	1	1	3892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVYLW32GC9D2sJw1SV3AyTZR38TUW4JqWgPXQ7my3CSDwQqW5
4619	payment	1397	1397	1678	1	1	3896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDobnsJ94H6adzpvX3qvMcd5b54X9oGvB2ZEJWa1w8jbgBSXj
4625	payment	1397	1397	1678	1	1	3902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgURrgbKQap3Evm9YdVCoVLNxG1ToMTtf9ohnpj37oRoKQp69i
4628	payment	1397	1397	1678	1	1	3905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aei97MZZosyhJYuHVEchEVyo7RHFwhFmr1p7N87oxXYhQ7g3
4636	payment	1397	1397	1678	1	1	3913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5LmpBYu9iN6JW3gnwovzt3q9QaE4dKn2wvMLJAqLdc4xM4Hg
4643	payment	1397	1397	1678	1	1	3918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZocrqpQY5a8GDXmaMeTfPGFsAuGV16YuR222jNvngoKba3Dr
4646	payment	1397	1397	1678	1	1	3921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxi3x8AMUJP4Fdjrsq65hXynfVS62sySAB1F8kc5XTyHNReXuy
4655	payment	1397	1397	1678	1	1	3929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU3dQLnqxN1VKyAWqxKhSh4GuSG4pJaVzGQj1oNE6s16GbMFY
4656	payment	1397	1397	1678	1	1	3930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvYbr9WSWSZ3Zk94yEX2hJYHMcEVfWzRGc5eZLBRgozG9mF21
4657	payment	1397	1397	1678	1	1	3931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoywY9JyBLxVhqFyx5TUdtFMZcZDPkaVwB4x7btcyyieD6gD6
4658	payment	1397	1397	1678	1	1	3932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBb2BS66FsCvFgajbEkRbx335WvwyBY51uGL2b4bd1m8ySdZoH
4659	payment	1397	1397	1678	1	1	3933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD3vB4LtQeRs2G1UB2iPuPyy1Yy7wiFzZmYjXtS9ZH2F7hzWF
4660	payment	1397	1397	1678	1	1	3934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEARZeN2g5JNevh8BQaLTffzNwcX6xWUaiHbLc3J7iQh2d676y
4661	payment	1692	1692	1860	1	1	1	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Bhw28V1Pr2VfV7zkGWkftRckWGxnHcoo9ETkgyhK49i1kZrj
4663	payment	1397	1397	1678	1	1	3936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHSGE1J8gnFu3Lg8ehoRzVmRiMro5RhybAnUexq2y6Pm8Bp7L
4664	payment	1397	1397	1678	1	1	3937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNGxnV9xCRb9kKPwX2nGHC3Qdr7PTtDb9o2darScfQM95y83j
4665	payment	1397	1397	1678	1	1	3938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxTQAFFFkwrXodqm257DWBaFCppuKyyMK18r4UwgGAKfbcdiH
4670	payment	1397	1397	1678	1	1	3941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEXJ7P9aEEMgRqgx3c6uPunMp2bEB3cWJ6dZgtpAEt5GY4z55
4671	payment	1860	1860	1862	1	1	0	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodnkzRDwNw3xmJ54gnZM7vGGs8mucuiVcPjs42e1N2SfrcHVg
4672	payment	1397	1397	1678	1	1	3942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9up1PD2NrtL5AcfwmVCex1FDpZG4G54YqEgFi9V1kqEkPt8YU
4673	payment	1861	1861	1665	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfkdbmwCNBCnya2ytWoRt1ZVP3jN5aaNCbt2QgvRK91vs2WPv
4677	payment	1692	1692	1860	1	1	3	43800000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7i3THihvmRhVNnNaRmy3B5p4YdjZAyDv1ePD9G1nU1x6DY17
4678	payment	1397	1397	1678	1	1	3945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76m9J6VucdnxccxgRqfzhnJLnajnwfLQ6Y84TRMBBYEWj1z2Z
4684	payment	1397	1397	1678	1	1	3950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwh74oRxmpU8EQnuEa7t7SqWwdecJG9caKKtRFQWaWfLyyr93f
4692	payment	1397	1397	1678	1	1	3958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWa4XSjyYr95cMLa9rFj3KsP4Ch8DzGboNVpc1b5sJisx3GZq
4695	payment	1397	1397	1678	1	1	3961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS5GUUjud5RwJwAHWyGGXhPgm6c8UiZ6QoeLM1423DyzHmSef
4696	payment	1397	1397	1678	1	1	3962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSfsrfrEW1F5ranKyCCr7H5zDb88cqnhcrKSfbwhdYEmNxvUu
4702	payment	1397	1397	1678	1	1	3968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppu9D3KkGzwD2k1G6Vn2Y9iXhXVWTXnNsJV3uf8U9UK4iFUsG
4703	payment	1397	1397	1678	1	1	3969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJp9uGntxRnyrm9ZxyMZ5AGsWerNCS72ec7U8JDj9j2B9BgPPu
4707	payment	1397	1397	1678	1	1	3973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1TkCvoDByread8rd43Xb9tvHwu3C9NWaAqe65vNq1jUk5mPN
4708	payment	1397	1397	1678	1	1	3974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYe5hJfDGHSoPbHQAu5d8eboVJv2GUsr3zjRYvt1zYsPqC1Au
4596	payment	1397	1397	1678	1	1	3876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAsTmRzQWN6LzDY96t5zUB52SEmgoxK1Eebc6tQ15oeMadU3c
4598	payment	1397	1397	1678	1	1	3878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rkBRi8qY5ighmkkiwzckEf7jsavoR92oEKPn2RJwaWSKXu5x
4599	payment	1397	1397	1678	1	1	3879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXotTrmUJh6FyL523bA72CLzum1qeVfGTfYHAYfjJJF45wqpr
4606	payment	1397	1397	1678	1	1	3883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HpqnmbAnrWGohENn5XZefDd1KNHwRCvnrQsL8V7acfvaTK2f
4618	payment	1397	1397	1678	1	1	3895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1VzQVhzbyxhMUgaLHedojE9EuRxMGH873shhAM8NsrcwNQ7a
4622	payment	1397	1397	1678	1	1	3899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqks8ybmSgwr3PhxVkcmczrzws9ytRCiN6L4g8aLwt8NyAC5m6
4629	payment	1397	1397	1678	1	1	3906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUBCUnGgwWBQwThNn7i6TH4XcE1oj9zwZHH5MyP6GcFnvrCbj
4630	payment	1397	1397	1678	1	1	3907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxJw3WNsNe9iiPivv4cXuaFfkhfAkVrKj2ajgpFh19UFb9sru
4631	payment	1397	1397	1678	1	1	3908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8JjuQ7m8fB6tjYhY5xBVPViRe5NAtrFX9Qq9XyvoCrhAVSoa
4632	payment	1397	1397	1678	1	1	3909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91vQGeUJXAzV3Nec5botxDvm77uXsX4kgzN6DW7Z8LnpKR2st
4633	payment	1397	1397	1678	1	1	3910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLHyPrxjUJLDxaEwRnWodojZbebs1mP2EbhnpdQBXZfjtFGjE
4634	payment	1397	1397	1678	1	1	3911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiHtw1HWoZAqWPLPdwbxFL66x9wcr2GE3h5eGVMnRo12PDKFF
4635	payment	1397	1397	1678	1	1	3912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNGdnGvTFGxFitDSGouRwPKKRcHfgtkqN5ome3xsaAZWw86aP
4637	payment	1397	1397	1678	1	1	3914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJmxct4HN1SBKKkzr21oPoX5aKLp6cF6FhtYiJbG5iUktViCB
4638	payment	1665	1665	1859	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pa7g5Kcmc3aHa836TAegq2Xm5qpChVagSnL8HUbgwh1vZPHw
4639	payment	1665	1665	1859	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZcYLkJxgtF6wZRghCYFvFzRofeCgYAmbrFtW6t95mzp2GXEb
4640	payment	1397	1397	1678	1	1	3915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofxKs6dLsSF3tmpbXVDdphyVKB1Vwy6RTbMHkrhsXT9vgMj4q
4641	payment	1397	1397	1678	1	1	3916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yxXxc4P9gWBtsVrEjp6rWUfYBoBEJLrVTU9b1Pyw4e3QUfU6
4648	payment	1397	1397	1678	1	1	3923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjMmd3LehaDaedVSG9pvKN99Lpm1y6dyU5ATi1ufinb6fXSuq
4662	payment	1397	1397	1678	1	1	3935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWqPTBkPikHFYzXXssc48s7Zp6MxSowpseiYpjFRSpBxptJiE
4666	payment	1692	1692	1860	1	1	2	100010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvPHYxWErRNrupbCd35Ej8JtFdcK8t1LVr4VknVk7X7NRrEo6
4667	payment	1397	1397	1678	1	1	3939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeTm8NXNTgBVqxySKVawzZy4puZPGSm89fVozGK7kV2KAhYo6
4668	payment	1665	1665	1861	1	1	2	2010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirxS7LyrNcu56iGkstocqWXpCdNXfR8kmpSFp7bdDUJqW2zj4
4674	payment	1397	1397	1678	1	1	3943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLM51P1HheCXATqfViMtKr4zz4YDfRVF6JtQh19NuBPJnud5uD
4680	delegation	1861	1861	1665	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5ZVcfTQBUpaopMTHMKuUQXL5jcyjCzc8Q4xHUiU8oHFnCji1
4681	payment	1397	1397	1678	1	1	3947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2U7r672LKHGGLn6xHgw4UUo3NAXc2KDDQeiaHG2q7ietszAF
4685	payment	1397	1397	1678	1	1	3951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzUByvFKeu91znnLfSKB8cnu1esWdxjxaNN5RPpxqny9vUPLQ
4688	payment	1397	1397	1678	1	1	3954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoff1SXqjzvXQbkRkmJ2u3q1kLPWi4QVyZoCm9qQd4bSb6cG9n
4689	payment	1397	1397	1678	1	1	3955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunswBYik4MdgaqtzcnxCeKRoXSiTtJKE53jrCvCZjsKzdYtBN
4697	payment	1397	1397	1678	1	1	3963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHYTdMhYvwiCWqSd6fdLo9cwHfkyXBqkN41kznw66xfxSMzdR
4698	payment	1397	1397	1678	1	1	3964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JwrSZX3UBhHfw7rb8KVKgPcJew4JwJyp4BtHdBtLnAnHsq7i
4699	payment	1397	1397	1678	1	1	3965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZL2fBCsv9TsJmn1BtsVjbPy97xJLSBTvZBZb31zQFWSEqfoQ
4700	payment	1397	1397	1678	1	1	3966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpLFcBHUBPGvf6eiQ674JBqyjWVoKueGTFbZPE6DPWrJtEWmP
4701	payment	1397	1397	1678	1	1	3967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CwkXEJyPjB7ZYLsAnxhdsMSh4Zmk9HZfYQQ3VMEPLiYW5xpb
4712	payment	1397	1397	1678	1	1	3978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFxkD8P8Daih5a8WBkhen4dpZShcZ8LSsXbLBVPabeerpU72Z
4713	payment	1397	1397	1678	1	1	3979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhv8opL6yBbFCrKMK4VT3RGrBHF5HrNt42ujW9z4YH2at2kQw
4724	payment	1397	1397	1678	1	1	3990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP3NSobfEvQB2Pz98UfxfsEnhn8MsW9oDTt7sJ8mgNFNtyMdkN
4725	payment	1397	1397	1678	1	1	3991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rpQjc1FLFBdSFDFpMcxmq6Zp2VnkSmgAK4PoMt4BWhh6PiPx
4597	payment	1397	1397	1678	1	1	3877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8LnZS5mrxyK7GEfyh1WRhb5GfXGpsJ4HvGYH5ndspncCsEMX
4600	payment	1397	1397	1678	1	1	3880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKoRSvD7bjNKf2yzDprLfznRtQD9fbmKemnpBNaeQrrsR3ooy
4601	payment	1397	1397	1678	1	1	3881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqsLananHvVjKLKmSgzzKZZj1MfdpNpFNE1CeR8uymK7PKZJ6
4602	payment	877	877	1772	1	1	1	211000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEz9d4RXwCKNstsf1teaEhTV6ba4t4oFPuufesnFok71RCg3DV
4603	payment	127	127	1772	1	1	0	152000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYcDdD6PQQeWHK5H1HTwBcc1LHYFeLPsJtyYMzhJ6bRd7ggvJ
4604	payment	878	878	1772	1	1	1	211000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx6FLaVxPGhydWyCdNfM4ftipPGBCBkxxr48AJoaddiTM1u8s
4608	payment	1397	1397	1678	1	1	3885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UXyytk5QzvJr5gV5Afqx3bjMHqqzNVoR7XhynKTbwaPeg9MK
4611	payment	1397	1397	1678	1	1	3888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDufGuLdjtEJqRR93xR5dFZPT1thWffka15rPeaw3xjvVgEn8B
4612	payment	1397	1397	1678	1	1	3889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCskqFguy3V1bTvxGrRmUXwUAHQiQ4jVsQmAiKWNs5Btm2eUT
4620	payment	1397	1397	1678	1	1	3897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYnty9LpksEVXMjtXM5zdee8pGvoLWHzqjkWRq4BJdZ5irsgk
4621	payment	1397	1397	1678	1	1	3898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoy9zv5bRvyQEHPBiPcbhzi2VERkXXYJKuTXtgcBqKhWoqEfD
4623	payment	1397	1397	1678	1	1	3900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4p79EMjjL2qGgyPJfrT4AEX977UQUkcXyKqPGMZ5Z4VfNP2wb
4624	payment	1397	1397	1678	1	1	3901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAYYeX1tbd7QVKPdb5BWtznDTYVQZwaYXmpKyXZVRuLh2QKTR
4642	payment	1397	1397	1678	1	1	3917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28mcUAuRRXxMS1k9ncs4UpQk5ig1zhHToFkZKK8m1MANfR9BZ
4647	payment	1397	1397	1678	1	1	3922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkJSzCyVeoqZeudgeGUXghoWwxXeyiBbPnFnSBxDuKFewXygQ
4650	payment	1397	1397	1678	1	1	3925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZBjsAVMNtEtqwQNneP7FBpqyzTv9bSCorcCPUYsKvxUK2f4L
4651	payment	1397	1397	1678	1	1	3926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFeCzJ7HTQFySyiwtaSVNCqDHUiyZLXJMwSbMY1Hvw4HpVQCG
4679	payment	1397	1397	1678	1	1	3946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggJq9Ep1s13BiGe1QmPMQ4Csb4QAWjnefG3csd2NZbZRjHFX1
4682	payment	1397	1397	1678	1	1	3948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91fHyecsgEsGgJcSkkajVXtFh49MxoQVbSsC24kxDTgaC2QH4
4683	payment	1397	1397	1678	1	1	3949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmA3Snn7AB7fKDuacUsdrvggBefZfiTtjD3RjR1JnJA2MEAoc
4687	payment	1397	1397	1678	1	1	3953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTZ9si9qYupGuexZhAk9HzSatdftMqqhhpYsiRJuDKM5RoCsk
4691	payment	1397	1397	1678	1	1	3957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooEa6qC278sDs7fNdka6EsubhARnmG5WUkDfbRhFCQu6yqRhy
4704	payment	1397	1397	1678	1	1	3970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqzu1GJcvbVoWAESPhAZqG3VHPFqvow3VB2uev1Nnqgj5TX1G
4711	payment	1397	1397	1678	1	1	3977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPMunEgLuPTvqQFgoopTfKfQUw4j7dmxgTtfVBqkRqiBWyXks
4726	payment	42	42	1863	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8SMfBbuUKaSquevb4FNoVeowt66bAo2UwmY8xtBH2woCcjm7
4727	payment	1596	1596	1864	1	1	0	111000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYia949d3qRSPAdViBJnMMqHznv6ZjnQUVFXEzR6KfW4fcX5JJD
4728	payment	1397	1397	1678	1	1	3992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CdK5C26rR46bHYNVNRJNaX5BGvXmDSFD1LD3YCwMS4uNM87P
4729	payment	1397	1397	1678	1	1	3993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrEPHx7pRpCejoiWM33sfAAByBbiW1LbbMryayhyjTdQtFug4
4736	payment	1397	1397	1678	1	1	4000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zDuZNZw6GrcqReakKzZWQWk6hnoBH3eTqFm2GbwMvKec16vB
4746	payment	1397	1397	1678	1	1	4009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcdHHbLbWZUHE17v76Hs4n6PKFusqX7WhY9dRCEt83ZGVMC7z
4749	payment	1397	1397	1678	1	1	4012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZR9URpsJKSHFyZSmYGbQiVFaYw6EBrTQAvn4q9U4n7X7BsCx
4750	payment	1397	1397	1678	1	1	4013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9x7dd7atxuNKRdVqdFGG6s2T2ouQKCiAFKL7f979L3Hh4pbG
4753	payment	1397	1397	1678	1	1	4016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCEkDrhjsX8BqosKfiC1ivqePJh6sqQjvuEvA1rMLPYv8it2H
4754	payment	1397	1397	1678	1	1	4017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnPE4HeSQAuwhHNrykh5qXdtmctrvT3o78jfjdjWe97Nuryaj
4757	payment	1397	1397	1678	1	1	4020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUxNfN64eTdQ6TqSBAo3MSLpv19oPXtntuT3X6moPZg7TAqJX
4762	payment	1397	1397	1678	1	1	4025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxU67KnjyFeY2CsvrsEaAhXH69zdzj7Xv6kkFGvT99ygjHxnp
4791	payment	1397	1397	1678	1	1	4049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZay9qfE8hUPy6AP9zaiGQWxrWduW54qo4P64YRdrj5WspzJZJC
4802	payment	1397	1397	1678	1	1	4052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbazTx5pFkK71EfV34JooSJmRXWmNiYxQp3nPtxYHAJ5PGBNRE
4605	payment	1397	1397	1678	1	1	3882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNmpUFtYs661hKHc6RLgjdteHrdr2QefcomsMqo3z8DAg6NK5
4616	payment	1397	1397	1678	1	1	3893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzqVNe3ZLi6QTckmmkzjmq1CiJyKCMNqHTwQovpBhD8Jnnazw
4617	payment	1397	1397	1678	1	1	3894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt79APVJfrBiXc9YPsw826fBBT65pcTYhN1vmJwGfBGANPr67
4626	payment	1397	1397	1678	1	1	3903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXrEZHfzHmV7EmAyaJLoTAmeVewGsqLk2A3XgFjfHE83fGNcy
4627	payment	1397	1397	1678	1	1	3904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmEFjFV2gPX4WSyzWaWddTHrE8umUsKHNHiQdX8oPAUyborwzj
4644	payment	1397	1397	1678	1	1	3919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h7LiEbvzjAEwNb5rm65fbPcwYpZmHunp7eb4Yh9qCNsRAsXk
4645	payment	1397	1397	1678	1	1	3920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt3n4FFeoZsgCc9UAtDXQkfNQ9HAtywR1J21P22YKWPpMfsWR
4649	payment	1397	1397	1678	1	1	3924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUredpDgbP6YY1R3dxYAveAC7ygWH3cAu1dnDPcxpXvJLWJtEE
4652	payment	1692	1692	1860	1	1	0	223000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTbeo2L3Vb6JpKux9SQPvK3wCktZ9YHh3EQiCn4TKbabp3Lw3
4653	payment	1397	1397	1678	1	1	3927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvr6rP3qXh9pP1jsTWUiRNwNgQ1RUQgg6LsUPUJPN4boETPtY
4654	payment	1397	1397	1678	1	1	3928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR8QURo5Cwzxk15CaXGDacxHshC3hgv6v9MhafgMK6bU8tHqva
4669	payment	1397	1397	1678	1	1	3940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6gSe3Go1yxB4EyR37ZpjsuczGEdN46T78bMzpDrPRXQtXkgN
4675	payment	1665	1665	1861	1	1	3	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktygXqc6kVsk4X1QXgNnuqZ6HCmVAfhyMW9Lu4fRVJ5ESUPKG
4676	payment	1397	1397	1678	1	1	3944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuj3bbobs6VKF5xM4q4dNUsYBNeo7egKkBpqgMfV69MyNhquUN
4686	payment	1397	1397	1678	1	1	3952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6DkYYQZU6p3iKjVHkZPZTKHJSfVyLgvmvnU4pRqb9bAanQRm
4690	payment	1397	1397	1678	1	1	3956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTQ2jzaVmTiXbiRfzyCQ4TznMZFfoiYuA9BZEVRebJp4moEM8
4693	payment	1397	1397	1678	1	1	3959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9bn43Wg6PMDJdTz5LcSkTvDAPaZ7RukVGwLM8jGHxBGtghv9
4694	payment	1397	1397	1678	1	1	3960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsHJrA1QJLy1nuMuUTLpXm7ey4znRm972mHvkxSqhTy51twe4
4705	payment	1397	1397	1678	1	1	3971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGThzPWhUYRCWuMFPkbqSKmP8AqJUTkgF4uJofUEpckVcT3Df
4706	payment	1397	1397	1678	1	1	3972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHU7pANYvuZ8gLFtd3DdqnS3gCZcjWrvANQXrTqkECiUDk2vHW
4709	payment	1397	1397	1678	1	1	3975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrh1TZDqjjeqitXum45SvLEcybfKpuo6rZY6pWpwscrGmiAYNJ
4710	payment	1397	1397	1678	1	1	3976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dKBfszjEngVpY2ju7KycnvniQ41kFbMZH2SBotpxwy2yMmif
4714	payment	1397	1397	1678	1	1	3980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbavdzYBJACacX1GLYxcgfuoLzJFBVCogzRSpb5MMAX2g31Ynv
4715	payment	1397	1397	1678	1	1	3981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUgEU3qaDZybWDWDM6EAHryeEXWU8iYyWhz7vfmhodBAhTCtU
4716	payment	1397	1397	1678	1	1	3982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3DfiVt5bs2g6uYPwJsKnSoEsF7XfkkfgCQvfSHQd51hWjiZe
4720	payment	1397	1397	1678	1	1	3986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDo4QcUCW5Xao7zrP7FMmvtNVnWLoHq36vJbPSqTWnrxdz1Er
4721	payment	1397	1397	1678	1	1	3987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKA2AYaro3YYG7tqhxeWSXMg9q2Vnk6eadEWEsvUCVZMTQbVx
4730	payment	1397	1397	1678	1	1	3994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdBwKoYDmouTqyVmFyuXYhZ2oWYNYXeNv8MSzPTjGPcWkvoWh
4744	payment	1397	1397	1678	1	1	4007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJaKSejPGTnRADidL6mGRQ8cZ28cXJbnoxkG3ATWv1qQNAyhx
4745	payment	1397	1397	1678	1	1	4008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fMEdpje6A7yHmBFbbxkC1iemVu2zqsXntSj9UjN5XZbKZJR9
4747	payment	1397	1397	1678	1	1	4010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzewBLjTK1eaaEuSv81eevoMZqQyA39SRApVyE4nKqabZDHC4s
4755	payment	1397	1397	1678	1	1	4018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYam9DYuzje8zau24fL58vZ2RQycoyaT9H4mJYp9eDjyDYgEM6D
4756	payment	1397	1397	1678	1	1	4019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uxGimpo9Hnnbc28hGsUSyquqhhyDK6PiJkeMAAQYtBpPzWp4
4758	payment	1397	1397	1678	1	1	4021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8aT1j89qxxAXBvR7fSkiZZPjQhtBJrBcYgRV7YPsP5vw6ySs
4759	payment	1397	1397	1678	1	1	4022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMmT55hUyG6SsqjkgQUx98iz4rSXkMEFCQN62zFfGA6AFfEPL
4760	payment	1397	1397	1678	1	1	4023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWWHPSkUzhd5ia1CmbFpc6z8UHnNq59kiZZc8oqz4K9qakWfx
4763	payment	1397	1397	1678	1	1	4026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriKpNN3CWjuPQMTwPmCZJwNSdy8HRoqYSVZNsaBhgtSTQhWcg
4764	payment	1397	1397	1678	1	1	4027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFa8nrRWdxPcUu4gaZ8rtiWwk5JikmAuBrVnEh4CTveAtscXi
4717	payment	1397	1397	1678	1	1	3983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeRdag7ktCtcibAd5ZLPzoTXdFasA55zA6FWREs7GoPqcj9GR
4718	payment	1397	1397	1678	1	1	3984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GEZC2pL3iuXaSYRsXRzZGK4SfjurVraVQhpt75MwWfrZFucv
4719	payment	1397	1397	1678	1	1	3985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpafGeptLLaGFVe6LsYX3UpvC84feSxVmeQnQAVNnk65iCeGor
4722	payment	1397	1397	1678	1	1	3988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASErgMzpwPTPbMU6CnnVhXUd6Pt8GLtHzzr2Ajdf98G1TA6J2
4723	payment	1397	1397	1678	1	1	3989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCg1xfxma5QrXrxR4av6gG2gSi1DoLDoQcZofGTqc2W2xW94Qw
4732	payment	1397	1397	1678	1	1	3996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDha1rzSPj2D4ZpUNjdkZBfrZkpC33uGU6n6S8MZA16pfZFqZ
4733	payment	1397	1397	1678	1	1	3997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9uoyRQxxG4gAWiGDWeG25UQXHCa6mbHXyUo6qXVhDsbig4gA
4734	payment	1397	1397	1678	1	1	3998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EXcZVMwioiRXKHGMdDSQqvBeMsHH9z7XShJ84QZYQpfv9Gha
4735	payment	1397	1397	1678	1	1	3999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHCGLFEYLhFoVKjacj2U3nWix4BUAHwHYdYdS9StMw3pz1Z5n
4737	payment	1397	1397	1678	1	1	4001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qTaJfRfgTaLfuKrvUs6KNuEFnFML6cu2ucLPfXG1Z4kWakCK
4740	payment	1397	1397	1678	1	1	4003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrhRZjYkm2nUDwW3Q2eUUznkVusTArJmqtPRPNKJ6y7fdRGLa
4741	payment	1397	1397	1678	1	1	4004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy91VVu8SZ4iSzkU6JYoQAG8iNJjsfyqdfbvCfLTkC5c8VoSjr
4742	payment	1397	1397	1678	1	1	4005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hm3xFMdpgby9ZipPywaNWwuAJVftPjRPZBRszo7Y1mxRVH7f
4775	payment	1397	1397	1678	1	1	4038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLByzcfbRAf2xKkqG2wayNkMtb5hybXP6eboPEJRdDK5Fj9nL1
4778	payment	1687	1687	1866	1	1	1	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD2DHxReMojnF24n5QgUhSKFhvBeCNArM1kfKDMseDFZHnPex
4779	payment	42	42	1863	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy6KuQ9p3XgCAWfg4REJ4BNszKnhppZPVDtvs5kPq4Ep2bpmV
4780	payment	1397	1397	1678	1	1	4041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3VyieWX7SQ5NozDPRgBpZeYWXSmVop3V6nJQ2LbzHF1VYd3y
4781	payment	1397	1397	1678	1	1	4042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83GZpbbRL6cSu12cowYFtLt4xdAC4ZAdyoRWJnaDC8fsJVEPk
4787	payment	1687	1687	1866	1	1	3	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfV3CAGD1nxxFb3aHiooGi8LQbw6asYA1b3jmkzH8rA8E7FUrn
4788	payment	1397	1397	1678	1	1	4046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVVnXXV4yQ9F43pmupd1UPZnDgra2Nurt3e5VMmBykvj8K3A4
4789	payment	1397	1397	1678	1	1	4047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kEYWinSM3Y7uEXpf2iZoG3q91JeSxfxjxYh4JTJhMw5XkFAW
4792	payment	1866	1866	481	1	1	0	156469944195	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZvsnMze9US8WR2vPqcTamgmDgPz39CSaXcTtxyPUF3KU2BrbNW
4793	payment	1866	1866	734	1	1	1	4741513431	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZCm7nUtnnmwkPMdzdmNWsuUUktkmkmdx3267A2cQHCLsUpmdtk
4794	payment	1866	1866	845	1	1	2	1359233858364	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYaiqBPhRNaz6QC7mesQyY7jYf4wAdkZ7R4LNsYLQapPrAuQged
4795	payment	1866	1866	846	1	1	3	1359233858364	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYe9A2ZXbHMd8XyqdAtYvtaEXCS3erWior2hwRQvuBJ4uFtAfRR
4796	payment	1866	1866	936	1	1	4	1258093169406	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZirY7tviZWN7ZSTVHghyLDPec57FwnbDhh4np7PqdmhVWqSvDn
4797	payment	1866	1866	1056	1	1	5	2254492180224	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZrmPYq6PhztmuNz7JSazKFei5E5qraTzkpYfSPBefxLdrBHTEy
4798	payment	1866	1866	1176	1	1	6	1521150797934	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZ6RZLgfonfHR2S7YE3ywjjVvVjpmtDPRfTzZGKSaRPX2Guhw2x
4799	payment	1866	1866	1302	1	1	7	4238821951632	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYUQtrJHQskpHrSHRoMSdTvT2ZWgPvbAkcdtnoQWNQ8orUAJtxx
4800	payment	1397	1397	1678	1	1	4050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ5kBXffeYZRb1gSBjRiU4vbSvHY5vd89oR3H2tCdSBwLKGWa
4801	payment	1397	1397	1678	1	1	4051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DcjSa3JePtJQGcQSQv9L49NyGGgQcFEycuAtTKcw18KoNk8G
4803	payment	1397	1397	1678	1	1	4053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZy1kgLxHVPKUVjTioh28mZEVviYxYzXh2Y3ujDJ4aPqiA42br
4804	payment	1397	1397	1678	1	1	4054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyqiLqmfbKB2FD5FuM4Z6Kcr9KbzHd26cErus89EtEEpNQDGU
4807	delegation	42	42	1863	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aH3vdDpnngRj8xbKWSZE6ifxSh2CPEHBw59QcAZFF1QhMrNe
4808	payment	1397	1397	1678	1	1	4057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVxG48mf1spA4KEGN913qTpDornjFrG8waDbenqpj7UH6aBo3
4809	payment	1397	1397	1678	1	1	4058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAySN1R4ZjQQ7ni6a9X6ZjniGDzS7L13o7qGpJc4e1FbHfDuQ
4810	payment	1397	1397	1678	1	1	4059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7UFUoUMBR6VyFmbBK1ygqYhUmPKDJrHPr7Ur7ym2ZQ4zeyiP
4820	payment	1397	1397	1678	1	1	4066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa773dfpJWVDUwyxBq3hKV85McVb87r4W81qEBMWWPRsipuHsBH
4731	payment	1397	1397	1678	1	1	3995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXvHY23FaZX44LvQkkC67zVfcnmku1no1reN1egSfXgo8Ke8v
4738	payment	1726	1726	1865	1	1	81	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZGRiTMkNaoWH39hzziMo9oeLAA1YQCbpoCmhbaWGEJZuTavhhB
4739	payment	1397	1397	1678	1	1	4002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVKm4uzfUwTb9wMaNdurCCXD8bKNikjtxUknGwT814pq9XXxV
4743	payment	1397	1397	1678	1	1	4006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucLtidzKp8SSHYCWKqpzMbDAiqLBd5vqn3kRZsNxB46imbZUq
4748	payment	1397	1397	1678	1	1	4011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfeWaJ4kSNNXpWmydr7UdWRThNfm7Ko3fC1J7BNDqH3pVrgYK
4751	payment	1397	1397	1678	1	1	4014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UyKQ5kEYNtwNPZ5tjv4fiFFDrkseNspz75od11XsAjTzDSAY
4752	payment	1397	1397	1678	1	1	4015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEJ2NEEb63TNks5fmiCetgSG7zGHx4C18d1zctKE8kQYdxu8n
4761	payment	1397	1397	1678	1	1	4024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6e2KdAnvxBxpQp3mexdsmHM8D85tcyV5n3aUZSduyD8LGbhz
4769	payment	1397	1397	1678	1	1	4032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CE7n1iDmnA31st6wrKwSDta8ECFoJeHH7Gfjy8QSomjXB6Yg
4770	payment	1397	1397	1678	1	1	4033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSVKtEpg3EkrASJCZXY7VB8PHsb4Sz1jL4HL9wdgo92o81QVU
4771	payment	1397	1397	1678	1	1	4034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcHEL5X9TBVbpVDLTUH2QhHBsqGG3BxtLx4z95QzaubzpjRwM
4772	payment	1397	1397	1678	1	1	4035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmkTZ3XhCnYPPXEpEiFcbhgG2hhj4ppeCZtMXDYNGBXjqasNX
4773	payment	1397	1397	1678	1	1	4036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D9x5xmUL6RKdiMpyC58FBed5y49xgbA6jDvMzPrqNT9DYeVM
4774	payment	1397	1397	1678	1	1	4037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdUToUSc4G21MS8nH8jm2huQNVHhgZyJBeB2iCvdYTqAoqG43
4776	payment	1397	1397	1678	1	1	4039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLEqyR5s9EDeAmnaB9opMUm5ZAUKZVYPPzWn22s5kHhhdzF8p
4777	payment	1397	1397	1678	1	1	4040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQjoJG3fKqPMGE4ppadTWcLrxYhdazMHnooX22zp8LjVrgfWC
4783	delegation	1844	1844	1483	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3HjTtJwdikQmqq6sz9ct2Nx6GuFreuSakETvG9fBNCGGT53y
4784	payment	1687	1687	1866	1	1	2	12143037273550	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFXG6YxzwNeVjU4JhrkvjeiaWsebgtN3KQwYSezuciiJhnAxS
4785	payment	1397	1397	1678	1	1	4044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrXM4pYZcXGU87SLdGc1PJYzyZbMNCMzk9r61WN1dvMR6mSCF
4786	payment	1397	1397	1678	1	1	4045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2XnWJwZRCCQx7BUzqhcCNRAsuuEHNXQBc2s8ZYgRw5MdR3cH
4790	payment	1397	1397	1678	1	1	4048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrCJyqZSy1kwXNPmvu3VTreA1g2YcXuahrVbNvP4qPXHDup5p
4811	payment	1397	1397	1678	1	1	4060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1DcVv5VPw75FGjtwJBxDWQ59vkPzmRkv226jtozffGiCebnm
4822	payment	1397	1397	1678	1	1	4068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJRTqvhAWrsBHzs85kkukVRn2hmtJm3H1iyzSR4FYEGX3NjQ8
4839	payment	1397	1397	1678	1	1	4085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynQrWTTrih7BcZVG7QB2ceMzW6YeP8hyS8dNBoM9g4ES4dVej
4847	payment	1397	1397	1678	1	1	4092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9sC7svzR9knA3mSp5nwqXLYsQzxgqXUZ2aC31kSBpuyLfyx1
4850	payment	1868	1868	724	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwTm2s9V7fcbLUr3PvUq2uj8M2GXMEqziugAukXc4CUQWZonr
4851	payment	1397	1397	1678	1	1	4094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMDQQojmXDueHQyHu5yrvv8HyQuBUQzdP54vmM23KhToHz17D
4852	payment	1397	1397	1678	1	1	4095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRvjRg74iTRTH3AZ9rZVCS3KdjQNeXsvgJ4TVe53yfNEyy99cd
4853	payment	1397	1397	1678	1	1	4096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9r1pmxRoZ8H9xHoX3cMyAKvEiz9aMVoiE9oRJBpGNA9KGprp2
4866	payment	1397	1397	1678	1	1	4109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfc55cXxje4F3dwXRB8PbyXm6dUEMpP1i98Yh5gJiKLZigvUcY
4867	payment	1397	1397	1678	1	1	4110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgNRgrqdR4jXMUWYN6Bb7fLX65DySc61yRUM2pDfa63b4iNaw
4868	payment	1397	1397	1678	1	1	4111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtype54JMXS87VoGFWkwdimXH91zJAtmRt45CcQRH9UrzR2HZ
4869	payment	1397	1397	1678	1	1	4112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvungDLUTU46gh6WqkJKeWSqYY6WRQU3vztzce8JLBnsMzbTz9
4870	payment	1397	1397	1678	1	1	4113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yEHKVzGF7c5CJXu9dD7oZKhmjzBoCxXptzUHdCHikMGgpHAd
4871	payment	1397	1397	1678	1	1	4114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgweM8sEJGCKskRpAZvbCcy93i86PnaueT3HoRbDUg4q1vjSRJ
4872	payment	1397	1397	1678	1	1	4115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjSsNqGpKn7xPpZKsU799rFHj13kHRUTQVPJdzP57VtvTBJSM
4873	payment	1397	1397	1678	1	1	4116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW6Ha8BRACDgoUu3iokPrDrqCZRj6V5pYvyUma9N9fuciFuju
4881	payment	1397	1397	1678	1	1	4124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCY7fEsWg6iavU75DnNGnueu65HuQsRBNZs3cbyN2uNy3tPjp1
4765	payment	1397	1397	1678	1	1	4028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzr26FigrG8H3hucXjG7m7SobUCzNVWRBTMFwvp1qf2Ww6PcH
4766	payment	1397	1397	1678	1	1	4029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePg1pEbwJZE6x1BUgV5JxMDMbdFi4jdSbVjJF5f5imyCkqPBJ
4767	payment	1397	1397	1678	1	1	4030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMCKquByLrnGU1ZjJaghhbZnrDGDfe9SwUn3P9uZkeCa4PaaL
4768	payment	1397	1397	1678	1	1	4031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gbb6uTknSPL25MWM3koGcaAWC87JioR1D99t6GuMK7M21LA2
4782	payment	1397	1397	1678	1	1	4043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizEN1yJVd1pLKW3cnPr7ELyTyj1ok64EWGj5nnMgmoHnaocBp
4805	payment	1397	1397	1678	1	1	4055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW4og2PsBpHxnDbeUsyVkFFw984QSDxWUvBQwDzBu6bDfRD6x
4815	payment	1397	1397	1678	1	1	4062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXoHTkKqqRgpzZBG3yiQ8qXSq1rRKWjEbdLaAbKeozuPXnFX2
4829	payment	1397	1397	1678	1	1	4075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzhCg8xpcUYoGkX9i8TQTpdzA1UQgkAdZ296txRax2kviwBhM
4856	payment	1397	1397	1678	1	1	4099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDWNRwRCMX15HtLUCfwC2UV1X2Xoga5HjLpj3jnfKjhDAsfxF
4857	payment	1397	1397	1678	1	1	4100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL44FB38xsPo2d1QknaaZ83GBAbDpdiuyss6s1RQR2Gym6XMLE
4858	payment	1397	1397	1678	1	1	4101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPbpQ6TsrLptZXuRceo1QzjARcb1esb167Tcbey9TwcTamuc7
4860	payment	1397	1397	1678	1	1	4103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEmz7P3xE6MGtBqKGm81Rvmwe2HhU5GpLvScvbXC61obvTXYQ
4863	payment	1397	1397	1678	1	1	4106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJAneV5AgJfCRNGtuWUbMwxmzKDCzjFk9N9iMAAQ3cdrZjjh6
4876	payment	1397	1397	1678	1	1	4119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX67cf6PS9p3isPgz2V37mqZ7JDGvLeFGcKDMLDdyWe7PsPw2M
4880	payment	1397	1397	1678	1	1	4123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRg9GK8unYTT6T3W5SjRqMXwAE8TKzjbap35dxCTtWRZBrr9J
4883	payment	1397	1397	1678	1	1	4126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ45PmuBWexkjHVhh9C6YWNDetKT7JymNfQuvqB9tU83hdpve
4890	payment	1726	1726	1869	1	1	83	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiraGzMhQXz7iTrYj23FpNMKJX3Woz2a8TNuxcpqJuSNc64gLr
4891	payment	1726	1726	1870	1	1	84	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8CEfhC3duSf8USjHm7nGGPfmZM3QHYXa9zjaWsiXZ1jtGT5Lc
4892	payment	1397	1397	1678	1	1	4133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8A9gRJLBnKqg8a5Hri15D4gVaYGBbuRvN3k6TtN1r4TBgBrF
4893	payment	1397	1397	1678	1	1	4134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtVnndQc4Cc3HmcvF5UMsmgPZuaGTYUghHB9CnQVaq1o22avh
4894	payment	1397	1397	1678	1	1	4135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWm9qR7iFK8Js6PHUXptxFLE5qQKuiLKqoHkE2c6h3yp8bwLrN
4896	payment	1397	1397	1678	1	1	4137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXLjBxNFsmXmSE4ZSrHtXVKKnoeuiSkEh5TxEUbZbDH7MdtRx
4897	payment	1397	1397	1678	1	1	4138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71L6s3JNYDG2gv88nBW38i5amyZGBjhCjriGinF1TBPBxZ8aK
4899	payment	1397	1397	1678	1	1	4140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKjDXGw3C4kgLvDUSZmF7TWaXH3CNbcBSrKgm9NQGfJwqHMmX
4900	payment	1397	1397	1678	1	1	4141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpKmnnJKCEZagniKeS9z6VPv5yS8wMnsK7Rd4ghpvirmjJMWm
4901	payment	1397	1397	1678	1	1	4142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKN4jDq7K36Pgfn1KSB3kBDhBeSvRe11VUSgC2NhYJnspKDMi7
4902	payment	1397	1397	1678	1	1	4143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSe5SAwabt41iVp2ibDqLTazithFSPhbV7qzpT8zSdEEDNAn5U
4914	payment	1397	1397	1678	1	1	4155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdyefmEJEhMX6trwyzav5XN5Hakz5sUCBeCx854fMgBsiHJKw
4919	payment	1397	1397	1678	1	1	4160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hSj5Mq2DdeeLfV69QTooWTotn84tMSojiChmSNt3nWHceLGi
4920	payment	1397	1397	1678	1	1	4161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z9nd485qYnrxxJGgP8XUFqLcXhJQGmdtjg5Q6Y8q3omSuDBq
4922	payment	1397	1397	1678	1	1	4163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkUibkcs6GwbQNw3zn4fLR1huheYSm3Ji9RAMcZrN2CzV8kNr
4923	payment	1397	1397	1678	1	1	4164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4HAhzrpdCF2tT7xUfZ2k4NKQ485EP2fYbJy8heUZiNqauYaf
4927	payment	1397	1397	1678	1	1	4168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqrwQxK6XBawxUXAkSUiSGfjycsGcMR4v1PfUgmP7XSWFmYNH
4928	payment	1397	1397	1678	1	1	4169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUSYiM7bQj6T7YnVH9WDbQn87QaoNYpdJd545kbZA4t3E4taP
4932	payment	1397	1397	1678	1	1	4173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywzS4EA26AsRGkuDvnwL8uXdJT6AQxqaHEdFeKHMHXA1itv3S
4935	payment	1397	1397	1678	1	1	4176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYeA7cChH5rXurJieajV5UTAQsjnCUHtgxs9zuf8e4CHPtBk6
4939	payment	1397	1397	1678	1	1	4180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LR6nEgmYRhU5ELPA47tTzSgJnTL5X59CCisgcVHKZoDUVH9b
4948	payment	1397	1397	1678	1	1	4189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkdQRgBf1rrRXuLuw6aXYftNgSqgKT4bVt9qfsWSQqrn9Karz
4806	payment	1397	1397	1678	1	1	4056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97VarLHLh98nzRqrYRrgkixobBAz5yXwkoUTVHXcGGt8aQGnY
4812	delegation	1863	1863	42	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpUgKK7LV2iETAoyEU8psvPq4y1jfNWT2t3sXzTC6jvFvAHUj
4813	delegation	42	42	42	1	1	3	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWFbgYXyx6aLdTwJSadCXxEhHtbUvFcjaAthbo5FszVngDkV7
4814	payment	1397	1397	1678	1	1	4061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAS3KcBLXNYfdrKwQX3SWMBPgt9UcHaijkh4XCZ7yoghDCiZP
4816	payment	1726	1726	1867	1	1	82	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYaBvSq67xrn2rgB16ig1a1qjQngg63MPZAT5Qym4G96oqeHS2A
4817	payment	1397	1397	1678	1	1	4063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4jFPWxQa5AKxWa6VsdZVhqauWiwa5bAuvuEfedkckTvwDC8W
4818	payment	1397	1397	1678	1	1	4064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SsDZnHcNoSGJDQHzyhg9eToNExwsNe4oT4FPMt797DFoPCkQ
4819	payment	1397	1397	1678	1	1	4065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvHPxkhSz7nxVTKeaUHBpAZJv9hMP2grh7wENZt9g94Znfy7N
4830	payment	1397	1397	1678	1	1	4076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vVmNmuWhhWHCicwBQV4CLqvdEkkZN6g7WbxiJjWE4bGRaozF
4831	payment	1397	1397	1678	1	1	4077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtheCqu9z5ypmwse7T4uBLjJrjiBnmEV1W2ZCEWrwuqsQfyJw8
4834	payment	1397	1397	1678	1	1	4080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFxV33amxkEAJ5tDjGZzqTZxxhaGC6pg6WffDf7MD8cqLwBwa
4838	payment	1397	1397	1678	1	1	4084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvm7eHyNL2JcWDbHDx6bGdjGR7kuFTniirmtFi2Mcpg3P6yG5
4842	payment	1397	1397	1678	1	1	4088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTozyfEhU4oYM7wnWjSGj5kozGn8Mid6kxv95zs6iw5v1STXp9
4848	payment	1397	1397	1678	1	1	4093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpVFWx2sLsBw6o98D2Jfh8UZiChuASjongoWpxh9b2qnYU3DC
4849	payment	1868	1868	498	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtx8P8ywtKxu7KZECv2af4dzSt234r9ifVd48G8rUviLY231We
4854	payment	1397	1397	1678	1	1	4097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Vpx9eVSDcyj6heqNRXj3jchheGG9ex5Gk6d9Bwz8kZydyozu
4861	payment	1397	1397	1678	1	1	4104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZernErEmmgS87QjQkDjnVzsWMBfVp2CXzfeTT6oBCdXJaybMtR
4862	payment	1397	1397	1678	1	1	4105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGabQ7yW8Zt261Xh32Qmd6pKSvc6zUssyNAWmz9w2iVUbwMUqZ
4864	payment	1397	1397	1678	1	1	4107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurThEW8vTWrgMFYNhwuPAGeAHYf77j8YBHQYmsKTB5PHHrjEp
4865	payment	1397	1397	1678	1	1	4108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqirrGSqZAWg2x78zytn2wAYC6zJr5ojNesduiiAs5ufGnPoYx
4874	payment	1397	1397	1678	1	1	4117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tWABkRb3cV9NhwRaXQaMWiRkUYacEg3A2oUAtNddkfwEKPhx
4877	payment	1397	1397	1678	1	1	4120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQFEuR85PWY1v158LZmf5oCStZR4dw9kcoiMiB2SQtppFPKvK
4878	payment	1397	1397	1678	1	1	4121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZik37QQV2q7yWppWzDkHCKVM9V8Ryz4EKKh8QcrbsZncAbFzUi
4886	payment	1397	1397	1678	1	1	4129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJijWHoeDKU22YWtfB2WSBPuxzERdq4wxchMqaxdYx51ecBjv
4895	payment	1397	1397	1678	1	1	4136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeofRt8cr31FUtRWdPQJd7FoT2LMo92yxDdp1GkTEQdWqAo3B
4904	payment	1397	1397	1678	1	1	4145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofioPRG4e3HUa2ZKjKh4wkKyJH8G3GxwdkLAhLiBXVjn7Sx8
4912	payment	1397	1397	1678	1	1	4153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDZW6LuURWVq1mVSyCds11xvJLHAawCX869dMibm786gBFyUN
4915	payment	1397	1397	1678	1	1	4156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqq5DBdMfwrvwRU85ABKbVAPKzJZVo5CLM9yWBwGpqRGwD4kiy
4916	payment	1397	1397	1678	1	1	4157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtRV55h3PhYfLRMAsYbnr49K8qrjR5pfFU3ZDRtLeaixxz8qK
4917	payment	1397	1397	1678	1	1	4158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71VpwoRuc5TXyjkF7N5iHSha1Z5fTebBtJ7HERzF13Xr9if6S
4924	payment	1397	1397	1678	1	1	4165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3YvrAm3XDuqEoCtMr91wkGyrCYXiTKZocKAmnk8MsMaDw4j2
4925	payment	1397	1397	1678	1	1	4166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYT5bL48x5JFCgA6BziorPLV64ubss26MaYpB9Kzcodd6DKwZB
4926	payment	1397	1397	1678	1	1	4167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwa8ppKVg854tbKtqfdF8uGN7zJbS4Gvi2YP4FkiNpVY6P8zgH
4929	payment	1397	1397	1678	1	1	4170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qBXyz43uferyEXiheNVmM9K7BJFzVUfJEzo1iwMw53DHE3hu
4937	payment	1397	1397	1678	1	1	4178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcxyYTmKxE9dXihUaZF7YbVjUoAWkF5z5G9GYAMdxWX5ggFcF
4938	payment	1397	1397	1678	1	1	4179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAB6odZrduAGrPg4yL5z34B5MYY48hzvJbw1Aqo7vgeSfzBHfE
4940	payment	1397	1397	1678	1	1	4181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6jSDQkNGipSdMvDeE6Gjf89iMZtXBZj4bfNrUR46uxEb8kn8
4941	payment	1397	1397	1678	1	1	4182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBNp5vczirVZDYNf7TwxugmLhEfrmqHsDUX72FbS1U4f6RNvH
4821	payment	1397	1397	1678	1	1	4067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpk8Kis5edmCLpakT6q7s366JN26CRMoDo1eJhJPjtWPpUWae
4823	payment	1397	1397	1678	1	1	4069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYjztybQN5pSngLAJKTYgQkoY4iiZJHgVK6PenTeXrdSVpRFq
4824	payment	1397	1397	1678	1	1	4070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3txKWn6sGzE1wXFGH4958Suz9CH35PLpMASfkkVR2SBUZ3X95
4825	payment	1397	1397	1678	1	1	4071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbD525xLWgjkBbwkmssyRXovv4GxBGhj51o8pKEjXiBkZmMUdi
4826	payment	1397	1397	1678	1	1	4072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53FGTUsucAqwQRHeJexg25se6ofRYCVGpP8KQSQ8o8kcnnunT
4827	payment	1397	1397	1678	1	1	4073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAA2HFU3vWaUgK2bvgisebcfmvJKRVaa1NTAzc8hS1qQWoEZz
4828	payment	1397	1397	1678	1	1	4074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgZkoW77MPxJW8C3vkp6wRSFFYPzqb8z88LwA4fYn44dVAbqj
4832	payment	1397	1397	1678	1	1	4078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bky5snXAznT5fwRSDDqEkNMYh3Mw9w2gmKx2Z2zuyE5YB3b1
4833	payment	1397	1397	1678	1	1	4079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfs4WF2gdCb1iA3PWTPudCxyFexciRdRaUsdgQXJCDi45BELZL
4835	payment	1397	1397	1678	1	1	4081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfTzU23MsMKnP3HKNoCXwtUdjK5vpyXiKb9dQukHYoQMG3UiU
4836	payment	1397	1397	1678	1	1	4082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNg1nMHp7X8JAMVqPc5tcV5HHQx5pKz3Z3Z9kRrGPsap6LprL
4837	payment	1397	1397	1678	1	1	4083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtuXqoXoyH1DwruXEDBK3W42FecG4RZcFCcQUU4mB7WBSiK5F
4840	payment	1397	1397	1678	1	1	4086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWpcV2Juvs5rF8rKrL5q63JMiXm1tYn6FJqLm9CqzSViyyuvL
4841	payment	1397	1397	1678	1	1	4087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8pZxi7TChkP8y1yZDRcLxfGhW7vtgcKW4ij7iHviaygvpSGu
4843	payment	1397	1397	1678	1	1	4089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxLSVGJz13XB44wd9FBchDyq5d69WJa9RPENfb2Jsg9xd444P
4844	payment	1397	1397	1678	1	1	4090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5cyK4ZXsjhDk3iEnDBbqiekTPwkadJi5VNqKBt9ZR6gBRGz2
4845	payment	1397	1397	1678	1	1	4091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgag3H5SUV9zi6frpaMR3oXXkrPrLsKbWWJyGi8dZM4x1FTdw
4846	payment	687	687	1868	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSH2T2xWK8gwAaYXGQtgRq4G398u9t8THEmHmypUNYKxHqFBs
4855	payment	1397	1397	1678	1	1	4098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybZjifAJGMmMkkTdhjm2i1n9KrQMwxRTgPDA4LhcjwZZ8v5BV
4859	payment	1397	1397	1678	1	1	4102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQgNtxkL61iYg5hNksUPKThJyYcibe2ZCw2KQhRcS5G7WHpD4
4875	payment	1397	1397	1678	1	1	4118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9vus7ac8SpTg9q88qUhivN9S89jZ8F1CvoMyE8gkmJujg8MZ
4879	payment	1397	1397	1678	1	1	4122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikbFSuyotMTkAi3yXcRykNxG2yHLjA7C3yJCtCu7BGG2YXjoP
4884	payment	1397	1397	1678	1	1	4127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkjoxkDzYg31qwHQk57Vmv7ECSvQnPfGkLKHryVv1ULo3gshR
4887	payment	1397	1397	1678	1	1	4130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UCKAb3T2KAGKqifqniK4SihiKbfgfjYDg1wFd3GiCVtg3vV2
4888	payment	1397	1397	1678	1	1	4131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULKHC5ZBA2AhXG9P72kYjPh4ukbQZyDHjxjhjFsAaGU2mNvdu
4898	payment	1397	1397	1678	1	1	4139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD3WLSpQM8WKevLg4keY3bBaEYw3ubgj536eJePMTif2Pwdp9
4905	payment	1397	1397	1678	1	1	4146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVoZbsMCt79JGonnYwcggsLaXC1RiojUf79y4Tswn6TiFTYnm
4906	payment	1397	1397	1678	1	1	4147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCemCHxXrJxTUhcdfLcPayNg3rSDv3PcM9VQnHpuwtUM4QbdH
4930	payment	1397	1397	1678	1	1	4171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksDrBUqu9EEXXGiKvYhG9KYj5omiFXdoa8HiYrmgw7jc3c1U2
4931	payment	1397	1397	1678	1	1	4172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6aWWr8xvQAvh7ZMkjE2quVmaSxduQx5aAgV5wDYvChNWpdki
4933	payment	1397	1397	1678	1	1	4174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QdKqYCr4gQRrgUEPweaq3FgMFawNPPA7vuJpSDWtG4qhBMs6
4934	payment	1397	1397	1678	1	1	4175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VgUbxeMLoneFopBuR3VrER2BsCr12HYiB27oM4LbdD6ubfEV
4936	payment	1397	1397	1678	1	1	4177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4suXS5coKfHmbncF45f69t5C7oXYdgmmoCZmcaJDihx8wXmHQ
4943	payment	1397	1397	1678	1	1	4184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawEU7y9mFtmcia7C7qKKWmRMbWy26wQ7V4tZjtgJwMpPXnG8S
4947	payment	1397	1397	1678	1	1	4188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2PJxA7qm4ZMQNLRwTcPWVeS6GchL5DubTacATC4Lyq7wA7Sn
4954	payment	1397	1397	1678	1	1	4193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKBQAqJ4ADsHLtiTmximqbjBVgxWxxZSk618WccqnV8EevFNR
4958	payment	1397	1397	1678	1	1	4197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirsBKxJWZ8BL4ALTm1PZSTxC1btZuJvT3KRUvN9jYq3P8JeEj
4962	payment	1397	1397	1678	1	1	4201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqUjMDd8ekA8TckkpRFKok3KxDDZFXc1PrhaxvLne2tGoybBC
4882	payment	1397	1397	1678	1	1	4125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXoLksYctSFN2rDNrm8orbXjrbT1RGSfiSTHFwSAP2eLxWsBq
4885	payment	1397	1397	1678	1	1	4128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M9sJ8FFB1B86PqYWaHjFBaVy9nc6rD2aTiguPL8pzDS2M7ui
4889	payment	1397	1397	1678	1	1	4132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSw2VwYGhRnEspCCskP8TzfibWCdGz9b4uVsgp3SQLXn6Ux3d
4903	payment	1397	1397	1678	1	1	4144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmP9NSx3mXcZ8StXgK5f6yPG6NJV3FLmvdXPitZV3Gk3gnRYnt
4907	payment	1397	1397	1678	1	1	4148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4j689yVcUu6xo4a5BAcdviEtmUC936Cy7Sa2d8jQExTycuTWL
4908	payment	1397	1397	1678	1	1	4149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoEkszL9WDpKYx8eHYTrV6RNFfLYNfdbc355sN63Zjk2yf7tt
4909	payment	1397	1397	1678	1	1	4150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuG16xcGDGavHuhjLKpwoYLU83K8a6z1zQp7DQsFC7FrE2PbDy
4910	payment	1397	1397	1678	1	1	4151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfc1TyrafcAuCnDvmeysyswwWR1K1JXvS24eU5t7u6r6tjUKr
4911	payment	1397	1397	1678	1	1	4152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJKF35DJkpV3DA1kahD4BLYWJxyhHcDs8nyFjkANNvSJLX6JQ
4913	payment	1397	1397	1678	1	1	4154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesHjrPdyE8ndbQ3zu7jt5uLAiQpSq53Ncxf2SvxbYwuDjEBHy
4918	payment	1397	1397	1678	1	1	4159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepLwfgMY64nNypWz2zEjCC8jGBQ4JViy5g6n4kXbR7MjR49Rx
4921	payment	1397	1397	1678	1	1	4162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqNQBBUmp8ns3Hq7WuB2AprTBgTwsxevDkY5HpZAkzwxkrAMy
4944	payment	1397	1397	1678	1	1	4185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kiLKMWmo5s3r4ZtwfCqsjSMipUzsDJLqnuYkiocKzmxtD11C
4945	payment	1397	1397	1678	1	1	4186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMX2ivkkadCoUgx5xrUFmxnuiW8A1nGQ5xQ1m1rsBbUeGY77K
4946	payment	1397	1397	1678	1	1	4187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxdnf7wqEEAP8Zw8GovfLjijGqixyFvtEGjzYbXqTagF3WjEX
4949	payment	1726	1726	1872	1	1	85	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfSPNbyHwkbUkFaSV4tNs1CJKENxHBk6zdNRoH3HQ5fP3ZfPDs
4950	payment	1397	1397	1678	1	1	4190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrp4fTNac58QDZwtD6Qxf9QPEQ6Z675QttqkKA3YY7GTDVs99B
4955	payment	1397	1397	1678	1	1	4194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZz43sAPrJ2LRihTXGkRcPF64zXXZox2gJsfVVXuh9dXtPJRE
4956	payment	1397	1397	1678	1	1	4195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8nN5G3khX6AvbRPxoGMBomq348cXDPmtuZFUHzey5KUYS5xh
4965	payment	1397	1397	1678	1	1	4204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEm8YfmehaHQ1sUttP8h4nvVaRCnFiSPNUCeb5Ht3EbMoHMAti
4966	payment	1397	1397	1678	1	1	4205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEzztnJxkcwgFKBHGh975MHEMbABTXATF73zt3zfo9eebKyha
4967	payment	1397	1397	1678	1	1	4206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi56QcUMD1upcNRpENCTN27fHUn4WGGzoJofxkSRa4RGSWq1H1
4976	payment	1397	1397	1678	1	1	4215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszNo5DFgkwruEPwBT9ba9K7cHszbGmBc62gM2T9deKmrP3zdu
4977	payment	1397	1397	1678	1	1	4216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCd77SefifYBUwVNuw6BnPjnVDZ4NbE8of6Q4Ug6qCtj5d14n
4978	payment	1397	1397	1678	1	1	4217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Vue8cbTKeiLUTNY1vB39xBma9PJjuJfUQqt7raUhfpV213qq
4979	payment	1397	1397	1678	1	1	4218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxkpW5VV2HjTTwQsFCq4rPEibRs2ZdrpfZz2UEXWkV4HcGMAZ
4984	payment	1397	1397	1678	1	1	4222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTuPPALgGEqUv7ksRUKrXmW8kDne4aM2tUASZmBUB9GiY47aN
4985	payment	1726	1726	1874	1	1	88	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99nEgwmeLZ3Fu1LVdD5jsra6NQV4BggzQaK86FsjYRfdsbjDS
4998	payment	1726	1726	1874	1	1	95	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2q8FznoBeRgYPEJT2L8FFeoMWSGTBfkK5vAnKWod9VZ6NWcy
4999	payment	1726	1726	1874	1	1	96	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SaopLcDXT6Zt3tVGRP7ckoGdW37DdcE9d1KWBtbaeuN5Pa9k
5000	payment	1397	1397	1678	1	1	4229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aM93vonrUQwB2er63S622hquMnC5KBNQ95iio2tjWAFwfbZV
5001	payment	1397	1397	1678	1	1	4230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzvAjojjt4rnMxCERBM1MrgHoJ6W9AH2CExUtpCtYreQFHrNA
5006	payment	1397	1397	1678	1	1	4233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3ZLJKGq4vS5CeVdi2paUM57DbDTuv4BUfMrbc8V4qZz8WqJh
5007	payment	1726	1726	1874	1	1	99	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQDaEbtqp6kchHNWq7RgFB2zBAERqUkLc2gyWqdW7uEuyAwHi
5022	payment	1726	1726	1874	1	1	107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEzGwUrAv67DZKqcFpobuk2gbUrexRsoyvt5DHUiot3XdzUFs
5023	payment	1397	1397	1678	1	1	4241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAWWZvyhDXLtkwbzoSUnkrkujCH47a3ua4PuJwkXxUFYaSMgV
5024	payment	1726	1726	1874	1	1	108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2e4u4Vie5pWx2baYqqrqt54ciSswgs75fujPjcaDjWJs6MLU
5025	payment	1397	1397	1678	1	1	4242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHrtxz2Mwv8EjmcUYceoYGJUeAwHxuT6L4PqhTKbvyj3vfZpT
4942	payment	1397	1397	1678	1	1	4183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZcvEEELKAZynTPdoC6FX4dKnUJGgJwHqboX9W7MD8KN9CRup
4959	payment	1397	1397	1678	1	1	4198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkuCkqUFCWeKb7A16o1r8o1jqEXUDnjzpsf9REcQSwdoQZ4ZJ
4960	payment	1397	1397	1678	1	1	4199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU7LgEweEWNqrAzeWvAEMKQKPJNWegasWF2e3EJCNtHwSD23c
4963	payment	1397	1397	1678	1	1	4202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZES1RFrQCuuan1ETzR89boQvtYF9RuEDEJ91cAYdEgAynp54Xa
4964	payment	1397	1397	1678	1	1	4203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11cvkVFAptzG5n9eZpyReR531Cw8G3ksonjMYjKQ436ur8K3r
4968	payment	1397	1397	1678	1	1	4207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Q3Sq3K9d4Ra2yQQ3nwj8wxwKMvTZMzVsH7jjXfGCFbXN2i9
4969	payment	1397	1397	1678	1	1	4208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcupRBBRg6xFcP8iM8Rd5jEtzq7exZDqv7v837wBtkaSZ8R27
4970	payment	1397	1397	1678	1	1	4209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZxGn4DRQftxFbTko85scojhk1kFUMArBuyC6p9kBxPjgYP6d
4971	payment	1397	1397	1678	1	1	4210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNBVBKehHvhH8v5s9wt2G1N18U42m9at4hZfbt2WJQPtxSZi7
4972	payment	1397	1397	1678	1	1	4211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1fstwpyT6nw6QLQCyYLvyRbQaTLLhSyKGXqtC7qE3paySUvE
4973	payment	1397	1397	1678	1	1	4212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADE5p9b5Crk4DtcGRAV1pai9kg63HCxqzh52kSb7ezzbV4VUm
4974	payment	1397	1397	1678	1	1	4213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwxBKHuSsZR4bK9aRxKeywUyErsSGJLYu4Vq5fnSbNjPMj7QT
4975	payment	1397	1397	1678	1	1	4214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1xDxzZMhxbZuDtBsDwPQ1ZNFtcZa4sjqtVCsUvRo5djn3Ci1
4981	payment	1397	1397	1678	1	1	4220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaD3YGkrkZEVV83MzsvN7EVJUGEBhEjxKgojWhkMRaKHxJhe9q
4982	payment	1726	1726	1874	1	1	87	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEtd5KyuZbzwDY9xfaQDRAccupTSqz16BB1w4yKj9GqXsE1yp
4983	payment	1397	1397	1678	1	1	4221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGe5qnkdvSgyeu8KMeS878PsCn6iMdtKeXX3efnZuknjvXVdk
4986	payment	1397	1397	1678	1	1	4223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPS836U4dw9pYU52njK2qk2j5ohr8ocJL12s1EXLzHH6poBus
4987	payment	1726	1726	1874	1	1	89	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGehGS6fmWNfTu99StHMhqUaYWBf5oZzpeXpVzHHfzGsS1o5AC
4988	payment	1397	1397	1678	1	1	4224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2h3reQxZs5ULpz2a7tS3JjbV2ot5NJAVw2qN9HhrczEj8Qdj
4989	payment	1397	1397	1678	1	1	4225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgmoGkxpXE9JpQFXG3YY5zFopMv8eXhywbD9wExBPEPFiPE3h
4990	payment	1726	1726	1874	1	1	90	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjD31jsfrQjWmdCVKYchCdEbNyffSphjNT8vj7cYKtm9PHXTm5
4991	payment	1726	1726	1874	1	1	91	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeTTtcxEgmN7aAgX2UZ6a1V3uMJRx2eZtJxt1UdZnpXa9qG4s
4992	payment	1397	1397	1678	1	1	4226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHNAHtye1Y91NNgRm4hDhtUWk78rCVeFZBkHQKWxUrbfNjFZH
4993	payment	1726	1726	1874	1	1	92	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2J9dpSu6QjtaAhXdMjPV44CiXFgTxEik2abUKBBMvjeYoc4M
5030	payment	1726	1726	1874	1	1	111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8u1sk4pXnqfXR4CVrTaAMZb3e4FBqrza7XACFx12BJxreX5FA
5031	payment	1397	1397	1678	1	1	4245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaBHA25X147mF2EY7TNnRzAgohCN64FHB2t3Wrd7tExttBRMd
5046	payment	1397	1397	1678	1	1	4253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7fNHz7WvLnkxwLt3C5z6xL7ZgdgCcsBANroDK6HEwnFoAS2k
5047	payment	1397	1397	1678	1	1	4254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoMTWukTkff9BxYwN8ti17qNS73XKuwRtQdTb3G9tgDdC7E3o
5048	payment	1726	1726	1874	1	1	119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsugivuSAPsmJcMhyGLr89ZDXR3ktVkoJ23LdRkzAXiDZvUH6
5049	payment	1726	1726	1874	1	1	120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGic62yyao9ncatkMbptF3i2Fa3pPR2YizqT3339Y9i4QYNXfb
5054	payment	1397	1397	1678	1	1	4257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61QU2z1Zs6zZLmuBE6DPuZ4T7bk15jsZ5qny8iRqHF2dh65GY
5055	payment	1726	1726	1874	1	1	123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdNQMAa8FGqeULiFBvuS3baqWmDgUAoaUcAsYoJKSr6RKCrq7
4951	payment	1726	1726	1873	1	1	86	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6sHGQV9cqHr33eH2SDjPszqAeTCEVRKswS1kACYCebGL4Tpty
4952	payment	1397	1397	1678	1	1	4191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4suGprmgdAH1nvxMTgJcaUYDdLM9YdrNX1oM4TnYqHaJE8nd
4953	payment	1397	1397	1678	1	1	4192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujCZgqEbAp4USQvrVG6QxXdxHddCWkWBzS1cgXaXQBEqw2HWQ
4957	payment	1397	1397	1678	1	1	4196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3spDgrAhhNgpDU5fEVGobk7XE7hCgfJQr7jDzUUcLz9VD9ZX
4961	payment	1397	1397	1678	1	1	4200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8Esudw1RQHmqssya8Qzo1pV2FcJ8PSv8ARwh17ihh48pwaMV
4980	payment	1397	1397	1678	1	1	4219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJT9ajCrZ4Pem1LtZ5JvKMbQZmawBdtMgNosrnafY9SuFs7Ft
4994	payment	1726	1726	1874	1	1	93	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxBEKd9MEvzRyGsbvS2WEK6g5TGW9mbpqXT6a4dQSMrM4Zc7w
4995	payment	1397	1397	1678	1	1	4227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMhsSDC5beBU4BgRXCtJEVYCyQT3Xc874GR6Q8mjzwZujaxjV
4996	payment	1726	1726	1874	1	1	94	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4szzfbchcBSvFvCrNYfWD4pXURYxtzesymqWTrj9SNYPP45b
4997	payment	1397	1397	1678	1	1	4228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2H6ZNWuzrMqgyRW5z9XdcxKuJhDmE4QB99sARKu8Pa4AXsW31
5004	payment	1397	1397	1678	1	1	4232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4zEjGbutfjfrMjACJrpPXwL2fYwgpPNeckwG55bLBK1wP6Pe
5005	payment	1726	1726	1874	1	1	98	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRx9cfVqN9KxFsDpBYonFPfgXr6cGcxZs1TfQUJpnKfunZGVM9
5008	payment	1726	1726	1874	1	1	100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHV3FEYDww1wCVBV6vfMP2iFHQw9wi5UrTLATNGKTaVBE5A3h
5009	payment	1726	1726	1874	1	1	101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZDXWex8589UwtrVrLXcZbkT23mGDfBW9t4EBfmnWLtihK76D
5010	payment	1726	1726	1874	1	1	102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyjCMjnGkTYjQrxXphTVJC2BPoyszaY3jshkK4VFReRc4uAkS
5011	payment	1397	1397	1678	1	1	4234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRpy2rR8Gmitdxqc4Dz5GhJuv3UUkCQff9MxpqS9g8ECsc5Pd
5012	payment	1397	1397	1678	1	1	4235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZyzfkKaDnM9Koes43FRQnhdMtZ6PZZJfJwtMGpkfeejPUbc9
5013	payment	1397	1397	1678	1	1	4236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUS6oMxNcogNKQ25TZHQuVJALTTDC2hUqz76Yy2pmi9FdJENaJ
5014	payment	1726	1726	1874	1	1	103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eoBPjdrepmS179AQYJSEHTvbJW61g8TxMMuQfNkPWYNxqCgB
5015	payment	1726	1726	1874	1	1	104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3caYxxVTz9KLq75bNU5hfnfaX2z7DxrDVhZGRU2ViM4Ma5UWh
5016	payment	1397	1397	1678	1	1	4237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2pRauHa7abqA52jdAwg8974JuK3zzVJCsvakkyJB4x1KZi6w
5017	payment	1726	1726	1874	1	1	105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGDnNBLJXuvHBm1FSgeoAwsM31unyNTmTX7SZmQXkorruPW7X
5018	payment	1397	1397	1678	1	1	4238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMvNZnwF2iCENaQ3Du2ehgg84trC4B1SxQ72dP6yv27CcC6xG
5019	payment	1397	1397	1678	1	1	4239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bJcCMxVQ1fCN2WSTpW7UxcrfA9kQSrHy6uHxv7bkw8xXdUHd
5026	payment	1397	1397	1678	1	1	4243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46bbpesu1aeyYKqawTBaHn7pwoh2pjxpA66Ycb6zZEAgpDee2
5027	payment	1726	1726	1874	1	1	109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQQfKFMDsPk8sYAorbWibg7LsanecWvqBnvQdCg8UeveDiUpf
5033	payment	1397	1397	1678	1	1	4246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjyiCH4xPoHbUySJvWHRAJE6ZmWmB8cq1oMQ4v1jDRzhjDWn2
5034	payment	1726	1726	1874	1	1	113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurN6mpKNzPVLeW8qataVgpj6mVq76XQfF9amtzNoTSqWaAU4K
5035	payment	1397	1397	1678	1	1	4247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3WP3grakdP5rwgaT8h3WHmvvfUnz3F2b9DoTM7M6qkDobNM2
5036	payment	1397	1397	1678	1	1	4248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiAZ8eRe1xw2ZbZKmiyUZaceQKyBTeNkw14Z3gsSQe4vTXmog
5037	payment	1726	1726	1874	1	1	114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGh3U96eQzb9QHmPVYoXFMAoovGCKpw5hbdosnoP4gxsDvRFd
5042	payment	1397	1397	1678	1	1	4251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XfGQvCwRQNN3AQyRRxAJN8Y6SQAXfdXDDqes2Gubr7bLhQNc
5043	payment	1397	1397	1678	1	1	4252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7qT5S4sL13qo88fgwhaxPHECn2o9kGxV9F1cgX81RosqE8wd
5044	payment	1726	1726	1874	1	1	117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJSnP7mYRrMDQEvjeuVwz2AXAfgSNwRsmtFkjLpzUWgnCpRY7
5045	payment	1726	1726	1874	1	1	118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WxikhbJq8DC52Yx1Wf7tHpiDtJR9JY4eagKBQ9jv7xAQm9og
5059	payment	1397	1397	1678	1	1	4260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrxL8nVTebau5JT5TmPM2EbtQA853eiSQwuxGu9MWvNMU7DWe
5063	payment	1397	1397	1678	1	1	4263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm2ZAawvaUhmHymSnwx9YgNWqqKHrxeR9yxLJjaYUwF74zxXF
5002	payment	1397	1397	1678	1	1	4231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahqBwaRzvAXHvYasqoZ96xV5FueXhhVSiknepmN1GwTybi56b
5003	payment	1726	1726	1874	1	1	97	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxviYkX7dt6PEkcUoYZ1SL8dxLrCxGvFLTWgGkTRWXqTzaAEJ
5020	payment	1726	1726	1874	1	1	106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsUnpL95KVH98HjNuifqCtRAmBjUykJnMbkDxaFmTTahc3Ytp
5021	payment	1397	1397	1678	1	1	4240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9y381cHYVFXSmzt1wEna1UScMPY81T9btHPwBVb2u4s26GBdU
5028	payment	1397	1397	1678	1	1	4244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kPAzwiGmg5T4Lr22XGnN3Dn7eD7LczLbwKEkzngn2BG2bJqQ
5029	payment	1726	1726	1874	1	1	110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPNFE5XRzAjbpTyRUjGYgdQC4gdKN5ip67diGEXVWP8HjjoRX
5050	payment	1726	1726	1874	1	1	121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYLoUrtMguDjo8m9QBHKv2kTKzjPFfJj1MViRemLVYWiJa5a8
5051	payment	1726	1726	1874	1	1	122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mSeGxryvoyFU78q1pKvv8zCnYxMLeDUjWVkzvcE9BkFGFthC
5052	payment	1397	1397	1678	1	1	4255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHyZT1nFswJdJsL3TM7kvwJiyoY1kgNcjdEwzSGawnf5MEBLK
5053	payment	1397	1397	1678	1	1	4256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUHyV1AGavVKHugPbcW7zC86rZiSWEYFWRiDhtZFx3ZxnbHHh
5056	payment	1726	1726	1874	1	1	124	1000	1200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zRsPux4xFLqdVXzftTeS7YVrA1NRHtcm88Aasgk6MW31yYz1
5057	payment	1397	1397	1678	1	1	4258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QJqLvAbsER2sL8T4nFCqCsWbLT2y8TUjiW33nrBq7tpg7uYx
5058	payment	1397	1397	1678	1	1	4259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7A8Xsxni2wDQsYbhAPUuzKFGZRGCwiXeFhLBuSdyMjypLuvxx
5032	payment	1726	1726	1874	1	1	112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXyTRBxLKDdCKiFmCAZvo4vV2uJqTXvGUnXKCnPjcFN8uSdnv
5038	payment	1726	1726	1874	1	1	115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMpJhqjbirYuZ9BDJjixei88qV39dnnqoTmucFTRMiPVnabto
5039	payment	1726	1726	1874	1	1	116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaYBVCc2yLm17uLXGmUfgNUg6Av51nE3bSwkwfwKNADq2xfxH
5040	payment	1397	1397	1678	1	1	4249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLgz3YmymordYE3SWiJRTPoGJ8jQPxwsat9Atq1yiHkUEUbme
5041	payment	1397	1397	1678	1	1	4250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPVkgrZv24oXSJNLwPHknB6Mbr7nMbzKaEpqmAgBVHcYAgnCy
5060	payment	1397	1397	1678	1	1	4261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXCjf8t1ZVgs7e3Ar7YxixwnvsnVf72mBj2ZZwSxrTKiPavJa
5061	payment	1726	1726	1874	1	1	125	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZgYsWeFABv4HYskE2mH6kxPXPWqKJdenxRaHq6kBamXSoEQW
5062	payment	1397	1397	1678	1	1	4262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL74ouD6i9XEinTQFhBqcYr6DEXQXdUE1Dny3YF3MZzdDC1CpB
5064	payment	1726	1726	1875	1	1	126	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7h9srosUdrHCrmLER22ujEBDaQZHqSDcJbn3YrCG9acoto17m
5065	payment	1397	1397	1678	1	1	4264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fF8p11hD8EoKsP2HXxdJ5DGzkzdAYwrLHzdwVwsFFoCmQxQH
5066	payment	1397	1397	1678	1	1	4265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZh5LvrDHDjmoLH7qRpGiBqRzA42b1g1V3zT1QWuirzBQMsBq2
5067	payment	1397	1397	1678	1	1	4266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF8f6oEEcrEzvUPVUmZqn3SpyGEhFv9th1XDKs5ZezxLAiXnx
5068	payment	1726	1726	1874	1	1	127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6f9Dx9jfB892HjdgpX3eDEzBpKgKbTSeuK2FMWLhihy96NyNs
5069	payment	1726	1726	1874	1	1	128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxavZmoCsBNuhe4uWtKaDGWU4cUz7zxUPmHjbCxrriezKkPcC
5070	payment	1397	1397	1678	1	1	4267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnb5Q6DwfHLnpLk8Mf2ofspToZPXDZrhmnZQYJcujd3bWauhRP
5071	payment	1397	1397	1678	1	1	4268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNMFejTVpzGrS4TAVoQVHAgMiBRRP9jFddZ9HPkT5hr3tc2C2
5072	payment	1726	1726	1874	1	1	129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQ676VVKjFTvBSDoec6ZqmkJfmu1pCX5j5otnG4HvLdzRSYT9
5073	payment	1397	1397	1678	1	1	4269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudUviuc88NALKbsE3v8GnJf3C49TrsDpcG2Rayw2BJ2gfc8q1
5074	payment	1397	1397	1678	1	1	4270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKMjsf8UTY6z1WcT8bpVQ14T8ZGP8mdggC6sLXrFSrGKHDiSf
5075	payment	1726	1726	1874	1	1	130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ih1jZ3BTjn35ZFqkBR9RiA6HkL3GNGVde2EyBw5J4QEp95iv
5076	payment	1726	1726	1874	1	1	131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6pakKhReZTuXp7VJ2vSHk1gDeXL2MtrR8NpVLkKnerbbtLyp
5077	payment	1726	1726	1874	1	1	132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkTjUHz1SPNn5kL441N9ySPw1ihm2oGSRohpYZ6pqRWtypW6Q
5078	payment	1397	1397	1678	1	1	4271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDu8WqAKwewBwM7TRUw4HPbPMEF9uWFDJT4B1dmyPZqsV8gVr
5079	payment	1397	1397	1678	1	1	4272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKiUkS6Ew8auLWoNAgXbMY5P7R3U4kZf1MSBkEcoU5NLUNHKi
5080	payment	1726	1726	1874	1	1	133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCp9deFgrNhi8RbnEEGWZ3BQrULywEGvb6SPm8RpVnDdshxMJJ
5081	payment	1726	1726	1874	1	1	134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtpCJJBZ2Nk23TVrn6brjYE3qD9iMMpfi3PWWVPPzStwVLMHwM
5082	payment	1397	1397	1678	1	1	4273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sBAf94jX3bDJ57QtZtYpGeG2oR3PNEjK4vVmVqkhhahCCEuZ
5083	payment	1397	1397	1678	1	1	4274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMvSJtctF2gMJj9NUFHhkWZpKkXA5JPhQgDBXegsTm3vk8XGg
5084	payment	1726	1726	1874	1	1	135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGh4igtEsi6GSSkJHCjNiWvBwFQLdx4gBUVqKd41boRw1c2xKb
5085	payment	1726	1726	1874	1	1	136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBpaPT6Efvkpi9QK7a3enc9Ct7UaQEq3RLmpX9Hbz69sDxv4C
5086	payment	1397	1397	1678	1	1	4275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMdAuy2MJAgbAHYQLxwSfUCn2qt9jnCwUGpxiiy4zwPtgdaN9
5087	payment	1397	1397	1678	1	1	4276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaFJdcaN2ijB21FeVZQJ1FoLGqsW9jQcrfiayxsMrpeoXTSuf
5088	payment	1726	1726	1874	1	1	137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyu1XLRFEdRnFXgfNqbkCekX7AuEDn2N3HdFUfbzNtU9CNnxN
5089	payment	1726	1726	1874	1	1	138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifniWJ5iaqTvJVL63VzCMU1HeYZqsB85TMVYiEuWxtgGBBMqq
5090	payment	1397	1397	1678	1	1	4277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3M5aWgfsQuqc3wm2aGG4zzmZPDzHpRWYga4jGyco99UY5TZec
5091	payment	1726	1726	1874	1	1	139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtvkGZ4WQc6jsPCiMXUnGQWwZas64QHce1juYqJXAFHQjdJ6C
5092	payment	1397	1397	1678	1	1	4278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aqADSjUeXqVmFWVJFoMFTtvWaYbWrD4GXBWkYEfjGxSihmS2
5093	payment	1397	1397	1678	1	1	4279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWADACS5TRMWBwmNAunChLJnyMQeTd9Xy6yAoBhEtLEyajKgPV
5094	payment	1726	1726	1874	1	1	140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUzK9SDsHd7Gd5bEabT311wBSFwJ1uyzNTNANausJ7fU9XCQ1
5101	payment	1397	1397	1678	1	1	4283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkXRA3szuurNeJh9mSydFrYn6BBWfVVkk1RCk5TsXxoBgm2nJ
5102	payment	1726	1726	1874	1	1	144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WdT7P13YbUZwsg7j1GgSngKcehgh6G28jJKx5kJH56GKsNrW
5109	payment	1397	1397	1678	1	1	4287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3KC9zBh3Vm418q4GRpfhvGwaUihKG4TGYVuUEvYcuZGV5Ueq
5110	payment	1397	1397	1678	1	1	4288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiu3x2sZCnqVhARd6RgMN8kbfanrk7W5gkWcGdccw9vYd6Hqbw
5111	payment	1726	1726	1874	1	1	148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6f6ZZHjoPnS34rbLMVtL9ATeFvuFkjzYgVfgSMQ49pmJPKSWP
5112	payment	1726	1726	1874	1	1	149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsKvWapoMD5fbjca9iZ1mTJpz2KFpaYTvaYXr6puc8hGJkvWH
5117	payment	1726	1726	1874	1	1	152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgKzDuAicTT7hcEcEBmBBo1yHyYxTSVQJZBtJiC2QosQmzkH9
5118	payment	1397	1397	1678	1	1	4291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsVb5xEfMkYgXGvzux9vZ95XfwdyLu64FPWZnNRJXD3rAeuUc
5127	payment	1726	1726	1874	1	1	157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaghUVqQBQwwojEtkU3vLLJdnNCVTVx6MekdUqArrLoTMWNfY
5128	payment	1397	1397	1678	1	1	4296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2oY2VRZf9CM1gkqgVKeBRomny6hqL885zeaxEEVcdSum6141
5133	payment	1397	1397	1678	1	1	4299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXptr4kT25sX9ku4pKx8bR8gEqZd7K3UWB9mztoMjhGED3TBzz
5134	payment	1726	1726	1874	1	1	160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzn9bJrPvDEHUtRdgdkiDoPCgVotmtVKexnBsJ7a8JyvzMVmxd
5159	payment	1397	1397	1678	1	1	4312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfAHsayemxkCcme5cjiHrERNQtqdnBZjiSLtdvHXs7D2jiw4f
5160	payment	1726	1726	1874	1	1	173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEhum7j1iePKiX4LHgmii7Qf17KTYTg2EBwrzGVVkBFEq1rs7
5166	payment	1726	1726	1874	1	1	176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8a7nXY9pZsyahuuE7GM68MiwHy35j2nspq8wt2ifTCvtYxgso
5167	payment	1397	1397	1678	1	1	4315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHB8kkdnKMicmdK9EKhNXrFX6GS6eiEZYLqHfMjKeuBRe5RYE
5168	payment	1397	1397	1678	1	1	4316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfEM5jVfVdfu8vNLqwqRpsoqXyzETs7dPvbcY1rKQcoGBuhXT
5173	payment	1397	1397	1678	1	1	4319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBfz9sSRiphZtrGJPbgdyCGhwbPVxuKLjFgv146uGJgnQCCer
5174	payment	1726	1726	1874	1	1	179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWhQXKqeoK7CVGSuU6WmBMwHr2XnxcrYoQ7TYcXPAvvy9kUyG
5181	payment	1726	1726	1874	1	1	183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLGVZGLqGy3wJ3zUFgQaBXAe61wLX9wAyvrBgtqjT5ZAhD5BQ
5182	payment	1397	1397	1678	1	1	4323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgCgr5wFBcgDFyajU73hA1hmxy1bMoUmT8n8GyMF2NP57GDuE
5183	payment	1726	1726	1874	1	1	184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw116RhMR6UgXyMhZ3yzFqxpcY6tV1sizSwpsBBLjFNnAyMYug
5184	payment	1397	1397	1678	1	1	4324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHQzd1Aw7d2YNCwJufitp7CzVmrkcYZ7ZKcVGW7QmsU92Hh5Z
5188	delegation	1876	1876	1540	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oaK3wwxQScmsNguzALobs6ybM4GqQ9LM94BCXC11kHZ7PqnW
5189	payment	1397	1397	1678	1	1	4326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAygANPD3wAWhaScRaJtGWwhEuoGKGswR81syZjterXbcPLZV
5190	payment	1397	1397	1678	1	1	4327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNn3ZyHjjN991TaWMo7QFmBkxwfCGHNonDsLVnGpRH3NbjeoG
5191	payment	1726	1726	1874	1	1	186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFK7aa3FhmCoRRqFTvgHQiy1szGbA42SXPQ6u2gfbK8ZB5EHFs
5192	payment	1726	1726	1874	1	1	187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC77WGY28XvDVb5ooWkpCtv6MEXqVb1wUdtA3Lh5QCa6gdZYf
5216	payment	1397	1397	1678	1	1	4338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5MvzxGfNRCxXsnaMjXuQHffTRojWpaNzhAZmnh69mv2H9UTk
5217	payment	1397	1397	1678	1	1	4339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoMgsjB9JwSzGkbDKRWBFA6UgqED9HVTKy661W5o6dMCgCGCo
5218	payment	1726	1726	1874	1	1	199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPR4VZNumsiuE5GHFrLEffmUPSogobcPntV7t23UMW5aDdetS
5219	payment	1726	1726	1874	1	1	200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRENRXEcxyRxFNwLCPj93ctiFK3P9tWwbkQixoh1iuUGA96Bt
5232	payment	1726	1726	1874	1	1	207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanzcVkjqVpmPgitJEfVrP4SqHYcdLrvXNHb9d9db8jLu91UX3
5233	payment	1397	1397	1678	1	1	4346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcxhJQYc1VXn2V3Gj2VaDoQtcbEn8vWD4VQNokd2GcVfnHuTf
5242	payment	1397	1397	1678	1	1	4351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaWpGPnGZaptynsmu7r4B6vbFDRwr9VksD1MzH6wguFrdyNZk
5243	payment	1726	1726	1874	1	1	212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRz3hW6gE1NRuPEh63RJVp6Yne2iY41MUkXpmUMWmEtioqSfg
5273	payment	1726	1726	1874	1	1	227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSQuEdTNrDfq8vUDPu8AKsdMQuGUc8yGzZtp7DkRdXHbgxGDn
5095	payment	1726	1726	1874	1	1	141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6eRBtMMiBYb883rZERhfSr8vh3T1XAVwiswkXyquxCpYUGwV
5096	payment	1726	1726	1874	1	1	142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15xPSFRb9QKVp2Ag1bcSDutibLFEjQqNY15zSRtWiMBBpLMBv
5097	payment	1397	1397	1678	1	1	4280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouaHycuyd8PpsoPzcTSWd32aEpYZnT4ciFwbwQoZqrWLjahgx
5098	payment	1397	1397	1678	1	1	4281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVqNitQmhLSW7Ji8XM9Ug3Kw1SCcA8UxQwD2NGguKqcPs6jVy
5105	payment	1397	1397	1678	1	1	4285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdDjWqdezAiiZ1YX8TmkdAbCW8Wq89m4mhSAAKrzbwNXiRPfQ
5106	payment	1726	1726	1874	1	1	146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoPncb63d3X7vgJAQbTJ1izHpdKTHLXz5x6DFAcFYCUBCgJEQ
5107	payment	1397	1397	1678	1	1	4286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3pAVA9iFZwwFuvXmxq3hDytzzijtsH3EFnaGNCBSzHU5wxWq
5108	payment	1726	1726	1874	1	1	147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBXsj1E1Z7P9tZqKd1bcF3jtPbFjZgydpwRuAd8HB6rdeUgWX
5131	payment	1397	1397	1678	1	1	4298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYam2BauhdwazZ8rfgRrMtBeXw14gaEcm2oZeRcsX4NTVJ7ipMB
5132	payment	1726	1726	1874	1	1	159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tv5uuwX8BVApxayYx7TFT246uvXhHKJkTFEcrCfoGRkHBPjz
5137	payment	1397	1397	1678	1	1	4301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwStkBxDJDzH2VP2ZebcuQYRp2vDh82oGMaDupj1yhDEjdw9A
5138	payment	1726	1726	1874	1	1	162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLGDYeYD2WTBxY5X3KmtrHESzYSREKpAR9Xi3kDShrAMBBjBc
5147	payment	1726	1726	1874	1	1	167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT58AF3oe8j1LtVs2trp2awzL5F1dKy3caUv9vGeZHgnhjPr7U
5148	payment	1397	1397	1678	1	1	4306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveA2Vbigr8qKa2XTX7mCZym6jHB1q9rTgEr5cB1BJc1NYnJTg
5161	payment	1397	1397	1678	1	1	4313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5xGFCsjqcmckCFookzzdrJDtCoK9aT5QMnAz6spRSYiKThMf
5162	payment	1726	1726	1874	1	1	174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekg32MXwWPPuYGKrirYmy9HqNfRJceu96M61Wi9yaGy4Qtk19
5171	payment	1726	1726	1874	1	1	178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSnKujnfVMmckDAxYRsqA7ppbmp3nxhTjMap9irweLn4xGrQb
5172	payment	1397	1397	1678	1	1	4318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUK79sAyFQ37nx5fVmSQE2UMgTqm4jS5ZrrJ7ELESeLgjHbWG
5177	payment	1397	1397	1678	1	1	4321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69sav4AsCk6ceMjWbzihvRk5aXfQjLHTtZvNY2nFKtWeyetJo
5178	payment	1397	1397	1678	1	1	4322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdf462otKqKEZ6PngRwsUzNcwtoZ4NQKgZNpDUJfhDH8gMLQtD
5179	payment	1726	1726	1874	1	1	181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6tg4QNasEGcEGdX2HRJFuQ9e1jqpzn1EzPCs31JaGZ9L6Lrk
5180	payment	1726	1726	1874	1	1	182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaufQWzkjg1wfN6rNez9rJZ3pg4RQVhfxYNyCkNyQsfQeihUj
5204	payment	1726	1726	1874	1	1	193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFYFQyj9FUgWT7LwTLpiULdxDggnT1jE2X8aGYcVjq7F8jY9R
5205	payment	1397	1397	1678	1	1	4332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iyp2BAx7j9XjL1C2xtG8KYGXgCzMroWeWzsUtMb57ngD6Z7n
5214	payment	1397	1397	1678	1	1	4337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJscj6VeVo73HXfEzfknmLiupH2R7pJcqC46YYV2DuchfGA3r
5215	payment	1726	1726	1874	1	1	198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyDAbeCi3siWWvETPBkiQreQMwmqiECnMrh3HnjWjF1Uc1oXL
5220	payment	1397	1397	1678	1	1	4340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa45J8tN8jMqwZQa9ooFNtQ9FJNLv78LnurLHyci6RU1zi6xp1
5221	payment	1726	1726	1874	1	1	201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsthMRmNTepbRYSpKXNnqmopAFsCrLRH4KF3opsmyeCbCkNiZo
5222	payment	1397	1397	1678	1	1	4341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQLAiqqnL45U762ywcombUi4U8dn6RU8FyJ5oKBCahALPwVe1
5223	payment	1397	1397	1678	1	1	4342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZjWjN7D4ytsSSVERTegVd6rGgS85RTdXnZvJVSWM3kiUvUdB
5224	payment	1397	1397	1678	1	1	4343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa92BAdzjrpAGQpYMUQTzeVobkpCwSb4KmdmJCzuV6Fgeoqmhb
5225	payment	1726	1726	1874	1	1	202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx8NPCwGsggZLZvxDaP68bwv528rofZMFPhWriLLf9XQDb8QV
5226	payment	1397	1397	1678	1	1	4344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9QBqfQ6ZCniheBLZYSWufUqJo1MmeVnLsrTaEevfQZr2MS7m
5227	payment	1726	1726	1874	1	1	203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuT4wnmXnkFBRR5sU7FyasGKLNvG3y6MfoHKwznEoDcZNi79xe
5228	payment	1726	1726	1874	1	1	204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP7UVrhkjDkRF8iHhBcUWoX8go3WyFi651zAi7MmrwkTvZ7eJ
5229	payment	1726	1726	1874	1	1	205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqTS6aJNvzTgjYXh5YEzJfCqDTEARZXGygt6fCYaSsBt5tQVL
5230	payment	1726	1726	1874	1	1	206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfU4cMDm6E6yXM4hZP1ZoKr7kj76qgsJ9N2oGAU4ja9xrdGfA
5231	payment	1397	1397	1678	1	1	4345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCNnMTXRuDMG3syNXTb53W7qXL1fGbnf3JHW4ETXp99duvx6h
5099	payment	1726	1726	1874	1	1	143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5PBW2xjAwesVsb3xwzr6F9eeLYThc7S1PpLsTNBCFGLuBZUB
5100	payment	1397	1397	1678	1	1	4282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPT6tB1JZVkCsMsMWpRrKScxsjurng5p6Z3jaqZFG1yCj9Y8E
5113	payment	1397	1397	1678	1	1	4289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfs8oajCNsNExKGEfPNBwfy18pqLRC9qqehLwZYYieCsREHTJ
5114	payment	1726	1726	1874	1	1	150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQfepbDpMH4ygJXzvJjZFGuPkZ9ayzZTQ2JSFUP982ypaY6yh
5115	payment	1397	1397	1678	1	1	4290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmnLqq3jvBhG2PATqBLmB7MUkM3KA2zs4nyoJFZfVMB8Zbdk5
5116	payment	1726	1726	1874	1	1	151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQipmDJSSmV64jnpAK3CkKYJFYPVPvAD3JjncX1hZkhJyuMxq
5119	payment	1726	1726	1874	1	1	153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdTX5F6vbmsN4BENfcCUUkiRu2HafDXxJ1AKce3FPLhbW5ysP
5120	payment	1726	1726	1874	1	1	154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSWCjwD38hgk1vXSX2sRvGdeGooNz812GgJyGn9116jnQFanv
5121	payment	1397	1397	1678	1	1	4292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPs3DU2nVhoGUKbkzg2hnT8h4aTPweku6ToJfE8ky35x55wYB
5122	payment	1397	1397	1678	1	1	4293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2Yidmagy59LGRFoFGKmCNavuSH7LfEPa6qTZCxDEZRGy8BeM
5123	payment	1726	1726	1874	1	1	155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvcQ17dPeAYBsaPC4WH7vJzVMnskFvnyrSyPTWC6cEYHUXNp5
5124	payment	1397	1397	1678	1	1	4294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGt63AJisdZQXrdrdS5BPEyArDnEuEqrR6cQsdMjMEWrsTXE7a
5129	payment	1726	1726	1874	1	1	158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZujCKYwKWL4ofXbSDiC6szUYAFP7LXMuG9TuFgE7ycsuBPkBG
5130	payment	1397	1397	1678	1	1	4297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94ym6Qfcb9xxQcXstTtkdBqFqa2s8KjcsV3qBC3ACwMjxwgpu
5139	payment	1397	1397	1678	1	1	4302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdvtKodGYJCc5VPQV4sg8BVhGJ2YbTFaKVAFJU118iF2uLmX2
5140	payment	1726	1726	1874	1	1	163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2pcbnt8aJ5uLnnaDyFLW2NK9mN5jGnhoJgL8YRkS9Lg1692j
5145	payment	1397	1397	1678	1	1	4305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZ6VVxz9mVVZhudUKKSwMrRVPwjm9FW6wyW946DmmtqkUau9x
5146	payment	1726	1726	1874	1	1	166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2w5FmvBDtVfhPNet99pAejKpiqaQcpEsG2Sj4yV8HbJrZMEW
5151	payment	1726	1726	1874	1	1	169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2nbHp8AFkCErHenbnbXhnanvP9BCoTVvpY8oJnTurddhZiWJ
5152	payment	1726	1726	1874	1	1	170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmY4XdPUiWsFcjUriNgAvhh5Vc8CGQHkQrv2n4af4zfZCobTJD
5153	payment	1397	1397	1678	1	1	4308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqjpB84cwmukS5L3aFUptiLfUNPCKd5gfHTAHcWWBaLvEXo9X
5154	payment	1397	1397	1678	1	1	4309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWFBrn4KKPdms7ZCoXKfZoYBKkR9eUiqF5vumfm1QXyCYviWc
5155	payment	1397	1397	1678	1	1	4310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMbieT4g2v9AHo6kVkRZL8GGR89jn32u4KvCdPfat5LdkT7qF
5156	payment	1726	1726	1874	1	1	171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FqfwDVD2iVcqVHhb65JFZzN19XR2PacXJTCyKeYgszuPDm9g
5163	payment	1397	1397	1678	1	1	4314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLkQP7rxh15YFQxHT6DBWTK3fWt47r4wUFBxtNr8BsMu7KuV5
5164	payment	1726	1726	1874	1	1	175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHrnEwn9vEDHXhKpBAMbjHGAJJ3ZxTDdMtz3MzTai75xeKuCm
5165	payment	1540	1540	1876	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCRxu9vhBHmgR3wg8TNgGLY9PXdH3k2um7tgXPCyJHDu8w7VV
5169	payment	1397	1397	1678	1	1	4317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSMHDNZAgo8wFkykkDMiJBjBA5WnPSS8RzhNE7o7M43cKrHLY
5170	payment	1726	1726	1874	1	1	177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmf6Tju4RbWhDCq3vcJZ9MFxGrXC2jGhkRQsp15SdF9KCbjGd
5206	payment	1397	1397	1678	1	1	4333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnKNqi5zsMhNVq14VjogU3nPzcjduhnedqY7MAAq2j3ebCmKy
5207	payment	1726	1726	1874	1	1	194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUp6Y1AGuNSFDfpT94Ud6Z7n3G5gL4Rdmz2woWDeCQYjHnuYRJ
5210	payment	1397	1397	1678	1	1	4335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3orBuE4t3rnHup7Y8otwMeAwpZBBMqUofYu3qpfJPkHMtH4Y
5211	payment	1397	1397	1678	1	1	4336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKw3DeLoi5DtWWmww49SuJ3BHJMZVwHWD3xH9zepvWJEK5Z3L
5212	payment	1726	1726	1874	1	1	196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcruxPs6AG2vTsZZiXHhKBLy3JU3b4ELkLECKxtPhgusqFKvpC
5213	payment	1726	1726	1874	1	1	197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9FSEQC8Y6Av9vst2MoU6D51PJbTgfwzKxrCrSGWvbXf7pyKj
5238	payment	1397	1397	1678	1	1	4349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjxuYTLkNea4Kxr5vmiNAi2JyVfTtpSwQrkVrcwJ8uqrjCx2J
5239	payment	1726	1726	1874	1	1	210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RVGtDNQC2xhq11easVhf7K84i9eqR3MFR9Qo1PBMcxzsw7Zz
5244	payment	1397	1397	1678	1	1	4352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLqpstkq65TTtiX9rGw3VGpQWvgJpZPVHr5JR5eU8QkLra7mf
5103	payment	1397	1397	1678	1	1	4284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP4RHaWtargrRWAZNaRVBurYDVJr4BHcHMAgu8BW8fwtMtSt5
5104	payment	1726	1726	1874	1	1	145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpkKRJZPDux7Vq9Ey9ytjdXBtPYwe46WJrmogb6byR89mAxeU
5125	payment	1397	1397	1678	1	1	4295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsEry9CJsXMibUnUdHNg6WfdmjwmPbfz2KPoThLDUqfmFSCWg
5126	payment	1726	1726	1874	1	1	156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvN4ym76x7SoHemmCWBxiae9MyDwh9pmhTTqR246xT2Nyuemk
5135	payment	1726	1726	1874	1	1	161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdqnM78WcxbjYikqQp9qZY1hfvDoHDYDnu84AQynwu4Ma4NY3
5136	payment	1397	1397	1678	1	1	4300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bmykxzq6jwhxre77yGhj1t6wcdpvvrgUQpEj1BH2ZTxVuUDw
5141	payment	1726	1726	1874	1	1	164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPUBJ47REciX96APiCkPcg9LjW6NSyQB83oeBkTJ9hDZ1WRgN
5142	payment	1397	1397	1678	1	1	4303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1XaXU7PN68yn4gGYC2Z3TS8iyKrzeiavprPcGAUGrinkkfb5
5143	payment	1397	1397	1678	1	1	4304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83vXFqHVQ1Ce8cj2tHUQQHoshusqAMoMfVxAH89i4MPc5U9sW
5144	payment	1726	1726	1874	1	1	165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM5WEacBwwbqeRKs8JoPAUBsZeMZ3qQMk9vdtvW3ZyEirdRnN
5149	payment	1726	1726	1874	1	1	168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm6MLdtkGZkGjYdYqURxiyy2NR9jQnfYXzg33uS5YEHvm1gwu
5150	payment	1397	1397	1678	1	1	4307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1D7Us4hGcSuA8FjfEhFLvGcWKsdhpuoF2mh6tdRQ4V6cQEiFo
5157	payment	1397	1397	1678	1	1	4311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KZ6dZBXojMHVwjax28qjdG9okzq16NUSyxbLQeMRz89Pm4oJ
5158	payment	1726	1726	1874	1	1	172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVkdy83XDu6VRoR3vsdcv6zjgG166TJMHSmhUNLtxQhgD7p9Q
5175	payment	1397	1397	1678	1	1	4320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVypsUh1oofRFPmhf6HgC3RH92FWGuDbJnaMk3SFTUwfbEQTo1
5176	payment	1726	1726	1874	1	1	180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1qf2wUqskYvHMwqLNoV4WnBVAiYkotZ9WBEE8Gxao9TH9kPh
5185	delegation	1876	1876	1540	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaVstTXjoudhwNjgdyzCzGQNVtpP5RobRmhMSWaW8LwTLe6iG
5186	payment	1726	1726	1874	1	1	185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSs22gjABqtc9mwDAR4hGmddZAW4jrvajChFeJsScns4PDaUT
5187	payment	1397	1397	1678	1	1	4325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHhKD5gGvCQcyJhE18akfagCG7C8EeRZ7ebTAood6MTuHZVSg
5193	payment	1540	1540	1876	1	1	1	347700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PnVMTqMunhKXg8M1fDTShv5Eycjzm3AXvtAGQQNidgiYpCgK
5194	payment	1726	1726	1874	1	1	188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNUZAynNpqx3jjWER1so43Q2JYSgSCtk2Ks3rbe9qVWuHHsen
5195	payment	1726	1726	1874	1	1	189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt2jr32mst7fsRM4RRrJCVjefX5HuoDstbV4ev4WWg4nXjjXV
5196	payment	1397	1397	1678	1	1	4328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UCM1SMAHoDFE1YiA5LS8HjjRiHcubi2DXh1r5s1DCV3v3jVH
5197	payment	1876	1876	1878	1	1	2	1000000000	10000000	\N	E4YvxQ6SFhV9NNcWanSNgykAansapi1gm5PmYkPPugxu4UzhrGww1	CkpZ8nPad5GM4kSZu482ZtpDdLY2yT793jgJhrcstb2bTV5WvhEmS
5198	payment	1726	1726	1874	1	1	190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryS7dcKYUAaMWXxtWEPhHce9MDcttE1NaMjzrsprdqUPNjDGn
5199	payment	1726	1726	1874	1	1	191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePQGDC87Rpwdw3T9u6VVfvvuYtHgUfDtdQzNyXLy1BjZXdGtQ
5200	payment	1397	1397	1678	1	1	4329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16Jc5Mbf6hAZgejv2fdZ3jfa76h4VqyApaSyZLdbER7ETRMts
5201	payment	1397	1397	1678	1	1	4330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ha4Ab187QDMEmzhWgqNtBWHjX8Be3gp3Zk6C7LU71xejPiFB
5202	payment	1726	1726	1874	1	1	192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjaeAcTLDCnWLt5LXpbfbaQ3F6NfJGSk81qB7kdtAk8sT45vY
5203	payment	1397	1397	1678	1	1	4331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhT3cuLG2iYohdczzeZPZ9rjDtPi2kCD79koHL4DhrgzLgGL5
5208	payment	1397	1397	1678	1	1	4334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUnNtEYU8ooqKsuq4p1BwYMMCNagZTyAFd6ZvCsPBhTXZzVT8
5209	payment	1726	1726	1874	1	1	195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5xKWgm1Xso6MUUPrwWffeSa2qWMhamzdAGYREhZSdHoaAKjF
5234	payment	1726	1726	1874	1	1	208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoSEssgRgFVMTmhQzAk1RP1Uq6NZFWreoJmYZCZX8MhFBLobj
5235	payment	1397	1397	1678	1	1	4347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KLQ8momuQduPL7c4MepcV7rJ3MkxBnQ4Bqdto2H2TNB5QuH7
5240	payment	1397	1397	1678	1	1	4350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3s8JK8pwSWs8B6eikPnvRYbsooZFjLwmCb66AbAC4QbKLZfB
5241	payment	1726	1726	1874	1	1	211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNF7eEHM3aJeLfyBzQzrftg8ttQvSyfF5Gd4opzZV9d47Bb8P
5255	payment	1726	1726	1874	1	1	218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoSVG6KYXUsXbsaqedkT6XadFy7cmGp3QhnYiggjCCikvoRDX
5256	payment	1397	1397	1678	1	1	4357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEHnX5UfT4Wwt4ZzqWSNbWQy2zvgjcxvtwobiQq85ut93vxnA
5236	payment	1726	1726	1874	1	1	209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEBNLNpSnrmdKJNNBxTRmi59f7Cfyy2ShddYUWJLnei8gCs6v
5237	payment	1397	1397	1678	1	1	4348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeZ7hqq2b8xeZPpjhUvL7aAQp1ohf4k2DXJRCP4yVKvFwUAYs
5252	payment	1726	1726	1874	1	1	215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDwjpjq3UJFXLXXFobt6fH1WGPowzhF2mdYQXcSvJ6YYEkoSr
5253	payment	1726	1726	1874	1	1	216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbizGAUZh5vjcB2pAzAjd3drhk6gAMaZoxxw3PpKjFgpMqYDHp
5254	payment	1726	1726	1874	1	1	217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqzqWKTVWiWrZXjCGJxBZo8e7yK2vnWkj2nNcuYrSmvDDXavz
5261	payment	1726	1726	1874	1	1	221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxE9wceZncDwaHgDPbGJe6smKbgumBNusWMJbUKohPmeu26Ls
5262	payment	1397	1397	1678	1	1	4360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tkMhGqdYtjDC8NhSL2Su4B4FhdECtthqF9au5Q6Api82gLEA
5269	payment	1397	1397	1678	1	1	4364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPx2MmsCTF6FUFr2QfZQp5UEcfC1B1YTz7tByCDBUaqEisTrU
5270	payment	1397	1397	1678	1	1	4365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZni5FVGb7USYXMpgG6e7d46fq8pveypYB1xpYYuZNSw3HAuPd
5271	payment	1726	1726	1874	1	1	225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpyatrWRs9F1CPShpZu7VY5w278N8VGMTyaT7dE7Ycs2SvKPM
5272	payment	1726	1726	1874	1	1	226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wWxZGvH37beY4CrTHZF9N1AtbL9WwtFgEKg1Gmwp9wbdRVTq
5287	payment	1726	1726	1874	1	1	234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT4ugaFJt4scvHQMXKmo2BC7KCmVgTbZVDgmL2NL2ePMYz1cV
5288	payment	1397	1397	1678	1	1	4373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhssiGMeD2nMANC3CiRCnBCkpXVrEVP4hjdTcABwnQRcxUt4f
5293	payment	1397	1397	1678	1	1	4376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLq9HafESHtiyUkWCPGzes5EB31cT3b9iaEtcsiiJnTSjz6at
5294	payment	1726	1726	1874	1	1	237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmcwkJpRsd2YgY5onjWKwQ4UbFMAThGZ3mtEteLFpGjp6EnA2
5295	payment	1397	1397	1678	1	1	4377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWkPtKSoVMmaPuc6TvZHoi7pcW2dohZjdm6ctL4Jcr8HRj52K
5296	payment	1726	1726	1874	1	1	238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx83Tm5yyVguxvJQQWyoTuhgGVDaeRCpczhh4RmEJQc2vvXvkZ
5303	payment	1397	1397	1678	1	1	4381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUtRny6jF5zdX8aE8aWJ3zcMXNCwftz46pQXLryTmL9DPBGjp
5304	payment	1726	1726	1874	1	1	242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbASJ85sFx6PnDbKSYQahTHFY629c7zeXooTiW6AszTR8qcsK
5311	payment	1726	1726	1874	1	1	246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE63uRwYqNqtmuhSxFqbXEoWVRvSrxszzDoc9pBZ9UQvpmoy5
5312	payment	1397	1397	1678	1	1	4385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz1iz7WWCYw6r4nUwZnZYjKbGsWwRg5yMDcxuHjVruHjkrMzL
5319	payment	1726	1726	1874	1	1	250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4WKgyoPAZD7nCSbVWQp3xr8qoCDxpCpeZZwP7L9sYN7xTL9y
5320	payment	1397	1397	1678	1	1	4389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XPL6CUA4F4DEQa6jSCFuZcPgHSZGqEMuTdoYEMDxAXZ4Ad1b
5327	payment	1397	1397	1678	1	1	4393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPkeeSUE3HXPhpMe6WN2b9eDP54to6PZ46tNoucYjtvkHh5ie
5328	payment	1726	1726	1874	1	1	254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ETw7ULRE5oQkvERVo71fWcxsYoXzndaKpK49UjrGvxizr9Ag
5341	payment	1798	1798	1726	1	1	2	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYnTXxRTnXb6RQxxZsz2nAf4Mn6vkg49SKFvqaEsmB4TJ52t1mz
5342	payment	1798	1798	1726	1	1	3	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYtaSKZCB3h62hR4VJfCjjqtP3qvHGZPk7ZZrnPDmy4KaPMykru
5343	payment	1798	1798	1726	1	1	4	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpZQC79qTLeYkN8We8cys175am4FcyuNbo45tTKfoTi525UMFdbq
5344	payment	1798	1798	1726	1	1	5	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	Ckpa1KVCT2PQWihZrGP1YwAzp8Ri2b1rd85mxgtEJzESbCrpv8CYa
5345	payment	1798	1798	1726	1	1	6	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpZnvR81win9aFYmG6SMvC1Fo9Jjh4oWX4RJTeKAVrXpaANS3th2
5358	payment	1726	1726	1874	1	1	266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9Web18C3a3A8ErVjZCRmXHU2sbd5SfFLTkHu4ZFQDFBhbSpL
5359	payment	1397	1397	1678	1	1	4405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6FfQaNiP83NnWZjvsDS5ginKVLL76P4eLQn7JfWwcJxKZf3w
5372	payment	1726	1726	1874	1	1	273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw14ZYXg2XPciT739yHgXXPVKdSY85XW1mGokTvEnVaxrmZt1f
5373	payment	1726	1726	1874	1	1	274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKHobSsyqrEV92eB1dJDpXEBffNwzAWZMVxCM2vs9N4p9waMM
5374	payment	1397	1397	1678	1	1	4412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9MEyYxxXPnbrpdnzXFS6ZGtDWu1mNHAUoASnDb8NYKMBgsWq
5375	payment	1397	1397	1678	1	1	4413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Qq1a11sF7P14Pz1UaVdhkvSAby486vohrCh8LKWb6nS3WP6e
5390	payment	1726	1726	1874	1	1	282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95ZL1A7mF6F6nai4kKob3u2Ev6RFY9UzqtbG4T3xoMQvewi1W
5391	payment	1397	1397	1678	1	1	4421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5X2TY29y2MKH5EHSoZQ281BBdxPVMjaH6RJrBM1zC88EoP7PU
5245	payment	1397	1397	1678	1	1	4353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeni5LLPGuyaEUm6VVCPenxZT4mnEVWpK5rXjboferWJJ1xDv
5246	payment	1726	1726	1874	1	1	213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVTkpsMoYxX6e54T3RtMVbQH9eFYcmyDXGnNhJvLPjNA34FB2
5247	payment	1726	1726	1874	1	1	214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenD7pS5TTjTzwZ4xF3rEgHSEUhCFZQiQwx6VGgKb2a88UKLLv
5248	payment	1397	1397	1678	1	1	4354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomghvqgiXNDTMHt3pRJJJxDGRQWxYdGHMiwzimgaweg99LuF3
5249	payment	1397	1397	1678	1	1	4355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgtPdiQC3iLVCwUjQKVUDxKaZrX6RntfYUaexFeMXbhsB97E3
5250	payment	1397	1397	1678	1	1	4356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8VepcxaxFkg2PC5G9qYK4bhevaCX9BHUPxWHmwBwHuyen6x1
5251	payment	606	606	1295	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEftpmxuNosQBu24ZruivycfvGi85JcFkR5QtV5oxamZFUW1SM
5275	payment	1726	1726	1874	1	1	228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkRV7xFYzVScY79hTySeT4BzVPPsz9Yah6eEUgPLUkWdfHVk7
5276	payment	1726	1726	1874	1	1	229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTCW46pGE5LEKoBiYPHLpKmupk9XCw1aXbY569xCCsThfnudq
5277	payment	1397	1397	1678	1	1	4367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fuAWg4AX3E2tcgizJjW8pKR1Uq46gJWaFFM57Mv2dA4QP2p8
5278	payment	1397	1397	1678	1	1	4368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5LfuQiLiG6JbPQ6Gbkg1RGpshqhsyeECuQ8jCWnjE1EoGrxv
5285	payment	1397	1397	1678	1	1	4372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26mSRx6RvaDCsKQxSzJhbL9UhiudLRfSYLQhpci4Y45eFtraf
5286	payment	1726	1726	1874	1	1	233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR9EerypemjMEzSHvxrFiFQxYRnVbtommQsAW7S6DPCULj4Kc
5297	payment	1397	1397	1678	1	1	4378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHRWKYhxqMYtHCNJajEnxTq5RZt3XRaZGeaMyqWuTifp7DdZQ
5298	payment	1397	1397	1678	1	1	4379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrB8RzoKWu3FXkVzquq9XVecsZFgPwhNx7RRHs5YihpLyYnhT
5299	payment	1397	1397	1678	1	1	4380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAXgQuZuZMnhLzxQayh5TQq8SU1PjsaVbfWSth5BPJYgGaEaq
5300	payment	1726	1726	1874	1	1	239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWz29G2uPiVEaELwuQa9He9x8PQNJhtzbALeBcpCcSBP9otPf
5301	payment	1726	1726	1874	1	1	240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6gaELRj3QxiE1E7snbNbMpEqdMBje61CMkCBN1r6AcMYDY3i
5302	payment	1726	1726	1874	1	1	241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWMqoMkH1ppgSfB24VA5fU9UwSHac5Z4VRVXWGzJVfWpp19z1
5309	payment	1726	1726	1874	1	1	245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn96t2qRv1KA1YG9q9MySsemgx2Wtk1tESn4dmmDMQsCfvQ3iQ
5310	payment	1397	1397	1678	1	1	4384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxyKQh9FqmRYRLbPpLXaJBLDjD8bfT4GoUtBZHq8xEpS9KM1c
5317	payment	1726	1726	1874	1	1	249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTqBgjcpG6oHSeHe6fDaFQkPUdmxacvytb5hGDXc6cwZnb6FJ
5318	payment	1397	1397	1678	1	1	4388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLLrcbtYBHpBfNXLNzEkjXnNHtNm5yQh6oNxNQJqGwMc2bPZt
5325	payment	1397	1397	1678	1	1	4392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWcbusKitKyAcAeSSPm4E8n1PJfF9RjXVyB84E43cY1cDZNBY
5326	payment	1726	1726	1874	1	1	253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5qHBoL9VXU3tB6sUWxHJWFS2g8YigpK6zqxs8hmSeJtuKGNnn
5334	payment	1397	1397	1678	1	1	4396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHhr5oxS7nGJPhy9BZj1ADhSBvEuyqJMbb25v79MdrWWBuFKA
5335	payment	1798	1798	1726	1	1	1	10000000	10000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYi56frFqnyoRBYxBK4W869mRQX7gyBdMapaFVTb2S4Z1TEK56N
5336	payment	1726	1726	1874	1	1	257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYje5d2myUqeXGXe4gSTXGtHfJho9pkE9yLKE85eYBtsMZsYimd
5356	payment	1726	1726	1874	1	1	265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPPL2cLf27gMa8bTk2ys5BHC7DqnCieehp2sNBWE27R7F6wYR
5357	payment	1397	1397	1678	1	1	4404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2hyTxaYE3aAkWXBCbJqeB4WrSPMZ89xorsYmxGs8t7axgVJ4
5380	payment	1726	1726	1874	1	1	277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ714JnuCwZnXZNDYNUZiwz7Mxds9BhYE892JpADeYLB4LvCDit
5381	payment	1726	1726	1874	1	1	278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoemxAvHRjT7jWnNVWtLZm5MVkXgVE5GUvjVqvbfbjzMFbNxZU
5382	payment	1397	1397	1678	1	1	4416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VEYbqLb6iBuo7JdMZWyZbED4Hn5xgKX6AcnZYH8TANe6UCzE
5383	payment	1397	1397	1678	1	1	4417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVUxesMwmhcytwJiCejjNPAA76y36bzUhznFY39f5df5bzZNa
5384	payment	1726	1726	1874	1	1	279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQs25cXPGThBh8bwm8mWsF4ufj1Wha9oUdYgn3jiAH7tQU1DcZ
5385	payment	1726	1726	1874	1	1	280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MR6XJeBUzRM81EvqqrnDEY1b62YYh13jMDynWVAafccM4Nf7
5386	payment	1726	1726	1874	1	1	281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYif9mHXavYge8ms39XMqcZ9DU91tJ9Uqwn8gQV6QJ2s8mhHTnn
5387	payment	1397	1397	1678	1	1	4418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerqfhyW6wXQxwUEyt9yVNbTWJvmxND3doSiNAAhc2gxspektu
5257	payment	1397	1397	1678	1	1	4358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoZbHMD2WtsGRyimcnKoLC6VPh4jMfSdjgDkx5eW4LqCxroZY
5258	payment	1726	1726	1874	1	1	219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr28ivXyvYU9G58wFgF2bX3oZH3tNiycHgjebxg1eXm3PmMeqv
5259	payment	1397	1397	1678	1	1	4359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttJ8bY8ujQY58Tajd1SFw8scDL2CYJahGKNuduVZiFF78ZZ1F
5260	payment	1726	1726	1874	1	1	220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1y82fao6jS87YKCHVpwy9J7UjNvbBkhx2qhaZk2YJoCA3ibV
5263	payment	1726	1726	1874	1	1	222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9GMDyeYdLh1qqAT6cV9p3kSEvRH5H2TrhdBJWgZcTtvx69SX
5264	payment	1397	1397	1678	1	1	4361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA3uyZ8KUNMDUFC6w1sW7P7CaChbZnukdrg1qCVmuL6xjKAXP
5265	payment	1397	1397	1678	1	1	4362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVKpQxfeZgrNRrZ6RHY8KgVXeUFm43psuJNvhDuc9JfPFrQFV
5266	payment	1397	1397	1678	1	1	4363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4hZsVMnx4QzzGQYkLR6tp7a6LTevZZtK9MygYHaWo6dGDbbn
5267	payment	1726	1726	1874	1	1	223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCD6fnT3a5QuEZCXVu6xcQisW4s2RRMEQrfiWMchGvFSgPqt9
5268	payment	1726	1726	1874	1	1	224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcLfn8ZTVfwHbHhPUF7gppPZDkdAHxrbGTS6Rhe4RWyeemYEe
5279	payment	1397	1397	1678	1	1	4369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbid1c7rRTYZ8MpF794wVScQbTmrnR8tgUJ9T27bJyE9wvad3W
5280	payment	1397	1397	1678	1	1	4370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnJTQ8nvnn1KRVhVuqdBLGVaCEVyvSusRC2rQbFop4sDALc9E
5281	payment	1726	1726	1874	1	1	230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHviAVh3stStDK4ad7fYTrXG9iz2qe541BLTnjo9tvSVcuWno5
5282	payment	1726	1726	1874	1	1	231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP2yDk1AfkdEgDehQimJYCjio18EuWFNtnHisSk5J2Lts2keH
5289	payment	1726	1726	1874	1	1	235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VCHtabUciZJqBMiQFezYeNWshnPL8EugHww31rP7MSoVkoqq
5290	payment	1726	1726	1874	1	1	236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfQS78Bc2DQP1F6MpTsYXFE1JKiXWGzuwzN9FxZJPhmXex68u
5291	payment	1397	1397	1678	1	1	4374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19dpXv2kgebjEFXJLX4ih9w4AsgMxMM3figKT9r5sThYy1UY7
5292	payment	1397	1397	1678	1	1	4375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEf9zPuVafTiV9K3o7tZLNwyZWUBEQveFvtJMqFrbjQnebU9qK
5305	payment	1726	1726	1874	1	1	243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBakPX5dbYKEEUGMJyXsH3crauzFqBwcApvaYCXkyFEpCWXHu
5306	payment	1397	1397	1678	1	1	4382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQEBXKh5R95Ht4Fs5Z4DD2bfsXD16w63hGpygsUbCzuQemjp7
5337	payment	1397	1397	1678	1	1	4397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxqUdYbKghPxAg6BGpNx4QRY4tywwrGLVB9vfRfNAZatip1RQ
5338	payment	1397	1397	1678	1	1	4398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNorr2nXphRaLEi2sZk9e9RnWhJbdJerWP88Rkg78AXFhxfec
5339	payment	1726	1726	1874	1	1	258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMGbqHjsAHS49mXxWXgNBhm3rCv4jJZxxVP2CQAUSHUw9WPJA
5340	payment	1726	1726	1874	1	1	259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWHe8pUz4azZSbymRdDbv3SxZnnYt1rsbgmSbnCssrZAmiVde
5352	payment	1726	1726	1874	1	1	263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokCgA7sy55is2w3WtJdYGX7CRr8imnE2cijVY5Hbmw3mvuQq4
5353	payment	1726	1726	1874	1	1	264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaGRtNbrjxBBmrsbwWXgQ1ws4gTeiM1yBpiLgPCQDoNoA8g9P
5354	payment	1397	1397	1678	1	1	4402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdNmbY9bFecwCq1ysQ8SYDuvrL4ZF5FTSCPQFTJPtsgcJA8Zs
5355	payment	1397	1397	1678	1	1	4403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfTg8gpoc7eQHgE2Ge8cBJbe7Jro1n8TRtefYEgyZgM7TCTR5
5360	payment	1397	1397	1678	1	1	4406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL929qFijcPCAdFPqFVDMXghChqB3Y9QbwWboggN6bHdQCEBdh
5361	payment	1726	1726	1874	1	1	267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4C6UjdzFHhr3aLcyfwmEpiCoGGPUoJDLa6HLAeD1ToSwcAxPo
5362	payment	1397	1397	1678	1	1	4407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhpZ1BTXKLRKh9crZEBaHppS99JKptxLzXuFDeG6GRGdnhCwQ
5363	payment	1397	1397	1678	1	1	4408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuVfaEvkdDCPHdnCQoeJcLkVofVLAg6KtgT8XyyvTPdeZrrVr
5364	payment	1397	1397	1678	1	1	4409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrY8Kc9vipAQPeFY6drhDZjSREa6BrLyz2Hy9RsWchuKvwyanY
5365	payment	1726	1726	1874	1	1	268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37CgmaiHrLJ24vGZKKVw7waDqZ8xsafRqkNEyHAiNuPLgA7uY
5366	payment	1726	1726	1874	1	1	269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF85K1MHsTayfpD7N7aL6dE2CndqR8edKD5ArPv4daTV1XobD5
5367	payment	1726	1726	1874	1	1	270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr17e3anm9P91jkTMXcLABMvXGe9wQs8KrHVaJqcjvfSzzpcj4
5376	payment	1397	1397	1678	1	1	4414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uMz6cicuBMXg4kmC4hR18bfLdNzfNUQqTMoERcvjMEpwEFaQ
5377	payment	1726	1726	1874	1	1	275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7TPHMWdKZB5PCALiyUztqGta17sshNzDBTevZGEM2epLPAk2
5274	payment	1397	1397	1678	1	1	4366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqs1tYL7LwZFsBL9sagtAiCjokwnrFpLj5AWSdY22NJGTxeETt
5283	payment	1726	1726	1874	1	1	232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxUb8Ey4dHdQqq1auqR2MCT91FYc9bduw19C5BKB1jW61Wbhy
5284	payment	1397	1397	1678	1	1	4371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmV9FBRgebtGZqNtqgWvWoZ1SaK35J53k6ULaQj5RioMxmpYK
5307	payment	1726	1726	1874	1	1	244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDVLLqVvo9pETr3YKwsCydc4T6DPD8CDosVPdnTL6wA49gVAa
5308	payment	1397	1397	1678	1	1	4383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUDgwAR4auC8UkAvnvoLKA6fB9J2hDFpszF1QNqE1sNRxPTMH
5313	payment	1397	1397	1678	1	1	4386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdt93JHqLW9yy9q5Tcn2CJnoDV5g1wmvSqyeH1EmVQYr2vp9Eh
5314	payment	1397	1397	1678	1	1	4387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgW8RjB1ReVeZjNFcSiKSVvtupF4WNC8madxsiFD43Wxaduvf
5315	payment	1726	1726	1874	1	1	247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ42LSsvyhXeve5F5rFg1j81sSFiJTXshYFaGMWAVhgZV3pd9g
5316	payment	1726	1726	1874	1	1	248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFa4X7qkmzh452eqnmiHmEyZucTX7K1rB8wDmf3LY2zC6uJYP
5321	payment	1726	1726	1874	1	1	251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7WMTswAuLy72KyD122MNDozdnpjq9wyXFaGkUTQ8S9R8PB4c
5322	payment	1726	1726	1874	1	1	252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmWuRihsQidnt7iRP1vcCriXMetu4JeJ2MAoLtkMruxZVvmJ2
5323	payment	1397	1397	1678	1	1	4390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32U35HWVrxrUYBgj7yDUSAwZdip2xfKapAa9kfcDqpKTYJiE4
5324	payment	1397	1397	1678	1	1	4391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKCwPmrq2o5T1a4KFGRSTSPPGL2CpKygoaxRZkpnwikTXm4mS
5329	payment	1798	1798	1726	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykEnN9BoBKpcK6hQhQektheMeCgPaz6Zg6mEdGrzn9NKDAeeH
5330	payment	1726	1726	1874	1	1	255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VFrP1EeKUnYZYHbGZxNmUsTPAXsYXkeesZAq3trB4uJrENGb
5331	payment	1726	1726	1874	1	1	256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kNAcAyRsKko3g4iLd3588pZu8ZcbZdViQkWMsseP5Bn9Cwrz
5332	payment	1397	1397	1678	1	1	4394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5vZAGbT7F3t7Tco2f7D13mxEUjBiDwn3NmCQg7nXVUPBid7P
5333	payment	1397	1397	1678	1	1	4395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqiPZ1XDwRwqDLdTFJtgH9vAkAfAHNWfLCzASUoHoSSfnTFCx
5346	payment	1726	1726	1874	1	1	260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqa5YEjyh19ZfWycnUXEYz46yVNtsW6QdsSq93emz7XFKBz9C
5347	payment	1726	1726	1874	1	1	261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX9NpCPTb8cVZKjeRHaBmq6Z8b2gXCihLigfyaHgCuM2BJdBN
5348	payment	1726	1726	1874	1	1	262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJZLGPN21qg3TBQJxi9qSdL5cxfFTfSBamcCGnyogi49nnsh
5349	payment	1397	1397	1678	1	1	4399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxiqmGf7xvqGJJZdpruD9uUuec6TnzTniEcQtqTPsaupUg7Kv
5350	payment	1397	1397	1678	1	1	4400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaN4zkmN7L2DapFmVa53DuutqK3oN9VYxpgFtgu2M5N1FThzd
5351	payment	1397	1397	1678	1	1	4401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PGi7Zup1deAq4Q4NW8zRimtcQRd72Ce2aBknHnrEXYuDF1YZ
5368	payment	1726	1726	1874	1	1	271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSKomDLCzDteBQn4mmwVYGXSMJjWJeuFmLRDZtMx4rKLHMS9Q
5369	payment	1726	1726	1874	1	1	272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpM9iNt6QC1q6ZfMv4dUurBJoebM3qb8S1nmdNnwUtUZ1eAK7h
5370	payment	1397	1397	1678	1	1	4410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41ByVpnH1xRJWH5sKt1sPf4hBc99hYNCHapszfM8HJegfwDxK
5371	payment	1397	1397	1678	1	1	4411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFz93U2832nsFekNjb6YR5KNL9HAB21CB8UWS7K8sp4EgTDTg
5378	payment	1726	1726	1874	1	1	276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxoSJf9qAjVkPSPMYQrFDNuczN9wNB9NETEeuH1eEQFTztvTa
5379	payment	1397	1397	1678	1	1	4415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxtBPE3NMxy8ijqNDwuz7ig2cVCDp4ZEdJif8YKRT5V6F8qAT
5400	payment	1397	1397	1678	1	1	4426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty5dTToyjMq7op3TfGs6Mqvj8wvdwXBFsuwMrmGKRRcTRwjdk
5401	payment	1726	1726	1874	1	1	287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLBzmDcnTEGmcMgWga4P5cCp6bELfXhHf9nyw37zDzNJdfmMM
5408	payment	1726	1726	1874	1	1	291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbs7m2Ri1674NjKSBYN6ms7YLA7KvAXCzT32Bhfi2m4vqDDnT
5409	payment	1397	1397	1678	1	1	4430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iZaUVZeo8LrpjyqaGT2PBKmugQtsYs5daVbXat1qwe31u65o
5410	payment	1397	1397	1678	1	1	4431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpw4tJfUvaysJeFMUigDsJzYokHFwWQenJYh37c5CF9urNKCLk
5411	payment	1726	1726	1874	1	1	292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnLwdUNoUxHuAP5hiTfk6VoiCaUYRfeuYFwWyJEBsF7UvoheX
5432	payment	1726	1726	1874	1	1	303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPzxT57SvdeRfhx8vZoYJAmM9CkE8WQ6H8qsKxr8JDVfri4PE
5433	payment	1397	1397	1678	1	1	4442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4wHUP7fDTaLLMxjrxPXeaGVHRn6d6ZfFmTkpezkepv9srHWY
5388	payment	1397	1397	1678	1	1	4419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYyq4ZScUD3L5w2FMeE5Ex3qqdZC6QiSVqo2jrVHc8m7Ljugi
5389	payment	1397	1397	1678	1	1	4420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJV6HzkRLUB5ZarKW1Erpt2gFqwZwohS87b6kexQ4sVPMxCCqh
5392	payment	1397	1397	1678	1	1	4422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnGLPEswAACA9J3Db12qqa3pb35je9m29vRQYcs3SoXoASv6b
5393	payment	1397	1397	1678	1	1	4423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUSYVkub1UX5jJVJb5QGw5g95mCdrVuq4EVKydH6phHLkdVP1
5394	payment	1397	1397	1678	1	1	4424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkKWjYebnnz62qfRSZ6rKFZNsN9vtn3f61LLGKTJPmxa9xRM2
5395	payment	1726	1726	1874	1	1	283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7BcskJMmNaiqD2UTeP9bpv1XAE2u7QUKQMLjdDnGkk52LY64
5396	payment	1726	1726	1874	1	1	284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqf5qvNgWfTDLLbYcLc3GmfoeLb2AchLfZDcSABj1voUriwxxu
5397	payment	1726	1726	1874	1	1	285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17NxjrFcP91CWcx1LScAY2w2qMxZdBVsCUrcvi4rJ7Xvv6JcS
5406	payment	1726	1726	1874	1	1	290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjgHj9hEsRp9a6nB9YQKcTFPHfUDKgktQLDg6ZkjYoRiKxr4w
5407	payment	1397	1397	1678	1	1	4429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jRTjvRMCkVQ5NGo3rPHkRPNZB9gwvGejwUjBDUGmnXT5inQj
5412	payment	1397	1397	1678	1	1	4432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRxpxnVaCRdAGwwwBptZp6KetRs9pZ7P46VDvBP1gfsL1s81U
5413	payment	1726	1726	1874	1	1	293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz86vzJ4VyEbL3VZa6XDZGF5ZuBM9KVUePVNZBLBuyDzCNMcrv
5430	payment	1397	1397	1678	1	1	4441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQpDLvpCzH4KMn4iHytNQKknwWJFj1V5PkAjAyuQfDmwsdq4q
5431	payment	1726	1726	1874	1	1	302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9Cb72skTUqKRdKY8B9braENCyqcsBUanS7nQmvLz8YHQ3siY
5436	payment	1726	1726	1874	1	1	305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDnLFGLxUSmmsy3TCFtomjTYHw2KEGnhksqD9cSmKhvNTFsVy
5437	payment	1726	1726	1874	1	1	306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9muryEDkXQiyWdhqBL7VNNXqLHUeHuuBHu1GMSvUYEzMKkhJ
5438	payment	1397	1397	1678	1	1	4444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjUGrLB92g4JkjQCPyQJ4dkURpvVfRico9y91AdbMwfRpLxd1
5439	payment	1397	1397	1678	1	1	4445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLSd4Md3UMKJ72u57VzrBxenCfixt22d3pQNsbz9dt5fDhsEW
5444	payment	1726	1726	1874	1	1	309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZms7rsGxshcWyzCKBZswHkqTAg5MRTevgnxAcnYKT9cc6QyimV
5445	payment	1397	1397	1678	1	1	4448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rGNhPBft16b6F26UYFNkudxQ6HTsRahdbPW8HL7DVthBmZp1
5446	payment	1726	1726	1874	1	1	310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4WgzF2cRniiVZwxiiJuVNz4wGvAMnazViMyJzNqyXK1Usi2QN
5447	payment	1397	1397	1678	1	1	4449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vUaqDiXcd483NEBKxDPVub7Ym4QF55z2vk5fNmEVX96S7EAZ
5452	payment	1397	1397	1678	1	1	4452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUymvEEPFjD9V5TxSjAvFrqMwEmPAW7mn58Kw8A7ws5wWWrCoy
5453	payment	1726	1726	1874	1	1	313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbC1E3cMf8hN1uGenRUXf81bxcWJiyGikToMSp4oL7DxM3QPv
5462	payment	1726	1726	1874	1	1	318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX8wCA8eoxwKku4jkgo1DsxhNJoKw6qv7i8mhybbngB5EU23f
5463	payment	1397	1397	1678	1	1	4457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybyJaMF1zVdwGLTCLHdocvxMaXN8UDzSZJUFZp987XvByZ5sG
5470	payment	1726	1726	1874	1	1	322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPJ48whnBqD1PrvJ5gDm9YNSBQs1AUNhtxi371XiwGtsPk7qn
5471	payment	1397	1397	1678	1	1	4461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NWoKsLJyzC9PAJZdGwTzvtXPAE86buNbwoAxazNSLMyNd1Be
5472	payment	1726	1726	1874	1	1	323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBQvaxNdYkgfywFFHEg6u4AXd1VhJx3kvSXkiZ9BQK7Ba9L1B
5473	payment	1726	1726	1874	1	1	324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJB3gyonLCm4i3wfKSjbSzTg8XtoidL4QXupvWR5it3JVd8ai
5474	payment	1726	1726	1874	1	1	325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiYqNQxhLhcSpktbTgL9q8xnDD4nY7hRbYnHwcFojSvf1g2RX
5475	payment	1397	1397	1678	1	1	4462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35RHqvBcGLX9ZeRxjSbE86a9gWVQzyRReoiCEAQQepj5ss2Ch
5476	payment	1397	1397	1678	1	1	4463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2k2Lv9yvgywAewSUszW2k2DGTEW1sLRveABZdGVXdoYJvPaGJ
5477	payment	1397	1397	1678	1	1	4464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM9ZxLRryErhZnhVUrk7DZfZMcG3KR3uaBU46mxsrE5M64yg2
5487	payment	1397	1397	1678	1	1	4468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgTUPCmeFw5ZAt8p2a7k8gbEEBfbuVpfjtQC6gnzXddcTX2DZ
5488	payment	1397	1397	1678	1	1	4469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gPiMvMASe2Qon9f9YXAWa1AXpYadS9ToiJjYbUP23za7GAcx
5489	payment	1726	1726	1874	1	1	332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtLqGHAeGXGyBimA3yyKEvjAd6EPoQY2CorUSSew13Voo9yx1
5490	payment	1726	1726	1874	1	1	333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2BezQAV6Kowctnj3prav88oNABstySFsAKMayvr2YMwYotrk
5398	payment	1726	1726	1874	1	1	286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7tb2XoC33bWm3mvmxGnN6szQQs7cCHYTWS4jx9DTbevXeTw7
5399	payment	1397	1397	1678	1	1	4425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPngg8pvjXVaGpv2XpVYQiCDonh9oVP1KAKchufzJfioDjEahn
5404	payment	1726	1726	1874	1	1	289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3WLdVbdh1dLmd9mZnrtGXGaZHUz1eKGzwcSkH1uWv9dTXZJP
5405	payment	1397	1397	1678	1	1	4428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5Pqn2ndu9sk4usDV46GBkiHVjazLXpwEcwxKRFiF4cUNfAJZ
5418	payment	1397	1397	1678	1	1	4435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzh16jivKDBuRMkd37fLhFityeCRy2r8gckZeSdHDiGLtbFJz
5419	payment	1397	1397	1678	1	1	4436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXoQdzMFtvacUNLao7F1NEUdKUfrKJdwbE1RysSoThbb9tGUX
5420	payment	1726	1726	1874	1	1	296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTSVp8cYnDMLvrnATRA1ZQKCvouxysVVdZDzgmqZ16tAG3ceh
5421	payment	1726	1726	1874	1	1	297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLX8JWhf38L5LVtGREQ2vot6SWaZRQM9ftbvAQXgj8ATLQz8jM
5428	payment	1726	1726	1874	1	1	301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSuWDHogztQu65mShUKFihHY2o2QpPW4KxyYbEJnY9cucNU1h
5429	payment	1397	1397	1678	1	1	4440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVktfeRsTV4AY3g7pszSE9u7TLgE2V6bCRDFmZbUzFKcySQQd
5454	payment	1726	1726	1874	1	1	314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25W9KhxNBywC333u2kAk1NYTcTCdBnRjWfamAupMZ9YDu5uj9
5455	payment	1397	1397	1678	1	1	4453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoaitbSk1wLB1379Cx1wFCUkaKysAvXyVimGzfPtjuegpzBHr
5460	payment	1397	1397	1678	1	1	4456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMVD6Zsab2LejoUfq1Q1jLXkQTS2aeFneNPzzLVbiXgaqcHZu
5461	payment	1726	1726	1874	1	1	317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4XFp2oFZGA7KHx2MLQzektgBQaJXi2GPq42KckYc38K1fdEB
5468	payment	1726	1726	1874	1	1	321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHopV9zHbywDCJzYotrARrNsjRddao8SJo2QWuyXcgWGfTdyxu
5469	payment	1397	1397	1678	1	1	4460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa8udSFW5KyDtWxfR8VY19hBrW44F5E6RWfRtupARAmrPEMrEE
5478	payment	1726	1726	1880	1	1	326	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYy3XbtMyUuSrFVQ5kVQcgt1o49jxMboq1sTgkUeyTvap6saX3y
5479	payment	1726	1726	1881	1	1	327	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaF2LtuVGGbF2docYJCuYhn8UEGY9DU95a4rYLExa86EHPRd2Tx
5480	payment	1397	1397	1678	1	1	4465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjRsV4w3p83jA86kteZihMT7RLoFSKoB1eiUCxCSVJ7EsEZoW
5481	payment	1726	1726	1874	1	1	328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ca2tAVY5dx3dWxtyFpQJmpywJv8fyUq9Hp2Fvq5FnXEAhuog
5482	payment	1726	1726	1882	1	1	329	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpxpKUoZZirj6ktc1qim1sPLVcN4gHQNQps2x88mSX9zTWnfBw
5495	payment	1397	1397	1678	1	1	4472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCG8YK5NY4CzzZktP3FGossxMhjFzpwqnrrGxphoLqneKFR9M
5496	payment	1726	1726	1874	1	1	336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWb1BWqKiNRoZDyYhUMxLkorZqbBTy4SFeWfjKqQGXHVTHuKk
5503	payment	1397	1397	1678	1	1	4476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2c28SntzWuE1HBaxBZEu55ij4wXYGopiaEgpQCqCRJoqWqugW
5504	payment	1726	1726	1874	1	1	340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrSJTFveqow6EeNZJXUSWrXBMHE7V9YUSEqgc4oKRmjCchRmM
5513	payment	1397	1397	1678	1	1	4481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc14nTDTzJoatgfBBPaC5xyRRQ8CNUFEDsNZsbeDjAafz49FZ
5514	payment	1726	1726	1874	1	1	345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFim52LsCx9wuJiMuJ1T8EmDqAWpwfPNrAGPk1tWDDVA9JRuYQ
5519	payment	1397	1397	1678	1	1	4484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnqW2XEZuRXuVoqG9e3wSEcomW3FAJ61JFGDToxTdtxuZqkRk
5520	payment	1726	1726	1874	1	1	348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2YAQogWw4bTjmrxcbSVWc4U61DDQMYMnVsdUZxmjNrBvp1Xn
5525	payment	1726	1726	1874	1	1	350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5JzuMHLSR5RRX8azVJEERUvKqA2mYdKsGRDTX9TKYjv9o4Yf
5526	payment	1726	1726	1885	1	1	351	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZor5iNscsZ7TWtKjpL3fC3nm6FA4vzr5S9hVdT9wpU5pcNVYfM
5527	payment	1397	1397	1678	1	1	4488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rvTrfkKAxVDJQCx39A6kXTu88grdzGTEDkzsYdbWy7gZfgAt
5528	payment	1726	1726	1874	1	1	352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHMa2zJX6cSjdqpB5WKBpZ4Kvdoxj9CwuXvpX58jjyw3mYyVy
5529	payment	1726	1726	1874	1	1	353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhqGbQbb3iyAfACza1FfveHpnQsKYN7LGs3T2nBJuwhC7AFaH
5530	payment	1726	1726	1874	1	1	354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZtSG93tLHfbdSPHxyD3c18nYzz8maMdMbAsdsvmYcvp29EnA
5535	payment	1397	1397	1678	1	1	4491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A99iJMwpFvGEbiBT5iE8siqEzfACuShBdYNZ8VZFiSngFGkA
5543	payment	1726	1726	1874	1	1	361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUK1ZZaop6VPhN4ezrLvHK8RHda6tZETer8PDWdKXbU8j4iMG
5544	payment	1397	1397	1678	1	1	4495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuzbtAeqHDwNJWwKuRLYYJCmYKcGfVdALyevmfCMNFjRwxeqz
5402	payment	1726	1726	1874	1	1	288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwULUh5WEWYjw3bhcYhPEvUzCwC4WQFTkZ4YGVR6RPdmMLdvu
5403	payment	1397	1397	1678	1	1	4427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNNAx477swVx77vtNwKq4BHrZSYww5BYcG1vPqNMg2BBPveMj
5414	payment	1726	1726	1874	1	1	294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnoK9LbLxoFHCJ5PYup7PcWPggQdgo9fHrH6voJoaeHf5BdE1
5415	payment	1397	1397	1678	1	1	4433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBurGKU12V6EHWBPopg9Nqdjfmw9eWgGc8Ebc4h6XLjYUoDDy
5416	payment	1397	1397	1678	1	1	4434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRTDCk4LZNLCvA5oFcF7koPaveQfk1Qp5uBxyM6aySeoctHyh
5417	payment	1726	1726	1874	1	1	295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUk4cskKDmSZz2gdGBQoAnMTaW68dGL982Gnet6UTZJuTULfef
5422	payment	1397	1397	1678	1	1	4437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDTw38cy3TWfbfZ9oDtAtop1a4B6tUvVdFzAxEReoLRST5g4j
5423	payment	1726	1726	1874	1	1	298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJL4CuzY3G6PSVKhEJ5dWpVZt95JVgaPrGCsWB31J7XKfTa5R
5424	payment	1726	1726	1874	1	1	299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbQqULGQmcLp48NfX6xUXfAf6a2fA9i4qgDyLWevYtiiyDLgT
5425	payment	1397	1397	1678	1	1	4438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJNKKMmVBhF2drzHWUvvxzmE87AQHKQf2JUEQoFhrRFtmLmLb
5426	payment	1726	1726	1874	1	1	300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3SND1Uh1rReBtDg2A3sGLawpwXRjSHS3ujGs9o5i7D1jhRWH
5427	payment	1397	1397	1678	1	1	4439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXB9D7udZkUrFNpKAX8Zsb4CdsWZP6wEtb2EkpsiwBDjcP9Wq
5434	payment	1726	1726	1874	1	1	304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtnwncGwcaGAck9z8jmhuyvutbYz3JH1cvUFAK5BAq39GEJQM
5435	payment	1397	1397	1678	1	1	4443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCsaXJ8dmD6Rx1mWStbpnnV3GgaPV7oHfY5kZDrjkh9dJYvJC
5448	payment	1397	1397	1678	1	1	4450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaYZ9des8tVAJyKThQZFcPrz56wvoZWypyBxmzCJToxKGtH8a
5449	payment	1726	1726	1874	1	1	311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaVLKTCDNUGA65gQV1Zc4imcL8m5UVfBD77EDYag8Mi2rmjc8
5483	payment	1726	1726	1883	1	1	330	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwAucQoArV1zaZY3kXnS1CjzauHLBv9JjrHuoMpTG3x1rbN4W2
5484	payment	1397	1397	1678	1	1	4466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiucqDZBXExFafViGReRBaLZZRdEgydRicp456uKjgzH3CciT5
5485	payment	1726	1726	1874	1	1	331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dw2ZMwdDJi9J8WrhRaxMFA4cfmr8rGFG4y7PrVehYVdPWusp
5486	payment	1397	1397	1678	1	1	4467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkdXkjUrxvpEWZtAP6sCQKk8Dgxb1MV7MFv34AvBZGXSG9yaA
5499	payment	1726	1726	1874	1	1	338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMnh3t7DaQcM1HfCx22FgebBKPM9zKwYErtzvbYkfAcafjdJK
5500	payment	1397	1397	1678	1	1	4474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwiPMDjko62Qz5f3ZDppBBvxy2dDKkePNZQVDBA3tEbwJV8yf
5509	payment	1397	1397	1678	1	1	4479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEp66rKm4RdYxepT1Wswv5kt5xGoXT1Xh9iK2XhGyz4HYq8ct6
5510	payment	1397	1397	1678	1	1	4480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuncpJEjma2ixU2n7FS5k28dy3dsP3ZCVMqH7KdVafnoh3Win6
5511	payment	1726	1726	1874	1	1	343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hewz3kW2GvYgwgxr7Kb5uwmKy1YfaDcYP3dBs9Nziw54GigQ
5512	payment	1726	1726	1874	1	1	344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidGKVADc93J7T5RueEyMAvTcVBvdYiHAREdXiS3P3Ju1EtBid
5533	payment	1726	1726	1874	1	1	356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Dcr3tW5xteL6CmMEhsmR8eqaoaiEFNPdxjTkmBKodENKfmdH
5534	payment	1397	1397	1678	1	1	4490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2dNwixTm33fECd7bwRdMfrFyc3N2LGJE93yUVNHnULgtsGw3
5541	payment	1397	1397	1678	1	1	4494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Mpuef2k63NUAUWxjEh1HXYk39tij87SmQeVMjGQKH4CBcEXt
5542	payment	1726	1726	1874	1	1	360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxkfpJwLso4tgw4vny6d6zjuNYi6PFxWtNo6hdr1J5SdC58Ua
5566	payment	1726	1726	1874	1	1	374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22YGUruWkJCUQgL7GWELxmro3a4bCEpg1wJnfgh7FHeppGU4d
5567	payment	1397	1397	1678	1	1	4505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64UWTaGfZXxGQJ9UHHoeR7NzXfPjJJX45jjKhH4xxonyHEVgq
5570	payment	1397	1397	1678	1	1	4507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXts1nn1Th5yKHPmUWMB6NqHAe7xts8t4DGivrHCWsGq2YiLi
5571	payment	1726	1726	1874	1	1	376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfPQUinpxrajW1J7N1x9XVkUsRFyeXLG5EdKf9CrULPzH57v4
5572	payment	1726	1726	1874	1	1	377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxGhh8ca2icdZdyajhGYCrDdfXiHL6GyxUDSAhJK1v9ipfT6a
5573	payment	1726	1726	1874	1	1	378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZin14m1vuBi6Bk4sUgekeBVT9roQ1qwTr2fKDVH697PDz2da18
5574	payment	1726	1726	1874	1	1	379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujthhBEt4ukHqfdh6cW9CLXkLEt6qZEN4E1Ssp9jxLBjHjsPM
5575	payment	1397	1397	1678	1	1	4508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdLgdt8gSegSo45AtKNKrXER9sbwLjag83M5V1dkMxCkZ2XjD
5440	payment	1397	1397	1678	1	1	4446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiW4njVRZQTou35VMJimBNjJvDkWNiLUSa5tw22n2E9YQocDqK
5441	payment	1726	1726	1874	1	1	307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvVwyZSVdBL1aHTkqsRvdbBnPs6hCMfFd92GD1ftFTL3oHjKK
5442	payment	1397	1397	1678	1	1	4447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe44CB4FURV84yRQxend2q928j2JvoSb5szT5b22fyTmQpzs1D
5443	payment	1726	1726	1874	1	1	308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLMG6xuuq1GNXey2XwCT7iZjsQYYbxQerTUKyc7dyDhFEXk2N
5450	payment	1726	1726	1874	1	1	312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEK77R5Hw3bHygzw9qGURaVkGA7KPa8RuhFY4yYMAbRPuPk32
5451	payment	1397	1397	1678	1	1	4451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dKaYaMHTmFGrLNJUx8oKqiZKHziFirGiXdVN7pf3sCxUFqzu
5456	payment	1397	1397	1678	1	1	4454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yHnvTgAgLrwb5T65SZcFkrgNzksRUB54FkRRdiAb4ocazJZ5
5457	payment	1726	1726	1874	1	1	315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLWJGoHeeMrnBVrg7x4rZ2Uwt3K8Rt7JWagFk8QamsPgUC1ty
5458	payment	1726	1726	1874	1	1	316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyu2y9ytWidatFfT1sEbzPuJovV2KCpmsDjo4RrpSrWj412msC
5459	payment	1397	1397	1678	1	1	4455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEg1mJ1Wehg2ZcZRoKPgJRW54Bi52hMXmWmqoMUNXuxU5tTTSB
5464	payment	1726	1726	1874	1	1	319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo78orCmvoapewBhq2wqyecyJynLbMdzwXcTiaJdEHaP5KDqAJ
5465	payment	1397	1397	1678	1	1	4458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BSiNoqgwvTqqipg6LpTFewPvPQJVLqUgQg2Uqh3MxdCWox6E
5466	payment	1397	1397	1678	1	1	4459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVYzyyL2XdAxW9B4g29NWY3nbLbu2ffeDUz51XktUu5ibHVZM
5467	payment	1726	1726	1874	1	1	320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfWPn4MyuQHAWVYcWcxc5TtUFGuF61NCN4qZuTVmLQ9xRiEkh
5491	payment	1726	1726	1874	1	1	334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9FgMTLke94Gdc9BeXhATHG6DjR5FpFJXfoiCVdqb8HPeuLzC
5492	payment	1397	1397	1678	1	1	4470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFW62kA1DoPZwip5Pvccb9qNyjPFf6t4Q6qCkNidtwxqhgsDTs
5493	payment	1726	1726	1874	1	1	335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHYZZLKv6v79TXsT86aERyCKARQdbuBgnKEeRafLDtahr4yDV
5494	payment	1397	1397	1678	1	1	4471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdSpe8TaiDbLDFyyvJPrVTH3bz5qoaXaM9vvzwMUfk1HiBKN9A
5501	payment	1726	1726	1874	1	1	339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtmjFVZew7JZbbfe7AhY15YtwHbidxm8AAysmmF63D5QgWBB2
5502	payment	1397	1397	1678	1	1	4475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8a3Dvs18U87J7WRE7zpTbjHjQRzQUphShP8GtuQ8fGYYgDALJ
5507	payment	1397	1397	1678	1	1	4478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3tVoAAvmtNQB286noKw4L3xpG6veP5EYWeGap2cXnUYNDCF5
5508	payment	1726	1726	1874	1	1	342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DbWxszYm7s24xLaPnP8vouV3J9JZttV3hfxoCCu1KjSCcFz4
5515	payment	1397	1397	1678	1	1	4482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtffvXtvDXUkpjGN6Kq3RTmESJcUAkhi6wkVNVr9V9pE2gQy3W
5516	payment	1397	1397	1678	1	1	4483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG45idzrPnvxSLVfeJSY2SWk15BygqMQWMqzyrNdZ9fob8JEt
5517	payment	1726	1726	1874	1	1	346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4ezVF2GBicQzvj22E1otLw1ngNipPXvvJjxxDGh3x3MqMxMz
5518	payment	1726	1726	1874	1	1	347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjGJHkbJmCCR8wUDiQCUoPg4YUQZmZnzAiZyjyNAEJoTFqtxs
5531	payment	1726	1726	1874	1	1	355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWGYSfu9t2xfve8wGBREzgmzA8i1ooFnGd9EZ5WP3dreas9ip
5532	payment	1397	1397	1678	1	1	4489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQSbvwCex1aMBrBWCrw6VQoAPRzaRYvxpXYWo1swHZy2jTzRq
5536	payment	1726	1726	1874	1	1	357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUyDkd9NSQXb5BbnkZ7KsXDycyAxcA21oNi4vLMmwHUDPRSdU
5537	payment	1726	1726	1874	1	1	358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoRNt1iPrnAYLsq6awczxEFcP56ii5uefK6dieXmJjWc7ExFy
5538	payment	1397	1397	1678	1	1	4492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZUXCCGEyrUxpC7jpXcKmHya7fhKJ9ZeSTKPPLhmNEYmqMoK4
5539	payment	1397	1397	1678	1	1	4493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rN371upUTAYGs6GJhDBWD4mLz6EhvMbPHrBs7gGA5szitcZ7
5540	payment	1726	1726	1874	1	1	359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5a55ZNgmsJSi1QFXN4SfXzL3oRAdFGS8e4sd72BXjj2mrNNj
5549	payment	1726	1726	1874	1	1	365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxrNr41YWJn6arhzpsPqALqygsaMSfJWB3A9igH7yxUw8rXSZ
5550	payment	1726	1726	1874	1	1	366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2jzdKVPp2VftDZsaANsnVXk78RCe93nyPE1s1Si5pDfA6hPu
5551	payment	1397	1397	1678	1	1	4497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnrPkh1P6TzNf428mH5FZ6RsqXVcFwK7Y98WjXPNWVb2UNKh2
5552	payment	1397	1397	1678	1	1	4498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLtFQeWSWPUjCmzDrYUU51vZofZSSYWaJ92DwHATEAgtDfLnR
5558	payment	1397	1397	1678	1	1	4501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovEubtL7QVN2Pe3NPwF9v6gs8x73Sy9DYiZjN26GofsCrKBM3
5497	payment	1726	1726	1874	1	1	337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2d9voGi5UgFRke4vT7PvY5srHSD3Hws7RZarAfeUyDGhCiE2w
5498	payment	1397	1397	1678	1	1	4473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P1fBftZVgiU4uJ78uA1Wrzn1hr5FmJZMjDCb4qMjtNYyHtpt
5505	payment	1726	1726	1874	1	1	341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatV9PwcSfFWobZnTGTq8WoyskKbp5cRn8qn13xdP7qiCGZJEg
5506	payment	1397	1397	1678	1	1	4477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqutzjt7FNzf2NeNfqcLkxM5K3Kma2S9vcB6xbihFaAWsHCVYA
5521	payment	1726	1726	1874	1	1	349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtQ3vw6pr2pcJMzUNU125eVj7s2rHYHU3JVjFqwR2Ppsj1Piu
5522	payment	1397	1397	1678	1	1	4485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BQqxYajt9xpYXinXH5GoGYt6jTzmfN4xsxNVXeX4JnfXTGFi
5523	payment	1397	1397	1678	1	1	4486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETZQBTh3bMG1LyG9i9HFF2Rt7eZo7Bj7eMhfrJLbz4jtRGnxi
5524	payment	1397	1397	1678	1	1	4487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDAEZAGEuf3quaQAbUJUiim1jyVCKhQRy2RpdjwJyv93tbJDQ
5545	payment	1726	1726	1874	1	1	362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzwkL7va1XkuD4SaT4eSAw7uKJY9mCME4EEZj87cM7fcHTkTG
5546	payment	1726	1726	1886	1	1	363	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJJyXGRDLqqGfw21WdkWBneBWZqgsLj3tfaHJpK6rgqykgZ1MQ
5547	payment	1726	1726	1887	1	1	364	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYo6uTF39xGAAeK2qWNNJq13KsDNXuHkWukRnzNr8vS9wKfDxkb
5548	payment	1397	1397	1678	1	1	4496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHndJN1Nm8BvyKioPTTxCjntJQoQjTiMm3haiunKJEcES8gKt
5556	payment	1397	1397	1678	1	1	4500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMvZZBWr2uHFyx7m2nPr2vkyMkEKvKYEujEqL6MwAjzsMUria
5557	payment	1726	1726	1874	1	1	369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdewHfdgXFSiiUd9k2DWzgzwExhqdhJeezturbiP5JCC6cifD
5560	payment	1397	1397	1678	1	1	4502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZexU3GxUDkdfVw62cfqxGaBN4EJ1h1WjZPQB8pBwi8hiezJwk
5561	payment	1397	1397	1678	1	1	4503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDsG9H2tfkxfUbSefm23ZKRH1tB6ym3jdvRkTvqYT3SezY1Hf
5562	payment	1397	1397	1678	1	1	4504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBfp4hAnNagtJRtWgA3TcDkM3H6iz89yYRDhPebNfRB838bnV
5563	payment	1726	1726	1874	1	1	371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiUMZYMo8bzC3TubF8AAgDfwwMo6Uf53MMP5bzKi5nEZZQzAd
5564	payment	1726	1726	1874	1	1	372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Mor1fNhcS7XCh4fww4a7fxm9T3UnFTnM8iVcXVcBcfRgsTqk
5565	payment	1726	1726	1874	1	1	373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPH9rC7cUCgPZ93oJxwCdHBFpHgmKzQWyyFyU4ZCAPxhUNJSK
5578	payment	1726	1726	1874	1	1	380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoBauHEK5QYhjE5mbPe7EhmwnfuL5pUW8ZNd1Guu6TYYaaMYM
5579	payment	1397	1397	1678	1	1	4511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QuCcYYSfHbWouvXrs6LpNY3xk9JWvqov9wMFt1ruVA1g9pEr
5592	payment	1726	1726	1874	1	1	387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCQN1Nxr1n1fQ2C2a4eqk98QARgXymHpKvC1Mi5dKBwu6yGY5
5593	payment	1726	1726	1874	1	1	388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyC6a3cdG8hap5vmMLgkMUV8KDekiUy46vYmWgS8XXxgQ7cTH
5594	payment	1726	1726	1874	1	1	389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2uveEPEtuUXpRrYYz7cWjkZvQVXiEE8tHg9LyJDBm44MKHuF
5595	payment	1397	1397	1678	1	1	4518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRtogum6A8gdGYa3GBPtaL7jQKU7LNFTR9jxEbHwyb9Cj7hop
5596	payment	1397	1397	1678	1	1	4519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgEF9uT9rFVYmUnyPhcaj42s3J3XTmrKt9rHTuv6xwXHXzzFH
5597	payment	1397	1397	1678	1	1	4520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GUsUU9ULicVKncfLctRmyuYn9KWKhmh9jqLnwyj3T4XYgpRd
5600	payment	1397	1397	1678	1	1	4522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiasSLKjgrjQWgfnF84yraEojnBKtYoRTwdUXF4YEz7ubG6ZYR
5602	payment	1726	1726	1874	1	1	392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwEYKHYdZMpzfMk1DzncVu4EZGyGqpmT8guj6FdoQMZQHbDuZ
5603	payment	1726	1726	1874	1	1	393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NC5F2Hkxs1GKHkJB1ccatToam39iHPeUNa5ygPPQfcDVVDCy
5604	payment	1397	1397	1678	1	1	4523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGsp6HLENiZubXERJ9CLqkPSMdM6ed1iH8BrR5JTn5mvujcXv
5605	payment	1397	1397	1678	1	1	4524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktbA557rGvoBoZit2ty2uzuZK6rZS9j3oEDP6Q8xozdeLeGyP
5606	payment	1885	1885	1889	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFqBnkuF4YgfB7DY36tBwZEVWA1x8PBw5xaJ5KFdVkqhuThYe
5607	payment	1726	1726	1874	1	1	394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZLzZgJfiKHuDUG7bft67TAuSu5H1cyfUtuqneU5ztG74ZXvE
5608	payment	1726	1726	1874	1	1	395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGYwFWhRk5JLsgTVuh2JHovFuFwzhMh1nXzaDavzbHx7d5EYU
5609	payment	1726	1726	1874	1	1	396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMrqxRkwDXo5y7P9BwH4cqjpGeztoDZKhFvDiBZ5bcKqubs1Q
5610	payment	1726	1726	1874	1	1	397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoR1thRvwBLPhmMUB3nWwTuvShJLAG4XYnXx7HPNZLs8SoiVZ
5553	payment	1397	1397	1678	1	1	4499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yhwrSrcwTrs3cQP3AvX3mdHBJ3AFGbcJ9ch4aVDSCZk2pSnJ
5554	payment	1726	1726	1874	1	1	367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tMwZoCxYNwW7ZJpzHAZD5vazvcLGhPSK3Jr5cBjTdcmoLNQb
5555	payment	1726	1726	1888	1	1	368	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpDqRm9LVAX6BwDcFuj414RGGxkwtFzbUPyx2dHLzL9fzj3oW8
5584	payment	1397	1397	1678	1	1	4514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFiFA4ehWBEEFxBUJdFnLJzedxfUh6bHL5ftatXSLh3HW8v7A
5585	payment	1397	1397	1678	1	1	4515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkW5UFJ8Rbk6GhLdkKigFQVnVcYfQ6fjfzaJQ5vQwRuoUh1r1
5586	payment	1726	1726	1874	1	1	383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJZuPc9xQaVxt5kQEQoytoSD3pBp9H4meVeQn3jx3LqZ7e41Z
5587	payment	1726	1726	1874	1	1	384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQn1gApKYFJRrJaEnVUrR8NQGsByJ2Po2zqeCJBkWEhTgY9Ck
5588	payment	1397	1397	1678	1	1	4516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5Ziz2merMGTA5ry9Z1DzQFeLEttrUBaD2JUnsKQAd2Xt3Mte
5589	payment	1726	1726	1874	1	1	385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLqjRQ3L5HRtrku81LfF712anETqjZfSEnkAWkAaiVKZx7Lvb
5619	payment	1397	1397	1678	1	1	4531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYswENUXZPvLkzi9MtTCnPUwe3HueTNQznX4ggVAAv4Mk1PVd
5620	payment	1397	1397	1678	1	1	4532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXmW5sF3smHp1BdrM15Pe9oYShhUySHX98trWgqq4guGuhKqn
5621	payment	1726	1726	1874	1	1	400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJNqun5qKAwo82bVqGft1gywm7r6SGAetksgy3UcD5yR1qa1z
5622	payment	1726	1726	1874	1	1	401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGihmuVdYpqHuoa3xy1TqkuuERUpY4xPsv8TzhtpgCujw1vhGd
5559	payment	1726	1726	1874	1	1	370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LjKbePzym7J6TbTrFEPWgbuKy8CASC2KfBxNP88M12KT6fhD
5568	payment	1726	1726	1874	1	1	375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxeehDreQKkkHUEQN2UuXFZevs3CqLgcsH9wVrtyBJAtYw7vE
5569	payment	1397	1397	1678	1	1	4506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjE3ia2ypHgcC8cMMyygZy2meGzfvLyHLb1qz18SUJXP9GtkCw
5582	payment	1726	1726	1874	1	1	382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wM8fVFvhceRFKXED5rgsTasiJW1QntuP3mEfPdPWT7ahduCJ
5583	payment	1397	1397	1678	1	1	4513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZcffufGxLHHbuYjFHW9JNtHmc9tA5i8YcqfcEaCbb7zMtZwt
5590	payment	1397	1397	1678	1	1	4517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyK513dC4gZoatZGmK3UmKg54dzJjKM4SNpnC5dHhdYkpZ86m
5591	payment	1726	1726	1874	1	1	386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKc8GRVP4m22jJvgSrWgji9PodZqFRfQV7RaE7y7Pm3Q9i2End
5599	payment	1726	1726	1874	1	1	390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6btftJVcQzoQSZZwXntTGD6cD5oTNxDzai4Twrctf3drFkCp
5601	payment	1726	1726	1874	1	1	391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAUTk5nwYy2dfq7JJEDCmruC8jreBpznSYs2nHT4k8cQcdfqH
5615	payment	1397	1397	1678	1	1	4529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi4MGBRN8teUm8h8AgHMiBGYPxyN2bECASuYo2mfoFDMqEkDg
5616	payment	1726	1726	1874	1	1	398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkkJCY6oYHshBDRVu7jBRgWg5cGFBzjBrqkWY14LyyE25SARq
5617	payment	1397	1397	1678	1	1	4530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKLE38R1RHjGkcfPSq7pgrmeYtsu8dGkZLFYnCyeJUkTZKz98
5618	payment	1726	1726	1874	1	1	399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CaCCmqYB6az9SwpeUzeMQaWuodFMQQizxGTRcUFbwMoW1gYw
5576	payment	1397	1397	1678	1	1	4509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBscveWi7M9Pm5RJEMakAjYWPr885sLSof2d8KjSmepbGmJox
5577	payment	1397	1397	1678	1	1	4510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PhrrG3qpooGrvFi9DiFNG71Bh3oNXnTDmz94TsGGDJD1d6QR
5580	payment	1397	1397	1678	1	1	4512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkvHqg1NMVxxbmzeFu61t83rCQ6nPXLTs4c1k5JHbGXrZLvsB
5581	payment	1726	1726	1874	1	1	381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseYB1Rqy1UQejxK9Bek3WdQXQV47VjynhsqKfkWvjaArojv9c
5598	payment	1397	1397	1678	1	1	4521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS9gKhxrLXsbJzdKhwMWJz5FnY7bzPfLNhjYe4ma9C1EwTeqM
5611	payment	1397	1397	1678	1	1	4525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGNNBGWhr4QUJmGsxhzPP7drcQRX9JjigJ7qFTYv94WKdnmLZ
5612	payment	1397	1397	1678	1	1	4526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5k7eUUJUYeW843XoKw6eMz1Rwp5LAij4TQ7SsQMUgoSf4JdF
5613	payment	1397	1397	1678	1	1	4527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLFNDQHomuQn6FFRKhrFWyjnMAAUqwGJq9ShVXE4heLhUqe9K
5614	payment	1397	1397	1678	1	1	4528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkzYrLH1UekRayUDxKKoZw2Ww5tF31JhfYWmay3WZtbFxfqVp
5623	payment	1397	1397	1678	1	1	4533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h8Sf1dJNhtSVxjsjjxRejLLxgM3sX5zxFnarYoEgzEkeiDSk
5624	payment	1726	1726	1874	1	1	402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfpE4jMPUwNexS1ANEQCwn14t6eJHQToe2xm6z8M4MtwfM5SZ
5625	payment	1397	1397	1678	1	1	4534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmouhdZw1MPVu5kuSHwRRVN5s9auZJRZEZz1r9BR6GVV1nvXd
5626	payment	1397	1397	1678	1	1	4535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjVE5pYRoWdpPJhQ9HtCYoidwAWSJw7FSLRX33faxcWv2pB91
5627	payment	1726	1726	1874	1	1	403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEmsHcgfqHSuWUpZy8KMrmLLot93LTDJkmdodL3QPWjZFwRAtJ
5628	payment	1726	1726	1890	1	1	404	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZR5j2QBsSYs8a4YkVkbe2qKVss8hocCFxRissBXuSgm7XxB4c4
5629	payment	1726	1726	1874	1	1	405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsCtpmByiMqkTw9u64DRFWupis82k5qK5rxghwCkDj3CjbkGc
5630	payment	1726	1726	1874	1	1	406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHFXwrVtD7Ja8W5rEWHant3zCUxYTBKvVSSp33oUKaSx21V3c
5631	payment	1397	1397	1678	1	1	4536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6fVttEeRiZKp6EGU4KnknYZSwwWbU71222gsNBsnHBiAyHcL
5632	payment	1726	1726	1874	1	1	407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYneTdp9aENJVGrHg4utSpQj1irBc2n7rTVFNoZKtDXkUuGN151
5633	payment	1726	1726	1874	1	1	408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo19DTLyXVUKmantcsp3MiPz7FB6SU31jw7ymAqis4ovJUmEb
5634	payment	1726	1726	1874	1	1	409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSYToXeymm6KBijthutqULRcJTc74x2F6LBcsDFVeBzNRRQvC
5635	payment	1397	1397	1678	1	1	4537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4WJLChmT993ByvbyFsfdKzQJHmNpsnEuV3GBwAfwxhu8ZoTh
5636	payment	1397	1397	1678	1	1	4538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBfpt9b7SWLetqGRaTTDVjZvkz51WvYFRFzgpjRiUsXnBAzLU
5637	payment	1397	1397	1678	1	1	4539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bUSxQAzsFTR4C9gXBZQNWNGgSQE3GEdS8YGfnLxzdQZFri8r
5638	payment	1397	1397	1678	1	1	4540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ah9q4UFMEb6ajmXVfYxaaX1UW9mseX5QgpXXYuEyne9fBXkp
5639	payment	1726	1726	1874	1	1	410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa26dXNEic5DWYACJ2PC7fwoZzHztSk2jCZ5fN1o62TJGYfHj
5640	payment	1397	1397	1678	1	1	4541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAbuodi1EzW5jKHwWCvxoZ6QjTE7N2XESbR5AfLfESn1ghriV
5641	payment	1726	1726	1874	1	1	411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadbwHWfSspb4f4ibhMdavrAga6s9Yh75iRcKXuheSrMteXfSW
5642	payment	1726	1726	1874	1	1	412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhC33yTrEQ4syaYdfCc7GBtW2JHPwWHngZiuaRwPNWM8MkPPwj
5643	payment	1397	1397	1678	1	1	4542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VHCff7eVQj4WCTEA2up8nf1ieR1JtqHpEJ8JdqLfHoJfEUDi
5644	payment	1397	1397	1678	1	1	4543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhAiZHUWbkAnX2aCRkTyfMfv145UJH4x973AFoyUaeHjktPSa
5645	payment	1397	1397	1678	1	1	4544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fikpGuzjfBuLMqeF4bTEtwdFioMgyHkpkPcqjTuE4H7bg68X
5646	delegation	1769	1769	1406	1	1	15	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dh84wvCM1LzoDLXLWLEAuCX96kBJrYiYJDqQ8KrufbHwDaXq
5647	payment	1726	1726	1874	1	1	413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4S6LdbfcQ4qHgYdkXM94Kre4AAXExCoQaJSjgv3192nGb9g1
5648	payment	1726	1726	1874	1	1	414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMFPtGKQ6BYTPstm1KjVpQ1MWPuQgoRrTCgg1BfKLi76diD5k
5649	payment	1397	1397	1678	1	1	4545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVqwiu9y6q96R5cwdN8aWuKY2DTYbABtYHBcWnsm7mA1ZDDTR
5650	payment	1726	1726	1874	1	1	415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fQ4GZ8FpVzjWEFUNVWwzA8z9dCCGWXmXGKP2E3MasZeVZt1G
5651	delegation	1769	1769	1407	1	1	16	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrdh6ftYNxvnopDZXgtq4Jh11m3KEhrcx3PCswruqHDdSY5fv
5652	payment	1397	1397	1678	1	1	4546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3LxHXEFbS8Qfov48R1ZS8kGSD7Zj2XGRQ4P1uexGEckRFEzQ
5653	payment	1726	1726	1874	1	1	416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDUPbfvNhswFcjUuTruGBZjVGXUsWXEggsLN1aZnErTcb5anK
5654	payment	1397	1397	1678	1	1	4547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4YBDgUQHkniqG8k8YaJV8Z1BZKBxKhNATTBYhPBcQKjorybJ
5655	payment	1726	1726	1874	1	1	417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvki9qsFKTtMyDV5AuE91QpXMjakTDEwZuxiYFqCgjSyqV7No
5656	payment	1397	1397	1678	1	1	4548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nRnz5TsENJfYic5BgW6bvHJDdLf72Nf6i5jWn7ycohXJZLzs
5657	payment	1726	1726	1874	1	1	418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVxq3hpAFKzXeTtypwqvYoZKivAAZ8BthTbPhgo56MYKBuy9i
5658	payment	1726	1726	1874	1	1	419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZGXmCYVDfdtzDRVXBBaY2e2g9s24Cxc4agckrBFTxRdNqN8J
5659	payment	1397	1397	1678	1	1	4549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzS7J8yY4RdmL8LwMpDEyf9SXWKQSEg19Tijjf2hxm7BkWhKC
5668	payment	1397	1397	1678	1	1	4554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxYYCmwu5zWjw3vpc2VXxzFfzPJUQwGRMzCMrpkTPu5RhDgho
5669	payment	1726	1726	1874	1	1	424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7a5mGdLgntkMmsCQJGpoYYWC6SeZDzZuMrx6QCrzadfMGLvF
5672	payment	1726	1726	1874	1	1	426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNuotoLTMbdxNv7sBjsAiV3CvazyeohRRvZ16TN61gbPvamLf
5673	payment	1397	1397	1678	1	1	4556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLv7PfJqUCgidSa6M9Vyz2NXYJAPawNLd82b3umZJHu1FxreE
5674	payment	1726	1726	1874	1	1	427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Rnwz8Ji47KpW6ow7Sdd3Lh2A3Nm78QBL3w7cdasnhiGWi1pm
5675	payment	1397	1397	1678	1	1	4557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWxsEXLpMKjr49CJQXMJkKz6ketL3brzD4RcSczdDuhnzoWMd
5690	payment	1726	1726	1874	1	1	435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE8YyBgxsbkGmBui2cVGAUQ1SkK8z5ECmn6nZXtCFDKGxQqRD
5691	payment	1397	1397	1678	1	1	4565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJXqcXuhTPTH2m4x3ffeffboMVReXjtmMFDVYLSkBhN2anH5B
5706	payment	1397	1397	1678	1	1	4573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaV4YtbWtz3LiDUtkfKbPTLGHsVe5ZRnmSAW7obNojpseitXxq
5707	payment	1726	1726	1874	1	1	443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hvHWdn8NLXYFLYhFK3H3vnTX19jLE71CPxVCcfz5YM7ukhCS
5714	payment	1726	1726	1874	1	1	447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYXS3HBNb3iaMqb1itG9vSg1ntDnXrxK9bjjJ7xqeJVFUWorW
5715	payment	1726	1726	1874	1	1	448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7LmQBSoMJTxGscFzux8RjNLWineguXCFvoi9cURFTZBnQkAG
5716	payment	1397	1397	1678	1	1	4577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYrJDykzNEkYvE1Ph4Y12aKeYYzWisegNhjam1gH6t851oCcZ
5717	payment	1397	1397	1678	1	1	4578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zs1GuHTrzRd15JX7yazco3E2aFa4Ya4FNbKsjCDKerUbYRzS
5741	payment	1726	1726	1874	1	1	461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHssor2JSsADpWtomSi5aRvDm7ZWU38YhFg7v1iLoo8yUTs7fP
5742	payment	1397	1397	1678	1	1	4590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYDgRqQG4PnK2odHFmu1PXdnqQQPiXTbLDoVZ4kJcoBqjKeGj
5757	payment	1397	1397	1678	1	1	4598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPuamcVkb3fjkutkBq7aYTQMQ8QeNe17UEvL4km6vVnBkioNB
5758	payment	1726	1726	1874	1	1	469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCEB2FrPrcHMCjVHJzXKVcGi14PXMSe69yWcwTcCgv3u82edj
5763	payment	1397	1397	1678	1	1	4601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8R6xzFzQdbECEFRMK1VXYeapQ9yqjHskqwseodrXMcpAu5fix
5764	payment	1397	1397	1678	1	1	4602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBfaZVqdV8CrJmfoLHo8i4xcvuthhcbzoVZLMck1NgynA3rRr
5765	payment	1726	1726	1874	1	1	472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tnueZhsMqAxMNX7kJSJ2ym852FKY2d5nLfksiGNEqqB4WgQ2
5766	payment	1726	1726	1874	1	1	473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTSzcu5UJkBVyQj6MCHhsm5XC5nw4rSA3wTFHbcMXHNr8f5Nk
5769	payment	1397	1397	1678	1	1	4604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqKXeYFLie8WmP1XGYuY5SMCxYHuydHK1jD69D2Yh228q8opn
5770	payment	1397	1397	1678	1	1	4605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPzTVb9X7F8UNHnVpkra8RPqwJyL1kxfyw4Etykt4vbuu1oj5
5771	payment	1726	1726	1874	1	1	475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEZxAQp2anCV19d1NGmGdAzUNurVkhi84nHXetaT9vnZtScnW
5772	payment	1726	1726	1874	1	1	476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbih7yGizvP9AaE6z9MNn1HY8GUMkbdwqhTpduuUuyGBAPqnf
5779	payment	1397	1397	1678	1	1	4609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxQK5ztTgKm2iB2n4FH4kET9LhgyGoH3NGJEQfKmm3pjUEwgd
5780	payment	1726	1726	1874	1	1	480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NWRyWb9i56hG5Qkh7hVP5jaf9hMfqegRpG2kaeu2SVCZPv5T
5796	payment	1397	1397	1678	1	1	4617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHsmkn7e3wnTUmE2gbmieuY7j7cLzjwRZ3F6Qobd8kEkA5vdL
5797	payment	1726	1726	1874	1	1	489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsYyT4pM4HghhYGPHEvq2Jt9XXNxU48GVHXHAbEo4mtwRgd17
5798	payment	1397	1397	1678	1	1	4618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkF6bpN1jwetycTHwfR1LP7uzyoxum8DDkryyces4TrH7BxyX
5799	payment	1726	1726	1874	1	1	490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzZrHvyehMGzTiaGaXrnsD6wiYoUfEbd4k7tAZH7tWiYngK4w
5802	payment	1397	1397	1678	1	1	4620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQei8Ruc4s5qKWLEx8vTwttTP2nE5ZQiKAPTnCMZXtG3GK4fUd
5803	payment	1397	1397	1678	1	1	4621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX34e2FAR6RzojJi2uyA48phB27ftSMTPmAUL1TEGUck2yk8m
5804	payment	1726	1726	1874	1	1	492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMqG87qCSaRdWjWfaxwyHxzPBdeFc2hqJ9qFAFRSLbACVpDPY
5660	payment	1726	1726	1874	1	1	420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsWc1CtPtZ6RQMV3KsFvuQ3VLTcwsRFnJUA4aGb8ZraWgjp6g
5661	payment	1726	1726	1874	1	1	421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MVtG9pvH26BMxUhVs6V3nTPUcXFj6NFyhdWRLSaj4Www2NKv
5662	payment	1397	1397	1678	1	1	4550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8JT7cPqW2hka2ri7bCxwV8oracwLEbfRJCoMNdejcAKCTemb
5663	payment	1397	1397	1678	1	1	4551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHBnUBQAZJdRp7s5d5ph7q3vjvANYeYfWmMb6AWMs2Kab3MQg
5670	payment	1726	1726	1874	1	1	425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6i4pfGiq2WM9JNTg6eRSw1mVp3LJBiVSH9rFxs3XrUmGTWNy
5671	payment	1397	1397	1678	1	1	4555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89wfF1pB5dtmkqbFibJFadpKAfwbk8K2jRPdSdTQTCVW3Xqds
5678	payment	1726	1726	1874	1	1	429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD9vFfASXqdM9XPnbuif2vhcP2s2rXdeid1uQ2eTDxPzGMymw
5679	payment	1397	1397	1678	1	1	4559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdbP8tgAHGGE63zrzDHGRRJrqXxrDsHTFS8eGpKDatgYPnEyw
5680	payment	1397	1397	1678	1	1	4560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3vFWNQnWr2FQgXJvZpu8k9tgsVQwD3253YYNUGuXH83hMEji
5712	payment	1726	1726	1874	1	1	446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8qBb5xpcLPpj7AFcS76FgUuqKoWRXjHhQYV2EnGerh2y63n4
5713	payment	1397	1397	1678	1	1	4576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTmBB7oADYs1EbmDwBF3sJDXQZnnvcUv3v5uA9ByjYrqTSMpg
5718	payment	1726	1726	1874	1	1	449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsgEbVvhHZpatNufhjjhPcAZN5QobHKfFpdcYhDPTfXMj8vcV
5719	payment	1726	1726	1891	1	1	450	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSjDxRN3LNhSofdtMjweJ3RRF5JMPMZuoXLHnBp3w9WsNMzov6
5720	payment	1397	1397	1678	1	1	4579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbg9VJo5Po6TqSNQBVe7miwjCGSZBncPNeHwnsthrFHr4cQV1e
5730	payment	1397	1397	1678	1	1	4584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCv2CDpsWcBv1yVuGAL2GJ5ozrFYdy6urc2hApSztxAscHKfR
5736	payment	1726	1726	1874	1	1	458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wYTeJ3Zy2V6qqC2twBFQSJSgGWM5vWiFs5w3izSPs63uMZTj
5745	payment	1397	1397	1678	1	1	4592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWY6HM2SzPp2faygXPw97eMFeTg6aM9J7ZNNe2KJY3RVhCZNP
5746	payment	1726	1726	1874	1	1	463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJY9FKiCnsJmCEpqLGvRbyFDbuTphGFRKdBiZ5gGen2op3LoH
5747	payment	1726	1726	1874	1	1	464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8zTfa3J3Yf4TBzjpakeG3gmCLjmzZED3oP5rDnKa1nqAmTPR
5748	payment	1397	1397	1678	1	1	4593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc87teVaVrm4qcdwsYCmAqgrHpZbWB2Ekwxt3Jz7zsGy585te
5749	payment	1397	1397	1678	1	1	4594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMcWVERkg6MxetC6sgq1DpQ1sdc9QREJoUYK6fzN39vTBMhG3
5750	payment	1397	1397	1678	1	1	4595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyrSBjXUVXRWJbz1xnagT4vFrXZcKwBj7Pe2mFPWx5Qni6BJ4
5751	payment	1397	1397	1678	1	1	4596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyRTCGKFRFdiUWwUKr9oMciTHA3PU1g85BFbsYGYGc75xWaap
5752	payment	1726	1726	1874	1	1	465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8xbYYppVUhe8bh5KquWdRZoJU2cyqw4f88APFQfbkik3DM3V
5753	payment	1726	1726	1874	1	1	466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcRHA94yMZGScdeoJQgjApun6fJWTUh4pkyqS1wUrVKkyfNHD
5754	payment	1726	1726	1874	1	1	467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH9BEcZsfZufqstbTcFjKM7DzNvBt3Mk8hD1kJv77AopqeSAP
5761	payment	1726	1726	1874	1	1	471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN6ERVDYrb1z6u8PZtqnGNJTMG6R2XDHhTtYMnS4DbzygNrVW
5762	payment	1397	1397	1678	1	1	4600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrAu8Nrv6osrWtiLr5VJtX4DhwNgijUgSwXAkKeohoKKL6t5h
5777	payment	1726	1726	1874	1	1	479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqWfANvKYJZiqzZH3zPyUWyhBKkdhaSh6DVQRJbsm2Y47FaZW
5778	payment	1397	1397	1678	1	1	4608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgUenm3UzGk6ZpE9gJbPtgkqmsx7ari1oDgZ8CJjniTJQueFg
5781	payment	1726	1726	1874	1	1	481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHu6bmcupdguZ8L2GQ2bRUdgCnXvQzHGTj5gtrPh8L4ZFJtZH
5782	payment	1397	1397	1678	1	1	4610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2gUben1fogr15VUX3Hz2jVQmMwgwN5yUWDzuXF1j2v9khMnr
5783	payment	1726	1726	1874	1	1	482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYY3eSUhiDMkNReDB4kqAAWSzYKGvnna5eTC2eJYvhdW4bL37H
5784	payment	1397	1397	1678	1	1	4611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5f3ZfjYfK1dkq7tjuUHaVGnJjxRnSbJ8Mex9v6gFkeWoMyA8
5794	payment	1397	1397	1678	1	1	4616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHWueCzzB8gDuYPDhoxfCuAZNKxJGSfDgkj5gCkUWcG6U2YvB
5795	payment	1726	1726	1874	1	1	488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLh1Ts5a2KemgoHTT8XkPLhmRWnXEbeCw4F6e7zKesMnAKRVva
5809	payment	1726	1726	1874	1	1	495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zX88S9reBPUdHsNS7EdxNRueVjV9bnGVtci8z9Xmsk1TZhWk
5810	payment	1397	1397	1678	1	1	4623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZjL2Px76TQB5mVr4ucgfNWs3aJXSRQJZEcDFUH3Jsz4KK8Uj
5664	payment	1397	1397	1678	1	1	4552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYmjTY3vb4pmcHsvAqusf6r3xiy19iCaBy9gtCfM4HrHtW2Lw
5665	payment	1726	1726	1874	1	1	422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYN2fkuarY7qLcuS4AHbeXgjKWUmnE7uFRJtXPxSc2uaWcJzX
5686	payment	1397	1397	1678	1	1	4563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4bKVSbaLpuJMp723AMS6WK3yRt3pfwLYGi7wsjtjf2MkeL5c
5687	payment	1397	1397	1678	1	1	4564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW6LSP5EeunTjF2tW7DBH62hEVgrUEToDLGTiUZfMu9Ws9MZST
5688	payment	1726	1726	1874	1	1	433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZQvBzyReU8gEJzYk9m29KuXp6LqLwvp5z31dFJC2G5o7JM64
5689	payment	1726	1726	1874	1	1	434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11mxH3wgCz8nuio3WAC6S2FPgaxXE8FEGhoTYPh6X8WAF1fxw
5694	payment	1726	1726	1874	1	1	437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAv5vsnN5Vbhg21t9kV3dXRW94prnS6Zb3R7bG5M4aK2Ch6Bq8
5695	payment	1397	1397	1678	1	1	4567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqtYsVrBtddMzSWQqwzCn6V9EComa1iBBxVZPNV83acakgvdH
5702	payment	1726	1726	1874	1	1	441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYHpyBg7SWPCafrh3CYbB99NC2a9ogEnsiT9XoxaSYuwZXGpo
5703	payment	1726	1726	1874	1	1	442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhijrayPCLkfi7GqaNCgJwM6NH7mwn1xhCmnQ4ua1i5ARm5PhR
5704	payment	1397	1397	1678	1	1	4571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGGiBZ9QtAdmtSniqM1wLoP4ULGNaHBamJjHb7VKt5KL8TbL5
5705	payment	1397	1397	1678	1	1	4572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk5SuX9Y7G5Pi1ccNJUkrX4mabUXHhMvmDKVZ3XBc9yA93Tho
5710	payment	1726	1726	1874	1	1	445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqnaWtZohyzGYa8L35hATW8DiWECj9s8Ue8p3uPDGehVBn1m7
5711	payment	1397	1397	1678	1	1	4575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnp96QwJaNdDWzXXz5f3LyTjpjZQUaeWoXLL9tJHcMAkmj37kX
5722	payment	1397	1397	1678	1	1	4581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZak3QjMUiRPghL8Gvgp9ZZ5WfW49hJKWqSsTdDJGoXqniUhtmn
5723	payment	1397	1397	1678	1	1	4582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqdfmkCQooix5SmKUTHsuJEFVGUD5PQLUJr5XZcJ9KraGE6jc
5724	payment	1397	1397	1678	1	1	4583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZuNoZr2gxsRbhCHc2iXEhYcA5yBtLN1maL2jgsrfLWGAtXdg
5729	payment	1726	1726	1874	1	1	455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6UEMNVSxudULuNsm7cTcNBuwPdoEHXredJxAzF1w9wvHM58V
5735	payment	1397	1397	1678	1	1	4587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyd2Swx3mjgVAmj4siJvYZKLDkxFXobpLAPMSMcctwX9PCHnUn
5743	payment	1397	1397	1678	1	1	4591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2zYivWHb7QLmjZziG2MS2WFfQLU4fiRu9yyvxqSYcP4mJhPD
5744	payment	1726	1726	1874	1	1	462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9ZeuZ5nBawDcLgWi4iDpPLR336uaMTEdZ4hdHWoZFxBvDyzE
5756	payment	1726	1726	1874	1	1	468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXsK3bbCfmxj54u285FBqHzjE2WDmvKsdi33R5vmnqecC8Tvn
5759	payment	1397	1397	1678	1	1	4599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSwXPnfJv6kMwXjczuzV68JHU8sEbNwbVVd2CkL5jbebTairp
5760	payment	1726	1726	1874	1	1	470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrMUXAX7oCqVmDKfB26B7o5pVxNExXexqbwSDA85Dwr7qhLD8
5767	payment	1726	1726	1874	1	1	474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCnZrb4uRTzHgwsidURHtmdHkE5D2onJwTJp25P6BTn4UdHGh
5768	payment	1397	1397	1678	1	1	4603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhegdCfAUBznQw9TxRHEzQg6hUwNiaEfoiE9h2xWkvPnJWfT1V
5775	payment	1397	1397	1678	1	1	4607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxGZeeJn8yxUr3bJSMsXsSvKLFXroy1SDNvVZCjsWj7NMvC7V
5776	payment	1726	1726	1874	1	1	478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPRSnt5kcM529xVwnmtPskZuZXUPmKGhHAQcGFdya9picapEn
5785	payment	1726	1726	1874	1	1	483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSfnziJffVnq22Ev593RfmutVrKZegJ9zbe7K2mQduj2tt5DG
5786	payment	1726	1726	1718	1	1	484	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYTrR46x84GAPD7TnFUdA1UrXwYJQHdXUDkM5cfaN28JT1MxGmn
5787	payment	1397	1397	1678	1	1	4612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1nV1xAEuvWE4F8UEFNLrX899eT4Zv2p6WWUhxsy72KErQiLs
5788	payment	1726	1726	1874	1	1	485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbeqZrnS5gn7MMxRwttZk74JZnyztMRnWCoGKrkVcL1qZGbDB
5789	payment	1397	1397	1678	1	1	4613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1QZ1SLgfRutM6iizxKiYvRsPKB9MGW6NhCWRWPVRMCNXyqEfP
5790	payment	1397	1397	1678	1	1	4614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33v2q9TQCNgkEjY7aSU73QvUhrhuEPYRdzrZ3vhzeUcazZiCX
5791	payment	1397	1397	1678	1	1	4615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfvfBayEJ7vGyjW4wXqGTyGJ3ZJQz3tTnsxck71mgDY4QvB3q
5792	payment	1726	1726	1874	1	1	486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1naXv7z9yZm8TU8uVF4b5nKcWrX3vnzPjBjiC5CvFwwXZyr1o
5793	payment	1726	1726	1874	1	1	487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMVHQTCiDsUYJCU4vEhhXUbDZ2KVCKmW3hHdLmjg6ZJYBRDsr
5800	payment	1726	1726	1874	1	1	491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3ZBtZLkU5fjtTNtK4pFqSA7guXbZ2i8LR2EJqvRnshwHNAzB
5666	payment	1397	1397	1678	1	1	4553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1UmMVtYHcJbBnZpfJrYtWtTf9aG27CugfxrDBzHWewTKNr23
5667	payment	1726	1726	1874	1	1	423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQT2uh56CUQwiwrj2oNGwcJDUcd85JL6XHHYxBz7xALBPSzqC
5676	payment	1397	1397	1678	1	1	4558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXBpjeJpEp6rutHJdVQSsQdbbTnJbic7ZRzTNPWVqqsrteFU9
5677	payment	1726	1726	1874	1	1	428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzV7b4UDdmn3Nc4YufetEBYaKdfdBHMZj8PshWHZXqKDUkQcxV
5681	payment	1726	1726	1874	1	1	430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHy8BWmK7uGSWPyjpg5MAv2qc7DQfLdueZTEj5EVZuUzPKvtu7
5682	payment	1726	1726	1874	1	1	431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV464WQ5v3WYg4ftXYqTtLp51rMLyrEvi4vjMkKFTZhH8ydqL6
5683	payment	1397	1397	1678	1	1	4561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVx56MiYbSgfofqQtDy3Fvc2naYeYyMrKkvMFXmLDCf8YPgPK
5684	payment	1726	1726	1874	1	1	432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbE3AiADWiBCAXCR8gZR6RDhy4GRqg8tdoLzysWanX9LoSBXHe
5685	payment	1397	1397	1678	1	1	4562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKo4P7jsGxjcjhnUgmUvuF6g2JPwLafHN9JMm9xa39Ddo2Ddm
5692	payment	1397	1397	1678	1	1	4566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAxv12SUyrsn8Nr1RJj4rYBCNbn5TPkG4XohnYfNcJGeHXcGu
5693	payment	1726	1726	1874	1	1	436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1G5cSDH3SK1cC2qQNycrFy3yr4MC5aRtxUM1bjXEhkWLbjyg
5696	payment	1726	1726	1874	1	1	438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxahqCPL8zyb8EjPnUyg4Nke7JjdgknAVWs85hDi9KvuWeD62
5697	payment	1726	1726	1874	1	1	439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iz8gkDLxLdUTYMchi9EiuEVtEQrWrbrV8buTmQn3VHGuf1KP
5698	payment	1397	1397	1678	1	1	4568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnggncAVrBUegCoQ2RwyW6e52qAeFunJAomRyTkStnXFUbLzU
5699	payment	1397	1397	1678	1	1	4569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPW8J1Qh6NDi2EBtvW8Sc4ujYPtuXe4mocmiYoha34Jw5AYJh
5700	payment	1726	1726	1874	1	1	440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4rcWnzM1ZjBvLJdkiEESHbgJnDKBSKxLE5Sb7W6rqZM89fdi
5701	payment	1397	1397	1678	1	1	4570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGxfiEUpW15F3avHUA5ZyRG9sD4ic38JfkoFwzQgiVSi5fSbL
5708	payment	1397	1397	1678	1	1	4574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJM3BH6bGGd5TmjvHnjrrp2CSJpu6a1ikE136rbcLpQssJSb2
5709	payment	1726	1726	1874	1	1	444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPzqo9Ygho3XTLxCiUokDPx5HAvQePNxbvSjnpJDcjTYKKmJn
5721	payment	1397	1397	1678	1	1	4580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3MyeNtMhfSJN3MQcV6SQBuZY23rjh8FtAnmeoEb2a1kdRo93
5725	payment	1726	1726	1874	1	1	451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMCTUhoEWhDNQ7thYTSHgTU77iYqHPNonVvx7mK5NJd3gHRy6
5726	payment	1726	1726	1874	1	1	452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tdHb4BcLsTiQkwfmx7u2HuDFCNmqJLKF8Rxv2jUyhzGsHbvA
5727	payment	1726	1726	1874	1	1	453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZax8SpKERsiityWpBb11b3UPuo8ByJNyBomrJdd71J6ruh7fzj
5728	payment	1726	1726	1874	1	1	454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoXCMsWGtaWuBboneYNNuv4WSnFquveRkHt3deGMLhGTR1i7u
5731	payment	1726	1726	1874	1	1	456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZRT725pc7ZEtcSeUXmPZuZpFdj9YBrX8Jg7sBEXfdPqG3SEg
5732	payment	1397	1397	1678	1	1	4585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Lb9qXRS2ojUAXQWzYUvkdmNMsdi4oqcDZwWqQAsuPrz3c27y
5733	payment	1726	1726	1874	1	1	457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSi8UdEtmgqstr89hT5HPz5WerjVp58vTsi9kaoNNWiiEDpVX9
5734	payment	1397	1397	1678	1	1	4586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfK14H6EcSNz3VAgLrRdPgaRBm3tcVCSgR7QsiCC72FQ8XAp6
5737	payment	1726	1726	1874	1	1	459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WodVrpqJvcAPJgmhBThr3A6qdGvGKjsgc1DEiHBPNkS3Ynf4
5738	payment	1397	1397	1678	1	1	4588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1i7wG81fZDAvRE2DGjUPxQGRaiGxPDKp3hmf7J4mtvoKHVYe
5739	payment	1397	1397	1678	1	1	4589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6qbuasdg9RStkSu5Qqe7yP148oetNJGDEmMZezHpbwQSMUG1
5740	payment	1726	1726	1874	1	1	460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAKvCVY54j4ccK27CKBkxovVbZ5TydyQo9i9xW9XCCFbLrXa7
5755	payment	1397	1397	1678	1	1	4597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7jWFdH7c6ogEw9A3cWhaUKV23uC5XrA2CTTYKDDynsxDyH9y
5773	payment	1726	1726	1874	1	1	477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC4fMqZN7pbVft2KSWbw3NrCYaTsCPyqhDkjF9oJ5HdypNabT
5774	payment	1397	1397	1678	1	1	4606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbBLAjytztbTHBr9xkCqWzrJsZ2MGoJSQCrkXmccn4Lx1f7Tb
5811	payment	1726	1726	1874	1	1	496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3K89URu4SuQJH9Qi9pSVqmrh2KNCMCNpz2yVpLTsrLZZ3ihFQ
5812	payment	1726	1726	1874	1	1	497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerKdE41HcS9zCfcfGNxaiq2ea5WbE3viaivi8M9dX94cQ1f3Z
5813	payment	1397	1397	1678	1	1	4624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVzXUbFhiXhZMPdcS8bu3uSiWD1TbrvWqpi7m53GpR8ZGUiNj
5801	payment	1397	1397	1678	1	1	4619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfjH4369Uv9ePV6EvLixr7k5qsXYQym5T51FScxs3AmebRhUs
5823	payment	1397	1397	1678	1	1	4630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrVsk38RyGzdvZR1PFxLL12azNbPy7dKuvd44duNHcKqboXka
5824	payment	1397	1397	1678	1	1	4631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDQu4BSpmSEAsiYEyQ9WuH7rk51LLJhy1BiTB6FXinToF1fBQ
5825	payment	1726	1726	1874	1	1	502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8hxMDP7FD39haddTHDLtewxciXZo8CD8a5NvB1UzNJwqL8Nr
5826	payment	1726	1726	1874	1	1	503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbNg4u53bVRLYNGgqyM35CsTkNo1cxR9xeTLYPEUZK7r4zGhi
5827	payment	1726	1726	1874	1	1	504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXtjE411rXNwHbZhK9rDRyr7DSuHgfenEoRDbKEYHUR9kDRJPa
5828	payment	1397	1397	1678	1	1	4632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC97u5RiPXz1TauL6FsErtDx6mDLt6K9yLgphDiUcR6Adtri4
5833	payment	1726	1726	1874	1	1	507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESRheBC3EJzF1ugw25e2ghjj1Scr7Khj9sNksQiqXfa3a7Gcv
5834	payment	1397	1397	1678	1	1	4635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVGkRCuqqKVwj8BvQzoSW5aLVX9WwYabSyzXmESnfN8Mxhm2X
5841	payment	1726	1726	1874	1	1	511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLHMdDH8Wba2S328Ea3hEugLKihETCouB3JfQC6MTFbN7EBge
5842	payment	1726	1726	1874	1	1	512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfhW9KiLefMmTGCjnkgvB9WSSgv7WDjYP65d2rJaYZUQohPKa
5843	payment	1397	1397	1678	1	1	4639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDRhdcoLAkCbEMENKxURgRjo2nuid4Xxsd6ybDmvqjbSxTj1U
5844	payment	1397	1397	1678	1	1	4640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWm9NB7tiTxKnvby2XwPVXwKiPWbrgNkXZ3Sa1KRQKXqyuFci
5849	payment	1397	1397	1678	1	1	4643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfziefM7UchwK591w6vaHCbDSEhqKzMFdCzooGHhxiHArMKfgT
5850	payment	1726	1726	1874	1	1	515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51KnEpGH3LGYrsdtmF2g3Rqh9ucZ4E74iprXSyX84zjwFNVDt
5851	payment	1726	1726	1874	1	1	516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTpukvoQJg9QbYsBT9TMgB3tB4DEp1HXamh6rCK7e7GCmPRZS
5852	payment	1397	1397	1678	1	1	4644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYMjCxWZRobzBoCbh1KX16WwTzrQDhcpJHeukBV1S68TDzhvQ
5857	payment	1397	1397	1678	1	1	4647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTawkXi8e7QvtvtViMYA5qbWxRsfkCCU3WBqdk5Qm3riK7MBm
5858	payment	1726	1726	1874	1	1	519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZtWtUbu8REfkobmLbS5nJL4C6xzaP9XXTg7GxRmrroUqW2NLY
5859	payment	1397	1397	1678	1	1	4648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5rNhY8228fDZKBGUzEs2TxPB1Sn9iQkauFXWnRiRzKcFqTyH
5860	payment	1726	1726	1874	1	1	520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrW2s9fc8ZEENbCDPnoTsKGzam9xQf8m8Y3gWf89PkkDmqszD
5866	payment	1726	1726	1874	1	1	524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZfduFvEny3exNrJNBaXndGbWembg8hGkVRxLuWwjupeZNHxG
5867	payment	1726	1726	1874	1	1	525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhVEXXGqxMWp7Ph6LcKoBdMgpuMULC8s1SFEyLcPPwKUfRuUS
5868	payment	1397	1397	1678	1	1	4651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwXNjsXETtXU2SXDnB56rdwuY3ZvHYbUwmPQ16GtvHpVrqSaQ
5869	payment	1397	1397	1678	1	1	4652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5g27Fk5FVuv2MJx3piutgAFATcXpcx8qb1udwmT7PGdmPaP4M
5872	payment	1397	1397	1678	1	1	4654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtvesu9mjT9r6szyj12AF6xx5EjuobbRTfRtDXaiJGjTYx8QN
5873	payment	1397	1397	1678	1	1	4655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgt1jJVSV6ZATVH1RM5T7DAmQo3zzK3bvfD5NMS1qrZBorvAhJ
5874	payment	1726	1726	1874	1	1	527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoMmcjZiv7Ymav8vdXbFnkHrphaVKd7DU3oKhASr4MmbVXZcV
5875	payment	1726	1726	1874	1	1	528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRScjiuiZuLv4CLxmArMvPiccX32TVL2dxfarGjci54pSCpdvR
5890	payment	1726	1726	1874	1	1	536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKuvtczZw3FcqSxpiz2mWNSiwjvLChMncV6KiG734LeVW9jAH
5891	payment	1397	1397	1678	1	1	4663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKtcnf7SFDKuLWrmh3BLvixmXdFrx45wBMgQuSzzrJuJMeu4U
5908	payment	1397	1397	1678	1	1	4671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCZqmsrjBjejo3H2AHqDRcPGNGnxPsmoZ2JhyMzH9YXKahDgA
5934	payment	1726	1726	1874	1	1	558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4ndJRWAMSW5e7AnizUmeus6ojN8h8hT4LoXazv5dnCtHHpUA
5935	payment	1397	1397	1678	1	1	4684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof7RaesJZEYs24YdURvNkVXazkCzGLJB5Xcx73EJhsFMsCZKM
5949	payment	1726	1726	1874	1	1	565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWeVHSaNHVr2ZF5FLWL3AYKA6dTNp177vUnNrWQApwvohsqrt
5971	payment	1397	1397	1678	1	1	4702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZMiDcM6iXN2CA38GTFmURfu6F8T9Q8sjZbbkthMqfVkRyK9T
5972	payment	1397	1397	1678	1	1	4703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKbdcLvoQ2fDYSynWw2pr2p54EpXkQdvENKnZBnjmLAdkyk9A
5973	payment	1726	1726	1874	1	1	577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptai5Yb31cXHUjhnA5scQ1vmz7ipJMwgRTTnutXhK7TpXf9tq
5805	payment	1726	1726	1874	1	1	493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUTZXARsj4p4fjYWaYxo4e7a5N6yomSatXxLqYhU3bg2oS8Fi
5806	payment	1644	1644	544	1	1	0	1439000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWS2kL98bB4hCe5yMLzDrbS5TT4UHawJtDQxZz37ai68pFJQb
5807	payment	1726	1726	1874	1	1	494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCJxq9AHzBp4qCGtK9pZu7G2Wh4K93HMPZR29WzF3crmu5hK8
5808	payment	1397	1397	1678	1	1	4622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5rUh2Ww2qyKvWJb7N5k7DttBBf8UbrQ2BM3TyMnnxNH5JRmR
5845	payment	1726	1726	1874	1	1	513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNX7kbi8kk2ouXWV6it34oWQxeZWjnqDdavcrb15pBSoHEeAz
5846	payment	1397	1397	1678	1	1	4641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPExeDHYNioKcE48eZ6MCnJykBV9ZPSr9KGvWBZTuraXdCQv6S
5853	payment	1397	1397	1678	1	1	4645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbH5GwfPxbYjkvUGo6XpMFvnhz4VS6e2jcbpmmCXqU9kBxCSNh
5854	payment	1726	1726	1874	1	1	517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM97TNM87HHoEgPHcsYKjMfFdRm8b1u6gsxipqyVtLSJAcreh
5880	payment	1397	1397	1678	1	1	4658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdw2MdUjSwcrB9LDQSx9DGrvHKS5qSZBGHoFGrLApAgzscEaS
5881	payment	1726	1726	1874	1	1	531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD9ytobNa5ByXqzG6UzY3tYpHTPUDVn8L7bK6FTcLbamUrtGp
5886	payment	1397	1397	1678	1	1	4661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2MWa7mz1sa5Tnijnd5y7CdbEB3sXKzS4Nz7DPnrPvpGAcbux
5887	payment	1726	1726	1874	1	1	534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJKs7oyAu3Aw6gL7dEbcdTRsAiGfo3BFf7xuKphpAQUkkvA1u
5902	payment	1726	1726	1874	1	1	542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMQ5jhxEgJoUausUeT4b94PdjursJjGbNa9Tah1yGZewm4f9x
5903	payment	1726	1726	1893	1	1	543	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZZRLPWbL2juD8P1G4Eym4Jt9oQtEQ5guPVG2t6J8AsEnk6PjV
5904	payment	1397	1397	1678	1	1	4669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2rzs1d91bU3gXobM9NUtedauuVRtj32UMmKpDsgv2AVS8fVT
5911	payment	1693	1693	327	1	1	346	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYoJEvCpgmgJnAGe7nuJkTYmRoijZ2U3cefepXQddygMMn6qGRP
5912	payment	1726	1726	1874	1	1	547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiFFMNsgNNUwhLE1ZzYxA4ecHZz3Q6v9AVHsft23CewyEogFX
5913	payment	1726	1726	1874	1	1	548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6LcRpTrPRsNMKZ9sXL9PsEcK8NrSHpP8FVuUYKHhokAf5DB9
5914	payment	1726	1726	1874	1	1	549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUBmGEX7hAiQhz18FRv1uNkpjZeM9Bq6ykstvPmohNCXq1U9U
5915	payment	1726	1726	1874	1	1	550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9LYuV57gQws69isYPF1fknqkgAi5LmDM9x2ftYgbfPT9RQXv
5916	payment	1726	1726	1874	1	1	551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5XUVgJaMRjbHo6SwbZNn5tKbm68dbcBRz9BWVmEKwBbYa8fe
5917	payment	1397	1397	1678	1	1	4673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTPX55BYN8DEtfJCxr1B4JiprnGGa8qKQFuih7C78GpWfaYpV
5918	payment	1397	1397	1678	1	1	4674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDSdjLAiKJmksaQcPuhiDEeUKg863ZCBNAerSxmAhWRtVgqQC
5919	payment	1397	1397	1678	1	1	4675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLeyNK9F81UcU7V7jvdyYBzEG1sexK7eQdLmEMYzhTaUwWHrL
5920	payment	1397	1397	1678	1	1	4676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdY6SB1KQGGjM3QZNir1r4ysvri2ecnGVUUJT9o2cev9wDFoGx
5921	payment	1397	1397	1678	1	1	4677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xvwLCbX26fu5YvoWKBqtMvXKCe1wNNK1uDFJoRpQk2W6Z7Po
5926	payment	1726	1726	1874	1	1	554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RECqXFHNmSuac853ZaPyzwdFnkGuTRKvBB5rPYQt5dMAm3FF
5927	payment	1726	1726	1874	1	1	555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4nuRLjtyBDaidF2g3BpXTpdhU3vswtQRHf1mkVYXkaWrrHZ8
5928	payment	1397	1397	1678	1	1	4680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM3ntQB547RzvW2BD6RJGCQCkkgXh9CMB4a3FqiEKcvkyc7YV
5929	payment	1397	1397	1678	1	1	4681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3P3PoTwmZWGbnjCUKK192GkfbqgdspWNCz1LinqGqjVtMoeHU
5938	payment	1397	1397	1678	1	1	4686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcNqRZQSGmVzef28Q9qJy4Z4dzNTfD2D5LD4NEUnDLyjsZHxn
5939	payment	1726	1726	1874	1	1	560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYmnkhcBLNUPzuRD1mT8qeE3PwfvJ3VUkHcYfhsRsmmoR2wN5
5944	payment	1726	1726	1874	1	1	563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SKeA5FJVeDmFT9VVUQC4JYArYzXiNzvTnH7vNzwzdpnFA32w
5961	payment	1397	1397	1678	1	1	4697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjh6njMBAvPDxGrjk4AAwnF8GoqM8hrusLUQgvG9STtrnPDA4X
5962	payment	1726	1726	1874	1	1	572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXkuGUQhfMNGfysv6AJvyUFuGraSLzD8wdPNzfPwQBC6WFbgz
5963	payment	1726	1726	1874	1	1	573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZ5DEUs3YnJxicvanxoRzgRbkTqZwRycGzt2bJT45GDwfCfeg
5964	payment	1726	1726	1874	1	1	574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMbZScJyJEczchZid9MLYdJbRD1QwAFcdun21tcZaoWkan2zn
5965	payment	1397	1397	1678	1	1	4698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwAAkEw1qMcrmHfzGeFA5dXkqLD5HVAkmCeZ73cJdegDcorWh
5814	payment	1397	1397	1678	1	1	4625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVwGQNDBJkrxaD4AY5dVYJoNJsxuXckNbERrvuiisd81QGB6Y
5819	payment	1397	1397	1678	1	1	4628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSy47QgqSE2m775FSK48KeEcx2cQU4uFcChTttq9CpbY2VwwG
5820	payment	1397	1397	1678	1	1	4629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSmTYx55hPJgd2fN79WhnJP9KhwXamGM5S5Utyoy7zLwrDwjv
5821	payment	1726	1726	1874	1	1	500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdSw5Gbah6MyuxC1uVRaTFn6B3ba7xUAY3tss2jAdJUhAA64r
5822	payment	1726	1726	1874	1	1	501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZSjYfnrsk9BnYV6GCc2xBJt4FtbF6JsBAnD92oXF2LEnayWv
5829	payment	1726	1726	1874	1	1	505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvmPC8dRTwwv3PHmmarNHhkeNTG2pvG97SLe7Q6M8PSrtwCa1
5830	payment	1397	1397	1678	1	1	4633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92Fci6GPVmwBB8c6PTHcg4kbTj9w1vieRc6RBhUmuVhQTD3AA
5831	payment	1397	1397	1678	1	1	4634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvBgXwUBRqgpp85gy8J5u5QNNbokrvuBFyAqWJDQ2kpNb6Wpn
5832	payment	1726	1726	1874	1	1	506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8H2GsQmmfByMyj1Ln4zL9yRFuFYfP3fwQyKENb4Xzt4zkgHu
5835	payment	1397	1397	1678	1	1	4636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN14RPKMTSWnFPfVs5hwBTDaWGH5BUaVBJ65MEctBD9cVwSiuc
5836	payment	1397	1397	1678	1	1	4637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYju9QKPYMNeHCiadD7rGAfrmLHXKt9whBL664mCsje5YxWLTQf
5837	payment	1726	1726	1874	1	1	508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBkncbzAMQrbRYgV4NboNHXUBvKUpSwXqUWrcei1R1Fp9c5mY
5838	payment	1726	1726	1874	1	1	509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE4RM9q9UH8UxaoX3JkwMad7f4qbmYP7bitWQK23tvrHh4KZL
5839	payment	1397	1397	1678	1	1	4638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsayVkta1uLBY5PFW9FioL2hXVSMoRhVNJEDGMSS9Y9Dc4Jy68
5840	payment	1726	1726	1874	1	1	510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfE6okgQxtj5FqHaaitv2c2bLDMb5XEfFzubWkA3KioNCqEWty
5847	payment	1397	1397	1678	1	1	4642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWtycwiari81TyKnuq6t4ARXZDNpcFBwrtbJcu3aBhbDxt48J
5848	payment	1726	1726	1874	1	1	514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJX28Yh4Xwv4x9oRnp9vc6KSiyuVRm4f5WGT6J2mNNKTu4EFmn
5855	payment	1726	1726	1874	1	1	518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWhWMnj5RNmDk9r4xiQAvp4NqMzJbvpQbN2bttzKDhJrJto5A
5856	payment	1397	1397	1678	1	1	4646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwdAVrVavN5uQ5MubBByAmLhfYmt9ZtGvY3Bg5YaE3GA6g2YW
5861	payment	1726	1726	1892	1	1	521	1200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLkYM5WaGUhuHv5WdZ81gs25LyivCrGATJRDx6aiwq4rwuwhs
5862	payment	1397	1397	1678	1	1	4649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ahw6s44BsWh5vRQR3s2qwxcAZX1ucBhRcPJzFo9WKGyuEyZn
5863	payment	1397	1397	1678	1	1	4650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfA6dNVMNyEhxtuh7C4EaYg4Az46EBtBRXBBcBVdmyUkPFNVY
5864	payment	1726	1726	1874	1	1	522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQz8c5wrK9JM2MhZfnzsXdUVj7k7yoCHSVJ1y7b912ns5MdJB
5865	payment	1726	1726	1874	1	1	523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7oa6EKPheMTtQAf675qD2MzpZz9TKA6AmvMit2EroNRGdRfB
5870	payment	1726	1726	1874	1	1	526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrv6uAMAqiY1uLmVuhvdzj3jeedRJJrjaW8PRzKqXGYnWzzmR
5871	payment	1397	1397	1678	1	1	4653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJX45rmsLusgKiJVgrEGi6hDjms6aMzEMz9SGbXFZFTR2XcAd
5878	payment	1397	1397	1678	1	1	4657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1LdYREyHSKgTpvDxdfM3Bm7e8zqin7Ht7WUQ7V2s2Ms7FBpD
5879	payment	1726	1726	1874	1	1	530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEKQXmtQTcgvc86sXvouzZekPvciqxvGYoCFNhmHmcYcvAYeu
5888	payment	1397	1397	1678	1	1	4662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyHk135aCgVDvqJAaq8LkZve6sn1tnhwQhf5gD8U3PPoBhmQx
5889	payment	1726	1726	1874	1	1	535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYah7EgBNj9448SwBbZxXzZzCbdKUqQUWBcU8xBMYNHFmWxTZpE
5892	payment	1397	1397	1678	1	1	4664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnWZPWfZC6aaHsRvxDWh8gaLeM7AZg2CMrfrE4x87ixobR9h6
5893	payment	1397	1397	1678	1	1	4665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNKCKJQvCtk44vHzC48X2RYWD1BnA6jqTMTJg9AASvWqt5MW7v
5894	payment	1726	1726	1874	1	1	537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5D4Ys1QZeAmd1Z4A9auciPeS9AQEVf23BpJex3mEwxwNnTnTv
5895	payment	1726	1726	1874	1	1	538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFexxbhxbs79VjKs6ojw1bW3DfUmQZgyeae4U6mhoWX7MD4oG
5905	payment	1726	1726	1894	1	1	544	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLguiq5vsU5PEyDzXCbfz61YtC8jQgbLA213oep2w4Cyuthv8X
5906	payment	1726	1726	1874	1	1	545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTcSozkB3wGTFKVubNejdGyTYduLR2x32qCnKdnYAq58hA9hZ
5907	payment	1397	1397	1678	1	1	4670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mACMtkrXj5DdHetuGZRS81oWtdfvvLxhPgo7dv4FLXJyJbUT
5936	payment	1726	1726	1874	1	1	559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZTNPsdhAFjtybErViysNpfi1DkSr9gvJwynaVkCbxbEtEpYx
5815	payment	1397	1397	1678	1	1	4626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk85EGtkHutScb6LMzcvqQyma7C5myDeGiSg8tnMqCZQmGhQgd
5816	payment	1726	1726	1874	1	1	498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCj2x59brDkswYEo27TJvvaq3TrJAKES8avQdSHWEn1iQjNjDf
5817	payment	1726	1726	1874	1	1	499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65dvq7Yi5QuxQvD3ZsgyiesJmtoEHrHFXGZj83YBMmsH766n7
5818	payment	1397	1397	1678	1	1	4627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGcUvoMsHvwgEBybDSJP4gnXuLkk1e4RoMgBzBGBnzCRyLD4w
5876	payment	1397	1397	1678	1	1	4656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBJ5Evx1q3AZm3jgKJXTGojRScTEfqCtBW1Xc5Q65R6LcC6bc
5877	payment	1726	1726	1874	1	1	529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtT3c4mzHPgYbFtG2DM1HEZpcFL46Ubd3XLVFv1p199e4BmFFP
5882	payment	1397	1397	1678	1	1	4659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxu4oPypQPe7s7asidsXL7e6oodKyVVwzTqmMx5X8Txj4xsqiA
5883	payment	1397	1397	1678	1	1	4660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yKSQ2TTBF6Fcyqe9gJ4Wj715N5ua8rvooXkhvGphGenJTZuU
5884	payment	1726	1726	1874	1	1	532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jisnYmvgevgjVim1mK6R4kxnoEfrhjy8WBowzqRZKWaC3nGU
5885	payment	1726	1726	1874	1	1	533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNPz3izLspGXfC38SCFKYk2WHQX1Pe33dLSpqu4AssMEXaupyg
5896	payment	1726	1726	1874	1	1	539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79buBpMKtFXpfh4Q7Uuxe4j6CHS4tMSf72LmGEHNNnvWcB5h3
5897	payment	1397	1397	1678	1	1	4666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6phvy99ixW3B8r1UbLAZjDJSwBwP6XRPkGNvkysPtt2qdJww9
5898	payment	1726	1726	1874	1	1	540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1kyi9QX6HWvzzaKA4HMCgG52invegcXW7cfakmqRfpg88opZ
5899	payment	1726	1726	1874	1	1	541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwrif4YhwUADM6427GzugJNXbSejyHXBPmcb5Yk6fhv96NtDg
5900	payment	1397	1397	1678	1	1	4667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZnXmBwPPkdownwyfAypgzrjXVrwJaF46Q5GGetgTaxMAeJyN
5901	payment	1397	1397	1678	1	1	4668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMbHCvEYvqSLGPLjNok3nAQW6wgQanace6Sw1sdWzK4XrzsnD
5909	payment	1726	1726	1874	1	1	546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjn8or2jmcoyt4HQFcLLGAH7uy6gjtkGjCpTzjvLi93bYrhEA
5910	payment	1397	1397	1678	1	1	4672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk1MrtHKNA6rZGn1pLvXszdBugbF1fDuSCiUZ8xrCp2DNf9YX
5922	payment	1726	1726	1874	1	1	552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12DnMLcuLeerxwH6kY9kkAqFHCFEGd4zfgXmPWZjYaKF11GXP
5923	payment	1397	1397	1678	1	1	4678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocW5knWGHjqpoiB6eXjrWDqdxCqhtf6wjcMRj7js45s55B9cJ
5924	payment	1397	1397	1678	1	1	4679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYK1TSEMdrs6BrTqzipHAcL8ay77FvYPyTF8ZTQYFu1jDzwCr3
5925	payment	1726	1726	1874	1	1	553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkeSbDZgYWs9Uumb5BVs6YNbaxeKaTzgU8SdR88WuNxpYjw1p
5930	payment	1397	1397	1678	1	1	4682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVtURVwamgjMy6Tm52pCCuaZbVgwWYJRgT3oHYuacnJqcTJhu
5931	payment	1397	1397	1678	1	1	4683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYziAjiL3torbzu63J7iLFjseeQNU9jn8FgbnMQZNWUVbCzipg
5932	payment	1726	1726	1874	1	1	556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVt6dc992X8y8wjet8HsWqtsRQ8vZL3p7qicuHpwcYWT1SSL4
5933	payment	1726	1726	1874	1	1	557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8V4BdnmQ478TnFjUq9EXhanUjnsCX6zDjVjQrBBYG3QmXEe64
5940	payment	1397	1397	1678	1	1	4687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7cT8PC5s7ccuuhgL9wVw6LjDJSMUtjcyJAKeAW7FbAUDoaJE
5941	payment	1726	1726	1874	1	1	561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCqErx5ZwNKviM5VrJgY4hjRFzuGGpZpamLhpd94zbP1hgeZw
5948	payment	1397	1397	1678	1	1	4691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMNTJzPfHwD6j7fL4y9vh7n5xPS5GW76hEo6jU7JtQKiiUYKg
5950	payment	1397	1397	1678	1	1	4692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPsAxnFt4jQmJjBK38t3sJ8ERNsdaou8RpLVcgQ2FR5JxaWUw
5951	payment	1726	1726	1874	1	1	566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfJWcu3MdTmNBrmpGxjpaCE9oGAo5F9WZ3RzqG7XSZT1tg3Li
5975	payment	1726	1726	1874	1	1	579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN7ku9w1wJxe9WA81zNMoEcPVv92HTdnsG4hCgCTRkJwYLbAQ
5976	payment	1726	1726	1874	1	1	580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrcGK1xnEmJGDXMvpHUySxUkLRGLFzwFvJ4GRuTVtwHZD63o7
5977	payment	1726	1726	1874	1	1	581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENZvfo9EtZEChdA5RmxaURxdC2G8zPYi9ECWWv2bDTypQptvd
5978	payment	1397	1397	1678	1	1	4704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURxpQxd9ne59pSjJwJr51bsZm54vLqFxjTmVzEBJUNLzg6bSX
5979	payment	1397	1397	1678	1	1	4705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUHjtn8HQT7NLi8xU3rhx9hXcMqjZFrTggZoyTKHU9q5DaLDV
5980	payment	1397	1397	1678	1	1	4706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uLnYU6yFfAGrPFuYosFbDAW8o5rqe7xF53cGNCWtGs2zE4uk
5988	payment	1397	1397	1678	1	1	4710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUEEfAsVo43kc9eGkQ27phQKzYh9WU5SbJjeMdx1raRJu5oZe
5937	payment	1397	1397	1678	1	1	4685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGF8VcybTbaZGoNq9rWFcYaAS4TQwREPTgWpfPwSZ5ckkudVh
5942	payment	1726	1726	1874	1	1	562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPnqfMytpRMFBSRScpj7zf6hAonftjHCi7jEF7RoVgTWEZTWp
5943	payment	1397	1397	1678	1	1	4688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtccUBMKxM1KCpbmU6AAzp2encseeqjWchxvzo7oMm3DVR1dz
5945	payment	1397	1397	1678	1	1	4689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8oQ87dvu9BBYtixhBNwu4smh7NoDVYgbNF8YrkfYiHHtpjji
5946	payment	1726	1726	1874	1	1	564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEjkmkt8y4q6jHKELmqbQA2hXgUSuMCFjbGxknZ1VXTBSo1Lp
5947	payment	1397	1397	1678	1	1	4690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtApkme2NA7G5vbS9cCuHuCmKQuc4kLyeZUnPidt5ojatLQgJi
5952	payment	1726	1726	1874	1	1	567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDuR6Xvm1wCNLzdB7iQbhTkvNzFSsupzgYKSKwAC7rJHBSzDh
5953	payment	1397	1397	1678	1	1	4693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGv1DNjQdn1KQEeFu8nF79fpcxtthSw53iw3j288GBFdmVwdRS
5954	payment	1397	1397	1678	1	1	4694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4R9gHsKGUwvTJKhwSMoxuxxqBqTN5TJVkQzi4tPSUXUMrAVNT
5955	payment	1726	1726	1874	1	1	568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpi3peiq7AixcRGwaiRvoPtNL9c1o6vvhZA3TteqXK1BJYspp
5956	payment	1726	1726	1874	1	1	569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1cwKU7ZJAY63Z9NNdwZUAHBHz151myPdJ3WfiSbAcEvVfysD
5957	payment	1726	1726	1874	1	1	570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJenzvTZWMbLRGvFWwH5JzhxaWmM8rUBp2QkkZ4zgREqcciCs
5958	payment	1397	1397	1678	1	1	4695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD513gFm96pM9Dg4Y63QNdoFCyKXMKzwibfNqHAvgQXyUULsVc
5959	payment	1397	1397	1678	1	1	4696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tw7yb1tr4rcF2pC9BjciYTSE2EvPbP8TAkrnM4HXLNNGuKQr
5960	payment	1726	1726	1874	1	1	571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiUstavB4iHBNkK6KurLcM3Ct1XvRWLY44h5ae8y1FCv2ksX3
5967	payment	1726	1726	1874	1	1	575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbPFCC586SbyT17FwvJt5EV7tSDoKjipm8mNWS4jk2JipeTte
5968	payment	1726	1726	1874	1	1	576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPwk39eBFLd3JQaLsgKEQvjev9EJSVdmv7yKjvvCj4nAnXQPM
5969	payment	1397	1397	1678	1	1	4700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnj3r3KNRUM8t8p1XpsasKtrcoiintpChmJeakU5UoSZztva8
5970	payment	1397	1397	1678	1	1	4701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uTFT24VVGivnS235zcGrDLNMNH8zvCkXPdPYsS4zn13meLL9
6018	payment	1397	1397	1678	1	1	4724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaQ96LdcxXwsHEprdC6JnpKXnM4MzWJrmDxPxPhvMTrF26rt4
6019	payment	1726	1726	1874	1	1	601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgXF1JW9vX8yzZa6CAEk2fJ8BoXN2Kteh9ddx8y7AKm2wDiEP
6031	payment	1726	1726	1874	1	1	608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2x4bqnNoyTMsCYNvtCRhEBS54kD7FieUoQdCfvBZtmS9cKaEJ
6032	payment	1726	1726	1874	1	1	609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozb4djwBf8ir8wJ437GtyX4NFAJeij7CbmVvvu7xJquSG31US
6034	payment	1726	1726	1874	1	1	611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTP49a7Rj3KP5kWq5gHuktUmLDtVQZktMbzxpQmcJwSPqdYGYy
6042	payment	1726	1726	1874	1	1	618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwBy2kyaWLLS6zm2hTrAoXgTkQL2cuJmVAB51giKbrJ7YubW4
6043	payment	1726	1726	1874	1	1	619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTWeGS53mzSL3gQ8y5QQUvR3bkxrh2BsXYJfhurg8hr8odACE
6046	payment	1726	1726	1874	1	1	622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1xJ5eJJUTzm5LVrLca2gjW4Rav5AUFAPM2cB3TFoEc3iW9MP
6051	payment	1726	1726	1874	1	1	626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwDFcUXgZ7q7hoEa2YdfBWrhX2uhU2MHBS1k6DxiS8JSS5teM
6052	payment	1726	1726	1874	1	1	627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVYSaAbLXm6ykA3LJ9yseuwnGganMe15z1mU54NeLhdDHcYA7
6060	payment	1726	1726	1874	1	1	634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBmKg2Kpo8X9UDGUaw8wNG2gL5AUfE3yp7uFvN99SBn82QDPj
6061	payment	1726	1726	1874	1	1	635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwXAsnPyevpjBFV3uXDo4dWhTYiyBqVLzDd3ZTxQGfvv8SECU
6065	payment	1726	1726	1874	1	1	639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QojV4gAijffPvgVVFKZDnBUTDZTbt2hiSXR72Mhe5e9swD5A
6069	payment	1726	1726	1874	1	1	643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrgXhBB8GwcTebv724GW3ZfwYGvwibfg122dd6eCQZs7wUtm7
6072	payment	1726	1726	1874	1	1	646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCwdZCC5U76jndA4JF36fXLQc6Q1Vh2fLJSD2iRHAsQVmevAc
6076	payment	1726	1726	1874	1	1	650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J5SBwtez98zKaZXJdwSddo7R5viLUD6r46bvu3n7VcMmAhHK
6077	payment	1726	1726	1874	1	1	651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvzaGr85z893HgVoKvSwJWk4GxbQMkPj9zXpNoKhMNNnt3RPR
6084	payment	1726	1726	1874	1	1	658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6itymbxJNqapjz5PLwQhGDYJuepNFAUJGR2ZuX9DQLL8cqzBw
6093	payment	1726	1726	1874	1	1	667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5VJg279EHi8NGxXCU8Qt2gWmtBxFKYrkHMfH6y62gLNosjT9
5966	payment	1397	1397	1678	1	1	4699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpm8NNgiBUEAsHWL1ESRY3Hjk9gXviJzmfyhxnxGcQ7r8qH1dm
5984	payment	1726	1726	1874	1	1	584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd9r7PKLYWEQj43xG1Cd8newMkXWwGnxtUZ4YdAjKGro42Ya3
5985	payment	1726	1726	1874	1	1	585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWQWXMQ7HifvsFvn9cRhsXP4gszn81iQVy4sNUsUkZ9n4h5Rp
5986	payment	1397	1397	1678	1	1	4708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXRvf9gTzzz2SAHMZBP5WSQpozKNrrmjuPPW9n7HZopoCrahV
5987	payment	1397	1397	1678	1	1	4709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrD7Jjo6XB3VgLCTjLPW5LFAo6oJqouG1vkefDkoEEQdMyfKGF
5992	payment	1726	1726	1874	1	1	588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2PRbHgdNhGDUjWs88ZMXUYgTRy6bzj9m9ShRVYLCqgPDgYti
5993	payment	1726	1726	1874	1	1	589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdUbRHyk4tEn6hBdUGXvxTwTmmACkoR8WBuTNRS85KyTwhrf9
5994	payment	1726	1726	1874	1	1	590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsiqyHN9e6ewtCgHEekCopySZf529rFMNYcjLEsQC6EWwwRRP
5995	payment	1726	1726	1874	1	1	591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6qK3DjEbi2c1e73K5bLuoMr28xQxcy4S7T9wiUn6CamupSYt
5996	payment	1397	1397	1678	1	1	4712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8wmSzBtbi1yPd5Adani1e7EU5gykjPc862jR1X8bijyBTNv3
5997	payment	1397	1397	1678	1	1	4713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLSR98PDraMTueLNx72ouugc3kgzx7We8i22gfayrFyBhprQX
5998	payment	1397	1397	1678	1	1	4714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiy5tErfJrv268ubUg1ZxmzaKGRV7pT96TVziDKAW3HX4pZQp
5999	payment	1397	1397	1678	1	1	4715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHohotGRDh8HYaRetP3vDAKGaEBAqt1vYR7thsjsrGeo392GB
6000	payment	1726	1726	1874	1	1	592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iUXLyLkAjbgMPaY2DVchxBE2R5vL8eeUb4CxzoX9RtaY8vKz
6001	payment	1397	1397	1678	1	1	4716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdk9HPyrAi7umuAE2jPv6vPFQT9TY5qXY3RBNoVPqRi6nVQo8
6002	payment	1693	1693	154	1	1	347	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpaJWzvu1zacqPfFRFh6X5CPGpcK199wkrC5GgCnT4o7pMrscyi9
6003	payment	1397	1397	1678	1	1	4717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaKwn4JQakRNm1pp6XCaXPrRAug1yRPKarbPcSHYtuNGNr28C
6004	payment	1726	1726	1874	1	1	593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnoWHueUH6nqgids1GL3nsu5ziB1xQ3Y6o231E7RthDcvdhzU
6020	payment	1726	1726	1874	1	1	602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDskcchkVB7Fj5WHZD3RnMuckeNsSJpq5QAE49TtHHXLXENmj
6021	payment	1397	1397	1678	1	1	4725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ySbMg2G5CXGWfAd2sLDsgZVQVXemUCG5sfFvB8vQFQDrEjRH
6026	payment	1397	1397	1678	1	1	4728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzwW1g2o9N7feySbbBM7MN3w3VkMkUgbkqm1ARqoZC6dqRP1J
6027	payment	1726	1726	1874	1	1	605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Swpn5wzoaxJrgTY1zqakNxZedvRDaLebESpuCVnVzWsENmTk
6033	payment	1726	1726	1874	1	1	610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJXUK8wQFwYeLPdS1PNJVaLpDwPk1AQXX6T5bdJFvR56ZthZf
6035	payment	1896	1896	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwSR1qCbbbDh8mZyCdTm27T8e46kXLMGjZhZnnLJhP6NkT5pL
6036	payment	1726	1726	1874	1	1	612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hXeNf8fMgvh84EdRxFjabEEMWrr317heLFq1GV9s3d7713js
6037	payment	1726	1726	1874	1	1	613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK17cmQaL62DyvQSDyQmGGJzrryZbqkZtBCTRoaxd6Q4CggkZn
6038	payment	1726	1726	1874	1	1	614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtFdFyQqVMoJwp4S5NaLPtLBwFkDimG6QvhPMRhMGovZFzjhb
6062	payment	1726	1726	1874	1	1	636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCSjmTudr5UryiNUWCy86cwC11uwHpBWG1VnRo1VB1gKnL7LCd
6063	payment	1726	1726	1874	1	1	637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH4ct6vR9TFfkrMcf9PRavFUTE8n16AmiYf6ZirX6HRsKBFW8
6064	payment	1726	1726	1874	1	1	638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwSZjSv2yxMoqEXKurigFu6jBUF4nBdvXFox6BgP9SADdxZd4
6068	payment	1726	1726	1874	1	1	642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyNJVK16vhRn2hcPQTsNri3wHCcFoj6iJ5dRpL9CS3qV5K2iy
6073	payment	1726	1726	1874	1	1	647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSxngm93R45Hce4oVTYTiAzBPACQnwkFYnZHFAJ5qzxLufKC22
6092	payment	1726	1726	1874	1	1	666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeFJh5t22R31wddABjA2XzRsc7tnWNeeJGqtwyYCSEyHANchH
6128	payment	1726	1726	1874	1	1	701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LEg6HnTYdQxPfhwqZS62LCApbGqpRcWmHKxRLGkYACNmA5bQ
6132	payment	1726	1726	1874	1	1	705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNngoYcsczUzZigDC1qpEhZvajVivbFjRt2rdzE2mHuqzsRRaA
6133	payment	1726	1726	1874	1	1	706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq8sCzmKaNiGnkqouHFAfsg3nFCTZd8TJFeQDUNn7bnGQiY9i
6140	payment	1726	1726	1874	1	1	713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLWRijD1qJ87D323wnDC9CrB4P9vZqfVWvVK5BBZtQn6ag69R
6141	payment	1726	1726	1874	1	1	714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHzo5JS3SLe54SR2YxWdfZE3bXZ6cScVPhtJqvjwCBHKjYS7f
5974	payment	1726	1726	1874	1	1	578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtce1tWDS9ARYneff9u1RL8dmaVMswMoRqdYPwroCweXn36XQu
5981	payment	1726	1726	1874	1	1	582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX721JESW5sgWn9JxoSnosFSuprL9no85e5pZ4nhEfUyNkP8KS
5982	payment	1726	1726	1895	1	1	583	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2rKLZParfxmfVUXGFQGLdWaMmFYmATmpWLBY5d7tjnnVjiBdZ
5983	payment	1397	1397	1678	1	1	4707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WXQhzishEqn7naEgidv1XADRctTLamUn7ddkWUA5WvRMJnbw
6005	payment	1397	1397	1678	1	1	4718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoCHP5wV4D5JYJ5MBp46rfBKszABw5DsAd7ju5F4vCBnLYuG8
6006	payment	1397	1397	1678	1	1	4719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2uvocsAwBTvdePtpcuBWJLU3Nxaf13hrey8Rczwd6suq2pJ9
6007	payment	1726	1726	1874	1	1	594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChigweS2z4tfUhC8T56Kw7GU6F8XhxcrCq5TpJcFjUux3kxzU
6008	payment	1726	1726	1896	1	1	595	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYznTeHUvsNyYHpKawoisnXqLGohFc9V5XjHzL6NQDyvUvUYjTT
6009	payment	1726	1726	1874	1	1	596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mYvN1za4r6zwB8TyhsDLgU7gADKeFXUn2nBTLTQNkrijUXDr
6010	payment	1726	1726	1874	1	1	597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDhRxHrGnNzfkvGyVJJiVnDkBGP9SZbL4wDLGHZMRoUK7Vk12
6011	payment	1726	1726	1874	1	1	598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7fbmTvDTrzM5ZwnS5RHWuNsWnWXssXvMcMdAmt9S2YXudvSW
6012	payment	1397	1397	1678	1	1	4720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmbeN13k71nTtGrMPVy1UpPcmWTZ3c28fMp8YdgLcdhfVTHX2
6013	payment	1397	1397	1678	1	1	4721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWwhtyaDpcSfeMcXJqePPow9RdP4HQeMYoD69Hi1oVHRdGPjy
6014	payment	1397	1397	1678	1	1	4722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDqHLodFkUzjsWJv4MYvhf4kyyXhTR6qzqqkFJjFcx8mQZAH2T
6015	payment	1726	1726	1874	1	1	599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwezxYMzE5fbt436hbcx1mPwrLZYdmHPhxTsrVHBVc8Z9Jqwo
6016	payment	1397	1397	1678	1	1	4723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszxPaF1HuUwZzyEfBmbWHoRK1iuZVTeUM7kBNmyrCHG1TfeHp
6017	payment	1726	1726	1874	1	1	600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51m5BudDojRnCQdVf52sm3Q1SpB88TXWcjqS57ZCuQ4RnBbCN
6028	payment	1397	1397	1678	1	1	4729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSwhV7hND5usuS5b1pEPACbdBT6dpD9Wcj2H82fMq9JDtG1av
6029	payment	1726	1726	1874	1	1	606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6z96nTu3Qbq8uULsYTDqzmNKuGBbCpCS5ssNHNFgiuP6UyyhW
6030	payment	1726	1726	1874	1	1	607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQxtpqN6u7jqMdGbMCwkLLBBAZ5LMXET92DMgXsCqgHoCoWAZ
6039	payment	1726	1726	1874	1	1	615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcqKYA6PkrQgy4cRJLhHFFW2SgakTVTmuaKJDspdj5zjuy5hg
6050	payment	1726	1726	1874	1	1	625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUw2cCS12deaP1MtK2KFx3hVSrDZaVd6cMncN3qrRDt7i239z
6055	payment	1726	1726	1874	1	1	630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta8Bv4nLruYi7svig211carGanNTdkfyR9xvyLdMqGmXsiqVL
6056	payment	1726	1726	1874	1	1	631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9pMZBpsmPTePgMg9JzCw5wmWvgpPx7dqSdU9KPK7pvsKwP2m
6057	payment	1726	1726	1874	1	1	632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRSQ4yGxjZwuxkvmNTbJcV9vvH4eSdq3Lt91QXbaxdvjX3L7E3
6058	payment	1726	1726	1874	1	1	633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKw4aPuA9rwPJ7cJa9tLCsZJuDDDVFfArxh4KSkQTgUNUf2Wap
6059	delegation	154	154	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Gd3wqdJu97zdJzuanLHMj1ACTY8hZDi5YEBWJdKiAAmku2as
6066	payment	1726	1726	1874	1	1	640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8eT6qkcMrLDbYABfss2BF2g8dchwMja85GJFvfFc4iT7zzaj
6071	payment	1726	1726	1874	1	1	645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7qZZNqSy9QS91xok8PERUQs6y2y4dohWwP1YVpnW8tt92Rze
6075	payment	1726	1726	1874	1	1	649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a7MnYsxcohgkj9USYMg9DtuzyEqCC9ukSxeRT9wJjpAScbPZ
6082	payment	1726	1726	1874	1	1	656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzyxYX8D9dv39HBHRx8QG6xcqeHARe8mKhSjJ3WZbVW6rNRzk
6083	payment	1726	1726	1874	1	1	657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYymmgp7Qq9BNoFMPkGw4Qdve7B346nUZgHifKiLokR4qZW15R
6091	payment	1726	1726	1874	1	1	665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatttQU1cq2XEFdL2agKoL9EyjMHL7vDF3ozY7Rnm23TfqVmPf
6094	payment	1726	1726	1874	1	1	668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8G99SbtpZ4RXDGgjFYZdSfWXS9PiyuMbxLX3Jwr1vcXK8cXp
6104	payment	1726	1726	1874	1	1	677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjvhgSHXsrMC47qQpR6CB1en23kn2ZVgVP9mry37DbVUBPDrT
6111	payment	1726	1726	1874	1	1	684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXcepTHNCerpB3EyQ7pov3Cw3jMhfvLNSH7bxgHouH8Gv6hqP
6119	payment	1726	1726	1874	1	1	692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshhHfyK8jBNvkDCMAdsHhp5HU9pRe5GTvwiFgDApLXNGP1Y5f
6122	payment	1726	1726	1874	1	1	695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnjQ3qS33qb9qwUJMte9oWryyZWkxwVUwQoCnGWGQGeSMdFS7
5989	payment	1397	1397	1678	1	1	4711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG6AC6WaobHyXpvMTRckR8ktoKTMyXpPcS8vkwNqtt8KzQCyi
5990	payment	1726	1726	1874	1	1	586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivyWXXUa7fGnwakLCH2eaBZXZrdp3THJLPabqvtvgV1uxwBeD
5991	payment	1726	1726	1874	1	1	587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmegRyZW2MBkgMkVmRhqwcwokGyxdgVvXWazLmrMpueQ91jzk
6022	payment	1397	1397	1678	1	1	4726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDmxTCzz7NJyvVhaCnMZTqTeUornXTifcUGUJia6tSbAskyT8
6023	payment	1726	1726	1874	1	1	603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT884aiPGq3J9c1kXyDMb1zjeg6mPD6fCgA8LP4pZLE7wEp6xP
6024	payment	1397	1397	1678	1	1	4727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvn28qjgD27hhohiemfP4eNnq3Mtr4BeJeQDE1FnEK2hzrASMA
6025	payment	1726	1726	1874	1	1	604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZU4mWY6QNJ5d5bbwMxkkq3wdBLYAjNXarPtmT8hEUNsfbSTt
6040	payment	1726	1726	1897	1	1	616	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8dzdth74tBKFjbApB3aHrtaZETkR5sSA1NX76a82N7WfE1skm
6041	payment	1726	1726	1874	1	1	617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78gK93E13GUdfpieEHAaDqzsoscpw8qrQrEV1YRkKU6A74P9h
6044	payment	1726	1726	1874	1	1	620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrUFz4BkVEnQyoXi7NmQx6UiHufLsotWwgaK7G8sb4DLk3Gfa
6045	payment	1726	1726	1874	1	1	621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToiMY57ga7mfGnEtBPAizTnkSpb4QmCvQPQmgkqoEN8RRXho4
6047	payment	1522	1522	1898	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9oEhtF7Bs9YNTCoPQc4bEsyCefSXEPqqQn4g3dgFSMxs1j31
6048	payment	1726	1726	1874	1	1	623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPAEya8dqpsQPK3fo9SMg6cEs8TRTEgw6smpjsmKriKLwujJG
6049	payment	1726	1726	1874	1	1	624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPWuU1zuciEehnZy1Wvcv7ftSR96NapWmHGHuEguSE6v1hW7X
6053	payment	1726	1726	1874	1	1	628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYg9c4VApxXX8C8egZJviFHw1fNEw4j3uKG3SHkejujtoFQjM
6054	payment	1726	1726	1874	1	1	629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59HzZH7SVaUB22jVsWQN8LnxPjsHej2HXQEJR3whnVN9pjgVs
6067	payment	1726	1726	1874	1	1	641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSb21ULtjbcWqJx9W7av4SES1b1e6fdXwVa7VobGQmkY838Yd
6070	payment	1726	1726	1874	1	1	644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJfJhKZ8nNMSv2zxidrBQLFQxZqtnSYMrrG1VmuqTzQpcQ1JW
6074	payment	1726	1726	1874	1	1	648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHY2TXdynUo8nj7QKfg9GDTnMhPmpH3doKJQFRqQnLEQLp83F
6078	payment	1726	1726	1874	1	1	652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJgaFibcRDeEPj3WrKjX9qT34fEd2XpPtQy9B83WY5qpXkFve
6079	payment	1726	1726	1874	1	1	653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHe7xZ5pKe6jgmjFkcSELknXnqYZEnRjuybcU43ujt9y6hgB9
6080	payment	1726	1726	1874	1	1	654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCGNV5TrnzSGpRSSYAXSyCVTVCxoHbdTgmqJsMt9KSQLMRo3a
6081	payment	1726	1726	1874	1	1	655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T5km22i4BRQHkekfHxd7yDVrmcerdhdN15tum1sYiP411ZBd
6085	payment	1726	1726	1874	1	1	659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPtGMnJyTQi75bVcheDMH9kpTPYwPKcVHZaPHbYMK7Fjgqbgd
6086	payment	1726	1726	1874	1	1	660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkYvcvKFnWDMqHAjV7m4PJUAki3VrNLgxXbWaqANRRaAznxot
6087	payment	1726	1726	1874	1	1	661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTtiDmLzHRmZHLSw7uKUdUeULxWzEUPf86RbwLAjHLXQfY2vi
6088	payment	1726	1726	1874	1	1	662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRAp71ZGWrDcZgn83pVFfCaZJGHMMW5Gvwkca5DGVt49nP9DE
6089	payment	1726	1726	1874	1	1	663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAk1hHr3wTVQdpqouLb57Rzp1JqS2eDTdLGocD8rGSw3iQ3bjB
6090	payment	1726	1726	1874	1	1	664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqwVpwHCxqCQ5ywinmW1daVkpa5K2uVB2u7cA5oPCg9aqojun
6095	payment	1726	1726	1874	1	1	669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVwU1t18HEWi9ZweAcVfrhxqZRb7mb7huiJro26Qfv1uYro3E
6096	payment	1726	1726	1874	1	1	670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8BD8KmQ4ScWAbtq8JLrfQ9g3mogUkqwKBxGgMnEBXEP8A4LV
6097	payment	1726	1726	1874	1	1	671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujbkpPZZvzwQLX32pnP3gpHvpVBwBe3tQpLHxq1NbnYKFPPza
6098	payment	1726	1726	1874	1	1	672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA6zNmtQvfWHGqdNTKtVRK8XSs7qrpVv4s2Jb2M3ZrbExd3p6
6099	payment	1726	1726	1874	1	1	673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpRtENwHsX2spaoGFqzibz21SxRXUtVvdoix5HsgSiQ4HkBaS
6103	payment	1726	1726	1874	1	1	676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh33h71cEGgTRgvwnNwoTeHsVLW6S2K2mQwyzQxnR5re7Y3tf3
6106	payment	1726	1726	1874	1	1	679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGAdBAonoEsk8Y6xQbazyFi4SddsjMSdpi9szvoMnAJMPdtaE
6107	payment	1726	1726	1874	1	1	680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsVRFrX8vpUBKiz2ZaaFKmZ6DRFEouqZsaYms74Jo5p2WJpTw
6108	payment	1726	1726	1874	1	1	681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYou8iX31urdnwctZV4y7CexyXxhxGqL9wyKmM7UCyKFtHMeFs8
6100	payment	1726	1726	1874	1	1	674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbD1CsUJMMFDD6xTLAr1rRPLUzGrALFq7Z8prUGmiBHMiVjT75
6101	delegation	327	327	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLpeQRG8RRzWAsEma9BeyRqMuiN7cq9G7XV8LnPgHBW2HtEpy
6102	payment	1726	1726	1874	1	1	675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANcwbkT7WmDRKmVsCNyK2RovzGWNoMxdy7U2KEKEuLrVBJVTz
6105	payment	1726	1726	1874	1	1	678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQhDFaxd6AKZe7feJ5vgxmr1oe9k62KMZxihNenjWdnSxLGDH
6109	payment	1726	1726	1874	1	1	682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvdZqRoC7Gq3TsSqAc5xT4dW8oRpjoJwViCDCNTu3X6UrZreX
6110	payment	1726	1726	1874	1	1	683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDi1qpxCk5r2amum9bABp8Vn13VQ7i2bXeKB8JyKtqtDAW81tL
6116	payment	1726	1726	1874	1	1	689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4PjKEgUBKTxNqD1RHpY3Kr1TfkyEoHw9tiQWFMPK1efFv7iC
6117	payment	1726	1726	1874	1	1	690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQkUNSUuxpKXsYNANM1JiVwcFZ9XpnfmpUX5SQeoJdVGomLep
6120	payment	1726	1726	1874	1	1	693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bAP2zESeCCfwGEkHBcGqGRqAfKi6HWzrrwZeXAfVMoQh3w1m
6121	payment	1726	1726	1874	1	1	694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7EnhwFaWSH4vf1Khzp2xGzWxhBE37j5jS3w29pGQuWRXpZEh
6124	payment	1726	1726	1874	1	1	697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyihw61H4sfPrrTSdwgQNFKseK4EHDZAZGBBjphPt42Ek2wbm
6125	payment	1726	1726	1874	1	1	698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRGx7uE4FTgDehzrP6pxZYNsmVwCnWEdyZpCc7aQbDEBmXRUn
6136	payment	1726	1726	1874	1	1	709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPsNReN1SHwtHcPkabrqA58YHugFhtahPpn2FSiriCAehS9AA
6148	payment	1726	1726	1874	1	1	721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9HBJ9nUzW7wecUYsrDQY7HH5i9oTL9UPhPpAtjPucxXQWN5z
6151	payment	1726	1726	1874	1	1	724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NVAxR2cqzQFBXzSpqeeLrLzfnrQM9Y3FZBfcmDHQbYUrRhN9
6152	payment	1726	1726	1874	1	1	725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJ6pB4Y4GnJFpmcedx2zbn9b7xUxYbRcjMgEEiH76QNBmaK7j
6153	payment	1726	1726	1874	1	1	726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8QPH53pngXU9ftMDtuGycNWZZ6TzjdK5PoGaFme4YEQ2shP5
6160	payment	1726	1726	1874	1	1	733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4ZwmvmCguSm8oDSFr6CxDSAZtgriihtVXqdvmpGNXNFqhnQi
6161	payment	1726	1726	1874	1	1	734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7MA5XaYfh9AYPQw41USWzccSip8jkuv8VaA9Hc3UjuhzvGQt
6163	payment	1726	1726	1874	1	1	736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqofpZj1G7MxRTi3J3VGm9Q7BDYoCVU5Ghgs7h7Y7UtzueFDzB
6164	payment	1726	1726	1874	1	1	737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Jf64RfFRoFbT1EHKDzGZiQmCt3tdHTWRy5mBtcvB1oD6Fz3a
6165	payment	1726	1726	1874	1	1	738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFpico5RHNuUgcngzynYzZrs55qkUPfB59pn4pkjcCEunADan
6166	delegation	1740	1740	1899	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8zFLUJzkGiKGibzWqrfJ1ReZbMb6i2gPCnkHYgWYkqHq21oK
6167	payment	1726	1726	1874	1	1	739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cm3bZyAzdXmQXHzc24roRtKDyBCxbUDrPVumS3vf9wZj5sgW
6168	payment	1726	1726	1874	1	1	740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGm3hBG6C4QK4zjTgFuoH1hykTHmsVm7n9EwpcsgekrPXhAw8
6169	payment	1726	1726	1874	1	1	741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSAAqwGHGHu32K3PiestpmAnZJnzp7LGEXyq4PYUctykmPMTF
6170	payment	1726	1726	1874	1	1	742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoCiCcckwm5gvcQy3gSDv8fgspB62zjynBvmoPxPKvo7hZxTr
6172	payment	1726	1726	1874	1	1	744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41r8BysiPYRXhnWTY8JUBUYBZ7HcjxpbSiwNmBFQB1hKkFMc2
6173	payment	1726	1726	1874	1	1	745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NeNVKypjojPTeKBBY8a2QVo6XfDvgvaWAQHheAdiM7E3Co5E
6193	payment	1726	1726	1874	1	1	761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAT2p7HzzqKxAZZiWyBocCHTdfAsLLBjAfgrgR5A8VdESNyPvU
6198	payment	1726	1726	1874	1	1	766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDYFzbMXTaC9tH84hoC7HwPgR7xiTim6Ns6NyXGs1Tz7i7vW4
6216	payment	1693	1693	594	1	1	362	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYksUtEQTR6d9Fd6MTkh8rhAW4emvco2kB1FCTFbSUYG5sw7bdP
6217	payment	1693	1693	601	1	1	363	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZcUdvpntkL7mDnBEsa7d7uqsC3HmUFe2xdZUtM3FrozQKXqhEd
6218	payment	1693	1693	680	1	1	364	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZXuXRa4EURN8E4P6L1Y8tGo1X5REbhyCc8vJEJuKE5UmxFTuzu
6219	payment	1726	1726	1874	1	1	769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmv8p9LDcy1gZ99ebeQ69nkXucwhzLW4FYdaFqqn2Z3dXfSwgj
6220	payment	1693	1693	392	1	1	365	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaAVcpdC2fZUNxcH5z3d1KJKjpeSLbcw9qG3ZsseXus9XQLmZcu
6221	payment	1693	1693	690	1	1	366	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYQBRB5ewQmtxooMJyF81BQGWkFNPsWv7uEidQA17svpcVSQFPb
6222	payment	1693	1693	186	1	1	367	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZfezEf8G7Jyptwfjmpih79Fa7MaTmZSh9ESasCPXwcEsmTYvfz
6112	payment	1726	1726	1874	1	1	685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpk5npkuwDxkYHCsTgLFedEu1U9B2tWMKUre3XiZ3aNc6KYGqy
6113	payment	1726	1726	1874	1	1	686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoHa12rcAbTjt5qaNeUAPMDqeWwmMtW3pHRMJsweFRKqk2mq2
6114	payment	1726	1726	1874	1	1	687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfd8C9wR71y4Fq4Ru5gtw2mDuypjBYHikvcqCNvnvDu52JS2F
6115	payment	1726	1726	1874	1	1	688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqLZ51G36imVerfqZ62PUMCBR5C83u4LRM25TP1RDHtD4iFD1
6118	payment	1726	1726	1874	1	1	691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8psp6ckv6TdTVHE5joXKSedpuR96ugHrR4aXjotsEaZ9baTZX
6126	payment	1726	1726	1874	1	1	699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiAK7LeM621cW51hE9oCt4FgpfsNAs44uNLiEMX9aV4sxz4ob
6127	payment	1726	1726	1874	1	1	700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTk1vX19ExNuB3a94oPmxxdh74mCyx1njkg4gHkPKBLH3CJYm
6129	payment	1726	1726	1874	1	1	702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGM5ymaPWPu9VkdXCD5mDhppvzp93PAJXGFypQMRrWGJG5rJs
6130	payment	1726	1726	1874	1	1	703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQGTDsrSuLT6PZ93C4ttyCESjUKqETdL89BKYjejham7Tz1Dq
6131	payment	1726	1726	1874	1	1	704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKMrJbaarpoMrQ2tke3Xknr7LHXZNX9rLkTFsxJLXjkFGwsHE
6139	payment	1726	1726	1874	1	1	712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw11BCeNveELdnX6SkD1ncxDqbpTxWMC1b5CV2DUtNU76VBD3T
6142	payment	1726	1726	1874	1	1	715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozywTJi33pcgr5cLVq3DPX74mWJrJhoorAW2KMq1r8v5A57Df
6143	payment	1726	1726	1874	1	1	716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLjcxAh2D3gzHxw1c1CJXeyiHgFRZ53Z5TCYzy5eMGrCYUBdC
6145	payment	1726	1726	1874	1	1	718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDGXfLmUuCCLdmFi4zBc4W2vooTuJKV2DAdUvJjfoV1xjMxtL
6146	payment	1726	1726	1874	1	1	719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbdcK3HCWw5WxQkmZdDszkLftbfuhBQzhr1h4DZWYF5ZMyq8S
6147	payment	1726	1726	1874	1	1	720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTHyg6cWszfXHXWUp9HefoBrh7uCGRXE8F1U6ptNpwN6pQZjW
6154	payment	1726	1726	1874	1	1	727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTQ7sN9wD9d4dgb5WJFxgzpCTmvP4cZp2w8tNwbVt72fXmoeg
6155	payment	1726	1726	1874	1	1	728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EcsZi2x4DSgkkL9ESQ5YuW2dQj5mQVeAeSNCs3erQa69dQHX
6156	payment	1726	1726	1874	1	1	729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ75zDsFGcZRNi66Fbn6JgMV4wBUzqHwMNBgTh1dHSCgMoYmm
6157	payment	1726	1726	1874	1	1	730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZackcdgfWqL38ySNfCb7h8VqpYY3t1UGjnn1S9A18smSVWrmC
6158	payment	1726	1726	1874	1	1	731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWjX3kRL9qw3Fi7M9RaY2croCovdf4oHg1NJZL5Bw4gkDU4nq
6159	payment	1726	1726	1874	1	1	732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv37r4vE7vjmLSynzjW5aQPSBdN8uAgm6Kaf5dR5qVQakYWv7Z
6180	payment	1726	1726	1874	1	1	752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq19uHgtBcndWPrQSmwD8348uYp6CMBgbjMCvtujhdXyxzjuWL
6183	payment	1726	1726	1874	1	1	755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuKEYKhcLtdxZEvHXPctxLmX8wzb4XLds88z97cuYsTWHrupK
6184	payment	1726	1726	1874	1	1	756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AQNajTzEM59va4F3hYxJNqKSx6epwhgFPew2x4kEkZs6zGaC
6194	payment	1726	1726	1874	1	1	762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwa5YnYkfQ7GWDe6RUVZWvxBV4c6C2ttxLmowAwkBkJKtaG5b
6195	payment	1726	1726	1874	1	1	763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPjS7hDR9kPAfJ5bf39V1epVKTeHpjMrFzsN8XxQskPcDYgNhi
6196	payment	1726	1726	1874	1	1	764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaAu9TKhC46QNjViTLLPHVuX1s4GS2cYE6QqfZZWNvhcDrCQh
6123	payment	1726	1726	1874	1	1	696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgng1eKKJB6QcLs6AyXcam7aJNniTApP8PbvQSKnSPFA4DptD8
6134	payment	1726	1726	1874	1	1	707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NGZwLa7nMVmWab45QgRRdVuyEPyMQiy3ms9oQHKgW5keHNSe
6135	payment	1726	1726	1874	1	1	708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4MbUmG9Ph9bpmtX7fqwrK45zLuWHSKT4r2VyDnMt8UMZRqQ7
6137	payment	1726	1726	1874	1	1	710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPD5AEo5uiLhyCxegRtzS33DgokhyeNwhKLS88bztTHnamghZ
6138	payment	1726	1726	1874	1	1	711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQcR1prv3wsowh373ciHyuc2u55xehKKYxpBxCnZ37etGZLBL
6149	payment	1726	1726	1874	1	1	722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU4zBgdMkN6rQpNbn5wnZWUjuG5Q7ZKAidmR2bk2ao6zHDFHk
6150	payment	1726	1726	1874	1	1	723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UDERbzwBxfEJZXZWfxbY8EaDbF88G9g62tYEu3TnpzQdYxJz
6162	payment	1726	1726	1874	1	1	735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tPoTfrdbxNmNNUvQaCYryKbCRDj8EhEw6rrXqiV2wApP4hGT
6171	payment	1726	1726	1874	1	1	743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Jp3f8k2fPAaeYwKQagzDXG9bjiQdYwp7XR8GV4MapTNDdn9F
6174	payment	1726	1726	1874	1	1	746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMCRVGFx2TDqaZvJ6MnkRaCEh6jgQ6boCiN5DA26f3u82hZrR
6175	payment	1726	1726	1874	1	1	747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuwkDTF9pT6rgjWQdRS7BNMoLEPckFGmbbYmg2KVNAk14N6Qx
6176	payment	1726	1726	1874	1	1	748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeK8dDbdxSSismyqxZkati8p99NpM64ibnBdFf4ywJXoGSRunM
6179	payment	1726	1726	1874	1	1	751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VHsRXbd93YxqbAqsGZ13FxcYjRfPvRmisHPi9LKFmnn8rHxN
6190	payment	1726	1726	1874	1	1	758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyXfvDySpHr2F1S1HfJMFsp9kRG2nPLKzJE7KT1Dgbxox3eWm
6191	payment	1726	1726	1874	1	1	759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zinRDwN1mJaf8hetBxP7QLzwvqsdn14PAZYJjZ29daBjbwK4
6192	payment	1726	1726	1874	1	1	760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoo1sVdMKw5k7YwmuVVTroDhKphdvvPU8yqoS2Zg2q2FprEV79
6199	payment	1693	1693	309	1	1	348	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYptLHxRj2EDdTUfEM15UwviNZvQVaTkDA7pG9svZSMpvrvWWW2
6200	payment	1726	1726	1874	1	1	767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDuQy9gmHPiiCjwTrpGDjq2fYENGn52yZpS1TpH2BLx12iVFs
6201	payment	1693	1693	150	1	1	349	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYyMHjgS7pARwY5w7oPqnahmrgsm6a236wPekKaYKSs3nfR6AD3
6202	payment	1693	1693	92	1	1	350	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYdWjKzpAViau5KqtqebDAsd6BvZnNT1ZwFciM1Jguh26qwStqx
6203	payment	1693	1693	63	1	1	351	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYaxEcG6Am4CQz4upkBEum1uYJQoZSpG2Sdir8W9TZpZFfFZa2Y
6204	payment	1693	1693	450	1	1	352	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaBmL6wHrwDBjWbwTA4p5JDku629ujmKVdg7hfwpH9DNAJR6ahX
6205	payment	1769	1769	1900	1	1	17	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUGNMcYSaupa3AK5D4GiJkY6wzAVDm7hkqhxHDWn9ixVdRujo
6206	payment	1726	1726	1874	1	1	768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCXFQtL6CCBN3iBjGCpVgQgcYtJyqHAqj8DBbhY861LtnQBEd
6207	payment	1693	1693	452	1	1	353	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYs9y75U4r3f8tgMJzS6nrs9VDvTZs1tXw5nAXE1r4qnYiBzTcE
6208	payment	1693	1693	322	1	1	354	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYhRpDJb7iX4UY9xnRtm2yT5fmWuv7W6NZ9Q1BjRLNjcPa5QeNg
6209	payment	1693	1693	373	1	1	355	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZVnTCTJhPBYa1BwFzhR7L2k6CH4N8cgCDtj8oc3rPfbELasYw6
6210	payment	1693	1693	408	1	1	356	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYxVcjeqMA5nRNP6mUKdYFGMToS3YZFe3hWkMhxzct7FnxeCXuo
6211	payment	1693	1693	453	1	1	357	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3HiK7sWnCAuwZEmfzAQ1QWa2ZEMD3pvp7NeiVuKUEsuoKh5ae
6212	payment	1693	1693	593	1	1	358	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZW3ufHKzuaHSZ2svDkLCbZhk4Gsyi56FmD6dLMoXiU6Y8mNRgn
6213	payment	1693	1693	91	1	1	359	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZxPDHrDtksf2hSsszkeLVCYc3RNt25wkFxJeG9XKz4pCgxKDiq
6214	payment	1693	1693	438	1	1	360	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZGsRokbxkY5GBPKJSzZiezivx4EKJCw6hcizCqnPPYHMXjhsk8
6215	payment	1693	1693	339	1	1	361	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZNmooNiDS8ihLMX3ZhSMe6LLysr47ZbYRA3xNZkpRqHWn3neVr
6232	payment	1693	1693	731	1	1	376	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvuqoHwedDtUjjS7ZQL6hE9gjFL4ZCeHXzwk2P5wpbXn2SZieV
6233	payment	1726	1726	1874	1	1	771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeWSjamSxdDdkG4RyVHMwoAkkw7sETbAKNRfPMCZB3gMyY5Va
6234	payment	1693	1693	295	1	1	377	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZcWs7ukxg1rvx9QHcn7qdAuFsBCnSa8rumwt5vMcuceWKW2kT8
6235	payment	1693	1693	551	1	1	378	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYsCreSW1Um9dQVJLqJkR1fDBGj5HyU9a9HkbwjPfYoM4WnPtcq
6236	payment	1693	1693	520	1	1	379	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaLMFMKo1W4fr62qYiRhXP4M7zLACaCUbKYiEK2afi8fPskA63q
6144	payment	1726	1726	1874	1	1	717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPW8sWp9Uu66Y8ykocdAnjgbhyjnmrbvV2GVTjT6MAzNb3BZkH
6177	payment	1726	1726	1874	1	1	749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQZYKLG3wKu3upyiWmC3EyPoFcS8hiesDBhbrKkGQ3gERsdtP
6178	payment	1726	1726	1874	1	1	750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVoQtLNaaKuW38QG2reXAoJzgcFx3DN6oxjqxzgXeZp9K3AMr
6181	payment	1726	1726	1874	1	1	753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJJzceajfSZ3bYoKopK3z9PHwHQP9BRxr2pMgGj5mV8cFN6X9
6182	payment	1726	1726	1874	1	1	754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzG95xuYnhDS92ynuoZj1hduVFqFdrREgq2wi9fvhkG49E69s
6185	payment	1643	1643	1299	1	1	5	2188768114000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRt3CqPr4Fk2T1JDeaMC2LSeooLXRgXXTxa7knLCByPYhh8iRA
6186	payment	1643	1643	1053	1	1	6	1164134907000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudL3ixQSo4u3fSEbm6jvDq7hrY9HcAtkCqoexx153Fi25qTtP
6187	payment	1643	1643	1173	1	1	7	785465018700	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVtQsZij5N8Rk5P73DX9P23hGeRBtEZzS5nFhFuyeGUWsAE7A
6188	payment	1643	1643	933	1	1	8	649631960300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEQvCmZNHkVYykYwX1a9ojFQUwviNQwJAwMUwTdXzBbdPXbMt
6189	payment	1726	1726	1874	1	1	757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRsCwdbZGc6BRgMg93pxzorBtsuvUUKZnnLh479HByaKzhQwW
6197	payment	1726	1726	1874	1	1	765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ngsNmQLtpbhNRjKrLHr1yfRVuf1h9Gvh9gBXSoSe8MK8iQty
6224	payment	1693	1693	1811	1	1	369	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYqxiYsnuTwsHJ1wRgjet2r1sE6nEot38gFwvK4CYLFz3PtxiPD
6225	payment	1693	1693	383	1	1	370	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZKoBoq5kKzG26kqWg9T46ozFDcDwKvdTvyZntPZAoxpwgP78CK
6226	payment	1693	1693	308	1	1	371	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZR3XjKvUHR1cpWwm4BKmde25uCpMefTKh866UMico13SXtvmyP
6227	payment	1693	1693	1811	1	1	372	127286667170	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZMHGZQmPZdWqUGvEuSVMDUriAQ6nFDSt5UN83w8fxoPKPAwaBf
6228	payment	1693	1693	1150	1	1	373	1184398497309	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ8iQTB5mhFZX1mRZ62bjoGEnxvuJPUtS8YKYeDS819XQo9WWVm
6229	payment	1693	1693	84	1	1	374	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ63nzERWjQLTKtyPR8Fpv1w8EzhumoWv1a9vQyUKbMRM1Eod2x
6230	payment	1693	1693	678	1	1	375	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcQL6ybTLmYj1jBtrzAEFnMn3PsdN32u5gfuF9Ch6zXQTSFSHL
6231	payment	1726	1726	1874	1	1	770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4rdExS1bDwob9wEUKfTMu53RroDLRokGLZwVjg24TQTKfRTA
6223	payment	1693	1693	89	1	1	368	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRtAq77w8DFibvMumUuo1AqrzizPtki788kgifokvhHihNQVj6
6237	payment	1693	1693	653	1	1	380	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYp5eZE3swk4Ukg9exG7jw9Hc7FnmcbAUbDdnUwWvVFEUajtZna
6238	payment	1693	1693	622	1	1	381	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaB9gGQ7KmVshdTrcwcNcP8HjGKBnJZzLEERhwWjbRzSPNeaKkh
6239	payment	1693	1693	105	1	1	382	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZFDkT71mfYPa48r5eadZ63AmBsQCvdARbjGCMZMG68bvPkeE2L
6240	payment	1693	1693	122	1	1	383	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa7GP79uNfhvdhGteEwMR5UNsbKdfhS8tzx6Nm12T3BCSwTyuoH
6241	payment	1693	1693	721	1	1	384	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZCpniYCMNgnAk2T773o5c9aSFLwpGmEVHcFcqaB28PS4Dd3bHt
6242	payment	1726	1726	1874	1	1	772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm92MJSGpWmDwuBUN8WKvb13b18DJWvBuXNyKPuT6FTQpaQHX5
6243	payment	1726	1726	1874	1	1	773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXmro22g1wHzEd33z5CwBGqvHLQPDLteN5XqQWN8N4xaHGbYN
6244	payment	1693	1693	206	1	1	385	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZvL6SV8nSa7t8yiBrtJGSLv9tyisuh9kCJH5Zt9DrrkkEzRFgE
6245	payment	1693	1693	304	1	1	386	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa2H6nGDywzzR2kxsUDDZVKkSuyB9tijfkDbkpdoY6RLdMiFM6U
6246	payment	1693	1693	399	1	1	387	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ6maCeTvZnSzLMo3wJ9MSXcsfmD8BTEPgBVeF8SXC1nuF3MDSC
6247	payment	1693	1693	194	1	1	388	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZsLCfjSLw4deT7hw8k3FhQjGzbD26HzbViDNLzUYYeoBRwAQwp
6248	payment	1693	1693	1276	1	1	389	3300431723570	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYk9qfPndAydhfXHxdPmxJqMLSiAZnAJSuvYBNb2hLvBafkhPdP
6249	payment	1693	1693	877	1	1	390	395633738066	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZB1ZdRHxfFckXPebpuoyyW2An8ZAHuKof5QwqPTTsQYXpXMtJ2
6250	payment	1693	1693	878	1	1	391	395633738066	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYiNUFHum3sLYp1oMjasikqfzTGTgAkxpVf1vCgChkYkCfKoJ46
6251	payment	1693	1693	193	1	1	392	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZZ6babxnYCQzdJJie17NvWWu8i68AuiJnsXRYnVkwzsZXukzzD
6252	payment	1693	1693	504	1	1	393	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZYYMwDFrL2KicBYxmFZavxy5x4CvMjirupjp3cJCHAcF2DLuUU
6253	payment	1693	1693	1811	1	1	394	13048597976	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZtEheNdaH2U835xt267wx6isiU1tLvtzJQ7VZZgF3Gf7v56p9x
6254	payment	1693	1693	78	1	1	395	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYQJEpFXZBQM9xxuxPUmCLtpGTScXJK4VgMU5A6xFD3kN4zPZ8o
6255	payment	1693	1693	658	1	1	396	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYXnjhpvguvvcCvMUCsGb251XR3gjzmLbfUwDQLRv3taoTzbjv8
6256	payment	1693	1693	205	1	1	397	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZAvMLzwpNmHJVg2NE4k5zKSndKYZTV9U4d4BKtosgiQAa8dEQS
6257	payment	1693	1693	660	1	1	398	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYrKxvPNNRJbMiYYMt1VTwe4DjLw9M5DRfwWhvRNi9eB1KTt8kd
6258	payment	1693	1693	745	1	1	399	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYTSiJD2Yk9Vy6KPaL8KtoMdnZnXVTVWFEdft47SLgvaXAjDL73
6259	payment	1726	1726	1874	1	1	774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn437Q1gNUvGyTUe2PWsGKWtNGkxDoncnqZQviJdtntCJcki2
6260	payment	1693	1693	29	1	1	400	13638970574	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZkcBikVus917PgLMdhbnf5eDHRXApMsohEXdR7dHfMmkrGzdfR
6261	payment	1693	1693	138	1	1	401	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZSypXfsiaK8XxjHR1vFgdHBbvyUtNdSxgsScdmnbCuMvW3NqLr
6262	payment	1693	1693	146	1	1	402	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ5EMoo25mJjniTwYVr6Q4WMT57EphtP5RfLTiCJvgBXzuspzMG
6263	payment	1693	1693	395	1	1	403	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYXy1Pxzo3LLmyuyfow1DgozBEkLvhELXraCYiFn5RNeoTe7pzt
6264	payment	1693	1693	587	1	1	404	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZzJUnoYgEbSm8a8RJXpXf7qRQYbfK3Rn9zrfBbt7r4ko5gWoy5
6265	payment	1693	1693	910	1	1	405	979576555661	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZP3JuuLD7KYefiyicsgveqnHMyLHAewXCF5vrVHRpv21fWBZvs
6266	payment	1693	1693	500	1	1	406	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZstDAJxCuGUJnXUaKmLPEcrhT7NmiUfeSdRx9YQEJueUdi7dmZ
6267	payment	1693	1693	611	1	1	407	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYS11ubAJNU3gFQiyEbN23Ub2Bf7XE1D24UjuVKvQiWPe6eW3iF
6268	payment	1693	1693	225	1	1	408	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3vRCzYaqKfyiHHEkS2kiKZXCaGvpjUcGP9ApwBxhvf2Y6kawb
6269	payment	1693	1693	377	1	1	409	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZiXdtYFXwPDKGhzMDvDTUDLZADkvhoNgXvdHaQy75JF2ahswBE
6270	payment	1693	1693	560	1	1	410	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa93WrFTmwLW4YyfLvYiYSaZTZuYK4xEYBhirKWb4yBXgbZY4gg
6271	payment	1693	1693	252	1	1	411	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYtZwMGs4Z3cnVwa8HZDdBw6RjTg7rviPPuJ5UE9iDhHraNE68a
6272	payment	1726	1726	1874	1	1	775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkNu92BXfyV3q5S2Kj6yaiemDobpsP7dpJaXcBysdkttG4Br2
6273	payment	1693	1693	390	1	1	412	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaES3u8BqXx1qCAVyPRpzq8k4a4Kqgp8vpA6LnNVAzsvqzAMVhN
6274	payment	1693	1693	108	1	1	413	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYx4hzN4KsvzAULrjLtaSQ7rjyTFnPqtFJNjGgvZYjD8PcscgPk
6275	payment	1693	1693	894	1	1	414	597821247684	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaCv8u2zJoQFZKLtKyABwFDbdM3FMXXMF1fXY7yCjUDevuTtFzo
6276	payment	1726	1726	1874	1	1	776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTSjbNKHsU24V8pBXUWfWVkeYrcvCsXUPmCgy4QgezZejUwNm
6277	payment	1693	1693	569	1	1	415	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYwvbsBZpPZb983NXmbrFdC3fdB8JNi2t1P9nCx8NcfQcs4sVwa
6278	payment	1693	1693	99	1	1	416	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvjtxyqTJUpFvXbHe4dwLC5pJjL3gBEm7R6h1ykjYktEGEw7AD
6279	payment	1693	1693	570	1	1	417	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYuQT9r9FsPHuUujCXwvyPDTA3iaDDq4mSkouHydWX19cDePf77
6280	payment	1693	1693	49	1	1	418	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcM3Xcr1J6wFvfjPatMwEXe9KUoeS6kbjDbdKw1GaEU2tuTxR5
6281	payment	1693	1693	127	1	1	419	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcqgBVC1YradbEi5NPbkNwTtkWgPp8xdWkSznxPaedA2zx3bbj
6282	payment	1693	1693	251	1	1	420	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa7PRVquPEcyVvRQPsTfa9pJBsQu7pNPCcwAQ2thEzc6BHsoi2w
6283	payment	1693	1693	35	1	1	421	37409747874	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYV11accw886sJrueBbjLNLG557fNb9pMvayBRouqBqQL7BW6Qe
6284	payment	1726	1726	1874	1	1	777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1ZC9cmhRKZCTBccXtnCbtWXzWTHfJSQ54PjWkuL86MgaKQHL
6285	payment	1693	1693	320	1	1	422	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZBErGHyMaM5rjJ5p9kXvPqpdvJXwc6fMHMVksM9ZGbEEHmneFM
6286	payment	1693	1693	1030	1	1	423	1755392794775	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZPtpxtKrjHtCdVsQn6cJeZ3qjcxET4gCRmjC4DXqetfpr6vrgm
6287	payment	1693	1693	663	1	1	424	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZA1erfX4WfPXAr9moj4ZmZcC4JuJVWUXV2JK6RMymV6q2XY85H
6288	payment	1693	1693	499	1	1	425	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYzJQwLN5RUVvKHKaF2EeNNAwA98tvGBHeSomPQUUtNEgogu8xz
6289	payment	1693	1693	54	1	1	426	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRYE3jqczNjkhTksFg7xAAjn2b3RQBRufb2DH8mWiN1mhHmDas
6290	delegation	1740	1740	1899	1	1	4	\N	25000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz4dv58k61sGjwJfHtyPCtkPtfyhH1ePSbrEyUasTHi26eWoA
6291	payment	1726	1726	1874	1	1	778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVCFsaJsebsfY8V6hgM7Dc1HfTVb7Zyp8QpsY8zBgvdJUq9gY
6292	payment	1769	1769	1900	1	1	18	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKK4cVVRco6Rxj7sDsjbeaA8UHzWWQtwxfndT3VmGfK3xcnmH
6293	payment	1693	1693	710	1	1	427	9742121833	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZuUbf3iy4hBZJGwnesZoEPkqTkqBs7fvhgUPKfMa1dXpmaVRbX
6294	payment	1693	1693	1811	1	1	428	19484243671	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZXXGsKk4k1DuXsfD1zWNPXhfK529GT7ox7f8uBFXbS4We4UFyT
6295	payment	1693	1693	217	1	1	429	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ4GDMrz9BuxvPwBUmYomzx3Ma364NPXJ3VPen6JGodPE1C9eA1
6296	payment	1693	1693	103	1	1	430	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYnQkvRD3vXMojCBzGQzgw8MiDjZHn9HhWdpduKERaC1CzW8Ujp
6297	payment	1693	1693	534	1	1	431	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYiR442FfRD5yFQYLgR9XKjwi4L9xMSSUaecTT8y7yk32wnmJPq
6298	payment	1693	1693	245	1	1	432	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZLMfhTRTwKJCzrntJ9VRpdzVigZPKzs1iRN1Zs1u2fEnjq3E2U
6299	payment	1693	1693	421	1	1	433	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3vNaLs6Mq3w3gf1ogCxtQW2ZHLHBK8D6ezA3QHCCXegPpKQHv
6300	payment	1693	1693	620	1	1	434	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYfJeDTQE9qm4xZPUtmeDXodaTP5osNxCmaT5JxZv4XaBUaDysk
6301	payment	1693	1693	352	1	1	435	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYmJN2S3evCRm47ZAGxZwYQHURRhpBZn3sPBof8MrUSALVWF7Ku
6302	payment	1693	1693	691	1	1	436	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZz9WdchF5Yv9qiCvZjk3VYFxpAsTFpfWshobTgDpVFhFZ3KCAC
6303	payment	1693	1693	191	1	1	437	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ6SZERpsKJfmGppv3Hju8ihmZj2drkBamrEx9gqvQ9h95Kv6tN
6304	payment	1693	1693	266	1	1	438	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZnGz6bT8ckTbBSHyJNbAKByf2v1T4rb8KLMu8aBRtYFF3t4FbS
6305	payment	1693	1693	353	1	1	439	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZP5ZrQsTSqmKESBPPDHGEXFN6AWaYNfUTH9GTjDva4M2RAaPRj
6306	payment	1693	1693	600	1	1	440	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvLSUm3qdJkEugiAeDvzvHyZzDtUqPMvttVEavTFwzkmnBxjZt
6307	payment	1693	1693	420	1	1	441	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZPeh4K4BtKS3aJqcZkRqnYKpURbZiN1iRwx71kpXmQN4fCRDiT
6308	payment	1693	1693	893	1	1	442	597821247684	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZSnHWRb4noFmxt1WiCaR9UvCjVr6yCzUh2bBxvQbYswpLg4Egm
6309	payment	1693	1693	180	1	1	443	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRe8VHJr19XFfegVMshGTW8GFUKZymSux3V8VLC3ujCT28Vhpq
6310	payment	1693	1693	112	1	1	444	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYqReNgZFRC6D9vVveswZa8jJ8JpKdwT1FjA9FwMUnLUje54FoD
6311	payment	1693	1693	106	1	1	445	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZU8etbF1aopgwnqr33xMHFdGQcg1Jt5kYC3Z2PNwLNpJqVA73S
6312	payment	1693	1693	1811	1	1	446	63436800585	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZJAmA9KNtLPJRVhte1W2KnzHxnN6PrGp2wAf94jaDCoXpQ9HpS
6313	payment	1693	1693	652	1	1	447	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYhuiDwXe7bJR8KwrkUMHSi45nmGD6rZRrFoC47nyLUo9pZ4tu9
6314	payment	1693	1693	397	1	1	448	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYnWT6St2MsrXfQd8NjFQcrBHj5xBy8jpuVLsKnm7i5pe1pSpo5
6315	payment	1693	1693	391	1	1	449	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ2SC8qJ496ZyZMpRmSKA51ChsFJiGg6DEEwHgADEdv5EtA2mmB
6316	payment	1693	1693	201	1	1	450	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZJ6SPTtk8R6nkMvegQWNqCympqcaNHx2DTYpJzyR9mov1vjij9
6317	payment	1726	1726	1874	1	1	779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NPLuPRGKzkVy1GUbWZwtX4FwWF5omefM9AwBLbkEP939kt8s
6318	payment	1693	1693	261	1	1	451	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa6K4U5Px7YLf9dEYXq66WWK6S7HBZvAy3hLEHFbg35w5Nq8DSE
6322	payment	1726	1726	1874	1	1	783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbftNNUyLu8MavztNFgcZkbGLo4pxTa6cXxpBSgh1WoyQjTPF
6329	payment	1726	1726	1874	1	1	790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHfRbetXKmAbBPnPg1WQXr88YGSd8Ugq53y4u3bG4ZvpCA3n5
6330	payment	1693	1693	402	1	1	452	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpZTR55SJZGaeEK15PoJons8QSrpjCCcAq98jZDUTo3S2cLR6cT9
6331	payment	1726	1726	1874	1	1	791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMp9MtthMfvDY3xYfQE5s5QxfXuX33C7Fp5vznTrtCo5mDcRx
6338	payment	1726	1726	1874	1	1	794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJd5V7ZiDXfEwjBvLD2NVn3uwCvHC4rmcvFsCnfLS2r7QDit9
6339	payment	1611	1611	554	1	1	0	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3TVfyNavQ1EPtYncZL7areWKjNxrKg5JrUxCq3YjdmD7omyd
6343	payment	1726	1726	1874	1	1	798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7QNQB2XZ4jQvTEmEAxNeMbughmh3P4LT1nRSn7ntiLqJRrab
6362	payment	1726	1726	1874	1	1	815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFq88HhPBjsQg1WTW4dUek8xf2W3xTCcshRNKvidTZ9AYHMf3a
6363	payment	1726	1726	1874	1	1	816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNZzGhiZDfJctYZnh8RyAHr8HdyHVcWNupRCohQPyVXuDTfLj
6364	payment	1726	1726	1874	1	1	817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPXErBTQS64i63aQeqwmY1xXRynvQfFtiQL4Buun75dWtKRD3
6373	payment	1726	1726	1874	1	1	824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1HBsM6fSc2WyYpUDveB5xXGf4KnBejYb4PcrbUnZo3ianwHe
6374	payment	1726	1726	1874	1	1	825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmh6V8fVvnCvvpgYCWGGAyVANxKqSryTjk8yMAkDzbKNTi4Ag
6375	payment	1726	1726	1874	1	1	826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRdX4ByjMij2qzoMsMsUZzUKxFSrkBEizRYJHcaAG8EvwzVfW
6380	payment	1726	1726	1874	1	1	831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3m3hQbojRCPH31HK99QavMY2C78pbRX4A9VK6UYY43ynZ3Jx
6384	payment	1726	1726	1874	1	1	835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYcQPT6p2kJ1aXuCxLRSNYjfmikw1pJKCa6u5Cs4tviJZ7oyp
6388	payment	1726	1726	1874	1	1	838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzPNA5Pipss37bq6GhwmN84PgaZKfb5NYBmvfXtFrkF9Bhakz
6395	payment	1726	1726	1874	1	1	845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVZKn65C5D9W4KvuBBeS95mYPhqSXnafMS6jc2CoQCuFCMA8v
6396	payment	1726	1726	1874	1	1	846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuoxUrbBQEfYRXSERonrFW9vTc4V4xaFKeCS7zDsDXan3tTG8
6399	payment	1522	1522	1898	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZP4RXN3ezJptwupd98o1MeDcycgCe9ZpEan7e2JW415iHHUq
6400	payment	1726	1726	1874	1	1	849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZms2YGBxcGAGMn8LJY9dRzZx5grYT6DLb2KFQWLcD4yuHw2oBW
6401	payment	1726	1726	1874	1	1	850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL6ExugasW32wx7FvzZaMmMxMuxxjJJZLpJHvmrJKRp18arxP
6410	payment	1726	1726	1874	1	1	859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKMkLgqrFEM6h93ckGDSRnC6wuB4qyQdmDpcwEDVspH2wbkyg
6412	payment	1726	1726	1874	1	1	861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwww66UuvjsWfKpE8ARpTAQngEahBGs1cmFuQYr3ZGf1Dq6RQ
6413	payment	1726	1726	1874	1	1	862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KEpyYYDnrsEPBAdNi4AYyvYQPSAfvop2LNwd5uPuVhxKySPR
6417	payment	1726	1726	1874	1	1	866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFR51cxgXURNMrxAnQAW9RP4ABbh6x8JbgAnuZYDar26kpsjF1
6418	delegation	1900	1900	1540	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6B2z8QMKZePjUGsspUVav5pHDSz86BEdw9YMHKHGacZoGLVF
6419	payment	1726	1726	1874	1	1	867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GUQVYnnQSmWL7H3bFYyGGXuBAbXMRdxnXBUeRzJFkaKKW54t
6423	payment	1726	1726	1874	1	1	870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vhJNV8Wf1oe9j22QHRJdtnwjaho4gqFxWJtRmjiiLgcSxgs1
6424	payment	1726	1726	1874	1	1	871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYUwefibrzkWdgHanXiX8cxaQtsUm213BoLKBbJUhQjUpbhjR
6427	payment	1726	1726	1874	1	1	874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE53AzsWBPTWi4GiHQntaeybCoWjLWFVmnTeamYK6rjt9piFwG
6428	payment	1726	1726	1874	1	1	875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcn25T4XHJUAohbhS67ZatRd4iaPth6c8gQnTGWQjSUK3N5uvj
6433	delegation	1900	1900	1403	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3kUvG62pu74eUjgmEC9YSMpi2PQarGaX1TBDuUpHDEkWwNrN
6319	payment	1726	1726	1874	1	1	780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrLpTDBgMzqgAQtGTrjFNAqa5dcEwn52bswYueyXBzgy4dnQb
6326	payment	1726	1726	1874	1	1	787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8j6mYQfSZkLQEn9dnecwsDfPTwo8Pj69qmc6YrYNFRAvY97Zz
6327	payment	1726	1726	1874	1	1	788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmntXT44kxDimFcYruv2dWeUMz8esVp8J7P9kETqveMemssMUK
6344	payment	1726	1726	1874	1	1	799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZuvDtoB1pjCSPWZ23eUiLxny3a1nbfrTcLjWgd6wRXDDeAyf
6345	payment	1726	1726	1874	1	1	800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TtDYxvExxLZgPDZ2ZEp8MZw8AuNBeYaEKqrWAQMNo2kU1u86
6346	payment	1726	1726	1901	1	1	801	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKYwnvPHw7QQsVKxTTXZTDkMGrbN3bPf2Vs2H19Y9sWCKVz4fK
6347	payment	1726	1726	1902	1	1	802	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmMLuDWPMrasZ5jiA8WLbPEKbHF5x1ykt1YAciMb8FYiMKEr27
6348	payment	1726	1726	1874	1	1	803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhp1yv8cfCXrpkJfTCQik9s48zNJcVvNDACgDqjcE14tuaihwt
6349	payment	1726	1726	1874	1	1	804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQtJ6GVE93XiE5w2Em2xsfGQSqLV2tHqeefH8SCv1hLJPBbDL
6350	payment	1726	1726	1874	1	1	805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4AeDjTGXotvRhxvMvTsLJjmdtbepZ1RiE7MJsni7wY7qoBbm
6351	payment	1726	1726	1874	1	1	806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFX4UF6bmcvYJfidQtin5zeDnuD5gBcMoGhAh7JsA9VBFx1zDe
6359	payment	1726	1726	1874	1	1	813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCsvpZjzVvkzzFNzu2Gm9fq7BvypgteVuMfLNe9PqxLdwJXhf
6360	payment	1726	1726	1874	1	1	814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwq1wPksD2BAcdFNgq88yJLLo9u3Q4WqSVfso3F9WBYPSY635M
6361	payment	1596	1596	1903	1	1	1	99000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2vMGZY859s9Mz44tH7vwgs4i72tKgycRL6mkf2Yonh7GTsQX
6371	payment	1726	1726	1874	1	1	822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGfVdGTGLoHjWMn856FiyrZgseTxoKa5Tfqs43cYpRufhxqeR
6376	payment	1726	1726	1874	1	1	827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoSS9qmy9eFALChZw9UwEwTM3mdN3EtJQH66pbeuNGGHaVaNf7
6377	payment	1726	1726	1874	1	1	828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLeLnUiZRHsM1JMf5RfoKi9CAGq2EmAZrgaRGtU78ceMN6Lv4
6378	payment	1726	1726	1874	1	1	829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBcSh9jmA3yFroRCi2MqGzkuHvMg2eiCzJknzP912FRZLmmfM
6386	payment	1522	1522	1898	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbhbDeTduruNr4vxhrRAhWnJZufaEcyvsFRsNG6XgcvEb2xh9
6387	payment	1726	1726	1874	1	1	837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBURrZHxM9GZWVihyPotjLYSLmn9x5nPdEmmWP5CZhJHQQAhpN
6390	payment	1726	1726	1874	1	1	840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GJHvHzHz15HWHxFvp3Avmu7gHuh4o6qKf3Mh9KsJhec5bkVL
6393	payment	1726	1726	1874	1	1	843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDepVF5AqYDBM3sqyuhLKWv19HxFBjdFH9mvmemKrc3MYkHdJN
6394	payment	1726	1726	1874	1	1	844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWaroixUCTX2MSHazBCfwfHVw7KyQdZzhKZS5cJyYV6jgvxEZ
6397	payment	1726	1726	1874	1	1	847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaV3Yn4cVAG7A3moRJdkCY4prCKuUNVQtH7PLGtAWKpTnA3syd
6398	payment	1726	1726	1874	1	1	848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F2CfGzviNhpR713XQ5nS1a44jvXkDTgQQKgaNGQcukGNAAag
6404	payment	1726	1726	1874	1	1	853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudmzQBUXyNjLD6K93dQfEpZU9p28vWErP3v1nhqoeppZ6FKYt
6405	payment	1726	1726	1874	1	1	854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ucpVARRT9VNyUfPCV7VaLNksACBwtn8qhQxLzcsVPFZtDp88
6406	payment	1726	1726	1874	1	1	855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFnJSd7c73wABsp4QTnv4ygr3Mfm8iWHYNAxdqRvv8Cnzen4K
6407	payment	1726	1726	1874	1	1	856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZEKSwFMJQ3DsYdGapBjmo5V6mTD66R9ASELQBoodjnY31oxp
6415	payment	1726	1726	1874	1	1	864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUMmPt3zPnPtfYaUMEkyuiSPBLntGLP6TUNWWUYusV87E9n4v
6416	payment	1726	1726	1874	1	1	865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4ZpNqLh6DXs9rNNiWB22bSn2pwCzo2hRY9rXjs7o3ozvjqff
6420	payment	1726	1726	1874	1	1	868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG4oh4QHtdc39tJz59kgFekvXhVi9EKmfs1NkMu6ZduJ9rRjx
6421	payment	1726	1726	1874	1	1	869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8L6KY5Ah3PZCmPFufiXZdLC3VekFxPwVKf613RCvNSRPXN3gM
6422	delegation	1900	1900	1540	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAVDiBskpMHwUikLcVh1wCQ26hjFfy8xUZyXtj442N9xbNgFc
6439	payment	1726	1726	1874	1	1	884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AeUKqt3RtJhP4Tv4n3WMsqsoXBThoPMJ88RmqjiiwjYXf2iN
6449	payment	1726	1726	1874	1	1	893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZoAyjHpd7pe8RG8Z7teY1biYWGfRnVnL5khykzGXXC84xRXV6
6450	payment	1726	1726	1874	1	1	894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXectmpqYBnm2fBhfvU9zxKCbuVSDMGJDCtmQTCYp22TJP7Ft
6451	payment	1726	1726	1874	1	1	895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwLzFsbp6mjBkXM8FUN3bhfn3DijF2cP35sfnpxXqxUBdXG6
6320	payment	1726	1726	1874	1	1	781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcd8AraNqVKFoFNbAfYJTkdc8GfibucLgoa5qz6V9MUoqfj13
6323	payment	1726	1726	1874	1	1	784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTDkQJeYLaf1gbeuTg3VtKhPyBGXAu7auRZanCyQssZQoL7u7
6328	payment	1726	1726	1874	1	1	789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fv6z2UEBNukxeRnM3JZnUTgyjav9YCYRwfLiqUzqxSH96pux
6332	payment	1726	1726	1874	1	1	792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4HynsWhzjB6RcWA1A31nE7gWtQLvRbj6X5RYhMyJWyEykMvB
6333	payment	1693	1693	163	1	1	453	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	Ckpa2XLzEMNEwnUtfvLaCB8M8sr8UJ5ejcz4VYWBfEjFTeRFW81m3
6334	payment	1693	1693	82	1	1	454	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpYvzCbdsWmuufXf5BsisTMBYfqPwC5YeoaHu1qh4ydP89M1DKA6
6335	payment	1693	1693	275	1	1	455	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpYVC1XtZxQHXBNhGeDRDkqLxLZeQCRAdEaTtDgrfh6ayjtP45G5
6336	payment	1693	1693	361	1	1	456	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpZ1RFykRZqPTFMEgAGQwTj1ZPWa4V5cXvvXbgPzXrDKPzZE7NjY
6337	payment	1726	1726	1874	1	1	793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrojYgJTFiByDzDGKymWuiEcHFbfMVtqU8A4tZPGuHhPT5Nqxj
6340	payment	1726	1726	1874	1	1	795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QdieZ6hBTQ3XeCNNGDJX9RffMARPPdZ6iJTxLNR6k7bZCqDr
6341	payment	1726	1726	1874	1	1	796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZaeuenB3sTM4WGLyeWBCW3AGKAw7mqhXnM7gWotfm1x2VQSp
6342	payment	1726	1726	1874	1	1	797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnYZsLnimiRPovhJ28EMo6sRZ4y5Q9y4Uo86Cq1rcY7Q7hkfu
6352	payment	1726	1726	1874	1	1	807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1rG2ZnQ7LQZCNNUb57AJrDHMR4qnkwqrRWbSmQmCRmixxmJF
6356	payment	1726	1726	1874	1	1	810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRt6pN537fGMWy1oepxVzUXU3eRqgmmbWF5mrpDfvk75bv9EU9
6357	payment	1726	1726	1874	1	1	811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYiqVWGEVMn3kFUhMybiUNQF5ztsbHFAFAfMS75yQaef81HSBR
6366	payment	1596	1596	1903	1	1	2	99000000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW1f53e2pBNLLdY1Fj42cwSSHB3bg4Rhxu4LrdmKa9fdA3kzz
6367	payment	1726	1726	1874	1	1	819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgzzqZUb95ot4x4LJDiL2Td89WSUurd1ccwKM6Bb51qgUSgp9
6368	delegation	1769	1769	44	1	1	19	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2UtJSyq8MjhY33iDRuwLFb4xt1wTSi9nJJezEBeVCvLPq4QZ
6372	payment	1726	1726	1874	1	1	823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8BDo1JZ525CAcMN2XrrLP13nfgJ1P36bacP6r4nYr4FhajRD
6379	payment	1726	1726	1874	1	1	830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJqLuZA5xTJqzzuRYaH1AUbMCnk3cYWcbtDG6dwRyV2sy8gqY
6381	payment	1726	1726	1874	1	1	832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH95h4CChPTgPVM3RmBvA59aFcFmLdZHHy8jTtud45Rf9q2Ww1
6382	payment	1726	1726	1874	1	1	833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc1oTyDGMQgCdQCsrJfdya3KQzUZMdv64oBLh3xQyGtWsbbtN
6385	payment	1726	1726	1874	1	1	836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQn65oaMVQEFmG454LEzPKSeQiSpW3K4ZxiCaWpTtmU1Db4Zix
6391	payment	1726	1726	1874	1	1	841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssoYS2d3exL4oeFsQK1RBtGbYcPWfW4oywF4jqhN3RwiwVafJ
6403	payment	1726	1726	1874	1	1	852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyyGLb3BXf16iYCbnxTy5RV1u71LW3WePJsN8o9CPfY1vtvYu
6408	payment	1726	1726	1874	1	1	857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikpfhLczGWtaFGD7wN2TvrtwzZvm6QkpsbUBZygcdRkFdS42T
6411	payment	1726	1726	1874	1	1	860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRS29PWaZ7igjYkfhrPk6RJ9tXUwYAPjbxV9F5WSTmXkd1HeC1
6425	payment	1726	1726	1874	1	1	872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWZGsC2FbcQ8SXJizerRpL3bt9xpEFRRLLm8qtajJXcgU89ns
6426	payment	1726	1726	1874	1	1	873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeXG8AiiEizFSW98bt7Lyr17jsMyHBGvrK2RFDBpN3RRUEhMZ
6429	delegation	1900	1900	1406	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpG8zj5BnsWZoW73B5J9Tv4cdDT8NjhGRJZwbBBKD8mZEYbY3
6430	payment	1726	1726	1874	1	1	876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9heuYEC8DfyhJEtVRTLAYR6BwWuTPGYG9V78bUXapr93qV54d
6435	payment	1726	1726	1874	1	1	880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS17FLoiLTkyXg2QCKBPL1goqyaZTwYzdWBmxfpgc2MeZ95xf5
6440	payment	1726	1726	1874	1	1	885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR48it15UhGYjX42p1B7G3VvymPZXo1JV5mtn28hhRPRjQSwXQ
6443	payment	1726	1726	1874	1	1	888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWc7d2nWWBA4ojxboPeXHYuJ9hGmXciL7CeN3WV1PzVLy1Mj9
6444	payment	1726	1726	1874	1	1	889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRAVcR6gQ7MZ7xzQPmev2uukqWpNVLeq8cABmT4cXYgDepffY
6453	delegation	1876	1876	1540	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QAyH5Vnjr9oq9xqAcjtWbC4o2qQkVbzsiZJPnGgpn1Cy2udt
6462	payment	1726	1726	1874	1	1	904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhh623Z2C2GfiYDo6YaphshALfeDEhfN6pwP1fWQ519TR7Q9X2
6472	payment	1726	1726	1874	1	1	912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NrbzG3qeV4h7SgppLdgFjVadFLs5MHpLfFLtDnpnE7KHgsJZ
6321	payment	1726	1726	1874	1	1	782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJB6URJa2Ag47hcqXWimiRLHga94UFTnTLkg9wL4xHJ9wQrqo5
6324	payment	1726	1726	1874	1	1	785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGJKrdVSEJXLzJyma3WLcyUZbwvEyA51iUzj5hQGXqmj952df
6325	payment	1726	1726	1874	1	1	786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3Wv39u5v2oUSww2oaj62owCP6ptf6n6HfSceQCKkXkBjK27c
6353	payment	1623	1623	1816	1	1	0	0	10000000	\N	E4Ynu7seRhW9HjkcbmwLcNBLtM5vHKHKysDNjXZ4e5uaCZUxKMuvd	CkpZLKv4WLHTwRKLwZcaFdVzrfCXnSofZTroT6Y353np1X4MAJ4ed
6354	payment	1726	1726	1874	1	1	808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPid4Na4a33vbZbtN63GMf3BC5RrLT2dVKjrbovYnY9MgxwUhD
6355	payment	1726	1726	1874	1	1	809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisqvU1T6Vf5K3d7nypxMJWTJ67iBiMTEwTpuTR668p13P8Ppd
6358	payment	1726	1726	1874	1	1	812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuh3Z8y2inh8TXE1bCNt5ept7S4hDD6XVfAM2jGPfM2dZzN7iH
6365	payment	1726	1726	1874	1	1	818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rm19PSrHFfocLNvkWPDmtLLkH7TmJXsGPubXjCFbZZfBsNV8
6369	payment	1726	1726	1874	1	1	820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeednv3qAoZxrb3WCynF47Z4d47kX6cTVzcpBnf5uqa4XrzVxV
6370	payment	1726	1726	1874	1	1	821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW64GU8v32yY311fELYwUMiKrBTkA2E5ssuo46d8VoMMZtsvoD
6383	payment	1726	1726	1874	1	1	834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGWapeVvoZNA96s58sjmv3GYLejAY2QzMqEjxABLoHEJD5a1K
6389	payment	1726	1726	1874	1	1	839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdRJqQmfuBhiaDHYEpvCZEkwoPqnB9mHNy2oV1b9379bwL8fc
6392	payment	1726	1726	1874	1	1	842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYtgyd3tyjsfmmBmomKnyWqe58qsg9fVX2DNRbSuiamGKTfzV
6402	payment	1726	1726	1874	1	1	851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJ4APdfyShsyBLTUbqspDSAVn2T6TUyr3MPQBzgQp3ZhAm1JG
6409	payment	1726	1726	1874	1	1	858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrSdnbdGan63nfdfX9SJKm75aQpgcxYcfB7M8JKfqtzbNFcUQ
6414	payment	1726	1726	1874	1	1	863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmGQ3rSnjLm98jQkdLgZ6kcpzcjSjajtJGA3suZZmd2du9FWx
6431	payment	1726	1726	1874	1	1	877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69i8w4Jbz12PB6PVNTLzRLBtaq1rFL2gXVB4iTiSTPQubs2ee
6432	payment	1726	1726	1874	1	1	878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4BPem6d8o71gwFQgTLqSsvJxHvbH1irEiuoPcn9HhLP9dPAE
6436	payment	1726	1726	1874	1	1	881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa735uXNgRsWqujmxM76FTqQ4irVPCer2nTwsNBxvMFpn2RE8gC
6437	payment	1726	1726	1874	1	1	882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERUEUfVdhr78JGsMoA124W4iJakdu5acjhr42b4Anf2PeULqa
6438	payment	1726	1726	1874	1	1	883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKeJrksUs6MU7NTPoNWpWPixiSJvCuX4xyapFDjUYpD3o46AzQ
6441	payment	1726	1726	1874	1	1	886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7o5WKJtVj5vABXppUquKwd7zmBZugBM3psEAwA6FMCXLzaGpc
6442	payment	1726	1726	1874	1	1	887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4fDVdrPq1d9rVt5q4eYnar1zuW6uS7bRnKqq7pQUV4gsnhnu
6445	payment	1596	1596	321	1	1	3	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZnUoGMCKnUm81cr2qMMBR6kzeKHQN1fdC1Vc1LsJEKykYvFb
6446	payment	1726	1726	1874	1	1	890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBMBXJK9P5FL8Aes3HmQ47cBK46deJucjyE43NRZfPcTc1fLo
6448	payment	1726	1726	1874	1	1	892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozgF2vVw5rJkA2NgvPKUzU8cScW5vnBr3CPReiwcXucJhaWY3
6454	payment	1726	1726	1874	1	1	896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEdENHyWZdkr83Kpz7EbwRKV34vR6sG8zCAk6kgTpv32zDRHW
6461	payment	1726	1726	1874	1	1	903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6SwC6VzDyWo6mwszFLjTWLjzdWx7vMUP4XTznHbX7yN3D7Nj
6465	payment	1726	1726	1874	1	1	907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQxRUzXWewUXZkaM2XygYVosEaQtM1VoQjwLnv1CQnhedPrmp
6466	payment	1900	1900	1900	1	1	4	10000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpZUYm1mQiTyn8kdr9q5nGJrCEjenEeGUs5fYDm6o2LJn1hQUuej
6467	payment	1726	1726	1874	1	1	908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKumxZi5F4bGmS8mNQ2XkFiQLNVXCLMh14f4HV7KCixaDnrdg
6471	payment	1726	1726	1874	1	1	911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wSnbiEmnkaD4zTwVX79YeAdAsHvacHex7JEFg2HU3E4S65SF
6477	payment	1726	1726	1874	1	1	917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB52bEUoHgxaDiWQjGcGmMk1LtBN1CpEcD1gYYfU4h5Lsohmqs
6478	payment	1726	1726	1874	1	1	918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAbom7tqb13W5i1BVbpYgHxi8HFuUKGTr7sLAAJh6zMeUgZ5K
6480	payment	1726	1726	1874	1	1	920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeRQSDUZbYCaf84n1YPpexBF3UD7rAwUtrVuCfimCQ4pZCu79
6482	payment	1726	1726	1874	1	1	922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a76C6EXGeid6HYgbyKtrQD4WC4894YfrCPr9AtE5HZPwJr6b
6483	payment	1726	1726	1874	1	1	923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9c5M7zp9rrmVHZpbFoCAwby9xpVTe614JJcugfuvoKowtE1tq
6491	payment	1726	1726	1874	1	1	931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLE9bkNKmnoJ2ZWc21qS8wcmPS934bLWp6Ncw6W23b8E8zF8hh
6434	payment	1726	1726	1874	1	1	879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYreCAcSK9XiqvHXb229vfPYHyBZ7HHadV8C2ZPszgSUR3KHs7W
6447	payment	1726	1726	1874	1	1	891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cBgWjijWb5Ve641LVmfVLTPaJhCKMWikxzfgTjYNdFiGwqLM
6456	payment	1726	1726	1874	1	1	898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYuk2xAmb8mwTL2wd2WzNsSa3QT7tbbpqt4hLfexqdkToEKnM
6460	payment	1726	1726	1874	1	1	902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpdENzzUEkfzfJsPA5jp98NeoWGk54ELPxsesMmgfy9qMDXwX
6463	payment	1726	1726	1874	1	1	905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tKyHdXTuZS1ri34dWxZ3ico9e2hQMD4aXDWKnM8UQzdtwwDP
6464	payment	1726	1726	1874	1	1	906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoEZ2vVNQhhAJA3RXkrjQDvgLbvNE4UsyZzMphKGjxBgWbWAz
6468	payment	1726	1726	1874	1	1	909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSZ97oG8o56rXE82P6GiFS5KPUdHuw8GqwC1xid6jGBDDytXx
6470	payment	1726	1726	1874	1	1	910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSziQbfnRnL2m6F1fqrRvCFTaQw1nfydpVJsgeCUMFnTJJ5ZMF
6473	payment	1726	1726	1874	1	1	913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZLWWpbQKxKzNDmRzTkmyW8uydYxcN2Ntfeg14QPRcvNsMioD
6476	payment	1726	1726	1874	1	1	916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENAyDV9SrPyfx8xQKPuBNJNKnD9kPyEs1ZZeSvpQ33AjSAo5L
6485	payment	1726	1726	1874	1	1	925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sV5RxDFbC9mkCwW7sakF1pVikNCyQrkvW9Huqr7rsZY6yqtc
6486	payment	1726	1726	1874	1	1	926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VKjEy3dQkoBChAy8hPSh4isGKdnhW2dCANvyLdajet4gmPQ7
6489	payment	1726	1726	1874	1	1	929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W6KTsAMn7LsMp5xCECHKbLeWsHkPGt3Vkj7kSnLeEVXDeSU7
6493	payment	1726	1726	1874	1	1	933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWJ2kX4Z3cTU4uGTbHGgHPouraz25PJAm6X12bQXWCuyndybq
6501	payment	1726	1726	1874	1	1	941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpURVMnk4PCvLdrxfxfi66PntrdfAPRJaBgQdXvUmhSqvy8Z3Y
6503	payment	1726	1726	1874	1	1	942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRdAoJjCE5UdVLyZCKAML6GECLMaRZfRin3xP2kFpc3ouTgH2
6504	payment	1726	1726	1874	1	1	943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHed1xxEtYfMrtRBUR7zX7qVvXfiyhr2BpRvih7DAZJH4PwjS
6505	payment	1726	1726	1874	1	1	944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mUSDYcSNUTV43ZvBTupro7BvMkxkiUPgMyj46mXemXKXdFmf
6506	payment	1726	1726	1874	1	1	945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbvEXgEo48hWErv2Y4pc7MvgspEcsKQMuJY51LvRUpd6zgSSs
6507	payment	1726	1726	1905	1	1	946	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvUMvtBxYuewt9sbJyYckiLDQPAgUmwGmfnJXKGoNw1UWdG8AR
6508	payment	1726	1726	1906	1	1	947	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCMpKRrMSaRnC4EAvfzNiVkJmLxy9R8kGvEGBoVpPr1tY8G7Nt
6509	payment	1726	1726	1874	1	1	948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBxziP6Mq55DrM2vKWSmdYcAcJeZborGCtuU5tG1tWxKhDz5m
6521	payment	1726	1726	1874	1	1	959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSfgXNGVkBgjPQV4V7unpmMCvG5azE2k3Zf6Rxkiidt83g8Ni
6552	payment	1726	1726	1874	1	1	987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBKuTL8Pi6iYkzpMhky6Rh44BEWwbnMXPFU7oNxgFudiywkT8
6554	payment	1773	1773	182	1	1	12	106567337664	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYTuMS3d7fkbGvLq2qJ8YutzT7smz2xfbQp54asKtSETJ2bj1Cn
6555	payment	1726	1726	1874	1	1	989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrWrx3exWdkgvJVPL1DaZ2aWpvkktyjcMu6AEHwD389R9hVTt
6556	payment	1480	1480	1910	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZBqYTrPQD17fzBw3H1avUuptcvy8t3TJNBtPHfbVfjkLNvi5
6557	payment	1726	1726	1874	1	1	990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUdZwTse83cmUmDooY2Ekj14bZ31QL5WNVLs1hF4gB2NaiNPc
6558	payment	1773	1773	702	1	1	13	71044891779	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZtW71Q8KVB778Tqrq28QoVo6RYNZ1oGZD6UzKiGb9nu6LytHgr
6559	payment	1773	1773	927	1	1	14	811162142739	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaBJqKfrqg2RMw4qxEtcJmE1FyHA7aGbVEUQanRb1NoAjLhpqMU
6560	payment	1773	1773	1047	1	1	15	1453595609754	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZNmtV542akF56tvthXnu9yZfmru4h8okyP1YyAoiz2Adhq161b
6561	payment	1773	1773	1167	1	1	16	980769922839	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYXBKiiYzCDK6vCnFs5wapoC9G148Ni9R4GybxZi2YCB2q7fvJC
6562	payment	1773	1773	1293	1	1	17	2733002595198	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ4ttBnSf7UJyJDtHNNqXG1c8iZGPtBS2Yiwe4NuoimqhaaWBSi
6566	payment	1726	1726	1874	1	1	994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9KHGyv2LAaHq6G7UMCajTFYaFS3St8pWjxhgWk5NNA5RsedF
6574	payment	1726	1726	1874	1	1	1001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCgv958cFwhaL5ukzd1oSfRhM2yeuf2eRoNanAEM2N5xT694F
6575	payment	1726	1726	1874	1	1	1002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZje7129Ke7BQToDnn2D6TEURopomCPpm8sTxq47rRKuZdA5KmF
6578	payment	1726	1726	1874	1	1	1005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xeHkwo42gMb9j3TMmrQ5SnkNB59NRth52oxiuACmstZXjRux
6583	payment	877	877	1483	1	1	2	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYaQUDsDozhZJvgJQYPaaRTAvTMm2sf5zX4uzmBMsdTvo2p42oR
6452	payment	1596	1596	1864	1	1	4	222000000000	5000000	\N	E4Ynu7seRhW9EkUbhuGwjptDMWn7o67ccYCoXfEwJygfeswKpssjC	CkpYayW6aWQ28ZaNbpjcGy6AsEXc2KMKacD9tffLf6xhhasuW9kkw
6455	payment	1726	1726	1874	1	1	897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz57xYjsQvdbSFW3kW34jeVr9XdzQrqpSRdp6tu4AvQGE8sL4U
6457	payment	1726	1726	1874	1	1	899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25d5BqtrrTm73VVHLqRPMcotCxjkWfsL6BR8X4qhGmn21L9dc
6458	payment	1726	1726	1874	1	1	900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmH1PGf5GhSGT5PbkF6memVVJ3YHwzxQKxVruSJVY93aNFDja
6459	payment	1726	1726	1874	1	1	901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gd8Wh5tsVQs7uLK2dvA8TPzTnvRoDVZZaZzwX52cKvPA1sfk
6469	payment	1900	1900	1900	1	1	5	1000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpZVo1LJ5ZG57VKVv826PJJi4ZmzA7bDEEuwN9ZY4WLZvt8wEaQf
6481	payment	1726	1726	1874	1	1	921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2tqTkqRKDKwuLCbS9KWfA7iy6QVoHtQWUUUWP5nQFppjC1uB
6490	payment	1726	1726	1874	1	1	930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZRUcA5ZNnceBQ6SdniG7VjrQPkeJgVJFyVD7tHi5Npk49iKH
6494	payment	1726	1726	1874	1	1	934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZgFH5Vhg8EA4bczK7v6J5RQXBjj9UKhEMKY6yzUazmhihw1b
6502	payment	1480	1480	1904	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxy3Cad4uo7mdeeu5LhYj3229AQbzMp3PdoFTtHtK27E2kkH2
6512	payment	1726	1726	1874	1	1	951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yNQ3auSPgW7GYrCzpEAe2DvpKdnL39XJg79ckb318WHDiTj9
6513	payment	1726	1726	1874	1	1	952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKdXNe9dcsVHuKtAVhaR3EbtkYHJCkN684b8KwFsinsYRa9T6H
6514	delegation	321	321	1540	1	1	0	\N	40000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6V8JKNpCN39qfkkmHbBDJnjHySZjBXwtCyNmijtkhMpVxLDNi
6515	payment	1726	1726	1874	1	1	953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5gesXS8SM2DPG2v4aLyjhRm2gbydoQadjD8q1U37svWQbnL3
6516	payment	1726	1726	1874	1	1	954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7XFxTqFZBYLQmUTqHNRz4g3zdGUwapsFNDAquFEJbd8oJ8Tv
6517	payment	1726	1726	1907	1	1	955	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZarzByxx8cVx7GnhhGAy6KsFbQcbhN9GyX665mJ6HCihRCFaSq
6518	payment	1726	1726	1874	1	1	956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcQs9L4Ga1r4wNFPN3W6dzJhFYHz2TYewz2p4H72rwuSyJUB2
6523	payment	1726	1726	1874	1	1	961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6b9AWyZcpHb3pFzvEuTieE19tGpMknra1tLeZ3BYWdsEXJxL
6525	payment	1726	1726	1874	1	1	962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZT42oLJJRfdEYGAvUzz7AVsoJ6Y6gJvw2e3Dm6x3QpcKUXm2
6526	payment	1726	1726	1874	1	1	963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4VyaeQbMu3zVcE5rrHhLdpicLeHdK5fuvZPUkyFGH8C3mG14
6530	payment	1726	1726	1874	1	1	967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLRbA4ynVpMnbxa5qDCa6e2aSNCAQg9iezRBf56gzWNXV35wQ
6534	payment	1726	1726	1874	1	1	970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTuD8hVbWnoc8qCXowiZM73PAKKmxS1KBq5a7km8udh21UCbz
6535	payment	1726	1726	1874	1	1	971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJJigCrbNDfU4C6APysFkkPmHSWiMV7xpQMDfuQbW71Me6csP
6536	payment	1726	1726	1874	1	1	972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmmYFBwwhWrwASZDJnoGBDYjcQGkMYgg5DPTS4XxNF5tggxsp
6537	payment	1726	1726	1874	1	1	973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGz7dK8ko7k7uPiTwqQbjvFzhtZz2D2ZxkWnBHRiYLhMd9D3Nm
6540	payment	1726	1726	1874	1	1	976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQu7RwpJdUK5314PWm4HSRi2dxSTw8p6FsJmtjK3SpsTEDsGqs
6541	payment	1726	1726	1874	1	1	977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpTqnE9bDb1yCq1xYJ1N2e15qrR2buBhoTjyarkNhRYjDHGPD
6542	payment	1726	1726	1874	1	1	978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwJJFdDUnoWd5NyQHhHMfj4qN1N4U4riBFhyR1mobHWUYVvus
6543	payment	1480	1480	1909	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDK5KyoGpznJCvZYNTFRTEKpMngWb9Miw1dmyG66FjGQ8RHjCf
6544	payment	1726	1726	1874	1	1	979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgwxEPuATR375L1MNUdH4X26QdGWckgL6RnZYnSZdwkN8Fy4q
6545	payment	1726	1726	1874	1	1	980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepN7AbvtSxH4ANxBz41grPGBbhuwcgDiBHTzXBLyu7Q6sNmBX
6548	payment	1726	1726	1874	1	1	983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAVQAun8ZpLdTYeHUWB7KAXLCKjJKLQWkNfo3YXiG6KyTfKsn
6549	payment	1726	1726	1874	1	1	984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGoEqXfxFqjD8xLvvNMUDn7ZXnAsXUzMK5x1FN8QG5oU2JSXc
6553	payment	1726	1726	1874	1	1	988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSXkSyKQQWMEMSwabeWHT6hoYZWdEvZJfaG4V63aFibLY2jxr
6564	payment	1726	1726	1874	1	1	992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5rHJrpy3J5L8msp75UQgZhtW5UNJafs1wCqzQkrXi7Q2dyYd
6565	payment	1726	1726	1874	1	1	993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexW4nZ4UQCm9xJmHMLvEUkBehmA2g5WkKvY6gWPRdfgqv9X1t
6571	payment	1480	1480	1911	1	1	4	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJq6T53VLBo1Xvz4sa3oBcyHn2jLDe3zQEKmjyLeekc3hAeaE
6577	payment	1726	1726	1874	1	1	1004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhCDo4herJ9VmXqksDYgRrVZ8CRDDNy5yPT2SCA1RYod8rc3R
6474	payment	1726	1726	1874	1	1	914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcTGzwW4NFDFJCAAVTXB4qq7DbfNyPH9Tbmn2AfdnSEMRdaB4
6475	payment	1726	1726	1874	1	1	915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fUxGDe3Q28mFcwjdPV1UiCdqWjuTbKAivdL9PBLrphALVc1u
6479	payment	1726	1726	1874	1	1	919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUe5bL3iAe4qefsh8ARUDFWTBfCNTEbtMPmtpS4mRp5diX1KHw
6484	payment	1726	1726	1874	1	1	924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFroCLy89Q5Gya5Nb7TEhBiwWaXDkspqkK62XJjRpksCnwH4rR
6487	payment	1726	1726	1874	1	1	927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DmyCUWX1d24Nd4inmwqtxr8R5yumNme1rc55CcpHeoQFJek6
6488	payment	1726	1726	1874	1	1	928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcUdsSHMYqCEccZ2s8SGw1WPdpU17ZJkBTeFPQZnukcXk4JK4
6492	payment	1726	1726	1874	1	1	932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRsqB6JVtS8LdeUs5DzzBcYZ5LN9SM7GyYQm4WWD4xHhHY9W5
6495	payment	1726	1726	1874	1	1	935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHsEjmU36AjG5PDEmEoQVd2477LkdAUv8dMj2LwT3z7SoYTbu
6496	payment	1726	1726	1874	1	1	936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYQC5iaS3GdYwDTLNDjULrHTkj8dNzPV6MhVX6KYiiQGMi46S
6497	payment	1726	1726	1874	1	1	937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWkWXTnzb6qqjEre6ttA5nDmTNzvEe2VQgJEUTcUcp8JpgTrB
6498	payment	1726	1726	1874	1	1	938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHDZVYrVMiGHHdoCUnDx7LbziVEHo9jhePquJgpeqcrbMs276
6499	payment	1726	1726	1874	1	1	939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk5X2LPxoA7bDCEQAwJUjdzFbda7SFD5cZXaoWM9oEHu1jd1M
6500	payment	1726	1726	1874	1	1	940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTj5kFzwmVCSXnhjJ8p3yZrmRYBwysM75Zuqtjrd6vghidVGZ
6511	payment	1726	1726	1874	1	1	950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLzEy6XvdCpMqrYmpAkqqR12SDZnPboUVs8QNp9bLi8Yr9zvw
6520	payment	1726	1726	1874	1	1	958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfapSHxeAW7w6aVQ9YBYVYBXznzym2zvyPs8NsUsgMKA65rTJ
6524	payment	1480	1480	1908	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfUfsSLeRjg1mvFPzSFWdnL5ubozuH5Y6jhB4bdcuJtcNtmaK
6528	payment	1726	1726	1874	1	1	965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRvxuJn66EGxy1G2TjWgfmnumjxV7jXA2X4dNhsjEe1EctKWr
6529	payment	1726	1726	1874	1	1	966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGaUUagCJDhxrhj4G2JfNNarxPcAbFSr4pxhsJ1qCBgLYGew5
6538	payment	1726	1726	1874	1	1	974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1ckFkFRVD2UPUvYiQbj1aAdw9T3RV8rq5QXps6JH2v3YYuV2
6539	payment	1726	1726	1874	1	1	975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSp3QKDkiwaqoUBJEvofmDHx85J8U2qyPrry7GjhTU9f6ymLu
6547	payment	1726	1726	1874	1	1	982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYp8RrJsZcCnVpkgjxWkQiXMGHtUTt1HR4WM77xvhJ1H152oub
6551	payment	1726	1726	1874	1	1	986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtGr2rUJDM8GNUsPMoVa26Qj2puzJmPtUNUbJw2DgQogHN3qd
6563	payment	1726	1726	1874	1	1	991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5FbbcZuzcwXAXdWRHkN9ZQuYxdmZMxBRaZdAHcEr1MRcPUbj
6569	payment	1726	1726	1874	1	1	997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVfzArcUnpgARv88QP2hs3z3YxirXh7QbzmttBsXkRUNhvVQK
6570	payment	1726	1726	1874	1	1	998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes4pXaTRgqEjEbbrwrX86m6zKMPfoB7xQpPCTqhkzMe7w2D3B
6586	payment	1726	1726	1874	1	1	1009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2NkbNdHUTnexZ4X5deskVNxL7bgXgf5kD7azdgDzc5dE6V8k
6587	payment	1726	1726	1874	1	1	1010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2UwpDekpfaAmghBY2UDKALZXEJjKZTdxDhHAi28LxF3gBH46
6590	payment	1726	1726	1874	1	1	1013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdAgtn5hiaF8MLMJ1TsCoYVJSz4Hoo2v2rZfskaovdWu7bV47
6601	payment	1726	1726	1874	1	1	1020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJUT8zP4wg1njtPB9eCKLkC29xvwE7Y4cbqkLWhpd7BpFn4Zg
6607	payment	1726	1726	1874	1	1	1026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm5D3R8K44PMw9FaxbAxZFGeFodMbF7rorcsEstbmRMg6Wiyw
6609	payment	1726	1726	1874	1	1	1028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8F7L4qB5XenjRmCMFTrg5Qq56H8E5sFfnqU4qnKq9haW9BDKb
6610	payment	1726	1726	1874	1	1	1029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MfAEXBYmWiQokWRjaSEjck53CxcWrgxoqQvTqxiohYaKbBoE
6611	payment	1726	1726	1874	1	1	1030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAGMk1E1AiSAuWNmWZPmZWriBiP9VfmdA4B6BQBHpypDDC9we
6613	payment	1726	1726	1874	1	1	1032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqbv3jgp4saJdA7LGWDSqSnu1imeVBYLt6NFk7MwEsjA4a4Mn
6616	payment	1726	1726	1874	1	1	1034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKa9ZwErmP2nCdPSepBhd4oB6N2qpu1WRfvyNXNcRwxKcajL4e
6619	payment	1726	1726	1874	1	1	1037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta2whuNeuDDJAsrEXg7guiH1NTJHRSsHWhQYqb96YCniMct2R
6622	payment	1726	1726	1874	1	1	1040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDZHss2NiTeuw8zrpnW1f9vqVQgUZQwQazwvhdSSoFiMMRiJp
6623	payment	1726	1726	1874	1	1	1041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSqmV5cJsZLavKeYR8Yg4QHeeXof1tUT6uQQvQTXknTKKVu5A
6510	payment	1726	1726	1874	1	1	949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRAS9F596pXX6NQsJZAyTqSndsTdCmTxufetVTNpJZNxGg4Yq
6519	payment	1726	1726	1874	1	1	957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttkXue1NasAB8wVTeQUSKL3NFhdcjwmLzv5avwkt557vgR5ie
6522	payment	1726	1726	1874	1	1	960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAH7BrEyDHdg5ZMncrqX8f1AMYxxgD7SRzLE83nCsgtqLgjbs
6527	payment	1726	1726	1874	1	1	964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJPFBLWMfTCXHzXgaPpqsYD4CB8tiRQyzYiEeGa1rnbkB8UdS
6531	payment	1726	1726	1874	1	1	968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3HjPXZyPbhrf7pHGfCv57NtcTViayQvEijRetSq5t6gcU2Uw
6532	payment	1726	1726	1874	1	1	969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzTQnZSRNkfrXjqq1T4EnfkLnXM4mTWv3mh5XHHfdW9Wf46d9
6533	payment	1699	1699	1773	1	1	3	6156202499973	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyTKMs9zJDMBWDaLEPCAX5dY8qHDoEYzkeBEnbcDc1BxxqntE
6546	payment	1726	1726	1874	1	1	981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzv4sPiHYJqnnBq34y6TCNyeWahjj2hMUkc4BAmQBSpBZ3zsv
6550	payment	1726	1726	1874	1	1	985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa918gEyJ3EDArWwpUNVw5jC4sgG2efSJfosvrHj8KJpDDBLRn
6567	payment	1726	1726	1874	1	1	995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDGLwbzqUNr6sUq5uyXCe2GiMtbKj1zvfFmg1hoLnmDxJQubz
6568	payment	1726	1726	1874	1	1	996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tgg1mHbc9XJCuhzHksq8hU6YUggX9MtNEE1RK1RHYuyhaWY5
6572	payment	1726	1726	1874	1	1	999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3odt38jejzGbPAwd4E3m8Z9JcyGrwkLAR8sQbkxzmJ7RwBNmY
6573	payment	1726	1726	1874	1	1	1000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKL1TqLHdbJ3SUUWsrKt7gYq3kybu6EjZPGszxwEJu5JZZTJq
6576	payment	1726	1726	1874	1	1	1003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQNDFY2vTDFhS8CMYDX7fj1U2KS4oPy9wNJg7MaAMEbCWwJW3
6579	payment	1726	1726	1874	1	1	1006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUj1sSPCk5p8dzCp3kTyfyhP457o7QZsAXDhELEZP3GEsfYfH
6580	payment	1726	1726	1874	1	1	1007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTFLPEZ9vbggoQCA6NmP266pi8DCowrR9RtMG8rqPhtdwavot
6588	payment	1726	1726	1874	1	1	1011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdZjAF6ZXMg8QfAfQa2ZMHyzPaRDFAeDoNQchJE7UuW2KRqLG
6589	payment	1726	1726	1874	1	1	1012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatZmgdXfo8kgSYG32vpzn8buoGnN9gTHE6qHYyW1HUMSoeZhc
6600	payment	1726	1726	1874	1	1	1019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqR8LPpXPwptJUpFJXrra6HrMjihLiFB883oHqmW243hNsbNCq
6603	payment	1726	1726	1874	1	1	1022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJ3nshwExgFkgjbqrvFL5hkD4VdTWma11LFXnuuvNs99wLyQJ
6604	payment	1726	1726	1874	1	1	1023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc94TfKMKLXe17tx6gN5mxjy5wm8xf6a4X5tekNrk2tgX3mS2H
6617	payment	1726	1726	1874	1	1	1035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiJM5b4ZGNuH2okjHvJZUKCchNNzjxsjRTob7FpBe1AEMxCwX
6618	payment	1726	1726	1874	1	1	1036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKZ1hb7P86ktvAoGfDpMBw3kgSNSd92xEB8g6rg8vba8enQZ1
6626	payment	1726	1726	1874	1	1	1044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5hhb8vWwNrXMnHyYF8uFZvXrdETMS9dgr85LDj1JFatEGnh7
6633	payment	1726	1726	1874	1	1	1051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJjDaL8KjbBWrBKKfmdnBCwx87JueQQbybYDqGCAFWj898DPL
6654	payment	1726	1726	1874	1	1	1072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsW8VAnTRHLxRUsKprh8siu72jBYyaDHMbJUtUTKSFFYrsRzBo
6658	payment	1726	1726	1874	1	1	1076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4prdnysmKWM8mQt1LGYvwZPTUhCifQqdB4UB7eos55Nzmh5Sp
6690	payment	1726	1726	1874	1	1	1107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTLxQWwMQhXeiKrAdyRpExcNsCG2e2hERHQobuJpBinGnqayi
6693	payment	1726	1726	1874	1	1	1110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsvk9eau92P7Ng9p4nNSgZBgicZUbqofEi37xfQrtBx5ouJXU
6702	payment	1726	1726	1874	1	1	1119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZni4Up1GX9LmCbhijXbEh9esLiMypLehif9RRzXZ26vGAdKU6R
6703	payment	1726	1726	1874	1	1	1120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZxp4e8drfckrmc2xphuHPrqXeF72oAGcE6i1Lw5ptbs1Jzqw
6704	payment	1726	1726	1874	1	1	1121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6Cbj9V4BFp7ZaXUGjv9oNKShSNPpABayczqPBxphA1w7sWoU
6705	payment	1726	1726	1874	1	1	1122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbRhF5jCGoA1vaaCb4hYc7PGpeG34thGqt12BoBcVyytCkF88
6709	payment	1726	1726	1874	1	1	1126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUQQArXc483bF4zSnYHUipNR7pTjVXGNhEFNhpmnE6yTvha6e
6740	payment	1726	1726	1874	1	1	1156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurozdVzzLieyxSLhN8BRhZeo1e2zzrxNnL7dYtddkrrb6wSsw
6741	payment	1726	1726	1874	1	1	1157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27NyYwcEH8zsX8nKcHF4brQ1EBgKxGopbQZ7qc4rAyyh4j4oW
6742	payment	1726	1726	1874	1	1	1158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZqR2WzkZAr2GV9NFHcJs3AQLfKh4139m9X5nhQFxLJsm5UUr
6745	payment	1726	1726	1874	1	1	1161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Qybsf9ZEExijFCfFuLLd2v7GqaZeqYF31gRE8xMxNTKfRY7J
6581	payment	1480	1480	1912	1	1	5	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSj41rNSZhrdfZbaCExCpQvFrFMWCeK6exBAqPdTL2hAxMUVSf
6582	payment	1726	1726	1874	1	1	1008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqC1FwYx73jj4g6Q9nHXrm8pejRNVMBmU3VmYeFuLTFA8fvq8R
6602	payment	1726	1726	1874	1	1	1021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpu24hT2j9D76QnaqEFrcApPgzT4bXaQupGfpjMLbpr2E8Abcy
6608	payment	1726	1726	1874	1	1	1027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYradY8ZopM8rhPUeyAC6XEgMqw9W3dWQaQ2zSqMMyNAzvSPxEB
6612	payment	1726	1726	1874	1	1	1031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQU9pavCV9dtRnuSVG2JRJG4Th469dF4c6wKo5N4rhp55JVgr
6621	payment	1726	1726	1874	1	1	1039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCwEQHtdoUfKEad32SdQzXVRAB8svpY1fpfMiBVeaEuvtsmTj
6625	payment	1726	1726	1874	1	1	1043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADny5FHjXWiry6BWrcQjM3mKvYjw7vq9KKthcManrp2MBSiUx
6629	payment	1726	1726	1874	1	1	1047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUMbmLRh8kPju8mMUvGG8yX7yXthEPX6XUGsYSUSgZWFTDv4S
6639	payment	1726	1726	1874	1	1	1057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPMtrWhy11w3kzUxNFwU5Z61yFTrrheossZc5UsdvDBTaqD4S
6641	payment	1726	1726	1874	1	1	1059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbpdUPo972cTjhMzUx1Lwxf5uhVoPrPZrPZ3KSgfhb44sr1Kn
6642	payment	1726	1726	1874	1	1	1060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjJYsGucC1oMtD48PbraXnGLGndYu6fpbhXnaqchwxDWJsmZd
6643	payment	1726	1726	1874	1	1	1061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExz7mdM2dyFfVQdLVR8jCBLqSas51piLP9pcSdRTkQ7RYcR6T
6646	payment	1726	1726	1874	1	1	1064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B4sRvVdUHtBiySZ9bDXB3R4uegsdYerNhToq835APLZ49WAT
6647	payment	1726	1726	1874	1	1	1065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9Lf9fDgLJqQqTWbEcW4jZCYypaTLxmc4vxNgEhxsPHoppkcB
6661	payment	1726	1726	1874	1	1	1079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1QfB3LFtH9HzJjsnR8ognGUwFm6zzxD8CkFRthBwLV5Nfg2D
6662	payment	1726	1726	1874	1	1	1080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFstnacoJqiQhKw3sQePfCFjAtvbR2hENVBqsSZPhEmc5t7LC
6663	payment	1726	1726	1874	1	1	1081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWZM2s2snYA9kvAeVTzACwPuHSswg8z7p2dHwoK137EAoTUTF
6668	payment	1726	1726	1874	1	1	1086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakn9yv7j3i5PhxCcGdwAK4zSTj1G144GFN5SGC22iawVy5k5v
6669	payment	1726	1726	1874	1	1	1087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4XWLDnSRERTZmMwUKN6vo2K5dKAMkAhpcdNKi8AHn5Ldv6N1
6670	payment	1726	1726	1874	1	1	1088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5eqLNZRRK7wvNc2SZBKZGjP9gweAPhya3cj2RzArTDRbi6n4
6674	payment	1726	1726	1874	1	1	1092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu55TGTk3d8YQ3TXKPvAo1TouG3TqQwH4NmSMnH9WR5WDGGyS
6675	payment	1726	1726	1874	1	1	1093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrc2nTasEBDFzL7Vgwh5fN4Qizhk3RrCPMhkePhfGqsL1L8Hu
6678	payment	1726	1726	1874	1	1	1096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNAscUcrXCdUv8pvhn5gRjeHE1btqG8i34oQznCro8H5WfAcV
6679	payment	1726	1726	1874	1	1	1097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1z8XwSWT748X4pP8QzkveeDRNX4jdqzUE4QoLoAbrG3JUmGN
6683	payment	1726	1726	1874	1	1	1100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYbwapnoVnJPYvED7ZRF5n2yhtXgoS2MVd72fJVa49psbN9X4
6684	payment	1726	1726	1874	1	1	1101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGF1ri9saeqziG7qZjmBCDrjuKj644gif3XM4Y9SA3VAYxbxL
6685	payment	1726	1726	1915	1	1	1102	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZoxMoffVdwg7yqe6ABqK2a4PDgUKjb7JC98JQAa8XbL8ovSAm
6686	payment	1726	1726	1916	1	1	1103	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqYTPCd72JDJTqFJgQCDhEkbVxPznQbjxS1JtaqPioW5YjXDxk
6689	payment	1726	1726	1874	1	1	1106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTNSyfnrVEpt74Kad5Cu5VYPmYBftpGy2PnXBv8rU2Xh19ME9
6694	payment	1726	1726	1874	1	1	1111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5LexsMfmuGurFGfXzZXBKSy33zpxtvtkc6qc4dki5A6bbxwc
6697	payment	1726	1726	1874	1	1	1114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLjCMYYSsxtCW7YCegQAkQZvmZ4XdYdGJM8Re6oRNYFwop5As
6698	payment	1726	1726	1874	1	1	1115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjJGabXq2zMXUv6Yj5QbpZ23cCsLZ7M8BhUhGp4mc4v6pXN9i
6701	payment	1726	1726	1874	1	1	1118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1y5seEtG2PKnghZcc6kXiw6BwBqfLsjcUP2B41zv74nd7r2XN
6710	payment	1726	1726	1874	1	1	1127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUb1XjVqJghHNq1PDQuNxaLJxR1XGfPRaDwkx5EjJzyJVkhBo
6712	payment	1726	1726	1874	1	1	1129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkM9BNfy4C7QDwPhn9LMiNqtQNZhLpC6jQfgfMsr1NPeFGfLoa
6713	payment	1726	1726	1874	1	1	1130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgjmu5UE8iC7PEtggGM1kpqYJN68ajbvEQH1tPRNmYPdmQRrK
6716	payment	1480	1480	1917	1	1	7	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahiTaqt6vCgYasYi5Y1eg693pMozPcHyG7oCJgZzHYd7B4Xmi
6717	payment	1726	1726	1874	1	1	1133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr4cFEpc3QxwL867XXRGWWngC1SeQruJCDvvmFzHADdyQsrjE
6584	payment	878	878	1483	1	1	2	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYg3KVGFe1CmjXuyvDKkjRr7U8Ev6HtixZ6syFth91jFeUiftAW
6585	payment	127	127	1483	1	1	1	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYhnEkfCX2oZgSjSByaVYFB3HgUDUD3WL5XFFRfAMEUk7aTpg95
6591	payment	878	878	1772	1	1	3	397690235728	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQm2RFXTyLnQR6X3FsKyaGX6xdqedkscP6pazwhmZb2N2uaiWR
6592	payment	127	127	1772	1	1	2	129947824773	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuCihMs97MUHw3PcczmH7e3bApYNHWkHAymLNouLBHPzqaeDv
6593	payment	1480	1480	1913	1	1	6	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYuum9nC5SQ4cUQrwwFk3eX5o1qihmenpTKh7ADp2rKiokgx6
6594	payment	1726	1726	1874	1	1	1014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ewuF7cawhsVngr98L2fhffTrinNRuYf9FGUS1Hkd9A8gSWVv
6595	payment	877	877	1772	1	1	3	396690235728	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FUUwVLwRAgTZm7BX6Bv44cPeFvy5sKpQQnP3t6Jfjk5qWdeh
6596	payment	1726	1726	1874	1	1	1015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WNhd5D8Wg8MFXrtPqa5S2HDDFKLyPu8gKeExU36tCq34WKb6
6597	payment	1726	1726	1874	1	1	1016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3shcNPGFzbvSqJuGN7gZ3aGVLSyYEA8kEX4BwFpg2EnMTdRk
6598	payment	1726	1726	1874	1	1	1017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnujFzZjVnN9XNWspzmaS8CEu81A5i2Xq8nxEYTKKvM4e2mg3x
6599	payment	1726	1726	1874	1	1	1018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVmAPYFyegANCK5E7ZhD89FKcz9R4E9d4wcaWFEJ16jtvVKNG
6605	payment	1726	1726	1874	1	1	1024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVjuJ5ei2PpFzTr893n8ewM8dsDdKQmUdZRtUSrJ2GgR6e5mk
6606	payment	1726	1726	1874	1	1	1025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYczFzGDZT3eFtyqcRsJj5oyaH37UcMwBtnzX6RtDqSeRKeor
6614	payment	298	298	189	1	1	2	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTCNizzFFzaEDnmwH7qt8UxxqMziFYUJmqCagnfYdnE58Tqgh
6615	payment	1726	1726	1874	1	1	1033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGG6XnRHtpRGwHsyWdJaSsva6tmuYsUxmsX2SCxQU6tNh7VEA
6620	payment	1726	1726	1874	1	1	1038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTf6MGMd2ga99Zte4BqAp9nHBcJS7mKevfva7xR72YLciEyLJ
6627	payment	1726	1726	1874	1	1	1045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6spkYKZjZxHgRTEUERABFythi7jsxuURkyTUQESySoNhYjPz
6632	payment	1726	1726	1874	1	1	1050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGLP4ArPToTy5VNV5uNw4VBbwU7uCKixXSQWCZPHXggaWdaq8
6636	payment	1726	1726	1914	1	1	1054	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwVakfKMyRxGjCnioF58QpEwjSmxrmy3DnCfc7gKzTMhr3zEYp
6637	payment	1726	1726	1874	1	1	1055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3WiQH64icQFtBUne7CVYrB6bC1vYU8mr5apPjspAMETTv2kN
6638	payment	1726	1726	1874	1	1	1056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnWMEAn4dNJLGchser4nJnuuU36q9dz6cLt7hw8Ngv4RDySFa
6644	payment	1726	1726	1874	1	1	1062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WpYcZzqXhL7kgjdVC5maGakMbgR1qx6PvqWydZNrJsWULxQa
6649	payment	1726	1726	1874	1	1	1067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzM8RG3fEmHoAg95LbETNfyBuVBt7HG8k245uUZq8WoYF31MuP
6657	payment	1726	1726	1874	1	1	1075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Y5LaiVgaWzniVixGnwmEHxFePWT32SUyZRNcWB9ykhDKcKRf
6660	payment	1726	1726	1874	1	1	1078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdM8sxF5huQjrPoNGS4BpcAVjwkLh5NMvofVrY9kjo8TiNEA6
6664	payment	1726	1726	1874	1	1	1082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6FbA12bfomruKSxrJWts6Cw6q2vtj6mPjAaZwisssffySSno
6671	payment	1726	1726	1874	1	1	1089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvCqmak5uk6KMQPJtDkBxZo435pWEfEAKz2QFkjaBepKzzpfo
6673	payment	1726	1726	1874	1	1	1091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXsv92ZNzyb2nhW9MLbVhycf1t2U8EhTcMkxgxXSngCpcho3ZG
6677	payment	1726	1726	1874	1	1	1095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtbtUqYuQQ34MHMeC46DzCGuaedXYNxbvXVPfJkGUwp67JFPi
6687	payment	1726	1726	1874	1	1	1104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGoqBWA823jLDYKkaCFV8SgSysNHBn1VQ8PVm2M6nUbMVh5i5
6688	payment	1726	1726	1874	1	1	1105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXPtHx8e2yUSv2twrSRAqF7KJaDXSxByqHr3HM9TBVqCK7vv5
6691	payment	1726	1726	1874	1	1	1108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8eHmdPSDFBJfXMtcNMsNQKnuq9nj7f1gHJTRjNNPNLkdED9Yr
6692	payment	1726	1726	1874	1	1	1109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKC6jyYmQgPsmoWnZrpcYifPMVjv9nVzDR3kWooUjuzczpY4Sy
6695	payment	1726	1726	1874	1	1	1112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8DMKM2xT4C9WA8fCP7spnrmpe8jmazTEy9ByFz4CDTLaeSGj
6696	payment	1726	1726	1874	1	1	1113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UGy9WZSkqb3f2XZh8dyH85EGtPxiNCA6iKWDJho5MrsTzsEs
6706	payment	1726	1726	1874	1	1	1123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjZR8RQ4EugHHxw18iEANEiPVZWDtPjLYPurKXTDzAva7Fc3D
6707	payment	1726	1726	1874	1	1	1124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVRh7fcFmidguHLTxAHruSUZrJxXH5DBNH9Egb3st2CgNc6zg
6708	payment	1726	1726	1874	1	1	1125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWPjTaarB54ETjC6DpwyN9x9cCUDaSuqmv4DNS36YCuFdQaJJ
6624	payment	1726	1726	1874	1	1	1042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDSyvf1e2BiUPb9JJ3iHUc3xCna9Lh5uTqsxEBQUpZ38rN2As
6628	payment	1726	1726	1874	1	1	1046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UDL8vsBCXaTkzayCmgaXyYFShd43t3VFD59rcdWo8dYm5Ybk
6630	payment	1726	1726	1874	1	1	1048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8GfEscEpspb65wf4dhCjRQYqGTt1tKEobwWWrLZu4sfeHsP4
6631	payment	1726	1726	1874	1	1	1049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeXYmsBVhyWwtcSHWZpHSqVA63FfLtmNMyUDG2QiqqGLp9wum
6634	payment	1726	1726	1874	1	1	1052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfHUCEd1QtaZrDw3YnDmKc9wtefHhUZ6wFoPnJDAxeT57Q2Lf
6635	payment	1726	1726	1874	1	1	1053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5av6uytCU5pMeanDj3u1VUmFR43ExoNiBnr72rLQeKK64Z56
6640	payment	1726	1726	1874	1	1	1058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2scsML8tHm6Acze1DT8czSw8B5a2Qn84EqwR9u78DR5gGdpGg
6645	payment	1726	1726	1874	1	1	1063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWTL9d3NjBNJJ86MJGdbiKEUEGYjvzEC94GaFQLoa6e8u1Pve
6648	payment	1726	1726	1874	1	1	1066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqrBiBoMKJQqErEyEobUz8jert5WpTDZaGXm3NtDQyxTy8pX1
6650	payment	1726	1726	1874	1	1	1068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WavK1pHxPkap2dQCT6HNUc17utrSX66YV6tstVb7FU9rSyZG
6651	payment	1726	1726	1874	1	1	1069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2ouar3AzyeLXWDgxLVEdtv3A8BSEo8W9GCHtNt8cTUANH8bK
6652	payment	1726	1726	1874	1	1	1070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW5Khpqku2Gd6rrW35rNod42MtdCjKAhsbrQrKkratq9WPv88
6653	payment	1726	1726	1874	1	1	1071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVNKgTVi3eFxVomzKRCWncGYC3SG8jXwLnvWR7ChJk5m478Ly
6655	payment	1726	1726	1874	1	1	1073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGTaxHxG4XnyjcVehUBSxLijNKkPCc5Lgm5XoZF7CtC6mHiqd
6656	payment	1726	1726	1874	1	1	1074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1ztdTErNiQNCnbed1Gusq5BYqMmd6DQUsEz4QHKkb3qB77te
6659	payment	1726	1726	1874	1	1	1077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6LLnhTf1wQveES22fpkRhpp9B5PNcHHr533BXEgro3LaWf1A
6665	payment	1726	1726	1874	1	1	1083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DBobiTMYUW2nz2tj7F5zJuvcu1DhEBHhGYCMt6CRGskM1GNn
6666	payment	1726	1726	1874	1	1	1084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHaFHZgDTLxU6ejVPdZGd2mAvQTWdfhxhVJjJrWLL1GpYt1PH
6667	payment	1726	1726	1874	1	1	1085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY23y9FsML1hm55Aq9Zcw2vzNfs3BDKaNSjfa4pxhWwHnfTVx
6672	payment	1726	1726	1874	1	1	1090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GSEJR92nAk3Qy3Gp7gD8jGMNPn2yK2pfm6QG1tMLSpVB5CTx
6676	payment	1726	1726	1874	1	1	1094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSoxnX5pPrgdjPj41YU8NyM3eeKCo9qivYKJiFD26wPqe59M1
6680	payment	1726	1726	1874	1	1	1098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSpS1KQj5JLBNNjH4sznv9Ao3XPFWGyPXE2aUmgMys6esEqNF
6681	payment	1726	1726	1874	1	1	1099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp8AiF4giv6gMH4gJC22pUdijNhZVGXGvJrfGwcjei6dnCqWT
6682	delegation	353	353	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TuHrEy6JRoNSe5Jh5T4EAHdPH7VGvPbc6nhw2XGttQ19zL83
6699	payment	1726	1726	1874	1	1	1116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZCbhbYUivyc3ZhLn5YViYSexxn9ddr1CbM2Au3t4uXv2aMVJ
6700	payment	1726	1726	1874	1	1	1117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDF6x5BpVkDHTbAWCRgaisnJ8EzVV2kkBLsGuykRbEEcmUsMe
6714	payment	1726	1726	1874	1	1	1131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzTWz4hkxyeXeD4WFMTW7kguPkwtVUAbxqLohYh14JgUdNv2h
6715	payment	1726	1726	1874	1	1	1132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQM8gcZ2DZUAdbNCFCjsNKVciM611Csgjwg6DiPg3LQNgfKQo
6723	payment	1726	1726	1874	1	1	1139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtLj9dEiisGN9vKQwVYqCy1Yn8xLrpu6JmGRsMJT1zBsv7Kt
6724	payment	1726	1726	1874	1	1	1140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcmTZH5AiuTkomKWMrCBKbrPdNPevB4pBFeRNdpDQ7QM9Xu5b
6726	payment	1726	1726	1874	1	1	1142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZv2P5MFfMPSsboyRxVKhVkgX4SLXQRt7Fox3oEBY79dEg6tMC
6727	payment	1726	1726	1874	1	1	1143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgNr2M3LQCKT4Ch2k8vbStaZ9BPbtmpyRhp64efxsqfEap8Si
6729	payment	1726	1726	1874	1	1	1145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeak6ENDdyaLet1bdpMnCiLAPwahcy4x9M8S1AjLRJhHCzdkmp
6730	payment	1726	1726	1874	1	1	1146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexrexzmnFxdrs1CTqoyA1g4cyNNiWqoUpJXYmZYfNhiHDBHxr
6731	payment	1726	1726	1874	1	1	1147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTXWcvsQiy3MpETXNtb7r6ih6ZfTG9s99TmejLMoTcCecjhKx
6735	payment	1726	1726	1874	1	1	1151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JN4xBHuubvHMNcsSUq6yhL43mZtaC3zCvtPrMXZf7i1urKGV
6736	payment	1726	1726	1874	1	1	1152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FajjHz3QdKzK1PgqEdCWKuSsuZmd2hHBP5MnzhLBvKEeucvf
6739	payment	1726	1726	1874	1	1	1155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zvnqLxGKWGidYYvtZzR5LUxq87Ccwdo5F7Ljb3n5dKQsa2qK
6711	payment	1726	1726	1874	1	1	1128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuWbarC5EnVPHT5Mdyum2Ep4tHdpwRRjBSQzBPRpauDd4TeH6
6728	payment	1726	1726	1874	1	1	1144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcPLp2CLZAHX9q8AY8nNcff3c6UtyGKM3c6t47mLoFq3PY9tS
6732	payment	1726	1726	1874	1	1	1148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZ8xA4Mx8jDabscc415gbSNQV5vgymNRVAMchWtGAPjVV95Nh
6748	payment	1726	1726	1874	1	1	1163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9orQvxrxcgeeg4KmwU7NCvF9hkKGCypBEW657eAaUVPXTpm3
6752	payment	1726	1726	1874	1	1	1167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ1mLTgUbWwwaJLEbm4YTTGSr1X23gBZSrdixba4jyz5ERbr8
6761	payment	1726	1726	1874	1	1	1176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VGjAE34UdwdxHdo8PwV1DZ5ncQRxfF8gyJCaAtBu39s8fhET
6762	delegation	1918	1918	1456	1	1	0	\N	1000000	1616981889	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnwuPXobJ6ue5hPE7wbjdjeEkLYvd2heYHtaja2kN5KcEt5LD
6776	payment	1726	1726	1874	1	1	1190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2uhGUi5HBXYGrFZmksWK1rvseMy2Q1r4RugYxqBWQauYpsii
6777	payment	1726	1726	1874	1	1	1191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1ydbdtyx6cWdypc357kxzyajUDxPFdDWZ8MxpYp6pg6GoCMd
6780	payment	1726	1726	1874	1	1	1194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7d7mhUtNMgJDX5rs5BESQ8ojJwvEdFJBeVwTWJZMMG54ZPUQL
6781	payment	1726	1726	1874	1	1	1195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqRSBSrK6ZdUwitVy8BZ1bNef7K4eWDtmEdhzmVnPCVQjoFdL
6782	payment	1456	1456	1918	1	1	1	1438138000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u6utBNzLgmNMBzTkdx666QRZBttHebuMXvLpdZnXmBJ5USrA
6786	payment	1726	1726	1874	1	1	1199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AkDsz1hw47TqJKMbKiZamcbVmfX9zen6Zy2bjB3yTp31qCup
6790	payment	1726	1726	1874	1	1	1203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUr6vAMztHxKJw1NavC3TByhN35PLEKZA1HPsP5Br3cxAqb6UP
6791	payment	1726	1726	1874	1	1	1204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTicyyf5qjdoKct6KrA5iAvEMLYN8rt7Z9f2gaUN16g44LTE9
6794	payment	1726	1726	1874	1	1	1207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJv7RDDTT1pRbQY91Meza5VujtXRJj2SYm3HaZZiu5c5DqVwg
6798	payment	1726	1726	1874	1	1	1211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEun2kQ6JX9aHtUdfoNo6sez8JigCunKZr4kX9DgENJnSpUNHN
6815	payment	1726	1726	1874	1	1	1227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRwJrwb3ssnBFqWGoahHu2t5YupBWNWMjpGWQtDU13vZJ4c9D
6827	payment	320	320	1474	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV62AJWyLGbXs3ukTLfHjiaXuKPkNAfJiKWi9ERGiREgWq5Ksc
6828	payment	1726	1726	1874	1	1	1238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vJ93Cvb4NFtsXZs6nbSPEoPMe9DM5bC8yjupxjEkTZXZrZ8U
6829	payment	1726	1726	1874	1	1	1239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHKY68c4b3N2Z6ruB28ivoBvty3X85efhrecpMzB9J2t61cQ5U
6843	payment	1726	1726	1874	1	1	1251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQj9uj7UsNVxF31CAN55S7MT1c4QpSt6R6X28mCXoTjpQax7aR
6844	payment	1726	1726	1874	1	1	1252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiWfSaTGVp9Fr8RV7Wdw4Vd4SdBNxSykFY62RAXaPLcE5wNFk
6847	payment	1726	1726	1874	1	1	1255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiVKWNn8wz271fBLC35y3KHhou32iE8VAs7b5YwFD4Py6AqhZ
6850	payment	1726	1726	1874	1	1	1258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLzPfguWwk8p8BUeA6guroQa6onKm8cQLBgWzp75GPFs1AkPR
6851	payment	1726	1726	1874	1	1	1259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ8Z5oj2SufY8J7bezft5tWRAe367pvVmZeePhLFrYMstosR3
6854	payment	1726	1726	1874	1	1	1262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnivGn5b42kpnxV6KCfReb9mjLt25Mn8mv6DR984CQHEmce7r
6855	delegation	1750	1750	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfmGFvGv9SmYZmkXumRG1VSDxmMhL2ZKHery11LYBV7JBguS4
6859	payment	1726	1726	1874	1	1	1266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dDjq353wsdrMPyTW516QyhdMWoCJ3Ncq6yjowespBvsL16Bg
6862	payment	1726	1726	1874	1	1	1269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGwunS3UPGibjs3sNv3BbHnbvt3eqA1wwrcEQxPSknWdqMi1Q
6863	payment	1726	1726	1874	1	1	1270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAhLmAgud26UakDY526s9qNisxeMqUFxnCoid1Wq2vLmGVqoL
6870	payment	1726	1726	1874	1	1	1277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzGH8vobLWhK6GtjDSBMrmTDLeG51h9b1NUT8Cfph88f8FcDx
6871	payment	1726	1726	1874	1	1	1278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaMQnh4cecKVgYyhUBWdppgfxLZ8akS54pYH17pF5YvhpnjM
6872	payment	1726	1726	1874	1	1	1279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sW7Qp2vnykMKsXKMNoT82jST94vdmwZRkKpZdYSwyBsQVipW
6883	payment	1726	1726	1874	1	1	1290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSbboq7SDeyJx56LykgmhQpRYTDnhPxQM2jjNGmCU2du944pr
6886	payment	1726	1726	1874	1	1	1293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTiTzBWaHoE4tRMaLAkXdBTnVJy1X3vAmgg97jKTTTrCMtUo1
6888	payment	1726	1726	1874	1	1	1295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4SGH2PERXndHeMMV7T291dMYCcpTNiJBoM1eW6QTxtcTPjJq
6889	payment	1726	1726	1874	1	1	1296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfb5WbcBQq7cSgVmRVxEmr6eTVpUv2HHgPUoRufyFed7BPjim3
6718	payment	1726	1726	1874	1	1	1134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GrQveYnE61FiYg3Li1NYZVJs39YvhMvUakoj84gfZyyquHbn
6719	payment	1726	1726	1874	1	1	1135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JvKGCQER3gdm6qgEt4anugHLXwd6YZUnNP98HM6Myj7ST7dt
6720	payment	1726	1726	1874	1	1	1136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNjXYriQB3yhr5j911M6ZaxtrhVCzDGSZKK8AAvZra5WUv51w
6721	payment	1726	1726	1874	1	1	1137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8FWEiYusD2jfWNujCGXRxGJktQiAXCNviSo2BhiBK7sFu1hQ
6722	payment	1726	1726	1874	1	1	1138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwPyBSVG9kPKjx9cNQUcnQDbMtAfTpsp85YXNeSvfbWqEjbxv
6725	payment	1726	1726	1874	1	1	1141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4LXMPgBqwkE2wSBMPR2wqez2AdFq7FFFeQSkTcpvC5JsVad4
6733	payment	1726	1726	1874	1	1	1149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4p72q5hGfXp6fao8wcoEHsscphimTBUtj68z4XLzve8E8RaZ
6734	payment	1726	1726	1874	1	1	1150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6w8XLsDHssPoU74uWUVRZ1rWkEeajGGJbHLZpPBmEcHNc9g8
6737	payment	1726	1726	1874	1	1	1153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ryPbZTTjgYqB6fHJD2nVdLivdEuCtxxTvtBLcD3iJ9Jfe73v
6738	payment	1726	1726	1874	1	1	1154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf7WLmwMBKQSc8Y9Xxy711hfpWQheuKKeUZE98XAxmxxCHGoa
6749	payment	1726	1726	1874	1	1	1164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVncZxVZzmxLC1sL9Ftke7AgsMeWXjBBSpmTyaFJZA8PPn3PKn
6750	payment	1726	1726	1874	1	1	1165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5FzQ9qtHZUxvNQpKYWhLvFn6PayUTz5PCkoGYNvwj9fg54ZM
6755	payment	1726	1726	1874	1	1	1170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbQY3JCaCfHPvhu47Kg9uqWPSexgSouhRwkL5pbgppkRYfFhT
6758	payment	1726	1726	1874	1	1	1173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HT1XRwENZfApsQvGdhdd8FWtt6WcVynXgMLoirtoWnjN4qwg
6764	payment	1726	1726	1874	1	1	1178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLm8yTkzCcNhVX4VR67jZFqhGNaSnEgBXcYw9ASfMA6oXkhiP
6768	payment	1726	1726	1874	1	1	1182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAoCTHKvEA7m3DTcJ8GAMfq44mcoL3v57HDd8VjTAhRAC2N2b
6771	payment	1726	1726	1874	1	1	1185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsqSX8kbm5wVupsbvJk9PupbGfKsdPCrrA7XHc5kjGbaXop1C
6773	payment	1726	1726	1874	1	1	1187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaao7to6AKVTTQnLMCsvy2iTEsxHh8zoaYXh1SjdFKYxpGzih
6774	payment	1726	1726	1874	1	1	1188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFnPJe2xmLRwJJiPxpG8NirHLjEQsEum4caipzEL2uijVuXuE
6775	payment	1726	1726	1874	1	1	1189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rGsrMTWYwAumbVZWbVUPLSUdixNJxkZ7xkUQ4yXdHbWDULEH
6778	payment	1726	1726	1874	1	1	1192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPTyUu8vJsUy2VhFhYzKucygQP3BHG2sRZYiivKG8F2KMwYgb
6779	payment	1726	1726	1874	1	1	1193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUew85qhJFajj392MFUdmWNmXDok6nJyBSjXT9m9QWuzz4U7x
6784	payment	1726	1726	1874	1	1	1197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tw47b3rdH2YastU7Z1GRAxgWizUqyjEYZ3r5XrvZSTrRsfSy
6785	payment	1726	1726	1874	1	1	1198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7XDuX53etLn45YB1GghuW8PLJ1RGpH5UgRmhT69FvmnLmAeX
6789	payment	1726	1726	1874	1	1	1202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmFTKPfGK7t5aZH2iGXU4RDpWHMRpbj3iN9fWvvdMeDsNJAqX
6799	payment	1726	1726	1874	1	1	1212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz47zWVZVhLbpafBicV2rvrmjcUCQ3gcNEKwGYyEs3ysYkYApz
6800	payment	1726	1726	1874	1	1	1213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCaJkCFzurYSFGWdtUBAzLfQDFFqctSJq7HZp5iPSXBv6H3Rb
6802	payment	1726	1726	1874	1	1	1215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkXKc9iMhp84xErghLHv7B69WL5wVxo1esLMPc33B3prAE45X
6803	payment	1726	1726	1874	1	1	1216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbcBJdHvUfG7gPjcauy49mcUDbaioXDADBDedzsjgVhTH6S7o
6804	payment	1726	1726	1874	1	1	1217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5TfRuVZ2pK2bZZpLDb9vRF6Wmh8RvYytwTT8qF8Vj5VmdSpB
6809	payment	1726	1726	1874	1	1	1222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhok8wcM8uadLPSo6kjAvPT3rxBfcyWXBUT2zSX91uBGF3k3N
6810	payment	1726	1726	1874	1	1	1223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AiynRfG82EvkZDr8JhEMegEvgH9tUyRCfLnhNLFdz6TsbbMs
6811	payment	1726	1726	1874	1	1	1224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMn5YxrVdtbzz7Ho19WPsoc41BQPQnwd1hFoRR5WrVXS9GW2C
6812	payment	497	497	1474	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZZJ389SAcf54EpmmuZmTBcShtqnbdRxkRXsuGz1WsT8YpiEA
6813	payment	1726	1726	1874	1	1	1225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNxqURWDWJ2i6y8ookb3JQMgdEZZ2fpKZ2ho2GMHddGRu8GoD
6816	payment	1726	1726	1874	1	1	1228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5siRxs7d1eCdzbmBYuGqdDQAvNuaGMty1GDDZgTv8Mxmqy7Q4
6817	payment	1726	1726	1874	1	1	1229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RhRZJLAvsnskdFtbdkA8K78ggzsEBXKhzCH699kVukA5x8yR
6830	payment	320	320	1474	1	1	1	280000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYsT83vj18LH51i3HGgfPq2PcM3H79SG4ximeWrTVr269cDBo
6743	payment	1726	1726	1874	1	1	1159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDy53WeJKy8UmkZahNtXSwPM4Uxvu5euQTDiHb6wTjRp1PRaQ9
6744	payment	1726	1726	1874	1	1	1160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsQns3hBayzk2mzXCWrzVWcZituV2vGHd6hmvGvBzuDTQMPzx
6753	payment	1726	1726	1874	1	1	1168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfDUaCboUjbAk3dvmCiB3p977Tfcnd3yWnFk6G5ivSrtsUQgU
6756	payment	1726	1726	1874	1	1	1171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xTWiSdhxfTmEwfGM6n7afAmfWyhZnEjPqoNeqByGLGDLrVK5
6757	payment	1726	1726	1874	1	1	1172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5N8NcvfZyqd8xymFgouRn4FyK9pKqpPR1sfAHg5ZH9qWhTLa
6759	payment	1726	1726	1874	1	1	1174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzQuXUgSF8hchsPEoy6oWkykgwXzSQnZ8Q2kRpzF4KgJz1g2k
6760	payment	1726	1726	1874	1	1	1175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B5NThNaVsVfxzjBA8PphkFZrjXvpDrnU4ucPSateALMUSuxc
6765	payment	1726	1726	1874	1	1	1179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Nb2FuA4tWpbaY2bCyqgcJDaoFCLfE4it8E9HRZgwfYGyQxck
6766	payment	1726	1726	1874	1	1	1180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS8usoiwUHR24JSeqvaZGoCNsbXF9pcM6JqXstkatRGNvemXr
6769	payment	1726	1726	1874	1	1	1183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXdBrjdB6KSUMat9pE31arJkQAufjYztF2KT69oMijjn2Ms6i
6770	payment	1726	1726	1874	1	1	1184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82dHgv7tGbPzTBuAvuw81wj64tU6pC5m2NH2UtgmkMrMEPBrY
6783	payment	1726	1726	1874	1	1	1196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCrW6dAw8GUiRui7MDGuR5CUGbRodEumbMs3Pc3iJpHsDu7mTU
6787	payment	1726	1726	1874	1	1	1200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpGo6Mgs8uuYjvBux8V6B195AoUsww4Eb9T8iZkCyKxq3JaEN
6795	payment	1726	1726	1874	1	1	1208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oK21bp8U67Escch3gqZeoNoMEev345qLbVYumuob6mXczx93
6805	payment	1726	1726	1874	1	1	1218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqngZPadRYCZB2ctx83s7fYYTUEao8pR9aYZ6baheHTHk3zDvP
6806	payment	1726	1726	1874	1	1	1219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPnoi9gfuH4K9P71kroTsCLqEWpynRWMUzs1DDrL13TZBpRyy
6807	payment	1726	1726	1874	1	1	1220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6Fm5BMFgGDR3crizt3k2iBMkEzRn6q8ewxgmGwTRsa4wNAre
6818	payment	1726	1726	1874	1	1	1230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi41Jobqfca9yn3dEs1CB8QmNejY629Wsab8t22kL66UVpibHs
6819	payment	1726	1726	1874	1	1	1231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86yZR6wUA2s3WU4DWPHaL2pYmEoN2ZR7vJsuLPvi24HbANSni
6820	payment	1726	1726	1874	1	1	1232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVqmGMtaCvVrvS7WSi2HPPdRqo1mCqdkUz7vZrdnvimUsMv2A
6823	payment	1726	1726	1874	1	1	1235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvC7zFd2P7TdPFt3YcCfRxetpfred4Y3EV2ayGgRAqhHkRXDP
6824	payment	1726	1726	1874	1	1	1236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8DBrcv58f5ZUuQzvLn7jC8brT6ExVDdsr2orF6tUTno859Wky
6825	payment	1693	1693	366	1	1	457	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZUrcM713vrjjuVgttG7rsHdtng99TDnNN6wC6kSPTT8o4vNfP3
6833	delegation	366	366	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9t2yYQX3jeFNnCuwe8vr52vphYr2gEcYMAdumFgCs4UJTcCd5
6834	payment	1726	1726	1874	1	1	1242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkRbq8obJ2ph8xsbzQko66v9525UwwzbNsmwzYDuTTCC46u9Q
6835	payment	1726	1726	1874	1	1	1243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZrZfeBZo67XqeHXkJ88MwVcFs9jwcZjKB7X36ryBcSwpu5wD
6839	payment	1726	1726	1874	1	1	1247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPzXQfYmXv8vnEUfDuJf7xrDNFWijKocb9AWKpAsx52jimFqK
6840	payment	1726	1726	1874	1	1	1248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8WLGE51fdyoC4HQcAQcTQzeEL49oGsw5yYFxnSn9U5tVD34g
6860	payment	1726	1726	1874	1	1	1267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiukLLpheoXhUSNUXggGcjQExYPoAFc7gfgARRSys5o2gEB22B
6867	payment	1726	1726	1874	1	1	1274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1XkyHMHaVSYcnEMryqfePichgyb86JaMUtX1REXNeANyGUqk
6868	payment	1726	1726	1874	1	1	1275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCwrXRTPCJ1LFzKXhoxxvPrjU7FboGxpWSCAUifLHogcvEwso
6882	payment	1726	1726	1874	1	1	1289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jMgojGcgjWybbr5E9Z2xJg9V3PH18aA1o4zCFvPb5sFUyqep
6894	payment	1726	1726	1874	1	1	1301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gxZB5FUxXprm55x6oLTjMqrwmmyM6vcptoRiJYYB7HrdTex5
6898	delegation	189	189	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8zQfoCNBmBhLhyA4vmMBbzVUmckSAi4CJjDQdzNUaxnLoKX4
6899	payment	1726	1726	1874	1	1	1305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVrmxQ3EtcidJBCbSFjAo7Fkz5Jm2D2WpmQMefmipoXEpL8VJ
6903	payment	1726	1726	1874	1	1	1308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHeA7uZMXFRhX2jMyrzmCGX4PUWdzZsyBtTCWGsJUGdBHRuBU
6746	payment	1726	1726	1874	1	1	1162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9HmSTEFYT8i3mH3m3wZNAdXQQuG45Ams7sx4P2SkDcZvrLmg
6747	payment	1456	1456	1918	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMcNucM6UXcTWHAWoy5adcEesTi6rdwht9aff98s7p1oSw1WH
6751	payment	1726	1726	1874	1	1	1166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcQE6nJXvzU4k9wefKd93y2esAh46mAvUUHQQPVXwUR5jQCAs
6754	payment	1726	1726	1874	1	1	1169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UnaBEdbRaL7HL3qSmArUSpnHAxvB11p1ZSz26Wwt76p7dBUm
6763	payment	1726	1726	1874	1	1	1177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAb5MivbzokMAYWBQ9MXPnxCZQFFjg2uYAAUfGiU4om5vY7Rc
6767	payment	1726	1726	1874	1	1	1181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusA1ETvb4X2ubJqhNP4qehJ9qeq4JpdFWoRScbEiGvk1wn5Av
6772	payment	1726	1726	1874	1	1	1186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWiLYJax8YLGPmsokzyYW9LHpjQeZsdcTizSHRBAFFBJJB1wu
6788	payment	1726	1726	1874	1	1	1201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziUcyzkHRPYcZu1nPDHe2TN3pKbwohAa835f81p6YQLDaef3P
6792	payment	1726	1726	1874	1	1	1205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZiARngBqMJgheUjxUx7V8BCqK4St7bdtQ5vfKfyzuiQH5vE4
6793	payment	1726	1726	1874	1	1	1206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYza4EgPKZjzxRSKkouTFRUCztJCRRSfyDeqdsca3GuLKuvMcs6
6796	payment	1726	1726	1874	1	1	1209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabpxfi2PztvVyQcr72UDBmbGviAxGQ71FspdSazYnNkRevH4L
6797	payment	1726	1726	1874	1	1	1210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3ZWDEiVNrKsUuPEi6kSHHKc1gLEfhmFUmYNJrHjfSPNE5dCe
6801	payment	1726	1726	1874	1	1	1214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYy4r28gBFTnnEVbAgqB5CjGYUn8jPsSAx5o92ixcuuDsVUR2k
6808	payment	1726	1726	1874	1	1	1221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcBagRPLxYq67EaSRUbQ3otAnMpeHzRwfDAS1u4LVjfu16Fzg
6814	payment	1726	1726	1874	1	1	1226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNsLc83DZXoLg6Q4Ujc5JqFrCabkgMgPaUomN98YbK3LupoGu
6821	payment	1726	1726	1874	1	1	1233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixBdxaGDBW3nNVX4dmFr5FU2zshghAgkUNMg8getizPt8ocHU
6822	payment	1726	1726	1874	1	1	1234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZzw9kgLTCPxrTRqoUvmy5QLyuu5vNSxMEcHPz4fXH2LQVEBd
6826	payment	1726	1726	1874	1	1	1237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFPViZmN1AAhYoCbYi3SbkRNCnr5y3JtjHB5kUijS7eeGQeA8
6836	payment	1726	1726	1874	1	1	1244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFp73wM5q9yo1tz954gkDqupxzwaV1pATe5P34SpUEAULYZNw8
6837	payment	1726	1726	1874	1	1	1245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5nhPU3v7khJtKhLZnyjZtBvgsudKoug6CvALSuQkLBU1nEcW
6838	payment	1726	1726	1874	1	1	1246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtT2fzAXnt8KfVyhJvHdKM4iCNZgVrDW4M53R1G9hgA51ohJJ
6842	payment	1726	1726	1874	1	1	1250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Qyr1zNsEtPbM19xiuapWjVP7zmUb1jZkHXXT6ozFEBvSmMS
6845	payment	1726	1726	1874	1	1	1253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9npMv9apFYzpGNWi2VkjfErEZ7Zd9kM53DxyQHNPeLR8uC6i
6846	payment	1726	1726	1874	1	1	1254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SuGM7zgzG39QvUprUG7BJh2xfYd9BS4HLmfWVDGXqcmF7SB5
6848	payment	1726	1726	1874	1	1	1256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hC8N4XBLyAcrt5FwF7wDyjTrrRCmWqzoJ3VXXDe2Jsb9RcSr
6849	payment	1726	1726	1874	1	1	1257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqo1tYy14FNyGhjRJZLTYEjR4UfNKtmysm8qsrXtkaW2AtEYp
6852	payment	1726	1726	1874	1	1	1260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbb93WHKcbmk6nHYr2TRY17Vt6KSZEgu1NkRVueZ1xBYzeFdjP
6853	payment	1726	1726	1874	1	1	1261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7R5mqhEmaPodogm4Wi8yCUFsiKGNp3mddSnTbB6DWacPqK4BS
6856	payment	1726	1726	1874	1	1	1263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDywhdopE2zWLj3AmnLPkTUKYaRvRk7em1r1vKb6sd6aJtzZYN
6857	payment	1726	1726	1874	1	1	1264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR2K917jDBF8VkbXxbogqdk53c9KF3dP4yHkPum2cjSSEYDfB
6858	payment	1726	1726	1874	1	1	1265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwuLLEeRT4YvorWrP1or3mYDdFvKzooqv22sHv2ki34Sodf4e
6861	payment	1726	1726	1874	1	1	1268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNqfktwgRRWDiTRqWYk7DfCFKYgGSSY4BxyiPGWRNeKoxq7UV
6864	payment	1726	1726	1874	1	1	1271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56yWkWFF9F9dcaAFYjvpwXopzYhUvX4yGbCMf1N9i1UzFfUqf
6865	payment	1726	1726	1874	1	1	1272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTTZqaRuv7fWdUSBQzURhzKphusGWuvscXVW1fvh5htLsh8SY
6869	payment	1726	1726	1874	1	1	1276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9c27pDj4RZQ7q31W8Gx5VhxMfUf8vnsQJqtyLJ6QXiEDhJ2B
6884	payment	1726	1726	1874	1	1	1291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin55f4U8FtDWdxxgPtxhnLSvTsy7p2HTD9mAG5YRychHNoytc
6885	payment	1726	1726	1874	1	1	1292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrRPQhdW51WAFZ8Xm2peMf4ZJqGXmYJuzPr7sptcpZmyzWKpe
6887	payment	1726	1726	1874	1	1	1294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwpjiZTQZTHKENCfoHMfYtTiBSULmiUjCMTyQCzT8ZWRJVhbs
6831	payment	1726	1726	1874	1	1	1240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQjxWcADmz2aHRpxubNpKG1zgVX8qhrA6zSHJtiiyNvSVC8dY
6832	payment	1726	1726	1874	1	1	1241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7jJcrDPWyQBnA79nSBpRpvFmYL2pnrLu2zAhENV5fk3EGsdg
6841	payment	1726	1726	1874	1	1	1249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4et1vGJ5cbC4cXtZLkuQD4DJfCC6fZDqboWZ5CRDhg4SV1KBm
6866	payment	1726	1726	1874	1	1	1273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzzQYZZBmKMWNuSaV1aERvY8V1BdSSCSrsJY3164KfGxAR1Fm
6873	payment	1726	1726	1874	1	1	1280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPjYQCroTxtJckeLhKhm4KPw13sgXAFXTw834Yt6WKJmsY3Dz
6874	payment	1726	1726	603	1	1	1281	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiJ6jEthgHHFhsTu2E7H53v1yn21NJUirsFfz3CzFuHXWvZJU5
6875	payment	1726	1726	1919	1	1	1282	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZxLWrM5fhjaR4jpyhmxcRojr7dsSHL7vqNnHQXdxaS2VY9EHe4
6876	payment	1726	1726	1920	1	1	1283	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaC8p21dwfdcsQfwhkfNJ4HdFQ2nDAe6Qwmhkxn424zMhYF5dWC
6877	payment	1726	1726	1921	1	1	1284	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFBpcfUQtFWtvW6cSU5nwa7t91S6s6UxC3KeMXaBg2jMAiJMVf
6878	payment	1726	1726	1922	1	1	1285	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvDemoSgQJFTK9U7ssQ6Qt1YQy843YJEhhYaHMSpoPhTTPd2g6
6879	payment	1726	1726	1874	1	1	1286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jriakdoMFBssk9yTwGfhZaACZnKwcRBha3wtac92XAmRFje1
6880	payment	1726	1726	1923	1	1	1287	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2pEBRxEJDi6jJj16GmgVG8AMBuLFkrGDqoSc3ZenuhNvKJqqg
6881	payment	1726	1726	1874	1	1	1288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpc6zw5BmCDcFnck3MVguvUGs1nbN88oWurNAet1v4NM7FNDeM
6900	payment	1726	1726	1874	1	1	1306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FKFUh35kKyP8uKf14nyurLswLZ5VkqoUCMKZmDQ1B2xgXf4Z
6890	payment	1726	1726	1874	1	1	1297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbkTzfQUa4Ww2hwChRBwix4R86QC2hoZY1JnwAZtpsTg2BPfT
6893	payment	1726	1726	1874	1	1	1300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKC3xnLukFxK96gVoczJcBiVcvusq7SjYi75RZPNTSbu84nSBQ
6897	payment	1726	1726	1874	1	1	1304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ674n4B2FmfFwGeuvTaGtNXNPufrcv6sgPBtiW1NTrcF2tzitx
6906	payment	1726	1726	1874	1	1	1311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCAJ4mveXs748H1tM9CNM29JzxFtfuZRQA41U8YaYGgeVqEtd
6907	payment	1726	1726	1874	1	1	1312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKCWRVnFrqYzYmXSdqDehC8otX6eGbtS5UehZi1bXCUymz9Yh
6910	payment	1726	1726	1874	1	1	1314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqWgvdJapXAeP4NFBuo8rTU92dGFBxw5AEuxSaGaKNQ6Nnz84
6911	payment	1726	1726	1874	1	1	1315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJFjCoQ4HhUNnee6Z6FQ6v1aCANbTStkG8g7nUNYUEbXcN5gc
6912	delegation	1750	1750	1745	1	1	8	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb5a1w2gZ2ygdzrgYs4JA3ouHFMYiab39oaxRofGroCkMcqXe
6913	payment	1745	1745	1924	1	1	2	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxExWgF93yx3nGd7hNdPR7T1CwA5gtUx6qaVD9wa14HTizgtoR
6891	payment	1726	1726	1874	1	1	1298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqgSNviwqzWRKUnHBiGpqPnx5egbnA3KohxpDvuFVfNawBbiV
6892	payment	1726	1726	1874	1	1	1299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2FXYaChv35YqmWNRn7Zq64evTx5RSpjyhfU4aqzokUD86b15
6895	payment	1726	1726	1874	1	1	1302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBDVxzmZxWPnykd14u8fqLqiHfhBjHUhHsQVxMPrm6Bdhy3V1
6896	payment	1726	1726	1874	1	1	1303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe6i5nhtCJ8BCMu58LzE1MtearU9ZuMePgZEEiL8orgsmrcgr
6901	payment	1726	1726	1874	1	1	1307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcquecdWWaeS7TXt3sXovtCwjuWtM3AFT82VbvR6ru2oGqM61f
6902	delegation	1750	1750	1745	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiXW6EvL8PueEERbckYbEL9CtUGqpuqgBtTtaC32H5TaL5DFP
6904	payment	1726	1726	1874	1	1	1309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhuKr42xBEmw7fWJe2ETBhWCuKfWjEgueNnX2kewxTRaFUVKV
6905	payment	1726	1726	1874	1	1	1310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWawmuep51AcCQpBrrdZYSKVpGGeyjhAgfaus7TW67mtFBZxej
6908	payment	1726	1726	1874	1	1	1313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzze8P3veDVponYxX3ZKXKS8AtHLive14yAtfPHTtra8BSfEj
6909	delegation	1750	1750	1745	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmaMrxpN24jPwYiFuGZs9VJg6JhJQCi5vnASCaeCZZbq2wm7e
6914	payment	1726	1726	1874	1	1	1316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7pRpr3MFb2Xdcw4nqSGCAX9tjRoEqv8c8j6jmtwjHbzpbPC9
6915	payment	1726	1726	1874	1	1	1317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ8RDWXrE9A6LPt8JB4nPN8J7b9xHrca261oVreppZ6nbQzNn
6916	payment	1726	1726	1874	1	1	1318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ8LuPc3e8ihWdgBUSNvwjtGB8rY2Y2ou1ETwZgyFVo37YrGN
6917	payment	1726	1726	1874	1	1	1319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBvJhPmSAHkz72K1uznoWFzur3wAM5RnwuoyNgY9Lg6xisK2L
6918	payment	1745	1745	1925	1	1	3	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjN2YRFiAtjBBqafMZw885Ewtou9fEWYFZdJgag9jHX6uSjfw
6919	payment	1726	1726	1874	1	1	1320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX8dKtQMbt8twqNwU8j6KUz8yvbt3mbiYRwEENrJnxWLMsJ7r
6920	delegation	1750	1750	1745	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1adGuSFWM8n3q1zscaHELjMFghG9Da8qf7E9K4CxmwLTNmrN
6921	payment	1745	1745	1926	1	1	4	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRNjuEwooWZhvTDpgtve8pMjMYYcc5MK3c2Xa5rnFXKY4EQ4v
6922	delegation	1919	1919	1483	1	1	0	\N	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhiCqXmpYc9DU5VG7x1KfDijKbJ6bu87uvC6jebPrYg6XMzuc
6923	payment	1726	1726	1874	1	1	1321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPN3y2JtQHwcgK3fiqbzKw8W28AAa1HAVCoqQ4nEqH79g8HUs
6924	delegation	1750	1750	1745	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLPzv7Nn1ZTM4Eb13DReUy8qBhAogJuNrYZu6rSrLTaPtPsqS
6925	delegation	1752	1752	1735	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtW31BWV8E8LuA1srQsNhJHKW4vby1pcc55YLJSGw65XARWzzV
6926	payment	1726	1726	1874	1	1	1322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE6EzbdmYAyFahr1CTL5iigPDcx7F5VJ6R1uWHAHaPW5c35GJ
6927	payment	1726	1726	1874	1	1	1323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fEZ1i7wszjvkg7m6pHwCKn4XgJ9sfZNq6n6GLKMFL8RFGc5i
6928	delegation	1752	1752	1735	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVR3MXHxGrW9P9GemvPtsawQ5o5RTayKb2Gc6pkWHwyHUzfmb
6929	payment	1726	1726	1874	1	1	1324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2a2c81cAV4ppZMyBoEwfUr4viyAxTYxvdh9ZAP5ZkTkjZh74
6930	payment	1726	1726	1874	1	1	1325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefPq2e2FFvFjFEicbfySB5gXmEWFSxi7NQNK2HfeDyvBKfPeS
6931	payment	1726	1726	1874	1	1	1326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWddUWDxLk1WUzkHLAHEizwj5SkiW9yVCSJN4RWqwiiVWQcfCQ
6932	payment	1726	1726	1874	1	1	1327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSEqQ4uNPGfXL4T7wneN4wYG3K5YwHjhPpUiSjfuxgGJ4Sx7x
6933	delegation	1750	1750	1745	1	1	11	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpjrLzs3SMVkCMRWZkBVR5xkdoJfySCirobtkriPRHosTGSfY
6934	payment	1726	1726	1874	1	1	1328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbW2rHuqMzY974LqxtBkAQ6mzkFxfQwWHCjytfXeUwMDd4DXt
6935	delegation	1750	1750	1745	1	1	12	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwVxx955TyLZ6dGMk3QZALBSNPLm2Gqhe9XCNiaqx587tMQQv
6936	delegation	1750	1750	1745	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3LZtxByCVXTvbvzxNYoWG85sLLBawABGqTxk8m8E2a4pu3SE
6937	payment	1726	1726	1927	1	1	1329	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsc7jWKAzJduFbb8bRzqMBjGQd5JHShXsv7ffUymVemCuP8ozL
6938	payment	1726	1726	1874	1	1	1330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDie7VhURiqNsaZQFUMLVg5QqeJgKPAmMpzMUmwrtGYzztMutk
6939	payment	1726	1726	1874	1	1	1331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxwQiqYPj4s4P3WRoNc3AFQdaxT5gbCFyjcSFS4y8RPxN7bWEw
6940	delegation	1750	1750	1745	1	1	14	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLzG2MPWZETKYBEE5FthSYYnhfoxd6Uehka7mp1A1HjPKdqjc
6941	payment	1726	1726	1874	1	1	1332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNFxrHe5atDNkfGP68YEajcPdYZYCN2NVPnut1SArbZy2fhw
6942	payment	1726	1726	1874	1	1	1333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvV4y99VXN9XJ5RJYCZrzkLWTBvr1rbTcBU14HBDuxeW44Ye8S
6943	payment	1726	1726	1874	1	1	1334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1HH2BdvuA1BiDBYkugfj15KLEQjqHkXUaP1aUqjPQpcmt3Vm
6947	payment	1726	1726	1874	1	1	1338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5NPnbKjriu4YishiNW2rbewvoCiXQmYkJXrMaLrxckG1bbvC
6955	payment	1726	1726	1874	1	1	1345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFBr3i7KtCrwP5mG5RGNw6wYjBRno2wWVwBUP1zR7ji7rVMk9
6964	payment	1726	1726	1874	1	1	1353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGL3TE3rXvYuDU9obK8wpRtCDw2xHjZT38QuA6xHY712wzY4Lg
6965	payment	1726	1726	1874	1	1	1354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYk543qsdx7vXLHGMPKmaLHH6Sqg7YK6vCAq83xDawqajMh78
6972	payment	1726	1726	1874	1	1	1361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7cPLuSj1ihnqz3PKuSWDRBCyeyCzgZbY4MumVucUL8y4pWd4
6973	payment	1726	1726	1874	1	1	1362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFNdFXoi8raeX5CFKzQnE9kbFkNn1eskMwovnrgs9nwQoNwJ7
6987	payment	1726	1726	1874	1	1	1376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbT91XymSuJretc9UJmuzAeYcvEhfAdBEGN2ebHZViup6gEYj
6989	payment	1726	1726	1874	1	1	1378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jZnt77bpqDtgMBJ5NYbvwf6VQtGZuEUxLEhc9RighYvBY5M2
6990	payment	1726	1726	1874	1	1	1379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GvnipFNcrDKXEQcJXGTuvn9dxWbkYbkWoXwzWRvMfAcSbG7k
6994	payment	1726	1726	1874	1	1	1383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGNpPu47WwzaURMVekzEKonrwK1eEJ26T7pueJwPyNh92e4HM
6996	payment	1726	1726	1874	1	1	1385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3qGWozASFbQh8Xv3tBaZRNBKXRMojN9VhY84FbyQM8XRA8ED
6997	payment	1726	1726	1874	1	1	1386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFhcLDDFCoo7nvG1Zw4UN5Ht3zNYgtgmnySLweeKrA3TbY3j4
6998	payment	1726	1726	1874	1	1	1387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Dgk8fczSvTFRoJvuajMBy2cxuM2C1kyuGjHNzMKZ3HSPNyZy
7008	payment	1726	1726	1874	1	1	1397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCfM5LcUCsfzeLY2jyDiN6W8iiDNSxXnbqQBMCnwko14g3M49
7009	payment	1726	1726	1874	1	1	1398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsrkDj2bCYGomurWJG4pQRfvqZvfbJLPYBCLzqpxpTV2nCAoJ
7023	payment	1726	1726	1874	1	1	1412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAtmyy4yPmhM9Ymx8SjUZkb745Vzck9nxCHGUKPQxCqUQ43c6
7025	payment	1726	1726	1874	1	1	1414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdwB8daQvxXkQnr8fBRRxfCbd9k9XUgS2176AKibKmcSSPwRY
7026	payment	1726	1726	1874	1	1	1415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJ9seQkFSKkwWk7MW1SkeF7CnWB6xpvGpyWy1fmBAc58BxQoV
7031	payment	1726	1726	1874	1	1	1420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhinQHXcK7KTDhdcPHiSxBeRxWatpVCssejk4fUMP5rLsJmLLB
7039	payment	1726	1726	1874	1	1	1428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqiDXcLcQXkx2rVctaJCJh6HF2agbUVcVU2Jh6ck4WTLSWfF8
7040	payment	1726	1726	1874	1	1	1429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQx347cRqNGE27bsLELEVjoqcjJDBJiSyidjPoHZHcZoRHaHUo
7076	payment	1726	1726	1874	1	1	1459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRS2HQBbvJgM4F5M9gimu1U3PXMFFmyt8xQTBVJVZruAS3TsQ
7077	delegation	1931	1931	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCjpfJZUA4GH2ZC1DP2QPBeRTXKc9tFVS1yV5XP1iTHV7vwhd
7080	payment	1726	1726	1874	1	1	1462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqX87CcepivxUXUG4a88yDBrAMWAKpFTmrQHjkrPbA4zZ9ZXB
7081	payment	1726	1726	1874	1	1	1463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSgDXWP2vL4uFxadVFy8a3heHAT3isoweYE4osYGwoFWFt1Xxa
7091	payment	1726	1726	1874	1	1	1470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVqGM8RAZdBPghZ5kQsYHWeaDd3CUa5iP7EP4NAwf2WJxGMMR
7116	payment	1726	1726	1874	1	1	1489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3v4kjvn1XzVcLdZz11teqnRAueLHney5fqS2CLsEhpmvCshz
7119	payment	1726	1726	1874	1	1	1492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqV4ZuMoX3gNWoKvb26D55svoS7ymJW3m1RXaosKcmVogR6Ly
7122	payment	1726	1726	1874	1	1	1495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBurMsyMyp5VSH552Ctzu4ABHJ15TiwH9oJ319TNR4nZMi19E
7123	payment	1726	1726	1874	1	1	1496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7xDXMX29TDHrnmgPb32pS9sK8NXkWPQWychNp7HKiM6MBdXs
7128	payment	1726	1726	1934	1	1	1501	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhdN3mGEyiqdm7kZKcMu5mKezxFLgpm7PxJWnkuyvdmffE6RFT
7129	payment	1726	1726	1874	1	1	1502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3EjG4adFEQvcTQobGpLhrvYCvWeZ9nvSVFkWASUp56cQeBaC
7130	payment	1726	1726	1935	1	1	1503	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8bhWRZ3ZqWptHJ66yGefZ7esmssfamcjCYPj9QXrZgrywUjuV
7131	payment	1726	1726	1936	1	1	1504	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFaCfkBw5byFdPxhTM7ofBe69bB6kS7DxzVkBxsGk88sojhsoE
7132	payment	1726	1726	1937	1	1	1505	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXnufA7THeeg93vjc9d39PQPuMbEB6euPyN8TCxd2sNfC8257F
7133	payment	1726	1726	1938	1	1	1506	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbFfcJk26SKHf2jVHi6Jiiyf61b5dbfWFYQpS6zsbyouLb79cT
6944	payment	1726	1726	1874	1	1	1335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGcYDoeM42LjH4CSDaWkGhrWuejAT4ZZCsyjT2wAUvtENtqUU
6963	payment	1726	1726	1874	1	1	1352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4T4AGVVoRHj2bsfr1dBaCLYctpuKLYAkNnoyRpG4ZzLYeGszg
6966	payment	1726	1726	1874	1	1	1355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiaQKxduvLmR5HcneQj7HMFuLet97m6BVh3REY3ZSDATRFLAV
6967	payment	1726	1726	1874	1	1	1356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snpwN7xvuKTHa2ArNEktip7wHNZ6wR5h8anvQJdQXJS2d5VY
6970	payment	1726	1726	1874	1	1	1359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgKEFSWd4FLKoRZoQyKE9rsz1XdDiBmMxGDSh83ob8nfWp8y2
6980	payment	1726	1726	1874	1	1	1369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmu2tYNXaNN5cqspW4KEjwWLoPYAHxRKsvrNC3EqccS6Uv4kc
6981	payment	1726	1726	1874	1	1	1370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wf6mUz9oKRytQF7rELVeDrh2NCsUEWSYt67MuSm2omcMDvgR
6982	payment	1726	1726	1928	1	1	1371	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZxcmbb6j5XWfHgCyCP781emoYswa4NMeUpU6Wc3ELbDvoGnAEM
6983	payment	1726	1726	1874	1	1	1372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGNfF6XqqD4aXVueuoeKqFR5XLqRTwi3LFnxcZ9pZTADJA5gY
6984	payment	1726	1726	1874	1	1	1373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38gM13TwQvtJVdP5R9DtYGELHNDBEoWkVj9dP6oFqWkLpi44d
6985	payment	1726	1726	1874	1	1	1374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5cC4ZANGB26ZxSzi9gqiggMeKRcxEddsPFgTTP1eVCtoSmv2
6999	payment	1726	1726	1874	1	1	1388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdSfR196EQQXaWaMBu8WCEZdELg31eCaMb3pBw7RxNtZNwrAix
7006	payment	1726	1726	1874	1	1	1395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4cHQkRmoFgeew55Rhfsn6mjtxbbb5aFrNzadmMnK7Q1vLk3a
7010	payment	1726	1726	1874	1	1	1399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBnFzDbjtFv3oMduZWUyYZCY7PbhqZ8vx7mE6ksxuQx7bccGx
7014	payment	1726	1726	1874	1	1	1403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJzgjfn7iS9jW8SDar6gnyvdjiaqXsGNarJzcUnotvKMfPYbW
7021	payment	1726	1726	1874	1	1	1410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2FD4NKgqqUWAJNRvJngiyUcvxAMTBUAEqSZmGjETTsqiYFYf
7028	payment	1726	1726	1874	1	1	1417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwh2ZGwjFy3dB95ZYw3cyEaxpUgHDSn7yiRQcvHaUPCixfyMuD
7029	payment	1726	1726	1874	1	1	1418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7hqPDfWjhTmfRrtY95kAJSUbrqTzXkEPQM7vyAQdVAtuTAsq
7030	payment	1726	1726	1930	1	1	1419	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbWAi1t4gA1DjwKvQ62Yp3A1fxxaBBNT31MBzpmAMroyiq5FAz
7033	payment	1726	1726	1874	1	1	1422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtcsEJ1Af6NGwPby6z9bV9N5p6UPAvYma1dfC2Z8hZKrH7PKJ
7034	payment	1726	1726	1874	1	1	1423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLJ8tTj7ZHDw4kJisAGUykaioJUzoP2fscKjJnfGkkTaEbPi2
7042	payment	1726	1726	1874	1	1	1431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2yE6ACbJka4WpXBvLfz8rBzeVrYVALbMxHa6cVQ9LJdGac3U
7045	payment	1726	1726	1874	1	1	1434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KYXR1zWUSN3Gyn4iKWnSBCNSsvXu4ebK3DaPy6GqL1r3curW
7046	payment	1726	1726	1874	1	1	1435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAr57S2KnsnoykZnkbEgSiPSS8CKw9hmvTRPUNEQ3Eb6bJxbQ
7050	payment	1726	1726	1874	1	1	1438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcJgMEhCZdKpPP5hnRW1zVySEn4hxY11ybr1cX5GYCw4DBMFR
7053	payment	1929	1929	1929	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHayJr3g316fhe7gVP8LpcQxMxjNdiEBDkMzB6dEAPXaLNJuqL
7054	payment	1726	1726	1874	1	1	1441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TwLmEkLtpLh16S5hdxTZHDJYk6vP5bWro2ttNQnn18BHxcrb
7055	payment	1726	1726	1874	1	1	1442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRB1zWihAPpC8UnXaJAkPnYqdcx3kLXSz8xB31sMnhXdcApoVj
7056	payment	1726	1726	1874	1	1	1443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYw9m5tmVb1DHPoYe7y3NnJhNDgz5JeKTfrMwoaFDr7d8h8k1s
7057	payment	1726	1726	1874	1	1	1444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyG8cDpMc3f6soLL1Evr75DWpRXa3B55pfDxSKtYeZD5mXyp9E
7058	payment	1726	1726	1874	1	1	1445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1qKKekHbCeCsJaLcgHSZrAHVWMZ7PKp8YXbQUGPExPfZ4Vhp
7059	payment	1726	1726	1874	1	1	1446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBFkQTQgYPB6YWkFAvfa2mTXH8enz6VHyFFef9qdVo4iq9WSN
7060	delegation	310	310	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdc9rXmF7LgeA14LGxjEG2oLt8r1KSWZPyRreoRoDVPhZPzJw
7068	payment	1726	1726	1874	1	1	1452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowCD486ZH4fGaUc9znUBUgwNxss8osrNzpjesxv77H8VH27gf
7072	payment	1726	1726	1874	1	1	1456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZwCNfe8sHEN1A2WhsGwzXe6J4hDfaJEjfS4WBDKZ9m9gL9Do
7073	payment	1726	1726	1874	1	1	1457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdfLS2MP6kCZxTaVfXbpBs4j9w31JUW1y38qeLW7iD4coL7HX
7074	payment	1521	1521	1931	1	1	3	1010000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFUhNGhUN6tgVEak1NoasmsHoqCLATRoHPiiQtyE8iNEWvXjE
7079	payment	1726	1726	1874	1	1	1461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tjZ46sUwv5DMixBGkQH3SvZiyUR7CkfNGf5tF6D7LS1LNcq7
6945	payment	1726	1726	1874	1	1	1336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuon82y5V2dbsSsjqaVUcdL2oZiT7LfSkU4Jq46EFENFVXeJxY
6946	payment	1726	1726	1874	1	1	1337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8XW1PPA1PiELwmYeJNMzFrnYVWf3THD1rpvkH2RuoDf4VsDk
6956	payment	1726	1726	1874	1	1	1346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSKNp9JPPLdijXJL4zR9SvZUjieUbFyffvHtYkTvXW6NfAvXM
6968	payment	1726	1726	1874	1	1	1357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFxxJBRuMKyeV4icnaB1KXPGdYEJnoLbz5YQJD7FL4Q1XzRpY
6969	payment	1726	1726	1874	1	1	1358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhypkxJhycABCeYaGFKxBBXFA4stJiDgoZ2NfXvSUkvwcYf26R
6976	payment	1726	1726	1874	1	1	1365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTNip6C4kVGjMuArn2F9oun5DsAA6QeykVzksjfM41dCzi14d
6988	payment	1726	1726	1874	1	1	1377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVodBfRZ4iqJdMcgTEkWZ7w2i1Qsxst2xUn9pkY91ebKaueqL4
6992	payment	1726	1726	1874	1	1	1381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tpsBrBf35KMD8UXvZTGPQGE279YXeBe5Gkecwke98WuPuAJd
6993	payment	1726	1726	1874	1	1	1382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgGz43rBf1otD2YEVwGDQdKk1xBaz7kyHEh5upms26DThudpE
7000	payment	1726	1726	1874	1	1	1389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNXBAwnmpSGnxJibWcoyPKmPHhmaXe6dSoKqeR8aVz5KKvkMX
7001	payment	1726	1726	1874	1	1	1390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNyudAB4t9ftMPo8iBymBvb8PmQSgFfEfWT2pVwBL2v1wwdfx
7002	payment	1726	1726	1874	1	1	1391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAx5xBRW35RBmNxZDxd8kPkpL8J35QQzxbJ8kANp3fCnBfqqA
7003	payment	1726	1726	1874	1	1	1392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHVZxdHa8b7sxPZPxL5kkzbpdaYv1xxS9xbYRw87cb3j8kYx3
7004	payment	1726	1726	1874	1	1	1393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvtSvc2hndwbEhYixWhr6cVd7hTUdnLxwxMNZHdXkTqzydUai
7005	payment	1726	1726	1874	1	1	1394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3MMxYAnqLxsjyHTED1SwdmGMZefFt8LowWzuoiAayJ7S8TkU
7012	payment	1726	1726	1874	1	1	1401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pN82carpCMNaMiWRr8CCmMTnS8HY84RHRRcyibSk6JHtkJk2
7013	payment	1726	1726	1874	1	1	1402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1scYAry8xLf5j3fkbcDShfdSDxTxjj8AQRPPjq6VcKSadrVRC
7016	payment	1726	1726	1874	1	1	1405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUr87zLi9FY2byE6S12E64cc96PFjuuELi26zNhyMv93krWWM
7017	payment	1726	1726	1874	1	1	1406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJQpDZ5ySgbT94BxAdB1mQjgzVivnGDJJ91xWvXNvuvc6aKvM
7022	payment	1726	1726	1874	1	1	1411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNedwaNFsmFoh4WpDHpepjNp2rzj18LW3NqmNtJsM5yKTBUM2
7027	payment	1726	1726	1874	1	1	1416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqo2K2SBQZmhTZs6A5VPjwD7tDWxZA78tqE4BCme9HcECZTpa
7032	payment	1726	1726	1874	1	1	1421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfdLjqUHGUzh8j3jYVCbNpFyT6oNRZGYz5yXErasZMDinwwbe
7035	payment	1726	1726	1874	1	1	1424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QPTHiwE1Kwe6GtHummu7uQHRjM1HAAdGg5wK179cU44GMHzY
7043	payment	1726	1726	1874	1	1	1432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CqxaagW9LPHyXRddJVBugBMnNaPW3gqAn3LXLVJRnHQiCkWR
7044	payment	1726	1726	1874	1	1	1433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnJZZotjAQq16NtdswDzJWJVsd542JAy4eS75AVxq9q59KtAX
7047	payment	1726	1726	1874	1	1	1436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBKiFBK6M3dnPxpAgnuyPoHQzUEeAS3vq7gFrrYZaYtcUtvrt
7048	payment	1726	1726	1874	1	1	1437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9b1cHAafzNYDxag66wQeG7MSbb45vT9aM7cPSyMJmnLWjMMUQ
7049	payment	1521	1521	310	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsd4XmjHbgzCnAR9HEamw6WAaBXzUv127YyKoqdWe1o3Vkd5ie
7051	payment	1726	1726	1874	1	1	1439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v6f2fKpb5LLwcATFcMaPoBBRpxmZZ8H1Eu7NZj4WgML1rDdH
7052	payment	1726	1726	1874	1	1	1440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyziYxJnRXtXfeTpLbZZvGbtM3oHtBwtwZYciTrwktBVGyFTL
7061	payment	1726	1726	1874	1	1	1447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ucKjwPiheQLu9fBZ4unMtjTJSpM7ZUfNiZQ11bNmXa7mQjmx
7062	payment	1726	1726	1874	1	1	1448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7oYvoAekJGfW9REoXVNqgXTKPX3Tu5y9BkDERHj7BY9hbBpM
7066	delegation	305	305	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYQo8xT8SvS5MNXrwMUMNF8esH7Dkp3am45tzc28MjmciNxqx
7067	payment	1726	1726	1874	1	1	1451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbvioDFUh2WRKgkhRPbKT6XPoRafg5wctp8yWWpm6sN6AneG9
7069	payment	1726	1726	1874	1	1	1453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83LdXQadvMTsYwsaVAGiQX67BrihZ8AjbfMXNW56VLfoFK9qJ
7070	payment	1726	1726	1874	1	1	1454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaDSuQBJZJPdBWtttog5mBRYRoREhioe2f1EEMxyxZwiAbrbK
7071	payment	1726	1726	1874	1	1	1455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDGUbkYhJrn56bt3DBJDPBjW6SEjPo8UuAHeTCH9uMC7CFCBL
7075	payment	1726	1726	1874	1	1	1458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgazHJ1iB5uuSPCF4hWChHzyvneEAZF9QBqkWQpoPFy6P192s
6948	payment	1726	1726	1874	1	1	1339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPrdMQkEZGQfBFHT3psjvnzpD2Lk7HhffpYjpsQXPsRAKbEgM
6949	payment	1726	1726	1874	1	1	1340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwv6JH46EsvmprL1v4VZVpTJehajPZ4rvdx4GH9saQhvc1NE9
6950	payment	1726	1726	1874	1	1	1341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSrf9oQtHNsfzu69wb2z64P5FxdYYjan1beRJZZWkPLH1y97B
6951	payment	1726	1726	1874	1	1	1342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLgftPEJJ2pNCsobzWtMqAs2WHwq5zU2eM76sQm3gxcHadWU6
6952	payment	1726	1726	1874	1	1	1343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1D82svY9AdZ1phyJbVZDaJR8yzTRdr8joVm7bQZodQN8bhBc
6953	payment	1726	1726	1874	1	1	1344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUpsmJpmcKSrvf4zMio8VKgNDLHBT36u4yfksQ6dP2ifLf9Ba
6954	delegation	1750	1750	1745	1	1	15	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngEFNUrNinBBDe9EES5a1xd79mUhicKH9aeEx1afcysoJK7PU
6957	payment	1726	1726	1874	1	1	1347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuh5RQfJrPJoctM81Vk7GvDmi4xMQSrzHoL8mU78AehXXDQUN
6958	payment	1726	1726	1874	1	1	1348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvC3zydtk6kGvxeUeferU9Er1cwnbLcvfyu4dGiq8ExDTymvL
6959	payment	1726	1726	1874	1	1	1349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQagsKzX13D9wiF2B7RHP98M2iz89HYhpgji9usoGp9HrsXpcb
6960	delegation	1883	1883	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQAFkKCrSrogShRF1BdAAB3jfCSqMZmXhrAUGWjgMWZqzYBWh
6961	payment	1726	1726	1874	1	1	1350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJN6U2zkvFw2pPgHVoaKftJE4849vkFnicUsgGpVBp2jArSMDn
6962	payment	1726	1726	1874	1	1	1351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVTECeAhJ4GW5HJoASHH8TRgFWffgAexCkMsWicsudQ7qGLxp
6971	payment	1726	1726	1874	1	1	1360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2xKsEWaAKLJbXRNFNFP6oiyuZg8UqNbhwH52uTheYdpc9crS
6974	payment	1726	1726	1874	1	1	1363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU5QTaNgArbxZKKQqBJAhdTSY1GChAVcxkjwfnYZY9zUwYJ3M
6975	payment	1726	1726	1874	1	1	1364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjL4QMyMMxxNRnXWFbFLmKQiLa2UcwL3KhZ1yPnwfi1RimzcZ
6977	payment	1726	1726	1874	1	1	1366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dsZonn42jKPxPwxcgCJYGArBF6eNoKTpywTFTFeKSjpAzZ4S
6978	payment	1726	1726	1874	1	1	1367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cB6fdUKEwXyqpCGwtb7zgYRUMkfQqEHHbFLUgHSAWsMjoPg1
6979	payment	1726	1726	1874	1	1	1368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfTMtDzzmTKZ6o4XTr7d9hcaUCnTJYDDwvj55sGobGbiemb84
6986	payment	1726	1726	1874	1	1	1375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVDcNNNteCHY9vDqj7CtJiz7FyHX7arcqQr9J77CS3L2USmub
6991	payment	1726	1726	1874	1	1	1380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZTkXpXqGHJRhbSZq7cZFFDkbijbC4c5r2irneK6tEFhYVtwJ
6995	payment	1726	1726	1874	1	1	1384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyJvHYrGWAhbHPL9nJAUzWARaTKtmtokGKrugbChcghxZ5ya7
7007	payment	1726	1726	1874	1	1	1396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYa9f5QmnrrnZPJ43a5rVTMdc9Ssj7Ad2B1MXqQmrbxhAH5uhr
7011	payment	1726	1726	1874	1	1	1400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fnrbUYGc7bTvjYT6pHdFg3cNFuGd6hetUVoFmRRFCxbT3wVe
7015	payment	1726	1726	1874	1	1	1404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZga1cvknXpbvz3iYWD4CYkHoavuEa5Bv4WfNspm8vF3JxzLgUw
7018	payment	1726	1726	1929	1	1	1407	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3KPTREwz61vs8uoPxBhFgXWoGv8qphsmqyFrQ1VLnu8BGTBCr
7019	payment	1726	1726	1929	1	1	1408	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCQRwYGVap1LhFrRGn4cET8SR3EH3UjyZ1Tq1Z81aMDxwF46Au
7020	payment	1726	1726	1874	1	1	1409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQM5YppBe3JfK43N6iuByxaLXJanLg1PVr9MbAkS1qBnPADCq6
7024	payment	1726	1726	1874	1	1	1413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXvGnyXs7Ku2gg1q7uxpGd6FqzgjLD7ATAoFzP1boiTDXvjbm
7036	payment	1726	1726	1874	1	1	1425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQTsBWorwnEUWC7UtACM4CJzuUGcvK6Liy49WgJ7jNtcShLUU
7037	payment	1726	1726	1874	1	1	1426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3RJRo9q8u683rFAaMKPn6NXYVRSq1t4BWtQvvS45RFRi9pFz
7038	payment	1726	1726	1874	1	1	1427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcD82nFkLCZbDBtgCJ4ZXKQjuBfzcLLdAEBp9pZi1283GbPRdr
7041	payment	1726	1726	1874	1	1	1430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1LtB1GE8fivRH7Sv59tf8h61y9SuJ8FKA6eWRPdSeweJ7eAz
7063	payment	1726	1726	1874	1	1	1449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQzAa44TmcV7HLSjv5qy5DJWYEbCz49Ci6DA7BLmzGy1CjjUG
7064	payment	1726	1726	1874	1	1	1450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ZRxyc7pxd6CCJ3LLUqnPQ5zjQmgUZ2QvDPDJSENT3zU6XP7
7065	payment	1521	1521	305	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kTjNtPSUPft1o3JBsKqjEAZeCq5vuz8Nia1PYdcMHAWy9nCL
7078	payment	1726	1726	1874	1	1	1460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWY5nevaRLjFSypdsceYxrx2g1QRynQ1UG5PDV6nFtyBeyF28n
7083	payment	1726	1726	1874	1	1	1465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghs4yyRmGXyqUR91jGRhkhGQp6456aw3KmgxWrmtFTDrkNPCv
7082	payment	1726	1726	1874	1	1	1464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNFAkWhGT1sLz7ggURa1Bw6XbvhA25bsX6hK4J8UhY9BB7m2Z
7110	delegation	166	166	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkRLpD54PUZNCc3RtABNmsChGgbTW3caHJAKxrPkUxFpm7biv
7117	payment	1726	1726	1874	1	1	1490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEojjEg69iFb22XTG4TGJQ5wFRku2MSG3nHoGv7iXQfmsZJ4vd
7126	payment	1726	1726	1874	1	1	1499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZLjWNWHTnRTMvHZ7W2HF6nRJBXwYCabcc969DXEyo8xmoPfK
7127	payment	1726	1726	1930	1	1	1500	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiM7UHeSGqsp58wzkH8SWA2uDQ3u6Lh7PCrofEuvHhbzsLEVDZ
7139	payment	1726	1726	1874	1	1	1511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1wKshkXCQGsug8CBoSFrB6fhd22iWr4QiUCy57L7FGyTjq5J
7140	payment	1726	1726	1874	1	1	1512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFbYcJZaHickufEErxTzD8wzDNT9THgyEKAwuaaH6TBy8Qh67
7141	delegation	1769	1769	1578	1	1	20	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy3cir3SBM9yQdEzrcF1cLr2hv7Z8G5XWsTWFnff9VpBVeLs6
7146	payment	1726	1726	1874	1	1	1516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVVK9LN5YpHPMZMYpuP1R9woLNer5xvbZfvJTT3UVdsqzyoZV
7147	payment	1726	1726	1874	1	1	1517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybgxCTmoZefxfUo7zJ5jCgoeAyTiwbbvDfH2CudDce6Tgo6uR
7154	payment	1726	1726	1874	1	1	1523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVzDpMoX8PSZQLhcQMnhHjxidyZKRi4wpE2EukKyJHQcsQipq
7155	payment	1726	1726	1874	1	1	1524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFRTYK2JPCxXSqxrkdGacgv7UHY6JuDBAx4twRUri1Akb1mkuC
7159	payment	1726	1726	1874	1	1	1528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFtmeRo3gxHizmQvgboMsvwresb1cTViATdxZ3RrcBiov38Bc
7160	payment	1726	1726	1874	1	1	1529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXVgB5LYzRmkVuoYmwDzh7zC8WqCmvVDdjH49dgBD9cyTqdxa
7164	payment	1726	1726	1874	1	1	1533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTRw7ZkXgAQheR1eSuecAHYcBUNH5hG863QfvUD3t21qmUmyY
7174	payment	1726	1726	1874	1	1	1539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSPkDNyKmiXWxPWj9h1y4CZvFAXj3RyUJABJfZ4AbNkNmD1qG
7175	payment	1726	1726	1874	1	1	1540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZF9x8FbKkmrrxThKNdQEVwu3Sn1JxkEppaUi8WH2BECEyt54E
7181	payment	1726	1726	1874	1	1	1544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgx7A5vbiJ6Q6p7uRZNSJcGrUmtY8ci3ZndhECiXs4g3Swein
7182	payment	1726	1726	1874	1	1	1545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFmeWn1Dq4CHuGjUVeYVfJTej4ag3aeupJQKK2qJaxKAgAHeC
7194	payment	1726	1726	1874	1	1	1555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUgquMYQVCrHgvmwxedRvt1TKfFjQLiUuBzpMvVFmr2N3Yfjje
7195	payment	1726	1726	1874	1	1	1556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5e5r793G3G48Bdzn272mhsiwvELbQ5uehDN9vy2uJrpFx4XoY
7202	payment	1726	1726	1874	1	1	1561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4jknAdMEss968dxoWEZdNchxqTS3vocV3XtMWLTTXysLa1C3
7203	payment	1726	1726	1944	1	1	1562	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgce4th7GEzThJFdDipQPzHtoYCJtGU6NAphGqkWqeYcnzdWR4
7204	payment	1726	1726	1874	1	1	1563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobVohczuH418bJkcDsAEmxWtsAbYy85Z9zj6TDthcNZMtVWB6
7208	payment	1726	1726	1874	1	1	1567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCop8UWzpZ4QxoUb5dodtXGmHyqRqcBrk7CkBkYxKrsaHEwctz
7218	payment	1726	1726	1874	1	1	1577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuL7zxiDSi9pfjCyKKRhubbNkvzrMcAc5kozgTLvkfoGME3qu
7219	payment	1726	1726	1874	1	1	1578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiQZe6Hdby2hqbxXrcupcDTtaTLs7AWcBt5ukEeVyqDPN8Lhn
7225	delegation	603	603	1483	1	1	0	\N	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRvXWHzc7E8FAV5DbcXLoRgf2G1HWz76QLrkWgeFntNqA17V4
7226	payment	1726	1726	1874	1	1	1584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzDD556oP3rbiGAaS3CFPXwd7jDAnTe67qGcMW5Y9Hx1vNNaU
7240	payment	1726	1726	1874	1	1	1597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTUoFt6FeVdUZjBtWspv9ZVEDQTK1J4QFRAB4k7t6oaE4pEX5
7244	payment	1726	1726	1874	1	1	1601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX58u3RsfdYvDy1HWrPQMWTKQsxkQeXdJcoQGJxs8feaNxYepu
7256	payment	1726	1726	1874	1	1	1612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUiP9LbFc9srmAYZZ2s6FWPSKXJEvZPFardUfdxJe1jRAJKcm
7257	payment	1726	1726	1874	1	1	1613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1C36FTMUzzvSWhAC7LyFMiBV1gAvxExtqEL5oB887BSR2orA
7268	payment	1726	1726	1874	1	1	1624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2StVaacQjBT51nLKWRUxpnkSXG6TEQNx3qd7YRJdZkauFe852
7272	payment	1726	1726	1874	1	1	1628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsyf9URBCKq3ZDFLpNtVXFm18nfiCn9bq1dvVbzxLgG9FHy6E
7273	payment	1726	1726	1874	1	1	1629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJj89eKJsM5baMgxRz2X1BpfqPq7RB6LceDSMq8Fc4pZQm4XQ
7276	payment	1726	1726	1874	1	1	1632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWKmHkQESx7ZpooDV8bLa1KMQrfmKjhVh1soiu5XasW1ePSuV
7288	payment	1726	1726	1874	1	1	1644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgHNiJQFaK5rHVh7RAD4RNXfkSpWuxTFkeX3epZa8Ld4VduvC
7084	payment	1596	1596	1932	1	1	5	22000000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8yQbAa9oe9YvtusywGNB7d4vyYzMfSc91phe43nTCwRp7END
7088	payment	1726	1726	1874	1	1	1468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor49w2WKWk6Y3gFt9yCov5SULZ3yYePswsYdNz2NgqJgyf4qM
7089	payment	1726	1726	1874	1	1	1469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPBiE3jnt1uZAxKTSHAijFGBFD7zv57iAmYnHWKNnZ2j5ytcA
7093	payment	1726	1726	1874	1	1	1472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPjhJFpumr9NSwgnsQa5tXy5EbKZYmCR9d96GnYN2HUjTNt91
7094	payment	1541	1541	1718	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8hEZy7QjBf41mwbrD9p54TfQkboaLqaSeyFZYhpuTmL2rAYN
7095	payment	1726	1726	1874	1	1	1473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPdJx9y93n1BCbWhzK2okxvRxZyD7FmMs8eyUMYNuuv6R85BC
7099	payment	1726	1726	1874	1	1	1476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMboYz6pxyhHKHktWrVnjnxcRAPx6JekQ2TLY1R5ZxSUZKcnp
7103	payment	1726	1726	1874	1	1	1479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA75ornrwiTmmtUUsZ4agwjsjeAYX8LtCGH9qjyLfPh8qTZkoc
7109	payment	1726	1726	1874	1	1	1483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnJB4QG3wiGKQPjQ6fdF4yW1c9gWYsPHXvxTMTjPwq724Bgtz
7113	payment	1726	1726	1874	1	1	1486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYie4pJ9z4aqwMTUCrEkyGkFFWG7xL4DZfGfwooahZ65hEksE8
7114	payment	1726	1726	1874	1	1	1487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3WcKyntbFKsAUYKz82TrwjCNojqE2CbwHQVhnKCUDU852eeV
7118	payment	1726	1726	1874	1	1	1491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwek7SYxfSBRwXbMVQqrtnCTFxEdvKyYpwmmD4akZviPjRZ1Ad
7121	payment	1726	1726	1874	1	1	1494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokAGZqsMFPUpzNbw9d7tbWki6ZUGoSdZnDcqaa9k9pNF42bys
7135	payment	1726	1726	1874	1	1	1508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsjhPdevU44fb4YCu6vi6Fj2PD2FYP8xh7G5KjhHFBDQqmGdR
7150	payment	1726	1726	1874	1	1	1519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTudisAfNYAEUDKHkXKbn3Gcw6EhcTep9MnSCQfcHpuhcSsyf
7151	payment	1726	1726	1874	1	1	1520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8U8aU1jmrqnFPL53x7Q3mcAHdGZwwA1QpegAe4ByvT1LUDLs
7156	payment	1726	1726	1874	1	1	1525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjjdvZPk7TTBSN2df8o9ibwVjR9dxo7W5FGj2pMXDbucGMhfZ
7162	payment	1726	1726	1874	1	1	1531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5D9SSAc5NcmwtMNe7aex3evB786AoyhMq5arquyn1dGLJi3Vf
7163	payment	1726	1726	1874	1	1	1532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUgtGsRCkTwxxu7XqoReoTfN7VuLyx3Xq63pWrz4ksiS7rE3v
7168	payment	1726	1726	1874	1	1	1536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkBQYNkdA2y32NeQXxsSkiAVY9kHpqPs9o9WUyPPxD6EQ3iFw
7169	delegation	1934	1934	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhxAPXcBmHeG3tVwXbopBnpaKVUrojQW9mZLwGHB53GhN2VqF
7186	payment	1726	1726	1874	1	1	1548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbykyksRPDNwkCzK2dGJqQscfvyoLSipAYJ2Gfi1zsvD6L1Cki
7187	payment	1726	1726	1874	1	1	1549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhFtos2VkXnPD5DU3fsa6DuHob5YCGowdkG9yMgapukXg7jhm
7188	delegation	1941	1941	1511	1	1	1	\N	5000000	\N	E4YPVcbhyETPHgogydmHHpQxFbyYTUQeLwUtHHBC8KraCXrR3kZAQ	CkpZvVKNYytxznCGSk6SGQWnNzzhdnjVSs8P4XYh5iXgYSEikr2dY
7191	payment	1726	1726	1874	1	1	1552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAejZcJ58KXNvL8YKFvg4NHHvwRG21NujyNHDqC4zt9tHaJtN
7192	payment	1726	1726	1874	1	1	1553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGPZRV65SQ3ams9hTZqgQi7MNWCxZinW8Bcxw37ZH2HGRB91S
7201	payment	1592	1592	592	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBk6tN68h4bcKQqsPy3oNnd3usotUvBWyNyAoCHMkNHKYSMosY
7205	payment	1726	1726	1874	1	1	1564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFXmpRr6YHQwj9Nidr9Ytexg1jkPZ7TrvwSghtTrgH1XBrLKv
7206	payment	1726	1726	1874	1	1	1565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Z75QLxjsKxghyvhmS2P2yN9NKdcZKCeVa529MchJw4eCUta
7211	payment	1726	1726	1874	1	1	1570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnQgX6kD92tTNL3HdNjA9uQnN5QEmg9KitV3AMXUu1iXPDuwV
7221	payment	1726	1726	1874	1	1	1580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr76VP5CN7UTTP46ow2KgCpUipVxC3SvuS8rsi1pBQF5YLMGq6
7229	payment	1726	1726	1874	1	1	1587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqE96tdHPP3UVP7e8ScTSqEKYhchKDqG43ycJqwewEj1yWzxH
7231	payment	1726	1726	1874	1	1	1589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkxT4kiuwTRBZ4nq84C3r5GffNQhYEcQFJvGeMQRjs6qhX6Vz
7232	payment	1543	1543	695	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbfzA1x35WjjsisbpckdBPiPySv5xvNJTQYspCD1n4krFFtZm
7233	payment	1726	1726	1874	1	1	1590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6AJouH8kGqJwBASJU5ZuUZ3Bw4gL86C5i8oAjTYE8UTgjYww
7234	payment	1726	1726	1874	1	1	1591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9PhV2xWc7hL6hekHPfNKGxV8K54rt77a42u3HQXA68VcR1Ld
7237	payment	1726	1726	1874	1	1	1594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBfc2Nw4To6azKGRsHVry5bRoDCCo9EVexDr7qRBPqGdCkLX5
7238	payment	1726	1726	1874	1	1	1595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nZEtiuavunGCoGMCRTEzBMpfJcVSVmyJCTjvVh9E8CzLBjHj
7085	payment	1726	1726	1874	1	1	1466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWNCaer8bD4iRMyMCcoKU3mH8BipT2ZpCbpq9wCbFeKfex2RE
7086	payment	1726	1726	1874	1	1	1467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocLVD86eMQvgDdzP6NmeSTn4Jqk11NYHgrNWQurgviftGpbms
7087	payment	1521	1521	1931	1	1	4	2874477000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkomsYtcy2sprSD9SFkMmygk39sBmyx5Hc8Ar4HSxdadwEV4vS
7090	delegation	262	262	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoi1HrxUm22TGPBRcr6HJSct5XXzJjQxMc3HQHfQF9CdjgijoN
7092	payment	1726	1726	1874	1	1	1471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdtd9vSdurTj7SAGcWVpcvDqwUEFBtZKC8VszFEidWtXACarW
7096	payment	1726	1726	342	1	1	1474	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoFQHqBbdzbGRkH446EJczwCXnVe6sdbKaSyN6HHKqQx8tJE7p
7097	payment	1726	1726	1874	1	1	1475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqhf7FA1gLcPnhq74oXddj8C68qxxLQdV47SZyrk9DXbPfwnh
7098	payment	1521	1521	166	1	1	5	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHEtELGy8TKTXpufB74NRu7CugYELwuoLVxH5T6HaWRCyQ4Lp
7100	payment	1726	1726	1874	1	1	1477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEhXocpvBkzFYptUTyj49qAofKANxMTwhG5dikEe9oG5vXZTj
7101	payment	1726	1726	1874	1	1	1478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrQ8sC4DzUMw8oPGcu4Pk1Xgi99dgp66fP7dMdnzTzJsZsFKX
7102	payment	1541	1541	1718	1	1	3	7917200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG3dLQc8KxjjCfdTFjwCvDyjNMgYW4uEps7SH96mEPGLh19Ss
7104	delegation	342	342	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMMUokE44FoRAW9dceNgHrPz8yHXtPiPx5TUTxaiypYQLjxGc
7105	payment	1726	1726	1874	1	1	1480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1SNit3abVhzJWKTZiFgJgqNLNhEYksx5Gb8JGoHTWfGGnuUy
7106	payment	1726	1726	1874	1	1	1481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpL7DfJZG6dqyjEaMNrhFruX2f77iAZRNGx7utQiGhMqK5XEvz
7107	payment	1726	1726	1874	1	1	1482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kN5XY6x2v97uwgWjAgcXxwcxJGYEghkmADihwh3PW5q7ESYY
7108	delegation	1718	1718	1541	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhhYFscRbpqUX2JyR2snLmxDHnH64XbcyDgZ5jjDgaSAyQE3g
7111	payment	1726	1726	1874	1	1	1484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5RRfaGFHW3QfocbCCQV43U9XWUkBSAp5ziu47avbiDSJpdbH
7112	payment	1726	1726	1874	1	1	1485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASaQvdrRFVrT6nbrzmTXFW3kSqG6WgdHMqLx731TbS1U7FByN
7115	payment	1726	1726	1874	1	1	1488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtBYbrzrmpXHjNYcdWSGSkEGky9tVNfYA9cpJPWW6zwUgRB24
7120	payment	1726	1726	1874	1	1	1493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc4FrTbCXBU16hvLjjGA7Bv9vWo5Wto7W4cw4ff8kF8xCBMV2
7124	payment	1726	1726	1874	1	1	1497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSn8xkSEWgHipbXnuFbzZuZ42BR8gxtenzewgUYbdBbLG2H1g
7125	payment	1726	1726	1874	1	1	1498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1P2rKs5GFGzXr8yE1tNSwhdUTyWWcPUvZuq6qrWSQyHcmFue
7134	payment	1726	1726	1874	1	1	1507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrG3CYBPnf5XzkWctAZRZrBihWRCU2wGmBACcEutSam2nLeeo
7161	payment	1726	1726	1874	1	1	1530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaM63QTFiGCS4SgK8ZuUA9NmKvMyKfHzp9r2AKWDS3FDytcJ6h
7167	payment	1726	1726	1874	1	1	1535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsK16jrLYuLaTXyXTB6Nf5PABtgPMbEf8zJpY37sBypiwYdkZU
7183	payment	1726	1726	1874	1	1	1546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9fLhrKEypfkvzv4YEzKaQgNJXyhHb4nsPo2FiPTALypwdPVt
7184	payment	904	904	1941	1	1	0	10000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwtQHsGwo6KD7wzK1SPyVkQUZHzbYQuhT9tjDexvRKFToVqLK
7185	payment	1726	1726	1874	1	1	1547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybd5f9vgevhjbKFeR9oiQML9KaW2Uq64oszL9E2tnk9nRqGin
7190	payment	1726	1726	1874	1	1	1551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpAHHiE4skkf78MZ5NoQtwbbNtYamuANXwMybCp1CVLhEiNEn
7196	payment	1726	1726	1874	1	1	1557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDXcj2sBtvUzS6dhWggH69srNRXmEKY67dSYs6HA2AGW577H3
7207	payment	1726	1726	1874	1	1	1566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAvVWkgqg6g2qfEvut9gBpeW6Zk6QPWdF8TdhZtrrnejWXFen
7209	payment	1726	1726	1874	1	1	1568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5oAGQETfAhvU81YGAHEUEicgmPDsqU8ifREkP6eiRq9AYoRy9
7210	payment	1726	1726	1874	1	1	1569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7txTMnhWVMBdJ22DWKmHtZcCmTK4Wg3uJBGUMBNmSDszHFEPk
7220	payment	1726	1726	1874	1	1	1579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxhm5uYVuhC1SomYFnLRkG5TJdtTUJHFwiV15NkhTYGGJsQfc
7230	payment	1726	1726	1874	1	1	1588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWfrBUzPB8AVY2Ynp3q5GzTSAPSqTgsbjBcRbFVUCQQuWXfoL
7235	payment	1726	1726	1874	1	1	1592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgK3SY1R5V8odvz6izvYiRyA7jEiAa6DYv7bvRoDoH2A7gaFdw
7236	payment	1726	1726	1874	1	1	1593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwp3g52prUu4n8CdTcfBatvkBMksi2vrtVZhkHYQuEQmgcz4p4
7239	payment	1726	1726	1874	1	1	1596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rvbLwS4kX6PnG1EfimJHHoAzsPAimZ8JEKWRoJWmpdskaB1Y
7136	payment	1726	1726	1874	1	1	1509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuGRfhC41DTTQZo66iysrh235ihaDMEVfUmWsZurKU1KwEmEr
7137	payment	1726	1726	1874	1	1	1510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gFAXNrbLEiADp8Qj2KQqQiF95xz9nk8cSuLykENVdLfUR5y4
7138	payment	1449	1449	1939	1	1	0	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MrJj26gSqps5wEuWELAdjmEPbxiMg8AryEjqhJRXN5ZDLVhs
7142	payment	1726	1726	1874	1	1	1513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrar6aiMQhLTBRRKJKp7w8CfY35PQrt2qQ1HckKdwtgH1rkswd
7143	payment	1726	1726	1874	1	1	1514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6GobFqw6rRqijj2iyRMdph3vZCH2iFraikozRb4ZXjeFNGgG
7144	payment	1726	1726	1874	1	1	1515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw9VhP9GR4TyN2h6QUzSEnuf9W2iLWJF84R6fYYARfZnKhzTH
7145	payment	1936	1936	1940	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUokNGfLuHJomFf4bE44RemQ8Ej2ZGZtdzoFSvHLSTdy9XNbV3
7148	payment	1726	1726	1874	1	1	1518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9sBkN9u75j4uEH3FBiddinpTJta5HmVTjEWF8rwyqJoAGTDq
7149	payment	1769	1769	667	1	1	21	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH76BJJHiwYVJQauAVTLWB8z8yGpwrCBfiwHgkjHVGGHMdL6bb
7152	payment	1726	1726	1874	1	1	1521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotgGevj9Uj6XS5VrawWUet1Y8kxsvQuL3pfSdnL8ktu9dtKpL
7153	payment	1726	1726	1874	1	1	1522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmpohzvn3dW1EnKrZhRWEp5DoyMd6WGhxjfpf4a3M4qcwAPZx
7157	payment	1726	1726	1874	1	1	1526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFmxyEZDe2EBRYneHPqq3BU2FBv7afxnuK8YjwFPGEUCyFyDM
7158	payment	1726	1726	1874	1	1	1527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEDKiHCVPYRA27JhV1RUAgLN2enhK8B8GDGx27EC96D4ZPCqh
7165	payment	1726	1726	1874	1	1	1534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhjc9qCzAyzJDXo1rWX8i3AxBC6B7AwqKHGUC7T9DmyzpLQh1
7166	payment	1511	1511	1941	1	1	0	1500000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZyH57z81ZwiScHDSUUjdVy1tUJqokMr77xZ7fMynCJaQWvGck5
7170	delegation	1934	1934	1483	1	1	1	\N	199000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtESZ23r6HU6FCEwEMpoAzTMrR2kmM34QbaiMja3G3hzR9uvS
7171	payment	1941	1941	903	1	1	0	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaMggkKaALENJ8661DjjyEhEjheZGTM4LjMwWHBRK9LFkDNSK
7172	payment	1726	1726	1874	1	1	1537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpRf9h8qcHuFvUoyQV1NQ5aKNXqPdmmJnYtbVaFP8wW8ojAuh
7173	payment	1726	1726	1874	1	1	1538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoTmMhBDU5B5v7eMry7N2UBktaBNV5ztqq1v3yirqpMnL9ybf
7176	payment	1726	1726	1874	1	1	1541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9iBemURxR7xQvhJCra7VkrCTixFvjm5rennUMRTDDmvRVWKn
7177	payment	1726	1726	1874	1	1	1542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzZocedz5AdPNgB3Up3qQcNfpozPs2Lab1xKzjxdXF9bh5MCQ
7178	payment	1726	1726	1874	1	1	1543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfYxefCCWbTZNheE1FzZChVbc6Nrf68H32yS4ZEJH4vFVqjoW
7179	payment	1511	1511	1941	1	1	1	718491000000	10000000	\N	E4YTNN4mUVeYRCxrgnNGZHr4zKUHVmr3um9WhFnq2Jnqrx8aGS1eu	CkpZqrtVQL6tfT2ePt8dLuwrsNrRN9KoZ5mPspzXfyoCJ8ud9AN8K
7180	payment	903	903	904	1	1	0	15000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaJo8eJq6bXmPJpwLUHupabzaWfcvorsSCyVX27MyzWtRfm7a
7189	payment	1726	1726	1874	1	1	1550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWLcTYZVFKg36Mpq4sJGCi3iCN7YMTiZvRn7qLDAh7JkUbN8K
7193	payment	1726	1726	1874	1	1	1554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLdqqxU9WYMbyXQjQQJ3pne9JWrXAP44bGBTbrebUSWuxXM3B
7197	payment	1726	1726	1874	1	1	1558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ocbCthUS5JpTmd8sBmgKPNBLJWjKEiMYdrHYnv16MQRb7Rrf
7198	payment	1726	1726	1942	1	1	1559	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYU6qTGfJbc1qj7cgBuRfkXe2JmeuNQBNQUHzbQEpQiiLVZQt1n
7199	payment	1726	1726	1874	1	1	1560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oWpLAKJKjrKxAdPARuzFzbUa2DkQF2zm4gti17VnfwN8JiNB
7200	delegation	1943	1943	210	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZub62dyVxTuNCkkFxYTtgzDc6Aggi6hYdKJpFyAGm63GtvSm2C
7212	payment	1726	1726	1874	1	1	1571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrB4oF9jzQxhEoP3K6MhGvdrLeVnccNFCpTYiQ8gHezLw2rfL
7213	payment	1726	1726	1874	1	1	1572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMpKbCTgPjCAZBAdoDFdpWiXaqYyC34pE22F5ufYWhhPHRB3v
7214	payment	1726	1726	1874	1	1	1573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAyvkug2FCi1zh6EerdGhG8HCkKGnioU4YABB1TNXCNV9vPod
7215	payment	1726	1726	1874	1	1	1574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciE1Zqg8hmHihNbDvKbESq6KNSGoFFNFMbmaD7z5oCutetEzD
7216	payment	1726	1726	1874	1	1	1575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8pYLpXnKxshUaRUqN5bG4ZuLMfKVEXmieyoNndgDyMqhybb5
7217	payment	1726	1726	640	1	1	1576	10000000	10000000	\N	E4YnqzxPfCA6ZvEouR8TN9NBcjuc54Et9HFvRW61gj87vqYAb52ho	CkpZduoxNGC3h9iztdL9MWAfvW35u8V4yD9QoBzeh2kK4M3yHgM1F
7222	payment	1726	1726	1874	1	1	1581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ861fZevicNrC725FBT28beWQHrhYpFpp8duWSuY3us2RmiDT2
7223	payment	1726	1726	1945	1	1	1582	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuakewn2Ljta4edMLJpLSpXWBEy9pDp74sCCvef1bUtB6Uqvoj
7224	payment	1726	1726	1874	1	1	1583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYDVhSAmubYmDofGjyW2rbvYvkd7J4JSt27pHCzLjJ9knXPwG
7227	payment	1726	1726	1874	1	1	1585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EhcfyvbFzxreK3aZ3GphQFDc2hp8La6dMFfYPuNtF4fPJZ2H
7228	payment	1726	1726	1874	1	1	1586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKD7iA6JhJumw5HXQGvVTpKSzGKWVFMjS882RpVzcd8oHHSrgo
7241	payment	1726	1726	1874	1	1	1598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQapnB4vvrbutmnWRzQg9D2UGMPwez2m3ARZH5YmFREd5n2ADE
7242	payment	1726	1726	1874	1	1	1599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8c4eYYPBMwZxSK3j6EgB3yqAyRVwMCjTiTnzFGwDcJQQeBCX
7246	payment	1726	1726	1874	1	1	1603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLaDFBurCsYmr2LGFmjcNS5DZuADw4N3GpL9P1WHxwuMQ69iB
7248	payment	1726	1726	1874	1	1	1605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDzAMCRfS2YQ1pHqcZ39n2Lf4eNjQrym1LoU5G3ucMjRi8eBJ
7249	payment	1726	1726	1874	1	1	1606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxnrZga9tZkve36s6gjX9DFojDsSRtkp2uGG9J96KpKGxgZRH
7250	payment	1726	1726	1874	1	1	1607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHVcFRxU8dv4x7QFCm41TSb2V3uycnWiUb4K2Eiv9N2iZ1zvb
7263	payment	1726	1726	1874	1	1	1619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeyFjzvYnZRmTGvTiWYgZbZ8u2U82kxNChsbBu1zqRtS2pTJj
7264	payment	1726	1726	1874	1	1	1620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscibkiLd9T2VYfTanX6k9qKae5CDREVD9JCijTaBztKNFjDDq
7265	payment	1726	1726	1874	1	1	1621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS6jEnegQPDGtP3Cs9dckiWDfEiG9TMZLhps7CMNZcRTSbMpN
7266	payment	1726	1726	1874	1	1	1622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwmVMbYk3CuByi138kiDkb1XwU7b4XJsUSEDDHYtapFmN55iH
7269	payment	1726	1726	1874	1	1	1625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz6DMh2o4yB4R9Mjmxe39xAQJU9732j9BXr6T6rTW2rdfDhBk
7270	payment	1726	1726	1874	1	1	1626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD87bomgQFJhMgah7hKMTHb8eeSSXeU4sPA7p5Qvn4W6UbGY23
7279	payment	1726	1726	1874	1	1	1635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyJAG7dLMkYvoJDpo4eG56q4EnH5wgZ3hkhdx2A1UrBEh6x3S
7282	payment	1726	1726	1874	1	1	1638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5hm9HYpDdh2oMdFmccZz9YKaxqYXjX1kcgdhm8gJynd2vHgm
7294	payment	1726	1726	1874	1	1	1650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaMZ5HfTsCojx51rY8U7V3gfWwaYmTirUyyxRd2aKzNPNbok1
7295	payment	1726	1726	1874	1	1	1651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCyMixaupuSzc7gciWx9MRqL8SyXSs5ob4oYADCFtjYjW5mug
7298	payment	1726	1726	1874	1	1	1654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSTS4VjGqKiYwjkBCSjqN7ajxVR3MYfxMYRJCC3GjyD1dvqZS
7302	payment	1726	1726	1874	1	1	1658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBuFR1qPpCNniCNP3kgiXBh3HMJMj8Y3RxmejnzG1j9RkUyup
7306	payment	1726	1726	1874	1	1	1662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUo5KWwXSHoU4UKsptWec4odxQ3Ybxv9oXGJY8aKyArNrHkk1
7307	payment	1726	1726	1874	1	1	1663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TvKiQCCBrcAuPQEN5VQc9haV9e1P4oS5hgQAM6sAVv2vSNRs
7308	payment	1480	1480	1946	1	1	8	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Z39J7oXgusamPW93YyBEYE34RFAc9XiuzVALJ5cys3sdmfg7
7334	payment	1726	1726	1874	1	1	1679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzraAGqsNB5t5HDcgFWKzShR9L3MK9KE2dHbhGV1pyTqaR6pM
7337	payment	1726	1726	1874	1	1	1682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHL2eSaMLJLQvQRrRG8zba9GPhCaAuKkFspG5tXixS4eQZd7Mx
7338	payment	1726	1726	1874	1	1	1683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1n7uth1eH7ikgn3epu5mAiHPPq5M95jmewxvXqYGKjthzxRp
7341	payment	1726	1726	1874	1	1	1686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHtZTSeRhkdSomCLZ5tkJ7TYzk3Bi6BHtKusm8KkLpKNwmGUH
7351	payment	1726	1726	1874	1	1	1695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJD4c29aSbYpuznGVDrbF5nbEWoXzBh8UciEUJYgmBiquKXvb
7368	payment	1756	1756	1516	1	1	1	16883489191100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1dHb1Zy4cWLYuYY7THTYzEJNzBu1yuVQPTowK3VEevQwkhKD
7369	payment	1726	1726	1874	1	1	1712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52kLQXw5ogNNgTu4K8mmeKbd4WaJndn9s9UEoS2F7rvnxBUtq
7375	payment	1726	1726	1874	1	1	1718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3q1gLipeEFLMiLB4tJDXtRZ6AC3x1PFWXKNtgj4h77djDXQz
7376	payment	1726	1726	1874	1	1	1719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLyiAUcCJM9Av77RNgkYvGfvZfva5h9kg9GWEVEZDjy9ENspj
7377	payment	1726	1726	1874	1	1	1720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wGtNrr3nWcKLSAMBJFZrejA8TZHB9aS7m3D6FPpJNTVXQRet
7378	payment	238	238	441	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebs4dabfnQc6PsXB1pY6mu5TCKNsjC282d2x146J6QgjTdAbY
7394	payment	1397	1397	1678	1	1	4740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdhx49QfF9gCzts5R3WqL8gARhyyaGHeFqRJvAWJCGndbVy3a
7395	payment	1397	1397	1678	1	1	4741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJzBc9wwWvMCcXKnKrPw78hVHeh21Gmh2NNQPsaSuzr8MhFMe
7399	payment	1397	1397	1678	1	1	4745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDX8AJMmEfcncVg2HgqaFC1VMyEhHMwFeNKX4Kme7sye3hbtNG
7243	payment	1726	1726	1874	1	1	1600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9Cx15VeTKJRvs8BNuKXB4Y3hF26Q3fnxUF5WN23GsCeKy5yR
7247	payment	1726	1726	1874	1	1	1604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGctZ3dceEoTFbKd3DUKX22Ph7YJZitRkDu4tQqERKsCeCenf
7251	payment	1726	1726	1874	1	1	1608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw932nY6ByVrRVfQLBLzwmRtQT9mHjiv9De121511twPEKjSHT
7252	payment	1726	1726	1874	1	1	1609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaUF9ZDnGEaZRgDHxu9boHbUcP7tr2dS6n93r697y6B4PZr3b
7253	payment	1449	1449	1939	1	1	1	700000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLX85oiuQ9h6eaNuFBzn4AcTg2U6Zz1iD5MDDHQg4quaXVym8
7254	payment	1726	1726	1874	1	1	1610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq3Scv1bGLZuzyvXgi1omvy2qJ9FFng22Z1smH2mfm7ENGDtK
7255	payment	1726	1726	1874	1	1	1611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPCSvRyEfusKC67XGmvKgjjfLm5TqD849nqAAzWUZQShnjvZB
7260	payment	1726	1726	1874	1	1	1616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaSzBVEz7HxsK83sK4hGf5v4hL9eGk8c1Js9BDi8woioBTZ37
7261	payment	1726	1726	1874	1	1	1617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftGkMn5wPNuUAgrju34XhAMtB6dRzzSyX2zUM3qkdrpq8DTqn
7277	payment	1726	1726	1874	1	1	1633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6fgSmQp32oTYKKVBcbdsqPDoi1Y6QYt113jNf57Lqz4KGr48
7280	payment	1726	1726	1874	1	1	1636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cVZAwvPhRS6gkyEKJHUdivX2fF7d4NtoGxwmRCjAB44mBdjM
7281	payment	1726	1726	1874	1	1	1637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDwqqCuK1iL2nQi4yg3vnbMUSAvCBMwQ1hePB9wbedoGYQnqr
7283	payment	1726	1726	1874	1	1	1639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDRh4WT3iAaExweSZsB62y27kkTA81kdeyoifDbLcK77cLAae
7284	payment	1726	1726	1874	1	1	1640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpgMm6Q1uYs23WPfJhvacthop1CZfGmA8UEtGCpLCJ1EHqLiY
7291	payment	1726	1726	1874	1	1	1647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bLKQ1F6ymAMGPp9vNWJBf4g2GBzAQ48bUsrBrE6aDUon7Ykq
7292	payment	1726	1726	1874	1	1	1648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5eztBxwRUQDCEeAjf3Z8d9gkgc6ytmQDCduhRMKvB6hcTVxj
7293	payment	1726	1726	1874	1	1	1649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGPhkuzUNAUdvdVsBjmQPkEN5sTePahSaSqHZHHsfHf1jwGzb
7296	payment	1726	1726	1874	1	1	1652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcizARLRzddxHU2NC54zmNBkWo9GmrqjwJHJvtvD6P1BcfcHd5
7309	payment	1726	1726	1874	1	1	1664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbr43776mjFymMwwmTtExTUatN5cNKDN7aSHUdKBCgtYMmqgj1
7310	payment	1726	1726	1874	1	1	1665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwdFh3o6mHDmzHbrmmsrFtARLS3veK99ZufCZVdN3sRpXhdcV
7335	payment	1726	1726	1874	1	1	1680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCxbKifBDsTjMaavzPtwyXHAPiYhFzkRYKdzoePEuWPYrrELW
7342	payment	1726	1726	1874	1	1	1687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLHwnT6Zgzw6zvYmJvCivr38SrPcdWttMdcxfHZkvTU1gaJwy
7345	payment	1726	1726	1874	1	1	1690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKGmBNkxDjnMp4gPy9C1tnu6JU1ieNMERak9qLsXRwGkaat9t
7346	payment	1726	1726	1874	1	1	1691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGr81jLZfrBAeeghW2HZYegBGZa9cU47hEfFBCG7Sbae2Gb51j
7352	payment	1726	1726	1874	1	1	1696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUokaoLpPCfD5ELcLKV3R6Hhy8YWCvm2FAnmqYYgghv7AN91hT
7355	payment	1726	1726	1874	1	1	1699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx5FBZMrkkXDaiFAwPTXrevaAYQ5P6WXisPsVndVupdCn6fzp
7356	payment	1726	1726	1874	1	1	1700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Xvgoskt1bf6VYNSCH9HnXaAqpcY7pquED25CETjDcFx5uFwQ
7357	payment	1726	1726	1874	1	1	1701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBFcsTsHVgAVLdKJmmWdRKzgC8wRt3gQcsT2MUYinsZ7cDb2X
7358	payment	1726	1726	1874	1	1	1702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQMKAD5m2G3uGFq3vn67DJjBz9TtFq6noscyZ8Txj1j2T5TED
7359	payment	1726	1726	1874	1	1	1703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgA8SjVXtdf54FjwaQ1LcdpAtug2V1cVs71pB8PCXmBU3KgLJ7
7360	payment	1726	1726	1874	1	1	1704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx9S538nXNVYUcVmPMToNGFAugsQjL8vqynYwgsaRZBH7tg8E
7367	payment	1726	1726	1874	1	1	1711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHs3AfASD9Jxuyusfn9C8Sjcrw6Po4cxBtREvgioMLVF2X3VM
7372	payment	1726	1726	1874	1	1	1715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5prYkRHT1xR7exMFepfDWz1XMp7tu5DzLp4rS6HhUiZgzmF77
7373	payment	1726	1726	1874	1	1	1716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyMhAn6xJNctcR4HtMS1g34zXBenubmg1rFuk8scqkRZTC2cV
7381	payment	1726	1726	1874	1	1	1723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaxzziFJRcwSBzNiVurCaSWiWSaqCuuDc439ZGzndvFSc9QKV
7382	payment	1726	1726	1874	1	1	1724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeBzo8zEoWt9sHwZ7h96AZ6R2tf6sPpEth3SM6mZ39oYK5ZwP
7385	payment	1397	1397	1678	1	1	4732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBRr2CFQd5KkMiKB9YJaMSb6mbcrQk6dtzPtRoNGWCSAc6RVP
7386	payment	1397	1397	1678	1	1	4733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mhyVQ46yAkdF3yPfpSgag1NJe3Lk5Axaoar4dsUa8pUUyZT6
7245	payment	1726	1726	1874	1	1	1602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGp8uA7LNdP7Q57TTTrtQvNWpKJTNk7ywSsTxstfWiJA6y4mMG
7258	payment	1726	1726	1874	1	1	1614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnRPxmaar2CFHz4R6xn2YBF1C9M3kaCca9SLi3oeBFzNXpVHS
7259	payment	1726	1726	1874	1	1	1615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZWESWYwkxXxae81CXT5QZF7drhZfnAVVxBJaCDv67w7MnPgv
7262	payment	1726	1726	1874	1	1	1618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZLz3JwevaDCkeKgmHJmRHTHhn4dFuYqVqp4GBAEvwNBSQbCy
7267	payment	1726	1726	1874	1	1	1623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDFzDxgaPswxwZquXGJBsZ9hC8JPWmFJngGK9VjMNm7hgeZ4R
7271	payment	1726	1726	1874	1	1	1627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabcEQzw1kC5q5QN842fea378gRtF6a9QFqYYg3DrHuxeTJQaH
7274	payment	1726	1726	1874	1	1	1630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mAxhL1SEAwadu15m3jxQTirCcNJzKwZXJMuDwSJoUiEKHf2s
7275	payment	1726	1726	1874	1	1	1631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYY87PyPQbSMu5axiooLwdiNxLXREwFhjxobFgbDYNrrNJH1Y
7278	payment	1726	1726	1874	1	1	1634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5258nFcg3c8ek8dtbRyGkDyQc2Y7Jg29WPhKzQLBw4VRGhNq3
7285	payment	1726	1726	1874	1	1	1641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5XxjEvY2sBYR721z9uboNXTTZfzTRGHzyYgsTov4yYoAz2cL
7286	payment	1726	1726	1874	1	1	1642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijvKHNgsFCrSQgPMz6DfKNL43VLY38vPcRLGrAKUSWx6UY6V6
7287	payment	1726	1726	1874	1	1	1643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywaXJw8aXXx5nXb1Mu6gTX2L2c2NN5sTVY4YchziNbEZqMjdZ
7289	payment	1726	1726	1874	1	1	1645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJz74ZqcC9JMyLsMav1wknx7RUh9oMDGshwcHpQUF2HFdQj9gL
7290	payment	1726	1726	1874	1	1	1646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsAFgNTLCNaWcs5tZ3WK2yG9LYmostDzp5FU3QmHSy188mdTJ
7299	payment	1726	1726	1874	1	1	1655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RVpgkVytaqGKXn1YM4kXPXED9ZGsNJDitGsii6akYCRMeRdB
7303	payment	1726	1726	1874	1	1	1659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2UcEh9QHf3F8egg6G8xVUgoqLdQL1YxQJcUKhPLzqHHTSnDE
7311	payment	1726	1726	1874	1	1	1666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ5dbAg5L19vSV9msX2XVZFFFn4JdciNonR6ovgu5bxzrxDM9
7312	payment	1726	1726	1874	1	1	1667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLHxyEi1yhqbaiBAfCwtEnN4fmLdEcvxSB5NFfLPJgB6kGPxX
7313	payment	1726	1726	1874	1	1	1668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpXZHSz5rMF45g6SR2jzovRHMspG62zbCbgu69QcG3fz69PJq
7314	payment	1726	1726	1874	1	1	1669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQN9pDb1xHMxn9wtcsTso9A7dWC3NHtNdJbELo7NCNW4JqtbtG
7315	payment	1726	1726	1874	1	1	1670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpu5kjTPFKhg3mXNeZSVzF3Df9AHKKvL7FwaieToPiXTWDf3X
7316	payment	1726	1726	1874	1	1	1671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRnm7wsFgsrfxYnojvuDuPQqy9P7oTmq6XEr1D4aHmjqFXQYy
7317	payment	1726	1726	1874	1	1	1672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTjGWDKAU6E3E16AqHPPTCy7KwTyJab26JFkaCrjMLWPP3fbu
7318	payment	1726	1726	1874	1	1	1673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeGoEPpdbP7FQdQgef54rDkJHEDB47hUsPoy3P12J7iyxHjfP
7319	payment	1726	1726	1874	1	1	1674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsGULdHvQAoCemmuNnnPsWVDSaWA63m8mAFbJ4aMevaQMhbDE
7320	payment	1726	1726	1874	1	1	1675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvto68FonsyehuHhSdBh1hXKZkdWq9ZmXRUWH8wCpK2ZrUe8i
7321	payment	1480	1480	1904	1	1	9	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW83Cncw2s9RKkSHjEP1pmPinvbbsHBqXAdcxrdzPEkypqPRcB
7322	payment	1480	1480	1904	1	1	10	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CBKjtf8pqEDow8oTH4P2MaNuAkTVPCBQuctWGB5wDDQEy3zH
7323	payment	1480	1480	1908	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpAMbTxrYBNmaaqdPxCuxRA7KTAez1HF17Jwbw8cZtZiQ3zYt
7324	payment	1480	1480	1909	1	1	12	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PZsaT91HPXL3wRQRvcGuW1JGhQxEQ9fQE7kn9HbPmmFjqktH
7325	payment	1480	1480	1910	1	1	13	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswxQBqCsjXnNjeyGS6wpExD58sVnYy9KLJ8GLRgJBCZ9UCkYH
7326	payment	1480	1480	1911	1	1	14	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb33Wgi7fCsuvP9XGDhxRD3396nhYxJ6omdCGbZzEzoT2UXrAa
7327	payment	1480	1480	1912	1	1	15	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT45m2tEh9np7tGsf96WgP5Hn2bm3LWK8K67p9nMoj9MCZ9rcx
7328	payment	1480	1480	1913	1	1	16	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYoaprSfuJ1ejBSGasXyeMLkdpaDcPmEkaog7B6164qQYMLcY
7329	payment	1480	1480	1917	1	1	17	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJdzvCr7ggm4fHnSEWbkBYrgXVTSGdXUsRFwRSo1HkpCMuCx2
7330	payment	1480	1480	1946	1	1	18	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gpfePyJH1rShtb7xtduRBBGFuG7eo3EddAWjCCNHJ4KuDUbh
7331	payment	1726	1726	1874	1	1	1676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeabUvt8AVjidWsiXhCQR9ogLo8iTAVofyFmUK5Tr2PWiSDsuF
7332	payment	1726	1726	1874	1	1	1677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZErV2U5ZdSD8DdH4uZ5FkeiBRHPvAssHjfG8gqEUqi6HzTZb
7297	payment	1726	1726	1874	1	1	1653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacAueyy7cdpcLr4WFTe7yYUUzyJ2KE9aZYc7FSS9AuEnekG4h
7300	payment	1726	1726	1874	1	1	1656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufCnaLnYwYGBHnLEcCQnt4LJHnPSs3aVLSAqFYUk3CRcU2JMb
7301	payment	1726	1726	1874	1	1	1657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i6gW62U1b5yndLXBT36oVSLTUmD6LM7GAQzNvSkx98C3RP9h
7304	payment	1726	1726	1874	1	1	1660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEhRH8vWxaGAYjxKbgbJsfBM8aWBhxHVnWJvPTm3UwtFH7vBQ
7305	payment	1726	1726	1874	1	1	1661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxDuSskXfbUZq3ArSXPgDNSEfyWc6R3HRcmYSdWcmPEt1xLN7
7336	payment	1726	1726	1874	1	1	1681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAJRDoB1VYB3dUE24D8hStEk4SR7npPrevmDMQTtJHuqHJufL
7339	payment	1726	1726	1874	1	1	1684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAs7YLBAk7PmhTBGXbJKhZAm1cx7ZKHtzjVHLFeehZpQ1CLybG
7340	payment	1726	1726	1874	1	1	1685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2T9zvGQ6RAvLscwbQjNKpx3JT5SGptgmmVKHgfLpztYnchi4n
7343	payment	1726	1726	1874	1	1	1688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDf5zFBaGgQoCtFQj4LWqbp6p359R6TA56UNkmYkMFiyJzkiq
7344	payment	1726	1726	1874	1	1	1689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VuwK2uhUP47HsFwuk7aGzYk1pctERAz4hqnpdaccU6JJ5RRG
7353	payment	1726	1726	1874	1	1	1697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BTeMuUdg6ywDTxNHFRns7XCnnYsdxvFhMJCgnkt1VL22k3eR
7354	payment	1726	1726	1874	1	1	1698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUhHbeaJTY2C9fTw7Nh7SgHhBz5zPDdYQxuKpHRe3N5naS6n1
7363	payment	1726	1726	1874	1	1	1707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYBNhYZurAEEAGCS7yih4ETbjSkhxPxYXQG4wKSPwcg6sLPyx
7364	payment	1726	1726	1874	1	1	1708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rABTGMvSf18wHGQapELeKPg4ewXwWcGBGDATXMnfbV2ne5Gm
7365	payment	1726	1726	1874	1	1	1709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZmV279kfN49aLaH6vhLa56ZqW6JPh5G3LceNqe4MW9KTg8JN
7366	payment	1726	1726	1874	1	1	1710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytpgaXaGL6Jzyt3PjoMWRjyiohe4DNTiz4ifgSDydbLA3MeTu
7379	payment	1726	1726	1874	1	1	1721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhpyMipk7Q2HhnHsP64MX9wr92HHmpnNwSaG1dhVHBidBuGUN
7380	payment	1726	1726	1874	1	1	1722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSr726ASRvoQHDzbg5op2bbjM71EaQmq8dVGADVSLH8oLmhRFA
7383	payment	1397	1397	1678	1	1	4730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ThWrpZVNr3f3CRCJeMmHzRqNxxHiMwFxHKHtMRdcLdQXYvkr
7384	payment	1397	1397	1678	1	1	4731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wHdRAvCoVw8YkpKhuKJDEEFkeXGzP1FJyNWnoaX5i2H8Wwbr
7387	payment	1397	1397	1678	1	1	4734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwWFjw7z2Ey4gHTdpihxE34ZntFfVmD2jCLNqivF6badPXJpK
7392	payment	1397	1397	1678	1	1	4738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mrQGNzpiyGbsYDBySXis6wZGDirijiDjoS2KHsKEFawoEBie
7397	payment	1397	1397	1678	1	1	4743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrARkr5snw7UvyKBfpV1yrGPaJKejLbcjKtYBvGYnfwrSBYB8
7412	payment	1397	1397	1678	1	1	4757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunyKiVhZF3G3ZS5zVfCEq2rQ61vbZVTELXESwgBFoVDNjQce7
7413	payment	1397	1397	1678	1	1	4758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufRRCFm3stpFah4ZRpi13FKan2deYyXWCXeYtPsNqAo6dkXPV
7426	payment	1726	1726	1874	1	1	1729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSfxp9Df3hYJxEA1ewRexvTGMfA1KTf3HGvLcUeGFKeeFvQFU
7427	payment	1397	1397	1678	1	1	4767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAXviUGxrSdZ9LmQJhUQfQifHanJiNX29vMPoTqVKWALEzLmq
7432	payment	1726	1726	1874	1	1	1732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvwxtCzSSNE2J2AVVHyZSkazcve88r1bFExYDcNvLrrD5jgxA
7433	payment	1397	1397	1678	1	1	4770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbTgaVfm7KGWJe5Q4WRqxrNTMkiu91W1osuyL4rQGyhLd2j4oV
7445	payment	1397	1397	1678	1	1	4776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVHMUjNsPaWDikKABKNSt6N7XDWspWbaQdGvjGdW4atZBoUqd
7446	payment	1726	1726	1874	1	1	1738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7SLELWaDruxNaBFx1175YQE18Sa6gFV1m7kfAchPmBVU7a5G
7449	payment	1397	1397	1678	1	1	4778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDsjUNVtxAoPMLQKEzQFE1757ttWsLmjHisqgYouYpKxdCYGV
7455	payment	1726	1726	1874	1	1	1743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjcWbasEKVMeWpLtLgat1777yo9T91xHZ2bHhETQZDqTxq6d7
7456	payment	1397	1397	1678	1	1	4781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhRLY7Hf4x3RWjNQedzNxkEzWJLM9J7yANWVco5aWcEr1Pui3
7457	payment	1726	1726	1874	1	1	1744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5pEkZcc6Wh8SC1o7rUqFxYEDeojpumfK9LELUY3btySnzskZ
7458	payment	1726	1726	1874	1	1	1745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3791D7h46h1HVdBqCiAP3rGnv2d83v6zGzR41KZuyR9DReTi
7459	payment	1397	1397	1678	1	1	4782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YTY7HXH67Yjj7piSCVFBSb2MyhGQ7seFLKgJaNYJ9RGsTFVz
7460	payment	1397	1397	1678	1	1	4783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAFzDmfqx8u11wHwVaczSY5dnzhqA5C4wvvVbwcmvXg6f3Lkq
7333	payment	1726	1726	1874	1	1	1678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5U1MuYKkdk8JuiGtAFp8W6qADXZZusbzCgS8dfy5qD8yZoEq
7347	payment	1726	1726	1874	1	1	1692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHVsvQfTnffNTUgc1JPR2yDejLEfBe7Lua1z66qfCyHHncgDF
7348	payment	1726	1726	1874	1	1	1693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9fse9u1EoLZMuc2DMQoacYmFV8ixqMQhGs892bBLogJzJLZf
7349	delegation	238	238	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xAvWA3xX3vRUcmPLjXKyEGTDmjqpv3ykBo93veeFFUpEQ2nK
7350	payment	1726	1726	1874	1	1	1694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPnH49PNkoHKGYf93mN23nGuKt7ep5FQXTBVWJAnYFMHcZJkx
7361	payment	1726	1726	1874	1	1	1705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRuqygLcM5voFnCBfdw9RQ3tCJhPrgcJNjEa1vZZp77G3fpCw
7362	payment	1726	1726	1874	1	1	1706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEo1hik7To3GguvcFHrQiUZztRhaAJxRF8AKUyhYve2kg5RH9
7370	payment	1726	1726	1874	1	1	1713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm72KmdE75AXCkDJpVSq9K2k7TxdvJXutWDDYADf8vYiXqd4uP
7371	payment	1726	1726	1874	1	1	1714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKe8VziD4xh429rHYwAphqwehkcnA1hGtJGY23WjfZ9dPDXzN
7374	payment	1726	1726	1874	1	1	1717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeaksUTLP4YREq4RgtcTeqAALc2rzwewpc1phPJCxvMVibPs2
7388	payment	1397	1397	1678	1	1	4735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7g8v7WXhQnAj2n6MzeoC1jzSYR49t42LT8uM1DwXMYbPeYojH
7393	payment	1397	1397	1678	1	1	4739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLX6A5bswK8GXQBAB9Ly5Dcs29TnC4JKdYo6NWJzpq4fgqqmye
7396	payment	1397	1397	1678	1	1	4742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK4qBucNHv978r7HkEYiYmnq7qeZSK9BsEdyR8ygmDycjgoA3
7405	payment	1397	1397	1678	1	1	4750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMjru7XMKarna92gmsQhR93M3Zqc6ZJhjRvkcF4Z5cDeyt3qw
7406	payment	1397	1397	1678	1	1	4751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnHvCzd3cCmAEdB9HzfPK7MXy74WFEunpx559nLqHFqqeAiD3
7414	payment	1397	1397	1678	1	1	4759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnZwM4NeAD9yuy9Rr5xPXq1CAFY8E98uNjSEQd7PYsGd5eXRW
7424	payment	1397	1397	1678	1	1	4766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiY3eecdrHRUxGtRXHSDgbSBviDKuc7UonvEAW2TP5XfCBPy3
7425	payment	1726	1726	1874	1	1	1728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8XJXWMNDnXm9cCuuSwF73C8BKghV27nSvtXpfUBTmv43LQuo
7438	payment	1684	1684	208	1	1	0	10000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYUWVD9q743JsjXFfEvDeUhnbjpTxLScdCKHCcP1fp1SsEu7M8n
7439	payment	1726	1726	1874	1	1	1735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79N4eZMAXhDCREtWwdEPJjNRUjYJbLHVxJH1oGkPkx3EPCU8J
7440	payment	1726	1726	1874	1	1	1736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5F93npFb8bADYC9ScnKWaQiqFs4ZEeiN3f9FZRRKkaPZJuQ5
7441	payment	1726	1726	1874	1	1	1737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh88oR1JEGxpjKj9TWoRz5AC38WrMPPwscbtPuGt9rXW7gfKyK
7442	payment	1397	1397	1678	1	1	4773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiwD1XKrPrqFq5n5U9U7FRFpWCWbSpYe85zRK7ZdSLJ5RxwPP
7443	payment	1397	1397	1678	1	1	4774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTe75utBLbeaNkx9ggSK4BeLDnNrc5t8YatSxtLeioRpGMX9kp
7444	payment	1397	1397	1678	1	1	4775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aLXLr24xmUHfSsbCMJ9yC772PYKrazWCW51MW6MerGx7F2kU
7451	payment	1397	1397	1678	1	1	4779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczTJraPimQohGA7XGhWJEGRkcX3HFFhhgnV5F959YSynXYB2S
7452	payment	1726	1726	1874	1	1	1741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSMR7wM29Me32wnU55Qeqvpyhh2FAQWstooZdJY32omcCuxyk
7473	payment	1397	1397	1678	1	1	4790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBNcYSsmBBueyfAkvkuzX4mxS3LArcuqxW5KW98wy8YXaKxRx
7474	payment	1726	1726	1874	1	1	1752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDJ58rriaJdV1WWy6iX6tjpqUYdGW47jpHua3fETHvkTnZBwG
7481	payment	1726	1726	1874	1	1	1756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HTymmmAwJd9KMXvxpCUpQ8Rkh4rPHkRcoQ6t6Fc6ai3MmnYX
7482	payment	1397	1397	1678	1	1	4794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7JmBHJrZMJ2u2pXes1gUwRLeibft7cgEqtHhJrsgRDEcCCxX
7488	payment	1726	1726	1874	1	1	1759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAg78p23mDdSqxpgPYSqKo4irrgtamrt7quFYRAGyPuCmvL11D
7491	payment	1397	1397	1678	1	1	4799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUu1ks51iJ3MQPi9k3By659zg78qBXbuYvprjM9EtVwsxTaZJ3
7492	payment	1726	1726	1874	1	1	1761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAPhkyTX2QoJjwePuXHpk6FFgjFbKpPvEpsXwA4rapuq3iBnS
7499	payment	1397	1397	1678	1	1	4803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWM5Fvjaoy83j6xvextyyV4J5vk1XBkzztjKsUUmEvArh22Xs
7500	payment	1726	1726	1874	1	1	1765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAUfBrNSci7UVr9u31uWABju5u1tQLLi7o3c4MER4sGpah1RT
7503	payment	1397	1397	1678	1	1	4805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgnn26SiTSpDSn4cZ2tewfcRszUcAHT9TMaRerqyVV1isjpUK
7504	payment	1397	1397	1678	1	1	4806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKmBLWv3g1jexUUtG8xtrudn6oL521VwwXsn5aMkYmq8bDBYv
7389	payment	1397	1397	1678	1	1	4736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYUmy6LwYbqZykeNsHYSNCmTy1w4fEMwRWA6BJxfU6Jcxye9L
7390	delegation	441	441	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzFMRSdZkRecFt4RScoXj5H9hpbtDcVpH7Y6xVFxryjA4SY3o
7391	payment	1397	1397	1678	1	1	4737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfnNLg1h16ndATSYMwsqjZs4j9ppBisexMGMzDVUWmXAdbhtcm
7398	payment	1397	1397	1678	1	1	4744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFkXjRnqWvA3f7JqBEt5XcFwnSKU9q4AuFPXh1tbNwhGwwVsH
7428	payment	1726	1726	1874	1	1	1730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWNG2qUzEFQrDzSsfc5aMJmxKZcsh56CCiBbkevmrP2U7yUMU
7429	payment	1726	1726	1874	1	1	1731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPixCeC7E3GXY7M7kV3cTQaSegvqFhyMk5VYPi8f9PeyK6feJ
7430	payment	1397	1397	1678	1	1	4768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34VUUugD9jdz7AbiXMzH7HNRmvWdfNDndZxmY8oEu6moT87Pp
7431	payment	1397	1397	1678	1	1	4769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKud4V8bxuUsP2rFQ9uHjMTVMvt2KF4BtMKDkpkwP4UTHvs8AD
7434	payment	1726	1726	1874	1	1	1733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwkyiR69KrgoyDt77xpjm3yhRbUw7FWZrKigq5G9RLhgKAsqh
7435	payment	1726	1726	1874	1	1	1734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHHgfxGEfnnGYAyKYahqQdEvfzrscGG7PZy7KM5pLJBKATsc3
7436	payment	1397	1397	1678	1	1	4771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5VG8EzebpQqeerZUQeVnCFULrdDHo9ccrhxX1LJKNyxboenG
7437	payment	1397	1397	1678	1	1	4772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVX9CKc29R6Z9U9BSdGiZ493AZAqZGBTP6GE2j7HTfeo3gvChN
7453	payment	1726	1726	1874	1	1	1742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxDqceGbDam6upqgTBJwWNqP7MhG1B2vvxDQN9TvjwoeRdxTo
7454	payment	1397	1397	1678	1	1	4780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygs2BGPpKwpGhHPbRjLDa1AGZPUc4nkxbLKY1njr43uPQhy9s
7461	payment	1726	1726	1874	1	1	1746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPDfALQUhDPreRdHoVmfzmCmN2CoitTsq1CBx9xefaokLub4z
7462	payment	1397	1397	1678	1	1	4784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6Pg6mfNoZrD4uvmxk4YSkKXvLkLSwqyRRGfwggWLJW28oAwq
7469	payment	1726	1726	1874	1	1	1750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJWbN3f5Xgc2JfeWkumm2e4h832voCsTAs1tNA6ZGf8HKNhHH
7470	payment	1726	1726	1874	1	1	1751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjMTJp6McrvPppa3XX6GhqffLZYnWmfvN92JVE9mBt58pTxW5
7471	payment	1397	1397	1678	1	1	4788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAhZYpP5esHg6LL32LgpSLbBFfrKrXpyrUgmsEXY8MQcxDh4j
7472	payment	1397	1397	1678	1	1	4789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJuHhduEuMzJEocYr5N5WPXf6XhzVnXeCMhnG818nAnRVSio7m
7479	payment	1397	1397	1678	1	1	4793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMDp9HJRgWbpHq78pjd28XqDbRFTWUV2PP6kCvCWq9cf2BPXj
7480	payment	1726	1726	1874	1	1	1755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXif6cUpmtAwDPyDgjDzhxcNunjb7RTrLQrL69usvfzfgLqsKq
7485	payment	1726	1726	1874	1	1	1758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxguyz2KTbqJsbhwiwncosRUZS59aA7WJ3wpY3SiAHT3fqEhW
7486	payment	1397	1397	1678	1	1	4796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MvNZNtDLgch4kAJbHRUxzDmghupp45MsupEGPEnqkiVbSbKK
7487	payment	1397	1397	1678	1	1	4797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsDXQNdM9VPBmG3qeyT14Ck9D8L5U54nQ9Foy8nMmawrB6NeN
7501	payment	1397	1397	1678	1	1	4804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTw8Trx6Pt6dzatnGfpwQavZjNue8eCkkDRNV3P5P7GdcmL2N8
7502	payment	1726	1726	1874	1	1	1766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs31PgBohE2QBzHEY6LXJw7i3tFT97Y2rB7BJhzgLE6zvqTN4W
7509	payment	1726	1726	1874	1	1	1770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCoSCiGAXUSqUCzSvpfQmE3b1rb6xG48tud8xqq7kQgguqkRM
7510	payment	1397	1397	1678	1	1	4808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVabZX8oroZgeXquaqtNCe8NVdEPviTM2F7zsnLc2jdcb2y1u
7511	payment	1726	1726	1874	1	1	1771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSv6NgVGPNB74W6cMEVnMYNz7WPNGuZEpuqS4CmnqoHjEZqMkB
7512	payment	1397	1397	1678	1	1	4809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9TyD1kZ97n7MtN5mHKWuyLFmBfUznWRB2RVihAho4ASma6X1
7535	payment	1397	1397	1678	1	1	4820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7ZNFW7AyAGkTj1CJrEMSLtqr97Z2fLiNxFgVbTA38sRdC6v3
7536	payment	1726	1726	1874	1	1	1784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKTYQkQYLVWrM8hegowDKTNeNUmr7FfovNLirb3RYYNs7gQ11
7537	payment	1726	1726	1874	1	1	1785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMEXcLpCLDqJTXQYB7kuxPP8rAJz1WP8o4tDTRXAXZuq1cod9
7538	payment	1397	1397	1678	1	1	4821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fkAwsjoEmeqZ7aTGTDMpbhLiRP9P8XyLzVd4zosMvXY89bZi
7561	payment	1397	1397	1678	1	1	4832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFMwbFDokEjUBvX5i4nDG77HYToQ8MLaL3cpijv1GCk8fk4iB
7562	payment	1726	1726	1949	1	1	1797	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwty9cTrxyPEtP2X19E87bxmokE6BdAiAUhynu9QNzcUzu1eWM
7563	payment	1726	1726	1874	1	1	1798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpsxgxvBCuRpyLmqxY89wiARgfyYq9NDpBQx8YB2HLqJd9kgv
7400	payment	1397	1397	1678	1	1	4746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UqDdXN6KZXTM9EtVSCTj5CbayiXj5bchVbnsS1rbuLwHjLgx
7401	payment	1397	1397	1678	1	1	4747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxr5fe6osrdBN1ATVH88VXbu95rP4MpCigzmBqofoDwDLUbEmo
7402	payment	1397	1397	1678	1	1	4748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vukPH95UQwLLneKKX5XV1jf7vZZwxbNpGWvQf3GseKprjK1s
7403	payment	1397	1397	1678	1	1	4749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkACPoEc9fAgk9JYncugQuKtGXPeXkCqVmMStbie65Dh7aNDr
7404	delegation	640	640	640	1	1	0	\N	1000000	\N	E4YXQGZYfdmxVCYpSLbkpq24Qqsyyx2gooxhY3P4Z6Dr9XsYEKkdv	CkpZbVKPAxEwK9CkwvYxPVvJozGWrSodrFB357Rnh1w1HQxZQ8ke8
7407	payment	1397	1397	1678	1	1	4752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK149FuhV7b5LebpzzDL3GyevNsvhvduBco5XWMs24w68PVwSW
7408	payment	1397	1397	1678	1	1	4753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1w696njfiitKmAvrmkZv2B3g2gtJLBFFmajbDwQZYNMhsX46
7409	payment	1397	1397	1678	1	1	4754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4kaM2r9ay2SkffYSkWhRousgdPXtybVyyQWFnJDmiMm2MLfJ
7410	payment	1397	1397	1678	1	1	4755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBPhQJfs3y6CkvT95ZSuG9UiQ7F2y2Q3GknVYs5QQt2dWA1Gm
7411	payment	1397	1397	1678	1	1	4756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqm8Uhe4xgWuXAm9sCeE1MVbgF5Et5oaKVScpiB6XxvUpLwwZ
7415	payment	1397	1397	1678	1	1	4760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFs49MK3DbPWwd6zjW9CbxMaPmk1xGgKrZWgs2KhAxrAdjRU6
7416	payment	1397	1397	1678	1	1	4761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ms2RTw1EixhboTGKvoQEdGDckrJ1v7dW3nbkQDceEMCy7SXJ
7417	payment	1397	1397	1678	1	1	4762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaD8R63FSQUuUTdGAH4YGtP94qrmPeWYyV8QvKwo8Uja1TUZM5
7418	payment	1397	1397	1678	1	1	4763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcpRz259EWc1dWrmMuYmFaspjYpRMZkRRzZE9EHoiFNntohhp
7419	payment	1397	1397	1678	1	1	4764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryfyerLHUk6XaVQsfb64Avj7qQCLLUKg78KtQi1vqqz86c4B3
7420	payment	1397	1397	1678	1	1	4765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dJNcP1RRoviAV3aqEg5z79ni8449vE8DAjSTuZfhkZoHwvw3
7421	payment	1726	1726	1874	1	1	1725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BeFjtqJeuHoT3Y1V7pfahrtPW6fLJaDKQZ36diRG6TT2MEVB
7422	payment	1726	1726	1947	1	1	1726	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2Fdn2Nn2ctTPxtAid9rgVC37YKk52FpatZd7CHQuAXKEJdSDj
7423	payment	1726	1726	1874	1	1	1727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLtZgQfYsBsvgruama7A6JDNGxAf7Le697n1JArAGQXk81g4u
7447	payment	1726	1726	1874	1	1	1739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmorsMp1umsjdWvHML2mUGuHbErSTxSerxrdPH6Ctsj21Q3bB
7448	payment	1397	1397	1678	1	1	4777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCK3Hrru5hBhrcSkv8W7Cm7ByN24fNVRjcumr1ineARwFjKL42
7450	payment	1726	1726	1874	1	1	1740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagcx82PLgPna95ztGBY3aU8iG4ofEHexHjUuYJDeHvXUQjAhU
7463	payment	1726	1726	1874	1	1	1747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkH9ZhnBZDtM6q9QGTMwHhSjKE9dX7rk8oH1yQ3nfUtSa1jjcp
7464	payment	1397	1397	1678	1	1	4785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dtEfrCDUww2KhFV3hs2XQybcAczTtvbmSTmyMfnfzC5HXZAD
7477	payment	1397	1397	1678	1	1	4792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRRvRLsUe3Y5ur7mePUGmv6NtqhyssER2WRjz9KmkL6rTKt3q
7478	payment	1726	1726	1874	1	1	1754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eQmrfbX2sKi1Uh7wkHBwgwSKipTAdv7uitDwBQ7meRR9ZXb2
7493	payment	1726	1726	1874	1	1	1762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQnD1zGdeDQsvG4pFP1f3eZTyti8nCcHhHYVpYfe9Rf8Vk7eQ
7494	payment	1397	1397	1678	1	1	4800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKn9VVQzhnzq9BZJtbATiaLadCjfHmTfiVtEMUSswwbmpjPSm
7495	payment	1726	1726	1874	1	1	1763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzja34EjFDn2EJv83i7z8kdbvC5fGLXv5VXhQj1HTeKga5JSSC
7496	payment	1397	1397	1678	1	1	4801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTxSh8wYz5nBn38Mpzvtg6H1YEufxTxAfeL7SKjqdT9BhACkX
7517	payment	1726	1726	1874	1	1	1774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXbsFwxXY8Ha5xJz2JChPBFP24qHSsTb4yCvaDwkzKWRyGTYq
7518	payment	1726	1726	1948	1	1	1775	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgqqctrafeLL1CC9RK3T1sRrxEmuxbbvmNyyGkwr3f73Cw8v9H
7519	payment	1397	1397	1678	1	1	4812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAQvdHojPkdaGkXwGgvYc7o7V2UkjNos4bWBoZMh1BVb9biNT
7520	payment	1726	1726	1949	1	1	1776	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6DVtV8hHKLctQi9RnMh5sb1i6EJjXRgeLUmFRdp2A1GmDKZG1
7521	payment	1397	1397	1678	1	1	4813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgLastcD4EFLE9s4VpKnacAsLoMry5cPmmg6jmrK6fLZ4XwRL
7522	payment	1726	1726	1874	1	1	1777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciJA3R4D7ibRdsh5EepDFACVn9msSsgikw2gM5ttaS96e6jrC
7552	payment	1397	1397	1678	1	1	4828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLPQ6Pi5R9zJcL2qaBsVdwDKZ7Lf1jPHsCnrmMN69E11Qetpn
7553	payment	1397	1397	1678	1	1	4829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCAdRzNDa78U5pQaXWMKjb5m4thHoufSHMzFETdDpoF8ZBxEy
7465	payment	1397	1397	1678	1	1	4786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86ZQjdaLnsxpSCt5fdVrvSgPK8VYsuaTW87s3XDf56fFzfDXk
7466	payment	1397	1397	1678	1	1	4787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUA1EJyTtCUtoZCqxVGBDKtJSwcL6yecwuX9vMuRUatA3ajzCY
7467	payment	1726	1726	1874	1	1	1748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpX5jqdhe9g9qjCcxvv9eLetvsm4ouEyhPWtoSEZgWWagqeRZ
7468	payment	1726	1726	1874	1	1	1749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoja5227TXruzBswnygro7ZE4RqqiB2mdHwJhC3TJjAP3x3uhk
7475	payment	1397	1397	1678	1	1	4791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFxsV38LEiEpZ97heeBtoNb2nveF7AYUdBm5JcKiCE7v3NVsT
7476	payment	1726	1726	1874	1	1	1753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAz269r7kZkjeyrSk16vkJwxy9Vs3f1DF9BZiRgSH1sWRqy2VH
7483	payment	1726	1726	1874	1	1	1757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavaGa9pQ92uXFVeMQaqFjDFk86eJm56qVb4XBQmu2kCVmNXmw
7484	payment	1397	1397	1678	1	1	4795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwuHkP92QgANHi1tqAfRkZ1q2CizwPPdvKf1tPsuLDrt3LGLg
7489	payment	1726	1726	1874	1	1	1760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9DEVxtFRHxUSzZp3dtDPNgZSST1oB1d1KdirhBU9jjWy4h87
7490	payment	1397	1397	1678	1	1	4798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dQsrLLhpeyLyC1G9sBYbXGpJp1m2B2NPcjWK16geMofGL3ZP
7497	payment	1397	1397	1678	1	1	4802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLa2PwGyo1zTH8NDYQVoHwCg9gqr7J6BDbuFBPmk6nV1WxLqy
7498	payment	1726	1726	1874	1	1	1764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaad8pm27cNYyZEW3nMfNFu58p6BRgpbnqF1bgTdEt3ER33W4
7533	payment	1726	1726	1874	1	1	1783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW9b4gPYzrEwdBt2DH4FU8mo9pDKuy8s1kqyDn52vnapKGtCh
7534	payment	1397	1397	1678	1	1	4819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFzeC25mb348asPXZeNwYGn8d7T5V2jZtVeCT6B57XpJy51BY
7539	payment	1726	1726	1874	1	1	1786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKPDwoLHQfbLy1gLRCocYorYro4xQsXQieZh3Uqv1RZeBJxDw
7540	payment	1397	1397	1678	1	1	4822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UM9ZZcFSc5nB8uzp4sqRKpVhrEXiTGVaKPD1pYVCMubt2BdD
7547	payment	1397	1397	1678	1	1	4826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZzGMWUqQkaEpiCQuK1Po7sAAyfPw5f36fKvz2WRMu2aPfR4v
7548	payment	1726	1726	1874	1	1	1790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVAB48d3atWTT8tBYFg8Fdgb1XS26en3EAkbz6UW5aWppB9pW
7551	payment	1726	1726	1874	1	1	1792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jXbFfjyykK5ZwmMQbRMuuipQegw1ZDUGYAePhjwaGJmcqo7m
7556	payment	1726	1726	1874	1	1	1794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dNc9uSYztWESyEBew8qxaQVVN6oSU5iGU8JJxu7Hzeo2sC72
7557	payment	1397	1397	1678	1	1	4830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZFv6rHrpBNMGVgrBWckamo8gKidqJE2qN4h1PXnjwkmCN1NG
7558	payment	1397	1397	1678	1	1	4831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8srHnpBhzHFBo6vnyPF7uaPKFzeAiBYFBq4XshYAS6zL7oS2y
7559	payment	1726	1726	1949	1	1	1795	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9XierAWtWoJXN8nAxJrNLXUnCRvYoNbfqGEfoCpy63SdsHTqY
7560	payment	1726	1726	1874	1	1	1796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiKGFddZcHKcKmPuGAxnyKbQJK7GaUaXgaDjHqfkvSrAXYWyq
7566	payment	1397	1397	1678	1	1	4834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk7uzwTTuuSXtP284Rrj79W9ZkMGPYp4s6y9Tx2HvYeLtdF4Y
7567	payment	1726	1726	1874	1	1	1800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkH1cxx3JD5fb6ue58cKpjzDLMHS5qj1tTBhmxGYiuW6pNU7W
7568	payment	1726	1726	1874	1	1	1801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHQ7BKMD6XXUMoUaxSnxC715ZcK4SwKo98pcTXz2a8Ww9W7Z7
7569	payment	1397	1397	1678	1	1	4835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyzP8V12RArMsb25kxJvEDweRVWKjuMh2P2zDtQZxJcbBi7Ny
7590	payment	1397	1397	1678	1	1	4844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffe69TyYWnH2HFUdtrup9D4gSk3Lb85KSECtYHeurZiJCDEhs
7591	payment	1726	1726	1874	1	1	1811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKCe6Msnj4Mr6Sx6z1daJ14pyv5nowgca6kW5GnyqUNR97THY
7592	delegation	806	806	1396	1	1	0	\N	265000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXP9uwZXgSAFBmauv9dHWMofoHMqSjFy4EEfRz1eDDEBjDUKUQ
7593	payment	1726	1726	1874	1	1	1812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdHqemhD5TrrS8fhFhXR8Dq89j3jRWgv8dxPXw55u3LjD6hqz
7594	payment	1397	1397	1678	1	1	4845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqfKnzd9WU6Aqw4FNGHZUwfZiXhvzUPbEXxyFTV57faK17HWV
7599	payment	1726	1726	1874	1	1	1815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QVxc6DGwwnNnxe7mzw4DENhawGoWTKgAMZfCgX7VZDwxmSaH
7600	payment	1726	1726	1874	1	1	1816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5p9Ej2ufWaxCnMkTPCbxte2kb91HDjEu8qFJr33UAwbT4W21
7601	payment	1726	1726	1874	1	1	1817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLhK2J2qxm23EgWNCKzY6jkWxVgQ7T3hN3xPnmXRGGvHX7NgD
7602	payment	1397	1397	1678	1	1	4848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJLMmNRM3A7Hg1sxvdF4KJxkGjRs62x7MQhMBkvGTkMXRQS1B
7603	payment	1397	1397	1678	1	1	4849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcxYA7W7nxUj4CzaravBdYk78Zgz8zGGaa9KeaXJHsCE2UtP5
7505	payment	1397	1397	1678	1	1	4807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVajLYuExc4d72NNxU51wtPYMJ5McfxugaBscCheSTxnMLYbY
7506	payment	1726	1726	1874	1	1	1767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkKtxanbaJpWhWcwfi4Gddksx56Yb6oQn1ke4yusMVMn3P3ZW
7507	payment	1726	1726	1874	1	1	1768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkSYzQpiuwcLyAUkGXpQfSCS3qChXH2V6DupeQGPLiPiESKKa
7508	payment	1726	1726	1874	1	1	1769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCocUwfdY5QKaXFtULdzf6Udz4hQkwf9DEwauSM2msnJdV6rt
7513	payment	1397	1397	1678	1	1	4810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBE8dRSv57xYk9fsAQKbGKChgiuqem9MBTYBXwVWoidH86eR8
7514	payment	1726	1726	1874	1	1	1772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRCRcyzj5RMnvc6DztnG7FASJ88iS6wMGybGU6XyRTeFWQCxJ
7515	payment	1726	1726	1874	1	1	1773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbR6PFWwjwsTyA8Efrz9ZxEQHaP4s18adPUyBQ62QZUJcpvzr
7516	payment	1397	1397	1678	1	1	4811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfS4eqoa8ATZDHhHDnujCGUmGsx6KMYynZmEa1q127VAjysBe
7523	payment	1726	1726	1874	1	1	1778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbStCQ1frdz5Dhrkmhw8u1x1on7xqdJPGmwcAUbvhVmyHwuKk
7524	payment	1397	1397	1678	1	1	4814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMApB8upYLYPfsHuQWM95B1Y7LcAm85mwcbtEXM414bzCRpLV
7525	payment	1397	1397	1678	1	1	4815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiUds5SBBLnuTjukqBB1jpETgsdo4wKC7R2KAKAoCnujRYLJx
7526	payment	1397	1397	1678	1	1	4816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCB8JyE6E2yf3NQyJVfHu7pr3dDSxYGu3YNxEcvreSWPsb87Uv
7527	payment	1726	1726	1874	1	1	1779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwhTpKuMiSiGZLg4xE7W98K5BEH5e2Uzyu7Jhp57dYZuFUXTT
7528	payment	1726	1726	1874	1	1	1780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiiHQMW7wsQ3r9WsThuEtM2NuhRh9ufj6ty1pAB6C3D29to1C
7529	payment	1726	1726	1874	1	1	1781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rbwjinLiunarxSpMd1iDf82oPzYdXb85a1gKgUNDTbaWEkMm
7530	payment	1726	1726	1874	1	1	1782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp88nxfiL2467UjsErE5HFPKZ9XwWivBRsn3VQeHAnfDA7Y5wi
7531	payment	1397	1397	1678	1	1	4817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tUFQYZ38v65K4YRX28CqX2tRSYdi75dBZGYk99Rb2iF1cQfu
7532	payment	1397	1397	1678	1	1	4818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2trk6uVpy5NWq5AaXz4zuouqgbz3ZZYViQwbKGkKToYcAJsCz
7541	payment	1726	1726	1874	1	1	1787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaunRVCZHCYzFVVwvj8b61e8Si7xHjLtpReeCHdCHTCc7DHrX
7542	payment	1397	1397	1678	1	1	4823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkJvGD3FJSs3ru2k3vgCnnRegR9fqaW4PSyQFyJcd3Y3GPxw
7543	payment	1726	1726	1874	1	1	1788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2PPPbmR4NNjbqF8pB9Pewd2mFGVqtffHCDnGXNM1TzkdzajT
7544	payment	1397	1397	1678	1	1	4824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yHg4DTQAurxrR7VHnfRKdVtqBfy7KoFpdVcNrG9XXA6s6vY2
7545	payment	1397	1397	1678	1	1	4825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTKMh3GgvCaHdnXR48Xt88yBLyHWygY6De3MvBHkwgbyg9aRc
7546	payment	1726	1726	1874	1	1	1789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpMCd6C3wGqQxBjoBpTe9C2rcMeHtdLthm6P9YWURQLuqZww7
7549	payment	1726	1726	1874	1	1	1791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHJdDNi24FrigzTJ7FPAL9Jc7P6HCwAoxovUAhNBUTx7CbAY6
7550	payment	1397	1397	1678	1	1	4827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLna9cUsMDDW218VSDuh51agBzKamWE4XTYW7VyiC9kcvdekMi
7555	payment	1474	1474	1950	1	1	3	101000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHg5tcmp8og7NmFPLG4PcfBMNKB3jWB9hVxPzBCSsEwQPLGxzJ
7581	payment	1948	1948	1713	1	1	0	50000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjbBWwdjBhuZQTWxziogEiUoYguewW9k8SYw7KQ9X8R6SFqcW
7582	payment	1726	1726	1874	1	1	1807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZLegLFVme24B44EUVmKUxgzVj1LgWQJjAsqvEdmMbTwFjnqA
7583	payment	1397	1397	1678	1	1	4841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBUBvqnXnwMxvQ6VM8LQfUrGzfGLpaiLBHXYeNNhjHkuCFuya
7584	payment	1726	1726	1951	1	1	1808	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9F9gv4c5eyRTgwyisStFdTjkArAmW8G75sapbuFGMRnJ53tdm
7585	payment	1397	1397	1678	1	1	4842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdFPBT4t5oX8nw715xre14LYKn7oWJFppi5e1j4dVNNpVQKZ9
7586	payment	1726	1726	1874	1	1	1809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54Fri2rs2peAtKwwnRwUyBQmYakYqB2xkinrvMraCLjadDsKj
7587	payment	1726	1726	1874	1	1	1810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAeF2BNpEUH2CBV5DNM7emujiPcAsL7iH6aGdMmtXcfMN5Gs1
7588	payment	1397	1397	1678	1	1	4843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKs1kD5xd7DKQs7WKaNFgfx6PwjVdPnv4pGqmVb85pTZv1DMQ2
7589	payment	436	436	806	1	1	4	220000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFN4w6Unj4AY7S2SRds6UnhPZvepTwvDShyWrViPsxp7HKkCu
7607	payment	1397	1397	1678	1	1	4852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbf7fZmGnPxdqioLt8PXWmmokJgXTPAu37khuM3iLVJK2Pz7Py
7608	payment	1726	1726	1874	1	1	1819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavtcKPH9fM7eTQHgDAHyS4GFFX1iT6NLXEgiBQ1PRvYigxvie
7554	payment	1726	1726	1874	1	1	1793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNEa11YjEW12bHAi1GgDTJVD5cx8rBbCB2zZbUte2JsLYYGBd
7564	payment	1726	1726	1874	1	1	1799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YHUkm2NvXReKX88RKSbkweRPqgCqbFvBviKhFtCuuwVWR55M
7565	payment	1397	1397	1678	1	1	4833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzU5LaZFqEuXAA5XPEz6knmbugjBhvmzyCavxBiRUVqhtocG2e
7595	payment	1726	1726	1874	1	1	1813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqanNiYMUjK7DXh4ssqeZAcaGAcSMkueuUUw6gXXMqM1zNLSp
7596	payment	1726	1726	1874	1	1	1814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aTVKf1C4Pc8UUbrFscYWUsCt9FNFqxfR3EkN73Kjz91uV2Kc
7597	payment	1397	1397	1678	1	1	4846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEfWBtGZ4KmdwBxYJe5mdTXA3SRJzUERicq9mfzsEoBChAhBN
7598	payment	1397	1397	1678	1	1	4847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggPwMWrmzjKbWcLH3vMV3NVRDTXPyJfEffYtydoBFf8Wuhx7c
7605	payment	1397	1397	1678	1	1	4851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBrfZ15Gz22mPY4gVRWtEbdgK14PvQEtRKSsMTR37Zpkj2HAg
7606	payment	1726	1726	1874	1	1	1818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowTPYieyMXiHjnRScGUsvLe4K6tWaKqbqoFZPFi3BdNCp7ZTF
7611	payment	1726	1726	1874	1	1	1821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3RU87GqNdP39VmyjsY6hmEb8SXe5GETCdDvt4g5Ddb56n14t
7612	payment	1397	1397	1678	1	1	4854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj66NdpqZz95UeSa9SR6wT7E7CThvh1LauvezSkZKonizszHoQ
7621	payment	1397	1397	1678	1	1	4859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FH9ajeE9FwpopHfgeSHXHy9pJim9dNkSrMLfsTpxVqpo2jQT
7622	payment	1726	1726	1874	1	1	1826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYBeMHV9iKwgUzvGC9jCcUG2LKZDKdA8oq2KdNfEiJ7nug274
7627	payment	1397	1397	1678	1	1	4862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKty4jTbxLSZTrkowVKrjBmbqrk29HcdJFsBUSkzQAaSajDao
7628	payment	1726	1726	1874	1	1	1829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8twtiXe252nknc8V7UtwyCTb4fvMS2Xdx7WiUrQvcVvrQuqWn
7635	payment	1397	1397	1678	1	1	4866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSkcKyuWCoSZj7jGBe5zCBwTRLzZALXQrVoWH3QPXE5MEtdAf
7636	payment	1726	1726	1874	1	1	1833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYzgHtVvzBRVGtuWE7Vsp4zTRuWkbu2LBWwE81m1JY13YycZG
7570	payment	1397	1397	1678	1	1	4836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jeRr31WFJZnK6wVDSkVuQgFezokuoWUjc34zuVcfqLDHtGc2
7571	payment	1726	1726	1874	1	1	1802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ziFjhDdsvaoN4m1ZLupu1asENoCj8MpAL7Kua3x8KDYZYZim
7572	payment	436	436	806	1	1	3	50000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3u9Qy53XbejNw85amdBWo5UhUW2bHhjFnWWoEKJGjZLyjtaNq
7573	payment	1397	1397	1678	1	1	4837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCF9kUQDLPxwNXcoMyvS9QxGgArzSiiQvLHjW1pqwfBowmBF1
7574	payment	1726	1726	1874	1	1	1803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiPuFHV3ykDHyfU2mKUx2bR6vk2L8dPc7rKW5C4G9t91jUvQn
7575	payment	1397	1397	1678	1	1	4838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1RNj2iGWWS8xdCi2dCZbfbhWdUPn7mCACsBGUtEZEiqEBWsN
7576	payment	1726	1726	1874	1	1	1804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Q1hT2BNLbX9nXsp9V5GPBZMqPuHBT7rrsjKKnVCUjjsvoH3A
7577	payment	1726	1726	1874	1	1	1805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJbX9orpVZVDoZswF5uWGrMxhdfpi8ueq2xw4DWcVnEeBtttT
7578	payment	1397	1397	1678	1	1	4839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WVQcBjSeC9U1Ut3vyzU3F5oX8V8L6PYPqAjpvD9mcu2EYwsS
7579	payment	1726	1726	1874	1	1	1806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcRMFFJHKTsbkrvkVQNariYZkSPVaT2bvTQQjiZp4seZk4Rjz
7580	payment	1397	1397	1678	1	1	4840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gzL523FmNdnWbMU5hNAjXgx2bRPTw1uxBTkSK9ajM4gKJr4R
7613	payment	1397	1397	1678	1	1	4855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoswQutgsMoKexcaDB1S4PN8Xg8TqzqtAFLSPHmYhrL7Uq3Xiw
7614	payment	1726	1726	1874	1	1	1822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjdkZefvfTK3E1owrnDRG1D5BUYrWSSVKy1whMezfMNf4U2mi
7619	payment	1726	1726	1874	1	1	1825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLBGVwQfxTdcL3UiHALZ5RmJ1qTSkGPYR6XwbWdbPLLs4kgBy
7620	payment	1397	1397	1678	1	1	4858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDS7jRkZCEcRL9QxTogaUX7GkYjPMaz9ZErecG82XstFsuvT5c
7642	payment	1726	1726	1874	1	1	1836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNyvCsEGuBkzA9yxaFX82uhEA762iasutCcEX8DwQgsYWRbRg
7643	payment	1397	1397	1678	1	1	4870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9kR5cdEejKZ1ccRekF7PcCY9U49C9kdBQYsmWpkDitqMZReS
7644	payment	1397	1397	1678	1	1	4871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5wSMwnHwjYm8s9NNSCyjn76poSopwtnzKP7QtBmJmUqArSPm
7645	payment	1726	1726	1874	1	1	1837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Gais4AGS5942if42DtSNjAgG9mw8QgPDQLtveTTQhXHbb2mP
7650	payment	1726	1726	1874	1	1	1840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTRQmVHft6JCTUzq5dS87TY8KVsaV1CQBCq9Bhq48NqA22Mto
7651	payment	1397	1397	1678	1	1	4873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWEqVEurk5rYPyAsbVVkeBbKmXrEQ2wkVqav1Lb9hAtDYbRUC
7652	payment	1397	1397	1678	1	1	4874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiToG63434kvSFJwsnfDGAzsnSwYvdY6EZmh8Nn8EUrNcURZCv
7653	payment	1726	1726	1874	1	1	1841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnyjwwFhxFZM8KdN8UgS5TLwQMDxLUcTUbRmE7ggazzjRakKm
7604	payment	1397	1397	1678	1	1	4850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5rBhoCxcbDAb6Wo1kFMATC84fFbUvj6axxtc5gZ2JhUjHmx
7609	payment	1397	1397	1678	1	1	4853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4M7MYUgVCixa2JXZBMvvXZM6vWy1WyPV5xNWCLySw6kpWGvo
7610	payment	1726	1726	1874	1	1	1820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGpiTNdoZQghpFuynRJ4ShDcumh3CfzG1VDCZyGMtwK5V4pXu
7617	payment	1397	1397	1678	1	1	4857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvE3qgbzVLqokFA5jNam49ticPLEWXxsceRnx6QkExAUrjNVC
7618	payment	1726	1726	1874	1	1	1824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVr4UFGJQnPLCPP5JgpQQxYtcH5Y6iur3Ncdi78UJr7YwVyGp
7625	payment	1397	1397	1678	1	1	4861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt2gVdDYoucWA3d9Xr2tQ1mVLoAfxRkEzWMhvnCXt3T2ZQQ29
7626	payment	1726	1726	1874	1	1	1828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGLg16rKDhQSkSWrTUgHABfesZ7PonFddadNZnrJ5uYDJNEUY
7633	payment	1397	1397	1678	1	1	4865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9Drsimu6i4aRKL819N9ZLKHcYLBqYFyF3gUrxNzutP6e1bVZ
7634	payment	1726	1726	1874	1	1	1832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rpkqxWGFXeSq1S8RCTLHgxiA6aduVxnNZeviXAsR1yEMC96w
7637	payment	1397	1397	1678	1	1	4867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLEy2TAVe4UxQen46umwRD2rc8NmaxuY1zPEvjvaBtoZge9AK
7638	payment	1397	1397	1678	1	1	4868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufbCPHHR9LhiwqNhCCUtkZCZ9nYzaQtKDciPNGLjk4A51zAQ6
7639	payment	1397	1397	1678	1	1	4869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZWKE9VgVgiFsUCpC1x8mK1GG9rnRebqx9rbe1iR2ESxkzbf1
7640	payment	1726	1726	1874	1	1	1834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wnLuN47gzN9zkbZrmSgXB34iE372N9qbFArYPyyMa2TWPePi
7641	payment	1726	1726	1874	1	1	1835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEVyUZ5tkAApiF9kSMCoXs5YydRfwJbkjuqqnG18foGkGi8DY
7646	delegation	208	208	1460	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9ZdrfirWkKvZC7kaYPKAE8gDGh6h5eBWD5RdxFTFVZe9DLc4
7647	payment	1726	1726	1874	1	1	1838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW1veupJwHz5ttoG9jRXUJyjBNxkU28cQdEFY6wzR6Vm5tvd6
7648	payment	1726	1726	1874	1	1	1839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JFfESwWLBgB2Lk86FUSPgckTad76V3honrZQFrEecUnfEzYs
7649	payment	1397	1397	1678	1	1	4872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdmqzP94TpBXiD7WkqVV1gz7vf71GBGDvarEEDzv9uvzuiGg7
7656	payment	1726	1726	1874	1	1	1843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AFm9fwkpvkzUEJeWdhYtH1XDmLJVLEERKnQBSKhuxa2aqKMo
7657	payment	1397	1397	1678	1	1	4876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCPmeh5h9Asjz8Ta69Qf9kQ2LYdyZ9PvVDAAH5N98yDLFH4uW
7615	payment	1726	1726	1874	1	1	1823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWw7rrQU36nVb5WP15pvxTGp93GbekyYSaacCa3268j5VYw3G
7616	payment	1397	1397	1678	1	1	4856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnAceismrWVRGFKpmhci6wmxSNDBXYzEB6uzEckag8Vn7GSjQ
7623	payment	1397	1397	1678	1	1	4860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe4iUZQ7qsYHpE9DgRiipkghfUqsHu8PMDxr698qjR3jK9Ufr
7624	payment	1726	1726	1874	1	1	1827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2psDKLvf4EvnY5Abhvw6WeFukTgrcAN7odxCdGWQsAi227kP
7629	payment	1726	1726	1874	1	1	1830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kBE9UgHH2KX3Bn8oFy4dBZ4hL5p71Q1c4DJXgX8gyvNhL5ef
7630	payment	1726	1726	1874	1	1	1831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3xrbmL6gNUweQmqz2Zd87Up6o9DWmYUvucAK57yh4RHkzbZf
7631	payment	1397	1397	1678	1	1	4863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8dZtjz4TvS5fJRYRn3g62Sxmg6MGma3AWoCECWGkd7sqKkKP
7632	payment	1397	1397	1678	1	1	4864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUXxSpgLWHwXEThve7Bvny5tx4UZyiC2vHt6MDJy1asnookEu
7654	payment	1397	1397	1678	1	1	4875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGbUeMg7LZN1H7f2pEjjkFBPFFdohuFW3JGdAfFKWAE7hogeB
7655	payment	1726	1726	1874	1	1	1842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkJBh6wZ5bZtdLSdwSuaXPqwM5WbVp6yM7hQSw75esRNwMstW
7658	payment	1397	1397	1678	1	1	4877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWojkEpbrUYDRdCKVLHxEsGebepCytBQS8UqosXyzuBWpTaVR
7659	payment	1397	1397	1678	1	1	4878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62LeDL8fycnsdLfQNqub5pJw4rJQr4U9RH8zTJRELyZwwJDSK
7660	payment	1726	1726	1874	1	1	1844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9KzRYE5ZH2BvMJSXtwAGAUxzecmvvPHoLuw1zKyHWcdBZDFS
7661	payment	1397	1397	1678	1	1	4879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVPnLwh9aEm2wJopwyU1euj4oZRt6VXdR4KfeBL8apppj9umG
7662	payment	1397	1397	1678	1	1	4880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSugqbMwV6pJX1fZrYg5WDQB39HqxfjyGGHATUeo4mNmQsmzN
7663	payment	1726	1726	1874	1	1	1845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcGtbkzwcWocdCb7c3fbd6sot5bvCC22Aou3UcuSg2vCPn4WW
7664	payment	1726	1726	1874	1	1	1846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbJ9dijvmnFUqKxR2u2Ur9LBN3gqEWSrtgARW5RhunXDdMhjv
7665	payment	1726	1726	1874	1	1	1847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRzHs5PtMCaJrAdjoyceMxpYspZFo1YvZXCFKeWVsNjphzvTS
7666	payment	1397	1397	1678	1	1	4881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauMC47fFXetDoE7qX7uHebrznbBoADSnEu7juJA8hgRCFiecr
7667	payment	1726	1726	1874	1	1	1848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVw7K3VZkPyF88J8UtPcMeNRTF5w8hQkoWN1PLAYjaCGgd1tHY
7668	payment	1726	1726	1874	1	1	1849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzq8VZ2gQG1tzZobZFa7XeHzPQsGPne8D2G7wEFHPbKWdxzWx
7669	payment	1397	1397	1678	1	1	4882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiRuqpCnQhuQj1ep8bSW92Z62RgULJcd266orT7TbfgjbmPYL
7670	payment	1726	1726	1874	1	1	1850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLivJadUYugKXk7D7KUA9jWBShNo6LgHMnaCZ7YJtKKr6Rbxf
7671	payment	1397	1397	1678	1	1	4883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqmxf3nctsHmLcaw1X7iJ3FKEp2WazsVKRL4jy4gozs3kYgUn
7672	payment	1397	1397	1678	1	1	4884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNxMJrD6fDRR5NpdDCttPpV7gJZuERgYcT1WYdTqtwf7XGepR
7673	payment	1726	1726	1874	1	1	1851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQrKd6CbrvXHQypRmu38Ptvg8Es6opieMRZAQm67kY9dSkQ6T
7674	payment	1397	1397	1678	1	1	4885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRwMXwbiyg4hRXfTfaUDNhz4PeNEKKh9eJV6fUkkvGoWYeX3H
7675	payment	1397	1397	1678	1	1	4886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqQ58uWekp3ExpGAsDuLkVzamRnbEzmB3GhVBMKTJ46hiCCyy
7676	payment	1726	1726	1874	1	1	1852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyZLk52unY8n8UKLqLMuXgCvBLcPZ1VGLezeGi9VUQaYejmpQ
7677	payment	1726	1726	1874	1	1	1853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW432WQu98DB8oz5czFfpqXvg9LvC2RqJzZUYELQwWXcwAuZ7
7678	payment	1397	1397	1678	1	1	4887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZT6ynGf7Ndz4P8TZNegpSerdkYhRhYYS82ubTq21EPoWxJgT
7679	payment	1726	1726	1874	1	1	1854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wuwnhNUcqqCWACe3kguHpMRErgoM1Nc4MWtCTWWbo5P6koVC
7680	payment	1726	1726	1952	1	1	1855	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYennv1R7Myxe5yL4scFwEPyLQdPrYsDw2B5cmjyL2jnoPPaxbo
7681	payment	1726	1726	1874	1	1	1856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE4wqmpNuPpFpiqSW7GaPs4DNLLDLLGKmzVPd5NFwZcJr2KuT
7682	payment	1397	1397	1678	1	1	4888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwxBi47dXwrYEZb4Pq1GkEv7j6E411heWWq1wazrJMNc4oJuH
7683	payment	1397	1397	1678	1	1	4889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPP9bodfYBwxvmg2xUTAW2kQrvW81C9svywzrVvJwNhfV7mqW
7684	payment	1726	1726	1874	1	1	1857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyzCE9yQS3pg1twwARyL1tWNzBDXApUuho8ABs3fa43DVDJiJ
7685	payment	1726	1726	1874	1	1	1858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9vvC9pfJw5GgMcpFtBarwEhJWZkz93jJkEU5nRxq62fJUZvW
7686	payment	1726	1726	1874	1	1	1859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mnoUVwAf3wnfWagnDP8XFVFg6y155eo3dpx4oribBLtK2CXb
7687	payment	1397	1397	1678	1	1	4890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZa2QAfSDertd6YDndrB7LUzdKg8MRoiVz3DCrdfWvzeKgTCr
7688	payment	1397	1397	1678	1	1	4891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcQA4Ra5bQLvzvYWTfLRa3kw4ETKZwri38jA19MZ3pUTBWPSk
7691	payment	1397	1397	1678	1	1	4893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLPJzYdTxNtQZJxsnty4BpcpK5bTbgfnx63cVMsPDsXtxzwuT
7692	payment	1726	1726	1874	1	1	1861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PAYojGdcSZwCQoTx4quoAfw3fibvFW5QBmTwn3sQTq2cazYC
7693	payment	1397	1397	1678	1	1	4894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALUEVn3JF6Go1KUGVeBwn1bV7CbwawfbXTqQJBwDSw2TpqM6m
7694	payment	1397	1397	1678	1	1	4895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsJafCAxyrYMMrhxERprWsFZ97RsFFMEtRMgazjjudPHtA87W
7695	payment	1726	1726	1874	1	1	1862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xmVfvacpH1ZsNnFNhzbPrfrFtBT9rvbFjnYFUywcx4LP1ek5
7696	payment	1726	1726	1874	1	1	1863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eecZBy5WeZP8RfSP7ScU2XzyTQ2Zb733gyTZ2CN7knCPmacG
7721	payment	1726	1726	1874	1	1	1875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcF2TyzUS8KeqinjNUs1tm6vHBT6A9LQhNZgNsxULm4wdCKp1
7722	payment	1397	1397	1678	1	1	4907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvF4mxNyHQmrLGQpGm38oCW3pePdLagWSD1Qy3whtgCAj9KPw6
7736	payment	1726	1726	1874	1	1	1882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfqmTWjLWLJmR7xuQ48uNMGqg5WhV64DFDs1uB3W5o3ffDPaW
7737	payment	1726	1726	1874	1	1	1883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5JQwnQx1dnZaGXQ7MD6EbGk1duoSpR8jm6qNthtijWcpBVxL
7738	payment	1397	1397	1678	1	1	4914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FkPYmZatrqjbZT7rTZ8UVbJftUoTYodrJArobp3Jkt63xkyr
7739	payment	1397	1397	1678	1	1	4915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnov4ntrJUz2WyBq5ddpzPbaigwBxpSYDXrB5d2RoW9ivwLMdg
7740	payment	1397	1397	1678	1	1	4916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXJxSTH3bTyrdv5RJriZC2a392qFoHM6EKrT4BWo4RYuxJtdy
7741	payment	1726	1726	1874	1	1	1884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzbz9tZ9AnJxVGqffc28VJEVjx19ZZ5AzbpGphVnt5Q56fK3b
7764	payment	1397	1397	1678	1	1	4926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBYnz41KcMZmg7MqnmqKsjfpi3RwXPEbBZRuGfYduy9Pat3Vp
7765	payment	1726	1726	1874	1	1	1896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoQjPNRDfSF7bTqgeT4Tzc8iRnojpyUgteAbhHamc1Aq5PBXA
7771	payment	1397	1397	1678	1	1	4929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjmUwGqamkvcGM62mJMamaEGtepCWomsU9o6PabkYwraiCUb6
7772	payment	1397	1397	1678	1	1	4930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRKStaH5T9CCLXMUAqma1NLwLwjz18wMXJY5iLhTh3ZkTAZnV
7773	payment	1726	1726	1874	1	1	1899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx2Z9zYrYf9nUpqEtAVk5aXYW4Z5EFNWfTSDj3jB4YvEVnAwom
7774	payment	1726	1726	1874	1	1	1900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFQkpETgfsb1XvMiR76UCZ6n6ohA3rCq1p5sR2PHsyx9CXf9i
7813	payment	1726	1726	1874	1	1	1919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi61o3rAXzS1SWsvSHWdh7D9STpZbSjBuV9XBo76em9ZSWZe8o
7814	payment	1397	1397	1678	1	1	4949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCoYCbozNDtpktWj3GqdUXY8tv5pmZCZyC26garXeqUvsrQdF
7815	payment	1726	1726	1874	1	1	1920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdvd7BbxDNPvEAsecGwcUREU9h1CxE7qRH4gBanmmNERytq3o
7816	payment	1397	1397	1678	1	1	4950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFH2cN78kfcv6w5pPdshzY4MEHbuD3CfPy8aAUZffwEwm3dsZu
7832	payment	1397	1397	1678	1	1	4958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8cRmSDSgM2sRodya5neqb4jBHJYNrwsvuTCaDdZD35ASCbFJ
7833	payment	1726	1726	1874	1	1	1928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzNhd4XduDvNnPxAV9HXyJKKpFtrdXqLmKhnSvD96nuLgGZ5v
7834	payment	1726	1726	1874	1	1	1929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDJG36SSAEspMKPMSsSsPPqcmVJj1m2BWHbNsThxo2tNYtFYo
7835	payment	1397	1397	1678	1	1	4959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHC1Putwfd8UfhGcALdUBiz7NanSvNvRjwjC9t8DSCkMjGzWVp
7836	payment	1957	1957	1941	1	1	0	5000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeaonXFric2sQmCDNJTg14DigPr5bexjSzi2jonJEa7m1x2WE
7867	payment	1726	1726	1874	1	1	1945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRM2C92NRN77MW9jKFEqE6LCzbCLiv2g98BySZyNiNJsjro9D
7868	payment	1726	1726	1874	1	1	1946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxTFJXHXoWEDKMrexcN7zWmXdvJNbAAwksKV4tU5vAv6aJWws
7869	payment	1397	1397	1678	1	1	4975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11CByo9gRNkiT343b4xo8vtLN4cXLHsP7GqZYstvTqa1iqtkw
7870	payment	1397	1397	1678	1	1	4976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxT7Hk7rnSK8nQvcC8h3DVyUtTJ6M3yeSJNHt9N29ehMzCQJ6C
7878	payment	1397	1397	1678	1	1	4980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ff2rat9or3HaYimUt7R9HxQiAFRY34urFcVtgjxbq7rDxZ7P
7879	payment	1726	1726	1874	1	1	1950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYj7kiGd4FvJPxrX7PEeS3MaGWMG7kHmLiB8k2UxYg1heqg2E
7689	payment	1397	1397	1678	1	1	4892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLywtUt9Bm7H3HY7McqSitcpjAemDuZ7odUXzwWyVic51Ktqj
7690	payment	1726	1726	1874	1	1	1860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJqvgMZF4qqTrMtSmWiJ3QbQcr8xsiveiCCecfW8NZ3Yxeho7
7697	payment	1397	1397	1678	1	1	4896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qeVr1eWLqpFQ58FackuE3c23wVDXZmeYh1i9H36UzBrN8ZTE
7698	payment	1726	1726	1874	1	1	1864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmuKuDRXWht874fABEMw2njxvWdLpeVG1ZZiG7SYULnBRDku7
7703	payment	1397	1397	1678	1	1	4899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDBY9qU6eZb99575BFSh42vqozLVM1vcBRMYhuvD4m5jmzSpQ
7704	payment	1397	1397	1678	1	1	4900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46UnQvbzH2xQoShZzCr9fi1PpqRLeFJXRziaHowFErvJkv3Vg
7705	payment	1726	1726	1874	1	1	1867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2QKfWfdgUvSNnKaoXdhskCgwCwRF6MqKUFAadXjznAkFLzFc
7706	payment	1726	1726	1874	1	1	1868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQLdJ6pVsCpwqKWquuzHwAEnrnmtKorfjzWqmAHgXKmjUucu6
7707	payment	485	485	1569	1	1	0	1000000000	1000000	\N	E4YfQUGvkNvLasMoEqGKLUBYSNHm95nZAV6x9ByDWMTQxvb8MVQzk	CkpaJPxkvxxJkUseJY4rgLukXf6SXd1GPMMfHaySzheZJyZzEMM2e
7712	payment	1397	1397	1678	1	1	4903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrMLMYCJ77PTgGV43qCD6ihgXfkd62ehytVWwy9ESBE511Ptr
7713	payment	1726	1726	1874	1	1	1871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZib1XWJifykT6myvcfztUHg9Hm4NjXW2W1MWCGPWUh6FzpnuZu
7714	payment	1726	1726	1874	1	1	1872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFC1cmM7WXJxptNkhG5qhr3XzuEPXfQtYpd2DsRRykZaRXM8D
7715	payment	1397	1397	1678	1	1	4904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGk7zauKt5ht5v946v4CnYAXiofyYhZDW1L4qzTNs8SXMqQh8
7716	payment	1515	1515	409	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGh9BJZsnpeff8ZZSuiscuw22TuheXSiMkaRFLnFBbeAtbNpKx
7723	payment	1726	1726	1874	1	1	1876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ELJoahLnUHwU9MxtQ13zTPM7YXwSzqGnL7zcJfH1jo4kVkUX
7724	payment	1397	1397	1678	1	1	4908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvVYWSXZXrN8Wh4T27SVpVSpXq4vrDcXssW9wpU5oSLmZvyZc
7730	payment	1726	1726	1874	1	1	1879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2KBGA7c3a5frvFLffhUu8XqY16m57orHNNqGtkhe34QDUDkN
7731	payment	1726	1726	1874	1	1	1880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzNdHizWtRqrrkansk5La7VX8JWtgaGZKUonEgsLecumZuKcP
7732	payment	1397	1397	1678	1	1	4911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAU5XthmS6thgmS3LALFmZG1Z1qLAo5jKo8Uda4bd6FzSjzkU6
7733	payment	1397	1397	1678	1	1	4912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5WFLKWusqdgw3fEHVM9rz1Z3BbVhd4Bk1NE1hfC58D4NgMTw
7744	payment	1726	1726	1874	1	1	1886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3BhoMyjfNa3hy4WaVq1aTXvaBLfk4sgVHZBwEYhdLhE36Sis
7745	payment	1397	1397	1678	1	1	4918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHif7huSPbCxoUouEUfVJb2VH1gFsLkZmxqodzrarJXpsN8Rt
7746	payment	1397	1397	1678	1	1	4919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpe5PzQS7BPnw9n4nuADo6x116BjHiaczJzT7NHkfLeVhL92r
7747	payment	1726	1726	1874	1	1	1887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5R8bSipG7qXVoLgJzceRGvDQ3ixaeirvAH4dsGNgYpts84vRb
7756	payment	1868	1868	724	1	1	2	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZThvCEki6ZvJ5sZee8NXPssZk91gCpeUSsXrTGJ9mCUnYkxMh
7757	payment	1726	1726	1874	1	1	1893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9tuezjCPNgcZXJjJXgGzfGatofJy5a3viw7Fz6NME3Njqsoe
7758	payment	1397	1397	1678	1	1	4923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6efd1ws4KhFMupJUsghRHp9dvR8ieXjbpXzLxuhK1wGBDucUv
7779	payment	1726	1726	1874	1	1	1903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQjd51GpFznFpT9jqTawK6na36Hz8w8Yp4hMbukGDTWaA7iNv
7780	payment	1397	1397	1678	1	1	4933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamoJQgtxdUnZXD78GjEPWhcpzDy2VT2qxp5RxyJBeU86NFKZp
7781	payment	1397	1397	1678	1	1	4934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsAjphxERQykikKcZt3rCXAbVpEAczx8TVeFjvqppaYEFLgLY
7782	payment	1726	1726	1874	1	1	1904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZHqt4p6XzLUEjakpyk6oVBa3U9BXHDrbH1kP2JNGSzungwsX
7783	payment	1718	1718	1474	1	1	1	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvvJ76J2DfvhZ4aE3ujYZ9jUXP7etrdesqCvnkfeSCSYVkyzC
7788	payment	1726	1726	1874	1	1	1907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4T8cHZmkfkayfSsJkgkoNtNwbSx55VoxvByyDPfJof29FB673
7789	payment	1397	1397	1678	1	1	4937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCy6HHF4nA52MsY5atqUZirLN1sGesSmTUf6Q6Zpe4Sx1LgBY
7790	payment	1397	1397	1678	1	1	4938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbx2S9PB3LRifdEsyaKh5q2jFkxFxhM8aLXH6Vi9p555bvBKXR
7791	payment	1726	1726	1874	1	1	1908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6J5LjPLvwU3ZmqtTS5EoD32kPCWyXX6Vj7dto2pf3JVRZ6qNQ
7794	payment	1397	1397	1678	1	1	4940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiLyJT7YK8EyFAXiXQUu2ze8AfobQw75DPvkkDUAwkrk1HQzt
7795	payment	1726	1726	1874	1	1	1910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7e6BFmYDLhoBU1hK9xEy8GRHA6C4qkXUs3tfKqQ694hPxo7X
7699	payment	1726	1726	1874	1	1	1865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtazj7SRcAmmB7Xmpz2YC3SzziycXHuUzFa1jAYKTEKdrNdbCg
7700	payment	1397	1397	1678	1	1	4897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NJbguK7Rwg1R5Yp2PghGBuVYKNEoJ5Lw5Y43vX9eRjWbRjkp
7708	payment	1726	1726	1874	1	1	1869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LYybSiWUoVJvtBPx3du3LY7bcagoCBD67UYGVs4JjKpHpJE7
7709	payment	1397	1397	1678	1	1	4901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNKVuMw3eQYAA4V4oyENh8oZSamyRAo8L3gzUnXRVVbqmoFPc
7710	payment	1397	1397	1678	1	1	4902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGxUJeSdwtueHrrdhuzacrtsbF3dA7wiEiZ35JeGdgWfFycA3
7711	payment	1726	1726	1874	1	1	1870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTH45gwf8nc29zgayD7hjXqLdKc45iux5bkMZ6jdBX2noYro1
7727	delegation	724	724	1953	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9n6vuWCt1q1LxDbex62cGKiv6nQnrQSWhxWgDHqjDMSyxMxo
7728	payment	1397	1397	1678	1	1	4910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNyv31M9qD5Ev9CkQbxxoQJvRm9qxWzzACju5g96z51gyxpSi
7729	payment	1726	1726	1874	1	1	1878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNRcxkfZVpi5hj1ZZvXmgoAwWnGL3FkhDuLU34aE462ybLvz7
7748	payment	1397	1397	1678	1	1	4920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjR8UB78sLYvL4CQUxZjkMWoLRKZ3Xy3AyHQGaqis1HQ8xnUnA
7749	payment	1397	1397	1678	1	1	4921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYnGrBCsRqwJDHUGh1GT4AmY8ePUJivmdEqyBfFEDy6ub7A2N
7750	payment	1726	1726	1874	1	1	1888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbJNKhQR6sWDgW8thzL7VaL8MhiTivAJUphRnPvokdsxsX4Xp
7751	payment	1726	1726	1874	1	1	1889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRHTLhVfmcYSd4NJ9iaePVnmKpLLFtUzP1an4wvXZzy1S4aNi
7752	payment	1726	1726	1954	1	1	1890	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCDVXEc5g8KgUgVH3S9TfGtvNM2QDcL17TrZA6byogNdzpdgBn
7753	payment	1726	1726	1955	1	1	1891	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfkvBw2jBGw5R1NGEGQj5HAK218XXAYtJ3ZkQk9thHHAG6XDc7
7759	payment	1397	1397	1678	1	1	4924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKrcDGsRhitQ44tTtwiGx28UWB3kFSbT6hKrvkj18aCbugGf
7760	payment	1726	1726	1874	1	1	1894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQPgtk8vzJbYaCMoiascsCQAdMqNUpGH5VCcVBJ8ogeAKREAp
7766	delegation	724	724	1956	1	1	1	\N	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDjfBvKRQtUeAhkXuQ6rRDpbiDZr9Gz6YqBCePPVF6nmh4W5J
7767	payment	1726	1726	1874	1	1	1897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhMxYumzZkGaFovLYcWxEx7hbCFD6LfReWvNFg5mU63oQFDJ9
7768	payment	1397	1397	1678	1	1	4927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPrbmdxGJTeH4AHgm7QLHc7wxV6GtX2LgZAQ5rckpeXTo3Sp4
7775	payment	1726	1726	1874	1	1	1901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsPhcUNgRE7NaFygZbJ9phPaD7RUkUFXZQ6bNcs5qLFTspZq7
7776	payment	1726	1726	1874	1	1	1902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yV6TLYmm6no6T6drfgbcyCqSTgQt8PmGYhY2p76z7SxB8MCc
7777	payment	1397	1397	1678	1	1	4931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRrU8LHDTiuhYthGtA9wkgJXtCAFZbNUEZTgZfVGK2g17p37M
7778	payment	1397	1397	1678	1	1	4932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcUQPS3wdha2452Hck437Ua8DqoYrbr7LXnv7WFGTsUTjsWLU
7784	payment	1397	1397	1678	1	1	4935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fezK2p8XYYvkMFRMXkKYXcKXF1woueuXfRmgJqaM7MTYhmFi
7785	payment	1726	1726	1874	1	1	1905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEwL8uB6MUV63nfWNkVtZEQFsjNhSnBvm1P68a4vcKet5X2Uj
7786	payment	1726	1726	1874	1	1	1906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhrssvv3DkvnMu4qQb4ctjZ9NdGFKAfVVQsVg8JNtRS6aWUvS
7787	payment	1397	1397	1678	1	1	4936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEpDAacuxXMp48rsjvd6P7KZphZu6gHWaZt3Mcga8fSF2rVv1
7798	payment	1397	1397	1678	1	1	4942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWjA2Fkfz2XJwXyWXkQuHKWJMsyW2f2CuygER25ikoJDKAmYG
7799	payment	1397	1397	1678	1	1	4943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT11FCGVGTJysCVNAWQPHLZdyNCqZUoraLH8PFpC3nXn34WtUa
7800	payment	1726	1726	1874	1	1	1912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtHvpaJ6hHLeJFRcr6jGRqWagNj8EPRazMgKHV6Y2QgjwU9tb
7801	payment	1726	1726	1874	1	1	1913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NVw5ejTB7sSp3MyTfcn6tg6pk7wgpEYJQbUWUo4T84eKNyhn
7802	payment	1941	1941	1957	1	1	2	1010000000	5000000	\N	E4YVa9F9Z3Lra867TW9e5uSkEVbZedrh4Ty4TCFFXMKC73s8ZJEXP	CkpYmVztbF5eBuYrRua8M3epkhSk9UC38TsSsW2nRHPYrmM73awZh
7803	payment	1397	1397	1678	1	1	4944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXh6xpWgahqYyFq6cQSMktuszuxQVVBkxmABDUanmbTdfwh1gq
7804	payment	1726	1726	1874	1	1	1914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gaPUXhLo78FYaz4EraA1E78qZHTw3yFAM9J2uSgrhDkJfL4S
7805	payment	1397	1397	1678	1	1	4945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAU6jhdu6RhepV7vkUc4ATeb4JQc872wboG7zD3cZEE439eVi8
7806	payment	1397	1397	1678	1	1	4946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgv8Wu13GwnUSbcNvV2ZyHKm5fWgJ6CtWyfvePrs3C1f7P6H8S
7807	payment	1397	1397	1678	1	1	4947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMGhYMwcyWuajWFGS4d2EcngVUMB1GazxMW7ZJT82JiT6JWW6
7701	payment	1726	1726	1874	1	1	1866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDV3LAkKXZvxAuUBRwYo6dXAbrNg6QUjmZzHAqZAKbm2M63GQ
7702	payment	1397	1397	1678	1	1	4898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvNduKfU8ahxxE8wHNkcz8AxvANo2QABWxkTesERMFA4vbi4x
7717	payment	1397	1397	1678	1	1	4905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9smRrtG1KoJxRwh5PQjGaM44yeu5WjYmjSX5qrbvfmhciQsN
7718	payment	1726	1726	1874	1	1	1873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu12g9HNsv9sVF4MfRh1EbXWgrBhG5cwTEPvWq168D5jDiGPWs
7719	payment	1397	1397	1678	1	1	4906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxQKBZ4toMzXj7VicPvJAA8qiW2D9vCtmwULqZPpRZG54pySb
7720	payment	1726	1726	1874	1	1	1874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxa8AYpCv36BPQsPoMqXD8DkReH6pDNu7temRY6GLQjKhJ6eP
7725	payment	1397	1397	1678	1	1	4909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bTgBMvdq9KhmZ2xceCgRNATCkv3voR92CsZ2nKwbaur4KBMG
7726	payment	1726	1726	1874	1	1	1877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtCTUAXgzCveUCqZXFPWzKuoMqxk6nUnQBMeSuKkTWrngtnad
7734	payment	1726	1726	1874	1	1	1881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPQg3z3hdusAbeAMrUymhRE4sLDw3mDtBySBim2BGrPXYXH2Z
7735	payment	1397	1397	1678	1	1	4913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmytSMQpUstBdGpJ1BSWbokRnPmuv2Qds21vWwhdg2gP1USeVj
7742	payment	1397	1397	1678	1	1	4917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h2DDt7wDNhAXtqdDtPmbvrGCVzANCZ4jGss7YLCMkVk2BPPp
7743	payment	1726	1726	1874	1	1	1885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqewh3jh3VXCQpnroYRwnDLzDNwK8SUJpKPeQJ47z4dWD77p2
7754	payment	1397	1397	1678	1	1	4922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5FnE2k2SLP7tfwVACQPGDWsdGejuVxKdZzgXNmZyhWanTzqH
7755	payment	1726	1726	1874	1	1	1892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15PJ5e7q2d4War54ReVWauy3y1mY53oTdn9CjK4D2UQg5yZkM
7761	payment	1868	1868	498	1	1	3	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRcmq2m7ukNwn8JS4sWWBKgCWF5HwHRpBqg3V7CaV6KyJDtR1
7762	payment	1397	1397	1678	1	1	4925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6n7BMRUPnkBUYYsUJ9V8kpvLpnMWnr7kqHgttvGtkpFztLwgP
7763	payment	1726	1726	1874	1	1	1895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmXyc25aagxaascxR53mFwLbq2eUtD8QDrHcaPZjnw79uqf6t
7769	payment	1726	1726	1874	1	1	1898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRydchFr4DbfKURLWLqQ1yMRxN4KMZAe1E3xEvQToSjrYVtEDL
7770	payment	1397	1397	1678	1	1	4928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiLg5KuAtUqdnwhjHHuGDgXDMZkAobhGzsUXvbTpvR8p9Q2RZ
7792	payment	1397	1397	1678	1	1	4939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFsPZkB5v5jLNLFNYN8yoV9LPv6dWJjLLHtnhN92djDXqAdv6
7793	payment	1726	1726	1874	1	1	1909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAshKxzF9knWGPmhyHdHTLJ67ecXC1Pr9MM4yGf2ywuqiAnXc
7811	payment	1397	1397	1678	1	1	4948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYs94redruFUc9r2zJ1iBTnvhMiQ7hojMph8V3EoWKDytrxTsn
7812	payment	1726	1726	1874	1	1	1918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtX9nPtQZnGH948YMhbQRiTFt9jCU2iRH7G8V1WJLMpbFTy463
7819	payment	1726	1726	1874	1	1	1922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwNzg2fxCLGzx6m46o17ZTVJo8vTw1dzC2RCv7sphtyUcKiB6
7820	payment	1397	1397	1678	1	1	4952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnVFoXLege5368WYm1Jq4apr26HyXvvMcPf4QUsj7AFMV8c8f
7837	payment	1397	1397	1678	1	1	4960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7uQpRuDJ9v6kEX4Nbf1nHZVcNmLKAh1UB7r3eC5yugoRdKLq
7838	payment	1726	1726	1874	1	1	1930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM74cDApSZvCKT176GvsRYZzBzv2S4iD2f4WfgZg85PfgmiSu
7839	payment	1726	1726	1874	1	1	1931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyhDi7WpJjuz7tWJ4xhmmKMCUmfCerdwBTGJYDH81KB3Zz3nZ
7840	payment	1726	1726	1874	1	1	1932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZZJYG5iJoGRBVnHqUZatybGTXLZhJABxuAKEvJgNHUu1T67P
7841	payment	1397	1397	1678	1	1	4961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJwAmi9aqA85PLzuZjsG7fG4FT1M4xrzwSFQsKwoVDMnFZQ8s
7842	payment	1397	1397	1678	1	1	4962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtgXhowRjjUoBACdpohuQjzg7MECr1JMGGdGncmbr5caXazuu
7847	payment	1397	1397	1678	1	1	4965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYzNBmGp7FTQ1BCKHiXfNyukL6LVPkP2FB5f85YYwqgayvg6K
7848	payment	1726	1726	1874	1	1	1935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8niggptQZPmGKPNFLjZEeAA3WW83cbUKejZ3i19zRbJahizWF
7849	payment	1726	1726	1874	1	1	1936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyDbD2mbexreL7SNCXCVNg9PBe2fkacHZs8d9ioDDdffS7DFc
7850	payment	1397	1397	1678	1	1	4966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAaogDCjpwQLhioWRXpT6gqdsWL3pd4KCRnoV4F3Eabp45Bxy
7853	payment	1726	1726	1874	1	1	1938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRxzkTD7JKE9H2xAFpa16gexuDCAwnCVVY3fk8WJ4LYuFxqBp
7854	payment	1726	1726	1874	1	1	1939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdynqkWThAgKPp2hvW61t92ieXH8GhrkH8mu91a9118YbPgRNi
7855	payment	1397	1397	1678	1	1	4968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp4fuvpgSgTu9CA8KLM7FV73B6txC3b1S7EUp8ZRpndkqTDgG
7796	payment	1726	1726	1874	1	1	1911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTTNZ8ywuKudjFzF64KPmD7tEpFrXNTWm6DQfJc1QvwtiUFN3
7797	payment	1397	1397	1678	1	1	4941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNVwqexVJgHzX9xtuGzJU13gTiEyR36yVhXKUQqipEMJjiVW2
7821	payment	1397	1397	1678	1	1	4953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA3AMZsVP2QK9MYruGXfUC4YqTWPiKKTrFq3oUVYCBW3wg4xh
7822	payment	1726	1726	1874	1	1	1923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFSjch6n2yjRtVSSdY5Pk4maZ1oEQ4JBjFmVnX7GF4qRWES73
7830	payment	1726	1726	1874	1	1	1927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYv9Z31HDMPS8wBZzfrNuKzmMDdrWYd6hcVmomXBYotzKHgwbL
7831	payment	1397	1397	1678	1	1	4957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaZGUv2PSbBkkgbsbkVSCtdkXEggj8Gg9dgbKANHucnr61Fvp
7857	payment	1397	1397	1678	1	1	4970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyPQpq7DqaKBNgMhmavpcRCr1unyrj2rbuccvfXzEJFBGi8dw
7858	payment	1726	1726	1874	1	1	1940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ4eKs7LEU95NEUyMRHLdZAZe7vYmvPBCmYqDREmMPaai4Zvn
7865	payment	1397	1397	1678	1	1	4974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutcytfvotByyzewA84jVFt88ZSDPR55VtLMNAfeJsNSrHEGzk
7866	payment	1726	1726	1874	1	1	1944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMk3ERm2wbZGjAQpDeKYCySvTHxo4qzAEqnbWE7iQu5dEgV8t
7871	payment	1397	1397	1678	1	1	4977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMRq5XqKnQVWu3W7iLt3ZMA9KY7Qc1bHdpHb6SmPiycKMp9G5
7872	payment	1726	1726	1874	1	1	1947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPxfEWTn8bTA5FNAVzG6Gzdp5o6YyGEHy73S63uNk9nnzkE4Z
7873	payment	1397	1397	1678	1	1	4978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XfvzP3MwPhRFUuwBuMTSEkmK7K38tjQqRCc8KPn1eWAdijMp
7874	payment	1726	1726	1874	1	1	1948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7m1ruPDujQJLj5fw7H7b3Y6jWp8dwGDWss2GoSRC4YGALnaR
7875	delegation	667	667	44	1	1	0	\N	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93ysb1VxVBhkW3rsVAAHKBggucFKcvzzpE5R83M94KknRdUk5
7880	payment	1397	1397	1678	1	1	4981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMDLsEJkje2eqR72H2GCfa3ioUEHV1KTFcLUYVryb38CVKd7z
7881	payment	1397	1397	1678	1	1	4982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMRxnDjVUSHeHeZQWARKYbAmmjc6g4uYUp9hpiKvs37ggzAwG
7882	payment	1726	1726	1874	1	1	1951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxqYsNYk3bL8Zgfa82rfViUujJmtUCPFuX7E1Zmex1RsfbY4C
7883	payment	1726	1726	1874	1	1	1952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47Ar3fgkNkjhLcsfGjhFpLrFSBUUcYTjphgAbHVot3tMXFMD9
7897	payment	1397	1397	1678	1	1	4989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFnJ4S9sZhGwqE7uFnreVU85hK9fezz5jCSjyhkgXE9CYxMPU
7898	payment	1726	1726	1874	1	1	1959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9hmHHzba2p6hLQiX52RFk9KFJefB2ssnAVH5fdwiUM5ep6YL
7899	payment	1726	1726	1874	1	1	1960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjc46czhz1qXqoDM1aPzsBTj2aPdJMFta7PjiNa8E9PtmSNiit
7900	payment	1397	1397	1678	1	1	4990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DVJfEYvd5ttFHTmPjkvM3fsf5RVvWqAPQB2jTg5N7az37hRF
7905	payment	1726	1726	1874	1	1	1963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrf2mnmo2HbBnRebhLBnSo2qaJdS944aUBizkFwUBcNNJFQ66J
7906	payment	1726	1726	1874	1	1	1964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SwLHkRdzexCraVEXzUM5eGA8LfugiQY5WGWqGntnJ1Xtax6C
7907	payment	1397	1397	1678	1	1	4993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7MvLt7YTjLDAJ83i4QGCK6SwgCXy1sPj83sFfiwxyfXxkuEz
7908	payment	1397	1397	1678	1	1	4994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNZtbUKJRwF44e1tSmP6j7TMVEzm9NBXmuBjYRB3PLaePSzXh
7909	payment	687	687	1958	1	1	1	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoKu3yWFC2Q1PxdqXkPymdA4jtZKacioAaueP4NVqFD9twoSr
7914	payment	1397	1397	1678	1	1	4997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqhLwMLsFxUq9hyj3ygaoEvypuYbbuifJ6kXhNQyH47jJKKTK
7915	payment	112	112	1821	1	1	2	130000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimjC8byFb63AjUoSXEFw6K45se9Cq4DjJtg6JSn1aUVEtwKPX
7916	payment	1397	1397	1678	1	1	4998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTX8ECvGxmZrveUEA799eNzfbFfV2x6FccmTULmiYcvnn5emz
7917	payment	1397	1397	1678	1	1	4999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYfRnQUH2wqS8gymbgurYBsEKCiwEdMCE4PG1q3ZP3uiEXUiB
7918	payment	1397	1397	1678	1	1	5000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK9szQQjDpZ7pMJBqfcFfGZ8bnesUwoR715Gu3Y22XBoErqBi
7919	payment	1397	1397	1678	1	1	5001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyxvwv4AmJu7v2N9RhCsAJ9FUGea1dCmdkqHgtdQbxK1jQY46
7920	payment	1726	1726	1874	1	1	1967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZ6NSQ68KqWNBxwvFDSvWcbD4v7mtCjtt94YBw1VKTvM5Hs4u
7921	payment	1726	1726	1874	1	1	1968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9tDqM1rQeVnvvxAf9RPj3zKNuhtyZ6uCMRfcXCHHpYqWuN8H
7922	payment	1726	1726	1874	1	1	1969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPyCRn36BfmDzB7uEzoiLd6RoeFvi2rr7kBKapvgT65HjiQD8
7923	payment	1726	1726	1959	1	1	1970	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkY9dLtmfZQPjkLMBLX4VJbJbWuR6veC97Rigt7uPcsHzVAaLS
7808	payment	1726	1726	1874	1	1	1915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKzypRgQULPSrgH3wppeqdREVckFyAidG1yePz8ThcaJk8rbL
7809	payment	1726	1726	1874	1	1	1916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAK62ZXxsajY7ipCZJoUtw16RYS6M1JHcYMPjDUeXNuhitAtQ
7810	payment	1726	1726	1874	1	1	1917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS4HcrqHuZjMDP2dFAhW9yCozGZ9FdMX7X6azasHLGVYHKyRyr
7817	payment	1726	1726	1874	1	1	1921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUa1FJ7aWCrmBFFakLFXEoBWfukWZZfCv13yJosDqWQXvoXoB
7818	payment	1397	1397	1678	1	1	4951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjpG78nnN4JU2QrAntQ4cS77R6qN9yAjxPEimWxUH5RZ47STD
7823	payment	1397	1397	1678	1	1	4954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtGfStsy7FJDah82t1ooyFG7X1PQWG6nZhxsG2jitoMdGT3zc
7824	payment	1726	1726	1874	1	1	1924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuh5FpvUh3ZEFvHUsMQodvFp14KgWNgPEXEjsmofsxQFw4qhod
7825	payment	1726	1726	1874	1	1	1925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVhfHqWwVCPxMJurctCf1bEWjcjBHZxRHu27RcHJYPyxkCmBj
7826	payment	1397	1397	1678	1	1	4955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6r6qBqkFJCYetBc6z7Q5euzVeA6kXVMJxnsAkY85RoBbjtuEN
7827	payment	1560	1560	1560	1	1	0	0	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ4cHFpsfkdRMro1kRzncHdJADpjBQc264hiZc31CAq4tZNFsuR
7828	payment	1726	1726	1874	1	1	1926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAB6bsdK6w8ShbhJqKgSqNSYikTd2t2JZRmnKgQE3xqF7YKcF
7829	payment	1397	1397	1678	1	1	4956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3QRF1ZTck6LYghBfciL3Zz3bNFk9L8AYpte9VpwZLHpfqdrG
7843	payment	1726	1726	1874	1	1	1933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SHusHR2YhFFW66RFJfWu7zXEy8DK39WxvcwNqcbsQpC1RyFv
7844	payment	1726	1726	1874	1	1	1934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPm9vi9c6Q8wzNpLfCX7oLyebq5uRvcw55TvZn1tBxRahyH6x
7845	payment	1397	1397	1678	1	1	4963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77HJjBgargxmYsDK8JWEK6sHGqGQA22P3PkqaFaj2P6PJhfhB
7846	payment	1397	1397	1678	1	1	4964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEHcKqb4SVvaJkSsp5QUVdKkeMwfrAVPtoUiGvdSB3EjVgbP6
7851	payment	1397	1397	1678	1	1	4967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9oSuPbBXaFxdRZgrxJddGarYff1SHrgqUH6cxa6Jq25CWLcv
7852	payment	1726	1726	1874	1	1	1937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpva8merwsZeGGDUk7oT5TeEt4kK2kbe5wxX52Rppqe5Q5vvpL
7859	payment	1726	1726	1874	1	1	1941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXjtN9qaWQZiZRNQ1XmG4AnwLX3SVUr1YC8PrhPnb8PKiH1NG
7860	payment	1726	1726	1874	1	1	1942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcc5srDZev2LDWQ5zvudwnEAXVo3BSmnJMe5Y9GpNv7GNXtBa
7861	payment	1397	1397	1678	1	1	4971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4G6zEXbSKwp9P8XdybxAD8WSqhSnUTm8DGAvr1FDsCdVEEnx
7862	payment	1397	1397	1678	1	1	4972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYStZqBb9vKX35Y1c3rSCA7DCXn1WLfF4dzgyosC66FpddzasK
7876	payment	1726	1726	1874	1	1	1949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNUp2qJMWp9z4rcFrPa1NDX2KE7ipjcv85oZGCe9pD36UXUzU
7877	payment	1397	1397	1678	1	1	4979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJkYR7hAifL8MHdRAVErnqejaiudjfwCont9LzUMjp5FB67P4
7903	payment	1397	1397	1678	1	1	4992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtQ8Fsy6o5vvvqaCtmBLCJryj4rjJMnJi1skQoHLehnGQoJeD
7904	payment	1726	1726	1874	1	1	1962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw3kVxQKttuZwKhBkuRT1S5JJG5De2zNtUXjjKgGmqQ8pnJnw
7929	payment	1726	1726	1874	1	1	1974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBzeG5oXeqSJpjddfYQB56TekF1oDJaF1SPmCPnHVsLKDJfZ8
7930	payment	1397	1397	1678	1	1	5003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f5kopcEk5ZzUQrF4RtiexpHsMC7YPeADhL6zxsxHTcczvbkz
7947	payment	1397	1397	1678	1	1	5011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGPJKHp9JeVV72yVAzFjaR29CKWYGjeTTvzbzLTssPixqV1Yh
7948	payment	1726	1726	1874	1	1	1983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqTBYuu4WQpBo5QQUHmcu2jezVbhFs9CPh36tyMyGxLvrdH59
7967	payment	1726	1726	1874	1	1	1992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdYUF114tggx41pXwo444hFcmKebQF68ExmV2GYvySWEYKz9i
7968	payment	1397	1397	1678	1	1	5020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWBwys4MBcNZVYGDJCnMRwdybvd9tvY3fQGYZngvFxWDBR7BR
7976	payment	1726	1726	1874	1	1	1996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn9HTnrDyJUSpSoUr6NFR1oZnFu86FEdqDt4MvqNVRFT9GgoT
7977	payment	1397	1397	1678	1	1	5024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvXo8CEnoNFvCb244qKRbsFiLhS2fuApb3f1jYZ5twQzp1teS
8000	payment	1516	1516	1756	1	1	6	1105766709	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEEmTDEbugr1pXNSwLWJwscKpPSB86PJeGzcxkxuVAR53McAL
8001	payment	1397	1397	1678	1	1	5033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2z57AWvyWBSQ5cc9Ywvmgw3JwfNGSf9omnUhYgxRfqPavmEyi
8002	payment	1397	1397	1678	1	1	5034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUMLGRiQuu8ekyJz9cySEfe5EamySDWT9q9QUsWSVX5ZrxmYF
8003	payment	1397	1397	1678	1	1	5035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGcxKC8dDAMAcRRxWunyPdq63avP5DMGCti3vRiW7hPA4Bh9W
7856	payment	1397	1397	1678	1	1	4969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsziToGx8nBfzMyHHoLfcUa7x619EoECofqkATbuQJ4vNDb7Ja
7863	payment	1397	1397	1678	1	1	4973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5gYZ3bzx5ux8NTVyotsRqdxn2iE8np9MGjPwDfVE3NBCJMTX
7864	payment	1726	1726	1874	1	1	1943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQC6Cct1PMtA7PYdLD9YRCUUBRKvNZCQdffhNxJjTBkjEb5ka
7888	payment	1726	1726	1874	1	1	1955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPELzz6mRJU52G8bdr7TAfzzM6LTieLMtWmva3jBukWYAMo7DK
7889	payment	1397	1397	1678	1	1	4985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2pDrLiPo9Cn2NSokzHJ3VCD8pZ6DvWmPFxqchtAkTVViLLjS
7890	payment	1397	1397	1678	1	1	4986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYw81fzRLADZKugyuqkhmugdgi4Yaj4jS5JWHZsMCmJ4ijmsKh
7891	payment	1903	1903	1932	1	1	0	196990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwZK84FHGG9dAP4txSWJap9dVToAtrQDNXLkY4PUdqYBK3c6n
7892	payment	1726	1726	1874	1	1	1956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbUNTCiPQ5GiJp8eU5E5d3ELMb6gvrFebS7UpDadK6SKkP9nQ
7927	payment	1726	1726	1874	1	1	1973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5V2RBEBjPvBsuDX3vsgnti49o7sAZK77o4EKG7xFbUTWBZMg
7928	payment	1397	1397	1678	1	1	5002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mco9jiKMdvKrwLmJMS4JEGKwcSaeuvjgu241FfwbELCpDVgX
7931	payment	1397	1397	1678	1	1	5004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPAZC5SLuyLbufat7hnnUguRzrubM4iAQBrja9t4dSJYV48iv
7932	payment	1726	1726	1874	1	1	1975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhbV4F36QPzMaf22AhXcxWeo1jL5y5g1e6pYL47ea2bdYrHL9
7933	payment	1726	1726	1874	1	1	1976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BZkX35DJGoZ3Gd2maVhsSLZ3vgFAVZuzGVWBFvxiAHnBf8zd
7934	payment	1397	1397	1678	1	1	5005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyEPPVgp8VyrKNsVKXjQQm3kW8EXVQK5go1DHb7VSFdKzx3K4
7935	delegation	409	409	1515	1	1	0	\N	1000000	\N	E4YvqnwQaecwNZwrQjHewwWhemqzAUZcEyr37x5BvhUPQd7n3LQL3	CkpZLrz6UQv32GGWWkSpZFCjcoTnL7bD4SJa9VSW7xdSd4W5mkKps
7949	payment	193	193	1961	1	1	0	282000000000	10000000	\N	E4Yb1ur9QwTLGanLZkXxK1aiqeYs8r1akvjGTddkBg7AecBLdfyJi	CkpZ4sha2R9DUoTM4xsReUaDE41duAhCm5izT4u3KUDtBrfN1Dagx
7950	payment	1397	1397	1678	1	1	5012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpy86vwVgZMBgUVkJpuJHc9CgedW3yGEqsSNjQo12JXKpBzYW
7951	payment	1397	1397	1678	1	1	5013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRTbwRYayX7gUjxuKV7q82DhMAFBJ7GXXd7vAq7oJLjtCFZNm
7952	payment	1726	1726	1874	1	1	1984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoSYKSh5dDdbRUGtEZkTrRNzJnRdqzzUSuYYJngoAVx29vMpr
7953	payment	1726	1726	1874	1	1	1985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgstaRtmDydrMpcjQmdeJV2TbPj1hK38S7FEXoCzrqim99twJ
8012	delegation	772	772	55	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUit7KmovWxwRxDheMaD3V5TZRtJEZeX9f8qB9HSwi3ynFGhL
8013	payment	1397	1397	1678	1	1	5037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ZjqR8pc82FVPiyeAB2BEGMWR2BF84Ts36X9fyc5D3QWxyt2
8014	payment	1726	1726	1874	1	1	2009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13A7ieNqbFEamLS1R2u79eD3ZjStFYwVjyKt7gVDUhf7Xtt2q
8021	payment	1726	1726	1874	1	1	2013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yZr4nW3hpzqQBmUk76pQadKAn1v8iHri98TxYV5cNn2D2qvi
8022	payment	1397	1397	1678	1	1	5041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHftUkQ5zuijcVh6XU4JnoKzQqp2Z9jeiQoKRqFUpmjuxXy9K
8023	payment	1726	1726	1874	1	1	2014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqttyV9cNdvzwGECwNoyZT4Htz9WzouyuXw1pgmjNDoZiNJx8
8024	payment	1397	1397	1678	1	1	5042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPFMYE8wPxEKYBJAGUD8FCUzBJRxBp18QZwe7oSEtvZLP5CUR
8053	payment	1397	1397	1678	1	1	5057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxnyEz8UDUeg9cYkfErrEXrJZS8CwhxWf1dHLNLy8dyLgVe9r
8054	payment	1726	1726	1874	1	1	2029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuLZJNtg2989mr4Snhchdj1Rf4bF5jaBqwQHCakTiWfaTFjfJ
8067	payment	1726	1726	1965	1	1	2036	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZVaQwkKvxb6jauqVVRqAS7znK3trGFsrpD5VCEkG3D1er2BMmX
8068	payment	1397	1397	1678	1	1	5064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK83ZTMRNWq9LP4ShbX6hGYCG6no2ZK9af8PbUU96iUnS4vTg
8069	payment	1397	1397	1678	1	1	5065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENQrNWEV9zViDdYPU8F8Qojae3ziN8YVU83p7tVyHV643oLWe
8070	payment	1726	1726	1874	1	1	2037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFH9mEYM6iik4ozgUCjM9sqqffhLUYZ6PeZWnrwG4zAUAprtpo
8071	payment	1726	1726	1874	1	1	2038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBXkg6Cj15yxbT3LpLkYPF5Qhk3jX7xjovdRgdL2uC5Bh66Xc
8079	payment	1726	1726	1874	1	1	2043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKCFH2BvQt7JSazV1oaiq1QTCRtv5TSR5SQvvTZAkSHUBwt6S
8080	payment	1397	1397	1678	1	1	5069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5SqKV5NTavDqeJdeAhdVt8UTpFrydjcadgcozrYfhzVhjNku
8081	payment	1397	1397	1678	1	1	5070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFBCx44CaQXwmdcBZnNhhehKMiLgjvD52VNd4EhTscXkDxfDEQ
8082	payment	1726	1726	1874	1	1	2044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBvjz712Bb8wy1DfBuXiiRkGKNj6jYtdGY2HHPrugdxC9dKSQ
7884	payment	1397	1397	1678	1	1	4983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46Q3gDd6KUcRVSpQY249pMXiUj8WaPu2PaxyTU6EpAH9XPwiX
7885	payment	1726	1726	1874	1	1	1953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMzBbYfKH722Nux1zBsNXUHBH9YAKrFAfW7gfDwVekmgsdw9D
7886	payment	1726	1726	1874	1	1	1954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtM7aTtg82VyzM8wtCgCgE6CLeEiaxgjbv5jJH6ukLqNVLqQi
7887	payment	1397	1397	1678	1	1	4984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYtzbHwijPBh6H9fPGaEvT64z5gz2JKUdt5dF3nhjeFgGQw6f
7893	payment	1397	1397	1678	1	1	4987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqLz9vSeMz3NdMcEaKmLgxGBTHPfGrQUPmMv3cppUd8beuXwu
7894	payment	1397	1397	1678	1	1	4988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRb5gWnEyDGds2eZfWQqgZgpchaNqgUycWGeWuJefs27nbZbSN
7895	payment	1726	1726	1874	1	1	1957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZLyPzVSK31ELkEtWSqbMFcp8LJ3DnyVSc3NiD33JkqSQ6Rmk
7896	payment	1726	1726	1874	1	1	1958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoZYQnSsNrAdJ5JbBmEc45NnUu4H2u8rjUSTMCPteWcz5VpWh
7901	payment	1397	1397	1678	1	1	4991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvKuoMqe5Dh4N1Jo8yWyYpUzSH1REgyNy5Rxi6EqAvX1WGnMN
7902	payment	1726	1726	1874	1	1	1961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJtap387ZLysyzUhGaHiThBALHcKjs8ZnoPYXwXS8UxmFfYWS
7910	payment	1726	1726	1874	1	1	1965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKAy1PztWmBntKAJMqXfCnE8WvptmzccXRUTkQcJjL5GqoH3K
7911	payment	1726	1726	1874	1	1	1966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzihPZ6CRwj3VZXFdkjRehZRJMssYgpp3jTisyjWFf6UvEj9r
7912	payment	1397	1397	1678	1	1	4995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZma2CLHJ1XCkGp4Nwd4aDaKptfdxwr83bdVhB3nC5fD4ay4Kpr
7913	payment	1397	1397	1678	1	1	4996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXscxnKVHC33DXBFRELR7A4ifHXziXxCG5sdkMNEykuZTfsi4p
7938	payment	1726	1726	1874	1	1	1978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivWGXVse1Fnog5VnRg2KLMfDf7TjeYGAu2kYSQbC8mYpkUbn2
7939	payment	1397	1397	1678	1	1	5007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyuV5pTwhucfkCKHq8k1qFcUy3sCaAssQL1BTzgnRMgHapwvy
7956	payment	1756	1756	1516	1	1	2	650000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFq2QzKTsC21nf7NhoYoxUT6zkXjatAAmjmGnrny9RRUuNPmJ
7957	payment	1726	1726	1874	1	1	1987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUhjTsvh3ZSj8wuDycs3gW5MT7stA6iDfbkEeKniM1oVpoecb
7958	payment	1726	1726	1874	1	1	1988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAtpFcPEntos3DMHRnvDBtNF5foiH3fCEZba1pquvQEZghGZe
7959	payment	1397	1397	1678	1	1	5015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcyyzMyXxJRuTXvYzyhXLRf6X82wyRztSpqXmVHs14y8DzhVq
7960	payment	1726	1726	1874	1	1	1989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAUz3F5HbwbnL1H2YWBXYCRaLGPXVxy8bXMRW7Ce7STD4uNwj
7961	payment	1726	1726	1874	1	1	1990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCJQWCkUvayUB6BfrDsX2Ym9FFR8Nxh2XsAj64zakF6PQgs1F
7962	payment	1726	1726	1874	1	1	1991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGcmmVGaZxFfA5LbUh6jkLdwftHTJLjSiXSjuGiNwWdQenwbH
7963	payment	1397	1397	1678	1	1	5016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHboBZorCPhtqCChENGEtHbqLv6ooePS2L2c1NYQU8KZtD58j4
7964	payment	1397	1397	1678	1	1	5017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYok3ujrqPivL8NoXsbPEZPFN7mJwLDUAkJ1axnpArcuqeyHN6k
7965	payment	1397	1397	1678	1	1	5018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbeemu7kuFg3HxEGoFfxXjFn5qfVRH2oQVCcA1YLJDDUYJwHa
7966	payment	1397	1397	1678	1	1	5019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGsu5Svu3our76RxUHHadYuZHFjWANxkVCApj2NTK4jH3Hhcp
7974	payment	1397	1397	1678	1	1	5023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4apHCXSxDpA3e5aWB3BtmEFZ13sDyKUzaqkDWhCkFAs6ZxR3
7975	payment	1726	1726	1874	1	1	1995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD7HbGWUFpJwSeL58un7oLpbupueq2f2bTKBVTSMxJgMBdvhW
7980	payment	1516	1516	928	1	1	2	2378770079092	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKSZTXJHaWLK9gmFj9ixT3GXi6vUybkhEvFHQa6vYmNd3ULwf
7981	payment	1397	1397	1678	1	1	5026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rPXkdK2bURTYrJ6xei8aftcAywXk8FtFXFrwewQAJZhhbEEG
7982	payment	1397	1397	1678	1	1	5027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDkCCqke2yyDJ7SgniEMnYdGUzyWF1TkQn6u1hKr6LmxPhHszZ
7983	payment	1516	1516	1048	1	1	3	4262735600448	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AGhTFCpyKeRtfYXCTVardTQe2pT2TbHnJfZfuAYJTQFycGHf
7984	payment	1516	1516	1168	1	1	4	2876152650622	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmkBW9eeTiDaGuu8kojobRP3G9D5FeF5cr2JowLHDfF7xQivp
7985	payment	1726	1726	1874	1	1	1998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sY1LdWDWohnn924QaaizMTiG5BxfCLw4c3UZPuNPctLAqNGP
7986	payment	1726	1726	1874	1	1	1999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qPWjdMbi9HUbCRwgzkywfqJ3Pz73QCr4iH1xmdKsWvo9K7Ea
7987	payment	1397	1397	1678	1	1	5028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf5L9AQTVoj1vQ9RnEyJBLSojRX3ofK3ZDv7XJn8TaS3gcpKf
7988	payment	1726	1726	1874	1	1	2000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6vmQreZHaKFiRDf24CvsfgpmKjAXptLAwv47eh77AgUQtK2n
7924	payment	1726	1726	1874	1	1	1971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRM7aeqnxvHeDdnsLT8aEnsGQoPxheTTLWrhFQX5iAPcooxeZ
7925	payment	1726	1726	1874	1	1	1972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVNKRumEGiVuwrKkqwsfngBtsGqwsRfdU1H1q5dpM5MngkzEG
7926	payment	687	687	1958	1	1	2	699998000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTALDUnaVmcFXj7hKhVUSPCXyARc2QrSvrwWhLysHK41ZEpuF8
7936	payment	1397	1397	1678	1	1	5006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgaNUQ6Vj6chqvuurjVi8xDnVUXewBeDQphDzyqJkuqZ7THen
7937	payment	1726	1726	1874	1	1	1977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciXWqjD2sW2fKQF6wtNTbQj8Hp5YPatDWKYbZQ7rWF7Sgeab3
7940	payment	1397	1397	1678	1	1	5008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWAJc6g7tr7UY7SVUUQmiiMtip3xwU9dmwVKkqaHGpni6TbFa
7941	payment	1397	1397	1678	1	1	5009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rJyXGhWZZr8aLBEJxi9UoQBe1HTvUx4GxqDVLm1RUBcsDHzv
7942	payment	1726	1726	1874	1	1	1979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdHUsHVrdEPWCa6jx9JeK3NqVRJ4WxFH4ie7dc5Y8UhSaCztz
7943	payment	1726	1726	1874	1	1	1980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAp2bkg4N14ce1eGRRrLC2oD8SrtBM5dDV33WGRzxDcELLbsH
7944	payment	1726	1726	1960	1	1	1981	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFeWFdHv4Ffi5PLTREAWjRQRDRQxJ96w2VQjQF9XqbBN8fAmbH
7945	payment	1726	1726	1874	1	1	1982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ589GCUo3PuQNsxk75WoxKXXwE3v9krp1QKnXqG4SJnbkkJztK
7946	payment	1397	1397	1678	1	1	5010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHe5NtjjEHNVL55BFemnjESrXK32oVFu5nyLK9cZH56jmyvoB
7954	payment	1397	1397	1678	1	1	5014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVocAdvv5bspf8J6EmtPUGv8rDN9r9vhGZGDfn2JTfnsEcLnuy
7955	payment	1726	1726	1874	1	1	1986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGarjbCPt85ajFTKGgsKfCH5e84927NzXDj4RLV4HV6QjF8zHC
7969	delegation	1885	1885	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33qV8ed2caWSHs9pz7mQqzUoudxBGYKZQ2Q7uzUp1DUrK6dwT
7970	payment	1726	1726	1874	1	1	1993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxTH38S9tEoWDYqGbpJbkf9QswmdixC95q1n3n5ALFk6RMJvs
7971	payment	1726	1726	1874	1	1	1994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5o4YmidkTJzWbTyw3jH4cG3mY2pYCb8d4YVsW9SZ6xaZ94UcR
7972	payment	1397	1397	1678	1	1	5021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa96tFbnUG1fAc7zPyP2SUc5HbfKGHHxJF7o5N1PXw8Vvtt8Eo
7973	payment	1397	1397	1678	1	1	5022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbf96ZBKdAQhvE3rfEEGEiPckd1gCp4uqxc1K4HEGcTQrowSv
7978	payment	1726	1726	1874	1	1	1997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDCNhB46n2LZU4SbNCaKgVWMPwPrwiAD4yGkTb8psSxfpHV9P
7979	payment	1397	1397	1678	1	1	5025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iwrF3PLzbjtNSARk1QMV7N6wiybAZKbefREmWkfrrhFf2atf
7989	payment	1397	1397	1678	1	1	5029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q88MNnGX2JCqrFnBNTEk7VKrhCcm5sudHATXhX1VWQWkhBUh
7990	payment	261	261	1962	1	1	0	282000000000	10000000	\N	E4YXdwR8uKtz8oMtzcsWzvE1c6w1U2eSoPG1AeLp6JgRTCQHcpJQ1	CkpZtyAdEZTxgJnK3tNLVa6gtqFfnH2S7mPcwyyTdPRbmCr2aiHzf
7991	payment	1726	1726	1874	1	1	2001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFHoKJW4wxcbhXz4ncGLcTAiaf9GeuMDjwqbRj8rxjeUp3vb6
7992	payment	1397	1397	1678	1	1	5030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVGkNPYrtbjdhqJ7iRJVJr1CnxD1J5buJ3UVLzkpmnVronTYc
7993	payment	1540	1540	1963	1	1	2	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtS5yS2727mxMs56TJPGcobWiewaZbYLMnu3s9u8dAV4izGmwD
8015	payment	1397	1397	1678	1	1	5038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMiETe8f255U9MwhxPxPKdVGFFAJ14bBFZ1aepxAQERfNNVaV
8016	payment	1726	1726	1874	1	1	2010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ695rc9jFL1dwb54Uca9moL8dVD5tTgAFbKYyqhCxJAR3WzXHE
8027	payment	1397	1397	1678	1	1	5044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVjwinsgai5N3vBMn67psLMBPPqzyw2GcSnfjByKDy8Fmnj3F
8028	payment	1397	1397	1678	1	1	5045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1gQwr3r8MUVFcgQV6argw4b8AoTFyBfFsva5rKo5RXp9y6ip
8029	payment	1726	1726	1874	1	1	2016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQXD6giNMqK2dnDPEei9wrvCgvdwbrsDJMREWgVfAJ5zk9qq9
8030	payment	1726	1726	1874	1	1	2017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ821GAEmnsNSCv6kMujwF9QhiYKGw2fSTr6n4DXugv7f3jQi2D
8039	payment	1397	1397	1678	1	1	5050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbianbbz6aoF7YxvxBmFeFxje96oEyvr5s6f7WpKrE8PsJfUi3
8040	payment	1726	1726	1874	1	1	2022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEEJeeLdrbFEjeNkHmVh3wWYm3YHDqPbmrnP1FNtkzqruSwzf
8045	payment	1397	1397	1678	1	1	5053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfrtcrtbhiRTytEJdDLaMmZFiFJLo3vzBN3dgjy3kXBgY8eJr
8046	payment	1726	1726	1874	1	1	2025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YzBBeLrppwNjFNFNz7epkkuDroVNjhhqeRFBqk1nPSAAFMJ7
8061	payment	1726	1726	1874	1	1	2033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQnpEMCu3tomG439boummv49vELdReMRfqW2dZoa9NuWtmKoT
8062	payment	1397	1397	1678	1	1	5061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxoSHB9DwWBFKNN4sso3foJpKfahuvanakxaRc9g3ZZyFCW3g
7994	payment	1516	1516	1294	1	1	5	8014655094229	30000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Q7Uxs2suowLfJDmu7vxX3R6T4wovwPdWoXawbAqgLuSD9GWY
7995	payment	1726	1726	1874	1	1	2002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxyRtGB7TKoNLgvcUaqMrrBqHtz5vapRPEAH4VSGfsJQXmSjx
7996	payment	1726	1726	1874	1	1	2003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABfX9FYJyKBxr39kALBtEjC4ZQRWFGp4jryt63cfPe8NNnTxk
7997	payment	1397	1397	1678	1	1	5031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfnVyS9vawRLHxFbH1pnaHd3As2bQVXHxPNA2pEY4cRGX7SrU
7998	payment	1397	1397	1678	1	1	5032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoW1qwrw5yDwLEPdmKxEZhgspwFmeyeM19fC8VxDEkeTzMQNL
7999	payment	55	55	772	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqk7UMXot8AkpGzkiFCp3XLG1faxS19f3YHBSYn5Qe3yv9CdiG
8010	payment	1726	1726	1874	1	1	2008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7SJinKsqLFt4WrH2eJzmfi9taXsXZyP4HfkAY1GKhe6abquh
8011	payment	1397	1397	1678	1	1	5036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqUTbHspa1BzjP1Rcrnsfb4n5WW9MrQyvxQTJJ1s9b2Acjbjh
8017	payment	1726	1726	1874	1	1	2011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3vnVpLvJK82no3XAyneZNo6f4PMapkisEK8GTtS4y8U6nHwm
8018	payment	1397	1397	1678	1	1	5039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdo8pFvBVv6GtApdWchEmVDaVa8ikMU83H7GkZwrTfifF5EhP
8019	payment	1397	1397	1678	1	1	5040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YrLdEuBnPWQi5hR7MqdT5Me629BU3QokjPi1tC9X6DFiNtL1
8020	payment	1726	1726	1874	1	1	2012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmLdVyxczA12fJ2RkakDHQN73yxqKTXJUFPugLdkwS5b8xdqF
8035	payment	1726	1726	1874	1	1	2020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXZ1P79H1K81P7T2p1YfmHXMBxgQpWgcBpr52rEMSjDurLcFp
8036	payment	1726	1726	1874	1	1	2021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFFo57uXLkN8YPBWwV8jxQKEVeHxxhrNPBjwN7x6jW1X9Mc5T
8037	payment	1397	1397	1678	1	1	5048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xFnQwqGsX8QosmcxME1E4riuTkM8R98t3UHMMWmfCYRpNUWf
8038	payment	1397	1397	1678	1	1	5049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxE2MimmmnqZzaCUGDzHH6hQWtenzoNGf8rSVMs5S6d8aEbTf3
8041	payment	1397	1397	1678	1	1	5051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1WaFMWdHQHTHgqHBNDKFkbynES6b5vbJqDBPLkQHnfFzE8Cy
8042	payment	1397	1397	1678	1	1	5052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RSDBRbtfEpnq4Ev1TuybQCwn8DUf97kkSRWuNRVSmcHw2aKn
8043	payment	1726	1726	1874	1	1	2023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuCLyRZozyDqrLax1LpQSVLtAthJYQBwn1jWDxyPYQ7XkLWjq
8044	payment	1726	1726	1874	1	1	2024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9FRCw91zpxwWB4eKUgojDe8ADJqgUuXNxwC21RWNaG4BzpSu
8047	payment	1726	1726	1874	1	1	2026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53stzJrwupBng6v1ua3DjLhSipDjdTWep14aqutrAx8mDqkw2
8048	payment	1726	1726	1874	1	1	2027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKhsgXGVAHKnkcAN2p3S58oiDr1uiqvzZfqCiEQ3ai6nWHKfy
8049	payment	1397	1397	1678	1	1	5054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7fP1KYTJTCDwfMs11giTYne7795vUxiyz4rW7rwDF7KMVGJM
8050	payment	1397	1397	1678	1	1	5055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5Qi2MYcDH5eGZsXMQ9soqNWa5aR9AzHedVMb5MMnCSeACYRv
8052	payment	1726	1726	1874	1	1	2028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKUajZaZLq4NcFMhr9WcfKUqGo4Tct8hgYqpAf8tgco2pSpKV
8055	payment	1397	1397	1678	1	1	5058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSEqfhHjN2YNAWsupD6D1K8gkCZQWR5E2JEPJkgAAREXqBbKv
8056	payment	1726	1726	1874	1	1	2030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnTfHLhdt7GrG8fXJbiEa7oRTTCqpqNWdEP3ykG6QJPNkTdUf
8065	payment	1397	1397	1678	1	1	5063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33j1DFs6MHbz8ydTVYtJSYKZDuxQqL3CaW4igMrTJmcnK42J3
8066	payment	1726	1726	1874	1	1	2035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8rDvgxSYbdMNhP4J8AqQHqn21aowZt1wbCwJqy7y2UF9CAW8
8072	payment	1397	1397	1678	1	1	5066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibDadMgf8ELXuBkknHqYrVF9PWJmu3DSVB8YnPBAj9NDB2uak
8073	payment	1726	1726	1874	1	1	2039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopsSBX7d7ry8M82P5aeXYPoWbyHyxCQbJV5VCWA5rmyRghttZ
8074	payment	1726	1726	1874	1	1	2040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqViG7b3HonS6DpFb87VTe5Yej2XPiL4m6KEctoThRgUiT7ESb
8075	payment	1397	1397	1678	1	1	5067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NcUfc4VME8JgD2tHg3pV5Cy4iL8HC9Q61i6VvoAZpA4Dq7wd
8076	payment	1397	1397	1678	1	1	5068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKdcNWtYxRiVyTxKvst8qGha9mq1onutj9pja9dbmKg1waPMX
8077	payment	1726	1726	1966	1	1	2041	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHt8Gwgt4xw5siKqMJJubSVX6szHirjtFM2DvRY6PPwsfyEGuq
8078	payment	1726	1726	1874	1	1	2042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecfG1R7s2CKUdmRDEAQ37a2N2Cw4sTFaQY4PpjXDHzd3XhRji
8083	payment	1726	1726	1874	1	1	2045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakj7jbjjrgkCiN4ySqx1qd8NmhvSKQLE2XeWbqAjnRhiZtoZC
8084	payment	1397	1397	1678	1	1	5071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHys5xq29byaVe2ahMPoE3p4KoxjBdjn5TyrJaYqaE3dNqvqDr
8004	payment	1726	1726	1874	1	1	2004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3A7GoELK3mi7c8o5cAr2FJJFFpiCDZWNqCbTVjKrLKjYH2gDc
8005	payment	1726	1726	1874	1	1	2005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimLDrEUypcbALu8csLAe16XAm5sGodxcAVueaAjXvcVdvKEjb
8006	payment	1726	1726	1874	1	1	2006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qV1iYRTm1QSPt2mhe5j4DoVehr9ryzUUa54y22aJKk8zVhxq
8007	payment	1726	1726	1964	1	1	2007	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQuk8FRuUHnFELCv2kQAr9dCcDrmEiDUAEfCFv9n3MS3ajzgun
8008	delegation	1963	1963	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWCXNhzqYr1zKcGYHTjkyFHRkgxiaCRi8S8eaZVqcCaXPBeey
8009	payment	1540	1540	1963	1	1	3	365306000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pnUjwYmz4mxEMPgBbxGDKMuYLcu699untfnttUSpxBMvbEMP
8025	payment	1397	1397	1678	1	1	5043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWzerqiB4FiZ51tZMariNna47EpNPptPdByCvsW5XuFTFBuPf
8026	payment	1726	1726	1874	1	1	2015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY6ZrjCrSGto5ZRJtkARXAfvmA64mb6Q17ECmLxVTjxuwfW24
8031	payment	1397	1397	1678	1	1	5046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZR5HF3RF9ZSdf1uvoWLQg5ZfmvtXVKdCgJRL1C8kircTQGcSb
8032	payment	1726	1726	1874	1	1	2018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaRsh13KY8rYx9twy8rtiWNTFpH9zv5VTfyjB5ZMRweA8FinC
8033	payment	1397	1397	1678	1	1	5047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vdz1j3YwCrDof3o4AzSncb3im5yTpE6xB4FiQCSSTUgQPCoU
8034	payment	1726	1726	1874	1	1	2019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQjEr7pBd8U8u8w8PrcYCa5NS9oJ5ZDC5mojtoGGUFZ2hfRSC
8051	payment	1397	1397	1678	1	1	5056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBtDVDWJSVfwB5vTjjYnDhAL88TDKNNRAxnNxXv1Go5cnoxUv
8057	payment	1397	1397	1678	1	1	5059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZ5gbB1Pjp8xCeedaAb5afJaSrJgiDcEGKoqR7bTPxbzMbkeG
8058	payment	1726	1726	1874	1	1	2031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFLhkmRb3K51h3q8rgH11Na8eyaBLdJAyorVJrYAkYrJYPcDL
8059	payment	1397	1397	1678	1	1	5060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJqsgVzLjmoqwisgakfSnoE5Jmcx5finVy6HtPTkyigyMNqvb
8060	payment	1726	1726	1874	1	1	2032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPxNrFVJ6MoKa4c5C8ZDdhqqnATHd6yNEkMCbjswf8sM8i4UZ
8115	payment	1397	1397	1678	1	1	5087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjUtYfx9HJfCnHPrx6tucgRq14rNE3uic7Y1whvMZj9gnVFyF
8116	payment	1726	1726	1874	1	1	2061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFJRmvoGy25zQisASH3eHRh7qmRLN3JHdxv4wHDDPnzAoE9xG
8151	payment	1397	1397	1678	1	1	5103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSgpkDJQAjfF61cXPadd7s2SKyU4eZG47aCbisViRQyb3GnhF
8152	payment	1397	1397	1678	1	1	5104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGeYuXQL84XyyQRK6MGHtjF49UQHCyTps9Kp8Ps4r52JZ7J5B
8153	payment	1726	1726	1874	1	1	2076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmAoQb7uX3wjTKAjuJbGgj1dVEi1AvKMxGrL87YXtXidkdCNM
8154	payment	1726	1726	1874	1	1	2077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxENM1p2uB6STvvPHmrvacnj9Yemf9GYsVSaJwzQwNxC9waeP7
8159	payment	55	55	761	1	1	1	3857250000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJPTLLfY3gPXqF6UWUZ2jSq1cybAZymCJEqcJv15KSCx18CUL
8160	payment	1397	1397	1678	1	1	5107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqFtQQTFpHtHENuBgKwCwTE5npMk8c7mCSvWh5Wpx2AdaaVWj
8161	payment	1726	1726	1874	1	1	2080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsocYxpWjnhwf9f27f8dHB7jD96CJhV4cPiv653G4x39bveyY
8177	payment	1397	1397	1678	1	1	5112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwGsTEkKNF3fkTSBzWEuQ7V9rTS14csb6oyRpug9eyhDhyVWG
8178	payment	1726	1726	1874	1	1	2085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHU52peKzbYkSRpPQ1sWJ93D1sxrT11tc59MLpCAXxn8WS1Yev
8220	payment	1726	1726	1874	1	1	2105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWhUEFAdZBQ5UxwYcKo5ZmsiQ3cRgc6aQ6gjHuEssUk5GoYCV
8221	payment	1397	1397	1678	1	1	5132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa449rSrFjboQ5LnDHc5d6qdQ59CaDADJfMC8A8znV2wEJ2EmGm
8226	payment	1397	1397	1678	1	1	5135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCq1WiS5m1KZqLrUrT2ECwbo89YzKa6dt4rRRxuHzwj7ZqejJK
8227	payment	1726	1726	1874	1	1	2108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchvKsH7mFCfS9W4MUp7v9jq94xszzDVXyzpkxo6tvN5wB5EMX
8234	payment	1726	1726	1874	1	1	2112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBtuwFYA5cuYzfB5s8VgE21CXf1gD9WUxUbLqLrvcN19mKnBo
8235	payment	1397	1397	1678	1	1	5139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcaqi5L3DRFbfaiuuHEeudffsg5yywkZ7kvgg2EeAJ3PsZCfQ
8236	payment	1397	1397	1678	1	1	5140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYw1nV2wDdWqBxtRtMJsZuRMU4LkSB6KawfdX4Xx6pDTLGMcNN
8237	payment	1726	1726	1874	1	1	2113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvMbm1NQZbfM4C3vVCwJmAqaFCu3hVaSDkACg4gJ9gAJep1JU
8242	payment	1397	1397	1678	1	1	5143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVfbMBsNoV2YGZMFiqVLSmrkDRu2zZN7doRWyQAXz5CGt6Ws2
8243	payment	1726	1726	1874	1	1	2116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXuc7NTm52jQUE9xvVcSKmYpBsorkGCnfJ69g39TtaCJgwNnD
8063	payment	1397	1397	1678	1	1	5062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXucA9TbEjrVjZRV7Whbv7Xbgs6ekgoKdR8KMHQaKzdSYAejuP
8064	payment	1726	1726	1874	1	1	2034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZdwz7yG1oC3QmeXr3W66nG4GPp1HVMsCPLw18YhdhJBNpYzJ
8087	payment	1726	1726	1874	1	1	2047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerLiar5zz4kGewceTUqpDfWAhUeoFoevXw5RyNL4MZ7QeCML2
8088	payment	1397	1397	1678	1	1	5073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYta5Zve269CorTS1we5e4XzhLbH6TnhoMRN5oHYiLZfbEWmFbU
8089	payment	1726	1726	1874	1	1	2048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33ezusun5vamTkbRAF33WcjfYiezuShNAng6jkyqrGDggcQJU
8090	payment	1397	1397	1678	1	1	5074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQECDBVZx9PqpLuWwrbbXBbw9B1GCV4EoVBYtW7i91thdbkqdj
8099	payment	1397	1397	1678	1	1	5079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyAjKJTaRKMZoPVrPD8Rr4MCN1nf2gS2xnF74GLPD24txr82i
8100	payment	1397	1397	1678	1	1	5080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB82z2AZsanNJDAwqZPp6CaEDmWDhiUF88eohy7qAXxRP3MQbK
8101	payment	1397	1397	1678	1	1	5081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdtMri73H9P5FWzdoe5wRqqnNQhnr2axy5UvDo4vS4ykxxkZK
8102	payment	1397	1397	1678	1	1	5082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnTyfeeWtvTZTVvhGym8x7jHRHcurdW9DN8CE9KoDknCitNpc
8103	payment	1726	1726	1874	1	1	2053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYcyBaras3wT5EnP4MM98pKg5NXZzNTavyLt7ZujpGJBqaVsS
8104	payment	1726	1726	1874	1	1	2054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQGrWisrXf5iZqBJfgrXazzbtvWRxqwFHeBiYJsYkpJ5h7646
8105	payment	1726	1726	1874	1	1	2055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Vdw8cFvvdWBh99hPppmxLtVXrSYyHkjKRzBYdmp1edTTUKaQ
8106	payment	1726	1726	1874	1	1	2056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXGvD6NNmxGvb3NtgrJBHdnNJqtREe7xc9z7pCBSsaxAuUSac
8111	payment	1397	1397	1678	1	1	5085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUPGL5URbNfTUhWmZGC1EPhrpj8ixM5fmpQzG3wFJaXjM25GZh
8112	payment	1726	1726	1874	1	1	2059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xtn5fHeGF3C48QLjd2FqB4X5mVeb3purczmt36Pvnnv4wDjj
8117	payment	1726	1726	1874	1	1	2062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHHh2kaeuRJtorEKjFhrMp1gRzsWNoNhoEPF9CepRDMtBGpr8
8118	payment	1397	1397	1678	1	1	5088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadpUYHNbrEJb8mFkqA5d5R49BcPuambHUbfS5nN6ayAhDcyUu
8119	payment	1397	1397	1678	1	1	5089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5u8Uf1XPgqbVxfaruqJMcQvHKiAs81uCQpSc3fG2oBG2S56z
8120	payment	1726	1726	1874	1	1	2063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPvps3g5GhTw1qEvoy3QFHJWvZN3kyH8VsxUjArqm8Hzi1QBV
8121	payment	262	262	277	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTEKuSPuzv7wwY5J7DxXMcBFdhAuaGrQTJG8i3WAdXFhTnnip
8122	payment	1397	1397	1678	1	1	5090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewL2EVJguaLcbj7Y5DhzgrxvxmqsWPcVbWUVDACRirE1uhKps
8123	payment	1726	1726	1874	1	1	2064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTiFjjXfBjvcYeh522MQWomRHydA5hNt1uwQWXxfxkCBReAp4
8124	payment	262	262	425	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NUfDS5BykdQZJBFVwKbKWBh7f5AVaxAJ39Ek9NGxrgeToNo3
8125	payment	262	262	668	1	1	3	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MqcogTks3gLoHHsR8pixe883rV3du64xrmTTEG4TAfhPKPzW
8142	payment	1397	1397	1678	1	1	5098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzUyL5QD1eFN3qaYh8k3jaNuaxcmGZWXdL7tR6vkTCdXXDKCW
8143	payment	1726	1726	1874	1	1	2072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdbX3B1R36SBK92v2VZM5UmPGGXdhvkEg43EGccGpoDNfKhzv
8144	payment	1397	1397	1678	1	1	5099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZic33LZNax8tkPSHqYPB4UrCb1DNiHwAhSt1bKtDWEEKbUiDVX
8145	payment	1397	1397	1678	1	1	5100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHn1q48ojEUyzexhFk3ZxtUzr8gai9xougZLquWgn56Giefn8
8146	payment	1397	1397	1678	1	1	5101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbvoYAubGBdZEresuyPruZ6xnPmyUqTPxHLJuaCeBMjPwrgD8G
8147	payment	1726	1726	1874	1	1	2073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwC1wRCfLrraik5TyCuFNC3nZh2ZSdKUFo6uNNWsBNeaiydwPL
8148	payment	1726	1726	1874	1	1	2074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxp9mftSgQAwN9PeZFtsvakwtdESvn9rTvwZzp5dyEFne16J1
8155	payment	1726	1726	1874	1	1	2078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLapTs8vZHS8RnbGh4ZS4r7iimaxaBs9Bh7u5zeuDsnfhdxt8A
8156	payment	1726	1726	1874	1	1	2079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinnrnuSUi4eRyM2UoDJq12XMMW2MhWFDH1LnJkjusQXFiV2Qe
8157	payment	1397	1397	1678	1	1	5105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbcDt2FyTtaGsKXedCvdXGJ58vt3bZnnfASPtUkFE7zLQdVYD
8158	payment	1397	1397	1678	1	1	5106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FX433sVBJyLizVih2nnNCmHocLCTVEDd9DtPjjq8yVGj2Yf2
8173	payment	1726	1726	1874	1	1	2083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKP1awkJszXLq5ErZZTa8WWjq3GQBHLLL5wLrh3kUgZehDGjK
8174	payment	1397	1397	1678	1	1	5110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFjaSNAsHYRPgx975F9eJjLdTVXjtg2yhxwCKf6hwEGfGxbLs
8085	payment	1397	1397	1678	1	1	5072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqegsvkpRNTpj2JaiTG1rPruQCxKQAJrEmyUXFRaVu3dRrPb4
8086	payment	1726	1726	1874	1	1	2046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMKwJ2TVV3uUoNgU37BAur7AaxfmxVcbGte8gv7DaEuJb7SoD
8091	payment	1726	1726	1874	1	1	2049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRa4aVY9DbfwyX31LDEqTV5q6tDxWPr6XuhD5zWLmQtRFbpEe
8092	payment	1397	1397	1678	1	1	5075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYQv176eYGqHphu17qhwqsE7g23B7TxB3tSGzS6tyki23xcZV
8093	payment	1726	1726	1874	1	1	2050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQoJE6Gkimh8wqcS3T4qWqsKBFqLXPGZp8S1HFHE4apo7FhKW
8094	payment	1397	1397	1678	1	1	5076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRFuka4SH6Mx9kfEVRxwNnRdhq7iAQDxDVkPXttdXkJ6oDduF
8107	payment	1726	1726	1874	1	1	2057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghdANUioi86hnG76ktoCFaZtjTat9UBesDkhnf1XmPNcTRuTU
8108	payment	1726	1726	1874	1	1	2058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR87bQfF8T4qo3Fztfskf578AeXiuz7udCtemF21FVe3nd4i2G
8109	payment	1397	1397	1678	1	1	5083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ioo22TVdk5YpqHUJe7ERBcx5s4h892VFUrw2WDFeKGVV7HcC
8110	payment	1397	1397	1678	1	1	5084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvcCz9tTMgFZZPf62jd6wCSDhfS87MRsmGPc4tYCVg2SyR4ro
8126	payment	1397	1397	1678	1	1	5091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz7fQZJzk7w6cau5jbph234XaAuVXKDCe8zHtQzYSYAFv5uJ5
8127	payment	1397	1397	1678	1	1	5092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVGKvcuKKSqkP6i4cjgQ2ac5UAN2qWFdN325jq8FfyuthipfR
8128	delegation	277	277	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG32vrTn4AktJA76pugratH9nAnxz8aMN6hFtSmyw78hhaiW52
8129	delegation	425	425	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kxjRY8c9f5SBfxfivL3umMkm1ak4Km5k9u6QvNtgC2W29Pbu
8130	payment	1726	1726	1874	1	1	2065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2AcSQvAYMvBVYbJcGpnbtT1cf8vLZ9bo5nuzaq3yjnoxXniC
8131	payment	1726	1726	1874	1	1	2066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfoXgfZgqv4NqkbqDLFaGhxYt4EUCzfpgjwDsfc7ft4ZN3zm1
8134	payment	1397	1397	1678	1	1	5094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecHSdQfyaNtBhxCwnqn6sMyyTvCk56cwrXqqTRHFNKxfibGDV
8135	payment	1726	1726	1874	1	1	2068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqyxZzQmSCGess3F7enq9Ycid5QsS1k2cbAzMXJzCRuyyr2Ew
8136	payment	1726	1726	1874	1	1	2069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhEKvckGGHoXtWyXBAMcyhcmoYwgKC7LUYfRtZhfXAzUcZhcY
8137	payment	1726	1726	1874	1	1	2070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkQvYcTfYaXaGjfj4v2NcfCyCk9aN7YFjEvA3W9XXm95HWawD
8138	payment	1397	1397	1678	1	1	5095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1G96Xz89hTvJWhtXwtifKR67su3cGyW7ZbfSkNJPkFZpdtpA
8139	payment	1397	1397	1678	1	1	5096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFvTpQZGwTcg6ZMZT7xptw9QkM2aqhp25neWsVwKQSqRre3QR
8162	payment	1726	1726	1874	1	1	2081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU912iGGcLNNDUkvoBnvp3NJ6L1f94WMN5GRqbxk2rtfJQATD
8163	payment	55	55	716	1	1	2	11571750000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkn23hgvL6sGQrGREBqYBmLHSJV3KS4aP9uuGm5trYz7DHqZDr
8164	payment	55	55	517	1	1	3	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqkqsJwKkxD844t4VMh7TtGzBfnW1jobbHnzrfD92kZzGLWL7
8165	payment	55	55	509	1	1	4	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2FaP2mxApXTFnBGoaYCUg5xzyLsrDpzzUiAsbVqWE1c5qZfs
8166	payment	55	55	463	1	1	5	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusSejjh8uSpzoHTxH5yLWjsYCaiGhmrRezZDR3yf1M33Tn3vX
8167	payment	1397	1397	1678	1	1	5108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoeCz9HbxKf5yvZyEX5dX4nhoxf5E2suyEFMUBchkN1K6qWVC
8175	payment	1726	1726	1874	1	1	2084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUzgP9RYBrGMAwgyqnNP92FKjSBAkpa36U9BpWpCUS1bQjN6Z
8176	payment	1397	1397	1678	1	1	5111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5NnhQfE9ucSN3Vs6QbERbyHwworUa3veMoa5vMVjGWwGzKF8p
8183	payment	1397	1397	1678	1	1	5115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXXE42zsN4bVwLje24JqzTQManMw6WheUNzP7ik3uNdHTJN2X
8184	payment	1726	1726	1874	1	1	2088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopfcjK6jGSrtCbg6bJsPwf8rkECLDmzvbvpzLRmF2QsdPZc7m
8185	payment	1726	1726	1874	1	1	2089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2nX7p9VvxfsYBa56Q4dH1SymhTn6BkXTZW68NvuAxCnBvbuH
8186	payment	1726	1726	1874	1	1	2090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjo13pAKY41srCdTZ4D8NFA4K8cYNm95a62XvNphcUvG1nqFX
8187	payment	1726	1726	1874	1	1	2091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRGCMEwyR4YtJtSAi3NH7dZNMTYkR41J1XCuq9SyNV4EGQYCo
8188	payment	1726	1726	1874	1	1	2092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtp1nyKTJ49UXb8HZEqXh5JGL5GK2gXcoF1iokKRuWiScAqWzg
8189	payment	1397	1397	1678	1	1	5116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcZZ3hNsbKKqWN4Ac88zyZALce1o483SCcfbR7QQUw4DyFuTe
8190	payment	1397	1397	1678	1	1	5117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ysK1L8tJAtMFjgXcVt35chkcQudoAiZjQDsJJ3pWDx1CSdGN
8095	payment	1726	1726	1874	1	1	2051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4Xw6YAGbbPLYLxR6uCwKHkxwdKD4p9ySVBNbZ3e1bT1NHC3Y
8096	payment	1397	1397	1678	1	1	5077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK2pT9qhi5H5WbSNAc6E6hh2S5R16Vir1x53ordwqnt4Rt22Y
8097	payment	1726	1726	1874	1	1	2052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBx4iaknWn4wHUKge4cdz6ALtUVdckUSNLP5Sw1sfC1jDRHcZ
8098	payment	1397	1397	1678	1	1	5078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AVTBRA5qzW6XqYvDuugcKaxY7sUp6Xq8iYJjDGmjsWcJ2Esd
8113	payment	1726	1726	1874	1	1	2060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcoHVrSf7PAqFkv4igE1qE4zbxE8bhRBTFJgStP6gErFzyngJ
8114	payment	1397	1397	1678	1	1	5086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3o3Rj1aw93iHJ4DN8vd1un2XVYv9VouMHAcNzTCJ1C6AAkNhJ
8132	payment	1397	1397	1678	1	1	5093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGY3AeFvhKxtadBAoJS1sNjb7AtahytwMEjq6HrrbC5PPRTBN
8133	payment	1726	1726	1874	1	1	2067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZij2X9WUa5Vh57LQxzYFTCEgXChy2htpMdxVsjGc3zjcgVV7pM
8140	payment	1726	1726	1874	1	1	2071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanz9Xtrjn5nKeHKRR88matsj2Z4pkraYBk4jxqKyr8ahiJ9Gk
8141	payment	1397	1397	1678	1	1	5097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTUD6toh75MeKwudMGsnCTCq5hCDypgPDyWPB7KxVcpJDWHLJ
8149	payment	1726	1726	1874	1	1	2075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQepDRyQBc1B94rUzrQDXwDNq5CZPC3Fyqt2UkVgfWZW7zkPeK
8150	payment	1397	1397	1678	1	1	5102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99X4g9kSte8HWEbNK42wZP4Aka9utRDRLa9VTMCKcJ2bfL6XV
8168	payment	55	55	278	1	1	6	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEF7XTDAxoUXHNwv6ciGk2TEDW6NERd54yKFrJnjFXrK1qwp2
8169	payment	1726	1726	1874	1	1	2082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpTb1o5QDUixkRw1uXWUNUeBZ5mnErCP5fEC1yPcfxzoPT3Ri
8170	payment	55	55	178	1	1	7	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RT3Pc6Lak6of1URahXxCVqNGuQE6UzoNLfmphzNsV3cGTerG
8171	payment	1397	1397	1678	1	1	5109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkivKfRbGUPHFamzW7FHBEKP5Zg3moQ91emBk77ozfMsAvvmZ
8172	delegation	1919	1919	1919	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAfGZmk7V3JfXpsdi9UyEAvWxrRQwecBi4TJgxkHM3NpGrHwV
8179	payment	1726	1726	1874	1	1	2086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7GA35AX7M7C9N1T6kvPB3DG1Bx7LDEhpqKso89DoapAddBjK
8180	payment	1397	1397	1678	1	1	5113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGKqZjFjXd3SmbSFpH1iFqT6pGKyxdN6hWtMDsLYMoMqUz5Cr
8197	payment	1397	1397	1678	1	1	5121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnC6PZDqtTGu6EXLDY7cvbvo9korij1WfsoTJ7wUawg292VBC
8198	payment	1726	1726	1874	1	1	2094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZug6tGWeiAsNJsHTbcvWEp8ttCRFALnTcipz6U1g4kwX7MkGih
8204	payment	1397	1397	1678	1	1	5124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEB3ivYTJZv5YfNp7bujpJmsPziKt4mBE9gUF2z45uoDbTXBGS
8205	payment	1726	1726	1874	1	1	2097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAzyJsU3rSwATZQk4AFCzEFB5LoVhefeNhYVSE2faicF8znrm
8206	payment	1397	1397	1678	1	1	5125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUx8A5DZFc6REhhYYPiLJgzYx81Vht3ZR8hDvGhwPUGaQUHS4
8207	payment	1726	1726	1874	1	1	2098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7689LSQ3DBy5DzXTYBDGvjsh6oheqRG3uHVE2PodXGRsajm4z
8214	payment	1397	1397	1678	1	1	5129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2BCuKRFRYf9WRcSrfoFvCKNMJRg23kw4wDfbjUQYXFEeSxAMZ
8215	payment	1397	1397	1678	1	1	5130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARdS5my6zpNsbfYp3opUEFPSi9jZPvHxYXmagz8Mrf5d8ZzQA
8216	payment	1726	1726	1874	1	1	2102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbB3Uo65UhzSRJW6r6Zg1g6nkvRKn3UsQBLmdW9fygKJ1c1Wzp
8217	payment	1726	1726	1874	1	1	2103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZ3QA5TLcpRurRpDp2XRVzWc2j3oM5bB4S3wKiqKCXKs4fMVx
8230	payment	1397	1397	1678	1	1	5137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvtb2U9TtHBq8dkixfwKVNqvqvz3aUFRF13UAViEhhMcwwVGK
8231	payment	1726	1726	1874	1	1	2110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkESPHLVvYxrSmnH6iXJnhKXDJRNCGaBwsavRs1HLs2sDMgGo
8240	payment	1726	1726	1874	1	1	2115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXsU2VJtG3VWU3LXMHa3EDmc17NRNzfgYkD3SnzSqeebd3mSe
8241	payment	1397	1397	1678	1	1	5142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSduh9TYmnww2Uae2NyCUmP6gTgtQpV2wYXmz2DKppJXcwWqsH
8246	payment	1726	1726	1874	1	1	2118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFMi2vZ19RnTeUwsh5Hp879DPZijiaZ3jSVpp9KELdiRNvnib
8247	payment	1397	1397	1678	1	1	5145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb51Uuz2dUmkXDPaeDWHPPnJ8t3Mv2ZevjfJU1HysrSKdNn7YW
8248	payment	1693	1693	910	1	1	458	473988655965	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZnA5Kvc1ANPq9pBZsouhTagjjm1b8x7BwT49Ss1h5tfhZ2Lbrc
8259	payment	1397	1397	1678	1	1	5148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfmgRJVvj9Rg2BPPFhrDS3HoUDobR2zSGb3bbzE9oBwZbrtw1
8260	payment	1726	1726	1874	1	1	2121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZSn2jLaUC5CW7cea245ejCPqU3Hi6Uj474b8iBKUqe1YtDFN
8181	payment	1726	1726	1874	1	1	2087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhD38ciWjeKQbespZa5pmBD291xCjC3AQtqvjMMfwzzk7S3tkV
8182	payment	1397	1397	1678	1	1	5114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2au4j4YETag81gA7iJx22n7wrFaDtjZPm2woWA7K3d8MWjD8Q
8199	payment	1397	1397	1678	1	1	5122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipt5BPhuzQzXASq1pkcooY6qfFAR7xhtkkJ4ebdbdtYAfQdLG
8200	payment	1726	1726	1874	1	1	2095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxrYNsByTD1mtLBf6jwexCvJvzEwM2m5YRzguovghAwEhUnUh
8222	payment	1726	1726	1968	1	1	2106	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHJ6CVH9jhgpmm65Q1NiiiHHyaTJry9jTURLDBzmMdG4jX6mpA
8223	payment	1726	1726	1874	1	1	2107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaRb7ds1qfmhQw5XzzCBnr9HB8E6eUCY7kJcssmGBdEdndpaf
8224	payment	1397	1397	1678	1	1	5133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXeVDCbKcvbC4YYMUNQbe1aoyF4n8zaxNYFVSE6ChjENhgDgL
8232	payment	1397	1397	1678	1	1	5138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvJaGpMgx8sAJKcQD8vTqrh2oxSn7UBmNrUWNWaPU4PrpdeqW
8233	payment	1726	1726	1874	1	1	2111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwumR2D9W5HsY6akAYddbWA9mBXXVNMv4GChUcXQ4wtuxi7dS
8238	payment	1397	1397	1678	1	1	5141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLCUtYvasveyUPv3y5z897Twg4YtnBqhKv3KrMhAARwXL8Exm
8239	payment	1726	1726	1874	1	1	2114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHG5SvmiqwaG1a5GgGTSiYaNF7afZ9WtQqpXj3oJSAaFXWJvr
8287	payment	1726	1726	1874	1	1	2125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVT53z8EyYpv1fKVUhzys2dhZRZXnaemUTmShUB24sMxDcUpZH
8288	payment	1726	1726	1874	1	1	2126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHK74hUPzkerhpKVXvx7aXyU6MQQKjRwbCn9Z3tVrG93S4v745
8289	payment	1397	1397	1678	1	1	5152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYuZDnD1NYVBu7dfqcVJpjYDBtoPWT8RMEfA7asdx2KyxwGtw
8290	payment	1397	1397	1678	1	1	5153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSScrZURq68kp4aC4kYQb2fkq1pUx7WrRRgmoXBJpn9AHdze3
8291	payment	1693	1693	653	1	1	485	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZn43cJT1Xhi9YRRuNjnVUE4mcsCMiZx2soXu9oio7iS3QQM7Jp
8292	payment	1693	1693	721	1	1	486	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ5fpDgz2XLrwbjvtSFhhdN2nUTZXE5sXAwsc8seY1a3ruLnXYF
8293	payment	1693	1693	308	1	1	487	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZHGWFECSNmqdjvWXZemsMq9Ptbv256NaqTe7TcZhapnKF2fNv4
8294	payment	1693	1693	1150	1	1	488	573096047085	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZRMXCABmok21jB1a8F17FN7NbTPDLdDUyUtxgmafzoXfnVUwEf
8295	payment	1693	1693	84	1	1	489	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZoKat1Vtr9gtCq5JAsdm9vGMKtsBF1iPkLXBECY8RrVEiifNw3
8296	payment	1693	1693	89	1	1	490	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYeqsuasS25zDz2VnZegiqbX6dGpSZkpK6vjGCr9YgNCHQpvqGv
8297	payment	1693	1693	186	1	1	491	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZXYMYPiWgjZxbtnzn3fiyr3drZ6bzBa3a6hsia8zkBvanFusB5
8298	payment	1693	1693	383	1	1	492	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZc5mPG2FgxqiWGTUixCPskrgdK6n9uJLbkw1o8ty7XLPkN7KWX
8299	payment	1693	1693	392	1	1	493	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ9zfK5JPnt6fsdBT1hTZQoUXHgZprhxjc8idMCqDJbEgp4F7xD
8300	payment	1693	1693	678	1	1	494	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaCvAwGLnurQ74gDC3H4YRCt8bzyb4FzbH3uzXx2PFSFy1qNJ9A
8301	payment	1693	1693	339	1	1	495	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaDtFiCuG3BfK6DFFwVrSppVyomZKoRjcPG7DJ1BnBEcFP35LNF
8302	payment	1693	1693	91	1	1	496	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYRRQqh7R27aohfHShvSQsABUtbgMtqazaqXqomKHRZJuywFUru
8329	payment	1397	1397	1678	1	1	5157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcncgc2BtrzKKvSqcSseYpsNtTDsTKEauSfB4GMJm92rFUjgU
8330	payment	1726	1726	1874	1	1	2130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdniVMSSymuxvt822yEQ8pDz3sYHasGrsi5C3d9kuuWF3aNLDC
8331	payment	1693	1693	201	1	1	515	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaC1B8dCDnxBaSshekTeYZ8iov7p6cu5CPRjBvsDKo4W2efMvXG
8332	payment	1693	1693	1962	1	1	516	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZbFwMuZfdsJy6SW4NbkjQD6zrAW1bXmQYMk5zLb1TWocw41ViP
8333	payment	1693	1693	391	1	1	517	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaFfM73v3F72aaptkn8Y5stk42qnNPuLZSK4VkR2MBwXkc6gcRG
8334	payment	1693	1693	402	1	1	518	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZwnfcL4y1shatMRmqYfNnVXrvbPn67UDf63Frxw3g4YTGbWeBk
8335	payment	1693	1693	397	1	1	519	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYnnbmaQugWpek7J894CyWZkTZ1vP2gv8wWPtPnheeqxza8tK8t
8336	payment	1397	1397	1678	1	1	5158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88qAYhFkFCSPrbpxY3wgXecPSiRP7NFf8K9hjjgnMrTB7Y46M
8337	payment	1726	1726	1874	1	1	2131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7fhCokPzyyFkPq3HwHo7CFR4PBTUg4P4dKBdUPLu2RPPpFH9
8338	payment	1693	1693	452	1	1	520	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaLAwkkmL4PVdKAYNoTyQ7yBt3fFuMKdpSsHdXFxX1RdgWUts8g
8339	payment	1693	1693	594	1	1	521	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZfnCEBD4B4ngYW83xBQfCw3B4MNWtsedqfkFBpsU2jQ7dDRrD7
8191	payment	1397	1397	1678	1	1	5118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbURuA3eVWxe12GQhQTgBToDBgCVFuiuqrkMMQvRFFShNLidog
8192	payment	1397	1397	1678	1	1	5119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGojFMN5DfxXPTYKvJH6E78zgPSWB53UBeifyNcGDAknjgtiUJ
8193	payment	55	55	62	1	1	8	254578500000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pH4XuRPEYmF7JHpmAudbCaqxFSgWqj5x9FdRiUSgHSYndrY2
8194	payment	55	55	59	1	1	9	254578500000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8BxnnBxNjzpkPK5xaZV75ToxhjQbpxt8pmGtsdoAFb7xmfib
8195	payment	1397	1397	1678	1	1	5120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfZpqhD6wZrC5f9tyNXPHqxPThauB33BbBKoSbNcKPkYfMYFe
8196	payment	1726	1726	1874	1	1	2093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKXdBmLPmceHp9vtEnD5PqsjNU4FfduusSbjyx8TmKEFMsQzL
8201	payment	1397	1397	1678	1	1	5123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxM9yFHSgj5tV5KY1VyWAmEW5m7bRUkvaywsZgVA7Ygqx61BB
8202	payment	1726	1726	1874	1	1	2096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQxE7xCRGazfBdNiNefzCYF4YMWuBkCZSU5UBJpSu3Z8fTCcH
8203	payment	55	55	1967	1	1	10	361451500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGqnBNpcNuzDeaNGZrW5LBDvEeBmoo4xniVo1QSiUu8dMTT9L
8208	payment	1397	1397	1678	1	1	5126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRm7RcwgR5ivEFLWaa1vJnzdUuh9VRmrTiG83wSsLS6EarjJ8z
8209	payment	1397	1397	1678	1	1	5127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkGQcYC4X2a7VGT2oRZGph3KSoajxnUkRz6hiHJ8MHDfY23Am
8210	payment	1397	1397	1678	1	1	5128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8USvMbVNANow4NGeoSfeFKfGhb1TjJNYTAFCh9dYLyKwFJoRg
8211	payment	1726	1726	1874	1	1	2099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPq63CJsjtPxqfdAZFR8E9DadJ2e57GjoEpt6aq3CSLot9MP7
8212	payment	1726	1726	1874	1	1	2100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJXFdeTk6UN8EaML5CAo9KPkYWcgvtn8CGHkiYix94vqn8t8D
8213	payment	1726	1726	1874	1	1	2101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREaq17zXtxxnLJBdnfVQ2BqjMTp3aE7CgxLk2yGwWi1WkjM7w
8218	payment	1726	1726	1874	1	1	2104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvuCcz6mnPZCTFX6aJwewQdkAZW4TiPRWBXmgE1qSkXPLmDCn
8219	payment	1397	1397	1678	1	1	5131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizPQVyx2EQQtfMaLmL1TB3nRUyxvftWQ99Cr71kAhV6mHrZZD
8225	payment	1397	1397	1678	1	1	5134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTTa6yveekXhZKbRXg2CYjDYX4nDoQLWGYBAYs4WPU1rRFJVB
8228	payment	1397	1397	1678	1	1	5136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Uxa2qxeVbMp3scAmbLPKuzmBbbxyhEf7uyqLB1kghoeg5g67
8229	payment	1726	1726	1874	1	1	2109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kc8R7635CRinodof6hR6K2Uhptu4zCcYBf5XgrPnsDp1kgBK
8244	payment	1726	1726	1874	1	1	2117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmLzrcB63AcuVdP4pMqkSfcw7TPRAKS4dVBXaUmqn741kHWvT
8245	payment	1397	1397	1678	1	1	5144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5R7AAknydsSb7XLFXXPbCxZdeHQy9AewkFvkFmsRjjaWzCAo8
8249	payment	1726	1726	1874	1	1	2119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifuqPtgDS2dkWWpL11J3aTsbkGWWugMTqktumLYYpwRqktFM4
8250	payment	1693	1693	500	1	1	459	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ1ohZx3By8hSCCC7DaxCH3tdk8rEBSyBgkaT8iHd9Twju5ZDWe
8251	payment	1726	1726	1874	1	1	2120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61taFVnorNnM3QhreKXYbFvDfU8CpELNaFTkaqY8Nkg5AtJWZ
8252	payment	1693	1693	587	1	1	460	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaH3cTeL6txT2437kN7yjWEuqhm69dbqJVJ4CfBqTyiizMPn4HM
8253	payment	1693	1693	146	1	1	461	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZeosLN39RRPRN8jgto15hEHQeVh7wpPkcJsTP5bFDJNkvbFA82
8254	payment	1693	1693	395	1	1	462	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXSQPuhR2BGxHXL26yyKZzceoUDqCcF2vcHetNz8eKsMS9wond
8255	payment	1693	1693	611	1	1	463	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpqzNHW3phJFuu5j1AtfnhqCg3cEnDytPjGdSmWhohSmDFw2rp
8256	payment	1693	1693	29	1	1	464	6599392205	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZfppeBemGaihnVbXPxyJjdeUBkqbNsimzZXNj3nJbXkAFDj595
8257	payment	1397	1397	1678	1	1	5146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdRNx7XqAuJXvmcxxjE1M7G2fqyLBqy7qY3HEsU7VcnmZ2WMt
8258	payment	1397	1397	1678	1	1	5147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC3D3WXeKmjtGE2nSfShvhR95qmTzBGA3YgqdUGKLn1Ghg9qz
8303	payment	1397	1397	1678	1	1	5154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZrUgBCVkEUaKHz9TcvguBD9eF3AEAPYcsc16Fz8GbpodvCFR
8304	payment	1726	1726	1874	1	1	2127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FMzpwTxLjq9yyuWZV18gUYvziuvZkZKRJSZtKoiuSFtqNFAw
8305	payment	1397	1397	1678	1	1	5155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M11XgMDzLXBzDpvYjje9oT7k9X8VekWy2hR98zHyXn5ZHYKn
8306	payment	1397	1397	1678	1	1	5156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAd9gMBW7XUsgrYmLbPbGYkQwTfZwnadVWjzTHzMiGTgoXFnuG
8307	payment	1693	1693	438	1	1	497	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZF9qSLXhNhym5f9x65UCoKv7HoMUPsj7KeJcQ7EtWB9xJTrgx8
8308	payment	1693	1693	593	1	1	498	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYxvf3wj8PWX4PsfMkY3M6DLUcPeV1cNa82zxBxH43QrXev7MCi
8261	payment	1726	1726	1874	1	1	2122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoWXRkUdhP3ihpdTqrFbqZBQFMik7pTtD6Dd1vSW7xGdZmVEC
8262	payment	1726	1726	1874	1	1	2123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiyan99bzoQJPMpVubqWataC4Y5TQYUoRXoQGp96rovK6QUAn
8263	payment	1397	1397	1678	1	1	5149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtEoUrgWzSPVgMWyF2TaJT8wGTwf5ebwgPU93GRAAdpEHqhN4s
8264	payment	1693	1693	138	1	1	465	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa6wNrDpDJKxBTYVe4LGiSBombvWVna34Ed54641k36xukRxW2T
8265	payment	1693	1693	205	1	1	466	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ8fWJmxk1sc8RV4RKh6g2n8N16Rp4tcP7nrUhZFgebD7f1mUxR
8266	payment	1397	1397	1678	1	1	5150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GdDZtgJ1fnTCpqr7wpycsSj8iD3ZLWmZXyTbfYPpZkXNDs2M
8267	payment	1693	1693	78	1	1	467	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaE2EaLQZjYVav8jb6HRj5aTmK7GW4aqhnYj4e8cr8xgr48a19U
8268	payment	1693	1693	1811	1	1	468	170248291866	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZKV3oNVEFoeu5MqYwhN7tomGEgE9iYj7pVWKYPb65oxFRBaHXg
8269	payment	1693	1693	504	1	1	469	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYrhMSFJun15JP4AgzA8svpshBq5gLZZHgwfdqvpLMN7auVK7hD
8270	payment	1693	1693	658	1	1	470	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYsDE1VevLPEssfCGrNvy6EaqPa2qE3VnJomzXB5WcxDUxyAcBN
8271	payment	1693	1693	1961	1	1	471	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaDV1ZBm8kSb5H1vLHfuQG2ZNK8PjMzZRr6pLqeESmUt99qu3qU
8272	payment	1693	1693	660	1	1	472	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXEaeCb3AH9gByJjBSehoG8aqkCNgk8h9mJWRaotcrhYLbTyid
8273	payment	1693	1693	1276	1	1	473	1596983092050	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYWwRGMDYyt99sBTJGpHwgPPbPqvnc2GaYJP93GMATMMG1N9vXd
8274	payment	1693	1693	194	1	1	474	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaF2mcg45nTqjjnnyNRWmotgePitXkX3meo2b4XCFU97vFJxGWm
8275	payment	1693	1693	304	1	1	475	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYa12PLjUytmNyY4WTM5BR1bcVKSDhdK83rbYk3bATScCK998NG
8276	payment	1693	1693	206	1	1	476	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZmSRnJtEGaxHYUmRp76JbPKAcasYsScxdVReFZToaS4dFKddcG
8277	payment	1693	1693	399	1	1	477	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZSS4q5VVhojZo3v6QxKNh6wgFHqLYYKMsshAgA8j3vTKU3vbHj
8278	payment	1693	1693	1772	1	1	478	445087836802	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZMjDzww7EGBaXC4H3HFHmXuhdbtHxbPmrL3fWxdbZrmZvSNkEY
8375	delegation	668	668	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTbGrDF7MwQ3cbQdgKavj9iocTvxpWAqFgwgmv4VdCBTxMpMc
8384	payment	1693	1693	108	1	1	555	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYY6iUFH3SbKcDNZgHjiCuPkuLi28JqeJezxsK2L3AzNKk6devf
8385	payment	1693	1693	390	1	1	556	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYtNfDyY7m9vnJL8snLTGaimnAg3D1ZeAJ3j3rPQaJNcbwEosR9
8386	payment	1397	1397	1678	1	1	5164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vqdQPbPjtJ72U19iu344op72RJs5GGAJxxYv8HgVpbhg6tq5
8387	payment	1397	1397	1678	1	1	5165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Zfs9eVR38okqj1iCskkmvEk5aoJ1LZ76A5AvW5YJngNr2kcx
8388	payment	1693	1693	252	1	1	557	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZPvSZp88uMQhAoGSAfbNg53pRH3FgknqGroGTDrcKC8caSbCau
8389	payment	1726	1726	1874	1	1	2137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRVYwpGAW6z5KYtRSerBy9svY1pCcGxN2941FcHTVHGXh9Uen
8390	payment	1693	1693	377	1	1	558	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZTxkZ9WBjbjRbFPXU3GBrC3qBqN1gxtm7HBZ2QZUBCfpqQ2rzN
8391	payment	1726	1726	1874	1	1	2138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnSAUFyyZFSB8FbeTmXxStsEB2RqZAFRAxkFiXrvhCTnkqyWM
8392	payment	1693	1693	225	1	1	559	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3XKCkJE92ooybe8ksPuMgHkY6R1csm5GgAW6Kk4zbABceGwHr
8393	payment	1693	1693	560	1	1	560	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZDaqA66sR85TaS3zpimcd1zMwR95QYnhKMWRH8YcavHFr5XFHk
8394	delegation	1946	1946	1480	1	1	0	\N	8571430	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAftYLbXhmhYC8KB8s9rFFiNGHxozoynhdecGvjiLDK2Cdbwpd
8408	payment	1726	1726	1874	1	1	2145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLkw73H5VvmeinmVdypFi8XNYpTMf7RweFXhF3EZ2f4Cpxa1X
8409	payment	1397	1397	1678	1	1	5173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVumAhGU2vFRwbZXDf4TWcyciGDjr9yy4j8ZAqX3dm1qtNhBs
8417	payment	1397	1397	1678	1	1	5177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgd59QG57JqonqcTpJTyzHBAskYtP4BnaCpgHULiQpBGFGmBe
8418	payment	1726	1726	1874	1	1	2149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy1Bfpgfp1QD2KoGSAhkrWp8h3vTK5a9AR9D75f2BgmtyzP11
8425	payment	1397	1397	1678	1	1	5181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBgaSBwZHuiX7qaFHMQjSMrgU5PrisjWWnYa9obXz6spzR3ZR
8426	payment	1726	1726	1874	1	1	2153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvGz3oSMozoEPrbQVeJkMgngjFiTbMwStpvRyPHrkZoJTTMsC
8427	delegation	1933	1933	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7qYoAbdtQngryqg95tSktiUTu7xf7AkERMXP7V8FhxFDqKsd
8434	payment	1726	1726	1874	1	1	2157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwxmp9PrWnCDGwosVruXunJZMJMk8grq3amwkNZPn27vToNJy
8279	payment	1726	1726	1874	1	1	2124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDcUpzxmCxxDJJfUG87JBBDrWHdNe7nb4f9DZy3LAzbeLw2Sg
8280	payment	1397	1397	1678	1	1	5151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaZZ2hf9VKbJ1r3aerHrMYxXTNBXp39EbqVtshKnWDtgQWK9A
8281	payment	1693	1693	105	1	1	479	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZzNNfRpTFsi3Kn5tZ7zmxhQaJm65PDksJBCBTCyctNkqW9HLrH
8282	payment	1693	1693	122	1	1	480	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ5GsV22wVucH3J57ACQY9xpEtm8Sk7GhmjJyHjPaQgyP926eUf
8283	payment	1693	1693	622	1	1	481	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZWQUEUXdtaAGdp6jjKSpUtPTq55bxUWA3zU8u63MAMGjUNocw9
8284	payment	1693	1693	520	1	1	482	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZVMtB1SA4LC53bq5GuNpo5rmWWy9SEoaU1frnnwnswDBG6FArb
8285	payment	1693	1693	551	1	1	483	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZP5MtThnEnKHn5Sjr9RqrknZ4kHdHERnWUh2UV1CUNAw5fLARN
8286	payment	1693	1693	295	1	1	484	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYz8VxgqiYeSuTRrBHpQQ3MoJnrDfCUCfgeDbrc9L1Z2dQDLtyA
8327	payment	55	55	62	1	1	8	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8kCQsxnLERc3T8GjMBsH2HPDoEdPMyp7bhwL6XMHToiUTnmX
8328	payment	55	55	59	1	1	9	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YD6kgVk3RSaCJSmvNiApCDV82rUMaiMnMeHFJR74L1ypmHcD
8344	payment	1693	1693	652	1	1	526	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYn9t7XqS8rbcCmpHRTKujcjxodKnsHudyNgXF2nxaPDjAhE9jP
8345	payment	1693	1693	745	1	1	527	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYSbBqsbEtgZKythHLNiEz9VEvM2GNTDwXXthSxeR9vrxdkcFkF
8346	payment	1693	1693	420	1	1	528	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYtEWuSWebfB1VdqHnvECTxbrUP7KWc5TnWo9tQG2ciDxxoEUqf
8347	payment	1726	1726	1874	1	1	2132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9bAW5SGrz6m5sqkh4BsEj2N5FcCivsGqTx7cH4yY78JNcjhf
8348	payment	1693	1693	353	1	1	529	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZaJBGQRyGAzSXekLaCB8WBCGN7VNprvZW7PKNiuSdhe55QrAjH
8349	payment	1693	1693	266	1	1	530	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYQxZxr9dH8V45EaqXoSgzHSvFQQ2KvDWkZoWgGfJp21j3ZhUqQ
8350	payment	1693	1693	191	1	1	531	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZAMAnV4CcrEUhPyQCcWFUpaeSHTJSoCo4BARzs95fow4Wm2G2M
8351	payment	1397	1397	1678	1	1	5159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMrG3rd1n2rph2w933VJ6MMmnnKKHGVDLiR1zyDaVrr3Vd9DV
8352	payment	1726	1726	1874	1	1	2133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRxUSuHq6km3j8S7kgm2pHkakvTDymPdgBwrj2SaTgmbXkbk8
8353	payment	1693	1693	600	1	1	532	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZtu9v7raa1gypLCzXA3qv3zKcDMdE7FDp2jGMQqcB83athc3zM
8354	payment	1397	1397	1678	1	1	5160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6Tr6g59rbjxM6dMn5FDgpXcjcgGwjHJurpHePeM4S7eQxYC4
8355	payment	1693	1693	352	1	1	533	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3sfLvhkvUy8hxipbRRiQYzVtdMC9D6RgQ3K4RjDjKxNSiu9hq
8356	payment	1693	1693	691	1	1	534	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ6R4JtMbiuY1Fv2S99j4kA98Us4KAjDe5vjgoaXnv1GvSazAKB
8357	payment	1693	1693	245	1	1	535	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYRxzDgoPKnhWKujY4GEnSs7gLjBD9B5ty8jF3KMGkrRYzko5UM
8358	payment	1693	1693	421	1	1	536	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZJEBFnDY2Rgtt5p7pD82tydoxPBBsLVi2qfzkkB4nxU6Rwq1j5
8359	payment	1693	1693	103	1	1	537	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYrXhJL3yz67eVhKuCBTiMb7RHmsj1UFXFVzmUjuYMfEAV7Dv3s
8395	payment	1397	1397	1678	1	1	5166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtuzoavLfLtvStrD54t2nJhYthJZPu8trwxxgmSSUaxa2AHxo
8396	payment	1397	1397	1678	1	1	5167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyy1ewCZXES3QYYTzWsur1e4GfH9Wag2cKWuHSBYC8k2Yt6mmr
8397	payment	1726	1726	1874	1	1	2139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeJ9J8QWS8YgFXYkxZBW6TewE8kGfwLHfcjsD2tBnUUr1VEfr
8398	payment	1397	1397	1678	1	1	5168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcce9KcuJq8snhxspLmmqkZAFbhmBtsueYmi687fAYN8pgCTS
8399	payment	1726	1726	1874	1	1	2140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4iSo6dY11mPpJrbtHTHZqKERKAg4cevfZr8X3q3RriDwD5Yu
8406	payment	1397	1397	1678	1	1	5172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDJGqqojqL9D6RL2wqh31ag81xszKiBVhADghb5dkfWqGU2AT
8407	payment	1726	1726	1874	1	1	2144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnDpgHUJAm2ftdMPuRjUCq9noFeg5gZLYVjxYrB4kw62SGmGL
8412	payment	1726	1726	1874	1	1	2147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcDAYxXG2oQ6DR9DGNCcSBxzDzEQ26z1L1ZggYtPFBdBDEoPf
8413	payment	1397	1397	1678	1	1	5175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymf7TPqYVDZKXp9S4WURzufr8jJGK7ZwTNfGREFBjBmq3Qpg4
8414	payment	1693	1693	1778	1	1	561	1950000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	Ckpa6GTgVe5PQ5uMwsnBJXTdB6hrRRoggdkRGyi4gP3rBjhraCvCb
8444	payment	1726	1726	1874	1	1	2162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKFpDzSoMotH9JNDCJyDh5Lj8dSaztMXLSzpVgdtMDU6jgor7
8445	payment	1397	1397	1678	1	1	5190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHH1pnLzSvkhbE6v41jj1oeWF6roWUGFpnLRMMYD3jdzVHf2ji
8309	payment	1693	1693	408	1	1	499	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYnniUHxWCrW5Uuz7uSJ7CHkQeb7Uyfq8qmVAN1T4Z3omtJ4mFt
8310	payment	1726	1726	1874	1	1	2128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwawcWfgkiALLpZbYQwJdEtjKv3oavAi3K61jnfdYnzgvmneJ
8311	payment	1693	1693	373	1	1	500	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZsnupNknFpBnKdm69vvoCrAeGH7TokCA6fvQC2Dz3kU7gCXstA
8312	payment	1693	1693	322	1	1	501	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZRNJzYfk7F5bwcxa17sZhcDt6tQayTDwHrytez4coPWGcjnWmm
8313	payment	1693	1693	453	1	1	502	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3EXg18Vga3jQHy8KUydCJWYQdo9ebZZFgyvnMi3YwThqKZ7iS
8314	payment	1693	1693	450	1	1	503	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZE1z5EWKipaBaF7fF414tUZQASPdMXULQi8obStHud6PT2u2hc
8315	payment	1693	1693	63	1	1	504	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYmUvwzWKeAezmiqo9xRHuQDC3zWYfnSYdxN2HmueBnKgGemcDW
8316	payment	1726	1726	1874	1	1	2129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvwrp1yxczq2FUo1PqDo1LQcD8Vm9xMtraS1zYm13RRUSiXq1
8317	payment	1693	1693	601	1	1	505	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaG5MuZoUiGfF3k2qwp8bmsJQRhxibz6f2DxsaWfoV263q4tUsK
8318	payment	1693	1693	92	1	1	506	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa27SwPcEbR1LAhQEJK2reVaCzzyARecVfMJArDws3Bv5sfSSib
8319	payment	1693	1693	150	1	1	507	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYucMoEQXfLuJhRjVjhS9MHqReZ1Thds5N2bRd6Nknmy1e2tCfC
8320	payment	1693	1693	309	1	1	508	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYkwCKLxq91D74CSDUNTnfuJ6YEmFJ6BAKcGovdVP8DMggCGk2x
8321	payment	1693	1693	680	1	1	509	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZr7y14VhAXtHefN93eH25VtSv148bsc6ErhhwN4tvQVFFb7fPV
8322	payment	1693	1693	731	1	1	510	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZnY6cMtuqR72PZ9Lafy4b4XJfKCCNqm6592FTMmMRMMeGKSN9K
8323	payment	1693	1693	82	1	1	511	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZPaRF21QrcAMcxSQ3fgBP7a6uhrbVD9AWU9EkKH5y2JTS7CPv9
8324	payment	1693	1693	163	1	1	512	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYu1r17tuN1PP1YUKTtJnXNYzcCXi8KbdXGntB2WjSv52zCFNe9
8325	payment	1693	1693	275	1	1	513	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaHeTXveyGKtnvEbbN82kuPofB64MW2hju1taFjZ69GXgrQscJA
8326	payment	1693	1693	361	1	1	514	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYWNhYS6KH91nezmkTX5De6PMsrmV3oeRHkj2s1JcGrB3EYbtxp
8376	payment	1693	1693	35	1	1	549	18101190052	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXGa7qJMQNvxXhVHvHGTGnyVxNJbaxQAfr5nJwkzcJmmvA67nA
8377	payment	1397	1397	1678	1	1	5163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsJKYUhq6b6XCE8FFWrDuY99VbXUQ2Y53YAcfkgbDSr2z9p5e
8378	payment	1693	1693	49	1	1	550	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa4rRbaeaZaqwAx85SRHkEiPm5GDoq6SCFm5Dffxx8USTVMcku7
8379	payment	1693	1693	570	1	1	551	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZvaUUraut58taKBuxS92e73no47pUNaJEBRv7BP3jFQ7gsh96T
8380	payment	1693	1693	99	1	1	552	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpwyLJ2idE2emk3sWM2b1tZc33jTCUgVxxH4N5V4Cjc3Kabery
8381	payment	1693	1693	569	1	1	553	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ1D8WzvrmCuWJBLwdb8GMApKccPqBwH5zhVc3V7stU9uU4WjjM
8382	payment	1693	1693	894	1	1	554	289263537919	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZtgqLQc3PPXurK7bTbTpRjnUZqD8uGbwr8dnEAWXZ1CAfEZZFB
8383	payment	1726	1726	1874	1	1	2136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gh9GzaKiWNhfzNkFaes4vnjt431RLctetZbetHbEiPe3wMSM
8404	payment	1397	1397	1678	1	1	5171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHeioNFnqLiATAUG65yq5h7ktbHvVHHgAEKskPQhEapiDmNwZ
8405	payment	1726	1726	1874	1	1	2143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThkw2mkZkDQ43M45BBPiVQQABmNiFuF2t4z36Gunm58XAwkoG
8430	payment	1726	1726	1874	1	1	2155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmD2RFvqdi2RfgwGd4dUpgUtDiAk4Msuv2fmnCyvin6nyaHLX
8431	payment	1397	1397	1678	1	1	5183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJBgjH47pU26xsXdQHWWPjLbAXGJftvHJ8pwurqoBn95PUxgM
8462	payment	1397	1397	1678	1	1	5199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9ToPthev1VfBRKvFzTPdnznvSEcAXpWU1pXPymRegiwBX7Cw
8463	payment	1726	1726	1874	1	1	2170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2qr4bRW1Aay6XdcapVKJ9y8MBTwjSNR2HeGRogtNGgy7bHG2
8464	delegation	1899	1899	1899	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3Z9mQXNFypJEo7sanKtcgYMNZC8MdkDJ65sZHim5KW25Escx
8340	payment	1693	1693	690	1	1	522	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpJos2hVQuPvRUEL3trSeAvGsSfkZDHAXf1dgdqFuABAA8UEPz
8341	payment	1693	1693	112	1	1	523	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYaxBzFUkV3Jii1MducAGTXpN4qzHZgTwn1LAK7h4vMRFvkwwfK
8342	payment	1693	1693	180	1	1	524	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ8JKACsUoAPP1NBvkhWnyzJMCPmv5jS2PeZzD1wVidY2gCbKv3
8343	payment	1693	1693	106	1	1	525	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaGipWXNB4tsAXK8xVSpFpiocqeec38Q5n1JzwZJqC9hFVZTGbs
8360	payment	1726	1726	1874	1	1	2134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2fxBYRJsbcYoCPoiifGoVFmAy17miKDFFoJCxN1d2MTqgRBS
8361	payment	1397	1397	1678	1	1	5161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyq4aaFosmhi9RE5xDZ98fsMkKeQCEBMcJTiivfquTeF5RwVC8
8362	payment	1693	1693	217	1	1	538	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZerGcALugKor8Xb82FHCXJ6hnY7uidDeVWP9KKenRHre3Khmtw
8363	payment	1726	1726	1874	1	1	2135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFXYtuwXTuyhtRTuctDMEnKt5v6VCiAaMK1xLJTvK9weRzq7J
8364	payment	1397	1397	1678	1	1	5162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtq6cRdhj5c1ScsgJM891rtBEcV84drhaxEJbGNknXZsgYfuGa
8365	payment	1693	1693	534	1	1	539	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaEjaMbVHyyHiD9mk9A37GqR9SrWUBwoF9eXSJsteSRgkLVw9GX
8366	payment	1693	1693	620	1	1	540	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYmqpP1jnXsqfctWTshha29D1pB7iCEYqvFgPVsXwA8JApBXZXL
8367	payment	1693	1693	54	1	1	541	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYaGeCapVWhLvaBupc8cAT7QwaRcWFhV3DXNE8Vz5mgwsm3nSb6
8368	payment	1693	1693	710	1	1	542	4713851573	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZsB81jy1nMSM1YnUgAvovXiS97ncSXLTpKKkrquGyWqr1yaXiG
8369	payment	1693	1693	499	1	1	543	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZrjoz14SAb8DD78ha1exEeHpZ7xaxgyDMwZjrTLGt68ecUbPqn
8370	payment	1693	1693	663	1	1	544	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZTgEqxmK8tXcyKymnU8UzoPdbS5zj84xGDBkhaTizYu7gtX9zE
8371	payment	1693	1693	1030	1	1	545	849383610375	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYriaqzMbDHP2z5FSSrUcbqznDRuamJTNxNkmP4YjJkSCrsmMgX
8372	payment	1693	1693	320	1	1	546	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZQ6EKgAYbd7uKr6B2kA39n1VnokuUjFTTQMwX97Pex9DKcSons
8373	payment	1693	1693	893	1	1	547	289263537919	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYqZxacK4RbibBPbD24xCQYT9USjqg8KrM3dQDKczqMs3Ewoz9y
8374	payment	1693	1693	251	1	1	548	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaBh6yHeASbCqXh7js5Wbbeo4jPQkq75RTYxnYap5ToCgL5dVkJ
8400	payment	1726	1726	1874	1	1	2141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCwnQLewt4gsMho64NQmv66uw11yW8HsEW6oZC93h9pobWCUZ
8401	payment	1397	1397	1678	1	1	5169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJR9vegTPSSSnx9c9aU5KCQrssAF8GFdRTrjpieQxA3eY1ynJQ
8402	payment	1397	1397	1678	1	1	5170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1dWkAWNfZc5JHtK8WhkSdmzQP5s8B8mrYGQo2CoVVtjgAqG2
8403	payment	1726	1726	1874	1	1	2142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA1aCESQatnSLJLDNicFdMmWLFqPUAetsBtW4TUwNbYxCXd2e
8410	payment	1397	1397	1678	1	1	5174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzEhY2Z6nSoBB2GTKRzi6nJFcnnuuXJUi3PMdB27hUeg8KxgL
8411	payment	1726	1726	1874	1	1	2146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetPkwkKjk68jSuVudXj9wCDSfFkitFVYhBuTDfAZ7gEKASxNE
8415	payment	1726	1726	1874	1	1	2148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFZcttbmUHYP2mTxqTtZyovMyrx7X3pEZ2QyfgubLAx64zEMD
8416	payment	1397	1397	1678	1	1	5176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQmFADkh5prt9srfmCgA3onCPnKWJ3UJjMJvQdMrdsrsto9ab
8419	payment	1397	1397	1678	1	1	5178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySB1cHqNi92YrkejhRP8Wy7JKjRhKfTteZf7vwLFTEAdiAVT3
8420	payment	1726	1726	1874	1	1	2150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZhkiGC6i7craniPeM4EZxnwueR2fLo3GfPHEQUNvvUR7EW1p
8421	payment	1397	1397	1678	1	1	5179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeufbAb2hRwFJ7Q2Yqpf7N8PEdz5xV5xvuJpqtsXowjzZuGd1
8422	payment	1397	1397	1678	1	1	5180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrr5ZQjqapE2n9fxM1r4ZEM3jLA8D2HwM7KygUXgHL9rXBxEM
8423	payment	1726	1726	1874	1	1	2151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJ3fAWKQRZj12w1KJMHaXqwA66MSJRH1BKWdjGd2HPUBLBkJH
8424	payment	1726	1726	1874	1	1	2152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJd511GZQnAqJWxBkFxquLV8yhGRhNS5now5aDTNeV3d3Sq6d
8428	payment	1397	1397	1678	1	1	5182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MDEJKLRtNsXs8LhZeDto3tcmQapHaxKvweU2qEAzWYjHG68G
8429	payment	1726	1726	1874	1	1	2154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UfCbkCU2bpnonM1aN1fEaqpZc93ya32QDFjP4tc2KSqwAQZZ
8432	payment	1397	1397	1678	1	1	5184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkhVRVkGMmYnxHVzzdWySofEaLyA3xg48yP667PsWMRrd28U9
8433	payment	1726	1726	1874	1	1	2156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9t7ducmNLR9fYAWCp3bgC1VQqz3RCqN51A53tBkFnqoGgGjK5
8454	payment	1397	1397	1678	1	1	5195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1DC1cQj6cYnEqyjgEQJ2xRuBEh4EMip6fpPjME5xzRBCzKK8
8435	payment	1397	1397	1678	1	1	5185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUx4YQ8oUNVrduzSE9LdCUvsTkW11Qd5fbD8tircAFqcogLJtt
8436	payment	1397	1397	1678	1	1	5186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZjAmdx35wf2bvHSnMXGKn4keZrazgnuE2qTZz2J3aSdxK9Fm
8437	payment	1726	1726	1874	1	1	2158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UoRNSRnReJ3dLkoKfRZwuVfEyZxZQSwrfnXBEWaUw1VALsZW
8438	payment	1726	1726	1874	1	1	2159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcX4feYTCSeuC6QJCQrEA6dY17ff92QEeYPnorKfxgjw8xRdBD
8439	payment	1726	1726	1874	1	1	2160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKSQLY2HQzcFt1aSro39KuLVHV2Gs3pgCidUnD2qo3K55qQPq
8440	payment	1726	1726	1874	1	1	2161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMPMeqgKupqJ9rPNdmdXYLiaRg2BgB2m37wR9rWYyGTqUwCvQ
8441	payment	1397	1397	1678	1	1	5187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpoTNu6GRrWhGFQ5DSHY2wmBnBm83EWowj7qa6hMVprauJzdy
8442	payment	1397	1397	1678	1	1	5188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijRoRSMzcjmi46NbKmUyrqynFHKn8DjDrLRidtDuTyy7rnR9H
8443	payment	1397	1397	1678	1	1	5189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjjn2zbzNMRMnkXoXdLrah7KZCDU6EuEUMhbYkTLr7BcWsnDL
8446	payment	1397	1397	1678	1	1	5191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANcgvYQnbHsmCNqEmmGJdHx6McXBt9pyFcKpuuFE4bYhKLiYx
8447	payment	1726	1726	1874	1	1	2163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaPnA2uPM1cm9v2rLo9BWjDeF1JECZF3LBwSAvZVbqjxAKKm2
8448	payment	1726	1726	1874	1	1	2164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRt58oNtDzqba7K1bJHLFr3Nv4sjCMQtqk2pTkZwqxkJ4S3Q2i
8449	payment	1726	1726	1874	1	1	2165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqmQpvy6zKyiH4AY5YqhbiRPfH3sP2zX7gxAb1Ecy1TzxLbYV
8450	payment	1726	1726	1874	1	1	2166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1f2NJRVzAX4wrsdNsG857ibSLttRf6XAQkUBa8NULNuJKpJxG
8451	payment	1397	1397	1678	1	1	5192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAz9Z1dtcbXzjjfLGi4AZdnHNZj7ADezpWpKrKftYvyNSjxe7
8452	payment	1397	1397	1678	1	1	5193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJagqVSPtvnuBiiPWfmeSR3PtbMeRN8oSvMvyY7CF8vczQjLq
8453	payment	1397	1397	1678	1	1	5194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoQzktBZNEQ8Qaiu8bfL7rFQHJ3TKgpEm88R6dginHAu1piWG
8455	payment	1726	1726	1874	1	1	2167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZzrA4La3w9513iDum6TgbSmaJfo8fjTNAkmZZQNQcPVNo46w
8456	payment	1397	1397	1678	1	1	5196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt7bDeXupN1HC74nEkWkJNV5eextuGuDucTsNqHRh85rhRq5N
8457	payment	1740	1740	1899	1	1	5	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRPzeHaQwF5JSyvRoUoaDy9fVnfcZSrmuVy4xXzTYw9khEioB
8465	payment	1397	1397	1678	1	1	5200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjsbvQ97JN1McXxpy7XkiJg5KGEsymagki9YUBZhAmWPEJiwz
8466	payment	1726	1726	1874	1	1	2171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6cJ8otDeQygcgPBTVqvrifZTRt4VZcoqvPynD6oCf8RQaS5L
8458	payment	1726	1726	1874	1	1	2168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bX82L3jecxdhiWDwJpP5E8sbokFYgeXJbWG2hfK8wGVPpVNZ
8459	payment	1726	1726	1874	1	1	2169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJufdry5D494FpwYDTUQborMaggA2uM72eDpA2Bxaxx1e1ERbX
8460	payment	1397	1397	1678	1	1	5197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EdY8aNtXHMxP2TsEAJySBfAQBiCZfBnJ6SynkikD919KdPFm
8461	payment	1397	1397	1678	1	1	5198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgUhgrZNnxvHBBf55e2cuycA2tJ7yfqm7YhbSYMNNAScS5s9s
8467	payment	1397	1397	1678	1	1	5201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkRfg1HDHNvqcFHFgNiWsXytQo2V4JTEamvmZaGN9TZhkin5Z
8468	payment	1726	1726	1874	1	1	2172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVHFcEJimeysXAAdJ9deimCw5nqkTY6FXFKjuHK2CmBqjVKum
8469	payment	1397	1397	1678	1	1	5202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZBFHPNmH7fLkuFLMZhT7pw7tqMQpWkT7qp7fmU5t1CVcPSrv
8470	payment	1726	1726	1874	1	1	2173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQf7oxvzTRaRjWaGo48NUXzvTniSfmq9C2UwvxbrWox8HJF8Wk
8471	payment	1726	1726	1874	1	1	2174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhpqdPMzNX8ZoCn2MfGdqFhWbXA2T4CGxeE1fJHbVASgxTxZL
8472	payment	1726	1726	1874	1	1	2175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoUqtBknckoQQVd2NgTU326ixDooibNUboQFv1GDgPPYXZrsU
8473	payment	1397	1397	1678	1	1	5203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUdpVpduCFmmamPsPTBzX3tWxXoxov23Jc1pcWxL4ccmb7xVf
8474	payment	1397	1397	1678	1	1	5204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxLD63f8z8XpA1YSB6teT9um1X236q1ucadANfvFsk4Q26sha
8475	payment	1397	1397	1678	1	1	5205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26bRzvyQpB4UeQMPPtRX8TTceeh9Nb9is8JUdWebq2uX85hP9
8476	payment	1726	1726	1874	1	1	2176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfwyKaeRShfnr7NbPJug7oCvszySCL2A7X2cCdqqb9NvBdcKH
8477	payment	1726	1726	1874	1	1	2177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5bjWXRaJvfXtQo4fNDYeJ4envyyQRJ7ew65TBgFeKJcEEyW4
8478	payment	1397	1397	1678	1	1	5206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLS3ytEnkhQcbCN7trbmutt6KucFs54PJQEePjSHbaHg6AX5gR
8479	payment	1397	1397	1678	1	1	5207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t8QcpMSa2CArJMwXeeYWiwMz8DHWvNSozNNSz27qts7Y1Ajd
8480	payment	1726	1726	1874	1	1	2178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFCpESpHk6MoMeM9xLYYTmN47wtkAPF8QJkeETz1TMhMgP2pc
8481	payment	1726	1726	1874	1	1	2179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgMv7TU93AtWtK2E7KLWEyeDrJUnXJZaPLaATSB7ekw6kNPB1
8482	delegation	1961	1961	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSCLLKL6im4Sgn6JuSqvQmXfShC9UxukhqhJtUeuhoEAdKUgU
8483	payment	1726	1726	1874	1	1	2180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTW4gGUNynC3HXWX1GRPNfeqgaxCcjFrbuacMCPTcXwXkjC1q
8484	payment	1397	1397	1678	1	1	5208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJmeuaKpLBH91tGSsmB7EdNZPSrenPWQsPWBLngWH5uHG2iU2
8485	payment	1397	1397	1678	1	1	5209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUk9vF2GKjGoSMRam3Xxjh6vrdiD7FW3RpmVCi9fAPc1gUdU4
8486	payment	1726	1726	1874	1	1	2181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwns2Qordmxw6CHvCv5PRQ2eMaMB8PYHyhVGDUeeDLbndG5WcZ
8487	payment	1726	1726	1874	1	1	2182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahQ5od9YjXxnw6UBL8ces4tQ29Kj3pPxmCLbgYoBou2FNSTpW
8488	delegation	1962	1962	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXNYgb68D63wEmbN694MFYq69RAgJJMRvDZzU1jt3GGCP7UJ5
8489	payment	1397	1397	1678	1	1	5210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkQNrecMmfpogDJBEM3TJuEyKRtQF312D3nGnXokmLXfsVNwe
8490	payment	1397	1397	1678	1	1	5211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirrZJnzp4PqcHd3GACYEkLHyKvoxDDgt1zWcjqivCSpLFqMb
8491	payment	1397	1397	1678	1	1	5212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpPbwb8NUQGthDPwgEyvC9zLMkkURQwKrfUvVKRPSxNmkPkbo
8492	payment	1726	1726	1874	1	1	2183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6D6UMJNgdofNsdN8jfSJ7tHkeLqegBNnw8D6sr8jPwRpWMGL6
8493	payment	1397	1397	1678	1	1	5213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNnkq9i2WsuvKFyoSV8jVyXQx57R9ig8KRrYivRmnY1q6aVeg
8494	payment	1726	1726	1874	1	1	2184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGYnHMkmmm5bveEcqHPcWZjzNnFQcFjaafTsBXouLGedQSQFs
8495	payment	1397	1397	1678	1	1	5214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17N3sechz9kiwv7iTcaKVatAa1gj7mYkXFDB6QnqSH1RcXmTt
8496	payment	1726	1726	1874	1	1	2185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLm5TrcPu4VpDE2tEssUHAKEGPcVQwwBewzDDiTzgpYQ934ZiF
8497	payment	1726	1726	1874	1	1	2186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPJfzUYufC41Wu2XzuD4Wk5tDgECkm1b3jR3yADGXPmaoe1Wu
8498	payment	1397	1397	1678	1	1	5215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uNeqLn6X1UPqR8uMsLAzzQcX6KchDh253c5L1HcpuSsQEdfj
8499	payment	1397	1397	1678	1	1	5216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvjwNisNCx97uSU6ssR2pWVkGaVCPoefbEx3JuCYmsWbGTkrk
8500	payment	1397	1397	1678	1	1	5217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6t7NuhATWXnqmD3y3QngryuW1sEQW5A2F5yiXs21fdCSRL7Dc
8501	payment	1397	1397	1678	1	1	5218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoj6JKQ7gxD4uVxQ1etHQ3YLYyfo5BKB5RwyWnWqADG8cVxuQh
8502	delegation	1740	1740	1899	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zTm1mprqQWsSHnL31oEU6y5JKb9y6qy6ZPUNEoxHXLMcjAYu
8510	payment	1726	1726	1874	1	1	2192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfU8xL8KBWK8Tm7sQLi33QcvsTq1o9GfnjXHr6jyv57Wu9TFaD
8511	payment	1397	1397	1678	1	1	5221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHX5Va6V71kLQGJYw36xehiQLwqo8KNVfa8YMmPBL8bTBqhNr
8518	payment	1726	1726	1874	1	1	2196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMfxoFhJGrYRMuEaEGBNgCAkExFLGBxyzufke1s2b5C8b5Npx
8519	payment	1397	1397	1678	1	1	5225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTywfSNbYARf3Cfs3cdDqoFks9W3aydXV4m9qPYXUAWotvrJqA
8528	payment	1397	1397	1678	1	1	5229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKcSrGSBqHfYmHjGUsYDFEUEe11nFXzrkFLz1iQBfkyDfJFHV
8529	payment	1726	1726	1874	1	1	2201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDmEhc5DwrLMJCWkjQ9ow5EKEaLzS6vpXXNMJqYuoqHrHCcPc
8534	payment	1397	1397	1678	1	1	5232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGNJJKFWMbxsYbvbhPgByjdvSPWJgrpYkNbdLnKaJGQNMcGHj
8541	payment	1726	1726	1874	1	1	2207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbw6cs2eFLbMFDXRxBFsKMw6dGQvXy5fiigzfVncm2yPnCgpFw
8542	payment	1397	1397	1678	1	1	5236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshQUN94jtmneCwMLTiWwrA2mLRMP8Mm2ZwyBoEaUZfm2XnAyd
8551	payment	1726	1726	1874	1	1	2211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4fZcm95kJZh3AVsU3Qxg1Kio1ar74zskwaNQG57FZzAVevKL
8552	payment	238	238	1474	1	1	2	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQMrSMaf6cZuNCFHNNaKouppL4j4doTDdgMLqzHkd4VK5BDJc
8553	payment	1397	1397	1678	1	1	5240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuhQhugWgaMMEC6NhCN5Lfsi7pWPUyR2vzLf8fLygoyrZmoLx
8561	payment	1726	1726	1874	1	1	2215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkXXCteFpSnF4e2p9Ev6tkb7pqXUiVPCVwgNpdy3xzXK8jEzR
8562	payment	1397	1397	1678	1	1	5245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZUd86HezBGHxCRZq796LgGhDG2bVP6x9fHKPmPHjvLZEcnq6
8563	payment	1726	1726	1874	1	1	2216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fCyqPwfv73UEfHYq2WbrHQmzHL6MbAnKPkM4bd5eGrYsVKBi
8570	payment	1397	1397	1678	1	1	5249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvtGHXKrhDj9BerGwcT3ZfM3moFvc7FhcQVnR3BWHwgUhFAS9
8571	payment	1726	1726	1874	1	1	2220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKJe9B3wLf7c8uFpf8AnyhfahohApm5hzemGAQDxxEuvQiaPj
8572	payment	1864	1864	1932	1	1	0	331990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeg6QQf9JdxJyg4Vhuwe43iQdaiQT3VEX2kmuDgtkXyPBvLcQF
8585	payment	1474	1474	1950	1	1	5	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6Kfq5efMwMCNXABqJdCdmaPPHSkciuuMs7cd7MPjQf24wW42
8586	payment	1726	1726	1874	1	1	2227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBxEh43yfUnbrX5vwpTmT8JTqBJva4wRwwJ9u5GwaovGN8CHM
8587	payment	1726	1726	1970	1	1	2228	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZ96HCy5A4utGVg8w4niHap5t434VSPoS5wYTTQHfhV9rcxj6g
8588	payment	1726	1726	1874	1	1	2229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvzpoQ6Cvt6hb1DzfcVhaMccEi3dSVatyafy5PC5YVSmaVBcU
8589	payment	1726	1726	1934	1	1	2230	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1TfKB3UFrCjk9ghWzQbH1rZkS8yDtwPUWGaia37FT6VewgLAr
8590	payment	1397	1397	1678	1	1	5256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzknhNNrG31xisKAG5Z32igS3K1PvgekE6hwL9neYhYRceQwQ
8591	payment	1397	1397	1678	1	1	5257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmf6UqsVx48FDd3WUFwNNM6A7hFzx7uD9aQgAjcXtcyEkENZ9
8598	payment	1397	1397	1678	1	1	5261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTCaqhzn6QVSig56ZhUQgXUH8g27r5qxE6YRZYLKkRzSiaX6d
8599	payment	1726	1726	1874	1	1	2234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbqVHEfpwixLyGvgdxRaoX7KVLSW28wJogAJXNiUzZ1gkQCkh
8600	payment	1950	1950	1971	1	1	1	200000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpYqg2iS76bAWWxDmkqB4Wb16QdF3KCB823jU3RUG4M5LPSbjAk8
8601	payment	1726	1726	1874	1	1	2235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWRu63HPiFKD67RKssXjedexmVTLmwDpmbATjs8JUAXsvxb5S
8602	payment	1726	1726	1874	1	1	2236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfz2HgiPJ5DxRvwaukaqvLvLPLUjTS16TVHRycBmWrhYxYHv8e
8603	payment	1724	1724	341	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXTw7zpU6aSftvLGHeRbPEs8RTYcvfkjB6jAaQW7JDkZSk4F1
8604	payment	1726	1726	1874	1	1	2237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrHatvx7TfL4orD1qMA6d7tEsxfPWahVzaekgEh8b89Yua9yX
8605	payment	1726	1726	1874	1	1	2238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdhzQzPBcGKC9xuS4rNbsEDSeZEFoE6Ky7s8w9QKfMwemnxY7
8606	payment	1397	1397	1678	1	1	5262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjc5nvwDTipf1wfjdVQQRv38Qne59dvUQuRdKdPe8c7ZuSaUx
8607	payment	1397	1397	1678	1	1	5263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3doSM7hyAAnuxeMVa2GiiDaaMn2XS3bFLoUFieR3FEqmQXmn
8608	payment	1397	1397	1678	1	1	5264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9v6jpRJwQbC9CRokBwDMfZgiFKbYbLmU9wKXtXC2mYRdHoxVi
8503	payment	1726	1726	1874	1	1	2187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXgrumdPTWLhaLY9YqyxVLzsFEzXyWNTzXm2UsBofHi3t2EEa
8504	payment	1726	1726	1874	1	1	2188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fHwvXBKGvKpmEhkXDJ7d56F5KTcW7142Y6zbT8CYT3PKb2iK
8505	payment	1726	1726	1874	1	1	2189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdURiJgLM4R27xHCA9k1uksWWhFVYMuUst942UDSw5Cq3uLTN
8508	payment	1397	1397	1678	1	1	5220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQdn5Qr2jRUA7HbPCBFGzLctYWGSib9Ew3W9ivMhkFqciwVkH
8509	payment	1726	1726	1874	1	1	2191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpEJqiNU72n35gnuts89wCfDK46TjYvntmb5efcr3bBGgsLoi
8514	payment	1397	1397	1678	1	1	5223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZaWG69Cqszrg86KBpTWUxpZKXGoCnC9EQH5u1UJqfrVyPP7x
8515	payment	1726	1726	1874	1	1	2194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KcH4m4PS9yDYyaK3PyEq2urKgdGS54hm7B5smJ3LmmwsuZjN
8520	delegation	1474	1474	1474	1	1	4	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajbqNhte3bUgQZhXxfGyFhEb4H3kQEqdXZuYzJc6GeVSjTKSK
8521	payment	1397	1397	1678	1	1	5226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKQrGsYFSSyuYu1Xiz655q7go15bQVepohh16JJk3LHEVJYcp
8522	payment	1397	1397	1678	1	1	5227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoU8eHSDX8SjmfHJud9aQPZ9eLPBXY2nidRjK5AwRFtbDt8eU3
8523	payment	1726	1726	1874	1	1	2197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6FWrUyWubkf7ojVxvNseTtMKuNBGnMJjR3yMXKRSWKcW3P8t
8524	payment	1726	1726	1874	1	1	2198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNx2XehAPpKXPYjvD2ZeC29AG4L7bYvbjuxFxM6h1R74GsXCS
8525	payment	1726	1726	1874	1	1	2199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2Zusk8a4Eh1noyukrRq1tDQ6AP7yAMmJGvjs847FCpk2DsiY
8530	payment	1397	1397	1678	1	1	5230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNtZRD1huyMxbYyJvYMsaoPtwfJYdHZJ7cd9s53Dgxh4CwcGh
8531	payment	1726	1726	1874	1	1	2202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyTBsqVWCGyU5q8yHbMJoW8MjgmLfLHZE4CgDjpq97qjhmoiL
8539	payment	1397	1397	1678	1	1	5235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX79bccbtRG5ZtABF13ZjX6mm5pUsA3UeB7MW7L6PTzBj2QQzw
8540	payment	1726	1726	1874	1	1	2206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQaynPKcnbeVx8g68coCNqo1G3j5XoXp2aSUssSxDmXErg6Wa
8547	payment	1950	1950	1969	1	1	0	2000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpYb9dvX55zxTYTNChYC1ntkyppS4VSH7ZtEBdfnchJ1k3NHCXFM
8548	delegation	1900	1900	1403	1	1	6	\N	1000000	\N	E4YRKQGMsxHFWhNdFjHrw3JgoLhAdZp43s8AUZh1rDmScUQMQaUjm	CkpYqr312oNggBhvE2uHDsQjoXbhRdNu7iQuvA89y4TWU39LwCkT3
8556	payment	1726	1726	1874	1	1	2213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7pWF9ZtHtSzPGLdLLVWpaZShjYF5jQERahCcvJ31hiwDwpHP
8557	payment	1726	1726	1874	1	1	2214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAgdBq6hxPzEp3uJ21GTSkGvAkYqZDxvsBgBC7bATw6pVe6T3
8558	payment	1397	1397	1678	1	1	5242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvYRbSSBjxuWTLVHma9oRfQvRJMCmDDqt13XnxbPE6CuqgPuP
8559	payment	1397	1397	1678	1	1	5243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fZx58S9S4ZFo8ZinFMAne4TcBtcNmicyfZGSpBRKdZZWCr7E
8573	payment	1726	1726	1874	1	1	2221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPS7KYCfgavyYSNCgNQhFpaJnNj3wze7UgdBWW6vm45zm6D4wL
8574	payment	1397	1397	1678	1	1	5250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMhdB66cdMNaPF4ixLE9mp4opyMz8rsX36tkCdZEpkPcrH4Ts
8575	payment	1397	1397	1678	1	1	5251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtiUoUTkTpRutLwmVy7dZtTqGNJN7bfBNFndLgLpBu78xvxb4
8576	payment	1726	1726	1874	1	1	2222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RqEo3hLRYqFcUr5P54kdAH3f8BH6ZYqaHsgfzwpU8XEeZov2
8592	payment	1726	1726	1874	1	1	2231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgauLaHQjwVybn6fiEeCKL3gJGcu8ARY2VNQ9rfomuKmZ7kxm
8593	payment	1397	1397	1678	1	1	5258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXMsnTbB5AU4b1vtjxDAUBxNy25HEieDydFBc9rWgcptP3HyQ
8610	payment	1726	1726	1874	1	1	2239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8XUqdjRoQf1c8HNeagMTKHJoyPkj7iZWLJiK5vULbCHTdWuc
8611	payment	1397	1397	1678	1	1	5266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5KHcr5DG872k39yrxsHjyb9Ji7EbBWbBCbpycVhmYnMd2BZA
8612	payment	1726	1726	1874	1	1	2240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxNLExnHy1B89UcAqdq9oak8XH1HaGSgm3pF9NAvg6VnzV4ox
8613	payment	1397	1397	1678	1	1	5267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzvoapxhs6HkJxpLs9LXsPbMwVbzrZ9GUyzBHDkRHeukJNKJc
8652	payment	1397	1397	1678	1	1	5286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsNgdxwbZn1T44ktyAZypyVud9WcHhCQuExqw9NQr5hCJS8P4
8653	payment	1726	1726	1972	1	1	2259	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZrX8ozyCKhgoDVqYXLqejHhSgezxeJjPFT9VaVjD5eJrPRmtkS
8654	payment	1397	1397	1678	1	1	5287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2rUBG6FaQNFYBmQVpwGvxHhVsddgekqHtTgX24rp8o8bx4U2
8655	payment	1726	1726	1973	1	1	2260	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEm6cay8ejDUmAWpGcWY7fQH6P14n6ww1YP6vWepLQJ8pP2Yaz
8656	payment	1726	1726	1874	1	1	2261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyM5c82NJz8Q9ca2ohBCNaFaPzLH1MjhaLc6kKG3A7HQPbLbS
8506	payment	1397	1397	1678	1	1	5219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnvxEsXnFEQUKaB4Mf7r87LNZ1o92nqGFeHrkksX5DSfJmaBA
8507	payment	1726	1726	1874	1	1	2190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87H1gYfTUzLN9HLP933cPHXQU55UpmKFgrGFiYEa1sbPg7ZgG
8512	payment	1397	1397	1678	1	1	5222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqbA1wmA9BhxDNCFxkUurY8xkhJwsZ3TzJoa2XEK4x4ArzT7K
8513	payment	1726	1726	1874	1	1	2193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxm2simYGjsahzHg2wwrGquv6bQmsvg9K3C36MKyVEKVTgMvSp
8516	payment	1726	1726	1874	1	1	2195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNNtjmBXwKa4ai1Vgk58qBr2sdxRsvoVdNnGVzHr5asKaWbwz
8517	payment	1397	1397	1678	1	1	5224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DHv2HG6kXVQq8HeKC7fwGb9XmFucYd2KYg5tzFqapnmnDkMQ
8532	payment	1397	1397	1678	1	1	5231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvbshnwwbZ5p3eEU9utKiDYw5NDQX2bwJv2VqZ4qXu6gxx1D1
8533	payment	1726	1726	1874	1	1	2203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M6Sw4g16ummcHBzkTSyvbkWrWHYgoB1TxvviRVn9HBFbdeLa
8537	payment	1397	1397	1678	1	1	5234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nevD7XFH5sCmizxviJqKfnjVpjx8BJsG837eo28jRUmsrFEw
8538	payment	1726	1726	1874	1	1	2205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrz4QAqVQpapV5R1UDBuLXxY2Np5t1qa7sjvn6cKEzfDbKK27
8545	payment	1726	1726	1874	1	1	2209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBcfUDQLGqJZgC7RNgFzUjDLzy1dVEQjEqGw5LpaKqWXwmrx7
8546	payment	1397	1397	1678	1	1	5238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyigWanUEHThPtjD9pUBTNW4GA8zdBreBr21P7dYm1q6Nq4Zux
8549	payment	1397	1397	1678	1	1	5239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiVy6tKD35vSfB4v7oyZs749niuRNZvfbfGKwsnkig1foxNCv
8550	payment	1726	1726	1874	1	1	2210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUKa31z4UTzHRB1Shy2ighgLFZvLSGxoantBXUrSQRhWE3yqV
8564	payment	1726	1726	1874	1	1	2217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sCTyihShmMDH8WSnauUBuraVujijvwngAEfQJJJerhkNQk4n
8565	payment	1397	1397	1678	1	1	5246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodvqsbah7eJ875peJ73ZeHL2aekiU4oqAH7KZgzX9fNnijT35
8581	payment	1397	1397	1678	1	1	5254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvVQ5bw7mbocuNJLtusoTUtEbFwRUyRytBuu3F7CKeQbTA8t1
8582	payment	1726	1726	1874	1	1	2225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWfu1VBRWdGGvU2xWyL3KqvPV4ns8pXkBU6qAqSd6BJPfoqmP
8583	payment	1397	1397	1678	1	1	5255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo81qZcn4mR4nMTvikN96KPpaLrrbzJrH7awrHgyecXtERTuzW
8584	payment	1726	1726	1874	1	1	2226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnyaVKDMu517QmuPuVEJBvRRbKyWibZRjeCwCMMUtksTeJZG2
8626	payment	1397	1397	1678	1	1	5274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcNkzGP5jw6Skf45BSQFf8hZpmkhrm3tn2zTwUHT6oq9jGuAG
8627	payment	1726	1726	1874	1	1	2247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ9eerHTzwnVjN1xjgnh1wcg61TdZKTMCmWA5sbPt2oJZPsMiX
8638	payment	1726	1726	1874	1	1	2253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaASRXEquVh3fiVQ5JGjWBq1zpSepHwjiS1upNNDkWFuMAEwW
8639	payment	1397	1397	1678	1	1	5280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MnH5iSeStxbH4vLfu9iBxhoPoSiSrfvdxnDon9ocWyLeE18Y
8640	payment	1726	1726	1874	1	1	2254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPzp7QYV3EcuRiHPgGXrmGrcXtfZyRLVm8kXKmhYK33AxgmQA
8641	payment	1726	1726	1874	1	1	2255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtr9tgwcTvpX9i1woUsEZkRKLLSohAXvzAkPjvgPzDiSV4ZEXm
8642	payment	1397	1397	1678	1	1	5281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uo3o3GRm5r3MGMhVanaTiC2NuaikVVM73AkqKzT6wcXThg6q
8643	payment	1397	1397	1678	1	1	5282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAPf1buSFjkWDjGtqBvjaiCZRz6LnGBDXzR3ViqgpAS7YpTs
8673	payment	1397	1397	1678	1	1	5296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhqxF1CgFA3gcUZhuHvYiwUHxkPHEeBCxNMdCNUq5SMokfnBa
8674	payment	44	44	27	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvMU4MRrj5C8nxDXhfRi62JW4AnoSwxb3ck7KR6Q1Xvwjyn6K
8690	payment	1726	1726	1874	1	1	2277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZackp4eodbp4mdZJNNKzYYt36RoTPShdnBu4Xd1jF7ZBtQRrr7
8691	payment	1726	1726	1874	1	1	2278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MxBVYbcL31yAWT5TKtpbsTdDAxzasMFE8wCVrbBETn9m1RcY
8692	payment	1397	1397	1678	1	1	5304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhn9PWwaG2M5ce6w8Ef3QMGnhHLrdwZ8aukTQbWWp4NRDjako9
8693	payment	1397	1397	1678	1	1	5305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8VmdgTckiFk9CmEE4VjLSVLj1JC8k1Y1V6mQ8p3dQbzRbpeeF
8696	payment	1726	1726	1874	1	1	2280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhZX7edwdxJM3Ckhv8GuPigWoHtoDWhPXV3Wejqhg3rT5mtAk
8697	payment	1397	1397	1678	1	1	5307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERJHupBoXP1TDdinLGGv9KHsLTs2B14etyTwoWEf9cxrXVb81
8698	payment	1397	1397	1678	1	1	5308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4FkvCZ7YZ88UTP7GRayoTPRevTjVT2aFpaXBuqrccgLSq1w8
8699	payment	1397	1397	1678	1	1	5309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhibPSrY5Qrb1x9Dru6umRYESe7eYSSUgCPVPeYhZKKyLQtu63
8526	payment	1397	1397	1678	1	1	5228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Gag3cBgpuUUWyrDDirErHwbsfouonc8NXN6mZfgib79t8RJV
8527	payment	1726	1726	1874	1	1	2200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkJycgEsUeo1eHdUGfL5Kxdqa1GjJLj8373tTSECv7cBE951r
8535	payment	1397	1397	1678	1	1	5233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhEeixHn4QZgM2Gn7bwawiHt4TrwysqskwfnFj7YzbiYhCrXr
8536	payment	1726	1726	1874	1	1	2204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1F3nS2QcP6TzrGFCYkEhkSpbNvwYYAekGxV12xiNXkhEanan
8543	payment	1726	1726	1874	1	1	2208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzG3s2XgyfF3VQQLanbYV9WMnEUmXv78PBd5dGqKuVvE4Ecgj
8544	payment	1397	1397	1678	1	1	5237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfB1Ni8VmYac1gNuzwcWoFBzbxY7EeXaPDAjdSzs4Nr446ZK9Y
8554	payment	1397	1397	1678	1	1	5241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42pbbPum9iw5cNLTkGiy3XTbgP957aQBpf5Gwobqb1PEfZh19
8555	payment	1726	1726	1874	1	1	2212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQpChTuC3DdhA9YDDjLcbPrzbCS2QLipgTnvbGWeSDatEJBpN
8560	payment	1397	1397	1678	1	1	5244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB53xuJ2CaQbER2u7WfZHGcnjpDVYL3mcgtn1HmhkHxWqZ6iY7
8566	payment	1397	1397	1678	1	1	5247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUs8sPUA85C6hvr5i7UDopSTbbunErHbeKit4ozYUbM9AQJqVW
8567	payment	1726	1726	1874	1	1	2218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFWJC56dyZSz5W1Q9TFgdnRq7Z5KYUP9w3ESkiBxCbWu9G13W
8568	payment	1726	1726	1874	1	1	2219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRY5XvQCee1eo4qDqYYrDeAZX8Ym6gDLMHHM3bxikrGX6Y1xH6
8569	payment	1397	1397	1678	1	1	5248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs1ZzsXb87XPLgidJwtXrvDhc7zN93oPLuSRLnN6ixhXreBMH
8577	payment	1726	1726	1874	1	1	2223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKArRB2FsmctDdQrSBnoufQ6A8cueHi6DwtKjQNhCof77fnFpy
8578	payment	1726	1726	1874	1	1	2224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEiLX26qQCDh4VFKEg2U47sSK539V6mXxXagJTgELurEi9fUG
8579	payment	1397	1397	1678	1	1	5252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpDxMGrwg7QBkA3RdkDXpvXjcNPwhpjyaYjvTNu7p4AiL5MRp
8580	payment	1397	1397	1678	1	1	5253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaEkhLqx4vpjFByzyiUVFJrZfBwuEfmoW5DaW1LQwzsFkpvC7
8594	payment	1726	1726	1874	1	1	2232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHavMEMzcwhxwM7TTrHZ7VXU3YrKaSRECcKUpf2sHnXNDWZww
8595	payment	1397	1397	1678	1	1	5259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4sVrENsX5YZkxG2inDyzkpMPkbaZhZt3WccCEDSdN69LnykU
8596	payment	1397	1397	1678	1	1	5260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjSBBF5fckbjyVMBomFM7PmgpjMRaBmFxBL3zyvSJFukCUQqkF
8597	payment	1726	1726	1874	1	1	2233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsBhC7erQZhTZpj2765a1XaLJRDciiAX1vttYLsUqC7iQv2T5
8614	payment	1726	1726	1874	1	1	2241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuWGjnN9R6j3dXfAy81VsX43s4YzuMcTAfbCnnXjexTSWBkEs
8615	payment	1397	1397	1678	1	1	5268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzM4kFLQJprz5T2i71eHP9AoM98do7Sy4iem3kvS7Lz2Q8WUdh
8616	payment	1397	1397	1678	1	1	5269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqahF5naxJRZsmnMRzH4jxm6t45XantsMsjD52b1Y9T4icDqf
8617	payment	1726	1726	1874	1	1	2242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrva3SfaA3rkCDCMPkrd3dTJTcYyYfewUhAaDsBwzUPU8qwALV
8618	payment	1726	1726	1874	1	1	2243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrTQ8czVyEjDwvWkzezK7hvWxjDaKv1XvWSqPSXf9Q1fJxGkq
8619	payment	1726	1726	1874	1	1	2244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5iZTZqBGNK6ASuZ5znqws4dY4u7xd8WAoXLMCXqsjHsAAZZ8
8620	payment	1726	1726	1874	1	1	2245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBtEGXkg1HCFx8jEVVW7fVqmHUALqnqHx6mhqLnxTfA6oJrta
8621	payment	1397	1397	1678	1	1	5270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTWFnfTY4ftRYkXeC9odQPPHoe94TeAHm6mYccV6SnbUMoLy9
8622	payment	1397	1397	1678	1	1	5271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieAEVXisZ5uY9h9gPGfMRAr9ijn6GRUk29qJrEKsiQuJFmGbQ
8623	payment	1397	1397	1678	1	1	5272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9UCgLPQBEaHgXiQEHRyT7Ymx2bsp6t2dq5MuARccBfjjV18n
8648	payment	1449	1449	1939	1	1	2	700000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87xNsNt2tMyQHKY6ruYZuaGgRaRNkVtXbZnxtb9cQktEyUHiD
8663	payment	1397	1397	1678	1	1	5291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsRfsWz1UKNG11drb54AGn3L4eUYQMTxSCSGcL5Apr3XQgEJH
8664	payment	1726	1726	1874	1	1	2265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiTV4aUBzASoy7HFjfE2zgvw4xHmNY8UEdZUVgxFMoPYMYvtX
8680	payment	1397	1397	1678	1	1	5299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEqJpYL7jhYFDWHexkdJ19Svz65CCSg66kvi5K2DPxxbCv4Jv
8681	payment	1726	1726	1874	1	1	2272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzxQwdfQDKyetYQSh43UjBJhvyzkYifw9jbJNbv8waXLkPWQJ
8688	payment	1397	1397	1678	1	1	5303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2sLBGA43NhJDJ52y6dPUBwnERzNxpo8ZrN9fgTX32NKccVcG
8689	payment	1726	1726	1874	1	1	2276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iM38JZXhbAknLH2hdnvMHStmxm1zF3ZUqbPEz7EzHxUC47Se
8609	payment	1397	1397	1678	1	1	5265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7i47SJk2GHcrhkBoaQjF1W13wzq5PmcUuB6kXhF4iDB2bPNn
8624	payment	1726	1726	1874	1	1	2246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohBUrnDBdhczSPpijkGXg8UsQ4Wmo7xvqQnaD5RHLghsLNmE9
8625	payment	1397	1397	1678	1	1	5273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5ZyrfCv3VYDTaohhBwyQKKiQ48E45s9YoJtuQHjek6x3PeoD
8628	payment	1726	1726	1874	1	1	2248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6K513nQWZinzJHFRCTgRS8PRP1SgyRjTeTxqt5J4cFNgRZmx
8629	payment	1726	1726	1874	1	1	2249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6XCQVDkyikXsSEVmWi9AzQgk1z5QQvG7FKxn1DnaP5Zn4KmE
8630	payment	1397	1397	1678	1	1	5275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4o1hD1tJHBdZYjtP4emzWLkrNVgPdRv5V1BqFqPpG7a7eh945
8631	payment	1397	1397	1678	1	1	5276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACgeHdhQu8txmENR13oYewjkYn3xmPqxd2yV4XebDq9Yx5pMB
8632	payment	1397	1397	1678	1	1	5277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz49XrNRx1xTWYrJ5WuqRhvxtU3EtT8Hxw9F7smN3JqQeEcUKo
8633	payment	1397	1397	1678	1	1	5278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhe1C5H1bZtsTXBVLkdoad2pjmxGHKfpvtAaqcdH2ePhiWmkQ2
8634	payment	1726	1726	1874	1	1	2250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKJqLLnkbNLR5Aubm7qNJfMQYgfpmyN9nZwU6UhYy51STF2y9
8635	payment	1726	1726	1874	1	1	2251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNyvQSf7EUx4TQn847b6keVZitySeG4cxjnahPhSP2sXyUUfq
8636	payment	1726	1726	1874	1	1	2252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbaxXiTQm3whidhVQa6kjRJ13Yn1uyHVCKNr6VnG4rbZ6mCyp
8637	payment	1397	1397	1678	1	1	5279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAakae1TZnGxqnJS6eawrcfPwRApGJaZ2xPbT81VdpjjxUdyW
8644	payment	1397	1397	1678	1	1	5283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCtmBPoJ9hnPBAYiGHbHBoKokF9khVY4Ndwcxh1VeFocSkAhZ
8645	payment	1397	1397	1678	1	1	5284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxmDRxC6ge7NaNbTNAAbQNpqgakszWpzMdnywE9NQPVNsvCch
8646	payment	1726	1726	1874	1	1	2256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk9LzkTb8qTDWnQY7C3jQcBbkxRx4m7Xj89n2eSASoxF1HtkF
8647	payment	1726	1726	1874	1	1	2257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkxtJ3LKxNw3Jk3mCu3YSyhyRcPwe84GzmNFjDZKbo72jStDh
8649	delegation	1939	1939	1449	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVXcntui9sxdcBFpuVWEsaPu48Ke93QGQchuKnTjtzN1MWp6U
8650	payment	1397	1397	1678	1	1	5285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeVse1QmKUtxRpRKvztdDRMWzrJm2sb4mQgs85fRD7L1M8Gob
8651	payment	1726	1726	1874	1	1	2258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4G4eunAZcn1P3EanYyiZWUMDNGDPATsAss4PweU54nhkXJjvc
8659	payment	1397	1397	1678	1	1	5289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqxJVJMZEQSpohTUdmzG2m9cCqMaqFwKQKPGfPSffeq5m9Ef5
8660	payment	1397	1397	1678	1	1	5290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjYMSsbNBUtWAAEQtsb4XgmtDD3LyUMPXiLj7ohnC21o4HE6e
8661	payment	1726	1726	1874	1	1	2263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmT15oYuwwCqTnAB9Hc3vP3DqhPm3FxQSfdduK6Q66f5PFg8kF
8662	payment	1726	1726	1874	1	1	2264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUP8Lbzm6AEdHsApfN5vvfNW11WEdjxG3axro3JWujSZswoqpk
8669	payment	1397	1397	1678	1	1	5294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaq6ytxUF6QGeQxG5UUi3MJPvdkAVHmsJ3NwzZFQAB6jEr1V
8670	payment	1726	1726	1874	1	1	2268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqrqyrxw9iZzMpFL5VmjspuaoiMDxLurkQCjWgCn5ucRfZfnk
8671	payment	1397	1397	1678	1	1	5295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3WG7dBgSh2sAYWNHnzNbNqwNoQztwucvziEqSM78c3zVAyci
8672	payment	1726	1726	1874	1	1	2269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3twAnGUWbqjNiWRG3U7WW7u3ZU4jbUbc4QWiU6Ge8ZeNP6UH
8675	payment	1397	1397	1678	1	1	5297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWirQKuz6A1kSiRb2QcJpPCQncS2iZUF3wCB61VFyZdGPp4UGC
8676	payment	1726	1726	1874	1	1	2270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnCa8C3dghqCyCBQ39wWHynk9VrMZxVGArfoK2FvokQmN32S5
8677	payment	1726	1726	1874	1	1	2271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1oJ7Rrn43eTmfRf8EwezfV8SjE6gvZDuFsumyYFTYs2Yd7cc
8678	payment	1397	1397	1678	1	1	5298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFLhEu84h3TNFt6AhpHdMSHdDbU9GKV2q3NGoRx7MtSrUyTcK
8679	delegation	563	563	1899	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JuAumhzrbS3ETsRRgN7uGBJKFAS2DjkwdkFH7fiPnCozNcTy
8686	payment	1397	1397	1678	1	1	5302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsSLMXGoZZs7a6WU8BgVmPABpVi7qfdJpeaKPZxXhJnM4yPd3Z
8694	payment	1726	1726	1874	1	1	2279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtFEcojsv33QBTM9Yc3JFXEcYbNuJEDNdw9YN7H6fWYvCaLKX
8695	payment	1397	1397	1678	1	1	5306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj4ngxxrLoaLwSnL5gJm8RXU8A8L3W37JDD8wt18f1Rrqbv7o
8703	payment	498	498	1956	1	1	0	2000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPV5oKWXPt6CZ7y4GS4QTTF6gzx4o2Yk8C97HVT9NNMJ4jrfR
8704	payment	1397	1397	1678	1	1	5310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TN35ZPMxtEHaTr14XTB46r5wNT5oPPEmHAYJSTRpwLMfQQSy
8657	payment	1726	1726	1874	1	1	2262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirnyrYBHCjJ3A8gWXXyDu77zuf8NwuXbZ2GKnembKuwiB1tx9
8658	payment	1397	1397	1678	1	1	5288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcs9T1SV2Gzvizhns67R6ZapDXbWAqVLoaZSSdJJQEHsdXbxHg
8665	payment	1397	1397	1678	1	1	5292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScc6r9pQw8638jXY3SyXbJcgKzqX3N8eFW5MFCsJokDUnv4y1
8666	payment	1726	1726	1874	1	1	2266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jW9pJaRGELjA1gkgCvJRLDTniUBQmN5VGjWtjf2rNexMhZno
8667	payment	1726	1726	1874	1	1	2267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoG4Y1B5gvvR2Hbgwtkxrjd41yyEMx95Nu1AX5D2q8wQkJjWZ
8668	payment	1397	1397	1678	1	1	5293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YJior8jSPLi4Yyh8EEouP9h7WGik3UqWx9KYNXAcDB1tsrqs
8682	payment	1726	1726	1874	1	1	2273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWeK69jtmJihfHpJUApNqsP5AFgtu1ewNgeBKPZcskruSsT55
8683	payment	1397	1397	1678	1	1	5300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAv6s1Bqjdt6msaAJKdyrPPuD3G1YpyvxXXu9zNdyFnZEevzJD
8684	payment	1726	1726	1874	1	1	2274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFkBKKhi58UDAdjQfRTH8pGj4bfuqHzcCy2NgD2ZNVfHNTdZ8
8685	payment	1397	1397	1678	1	1	5301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRWaMRv9iZJ3x28qyCWSZUGdtfmvPDxj3iCnqrao4FmSLqRfa
8687	payment	1726	1726	1874	1	1	2275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvgud5YYDQaxqRFUrypa23NHF9rwxhbqBQd7L9D46eovhjZY2
8708	payment	1397	1397	1678	1	1	5312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS25bCRxFxfQMy2ijmc1nmsjumVPcRZJxUPpJ2RAy6tQNoMXS
8709	payment	1397	1397	1678	1	1	5313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehxUV6UqBbjnNtwmVQhHYR5EjmpYFxt5E5GPb2UkzV7CbNHNA
8710	payment	1726	1726	1874	1	1	2285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28DB2Q5CCo5sCZVjHmo65uN8PeB21jXsBFJ78HpZMkbBVH2d4
8711	payment	1726	1726	1874	1	1	2286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjeMwXkYhQZYPCRF9tgpDtj4Bh7e5Xweb5sVg1TC2A7KaUsdV
8720	payment	1397	1397	1678	1	1	5317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EYGFP1PNJJCNZjwPwpkYnGwEoNYSaiSJzaxjbEF8cmQhkesQ
8721	payment	1726	1726	1874	1	1	2292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnirFbAmsUzdEqtKcN7HGrfZiU5vSegSRQbpfi6ytZSktLLbdu
8742	delegation	724	724	1956	1	1	3	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQej7F8tqDcfYSgxwofC6CvVhNR43j7LL92mewgCujxqEaD4JJ
8743	payment	1726	1726	1874	1	1	2302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWokADmogi6htoaz32mZ8Fp97xRMX8G1MHusJ5sXVdBd2bWtGi
8744	payment	1397	1397	1678	1	1	5327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5xntE8QwSF7H59jeUf6oC1D4hdYyAxPSeLtjNJ9KB5TEGnDX
8745	payment	1397	1397	1678	1	1	5328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQco5YmKEcDtW7RTwrngmDRxZZGudLdvpxMzExJLXMuqt8pM6i
8746	payment	1726	1726	1874	1	1	2303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz5ZWqZdzXmvr2A7KsaqNA91M1L5ya8xeRtkbt9kxdrfdyidX
8747	payment	1726	1726	1874	1	1	2304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTihYTbiSpPQjuhwxnppc35BVfZWANjcPYpQUsHTrtZS7L9ebK
8748	payment	1397	1397	1678	1	1	5329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3KN2oGUd5QDUoaKqPCtZaneqyDhwczBEfvDBYTsgpEc83Y3u
8753	payment	1726	1726	1874	1	1	2307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9L55hkjVxqyCYVvGz5Ss7zTKELcs28M5dkYGxY5nFJnTJUfE
8754	payment	1397	1397	1678	1	1	5332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAC7V2vtkNL2vt96SWiytbcx7u1Q9Qynp5WGveSxwHEJ48rfw
8755	delegation	498	498	1956	1	1	1	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTjsKEnhu6q42JqWBY2QViVKARZBMZ8wQw3wUahTbzxjGcAd3
8756	payment	1726	1726	1874	1	1	2308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodj9WDnZNCW6FbcDq7eEJfFytBvPkvywrszrfA4ZCDAs253U3
8757	payment	1397	1397	1678	1	1	5333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbVHBq7miuDjhTMe1jaAPn6cZR34TkQrR1v3KMQaYweB94dbr
8801	payment	1726	1726	1874	1	1	2326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPUw6uwud9CEzQj9pUvdRvXSdzXDgSNmHcVSTfH2LhcXK1iV8
8802	payment	1397	1397	1678	1	1	5352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXc8xirHp4SDVsqyoXnB51xdh4a28bd9akX6Ln9DJP1PhviK2
8811	payment	1726	1726	1874	1	1	2329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBtwg5cLax4RQQt5MYFGCNpDKhVYuwDDXqXSczhSxL78opApJ
8812	payment	1726	1726	1874	1	1	2330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKdQkfo9Cz1rCqQn5AZjZSMmvHPbhxojsnYXeUEKh4Z1t4Xmg
8813	payment	1397	1397	1678	1	1	5356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TQd4AFNHrFvkprzm6Qrxye2jLSLtpE21muQR9T8gHixRvnSX
8814	payment	1397	1397	1678	1	1	5357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15VYXwQ3hg5zvnmot9e9wZTARUP1TVdiTQSWjEqXHui7aMZC9
8819	payment	1397	1397	1678	1	1	5360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCdH7rBxAjfr67SherD4erQGhDZURjhf7qEZw1KmfJJguF3dn
8820	payment	1726	1726	1874	1	1	2333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4LgUerK4aQoHFn2kqBnGs2632Dn5Pj67KHy47WYyMsxfTGvK
8834	payment	1726	1726	1874	1	1	2340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6vWQwF9aQZnUbc3nqdXNoA8geyA9ganbd89j7XUwJMHTEeYs
8700	payment	1726	1726	1874	1	1	2281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FHQUbfcPTquAeTcMwKwcTY42FXvmt35pznVv2eyRHg5zBDXz
8701	payment	1726	1726	1874	1	1	2282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDsJ8k8Ltk6m5apYpLgY1vczv63m96w26B94B14wNYBhYsDXd
8702	payment	44	44	9	1	1	1	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNSnHSyMp2NkMnSSuHwDaNXcvTfCncwitJg2vzfUYbmCzw3z4
8718	payment	1397	1397	1678	1	1	5316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzNfRfkS2YyqZKeyydqzyQdWo5eaiTyZwqkKCamDTcYrbWzUW
8719	payment	1726	1726	1874	1	1	2291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS255iqHVevW1tqGShJNDgKXt3yxuw3v6Nosa9LeWzgvwhRFN
8722	delegation	528	528	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuUbsnneZZQPF6cQbmgVmsXFpcsabceSy4EPqy2cFpB8pojd9
8723	payment	1726	1726	1874	1	1	2293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFZ4hLtqAdTC7TQQphR1A1DLeKVCKcxwpbYqs2Eq5oii8VaUo
8724	payment	1726	1726	1874	1	1	2294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuYUcXorh1aKFLYjxLFuWWmmsymwGQCfKnEBmJZrqUNj2mHZv
8725	payment	1726	1726	1874	1	1	2295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ADNT6FvZaNoQidHgLr5fuMEMPKJcCzoC4H4K6ApjX63FRtYY
8726	payment	1397	1397	1678	1	1	5318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqsU85sfKjrGkp4EC7L285XaXjZYBL2usADpJnNvgpYWZHLtV
8727	payment	1397	1397	1678	1	1	5319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd78GG8DD4saXJVkFwPYW6YHPqVDTbQvVwgrceT537W1pZxoRv
8728	payment	1397	1397	1678	1	1	5320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jhZkCx6L4XgQeKkx8JFJmHZZc8wi3tEXcWwxEa6TAfubsaxB
8729	payment	1726	1726	1874	1	1	2296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztS7FvsWXQFkBsXJ3CnvizjBESr9nyS1tvQeFE53S2pMvzUyx
8730	payment	1397	1397	1678	1	1	5321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmTMDhkSkfs7gotXfvSrT43NNLdsbioq4dWT4GYzi9zQFyc4U
8735	payment	1726	1726	1874	1	1	2299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozcKKtbgVpCftoNU6xeSt9zEzWrLSrjjyUaBgva6hE5Jt8Cy6
8736	payment	1397	1397	1678	1	1	5324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6W4g8qJncgGPY9688cE7yXBYzbTmZFPiK56tqrD1xRpARb2oj
8737	payment	1726	1726	1874	1	1	2300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7Jei1qZLDtL5dGd8sJJfGfBuZmXYi4nKLMgM1bc4tSQG26jK
8738	payment	1397	1397	1678	1	1	5325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVH9BHLhqhyZKAWhgGvMJG2yxLaHzZy4iCqP81yzdZuYsaNXLA
8762	payment	1726	1726	1874	1	1	2311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MAdBmxCYX7Yy5eqGELGKLgA5MktcaDCV3hfh7c2w7m6TSUju
8763	payment	1397	1397	1678	1	1	5336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNaPh2qS48foFJED3mvQKbJaNmCGhLcaSmaP6mjW7js6f1KzL
8764	payment	1397	1397	1678	1	1	5337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifbeQtnTTKSvJpYz8LtjbfySdqmLiBVwJL56VaGZHVrQorxro
8769	payment	1726	1726	1874	1	1	2314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDVjuEsqRa2S1RrnbQFZzn5XpQ2mgyHAvUReLv244JUKA6ARA
8770	payment	1397	1397	1678	1	1	5340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLp3tAe1CEuVRpZArAGYzMvPpYjNgSPatSvnPD5gy8M4ZDuuP
8771	payment	1397	1397	1678	1	1	5341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVAesUMRF9oCagHbsde9YFaCfHZ7vLN2CMMGUzLnt8fEfGp2d
8772	payment	1726	1726	1874	1	1	2315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoREMpaAumJJGS6ZaPMhW4bGzJe2x8krWnSubC2csFJpQbvvJy
8779	payment	1397	1397	1678	1	1	5344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uer5EXmrdrbKSDBHzrP276FGJSfcfzRJTRB5zYUP7xXDHuQm
8780	payment	1397	1397	1678	1	1	5345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5yKyzaR1DCQctFXMw2UShGxx3KF1r6MHPET1fqSHBYCsVjaZ
8781	payment	1726	1726	1874	1	1	2318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6jU4kubPt863TbsZ6EjVmimzCj3mzbMv5pZpGqCHZXkSmHoo
8782	payment	1726	1726	1874	1	1	2319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjHP5rcjik2L7ozkCr8Jwv457GdmZmhDsq9TcY6dTJCCWcTzu
8783	delegation	9	9	44	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbo5UFoRdWBF6JVCuP7YLiSydk5kn9xgXnjagRn31xsJsfKRP
8791	payment	1670	1670	1036	1	1	2	5157000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxqihjuipiim3DM8Y771b6DHGaM1hs6WsbNM8R3vpYRDBixAf
8792	payment	1726	1726	1874	1	1	2322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaAMjkJTEvWFCFGsqx1UHZTw8k4bjGdt1Szh82e1vc4PnYygQ
8793	payment	1726	1726	1874	1	1	2323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6eXqp3YPj1xzfnechnuPqSgzWY9EHFuYNhPiPx8pqmkiGzZ4n
8794	payment	1397	1397	1678	1	1	5348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQpW2cqUcjqM35KB9fF9GLRZc9785U1uXY4t9vbQs8Stu3gCX
8795	payment	1397	1397	1678	1	1	5349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7XSgHBL1ajn6ck67cu9aaD4M9d9ZMMBQw3e46PifLvte2oi8
8803	payment	1670	1670	916	1	1	4	2878000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6w9TGYYTxB3hfvu9dzMQXTtKupwQLWPoBy7e6hxvjWtkUSUWJ
8804	payment	1397	1397	1678	1	1	5353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxh2WWZY38VC5R5jLMR566GcyoseMNSoxhFgQ4YbXdoyBjexC
8805	payment	1726	1726	1874	1	1	2327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3SxbTQcwY6Ja6uSAafccDSzCBStoUz8z2dSx5tbUeNFR8RQn
8705	payment	1726	1726	1874	1	1	2283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwVFJTk8JHvAHgoewNSPfdbWYDLN2JZE2VadsF2ioLd4qJ1ar
8706	payment	1726	1726	1874	1	1	2284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mt6HM9sxCtShum3t2Sdjf2rMWXsGcWAdESu7oZ5NYRf732mr
8707	payment	1397	1397	1678	1	1	5311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFPj76P9pLDQxejtaYLuz5iCUw8AyzptXYvRnH35jh9KA2eFt
8731	payment	1397	1397	1678	1	1	5322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJWC3B77mCBKB38sTRwGatNrcMG4nRt1H6hgRQSG1eqk43YQo
8732	payment	1726	1726	1874	1	1	2297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikG1JKwQngAVbxTysUGeF2anPTLiPM3rZGhQ7smbZ5eRBXaPg
8739	payment	724	724	1956	1	1	2	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRqxB5DAv6oB32tV9nBwaomLXZATkHwrUV6AeGsiFUghvsFyx
8740	payment	1397	1397	1678	1	1	5326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fE4C5zFzuyFF665WyuQjgF8i6N1AVucWtYmt3YT7o5Zt1mGZ
8741	payment	1726	1726	1874	1	1	2301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVx9Cu9DHpYdw65Unc4m1bCcehik2dQNGcCJanefvSQMCDfmy
8749	payment	1726	1726	1874	1	1	2305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SoPVSTqUSEgQ4RAk1ayNr8X6U63JsBqC3VNPcMfhguCbTv4J
8750	payment	1726	1726	1874	1	1	2306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Fkupz9K3FJYWyGZBy227mDzDuqqgEzrUoAhkeGuitz8ZGYSo
8751	payment	1397	1397	1678	1	1	5330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjNrh6q83HLsn5t5PsLAcTDciSsqr4RkDhUBhpRn3dAk7aHcY
8752	payment	1397	1397	1678	1	1	5331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7648eM6fQn39yNQTN9KbDdXaRWQjqkQRrsoG33yVpYjSM5iY
8765	payment	1397	1397	1678	1	1	5338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP71cWeWan933gJ4j4sbR6qRAozoHmVytoCCd1kB9JqfmJwTXo
8766	payment	1726	1726	1874	1	1	2312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVVdJWx3xVKGQUtfNMwPeLP5SS5oWHuevHv77P142vBRyT4dd
8767	payment	1397	1397	1678	1	1	5339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zjuV93J6FFD8E3QTdipKu7mSKsaPDEvc9czvYdUFw8WsZEMN
8768	payment	1726	1726	1874	1	1	2313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9Qb4yeee5RvDb4yFEbZ7s3tSySQshMjLpgWYd8WY2zha4rcf
8773	payment	1670	1670	1977	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qReLmGpRoLnHGnK4ptpK4itZPiexQwBXU6KtyfuxoHh65dax
8774	payment	1726	1726	1874	1	1	2316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uooEKRXti3hxBGAeJjU6raCbJjSkH5hZMt9ombJByLs7pYBJ
8775	payment	411	411	1950	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWQUV7xd5UQjktZTuntVCUcMuGcAp8Sr3HJKdLc1NLgtsbxaQ
8776	payment	1397	1397	1678	1	1	5342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkEQCYzheiM4WWpXbxaNvk6bTUWDiBSm6xwQNSLsqK8HcNGVk
8777	payment	1397	1397	1678	1	1	5343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxtZtzeCKxnsiMgQyB5KH5UcHzHH3JD8XJ5NyHE7JUBdWL65P
8778	payment	1726	1726	1874	1	1	2317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBoasxA6DDZ61xQysW1na4zgAgBkKmxqCV6mri7WcNAJE27a8
8789	payment	1397	1397	1678	1	1	5347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmRhQAmmeznzRowCZLVBFoX7fWueJ6CTUxTrH8UgmbWruFF3g
8790	payment	1726	1726	1874	1	1	2321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsenzQvUeiPtiVREqrweMgts9qEtouK64jcQifoj5zY6Sc7fMC
8806	payment	1670	1670	1977	1	1	5	1109000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYowsh3LzFN4TQ5HSgqcszjauELaSFDeB9n1hurWKueGUiTZTus
8807	payment	1950	1950	1971	1	1	2	228570000000	100000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZtNmXaUZVJXFzCKBvdBrWM3hrdrk6irKWgQ3kQ2n16H8J122tT
8808	payment	1397	1397	1678	1	1	5354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmPU1h694mqmnVgAN1DGaBLMfe1ffVgr4vVqj1rfNongQL8kc
8809	payment	1397	1397	1678	1	1	5355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyNTvZq8iFpchtj5oeceWqWMExinNhqQAimF3Mty1FyFbDkit
8810	payment	1726	1726	1874	1	1	2328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CcVZVsxQheD3786UUdvWxVsY6YqWqqtBErgu9QJwzpPadZUD
8817	payment	1397	1397	1678	1	1	5359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntkvPuHwGmkVot85XFmQcmgEPWKgSBNqkLS4D3ZKibNmKi5KU
8818	payment	1726	1726	1874	1	1	2332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3d3DHPfnH8um4J9sDAp9KVhSiLPVJANscnCWRk4YwnfVR5ki
8821	payment	1397	1397	1678	1	1	5361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoDqyjDmG3CPac3SfqzJYopmcMzNkirNbrSUDrg9PwkQPmJGV
8822	payment	1397	1397	1678	1	1	5362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg94cSksMVUKjzPmisDiqS8kEnABegzSitgGwtSDQkTq6rxsp9
8823	payment	1726	1726	1874	1	1	2334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSxt9HRt43E2wzwxE8QrxUuLYzouxJiXgrAC351cfxj1KT1Uf
8824	payment	1726	1726	1874	1	1	2335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyUagycJ7NoCxTK7o3QyQEh4QRxz8a6yQEvYmvPnkVJvZzzSM
8830	payment	1397	1397	1678	1	1	5366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6WQ3MnW3LJEhW141jox495HNhWnkuuqMDQcXFMG1QdxFhzMh
8831	payment	1397	1397	1678	1	1	5367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xQ3W9Q4tPhmm2P6CZ5XZQSBVM5WTxfVpfA1dc5kUN5PBVivD
8832	payment	1726	1726	1874	1	1	2338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFQtSir9222NCYJxsAsbcTMvophzPanjHd8ihDJrrWoASUkzr
8712	payment	1397	1397	1678	1	1	5314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRyiRHo2gVPNSpWbzgqegQWbC2i4X9MkbcTG53MuA1tqezq2d
8713	payment	1726	1726	1874	1	1	2287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4rH95sv64FcaH5RSx1GpBugrosfBwwMxDqi8iUgQc1GAjiZe
8714	payment	1726	1726	1974	1	1	2288	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6MVx8ngqt4aJ9vyyKsAT4zbHYKhzjFPotQv3UAK2AteMC1vPj
8715	payment	1726	1726	1975	1	1	2289	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYe3YgQZnkpVBJCgfe8QMZYwD65Baayxvq3A1ANKE4ogGYGnVPg
8716	payment	1397	1397	1678	1	1	5315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYL4f9pJ1VC553BsLeKy5H92LoAmiTVK4YH8MctJYw1aCK6EX
8717	payment	1726	1726	1874	1	1	2290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoswNT7J3ggCb2U2FX1oT31EKn4oBaLnCHTMXt2z2ivfBUwobj
8733	payment	1726	1726	1976	1	1	2298	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7nEMfHmhhM9CsZ6wE5VfbXBYPCP291ymeyWvJfsE6rwBRDVT8
8734	payment	1397	1397	1678	1	1	5323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBU9xseosib3dpgR6ByP4HqRHY5gBZhnGhf8ugVBa2noX2zFF
8758	payment	1726	1726	1874	1	1	2309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVeSjzhtf4bPzacscpCJwR4jt3LrwoxjG3VowWHZ7UZuA3vrF
8759	payment	1397	1397	1678	1	1	5334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPNMmUWXEP88pxedEB9aVZEUnBN5FThwX9jN4Vj5JrLLMJMaY
8760	payment	1726	1726	1874	1	1	2310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Tu2Ng1emkK8bzMQpd2LJd2ZPLDceDhQqBf6fhS6Mdf7PBv76
8761	payment	1397	1397	1678	1	1	5335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKauwJKtzuA2jCpx6acZ76tEvaLwQLULnbZYLn1dRpW2JXFkS
8784	payment	1670	1670	1282	1	1	1	9694000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKTg1ckGRWub1P8qzcSAC6h77tkSXDHBQ27yqCq21j3sCNRmF
8785	payment	411	411	1950	1	1	1	300000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkrBkKvrCgJBr8ohpWbebZBNhUBd1bC5zQQQdNDuYXibZk5Au
8786	payment	1397	1397	1678	1	1	5346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqrA8g7897T3R7n1MvKnCPBv122PXpzvShMo5E3mMu61KnPKM
8787	payment	1726	1726	1874	1	1	2320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTEUtjGt5sSXbrtq6sDWyfTKtAjmaAjmoy8J9Rt6c7ABjzmD8
8788	payment	9	9	1474	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL9AMmWL67ETsytqq86af7y4NnAJqcRgC6bp7fjEJAc9f6Z6j
8796	payment	1670	1670	1156	1	1	3	3480000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyibyhhmecD6eaMCMWzGqSXnBN3LZDJxZkzMYwc95QTJLFp4BL
8797	payment	1397	1397	1678	1	1	5350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfX6gEALECSiJGXBsGavzmhJKqHq4D38R4zG3UvQBtvCo8cgh
8798	payment	1397	1397	1678	1	1	5351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUAmGzxovi62g18VEwManAw5aV8kgdVPNCzeDCkitQtvMak1J2
8799	payment	1726	1726	1874	1	1	2324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuxFsQFvfDXmxrjtyensjxJMEvqcaiFCkc2iptGyooDtU4wmY
8800	payment	1726	1726	1874	1	1	2325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKvDWiuQfds3fjPTTWLGPEsZ5m6DHTAt1x1CMdqPtZFL26C5d
8815	payment	1726	1726	1874	1	1	2331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHqnDRDDemy6fQYUvU6brjkfGLCTLHiJ7veG7ESKAD5XEb5iq
8816	payment	1397	1397	1678	1	1	5358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpAqgxv51h3CJsCnxRoV1hczni5QiaFYN3fG1ZR8nnR6sHNNc
8825	payment	1397	1397	1678	1	1	5363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wcsnRQ5nJCp4u6t9M91eTQYeGYiPA38vHAHuVpfvymeh3ioP
8826	payment	1726	1726	1874	1	1	2336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94oHLAtY4gWDaPoPrFYPuKPxCisBn5HmtacAPhd2YKFQxKEb8
8838	payment	1397	1397	1678	1	1	5370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT1yo4otqVpArG8HT49RfM75Fxfq1Tv4d4rm2VyMuQiHym27d
8839	payment	1726	1726	1874	1	1	2342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtBUUHvSNK96En2y6wxtZ9eHLjTQMfRbpFuM1xkRxm6PT6Tu6
8880	payment	1950	1950	1950	1	1	3	600000000000	10000000	\N	E4YaTnTqqzfkFWbMz8sCXmEyT5z4BoxNMWi6eJx8pNiXNuL2un8td	CkpYbMzrrz8Wv6y3tkGESNVdgGSPNL3kzSoHXhkjeWxtbJwWi5huV
8881	payment	1726	1726	1874	1	1	2361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWW9WERwpuBxdK6VHAMaqQDhvavA1zgmAgbVe6kjQZ2LydaJX
8882	payment	1397	1397	1678	1	1	5389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8Q5rsqqNthgnMgk6999ecJGCzadhAFhSwCPhTwajwBmisUfp
8883	payment	1397	1397	1678	1	1	5390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3htEg3M2zHca3F3rtvJ6SW63vDLunW5EipadtByiAn7MNdhR
8884	payment	1726	1726	1874	1	1	2362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgc33W3rV8bbrkotriNd58QzoCPKxcEhEL3wj6KJTUVHrQr8D1
8885	payment	1397	1397	1678	1	1	5391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27gMjTW5CBp6EaqADuVzxDX4iPDSxsh6U3PPrd4PWS4fWHtuH
8890	payment	1726	1726	1874	1	1	2365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuHZC8WAoKmPb8U6JyTksYRCz3JMrj1VHfhc5dd5uXNPrTPAV
8891	payment	1397	1397	1678	1	1	5394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jMqRBz1qMeDYD3aVsTJ4eRFm24Xu7fSRLbPoQiftzPUpv6bG
8898	payment	1726	1726	1874	1	1	2369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqkxLYzQ4GfLfSPQMBmYZk6UECeoTaFLNF8Jvjs9U7sHosAHb
8899	payment	1397	1397	1678	1	1	5398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmFo74cv4Dm3wPBSEzkXCBH8WPdPAB8ur746nkzPceWbS9QJN
8827	payment	1397	1397	1678	1	1	5364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCQDQWs6YQFoW1sqJdrovBWmgv9tycjXGXugbfoZK47j3Fwou
8828	payment	1726	1726	1874	1	1	2337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcoA3Hz8unrvswEyi4qRabwhADZ7H6d7LPXNbHAJv6VupDqqY
8829	payment	1397	1397	1678	1	1	5365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkRtTQNUd5Xn8m8ooWVuq2Cgj6tERVXkSsr6CCnGx14sGKsLB
8860	payment	1974	1974	1972	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRKQ1GykYVqqrekQCm2pkNrwVW86NR2i1nUWpbFMxDmUcTZ6C
8861	payment	1397	1397	1678	1	1	5380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjWLrt6GMS2YDHKzAesqxnUBUnpSxD3NivpAWYvzGYvdkHzv7
8862	payment	1726	1726	1874	1	1	2352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz8ftNfQitL235pKksPznkm3yFNKUEY48c2PTtvpr2WJa4Nby
8869	payment	1726	1726	1874	1	1	2356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DHw82VYnvhq232tNVRf6xJkwQsizPcSuJ9e24SyJonXxZsuN
8870	payment	1397	1397	1678	1	1	5384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUoY7FQ4ExKiboxjGGz899ddUcdfgqKV5ZQykUySGkfQG6xti
8888	payment	1726	1726	1874	1	1	2364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJUDNtgZBTXNbPLEBrZFQh7ey78H8xMJ3VLpYjir6T3fSVLcK
8889	payment	1397	1397	1678	1	1	5393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TAns2mZyCyAMAxCivhaKPSydcFM3f4QPN4VsT34AYZg1fNbR
8892	payment	1726	1726	1874	1	1	2366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzv6dguKWzMwaT67YXvwHnfAv63UuGsjG4bdC87av4EKzam4f6
8893	payment	1726	1726	1874	1	1	2367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9RWhoiTnKGmsgJdxt4dqzTLwDCzEEhmwJ2Q19GVm8UhmCCYK
8894	payment	1397	1397	1678	1	1	5395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuk5hPmrpinECcsLSURjN124iNtDUeY4pjUrFRacLa5kZbQQP
8895	payment	1397	1397	1678	1	1	5396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D3RntekunrrkSV4WJ7JwMgRXatb8Q1x1F77g2X6fPi71nXwU
8905	payment	1397	1397	1678	1	1	5401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTPazxLD2onNA6X5JKhvkTVDESa6BkhCod2XDCVBE2usQcb6F
8906	payment	1950	1950	1971	1	1	4	600000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpaAvwSBxPBum14ThcohjNu7uis9KsD8bJYP4ypNavotFi9Sn8yH
8919	payment	1397	1397	1678	1	1	5407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTsfvBFTSRtBXRwjiNrm6q1ekXKcWHMzBG4Jj9PBJPqjcT3sj
8920	payment	1726	1726	1874	1	1	2377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL67X6zXLWDiZCT2Y49XUeWrmWvJrwGwkC843aoaobTKEEW1F
8921	payment	1397	1397	1678	1	1	5408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44A4msAxuipzYjxLdfJwZnSmL4htTHazt4V8ZAqcNWAGMFyvB
8922	payment	1726	1726	1874	1	1	2378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uWQ8s1TcP5kk6Xw6mF1ozRsMtBXVbUSyiKhTsvwk9fDsHjPJ
8960	payment	1726	1726	1874	1	1	2395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRH1YkGZf4kE6utjaxUDZ3TNdLQCWJhH6DuFtGp4VGZzfnLDvS
8961	payment	1397	1397	1678	1	1	5425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FJmE7EBniva9uBakHihrCGwc2DVA3Aq7trrXDCAY8svLoRSa
8962	payment	1694	1694	57	1	1	6	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZSgXMJDV16T8a4C6i3bB1sMcJsGJVb6MJ6N5SFzD7h5hshHK7W
8963	delegation	1979	1979	1500	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn76SuPJBdw2NJ9o6scFuzeLsRCLjUjGjgUinSpjYqAWxFTHa6
8964	payment	1694	1694	60	1	1	7	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZur2fKEv6UEy5PCpkrAm6JAqhn9BJdeQ4FaxCaV7dY7xVhs8zs
8965	payment	1694	1694	61	1	1	8	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZBZyAmHRV8dZVAiip2Y3SHo9nWRozUBXFtPntmJSrzwCqiqFVE
8966	payment	1694	1694	21	1	1	9	223972906270	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeyhgjNfDkykzkjeYAn7tW6uf2qLgdig6L9WtpXqLb6SHSAZ2p
8967	payment	1694	1694	52	1	1	10	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZvJh1f9CPna21o3shXcQd1qX3j6YavHEbdFuV66Si8zJMaENtD
8968	payment	1694	1694	73	1	1	11	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZ8sKsmCJpScXFSXEc7ULxwbkWEM7b2cPJJBd2Mvpvm7kxs1Xdc
8969	payment	1694	1694	68	1	1	12	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZS1F2RasfZVFaB9mDKpspiE5TNeKkpTWGkmPKFDn5H7WeJCLfU
8970	payment	1694	1694	67	1	1	13	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeXPhMFkVgpywt8ksb4cCn1Cehd81bEwCH367hutVVnhzKSWYt
8971	payment	1694	1694	81	1	1	14	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZuGSCDw9vt23eA8WC1KceYMKc6BF2GB2v2gMyPjAHTFD7vecuZ
8972	payment	1694	1694	156	1	1	15	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa4aCKMqiswLLdEfZjL1oKQaVyBwkWTvTfSMVvbYcfmpqptcx9B
8973	payment	1694	1694	164	1	1	16	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZTHSfeqpLecdHZvZw9coc7Zdn8Lpk5WCQkD5n3BBuxorGuJcaU
8974	payment	1694	1694	129	1	1	17	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaD9Y1VmjcLcRVshbCDiy14Q13mTPEtPojsaev5V7wdJuHG9L8b
8975	payment	1694	1694	428	1	1	18	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZaskLBWCv1rEiLftjJykXBwwkSZ9D6fX5xrEFM37vPg4kdQ3HS
8976	payment	1694	1694	432	1	1	19	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeQXaqCShF3kHVuUDBeGBvELyDbvf3gYgBY7pGAwWponk58FpS
8977	payment	1694	1694	433	1	1	20	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZPpsmApF7U2CP1d2mwoULE2ucmGMP3CLkiM7L3eyX6xbX4V1fm
8833	payment	1726	1726	1874	1	1	2339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9FzGhgBULtJGSKEgKu1mVpvv3yGdMF43PTDtAYNWETnYku58
8840	payment	1726	1726	1874	1	1	2343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqjYhBWHtTgTqKRJPANnznmDrTkmAFzDUvL1UGfpoQqy5z22K
8841	payment	1397	1397	1678	1	1	5371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJjgYUc3fp1rUYrRPjdbCFxL52N5edstRiDxkaC3yasZcWLC5
8846	payment	1726	1726	1874	1	1	2346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rV5hLEq4aWUiinKjHjzgQximmYTN9cxEWZVMTtqNDm3Rqqyr
8847	payment	1397	1397	1678	1	1	5374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpn3KArC8ACcggGcU7kAPLnsHQaoFYhy3YvDiEAZaNvrfGb9C
8848	payment	1764	1764	1950	1	1	2	200000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4prX55Yrne6fL38vGsprX3texFiFxW7okmdJAhUrfk1uoiWX
8849	payment	1726	1726	1874	1	1	2347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLD2CWsmDsvxPcLGJ1ypdKTL9PMrL9tygdKSxxeE1LAw8u1MJ
8850	payment	1397	1397	1678	1	1	5375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7nhPKvLUgkqB61YFheGtbWTZLmuSYeenYV32zRtut7QY73sL
8851	payment	1726	1726	1874	1	1	2348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyBwFGtrghqSu7gL1H1WWUbp8JMBFrFerW2MHebKaEB8VAsbM
8852	payment	1726	1726	1874	1	1	2349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaTcsqZJ7sDHxT6YUQpPcySY1CnS9Awb8iZdXut4QAM34swbn
8853	payment	1726	1726	1874	1	1	2350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhrWqbhCRhbujgNHrJhZh9AWCiFjpY4xvKwh5BMGuzkcVVaMp
8854	payment	1726	1726	1874	1	1	2351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdkMwRvgc7cMHNRSD64fJAKyqwSAnx3AQmo9tcYucqonWpX9A
8855	payment	1397	1397	1678	1	1	5376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8RAL6cVTk8CWvNH5EEwWEopeBt5C9XY1DbT6y9cgYzgsGD2H
8856	payment	1397	1397	1678	1	1	5377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68ibm8y11oi8TD2SKetYiCLL9tw5gvmSMwC5vQWprtJxL3D11
8857	payment	1397	1397	1678	1	1	5378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtr6Wo41MRb888ZNh2nRu5ConGKDnDCVSfKS9VSNF4g1VYbL4
8858	payment	1397	1397	1678	1	1	5379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjfixGjxnADPRaxQGoM3tPFpjy3cn6xtrceGbR4Z5jawFnAp6
8859	payment	1764	1764	1950	1	1	3	2800000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYma4dL2W6PpuSpszeujbqsQZQ1gmyamy5TLZs88YxZUvN8mRz7
8865	payment	1397	1397	1678	1	1	5382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphCEXe1xK4PW71LH8D4NHvw4HADq4xUj18zHz6zFDpHpb8eKM
8866	payment	1726	1726	1874	1	1	2354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQLfWTfCMcATD9uEBKCb9bcpfwoakoSP2fdGqGPLqXdxXn67
8873	payment	1958	1958	1978	1	1	0	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs56nb5yWvr1GPv3rQiCF3KvWYj37GEt9WtaUmgCFhwWekFRdE
8874	payment	1726	1726	1874	1	1	2358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvoQeueaQzFHiUqsvefiwWsa2ZRQV4j9Hrhvau2DPetkkq1cA
8875	payment	1397	1397	1678	1	1	5386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFD6yvvff1581jLTLmiK2eDjkCvC1R6Y9rM3A6vm4BsTNuN4SQ
8876	payment	1726	1726	1874	1	1	2359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCTBFdE1p38LUBvrxL3ij5EVYoMP1hFjY5ZvjNZJteGaNMTbr
8877	payment	1397	1397	1678	1	1	5387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR32TZvuJxprFZ2tCfayHvccaWDTL7hYbi9wH5CqVkrKoUZ2pc
8907	payment	1726	1726	1874	1	1	2372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLQJ2baqomvEHY8gDhyrNVBiL5mtuJ5dZ3i9zKFDayNcV9KGn
8908	payment	1397	1397	1678	1	1	5402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61pYvs4nAYJ1hPnNwU8UkfrBShWJm4jG9v3kEZEU3WNUnbeRm
8915	payment	1397	1397	1678	1	1	5405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzq1kkNMXDoQVjqDLEm1re6sgb9pYCwDc15peBobgnZqqRL1q
8916	payment	1726	1726	1874	1	1	2375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjsyXC8PSiiq7oyoofYFnsaoUw3AzBVnYsbmLtViFjkefx6wu
8917	payment	1397	1397	1678	1	1	5406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2hMC3KHLEdZ3YC6ZaoAz2UTAFSnm5FXPEK48KtidoCs8xdbx
8918	payment	1726	1726	1874	1	1	2376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjpUikcfBzmtUNxEmzExp3SGuWTMxZixBkcdEsa7YyG8hiEEp
8928	payment	1726	1726	1874	1	1	2380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgapaf796aGE87zcs7cGWpcgTJL9nvWcnFgMJA6n5r42wZuneg
8929	payment	1397	1397	1678	1	1	5410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HtXduqMXiSZBZPJzTgxxn4SwwnfiDvC7bwaZGnq36CGLxbWN
8955	payment	1726	1726	1874	1	1	2393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRshDbv99uLwsZp74bXgkyS1VeCWPDpEzDqNvJ6QkPYcqhtFRv
8956	payment	1397	1397	1678	1	1	5423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4G98bAWvYTAAbpYCxUs5kCAo45sPSPktvdGshHweTyvjZgYE6
8957	payment	1709	1709	1979	1	1	5	1050000000	1000000	\N	E4Yq19AFkEW3GnivvBhHRxj5SBy2atsqGR8QwMG6WSYHVQ2mDZfbN	CkpZWKorrgSe3bd3h1FGLg7Cv9TtDfbw9H2ZAJ5Luq6QTZ7tf2HV2
8991	payment	1397	1397	1678	1	1	5426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxo8LhcaiSeb1aeTX2Jn9CokAFUaPAdPHPTSbRvZV8oxzn6cw
8992	payment	1726	1726	1874	1	1	2396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfTqj591wpWiwfRHHVpsbu8MBe2K93kWXdYsujBy4aoDx8q3g
9018	payment	1397	1397	1678	1	1	5437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNq7aqsyMABWqGW6a8YmA8W9r7YGoix7csnjdgbTVTW9i4evD
8835	payment	1726	1726	1874	1	1	2341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWQu49RTs5ZTnZj8fMKfBgueEadv8eRbg4EMJ3Q32FLmuJtag
8836	payment	1397	1397	1678	1	1	5368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPXLkNw5cst3S7HE3BxadXoii69rSkTuJ9BJdd6ajBcsCdLMr
8837	payment	1397	1397	1678	1	1	5369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQs2367gGi8JcBiz5nXmCAc6txDSYm7VqDShCei2RQ3VNxhrj
8842	payment	1397	1397	1678	1	1	5372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fXZtSH6JprNuES95BYHnuS7PmUCHUXeT3iETpebtfjWfsMFz
8843	payment	1726	1726	1874	1	1	2344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHmzT9tQmhEXZtxfYfaeRPiHfquA3HQpuSrDMHnSJ6o7afrFC
8844	payment	1726	1726	1874	1	1	2345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqgXsB5barcVVLBishCJWEFaZ8MhmkqcsbBb9qVFRUEKQF87j
8845	payment	1397	1397	1678	1	1	5373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCvTiV5ZEMkhpCEr7vFdZnE4w77govTd5tnK4TdEH57M5Tpw8
8863	payment	1397	1397	1678	1	1	5381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqPBJ32GahKyWLq1pESaDaKeYA14mqt6C5jGFbUJTD17VZML1
8864	payment	1726	1726	1874	1	1	2353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcBwURjHUVdY62NS19cR2rhjV3iSwfU4jiecErquYss6XHX6T
8867	payment	1726	1726	1874	1	1	2355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2CUzTqh2cdkLUgs2Mi1PMmhvEHuBGQm4fBZodLeHywTYaaL8
8868	payment	1397	1397	1678	1	1	5383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HvEuthYkQcd65KJvDZo9jmwBzQhBRoU941QYtircMqcZd5w6
8871	payment	1397	1397	1678	1	1	5385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVprx2HUe5AhFFXViwpzm8w2b5ktwhCpr7Aeiwwy9fxRRAVHpQ
8872	payment	1726	1726	1874	1	1	2357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY3KMLDi1MzfD26oKLs7QGpwmHn7dGbWrZuiRceDFEvDD432A
8878	payment	1397	1397	1678	1	1	5388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPYyydyKPM9v1v1LtHxWk2YZLdEG4rMaxaqXfdbxdVB4dDseK
8879	payment	1726	1726	1874	1	1	2360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqXMbs2EHDEfzgcS5Uxh7SwcEii8mXVJm9tye1DoHiCJVnMny
8886	payment	1726	1726	1874	1	1	2363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxkfFtBsjv8NtcGawQocWrKsR8n9hkvXJyk35TCDdc1EJtk9Jb
8887	payment	1397	1397	1678	1	1	5392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvxgv1waAgn2jywsnUY29bYNsZ8HU4k9MFwWPHVn5XQwVPa38
8896	payment	1726	1726	1874	1	1	2368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLJR1JRdpYWGvNRUYAQFGUp8TdENsuabYE5N1rsGHEYDh1PGS
8897	payment	1397	1397	1678	1	1	5397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CZwjKnUzfZgxHp9afG5gEqdBYMr8J33Gaz4CHLHAeutE7YXT
8902	payment	1726	1726	1874	1	1	2371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ayUZceFUhhypqvTQD1qjfwhmHYN8iTiuGx4Zm2n5r5W4tea
8903	payment	1397	1397	1678	1	1	5400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBW6PjUDqLSB6Z1PE2kMQXc5zQMGgKjrxTB44UCQtmSr8Kc8A
8904	payment	411	411	1950	1	1	2	300000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwi4FLcZdkfDkUdz8kfDfrZFoxDNYE1rh8CE2JnViVcfZB62Lj
8909	payment	1397	1397	1678	1	1	5403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgb812ZzZxh4mjbUeXHQNuuxgzwPUXPBrwHWKBFYeyziriRrv
8910	payment	1726	1726	1874	1	1	2373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1Hr72xjzaShQGBm4PVzDq8DhDHvgxU532GRFqoP3HjRYn7es
8911	payment	1726	1726	1874	1	1	2374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNUuAWPitx1XsF5pwcJec9WMwrTD5FoWNkFRZjRf6xzNBELNH
8912	payment	1397	1397	1678	1	1	5404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD79qPfzqksqMxPGhzNjJsCm4uUFe9Nw1NoituHkmDSDLJ5Kmi
8913	payment	1694	1694	1694	1	1	1	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaL4LMJpGnvt8xbe446ADo4JRLW35bMcG6GVbkjC4TJC6BprTNq
8914	payment	1694	1694	1694	1	1	2	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa8bVPTMWwVdtTMtPmZFEbP7T2MP2LnXyMzKYJQ98cmsMuuYhf6
8923	payment	1397	1397	1678	1	1	5409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvguj86w2ZvxfaaCn4BTCnoy6WNJ1MxJQ3dpW9TidbPfv2cxfp
8924	payment	1726	1726	1874	1	1	2379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbAQyfKpyredJ7KDfomMwf9UkZvrzk5pPovQAcszJeNT1dKg3
8925	payment	1694	1694	1694	1	1	3	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYryNJ8dZz7qsfn9XbcfXZqUAfrkv57YRcYLZR8aY8AYgW97KQ5
8926	payment	1694	1694	1694	1	1	4	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa6cuzs7u9MSXstCFhBN9zvSJDrZ5YrdNdz4v9kko3VtktVoZ57
8927	payment	1694	1694	1694	1	1	5	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYrUKuv5uh1x6Ev195iESDoog38U1QBkpApk1thKJQcxqyxumGM
8932	payment	1726	1726	1874	1	1	2382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2bpdN6cxrYqRffpQEupDbJeAiv9MnxCgrXhq1codcLDA9dSP
8933	payment	1397	1397	1678	1	1	5412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRNo944caQSkFvu3RKGwCNJNtMydP6ni3TUPWVNE6miPGLB67
8934	payment	1397	1397	1678	1	1	5413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDBgUZxakcz7Z3Si6VbuWkk3R8qricLAnNQ1edZ2MGVyXus87
8935	payment	1397	1397	1678	1	1	5414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLARnAGkmn4Wr45bsi4h3uo2ptb98ru9JyUiR26PwF6qvtsBL
8936	payment	1397	1397	1678	1	1	5415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PwLra44RyxrrsXwJrktYthUrxRPCbwCY4GSiNdf5KPiMhjAo
8900	payment	1726	1726	1874	1	1	2370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtpEw3Qd4Bm3Jq4scGiAA1Vyn6ZTsGT85x6LgYmLvb7mRYfgw
8901	payment	1397	1397	1678	1	1	5399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwe9UnxL7uGkTqJZ2gSpcT2Y4imqqyXpwith4vuScnJVNmxzt
8930	payment	1397	1397	1678	1	1	5411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6kq28j1d3MC842rLQpTns1DBaLvfcNumJyXMtut28CXoss9v
8931	payment	1726	1726	1874	1	1	2381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAhmRcbjzDxVesbCsZB6YwLWTYgcPRRiqKKnHXx1RpnQ41qKE
8942	payment	1397	1397	1678	1	1	5417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMjXZ2WJTHcRr3aZ9TPvrHYxAdEmk2sqMr6X5wuNJwrBeN3oY
8943	payment	1397	1397	1678	1	1	5418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmDcpfGGP2AjyAyhmzquj6b1a7npx3TXkYWTshfsAM1RukLMM
8944	payment	1397	1397	1678	1	1	5419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1fmx5sbM3g2jzS7o54cbjA5zQqk4eNfrmTY9CEGJGx8AxnDX
8945	payment	1726	1726	1874	1	1	2387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ5Cee24xqZhGwb2MQqjjVqD7yqXBvtfN7WTfAFLAGtbRT14G
8946	payment	1726	1726	1874	1	1	2388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KqprEYDAR5Y3xQH5tviaVrXbmbUphMVWdPwfb1gmPK7Bcxz7
8947	payment	1726	1726	1874	1	1	2389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsGWB9zShPuMNFQqLcZEvwhuEdrfoUSeZZZLGPUxvipZFGqj2
8948	payment	1726	1726	1874	1	1	2390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4r2mk6Pb3MK4ZTSrxknd9MtSjRfxrcQqTLDvPxY7jBL4756iX
8949	payment	1397	1397	1678	1	1	5420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7W8aENAv1HnzLrwaWcrzXES7DFYZJ2avCQSo3dtsc2sZDW9a
8950	payment	1397	1397	1678	1	1	5421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPkxNuPWWejm3M1hT2ivJbHf93z62MovQ6LArU8vZjfKVptj7
8951	payment	1397	1397	1678	1	1	5422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuCn6x8MuWXHLjwswc3sY2sMqqEPe7Th1UzHXK6pA2NhPYh2c
8952	payment	1709	1709	1979	1	1	4	50000000	10000000	\N	E4YfP93swBbqbega84WaSyB3raV9snhP7duK56gBtJ9hEUh7dqTHZ	Ckpa4kxSBiHtPWoCEkqpax6fDaSLXUHVw1D4W3tXvK34px5aaVe16
8953	payment	1726	1726	1874	1	1	2391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHve63yKHziEAfZiBFwU6yuyBGet2h5uJp6RsDXvLGTvmFfASY
8954	payment	1726	1726	1874	1	1	2392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQU9BvR8TBqKSWyFaAE3iPms6CzRznVYmqX1MYeG7EpCYkpKu
9003	payment	1397	1397	1678	1	1	5431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmhZvcnyefFeWL252uukxMq5mLJ8SkfuzAzUALbAoGDPsFzHT
9014	payment	1397	1397	1678	1	1	5435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xHcuQPCd5YrK2ptZA8LDJ1PHMyBBtdqWqSMFppKiM8RfZVnE
9015	payment	1726	1726	1874	1	1	2405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1kzLirmyAGCKt1mEahUcw9Gf64p8HpySUpJLrEwUmkcRnDR2
9016	payment	1726	1726	1874	1	1	2406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhioRgJLv9LTemp5eKTTS35okXPrMjX3yvBmuWRE7rVE9U7Ux7
9017	payment	1397	1397	1678	1	1	5436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Hw1SQLHxJnxenz3AnFPWFSTaXzHEQWx57fYZdnGQGR9QRhYA
9022	payment	1726	1726	1874	1	1	2409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULyfQAR7ZuQSUpZmx3zegbMNzZmfCBfCXN2UDi4VVYxNyZ3po
9023	payment	1397	1397	1678	1	1	5439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtuXdQEX87XTRGP7ks2Pu3EaysZX9LdMaQH6LDx8CF1fM7BGR
9050	payment	1397	1397	1678	1	1	5450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZh7DLkg1yUdTd4WPzkatmET9PJWpnRvpPW7AfTHYK3UMLbqk
9051	payment	1726	1726	1874	1	1	2419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8XgzW17nYe4e712GG2W1Fx4aK2mmycRS14Uucf31T7AY6yFj
9061	payment	1726	1726	1874	1	1	2424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnga8aHJkwwg4UTAbzMBThh7yRRSkGBgti4AA2CsfHAtA3TjSa
9062	payment	1397	1397	1678	1	1	5455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJNCCFo1gjEwD5TFuEuBFmD3qpkbp6eFK7feT9Jn6XoqacGgn
9070	payment	1726	1726	1874	1	1	2428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36N1zJXsCLtwgUEFw5SuoLbMeHf3aFcqQve8HZzrGAwF9TYf8
9071	payment	1397	1397	1678	1	1	5459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVucgWURtqGLPRmeuNQtgviWUfafjzZCLxeAERmystKQwRCb5z
9072	payment	1633	1633	1390	1	1	0	6566	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpaJEkLuqMLpTrLQ3hqypS3L1ypXc7ewhdKnyNAH2AsuB8QtpWbA
9073	payment	1633	1633	1144	1	1	1	3492	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZF6nkYbd3UfWkaTaHfBKJPknDzhTsvDrGgtJ7d6Br8PZm9YdsD
9074	payment	1633	1633	1264	1	1	2	2356	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZRfQzozqCHQ5fabJpykY79nsud5if2ZZWSF7F1dgCZd7nNmghg
9107	payment	1726	1726	1874	1	1	2438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhc1mjNrfN7THrSFu6F1iTYUGzUC2eEV8A1TjvihCJiZnyFUYq
9108	payment	1850	1850	1682	1	1	0	10000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYpZdteFbXCS4ycRsxXRSGMTGKd6pyjovfEAUF4S5aEtb4FCU89
9109	payment	1397	1397	1678	1	1	5471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqvMqY5F7oPxWUQKc2PpdFAZ39BsXxqbFXpFYzRUz43fuFXA9
9125	payment	1726	1726	1874	1	1	2442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZbrLFZtiAqSmXnCHd3DhP5RPeMVAR1iDBfYAdJuggBpfxUQG
9126	payment	1397	1397	1678	1	1	5475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxuFYz1JwzQ7pZkTmHiLtsnC3TDv8ETdhXJsMjVKwqt59zokW
8937	payment	1397	1397	1678	1	1	5416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpfrG1YFa8TicWEAukCdFff5r6NRzGDkEnzjd4NRsbdvEo6p3
8938	payment	1726	1726	1874	1	1	2383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFcNyWmdy2YGmLFAB3vQsEZY4RqiZnjNJJv8uesyT8eArHK2kK
8939	payment	1726	1726	1874	1	1	2384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfgRoadZdyUSk8feq49XKV1bjCcPHVD7kyC9ie4kHksuyFEgV
8940	payment	1726	1726	1874	1	1	2385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwAi2x4xW7ZY9hhrpqXkz3eQFkgYxFuvvdDmUDGSuLSrRq2bf
8941	payment	1726	1726	1874	1	1	2386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2EKuZkECsvDPYDP2Hu933v4f6FhD2kg5t9DDNqX9ZHy417tW
8958	payment	1726	1726	1874	1	1	2394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaL9Yn3oiT5or42LSsWSQad3CBzV1915LWcjqyBVTbXk3Us6CF
8959	payment	1397	1397	1678	1	1	5424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnem2yLi8jCGCooNNe6eAoqMnMaFcg3jTyGTGwYTMjoebpzmQV
9000	payment	1397	1397	1678	1	1	5430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWTaFcwFD8uygtZJJZsENqWq7tT8GaNtqrsvEfJuucieX7jjJ
9001	payment	1726	1726	1874	1	1	2400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVpY7SdRFnbYfrfyHHF66B3UX7aMcFhpyqq6KqNMhkAyuLnEi
9002	payment	1726	1726	1874	1	1	2401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQNdaVGhvq6ZKFTM2ET3MAaoxyBUymye9YjgNJYztgCeN1gLt
9024	payment	1726	1726	1874	1	1	2410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjnKhtKXYfMnsiygiccJDshWKw322dxswDf5cYzzmNzAnxcVD
9025	payment	1397	1397	1678	1	1	5440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdBUcivB7gw4YCmwxjT66aaAxJyMb7UnAAZwvKTpmQPwyjx1s
9031	payment	1397	1397	1678	1	1	5443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVCFPTivz6psDYwPG3qZ8HgWrSMx24uGQPXEbzJCxXamkht7u
9032	payment	1726	1726	1874	1	1	2413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEVodSomgBrk2TFE5M6gVWLsiVW6gzdiBFdSq4g9MVczeB7x8
9033	payment	1979	1979	1776	1	1	2	274575970106	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZRAiK6CD8GnkLLKEX9cWpKWq3Md8fbcZmzY3htwbLZAkj14aB3
9034	payment	1726	1726	1874	1	1	2414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjY2yCTWEkLHcCgeC4y1K4vNdWrdZfPzKFtt98dgQih5QYoyRJ
9035	payment	1397	1397	1678	1	1	5444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhaSCsA2RkJJNbLXaiw8FzNPwdYuzb5kdwqjp19v1XAsMjXih
9042	payment	1726	1726	1874	1	1	2417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ocsfg6yfQYbnXxPKM32AtaQ1pHUV4LPhMqusTeTiuXyxTEQV
9043	payment	1397	1397	1678	1	1	5447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5X8pdSosNtbKocWNBVf1g5tCmm7qovdJfkS9AEVGhRHfShXQj
9044	payment	1397	1397	1678	1	1	5448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcG9otMxJPBFNDdmRFsbk2D119uuL1Hxgg6oweVZdPfKNHRA8m
9045	payment	1979	1979	1051	1	1	5	3748267631329	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpaE4dPFsiMhQxfvKhM9i1Prwan1QtoZWgYkxwtHRR9ApS7LhxVe
9046	payment	1979	1979	1171	1	1	6	2529030858977	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZhi5u4VH8j71FAS6TVwAmv9KqPAg6GfQ5e4GKyQvmnTyFPmwFE
9047	payment	1979	1979	1297	1	1	7	7047369361431	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZnvyUhQpJd6NEJ6vLEvwwJt2qhFYMUbNiXFKtN1YZcnAhZPMQN
9052	payment	1397	1397	1678	1	1	5451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1C3173uqkpcUsE5ViU5VeS2MECz2e7mMNG2yatjmoL9E2LQm
9053	payment	1726	1726	1874	1	1	2420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeYqb1bvSJ2iyAr5tGNQYTVVAYcRYYmmUUYaekz3RQ9hpzm5z
9054	payment	1979	1979	1776	1	1	8	823866553266	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pyrY5VghJmXm9pa8NmDRAu4mub4vksLU7DhJGhkcsYi6UntK
9063	payment	1397	1397	1678	1	1	5456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerA1GKAi4uGFWiyNXSLJUFWsbg4yDaM4wztT38h8cFyHy4aHc
9064	payment	1726	1726	1874	1	1	2425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfQirAkxwQaDgD5GhRDjxCZgN6shLmhyxfjywS77bL4RkAnBY
9084	payment	1726	1726	1874	1	1	2431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQy4EMREejGqYLQvQa5J6trEHBpvm8fFJLWDY1uwf6tCzA1BmE
9085	payment	1397	1397	1678	1	1	5463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvuS4XHQhNFv5imaMuB7piqZ3xH7Qob5biiYfBDDRJX2wbzyx
9110	delegation	1981	1981	596	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgvNRjeAwXX72UxyPvdWyYHyWmGMWQSMHUmMgqGbrts7oUBwa
9111	payment	1397	1397	1678	1	1	5472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNEAd8G3RokBvKNETeL47bPEYVmrc59bAbUSGWFD6VzRkjX7b
9112	payment	1726	1726	1874	1	1	2439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSEFpqSitxb2Zpqvg1TaAURRCK7rRQ7EksQAEoHAHMURSr3Nt
9115	payment	1397	1397	1678	1	1	5473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXr1E1ZqhbKGdqnmmgFjuhJr9zhgcHZoNN6TKsWH8yYokQmkC
9116	payment	1850	1850	1151	1	1	3	2726000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	Ckpa5k1w1BHkuRFHvVCZvpnaQVxahRBZSzSRyPj7wfReShAeshJ6c
9117	payment	1850	1850	911	1	1	4	2255000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYsxPX9LQNnFtWqGVsFamRtnTTHpYT6qfZij6czjiHvkCb9Zv5N
9121	payment	1726	1726	1874	1	1	2441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gFahFR2NBd6bmLbuELmk3EjGt7Ag3yugDFyvy1PbwayQ4Lbv
9122	payment	1610	1610	1188	1	1	2	3197247260000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbYSemHM9wbRWsJr61ksb8YfatFBpkSHpbnyr356HhX3diquy
8978	payment	1694	1694	628	1	1	21	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYkqSWicBjZpF7zcDxm7sRjA5HmCM6VAaym8TYagKgQNZj1soyG
8979	payment	1694	1694	222	1	1	22	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYuBwXMMQTrNPVXSrgKkGKB4FhCQCnp1K5cxFMZMhQpcSzrGQJ1
8980	payment	1694	1694	431	1	1	23	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaDRCew49W3gTDV8YRXnq4J6wvE3eZqv1F32SU6E49ghN1fVQj8
8981	payment	1694	1694	574	1	1	24	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa2PA6pXV7ojKECJBgZgdK3q9inLXtbrnsj3uiFpTgYQfU1DS1n
8982	payment	1694	1694	256	1	1	25	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaATm7ktmiaJkWALgvHuwUAokmLPmpuk7AV4H1Gf31QrCGV1wmZ
8983	payment	1694	1694	604	1	1	26	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZTXuvMvqKoo87pMp6RCnZaSEFRj1zVTnhqjR2GoNNMKS85nxP6
8984	payment	1694	1694	220	1	1	27	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYdp9Nhr1mDkaBcnJwbPm9f6iwTKnswVMy5GsQH5A2NHvLpHdTh
8985	payment	1694	1694	371	1	1	28	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYn4YqjygPPR13NrUUenfqMob295ehSx2JWcK9GsSG333tPmBxf
8986	payment	1694	1694	638	1	1	29	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZcsy4o2YEDnAHkL1xxAhVaGaXsXNuV2Gj2uS4gDPBAB6KdYdVg
8987	payment	1694	1694	951	1	1	30	3533388363221	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa4Ypjw9MbjRbt8MGWLjv13eaQwCJCJWYWsLHf1bNy2ForXL3Pi
8988	payment	1694	1694	1071	1	1	31	6331563977293	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZFoeGKirWRT7FWkxcyV2FbHB4E9rbHdrob1vwQiMSxovjTh623
8989	payment	1694	1694	1191	1	1	32	4272129988533	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaGzVfhEnWi5PBBezpUQTwGaCdsNdjhXp8UT4sAktjcpq4A8KYh
8990	payment	1694	1694	1317	1	1	33	11904134108790	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYRcaHKS22L7EmSNwF1XpFxti8Lb9Zc9da1CH22zDP3MxxaocXr
8993	payment	1397	1397	1678	1	1	5427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcVTctJKCd3wkxhRuSGdSL4uRGgivJ36HsRsieS1osBZFVdsi
8994	payment	1979	1979	1776	1	1	1	10000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZK2vEymW93C5bnZ8G6HGCdAr3efqaR1iSbkk5B5LkizwGxkbGW
8995	payment	1397	1397	1678	1	1	5428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9J7T7vSxRFsUKgrchJW2AmU9vf7pTV1cKXsem3CmKFKXai5D
8996	payment	1397	1397	1678	1	1	5429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuzZiexrB6Dsv5ABNJewNURQtZSaEZfYWgKhMAvBWGsW4VwDu
8997	payment	1726	1726	1874	1	1	2397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8S3HnFxqk9yDnkNfEnVo5E739c58924pXschFGaW1gebnqMn1
8998	payment	1726	1726	1874	1	1	2398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhfA7Y6mSfFKJ8FRmLA2g9KXocsRNgcbEHpQSmKtTaRQZJXNV
8999	payment	1726	1726	1874	1	1	2399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4AAuhAUd3cTZ92Wmy2RvTHHbMipioZ26PsUGcK6rhVDVENkv
9004	payment	1397	1397	1678	1	1	5432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihWrGa3Ubdz3H2FRSPyfpwEbaprBkw3VjEAcU6awGsuhy7up8
9005	payment	1397	1397	1678	1	1	5433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWrqpW7HnjKGFGdx8GiyJMZcqpWmsk88QDBFj3yniZyXhgagE
9006	payment	1397	1397	1678	1	1	5434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FiNERCGbg7xJN587syvFNtA4CBtBe58pM1V5w94g6ytQBP3x
9007	payment	1726	1726	1874	1	1	2402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJwkhzM3LCfZMMCk27rsYD13gdmsnxagEdZaSaFBmwmonvh1v
9008	payment	1726	1726	1874	1	1	2403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyRx6RqgY4SUcYRmo6Wh1m63eFkxuiTh2dWzwUJpXZd81K5X1
9009	payment	1726	1726	1874	1	1	2404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnhkrtjdTCV6u3ZJxFMxDGRgjpyidCAjjP4QB54kR8j6i6i9y
9010	payment	1601	1601	1388	1	1	5	5002502500000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	Ckpa1yvTfwVYXxVx4FAv82wqmk1xXZ6oqcd6zkrWKEQXJAfy8zcbr
9011	payment	1601	1601	1142	1	1	6	2660486500000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZEuE8Q8B64bk3QpDXGeBcSGxnRckZfa2bfPwVJZCgZsGWnbE3X
9012	payment	1601	1601	1262	1	1	7	1794816100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZupfdhR33GQJSXoQhXKNusuxYhb8tzmxXtCmPMnKMJR1gu9guz
9013	payment	1601	1601	1022	1	1	8	1485100900000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZyfYEszDWodw4D2fwMPzfrxN5kHA1QsdbUWcPrWHfFGpWe9wTB
9020	payment	1397	1397	1678	1	1	5438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eEUuaSe3U6kyqJHod4H8U5kYu1U71cp9kDFY3rfRLfJftCXS
9021	payment	1726	1726	1874	1	1	2408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRGBvozXbb9e41KThjNNDBdHkdTf8RXUKdepTaPmfuKLNwtm7
9026	payment	1397	1397	1678	1	1	5441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcas2wKpvqrE2vZ6pLKg57ocRyDCCNCQ7fDTH9aBXhNTNLPov
9027	payment	1709	1709	1979	1	1	6	16556440000000	10000000	\N	E4YpwWCUcoxadLVmecexEyYhq9YMpf9u3b7rBaxFzbbUftDNkYdMn	CkpZcH4auKJdtA1n3zzoCqzURgTBHtHuT3ktoE6Bu6o9Wr9Kf2eYj
9028	payment	1726	1726	1874	1	1	2411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnteRWTQnX3LbdFrF6GkgmoMyhNVkRWYYy3obMheDD7ESQvmu2
9029	payment	1726	1726	1874	1	1	2412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTuwCSxU8BaXqPECqMZVRfiAiXNdvSMnLHsc3n1MnhbiB4UYS
9030	payment	1397	1397	1678	1	1	5442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aPn7y6b85bufMMak8jf33tCwKpAxh3RUFPyjzoNBVwPB7LS9
9036	payment	1979	1979	1776	1	1	3	41602419504	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpYfwDeNFaiqtPqYNxaEP4fRs8ccLe5dTyU3cyeTjFQaJXLfQJqL
9019	payment	1726	1726	1874	1	1	2407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvMWbB2pMdVPGvzzAcSJLwArVTCUgdwpzKx63csya9WBHV3ND
9039	payment	1726	1726	1874	1	1	2416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppepxSFvhCkgRGVMHoXyiGZJfK9HFus1kbqPscoqZn8mukx1B
9040	payment	1979	1979	931	1	1	4	2091677205387	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZETGoVjg2WLwnQAnWSzrv6h8ahzQjCbX61icRCRW9sCRhDChYT
9041	payment	1397	1397	1678	1	1	5446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEEttzxBk2kGwnoxWshwdCUdA49E8mAgyBbUBwFH5BTfsEihv
9059	payment	1397	1397	1678	1	1	5454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmhCGkZSuVJwCsJkCcQFyh4PrWrCPwZvGvdakXJaotwqtDm7i
9060	payment	1726	1726	1874	1	1	2423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwyUV9Kv8Bd3DZ4T5C76UVVh9YgcbYRqpv6AaUHo3WqT7xAJ4
9079	payment	1522	1522	1898	1	1	5	10000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYf1jqyz1pPvsPqN67dN3pT3nYvD8PnhQdVCVUeHPF2EN3CDBPM
9080	payment	1397	1397	1678	1	1	5461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5zbeRKt6oMALPRY4hi7dA6tWPruVvzYuHLKxDCeT3ZihoEyq
9081	payment	1726	1726	1874	1	1	2429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHahMMjtBrwXkezm5DSW9m7KxPRxBrtB6sRZc8yVEyHRJiUi9Q
9091	payment	596	596	1981	1	1	0	102000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8u7MCAaQdz99zMgtPu6ZfALQkjBdAzJoSQDCwVXpfwSSEUutK
9092	payment	700	700	1980	1	1	1	7197000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxRgs9wCNF2nRv8yqGZgomTq4J4EVsSMRhHxs5AdCYagwd3Yx
9093	payment	1726	1726	1874	1	1	2434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmi2deEfdCUfQgGyU8wvsfUcnkXow5bqhN1VschY8xHsk79RQK
9094	payment	1633	1633	1390	1	1	4	6566304342536	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYuZ7V2ikyGL94DvNYZzinToCN6HcUpHq7pAgDVWBEMnjqYW1sC
9095	payment	1397	1397	1678	1	1	5466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqgHzgEkCCFL6aM4gLAXp31qsRNQF4jmjs2XYRwGneH341MhC
9096	payment	1633	1633	1144	1	1	5	3492404720511	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYmXTUaGs7KevH7vXFQSuRJxPg1eVrddr1cfh337zKd1y3TydnE
9097	payment	1397	1397	1678	1	1	5467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LjKe1efTSPaRde5uTJeqzvoVoV6fr57uYHHLAwkukJjAfMWM
9098	payment	1633	1633	1264	1	1	6	2356395056009	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZhnXoQVNyZGmcPZPDCNBtabRoG3D96BXN4oc4peSTK9kRz8dU6
9099	payment	1633	1633	1024	1	1	7	1948895880944	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZcfT82yzGHwtfU9m46vMtcq9TH4ct4X3LtxcpgSRf7XgFeCkLX
9100	payment	1726	1726	1874	1	1	2435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRm8NZXmSvRzbgv6FucdkGKNviZ3V791RTvv1aMHMqXhHCzN5
9101	payment	1726	1726	1874	1	1	2436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgfWiGBtDRBZN5WFSJJJx9jhZ35Ny5WDqk8thCeifKstXVYmB
9102	payment	1726	1726	1874	1	1	2437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6ptHqqoqySFkYcAyncbLHMuuztjadKRLVhCQF7XMYDaPLbjv
9103	payment	1397	1397	1678	1	1	5468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoo86xkAdRpbAahkinVRasKiuCwQRvREvCT1atq53Mt8LJ87EZ
9104	payment	1397	1397	1678	1	1	5469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa9eb87V2T8deZvMGkXoNC9vkJB9EGKtKqmKdcR9TVCeirukM
9105	delegation	1980	1980	700	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5Si2eyiQz64oX5sPhhFgjKuD3e2tEy4KbbJUM6TdnVmNpbE8
9106	payment	1397	1397	1678	1	1	5470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKfbfT3MtzPa7a5PUQ87ppELVU7CjGGXSxdQLmT6KVPEW7WLf
9118	payment	1726	1726	1874	1	1	2440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQj2Y3rEkCWyFcmHtTvWdsTQX5ZXnstWjYRiw3PoBBrKjtZCt
9119	payment	1610	1610	948	1	1	0	2644336740000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eEo8Dn9whpMGbXS4q7RvmXJruvSxExHEPZ9W4rRzfA1gBrzD
9120	payment	1610	1610	1068	1	1	1	4738628770000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNPWZu13NPm9XkETbkCxTLfs4fL21sJY7y74zGH1PfaFB9ZvT
9129	payment	1397	1397	1678	1	1	5477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePgDGmk6UQi3sbTzN6NmN6wwvobPapvGCvvwRQqgA5w9oFk2P
9130	payment	1726	1726	1874	1	1	2444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZX6Vsryqpr7WD4SPVDnVX76YCfjgowpvR6MBRGuvqYDBMMUA
9131	payment	470	470	764	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtbcGnBD3RVUrSPpzf2rf84srAK4Gx1jNR5966RsmLDKLXdTZ
9132	payment	1397	1397	1678	1	1	5478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKNrqW7cRPxRmR3izBGBGsA4NCqENNYhGf5RKz6RGb8vnwxkV
9137	payment	1726	1726	1874	1	1	2446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRSyFQ5d1wEnZCK9g7GoS5kotqFAAz9WRHmpCe4fjFqgXtAJ1
9138	payment	470	470	1183	1	1	3	2976000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5TSE5hsQ8egouQcZFMpdLtUSSAe6pCmWNxfEKg54WJoP3vJK
9139	payment	1726	1726	1874	1	1	2447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2gfnffDBFBKwDGUn6MGry4E7r7VUzwxuun4wGNEpCka5jCRP
9140	payment	1397	1397	1678	1	1	5480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8UMsgThe3shdW5yDx1uhqB4oD3A2vo56UqhwtufqTFAkwJJ4
9141	payment	1397	1397	1678	1	1	5481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbbfi4RerKNL9t357TzNNZp86VcdTYntHk8EabNTBBym9JKfk
9142	payment	1701	1701	267	1	1	4	263331324931	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZ411s5tQKCzzwYRxwSnBYHiuHt5nfnHzaxrSGwmeYfnKw6AMwU
9037	payment	1397	1397	1678	1	1	5445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3GvxPdM3o3WwfFU6kn4pwHbgNLk8PZ53NTL1VxMAnVdW8i8w
9038	payment	1726	1726	1874	1	1	2415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ebPVCecGjKGRkuwECnzbiLTGbxk8iYza9vxa5ZdumLSQXsBS
9048	payment	1726	1726	1874	1	1	2418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8NHrwiGxtBJikKDA56MqzoDn2wRpg1XEaj2UbRGMSdPNfxbG
9049	payment	1397	1397	1678	1	1	5449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8yrHiJDewaP6piLdqq5NuUeqmLCKv6RW9PtCynXf3WYhr78j
9055	payment	1726	1726	1874	1	1	2421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7f6xbYG6HmUwWYedShTdikKNCCQcn22fQryevAZ7AW2kJJSW
9056	payment	1726	1726	1874	1	1	2422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNCHze2wA8LpF9VmsFuspQ1Qf7DYYnryGtxr5ojTrZXM8cpbw
9057	payment	1397	1397	1678	1	1	5452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALuEMkQrEMC2xJeDUghEY9YqFzN4Yfy3jkPQkxBRfh1Yct6qi
9058	payment	1397	1397	1678	1	1	5453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKzrrhttXFHauRHti5zDC3K4szS9npZijEk4B9TPWLcCeirba
9065	payment	1397	1397	1678	1	1	5457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fAxamWEMTyk4rL86Ay8Qn1SqJB54DbHFFPsnwtHxb2A9foiR
9066	payment	1397	1397	1678	1	1	5458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2MgHht7ES3P2bfM59VUNyszH5cT1Edn5qrw95k83kAgP7vUP
9067	payment	1726	1726	1874	1	1	2426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuaU1SZjrcNpXuUqWc2hvXnMQicrUsF9oidoSTECiBnpVzB4Q
9068	payment	1726	1726	1874	1	1	2427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbetKVw4hVqTtPMXecwBJkjfj5CfQP8RXhxd99fiYLCqtesh3
9069	delegation	1900	1900	44	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQjQs6hhphn7gm9SXhHCtbmrYNYU17QtcK5oCXdrQVGLjt8rd
9075	payment	1522	1522	1898	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1AC4facR3kPsLX6RkWN81r84npWEQip6YZwV7jRuHJZCvSVG
9076	payment	1522	1522	1898	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVv3PLCv4nXrrxMkH96nCx63AhF1mfY3VJber6BCK7H1ksj5K
9077	payment	1397	1397	1678	1	1	5460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGSNRrzSmTUnbfvtm89NL42EoFyedr5beScXZmWyQ6P7qpNYZ
9078	payment	1633	1633	1024	1	1	3	1948	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZN78d6ddrgj9vWJ7aNVYZ78TjyPZg9ShdjPD2Wui22AZDjhDBN
9082	payment	1397	1397	1678	1	1	5462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7c9ZNMiHHSnFYtr5svUoVaX3TKjRZK6pWmrgY67QKJe54Ucv
9083	payment	1726	1726	1874	1	1	2430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZV8b653uEhgz8Gw2V5dUurp1897QK7aY3mbZAPHvFVWGa1YGx
9086	payment	1397	1397	1678	1	1	5464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbg7hsnkDkTjWFR7ynCg8sD5fV1aqdVEaKwXjF3BjWxkGELyP
9087	payment	1397	1397	1678	1	1	5465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6kPq5MPnRBCrBT2mXzLHDXq3FuZ7mnnRe41UonVVdKH1NitD
9088	payment	1726	1726	1874	1	1	2432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEp3DJ6gy1B1nUgEzenFP6GdZZyVSbEvcgd9McnVAWBRxcNsR
9089	payment	700	700	1980	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEtm7XCttVs6TRSuBfkH1bbwH2EM9Qos6EekxBP1N9srvsDQ2
9090	payment	1726	1726	1874	1	1	2433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xNfE9mnzeiAjy1fMyY8aywoWiZa7pw5M2rN1wRpKT4iPeeKE
9113	payment	1850	1850	1277	1	1	1	7596000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	Ckpa8eZ98BmDgxwvPFLShrmowyYCuv8jexRPtuzBRSwqmDm5cY1RR
9114	payment	1850	1850	1031	1	1	2	4040000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYxVbhoZ8BK6AZ5JBxb8g7hAV53Bs1yF2Mykm4moTPQ9qmYoVVb
9143	payment	470	470	943	1	1	3	2462000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvyYjeg9hNvLV4XPKEyVxQbXJKGgXLQA74rjWpmurCV47VTwG
9188	payment	1397	1397	1678	1	1	5493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdq1PZrDX5GjjUPp11pnWE5i5hVBMaMzAyQf34jdkBnuz8Brd
9189	payment	1476	1476	1371	1	1	0	7988000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4E9FsEEzSahoMXCp7L6USnXA4AUMiFzVcbXKDebakHPadzAC
9190	payment	1726	1726	1874	1	1	2459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE7eCLeZo13tgrSMUPacAoq3KV154GX6dEsbEBWwN4ZDDxdPR
9191	payment	1476	1476	1125	1	1	1	4249000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bipzhkx7mh9kJS9862TCd287CVLhuxftfi97iUVzCA2F439X
9192	payment	1476	1476	1245	1	1	2	2867000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Vq4rZbwXoTuPk8F6XYCehM2UWDUkzTwtUsLEsQbFhFBANU3S
9193	payment	1476	1476	1005	1	1	3	2371000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TXzv6J9wiVz5rUvDY2KWBdpdmvxgvbcGqPs7rk4m4QYzZ8pU
9194	payment	1689	1689	1984	1	1	1	1000000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZpw2ASYag2EGnnKdDYpLrZ4RzEVR9wM7waForNWMyMW1xaRGVi
9204	payment	1726	1726	1874	1	1	2463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgDcK2rSW2CWBkSJXWugkfeL8mie6ykdNuG8oAyxg3dKdbHLt
9205	payment	1726	1726	1874	1	1	2464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWH8nAEms9qmtzzAV1QQmCUAZMUfydUYSH6FM1XgGsRxVuxcab
9206	payment	1397	1397	1678	1	1	5497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3v6XdUzNoNMNz6gLU9zwp9gwYiuzeW9zbMpife7BBuQizZhw
9207	payment	1397	1397	1678	1	1	5498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfxrZkRBLfCiK6HvhiU3Uvqzy6kPhJXrtjB48MivNt2WnheSo
9123	payment	1397	1397	1678	1	1	5474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxWq1iKUwF5cV4Wd7heDiCoy1a7kxhyjGk3VowMhqr6JfxnKa
9124	payment	1610	1610	1314	1	1	3	8909413760000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sKw6dK8ZowwUZFzgXgMSjhSHXtHLndbmrupVgXYU3FCkHy27
9127	payment	1397	1397	1678	1	1	5476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7DWWXtB7W6g9WjYSYoksoRuCeNpXrJkzBGuN5jUfjtZt4GJQ
9128	payment	1726	1726	1874	1	1	2443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeJAoXGqpULE8EJj1FkMaXCxM7fEiq9KCXRkhLE3pbicXuWCT
9133	payment	470	470	1309	1	1	1	8293000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6cgC4wdv6tfgsyWMz2DDbtNsZYpsXvHgFt7haqRnHonP1r6r
9134	payment	1726	1726	1874	1	1	2445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqdsArc167sYxKNwSrByekU86mpU2KugakH6ja9dEvcC5dKuj
9135	payment	470	470	1063	1	1	2	4411000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnGoYjKB5BK1urJG2zjs5hqvhqqWwFbr4yVMM4yqrTNmUkdJZ
9136	payment	1397	1397	1678	1	1	5479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL9vyaxWeef1SBVdaLnLQptRiFQqeGqwcDWNBm7Q8ToPU2G5M
9150	payment	1726	1726	1874	1	1	2449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZQj99k8WW7SRwSmepPLSqz5ddHNJduqLdFAyp8u8D1FzjLn1
9151	payment	1726	1726	1874	1	1	2450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oLMie2DjzFiV2cCJn4iFDU9jKmBPS8PHechLQX3QPoMBrgCz
9152	payment	1397	1397	1678	1	1	5483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TnkKVr84XPuWdF1vQPX7BhZ58hKC5VD15ec9efUzjfQMjq4R
9153	payment	1397	1397	1678	1	1	5484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsC7AvsYa5QDySDcd7jVACZgLPTCahf2e6WjnZtk4RyUiGidNk
9154	payment	1610	1610	1983	1	1	4	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqzcCzp7gRiA4fL8CjAiGFBPFYgGgmPubT9ZL2hTYjWHXhDHG
9155	payment	1701	1701	1042	1	1	6	3594765701196	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	Ckpa13sEbX93Aomgktcf9G11foaEmygF1kC8L48njPkeETkd7tk2j
9156	payment	1701	1701	1162	1	1	7	2425460049358	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpaKKpiax3HBX6R8ZLYbuGgD6Y6u8vqy8Rkk9kbsin45xeyBsj21
9157	payment	596	596	1060	1	1	2	4085000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9MnC3qZWsZzdEc1qnnzL275kcJ5PwWiSEXCevnATWmNxMq92
9158	payment	596	596	1180	1	1	3	2757000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oTrm8qVjLN5DS4dtcqmRk1477fBpRcUHzA2CkU2pqbLcazZN
9159	payment	596	596	1306	1	1	4	7681000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkX45DoDarW1PLnpi3g65Bo8dQDPQZnVcCNKqPz3mo5CzDXro
9160	payment	1610	1610	1983	1	1	5	1389103470000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPY8XyYAsM3v2pQcvF1HgC63w8C16n314Po76rwcyU1xERhiZ
9161	payment	1397	1397	1678	1	1	5485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBk1EyddPpoLvFisXGBdQv6ScAJSpPTzLvKjUVSnTFbnu2RdeR
9162	payment	1397	1397	1678	1	1	5486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnX1oFfgmzNfdeTeKyRjbApz3KWKJFSRuq5PiRtcvg7eGAPV
9163	payment	1397	1397	1678	1	1	5487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCe5c3ofi4CSTYmgnYgct8wP35wP7Z1BNxWnvAtN8gJxrDpC7c
9164	payment	1536	1536	1067	1	1	2	4248300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeumThxfHPkPbW1i4piPJQ91f4RaHqN9c6fv2PJwCDXqsVYhEq
9165	payment	1536	1536	1187	1	1	3	2866400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbq1zpxp4SErkNDiVtdeg5bhCD81w22uJhddS5hhEpMmvevS5U
9166	payment	1536	1536	947	1	1	4	2370700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkWiJnQwwxjF437TqftdNZRSpj2KgKrwxmy5PNsvfpuJCyREg
9167	payment	1726	1726	1874	1	1	2451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKt6AnKuuHgf5iQwJcLtjKtDx5F1UnrkegvD6nRzYQE4BUjpN1
9168	payment	1726	1726	1874	1	1	2452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4XGXCaSyiaMVzUH1caVZJsARNHeejxoZjAuTt5NrBNde3Hyz
9169	payment	1726	1726	1874	1	1	2453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkSMLX7pG5rMKfekBmQjfDTBv35arrhjjP6ZoghyhbJbGHqAu
9185	payment	1726	1726	1874	1	1	2458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhke7VN8r65VNsQm5zHEbT8SwkNsomUxN8ct2kXAJJpGZvfXSu
9186	payment	1701	1701	1288	1	1	8	6758760087438	10000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZoDsk872U1KkjkQoi672pGHaBtH2RSK7cqCU6vEPRaKUdsfbpZ
9187	payment	1397	1397	1678	1	1	5492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtMxMPwKg2QQU1EhXuro397LrRCe9rjPVngqf8ZWSmDh3VqLr
9202	payment	1397	1397	1678	1	1	5496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoWMGPzZRYjotKLhMDVBPi17FSo6QytA714bQPpDL1LTvPQtK
9203	payment	1726	1726	1874	1	1	2462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgo85yigZnVjYNpnE8MiKmEFezkz7VpAo8vXD8H5xp1RNwxbvz
9209	payment	1397	1397	1678	1	1	5499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwdydGNuYTqZaTXNb7WrGYVXrcukbTqMgP8W8BFcCnEExPLpT
9210	payment	1726	1726	1874	1	1	2465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xztUjfZhHkMkNppXUUqhWLStyGmEzU3WwAMfxJKSH8gYBJ8A
9211	payment	1594	1594	960	1	1	0	2279520000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQBfDhWQRUKoaqUWuNN5gLBXmEvjoZryLJ9Pw34KYDkSBKvLu
9212	payment	1726	1726	1874	1	1	2466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KMg6CeGi9xX7FcssLvxB3xoDuxxb94Df8zwTRhfsG3nyNLX8
9213	payment	1397	1397	1678	1	1	5500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs8fP4gSbJVSMhwsPyaoVK5sGyKBfvDoGixwi956jjzYvGDne
9144	payment	1726	1726	1874	1	1	2448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9K9haK46tTNgazLCg2oLTMoDnYdBr2oJVufTEiQYGhS6KjhzS
9145	payment	1536	1536	260	1	1	0	311200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmiyHZ6hmD9z7WrcFPLNLW3k3GWsqQzr34PRrVn1qPSFADS1
9146	payment	1397	1397	1678	1	1	5482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvapJ3xy43sP4mw2hhkzN3LKv8irzi1SCZYfQjhcgKUf9BEY9D
9147	payment	1701	1701	922	1	1	5	2006017237021	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZbUzd4b89Lz4Uo7KJRsVFsM5rzGgD5748XjZfBYFR4HCv2Bfs3
9215	payment	1594	1594	1326	1	1	1	7680240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZro97NcWP9WMATQst1gDRx6eEzXh4Xpx3H7EQJBYhmVKdNUdXy
9216	payment	1594	1594	1200	1	1	2	2756150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBpGaJtETMVUo8r72pqPzc2d8jSGDhG4ejwh6D1t7bLq7tavL
9217	payment	1594	1594	1080	1	1	3	4084880000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHebapEf6ykFC3FHE8rrHFkfVnRZyTqrz68HX4sKaHnhLaGFJ
9218	payment	1397	1397	1678	1	1	5501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcP7hzovB7u2Q1ny9p8A4Seqt1ocF5QWPXnFesU9nPcN41A1k
9224	payment	1397	1397	1678	1	1	5504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDLRQXWQXD54rB6cxEBMVnDcWgd2xxd94JhfcKTrXdzNVugXL
9225	payment	1726	1726	1874	1	1	2469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBHny1p6g2E5GjwJCS3pP4eRxQvgUEGTZ41zYhytU11dfaD5E
9230	payment	1397	1397	1678	1	1	5506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9BxMBGkER4NMUwXKBqrFg8sm35fmyktP3uJWS7AhJGSDFqNv
9231	payment	1726	1726	1874	1	1	2471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9W5sDjfQnbXWWjrnrjhgDmVZa28oTqUpHAyBQjjfPthP7c22
9237	payment	1727	1727	1148	1	1	2	2058640000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpWGzCr6UusBeGr61CbM2mETZR9igj5EDX5X3wD1dM6mZ6nU1
9238	payment	1727	1727	1274	1	1	3	5736600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqcy25jjDyRQjzatp55r71ppRHCDaDafJx7ZnbV7QuTqmnR2P
9239	payment	1727	1727	1986	1	1	4	223510000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8hV17ykCx4oThVscrqwWdzvBxYDehoGuXWGKRFhjKhsVvK4R
9240	payment	1726	1726	1874	1	1	2473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiL7Txe6qzmc7dEKAdSkKKL1m6JeE3v4t8ak8TVgJzM9xUAHqJ
9241	payment	1397	1397	1678	1	1	5509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2i7XK9MctHVWhnCUyA3G8hNSGAqvtz5eZzvcgU9AHMrW5iHt
9242	payment	1397	1397	1678	1	1	5510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDhdvvYX6dXdVKPNdKMZq6HnSfTcNLtXJJysoGJHhVj3haYoE
9243	payment	1726	1726	1874	1	1	2474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog1wsdLmSftMvL8H2tJuwhdFfgtHkEoAUTiWMU1F1RqtsXzT5
9247	payment	1726	1726	1874	1	1	2476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7rXdyzzEF7mhas5ou7BLJhVbawqnsQU84rWgtxSBHGMqVSfC
9248	payment	1726	1726	1874	1	1	2477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbE3L2RbUsW5LzUhbw61CLdsuMUrxi9siFGBRf2E9so7zW1rvN
9249	payment	1397	1397	1678	1	1	5512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyoSfmAjPdmiTJCwJ7Pt2QaZS5GkGSXMg8YYTWsVn9mWNYUgx
9250	payment	1397	1397	1678	1	1	5513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNzEwgEV8ZcZQavkYZwhA5JDFVEiquRzwkHGc23wxpgarJCb1
9251	payment	1397	1397	1678	1	1	5514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWLVDz8zSBn853UFEX8SZ8PpFV9MZDTxgnq223nXSn6u6iLvi
9252	payment	1726	1726	1874	1	1	2478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pwVuM3uhg2dkgknk8gFQjeuhsdJc2ZZxyW5wqMsWiUMehptd
9253	payment	1711	1711	1711	1	1	0	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpZMRX7qajarL1KQxZEuLz2ic3jSXMpTf5NnNffxZ49wkDJmE2xT
9254	payment	1711	1711	1711	1	1	1	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	Ckpa1ykKJcwAH7Kr4WPrhStDekFaT4NwW8d8gRBD9xbz3FyNcTAcG
9255	payment	1711	1711	1711	1	1	2	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpYmem5c9ftSdvm4gJAsm3NohVEXPj18MBsXh5cxhQpjQvo9jEov
9256	payment	1711	1711	1711	1	1	3	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpaLU3nXhdyx7j2TAhwxnp7JnFEXQqqg2szDoF6cgXWKmwivvTx6
9257	payment	1711	1711	1711	1	1	4	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpYqjF6pEWCdUsBpjScAnuBDV8uEnP193YPP2LYTQ7BRESjQ1Fvv
9262	payment	1726	1726	1874	1	1	2481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qpajai7gvGEtYvoGwNCqGQ4MKkCpKWc7wFXgppd956L8o5Mo
9263	payment	1397	1397	1678	1	1	5517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrk9vyzniPYVjgSspbhew7W3DaxMz33aXxRKsBWqo9xKegKCe
9299	payment	1726	1726	1874	1	1	2492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfvxy1nC8Cah7SKKDTvqkEkiS6aeEu6Qw5bFbFzgGrenR8nvj
9300	payment	1397	1397	1678	1	1	5529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY6KwVcmwy74k2hapkagmBMJdj2rLRtMdiAY9b3E4JZEUh7P7
9301	payment	1587	1587	1357	1	1	0	7246230000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDEy34mxVzakGa2mADVg81DUqBrejcBJqcTdHasx6DL6mJ1wX
9302	payment	1587	1587	1111	1	1	1	3854040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYnSuftbL1VpdFBt3NK3RuxaMWHSUoSa76Nqejxd5cKVjCZ7P
9303	payment	1587	1587	1231	1	1	2	2600400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtmAaznYv8HebrE73DWqu3bwdX6f6xGhBUWLxiFVazNUq9EFm
9304	payment	1587	1587	991	1	1	3	2150700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMCdK548bn9hD8QFTAUuvjNskcsiR2FB3YKcSyFVBocSVdqN8
9148	payment	596	596	940	1	1	1	2280000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgX8PqNBYiAFDY7Dt2VnKR2gCM7aBhQd2LEmkETzhmAAqnJz8
9149	payment	1536	1536	1313	1	1	1	7987500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ntDd8YJ7VrcY4wZckMN776GpByGGPphyp7dk1zctcN4N9Db3
9170	payment	1397	1397	1678	1	1	5488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHVbdGPYMoJ6ugrShgZXCixGxpsY5ropLSRZ8avwpbAAZrJdx
9171	payment	1726	1726	1874	1	1	2454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSZPse6gzgNbiRQX41XUoZMNhMRVNvtjSMicEWkrMJWjvNDDr
9172	payment	1536	1536	260	1	1	5	936300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURoAQqSJdc4i7yREQzSVB2tJ14qTCAmBSpXXLbFTBfPveWe7Q
9173	payment	470	470	943	1	1	4	2462000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMXCotC58EdhrQ3X2ZGvP22EKAEx7ezcCjfkvSPrEyzxccwhA
9174	payment	1671	1671	1365	1	1	0	9523495762713	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFVADdWRBZeLaTvuNEQarpCkbE7R8w78HxUEQjtDw1P1DBwvE
9175	payment	1397	1397	1678	1	1	5489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF97n2euqiAzna3NVQGPFqSBJdjSVe6EyMYwP2esWzxQBn33x
9176	payment	1397	1397	1678	1	1	5490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyCXiBqeJDMMm8YVUcQbccNRm9xAdnruBJoCt4nayU1HKkaQu
9177	payment	1397	1397	1678	1	1	5491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkUJBJve2rScjEErbdznmVGdSPejmdw78k52FTVdaGScdd5Y1
9178	payment	1671	1671	1119	1	1	1	5065239109009	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPECqevQiXixT9SKJw6xo9Q9SeCLvovcCJ7fA1z6Yy1qjdnky
9179	payment	1671	1671	1239	1	1	2	3417617758868	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEnNRbUx4i4hbRL7WDoeF8o49YFib71uspLbh3RC2Q6QGgcZk
9180	payment	1671	1671	999	1	1	3	2826597838895	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYdmU9W2Uk366ZoQDYwqCDqmHASisdjYWavjL3WPdWpBxbqjc
9181	payment	1726	1726	1874	1	1	2455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVS17fnznghHGifXDpEqB7fmbW6DeVYMvZLqk7FBYpdiEVj1u
9182	payment	1726	1726	1874	1	1	2456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN73AYrYTVfLGaKss7RYrRHkvNy4EnC7XxhF1phsvViLNjZ1o
9183	payment	1726	1726	1874	1	1	2457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17FTtJJJv6SoC4wKvgMWtAkiBvDzMqrQHmvM3fyhzWgivRTTm
9184	payment	1689	1689	1984	1	1	0	1000000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZqUh6CdvWcYiv5qDyW6RBvR9Jqzzse5sWqgfTJywFqEPwJ1DeX
9195	payment	1726	1726	1874	1	1	2460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33r1gUikvAmJNNmQNNy1nYwpp7rjLLxorsxFJbvpDrkU3Y5wg
9196	payment	1726	1726	1874	1	1	2461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuyGfWJSrbcuoPNwsF289xE4Q14cAHgVuSZQUL2LmYbdLM3xF
9197	payment	470	470	764	1	1	5	1298350000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACieAkuCvbLxEv5BUCFXNi3GSBq6fWPCLwn5dDYmk4MqLjCrK
9198	payment	1397	1397	1678	1	1	5494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZriJaBNpJhHPmVBo4Nd1KEtUchjTz9mYPNnfP45AbLBnhnupPT
9199	payment	1397	1397	1678	1	1	5495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNSTsFt27XHJ2pYmGQ1jun1BXj4AoQp7C31LiDUngBbXVpnDb
9200	payment	1476	1476	538	1	1	4	1245340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2ZgVUw18UJjswKcd52hAgYQbMsUSXQF8yA5vG7VkqLkEw1sT
9201	payment	1689	1689	909	1	1	2	2369438510546	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYkgc4CkeYphLnJUqFGi8fceoUqR7HAzhKa6GhPjZyKVGbXXrP2
9234	payment	1727	1727	1028	1	1	1	3051110000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6CqHoLZGFPQpeKmCm3sQh1y5D5Pn58bZPMNWPYu2WBx96R8Z
9235	payment	1397	1397	1678	1	1	5508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Pt2fTtxpznSC865kymCURs8zkrKxyE4MU8JnozZPFsy3WP6H
9236	payment	1726	1726	1874	1	1	2472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pApZmRyTead6uJnp3C3Mx6D6p3bB7kkvRzVjfwqrLUjxDAFB
9260	payment	1726	1726	1874	1	1	2480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5p5KWqxHARCFXif1ugGZtKkSyX5DrarJ6MdDApkC47jQS9sD
9261	payment	1397	1397	1678	1	1	5516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFH7QB43ijDhhgUmjxPMhqmQJCRosndzktfrcn7KEVc38osZH2
9288	payment	1397	1397	1678	1	1	5526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6nW1GTKaxr5fCaW717Z1TiBwTWuAXNHH9CFpPbWyzv9miJPw
9289	payment	1397	1397	1678	1	1	5527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbgCCsnKqnN56B6rzM2S5bZFsKy74XhRr4BfZHt5zQeG96vPs
9290	payment	1726	1726	1874	1	1	2489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5M6Lh1LnhwAWFyJzsUEQEVQN3JHp2goPg55QoQKkMGpLFxYs
9291	payment	1726	1726	1874	1	1	2490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoGvL3jBxvKzwUEkfMQycjutvuGtf44TpGpTHesTruEQoFWHB
9315	payment	1397	1397	1678	1	1	5532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZPRN1kCQxi44nfugJhrNvRKkQdrgCjWwRSAkq88vFsyqecSu
9316	payment	1726	1726	1874	1	1	2495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhBVoNpmGDJS1jHojXAHZukHdrRxCVTNzrzv1SaiiMFvZFKcs
9317	payment	1726	1726	1988	1	1	2496	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvtgZwfMs2YEE7Syv5L9yAdarRE4LF7LGne74wSXGXvrBM2jFt
9320	payment	1397	1397	1678	1	1	5534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgjBaT6rT3tpxS9Pe7UDjvXXNu4cQt3gjnZTZCN6kkKuxeYcP
9321	payment	1726	1726	1874	1	1	2498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2zgQxDVzEa5ZoAHMzp5SfAxfFBtNSzMqF5oeZ7XPDccRK8Rj
9208	payment	1689	1689	1029	1	1	3	4246013509549	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpaG1x9pcYMG4b2xXyyTEGityrFqqedfpEPd9CSrT1xXNUVxMnBP
9219	payment	1726	1726	1874	1	1	2467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbs3rpBMzsi6J8hUL9moFR4HGF5avSFgxaBjbSLcDJF33L5Ce
9220	payment	1397	1397	1678	1	1	5502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wJC5L6nY7cTMv4S3ocm7Zq6UF7y9spwTmsewaqwAAYfqqZgW
9221	payment	1689	1689	1275	1	1	5	7983214769602	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	Ckpa1MMeTSbpvJpJaB9CcKsCJtLr5foTZc32ZduEhvYw8M7LWGsbo
9226	payment	1727	1727	908	1	1	0	1702640000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLe979jBXSoXVm1ynUajcPfQkzA2cgVZvKST3z7PeYuh8cJZwx
9227	payment	1726	1726	1874	1	1	2470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhxyWKjejU2F4tG8QLqTrU8yVoF32ngT7USEik9UyTQrmxrEp
9228	payment	1397	1397	1678	1	1	5505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq819RAtJdgFBotvU2H5ZKz578ZQqN8Bw222ss6FxeXJmuxzTw
9229	payment	1689	1689	1984	1	1	6	1253900000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	Ckpa3ThThCQxGPFn9rWicS4w2gQKKKghJphwUcXAAGKfASunu9Lbp
9264	payment	1726	1726	1874	1	1	2482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVRih8hWstcFF5x9CGKe47ErmDLJvYNEoPgLWhwA3LAdtQkjJ
9265	payment	1397	1397	1678	1	1	5518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeM9Dmwntgq94VmpBfkB9vDER99mEECqVn1LHNddPfKhaEKhmU
9276	payment	1668	1668	1987	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKjhhVBoDvsaNpN3MkwdXUVYdMznAtFaXSW1kTYBvx7c6rzH2
9277	payment	1397	1397	1678	1	1	5521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVcjdQdqBuBXTtE2fMe7LYrZnQW3ckrxJLF82mikuCAkMkYzb
9278	payment	1726	1726	1874	1	1	2484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmE6UYfxWgAchYgBUDeXzYSPVg8YLzf7dApxNkpFkBbVoaB3Dh
9285	payment	1726	1726	1874	1	1	2488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkftTVnVXsAQ6nCmMSt4bYMq96ejqRi1WP7WKYs17kSokA4vo
9286	payment	1397	1397	1678	1	1	5525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpdxUL3mebije1F6TEuZpB2rggGAQJc6qWZACVNujWTJeJcfj
9287	payment	1987	1987	1668	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVtZQNCeuodmXPezJoqxUHcZhKRBhgsYMbxQhfqgbgWms5Ddq
9326	payment	1397	1397	1678	1	1	5537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ki88pnbcMkXiMj5azygvpUsWd5s7Gd24vKDahetF56ei4VUY
9327	payment	1726	1726	1874	1	1	2501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeZGEvL3yXbr14ogw75D7DUXVBQZczYej2pCcKGVkAKd2Gi3s
9328	payment	1602	1602	1989	1	1	4	861340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3p7Btfijo4z2V19TwBnxw9y47sC8eSTJUBr7E9jgmxa7o8Qjp
9359	payment	1726	1726	1874	1	1	2508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmudnhqS3oBvod16qr87zqbosksvv1DW3Dnpg2EPMMWVZvFw63
9360	payment	1522	1522	956	1	1	6	2006000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYy6i9yzuCwxWAMvGsRh2fefzb4mcBYu9Bi9NmtQ2SeaPhg4MZ3
9361	payment	1522	1522	1076	1	1	7	3595000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYT9ft7L7EoSuZerQeGA2hG9vm4pRtXeBeVgGi3muvNZHbEMLnN
9362	payment	1522	1522	1196	1	1	8	2426000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZvqxvPLeNegKk9XzVyQ1Fp9zSBsKEDg95mATdErx49qjERpsjp
9363	payment	1522	1522	1322	1	1	9	6759000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYWozY8FYtfY9w121SLFHHjY9KdcLuTMsEgTpT35bQ1wqJBgcxg
9364	payment	1972	1972	1974	1	1	10	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk3Xi32iLdNKR7ozkH7cyY42ziame9i5TYk9dvCK6tRoqytgQ
9365	payment	1726	1726	1874	1	1	2509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfv3r1kfCqpvxrTTpGZRF4NnXniuTvsQQcepeKWyrzu2EnVoS
9366	payment	1397	1397	1678	1	1	5545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bf8RBXMqEpRBR2Mr1NiqbDukebGHB2iiwGbfnTYg8D52uCtt
9214	payment	1689	1689	1149	1	1	4	2864869922689	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZoA5CvQo1f43H1tfybbHVttbGX2qaeu1c2HzAEeX8FnehCEAaf
9222	payment	1397	1397	1678	1	1	5503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwZMSrhWTGHBTUTVD2rnwNTMZio4WwmoV4JH11ohy7hYZDV2c
9223	payment	1726	1726	1874	1	1	2468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdx8MBaFu6mESC8su7R1DPd9RACrMG4HhL5VRNtBsUmpqZEsmV
9232	payment	1594	1594	1985	1	1	4	1198000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkqEqoK4muyUExNVh46i1f83Duan1aFiQ2Tnfo5iMrThnZ5wJ
9233	payment	1397	1397	1678	1	1	5507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwQhfdFJVdSb29FZgarZVrA1uKpe22eJsYmGSpB4Xca7JjgtB
9244	payment	1726	1726	1874	1	1	2475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrYHQQafssY9AJgBnbhNH4tB1FcGuMT56VjsBjFJCY244ejXa
9245	payment	1397	1397	1678	1	1	5511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN6f8NYgjh4RP9VTCCeKpANDWun9XiiHc6hRMUwd7KbrPMZd9
9246	delegation	1983	1983	1610	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjRytpVrzNTMs7YRY96eamKnELHUSpydcXcQ4MzrDZDn1NVez
9258	payment	1397	1397	1678	1	1	5515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZndBVm9wT7W2GhH1jMuxgVpnYNzhS7pqRzPKwHUb5kxLZYgVp
9259	payment	1726	1726	1874	1	1	2479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUwfobJoQdjGGsKCD7biM17FjNVfdVPTeDJzGddMAVQJgzK8S
9266	payment	1726	1726	1874	1	1	2483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogEohsZqapvtKYz6Zcd3K4cTCswWJL8tk589kZo9Bq7NLYCGt
9267	payment	1397	1397	1678	1	1	5519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwDMpiLuVgficdMyqU8MjGuFXHxfivZSmEDJzuZJWdZZ6vvjH
9268	payment	1711	1711	1001	1	1	5	2371000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpYv339xTmHuPUhJhLR9sTAEHTkQ1z6chaPZpYyC7U6w8S3PtoC9
9269	payment	1711	1711	1241	1	1	6	2867000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpZ21voe9g9ykWBBYpbkvgj2jfhExXYtrpE8JVN4EQSZcpVfQWA4
9270	payment	1711	1711	1121	1	1	7	4249000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpZx2NWTNc2n2DUK827SoRMKDis5YeGuyjbb2FLP1TmrbQyUj2ar
9271	payment	1711	1711	1367	1	1	8	7988000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	Ckpa7P8ELkLfEfgEYfCKar7ZWuvdoyKG7246Bf6WLMAWxpfhmUbTd
9272	payment	1397	1397	1678	1	1	5520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAacd9TMiegMCFXx9YnQjZusCjHi4xEb3updHBtLVwFuXu1sBS
9273	payment	1747	1747	581	1	1	0	300100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7VbGEj5oJrKhSzrnDenbGfYjzqjTkPwfTiK4xiRAiGsaEtLu
9274	payment	1747	1747	698	1	1	1	300100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGW3nr6SnGLGkoxrDuazNBSXQ7TmZmc2PqfJzE2pc9zzHJhKvx
9275	payment	1747	1747	742	1	1	2	23100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9XUhzYBvNBJBjHxYV4MQsatNjkqEQexVheocVMzxczL8zsTW
9279	payment	1397	1397	1678	1	1	5522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEih1XTw8PyNLHeFMUftbKo6J8hpMWWUbZkSTL1hoRsC4PaML
9280	payment	1726	1726	1874	1	1	2485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjQZC6g2vVrPKquL7j8JLYkzN49wogcaJdf5HbAjUqZp48eZK
9281	payment	1726	1726	1874	1	1	2486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4aqGwNchQSUxmxjhkDeHm7QjXCub75tcjqfXHoAQp7c5xo6n
9282	payment	1397	1397	1678	1	1	5523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKoWgQKjG3cyfQ6hJAvB1BPwqWfMfg2NWE2aLWHPV7WUwPVNA
9283	payment	1726	1726	1874	1	1	2487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHujww4R6bisJsyLt5pnqkF2L1GNK9RofCbf6EJnLujZ97hK6
9284	payment	1397	1397	1678	1	1	5524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMC19o4zdu7UdFwYZdv7dnkrdETyPHEz9LVjNpHHhnN6CTG9fT
9292	payment	1726	1726	1874	1	1	2491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMs1ibp6uoXq3YFhYvi2r1GjuiJUP6UGvDjzcDripMYV8eUd5
9293	payment	1675	1675	976	1	1	0	2228000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi46eLysRjmwZfgZTBPq8MSq8XWKfcw1QdtvBZ9FreudRy64sm
9294	payment	1675	1675	1096	1	1	1	3992000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUU4cGXWXEE3gXyq6FYf983Ju3soDAnHTHy2ztx2YsUwG4x53
9295	payment	1602	1602	1003	1	1	0	1642000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiJgHW2QoKzsDPFX3mdxYSFxZx76XF4YtX8jwqFyNi4CNDT4A
9296	payment	1397	1397	1678	1	1	5528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFXGSmCDTy5dWXHKxn38VHPutZhp1AxnVqFFZbLNWi9ehmM3c
9297	payment	1675	1675	1216	1	1	2	2694000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86NbyAsE81enyQDG3wPH4YY2Q1JnY1vk9SEVTFMuR1bCwQzXC
9298	payment	1675	1675	1342	1	1	3	7505000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQhDSMXAnpwt2uQc8EJGKanH7LPoEh9KDBZLb2TqUArWBXGNF
9307	payment	1726	1726	1874	1	1	2493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Ry3H19ATWi9JNz4wFBk9jb7Xn2amJZejNv15LUMZJDi43hXv
9308	payment	1587	1587	272	1	1	6	864244000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcGuXG3i6DBJHTHHE1bAr5h6XUN9Fc9WSoYYw8QcpsY5F9TTR
9309	payment	1726	1726	1874	1	1	2494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ivhNwPDRkDjRBdq94rrCXkxyDkqfihzVsaswcvRyaDYNSRWv
9310	payment	1602	1602	1123	1	1	1	2942000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAatFdJaApCyFqTHYeHkoLXzUuxwuouGEiudd3S6Qft8Z7XdG
9311	payment	1602	1602	1243	1	1	2	1985000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJptUt9PyS41kuU2FFrTcgX8KdFksFofnt4yLEcuTkjHWehk9m
9305	payment	1587	1587	272	1	1	4	282330000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHrefz5pEw8zEECLjDnPp32crTNW9Vt5xAfsP1XX8sffcmANw
9306	payment	1587	1587	319	1	1	5	282330000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxY5KEi1379DGoAVTMh6tWPA16ZeYb8vvrYi7fMJnuSHNSg9L
9318	payment	1397	1397	1678	1	1	5533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6P9nVc6QRtxsgo5qozrN5jnEjeontKzU1MVLrnLmSyMzzQHg
9319	payment	1726	1726	1874	1	1	2497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXU5vkj8gxWFBavgBUNFXboWBHRqzqPoEoDkUu4YiHWh62jXD
9342	payment	1397	1397	1678	1	1	5541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYNqhAJsYiiCQNkgBCbjgYwDZQ18QRaaMWQ31QKsHPbGHvnrp
9343	payment	1397	1397	1678	1	1	5542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgYEZMXquNjTv4GrvR9nsDZK1gAUpauLf319Np7JhSf9XVy68
9344	payment	1726	1726	1874	1	1	2505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2n1f4Rz3yHkrhj1uN1kmNR1QX2oJ7QPXECbSYAmVRfGgbsZrk
9345	payment	1972	1972	1974	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZno56LwgpuQNQzMjtXDc2eBwvwKwNiwMerrHLpQf3Efq4GiUrQ
9312	payment	1602	1602	1369	1	1	3	5530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4YRpC27mJYTHjtUvej7dqsoZfSmDaN74HurDRs95mveEGtzY
9313	payment	1397	1397	1678	1	1	5530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQUyfCMLZVPFvvpiGqZtzpx6sCe6SS24eSEps4Cs5SG3FawdT
9314	payment	1397	1397	1678	1	1	5531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bmmiv11DuwygNsTCoEJAddAdXMFpVLbHq68H4L6kQXZ8jXd3
9324	payment	1397	1397	1678	1	1	5536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPZdo1sDiiRkCRg6bvUNd8FmSLfQKJd9DJKZsxEPydhFh5ht1
9325	payment	1726	1726	1874	1	1	2500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwmKBU3U2WPedd83CYrzsAr2kuec9uTox2V4jeY3UXj9fkgsV
9340	payment	1726	1726	1874	1	1	2504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqgJgi2KfZfQ7wmwmpC6XoWPyKnRspf9kkxWQwSskhTe3poAX
9341	payment	1397	1397	1678	1	1	5540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AammimkvQmRMP7j7RUikzighQUBi8U1bjBnp3k2CEFaoTTE5
9346	payment	1726	1726	1874	1	1	2506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwF3uR7Hqv1NUTavceSU7nDzMqJzGyNgkRW8VK4zz3yWPC9Lm
9347	payment	1397	1397	1678	1	1	5543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB54zhKA2UGSyTGwnSwK912ipXnqouPcHoDVRKc6t4Z178LVJB
9348	payment	1972	1972	1974	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqo8sNSH6XtmzuormUa9FUi26wwtYDuaXYguZseiUvk9GGhYp
9349	payment	1972	1972	1974	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFwm64dDBP6upt7Qr7zmFAxddEiRJUkFshnyub7m1oM9LJSNW
9322	payment	1726	1726	1874	1	1	2499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpACcZ5Y2Xi3FgHRwruvcA6g6Dix5mcMcia42uhhGSPf7JHQ4
9323	payment	1397	1397	1678	1	1	5535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYoUEKLKzxykA654bbDXjpFZsR4CrjyCPPVrqLXFkgzTfRjxb
9329	delegation	724	724	498	1	1	4	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyX77HVqGiMrF8AiNtQ21GnFPDb4nr15dMQ9dbgwdEdXc8Rgm
9330	delegation	498	498	498	1	1	2	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcR9QtNePtJgCJAYn3i9au8qMXhN2d4ueppty7CYNURczDPsu
9331	payment	1672	1672	919	1	1	0	2599000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsg758t2KmFdM3asKo3k4oXqKWkV7KoTRfZJNqRHGtqc7CueiN
9332	payment	1672	1672	1039	1	1	1	4657000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG36bEwPPYtpBykeajbGWs41pW9EZMDK6zdp9jXMYdJJk8mDw
9333	payment	1988	1988	1990	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELyGFYoktqsAjWAG85Y2pA36qAN35Nt37UP3oXHK7aLKdxGzt
9334	payment	1397	1397	1678	1	1	5538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXYxQs7g6MSB33ejfAZMmHZ9ymDFMXx2BVJHZdJqS97XszjNF
9335	payment	1397	1397	1678	1	1	5539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjRykQJB9FytjVbAcgmqw9yn2FvfYreLxyAkov1PgdruDYsQj
9336	payment	1726	1726	1874	1	1	2502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxq82MeWBohwcS7aLVCadwtEpJucbPHJZm6yBBZevDR8Hjb7Hu
9337	payment	1726	1726	1874	1	1	2503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEDTt6ydgaWeiXLJBBMSxBbAoQdCXEAPiWKQRs7ZzAnvKuAiV
9338	payment	1672	1672	1159	1	1	2	3143000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdAiXjzaMebLr38YRnNwTLK1Ep2MemV73Kfz5UmWmcYCfH41D
9339	payment	1672	1672	1285	1	1	3	8756000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AcHbYbpJpzhs5j6KLZiZLFVCmw3L7zbdj2BpEiwGdxJmUpbz
9350	payment	1726	1726	1874	1	1	2507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDAzDoc6ATBLJecfcpkiBqoQnQCZSNAk5m3x8rgqZD34HidQv
9351	payment	1397	1397	1678	1	1	5544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHvrtSjHYGeVgQx1ycYJ7FmPQRBxk1JmTzmqDb2Nv8u3ndEyp
9352	payment	1972	1972	1974	1	1	3	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRNpnVynW5aidyWywiAtajoRmhhWcN54zvXPRz6mUXWPSjbt4
9353	payment	1972	1972	1974	1	1	4	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNr1NJijwtEu61VhbXYQVwmLudqhasS1xSxed1h11guXCnMSw
9354	payment	1972	1972	1974	1	1	5	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCydXu6qV8LVQU7KKoF99PPwKRLUuWUVvUp2yB5y2a5EaixmG
9355	payment	1972	1972	1974	1	1	6	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JHHiM56za2wJN46kcb4mTYWEkSbzwKCcjHHEEpTX3jJU33k8
9356	payment	1972	1972	1974	1	1	7	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8xUvRXtJEXgwE56oKZkoqjhpsr8LAjn3iMWG1BBi9ZLbRPdK
9357	payment	1972	1972	1974	1	1	8	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ui7TWgARRowsYJgJjtpDsc7yDJngvxChen1Z4PXm997TXGvQ
9358	payment	1972	1972	1974	1	1	9	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWd1KMWuWGesU6HmiaHqJj8kSuj1vhkW9QgTpUiKVExkzFzKx
9367	payment	1397	1397	1678	1	1	5546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPTKqy6QUG7FaRa1zH5Vp23u6aEJyy4T9jtVE66UUVdJynZ5c
9368	payment	1726	1726	1874	1	1	2510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzs6gcWPxM2PsxtyoG1gWNzFePmvgpn8iRz9fmGx4amomtUrXc
9369	payment	1974	1974	1972	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFPgs3NSboHv45a1oZRsFsETmtGbYCWV8ezwUkUdNLxWQXTxN
9370	payment	1974	1974	1972	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJ3NJpuTV8t1zxR1DZ8QpZHLqK6KpCsbALkL1NNfbbRj14pnj
9371	payment	1974	1974	1972	1	1	3	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1r4Xiq64CTN9ahkJRX1BcejwtawyfRy9C2GYibm3zHX54tjG
9372	payment	1974	1974	1972	1	1	4	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3YMQfioNEskbPGWUXEezJwMReMm8XpxgGMFaK4C7ZzKH9n7i
9373	payment	1974	1974	1972	1	1	5	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pSUhRnqxSbuVZsH29fHkZYUDG9EyeuwtrWvbGncveQaSFZRx
9374	payment	1974	1974	1972	1	1	6	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AVXa9PCnPR1E3jC9EUhFf5TyxjhQmyKAmXQYqQVqcFHyTVx6
9375	payment	1974	1974	1972	1	1	7	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWYa6ysu9Lrnf6JfDMkkftfzjLiJmtC7ipVj2U3UaZxwL4mYr
9376	payment	1974	1974	1972	1	1	8	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2mHHvFn8DN9nf1g92Vno1v3dHjzZDm1VP2QxzvNwXMWGe961
9377	payment	1974	1974	1972	1	1	9	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfKgnU8yJ7Ehr12Go2BpxU78pSgZPKjSTkW57c2y8q4HtxwDh
9378	payment	1974	1974	1972	1	1	10	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJPpoQktcq8i7vp69nJJLmavWCuj4386wsHAARoQh36uEAy7a
9379	payment	1726	1726	1874	1	1	2511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyveZX65wSmJ73Eojo2zzacBJ6P4om6twxmfmdfNTF1xuNiapA
9380	payment	1397	1397	1678	1	1	5547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FnwgqsmZvQFaqvkqMn8hLYbvFCE4V1Fs1B3fbatnHQk8x8we
9381	payment	1972	1972	1974	1	1	11	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAhqN7BAbTZVJD9dVjwdewE5vPC4yZoEGZvL4bebmfkVv2H4T
9382	payment	1972	1972	1974	1	1	12	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8wBtYrY6cdF7NQcc2LWWQUsrwimThjrUk2hpQwp1qNmFEZ4e
9383	payment	1972	1972	1974	1	1	13	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAFsrZCMH5TZRLsivLsDUMeFqor264Vf9aKm79ZvyErniUutk
9384	payment	1972	1972	1974	1	1	14	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRmD5pBbmJTZJ83STUbgxkXWJxV8ptdgwz99g2aJdcKQEpdPg
9385	payment	1972	1972	1974	1	1	15	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVe8VMhkvQ27bGDj4DCr8hgu2sT6HpKPa7TtAphSjF9sMbMmx2
9386	payment	1974	1974	1972	1	1	11	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhcGL66wPrDsvEcptqrvahXJWWPaNTbZiJYBtdHTqpWxn4uSW
9387	payment	1972	1972	1974	1	1	16	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMtPBMjvivzzpqEnhccm2yHgFLHiux7KhSaBXGmudHNFae672
9388	payment	1972	1972	1974	1	1	17	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyz7im6CTUieT7kDg3NLrp2n4KiBv1LR4kZY3UXLUA1RHRm8G
9389	payment	1972	1972	1974	1	1	18	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxySb8TtfGoFprPKRbYXHmNbW96sFNF7ESSCZtHoV4eSgYdPs
9390	payment	1972	1972	1974	1	1	19	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6yoEVZeecASC3ALEczv1tf5fUfTr15vJgyZM8T6TY19ZdBBm
9391	payment	1974	1974	1972	1	1	12	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHRTj1JRXUrmANGeqZS4bUvEFHv2HqpqiYXh1DpMBktWVw97c
9392	payment	1974	1974	1972	1	1	13	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1LtxJ7wfaRhnaGqFA8XcwtZKE6LCuzgfiSfegK7TB2zNAgj5
9393	payment	1974	1974	1972	1	1	14	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNX4viRiXgsxYnAfGDYeUn4D8hgZ1sZDWeezzfdRuGwicTDD9o
9394	payment	1974	1974	1972	1	1	15	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9DDAZcZxgBugnXLC7aJZNfzRZ8e3nRmmkcjMZaqUabe4gz8b
9395	payment	1974	1974	1972	1	1	16	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMLEfCbm7uyRa1QXgfBQ8pPrey8EVPCocgiNi1YGRf38FaWDg
9396	payment	1974	1974	1972	1	1	17	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gmushzD3SiAQkXUhkLxfK4TdReYob8kW3KnmxTLYk3mqFRnS
9397	payment	1974	1974	1972	1	1	18	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCjqMvdzjcGHNGKmqPQWxDsxmUzQRX7RQyviXNUYd8j4KT6Mx
9398	payment	1974	1974	1972	1	1	19	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Zvk7jmazXeeBD3uy3acG5QZZvWiMFXi97oqbtkghno2Ud9kd
9399	payment	1974	1974	1972	1	1	20	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFUY9EhqDpqvwPf9Mtgdb2BASbJ5wzhEANSELTvKwJNNi4cEi
9400	payment	1972	1972	1974	1	1	20	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSQFfWTfqMPzeoN78R3JUnDBwHs5VWuYD8d9MFvrZ5T7rbw35
9401	payment	1701	1701	1288	1	1	8	6758760087438	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpYVjWwURtPADigF1oGa9Xoua8tkHRokD1myb1aP6W1Sbjrm2RrZ
9402	payment	1564	1564	1338	1	1	0	5837000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTX8hWfCgAcPDMPExZjUxdvWpNv7MMvUnG3i8LRGicLuX9NfY
9403	payment	1564	1564	1092	1	1	1	3105000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCaLJypvbF1pZgzutfP28YYGhhwNVbiBqgmuVwZda12hiedBt
9404	payment	1564	1564	1212	1	1	2	2095000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEuqtfcLqnqwMMnhxxXChE6W8aPWrWDUyozfgapbKVsqBqUWS
9405	payment	1564	1564	972	1	1	3	2095000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBDp3qrv1seX7QwKijpu6DAu4edv35KjpVrwiK9DEdBsACHAn
9406	payment	1397	1397	1678	1	1	5548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TVwtmniahK8vi4awJrVbELG9SskJWHHgEcBdiZeR4di3UsdN
9407	payment	1397	1397	1678	1	1	5549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn1x4r7i78YYnzknHnTuuMPM5p6khgaQYMuit2vrht64CZ7F9
9408	payment	1726	1726	1874	1	1	2512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQd6bBFK8TfZVDknEVwwoH5Cg7149ArPF3kfjkUb57ZgWXjKP
9409	payment	1726	1726	1874	1	1	2513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdr5Hb6VssrsJjfZcJsUdGs7b2mNPz3mW5RgA95Y9TksBgvvZG
9410	payment	1397	1397	1678	1	1	5550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpaZTFfJuj8YAL6KUtryuh9hfpT41yE4Nfu1QpZj57igQfRuf
9411	payment	1397	1397	1678	1	1	5551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZkpCKoqBk6Z2B4hubAnbLMhTkwkqyDtQWkxCoiXkqMUXDdei
9412	payment	1726	1726	1874	1	1	2514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9gNwMd5618YYCQSmhsmjtPDpp63KiKA2C3q85jVeUnhtCmp9
9413	payment	1726	1726	1874	1	1	2515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDJiakXcFfKupq7q44vQpVa5vR4bng5e8NcaB2KA7KWbG1wNR
9414	payment	1668	1668	1004	1	1	1	2739724000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmrTtZWUSDj2fWQhGBwwJmhw36MMHLHXW2SX4yzFNAM4iFHFs
9415	delegation	1974	1974	1483	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45AB2RfXxHLDctuQWSbngjB3sCHBuw5ftyJntj82ZvNNr3bqo
9416	payment	1564	1564	588	1	1	4	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnM2oURWAadfe7YfNpods8iomwm7dzFmKg92Qm3w6Dpe8PdmDg
9417	payment	1397	1397	1678	1	1	5552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam3Nm21FoFnCAZnBuLN7N1LiRaa5vK8Z5SZgtke9HxMyR9A9H
9418	payment	1397	1397	1678	1	1	5553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AmwZ7YoQ6azq7ACGGWejzsNfRDsh9wxwHmuhGzSax7CbLEjP
9419	payment	1397	1397	1678	1	1	5554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1MFM9EG4EJ3EdE6skMYacEygLwce3F8sWW5e53fqgsQvNbEm
9420	payment	1726	1726	1874	1	1	2516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5Wu7hJHJpWvwrFBCSLQRUqM3iXnzTkTUcwrpsLAP7gNZmT5o
9421	payment	1726	1726	1874	1	1	2517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWfVZA7auN3s477sNav9v1WKhUGvVACSiJw7iKD2jEpkZA6h7
9422	payment	1726	1726	1874	1	1	2518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdenvTo9SXTSum7frmV3tPM1V4U6588qgRJ7YgFHt3vdjczbb
9423	delegation	1972	1972	1406	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuMLraa2pygWJk8ptv4Ukio4U2fPFerVGTm1Fo9AfRPCQLRRR
9433	payment	1397	1397	1678	1	1	5559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbgvtkFV82VKdDakngzunZuPSNLqwoLX2NV3Vy5MHEP6TWyM6
9434	payment	1726	1726	1874	1	1	2523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD5ZN6oAg7UrZYRhthHzKY3JeduWY8KkmCxezmYiyddzq3JqR
9450	payment	1397	1397	1678	1	1	5567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4jKg7E6FkXejKp1Y3KCnyoRdf153c3vNNYJuwMqGVpyPEwas
9451	payment	1726	1726	1874	1	1	2530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwRxLLavqwL8g8aVdPzrBHmS9MkUKcJkqu1g29QDWCFMWe8tp
9456	payment	1726	1726	1874	1	1	2533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc3Kfo8rWMV7kLePuatB3cxKgYwsq6kzrdeiXuf41ehvnzAhr
9457	payment	1397	1397	1678	1	1	5570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hCZhGk21UzsqgAnwgmWRmH1bCVMD3fBhSwkNhtGKYjbuwpjh
9460	payment	1726	1726	1874	1	1	2535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkahXx7MGCeSke8LAGJ1tbAwPK3greUgSTotocCuZkFKazEyso
9461	payment	1726	1726	1874	1	1	2536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLNxFtp8hxMuAsAQqG2T1rP6zNEEjNBwQVCw89nqWgtH8DPLS
9462	payment	1397	1397	1678	1	1	5572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGaBCoGb9uxUaSPrtv2ENNa9fD91p5DuRGuWwVXm9xzyimzbe
9463	payment	1397	1397	1678	1	1	5573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7iySJa6L66A5P2Yguc962A6r1rThdvpqqwfN4HQZ9TjYYNLG
9464	payment	1397	1397	1678	1	1	5574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftb9VfWK6Hfff2hS4tavjEfwP3LSEFVtLxVPHj9jxmbmA4k7q
9466	payment	1726	1726	1874	1	1	2537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3heYtNZZduAsQz6GUAgrjFDuwr1BVSaTCkkC3y4x3e6ej8SZx
9469	payment	1397	1397	1678	1	1	5577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu6HfwPkZadiqqSmeji8JS9CTq3LgM9P95Fpw7onVjNVw2yYo
9470	payment	1726	1726	1874	1	1	2539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxYpUqy2nY7KQgTcgwAopRGPYUCmZNsti9EWuGFFzJpHDbmcG
9471	payment	1726	1726	1874	1	1	2540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYED8CJcpvhPZ3AJar8NKk6Fb5Gp3XRYWQPGPQ5vp5PWqgkzup
9472	payment	1397	1397	1678	1	1	5578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswRNVn69b9zCpGm27dRB6J9CCbZKELWYockhEdHeK9v6LCFAx
9477	payment	1397	1397	1678	1	1	5581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYRRnxEevzp36VaGxWLtkzQhaXezpXRZhFiDrrJ3ZCrQebjA6
9478	payment	1726	1726	1874	1	1	2542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqe68TdbG17iFiVgYGK6JRstx84qfbxrPbjbyMfXCeHtXNV55h
9479	payment	1444	1444	1381	1	1	1	8294657600000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpYxLBqf3G16pWa4ce6vbDr4UG2aHqHtRb9FcEkEPF3saZcP6gsk
9480	payment	1726	1726	1874	1	1	2543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ56YpLrCzFd3ZkncUJhtzyeT8zcUWrWiRxA24V8MqPScVYUfM
9481	payment	1726	1726	1874	1	1	2544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFS3APbwNRYC736QT6LyvPrW3E9LzFwHVLduLUxwnbGnmYBz7
9482	payment	1397	1397	1678	1	1	5582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN96RJhXTTcvzSVDdsCmWPEwzj2FwBbvGPGRAWwe321DGykmX
9483	payment	1397	1397	1678	1	1	5583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hR4jVgMmBNqDSBxHh3drDxNXVVrwwCke51nb3HK2XM3EE8Tm
9508	payment	1726	1726	1874	1	1	2555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbgmHwEhH4ZfJWmtZ4He57fXX2GVkvDcJupB8715JT8B9NCBy
9509	payment	1397	1397	1678	1	1	5595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrdh5183TtP9jD8AvDCmkW2Z8Mdc63MZsEKnm3PMj5Fd6oNH9
9530	payment	1726	1726	1874	1	1	2565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3j7ZpahFaFJU8usXEKLjrU6E2UUiZnvyKtwx88KZRbf6DBaZ
9531	payment	1726	1726	1874	1	1	2566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9YgPDaah9JZhvg51bGmhtcVjsHgnvG8SjKUJYCqnwMgBbPGX
9532	payment	1397	1397	1678	1	1	5607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwv3XddGQZda6XxnhJm62crwi5ne3HJTVmYLG7BiymGTmEkc7u
9533	payment	1397	1397	1678	1	1	5608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qLTaAMZhCG6Vq2aBQv12b2nCFz8vKqqKHCLLvDNxUxYHFaJz
9542	payment	1397	1397	1678	1	1	5613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfg6HFofadoXZixScFNyG7LYts63P1AZYqCg6n2CzP7aTsBfu3
9543	payment	1726	1726	1874	1	1	2571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hjypa1fNiaWTzJJdT8Qe5DHG5x1frx8YeSXDAVurFnisGccJ
9558	payment	1726	1726	1874	1	1	2579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvoNJubNQfKVvg4c5VG83eCsD4gEsLDUF2USw2zGFPkPNH4Q2
9559	payment	1397	1397	1678	1	1	5621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9pEWsTFgH1Pz3CSdRzXQTjR9d1aVdTbbJmhNaPJZyzodrvDj
9564	payment	1397	1397	1678	1	1	5624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhtanPS5DUAocydpnDzJ6V2yRESpD3pAefcruUZCwYiymtAox
9571	payment	1397	1397	1678	1	1	5628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1D4KtrS9WjoGEQe3jV6TMcdQ2ojvxjVhkjNLnnpA4upZdLiji
9424	payment	1397	1397	1678	1	1	5555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxe6o4fvgAWjvJEEcX6thkFeYJtZqXz4NkbT1AMNHFkN8QoL9
9425	payment	1726	1726	1874	1	1	2519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsq4n3SADwkL6AsNdHb3dDF6Pmv7QSmJi6uhdMjb2s1fzpfWqK
9435	payment	1397	1397	1678	1	1	5560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGbGpDvHh5daZTbxZG1sUvLMTMCJqeuPnDFXcpZ2oqgSAsK3o
9436	payment	1726	1726	1874	1	1	2524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCmG8up1ciK69LJnMWqgsSky9QP5CaDKseMXAARw2bbLiDvJk
9437	payment	1726	1726	1874	1	1	2525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzatBspn8oq3wDx1Rcy4vgidAG1Z6za3Mr6eh9FCtsqfTt4TR
9438	payment	1726	1726	1874	1	1	2526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPfE46PJgTjdYJLjXmmKAW6qJZoLkkyreNGyi3aatQr7j9XM
9439	payment	1726	1726	1874	1	1	2527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46RVJfSCRybBgo2U8dncp1ksctfeVDYD35GpaJCja1sHjCTYS
9440	payment	1726	1726	1874	1	1	2528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtFkPCBgJ8CdTyMwsREaSFqz5kYt2s5gGLKuBsseCRHLzUxFX
9441	payment	1397	1397	1678	1	1	5561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqqbNkB4cGCE6fFKdYSPHDHP9HxZXt3tsB8UHiXNcq2bA2qJ1
9442	payment	1397	1397	1678	1	1	5562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrFrBPVSEHNoVX851w9LRDGyksuSAsYMupy4eCFNdZgeuadxg
9443	payment	1397	1397	1678	1	1	5563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7vMkKGDZjkhKBRtPZJK6wAaJRcSnHnj6DKEMKg6cvkYpTKoB
9444	payment	1397	1397	1678	1	1	5564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHUc4XsAkHDXMHm9rXkg2RWY3BTQQs7AV2DTacEVsFkhd5EsH
9445	payment	1397	1397	1678	1	1	5565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnud1q2VJaKcaRdkdSy5UFJLtfy3y7d8cgwf9vgBsSQ78Q1GEZ
9446	payment	1668	1668	1244	1	1	3	3312579000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP5v7LgSg83n9RpMiNss9pkFxyUcrEz42YUzovcWyCHnVmAjG
9447	payment	1668	1668	1370	1	1	4	9230795000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77n6xjpgb3gTA7mUySHrkCenwBLANAHSVUW6btpKoKy7jofUg
9476	payment	1397	1397	1678	1	1	5580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzojUjtNbUaGoGV4WbQat1CfkwUsXXirj4YcJt4UoXzytYLHNn
9484	payment	1726	1726	1874	1	1	2545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwJMKLGeuJJArihJwb39Dnm8xbY4YgWK817BPc57yiDYjDpZC
9485	payment	1397	1397	1678	1	1	5584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykJps5aE9tBHHJiUms3P3DKGqPz58j5WsxKinxHEcebdKG5ku
9497	payment	1726	1726	1874	1	1	2550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB11NQ9y2ih5En9G8pr4xEBB1hnMWWAiz8nzfd79VvSkFpv34
9498	payment	1397	1397	1678	1	1	5589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1APiWCLek3nSUSm67bUtXxP3rbsQ6T62dCQ2JqMWwDcEkUG4Y
9502	payment	1726	1726	1874	1	1	2552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMxQBbEsjSsJyibeMKCcku8vKDoYJfhj3gx3Uueykxi3Dc31q
9503	payment	1397	1397	1678	1	1	5592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQL4UMTBhSZ8YR7hUXCXs7WMYHytADV94ZoxYAt52t956ZaeP
9504	payment	1397	1397	1678	1	1	5593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWK9hctdatUKchtFmij1TV1YJ2fMBARXusYMDprnDeyDfkp5o
9505	payment	1726	1726	1874	1	1	2553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByEDPfKXRNcw96C5LsFB14fzntAx5eVNJ9MdKVr1b5aGYToaq
9523	payment	1397	1397	1678	1	1	5603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rePvEVw1tApVFzBiBCc8PnWuG6EA7pVNyEFj8iMKTxwe5BVT
9524	payment	1726	1726	1874	1	1	2562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdZsexkdepSWb3PqK6HHJhsX36QmHkAAEaJ4pbWZvRJM1KyAF
9536	payment	1397	1397	1678	1	1	5610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkLDxATBorhuwYgpee6KqbU2uyXkwBW91n1esnsPzvKqVoE9C
9537	payment	1726	1726	1874	1	1	2568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4dsCTN7Gnv6G1ga4ogDS6EhoaBGHzXzgitWCcpR2JZ9TuuhD
9544	payment	1726	1726	1874	1	1	2572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoTGQKqQ88mcrpbzu4jPttLxtAP4amJndcoLQpkPWCsznMziYK
9545	payment	1397	1397	1678	1	1	5614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9d2m76dsYmPRd5HR2wgPBJpRbsGiFY84QEwmhPuQ1bEoPLB5w
9560	payment	1397	1397	1678	1	1	5622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMUMY6Ymz2zW7SKGEqiWFy13qJjyB56oBesbd8vjQVAZ6kf2E
9561	payment	1726	1726	1874	1	1	2580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsUvCxjCnkwBToUDHreqVB2P6bjkRQbxe4ptFnjduud6qxPq6
9562	payment	1726	1726	1874	1	1	2581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRb8rP8S67z5putWYsGDoGB3kcHGKHnAiQks9WfYHZ89qNNJFx
9563	payment	1397	1397	1678	1	1	5623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMzDkDB6tgfyURNuFRjDt5ZPtkCQU2ys78GkWFCFgrfv2nCxk
9616	payment	1726	1726	1874	1	1	2602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsrHutbRZgf5hQq5psRC8jd4PCeBXCLPXQQAG99M6AVgnbuFY
9617	payment	1397	1397	1678	1	1	5646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FvxZRfLNKgQUCSmNoiKG3hUZEjSMm6qoUk7KzRrLdxfrctLo
9618	payment	1397	1397	1678	1	1	5647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTSxaGREwCFPNVD5eUhnbCmdGmLWjBj3DjPihLZEp5e4WHCmN
9637	payment	1726	1726	1874	1	1	2612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5haBYr7DLMmTB35zhzkqk5EoSRZNA728WmPR4zfyVpAxw88J
9426	payment	1397	1397	1678	1	1	5556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRsS3xwtLSiqdpCyB9CixCpZthUjGog8X4zu3psgAv49sD9iG
9427	payment	1397	1397	1678	1	1	5557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ8Dmcg5Mmpht4hWmM1nFq3nfgihsazZANjm9HLdg8T5diqRG
9428	payment	1397	1397	1678	1	1	5558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58bR4cLbEP7r5MAdQPd3Qxi8Xs4nNBAhyWVaYM2VUCoAgaidf
9429	payment	1668	1668	1124	1	1	2	4909561000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn62RZcAMxEwtXRi52yFvAiJGJPqbcTxYsCvxvgCjStv7JtKx
9430	payment	1726	1726	1874	1	1	2520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZUxjbC132c9fLMqq3fQew9qmVA2FR7nXoEbEH7NTtsduDuJz
9431	payment	1726	1726	1874	1	1	2521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAiwJher8AmGvL8AefVmVz3GsyUqSttfuBWr5bJX6jL2F5Hoj
9432	payment	1726	1726	1874	1	1	2522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dDsUc5xhg3rBXJbUeseGLEvGzkzWRDRKkoSnu8GwBJE8MSSp
9448	payment	1397	1397	1678	1	1	5566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYCyamSqsmajgXjxgV1eajKFdCiFPHm3dyXqY778mFrDngGTc
9449	payment	1726	1726	1874	1	1	2529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJY1JUnNDtXBBxBYumLqg4DEKPQdBeBU6NvRRaCVUBTbUmism
9465	payment	1397	1397	1678	1	1	5575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZ4MU1BWoryj9HpbXYvbgWmtfR4Vx1GaBCExawELcWTCqEuyS
9473	payment	1444	1444	207	1	1	0	1110000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaim4ABLbDtCW43Pm1m47kaAdDgNxZwiuJ8RDTbwCWGAJPWhSy
9474	payment	1397	1397	1678	1	1	5579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYSVgMuC9aqzNnuc1L4fyT6q7EmwhXuvdergsFSSTSftWouPU
9475	payment	1726	1726	1874	1	1	2541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MB9p9JAdbp3riNEJSWLgjMNp2o88PX1Vegkf8HvxbDkSDsWM
9486	payment	1397	1397	1678	1	1	5585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcozqVZFrgXybmkCxSUQTxa9WCTWSnVJMZBkv5QHY2Pwz2SRTA
9487	payment	1726	1726	1874	1	1	2546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN3VmJP2sXpr1cvsLCu6uiwJyUF4ZiQJRLE6ARempwKhJeday
9488	payment	1726	1726	1874	1	1	2547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckdKRLTGWygD68u288XJZk7pZnrnvSUZPy6vaxAta7YrynFi4
9489	payment	1444	1444	1135	1	1	2	4411659870000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpaH9JQgkBeZEYQk9pkk2KwvscT8TTwQ6nuXqscmmSi2NTwxWYrb
9490	payment	1444	1444	1015	1	1	3	2461875540000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZNn6uEm3vzErouj3nGW7MwmV9NGfWHPnqcrPWPhpK7z5Fh5efU
9491	payment	1444	1444	1255	1	1	4	2976634830000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZiBdkH8qBdhgASWRsdPdGBu3HaAKskVUnSuykwwrpMVDtGycok
9492	payment	1397	1397	1678	1	1	5586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvFnu7F81nvVg9tBTHJTJGE7KhrXYAz3zmPHbA3yL7RQD7wnr
9499	payment	1726	1726	1874	1	1	2551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnK4j8pk9fbCRGhZ5J2PnWxMWhSb7h9wnBBT1vfPYJFeK6Ubxg
9500	payment	1397	1397	1678	1	1	5590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWC1azu6vTC2w9Qqp9NBdpwKyAViK4XZoH82eaAyxFrdbVgjd
9501	payment	1397	1397	1678	1	1	5591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2TfNcbofarVo6qSMUjL4DC9U95KDgsHgfSdEwA3xESX5HNcX
9506	payment	1397	1397	1678	1	1	5594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufhAP9gDE98Q3rYjDuXUaKtGrigs7AfupQUeXCDNASv5MpdGb
9507	payment	1726	1726	1874	1	1	2554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4epkXVDyZ64cTw4WfbunUGPHTqeuhyeauUXX2M7SfKV4AoV8
9525	payment	1726	1726	1874	1	1	2563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczc32pXi6ekRS1uQDZUJzGs2NN5vC6MhJrTJVT233s6o61kFj
9526	payment	1397	1397	1678	1	1	5604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAowchozUvdVzJoUXHDvdP3Xy98vfU4rzXqDZDQaiP4Y3Pnxmm
9527	payment	1397	1397	1678	1	1	5605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbhmRQ8166guo84R6y9NfEWkkuh3montmJv93j2kKTWGPyEHL
9528	payment	1726	1726	1874	1	1	2564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbMFSQ8NyWJHMp1N4LauWGV5jkoFApwX6VWw76XHtkJZqZvWb
9534	payment	1726	1726	1874	1	1	2567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9g2f1on16CsvFNMu8DfwRQa2AF4wCdhLPHypZ7bhMi1wJYFQS
9535	payment	1397	1397	1678	1	1	5609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAnywSuovkxxt2J4GxLhYahUnWEotPu1dhuo1zehDKpbjJgCJ
9540	payment	1397	1397	1678	1	1	5612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLfUs86Jta3KkbkxmP4MgyeiG6bWymQ4UCgRiPxkY2j7jKQRJ
9541	payment	1726	1726	1874	1	1	2570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGVDDx99dWYQhqMZqZmQYVJMVsx79BocWbSFerX9n5Qqf16Fs
9546	payment	1397	1397	1678	1	1	5615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgU7x2UmRt1Nbb6eyyZwcazCNc4X8oPCxeKwEFtTJrgi2A1r7
9547	payment	1726	1726	1874	1	1	2573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpPNoS1mJ2BeJQQAA679T4C3bjDfszsDvxijXY6igHhzVZwmN
9548	payment	1726	1726	1874	1	1	2574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKFom61gUgkJksTAJbcZGNJKvURW84UHy5zJwLzcSUQYrawFk
9549	payment	1397	1397	1678	1	1	5616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKM4bLGgVmX7hPBbVw2j64sKYGnMp1dS3AarxQ8bRzUKAQheQ
9550	payment	1397	1397	1678	1	1	5617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjq9bDZuxFwitgLVjRZNsrR8DBQHrrUVfKRF7kGqckiyJpAqu
9452	payment	1726	1726	1874	1	1	2531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DKjZVoijE68cU4ZXdzxLKcoP54z2Zmwno2GaC7XRisPtA9rz
9453	payment	1397	1397	1678	1	1	5568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5qkru1fdVCmLYxpVQT2SdiBbZJtuERnxcg67WWGqRjQiu3LH
9454	payment	1726	1726	1874	1	1	2532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RKfAT81gGR7KbqRk2Rz9EwQAHg99t56x9qAeAxKeFswYsc3i
9455	payment	1397	1397	1678	1	1	5569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TP4iX1CL7LjsTBWAaZfLHyCze7gy6moakTJM9siAuJafhamv
9458	payment	1397	1397	1678	1	1	5571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmWP4NJ9gtA12ZhC8LeW7CfyuTB8XRZe16N83XfxSgQcoy9ia
9459	payment	1726	1726	1874	1	1	2534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4N7ZtVwCQrMcw9rvviqNhBdPp2puCvcs61pgfUMst2r3XLSGw
9467	payment	1726	1726	1874	1	1	2538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytHLofCN3V5JKmU7siS9CWZXSXMrhmSbYwyRkoCwieiKc9n3m
9468	payment	1397	1397	1678	1	1	5576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCBCG4M6Wcop8qxehBMg2C8D1jrZj2uNAk6nbaDRXSp2TMktZ
9493	payment	1726	1726	1874	1	1	2548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfsduDqcx8sdgx4iRkyUQ6KYBz89sLWkHW8Zx6bmJbrXu14Tw
9494	payment	1726	1726	1874	1	1	2549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZG6wpqQ8D3yMEVibTaXrECA5xsdLTyo1hpQJCQszNUYfnRoP
9495	payment	1397	1397	1678	1	1	5587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbXLEroT4zEgMbWNvG33hX4YMZtHs9HBrjnyLZRbkWYF2nazR
9496	payment	1397	1397	1678	1	1	5588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTo6j7465pi9bA7S8fvxebW2mTgr6vc2fqPGyXShoKJ8ZUktu
9510	payment	1397	1397	1678	1	1	5596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8F4VBJTgbyTB3pKPwtaEbVimiPzAhF7W1KxZ7R9mQd4hHUsg
9511	payment	1726	1726	1874	1	1	2556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QpnKaZRMBQK1mdhbAF1oPdD4LbBH1rQjKZhkCqtjzTvj9t4a
9512	payment	1397	1397	1678	1	1	5597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZbpq7TpwoNoBeBHgnLJehN4GHbwcPNuVGqi35Dec49Rw8aQS
9513	payment	1726	1726	1874	1	1	2557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6zwTi7ifcFRjVn5YgZocZmCe5kZi2Xh5L18ioMmTx7CqrBh5
9514	payment	1726	1726	1874	1	1	2558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61mUXYepZfZv3h2DvShFn6Qa2YaZxUUSGV2khxEYJZPwFAM3e
9515	payment	1397	1397	1678	1	1	5598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfn9FxptGx4cWXmRZLRSpnV1rWv3PpJLkrn6sUZVxFa5Ln7d5a
9516	payment	1397	1397	1678	1	1	5599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzhu1dBALLbDmJiBbmJem6gGqfkC4cPZ9HrG47fCxqv2bBeUS
9517	payment	1397	1397	1678	1	1	5600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ANZWqqqxZJsFvSJ3BqvyKf5jDKfJ5iYjGeLGjQN4zhNyNMtq
9518	payment	1726	1726	1874	1	1	2559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5G3zbKZ5NKScU3iHQBBX5zZTNCZXqRahyyscF9LQq5bJhLtb
9519	payment	1726	1726	1874	1	1	2560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXACQAY1c8nChNKie8i8vbKCMbmn2cbM53P37wAXtgwBiYCqj9
9520	payment	1397	1397	1678	1	1	5601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pWnnHXq12HuHsv9q2mKFApbu8PhAy7HyKnt5KZUfxbsDGArW
9521	payment	1726	1726	1874	1	1	2561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcS2wAu2TyLBiXW8aqMaAwSQpRCfthVLUmYtPXapiMcfToucGw
9522	payment	1397	1397	1678	1	1	5602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhezwAYqUkH8xQnKEyVKHQMGMzMZSgUfFAaxoN5yF54TnxFM8X
9529	payment	1397	1397	1678	1	1	5606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsd3RbjX7guDuPfa6BFRAuVWFG2fzEzupRo42dDJWYoHr8yRyr
9538	payment	1726	1726	1874	1	1	2569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pQhSa6SZTygGN2n9nikbBZXDxf7o3JVS55satqdoiy1T1cPN
9539	payment	1397	1397	1678	1	1	5611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuJ3bzbjNDdBQgt9wYHcGBRLhtanBRe8SmR8ex6Eno5eBDuUo
9567	payment	1397	1397	1678	1	1	5626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSnx76VyxFXor1TLzykccfUz5nkmAcgThycvNNDyF81Z8r6bH
9568	payment	1397	1397	1678	1	1	5627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmHochaWx3qmFaZQMM8dMipFNPa3se1xZAn4iyL6xBYQkKMYh
9569	payment	1726	1726	1874	1	1	2583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7a219fvH7BBZBoaEXupG1hg2QYB1hjJagzQKpTT78kue2VqRo
9570	payment	1726	1726	1874	1	1	2584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgisa7vxLvn5mFy5eP4srQTeD7CWyiZMDrC2VwfHkqHcJtYqHF
9585	payment	1397	1397	1678	1	1	5634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpHUKzA5f5GfGAaSvVrDin17JXq5bmVgepVjTmCDwDoUsso9t
9586	payment	1726	1726	1874	1	1	2591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYpogshC1U7yffL8EzcL5QgNmog1dRDLBAEz3hzuGEkLqsu8C
9587	payment	1397	1397	1678	1	1	5635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Q6tpa2yWQZJwxwBGgV72s2p5g1RBT9tdKfvRkSVcAHbVnXb
9588	payment	1726	1726	1874	1	1	2592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hviFJDZwNpdtxLVN1e24QbK8W8uy56ypDLBecTqjLPSs3ZxL
9596	payment	1397	1397	1678	1	1	5638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63KtUP9qbiAjncLSmBNPoxzjXBQkdJCxjLRaG5SXrwWPb7T5y
9597	payment	1397	1397	1678	1	1	5639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUktjVYQjCsEZ9gUKXNZNJNyqbNH6m6g8duBZTbx1geHTePZ6
9551	payment	1726	1726	1874	1	1	2575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVooNFkfk9BwpktiGh3FktFcvWafjTUFUjjrSo3TPr7BtYGGZt
9552	payment	1726	1726	1874	1	1	2576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iex5rzQEZjq3QhPXYoJiGsi2RtWCDa5i5uqjDWpEwgVGmD4W
9553	payment	1726	1726	1874	1	1	2577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW6dR9aoHgQkTgibz2y8UZjHdEqMwHmiSsNdpDE1PxNLPTcaR
9554	payment	1726	1726	1874	1	1	2578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhw3GxLUJaxCivHtsPqZbhwf25FS8hywFpGoRHA71Y8Vy2oggr
9555	payment	1397	1397	1678	1	1	5618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQi1to6kETr6JiQ4VozqEi7MnTbqV7zV7PerMABvarkgcBhbX
9556	payment	1397	1397	1678	1	1	5619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFRhdQjEMvp7imbgZjsTy6aPXfXy37GnSUn3Z3sfZWuGQvTtha
9557	payment	1397	1397	1678	1	1	5620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSaapKbutFP4vx1Da2vNuMBcB3WdWDdJxgQRPwWxatQFe1Wpt
9565	payment	1726	1726	1874	1	1	2582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQmvuCQc4Dk16xpX1aJ3yzMuyL7TiXfq5YpYGsxkYZdSoaPuV
9566	payment	1397	1397	1678	1	1	5625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvqS8qoHABsNpYtVtj8Zsse1A18WaNEt5Bn3kQuNgnzD6dhz4
9573	payment	1397	1397	1678	1	1	5629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksKZnsoJ4EPTPNYkbx7mCtN2teHrj98n5y4bjLejATAsWaPFP
9574	payment	1726	1726	1874	1	1	2586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniqsWxgCmMBSiUSvcDhh38CbMTBQgFBmkBMuMF4JwdzHMqU77
9575	payment	1759	1759	619	1	1	1	500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTa3Bo8V7HimxLFF8XJA5a25YVga4bdNgCD8KSr2Fw9VuAft9
9583	payment	1397	1397	1678	1	1	5633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rFVmWw8w7oUvMTSxktiPQNLRTAhnhdGBvNewBcqunkEnu9XU
9584	payment	1726	1726	1874	1	1	2590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyG8ogM69hVzK45fp77QRwNRWZhrGw2X3fm4TmTozbJsgdXDnC
9619	payment	1397	1397	1678	1	1	5648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7qhEN8a45LFcWnPUPVMoTpKBRRtZvs5S4Z4TrkppGX2NRhH3
9620	payment	1726	1726	1874	1	1	2603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSg8gZf5PqEsK2WwpTTFUfFmDvXA5C4tEwEbu6ydifJ7U9H9t
9642	payment	1397	1397	1678	1	1	5659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVkTGYYpnr7egXAchLvPNUdQUofeu88Y2ep5vTmafaHTsLLPA
9643	payment	1397	1397	1678	1	1	5660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJtD7wEvwLXrJZjakhooNZ1vkL4H3UJ8Ks6TYHekZbjZiZ3h1
9644	payment	1726	1726	1874	1	1	2614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1imz8kcZ4Wrk5gg8YLppf7TvPDyG2ngx9zKMX9dgGJuNayX1
9645	payment	1726	1726	1874	1	1	2615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzB2qVngCZfRsTNAiXCPDAZ87mF1Riw1vRDwxxb1agjxSVFEHR
9646	payment	1749	1749	1950	1	1	3	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHdJSpEYsMjf5outcXxtCL4cGNV4u357W2bd4thD1ZD9qrWCW
9648	payment	1726	1726	1874	1	1	2616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1GYjoGBwVmZNKgPjp25Cu78RLLQW5Qb48FjyrRXxWQGh5Pbz
9649	payment	1726	1726	1874	1	1	2617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyWNeagfED53UeeEkVrQ4Fx7xbWcHFyaX7tAo6U2rBeNjD4tt
9650	payment	1397	1397	1678	1	1	5662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbA9xBEQA6oREEq91QTS9GsTDP41BWXPkfqVbR8eyveBitQi9
9651	payment	1397	1397	1678	1	1	5663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaTfuFxc23WvFharh2jyRNWwwSKj86y96CtxCBUJtAAw9JDuH
9661	payment	1397	1397	1678	1	1	5667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf4SNgVaQ8xADysXg21gpLDm3QhDt8d6ukxVD7fRaVESLdCot
9662	payment	1726	1726	1874	1	1	2620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyoo1bXFauFad9cmf83pPU5B563gcm7ECAdBhnf6Ap2cmDroP
9663	payment	1726	1726	1874	1	1	2621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LLbFdJ2mKt2appDjYVR3wzQpoWjzpm4AcesEM6jTabi5ypLL
9664	payment	1397	1397	1678	1	1	5668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65TEUfNJXCMkJ4RPxj7257Jzp3jZnTkKnMkjd6qCjD71Vwj6b
9665	payment	1749	1749	1950	1	1	5	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBUzpPko8PnmsW7bXhZmWm3TgR9XGGVMrmCLtykssqosLdcQv
9668	payment	1726	1726	1874	1	1	2623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCHEUoV1ceMkHJKtrtQxEyHMsu5TnYqw7ZsCeNb9Wdbg5ZkfY
9669	payment	1700	1700	939	1	1	1	1912257035010	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8M3boGCs9S28ADHCtmBnmgNUDC1P5smcJ1bd3fh9CAd1f1Hy
9670	payment	1397	1397	1678	1	1	5670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5p2djbsLzY1ADb6HcnLwvz72uGnCHAu6nuwnX6cimyuckCXt
9671	payment	1397	1397	1678	1	1	5671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFQ66Agp41ZiVPRfehhvu2groXYjTyGSEC7JdM5MWgkvuQZjr
9672	payment	1726	1726	1874	1	1	2624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v7wiciASXzAuE6mp5VCgg2kKZVGmo6AWsnrRzfWtSWSAX9V4
9673	payment	1700	1700	939	1	1	2	10000000	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpaCXdKwfw5wU3eT5GHQnR1c2prX2F22efsw4EjoXHsBqfxiqis8
9679	payment	606	606	929	1	1	4	2098153235309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTBP39pDF9ZWL7srKrUA5vhLUQttdihShuuX2btxS6TLz4fEE
9700	payment	1397	1397	1678	1	1	5682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFmJo7NG7o6uRqGmxGP6R8qNMjisTWjkiinNnDb2ZvAtEsW2S
9572	payment	1726	1726	1874	1	1	2585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18o1QdJjCATMfQK825utup1AMWTMXPbjBPWWbFsaFfagDKkF3
9576	payment	1710	1710	914	1	1	1	2005972659856	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6U21Ay6XuQREWnyLBUkgrSAo8CpaWX1jNgufZX6rTGexgf4j
9577	payment	1397	1397	1678	1	1	5630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeCCBLqe8AXHPMV4MFY4fvgiSbVwNSAiY9EeLYG88GvBuy4PT
9578	payment	1726	1726	1874	1	1	2587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBkDMBa83H3vbjpSa63GPZM8sU3cx2DCbJgiZuNeGKoMbSkfJ
9579	payment	1397	1397	1678	1	1	5631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6GBRJABXptmtv9kJNxiKdePCfPkpPj796Bu6fDbxxZBw8QHN
9580	payment	1397	1397	1678	1	1	5632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxiSx5QKJVGBDciRqKTm9VrmkdCCLTszXb9XNBgtPJx9ePGjd
9581	payment	1726	1726	1874	1	1	2588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbDZw8FW4CfVfwmr4Qo6oWtQQ7rF81VUoqN6wFYoVV83gQR43
9582	payment	1726	1726	1874	1	1	2589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3U3dXFRsvK7c4yAaEv8tg2C3fk9Mk2Dhe7BbcHrxhdvrWLoi
9589	payment	1397	1397	1678	1	1	5636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WyQrdMoAhU416dpurtpHBuXfwqv6TRLxyqWWer76Lx4njBEf
9590	payment	1726	1726	1874	1	1	2593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PQ1YEuu19JCqZbMJ6sUTRSf3r8n3VkAY4mGWoyMWw9gkosNQ
9591	payment	1710	1710	1034	1	1	2	3594685819296	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKSxoSyWEXTbtrPWWr3Hv8foHRcf8e3Da5gaD7F8Ka7azj5Sg
9592	payment	1710	1710	1154	1	1	3	2425406151454	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3pYqfVWLw428HvtdYEbhgdYupmPuBTSdW3YmZp2J7GBBc1b6
9593	payment	1710	1710	1280	1	1	4	6758609896104	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHx4bNV4Ez1tLdZ9CDXWd1SEx6eZZH1p9vDN29319B2iRgzNTZ
9594	payment	1726	1726	1874	1	1	2594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq29ZLuUdJu1CeutZvhk63UaUVHV7RcU7wvVqaNUMDtraTcEGK
9595	payment	1397	1397	1678	1	1	5637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2g4f5Exr28j7qEpkKw2nSNWtabxHmt64xqbxaiFNnxGwNUad
9599	payment	1726	1726	1874	1	1	2596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmm533cyKbUCNea4n9vZSVZWfB4EJ9mzHXUEfMNp4gRpPygLW
9600	payment	1397	1397	1678	1	1	5640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxbbT36dR9j1j5oNe3Bh8KuN4kM6TwgMXG94BJx1HqxHVJt5B
9607	payment	1681	1681	531	1	1	1	407503985720	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpYwxNBswQw7t6dMo3XBexe9qpdPDeRXoVdzMdMcUHsBGeV4HZvY
9608	payment	1726	1726	1874	1	1	2600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96U8UjrdgmNkZXCApnQLrxU9X2rCo3XdxSexD5eWcVpiw9iRU
9609	payment	1681	1681	984	1	1	2	3100139565232	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZcdpomC3AeMuUVZDM6hVk7qPdfKFahdTwaMouVUuwphqq4619j
9610	payment	1681	1681	1104	1	1	3	5555423538912	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZYh5uzjgUpvLp1hytTWCsiwT6gPVdE8Zynv89a1AfJZwqJuQzL
9611	payment	1397	1397	1678	1	1	5644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceKd7eNxTcH9h9BKs5qAQsRNwxMbXYNpSc1gf67qZmaXHMmZo
9612	payment	1681	1681	1224	1	1	4	3748354961338	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZrYWXzLHnJ7paS8iVPmCYgkPWrk3CaRbRJKxbZ32EVp7DChVXQ
9613	payment	1681	1681	1350	1	1	5	10445124384888	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	Ckpa7CvecUEd76ScDUp2omer1kPnPF2nyNHXcDjpGk5KBWP6dFmxw
9614	payment	1726	1726	1874	1	1	2601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dSYdQSuh7V6eiNGsaxz6ubahTx7XjMgKW6LqSavwmTM1aWNg
9615	payment	1397	1397	1678	1	1	5645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc3hYmfSgVAESHCZ2AAwb6E8NRnAK1LX3XoXMdUG9xTKjxKM8
9629	payment	1726	1726	1874	1	1	2609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQtwatQdJ3joiMFqSu3SBcbjkJUMkusF6WyDRgB7auzkD2QY2
9630	payment	1726	1726	1874	1	1	2610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAW7bkx5gqiwUSncqpivg23MXsPSrkFwAaA42XV3qS6D5NSqEE
9631	payment	1397	1397	1678	1	1	5652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzwdbwZocYJKwrnTUHHnW99FrLYekZBru4X5RNb2UEGJHJHC7
9632	payment	1397	1397	1678	1	1	5653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKH9ckLKX3gFU2GnnrKC27V4wuNiEFZsKCCGBxscmFsPmJQGd
9633	payment	1397	1397	1678	1	1	5654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDejB5jMQEaFBvu1GRirSt2zVxsPPDYAntkGjCiaBBhjwXYLK
9634	payment	1397	1397	1678	1	1	5655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvL9qZrTpH1tMVPQYLgpCoQMHPAwY4A81MtN6217fQLTTeaEEN
9635	payment	1726	1726	1874	1	1	2611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tn7F1HKs9m19zze8CVd6FGinyDzWp68esFwYzWdRZ39AiyQJ
9636	payment	1397	1397	1678	1	1	5656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsLAyPRrGJP2k9Nw3Gfpmez2NVE3dAed8CXNzdDFTvbFAq1eC
9652	payment	1726	1726	1874	1	1	2618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuJ29PaBiTx8dfcnoiUx3TvHVA4H3Kj4f4CtnaWcmMhUZCaXMx
9653	payment	1397	1397	1678	1	1	5664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwg22kLNVmHhkHj965tDkMwDXDoQm4wpgaoYnu2hxAAiTk7Bn
9654	payment	1749	1749	1950	1	1	4	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MHfs7WH6Nyb2mM3Y2oX2RgyMymGQ6BxFzdLtXm26rHYydKZ9
9660	payment	606	606	1169	1	1	3	2536651885611	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uCAkCy4wgKVL17RkSHLJzCTaqf5ySHYd3FWrRSrDgyvoNtWf
9598	payment	1726	1726	1874	1	1	2595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFrSkyUSfQKpRiDNdAcstnALtGKuSEju7GYGQjCFAqyTtvwdY
9601	payment	1726	1726	1874	1	1	2597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGFhkrco4HyT72SJ9uNFNobZ6sNrX2pX9EArwGm7ptJPesDsn
9602	payment	1726	1726	1874	1	1	2598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsvY7Lw9c2W4kQp2k1aC77BsMAshXKqp6Vt4WoFNnLhcBo4k8
9603	payment	1397	1397	1678	1	1	5641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6E9qmj7vsNWtRMSGQiQWQui4fy2SxB8Upu6YPjg6gQ5RLgYD
9604	payment	1397	1397	1678	1	1	5642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj8ewHfkXhggUHMHhdCw2kz9VDwwwFc3rjawj2qLYqwZDEVuE
9605	payment	1397	1397	1678	1	1	5643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNLccrQ4t3G98xfwpSvm2jVqxx58nxwcWKtApqmdradQkeeLB
9606	payment	1726	1726	1874	1	1	2599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDynB8cz2M8z6Us4hpgbfP41EayTnWej8yh5Zp3zU5Vcz7FLb
9621	payment	1726	1726	1874	1	1	2604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbrDLQoTzaAoadteEhidNrxa6KJ5pjNLd91ChvUDpvNp7F5ap
9622	payment	1397	1397	1678	1	1	5649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa66Z6uAyiDCoYsyMkdoxK3Kq8Lgz156Kd1q7SoPREQhVc8L7jV
9623	payment	1397	1397	1678	1	1	5650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zDp8bFfZ81X82fMNxCQv7ZPjtxqb3LcuJqpStZWq8Sp4ZVHf
9624	payment	1397	1397	1678	1	1	5651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTxRTrXRkF1sEvTz6JZDEWnuSBSZLR1cXooG4PcSQct5RdAqC
9625	payment	1726	1726	1874	1	1	2605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQSUxCzoWUUoJ1xpQ93ShiqhgsmerSN2pKAprZJpesN5QyoEn
9626	payment	1726	1726	1874	1	1	2606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEuxPMeBWRT4rEppgCLQzw3pysPbTgpMvAsuE8tmEovvjTNDd
9627	payment	1726	1726	1874	1	1	2607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9KKxdBiVyc2QF8RmPBEQz3ituHLyo9DwcMbcURZZb5Ga6yGQ
9628	payment	1726	1726	1874	1	1	2608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1oNdXWoHeVPXyZAw9ZDruqkMFtv6zHFZv7P8NKw5UWnKp4mZ
9639	payment	1449	1449	1939	1	1	3	27000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ54uqjQvjRcuHyh91eicaGL8aoL3Un2d3cLz7CbJbtdV3Qhik
9640	payment	1726	1726	1874	1	1	2613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJdcf8NBVL3FfJCfFYyKBiEenQLfPrYtc59JCNYTsKNeYhWG7
9655	payment	606	606	1295	1	1	1	7066819436851	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJchFsHuviKQcG6a1TsUGBT9UrGx5U6gXpHVu4pa97Ly2g61kZ
9656	payment	606	606	1049	1	1	2	3759080629265	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTLeBc1tMNfYPMtdBw1rWXyBXqUcCSkJTy4tvZziySaMFKwph
9659	payment	1397	1397	1678	1	1	5666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5m9kUhbwUYHzSK6h8aRqc1GxkXdSpZkMPekjXFqZjMa2g8Fc
9666	payment	1397	1397	1678	1	1	5669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTUEMtsdAHZMtnony2BHzJ7pJcTquqo3xdnBwh1ocCmawwRAb
9667	payment	1726	1726	1874	1	1	2622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7MBHUXZXaTx5brsPvEiaHBKYpjKQXfKjQyFxmtjwyFhwfRHQ
9690	payment	1397	1397	1678	1	1	5678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArKqvjkFjj9Xgsvgb6PPEzux4V81GnDhtBSoxDQCtxedN1Doo
9691	payment	1726	1726	1874	1	1	2630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpodG4v3XdGM1iPbCG7DJV8v2rxfaD2xcfv6mD3i3jG2WApv6d
9702	payment	1397	1397	1678	1	1	5683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSubVtjVxrzE3E5p91ahBksx3G1QJCkQdEYpLguaYpVuEyxLQ
9703	payment	1726	1726	1874	1	1	2634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwFVF6Znm6iHQbEPFPBQfwmMyp8Pcjcahg7SSkNuWx6CC53W1
9706	payment	1726	1726	1874	1	1	2636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyAD9VsbYFXrCaLCJUQKSNq1LHLm2UkUCwUiUg2tjytCRJuBM
9707	payment	1397	1397	1678	1	1	5685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SNhR3STZCVqC5rrWyjdsRps9moseWPUvECJmxwiutG3nGsXK
9708	payment	1397	1397	1678	1	1	5686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXgc8Svqxj8QTGs9zJEHXH6U51UMf4d3wrJQiAwXZkqczFd2E
9709	payment	1397	1397	1678	1	1	5687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLou47RdpcEFPyzZVLHbcBT1hgCYWxxjiqNQ5GqYpcUEmNnjV
9710	payment	1726	1726	1874	1	1	2637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EDZZ9xZEu5PsWJh4LmPtv4v3LKpkKVsKG3sA2HeGBUjKXXpP
9726	payment	1726	1726	1874	1	1	2641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7YznT4xy4eE2wusVvccfzHusoqeE7R1qdk66s59LJ7RLwdWF
9727	payment	1397	1397	1678	1	1	5690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmLy1HrytpG2x16J7wQoTuH6vE9vF93X7F2iFhJmLTZbAnEKh
9728	payment	1397	1397	1678	1	1	5691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQS6kmD3y2yiYrghYiXyjdYrE9G8efRcyGpPYDsoXesHXGkQF
9729	payment	1726	1726	1874	1	1	2642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxT3LxthwouWm1fcy65bWYE74eJWkHVe1f6VMYukPTXBVG1BZM
9730	payment	606	606	1169	1	1	5	2536651885612	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79V6Yr1ciDKdBtqTdSCnGeZj97gN9MgRD7VrqJYfqRKdyN6bA
9731	payment	606	606	929	1	1	6	2098153235310	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCJnaxFq7DyS7q68s33rB9UnUFxmdg7oXto6D3xFzZzewo6hh
9732	payment	1397	1397	1678	1	1	5692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomjoiNPkyF43dzkjYaSo7WeFQR94s4ggQpmq6XX2MxXEPUnXJ
9638	payment	1397	1397	1678	1	1	5657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1kio3vBCzKooLFoBwnnw3E5qav4JKWcYxRZvnN22QcBgEXEh
9641	payment	1397	1397	1678	1	1	5658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeiGZPUebds891ssNirzR3jcfwAQZDzPxv3oZRd5XvALUET7W
9647	payment	1397	1397	1678	1	1	5661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaUdDxdSUcQkfFEhfrShvYu5emSjcnYupsQcGVQdVjRtLy8iH
9657	payment	1726	1726	1874	1	1	2619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdshfFW9MFf2FxZ2LimULBy8o5ex6YjXviiTWgutHmENxhFYX
9658	payment	1397	1397	1678	1	1	5665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoznHKjWLXn8n9staRDYg3h6pXgJiE4wFsv72fBTqMpmopUjoU
9674	payment	1397	1397	1678	1	1	5672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNj5NXd7e1uvvkWCjqF4hhbquqAcTpnZdsghpRQ91NDMtkPtA
9675	payment	1700	1700	1059	1	1	3	3426748222506	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYs15Nyz2NCsRM7p47PGoHyDVbZwujHcfRmTxCNXEG7TQwmuQPv
9676	payment	1726	1726	1874	1	1	2625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLKAa77g33kVJQ5JimQPvFMf4tPw9xLRzxekTT8m2PdhJvAMc
9677	payment	1397	1397	1678	1	1	5673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoS8JeyhC7h7swsWMNn8TEsvoCjr6Dtj96sayhqUPJDyrtaWyw
9678	payment	1726	1726	1874	1	1	2626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BntWs6XvC2vhBRsHyHc7GT439ZPvp2UNKr1V3u2ZsCcCmZbb
9688	payment	1397	1397	1678	1	1	5677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5EyPoU98s9kcFJUbERqL7VSo4DieDNveTJrmY6FrJqVCxSYy
9689	payment	1726	1726	1874	1	1	2629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBCpvrVEmi1sU6XTGoJg93HBC9PJwQEurd8dukst5VfJTWNbu
9698	payment	1726	1726	1874	1	1	2633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JFsSpcZ573duy1GGDb8TXHbX9p57cRokJfaKoq7gouxCHWTS
9699	payment	1397	1397	1678	1	1	5681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN58gxmtKNLQSGgiZHBCSTzSVvTrnmm6nSDdNhpE9m7atPCHUR
9704	payment	1726	1726	1874	1	1	2635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn74QHA2RdeFCyXQ5BKU96Fxy7fg65eGijrdpUPZDaGwLrAcph
9705	payment	1397	1397	1678	1	1	5684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTwzUD4AVuD2PuVEmztUsMuB8tMWH6igmhsvRCzDUbKM1gLcM
9711	payment	1726	1726	1874	1	1	2638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHFKQiX4kCVC5tDxyziScWKrjk3jExoKWwgTAMzgA3GSGrb1h
9712	payment	1749	1749	1722	1	1	6	1000000000	1000000	\N	E4ZNCkMxF6FcCyWfy81tLX1ayQ3XxU3dgHcpYeRN2KamBfVwt142k	CkpZkKGGYEf6BuhPKuz6UBjTm6gjDwnahxMbaQ1GaFKh18mpgwEDQ
9713	payment	1991	1991	83	1	1	0	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94W95T44nvLUNtiCehBMaXtebY4pReZxL9xWvyBpYzy73d44y
9714	payment	1991	1991	348	1	1	1	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVatpfuPVytPrGmdU845YDKjiVuMp6gyZXdy7fEXPgiFy6EqrY
9715	payment	1991	1991	380	1	1	2	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL6w6PnQJe9d3EjkwybaC16k9YvzZsxQjQXx1GiA8SNeXi3K5
9716	payment	1991	1991	530	1	1	3	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBazjZpH12wCNkoEPBXUtownuwgkc9cQbihKX4EDXgzfLPYK7
9717	payment	1991	1991	675	1	1	4	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGaCufjsdH8V3HX7VRwLr2Nk9XaQfMxn1moeEQi7RkcBmeUSS
9718	payment	1991	1991	959	1	1	5	1911646833169	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgURQX4zSzYKdkmTvHK9qkd88shqHUdV9uBNG38mkWW9q6D2za
9719	payment	1991	1991	1079	1	1	6	3425654746054	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTteqh5zWCdSHcFARaXw24bhUmnTUVpBTeEQV1bzxfsAcL7wWi
9720	payment	1991	1991	1199	1	1	7	2311357518151	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgU43t9aiUYGxRYV97SwRWJ59gHrHvYoxQY7TmaT8PPrrtiMc
9721	payment	1991	1991	1325	1	1	8	6440803238821	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DRMotC4sBgGAa4HnQAesXNNQmy2dDAgrm5MKGAp5Sy6PoYnS
9722	payment	1397	1397	1678	1	1	5688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxze8HkiGUuMW34ixhSASn2NTzGGnJZPmsgxRVGczy8G7ZcmqE
9723	payment	1726	1726	1874	1	1	2639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSaC1s3czD6t4df5CyQix1i1wDd4jJpdGBvQM5DCGbxV2SzE2R
9766	payment	1397	1397	1678	1	1	5703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqj8fnVwYpef5veiGi3EA7wUk3C3sMxWV8TFdqeBVLTDbYK9D
9767	payment	641	641	1090	1	1	0	5332248000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdAD8pSgATnX3CJ59yFqQXdEZbLXVeQ5hDWGJQaxWBLybyGVp
9768	payment	641	641	970	1	1	1	2975256000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncgSTk2RLupEP6HspQuprNCkj7613JgezbUtU9kLxhb8digKJ
9789	payment	1726	1726	1874	1	1	2659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfPAJ3whraSWHDv1RLkNzyFceLfjFqAkSuFR6BCxc3rBs7A7b
9790	payment	1397	1397	1678	1	1	5711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhYfmrc8g2L1NiFQPN8gjNtw9B3HUruMgQc3oWgvTe1Ygy8MP
9809	payment	1397	1397	1678	1	1	5719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QRHFs246Zt9aG8TmibdF7WZJ8xvD7o4mvxL7zpKzBcfTPtg4
9818	payment	1397	1397	1678	1	1	5724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Diqn5gDRYijhjYw1urCriCXFHZoCaSdv4v6Pvh6xuuW1QmoV
9823	payment	1397	1397	1678	1	1	5727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDwFnUF9PyCxYtwRGB2jS8ARZrnncmCS3XKxDgSTRhxCHW73r
9824	payment	1726	1726	1874	1	1	2673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2wQat9KcwukP8iN7MFpjt4tVo6QoRLHUmScs6VqVkaCVTn2u
9680	payment	1397	1397	1678	1	1	5674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFonqkScAfiBzbsyu1Z9PYbtog77Q5FVAnpiwwM8a3H3x3dte
9681	payment	606	606	1049	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYR17rRi4cyrMWfspFc9DZUVK1k7tnH21PWq4btY1XkQcdjwJ
9682	payment	1397	1397	1678	1	1	5675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv57HqxdpoezeDbJCayRdQw521ccd2f8QsMG6gszZttaesDSGG
9683	payment	1700	1700	1179	1	1	4	2312095308516	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZBYTiY6gp2Kai4FqQVxfY2qmjp5d6UoQzLHJhSmo7ywBuTxsrY
9684	payment	1700	1700	1305	1	1	5	6442859157231	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYRCPzc6k4VgTyF86t4e6cvW45H4ztNtsqszLxcxCwWVBWxNMSd
9685	payment	1726	1726	1874	1	1	2627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhnEwSLpz3A9CGrfEsHUMoVS1PqEVcpG3EQTr6pPayrFRPc3uv
9686	payment	1726	1726	1874	1	1	2628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJNXkCFEHVWJjUwFi8b6vGwjmgKyp3BYbPmeGL4fjz3Btzref
9687	payment	1397	1397	1678	1	1	5676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgd4oCRchCcc24ooXcXkLcZQAXywr6iB7wgvTCKAJC8VaMQwiy
9692	payment	1397	1397	1678	1	1	5679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAa7jdzvckpJAvSYjbYy1FUuNn2thVRANLWzDUxgJyaZeBnXq
9693	payment	1397	1397	1678	1	1	5680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQuHDJY3vBmNn1vCt5FemDAWnc1uRMeNd5HBQch2FYe2Cqsof
9694	payment	606	606	1169	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yBgmNy7HntT99PbDqvbu8wghnLXYALxoR5pjbcpQKKUkSfJ7
9695	payment	1726	1726	1874	1	1	2631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJr1mPzPZq35WKztdD2SJD7ARTWyrw2we99xp8hxVfnswhZYJ2
9696	payment	1726	1726	1874	1	1	2632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaB4jmaCd5KRH1CgQzpBtq8NUrEfmrk9AiFoBRzrmt1tQwp5kW
9697	delegation	619	619	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P2ZZqYD8JcSzCP7ct8fbyU4846uR6YXotxSaj8jfMxXGHZAw
9743	payment	1726	1726	1874	1	1	2646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVvFnJLnrMwtPDPWmoojttzNa5r7zcVg5hxX82WDinoPPw98g
9744	payment	1397	1397	1678	1	1	5696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9smwHdF9jtfbaiaiqFkdBKYjaQ89zr8xKBUaKHETUH84C7oc
9745	payment	1726	1726	1874	1	1	2647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv98j5TGebjA4xLzv5QCQt6PXJA43ZkNHG7t5zwh533K5ELYEd
9746	payment	1397	1397	1678	1	1	5697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwG38JVW7eSBiM1Kz9r1N1jX2EodLBZmwTyvgcEevWyLVf7wVj
9747	payment	1749	1749	1722	1	1	7	1000000000	1000000	\N	E4ZMxexvZb2BNa7wmf9p8mWvQ3vtt16ApgGcfP96SLLJgcgvZBFMf	CkpYXaSp8Y1M38XzSRVwVbAaDe8BXhEC7YDG7JNktXuqNoG6cCtvP
9774	payment	1397	1397	1678	1	1	5705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtynkTJiNA1TWUPH3JFbedprZ1oeV8azWDnKY3j7TUFEa6twES
9775	payment	1726	1726	1874	1	1	2653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdp6TmQNx3c66SgtL8Ff4Z18x1RXRb9mfvnS8Smx7XxD1Y2aV
9776	payment	1933	1933	1764	1	1	1	2879000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRXL1YKG9ePMMNEpPXiVfYL6senMLRYooYRNqtvHWsiv429Td
9777	payment	1722	1722	1764	1	1	10	120000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHT1bbANhTTnCgn2yZj6vnN3GsUqzvKijjBMZVJRSNsksssFJx
9785	payment	1397	1397	1678	1	1	5709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PkCKGYd97s9QEf8ngF6uafQskKhapdE4r4WJ352oN3v7co9m
9786	payment	1726	1726	1874	1	1	2657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqyTHkzwKspeCM9JQZmSPc2RX2dmo7cUNSZhHsZVuoRX7y8Ag
9787	payment	1726	1726	1874	1	1	2658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8D6YD1VcWXNP7rbtABSqVVx9V3uc4prGXJ8UWXnuyJsDhAch
9788	payment	1397	1397	1678	1	1	5710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgqyCodbCxTjsArLit36U9FEQqK6hCwE5pziCL5xwFZJs58fU
9792	payment	1397	1397	1678	1	1	5712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukrDTSyMzpzVQgXHrEaC1KPvMVHyCs3awkAFgA9XkL1ni84Eb
9793	payment	1726	1726	1874	1	1	2660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnszspAe6gSyZ3j4FB82q4G7SoeuwCRi9UWUNECJUSgL1P6qg
9794	payment	1397	1397	1678	1	1	5713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCu24cMPDSHgkyLdukZsSU86Z7tFQxkFQvVDu1bSLPg7hu7RB
9795	payment	1726	1726	1874	1	1	2661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswwkmZT3pbjFcJFbBePV2Mf1RyFSVPh4MKEVbx1FGrL65KKjY
9812	payment	1397	1397	1678	1	1	5721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMQ4dgnkhaZoVeiuDpRbADYLn9XqrwQQDs4aEh3aVoKxG1B96
9813	payment	1726	1726	1874	1	1	2668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzHnhZAuRSvG3jUMLs4WUjk6yaAQk3b4qL654PfKFnVmcFSqL
9814	payment	1397	1397	1678	1	1	5722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrxkgVFtJPrbM1hxS6tokoqMP5m9knhLARuEpaXiMKDEZNBss
9815	payment	1726	1726	1874	1	1	2669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCy1Quf2fVDWKgSsomPijeSYx5ffNxn5W8syizAs67JLJY8t6f
9819	payment	1726	1726	1874	1	1	2671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Defp1q9XZ33v4zhBzGRxXbuSChgvsuSYNiHJMCNjiW8Zznm
9820	payment	1726	1726	1874	1	1	2672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZQDwjqhHo1JteMSaQqVZDuXsZevDjANF5ru1CpeGf9DPURD6
9821	payment	1397	1397	1678	1	1	5725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymmQKTdP3NnJHbkos6JUbeJTePBDmLDNMVFoecPnAenvEQNSN
9701	payment	44	44	1991	1	1	2	16541007000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZfEWGyEnEyto68T9b2dMgsHnwxzkQe8HSEYn8BYbBHU8Kfjn
9724	payment	1397	1397	1678	1	1	5689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmP74verrWNeWD2bYn2tAebWfRdYvf9JPRavKoumLJHF358ZTy
9725	payment	1726	1726	1874	1	1	2640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWdtoYEGbKhLC2nCiiuTxpYu5iLKwiBgjqijfZ3kvE86BTRJr
9733	payment	1397	1397	1678	1	1	5693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAYdzVLDjKRURpX1ZDrDaNA23ADXJuZ1tqhvcNFuvJQCmrXVu
9734	payment	1726	1726	1874	1	1	2643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczX1SWn1jbyuxUPvyG2VztcE7NLnnYYASgZwuuYRhCJ4A3XDp
9735	delegation	1991	1991	1406	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBocMXL5bndGJVxXVb8XtFJmei3zvLP2UQ4D33amJe7Rsztkb
9736	delegation	1991	1991	1406	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqJnNx1JCkcpLgzqei4cKA4JDreiyaZf4TBo9wMX3XQZK1KRF
9737	delegation	1991	1991	44	1	1	11	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpbwfSuhff9C1G8WxbQYGohipXBBkoXrG3kd4MbcnhETzi4mn
9748	payment	1397	1397	1678	1	1	5698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZp4Lr95a2zGfrs4AQm6R19fvyc6RTD9kMwvDJquaYu3hro6wK
9749	payment	1726	1726	1874	1	1	2648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvbDiuVZiLdnAmSyF4gXRegHckfi6byJqLG4fudXEP9aawmbh
9754	payment	1397	1397	1678	1	1	5700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BJPGK8J5NE3pLpZZMr2Yz4Cb3HFa75ame2GsMQUABvsZYEGQ
9755	payment	1397	1397	1678	1	1	5701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFPi1PqCAQWp3qYTbpK3u6WqysYJJDUxS9GJ6AdNGMSeiidV2
9756	payment	1397	1397	1678	1	1	5702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTLFKAHN9ZSgwAr8EMQBsrULfBFS7sJ6jAaZJZajStnMYjHug
9757	payment	1726	1726	1874	1	1	2650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLStkoyWGpc9BDtStaV5HgHwwShuwJHZ6LqbHmqRnQGg36PfF
9758	payment	1726	1726	1874	1	1	2651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPMWuwSXKQCbgaxTFqM2sSKN2GzMN4nNdNoYTN2wXFZzugdPr
9759	payment	1759	1759	1069	1	1	3	5076500000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpYuhYpH7RjfY3L49iuhCt36oYj53Etjk9qgycpcFg7BLmfcNxLz
9760	payment	1759	1759	1189	1	1	4	3425000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpZRJSyvi9m6F6ykg6tkNwTSWU8TwHo6dfm8cktyJZdXEjStFhCd
9761	payment	1759	1759	949	1	1	5	2834000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpZAgrdD5yDio3eFRHf6KjutvX1TCYboFU3CqsekeJWBmDWfwvnX
9762	payment	1680	1680	907	1	1	1	3191320140680	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaBmr82CgEdqGQVum866CHBrpTbS1jqeymPcppsoXsiAZgoa59n
9763	payment	1680	1680	1027	1	1	2	5718818348880	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	Ckpa1fpXNZ2LEbuHzn2UpxPhE5b9DbhWrgnwppEkpvQg1w8hQYSN3
9764	payment	1680	1680	1147	1	1	3	3858600695495	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaG69SjGWQeVp1dVKvrRVTZGXPPw99iq9VVv98g7hJ76hniqxes
9765	payment	1680	1680	1273	1	1	4	10752333925620	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaHC7QcPXXQaLadvPNCxEjrt1EQ5MzpDA77SWSFtqcSkDjKKzUf
9778	payment	1397	1397	1678	1	1	5706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNLukN6YDMwfEMczbqaHKnjQG6G9Ek8TBN19v8CkbR9ZppAYd
9779	payment	1726	1726	1874	1	1	2654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzM9UusmghS4w1VWv8sh1FqvH1JcQ6Uiru1kg8NAe5SDwAhc55
9780	payment	1764	1764	1334	1	1	4	8557000000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpaJ4Fgsj9GsT9RYhKTEiQ1sjAn1JYjvAeKaCAaAHnD4qT5UoE6B
9791	payment	1716	1716	950	1	1	0	2826600000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiU231TGwYeZRAcUrG3nfPfH3N2s6cFS2BDnqpWedBQD5PNbfJ
9796	payment	1397	1397	1678	1	1	5714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GQhUS2UbiYvRTgGKcRQLbKuEaP8qMN58vpWRVxPXy2VRQTvr
9797	payment	1726	1726	1874	1	1	2662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6MfkrHdyF3CX6SRxgEAAXQfpQZL6sL49nUZ4Jwx2NDas1x7P
9798	payment	1716	1716	1070	1	1	1	5065240000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPADUSoHrKaPbKXeJyyixpCeLbxuDM3CFhLqJoFGgDxe1iRf1w
9799	payment	1716	1716	1190	1	1	2	3417620000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuuYnUMyPgH3pd2ybxuN35EVaPgjJxneNnYxnAx2kVQYmDLmb
9800	payment	1716	1716	1316	1	1	3	9523500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoawVR2kF7Ap2RXhbVHpNhxRQGQWr48wTksadB87jpmtukiu8k
9803	payment	1726	1726	1874	1	1	2664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLoz4SnPPKjABDw7wVVgujfK99HUMkwA8ijSu2ft1MBXPL2auE
9804	payment	1726	1726	1874	1	1	2665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYQqSDm9QUeRJ3XthMGH4Puu8BuXubR1A1Qd7dvGmTnWZtUER
9805	payment	1726	1726	1874	1	1	2666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTK1vyiF28P2ndGpaBh8KsBWM819Q6NqeMpYvnaECTKt4utQ9
9806	payment	1397	1397	1678	1	1	5716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGyyeARr6ps2Kg46g3fvHhTauBKVKYdSVtEGcaoYBjg4asd7E
9807	payment	1397	1397	1678	1	1	5717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWfSH7cv58cE9aGH8DeejqYMybp1KPVuXj17TApXZxph4akDn
9808	payment	1397	1397	1678	1	1	5718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARjun3y6Uti49Qfiqcuwc6ycEroJRLhMt1Jd9xZyfksfYjiXC
9858	delegation	1750	1750	1745	1	1	16	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwPEMxczNdWMtkAvuZCRtwWJV4CUpRgMWKewijB6jRYwuRyax
9738	payment	1397	1397	1678	1	1	5694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaVxaJENZwHUhWWF9ZbZAV5UMk6iEhaLBwJgZ2UYPQtw7JoYa
9739	payment	606	606	929	1	1	7	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjFJYQGor1tuXGXmEETQJxSY4aBUFr9QSuAedKqrrPrc4U2oV
9740	payment	1397	1397	1678	1	1	5695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M8FdRjN3r3noMjPL5nadA4FrKzoznmCYwoc7Su4ffeHtJM6t
9741	payment	1726	1726	1874	1	1	2644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJntrxDNJWRCsv24iHKoUE1qdnos6wWGaDgAhX9wBcyTDNdGEo
9742	payment	1726	1726	1874	1	1	2645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4SDhBxjkdtk4wez4nuWTbRgFWL5BRzKAPix7vTjc6KbVyqoR
9750	payment	1397	1397	1678	1	1	5699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9piKCUanTN1srjUg9SiT1m4ZxGoiv4tFjUjWp4L5vrAzXnNS
9751	payment	1726	1726	1874	1	1	2649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCnQpeu2YGHMAH13doCaXbDUXSTshoKFxcTCs5ABhGa1R9ro7
9752	payment	1759	1759	1315	1	1	2	9545000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpYonqBrVsRz8VP6CF5qGzagnwEqkaHU3zCZvQZaDTGFMQm4NU1S
9753	payment	1680	1680	1993	1	1	0	419411389290	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	Ckpa7JXFYMKYPNnV4u1UXSLgrS7u3g7XVYL54Bz33QYjFuFfkbqUs
9769	payment	641	641	1336	1	1	2	10023912000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UXbbPRZrEcBdGzqUxZpmZaBnwyqJE6fj6UsnkChrUDHKXS59
9770	payment	1726	1726	1874	1	1	2652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhD2cg5QU9w21Xyt7DP2hPdCDtQgqnKRYGraxKsnamtq5a2uJk
9771	payment	1397	1397	1678	1	1	5704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdErPfyFMRUmMwrt1zz3iNjAzetjoaJ4LUVfX5uYraLkhUwX4
9772	payment	641	641	1210	1	1	3	3597984000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLgSvsAQHqAZE4YJZfee5YfbaKGH4GaKBFScRLrD5ngJKyKgq
9773	payment	1680	1680	1993	1	1	5	1250000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYSWLecwtDesVAH8NZRZ5kHavrYMT1gYQeyXS1jFtLvm2ioavBP
9781	payment	1726	1726	1874	1	1	2655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Fgcifx3k4SsrdsXkV7d2YvU6V6DXMp2oYsnE8UjZ3y8gwCtq
9782	payment	1726	1726	1874	1	1	2656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrMQmX26mKFbeRMVftvo3XjvE4W9bg2DrUGnndFaU2z6NJyWY
9783	payment	1397	1397	1678	1	1	5707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfjxRscknVmxQ8mwB9QdweAUU2UQQVa2zvCVCtCzfa3JgJPeA
9784	payment	1397	1397	1678	1	1	5708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmqVKyRKUMayg2Pr2CcfisfXh26x5pqvaGAeaL6zgY3YUxXWq
9801	payment	1726	1726	1874	1	1	2663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFuqnmBptL6WDvowWHxFLu2rdAWYmoGoTWC9XXS9pZH9qqLJC
9802	payment	1397	1397	1678	1	1	5715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cYXGxwm4cjfBH7SV19gxHBMLa5pJCSEH1B3MQUf7gzgEbZj3
9810	payment	1397	1397	1678	1	1	5720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQQRrdQJrkpv5pwKcVhex5sB8M1HE7MGBGsQjdTLhgDuaXBqJ
9811	payment	1726	1726	1874	1	1	2667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5hGva41Tjk2csgZD9xDeAc7AMzBePF1zXqwC8WQWCCt6FTeW
9816	payment	1397	1397	1678	1	1	5723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27243K6xJKvBEZLFewULXdihQxKWbvtwerZdsogFK9NrLwhbK
9817	payment	1726	1726	1874	1	1	2670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rcce2cJ3QVtX6LibkwfCo7FSmcnhZh7pR965Tj7pa9mYBekx
9828	payment	1726	1726	1874	1	1	2675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvvmsyYhQTLPyJJMHp2gvDUvZBNPdqC1jNyAACRoqhp7pE4Q1B
9829	payment	1397	1397	1678	1	1	5729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYBvH39urjRMGKcvhR7wHJnHWDC6TjqKBDx8nSudooTWH5UYN
9830	payment	1397	1397	1678	1	1	5730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8M7ExLo5PwmsLzsd6ypMGf1ASBpLYJJ4THo88b52YW5QUhyT
9831	payment	58	58	149	1	1	0	341	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6Y8KpxorA2iC2mHptn6H28Nub5SrDrCTWbhnAN57d2sG5ynF
9832	payment	1703	1703	1651	1	1	1	10486000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRcNTS9Fqm5eg3Pi28SBQfXde7qVM1JZ3ivHJ8PwE34hZHz4Q
9833	payment	1726	1726	1994	1	1	2676	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoPYGdBgAYHvjZJy6QuoHMWwxjfhMGN7BoVa9VN8zMh6rVbMq2
9834	payment	1726	1726	1995	1	1	2677	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRCMhHmMDUDAWPL8PGKezhLLWvqfGERwecjUmG93o5g1EFV8Uw
9835	payment	1726	1726	1994	1	1	2678	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLifUQxtp2RXFyimrpw15DApsC1ZjUQ6TX9UamJb3mjKmvrL16
9836	payment	1726	1726	1996	1	1	2679	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjJMnnofhryduXNzK5MXF3jkTFMvZ3pZ8iUge6QiaYdRE4X3rR
9837	payment	1726	1726	1997	1	1	2680	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpztnDnV6jr3UVyzmCUoFK25jr36jgkmVZhGBGqipR123GrN8s
9838	payment	1726	1726	1874	1	1	2681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8VCsQ78NVadYXXvAW7pucU4GDA1dfD33JDSnq9czusZhky1f
9839	payment	1726	1726	1874	1	1	2682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23vvVK3hoBG8EVLjudeJsBZcuJZ5PFYbXWXRY1xtqyMrkbcJ9
9840	payment	1397	1397	1678	1	1	5731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hX3of9NNA5187685DnVHb25L6fRFYhWb14ZmQ4Af6ovp57wr
9873	payment	1397	1397	1678	1	1	5739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dYb25wJfYvCvns8vPNsQBcEdqWbQC1GeyRCngRuHxSGRDQEy
9822	payment	1397	1397	1678	1	1	5726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudJ2SyMJK6J5T6YP2DKBq84QrPm2ZrCRGRm86LaAfjgAZibTz
9841	payment	1726	1726	1874	1	1	2683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAaxGSy8HyumgWP1MMzKMhhY7zK5iBwDtkUWt2DL4x6q622HK
9842	payment	1423	1423	199	1	1	0	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZbh7TgCd7oCm3hWbKvA4RyDn2W7UKguUVAVofAGb6BtTYZ7VT2
9843	payment	1423	1423	214	1	1	1	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYR5NBdexZRbsyh2G3Pu1vW3v8KA3dS33MJwvEgw6BsuPpMtqS7
9844	payment	1397	1397	1678	1	1	5732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhWrDGRTDrP4hsT2RHanLusGyvPs3vMN5xpqgFPsjyXAbMjCs
9845	payment	1397	1397	1678	1	1	5733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpTnUBxCMVKo9ZfpqSkZGehAx1v1fCGXWetsaNfY6kH3qPwx9
9846	payment	1423	1423	234	1	1	2	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZoBrvhRPrxk5nLv6JMcpabxoVgofQ5VobXwbSxoF43AF5J2tEt
9847	payment	1423	1423	282	1	1	3	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYUmiWX4AFUvKFXnQN2B6kuNqSpV3tJ1PFiGtsXfs7svvZvjWht
9848	payment	1423	1423	314	1	1	4	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZukM4cmG3ABGWmjjJUVqFXZPVzRNz2m3uHMXYH4W2efWe2Xv34
9849	payment	1423	1423	323	1	1	5	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVWFc3k3KgZa96hxeETdKcjgkVRMdw4NMqkFfsb3t9prwPBxws
9850	payment	1423	1423	330	1	1	6	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZLzqPGauwjRFQq64YAGA7arst6uD4nbtgM9RHsiz4kxwCd6boQ
9851	payment	1423	1423	332	1	1	7	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZEGERW318JH5H1uwgahy3bgNnM951bVLQDf9xSgTSKTjcJzgMx
9852	payment	1423	1423	334	1	1	8	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYR51krcBu8amPbb7K9qN44Brfyf5uTbp2bYYmdeM5ok4cCkbfU
9853	payment	1423	1423	343	1	1	9	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVPTyZ54XBUzdp1yXLbtmuU2t7Q8b7dQqvRwxh7Su1d8iS4R6v
9854	payment	1423	1423	559	1	1	10	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa6iECTBQwWge2K6EmuqpqBcP8HkKy7dLAkHNh6C9oVfcxtUyg3
9855	payment	1726	1726	1874	1	1	2684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjvJMFCSUg3ZUKwPG45EiJCn3wmFGH4nBPMjnjBPpcz5Uikmz
9856	payment	1397	1397	1678	1	1	5734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKwR4s64EA4pw2eRtS8JgBEr8UE5pZD7oXsTLKSjWCf5rvNao
9857	payment	1423	1423	561	1	1	11	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaFessQTF9uUD2xdL1yjJcb4yCwWRhPAkJZVXKVGjBkaAoK8opF
9896	payment	1423	1423	561	1	1	13	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYpwcAfUdkTYNV6QyvFGcqaneG9oMMMZQssHDUwDZAcdhQh7TSh
9897	payment	1397	1397	1678	1	1	5745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxD8biLQmLX4dQdvPAhYHUrX5uvoN3nYLcPCycpBcMW1cLfWLu
9898	payment	1726	1726	1874	1	1	2696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yrZmAb1faLiDMXgocNgsQfscKcR3efdVQGKMa56hL4PwGEPz
9899	payment	1726	1726	2000	1	1	2697	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzo3gzvrLftkqrn3Q61FanJ4wuBpG7SGrEGmoJFjJaFh99abuJ
9911	payment	1726	1726	1874	1	1	2701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1P1XmxNryVzo9vi6VCV2v4wsD5QgZB3VNAjfpoevr4apR9Ly
9912	payment	1397	1397	1678	1	1	5749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXNd2agRNc3UHCc3bkF1ahapjbVxeFw75Bp4vznLpTD9qitRU
9920	payment	1397	1397	1678	1	1	5752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUkwv4HQQqj28FqTCAbjW9LAmHqj1KbkmYLJKjZ6GFdFP7CHN
9921	payment	1397	1397	1678	1	1	5753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYbTM5nYbQSqH3EtDXFyJhpyGcLvkWkDK2YdJCrJUke2Ui6Mi
9922	payment	1397	1397	1678	1	1	5754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEhgeHgsCrWWfs96NAbB7ihFuiCoMeiPJ1FNuzHXqTnnm6V78
9923	payment	1684	1684	22	1	1	1	113350095941	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZh2QMB6f4Nn7dcJQ1zgz6MQm2uxXPY2JjRJr4RHvjmDSiWx7Eh
9924	payment	1684	1684	190	1	1	2	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYVRfXgy3J3bATFdaNxGiZQ5UfoNH1bgA5jkRGnMaQNTSQky5UC
9925	payment	1684	1684	258	1	1	3	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZeBeSwpAZiG6VYEfB85SQnxrKnp9cWdspSUHDW6y5qQCTprear
9926	payment	1684	1684	273	1	1	4	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYsDBs47f84fqTu5JwQkP62HvvjAfZAY1kSYVPZDkRrfD57NSc3
9927	payment	1684	1684	292	1	1	5	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZxVtiVZMs6TnHGdLQveyDZZu9nbHNupqnFJ8XBBZtCxNd77kBK
9928	payment	1684	1684	293	1	1	6	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYdjTaEtn4HVeT2gkZdhubgEezx1GpcFgFUswykBNb1gyCYZfnM
9929	payment	1684	1684	333	1	1	7	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYQP6UTujmNAscavYjvUN3Zi6UgFC8WLKPkNKTrX2ViGMLStPkT
9930	payment	1684	1684	376	1	1	8	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLB1N6yuY7JxAFAswWvpNtmWMAxwfWTGYSi6m4psc8Uk2154ui
9931	payment	1684	1684	426	1	1	9	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZbb6N6YtPyJkNBuAQWt7pecnQuqFCp7do1Z27GptXgH8D5s5Ch
9932	payment	1684	1684	429	1	1	10	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZY2dybpXLx927f5tYvv97xguvqn5MaoDrNPgyZTCM4PbiijycT
9933	payment	1684	1684	430	1	1	11	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYmEGVVaEBhtFn3Zsj56UfLs4KoKjGtgsNuLCzexnD4MgFykv6r
9825	payment	1702	1702	1651	1	1	2	9354000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBAyWfgRWd7khHYugLMppAsFjX1HuwbP5M87YEyvWm5pAk8RU
9826	payment	1726	1726	1874	1	1	2674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7P7hDvQprMdALnfkr4tNiRhNmvK3fTqXQMH6KqckFcYV8tzW
9827	payment	1397	1397	1678	1	1	5728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixyZQ7AiS2LbzgAxuVwHFtySnxtpFWZu8tyhTuTGARupJAT86
9900	payment	1726	1726	1874	1	1	2698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUa73z4Ua3jV4XryU7hhsVa3VPtDDThmy4tds9Nxs8yZojR22w
9901	payment	1397	1397	1678	1	1	5746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1taRQzQRfv6qrBUJbLQ3z1N3Ged7g6iwoQ6RpXkuBomNbyws
9902	payment	1607	1607	271	1	1	4	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ehby41KwKpxtcec77CU8db3xdyGo7JU5gNRD8gmCxQEsAtYh
9903	payment	1607	1607	269	1	1	5	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZaVgx3CVQMAv4vDi5tWKwaDoSobn4MvRra9jeARpZKSjCDZq
9904	payment	1607	1607	577	1	1	6	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoF42PrdC8TwDz58W6VDvhYsgrWuAqqmFzfUmVY2osWRHf1y4
9907	payment	1726	1726	1874	1	1	2700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsx3oJ7MkNrNz4tqForhmuVEwCGTMvTKnWX3rbdNDsGFtfECL4
9908	payment	1423	1423	683	1	1	14	1000000	10000000	\N	E4ZRr9KPUGGD1N17iaFeRLiHx8LBLo4BM3X6TDNyBcHRfT3vN3exv	CkpZxAb1c3Awpyqpv4y3fUdj1RyD3scuunb8fKGsEbQBTyp7pAL1i
9909	payment	1397	1397	1678	1	1	5748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xkCpfXGB1FeoaKKoQmUJz5mYBKWcktFRA3SgvY2ap4hajJeG
9910	payment	1764	1764	968	1	1	7	2541000000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpYhUWgAkh1Lk7DaDZntnEEZUVuTeuhkwUpv3DSKu3kaX1vQhtZy
9992	payment	298	298	1768	1	1	3	3038000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSAhB8THwDkgyQY745yAARVhF3SbvrarDQwkXd1Ugkrnez5vU
9993	payment	1695	1695	1330	1	1	1	6430000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGn9cDkkZttn5w8XDfnHuTHAYkAUUs2B39M7UfT5cpN1b3ApV
9994	payment	558	558	1958	1	1	1	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTMB5zwzQpjsUvbxThqKn7wG8qqh2BdmCxV55k9bGuFQNRVcb
9995	payment	1726	1726	1874	1	1	2712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBZfJEqVuSqbK1NTtMVRiLXdSaeLZvjXRjD18HUmx8gkN24PF
9996	payment	1397	1397	1678	1	1	5759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKMVTW8vd4PjokoC9EJbVUUrCM61MiBVqxpyNToBSkhk7CUGK
9997	payment	1397	1397	1678	1	1	5760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeW3xwkZsSPTbgQjnadhFSqkNMTbact1XuwjfDF5PJEWQQNeJ
9998	payment	1684	1684	681	1	1	55	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuXhFGoZgzMvVwbrFJWTdcoVF3kux7ys8i8fvPkyHajPxFphQN
9999	payment	1684	1684	720	1	1	56	10154089039	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	Ckpa132mtqDxLYNpmh2ZHJ25MJysjN6EBKXA7L39VHWoKX6eF79gE
10000	payment	1684	1684	722	1	1	57	10154089039	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYpQkoK17gGd1yS1uKo7q25nUJjKTNRK8rVC4wZu53vaNBk9Muz
10001	payment	1684	1684	760	1	1	58	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaExsVSmMwvuTMqYitFv4uuHT9qviNFGbYjghWxfHKNs1p8UQiL
10002	payment	1684	1684	763	1	1	59	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3RAjpV6raE9ueMWk3FXt75ogTbbqxRucgzTPBdYPYCLopZGd9
10003	payment	1684	1684	767	1	1	60	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZdshcYjgrg48LL36odj7L2vtRVzceV17e6zckNjCW2XjBkZyMP
10004	payment	1684	1684	769	1	1	61	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZh32WiPGb6yCoC33EprKe2hr9dvNKaoFjWtJDC3zXkVVYQekTQ
10005	payment	1684	1684	958	1	1	62	2608000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuKe9hBbMBZDrTzSMkAAU24hQQSmBnP7HyoVercY6ZZCVdsA5d
10006	payment	1684	1684	1078	1	1	63	4673000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLzxSTnbUEHEH27Q88Vtr2V6k5abN4nVFBeLp8xp8kzj7KT9sQ
10007	payment	1684	1684	1198	1	1	64	3153000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3amMZ2T2RzfBr3dorVbMy3q8SXriJ3sk8ad9VmiRz89oF91z7
10008	payment	1684	1684	1324	1	1	65	8786000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZUwXPZSoaErtAmFfy8Zx1EYr7aff5a66vGBtJuM4KGaEfFVZi2
10009	payment	1729	1729	967	1	1	0	1914800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DopZYYbGN8n7H6FnBhJ1yiZCdQdXw9EbjbnNXYXsYuGaaHpZ
10010	payment	1729	1729	1087	1	1	1	3431300000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgpYNBtZLNEkFqScUrE9g4ggqHMfnVG9PhVzRDGwqcpgaNJQT
10011	payment	1729	1729	1207	1	1	2	2315170000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXg1jDq6ediL5RxT8ykZQjw5HkTyzAt8g2zz2VThfP4f2xJha
10012	payment	1729	1729	1333	1	1	3	6451500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4N47EKcYwFkJabCnQJJB4Z9VprcinZE6K1rFLT6v1SPZF1pqN
10031	payment	1397	1397	1678	1	1	5768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYri4LGvy2RvvWobPDQPt5c9RfjPjRe5rQTd1VfwrMP5axFxHdj
10040	payment	1397	1397	1678	1	1	5772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8vAAZWhVtZwpUcEEtS1bfw2p9G1ikWBCtb85ZBmu3aGSZGMP
10041	payment	1439	1439	913	1	1	2	1523412000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAyBj5YsJKnAWAoSEhrXHh3WNQsv9XpGY6zRyZwBsJANNvCPN
10042	payment	1727	1727	1148	1	1	6	99000000	10000000	\N	E4YxX7z3dDu2y4TiY42ENEv7UNHR9iq3ez6bW2qAqgghCENgFwzPN	CkpZmHaYcah447f8tKfnog84yM8GbWixoS2A18yJdiobyeVaTzbMP
10076	delegation	2003	2003	1651	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSfYTybnXiGnan64bS9c2qEgQHQAerBG5g9ke4Qov9SoMGF4r
9859	payment	1423	1423	683	1	1	11	146584999999	100000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa9gzDqRJ5nY88akTrQ8wyS56ApXXatKkLGEhFJvAbJRqwBysRG
9860	payment	1397	1397	1678	1	1	5735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC2yRckYnWPH1HfyJhRXwuk9urRv5M5aiZLQtaTsm3tmryeCv
9861	payment	1397	1397	1678	1	1	5736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFpiERCCinih8b7nkkvFz899UH988vWB69uPGS45L2aLQzJwG
9862	payment	1726	1726	1874	1	1	2685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfufTshWFGJz2pALbG3GEoxf4tHpN4sJ75Qo3Bj1dFic8oJ2R
9863	payment	1726	1726	1998	1	1	2686	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXGupZQFrovFunkPGmRh23UF1Bd8Axeehm3V9eNUfri65eLsbn
9864	payment	58	58	149	1	1	1	341150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4CgC3iCZ7684ucqAc3VBmLQmaZUKcsCyHWLkun7tYmt1PuDw
9865	payment	1726	1726	1874	1	1	2687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoAdRQZK9DxKSrcMcJjbuvN7fNNH9TXurc88hmy63TeVWCQPe
9866	payment	1726	1726	1999	1	1	2688	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZSqMm7FrKujTpvf11xKZwUX47JwPk4daLYmSeU1VxJRoLCCuB
9867	payment	1726	1726	1874	1	1	2689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkH5SxcEpFhTkhVR3R69ejPcWcmiN8eijQdsjXHqvg8aSxpAM
9868	payment	1726	1726	1874	1	1	2690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXJuLHPfijDFt7tRjWA95UwyVxWYFeT5xRZkLDbtVYW7xaekV
9869	payment	1397	1397	1678	1	1	5737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRur9WNzsGNy6MQs5B1BDqH65scoePXpfowGyN89wri9Kfgtg
9870	payment	1397	1397	1678	1	1	5738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNY7LhpFAUHCdtWgAc8peaRuQTakDoBgkPRkKvMBrbfd8b7wK
9871	payment	1764	1764	1088	1	1	5	4551500000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpZLcNCUuLtJS8mxbxNG8utrY3YuDLhxeTGRQyYaBAbf4Nvc5ChR
9872	payment	1764	1764	1208	1	1	6	3070500000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpZaF4XSpZgexzcFZtLRWynmT2wKcC6RjjBsqLobvGYATQ7gKxhQ
9913	payment	1726	1726	1874	1	1	2702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwt4uCwBHcCtTyLCCkm37MvizwvKdGDDM8gj41xoVif3p5EVGV
9914	payment	1397	1397	1678	1	1	5750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACruKwGAX1cXbJd8n2MFa7nVcvYnzdhw82wijMk42GFrdP45b
9915	payment	1749	1749	1327	1	1	8	7570000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpYZpZ38UaMfWrLvsN4mWPXrRSCF7TKQqsNaMqe4WxYbSjoogZw9
9916	payment	1749	1749	1081	1	1	9	4026000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpZMh7chEdgwE5Tj9xtjDNevWq7rLwo9X3NWSCparpmPscrQ9RPa
9917	payment	1749	1749	1201	1	1	10	2716000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpZUr8EcLqZsnu9VMACNF5WJ9RwYY8hydoPgApaw7V1PDSMgDHCx
10032	payment	1439	1439	913	1	1	1	1523	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS1HBZuwsc17J5xPLWPXEKv4hopok1XvZVNDAJNUucxQ7bist
10033	payment	1397	1397	1678	1	1	5769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4bFsC4AFCsipEGomQN6zQpepr2GRBdgmfoa1eUmQHQg53p8B
10034	payment	1397	1397	1678	1	1	5770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNo9YaL9zDgLy62iK4k5uABnQK2jSA3cqo8YNpNAcYSQQ8Vrw
10035	payment	1651	1651	1055	1	1	3	4737193484311	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZdAscNDj7quUTZ2FtByAmzJyYmdEPCA9pXdk8ZxU1Xf7C2asdc
10036	payment	1651	1651	1175	1	1	4	3196278839126	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYegLBijecri5jEbCmwuNheJxzb5AvwieHERsUDtQJW7qb9TXNp
10037	payment	1651	1651	935	1	1	5	2643535789138	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZ9U4B5gWdFB11qyUeqg9BZqB2tyZeK56KZBcsqqxcm69WfG2Sz
10043	payment	1397	1397	1678	1	1	5773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZQPPHo5Qrbg4mzqoW1W4CHppZUkKYERRLQorDx6vmPgLLSn1
10044	payment	1397	1397	1678	1	1	5774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYun2yvdrcpKqQUfMWndRM4JZMnPR7o9HSgy45nhGFv5cpwZhAA
10045	payment	1726	1726	1874	1	1	2713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteV3U9xPA8fZWvNHbiFi9PnxwMpr26tHxEXz8KbMsPsBykr9h
10046	payment	1596	1596	1363	1	1	6	7373028977584	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7GGusWSbASdRbW2G9C138swF5QPw3mGLcWNHGhBF1TcZV2JB
10047	payment	1596	1596	1117	1	1	7	3921475439233	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7kgmdc9iSv5eeDmZdpMnwAAJbhJntF1Rt98te5XDev8FEkU9
10048	payment	1596	1596	1237	1	1	8	2645897619768	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTtV8MNUQAsr2go2ghUuaXCVfiKJ3RKWCEJy3bGs4p9rTWCvn
10049	payment	1596	1596	997	1	1	9	2188333810757	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjPL16yzj4cGJ4amC7cTB33CRnQnPprbpQTEtb8AAZ62mTaCr
10061	payment	1397	1397	1678	1	1	5777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQQMdWpgNGsXqUDqzKXGcA4WwukeJKgwcPwuLA6wzCiF42Gbm
10062	payment	1703	1703	2003	1	1	2	1033000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArHTLR4fLtTCtURjug3UbE5RP5eD42adiHW5HDV3ZbFeXxofp
10063	payment	1726	1726	1874	1	1	2716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDpENahxEuUqJR3vH5xC2sgZeMUhNKyxNNJmHRTiRFvY8Bbu3
10064	payment	1726	1726	2004	1	1	2717	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1YbJmupYqzxNZKWhf9RVPui4zUQT4uNHoF3vwmHA7tPmNUUSA
10065	payment	1726	1726	2005	1	1	2718	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUzP2G6WNJKv9kq9fxRuLJCz7QvdBbmGPM8VPwwtZ4CDFwb21i
10095	payment	1607	1607	242	1	1	4	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqbhVd9xyx8NvRwok3UEFsg59o2CtLsoP9zdo1BVGpcV12cqa
9874	payment	1726	1726	1874	1	1	2691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pbcTMX4jgv7eVUd2yAWcU45iDhxMBeqMCr9PZediSpddswLk
9875	payment	58	58	1281	1	1	2	8755860000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdGqFYjshLKZwLchEdoiP56zhNk2LqFAo8QiCbwA7iJ3xf6Jo
9876	payment	58	58	1035	1	1	3	4656960000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseRg69uoGcAFFVSqCc2nSv72oNTokmyMzBJ3VZd2AeLxxx7Ee
9877	payment	58	58	1155	1	1	4	3142150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGbU4M4mViQAkWKwZwJFMPskojek9PWGUNLWFbxQ3EUA1sq3S
9878	payment	58	58	915	1	1	5	2598770000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4u75zHoTS1tgzGSWmh8tcsCsdMjyTqgZaJgPMyLHBjqVC3wr
9879	payment	1722	1722	1764	1	1	11	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzycYLuqaJqZGC1tRT5fS5yz7cQrLQf6Bd2SABaukmxvqzKhU
9880	payment	1607	1607	1348	1	1	0	10132684275022	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEznKX8jt1R9ZFp4NkRc5qMQ8KkHZ8re5orA3iqZjWjLohm62y
9881	payment	1423	1423	104	1	1	12	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZV87wAUtjPcfCtsbrm5eMgfxS4xQGyYLgUR9B1zPmdz6R53WvE
9882	payment	1397	1397	1678	1	1	5740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AgTJf18wVzQvRXWcaaS7ufY1sAnPF6hxQwQ6T3yNYZwfyLSH
9883	payment	1397	1397	1678	1	1	5741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Epcd1DDnfzC6qMyLZRQtgwZqx5eVMp7K43kP4JXdXe77i5m3
9884	payment	1397	1397	1678	1	1	5742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEbayC1M4XUCdsMhcRMMfbm1uYvUdnXAmLBj7T3GhvjH6rHEa
9885	payment	1397	1397	1678	1	1	5743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPNNwFTa2D8kKYUN6tSmHF9YDSJ4ZBT8qQmBN225dM82hgtp7
9886	payment	1726	1726	1874	1	1	2692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XLmYjbBfaS6tPnkAxWts22z1HzyZvBfeWwmNqwgkRTzaVHvr
9887	payment	1726	1726	1874	1	1	2693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZum3zbM3fkyAxFep1vW9NEK8241eQyTuCVeLBNFp9ExhGW8vaB
9888	payment	1726	1726	1874	1	1	2694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyYwBEFLsfK62M2u6PUedXmYrcxExfADXPz1jkX7MCYBW5C3CG
9889	payment	1607	1607	1102	1	1	1	5389246758531	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSDmr2hHcAdDHe1H5JxbzL9b8kZ5EiPkNT5u4vKfYagE7j7NM
9890	payment	1607	1607	1222	1	1	2	3636232176308	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmg4H9Q7vK3XCiBaHV8HdM5FwX4S8UDZtYDgpy5Xouj4MhEyV
9891	payment	1607	1607	982	1	1	3	3007406543521	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4QbTG6RHUU5rAdPcnRgFhvZDfHLuitcu96WVZfBnKQaDqq7t
9892	payment	1722	1722	1749	1	1	12	1320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTx1UTkDWKUW9Qc5uUyHcnHjV1wZcevp5HYxGvQZD1HZckYvi
9893	payment	1397	1397	1678	1	1	5744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh3ak47yT8cBUfn3dfUijmydH6A3Tx9sgfXbsGz3FkiicVkCJ
9894	payment	1726	1726	1874	1	1	2695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQE5keH9mbUyRjCcvKeVvLmUcwg1Log7xMcodUZGEYYeR9QQg
9895	payment	1759	1759	1749	1	1	6	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9mVnQyw6M5JHaqXGZtdAtMy3hHrgGJ2eZnwC5Yb1v5PSF4a1
9905	payment	1397	1397	1678	1	1	5747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uxhRPJxW9Cshkf2m9kfiBcotjq4UBJ9Dkcv4cEs77wqTWofQ
9906	payment	1726	1726	1874	1	1	2699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTM2ciA5TybQiarU51g5xQh836nvmSZE3VvbX9Zbu6FUcxtVh
9918	payment	1726	1726	1874	1	1	2703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC12do3skgCgnc7sonZFyyKmFG4f9RtPrqZ6Dg8N2GXZeX5RE
9919	payment	1397	1397	1678	1	1	5751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC22vWR1yqrFD7nUvrWw2jb5FZ5nhEpYdMoCk3pHq8ss3HEAU
9946	payment	1726	1726	1874	1	1	2708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhAryFa3WgZviQDGePspQNiYwWR5dpn7nXvoLx26X86xuxRgP
9947	payment	1684	1684	511	1	1	20	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZphktpu6Eo1LASRaSc75QPgLYvs7LPCQCe8LQFR8Wh9HV3rkmj
9948	payment	1684	1684	512	1	1	21	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ6eBq9JWVRdVWDYu9hmkiRbum4fABAY7xPtwmy73oXy4RcmCYk
9949	payment	1684	1684	522	1	1	22	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZU19DTS5pKHMZhfNWm376CNf1bN2PW7FmMKYgw61PjqT1re9kq
9950	payment	1684	1684	523	1	1	23	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZUL4nBpvGnYvv9bu48fnxfvgTBS22sj1JY7tV7rSrRk36xhqxP
9951	payment	1684	1684	533	1	1	24	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYkPq6FTaK7oH1udXwUjEFSLHk1KBj6DBwAb4cZTFPQ8H9DcNVY
9952	payment	1684	1684	539	1	1	25	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZGVQiUUgDUvw2aeZ9CaqEHjd7bfTAUYj8MppREwYVekmsuPNNv
9953	payment	1684	1684	541	1	1	26	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ6C34k6ePbJKdFpZ62JcDVP6JrEjuyvLe6qVfx57QKjavpgyef
9954	payment	1684	1684	558	1	1	27	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYWGEGcMDPGnGP9Kp9FpsXTe6H98tb68qegvbZpXPgcQFe3ufJW
9955	payment	1684	1684	565	1	1	28	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYyMyWduhfBdUqGfRqme4MRF3EcEHgG2xGWT8na3Nij9sJHDR9u
9956	payment	1684	1684	572	1	1	29	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYTbpYLTqgd3rPbsQ5zioZ38dUkjyFBoyn2UVefVFKk6qKVxmJv
9957	payment	1684	1684	573	1	1	30	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYhJVqNE1vk9oNCATADAZUP4oRqCcNA9vaocFth8u7aC73Ttnh3
9934	payment	1684	1684	440	1	1	12	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZMfQEEFkKU7rhe2VoEuvuAhSq8bGBMFJ64jRkoCsmxzaopQvb2
9935	payment	1684	1684	474	1	1	13	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZmPLYW7kAbz1kpHqGZZwZiMoMbFarL3bnKJjwb142wfDxBZtDg
9936	payment	1684	1684	475	1	1	14	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuNGU9CqTNHtZQ65RWLTUFntV1KcbQaNaVM7vMyLpQpb3wMuGk
9937	payment	1684	1684	476	1	1	15	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZEPntPnQAdtdgNrRVs9pgm52y5tst8Wq5WnHkGw3KyVGniepGD
9938	payment	1684	1684	483	1	1	16	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZHm6dWfA7XCsmh3Qf96Zb3Ljfb6BAhBycBRk7DEfy9PXLL871k
9939	payment	1684	1684	486	1	1	17	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYvZNNAtKsht18VbdaxjbN4bYhfnyz78XVjTsZ9KUnhbPymCCc8
9940	payment	1684	1684	490	1	1	18	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYz4GnsgGVfcw3mx8jNVASpmiNeaKi8pHmxy1Lavapi29hmwciY
9941	payment	1684	1684	496	1	1	19	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYwWbH9FmYZ5kko16rfih4WXuRNTg7emWwqQggdUQSFB8X3tVVA
9942	payment	1726	1726	1874	1	1	2704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGK6iuV84cWaADr9STafSt8fyYDrPg8qZTrLutWqZdsBgH131
9943	payment	1726	1726	1874	1	1	2705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMazgQ27X8J5MpvJGs44HphEW32xhVwadDqxBsFUa8k2h8kNB4
9944	payment	1726	1726	2001	1	1	2706	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa48QxbCCNmdUk5oTi4W7wcsQd6aSjbUXh3k5Rt17DZBmHDiVfK
9945	payment	1726	1726	1874	1	1	2707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi8KFSswYowiPjtQrivdV9JiQLUEzfEeuMuY6q3WJhaeEooJX
9968	payment	558	558	2002	1	1	0	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCScGS14NSC8efXw2UaRHKDJsgeCVTKZ26u4qgbNrxPWKicUAk
9969	payment	1397	1397	1678	1	1	5757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmu1qepJ5dQxugeumsm9i4f1NA2eZ3AZ9pURXPYRHHJyK6WtQ
9970	payment	1684	1684	609	1	1	37	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYd9PyALntYrpNmsSjL2mKRXagSuGgFWo558oDV4RnN9caMRU5i
9971	payment	1684	1684	612	1	1	38	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3cTHFmKjQrGRZzPw7djaeWhbZKinCPgEhgWVnPwz1H8WEpTFt
9972	payment	1726	1726	1874	1	1	2710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqYLGUqviiMUzZz3goLK5j1yVQAviUQ49iR5F6hcnUBAoUW5X
9973	payment	1684	1684	615	1	1	39	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaFHK7hXXvmkiBofnZjnr2PnRAkywCujJZ3WzvBJaHVhN6rLgwZ
9974	payment	1684	1684	616	1	1	40	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYjFzaymUSaHxG4uTTpMhhAZVgBcrbPSwb4crycPctvHo1i5n84
9975	payment	1684	1684	617	1	1	41	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ8UEsD3UasmEMhbwJR8fadCDmSUzVxP7sdCLe5a5hv8JVwepZZ
9976	payment	1684	1684	624	1	1	42	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	Ckpa27Y5wpRnfuVqoKtxRDwGZ4dBtuAAKPN2E3z1XDbbeCkcwVNvX
9977	payment	1684	1684	625	1	1	43	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYxUqoiKHLcazaV5j5EwHmUxKS8EMhPNtb2Wchi6tzBZk1sd3Fo
9978	payment	1684	1684	626	1	1	44	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZPfK34bcrs4uaKKw6M84WZKw4z1itBoxVko3Reaf7Z7bdUbLzv
9979	payment	1684	1684	627	1	1	45	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZynbgMRLU6CSEoehMGA8XAuRfRV2Da2wRZyzbZEWhm35XiiCAC
9980	payment	311	311	1762	1	1	0	8639000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdhpLrJiRwgubAJoycWGwbZyivJCumcvynueDM3cFs4cu5nRw
9981	payment	1684	1684	629	1	1	46	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYrfbdkF9aKzxsQSVMLBnPuR9sjPbt77VtQmPrFsxPvG2s1ehmJ
9982	payment	1726	1726	1874	1	1	2711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnPLY4fjzh3aWb56peNNjQRxmQ2uoRx7gMSZ4kpZquuKGA3QL
9983	payment	1397	1397	1678	1	1	5758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKKosddbyAtarph5qzeRqwvZAgRC9z7N49Fmf9Kp4QxXFG2ta
9984	payment	1684	1684	637	1	1	47	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaFzg5AwytXnPxa3j6mxz6VU9cfmBYt12UqWm2xS77a6MK2ED9n
9985	payment	1684	1684	647	1	1	48	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZQCydcke5oLPdSWUPNJajJhEYxwk8uk3Sjtpk5Gb22ji6HPdCN
9986	payment	1684	1684	656	1	1	49	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLQ932JGLuQ5o2P6Huv6WWgDBPiDzN4SGL3SmXKcrMTQoi6kfS
9987	payment	1684	1684	664	1	1	50	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZzGWiWbufTMXWKirEFSnFNJKwwSExN7Gt5L8TYPKYuJuToUPAa
9988	payment	1684	1684	666	1	1	51	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZkTodGn9DRn5Qsg8Wd9Z3k8gSbzRZj9WGW5ZESeZa1pvBH4yyd
9989	payment	1684	1684	670	1	1	52	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZo7fFNMvP1U1fsW4V21CRfjraXwdSxYUANucKbC9k2gb85iD6k
9990	payment	1684	1684	673	1	1	53	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYqEvaFdR2ibkGuyhzpv1rJjv3jhWxAZv9dWatqQfgCc65tLmLr
9991	payment	1684	1684	674	1	1	54	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZFA9SUUVamW9RkakTTvbYKSEbNUwzf7FpR926Hjdedauuyh5oR
10013	payment	1695	1695	1204	1	1	2	2308000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Wb4MDE6KwbSSL39mCoMnna1Rigy5zHbWe5RG6NeMwbxn2dx4
10014	payment	1695	1695	1084	1	1	3	3420000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfhcTmTb7J8SmU4bjFGw2U8NBqLtC1FZqb32wwAxPs5bYZ76G
9958	payment	1684	1684	576	1	1	31	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuU32q14g4kZcJ9NJ4hb3ZrVHpPwCSVsCjRshCEst5jQaAJSin
9959	payment	1684	1684	584	1	1	32	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZK91XBftQr7wQ6DBu3teK7avGEFT8FQ5gnjfJqJHpUv4VLfsGU
9960	payment	1397	1397	1678	1	1	5755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjqFvRtXHUVrLtuM2ueYVLC2r88QexRwGWa6qEeJV8wUUBnQg
9961	payment	1397	1397	1678	1	1	5756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF6FMdwZMEaym47TaYU5TwHksFAS2kH9iWruDqTq9SaM5VDvi
9962	payment	1726	1726	1874	1	1	2709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCf2RgTQeTxcYRcdTjfRc9vit9YTda8jEBcx5r17pHsHGhf85j
9963	payment	1684	1684	585	1	1	33	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaHMRRy96bo626vwESePyqAVNiXBpVH2XkEpbwSb4R8EgAff4sn
9964	payment	1684	1684	589	1	1	34	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYwq5D5aas2bPbjXDU7APV2ZYfG7rdNTrYbLV8gYRJawiSvMxia
9965	payment	1684	1684	595	1	1	35	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZgUw11v5VtXPFnSECjqAFfkj6DjPG2gm2M5okZX2q1CYCNwocv
9966	payment	1684	1684	597	1	1	36	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZa53eran1uwwALmnMTmk5UEF32M4kptY7WgbFtWH2odGp26pau
9967	delegation	1750	1750	1745	1	1	17	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQAW2WNVCaM9rjN2859iWQxe8xKdk4bFNJGT3D3t6gfXdjXgo
10030	payment	1397	1397	1678	1	1	5767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgCMM7B8f5Zedvrztk5nFi27qq74VvQ5NxAfbvtuhH3ZeriQ2
10038	payment	1397	1397	1678	1	1	5771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoN31rF837cfugifosc979oHuKCxa2mmgUmrP4gxpB7csZ75pF
10039	payment	1727	1727	1316	1	1	5	100000000	10000000	\N	E4YxX7z3dDu2y4TiY42ENEv7UNHR9iq3ez6bW2qAqgghCENgFwzPN	CkpZKFjBmLNn2eGiffmMAsmaFQ11L66fRTFALiptrbPdLdQLqEX7R
10050	payment	1726	1726	1874	1	1	2714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ASXiULmjaQcKY8aSWG9uQ61BNU42kuukpQ5rzjJQ28utZ7RZ
10051	payment	1397	1397	1678	1	1	5775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FKx9BigEFjDZCTuGSuz44Q7Ak4EcTzX1YN3rypYwHWpg8Qjq
10052	payment	1726	1726	1874	1	1	2715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4dwp563xK6gjRxCgDFoNq4g7ULLQd7fHHP5BHXUewHbCGMAY
10053	payment	1397	1397	1678	1	1	5776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZst4PCBdAytc1FgYQEQZybkpGzJoxyBbnTk4fkwyhWPsX4tuWy
10054	payment	1439	1439	1153	1	1	3	1841946000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwN6UNWFf8QnkAGkCk76QNWGC1fW4AnX6bTNSvxGadAd6FMoo
10055	payment	1439	1439	1033	1	1	4	2729941000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFK6rUZUbChLyvAPWypyEv8xyiKwA2TXnExr7akMMfrzVwPPp
10056	payment	1439	1439	1279	1	1	5	5132745000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa212jzSjRPivgV9BmtDfEUogF3QPi4W5Bt366eAnqd4jnseUPD
10057	payment	1719	1719	986	1	1	0	2097160000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBfgRdD2xRrc1BJvfzX6vqpQCa7maEXpMHYdVDr978KnU1aA2
10058	payment	1719	1719	1106	1	1	1	3758090000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoT5mSNYrHA24DNYTbQdpWZ3u67crFQfKFh63hLPHuw9QJ9rV
10059	payment	1719	1719	1226	1	1	2	2535660000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v2dbQRtTx53EJ1v1hZb2FSRVESU2xHq27Rw3e6E34HwTrKpH
10060	payment	1719	1719	1352	1	1	3	7065820000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocAauHgWRzGeEa6fCB9ZVmyEt9mJctrprrM2ebAG62NSbV3Qw
10079	payment	1397	1397	1678	1	1	5780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6e9EkywhheWTWJiYdo831yeNUN5vRc9mkKzgYojrN4hqPX47
10080	payment	1726	1726	1874	1	1	2722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXR5Xt1PKuCFtFSAXoaeBvh3h3X5895k85NtaeHaLQJuC2EzR
10081	payment	1726	1726	2005	1	1	2723	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdvLCXXBGx6YCnyqAMXPnQMtqBeK9zXXavJEbHTxsd1CNAPQSF
10082	payment	1768	1768	1308	1	1	2	7297200000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpYSD9Gxb3PQZdmh9Lf8aYj5rJFfM7UvzsbGqYRprifTmqg8J2QP
10083	payment	1768	1768	1062	1	1	3	3881700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZyQjwRr7bhveYAFZWmdhRaN4w25LGejprvbsaUoYmKWmGW8Taz
10084	payment	1768	1768	1182	1	1	4	2618700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpaBfcPjwrQ26cNr9W519qaJgF2USP3xEpUU6Wth5xgt3nVf8hRb
10085	payment	1768	1768	942	1	1	5	2166600000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZAts3w3hnn4ywFkQrKGbmPe8Bbp9Ky899Lmg863pkQtVHnKTRQ
10086	payment	1397	1397	1678	1	1	5781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUsfVAN8uGC9khH8QPQahFbdNK93SZhSQcxrKb8S5BLohkvfK
10087	payment	1397	1397	1678	1	1	5782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabeABcnkwqsb9YcdcdnGCcLNqvP2C8hqridjmyi9VpJfPpzQ1
10088	payment	1397	1397	1678	1	1	5783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRJQjHAW8ZLvq6a75fbWYyNmy4dCJBU6ANSemgL7usvsXiSaf
10089	payment	1726	1726	1874	1	1	2724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRrpQNxhAtgQM2CbsQH3eNUubMTmFBBfezceDiNjLYWNdD79P
10090	payment	1726	1726	1874	1	1	2725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSSPD9LzdLvfjNkP7xzK93zKPkvAmQYM4YvCaSfqAAri3SL2Hz
10091	payment	1726	1726	1874	1	1	2726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqwg2d5AyqX3LqFQvLZtp8RfGmKEwoDkogjcz5kYB7rZhfw5g
10092	payment	1397	1397	1678	1	1	5784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvuyqPzoBvjnXL8wcZVbC6DAnv8NC83fv2JswQxEVszRvegZe
10015	payment	1695	1695	964	1	1	4	1909000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL79gkurXd99NC76Euhq67zMWAS1m6ECyLn52eEGnwYfC8KDhw
10016	payment	1397	1397	1678	1	1	5761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGq8oyGu2Df2wPr94zbcZ3QhShmupFKbvVXr6LJzVPzYAqxpdm
10017	payment	558	558	1958	1	1	2	295000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqR3Ttu3HPFLefFYATGHQheXktxeegAgbvv1PE5AuUJzdFAtw
10018	payment	1397	1397	1678	1	1	5762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHZ6vD6KfiGp1eQVXbBZdoz6J3QDzPSWJBfgQ1FYY2XrR5PVa
10019	payment	1651	1651	2003	1	1	0	5268367953	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYh24cnyAvhMBNT6cRxAnhDKsfstg7iVNVkgEHvEBSmSPN1gQiS
10020	payment	298	298	1768	1	1	4	2000000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mEQGbWEiYPvRPnYCjQzKLbhSJw6TNHDsaaLhpzEQKRovVYHi
10021	payment	1397	1397	1678	1	1	5763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxmtKAc2vF2F8ok6ikTZngHLDZpWTgBn8QHmS6kyqXUTSzDgX
10022	payment	1397	1397	1678	1	1	5764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86PvMpKyjkKu3atXF87fgrBHn8JwrVGvqkQHhNQkoAmgejUQC
10023	payment	1607	1607	242	1	1	7	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xMf7z8udveQvX9jmGC9WLVwjE9HR3arBpdPRshBptSeTNNMi
10024	payment	1651	1651	2003	1	1	1	347712286868	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZB1WXcsZppjtEAzPSxJKUzWYKMJaq2bgJKrVphimpnJnEUkhjw
10025	payment	1439	1439	482	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBUR4qbx3KKGAe9nG7As3XcViZGFJuECcbFP6kN6fnaq98DTL
10026	payment	1651	1651	1301	1	1	2	8906715182489	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRh6CR72ohvG7g8kDbm1znFMJGNKPqj7kj2Rw2uKnoDayGK5h
10027	payment	1607	1607	372	1	1	8	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygtU7aQ2hJdwDL7Jy8dTEYKbztqQJUnHSWoJR44Z9zavnk99v
10028	payment	1397	1397	1678	1	1	5765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JxihfmNHoGKtqsKoQqjVyjP4RhU8hFxYfqDK5VjbRs18iUEy
10029	payment	1397	1397	1678	1	1	5766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXHcsj2VWCZD3zHm1bVU66tNNrS7rhZULZaA3AcE1SnBpNCaq
10066	payment	1768	1768	298	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpQtYRMFoTd1Jhgr6yX7HHwDrEXjXSoMQqfy7JjipvdPB3m4F
10067	payment	1768	1768	298	1	1	1	1000000000	100000000	\N	E4YRiPpkpbcWzDofM8ofr8x9F3PYuKqG2PXcscd4dommdiYMYu3AP	CkpZAEtEZUQyFaj9xUfQHxCUnPEHYHDt4ax3L6tgjn5ub8oudmot6
10068	payment	149	149	1283	1	1	0	5628270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuv4pfVwP8ithddgB8MfkLTD3eGME83uvYJpfvKiQwjQHf6dx
10069	payment	1726	1726	2006	1	1	2719	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT5Yh7A1aZkJmqJRcuoe58qfK7tqNE9zZNiScyvhU6vv33WxB6
10070	payment	1726	1726	1874	1	1	2720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtfPX6Vngk3jHaP2rFfnLJJEChf3cbdVYhu65XdMUX3DmaidF
10071	payment	149	149	1037	1	1	1	2993490000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcVg6V5bkdadCgrGmtF5kzXQsg4ZgaseGSgjsWAHJtM3YXqsqs
10072	payment	149	149	1157	1	1	2	2019770000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZBH86jg38Y8D6t8cvNEWABTLP9dgQFwbMMhb3BR23ddS8sod
10073	payment	149	149	917	1	1	3	1670490000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCqkUXAcf18XXDvP5XtC5EbksQ7gTCXMD2ZGcUoPXcWUJE9o5
10074	payment	1397	1397	1678	1	1	5778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sxfwoX2e1u2f7Rc2TxF96MeShhuc46bvcrMB69Q4NPZDRm9U
10075	payment	1719	1719	2007	1	1	4	1102625000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZap2Qg7tKijdiaa7W3pQYzwC4uZy3wkerDp7y7BQw6XBKF4T96
10118	payment	1726	1726	1874	1	1	2736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsognqLBtDDei5S2XqAfH2PW1eC7kf6pRdD5m3789QausSMDuQ
10119	payment	1397	1397	1678	1	1	5791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5sMDiQFSRCwPJizCJzafk4LhZvDDUb48PdAGCiqxLiyDtUoJ
10120	payment	1754	1754	1779	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Bmz3HC4LqPc3KKiLR2p5q5VbjyJWXTb4yv5hVys1ohZMSMa
10121	payment	1397	1397	1678	1	1	5792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MF3P5ufJJWWYELdNs4xEtwAEdzXe5JdZW2g2ASDYKE4isexo
10122	payment	1397	1397	1678	1	1	5793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxJKwcGXgowC7aBtSni9sVYC78xDqPwABMvArYe2QkYWTVRPA
10123	payment	1397	1397	1678	1	1	5794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpBRMi2FK68LoY4h8PTFqcVRRbCw3XGcm7raymC39CzfJdkcY
10124	payment	1726	1726	1874	1	1	2737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGpowTAwZGDYQVECrTn2BiCfBbNVT23sVHkJpwg5trz6D5KYf
10125	payment	1726	1726	1874	1	1	2738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu532VhffzFL1hykWB9xoG7de32KMHxixbeWYcTJManJGMY6RC
10126	payment	1726	1726	1874	1	1	2739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7HTtRL9jnhbKrwDuLDAHAxiTs4h9mr5iZXVpkkJ7KUDY44m6n
10133	payment	1397	1397	1678	1	1	5798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1reESp2MGwfDg45kGyMBL1dawQKvyUsAUQ1cn4z9FSLWiF8EN
10134	payment	1726	1726	1874	1	1	2743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFreReDhqWWqHokK5PkgF4mHnw2ZE51ANnPjBd9aUBwCbCzfM
10143	payment	171	171	1008	1	1	0	1955138409273	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpYQBvzEnbrdPpFBCf8G34ScLKRoGeJigQgGhXyfZu5yoFMYEWRw
10144	payment	1726	1726	1874	1	1	2748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHTFUHzsDPEAVcKLJ6tnMkF9VPVSGqhw2XY7Vr2XzpMSjR3aG
10077	payment	1397	1397	1678	1	1	5779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQEBgNurA3MfwDLTQXUNJjJXGXwX3JoxgCEYsjWpV4XAqGFFX
10078	payment	1726	1726	1874	1	1	2721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcML85zkRT4751aYafVKZDGBBMpUWSBnrFShACXCL5Fxo1rp97
10104	payment	1726	1726	1874	1	1	2731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4o5foGw7ucF8Pv8yLyGc1rCsenFwExCtgqd9bjSRkvnyUnTZ
10105	payment	2008	2008	1713	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGN3T8XUcCqqFeizEjFFnPLgGdPMCX5UhRkjUaSAppY21FWjB
10106	payment	1419	1419	814	1	1	2	19820076647323	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk16bzfa5ayPZTjFp4hapza4Hh2u3ok32YhYWGvHG5s6sRdYmo
10107	payment	1397	1397	1678	1	1	5788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy8gEjJX4a5dHyca16SavHJpGtzFmVcNWoSFNxGmc6wVB7NmT
10114	payment	1762	1762	1181	1	1	1	3254070000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZe3BpLZ8TDLJ4MgRSXdKJgXdJ3UZE7Hxz4pLQRe64yUrdQmEjk
10115	payment	1762	1762	1061	1	1	2	4822850000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZkMgx5oZJwBiVDnDoix6d3qDNnp4cpRcyn4vAt4V7dmBNmGa1x
10116	payment	1762	1762	1307	1	1	3	9067760000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZLzep1Pdn55zmekc4R43w388jxk19RGaBteEw2B5GRLz57Mowk
10117	payment	1726	1726	1874	1	1	2735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg1gQaYaR8mXyNkeAFRwyvwaBZkt6PcKCW58tYnNEkXrhToP7
10127	payment	1397	1397	1678	1	1	5795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLVc8F58JP5GaDJLVp8eXVQf4zNJm3Ff37RgGRbLD71DbkGmd
10128	payment	1726	1726	1874	1	1	2740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc6HxhSzcAjKVSHSshCXpg3Zu8CRTJv11aU3TTzZyyiVJP6er
10135	payment	1726	1726	1874	1	1	2744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47TqJpfvzgXNbaHF689syBDFfa9fM8aQHqeArPm6AtpztaWzv
10136	payment	1397	1397	1678	1	1	5799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr3dKcW21r8WQ9nqCJn6GTvMTuf9gvL3Cd8Re1uC94VY6rhUW
10137	payment	1397	1397	1678	1	1	5800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikrfHH7juKqNKvX8WX9tQD4yDjr8XopqmShvz5pboEaiU7vQ7
10138	payment	1726	1726	1874	1	1	2745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHUakKVeY2VDRLmkuxyJnrc8xaNW6LUpgqAGNM33RWSD5d5C5E
10181	payment	1726	1726	1874	1	1	2755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvduHRDVGFtt8FT2LhgkRmvKWrDK1sLF9mvt2gD2waqHPccDn
10182	payment	1726	1726	1874	1	1	2756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVh9FGkcV6KdwNLnwssc7vQB4VTYUqvkz6mLx3rdxcSAP7dBj
10183	payment	1397	1397	1678	1	1	5810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zRgnoYasL2J5UysZ3GBV71x6wqKnJHNEpKtCwT4YGpSh6yi2
10184	payment	1397	1397	1678	1	1	5811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBZj4MEu4zKnZvJh8cMKCsGZVebNL9Dpjf14spp4EFAJuApwD
10187	payment	1726	1726	1874	1	1	2758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZDQH22cf3M8KKZ7CZX6t5Ntq2PpuoseHvswG1fJAbe4NnBd2
10188	payment	1726	1726	1874	1	1	2759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVjWyfFDvVvnhDEpnBKXU3pNsyrwFxsaLbaKVVEDuwKN4zhTz
10189	payment	1726	1726	2010	1	1	2760	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZb9LMUiNBrjLCRVxNzfpvGtToP8AY8sLB2Rv2hyFvLhnVAvRkV
10190	payment	1397	1397	1678	1	1	5813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mwozgZihxjhqATvUXfKAU1Rgu2SHzUfkyxCcrQFY2cJj34aR
10191	payment	1397	1397	1678	1	1	5814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sVpXZ4TgtxrMvqotUb1yraaKeQqi2PGxhwx33jU12Pdn8qH6
10205	payment	1397	1397	1678	1	1	5821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3dJa9PorokiQpHEk3m8GQHX82T6LfqSUuzJmXM46LXZ4LJRe
10206	payment	1726	1726	1874	1	1	2767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc4fxypzfZNr4HUdmqBb2LgRr3AxhVC4XnJmcfiQsRpXebEcX
10207	payment	1397	1397	1678	1	1	5822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUDkReQFBFKnwMdcbmYuPjzfFH8emazc2BHoHZ6MDwn9QHesf
10208	payment	1726	1726	1874	1	1	2768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGN23P9Lcgu84JYBjfNpuRJNS9vZfwhifhMXQ8QNziajkaFji
10213	payment	1397	1397	1678	1	1	5825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNZXio7TF6uozoJaQ5WcBayPST4ny28NdCi9Ev45q17xHWziZ
10214	payment	1726	1726	1874	1	1	2771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgimEzqMTGVatxrZgYkNYU6GiUAxVhAHdff5rFjtsearjviy9
10220	payment	1726	1726	1874	1	1	2775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMsApRfw7iVfrkoWc6VvFHmt1k7V8VREq5cN2KteS2CuNDZzq
10221	payment	1726	1726	1874	1	1	2776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9mcw9mwgiCYHv86WEJ7kRUU6ta4Xad3Kf3roexfhF926Guu6
10222	payment	1726	1726	1874	1	1	2777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvwYrmaboHPAsQv9pECCVo2xPn8SvpPVusNThEGN9P7Qio249
10223	payment	1397	1397	1678	1	1	5828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDmycSbFXsnT3319zsH8xuU2hAzcFWa9UFSkBBz4sKBWeuriN
10224	payment	1397	1397	1678	1	1	5829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TZVvQyTKgP4HUm9uZ8frJcn8jVgLryvtrUoFxLpi33tcxC1A
10225	payment	1397	1397	1678	1	1	5830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqgjQVARXqnGtMrx6ftrey7Xh1Kxj3LxocyfbAu22AnXFL46R
10243	payment	1397	1397	1678	1	1	5839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcz15BfgorLv2vtoeHj8PNsp9mKrx2vMi9JzTszqwxbbMHjAhs
10093	payment	1726	1726	1874	1	1	2727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkR1WWcZz64AvxgxS239bJVTETx8dk3XfFjY8nHZudNtakrJeu
10094	payment	1419	1419	139	1	1	0	237840350373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHwDJvGD3YPFguJvXo7vbVmwarHE1MTNhMtoYHwirQSm7XSif
10103	payment	1397	1397	1678	1	1	5787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBDxHP5RAkXs3MQwkpcp3EfV2RFAxC1K73uCoCFSrmXibBoYC
10129	payment	1726	1726	1874	1	1	2741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeH3zXGYVkXPeK6anjYChWGucCnHFoSvYbxTkeEaJTZD6Nxo1G
10130	payment	1397	1397	1678	1	1	5796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvCYtLEb3Rrhdhi5QmUUA2YF4npnAUbz6QbKA16j5VQ5FnupJ
10131	payment	1397	1397	1678	1	1	5797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeJdCibnur85ubFyzwtWoNvk9SE3hMPXmBjYSNjmVu6E1Cti3
10132	payment	1726	1726	1874	1	1	2742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56efQu7uvrxyN8zrvD2n4gYTjAQBd8itxogXqL1H5o47zzbji
10139	payment	1726	1726	1874	1	1	2746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVF9ak7juQxp9jZnEeqCNXB8bXC61ijJatNkxMNJ6czd1nJ2E
10140	payment	1397	1397	1678	1	1	5801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxnbaeWXFeEjzEQNp53XWDX5VM2hobxf6bgCP9PVajhQh5WUF
10155	payment	1397	1397	1678	1	1	5804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5jahE2mxtaHNc8tW7ySnD1YhmfhMHYRbC4LNLqsrm979kwbi
10156	payment	1726	1726	1874	1	1	2749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ubTVw882K2RafJwXzfFaXjZYaRfPJGHYw7UxXU2zYr96jNdg
10179	payment	1397	1397	1678	1	1	5809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNbeqJXn4L8fp8wnyoWUW1SyVKkFwkj4wPKvGnPUHRESG1ZUT
10180	payment	1726	1726	1874	1	1	2754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKujvHPrDSrMB5i6KhdG4RsJfoCjP3EcnhFrnJmFNpnGNaQwM
10185	payment	1397	1397	1678	1	1	5812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyYKuFgGZqSyD6pCpgxXaEYt3JVtp561QGoMXCQWqsaqjAhPy
10186	payment	1726	1726	1874	1	1	2757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu7EKo5KFwBksR4TE6LxDW4yrFbxKkYHDmve683baYPM5gzUt
10192	delegation	1871	1871	412	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtnRbwusLbLUc6UtFfoSdNsD4ZBLeB2AVvFumrXmKndcmBRGX
10193	payment	1726	1726	1874	1	1	2761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHQ3avXdsk1G9b8o1KoYzKrtKwGyTRy8SqVw7PtfGfUnWVZfB
10194	payment	1726	1726	1874	1	1	2762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFydj2uQPfWT4dTRvCyirFRCEKfBavWfkioWnRkM2wy8ufEH5
10195	payment	1397	1397	1678	1	1	5815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb1xs1XVgfhbyFzfM7MAqfh8nA5Y8KRYDANg8B5c3UxTbF68q
10196	payment	1726	1726	1874	1	1	2763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Edupa7At3ywmwCxsxhYzMfTxGpt9Z2tZzk1BnvJUFNKdox1t
10197	payment	1397	1397	1678	1	1	5816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgNHYFCB6Hu1JyMzyFipm6pcwrrXjv5f3MQ9AKPCoYrb3Aquz
10198	payment	1397	1397	1678	1	1	5817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE7uHgJaGt2p2Wq4tJqtLTiha9WvPWu3MZhokqd4mLRwVpqrG
10211	payment	1726	1726	1874	1	1	2770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCy5AActR77xB1U2FLKmJSjJuGuvsTgJcDHYnKsMbCK2xFka8U
10212	payment	1397	1397	1678	1	1	5824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzsobK6Z2fHxq68XDRkL138A5Ge1sbkC8jgY86ywJX4FKrmwT
10242	payment	1726	1726	1874	1	1	2786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn6z4ixR8iyrtVCp6x9qQigWCqrtWTP4cToUeLHZCTCkvD9qv
10303	payment	1726	1726	2013	1	1	2813	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYeyYvgcAzqB7JrEJ2ydU9J8XKucuowy8jZmA92aot29BRQMEoo
10304	payment	1397	1397	1678	1	1	5864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aGem9yeduDrWCCxLtPnV13C9PK3GHuU2peotXMx7tenfcWyi
10305	payment	1397	1397	1678	1	1	5865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGF1UFZk5B2BSsfEMRw4TZKSjiQ3g9vXWJ4vKBetUVc1M9hp8
10306	payment	1726	1726	1874	1	1	2814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKgSnHse7MJEjMYi5uqLWVdyu7TYfQHM78AWe8aq1CZD2pr1c
10307	payment	1726	1726	1874	1	1	2815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfJBEg5oz2BTD9BedDmVuE5CZN1tLroVvrMRS1iG4u8a8EhEb
10324	payment	1397	1397	1678	1	1	5872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEUkWmBjpaj23avDV6hJLAn2QKQwSir6z7vkmdAXSwyfd4wNm
10325	payment	1726	1726	1874	1	1	2822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvdSKmzMFGRatG8sQVTEBDgVNtHHgFJj314j5BXSYW19E2iLe
10326	payment	1726	1726	1874	1	1	2823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbzRYdbhCfAe4rPygbUbRM7hWk1DqkGuQudqwKJgcs6UVrMiJ
10327	payment	1397	1397	1678	1	1	5873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWxdCa9MT62tNLcTBVCJYVo1qaTN39mnAAnc61ZhH8VVdaA6D
10367	payment	1397	1397	1678	1	1	5887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3bJLMDiKbbvcyAf2VApMKC1DmDMUJE6ZPYv9svSjyasRaCZE
10096	payment	1607	1607	372	1	1	5	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgN1RUkc2FxdGpRoSS2sKDUmtt9zHBw45Yj7FowpaGQQu3XUF
10097	payment	1397	1397	1678	1	1	5785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4iU1o7mr4SXQaYwAuBGqyR3xnV57U9zVwdMEZ2PzF88Yk7Px
10098	payment	1726	1726	1874	1	1	2728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYna7tNUDReT2ih6njcN5X3bUSpWt5Wx7FuXPUd2Nvzp4spGKe3
10099	payment	1419	1419	813	1	1	1	1801826722240	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRV5sX3DSmTtwpug74ojEthVZqJZMFumTtGUD8UFuZ5ygJgAa6
10100	payment	1726	1726	1874	1	1	2729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnXqLpKRt5ZxnpzGF93grqCPkiRMR1WdXVy9arK7tBCg9LAE8
10101	payment	1397	1397	1678	1	1	5786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfcmCam4JsQ61Ssv8U4uRmGXwQBjsifT4gt6xkaQvCNmXW5mo
10102	payment	1726	1726	2008	1	1	2730	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYh5r3eHt6adomUVY7XPcH7UfngyVtXkaYt2FpLX9qrAPSNu2Uc
10108	payment	1726	1726	1874	1	1	2732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgq3gcsoZCsBn1nUGZm4BNxiHwM6CZDCFLDf6nCoxv6GkSYMN
10109	payment	1762	1762	941	1	1	0	2691750000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpYivBABa3jBL1gLygxcAtsfW6mGtVxbhJRF6wfo8LDqDqCp8ujo
10110	payment	1726	1726	1874	1	1	2733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8t8CkaVZgH9sW6xVMyZr2tVQJxmiizda5NAjwJftSsxL8DW6
10111	payment	1726	1726	1874	1	1	2734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46EvWEwrKukZPqqPsH2k44RzxBUF4UCoRTRedpLLsbDEVHjmb
10112	payment	1397	1397	1678	1	1	5789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYb5PJqJcZvtvzQGmuRurgXTQvcFPXHS7Y3bNrCnXzzAqjfnwp
10113	payment	1397	1397	1678	1	1	5790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmWeu9MhUF1Xv1js2A3C3W93PjTMJrmQPtTvPpUYXek42tV6o
10141	payment	1397	1397	1678	1	1	5802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRrf8kq4SRVR1NNNZJGPX9Dsr8cLDmaKEZxanE9hJ5BsNZDHf
10142	payment	1726	1726	1874	1	1	2747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxe9mMRVLhbSYVrXx2J7GPuj8EYQB7jduMVz9EoeiudJTAnLB
10157	payment	1726	1726	1874	1	1	2750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRteFX8CQN5Gm33femZvozxr7qTiZXkwEC2pg3n5wGPdSbK5NR
10158	payment	1397	1397	1678	1	1	5805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFM6V9GVsnvVzb58tSHYf9kGPE3oFrK3HfoXHUFL1m1kQwNTa
10159	payment	1397	1397	1678	1	1	5806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZpjeQdwCVKUi1sskmSykDqusDBzhYa7WhC2i6BGt2qTPM48S
10160	payment	1726	1726	1874	1	1	2751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiDjpSYVv1QyY6zY5Hi58WKWpjtjSDyZ8fPzZUo9RqAAG18Gi
10199	payment	1397	1397	1678	1	1	5818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSHtgTix8DAzevtDaHHFwPPL721md8v9sBHPrZag86JVGbXYsH
10200	payment	1397	1397	1678	1	1	5819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNK48uJxjJ8G1zFXBz7Lieyox6EArsUjtUD64w19WXXuR1sWC
10201	payment	1726	1726	1874	1	1	2764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJi1YJq7Bgx4r1xd3PYQeCAQqkcF8zx3omssZQoUt4osxhAuoj
10202	payment	1726	1726	1874	1	1	2765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21jtPmpk2FHzgoSoJjGCRugAaiDKYP4DQXv6z5rxz8UCQvEXS
10217	payment	1726	1726	1874	1	1	2773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCUE4SQKm5vyFyt22Gtr9d1swWiLnN96m4WHVuQJyWnYL6b6h
10218	payment	1397	1397	1678	1	1	5827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7sCaQgwms1v4Z5jzB8rt6Yhw51fozTBmVmCkmxLeQFNnsMeg
10219	payment	1726	1726	2010	1	1	2774	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLDTjkDEcHgTsHgJAMVRnzxEGt74jrRiK4ifHtuQZxH1M1umbq
10226	payment	1726	1726	1874	1	1	2778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwhZJS5TfcppRVuXxju9Reu6k7FwBTVDcrSoZjZhX4GtcyNCTf
10227	payment	1397	1397	1678	1	1	5831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzQfdMTxd2j59V36JiJFcj6dNiENE5w8hxK4MucdvohVChz2z
10258	payment	1726	1726	1874	1	1	2794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX2TqqgKeDrZCX5CfTxfJJbKSwu8yAKYP4Wm4iyhDeJ6rrumD
10259	payment	1397	1397	1678	1	1	5846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPP8T8P2hJ7XwowbaeWPmzZodMPG9u1xTz6KMeqj65GjUxB21
10281	payment	1448	1448	741	1	1	0	18666003811	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQvfZJsZ88VW5veJDzdNmbRyhPoJnVDzYUf6QDChJGQzbVzRK
10282	payment	1448	1448	730	1	1	1	18666003811	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpmR8wmkcE4TdmoDoAHSeVeKgHfKZn8rbmL1jcN5w2F12q3bA
10283	payment	1448	1448	449	1	1	2	246391250309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BuvbrS7nATh8abAFoRvVexh8CbebpPbGfaeNPzEVunBUs7gp
10284	payment	1448	1448	489	1	1	3	246391250309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXzfj1rEaFvR6T8nLXfioqaQYurjnrLzfmuuNrX98EAovLEUd
10285	payment	1448	1448	945	1	1	4	1876970391541	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLus8HQDJ4LGCAo5yg2agbvGsrGF8fuSpeVkHGZgFqheg8VrJ
10286	payment	1448	1448	1065	1	1	5	3363514807644	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5Q4MvxXZ5isnFE6X4R2s3pzwUdab3G99MM9nTo2ojGoRzoe
10287	payment	1448	1448	1185	1	1	6	2269430476079	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJCTvwtu8ERv8XD1ZCEo6SRPeQNY719GdH4NSWrbq5GzdeVN8
10288	payment	1397	1397	1678	1	1	5857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGEaSAs8mXPHJchpkraxzfff3VrygFGdc2vDt1HULKQd4DGUs
10145	payment	1397	1397	1678	1	1	5803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1asoiLcoaGZQXfsd7e9tDSWT5nGPA78prU2TfcUq4h49jUG1u
10146	payment	171	171	1128	1	1	1	3503591277789	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpZrTer2AR22XpNVTAAX8WdBz5yjrwNhytCw8psqawess2Qx5iLW
10147	payment	1705	1705	148	1	1	2	155970757207	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZsZoPUVhZJW9tgJ8qfsy9iYoBanWXNj9msMKa1a4K4EvPzAp2h
10148	payment	171	171	1248	1	1	2	2363942849109	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpZyHAThvi6rddSqQsXAWWCBW14hGXu9EfEXZwtoo8GoL2ZN7X5Q
10149	payment	1705	1705	714	1	1	3	4726386573	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZyz9zSPMXAT7rdoHQ4U1DE2zH1WyGCw766NdLDuLdHPXk4dBGj
10150	payment	1705	1705	994	1	1	4	1184719255265	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZFLyh2MabHPuyBfT3duozumhwxdFUZ21WmQXFYP7s5tCDGBtqG
10151	payment	1705	1705	1114	1	1	5	2123006754765	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ3mpTN7EwPPVo9hu4AfWimC988shthLQbtfFpCXfwQw7LDxsZX
10152	payment	1705	1705	1234	1	1	6	1432434961334	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpaCFrAUn1uxfZXGYAhvJMXCWtxR4K1kBM9VMoR9aGb32wweFEpK
10153	payment	1705	1705	1360	1	1	7	3991607384791	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ8Dyo5MAtAt8w3GxzXMBtpBHkGWFTM4g6eAzDnC1oQsttkW6k3
10154	payment	171	171	1374	1	1	3	6587336939141	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpaCbaQpsj8NXJ3ScovPfJXiKnJmHkpXZmm7HMjMrQtrGpWovvru
10161	payment	1397	1397	1678	1	1	5807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAW8PTNrwQDGaM3td7gRPwPKN6gmqHSKBGcFpudioiuLxN7Pf
10162	payment	1726	1726	1874	1	1	2752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uaGonjr5gT2HpzgKsoXe5wn8g3qcnGtWZWeWUYBDMwD1op7E
10163	payment	1560	1560	135	1	1	1	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZAkAvUdMk3kTTzyrFyJdiSfibEw9t68qsKoM6zenPuKHvFpe6a
10164	payment	1560	1560	170	1	1	2	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaCPAaiCkBNGSqvyJezWjeHA9W9SpNEdtgvn6vUHQQKpsZaWfk3
10165	payment	1560	1560	202	1	1	3	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ2eJWB6c4P1dXqL4rGhZFcQKzQCY8XrcuWVPEoyXT2TyaENj8q
10166	payment	1560	1560	264	1	1	4	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZnGWEUEAq6xJZvqtu7b4SxDJdAgWwAJWEpdaKJjD9Fznkk5CPz
10167	payment	1560	1560	279	1	1	5	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZxykwJirN3jLSkUUgQZx1bhY6PSWGpFbzcVU2bcWxaYjLdVdiQ
10168	payment	1560	1560	331	1	1	6	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYXyYxy6yxMAEtWJaAJD68JAdNKMh4kLutMZribw2iUQZq2hcEN
10169	payment	1560	1560	382	1	1	7	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYaH6N471FjpuNShDv7bXgHUbHJn46yMSyfmAeP31Vq2zytxqVA
10170	payment	1560	1560	388	1	1	8	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYaikdpkKLV2uHqcVi6ntHAtjcfa2WwVqf1FQqPuWJjg95461sa
10171	payment	1560	1560	400	1	1	9	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYnWG3AdseJW7poPBcaukqZvSWMUucmLznyjqAzzVnxcXAkQGcv
10172	payment	1560	1560	505	1	1	10	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYbdG5ieniyif9WYFBQCnLeQ1L9JaMnPeBfPQBkNEj5bQCVJhHd
10173	payment	1560	1560	925	1	1	11	3387295182596	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZARSnRt7As1ALRYDMqwuZcneeAp9gK1E4CFmBBKQu7WAqXHh4s
10174	payment	1560	1560	1045	1	1	12	6070003944920	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ2J7Tkc5SnPxHaKPuttzYp4KtPQfbKNHCA4vF37LN3rTh1TXGU
10175	payment	1560	1560	1165	1	1	13	4095552614993	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaBGP1zdY7QsdbZRosfbADzpPGCMtfyFrsnfuCXKSBDZoHjBMkq
10176	payment	1560	1560	1291	1	1	14	11412621517949	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYoQ8MDmfVNYrZbcdX7Zpx8aQPg5oG6tDP9H9r87kGYkFy5kv6p
10177	payment	1397	1397	1678	1	1	5808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXMCuXBAmQ4bqMRDzy9XDuotUL1dhgHwCghBv2cRQs8UPGTYP
10178	payment	1726	1726	1874	1	1	2753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAJ5Xd4G2NFtRZmcSbcNjmYGByKYPeG1B8wP2FwCLqCG96sNF
10203	payment	1726	1726	1874	1	1	2766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVhTTXmrKN8u8apJrFoJC3Kjk9XTdo3DdL9yrgjM32zDpuRdQ
10204	payment	1397	1397	1678	1	1	5820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6nYrJdGWe5HP88JKaZUsVpSid7DCN9jzYrjh8u6XJ2xx2pdEn
10209	payment	1726	1726	1874	1	1	2769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycF7pjJ4WozdAKgj9UGEhjGp5jx6u8sxScQ4HFLvF98tJ6jNz
10210	payment	1397	1397	1678	1	1	5823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6g8giwJPw5n2YyXC6M7nBthUwYJYQhhVK3htzR8reWy91zsTq
10215	payment	1397	1397	1678	1	1	5826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGTQjtpdJDWujsydLNEgF6Szmn6anMW2RySmVLggJX82btAso
10216	payment	1726	1726	1874	1	1	2772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQBPBZ3jCKCZxAd2uSDeqndfvPqQwbJYdyzc3DAirSJRB1XCt
10228	payment	1397	1397	1678	1	1	5832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPxw8kwrf1JgHQ8a1nkGBd1GCDFNVjwgKAMbg5H1Cv436uqq7
10229	payment	1726	1726	1874	1	1	2779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAQk6hDWx3b8S2hGDzd3dxQtRjHePFU9PbVUeFEXDo1AjjpzU
10230	payment	1726	1726	1874	1	1	2780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAV4wsBaFVaPEWbKnHJzD1aHSY8MC8Hi3y9VH5ga927nAuPvE
10231	payment	1397	1397	1678	1	1	5833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpeCcsB2b5EoBkbJqEgZ8D3zJAMo4FyZMQcarjVU86DCgKpWG
10232	payment	1397	1397	1678	1	1	5834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJGzNXQKBbTMg9WMRAc1w1mgXwbUZsceGfeKh6QY4ANxQR6ee
10233	payment	1726	1726	1874	1	1	2781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvErqq4cAzh9JeQ13vC3NbD7EEyxvqMtoSujK6hAQGNqXAHKrQ
10234	payment	1726	1726	1874	1	1	2782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHrDXDZoYUjZFbAEcCTBLFVdTZZpZhNLytqKjvMSnHEjTbrS7
10235	payment	1726	1726	1874	1	1	2783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FHmwC4d1C5nDT1U8SYgGxcePQMG7yhqAfuQeWdfSuzL2Hemb
10236	payment	1726	1726	1874	1	1	2784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYbDY9cSUNz6pfhrQokF567MuSjEjKEGcyFaT6MKrr9yxER6w
10237	payment	1397	1397	1678	1	1	5835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyGGQQq3R4JTLdjycC3e8nQFQRFkrBwYAsYYD1Z1Zy3FskbGb
10238	payment	1397	1397	1678	1	1	5836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1XjRnp5kKz7otpCKGbhQekFRGG5mHt2JaQccFqtY5tfxwQ31
10239	payment	1397	1397	1678	1	1	5837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92QRZrZroFDX2Vd6QdgJ511YNRD8mbmjiAqdH632mFW4otqb1
10240	payment	1726	1726	1874	1	1	2785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtiFNJbYgwvyETFnJkSnjsSMg1TQFaHsaop4TgaAF7Db3rJbF
10241	payment	1397	1397	1678	1	1	5838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaLf4HqS1tzNpF7PLZ7YLQBYaBFGxL9z6dmAHhffZe3jnQKMD
10253	payment	1455	1455	2011	1	1	0	900000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUk5t9xC6tQVsFGqvuViaoEyyxCbQsE5H9ArhgpAySctf6aGUb
10254	payment	1397	1397	1678	1	1	5844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvcs4DYoyC5QExPgHRoDdeau2Lv9PSkAhCgP1kpSi4fjpLC2K
10255	payment	1726	1726	1874	1	1	2792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfdKjCjAaj3LP9VyYgLCoXrZWB48WTGotcXsRm9A8pSDvAiLz
10256	payment	1397	1397	1678	1	1	5845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWbeDabYXQeiLMZZamT6Mu2AfxH787iUhU7JCn3GcMG513Lhf
10257	payment	1726	1726	1874	1	1	2793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCK9E1sEUGjbBGEmkgS9Tg4zkz8oT53qRpQehXyYhws8CEZC9
10260	payment	1397	1397	1678	1	1	5847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNHgx1bPL5BtcxVfUKaQWXCpBMsbznjvqdHnTbzkLhXxSFRJJ
10261	payment	1397	1397	1678	1	1	5848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhTukVzoLFebBQDbEXRz6i8XfjHikEuHvbsZrKXzvWyYCF4Wq
10262	payment	1726	1726	1874	1	1	2795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAv16qLDiPJgcM7debBGskb8kS4RnAStwSvUC253tA23R5wPe
10263	payment	1726	1726	1874	1	1	2796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUr5ELdZqHenqTxqJBgbWe6AATvN6qGxDvsfeEVXErgFsLzwF
10264	payment	1397	1397	1678	1	1	5849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcDLoMm6VYHKWbEVotB9P2wwEz3jxY4rModC86zeiZaxgN841
10265	payment	1726	1726	1874	1	1	2797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHrz6E3HgrSJbsLwBkTJkdAotVEQQi9ek8jvRThT2grJ2dtrw
10266	payment	1726	1726	1874	1	1	2798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdXqE42td9fhsxkXNg4GryUUzN7sFbHcTxrW6G8y7t8XpejoD
10267	payment	1726	1726	1874	1	1	2799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHviYWKhCcYmdDty5KFCtc9rbKn13YqvtWhi7Vv6NHh8f3UF8w
10268	payment	1726	1726	1874	1	1	2800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbAWP6jvG8ZxcQcr4YL2QJLuZ4UVzCEoX48F2djwKxDEnafJU
10269	payment	1397	1397	1678	1	1	5850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMPcc6FdTKgR4UzSCo3wDPRaZhMGhZUkW3YiBi7vGshaNtoXe
10270	payment	1397	1397	1678	1	1	5851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NdYtBe66CtsZ3syrck7tcJZSL3gZDF3vfTKQtARNQEF3DoLD
10271	payment	1397	1397	1678	1	1	5852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozYFQWr7vi1waJYGC52ykAafnAkBFCqe3JRsGeP23z6zWphYB
10272	payment	1397	1397	1678	1	1	5853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKMaboTcEgRHhgXVWvnasQrMR3zBuns8CjtogZDaZPXpwB9zS
10273	payment	1726	1726	1874	1	1	2801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnvpZHYxHQKv8f4Uk8q8DNdbpktpoprj9pbpBxNJveJ4AqSdi
10274	payment	1726	1726	2012	1	1	2802	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6SztLLMKwghc2f9dap6L1HFAH5Q3CRqxhfz9vWazT7S428dMT
10275	payment	1726	1726	1874	1	1	2803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueZM63Pt13sbDrMB5PnL51y9Una3ZVDca5pHU1q81ZzBC8wWX
10276	payment	1726	1726	1874	1	1	2804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wXtAtFeRB7oKaPD9ZTZkxxA1tLyTRALmPnAfHSfJEgUYbt7V
10277	payment	1726	1726	1874	1	1	2805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BRxUyX4JK5W4W4FB2HNFB8jEj1KSo5URMSW5bXCm11FoD3M4
10278	payment	1397	1397	1678	1	1	5854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKKSBTYtbi8ymr6nUJQVokF4zzCKKmtLrsba3acSsL5bN44HR
10279	payment	1397	1397	1678	1	1	5855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9jMe4TUZaQSEkhy2ZMXiNoK1b5k9JRVYTfnu2jmX9NCek5S3
10280	payment	1397	1397	1678	1	1	5856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPNHbLQKXzQsGYzuZMgZ7WHHo3ozKRk4qUZ9AiiM4jnfXtL3Y
10301	payment	1397	1397	1678	1	1	5863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5c1nbYgWyLbHQE2Y9qmNZQg43ApPss6HUqSr9FQeeLae1qH4
10302	payment	1726	1726	1874	1	1	2812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxg1bC5JWrzDRrmVtiRs5vWTsEDDvHDGQSzMGpDoQFKr9tpaiv
10244	payment	1397	1397	1678	1	1	5840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbzA5Ye8r4Z9EQYjdEwk98p9Nm5aonEpU54TvZGqoEjrdgknb
10245	payment	1726	1726	1874	1	1	2787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFCJKnTWkKjqtDz9UKzPwPJkgezsy2MhM76Wc8nJLdqG6dtrK
10246	payment	1726	1726	1874	1	1	2788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sEC9iULeT679dQwo2vfECDZsz8qkMyU62sS8pHhu8Fi8d3nY
10247	payment	1397	1397	1678	1	1	5841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUd7e3CVuNZVq7LTWyeARKs6PVQjcT8RexUVDhCzfNJTMFRQ8N
10248	payment	1397	1397	1678	1	1	5842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbhhSSjdRS6zNNcMVYw5ZqvwmyzVvShbC4dNjRPvsioEbjCEe
10249	payment	1397	1397	1678	1	1	5843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWcnXb2sES63DGiU4E3td8ienLhfi8gkG3DoKboTejjhvxeyT
10250	payment	1726	1726	1874	1	1	2789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZWVh2KRNC6ew6DjcPjZWcVxbMfDvbGPxWnfpA8bJhjPBABcW
10251	payment	1726	1726	1874	1	1	2790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkF1uf85eFCHrWmWBZqxfxQiauNZBujsniNGUbpmMwwguXMsLz
10252	payment	1726	1726	1874	1	1	2791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifavvq7saybGVahDTSdozzcrD7c8VpcspGV9vHcjDiXQkjeVz
10299	payment	1397	1397	1678	1	1	5862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCRb1CWfjrE1t2w8Wry9rzfreyRVzUv76cMDYg5ze2ixsCCNC
10300	payment	1726	1726	1874	1	1	2811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzdQxpvWynwEnyJcFpi4wKZeG7WzzUqsSCRTjzEaZVA43zuba
10308	payment	1397	1397	1678	1	1	5866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfr7NavAGYpMcP1MGL7bBXZPBejKn5EoYhyY4bQhoVcJSmNwVe
10309	payment	1397	1397	1678	1	1	5867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLM7AzzoQywdgP5WetAqPirJusdMJfjU1C3x9eGaHuHdpzHe9K
10310	payment	1726	1726	1874	1	1	2816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVcUVwHP3vT69dnY6kLSDWLHwSUo77NrmDN5orBW4kz93pfy7
10311	payment	1726	1726	1874	1	1	2817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdL1bWq4JBZnRYth3gHj2HyiH2QYuXuJ1maaZcGwmzVSjSX82T
10322	payment	1397	1397	1678	1	1	5871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcNriq2FNF3m6BjKGpnoyhcutFCQwAuD3hWKucQufzuLJPC3u
10323	payment	1726	1726	1874	1	1	2821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2t8GRHBjZLRZzeA6nAuwRnfrqhDK2t9UrWJHgTwE5KwhUQRRe
10332	payment	1726	1726	1874	1	1	2826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9Qfh2xUj54x54zTywbL2oNiTL2sZDJSsGTKTLZpfM82gzegj
10333	payment	1397	1397	1678	1	1	5876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXt92aoQ6Cd1CRc6aTEWAJMyzH7pxcx9gp8Ueehc6rknpCdP5
10334	payment	1397	1397	1678	1	1	5877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYFDsGo2EtwT5PtmjDy9mmWT1zftsiu8cbB3x7vjGrV2caGyh
10335	payment	1726	1726	1874	1	1	2827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo94tMxDcDV3h75d1fFvmgSXy2zbcY7uxcov1z1uf5XUcQDAq
10336	payment	1724	1724	937	1	1	3	2644138800000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpaBsvCPNoZPyHpzuwD3U3vcG9dFnMKYejPTdSMJpk5H3fXjmgZ8
10337	payment	1547	1547	683	1	1	0	1000000000	100000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa3LZank5atPU1qD9vJVsq4wKdDHo3FX6HmfCNFACYRjeiD5QVh
10338	payment	1397	1397	1678	1	1	5878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzgYmqYeAabvsedsf9m7Ak2i4nCtb5E86hyqXLyQ3nRwHKLxf
10339	payment	1397	1397	1678	1	1	5879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JeBueXm2Dh7U4aLF5irfYasDrrKFcjTgq8apKjPJDEUSNX4N
10340	payment	1397	1397	1678	1	1	5880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbnKSoMTL5L6d1Jx4r8r7Dv7TrhTnARZ47rq9rAqGWZSxVvb8
10341	payment	1596	1596	1932	1	1	10	588869152658	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQTQqv77GntcFzt7kfswtGv6E3LeQ7XeZStWBpQKvxLEW7SMu
10342	payment	1726	1726	1874	1	1	2828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFCbxo3zQjjEPsPk139AD7MzT4Sq7gcxSmtvZ3WA6FeqLhwmB
10343	payment	1726	1726	1874	1	1	2829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuejn9hYrrtZYyv3FmcGmHpgCULR1B9DGY7nc2qZAgTsPD6wvu
10344	payment	1726	1726	1874	1	1	2830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYKFfLiKc6tCfEsAao69Bnsjpd4MY1cg2hHrVaeYmvoZv7WP9
10289	payment	1397	1397	1678	1	1	5858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD3QobZU8Lo6oDxF72P9jwMGkaZm1bYAkodQwNPCnrYWh2SDe
10290	payment	1397	1397	1678	1	1	5859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHfBkFUBP2K7XS1AU7QgGXoK4PQK8hfY3kvfVpeRn9Bv3LnoM
10291	payment	1726	1726	1874	1	1	2806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnemMM14GtUPTCPjLpd8fcnprRTsvTq5tFS1NiMBLj9dBufH5s
10292	payment	1448	1448	1311	1	1	7	6323969816495	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeezbS4MZwgEzPyneWc9tmA9dA8U9GUCNLVNMi7LS5XzbxPKo
10293	payment	1397	1397	1678	1	1	5860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvrN2vzH7XP9LHbu7gfSBnS3uauzgbLJG3szc8MhLeGpSt5Yq
10294	payment	1397	1397	1678	1	1	5861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij2VAaJr759gJmqq7UqTaeSwzvh7D4QYFC2Cc6n6kSciAq335
10295	payment	1726	1726	1874	1	1	2807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnQ54owbYFy8NnT7LTPePvCSY1ZxNS1kEhCrv4tKP54Eedb9w
10296	payment	1726	1726	1874	1	1	2808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4VwW3obbk6eEMcDybc8UkuArvShap35CUiHfT4J3XPfysD4q
10297	payment	1726	1726	1874	1	1	2809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJiSub4ArUueHx8M5JJvLRmVgjXDF4X33bo3vBPitS1cNAmvx
10298	payment	1726	1726	1874	1	1	2810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLN56XmCy9yRQwhop3wSnpDoqTHemUp5H5MNfqm13hjM6oBhqB
10312	payment	1726	1726	1874	1	1	2818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjXPsLybsNbreuQWipCzjpv6FGGAPgfmGtgtQtUgAEPimmf5t
10313	payment	1397	1397	1678	1	1	5868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfYU2s1MwPfnDNEQNTFPNkFXbbddMwjHjwiuA4kuyUnPaW3Ph
10314	payment	1455	1455	966	1	1	1	2413000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrxBd4GQn1C347eLVtL3BsLZuDSS4rMYabxMv9wATRFw7xSmX
10315	payment	1455	1455	1086	1	1	2	4325000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJnigbE5JS8MpvtjHgr3mTWDZG47dzkDvpQGZUgCtTsKq1fn
10316	payment	1455	1455	1206	1	1	3	2918000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQT2UrADN2Qycwk7gNav5Y7vdJy8HHw6qwngCMcK9ektocJje
10317	payment	1455	1455	1332	1	1	4	8130000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmBNa35vEY7A4Weu4MnzwaQwv29TqkJk6VsJqVhx7ep3qD6eG
10318	payment	1726	1726	1874	1	1	2819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKH9WSrHAsm6CksDvU1LQKEwgMn1WQmVEi76tvFRPTbyeyNjJx
10319	payment	1726	1726	1874	1	1	2820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsArecyPXMeNpkPYatAdc8KfynTh2RJHdd3Ttd1WyWQJzYxoAi
10320	payment	1397	1397	1678	1	1	5869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tY2fV94CWS62f81gGQ2pQseDpesQwyJukGakmz2GkqDc2RXv
10321	payment	1397	1397	1678	1	1	5870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemgEW8x8URYZUUeBUPErwNSivcMjBLJT4zzXjWYXwpTE3huvn
10328	payment	1726	1726	1874	1	1	2824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH5nq4QjK5gto598LC1PJcxUpP5QjRzc9QZiCcAtMtNzev24V
10329	payment	1397	1397	1678	1	1	5874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ29yxUCcMC6igTso1LRYSqTF2yZAB9mhKwLMCPf4AY6m412Ej
10330	payment	1726	1726	1874	1	1	2825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuWkGEsoZGwvc5QCLcSWYtP8KFSqm6zWH1GUpMRj3jeoHyqyF
10331	payment	1397	1397	1678	1	1	5875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Znrbg8AMzzpyg96JeHviy8JeB47W4Svr8JwJ3YmHLyRuDHxm
10352	payment	1397	1397	1678	1	1	5884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYG3qq6XjzzrxkbeNaBgiGrHAxZhvNu5EpdiHPHXaUfvKkDLVf
10353	payment	1726	1726	1874	1	1	2834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtuLyfH6PRghZnzoS8yqimTUZ7wPRFFBHHQkYZEoWaMxGVuzF
10365	payment	1726	1726	1874	1	1	2837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5B8bqHEGAEDF72asfQAxK1hzdtnhXKrvjyUeKbWfSm1sFdcC
10366	payment	1693	1693	344	1	1	562	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZERerWSqokTQw3MiLyBxSs2PsFFXncQRtqeCcdVttRSty1o1Fp
10345	payment	1547	1547	1012	1	1	1	1459000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa5x9WkQAkHQKTVmZewVQ8zqHmhuhmdqYsztQkNngAFoCM8N81K
10346	payment	1726	1726	1874	1	1	2831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLW9uVUwQHjeyexfA7mRwrshqSn4C4sjmYPJFVPYfk4uyk8Zr
10347	payment	1726	1726	1874	1	1	2832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJgddPFtKF9EX5KDSM843tTmEuDKij7d1iFASxfhpukgk5h8m
10348	payment	1397	1397	1678	1	1	5881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qmQZ5YRSe8TJqGUYdW1UKvs9KFkJDYYFqNFcVSyHphZwb1PE
10349	payment	1397	1397	1678	1	1	5882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdaPEZWXcp4kM97tfJNaZUJHLJXBmDWNFsi42zjQ9KjpqdK8D
10350	payment	1397	1397	1678	1	1	5883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn479pvQiEXCwFocSbB96xg3XsZGD8vDwXtKirpcTJxXyQsr83
10351	payment	1726	1726	1874	1	1	2833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPZFCoYMw6uvZs94QoVEckFpPrTxLyjhKYPucLBv3r2FpK8RW
10354	payment	1547	1547	1252	1	1	2	1765000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYxXeb6qsjPYBEegxaVebtBsuUqSw78DuzueXezKUVUAPKodKR8
10355	payment	1397	1397	1678	1	1	5885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkgnnnUjPnYK9Fc2w6Lny1iduoPgNyFFrtjgkDhLm9DbET2Hq
10356	payment	1397	1397	1678	1	1	5886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1m2thp6S9kZtwt8mQ5oxmDp5widfxP9VfCqE9v36CBBNajq7
10357	payment	1705	1705	148	1	1	8	191684554121	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	Ckpa8yBZ3V2fviHVvV1LRqA6VocVbix2Ed61CNDdfmZ1pdokzKvNN
10358	payment	1705	1705	714	1	1	9	5808622839	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYkPAfKyq4uV2RmLLy8THrft9sg6nfiRZsKxvwQRPbwMisTzxPV
10359	payment	1705	1705	994	1	1	10	1458116006480	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYXQnXFWouS29YogDPLBkoouRNi1P82AptfaaGsM9FqhVkN7cvF
10360	payment	1705	1705	1114	1	1	11	2612931390480	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZcgzzCY1tJmhHbn3tHTvMkwhbaxduuovBEfChiGyC5z34mFCVm
10361	payment	1705	1705	1234	1	1	12	1762996875488	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYcVmsaRGk5sHxm9vXhrJQaCyiJ6N35SHwuNo5W9h75ZtyD7aW3
10362	payment	1705	1705	1360	1	1	13	4912747550512	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ7mnLF8mQw6Ayq1szZ1p2rE1pjGAz8wY3Ms4n2cXxRVzm9momu
10363	payment	1726	1726	1874	1	1	2835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4pwZixR1f7ckzCpx5CTsxmZ4v5dWvJCZLWZ5Xj4TDiZwR88M
10364	payment	1726	1726	1874	1	1	2836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRyBmfSfV3Nvtk963eCWkRb9ssA36nShzj2ZdetVwxmJLwMDX
10368	payment	1397	1397	1678	1	1	5888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrh78oY9SxRHHaELLeuNiXShZny4KTT6bNsR3SpdSjxNmZSfG
10369	payment	1724	1724	1177	1	1	4	3197563200000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZNxdMjFhMaR4gSeatEBdmCYvbjcBpJchmQSgVia9JozngUkXpm
10370	payment	1724	1724	1057	1	1	5	4738820400000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZcmw12ir7rkqEZJhtuVVTxUnTig1vxNL3Xjeq1jLkHP2FJqEwK
10371	payment	1726	1726	1874	1	1	2838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCx64EBmuF11cNsM3n6dSEW6kfLR3QbRMRdBv6SXNuks2xx9Z
10372	payment	1547	1547	1132	1	1	3	2615000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYRSYu75hmVpEwzNs5pJsPAZYWnrLs9Qpe7SHZPB4KTZS9MTho5
10373	payment	1397	1397	1678	1	1	5889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaaZdMHd5sohZB2X5FjwkMxFrC99trE2VAcTxnwSpuogrsKNH
10374	payment	1726	1726	1874	1	1	2839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfXuNWxWJ3kjrGoSDxVeZQVmM4iSHonrCLpADmEu2pSwatxqc
10375	delegation	344	344	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6iWJEkhiYD4u9N1zQGe52kDpf1tpraKkWoBC2sY1Tyvv16yZ
10376	payment	1397	1397	1678	1	1	5890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkNGSKwvtYAK43VEnP9iL1HmVvLEd7gdZuxksdtKkQiSqGUfj
10377	payment	1726	1726	1874	1	1	2840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNNF2kMibLSii3nszKr7RsJtZw1UpGav6QCcaTJmFRi2icFgc
10378	payment	1547	1547	1378	1	1	4	4916000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZuBGaVJKJTFFrxFQNiD8zBbArQnNRwD28BFa3KVPxgXDd3PM9B
10379	payment	1726	1726	1874	1	1	2841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77mZyirqSdbJrGcbdg2BDzAyQyNEVRNNGKauLQA5TykTjPorK
10380	payment	1726	1726	1874	1	1	2842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42owJhGvHRQrERZ33CqCSJQdLreA3K3H4abJSLdprhNuc6GCz
10381	payment	1397	1397	1678	1	1	5891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EHwrr5SY2HCZVzUeT5bauQX6f4NmYnmBmX7LgTrSi3G67N1J
10382	payment	1397	1397	1678	1	1	5892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EYd9Uc1MJVy4N6TWJqs7YeyvZJNWDxuKzbTZjMPcevLDy7pL
10383	payment	1726	1726	1874	1	1	2843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVPHgVVVjH7m5ri6s2vFTvZpmEDgZjv241ibQ1LHz6rnK8s63
10384	payment	1397	1397	1678	1	1	5893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7syD2mW3RnrTXSRpCJjexJLDN4BNRxkvr2vEeRBps7NNNs2j
10385	payment	1547	1547	683	1	1	5	191000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZdoP7i59dvNiNp5RqycWucTYRJ7BkKju6xtWecsfCaeawK4VF3
10386	payment	1726	1726	1874	1	1	2844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG6BAthZ52SrupqhUDimMM32GrjmgvtZsHPUsL5K7FQYSijhx
10387	payment	1726	1726	1874	1	1	2845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodMW1Tt5YPxjPgH22meDDKAYviNJPiAJbYZbFVwLDeEV84io1
10388	payment	1397	1397	1678	1	1	5894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTQn12NNtd6LxrXxby8xdGG95nCvpszykFSwdN4sarcGDWzrk
10389	payment	1726	1726	1874	1	1	2846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd21G3AYvrL3wgmZ7YJSwvnG4ZSe4FyA5Mfwze4Hmg6Hu4VHd
10390	payment	1397	1397	1678	1	1	5895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjenZyZcCP66tUrM9Hypziw2qZ2g1XEUjZuc6yijkTN8W5MYqc
10391	payment	1397	1397	1678	1	1	5896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsKgXduo5ecazW8yxRPxo992fmLLqsfPkQmVwnaC4SMu9Li9D
10392	payment	1726	1726	1874	1	1	2847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoHB1scvKdDT5JHqrY16vY7WLWppmA4tHtqU2GxateowhaYyE
10393	payment	1726	1726	2014	1	1	2848	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnTHNSBMa4aGCqZzMoRkumX2i6uG5rsyCZ2G5L9y4AqTrMEjNK
10394	payment	1397	1397	1678	1	1	5897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YSBF8pRpCto6pSXTsyQBNQJcGtRn9f2jUHe2uvNjt131rt38
10406	payment	1724	1724	1303	1	1	6	8908347600000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	Ckpa7hgaXhTfjiXWtj5JPWb6wppqNMVB6SYKNrWzXTfYoD7tCB1WE
10409	payment	1726	1726	1874	1	1	2855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsB79qcVvu9pc88HBsvH46Qzz3XYXhEWS6kWb59kpciZbj63CQ
10410	payment	1673	1673	100	1	1	1	337270000000	10000000	\N	E4Z2WL7Rj8NjhXTuGVLvWa26s2mRNhvDL133eXGrheXSwEo2NLT29	CkpZ9khkCAijBcERjVJxMDH9UbTn9M1eqp6cMcYKi1kMyKpNELXDb
10411	payment	1397	1397	1678	1	1	5904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeuVkLD8DXcD97VVKY3BXffyLMQ7swCYxYWg13yZGBLZQLTcP
10412	payment	1422	1422	1422	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJavjcgasEbGjVF5vquhFuZQqsC4etH1U6KengJ8ZZ4PeK21pJ
10413	payment	1726	1726	1874	1	1	2856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFeMoGcL7hDj2wV5ZT1mEk968Ux9Gy2n5sJtdiARDSf315WMk
10414	payment	1397	1397	1678	1	1	5905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWG3ZN6rrWkMgdKPhAd2ZKJ2tfjKb9FgQ3AyR5WhYD4cNexVv
10415	payment	1422	1422	1422	1	1	1	0	1000000	\N	E4ZABcF9yybQPURw55T5ad63TjCFSJtoBJWKNQFghvYi1vKf1XtKd	CkpZmyt3vLriMiVzdEL6zYej1sn8nGQ11pv3B84SfmeNR6n1baVPJ
10449	payment	1714	1714	934	1	1	2	2906467622784	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZgBbLHnLkg8R2vQ8msKw4nNkmby5ZCRBcqi1B4zQevJbrXhS37
10450	payment	1397	1397	1678	1	1	5919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uxixwc22x8y9CUe6q8aA8GYxmMMLbbijmW6q54BJZkbA385e
10451	payment	1726	1726	1874	1	1	2870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHPyJntk682FWb46XipiVJghUwHVVYkHdfWt1UQFZLpfCa5v9
10452	payment	112	112	1821	1	1	3	62000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTDXhuEGnLECi6zhn58gqyqkoHdR8UqC6nmNXtmX9EpEP1Grj
10483	payment	1397	1397	1678	1	1	5932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qc223LQtghrFg7tkFx2jYc4VLQuxeaRneNavDVrkF26pohLt
10484	payment	1397	1397	1678	1	1	5933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxvJWa68jZm4AroM6LHQkSYhrmHKWnYLTCPfLtwEEB3HToSWG
10485	payment	1726	1726	1874	1	1	2883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBreLXkKEQbZwdD9Kw61CxMSKVCdJvyrbhpAJJ43oUqzFdh46Y
10486	payment	1726	1726	1874	1	1	2884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAEqo7GHbkk8ZnwcLHXikjhN35zqd9S6jCyeXq6tvE6Qy94xz
10491	payment	1726	1726	1874	1	1	2887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaV4XG7ho5UH9HUzXkfX1d2tyMjPGqmcGNyQaDpzAJoXb1uAgt
10492	payment	1726	1726	1874	1	1	2888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6VRAzp7QoL587C8pPCm7JNWp4Dm8j95cgrRRuVwYAs9DwweQ
10493	payment	1726	1726	1874	1	1	2889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC6WuDfjUFUPpPgaDk6qK5btqGf6x8P82VU96UCEAuc5zqkrt
10494	payment	1397	1397	1678	1	1	5936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzc8wxuDnuxk9wN88q4vYdhrotnGyDeohaimCcJpFZyM6PkD1
10495	payment	1397	1397	1678	1	1	5937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzYERvgE7sFpoBHDubuGNvQaZ8XUdjFWy2iwJLLiC3c6vQYWJ
10496	payment	1397	1397	1678	1	1	5938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVAbngrFkaub8BmpV5kboCpk6CCq5FZV52LyaBhux5o161kCb
10501	payment	1726	1726	1874	1	1	2892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoMKCfyPQr8T3NYe92dFLxyELA9zMVKBiHJkbcRDFKn49Ts6Q
10502	payment	1397	1397	1678	1	1	5941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnL4EZV5jX1AnKHqgxeh1oDEWYH6Bxgq4zFqpve24b4Xhw3J1
10509	payment	1726	1726	1874	1	1	2896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aFDd5w8xGnNdU3Xa6QJEM34DSf2LwBWY4gLB12AexBcyZhwr
10510	payment	1397	1397	1678	1	1	5945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSZXfRo4P4DX1M7AbVooJEVDutTmzWHzRC8pRJ4Tegw3Vm8Jk
10511	payment	1726	1726	1874	1	1	2897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmbUzZjxd4dtXcLmPz41Yy3z4wT7soLjPe9xtoSzRWDLGvzfH
10512	payment	1726	1726	1874	1	1	2898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJGYr3p5RHVC7ZE2VtboZK8DgDTRNws6dK5Jr2Mz5xBkJiVH8
10513	payment	1397	1397	1678	1	1	5946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBtQgBpVoCtnGVu5QRPTZEbLTamLYQunwp1TYqoT5ttMhmJxg
10514	payment	1397	1397	1678	1	1	5947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oSdobLkjbY4ko8H6YXYTwEPEKgDWXFuZ76dJF1RK9Uxtgvo1
10520	payment	1726	1726	1874	1	1	2901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NkTbjTAfRL1qYJnDU6bcjc3ehuRHzhS3xv3KMfo2jzmdGGh7
10395	payment	1726	1726	1874	1	1	2849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qPFpEx5MPK1TV2Rkx4jjZmbdrN7DdpygRkXPvK6dXHLr1BDa
10396	payment	1397	1397	1678	1	1	5898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cGZmydmfQ7hk5cH1iLTTDhtHhrchpYJJV51874Ht293btSbc
10416	payment	1726	1726	1874	1	1	2857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26R7egkxwdhTzfUkT9pvwFQLiwxcPvk76NKXjaXuXqdw94rzB
10417	payment	1397	1397	1678	1	1	5906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxuF8hBbKQAnUg1NHPu5hXu47wz2W876BnxcbUM63MazHzCst
10418	payment	1397	1397	1678	1	1	5907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1Bjm2hfLwng2VQdWVbCKoMgHGAYfB7qU5Ed573GJQFTBvuFz
10419	payment	1726	1726	1874	1	1	2858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjz92CcLL18QQggKvnXYtF2FQ1ptGctxD21zawJ5LKT1iHBcrb
10420	payment	1726	1726	1874	1	1	2859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaq8Xs5pMUbqHzkxXGXHkq2Pe6tMwhLiWhrkDErZjoMvdgtW1
10421	payment	1397	1397	1678	1	1	5908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVsDLSqjuXkhSnqMFN1oV1ihgjy4P3biCPnY6m4NPCh32F2Rc
10422	payment	1726	1726	1874	1	1	2860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqvo9ng4bTQuUVZtfch2ukzcM2rQmZEDxgrqQmLJ6V4ANaohW
10423	payment	1726	1726	1874	1	1	2861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXuvYqrsZ7aveLeG4MgTBaoktZDCJAzDH6xMRqHE4VpzpfWd2
10424	payment	1397	1397	1678	1	1	5909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8EKVH4jQb3t4zV9CSWgkiiz5JKMGvMSTJUhSEwzQeJC2pn9g
10425	payment	1397	1397	1678	1	1	5910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXg97NPLh1MQkrbX32bHCyFCH9ofYLbUUiDZVdsSNVdHM7n337
10426	payment	1699	1699	1773	1	1	4	6840402949970	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZNHneoivDriWRztJHkKLGooU36LBwv2LXvBb7GzbhDbw8qMK
10427	payment	1773	1773	182	1	1	18	118518922960	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYdFcnoPutcFCVpaCtTVyW3NBV2ab6MecPKGKtWcDC9CW8hqzb7
10428	payment	1397	1397	1678	1	1	5911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggigXtua19byK6AbX7bHTzgvmZRcKwNwH3EBYewgZtkyAy1sq
10429	payment	1397	1397	1678	1	1	5912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePLDfzvsCeDsGdTgtAEWA7BPaEUB7hDP6Cr69RxkdK6hDBiWu
10430	payment	1726	1726	1874	1	1	2862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2Kw7bZ31LvSBxgiJjJ7UUxER2pswmzNrm7HmKL6apk1HdPH8
10431	payment	1726	1726	1874	1	1	2863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtfxpVC56CXmVsaLCTwTyBD2BKXbsTdqUejobt9CdQ6B1dLcm
10432	payment	1773	1773	702	1	1	19	79012615310	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaC1NM2F9U16uDTcXrdqLMvhKzzBvNyrSK6Nykadb5jafVkGgQY
10433	payment	1773	1773	927	1	1	20	901291269710	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYy13N9pvtNHg2cUi6FitCbdZAvdiqZMx4z4yzECnNvPn68D3dh
10434	payment	1773	1773	1047	1	1	21	1615106233060	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaHQfrz97cWrg6oNeZfPud7oDNF4wCDbb4kPWs5mJ2c9JEuPj2X
10435	payment	1773	1773	1167	1	1	22	1089744358710	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCGVcDoRW2v58xNtoX8W7GEsz3hNPFCJ9a3UG5eWAavhS3tcfr
10443	payment	1397	1397	1678	1	1	5916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhNiVYUo5xEsTyEmAm2D2FzcLvsgWyjL4VGK81u64H74qdhEX
10444	payment	1726	1726	1874	1	1	2867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbjo2HagzdAGazqFkpEwYigWm9k3LLHkk4dvNKDR8PaRpAx7F
10458	payment	1397	1397	1678	1	1	5921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8vZjUHGstcw5CfzjtFjTzJddGX2D31Gkc458xy4jz7uMNqQH
10459	payment	1397	1397	1678	1	1	5922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyawk46dkhR1jXmHfdsp5de8LDt6XquD2MQmLBHk7GDd9y322
10460	payment	1726	1726	1874	1	1	2872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZBTwzsSfNGn9fG7nTcPRJHN1VPWjM2ogHBjt5y4JCs42B6rZ
10461	payment	1726	1726	1874	1	1	2873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXB4qnd2Nb5mrSTd1vQVdy1yBiTGk8ZpnzUJ4hTtHZsCvByT8B
10462	payment	1958	1958	1978	1	1	1	120000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T5hS6YfRJcdKNr4N2p7To8gBB54WsruyjcE7WSuggRgRDRti
10463	payment	1726	1726	1874	1	1	2874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY74C5JLCnXqeeEZ42sJoBw3uJfeo8P8oyHd6S1WBELqYBVPT2
10464	payment	1726	1726	1874	1	1	2875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfWGBQnQ2hg1fkSzqkF5wh5rBec1RKjgEJC4inkqQ65ZbQ3RV
10465	payment	1726	1726	1874	1	1	2876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobe1heYKoaXqRrunYHD6GuQVVFf5DKtCLerK6njK5GFKnLZdo
10466	payment	1726	1726	1874	1	1	2877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDqFwUfbdtZhNnfXto62yerU8GfZmiB85rf6m6GeVAxDfb5ta
10467	payment	1397	1397	1678	1	1	5923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrme6oSzeipcJ7kb3RXtr84t6fzkDUZxrfQ2mQAjdzKHmUpn4d
10468	payment	1397	1397	1678	1	1	5924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2A7WYXwmZWFT6ExEJF6v6ZHXqqAt2C6oN2JvdTfVY6BFrewg
10469	payment	1397	1397	1678	1	1	5925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9bVpLF7wBYYcuYAmtGuE3TAACfLN5Wju2NHwTrkkdMMk5CJ1
10470	payment	1397	1397	1678	1	1	5926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkMe6MjytYKpFBScWkeexwVyWE1J8kPuJsYBw5LYqUUxuJonj
10478	payment	1397	1397	1678	1	1	5930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qhypv1b8ydjQfxvxCFWwBb4fxqqKAU1Vc3mUP3bywHr5cxjm
10397	payment	1726	1726	1874	1	1	2850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWXhjiTmnq2nRrNEU4JSp4jwTbCNB6sHakXpFXF9hbNyFj5Zf
10398	payment	1397	1397	1678	1	1	5899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ4FJQ4g2U5vXDLaJKQ1CwHu7R2mdDJqVbU4Lu3M3Np1gTU36
10399	payment	1397	1397	1678	1	1	5900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZCZ8M65j7QMyw9KA3QFvPgsn3ywjqG6GKEY5qyVoCgpV8TznY
10400	payment	1726	1726	1874	1	1	2851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5cqs9uQrQj2Xwjfr79HJN1GytFugA1hVqY6fPKmrMR3wAcyM
10401	payment	1397	1397	1678	1	1	5901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy3teHP1BgxSAJor72sQRo4FBXFLw8HqM3GR5MsPvrsVz7XA1
10402	payment	1673	1673	144	1	1	0	337270000000	10000000	\N	E4Z2WL7Rj8NjhXTuGVLvWa26s2mRNhvDL133eXGrheXSwEo2NLT29	CkpZErCVd6Vgut3wXWHQNRMX9GxU3SKX6iV8gb9bdoFo4T9KtGhRU
10403	payment	1726	1726	1874	1	1	2852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBLa63JCC9kp1656QSDYZh6imddbSXBnxjAgiM3AfsWDM6zQ1
10404	payment	1726	1726	1874	1	1	2853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfmRRACu5FebfhQtn1j8eKFsjRkZUxV9BRcFMfa7Ag2E4fMkq
10405	payment	1397	1397	1678	1	1	5902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnTGcdjqqtSe4AnQjB8MjuHxHRVYWqA9amrrSp1rYM3KxPdUU
10407	payment	1726	1726	1874	1	1	2854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPf7KszwYtt3vCsex2Na4cgF9RD9MhEFWmhYgwLpTUs8utaNY
10408	payment	1397	1397	1678	1	1	5903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSygpc43sS8YzvzaAs29rmmj89JzHYLyQeH9gHTSpCXDqLNMmL
10436	payment	1773	1773	1293	1	1	23	3036669550220	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCQt3odoXXjdEQ48feGBDgbobwBE6mHKNmQwHUPmegwGWFKane
10437	payment	1726	1726	1874	1	1	2864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHixaR3XAGbajU9t4nfxdZME1DFm38Fj5X8RWYeqQMsDvqoT5
10438	payment	1397	1397	1678	1	1	5913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9WYwyweBWt4hCmA93stEVptmsGumzinNXtKjX816qKJJ2JBV
10439	payment	1726	1726	1874	1	1	2865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNFz7m7cn7D1EeXGVTAwsE5meBrHC8GrZJCdB5uskGUuQAXAr
10440	payment	1726	1726	1874	1	1	2866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqADpVLM8htYyEo7rys1BFzY822mcFFKXPbs9KBCNCVFptD82
10441	payment	1397	1397	1678	1	1	5914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39YaM9GUYFx7mSFnzgj3dZyzdWzAaTTeZWiSYDoBXt3B4xAwJ
10442	payment	1397	1397	1678	1	1	5915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PwfNNnHaruWhjgMKWwwhtEktm3PFjjfF4fEpZ4CxCpWZZfif
10445	payment	1397	1397	1678	1	1	5917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEzeRx5rDZrrJVqu3hnZ96tGeieFXWM5wMDhrm4FcikyoFvAP
10446	payment	1397	1397	1678	1	1	5918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gbjAPyUXYRmDVX6AqxwhvVuv7hUVrZHZw16RYVmrvtmpn4fY
10447	payment	1726	1726	1874	1	1	2868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ETvExYBafVhrZBvBwQkq4tDySLPvrYaYpoMWHotgAizPit2W
10448	payment	1726	1726	1874	1	1	2869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPWEVWEr1AatMPQrG68N7hNnkFQ17gTENgzJ8Fb7f72P3obmG
10453	payment	1714	1714	1054	1	1	3	5208365077410	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	Ckpa9F64DSL2tkmpM4KAVwA1JcU7FQwWdZqjxy6mqHGNSnfd5HfaW
10454	payment	1714	1714	1174	1	1	4	3514187701728	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpaJJBW4PeXrbqs8kHWELDDXj1Wc95nTbTdHndHgSeQGB9fyfFPL
10455	payment	1714	1714	1300	1	1	5	9792596495022	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpYW4RxAUdHptKMZSjbfebcEh3CfCJCzS6eHvnazbab53RjELu7q
10456	payment	1397	1397	1678	1	1	5920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJwpGNaVWVpGENVf9VmuiC65kkDEuQwBoMsVVaaJwxWZXWZMH
10457	payment	1726	1726	1874	1	1	2871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRNY1FWi8W16rCmiFnuMvDtXd4fc46chCvLfZemHw7i55Sc1H
10471	payment	1773	1773	1293	1	1	23	3036669550220	10000000	\N	E4ZAVfjhtcnCrUCBPSR7ibQebMWaPc2csfwG52zY9wUVvE2NbSYoP	CkpYQYt85U7kNSrJFXwWqDvrEL9jMiVvoAdizBnBN2kDrnVxSnuys
10472	payment	1726	1726	1874	1	1	2878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaydjZ2k3QoRTpDkcWKNir6oh9Qx4dmRvrz9gfV3Ed5Bj9oHs
10473	payment	1397	1397	1678	1	1	5927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBn2DaPRZSrGKU7Vao5RDEwkgNU1Ggxw8wCybWPieei5z59Ey8
10474	payment	1397	1397	1678	1	1	5928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9VBw6ZS89f6TaAhwCDTchtc6GeSzm54dz3cB3eUVUg9FdKKN
10475	payment	1726	1726	1874	1	1	2879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYKFbhxCiespkwDVxzkAeaWxTzEJ2C7e7NrYM1rBzYzSRfajR
10476	payment	1726	1726	1874	1	1	2880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLasRsVbGZLZYv9ixr3dAP2B27Ya8dqzeCnaLXLLPqZRdnaw4D
10477	payment	1397	1397	1678	1	1	5929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqTUZXURFHiKZ5QWtC1UYXzzCCLABWdDfQzLDLkKW2qhE9FxF
10481	payment	1397	1397	1678	1	1	5931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshSJAmSr8AkbemsW3JeHEm2K3uWf8ytEHzmxHXkUv6MFtMMgM
10482	payment	1726	1726	1874	1	1	2882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Lb9XRQukx1Th9JNYszwDkcKfkzPxrCRdEVEwMM7UuyaviUKo
10487	payment	1397	1397	1678	1	1	5934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZYPHmCehCeWEjPZkGgTH5AqyyV8KgfPib2NKcExhF2r9ToHM
10488	payment	1726	1726	1874	1	1	2885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuBV4QHMBhokRbco8hqSmE3ZNN7iFuzEVpsTwvvZXBp5CAqA1
10479	payment	1714	1714	1590	1	1	6	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZER8iLuNoAEHNBAp2H7fmnGsuXc6s7i57BjCdqwSRZuGEsT3eS
10480	payment	1726	1726	1874	1	1	2881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNyrLKoaf6SmNtdkKmMpnshW5x3TvuZMzVBLDF9g8zFZetp1
10489	payment	1397	1397	1678	1	1	5935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7zLQ2Ri2zMw6EVarNXuAk6HBQ8kvCPGbEzNL1MjJE49WoRf8
10490	payment	1726	1726	1874	1	1	2886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHN9biv5HwPPN7Mi8VRXqzXeoG1yMsBND58x5vWyfY74tL6sd
10505	payment	1726	1726	1874	1	1	2894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdXRNTE4Z8CKhvavZBgNdSo2uceonDjvZXVzkdz3mDGmgpYKv
10506	payment	1397	1397	1678	1	1	5943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzHfC3WiDXDGAshVT6xRaSWfMxQjewRWGkYRHQcoummdENqty
10507	payment	1726	1726	1874	1	1	2895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WS3T8dHVsMCPegLQq7wd5XD3mhwUSi9Wzs3Fus4Ln7QETJxh
10508	payment	1397	1397	1678	1	1	5944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCxQr8xYa6DXjDNHxzUmaQxFdwKGacSKffeNoYn9bePMMNQi
10562	payment	1726	1726	1874	1	1	2917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmP4tmMXbrrxUyYZsb8Ss2E7eHEvPfagLDZUtuYr1DudjFSoM
10563	payment	1397	1397	1678	1	1	5967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8nXZbRqn5YseEAgv5d1ZPafJJGKRr4bqYKCJsXvECi4J3mmg
10593	payment	1397	1397	1678	1	1	5981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqHqfhtwq8tf8C6AKjJC6AsrH5vbPDQGiqJS7k7ZLck5XVRxD
10594	payment	1726	1726	1874	1	1	2932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQeVXZBYDT2PNLN65umMSiWZQze2sxfUo7nN5F4WjtpFRNzkA
10625	payment	1688	1688	786	1	1	7	9803361598000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZXMWvb1UuoLtTeGrK5yZrmDvTX3jWHqyo2Ttj5b5XZcc81chw6
10626	payment	1726	1726	1874	1	1	2945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5Sr1DwwgPSQ8cbi8xHYPfi2bRy4yPh7KmrREfsRpwgVRLecT
10627	payment	1688	1688	792	1	1	8	2450889968000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsUfE2hS8YjpGwQqGN99oBFGK9ez4jmrdzC2i3CUGednnxUUit
10628	payment	1397	1397	1678	1	1	5994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKizDuhNsz2at3FdU63hLEvWeri1NiV1EMbWSgW2iHjHnnLS7H
10653	payment	1445	1445	1290	1	1	1	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC1dyKFqtyD9rXe3YiPYpggBHP5kDhTGRAigBqBmjBFurW2hx
10654	payment	1397	1397	1678	1	1	6002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeU9eWZaugncYrBn9JzGNVMAcqqxMbYrB892wndiWjaXmUQQNV
10655	payment	1726	1726	1874	1	1	2953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXX19pUUsdGeQGuJkZ31nKhtmE4GaLmVMJdCFm4gbMoAjJTnW
10656	payment	1445	1445	1044	1	1	2	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrvnXSKg25Ws1FcfzH9nWH6YWx59V2VKMJ9SV4LqJ36AXV6nu
10664	payment	1726	1726	1874	1	1	2956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8BvzbHdXzE2JMFsSvUYYJ8grBeEHoQxcGLzK5qDKC8RME3AR
10665	payment	1726	1726	1874	1	1	2957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZ58ge1o6LEk4HiEXGPciLT4gnNasHmunEiL2pDZAmJZ7a2oT
10666	payment	1677	1677	1395	1	1	0	249919890675000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEvKvPhpMrPTxN7Ggc8vbUBxNtPs3RXMtSicCJCmR2nwwN7uN9
10667	payment	1397	1397	1678	1	1	6006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv1MFTcfgK5nJEWWz68KohA65JGNgaPaZK3MfKnd4ZCZJ3BgE
10668	payment	1397	1397	1678	1	1	6007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgcJqxWZ2TbopoCTa25ydQDe1YmWjTFAymkYWujFhf82EFHqo
10675	payment	295	295	2017	1	1	0	344200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskY5zCnoPw5MVnxJoJZLwFPf1WJswfDeoq3JJ9QsszHgRfQ9L
10676	payment	1397	1397	1678	1	1	6010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoubMcDor3Zz12segJfRZQbgFNuyZ4QpPxDwW4ihe6pmSsDfVX
10677	payment	1397	1397	1678	1	1	6011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByjYi2mTeh64u51spNiiLxQJVcSFDXZbSrqP8yBGugdk74Kz5
10678	payment	1679	1679	841	1	1	1	441936090000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaEuoYzxJ31vPFRv2h9V9TKST6X9VwnKy8hKCud2YLTsw39sNtN
10679	payment	1679	1679	843	1	1	2	823928232000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ8noACZp6je8Rk43Ng9kNzNWLFjSushHLqPQnfThr9KL6hzs9Q
10680	payment	1679	1679	849	1	1	3	6100212524000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaCexPSaAMB3YiF1zwbYaaTA2tadVhJ86ViPFWBjKRKkR4na1bp
10681	payment	1679	1679	851	1	1	4	11817032227000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZh8HXStYcPSroG9E6nwQrLx3b5mBgXSHTZhv5S3oB1cEcwaRrM
10682	payment	1679	1679	853	1	1	5	1303017940000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYuunqhw8aDtmeYaBKZXP5UvnoK9Rh3RQKSQ3hkCFhWZ9vYLpyC
10683	payment	1726	1726	1874	1	1	2960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQTadzKvgDyF3SjxHMEMcKwLNcsQiao4jphHWUu16HdE5S5wy
10684	payment	1726	1726	1874	1	1	2961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ih9KwVNYQ4LQWJnXESdHsPjnGTphbFgeDcQriwQohZEcsBQK
10749	payment	295	295	1483	1	1	1	0	100000000	\N	E4ZRkoynDwC5RjaPrhegBZ8F24t6ywVM8icWn4LbKzyCe2iu9Y7f4	CkpYrVERFAGUTe6W8qvQh5JeDYjUZQBiukCsXuRHsh5n1xCkNcqc3
10750	payment	1726	1726	1874	1	1	2979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNiKM5PpaP8YQMU1tYJwjenuukvCUqozgwzvV455vCcjuFTev
10751	payment	1397	1397	1678	1	1	6026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZLGFmLxf2im9DYWeLdmpmtJ5ygyAWedPCpDYpjbDTiDMteTh
10497	payment	1397	1397	1678	1	1	5939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAVCYGYRR4SoVCcvnF2S3FL5um8JSP8RgXN51gW6HoU7ZgTxj
10498	payment	1726	1726	1874	1	1	2890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3ZCzjac4mMNDHHF24UUTu645cJGU1bkdWeYdZVEehdCZwmN2
10503	payment	1726	1726	1874	1	1	2893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhv8n5d5WfvvCxYyRy52sFqX1Jc8ipGgLdPWjhHsGT4P6xWYG
10504	payment	1397	1397	1678	1	1	5942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSWDHPq2rvWHhzEy116zzjpk4eqPXi7tTV4UzDKSsCeHE25NA
10515	payment	333	333	2015	1	1	0	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmMxnHTjZ3RytHWh19ft9NN67bAVAy76S9ZMZFJfximeScnFy
10516	payment	1397	1397	1678	1	1	5948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FVJ55DCnMvqGPVYY2hyga9D69YNgQLVRPAEjiiZvE2itLDE8
10517	payment	1726	1726	1874	1	1	2899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3gzZBMdm62dk7FTVdjzQKFU8irc4iTYy8hBKogkqRVahz1wq
10518	payment	1726	1726	1874	1	1	2900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsp3oRam6Haj6DCjU9CTpYCNnQSbiqYGZ6pveSpBHtfgwndJ7
10519	payment	1397	1397	1678	1	1	5949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFfduftGi8EX8Tt31cvjGRogKwaSe7v36miRPpuvpYzWBfKwp
10522	payment	1650	1650	535	1	1	0	1000000000	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqpt1Z4mrrmGm5Y2RdBBrcFwsD4zWYF4EJmvmsLKsFBkeMta1
10523	payment	1726	1726	1874	1	1	2902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQV2qTznSkoZ77nTyonZk7ZBzyN3qUci8UQCMMEyPJZND7MLNY
10524	payment	1726	1726	1874	1	1	2903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGwJRuAUJZhAgkLUP5rkwy9Ut8AViwNH5JAMPxnZHnHkTjtbE
10525	payment	1397	1397	1678	1	1	5951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfrUGetihNGDk9bkQcUTyeWZrwaKnkuRrTaog1C8KmWpaDkcE
10526	payment	1397	1397	1678	1	1	5952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfw2wLgse4K7aFqqgvTVcJ3KrM4TeFbcUayB1npaBjdksYBaVJ
10542	payment	1726	1726	1874	1	1	2908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9P2sRxNJsWDGzXBa2b1vZQf4ZNjuUdZASeygN7tP89Qh9gUF
10543	payment	1726	1726	1874	1	1	2909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjoPSfiBUayWqR4R7jrHi1P4C2urjeLcCwa4reTWqUivyv7nu
10544	payment	1397	1397	1678	1	1	5958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwSFxsNd67u438SgfxWZPvapHeb8QEcZbboYtNP4r5rWiqh3x
10545	payment	1397	1397	1678	1	1	5959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXdAtmz5rc9y2NPB11hDCUAmUeGwAdMuozGr3SLo8kkJtYovG
10551	payment	1397	1397	1678	1	1	5962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWFRsfsUE78ST7ijkmMBVyuvWRHVBfsPQtRr3Bp99RFVFawH8
10552	payment	1726	1726	1874	1	1	2912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHnCoij9ynosZG9wB7LLo7oxcAKWy2EUXsyT6fufaaV6HtRbv
10556	payment	1726	1726	1874	1	1	2914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYyZixUmaWyU2MDi36uNiiCdBpJuYqkqqtCeVZxQ2qGMptRWb
10557	payment	1726	1726	1874	1	1	2915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUGhCFBmwpA5z2T8JihM6ckJGtAeFX1CNeLiNzz2DqXhBCecu
10558	payment	1397	1397	1678	1	1	5964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZur5ENn62NKBhQL6PEoH9wARNWzq8VSN674Jz7maXd5xpKTcKX
10559	payment	1397	1397	1678	1	1	5965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yREwkPDbkRNYFQcQWPjdpkAhV4U7ThptsKWkSBP5iDJptgRq
10568	payment	1672	1672	2016	1	1	4	1005000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvssH13rhXGwhwYPCv7Saoqj7zig19R5QpwnNeVVCAZZxNFKUz
10569	payment	1726	1726	1874	1	1	2920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2t77Efrdk2p6iSF6mwVT5ooZysA8VW3BEtJC698j3ZbeeDAFw
10570	payment	1397	1397	1678	1	1	5970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2w3eGjwCqrB2EYnJ7QUYB1uv6znHLxu9omtxxAp3oGBZareF8
10571	payment	1726	1726	1874	1	1	2921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9zrTy2ZJzH2BP7zLDeAEtWKSgSL2GpsFvXLT4eTfHsRJR8ZF
10572	payment	1726	1726	1874	1	1	2922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHodzMAWbNbne5Qw9NfwhhkbXokTMR9xtg2t5Nx7oUPMo1gMH8
10573	payment	1397	1397	1678	1	1	5971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6rtmRYSk6vmGzcKc7kkK9yyvzkUwtCnmWxfCv6cwDxxa6DWe
10595	payment	1397	1397	1678	1	1	5982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CTdUtJu2ggTfxWPwvHe8vcz44pnvEH1yikMbW9jNjBd4SwMG
10596	payment	1726	1726	1874	1	1	2933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDyVh1QMDDDFQSqwrR6VTLZbB82WPPPkK7gYSBUKQAwekxCcY
10597	payment	1397	1397	1678	1	1	5983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAVgvujhDS8PY9WfTaPXQpim6om31EhLirATyPBuzXp42nYpo
10598	payment	1688	1688	31	1	1	1	5288248766000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZFVwwnazsVWgpyMiS3zLXofTKy3VVMmzYggRA5gQwNH7G1DKnL
10599	payment	1397	1397	1678	1	1	5984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZPru4ahQoYe6iipqudNNVmyuLXGFaMeTcrrUj9nnWUeWQBDD
10600	payment	1397	1397	1678	1	1	5985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEYUT6WpwEimx4cxG8xUve12wqgbC2fdmTuiVcustVKz5afyJ
10601	payment	1726	1726	1874	1	1	2934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqracJqV4FDK42syEJZ5t4CXKdfpyMcUyZSivcw6QFAXiHgJP
10602	payment	1726	1726	1874	1	1	2935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGhicCGwjmAz22XW5rrUWNX88LXTaouohiHSdHzvWfYCPspxB
10499	payment	1397	1397	1678	1	1	5940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWveFaL47is66mqUTRmhTq5RooJnT1NPjWEbUTD2qUG7PTS6a
10500	payment	1726	1726	1874	1	1	2891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eQusA9iP3x84PdG1T1vUEYp5CprnxRSPsL72BLgSxJXkcvyR
10546	payment	333	333	2015	1	1	1	324800000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdBUFYpUUNLu1iyDbpFKajJfaaiUyBATDbyXvxsGsMreMJPCA
10547	payment	1726	1726	1874	1	1	2910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLJ5Jv54JdNtkg8TFgq9uuPxvw1vJoFDzo9EnTyehJ1kWJNyD
10548	payment	1397	1397	1678	1	1	5960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LCsqt5oW8aiJkMgPninPsfu3NcJfgBJdrwd6hika2BkLJC87
10553	payment	1726	1726	1874	1	1	2913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1zEEGcJYCURXrE2swj2V6xcrtiowAEazPaWwKZhgksaYgvRP
10554	payment	1397	1397	1678	1	1	5963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa61evGrjFK6TSyyfrW2pnH3JoqnRZQhQe9ChETMJsDUSdQUm
10555	payment	1422	1422	1337	1	1	3	7500299770800	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZFe7md56GiTxt2Genfisy6G9RQHxx9zZ5J14V6TFUphh9sy5CZ
10560	payment	1726	1726	1874	1	1	2916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRucnDBSmTwBXZRktXyyHjjFsJjupdSuEo3DnW8nTRAk3ziY7q
10561	payment	1397	1397	1678	1	1	5966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhEQWgoAS4CieivCGyn66RvDgFuJRg3NBRYDHtELgq9gmLd8J
10564	payment	1726	1726	1874	1	1	2918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8HLz32pAcz6EcMhAj8W8sHFRVzBcxRABHUXnokc1xpenw26s
10565	payment	1397	1397	1678	1	1	5968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa627Jj7wj7wG9NjJ8X7rWaDkRA4dq1ai223CbsBGWTNWuK3Nxx
10574	payment	1726	1726	1874	1	1	2923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHFVQLcyiCvovLbPqLoryDCcmZq72LpPTtgdM5EFxTMyQcRfF
10575	payment	1397	1397	1678	1	1	5972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8g5AAgy6qisygutEyRixA3zgJScvepDCCp6TJbXehBeRXwpK
10576	payment	1726	1726	1874	1	1	2924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZ6yUoDfT8XAXZn1vLYpHtSFVvThHtgiHwBvWijsztvT5hk24
10577	payment	1397	1397	1678	1	1	5973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XMSsB3Aypi7b6np9tB47JasNfAEa7YryZTwaM6bq9RHfkjQk
10578	payment	1397	1397	1678	1	1	5974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDirpK9eXNNwiFVxxneiWJVisE9XTJGLU3LSjqsu33tnPUuTGV
10579	payment	1397	1397	1678	1	1	5975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJon5qy6W4Mqv4ytWWfdb8pFV8bWvfPdYX5iGwyXUch8YsevF
10580	payment	1726	1726	1874	1	1	2925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SEi5Xs7Z1e662FRjp9KmS5rhpPWMbjmmDf3JU1d8kbHyAJbe
10581	payment	1726	1726	1874	1	1	2926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyhTDMK5Fzmd31X9oGmooPeTKp7REVXpbCifgU3GrFuy9Us8r
10582	payment	1397	1397	1678	1	1	5976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UbmxhbWTEXEMfeuXtgc6S6KbdBaVPYwKXvLU2Q7SEhs3KZiG
10583	payment	1726	1726	1874	1	1	2927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZsxZEZxwYg15NHPrF5oj6CA8mUKH6MFjXd6jaLDxjAUiYKER
10604	payment	1397	1397	1678	1	1	5986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquDCZE4ECe4rLf64FwDjrut9P1Vzy39Lq1A38ZVsGj229d6ds
10605	payment	1688	1688	32	1	1	2	295280157000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpYt1PaBVGuRU6VdLUoEZgxBdKbwfmD6zx6Cnv9N6Zpxt2upsVLB
10606	payment	1726	1726	1874	1	1	2937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKchABHaMSxmVU1zBT9QC7gLnScjNbLTfacf7YpM6x6o9tA7C
10607	payment	1397	1397	1678	1	1	5987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqtxGUB5NV5YmVMjR53eWtAUrbmCdz5M9q6fZ5RQ6gjmf2WNh
10608	payment	1726	1726	1874	1	1	2938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFdBfVaaMEmW5K1d9x662Xv6A5jV61oXUsJkuUNUCLJ288yN3
10629	payment	1726	1726	1874	1	1	2946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TWrPHWuLobzAGqUuxiSmGJDjvcEh8ZtnkMZhw26TPxH4Dg8P
10630	payment	1397	1397	1678	1	1	5995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZz1tpwz5H7bZjducwGynGLE4Qsc3UdiCAHafSCGfrvvefceA
10631	payment	1397	1397	1678	1	1	5996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3UCAuJA1kGLx2T6Nnca5F7r6p3tumwXfidtswMP2mGAbu3xg
10632	payment	1397	1397	1678	1	1	5997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUm2jaWs2VC9K2ijRqzzPMe7FanS7aa1ugvjggb71fzUWXaYna
10633	payment	1688	1688	791	1	1	9	222808373000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZvr1kFKWfHiBocVccsQESNpDvUyeC8UjbYFnzTo2mRHRZEcdB1
10634	payment	1688	1688	799	1	1	10	55697102000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZE7BUpLjBhrR2jpayDmGtUms8fbE6hfvSFUB7bbCc2H1P9FzGH
10635	payment	1688	1688	800	1	1	11	612667593000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfbN4odNqDuwyjbRQawYbkstukmjUmGCY9x3BUr7ggGtjwWUBz
10636	payment	1688	1688	801	1	1	12	55707407000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZN8ivHxteVCn6t7mRCbm3gHjw9P77bpnHPvXZDX6oMuN1jmoe2
10637	payment	1397	1397	1678	1	1	5998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAULJCFcNn4tUtBFmUCw8DB51SUcCebHRvgdZxVX2WMq5MKpT
10638	payment	1726	1726	1874	1	1	2947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LUWQND6tRa7YXRFFL6fEWKFybxVYHKe65S4Kx9S31mSxtUjs
10639	payment	1726	1726	1874	1	1	2948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRRoBJ5xL9QGiNH7aAvGYmucAbQVhdLLBjGR2zP5kdMEpMyCU
10521	payment	1397	1397	1678	1	1	5950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT2EUs1B4PLgRYzNTvSiLspTkRCCR9xHJfw4FDWDnKjxiv2xr
10527	payment	2002	2002	558	1	1	0	3990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJzij8NFwCqFUaiNFjrNdKkxrMUXRWgFRLE8hvB9jZ8ugCg63
10528	payment	1726	1726	1874	1	1	2904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZdTrmB4wULbq7qCDP2XSThP82AM9QfVdmGz5Y3jJyL4Lg85Y
10529	payment	1397	1397	1678	1	1	5953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tp6esovBZi4A9NoRjvPoXj8akGCfCFSVSFCKhW7VL6mEegq5
10530	payment	1397	1397	1678	1	1	5954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCiKoxPE9aG6fHQiYraGHWum1dp4yWEinnEUJroVx5tAVsKtHA
10531	payment	1397	1397	1678	1	1	5955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGUDWzkxo41DARqsHuUkWBXSMxzCZfW39CAweFhuqr2pjnnpJ
10532	payment	1397	1397	1678	1	1	5956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSq5TZ9ofY2xqN7qixttWqB4awKiSVUcHb1bcQgNso5oy2Zhhe
10533	payment	1726	1726	1874	1	1	2905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkkstDTw7YQcmWPMPt9ecVKfyzHR99L7CQ1er4UxgRMHSWaHs
10534	payment	1726	1726	1874	1	1	2906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFPc3bGe7Bov9UUpmWmzKm5nfCAn9ZHdu21CmZexFe4SDxP6K
10535	payment	1422	1422	715	1	1	2	8389376502	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZVUAk8GE5PLGyGtr3n9Dn9oE5F5EiKhwvQuRGDswzqmFLLe4bM
10536	payment	1650	1650	1009	1	1	1	1558000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cYMFwPsJjnecCPYJpurQCozqYRr6z5riwL6KjpBMjuuhJV2P
10537	payment	1650	1650	1129	1	1	2	2792000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwW9T3bYJNQ9j8p8Zd1t5BkHbm9FgdGp31yMEU9K6bLXvPPgc
10538	payment	1650	1650	1249	1	1	3	1884000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuiy7JGyoQDBd2BdejAUsr97aYm8ygJ7M9C7Tsuu2uFF6KxFV
10539	payment	1650	1650	1375	1	1	4	5250000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzJP8XH3vXvys83QUh7DZW9ftkndmVrumvurdRczb5pcsiYMc
10540	payment	1726	1726	1874	1	1	2907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8EXanyirvQMsEjs71xjpJDyzHHVP4KKjHk6ZZ6oCrdECFu7K
10541	payment	1397	1397	1678	1	1	5957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPWqF6oiEk4v6kd2az3RNoPwHEKzi3pcAaG7ytQWUC6uNEFa4
10549	payment	1397	1397	1678	1	1	5961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgedSETUaddxUv7dYM2QrhYcyDypEpkeXLewR3ejArvJDa25YD
10550	payment	1726	1726	1874	1	1	2911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeZJW2cWzee3i83fsFgFJBDK1hxLDi5PHYYW25UtRDfgBZfhk
10566	payment	1397	1397	1678	1	1	5969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAjNzYz5wnVDpFshMGKJpbZvqJggqUYkobMcu3J8FJD91uAJX
10567	payment	1726	1726	1874	1	1	2919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmda5Gzwb2zu6saUXxVspufdo57uog5GrB8whSxaX7qAqdNEQF
10584	payment	1397	1397	1678	1	1	5977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCA7TNjWNcTqukBTgUTXzZQqMKNuGbauy64Lxa8qWpbGSRWtC
10585	payment	1726	1726	1874	1	1	2928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsAG4JKkQ3PnLukFZPFJLB8HPSzcPPSn2GstSDbcxNxkzzSDh
10586	payment	1397	1397	1678	1	1	5978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysrseyY141gCMbP4LeyG7aQgaeCyqw3EjtLPnmAM1wsgd3KkN
10587	payment	1726	1726	1874	1	1	2929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uuWUhzEjUkgibDdGKTY6sSGdL3sUxErnPtSsJ4tGXUQFgqKD
10588	payment	1726	1726	1874	1	1	2930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVxdVbVMeNoNvnNcn6peKeJgdLzG1pA1gw52mJrvUrDpAWSq8
10589	payment	1688	1688	40	1	1	0	264692170000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZ9ddf3kGJbfpavUUECoQCXzjtv3PkyrHZoX8mdFKb19Jhj3xxQ
10590	payment	1726	1726	1874	1	1	2931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4AWJT4SFGbQubCptEkJQPGYk3H93Jdb5Ma9NREYwVKJB6XR2
10591	payment	1397	1397	1678	1	1	5979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwBvk99bmtrxb7jcYkp7PdEunoeBPzWhUGYRsUg2wi7cmX7JC
10592	payment	1397	1397	1678	1	1	5980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdynBKuxTEaieVheBxkpLbtagVqRZE39agVZbuAM6shoY7WBf6
10609	payment	1726	1726	1874	1	1	2939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbULraygc4f3RLyGkPHYrqEc5v2gybdwjHytYG1zem4ZMZc3xu
10610	payment	1397	1397	1678	1	1	5988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnikQrCnF9hZw8zxx1LNfbkHNMYksnxGKq4j6iciiZ3K4rZSZ6
10611	payment	1688	1688	779	1	1	3	111404186000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZxAQ1hoDqSEHLiPoe4L8oA482MsbjVdrgit8Nban5XD2rkJAxo
10648	payment	1397	1397	1678	1	1	6000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNtJgroa4bzYNshuuyonZWNHViZAp3vY8boYWW5emie2WTrNo
10649	payment	1445	1445	480	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2eNiPPimT4GUynr4pNt2Bi8GBV3TwDdf9yH1Nrx4tGM5onVP
10650	payment	1726	1726	1874	1	1	2951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmja9uWX8rJZzTbDJ92NtZSTE77rt9quz1PF8nATWU9sqhXWGq
10652	payment	1726	1726	1874	1	1	2952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmoU2Gw9pgGvnWedyBDZJAYN9BPkwkZRtQJrh79rcvnUeAGcm
10661	payment	1683	1683	1393	1	1	0	746941148850000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYqMzX5raicPws2yppeqYEK6WBK3sms8uxX2eZRJrYVVDhjDcsu
10662	payment	1726	1726	1874	1	1	2955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzffx9a2fAseMJR7NmeVQicPsjQmgk5HVygbhzWtSiakTSA2Zh
10603	payment	1726	1726	1874	1	1	2936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5BRv2Yv5NbMGPxueFh3j7KcW5uRCuxuk2LQT79fLkQ23PZq2q
10612	payment	1688	1688	780	1	1	4	1225444984000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZNgi65wNa9NpZcYfbYjb5rT96FnfHZg9MEFMuAuDZYMjKo6uXi
10613	payment	1726	1726	1874	1	1	2940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymhFw3YvHtYmPBaLzyLkwSmk9d2ca7ZvqDnHo59agjwr5bMLo
10614	payment	1726	1726	1874	1	1	2941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTBHuF7BrVJ4A8ooRyT2xjwMmzCA1Mr25UBCw6aQ1x5MnuLgQ
10615	payment	1726	1726	1874	1	1	2942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenZhMUufggMcfWSZ6aSyDWrTNvFascCYxmWC67iZdkEJmvtff
10616	payment	1726	1726	1874	1	1	2943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa589gwkSjjhWGfPk4WNmdykwN4Hx9mLMvkojRTM67n5n2Vx9cW
10617	payment	1688	1688	782	1	1	5	9803361598000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpaFWVAjkcCEts4ZgwbusaKYZhHw5X7yn6QQXUK2Jk11UxaAtk1f
10618	payment	1688	1688	785	1	1	6	891215468000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaAWqgjGmJaSXAveU8bjfqKhb6BoTNGL1wjExFmaGcr2oGd5RY5
10619	payment	1397	1397	1678	1	1	5989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKgUuZaefMk1jARE5ZNMvtoV6xykjjcWrj9Lvgf3pw6zAYSc1
10620	payment	1397	1397	1678	1	1	5990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZtAff3FNmRPcSjw5pfWreZEbrthBAxh3mLbh6uLMg8YQ3Do5
10621	payment	1397	1397	1678	1	1	5991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87PRuEGKpCZbfe1DxjKzvir9xG85FX4Mv4sx1QDzzrFLs7kMN
10622	payment	1397	1397	1678	1	1	5992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsjNsNgri3r4pyZNGCG9BSRF9GRDCqFsNFcWDmBjjWgCyxNJp
10623	payment	1397	1397	1678	1	1	5993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGb7fkU6MDEZhmPFeJ8kHBQLuTJVwQDaJttDdNgdzgFAYYvjV
10624	payment	1726	1726	1874	1	1	2944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRB8Yxpj7qoYQcrLdh9M1wPgfgCkVt7DnfXNcZ33wtYwCwCRUi
10651	payment	1397	1397	1678	1	1	6001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmkfXMuhWU8K7dBCRVivebuCW88TH6tD5cxwJvRgseFSZi2yW
10657	payment	1397	1397	1678	1	1	6003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXa7U4RYeEmxNpVECY4yeQcAgbDv2JY36xE155zQ49X1zVbFm
10658	payment	1726	1726	1874	1	1	2954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJ5qfy3yjSQByJfiDHtfF5shrqHoqedZ1jZkbEZUceZJjpwUs
10659	payment	1445	1445	1164	1	1	3	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtm5K7oJypraMpWbTqqHcJ19vpj4vpmmW7eCtfZrjmQsSYCqB
10660	payment	1397	1397	1678	1	1	6004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sziknyViPxcsm3C4Rg9Qh2EksMjUCYye5pETW3jDmQuzrnuJ
10669	payment	1397	1397	1678	1	1	6008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PUPFjFnRoNwminjExkXeTQN3nepg6E8cKnDPYq7Hx93Eqw9Z
10670	payment	1726	1726	1874	1	1	2958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhjamMct1CCjVkedCwiznbuDkQoZ1WdqVrLe82jC6mmyBzgA1
10672	payment	1679	1679	1	1	1	0	1974383793000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnTD2ZSS9RnVbsW7ebvUGRhTg28RUQzM2rLa6t6bwtQ4p92TdH
10673	payment	1726	1726	1874	1	1	2959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmPCtLUJxkRrDBh8A9NGAYDWFvALQM3SPYFGtkrB4XAyJKDjs
10674	payment	1397	1397	1678	1	1	6009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oxyriiv2X4P2PM5ELrv4rYFsCyaGZ9zme7rA1UjQebJL9v4k
10685	payment	1726	1726	1874	1	1	2962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSA9WHUwrvyHnF53PC4DLpXxNr4mXE4AW7B1PVjZBzYMuEMmqk
10686	payment	1679	1679	855	1	1	6	689247656000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo13VnMvvjFGHRCqAzH9D98W44uBXeBfZvrJKncnkPPbExKBgC
10687	payment	1726	1726	1874	1	1	2963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNFn3P3E9CpsVGM65kcAwo9ntgj48WsMD8AH1sbYRekmy61ci
10688	payment	1679	1679	857	1	1	7	1737927666000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4scsMQXt1hJBfdt3BXBG9oiZ3Kn5ShfGyVHBW1876Lm236QUL
10689	payment	1679	1679	861	1	1	8	2400483216000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ6EKEndYkeVVkjZkzPqKjjz8E4rtJirhe9uV3ejkDa75PQeVVJ
10690	payment	1679	1679	865	1	1	9	2107354902000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZihN47wZdkpE81BxmFsDrAUzeJdtPmkiTca7SnQ2ADLmCGGkLU
10691	payment	1679	1679	867	1	1	10	12834266702000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYSiHhNLpTD6xSx9qqG6oXvLHdfC8UqjMkMVL2gqTYMd9BDPuWP
10692	payment	1679	1679	869	1	1	11	1372525001000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5Z2qiG88eyjFQSpLxhnCWYAbxxM6maszMdXzVnemNi4Aktdi2
10693	payment	1726	1726	2018	1	1	2964	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDs6mjXsAxe69AUGCqZhRD1PLyEizHK5CqejkBScinkkZoWYSF
10694	payment	1726	1726	2019	1	1	2965	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZg1Zb2nSe71zuBw6DgDyGrEqB6os3dz8enY7mvdBbw6AmsU3iv
10695	payment	1726	1726	2020	1	1	2966	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhuqe8F4MWS1nP56WeuetJhTZ7LLJZeDKuF5haUzQeuPMbUfjh
10696	payment	1397	1397	1678	1	1	6012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTTsewjfHbH7g9gLaVhhdDvEP1n8ro1NAeThmue2E9pZhsdd4
10697	payment	1397	1397	1678	1	1	6013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQhGZDGeEt9ybpznw5LSLheg5zZaD98hMQ8ypWFAvAP4R8gdj
10704	payment	1397	1397	1678	1	1	6015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFdGysZtNBgoSYE7oQiVuPpNZEytsTD5XffmAew3bLTdJkfsT
10640	payment	1726	1726	1874	1	1	2949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8acf4nq8ek78H13yyRSHjfz9uNemKVCu4hzBv8GBemNjUFUMv
10641	payment	1688	1688	802	1	1	13	612780945000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa84ta1sdX3njeMSCe3oJxjkWNfHuGgDik1jxzCgv9PdAdVT7di
10642	payment	1688	1688	811	1	1	14	431127745000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkJCemr5c5qbqkCbabUVxyyHzJiLdJc8gWQo94QabWCU8gKkf1
10643	payment	1688	1688	812	1	1	15	4742401062000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZQVXurYFfrpbm6NVygkhHJUKwvmxCrpCXKzYp8g7Xsh9rkCpf2
10644	payment	1688	1688	823	1	1	16	6918098282000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaD3YJyUPv9LUtsekMZg7nNPubMb6ow87T5XQpnsLFGa2LFLZ38
10645	payment	1688	1688	824	1	1	17	76099014692000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZTJYdE3yV46Pmu1SbrRNwMuqZrDPn19Apyc6aQSVUh9HthAW8m
10646	payment	1726	1726	1874	1	1	2950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWrTpCmZBpsmAxVfHVcBrimTfKQCaLuLKAAne1dSEReFeFo43
10647	payment	1397	1397	1678	1	1	5999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBc32Mgnjh1kkTZ1WMsjTVpRFhFkphgnjETEd2nD5pPnchKoAW
10724	payment	1726	1726	1874	1	1	2974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJyYqReu3cfi5jGBs6DurTobhVx2xZz9RLyu6S3uC2m7HEjnb
10725	payment	1397	1397	1678	1	1	6021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiRinBLek2pjuDF7oCUTAGzHkrCSeVBS6QWBNBQKNNpMLcJto
10726	payment	1397	1397	1678	1	1	6022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXYbnSbN7HDi1wBBY24LHBDnMBdmZjng8M2MfZEgpRGWnkBsH
10727	payment	1726	1726	1874	1	1	2975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtghREYaDJZTC5JM7nwQf6rdX1w92ZacLBusdy7S1puLe1vKe1
10752	payment	1397	1397	1678	1	1	6027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHMUmDALBdtnRNs4Lu1iJ1E1McMUcQWnAjGLjsSjQnnhBd2wt
10753	payment	1726	1726	1874	1	1	2980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUbVZv48JsJDZyoFgiUeZdSZ5wpErsQBNgVstS2FjXcxDXgmV
10759	payment	1698	1698	2023	1	1	1	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCSS6AN2wt5ZEJwe6xyaqQTagwEiCpAjcoVGN7zmiRW51Kjd8
10760	payment	1726	1726	1874	1	1	2983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSiNHfQzNpBR9PHfJR1NVAPq9gNstkiGDteqNgAgyZQa6qCP3
10761	payment	1397	1397	1678	1	1	6030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UAhZ8rcE5CDnCE6Mq2XTy3nBAnt1cAC3uwZ9XPGFvgEjhqcG
10762	payment	1397	1397	1678	1	1	6031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2U5p1gQwxkmv6pz4kG5o1MAbQaYrMoG4QjaBmod5rSkNhjjzg
10763	payment	1726	1726	1874	1	1	2984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGy2rpjz88YZKmPcvyd9J4cKtws22V7j1MUb21gaBjiL4XhwaQ
10764	payment	1397	1397	1678	1	1	6032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p6dKrQDt2aHh9kbhnm8qSxgSkf8J3ejuf2ydYEmFQqgpAw3j
10765	payment	1397	1397	1678	1	1	6033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijdB6rEmFbpxvNC8UG8RZ8LJTNGZjAV8NpufN8orVt6nPqyR3
10766	payment	1397	1397	1678	1	1	6034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrnLyKxn28UmGB6vFrMCauQLMZ7GZnuYwMFL6Uezmps6LVXBE
10767	payment	1726	1726	1874	1	1	2985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7f8Axf7nnSPJuuGegqw3v77Y9hfkPvXTMeYYUsXb9mq9cTDTm
10768	payment	1726	1726	1874	1	1	2986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cHhNjHp1mM2naanJL3QwBjt3rVPVKP17qsqW9L92UVy444Jr
10769	payment	1726	1726	1874	1	1	2987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Lf5hSgzZu6y47Jv4BZGQixGq1vMQHjYbHhZS3ANW6wD8fb52
10770	payment	1726	1726	1874	1	1	2988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBzukJktdiSufbWB66kinLtF2CUH6YSQmVc1GYhxrbrDYTUUN
10771	payment	1397	1397	1678	1	1	6035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo83BbbDsXLHxT5D87rAMaTSfRVVUgAgiz5UwZcBtCNbg5hPg
10772	payment	1397	1397	1678	1	1	6036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvR7P671G11XWTeYB57dy9UrxcRau4DJPg3ZVwxrcXLQfzxaZ
10773	payment	1397	1397	1678	1	1	6037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrv6nFLiVm6RRhWjNtY1rQUhHRjEbQGBuy3LLYWacBaQCy26vq
10774	payment	1397	1397	1678	1	1	6038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzkncjz2k7CTzHRHxarinZXrrW4cjtTqsR2VjnMscQruGj58o
10775	payment	1397	1397	1678	1	1	6039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pMFnFzEzo1P8JPF4K7UNbFEf2s65rJ1f8aQs858vfFzZRHsa
10776	payment	1726	1726	1874	1	1	2989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cL1FAsYt4gD6PFXbWBvoS6kn1cb1BCAsZSxMSV7VoVLYT3dJ
10777	payment	1726	1726	1874	1	1	2990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryh5AriAPk19SZpxCX2vfJgGY8tAQ4ywfp1fLCww9zp3fQ5TU
10778	payment	1726	1726	1874	1	1	2991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBMsRqECjnMPR6Vx4d3PGZ6SyN51RhGuMoyj73dchXVwTHShD
10803	payment	1726	1726	1874	1	1	2998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFF9RfEuKvuGkxHUS5Eqh31vzvvbPBcU4y6UF6MUzvATxx5sq
10817	payment	1726	1726	1874	1	1	3002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcW6zXK1Pj7PgWWLpNfCtVrZWhVUZ9R8DbUhx3CsXd353SGwx3
10818	payment	1726	1726	1874	1	1	3003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEgMm5461nZmzKF5GMG6xJjzUs8p6SbPP88B13jwQCM3qhRSL
10819	payment	1397	1397	1678	1	1	6049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByCU6cy5f6LR4Nf6hKAo8Aj5T8CjcmCt9YkSBSPYRjys4MqaW
10663	payment	1397	1397	1678	1	1	6005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHjcPPSDDbkNCyzXTyPjaxwAcAcQiyrWghr7q24t9WyHZPVBA
10671	payment	1445	1445	924	1	1	4	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F3ooqCw6CrV7yfppJdRgik9uzQzV7WA3GpAzjFaYwvq85SrG
10698	delegation	2017	2017	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEGbjtAaatFGLQAaPriy8B3jVDGFFj51DBpATefako4ue9io3
10699	payment	1397	1397	1678	1	1	6014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMpRoK1AV2dmzDdXwFxnqRH7LZHiyWHxMPY7etmfH5JazQ6PW
10700	payment	1679	1679	873	1	1	12	12834266702000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZBsha4PaHaY9Rboxc6BkVavdaABDWnVN62vLNUT77K3CCKaKos
10701	payment	1726	1726	1874	1	1	2967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkRXrRZwWyYnnJJaZiHxHG89fEBUGFRmKHS77HxBzB37a7DdF
10702	payment	1679	1679	875	1	1	13	1124978933000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaF3mV2mkynryqnWAZ1zYCN38vvpKCKHvf3Z9BS3k57Lvysxhfp
10703	payment	1679	1679	879	1	1	14	713014817000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZVoMMCBXkDWoKg337CrfKk3dsoytzu44wKzpEoMg5nye4ro6Ko
10728	payment	2017	2017	295	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumvqYUidxLVnXpgrJ7gW4XZ1fmC3o8n6sXM1VtHzQtGLFm1dk
10729	payment	1447	1447	1345	1	1	1	9145236398000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZPYELWf4cJC7vCRzg6d8d3AnDibS4SDS8uwXs7uff3o5cHy5EQ
10730	payment	1447	1447	1099	1	1	2	4864055198000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZZA4LiWKRq1zDP2CXR5ZQUohQZyWWieZaD1QHNGTxtKLe6845T
10731	payment	1397	1397	1678	1	1	6023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BYo8J5eAptrAisic3C2pbtnTrujq2VGKphPztmjsk9rT2iiX
10732	payment	1397	1397	1678	1	1	6024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuk2QoxfWNnTttyy4fJAK9Tu4F2CTZamqq6ueauwYGpjeVEXs
10733	payment	1447	1447	1219	1	1	3	3281874965000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpaBTD8PbhoRspmtt2z97vGgWNBDPJNMHP1AxB9xaKcvp4ycMTkB
10734	payment	1447	1447	979	1	1	4	2714329495000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZFpsFpuyzSnUHNYFmuZawoX7VTAeGspZ96ZTtitowmtfdEvAGP
10735	payment	1726	1726	1874	1	1	2976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKSNRC4NCZFEjrhYFR6ZVoNpniYg1Rn4ZKT7oKjpsG2o1Edij
10736	payment	1726	1726	1874	1	1	2977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rX7ESwFX9fPVBr7fPPbUYKeRGUJZJ6cL8rwN4TrTsS8dSLpz
10737	delegation	1972	1972	1406	1	1	22	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i3QYt5w6j5i7FChakW6KwbjYb5Q3EyfJRwKKCxKzm5LZNDMP
10738	delegation	1972	1972	1406	1	1	23	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyE99huHu1XP8Xugev4J8trUtqdjctA1nL9HWvCJaW8eex62Kv
10739	delegation	1972	1972	1406	1	1	24	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8qVRVEL5mdZ57daWhiMASk7Xar9Gj7LGF8yfonZh4mSwGdyi
10740	delegation	1972	1972	1406	1	1	25	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLKLQaobGA3YDZQCmabg5VZEjgU6WJAHUEx6Rkcpj4UPkh4Tj
10741	delegation	1972	1972	1406	1	1	26	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVXfXAr1C2ieLBofQ4uUHuSzNocdp6rWEvCq4HLEh15aaiEi9
10742	delegation	1972	1972	1406	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkgMjCBLrYZVHFYdYpgFj6ijESAWhcsENaaRraa331cogHx2e
10743	delegation	1972	1972	1406	1	1	28	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1PNL5GuBD9uvq4YR5gUWzodK4aAnUSLAXMNHsGuY35aR8JPC
10744	delegation	1972	1972	1406	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1jMsks9JyZHsTnRFvZNN3DZvLA4n2TBjZxmyK2PQG7zkMqZa
10745	delegation	1972	1972	1406	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CgMcEfxhGbhhuZboJBZyoWmA5ecv4g5yF4fiCAuj34mz6duD
10746	delegation	1972	1972	1406	1	1	31	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESVEZ5Q1wm5kHDsYtDjVYko7kBB2ibnk1CzZ65drkLv9Dwc7B
10754	payment	1726	1726	1874	1	1	2981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5oDBRF3jSAbcawuzKfQu9v1ZZ2mq5N1i3NSga6Tceu6zRDdSG
10755	payment	1397	1397	1678	1	1	6028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfJBy1wtnYq2Lb3jSyun7NVTziVMfxNRPtQdUPbnP8GLNm62t
10756	payment	1445	1445	480	1	1	4	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXi9Jxax2wbKUxJEZUbywL8HMHdyiS6ecNoEdCJxmatcd1aweu
10832	payment	1726	1726	1874	1	1	3010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QohB52zDgk8vnk3TPDThZxbPGdfYpF9XmDjg8SEcfBwkX9jQ
10850	payment	1397	1397	1678	1	1	6065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8PQ7XTNqRBqrdBDyBjnhv8Rfybgnc7Q16YYscCACKQRuDxY7
10851	payment	1726	1726	1874	1	1	3019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gSzFE8kFZuCf9nVQmjjpWASPSBnG4qfsPap5mer8LxNiRMGB
10852	payment	1726	1726	1874	1	1	3020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UmaenwZ1vVaAPetkg2jZRzRZn1DsXeKEp77v575MyrcRRhtc
10853	payment	1397	1397	1678	1	1	6066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gXNJimCx3mwm2mzYDTCzaXrqLisbhJHjKTgH9qnkZYQcUvNS
10854	payment	1397	1397	1678	1	1	6067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEEnV584zfqxwW7tukYNjvVUFuj7D4mquCroVCsCLHpDKNgKN
10855	payment	1397	1397	1678	1	1	6068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpsvLU9k1NbGk78n8sxr4FbQkX3vXH2mGTB1JR1EPeDzBCbJw
10856	payment	1726	1726	1874	1	1	3021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdDzn9p2hDGAKChAegFHnBzoFDgjojr8CPmCbBFcUzrQd4JNF
10705	payment	1679	1679	881	1	1	15	3089730872000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ23oD4PyGm3jZkge3aP3oYmA1kpvaitNbMryJ8d7Be2tWXcvqg
10706	payment	1679	1679	883	1	1	16	475343211000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdDZHw4iwWRPAigjJsuwcBgtGb4Cy5zLAYMicj7FmBt4ksKvDC
10707	payment	1726	1726	1874	1	1	2968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfhxDkkymBQtGSmX1YwaCJ5V1fLHXvMh8XkYbQNqsmxxK3knp
10708	payment	1726	1726	1874	1	1	2969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcudNuBy74ujSKC3AzcuQj8zU2UC8DvsGp6QFViHxeAxq4sqYV
10709	payment	1679	1679	891	1	1	17	2614387661000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYyYHwaj8hZE8J4HU7gsx7p9no2ufgvokAw2sKDZ3br3zfuFmRY
10710	payment	1679	1679	897	1	1	18	344871006000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYwG4FokSUxRfr2qtPKgcHVAs9oEUJsUmnw3VkJGXUwdGJmUbFu
10711	payment	1679	1679	899	1	1	19	205576432000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYiL9oy4DTDuDd45i842rJfZYEnZAEiL6ZUhBfmK5zZDoR6Fwqg
10712	payment	1397	1397	1678	1	1	6016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLxC92dfh4ZKAzFKcrxxE4GbuDn6SErgNqReuVpU6Hhnysu4w
10713	payment	1726	1726	1874	1	1	2970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmnjDpecvrqTCkLS8jmuMA6n1ZFExGoitA8HcA9MHvd3roKak
10714	payment	1397	1397	1678	1	1	6017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWD176zy6Un7X3hUWVMcZsd8Hy7bT4q5CBhZuhxmD9WwvJHvB
10715	payment	1679	1679	901	1	1	20	617946174000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYhotFQybu8pqsrHtFwDAMVty63zHCWQ7s5sZ6PVTgakXYMy9jb
10716	payment	1726	1726	1874	1	1	2971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4M4yiA8mg4VAgY4Wxu7Vi4fRHfCYgxMBuB16Wjm9pQWQosNp
10717	payment	1726	1726	1874	1	1	2972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbUNAgDfuDBfSNRd4EJVw69Nq5ubm8PHeo2FzAGFodNT9zR9w
10718	payment	1726	1726	1874	1	1	2973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5ijV4JhU1iLyEZPKPxSKHimzhQFASAeYF5KNgagvjhiJyRa9
10719	payment	1397	1397	1678	1	1	6018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QhfrBXhfcgRWoABoyv64FaYjT4ykqnzNdhKqMpsXoUhu3Vzt
10720	payment	1679	1679	905	1	1	21	2222229512000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZrUAG8hWGcPQFVj5ams91Uh2Rg5ov3BZExr3yiUwV8bKZK5C8Y
10721	payment	1447	1447	2022	1	1	0	1000000000	10000000	\N	E4YTcWgPZEpWk7rugJD6XDHgDHZ7FXgxDSoYtgMKSGFuKztTpaoap	Ckpa8fweh9xQK4okzJC3mGdnhP5bbzhZw68kWYNQprmxXvSbrtgSj
10722	payment	1397	1397	1678	1	1	6019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAaNvoxoUcvTjLSQH2DisELayPUABrn7N8vsbBNEjrkYYtjQoJ
10723	payment	1397	1397	1678	1	1	6020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzxDvyhgAC4jwMtoJmdCVw9VzcEUYDckXmvz4M8d9HKiZ8hvz
10747	payment	1397	1397	1678	1	1	6025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg92TGPmccVQ62JtNwJTBsM5jh2qAPz1G3bcnRe66N1ACppewY
10748	payment	1726	1726	1874	1	1	2978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDyam4krpwMy6GowTRcXZhhdsDgsi2HZaYKiCtcjgA9K75DtP
10757	payment	1726	1726	1874	1	1	2982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvNc8mBJTQWJp41tpJ1UQknyjBVUVXuNpaoxyzfd7RSgNhLTU
10758	payment	1397	1397	1678	1	1	6029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2AhX7U7t9bDkLxxAaxVPb6bgmuqncDpyPW3t8gQZQAUeAvgc
10779	payment	1397	1397	1678	1	1	6040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNF6GMbKi3j9CQLc8C4yt78haNeSrrrsSSETAG7sJ7zh8QLaLi
10780	payment	1726	1726	1874	1	1	2992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXysEH5dEusEAQqD5iTn9QveEzd9eAEc3GM9DrzyEPW1gpgR9L
10781	payment	1698	1698	556	1	1	2	419564339290	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpYnDx7gcyknV6425jiP1VCUAx4cCxMMUaugMXDnd7LvqHaLAGPo
10782	payment	1726	1726	1874	1	1	2993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8eQSSASvnLWJCCyhS8DDtHv1bMtxGECF2KoGwVLvYYmXYJo5
10783	payment	1726	1726	1874	1	1	2994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pmXxejaXyAEnQBNRbxt3221FAGmonQVykJvEhYtAb4NFQp5z
10784	payment	1726	1726	1874	1	1	2995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYptZrhaPSV9hwxrzPvFmRH4nbm8oB35irEaYdzNeQbJdEuCg
10785	payment	1726	1726	1874	1	1	2996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMXUtuZ15xtajpqo1ze5Nzq6d3Wf6Tdk7EtqsUKctzAP9N8Qe
10786	payment	1397	1397	1678	1	1	6041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhU189W5rXKC752nhdKx3tnVUqqZs2VCsMivvN6Wt5pNYReCSD
10787	payment	1397	1397	1678	1	1	6042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fUoiKHsRgYY3gYdLrZxas7FL6o2K7AgpzKcie3JK6Pbvh95i
10788	payment	1397	1397	1678	1	1	6043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9xZqPpQDWYzestxtsm3xY2P62moJY59WHu61ktahAtxt8KRj
10789	payment	1397	1397	1678	1	1	6044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjMJr4HinMWfcmQy2Eu6oQyA7UTJ2ubocxxn38EXyTZem5kxX
10790	payment	1397	1397	1678	1	1	6045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3Um5kZbDJjfLrhxnpCVepwACFHNBL1dwWvJZMS1u4F3wXSEJ
10791	payment	1698	1698	930	1	1	3	3191320140680	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZimsmjYMmbu633xjmPb5pabPqnz9MEUsCkKLmatK4SiQuRjMry
10792	payment	1698	1698	1050	1	1	4	5718818348880	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZqSuCkrTZ58JZeGDVMqbtKX3tDcJkZEjZDhJuCUUDceVQqe8F6
10793	payment	1698	1698	1170	1	1	5	3858600695495	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZQrxbhZuQCDpXNoKMh8MyCeCTrTwb1RbuRi5ywMnNA8duVKViE
10794	payment	1698	1698	1296	1	1	6	10752333925620	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpYcPMhWHvRs8gDt5tJwEPUMkhyFQsbeGSrL3ygajuPwpxr94KdK
10795	payment	1706	1706	451	1	1	6	176478352080	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpaG2kKX6Qaqe9ZGkc6pQShMQA3Dtt1Fsz2dLHjrmc8Dd54dzENH
10796	payment	1706	1706	487	1	1	7	176478352080	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYcqipXGnUtMxDv7mFRL7Sb2otjq3bU5hm6evB7jEoa2jvp5pFt
10797	payment	1706	1706	744	1	1	8	5347828843	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZN42LZkD3oL2fQoR1yKUB4hKvbNtnJ514HfykmPmChUahFGkhX
10798	payment	1706	1706	988	1	1	9	1343486499270	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZv7UXfT4gfJ1ixCNFREw2eorVq6C7ioyWNPpLidxWA365ugGWX
10799	payment	1706	1706	1108	1	1	10	2407516295700	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYQhToNc6wDS8iaxxsHQRXdbovNpf7UabEg9ivdC93Pu9UHCwqG
10800	payment	1706	1706	1228	1	1	11	1624399217850	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	Ckpa4vAbxU6k9XWKx356DdpQZDiKU8Z8j3KgfYv4DSX2JxcYKCJ9K
10801	payment	1706	1706	1354	1	1	12	4526532854100	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZc5boPEwh1xNoqK2XWaTAHCQsJMTmMjg36wozXgLaUP4WtKtsz
10802	payment	1726	1726	1874	1	1	2997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJR2u438z79FN4mz5tx4kygjNYJpTs36FKAZaDHpjfv5GdAWjp
10815	payment	1726	1726	1874	1	1	3001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5B1T9Km8c7TdFtbJMEYoozSvdU6XucBgJoAh4V5QsbFDWRV5
10816	payment	1397	1397	1678	1	1	6048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNACV8adC3ATbFcaZGkCipzd5GGrRyWCeaH2EnHxzTTzJuEDd
10823	payment	1726	1726	1874	1	1	3005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvvJACrtnbXBUb5v95ZquKR1LYLhn4oZrbJcYL51PQzs9UvUh
10824	payment	1726	1726	1874	1	1	3006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWa1CLxmiKDuu7r9iByChFULcZLWUgfVowSV3PkHu8aEKn5EC
10825	payment	1726	1726	1874	1	1	3007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2oS7MZCjLDrtNTeoFpwyhqULHMw5dptoytDYAPGgfzuj189z
10826	payment	1726	1726	1874	1	1	3008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKSB1RqNNvZdoajZWcZyensKzrBCAhdSQDW41PSeuhRDaiiAE
10827	payment	1726	1726	1874	1	1	3009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhieRkC7VF5YkByBQXQVWtGTHsjsefo5cNBjeUJDmyncGZYeHZ
10828	payment	1397	1397	1678	1	1	6052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBcskQZzjTeLtsVJ9BcJUt3u8acsoHhdka5hsNrB4iFcqbc3H
10829	payment	1397	1397	1678	1	1	6053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVVXATFRoPPf9xH6TP1K4Px99Mme9yVVLgf3Cgx2JqCHx3HEN
10830	payment	1397	1397	1678	1	1	6054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9kz6DZ9UYmNpuAaoCoyJfw2yjpyGjazzhD9vD7c5f3GTD85n
10831	payment	1397	1397	1678	1	1	6055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UG64Y5tn46aeXvaLhCHq4LzVCZzy2zZVn9vKwMyBAMqs1DBu
10836	payment	1397	1397	1678	1	1	6058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4z7EvRiiW75ZWaocS64AddueKHEjBVirgPsxHH95zLvhNcpCp
10837	payment	1397	1397	1678	1	1	6059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzf48A8yYuY3b1EbNqV5gx2ZhxdoiA3cAbdr9rMzyrBVhN27UL
10838	payment	1726	1726	1874	1	1	3012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DWkoNFGTEfgjDDuw6DQqaHgAziS9xuUesgw9H4WNawLFtmCn
10839	payment	1726	1726	1874	1	1	3013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8TkwhToR36JB97eeVYKqdZYsxDoAdJ1yc8Cb92QeLS1gwwsr
10840	payment	1726	1726	1874	1	1	3014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqcAhKAnfZcE59hkzHZvxRepMwvuV3qeoWKpnxRL37YHtYL89
10841	payment	1397	1397	1678	1	1	6060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdidHVWLuHPL6Kv8QT68i4L3D5fGjqpPf5nh4SUN3yUbSNdqww
10846	payment	1726	1726	1874	1	1	3017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A6xRUCDVvdFMpJJtfVuAsdhsiWmnftPN1NuWudLjVWVe6YBp
10847	payment	1726	1726	1874	1	1	3018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTzbakBchRmHrRzs2M2iHAJynKaaxaw3H2FedvJ5XpgteRQhp
10848	payment	1397	1397	1678	1	1	6063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAfRnBZWJcoUCak7YNdnEZbWDCod5n6k2rzNQHNnuYEGD81fj
10849	payment	1397	1397	1678	1	1	6064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWv6YpcDEVyRQc8mvPPw6orjMB2JWwq6dXYKHQ8jeyZBUCkGy
10875	payment	1726	1726	1874	1	1	3029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2bPL6fbCpG9gvw2T3xEHTC4NM11J8of5EB7Ci75X2frvoF8p
10876	payment	1397	1397	1678	1	1	6076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBB2cC2hZs6dosVs7VWyCcmSvqm86gTyVFLSUSkeeDjN7YLgb
10883	payment	1397	1397	1678	1	1	6080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqWXAFUUTaadz1taY5n5TkV7Yvz2jGPhKziJZXDTWNoCVmWu6
10884	payment	1726	1726	1874	1	1	3033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcZSLK6REoshb4c6gcBLSXMq2BbJuHRocagQ8ma9akRp1Ni35
10885	payment	1950	1950	2025	1	1	7	2000000000	1000000	\N	E4YXWRaJBCzdEd6ib5xAheNcDa8FjC2Az7XLerCRrdxBAnUiSBbRB	CkpYhH3CEqobnQYvdPz8xkeon6bxcFzddpX6co2HthxhMVXHJYWxw
10906	payment	1397	1397	1678	1	1	6090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJUJ1QSPgkgM9JFphZQRs9HpSHMnAxn5ccwBRsB5RBsb5QsHY
10912	payment	1397	1397	1678	1	1	6092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQAAgfv187TRCAjCRBFr55dtdHHN6nfyuKMzTpR96jGeY612r
10913	payment	1726	1726	1874	1	1	3046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoidpKS81agfdkGeW3izrFuuX86PMspypnR9oAizgozPqNDngF
10804	payment	1706	1706	451	1	1	13	129405854012	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYu6xXQGTM8zewGaP13rFMbQa8TuWGmZ89MLq5QUFKeaGeRpFKb
10805	payment	1726	1726	1874	1	1	2999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsfVGnEzuEt8V6od7fWVhKc1EhTcarSMVy62umPm95ASJ6LQH
10806	payment	1726	1726	1937	1	1	3000	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYTvj1BSDLGXbYC2CeSHQbkESUWUPGdgKZHnYuzXs3m7N85veNm
10807	payment	1706	1706	487	1	1	14	129405854012	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZbjEiKb6eL9D9XQmoodwv8cEDy9UvrVVmNq42yxDWrhwEXTHCU
10808	payment	1706	1706	744	1	1	15	3921389510	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZ8qr3sC4AgxHAbUNhnZVvQE2yhHghw8WLDbMxcqTYpUko7L7xR
10809	payment	1706	1706	988	1	1	16	985223432798	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYeQBZ7j1D2EJ3uCh4Cm5ZA5vpC3gXGm6Pzux9A3EqviP115nHW
10810	payment	1706	1706	1108	1	1	17	1765511950180	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYgnMJ6pexgzNKTd47vebkxckY38UpNABgCF84CeSjRCx56hc97
10811	payment	1706	1706	1228	1	1	18	1191226093090	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZq17Kumwme8VVsQFT24faDNA93q7nwzNBcCesZAffBiYZnENYD
10812	payment	1706	1706	1354	1	1	19	3319457426340	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZhGQqHxQtBQMBurN8RXiqmy2B4PcAwCpUNbeVZWTv8z7yGh2LX
10813	payment	1397	1397	1678	1	1	6046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmt92cAQ81ZCvCbCwzcH83FYaHKibJEWbNDmP91aWcfsCYj8m
10814	payment	1397	1397	1678	1	1	6047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZH2NfTiN2gj7VGLXZbf7jMgw3P8U9vWTRTNckmkQfNvGsxuLw
10821	payment	1397	1397	1678	1	1	6051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWY3FSKWeX5V9sTxYmoANfgGVboA7586uuExb3QVBd8STju1jL
10822	payment	1726	1726	1874	1	1	3004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PrV3PGNyNQcCh36bfNgb8mQMjWDnzFDyJvnbkRawS3kivoah
10833	payment	1397	1397	1678	1	1	6056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWp7HTvH8f7kpu8NqMdU7dXudgSByCRRFMLeJerZghArtAXRs
10834	payment	1726	1726	1874	1	1	3011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLVGmXAek2JNT9sgsy3aTDLPAgu7PnhBtuxuwyAZC2jTbi8TA
10835	payment	1397	1397	1678	1	1	6057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVzsbiEBAK9ApWNX8Na3ijTDrXvwNERC2x2AhUPwnygHUweYG
10844	payment	1397	1397	1678	1	1	6062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKbPieENN2GYeK1gb15rTz6gLSqXNhXJ4ZagTh1twz1fPBScN
10845	payment	1726	1726	1874	1	1	3016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk96dQw8EjRed42YMhJU9TebkTHNCuC3qzzmW9gAcEhVKBX4ur
10866	payment	1726	1726	1874	1	1	3026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnFuFrNdCeGmKinfzpevVSXyDGueGNtza8TNw3feKDouYhpo6
10867	payment	1397	1397	1678	1	1	6072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVYxYMqsWExhA7c29by4yH8jXT4XEEtXo6NYJnLn9T1VpiBzU
10868	payment	1397	1397	1678	1	1	6073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWw2iDFHWSo797jGMexThn6jpL1woiSUK9qNydLBG5sPY74234
10869	delegation	1740	1740	563	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrUR3biNko84t4BqEWymKxboBV7rRFBFDfkvrfXF8vsV4pstD
10877	payment	1726	1726	1874	1	1	3030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbNDctfP9HC6DyoHipZhhbfRN6vvpKkzrYt9Qg1SRH2PvuM2h
10878	payment	1397	1397	1678	1	1	6077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiuX5LywrfqkutZNogUQq5Kr5TAY3VvczrL3UroyJucGqZbw7
10888	payment	1397	1397	1678	1	1	6082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeg1nMhQHjsqcnjWzCy6DsELJ7p2HX7HrRc8Kdaz1SV1uBJdy
10889	payment	1726	1726	1874	1	1	3035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdkZeYQxUKoNwB3HjQDgnhDx9hBEAsneBHFAQ1x3QDQfRPKaN
10895	payment	1397	1397	1678	1	1	6085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEchfNsVJ814SeVsBM1oBsg4uvDCv3g3fTEdxFZ1tNKG72vQHn
10896	payment	1726	1726	1874	1	1	3038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQnwxd64cPZSJHnzPicAH8Ysy4n9SQGGuHyhvymSpWmFF6aou
10897	payment	1397	1397	1678	1	1	6086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPLmwF6fbNfYXFPpV7wUkEu8Fs8BnQv9StiB4soTN3UyZaVXA
10898	payment	1397	1397	1678	1	1	6087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbtyAFTBLE3bUd4VXvq3ZBZNifB8PFAxzE1WiPdgXSEkbXoJ6
10899	payment	1397	1397	1678	1	1	6088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGrZx8W4u6QderHSGkWfkgwmHA8cdJiRxcbiZc6Ekc8wfrQhj
10900	payment	1726	1726	1874	1	1	3039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMWgpzNBsXLzKu7oESQVesPwS6U6RnGnTAh424exA4sF9rPW3
10901	payment	1726	1726	1874	1	1	3040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7AwF8DX1faE9urwGjZM119Wu3AtmWg3mVxoidxUeRV3YvkUg
10902	payment	1726	1726	1874	1	1	3041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpsecL2x2xFYGHFmGdMqHAtTJvEBb7RUporBUDT6zcZ4xyFqK
10903	payment	1726	1726	1874	1	1	3042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsaAefCs2xreiYfotzwa3WGymYNX7TAL7WyKZUAD4cWEWt76N
10916	payment	1726	1726	1874	1	1	3048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3EMKN61LeYrtWYTYJNpraT8JpyBFhpjtWufhb5GXftewB9Hu
10917	payment	1397	1397	1678	1	1	6094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZVRGHvJDbcPbJxUR5FNq25uDs3CJgAK73vBHfZURJUvngFPb
10924	payment	1726	1726	1874	1	1	3052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqDeho8TzCCBoxMYjR9YgqWfRaU1X87eEtn8zuxSXT5bnZTiH
10820	payment	1397	1397	1678	1	1	6050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoTXXJxik8RYQdZMtHj8gEA6uymLftx2jk251ZzkndyL8HNof
10842	payment	1397	1397	1678	1	1	6061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKx2fA8MKZowkbq8aMxZL4fv9iWPJbYd9Y7yW1yA8BxGhemAB
10843	payment	1726	1726	1874	1	1	3015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9bQRQg45Ge5gz3R3mriS322ciPVAKZPkBmd999v8GzwT24FR
10858	payment	1726	1726	1874	1	1	3023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBe8TRzqm4ZWHcDuf5QywNtsBswXhMg29kmsuNdG9FCrFbZRiu
10859	payment	1726	1726	1874	1	1	3024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4h5JKgzw7RMJkBHEBWcQNXrpgHi8cvpDuJbPsdDpmBnzjhcAm
10860	payment	1397	1397	1678	1	1	6069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxwqkj2sXkKjUq7urhwLQugC67UaNjSBdNU2kodwic9P4obwC
10861	payment	1397	1397	1678	1	1	6070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLFy67En4B5BVk6jt6Ep7tTMdVU9y6p4yE3RoEVdd2ndvjPkQ
10879	payment	1726	1726	1874	1	1	3031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7Sa9T6wKUXCHGonQFfkw5XLc3TdxBnY2pX4sGm3Jf2xVADNe
10880	payment	1397	1397	1678	1	1	6078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjz5vTmDjSjEKiSFdxMTVJP4Li27BLkNi4DwKXiBpK5Ejhx5to
10886	payment	1726	1726	1874	1	1	3034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qkgWUf8wVW65BmM7P2sKeW3YWZgMFHRusiUEfG3xgg8cBcvM
10887	payment	1397	1397	1678	1	1	6081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CQbSmXeyUyAFEhr2ua75P5aoP9KURsMnVj5gLtk8yAtBnP7s
10904	payment	1397	1397	1678	1	1	6089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmqRpodsgDtRkjo9ssT69fPZP9Ajyao8jBRVufT2UGnzRN6Bi
10905	payment	1726	1726	1874	1	1	3043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvY11Q9X7KimQ5wtmh1VbqazRGW1PYGjWi1UuMnct6KciCBtT
10910	payment	1679	1679	887	1	1	17	1418704594000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYzYLk6Vc3UqQc2KZMoGaDHTLSa7PRMJRfja3BBJPs1DxqzyscE
10911	payment	1679	1679	889	1	1	18	1190926465000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDQKLG5ARJgQSNBHRn9RhM8XjbDJG5P8B2ZHWQhcfbE1VG1tWS
10914	payment	1726	1726	1874	1	1	3047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ55DP9Lod1EQDYWx5DYLEt2EmL6DvYeecTZ9ERLi7585C5ra2x
10915	payment	1397	1397	1678	1	1	6093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhGYoc4z6nBtkUDhUk5k36eC4W9mbDkY9zCHXBJGLtQYLWSSA
10918	payment	1726	1726	1874	1	1	3049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZar81XnZbxsm1xJjMQ7NCSUbqC4sigkpDqL5uqcK2ze23wJzrH
10919	payment	1397	1397	1678	1	1	6095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmf43apJYeuVgG2EnfqTQMwLyziDrgCDfGahbsZiE6MTNkJ7kU
10947	payment	1397	1397	1678	1	1	6110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96TuCmXAwxoAxmPm1nWQoW2t26yDu7Ex41SeWQnBCkL6D5jkH
10948	payment	1726	1726	1874	1	1	3063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwdy9KWQtEFrU5wMwyk263vKSsfTM3TqVb98pSBmsEA2TCyEN
10949	payment	1726	1726	1874	1	1	3064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFEYg7nzsNzzcwA2vfrQvcma2S6yXSMKJyCE1RmpGDjBv4dQJ
10950	payment	1397	1397	1678	1	1	6111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEiB6oqxMx1vokvwZkruGN1zUHxSHy5iyYAYQ8sn1qwt8nGPs
10971	payment	1726	1726	1874	1	1	3075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVfco9koKPuCKvfQ8i7wjyKTg5b1Jq7424rQp2npcK29tFxBU
10972	payment	1397	1397	1678	1	1	6122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tuLnouFDeguR9m87Edv8mag8hjeAVsNFXrj4B3SFikasZfwn
10979	payment	1397	1397	1678	1	1	6126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9KzpG89eFtcP5ALUm99pWJYSmWXhjwHLNDPj6GhCxerFYJKU
10980	payment	1397	1397	1678	1	1	6127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3SejM6oubAfxMxLpUynFCzQg3qtzyaURZJjRPvxiPDw3UR9E
10981	payment	1726	1726	1874	1	1	3079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAXAZghVH5cY2xDXsfxaHHhgky5dez1aedCDqA4M5Pv4nRdW5
10982	payment	1726	1726	1874	1	1	3080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KmYuRxW42Sf7mwQaJAiTi7p4sa6EqV8HKzvDdmFVnLU2gyJj
10988	payment	1726	1726	1874	1	1	3083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzj3jSb9h3ZDgNAVrS5LuEieJsKoNGTXk2ha9NNBptiZwsaKDm
10989	payment	1397	1397	1678	1	1	6130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW1hNHSB3FuNAcBsSryfbq8Lo6Nde9S9X7HKWe6cbeoDofcys
10990	payment	1397	1397	1678	1	1	6131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmDuNcHEfuVEzvDZHXu4A4h2QX3PCeVGUTvT6sbN5doS3c8re
10991	payment	1726	1726	1874	1	1	3084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8U2jtkQs31c534k6oWjMKT9Gaanwtxby3QoHF6hR5KK5Ezs4G
11004	payment	1726	1726	1874	1	1	3091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSE6HXfY62VWjSXRVsu5DDB2BRUXorjV9aBTNsPArN7XCKt2d
11005	payment	1397	1397	1678	1	1	6138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwi2H7dRoEEr78QLzY6qjMoYHzvryj4oYWG9wt7dVK1X39YYz
11006	payment	1950	1950	2024	1	1	10	829330000000	1000000	\N	E4YXdUHAxeJfL9JRVMhPb1wea6gwWhCBaDYbaEv2S46DKk6hTxrmv	CkpZgA7RoBCBq8hYiXWsy8fYuL3KLnM4iwzckb3v5QzKSgkMCjN7B
11010	payment	1726	1726	1874	1	1	3093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVAFHsjYpfsn4zsEGVu8x8YdH3UuGshXKrsYoYf5n86h6K49J
11016	payment	1726	1726	1874	1	1	3096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiC4HgzNstPmty8f78vvFhjXmWZamwpKiy3HLn3pCzVKENGHU
10857	payment	1726	1726	1874	1	1	3022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8SEztopmt969356VcqW6dEDCGt5rTyhe2xgUxHHfBrQ22CGCG
10862	payment	1726	1726	1874	1	1	3025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqbNDZJ8hqcSFdPGvzpXkpAtsUXiBCvQyKgrWQ3y4Qcbbeq3j
10863	payment	1397	1397	1678	1	1	6071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnEdxAY8Xawfnr4JQ1EnQs8S7pVwGLiwYRdzsY1WFyB6yUDKeJ
10864	payment	1950	1950	2024	1	1	5	2000000000	1000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZkvfS1y7Q2uuMHwiET7bvhF6MGJsozdZEGjm8d3cqnt5aMFTSt
10865	payment	1950	1950	2024	1	1	6	2000000000	1000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZYeoQzrVD9b4iKG3xM9cMkLTCngaUexVCFo6hMaepiqs9JJBvb
10870	payment	1726	1726	1874	1	1	3027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPruyux6mmaKUH3meBYrNuC6zsbKbqp2BNvyfnmQtyKEybxem6
10871	payment	1397	1397	1678	1	1	6074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSQvpPKeX9ycD3QW6rvW1iv3ZuPmBCDEDC5iU6snoHWXTM3Cn
10872	payment	1397	1397	1678	1	1	6075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YqpgPqkKfeHDVMqHm1C5mYiPyor3pYx49871Xa1SyswJuA3S
10873	payment	1726	1726	1874	1	1	3028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtBQcs85V92Y7Q3z496RgF2nA56XEQzPGy2VtR5JJHYhG6mK9
10874	delegation	563	563	1483	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVHZb2LGKFSMU5mRfs2F6yh3juPtwsRyiwnpvXpEtcNHt83eD
10881	payment	1397	1397	1678	1	1	6079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVp8BqvVVoP9BiEYusdUCPdFienKJ2WWFi8332ipNCGVoNK2VA
10882	payment	1726	1726	1874	1	1	3032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcwHQ2wiPhc1pRW5A233pnkXHUmnHHNy77B7trjNaaVdSxzJQ
10890	payment	1726	1726	1874	1	1	3036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHs3ZnbxqCuBfPdYwdYPG34Mfe5nWwamMkRr9iLHqKFL6NNJRY
10891	payment	1726	1726	1874	1	1	3037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvrWKdz5Mo13gYM9qPhuGNiFLEd4VwCeKN3H6YcD6tEoGzRGB
10892	payment	1397	1397	1678	1	1	6083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkuJRJmQFVdZB8qddQuftGHuXKZohiCqbofrvCgurDKgnVdwv
10893	payment	1397	1397	1678	1	1	6084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnkhajg5ByFwjcjCvwi99HTkFFe863FrZpiZtiPkVSi9sqfFY
10894	payment	1950	1950	2025	1	1	8	998000000000	1000000	\N	E4YXWRaJBCzdEd6ib5xAheNcDa8FjC2Az7XLerCRrdxBAnUiSBbRB	CkpZP7N7NVANLmVeF1nybn2UMqVE4LkxVjprKKzHD9EbtSFKkX5hn
10907	payment	1397	1397	1678	1	1	6091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLV1rTTqudfkcuepesqfa5VUQajJWGFFoLy3978hENa9DxYb3
10908	payment	1726	1726	1874	1	1	3044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdNz3RGTq5arGrUBfjc7FqL7pro95rYSdH6fJDy7NsJ9RTz4i
10909	payment	1726	1726	1874	1	1	3045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggBRMQ7VH6zHh5Af4mCz7ibekc9aMUvdssD5ekjWnAJ7Lzn9y
10922	payment	1726	1726	1874	1	1	3051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecqJ9L5thvDn9BRKm4SeBPrdQTP9Fr6LwGNTCMDZUZUvgzN6q
10923	payment	1397	1397	1678	1	1	6097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dXohkH1dW9mSJahfZXAUFciizoN4X8v8mgoMPwBMgXHoRgrw
10929	payment	1726	1726	1874	1	1	3054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15YZifjPt22BWotmKW8M6YpRxFWssvqR8TYk4HFkTYCtz3AY5
10930	payment	1726	1726	1874	1	1	3055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1hfwY5nG98wW6Dts35z55v49ScKAtTRWTLfZV8JVCnwnuhng
10931	payment	1397	1397	1678	1	1	6101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HJbeyGvntGSUt5Q4Q5vc5mWMgPUCT5d3rbxZ9RASq9HkWgZ3
10945	payment	1726	1726	1874	1	1	3062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtSCcaU4fuQxM33QYv3XMMm1e2CrNu2frnRUztht1B4t7JJek
10946	payment	1397	1397	1678	1	1	6109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3K53WBCFfNAL1JoZuZLs7PxyyuABRsDSxfCvcjnrV5Z8UsQLG
10951	payment	1726	1726	1874	1	1	3065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRBiCjd4ZYHdP7n7pnZtWVuo2LPBWo4H2jeGPtp4PxnfNmQSd
10952	payment	1397	1397	1678	1	1	6112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbtybxsu9pyGhkUqJ5NSkmLxbhKK53yYkE7CcSGUWn6Sq4pXc
10955	payment	1726	1726	1874	1	1	3067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71N4eECFpAGsnig23gBXuDhhXLt9PNZPGPrizYCJUpGbZnYZ5
10956	payment	1726	1726	1874	1	1	3068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQy4jNVxoQBhYSYqey29ZSaEcbTrTimcAbbp6f7cDm7cWKcaqj
10957	payment	1397	1397	1678	1	1	6114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCdVeYJVoJEHsSMgEXRhSAoeEzKwvyrFcyNo6JHDZPwBAQwBX
10958	payment	1397	1397	1678	1	1	6115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyB59i57MJhHPhWBuVMfhsb5fDsxMQqNwSfc86nqkArTctdhp2
10969	payment	1726	1726	1874	1	1	3074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWCawr6aa4EjmcnfvCgGExYYX4YTTmGoWBbyBL5i1QgLPn8JP
10970	payment	1397	1397	1678	1	1	6121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxL4z9a8zthpfUnAnj8bmRdVKe8ReP9qaBauLpTYxGTWgN7CQ
10975	payment	1397	1397	1678	1	1	6124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntxn7zpyAnmZUarcrkBRF8JsEU8uz3NeWRShhmnP8QyASFjRo
10976	payment	1726	1726	1874	1	1	3077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEj43FrPchMkrVfZ9VsZSbqssBcGNtm4AkxWXvxD4rRtdek5xa
10992	payment	1726	1726	1874	1	1	3085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqLbKkFxvax9FvwUGW4KUrnuiyWh634pbvJBWJ4tWQW5F9oWt
10920	payment	1397	1397	1678	1	1	6096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1B9fzfTZvvDy1bNM1rbX6Ch9Vf6Z9QKo58iGjMPS6aHBm4WU
10921	payment	1726	1726	1874	1	1	3050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6XikHZqP6csGL8GPSSK51JbHQvcbumWAo5V64Ywwgr8a9PrM
10928	payment	1397	1397	1678	1	1	6100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UUhQwmHRH82pTuDeVHqHgpQE8KeRDsrm4YwgJdqKnr2FLQ4x
10935	payment	1397	1397	1678	1	1	6104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAphkmp421YTPxToN4JjMFxdTkJCQkiopv5v3wdam5eEE2buA9
10936	payment	1726	1726	1874	1	1	3057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMH5XpbcNtoYrv9o83TLF9CdDwev9KZ8grqKxWLJdb75dQnaZ7
10943	payment	1397	1397	1678	1	1	6108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6awkUknfibHtrTqsZ664T5C5PGeQ3NSTjRSfw7C1u9ey6AMv8
10944	payment	1726	1726	1874	1	1	3061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAX6gA9tpCTQ8aoyhYgponkqdNop6ChwSeMYqwyRybC2h1tLzW
10953	payment	1397	1397	1678	1	1	6113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwab6MS5qcqNCuUmBCrfYchhxmqjNe4Vc9rrA86HWnMgbxMXZ
10954	payment	1726	1726	1874	1	1	3066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYGeX1wwu9B2oczFvnHiqb6tqXxYwnD3yiFVgviRNEWPNdx6Z
10959	payment	1397	1397	1678	1	1	6116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPN9B7GQgMKTKsuAcAqG764aLVPQg2B71ym7YhzDsi1aJiWmv
10960	payment	1726	1726	1874	1	1	3069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuhe1x2m4kQizzYVVj12KJNEuECBxUGLjVJMtpZXyXt1mDRvR
10967	payment	1726	1726	1874	1	1	3073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRGHvU5FuNs5KRVCV65d9Phyfeagy4twQ26K4oMEGx9bAtaWZ
10968	payment	1397	1397	1678	1	1	6120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL79txDeqB6wNqANwG6x4uT5kPwoaywscULSVm6hmGCo6ErXaS
10977	payment	1726	1726	1874	1	1	3078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDXekC6VPNMoxfqJPENdRLETZ7RuV6JKLhVtwo4H2bHsS4GLM
10978	payment	1397	1397	1678	1	1	6125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVk3Lv7KHHXTSanLr9SUhC51YNCbSJvJBH5ihtLSaoT4osbdo
10983	payment	1726	1726	1874	1	1	3081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyTeDMoQSuWs5ajMdJEipLxejMYekJvTCijsidPemibot8Jbv
10984	payment	1397	1397	1678	1	1	6128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYTC7aFenn8YLBXLNSUaU8K4dPFHU2maLMpppjbps1W13fJBp
10985	payment	1397	1397	1678	1	1	6129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eLvocfjBp25bztyb5GC7kTCb8n2fZyZGVX1rtzHBkGU4R893
10986	payment	1726	1726	1874	1	1	3082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQbUmAk2DwpQm8LDZqodExYcidjBPgZadvLVUMCg4aBVtRGsn
10987	payment	1950	1950	2026	1	1	9	76200000000	1000000	\N	E4YPfJZR11vjzDPSVGMhvtwY2HBMhRC2S3f9heZFbKLdvFfJXpSWB	Ckpa57toqW31MJcscGY6eqo3LU9hPxs57ZcTgEqVUD4bvSy28mi5p
10996	payment	1726	1726	1874	1	1	3087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZGsYpWewGGgQt5j78mcUC1QKJJhA5tUkeJfpvnLGdVcM1AXE
10997	payment	1726	1726	1874	1	1	3088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHovpbGevQ8BqYjqMv6QgbXjyAvesbgrAFRR5SaGfBwjJMiDHo
10998	payment	1726	1726	1874	1	1	3089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxm242E2M7ewTHgnM6PKk4c3FzJXjBsTe2wCdS4k6g6MLfCXN
10999	payment	1397	1397	1678	1	1	6134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdBQYYtgTqBqLB3hq36sSRtWzKYTvEA4trmKX6QdSuajwrpYK
11000	payment	1397	1397	1678	1	1	6135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFU1jPdzEWj2GQiJEaqTD1i3DP5TwBgrLrwhhHpnNsTgZjvt1
11001	payment	1397	1397	1678	1	1	6136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgYLbMc4nXjb2YF6YNwdeC3XW6cyfBdfMgkpTnvjqVqH4zKni
11002	payment	1397	1397	1678	1	1	6137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb46GsFQhtZsjUTUqvJutFa3gFbdgghQqNVpQNx69EoY4Kn7s
11003	payment	1726	1726	1874	1	1	3090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMC6wh7sds7x3sgLrRVTmucQoksvSXgtrmyAJEGbi5Pve9gvtP
11009	payment	1397	1397	1678	1	1	6140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEgECPcvCeKxrPwMnDHsk6dCVW3USJF9E9SzXWSv44RAXUj34
11030	payment	1726	1726	1874	1	1	3102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eHu63UFVrkLBPiMW9yxCnnzkSUCckbucmDaMxwLb97skLYWf
11031	payment	1397	1397	1678	1	1	6149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYCpNpmDwjuhJCSGpFCDJfTYChrXsWqUbDKbUsydPd5oEnteo
11046	payment	1397	1397	1678	1	1	6156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3eYna5L5BQ8t5UAb17uomtMhgLQCbkmNBzfRHFGF3BKSePDJ
11047	payment	1397	1397	1678	1	1	6157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRQTyzFcVdpEEkQVA9LoiNiYZyXJD2x636i4g7G5HPRWr9cCr
11048	payment	1726	1726	1874	1	1	3109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvUoYPrBEyDGmkZhegqPM2NeVN1yoEBYG4KTP3Hzp9EAFCf1C
11049	payment	1726	1726	1874	1	1	3110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZojs4zPPNpUJ6wyLEpYdpkqaSWrZ3s39pYx19yAU2xrdERw1
11054	payment	1397	1397	1678	1	1	6160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnFQKqRQuHjiFkSrCmK2n2S5e7hRBNnaXniUfk1ybbFRsn7bJ
11059	payment	1726	1726	1874	1	1	3115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsouQPfYY42a63Lt7hf82LhPtwTfKbQvk96pNms6Wm8Z9CWws
11060	payment	1397	1397	1678	1	1	6163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaHXeEt7QiYd1fknRmgzp55pTkKCPHCWnbtRLSLcbEAQAwAAb
10925	payment	1397	1397	1678	1	1	6098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKhFNxLfj3sRSqLhxLQPueddP1ZQYwbGxxGhLqbsndN4Qq7ZL
10926	payment	1726	1726	1874	1	1	3053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAGkQgaGNeikjiZ4JQ7sydAMjuMhqkrmAg85KNer67L8MdtyH
10927	payment	1397	1397	1678	1	1	6099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8fj7ZAty7mk1cb9gTqthuriHBHPd1AsWqjGt3FVywhCa9vzz
10932	payment	1397	1397	1678	1	1	6102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVocGWeUWkBsDSczGq2gd8kqvokoe6hP267JUDfTU6yM7yAKj
10933	payment	1397	1397	1678	1	1	6103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBTxQwog1QEioHfGB9pU72vDjraM9RuEbs7PJCVLxt8n7Bpic
10934	payment	1726	1726	1874	1	1	3056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprDsw9zwLCTJZffTRyh28Jv7wRBFqHocK2aBeihNMAJYFrgXz
10937	payment	1726	1726	1874	1	1	3058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnavcV3n58chqYs8NHzsZkWUwyvVvVEaLLyKPfkbjMUMRDUgXZ
10938	payment	1726	1726	1874	1	1	3059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuqDZVKiLPVwohMEBZGrKTQ7yuvhSJfr96ijP9ALJJoSW59G4
10939	payment	1726	1726	1874	1	1	3060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdVtTXNRRwQLPUamBMpskhvSPzeLscCB1iZ5A2WcxZidqF3Vp
10940	payment	1397	1397	1678	1	1	6105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGUWmETXbnhLTEewxt5ee9TFGaUyN6TQBNnqopEzLjNt7rczC
10941	payment	1397	1397	1678	1	1	6106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ49vrYP1yn8MYGVVtMeGco3xs24qNzvQgKqUhgCjUxatd91q
10942	payment	1397	1397	1678	1	1	6107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyY47uEWJf1CSSV3gkJf8B8rsYJgiixkqZZqL6FvwjCqnBAMT
10961	payment	1726	1726	1874	1	1	3070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbhuKf3UBxsDwMxAFoWM8cQRZaDP6wEnKns7jPuU7UJKcWqt1
10962	payment	1726	1726	1874	1	1	3071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15P6m29yto4bucB3mQGeMi1wQcSmrB94dY7iiae7TRuavYymb
10963	payment	1397	1397	1678	1	1	6117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2EbJmLsFT2Vk5i8fiADuaYnKQNA2A5UUA1brZekG4kuaXgKb
10964	payment	1397	1397	1678	1	1	6118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKea4HbQHcr9yCoH3ZcAHp6aFpPQEKMRzCGWpf9VgdE69YQu8G
10965	payment	1726	1726	1874	1	1	3072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY48rGcUGyxKeWSWkwTLke42tqaGS91zhEd8b42ZSs3uLowQFP
10966	payment	1397	1397	1678	1	1	6119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUWkis3UxRTdYELD1nk91WAGWVPwd67w6coRxxbc1VQSv91He
10973	payment	1726	1726	1874	1	1	3076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWpmdZrZzwn8WVRgTbcA2ejqUz4w3y1GVnVkPdB2aKst8Yi96
10974	payment	1397	1397	1678	1	1	6123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk7MUCKxRX1wkVVkLs9dhnv9aSw3DDo2K7vfRMmsQEnmsCUen
11007	payment	1397	1397	1678	1	1	6139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpSHFNkUJRY9NoQkhLZ8sG6M7rgVmZHJChHG1EdQnQg3CRySw
11008	payment	1726	1726	1874	1	1	3092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhyVZk5WAUyjjm8HSWjsRmssNaSbfdmmuX24Fj9XwtLBMo45k
11013	payment	1726	1726	1874	1	1	3095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuS4tExXM4aHUDDofn8X1hr5Xj1ELbQCDZhWXmx53hbayoLKT
11014	payment	1397	1397	1678	1	1	6141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTtprXJ6oP91adJNJNdzogt1oeCikXujYkvvi59vfCe5sknty
11015	payment	1397	1397	1678	1	1	6142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8SdxgubJGgfPPzc722xLRzq5vvBWYaNp21pGMkijpXgqyqhv
11025	payment	1726	1726	1874	1	1	3100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRnSvbg5MJRTtPJoDddmg4v4S3ah28dUmEoCC6jfpV27D98mD
11026	payment	1397	1397	1678	1	1	6147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTtUFr7BBDP9awawPXrZsbxetJXeZTPeA4JFCY7TTjnjP49dp
11072	payment	1726	1726	1874	1	1	3122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkWBwju4Ems57CAwWuUa1MJiJyaakM1VFo1Rsjf4keo4dbCyU
11073	payment	1397	1397	1678	1	1	6169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSe3fTCRfdYS131mvtk8mSr3kzfPStE2qu9RnzSEnsvD9Pgtf
11080	payment	1726	1726	1874	1	1	3126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFVhTGMhdWF3rqTZAR4tbSvi9xqhsFGwjpVFG8pF4LyiB3s43
11081	payment	1397	1397	1678	1	1	6173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNKSCvzm23oxwYv6vrxd9bA2xEsG2KEhHevmuwpLQe3qiYNu2
11082	payment	1726	1726	1874	1	1	3127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48bg9yrsVa8zVcSfGTHT6wz5b1owj9KD3xJ7xMKz5KctWCeS2
11083	payment	1397	1397	1678	1	1	6174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBUkgBXhjLpwNhk165DGA3h9LSVqKgEy6iFBPESfBxswyvEy7
11096	payment	1397	1397	1678	1	1	6180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dGzCXeZeXMrF6yT6abrvYipharRAT7h9yzcHPhC6YdUGAbas
11097	payment	1397	1397	1678	1	1	6181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCwSnBxNDtbWDWuvVh6hge7avArfjqAwgvif2cnWc21HsK4R6
11098	payment	1726	1726	1874	1	1	3133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT47FqWnmdv95UiusnRumixJ9yG89KQqHQkGmD4ZhQMkxLc57
11099	payment	1726	1726	1874	1	1	3134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7NtF9uqPpHJHMrsgf654msjkgzNHfDkkwPJhQ5XtfwHCdFEu
11100	payment	563	563	1233	1	1	7	2866900000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZFPLdnhzoudrPSWf88PbNXsw6KtChkKC2bo8UZAPaKXH5fR4QA
10993	payment	1726	1726	1874	1	1	3086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonz4rAwnF5Uyt2X92xKoh8jLtDNKQSaL9cqWBLGb8ScJghAFv
10994	payment	1397	1397	1678	1	1	6132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpo9okm37jNF6yV9dhT6xEjsjs9KLBKKsZXCW5JBZQuMEra59
10995	payment	1397	1397	1678	1	1	6133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxFApTuqeV1wePCgzrDJwo6NR6xp5qhDBasqDtuVD9hRL25VN
11011	payment	1726	1726	1874	1	1	3094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstWidSTw5URoUEiKD2bhqBN1y3n3sKkdHJGihPC5WymMUJyAd
11012	payment	1950	1950	2027	1	1	11	1000000000000	1000000	\N	E4YXPpX9SKaKLyQDxfYTCwYZroUWRDTqyxTxXBRJLT9RdjKAaqYLN	CkpYWHYtrbjkRzqmKmgn475de2JmMj262UoAaFYacvnwdjqxmLHpS
11027	payment	1397	1397	1678	1	1	6148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6QTgRvWx2ML85HaUJNi8pSg7RmemGXrFH69erV7QnTdzfNmi
11028	payment	1726	1726	1874	1	1	3101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxXMYtAcuYihy1MqzP7BSoEjonwCcZuG8pRFa4f98RBWjc8Wz
11029	payment	1740	1740	563	1	1	9	17473000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZsUfFtfdEe2aSD1MAoxRsTPMzeQxBN69gPBuqxkGfTvBmLpUJq
11036	payment	1397	1397	1678	1	1	6151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSyr5iwC27mS78N2ms1CKyBdPzgeWEaq6ZrRWG8W6Ghi5cXFb
11037	payment	1726	1726	1874	1	1	3104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKGjqrXFFq1yVDmzrMELzNoozTTzKQMasoq7zuypxSwqUt959
11038	payment	1726	1726	1874	1	1	3105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8RbqVeTCTSyrqs3RSYR9vJQdpgSiQ4zAKxhzp3DnkcLFSqsY
11039	payment	1397	1397	1678	1	1	6152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AbQrrJhr4kGBHRaUwknZNFcJ2U6QwBR6VX5Z5QEt7VZPopaH
11040	payment	1726	1726	1874	1	1	3106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqDp282CmSJvX9y2eeKvNE2X3mYjCQmQsUTuZiFrN5Sc5Rqgo
11041	payment	1397	1397	1678	1	1	6153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHc51HwrHN9L8zYEZPwcvzXvpcK471ctR3SA2TLhR2XFrrJ9E
11055	payment	1397	1397	1678	1	1	6161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4RnfpuGYjf9DzEpNr8nGPyhSvhgenmceseJ6drdVNzkUdrem
11056	payment	1726	1726	1874	1	1	3113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTjrpcgdcmJjBiNhWbyguxbsEeGUsitVRybwSyVJTn6EM8yHQ
11076	payment	1397	1397	1678	1	1	6171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH3diBiCEq2ZCZvw7uy7LFk9dVsSgkgSMb8kVU7bV3DrwSQxi
11077	payment	1726	1726	1874	1	1	3124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJLZe3YyixDSHdc7fVNqL2fEnSSRpKrVZ8MNqE8DEocH25Gw7
11086	payment	1726	1726	1874	1	1	3129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVAPpzFHE2m4KAdqWwLX8peNbxX6Hf4Z1myiiU8Mm7AVCyXwy
11087	payment	1397	1397	1678	1	1	6176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzabjdfuwGJZs4ceyYMnvhdKqhTifJru9NccgyKiaUFq9trsKt
11088	payment	563	563	1740	1	1	6	5239000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZWAZJg8ggpYjepDH4vfWq2pnN2PhcXySCGVxgDB5Syv7pHXKeP
11089	payment	1397	1397	1678	1	1	6177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCPptS5a3qQ1Hg3J3as7CiKyRTxMJkBfz3u62Q8r2ByMT1yeA
11090	payment	1726	1726	1874	1	1	3130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLQzbCAFQ58jEnsK3Gk4Huw6vjRCvdtUu2Tqft1Mp4dhZ3cU5
11094	payment	1397	1397	1678	1	1	6179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY63EUgZrBfrPtEdUTughYxoYh647cEtwsvEctePo4YYB8Db2g
11095	payment	1726	1726	1874	1	1	3132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi15D1YRevBrqeMDaypCgEAw16ZH3PQrtmBw6SygE5hwtBqot5
11112	payment	1397	1397	1678	1	1	6187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhopR2EUJb8ubsNoeFKsyHgkH4QJdncraPMN69G2hAKg62PzK
11113	payment	1726	1726	1874	1	1	3140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLAN3ofKMEVUVjhiEkgtWrmLdCsr3JAWH2TMUuL5DACLbCiqZ
11130	payment	1726	1726	1874	1	1	3148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkboc9fRs3ydpJEAPr1hhRJNkNDn8ZWgzQ47DBtmDGwMXwFR6f
11131	payment	1397	1397	1678	1	1	6196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g6Csbwpqr1zuEtEkJu4fiSGSYCycUiQ5t7SYnotrfV4dqu9q
11185	payment	1397	1397	1678	1	1	6219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxc3R4Kx4oypsZ5Xfv141JN2qRTkg42BQqJtdeQC9nsVeyag1
11186	payment	1726	1726	2031	1	1	3172	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6ZDFeNqU1k2VbLSSNCSGFHRUHDKmMJuhJ4NY9JSy86spxjJUZ
11187	payment	1726	1726	1874	1	1	3173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyszup7yLszFXKfdXq6MzVe2fdSmbf7JTzPn9Mi9utocCcPvMM
11188	payment	1726	1726	1874	1	1	3174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9UdxtfU2THyzKwAC7WnEaqsFNA9njxVN8MDfyEj4DUpu2Axi
11189	payment	1726	1726	1874	1	1	3175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrRfWcD46caiXdZb1pM7aMGYAWXFpQ5XUCA8sXphDoySJcinx
11190	payment	1397	1397	1678	1	1	6220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAd6dj4Bwg2hxwSkeKRdgTospFhq9ohPM23MfQTbfAhs5gNQQ5
11191	payment	1397	1397	1678	1	1	6221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5ux9mQKrLps7d9QuQwaZTVnfAaHftQq8c2U4qJRhLh7PJNdx
11212	payment	1726	1726	1874	1	1	3186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBW4BPaGchdR6oPVhMt2JCDRzjjHVCwG6UqHQbhoeeyaDvY1wQ
11213	payment	1726	1726	1874	1	1	3187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8V3UZXRooyG1xGhNq5jjbA6oYFk19t57ddJ1mAWyBtiQD1J8
11017	payment	1397	1397	1678	1	1	6143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSSJTNSH16zKqfwLw5jZ9UmgHKU5naUnm4CYcShbZipNSLe7e
11018	payment	1726	1726	1874	1	1	3097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDT8U1ayzGnaTLemxsa17tjvZ9xoBAGBdhD4L55uBb3bbLfnj
11019	payment	1726	1726	1874	1	1	3098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bxYSqdZKUy1fguM4DfEYs4ANif42wJJEGp1rWzzEt23MkYNo
11020	payment	1726	1726	1874	1	1	3099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFGFuno8qRhQSiN3vB5q1ASHhbxTqBwYfgCeqZtdVcjS3BApu
11021	payment	1397	1397	1678	1	1	6144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiLGLBJUFVjhShVzCqxNREXKLGonPN3HjPokmDmrA6LCjDNXU
11022	payment	1397	1397	1678	1	1	6145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGde3k6Vxezt2xyLW94fV5r91nLDV8qGAMjfnb29yvtU5nbPzP
11023	payment	1397	1397	1678	1	1	6146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm9JAxPnKEZYWHi6xasSBfop4TjJywPt6UwnD3o7Ve5w2KdJd
11024	payment	1740	1740	563	1	1	8	1000000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZQYqMqMVADtXPAW9XjmzQTqYDjeXZSVSGVz3KMSQro5jurguJM
11032	payment	1397	1397	1678	1	1	6150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEjq2X3pUx8UvpyLG17fxC52bLvDyBgMBR24cFSskjsgeHYE9
11033	payment	1726	1726	1874	1	1	3103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY6Ycd9a9L5yiistcUVddAm77tF3BUCzos5QTTnz2axpPcZto
11034	payment	563	563	1359	1	1	4	7986800000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZ3cvATUFCfrwL7EfjHPBBfy4ZpSqVzAHtmyHLp8FdtahTFt2wq
11035	payment	563	563	1113	1	1	5	4248600000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZvLz52yuVjvpKdAAvBrRsgw4MYes37wUA8LERH2D8W72Dh5HRH
11042	payment	1726	1726	1874	1	1	3107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWevJrPy2wGbTm4gKpXGnX6UMFZTs5zsraZj95V8TTRzPERqmm
11043	payment	1726	1726	1874	1	1	3108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPuxKmKcx4pNrureVhUVKFSThmWrbyPPZ4cEmThNpbaidHeSt
11044	payment	1397	1397	1678	1	1	6154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoeknA74TuKKHASBhwEVS92rFcPXahBJvq5dgYT8H1qa1HJLCq
11045	payment	1397	1397	1678	1	1	6155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmntmbipBrc9MZqibGtt1ZwkBsFsmsoootodB3B5J3ctpMn8ye
11050	payment	1726	1726	1874	1	1	3111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCRnjwM4q5EWU2faw3c8bE6DASLYLZdcia7wJazMDMFkEjySg
11051	payment	1726	1726	1874	1	1	3112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJZqwVBnrEYEPH6vsha2bESvHiqBzP95yho4GPwYvgmsvSpP4
11052	payment	1397	1397	1678	1	1	6158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk3M6KeqPn9YQJGv34kdPVeWd6C2WhZ3JXYZnNNh4cG7fzsRz
11053	payment	1397	1397	1678	1	1	6159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWwLme1bbcVaihhVxyPXQKZhHe7cQ73GcSckv344Y8poBdJw4
11057	payment	1397	1397	1678	1	1	6162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTPic6xLFHy44gh9Ti1eyK1Vm7zjM77BBDd6tGup3Zuoa4BGp
11058	payment	1726	1726	1874	1	1	3114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBstJKLJZrCWMJpe6mJvAuB9zEpYDyxPei7QzZvsMgDZdMj6F
11074	payment	1726	1726	1874	1	1	3123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJz4zyysTMpc3rY9rgZLufCKyTPsDxxf9qMAFqKB6kgy623Hg
11075	payment	1397	1397	1678	1	1	6170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9hFhLUCxV4H6aZdYheutQnzcMwHbPwhTRJDQTJpm646SfXBF
11091	payment	1726	1726	1874	1	1	3131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGn5sEHmYJVtqQuF46sczGM1gAn3Xw6ZbAY2ZRKQnRwTqLMy3
11092	payment	1397	1397	1678	1	1	6178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3RHqF9T2du3pbsbnbzYwLhnvZ2TXHbwuygm4iLn7anREk4d1
11093	payment	1740	1740	563	1	1	10	5239000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZmbYif5Wzocx9vYbFfFe4BkQsSX9JexuNimdz1d5wGyDkqPEyJ
11104	payment	1397	1397	1678	1	1	6185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bjEmQQztVBiDTjejX8uFTNRar6uo279W52hLchyHQAMrxsWu
11105	payment	1397	1397	1678	1	1	6186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZKmnDUfYiUzTL8NzD6nCiTcWeY8uQzMuTRdyqZcjLmWYudDe
11106	payment	1726	1726	1874	1	1	3135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MPTvgh7ky5txgtUbSotp55z8mxnjUHmWyercKy2NTjSTpPym
11107	payment	1726	1726	1874	1	1	3136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrmBet1tkUiEZU2R1b4uHvWZ1cSV1k1fZGAQWD9DMqVwAMFsE
11108	payment	1726	1726	1874	1	1	3137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouy4cmrR6YPN2EURnenp6iUqk6NNCoABAfbvecuemBKrGDdys
11109	payment	1726	1726	1874	1	1	3138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1omvDVqrW1pJDwc2HJ3Dau3t3n3btAakiTrwKqDJejYjGNmLa
11110	payment	1726	1726	1874	1	1	3139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpFjZEcqhwGJ22NVAHh3hhWw6fgaizxQPsYDKnWDFzcJLr9cU
11111	payment	563	563	993	1	1	8	2370800000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpYjDwvzZMJkkBDdmcHrVBQ6dTxHQvFH1yqcXYcC16T49pjfJY2o
11114	payment	1397	1397	1678	1	1	6188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCqZUBsT1cx5dy7gqUsDV3XLtHThrwU7qriPVF2DmMcj5SHPX
11115	payment	1726	1726	1874	1	1	3141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWoY9yndSTcVBetDLVkfAEvENs9dvh62erV9vTEDMFdgtoS7e
11116	payment	1726	1726	1874	1	1	3142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwdN4Wq4eUhVaNu6QznTbHjiznMLztytNfWYydRzZ38RmiWrB
11061	payment	1397	1397	1678	1	1	6164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosxcMN6RxhRPX5rdtPN7jyPMxScvaoNEdWLaNbgSBZQqp54Bs
11062	payment	1726	1726	1874	1	1	3116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJxYgNkkJ8ywdJPuaEBCpi31ucnMbEot2niefxom6uQxo4tG6
11063	payment	1726	1726	1874	1	1	3117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchZFjYP48iiw9nWSUPyqLhj4HPTg2DQsqM6fWbznBYC1DvZTi
11064	payment	1397	1397	1678	1	1	6165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSLLN9ZAqmDicnahFd4vGDv6F4zoHUfCoNR7DZbJ4isiKocAc
11065	payment	1397	1397	1678	1	1	6166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCro7BiQ42edB5dSXKWMD3xGN3uaDs2hX5JcXEEZNPZw5Ybwi8
11066	payment	1397	1397	1678	1	1	6167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8doJFQWMRgc4mp5Mypo6ioKPkD6T2gb8t6eRf3qKPngGQPutP
11067	payment	1726	1726	1874	1	1	3118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJNn4y6sXA7P2o5xEb1vpnN9vBgcpppZQ8r3dwKizmrGeJDvZ
11068	payment	1726	1726	1874	1	1	3119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJxWctkMBr4T2o9XHn3674mVsYnWTLTjCMvmad4KqW6eQMmpx
11069	payment	1726	1726	1874	1	1	3120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThKr7yQbApMFcFjxXvkci84XQponYzeRdy3kMCDqvVUGamKMf
11070	payment	1397	1397	1678	1	1	6168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mJFLB3Qtf9N5r62YtdaqXqmYY9HA1HQN4MfWJFJ6f2qF2AV1
11071	payment	1726	1726	1874	1	1	3121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nyN949NqMbsJLDiygqsD4MkvHKmi9PbX3VuZJJVUsVCZ3xUb
11078	payment	1397	1397	1678	1	1	6172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVinpixe1RGvSxHqR66CmmZPhd34EDu8P7xcoioi7mZsxAYKXE
11079	payment	1726	1726	1874	1	1	3125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJmxRJWxQXgdEfzgTt3JenP8tjPJH6XAedCWQywiBivAYFVE7
11084	payment	1726	1726	1874	1	1	3128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsBzvjonS6ytXo1rzXaL6x7KmarJCDQpP9SEhVDxMhGfjBNVP
11085	payment	1397	1397	1678	1	1	6175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvMXYfkUSvvQZ7oW7FqpqfJpNpnEj6AoSm7MCNTuYzJJJnrFb
11129	payment	1397	1397	1678	1	1	6195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsuwT4R6WxbNEsa88mawe2hTJjGZoLa4LismbyNjzc8FVGXSB
11136	payment	1726	1726	1874	1	1	3151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyCxVQYvedUhc4EsTunFMGQ1bHeRDr1e4fmkxEtP4CR9Pvsav
11137	payment	1397	1397	1678	1	1	6199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNqLMktGUmfZmsobRDXrBRU6JJAwXazXZMt1ncKgxHiFQykZ1
11155	payment	1726	1726	1874	1	1	3157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBtrpb6JW6dkmSyNA3xm4ypfKAsiBsmGV7czykP9wUJXggaPp
11156	payment	1397	1397	1678	1	1	6205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8pn7iSdxnyuYb8s4feDBLVCwxRaAUG51WyrJATBqSUaZtNaH
11157	payment	1397	1397	1678	1	1	6206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsienqiC8Zqe7Q6M1JxAW7r2Q8LgLGs6Cs7aR5mWPyoaN8ajms
11158	payment	1726	1726	1874	1	1	3158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VXfnTKd13rNsebWr8a7JguyHMW8j7wXQKMFzUtuhWyYBhMLF
11161	payment	1397	1397	1678	1	1	6208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR65r9WT2yUzJHtiKjpZF4WMwNPkQKC5hDqq2SKTU1pHQc74aZ
11162	payment	1397	1397	1678	1	1	6209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL7bG1W1iu19qJWxSYSBv1KVmFbe4MD8fZGems6Mt84QDqGvK
11163	payment	1726	1726	1874	1	1	3160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BPi9Rm9tPQRDCKeNRjc1CnAM7ixbp3Kfqgbagb9y9XdgK93f
11164	payment	1726	1726	1874	1	1	3161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxNfky5qkpe4udq1t2SZyCT2nvtC317ZqbC72WSuMTAa7Vd37
11171	payment	1726	1726	1874	1	1	3165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRnVSAWnXxnD4U8U98TULueNkYHfspzzHHogn7bp9FCUtcXxv
11172	payment	1726	1726	1874	1	1	3166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqbYiQJRDBiGh5oRFpasLvwaaJLiEoab5qo4A1H7ZttvuoDRn
11173	payment	1397	1397	1678	1	1	6213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCJG6aN6N3j3Z63TL1PXhHFjjNNEReifN7grzgtuaSPpBxBf7
11174	payment	1397	1397	1678	1	1	6214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJeX1tL4wb6H3GPiXVh5Ub8hB6y38AzkHwDNwSgxf7q8eJXma
11180	payment	1726	1726	1874	1	1	3169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4bdYRSoDHznNmzZcm6Sy6qafnud2F7nk7oZbg5m3DVu7hfBp
11181	payment	1397	1397	1678	1	1	6217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8WpUAxAScAVNcJnpw9p9HzjTerTMsBg8uMA1d3HmCaMoDd8m
11182	payment	1397	1397	1678	1	1	6218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzF2tXQbQ55qewgXd4yoEvvXHLspt1s26V3cEhbk1jSHMm4GoK
11183	payment	1726	1726	1874	1	1	3170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rimK4m2ncFkMJQ4TwGT31UjpXCykd2Ujnw6pFpqTPHR5MX8X
11184	payment	1726	1726	2030	1	1	3171	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2hS3mAHaWreXggrdA79ZRB85ZXBedfXQhKZ39GX7XkgBk5RAM
11198	payment	1397	1397	1678	1	1	6225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCijjCz8y41Xi2TuKPafCqZViCPk2zbiozQbBfKa9K2kWzZFQ
11199	payment	1726	1726	1874	1	1	3179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAArLmrVzmKF7Vnvg7ikwJN6zRDSwLtWeP9bBZsx3wdz9oDNoy
11200	payment	1397	1397	1678	1	1	6226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kaB1afEfRT3Hn5EdQ3PNZ71mUx5o2RtCCE7VvCao2sqXFihJ
11101	payment	1397	1397	1678	1	1	6182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCeJkQygatXAVcSByCPjSGDFwruCRrMgqs5F8rLcJq7dZAA28
11102	payment	1397	1397	1678	1	1	6183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvnqyBerW16EEbfdqCpFcdxHDArmgadZxKeF2bNWhtaP87gjq
11103	payment	1397	1397	1678	1	1	6184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVRTQnEhrNDVxirberZmiRDFo55NWeULxjLR7dxrU8jiT12rV
11134	payment	1726	1726	1874	1	1	3150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJrzaC3myP61U1iN6hQkw3Y32SuM7uXjkzfRTeSRp7KJxandr
11135	payment	1397	1397	1678	1	1	6198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHyzDwDzpX2tCL78r7ZnB92TDKAZaaM8mwK86b29FRU9eS1ZD
11146	payment	576	576	1229	1	1	1	2805240000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpaFWP6cmM8zkxnwwFJeLv9PrVnKW6DXYyF8xPouTR5jeTYmKW9f
11147	payment	576	576	1109	1	1	2	4157630000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYsKTDzzLgPzqKYGNF66ivoFhSmKCTaDuZz1mTtwp1A4yF4Xggi
11148	payment	1397	1397	1678	1	1	6203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRk5TxNtLwGaK3JDLfnvMWupLDNGUCZG69CTv8TmE3Fcn9W3Es
11149	payment	1726	1726	1874	1	1	3155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsNXdzWAFCqx8TA1buYPQdVxHvTrmiAL9iPqhwhiYmsjBdSzb
11150	payment	2028	2028	1310	1	1	1	8294657600000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZ4JCSu9Vi3KvMomzobuJ2Ut8F31HMK7CNWME84F8gJ3K8SHMdH
11151	payment	2028	2028	1184	1	1	2	2976634820000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaBRPk42xp3MJjF86x1A8c9269BWH6reCVhNTmKi2bVuViub3m7
11152	payment	2028	2028	1064	1	1	3	4411659870000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYXL3oiVWC7VaxBswvGEa2vQe2NANg1RBHvmm5UrsSoSYsu55bF
11153	payment	1726	1726	1874	1	1	3156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFpREAJS3skrYB1MUWZLxvyUCGTsiHeQSsoDNRHKYJAsirp2e
11154	payment	1397	1397	1678	1	1	6204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvPQm3WjUMR5ubZiqtwkKwp3n7KnV5PZJ27TCku1CU7RhAJfH
11169	payment	1726	1726	1874	1	1	3164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg63skit38T7DLPKrC2C9N2Jo4yXnRBokGWrp6QjF4KhmDfJwU
11170	payment	1397	1397	1678	1	1	6212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6SeX9RoVs5KMXMaDW4xogEaG6aJ98k2RV4VyhkfmdvMQgYgK
11192	payment	1726	1726	1874	1	1	3176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtR9e1vA7bZPGg9vrY7rYCX1QYuju7VmJq3bvPBL49sVbp7mX
11193	payment	1726	1726	1874	1	1	3177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Fdh1hp6bPHSYEUzvjqAGCBtiTUczAta1ojX9LbUThAimaC1z
11194	payment	1726	1726	1874	1	1	3178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWz8Sm73Z4e89RgynHU41NsLU51kzmAcww3XTBRBddZhZN7Kg6
11195	payment	1397	1397	1678	1	1	6222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjBBKD4wntRBsF8rHB9XUSw3HsRhwXPmTzXkgP1XJ4cRUJWCW
11196	payment	1397	1397	1678	1	1	6223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nsPtKRj7JfN3jGDakir7NuYa5VdEB65eu8zNK1RDVDbZyr7C
11197	payment	1397	1397	1678	1	1	6224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbhi9RUe2UVhWiYLxsQHsqvKbbMHNtiRYwuG5aUpxtWYybnRN
11202	payment	1726	1726	1874	1	1	3181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ66zkKSS6LEERHXvL1WLieZvmnqfLmhuSDvNXHqq7nsA4HBKGs
11203	payment	1397	1397	1678	1	1	6227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn14SY7xWY9vvaz6JbTNQQPbMXNbaGeo4kjbSnrgHFRMjjo53T
11230	payment	1474	1474	1083	1	1	9	3825014693893	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZ5PjUXMAhm6Yzkw8AtNZ5aeZE36R29gVezGrapreyCeXsZFoB4
11231	payment	1726	1726	1874	1	1	3193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8scDc7nVckzzydSdB7xB9MX4RmhCcbaasGnUXguncAGFArwz
11232	payment	1726	1726	1874	1	1	3194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoFNrascPxytySoDoDHZBCNvP1A7dHghqHSgUbtaY8F8aYKwR
11233	payment	1397	1397	1678	1	1	6238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun9BNU6eGz7b83k9Y1dhEvVeMPYja5ZAQsVGo9Lk4JuRcTdoY
11234	payment	1397	1397	1678	1	1	6239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHydNscpjbFBVpbvL8Ee63Cv9cBM9nsM6CK7fPoJVxeP1VMtiA
11257	payment	1726	1726	1874	1	1	3204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEvxBqeSkT4vJJqngXMfFQE89cxPm12zp6byNeYsAprNQBKjC
11258	payment	1397	1397	1678	1	1	6249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxgsKsUGPrEB3ezRuUN5kvqyBXoechKqgzLYQj54E2SaWXHz3
11259	payment	1397	1397	1678	1	1	6250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB6NmAFb7KeRgzPfKKs8g8CQB6cvxrt8UMDm1kTKkuphWdTgaU
11260	payment	1726	1726	1874	1	1	3205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbHTX85uz4CPooddZ99QcRD1rj5vgftxKRQunYeN8Nv5K4Fbb
11261	payment	1718	1718	1474	1	1	3	1000000000	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZAADiXUzjtQ3dM4nCtwwuFv4xjNhxYaFpQAP2KDrFFa3Lv7wuo
11268	delegation	1894	1894	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmL19VCyJXe77jMeiDTW8feVr6FFoUHz8L4Pu3X6wXLZ6tC333
11269	payment	1726	1726	1874	1	1	3209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsnqkBr452mxBxpHdQsARLohLYMtYJpWeZfPXtmhDDdSuyXqf
11270	payment	1726	1726	1874	1	1	3210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmsRUJsLJDqP9FyohiNYq2jrKndBfJ6RKGB9mwgUPSSLeh245
11271	payment	1397	1397	1678	1	1	6254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLpBKTRtsygBrJALfRyeh6G2XgCKkPr7HByhEJmkq8bkLmCs6
11117	payment	1397	1397	1678	1	1	6189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFdqdXMATxfFue9w9D6LDW6T8GnubdwXd6t4RSJLMacLopPrF
11118	payment	1726	1726	1874	1	1	3143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRr6PMStkw7uA9kwn6aJZaWdXp4VS58bVfU9mZsw6GyLigmT6T
11119	payment	1726	1726	1874	1	1	3144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6421jsURkTzjhyS4xbFYDc48YN4ULWXEzw2BKHcMiMuB8E3DJ
11120	payment	1726	1726	1874	1	1	3145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiBhXf18yi3fnLzUciYWS8bcF56UCAyjX3577qReASyAqPLkL
11121	payment	1726	1726	1874	1	1	3146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKggNnB6Nn5gxATbA2df41AJDgsVFdYUD4bqnML7VDV7hQc8g
11122	payment	1397	1397	1678	1	1	6190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfspoZVCrhHeKhKwCwt8MEhpHQwKC5EkTj1oLGbDo28ZaYbX9
11123	payment	1397	1397	1678	1	1	6191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bcWeorFKdEDSBscy4x2p2HeXUvUDWDvhApB3QBvDescgm5vN
11124	payment	1397	1397	1678	1	1	6192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTVaTdWWfn5iGWQZ5VxTjbTNPE6rHQB5mjb9ChDVoeWHtGKVs
11125	payment	1397	1397	1678	1	1	6193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9fbCmFPHayYCYW22GcdYe3a3ondy3PdvT4GvmbFvdBF9dmjZ
11126	payment	43	43	2028	1	1	0	19440100000000	1000000	\N	E4Z9wy61chZh8Zcy69t2kWC22fjkBr4coeu2z9onURnuBkmeV3Uct	CkpZxjUu2mmnKs22twRkKDE73SaGGLkYiniuxuzjCUBKCnopch7r7
11127	payment	1397	1397	1678	1	1	6194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX9TZcV19xfyKddSJHuo9jkPRMG6ybFMERgQj83o6nxQRamqa
11128	payment	1726	1726	1874	1	1	3147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXE8w23w2zgpw4LxDn2u8J9X3viKWX4zThDgbKsSMZhTKprAE
11132	payment	1397	1397	1678	1	1	6197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgZBBSibyftcaEuiwzdGfLcmfLDrqsMcUA52qtgEiWbJvvTKF
11133	payment	1726	1726	1874	1	1	3149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NDTecu5VqAnfkwN3f7Vci3YBh9gUwBDQp8XbB7B9UoBcPePz
11138	payment	576	576	989	1	1	0	2320150000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	Ckpa5Yt3VR5N2gJUCNgAbFvm3rZgd7ECVuRkoSv3w58dtCRzrfFPv
11139	payment	1397	1397	1678	1	1	6200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDc4mqpq5Bnmrck17Lijpo1wCTUWvmfa6XyNERiZ2fHU3yhx7
11140	payment	1726	1726	1874	1	1	3152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WYuuSw9Yua7pSKkjNkfQoA8W4ZrwQ6vaGHTS1U5AdgXuAr31
11141	payment	1726	1726	1874	1	1	3153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kQKbD8b5eLBtqtw3UNZV7BKuUB5YJhJFriutrSCYNmfSv1WK
11142	payment	1397	1397	1678	1	1	6201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMq6jKghaXpA2EoF2xk71WAqbemGQv8rZCdTvRKhtT7HzMbBE7
11143	payment	2028	2028	944	1	1	0	2461875540000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaKytcsUZv8bZUQhZd7VGRBR5o63yMnJwAjtrNFV6LbvpSF1Gcp
11144	payment	1726	1726	1874	1	1	3154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD85UjW53x3GRcqYeSmoayzvVzbu6JccnRc5Aqf5frXTGouF6
11145	payment	1397	1397	1678	1	1	6202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9GJcNFZzrvyNGv8UJdURM4TbcT1viyzt3bP6EeV44YpVKhyk
11159	payment	1726	1726	1874	1	1	3159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9psbNS3SwEtjYQARCsGUe9whgKxo8497C6eAbmTD3KQ7DjQL6
11160	payment	1397	1397	1678	1	1	6207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQphwxecgxGWPLtGSyz19gAn1fwFjXuH2YUVCrzrDEAdL5m4VE
11165	payment	1397	1397	1678	1	1	6210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8iNYVJBBEfZQ3rQoh4LdoHAfdEA2v6kpT2ZKdRNqLUQeYw3r
11166	payment	1397	1397	1678	1	1	6211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzDQcNApjE8xVpRqfdMvNq3Xgk2tVGSqtsGbj2NUczxpCEiwK
11167	payment	1726	1726	1874	1	1	3162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8u5KXJmJmggCc1vaQydhcd62zUxkMVT2GqcbQ4ZKG3FGFQmT
11168	payment	1726	1726	1874	1	1	3163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaHCmC57H1MPM3VJALSWfymPrJxTMHrVpAJ9iUDPTJuQpiRZf
11175	payment	1397	1397	1678	1	1	6215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWQY5ZtrxWyHQRHPE8op6EYBS1erngqDdRKBLM5uBUDyNyMn8
11176	payment	1726	1726	1874	1	1	3167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguLSELqti1o5N8n9MGNRGn5sSNecRfvgJUR9HbS7PJehMNqk9
11177	payment	1449	1449	1939	1	1	4	715000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju87JJKeKfrJbX9jpqYXsWRNPjHNtvpZ9ECSVPif7ai9hi6Eu
11178	payment	1726	1726	1874	1	1	3168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2K7hbbNuLUPYzVA1xFsBpAEWsuPMijBd4WGXp8SSugZFXJnhm
11179	payment	1397	1397	1678	1	1	6216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dkNVQEZzF9BXsooJ16DPjRDX5KhkbVWmkhYS2KmAXP9Ju2Q8
11210	payment	1726	1726	1874	1	1	3185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRsgBGcEvrNpKZvGoW8munqeaQr1PeESeuzMgjxNnk5zkMbU4
11211	payment	1397	1397	1678	1	1	6231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fJwf6yDA9S2ReQPKpo5uYTUhGqvDjXWDkmU1wBjHWJh98DbH
11218	payment	1474	1474	1541	1	1	6	1000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZ3VNww7ZmazUn6r94t3hMhrVcUvxmNohvcs7zkEaoWpWCig3iE
11219	payment	1397	1397	1678	1	1	6234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpooKNAcFNNJu9Yktq2y5BKgqGMUJc6hHiP7kDqMDJjKLvxK4
11220	payment	1474	1474	1541	1	1	7	1000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZiqVj2h2ELNCDDGE42kgzURZMZbHjJz4pVC9dD4oh1mZXSY2Kp
11201	payment	1726	1726	1874	1	1	3180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKs8UdFN3ESbqY3TS7sLup1Ppopwpi4J7iU7rtD7jYvcMXDCJ
11204	payment	1397	1397	1678	1	1	6228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTaXBoRYSijD3uyyZKhMzPYLUSnYwp6mePL3dq7DHGSu8XN8k8
11205	payment	1397	1397	1678	1	1	6229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawbsLn3zUbvRv2a7ak6XWKtvkyN39Ciz3EkTNCTQNoSpzrFG1
11206	payment	1726	1726	1874	1	1	3182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJTbrtVTAkmVcYayPWkc3PPEx7yee22xS7DdJyGjZhQHcERuG
11207	payment	1726	1726	1874	1	1	3183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6asN2RFtkCNosEipaBRw4Dw76gSB2xRmua3kx9tLvNYMBPnK
11208	payment	1726	1726	1874	1	1	3184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhWbbUK7mFPxj7zFDAPreaCvDpUYqMoeAHbJyWRtdn8zhkK7v
11209	payment	1397	1397	1678	1	1	6230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtrjxHAUrEzDK1CjJZeRuFK5uGxPJ91baZs19Fz5QKc6xcccFC
11216	payment	1726	1726	1874	1	1	3188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3c63RVxnAxZM7twn5EHHwHiGmXP9TnqWCcgcp4cpWuaGYp7Mf
11217	delegation	2031	2031	95	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXWUVFAfUa9UsbWC6XPi8eVzjdqEk1XQ1sisxz1zahsQiCfev
11236	payment	1474	1474	1203	1	1	10	2580813632763	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpYqgE6dfM82sfLaNcrgRUvgVoKPUVWqzcU2cdVjQo3iEkax2aDk
11237	payment	1397	1397	1678	1	1	6241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bnHyukSVNdwCVyWJ16aFRQq7378XeAyKwbEwdDA64Yt1NfJ5
11238	payment	1726	1726	1874	1	1	3195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcHhwLAy5TXHEhq14GLA6nZacQvfLAHh4op7wUm1oXpWAVbiw
11244	payment	1726	1726	1874	1	1	3198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC4Z7bpafej6fW4tT82yHk96jE1Y15D3fK2rxeCuSrMpXcUn2
11245	payment	1726	1726	2032	1	1	3199	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCMkk5FfgzMJahfiwtUS6Sd4wGDAiDbnmMqur7WrnpKBoD5BTk
11246	payment	1397	1397	1678	1	1	6244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9J9WEwQ4kCKPC5fcRqiUX3jdG2wMWRFNU45dzG5DhmnSeDpJ
11247	payment	1718	1718	1474	1	1	2	1000000000	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZyLfDrMrpmyrb8BFRxDdE83Ejm6ziP82o9fzWBiJZuxakrAU6L
11262	payment	1726	1726	1874	1	1	3206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWqJBXNyLo6cyqWLbfHozcC2vUJTcFx1hsukviiHbiopsobkh
11263	payment	1726	1726	1874	1	1	3207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV8rp99DrDZoCkXRgLbuF4AmHkLWEnBoDATEmYkVhTt3VcJe4
11264	payment	1726	1726	1874	1	1	3208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzcLUfwmiiwbooRoeGVndsXwrb53JhMVci4x3CSzRyfDRxVZv
11265	payment	1397	1397	1678	1	1	6251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uQB5xxwdJaaC6P1prNWfELBRw8j8Jok4SzsxB3JsFNm26fZD
11266	payment	1397	1397	1678	1	1	6252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HNAFnMbZv7VKdnFdNo8FgjujW1PspJme7W8WK45ef7KfBpss
11267	payment	1397	1397	1678	1	1	6253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyDPEcFX6S1VDbHiDxyPYfeDbReH6m9AzxddMjfQb11k3VfNg
11273	payment	1397	1397	1678	1	1	6256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXjVnJh6jg3KUHy5mJxRYcmvW5iFRjbk3sj1nRNgqqKEvpwpj
11274	payment	1726	1726	1874	1	1	3211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kNkbsnqQcadzgCCkWQsvhYGerohMKqajHVdZpwxxwkXdhhLf
11280	payment	1397	1397	1678	1	1	6259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRvK9yvPksuyLB2YH6yaS4uSfTncmXR8n6TC7c5C1ATgAEfc5
11281	payment	1397	1397	1678	1	1	6260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqygkrpjNzMihuAbQscX9CFoPdz4LPuCJb9Hq6BXCYzpUm596
11282	payment	1726	1726	1874	1	1	3214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtXHbHywnSmS8hKkoctqx4umvx4s9GXWx2YVAwrS1t8PLYGw4
11283	payment	1726	1726	1874	1	1	3215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnu5gi9LrWGJPzFiy9SyNn8e1WAZeB2AiAZzi8gzUYN9h5tm7
11290	payment	1397	1397	1678	1	1	6264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpt3yiQ15i6zeTjacjA6SbWTV5NSkUQg9DFGyTNL4AeCKowsp
11291	payment	1726	1726	1874	1	1	3219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxo7mRzyEoozL6PfBFmm4p3zPGs9SUYtBu3aM5fAoRuKs2x3s5
11292	payment	1559	1559	1107	1	1	2	4735940000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx2ft4a3jT4tmCnTgmN6VqeNsSkwL21bNDgrLr6s54jokXguC
11293	payment	1726	1726	1874	1	1	3220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgb8gSAUo7XUZNw5htyyC3tApJcdGHve43PcQDBiHWMvXrtXi
11294	payment	1397	1397	1678	1	1	6265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9njZFNfVFJjindMBRBPDc9rcMujmC76fZ1aFUCbdjQmAJhRc
11295	payment	1718	1718	932	1	1	4	1732480942128	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZHraRY111pKqdLGEQQRbtGUd1MN1vhsJ64tGWU5dMZkLpkthxe
11313	payment	1726	1726	1874	1	1	3227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbHiV9AUrPhTwXFQdQx2zDokdVrRm3Cojb9ReV5JvwjYqjz59
11314	payment	1397	1397	1678	1	1	6272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sEj4acd1orxxf7HgkMiajJaaHM8E1WsCTETzKcrPJ2bASDpq
11315	payment	1397	1397	1678	1	1	6273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2V9ofxz7oJPmcnCVfNh7m2HRjGGLYazdxhvMD7WDWRxaL9DW
11326	payment	1397	1397	1678	1	1	6277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GxuAGsFQoFxVk5Dw3KNDVTdZcjqLdgKt2ZNeHizuXCcJgfxj
11214	payment	1397	1397	1678	1	1	6232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cRMKJodSNJkpP7Ea9cqtLmBFjeMztJHraJv35bQwEkQykrP7
11215	payment	1397	1397	1678	1	1	6233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vef4EUvqGJhUUNPyBwaxucnsKznUAqHnFDtWsuyuWtsT3XyK
11222	payment	1397	1397	1678	1	1	6235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2jJaHVHHtrsJspDDPYgqSXsbR5M3jp8xmaRHqCHNu7bj9MKy
11223	payment	1726	1726	1874	1	1	3190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7JkKrDxFRnB6Y9D5xQN6FQWkqXGT8sRzUi9EKje7hZqc5e1M
11224	payment	1726	1726	1874	1	1	3191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQNkTbnvJLNCwFTpj7jpjt1HeJ9U8sB9qAZoNLJsdzbd9xnCg
11225	payment	1397	1397	1678	1	1	6236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQUQ8ffk6NEtUtP57c1F7NTbfLWmoaWit3VZgHjzsGnXMWJb8
11226	payment	1726	1726	1874	1	1	3192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8byGFHKKFzHVTmWFt7qD8Ya1yKoi3fXMtwGVSNEeef2UYdit
11227	payment	1559	1559	987	1	1	0	2642840000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppoQFKrQeYCkBmkZGnPAJvXCjpDVNWxAPdTsf4Rthyb2Sq6KU
11228	payment	1397	1397	1678	1	1	6237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyc6TyKeo62TgzFcACim5qVh97B3gKzL7zgXm1c6dxsGx2c3rm
11229	payment	1474	1474	963	1	1	8	2134505012457	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZTdGMUnYgiUAip8NbadSQ4zDsMY2ovLPPsaxKAGk2R2BzQu4bN
11235	payment	1397	1397	1678	1	1	6240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdTRaD54fw3trHBLXCKSnvdd95PUMPdxu74GzdoGBKKZNm2GZ
11243	payment	576	576	1355	1	1	3	7817030000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYqxQ2qozKM1EUsSE6xBx756tfP5GakLxMK6YFcYT2xdYAmA3pS
11248	payment	1474	1474	1329	1	1	11	7191666660864	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpYXWeYNgj1NHsjcfwDwzecU1t83ZGcXjkFgBqKMSrKddiSAaEnJ
11249	payment	1397	1397	1678	1	1	6245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrkBTYJGKHTL5nRCLTXrLr2kYDwqP9EDTB53zBRpAknZHTbAJ
11250	payment	1726	1726	1874	1	1	3200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhz5fhk5BcTYv6PNGN7Dr2Vwo2RyTkohcQudx5tzJBpN5rYKo
11255	payment	1726	1726	1874	1	1	3203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxm4KrDhvA2UdBJ8qJgNL4e2iiFGk5hKhmwzReWukEurbTxMsz
11256	payment	1397	1397	1678	1	1	6248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6D7veF4skr5GxFvLMNxpTR8XjxYBTtfjWQCpBHN9xH3TiqKRu
11288	payment	1397	1397	1678	1	1	6263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjuf7G7K6gjwwVZSXHRzjUHqZLQ11GfceCQq139tAGKSNp9gm
11289	payment	1726	1726	1874	1	1	3218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevaSvvLmfsBzhceqdgKicqKxCFGCmsqrXGfdWtcvSijyCGLf9
11298	payment	1397	1397	1678	1	1	6267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShBY4qhxCoSwggp4MbV2cjiAvqEqmQfdfyviDaNqodQTVDFs1
11299	payment	1397	1397	1678	1	1	6268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrTtEbGyoLou1HPa4kueiFTBAUS9ypMcHcbeZrtQf37QrCEta
11300	payment	1726	1726	1874	1	1	3222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTUb2QU9cH2WHA65EiJPWm5VZAFYjUkEsNSNbGHdNhy64a1SU
11301	payment	1726	1726	1874	1	1	3223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPt1LLqwpXn9G5NaUQhGRPJZykn8wJEgCS4K2R8BTitm2ou7f
11302	payment	1726	1726	1874	1	1	3224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdx63ppcZa22mmumEZfezThnJF4epEUfaqVY19exFmrbN1TST
11303	payment	1397	1397	1678	1	1	6269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCMH8hTGeffbVyQQjdUSmpPv3DQA2aNR7nRqyU1enFZtoTkzB
11304	payment	1559	1559	1353	1	1	3	8904360000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWLrRmB9ej68FnR8crVUtGzWh7YuhneAJCCpkgpfojX9ntBV4
11305	payment	1718	1718	1052	1	1	5	3104591004405	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZ8L6cjD8w9x2AJaWmME1SehL6jHFYPAZvActUDaMnUCYtJoCf4
11306	payment	1718	1718	1172	1	1	6	2094729414015	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpYfVUhGT6G8hmZmGw7tBaFDCvZGKYGtDNPHBCMGwGByHzPvCNR6
11307	payment	1718	1718	1298	1	1	7	5837149765120	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZNTCK5FQjxUByNMHoDDf1ycuYCnF4nCq5NWQuUUPmknVtQzHii
11316	payment	1726	1726	2034	1	1	3228	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa16WprNEJLhUmMnn7W9SnWvRcTCX9sVXCRku7W3ANYPf6REiEi
11317	payment	1726	1726	2035	1	1	3229	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtXT6fS3mgz733xDe8VtUjnDLQndeZ116GNkMkJmRkAao1jY3u
11318	payment	1726	1726	1874	1	1	3230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTR8twzWSSh4FiKK3TSXMALoq8uoQEtNVCjUQ5nRRsde8Z2hAX
11322	payment	1397	1397	1678	1	1	6275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6HeopiJVc9NZ32Cf1BBkATP5kf7KgHqZdjLPxNnoeb2UnBCw
11323	payment	1726	1726	1874	1	1	3233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTQ3ZbGpsvniLxXzHEfmBEGHbemW2BVoE53cEg5BTJZeqDCUF
11324	payment	1726	1726	1874	1	1	3234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4Y97oVqn7bd9b4YfYncPJy15gGByHQ6r5piXgvAa4DFPEcTY
11325	payment	1397	1397	1678	1	1	6276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZUsSZn1NXC1Pc4yAmWHEx8Z8G2yhUZe2Hu8nSMJWqz4SUgxK
11329	payment	1397	1397	1678	1	1	6279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGrCbdpmApwGtGoi42tfFYiq1RxVjWV7s766LVgZjZ9wpiWTX
11330	payment	1397	1397	1678	1	1	6280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjfZiB69cShWGUYtiYSKu9mUqTHaxeu5XSR5B1qxF9ebAwXKb
11221	payment	1726	1726	1874	1	1	3189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQSkoHViddZzW1tHp7ohkYNF1dthLcJ3VtmsvJJRLgN1byMsY
11239	payment	1397	1397	1678	1	1	6242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8u5kJTJnzvAbJpZb99SGAzYU3ZpcpDmEzAb5bRi3p3Z9ybrCJ
11240	payment	1397	1397	1678	1	1	6243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC12GX1VGF9AfXQG5s14eQSvMu3vyyLmzq1wGNPfwaZVxNxopw
11241	payment	1726	1726	1874	1	1	3196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPy1KZPC2YvJs8PwnxnHXh2Z1ohpPu48RwYHtMRYMPBJ6kRJ2
11242	payment	1726	1726	1874	1	1	3197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5Ww8dETTxsoAxpUCk3KEas1qbxHqSH8bo6qVPo2AVAvsupfs
11251	payment	1726	1726	1874	1	1	3201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9GHCmNwJw412fouhsSN4k8P9N1RYJav7qwii5q2MoER5zn8o
11252	payment	1397	1397	1678	1	1	6246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44pD621aNkhFGnazyoEqhftwE2Q96pMXcU14enzYvHCwqGM6p
11253	payment	1397	1397	1678	1	1	6247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhbqqjoz7W9dL4JEjs6SJKGLxPAG5w1nrUyg64GRoizEDfgma
11254	payment	1726	1726	1874	1	1	3202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3o7BqzFMsbrVwupgs35SUs3Y7M7SHExBqwrD51Jsed9jEzVA
11296	payment	1726	1726	1874	1	1	3221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNTfF3LyrXL9RPwiddZpF4gqd5T1ubD6WBZ68Y5TXDB3ZkKcm
11297	payment	1397	1397	1678	1	1	6266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRUusguVAdE164wK5znY8WzmijnH1fy7vzhJgKbhjnPyFTd3P
11319	payment	1397	1397	1678	1	1	6274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ruwcYoPEzHMT76rY3n9ESG2e7MoF6Fo2WR77G6J9qGDGnN3L
11320	payment	1726	1726	2036	1	1	3231	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCCdxFuaDX48WymLVQqMCTVRu7b1puvSkkmBvuEnn4MvSZGSTC
11321	payment	1726	1726	1874	1	1	3232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnrFcUVsJ65BVsfhEG9SsribnxG9YeVNASgKxPR5pyfVyDj4R
11327	payment	1726	1726	1874	1	1	3235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8SvWXPoNLLrxGCBuGyYt75jZDhKHf2q5q4anyrJ7emNr3sCx
11328	payment	1397	1397	1678	1	1	6278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2StCF2p7z7Cc54USwvwdYr1cZqWY3cGP3pQLpKoA8oUJuMJDe
11362	payment	1726	1726	1874	1	1	3247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwECxiZPSEFMRfzFoYU4hyd6KeTSbxCqmiPFGtus8vTyfT4gc
11363	payment	1397	1397	1678	1	1	6288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YEJeKDpJtwxFMvq8Navh32tv2gme4Kx7ANjBSZVVQwUbaNPg
11364	payment	1506	1506	598	1	1	12	287273000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpTmDQ62erJ6ZGFWMRctPX3YZbhrjUV9MeSPYM7ve1vwv1eVZ
11365	payment	1506	1506	1007	1	1	13	2188398000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXo1nc41VCQ76HVDmza9ER3qJEYCXMjGdwiFJTUz4Z49TJRqxa
11366	payment	1726	1726	1874	1	1	3248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiund6LMrzvg8pWwQQCspwgU9VqRtF4QMpe7jegJyrUoUVkje
11367	payment	1397	1397	1678	1	1	6289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieTEsiPnvzFPQHPQHPjXnzxKpw3YWEvsoy3JXB1oHk9JwbhQc
11368	payment	2039	2039	480	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZKrvfDLUf5H2gwrTkDhSxFJSE4usysjW7Z3RaN9SxzTafJMs
11382	payment	1726	1726	1874	1	1	3253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mQmrqFtSB3kUCkqnd69ZQgjcK9DaaxrLh3ZEwp1ySoT2ijgz
11383	payment	1397	1397	1678	1	1	6294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEbgbUDGCBnWVgxZBZTb2UBEfy3WcnTMjkd1CU27ypxmZnpff
11398	payment	1726	1726	1874	1	1	3261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7yXy4u3uPeLixpWNmUECRfbeMxeXLynHy6iEusiea3uz7fEU
11399	payment	1397	1397	1678	1	1	6302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEDF3ENAnbTkg2UEHCKMDvgUo44btskS9PFX4CVTPayJ4ddxj
11400	payment	1397	1397	1678	1	1	6303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQH6aEmP72LDu2bjk5w5TBLgU3ed4Sy2ChjCn9fTSAXEMp2pa
11401	payment	1726	1726	1874	1	1	3262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyHjTXhXba8mFLzQ7tT719nLqqqExwoWfXjsq2NiDH6meLyuV
11402	payment	1397	1397	1678	1	1	6304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCVZK3XvtXvkxBc7n4NVnwyF3cybN479xLMj9sguohA66sth7
11403	payment	1726	1726	1874	1	1	3263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY9vq5Dg9QiLdXGFG7mAtUnTFzn11t2pF6WwFqqkkirdj6yz7
11419	payment	1397	1397	1678	1	1	6311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYAGUHs7JYFtxLRordrh85jDCQjvF6hrAx45cmDKCavYXopP9
11420	payment	1726	1726	1874	1	1	3270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHjfvetqEEqGVmGH6bz5s3RwzjrBtrzEcuAvB5KxWob9Gm1yV
11424	payment	1397	1397	1678	1	1	6312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EW3ZeSDRFyZ1eTmTJ9P8LMF9YYDZFcGzShCUqJxmS13LnqjR
11425	payment	1726	1726	1874	1	1	3271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtgrcQ4DLEVpZPKc465jejboDPY4mgJDiMMGYWShe8zaJPX6n
11433	payment	1726	1726	1874	1	1	3274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9yFJawo6nViTqLiAimh7CDi1anGT2q72xo2RPzxvnKCapQZB
11434	payment	1445	1445	924	1	1	7	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfLMfqiZm1CyguJT45vyJR1FcanFCvtdCdmYxiU83VXEZ88S1
11435	payment	1726	1726	1874	1	1	3275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhufXsV7x3VGQjTTQXr7cqHNzHyRqZuzPUgaBHL1nB7XWReED
11272	payment	1397	1397	1678	1	1	6255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5zu6Wi3qDehGnT3dMZbp1R2LbeXLXttM5EsgVFg4BqJaCNbB
11275	payment	1397	1397	1678	1	1	6257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtixGuUFX6yZx5MWSWZBARYQcDaRdNAr2QDvXqhhmzxRBnaoQ
11276	payment	1726	1726	1874	1	1	3212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCXowUsQdfZzvkprSrHXEQ6aUarFo4yYXsJVmRgPGifiwGpvw
11277	payment	1397	1397	1678	1	1	6258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXHBXKEcPUNgnkcMYLRqT4n18kPBcZnAFzHgPm3rZVRTxMiMkx
11278	payment	1559	1559	1227	1	1	1	3195440000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iQNjXTTmxxN2wTqtDiq7f458y9Uceu4D7hRc74dwpMuJx38M
11279	payment	1726	1726	1874	1	1	3213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yiR69J9TJuF4JcMY5YWN2frDeXxMCK3zeZm681dM8ikdoqjS
11284	payment	1726	1726	1874	1	1	3216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv6ViXPx21N7mxRZvuwQqYG4EPCNgP9KuapcwaNFE4SRNEhqV
11285	payment	1726	1726	1874	1	1	3217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrrVsVVQuNWyuZXA9cg7Zqg1yz6CsWBMiib1VMYdUAkLaS9NB
11286	payment	1397	1397	1678	1	1	6261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TdqiRMNjxX6XcmL2LPBGo7TqaX68oRRs8DA88q91FKNschvM
11287	payment	1397	1397	1678	1	1	6262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKVyhF5gnWWvM2ahxTsy1M2wSYgn1LoFppDQdTyASq75pSQon
11308	payment	589	589	2033	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorawCg2LGiyhFxPaYdLKMkapERfHsoRJNXaFHXUjEpbWWRktk
11309	payment	1726	1726	1874	1	1	3225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1zbXqDQBsqqHXUM4efM9ypxPdQQbHimkmrHMrQTcReBHe9Aj
11310	payment	1397	1397	1678	1	1	6270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rDbUpdTHtafFyktidn7RpmNxgAJ5X36VU96KethPMRjQ143w
11311	payment	1397	1397	1678	1	1	6271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseSqWYnkK2uoqmEna4cgG5YrqyxD3hPUPL9b5MAPWQxwzAmoj
11312	payment	1726	1726	1874	1	1	3226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qLjV7ikqyhmiULvSLcmbTeT5MUocVqd5Yn9uG2PWRYWLq233
11335	payment	1726	1726	1874	1	1	3239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEL8ekQCCUFSoEk3hH1VWMnyKrW2ec4SjngT32Faqp8pcxZA3t
11336	payment	1726	1726	1874	1	1	3240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3enyrdM9igwArcCHZ8jaRKWvfEJaDGk2PFFpduSpSTAanFzc
11337	payment	1397	1397	1678	1	1	6281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqE7JhQurSvSAzHzLGPD8L7wMu4Wc6rV4jR8hsav5xviHm8cs
11338	payment	1397	1397	1678	1	1	6282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEW4jmgJHLovkPTqEDjHFgBnCbpoiG8y9Xatn4z7citZ5bkZEv
11369	payment	1397	1397	1678	1	1	6290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmhW5BwANW8rE4wSuFSiGYjqVr2J8FMtgbkKLs4Vog2nByma7
11370	payment	1726	1726	1874	1	1	3249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZwzkDcEUf3KeSrQdRK3Lx26eASkjXQeALxxfYqLyx4p9hbL4
11376	payment	1397	1397	1678	1	1	6292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8us9uvUhBim9TKsdqq4DLRLuSy8xskgK3FWVPi8m5NNR1SHX
11377	payment	1397	1397	1678	1	1	6293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVKMrQfipNUEiZYGebwos9bStt9eW4836w8EhigURauyuocPV
11378	payment	1726	1726	1874	1	1	3251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPMHqR9v3JKpcaUqPZuwe5WNV7rRhzjhzdbFVXyZNtve2dd3o
11379	payment	1726	1726	1874	1	1	3252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPasEjz6aq8VmwkvPweDtVYKsRnpvFmJfDVT6Q2cfwWxFGsQv
11380	delegation	2038	2038	95	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6fikDsx2JWMTZqu7N6ursS8ZuUFmDFTX4W7tBXBgUka1PqWC
11381	delegation	2038	2038	95	1	1	1	\N	90000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNcSJtZvQ2o2kuRkBRjnfuNnDEfK3yRAnJxNQYetG4vNxLY4H
11407	payment	1723	1723	1000	1	1	1	2781	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYzFAwkMisViAdH4bgWrD38LdeM43ckW9sLkDZC48UG4Hv63t
11408	payment	1397	1397	1678	1	1	6306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAVsX45pDig8mhkfpnRvJA9w8qYx7RGJKVSgKYRiP3Sc159k9
11409	payment	1397	1397	1678	1	1	6307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFzGyGi2PYKy6j4MtcDxjeBoxDBcZrAcPM7nxjtYvU6ZRdCaN
11410	payment	1726	1726	1874	1	1	3265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxnvW3o5jBB8qoF2wfxZSAGnUWr9bynk64o2wUQbKcy7VH9Fc
11411	payment	1726	1726	1874	1	1	3266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXqPu58F9Fh9aoGasfkPvTk27jRie9xEnEk9brZqDeTUuTYSu
11421	payment	1440	1440	2040	1	1	1	1116040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg74HktSkhNWDJwoRUua8xa1CVsbqLACpkAhhhgSG4s87skVNV
11422	payment	1440	1440	1011	1	1	2	2877040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabGsB3v3MBAJpsjkmfMMuLzPnwCsLEDBRhjiwVH84Grqbwp7D
11423	payment	1440	1440	1251	1	1	3	3478610000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwyxwXCcgSRyKSkHA8Gu5634RvzCJ8geGRSCg9Uxh1VGoHHty
11331	payment	1726	1726	1874	1	1	3236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrybgvSBWK4YYoDoJcLEMP9isTdC3LT9n4HbPM2EseQknp4pH
11332	payment	1506	1506	2037	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiEHDkaYzWnYvVC67aMi6aFBc7HKYVzFTEQDafuzguRvsWCEz
11333	payment	1726	1726	1874	1	1	3237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdq2skur9KHUjV1i84x9DKLhiuk3PYKvN8E48Duij95PWacRN
11334	payment	1726	1726	2038	1	1	3238	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9dLU2sc2NVrHqnPU5992n3quP2Q42Sks3bHwy7SqZfig5GQzp
11339	payment	1506	1506	2037	1	1	1	862000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGXuwWG8MSiTnjiGndFJFgw7sRaeYMXbfR6NW4K2RJmqSXaLk
11340	payment	1506	1506	598	1	1	2	287	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jKvhmz34P3PBKbZoK4HzKJBHseMhBvvXK4esUmRSRrNeAtxK
11341	payment	1506	1506	1007	1	1	3	2188	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeg7ZDrZMKMRNGYf5Hb7f78SGeLwa7541wHEeCi6cuzVV7y2c7
11342	payment	1506	1506	1247	1	1	4	2645	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUgdaR2FRNEBHkuYthFsjBPoczTm5TbESnD85r81durvJzTG8
11343	payment	1506	1506	1127	1	1	5	3921	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqqYfBbwxEHFSSJZNR2DTp7nqmkU4omkG6jTL8Z7DUTbhkLfp
11344	payment	1726	1726	1874	1	1	3241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxU47ZZgHM6LJeuCrNRN7zgdJWP71DHqXLTjkQ9HNWnkVMuQwa
11345	payment	1726	1726	1874	1	1	3242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHo2JEQk429s51XVgabhbgyXDGQv2DTDY4ztj8XgAz97CNTq9
11346	payment	1726	1726	1874	1	1	3243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGhtrz1Q2gQDoESTDKZw37FjfV8jSuECjvMxRQMFAFjTmiA4Z
11347	payment	1397	1397	1678	1	1	6283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhz3na196cE8HhmKFfDk8CvwzEm1PEDvzJGrvcPU3Eeyi5whc
11348	payment	1397	1397	1678	1	1	6284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1azJKLdEsLxKg2h1VjRMnAc2Jtu2jcvUzSWQqQpE6CmmYyBvq
11351	payment	1445	1445	2039	1	1	5	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUyftTmhoe8viFSPTpsruPUeUJ9vaiPueY7Dk7NgtuqnnKT6B
11352	payment	1726	1726	1874	1	1	3244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSUyTUMPm3h1WrxV8KbkyErp5ZbwXEAJ2vhQZHzMn77BSEX8j
11353	payment	1397	1397	1678	1	1	6286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk67yysACEFokrmQZYZvXCr4HTD4wR6V3RhzE5462W5LFZ9odk
11354	payment	1506	1506	598	1	1	7	287	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ518dYD5wBsjMPNUNDvmazqaJKpJcogHQWuDKP5zkQuo3ze9NB
11355	payment	1397	1397	1678	1	1	6287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTPn9sw6NKv2JjtUrVQ4vvnbkAd5dDv3B3uwNsFDiYbYRUzRK
11356	payment	1726	1726	1874	1	1	3245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uoxB5A66iyYx1AZWQMENWi3SY4VvRHxMAF3CUgwjjhuBi4G6
11357	payment	1726	1726	1874	1	1	3246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMTZVb38Jsun81vTA9fbUmCjh84Nz5RXcZ6rLwbJFi4iPBriS
11394	payment	1726	1726	1874	1	1	3259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfKf6aidSnuCQGVYpc5WofpWZ6gasSWo62xsjpE5yg4mGLHSS
11395	payment	1397	1397	1678	1	1	6300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AZcBB9p6PdVhp1KzUyRjfiKf3MSAKDfAwMb3sr1f8NtowwBT
11404	payment	1723	1723	723	1	1	0	16599090000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtctUz6uvxG3r8rETc4PqJS57Yn6pMAokmcoptAXo2B8hsX2r
11405	payment	1397	1397	1678	1	1	6305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3C4A3iD2Q2K3pnsrFA1cqsnno9VMswXahzZ8a58E6HVULSe4s
11406	payment	1726	1726	1874	1	1	3264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgiE1cPvLPia5PC6TzSNiTEsrnvm6NUdQu4TtuNQTsCZcc2qs
11414	payment	1397	1397	1678	1	1	6309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JDr4gfJvDnQQsuRWk3XGj47kKkTerNCN5EFqHk663V4WHmku
11415	payment	1440	1440	2040	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ozV4uFoj9QvdiaUF51QExxruXWqdMSevxE2hGtti8rv8Lshk
11416	payment	1726	1726	1874	1	1	3268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpAaVbjEPZ4jxzzsYNabCZka6M7r76qxf5sXQHQJBjjpfHUGv
11417	payment	1726	1726	1874	1	1	3269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSbUuF2B66FFRmu7WqtFpHfAxsTSbJMbqXDbwWwdVUc6Fegk8
11418	payment	1397	1397	1678	1	1	6310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr538EY1MtoaR7kDTkUUTE8oH6yj3nNt61EkUcZcMDpCpxnzg
11426	payment	1440	1440	1131	1	1	4	5155630000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AKF7hg2eefzvSeBH4jUmu1evhyLuguaKj45ZDnYBxycJa5ew
11427	payment	1397	1397	1678	1	1	6313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtr3zXfdRKFEDQLJboHk3GUNVC5wzHEjqzN6wZNZkRYcy6oYeb
11428	payment	1726	1726	1874	1	1	3272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nfAQqWEPrQqdZrZe8C42mNjc6bPCkSzbSPgi18TELyKbERut
11429	payment	1445	1445	2039	1	1	6	1440000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9ftoqjDXZWk9ei7GfyughA1cvm7wnetAmaCUQwWSd3rRzqV7
11432	payment	1440	1440	1377	1	1	5	9693450000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2ZTmFnZmuPjg23NtA14zMSdGNBREhxc5h5g7awh9s6bfMwXm
11438	payment	1397	1397	1678	1	1	6317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CAwm97ZP2RBJPWq56ZPKAC6ztacH3atXXXnicCvrigmZPVPh
11439	payment	1726	1726	1874	1	1	3276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj9nTQgrhvEh22VaMwe2pF86JCNedBW6F998EWuYerxR3eDo5
11349	payment	1397	1397	1678	1	1	6285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwYncRyTGCEohXzXifijh9M3NGM5Xt19a1bVCWEWGeqAkWXhE
11350	payment	1506	1506	1373	1	1	6	7373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvXqTYsXWgESjSS2AmAoipEXBZAQdEare4Mo4m9yL19JRYKXw
11358	payment	1506	1506	1007	1	1	8	2188	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRBuSEQ6fzSFy1jSeUhQ5o6cnKHQEG5Eo6BgvrdsjWbo55FD1
11359	payment	1506	1506	1247	1	1	9	2645	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztquiYVLSmFsgM2ArBb6Mp2XfaNQzhnm2KxKis4PmYi6tHAvk
11360	payment	1506	1506	1127	1	1	10	3921	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6L2ZvmdEFoYoTKL6YgHucgovaaob8eAPvUjYYvVFQTZebN9h
11361	payment	1506	1506	1373	1	1	11	7373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgQh5AMW3yCuVTbf2tmt92CSWoMxTKzLwwhBzrp6mJhbPPawu
11371	payment	1506	1506	1247	1	1	14	2645975000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4BkZGeGQS11oKanaNi2fEVwjcjzybcZiiXrGcCKVnt7ZqkQo
11372	payment	1506	1506	1127	1	1	15	3921589000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDQkwnVwXDaivEMq8AAFxX51me3LxeaRNV7VPJW75eoDkv3rN
11373	payment	1397	1397	1678	1	1	6291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzrZQELYH1zzjtixHKNSCjFRcdMXNkWNmZtbzvLDfs9kdv62e
11374	payment	1726	1726	1874	1	1	3250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuHwr7UPba5YWhz9N4LaAi5jELP7xEDoMfnEzEnzATDaeKEtr
11375	payment	1506	1506	1373	1	1	16	7373243000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VpZ86pYdxC8ZTF7joztvR8CRxyZNeqoX1XPA5LkvnWfrHqoi
11384	payment	1397	1397	1678	1	1	6295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwoN2jm1exw1sr89Mc12hAWpC5ctgzBnTZjkJcMucY78X2qE3
11385	payment	1397	1397	1678	1	1	6296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EcqRAbzS9UCjG9m1yZN15GmUcpD6j9SNyJjpbZHKSuregU5R
11386	payment	1726	1726	1874	1	1	3254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMXiGLvvLRjJVTXaFYvv2KFDdvede82NRKvK9YKDBo8AkVS1X
11387	payment	1726	1726	1874	1	1	3255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP13FaWmEqE6rZRRd31TdFBQqwHRqnKXFqAZcF8zzy2zaFrrPd
11388	payment	1397	1397	1678	1	1	6297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeeCXteqbQTFfaBdXHnvwyJVxLqFWRodjWf2Z8NEd2suNggjnH
11389	payment	1397	1397	1678	1	1	6298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LRSZvfZGCTx9DfPtZXV2kfiibQNA5UkMnsJhHb3N3ghr9Pb5
11390	payment	1726	1726	1874	1	1	3256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQHAebUmUPteQgyRYfxyXQMPNqHQFKK1SwR6Jqf63QqhnW5go
11391	payment	1397	1397	1678	1	1	6299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcMVcbNuwMyh9H7ydko85CE4Kg6R1NZhEnVoqfVi6mv5Mh9Sm
11392	payment	1726	1726	1874	1	1	3257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEFK8gh9Y8ppKx34yHmikfwAghU4VqZguuMVXtyEz7wodkBu4
11393	payment	1726	1726	1874	1	1	3258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcQbHrzJmJ8Nvx67tM4EgecJR8U8Nd2bQDDEYhEdnYK2WrcgQ
11396	payment	1397	1397	1678	1	1	6301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iPqzWf2NVXtPeaDwmcb6ftkjCVkYJVAS93EWn54oB6vysV5H
11397	payment	1726	1726	1874	1	1	3260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhoQy9r6NczdXxxKdJk3jTjKcUz84hyNSStVWpvwRjWb7FU5d
11412	payment	1726	1726	1874	1	1	3267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFeApMBeS2f63T8xwoYNYGX8oUHrAEtqV4jCGQUvUhQ1NjjYc
11413	payment	1397	1397	1678	1	1	6308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6uNPwV6EMYUuUnhwTut4c8NiFkmhc9AgCcDTz675Q4opL36W
11430	payment	1726	1726	1874	1	1	3273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwcnM3MqXL4m5qadW2z7CwBbQBfYARh4ZYPURgMMiD1VLWj76
11431	payment	1397	1397	1678	1	1	6314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDzkVyXgdmDEWceiJSLXE1WoQWyUECPFbLXL99DFXVf6J9MWZ
11447	payment	1397	1397	1678	1	1	6321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mJG54jhDcndTyFaTFzWTWtiBj8beGrZNsGEXvWWfkR5KBX16
11436	payment	1397	1397	1678	1	1	6315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5R7833VgjxdEXAnnyFhaYMnxjBj1NGEG1HgiPk5grRCjpjLH
11437	payment	1397	1397	1678	1	1	6316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpTy1GozZw4Ed8wenmo7FayiNwsr6FvYEre5xCyFpfFGhdnWk
11440	payment	1397	1397	1678	1	1	6318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBgiTb9N2JcZ2HEHpnkvaeBeCPScSF3rtZ4n5pC797eRZ5oin
11441	payment	1397	1397	1678	1	1	6319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmB6UaJVzkDmGt4wsk7VBZSDcmeB9NmXV4huPweKwieQ4r1FkJ
11442	payment	1397	1397	1678	1	1	6320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4QVjHfXkMuB1SKCmnDsMDbnvpZ5CH1SxarPUHiQexN3B7WWM
11443	payment	1723	1723	1000	1	1	2	2781884821000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZmkfiAjqyjEKfLZuh1prtP4mgSQEHiSNuJXXho4PRs1duwEX3q
11444	payment	1726	1726	1874	1	1	3277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFXTRu3hWUQtXft6PFH62G3nyENisQJz9eoWWHt2jdMhrXe5bH
11445	payment	1726	1726	1874	1	1	3278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSJgjZVF6aETqJVgUFJZiS85MhGHf5sgLZjYNvLCkZw23wRQe
11446	payment	1726	1726	1874	1	1	3279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9aoQAmVErkQWkz5AaVUda8TpNfZjtUTsP2kqY7aKvoQtZ9Z6x
11448	payment	1726	1726	1874	1	1	3280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtsc1jaCHoJ5AKjqVVbaaSGgDj7CibHEBVGWkJwdU9hNH58MD
11449	payment	1397	1397	1678	1	1	6322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdszbxAtNr9nvtNkemcuXYpmwDKZXytGjEhk7kQ2B75pBrsnKM
11450	payment	1723	1723	1240	1	1	3	3364000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZRdkjbbGATQog46RMZ6sHZtPLrDENoaRmUVqxP86hPeugSyETr
11451	payment	1726	1726	1874	1	1	3281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbA8FNGVNpBAzKY418JSFsBP7FfuagtGFtC1W47yDY4XtJHEb2
11452	payment	1726	1726	1874	1	1	3282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeMvr1XyLTufWDifzetuNwaJJGSvxBJNDosX5Vj1En2rhwZoU
11453	payment	1397	1397	1678	1	1	6323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq2pzAdAzx6kZELQkd5war8Qj4JHnkDmNHhfVf3fnUJUN9pTw
11454	payment	1397	1397	1678	1	1	6324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXSCYYm2FFbppAeVxji8MFec1XU3uWjuQvqeTNoeYA4fnVkaR
11455	payment	1397	1397	1678	1	1	6325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHXCm7T3uWoWcUEckR66E4TUfx16WaYQMrnPhrt3i4Dv2SDcG
11456	payment	1726	1726	1874	1	1	3283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsFrigCof1tst2rbLQBTZbEDTovrM9KCzRgXy7jEjcGZznARG
11457	payment	633	633	1384	1	1	1	8280000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZ2quRXD3kRNNmsbgUSs2ruEUMjdLQB916aQKh5yqE7uait6gnP
11458	payment	633	633	1138	1	1	2	4404000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZhCSk6Cv1PZdjG4CraHbVVT8Kz7KvQqVM9oLEmWt59qhdUygF5
11459	payment	633	633	1258	1	1	3	2974000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZaCHCBy5XrWq2XnH5L5kcYDBxNzAahoNjJScgU1jVK379E8U9C
11460	payment	633	633	1018	1	1	4	2458000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZKK2AcvrKKTqiWKjA9tPz5P6kCHYnmBU2kN9z81NxCg3au4UvT
11461	payment	1397	1397	1678	1	1	6326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGSnrBHZparrNpLosByN18KN7Lkmo26FXh4Lqxpmu97Ue8ymm
11462	payment	1726	1726	1874	1	1	3284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQBvqsYmn8TXkEpc2vRPoz7q2bR7UvvfyM1umLQdkQTvZWad7
11463	payment	1397	1397	1678	1	1	6327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyX4ZSHhP8fFi18WsfFeZQvBXhdDK6oNDEVQQHPV8UANGj57Y
11464	payment	1726	1726	1874	1	1	3285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvV3GBgEG7ihHbywDKgryEjTLsx9LFu1PGqw9Q7L3zythWhtcN
11465	payment	1397	1397	1678	1	1	6328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oxQhGt4TRCe15JyYiMZQhbTEhXhwc2iujJTXqi4XTeTsE25e
11466	payment	1723	1723	1120	1	1	4	4986000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZsRwWJxh3ptTwNB9bhi7YiUvnkmXnUMFjPfR8bzFJL1aw681mG
11467	payment	1726	1726	1874	1	1	3286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Udu3jDkw76qBYQJQ5UJyQpHkaC1Xxgpzmc7anpPUM9TwUFgv
11468	payment	1656	1656	1343	1	1	0	10138000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznbBYnY31gqZLWFAQm65yYykSBS3qua1u6CuWXmiCoZThqZfx
11469	payment	1755	1755	406	1	1	0	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpR8cWiuqMnJDRcTfadb5onRyQGThvmQ1dwdBVpr2Lb6aNPMo
11470	payment	1723	1723	1366	1	1	5	9373000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYfc6MAx26t7hbRhNXeVRanR1TRrhzi2wShsPp4dZffr7TuKJDH
11471	payment	1397	1397	1678	1	1	6329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsukzKtapkePxwWyv2uCHTzcCUnDzPqCYcS45irLKE1YKMnXXe
11472	payment	1726	1726	1874	1	1	3287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjiDSYgWtcB3dGQXqCkfCL3gCPZmKMi2LiQmrLBjib9o9NY8z
11473	payment	1726	1726	1874	1	1	3288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuhVWgAkWHyd9LpJikd58R63yQXkpZNZ36oHoLdaUNrZvEkB5
11474	payment	1397	1397	1678	1	1	6330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9X1X14KW6aGC6pQGB524PSt9gi8Phzwb6YM9ZVEdsB3Ls6bB8
11475	payment	1397	1397	1678	1	1	6331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyhjDmqTPRR8ymRnNy7m5EsmKHEdGmBqYathAUAtR5qQUuMnf
11476	payment	1397	1397	1678	1	1	6332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvR5RpgUUE7aVFY1Q37NTSaTEFp8ebAXUiT7XCi2txjCaX8se
11477	payment	1726	1726	1874	1	1	3289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQ2L1oHkYPnLX2KmvAHYz9HtbkDdaXGy8h5hMjAXuQMZdvxi3
11478	payment	1726	1726	1874	1	1	3290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddRtS5ngSgx24x9XmGdMPxqvMRtZcxg7b8zrxRWddKEizqwDo
11479	payment	1656	1656	1097	1	1	1	5393000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMz7QS5pMaUW3cW7bjdH3XSy9Bqzns1uD7XesHXEUhwNkmQSS
11480	payment	1656	1656	1217	1	1	2	3639000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYCXMPNvgXJV14PZc4mPYJQrkymYxS1hZLcgJAcTPsPqAhobD
11481	payment	1656	1656	977	1	1	3	3009000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYav7RRYcpjy2asGFqtJYBtX2ffwGbjpzifhH5rf6ib5dKptoo7
11482	payment	1726	1726	1874	1	1	3291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvivgStC84DGsPN1okbrH4xgxqzN5BoLQaYRuFWWaFzPygEnW
11483	payment	1397	1397	1678	1	1	6333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXSG7GQG3X44VJPEYpJtN8zDF8Q8PLWC1sWiYBCAAiM3c8n7G
11484	delegation	406	406	1755	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhqv5Sc9aojbGsU1KbPcaKifqJn13tsh13znjcz7mEHWtU7HW
11485	payment	1726	1726	1874	1	1	3292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcScdvDNuHJi2KTeRyjx9Nq4LD1wxg67ZG45EZk3gEFW43Jc31
11486	payment	1397	1397	1678	1	1	6334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Da1CJCAhMvdaQTtmGCWJvsxbrMtnv37K3Cd19Dtqywex4rLq
11489	payment	1397	1397	1678	1	1	6336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYARgMTmcY3BzgAziUhPUmkBtiJcjf7PnP4wioVKqFAn6JZt4d
11490	payment	1726	1726	1874	1	1	3294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1mt6e4uk8ZDx4umuroDPN4NRA5AfKMwxaYCroD5moW6XjprJ
11499	payment	1726	1726	1874	1	1	3297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrLPvvceqmduXZhwEhAkPAvVzXQ3uFtbvocGjUXVpDgbTXEeF
11510	payment	1397	1397	1678	1	1	6344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiciBLt1kr8YdgedBboLKoAkHzxT8rNNUtq7ZTZ5F7gceZPKh
11511	payment	1654	1654	1094	1	1	1	3431559600000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZMXDdMUVHkVJmSoEptnHHDyjb1Y5aFBDKG8x9TH1dtAe5QTft3
11512	payment	1654	1654	1214	1	1	2	2315476800000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZNYUjTvrS7KXbuQXSSiy42ypnYyoUQyNPn3sEZpdaeJnDwV3Xu
11513	payment	1726	1726	1874	1	1	3302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDxgsiGecMbCJD9Pvn8mnT7UbFYdoY9bgogg8n4VazozxLsE6
11521	payment	1397	1397	1678	1	1	6347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdncNSKYvPMyfpgVe7gQtypDsfHSvRTER74TUZ3X862ReZf3Zu
11522	payment	1726	1726	1874	1	1	3306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYQTFZEpqXMEcyXPtGmGCQR7Fw6eCSCjtEsZoL4JgeJaoLWnm
11527	payment	1726	1726	1874	1	1	3309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCWDxZevVFjHA5M6NcKbdxxjxhtLgksrgW6CxLkNzZoj5kYfC
11528	payment	1397	1397	1678	1	1	6350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpH3sP7UVe6M2UHUxQiNwgQEaLnZDVzhkGWBsAK9vqkn9CBRTJ
11542	payment	1397	1397	1678	1	1	6357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJv8efhWEemjdUv2hdZQR1G7qPGCF8kMeVdmR7WzS3GUqB9jho
11557	payment	1726	1726	1874	1	1	3321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWyTRmUhe9jKU5XwtvDk4ApKT5yaM7wfJpCBV22RMZcxdUUnw
11558	payment	1397	1397	1678	1	1	6362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TrFcTsMq44xf5iCHc8DSzmWQhx5LNkaZZLerF7ezUUP58CSi
11562	payment	1397	1397	1678	1	1	6365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkwBAqe9Hhm7xytzm2eXv5RGMZaW9LNnQku3DCkByeYtV5yEt
11563	payment	1726	1726	1874	1	1	3323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7bQ9jru5AhD6zFRJx7PT39Zhf8H5jg2UGsuHW1zHwKJ44vwn
11564	payment	1726	1726	1874	1	1	3324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6Z4KmjKN3bimnf3dNbCapo4gFsEsXmBFW6X44Ka3hVtKqvsZ
11571	payment	1726	1726	1874	1	1	3327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYqj1S5CvWUnx92qYdetCA2aHqEuWYv517WbnzNQxC8ypZ7Xc
11572	payment	1397	1397	1678	1	1	6369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigZ7qGC8km6yCiDFRx66uZ74rGgrG5bE3A9gHESfXm7n8YnZr
11578	payment	1397	1397	1678	1	1	6372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafwvqJiB4GsrSfeRHVHwPW3d4GCx8sopkp5qdyEV9Rez2jcTY
11579	payment	1726	1726	1874	1	1	3330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9XcuDktAECWzXwMq5NRNErn87vhxAwNcSQQSGRi4F213aUxi
11594	payment	1726	1726	1874	1	1	3338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqnpgVau6gARYKbbbf3uzTxmkWCJURNn76KC5DLp1RS1dKUhT
11595	payment	1726	1726	1874	1	1	3339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohzf2M1kLDYi5rcexgZowYtejGUNaSFEz7tvrnCZPD9uy9uYW
11596	payment	1397	1397	1678	1	1	6380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJdFVtC7gTVgvJKXNXs7VtLzQJzMWyrQg4ez5hUrx4AqNetnA
11597	payment	1397	1397	1678	1	1	6381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdKr48vVrzfomRqs7biCoEHwCGf32Ez1bvwWLhQtgagAhkS6d
11605	payment	1397	1397	1678	1	1	6385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvf1ygvg5yVtyCqCEUUxVpJmyhMynN6e4hj2opBZNJHQ43hTBL
11606	payment	1726	1726	1874	1	1	3344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQHpYxEk5sRWFQ3peBnD9EmgKhaP1P3eqwMv34bYwbH28wfU1
11614	payment	1509	1509	954	1	1	1	2644236687992	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAu57MKT8BFQvZsQiujU1PUH9HdSr5Vp2cgzPwtEMBoQrGuZK
11615	payment	1509	1509	1194	1	1	2	3197126290553	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYjxznmwDfXM34K5p3dWFuZTPTg1xi24beqxrfDCUbqfH5n6A
11616	payment	1509	1509	1074	1	1	3	4738449489072	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLuzLESgx2tARAXA7XAyCUs6XuskHscnPMkNcpbvqarU1a2TU
11617	payment	1509	1509	1320	1	1	4	8909076681228	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYR4a2bHjm2Xdtt33TVev143BAEeGfYq4LVos5pX7DJAKw2NQ
11618	payment	1726	1726	1874	1	1	3347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnz6VGZkr93YZydzgKFAZyUm9BqoynaJXegG1QJgVv78FRMpS
11619	payment	1397	1397	1678	1	1	6389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLdMNwrhSmoLtavXaw2JFv5ed2Bu1iNQwvVECMYRfXeJ2ZPjB
11624	payment	1726	1726	1874	1	1	3350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdqnmu6CLr6exNzX6xxwXCeyQxXyVoQaaEzExwRqiakim8WHo
11625	payment	1397	1397	1678	1	1	6392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufVEGcDdamLq3fszv1W36qW4Qj9JweuNVWG9TtqnpM2Go6R8u
11644	payment	1397	1397	1678	1	1	6400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWsPyGWo2B6mrMBtSTrp3cuKB5qcY6tzwLX3KPLNGwSsPRWYh
11645	payment	1726	1726	1874	1	1	3359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrgt4H2AqyoC13SwFafmwxHkRc69bdwEUddPVjPnwmPkBXJAH
11487	payment	1726	1726	1874	1	1	3293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBR3XC7RdMLKiMoMFtpWniMdi2abw1ww7miCMaQorEv28bcJS
11488	payment	1397	1397	1678	1	1	6335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1mgkvqVK4h5ui2j2ibRfeGVA9Zwi7yAzZAgZrHVZozHueC5R
11500	payment	1397	1397	1678	1	1	6339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYwtSYQFSrfJXYJ9SeCpHAnduMF4ZZY8xZxCbS3giTNB6SqW3
11508	payment	1397	1397	1678	1	1	6343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17AB9WntbUr5zedNMsS7TnBDyUZGnWGhEvfesSosm2d91Qk3B
11529	payment	1397	1397	1678	1	1	6351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakrk6w5m1M67KKunZL5ixWS81Qm7tLszuAP3f2Znjaab4W33Q
11530	payment	1726	1726	1874	1	1	3310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLN2NruCAMMMdzysAzkSQAPhTXoGY9ycsctWbksYzAkwnXa83
11531	payment	1726	1726	1874	1	1	3311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLTv1SiLetdpBwxjXTKqvy6ymBDmrcWowo26hZuZMG4LaFXA2
11532	payment	1726	1726	1874	1	1	3312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyg8oBvMkp6U8n8ohDvFWxu99NBAuXJPRo8ML1RtohEvzUxJgJ
11533	payment	1397	1397	1678	1	1	6352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rVdMa3kSXWzu1Bm4sY2G7csysZCaoVpmbwLi4zhvNuJmTtLd
11534	payment	1397	1397	1678	1	1	6353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwgPpw9umoduPEZ3bckeMcKKX32wMykAmjR16FvUT27mNasAQ
11535	payment	1397	1397	1678	1	1	6354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkbgg1H2GuQQLRq9hWGE6o6VRqKmQh6A6FpgH8VN4H2piZ3YW
11536	payment	1726	1726	1874	1	1	3313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56PSN9S2Sqw2ewxWtrqnBHUBgZ88QhtAB1KwuzofFsTFus86V
11543	payment	1726	1726	1874	1	1	3316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2odbtMHAxnzizyjHYsAgtgmAk1jpDR5ucf3FFsF1e6GLMaJoQ
11544	payment	1726	1726	1874	1	1	3317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqYkEn3dEfkqacACMdtvYxMwfwYJCu43dLBXwH7y6U2cHMQny
11545	payment	1397	1397	1678	1	1	6358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4yRuE61wNMAwLyEiZJXMR2HZ7fsLWHwrodE63YvBaodN3szi
11546	payment	1422	1422	1211	1	1	5	2691570231373	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZod1pE7QLvUTuwUosYqknyhr2gXFUQadAUTFAc61fSP1JUS48x
11550	payment	1458	1458	1197	1	1	1	3528000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxX3YPtPrwyhV85vAJY4GD52zndmJZLHvQzXGGgitvAQqri9K
11551	payment	1458	1458	1077	1	1	2	5229000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZ2P9PcqaxEgT4jS4n5GERvA81AKAuycms8vNBaR8NqvHhoHb
11552	payment	1397	1397	1678	1	1	6360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipKA9AH8oWyH1TrKEfD8VgzuJx49Q8ay9CADfTGafv6EQSDJA
11553	payment	1397	1397	1678	1	1	6361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPdG9ajeSPyoaXGZSTq3n2GiucVseV9uMm3R2CXYobFjRB2gB
11554	payment	1726	1726	1874	1	1	3319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs5WaPbbeZqbZruH2jqaGLubbPPDuqHX1zdJZRJzScHUx29CJ
11555	payment	1726	1726	1874	1	1	3320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMtmp9rgHdEj492SR5zdNZJteQhMh918jyCESerFupJU2CSvz
11556	payment	700	700	1980	1	1	2	1441000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6pr4Tnn4eD3psm2fdxEDUW6WPCaG7LMjDXyY1K5KCsYiPNAA
11561	payment	1397	1397	1678	1	1	6364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYuh2LdvkNqUZVzaBtQBu7C6KVRCsX1oidFSpxbXbPbaAdoKg
11565	payment	1397	1397	1678	1	1	6366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhAAedXQt6Tj7XonUK368cXXrfLi9SmBoj6GhjF4XovZDcaiX
11573	payment	1397	1397	1678	1	1	6370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRrXs1p41q5cThMCVxaSCuugDGK5SjDm484Jo9YrKFSC6cw86
11574	payment	1726	1726	1874	1	1	3328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11aSsFa9AopUJ5FJZoyWhgwxjda1imEHYHKHSghEkBL9fLiw2
11575	delegation	2041	2041	1437	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCVs83uXQF8jW77j13PoHSh4NtD9mPFD3ovivH7TTA1xHfcev
11586	payment	1726	1726	1874	1	1	3334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCrjkLsPa8w2RCVQFo8fvueLDM4p1BuKEaNh3E36oWZb6tcY2
11587	payment	1726	1726	1874	1	1	3335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CTPP3cxNfmJfjQHMYQ3qg7cTTCiKxD1xknQPoemeomV3fShn
11588	payment	1397	1397	1678	1	1	6376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDV8eY3TG8c42tK6Ak7o6Nb3V3wat9G4tcyPvyZBfiFuF5yQC
11589	payment	1397	1397	1678	1	1	6377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6TJtLKd9avQsELyTqGJAsRiHZRujds6PVPuBy5Foj77zfze4
11598	payment	1397	1397	1678	1	1	6382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ66CPrHkdHpXoC1eeMQ1fGKDMoi9Vc2nc8HpiVuvX96ZAj4N
11599	payment	1726	1726	1874	1	1	3340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4tTahPadepJ4EB6Aq7MUaCuBG5DxNy5zf6DUtutjW4N6NNXq
11603	payment	1397	1397	1678	1	1	6384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPFDiht8Bb2abuYXXCfUgyUC4ZUfFhnUu5Uu639tKPM64JW6h
11604	payment	1726	1726	1874	1	1	3343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPJzT4i8jURgwDCuRpxgCK7RwfexcXrWJ1KV3a7wQt33vBvCE
11613	payment	1397	1397	1678	1	1	6388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7ecqvA9x8c4c6mxNQnZV9RFAd2Y2cGfDZTBCVzuFr8aTDGHL
11626	payment	1397	1397	1678	1	1	6393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccGTPvzBAzj48Weec5t5oDouixDQSVD4icwGn1bYDkAwMJ5Bd
11491	payment	1397	1397	1678	1	1	6337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iuKUMwGSNyDKfZJ1hUqzkhpffFcj3eQ589AL5moFptEq4ZYb
11492	payment	1726	1726	1874	1	1	3295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBbMANaQ9Skuq5UNiSaxtRwvFCnWMfLrGdL4uF1nmxVyodYjp
11509	payment	1726	1726	1874	1	1	3301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3C1s6uqxTAzxaZPMEQksba4jCisCk8RAPTi2cMRSKRcKzGQpp
11514	payment	1726	1726	1874	1	1	3303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqChQRsKWGawr1PxNMR5Fx5vkNuupJ81XeotQcZ7DPyh6pWQ6S
11515	payment	1654	1654	974	1	1	3	1914721200000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpaEPCta7yBi9Kr5XAF3EDCfmdCTWmvx5SgETvM2Dj6kzehJCVJU
11516	payment	1422	1422	1091	1	1	4	3989166654234	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZeZy51b6irvDfALxwsTzUVeoFBCVkmWRpquwxUt2qhsgHrbh8r
11525	payment	1726	1726	1874	1	1	3308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5s94kLbzwfUM6odUJfndEvp8TKkpoaP2um5jjr3tjjUxw9UB
11526	payment	1397	1397	1678	1	1	6349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3RrPtWwFnXBUQauvEAwaoZyN1KhZikD68UmdrP6hgLi9jdqb
11566	payment	1726	1726	1874	1	1	3325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCypoDLkDJVSEvNY3KU5PiS4V79viS1FUS8utV3A2x2UZRu9x
11567	payment	1397	1397	1678	1	1	6367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKsXUULQntaVFARbSDzm28eib4iSpm5ZYaSDnt8NFNUkpU5xJ
11568	payment	1458	1458	1323	1	1	3	9831000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVMZjnVZYqLUsvHDFU7abQeUy3GffAh8kgAZYYSfXgJUr7ugs
11569	payment	1397	1397	1678	1	1	6368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSyzDL5vgZigbAeHKTrcLBbKYiXPAT2qTUNnDnF1uH7y1u2ff
11570	payment	1726	1726	1874	1	1	3326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEE76bZA3ZCjnCEthehibGQtxT7fq86b3RgLR4XYp7cY9aFyr
11576	payment	1397	1397	1678	1	1	6371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzx7n84LgwStSYvBpsMCw3fsythC3pJ4fxPMhqXQrCSywFUvw
11577	payment	1726	1726	1874	1	1	3329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsPvysNpngMzPENiwJJ493DcjpjPxcQQAJzus1ACHESZLAsBg
11590	payment	1726	1726	1874	1	1	3336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzfCNbKMoPx8eRJThTXNAworCJ83n1LQgwLe5NJBtPZFL41fB
11591	payment	1726	1726	1874	1	1	3337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrfnw2YbwMT5uFmWdsCoHkpdcNHisffZKa9AA9pH4AnspMXQB
11592	payment	1397	1397	1678	1	1	6378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SVg7x9w4ymXZvee1P98MzBvr7Gr8SU2hJ2Bwo56R9rYSEJ99
11593	payment	1397	1397	1678	1	1	6379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8WyF8VA1TgECEgedoQ93JLwDFLfWGGXz7SobS3EyK1LKBeRE
11600	payment	1726	1726	1874	1	1	3341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9v7PXFPBSDHzziyyaSqSKKyn1RHUJbRfRzMYwxR5RG8rTEGR
11601	payment	1397	1397	1678	1	1	6383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXnBDVvCwZqDaEdLFRTcyjZRjAmoZbZpvkELuFiL9zoufFhCP
11622	payment	1726	1726	1874	1	1	3349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPws1hPrU1nbiYFc3zxhvEkKH73aQxT2uTPrkeBzHWKAUBBHnZ
11623	payment	1397	1397	1678	1	1	6391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8FomJMayiVvtdTeaaLVjnaYtKCMyQphPyg9ikbiBMqRizhEv
11629	payment	1726	1726	1874	1	1	3352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAvZA3neLo8PTEy5URGmfnnERBEEKkLkMozzdnFYiAPsQzzag
11630	payment	1726	1726	1874	1	1	3353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuF5xNykbqrPNRQxM6zvVXos4F2FaZUfJhfKFeQCEgnaF37J2Q
11631	payment	411	411	2042	1	1	4	830000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNT9eNuGscq3qwojf9Yc4jWQDnBQ6pydncxbpeAW6toWZDpH6
11632	payment	439	439	2042	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfntUXUXrB7ZamAUrEuSxTSdyHAdxTXwBpucdycw4TcPAtoreY
11633	payment	1397	1397	1678	1	1	6394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWNaEve9MYw2GKiw7ANevmunb481aBkAaGoHSTrtp7FHnGVwZ
11634	payment	1397	1397	1678	1	1	6395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmEaR8qy5HHrS9eLR4CpfT5Cnzw8YwoC62TMFq71DVtGnogRG
11635	payment	1397	1397	1678	1	1	6396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzE7W3oZBkpXUB6oW28C3rcAf6JA1dttLurFpDoiVQVabkJoAZ
11636	payment	1397	1397	1678	1	1	6397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1DsoJugGp32y7AhBn5BVJZMWH9LRKqdjBrrnamhWCcEVXsoC
11637	payment	1726	1726	1874	1	1	3354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK41ZqCp74i5v5Wqmsw5nsdTukQpdqY5AfD2qbGeW8ryQprpq3
11638	payment	1726	1726	1874	1	1	3355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUKjH9oNLmBRAPUKy5DpkseWVdpAfx71xzLCeB2XPYiPrPx9A
11639	payment	1726	1726	1874	1	1	3356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptg8sfGybAmg2RXhbmAPvNFnRj2F1iwSKbwqZQYE5o9sPanK7
11654	payment	1726	1726	1874	1	1	3364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1gWqQjFcm3LxqdAXkY5uYScyyKPbKr36Hnfg4JreCNTY2ozT
11655	payment	1397	1397	1678	1	1	6405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cn755bJAH56Y5jzw3spF3Y7FLATAHnpopJy354U2Eh491mtP
11662	payment	1726	1726	1874	1	1	3368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuxg8qA3wVfbeDKSBpdNk1eeiTrZhFxuR78HgKVo9o7PgFPnZ
11663	payment	1726	1726	1874	1	1	3369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rT6KZn1fYft8z9ErbrcQkG4Au8BxeZf4ji9K7zATApEhNzHv
11493	payment	1608	1608	1289	1	1	0	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcz9W31FnwyMPgdoxcCU4smf5jfxLao8nGHDBz9WsfWf4LN2p
11494	payment	1608	1608	1043	1	1	1	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaVArWKqzqZmvMrkbB24hXV8RZdD3eyqNTBRaYW71dPSYzcZ3
11495	payment	1608	1608	1163	1	1	2	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZbZwCiqA9Jg7kxuQVvYtLDqfWmwJEv7ZvqmfwT3rWkaa2enz
11496	payment	1726	1726	1874	1	1	3296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQv9TYV7krPFsebMjibSP7Ft2nu6ZHmFBWL3iaaf9o8vDqQzK
11497	payment	1608	1608	923	1	1	3	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDky3RrVNJSgijn2k3zGAEyu4GGe1MZynkobEvd4k8DUrPEWT
11498	payment	1397	1397	1678	1	1	6338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAyiq2nZMpynTHkZMqum4VB7YqCzAx8VL2q7LnezczbbGgXG5
11501	payment	1726	1726	1874	1	1	3298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Uhi1ZmAETpgVuQnjVNJEjukJ8feRcGU7j1Kwr5szh9uQnz7K
11502	payment	1654	1654	1340	1	1	0	6450872400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmwGxRGRk6BcJ4tVoYK11UNAtf6NoybdgqBJFP8QAf9PEaLUs
11503	payment	1726	1726	1874	1	1	3299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiamMteWEB45kCPVLtcRxzExvXSqFGJfE3LWX4rES3N3T9RayR
11504	payment	1726	1726	1874	1	1	3300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQbQGUnzWa9bjmVQvoeFnyNxWKgARMPWk4smPWZi1CeQp7qXe
11505	payment	1397	1397	1678	1	1	6340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhk19grTbgt5vrm4hDSZ3Yu5cQrCaXweDeCFDZdnPihXHrxaJ
11506	payment	1397	1397	1678	1	1	6341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZa5N486RXQo18RCHkoPrssXYd7vngdP6ybx8eX7hLKEhcVCEN
11507	payment	1397	1397	1678	1	1	6342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuy1Mb1miMLJL12CvWPmeJFR4sL8ByR3pkM77QtTY8ohiLSEbL
11517	payment	1726	1726	1874	1	1	3304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA6kQSQTWHquqycgSj8uE12yo9J3a1aRtk5NNUozc8oXu9RMG
11518	payment	1397	1397	1678	1	1	6345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDMQRw1qiwfbni9bNEbmxkzYLThJAzXCCzoKPQxFbjcRqKkYD
11519	payment	1397	1397	1678	1	1	6346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiZ3yCDkQkcdFPyyhdGMGEg9b4VKoZ3Ha7FFRKSwaH5oYRWjU
11520	payment	1726	1726	1874	1	1	3305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4ibk7kbSekbfgHa1LsxYyoeFBD2edfa9HrV4oRHwma8N8Tvm
11523	payment	1726	1726	1874	1	1	3307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wVt4H82JRtaBaHwErkPDrcB83z1QKeH9YGV8a77uVd2Wv1Ks
11524	payment	1397	1397	1678	1	1	6348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mB58zL4Br14ZNzYEXwRhPKWPb5zgqgGGZdFThwV3jYNAfLSh
11537	payment	1458	1458	957	1	1	0	2918000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdiMo3P5cNZATvtiQ5G4N5wQMtzSj8b476cCxWircmUN5wBZM
11538	payment	1726	1726	1874	1	1	3314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYqD8R6WMbSgTzvfU3NmqBMmpJCavf2MSfakdoXXr6k1GoZ6u
11539	payment	1726	1726	1874	1	1	3315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNsnVjsxcQpvfe8LsnW4eZxFwzTo4rvUYUjxkXboq4AvaRbgP
11540	payment	1397	1397	1678	1	1	6355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEECjvECK7GDtsAnpisHS1W1ZoJur2KBUxJ4ke9v7f6xcmxLVJ
11541	payment	1397	1397	1678	1	1	6356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKevUKW8rmBbSyMvLDPSnCi4AXF9sHq1W4ocNzbKUTJT9qjA8K
11547	delegation	2015	2015	1534	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskydjVsmhExNYTou3XTsH8xTtBa7XVdQTGpU5wyVVizX1ipVX
11548	payment	1726	1726	1874	1	1	3318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uH15WfH2g3gxsG58JjZyHrzPRBFvv5c5drd97ZXuoakgJd7w
11549	payment	1397	1397	1678	1	1	6359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Xt3zh1yyTDWBX72xdMWYeAm1yrNxEtV4pcRZ6YXfkqZw5ukb
11559	payment	1397	1397	1678	1	1	6363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1He4P1jvdT6VjZFLG2vwseRSqEAbMUjxAYXriETDCypBCKisQ
11560	payment	1726	1726	1874	1	1	3322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgxaZLzcg2GswFMXFkJiQtD2xK2QLxgSKH43XLNFMZ3YbfESY
11580	payment	1726	1726	1874	1	1	3331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyu8kBCpPrd32e3Taj7XrfxX7PzrYasi5U1gJsKtCs2i9dQmCj
11581	payment	1726	1726	1874	1	1	3332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNVLsdUfp3Xq8JyUcqr4Mi5ZyAxfqQvjtRjV42R3g8b8Mh3HW
11582	payment	1397	1397	1678	1	1	6373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpjyhWrM3Rui5DaxArmkwnwgnq3Kt2QENzY9vJ6cDvWroaAU3
11583	payment	1397	1397	1678	1	1	6374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMayb4N4nLLzBvqYQb1WhgN5JUMhN6hWykBZSeqLbwpKUdYnL
11584	payment	1397	1397	1678	1	1	6375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVQwcHAvnZqLHNBgXRkxHhhno5ZtpUDSVraYMBeSwBXtpD4rj
11585	payment	1726	1726	1874	1	1	3333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2iiH5JoAKUgisWNtf5ErRV6V6DYm4WDRcFTZugrgQrrJ4u86
11602	payment	1726	1726	1874	1	1	3342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAB3LzNjXmXP48gjZ7UpPjoMZcyjh1KzY4vn1QrkyZobFEuo8W
11607	payment	1509	1509	1509	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqbmbxS5JaTG4zWm5712Rqn1ZfE5AuAUPRq4cc2Z5KsWZmSzb
11608	payment	1397	1397	1678	1	1	6386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL2FiFWq1rcvV8hgZhhx8FcdWBRcJLifr15M1eaAZAnLpVXSg
11609	payment	1726	1726	1874	1	1	3345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBVuANLknfmg5yoG9VD5NwqTJmTjkcoRriQHoWRdQ3a4kgSVp
11610	payment	1726	1726	1874	1	1	3346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hSWYf9ETMhT3vyXLVUb9MxA9iFageXHf9pf2gGcvvhejWBzi
11611	payment	1397	1397	1678	1	1	6387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwcbgX1i6ZW4JxK9xEodXYuH7LHGBKdc6hr11hW9msyo6CWeM
11612	payment	411	411	2042	1	1	3	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnSLKyiByJZs4gnChei1bTVuZYWsgW97r2fK1anHSYnF6Pioi
11620	payment	1726	1726	1874	1	1	3348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQ4gQSjfgC9HEFLAmZoVQWf5X4zT31ZgYByEAG5vWFB4K7rVS
11621	payment	1397	1397	1678	1	1	6390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGwafuBW9eLYbYR4rM4SmYH2yDNQaCgECpJrhiVkD7nm9TiDF
11640	payment	1397	1397	1678	1	1	6398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagJVxixhTeurkamAYx4zESQoMNfhBtCqM5cFyfwgMKsrZUVnm
11641	payment	1726	1726	1874	1	1	3357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3zcuyiqoTAiyUCMDLvxnTjZfXLuCkaBwsfmvkotKgX6EjeHS
11646	payment	1397	1397	1678	1	1	6401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yp7YSztiEALnJqGdqA75d5JKc67D8GweSwFkCgFhRobHJ9YD
11647	payment	1726	1726	1874	1	1	3360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHYDkxjikSjEVQJCYrNLH1WE8bpToWNLZWm3wmsXHzSaRz9Rm
11648	payment	1397	1397	1678	1	1	6402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfWUQtXgjk3v3UeCYwWTNarGv1LKrtSuZxspACmt2s5Q6ZuDa
11649	payment	1726	1726	1874	1	1	3361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoNBmTsW3McsaocNBu3bn5CpS6mYdoLMaEJn3feRhVojpg7U9
11656	payment	1397	1397	1678	1	1	6406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm4tTJQCpnGe5UovbYvF4NLqixHY5xnkHPTZSVAJg4QYwyokn
11657	payment	1726	1726	1874	1	1	3365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWV1FUcuohPe5H9H74ehcmtT9Nf64SxzyijcRbW2tnGuvUsHz1
11674	payment	1397	1397	1678	1	1	6415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJak9KJWG98X1QCWrvPriwLKMNTuMZac9GzFRpFDRyWkstR4Lc
11675	payment	1726	1726	1874	1	1	3374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eDGEYnRZokxDhXgKcmWuH8uti1rdfrnzJmXVdVYLAf5Wy397
11676	payment	1726	1726	1874	1	1	3375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNdyKNDfUNfju7aCoUnVmRJPpbkgAtkqLwa3koScgjhjhs4WS
11677	payment	1397	1397	1678	1	1	6416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJMYbykQmTfujXGjkFG1nqhQSortaykgSFzUhmVkR7NFTpgmM
11678	payment	1397	1397	1678	1	1	6417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzCcMyhQbRf4KcqJj2rkr9NzQbLnLce7wwS2pLaxkm5EkJ9G2w
11679	payment	1726	1726	1874	1	1	3376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uqMnjTTkT1eWNcBwPP9xKrKDozVea9kMqpA2vKkCJebmSqjo
11704	payment	1397	1397	1678	1	1	6428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnqg9Uti5LEqYDGbnCPxfDHgcyskNLzWfbvtPYQcVjeMT4xGS
11705	payment	1546	1546	1339	1	1	4	7988000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZnk9UkLonAXQa61rFrA3SfdJYL9Bd4qsG9SXfaCS2WBB9JLNEC
11706	payment	1726	1726	1874	1	1	3387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEgWYhPSmYjUbV1yRahdUVSbFKdjjUtvT4hx8HUybCwyqHKGy
11714	payment	1397	1397	1678	1	1	6432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJHGGFNv267LfnF8ec3aYa86EyEWofuaTxKjYZd8ZHpAXjYUt
11715	payment	1726	1726	1874	1	1	3392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBG8Z8wgzrqhEsiCK1bjbQoeW3AJYWLBH12zkb7utXnHWRNCd
11744	payment	1397	1397	1678	1	1	6443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLLi1vwTUvtKh5j2rctp2oPcJkGYrNddup4RaVcSFotgnXeFP
11745	payment	1726	1726	1874	1	1	3405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZverSiAhzbc8dsaTLJaZMxTxs46wRc44RZobZBReZK3Uw9kjb
11746	payment	1726	1726	1874	1	1	3406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCurcSh8KmgHeEVxWoSyfhkbQn2cfBweLE7LottsuaYFJjsz1J
11747	payment	1397	1397	1678	1	1	6444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMk8dpCUneKNy6wBBBPQ8A8mRcNQHMComesxeXXassEDSnSF7
11752	payment	1397	1397	1678	1	1	6447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXVb5phHTgWU34Bw3YinCDAwztQAv96Gk7Bs4yFtsoBHUvJ9R
11753	payment	1726	1726	1874	1	1	3409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJFTXiqhsBKvCZWcEcPAeNVPLqNJ7Kd4V8waoJMDp27NCCgN2
11760	payment	1397	1397	1678	1	1	6451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkVkZJ8ioR5cq7RrhqEtHzLq5gcJ5JEdEfu5GVGgMcPBRieTg
11761	payment	1726	1726	1874	1	1	3413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNA2wL1Wf359JAHHGNoVvkY2gkWeyRxJofzuJu8dFfbkVdk1J
11762	payment	1726	1726	1874	1	1	3414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptvvFKA7KAApx6Y9E7v9JNYiThop87CrEKA8N6UBHtcZrZUjP
11763	payment	1397	1397	1678	1	1	6452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYgAAZw654sFnAjsj8DMLSKftANmYdswSBJTgd4qVL5jErXCh
11781	payment	1726	1726	1874	1	1	3423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnDnXMLHppsFro392QuDfefB9VtbkWafdBdSovPS2hxSfVnJ7
11782	payment	1726	1726	1874	1	1	3424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXf3PoNNAUe9iVd6chvzsVddG5qUWZLDAB1dX1fQLzXb1bwcE9
11783	payment	1397	1397	1678	1	1	6462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKN959tGRDLSq4C6tGbzvXur1dFms2qhkeK633XX7W9gBwEaT
11627	payment	2042	2042	411	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfCJJyhdmREnLmP7EmM5DFB5sTjRqVqyUqCbP4ioWhTx3aMP7
11628	payment	1726	1726	1874	1	1	3351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VskNDZY1fW4GXbyPwHkizRszBqKV5UTPWtMTXa95PxWKYhaW
11642	payment	1726	1726	1874	1	1	3358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3oMMyehynsDG321GuhNE47SA7omdzyjs3wkqC7mxLEuLc714
11643	payment	1397	1397	1678	1	1	6399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mH5JQMAQdeVosz8vPiziPzQjHbKoZBeHNLwNRSkhKwDodDVR
11658	payment	1726	1726	1874	1	1	3366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ryhaoJJ8AsBnWH9DnHTJKFoCLLd9Ejez1cktYqBSSG3hbfnF
11659	payment	1726	1726	1874	1	1	3367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n7u8AWSxkeUnZReyKHBc6KfBMayexhVcAuJKceeYXj1oszNP
11660	payment	1397	1397	1678	1	1	6407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKGi3ET8GBM7YH7ubcdnXvJZyUouMaytykxoh8bz75n6eXyvF
11661	payment	1397	1397	1678	1	1	6408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9n2kq7DLNsybVjGAojW23xPqNcnhFjap61yizw9hdvxwfd3Y
11666	payment	1726	1726	1874	1	1	3370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FCPk6SXMA9R3D4btQMnqs4Q1sPeZRsBx3TLieznbLVQ4yvr9
11667	payment	1397	1397	1678	1	1	6411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYH3W9nsPqr8tyy8oUyXQKZUkcjxSc2qPFuNwkg5hy8GUffQEW
11668	payment	1726	1726	1874	1	1	3371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56CSg5RqsXu9gap9A4QT5s4HEdhYxDPVQ1AzZ6JX4Hqo9CR65
11669	payment	1726	1726	1874	1	1	3372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ125gpRff4zyzeQ9ishPijWxxWbJxqsQsmgohA2VqDNXEcWYpR
11670	payment	1726	1726	1874	1	1	3373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFF49WsWyS7GWvYdwCczjkWty4ZZFua8QeNA4CQvejnFZtYCM
11671	payment	1397	1397	1678	1	1	6412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtfNpF2zpbraWsah26hjz3QNcj7xsXzjdKSto91kqLrHmitC2
11672	payment	1397	1397	1678	1	1	6413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttnyAjpDoGxb2qrUVdCjJnBWkb3VxFD7UfBZV9cA7pmCCKZeT
11673	payment	1397	1397	1678	1	1	6414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtqoy5qhiHdhV7S4FShczTCAsML6T4BRYgEg5ZNMEQjFEgey
11682	payment	1546	1546	257	1	1	0	1000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpYbjwLPSg5pDZa9SHbEFuHmoDExfpMNzVerQB9DaribBoNEWiKW
11683	payment	1726	1726	1874	1	1	3378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgiQdKS3oLnfgUQTCJHRLQBgmEMGRx6RJiyVQ75U9ihsUhqXP
11684	payment	1397	1397	1678	1	1	6419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3MUgw1RVvtAuChhV8QtZjsLB9QtzZ487f3ZpNsaeRDGKhnnS
11702	payment	1397	1397	1678	1	1	6427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsG9XZYj1F7eTiiur9GmYxJYbqyD9qmbbwa9cHmBoKxcQo7qas
11703	payment	1726	1726	1874	1	1	3386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcC7q28ZdgQ7Uwb11Wt2avzzbKUwcgKc7AkZ68wnGZwmEitSC
11711	payment	1726	1726	1874	1	1	3390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QpyDxT5uJ48FBCrywY1DoJJbJkCAuX6ipdDemdodpWtxoPEV
11712	payment	1397	1397	1678	1	1	6431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8eZQ3hGi8uRahcVAhwKsGqskpfzeMcZZ1kyXygAtdfkuixNmz
11716	payment	1726	1726	1874	1	1	3393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6ZGRDu4hwphvjxV64EuKEv7WDKigup3ruT8oNdMHrSFUFqzd
11717	payment	1397	1397	1678	1	1	6433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixhif5fVxKHgwF92ytkku4JMapMciLh86ocRSXugiDKegcRha
11718	payment	1546	1546	257	1	1	5	1244000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZq1GEF32uHgp3rFmWUeLWfTePveCT6hFYH4wSj2Mjjp2ak1tF3
11719	payment	1726	1726	1874	1	1	3394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDB7mVmukSjof13kabCgAvuhwnckBZCvrCJapzj74Uy6WuGQBb
11720	payment	1397	1397	1678	1	1	6434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSE762YdkdLyoCtRSTWKzk1sexvCj3VfvX1yYrYSt4adcHuRK
11723	payment	1691	1691	192	1	1	0	227799354186	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpYmMwD32NLEVzPperekWqQwzki7UiAVdY5jVNd5RdLoxECWCRFq
11724	payment	1691	1691	918	1	1	1	1732430933512	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZPjiMVrHVVVCckY3vRyr43JUBrg61NoVVtgsB1zcMcHrKfxkf1
11725	payment	1691	1691	1038	1	1	2	3104501389392	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpYUKT7WPTGniweNByfWJ5gd9XaEP1HQzX9VSZikKScdcoe7ku4o
11726	payment	1691	1691	1158	1	1	3	2094668948983	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZaexqaoV9y7AjDRTorSHGbGJkSyHcKMWtQ64QatyQmk9QqwtLj
11727	payment	1691	1691	1284	1	1	4	5836981273908	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZMLTEDjbgKCP7S4ZWn6DiHNuSQjTJYUGQN4Uv676HJ5P6SNCxd
11739	payment	1397	1397	1678	1	1	6441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyoNnuRpp2eddY8eLUswqihN4WfDciU2Uzji1uP5jDy9yWQKQ
11740	payment	1726	1726	2044	1	1	3402	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrQaMsTQVUwDaktgWs2mpSVk7vJBsGkL4cffLPJYkSAJjBrHBJ
11741	payment	1726	1726	1874	1	1	3403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY87V9RSnYEoFD68a5UE9q4LWF3ryHtNjwvxdMAbQZq1LyLCMx
11742	payment	1397	1397	1678	1	1	6442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedV1FKpWHNeqs2PijzFnVZP4itekVJbDEUnnd3buzdBGeMVr6
11743	payment	1726	1726	1874	1	1	3404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCQqzVpNKF6KGVMgt3PxaJ21zA3dJeWqDabEAAZNaRGc6tAmS
11650	payment	1397	1397	1678	1	1	6403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT1uAY9PgCh3rTW2F3Qs48HK4K5WdTj5p4WHX966T6xwDQMPa
11651	payment	1726	1726	1874	1	1	3362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrX96SMqSMah7xSb91xWqiuAR6531PinsmwJA1h5gjZF2cpKy
11652	payment	1397	1397	1678	1	1	6404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4PyoUAsLYGNr4USohjsD3jvFdDJLFfYdvnRAPMmMNMxtSia5
11653	payment	1726	1726	1874	1	1	3363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZkLJwFXABuNvER2bzLDHuTvy57AyYS6zSXPwW2cFo6AwqdL6
11680	payment	1726	1726	1874	1	1	3377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmgKefDoiz9pKZSafSEtY2A4kjVNfmwF8MBALAiYo1emRmchg
11681	payment	1397	1397	1678	1	1	6418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieNZseVkACs3fBLk5Ts1yx3pj9t8SEBcb6cHPqG7WKAqcGQYP
11689	payment	1726	1726	1874	1	1	3381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCdZmvHpQnJMoButYhysAibCTDzb5DrmB8jN5vWjFuQuEMrVPy
11690	payment	1397	1397	1678	1	1	6422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXKpkbxrA1Byy4hgJga7CkKipJ6NRwo4J2bKPmGmM5iFmNmxF
11691	payment	1397	1397	1678	1	1	6423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiNFWd51y2azimDxEnSq9dBLkM4jzq569Suqx9WXrRQvrH3Nm
11692	payment	1726	1726	1874	1	1	3382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U5cjLuHYfFq6BAJaY8M33X8bP7VLi4JDYCANGkiE7dgnHMbV
11698	payment	1726	1726	1874	1	1	3385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8F3SujVSuX7nvJ6ZVk1kKNy73otYm49zugQ5nCKTFShQ7Wy3E
11699	payment	1546	1546	1213	1	1	2	2867000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZd3qHqACj9G7DBuqSK91pHsNQuBi9ycb3GX2UAhLYmc9oVn4Aw
11700	payment	1546	1546	1093	1	1	3	4249000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaBAwC5rPN5YoR7KXwCbjFBQuZvrHh4q35P95Lorj2NnWMZT1VK
11701	payment	1397	1397	1678	1	1	6426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCuS8T7fXXm7QMoMQHz7fHWPGPhttbUDpwg4Nnn6ZdVCqUy2d
11707	payment	1726	1726	1874	1	1	3388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZuf5rzgBueNhrFUNKf3G5YTwCdJ8Hvw3bg84WQKq4w1SUSn6
11708	payment	1726	1726	1874	1	1	3389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGDk7a4NBvCrFEiSSGPkfuijWF9hDX9UWiBnD93mu7r5SzKm2
11709	payment	1397	1397	1678	1	1	6429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWQbq55ztS76r9MZctx127wW1ffQaQ7JNABEMA85fYW8HQtjc
11710	payment	1397	1397	1678	1	1	6430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4iJ27YtX8ENd1CSrK88x1SPi4B8o8esDXjoGKmoggToPZKLh
11756	payment	1397	1397	1678	1	1	6449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCut5NXEokQFAkFVq85PnrbKxNknuSumQCa19yaG7H61u4tK1
11757	payment	1726	1726	1874	1	1	3411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQcMmEDea5j439berQJCYAaqcGb5rgL4pQ8UeizN91XvHyYsQ
11758	payment	1726	1726	1874	1	1	3412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnDLMNBdWfj2PBegP6obaCSJtnURb5rXakdA8kCJJRZKW2azw
11759	payment	1397	1397	1678	1	1	6450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FqEwKs1Qrmygqk1k7zvx9FoNBGwJxnB6dPXQ35FVQ4kcwaUy
11766	payment	1397	1397	1678	1	1	6454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfRKCPPX7exkxsoQKJ8wA9b9VzMCfSD4FAC89tNyakihTMyNy
11767	payment	1726	1726	1874	1	1	3416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzgdihufbRf1YaFFtjP73ytmHXM46Kjgjoou4SHup4jWBf7kh
11778	payment	1397	1397	1678	1	1	6460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawXPbMGqifsL44nNy644RKT3GTA4Qd1RaS3cnhuZwP4BA623w
11779	payment	1397	1397	1678	1	1	6461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1NzQAZiu7byLqqycaZ399SmHHFEByXkoiRgR4mJAFJCUkaRt
11780	payment	1726	1726	1874	1	1	3422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnivEqz7Ef3Ewoq7iLvZHH8MNyzEXz95ewto3x63CuoD5WPZN
11810	payment	1726	1726	1874	1	1	3438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEARwXxQhK5jvwEifr2PnjQo8T6nxSkmAMMexBPGPcQvAMQtpY
11811	payment	1397	1397	1678	1	1	6476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh3c9N6wYoGp9X9sfySCykPYmUgPT245wKmeWvmKU5tTzKUj4
11835	payment	1397	1397	1678	1	1	6488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuXbvu43MkeqMATPKVsEwkwK4nrss5WFayBWC2AYA3HNPEKiF
11836	payment	1726	1726	1874	1	1	3451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggbqPfVrPeo3bDvPNQVh85Z2CMMjGMB1x5co5T8btnRSKDGRd
11860	payment	2046	2046	1937	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfYZBnrkqyorbYse5i9FEnnZwfjuE49ehe5XJCPEaawWp8kxj
11861	payment	1726	1726	1874	1	1	3463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZXAbAxuHERUWAs6weDxcQiFaucF16oKLiH5gDhKERAJeAHa5
11862	payment	1397	1397	1678	1	1	6499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ri4hXgR7RtTvHZL1WovhcCvaEL7SQEKbnCW8tM43fKJsccZm
11876	payment	1397	1397	1678	1	1	6506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRggafXKFK71xL7BSExSHTUozVzCRKLJcpejhreqJqc7j1bXh4
11877	payment	1397	1397	1678	1	1	6507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1hCJQ3zm8grp6XCbNgHTpzWv3mJ2XkE4K4TkzxMtmLQhqizX
11878	payment	1726	1726	1874	1	1	3470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAdnLHJLW8n1mgUUEcuFk9sCfaie8p3SSdNKK5rsrdMRXSGRS
11879	payment	1726	1726	1874	1	1	3471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRS6Cu5Huha4U5kshbaf13ktp9afjaWsq3hepGtfRjjJMi8GY
11664	payment	1397	1397	1678	1	1	6409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSXwXCGQ5MqegphFScjrbShE1pPWMjGtY5XwF1o7B3H627naY
11665	payment	1397	1397	1678	1	1	6410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7NnSewrcnyZkRPzffBX3m6FLWjJpZ7QFod4CSq8RmKP6NLPQY
11685	payment	1726	1726	1874	1	1	3379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofKKCf8HceZArnzbuqXfyitkH14d23wfJjYsdfEqz8frpDXW6
11686	payment	1397	1397	1678	1	1	6420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJk5F7GkuT4Ud7ZVPmS2L2iwnj9VDDjkB6oLt489y8m92odHo
11687	payment	1397	1397	1678	1	1	6421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaZvrvYPpqRzPuiUzrJWCvZwQmCXXTNdrLTA3tLjF9VhHevX3
11688	payment	1726	1726	1874	1	1	3380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFkRvGJGGnx6be3jbY8DdybGoEn5Q46JQhCkVJ37hqdkKWtvp
11693	payment	1546	1546	973	1	1	1	2371000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpYnFaHrstARDzx5meckKtL1vgzHTCMeFzfQrXoAbDYKh8UthxWS
11694	payment	1726	1726	1874	1	1	3383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PiFsbpCcBW1sV8e5BWzx59GJHMt71uM2Ei7DnbLb6UUqJnmY
11695	payment	1397	1397	1678	1	1	6424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8f6VEPwiJP3HfGMBCVGbfzVcsr6Gx7MQnDbgtTnEgfUwK7ia4
11696	payment	1397	1397	1678	1	1	6425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacveM4F5dzbrEwa1NmJwFwSUBjH35rt4zdvtrTHaTSmnP3p5M
11697	payment	1726	1726	1874	1	1	3384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3u2CQixB1R3RuPsAazEEXEAZ5RCNV4a9ePtgQSJr3MuvVJGcc
11713	payment	1726	1726	1874	1	1	3391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoq35b9d8ooT8w7EYvTSK7PUsmdc9tNWv5r658mjyNBr7xXFXv
11721	payment	1726	1726	1874	1	1	3395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPLfLoHaFL47VXwaRT4fMJAymPvbpVV31Lgm8cFQNGE3VEKdL
11722	payment	1397	1397	1678	1	1	6435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mmnZU9gzFwUQymiRAUnsHB7MgtmLQvKV2eQbQPvN8eaepA9z
11728	payment	1726	1726	1874	1	1	3396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYZeWGHPnu24kG8rmzNtvFEetdkoHFLvHuSP8uBWn7xqa1YsR
11729	payment	1397	1397	1678	1	1	6436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAvk5r4QrwVAqNWdyQRxfBAfXpVc2FbpGR5xLYMMzc2HFbyt5
11730	payment	1397	1397	1678	1	1	6437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1LyxK73xXbGWVocGjaTNEW7LNXRQTk7a4KLsZ46kDJuCNuWn
11731	payment	1726	1726	1874	1	1	3397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfHohnysmXgfdQ4yz4ojyrfUouZr1KGTsqyDzz99oBwCc4Q1L
11732	payment	1397	1397	1678	1	1	6438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCR71HBH2HvcRCQBJ9NsBE8o47bZPqoeDzuWVTiRrX4fcck6UA
11733	payment	1397	1397	1678	1	1	6439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoHFX5bWVjmrWAqAUcLZYyC7uqTEmdhafSvTTfVi3rDdfDd4Y
11734	payment	1726	1726	1874	1	1	3398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GoxP5afEzhSfJQnvMUb5AjmbPPKykZTUWQT8d1VV4EtMGqUi
11735	payment	1726	1726	1874	1	1	3399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcYzbRmxR3WNXRWqDdYx2KmXe5JQ71wrKsfJ2FvTY1H8cAzjR
11736	payment	1726	1726	2043	1	1	3400	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZG5euYbcNFH2bTiSygtTiX8fz3hunmXaDxtfZw2z55ztLxCVyX
11737	payment	1726	1726	1874	1	1	3401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyd4JSSYh22TUihTECnHNuiq2zs2cvu7QxW3tfsb4EbdFiFi9
11738	payment	1397	1397	1678	1	1	6440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmapYrRV8CKQQJ4Y1qDYiue6mWtYRb9zkxhitT9jYv1X46D8nm
11754	payment	1726	1726	1874	1	1	3410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviwPgnmBwCfbrFWfGCtKfRXfUZCbLqnKHbrfMKQncCGc3hrsA
11755	payment	1397	1397	1678	1	1	6448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4NwBVXG1L7GuJDF3FfiZofrTtC6MuTWK6vL4cPZj3j2GSG2c
11776	payment	1726	1726	1874	1	1	3421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgHKUeprpKF9bD6CRvtT4VoBZguPFqEkwVr6TqM88u4e6cLTB
11777	payment	1397	1397	1678	1	1	6459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiWbAD2EHfNpbjtcmrR6MitZSiF5KUmBhrseuTjFZiXK9TFQu
11791	payment	1726	1726	1874	1	1	3428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGTWatAyX7gQX9i9mFAQbTqWW54pzxwGx1LJM9q4EvC1QKCSZ
11792	payment	1397	1397	1678	1	1	6467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKhmjrphQUL6GEUeQ4b5CjpiXPb1LgxhNgsrrEetv4UBdRmEZ
11808	payment	1726	1726	1874	1	1	3437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8QVFSi71XL1J6MwCHdzvoK98hQv9732jht9aHLK2r7EtCyWE
11809	payment	1397	1397	1678	1	1	6475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf2u9KVqTRB8TG15bRJfkk333uFCApein1QAtJZ5gRC72QKCW
11820	payment	1397	1397	1678	1	1	6481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6yWpDAjqDF7HeZ1DsWD9Tm1PAtCLUgVchZGq8on8heAgosRg
11821	payment	1397	1397	1678	1	1	6482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHBa9mXuWa1vfa49EYyqmAs3JSf6AiJRE6Z78ETAZtqhPePcE
11822	payment	1726	1726	1874	1	1	3443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QGoTZNQTsTvT7H7qY1mRbLqYd1nYvGiRPaWhCfx2iBZs9bnS
11823	payment	1726	1726	1874	1	1	3444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXtqAR7XUjJXCHiiHADGpvweHd5aoXWP4BmyhiT2zwzSyQsyQ
11824	payment	1726	1726	1874	1	1	3445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRGxMVBojSHQpUiF7ZSjzAbU2fLP5EvCWUFq3RRMA8EhWPnau
11748	payment	1397	1397	1678	1	1	6445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnRm2kSZRdLcQjDGgNkQp3grpJTa7en5VLzyb73XrtFvZsvfV
11749	payment	1397	1397	1678	1	1	6446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuS3cxaTBkt29XbXDsCSrkpLY9SNiLpYMTvRyfnu28SCBVcdL4
11750	payment	1726	1726	1874	1	1	3407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNScgr6xg1y7btMV8jpv1cc4f3LmzFfytgdsS21C6gFHe2uEw
11751	payment	1726	1726	1874	1	1	3408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWnnDKDkcpZ3r1yDXEYgzn3uu3VburogMcHyFqzjwReKgz7WRU
11764	payment	1397	1397	1678	1	1	6453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeCnUYmbV7TeALSMKf9j79PV3WYmToQ5jTmcBKmcfsU68tz1N
11765	payment	1726	1726	1874	1	1	3415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9rvJxtC5EasCwK1azVxmzgNe1mAoJfSbxhb3ZBKMPAnDTbQK
11768	payment	1726	1726	1874	1	1	3417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9a95YRou3jKek3fwdvnzJ5jW2xrHVJRT9u9t4qstZUVdwFZA
11769	payment	1726	1726	1874	1	1	3418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa78KUSYFeGaECvNVVPxfWGSNvBtAXHTn3p2EXNFT9HahtBwTy
11770	payment	1397	1397	1678	1	1	6455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukDWvxEYa7QbH9RZxTnw2APPCjZJH5GfVegK1csD4MgAbdQEN
11771	payment	1397	1397	1678	1	1	6456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94vkePwKrE5T8dXgfiykLRbHTJfC4BRWgScUnpMCnhF5iv4JT
11772	payment	1397	1397	1678	1	1	6457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76BD2Tc6FjRmdwttwV5xL8b9VDt5UHmdD54FpSd4uZcbseFpN
11773	payment	1726	1726	1874	1	1	3419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhQcdnCSL7JKfbanpcD67ykLz3XRgHQzSCrBXSs8KQK1Jw6hm
11774	payment	1397	1397	1678	1	1	6458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8ph3K9X5247rVg2TwfotQU663bSrEyBZERqGJn83PoaDuer8
11775	payment	1726	1726	1874	1	1	3420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YZiBzVtLTDFQWVm7S5F62Cx4Pkj3G6WXBQio9Um3yuSmVD1K
11787	payment	1397	1397	1678	1	1	6465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59ELrJJgx2jH9tHMJ5uabjmHDyz6UVdea3pktHyoZH9XTRLER
11788	payment	1726	1726	1874	1	1	3426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzFBiQAxfbMgawha6WyJ8hPGgo927QtJsWm8cFNUq5iNXAF31
11789	payment	1726	1726	1874	1	1	3427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVg5HUmhdYXfYXbjyEHSoDZrydgz4WhjJAfmMdz9tS6x9TKUe
11790	payment	1397	1397	1678	1	1	6466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhS8V6YYekQTm3apBrJrsXfWHGxe9RksaAVsMbeKWpbUrYxbtJ
11795	payment	1397	1397	1678	1	1	6469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7FWMN1mqgTDGDKdUciVNZjn3CuxbKwpkW7DpgLrfWVdMi79s
11796	payment	1726	1726	1874	1	1	3430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGQ9S3PRqSVtAn2snvpW87uk4bbEGz57KAiP7aSE9AB4s6xZf
11816	payment	1726	1726	1874	1	1	3441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGHYbk7iShLmwRnCMsQJBeDZVEw39cL3PaosA5zwMbbKp2HtBp
11817	payment	1726	1726	1874	1	1	3442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNoq6fhrQj5j8bKxmme9NM1Rn5wuuS5FN9GBdDUEHsufFN6ZgU
11818	payment	1397	1397	1678	1	1	6479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCWy9j536tBxJNetm1F4WpQqqztkf7trHLd5VjporgXZQsd1R
11819	payment	1397	1397	1678	1	1	6480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppFetZ5jsHmA1AKreH2HwaFbUMiZWv7B8TZf62KcDQZ5o7zoc
11829	payment	1726	1726	1874	1	1	3448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRMNupz85JrjHmzixzCHoU8Zq9KtBRZPKuXfBibt5bDHGnoJ4
11830	payment	1397	1397	1678	1	1	6485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5L9fNNDNKfgtdg4M3uBvH1s7WF6yYTD1wBgx6E9YC5qyBudn
11831	payment	1397	1397	1678	1	1	6486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53r1x7nQGsyQn73fu8joqmkR4JoAQaoXR5FXmD6uZRX7DfPao
11832	payment	1726	1726	1874	1	1	3449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKprxmJaKh3Rj8toKcFdoCTa171dzMtcqwzpcXptU1gWSgXuax
11837	payment	1726	1726	1874	1	1	3452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAw2tpnkkmdNmaKd8UKNWq6MfrMPsHiQdQ9xEWJMo1NbCSKuR
11838	payment	1397	1397	1678	1	1	6489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh28H7Gfd1i6uy8iwzezXLARpYYwGaHdSZ7o2wg3cnRQKSeRfQ
11839	payment	1397	1397	1678	1	1	6490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXCeJd3LgL4xRTXRAi9xKb8i7nHTcLwYw6GZh3VTodrhHDEVr
11840	payment	1726	1726	1874	1	1	3453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsPTam8WPCSBPzfS1f7GV3fMdBnMdWizVMZL5MNxNKxJyVjzg
11854	payment	1397	1397	1678	1	1	6496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYphBSJAqiS8TbsvNvCAEYcY2gMruJC4Lo4Pe7sCapNsAQktFU
11855	payment	1726	1726	1874	1	1	3460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSVEybBvjLEUwMCjuJe9qsVSwEroorcQEnP6YgNphsqSXdN4M
11856	payment	1726	1726	1874	1	1	3461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9NHADg9pKVCmLJGsnPQB1N3t58aBUdqXNvhmjT63SDNNzUST
11857	payment	1397	1397	1678	1	1	6497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQkajm1ciAQysC8CNQkALJn7QFpCcjA3RtWnfexmvAURuYeXz
11881	payment	1726	1726	1874	1	1	3472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5DzjFYkbmRwBTLxwZecpFgsXTfRqGeukbv8MPAm1QmhjtG5j
11882	payment	1397	1397	1678	1	1	6509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfugTKFWCJ9A2fWDsTUcsDQPJVFQTEkL5ARU1D7cQYSSNaMnuB
11784	payment	1397	1397	1678	1	1	6463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9tGyCwdJ1wzzgKz17vxDByQnSJELPm2yBaELbXVN3qWnSdUd
11785	payment	1726	1726	1874	1	1	3425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6yvj5qxeFGwYaW9Ao9Z87ySYoRr7KEs4yFcAv2RNtqctR1Ah
11786	payment	1397	1397	1678	1	1	6464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLqKTwnmPgTmCNobsCx5fhzfmB6SQeSXHwwEj5r9bxpwA23XU
11793	payment	1397	1397	1678	1	1	6468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBChGuGjAJQZVEWkQLno4UMwHufWhXdVwR32wMNntkXutbNR9
11794	payment	1726	1726	1874	1	1	3429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4XQZxH7HymZdNWDoBCwdmxtsp6LRHHNzSekKEuVZPaGLh3AY
11797	payment	1397	1397	1678	1	1	6470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrfBCjPLkX6kmGcAqgVfqJxrVx5wrQKoM64ekEYQePRL7dKAU
11798	payment	1726	1726	1874	1	1	3431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UCt2a6QiQLiqGruKEA7wHeaLvypEc5MhHF7zci5iT8ZcshG5
11799	payment	1726	1726	1874	1	1	3432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsNJCJHjPyWFc5n88BmJYXcwcAN1GfY2tj9CWsvaAp89uNXN1
11800	payment	1726	1726	1874	1	1	3433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5yUHKeiie1WazQGZ3C4p2QjBXmEvUZwVugop8RufMRyGEc5p
11801	payment	1397	1397	1678	1	1	6471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PuxocpKbSKsRU4cStuNUUC8FhB9xtZdXiidnnbjDhGo1vJjt
11802	payment	1397	1397	1678	1	1	6472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJA3FkVbVmTFYmCtLccFGT9FunakBLJA7ApVh5SEBvxqyh7djA
11803	payment	1397	1397	1678	1	1	6473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEJDfceBzRUSBjVcqKtBMjt7WNim1RxbtiL5WPnjaJFz5bA9k
11804	payment	1397	1397	1678	1	1	6474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BLCNnuHqqcF7nDfopBrWVcFRiFbQzycLytNrotaBGqJrvtWp
11805	payment	1726	1726	1874	1	1	3434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQrc9ne3dQuKdk6D1m9i3zZfzeUuMcCidJsBj5ye2svKD2xTZ
11806	payment	1726	1726	1874	1	1	3435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq96dyhLK1UafwNoYZcAWJaegKBAZKRxS47P4c1KZQGTvM9ei
11807	payment	1726	1726	1874	1	1	3436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvJLJqhy23cQS82tfxvgdcQVFTPvAmhnrp95Gno1AfiTKkiHt
11812	payment	1726	1726	1874	1	1	3439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwojrE1nDMgbFoHajzk7UwCta2V7XVbNc4hVmFGvbeC3QE6M7B
11813	payment	1726	1726	1874	1	1	3440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1LzfFWxwjNqJ7gSyx7TdtE73SYrXPo4h2g5g28kBpaAFyjvh
11814	payment	1397	1397	1678	1	1	6477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqwtjFQpNAykPEdgnkgs9FwFeToLd2Wvk1NH5qEXqstw5r28y
11815	payment	1397	1397	1678	1	1	6478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKihspdVEGH3kDAZHt63KFBgf8VnrugVnGsTZ2uTQxpNB9G4j
11826	payment	1726	1726	1874	1	1	3446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFUynXjwq5ZpEi3FHEzDPRhsdpBQYKvnad63EaYq3gDN5yHoi
11827	payment	1726	1726	1874	1	1	3447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5z1JcnLEonaH8rGUb14P5e8kvbuxGgRfDfc817XBKMNxbqXw
11828	payment	1397	1397	1678	1	1	6484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAyTmY1QkqJNU8p7PeTdQ6GyhWSjieBAnjtDs1y4PudvLbD3M
11833	payment	1397	1397	1678	1	1	6487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSXu4t1JMVMNo52Up6xbaJ9e7dpYMdehvQ4PptXmApCg4YfgX
11834	payment	1726	1726	1874	1	1	3450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYKD2hFcThZ7RPj2w67cRquiJdyyZb6YsxrppPvCmRE1Ph7eC
11841	payment	1397	1397	1678	1	1	6491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSXYQouuDEi4i4tPnRKgYsJpBM3S1NXpDa5EW68NBEyzB1mBK
11842	payment	1726	1726	1874	1	1	3454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCbsJZfgh99VDvssoZJLfqt91Qj4DkKQiV1fBMURawLf1ANjw
11843	payment	1726	1726	1874	1	1	3455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTBUdvAaYXzKcAySN2f1jG6K7wnBoGPNPpqPCbTjuCiYURCKv
11844	payment	1397	1397	1678	1	1	6492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJQcp9S12tC3hktRRtPUdDE3c1775cYwhP3LZiGnSpWUCvMEY
11848	payment	1937	1937	2046	1	1	0	1300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcaULwKGXeJNRTjN5tGRApMW5bUArBDspdyWkKNh1oqd2X5Bz
11849	payment	1397	1397	1678	1	1	6494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEZ2v3yyLajySZ94vCqSFLHmiW7V4QGpUGuDV7eXBf1dp2J7o
11850	payment	1397	1397	1678	1	1	6495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfQv9GdMDVMa9MpSYhCBcxJTUkbi4NZ1USNnJTA22b13zNJzu
11851	payment	1726	1726	1874	1	1	3458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJw9QzG9zFAmrbF9encxnkuj91VNXZnwpqmuDTwPThrJs4aLK
11852	payment	1726	1726	1874	1	1	3459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33YUGSSLKQXVUggnXHibMZcSEkrs6VtUsxuTpax7nugUeu9Ky
11853	delegation	2045	2045	2044	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjVyTDq9vf8EXCfeu65bLfjue36HRRY3LmBrYmjqwdQUTcG2E
11863	delegation	1937	1937	907	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Qbx9bi2BUmB6KN5Yhie3BY5yds7ahGNE1JFVxditTX1JYGCc
11864	payment	1397	1397	1678	1	1	6500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSdQGqrKydT3UG6dBRxLvqa8Ei9ZjFNK2WPeAjPTCztfk9wEb
11865	payment	1726	1726	1874	1	1	3464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6XbQnnBvUunAkLTUdY55m9Z41f3uxJyekVTfLmgaYvaxPf6H
11825	payment	1397	1397	1678	1	1	6483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFPUKvF3Cftn38UHyNKAxQ2e1v94uJHArWEnZtq3dEBEBXo6m
11845	payment	1726	1726	1874	1	1	3456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhs8PrBSf4DFyq4BWm3FgUj6A6spX4XHako8WMY1mSpUXhdfMx
11846	payment	1726	1726	2045	1	1	3457	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkk9Lp4a5PzfyHqepcYj3Zpw1XWonqpkdruaPx7UVaCACKZQ6s
11847	payment	1397	1397	1678	1	1	6493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuM9LS37HpAQkvFdHdUfhsnJscoP5pHhfpcSV3knLXpvx73aa7
11858	payment	1726	1726	1874	1	1	3462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8soWRmaKz6dbbF1o7jomtjuvgPNKfthPyrv6o47WgzyW5pbKz
11859	payment	1397	1397	1678	1	1	6498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9BhKoZWL5nKYVBb8q5ZQsG7qbyGt6aFGwTbbWaVQaM1HL3kC
11866	payment	1726	1726	1874	1	1	3465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdydBMMModruR8ZonutE4qXBFUCrkVJ8gXEMkxYQv1mEbYC8gX
11867	payment	1726	1726	1874	1	1	3466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsBfXbFj6TugVTxQe6oncCxijDmsZ5gfp1dDRpvw8ZGQ1Tydd
11868	payment	1726	1726	1874	1	1	3467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZremUWPFMB1MQxxt9bdCCTq8H3fMTLJPom1gMD2RPq32gKLm
11869	payment	1726	1726	1874	1	1	3468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUCS8CVCDoCYRDL51aPybdGp1AobbihRppVgWmbZNKK3gFNY2
11870	payment	1726	1726	1874	1	1	3469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksW63Gi5ES7MBj11hC7JFGuxLa1QmEXrosYZvBnyHyRngxxMi
11871	payment	1397	1397	1678	1	1	6501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNP1FnUv94SyWwmhbwS2obmKW6tkePEx5WjxV3ripshWLm16L
11872	payment	1397	1397	1678	1	1	6502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrHQoBNXnFdrb7J6nUMdEPLKNThb3A3QnzBMeEawrxQ3qt4rm
11873	payment	1397	1397	1678	1	1	6503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDfnwnkekFVTtjrgtz4AT6RrNQDRpZYmwHw96ZpKNKPGp8qqg
11874	payment	1397	1397	1678	1	1	6504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARb1vrnpboZWXNtsD4c3651eWAzrtd8Yu1cpY2RPYRNMxjhrn
11875	payment	1397	1397	1678	1	1	6505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCnWZXiVwrCqkd9En7DaRNf2SoGRDiDrz923HHezdQX1ie6qj
11889	payment	1397	1397	1678	1	1	6513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBEujXdufWFVPjchx6985yyakfHCgHRkkUqVBaiivuaobnSdz
11890	payment	1726	1726	1874	1	1	3476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS8LSQ3G9decrdBuF7R3FRAe4rjz3thcJsY1NivvsHjWSXnFn
11899	payment	1726	1726	1874	1	1	3481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aoZPmKW1ZSUmB3y2Gk7tHmPnbGb9Pu9h35hNroXZMGFPTpFB
11900	payment	1397	1397	1678	1	1	6518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLCBjMRy3EuwS9oaDRqMkf56chWCHy6kbj69pBxaVGueyJWib
11934	payment	1397	1397	1678	1	1	6535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ywxigXZ68YEBcZRUNXBB7Wr8ePVW4Kb6KGBTipL8qUFgGtPS
11935	payment	1397	1397	1678	1	1	6536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNEfgwiUri7NDtV36buikXNq8n4PCxmFJQe1NBWyKazDyJL26
11936	payment	1726	1726	1874	1	1	3499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwU5wWuFSYmBCFe9rggXBji8hrC1QQ7w7pLa14hX3t5B843omR
11937	payment	1726	1726	1874	1	1	3500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FBrKmCkME2vPMurJWx2RpHLugBxMCHf8eQRG6TPjRACZvnoq
11958	payment	1397	1397	1678	1	1	6540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY2VFkVMZvKcAXUdZdT4us7n5Gp9aB59adSD1H8okp3UJzj4a
11959	payment	1693	1693	251	1	1	577	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZsRQuZ25yeMtr9uC3pWE2jkJuzH9dgAygtd6EECgACD73bVm6p
11960	payment	1693	1693	99	1	1	578	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZVjJAXR3swb5SU37BrnKx71Ei68W4GKAvGT3fPHAvHYd8RvuHj
11961	payment	1693	1693	570	1	1	579	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYq7EhjY2LTsuaiUtDd1H1Kb9TWa6Zbkw2EQGgjm4db61NuhErs
11962	payment	1693	1693	893	1	1	580	327851556730	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYUte4xw4ABSGSrJgdsFycmbm1vTYphcCHLxJBFGpmYmeao8fwf
11963	payment	1693	1693	390	1	1	581	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYyVgAHuveYkfCAsAKeaLSzaaPSjQt68NKqEQv782qDgKfHw5yK
11964	payment	1726	1726	1874	1	1	3504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ReSX9w2ZT6iKi19xcnqmo8WJmKTgynYurD2AZzDbxG6U2Tyb
11981	payment	1693	1693	402	1	1	594	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYvPg8QKFRNbSyeN93TbkkgTjwe7SAkwX4kmdKz4A7azhpmU4mP
11982	payment	1693	1693	275	1	1	595	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYneQxeUigWCFHgmaoJ5S13pok9ziBo1sBAeMjoHwjsUt3S7ZK7
11983	payment	1693	1693	163	1	1	596	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa7Rkxx7eRQ9kr5UWHnQo43rh6CLi6XfGmyGieqfUd9YicAz861
11984	payment	1693	1693	397	1	1	597	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZK73cf7YrUzptYPaC2DRAh445WNCFgXhdP5kHQmGaVC2hoTQX7
11985	payment	1693	1693	391	1	1	598	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYRrNr7f91QntpvVLn6tR52uvMqaK9bjL3hXf98Cn4VC5g2ixGo
11986	payment	1693	1693	452	1	1	599	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ9K3nxYn4ouv5uThrkQGZ29srwWc2eBKzQ3rBWHJZbD8w7ud7p
11987	payment	1693	1693	106	1	1	600	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYW2tZhVPTJZMK9uYAbN9D7NyynT8ABQnSqRUbS4n7A2YBvBz1b
11880	payment	1397	1397	1678	1	1	6508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEJo6GSEPrVHEg77X1zyAFPYEzM1EsBEptgDVMSfJiLWJnzFM
11887	payment	1726	1726	1874	1	1	3475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4a8HxWR1uTW3bLJmwh2Fb2WdhAKQtfoBC9TKMzYMiSGYuHzG
11888	payment	1397	1397	1678	1	1	6512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ydnRLzxQog3jsxxVUQ4eVRyDPk4CVoEUF8KZz2eWWPw3w2kL
11901	payment	1397	1397	1678	1	1	6519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9WQTfNGwZB59Lv8xsEmHBrfNyRUU3zouhwQJE9eRgzSD2G1b
11902	payment	1726	1726	1874	1	1	3482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CaYKjKSpLsETWrwcbnEtpz9nAhD8SpYNmsAFZD3reMWdDXpU
11903	payment	1726	1726	1874	1	1	3483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkekvwRsAWBMdPJurSQjkiqcJQHy2S4PgEivsKmKNNwt8w9yv
11904	payment	1397	1397	1678	1	1	6520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TPsuSGDifQszUpuxSbVgUt9ZKHboK6uARXcTK4TDyPn5Jxvw
11905	payment	1726	1726	1874	1	1	3484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57TccxyPnD4U2XGWyFaMRLxL9fySG842hLVx5cnjRGsL88tB6
11943	payment	1693	1693	103	1	1	566	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYwuJDp5H8q9KgUVkfebji3j8h1u7mKu2eCYnFPAFDjFDiv7crn
11944	payment	1397	1397	1678	1	1	6538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj2st1Fccdbqzvns3mehGFG8QPDZWQS7qBWe5fRrTKhVf4uBG
11945	payment	1693	1693	1811	1	1	567	192959568702	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZW75xq58t9ivcFz8y1rRxz8ds4RXtCqAzoUPZFPZY4EuC7wQcX
11946	payment	1397	1397	1678	1	1	6539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGddi9wny9ofNvQnhFaMHMmtrQP4qdMR5NveGF3X2szHL3kEYd
11947	payment	1693	1693	499	1	1	568	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaLTuDKAPwVk8vcSbDJGoJHB56RXYWQWCkUry3tHzZvkJmokLE1
11948	payment	1693	1693	1772	1	1	569	504462958661	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYiRs2Tycp8srBiqp1GtcoC16aUpFLTpW2wqboFbQi66HQFxcC3
11949	payment	1693	1693	54	1	1	570	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYk75kyLRhDqoYvz2yL5JgEz4oydEh5qCxye2kdVct8kizSkaAf
11950	payment	1693	1693	710	1	1	571	5342683655	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZTPDpQ2zeGbTTVqgnfSjEc1cbLWWsnWD2vY7GJGYbxneiagUQZ
11951	payment	1693	1693	320	1	1	572	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZhHAURG7damHJfxSq8DoTbM6nriXnWQJ3jRKkuHPYjeuDCak3X
11952	payment	1693	1693	1030	1	1	573	962634758425	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZMP3i1TMQdRMnBsQjFAr1oevAGkW725rcCP6f2fUbsdJf8HFnB
11953	payment	1693	1693	663	1	1	574	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZkEmg5FX8akWP3xYdii3SRxgoFvhxFWpPeUUxjnjBTzP6qDtMT
11954	payment	1693	1693	35	1	1	575	20515905255	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYYcAwqwsCWV96J8NV4g3sNaavJdeb63shSABPUyY1svDCVqsxu
11955	payment	1693	1693	49	1	1	576	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZo1pZAKm6bTiAKxjTNWYDRdVFWhyWkZuK4snyaAV5LtfUKCA9Z
11956	payment	1726	1726	1874	1	1	3502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuUv7ey8fwVmPLwEZzrxCGoXviNxaq42eVAGsks3ZKYCVbNSS
11957	payment	1726	1726	1874	1	1	3503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevuU1Dp4WR2XMZs7nND9AiquEbR1v6jiwcv16AaqAANwB8auW
12023	payment	1397	1397	1678	1	1	6548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9uR1xeyqjiwVLRTJf7zwiaRcvmAy7tStXUbPC1N4jSGnhhzL
12024	payment	1693	1693	678	1	1	625	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZS4GX6vENodTXZfmqfaPiTUKPY3k5hcnVPKp5xJMtmP9D6jf5C
12025	payment	1693	1693	392	1	1	626	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZJPteb7ycQpzQt6eHhaGU4skR9Ax92H9z1h51VfVxM6YBaocvg
12026	payment	1693	1693	89	1	1	627	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZzwhayxXjiW7o2nBiMzkJ9Q4wvvMeD3KK2TdtPPqUDht2TxwaG
12027	payment	1693	1693	186	1	1	628	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZqNG2TbspkLX4nQXJbordKiP4KB3ejU3w7eEypyBb7hAmiH5WZ
12028	payment	1397	1397	1678	1	1	6549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vd2ui1iwnP6Viwyxk5YV6P5RS6aDKYdDn9BdSdAxt1XTnj9j
12029	payment	1397	1397	1678	1	1	6550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYzCLAhTk9xaggDZoTbeybJQMGrRShM8n7zNs4bV75fYHP1xC
12030	payment	1397	1397	1678	1	1	6551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVi4X972CZrsQ3gpghr7Gb1LbU4mrTAQMrTBM3SQYohDGDUV1
12031	payment	1693	1693	339	1	1	629	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaCCXiGjHUCQzV4ymjrS5AD3WMCgM5VPdCxTk7SbkH7nb2HBTnX
12032	payment	1693	1693	383	1	1	630	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaBz16ALLBER5H2HiiBXZz7A95GhBd6Lf99DXhz5eQXDfooQF9v
12033	payment	1693	1693	408	1	1	631	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZthniUpo6H9SF9DxCfkxs5dKZvhsKJxytd2veZhaU4biETX62L
12034	payment	1693	1693	745	1	1	632	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYW7Cd5PsPkCznBudttmbEYa9FYgjC3vcTYVHoqrAG4h69nd4pL
12035	payment	1693	1693	593	1	1	633	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZwXA264rm39mtJhSuNVGG36MwmvRxqEsouKF7wZkM9aXYn7ZTf
12036	payment	1693	1693	91	1	1	634	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYxwc88ehKMp8cGmGfxYnX6HDvdqCfjFZUYTWj4mhnz1zoEg3WY
12037	payment	1693	1693	438	1	1	635	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYbLsTsk7QgFRMTqHf4MpUnkE9mUyPk2k9EK41pwMcsHYCBK74E
11883	payment	1397	1397	1678	1	1	6510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9NhwThCen4rGdiLfBQ5mZEpnLS5jAJZPVi3uYgj6ozr5sHdY
11884	payment	1726	1726	1874	1	1	3473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8EiSi6rxonnFAoFjivwFKh6vb1QUVEkddNPrzVhr3GBprZqL
11891	payment	1397	1397	1678	1	1	6514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqfCxNSo3uCtuJ4reeYr1fL6puuBTCAXgPu1L4Jf5EpX3N32F
11892	payment	1726	1726	1874	1	1	3477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPcAsChXNMVcxTRmfJHcnYbDaSsK3qY6EEHYfuaiLUUNpfPhd
11897	payment	1726	1726	1874	1	1	3480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUFtaYB7krN3PjScoL41aEKLQ9DT25iWKq6ydSG5NWiejcSUg
11898	payment	1397	1397	1678	1	1	6517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DG8Ne2dbVbZL5d5fEEEks6sKAJzzwyUVsoCG6E4jArB5Bw55
11911	payment	1397	1397	1678	1	1	6523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsUv368xZ7cdtTKzvFojpURZhw4yt4tarabFy3smWQ2xn9jxz
11912	payment	1397	1397	1678	1	1	6524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUV1nPi22WHznwnrZu8akoLwxQErurKGsbgk4vyoJWbyAgKbM
11913	payment	1397	1397	1678	1	1	6525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhJmfgGnhgjTis2XhcjCDvTX2UJohEr3RUdT4XTZTD2i583pf
11914	payment	1726	1726	1874	1	1	3488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EKXHMmHJ4vaoYFWachPDV3R5XNZ32ZnggH2nTf2C8Sc8NT1p
11915	payment	1726	1726	1874	1	1	3489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgf4WqivBPb1zvcRqcWx2ACH5BXCeBUgxv7Qo4jZS4QiiHmBm
11916	payment	1726	1726	1874	1	1	3490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2PhuXRn2BuHC3YVKHpmHtPsEY5brTz68RNyHPLB8cvtnCD4D
11919	payment	1397	1397	1678	1	1	6527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWrdQqsNsMKYmuqWaMKkmLQrfF7ZoiCeaBgdWs6f8WhMkHtNP
11920	payment	1397	1397	1678	1	1	6528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSkf8h82ucmfDnZW8w9ExPV2Y8kvVuKFq7Yseq51TaNMRbtxY
11921	payment	1726	1726	1874	1	1	3492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqCnHaJDqbyMGgQEcTfBQHSr5YByVMqRY1ewRU41UgcyH39wPD
11928	payment	1397	1397	1678	1	1	6532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61nxrPyLDXSAi1RimkMzZr5qj653Guokj6HN7QaxK4DExTC9v
11929	payment	1726	1726	1874	1	1	3496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxBQeB53sWH3fRGJ9Xde1xsf39davPAhgTCySq3NWe95Z9zVt
11938	payment	1693	1693	122	1	1	563	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYsmq3AvCgUZztV3ac7CYcZz3oUtntwvWFjj6wAFj6NQWJLNCzY
11939	payment	1693	1693	721	1	1	564	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZDeP66pd8fw4KmagkhzkAcThCZP5tTR73VcRvqhFQ6MLmtbtfc
11940	payment	1397	1397	1678	1	1	6537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRjWx6v2vdaYQziqzxMCzgdvhuK7NWQNcfK8s9zzhzdrtpe6M
11941	payment	1693	1693	217	1	1	565	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa22XSAigVN9abZmBAJqqN9xkDiqK5bYt5TGimdXyxJRxTHcFFp
11942	payment	1726	1726	1874	1	1	3501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMpgCExFSMLpY6381xY6FPkKMgWek9KxvbgS9gkeFdV9n3t5J
11965	payment	1397	1397	1678	1	1	6541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yvce2cN7L4eJ4PWDk5C1ABNZMY7fz4gHfzrBJtowceziXJ1W
11966	payment	1693	1693	108	1	1	582	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZsxBY96PPkF73dSGZDmo1pf2XZCNjx952ZsvBHY3RxPwSWZYwg
11967	payment	1693	1693	894	1	1	583	327851556730	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYzndxQV9CXYgYDwcbmT1tg7ike396tmW2fDS5YSrZax4zCj1Uq
11968	payment	1693	1693	569	1	1	584	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZGih8EYVKW29uVJSuteouLzgYDSroU2dWnu4yfkBoc3MCJQH8Q
11969	payment	1693	1693	252	1	1	585	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ174TdkmjjkJpscvNCto6P7quFgeX2NiMvpoZ51UyyrMSo4Dgr
11970	payment	1693	1693	225	1	1	586	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYumyVBhh9qkxn1SJp1Mq6N1Bv3N7XnN838cT7SbwgcJ4D84dUe
11971	payment	1693	1693	377	1	1	587	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYQe7ZsEKEyvJFKF4QTxT9znEwCjWZ6iD6V5vZhvDy5jwFy6Dc4
11972	payment	1726	1726	1874	1	1	3505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFxfqGgLkn7mF7xEQjvq8TYx8NLur5BiEusSVVwkWDWruHanN
12066	payment	1693	1693	194	1	1	658	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYhgzVDzsvHBELiiGeHQt1tsjMukQdvGW5uUdU768LVrNoYyMQj
12067	payment	1693	1693	1276	1	1	659	1809914170990	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ6H2kMsHjd8sL5WfhjMKwgxUmZb4zqM1wag7S9L2v8bYf2bgiV
12068	payment	1693	1693	206	1	1	660	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYxKHtuxdd8CyWnUnHfSHLV9CTWKmaPfR6w2pwdXd6dQcGqBMhc
12069	payment	1693	1693	304	1	1	661	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZpah7qPW7TgiRWDZ7LYtanAKB1WPkeVHv9hMvoGJSsee8YwEHa
12070	payment	1693	1693	399	1	1	662	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYiG9RyDyz5UB1hWpbiTM84tdnW5xAm8ufzW9ji78t2NF8baBJ8
12071	payment	1693	1693	653	1	1	663	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZo2dGkHgTkEkYvLgDQ5R6ShwXGmd2SwR8Ms6VeapYt16dtBUBv
12072	payment	1397	1397	1678	1	1	6553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeaaA4iMSEdJ9zXAp6qygXhcs6TRCc7XmS89fwwATXFUvHx29
12073	payment	1726	1726	1874	1	1	3518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq87pXSpvVJiWmVVeemHWiKFaGb9322Mc7TYyb9Vcvf8eTTS1T
11885	payment	1726	1726	1874	1	1	3474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxaUXWXfkKjsJQaEBznnic3CLVNixywk9ic3rMNWtBhFGBzEbV
11886	payment	1397	1397	1678	1	1	6511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkUFhMdf6hRhrdqk5a1tsTXLoDeDvGpQyMgVnZtPomnDGYBJj
11893	payment	1726	1726	1874	1	1	3478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqBnUwXZ2w7mmR761kTtH5yNwFEmPrgRDJJGwJCxCt8eLwLGM
11894	payment	1726	1726	1874	1	1	3479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbBr1SuGwG412euoVntG2JZGXDNUHp9LKVNmHReX5YRw5zWba
11895	payment	1397	1397	1678	1	1	6515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV4CmmqDhavQL1XTEejiR64EZZ3h2u3oVU3Ffq4Yu6Qn3ts8x
11896	payment	1397	1397	1678	1	1	6516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkcUSFjThULmEr3pMvVqK7eejz6SzmUp1rLyE3t4AGpUZw3SC
11906	payment	1397	1397	1678	1	1	6521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaTAeaAp9vBmaHCofguyZ4Zd1smCukjLk32LWHrk84JbvvkZq
11907	payment	1397	1397	1678	1	1	6522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kcVkfXgWS4ZhqaXDXUVJ2BtCn1RQyEFCqSKaKiZFXpCV5MSB
11908	payment	1726	1726	1874	1	1	3485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2B4wQBA2pGkwrUgfkUAHkWHTgMQNknvfFy4q6Ve9LePGqNwZ
11909	payment	1726	1726	1874	1	1	3486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSjAgv6DVufKRsRTwTtgyb4UMPnbkUSy81ytpv2WjEJ4mzaxe
11910	payment	1726	1726	1874	1	1	3487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabC6YCqobm8MSXGWnKpYxcaRfFPhjfETMYc7xjZ6j6Dtz8j7J
11917	payment	1397	1397	1678	1	1	6526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvrDGCQLL5TFmtALa6h2csAUkUoMHDbUA5kCnUA5AzHwwy9rV
11918	payment	1726	1726	1874	1	1	3491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZiram8zGScYLL5f1s8866yeRxmUhqboGzHCXtT8M6ZBLbz34
11922	payment	1397	1397	1678	1	1	6529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6REf6pawfBMcUA6MWGRQX8wbeL5ttHKaRt8cAGWvzDjJUsSAC
11923	payment	1397	1397	1678	1	1	6530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaUKn7Bzt8UzaJpugiePLLxyKM93hMpxh6XsyRPiCASFwPBf5
11924	payment	1397	1397	1678	1	1	6531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6rBqp2MJowm2LpXKjJaE5Dh5p1eN71N631aAdiMcpWF2jneb
11925	payment	1726	1726	1874	1	1	3493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcghCebzKyeJTYBcEbb2VXwoEpXbQuZo4ej9SzxhqBC8PAH8Ay
11926	payment	1726	1726	1874	1	1	3494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYuZYUZQ1Uf9PTnPD5b5QWWKK37X7x6ePrTGzpph3GfLpiBRj
11927	payment	1726	1726	1874	1	1	3495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW5ZzB7UyS5TdNYtP41bTc1baQ4UvmWffL2vAEkbF4MGccPCW
11930	payment	1397	1397	1678	1	1	6533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8vGAyFqqDqNLq9AzZ67BA2try2QBcxP38yupUEWB3RSXuN5T
11931	payment	1397	1397	1678	1	1	6534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8pj9Tu5aVpFceHwHL6qCDawsrVbiUv3XaVXbiDbNjqUURJN9
11932	payment	1726	1726	1874	1	1	3497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkP8v6JtqUpNWeKHEEidYYY2qjpRMztpDfPts15MLK17XJ466d
11933	payment	1726	1726	1874	1	1	3498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sdjDJQh6LJiQ92XDcenYTB4hVRUi8a5o3sdsGZeSGHE7Y4Fd
11973	payment	1397	1397	1678	1	1	6542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJMHBihUKXS6ouwyWuwrrgf26rYY4dMkENhBtXN1iUQ2NfVAs
11974	payment	1693	1693	82	1	1	588	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa1UTjuaTDzMBTmZK86ZdSy9aQJxas9wpDCpb3mcZBEpN8upUY8
11975	payment	1693	1693	361	1	1	589	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaKnB21mvw3sFyJMqd9NWaDb44HsYAuzjLJftHwwti9tZ7KmyRY
11976	payment	1693	1693	560	1	1	590	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYjufnUQAoJqyoM5gbyiUb53nxEXnQeWnfHnhxA1bTZxkJFjYJf
11977	payment	1693	1693	309	1	1	591	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYdMHCU39oRr3NuHkfSzKx6kzdNYox2je8kZ3Y3japjNW3uZ31n
11978	payment	1693	1693	1962	1	1	592	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZAz3X2NLE98unsDsBBuxebieqpecPa3Mp26ckQKbL9Nt42oG9S
11979	payment	1693	1693	201	1	1	593	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZS4u679UVqWAbi6owTHTqh3m2zFNGnV7ewzJyFejgkoBXbuyGk
11980	payment	1726	1726	1874	1	1	3506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwHKrX7omi1JJLPpQ7iqhhh1gQaUTVxL6phPWzHdzW1w7eEx6
12005	payment	1693	1693	191	1	1	612	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYkf1r859ePZCbQN5nk5h8X3AXdgWsxmCmNSqzzDaotNCBEo73k
12006	payment	1693	1693	266	1	1	613	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYwECQXUMckoUtNdRi8UEuj7P9uVgiBpTKyf93TfqBvUEFfHvXS
12007	payment	1693	1693	534	1	1	614	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTsCb9hwGXcNZsnxM8dEGsvF3hzJCkwsgSUXNs5bJMMGuQuWP5
12008	payment	1693	1693	245	1	1	615	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ2aQkyitJdn5jBjcvKxySmquMojv8HqSnpUJ8zVWCqoFwMGDWR
12009	payment	1693	1693	421	1	1	616	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZbA1NExe6m6zXTPta8gMuLcVko4qTXrU4p2nUXXfYQaXW7ULxb
12010	payment	1693	1693	600	1	1	617	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYSMXRAtUpgSZ2wNonWUu9tFvy2Ejp9WwZ4nSuEzyFE8X88Uppm
12011	payment	1726	1726	1874	1	1	3510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8TqGuZqygt9gyQXbyjziCepREzhC6cjcXWhfjNCMGLcGCRX8
11988	payment	1693	1693	594	1	1	601	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYkuoqVk2qBSFxk2kGbYhgCUqx8EPv4eG22ZVKGahkfaKc32YRL
11989	payment	1693	1693	680	1	1	602	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZajsyDrWs1yhHY7ppXSj9d72DYSAXjnSzDZKX9AnorxpV5UANe
11990	payment	1693	1693	690	1	1	603	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZm6xXiBtAjHMuazQaKPbVWSWdWdWM6YQ2bZcKzjVFuG3Mf4puZ
11991	payment	1693	1693	731	1	1	604	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZb2diQZqBnsM5eThzvwYHoJCJsHe2i1qjwLr3Cf7KCWrLrVR4o
11992	payment	1693	1693	180	1	1	605	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZPqtEm5x5oZcqZpQN8Dy6f24RSyqtExDRTLxHV2mmbVPghF1t8
11993	payment	1693	1693	112	1	1	606	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZh86fqDppFHSKF7iuA1HEDxcgUNrcyYgfJSEiEDFAhtqw94rRr
11994	payment	1693	1693	353	1	1	607	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYUKTe4U59bKpGqaL7uzaoFjSHAPcbsVF6aqTjyzvf5rGhLD299
11995	payment	1693	1693	652	1	1	608	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaCDZJqJTmzPMKAaQpNzKgbjp57aPFCwKqhJCvetRcXasxeAVmu
11996	payment	1693	1693	420	1	1	609	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYbA54iEBcRjT2Z5opjJuqLYWfxYfwzy5Th5Kv7jZM1dp6BXyoN
11997	payment	1693	1693	352	1	1	610	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa66C5cbc3hu1eT9FwcZUU121wVZL9mwrvqfR7dXrtT4sqMzQKL
11998	payment	1693	1693	691	1	1	611	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZYm5nXMdfVmtVVvZxcocZDcRLLLJKq99E6FWE1nMbVhEVt5RaU
11999	payment	1397	1397	1678	1	1	6543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1BsHoSptQdsJZgipRNEUGyPHexdLydTWPE2YiErG7b5iYh8b
12000	payment	1397	1397	1678	1	1	6544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AbuxNDa74LQ6GHnu3A5nkGnpoB5WCyurwujM3nHjSKKEgAgy
12001	payment	1397	1397	1678	1	1	6545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu3Bz8ZweySUpsKJfSQ6yNWBJGj47bxz9X6Q1uN9kSn3eXNEW
12002	payment	1726	1726	1874	1	1	3507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfyw1DiqBLxdG5zdtikEMr61eVLU5NN31GvxzNuPdoujQDMTn
12003	payment	1726	1726	1874	1	1	3508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUNT8TCydEewhseJvzP56JCXjHp156oBTV3tULeXz8GroQRDc
12004	payment	1726	1726	1874	1	1	3509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF71WMsGzQP1EhzR8oG7RkmLsPBwCqPEZZV8LgqV2xoVnpb5aU
12022	payment	1693	1693	308	1	1	624	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaJkjQGHHnKpsN6phFanWGvaNySdsTkgjcTLEkdW2Fi84uM3x5s
12059	payment	1397	1397	1678	1	1	6552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwGZhBkQ69XVBsMHDCcdnAQG44U1NWNtbr4AuNvFgmM6yf6ki
12060	payment	1693	1693	611	1	1	653	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ8LrwUYdVco68Y497ZW11qPBRpCUsYvgwk5tQ8zMj21qdmzyLX
12061	payment	1693	1693	1961	1	1	654	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZXTPZAg7QvbEZHguQKGqCF5mwgF98XjqjbaRgwzTCEGFRXXMod
12062	payment	1693	1693	504	1	1	655	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYXkmWQoRgFYru5ofUzKaZKbUkEsnNH2WV31Jgf7fT4ezJNCcGC
12063	payment	1693	1693	658	1	1	656	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZBkcYnLiEdaG9zhmZTLEbBuNdwdXhYJyu3L8ZGduYRcZdiGXcj
12064	payment	1693	1693	660	1	1	657	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZgmJZECmKKYBJWJJjhohb6Pw51CEWnriBbc5mLfMk17JYnRmfy
12065	payment	1726	1726	1874	1	1	3517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5brxjHWW25eUNDx6KyDjgSkboHt8KxnZjsbByQp1XoR22a5J
12074	payment	1397	1397	1678	1	1	6554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbQjW9ScBnRiSyEcmtP4CGg7sfszxvpWryryyfPeuF3pMHm4H
12075	payment	1726	1726	1874	1	1	3519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtSk6QDm8DnAW8tt37xkhF4ucaPcRXj34hnUCxYxUB9i2CTSS
12085	payment	1397	1397	1678	1	1	6557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1L92J7vhBgQUaSQiH5WsX5ippGTJN18LWNsNGuBBfKZWMzcNd
12086	payment	1726	1726	1874	1	1	3523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkrZ4bxdqr1mWp6Emk4BAjwQi7FaPAG18eewzp64s7jDDjebf
12091	payment	1397	1397	1678	1	1	6559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkKFMK6dwjyYgMZshAeCi2LNgqkFSXjpc13RUVZa5F3ckrEs3
12092	payment	1726	1726	1874	1	1	3525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNJGsdtrEbpVFFZpftkBMfUtbtYATj8bkSFYceEMrJKXAd89X
12124	payment	1397	1397	1678	1	1	6576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJ6YWzrew8GVdFHdqpnBe2bvYwz1uqh4xZ22CToz7xXz8XWqs
12125	payment	1726	1726	1874	1	1	3541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTLmQXQZ7SbfJisz3NTP4KU76euYbmE4HsnSu6EJXYQaz3wu9
12128	payment	1397	1397	1678	1	1	6578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WQiX14C1aJFvwRjiCmr7vTTqWdrqBqcWKmNq3YpHgsACm8Eb
12129	payment	1726	1726	1874	1	1	3543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PNuVMohZU2qTH68BFsmoeJNkc9kxUGxPW2NLuMC9Draq6avq
12130	payment	1397	1397	1678	1	1	6579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgKepc9TaLR5Ybd9s3PSEPKEbSGSDH3hma1s15p7vGWDuewMK
12137	payment	1397	1397	1678	1	1	6583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCZB4LZfTutgFGKWnY43QVmkRYCrY7vs5HaE99UJ5a1LEfW2J
12138	payment	1726	1726	1874	1	1	3547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqhDBa6KAGMV3nUTooTNyiDAtzVG53gBBJyKkcTnW7UjSBaAA
12012	payment	1397	1397	1678	1	1	6546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2y9GL5CzmwJ88qSN2bQ1jgjQ3TMnnMT8hL6Zd5bQUniNquZq
12013	payment	1397	1397	1678	1	1	6547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUV2ViWKgp4qg3JEw9qKcbaoeeJej4nmRZ3TLoqkJMCuhMBG3
12014	payment	1693	1693	620	1	1	618	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa56auBubeeHo4LT37RG1NESQbm4PmFUTJFAcSC2ZsPp3DHLEg8
12015	payment	1693	1693	2017	1	1	619	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZQrta7wiWWbYG3qJ1YMrMAdAnAMr6hyByBR1JLow3drwSfFTEj
12016	payment	1693	1693	551	1	1	620	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYXTDtVY8RdYM7hRUcHz55xNMKPRcmRZBZJjrJZm6K4Y4GVsi76
12017	payment	1693	1693	520	1	1	621	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaELjFJoHRZCyFZPwZWEaUnmHM2fvjZhQKXYgTi3u6nEo187wF2
12018	payment	1693	1693	84	1	1	622	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTx7ZP6LFji5vGcpT1WNx6fqbVYMJqhEDaqTBSBLwaXD4sb8Dd
12019	payment	1693	1693	1150	1	1	623	649508853363	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYijTkksqmiKTSiaBLpehGWFfeezn8hHGqmR4b4kqGKBzwc96yh
12020	payment	1726	1726	1874	1	1	3511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTLUAw189WPgXDnhNrA44svXF9K9hF4naEKTZoHFRSCkqEBhk
12021	payment	1726	1726	1874	1	1	3512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNGLNambkUTb6ehhQpSUueoWdssbwHS9NRhnmRHQGeECAUM1p
12095	payment	1397	1397	1678	1	1	6561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KzkLqEFS4erAnPTwJhqB55ikYhuDaE7SBzKrDVni8CBDBPHA
12096	payment	1726	1726	1874	1	1	3527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78Uhu3gTKRFfiH4USJ7Wp4MbZSWipWES7io6CuJ5fh2ECRGvf
12109	payment	1397	1397	1678	1	1	6568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJaRBJgJrxSaTbTMURteLFTYsMuviu2mjigC9anVCT6uxmrr2
12110	payment	1726	1726	1874	1	1	3534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWQesgRVwgDKPhqWuHn71Ex3SJJ4D9UwFbNtCiZRbvTK7tx48
12111	payment	1397	1397	1678	1	1	6569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTdaxrFaCVTM7be55G44ekYBDnJzVsDBN4qeDt7LP4AfHKsEQ
12117	payment	1397	1397	1678	1	1	6572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoqj36aVek5Yd36mFUB1x6MCqVTPVWy1EGA3bFPtBMZFfM2SE
12119	payment	1397	1397	1678	1	1	6573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUevsnth75AYcuEvCCr8ZMRZ812hGezip8yqsRGXvKSCXmD7a4
12120	payment	1397	1397	1678	1	1	6574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5GweT6nYwhZYpcEfM5AaBYmtEviG2G65d3zBtCqEBJazonxp
12121	payment	1726	1726	1874	1	1	3539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJSZXuzEQQuD2z8jxiTHjDqfc6g8eWuu4AyNs7yJHBxCfPSVB
12122	payment	1397	1397	1678	1	1	6575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JRfMwHq8R6LwDegr9i3bVMrqCWePSHcvpH9etmro77nETobm
12123	payment	1726	1726	1874	1	1	3540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDF6rZanKp82AHh1S6yZcJBAPRNL2h75AbCaiicFXsMhpFERu
12131	payment	1397	1397	1678	1	1	6580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8r5d9SzvqHxHZkBkjLGC28NJXPyMFtg1m4LXry4es1Xk4uGPz
12132	payment	1726	1726	1874	1	1	3544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHduy3WGHSRhX6wmezb8H2nuSPAnGy5XBRc7ZC1ZrgJkuoghv
12133	payment	1397	1397	1678	1	1	6581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiq6weCaDArcMYkUt83rNvxv3GK5bAN3e1BLvjQmgQENzjuuT
12134	payment	1726	1726	1874	1	1	3545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQR8digw8LbrY7hWeMxJdyPZJcMvRjqemqHtncjt1Gk4M1Bz3
12150	payment	1397	1397	1678	1	1	6589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LPGZkNBpVphejn3Rh7qAcuCQimd2N6AMDzSjMznWV6DXTmvg
12151	payment	1726	1726	1874	1	1	3553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE9ErswiANLGsbKA3jQbsjckaNBZZuzi8QG4u4MSgMHzp7scR
12170	payment	1397	1397	1678	1	1	6599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeN8Vsh4unq1kQYwnggNiosoxZtU2dgFBqzFRh3r3xe8Hz7z3M
12171	payment	1397	1397	1678	1	1	6600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GbsstcLQqi7Gfcw5Fy4z7Yh6mC8drh4mdTAtqshkDVZrmsUv
12172	payment	1726	1726	1874	1	1	3563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTR8HGMHcwtYVEoj7LsqQT9fXjLoKj7zWmgh5ihWUaJ41jt4Tv
12173	payment	1726	1726	1874	1	1	3564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yw1iyw4uz3cnhPRQq42Gri6ej4Qn2LFimPLMXDobv26GhynR
12174	payment	1397	1397	1678	1	1	6601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5R7Cvt8t13aGwpY9gEb8mogtnVujAfULsWU5a6ttUeb5J7fW
12175	payment	1726	1726	1874	1	1	3565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4k7ZFNT2KZz2TPxydccyUpFz2JEytZMnnZBhfF86t5CBtmRuT
12210	payment	1397	1397	1678	1	1	6619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLPCe4SWKGzaUVBaDyBnrnZnWDcJPNu94ZJ9LFX2CNBq9w8g7
12211	payment	1726	1726	1874	1	1	3583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kss9jjoBQdxbLZFhvzGV7G8mDPjuizDHp4sCR2z4sPYbfHf4
12218	payment	1397	1397	1678	1	1	6623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLProaYZLkbX9Lh9HXoa9PVkvXgzG31FyQtV3Pd6E2R8YmL4p
12219	payment	1726	1726	1874	1	1	3587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3761EtcRQ8H5ufWJA8pqXdookJnCUXPCVooYC2P9BeK3F2g5
12228	payment	1397	1397	1678	1	1	6628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxKb9iZ9MfNdcppUihCYgMAoR9yS7ySKDXU2P7QfVJtXKfrNG
12038	payment	1693	1693	450	1	1	636	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYpKTiigpVDLGvmykiibdwexARMvyGenmEUrrasWNwPPgYggU77
12039	payment	1693	1693	322	1	1	637	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZaYKQa3Va6kCHeBTCtD3rYL3LeiKgbvzzQZfSmQhLaL3awtcKE
12040	payment	1693	1693	373	1	1	638	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZRk7tR58YCgy5r7zr6oKhLVA26rc7WM5pcsAPZqgPQmnjtRsEk
12041	payment	1693	1693	150	1	1	639	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaGgCm1GHvztJeToLua8n6oiTN2g1cj5W2Hs1UDo7x4PS23pL7H
12042	payment	1693	1693	92	1	1	640	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZpzH6zV84ZKmFkzECSkSfqkzbeK4Nciwbmp4nQbFPUuXSAqvrW
12043	payment	1693	1693	453	1	1	641	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYU4k5LBVGvUQHbxRdsqvy36UECH7sTh9EPahogjNQohjgf9A7j
12044	payment	1693	1693	63	1	1	642	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZLokka6GaJPji7sTj1eHBTRara9T4Rz5spwRaP52SszMhCCzZs
12045	payment	1693	1693	146	1	1	643	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZSDUZnBd1Rp7NEXET3RpCp1eNDFFpDDvkn6jq2q2wWQ6bCzWXW
12046	payment	1693	1693	601	1	1	644	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTUeMjNsXXwBUGGPEMYjh5Rd7K4jECCyh7CnznDkJhF1mHD3LY
12047	payment	1693	1693	587	1	1	645	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZAxDHU5hGA5om5fTEQKk2hJ8xk7ofA7W4k87V4eH48Avfv1DZ4
12048	payment	1693	1693	910	1	1	646	537187143427	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa6pj3WSkJu13wb83YMT5QBn7W3nBhm8XRHXzv3iNRobwQdaANG
12049	payment	1693	1693	500	1	1	647	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa9XxqEkn9WL5MidWEHb4fybfTL9DsheZHHWUJQyJtBi4w8jAbw
12050	payment	1693	1693	29	1	1	648	7479757120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZxbNBnh7o6gus1tNvUCNYgkxaDB4NV2AW3pJndMCgHDGiA9MWJ
12051	payment	1693	1693	138	1	1	649	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYQvtHN4zRz5JYZ59wrzm2mgxna5eimKUDsVDVus9oecrhD3tGM
12052	payment	1693	1693	78	1	1	650	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZEMXmXTHuthHHWqXE8uayCnWhiWcsUx8RhJv3KtdQsRPkJrNhF
12053	payment	1693	1693	395	1	1	651	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYb64taU7S1eBCeyzCSp3ZR6Fhfoieu6qu2eohcPxQxwWo1TVYC
12054	payment	1693	1693	205	1	1	652	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ3BDcPnCGTvdc8FgmHTy4hZUnUP8EyDU2v9WUdZtqkBbP1Zr7j
12055	payment	1726	1726	1874	1	1	3513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZPHVytiNWwvFiuQT9sL6dRbojpojzd5UACC4a6UnkbEwjeez
12056	payment	1726	1726	1874	1	1	3514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXhedfSVVXcwsntCk7F3drGNrSbXMfcMKhtrVDuv4Tr3Zjz1g
12057	payment	1726	1726	1874	1	1	3515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKw9VkpTz4zKsoLNoJgEr6Fi692VbuRPxSmc7SSPFEkacjt4Fq
12058	payment	1726	1726	1874	1	1	3516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXspkJKJn6c1jo2SKVnhoPutAhLURac2rjVwf3cRonbRR7HzBT
12076	payment	1726	1726	1874	1	1	3520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7YnBj6tCXWQDPJkXBGGYP3NLq9Se2d6bLtn9DZSGdgziXRgh
12093	payment	1397	1397	1678	1	1	6560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9TkTSCQEyDVxBCQzL8jJMD64QvCnoUsJhoebXCmEiuhx8Rog
12094	payment	1726	1726	1874	1	1	3526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvkBGYFukDg5McLfy5hVcRVGvYkRUnNgDZ1h5NBadRJDavLmx
12101	payment	1397	1397	1678	1	1	6564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxkfGN8Fczk4maxZ9s7Kosmt14qUfHCHyb1hGnQsbmC5TXnm
12102	payment	1397	1397	1678	1	1	6565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgC4G7c3PvuqbGDS7SmJiUqDWpUKMjrx4JArdBPnNbVsfC83u
12103	payment	1726	1726	1874	1	1	3530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6n9Vi9uHghTP8PHCdVoATnU9Z1VwC6hdJPTAvACgSGSwruME
12104	payment	1726	1726	1874	1	1	3531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLCm5x2JtEDAzDSFnAgXhBtYH19hdUiYGATSaM36wgqfqKPrm
12112	payment	1397	1397	1678	1	1	6570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoZVDU7r8vumDRf5MuSEFaEgShjCUMoPiBT2ihrhBanzYAc2V
12113	payment	1726	1726	1874	1	1	3535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYssg4xerhei4YgkV3XaSRHwbUuSva8Tt4v4zbGEbY5twUiizkX
12114	payment	1397	1397	1678	1	1	6571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh9LFyR7qxB7qDYFwuThCz4oTG2UHM3VXkr68iRmTjUfVW81m
12115	payment	1726	1726	1874	1	1	3536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyPCyqFASeyk6RHWd6BqHnwbh8rijiPFCf4JxusB29hEEvuas
12126	payment	1397	1397	1678	1	1	6577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SkHtXCsQzPNn2msHLTsXGcGgqvmFU1fN6YwLmARXA9PKPfGD
12127	payment	1726	1726	1874	1	1	3542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJFtudqo5isYGvhCMMNXpYEs56R3ScDqu929tGWg7keP1MyMM
12139	payment	1397	1397	1678	1	1	6584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUJtfiupQvLes9CEYZM63BBVMAZCmBomG9qijdoe1GFcAqfHv
12140	payment	1726	1726	1874	1	1	3548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE9gKrFPUrU3zxcJ4iYjXoPaLqmJyD5qYDVMDUru7uirNfkoz
12146	payment	1397	1397	1678	1	1	6587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHonHF3zqCGJx2Srtdc1jxZDbpWdN5RVpBF9PBEggQP3XQs9bY
12147	payment	1397	1397	1678	1	1	6588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL7cgjoeYAYn7bKFSVoyWtqMxcoKdoMvTR9rgH85NDHfPqqrn
12077	payment	1397	1397	1678	1	1	6555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6awnfaugnR5jQbfYLgFrgDeRhV4VU2Lf7f7iGg8VhBXNP8www
12078	payment	1613	1613	1349	1	1	2	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSx5prKjM9UzQM5VQmfitt4vZsWN2PhXYwq9pe1qkY6eTCH7Dx
12079	payment	1397	1397	1678	1	1	6556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2pgcVhFCDSriwMCawpeMa84MC9ttcKjBTg6yXFdgZcw64eLK
12080	payment	1613	1613	1223	1	1	3	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3gJubDFwWHTbGeVSpcmkeWGWW58adxG6YoCnNot8JA18qaXQ
12081	payment	1613	1613	1103	1	1	4	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q5kvvHH29QF4h4N9AG7nVAnVrW9NykzSHd6McTBiwtmRB6Te
12082	payment	1613	1613	983	1	1	5	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Cgy4MQtdPsB2VfgAqsATPEPD21jYJ8p4kiiDTyANwxWZDtWo
12083	payment	1726	1726	1874	1	1	3521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZePtF7r7sanaenidxoMEPjY7QvhkJHdXLEPjhjU62USbMGi9DG
12084	payment	1726	1726	1874	1	1	3522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8CwrqFZ2BxTXQT69XsHU2LExLL3vjKS2oDHr1H8C8wJmnUEU
12087	payment	1693	1693	622	1	1	664	70523424329	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnUxEhGseJgqhNtjSNMEgsn	CkpYj5Qe8aj8fqM8P6BznNiwQptHv3vFxUdc8SrcRNVKor769mrzQ
12088	payment	1693	1693	105	1	1	665	70523424329	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnUxEhGseJgqhNtjSNMEgsn	CkpYtbe3ideCTRtz84SKEegQrfU7aZdniw5sJaVCWMxkhkXsqFrAN
12089	payment	1397	1397	1678	1	1	6558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgVxwvXRwapHjSWxcuZUChCuCd8NC7mgyeHnLANS6qKs121uJ
12090	payment	1726	1726	1874	1	1	3524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeGn5umRG9Qhfo97fHvtSA8ABcp6BBjBy52Y936nAbWCQPY68
12097	payment	1397	1397	1678	1	1	6562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrGGx7fxnnyPQc9ivJZqtf6ezzvwqz4KjHNY54MxcNQ58eAjC
12098	payment	1726	1726	1874	1	1	3528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3dVFAAeX9t4E3zTSwAQEKmrLGj1reN6NrX5S21j5ZnW5kYLf
12099	payment	1397	1397	1678	1	1	6563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKbhMvScEVgFotxcKE65jgehU3kMWz6n4MDkc74jeK3cBiBpT
12100	payment	1726	1726	1874	1	1	3529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDFFWZqaogveSY5zDWrd7kmxMBzzgZiTBqeUXy9pog7suYgQ5
12105	payment	1397	1397	1678	1	1	6566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYMy5gJRxGQ9kGRADKmoymL67PzVdLGm1YdxwEtYD2X28dK6p
12106	payment	1397	1397	1678	1	1	6567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniGmiSx6M7QsY3RDJH1kxtS4MkGJLGG3CSuu8b3RSz184AmEa
12107	payment	1726	1726	1874	1	1	3532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEo5VtE2cDT5M351Zf7kbE6WUMJXfTRnuAVGR7uU53BYq5iZ21
12108	payment	1726	1726	1874	1	1	3533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVEHUXMagTu8mHzpQFLHpS4C4qtbbJK2Daiir57A66hAUvuyP
12116	payment	1726	1726	1874	1	1	3537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjyEhnJR1UN7vK27F1KuMnR3uFdNR2uFdgXB2QiLoRLyDYT5w
12118	payment	1726	1726	1874	1	1	3538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLL9wTvYBCL8ZRo1qcmGCx7kSgYmaVLgPvpNQVsboGW8tiEvT
12135	payment	1397	1397	1678	1	1	6582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmefzWnUZ65GRTomWXrhffWMu3izV1EhVijh11RmH8s7nDfzBH
12136	payment	1726	1726	1874	1	1	3546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWRLcaTfmC4m5yHrgAKBooeppXdMwDroHUz6PNuhFmFZGoa1C
12168	payment	1397	1397	1678	1	1	6598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTQ88B37ZqxoiMASTrpa7kHEfK6hY8i4C1W7HfCjJr9ZG5Li5
12169	payment	1726	1726	1874	1	1	3562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJLe4v9LBpMXpmNyro9paiLnw5mUBjNVpKtrBtSLbcyAruBEw
12182	payment	1397	1397	1678	1	1	6605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJ9yGiMNAnts7wioGQfie2wraARJgkxFrrGBJZmporqbTUNmD
12183	payment	1397	1397	1678	1	1	6606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2E66padk6sjAeyA5hwGU8bZonbNudv8XYPxaKi42GURGRn2Dm
12184	payment	1397	1397	1678	1	1	6607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkciA5UkxQDBS1HmsaY29vFW6EqLLve6vtvaBaX65JJBEm5ukJ
12185	payment	1397	1397	1678	1	1	6608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQjPJzVm8gbjNegF6Vrwzr6DeYNYxhBdPxurMJ4DnQrq66E5R
12186	payment	1397	1397	1678	1	1	6609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhJtCB87QQDf5SJF4pwdyn2ZXUPeoLmBDkQ7wdTBoJ73KhUab
12187	payment	1726	1726	1874	1	1	3569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qzdiXcBytGp7HyYbDyTfLoHhyQKe73NKvWb9a1BivFFYgqCH
12188	payment	1726	1726	1874	1	1	3570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8txxhK8G6D7deSjykx6mcdWnp53gWQugVeX5Rpi397DfN27u
12189	payment	1726	1726	1874	1	1	3571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeB8C9qjM5zR6zAnwwbczk12v6xbmNsG7pwVWn5d6aiYGbBx3
12190	payment	1726	1726	1874	1	1	3572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQeHChyBBSQQMpacPkDMfZysgGtXPk5yxBq44eyLkcq9jmiZb
12191	payment	1726	1726	1874	1	1	3573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBunpj8suSwUENBz7cAGjRbWjx3kSaThqZ4Ubwu9s6mDSgFCL
12192	payment	1397	1397	1678	1	1	6610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3aB9WXA5Q4nZBQ2vYA44GkHWJZSg5PEzWwrLBf5UMGEbfCJS
12193	payment	1726	1726	1874	1	1	3574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9f2KS7xrPfoHrVih8hFrqMAm1ajJrjQnXwyvtLULZbvotL3TD
12141	payment	1397	1397	1678	1	1	6585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYRRBB4E5d8KWokjxtEbY2YE2stBUmHEt8AGPmFEgunq8G8wP
12142	payment	1397	1397	1678	1	1	6586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJXgicATTcVFXJgpDce1qq5g76gqor75RtYvTzjFkgbijWzkh
12143	payment	1775	1775	2047	1	1	5	1000000	1000000	65535	E4YrvzrFbtDw4bc1ZWr274D1kVZ5JUvRrqYzmttAqXYHeWGZZTrYJ	CkpZSpVL8yNVPhRhHBSGPZT9SfUyCb8ZY5nx8AXsyHNse8V23gYcC
12144	payment	1726	1726	1874	1	1	3549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EHe7GhRo1B1vs7eYEtZP1ctUqY2cR4YdHpP8VpaaH1QUXd3v
12145	payment	1726	1726	1874	1	1	3550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJW8mfXC8WQWwwbVtM8qpejeoZ7gzxfjuu7kFqzG8f67nUSVU
12152	payment	1397	1397	1678	1	1	6590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZh4X8BxPSYYgPoTZRvnmevnncNKJBdXRLsxx6eCYsipKg4gH
12153	payment	1397	1397	1678	1	1	6591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4ddLPAysRRUJe6A942GWz9uALL4BqRZ6pP4ostSxwzpYwBNs
12154	payment	1726	1726	1874	1	1	3554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19ntyZhB74pw8kezsHCRgVWN3teVuEe5ALE3zjWexuy5GDSeY
12155	payment	1726	1726	1874	1	1	3555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C5p1Gk1fGsYh6HkUoBtSRmB5WnQ17LTNn55HiuJmFwNDRoDA
12158	payment	1397	1397	1678	1	1	6593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZng8YGnZu31y81dJestDPd3NeV3pbVUNkVnn6rUmvPRh4UovRi
12159	payment	1397	1397	1678	1	1	6594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnRBDiLETsy5mPnknaSE8Vu2JVXph9ecNvB5pGmty7QTou3y2
12160	payment	1726	1726	1874	1	1	3557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4PCovPo7DJoHJkKGuUHkpJvns4qtQZveyXRAYtwBdZvzYnZX
12161	payment	1726	1726	1874	1	1	3558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYgv3rpNgSLgF55hq15ykgXNPTFaPXwPTjoGBt71pRmzgjsZY
12176	payment	1726	1726	1874	1	1	3566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8tSrrao9hvrUS7RxXyG7McmP9a8922ifazpCs2GuzVngUY5s
12177	payment	1397	1397	1678	1	1	6602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9BHKjN1r1FsdZkK8tgT7KDvKbL3RBmqe52JSZptDRwfU446X
12178	payment	1726	1726	1874	1	1	3567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDW68wP9DhLjbKjkfUHFkSpGYQ5ySGYVxmu7kpSRfvcrKGfe8P
12196	payment	1397	1397	1678	1	1	6612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjn9yMcQpGMExLvDcXMLaXNax4BY6CWrqZ8iMfjL4sAJWRNj6
12197	payment	1397	1397	1678	1	1	6613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyDv1thsGnezS5jChptKpyPAxHDKDcAgMC8Dhb6MP7K7L7X5m
12198	payment	1726	1726	1874	1	1	3576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS2Q6tm18z5JfR8NJCdHanSbKHjB4EuTGByNVJv2sk6is8yS7D
12199	payment	1726	1726	1874	1	1	3577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uJVv6GozBQ2YjFLz1RKR3tCfKowHmWQVzi1Dxf8Bwewaa1PB
12200	payment	1397	1397	1678	1	1	6614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb4fNS7LvM3eu17bf8YUA7GWzs9AoYnk7HEdvMQWx6Qiz9rhR
12201	payment	1726	1726	1874	1	1	3578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxkS5UPcz6PKkneDrpgVExVeFS9wEddZF3Datcz8n4poZpmiJ
12216	payment	1397	1397	1678	1	1	6622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUSFuD3yxzmY3Y8BZpxbNwqYdT5eeE7FGJi99W6buFUyg12a9
12217	payment	1726	1726	1874	1	1	3586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZartUnc8PkCD7isy7UjLhkfvixSAGfPQJ9T3rVtbqFesucQS
12220	payment	1397	1397	1678	1	1	6624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcegcN3rxdqP8EU79jz9YqC2SkHasEDtMzUL2pmkaJLVyj5r67
12221	payment	1397	1397	1678	1	1	6625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFxPPinQCkfXD3Zk5PGwzEhygVNAkfWsT6Umd4BCrMsnHDzpU
12222	payment	1726	1726	1874	1	1	3588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg26uu4suu3qUFCtYRZk3MXQRk39VKk3wJv1gR7wN8MyTZKLhH
12223	payment	1726	1726	1874	1	1	3589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzT9MjmSb93rNG9Bv21xkzrcfYL8aoAJqtKZjKjtW8vyYKUEU
12237	payment	1397	1397	1678	1	1	6632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ab9tBY1u2Z5Hv5upnSteMFcXWGMQUvGXKMBk8LSExUKsBmr5
12238	payment	1726	1726	1874	1	1	3597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHNdq2pnyH8KvU8x9XaHSS7cLKN18er348UPEkStqLYXeVNJe
12242	payment	1397	1397	1678	1	1	6635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4Gtzggz1ufR9FqzmT5AhqMs85zR5mPKQjrH8crogiGKyJiGC
12243	payment	1397	1397	1678	1	1	6636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpgGav1FHoaAWmvWeD56D5g41Wr6MYSy5FHVXF57FtKsEJaVG
12244	payment	1726	1726	1874	1	1	3599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVVRWDyv83NUmLPykUrY9oZu4bFF5UJmNfN1iiHttVgZDKvNz
12245	payment	1726	1726	1874	1	1	3600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfku7hvjVV9uzGTPZdVVkf1AnKKA1B4VfwMyNnYeeEL45dSts
12246	payment	1397	1397	1678	1	1	6637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A25v7zB9sH5cd7h5TgK77M6VkCoEcpMHY4GrqSRzpMGM6FyS
12247	payment	1726	1726	1874	1	1	3601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCKogozyKaW7jU1wZHtt8P6kQsBsBbEWMBtcYL8YbjxNBFu1R
12250	payment	1397	1397	1678	1	1	6639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xFyYBztNZexKJjKKe5yC7PRPJACNbpwZt6vteSEzcQ3m38Hg
12251	payment	1397	1397	1678	1	1	6640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2kHx8iAXh35fecAE5u75awoL2yNvhwXepKAPLY2gknKGYAT4
12148	payment	1726	1726	1874	1	1	3551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MHjQ9i9ArcgDGDJ8whR3o68hYp3aUnddkfbMRgSPgP8ABDr5
12149	payment	1726	1726	1874	1	1	3552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dyavYQviRP1YCBUYPAy1YoRgBPpHQrZK2qggi9mAfuKuBkQM
12156	payment	1397	1397	1678	1	1	6592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nNFgHU5ez7okwi1tGeRyE8wbRxzNZstZDtw2oKrwyBaXgvi9
12157	payment	1726	1726	1874	1	1	3556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SY8gh17PJ2X45k1zkuCxaYrFQeh7TC6g9pksWGmG5eTHqgih
12162	payment	1397	1397	1678	1	1	6595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dw24QedHJkmpE17qNJmfKo17zFPBR6eC6Wd9kfKrX2WLe5qM
12163	payment	1397	1397	1678	1	1	6596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRVB89UCF38aHVoh7vUJ4pEMLbxebcsvp9HEzgzjTv3gYQFwt
12164	payment	1397	1397	1678	1	1	6597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvKpMdStNKEZuMv5ZoRit1nUbMftTLP7aidN7iV1wi6d6F2EZ
12165	payment	1726	1726	1874	1	1	3559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX4kzN8nWVMGePh3j2c3oQxiZGLH5Jd4wnDeQqvPEWhpWLFXR
12166	payment	1726	1726	1874	1	1	3560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78ZHd3zp5KTq9hVJK44bHU7SS5FuRybdtKkqx18518mphyeDg
12167	payment	1726	1726	1874	1	1	3561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKe7wJY1D7B2sjnRQw3ovtdDRB5kVLgH641btDuHm1vD65m6Bo
12179	payment	1397	1397	1678	1	1	6603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGKz4ad1RrQAt58mXfzMbq6vWsmbLJsUkoWMnfBAzuCDa79F7
12180	payment	1726	1726	1874	1	1	3568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoyCqcQe8pPFeZgGReGEKvm3wtaTaWJdJGuDU57hRXMQN4Bag
12181	payment	1397	1397	1678	1	1	6604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a7X17c16SDmpZ8KTcw5NYSM2oD3VNZs7YBmmVDfWEuCERyUP
12194	payment	1397	1397	1678	1	1	6611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRWGyZwnze1X66GFzPGvN2XyFCLT7MUCz4Q1MHW123u8ywUGq
12195	payment	1726	1726	1874	1	1	3575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZLRYWSX9fjZn1UrXuEXwTrsGKMHMFzTvsZ38tZdL5NkCTt1s
12226	payment	1397	1397	1678	1	1	6627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiwyTnyszfSVRUVAthjiuvY2Brg3gMDhoDJjud2JWPo2zV7Rz
12227	payment	1726	1726	1874	1	1	3591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82Y6YqBcri2K56jEV2zFMT49gQHTWvyGsHjd7AeYvkQdjo1D9
12235	payment	1397	1397	1678	1	1	6631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQcqcaEYtLvtjdx648s51WJNqsVCBpM6RDrR33SFWFMyY2Dt3
12236	payment	1726	1726	1874	1	1	3596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaRYPCecd5KWmAW2eQgrjnmdksRtXBqsz4UxUAyBgwhLigGWn
12240	payment	1397	1397	1678	1	1	6634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHvavCugBfKm6na6bgepUGrdjW4nZ3fZZC29nKBrRK6nTWe36
12241	payment	1726	1726	1874	1	1	3598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vxK22wYqZZgUSVVf2vPnhb8GBQd9qto9SECiWwNWNrdHrWHx
12254	payment	1397	1397	1678	1	1	6641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mSbPQBtYjy9Y42DxT6QJnD3xj7WycCYzGSCkHfyE7AZNXAbj
12255	payment	1397	1397	1678	1	1	6642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfn5PgbiGTvg8Aqsjrr691iLmHFeLCfBoa4HuhY59MT1tQ1eB
12256	payment	1726	1726	1874	1	1	3605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vYvFy2U9mf9qLuZ54NoKpV5uNPXaMu26Dz1PPGZ7vUdEdagA
12257	payment	1726	1726	1874	1	1	3606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfFTz3s53RMMA5swBuqFLp6oeP9oMH7ERXUBx1YvQnb4ek5U2
12265	payment	1397	1397	1678	1	1	6646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i46ds7zZogeHgLZjaqGK9qLhJJ3nJS15iiKR7UL1fK8F4kde
12266	payment	1726	1726	1874	1	1	3611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhDYWQ8rxWZwdiY4xxufKn8ReFD1b3jqDzUJU2qHQnLgRpkMo
12280	payment	1397	1397	1678	1	1	6653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Vvaj3KXPEuRhV2Vxqzj9GR83YuaWQE2SUAuLr2Vnfv46MWnf
12281	payment	1726	1726	1874	1	1	3619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABCABMpakBWNGBkMQqJphtrzx4AMqxvLK6TpdybSKBebGzQrV
12295	payment	1726	1726	1874	1	1	3626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthiyyAKSn5uMaXqUz1SmXzGBb75u9yZTmW1mKfSW4J7xujxoa
12308	payment	1397	1397	1678	1	1	6667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnk2xREG9F1sJ6hAuzBTBXeYJuCNGGwHQLkwshtwnee3LPY6QR
12309	payment	1397	1397	1678	1	1	6668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEw8SopxJvCZdptNTLvpED39dcxUQ3f22eF8NEDfnyNxm78wFt
12310	payment	1397	1397	1678	1	1	6669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkaywT2ESF5QhLxrDeVoyeE292M5JycnJNXNwahjvwdwAXxGh
12311	payment	1726	1726	1874	1	1	3633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtAW2yxUmx2WamKCJP1ySpyAmRcHcntYrgdzXzZ43NqgbaGk8
12312	payment	1726	1726	1874	1	1	3634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRA3xAoStZ5m53z3nm5T9PjqhAvsueoApnME91ygpRhWQH1yQY
12313	payment	1726	1726	1874	1	1	3635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7T8fbJsR4MXE5ALo7Y1zvu8juFKGwxhSaUDDsK9Tn8ewHikAg
12320	payment	1397	1397	1678	1	1	6673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaJWm3CiziAZ35s17PDmkRSaihxYfvTsFcTMAmDQHpAaKBW5X
12321	payment	1397	1397	1678	1	1	6674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wggb6TaM7cNh2pQULCRwHB2J54AjugsGPLZfAKZEqVLxxhfU
12202	payment	1397	1397	1678	1	1	6615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFEFbHeReUDPZJKV9aNU128nbe9XX54gJ63C8EpMicEqSJyCN
12203	payment	1397	1397	1678	1	1	6616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMNKM59ktKqGCnd9xDNmjbQjdpZTBvjCCR69wk2AJeVfQBrDm
12204	payment	1397	1397	1678	1	1	6617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRfiuup1nyZ9P677Pj2RKqKxT3nm6tTaP9qfsLpGwaLfREWKm
12205	payment	1726	1726	1874	1	1	3579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uYfyjCFyWWwL6YWETgDBsRQYKvU7VMQ31m3BjvBFmm81tBvL
12206	payment	1726	1726	1874	1	1	3580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpH7BGq3vEAX4A8iutkrkGe4TeqVxdkihnLTB6nysDfLuF1qq
12207	payment	1726	1726	1874	1	1	3581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQAs8knueV76ou5ZsWrUMsNqDR3jBeqkcQTcVny2EJrUTkwYm
12208	payment	1397	1397	1678	1	1	6618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUA5ntA9ZsoGHLM8PfPvxJsWokSHDvtd4WPwmD7mbNcQbCcVyZ
12209	payment	1726	1726	1874	1	1	3582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtwJqAcYgGGRqPbeAkUruW9a6rJBAEwsq7C4cmQectS2hd72v
12212	payment	1397	1397	1678	1	1	6620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69BnqLk18pXCiBgN6jkGCBqhHnwEF9Np9tW9TXu82mU84Ntx2
12213	payment	1397	1397	1678	1	1	6621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzSjvJAMzgzuSHKtsTiB3j8DE3MjRr8CEXvC9A7bfNvBivwmd
12214	payment	1726	1726	1874	1	1	3584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefNM15GGxqn3SGoTXcsXmheLq2vNYM6231skwYwVBYxf4jkek
12215	payment	1726	1726	1874	1	1	3585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfbDVNRearuVWqpYJu78TeBs3oPsYtX5BPNb6PeFK2X3TCy5q
12224	payment	1397	1397	1678	1	1	6626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo454TxTZAxu6vrq1tHYBJdwRR6P49AThyQb1VdeRrC36QD2ha
12225	payment	1726	1726	1874	1	1	3590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6cwYUavxCsBZovuaNcEFkcEK32oyobfxZvi5NyVigYdvhsjs
12230	payment	1726	1726	1874	1	1	3593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97BsLTpsrecEdjPQkrmZyUudoZ2eyJH7dcLj2oJZ31BMJaegN
12239	payment	1397	1397	1678	1	1	6633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2UoBEtj615M6F35naVr4drfCyFP29FrGxq7HPa5t3fa8bhfa
12262	payment	1397	1397	1678	1	1	6645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskYoWHPKwS111dZFnK6FBBXvhvrAj51N9Puv8FFXaGzz69Eaf
12263	payment	1726	1726	1874	1	1	3609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaveQXG2SXnBvrR7P2YJ84HhJRPgyk5wD6iwmceA19JZusFEN
12264	payment	1726	1726	2048	1	1	3610	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXwiFF84mYgGiXPEB7B3uWT42QQEqRKCfdwYXzXzWSGPq1SF3k
12268	payment	1397	1397	1678	1	1	6647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFoW2VFpPjnjYEs8yHCrd3kPa2JRGESY77ndYpBHsRntKsbGb
12269	payment	1726	1726	1874	1	1	3613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBije31wdwbSYWiVrLTwsMccZYKZgx4LU1tgBvEy2vVCAmf3T
12274	payment	1397	1397	1678	1	1	6650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9m5fnSQesmkFMpza771FW4mVp6EBogT2fEmjzTYSbTxTq8Aai
12275	payment	1397	1397	1678	1	1	6651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVP2d1SkJRDwGGsw3zhmokKP4xLq2RY7mCZzEysJ24iDCfqsuN
12276	payment	1726	1726	1874	1	1	3616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxm2DeGaBvnhMJ59pp4gHaQAqJbULmSzBb3x98zEYSa47Jij8
12277	payment	1726	1726	1874	1	1	3617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oGKGAnyV89mDPtRANc1rsNx7DziSWtcDit6T7AWJZVx3hLmR
12278	payment	1397	1397	1678	1	1	6652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsMcXPjd1PqLQVUk5BCuUWNbktXVGEmhPMPg4gWWqdfG6b5f3
12279	payment	1726	1726	1874	1	1	3618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2bzAWRL8sVXhHrCYVWBM3RoguvRJBG3ehksnmkga85HVgU5n
12282	payment	1397	1397	1678	1	1	6654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXjQwfkFJy7zk93NR1DqcQ44tMyTY9NUiqbmje3uCLRzSFRBa
12283	payment	1397	1397	1678	1	1	6655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfKL7kzR4d7SftX58Q71u9JNRrbRjXVxL7oaeVkh8NuEeP76u
12284	payment	1397	1397	1678	1	1	6656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwUqo5EsJ7KPjfpBr4qSmXbZbkA7K3xx3hHPNPXhQiCAfnVWH
12285	payment	1726	1726	1874	1	1	3620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBRpKX6Y85bzgTAiAjBVzKaZoBYbr9B6oJ8wqftKuBUXQFt5H
12286	payment	1726	1726	1874	1	1	3621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWXzZE7Cx2FXSf2HuJ9ngsi8tx5iDmNrfWRCMAQVVysSoukox
12289	payment	1397	1397	1678	1	1	6658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuJEfxz9pXc9BC1rtr1yFaNZNCeu4dyUBMo9uZDkiBPwKU5C6
12290	payment	1397	1397	1678	1	1	6659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswzQUKBTS1osZk7HvY97gcV8HnUkvWiissGgC3w8PvPCzL2qk
12291	payment	1726	1726	1874	1	1	3623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sktyk7t7e7h1Zmp3RvAnL7mLoGxpo6eURcrFHvmQ41k1k4HL
12292	payment	1726	1726	1874	1	1	3624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWGrPc3zRENbYLHCYEbYsBXGAGkk1gc4kkFbQYcVcknvtSbvc
12298	payment	1397	1397	1678	1	1	6662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbvfYb4HGqCtu1evfQC6opiFWVBwCJCnfRinY2jBnNZ1spvMp
12299	payment	1726	1726	1874	1	1	3628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUs2i1jhbZceKfVJWsr5sjSVp4waJ79QcZx8HjJwQV7RQ38n1Z
12229	payment	1726	1726	1874	1	1	3592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBWJqzphzYL8A3ywXX2LDqspBuYnCNJr8peWNagZJR1QimMMh
12231	payment	1397	1397	1678	1	1	6629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaYzdYEhKhR7kK6NywcKnLSYdagkquJWBnbogCWfJ2qCPugZn
12232	payment	1397	1397	1678	1	1	6630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMxXD9bQL1cv4KQS1KUvf8xETSNpZUqNSrFUnxbbRqXzgBrDN
12233	payment	1726	1726	1874	1	1	3594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXSEndQdHxUbVKr42jixd1BDcTdVFHP37QrcSbhaUUvtbdskM
12234	payment	1726	1726	1874	1	1	3595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBm5fyAaKsy1LCZFcnQFVfmPVVkqFZ1jNZk9wjzQyNBMmoxmW9
12248	payment	1397	1397	1678	1	1	6638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbEEVsQWkyiLUJHdLqGzNi5uMQ85p5hmnw1F9osoJKYGAcVDp
12249	payment	1726	1726	1874	1	1	3602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QUd3RZa8XHvojGKLn7cuuATkMsyDy8hg9CvXuqMvpkfMKy1G
12267	payment	1726	1726	1874	1	1	3612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwus78o6Ho8stMyjze6AYf3VSqxgf8ergHqvMk31iZiEtigRP
12272	payment	1397	1397	1678	1	1	6649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseDqT1oXaGA2RtAy6CkWKUMfUBpTd5MishRd4uwJ6BjJuj5mk
12273	payment	1726	1726	1874	1	1	3615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaGTBZQXq3UAXqWHPzr3FpfWqgFWr4GiNrVxtjmbNSPnTczeY
12287	payment	1397	1397	1678	1	1	6657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavgQ598AFDv6GegRV8nG9JS7X6tWKyGzCPnLqZgChCAqGFTf6
12288	payment	1726	1726	1874	1	1	3622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4SgGhggPPQp5AkL9aUJLv2Pzzj55eo8SLE1YKb9oLqrnXEoJ
12296	payment	1397	1397	1678	1	1	6661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7g3LHiRToL2d67wEeBpjhzm4xzbKT7kJcUG5XoKsWkWWxof56
12297	payment	1726	1726	1874	1	1	3627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNr6JL2YJ6HSPNQERrmKHyJJqerG1DsjjBthCHoX68JXcFdJT
12300	payment	1397	1397	1678	1	1	6663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD9W44LYR5RBJXhGkJWsWgKvSMzbNCpLFzxWjhSNZK4GgVCnq
12301	payment	1397	1397	1678	1	1	6664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjFMLhsVi6cEmw8Dc6BdgdoX7GshyWXevsBRS1FR7rKUxdUtt
12302	payment	1726	1726	1874	1	1	3629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzo2EvQ37ZyHKhgwvbKy9kDdYSaPtRo1eEksrpKtCd23EXGth
12303	payment	1726	1726	1874	1	1	3630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5hFPTko5fseR9iHd37SFqqXY7nHaW9f9BNBRVsjZSmuf8D9f
12315	payment	1726	1726	1874	1	1	3636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ea3WpVv5sgPXYtNUEGpB12hviPjHLx6W6RRNSHzip97XxFo6
12339	payment	1397	1397	1678	1	1	6682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvpcGD1GMfTRbuhr9SZTQchJLyweHze2buHNqngKksBnECqML
12340	payment	1726	1726	1874	1	1	3649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XiJED2RsFs3fuiKHFKp9tq2tYBXNxWvJUHKu13Pcc1U83oWT
12345	payment	1397	1397	1678	1	1	6685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kYSh6CR9QsCN8PyVY6kT7mgeJkqRmvvpGz9PEcb1QM8VSwBc
12346	payment	1726	1726	1874	1	1	3652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5YHZtreG4qtyqFXm13AWgvTsm2PWstutVDnMQkfX57ZQSNw6
12347	payment	1397	1397	1678	1	1	6686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9ZyuMAcGGqd34ETjvdZ636PiDRHeEhjXcJdNE59Qi72h4j3F
12348	payment	1726	1726	1874	1	1	3653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkA8ziz4dqwMwPeEQfMixxjweiba1XeVwF7wWDxknRD4vvDis
12349	payment	1422	1422	971	1	1	6	2226108106880	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZ9pq6kxTMRMyZSQHAvioXqgyK4DNKdZNAGezaptvg7rKgKAvBr
12350	payment	1775	1775	2047	1	1	6	300000	11000000	65535	E4YfGXnrto29QXhFDTwqXiuZfyn1e6qmX4d2fvfhBndeGw6BEsMhK	CkpZu7p8TetuNUFrxsqmSWC2JZRPc6qS78AG5wJyJSTgqTeaNQEDR
12351	delegation	149	149	58	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVufXyvmVTCWLgaAG1ycru9jjtam3AsUy5Je4vA1zhEzWkzvB
12352	payment	1397	1397	1678	1	1	6687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnkNnsySHqcSLceo2awArJxXn8bxS81BjxSkXmo1Hc4nsYh9A
12353	payment	1397	1397	1678	1	1	6688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Wsnj2iK2wcN467xJcSjmoeW6H9xFuiL3C1wWGoXbJ7Dowtsg
12354	payment	1397	1397	1678	1	1	6689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GdEEs3f4sAeKcNufjoBdpNFamuLgjdoFdhFrKBRjTZCHjFVx
12355	payment	1397	1397	1678	1	1	6690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymp9e7q3ZK4637sFTBU4yyMJmzxZG4FbgWKa9ohwoFzzc7RFj
12356	payment	1726	1726	1874	1	1	3654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJASyx8FwYtDuZbnNmF2kxNzfxv2e7RFLFuajXsAZ62F4Rowzh
12357	payment	1726	1726	1874	1	1	3655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEfZhbg8tGkTPLYrWDS65b1KxNQNd9QM4EDhYHFmUR1JHahei
12358	payment	1726	1726	1874	1	1	3656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WVZETF2vSPufwnv48GimgDrzog2sJt1fRBmpWBjqQAjGVggK
12359	payment	1726	1726	1874	1	1	3657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsVRtwms79N8DEDFcYPN2j1a4taxoVBeJBuAJ1PC1UWMHciUC
12373	payment	1397	1397	1678	1	1	6697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCv8HUQL2Hsvec9hHry8MPeJNNeEEG8XFUh5a7CezFWLcGzgki
12374	payment	1726	1726	1874	1	1	3664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRohhhWcXhZivVfG8xJjp5YkxSboxnwKd3ZskcZcUZesY6s4BL
12252	payment	1726	1726	1874	1	1	3603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuh3PWTd1XkTx6K2oMV7W59m9DMMzMQ8kZ3gEDurqJRrxBSmW
12253	payment	1726	1726	1874	1	1	3604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvYSqYfuxiXW4cFiA1BbYpg2xgup75PtTfgy8kmCa7JaN8c4Q
12258	payment	1397	1397	1678	1	1	6643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrNoHsyA6taWwXmTyovLjL6SnNgr5dUaoeXmdWbW4XALDgYFv
12259	payment	1397	1397	1678	1	1	6644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJqCnDK5wWd8cLeAXHMs6QdM7ZWWXaWyNLrjNwGvG6nvtxZ8d
12260	payment	1726	1726	1874	1	1	3607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAnGBFsV9SCNE2TsmYnhUCktw5APRT78aAtLxFBbPkxxJBsgC
12261	payment	1726	1726	1874	1	1	3608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGGBgWsA7krFDsTnptNwM6rdgrtzWRvG38B8UEvYoTwsu94Xf
12270	payment	1397	1397	1678	1	1	6648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW1cGN4uGPrUx76jGLkdZCxdMqagDA2Hc5YVrg8zPmC8qpAXZ
12271	payment	1726	1726	1874	1	1	3614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mccjMEDJVHMoWKuvjnLk62Mr6RVfnbdMCbuAoWRdhGgPZKm
12293	payment	1397	1397	1678	1	1	6660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXKAkKkn37wjUJGBkrpuV9BQTQrX87Xhr8k3WMUqrb5MeA1B9
12294	payment	1726	1726	1874	1	1	3625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrxGqHczMasMUuthAEcvHgCHnpm6edg218mRQukwkiSFXFYCg
12306	payment	1726	1726	1874	1	1	3631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfcATPqCMhQQoXKjaYkNDCQ5SwWExg7BBgTaRhxHuzT5Ak8Vj
12307	payment	1726	1726	1874	1	1	3632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FNYFXqgZ6kQ9pAq5YEbeKdgxRoUX8s33oLraFypAUxKWWoqe
12314	payment	1397	1397	1678	1	1	6670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzK78F1sHuJabS1Jxg9yW4uTNJxmFKU3tFDokeC4waspLD8vXy
12324	payment	1397	1397	1678	1	1	6675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnC34aTVcHmMgwu6w4t5SSe314YVc3yrNpZkigQhU5CpTuvVq
12325	payment	1726	1726	1874	1	1	3641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9GrK9V65XtsoKDa5bs3opcL6aSLazUgmDHA1m8k8kMQpieXt
12333	payment	1397	1397	1678	1	1	6679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjk7ffcBwrRRp4o7rJYM4irixrKpUAE6Gz6twnoydUggJqhex
12334	payment	1726	1726	1874	1	1	3646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLjSUCcc5msKScaAds3R8tjCMrgcZ7kVEbPfs8gtC3cc51dNi
12343	payment	1397	1397	1678	1	1	6684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomB82eFq4DtjT9q1VebokQS265UdPYEpSmLqbAB4crUBvRLbv
12344	payment	1726	1726	1874	1	1	3651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHYMsAfnhUT7F1pLw9FquMMbnpNK7BxquctXYoJW7W83tjNCx
12360	delegation	58	58	58	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGnc9zJenJ7S47Ec3DGbV7qx8nvRkjx5Sg8WeNQNPi3cSMdjp
12361	payment	1397	1397	1678	1	1	6691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEkjvp7RWPoFRFyjQgPJuWdJ3D54ue16vkbo1qKJYAkSGBh2r
12362	payment	1726	1726	1874	1	1	3658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMhzsUXXan2rLntDc673voPbjSqkyLQcjG1vdcmwBqgTVjnXr
12367	payment	1397	1397	1678	1	1	6694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZRfhANbCgnd8NuwYkRctj27Hsb9xTjspQndBUH7HWcaYt2iG
12368	payment	1397	1397	1678	1	1	6695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoNzLoPDSu31hy99PtradtGsZ8SansWLTFLSadWy77PyZcVbZ
12369	payment	1726	1726	1874	1	1	3661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUDaQJsYH2WBEio8cwHY6kyAs1mQCj51iPhRjD91axkCYwqE7
12370	payment	1726	1726	1874	1	1	3662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDydgRYn6JTUSV7kgXKvhahSaj4Do25LaL8vWKPNg3Mn99xpWf
12371	payment	1397	1397	1678	1	1	6696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPVCAL2PZB421AQxgE4R8ULVHz6js81GMtF1598BWgqd7gq5
12372	payment	1726	1726	1874	1	1	3663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEStgiK1nG7F5NqmjCpnV3T5Km8LEz7Jo1n9KrJqoxuMsm2Tg8
12384	payment	1397	1397	1678	1	1	6702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHpymzqkMzAF6BtKyPhBWPAuJ2pFmKqXUsPu2jA3c1Xmf4hu3
12385	payment	1397	1397	1678	1	1	6703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76hyYLKxzQiwsYkdvAhRfPMJR9y3RFWWCLnSByoUokCpLXvvT
12386	payment	1747	1747	1704	1	1	3	1000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYdALvKQ2DmK9gRyunf28BXUKA1yVX3BEndo81odXXxuddaEMbP
12387	payment	1726	1726	1874	1	1	3668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqXe65YKT72hUuboD85mJYAKLG5b49WFxuX3Akp7vst3a5FtK
12388	payment	1726	1726	1874	1	1	3669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAyqPvugui7aUnxDrYQ7MHR4aiDKoJjy6jnLkSFXdAbvwGFXa
12389	payment	1397	1397	1678	1	1	6704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsF9484EUz92DBnwUAAGo6XjAauvtrM2pGwxh1s7CPrdj2At4
12390	payment	1726	1726	1874	1	1	3670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnrUveoWCs2DyNc95jfogywqze2853VLauNyjqeC1NED2vJYo
12400	payment	1397	1397	1678	1	1	6707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmVrzc6Wk4i2XEEwdP6tHwVwv6KnsSdbsDwX3xmkGbEWz9pSx
12401	payment	1704	1704	1075	1	1	0	4254000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYSmoUs7JMsVcrZVMTSdYieLP8XkrtkHiqTo4AAp7stnBLf6fvb
12402	payment	1726	1726	1874	1	1	3674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRyuwvBXFYifKfxJA2XbP6G3Px2n1ZXYj1ESJXRoY3ecNyojH
12304	payment	1397	1397	1678	1	1	6665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV69mGUG6HeaWBNYEszuTAMmpyy341dNXkPYRsoeoAkXkJoBwF
12305	payment	1397	1397	1678	1	1	6666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsy6uasqeKKKBuDcvqYknD9HJRoCoMbWNiMEt9JKZDsBpfuojF
12316	payment	1397	1397	1678	1	1	6671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48DXLPKfNbXfVRo7BRY33LCCKsigD1D3kPJWYsupKxhFQrFeD
12317	payment	1397	1397	1678	1	1	6672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBoHn9qhSU8GEUHkRKQUTsHYCochEeUTsM9ZMeZVytZcdvEgN
12318	payment	1726	1726	1874	1	1	3637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U46jgNwdwH3d5cpxqeh7FqTjbqX4fPbmgThiBL493puobDgH
12319	payment	1726	1726	1874	1	1	3638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3p1Jj9gGn7maXXY54NupCQmpBDjyDEAoRvP9wC9e7QLHzDXYR
12326	payment	1726	1726	2050	1	1	3642	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgEmZ6vkzJEhoiNxrAvDt61aSaRbn9vfHCPXmjDmuoTThma4vD
12327	payment	1397	1397	1678	1	1	6676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsSt6mHypZtDaaLYyueYjUTv82zKriR1o3DbCth8BzSNfiGHc4
12328	payment	1726	1726	1874	1	1	3643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAz5YVjVwe4p5YHANmfX9h685NJWoSxR1Z1Y7ApVbiiE2TL7Hk
12335	payment	1397	1397	1678	1	1	6680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXEYfYS4Lpkrv9wzuN78KgyXEQWs9BMXBDasbeDeiyw3hFpCM
12336	payment	1726	1726	1874	1	1	3647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcaQgH3xepgq6XQRtrhDr8XKL9d9MN1uERXgUUgAsvNBQDMAk
12341	payment	1397	1397	1678	1	1	6683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRX4YgZHdYqMxHTenZEvjatKRZqWGm549DwzmZgQ4XPBwti1Y
12342	payment	1726	1726	1874	1	1	3650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHaCN9eiP4hginrYcGGV8mq5qLpq2KJDPeGXRo62SjgwXCJQA
12363	payment	1397	1397	1678	1	1	6692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWpWSo8nHuYCMNR28zn9eiXSX1TNCrAH3KPVLrSrHwhj7QkN5
12364	payment	1726	1726	1874	1	1	3659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kLQCHXDQzShgkgd8M5PbNyXGJt7YqwmWfw61mQ9nkroPK2qB
12411	payment	1397	1397	1678	1	1	6711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmwY94fSJJCHYcSrtrN2ZcVvomDPtM5ZLUieppUpYmRfrqScJ
12412	payment	1726	1726	1874	1	1	3678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiuPoqKu7FSGki9GkvTCVfkkSocu2SeYrU2ZMrb3efzJ3cxx7
12417	payment	1397	1397	1678	1	1	6714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FK5htsu9GVsnr7fvvUpoRaX5kxikAkCHygSiqW5ER3tBWTuf
12418	payment	1726	1726	1874	1	1	3681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfLonCkUN2FjqqHzqGFt6dYJF6Us9TCUGZjE36PH1W4bneTRv
12439	payment	1397	1397	1678	1	1	6725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Tcxkity8fL3sQgAVKTDooFiNZgx2NvzmMcYGDuVQ22Hv7CCt
12440	payment	1397	1397	1678	1	1	6726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc5HbM3zdkb5CWxLEbaVL14RXDHr3ZgJw7dwjKPAuve9za31iG
12441	payment	1726	1726	1874	1	1	3692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiYGsbWwABYDp8VR6ByZTzQrpqJgW2FcRfV5aDHrtrT7zaeDr
12442	payment	1726	1726	1874	1	1	3693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DsjiFcCP7y14xS7VsycMgmxrgMhJqUrfLcWyTwkQmLKSxb7s
12443	payment	1457	1457	1025	1	1	0	2552961600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXh4ncZnNjyiyV4deLfd9ZFoi1K9FPKBd643oBpfH7QyyiExV
12450	payment	1397	1397	1678	1	1	6730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGvhk2u9wy18aSUQAqD3qgAyX8pP5r3iW9jdbFC5VQL2ccV4k
12451	payment	1726	1726	1874	1	1	3697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMFhZX6nF8nHwdU786sj6sreuJXfnXMM1ZRgSi15sYS7bQgXX
12470	payment	1397	1397	1678	1	1	6737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1te8mXcuofZHaGiyRDwT5zMoNZEVW75fxEc8YKqg5tndx8si
12471	payment	1726	1726	1874	1	1	3706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYnEMeRY6yKmaCHbEkWUjXiZa5MpmnCcBi4gRPan9QwFpDNXL
12472	payment	1397	1397	1678	1	1	6738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbZjNxb5ryLTmQhHeghUEvHdr426QLyj4qF9zc5btDkB8kN47
12473	payment	1726	1726	1874	1	1	3707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEwD3XxVWXLLifxyoLpoWsdAUCapYqd3ZVxBmDMrsRAuSiPhJ
12476	payment	1726	1726	1874	1	1	3710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFmNaELndsbs1U89XPfjNoMKdJNBKizR7tG5mLocdjwWHUT2t
12478	payment	1726	1726	1874	1	1	3712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceuXAC8uDFu2zffQQtnpke1guMPCKw7xyw4Neveb6fKGwpAAL
12479	payment	1726	1726	1874	1	1	3713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8GiaNthjjBQBy9NGkB2B1EGhbcDoPP24RE1qwp4NQRA64XDR
12480	payment	1726	1726	1874	1	1	3714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8cxHZnfnEFvbP3FJxG6rDhZjhAxH6ykpUM6wRCEsPFs4TibB
12486	payment	1726	1726	1874	1	1	3720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3HXd3tFFw39Ry7MPr1EU6xbdxJxF2VRi6YvaGHoCsPNLdvHxn
12487	payment	1726	1726	1874	1	1	3721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP61gu8iWjhjKEjkESUQAJRUCvvALwcw7NtK3jf8hx17N9zW8G
12492	payment	1726	1726	1874	1	1	3726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLXMppqqiYeWBse7NzP8ekwCRZBUHpmv5W57iTQgdGZEXRgqF
12495	payment	1726	1726	1874	1	1	3729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPip7t5cFmn27ZP3usb3DnSP8epQRPkd8EXDgJZUncfmTBfgC7
12322	payment	1726	1726	1874	1	1	3639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNXpHcvnvcAecBzcook9ok6r9WrSsLJBd7eKZhMpAHgmVy7No
12323	payment	1726	1726	1874	1	1	3640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBSCP7nvuiAsdtpn463wZbdDWygK29cLGjGSWSC4rXzwgUMib
12329	payment	1397	1397	1678	1	1	6677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcipsGZBDhVVvTFxTcSFx7JxEfUEbui42eJ9bpeWAMQo7ZCcg4
12330	payment	1726	1726	1874	1	1	3644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3UAYpDGPtzsL9UHGB5FSZ3WxaGj4X7z9g21uTt3nrif2ihJ5
12331	payment	1397	1397	1678	1	1	6678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9z7hTJaRQvSNeqhqwPC2WqQoJ2ybvjqhT4kW7FDSbuk2SFxp
12332	payment	1726	1726	1874	1	1	3645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo4Z21ZjYET96FaPHUHHYeuoB9Y8hk1mp8GdZ2MhoibQ5X3ey
12337	payment	1397	1397	1678	1	1	6681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MXEy9GZZ9SogaTS3GWa1PRwJK4GouNaX2CvfkSwGkB5qwXo8
12338	payment	1726	1726	1874	1	1	3648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFEaH5QLhwD3VzdvLcetHwj2Pd6LGkduoMevScpGf3WtUtHH7
12365	payment	1397	1397	1678	1	1	6693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a9peV13cCgKD6C8wZcYJfgZGXE5cqz1fE3nPKNKq8ox7Et1V
12366	payment	1726	1726	1874	1	1	3660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46T7jXTXGVV4ntAJa5tJhaU62MqPpqhvV8eJRXq9uKV8ZHmRG
12394	payment	1726	1726	2050	1	1	3672	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2rDAJcMMRTkYGKKoCHGagcLPtQ68fMeEcm27cCaMBAd6kJkrG
12395	payment	1397	1397	1678	1	1	6706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPyFKQbc4ba5bRFxpUGVHKwEAVTy12NnY4JgCbYzYK2pqq8q4
12396	payment	1775	1775	2047	1	1	10	700000	2000000	65535	E4YRfE2fnUBCLHteXSgVMnFhVVVgAr3rPHwn8A4cnYm92qV5mAwQ7	CkpaBPxs8yYmHy8LiX2QVFQ3KDEhRSrbazmFvd73vaKwL3Dx7ypEn
12397	payment	1747	1747	1321	1	1	4	7998000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYfHX2vL4b9ToYETE7ZUqLmeVUHnmEhXMKVzHmw33xEqGgqzTJs
12398	payment	1769	1769	1769	1	1	22	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Kg9qe6QPJh6a1s6oiotK6oKDxFREvTRADnvWfRAMy5rxRpzF
12399	payment	1726	1726	1874	1	1	3673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFrnxqEhvSxwgzngeYxfjMX5N5S9ve721Udeqooekceah21AM
12403	payment	1397	1397	1678	1	1	6708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcazeE6gt8Bx5N3JFoMtEee5qfuJBuFYTF4TDAiMN3aXuEaDJh
12404	payment	1726	1726	1874	1	1	3675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJB9CCQGXxv4uEJK2VJ7rQqnKx4Y4rJU1o1ngnADV8UJE4UJk
12405	payment	1746	1746	1195	1	1	0	2871000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpaFery1Bza9CgMtGGKJHmt4JzMZpNr7F5cFfbhtQbw3PT8FJ6hg
12419	payment	1397	1397	1678	1	1	6715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhh3cYTwgzavksMBugXsT2bwxyxNeZzYnCapekZYMEevAYw2nr
12420	payment	1397	1397	1678	1	1	6716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmbd6v5QfpyZ5eEZ2qKt43UMSTx29KW47itznbwG3Y18wKLcv
12421	payment	1726	1726	1874	1	1	3682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjsTjFoVNCFc2oeGgZ79q7VUa3FyzkcPEzY1g6zStndmq1kd6
12422	payment	1726	1726	1874	1	1	3683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbma5p7M5UgRHX9LtrGuCqBqkEZeqYNPPSZ67S4eHGsY6zi2o5
12446	payment	1397	1397	1678	1	1	6728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmvGDBuXviYeniQSiWSztYvqqaVK1M97qwA9XdJJ36QomQRaL
12447	payment	1726	1726	1874	1	1	3695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNG5htM3h7NWzaSn4NDoqrLN1bJcXfqcofuQF6hLJ7oj1wWmoT
12452	payment	1397	1397	1678	1	1	6731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhn1f4thXzu9VjQP8dsLfbaBZDrGaXppZpgex4yqM9suKjFJA
12453	payment	1726	1726	1874	1	1	3698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAPWQ1DHUiNDYsq5JFyzBCXkLa4X7raqJu2ck2XUijKTTsXbg
12454	payment	1457	1457	1265	1	1	1	3086727840000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGVR2LSk6UdcmeajReYkgGiHHAAJsN3nyFW27aM4b922Hbs3M
12455	payment	1457	1457	1145	1	1	2	4575029760000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwnY7sWaHv3CN6RcjggKvzLhck2V9B3rPZeemrBX2Kj7pUuoe
12456	payment	1457	1457	1391	1	1	3	8601737760000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1doYig6u4q42Tmq8XBWn99Hkpbb7gP9x4SosK1xnZXLTGGK9p
12461	delegation	1769	1769	44	1	1	23	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBAv8yCSPnvYcZDxACWvcs3bQh6WfNjBkJixoakzdJvYnZezy
12462	payment	1397	1397	1678	1	1	6733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBUgxfifZYMkiDX79RnNAwnf1LWWFgCNcNhAVY4yLEWoSjvE7
12463	payment	1397	1397	1678	1	1	6734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB1V4R2BS7p8eZDedZqLbT6ZRa56nEgCrAzpEBj5rj2smaerA
12464	payment	1397	1397	1678	1	1	6735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfA6LD9yUfn34kEb2Y51R4A8xeZ9AgyML7vWFprkTWQRgx6462
12465	payment	1726	1726	1874	1	1	3702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYGcF5vdrPBm7otGvmgRevBBMN8GrSPew5tREi5TeC9Nytr9mc
12466	payment	1726	1726	1874	1	1	3703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQSfQT3HPe45wfwSF7obLAnymiwNzCUrnNxaqYpnYjkjbQbYL
12467	payment	1726	1726	1874	1	1	3704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzUwpBMzS8aZTmmBamWBwdBqmcDEKdEj5Lbx7naN1meUruW6z
12468	payment	1397	1397	1678	1	1	6736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLvpymez72majgLe6grzeiNuQv6UDJGNRp7X1MuQfYs8mNAQD
12375	payment	1775	1775	2047	1	1	7	400000	1000000	65535	E4YpzFg29rNWPNUGAZ3fqXqXpELrQDtYtSCac5RWjWNLa8tmzpuF1	CkpZbECFzLiG2dM5amj1UXqynZwrtxUUhfHrqfJSPtoUBY9PaQrPm
12376	payment	1397	1397	1678	1	1	6698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEZ3vinjTbgGGuWDzHqc9e5iTzQgTFyk3yTC6WLwMF41zUdtbo
12377	payment	1775	1775	2047	1	1	8	500000	11000000	65535	E4Yo3WVnhpX5i9LH3Fn2zNxFZXmxWbYA5N4D3LYipz1q79qNoKkmG	CkpZSHYgTY2REFPb9jfJtgYar5khxKCs9JhvBJ2nJhsfQDZJ1YYS4
12378	payment	1397	1397	1678	1	1	6699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUbswiyQHx7SjhepXs7Z33tiNHnhtYQQs686k9rgpE6535wP5
12379	payment	1397	1397	1678	1	1	6700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjJTiLbdp2PtKAUG3QUFnK2PX2KXySxDetT2nMee1eWGFd6by
12380	payment	1397	1397	1678	1	1	6701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6by35ivxdo6trdSaJxjH8zgiBaNaZZufd1EaVThpcjmqbeWce
12381	payment	1726	1726	1874	1	1	3665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Er4MuXNmw6ed8vLxH1jmRGLKADkPFbiL1rViQR3bzXN5oH4
12382	payment	1726	1726	1874	1	1	3666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhi7qe8EaByqUfzYy7bEsjrP5EU5xaFZBukh6xZHyY58Jvix7
12383	payment	1726	1726	1874	1	1	3667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9KjyQMGxGP9j6Mb4DiSsNFAANB6m6HTd9axWrz9BpPg1pDkF
12391	payment	1397	1397	1678	1	1	6705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHuQj19gUbHawS1X1q2jQ7S1qqQzPdpuFy1jtiok6bgHhnsWG
12392	payment	1775	1775	2047	1	1	9	600000	1000000	65535	E4YTbvw1s9BiHM2ALfgQRyyrxtSmz6rSNSYizMdwT65UU2NHky66f	CkpZz89WtEypmuhe2EEu1brtTCisMPXmNA5XUbeQfhBuJAbhRPzGz
12393	payment	1726	1726	1874	1	1	3671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXRTAR5zGUkZ4SyjPdyvxQhYxfrvSYNmwueupQ8er2fTxDMTy
12413	payment	1397	1397	1678	1	1	6712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPe2mA47xyEw4scuEN3359jzz3nVMrYezVLosS2p3DE9eDTah
12414	payment	1726	1726	1874	1	1	3679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJVHPUfZkrXyT3w9mqfmxqc4t98wwSW4AC5tN4TWcM2uhj984
12415	payment	1397	1397	1678	1	1	6713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcnAopQ4n1XdtGWJcTXNabbiErV7t2EMr9f32WAKfb85rFnUc
12416	payment	1726	1726	1874	1	1	3680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnh5k7mdbGVD4pUetv2EJt6DhiAjdYWyp3mTzAuHyK24g7yW71
12433	payment	1397	1397	1678	1	1	6722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjuzsewFMQLX9AaD3cMsY5vyWLbzSNVr8wSR8ei3adWTYzQ9j
12434	payment	1397	1397	1678	1	1	6723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrYBsidsQkZguGgNwyi56fDRqeoBSKtJUBZdDf9ePCW5LGm1C
12435	payment	1397	1397	1678	1	1	6724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAYekGpcCDxLrfs4xePRbnB5W2cMVNy498tPepwXRbWwfrnMA
12436	payment	1726	1726	1874	1	1	3689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9MaGH8nkcMQVdKrPeZdXTKaap6E7WGaZbc2VnFk8NVCWUEzy
12437	payment	1726	1726	1874	1	1	3690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnVjyhk8rG6zSzhDf3KGDa5v4Ue6MjrMQ7y2S5mmnVi9fjhDC
12438	payment	1726	1726	1874	1	1	3691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMFDHTdArUjBJHeRWb4HdQKhE9Mpd76XWECX98CMajAP6HeQK
12444	payment	1397	1397	1678	1	1	6727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXquQFiQPQvcMMmSDBfys5rd4tKG5eh1BwwFXQmo4yDNtYsGVX
12445	payment	1726	1726	1874	1	1	3694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4tWACW8fpv1YQYWuNnnY3etFTz3Zh4eDJ3q7HBidjFL8XWyk
12457	payment	1397	1397	1678	1	1	6732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfV1Kz45nuQnErCR5nQU8y7eKNmTugetUEEfkmx4HU1kGqMd3
12458	payment	1726	1726	1874	1	1	3699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2namZ8MwjS8gAMgbcwrPPnFh6NP52EWb5Tphc4or9sW9WcT2
12459	payment	1726	1726	2051	1	1	3700	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnLihDrva3YjYyrUvvCUGbe1C3ZXBFfxtejfRC7C4ycAXtZUnh
12460	payment	1726	1726	2052	1	1	3701	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoSzyiw3mRNRxm2N46qzzyr4mJS7jnWiHDtUXje2tp9h5NsYkc
12474	payment	1726	1726	1874	1	1	3708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDkcVYMfhBhk5wWfkBGGv5WmxgAFAkiLowYDauEE79Bk9eiXk
12477	payment	1726	1726	1874	1	1	3711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaaimqExs3sWC5YwyXi8qD1FPi5jygGUkMAzNbzqJLLyoMXJe
12484	payment	1726	1726	1874	1	1	3718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzy1ndSZjBv8MruoQXf6CUoiJxgrXjiEM5cDYHRvX2rf6pkik
12485	payment	1726	1726	1874	1	1	3719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgsimMbRGa8cq1vd1h5SsLoQLDVut4MzohjL8YjfFHJZXjDze
12493	payment	1726	1726	1874	1	1	3727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT25vmsdiw4KC7vjkiwp1EhZbTqDrJz6kbYAcEbvVLxmrM2xkH
12506	payment	1726	1726	1874	1	1	3739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgxFcae59owA1Eq76UG8SHw2ctgXyYiAyN7nxQJS7ehEdq2DU
12524	payment	1726	1726	1874	1	1	3757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbXECP22VLKJJND7o1brj5ypvtS8gY23hjn8Tdf2UHn4dxe2y
12525	payment	1726	1726	1874	1	1	3758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJDnjAFk6wuaTZct9vMgytwWuarBfr9nuhfYw96CaqQtnaRZm
12529	payment	1726	1726	1874	1	1	3762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6EfNBThhdFeyk6hhoBs5K8TRkrcfArf7tDYtDZnVzL9WNgkN
12530	payment	1726	1726	1874	1	1	3763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcQH8xaDX3KNAedeC6NL2Ya6bbiohNozD5f7BthegKcXMPdjM
12406	payment	1397	1397	1678	1	1	6709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUAajt31KtTmHYNwRf5c3ZqJsxhADRhx9ZCDi46HfKkrTQBLC
12407	payment	1397	1397	1678	1	1	6710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQG1xkAAgduQxY5e5VhcDTWUjSZKdiYmZiowjcgXz69upotEh
12408	payment	1726	1726	1874	1	1	3676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBiYXTLeojESfTwYh81MPRdQDfjvGYk63nbnRP5zTgipuCdzq
12409	payment	1746	1746	955	1	1	1	2374000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZ7YrXyjxwHXoVu45Weu6Syy5r9CqJwbf7yaJW5wV6Sm8MqFnVb
12410	payment	1726	1726	1874	1	1	3677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkE6YQvJQJJWXKFhw3deMj3V3eswbLEhKnFJ7wWqpwnRLnvFWw
12423	payment	1397	1397	1678	1	1	6717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHaKkXSeSkfvxsRvU7jwkt7m7ar5qBxxuwJeJqyPMmjHxu9U8X
12424	payment	1726	1726	1874	1	1	3684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfqFX5m3128HXnh3xpGLCfg3MwLA96Cji6yCWpz1HKtD1BjKe
12425	payment	1397	1397	1678	1	1	6718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMibNeGSranoHY8cDbZUQE13UzzArKd9MTt6jmG7Uw6EWQ2cQ
12426	payment	1397	1397	1678	1	1	6719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCuEQFpwxZcHgA4L412HewEcdBhTDkAJ1r9AxyLmT34MrBSxX
12427	payment	1397	1397	1678	1	1	6720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9S5WAZsYGwSnRRQfWsYPYrsNSax2u3zYaAoPjVceVa8EugsVb
12428	payment	1397	1397	1678	1	1	6721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyLmbaCoounKBkPQionro1KD3ixS92LCt5e2veMeqtT4D1qiR
12429	payment	1726	1726	1874	1	1	3685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbNgGmXx1ozB1itmL2MTLCKz3Kiwgj21bk1nTwUbAq9yKXMso
12430	payment	1726	1726	1874	1	1	3686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANUwdq9TgTpoUBEqxJrnfh8Y6RbU4hggAwQw1NnhBtbBFnvPY
12431	payment	1726	1726	1874	1	1	3687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSBfYiNG3t9TwDW8dstLaeZoR7uSwBAezCQtwGjDyPLxGWh1C
12432	payment	1726	1726	1874	1	1	3688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcJeVsVZY2qRmsxos2QrEuPS3g1jE5EuBUFPLc57cz6zr8VUC
12448	payment	1397	1397	1678	1	1	6729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYa7gnUDED4rESCSecEwkRDjCigHYxgh5aNcC83qCr68bf9Vah
12449	payment	1726	1726	1874	1	1	3696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WYBKSoguZa2G6RxN6ghdpdGjT3KHxtJ7JiC7PCjeu1wEzJFL
12475	payment	1726	1726	1874	1	1	3709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiDFckYWgSYzYqM43Yt9qP6F5H9qabw4FzsXo5x64tn74QY65
12482	payment	1726	1726	1874	1	1	3716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kk3XtQLgTWtzoF5Ea4S1skq48TQsfyNigpqDyxKy5vFwu3s8
12483	payment	1726	1726	1874	1	1	3717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsici93w4GUM7WMpXfjaav7kCoEyBHjFcUKaFbmx43xCh6wW9o
12488	payment	1726	1726	1874	1	1	3722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykPJ8CCVA38JfyKqTDqAvxHm7q7yczvMzE1ChkVwSJn3TFomC
12491	payment	1726	1726	1874	1	1	3725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy1fKBD9YyDHUyVPxPfJtPkqPU3CpGgLmsVAkekFw5rbZkSKz
12496	payment	1726	1726	1874	1	1	3730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt324WRKxBzVrkrcvJuswWqjxitZk1RzkuszarWC9YBS2cs4nj
12498	payment	1726	1726	1874	1	1	3732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPzBUn4MhFeq71eeabzp5MbCU3APcPwQPva72C1UP2mNDjgXn
12499	payment	1726	1726	1874	1	1	3733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPPdZiLzaUkeGyNivzuEcUwcd7UDgkFB86gC3fweZUdQ6vrs6
12504	payment	1726	1726	1874	1	1	3737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKoAgqU693Z7CRGqFv1Rz128gGZTJcCMACLSBnEM9BJcVX451
12507	payment	1726	1726	1874	1	1	3740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fAobrYLF28CQeFakd2dpWZarxVhrXKBaQsjNhbQqwYYDmWrH
12512	payment	1726	1726	1874	1	1	3745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvU92TEPeq2Ft7JhrLKLeDRY34k4MVjJcMEyK4fMJymUdvhzt1
12517	payment	1726	1726	1874	1	1	3750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYfG4qQ1k9gH3RrVxEEmXcrvn2sZdeX6o5y1sd7nZn6tbh2QB
12518	payment	1726	1726	1874	1	1	3751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ncDvtUAFw73isHzucU3mLSJd4pmEAtcWWa4gLAR2M2AEuTW5
12522	payment	1726	1726	1874	1	1	3755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTrEvS5dm9JdrL5wxCTeQtBcsrKxKRPCV4E4goTgzd3pgDUDZ
12523	payment	1726	1726	1874	1	1	3756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYim3Sr3LBUMH9jTkwDai9JLa2GydHKTNtEWcac4sZEVHy1S3Hh
12542	payment	1726	1726	1874	1	1	3775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLYzPQUMzY4WjcV4deap88HMVP8eLeQdFcWCL6NsxHA1PNj4h
12553	payment	1726	1726	1874	1	1	3786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC76Ppds5ePD6FDovGH6SoS35ARKi8m2JsfWFqrjE5yp6UEXsT
12575	payment	1726	1726	1874	1	1	3807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFUCmNzR2gr5fT5EMe5QKio9wT4qhce8M3xi9S5a2FpXn4mBGg
12578	payment	1726	1726	1874	1	1	3810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibtWFKhYFxdLeP1Do4CX37x3eBEqhz82co53xtWrMLbnKpfdt
12595	payment	1726	1726	1874	1	1	3822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsU5idPDYZnDyPQPUkUKQ1h1gj3USQqXRsMeCCt5h4mdCrRYkM
12599	payment	1726	1726	1874	1	1	3826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5H7ncxWLo5yRJK4NXYH7fM3MGZrV5XMdme9DuXTCa5vap7WSJ
12469	payment	1726	1726	1874	1	1	3705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo9BqgUWCEbczavxryaRATiKiQQ7dJ7cg9LGuRvFG85EAprJw
12481	payment	1726	1726	1874	1	1	3715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3wUbuAwgbhbR8SaRPDqGyswYnUjjZe1HQ2Sggqx53o9QWeAc
12489	payment	1726	1726	1874	1	1	3723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgpP4kiaU6ttKnb1b2x83BjmXpkZqtsoau8FQKZxvzb7kacE9
12490	payment	1726	1726	1874	1	1	3724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnCoQQXAx97caTucr6a5tt93Kah4M1Nd532r15Sw4PL7geLk1
12494	payment	1726	1726	1874	1	1	3728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RcCN6SjsD5jeGq3z3uTrG7uKhF7eTt2d1DbWm8sa6jRSbRZt
12497	payment	1726	1726	1874	1	1	3731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkumiiUS3qgkQhn8ZLCmNniCUJR7N3jgfwpRbMiQmnroFpTqpf
12502	payment	1726	1726	1874	1	1	3735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bXXSzJDcN3rTstZ5btGgJFudcy35huB46YxnVpiyTVthqRGK
12503	payment	1726	1726	1874	1	1	3736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYuiZrNnkg13ZbnSiCbfvXiSJ2X31CWmiVyTAEMsidcVaXaRA
12509	payment	1726	1726	1874	1	1	3742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL14exM8Hch2887WsSBFFpn6x2fEN8eu2hGxxhpENFaPibvSx
12510	payment	1726	1726	1874	1	1	3743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEjhKKNVFPGEyPHhCaZEdyrshdwVD68PySacam9NydnNSg5pF
12513	payment	1726	1726	1874	1	1	3746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHZK9hz7YpWvCux8wHFHPWjpNc9RgzMisuVZ2SLFHQt7HD4xU
12514	payment	1726	1726	1874	1	1	3747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGi4warDHyor36jTF9Zaqnt7yqpQNFpRtE4V7cHA2wjFHAhxR
12519	payment	1726	1726	1874	1	1	3752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fihxsEQ1LccatoW8csHv6zXpUBGk3dAyWz4hv7wtrruk1Vga
12520	payment	1726	1726	1874	1	1	3753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDGN1zWky6eeD97emBoZC7AvC2XRQDEqXK6HtcU711kMhu4zT
12521	payment	1726	1726	1874	1	1	3754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBb78UAkfV7b4GLBiTtWJf2jkwvBzqpAMRj31cYdU1pZru3SAx
12526	payment	1726	1726	1874	1	1	3759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHzprjw7Jyd8f14PQjK7YCRfBdWeGVPGWXzPHRbDvWPDojoQo
12527	payment	1726	1726	1874	1	1	3760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUekn6HMrFs2eRH8eLmfQDJA14PxUvMAiQNk7AXS1gh8GwaqX
12528	payment	1726	1726	1874	1	1	3761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgTw27483oyJyBuWoQKEavEL9VxUmCqMUd51imecH4zX5Y8hC
12537	payment	1726	1726	1874	1	1	3770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj1k8ZCZb2bBdyMuDATdcWWRc5XZoquxhcHPSdgCQTjZxMY9f
12541	payment	1726	1726	1874	1	1	3774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8addJbgYr7ryytV7HUkjN6QEAZuvpDWGq3d11FiFjNaNC726
12543	payment	1726	1726	1874	1	1	3776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5YmF7KPepZnq5RDyyZKWPYvmdTekM3WSWp3btHrBWZUd1Fyh
12544	payment	1726	1726	1874	1	1	3777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cty4EQS5hC9u21DMwmUMT8s9CWFqRT9LVjQEVBuRiUfJq7hm
12551	payment	1726	1726	1874	1	1	3784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe25fD6WbpznqXow9wkFKyjdtuV5MaQjHBc1SJvcBXc2kqBm5A
12558	payment	1726	1726	1874	1	1	3791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEjWJ81Lr4cc37c9FvDdpfYfocaFhsrDHvhgskVeQtn9QL5bj
12579	payment	1726	1726	1874	1	1	3811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGCMJCkqcVBfVYfXZwCMKLVzP8DA7kUkfHidEKsef2SdPFhVL
12580	payment	1726	1726	1874	1	1	3812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpidToheRWXzeJR9Z7BuNT4uhdw8wm8EUVEdxfJQS4F12jNWj
12581	payment	1726	1726	1874	1	1	3813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJcG7nGR2XLrzDLmBr9FXwKPcdbg3Qy9QLMie7JKTa7jZxEPk
12593	payment	1726	1726	1874	1	1	3820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPcdh7tPHmXdCNXSz3pzeKUDVWhB63uFY1FmrshEmTWm9bJN8
12594	payment	1726	1726	1874	1	1	3821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbZAssAcLFQXuss4UvL3rCABD8mWYnfZ7S2jrNrtL36CiX7AW
12602	payment	1726	1726	1874	1	1	3829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk6PrPzPzNRmoJR2YsYsDWGi2um249Q9yUS6ZGQuZfWBmhYrs
12605	payment	1726	1726	1874	1	1	3832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dubv4bP8xFCy98Wy1mnj5HF4zXmXnRsw8MoGMtbvPnAnJzup
12614	payment	1726	1726	1874	1	1	3841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwMgfuEs3JMesd7mL3B83YDUYdziFFq9tvygbYGopGbGrPACT
12617	payment	1726	1726	1874	1	1	3844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfUbuCiaNCEVF2rEJfE9hRHzeV1pf9N14yAWYQiCkc8s5RvaJ
12633	payment	1726	1726	1874	1	1	3856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyar86tZtmBZEHpTUjKidzvhz8wc2oikhySQkhWofRX6iYPdZ
12637	payment	1726	1726	1874	1	1	3860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzQrkrFnyGeGdxUHf1pBmywQERJUsyZNrKbLiXf1S633rqtnJ
12644	payment	1726	1726	1874	1	1	3867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5d4umRC8UeBVtZKbSrBwAM6nP9V3o4vMa99AsNvPr8zgXXxz
12645	payment	1726	1726	1874	1	1	3868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjL1HWjDL8M2mcBySU1eQoYG3CGzFeycPXmXHorM4axwGZXZdD
12650	payment	1686	1686	291	1	1	4	231401142041	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaJbtfR9J6nQFxPHdHwSytUT9ZUiCceRU7R4575FHGG1NWs9zjc
12500	payment	1726	1726	1874	1	1	3734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNMBfN4qQq5QvvKqx2gVzCNSkQRvwdUfofrtgbKrDqD8UM3en
12501	payment	1525	1525	1931	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZV3B3aswkpu2jmB56KnrtXzmwtxGyYcivmpAspuW348hsBwMu
12505	payment	1726	1726	1874	1	1	3738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiXScgTPqxYFEbWDYQkWrhmKNkaQhxSKgcRwLrU1VCiadbYQv
12508	payment	1726	1726	1874	1	1	3741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYRwKnqtuFbCrAcJHThi9oKq5y11qcY7DghPxv9YaNvhQeyEb
12511	payment	1726	1726	1874	1	1	3744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfsUd5pFZC7XpSuEUGsEUCA6ha3sPtDwejhp9XEy3CgvRxTtU
12515	payment	1726	1726	1874	1	1	3748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhf7w4CQY7AUFBYTndfREXmu9FNVZtK6YSCjtpMxoE4Xj5FFem
12516	payment	1726	1726	1874	1	1	3749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXD13JqufsdkXa8A6i3uZ3szTXgietizp1dLqoeAo7FvFswEK
12533	payment	1726	1726	1874	1	1	3766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFQUKehz6NAkqtgAVJDVicaWjecKgfPUTtjRYK6GpqX5K64SG
12534	payment	1726	1726	1874	1	1	3767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqye8jXPTm1zC6896odeKVmqVNZDmVNsGgj4uRMAZEdyV43ibZ
12535	payment	1726	1726	1874	1	1	3768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdX5UnkLy1f92hJsLh1V6WDQbxSvKW7Cvj6gUVYApQDQ7h7Yfg
12549	payment	1726	1726	1874	1	1	3782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5FiCybeyxkZ2QxUhoCLYyXDWE9W1aRhEE6RDDhjx5mHuWfTV
12550	payment	1726	1726	1874	1	1	3783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxcKnECCRN2AzDhnCweu4sK3hLbnJ6FQQHbjfJ1ELRwzqHMJZ
12561	payment	1726	1726	1874	1	1	3794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNYDYA1FVx4iYJ7BDwDqLyb1ZdUATfGBt7ekKYeKFVdMqUfxa
12565	payment	1726	1726	1874	1	1	3798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqNAHM239tPvPBuU28F1cpx5XA1yda6PvU6p7KE1pZbbhxPZb
12566	payment	1726	1726	1874	1	1	3799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHH5tatBo1cULHuP5H4ZYJYZ7TRoS3ZT6afoxQbaEJMi8uaUg
12573	payment	1726	1726	1874	1	1	3805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZrLTmX5KqovEwoxhjAFdySB1CDajfWXNfAQJSNbgW53cmN5k
12577	payment	1726	1726	1874	1	1	3809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVwknBdjEAdUf7D1CoBAeE9tLfb1aHeKkfRSuCezX4QwmoAmV
12597	payment	1726	1726	1874	1	1	3824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFxppi7Yz2DcWTH14RbfeHREXjxohyxtif4KTHAXdXuUnAoB2
12598	payment	1726	1726	1874	1	1	3825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjevVjxxfYe8SqQhjcw3WTBhvFLUUH6Dw1PxdFDHdnqZbEQ98
12601	payment	1726	1726	1874	1	1	3828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEMAn9wLjJTYmL2ZBU2gSrekvhVbWKeEmfwV1Sok5oMWtvsPU
12606	payment	1726	1726	1874	1	1	3833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ22GVCdvDdtAMkF54yfonspqtKPL5ChbXDfykoa4FesN1WaCq
12608	payment	1726	1726	1874	1	1	3835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCuqo52dhaJBT1hr81eULGY9nPLbkkXbfw6618hEh22JwBZck
12609	payment	1726	1726	1874	1	1	3836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtuq159YsB5UkvUTHoUvReTSohuu1jHLezzQi8phSZTcN6FHf
12611	payment	1726	1726	1874	1	1	3838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfuLm5yJmC68GgP1LYqovtxZgZfL966t5K89QkZsfzYmaoY5k
12612	payment	1726	1726	1874	1	1	3839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL4UZq4oTCm9u5vSJdvTUCAteNdNoyjXWp1hnoZEKLXF8PVP6
12613	payment	1726	1726	1874	1	1	3840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qri2RxjQwfFBeyVeRG78VkJYCjeFNGGmhrMfHqdemhGRMw3Y
12616	payment	1726	1726	1874	1	1	3843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDz6U32HkwWrVNJBoGz4NgdV7CaEkS7qCqzPHciJ38JQPee3F
12618	payment	641	641	1090	1	1	4	490222800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1ttg1q3C4qAZ1zEuTBuWnoVA8XExBd8qxQBPnhYZMBiLEkE3
12619	payment	641	641	970	1	1	5	273531600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9VimXanDSWxsRT8dxsxQyETfog7fEdqqLoLFwRrUQYpbWZch
12620	payment	641	641	1336	1	1	6	921553200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2b23GADUMk7wxGQ2ScKXmtRF2EkZsaMvBJjsbJhUZoG614wnR
12621	payment	641	641	1210	1	1	7	330782400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjqtxMvxUkzsUknw46rzqY9h1wRRLSdkb7vjHMsxTr1DhSfST
12629	payment	1726	1726	1874	1	1	3852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNo1HQ6bAEvqPcbveEqpkGKCV5CFoEzAjWSASrbMRhYCBQf8c
12640	payment	1726	1726	1874	1	1	3863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dWGwYtLAv9GZvdDB4Dakqjt1mmP84oaZZDFPsrZrvNNyB8rs
12641	payment	1726	1726	1874	1	1	3864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBy5UZq4uQA4yWv9wtVQUAKc58wrQE5Fde7s5y7WJ1dT58GJ8
12531	payment	1726	1726	1874	1	1	3764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCBu2BpKUp86maW8Rdu8h4n7UjSRm13vLbP4dNzwcnYxerr2c
12532	payment	1726	1726	1874	1	1	3765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQvc9MLzGFdgpGn9EvvKJMaF1UJrTsqvGHxx69DxtBy3jZVGC
12536	payment	1726	1726	1874	1	1	3769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYya4LSgmF4Z2bUjY5AFd5Tp6u8h4TYhsMkiUWArvJmtgtQjHnU
12538	payment	1726	1726	1874	1	1	3771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2NHkNXcfcE2VwCsfbNTeB3dR7faTJxBJfhAesos8iBqwbRzu
12539	payment	1726	1726	1874	1	1	3772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWex5YwaAf5cR4KqT9tkyhgRF2h6CsnPERRqgBTjLRxDokPWx4
12540	payment	1726	1726	1874	1	1	3773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptgEQ5QrQsy7omtEjPujuvFjmxHePY3CqbZY9bdNobyFY1Qw4
12545	payment	1726	1726	1874	1	1	3778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjzyibh99MGzaR1VqpTFxVaLetkD2PKn2jPuT1KHpN5B3rJ5e
12546	payment	1726	1726	1874	1	1	3779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBSCGnVP5ynGcFD54bNma6uYTZGK2YQCqg53hw3Y3mDGhKJPv
12547	payment	1726	1726	1874	1	1	3780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJDW7G9HmhaLvzxK9dC8qV9bSTUH9BduevQgZqrSkiEMgberv
12548	payment	1726	1726	1874	1	1	3781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjExBdzTgy6JxoDgHSeSWhGSrCuxsioubCAgjhZU25oFxMRRE
12552	payment	1726	1726	1874	1	1	3785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcaGnJXu2yN7dVBG8Y3jXmTdf3A8rskKfqY6QirCyxfZVrMtE
12554	payment	1726	1726	1874	1	1	3787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqLoBNNUJUak2Nn7aXpYBawWEb4d4P6FC66jqzfutxiLHjpQG
12555	payment	1726	1726	1874	1	1	3788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUi5XnjT7nd5dHgmo3bCZSE6oMeFYL1y1yfb5WhBTeEsqKQ8Y
12556	payment	1726	1726	1874	1	1	3789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafjprBTh6ckGj9csknW9XHnJTfZji5mPwREHCWFpu3Tt1LPxD
12557	payment	1726	1726	1874	1	1	3790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLoncjMHqMhjGF9iMYa9Mp8KRTfQUtnPfxCwMQWNJxkkXcCcU
12559	payment	1726	1726	1874	1	1	3792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQKQa8dRfzrXdXab6PEBw2anZfTsyVoBCgyWn5C2XAprFQHPd
12560	payment	1726	1726	1874	1	1	3793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT75KBHph6mRNNBZq6WDEcfL2PrfQ4AB994NwRmmFjqn7drZTX
12562	payment	1726	1726	1874	1	1	3795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytGLCJe5Qy2eq1KcHrvd5P2p79Zt5qt93rBqXi7tP1UNqs2VD
12563	payment	1726	1726	1874	1	1	3796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eebA6tsP3hFaGGqShTbHiK8eF3kaWhpadJWVzowoFm4Zaszk
12564	payment	1726	1726	1874	1	1	3797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD42mYzXi12BSBds3orh1tAH4CxY3twK4Ybq8N8GBBqsGn5ZEe
12567	payment	1726	1726	1874	1	1	3800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWayUrQ4vjF319qHVLa3hm3yJHCi49KjhMHYyBr3PgDDxLiG1
12568	payment	411	411	2053	1	1	5	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYy2AMr4U9233uqitiy4aqM7vovm6rMEzbMidw1rzWTyiLgCNs
12569	payment	1726	1726	1874	1	1	3801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbJZLnnzbFF5w1rtH9xS1wsXtpXqzND3kz77aiKFx5apFXm6K
12570	payment	1726	1726	1874	1	1	3802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqdas1rFH2BoSrSYkGDxxZxQZTKAfUJFUvNAh8miVaUvGu83P
12571	payment	1726	1726	1874	1	1	3803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMBbCTe5w8NCnREgQBv3ZMmWdLugpEecJ9ZBhrgPAYecjqnA3
12572	payment	1726	1726	1874	1	1	3804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1zNVNM9LLnTPmyxB1ph88zR2tkzGGQ8uh8MvkyAN1VpJp6NE
12574	payment	1726	1726	1874	1	1	3806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKznd9Ei5QgnSPB8wm3xUdgQ3T5imyzDYKyURZxFk7mC4f3aPb
12576	payment	1726	1726	1874	1	1	3808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6ncfoJqBMuruW518mruFe5kgaXRhGQWppnjFCsJfv6qqtn4d
12582	payment	1726	1726	1874	1	1	3814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZje5U89A5GcMdGLXdsUmf6eqtJpii2pp6iqLqvu81KYa2D7VAB
12583	payment	1726	1726	1874	1	1	3815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgHhhpL3LwDzdQTB9nG4rBGVXFPWkVREcovbXFqD6AsTTjJrU
12584	delegation	2042	2042	411	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBUyj7Y1kXPQva1wx2hNwdAmHdMt5HF3pfrVD7C9o86HqYMWz
12585	payment	1717	1717	920	1	1	0	2134505012457	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpaJfN9tBpG2BhYfwzf3QY7h6x1sD64SsHt1M4WrZsqkgSkj83Kt
12586	payment	1717	1717	1040	1	1	1	3825014693893	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpYQjXwGZEJ1mmQpzUHaPNq6yDxnMkcnL46NUeo5prvhiUZkUPan
12587	payment	1717	1717	1160	1	1	2	2580813632763	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpZd1eQFBxgegsabHnfsJMPePv6Fkj4HGP2kFFbEFRrnqgKMAmrB
12588	payment	1717	1717	1286	1	1	3	7191666660864	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpZ7BrtNY2Hcvfcq5qqHGbuMXMvNfpDuKiPRgwKtoTEXZaW5M2dJ
12589	payment	1726	1726	1874	1	1	3816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzmwjfURoGHMKbvF3SYYtPmLo7v2tYyjKbS1MjMh9R3C4T3et
12590	payment	1726	1726	1874	1	1	3817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHMjJuvjW6PnKYhwKEQ3NLWi3dy7g5GSZGDvzrxB2NJbJy7wkA
12591	payment	1726	1726	1874	1	1	3818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf346eHDtBSS6wcxwayTRSYRSekATAn9fQhUEmyhyvv21d71z
12592	payment	1726	1726	1874	1	1	3819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESuJWn9VjDGjt9Sha6rkWPM5Rxq91aSxmy86ePe1QVJurkQfs
12596	payment	1726	1726	1874	1	1	3823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYjafy8XC5vb34ByhifACX27Ubi4JNTRvAQrpiYu9JqobPCuA
12627	payment	1726	1726	1874	1	1	3850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrCXAY8snkJedPNE6LDwX7GYUkUXNvkBN7gs2x58bFhN2vJPk
12638	payment	1726	1726	1874	1	1	3861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1Zh6ZHSuDX7SBwZ8Ex6eijzi4wdtiPNphaJL9DZ52ahWQNvj
12642	payment	1726	1726	1874	1	1	3865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zuM4fxnryXWN2u6Ztzf1gFZpYQgyanm92VzN9Ah88kDcJ4bw
12643	payment	1726	1726	1874	1	1	3866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6hh7kuttwjmazDorvF47BXMZLTX6LdaCZqWCfP27daiSsBp7
12600	payment	1726	1726	1874	1	1	3827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxBybND5nRXS5yCoiT5mh8eTJssWx51T57ERSQ4sJzsSnGPap
12603	payment	1726	1726	1874	1	1	3830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexXPXiVmoQSQKBHvfcqyZZSnDRK3Q5Gxp7dei8ry6Q7ThXYXE
12604	payment	1726	1726	1874	1	1	3831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HYddd855yLJpFVHxTGCuw6sq4WfFCAKLwu44UZbeTvnnjhDZ
12607	payment	1726	1726	1874	1	1	3834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkB2pQJ3sgtor34B5yNbuZTjpNm7yuV4r7hoijJop5rLoxevyd
12610	payment	1726	1726	1874	1	1	3837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQW1MLxLoEtpjBRRew2wLJQyqTfQ7F4bc9UFFHDi5TWab5qcG
12615	payment	1726	1726	1874	1	1	3842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT4Nh1Gs4UdkLH4DCFPR4vnRUzgVo6jTfhpedfRtKEWu8Zs1r
12622	payment	1726	1726	1874	1	1	3845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2FdpFXAzBPMveVdiWBhvQYQPzGxZRNjcL5nqu6A73XUxLipG
12623	payment	1726	1726	1874	1	1	3846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97CTCL2eHgBq8k1TiUQWnFUGXc7yZER2rV5g2cRaWHedxbuCU
12624	payment	1726	1726	1874	1	1	3847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfyxmfPgg6K4GyiMzpX6wUCRJkwLi9Sas5RQqvNr4FDXAo2Rzo
12625	payment	1726	1726	1874	1	1	3848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrKAJC1q7oVRmkXHrem1LTkQFSSMZGW1RVLRpyQyLHPwiCCAT
12626	payment	1726	1726	2054	1	1	3849	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoqiBM7iqqZ8LR3FaWEQePJu4mydJYkRttia2t6tpPASN5cHwf
12628	payment	1726	1726	1874	1	1	3851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3YoBqwRLXRN318zPd2mi7aseXsgWsNp4xrrHbmR8DvqJgN3T
12630	payment	1726	1726	1874	1	1	3853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGurVdWa6aq3Cxs9NJTDgY8wWUnBhvMVmb3sjHoHWmUWJiLeU
12631	payment	1726	1726	1874	1	1	3854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUpZTBoJyLoaNYuZSkTxq79YJavW2EsSpN4yq8AH9ZKLy1pPV
12632	payment	1726	1726	1874	1	1	3855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVovQjSG7AQopYc44ZTLzdxfXLjdVE4KthwjRzXUMZfXgap9VP
12634	payment	1726	1726	1874	1	1	3857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVfrmdEiLsfyJ9BphtRTRaFjtWW8FepVLEG1yEq3Qf35PiGBU
12635	payment	1726	1726	1874	1	1	3858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHHFGDYSzPdvwS6oBRbrQQbvUNSfZwb1xnuqW5LRodNo1RPxp
12636	payment	1726	1726	1874	1	1	3859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGhvCyYKs1qjtifp3faoFFkvMa1fkmc6e8SkMjv3C6jWEans2
12639	payment	1726	1726	1874	1	1	3862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKLo82XRFcavGY1c4Tvif1wTWDjnEGDGCxww1RqTWhUtVSafB
12646	payment	1686	1686	1771	1	1	2	234661794490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZVSGw4cSrZEryE2C3C2TZF84Kkd7cQL1tGWJi3yXzaiq85aRvR
12647	payment	1686	1686	195	1	1	3	231401142041	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYrPLwAX85ifXUmcG2VTep4JHWz8HTRAEYp3pyqq2W12hSqdiTU
12648	payment	1726	1726	1874	1	1	3869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchQ4kizcgGtS88QHCgYKTEFbEGSA3QiVQtTDfM9b2i5wV9iEb
12649	payment	1726	1726	1874	1	1	3870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWWAoyNAXy8R4HSucr2VDTMJepGkzh2Up24U7xczeFbRaR42G
12651	payment	1726	1726	1874	1	1	3871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKqrQjtBiPTW1ctedCHPF7kzNvQrWzm4Vdzd1HHZwmzd7rqqt
12652	payment	1686	1686	1023	1	1	5	1761527108560	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZpnsFvEX3MNxCEAAFuwiFq1RYsk3nt27btEk2PdUMxaJqfM4jh
12653	payment	1726	1726	1874	1	1	3872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSHcx1qnnT1meSQ3awDzQhn1ChpRYka9k1QRp2MTVf7XsFK24
12654	payment	1686	1686	1143	1	1	6	3156641485780	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYXchU3A2yRFgZ1wi6i9v28ctzxxvrGQmfUiyVZSmWAP3qgNVxy
12655	payment	1686	1686	1263	1	1	7	2129848910979	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaJPSWg9Urdpp9YQizu9p1WaYedAzCanjRcWBBppnzRRtfJbKdu
12656	payment	1726	1726	1874	1	1	3873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMtvkyNxQLcrtDLVqgm4LNfJtWdNKYabNuPt58E6Y9CNsZKmx
12657	payment	1686	1686	1389	1	1	8	5935013366060	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYXfDwPPvFqbAmsPP4iPKS9fjjcNY7qATBga3HANAcnMLNX1ZdL
12658	payment	1726	1726	1874	1	1	3874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTra6qVnLQSbdn421GvUkdHQ3cbBija7L47xrJwfZtKRhZfmg
12659	payment	1726	1726	1874	1	1	3875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfH6LsPSPc8cHgLRStSf5J2SNTRDdzjhdvpLvkf6MVTbarj3J
12660	delegation	1737	1737	1646	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cTjxHvc4R9RhmkaKnK91ypYPCP9aHUeuwM7ubGyNgWv5S7Ti
12661	payment	1726	1726	1874	1	1	3876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcRNe5vVeTXZSGHBLiVAxAPmwPAAafnehjbAxXqUQpQ6K1LtN
12662	payment	1726	1726	1874	1	1	3877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kS1irm6xZvz2zwwwYQK5HsCVjo9SM2twfmg8WDs8oRPyKE6r
12663	payment	1726	1726	1874	1	1	3878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJZb7Bb5nDGnJX3i5FCvqGAUk18dAiKdXDGpcHwjrht54ZN45
12664	payment	1726	1726	1874	1	1	3879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLpA7CzXzGKcqTmM1xLY1Jh7tsdQonvi7Dj6VjfdXmR7vmBT6
12665	payment	1726	1726	1874	1	1	3880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RFhyyGbz2giFEBfSjdc3tKYrYYKnshAfpTtSdg58zQ9AWoPP
12666	payment	1726	1726	1874	1	1	3881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL28K3srguLVpBM9JxAYTa3LRkK2G7BiTiy1PxteiyHeDqSoR
12667	payment	1726	1726	1874	1	1	3882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JeSGapbkpvidACB7akLKC4NbGP3GBhwxwh5J23AM92zynkU3
12668	payment	1726	1726	1874	1	1	3883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsh1F7dX8iFpxyj3nY1ibKtQNz2hziBpq5JgeEej4B3geqEmMy
12669	payment	1726	1726	1874	1	1	3884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicrrhKf5UNbhHLQeaiFLXktfnm5yEcHHnug4LdqjjYar6JaeY
12670	payment	1726	1726	1874	1	1	3885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XrtUuurFzjaPN4P5dxpUvEkVnaELeVyp6YThzWzuCqjSbhT7
12671	payment	1726	1726	1874	1	1	3886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnN2m71rBYXzda6aydHmMiT9GZzExbmMiNL5xKtNh81NWWw1Tx
12672	payment	1726	1726	1874	1	1	3887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsk6g14qETizPHWzW5NryNn4GAS5tA3RhK23HeeCmXhGK97yK8
12673	payment	1726	1726	1874	1	1	3888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6T8K5rRb7tGAcypcGq5m3Rrokwm1ubUxe6zDj5cBDiZSrEdq
12674	payment	1726	1726	1874	1	1	3889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoyEVe1qwoFYPii6QWf2xn6fwQoZnoQVJePfaciVdmNa7Utdy
12675	payment	1726	1726	1874	1	1	3890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYF4rfsTx7wafjx4cBKP8ZiQ6Srx4PfMh1siJZYpVmkhvQCDu
12676	payment	1726	1726	1874	1	1	3891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLqB9mD8hB8KGhGGiKtRxw72tVKqKDFZ3hRRiK1MHtcy9qMgb
12677	payment	1726	1726	1874	1	1	3892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6E4Arjh8sFfSueSduWo7BLKQgbZccvk3C3bv9Ld6YZVGS1PTk
12678	payment	1726	1726	1874	1	1	3893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6XGxhurpBgsA8vQwhs19Tzwkh94xRSBTQRZ2m5R7jPViCZNU
12679	payment	1726	1726	1874	1	1	3894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQCuoySsWxTvq2p7LL5a8YTaSKHwrRFBqLUvgXCDc3Jbw89FR
12680	payment	1726	1726	1874	1	1	3895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzuu2avJtykN2Mf8huitXAGYj1nwUrWnin4xk1793xt22C2ER
12681	payment	1726	1726	1874	1	1	3896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk73jMKPA2mQLLpoBbQUbGwFhu1shB3iu17YFmUnBpZJhpkcs
12682	payment	1726	1726	1874	1	1	3897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oiwGTXnrr2kJaxNbPbh5nb1zvMUYPkbfHK1CXvRQWDgwfZrE
12683	payment	1726	1726	1874	1	1	3898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXB7BbTuszBuSuJwFKFuqEE9JMzz4Y17QFPsVCak9pNJgA6KM
12684	payment	1726	1726	1874	1	1	3899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSaPcj3aDfYxN37DauevMuDsGBU3r9bTJfx7Fm9J76qU2b5XTe
12685	payment	1726	1726	1874	1	1	3900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUuZ3DNbcb4UVTRtPnuZXZ88BKEtDdKSggQ8dkio1JbhsKsYK
12686	payment	1726	1726	1874	1	1	3901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMR99VRJuNNNQH4sDjuKaSZSAYsTfsviWvQea2Vw7XkhoCW2T
12687	payment	1726	1726	1874	1	1	3902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHqC2p1bZB5p14tYvtmoKjxadxQB9tqmZ8skbrwNxwQZQA7jD
12688	payment	1726	1726	1874	1	1	3903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKyg984z3EVndZgHVLn9P1wty9JnhwqP4u3RqJ1hvBhp5TUxRL
12689	payment	1726	1726	1874	1	1	3904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKsGq78eVXvgsyh7e7LKGrKafMjtnx8NDxQXjL62qVu8oFAJR
12690	payment	1726	1726	1874	1	1	3905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUeNnmQACxS1dYykTySoituao63ruTbQR3jSzonkBzHFZkS5d
12693	payment	1634	1634	13	1	1	0	21715676666	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpYZxZ29NMVZpRg9XJ7uAqcbSCWxNxz6Nu2kTUkt5hqWpmAKsWFp
12694	payment	1634	1634	19	1	1	1	10860172844	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	Ckpa3DtkApAJK9QBUQebWKb5WUBEbiReBBFTgdMVt5k7PGV3VXpSF
12695	payment	1634	1634	203	1	1	2	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpaJKXdcL7KFWb5Xyrach62EomhJ2svzwx5BR5NT8fizVNc6jaQ3
12696	payment	1634	1634	241	1	1	3	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpaJw6CmXXV1LcmjvsPFNYqjZ3GEzWRurTHCWgr1gF7YxLuvNDnt
12697	payment	1634	1634	313	1	1	4	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZJJPVfVoofgBJPPSg11dgEksaGfiHc5rVCAV4Y1RBZY8fHLnUu
12698	payment	1634	1634	965	1	1	5	2286444226326	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZGsjGNfc6B1Re1Lj5951EiwXCksrqXHKCbs8J3DVBAeGFcyjyq
12699	payment	1634	1634	1085	1	1	6	4097288463320	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	Ckpa6mPNEYKzzV9UqYT2xnRZmbzwvYdNZj8f7kDVCnvsQ9zXRz2LK
12700	payment	1634	1634	1205	1	1	7	2764522170436	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpYw15Sv7GxpZZZB8cpj3U9xdNptPZeaXtkkDb9QG9iR6BJ5WQfa
12701	payment	1634	1634	1331	1	1	8	7703586835568	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZtS6rDjGjpgJNMdMNhPjGPkPWgBgxSS2KP8hdQ2V5huMnmWdfe
12702	payment	1726	1726	1874	1	1	3908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvmnqKh9QgeVBuMhT6sKtYoEk521reRZt2T8rARqU3PpLKbYt
12703	payment	1726	1726	1874	1	1	3909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1gT6t8qWJtAKajgYnSrgJSLMiLK6ZsKkKXLvFhF7efVxhV3V
12718	payment	1726	1726	1874	1	1	3924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh98kPPRKbGF3Q3Bhh14TegZgECWAZ9rAS7LRcGJjYzP4pFHe
12723	payment	1726	1726	1874	1	1	3929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhjZHreHpUozRzKbFxkTXssg85RJrf3CaVWC8ysPvbGr6GtgU
12724	payment	1726	1726	1874	1	1	3930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvqyBJuu9Dwpn6dqFqjm51XTE8BmLPYMj9kiUmx2pqHEc6BnC
12730	payment	1726	1726	1874	1	1	3936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuWa51eZoG7VknxbdN9eQMsYZD7QkoKUxeRGX8EzVtkhsMq8C
12734	payment	1726	1726	1874	1	1	3940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCzSRFm4jwjk1xPuiQ3518eA281ugvWn43AAxDairKiJQwTuc
12738	payment	1726	1726	1874	1	1	3943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkReaCksnJL6GWm6YqAcf7wbkt8YZ8tucsqHB1iTda8JSEkfwp
12739	payment	1726	1726	1874	1	1	3944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwBZv9MaScH9GwwCpGuKYp7Jn7FupyPMn8SXAroU4DuJEoMQ
12749	payment	1726	1726	1874	1	1	3952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzm1xW5Fq4NwRiuB4bAXhQeZ1g4uNazVpJRPPVzVnKXpn5sSD
12761	payment	1726	1726	1874	1	1	3963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWzdiCsQMq2LdkGsYoDvDHmmDPnUYjXnyzLFfggkReyKkJfXt
12764	payment	1726	1726	1874	1	1	3966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtKD515KoK3nCLY53aiFJBLavgoMJPgqBNpyPpYpjLCKEDrmF
12765	payment	1726	1726	1874	1	1	3967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GgBpfmydaw3b7yftUANejuVC7xxPiE6t6aDzkyj97DchUiyS
12769	payment	1726	1726	1874	1	1	3971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQbJTwzGWEQExtEXYePrFj4Cq3NyBv4oxfbj1FQde7qYUSGZz
12777	payment	1726	1726	1874	1	1	3979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqCW6uEB1SHwT4VSr1RPY9A1djRtKG1Somky5h2JbHCMZtEF7
12780	payment	1726	1726	1874	1	1	3982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjiu2VvDvkDbkpBMG6aLN1cUhn66rGJhHCPBJ8J7Dg9tNqqsy
12782	payment	1726	1726	1874	1	1	3984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UuY8zEv6pE3GZ6WD4YuerZE2xsdyWhGCqjQcF5g8RZ6kcYNS
12784	payment	1726	1726	1874	1	1	3986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5WALGVdSxhvzzhVWUy5cdmXXrMEsxLSomb15ahk4PWCDGx7m
12785	payment	1726	1726	1874	1	1	3987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqPs6814ntq6ipyGL39Cx8cWo8jnbLZGfHgrTBWXDkszBX3pR
12790	payment	1726	1726	1874	1	1	3992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxydyxUyKwqW1Eg4CQPBPENHumGfULh8Sr4BqDerY3mcnRjf17
12794	payment	1726	1726	1874	1	1	3996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaUBi9vNYv7GFd9HpyW7WaKqUgFVEcfbr6ZZV2knfZJgDgqyR
12796	payment	1726	1726	1874	1	1	3998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EE5r1ryhJewwA41QRt5m6bbWETAy1WD284kEpHdzE75dacNa
12802	payment	1726	1726	1874	1	1	4004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC49VtdzHZe9haaxLLngSUfeFzzHW4onS3ri1j7pb3TsusTmY
12803	payment	1726	1726	1874	1	1	4005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6x7JgM2ibXaioZ1HpCzmfL5ycHJuCDjVqQHfzuxb4e5GBwzFJ
12804	payment	1726	1726	1874	1	1	4006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxUURAYGuCnFNbr63dFnEEqe6AVgCDKsdfvTx5YHrjYMDA9Rp
12819	payment	1573	1573	1072	1	1	1	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFCg5xR5ugaxrxSvguPDZs7rWCk4yuWGranq9FU5d7yHKAkyu
12820	payment	1573	1573	1192	1	1	2	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddKgY6yKcQYSyztrr5mS2marhBm3gtuPZzJNah1eQFhteRE9r
12691	payment	1726	1726	1874	1	1	3906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBk2xJm9UyZgZoZJm5uAWWq1GftefZzf3CsnFD5EafyvTW5UM
12692	payment	1726	1726	1874	1	1	3907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndSao9pFN2BWx8G3GZdjpMN7iPMQVhF83MyRfnMXCYsSsD6g1
12704	payment	1726	1726	1874	1	1	3910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLk11RZAoUqXfFT9kNgSYTJNQtWYbaLgRetj4c34U7XSg1YU2y
12725	payment	1726	1726	1874	1	1	3931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJ3GejafNK3dBjSPbBVrT73gPRKMgsumxRnkZcgKyPmRMNMZV
12726	payment	1726	1726	1874	1	1	3932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpdDqETMfJvqesX3dXhdxGMVdQPPE7QrnbJ4csFkuCr8RBikp
12731	payment	1726	1726	1874	1	1	3937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhgR41PEEM6m4nd5Dk5ws587NZWV79Wz48bHpjGJQaWzQYFXE
12732	payment	1726	1726	1874	1	1	3938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyorFAmcobKfZfcwLjMAAQq5XpoSMJCGW86vzmae89ayaAMSv
12740	payment	1555	1555	1101	1	1	1	3103678489721	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZNEPeNknPBoUZ4C3ivWLtFcyjiLK7UCUG56sPMnN6nLDgttewE
12741	payment	1726	1726	1874	1	1	3945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAgocQ952SyFQgNDwEYWnHqHYuvetqBnmhfvXqbZvufywKhQD
12745	payment	1555	1555	1221	1	1	2	2094113722186	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZHrbJQsnJL9CNkq9GDiy5UzRGBuEGMcXRTqTtG664GBQYuibPv
12746	payment	1726	1726	1874	1	1	3949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1WFhRLUt5YTynkMTokjvYQVYHWbCXzHQtucrHGfTpQRXDtdG
12747	payment	1726	1726	1874	1	1	3950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Pa2nUuX3qWZf5TMfMmuGRoMsEK4o1fpTda18FfraZe44xEx
12750	payment	1555	1555	1347	1	1	3	5835434085079	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpYhbmuGA4bto89x9BjvwgFkiSZagVQsr7Q4gNE2t9gAB4Bj2JQe
12756	payment	1726	1726	1874	1	1	3958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4i3YqPy8zgUFGevHWoYWR5jFUjKKkdyAoXSxBBxzD2j7x91u
12759	payment	1726	1726	1874	1	1	3961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdHvuvfN48UU5p34L9fet2yHR8kBmAVSZL4AuXcsRgstG6KT3
12762	payment	1726	1726	1874	1	1	3964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVjy2a6Dz1MaxxgVPfPMHr3eZuFWWJ72zx6dMBheG8Nk58SKY
12763	payment	1726	1726	1874	1	1	3965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpMK9W1VHjfZNgPgyYA7th3qfUXrA98RRB3bCLmEAZXrxefpe
12770	payment	1726	1726	1874	1	1	3972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkmcHfE64UvBT89xoGi39WoJhpbzKobMVJCsdNZfLG7Yssrf7
12771	payment	1726	1726	1874	1	1	3973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnmUFiNpCnPFqdhzBCiYV63YBUnGrtkB94GrMRP2qc641znrB
12772	payment	1726	1726	1874	1	1	3974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpB2whFaTtUsGkfaoPVDUhjNLRXnJFYnrn7T5CbtJ6GFizEHR
12775	payment	1726	1726	1874	1	1	3977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4NNAd2qoK7huwAcC4HWMwo2CkbFBwhGqu4nc7PxMidYqWTHP
12783	payment	1726	1726	1874	1	1	3985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYhCGpgoZRvVkvFYB6po9zyC39643W5UqEqL1nvfL2z9dS9bx
12787	payment	1726	1726	1874	1	1	3989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fbGDitffU5YjtNnUh4bE1LDnrV9eWP12BAnP7iy4K55j2FBT
12788	payment	1726	1726	1874	1	1	3990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDE4XXBqfZr1u1E3G1b6vXCzpmSTXrNNbQAFeE1fMJDinCb1VC
12791	payment	1726	1726	1874	1	1	3993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSw6MJjQQKKNDH8GrHfYkDamEX3y3HvQ75axye9TmWE6StaaA
12795	payment	1726	1726	1874	1	1	3997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMAKR3bBeNEK8FhmqhJNBmEfV3K2Fn7hRvLF15pnJNYUhc3hF
12797	payment	1726	1726	1874	1	1	3999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerKLpFLMfC2SiVft7ZikqEqKJ9vgbncn8RUUf9a3kMV9Ren8k
12798	payment	1726	1726	1874	1	1	4000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumHwQQMAbYmUG6bvX9MpUw7KeQsdfW2xxrUf8iyZtecHGqSC8
12799	payment	1726	1726	1874	1	1	4001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBsEvNW5jw4i64q1dxtp2XhjgqSLBV9Y4PfVF5M7vhmLdabsP
12800	payment	1726	1726	1874	1	1	4002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ttB1JZf5Lro447ziJQ5qawLuisFSk2K5rtbmyss1tTQugkQw
12815	payment	1726	1726	1874	1	1	4013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGKfVyXT7RKCa2mKFt1RLQi9cQAdE5rhRTAdiEqPnVsBUTzzk
12816	payment	1726	1726	1874	1	1	4014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS78NdWBtbfBaFiWGYBL3FPRe8AmXvYEeqUNZ7kEu2vSYd8Jh
12822	payment	1726	1726	1874	1	1	4016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKnJt1SsezeRUeKUvJtyu6MPFVcz2DaW2Eo2WjPqfnQn8aFPp
12823	payment	1726	1726	1874	1	1	4017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKY56KVEsV3kjjdwqW5L1ktWCds33DiRbvTzMyoT8wN2Xzfa8
12824	payment	1726	1726	1874	1	1	4018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJmc8KddX26X19R7Z6Q7xDVa52sBK6F8Hn9VJjLygHBE88wQi
12826	payment	1726	1726	1874	1	1	4020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uKfaPF1FRZxXkYKG5YEs4xwGpaBiWt3sMTrxjhyJjSDkfKok
12827	payment	1726	1726	1874	1	1	4021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURTL2hLogbkKfzXeBC3DUubimhvVR9MkfCLsdpipeX7n6PVZk
12828	payment	1726	1726	1874	1	1	4022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAigZoKrCUz7oWQFdj6DwYtnRYJaqdNh6KCJQiU6en3fKGzGJ
12705	payment	1726	1726	1874	1	1	3911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAcbqYj9TnYuBJgUmqDyHL8oSByT4MhoTr9vBR1va4ADVyFQE
12706	payment	1726	1726	1874	1	1	3912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7MY8tue6XSodzY6xCpFQt1QbPwgEjTebt1ugbNKLGZYe7zEt
12719	payment	1726	1726	2056	1	1	3925	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbb9MmfgKjPwkk3rCpSSmnDyhzsSCZn8YyBgCRKqezk3vvW4fs
12720	payment	1726	1726	1874	1	1	3926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkd46NyjAaSTTtNEKAU3tq5eEWNDSSwvcwh5Lmi2PEsVKXVSm
12727	payment	1726	1726	1874	1	1	3933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZu8o9zvnfW593bctFG3shT4jLRGrDp77qXmVpyGL7BrdNR9z
12733	payment	1726	1726	1874	1	1	3939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrT4d1r38TByPtqsMnbtutx7VA6aek74MBtxtTsbDw8yWxpzU
12742	payment	1726	1726	1874	1	1	3946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmfkaKpXQ3pwyAX4yebbW6iV5dUgXi3ebcGu5Vprmpdw2zUZV
12743	payment	1726	1726	1874	1	1	3947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZCSFzs6SnUYq5LJzt4958L5dvREbPpEkezb51CjWix743M3A
12744	payment	1726	1726	1874	1	1	3948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoRpBaYx5qo5AQWt5YeVdRMABYZC297yAtmxL6eD5ASLtjrk9
12748	payment	1726	1726	1874	1	1	3951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdodpiKKpouXpjv5XmBN5nQ3LXVmCy456Rfo8DhkQY5VFAejXU
12757	payment	1726	1726	1874	1	1	3959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKy9mFuLXGMQJPigSHzBXK9bDzvbPWWCZetmoZTNXcoZaDY3nB
12758	payment	1726	1726	1874	1	1	3960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTxEJrac43mKDwE9umhf4kjHkeY1HAsXuBH4Fctsz44RDYUcA
12766	payment	1726	1726	1874	1	1	3968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Dz7zrBTdVsK14sPNi7LRPKYDY1VqEoj8V95StUgnRUHWMaBM
12773	payment	1726	1726	1874	1	1	3975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjr3TjtdLQsV7jf6mqLMmZmmQQJNbMqRSooxeaYemVdesYSG2T
12774	payment	1726	1726	1874	1	1	3976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzqoPAo7ZF3czKfYusa1BvFPsYKGtLg2DCAXKBA5NHcbuD9dN
12776	payment	1726	1726	1874	1	1	3978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfWrq4Yfm5zFKrTDyZjt4heVAYiKNZNjA8AbzGuJtY22FBAxM
12778	payment	1726	1726	1874	1	1	3980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnkHGgJQTa3LsND7y3QtmdKZ4kPCNNh6NmqhTzPTt3hhyLa6Y
12781	payment	1726	1726	1874	1	1	3983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJcMK3e25d3RJvahAc8uBuctzHhxJ2ZzXktSBkiBoSbj9RLmD
12786	payment	1726	1726	1874	1	1	3988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a1RMutvTK4gSU51yan2vWpWx7kSZ2Cceh1WJTZeBnEYBfsAV
12789	payment	1726	1726	1874	1	1	3991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqbAmaRHo6dhG9BPkfrZT1REAdoKZwSB2Ht3mkJVbc5RUBCZx
12792	payment	1726	1726	1874	1	1	3994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEL3WrHn5ucnbf24z2FT7ZeswATJR86JNRbHTkoiS8Qwpwbx62
12793	payment	1726	1726	1874	1	1	3995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnn6bSJ5c8Fis75vqnjZF7uwdJ8vni35iXHtC8KQZUaAb1N3MM
12801	payment	1726	1726	1874	1	1	4003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCLpSFSzemTjvMshCWL7GafEH67DFW2R3gVXnjjQS6yqpxk68
12829	payment	1726	1726	1874	1	1	4023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuWXEvTeUYp4Bi2gqAbmdw7SKX1kwFCr5vLSHCMEPzKTahRCb
12830	payment	1726	1726	1874	1	1	4024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszRK4YTFmUdyXLJewRqC5sA4ZdaYAAfZf4b28EsCqjHWZ4FsX
12834	payment	1726	1726	1874	1	1	4028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdqgeVcoLxw5mafPg4aap3WcMVdzCW4ysMN3Jb7QrwoD1Ux6q
12840	payment	1726	1726	1874	1	1	4034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNAoAjQtUuhRVyvcNKjFRR4R9VLLxSogjNWQjTFsnTtWhNLjr
12841	payment	1726	1726	1874	1	1	4035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Etk3VY9vXjfq1yUdKYW8NA7woifVin1Fc8smbm8z7iRq9TUk
12845	payment	1726	1726	1874	1	1	4039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSAsMhmcw6FXTiop8SZ5qfKBGi1X8q4AF4isTPdqJu2UVDdRL
12848	payment	1726	1726	1874	1	1	4042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYhQDCisiMVRzGtSSgqYsj5qibhaTiwZy53fnTTki1NRFobPL
12849	payment	1726	1726	1874	1	1	4043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZ5onfot8KiNTDW5GYwo24qu3G1Zernm9FAPhksQCCmLd83j1
12853	payment	1726	1726	1874	1	1	4047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsghdGXeer8jXpuu56ynCh83SthpgTfbGU8SyV7C1Koy8WrYKe
12861	payment	1726	1726	1874	1	1	4054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrQs3uH4wgo45b9snucekLm3ohDPmEz2FP91bCpR2n9tZnjhj
12874	payment	1726	1726	1874	1	1	4065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5rtVUR5Cd9ow8pDnS5wxJmeBXHaLHkzsAbdzbx2dNMbeUYE9
12875	payment	1726	1726	1874	1	1	4066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4cPHD5ybnkqQnm4sKjY8KZeY9scqdxrb5efaSJ7YnMywgV3j
12876	payment	1726	1726	1874	1	1	4067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhQgg33LtWBenVHVtkKZYo3Hqh3tm4LfnuGecscQRMRpFN5UB
12877	payment	1726	1726	1874	1	1	4068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZtQXKYsHSSavXNU56ur1HMNTrjommWiqEMRKq1Gbc1WZUKX7
12879	payment	1726	1726	1874	1	1	4070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAToSRtyd5KBnrFJnxhEDSGhPaQ1iUsrwbsRN2iEcWrxkFS5UK
12707	payment	1726	1726	1874	1	1	3913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKoR39qGtqrBNh81usBsuWiD5cd22bhhDDiWiEhiGSnQDNJw1
12708	payment	1726	1726	1874	1	1	3914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSkyLtwuTo35sjsAnhDx4DqxfRGsKM3D9r6Pw7HyKXKpxkw7C
12709	payment	1726	1726	1874	1	1	3915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1sgeEd2bzbbtyvHPbGdGGjVPmqMBA3y1y7YHwyRC5baqGgvT
12710	payment	1726	1726	1874	1	1	3916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1K6ZB35YnNwK1jX3V87WKdWPtokGahjDdXZ6mzJdujS1i7oX
12711	payment	1726	1726	1874	1	1	3917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6njdGDL3A3SSe4GKWTVujKziuRJhkALB6BprVxzKQw49kytNV
12712	payment	1726	1726	1874	1	1	3918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9Yj78bjRWZ3BcfNZ6fRzz8YEE2NgQFmbH16Ri7b5SAS4jVTQ
12713	payment	1726	1726	1874	1	1	3919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmTm2EPpfYfbUTpYdgoo7kcJkEHmsvx2RehnutjLVfrBPoJNg
12714	payment	1726	1726	1874	1	1	3920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dxvS5Kc82bXZBQHQ5N1U7C8ZB4SPRsh6CYkpc53czuquMpi5
12715	payment	1726	1726	1874	1	1	3921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1k1yHqP75zqPSBxAeHwXhJVqzJJ8xJfhNjtBLx8dRSaqVnyfN
12716	payment	1726	1726	1874	1	1	3922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrVwZVfMSM2NJTdLDfAfyZdW8ThPBcvaxNJkhub1nBkFttNzq
12717	payment	1726	1726	1874	1	1	3923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfSXJykCK8cCdj4fADL8N45cKc6jHNaZjK7bhczzpS2GWVpUd
12721	payment	1726	1726	1874	1	1	3927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmSHWUxtQER1CCJBjuA52B7BPSDTfFC6TUo3JjEiKUEKXqHri
12722	payment	1726	1726	1874	1	1	3928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjALtLA2eMUMWGQvECfD77ytUtjWmiTfF5KCKaxigMGtRiknpY
12728	payment	1726	1726	2057	1	1	3934	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHkcAXa8oXS1qxcnN7kxfZk1DKLe2n938ASAsBPRo8M7KsRvH8
12729	payment	1726	1726	1874	1	1	3935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgR9aJVqqR6GgRgaLRwDMgHYU7equxQALwz18sv7zpb3fe124V
12735	payment	1555	1555	981	1	1	0	1731971723918	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZL2LcmUCzvYMjcwJhvfDVd3g7mPQZ9NpU1vWJfsfsM4iKEpkuG
12736	payment	1726	1726	1874	1	1	3941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvP5kirRiE1JS9huFz7piTVfv3ULpwQrXfwayDnXoFADcihwn
12737	payment	1726	1726	1874	1	1	3942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwAGTfRJajub6BnWzAcytnAV8Ls1s1XFa8sYmHP3ZyfbH3ppb
12751	payment	1726	1726	1874	1	1	3953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJt8pWnxUNNSpDmABp3fm3HG7YnjfjiMzvmnF1oaSgLHRKj7Lz
12752	payment	1726	1726	1874	1	1	3954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs53AjM1wMgFpDY4bzrc6bM4uhYgwZXCJdsEQNPNMRK2B5GK19
12753	payment	1726	1726	1874	1	1	3955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR1K9Bo5UhX22TZFn7TQny3KVBA8UwA98rWaLygSUoDVDY6sf
12754	payment	1726	1726	1874	1	1	3956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznxSr1aD3HHJ7F1YDkGZSaZ2RxcqUmDSoZLNsNsyPnMMm5RgE
12755	payment	1726	1726	1874	1	1	3957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5WsFjyy9Bz9fHweSYQ1vfDs97uYhiAGrGsk5sudXx1bkT6uZ
12760	payment	1726	1726	1874	1	1	3962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtKa57DZk8sT8JtKU9RP8RuzFx5vt775JBEnZsxDyCFMFhBpP
12767	payment	1726	1726	1874	1	1	3969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJmKwu95LZzy6G4VbSDzFshEuNDP2EaWwqkcXGgKXMF8vFANY
12768	payment	1726	1726	1874	1	1	3970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNavcMNKph9svy6LY6PTeZvwzD1R4LrfaqKRnJHTKp2JYUgmD
12779	payment	1726	1726	1874	1	1	3981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW5gCsxWxp7w7M3jTKmxgLvFq6gLDTWzs8zASmmUGmiBmZNk5
12805	payment	1726	1726	1874	1	1	4007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNiHopAC8AEJ7W3bZcLQscWLQJGkjp9FzN7YQwounpkcxEKjV
12806	payment	1726	1726	1874	1	1	4008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrRkyffTArjaPeehg3ZnRugJeejieWPsQ2E14x2erJjjfrp5d
12807	payment	1573	1573	1318	1	1	0	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1oveo8ZK11krZzvjjZy2KNVpeKRZAYo4KpPaUpgHXubqCA12
12808	payment	1726	1726	1874	1	1	4009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppgsSYUaHtwTofrLaGV91uqWKJkrFh1okrv4kXxF4hsWfWsLs
12809	payment	1726	1726	1874	1	1	4010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeff4usSfNm6JHPSu2yL9XhMhTbi6ev5QrTeRgPF26BU5VkfFV
12810	payment	1573	1573	1072	1	1	1	5777000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxaNrUDVquTpcovdYNpVtwXyc3ySgAnUs8oP8Nwn8LKCmyMec
12811	payment	1573	1573	1192	1	1	2	3897000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvfr7jS4wMu1vMugmDsH5SrfGb4eA1UGHV3ZeATg9G3fDUEET
12812	payment	1573	1573	952	1	1	3	3064000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ8CfhPEJke5iGSXaXZfZyv8oGos88Pu1YXyZ8DpVsARhRdye
12813	payment	1726	1726	1874	1	1	4011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSgNc3BsYGdd97hj6KoqGJqMNJwEUUuzxxbnZjLZdMoo3BhuF
12814	payment	1726	1726	1874	1	1	4012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZDCJesDkEth2dy7RvRsR1xHv2hRzyommBdqvftpZ7sGQbRzT
12817	payment	1726	1726	1874	1	1	4015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSz9iSX7ctTrmTG9Q2tCkJLZFwBL9iCiCtRtGpxXbHeNZ8FoeK
12818	payment	1573	1573	1318	1	1	4	10319000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaic3AqgHnQFV4FVCpAtJdkAEAYTGL7BZyjAq2RAkEEb6thyR
12825	payment	1726	1726	1874	1	1	4019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1PzdhxMEXDfGhtwJReoeQg7LkwnUwpxzQrezr9U4vdxHV8cM
12833	payment	1726	1726	1874	1	1	4027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHhptiz6EtRFkPLHXkgMmc3jWYz6yFwsD8uooDS3DK13zdAT5
12837	payment	1726	1726	1874	1	1	4031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6upxYzv4DeTo4X4zoz9jXX8D9YmwnGkZYcfafpzLDVdRPqcy
12844	payment	1726	1726	1874	1	1	4038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeYXN3GckMNVAJ7AVScpqrYSQQGiucJhZDccv7dduttMUWMtL
12852	payment	1726	1726	1874	1	1	4046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziXJGadrMcERkymg66xyrMRucfzMFMUdwBw2n9yraycdkEuya
12862	payment	1726	1726	1874	1	1	4055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRcgWPMGoJ2GqGFP6CJPQgcYDAwBhGAWw2s2zrGaD9jpuwGX2
12871	payment	1726	1726	1874	1	1	4062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq96VCJXASxb49NwgS4uT6UXqdme3NVvPZ47fbc7mWkcMAMPde
12872	payment	1726	1726	1874	1	1	4063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfhZ7KwqsJzn4TMLZkXTZt4Y547NtXrPiChqDE7QmNvAK98DH
12894	payment	1726	1726	1874	1	1	4084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ8bJSSR841MMpgmJJAPCPq43HWTHqcvoMkKhFX74Ymqz83pY
12895	payment	1726	1726	1874	1	1	4085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVuvvb2UkkZyx91MXL1uDf1MSyPMGdvhdRC86cmas6QviMnjh
12900	payment	1726	1726	1874	1	1	4088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipwcR3tGf4XHC15bBRMfMmTog6vpK3cRiPzJx6ivT1v9neA5b
12901	payment	1726	1726	1874	1	1	4089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxHRf7cWT7sLF7jdW21QA5K3nhhfbYquKRuRPxv3jzSWq3hbZ
12905	payment	1726	1726	1874	1	1	4092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUkv8NjMg4JT7HTozMWmHo2ftwZ27Tz4owJPLnumfqdcKAT8K
12906	payment	1726	1726	1874	1	1	4093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbkw9yyhgdVyTJnMsryXAQur94dEAHbXiSUURXGa4kH23jQ2M
12907	payment	2058	2058	2059	1	1	0	1000000	1000000	65535	E4Ym8y9D2MXY4z3cdN5DZp9r7LMkSP7E62uPwx6BMe8eaf9EQhnWo	CkpZaU1M4YRXiH4hbsXn1LmCWVM63mVUxx1SRegzsGASm7cFUpwHM
12908	payment	1769	1769	1769	1	1	26	20000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1ycbdM8Uj88y9cBsahKPZJNuugoHVSvdSNwwX74ctoA72W9h
12918	payment	1726	1726	1874	1	1	4102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGi5Pt8hwoz5QwM9cNSxn7sWCf7A1XwyGymoFGRTbovz8rUHX
12943	payment	1726	1726	1874	1	1	4125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosiZ6pJUkjA1w3iuaG5N1HDjKNo4ejhBpe2pyWdjo5pi1Waw5
12952	payment	1726	1726	1874	1	1	4133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtsBaByoC9Lji7FkrUiSHfou8J5pPrWZtRvWywajXVNP1y4Bo8
12973	payment	1726	1726	1874	1	1	4154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9yMDzrsomvRJZBTrmHeK6X2pRH4qcAf1Rj31zxzb7qzKNiTW
12984	payment	1726	1726	1874	1	1	4161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVonPJ7u9W88j4QimyttKSTSj96wD74VT3iwHKKb7rR9VhRdUk
12985	payment	1726	1726	1874	1	1	4162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviE3Eg9n1r6UMW9oHU7urMHBPN2RnQpJRVMBkF8gMvwsfNsS7
12994	payment	1726	1726	1874	1	1	4171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE52TbPmLv8GiiQDiWEbLH33Xi1qnYJtcny85vqeWnSW4N9yMR
12995	payment	1726	1726	1874	1	1	4172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEnXZDCvymis8vBMHKWSBQot1z2z5jS5iE9Hh4U8DZ7TkpZPF
12996	payment	1726	1726	1874	1	1	4173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhHDTi9p5LcoSSr5BQHZb42pNZVQAYX37ESC5MfwLE45xpnYB
12997	payment	1726	1726	1874	1	1	4174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsgNwDgT29nWdZyZB7ttLBJ3mSZysLQmBWauE5HEfPrDssUgc
13008	payment	1726	1726	1874	1	1	4185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXXWGbqueUqy49qDyboAEBiEnWNro3kqiuGmMo69TcxyZzyfY
13013	payment	1474	1474	1950	1	1	12	600000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPdAvgahziMCBtWD4CTkjWgNcNri8LceqasQkJyGdDGzj99bb
13014	payment	1726	1726	1874	1	1	4190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTL1i1DpCALTJXqjQVTPeQBhTgT1TeYRo8W9fmfyiMKFUBJv6u
13018	payment	1726	1726	1874	1	1	4194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy8MQU6Hgbovxxa5RuG9RA545CX1VLpwBPvnDj24vbcUmkzMq
13026	payment	1726	1726	1874	1	1	4202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGDU2odKUFkBqoY7C12aQkXFP8Wpj8Uuns5vU84YxxMLjMrT1
13032	payment	1726	1726	1874	1	1	4206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKCtNijTczGApADaAFDA77VoCdraaPSZFDM3qAeLbE3xPAS8P
13038	payment	1705	1705	994	1	1	17	54030000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpZnacWEfyyaTUP3CR3wNgLXizbQae1c3Gd9hFsh7jq545BVuRNe
13039	payment	1726	1726	1874	1	1	4210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXxEbWyqCHc1fzT14uMW9iB1pic5c13h9jthFF36GZWdjjYwn
13042	payment	1726	1726	1874	1	1	4213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nNb2hYuL5b37xr1Esa3Je5v8yWyDU8QSwZ3am49VZoytF5ni
13050	payment	1726	1726	1874	1	1	4221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHNLJm7VoX3woG9yvGeyHXuPcRUU5zSXuBqq9VDMQoaDGNUDY
13051	payment	1726	1726	1874	1	1	4222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQvFRSw64cQTZaurkD8Ns7YtQGDxsbGGZH9XFuDsjkAptun19
12821	payment	1573	1573	952	1	1	3	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMSFUTwyoEKRwpcye7By6PqQS1KpATmTX2LQzukWa8Z1usF62
12838	payment	1726	1726	1874	1	1	4032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxX2iBkjQxyMjqRRwS42gXWTEzrXeUjecsJ4ErZ5u6EWLSRoV
12839	payment	1726	1726	1874	1	1	4033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Jrpz3TBUeJW94kckfYFRRJQAxNs1QCP6ZA9jDfnt68YH7aji
12843	payment	1726	1726	1874	1	1	4037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MCoGKi6xjQNxbA5NUcBa9daThwN8cBQeKvyffdtzZJShLpXS
12846	payment	1726	1726	1874	1	1	4040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjc76QgEVtkKbL4Ymwfs4zktCmq87PwQarkmbGykrxDUwxVPMK
12850	payment	1726	1726	1874	1	1	4044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwz7ZG9ZnEbf2aDZ4TzZiPr9gPjNoxtnve7DbCA5VfgcnxFum
12858	payment	1726	1726	1874	1	1	4051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbui4YQ8QRvYN2DCGi8BjgqjebN1Jo1ne5eFc7PcYj4Re2WeSB
12859	payment	1726	1726	1874	1	1	4052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTZyC76t1UVk92V9QXDNrc5cfxjRgGKXroj7DdPmTKRTyfV1j
12860	payment	1726	1726	1874	1	1	4053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfvNGKFhgkUwHUfmdz3pP1ifuyNQhf2N2Jd9x8Y1UujNnKwCE
12870	payment	1726	1726	1874	1	1	4061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAph5oCMxABs7R9B2VQwBG4BALDg2qPT5xfRtGuUeqMeYpzVBv
12873	payment	1726	1726	1874	1	1	4064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7j2aeW6bPfSBx9wGALLMkSRH8ZQXjms6CxzgqfAK2tex6wxQ
12878	payment	1726	1726	1874	1	1	4069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFyGHpreRS8TEDnFEngcHExvsjXk7qEHwkQC5Pw9J41wMa3FZ
12884	delegation	1939	1939	1449	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWG248wfhnN4k85zntWxLm4GZJacVrffwDiz3BmtZBoZon1do
12885	payment	1726	1726	1874	1	1	4075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1u4aLjdy4Hy1eyS57ExJSwrYbhbWGjcX5RaoSLqwUzvdDAXR
12889	payment	1726	1726	1874	1	1	4079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupi5k8tBwKjBwj2WKc4QJGVv7JZT1EGCtWQTTdoshJJysmofx
12893	payment	1726	1726	1874	1	1	4083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mnoM5rpYt8idnPVQ63nPkdZkWY8XRD8LK6GokyisDrVJTQp7
12896	payment	1726	1726	1874	1	1	4086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYxXntyYeg55q36fQ4UFBURrNFQghToERVkfsPU45FPasiady
12897	payment	1726	1726	1874	1	1	4087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc27fp1vom5diV5256kQbmwRNSDDyf4bK2LztShgJvunsedYCd
12898	payment	1521	1521	2058	1	1	6	1586000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbcjnBHQqCJ74rwCsAr6zw5PrGBPXqZpk328cns7Wv11S5o5B
12899	payment	1769	1769	1769	1	1	24	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCpBzwY1G9KtgrQ5PfB5v5yBAxMTUEGf1hWHkP73VKStvwZLg
12902	payment	1726	1726	1874	1	1	4090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrQSroijDMJnNkf5VpuKZpKTkwmJxamjMU7RgG8Jt6KZ1L4c9
12903	payment	1726	1726	1874	1	1	4091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQB9u7XZ88jc2Pak7BLjmbQrp5xvMz8EBE4NkWyXyK1jKbTpd
12904	payment	1769	1769	1769	1	1	25	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNMsC2pykKgJ1WV7mUz9wdjq5QjxpTUbAWrQ2FUNpDHF6aLdQ
12909	payment	1726	1726	1874	1	1	4094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Lpyd8Z1ecm74pi8kbPemTNX39SvGjdK8Zm7vE2jr4Sqd1x9T
12914	payment	1726	1726	1874	1	1	4099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotGCSeN84BT5FCWKkLKFJZUxSpvR2xgzTmDTJmSxCmXipNGkC
12925	payment	1726	1726	1874	1	1	4108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ti3gKPeRBWEiNj5q7qUfLnrfiSCFSjjHBpD8pxXkXFo3onQb
12932	payment	1726	1726	1874	1	1	4115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBD1w5WjGupNia7vxh9boG15LVMhtFEJveHh43HPQThV1KAVn
12935	payment	1726	1726	1874	1	1	4117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2e3hBMxXWcUZ7jtA41iwQX8zCPoF8TKLXoajbXAcBwzcTF5hH
12936	payment	1726	1726	1874	1	1	4118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZpgmiEBzsbcoJSZzFSqjiPncc1CuG1PenHRuZM71DsUMSdcQ
12940	payment	1726	1726	1874	1	1	4122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcryMXNbLo6Yb9qZbXqDNy7dwpH9DCEJ3kG5oi8MJL6pqqGyo6
12941	payment	1726	1726	1874	1	1	4123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSBbZvH4etgK2f3s1DMxkfpZR7jDcW24EXvF93AX3RvT7u37B
12942	payment	1726	1726	1874	1	1	4124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRrAGk1tTyaCRdzZei5gjvLZC5tpDPAELBU5vc7vTfY26LX1y
12945	payment	1726	1726	1874	1	1	4127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnELWhqMq7mEsxPthsWqopw33WTp7KHXYXZ3xHt9RoPTpLG44
12946	payment	1726	1726	1874	1	1	4128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKho4GspZFSHxDnmDv6tNN7FZjdkjnJP2yYZxVNTKZjj38LWw
12958	payment	1726	1726	1874	1	1	4139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMw8PnaXfk7FmZwLhm3rDASXLTmtneJomgrxbNxAT9mkNhkuH
12959	payment	1726	1726	1874	1	1	4140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9zoShRKdnX8izTMRnomqxykL7xFMDoye5wzsf8Vv3Bn3R2Jhn
12963	payment	1726	1726	1874	1	1	4144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Uov2T4nrVTDQ96R8W2d71ujaKvBRs6CSEWLWDaBKdV7Jx6je
12965	payment	1726	1726	1874	1	1	4146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh13FCfwvCE55BKUP7w87x9Rp21SdDstaShmmdKF8jBFSTfZNR
12831	payment	1726	1726	1874	1	1	4025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyDpGLThs2LVAbnJWe197EnU3xi3mY1gKDhUsAH6ycTMR4tDD
12832	payment	1726	1726	1874	1	1	4026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHBKqttZPB7j5hoPCqSB67DsfFiv6SZkoCWokoRP4tK8fRPvw
12835	payment	1726	1726	1874	1	1	4029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfA5kW5E1Xawv2oWdcuJRtRF3zRJkrJZJvZxaqDE88SvvrdB2W
12836	payment	1726	1726	1874	1	1	4030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemHwq63E87bSfd1TNAsJVVRK6CqmXZkrAkHgw1rdbibSE36Hj
12842	payment	1726	1726	1874	1	1	4036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqU6iL6AGesg1gB35k6jSrVA74RGpphMHnEnYcdMd75u42Xgn
12847	payment	1726	1726	1874	1	1	4041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKHQxtfemnEwmgqLMvGE6ZdmmkcwbFJK6gvpbBZ2CaZaWiFS9
12851	payment	1726	1726	1874	1	1	4045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eFXJhpMEssMc8T68f9bm2zj5b7hmNiMxU1re96MwaMXcJR4z
12854	payment	1775	1775	2047	1	1	11	1000000000	1000000	65535	E4YZaD9tEbRKj8FGKxKCUFsDNb6i3XRnNmydzwLgvk5T9w8cPKjJ7	CkpYi99BMxFa2yk7cP3x2RbtKh7b9EJ1PYUxT8oe2X5nxZAx25cWd
12855	payment	1726	1726	1874	1	1	4048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzdvL6389AfmUeJ5sJaRurfbuKSPWTBVS4hgucYgmroJ97LYM
12856	payment	1726	1726	1874	1	1	4049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwMF1wZzeSdbt5HspUXYGiU43y2LkW6TWp83bB4TuW5y8xdWc
12857	payment	1726	1726	1874	1	1	4050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXphgLUEqNWaef4EJL5efg85v9B3MSTWJyqaAyGtRzSSxzK5G
12863	payment	1726	1726	1874	1	1	4056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUwToMdomSDhrwacQcBHKDRcACf5xJB45eTM4WwY8pvgwTU8s
12864	payment	1726	1726	1874	1	1	4057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupUu4NHMvVizyegWKcYbgzFwcHSH2wX8sjkZEutvKKAaEY2Fp
12865	payment	1775	1775	2047	1	1	12	10000000	1000000	65535	E4Yq8AZjprEiQtyCYNUN9PGBLmAa8JJNRtZEXpHqYapahSTcLgc2N	CkpZTAQAxdYJ7hv5z6tXhALLVFZuihxu8jnxHSsmFWGeoMUXbvNqq
12866	payment	1775	1775	2047	1	1	13	20000000	1000000	65535	E4YX7s3Hzzve7HTDZvce2ePq1kRQYbwyuSC9kbj8C1rs4GcNa7kNe	CkpZwH3RDvJKzVdU5hcsbsZ4JrjcmV1oSS1U6BwE7jEqc1e4ZYTyK
12867	payment	1726	1726	1874	1	1	4058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3q8QpcJmYjYN6D23euCxYn9UaF59CcngLfyMNftdBkC3zj21
12868	payment	1726	1726	1874	1	1	4059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaiDsWRdRLLnBkoAZCXu4Ru64viSUKKUabsJr2dM2kZP1QU7N
12869	payment	1726	1726	1874	1	1	4060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHjUarWn1aC4kXNPofpBRYiaHQDoo7PnPeT8tjFQmGT5XzYtd
12883	payment	1726	1726	1874	1	1	4074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkp58WW6HqvzR6v7dMoeXMY4BCjw4F18obmaQpAWtAQka2qNSM
12887	payment	1726	1726	1874	1	1	4077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQhfXzVJtPRFp5fcFuVp7QD3zV2qZFgXp5D6L9iyTQCPvht5r
12888	payment	1726	1726	1874	1	1	4078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmi6e8mmaNGSsso7Zq1qEk5ZjqbsY8jvipz7E6epbJYAvHdYK
12892	payment	1726	1726	1874	1	1	4082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2WMChQFcLCoC1STEXGodCpJWYBzHaWSzUfEDRfTh8bEVCmcs
12915	payment	2058	2058	2059	1	1	1	200000	1000000	65535	E4YZU4qd8otUrQDK4zTRC6dViYNSRtfjVZAaQJAr3uo4HGJtnqexc	CkpYauDNb2SpnCMSiBpS9rXWCcVnGbVsZFfFBufEj9uA16tDCLjm4
12916	payment	1726	1726	1874	1	1	4100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFNQhzDce9ZPQsLTxe2Rmqd7o3JHiD9ADefWVXX5p28PBDDer
12919	payment	1726	1726	1874	1	1	4103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNV1kuXKPkJTvAoTnxNyx9Se44gqFXFTMq71fJNhUjbZ2HV5H
12920	payment	1726	1726	1874	1	1	4104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYky88nYgPnBsRnzqBLUo5z7xftaPRAyXNHsnBXJ2d42XNGxgwe
12924	payment	1726	1726	1874	1	1	4107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSueFMFfiMsaZeHrMwtFEz3DSMTyTTPj4sdCrqXLBhyDeUug3
12927	payment	1726	1726	1874	1	1	4110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTCLf4CVsYnqkzvUL5ZF7u5wBgHbfTD8knRZ29uSTd5wymnBA
12928	payment	1726	1726	1874	1	1	4111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CeEmk11DyU5P7bx9bQH6Z75ZdNp2RBKWwZxZTpAGhbyTvUXD
12929	payment	1726	1726	1874	1	1	4112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrJB9539GgntdaD1ttnf9csKKNwt1tyMWtgCx74twcsJFvb5a
12933	payment	1726	1726	1874	1	1	4116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8TWXxm7gHfR9UiTDtQrzJmur1N4gaiEseicDUKkTBnKVzqEB
12934	payment	1775	1775	2047	1	1	14	10000000	1000000	65535	E4Ys4ujyGt75F24Z44TxUVFtnz3oHHcmLA8PNAaa7SkJhf4yR5eut	CkpZTT9angWS18PTvzozQD4osrvgv9KfLkTaPj9umgCjcfurYpwCd
12949	payment	1950	1950	2027	1	1	12	130000000000	1000000	\N	E4YXduvB7pokBNnxA8QXQh3ES9b9VgRJqZpAQShZvSPt8n8HQoMKM	CkpYsjYzUV3KdejbnSymQbpdgvowbwafeGJbDVmxoPMHHvkwnt8uv
12950	payment	1726	1726	1874	1	1	4131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNotZFVgPWnsjxEHjitxNj4r4ekUvcT1waDBEoKKKCcVZA4eeR
12951	payment	1726	1726	1874	1	1	4132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGsEMrxPmFjbyD8kvbZYHtTwf4YS6UMuF6YsR9wdiGovaWQRe
12953	payment	1726	1726	1874	1	1	4134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZfmznLXfEqkYE45hLszeEkume1DxX9ymLU1BjyfienExqmSs
12954	payment	1726	1726	1874	1	1	4135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V2Z9QVsu3Lb55wSXrvebALVq8CsHvMZF6s1NNunUvbyB3TK5
12961	payment	1726	1726	1874	1	1	4142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuSpUbo1Q5VrpUtun21S9eVwkHDXFG1vC4WCt1vx941aovPRn
12880	payment	1726	1726	1874	1	1	4071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8fQGL4uMn4KVW9YJALes7KpBQSWesDdrfN6Yo65BQ9SY6hB8
12881	payment	1726	1726	1874	1	1	4072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxvibibZdWpNdZMDUYkSf5Kk32UvHkE6KcpWjTUgsA6gEgfG8
12882	payment	1726	1726	1874	1	1	4073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiu4Dw2chrcp8WPdrp3xQoaU4ncuNjv6ye3ovFyHo6MYCshs2
12886	payment	1726	1726	1874	1	1	4076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGj6E2TLrQe9t5QVyXJjwbJQe38b6VJypLEZLe4zShLqFWcCw
12890	payment	1726	1726	1874	1	1	4080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8VxC8TMDcUhgDbYFz4F8ETiDB896f2CztxE7a1fi8qZBR97x
12891	payment	1726	1726	1874	1	1	4081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwiacn5QHtmRQtRRzvXnXmshLsH8fDpNQYP8R4CK3VJpCDDZL
12910	payment	1726	1726	1874	1	1	4095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeMaLTjn7Um2N7hpt28gsoUmszZs2PhdGqtUfZdtRNRQCiBzo
12911	payment	1726	1726	2060	1	1	4096	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZS7EyiWjm15ZvX6L16A3pFMM6MvG2vvnbo5uEN3tgvsMMHkoUU
12912	payment	1726	1726	1874	1	1	4097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTQNQPGq3QuaDnQQ4GD2CmNao9VnjuAFgFP7phLMTQJi4XivN
12913	payment	1726	1726	1874	1	1	4098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAsVWH4kPjjNo2z7K5VuoJWxcQS3KCRttrdgMYfkuu6LUmJdh
12917	payment	1726	1726	1874	1	1	4101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rfcCGZDzTWvjvaMAPrD2V4Pzeo7hwKEQNkVLVcMZbnLAP8bE
12921	payment	1726	1726	1874	1	1	4105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnL4SQgmVbMXydSkDKutVnC8EkgPP8eoLDqyB62ZHyg7XMn5P
12922	payment	1726	1726	1874	1	1	4106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFw86LxJ912939rRsG8pa1zFzcTV82bz2ajeZPayBYSjLQfiQ
12923	payment	2058	2058	2059	1	1	2	400000	1000000	65535	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpaCfyX659UH4FggLh5FYS3p1S6fzc1WcR8V3mEBcy3owC1XznTN
12926	payment	1726	1726	1874	1	1	4109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3UqtXUZgM6Qv53ftPtKpnNzo2var5q6rdCgaCLGbSkgMEkDH
12930	payment	1726	1726	1874	1	1	4113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9bbGwo1buv74vSPfpyg4wNaw6T1c5XEVAojroKiJG8QAkkPT
12931	payment	1726	1726	1874	1	1	4114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7HTecVALtw63XpDedBHnauDeYiFfyJywEV5hTZ5jkjRrnF4t
12937	payment	1726	1726	1874	1	1	4119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMVwWZn6tpHekChQVGBB2s5eJrBS6awcypft3Z1t546ZSWaZv
12938	payment	1726	1726	1874	1	1	4120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJR23UKGy8HLZRrJxxt9H2oYgB2SS2b5dCzDgo78FDHvfA7te
12939	payment	1726	1726	1874	1	1	4121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDZz1rC3mAtHaY8dgYFGpKbxiyuCKFgb9qiseMz6g5tNXJMji
12944	payment	1726	1726	1874	1	1	4126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFFmF9VQS7w2PBJHbaFibW98G9m8e5wyjBCqbjDdMSmbtnVSA
12947	payment	1726	1726	1874	1	1	4129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLD4CDg6aGbGiV3CvuxD3t7rcVUi4djvkgA8riyabpEWb16oAk
12948	payment	1726	1726	1874	1	1	4130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4kuwu1Q8WrWt5rpsEDPPGwRhgGp5tpUFz4Gc61wf3igLcZ8K
12955	payment	1726	1726	1874	1	1	4136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qbSQR9SpJHZxoHnANRYzetGNgaXE6WCabH8NbaSscotpDH3E
12956	payment	1726	1726	1874	1	1	4137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScpTH4W4DkHwcE4itb5P5LAKxZ7te3D35sg8rBZCgnKwqyH2K
12957	payment	1726	1726	2061	1	1	4138	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoF3TT1Bke1n3q89TrNWf5Ukb81bW2kekphUZ6DBS1YYYmVaGi
12960	payment	1726	1726	1874	1	1	4141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9qvdk9Yp1NbDianEaUNpe2Rf6xkMkS4J6d9SeMMtVNDkFkgf
12964	payment	1726	1726	1874	1	1	4145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfcrWH1aDH3U5GUhjfyVNxRftYugdhptDvLnKqZNkvF49PVzV
12972	payment	1726	1726	1874	1	1	4153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGrBG7ivgbkqJcuZ11TV8JgbZeYPKA6pdc4r689irQrRTEkyX
12975	payment	1726	1726	1874	1	1	4156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yDG4npnrqFQEjt9HMLyLFzRWriZSNG2kbdtzNqBdJ83j7493
12976	payment	1726	1726	1874	1	1	4157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzbweyLf9VrQTZWZkHTHoYB41gPYhwFpb487bfLdc5babuKnH
12977	payment	1726	1726	1874	1	1	4158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcYm1mA4cEEjgmrPrEGdUMBnhUxcNQEQvgJuCQNq5GpQzCVbD
12978	payment	641	641	1090	1	1	8	222654800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfmiDQmk16RfQiku4Ma9372jr5aJ2j9zUstoHgaWKVNHnbFGr
12979	payment	641	641	970	1	1	9	124235600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gnmg7Bdef9QNkqoVtZjLwqLJmyLtzsGti8kZspgRHxkfE2wA
12980	payment	641	641	1336	1	1	10	418561200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJZRUE7EXsTKAoeVdgB1R32aWkF7SwzmP3yxzxwsp9cixPeLT
12981	payment	641	641	1210	1	1	11	150238400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfGcFyrDvF4CQLQMyDqKcbjaEcPtKw3jFqUA8pJgUMhH8pDC6
12989	payment	1726	1726	1874	1	1	4166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf3dWMJSD9D35BrNc13tScJZo7vv7DSD5N4GnUKsZQVJzNbjA
12990	payment	1726	1726	1874	1	1	4167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqDu3EHy8v2xLUCjC8HfpYcFwHYU5HWYsnaokQ23JR4rTUxaQ
12962	payment	1726	1726	1874	1	1	4143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwTwiYDPYNVriCQmjS3edYzpVtksAbkkhMRmdawEPNPvZNSi3
12967	payment	1726	1726	1874	1	1	4148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtsDhbFBwVoEpxgch9UTzX6YdKPEqzckpDpp7DjbaZi9N4PL8
12971	payment	1726	1726	1874	1	1	4152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmpdPBcukYrosMkcDiBakjbXABJQDHUABvVEuShpGarHqpB5z
12974	payment	1726	1726	1874	1	1	4155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuoyS5AnVJE6whw6qbzdandD5prVsTBvMiaVdFQK43d65yEyJ
12983	payment	1726	1726	1874	1	1	4160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAQ2EPNikarn4ZLRZ6ZhZM2zSxWnFKRugGd58hZRBmVHBTSni
12987	payment	1726	1726	2062	1	1	4164	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKZtVumggftHPsyoEhC6TUdW8vLYBCAVHGPrtTF5r4uqKk3qUz
12988	payment	1726	1726	1874	1	1	4165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtg8jq9BphLvkzBWMShUFuykRmJ3S2Voy1FFiC5ztGrAjcv1qQ
13005	payment	1726	1726	1874	1	1	4182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2Qu18PeYSwK44ViMESPeZVKKvinne362ztZic9oaXGcmnVBh
13006	payment	1726	1726	1874	1	1	4183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUehAArF3bdcfjgPDr941ASoFJfwva8sXP96AcvXgBWzsYDu5G
13007	payment	1726	1726	1874	1	1	4184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP5fkti1oP8jT5LDcixaxuW4XECHRzjcNn29tkTSkC2QE5fQQ
13015	payment	1726	1726	1874	1	1	4191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusfRPpNF66s6d53TQyoXoFR7dAnsJyEtPiDtAE1KVnTMcYJNN
13016	payment	1726	1726	1874	1	1	4192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeuGVFoQWH7yxtogfRbwCnqjEGpGevSEPmq8iMQHoE7zZJQgS
13023	payment	1726	1726	1874	1	1	4199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZU2GopHR19rAvg7isdA2ndLPAxumJmNG32FQMPg15y8M6pLKb
13027	payment	2060	2060	1713	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8sJ7UL1WK2Jodg3aSvJrhdzSvKPnVRZ6baPEBpFKkep7pRQt
13028	payment	1726	1726	1874	1	1	4203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsh8xzSPet72TdaLiTP4hU5BatQipYD1ev8V2HhkGcB2pZSMWx
13033	payment	1726	1726	1874	1	1	4207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcgjfJtzBTaw2o6jf4u1V9GNW3ZmybEwhyhehXJHqxaSiJMhD
13040	payment	1726	1726	1874	1	1	4211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApJxH7utSTZR8tCDHzF6HS9xSKfc33HhJor5exTAbBLExFGii
13046	payment	1726	1726	1874	1	1	4217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwj6iU3iEUmgcE1yyUzmMdh6EZ6ZAujm6viP43DM4ghNcMaS5a
13053	payment	1726	1726	1874	1	1	4224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9tCdu8LuJatDUavMbpBA4GnAPXok9tCP7qMU9LCVibpvV671
13058	payment	1471	1471	1386	1	1	0	8603000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnccHNg1cKansf8ZjRWGv6LahBve2fRa3RX5Lb9MvWP4fwcXUK
13065	payment	1726	1726	1874	1	1	4232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52668V4xyU9BeYEj7pWSd6WkRHpU3g7jBgU6eiCJFBAYeaHDD
13069	payment	1508	1508	773	1	1	0	3811812300	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZoqeu5kBxocGwCat8X1qLqK1YMo9xpbNv2Nd95KLaAEe3Jcyjr
13070	payment	1726	1726	1874	1	1	4236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkEtsiv3qARjJ5ykSBL5JqWfMkpRZu9v8gzet7vfFnr7tyBC3
13071	payment	1726	1726	1874	1	1	4237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKNPtc8DRvkT5PqgZyfYEYeV3ZKfxk2HWCzh8AGhziuj5ho1z
13085	payment	1726	1726	1874	1	1	4245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4u2GC3csni9N1o6N6bMBdz2MTg7kHcSh3uyQW9SLwMS1wTN2
13086	payment	1726	1726	1874	1	1	4246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nthtvDbjbFrAbjHagdtzbGbZHne8GBagvnaqppQLgMGrsEvN
13087	payment	1726	1726	1874	1	1	4247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwZZZBg6xRsUD5CQaRsNK7YgyfYWtMTTGmqQxSkD3Yh9XZ4ZE
13088	payment	1726	1726	1874	1	1	4248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHA1NLQnCDM1y5WfGgCXpCd8jisKf1XxmR61XZ3oqZoMmMKR7
13090	payment	1726	1726	1874	1	1	4250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZje9HP8UZMp6iQP2WxtFQuzsverCPuQwuvUGfieqpiWrhJKF
13091	payment	1726	1726	1874	1	1	4251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9F36k1HMbfj4rJtoufDvWvwLzpbFSpvoLv8KHmcWrxMfW4ZS2
13092	payment	1451	1451	759	1	1	0	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZZN6prcuA7e3gJUr5Kch2A1coccUh3Dgs5w23UKqHsAyuGzx3z
13093	payment	1426	1426	1364	1	1	0	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs627GxLC6YEMWoWX1c1G8p89TYXijBUo3sJuG68jwSdH52V7d
13094	payment	1426	1426	1118	1	1	1	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQmdWUCCoE8Ehyy8n5nBzEPNwGQskYCZxsgxyVN729jsJcpjp
13095	payment	1426	1426	1238	1	1	2	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweSGi6LPDvRhTKWAMx4AidXL5mXXLFoLDJ5AdcfFphdu2g9Qm
13096	payment	1426	1426	998	1	1	3	1916000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nosD3JFoFfqkNdGrj5XwhnVCB8msUqPTwMmS64WTiztVhgEo
13097	payment	1726	1726	1874	1	1	4252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDvDgVE6pvsGYW3uGEs1VEaWGsYmWBdRbcTciJ1dKHi1PZ92K
13098	payment	1726	1726	1874	1	1	4253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQKenFNzsb1P4FTiT9Z52FPjXeKt6nkoprUaMitZmzTxY95uk
13099	payment	1726	1726	1874	1	1	4254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSJjPtMxuKPMaKCGJNAwJgURp8ytiyJ2NkReFKn29KDgkfq6M
12966	payment	1726	1726	1874	1	1	4147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuarrYmCygXrGvx6RGe8KYMrXx6aitQLujo54a9dqiGF3CUZVq
12968	payment	1726	1726	1874	1	1	4149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYLzYMetcCgfwE4jBy2nP5738BmZQvdxLoBEQk1HhgQB2dVco
12969	payment	1726	1726	1874	1	1	4150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6RiowLvAJ7wrvfweVBYHFHhJ7Yw2F4PoDDNBrHxCxtU26AKA
12970	payment	1726	1726	1874	1	1	4151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QfcBenjKTkozuShatt7C6ey9Vh5MvSvkmSAyL58KMtTocZvZ
12982	payment	1726	1726	1874	1	1	4159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFua4jKiwny829VRgyx9jWzG8Zc778P7BRFnnpQg28vUGSq9U
12986	payment	1726	1726	1874	1	1	4163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6iNjs9QeR4YeGECR3rEme9CeXLgrRLJbbaA5wc3EZLnCcEjv
12999	payment	1726	1726	1874	1	1	4176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCx4xcnXwPp6NaDm8gduxbQxhQuBkjzUCsFpa4j9KarfaRZ1P
13041	payment	1726	1726	1874	1	1	4212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57S7mSo1KrtbrgoEz2mSQWErG9fMm3nbQTQLBX234fCFrGHVV
13043	payment	1726	1726	1874	1	1	4214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9MVLtutd66kpRgrvMF1BmCcB47jeSWihwneX1JgNfZUk3HDv
13044	payment	1726	1726	1874	1	1	4215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyPTLaEtEasJ9Rn95XMfFrSQ11RciY6Tmyn1MtPjH2RAbBdfx
13045	payment	1726	1726	2063	1	1	4216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQdpc2xNyUz4vJrcbc3xGtpDYcqZUrszBmQPm5wKCoihqJmAmH
13048	payment	1726	1726	1874	1	1	4219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KbQt9vCs4kBM7iDyEKuwJ4AD3YTvmH8vWhz41L3Mm9iJVthL
13049	payment	1726	1726	1874	1	1	4220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRritVDuq7fUzeQxRNqLU2wF4S4sBtbMYTvoMpd4zjTK3iinsi
13057	payment	1726	1726	1874	1	1	4228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7WJyzk1Uw8HXGyv5BCkfHsH2SBbp6pReqYe6GkuTs3HSriHF
13066	payment	1726	1726	1874	1	1	4233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUvbrVaR9ByVN247JS99xFoUCedFU7oAxdxtbmcVsKYbKs8xb
13078	payment	1508	1508	478	1	1	5	251579611955	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZnd9fJTHNFMi8ApjVPPfmsJ7jPBgcoVtFMVuiht2th3vy67cmr
13079	delegation	1897	1897	1600	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyPEoZFMfcWaXZwRrovhmJwvgVW53fpXQD2cQdEMZKJhVro7z
13080	payment	1726	1726	1874	1	1	4240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MhKhQiu5quc4LzSBeTLtvroALPUwK15rmEBEQpbcAre33JiM
13081	payment	1726	1726	1874	1	1	4241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhwNnJ8eQWoBKqxvhN5mN5EGMvHYXYwi21RQdZzE3ciin54iu
13084	payment	1726	1726	1874	1	1	4244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQ9WU4geDgr3pPYZcjQFdXsGEbYhFPHtxaxBJWBboRd6HZ1i1
13089	payment	1726	1726	1874	1	1	4249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRSjqYGpnjDhYaZ5emJ37at4rvZ6efXTzLFJDGjffGViN9FXb
13102	payment	301	301	1474	1	1	1	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59ENfXgc65wThDbraBQcEYLzadaMfr1oRVwfmTvQptYm8pD5D
13103	payment	1726	1726	1874	1	1	4257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfz44zRoNQ979d13XXKXLpTYf8NJoRtbmwBvbcz3rCJYhKPWex
13107	payment	1649	1649	1017	1	1	0	1916000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DAynarASxp3XmDMECgyd1WXuAQuLWXGAJqbiiMKEArGmbjYb
13108	payment	1649	1649	1257	1	1	1	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptj93srxTGNaaQ3vRvjLvh4EajpccTQvryjUaptfACJ4C8VHQ
13109	payment	1649	1649	1137	1	1	2	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvyRUBevsRLhBMrjQ9akzc6cmT54NS5Z2X5WusaZveK6KHp3J
13110	payment	1649	1649	1383	1	1	3	6453000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPE33W3DNqzzedSBtP1x69tw9ma2RR7NhgnAWXqihxRb3SHwV
13115	payment	1687	1687	1866	1	1	4	9452848201646	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3zZcx9jZ7pzRPdB7WTwcxRkATbfR8sWYHL33rnfd7PyESJpg
13116	payment	1726	1726	1874	1	1	4265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYWpm3mwFBnPNtbgn5P58RR9Zn1kHspPxU8x5hcYFmBPRVDxt
13117	payment	1726	1726	1874	1	1	4266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTGhnaGTz2M6MkRjiQUKurv84aBz9Ybs6TXpzvRocXgRD5tPk
13130	payment	1726	1726	1874	1	1	4270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQfKynKVAaYXgWLgKaUetNjtK745fqh3JJyYt4uCAGTicSuNv
13136	payment	1451	1451	1046	1	1	4	4575000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZx32QrA1LEShVJiU9eivQEzRQ6SYPQaxdLVVxCn4Ur9frAyCxE
13137	payment	1726	1726	1874	1	1	4274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQvo4RUVopj9CyiSxs9ucJjpeXFeaQLEE3vm5i9rrHUmK87cZ
13142	payment	1726	1726	1874	1	1	4277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQMvrbfzn8Rc2TeLGgeb6mGuoBraLP1j9st9QXAbNyybBMXt6
13148	payment	1451	1451	926	1	1	8	2553000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZawFRnrjttFNGEJKm6YAaVDRx3jL1v4UeciU3JasLZCWRVz6Qs
13149	payment	1726	1726	1874	1	1	4281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1nEPHtJdMZgafrCZZdBBzsL4f21MyRoVzHbDvUqywGDTUdqg
13156	payment	1726	1726	1874	1	1	4288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7m85PLUytCovqQTpnXGY5Aq5qaruUfsPRAddeDRE6iUcXqTP
13159	payment	1726	1726	1874	1	1	4291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFKnBXPqFaW92XafAvnWtBBFSDFFb2Vdj1oxGjpMM69HtRNZS
12991	payment	1726	1726	1874	1	1	4168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3p9jxFdhmkJ5m5c7PLmbxDoshX9WVX7yTD2oP7RfWzdBgRGN
12992	payment	1726	1726	1874	1	1	4169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9muRm3kcmPw6LeWBnW81aQvpKYpvJ3gYNtrB7GwuuDNNourY1
12993	payment	1726	1726	1874	1	1	4170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39wdYFCC9icvd6pLzqeraWJGnJHRqdnVWW3ipryq2MrzXNk1z
12998	payment	1726	1726	1874	1	1	4175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnDx3bp87JJvw3eLJhbP6DMaoJHCETkrd56He3rPtTbyfw32a
13000	payment	1726	1726	1874	1	1	4177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRWn6MY586LUEHzrmSt3Jr4BTGMPpaxiBYtX1dxHEUmFPt2MK
13001	payment	1726	1726	1874	1	1	4178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxbdoGY3p8nk2oA6N2gC9GZrJbPsr1GXqc6ZB2d98JUPc3BY6
13002	payment	1726	1726	1874	1	1	4179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoCuccKmxMk1pb1HX7rG1Xsue4KvLHfa8cmdEs2rt4KnijNHK
13003	payment	1726	1726	1874	1	1	4180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MN5sKQ35DBMaEJBeZp57CQ4F5M1TmrbZtzU9bB8YQBFs7Zgv
13004	payment	1726	1726	1874	1	1	4181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkv8mwwz5nbSMsaE2yojMpATbUzBnRtRkLBdaBSbAKtw3hc9tB
13009	payment	1726	1726	1874	1	1	4186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Y7xWBtgNXyWUgN5Y9T1UfVZR36aPtX3BooFCtWiLp8gCcajC
13010	payment	1726	1726	1874	1	1	4187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQddXoYWZNqXAUvzmovPRrYhNyuLHB8Xb9VoYZjZgKLsHnLXz
13011	payment	1726	1726	1874	1	1	4188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCijoDxLvHm7R3AWF5Xsw29X5FhKqY8PU8pmSgp94LNGGH1qvk
13012	payment	1726	1726	1874	1	1	4189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZev56wzG6FdaF4Pojp2w4MSvShWxniromFjxHY2T8WviHn6h8t
13017	payment	1726	1726	1874	1	1	4193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFX8AFQ1CL1W3qBHW5gKtLqFqXDgr2gkmkRMQ1E4uqBG3cuPp
13019	payment	1726	1726	1874	1	1	4195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDx6ViDuP76sy54iK25HHVT7Z4LYkRkbL2crqm3D9wtmbHvshe
13020	payment	1726	1726	1874	1	1	4196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzU7JTHZ43HYiUkJUamWHkN6Tf5SeeiBSRArdTdDvzGyzsmZZ
13021	payment	1726	1726	1874	1	1	4197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSyD2914LFKC42uoTxpQL29AkRE4C1wcYqm9zS6htE11ho5ZD
13022	payment	1726	1726	1874	1	1	4198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8UoBRuCPyuQauKzLhS3r671gdNQhrwHEZkcyZKuEcJjx8QGe
13024	payment	1726	1726	1874	1	1	4200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sdkfGSRYpezU9Uhh7p7T165LnJJJZaPRaqd3qcyZyfdtvPUn
13025	payment	1726	1726	1874	1	1	4201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNAKFtSDZnChgR8BdR34S1CzvDDxxcib2h9RSry82bkg6ZXXy
13029	payment	1705	1705	1360	1	1	14	182110000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpYzanLMNeH8vxSzUnTXUMwameWJdDNRjLHHvJ4WTvLoWiVmtaJi
13030	payment	1726	1726	1874	1	1	4204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrwSaRvjFCAVedsdrnCte6nFWKqCseRJin5cr95v4CZv3jYuJ
13031	payment	1726	1726	1874	1	1	4205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwwpCs1LNPU9dwHt3LwwMWxW7XdWBLnffnxZwjBu3GtNUoqnv
13034	payment	1705	1705	1234	1	1	15	65350000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpaKGKuNLrvZoFrScEhcSW3pn3JpdzCP3herWTuwXiyz2SjH2qU4
13035	payment	1705	1705	1114	1	1	16	96870000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpZPjQexJTztVPq8FZCuqhMxye3wyJFwUzxZudqpPC4uHLsJnbym
13036	payment	1726	1726	1874	1	1	4208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbfj2kk2ctyrEuwWPRMWacwzkqjQa7FAqePfRAU3xf8qjYBdm
13037	payment	1726	1726	1874	1	1	4209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokaATqoYSh4AoeYCZBu5dfmN7XAFUsrj1JFd9WWGJB1kHDRD9
13047	payment	1726	1726	1874	1	1	4218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUqL3HXbSh57MxPdzh1kM5xYeE84Au4no7zcNcPkvLx5xf9Wd
13059	payment	1726	1726	1874	1	1	4229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdBXJFFJhmwAXAyv1UxTx3SvhPQhWxATe9AWW2882ZboHar1F
13072	payment	1508	1508	1021	1	1	1	1914284536962	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZG9sHxFy9VvPobEH6ebRpERfJ1eGngyzt4U8musmoa2uac7Zpg
13073	payment	1508	1508	1141	1	1	2	3430381488639	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZC259e7VxYcnuy1ZVMXYXC4VG9tgmCepbbqsro3tTd1YdKbKPj
13074	payment	1508	1508	1261	1	1	3	2314546745574	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpYsYkCv1zXqAEZyHcddhiNUxwTQs9uDWva5oLR7MfBSh8yXTF6N
13075	payment	1726	1726	1874	1	1	4238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTWMksB9He3Hzq8mxhP9ayeaLKwodM1VHuAsiMTq1eaDwPBRR
13083	payment	1726	1726	1874	1	1	4243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtqkqz9JqCG8qCMZDGYce1JsU9a9PWMnmaujL8FT3Vwhw5bDc
13105	payment	1726	1726	1874	1	1	4259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7cYS59ESW28PH85mjZmpEVPeperzfK2ENXbgq2VicwXUkjTK
13106	payment	1726	1726	1874	1	1	4260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbwQW7kgCsUNXr7g2eSjPCe53g4TW4Xhmy22PS6MUo8udqdV4
13112	payment	1726	1726	1874	1	1	4262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepGs1qjEHETFt2TsjbNPoPoKf5PME7kxsqQubtKhbB5iXvs8q
13113	payment	1726	1726	1874	1	1	4263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gvmEQ1ExqmewyewZGDhGhwJ1YFpbsU7WYEG129W4a8NUm5SX
13052	payment	1726	1726	1874	1	1	4223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaL7iDdikP2furTDDyHrGLAVVzoLZD8R2vwPsSh4gnGPBcQjv
13054	payment	1726	1726	1874	1	1	4225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyBCDkyWBm1SobJ4CEWJhjPocGKUFMMnLjfZKTN939Mz3QzMN
13055	payment	1726	1726	1874	1	1	4226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxSi5GtBpQAPmayppKDm65AgfzmnArKGk5eFhXUPrK1266R86
13056	payment	1726	1726	1874	1	1	4227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJVGqN86q52EEksu4BJfZFvKjdGBumCGCq5hqH1PaRjFmBLWw
13060	payment	1471	1471	1140	1	1	1	4576000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNNdEs3SMzEVviuuKhnXZMXkvZAazD6sghZKuLxQPH2cLrMq7
13061	payment	1471	1471	1260	1	1	2	3088000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMrAbXF3zNZVjBA7jeFvB4dWwkwzjHV1c62NSXgB8KiFyg9Gp
13062	payment	1471	1471	1020	1	1	3	2554000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZStLXDSQ2o3LsQ5G6whKnFbLGXJicMfFnebpKTafjpMtFKnAM
13063	payment	1726	1726	1874	1	1	4230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCtuJ7HtMHMY6gSgHP9dFb3F3ia9QRua1ppsJuhPQTfNZww5C
13064	payment	1726	1726	1874	1	1	4231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFicsN22zn7voZBtxVYuR3vSHEzALuKUumYv5zssuvRcMSD35
13067	payment	1726	1726	1874	1	1	4234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdbXS2L3L6NAJwzt9zoxVBHdo8MWsxrRaGcU2f7EmkjcRAJqwk
13068	payment	1726	1726	1874	1	1	4235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36uAhi8vEwWwRpcZTQnG8JqbY18g4SrtCnijfVfeQRaxGPMV9
13076	payment	1508	1508	1387	1	1	4	6449690304561	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZvYJYg4dn27tfZpgg7ycPRDbBFaow2RamGau5PiHVPwoP8Kjr6
13077	payment	1726	1726	1874	1	1	4239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJBcsvxPhyhEGCAEjsvkbNuL7Xg3gH5Ssn9vp4zCtA3u5xN49
13082	payment	1726	1726	1874	1	1	4242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLmQSNsB7NfVqNRLqiDGDJ3xupw76R4C6zUBz6mrzw1EXqEPK
13100	payment	1726	1726	1874	1	1	4255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3cwLZD6yxXAGGXXkC3y7oFY4F59dgBiDaLUcPJeaybTnZK8v
13101	payment	1726	1726	1874	1	1	4256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkq1XR5yevnTh5rSkPBSFa1JHV7Jnsi2iy1QTCpXJiRLKk1WJ
13138	payment	1451	1451	1166	1	1	5	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZPD5S5NjYPnzbFgoHWAe5DtrpGAhoSxS14nYCVTFtHqttbwJX1
13139	payment	2062	2062	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWk4PyrxP7QY9sdeSB2ngoHfrcfjHqW2eiht6VLNT1zsJoKqX4
13140	payment	1726	1726	1874	1	1	4275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6mmmokGJscj2bSZuLnxKGyq59132SYtg4dtqA5jPkFLtpkQ3
13141	payment	1726	1726	1874	1	1	4276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtBqFx5Vuh3HvGoLuusLxTqXvUsU8xiVh9YsE8g5W1e8yn1TR
13146	payment	1451	1451	926	1	1	7	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYjZyTca7tHxGwNYX3fzCHNbVjtfUARSodU5Dw5pJM77XDUS8Df
13147	payment	1726	1726	1874	1	1	4280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNs2bu6gt5qXrGBTFE5iKffwX2BzTz6wKWXwSqw2tH2aTYLAw
13150	payment	1726	1726	1874	1	1	4282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY1P3KuQknukLCG1r8dgxHqw4fw1MNsnvRrW7osW8cfayQLbK
13151	payment	1726	1726	1874	1	1	4283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpxpnWVSx1zFRzWBzE1wkyPqh9PCCjjJMApgKnqmLuwrdU3DY
13161	payment	1726	1726	1874	1	1	4293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniFSs1BeF2UfQgU7hLcNsxdxxCu4YHX1k7ToiupTs9REXjJPz
13162	payment	1726	1726	1874	1	1	4294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNJBsoj4vbTzC3K7w6FmShHtbMLhK1B69jepHEtJMr3VFnDC1
13163	payment	1726	1726	1874	1	1	4295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZg92Pr8SC3hJFGudRDGEG1aKy4JFsBJW3Qbf3FVActjPaoGLq
13164	payment	1726	1726	1874	1	1	4296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8NQ4agJSSTPJAFFArM4CFtW1Dz61QPNisnkgdPS38EqAiMYr
13165	payment	1726	1726	1874	1	1	4297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZfCJMPRAtYNM2o7Gd5bZomv9A4ywmUo85b64rFvYQkaa1mSN
13166	payment	1726	1726	1874	1	1	4298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89gCSijYUK8yQXTZxu7QnWdeiNvfkEmxmBmsvqec153AWwH9d
13169	payment	1726	1726	1874	1	1	4301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW9jtYUNTCkfz6bV6z17BWtCs9Y2go2BUvznkLFRcQb7uW9V4
13171	payment	1726	1726	1874	1	1	4303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBdzxwvQh8wN1h6oSjk7gP2Ap77zNebsYiYDtpMcjsCV5hLFp
13188	payment	1726	1726	1874	1	1	4316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVNzZQfWopBqV41ntSefp2upp8yYU4BUuyLzX7cAGeCYqi1y6
13189	payment	1726	1726	1874	1	1	4317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceueCBfWmjtQWKGiq5qtAZ2CEM41Stx74XaUvpyHoAC33cWqu
13194	payment	1726	1726	1874	1	1	4322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFzMxjZkCGWQBZNVjwwQhbASqrNo1uDyoCgYamuR4w4X3Lr6h
13197	payment	1726	1726	1874	1	1	4325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33pfKVZYGz9zJr6wYwgbxB9nVcQyRMED1exNSuDVr5x69fUrb
13198	payment	1726	1726	1874	1	1	4326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFENx7fkGrPeE3mU4buNLja5w8nMZ8oekmenCkWT3ZB1qm4oT
13204	payment	1726	1726	1874	1	1	4332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDz7mm1qoBm7ZaxhhVj6UEJBY6YuE8T6U1efyoso6ZkTDfPMw
13104	payment	1726	1726	1874	1	1	4258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBuKeg5vAgKAQAUoNm1a7sTW8M6GUAcPAPYhTJQ9yTgKLtniL
13111	payment	1726	1726	1874	1	1	4261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GgF7knu71PndkiBswdHeQeU5avE6AHBLWcoSNiB6XAHBVBUR
13118	payment	1451	1451	1292	1	1	1	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZJdRLfF6eg76MrDaxWMeab8XjUTFmFLTnJNpjNe9S87urtNTGs
13119	payment	1726	1726	1874	1	1	4267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5kbojfXHi7eM2Uja2L2KnG8KsJNpEhsVMobiEQJDnm9HdDHo
13131	payment	1451	1451	1292	1	1	2	8601000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYdvyvMW3aEs5frePfe2AWwyT7drXnRRBMKxLtGaeVcK6X9MxwK
13132	payment	1726	1726	1874	1	1	4271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUoVTggRXCzQxD5B59GU8H2VQhM9Q7AwwxvEBRMCopi3G4Aggc
13143	payment	1451	1451	1166	1	1	6	3087000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZ532ZBVk1crCPAE3ybcwm4yQHMBx2xoSU4LgUEmyVszB1nCqA4
13144	payment	1726	1726	1874	1	1	4278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMdJVDUxDiEcabA4nnKkzWUrtXYGjQyq2wQx8bdqLcbU5nQjY
13152	payment	1726	1726	1874	1	1	4284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh5QNVK1Vw8eLG67APBsGXWaEWCvc7vhn1pJVPoecKueQtEhJ
13153	payment	1726	1726	1874	1	1	4285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmh5B5M5Tp5koUcbbrM3gctvqSa1PF3jz1i2Jw1DE8hJwHhYi1
13168	payment	1726	1726	1874	1	1	4300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4aDYSAcGCk99akG5Bfb26a8xRP9qqy6AFzzehaE54RWy3KEX
13170	payment	1726	1726	1874	1	1	4302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4xt3WKQP8S1xayWFdxDWPzG6JBEyZUNs7Qos1XhbNH7Azfki
13172	payment	1726	1726	1874	1	1	4304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqJ3L3EmPSmtncaT8cej6Rnzd161J41rTf4LcwFvy9VzhV2aW
13173	payment	1726	1726	1874	1	1	4305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3o2XCedxSbsiLjr7M7PnU2BLxvfbL4j9WCyniYnBGTUzCYjp
13174	payment	1696	1696	938	1	1	1	2769083740000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7Kg84FjiZ4KZP1SvyrRyw9ZCeF2qTkvfxxEVDkWANDJM3fbC
13175	payment	1726	1726	1874	1	1	4306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxadDyRThnJQPgUo4wSsHYneYuExeH37Hdij4GzmfoNxSBv8h
13176	payment	1726	1726	1874	1	1	4307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFBDAdYDanJJu2PPbyHLu4Qiz7N9JLspNaLQQ98yqpX7AVuqd
13177	payment	1726	1726	1874	1	1	4308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuJUnshErKn9DPC8j51vFeKrU7nGnKnDmi1KNf5KaA5ehNb5f
13178	payment	1726	1726	1874	1	1	4309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbb7AbJaqhFEmEUKm6u4RyWcbCECpaTh7bb1JBu9vc4o2o8X5
13184	payment	1726	1726	1874	1	1	4312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRv69YJBCMJNNpu4rsDvZHe9vHnTnqwGSFkQSkQpfQwNs4FCeB
13190	payment	1726	1726	1874	1	1	4318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWPp3M9kfR1tmVEkfvVyjgpi966zDKRh8JUecMNzZEb9R56Ej
13191	payment	1726	1726	1874	1	1	4319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnHaCRfUwYky4Y3HpRZMtRdxCwTKBZLSfA4b374y8vLzC73jJ
13199	payment	1726	1726	1874	1	1	4327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxtEyyiP9FnvjX3mLNwav3zE8EFXeEG8CXP9ucA1MeXTF49DC
13206	payment	1726	1726	1874	1	1	4334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDUcKEwSorqse7yPnTiBGgMDAVTREWYcRVw2XS8ADuYBzoXXX
13209	payment	1726	1726	1874	1	1	4337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpq1L7adRuZVubJLFbgFEqiQCnhutuzFPPifgTxQ3dW5ZFbUw
13218	payment	1726	1726	1874	1	1	4346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJyvVuCGEpLGdbYHdCehcBviGLGEBjC7hTftY8xZYXEsMBXoi
13221	payment	1726	1726	1874	1	1	4349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRTgz3uBm9KJPAyNYYxEVjn9VdDkTGk3Fz9kUvDmMZk3YoKME
13222	payment	1726	1726	1874	1	1	4350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPhj7B2amqcYco7Ye316N4PQfttjiSfKXwNn1NXfphKE79sYh
13223	payment	1726	1726	1874	1	1	4351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSE8NTQ6PjPwF26Wn8WJCQy7WmBuxkNNDZgaUstPsQ3R5ksEE
13226	payment	1726	1726	1874	1	1	4354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppQEGWj9rDyFTZQpXksNPHQYk9DUwaZbLKv7NtuFUYyFNVBpS
13227	payment	1726	1726	1874	1	1	4355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyeNysuEtTjGF9KE7RDPNoss3KjwMjtn4q4i7wk6X26ee5fDic
13231	payment	1726	1726	1874	1	1	4359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KzMq24ZyPJ1pFdRqy8Q116FjZpV74vUesBMkrkkBYdeDc7Cp
13239	payment	1699	1699	1773	1	1	5	4104187299982	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJyBaH9X3DQaqu5gvZAxaKwKFEenoBT2Zg2xCyow4AqgQw3L3
13240	payment	1773	1773	182	1	1	24	71064271776	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ39iPVoYZYaTEfUiNFtrC4ZZj5CdCWDqAgZwr7cnQq49fqwnZs
13241	payment	1773	1773	702	1	1	25	47376181186	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYbMegeizvHyjBKUa8AhqZ4ksveZsyfryT7WAyfsseadhpXxmUn
13242	payment	1773	1773	927	1	1	26	540774761826	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYc3XaoV6KZKH9RedqM2z3cDAcV2iTpDnT67tssJic3FGHWxkf6
13243	payment	1773	1773	1047	1	1	27	969063739836	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYaMNuDV4gyhMT2cYkp1rb1N2EopoKw3FYw4P2niiQd8LY4j1Me
13244	payment	1773	1773	1167	1	1	28	653846615226	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYhyyWnjdvyZMXTA35nusA2PvPE3cgtUNfqroYK2t6t6QjMaQrs
13114	payment	1726	1726	1874	1	1	4264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJS4SRBao5v9Qb5ZZRoYCGBNpUcnGA2wHrDh52kgB7eETXkH18
13120	payment	1866	1866	481	1	1	8	121715586372	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZocysyLuuNso2kWgEy97baCWDMX921dqgHTPWR8UNFWfuoZXfX
13121	payment	1866	1866	734	1	1	9	3688351080	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZCsYiWwCMATZuEkELRquSfzWLZgCuLdrU376FLeLXeQWVcUgzi
13122	payment	1866	1866	845	1	1	10	1057327315743	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYw8M87D1XTQQoe7gxTYwwgtB5vKXKDYqpGzYFr6d1AWaMpbKHr
13123	payment	1866	1866	846	1	1	11	1057327315743	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaDUSWppFmg3uCnvjbGA1jPaXN9jwjLzVnEqBRzo5VdxVFaVLAv
13124	payment	1866	1866	936	1	1	12	978516909538	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZNCRGVgeC1afBSyMLpobuVcVvCMGc2gebgqtXhAYM9AJzBjpHY
13125	payment	1866	1866	1056	1	1	13	1753493917952	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYvAGXVzZzYMLmd4XPtT3KGhmNj6FhAL1wbTvA9GxZ3sv5RgM9X
13126	payment	1866	1866	1176	1	1	14	1183117287282	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYtgZJU9sq8mEU9cXLvMDbHjzYkzuSwrg5NXVBFb8R7ut9r4hq3
13127	payment	1866	1866	1302	1	1	15	3296861517936	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZgyG5vHHRjktNsPqapJzpk59igJjpduCJWF6MbvGsMoN4kL7dJ
13128	payment	1726	1726	1874	1	1	4268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzt6FeqFYi7CWFA7gCmq85KKWLCEi2sYnZM8AFPjVyRcdmufnD
13129	payment	1726	1726	1874	1	1	4269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBshjQqu32PtFdM3LSPCTJZiVTyyyorZuSU2KN7bBr1Ft27P7
13133	payment	1726	1726	1874	1	1	4272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFkgRYYwFq6hCwigZgPBuKPSKVm4c2WRttjUEtE4qzRxoyp6E
13134	payment	1451	1451	1046	1	1	3	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYT7bkjuSdPgxZapAXQemVFccJDwV2g41B55UZnJqts13Th66eR
13135	payment	1726	1726	1874	1	1	4273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLNVuJnM1ov45eeN29wksZPWwGXD6GLCQyrfxeyrLhTeWfa3V
13145	payment	1726	1726	1874	1	1	4279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnispuXwt2vJyPg9jrMaM67xgZbz3mkL9HMMvJ4pwouLkJ3Dzv
13154	payment	1726	1726	1874	1	1	4286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27yib5okb3Cs5LxYf8TQ2dVwQgHFd8ai1t6YsaJKPmMEaBj6K
13155	payment	1726	1726	1874	1	1	4287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYanNzCyCy59BbJqx2z6DtnzyvYss7e1XrpSfQrWhziWtRNSN
13157	payment	1726	1726	1874	1	1	4289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT2a2D9ouq6tEXuuQupBtCEypf39RmeEbGFByk5D1U7bLNGxB
13158	payment	1726	1726	1874	1	1	4290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwr1yQZYzpvvvhg1tyvPMa6SVGngpScqDVsoQXdYAJPp2417N
13179	payment	1726	1726	1874	1	1	4310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KGXhJA2AfSVGGXEWYKtf18FUAhF7g9TngT7ZYWZaNpKre93U
13185	payment	1726	1726	1874	1	1	4313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEs9RYbiHgHASveNYiH1kxovM3ZZQrmwxT14bXuCJmXyehhxP
13186	payment	1726	1726	1874	1	1	4314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJLYEbzbKLdmoQQemgjqibKBkEt4akk1f81ZCozM66JtCY9Yu
13193	payment	1726	1726	1874	1	1	4321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDMqkUS1TpU3BMBqCdVqf7wn9ASBan15fJVA4fwT4rdruVkQZ
13200	payment	1726	1726	1874	1	1	4328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf2RSXwBGgkfCL39mw39tJT4aaRCJ5bEYtvyVWWqKv7CtXVJG
13201	payment	1726	1726	1874	1	1	4329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYRR49RymfJqQnC3XQQtqEwHJgZqy9sNYFp1Gygyra9gGZWeZ
13202	payment	1726	1726	1874	1	1	4330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmT8BiasKxrLL3FtumzPpHgsGL1UNND1QZwc1sB9oVh6mPZ4cz
13207	payment	1726	1726	1874	1	1	4335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2v4sBd1QUjcziWv6E8pXgfTuqyXZaDxiUMtpZ65ku3rtdqrRB
13212	payment	1726	1726	1874	1	1	4340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQG4yCWyCfSTfE6VMRPts6nsnUTbbgJtTBoRquh3hTPhwiPuzt
13224	payment	1726	1726	1874	1	1	4352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADXr8e4cySS399nJM2Q3rhg2jZ7woGX3L74MEquh7JFCX19N6
13225	payment	1726	1726	1874	1	1	4353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2V2ccJCsmrnmUTajqAs89Vw5KhmFuSLr51qLNt9q2MoUo3xp
13237	payment	1726	1726	1874	1	1	4364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bgNySn5xcPTjpPLFKtQgzPCXbeSX4vhQD5yS9RBetjaiQcoq
13238	payment	1726	1726	1874	1	1	4365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkapKNRzBhKGPJeVnnrWgSGRcsWZcgBwT9QtYmo8DRKyBSo5Wf
13251	payment	1726	1726	2066	1	1	4369	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXZmEs9Bev37dWEeCQJzgv1JRSsvHuCC8QTSUQp2eSxK9RTH18
13252	payment	1726	1726	2067	1	1	4370	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZikM8tp1SLLSfgj8oZdQXhZR6WMx6oThm3LP82jRXCWJv6uCty
13253	payment	1726	1726	1874	1	1	4371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXeUGEiQ9MCbusWAYiykKHJivtUi8zs99RzwULtXGKMNZX7L8n
13262	payment	1726	1726	1874	1	1	4380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPXVg2CFc27YJ1v1QTs8ZTukRhSLL586Ah89Q8mHTMgJRBcqt
13268	payment	1397	1397	1678	1	1	6741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKYeZ3u75VqLCikLsqPBWw5cihKxuWGkqHTgFMEH5pSWRRw2A
13269	payment	1726	1726	1874	1	1	4384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BzoXQWgt4vdY6S6PMC3Pp1yWGYhFsyG1eXNbVtgtuuksM8fS
13160	payment	1726	1726	1874	1	1	4292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsx61W1UUGJZuQQBBEwxxCtBDRUViMHMeipDxPw13bFFNjbie
13167	payment	1726	1726	1874	1	1	4299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWiNj1PuEsigfMxbFSQpcTev3XMJRhqvpJ1xDAvLwHxx5KBWL
13180	payment	1696	1696	1058	1	1	2	2769083740000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidyB6UjtqEMjSLN6SvbwJj9P2r5qhvY1ZvQafQwe5Gz6izx91
13181	payment	1696	1696	1178	1	1	3	4540771340000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25eDfNHtHeQGbYM19NiymZXw3qnu6gERQ2BKuBxmSNH78pQiL
13182	payment	1696	1696	1304	1	1	4	4540771340000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQDqog87bBZtk4HRL3EwWEPDA4Zf7ejdH6mxfhNVX9irLJkHt
13183	payment	1726	1726	1874	1	1	4311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUJyMgyPs5Ksrhb3xkcSdjEGNmjteefRB5MGWxSSibimroigM
13187	payment	1726	1726	1874	1	1	4315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8vBbez9Yn81ZmRJjvFGFzuvSBUgeK6Cod7qwJTUNc7PeqnJ1
13192	payment	1726	1726	1874	1	1	4320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CJ4uhDThPL7VQpKgrZ1CSvqmM6PcKsnumBYEgUtgUqCiNMem
13195	payment	1726	1726	1874	1	1	4323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsefRwf5i8SZxfq5PxSd3UrDcQYnDEMQRC8zsbGsQJPY6j6Uoq
13196	payment	1726	1726	1874	1	1	4324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmjyKVRqLhejeTSNt3LX7m3zEowby3c33Lf4iprdzwKnkvLFc
13203	payment	1726	1726	1874	1	1	4331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfh7ddtWiddX7JaNEQoe4QYCZqFkzcdMwfPPUQwYyncc4CMWKa
13210	payment	1726	1726	1874	1	1	4338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFHSKpfo2dzhLs7qDiyEZ5rcyotJ7mEWL8vMnzaQhzhZGkg4X
13213	payment	1726	1726	1874	1	1	4341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xGLDrHJWCQ3NrbnZ7ngJoAFZ2pxnA45nb2JvW3PkpqncwM2L
13214	payment	1726	1726	1874	1	1	4342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsHw2D7u92fnmh6vpkZ4aUmy8Z4CGf8H7PoTnqPVU91vYJdKH
13216	payment	1726	1726	1874	1	1	4344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCzJa9CAPonWQAh4kBTuRcfGmC5GNK7DNUN8oJmmZCZovPrUX
13217	payment	1726	1726	1874	1	1	4345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCdGQZpD6Deub9jkwPJ1DevD44pDtpN7kyS2wit1dVKPqegHj
13229	payment	1726	1726	1874	1	1	4357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7bx5Re2GsieZu4iemWj3xCkoe9whBjLBbULUAE75NMPVF68c
13230	payment	1726	1726	1874	1	1	4358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cNfB4UW9tSsGfyb5D47XA4VnM77SHZ7CmzKWH5ee5cPrYqpF
13234	delegation	131	131	1538	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoRcwfDYa4Tn7qTmXcgWs2BCorC6LTQQmfN6Uj13NkwU3YDzd
13235	payment	1726	1726	1874	1	1	4362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgxN5HXg7BBcFkuDBwZUG5ak3ywUUnaCHyUq2djUao5wBrzYe
13236	payment	1726	1726	1874	1	1	4363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzsDxMQPuWQMDiePgK6yqmpDNxWw6p3MRXAomRUmGNVsNq16s
13256	payment	1726	1726	1874	1	1	4374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyeWrHBtDPrFVGZyB9UgkhCrcEpb1hA48VFUtBNEwod17qrece
13263	payment	1726	1726	1874	1	1	4381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3rKB4GGvYQH9Y2H438682GYuwMELsKoh8LpzedbxhXcaQs2Z
13264	payment	1397	1397	1678	1	1	6739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmRwSALdsGXbicdjo9xaERD5SMHosJGrrHCnCJPxP5kPNT8vxE
13265	payment	1726	1726	1874	1	1	4382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppsstrVqe24cc9XEJJSHDn7n4YXbF6DxYfWWJUHzospaD4wSQ
13294	payment	1397	1397	1678	1	1	6753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHQCDazuuSu4Fc8GZcwjaBJD7bWcXXoYHgN9n4GFzGZHF1Hjj
13295	payment	1397	1397	1678	1	1	6754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvgasCeX5Xakf468CM4QNdsXWAn7yqSLWqT7jGUkgr77ENHdU
13296	payment	1726	1726	1874	1	1	4398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vc3RVsUQfhQu9sN4SkrpncB2jBBFPRaRCeecXCubfS9cQ5Fp
13297	payment	1726	1726	1874	1	1	4399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxF9ihV59ue4MMZwxPLGMcsdFPh9TzV8MhMFRUZDEkdoMqKRwe
13320	payment	1726	1726	1874	1	1	4411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetPtDDFbep6LMcWwANhCYHD8pYpskeYSz2MADc5qapbjjnWFX
13327	payment	1397	1397	1678	1	1	6769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1aQQnPsLRyvuRMgJ5vHMK5jvMHjvxXqDQehfnVEQWbTnn8P3
13328	payment	1397	1397	1678	1	1	6770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85nEdHSZYFCdLgNFMuweikBqhqDmJ1BAzfbkWdiYJGhHzFE2a
13329	payment	1726	1726	1874	1	1	4415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA4rvFevrrtq7gkobq22ysSNkstLsj2ZQfvVWZTyfYQAWibmu
13330	payment	1726	1726	1874	1	1	4416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1yCDSxo7kqeqsWuBuZVmNwXRkgPXLZWHMiMTPQuZczutEQs5
13337	payment	1397	1397	1678	1	1	6774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK434op98orBfrzkYYmrFksMdnDTgATcthff1eRd1X1oYwiiho
13338	payment	1397	1397	1678	1	1	6775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMJufmVjJaYM3CYvGdQJgMmqX4HhhDUockKakboTWyqs4sXpL
13339	payment	1588	1588	2068	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LZBUMt7qp2p6PYuxoQHZgt9pR5SoGnSQxRtTm86zrK6Xrqok
13340	payment	1726	1726	1874	1	1	4420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkVuBp7vYZvMX5Rzgf51D8kqwgGkRvEyG3HGvRTe5qZqZqkJ6
13205	payment	1726	1726	1874	1	1	4333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFoRnCLnAvz8PZMeXsZp4HqUxXGzmeGJrE8MLgGtMBZ2HtMRM
13208	payment	1726	1726	1874	1	1	4336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKcUroFYQfbqyguMwnZbSCe7SnShH5yVqJUb81zAsnFvjVUB9
13211	payment	1726	1726	1874	1	1	4339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9v9gUqGFTHAdHHp9cmxn1yz7DkpZxG126E3pht7st2UPV2aY
13215	payment	1726	1726	1874	1	1	4343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fhtFwxQgq9evBDdQb7j4gZYQQwg84FhMV79EJ5kGvw6Vv1us
13219	payment	1726	1726	131	1	1	4347	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZpdNGisy3tPLmvMF3DRphB5vDNnzCCskAZwLbfrEF3EXvnZUx
13220	payment	1726	1726	1874	1	1	4348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzG7VosjPmhZjgkSh5yAmMwoxftqaXgJupi51x4ZoajiLTqn2h
13228	payment	1726	1726	1874	1	1	4356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8rc15ARXgS3Y7f2Jd6eiPXqRsfYTdGmiU91iA6pn36Vec8wj
13232	payment	1726	1726	1874	1	1	4360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkdLUcFNyjohWsaooKeqVQtwiEvjM9QbiEQ8uGAvb5XczXqAH
13233	payment	1726	1726	1874	1	1	4361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJr9zWdVcvoWf9kFVt4agt5AwKDSk1zAN8SK3ntjzNxHvJgdr
13247	payment	1268	1268	1269	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjMgH68f27aiGo7z9pqP2oj8iUiSYumWnWnEeV5CL2yxvSybu
13254	payment	1726	1726	1874	1	1	4372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicaEzvBTnxME6ckKVQ7QPpxcEXpFJNYv4WHNBeNnz33pByfsn
13257	payment	1726	1726	1874	1	1	4375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkF2aGStUxYqo2cSTvxUCCQgHyekcpzqVCiqosgWpweoaX6h4A
13258	payment	1726	1726	1874	1	1	4376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9SAtikFuYXFDHCPxhZUZEyea8XJTinuUujUJqRoTz8PYk7mT
13259	payment	1726	1726	1874	1	1	4377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqakZZ3i3C7JvtJC5FWY5KRVHBVmUS9Ni6aiogVv3GNj42hqU
13260	payment	1726	1726	1874	1	1	4378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLVhFQy9v8qRsN8fpTA9Dfyy9An19FLaoRsgFNmbYc2B6rTUB
13261	payment	1726	1726	1874	1	1	4379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQVooEcNjXyRkEypbmpPJB7vRau7EGP9ABUJefEyFgMfy52bx
13266	payment	1397	1397	1678	1	1	6740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmbbLUbhB4tHsh4WwMxEJoJtB8eZnbZr47HyWnVmNREPypbK4
13267	payment	1726	1726	1874	1	1	4383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqeYaWaes8BXjKknqwT6nUHsfDqkW8Vy36nypnae3BQE7hY4c
13273	payment	1397	1397	1678	1	1	6743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn4fceEEmFJj9KLntzZquH7QqTraZY3Ve8QWyNHPcWBUmvzqb
13274	payment	1726	1726	2067	1	1	4387	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRQCcPujzQ8FRwaYpLtSc3FDeK4aJFHPiqRBTmWegQN6frdRfZ
13275	payment	1397	1397	1678	1	1	6744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj71fsuHLYGxTFw77oo9dNsusbUNhyTfKmgC4tV6KrDd6CeYt
13276	payment	1397	1397	1678	1	1	6745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvogmZkhcXpmQ3jpntVwWwxx35hu1HriXDwkiQY3MsLipPXCG
13277	payment	1397	1397	1678	1	1	6746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZkqPDH4wPKt5SB2K7kY3ngNPoAbU2Sa8Wi5vCAQwbp1YKs9a
13278	payment	1397	1397	1678	1	1	6747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZFbYfB3FFQYFGyBirm62z5SSBt8Qn71Pbhu1XdDmhYWQxwKW
13279	payment	1397	1397	1678	1	1	6748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoMdU8qRNqpkjqEyW7HPSWEtJsymQ5HXwQGPAK1q8ZQY2AMP6
13280	payment	1726	1726	1874	1	1	4388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSPev9HeMWUALSk6csCm6Pc42PRyxABRN1ZuoAyGt2Yz6bkNG
13281	payment	1726	1726	1874	1	1	4389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe5yS1qdAwzUVaZc9UM96g3onVvvccrz3GrcN5rSzuWBKgrDD
13282	payment	1726	1726	1874	1	1	4390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6V8XPQFuvAWeBRK2XjY8mbFweNy6U5LkZzHkRQjK93KSzd5Wh
13283	payment	1726	1726	1874	1	1	4391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpARENyDnD7CJKJw4CZ28kEAscCr4fMeXQHRu4B4Tp2h65cgYs
13284	payment	1726	1726	1874	1	1	4392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgVJLPmuPHfKQarw3yFBoUV1iFi9MRqkByiBVXoS3Ey1eJyUG
13291	payment	1397	1397	1678	1	1	6752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwHWj1zWPtzqoRSL3oycYyR3FKVPJzP7jk1phd2p7nW7ZnrhZ
13292	payment	1726	1726	2063	1	1	4396	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYpaEEp3gg7hbHKtMgbQZKypdaJht7QunRBRx6C6qvG45RGmL2
13293	payment	1726	1726	1874	1	1	4397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9418JMUBkFXqHbf6ps93NYA6y35biJeCTDfdu8W3Y8Rw81AuD
13302	payment	1397	1397	1678	1	1	6757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRtyiemgK9io6rtq9GXnLCbgow1rPmkxZ6B8m5RnWFjhtEJTu
13303	payment	1726	1726	1874	1	1	4402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUK7WwEfQZaqezdZ751mvYcvMPnG6d77RpT8jxudompqrwwbEp
13306	payment	1397	1397	1678	1	1	6759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQSmChhJx87hwLQP1pcPN5FyNgh1LwxRAPUDSHKXUeVe28NsF
13307	payment	1397	1397	1678	1	1	6760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWttX9gDKgXMHAeyxMSHmhAsNmMpTQeKvAxvfzBYhDor3uCEt
13308	payment	1726	1726	1874	1	1	4404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiokAZhsWUjYVsn8g9iAAKDxRHHN4xuFkjMyXLeRHJKLsY68w
13245	payment	1773	1773	1293	1	1	29	1822001730132	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZDHc8utpDQv4FxQzcG9gwiwWuNYLDW5jXPidLXBt9oHW4RGZ3B
13246	payment	1268	1268	1269	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4WhnhVvH8MTtKxkJqo86RikHAE7rtZTDAo7PE2Cr6atMdUkgM
13248	payment	1726	1726	1874	1	1	4366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6f3evFMn6efKTpFfnfYwkkqYkfD4acwYd3UwAeDCXg6MWVSfX
13249	payment	1726	1726	2064	1	1	4367	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYd5ujcR5yFqNH3SrjfsJ5kVMaYnmBnhPKEsb45ja15qPdbPB5y
13250	payment	1726	1726	2065	1	1	4368	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcgz2eEzYReWAKufLJKGyciTafwLDZ4YujAzojT59FEu8V6rEK
13255	payment	1726	1726	1874	1	1	4373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9NXgocB7paibahDxgqBg5os18XtrAZrEJcPFdgdE2grUBJTa
13270	payment	1397	1397	1678	1	1	6742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL6BwrNFq7X4QXdDjnwFjphTi4XqYekCVnRpDQawHoNUMnnhhB
13271	payment	1726	1726	1874	1	1	4385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDHb2PiYRS5E4NwKCzeZNsJnkb4PDUQzSkPFXXPCxpTL5X7WL
13272	payment	1726	1726	1874	1	1	4386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyP7pdGD5StRVoGWhK3HXLS4McUkYzWpyhecqZc91DFnwYHQJ7
13289	payment	1397	1397	1678	1	1	6751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfDmr6ADLXc7SAYpweWLRdxRM91a9jaRVHiSeDSaCksoxGWDz
13290	payment	1726	1726	1874	1	1	4395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajg3BH9c7DQtWfi91mUqzapKFbTyiRnxHfNmTKMdVC1haDHWs
13298	payment	1397	1397	1678	1	1	6755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22jKuwZ3m12BEL75tKC729BGzoEEKyfQPQACGBhyxdoNqiE7m
13299	payment	1726	1726	1874	1	1	4400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5dUEZcqNsur78XGtCrBZkcSCmG1nAkycWNazubBKMZbBWZtc
13300	payment	1397	1397	1678	1	1	6756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LzoZ15EkMNG2FfdNCo6khkpS17hAssHjbCHE5sdrM5YL6iMC
13301	payment	1726	1726	1874	1	1	4401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqchVSDhPgWF4fAyveQyU1fnVB47QxF7Z63kKHomxo94Kdt4xP
13318	payment	1397	1397	1678	1	1	6765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXEc7RrV5UZZ5pfwDM2fcqhPJh7i7VLGSP5zJPHyMsR5ChoFG
13319	payment	1726	1726	1874	1	1	4410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe5Zi2e32LGgvrSMWPdA4SXmDMn5njgNkGh2SvNYiygTteFAQ
13331	payment	1397	1397	1678	1	1	6771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcD93L9hj75FU6sKPNksmNMufuViQSQKLnSVgoz1ueXhRTs2W
13332	payment	1726	1726	1874	1	1	4417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QVTH8LdiMFHzjQaRtGmfYX86JJLkKLTiGiwcHNZXnFzLNV7u
13349	payment	1726	1726	1874	1	1	4425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirznsUykMG2GL7gdchRNthxzoWLskakG7DkhDgzqzufsuDjin
13368	payment	1397	1397	1678	1	1	6789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNX4TSjnbsd9xJXPgjKmdRjqJzjW5uFP7QWDUnkeYXCgi2pCcB
13369	payment	1726	1726	1874	1	1	4435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5r1mXESSyv6cS3gLq4Crwu68cg6WRq1ERWTbw1uG1KZjuKiMi
13372	payment	1397	1397	1678	1	1	6791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnFN7zqASkhKzQdnmH2gq2hZyZ7PNbWWSFkL8Q1hKvJ1KeLdJ
13373	payment	1397	1397	1678	1	1	6792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9ZJigAB9dhr2F2AqviA9mvkGYWKxTXafKJ1o4v7tBHdHodGZ
13374	payment	1397	1397	1678	1	1	6793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1116nKCWrAien3w8NvK3bdZrWNnmMGhCnEDw8nYbEHtJMJD7
13375	payment	1397	1397	1678	1	1	6794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAAPXANVXQGZz4iTNELF7cTgwp8Mn6u7wJNBx3Yveq4J2SbBn
13376	payment	1588	1588	2068	1	1	1	1000000000	1000000	\N	E4YbQnKcERdtgNgMBtTfKsAtCbUFkcaj42TesVhkJFRSLFj7gNKHz	CkpYvAj6tjztLGH3kYghhnaupBLcNT46T3rB6RgfDDxuub4UK2Dui
13377	payment	1726	1726	1874	1	1	4437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEDpNfBhEKJf6L9m458jEyWyfivTDpE5JZ62v5bFhusMMwBmc
13378	payment	1726	1726	1874	1	1	4438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3a3B321bisLGK8jyrmAkv7NEn565jL1jSoJ1PKefx26wJgUo
13379	payment	1726	1726	1874	1	1	4439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mU3NytM1XUN4y4CS8L4ibHcXzDd2cyMhtAf37532JDnaEMfZ
13380	payment	1726	1726	1874	1	1	4440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCemnDnWGuR7nWxmp6mFbmBAv9WkvtmZTAyTX8cT4FZKzoMhQh
13385	payment	1397	1397	1678	1	1	6797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4WqwCAa3ZZ38kuyRWaSrCteVdUNVq4fd3ywju6mYLRdYSKUE
13386	payment	1726	1726	1874	1	1	4443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBtKqQJBHrZMTg8cZDFrotPqiDor945AJA6bJHTAPo18JXQkL
13399	payment	1397	1397	1678	1	1	6802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS97wxNfYvbCfoiBo8etqQ9s7dHvLyaLkPCfwYMTS1fS2YnMs
13400	payment	1588	1588	1392	1	1	2	8132871000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZTrmqU3y3Q4yqX333kpp9c1dz2azmcVJovF5NmVfVT5icYXitA
13401	payment	1588	1588	1146	1	1	3	4325611000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYzA1UXT63Zvgfs4FwLbEmXjkGdBMxyZsfq661Ry3tysaYzQQRg
13402	payment	1588	1588	1266	1	1	4	2911662000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYQkqZeP8Xt15ZoaVqP4ZyZuYKCFRu1voSy4uRmjW32PXSQNA4w
13403	payment	1588	1588	1026	1	1	5	2413857000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZLNSTWoEiyf1TH693qXjV9dn5STZz4zLfeCfx4YnnNuMqcvEto
13285	payment	1397	1397	1678	1	1	6749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6DybtENQ8aR6a5QH1zHJq6n5qidkAq2WtGSEjGM2SVeYoa65
13286	payment	1397	1397	1678	1	1	6750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT42ZCRMPEkxxnXieHLoCZ568d41EPbbRFqnpcMmSffy81CD6
13287	payment	1726	1726	1874	1	1	4393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AUdU3dQDCATEAt4MFUUtSMg7QYqXfU1Dzt6zavczQA5iw7Ff
13288	payment	1726	1726	1874	1	1	4394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcsZnMjgHmn9xALwA7jMaW4P4V7DQPXsm7fT9jZADKmFtxr1L
13304	payment	1397	1397	1678	1	1	6758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFchh5HBu1aGYu91WMHgx7JMKShSt86E4aoJR71ysPzczc6zY5
13305	payment	1726	1726	1874	1	1	4403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYENMuvN7AZRANQkXis5DV2eCjikH6PPxDTB14cvRpvos9QkcF
13310	payment	1397	1397	1678	1	1	6761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G6uEpffe1dX9tUK2aPFwdqrW8F99tBs7aDtNXXgEY3T6pPAz
13311	payment	1397	1397	1678	1	1	6762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfu9FpqAPcvip4gnrinbZLWwLUqDGxcxdnFjbH118V6VvqDaRP
13312	payment	1397	1397	1678	1	1	6763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXeppBWZny8xzMju6MigZqkc9DkcaxNhpfn4cR8qrnFSXUrAD
13313	payment	1726	1726	1874	1	1	4406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUHWcKXmj4R3UDW9XCnh2mcxrxHcEGjwJp3skwKNS49YCVSzz
13314	payment	1726	1726	1874	1	1	4407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbue5ZXJAGkkugGeLHg3AfmqJjwwVsQnBxmkkKggJMbvu7yNZV
13315	payment	1726	1726	1874	1	1	4408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgJx3vR37bDmHoSaaBMeDrKT6qik5Rv8VEdJo4aKH91tniAaL
13321	payment	1397	1397	1678	1	1	6766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zWMkDpFJwwzbaZE8ojRdS8yiC3eNrLiDwDnnyUcPgkuxSmSM
13322	payment	1397	1397	1678	1	1	6767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMzQnmNU7X8pnKXzbPHo11WUmm4nhk8vAyWQoTHNHwUBPQnBk
13323	payment	1726	1726	1874	1	1	4412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9onDaLpyzePhgTreuoZx7WUQTDDtvuaF7BJ73kDpShR8beHf
13333	payment	1397	1397	1678	1	1	6772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW5EquNW4fbojtCUjASyYjuhyPKjprx48Mhr21q94HdU29LWG
13334	payment	1397	1397	1678	1	1	6773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LSvYqiAiDbu5heULuSeUWKwoozmwwkeP5kDrcWTQ3ydA1P7Z
13335	payment	1726	1726	1874	1	1	4418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbuYCaAT4vdLoegTtMbVs3g9sYin8APqzJ28s8Q8xMXhHQMrb
13336	payment	1726	1726	1874	1	1	4419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mk8H7JTzh2W9KjW4BW7ARbJCzCXBqZ8UGHMwQ782fAtSPemp
13344	payment	1397	1397	1678	1	1	6777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3WuSRE8A62f5hYFi5PH9Gq5vGZxUPYVr9T4K2t99DH8PxkUz
13345	payment	1397	1397	1678	1	1	6778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6d9gRokDzH2JsJViJuXRqTaKDodvEm5iA3z1CRUCRuHmkX6ih
13346	payment	1726	1726	1874	1	1	4423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9imPnqfV2TPFGarPT5wn15wASDyWXYD7zstxqL8EWZTPRRao2
13347	payment	1726	1726	1874	1	1	4424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4m2pDFKih6SspcMp5bHtg1Kw9z7f84vnuzuUDHRzVKiBQYtx
13360	payment	1397	1397	1678	1	1	6785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9FqDmEqkZs6U33CnS9wodoXoNj9j7ordTup5v9mmnfWFtw8U
13361	payment	1397	1397	1678	1	1	6786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9416gNpMWjeMwYzyQaUkme9m45JjVgY9pduwKM5dsbVg3iVu
13362	payment	1726	1726	1874	1	1	4431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGKFF9rtezmfhj7v1iA7YSwKLmiMgjsDaSAM8PhkjqYiMrB99
13363	payment	1726	1726	1874	1	1	4432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dFybt8RoTTVdycLwsSxf2BPE36vGzBCb4AnQzEahmjumkFPf
13370	payment	1397	1397	1678	1	1	6790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmumNjEduG1Tb6vhrQ7xUo9S3ucNMdj7B2BzdbyB4TWTQeoFL
13371	payment	1726	1726	1874	1	1	4436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wrxeXsBY2aCNvrrxavaxpkfNWubYTK3uLgg7orTaJAtELQMc
13387	payment	1397	1397	1678	1	1	6798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwjpd6pEy422CgPBxjNQrvadp3iFhVmbBwYvekeRzAo4H3xdd
13388	payment	1726	1726	1874	1	1	4444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aoWmJd4axMk6Nk3tVEUe3xPhMzTkKNfZ1hXP9BeYgrP6fGXm
13393	payment	1599	1599	921	1	1	0	2005440943484	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXec92zAvZwFobkuNhYY74d8BwcWHK5SPTZ8piNgYWBJVofM9a
13394	payment	1599	1599	1041	1	1	1	3593732988098	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JFrJy4KGXsRuXsTT3W8A3ZQEqafTZ2NJTMsUJnxC6BNfjPsP
13395	payment	1397	1397	1678	1	1	6801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaS9ojQ3zjw2i7CRSq2WmxuJRowkHAsChhvSUsMGUgRcoUtTqv
13396	payment	1599	1599	1161	1	1	2	2424763257268	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahhNrLrHd7Dn2Q7iMzsKAGboicjpzAfotsfpMPjELWerrJbdM
13397	payment	1599	1599	1287	1	1	3	6756818414302	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUZvtimkYBwRoKSFUkJp3WdaSXWrUDz5vEmMqdscGBJUmdiX6
13398	payment	1726	1726	1874	1	1	4447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTG724masTFV27TrRMx1jrMuEMsQQUSME8gQQcqNo9XHvJTzU
13416	payment	1397	1397	1678	1	1	6809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiFk7ZXG7Sa48Wo3iStsAxVj7Y29FHNS8vQptknpEmDoHGbfi
13309	payment	1726	1726	1874	1	1	4405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cvVy9PX8WFUa4ZmMruNwQWt7Wjenmrg8YWVTjExF6YkBXENW
13316	payment	1397	1397	1678	1	1	6764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbG9WSG3tYfgz7vpFMWgrrYc5gK2F9V1HbJG25XTo8BZPCdbLN
13317	payment	1726	1726	1874	1	1	4409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjw8cftFSSBWRSMFNuNKQwxBdiANVrrcrCtfsMbSDYg6D2dxG
13324	payment	1726	1726	1874	1	1	4413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoZNCsDbxYoQKs3adLHamr141hFkvctAZ7pEubyxzJkS96Z4k
13325	payment	1397	1397	1678	1	1	6768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikgHNRCCHaRoFZcVbHZMfEN45K6rxJac5Y58Y5E3cGbPUiFCN
13326	payment	1726	1726	1874	1	1	4414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuivghqRp4cnRX7fK1taVSVR3QjRXKyxRjEVVNg84FKNJrthzY
13358	payment	1397	1397	1678	1	1	6784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsf4SxJrDY1LF69QKuVqRkFwA6Qs93DvdykrpRDqUgMVLcFmY
13359	payment	1726	1726	1874	1	1	4430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhtmpX5SwNWZSWphTtAZeeFaXzaPR6kKMPsRPDfsDPvxoUz8u
13381	payment	1397	1397	1678	1	1	6795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrkKnnE5tkdCyzzALsPsZm7acUzkpAdRSSFDPY9qzBE2G7Twx
13382	payment	1726	1726	1874	1	1	4441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpGqido9wD9cH9uD4ZQnixjXKnPM1JpgkbccZJ4sQs96RjStw
13389	payment	1397	1397	1678	1	1	6799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBBz8F1VghbnWj2VpeyUJ5tUVwAUxPr2ayGPtCaSPcH5pmwy7
13390	payment	1397	1397	1678	1	1	6800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZUT1f4y3RrDozRoTaPaqQNjfQzJVBs7LKmDCE7vb4sEetJg9
13391	payment	1726	1726	1874	1	1	4445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1KYYvqt1Vb3DRupYRLknPPb2vhvLkf69xcXWtBaasNgAHxPC
13392	payment	1726	1726	1874	1	1	4446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpw37upEgbTM7fn9v8B747hZADVHVRHpYbdfViSx5wrM4Gid4
13406	payment	1397	1397	1678	1	1	6804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pQxveKE8DX8GkNbQErpo5BCgvX9BH8XuHbKepuw8WQD8HjUC
13407	payment	1726	1726	1874	1	1	4449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGftQbMwm5agHsKCuBBUwLqKpbJREdLQCnpWQsXyyarjhFiRy
13408	payment	1397	1397	1678	1	1	6805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7LeSarvYY2dphk35LKnYGo7pKeLDTjMV9gci7CipLPBKk53m
13409	payment	1397	1397	1678	1	1	6806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6AQahH8LsUUS1HQCvbEx49q7sX8bjWPgBjzgikG2BHHxb4nz
13410	payment	1397	1397	1678	1	1	6807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntXw46sJ62RLfwdhkRoSaHw1aUrP5UrL1U5HeD42AYGcZa9ex
13411	payment	1397	1397	1678	1	1	6808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK7rXHStqTqvnzuayraoKECDBFRc2o8aeVpRCjbu9maXddnSB
13412	payment	1726	1726	1874	1	1	4450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCXcNJCTRrNRJrC2hPNExubQeWXR5dJbB8Dr1xXByPd6e7d57
13413	payment	1726	1726	1874	1	1	4451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDuVXNkZGA4tHXnMRuJNcj33JL7JDwqnsGQF7iqBvNkcdSMFU
13414	payment	1726	1726	1874	1	1	4452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cNCosLF4Sv869UESoFvDQbW76JuAwQTnNNeh8fHkzV5dAN3U
13415	payment	1726	1726	1874	1	1	4453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YeXsYY38FDfVoHj24Ggz7toCBrcoXnHsM9yuz7UvvjHDqQAP
13424	payment	1397	1397	1678	1	1	6813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DHh2H94HcruKRqNnHV98AtLBpDRzZkCzVKntS5DxBP1G1Bkm
13425	payment	1397	1397	1678	1	1	6814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W6CLwXxaZw8LjZz5JrpkmoPnk6kChq7zXTNCR9mFS3urGDhW
13426	payment	1726	1726	1874	1	1	4458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtU3zqJSFvtC6cprEWKWCwD13BJPMNAhidYLHeZur81Px4oZy
13427	payment	1726	1726	1874	1	1	4459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAN3gdCFsJEafzru2P8rj9x37qaJCZbZ4eSnrFz6TeY3Yu4SP
13440	payment	1397	1397	1678	1	1	6821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcWPWvJ58EKcg21cEEj4KgfMatXp6WXENRdP8gqCzS49cGUdZ
13441	payment	1726	1726	1874	1	1	4466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tRRMMcE55dz7p1QiCYejPa5k9TK1jq2i4vhx6pogDCEsx35R
13456	payment	1397	1397	1678	1	1	6829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAJD85n1djNWLngMo3VJUhqUDViFHgN8BjNqcJTHqePdHa7bq
13457	payment	1726	1726	1874	1	1	4474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDV8F8FRbNz5nesQj4DiDw9652YTdtKksnhwqQLbUfsG8pWkh
13458	payment	1397	1397	1678	1	1	6830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGhPZTc1rx1DCy7WqksvWvhoWFywrYuwVBuQ3HSrGGEHKQ2rn
13459	payment	1726	1726	1874	1	1	4475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpmgTjxKnY999bYLrU2nreLak8x6bJMgHKerFqpRD4XSVeDa
13476	payment	1397	1397	1678	1	1	6838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj79q2MLwvhkto5RzJwbycdkspekt8JiuDuHtkD3eNnQ9NA8Xk
13477	payment	1726	1726	1874	1	1	4483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4aJMT41uchvryDXTkB5smU5zUMijidJcYYF1BbCeiQwmPkit
13482	payment	1397	1397	1678	1	1	6841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8tcew2kt9GyowSV5bct3jSCpN2kFuAEd3NJMxorMLJSeev19
13483	payment	1397	1397	1678	1	1	6842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNct8RiPd3KeKvaYmfs64guaaUhYhVGRgVncD2BF3phASujmT
13341	payment	1726	1726	1874	1	1	4421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6Rp4sA5vtquzA51hsVTGkEPjv8ouhaNPJP785EkFjRDsshMN
13342	payment	1397	1397	1678	1	1	6776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFryPmSR1KFBDZaDBVGRHJ25Yb769VQ95jtQZDqzZtTrVVsPC9
13343	payment	1726	1726	1874	1	1	4422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UvLtRzdtgvQuqrACcMbR1pdrfLj1GDUG7ZxUTKwBiAUJn6KU
13348	payment	1397	1397	1678	1	1	6779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWX9A15s1tMy7XWwpj5rDBn2ES1erfaVapQGjTrsKSsWZTSQHv
13350	payment	1397	1397	1678	1	1	6780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kVQJSb7T6Xm9E27BTMk3oTPBATRJmLSdQNy4kEPWDspGdhAw
13351	payment	1726	1726	1874	1	1	4426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRnyrEiYdDRpzZXSTTis3wgdjJefsbqarKe7Wro9NVs3fkzSH
13352	payment	1397	1397	1678	1	1	6781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTWhgeBeqa68kRkbQeEk6hbAC5nbv1nux6TuBuWtU2x51XhhW
13353	payment	1397	1397	1678	1	1	6782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisxWXZGxuh3WzGVkJqfvKfP3HjgD2Uuh7eYpkM3bC9fswLPjp
13354	payment	1397	1397	1678	1	1	6783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CsLBHwC5YRpxiP1AqLsx9iGaQg9wL9v4zxwxdvabjCFey8wc
13355	payment	1726	1726	1874	1	1	4427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDufED2Xd2J3j3L9rB9VWeMBqr6EpejbXfPRbNFhZYN2TH5CdW
13356	payment	1726	1726	1874	1	1	4428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPy3pez88WFvCjN4wsTnskx1wHyis4qiurhPZeHDZBcZXYEx9
13357	payment	1726	1726	1874	1	1	4429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMttDV33TX77ZuHdT4FZKTB1PHg1LKXsXyWbHmk3JYaWgRWir
13364	payment	1397	1397	1678	1	1	6787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCdU3PwiizpLCFWSC4WRNF7KsAXWhmNFRjAQyTMV2nhAJ3kRf
13365	payment	1726	1726	1874	1	1	4433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLR7o2Yne1CtMKMcTr8tV89uqbnbX7LUPJLFn1xCxXXARn3MJ
13366	payment	1397	1397	1678	1	1	6788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYioKuCGeAiQ8eiyhM4nmETaBrrZTHWd6NRpemsVXwYd5XzHk4U
13367	payment	1726	1726	1874	1	1	4434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uDwnT2qEAxRBTg6zrnDXac8rmJ7CrPFnbSrb2TKaPcvYZwTx
13383	payment	1397	1397	1678	1	1	6796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetEbsnrPu2ngZvpbFXPSgihFFQzwCnn32hVy5XqPGCkARQ6Bt
13384	payment	1726	1726	1874	1	1	4442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGizcDMPXonNx4BHUaiLGepbFBowf7563MUQcDQT1FvBqTFHc
13405	payment	1397	1397	1678	1	1	6803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgJu61C4UrvrhACEHcNxWHvzystyLwmQSSfUAacMw7T1DY1xt
13420	payment	1397	1397	1678	1	1	6811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCoWnDjedfU2YEh2LUUX4nYBzYkBxAmKRg2PZhDVnpsnSCf9o
13421	payment	1726	1726	1874	1	1	4456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZQbHTBvqXYxS3wwBXUp7cws1sAHXXqrjzV4vJNkR7W4aDvYN
13442	payment	1397	1397	1678	1	1	6822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcpsqZYujHTDuehqNBJz9JPHRMYSFroE2B82sxu327kmvff6t
13443	payment	1726	1726	1874	1	1	4467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqQUMQfLamNXzwfx7hk6XrdAQRue7oW8xkNkkPAKg9nnWVC1h
13464	payment	1397	1397	1678	1	1	6833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2FXQX9rG52udY5X9BmP9Bo6kqhtZrz8T7EEfzM8n1pNN9Xhg
13465	payment	1726	1726	1874	1	1	4478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs73FQC7KMC6WNhLxmkmzZqKekX76ETi3NyVmcBwQxa8of7Lsi
13474	payment	1397	1397	1678	1	1	6837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5BS8fE4tH5UFN6nSsS9Tn7TSQw7g1gnfDEwRzcrVRWq1Ev4X
13475	payment	1726	1726	1874	1	1	4482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhb9L8RDS54f8E5sfriVkJM7DySoRZszVFcEf94CRGdzoK2zYj
13488	payment	1397	1397	1678	1	1	6844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxetryYud2isHPrsyxusHbUegrHP7RpRXA4EpFQr2L8gGypnp
13489	payment	1397	1397	1678	1	1	6845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfdy58JtVi7F7iFYnp3V7rir2u38dUqjxyU7RGpaoNtwG9fF1
13490	payment	1397	1397	1678	1	1	6846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Ks4YSKdJfhqjfyzZbk8V1cxiRcqLuVKagGjCBi45am1VaqN8
13491	payment	1726	1726	1874	1	1	4489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dq4nNDmB8z1csmFiDH95EefUSv2FhtqjqWLHu7H6noWjWk18
13492	payment	1726	1726	1874	1	1	4490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkJy91mNyJhCNw5FFVsdSDTdvdV5P3k828n3FuSDttGz66Lvr
13493	payment	1726	1726	1874	1	1	4491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJSyCpRoUiZEbjwx17YLasDU98D62bchGVF4RVAW7JQP5bwBU
13498	payment	1397	1397	1678	1	1	6849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5jNYbzhbp22okd5XrdXxin2325FXhMDsKajUsp91cJLnSytS
13499	payment	1726	1726	1874	1	1	4494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXevsaGBxDV8mvr37HYmGavPsLYrFAienZq6sWZy6JkcAxCK3q
13500	payment	1397	1397	1678	1	1	6850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRC98KNDphZfehC6jw12n3X6rQ5Pk9GP78d36LnZQe1XUjzym
13501	payment	1726	1726	1874	1	1	4495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXXBtzpDJoBNi2Nx5rwH7iwWKKjKQMYxMwHxTnFa8Zm5T1oU2
13524	payment	1397	1397	1678	1	1	6862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUMnByCYqtyZ2JEDExJZ7AeRkfJUz6NLxFF8xaPZWRZkAYaR6
13404	payment	1726	1726	1874	1	1	4448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaqtCha4jd4b3s6UFPLZipJwM8RWWJE1oaN88xr7zsBRcA1id
13422	payment	1397	1397	1678	1	1	6812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVRPLzba34aLBs2CTek5Ff6hYzn2QXMXgLrRQeForLpvfMfta
13423	payment	1726	1726	1874	1	1	4457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pyWN9iuVvjkp9dPnLkCCsURkhHcjcWZYxy7YfTZoUPqnhG5P
13428	payment	1397	1397	1678	1	1	6815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY37PEdSMpVv4dyzMM7BA4eFC9VwozzHRR9RXtxbUbsd2nxJib
13429	payment	1726	1726	1874	1	1	4460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1i3Fjtd7HFf4C6rzb1UJhgF5zBiuPnXic1RVvhX9WAXtuXypM
13438	payment	1397	1397	1678	1	1	6820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRHD4RfkgsrmUj9EzXRj6N3Frk5snJQAMLMm6Pq31DhcC8edb
13439	payment	1726	1726	1874	1	1	4465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ad6MmvVQYTdiwpqV56iCAeGA99GBpDk5wzYbBaqqpAXLsL7m
13444	payment	1397	1397	1678	1	1	6823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62HAbRJMgbRu8rWA3r5DBGeRJH8JAmknq9UwipHkyw2AGWP1V
13445	payment	1726	1726	1874	1	1	4468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6sk1mA9Dwdt4oz8QJ72cxgg1KwE8RiUuT5JuXzSMXprnL9ZUH
13448	payment	1397	1397	1678	1	1	6825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGqP5TaDzULdf4LAhGYSYrv8GJ8927hkCGwmp6UfRnoQmYwSX
13449	payment	1397	1397	1678	1	1	6826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhTQViEUyPZFY9j1r1qvUnhcfi2UL398BnWDYR3ANSLZuguyc
13450	payment	1397	1397	1678	1	1	6827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6XTyhEwHtpUcpxZSrQtu5t3AApXmCYge5nYnpvG23TuCog6K
13451	payment	1726	1726	1874	1	1	4470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz85aQz4squCJL76ch3PmjJXfPuvj3pd42fLgjkLjcxWyHNZLS
13452	payment	1726	1726	1874	1	1	4471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhyf1nkuQuiDkm47Eu3LXxeKD3YdZzscEZ6rTLqMQWdK5MD4B
13453	payment	1726	1726	1874	1	1	4472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wdPrehVV14zEh9vop7HGRZgdgteJSPz5VAmoc2vLgqCq2kyS
13454	payment	1397	1397	1678	1	1	6828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaRGRsiuaW8PaQfxEAnx5USGsr5VzSrexbTmH7R15dhp2v5oH
13455	payment	1726	1726	1874	1	1	4473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYna88anVT1CQRY7TDHuw5auxwb9DEn2WfoJVA7Eiq83Zb2FAQq
13466	payment	1397	1397	1678	1	1	6834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf3w9HVWAtEWciujta739oPA7fLbRSP6SoAfWjpT7EaKy9rYG
13467	payment	1397	1397	1678	1	1	6835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrySCwNfJueLcEP6EixmiDayKDoP9oX3KmXFu2eQ9VnybBZ9H7
13468	payment	1397	1397	1678	1	1	6836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBowXnxtnZBYxrLaFmj1fty9ecuQryDV7wACQianN5MFv7h8H
13469	payment	1726	1726	1874	1	1	4479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbx7diebWbrtRvS54AbcrnSbHrCeqMNnKUQSw7HJj86Qc2L6MH
13470	delegation	1750	1750	1745	1	1	18	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Sd66BfFHR6Rc81i9Yb4zBwHvKCdixgQLsG8FQfermVmiAhUh
13471	payment	1718	1718	1474	1	1	8	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffUXMxYWwf7dZVBDkRCFB39VjR5qPAj3JLicYFPN8MjArMT1H
13472	payment	1726	1726	1874	1	1	4480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUz5muwRZCHvv2dfcmkuqLPorJniVv4A44jwxxbSqyjfjvTZa
13473	payment	1726	1726	1874	1	1	4481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYJeVcqhxGfwP5pMih2r1UW8iaK1AbiQCdvCZwDYgA3aVZfWf
13478	payment	1397	1397	1678	1	1	6839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16CaSXBdJ6o2RFgJYtZ8Tpsk3xQDgKVVfExmB9XqoPTx8VN1q
13479	payment	1397	1397	1678	1	1	6840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvWcVHBzw7i5aVAps4fpez2LFx9BNDXPysrJLG564sFK8xtM2
13480	payment	1726	1726	1874	1	1	4484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1Nn5ZKaVa2TpotwA87piB1eDj9ncQnrn9pArEDD8d6raPYvx
13481	payment	1726	1726	1874	1	1	4485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm49LivWgmLKyxaSAkaobDPa6Az2iYLQLCp4kMzEQKriRiqXFp
13494	payment	1397	1397	1678	1	1	6847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykWhQbZ33XLm9B6fyHZ45if3QstS29X8HKUYmCWsb5jm7RgGC
13495	payment	1397	1397	1678	1	1	6848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cjz2wGFsaZzvfuXSm1TLZtdo1TLgfcQfBKFSgBQSVNhhXYck
13496	payment	1726	1726	1874	1	1	4492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyREJiAj3xfT1Mbb9DFVEsJFmj11cbdJiV7hnkmtpkW9cSQeU
13497	payment	1726	1726	1874	1	1	4493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRfNJ7be57iwrwdNFbinNKqAwQWEkgYpNGAZ2Ts21MipC3UHH
13502	payment	1397	1397	1678	1	1	6851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5C3KmMb1aBYEpTFJACa1idPARDS9LMtdSYThEqarjpxv4CEvW
13503	payment	1726	1726	1874	1	1	4496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3uyX5HCyzRF4P5x75r6QdCUWbVvqCdDhxekMmEapd77h8f6k
13544	payment	1397	1397	1678	1	1	6871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7mqDEh2SBRDshhZFevJ2rtc9J6EARrF8TAEoPkxCiG3QdFkf
13545	payment	1726	1726	1874	1	1	4516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9SrhcSJLriyxs2Wj2Bt7Dn7Q6xDefD1D3qKXsnJGq7Q2HSx1
13546	delegation	1750	1750	1745	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidw6wZdtXfqCUNg8gJCQrbBcQxM5oWoMVA77RVfDZUUR4CrVb
13417	payment	1397	1397	1678	1	1	6810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZfmSiLS7HxkSSpfDiZHA9SouVrg7wh36WKJtLaqkzUAauoLo
13418	payment	1726	1726	1874	1	1	4454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxJX1r3dj2T2iYtqZ81iKmtsQHoNKFNLYA7Ym5U2XvwoELEog
13419	payment	1726	1726	1874	1	1	4455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDEHBWN1dpqqdoYzy8tjyLyFYKTbxW2FLABYDUCqiLanv42gs
13430	payment	1397	1397	1678	1	1	6816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1M12jWByuATh5SX3PRkQghpJ8dRoPu1SMREXRpyZoLzbsdUq
13431	payment	1397	1397	1678	1	1	6817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppaZ5NMn9subRDgDkmdwPyiyMNcHct5J5QHBAdKgNZHgc7HDN
13432	payment	1397	1397	1678	1	1	6818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYme4QHrz4EaSNpqmTXRcj1rcRkLKqv9pHCnGNWSiKDy3hH2kfG
13433	payment	1397	1397	1678	1	1	6819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAnGmaLxP4Lia1c1pXZkopyQzqga3b2wo5dkQubxaPPgth7Hw
13434	payment	1726	1726	1874	1	1	4461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37ftMC65pwTCVWVwQVoF46QEv9qmTMge7Lyj4GkFiExepX9g9
13435	payment	1726	1726	1874	1	1	4462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8hCSWaRueo8rAieLx1HvcQD9f9xwU6KR6i1rHCy7NgZHcryV
13436	payment	1726	1726	1874	1	1	4463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEWCCnXFu1AnucyJGnQQhoVwyLXHYWr2qyGu5hrhba6pcTdvV
13437	payment	1726	1726	1874	1	1	4464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHdDyJAtw1B8EEDK3Gwaq9kZBampSPMvLQcZt9SpQaZ8d1oDD
13446	payment	1397	1397	1678	1	1	6824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiHBgvy1th5Z7g5UffgcqbZWF8wsngt9MxZbbvnGPdcbCp87z
13447	payment	1726	1726	1874	1	1	4469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ74NkpFiEXfjeiMof6AVcWnbAhh4cFKeYEe4YuLwonhWPduni
13460	payment	1397	1397	1678	1	1	6831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirj96tNwCuT2x8DBYz9V4JsZE7mxLJBJs9wup6Ao2a6VPmTc4
13461	payment	1726	1726	1874	1	1	4476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDh9G19qDTkR1JrkZVVyYLD45k7oDnRSowPwzwRGrxoATZss7
13462	payment	1397	1397	1678	1	1	6832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtpmBEoJbJnTzEtGX8cv6B17XFvrNSLLC1syXrRtPzq8E7uKx
13463	payment	1726	1726	1874	1	1	4477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKPjanBqksXP1eRiEskZFDVzchNks61f5EFXr5jcMhJ9NZcGo
13486	payment	1397	1397	1678	1	1	6843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCk74ZrXBwpiRvre4imz3XkzXcs3tHpPWFcGY6ZWE74vfEouxY
13487	payment	1726	1726	1874	1	1	4488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5po2Yfb7hRnBjteaxWBx3px8U553S39gP8rpghosQK5pMmKr
13512	payment	1397	1397	1678	1	1	6856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aTDGrh24cPBjgDxAcQvKkC3Fqo3rdTz8zEYaN1XSpMCge3u5
13513	payment	1397	1397	1678	1	1	6857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYbz79S4LmzVf9Kpx4TB4JKT7NihpKP2KvHUG72rG86QHPzy2
13514	payment	1397	1397	1678	1	1	6858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFg8SD4dubTQovpWD5UmFJsv6bJLX66w4nMSKUzzSznWQ3Awp
13515	payment	1726	1726	1874	1	1	4501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRjLsVKP97KPNweuMowA2iDu5iq9CQMie6zTADSuDdXosir7H
13516	payment	1726	1726	1874	1	1	4502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ut1sCy3skpEB6jC7FrYngWQwhRFNYNCvmHNgUh5n8if1w3iN
13517	payment	1726	1726	1874	1	1	4503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMYwqHhrXcQJRUD65aqEeYiVzME4jAACuGXxSf91N2cKxGbZx
13522	payment	1397	1397	1678	1	1	6861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNorE8zyjhSBSLCQmY9G9e3RcxzNZTgsmLWASgq4gBYawYbRPj
13523	payment	1726	1726	1874	1	1	4506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5FeNxNEBS1xAqmbiMBC9yB5791zvvPAwqHwnsjdMVNGfMUsV
13537	payment	1397	1397	1678	1	1	6868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEj8BDu21hBSsp9P8ymnKcLDTDRAv7zxUZj7MEdz3zyGiy9Vh
13538	payment	1397	1397	1678	1	1	6869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6BL7iwpNFLQZ5Rn57xrCxjxXkWuwqnajLEZb74paTbc4HBBy
13539	payment	1397	1397	1678	1	1	6870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUxcX27CaKLVa3Jik8BSVsYQUSEtZRSNYaxREbVDYJAkb6ubh
13540	payment	1726	1726	1874	1	1	4513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMEAyF2h4tXJuRQkG7eeEBgUgHJc6iLZCtTpi8KxcXrm5dDx
13541	payment	1726	1726	1874	1	1	4514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTbmvCrcfCe4pmFReotNQiszK2JCWoqsk16XXvNuVJ64wussN
13542	payment	1726	1726	1874	1	1	4515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqvBuHiFKWadgj5TdyRphZ7uv9JqaFG21ar1fGUwEr3tcL68D
13543	delegation	1750	1750	1745	1	1	20	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvuzbaQySxsPsJtvjySnKhjYCW9CxB8BgU8HPwKTX98RPyQZFX
13550	payment	1397	1397	1678	1	1	6873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnx5CuV95zCP9kbEdFUTf5XQmkMSD2MExMg9Dy7aEyEhdw8YxK
13551	delegation	1750	1750	1745	1	1	23	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqMAXNWEymqCR3dhHw7rtxqARDQF93Fca8AqxFcojnbe9Bbvz
13552	payment	1726	1726	1874	1	1	4518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57GSGVx6zfdumoaqqyXgbcenmbGMfZzrid8MdTcN7MrMotEVW
13553	payment	1726	1726	2069	1	1	4519	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNorsajo5mJ1Twg142rqzoPzTWLb5zMmuDRqttnrh8BcfgActt
13484	payment	1726	1726	1874	1	1	4486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyPuFJcx3BFqZ8nQctW8oSULnMC1Uzm9SWH22kbBjLxwmoXaa
13485	payment	1726	1726	1874	1	1	4487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkd3gsouMK7sbvnEqm79MhQv1b8jUYFvyyyXDXoVMueuLjb7iY
13504	payment	1397	1397	1678	1	1	6852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYyBeecTVmbo9kTcUcJ61NgGk4K4aMUoDMHsfhLpua3pqtZYi
13505	payment	1726	1726	1874	1	1	4497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNK5x2ziU6wriuMDbTEs8dB186tk1dkboVM75ZazcJTF4zm8U
13506	payment	1397	1397	1678	1	1	6853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotfAUS3n4XqKqREyBaUemdfB54vG8RMUcUy55Nrhd9H4KzsuM
13507	payment	1397	1397	1678	1	1	6854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P9sGmfEmqHoMyY3AsyxhXDAhmViNGVZp9eFHU2YwcTKah3oY
13508	payment	1397	1397	1678	1	1	6855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCE4iVHbKx5Y7c7AY6UnQ1KyPFi5MV1cZtSna2wgUZbUtKhy1m
13509	payment	1726	1726	1874	1	1	4498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEGQLRpUR7W6chSZ2ny6BWUupgSbhqKYJAAzSAeEizC9DwSwD
13510	payment	1726	1726	1874	1	1	4499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobRfS2nJZxEAKjpDrR8DrTVShEZww43aWXwz1dnto3rxEco2J
13511	payment	1726	1726	1874	1	1	4500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSTDUokTceaznTqNBNpgCbLvGFfJ2SkobPDGDhwURMrEGnKLB
13518	payment	1397	1397	1678	1	1	6859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6huKj5kbuaXp2Nop7G4J34qLSXrb3Lv3chsBbvqDeCEvuq6C
13519	payment	1726	1726	1874	1	1	4504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QMbbskmVN6vD5GFHTQXPLBBsTecQQTXdDL8oNFL3H95GR2bP
13520	payment	1397	1397	1678	1	1	6860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSexAFyTL49pUNb95n8cA7KWCkqhvUdg4XfPxwTXBJn2m7HX8N
13521	payment	1726	1726	1874	1	1	4505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJh2FRFQRiLVr1rUvy9HXGn4EbQrUAnyFxHBnbCTXQbnbmhGvh
13535	payment	1397	1397	1678	1	1	6867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7oi9bpS22PuFR4VEE9in16cooHUfVGDMFP3YnDKdxZfhMGa4
13536	payment	1726	1726	1874	1	1	4512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7T4PN2iZ2PGAwEc93gCWsjDALsGfpgSiaH9BEvKLnfPBhZzH
13558	payment	1397	1397	1678	1	1	6875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsKEVbycJxTrRMKo5AhSArgQQShVFTGyAD1MJF8DD5hTncY1K
13559	payment	1397	1397	1678	1	1	6876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj8zEkrvVxLhnybGsHkQGT3mRAGkPLbKGgjiUMA3ueGk1vsnQ
13560	delegation	1750	1750	1745	1	1	24	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUDy6F6VY8p8Qft8qA9fkWtjLRuPdKL8ReR9CYM6zKJQqTmwR
13561	payment	1726	1726	1874	1	1	4523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvDhivwJENpxKUGngtEuGEuKeM96NG3G4YizKzjapcZkCDMqe
13562	payment	1726	1726	1874	1	1	4524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dBzwL57ouk6NmHa5vTRnCtt1paegCPNoBA3zyZCDvvxzQdep
13573	payment	1397	1397	1678	1	1	6881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXPngNhCTVaJdRKbUFBR7N58Yn1e5dd5H7CnnSz61xhx6HZLb
13574	payment	1726	1726	1874	1	1	4529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMtG3h2C4eDF8Rp8Hpq8jG9t5Kg35kV516t7huBBG6yRu2SzN
13581	payment	1397	1397	1678	1	1	6885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGxiAgNiJYdGoDB527mxvyeQaSfdxGXVQ5skBUEwSzvgjvFXt
13582	payment	1397	1397	1678	1	1	6886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBVETJc8oXdyDGc83NwEtCSZ3aok7pWPngjSujaSQP46uiVYh
13583	payment	1726	1726	1874	1	1	4533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5CNTHkNGBeuqW8wxGfk8L4a8pf4tfQbaMdaFGtDVqfYRaERQ
13584	payment	1726	1726	1874	1	1	4534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRe8kGjJdpjU1DFfhFau7BKJ7jkXdJ4BXjABv8So3CM9NHLAbE
13604	payment	1397	1397	1678	1	1	6897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwYUAKM9dmPPdvcdL8rB7vENxYRaJW6GRzW6uuRFKdiWJap8U
13605	payment	1726	1726	1874	1	1	4544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyNh4iKsXD9onUoupMRHWjHzJRxi5uwdg7Ga5dxHP37VTH1ps
13612	payment	1397	1397	1678	1	1	6901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3v7UhiNaZoFF6j7zVAad5krtnLLaCX4FPpLmPsJb59qKunAL
13613	payment	1726	1726	1874	1	1	4548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu3HTpUqFeKwJYL3Lzt6q6Nt7EARB3RfWn2kCRXbALrhThccz
13641	payment	1397	1397	1678	1	1	6915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xJcBZwvKGEfh4FxDGb6kW1DmKdXXP5LsqAJtwaiRZbP7jqz5
13642	payment	1726	1726	1874	1	1	4562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VGcDRafrQ1LojCxxnYnrJ5Sjduy7LcjaFDfS1g5V3Bw3jdCR
13657	payment	1397	1397	1678	1	1	6923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRJjXevggDSWRTggYeLjxvvAio8vYjq8exW1DKhQRDvPn4suo
13668	payment	1397	1397	1678	1	1	6928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnqZ6em9MoEPxD52oULnjVmD6z69YdrCLSfMqSiwzMW4nYfz3
13669	payment	1726	1726	1874	1	1	4575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYB9eKnEYtwi7RXwHPD2Ly4MvWQPzw5khvAUrSotJgyAZT7ATY
13672	payment	1397	1397	1678	1	1	6930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gr9yZDSnKUXGURXw9GCMC3QPNrUjmNtwKrHCUMcrswQLpywf
13673	payment	1397	1397	1678	1	1	6931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutaLXynB6n54qJiPQcEESB2SeKEcghW3tUhDAgKiLTjfCg95X
13525	payment	1726	1726	1874	1	1	4507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfxQqzDStAXCnnpLTPLszeJo4851doxYGrpufpo3NpXTGYXYo
13526	payment	1397	1397	1678	1	1	6863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopokUzPayQGhgRLRZrbS7ZZAN3V2diLVxoJ1VAaRYJp7KdYiV
13527	payment	1397	1397	1678	1	1	6864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZ5iwZxBfgZ2xoAKinamTGFw49LmAAPHMRCENcgVVc1fK8ZMG
13528	payment	1397	1397	1678	1	1	6865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgVjavN4mV2FB7NC3EPvBwiyuFRMH2MFAHtbQ18H8ACZF4wA4
13529	delegation	1750	1750	1745	1	1	19	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPS1ZYoXgtMmYa9FUuUxGNrVw8WgCZgn62t4EAqwrdSsTJE1zH
13530	payment	1726	1726	1874	1	1	4508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYSyEf73wU2YoStyQ4tMZF8ZKLFdWAdHQqBPQ2ibnh6cLxh5N
13531	payment	1726	1726	1874	1	1	4509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZohvaVWiCtndZuudSig71XyJf3KSR4hv8Z15SsTru3pELHov
13532	payment	1726	1726	1874	1	1	4510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fSB5VhbXZosiq3yFFCz4pQ5EbfQgvCvJWJLQ54En7mpsk7cL
13533	payment	1397	1397	1678	1	1	6866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9xm2vDAX7cP5kWj88JocYRYb8bdfDNLHLTAPHZxKybJ3nUpp
13534	payment	1726	1726	1874	1	1	4511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16YdoSTA8DhdJPt5wPXmRhbEy1m8fUoKEEjJahb4xAkeuDbpw
13556	payment	1397	1397	1678	1	1	6874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpWutcDYm7TDrvS2zosT3Tyih5Cq8o2Fgpw8PvBYtNXf5agmw
13557	payment	1726	1726	1874	1	1	4522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yKa8oC91NeNgzDguyfv9BfKMppzcEAzm9Ssz2coXYiXLBqwk
13568	payment	1397	1397	1678	1	1	6879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG9U8dCcGfUZtWYmRCVpSpStjTe9AbNYXLrDD7X5yKF4RjBPG
13569	payment	1397	1397	1678	1	1	6880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpSXWcuhMMbrYj5LPNemSmZGVWW6UBbcesqxSiFB5ZT6b9L4f
13570	payment	1726	1726	1874	1	1	4527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjfKF8Q1MrPYqpFX1BvmtZG8VpfGxiWJCGMzyM8FQaKKdX7gw
13571	payment	1726	1726	1874	1	1	4528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEBBvJbQbEf5V1SscrPpbJegvpJFYwuiamUmR5Fjvt4DQ4f1G
13572	delegation	1750	1750	1745	1	1	26	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURVzgnjUfXrYv3m7hkcX1g4T7JZv3QmrALUVpbBfmE4jHRkZB
13575	payment	1397	1397	1678	1	1	6882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8wqXJ4W1hKJ9zEct7CoxX8eprw7ZBmbjhVprdBeSVLgTSso6
13576	payment	1397	1397	1678	1	1	6883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooDasN5adDAKMrbyHHWDbosWE6Nz7yYgKZVo8s3aPa5iKcsVC
13577	payment	1726	1726	1874	1	1	4530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQFCmAgXABemfNKQzDszFtgT5yobabZPVgPkswqab7ZJqJwLz
13578	payment	1726	1726	1874	1	1	4531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BNny3v5o9GdhdVktVSYjxwYKTHhCiot1ZXw2J7wkZRU3qHtX
13579	payment	1397	1397	1678	1	1	6884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCMnZhgiykGKWqsamP7wQzdSB75P2UGmhZfrLTxdJjYT5ar2w
13580	payment	1726	1726	1874	1	1	4532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTfiC17LioKgBAjo871cGTiysY5TEVTP1EVRgYPN9J8G6nkML
13595	payment	1397	1397	1678	1	1	6892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeN7kZXpE42P9KdsGCxeLjx2TGJYcuxmFvtndZT6Hq8WyispJA
13600	payment	1397	1397	1678	1	1	6895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAY6sAKfritoN4GAV5WstC2DdUENfwsK2cQGZwpGvHMWEixNT
13601	payment	1726	1726	1874	1	1	4542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfzi1HWUWmB49vHjJDzMMnb9FrCRJkvRT7JheSFbAFM5L47DG
13602	payment	1397	1397	1678	1	1	6896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BPajw8MnLWst5UvnMBg9GbhVXkAeZs8sU97ZGouXaKyikqJS
13603	payment	1726	1726	1874	1	1	4543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6MYCHi8q1S95yzmbqcXWTdEUtFVEMMZT3Qj3U2VqVoRC44ry
13614	payment	1397	1397	1678	1	1	6902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGQgpL7r4uVwMUwCHhHgPKS5s6rKEAP5KmVbs31U4zixTJ9gB
13615	payment	1397	1397	1678	1	1	6903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YSi5A9A7dh7BDWHic9GaSV6Q68i3dSJKqPey2dFf9uKDET3g
13616	payment	1726	1726	1874	1	1	4549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJbbKx5FJu2YRgb8VRyteKg3Fgs7Y54a4ZBRmZaV68kNkEEhD
13617	payment	1726	1726	1874	1	1	4550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DW2qoRHYSeog5ZRMgUmFs5K4vpVQSg8aUwTKiifozJwzHT2Q
13620	payment	1397	1397	1678	1	1	6905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr591myUex6eaxwU7sckuWo1LcoBZtydMQg14cc1uVvCndxTBA
13621	payment	1397	1397	1678	1	1	6906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSpsLjJ5YTtTyZsG5ebmt9r2HCgSWKUEL3etDFzLL4xVSvLLA
13622	payment	1397	1397	1678	1	1	6907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNUXgz6CbVZx9AHT3oC3VcSsbPeB3gzDiVTtMWSbWwrSvwyT1
13623	payment	1726	1726	1874	1	1	4552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjPa8mFcDbKLmL92DDaeUvTpAQ9ApYhRDCFuvgyc6PxiJAQQ9
13624	payment	1726	1726	1874	1	1	4553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkpAyKqWartbRkGLYhhnygcBWowKfFrtvqdqes9nBZcsKsvrh
13625	payment	1726	1726	1874	1	1	4554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLX3198aXYhmpRtTm4m6RPb9boYjDYByoraQwKaQ7vT7m2CnY8
13547	payment	1397	1397	1678	1	1	6872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwaFDpBkKR4guKKXv88PrR37E4tskz1ssuD4d22e4gbCQNws6
13548	payment	1726	1726	1874	1	1	4517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXbrNcHf52w4eAxosUSqpTbwTMzG57vqLCryEDZaJK7Bq5Y5Y
13549	delegation	1750	1750	1745	1	1	22	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1hYxYt1SNbQuSxGA3txF9DxwNfaxqe4mT4bFHtRxLKpLMw3v
13566	payment	1397	1397	1678	1	1	6878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoef7MkEHmftjubuVnspdcNKQr7jCe599XpBSEeCpmnMS6BNJP
13567	payment	1726	1726	1874	1	1	4526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yCB3HLHsN7ySPXV61LX1B4721PHprJ8JtsgJep9b5CUG7e9M
13589	payment	1397	1397	1678	1	1	6889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3sjNSuRWwfo3noaMGsyVaxypAbezCAwUFPv53iueERad1DNG
13590	payment	1726	1726	1874	1	1	4537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyMvrCZZjGrAzUNzL6VtWaoeRmu5Y6R2aMSryNNc3yWUijVKJ
13591	payment	1397	1397	1678	1	1	6890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd57Z2kZtauGjez87t4eiVFM4A1RZsXPJFuXtGgqCAwVHsuyYM
13592	payment	1726	1726	1874	1	1	4538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZka8GBGpV54axZYMs2TKs9qTHq1s3S6JpvndRPTp86m4Tji6h1
13596	payment	1397	1397	1678	1	1	6893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLnBw2pj9AEK68mZkrHKR39qDH97bcoJ21oTzGfrxv3Hrt7fx
13597	payment	1397	1397	1678	1	1	6894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRodtTVuvwGwDcFojxce47Bsym2V2ujFU9cd2ifgDwx2mKN8fo
13598	payment	1726	1726	1874	1	1	4540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvoCQX1BHJtEstHoBXFsbp17Fjna459UQYorTPspA3syujKvr
13599	payment	1726	1726	1874	1	1	4541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6rHydM2p2bNX1F8ox2FJSTfZSMEnVfb4V2P5B6oBncQRZ4iE
13631	payment	1397	1397	1678	1	1	6910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86iT7aiV33X6CgKTKuJyaFD6zV1TsEwJ7vGoBWCcwRsv96Yeu
13632	payment	1397	1397	1678	1	1	6911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkwb2rYwTmgszb8q8BdmoDykjvEcWqphUdATx3gGFsHWgXYcw
13633	payment	1726	1726	1874	1	1	4557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWZx4fGvMprEZnxdPTUe3AdBHWoWY3CNFjLBUEqrP1UeYdTy2
13634	payment	1726	1726	1874	1	1	4558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSL35uL5WqzAXXi5gPhke5nX2KsGq78yoxK5xRJ1efEHV7m9c
13635	payment	1397	1397	1678	1	1	6912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9oMJSic6iE66BggxKe5Rs72uGg1GfP7fEZ9s5c9NS2Lh6DYh
13636	payment	1397	1397	1678	1	1	6913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrwSd7KsiyidGRvLMf5UKD3UJY8VvCUN27trS4R3Qr1YVdw9h
13637	payment	1397	1397	1678	1	1	6914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjeVF5rqG3556CkKBFYzKktRjBjXPc6Dv3d1uv8eaBHLyKfWt2
13638	payment	1726	1726	1874	1	1	4559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEEB1HkRfcWBqXj2SuDJaG5GtGPAmFTKgTaizpSUGhEkMUmNtk
13639	payment	1726	1726	1874	1	1	4560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7YAHvvNhn1yhhq4FWW8zWYLZaa1JnQVyhSMwNtPRqLKxbLZD
13640	payment	1726	1726	1874	1	1	4561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm4gQBAc8R8d9RcLwUYcdzrNP3TEMzaSAJxsCGWR2wig1kGPB
13666	payment	1397	1397	1678	1	1	6927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXrd1y3Q5Ah56Eo36ojzYj9K3UzdyHYhMz3XGjYBq1ZUn3pH5
13667	payment	1726	1726	1874	1	1	4574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj2nTecEutk3VykNysBA1ZCTNzVRVGi5cKvZjrc7pB7uhxweK
13684	payment	1726	1726	1874	1	1	4579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aTFT5gTG4ifTgBFqfCQZu4fT6FkxDJLrrKMn7TPGeX1eAoS2
13685	payment	1726	1726	1874	1	1	4580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ7erS3ErqBdadUCzQiJbA1DkKxnBgJRQvYPgE9xLFEA3GzhN
13686	payment	1726	1726	1874	1	1	4581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ybKM87iAybZEqCtfok93wXyLyA5M6enxgy2dHvHrbYrNrVZH
13687	payment	1726	1726	1874	1	1	4582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTmUgnr1yKWgAXwg6PgYag8nHYYri1MeKXkFj1QqigZAuVYN2
13688	payment	1726	1726	1874	1	1	4583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VKwHt9ojQE1b5s69yX6PW1kffn7hEtJ25yspsxW3XjS8wj5E
13689	payment	1726	1726	1874	1	1	4584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWk4zCvffc5Re1aeMjovigwRjdEaj1tE9D7det5CgLhUfsZH5v
13690	payment	1397	1397	1678	1	1	6938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobevW44ZSE5kRpHWkjuywh52f7upGj58aDPkB3HxTzBAJH5fZ
13691	payment	1397	1397	1678	1	1	6939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdptGStPMsXqSmH5cK7xymJ4HwBMubBPUEFULssq8rAhaZLfG
13692	payment	1708	1708	1019	1	1	0	1948895880939	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtE7zeVsmRXczoBDxFWvrFuYvvf8gSsuS5o9FJTmqj5BoEUZe
13693	payment	1708	1708	1139	1	1	1	3492404720511	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkg9C5t4JWoZKgkTAdzyCaParLJA31dLHYk4vW9ZVWRGGY8wY
13694	payment	1708	1708	1259	1	1	2	2356395056001	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnR6MsZDSJSq4hdbmdPVK5UMpFKbCj9Apu4mckt7JQFJMWhnTP
13695	payment	1708	1708	1385	1	1	3	6566304342528	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaw3HDhAeQuxjv3ByDQdwmq66qxEZQWhDQUMMPZbtqfk5p26a
13696	payment	1549	1549	1236	1	1	2	4079093000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4y8UzHmeu8KTS5JauVqSJunexkpsZZYAWsaeTxiwt4JcKZA9
13554	payment	1726	1726	2070	1	1	4520	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWh85u9e5rsserNcZ8cVUuN1aLyCAVZAo679zQW3ZHP28D33Up
13555	payment	1726	1726	2071	1	1	4521	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9svkSaSEdrsnGjfZEcKdQF7xcdsb9v5DTxWWWpnnkXKVLzgyB
13563	payment	1397	1397	1678	1	1	6877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmyCuCmwLvTL9jRDKmv4Sx1DcbH2XtQZ75DhKAFB5VMUvr2BD
13564	payment	1726	1726	1874	1	1	4525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhvAiVvBktqPCp9EWXooiw2GCj1aps9iXRerSsig8yFCUxBzd
13565	delegation	1750	1750	1745	1	1	25	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvyJ9EgPUMSemhqnKHUy6tbfXhkynGMz2TjWFSg3CjfwQS1oy
13585	payment	1397	1397	1678	1	1	6887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3akY1GWBTnmfvAXF9qzeUedXuLzm3Yf8TssvYBx4vttmvCpvG
13586	payment	1726	1726	1874	1	1	4535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHXN1yiykUKvxcPfMEyEJVMYRQmCJYeTixWDPSj6bXdCYm5Jc
13587	payment	1397	1397	1678	1	1	6888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iwCTD84fe2PNPUMEXKx2G4LvC25wo3c8ptxNeik9L56fw1Nc
13588	payment	1726	1726	1874	1	1	4536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNVf1bSHZsMu2b1EhtKTwtZmGDxtKupyffjXJ9nPZH4gaXcuMp
13593	payment	1397	1397	1678	1	1	6891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQrA3CupBrvu2ZXnU6vvo8LyD7kTHuGBSJZEfhXJ5eiTz1qUW
13594	payment	1726	1726	1874	1	1	4539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffvoZHuc3HiPybbxRa7jRBCtoDoJimwSbLCnFyFMGUJj47fNK
13606	payment	1397	1397	1678	1	1	6898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kQwCRswapdYMZ4ZeTi7SGXxQRQXfTqep9T7LsSSW6EoVZkcr
13607	payment	1397	1397	1678	1	1	6899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEATU5cqUJRUL2AJqRvinvfESqaeXYc9oXo6PHWZPAEVUpa2n
13608	payment	1726	1726	1874	1	1	4545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8ktprNgaZ988nCFiAiwYAtVeaiB28iwmcNdHYfoth93Rqo2e
13609	payment	1726	1726	1874	1	1	4546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWX278TnFoyYCH48pmeqKAkhsjLGWmtqK74bNzW1hprR8QJSS
13610	payment	1397	1397	1678	1	1	6900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhP6JXqoJG4fTbvxH6SFy3HYwSdijKkrmLxjsqGhTcWKoApZv
13611	payment	1726	1726	1874	1	1	4547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Sj2dY6JF2c5ckqJ6NkCgqcSwm4rTDNFJXLwmFGhJJUeRcLf6
13618	payment	1397	1397	1678	1	1	6904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfqsb54KmRNw9kX28v23QNvNJaFzhvAdRwdcGxgj475CQhjMw
13619	payment	1726	1726	1874	1	1	4551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JbyuYJH1XRziDaR5Vfs9B26qQj2sBhmNgHALso2wXFAj8G1a
13626	payment	1397	1397	1678	1	1	6908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEDawaU25zDTH9zu6PadgchNLahox9Fka9QShvDPhcaMWYRDk
13627	payment	1397	1397	1678	1	1	6909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVacHdqu1tAvzbbLnagPdXJPLshY4KGLc9WcXCd1YgmFEMpBrx
13628	delegation	1750	1750	1745	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3StBk4Cjp8C6xUKoMrMBYUodHY3ShxD7gAD3e6EMHRuu4w1CR
13629	payment	1726	1726	1874	1	1	4555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa359qRxMyrotG2m9xRh36xpcv5rMHhzuMAef3mkXeC5gDahWBv
13630	payment	1726	1726	1874	1	1	4556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQae7xfhZXQSDxkLy7cnepLQakST15Dq1riAVB8MKXMyrH7Kkq
13643	payment	1397	1397	1678	1	1	6916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrftiNUfzo7dybyv8jKudqnew1RgQXDjcoxiB4WJGHcnZJojE
13644	payment	1397	1397	1678	1	1	6917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdi5TQMeZfe2WtzM8dyPq2n4TkvbXZnWf23At4t1MocEYKtBpF
13645	payment	1726	1726	1874	1	1	4563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdvwPSHarYwhKVTnVPX82BhBKvUFnXehPhBGmvibDQbAdepyV
13646	payment	1726	1726	1874	1	1	4564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJxqwwErcquigmgKa9hAaC9Row6NWuEFbCzq3jk4ag4AZ9zQy
13647	payment	1397	1397	1678	1	1	6918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQzpYVhRZk2de47K1s7roAgkGW8AVQiM8zPuB9m1Lz1JZhwFo
13648	payment	1726	1726	1874	1	1	4565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyd7QXhWHP44mmcnzLQpfGLNEpoE6HCkoQf2CoUjjYS9o6RxJa
13649	payment	1397	1397	1678	1	1	6919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapmik3MLLJ2jFAXW6Dm1EwouG2cvarSTxAk4KzqrjjVtQw2Gi
13650	payment	1397	1397	1678	1	1	6920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQUj64tL6Fvn3o3vmA9XvLLBrsBBijY8qCwNnc514WNWiWw1g
13651	payment	1397	1397	1678	1	1	6921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTJ9UdQ7kBedJ4jC21uingUvPWFb9tm2MEVr7CUAmwSwsoVUx
13652	payment	1726	1726	1874	1	1	4566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaerUrNiDY4E1gV3TAxZGyctmqPQC3TrqwcPqiSQWNGvnFnYQh
13653	payment	1726	1726	1874	1	1	4567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72CBSoRzinVskpNASBTGF7DwbNnRV62FicitXvv8kXG7MiCZd
13654	payment	1726	1726	1874	1	1	4568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKuaN1c6fCAcqaUBjAZJZ1oxiLQPkwqCZmH2LjGBH7BdNkJkB
13658	payment	1726	1726	1874	1	1	4570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC8yWtezAkTKdGN88JD7uuB2EQvv3yyUgu47PQHCZgczKcgFb
13659	payment	1397	1397	1678	1	1	6924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTn8KVomH1oZQ2x2faUFepdB9MtWksUkPmGKePqTZEFWoiE7d
13655	payment	1397	1397	1678	1	1	6922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhsFLWPcatPqy15AZJztKpbresNW4Fyux6b5ZbFLVndAEv2xJ
13656	payment	1726	1726	1874	1	1	4569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZmgBwxbTpmXSxwkWRNNpXcsUM5RKo1QXH7bjdfA3ZqVgPwSx
13664	payment	1397	1397	1678	1	1	6926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdj44YTa6xH6nXV6KcSFRhB8ihrFggQSBJS9YwFMyvG72CG6vA
13665	payment	1726	1726	1874	1	1	4573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxAAuF45EmRx628jbiSbwseMZQkCa8mqYY5MAUiDE9e8Qnhxd
13670	payment	1397	1397	1678	1	1	6929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkYJsmBZPoKjYJuGUH8TQrm1BC7VAnfDfdhEpwbb3GtV66rcp
13671	payment	1726	1726	1874	1	1	4576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTKm92yu6c7WELf3iHKkSCjWL6B5XaND8BKSScVsvvHQ5ot8L
13709	payment	1397	1397	1678	1	1	6944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXmSKWpe3SGrE41GfkhSr3uSq2BMc7XxnfhrcWeu69UzW2Ls8
13710	payment	1397	1397	1678	1	1	6945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZLyw9gc4pkuJC3CFL2MjCF4MLjanYrtQZ7b3Hr8y2jpaZkKN
13711	payment	1726	1726	1874	1	1	4591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1jfyXdywjza8fN1RtRKvZCmAp9oYqDGsgqpnCd71ygqgTwxf
13712	payment	106	106	2073	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3nEqrtTdG2qeFYVvcJzCPoUgaxwMdjfCL7v9fkgXWUww8LTm
13713	payment	1726	1726	1874	1	1	4592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsi68tqphmsk4DNZBuofjtfyknUxALhhEQQoZXneLVqf5dATP2
13720	payment	1397	1397	1678	1	1	6949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCY21ZmmFhUQQSXTNzvWZYzzgVFdQbdKxYEJwx63ELLU6qPZL
13721	payment	1726	1726	1874	1	1	4596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2DZB9BbHkz7cgARZrA3LZnm8WBGQ7S1EswL7hoDipyXf23xb
13730	payment	1397	1397	1678	1	1	6954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhwmMv79HpcGDF9sFHmD88Mj35YoRWa5VabhRqKBQ4QQtNUwS
13731	payment	1726	1726	1874	1	1	4601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3N5qfrUy9yUwfkHKpdbwjQQCUKeMEzHbZ8SngGThxQgseL9Y
13736	payment	1726	1726	1874	1	1	4604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBG7QfEwZXykT5TyqJHhXDBznMtftTUHtpB4rW51KdC4nLFuK
13750	payment	1397	1397	1678	1	1	6963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnJkBcZ9SjAJxkC7hDvwardxRuFT2EYtRmRZswfkT4NRhw5MH
13751	payment	1397	1397	1678	1	1	6964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKsPvpGkECT3rygs2NBLkCfE3WXPyewJhEUwo4u5urEpVKp5a
13752	payment	1726	1726	1874	1	1	4611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhwJbJiNXMV4kNef7WJ7SwNJLSLtJDtozWVZfoexswfXQYncE
13753	payment	1726	1726	1874	1	1	4612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzFntmRsZR9LSjbyZUrofkS9nj8D3fJwUKiohYe5nW1j6qLxB
13754	payment	1397	1397	1678	1	1	6965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3VANqjHxoyCygopiy6wgKMygg3hVDibxAP2CFmoP82Tn4jqX
13755	payment	1726	1726	1874	1	1	4613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FQuF5NeoaCf5TxbgHqSH6i3oYsbDpfXiZ6Lu9fnCU9EQS8vL
13759	payment	1397	1397	1678	1	1	6967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyNdy8BLd5quAfrns3tnQuzpoe7BaZPHfNRPyP1WNUaiBLhUn
13760	payment	1726	1726	1874	1	1	4615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEGJkMhP9dPT35vDFT7K4fcoHZrL2CfkfaAnxo5fubjRtg3oA
13771	payment	1397	1397	1678	1	1	6972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmV86zqG52Tb3crJHAQmJVCxnW8LJZAoxcGB6w3xfz15R4mqDR
13772	payment	1726	1726	1874	1	1	4620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51QiJ9ucQUuy8rw7Nmk47M14AmYCywdXkoR4t5VSiroRVwjLq
13773	payment	1397	1397	1678	1	1	6973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKny9YsTuh3YP9SFPJnDhJxFVHnpeBESRbqdEBL3aXeyk7N6k
13774	payment	1657	1657	1344	1	1	4	7034120000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySBSWrbQnRkWK9XGbV6uTQHG8bVYXPNFAgkza1YHepC6zsnd1
13775	payment	1726	1726	1874	1	1	4621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyggrKCFNrc2z6uFRqCZTmRo5Ywjg5RfY4Nc3c1fPy8dY9FKr
13783	payment	1397	1397	1678	1	1	6977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywX6EsVtuT7sEJB5qPwLaRNCsxGoXbTEwffGYKAedUWedegZb
13784	payment	1726	1726	1874	1	1	4625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWgsQ35HP21aCemK888nGnkuCtgcwq1EAEstX6LZm9YH35Dxu
13789	payment	1397	1397	1678	1	1	6980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf5ZtBDXeA9v3jNNqpi3v9qsEd8gR25NNNpNpW18cgbzSneyy
13790	payment	1932	1932	1958	1	1	1	498000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrcErN5ZNtkaVuowfG6psbCujyJPXHG7ivYCKBUgzvcCYy7GT
13792	payment	1397	1397	1678	1	1	6982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VvASZGCvZPABQ5syXzCcfCTzMCy1cEXLWVt5u185skhftwN1
13793	payment	1397	1397	1678	1	1	6983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdDn7ixZz72rjrSwaGhDtvn4daTuJz9NStemeeicXvtYsKfN1
13794	payment	1397	1397	1678	1	1	6984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdbHYVh3ZatY85XUJUJ2oEjEQ7AJaNSA1nVkeWLw8KSdaSghx
13799	payment	1397	1397	1678	1	1	6989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgfGaJX95Pm1CzjCwaU7mY3KD7F3D3XtyoQHrt5amJac2BSeT
13803	payment	1397	1397	1678	1	1	6993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDPgE3Q45dnriFVSp5wbnsXfGn8BZe4NiiRapjx546D6YourS
13660	payment	1397	1397	1678	1	1	6925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwvz84iG76jTAeZMvWPLvkikf1BGwTrg2DUxxmKpRb6GMoC12
13661	payment	593	593	2072	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6crn4TSCMXZLc3QA5GXiDq2ScUZjWSDwry4eJkmDc6WJTDpU7
13662	payment	1726	1726	1874	1	1	4571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4Y8uzXAv734BaVw95p1nE4YQPnyntWWwbwKnJYbwzTM2rb2a
13663	payment	1726	1726	1874	1	1	4572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ocKoVoWCKUyyH5moVHpVi4rPHSLs976p5CT7js4WrEyf3i4G
13680	payment	1397	1397	1678	1	1	6935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4EqD6NpL1g58ThJf7xAmBq8ZDZ1iLuePqVnZSq1VckVZvv5p
13681	payment	1397	1397	1678	1	1	6936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnQrTtutPY5ZFQfWbmiKUF16Yj7K2FYSoQTGje2xy7ur2S3rq
13682	payment	1397	1397	1678	1	1	6937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEP5eoepSp4AfyLU3GAZuvS8XQ9Q5qiu22kSFp5gVyMGNZ8V8t
13683	payment	1549	1549	996	1	1	1	3373682000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3AnZgB2Q5nRjKHKYtRZS2S47pdEaabzq327kYQCNx9VKQRaD
13701	payment	1397	1397	1678	1	1	6940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8YwEmobLJpTQRZZeTkjiRYW28EKjx8vGqeZcESLWzCZCXTUV
13702	payment	1397	1397	1678	1	1	6941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywAzT8X7Fy75njSTVeJN1Frh5e32prbP6SbGTRWLWfc9rYTyH
13703	payment	1726	1726	1874	1	1	4587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARm8os2W651rvKHCpa6ghSqkd1zPdwpKETqiWcnbFt6LFjW5Y
13704	payment	1726	1726	1874	1	1	4588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMhYLaTJdhkuPMwL3Nve7Bzg492W3thCpRNSCjqbkx1gQt18o
13728	payment	1397	1397	1678	1	1	6953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kkFjdDsh1c5xX8cz4wxq6QNc7yffg5zmhVF8QBtszHwQBRWo
13729	payment	1726	1726	1874	1	1	4600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmin7owDKHtDoF7u6hF4vw6MK7hKEn1SLNUayCaB66Gb25Duxa
13738	payment	1726	1726	1874	1	1	4605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfZuH1mBmWp25y6Qs1n4CoXAKAA7ynarAhMc2R1pWjozhmjuV
13739	payment	1397	1397	1678	1	1	6958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2567VHWcfsCUMcbRfuPrX1ziErkM9yvvjqBL6rjsDCwH4dDaG
13740	payment	1397	1397	1678	1	1	6959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSz693SfpGCRbJn5ZPz3NwHdKvrQrL5DmZPYcYuf3mVFRRePjD
13741	payment	1397	1397	1678	1	1	6960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rjTXVshzWMeUXbY9QtnvzzPDH8oB7gCNn7CvjrqZrm9GcQwn
13742	payment	1726	1726	1874	1	1	4606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspnxXsnAsHEHs8sGnEY5xCrh5wJ8kiFjCDPG4wPHEFvwL5krA
13743	payment	1657	1657	2074	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKaVkxZYVmZMMUD6noG44X8aHVxv7f9v3RsyEdqjqMhUPWAfZ
13744	payment	1726	1726	1874	1	1	4607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5D2feaJwtgR9dgm42kpzcnqjfGGdQxSJ1rw8sAX4PeJTX51t
13745	payment	1726	1726	1874	1	1	4608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBt1djNdYcxu4J6z7p3jiKqpG6HZuwxfKwfNgx8kAQmg96kLr5
13765	payment	1726	1726	1874	1	1	4616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcthKYzm7BURrmkZYKuZEuJGCgNfCxoLLq6q4nz1uA9JuFN9k
13766	payment	1726	1726	1874	1	1	4617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44h4g6zu5NWb8BptWSTM2JwjivXWNvszYJP7YiG6eT5Exkg1S
13767	payment	1726	1726	1874	1	1	4618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GsNJoJMTFywsstz8cJW317A6Tb37ZxR1HDiirRR6mVthydzr
13780	payment	1397	1397	1678	1	1	6976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCY1pPJgYBvVyR7DHoZbiMEGxgruHSYuGB9FcniK1J1vhzu15
13781	payment	1726	1726	1874	1	1	4624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyadwyDczBtSfm9DWb9VgWNhF88fkP39hHcQtkMUNC9ddXGuE
13782	payment	1657	1657	2074	1	1	5	1162600000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcdYM94m9xv96L534dA6pnnHgH1VkWEYnDQQrPjMYnxXGY4TPK
13786	payment	1726	1726	1874	1	1	4626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KJqmK48wZArxSmDQrAK4PeCvQMvgwxUX4jZctwBqunh9gQdH
13801	payment	1397	1397	1678	1	1	6991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiB4wCaaRTVNWZWgjoHcnASaxfJq9ikf84BvtkbAhTT2pmp8ws
13802	payment	1397	1397	1678	1	1	6992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzXq2oJakYUXEJwFxAcBtgNDP8DanBFDWh5wmmTFwqYFPS7aZ
13806	payment	1397	1397	1678	1	1	6996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW11tJmVLsH1CCo14aMFAz5QgMvGWZYvTAcKXLC1bbxvQdtgmP
13807	payment	1397	1397	1678	1	1	6997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvo7Mhw3YJwasidPQxH4ePxVEVtrvAqECefK6xj7P7n8Q2TyrS
13810	payment	1397	1397	1678	1	1	7000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiNBazff7LbZLfo5Jv519qvwieVWsXHhQoVNU8SjH7NdfG77H
13827	payment	1397	1397	1678	1	1	7008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcx7pzS9fsnh65kQpfkrPknJAhwopo2ZKCqA1rfdJVgTnFZWh
13828	payment	1726	1726	1874	1	1	4636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyz3viAmGJ9xsQ7D78V6PrSpphQRMMCMd6QfMZewpnVCYZ7CF
13843	payment	1397	1397	1678	1	1	7015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNwzJBNpw8rtjADVnWbwhfXWgo1qdFKSXJaF67L58LM5ck7b7
13844	payment	1397	1397	1678	1	1	7016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ41q89JufriE7amsiUt9VJUC4sTqafNTsLGyWwdvxKBKb9np9
13674	payment	1549	1549	1549	1	1	0	1500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8qJiC362kMR4egsxSdZQN16NYEtsDLopLvhDuBuNSYCTwaJP
13675	payment	1726	1726	1874	1	1	4577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLWXbLGByWCC1nJAoaxe5VMha7Z7gmqvsqVLEyvdYqfMud4rv
13676	payment	1726	1726	1874	1	1	4578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6o61bvXZaKynCkFQn5gqGF4ST3fwjxzuZDuRhg1raMuoWfKg
13677	payment	1397	1397	1678	1	1	6932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEWsZsv3hkq4QvXA6tA9cjBwHfiJQYx27gJn2ydnJahdpHhNX
13678	payment	1397	1397	1678	1	1	6933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtSvohmEVYHGzchV3LEpWCJq2MjiN4mzvLgb3FL5WR3MtVWDH
13679	payment	1397	1397	1678	1	1	6934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8MqVYY2JUiYoUJ7UyCx2vparjnvyhHp1w41UComWvowNyHUS
13714	payment	1397	1397	1678	1	1	6946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fymYjY6kiUp55MHMfJ6ZsLjHhfa16uUyJAVk1bAQneLj4qKw
13715	payment	1397	1397	1678	1	1	6947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92RD9WyADZLdZ7cw1ap6vTJHZ1FDzXEyz4dgpcfPUg1gYBeaS
13722	payment	1397	1397	1678	1	1	6950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxWwwFB9pvqdV6sAfy4tzUXU5DfF57pNF9Ea4qd3UtFv9mwqQ
13723	payment	1397	1397	1678	1	1	6951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xURNpYBUYVLRokbUjSS8pdMnjDSKPqfxfpFKEH6PH5nBpkeB
13724	payment	1397	1397	1678	1	1	6952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmypD1saniwBh3EaS9XXxRC3YpYSSaZZa8Fi6KwyZFw3gbWF2
13725	payment	1726	1726	1874	1	1	4597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2D2JciasygyCj2p2CETPpzs3dugJkkpwdQipN5kdyg8q3bgEy
13726	payment	1726	1726	1874	1	1	4598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDedmCfTqU7gBunxvmU3K5CVGjFBkouCzioQFz92mw12svpGJS
13727	payment	1726	1726	1874	1	1	4599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSy8VStTnotKBjd3sQapfzSeM7LtdcetQeD4pZMvxgMUqJNnSh
13734	payment	1397	1397	1678	1	1	6956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SHXfq8tkS91Z2dL6oGkvdQxMNEjZEbsABHBYZqKgdPU6dXwq
13735	payment	1726	1726	1874	1	1	4603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnP8ef3VhF5chZNURNrRCud9vD6GhQK9C5VKhx1HAkEnsH1qX4
13737	payment	1397	1397	1678	1	1	6957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDraGYGjr6j72Gsn2Auw2bbdJA5o5Ynn3A4jek5JZYs4ZUikb4
13746	payment	1397	1397	1678	1	1	6961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbH4fHWM2oHDvFWPwfpmmpEj1yV9npgiDLy5Swvy1W4DZZ5cKK
13747	payment	1397	1397	1678	1	1	6962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9XnykDBh6Gr4L6jWLK2VAihBwEEjuf6rNGW3Hb8pzxxPAZ4e
13748	payment	1726	1726	1874	1	1	4609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGby3xP3Kgkc1vZUsba17gHg3zhrFaC1CHFqkFmXZrtYJjKJp
13749	payment	1726	1726	1874	1	1	4610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP12YtnzUTtVHpqpP6TPX1BRkziMGQLzoqA9UapuY8tMfwskvX
13756	payment	1397	1397	1678	1	1	6966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjnXoGY9degL549nzgDrQaoBecjYnQk2bZKCmE9z6ww3oY92Q
13757	payment	1657	1657	978	1	1	1	2087750000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgNRzxpurSPPscM2nkeay5Z4DyDJLSREYFKT6i5k6ztJVKvyN
13758	payment	1726	1726	1874	1	1	4614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYhCZE28JAGYnkZVcRjhDyphwWVdW3nvdAidRSpmvCspJdEAp
13761	payment	1397	1397	1678	1	1	6968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKp4EWAqMGBfRpE5L6RzjqSu3mgqFs54i2bDpaLneuAAoL67CP
13762	payment	1397	1397	1678	1	1	6969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfwH5v3iEXUCEGpPzfLdShxojfHmmUym5VSW7p25qndKvL8yR
13763	payment	1397	1397	1678	1	1	6970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFwqYjdL7tmnjidwBAx2Hj39YCHJr7HJ3y6HVsN1n39e8Rzcd
13764	payment	1657	1657	1098	1	1	2	3741220000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmGFstykNirJvA14a75kN88ee7XuRgCeuqpZAiCYUkcLLSBPx
13768	payment	1397	1397	1678	1	1	6971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPpePynauBwpdzUBr5QGsshnwyxsG235VpUmns3VG5Y8puTqG
13769	payment	1726	1726	1874	1	1	4619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZimfiNkSMici3Aa5fbS7PgZiyWc5muVadEfzNQWZcB27DH8W
13770	payment	1657	1657	1218	1	1	3	2524280000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgkN87js2LGjRjRpMDTBfMyz5kEWP7VwtybFZ2Rd2GaYbsZGw
13776	payment	1397	1397	1678	1	1	6974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8xMfE4qhzAXq5UtakkxSb7YWcR7H3kUf5g1X8HbQTKCD5yEb
13777	payment	1726	1726	1874	1	1	4622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGoA23LhpLmCHV1kuDzh7Px8b5fjXdBPacvFLF1MqUmoSawPt
13785	payment	1397	1397	1678	1	1	6978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVRtwpiD5vPUnk2VdFFRgawVXkdj98fvH7aDNHJUXWbw1rWCp
13795	payment	1397	1397	1678	1	1	6985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDk4YNvLibCGc3epFuBScKp2jM91tnerC77xC48ijxy46VQsE
13796	payment	1397	1397	1678	1	1	6986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCiya5EM3tzgM1bMZrk2gUgtiHmzhrtMdPXmvKwt3jAZ6zLe9
13798	payment	1397	1397	1678	1	1	6988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCDe2jWAvmv62aRWVpon6g5nkjvEQLeu2nBWtxTQSasADiarx
13800	payment	1397	1397	1678	1	1	6990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJiuEoiYnqrG4ZoFqp5tNgXdaRUyQkPxp2rZzodo7HN9V2oDa
13697	payment	1549	1549	1116	1	1	3	6045608000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLauHqVi46M7T5Bc5dVSkgTMvHDNXz32hKL8SVEBgPMQwexYG1
13698	payment	1549	1549	1362	1	1	4	11366754000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVMky8SDFktbf4RGUMJ39qcEBVvr9CevT6krdJwX3Ezdi8uh1
13699	payment	1726	1726	1874	1	1	4585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xgjyngsTjQs3dGNUWwHsUfHfhHG5L9eAraGiX4BYhjfkQBk4
13700	payment	1726	1726	1874	1	1	4586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YpEPu6MDJKUV6mXB1DAgi79fw8HnJAN5LDfisiCuyUCvwoog
13705	payment	1397	1397	1678	1	1	6942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8GdXYdhntxUmCwwoiw8at9wBWxdXWAqLikBgDo7pWxHnu9w7
13706	payment	1397	1397	1678	1	1	6943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4uC5oqbnBZayu5b1PwMzFQEWxoLMt5FZgkG3kUHAkcF6GFmg
13707	payment	1726	1726	1874	1	1	4589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcqQpSE2hB1y29BphnktUqvCvzF4jdsXae8zezTwoT7GDVfya
13708	payment	1726	1726	1874	1	1	4590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzivUtJrN8rwt4rJRicgFNPxEYcCUdU9nWPUdtndEAgxf9Td9
13716	payment	1397	1397	1678	1	1	6948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopBM9mdt45B4Ei74cC7qd4nVU5KkG9nZkBye847ffiS6mnefu
13717	payment	1726	1726	1874	1	1	4593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsxtgGFhsXg9V2TYjUXXSxRfd3XQHz2yniXegbkrGSXjF9hhW
13718	payment	1726	1726	1874	1	1	4594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjVPe3YqKKEp3ckPB3m27cpk61h35eTuqgRBFuUYosv5r3q9y
13719	payment	1726	1726	1874	1	1	4595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxp3By8d4h8HXtQTJmf47Ufc7GqR6pWtQDV6Fd7jvUu1YdteK
13732	payment	1397	1397	1678	1	1	6955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViMB3hzcJ1c3Wzh1kPx1QxoyukCYkpAgkXi7CyFaTyNjYMTet
13733	payment	1726	1726	1874	1	1	4602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZdPURS3j7MFumJ978FJCBWXt15sBUU9RJsrikyTS8mxYqJgB
13778	payment	1397	1397	1678	1	1	6975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatiHakSXCW813Cuq68xLtCwjtmLchaVTpwU85TT7AEkfjvLYg
13779	payment	1726	1726	1874	1	1	4623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QKKMWokQyP2XaEsTD6oA9x1iLPzZSELJ7YLvoHrm6wZmf9fG
13787	payment	1397	1397	1678	1	1	6979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWBhHHvo8e4D6Ubempy9PUwrvQEERqe2yaEWByihpM4VcBk9m
13788	payment	1932	1932	1958	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCHjZNAijrS7u99EXCFpNiYANsQr6has9WdH5Rof5RbFaijo4
13791	payment	1397	1397	1678	1	1	6981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCypUwRvmxiEhi2xNLNQRNfh6eMnCBkVSkqzMpSnAe5qMusfM
13797	payment	1397	1397	1678	1	1	6987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPzWmskiNGko7dEwrfF1QgKXMAuSJps4HYfeDHPg2bremLvDY
13804	payment	1397	1397	1678	1	1	6994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwY1RVaxWvTghdDbSuP5e3QuoCZkzFjtSaNpBm5wLLi38e2d14
13808	payment	1397	1397	1678	1	1	6998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTvBzsf97Z1SrUWwvFmFo2ASC9VL12jiUiM2D1LypAXBWgLao
13815	payment	1397	1397	1678	1	1	7002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWJ6thHbhR958fkjyTsnNNh38Z3cMaVQAyWLkJ6WmeXuo2ixv
13816	payment	1726	1726	1874	1	1	4630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9QVJ7eKqdWYv8dQ5MWarcNE4S9tQHeTXt21anJyWHsCXFvqx
13823	payment	1397	1397	1678	1	1	7006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CsjyJesVxUiDtTfoipdGVdRnF5jUF3y5k81J9YyvCHgz6CsU
13824	payment	1726	1726	1874	1	1	4634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1uCdLMggysiViWYbsLg2goNS69xxJqEysGxQkoD3xMHiWd9K
13825	payment	1397	1397	1678	1	1	7007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcB4H1fUCma7Vn4hhRqZh7Ljv5RrUAtqAeuJj3ZFw94Mrp1pm6
13826	payment	1726	1726	1874	1	1	4635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvc5tTNDvDGFbFLR3UEawguKcRd6UKxMtvHnMyfopvbLfJHtk
13829	payment	1397	1397	1678	1	1	7009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEqP1qNd7ZV9KtVYG15MhsRJt5ceBp2rtWQxAZwxkL4PPxzcQ
13830	payment	1397	1397	1678	1	1	7010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs47KLe8LH2Jj432XEFqaDTbzWDXeRW1SR5LkXUnr7yXAAJi1T
13831	payment	1726	1726	1874	1	1	4637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgcWxuTQamRJUbAdngMmLhM7YyX1z58R4YWQfuQjaXs6zYRbz
13832	payment	1726	1726	1874	1	1	4638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTn21pUAQeyNL8pVfUYi2Ajba6XToAsTKNsZxF9fVWAqcQToPh
13833	payment	1397	1397	1678	1	1	7011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUt4Qx9S6oJH4FmX96d9sAxwb4X1vV5sAWgyPL44Zq9Rvtjdh
13834	payment	1726	1726	1874	1	1	4639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpsMweGdbknPzJdaq6Zegg3BCJdcHp9YKwcDKWV3JWDMufTsX
13835	payment	1397	1397	1678	1	1	7012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ke5ixjbB94Sm73br5vEhqLaGo5wiYQxtzHP9tafPP3oHYcB4
13836	payment	1397	1397	1678	1	1	7013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggxLLX3uDbgovHii6DzgykmJreYUyfGTiSzH1AQy5zo98CEtM
13837	payment	1397	1397	1678	1	1	7014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCE25N7JWRJqprnoxxgJJ3NpBuprq4rcPFosRRfVBjirmgH1CR
13838	payment	1653	1653	2077	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhef6zXyDgt6BMNt1GcZy2GPiKd2C2wEJiK6ad3cqN7x8HFHJ
13805	payment	1397	1397	1678	1	1	6995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgyPHenSHu9rYwTPqbHqN7j7WYFDmQh3kiNzbYPkaE1m1gStW
13809	payment	1397	1397	1678	1	1	6999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqqX2DJQ7tS2LwQydpSMJSyzNbPMeNTarEXDyibYdLVsasUKy
13817	payment	1397	1397	1678	1	1	7003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQYE7onMkDa29oLuHfZTj8EXXd6CH8sogaYcJAqiAFZf1RpS2
13818	payment	1726	1726	1874	1	1	4631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r67QANebLM6LNaBFntfwPeUuZqGzktgNY3Ud2hNvz78Bsxke
13875	payment	1397	1397	1678	1	1	7030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXayH4uELDJmiexFnJWwfGgyxGvxqVswFVbNwJEKxPpYcb8ri
13876	payment	1726	1726	1874	1	1	4659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5FLfAAmUcnS54Gdko1aq83Aw8rq92WAvJeZEhuNzpoVGYvsG
13891	payment	1397	1397	1678	1	1	7038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwzHLEucRoQTFuYCyLtLvFZ4fHQmDgPXBZn7PU2iSS6FmyGG7
13892	payment	1726	1726	1874	1	1	4667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYeNLC9vXqndDfyFzxSu6KFPmTjcqUgY2iRTJJcYeKMgvL6bX
13899	payment	1397	1397	1678	1	1	7042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWJWUoKWwpktvnRMSrDwekx9wuFa5KaQNdKJrgjFDvgq6yqt2
13900	payment	1726	1726	1874	1	1	4671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhi22FQWe5dokMjHHGkYBUBsXZrbNQWx5dYYDdm1zUmLdSSua
13934	payment	1397	1397	1678	1	1	7059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDg4GsTkjWqJnzCdeua6Rxs3jPuVzLkQLWXwhZEYzgL1SLeLdB
13935	payment	1726	1726	1874	1	1	4689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4RKWbG2QQCdBTTV2wSKmiggMN9V8APA1zaDyX6CdzqamEqGM
13942	payment	1397	1397	1678	1	1	7063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXvxVjq29cMmxRKPLQhuuoFjj9dJfE7Qrp7jPztqBabVggEEM
13943	payment	1726	1726	1874	1	1	4693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8eZfQyh5g4ESLBPAPX5gZ3kehYjYmNZdzpBLF2szeiRiJWxM
13944	payment	1397	1397	1678	1	1	7064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsc1abmc6XmVn4pneLVsuWDPc6eLpKv8rZ8rms2Wa2AC1YmasD
13945	payment	1726	1726	1874	1	1	4694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eWsrwzr8ypBRu2fvzqMvxbDmUdNoExkGYDjcYTWSSesf6LyM
13966	payment	1397	1397	1678	1	1	7075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASAzuPzjQ6Ncdvo5YYMM57Nuhg8iMcBSwiVxbBbrmuNX5TQUW
13967	payment	1726	1726	1874	1	1	4705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56vtd8oRdSCpSSWCntphHGobUBpr4hP8R8Q7pukZD12akRzbq
13811	payment	1726	1726	2075	1	1	4627	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYu1P6FkNvS5we3eo1mJQTy5Tysr3ebJbTf7bTKBXFohHHSGoth
13812	payment	1397	1397	1678	1	1	7001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecCeGdqV2uxHvSbAhpLgm4NJ6VGnRvjN97dktwYKs9UQeFCuL
13813	payment	1726	1726	2076	1	1	4628	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLCXqAX5EDz7yHXxs6RQrLD4TwaMMLcWcm8ysCzYbC5ReViLDT
13814	payment	1726	1726	1874	1	1	4629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskHfuK7bNvEBnwAYJdJ3uZM3Fnq8qpjSnxKbh3t8hi4vxPtiv
13819	payment	1397	1397	1678	1	1	7004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZorqhdmt4th83AbNjGHqPLtbvV53CDqs2ytjpBD6WPKz1YDi
13820	payment	1726	1726	1874	1	1	4632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd4zaFcyC94BRaP8pfrFdiCmAFsVD5UUR5nMptPyZZUTx5ea1
13821	payment	1397	1397	1678	1	1	7005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopU4GEdx2k9A3tLWbnDAHBoVK7hh274KsgsVY9Mnjp8EsK97h
13822	payment	1726	1726	1874	1	1	4633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj5NPqwfaPxhvceRjNQVsGgkyboyiQks8BdoHrrx5w9YparaS
13850	payment	1397	1397	1678	1	1	7018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjXsTxUNKRG8RLQNR4gksF9LRkzf2VFAuHQwisy6rceDmTEFW
13851	payment	1397	1397	1678	1	1	7019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnReB4xHMFyJvhskbdqx4wz8ouSsHKcaSgj2ywqJ695irZGRA9
13852	payment	1397	1397	1678	1	1	7020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZ5GaaLxWwFudBaxUpnhEqkbtVLvTSDhLApsjtjaEaWZFZtju
13853	payment	1726	1726	1874	1	1	4647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwRBMesYmBjYoFwC3gYtBKRzV8CDz75tyxx1rFB1HU5qt1nwF
13854	payment	1726	1726	1874	1	1	4648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb42n3RZ2SJeR4oesnzcSRWopeZ2UmggW95LRxYEEEAEE183B
13855	payment	1726	1726	1874	1	1	4649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYZ5tAyeMaSLWcry1Q5S2mPS8wNMKyTmJWw7Hd4dgBTYm44fL
13856	payment	1397	1397	1678	1	1	7021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS1RXX1TpQnyp5SPKfaN84btT65ep3vgvaaqLhggju17JPTuK
13857	payment	1397	1397	1678	1	1	7022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyomtre73a2LVtGxfUmYRyJphsu3knjPBa7MexVFotJLJv44M
13858	payment	1397	1397	1678	1	1	7023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFPpEq7G8ZeEQx6vqaEY5CpHLtuTe6y3arJufzi7hnKnet9Ey
13859	payment	1397	1397	1678	1	1	7024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YxFU9rJCZVUC89SspQZ8FegjHtWieHLk8s5jgxXuzLXpSEdS
13860	payment	1726	1726	1874	1	1	4650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAETfH4T9t7DYtvpDELE8iD3kP8LoRcpKMJ4WKZJDfDV6ojafi
13861	payment	1726	1726	1874	1	1	4651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwUSq5xXCxn4LBLtDLx8e4wQzgKSofBWd2zEBGj7jfHuJ691f
13862	payment	1726	1726	1874	1	1	4652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYergprx5HZAzMs8yNesr9uSL2jbgY7U7ef2WUsuvTkMDsvjmX6
13863	payment	1726	1726	1874	1	1	4653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBv17qecRKxT7Ew5fYvjNQR4gmLYZcUeGcxeVpHTyutiqetfc
13873	payment	1397	1397	1678	1	1	7029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYe72VptrvLB3bbmrgGApNv21pL39ieZ3k37ugrYK7adjHzdAx
13874	payment	1726	1726	1874	1	1	4658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yCpRooopjXK1gBbJ1bbCzAHhaifdiKWVFgki7FPqJ3PpiMqq
13881	payment	1397	1397	1678	1	1	7033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUoUp3aAZ46xAMGpiaZiB6ZA2HeuwKmj4phD6DLJpUS1vSJAee
13882	payment	1726	1726	1874	1	1	4662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvURU4sBkfTyqiaevfMHfbxmPRCdogy6tjhdJMnjEV3vXzcEg
13893	payment	1397	1397	1678	1	1	7039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseKnCMqThke7gUXTyvafLixGupU9pk2TjQd6h7uvMdbxu9x1v
13894	payment	1726	1726	1874	1	1	4668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRioa1FaRfPv5PZqohwoBKyxL7ccJrCs3q1uLW89SMhgtNLmbx
13907	payment	1397	1397	1678	1	1	7046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWubjQ73izuoY3YEEvKpBkxpLQ3suuRgBFkfswSun8VQH6k3m1
13908	payment	1397	1397	1678	1	1	7047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFDsAu9n1VbnsS8onK2hicKKDQYhUiUEr8ukrREepupURCSpX
13909	payment	1726	1726	1874	1	1	4675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgExo2KL1nJLyVWoToEFX9DYoi2KdZAivUgYbcPS7anQUVXze
13910	payment	1726	1726	1874	1	1	4676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxA4KePaP1opgeu4PMiXkH8kzfcRN7V1TDeFgz9k6jTjTsn5YG
13922	payment	1397	1397	1678	1	1	7053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkN5r9VMsGMiS4yznmLMKKVQFV9YGRBkEfyLzQv86nFe4NEYY
13923	payment	1726	1726	1874	1	1	4683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyWzWzBhVSvQ52rAestVLd36LKXLwjuF4aHawFkKwqwck6NUV
13924	payment	1397	1397	1678	1	1	7054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnUXiNBHokoqovQ4syywEjuSsfsLvUdQ3qTdrruvsFKTzMhQz
13925	payment	1397	1397	1678	1	1	7055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYj4CYHekRmrHfUdGTYuU64C7PDu1HoDidGHYHekxBYYfs7kCM
13926	payment	1726	1726	1874	1	1	4684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCg3t7Ymy7L6MPohvFif172zxBoGra3xMMKi9Re99vRav36Vc
13927	payment	1726	1726	1874	1	1	4685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpz5HDk9LacLiSJEPzbPw8RA5EC7ZNm5RXDsxgNC1xSzqViiA
13839	payment	1653	1653	2077	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDe2Lv477CiR9jXV548qwEwYWVmexQE5m1xW6khsevaE36kTx
13840	payment	1726	1726	1874	1	1	4640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aAvwML7umRbbcAEw4CcWdJAxNuJevvUuxSu8AAyFZyfeCqK1
13841	payment	1726	1726	1874	1	1	4641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVJ6aJcTijyXSSaWVgDvPc42oawutrFCdL1pgQYaQcTAANVq9
13842	payment	1726	1726	1874	1	1	4642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdn9QQDLijYorrDPhN4A6Nfc6hJCMhbSJvyai4p4C2NJjbPpM
13883	payment	1397	1397	1678	1	1	7034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjmsY4dh7tHNMqLSZi2JiGLMkepmNoeys5MfTvPKqzMCBpcHd
13884	payment	1726	1726	1874	1	1	4663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqhhyAzYrUWddvYYkHPGFdrBnV4eJ4h5vprC6bN4ziNt35m33
13885	payment	1397	1397	1678	1	1	7035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGSmYH1BX3AwGUaRe7vH118FnFh2Env6Nm1yozkeabgLKfrxC
13886	payment	1726	1726	1874	1	1	4664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfJxCpb5SXBNyCKbs7z6W65guresJHdxg9eH7wYqmc7JkAamF
13895	payment	1397	1397	1678	1	1	7040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uAAzLwMtj1eTEdnbgaWVPvtuph9ga9TehATGbFHc3vXbNX4h
13896	payment	1726	1726	1874	1	1	4669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzunDX8LRytbhErTvubUMTkHE9WMyxp1AbCJZCyVJBRdFUpe7K
13901	payment	1397	1397	1678	1	1	7043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyb1iib198Q621Af9vt39nxq7ainwXW3VSKvTDMz7FbbQvENg
13902	payment	1397	1397	1678	1	1	7044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VZ7GYStpww6YKAuiepn7qyA5r5Ltv3qiuroyESsngJWiYeeZ
13903	payment	1726	1726	1874	1	1	4672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZd5eTkjjTqxckknqcVZXEr4md3JiziqnxaYiJuBHMWzqDjfu
13904	payment	1726	1726	1874	1	1	4673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXxExMbrjW8Zi9GWy1qnXdvuiQgzuP7g5a4yqV5p3yJLEYXV7
13930	payment	1397	1397	1678	1	1	7057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13ovcFcMJmE8rrpEVuNbrLtGAyXAPsFQVrjcAnF9fVZt7mgNt
13931	payment	1726	1726	1874	1	1	4687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk45e3afBG8PWXk1NQTR9HmPnzte3sQ7eQXURmW2BPbaxMgbte
13932	payment	1397	1397	1678	1	1	7058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfokGq2HwA9aWTiUdwAxgrqrScXz8Y2iqeSkVhdoEHAW36Z9D2
13933	payment	1726	1726	1874	1	1	4688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTiYgfDeypn7ZEsVNcNKxYCi2dmV3MY46uoUvJhpSwA9rbAvL
13936	payment	1397	1397	1678	1	1	7060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyDS8cq9VqBrWwFFCrSgNMk4ydH43ouVbhhUPh59VtPmCHTh4
13937	payment	1397	1397	1678	1	1	7061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BaZoCrYTkymAXxeagG2BFa5De1ChGDnaMiTnTpfnpAYeib8i
13938	payment	1726	1726	1874	1	1	4690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsjyapDEoAshgWdr6XY26Pt1mJBd3sScfv7gtC2XED5yWALSR
13939	payment	1726	1726	1874	1	1	4691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMptD2QGyZuVuY1wgLVzzDzGQpNALFuk6pnQYfRjyiaPfbxsC
13940	payment	1397	1397	1678	1	1	7062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56jG26VahVdEHRxyZR5KGZv7tJe9TJR2hevC5Qtj9soRQbfxH
13941	payment	1726	1726	1874	1	1	4692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvtscnSHyECTntqByEunh2AYmTFdjRp36YKmUr6D7xNZ5BvgE
13946	payment	1397	1397	1678	1	1	7065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA57mvhGRA8BitrzYifFxThMYqVPNCRoPyh3ooZa3zkS9JY2z
13947	payment	1726	1726	1874	1	1	4695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRLCocPKPwT5a3uFnw9YXSk17YNoToubCgL3pbgqQv67BS1dD
13948	payment	1397	1397	1678	1	1	7066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5D9zA6XLoKwUc3gLPSs8DkdB16XgZLN9pCM8xgY7JpVEUtwNr
13949	payment	1397	1397	1678	1	1	7067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvUDbw7NRgBHKJCNDxR7pGeghSzYEMatUsS6ubFs9f4o7tbxN
13950	payment	1397	1397	1678	1	1	7068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eMS3R48GwWZU4adnWVawGDGnCfvnzVqZT41ishiUcR7PhnLZ
13951	payment	1397	1397	1678	1	1	7069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAq8SL4LTpsCnNAYCPMTxMopTT88kKjeeNsgWbq8ijkh9wPpcD
13952	payment	1726	1726	1874	1	1	4696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEXGFJuwH1EUqp5HhKkHQrnMgxvuS4k1xC3VaLLahZPSJKBAA
13953	payment	1726	1726	1874	1	1	4697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMcaqJ3QNRsivnzgvcFcT4Xd3uDL4V4D4NNk1hwranyG1RdBQ
13954	payment	1726	1726	1874	1	1	4698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBrKcP17SikcxPWYGsumhzp751KeuFmTEA57sgorHsmT2TQhd
13955	payment	1726	1726	1874	1	1	4699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhVMKSg1yncyULjdxkEkFuPtep4hheNiXrE6AF7n9n28YboAe
13845	payment	1397	1397	1678	1	1	7017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGsVHE7EpvL5xJMFwuh8zELo8vpKz196AF4bFsGJF7eSyiMFX
13846	payment	1726	1726	1874	1	1	4643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BQMSbykpuhmWBor7MqKpGKvivQinAjkFcMCmiroQbPRCuaga
13847	payment	1726	1726	2078	1	1	4644	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCb7NPS7GfhnAuawVMD32ronTMSzEffB3fPSVC3ioczwx8JfN2
13848	payment	1726	1726	1874	1	1	4645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1CwYenkCrGg95Db5WeXPjJwCcatwAE1GMPwEJHJuTApVJ38F
13849	payment	1726	1726	1874	1	1	4646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjPidW7VYJmNHLG9FVgsqLRk1fi4dvQ4NPw34F5tBZw9Gkf6t
13864	payment	1397	1397	1678	1	1	7025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1btQfdCEJdujsrvqYfoWvpw7xTMxn6C4bGdGHXiLKeX6d7rz
13865	payment	1397	1397	1678	1	1	7026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFp7cvEncV3Aqi14rfUiKb2SkXDdcCPoEBRYMf9RYRTmoE4p3
13866	payment	1397	1397	1678	1	1	7027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjHu8Y7xTfVE1MXEyMbLoseRUSGeAgR4TVD5FE2gGso4pEqR2
13867	payment	1397	1397	1678	1	1	7028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XxDJvtMwKKtg8A2vQhjTCcHvn3Q7ucz3tPX3KJfiQj4Ke7jZ
13868	payment	1726	1726	1874	1	1	4654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMVa6LQ1dbT38heiqZVUwgNKcy89uCbhDb8tu14zCzovzrghY
13869	payment	2044	2044	1816	1	1	0	0	1000000	\N	E4YtjMQLmo4RKeHKVCvU4CjvW8hYLbW9ikY1oiEYsU9YgWzsdTBnA	CkpYV7P3ZFe6RAqXT9gHmDvtGZricxVX62qvJEtnVuEYr8oB3QKH4
13870	payment	1726	1726	1874	1	1	4655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSJWKDCPsQxpznJ7hYGHiMKi5a8k3Ki6JeufP51tWq5oofUjZ
13871	payment	1726	1726	1874	1	1	4656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdy6QDgWUMxMZor4ZKZnjeCZBHAUqcgaxJCYsctY1oC5j93ekk
13872	payment	1726	1726	1874	1	1	4657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuVonJamCBjmSrTMMqMEUGn4uS8RsME27FBwEPRDcZ5joknAU
13877	payment	1397	1397	1678	1	1	7031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWxKUGS3PkYTBVB9qmM1DVSKGh6dcqWS3d7A7vdG3rqykHYvF
13878	payment	1397	1397	1678	1	1	7032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAJdcMB64PyEUNxkybcvT5i2g1fBYybNh4TrdGYvdSfaj8AGR
13879	payment	1726	1726	1874	1	1	4660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPYmTgwBPBoQjBSV8ZfXy5fCiHSRvAYjHaQpdPwSy6QWdse7m
13880	payment	1726	1726	1874	1	1	4661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmYmz7fT1xbo4yNWk3gZg8XVadmQxtoocXNUZwekLHWxYNjdF
13887	payment	1397	1397	1678	1	1	7036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpAvPvRNqe5ZTUfHiUFak2ckA6CBbrkqAM3MbxYdKrBbUjzfn
13888	payment	1726	1726	1874	1	1	4665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7LPvivxhWNBRejsMKVBg2Y4EMtU63ab36p1CJT97ATPFrP3R
13889	payment	1397	1397	1678	1	1	7037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFvcKwcSpdgvj3x2jX9Jd4Wigit9tZ4cv8b6j3MPNqFyPeokU
13890	payment	1726	1726	1874	1	1	4666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxacj1VySmfdLkZYpCmE3HsAhnwxtTHpjJKejxyBMhoFNjE2t
13897	payment	1397	1397	1678	1	1	7041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdThC8bxDEQD83PsfGeGRecWA7oqhtEWQdtBermD5XGpUo25L1
13898	payment	1726	1726	1874	1	1	4670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVgeHbmsZ8DtU8z6saGKiWxkKuqYKBoW6hSV1FoKEzQSeUWSy
13905	payment	1397	1397	1678	1	1	7045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5gykcp5X92hR6fHrTUFr6qJEMchCkns4zSKCoGQiHZQ5avaA
13906	payment	1726	1726	1874	1	1	4674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHWZeLeJiTtQJFdxUV3XpGnVm9ZT2zWbGYKHmkqvpNvxYH324
13911	payment	1397	1397	1678	1	1	7048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWG5ssqyiP6SdXoMHZ2QhKfDH9HS7EVkjF5ssN3enLBEmrrzw
13912	payment	1726	1726	1874	1	1	4677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTEyr8KrFRdRoJUxTkwRaSnDrcSnJ3mDy56CxgzG6DfSGXCzD
13913	payment	1726	1726	1874	1	1	4678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJjtnp7vWmKfGVH7Kf6iim6y3D6yCtaejKXDNREUkdX8Buufe
13914	payment	1397	1397	1678	1	1	7049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUcfqLETviVTSTxFoGLADLYZrHujsrPhMAk2sd11LpZRmQvFp
13915	payment	1397	1397	1678	1	1	7050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxGt6Kcv9LRDFZP5my6FuP3qg8ZhKs9eXhox9DPKeWpvrx2ER
13916	payment	1397	1397	1678	1	1	7051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbzobcKFSEApwkPcxTR7VFeQeGSze8eUUe8AZNkuxcxaqRQxJ
13917	payment	1397	1397	1678	1	1	7052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDdnqwhWCbmhTgGnqABA3cpKjSoX7qPBgJnkydSZsuFnMajEk
13918	payment	1726	1726	1874	1	1	4679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU217SyGcMVdRyMDNSc4EC1VJ9SLh1RYyWg43K4f7fsTgvCfmb
13919	payment	1726	1726	1874	1	1	4680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpeP2dyLh7REmfM4VPrRzaQsubhzSsoETHFJVenCnxgbqbyUg
13920	payment	1726	1726	1874	1	1	4681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxgMbZYRkpSLQnCbkMrD6pM2zPNUprwhbBn2iegKWjBg4X9pT
13921	payment	1726	1726	1874	1	1	4682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLo7XWz5np4tNxL2YJoBMbczYUssQeNxTqP82ZFWBC3jaZBDd
13956	payment	1397	1397	1678	1	1	7070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoxBL7srSyQZMB1YfvqjPk5brpkP9ddPkS9X7p8o2yKqzyVWA
13928	payment	1397	1397	1678	1	1	7056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJwg34qP7DyLDwS156sPxjEZiThsoXRHXiTkwRvBxjpuQjKfa
13929	payment	1726	1726	1874	1	1	4686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicvcicoWSWoS3eKswsjeZtVusJkfW3mau72TYphAAgveY3Xk3
13958	payment	1397	1397	1678	1	1	7071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJLacbScVk264fX6XMthE7Qne8WtcEH5osHj5RaN1Ze84oSpf
13959	payment	1726	1726	1874	1	1	4701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVJp6Met8AvKZx5MWCAa4Axo1CWMpWdWgrxVZ3SAz4KQgcVDj
13960	payment	1397	1397	1678	1	1	7072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pZZd6WZwMXVcfSTv5i2we65BNBct5CC8MoqpH9TmvmD8aXvG
13961	payment	1726	1726	1874	1	1	4702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNP8kfn5aqNoe9vrwZYUq3Bz4zwi7BdreFZb27ZcJ3z51YVH
13957	payment	1726	1726	1874	1	1	4700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWomSqd51rSewzsFzzzCzVcN8VNMbwUiTwFD3L8NNs3HaPZ6Y
13962	payment	1397	1397	1678	1	1	7073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJe4VTEGVwk3WMtYHGc1vqDQbUS6PsFeM673r9RnB5yVEpjxX
13963	payment	1726	1726	1874	1	1	4703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp4YqPH7PKYA3t7senjKsVfnpqaXnyPMagAXxTCWdaqZHfmWB
13964	payment	1397	1397	1678	1	1	7074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Bcr5HHyKV6F6uu5i7pbGHGgqgAzU38yXNsNjzA36qBSQFrUh
13965	payment	1726	1726	1874	1	1	4704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBDGgWkHphSJHBo3Mj3vEtfwkJSeH3CY96uVeXkumybiJD3cc
13968	payment	1397	1397	1678	1	1	7076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2PJL5C6vy9bUwsJKseQPMCM57gRtYgx1HdcwNyPofgSaCNw3
13969	payment	1726	1726	1874	1	1	4706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqYhbwNdeK8odNh9nqe1hJ7JYaLGnmrivbsXHvuKCG2FE3jMX
13970	payment	1397	1397	1678	1	1	7077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8HKTBEfLDbsxokLzFmkD8PabA6zDrjeFkTRxYUAHTS4fPGmK
13971	payment	1726	1726	1874	1	1	4707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBeQdEZ1tfoFNbS6WSa2byjsRdznuZAwwAcmhdBPC3kSm7TLN
13972	payment	1397	1397	1678	1	1	7078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WiWM43YVvdck6yP4tJ3D3ZCBdMzmTRDHQgE5c2XVx7985jK7
13973	payment	1397	1397	1678	1	1	7079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenqZ6FLV1rnogomHoy4ybT7dQZB8brDDs4FLki5nYTP8rQgKe
13974	payment	1726	1726	1874	1	1	4708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbrEnKFxbR5QNDtZXye9Zm8f4qiGzFdVXWw6CfhLb5aQHDz2n
13975	payment	1726	1726	1874	1	1	4709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAamXtq7h7jU1EDmADVGH3gqKrCjPs7rAaCrfbfBrhuywaDEre
13976	payment	1397	1397	1678	1	1	7080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucJZrG8fspTyeYuPeQjbNrgjN5Qny2ASXVaonepYHbWVmr4Bv
13977	payment	1726	1726	1874	1	1	4710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsQWtYnjNeoXnhWnUDQrH84vyKqUaqMCMcg6wotBz4xJQQX3e
13978	payment	1397	1397	1678	1	1	7081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBjbw6vpz1odbVfpTrNUzJTGrioFfdXtueyTruSDcRupQZJvU
13979	payment	1726	1726	1874	1	1	4711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtVcY1GvuU3QpUu5B3v8zqW25GVpyPKAFwAXvQfe5VsULaxws
13980	payment	1397	1397	1678	1	1	7082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8QeBSJWr7Fb58nTtECSBJpkdjx7yFtNdMqkE7GZEJrk51QUR
13981	payment	1726	1726	1874	1	1	4712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFUttnhu8pHqR9z145h4twwi4xrtaZqDcGShwux6TxnzgjK9r
13982	payment	1397	1397	1678	1	1	7083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrRvKCGRDbxDunn5tFLNp5sovW8PLnde8C5pRpovZGuLUmyzp
13983	payment	1726	1726	1874	1	1	4713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQy77CnZ8F6TifQKgLtwjKe4KXvzVXKVGqmD4zmGsKNTPSYnR
13984	payment	1397	1397	1678	1	1	7084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9zqKyffQMxd3LeQNbfuCFto9FwXNamZea1DHjXqzv3q5WBEm4
13985	payment	1726	1726	1874	1	1	4714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TGkgX7GJAWm7imxXB9E36Sut83i2dYn9BE3TotFkagWPnpfY
13986	payment	1397	1397	1678	1	1	7085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNgsPHV9zVPntHnN6LBAUeWk77dJYbN2gPoSaYbDJTN4wZNLH
13987	payment	1726	1726	1874	1	1	4715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVRLf5CWPMNywEXXtXXMVcCamToEbysLiPP8zw3F5q8dXpoNi
13988	payment	1397	1397	1678	1	1	7086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rbjsNhDi5JwYfX4ZoV9pYWZNtgchN9eGW5feVLdm56CNmTpA
13989	payment	1397	1397	1678	1	1	7087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCng3JS4sBeUH7DyrFyjjwHjGS5HH16NytinNLcB8p4b84Q83
13990	payment	1397	1397	1678	1	1	7088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uGbCiGkSyCvUf3SxMVjB8BctP7fm1k1Kuv8Fboqx9dPkSmgD
13991	payment	1726	1726	1874	1	1	4716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJeLqRnAzrGJYsiyuvejmBN4S5xbKwcK4QcRJVWLTMuAkHQQb
13992	payment	1726	1726	1874	1	1	4717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7isWWVAdwr3a5Hg8DW1em9CkjqmXkYAJUYrVEDbqUw24nXHKp
13993	payment	1726	1726	1874	1	1	4718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3XGEaRw8hM36GThpcqopNAz6zMWe8uzaSfJK9yMa18JQKuYo
13994	payment	1397	1397	1678	1	1	7089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboVsdhqZhwAeZQfDn8hVzMdc4Lo76KXYbcD8cdpabBJGB2T2Y
13995	payment	1726	1726	1874	1	1	4719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDSFnhMtCoUBkSZTS1Wz6tDjBWULBEA6AC2Pu34RD7Un7SCHC
13996	payment	1397	1397	1678	1	1	7090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DuDwFtRDTrBUNo435wnAQMsN6KGmW95B6gLGK7p4ZXt9BZwR
13997	payment	1397	1397	1678	1	1	7091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLMUFkSm6fHPgRLNVUuoCRjroA5ayzLBanTatqb4wMdPTWNZA
13998	payment	1397	1397	1678	1	1	7092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87spKEzHJ11YTWNdyMTKDh9rVrohSw2vtYmaAD15tWKwBYRn9
13999	payment	1726	1726	1874	1	1	4720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcY6g1JfKzti2E6EeP3NUPJwRja9o5SqDgqHrmfDhDj9Mbjs8
14000	payment	1726	1726	1874	1	1	4721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRNjPLf3Fz12FWSbuHktRdPXdbWUz3Wh5nQyi41dXfiF5BqW4
14001	payment	1726	1726	1874	1	1	4722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cL3Jfx2pKDhYf6rHT1MqUDNccyrsqyyNfV5bWfbk9EropT6B
14008	payment	1397	1397	1678	1	1	7096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY3TbsMHkxD5W4TAZJY7csSekW7ZnyUSrQsBrmSviPkf5wtJY
14009	payment	1726	1726	1874	1	1	4726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfZVnDsJkbkZXbiDWt4DHtxYVrwczKKrfSQVyjJSLjQE7Wug5
14012	payment	1397	1397	1678	1	1	7098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiJGgQupdQb9aGxapPgAh5ZnN9nGc8JX2EfGu2JmjyT4dLAfJ
14013	payment	1397	1397	1678	1	1	7099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrgFKdF2fpZasD8sxEFfAg8ApCtW2RnKKqAgU8T6afP6PSJZJ
14014	payment	1726	1726	1874	1	1	4728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oqyuVXyWoCmimPR1w3KqTkG2gfzXi13VXVJrczsN4kYfgjBf
14015	payment	1397	1397	1678	1	1	7100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKuZyU3SoUoko1WEiTT1FrBvkcaTJvyeWyc7zeYmFTEv41Sgj
14016	payment	1726	1726	1874	1	1	4729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLn2hQbuCV4f3Ej51UzUJNciarhvQXokqN2tvnXhof133jm5rw
14039	payment	1726	1726	1874	1	1	4741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLRAQYK5G6nE6z91RanYZpcHEWtST1H8nYPdXfkLpf7ptJfKN
14052	payment	1397	1397	1678	1	1	7118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWP86pwjsfALxe6TUiRUqDHYT83X1v67yBKJ1ySWVXj1heX8L
14053	payment	1726	1726	1874	1	1	4747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8afhmKZQRqtJJ28eXyUtr2LbcChUZu7oZ7FPTy4SjxiKZG1ZS
14057	payment	1397	1397	1678	1	1	7121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRj5zWhorN6nw2KtrVX5oD5azxZhTBop4RfCL7UBm7Hcws3nxv
14058	payment	1726	1726	1874	1	1	4749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSk9F3HgYi33XDn41oi8DMydE5S7WjvuSiooiaAbDSoabK7on
14059	payment	1726	1726	1874	1	1	4750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNgHvQwVxQdZjENL6iDNaz9cGLPFspQJy65B5r92jQAiNsJ1H
14067	delegation	2075	2075	2075	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfuHJCnsEjtkQP9ax7G6fmhcSH8PrJ682i4dGN2g6be4owRQy
14068	payment	1397	1397	1678	1	1	7125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJPjjAvdHm9apzBWqaPPUxtxke14EGtrCTddHJduT7ADwvs85
14069	payment	1397	1397	1678	1	1	7126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLfRG7BKAtJaK1e6XGuqiXyKfeGGjnaCLgB5dhWCxeBHkbvTf
14070	payment	1726	1726	1874	1	1	4754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGGi6aGBEXpPvLAf3NS1estPPGqKjAJgi2sfTzanbMJr6SDtt
14071	payment	1726	1726	1874	1	1	4755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnuWdiKhS9Ut4SdM2mohQMn7LmQUyex7VMuJSHDBqgPBKvxjU
14072	payment	1726	1726	1874	1	1	4756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa488feaEYYKvSXjBsS6P7XZdtBZveX2SnQDVzjnZEuWuhBvrXE
14135	payment	1397	1397	1678	1	1	7148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5TtqoP3j8nNgPaCDqXia2SMhfstQoFgkSjLMpkAvSdgKVncC
14136	payment	1726	1726	1874	1	1	4787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Y3AdgmQJVLikUWkQxnYKUFEMT2RLtHXQNqEEGz3ZxKLFDzB
14137	payment	1726	1726	1874	1	1	4788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5N4R1uz6tjdCma8ieZNRPim1gfUAmLJpBWBXU6hQbTtBS3Mj
14154	payment	1397	1397	1678	1	1	7152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa95aRHQNEnKWqKDM6HdVuM3Y7AV1XnWC7thVhdKSey8nsgfDtD
14155	payment	1726	1726	1874	1	1	4797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbn46yDKjn4VPE7SudQLpfTw1t7MuQfZ31dFo8JSDQ4YPtCZ3
14220	payment	1397	1397	1678	1	1	7165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyCGj7vuqAFnxWoRjHa8d3t16RZC1N7hqgLWasroSGwkhYvra
14221	payment	1726	1726	1874	1	1	4827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCH67YBv5ymJvFxRda97LoqSdoN8215hyYtSarSL49WMHvfgmf
14222	payment	1726	1726	1874	1	1	4828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoXT3Yc5h3997CCSfM3RFHu9MG5uYEC9kTnxPc3JnzybQhF4V
14223	payment	1726	1726	1874	1	1	4829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4v5zKEq4TgT4ux4aayTw1kowWAeNDoRNaUmgfybKjqnQ7sWx
14231	payment	1397	1397	1678	1	1	7168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLr79YEhJEtasi1QcB5zpvepm5v4AELRXa7mQ6XiKk8PGQ9n2r
14232	payment	1397	1397	1678	1	1	7169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEengcwwV5u1WV4dZhtduESy9eZRMjZM2EoxTypNwGrR2iHaME
14233	payment	1726	1726	1874	1	1	4835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5pnQQbJev1n6kUBPm3XQdLhXcbZ5omVou638eJqVysQFk6wT
14234	payment	1726	1726	1874	1	1	4836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPvebK3puyoqeUS7ymQ4kkBdpFSQW3RTThkMN4VX8n9GMmdBN
14235	payment	1726	1726	1874	1	1	4837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf4LdHXvdpLQMhfwkfZnchfFTtrG6nMfw4ePgw4pkc8GgqZB8
14236	payment	1726	1726	1874	1	1	4838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWuNC5Fha3heSkeeJuLwQeEAuezc5RN2xZEfdS6y3SkvgzTUB
14237	payment	1726	1726	2083	1	1	4839	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaA7MoBjU2ANcVeHnGL2fHa2b6bK6CB6N3Wnxj8GrqRtcFH4iTs
14238	payment	1726	1726	1874	1	1	4840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreDibwyRtjrLJaMSUqcxzdPPB1MF2FCmveYnqXwWetXy8rptQ
14246	payment	1397	1397	1678	1	1	7173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEMqZsc4F75GB8N92rQno9BjC317seVRxcbkcPqJQteZgb6x9
14002	payment	1397	1397	1678	1	1	7093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rPeSCHvbSsXJ3eNdC7PUbX957qMhda1m2tsbupu89sC4bzj4
14003	payment	1726	1726	1874	1	1	4723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFgv9T6wKQgorzYAkBJA1tB2suzezhXAPHNYBTYXAg5swdtN7
14021	payment	1397	1397	1678	1	1	7103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yUXA1ESizrtD5wBHXiRWAWB2dgEAKreAxxwyxEAb1SQ79t7G
14022	payment	1726	1726	1874	1	1	4732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUHM7RUyLhjxnVdaGjPu97sDBQ1U3fLWdCyemmvmCKcGGHp6M
14023	payment	1397	1397	1678	1	1	7104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoW8WXKKJcrwH7xUhwQHZmB38kwihEdy5KpAhRkk9PVUvY3hd
14024	payment	1397	1397	1678	1	1	7105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLADW2sDh2xYKvMq8rK62qarsHfk2ZTcDdMoEvcKwVnE82zGLe
14025	payment	1726	1726	1874	1	1	4733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGaTRJss4ygkB72MouDKLWaBXReyuEMSxE2fYnac4BSsZwHFu
14026	payment	1726	1726	1874	1	1	4734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1rXB5GqhGDd38kpMiBTm9kSS5o7AYrRS5V1mpSbZRT4t1ddC
14046	payment	1397	1397	1678	1	1	7115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGo1DNtaNf7QGZTvRBHv7SpyBXB2CYPbHLaasg3jnfFSVrvtRm
14047	payment	1397	1397	1678	1	1	7116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5652MBVkuSKhgpFRa3mgujCuZ4qEE3m7o7WivnRpJf2J8zr8
14048	payment	1397	1397	1678	1	1	7117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Bw6L23a6gRyKACm4Nkk7URWwZkkRV9oLy1gSJsnECTfGfHKG
14049	payment	1726	1726	1874	1	1	4744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebHiB5K3YYkQ45wLyMzKqvbQ1CZjUFPrGuJdz9VF6MJbzsdh7
14050	payment	1726	1726	1874	1	1	4745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4yvwLe2w5hdKncRczTzZsF55Cu2zR9VgSuA9YNuYnmL4kj6Z
14051	payment	1726	1726	1874	1	1	4746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GM2NbdkYXtBjm45HGhooDCaYbo8fByvvxiv6nEfpxedbmxCk
14060	payment	1397	1397	1678	1	1	7122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiYtTU2Jxq2TwZkR5yhHiqVn2Sy6ZC3b83JW5Yvy4hWJFqmBx
14061	payment	1726	1726	1874	1	1	4751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxRUGxWgz7AQuDy2Ndx5qvV2s62Rb8nBdeYfTsxTWhH2f4fa6
14078	payment	1397	1397	1678	1	1	7129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmBtHDN8orTyFF4gvgrpXCkYWLYfgkm7KvQjopo6XapgcNQjg
14079	payment	1726	1726	1874	1	1	4759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXHus2Jxy85fhcVBzkBrBuWPnTdFCWRb6MhH7rL94eT8XtbVN
14080	payment	1397	1397	1678	1	1	7130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZnzzx9wXVXrT5fB441D9EmsWB2ikvjasJ9eaJxVQymuTD8QK
14081	payment	1726	1726	1874	1	1	4760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoryQCHtmZi1uy9eaahrbYVELbEXthRrk8yQE6PW5CCKTkA7vY
14084	payment	1397	1397	1678	1	1	7131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2A3pKjTtD5XPdtcT3JdHwzXM5jrpBuDVex9KoeCknTKiui5pD
14085	payment	1397	1397	1678	1	1	7132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBS9K9GCpvDGo7PrVx7JanWesEGYeajNwu2WzEWWDTr5b5j4e
14086	payment	1726	1726	1874	1	1	4762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQz6aYryAJnWcBi7MPMh4td2UvY8j7CCvDENHw6oyn7fafnqV6
14087	delegation	2073	2073	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSJ7Xmiv6akKJUD9JNcG2aLV7EagU1zgZ1LmwnAXWwj1rYntD
14088	payment	1726	1726	1874	1	1	4763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDrg66ZvELKc61cPBG1hbSMavERC1cQnZrmFFe8E5576zjReM
14096	payment	1397	1397	1678	1	1	7136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3t3jmQVYUkZj8p1mjA226Xfp3oeBuc9faMaXYqt1M9KxQCP5
14097	payment	1726	1726	1874	1	1	4767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmUSBWLHGMpfhNLt187Dp25LVvLsaiHkSpXBdp5tsxisx768F
14098	payment	1397	1397	1678	1	1	7137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarravXhkf448dXxBxdbT174kjT2XTUNPK9x7GwN56hThHjXcc
14099	payment	1397	1397	1678	1	1	7138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetAyL6YNa4ey3eXAhpjF5YBJQVMkV3XQ5pE51v2o98ZqwsmUQ
14100	payment	1402	1402	795	1	1	1	259619730296	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9dq7y6WYrsBivS3oufBuN2DXLN3VPxLkMzKMr6F2myEmJFCTg
14101	payment	1402	1402	796	1	1	2	2855814541130	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhcQXERwycqbwbXe8MG9UPZBwZpT5xw51dj3imxFuDSybrFvDN
14102	payment	1397	1397	1678	1	1	7139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCXfmpxm5sDWEzkgu69PhBoY2WRCTiWmQXNggHoawpZAdPJYm
14103	payment	1397	1397	1678	1	1	7140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1znuqvRRpKQXFDp8RLdduhQ5e8m1caHHaPtjs9USWMXe8saTJ
14104	payment	1397	1397	1678	1	1	7141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNdSQKPREx98gmt3kgDiZ6ybzs4ArwpTxveSEz2qwTdmpL2Ug
14105	payment	1726	1726	1874	1	1	4768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGhXxNYgmL6FKB2S4CWSfhrZYKvhko4aVRPnS3Vk4ksDYAhqU
14106	payment	1726	1726	1874	1	1	4769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3igssDVCu3XRrt7kJZUjD6C8GcRLnrRtq9dLXkGWKya9UEVj4
14107	payment	1726	1726	1874	1	1	4770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gv6jW7xy2J7LDYcXwprzsuEczzWfvZg7YHumPeDsQoMDtiG6
14108	payment	1726	1726	1874	1	1	4771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprrZs7B3i9HV2uSW1YqWKg7A9u56ZYnGuLD86PSfFUvoVoKzc
14004	payment	1397	1397	1678	1	1	7094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUAyNzewvquN1UwJ1275QCf5bW7oLdtsM4pNgkNQXBeNWxpZf
14005	payment	1726	1726	1874	1	1	4724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt6gZ8uq8atdJLpuEay8ayqiznfZcHxGXNBF6u8mF2Q5iy25x
14010	payment	1397	1397	1678	1	1	7097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKqYxsEYbKAxhrzkewpbhLMxuVX45BhSKPsDZAxD3UJpL3pzS
14011	payment	1726	1726	1874	1	1	4727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fHpt4fGEkrxfJC9ofukLYPaRm3pQc5qQPxbWmcVhN2PV8e52
14017	payment	1397	1397	1678	1	1	7101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMBUn5zXoNSjTSBDU28ER8sbMaBbnVXAo4WMT7Ak3g9LwSeWf
14018	payment	1726	1726	1874	1	1	4730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDaQxBxAx8VJMGkSdUkAwtpJwZH6Jv8wpoCKm7hzp9wgisL6M
14019	payment	1397	1397	1678	1	1	7102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpZmgZDQwdJLXJRpHjpNDw4QRXDxCGDcBwxQmSHK9dmJ73fmv
14020	payment	1726	1726	1874	1	1	4731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUo4nHFJtEMh9brK2NTfqSEJNHRV6wuY7GLDRgJkmCPwt7Tk1
14027	payment	1397	1397	1678	1	1	7106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQsjvV4yAuyqysPWYH5Dfvf7jmUAWdUdhP2ZxAEXe776CUHf2
14028	payment	1726	1726	1874	1	1	4735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrjRDuU59ofp1rppJ8xanAJmSSYpwtySSs5WTkF5gu4EWShHR
14033	payment	1397	1397	1678	1	1	7109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEErDCZ2s8hDLmpA1knthQc3dzYJrQDRyw8ybW5Ty4cbCdhxS
14034	payment	1397	1397	1678	1	1	7110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsM83WErRpAeUjuivARSykNj6paVg6ka6pjCw51b2iM86ahwaq
14035	payment	1726	1726	1874	1	1	4738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW6RTvgJLsrPTvRmBnfzSMpEVdcTKZeRCEpVdnT3JFd414Fra
14036	payment	1726	1726	1874	1	1	4739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyTsb2P6hyt4gBseMV3hZCDo6DBzSniKkwTYd4euDMsEMKFT9
14056	payment	1397	1397	1678	1	1	7120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwqSo98PiCU7m9tjdTyJyCUm85TRRecV7z32mrp7kTAxevfa9
14076	payment	1397	1397	1678	1	1	7128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNKvpJ2EQ9FXMhNHWxKVzePYr73EpZcV1Jp69GYxJumhZzFzN
14077	payment	1726	1726	1874	1	1	4758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaYtQkyGc7VPGStTSkQpde4cMUkgwZPEBqFsmrJhBRu1ZYJC1
14116	payment	1397	1397	1678	1	1	7142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KtySBwkwm5p2xmxhzweRY3uvkGbesUPonyCXqXH5uDGpThTZ
14117	payment	1726	1726	1874	1	1	4778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9ZEpqvqkb5BLoTF8HfkW8YMMzB5nRMfZSYFgwgreZZ9qsJmJ
14129	payment	1710	1710	1507	1	1	5	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dXJPGLzeQWLTUCjg3DmW54D1LNmFuc4A8tUrhCK9uu7mLp4S
14130	payment	1397	1397	1678	1	1	7146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HcpjNwDDs8nJzCvqiHfFSbGWTMdWQtyFRmsbjZLQybnspLo1
14131	payment	1397	1397	1678	1	1	7147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4ptQSyo1dMPpSPfD3JzLXmmAs1uWU3ivVscvZZEeFJj8rBgh
14132	payment	1726	1726	1874	1	1	4784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFUgfWhh6obdAytkf97FNrxEW4QD8M3ZHQ2bjSio1vdWHb85T
14133	payment	1726	1726	1874	1	1	4785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmZMg3BhfFun2CjSqemeBrZWZFcMpBz7h7QwzGBo1CnJHWXF4
14134	payment	1726	1726	1874	1	1	4786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTfE14U8FjaM79CbnMpzQBuUa4nuWfCEidmV7YiD48DnkUcDs
14146	payment	1397	1397	1678	1	1	7150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pYn4j6vWL1DiYS1vocLf87SMM9XUj79hFiZKKJmtX526pEG6
14147	payment	1726	1726	1874	1	1	4791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLVCQ1Y5JN8LNKYY7R1qrXXLcjV31VP6BWWydKAbAJC1FYhQq
14148	payment	1726	1726	1874	1	1	4792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3Dt3ufeAZNn6h9HuJ1nhGvP2GZAUMx88euGjKyLrJHzXh9N9
14149	payment	1397	1397	1678	1	1	7151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9B5CutFweLjiZsL5zr2bHZKTi2YGe8rTT4HRguFVCFxHUXNnr
14150	payment	1726	1726	2080	1	1	4793	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLWWsqpnWBC3VVUEbYEFPEDru7pRLa2hTZnRfxPJq3uKVC7qa1
14151	payment	1726	1726	1636	1	1	4794	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKggNb6j3y4NpPuhLg1MXWZ3DSjBddymUEM7DWWUztQQDBzwMv
14152	payment	1726	1726	1874	1	1	4795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RitjkCizaHyZQA1LdUFQkYkWmtFBenCaaZ7qoufUWcBYsbnX
14153	payment	1726	1726	1874	1	1	4796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmEc3MnmxG8AkcHQbTs5ck4WiqPcNwZ6rNj1f4PHPCK3CSMjf
14158	payment	1397	1397	1678	1	1	7153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq17GSXTPeydcyPRJZxkMkhBcxKigC7YEBrwJFWuJ467BsPBL5
14159	payment	1397	1397	1678	1	1	7154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKGzSe7iXQHd7fTajv7qYTryTjvR1Vfmm4SsdSRDNPtcot5w9
14160	payment	1726	1726	1874	1	1	4800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYTAErAUTmbLwXCT8tRkCe3gHqSrinUqgMdoayCpyMKCMqBZn
14161	payment	1726	1726	1874	1	1	4801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ4qQwLXRbYHsPtLUJ7jnkUfNs7KVnyrHP2NAEKb2y5KTjkVX
14162	payment	1726	1726	1874	1	1	4802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82jMrSCpwwaZSbi5Yn1YsQ8AGyNXuyuRjvigdr28w94Y2STBR
14006	payment	1397	1397	1678	1	1	7095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAUHV7vQNfSi26XkifUESAruKzU2osi2HkKnb34teT4G9uE8o
14007	payment	1726	1726	1874	1	1	4725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQa4dpcJFa7KV9BQawLWQY64LV4ujYhM29fdSYJ71xAu4BKmB
14029	payment	1397	1397	1678	1	1	7107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUkLTu1Nb36wz2DdbxfTfUxkYF4m4JWLjZNLPovjMTkeyBU5A
14030	payment	1397	1397	1678	1	1	7108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzNJMAA9DQ71fJ46AJTpgnYrEihTquve99evdZ5WYWWHSFviq
14031	payment	1726	1726	1874	1	1	4736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVdoaF6KpC5ejdRdj4rVmpetQSvv7cKFnM2d4WGKEjKiHj57B
14032	payment	1726	1726	1874	1	1	4737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauqThzfvHWxGZFinrpZkueK8KUdNNgHJ3Lsxwua46WVRxJKKD
14037	payment	1397	1397	1678	1	1	7111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSn6KHhUSBTR6rAP7ja6LXNbqSWNQStaGGG37a7TTUXZNiRpo8
14038	payment	1726	1726	1874	1	1	4740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGT3rYqze1WRnNwiCPWPoUPGKTWb6vsktnXfwET4WWiSaBqJvk
14040	payment	1397	1397	1678	1	1	7112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhKpLjf7PxqBHwYioULFpboUDRHMnrjwhA1uynEY8m2dxvvYJ
14041	payment	2054	2054	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtnRLa9SQK2Ee2s65adHkibmUMKHtEifs37whEXBR59Sx8Gcy
14042	payment	1397	1397	1678	1	1	7113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwMpeGZqyi7CJE3xSoaP1aPq5EXzai74RsAYCRMfUHpv28ADf
14043	payment	1397	1397	1678	1	1	7114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEQRkqjZNZWDosWmGAsJSjZqFSMZ1M8dcD8gzqmZccqVp8od8
14044	payment	1726	1726	1874	1	1	4742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYs998afjCzRjXpAaPirKF3im9sdUPSdpVUHoojteUhRt8wirj
14045	payment	1726	1726	1874	1	1	4743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bWnRd8Vk7rWT5Uh4qcGCxguvYXa22acRi3LytVsTsu8ZEJfW
14054	payment	1397	1397	1678	1	1	7119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8kUrTD17mJDZQqqi1as2XCvaxF7NWV3Hr8pqLdYurQ6Fkzdei
14055	payment	1726	1726	1874	1	1	4748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1K5YmRSbJ3k5cPBAEYdQjRu3BmVvynHULwutofkTe13h4HeRZ
14062	payment	2075	2075	2079	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZsZW7F8cCkQnMXU3s5HiLvruZuVJwZaTffDT1xZq2w3MJQAS
14063	payment	1397	1397	1678	1	1	7123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8dKu6Ufun7RpWxm73vC1nHMi8mLwb4rUUK4FvSDwAXmJh68J
14064	payment	1397	1397	1678	1	1	7124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevik4urWrqt6pCZ2MoseHJP66B9mJ6ETefuzUegGiFDBHnCsu
14065	payment	1726	1726	1874	1	1	4752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQso48fmkBXV4dsZvUqyEryq1pfzAt5V4tQFV22uFonV4N63kf
14066	payment	1726	1726	1874	1	1	4753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsE74yHuJx2X82TzcSENRuERnFxrYmA6eGcu2HX64Ty5XyqbhN
14073	delegation	1693	1693	1483	1	1	666	\N	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYXCofLM9LfvvXXP9Bw4kDZk	CkpYino6G5WMVrkXb4dphK8eeLo2LY2LFVwiR2MHTjmM1qAUfYn1W
14074	payment	1397	1397	1678	1	1	7127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYquuh49TnJJsqALghZvU53QeFmi5n72w7mfoG1gRpcZoAm6n
14075	payment	1726	1726	1874	1	1	4757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrdUQ2seYPuhGfiU1L7MKaPjA3kGx1UrrL9Ctu8nphMPuMrh2
14082	payment	106	106	2073	1	1	1	413000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FfhxzD9HaWK3jLZKY9yURdzwr6gh3ZxwKbGz7X8v3XqN4gh2
14083	payment	1726	1726	1874	1	1	4761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFsFCTs69DWjvokvbCqYDyTZYsZR79yYg7Lsg8TXjCkuMVivc
14089	payment	1402	1402	34	1	1	0	312983391438	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYUUAp7K79grXKmoZpKfXpKYovHqsufiFNCC7p7F5d5aB1TVcoM
14090	payment	1397	1397	1678	1	1	7133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVtpUhGTd1HtnZ2k6HZQBoSEoJCqtEKhUGmmZLZxo1GJKXJZ9
14091	payment	1397	1397	1678	1	1	7134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtX7iSyhEaXcHXANKneaMra1C5YMw4HCBLDB2MbhkPfxkkjkW9
14092	payment	1397	1397	1678	1	1	7135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4BdUumfdnJkpai5jc77NwfDuHBXSbXhPucPn26G6wkv24PxV
14093	payment	1726	1726	1874	1	1	4764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9B7RCWrVeMPK7ePfGhCVHBrRKuDybvntJkpGvCfaiEfB2guy
14094	payment	1726	1726	1874	1	1	4765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjehyU4fA3VrLBLmesJ7J8L8pssgE6bG5wLurrzTShwp67Aev
14095	payment	1726	1726	1874	1	1	4766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXekmAJywGNaTv3SuzD5vxUry73rSyE18Ride6xC46hUWhiRp3
14118	payment	1397	1397	1678	1	1	7143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrQfQKPDzVkvcVQhnc9VdFRrdYPYZxsSRLku3HZs8fa6fzSah
14119	payment	1726	1726	1874	1	1	4779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDczAGbcMKC5MncyM3Ca3d2Te8jpG4tPxdcb6CHNYmoyUEPojR
14120	payment	1726	1726	1874	1	1	4780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnTPMnviUsPrbxVDYb75vqomZUxYzVabYVd7rmvX1YZXo9zCU
14205	payment	1420	1420	2082	1	1	0	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNwpVquiLgXGfPazG4dTUmxHuJRAyYyB5CEZssBcaar5d5icR
14206	payment	1397	1397	1678	1	1	7161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3UQ8Gs73kSU7vwDKDRJqu3WW4fqZKn2tPENToyuXuwthwGsw
14109	payment	1726	1726	1874	1	1	4772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrkLEDibe4LdxHhBNcyrH6eQzFNpcHJ5omqQ4KTGidQmWDyE1
14110	payment	1726	1726	1874	1	1	4773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdBGdqpMGb7NyGtTeobEYch8NjMtBxUa5JoQCaedDCFGq1NwK
14111	payment	1726	1726	1874	1	1	4774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYem4YFpZUPJtbe8Zi3DE3psb2L1HjuDJcJG2YGoq4a24Y9Jk
14112	payment	1726	1726	1874	1	1	4775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnqJo2rsgNobcWu6D9F6HWRFejZ6UVRKW25DSu3kba1G8QqGg
14113	payment	1726	1726	1874	1	1	4776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5618ZEuzfJp84DadieHnnXkiT79h4EkmLaJiMW4N8SUen3Ki
14114	payment	106	106	1483	1	1	2	10000000	1000000	\N	E4ZRf4XWzWLF6BwBq4EWzNkqeUpxwvxFezFNm2sj237BFEgorx646	CkpaBeniEm4h7hJTWApfEkh76uz9YAhqsZ6U8HuwioFLzTtX1MUdf
14115	payment	1726	1726	1874	1	1	4777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkMdGuw1xMhCi1dBrGdQ4by2Pi4Ph1dkH4pyVtcs2J7mbwBuE
14121	payment	1397	1397	1678	1	1	7144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgTLAwCzppkcGCMUzYg39CHWWBCNYrMRfcuHG8MKG1wAWy4iZ
14122	payment	1397	1397	1678	1	1	7145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZN24gQL78NPkK7ADuX7drTfe1zeWg59ypqS3b28rgBvMh88m
14123	payment	1402	1402	807	1	1	3	122977766961	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZxNjZWDNMfYJNipbvnRwa2uX4XmvD6vbEAA4EmSCkpgQFapaFd
14124	payment	1402	1402	808	1	1	4	1352754256290	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZGCzVvtRJPPiawdSE1qrEZyxGWXpnfew7Ta7KFViM4Bdux9HMr
14125	payment	1402	1402	809	1	1	5	279086220927	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYaByc2M7V8HNfX8Q7AeT6wstmksS2FsHjf7Rf4ZBauar5bDRRM
14126	payment	1726	1726	1874	1	1	4781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm892HyemtKgrUqcX7diK2SJPW2iZj4j59ZS3tnsh8CSnESb4
14127	payment	1726	1726	1874	1	1	4782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Lih9aibxAgwsrHnuJxRLsPoGhx9fTQMw16Tu4ZCP6EJ53hCc
14128	payment	1726	1726	1874	1	1	4783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGYsSZuPkEPDtt61cTXknFDbkvM9cYYxhz5mzDr9McsvhpoVf
14138	payment	1402	1402	810	1	1	6	3069945751228	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYVo6pS9oXKv78rgQPmemiUPyGVr1XVjn2ukwNKiaJmnfgi9KhU
14139	payment	1397	1397	1678	1	1	7149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVedqTZnyE1TFSbtpDHd847fDWtoxfaSyEMpfzoNh9959aXVRq
14140	payment	1402	1402	842	1	1	7	389207747947	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZkV7RuujeLU7K647fPiSLgSZkxVf7fWyfrW2TdD3ciASmmrBF5
14141	payment	1402	1402	844	1	1	8	725623588957	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZeunxMQc36wt8tUuFPpo69YmLL7utEZgBx52iCHf7zQCzmi2fx
14142	payment	1402	1402	850	1	1	9	5372383091570	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ7XozWzLeT1Sx5QmiP9GSRR5ZSi8Hnsmu9PhKx3tc6gT4GhLvf
14143	payment	1402	1402	852	1	1	10	10407116782127	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ6WZ1c7VaBeMJVXz2QJVY22UAeNqKyCJ6ZjXxqwUEEVNFsYubw
14144	payment	1726	1726	1874	1	1	4789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jyknsMCmQj4qwu6qgwKYjJqyzP9ZynYAHUTNc74wR3JeE5bU
14145	payment	1726	1726	1874	1	1	4790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zerLwN4ywPKL8SVLq3gL7AydXcgFAWfaqjk5SKsf8mQ1SjiM
14156	payment	1726	1726	1874	1	1	4798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyM9odxnnjVxQRpgF3ub2beGZHJzpWCEjYRs3BLNy4dc8zmwn
14157	payment	1726	1726	1874	1	1	4799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFCXo1aZfyWF81Nwh5Sy9a1EC2hYbfSwZ8CLhBmeeRVU88oNZ
14163	payment	1397	1397	1678	1	1	7155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3VQ3NfSsN2meGVTBSDRECVK8UstLM7m2mgT9C2SZEjB5hSwi
14164	payment	1397	1397	1678	1	1	7156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyfR5GMnbg8CK8tKrQE7xtk8GBhm1TMnhntVR1HdwQBfH699L
14165	payment	1402	1402	854	1	1	11	1147552076813	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaAZMsWBqdkciNASkwzgcVxMZKm4xk4xW4qGrFin82TFPJVe2hV
14166	payment	1402	1402	856	1	1	12	607012040752	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9pubXjxsFXGs6xkSUaD8zRUdT5s4fvAFUgQM1Avjk5Cd3mzev
14167	payment	1402	1402	858	1	1	13	1530571790543	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYqmfzRW2nTpsf8NEnQcmm2J9zW2kuxgTia8hH9DGJScetT87YH
14168	payment	1402	1402	862	1	1	14	2114076417905	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZKsShathopZoHiatALAatrZeNfBYk8KcC1fwJ9Po9o68LMJRq4
14169	payment	1402	1402	866	1	1	15	1855921871779	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa5rf5zi1iqeniZmT3tDsp2RoQ5dXRh4RkAMpbCN3XLXW2V7xGU
14170	payment	1402	1402	868	1	1	16	11302982831172	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZKUWeY7cTg5fpDqfHeSXDxFs3v4U6pwmkouLKtJU2QxxNqGcqi
14171	payment	1402	1402	870	1	1	17	1208766101386	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ5oX9wYH9LhfmViwqRQtrDCDKkiTHC4bGsoaCXaSu7Um8takE9
14172	payment	1402	1402	874	1	1	18	11302982831172	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYUoLtd18goyUhgj5aiXiGUMEJd8R5ytq3qArM6Po1s8wN5GbWo
14173	payment	1402	1402	876	1	1	19	990755284935	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZiFXQGG8rPhVfGGTDin8D192GUgGopXVgpN3krEzXp58BKYvWf
14174	payment	1402	1402	880	1	1	20	627943490425	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhTgegmVKj2PNGMrRcwJeVcuiKVRH13xiYgGAA5Wg4hPW3Thdf
14175	payment	1726	1726	1874	1	1	4803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuuuxarSVYVMQFJuzmAFRZD13AxXLYF54SnnQCJqmwowthkY73
14176	payment	1726	1726	1874	1	1	4804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgPaBGqsaLW7M9qJtiKnksXp36PrrWj7cSmGrjwtABD5prEVC
14177	payment	1726	1726	1874	1	1	4805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3urREmQUd7TwpvBYEJMtPPcXKdf9eb6izA6nkpmmx2u3J6bw
14178	payment	1726	1726	1874	1	1	4806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQEoVp6bQVnr3r3kCk8WqunR9pQjmJLiD1rLFiLAMe4gukejV
14179	payment	1397	1397	1678	1	1	7157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rAAm8tVtvGNh3Vn1GuusFYYqet5CK4b6x1gAydhYWDTQSKyZ
14180	payment	1726	1726	1874	1	1	4807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtbn8PugJe5wQHukzmokWw5RzvdWAgsEQsjnrChooDvtqsz5M
14181	payment	1726	1726	1874	1	1	4808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNVtZpumoMjy7W7ZdffPKFvJ17YTNGt5HZHYKH7weimkenXY6
14201	payment	1397	1397	1678	1	1	7160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2hDgskqcZX1jEbrB68ZRk1zVe4qSobMkkHBjTNpVv4Gzvevw
14202	payment	1726	1726	1874	1	1	4814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryUxnWEiVuhG7itkYf5JTzRUMUAoh2f5N7pQwWTURCXJbUVZy
14203	payment	1726	1726	1874	1	1	4815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92TEvzjGNG6fHmKerBF3mTw6zF6KMUw8EHQP41AZUR7mC39sw
14204	payment	1726	1726	1874	1	1	4816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dqb3Gbx5oJGq9FB57No378ySV51PZawPZrdQ5XwBTKtqMLaZ
14217	payment	1397	1397	1678	1	1	7164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9y7HiZnJ8zZaYZ5pxjVzrrVY3VitzKJAnLmYMh4d9FD6yjiq
14218	payment	1726	1726	1874	1	1	4825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApBvhiGF2rHfEktmmK7eUWCV1P2H96f3tcZ8GxjFfLFBjnfA5
14219	payment	1726	1726	1874	1	1	4826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98wwRaqnoesNA8vLb8pH9aMhWyVtgbffT7AhnyxUq8NKp9hUL
14245	payment	1397	1397	1678	1	1	7172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qFpszBQyqGio29xevDFmxCAq8M47CsFzA8ZaUymmyuUUvHAW
14279	payment	1397	1397	1678	1	1	7181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuneBKoi1Ee8FKoPXdZMQHAxgM1vd1i8az6CV596g6Qiriqh25
14280	payment	1726	1726	1874	1	1	4870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFmREPubHmdzL6BgCF4ZFgB7FhNUuPMBszxSVo9Cq36skYyQv
14281	payment	1726	1726	1874	1	1	4871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxCvEDGMUZpPwYbHRj35AHSYguFAYe4AwiicJX5KvT2HP3uX2
14304	payment	1397	1397	1678	1	1	7188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5y423SDNujcMZ6Cjen62HuEzg7QmQtK8V5zDpHYqpqgdLsKB
14305	payment	1726	1726	1874	1	1	4888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx3iJYksGsWZF8BABp7xz42Y5S9bcetNUhZMjysmdMETFXXJm
14306	payment	1726	1726	1874	1	1	4889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fdJ1e7Qo6zc6cY3yPEmkwiLgmqtCd1tPDBYv7WqBVyFmoQ7P
14307	payment	1726	1726	1874	1	1	4890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AheGQvgt1jQG1gPZ8z43AmjqUepLjVs41LQpZ7iLbADKoDaD
14314	payment	1397	1397	1678	1	1	7191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDHwUNZQfoLDZvRHWxQEcFR2qbzqW2iRRoKMnvLpkxZpxdm6C
14315	payment	1397	1397	1678	1	1	7192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpc85HcPTFtSEQhyTWykH3CzNXkr5Kg2air6nbgLyQPMunPeSN
14316	payment	1726	1726	1874	1	1	4895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCa6VfvUARSk33DTVM9GMCzDMP7DS6xUYii8QfCqrAAb3QB39
14317	payment	1726	1726	1874	1	1	4896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLrc4XkMvG28pV9nJeKqptTEnTvffyvVhiryqv5Jb65KYrxdw
14318	payment	1726	1726	1874	1	1	4897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfnEJkxVcGYHVAWLcVByqVUPe7JqGXNGTSYCMmzSXNfbCKVq2
14319	payment	1726	1726	1874	1	1	4898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGm6xa6KYUTnGLVy3fSdSByT697mUXTsfhzssrGmcnQpVwEN
14320	payment	1726	1726	1874	1	1	4899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADQRRDBrMxc8emH7ckZmmJBbATw9oKQCPUExiLGyDXzpA9WhP
14321	payment	1726	1726	1874	1	1	4900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRYfUTpYabWXMGsUA4jvLqiwiLCtRjhTbVYex7s786TVDH4X9
14322	payment	1397	1397	1678	1	1	7193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJJrpmsPgcWx2DFGKRSighHobimu1oa4KafXuPndZjJQCSHtt
14323	payment	1726	1726	1874	1	1	4901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAfCaDsHpxAPkJJ6BAF4VioAv1boBm4987kMzwrWgZrZ1gjSg
14324	payment	1726	1726	1874	1	1	4902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9UQsefajQaTvfcbLgdn85oETr8RENqNEFaJeJdDXJGqf76Zo
14325	payment	1726	1726	1874	1	1	4903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Y4xaiL9H1SFVXt4TCvQV5pmbSn2XdvgAQDmtRqppQKQ1bH6d
14326	payment	1397	1397	1678	1	1	7194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVr6bHQwGbuHCGbfMQQZ87JTFKpRACSXDt5hM5XHu9QNbhZaqJ
14327	payment	1397	1397	1678	1	1	7195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZCGrmp3zc7eWhZ1euB5X2F8uqioMvE7DBaYysvS68gf2Y8ie
14328	payment	1397	1397	1678	1	1	7196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjo7QWBgy9kiG2oFWEQzFjiEKePe9AzZp3E5YTU2CCb7qh4Ss
14329	payment	1726	1726	1874	1	1	4904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzBhV6Bu5EbZFJ29BMPXJZ2c7BB8585LVWM9974D63TYDJJGi
14330	payment	1726	1726	1874	1	1	4905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNW19o93RL7qGYBdHPHwboHAN46hJTi8BWiyw3BXDrsXcpyF8
14182	payment	1397	1397	1678	1	1	7158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnKEk5PhFT4E9i2ghfN3UW6mBrqgrpjj3u6nKnQVHQgFAC4Fw
14183	payment	1397	1397	1678	1	1	7159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3T6mfNWkXKNgt7Wouuykrm9vHe6feowMHoGwVqTUfRvEQ9xf
14184	payment	1402	1402	882	1	1	21	2721088458699	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZvehksKQ8mXQfqKUaw6TCU17tLgUVuJCX8VjFvULg4RNo1QBHR
14185	payment	1402	1402	884	1	1	22	418628993633	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa99CRFMJT7MBw3CXMx9ASTqJKUYksBZDnaTXVUQALKoARyw6LA
14186	payment	1402	1402	888	1	1	23	1249435908129	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZhvn5SYkScrrR8EaAmmFVjEWyEUzx4oXr7XpiFWPDebHkYmT1Q
14187	payment	1402	1402	890	1	1	24	1048834476096	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaDiLjW2ekWPNm3uyKJpCPzFnPp6GLF1fAKEij49VAYeRQzoWpU
14188	payment	1402	1402	892	1	1	25	2302459465037	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZtabmsE7paW55bNCru9EFwRWcjFua4wR3jAYXKdQgMLup3EGdh
14189	payment	1402	1402	898	1	1	26	303723707441	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ45n4PWdMaJhrWomviHaz3sAxCDFoPujYvpuntAq2VqeVvdbC7
14190	payment	1402	1402	900	1	1	27	181048667141	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZrYjkjNyNbVuMNarg6xyKc4SdxsbiZU9PvfrxcVPGVmxLF9yAo
14191	payment	1402	1402	902	1	1	28	544217691679	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZypVG3aFnnqCjR8WykMxu9HT5apDnVvsrqD33bYX3j5CTnYGFt
14192	payment	1402	1402	906	1	1	29	1957090545271	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYgRLs3iDxKcvkrcF68BrxkRMvHup7LWveFrZ3CVFtsES133rUn
14193	payment	1402	1402	1267	1	1	30	437399149501	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaKic39AhNtQrsh3gXdyhxY8KKBGdbdabNHczvVD1qqbgobu6D7
14194	payment	1402	1402	1268	1	1	31	4673067789	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaLZRFzHaUmhp6ibBMsoeMHiamKPt6KCAQamYCmX3z2BAhbWfC5
14195	payment	1402	1402	2081	1	1	32	984784944532	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYcjzo6988CJ9AvZdkLcrtXUFAKwnVCmq3NmZnXRceSj69xN148
14196	payment	1726	1726	1874	1	1	4809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzzRHdNSrJKLy6gHGjshCX2UxZNUeCRcvNMMFAUhEQQLRPjDQ
14197	payment	1726	1726	1874	1	1	4810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1A8ntKqog9akbK9dgUo56r1bEHa5t16MsnHgSqhtQamKW17i
14198	payment	1726	1726	1874	1	1	4811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMA3Tnytx8842vDHjkBZodohvqDJhzzqg8KsNmfrqs82rACEm
14199	payment	1726	1726	1874	1	1	4812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPo4XjoXbbNGqfS4KDoBHtZbKJNpwrBDoPMeF8FMnuk64oefjX
14200	payment	1726	1726	1874	1	1	4813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoox6cxAWXMAynzfSXe7gPKdBx9vwxabYZ1zLKTLRw4ZNWGJGh
14213	payment	1397	1397	1678	1	1	7163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqxtBwN4uCQTbL8J78kVsc8Qf1bXsX8uaTW1YfoEARXiQgLXu
14214	payment	1726	1726	1874	1	1	4822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DLM2fT6txFGxCA36BpEMH2fsbo5FuCQ7yHxkCtbJZEYjAk5d
14215	payment	1726	1726	1874	1	1	4823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFSBzeYf7SfTPkzFJg8Mc3Q7EB5JgjCmrLvQLHHb6uPJnJ1wg
14216	payment	1726	1726	1874	1	1	4824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSuk7BVsozRHz7jmeskJLMvLouj4WMkB1rFoRjinwD8DPmAAZ
14224	payment	1397	1397	1678	1	1	7166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrmpVReRY93SUWwnCDULvLKeuYFBjNXsuB7c7fxshFR1viLKy
14225	payment	1726	1726	1874	1	1	4830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxrDQs3xgp7wAry1iHA7V32vu5efvyReVCgZw3FfppGXXx3rH
14226	payment	1726	1726	1874	1	1	4831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa628fQuHzpGRuYMfx9EpTQu6ds6MCDAS2FxDgaumx2mbcLBtCR
14227	payment	1397	1397	1678	1	1	7167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnr2nvEv5cT9jio2UpVKQA7igDGnuUy45nvPgd9H5DjhJyo5y
14228	payment	1726	1726	1874	1	1	4832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpufgERo9Kf31i3Hn1LCVoGjmb9ofUc76xtaBshpghkXs41Tt
14229	payment	1726	1726	1874	1	1	4833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvHsY67FvM7sLLTxnNdxMLpREgkkhhnLCERqTiAwb7jD7skx
14230	payment	1726	1726	1874	1	1	4834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Y73PqGLfQPSyemmf2AETzFTAaQr1kF2aH7pDoveSUjdRNQk8
14242	payment	1397	1397	1678	1	1	7171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QEnj4vDv97WRQaHu1CSAchXt5QTw5YqcAnCpqSoatQo5ebjB
14243	payment	1726	1726	1874	1	1	4843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9RyDoGDteFBvP2tgfSaW2mvQ2yL7HPWEtDTDAE7ggARpWN4G
14244	payment	1726	1726	1874	1	1	4844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt94SRa6HZxvCXF6tiRrE5VzLTbfStFGqmkp9y75PGK39xfJxH
14255	payment	1397	1397	1678	1	1	7175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEm1U1jnEVpnssxcu9efoySo45G3TLYN6ZTHspQFYxEzfhg8DA
14256	payment	1726	1726	1874	1	1	4852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoskwcD2d647TY9u9qTPK1KXpFcW6jGsx1iSJ7gtYkKXpn8r96
14257	payment	1726	1726	1874	1	1	4853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoJDeFQdsju7Ps98coPn7Zos99LQKXE9AgZpnVJmqSHcmfecr
14258	payment	1726	1726	1874	1	1	4854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLRk7teNJHvFtzBFNRumsorSKLQYy4SEmSdtpKCzphHpwR2tW
14282	payment	1397	1397	1678	1	1	7182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpv7cCV7tDwKdtWEyUzeLwSyaWn6CPSeH6XeEpYX3gG1iqfKG
14207	payment	1397	1397	1678	1	1	7162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwCusfbd3gxPiuVbkhKSWcWScq4DhGRRyPv8PgaaD4hznbEBD
14208	payment	1726	1726	1874	1	1	4817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGrLMD8Vj55GD8PbZvxdNNc21RUehBgu1LgiAdpXSMNABwoSY
14209	payment	1726	1726	1874	1	1	4818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EDz7yH9DmAyWcJpbgq5uJdwqUUFnhRL6S82CZycLttgaQCKd
14210	payment	1726	1726	1874	1	1	4819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeNUpie8vwWhnGqGdJqA1GpAK8nkvgcANXNCuDTYiUXXp2897
14211	payment	1726	1726	1874	1	1	4820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSK8r6pHAwnptraqXNCWkKnvz1xK85pHDkwiSZCYdqxNJ5fDXM
14212	payment	1726	1726	1874	1	1	4821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzUkvNwZK8i1hEiYYcYLchdYv8iK4xw7A6WGmQmGNJyRipoGy
14239	payment	1397	1397	1678	1	1	7170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QzC2bQDscr1R45wtKaam9TVVTqS1DdMChQtyAi3kNVjCNre4
14240	payment	1726	1726	1874	1	1	4841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeRCKsGDubkypVCeUiPpZMyhxqoqFmJ7tCyV3QJwwXfWboXNS
14241	payment	1726	1726	1874	1	1	4842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns6VnaFyMvBsUCLj8E3vjQHRAV3FxYXqryofNGZUnPt2YqUSc
14252	payment	1397	1397	1678	1	1	7174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiZ9ciXXTHfBQeMGFeEYmYpq9YYnDZBCuoC4DxPXqRRg3gpQj
14253	payment	1726	1726	1874	1	1	4850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLJY64gzvSm9d5nP8d54w4T4yZ11ECGNEZ1uC8GFxq8veSsQu
14254	payment	1726	1726	1874	1	1	4851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFM7TX8EFgnmdHBEM9Uk9g8mnibfaUWRJotPWsEwnTHegSAGXf
14267	payment	1397	1397	1678	1	1	7178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzotC984kaBmzPDVkKEsKywACYjU5SZHWhZRu23CQFvZnyu1FC
14268	payment	1726	1726	1874	1	1	4861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXCruKLwwPdLwvfKLy5GhTNfscZNrFdgp52GiQAsKgrj8hZTy
14269	payment	1726	1726	1874	1	1	4862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDcrshFYCVpYdr27HXhqoZd7khjAmQCJ1GwuzLDf5bFxLxYqF
14270	payment	1726	1726	1874	1	1	4863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtXnb2Jx89EqbhwVYWYHihxet7aNkk44zxZeCVa9xwCpSjApP
14271	payment	1397	1397	1678	1	1	7179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMqxG8xXzbjiaRFq9HXXnQhxHKbyYMQp2pwcBvtGNzgZQe7wd
14272	payment	1726	1726	1874	1	1	4864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCijnMhkQVrRSHvu7vbTDKwTPQh4h1qiDRxfnAvbk3AyPBgfX
14273	payment	1726	1726	1874	1	1	4865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp533bCMAi25gLHT2uGAVRY221UEY2NerAXPmkUGFWa6qyYH2c
14274	payment	1726	1726	1874	1	1	4866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZx7Yy5Rsd97DYrPBssRHsY1noRdvK1YfuRw2KrkJxkESQD1N
14286	payment	1397	1397	1678	1	1	7183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtwSN9VCL8YixkpATwNpPiB8tdkoRBbjWnRZhxKyaaKzk9HaK
14296	payment	1397	1397	1678	1	1	7186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSQGnwmEK35W5Rn7cqcRN8mmfef3sdEWshqSZ5sEUTiPpj76e
14297	payment	1397	1397	1678	1	1	7187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoWMC1zBcv84Z9L4SGw2f1AXNfyp3votJbmZAHsqBvPfNZhBT
14298	payment	1726	1726	1874	1	1	4882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPebe3Q6G1gQVfMAxxiKXcStpB3HE7j2TmgYu2eHgfDnMgT5U
14299	payment	1726	1726	1874	1	1	4883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBpxKUqeXNH6qT7s7K2mcK24Fg5Mm76pa6RVa3sdNMTvu1e15
14300	payment	1726	1726	1874	1	1	4884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9teNNpfYGE5p35PffjoaxAcVu6ACCw3tSa4YpV6BnTCGGQBr
14301	payment	1726	1726	1874	1	1	4885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQCABKhcaZUbF5gFgCi2rnY4smLuBeVjfZtRvAyR6SFXuJUvb
14302	payment	1726	1726	1874	1	1	4886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rs5YTG1vdt8ihyoLyKjqpXdZ32NZ45ZAGtm8NfHBtRLMea6o
14303	payment	1726	1726	1874	1	1	4887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDsFLREH8KfDB5L7v16PdUMn28u7kRXTqiPLtA9VZwaxYGxAG
14311	payment	1397	1397	1678	1	1	7190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVVrGFa5pWhzK5a4g8aL3ALfKgJbYaMwHjHLcxvABF7bRdFa7
14312	payment	1726	1726	1874	1	1	4893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGh1LgouNvtdHsPGWewcL4HD7t84cwEdtYqD9fpfctktcRwEt
14313	payment	1726	1726	1874	1	1	4894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wUjydu2GGGZZ6QTVcTWRMQsQ2Afm6GmB8ZLkNAygAyWRffvW
14341	payment	1397	1397	1678	1	1	7198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRZT5NTEMvc9EYckkQfkMj7wWuioks4cZTddGSXz2nfX8QZpN
14342	payment	1726	1726	1874	1	1	4915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31Mj2MVEhWDmAtH2KTqGpWuqFTJZcdoqhtYyfv4YDPaYiACk5
14343	payment	1726	1726	1874	1	1	4916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrVETGyHbRCUV8TPnpmF2EmRmdyC2nbksKmWy6j37Dm1Jtsen
14344	payment	1726	1726	1874	1	1	4917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjgtyjjWC2Qb2tAVqY2cvu6gUVM8RU4FWgDC4zWnusFESTbcV
14396	payment	1397	1397	1678	1	1	7212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoRP1vL9DhC6WepHQXr7vQ3j8uCDHoCHhjbLAY2sR25rQxqbt
14397	payment	1397	1397	1678	1	1	7213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oCqQV9a6bAyQryM1UDtZZ4kb9cWEVE5GiF7mcfuFFf8qspzC
14247	payment	1726	1726	1874	1	1	4845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VhDucseTcKDUKfCMnQpm8PDe8Nv88fEAEM2rkxuJNYY5trfK
14248	payment	1726	1726	1874	1	1	4846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdi3uNX4ZAa5g6noJfc2UQWKqkPzhm68NUveaQNqNhB2tHyqM3
14249	payment	1726	1726	1874	1	1	4847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtPMHoHGZGN1SBAsNh9mJWhBgNQrnQwzhv4gQtEa2zuHNjd7a
14250	payment	1726	1726	1874	1	1	4848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj11Lus8KTY1SSqRkisfL6ftfssDCjq6kpFfFdWcLSB4eiXVnT
14251	payment	1726	1726	1874	1	1	4849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8TGUa2ougan4pbrfX1qAETADE9VmFfdRh8v2U31AVpLLF974
14259	payment	1397	1397	1678	1	1	7176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1yyjCNtENByM2Ro5Jj4yBPikG1qt8wujaPG8BXkDiwzs7cg7
14260	payment	1397	1397	1678	1	1	7177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cmgC3k3MrLAzjXvxTAy7HjxZtc2MxUaZtc3YhcLRtXjH5Pue
14261	payment	1726	1726	1874	1	1	4855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWXZ4PtchEEVBM5DothQVc6owmxbGrKCLQWmyjZUy5EVXYkwP
14262	payment	1726	1726	1874	1	1	4856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUMCHET5UqJMV3y2pdNmEcmaAvT7Wx9wb7Yf6vVSErNmqfUYz
14263	payment	1726	1726	1874	1	1	4857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFz2Puk7x5KyqvrzZy5tr8iEbUPkHCphPoCMEA6JsA3NPkPf3
14264	payment	1726	1726	1874	1	1	4858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwSZNsqpGYvnkQSFJrqYmZqWb2fgdamt4BtcUQPqXEBYQbf2P
14265	payment	1726	1726	1874	1	1	4859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8JyR5omFDL7y4bg5Q96YPfYMSmVe5uBcMwGFE5BCJ453HyxF
14266	payment	1726	1726	1874	1	1	4860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaSPRYaFVRQJDCLBt7d6q3P8CixpCp4pMrD4ZobPqgka2ekg1
14275	payment	1397	1397	1678	1	1	7180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM2utGfHu6nEZHX9MnGFrDaYTRwH1bEaFzMsmtadpFtSJ6S1Ji
14276	payment	1726	1726	1874	1	1	4867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgtBj4dp1LyGA1fRYCaUoombbF2mjWgaJN6KxqYkZcRUs79Zc
14277	payment	1726	1726	1874	1	1	4868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPTFDUhqqYn5UdBP2Nntiqc6WGKyS1hSCp6yiXbAaC6ZY1Gju
14278	payment	1726	1726	1874	1	1	4869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtt4QtXq6DCcNccehGSrrM7kfEjmujAXJTi2ZUe5p8wfKEe4iH
14290	payment	1397	1397	1678	1	1	7184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dq45YvwTJjadeZoGz5Y9EZzdbV2p2mhhHBq61qGvu9D1mmvq
14291	payment	1397	1397	1678	1	1	7185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pUkH2yibQ1Vc9kCA8nUdcYgDkgmCtYcTZMc6xXX6kdkvQW4K
14292	payment	1726	1726	1874	1	1	4878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GUBM2A1SpjAfbN9GYoPmWMQJc8fwKbytTXHSocLV7ad2dAia
14293	payment	1726	1726	1874	1	1	4879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWLjrKfzJ3KYgia9pmgoQyMg4oFbhL3FNiX3nTYkUujBsWKc8
14294	payment	1726	1726	1874	1	1	4880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPsfBDT7bqNhFCWMbXsgETKFYd4vcdt9NYRhUWFxh4MQyaXS6
14295	payment	1726	1726	1874	1	1	4881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbzu6wK1wya4umhqj7goeUm73munbWrdP9wPa9DWBgsLKwSy9
14308	payment	1397	1397	1678	1	1	7189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinn12F9hWM5fs6PC8ZqN8jgr5viuyht82nxkZPMHKFKRQvLG9
14309	payment	1726	1726	1874	1	1	4891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbVrHs3UccbhZbQ9R6gUvoT6Dkey8ZHCgVoWRvNxLWKL4RzAc
14310	payment	1726	1726	1874	1	1	4892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeB2BXDDbZPmAGqk77nUbM524MzyyNBgfxTaxTm3JbNCX4PKi
14338	payment	1397	1397	1678	1	1	7197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7QaHYa4yd2M9jSTySG5T87yYgs6S5ivg7QEP2zwMYeSanbyR
14339	payment	1726	1726	1874	1	1	4913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj2qfiY9fRzwesN9NcGpo9ESmp2m2pR4S9apL6kPzufpi7GUm
14340	payment	1726	1726	1874	1	1	4914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZASHkfAh3BgV1fdkUiN7hWmG3NiHhovq5LWiKrRW7U8uPsau
14360	payment	1397	1397	1678	1	1	7203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTJvS8GT2fMFPV2RTvKyNZBbd6zQgPpbL1j68vnwHD4JkhSQN
14361	payment	1726	1726	1874	1	1	4929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqexRZXgZuxs5TKHsqf7PfRLXYeU9vBwpPAWUr4nvmKe9DWAt4
14362	payment	1726	1726	1874	1	1	4930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfdrTC4pipu2PB7YWSbyPMKxXgRkEqvrTWLjuxHFtkv7QeMTx
14363	payment	1726	1726	1874	1	1	4931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KGzE4fwYUNoyRXXeDWtW2ScouBGYS5QYM2xWaL6ZqZr7wCkF
14364	payment	1726	1726	1874	1	1	4932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgn7NyWLB9sXmqgme2kt31TTVsFu4J5EcbCQ7o9Gy8ZARtwHS
14365	payment	1726	1726	1874	1	1	4933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSmtMJceFmSd2J7n7QTuPXTKaDQJTExism5LzbLhMjhyn2Fxj
14366	payment	1726	1726	1874	1	1	4934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Z99ptR1iJZE9yzJQVVsaTtHrRrz1gYPCTzkMx5E7pcJrZn9P
14392	payment	1397	1397	1678	1	1	7211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfUkwr4HL3Heyd2toA7pFvW1tw8bdgXoJhALvMTXGtPrt3rsL
14393	payment	1726	1726	1874	1	1	4953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN3ZYMe8UXpfVW2SWvko8yCVbqc7yBakz7RkRUsWJ55omKTzq
14283	payment	1726	1726	1874	1	1	4872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGniAtLKS5AKt8xky9x3qxprGuXTyzGn9Nzm8yD6BGfpUJqRmS
14284	payment	1726	1726	1874	1	1	4873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNTKZupuq466oAHBWDkmdNGLs9NBYAU67MofWRXceJyrhTh6A
14285	payment	1726	1726	1874	1	1	4874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBafZSs13feUhCHi8YC3S6cUFtrh5afeHbHQHKS3gReNbRiAw
14287	payment	1726	1726	1874	1	1	4875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJutyjL3vFAzovsHvBjuGtdKehbhxyY3U61qxpSvMdKt3QCYbE
14288	payment	1726	1726	1874	1	1	4876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzE4vVoXNKTvAbj2byEsSc6HHvZBJL5XxQ78tqDMkwkxkoXS6
14289	payment	1726	1726	1874	1	1	4877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qo8UWs6ZtueRPVpq52yBq5zVMHiDywZnQdG57oNzHqKAKqMf
14345	payment	1397	1397	1678	1	1	7199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTeSxAyRPoytqyWxU8UipnWfh453xjb891Guq5MEE61T9f9tY
14346	payment	1726	1726	1874	1	1	4918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7AV17Db2FhzkPtrXWCUiz6ADkozNVxz8ncgWRVY9Ug6q9hXW
14347	payment	1726	1726	1874	1	1	4919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcgrp4FUhL3oaSp3oKdxFYFZHpu3RvC8PZMMRGWEJKX7AR52s
14384	payment	1397	1397	1678	1	1	7209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLLyj9bYAwGS3Pi5vYayAxunvsLnMGmjMq4TN1wYaKPHoz2tz
14385	payment	1726	1726	1874	1	1	4947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XgaYmmFkgjVHWiDf8ZJNXHXmuacqNSRxkQisQgbDL8oMfCeJ
14386	payment	1726	1726	1874	1	1	4948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1X2tymX5nvYGHcJ6RX81qjHSsTGWPTWcfm6jk3qpB9YmhkRgE
14387	payment	1726	1726	1874	1	1	4949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFAT6dr6voftzYPkoCzvQYrJT59kwknwZqD8eeBFEHLwcETsH
14388	payment	1397	1397	1678	1	1	7210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMdCR8jyZk99aSmWjP5TBpjNpgw6bXrDqRtZr2AmeXeHBCJ41
14389	payment	1726	1726	1874	1	1	4950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXQqZP2J7mxWHjQSk7VHK7efJT7qPAD2DnRuHfhQN6ztJfz6y
14390	payment	1726	1726	1874	1	1	4951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdf7QjiuPRZBfhnzreECpCbn19sJx56p6RiB7MAwYdyh4ZSZ1
14391	payment	1726	1726	1874	1	1	4952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxE2mgQHykCuXjdjG6kDgxXa224S8Auki68DYnnr3iK3194UKa
14428	payment	1673	1673	1122	1	1	3	4616070000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYzcUb3iZT6yes6hmvkYWncpaa1YKiQhfaXwmSMWUPHtZfRi1wg
14429	payment	1397	1397	1678	1	1	7221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatdMZxMWSzKehE8QVd9UyfMysotxpzFXo3pq1FohymVgb1xDv
14430	payment	1726	1726	1874	1	1	4978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCuEDqgfsSo8ocSyY5Q1AvtMUYGwXvdKh5DmCPs8bmgpLApFu
14431	payment	1726	1726	1874	1	1	4979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTYJrMEdjVt4SPvoHSNTpsxt81kK1kxJMViHkgtoVq119zWdU
14432	payment	1726	1726	1874	1	1	4980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGv5ubevVNzjq69WXFdCtZFmTPNssdnotHjeCHXuj3thxdtUb
14433	payment	1397	1397	1678	1	1	7222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBi5s3aYjrgg5pm9fBtV3MuKBowvo7Kw1UyYrykaGyDjcFwpUm
14434	payment	1726	1726	1874	1	1	4981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAnrwJi3BqFXQ3RXLBAhJUZb5SrMjDbqeTGFUVkBeE3GkT4wL
14448	payment	1673	1673	1242	1	1	4	3114410000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYZJj2c3zruxPccpTiETQbyRhnNhmmo2875pgtER1PwafSiChF9
14449	payment	1397	1397	1678	1	1	7226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDn1AtGJcAzHacbsudxCtdEpbewxJvKXFRmvHDBnBS3cEHkFP
14450	payment	1726	1726	1874	1	1	4988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFC8Tz9gRe2vU9b3nLEqtumivmLqkFpn2kgP191i6Nf7ocBCTT
14451	payment	1726	1726	1874	1	1	4989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSCgJNQxXdNdeCE7DdT157uKVofYgJnDq6bNnzYpr2Q8NubKb
14452	payment	1397	1397	1678	1	1	7227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmaNposUV1jwU9b1YrfcoTRmQkuJxV28n8vgGk77UhDux7ja3
14453	payment	1397	1397	1678	1	1	7228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaPR8jsBNCwcUABRUCbZVb9iEDzZakQZzT6DPrAjuTiGZeR8P
14454	payment	1673	1673	1002	1	1	5	2576830000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZXafXa15Kcg7wuSLsaS26GP85ELTaSKnmdA4T9vsyYiZVh3g4g
14455	payment	1397	1397	1678	1	1	7229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MJnM64FvUrWEXzXfUer44jXBeMWjNhC2N2W7rqrwJD3VMZns
14456	payment	1726	1726	1874	1	1	4990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomtHRohbRt7w811ecuBreWqKXuiD3kxoHPeMmRzNMXM2kAyi3
14457	payment	1726	1726	1874	1	1	4991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhwedoHne686WvTtr3acw1UdXpEwYtKskriaNqHCtJsEkXLG3
14458	payment	1726	1726	1874	1	1	4992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvuL38UAXKmfFXgwbGFL97YyvvvXYPAD9AVMUPTyncqqzEacA
14459	payment	1726	1726	1874	1	1	4993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVC1LeKzUarJbweozzckEWgz3m8hAiSbFCD6SFPtLJVqtNBBws
14460	payment	1726	1726	1874	1	1	4994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhhN1wnaZWaygWD1cdSwwjyqftCPvHtWjEvsNgUN37UvZp4rE
14461	payment	1726	1726	1874	1	1	4995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYsanvkTJh2dXwPZKMJZxTeLQsiHiqFBzNq5fAGiC8Qihn6MB
14331	payment	1726	1726	1874	1	1	4906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQ9XVtyGw39jGtQzq6xB9bGwaGQGp7jahuF4tVTw3NZvbpQrW
14332	payment	1726	1726	1874	1	1	4907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpg7qFS4ff3ty7h6Bw4H7yzjg5nLbCd11SgYufQMCfMKEoWek
14333	payment	1726	1726	1874	1	1	4908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vkz4aDva47rMJDZz8PksTxNEFytgbfdoodBJwYk5rpPaoNxj
14334	payment	1726	1726	1874	1	1	4909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ77r46PZpEqQY8MFpJnUC7ca7KWBsFMRJBpgVRH8Xqx4kUet
14335	payment	1726	1726	1874	1	1	4910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejhaap21JU7nEU1FtPYctSqyAwxyeWbde3b7CfWN4qo3PeWfd
14336	payment	1726	1726	1874	1	1	4911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknTnaP4fpSCMdz5GVgVydXtCPExTxtj6ndB4Rrp4pzYubqBQa
14337	payment	1726	1726	1874	1	1	4912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWsTLzJb14TRQPTsPxumKWchTbfFbK1C8rk42thoDD3Yq8diw
14348	payment	1397	1397	1678	1	1	7200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTB1QYfp4TXizcZw5DRGz6598j3fGa7jXKp4sXBEpwD6uWJF74
14349	payment	1397	1397	1678	1	1	7201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSi298MSmfM7JnfcigiJ1vXnrmanN9UfpPxAsa8YucJoNsLAzx
14350	payment	1397	1397	1678	1	1	7202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCyPWbF3CQ116zoRdxMvhEDUgK7w1k27jPXwmNCdfrLvfjLf8
14351	payment	1726	1726	1874	1	1	4920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZ42opzjwSxxrJq6wvAnNUjDyWAhNNxyVcg9Sc8QmDAFggeGu
14352	payment	1726	1726	1874	1	1	4921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuK3eLRQJBEk8C2FkpbYxx29MrUQ8nYQYsvtHVjPgy4BtjRD36
14353	payment	1726	1726	1874	1	1	4922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTEVrna1btPAVjiDHXzVve5aCnbiz6fkajL7p3oh5PqzuZE5M
14354	payment	1726	1726	1874	1	1	4923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNQVEbcKpu2EhPr2ojkvjZ2sjFWu3uZ7jR5YhTZjpUf5DmZan
14355	payment	1726	1726	1874	1	1	4924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DUTs9846UEYVnTags5WYVAhUeXbPds3psicVxfuMy31EACej
14356	payment	1726	1726	1874	1	1	4925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnioR3d1r3bjFDvyPcsU8NdcnsYoU9GvfUHgosu5gLgPorn2zw
14357	payment	1726	1726	1874	1	1	4926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5vdkXG6Hhm25cANSdgRf3wFkZvYnL4YQ8EgFvd66oXtNZaiT
14358	payment	1726	1726	1874	1	1	4927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaRBRSVGFepg4ghjMySTNArebcbZBRpQjPFBpCVUq1nHyt9Sr
14359	payment	1726	1726	1874	1	1	4928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3AMB4tSUNBGwc74gBiDhn2kihuWEbeeE2LK6g6uMRv1LpXEs
14367	payment	1397	1397	1678	1	1	7204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSVCKEM76RsJKkKY41K4v5HYJQkUtuEe61d2zvDE9skzX3EFB
14368	payment	1397	1397	1678	1	1	7205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsbPu1a8yHMrH8m8bwCwpciY5j578Ty6TwAjidowQud4pbzrq
14369	payment	1397	1397	1678	1	1	7206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfCkXNzvw9ev7ob4QZcfwGkMTnvnnKa2LPfjQmmNGYatDhXom
14370	payment	1397	1397	1678	1	1	7207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFAbbepq9VVKPBvTDMHoP4zEhbrb5GbV5gp3GxLmWaHmmPZ2M
14371	payment	1397	1397	1678	1	1	7208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAFeoBDQ1285X17oX7NxWfs5nbkopEcojwcc1rqCAmZsgnqLF
14372	payment	1726	1726	1874	1	1	4935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKfMjZnjiBRQL9TDKWrP4pLfKShTEpzMZKKfxqSFeBvZtFyDb
14373	payment	1726	1726	1874	1	1	4936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDxg4bZ4TyeragmdyevSwEV835gfJRADj3q7ihmVnPCJRdQT4
14374	payment	1726	1726	1874	1	1	4937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xST9YBi25TdAdE5SGzVLpcxPfhEoF2cr7svUosE1SqGwLTuP
14375	payment	1726	1726	1874	1	1	4938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj6xYqGTS2tavDorNp7x8uEuhytN7vLRSYZobSjFoQmqjPLYD
14376	payment	1726	1726	1874	1	1	4939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC76TfjCzcXoBdywHwwxwdMdhhgrvufwffeeCDX3BGQPwmhgSk
14377	payment	1726	1726	1874	1	1	4940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNT7zW1JeKW1T54JjdsSjBWxbpRCvfeTJ8pqW9hm2XWCs1RL1
14378	payment	1726	1726	1874	1	1	4941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuomALtpAazHjTtzwBndnDLFpXxqvDPQV22kUdn96f5bAsYd5G
14379	payment	1726	1726	1874	1	1	4942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrGuF6sgJUrHJXco7SJKPpmCpkBte2Bgyc8hxh4oiLmAkgQDj
14380	payment	1726	1726	1874	1	1	4943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDTuRAWxf93SDF7dpwSnDabbdrnmkUw4Jtz2AX8aRjWNzsevoR
14381	payment	1726	1726	1874	1	1	4944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRps6ZfXTWJaeuP5wg49xat2npAofpgk3E7ybDPPH4SygpiUSS
14382	payment	1726	1726	1874	1	1	4945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr58db5DTHSWMDdZXdtdNPJ1wthCK7RpatmG2BvEbVT7mV5syG
14383	payment	1726	1726	1874	1	1	4946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCZ9JVChH5QTLCh5TuLNH8BXUcSmDdGy9Y39yx1cSGMdu8Xxo
14435	payment	1489	1489	1014	1	1	0	2552961600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL9DbXwzjo9nTahPmwSjB1oCKbjeBTMUbjGW3QiUn8C5yVxkk
14436	payment	1489	1489	1134	1	1	1	4575412800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkRR2XgMexnJNiAmzUYnaeNjxR1e78CXC2j58YFEHz22h9rcr
14394	payment	1726	1726	1874	1	1	4954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCYd6sQRhc5PJPRx9ZFiT1MUxYA47x2vMVndFAv7r2C2WNFAV
14395	payment	1726	1726	1874	1	1	4955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLtFdonpM6zsdT9cbBzfafqVNbmV3rTe5C1knusdjD48EgP1w
14407	payment	1673	1673	1368	1	1	2	8680660000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYcSAh1vAVtDtp4Koy3K7GDzds8MU7ZYdyk6zZY8efSuPkkyuT7
14408	payment	1397	1397	1678	1	1	7215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8uhctxfTfmcAALZZuVxWJinMJk96zM5FQnTaPXTB7q9jw3jh
14409	payment	1397	1397	1678	1	1	7216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPaMbtomQTgP9kTzogAEKCW3JgcG7c8RPDnYzCWzZRL73g8k9
14410	payment	1397	1397	1678	1	1	7217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4k6wbzUbvxUbipgwQjN1WH171qcpQMYD4SN7hHeUmMJ1F2sN
14411	payment	1397	1397	1678	1	1	7218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdG3wyEzi588kzFAvXUkULoEPXo9r2z14CyyCm5WPaNHyUGEsx
14412	payment	1397	1397	1678	1	1	7219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxr8MYBT9DdiBNqdSXhPBqM2fjLrbUeonCYrNAJ9wqQMNWgsu
14413	payment	1397	1397	1678	1	1	7220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7EzNtZLpB4cVj31ody3URuGPDy3jwx7SMw15vTatpCYXNQnb
14468	payment	1397	1397	1678	1	1	7232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2y5WRCY3NjDALdJCmjLcWuFZRzXfLiX2rhJ2jKsqfzjFgYPY
14469	payment	1726	1726	1874	1	1	5000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkziAnJQqw8D8X3rtSqZ7LnJUWg9yyoGzdtVYWJcHYMJ4h4ej
14475	payment	1397	1397	1678	1	1	7235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2oucMLNdEHS2q9Dzh8uGcTkfeBkaf4ypiUSTLZXZGPXoTHWs
14476	payment	1673	1673	23	1	1	6	166630000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZgy33UWXUic15Rd7eFnYtDJ3kXe6N6WLwzCZNwCYSbWtV7HBDh
14477	payment	1726	1726	1874	1	1	5004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzaMsYyetY6eD3uhs1pJdKbaAMx4ptvRTnePUHYdfkTL4WXrx
14478	payment	1726	1726	1874	1	1	5005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEEtk8efVSi4XqD348Z24bPBQQRfQjCiaGknn6Jaydz5MBZ4F
14501	payment	1397	1397	1678	1	1	7242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkgXxBXTNbzdWpnVjUrHcBbBZty8rr5Mvr5yh9LJji8qxXKEd
14502	payment	1397	1397	1678	1	1	7243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8ZvE1m6a9aGB8E4yx9cjhWixAeCNkSEz5Yg6jaYRV98AcEah
14503	payment	1397	1397	1678	1	1	7244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKXg3PQwf9T94hPTKL9fCafenoF1htGKfMP6vDvNbyDScGUNr
14504	payment	1726	1726	1874	1	1	5017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJL5GbfvM2ebyf4xxbUciZSqw4ChvXRdf99NgmzFh671x6VpD
14505	payment	1726	1726	1874	1	1	5018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXEfoLYpZScBDLvWxUzgnHtx5gTsGE88JYJq8FEB1W9fA83mE
14506	payment	1726	1726	1874	1	1	5019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSEptj7fgD9E4CbWNcjowWVFCw6GaAKW4iSKUcYStZsizoJAM
14507	payment	1726	1726	1874	1	1	5020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6VQCKRwfDwuo4N15NeoTYmdHxbjkpVRrKcP883xvgqoC8vYM
14508	payment	1726	1726	1874	1	1	5021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBabTZ78HA93JnFJeCqbEYsdnU56o8MRyLskht9ckQtr1DBBt
14509	payment	1726	1726	1874	1	1	5022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGqqHo5yJkuxXfFFBKjkW1hBsFniRFi4fQSxVdcmwbDTKqmFA
14536	payment	1397	1397	1678	1	1	7254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNtg1y8v999kZPDufBVYUDzniGZs655QQSghcLTProg5EKqLd
14537	payment	1397	1397	1678	1	1	7255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iq4r5FBvP3qjDBDFxAVxQbyJL7TPUqoB74uVDXekjybws5ZV
14538	payment	1397	1397	1678	1	1	7256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx2FAWkPbc49o3iwbAwsZoGBSxKzDsv1bDAZqHJPoAMHbxeVGc
14539	payment	1726	1726	1874	1	1	5040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9UTPPHWAdZhVi4RLQCAqAWRW1kRt9urzryfGyRTQLgNdgJbg
14540	payment	1726	1726	1874	1	1	5041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9MWxyPaNBiwtbZNvXmZfQYdAmhZAA6FzVQD2bQ2GNhdTKU3M
14541	payment	1726	1726	1874	1	1	5042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFV9aecv24EQsS2L6ZWTR4VMbP1uaovpZp6KFX2dxrVcH8UG9Y
14542	payment	1726	1726	1874	1	1	5043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdUdjmzN7528cCQo5YcX4Ha78NowjeqjeRbDA6wehD73ECoaF
14543	payment	1726	1726	1874	1	1	5044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVGXH5LRJ6eeJcM6hUJwfzaXiaPsJ8ihXRGrZS9NKQ6xfbBTg
14544	payment	1726	1726	1874	1	1	5045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUxyar98LprdvME9eEupEcmpxaMELkzPorb6EMzXCSS7GUQ3w
14546	payment	1726	1726	1874	1	1	5046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPz9CzggTStVKGyzApgcmaFCjNwXe7Rw8xZoNuehdUn9VgAe1
14547	payment	1726	1726	1874	1	1	5047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHGf9YCPL2G8qpXuis96ZhdnABYn1V19kfBsGzkLdWdA2s14w
14549	payment	1726	1726	1874	1	1	5048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunTuc6nzJWrP4Gjw9fGxZZcTpW63qQsmm5M8tdEd8iSqx46dE
14550	payment	1726	1726	1874	1	1	5049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUWa74yPWRzrv5f3J1DYNN7dipZW6pcnsvwMZiq9SSWM63hvc
14551	payment	1397	1397	1678	1	1	7259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCj1H3nh5oy1oTHRYy8A368W9hhvQWFLNGAEyBTcL834PVCsgU
14398	payment	1726	1726	1874	1	1	4956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmGr5HihK8U2q6bvzbZNzfkT5PKaLSPV8J6eentuKgJcF3rny
14399	payment	1726	1726	1874	1	1	4957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM81XbESqXUZmrva6xgiw4kBtGFePkgeEo4JBbkQkpCpwLLXCG
14400	payment	1726	1726	1874	1	1	4958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwV8AM3BTkRisPLrCPST2FsqEk9w65JcRL6zMHXuJKP9iuPC8
14401	payment	1726	1726	1874	1	1	4959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND5mJo1eTHxbmiLbimt18YfS1jTVTFqVzY4xDfP8n8gRptYUp
14402	payment	1726	1726	1874	1	1	4960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjfqYrfJu63UYC4q6BHGVW3VjPEhprJAB3tTusb8sX7Hgnyvv
14403	payment	1726	1726	1874	1	1	4961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYPDcnZY73zEKrLji8ZsNu6atmpf7JjsMxXEu5gQ87fzZkcCi
14404	payment	1397	1397	1678	1	1	7214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfpkatvwTQb97w9S4E6SvAEaTS9zqmVXkpkLKA9cFMWZZdi9F
14405	payment	1726	1726	1874	1	1	4962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7Dai4XP5m3ku9ADYCUw5d1Ts5eTF5LgUtJaixcgqNfWepNH4
14406	payment	1726	1726	1874	1	1	4963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zzRYcTVxqScdtfNVn3w6mke37gDw1xBh3C3LE9GsEfgqU5Lq
14414	payment	1726	1726	1874	1	1	4964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFsWcHLuDbSgpWey67poNrLoPU4yeEcFFR7pxaswsPoRRGD5P
14415	payment	1726	1726	1874	1	1	4965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUE7snTWZ4gvSUoD4Jt4fR99z17wQyW4MiZvFhnaVtXEKz372J
14416	payment	1726	1726	1874	1	1	4966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8uaJa4J1RLpS3wBt79AzYTUgrWg8Svf76dkbjA5Ntg5KQwhn
14417	payment	1726	1726	1874	1	1	4967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf7Lk66PncNRMGN8MBDK8AWnANuLnpHbfCY9QosA6n86Yu7mf
14418	payment	1726	1726	1874	1	1	4968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMZLcr11eUBqDatqnLrDfpGnZEGqcbe5RMgLMWvaGCeAyH6WN
14419	payment	1726	1726	1874	1	1	4969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEgJU9TW9y7UZuyVBB3PFRpVDfDvzgu3XireGnr6JywJY4tz5
14420	payment	1726	1726	1874	1	1	4970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURSiAE8SaTMYQqUGJpsdNR9aBuCrvC1bchjHCX6kf2wCHC4Jo
14421	payment	1726	1726	1874	1	1	4971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkv1v4MZJVZ3oSVJ4Pjc3NamkAQzVQDxP3hsCbvTS3T2m1Hf1
14422	payment	1726	1726	1874	1	1	4972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaBR3toDVQV9msEifnDqSKCQhPbL6d3B5V9j2pb23nNijyWje
14423	payment	1726	1726	1874	1	1	4973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT2sDj9iWR7TDggTemi8o9Z3zzMVFK4zMQGearfgZUC7n6nqa
14424	payment	1726	1726	1874	1	1	4974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZGEjghnfJAQaNy5cgQaRzvUVHGuENsWWjCVpyoGoAHFsQdKB
14425	payment	1726	1726	1874	1	1	4975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3PQHdGUhkQp99tqsZXBong1DQ6BTerVJ61HzpCtX378nmmps
14426	payment	1726	1726	1874	1	1	4976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPjzvC5PhRGfKxW7n9sxmwQriV9pbmre1u8vyCEYgBMN5wb8e
14427	payment	1726	1726	1874	1	1	4977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4JSwmDpTXfTPYy59cXcBhV2PB49y8N5rDUmNecHehRmhGRhj
14444	payment	1489	1489	1380	1	1	3	8601163200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2rmhZGw3AR97tdhZZAmPph38KTkfEqAjJd6NuucKWesQykLB
14445	payment	1397	1397	1678	1	1	7225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTYzumfjvioX49NU2E4PWZHCZchts79ALk3u342yQKhp3AiAt
14446	payment	1726	1726	1874	1	1	4986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYe62KTkgDyzeCBXZttuQis8hUeheS8PeUZLAu5SmWhj7Tf4XB
14447	payment	1726	1726	1874	1	1	4987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1YuPmhHVetfBVUBUxW6b8hZ2wUK6W2MBtckoi6zDpf1r5aCP
14462	payment	1397	1397	1678	1	1	7230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipLKdhcRb3cRWZFHDig7UtxrsPmciWw3YF8gz3VEfYmx6pWHu
14470	payment	1397	1397	1678	1	1	7233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2cPUpvJ5mVT1hrSAzdai3ibVxxh98nA9V11kuou9E5aZC4h7
14471	payment	1726	1726	1874	1	1	5001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1X5gWvFVFZbcdP4BXXpzQqbW8wAtNzk46KZuEA9VyqMFh9Ch
14479	payment	1397	1397	1678	1	1	7236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWrJWV8kkMGqKLTgy7VUBVFiK5cCHuJ9ab7AxV3UiQNwWo8Az
14480	payment	1397	1397	1678	1	1	7237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMi5VxhYcUWShnSuKaAe79H1hPZwki9jfXMthhyk4ZigFV9H2h
14481	payment	1673	1673	756	1	1	7	5950000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZYRpFEYWK3WRismGAHE8U7i8vsFyS3tUxYNA9Brx6i9MVPmQmv
14482	payment	1593	1593	1346	1	1	0	7977000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGZhNdm2Hmqnp9hYsx8HDZoywaG7nn86tbfhCDYkP6JN4CcSL
14483	payment	1397	1397	1678	1	1	7238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eKchn37PwNHgoCk1xyujEEhqzNsfdBsFeiyTDhRGAou2yHMY
14484	payment	1726	1726	1874	1	1	5006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4xLLkMwMXLqa128qLFeVdrNQRtkS1mX9W4j78ZGE9BhUthq7
14485	payment	1726	1726	1874	1	1	5007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQZTmgXGAbSWp6VDWTarjm4SE48hNgzGoF651NcAxNSWmhz2i
14486	payment	1726	1726	1874	1	1	5008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRrqN7G7Fp7uLFJHGoCdHkzGPzTDBLa17kgv8Esc6Km7LoQsQ
14437	payment	1397	1397	1678	1	1	7223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3S9UY2bn8RjRvaUv293EcmXdgbV6rZFzoobBuCnsf18cFX5H
14438	payment	1397	1397	1678	1	1	7224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUGTB4iSoh6iSpJ2haUU5Jf5CcueGuuzRJZYE2JH9HN9HvRyv
14439	payment	1489	1489	1254	1	1	2	3087302400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZEc4Rc5FpyZhRHxf2kuJCUNacrsJMybyuQzjpDNZesoANF6M
14440	payment	1726	1726	1874	1	1	4982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRwU9z4s585ns2btypZCYRFAjUStWYpRoL257DGVWPmMo1xTF
14441	payment	1726	1726	1874	1	1	4983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQsBakeXBB9bdskXcGFaULXF69AJAzhV5SgSNw8WNyJ5JqUY4
14442	payment	1726	1726	1874	1	1	4984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYmfgsW1s7BH8J7vwJbtbfADWLdkTzH6VsqTPpSfjx3Mg5CQX
14443	payment	1726	1726	1874	1	1	4985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZfhSfFnvFNCwyfsfP51iztBcX6Sujsvcjwq7W2RmjZk81wZ4
14463	payment	1397	1397	1678	1	1	7231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxof4adnvr5NgH4uQ3zx1c8UHYTknb1q99QoLUnEBgwiccLJjE
14464	payment	1726	1726	1874	1	1	4996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgVBp6TJTCpN21DK4Xh5ZewCyrEHTVkQdGYioaA7nZtiECsta
14465	payment	1726	1726	1874	1	1	4997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRj8ESADFpwJXr2w3ogcQxPL8FQzjc3575jzeUwnBWiSqymqoV
14466	payment	1726	1726	1874	1	1	4998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMYgWg7TPmaU7WjGU2pz5JehzN1GBvGcdRkPJ7ARG7m7qnTmL
14467	payment	1726	1726	1874	1	1	4999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKurL7wwqkMi3ebYDCjrdJZe7ih2MJKBWdtxafTGAag2yafosu
14515	payment	1397	1397	1678	1	1	7247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdx5NNMQRTQmgH4WT3ZUM7h2NY4M1LDWsZpYk21MUVjtvQ8RS
14516	payment	1397	1397	1678	1	1	7248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm67NKzMDZJLH81jPyK3HQYHvjSvWt3DPTMxqzYDazAdQNqox
14517	payment	1726	1726	1874	1	1	5026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot3Z1ZcwbMJDAXCajFzG4nUSb4Tc3EFZtgS3WuHR1KKKGiJGk
14518	payment	1726	1726	1874	1	1	5027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1kb5VCvz2Ds9xEBuxt8qGFrnNC2VfGRHJrWpvbua1qy5rzMK
14519	payment	1726	1726	1874	1	1	5028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJZUKXXTzqxGDn3hhPby5iVhs3hrPTtBCXeffXU1dBWT95JiF
14520	payment	1726	1726	1874	1	1	5029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXfMkLBJP2MAWchYH9U5KFjCAFUV2wrHg4CwdTcoiAwPZgviG
14523	payment	1397	1397	1678	1	1	7251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqNUBj4ezJ8ne7KwKft35H87hBeBccYPB6wpSjMf3HLCZYh9a
14524	payment	1726	1726	1874	1	1	5030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFiwdZKj7S9v9bSnUbWxh4z8cSh3jQGBSKjuhzXQtr8CLN5o7
14525	payment	1726	1726	1874	1	1	5031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsseq9DCje2spdu28MMbkTXc43RYGwzfYJFb6io27nURKeiXi
14526	payment	1726	1726	1874	1	1	5032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx7XFSbKV7A9azKYoyNBK7SYLt25nPQwPvddbVbWXNWSVsCz4
14527	payment	1726	1726	1874	1	1	5033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsYFWqEmkC2MqeCtjwzenQpiUDQbskCyXQsuKE1FAn2LsP1Ff
14528	payment	1726	1726	1874	1	1	5034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EA87KmAszVadHk73RBxP64RsyfiZT91YyUpWBxJ3PEkYMq4M
14529	payment	1726	1726	1874	1	1	5035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyK9wzTJEgQ8YCNpKymJvTxxZHBSKatm9aw17sVE9pV7FJxU4J
14559	payment	1397	1397	1678	1	1	7262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkpJhimMHHvUjtGWFyYqtYSWsjbcfw6onvoEGm2u19XU5V8uH
14560	payment	1397	1397	1678	1	1	7263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVAdjwwovEgijcyfb8n23dQikSLzDQSZgLP8z6BZiyRbr2hCR
14561	payment	1726	1726	1874	1	1	5055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHJKVj4X6sT2wx5RTpQTc1Xr2d6mQXUagLBGnmZ3VH2Tp9Gwa
14562	payment	1726	1726	1874	1	1	5056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHg6NJCkKr8vhmohFiviFbSbkxFTzPMtAuPtExLXiaoxygZeWi
14563	payment	1726	1726	1874	1	1	5057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8v6sQ2XKhCQeCXnNAdExuW3vsez9qd654vaNuzjnCxLghdYP
14564	payment	1726	1726	1874	1	1	5058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgYZGU5f1ZjVYZkMPWxUydfN2mnyJCDpG8AVe3qvvabdmpA3r
14565	payment	1397	1397	1678	1	1	7264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb87fDo71E96VrgTUnpxo12oBXyMDjkL4bX9a4hqvozm7uzWR6
14566	payment	1726	1726	1874	1	1	5059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhni2DxA7ViDWsPGjXo8RTHypM6MBPq9AuvEGYDpwHLFxFm3R
14567	payment	1726	1726	1874	1	1	5060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1NiXPpgjfNhWXYSBD28crCQ8fiqPU6L11uxDfUNdXWgAbksL
14577	payment	1397	1397	1678	1	1	7268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYheaZiHz7h2Qs8T9czBFExgZMV2NmdF9Up3PJAaPqLGmkh7pMB
14578	payment	1726	1726	1874	1	1	5067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeK4TYYAr7bgDyprDn7jT6prWHJ7q2JELh8opmJmxAwxShcXa
14579	payment	1726	1726	1874	1	1	5068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1MRv2vo7owk6S5SYXLcTkwEane3qjMcfhuAfKxA1srr38KgD
14586	payment	1397	1397	1678	1	1	7271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPSUHdDBUgNtnRP3UQDFY1f6M7Fyfp8EYssiU6LbitrqSrhZf
14472	payment	1397	1397	1678	1	1	7234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiDuDD9KdfQBdwzuFRJ6DQykYR4mnivWqx2jWdT2gK5HJWZrc
14473	payment	1726	1726	1874	1	1	5002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HaBR64FiYRWWp4e54hNwbNn5g7kkpT33NAJm2vU2cREJXxmw
14474	payment	1726	1726	1874	1	1	5003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMLFNNUJcTmdF7rVuXgtUh5btNzj49Vny9VLiFrk6KFa4rxci
14489	payment	1593	1593	1100	1	1	1	4243000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSJVNvaTunnQkbNRfZqTE5TeUkJCUR5Pac8p2pVK9Y5BA8jUo
14490	payment	1397	1397	1678	1	1	7239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQNr42vPyFpCkcUQzbZAMyT7MtwVukTtwt2JniQdQSKx7etx3
14491	payment	1593	1593	1220	1	1	2	2863000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweKUPaT32wtfK3GKoFyjpGBckTZqFgnarfUDeoaK4WEAPN4hc
14492	payment	1593	1593	980	1	1	3	2368000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkPjWh21WmxTWRVuygme4B6Vk2nJptVeL7Ynqwp2krTQTsKGY
14493	payment	1397	1397	1678	1	1	7240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzKrUdSDQ4YvMSZ9VSJtB7vnFC6UPEAPnkkEH42z51VwiHWQ7
14494	payment	1397	1397	1678	1	1	7241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKqzD67Y2hqxsBddpbymwjBxcimiwi3aPtgCoErPSyWFkuzpw
14495	payment	1726	1726	1874	1	1	5011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbN2iYTzrRRi76vcYri8UxdjhmgTeA5hpTWsJPBiV3M2jAUK3G
14496	payment	1726	1726	1874	1	1	5012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdQWSRZy6dm8DBcGaR8FzreXcnQzepiiAkZzXNz6fG4oj1HUW
14497	payment	1726	1726	1874	1	1	5013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86F9sXHpVcBYr38pSgaqwVcUg3pEseQiwxymr2w5u9KSj2bby
14498	payment	1726	1726	1874	1	1	5014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehaGzH7Sv5qdvm3TpCGE6RCXwsfdxgU3WUZndrSAUJuzG6sNy
14499	payment	1726	1726	1874	1	1	5015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsnZLGHyX8Y5CCiNro4AUYrjpHXQD3ch28MxD9VfZfgcVKK7N
14500	payment	1726	1726	1874	1	1	5016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDQGFbyc2copdFQTTkxEWvRxxULULrzEYycz6MmburqjDVBha
14511	payment	1397	1397	1678	1	1	7246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPDMGbhSBf8GJuRp6GaKoBJCJYw8G3xKro3h4McNHGqf1abBQ
14512	payment	1726	1726	1874	1	1	5023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FWP1gVuRKH6iEqeqxVSRZwnMJERPMcqNeu59ZeehFk4Wa6xb
14513	payment	1726	1726	1874	1	1	5024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zo5sM3LaGuvrBhyjkw4XGopGbMrYxzuhTSNLHsefnUvv5dH1
14514	payment	1726	1726	1874	1	1	5025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ko8uFCZLPgA55ajPJv588jJpf8HQ1irKXL8S8Hfw9BfoFmfE
14530	payment	1397	1397	1678	1	1	7252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwSuzJxEk8GvqsWtswseJnEiYywsUc4NSERWrsmnVbR6MEXb
14531	payment	1397	1397	1678	1	1	7253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSfrF5JbTb3tZBwjSFdFYR3Yt5Z2vfeWy8VtoTpgS8xteqSQJ
14532	payment	1726	1726	1874	1	1	5036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fFBuaPxcg8h9DVziagAnRMUbrGeFL85uUPDvZLitvaD3LqN1
14533	payment	1726	1726	1874	1	1	5037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQgX9QvDmwWdnu6vZZuxN9sAgQNZX8WSpLMM9xUKmJheUVWnU
14534	payment	1726	1726	1874	1	1	5038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93G8WbKw1spXK6twDodL6bNiEL8Ktj5UXZSfcFRWvEDUoheeH
14535	payment	1726	1726	1874	1	1	5039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwWQAvtzcxk6E3UWLkc9yERtRpsLBwKD3KQiig1WhRUG3gfMm
14545	payment	1397	1397	1678	1	1	7257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvvrqd3nuP9Gtx6WjVoRsGJCHJkkBqpoS7wyS4qhvUMxanseW
14548	payment	1397	1397	1678	1	1	7258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuQLw3hfJBmCJ3aN1Ab4QiNjBsNcPPwqU74t5gnnBLbvygVsH
14571	payment	1397	1397	1678	1	1	7266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDJ5pNuG52t6YttFXkamabGTQak2LoDwHf7r6Nd5wpvhkhSJ6
14572	payment	1726	1726	1874	1	1	5063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGtitHMnCBVznQhCETwKNEadFz77avKUqKBbEfzzPe9L6crRo
14573	payment	1726	1726	1874	1	1	5064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1P1YG6d6PJdWCs32E2exwfKpSPyzhguo9pH7NJoWS99upDSC
14580	payment	1397	1397	1678	1	1	7269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnuk7qntQAtAgNZV2pEtd3m4Xyhkhd9fW1Lbuu2tfuriE5MMT
14581	payment	1397	1397	1678	1	1	7270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBar2M6sNMJj8p5tkoxUEvDx8Mu9mkvCc72h3dogVZtAy6HgGV
14582	payment	1726	1726	1874	1	1	5069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbaLWQNxifiJdv3c6oVkFj5za5GJgtpG2nEqN6AUx77fXJXz
14583	payment	1726	1726	1874	1	1	5070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfmLbSJjxghvx53oG7SNtxeQ94FG2fxt6YhovGTrva8jeFk53
14584	payment	1726	1726	1874	1	1	5071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFx4U2d8EYjbS887c2kfXHxum5tDU3q3cHkcrZFR7PtM7fLJZ4
14585	payment	1726	1726	1874	1	1	5072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXyB3gKYVJfnVX2qar4Npu4u1ivw9u6FLw4bYvMPi6zJKoV1b
14589	payment	1397	1397	1678	1	1	7272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4RubCKWXBUFBTFbdtGWL8CdsCUXYM2M5SHYULuDquDzUzvzy
14590	payment	1397	1397	1678	1	1	7273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWUWiKSygUGVCTHXmx2hBkHc6BqMhUGApeHtGxZzSGnCkytBG
14487	payment	1726	1726	1874	1	1	5009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSj4XXhdtscZSWeR3ae4eQAUeuM7bNrPVwkk1VLymvpmEbSL5
14488	payment	1726	1726	1874	1	1	5010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2eZ9sq55gmPts4SEZoGi9q1f418ToGtRug4dvdZdHW8C5WsT
14510	payment	1397	1397	1678	1	1	7245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwB2n6Gd3qDYdCA75DenNiezRzsECrtmuTLQvGzpfpV47V5n2
14521	payment	1397	1397	1678	1	1	7249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabxGkm8UiJ57ouLLoEAdaLYdb7pX9NPsiGHQCMdkqc6pNJ9yt
14522	payment	1397	1397	1678	1	1	7250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswBYWpQXUQ2kEeKNFLrifKzTW992XMpnaxUkTFg7QYiba9fvR
14554	payment	1397	1397	1678	1	1	7260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLHGtxiYB8KPNEjjqwDXMsJynf7ZdxM1WjafmWG3niaj9TFXR
14555	payment	1397	1397	1678	1	1	7261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj4HNykrcJfDESgC1vcpezqLyrxqtYJ4SJmUuNdK9bR5MTzFu
14556	payment	1726	1726	1874	1	1	5052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvnB3XPubwGCdiCyJWn1Q48NVawz81ba11drCfP6SNEM9Nrxh
14557	payment	1726	1726	1874	1	1	5053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc6foBFVGJf1ivQZTbcmPKdvC7v2DcxCEqJqR5KAFsf6JsRd7
14558	payment	1726	1726	1874	1	1	5054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfrCKZXqorKHJCBYmFqL8Rksg3H32uXwSZ9bS5ezUdHcvVUB8
14568	payment	1397	1397	1678	1	1	7265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DkCWXsahy8SX6yV7ebAFQP43DvDpb9XHxtCZjKqS53QdvoeM
14569	payment	1726	1726	1874	1	1	5061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmibyozeJpMUGTsja8FjLpL2EhHhZrahXnNdNGGSSmWM6GRJRX
14570	payment	1726	1726	1874	1	1	5062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPTSsawYWV7JJkJDq1E1sRHVXxPJTcBdfYnNfdtZJTYExybPY
14612	payment	1397	1397	1678	1	1	7280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHape9XJrmKarPYN5XJh2effDU8DiKtdPTqVaTKkhymBVx5qbN
14613	payment	1397	1397	1678	1	1	7281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjd4FM99X4wZN4AwEDLS3GTCgzUo58vXF7NjQ7szzjGcZ4w6p
14614	payment	1726	1726	1874	1	1	5090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQKevVcTE8rPCtPfGRheYqcuxpCYipNjjuYnRvjWh3hHsamHc
14615	payment	1726	1726	1874	1	1	5091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZZhhiiiUx6b8gqdSqsHbWShmqsjm8bK361Tp2eiKLjy1GhEy
14616	payment	1726	1726	1874	1	1	5092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu6FYD5VekDaboFVZYquypZLZVwUG3PLmsg1h9bGhZuevWHLG
14617	payment	1726	1726	1874	1	1	5093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MXvRPgR6PeM7Ub9paDZruQC9yk42z213CD6RaJEzwUJ5do5W
14618	payment	1726	1726	1874	1	1	5094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6DBtDgw63PgeHMPkqL7ZjNzJEcxjNeicBMbP1TLN6Roszes9
14623	payment	1397	1397	1678	1	1	7283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdvLiCNRfCPR4VwYyqFj6wA3ZYejY93ZcPo7M5SbjL5bcKwBY
14624	payment	1726	1726	1874	1	1	5098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHrxNePsvZQDo9nEk1RV31hEPN5QMWdJ8mDVUYDsALnpa9FLs
14625	payment	1397	1397	1678	1	1	7284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHutZvXS1uGsCdceJckBgiTqdYFh4FHH9jpFQxQ1jj5JCWwFE
14626	payment	1726	1726	1874	1	1	5099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgF1jK28ZoThaEY7Z6saKDmFzdsYyKkFYxQfteStFm1sFDfCaw
14627	payment	1726	1726	1874	1	1	5100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zSvpxEY6RBzGHLFT6oG8CgRDzYo2k2tMQmAmCgArMu812C6b
14628	payment	1726	1726	1874	1	1	5101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvopUgJPP1vGXXXX5u973kzAJXpi7gjTgZrULuTEpSAZzhY6j
14629	payment	1397	1397	1678	1	1	7285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4tP5ps3mVXLACfWoMX7N9DMqrAVmNMFgnBSjUytjzrg2GZQv
14630	payment	1726	1726	1874	1	1	5102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPFejXHi5VWEEL5J6iethZNvNEunNScLZ2aViBqezKtuRLB1h
14632	payment	1726	1726	1874	1	1	5103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KDHJsT7B7W5TJFQVMxbm6ZLTQEiQ5QcPM99v8mw8Fuemmbuk
14633	payment	1726	1726	1874	1	1	5104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTa2qHWeW3beQq6gM7V5JLuF91EgJEtryPPrrVVcrW55TbMJB
14639	payment	1397	1397	1678	1	1	7289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d7XnW8egfvzr2TGh7WDct46T8u3MTt3WbsriXSK2iiu9X81U
14640	payment	1726	1726	1874	1	1	5108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVWLiqgw8x876AVcvqmVp6c7SE8kni9e2crA5u6Bj4HFcZntm
14641	payment	1726	1726	1874	1	1	5109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqqKibuU4N4SqrYLxYPSA7VFcks9VahXXX2qiVMFvFSvBPUzp
14656	payment	1726	1726	1874	1	1	5118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhqNHf2rQdHEWJdU3JQEAFZ5oezzc6mjgXuQytZCzNBhUpypV
14657	payment	1726	1726	1874	1	1	5119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XZT3u35StiZXsDio28R3JFyDskwoLnF6QyLyv1Xc7sfEtK3d
14659	payment	1397	1397	1678	1	1	7296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ujaUgEthnCadMXncrcviSBMxaGK2bF8gFL2zup5Po4UpW7YX
14660	payment	606	606	2085	1	1	9	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1531FKkPdoeThBWAQJNoyPkg6Tdwk2yHWy4ENtjFBZHwLA53
14661	payment	1726	1726	1874	1	1	5120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCSaSrqf13SGKV4WEN2HD4N3UfWLTLtHbYRY2Pj7zvHqPpp16
14552	payment	1726	1726	1874	1	1	5050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMcqXPXuXEXAU8tvjYypK5MV7aKGf15vssQ4N4yHFdAb5Wh3q
14553	payment	1726	1726	1874	1	1	5051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetvWi1EB6JXSuThWPhjuBP2vxx9ycKdaCY1S7s6aiNcAujafr
14574	payment	1397	1397	1678	1	1	7267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uPBRvt1Rh67QeruALzjY57B2QQt6t1B4EKzipkVxG3r571Um
14575	payment	1726	1726	1874	1	1	5065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcRP89LiPaN4Kiua7Pjtau9npyVKEKjdHiopsBjHVCmZMV8ZE
14576	payment	1726	1726	1874	1	1	5066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdzRe46m1ZPGm9Df57DBx3KGGiFuQ128bhoZnFHfudyCY1DBM
14597	payment	1397	1397	1678	1	1	7275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnEbnnz3hy5k1owaRZz56ffEuDBeki7mvWixysBzmSyFCNo5o
14598	payment	1726	1726	1874	1	1	5080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WCgpTty3Fiss8sF24hGpRYvrGTdFzc3jF1bGEcK1gS8T5sw8
14599	payment	1726	1726	1874	1	1	5081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNH8TkMSzVuooDxQcAp2w3nJjymXficnTi6hZiw1M7LfgNi9b
14622	payment	1726	1726	1874	1	1	5097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwTEBExVjsaRgwL3pGAi8fmtg7rmVJkxvj9zAS6LP6EPpj2YC
14631	payment	1397	1397	1678	1	1	7286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcPT4QQLQWvBcnC3cFYnSDD8gmkv8FMrXRKrj4zt2S3L2nu6C
14642	payment	1397	1397	1678	1	1	7290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgg7we4k3aYEUkyb27W38ZnKeT5Xtr7BvZPjPRJt3u121UvQT
14643	payment	1397	1397	1678	1	1	7291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBS9EbgrSxWBquLRM2vyxaLqFC4Y4FnVJ4sx3QKk1S4kLN4Y2u
14644	payment	1726	1726	1874	1	1	5110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYMcaeHDnD2F1vvv4V4VFh7DREWMdYjuFRfbVuG4QZhbcfa3Q
14645	payment	1726	1726	1874	1	1	5111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MJbkCfvkBvBsQyCZLELMFZE4vd1DXDVqZaBkyqMMio2rw2ca
14646	payment	1726	1726	1874	1	1	5112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicUemhqiXqdkEsN53WLCnng54XDKsithFVk9EoyR3DUEhsYxp
14647	payment	1726	1726	1874	1	1	5113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPe9wZZzEYEM7oz5dcjnA7qkaCn6BAhaRLUD5ShWvcxNuDFXs
14654	payment	1397	1397	1678	1	1	7294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLc1tFCxY4sEmGFtmuxzQaNie7Hez5wVA8nZgaqjBAuZ3w4eKP
14655	payment	606	606	2085	1	1	8	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1v4vPXX83TbuheWk3bsk3yr4wj5CKzd16JsuZ5RoCYf2mv4N7
14658	payment	1397	1397	1678	1	1	7295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Fg4toVYvwModNF2fctWmV9tgp9qcsRXC3xBaQqvvCf7b5rqU
14703	payment	1397	1397	1678	1	1	7311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppmAupKchRCL51Z2Nr3fjHEdWdjXoiTqJunUJaz4bQvU9rt4s
14704	payment	1726	1726	1874	1	1	5148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgnjkQSMRzgGxGb2v1AzoAv9Hp9uJMHyrwZjbUnrJoYmvy96y
14705	payment	1726	1726	1874	1	1	5149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ve2zExUadR7zxsyiUJ1iTYWgMSBs62668h1zzkQt2jRLZovx
14712	payment	1397	1397	1678	1	1	7314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42Fp7JPfjUxtYyjFjGPKQYunzFKYYcKYNpMvWYnSoxbaQUyeu
14713	payment	1726	1726	1874	1	1	5154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhvR7Cc5sqs1s9zDB6p33VYayD1cbkXg5kA7qAMWXQddAMpfW
14714	payment	1726	1726	1874	1	1	5155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu7EufZSYXosFABkCGPG7DFCveH2YSCqjmALrWykDJEMZzvCg
14727	payment	1397	1397	1678	1	1	7319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKNy8wmWXqtLejiqeQKake7JMJMqv4BUymrNwaf3djGqpPzi6
14728	payment	1726	1726	1874	1	1	5163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFuQSeEemXEyfZ5eduzGL6KJujy1het7bi6MZ9zSM2EoDnhdX
14729	payment	1726	1726	1874	1	1	5164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VT5sdoQcntXVFxruKQcGQipQRmMLTaChnYdwzLtSuhqRDq1H
14740	payment	1397	1397	1678	1	1	7323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcANAEcxGukx1KzvicQBmAYEpQ9BDBjqM7fXEtyN6Qnc3GDgt
14741	payment	1726	1726	1874	1	1	5170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9v2MyfSAEiAR9ng47MWkLoj4Y86JoS8vRJJdnoLdCFh2wbTF
14742	payment	1726	1726	1874	1	1	5171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qu4LNfr1brpyKu8MBZy1vgLo8Qo5MC3dp1th7m1JVXEnbsoL
14746	payment	1397	1397	1678	1	1	7325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyB2JEBY6FeqdMF6BidmcMiw77nRE4qPNpxpsMHzCC2GtgFR5
14747	payment	1397	1397	1678	1	1	7326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVG2CuDT3rHPxGuVfpbF6Sy7WFeCuvazKZXL2tCJVsaxD5qg1
14748	payment	1726	1726	1874	1	1	5174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8nRwa2V3oVdLijAsKhtKN8uQgwbiyC7zXVdC4WSZYaDbb7Gy
14749	payment	1726	1726	1874	1	1	5175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKDBDG95sdpuMfA6ThsmWF5jCRD4iYeBp8XBbdZHCJhgUTybS
14750	payment	1726	1726	1874	1	1	5176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6SdoUFTnHkkuLci1g4JmKzC1qZZHEDzfYcHVVacLBPg1NBfqL
14751	payment	1726	1726	1874	1	1	5177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzcKg3DWqxos2yaniSur9wLf8VSyczbP6HMfDkA6GGH3nQ8oe
14752	payment	1397	1397	1678	1	1	7327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYktbrdaaH5LtrnxxyiBfVzBQc181V9LKZ88Exk9friPPFA3V
14587	payment	1726	1726	1874	1	1	5073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnS2r1YJmNdHMuvopLXTG25bkWxhTgKnf8hGdXJhDKv77cLLT
14588	payment	1726	1726	1874	1	1	5074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGmWQz6iwwbzwcg6swEjxvabTRfVxEsRa3tHdLTsNYUVwre2J
14609	payment	1397	1397	1678	1	1	7279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTGqGiDPzmQDrYJna38bSQiv3Qh6jxWTaSaedFrDePtNjoHyE
14610	payment	1726	1726	1874	1	1	5088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85HVN84i6aHiQDkJ7Qn69wyewCkB53eWyMFDPFMVTD6hg4ShH
14611	payment	1726	1726	1874	1	1	5089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQWYGx3ktF8Eee8yJrrtFfawExGrrDPxK6BnxYXpDez6qVptn
14619	payment	1726	1726	1874	1	1	5095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEMztcvxwfAxkzyxBaLm9e61REegn1rB9WHjpvURVGeichp95
14620	payment	1397	1397	1678	1	1	7282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKdkT6KXoackPGsXz6twFYxtebFNeKnEsMMvrR9yrWhKxYaDQ
14634	payment	1397	1397	1678	1	1	7287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3dcyv5LAtEHM6qGqL5StUc26qR9zD17Pup5sTyD7bg5bZGdi
14635	payment	1726	1726	1874	1	1	5105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQqFrXoHLTJ8WuoMnkiGHvKFzqBvBJKMXYunwxT3SSM3bKEVK
14664	payment	1397	1397	1678	1	1	7297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurkaC8JKfgP645aCQqU7WnFbMY5cyMsEPZptsAqLHEJPUAQoh
14665	payment	1397	1397	1678	1	1	7298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxvgBZxr5aFWSGpm1TPhsJJs5YXaGivKugfFozascteVmKeVF
14666	payment	1726	1726	1874	1	1	5123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzXGZf85kH2uDd9F8fb7VAby9x9nqqi3hJFBYFYyVYvinLZnp
14667	payment	1726	1726	1874	1	1	5124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrRwXcnJh7QJtK6akzPtNETTEhTjcuE5MfMroRYwew5XLS8Jx
14668	payment	1726	1726	1874	1	1	5125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUM7osJh4BTsn1FPkVvtrpabxAiXoThZNEWFp4fjFDPb6UBF7k
14669	payment	1726	1726	1874	1	1	5126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKB9mB2kct8ygAAf8ax4rL23Z8je27myBBLD4QtTDcGTNvH8K8
14670	payment	1726	1726	1874	1	1	5127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh6zcjzx7ZHFktrZLwwsB6m4FiyPktZ6oY5kGBdJ4mL1RajUA
14677	payment	1397	1397	1678	1	1	7302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuRyjec21HxMGxveiEyV2Jz2WiNcsZVg2yCK2NJixB8CmVjEG
14678	payment	1726	1726	1874	1	1	5131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhq1KtM3YdFpAeSeMUrghFtyEvXwKmUD1mi8rQZ2SpTqu7AvCW
14679	payment	1397	1397	1678	1	1	7303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWsjV5dZduDyxTivG2YBv2Y5SCt9rS26BGfvUrUXEe7Ryy3KN
14680	payment	1726	1726	1874	1	1	5132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnEEyUAMbQjnYyYFmgqmQQEjFjtPG6xrqtyQdGMyD48crdtAr
14681	payment	1726	1726	1874	1	1	5133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexrhcrWSNX5X7MX7trAKcrd7GVPrUeMCac8RyJW1Y3E9r1wN7
14685	payment	1397	1397	1678	1	1	7305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTvRip9dyABfr44dnPSqTDbcPybwsJerCRRYaKwmrEi3wuRupR
14686	payment	1397	1397	1678	1	1	7306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWFW8noe4xS38ephCPJ7tKBXCznW5azovzVW6Ym3ZSXWDt7zN
14687	payment	1397	1397	1678	1	1	7307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoa9YWDWLrtg6mAWGXBs2E2Zuk4Et8udSQmeTwgGV8t7uLxYDC
14688	payment	1726	1726	1874	1	1	5136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqueB2iVjVeQnbw63MgiiF99ZaNrxJeAZDvuHSFModfnG7iLh
14689	payment	1726	1726	1874	1	1	5137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ivKYVhQ1s5Boh4v1QJ31xkUPjeHFXpxPmpKT4a2z6rSuEVp7
14690	payment	1726	1726	1874	1	1	5138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVzsiWYZdT8kPzUyULkuwf58VddudTY8G4rW9qcCMuSxdN7CM
14691	payment	1726	1726	1874	1	1	5139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1MBUMJapH5nvCNDxPoY29XybuogKGsJ8ZKULpCn6jjA99HBL
14692	payment	1726	1726	1874	1	1	5140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5Ci1n7SR8dB2Bc1TesGceaaAjoEzF9W7yJ8N6VLwPmJY2zsg
14693	payment	1726	1726	1874	1	1	5141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQYxJQWCEEnR6wAMkMmTnoxp3y12HpRiiPVTQzVgGYMGzhCCu
14697	payment	1397	1397	1678	1	1	7309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4ancSYgm9WUnoZvZwaesbp3rQgFMFe2x1YkR69TUudpPp1bJ
14698	payment	1397	1397	1678	1	1	7310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsuWfAC2SJxdWqEyWkgrcFdkNYFEH7xZUaTFNZ6yqLG7sdr6M
14699	payment	1726	1726	1874	1	1	5144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3RLdwL8FRYAgR9iLhz1pyYWSgTxZDuHCiMDLRvhgC4Z2aHv8
14700	payment	1726	1726	1874	1	1	5145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRV1mzRhpRFbcmLxZBUC81Aogv7URuXc3H78KucEV5kkyqcrJM
14701	payment	1726	1726	1874	1	1	5146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wFF4YxWQBe5zoDheURmrVHvAvdU3TpdpX2LiBHRmFxUkhdrz
14702	payment	1726	1726	1874	1	1	5147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EWKkKkkoG1t8ymmeXcnPXS5STZVQrT3gXhE6zscbeNEoJULy
14721	payment	1397	1397	1678	1	1	7317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPX49oFrg1SRRnZQ42nZV1e8SserAnEUL3BKeqEWt9j57pftD
14722	payment	1397	1397	1678	1	1	7318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaASBi6P5K9e1H9BtUozWJuabzR9647pvs3SENg5oCVByqStB
14591	payment	1726	1726	1874	1	1	5075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXE9y1nkoouaFeWFxP5DNwi2iQNmHtH6VKdRGwkaeZNxv1tsE
14592	payment	1726	1726	1874	1	1	5076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGKtFmNhpZux96C77aS8yPSQhHW5pZn856pAWTUTBdygh95Sy
14593	payment	1726	1726	1874	1	1	5077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEU62XqMiMfzpk3McziDedBcnefLyxB6t2Tp1KgyxWnTiAnczE
14594	payment	1397	1397	1678	1	1	7274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BgaNg5HVFLVRa1NuC3tHrBmUu8vQKpTRWdcAxpfuBe2iuccc
14595	payment	1726	1726	1874	1	1	5078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjmRnMPdcKSHdNwJrRUPq3Kqy98FiSKnxamMtEcB8nY1hAni2
14596	payment	1726	1726	1874	1	1	5079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KAuRZFNnMvv8Sh1KbLEyYDhKjDbx3Apc6Y8sEbj2QgXd4CQS
14600	payment	1397	1397	1678	1	1	7276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVN92Y2XabadHDKRdGTa67St3Ze97FX9Bdb8JMfYr8Z5qP4Twm
14601	payment	1397	1397	1678	1	1	7277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsioM8KedmyvbG8m3b1UmbE3ypabHJh3G3LvcTzWYuyFDLogpA
14602	payment	1726	1726	1874	1	1	5082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tAWQLBq5qfpjdUUwg76oTQbZ3y7eogGWmZoUgQFoPW9YjxLA
14603	payment	1726	1726	1874	1	1	5083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyAddPyCJVsp4B5sipEYCGjHz2MXr2RMwa7FSYgrPyufTFbpU
14604	payment	1726	1726	1874	1	1	5084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Kx5FahofcnxkmkeWxJZG9hPneYkeFvvRyUGCpv273x93iKJE
14605	payment	1726	1726	1874	1	1	5085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsizoax8wj1DSgj9hniJBKasv4UKKvGeKPJfQR6CM1hgEvxJZS
14606	payment	1397	1397	1678	1	1	7278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBz2HucPP7QjbL9R6WwWXzhKxSGcz37EsTBvtLpJWb63cDQiWw
14607	payment	1726	1726	1874	1	1	5086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxrmxkwhH8XTs5goZZHEo7ySc6yF3NrrT1Yqwv9g5n7fnZrV8
14608	payment	1726	1726	1874	1	1	5087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPKRmbHxW7p4ypnDZfWzWaEzk2u4LZWk16TtgMhC7xNSL4BYo
14621	payment	1726	1726	1874	1	1	5096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74M4kQYxZBpPY7DJWh82UAs1AjrF511Doxq3EU2cos5xZxNef
14636	payment	1397	1397	1678	1	1	7288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ayNrwQBNYKvdt7ge4jP9RBZKqaxBbbgtWrEgjaCwZfdUQS9k
14637	payment	1726	1726	1874	1	1	5106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTd6G13D4zJSjepWH7xyzKwi4s7c7FCtBLczTgU1EtzpMDaJUS
14638	payment	1726	1726	1874	1	1	5107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XuKxpnrDXJbDpRDGEkrVx9bxDvwjWe3pWBz3NPuunAV7A8so
14648	payment	1397	1397	1678	1	1	7292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASkW7kpYkqg9yubYA7PJzjXYKe7UvU3ewjXgzyABZSx6tqJbP
14649	payment	1397	1397	1678	1	1	7293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMoeoF6ycDQRRv3LRdAa3ujPtR5guiq53xkqRg7HDwZok3M1G
14650	payment	1726	1726	1874	1	1	5114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJusPnZSdKNdgzw275VPfDwLRc1M4YZqRPGKQ7wQKekNmB6cUJ
14651	payment	1726	1726	1874	1	1	5115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzSo43tdq7Zp8SPFBnGBWwYQeESggSKYAModDykhpKSznqpR6
14652	payment	1726	1726	1874	1	1	5116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD75kMrhfsvy8UTW9EK3dFh7R18h7mLq7Bh6HW4sMJ3vQYN4d
14653	payment	1726	1726	1874	1	1	5117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYu8pUwtSg7Jw5dhouREWodkWCcR7wyVyPLNzEC6y6TsKXM5Mv
14671	payment	1397	1397	1678	1	1	7299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ued9kUj4HaeNrKrLXYdyFgwM5T7MbwLGfXyw14C7c9oFLEWH
14674	payment	1397	1397	1678	1	1	7301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAJw3iv1D8eEeNMNJMQvXK5EpHm9xZrAQpiUCdmy36qDujX8Q
14675	payment	1726	1726	1874	1	1	5129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7oHJ21SuUpmWcw6Ci5EdojyCUAN1FoiCEHG7XoK9RiZ6V3PW
14676	payment	1726	1726	1874	1	1	5130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbvBiEUu18Uh9AWaUHCxSsuXhVRs98pcVucj1Vu5gMrNLkvan
14682	payment	1397	1397	1678	1	1	7304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnry2orNRiqZHa8uy4S4YUWiF934aPNLRJvtBG9pyZh51pWC7C
14683	payment	1726	1726	1874	1	1	5134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLf8oipFehCoTYzqfvjqq1SZCWT1XGMXG8QEc4vioZSqJ1RzcU
14684	payment	1726	1726	1874	1	1	5135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoQ9vVfqhfimMo2VQhfe2fNAGLCEgFqkrErZwXhM572wCdsPX
14694	payment	1397	1397	1678	1	1	7308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQ8LJR6KfLMmjx7bNLF9vK1WbWsLtuDV3dgbX18N3gwtLigET
14706	payment	1397	1397	1678	1	1	7312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2DSCNhkKvrBE7gYUMHUvDybXZWRbaZPrUpjm6ZuSUQrA2r3N
14707	payment	1726	1726	1874	1	1	5150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwPsYVzr759PHzhfyy9vySQE5dPhH9gr9kVw7UJDMwi7qV2eN
14708	payment	1726	1726	1874	1	1	5151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTATDzk49X3MD3cKJ7Qbven6NFWLnFGtr5BgUoNtgT2P8sPj59
14743	payment	1397	1397	1678	1	1	7324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgnoKXnqSrRuXik57x31yiykX2XifTxT2fk1dXpc2E4MejJi8
14744	payment	1726	1726	1874	1	1	5172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRo7ii8Ax1rFqEgonTbpRbKcSSBTFzTS87G7aG3MExp1bGgrM
14662	payment	1726	1726	1874	1	1	5121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdp5chZm4LhaUVuawgDtJuZ1TpCPNxaPpoJopraDZfi5vXpHE
14663	payment	1726	1726	1874	1	1	5122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TmPNApEbdiFvrKGP1YbQ2WFBSQ1fAtprMsxJ1uYcoxNs3nZX
14672	payment	1397	1397	1678	1	1	7300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHoKA83zKtY7kpxUHh3Xv9mR6MqRRKAASmqjDsjKQDNJhA95s
14673	payment	1726	1726	1874	1	1	5128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmeySzFs2UubvBGHDG4D3TE7XLemuTsCxaJzKUPKVPbbAeTqZ
14695	payment	1726	1726	1874	1	1	5142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7xGSJNAhBukr9AAkMnfRa8r4jHZHqFHm1SRrsZHN2bd686L5
14696	payment	1726	1726	1874	1	1	5143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRghfKnfEZfBe397mY6DzBcnch4evqn4KYVRwSR6UL6GAm6zN
14709	payment	1397	1397	1678	1	1	7313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nijbkTkAYTSmgbbCoM2J92huBUsefXSBmWZu7q5bbCvfv9wN
14710	payment	1726	1726	1874	1	1	5152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsguhDNfMT8p4b6XjNCX9zcYe1yZFDigBKudcwTgdq8aw2tUs
14711	payment	1726	1726	1874	1	1	5153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKF1vWU3ce4431wMC6HBFyh9paRxpRMzir6wZVHWqfnwA9Vq2g
14715	payment	1397	1397	1678	1	1	7315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2hQMq7rvWDbCMjDzWRvoL4sHe9f6EHfyRzqThMCavYWqHstj
14716	payment	1397	1397	1678	1	1	7316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcW8Tjwr3RX1i62qqBAWUC75LK2A8MzQPKUQLmw59FBFwuZmw
14717	payment	1726	1726	1874	1	1	5156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtFNGYF6sCw1xNKkuaxnCs9bYx6xdWNUeoKQzxDm9piTbxxwp
14718	payment	1726	1726	1874	1	1	5157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CHdMSyb5Do1PGDvUftGSqiabsoYGM67B2r9r8z2aM5vQt9dY
14719	payment	1726	1726	1874	1	1	5158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4eVA9TJGQzvVVHeSGW8BpTbwobMP8X8JJse6nRsY42EjpiE4
14720	payment	1726	1726	1874	1	1	5159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrdctdU8TEZjsYbrvRy12f34nKSwEMnUPxKGb4WCZF4vDfCHi
14730	payment	1397	1397	1678	1	1	7320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MGgWNDWsezqJS2bXGKTi6LiBgz2kfawLMKXMmNdBJTpaLZ8Z
14731	payment	606	606	2085	1	1	10	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzfVpZYiVcbXDCTtZAprCw5B2D6LQ1y3k9p2GxyBpLz6M85uB
14732	payment	1726	1726	1874	1	1	5165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBA5CwMukzn3zyN7qSdY3vKoc1KDPSo5tA1z4vXNGMTuBXYkJ
14733	payment	1726	1726	1874	1	1	5166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48pfWGFrZ7BMckGHXqFGFd7jodoRysN1KshjYfiUjz6gANU3v
14767	payment	1397	1397	1678	1	1	7332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88UZ7yDudGCDzcDjddDWLKBppARD1uxrE7sE3FMcVQ4kYALNL
14768	payment	1726	1726	1874	1	1	5188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eXNAmD1yeatV9mjZZRiPyx3PB7E4aQR8KQcNr1ecL8rG1Crs
14769	payment	1726	1726	1874	1	1	5189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMptLxTfG48t2ZRPGJSnFmAjmAZi9TTmGSXAK8Qo6ZWZVe3bA2
14793	payment	1397	1397	1678	1	1	7341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8r3xsyb74yhwjsXq9hE57fKsnCMokw6xyMsNpQV6EPGcy1SS
14801	payment	1397	1397	1678	1	1	7344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn4BUEbiCmxsTqUeNnVB5LxCkQ2vaUJGZenaFddAHATSrc5YYQ
14802	payment	1726	1726	1874	1	1	5210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6FFumsyGjYzFcJrtTf49woQ1L3BjJtxgb9TGP76T4FzR6Q7x
14803	payment	1726	1726	1874	1	1	5211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDMWMmkMEG77WoRNaHra4S1Avz5qqye9b5m59yHQDRurpyKK6
14804	payment	1397	1397	1678	1	1	7345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQ74zWKZNUMZdZ2ssxxmKkLLeW7psgdTGpwoWc9F535QAtYqJ
14805	delegation	1750	1750	1745	1	1	28	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaS6KdXzUZyuPyzrpkMpC5Jb59gffMfjGqdzGQuB6haDnwaDAq
14806	payment	1726	1726	1874	1	1	5212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHeXnnEFbh1UAadZZPSu2JtekmjXHSbWFoDBimzBJ7k76pjrR
14807	payment	1726	1726	1874	1	1	5213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa591Epmu3x7cwYfWznDHsnkNACMLRXWLK6GQPdZZXGGk8HGzkg
14823	payment	1397	1397	1678	1	1	7349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcwsr8FjrYumKPGvDkgkJbQfH5cFS3bSw5Z9ztnv7RPwDfN5V
14824	delegation	1750	1750	1745	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfr1yvvHpe963kKdZs3fXb2dFGUYojRzXZnXuEXChzkcjYxNK
14825	payment	1726	1726	1874	1	1	5225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHqKyPVfymp9MCpFjrFDRkMH8g8yjsRi6BpEtUnaNcgyW8bFb
14826	payment	1726	1726	1874	1	1	5226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpWmkp4x7s9svWYXssSBawfRUUh5qGBccuL31Ff2wp2fFcxaz
14827	payment	1726	1726	1874	1	1	5227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfG7assznxYGNbcB6c7cdemL72uCmaKsGNRayguwQZPdpmgYi
14832	payment	1397	1397	1678	1	1	7351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBRbZHpQoPv34eC9yfGDxw181v5AhjRZESRLMwkaLk5eQPj4P
14833	payment	1397	1397	1678	1	1	7352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLesdsS14iVwPp3kxmThXYj79p6XJzrnQnVC6m74CxMYL4mLu
14834	payment	1726	1726	1874	1	1	5231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPWPYAzBz6bR2wdbsNyo2uEJYC8WEomjSKyAgeysLg7r7X8d3
14723	payment	1749	1749	961	1	1	11	2135500000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpYtQ1jioy9mMRGCBUbQsvGMM5zDrALWmFRoSB78GHcJTJCBuC2C
14724	payment	1726	1726	1874	1	1	5160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqUwpozH5axeJJaXU6xKKH5J21jMGzh111MEmuvq5ZCnCEwgZ
14725	payment	1726	1726	1874	1	1	5161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBGv2Qv6Cai5KMf9sBJk2jQauVqtEMqF5JDrJkxZfDeExRGzU
14726	payment	1726	1726	1874	1	1	5162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo326QhhV9SJJK6dWbnhR6uoNXGEEzdMpCVowNc4LGUiikDNqM
14734	payment	1860	1860	2088	1	1	1	1012300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3hQdy9xt2s2NQzxjDuhDJ1naTCAtgJnPE8vzvcWZdJNFkz2v
14735	payment	1397	1397	1678	1	1	7321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk2SW4WimrD3SV1eeuU9tnGs5BbJsmGF8FznmynxJ627JFwM2
14736	payment	1397	1397	1678	1	1	7322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hLA73mNJdxBEehE8Z5EkqFGwB45pGDozf47j8q58DsYqkW4s
14737	payment	1726	1726	1874	1	1	5167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeZVAJwbftDLdR1A7qHJM99UxYo7fWNfAUTTT1tN5xJBH68ts
14738	payment	1726	1726	1874	1	1	5168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNWfJk5KwcpXFdSs2cFdSj6W6GqL5Fc2VCZkkMvBN5dbwYNh8
14739	payment	1726	1726	1874	1	1	5169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3RBvjAFnvD8dFyZtCsUoQw8T36H8bVxykVTLfaAt9P2t2D4p
14761	payment	1397	1397	1678	1	1	7330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgLki7dp82u6zvVU9BHSCdRBkytJUZGJQMoBa7ZnC9ZQWqW5Wm
14762	payment	1726	1726	1874	1	1	5184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Dj86EUN7Hrejdup9TNbr676eUMCHQLsnHqErTgEAn7D7yraW
14763	payment	1726	1726	1874	1	1	5185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPiCA2kcCqHyKFLdPRWBJarbzPGBkxwExErCpbbcgnsAjTm3D
14764	payment	1397	1397	1678	1	1	7331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtFCJ1Nhzhq8ahZJH2FKLsdznU6q3eHh5RcvSQxN1QUTkCy1k
14765	payment	1726	1726	1874	1	1	5186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgaoBGMGGdHYMBmpdXGRobLK6cQDwkTknroBmr7VYRSccz4vx
14766	payment	1726	1726	1874	1	1	5187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayEPceEr9FXprU4CPffuDyt2MCLVaa3eRVserrAK8h3NM2RVD
14775	payment	1397	1397	1678	1	1	7335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwnguDFm7e18M8z2e9jdh8BRTtQchZqRYHUeV3VNox1JmyPxM
14776	payment	1726	1726	1874	1	1	5193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc51zW3rvDEpgBN7G9c4ygfeBf98W2ivCGBBy1LKMbgdsYd7cH
14777	payment	1726	1726	1874	1	1	5194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrTUckkiDXDL8kxDEcXGqaEFMbTDeqAmhiGhTRYHGi3k5TN8E
14794	payment	1397	1397	1678	1	1	7342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobKhdjSHZR8swFHernbJpeJBLMxfyd6HvpJBWR1YwmGs1UJyS
14795	payment	1397	1397	1678	1	1	7343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTe52f6Pw9R8z6qHbrno8cALqJNFgNj2Vfcd51jrGVpUHb2RR
14796	payment	1726	1726	1874	1	1	5205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnJcmrZdibvq917REDoZCVxyJ3WsxtgLace4A9NsRLXsHYyaL
14797	payment	1726	1726	1874	1	1	5206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyg1Q8dREQqMFw1tv336pSi6cpeNaPDqWQn9R1prg43PeprEH
14798	payment	1726	1726	1874	1	1	5207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY26RFPFKtFLEs1AQqCurEPUDWxpet4L6xzhVnYidBNouPB4TN
14799	payment	1726	1726	1874	1	1	5208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ti4VssnZzJSRdBzGHxtU9UGs6FVRyGxCvTFVWJBRhMWMUpti
14800	payment	1726	1726	1874	1	1	5209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv4aLsE7dwBUxaqwj3hfiq9Nq82RKTfB5kyopvGAyXeWj6rAv
14808	payment	1397	1397	1678	1	1	7346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8jPNofZeaStyg6vCvLLAeVMuVKVcP2EvRYwZ3ixr9ruwYwQL
14809	payment	1726	1726	1874	1	1	5214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmnctwFSYe7qYiipGkFB7GFEJokWJ4UEtKAQhoNwbVwiFxdyv
14810	payment	1726	1726	1874	1	1	5215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpDrtgFp12X1maAqCGAcxnemQ17NooxUPmhDXJbCnWM6LBNE4
14811	payment	1726	1726	2089	1	1	5216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYuxoeQx84bd6NGaadDcnkw282wrux4o9gZG6E8fxtHJtum64TY
14812	payment	1726	1726	2090	1	1	5217	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWRni3dcvfwx1dE186rm67RRzPan62TDsyhCgzRJxtRrSvR12S
14828	payment	1397	1397	1678	1	1	7350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZea5hBSm8XcHDq63pXU7VJ9Ybixa7gTQ6uBfNHTbFhUSYFit1a
14829	payment	1726	1726	1874	1	1	5228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ87v4MjincSQQQuwYurKnegdvSD57gstVFqAkhVqkMdUNoVao
14830	payment	1726	1726	1874	1	1	5229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt46EqgkYZbMQfRDFBydYdghNKUruMFwn1SZ4G7zvV7hRAszz3
14831	payment	1726	1726	1874	1	1	5230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSo2fMh6x4eWxy9o9NsPJvfeeCsZUrH8u1nbGYyKZwPJfRDu37
14844	payment	1397	1397	1678	1	1	7354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVigWHGLqv7HYro9k58XK6RU3AfyM5cpZ5G4bGP9oS91QujEs
14845	payment	1726	1726	1874	1	1	5240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRetKqmaq7hfrcwsF6zU2KZb4RoN3YJHHcadosibHV9XPz9CL5
14846	payment	1726	1726	1874	1	1	5241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLtjujXCx597HVKvFTepzqJWw7cv3vS6hRbpP3ZiHU7FR7zYy
14745	payment	1726	1726	1874	1	1	5173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNL6Tv4LtCjDxsqTTjU5oLEcHwQb86u1praHVoybHAvqXzTPN
14755	payment	1397	1397	1678	1	1	7328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCq6NWxeBPcs1k1x8j75qJxRU81Yb9px1wuvr4wFg9ENpK4ed
14756	payment	1726	1726	1874	1	1	5180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qhuJwvg6fWvc4UhpwdTfqbqdbM73C7jzMv4xsxRutK1gX3Uf
14757	payment	1726	1726	1874	1	1	5181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4ATvJcFS2Vms9SnPk9o9KjBgFSR5p9GYmdsUbCS5UJgh8n5D
14758	payment	1397	1397	1678	1	1	7329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDKSHtZyHG9P38znjKS4LbpTfTXuN5rpGwVa4mYunhrSaZ8vrZ
14759	payment	1726	1726	1874	1	1	5182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV8CbpsjQk3DY5HP4VY8q5pYkTnhSP5XnwaraPKyGj4sAuuRA
14760	payment	1726	1726	1874	1	1	5183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ac9kpA5vQ5RMhRTZn4HJmS5yvkwKEtT6W2LgYzsE2qzSNbqz
14770	payment	1397	1397	1678	1	1	7333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQFrK9A5LynjiezX7GdHKTM1nhiq2GZtByd9k5iq2TYfMiFVT
14771	payment	1726	1726	1874	1	1	5190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ2SS6BKU4xXxaBby7HUwM3BbrYoiihDeFfGpnAGZ7FxpAhzP
14778	payment	1397	1397	1678	1	1	7336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dvdowkjq1RXB1pkiGzg4hSqrw2V73BAtqqL8bMR7dNw8pBRM
14779	payment	1726	1726	1874	1	1	5195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbF6q4kq9UZK7P3P19SMPpKYZTW41tm2SntHgKzwQ2DuoQi8u
14780	payment	1726	1726	1874	1	1	5196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhxR17C7oG6vm6T5pQ4gFMJkHYNKmMfr5Uor1NkZyh4Q8QMXQ
14790	payment	1397	1397	1678	1	1	7340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6C9RK3UyBSq8phV1Ppp2kSThQ6nxQeUrp4Z9wz3prpGDW1E5
14791	payment	1726	1726	1874	1	1	5203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWQXhR9uSfegq2R1Hm4s36i6yrKcvkC1cEneRUTnDnw28CK1h
14792	payment	1726	1726	1874	1	1	5204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGXdumx57X6euxma1syD1PeLuWkKSMuFKiLMuh3tgkEsK6aNN
14813	payment	1397	1397	1678	1	1	7347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSHq47qJzJm7Lj8tafVuCtFWcWJgxe8CknhT9qWTyDofVwP61
14814	payment	1397	1397	1678	1	1	7348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnRTU7KKSptaFzY1PErbAsmAb2EuhKBKhdT83UBzJHymMekwr
14815	delegation	1750	1750	1745	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WUXevvRznaDxWG2VukDCSLq4R24Fr4s16HeevSJdMdUK7byH
14851	payment	1397	1397	1678	1	1	7355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSu5Te3D2RvjymPNaZL6H8RWfLTt5ZMryWBr3h2fBd78mUBrz6
14852	payment	1726	1726	1874	1	1	5246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgGcwzRoVTYUoJDaoRmqfWL9tVczsr9hQSmFaGVA95FiG1VCN
14853	payment	1726	1726	1874	1	1	5247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXZoCnBTJxZ7R3X3izjMs7SFZ4ciRrqFUwGXuUKfmdapppG7R
14854	payment	1726	1726	1874	1	1	5248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyY6QwXiaNz7NTs96mdWxmA2ErQJvhfhNsKbRMe1Ndt2Jzwib
14885	payment	1397	1397	1678	1	1	7364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsx1AjM8L1e4PjowR3BRXRMASPYZP2oZUqP4zUB5Em7s5bVc2G
14886	payment	1397	1397	1678	1	1	7365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGYvVpY4rpJp8x9cbwxrFnibGtVgPdPWUSXhAsT89ruWhifDM
14887	payment	1726	1726	1874	1	1	5269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxZsok6dV9p4a5LD8dxQcf2Tz8mzRgJU4tdCTbYnsGd46HJ7b
14888	payment	1726	1726	1874	1	1	5270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4smEEshczfyMapXUmq6Reph5AH6sFwyp3Xb9jWG4Wy4SgHVe
14889	payment	1726	1726	1874	1	1	5271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6cmwyUuFBStHkPUxXvm7xDfr2M8J9rBaMhUoBzpSHXJ7rsasm
14890	payment	1726	1726	1874	1	1	5272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTHuFMQn6Lv58t5vBmwWjZuw98ecnRetKsHRqtP5bGfLvcZJi
14891	payment	1726	1726	1874	1	1	5273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapsVcPCk1z3Y5BTjQ17HRy8fVqfRixJmyzFAG5STCJBWNfgLo
14892	payment	1397	1397	1678	1	1	7366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirZ16rfL6JqzyNm1GcogLze8MwpeWRFWySEAvn5Mcyf2C4VzS
14893	payment	1397	1397	1678	1	1	7367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdQPpMQrhGnKpbgkJDX3o94kpQMwTfi4NnKaPUQqSnWsm5eyu
14894	payment	1726	1726	1874	1	1	5274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh4kGJ8CRH8pQUqW1rrLjUUpVL3HYqH85fY98pPDddUSrhJhN
14895	payment	1726	1726	1874	1	1	5275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncR55NqCu9v4iLnB6Zxwdi22VpYY7Z1146hVi5gMjUU9Xpr4u
14896	payment	1726	1726	1874	1	1	5276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpq3SLdZXbtF1TnmPoEHFCZmjZEzzaVZ4Czr62PRMbmESvxmoY
14897	payment	1726	1726	1874	1	1	5277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTibbyTFNf5LZYDMcYFaTGXVRZ2ASwTkVwC1QqLpPRRDuTH9Tk
14898	payment	1726	1726	1874	1	1	5278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPZWKXXHb4s9kExm8rdM5MzE7WNcpUDbTN7aKUL9E2ZZ18mhb
14899	payment	1726	1726	1874	1	1	5279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4hCDntdGhg9QnHW5Fz6RrqpCh1Q5VDJd7Ppw6QoW1tnnrhun
14915	payment	1397	1397	1678	1	1	7372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTgjXTBAH5Hg8khqiPeWxPNr4EXv9TMPhAKDWbGDbBoLkeW4p
14753	payment	1726	1726	1874	1	1	5178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GDsnrDozGE5UUcvzxRK3sSE3cWep7PkTSX7CULr7cw8JTagL
14754	payment	1726	1726	1874	1	1	5179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTMRzacPEsWY4KngpZm58tH8xZE81MeGjAWa1cmeU5eEgZFPB
14772	payment	1397	1397	1678	1	1	7334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUDg6H3PA7esh8AXXar3jcPhWA3g3dRqGTbwUyTN52mq9n7wr
14773	payment	1726	1726	1874	1	1	5191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnEA6rzqyWhPfMtc1rDwaBoCWWwHxEKg8YsBydCdY7kTZfqZS
14774	payment	1726	1726	1874	1	1	5192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUT3ZpfrMpyx92p84xPMsAK6BMVDkAauXao4cHSSsm5UPdr8m
14781	payment	1397	1397	1678	1	1	7337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvV39FHPMRpVcDmRf9imerU6ByNjVGG39ZnUr9hd18XLJ5Eq5F
14782	payment	1397	1397	1678	1	1	7338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL488xG9dDB2vxJv6jsiVti1YFgcYEc4RCFwtAcJ3gUzSu7J7
14783	payment	1397	1397	1678	1	1	7339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSfk3JcvVmeNnY744swPjcEpEPEvGiCUmHcuzpCZVJoQxnk14
14784	payment	1726	1726	1874	1	1	5197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNvpHYShzZjYSu92o41pekaga6jZ47bmHZC9aZ8gXYRCUrAWv
14785	payment	1726	1726	1874	1	1	5198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PArLwaebaXTubQuWd19U7UU5Bu7DezFyeg7LvPsmwfRZTL5b
14786	payment	1726	1726	1874	1	1	5199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqTnN8SpWHUYXxG75GkV1EcXQSXtkftZ6ZvBEkgoZrW625tRX
14787	payment	1726	1726	1874	1	1	5200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjt31jqoxqGG3jVpzye3ap8T7RyYfFZZJYL8FRz3zEfysY68ds
14788	payment	1726	1726	1874	1	1	5201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsqYcF5i4UaEKAXcRSaYzhrVbSPgWi59sn3Jy1xbYzcyhUNFw
14789	payment	1726	1726	1874	1	1	5202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9Ja9Bg4UfwJkev5x7mnwt6oo5h5fvKfQ9AYuexxjMCphZnsd
14816	payment	1726	1726	1874	1	1	5218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBYEXpzuqhmstLSN6qBqeDqTEPjcDQXoj2DjzZwE5k7djr416
14817	payment	1726	1726	1874	1	1	5219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4udLv3nabfZaWhagoC38XkgJfDHbPvwCodjx7Z26jPQ2AAcL
14818	payment	1726	1726	1874	1	1	5220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8Xwp172VSrH2dRre8scTDjGeMnjfP1kfgoKRZ3SGGyp4uSD3
14819	payment	1726	1726	2091	1	1	5221	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3WGUyijEDPPxsgpb8wKXNDpTvVfd8bJyZCmx2hCqzLas5akim
14820	payment	1726	1726	1874	1	1	5222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdGB2sCjF9xnmu59pDAbnYvpsgoeqoEVQR1HA6hingzLgsGG5
14821	payment	1726	1726	1874	1	1	5223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtL2XRxnvCheB1yQhFtF6KpUyVu7e9jN6HYc62ccBkEnpb3g3a
14822	payment	1726	1726	1874	1	1	5224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12kAhAgVmnnYMFKRLUtpK5dE517oPqfK1rnfW2xqaVY8nwu9c
14860	payment	1397	1397	1678	1	1	7357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hYoHSjeQQMu3efn6aoMFbQtbnFoEc7AMHPjmGQ252kePQir1
14861	payment	1726	1726	1874	1	1	5252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXX8ZK1LEFvDUdRDntC8AKJMBHJhzKY6rHB15xv9koLXEVvwjJ
14862	payment	1726	1726	1874	1	1	5253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdFN9KNqsCJf5C5k8T3fj8JPrxwjCc8HUp6oK3cuQiqMv65bT
14863	payment	1726	1726	1874	1	1	5254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaWc1wVHgPXSodAZ7zagfh44VwtewShW4VcWoER7rLC2CZcyY4
14871	payment	1397	1397	1678	1	1	7360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkg9CWqy8MjJXrHeUkCgbZ8eU6i5k9LTaZxUfDm5kctQM8RbJ
14872	payment	1726	1726	1874	1	1	5260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZnaDJ9YhDHJEWm2w1BGMkJHQ2mr8jzgdVWmjkSPAmUfVxwCQ
14873	payment	1726	1726	1874	1	1	5261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQFMZEkWbbG9DAuHDpoCLYtK3V5pf6bakxS2jdpryzvGhwz68
14874	delegation	1924	1924	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1eACJJrnk3xxTEHK8hETiQciTJKJE2smhiKrNyxq3BUbcvxb
14876	payment	1397	1397	1678	1	1	7362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfJ18XDMPJAjJL6p1DacmQrttrhzNyxHsdxz7nPupJDFqo1Lc
14877	payment	1726	1726	1874	1	1	5262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65x5iitLB1CxBGrNLC1KQJmQXhbRrmtn4Tfz2BT7DsYvPHz4A
14878	payment	1726	1726	1874	1	1	5263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnikz8bphoksjCxr7doztY3WkFM1Ekh2vFwH4FVazMJEs9iKBr
14879	payment	1726	1726	1874	1	1	5264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigAV6DjiDagCuScDnssuYmmNpAVx8zevdnfAV86tEE7LurrNB
14880	payment	1726	1726	1874	1	1	5265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTc8NzJrQMdXPzZsfuczEQuy9uAtiLHVxr7NwSnweggw5YneAm
14881	payment	1726	1726	1874	1	1	5266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenLoPLhPZpPENT67y4t7ZfGfXHcgz9S1muJsXRfg6e6avUCAt
14919	payment	1397	1397	1678	1	1	7373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sTVkiAYGVACSb8Zu2XjEy6vXDM8cWShUFCqBt9vtV2VeXG7d
14920	payment	1726	1726	1874	1	1	5294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQsLMQwBJuxb69HYb3ZUxMaYJPjKUj147MuGuZ5pvyY9XSNJn
14921	payment	1726	1726	1874	1	1	5295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdENBCKU63oRvprVjdGrbvMcyn2TXYA2vfMkqc5spxhbj2eSTm
14835	payment	1726	1726	1874	1	1	5232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTswjEjfeZM8VDFxsDPm2nv9An9dVMfSkde6Qk4ryxFdkLW4Bs
14836	payment	1726	1726	1874	1	1	5233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkirm8wcwVpoStf1ZPPr5eLLHSHouUDJZfNkqNYHanyQdVL1xJ
14837	payment	1726	1726	1874	1	1	5234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZgUp6WWKHK4RBcftL4MVbiUzjPXfNH8bXWSmXbgoRhzoKtT6
14838	payment	1726	1726	1874	1	1	5235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5XmY9yoj4GjdmbdZGey5D2T6cBARwLXcjyYTfbnKs7B5o1sL
14839	payment	1726	1726	1874	1	1	5236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHCRwE9AxfMWKW66fsgrnLm13JvUbjqZzBAu65RVNmP3wJpJs
14840	payment	1397	1397	1678	1	1	7353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHfCuMvsEgrnwuqh6RoUozn7CDoz6VjAXJX8tGxhybdYUk5PC
14841	payment	1726	1726	1874	1	1	5237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rymM84ANCbkyav46RDot9GWXNBTQ3UFqiDspAaTNK6n3VcjW
14842	payment	1726	1726	1874	1	1	5238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMLLHsxzta5AD92kVpcZuDjX789DtePHuEBNHEhYXbygQ3DqM
14843	payment	1726	1726	1874	1	1	5239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9izThvffpNtVtPZkTAyh7DWNej2b5ASmLsLZMAqvddebuk95
14855	payment	1397	1397	1678	1	1	7356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhn7cfRnSh2TkQJ5kQsktmA1bqyqyWnr2WLQyMEG9EanV5Maid
14856	payment	1726	1726	1874	1	1	5249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZAFtCqKbe3yM4awscB3mmV222nbUwnu7QKThfYKpEoU5fFBa
14857	payment	1874	1874	1726	1	1	0	204000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YwB6Ne4QdLnrv4FPnmNVR47FahnvaaDLDgcuovXgS5J2Fdxk
14858	payment	1726	1726	1874	1	1	5250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7GUWGcdbHCsMVytR2wnfJjxQM3bR1esgvzCfB4edV67qSmqJ
14859	payment	1726	1726	1874	1	1	5251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jCSu2JEBx4utuouyHbWTK62Qa2cj6AWfYc1g2zvHCbKPZAUQ
14868	payment	1397	1397	1678	1	1	7359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQtp7mbbGyLhh8Tttv7WFZzst83mK7s1bGScia12DdWAk4wNw
14869	payment	1726	1726	1874	1	1	5258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Kbeogq7wtnSBcscycUHNrykDoqU6UFbtqiPYXft31cucJNCc
14870	payment	1726	1726	1874	1	1	5259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefXvq3Nt6PQ9PDjneR8DAuFxzLxtkpT5uEaoFDZQ6v8Mh7aLX
14882	payment	1397	1397	1678	1	1	7363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYn7GFBrrqAqtKUc7LTs4LFx7FghvVpmyPgLybnB1SD3RcnTkM
14883	payment	1726	1726	1874	1	1	5267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5vYmiDfv1vPcDbbKWM4UAH3EQ3MQfskUhKzYYuu1XyUJ193V
14884	payment	1726	1726	1874	1	1	5268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iWHvEDwZbRdSQfQD67J1vyoBbQCBVGaGZajEwgwT2HKTh1TT
14911	payment	1397	1397	1678	1	1	7371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hfKthAvDUx3tcqG8GnybJWJPvbaFAZAQzBRSvJeYdrdPKVgG
14912	payment	1726	1726	1874	1	1	5288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHytvihRTh6VFzcNUFyUxJY3fBfsFBu2zNazXEuTSmSYhDa3Cu
14913	payment	1726	1726	1874	1	1	5289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nS7MRFXtrYHgRPC2PJ4vDKWgcgePAnqVAZfB3ihA2gJJA4T9
14914	payment	1726	1726	1874	1	1	5290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGwBzejvvz65ytZj53EojF2LkmndVaCxB65rvQdUwrdVbh5ME
14958	payment	1397	1397	1678	1	1	7383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gpkXVi5afXFRMcFRzPQHE2rmS6AvCsNwzq8J9bDWoJPMWQq9
14959	payment	1726	1726	1874	1	1	5322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQnYfuuzyrjDBtWBiJZHoVjode6fcrhzgW127dFt39pk76CUs
14960	payment	1726	1726	1874	1	1	5323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRfsXdJajHWqRsXZYcF1AiMxzzV1FrbeuYe4BZ6VPfjf1eZT5
14961	payment	1397	1397	1678	1	1	7384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZos2vXaxkPmWBt9FrokBTpYbmhLzw9LbYnHRzv2PrwBZUCXmfj
14962	payment	1726	1726	1874	1	1	5324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5ZbwJRnYehErTdMCeHT8fQcznds7t4V169d1CPJku26zturc
14963	payment	1726	1726	1874	1	1	5325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts97jPNCn8Qgkmxzzs8jzMAQVP1pWE1cvUKnVkvzAdjnMLmMc
14978	payment	1726	1726	1874	1	1	5336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p34k4SFfWUJJUmPHcQKh4E2VXxGSNi4W1X7t1JbS3kX4rgni
14992	payment	1726	1726	1874	1	1	5345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsoTUEcBbRmcXYNjDJmbwZkagq6YM17kux25EznTKQJXVppGC
14993	payment	1726	1726	1874	1	1	5346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3knV4ZLVkse4NSq3grnxw9EF2rZDDgoSqtqbgLMMjDsW3DA6
14994	payment	1726	1726	1874	1	1	5347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzYx9idfx67Fe1nqxkfGMSDf1eJjvpKhky1cvbDUnP6MZu5Ek
14995	payment	1397	1397	1678	1	1	7394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnQ2PiZjSQQwsxu1oHoBeuzV633UgNootrtqsEcVAiMxAoVUP
14996	payment	1397	1397	1678	1	1	7395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqH7KUBBxewStuuTa5318nG3YgMtSk67JrdAEztV5pkzT4u7tC
14997	payment	1726	1726	1874	1	1	5348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgv9qHVQ93qzRVXptdcULm8hQbgQSgn79nz7Big6nxiaHTTxTm
14998	payment	1726	1726	1874	1	1	5349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6KcRPZzKp8KtyhgnnQgfzQhbiVWubc7wstBYZNV1bFTRik1c
14847	payment	1726	1726	1874	1	1	5242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYCz2znCEgBNqWcyFBqtHBF2aLZNLsnbA9hkF5cqYqZQCdw1B
14848	payment	1726	1726	1874	1	1	5243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTq1HuA5TzHuSQR6vLWzES88tDHpKWV7R9tCwg2CSyLEGL3H3
14849	payment	1726	1726	1874	1	1	5244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEpn2xq6mmFM4KuhjJu5Nz3sCNnVisELkuFfcvdimiR49gA5W
14850	payment	1726	1726	1874	1	1	5245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCQbHXV8z576gszX4pSRejFrzpfTLFCYsV8G2K7uA2iPJ1vtT
14864	payment	1397	1397	1678	1	1	7358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9F4pazZn1kQHHy2tKy22G54sBLTdkC1qSc2E7xhFUAA9U1Xb6
14865	payment	1726	1726	1874	1	1	5255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCHVs1k9sQc8j7vSuv5gwmKXR8VXPZffcvn3dL7uR2PEZvMbu
14866	payment	1726	1726	1874	1	1	5256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDyZM76YN337NEHjEY9xUA1Zkvw6sNgQThtAXza25Xu3VXkxJ
14867	payment	1726	1726	1874	1	1	5257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEzSt7kd44PyCmdrZ8n2tkUXdsbNfL9JWgc4dvFmb53UfnzWh
14875	payment	1397	1397	1678	1	1	7361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3uaaWTj1VfbMn7vaxKAYXrNmXenHj1e5RuE8MRrkzkiafcWV
14900	payment	1397	1397	1678	1	1	7368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6n9q6C3gnBiUzooQr5jsF5ZTHQ5QxH3TVWDWxjKX9nR6Cv23
14901	payment	1397	1397	1678	1	1	7369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpQD8HRX8XZHk8gDzx3okZbXGeegYGg3uej2GoCSaDmHdk4cr
14902	payment	1397	1397	1678	1	1	7370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPwSoSe1emnqVjPeEdpdLdzM7Hrc4jiNkRxKq17Jc6zou4moR
14903	payment	1726	1726	1874	1	1	5280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6pokcrdJxNx23QCfwxVwe92L1fs2MKN4KoSzSXQvgeRGo4n5
14904	payment	1726	1726	1874	1	1	5281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8UN4jo6B81BVzxQaWJPd3hFEmWK1k6KVbVPKwzktG6bxGbr2
14905	payment	1726	1726	1874	1	1	5282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai9x5zWhSqSd7bp26dZVostDT3KFFfc7TUBTfMkqHKQJXtqT2
14906	payment	1726	1726	1874	1	1	5283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSPo2fCn5MYwoZwH6Guzs5rVxrjDVtfSt9D8pxvTaSgPbiWEV
14907	payment	1726	1726	1874	1	1	5284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFsZdBHHDzcVh8oLEL43S4cz3hF1pHkSS71Ewpr9jh8vE3ewc
14908	payment	1726	1726	1874	1	1	5285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidU8z5ZXzB3Zkn83ssi4NhomH7qawG5skf2HC6B5Kf68KDUuv
14909	payment	1726	1726	1874	1	1	5286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsp9qNqGUcudpbNGVc9rnVLJyTUauJqZz52yHsg3Ujk5x3baZ
14910	payment	1726	1726	1874	1	1	5287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhEiHPdupunf29233qxoFvL3cfKmB8qJaWgSBMBTVtXC5Uzsry
14923	payment	1397	1397	1678	1	1	7374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4eSJa9btm2TJfXWgKpuHAMSTZoULF5eyy6Y3NVz8fvd857sco
14924	delegation	1942	1942	1402	1	1	0	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBDQrmNJkMNCAMhiFMpF63gE6hpen1SSix7i6CrrW1mdCxMAn
14925	payment	1726	1726	1874	1	1	5297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qo6xbmHBbEGgEowCmwjxgHzM6Zw1hUrx2kXnVJD8wSiRLWUU
14926	payment	1726	1726	1874	1	1	5298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZKeomLotCgv7GcsjzK1cTHgRFrnja8y1n5493p39z8raWbup
14927	payment	1726	1726	1874	1	1	5299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Kzb5xEHRfKGVHstCpbeKVAfHGmCYhe5UtsJjCrKamejyUViu
14932	payment	1397	1397	1678	1	1	7376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHXTCerZHX5MLwa3RFKCdP469iekbcRgxWqY2k4uyB6oNBpzS
14933	payment	1397	1397	1678	1	1	7377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwDkoEK5YEEMnyjToeWLXxDaF2pWbKD1CSC5pbbSqtiNkBvGB
14934	payment	1397	1397	1678	1	1	7378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DrNjp8MVxpPuSALagpL8D4mSfZsa3UvGDwN3X5sAPRgESKy8
14935	payment	1726	1726	1874	1	1	5303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimo6UKTN9ymwPnYUE7ddfrFsjXMAsqf5zYzmf4uCQ9Y9uQprd
14936	payment	1726	1726	1874	1	1	5304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDXj6vWfJ4scQK18vqwxCdX6rgCfBSR9tdGy9AiJXqsNKtt7R
14937	payment	1726	1726	1874	1	1	5305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCGwLAG2PNaYcBWDDzUfGKMMqp3ugTazN8KsLtTgjcNWFL3uv
14938	payment	1726	1726	1874	1	1	5306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfPZXHDwZASZTSRaKmpjTSzZmwP7Ro71PV4ELqKjfuBbXzG4P
14939	payment	1726	1726	1874	1	1	5307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJT1W7hm8uMP4VAcZAAVAaV77LKNEoNhWK4ifX8kvQrM8zXVE6
14940	payment	1726	1726	2092	1	1	5308	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvkkPVuD88CJq3HteWcoRKvQ8VXeqhpeBZ2MYe7s7HBaB4Zc5m
14941	payment	1726	1726	1874	1	1	5309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51SAkoJ3LRE8HQFeqDmjK644ccRKAJ9wH4hiRZHez9xbYANrP
14942	payment	1726	1726	1874	1	1	5310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVxJHZDSa862iXKsrXvcSngPy9ffadSS7WAA6h6YY4WxpxyDc
14943	payment	1726	1726	1874	1	1	5311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa211xvv5TKPi7ekHTSRvTixTGP4pfwXNtdrHK28U7hahbCfayT
14955	payment	1397	1397	1678	1	1	7382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YJPuWsYdyXUY6JfLK5n7VFZggsxX3Wzu8pjvQNrJCXSPbss7
14916	payment	1726	1726	1874	1	1	5291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zVD482pepFj6EDtCo52BphBnrEU3bSQXv1jmQvdYCSCCm8Z5
14917	payment	1726	1726	1874	1	1	5292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgzdBtNCTmLGLySEpBQgXGeMP9j7A6SQeTDQuBpcUPxpn2LkA
14918	payment	1726	1726	1874	1	1	5293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1X7qzdASL6bB5m2wSXNztSFbiWKPovDV7mpneA9MEXavRzjV
14928	payment	1397	1397	1678	1	1	7375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtx71iqY6BBMnb1f1oBPS4JyqcdfwUPgYxa818gCjxxuL1nnVn
14929	payment	1726	1726	1874	1	1	5300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8mGPfHeUhAYxKNU5Fg66i97zYm43evBKkmtRtcbr63R23TfG
14930	payment	1726	1726	1874	1	1	5301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcxNtV9b4xPaEgPMANqYukde56k9YHq1JAU9XdY3UGzgNZyKp
14931	payment	1726	1726	1874	1	1	5302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SSwa3BUZVgHQBNYDL2zH776VtYkx6nGsfVBMegHjhAxWNm1k
14944	payment	1397	1397	1678	1	1	7379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR25beYm7zMwiWoCRPL4fhmcPjCFd7hqfLYySDa4V4RuEbBgkN
14945	payment	1397	1397	1678	1	1	7380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoatE1o7cUzXPTHh4mS65NMZTpY1xyuT5PFbK7KqoSPUwum1A
14946	payment	1726	1726	1874	1	1	5312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuxLkDw77UuENRZE8qR1iZGCGrihjuzCstKTUHAmBC9QeEra2
14947	payment	1726	1726	1874	1	1	5313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uKhsGSLsxMQogtDmMbAizPCu6MteH5DDACf8SdPHYYFGfTrC
14948	payment	1726	1726	1874	1	1	5314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hPpd2yjuF5hjugUVQyfEC8nEvDdthc3eUnD2TVMN7DnmV6C8
14949	payment	1726	1726	1874	1	1	5315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TW293AxwpsuBZyfYHhE7izrvqFsjtFu9NRKcDyabsPWN1Sz1
14950	payment	1726	1726	1874	1	1	5316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91yDBUjMKJjWcumZPUNH7YHXVmcRhDwpC9U8XmQttFHBt35ZQ
14951	payment	1726	1726	1874	1	1	5317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpNHhKaSTqxHvy2g1NFmtoWr35iwt4TbabTP2iNExrtG5415M
14971	payment	1397	1397	1678	1	1	7387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHGYmx4e7CwGfckSb4dFceJPnmQy9qePNvwKYMNTY2vs1FkEm
14972	payment	1397	1397	1678	1	1	7388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuurEsHDayr1czfAfR6ZMuHbyVUeTsquVkE6fMNaUCaECAkA9k
14973	payment	1726	1726	1874	1	1	5331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGbRX7Cen93Qe2VBpLoZYrUVe49rnvpohfTmkhZtHzgpvVGQD
14974	payment	1726	1726	1874	1	1	5332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fRMs7A2jv3vrddBNKGp6HBSoaQQJFT4HynxhLoidPCSj1uYi
14975	payment	1726	1726	1874	1	1	5333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3t7rhe5ktsM4MQ2JrtEj9WSJg1usDLfLzdSJjicbPWyuoBiQ6
14976	payment	1726	1726	1874	1	1	5334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYmbxStwLizPEhyHAyKjKKPuftYSSTm4Dbjgu6tt7jyLpQD4U
14977	payment	1726	1726	1874	1	1	5335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENcE8a3WTjT2u6SHMenEYuZHwy3E2bRU5dfBRnYgkofvJUtXp
14985	payment	1397	1397	1678	1	1	7391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKRBnQS6LNRJgS6XCENqZWGb8kdrwxkgcN1r1BbiccWCL6Vdc
14986	payment	1397	1397	1678	1	1	7392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9KqJGrdbRK3FdFCLmhjdgfHQXfDifzR2eGjsT5Qejqvgu1kD
14987	payment	1726	1726	1874	1	1	5341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECX7arh35t6FqS4ThZfSP397jvtge9Wb6trohuYQEm468wpKm
14988	payment	1726	1726	1874	1	1	5342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdhBDuunZXX1mvFKYhL6wi9zpe6xWcwCSt4Fg3wR9RpZZPSv6
14989	payment	1726	1726	1874	1	1	5343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRinSJ8AdMYAVtmCoFXUMXGuXoTGpBbKTgtPmpmLzTwkWgKFss
14990	payment	1726	1726	1874	1	1	5344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9R2Fk5R5xszkLg9jPFkuFNCjh9CEjHxnWMkBnGy7cc3tQij7
15013	payment	1397	1397	1678	1	1	7399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTa6yeRSeVt3cTgUzrbT6uXeNMbSg6yLyMkg9548W4n889AfxF
15014	payment	1397	1397	1678	1	1	7400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcyXAfw5JxiZgLALYNv2T2yEK9PT8g9N9bq9BuVvbjDvqRLdm
15020	payment	1397	1397	1678	1	1	7403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnn6RXqT9CDfXtY6pcdAZjw8Y1zLxNwsVjiGQqzsuaWeXPkS9
15021	payment	1397	1397	1678	1	1	7404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5XgNZy7PtwaaFTn9qmxvwuFvDA9TYEi1igDoDBmFfKcW2Ugd
15022	payment	1726	1726	1874	1	1	5363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJpaZT4PpfDd4GFkpmP7pNEgt9z4rAKkQbKt6By3S9Zg1DXe5
15023	payment	1726	1726	1874	1	1	5364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQjP6XYYvi11mqVEvGxicSje2xnu924YMDxHg8WnNMdcv769B
15024	payment	1726	1726	1874	1	1	5365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNeiHETHMSCtBQBPT8t82BvfBju7wCLPMonD8RgzXNbwPyzkE
15025	payment	1726	1726	1874	1	1	5366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3p7ewgsAetb3SoS2v1EbgKWzuUvshBuG6rmbLw5UuWi2GcrP
15026	payment	1726	1726	1874	1	1	5367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvFP5hXFbpKghxEV7QxBSwECRN7eM3iVTsYEmKSYXUjnsbfB1
15027	payment	1726	1726	1874	1	1	5368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2nm4S168wo6wadVw1u6pRvdp25yBiyHZbUaf62o1VrkyTnQS
14922	payment	1726	1726	1874	1	1	5296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcztTXfExyGstMtFHZhFo935EbBc9jM4FK1J7H8wkt6iDyWE3C
14952	payment	1397	1397	1678	1	1	7381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJoU5dkv8MVohY46MSHtHSx2rabyTMoNRPfoGWjZGeZk9sGQT
14953	payment	1726	1726	1874	1	1	5318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHQmdoEZfMXqpV71SJ3FtTfnFR4Ky7S6pLRKZMcPR61LshVUU
14954	payment	1726	1726	1874	1	1	5319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwVZMNhR1k1Lhw7Mam6VAmkxtimuuHiMVKS96ueiyQnxnUpXL
14979	payment	1397	1397	1678	1	1	7389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgp5g23s6txafM3qxDQiCCX1yJSZJbQQ7eRs6sCKuqPynZvfaj
14980	payment	1397	1397	1678	1	1	7390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjgD9G3eWSYFeEyknfkBZvX5fiucMcmoaPPkXBRW3nw6JPbxG
14981	payment	1726	1726	1874	1	1	5337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sa4CTzRnqWfjuPNUTJzx8LhDWLjnn7SM1GEp8tVR49UNgQRv
14982	payment	1726	1726	1874	1	1	5338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEHKAmnWXVcRRJb5j47VBtXcvfmqicK5zCJ4dq8oGM13HxPQ8
14983	payment	1726	1726	1874	1	1	5339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgS6Xt7Dz4wbFX6YaaVvSuwWWaxiTcemcKaFa49XT3n8U4DF1
14984	payment	1726	1726	1874	1	1	5340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkPh4s7jZyypHG5M3DBrr7suip6t9518Rmu3CenRo8qML8wfZ
14991	payment	1397	1397	1678	1	1	7393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYqnCb7NoBQ4AHWxmEGMbMt6GdaQmMLZVLdR117kKbiimeRbf
15033	payment	1397	1397	1678	1	1	7406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjpYV6DvfHbxQE9YMkVkbyeU4oLHigANjPHBvTCLd4M5ydVXY
15034	payment	1726	1726	1874	1	1	5373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3UufbQuEak4a5Q9G7A95g6avWNXW2D7cgyFRGVKWiMJ8gxiE
15035	payment	1726	1726	1874	1	1	5374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AD7bzcch1jA9h5XCaGbEuQxrxhtNXp6mn4RNq25mehZHPtjy
15059	payment	1397	1397	1678	1	1	7413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBcskXf7WdniZdtNZUqhbx3M2L5rvY9Xid4d4kD7JUvRonsh6
15060	payment	1726	1726	1874	1	1	5390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAKNF3FJMvGkNiHyPAnFV5doMRFLdhej6T927CggZYUVcK8rA
15061	payment	1726	1726	1874	1	1	5391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdStAL6iKbbrgSfPtThPxBQu3Vu4jXASDE2q69Kjod1AKZR3ev
15062	payment	1726	1726	1874	1	1	5392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEuPAAyNoSrrq2n6NStBXoaq4V13cfhx9t3UxUM63MgAg97mqk
15063	payment	1397	1397	1678	1	1	7414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyVkhZaJUgpWgdbLNPxTbQz8CdvLtXdmqHfPBw9652mCcBsqh
15064	payment	1726	1726	1874	1	1	5393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRbiDnVV99LHAsX6w5QkXJ9jRbRKteJZZKZkp8Y88NyT8r3aK
15065	payment	1726	1726	1874	1	1	5394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTb8hbkYwckuF5QXiZpqGkX8UMKNdcAfxzs3nom7y4P3i1hmMK
15066	payment	1397	1397	1678	1	1	7415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrCKyFXabnVyc4G2Lw57VtgAFVxGUHNt9WHAZ5AaMgecXCskF
15067	payment	1397	1397	1678	1	1	7416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRVPbodNwZnoG9KqjLJUn5wL6DKYwUbGrkJE68vAS2Z1xdGri
15068	payment	1397	1397	1678	1	1	7417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWZDKAbezzbvVt4c5nEudr8eARtG5wqkfCBNuAxYZkGLMEQ9y
15069	payment	1726	1726	1874	1	1	5395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmnxrm2DvA4irRipKJ65FS8mB4Rdf5yb4Uqx4BZYHfGRCMM4G
15070	payment	1726	1726	1874	1	1	5396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsWCNeVEpPcHbWX73j7PzyypEm4JVYErTpJWJThaAXY8UZpkE
15071	payment	1726	1726	1874	1	1	5397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyLEwzbtbrcGDhsLHuAA188QWkaLhjokSRHXzUjEwCYf894Aq
15072	payment	1726	1726	1874	1	1	5398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcDjHezivEaL98XxwZLdJLMGpiUK8AAm69bxJ3AHqkwJpY3R7
15073	payment	1726	1726	1874	1	1	5399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbkQPkk1HBUiFJ5QZwKnsgLdmQGKxYASFZ6MjaRkVnB1H3Gms
15074	payment	1726	1726	1874	1	1	5400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCtTTZus6TXVYSJLnEHED11c4hoy6Lna5HhoR5WBBLxrJjj8S
15075	payment	1726	1726	1874	1	1	5401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMLG7NS7ugSWizY9VJuH4C6gAaCnyg7tw64FFBjzjr7WiSh6r
15076	payment	1726	1726	1874	1	1	5402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcAn6cNL4Q1TrnqjoExS8yGtRMTXHHDN8vKvN5DB4Eb64jLPS
15077	payment	1726	1726	1874	1	1	5403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoMurqfCNqBAn1V5Buj5WKSh9Q1U6MB5KjBzzBt3jxvsrD415
15087	payment	1726	1726	1874	1	1	5410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2QYrsqrjGbyqdeDgnC5fzrMCPqa1guPRTpBEbTp62Ef5Vs6W
15088	payment	1726	1726	1874	1	1	5411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYata4iPXo2txzx86gALUweiVtf8o2J2Kn2cXEVF48CdtswPGsH
15089	payment	1726	1726	1874	1	1	5412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKeAKPi6sHE3LYcNDdtV8wNFcLmDGkJ5hUvgYh5qpEZ2mTjww
15112	payment	1397	1397	1678	1	1	7427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1wLn9DXuh3252WbAB33GvnN5sqhN2vKbCRviisdS9XNsYoEo
15113	payment	1726	1726	1874	1	1	5429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4FgeA4WBg2Xr4gvhQyskqrhoszo8xEDuX5s2kRgSeiHZhg7F
14956	payment	1726	1726	1874	1	1	5320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQugegkvL1mnA8v7iZLx6W5xjUU4MK73pkHVo7MDAQx7nGq4B
14957	payment	1726	1726	1874	1	1	5321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd134vHhZFHjDzFkomLF3xwCDqA7NAMjiuqs9xSpJv6UzG5Mkg
14964	payment	1397	1397	1678	1	1	7385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapWvqmmceLmooZ2r6XTvjP8RnWwGotCrVHJmETBuT7qzWaDv1
14965	payment	1397	1397	1678	1	1	7386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXnWUvt6nDRgk9x1crGnYvMTAnU1vw9hD4GMXaJyRrEoMMmQa
14966	payment	1726	1726	1874	1	1	5326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLg6nxFcxVak7yzbnQ8vx8dj5mY9GZNYMFQmHHRCUYvRztbEUL
14967	payment	1726	1726	1874	1	1	5327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLUegxmGJDAHDvX7MLShdkqcvMu3CffnhEscaA4dMMhvh9SQi
14968	payment	1726	1726	1874	1	1	5328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDz8vtmVSrjA1AZtRXYmnnhAFGAkzFwSGa9RavpxwatcMEeJYy
14969	payment	1726	1726	1874	1	1	5329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKkfzeduq7xF9h5TwyV5bTbeWt8h8zqwyXjDoBBBQWn1ndzWe
14970	payment	1726	1726	1874	1	1	5330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfSguyskkr3nauA8jJNPurnwsHHhJb4gpPhvp3FBfTwhZUYMw
15007	payment	1397	1397	1678	1	1	7397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbBPrCef2C46H34eiEKmTZhsa8eBzdjpFfQvZuTrGjs9oU1uv
15008	payment	1397	1397	1678	1	1	7398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nHu2xkkJd5GXDY9bCDc3LXWj93uSuMvEMnXNPhLc1uaa23SP
15009	payment	1726	1726	1874	1	1	5356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9FG4Soa2XMSkTQmatZ4T1Nh7r46dfNG6kVBPPsBu1Etj9Bkj
15010	payment	1726	1726	1874	1	1	5357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMikc2J4z9RemKU5k6uZM59jYSDRAFtN6CNqDS3BCpBDzGsw3z
15011	payment	1726	1726	1874	1	1	5358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskFAv1NyYcY9maHFFacTeS8oWH6GaVZxWDnQ7DYctoePtish3
15012	payment	1726	1726	1874	1	1	5359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4Cg6TNPmXCFhmyKLxkKzRog1nETweSkV63UfDLxPs6jbu79V
15018	payment	1397	1397	1678	1	1	7401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMCwebYejchHoLdvkGDcSmoQKhhtXUUpaUm6L4qaDNtNXniBv
15019	payment	1397	1397	1678	1	1	7402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YvhaLTsQhu4uucPUUFfyMafXfzzPTtLmcwSUeYAxXBDXD2v2
15030	payment	1397	1397	1678	1	1	7405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLcfgEo34KWyc1M8U11XYQndCLciWwADbyThmySxt1A6kWVdUV
15031	payment	1726	1726	1874	1	1	5371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchPa94omPJMvr23rakgaSrxXJCSGiREnsRk6qoatHnRnMs5XJ
15032	payment	1726	1726	1874	1	1	5372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1AHN3NdZMVTfrCJR6ggWkuncuM2k5DfXtaSQ74hw3kCLe4HD
15042	payment	1397	1397	1678	1	1	7409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8GQZPhMeVCQeotAAohWwaC8sFrRJipwoHMcTSckFH9Em7VpN
15043	payment	1397	1397	1678	1	1	7410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93aDxagxMVuQanjJBP9LxdJBnfs4Ke3AeT5AkGmY3NCWywPVj
15044	delegation	1926	1926	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr2mrYpnN5yKFk2nvV8bPnygQrNCW5sDF2fHX7beHgDfjG9di
15078	payment	1397	1397	1678	1	1	7418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXuDChFTADUg7Xf33XisNYcTENqaemkDxkef8UHJ2AZyQPiim
15079	payment	1726	1726	1874	1	1	5404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxjxyNuFDbEeBiCA51KPooheLJdgrFzh7FTzKwhCLTzp2cpd1
15080	payment	1726	1726	1874	1	1	5405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnYEKe8xe6McamvMCbhNrbrfMBZ9ykHGw1cVHhrzKtuVCuGuY
15081	payment	1726	1726	1874	1	1	5406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbAKNys6czJE5kXGsETUeMVjz8tMXdiB693A3dcTkAVuvHZeN
15090	payment	1397	1397	1678	1	1	7421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXgY9mZPDsesBQ2wvwbUGv3DzMa8ua3Ei1dRunuKd4tWW3ooN
15091	payment	1397	1397	1678	1	1	7422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsYY28LEcmQ5DJSyoF6Uu9idy9mDapFi2CAR6ZjNY4Ldggupg
15092	payment	1397	1397	1678	1	1	7423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcsKFEsiZRFUwXKftzdiwxF4DRK88HVHUijb7JPFeLV3gr32a
15093	payment	1397	1397	1678	1	1	7424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSTycfWDmkqtnfoy6ubVCsrZUY8a74hENfkqvmhs7aiW2MLfW
15094	payment	1726	1726	1874	1	1	5413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrKDVqkbdgYXH37GfE7HtjFjgSKbVbfUP3eXQDAvDz1P74FVS
15095	payment	1726	1726	1874	1	1	5414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3VTPwGHyEjZrXRpGT3EX4ewmSgKVzLCZ3tSR4FSaoQfXjvZd
15096	payment	1726	1726	1874	1	1	5415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7VK9VpipogLiMoAgDJ9NxrketdTPWzQSTPXVALRwucLQfiA6
15097	payment	1726	1726	1874	1	1	5416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNyQahWi7iLTzx1zSuHQPT46NDZumU5qssdWdeJMSVBAc6ZfQ
15098	payment	1726	1726	1874	1	1	5417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4gWvszTsoRPZcycsWmkCKYAJzQ8TA47LTgePdL8PyvP9mmQ6
15099	payment	1726	1726	1874	1	1	5418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNUDRQNXgSCVAEBK8GervrsHtYM9sdjnzbgLhKkcqMvc8Svex
15100	payment	1726	1726	1874	1	1	5419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3MiLPi6LYRcvWFwpUBbaJtiWAkZr4qixfRyXennbGYZ2zf8M
14999	payment	1726	1726	1874	1	1	5350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLRRKXv2s2iy68vy19hXaD6UU6FjUg3aJewkHs2xnGPsbhbsd
15000	payment	1726	1726	1874	1	1	5351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wjEv9deHY9VqyegDE5Kwef5e6KeyQ6aufTDVyaXs7gnPYB8M
15001	payment	1726	1726	1874	1	1	5352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwfUfcxCackjejsEQHvc1YS32qPHZss5inJCaxxnJtEYkxZEu
15002	payment	1569	1569	485	1	1	1	721000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixUeFGvaJ4ypkzwQMVoTpByKbMLDSfU7G7qWeBP1HigzzMnt8
15003	payment	1397	1397	1678	1	1	7396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwtqF9m8SVhyiHUNpShaHvzyRZboKxJcUZy9enhwWW93VtjEo
15004	payment	1726	1726	1874	1	1	5353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2mAthM8Kjp8VUHXJUtGsxzhrJq3kHXw2SrdGCwbqWqbmNzbB
15005	payment	1726	1726	1874	1	1	5354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5M9UBZeGsjGbHtAEaLBZi7rNYXo3TyHhKTJYHZdG1FCsK4svG
15006	payment	1726	1726	1874	1	1	5355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDJjEUUM5Y6gKQS79Bky6iTZyhb4AnKTVork64xPaN9Z1sbP1
15015	payment	1726	1726	1874	1	1	5360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasfvNHyBbsf7Xkid17tvXieVa6ZUQnZRvnad5DbYBszxP77pF
15016	payment	1726	1726	1874	1	1	5361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDK9GcSBeQZ8TuyMziruWrtZ1d5APSbZDb87Dhaeb7o5yK3JT
15017	payment	1726	1726	1874	1	1	5362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZyH4KoWHbfmda9BTbS6SS46aLAH98gCfvMyfx9ha8iTUGXx7
15036	payment	1397	1397	1678	1	1	7407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VdAZtie9q3p72VUb3FacchtzQcjRdMok3S4tYSqPDoeMG2dp
15037	payment	1397	1397	1678	1	1	7408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTQjKK9jLwirmqAr6cehqNfjmAmdxsmB8tEAdHzS9z9xqRyiq
15038	delegation	1750	1750	1745	1	1	31	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopboChuv9Dh7pkDSE9QfVW2rc7fQCx6dtMPVBLY8FtSNEVo9S
15039	payment	1726	1726	1874	1	1	5375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3vQ6fhx8AUQVkdfm4WN9kWX16F29MJnG796kdT1uBpRzZFVY
15040	payment	1726	1726	1874	1	1	5376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6Xn72wN6rGorGW6MGM2antmayz7bs2T4EBw3HLxUHkdmyFk9
15041	payment	1726	1726	1874	1	1	5377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTped4AqggLX3SPpWJ8LJ33z4C6jCt6Rz16fs23KK7i3PNUMYi
15055	payment	1397	1397	1678	1	1	7412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCDqT3av3fgjoWrTuxgBB2uZpFZAe1YTBXrEvTLGG76UEXbtt
15056	payment	1726	1726	1874	1	1	5387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2tzsMhZBWmg8Uy4VDs6cwGnsNJ29uym1hMxbTJ8KrqsMFU3W
15057	payment	1726	1726	1874	1	1	5388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBc6fZDnWE1KXcs5oJKLymFstoZ4AJqxbxx8JCSW4kb9sHrMGj
15058	payment	1726	1726	1874	1	1	5389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjZDKQoR4vj2mZPmPcxZ3j5WMEtaZyQapXsUaFKjNxzJkRYie
15106	payment	1397	1397	1678	1	1	7426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKNpktYtbn6FPFkVnHVqQT6yNheXYwy3uAocHk7tCsArRSKts
15107	payment	1726	1726	1874	1	1	5424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECERnquPMpJSSnRM2x2cAJYeNNsY6BpWLKuuAFC4gvAq45WtB
15108	payment	1726	1726	1874	1	1	5425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdimFFStfqgnDCG8PA316eER58Gvk5J63c1k7CnNRhzp2TsL2
15109	payment	1726	1726	1874	1	1	5426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6kPY6Awhzf5T8xp2kRuSFpH6qSrwMMLEDVSXnnW6GPXcg6pb
15110	payment	1726	1726	1874	1	1	5427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqkkf1oYuRZLzLy1XYS3MZcwi51r4pU5NnCCmdaBLXJbyuJSy
15111	payment	1726	1726	1874	1	1	5428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYiDRcrL1WDfy5ZREq7px2bqJ8NACdMgZiNr9LHMKQLAUfiMgn
15120	payment	1397	1397	1678	1	1	7429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPbsx6bjLrqR95PfHFLzPduzwaziWFep6AqYab12G2RwtnKQX
15121	payment	1726	1726	1874	1	1	5435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6DTL6KKVeBhp89q7SE7DbhZUiqxfdbCNHN5ZY97rd8q4dbWf
15122	payment	1726	1726	1874	1	1	5436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbzcGerie86HFiVqBbXBEWbjphENmRg7q3VQ5XRFouAtWoDTR
15123	payment	1726	1726	1874	1	1	5437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3j27cnnDtdMjFFUPDBcvb1sWhyxDGA2JXHBTnhqpvEkySqDjn
15127	payment	1397	1397	1678	1	1	7431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJFD5qqNRUBUYGq3F2WRSqha4Hpk6GzaTTpPzbidNnAZ3hRyy
15128	payment	1397	1397	1678	1	1	7432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPFfLe89mjDMvDC7qeNKW9dT2iAhxFiAqnQqFEurqHr7dtFxm
15129	payment	1726	1726	1874	1	1	5440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAztgyurrCN77MjkBepNJsmkAvtGPjrnWxUDCPEEyyMSoCdp8
15130	payment	1726	1726	1874	1	1	5441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5JgT1U71cP54heynSRfUM6HaKiEUTd2QYtPGtXMxRfCwrPcs
15131	payment	1726	1726	1874	1	1	5442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVx3EcJVmfP49HsTKJPEijKSr8mwLsDF7JYPwwctq79PioFMm
15132	payment	1726	1726	1874	1	1	5443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybM8r1VN9zo4Zu7Whvu6tx271wdgYjLaxrW8qFwYQL6twAHa4
15133	payment	1726	1726	1874	1	1	5444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdMtrkFdAiz4oEyGMUDiwLRm4mLxSWNUcvevTjHJhgrEnBu42
15028	payment	1726	1726	1874	1	1	5369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavfMa5wEFCq62hCxJ6g73C24uMx3oJGDPWUH5ybsUt3jeitEH
15029	payment	1726	1726	1874	1	1	5370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EvBmGDYFxbVrLABBWkbPq6wRAEAGdgRserG4RsEA9BauTwmb
15045	payment	1726	1726	1874	1	1	5378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Co1ov1UAsh5UgA2MFDF285a2SRFYoz5Bfy7hrAUmoNpXZse2
15046	payment	1726	1726	1874	1	1	5379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMZKc47YgVUnULzG87TmXFbcS3Juq6oDxBQknZJQkzPBAdR8g
15047	payment	1726	1726	1874	1	1	5380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJk7yDjUerDEP9nAh2etEXstz6LrDEND4LJtvPVKc4hJCgpkwq
15048	payment	1726	1726	1874	1	1	5381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpgxoUSceukuAhY6w2sAf5N2gdNWDNjHCbtn6TfeKpDsXSWMa
15049	payment	1726	1726	1874	1	1	5382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHDsv4qaB5oPGJAsLvwZpZ7biMxEbPdWh1cSnQXjN4nZkxuNz
15050	payment	1726	1726	1874	1	1	5383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbgGHhbp1dCr2VwqwAoFdFQkutVoAAA5JWQGJxEeoDnLQwFh6
15051	payment	1397	1397	1678	1	1	7411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvmBRLGF4gtuUzd1bJqBo8pkyY5gR2jVU5AGe6WVQd5Zka4Bf
15052	payment	1726	1726	1874	1	1	5384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6TC3feBob8BkZfBa2F9pjy3HED4oYeiHA1aL9mY11w8e7yBX
15053	payment	1726	1726	1874	1	1	5385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uj3WXQiHTxhQVbUzA76wNWepKArd58G87BkxnPrMsxBfdqyP
15054	payment	1726	1726	1874	1	1	5386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwJZ1ZbF37S4EntbTVYNmBye7BdzYro1xbhvn9S5oBvebLkB9
15082	payment	1397	1397	1678	1	1	7419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN23t6AoKAmA1gDpwRp8dKJ2Wh86jWXvtz3JZ6UVrezCZhFJvu
15083	payment	1726	1726	1874	1	1	5407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zPVGdkicusAbLa92x2D59mCfCtrpreUL57t3H9fc874ULPmp
15084	payment	1726	1726	1874	1	1	5408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSxkGgKzu7UuEPfAuUPdTN4R66XUh1x8xZrwG4jeAGB79aVKi
15085	payment	1726	1726	1874	1	1	5409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5uhQVnA5iYoGT6crQSsip692s2Ufug9pviijrtGx8tUnrE1e
15086	payment	1397	1397	1678	1	1	7420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FZD6PxDzVnG3NpP6ugq7EVVGii4DHfoXzUeh47saaaDNWmox
15105	payment	1397	1397	1678	1	1	7425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3D7v4Qp3zBUTZLRecmwdgM7iKNnE33PzCGMLSGbU3Di4J5Z2i
15116	payment	1726	1726	1874	1	1	5432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLre3VpMQ17Bn1cGguWJN1MtM72aj3ywBZNkke2vZF6McdDHB6
15117	payment	1726	1726	1874	1	1	5433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5ozGegz6U2gLRzAW17BPe3k5DADdPGwNqZX6dMqaCh8UXJLZ
15118	payment	1726	1726	1874	1	1	5434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDk2kyRH44pKGXzJM2DcC8HnxEkqNwiH9mekMoQfeSSaFnJgT
15124	payment	1397	1397	1678	1	1	7430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSuQcvDHYhcdF4TstTrueFWNFL5BGYQwVbrxnxRMmCY6p8ifS
15125	payment	1726	1726	1874	1	1	5438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XXx5sbfuDCns2SYiDffqGQ2bHu8DqbWGhCi5y5Yemjdy9PKb
15126	payment	1726	1726	1874	1	1	5439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4EYX9ZWUNL8jN7xEsaJVBAe3xHFyJAZcx76P3hpbVBshEkAE
15135	payment	1397	1397	1678	1	1	7433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEE4z4aYeDWPrzaQntUgQCNysRKt7M5nuKG2FUPiAwURy4xXd
15136	payment	1726	1726	1874	1	1	5446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaFssj4wFJtjod4WcgbVaSQA6D1ND8jmB7EqzRD9wxTaqYmKr
15137	payment	1726	1726	1874	1	1	5447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfBMXwqJkRs1hT98qfv9bpCeGB2SnviQ7mrAw7K3ovfcUMrfE
15198	payment	1397	1397	1678	1	1	7453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiGKV8C9PsVmNrrVcch23n6pkjEkx6LdYopSQHBRtJyxrqLko
15199	payment	1397	1397	1678	1	1	7454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7m3E2ywHhVxgTCcVyFvN1o2P4pJahnertd7CpnWkFxQNwaUZM
15200	payment	1397	1397	1678	1	1	7455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtsKiv53xDUFJHPNoLkZoQzYL7boT6ApQfrwmcDE25JFyfAvc
15201	payment	1726	1726	1874	1	1	5488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstiGcqGA2D4i9eSNrzy7kovC5Bas5nU6LQWZLL41NtTDyRKri
15202	payment	1726	1726	1874	1	1	5489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4K4ffVyqRbcjLGvrrMg76XNH2yQRj98utmAvsP8HzEcN4fRc
15203	payment	1726	1726	1874	1	1	5490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg2GFUBGQuqmTDDY9TD9BYYfK36ix3WEiuH48iCLNWw3YLPds
15204	payment	1726	1726	1874	1	1	5491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxw4sM5ix658Mo1uCrpnUbnbdjXbprvWoctUoV8T3n8BFNVbUo
15205	payment	1726	1726	1874	1	1	5492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gTYkRVMfSXmGxzaRBLsZLnjS964b49yvjbvV4fhjgwsKT3j7
15206	payment	1726	1726	1874	1	1	5493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eivat2mGjFQDc9TjoSBqUGNLQ2FBgC6cH6rxSEAFCQF9CH2J
15207	payment	1726	1726	2093	1	1	5494	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdvHFUS5oRs55MgGqQbmrLTDRnZwJu6ELf6SP8gbpG4i4XQBBZ
15208	payment	1726	1726	2094	1	1	5495	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWMHzXRgHXAACG8LPKvZcMkw3fnoZJTuSa1cdjyjGasEGQZ8MZ
15101	payment	1726	1726	1874	1	1	5420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjCBBttZY2UdA7U91C9BhcaEBoHcZU1W7X3ryMWkJCFX1XLrC
15102	payment	1726	1726	1874	1	1	5421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqTLwSrv6XuDS6J8R5ssrF5Nk5yhf3aC15ahTCJ7SBhAYeysy
15103	payment	1726	1726	1874	1	1	5422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgv3vjc98fSrurGwyQU8LupgwYnS3r57MdepfjTyJMeL5Yray
15104	payment	1726	1726	1874	1	1	5423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27EUZGB9yvHfhFDdEnoGgYDPfVbfdUuUnVDanTNH2eWdm5bu5
15147	payment	1397	1397	1678	1	1	7437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2qhfn6hhUzpLxDoFjJfMvfZAaZ4ti6C41y7ra9yBjyXxLEL3
15148	payment	1726	1726	1874	1	1	5454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyPCAbUJMwVrUybT59YGVSkvKHBVdcnc79S8H6vxLT83gLAJf
15149	payment	1726	1726	1874	1	1	5455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdx1Bsopcd9MVLKYbXjY15iSd8cKUu3a3BARZodkEYYZ5zVjGk
15157	payment	1397	1397	1678	1	1	7440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebnewopjgF4iLE3i7ZcePVRxzgBsmMY4PSE97SeukU7hLeK6r
15158	payment	1726	1726	1874	1	1	5461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBc5ByrKLxhQr9oBSPkUhMnnxoKWLpAw5CKAet64BwT5MdxPhi
15159	payment	1726	1726	1874	1	1	5462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkF3tud1aFgs8vTUBu2xe2cxd1Sixbi69DCfd3YSFeaaYv81d7
15160	payment	1726	1726	1874	1	1	5463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4uHjxKUHvXrAmwcxhpDVwBDFgwoHMrd87nHnN5GRr8rXgMDd
15161	payment	1397	1397	1678	1	1	7441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBoCZdPni68JkTvkeuqDXU2T78gyGMcWUzr87MSzvtSVHZW8q
15162	payment	1726	1726	1874	1	1	5464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RNt82r2E4ckBWwaq2gYY9MrruQnFxgoZ4hjH3sGr8MAxuLEp
15163	payment	1726	1726	1874	1	1	5465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYToVqVjstzW1xmn3ihQQiqVKRWuCcUx3eRXYVsVr3CmHdzN4T3
15164	payment	1726	1726	1874	1	1	5466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUyETYr5DFrw4ViesN4v6nMrc8gn48ieaLwPcjhrBnEn88eAj
15180	payment	1397	1397	1678	1	1	7447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5kFxSLq1HXKMXYiNKzHxdkJh9S1UW8qWWw9Cv1nkHkigt4aK
15181	payment	1397	1397	1678	1	1	7448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVvPTmzZsAyz5tEu2B5TEQkaRXiH1q7oDA3DnroQN7Z3Dff87
15182	payment	1397	1397	1678	1	1	7449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4q7kdtnbRYw4nSguat7bBWBYAcoAFiLnFS4dNj3fuYqRoyxc
15183	payment	1726	1726	1874	1	1	5476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7ZAYWWb2fxBA5mGPgM9G1mMg3ooMUfhsfAVDHXhYu2pMFLtv
15184	payment	1726	1726	1874	1	1	5477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgjtGJZQq9K41kL8drr3y9xJbMFF9mLjwGpgEpsw4ysWhtmgg
15185	payment	1726	1726	1874	1	1	5478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme7HcLuNgtgYJCy6VYSwHZCwM51pdoyqzD8xeLRybsNopC76N
15186	payment	1726	1726	1874	1	1	5479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf7a2AoYSWD5FMFgC8Qbxi9swuJYCVARfAkFciTrNSneMwr84
15187	payment	1726	1726	1874	1	1	5480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfQvnWrujCGikkHEYpicTg5wVwbQaL9TciuCEZUUurkeUD61m
15188	payment	1726	1726	1874	1	1	5481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxMrWr5KK94tuf2afe8dGicpV1FBbs751sq77koJgErTjWAoG
15189	payment	1397	1397	1678	1	1	7450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCSETb2JxStEwo5D8zCNSLyz5LT6Kf67aunSwvQGG3kHTaz1Q
15190	payment	1397	1397	1678	1	1	7451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVY6DfPkibPbYcs6PEwsMKzgpr55LeY1NZD2Mztu7T4R4J2az
15191	payment	1397	1397	1678	1	1	7452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fGNVfhoY7voaB1RdJT11T9X7ibYjcNdMqgJayi8eVNVk8e1g
15192	payment	1726	1726	1874	1	1	5482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzj33RhvocmGVjp1QmdHGyEvZv96S2FzA36zGy1nD3xKyqtii
15193	payment	1726	1726	1874	1	1	5483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwbaBBfw4Rna5bSDDDeLiPmD31BHHu6dDddtQycWGDjjun6kr
15194	payment	1726	1726	1874	1	1	5484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryuX5vofNJvpGWcJJobjAbfXL6Vt3SYJa3tzkgXGcbyZBsDDY
15195	payment	1726	1726	1874	1	1	5485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXDDXxbGBTdBiHhG6DJ6MGggEbGiZxpMKPSHunbGG2SMhUJz1
15196	payment	1726	1726	1874	1	1	5486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7xHyGaJGHuxR2nf2yFkqjLnpf4WNKBXs4cyTmFN9fyoUkE1M
15197	payment	1726	1726	1874	1	1	5487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNPcPVZKLWKfGxkvPCfFLdz1WMgZkuUfSzCM9REv6C8Qivmon
15219	payment	1397	1397	1678	1	1	7459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFf7BzC6DB8F7jGdhCfm6ZgPVbcPK5zVKEz9NCnE2KMowZwhdj
15220	payment	1397	1397	1678	1	1	7460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxoADqwjK7nuSTmQW4dXBjyhNcPRcUdZuXnXPDAhWGS5nDYTf
15221	payment	1397	1397	1678	1	1	7461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8SxRxQrdM6nUHYsB9ArDgqNWkJkfnjyEwoqrLazskVjPPmxH
15222	payment	1726	1726	1874	1	1	5502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbJvLwtxk98tvCikAn45u1JkT55zG9z9HuNy6oaAr8gRZKLF1
15223	payment	1726	1726	1874	1	1	5503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXk9RWthYpESFCoYkrfds8gGjqhNBHkpkSdkqLicWeoG7RL2GV
15114	payment	1726	1726	1874	1	1	5430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVzBhmHm4oGQCziQvaUD84Rvv4uJU21wBUfNkryPtWFqhNRWD
15115	payment	1726	1726	1874	1	1	5431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNguDMZVvGFxm3EB197wMKNqcoA9PtpFCYfGyJjvTtvCWwMay
15119	payment	1397	1397	1678	1	1	7428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cScWhKeKEinr732MMLaF8j3Y115x4T4qiS16wd7ysQ3CaTkK
15138	payment	1397	1397	1678	1	1	7434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ctPtJw3PA7oFteLz1QErjoL5FDWpmsqMyPRBGubV28KMiH7U
15139	payment	1726	1726	1874	1	1	5448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZWuNGMMQe6aQJAHRsSdHpNEf4eTatZLdhXPncKRCNZtrR24a
15140	payment	1726	1726	1874	1	1	5449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSi5n7KxNmvgSsXUrkvhmKUN5pYDYu6ER2wwkNzDTVBgS97yoE
15141	payment	1397	1397	1678	1	1	7435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4QswSh2i2dbA2PaeNWv7cmfazFEuJkbp8NaQFu2eNZNcZ6Jp
15142	payment	1726	1726	1874	1	1	5450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq6FKAuYhpk4ffp77JESkwhVZKbTwJ4jPuTfCt2avsAXamTwK
15143	payment	1726	1726	1874	1	1	5451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXcNmNHuYzkAh1pyieW1W98fGSuEvHkxMGKLs6vsunGcywQ8Z
15209	payment	1397	1397	1678	1	1	7456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvaV2sjodnwEQRP7cXK2WKqXQg7p7sza9EQFST8EjTjtgB694
15210	payment	1397	1397	1678	1	1	7457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa688agSocy96QVQw8hudSLmmQ6tvVEFkGFggBU2Jv7bk8rR6cb
15211	payment	1726	1726	1874	1	1	5496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeJ96JMq7kwq82Usghg6qHLLML9HsyqMGv76J71CNZhuWPgAW
15212	payment	1726	1726	1874	1	1	5497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RjXdHL1ea5Mk9ZDXd9UYrmbBptP8yeWHJRPitxXP6t4TcFMv
15213	payment	1726	1726	1874	1	1	5498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1pHviGDGnZazLwsrsjMGg1h7c88NsvSHnYCFA66K5tApUoRh3
15214	payment	1726	1726	1874	1	1	5499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2dscSh4vZSe5b7aTbh5nXKNHZYKdpGzGSGD7BF5nyKGNvnq8
15217	payment	1726	1726	1874	1	1	5500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvREn2DXeUdL9TJTfCVJ4pm3Pq8BmNesewnoR6e58wfFV8WU2q
15218	payment	1726	1726	1874	1	1	5501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2e9Mbe9Vka2UzKRMoC3YeDQZ4gGRnmzwWzvKxL3itFFQiyMC
15233	payment	1726	1726	1874	1	1	5511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEhDtLHdotNgBcJ9vXTLicWhHgPZcizJc2DTfmkFEhnVETznj
15234	payment	1726	1726	2095	1	1	5512	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSMZSkme49bAT9q1hpMSPh9c2rfqawhKBEBFSk3iBcfYpQVnix
15235	payment	1397	1397	1678	1	1	7464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT8PBbQSrsJqyTxNxW2KbVzV9zPi7svq67GCUXow6cGHzBxYX
15236	payment	1726	1726	1874	1	1	5513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2mWLQUAhncbcgPdgHkK2qjSFEnk13q8QeQiGcRk5x5wPzLXe
15237	payment	1726	1726	1874	1	1	5514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSZZm3gkt2FjWF1xyPg3QvqprgbhBNA5oZBPxHoptr6w23r67
15272	payment	1397	1397	1678	1	1	7476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKWndidu3k2BgwtjusxyH2JNnZDNNVPVKdwnpwbgwt29GJgHk
15273	payment	1726	1726	1874	1	1	5538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn8MZbnzCq7nic8zeMtNMyF3dTLPCHtn1S9H1Qde551pXadLF
15274	payment	1726	1726	1874	1	1	5539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Yb1T965bg27JuNGkiwoX2fvAVc9q52jZnMMAW55orHaWwBRC
15275	delegation	2077	2077	1653	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vor3UyMabKPkG9pi9PNxmixQA1fLuvq1qa9NDmgAY9ixNJ9v
15287	payment	1397	1397	1678	1	1	7480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczCtt6zaeJVxDZyUEu3b71rKvYNJU8uMuVdS2u4ejjarr7Z5f
15288	payment	1397	1397	1678	1	1	7481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc9mEVM23vu6wHM9uB3UaRW6vKyjougJVTQ1T7sYi64iXpMUu
15289	payment	1726	1726	1874	1	1	5547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53zU7iYQtN61FhHYX393TxFbCJG1kR77idk8rm5dDZQtYEN5Y
15290	payment	1726	1726	1874	1	1	5548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyFX8wGbNki9Xk4uCV2DNB6b8TXMDzVVt6U9HjueoPczog3gm
15291	payment	1726	1726	1874	1	1	5549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6w9UPELaYHvxJ7VTmaQgH7sotzpuiNVzDJcT2hr6cLy7pWSX1
15292	payment	1726	1726	1874	1	1	5550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVtqxa8AqU6T1dcjvZE3Ada8V5EYgGA1mVq28qGpCSzmb5ajx
15297	payment	1397	1397	1678	1	1	7483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MjF16bahvGUjMtFQJgWQR1NGvySgtvDzL2i5x7P64qNV9RWu
15298	payment	1726	1726	1874	1	1	5554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNLf199QBmNmnBBFFsJi8RNYRc4v8KrTFzr2LduFbBJxwLMJB
15299	payment	1726	1726	1874	1	1	5555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVXySiNrtTqidm5KQBYLfWkCTSemq69tWLrAVXGbK5EK23urU
15309	payment	1397	1397	1678	1	1	7487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy82ZaQqDx5DFyLB3CCefCdQciUAiVMJie8jkekwqg2WhKuodr
15310	payment	1726	1726	1874	1	1	5562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEcuTyj59nfZDFPQMd9FA8KU2CRhgi1svXjCRVXzMZEv4MAdX
15311	payment	1726	1726	1874	1	1	5563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7y6C3bnwzFttf15ERbs94htmbVPxDop9D3GXCzUw7xkghf4VL
15134	payment	1726	1726	1874	1	1	5445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai5oUk6JriAGLFjHvrE9CWVFjMgvm7KKDw2MTwxCaVKZmbTSz
15144	payment	1397	1397	1678	1	1	7436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAT6Ev2qfHnKE4do2ismfqXsqpziz54hVDRMxtykETdfmnvaw
15145	payment	1726	1726	1874	1	1	5452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTnuE2d6RJ6ZYfqWopuy13kicX1w23mffV8g1AUwqSxPhvXor
15146	payment	1726	1726	1874	1	1	5453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZct99rsa3KSsLYoRfBXJhFqKjrz38nDHm2DtMoDGMBLsTErouQ
15150	payment	1397	1397	1678	1	1	7438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wL3QnVvFxMf6hP1mtpWDpBNnkTqPn7pJFHNJJ5s47jcdUSNS
15151	payment	1397	1397	1678	1	1	7439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUhWySozzfQK9DDMw47GGmkMinpU7pw727ZMkmv6H2TgaQHxL
15152	payment	1726	1726	1874	1	1	5456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFvffzksYHf6xvGyJzZ3d9HUTgabUDRBCfkrw2J2Uwm9py5Lu
15153	payment	1726	1726	1874	1	1	5457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcB2AP489SyhVgQVwFL79ge5ihdxn9Ku7Vryd9vK6bzDrKQe5
15154	payment	1726	1726	1874	1	1	5458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmKJAb2gskVufVGZB1YFhowU2S3iHoM1BWxhNRYMPjHD62vRN
15155	payment	1726	1726	1874	1	1	5459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVpBR2cRiE3r9hFb7UvrbQZGRYU31i6UFnG4fRqiVvHcSoFMW
15156	payment	1726	1726	1874	1	1	5460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1e9EjaX5gu67j9ZGJesKRPFxi1xBr4Go3GudsCFAcCXQ4uat
15165	payment	1397	1397	1678	1	1	7442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqRkrR2CMuKhykCdZwqxAStgyAK2N7y4RRK4n99LskKGDRt5R
15166	payment	1397	1397	1678	1	1	7443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEVsUHXDWbMT38FUj7VSf5WrCDvHhzYNfE7zg5DjjbDULXS9q
15167	payment	1397	1397	1678	1	1	7444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNh6uUGMgJAFS3DyPZ2zFBhrUpNij8qXVCgZ1VUMmc2d9guh7
15168	payment	1397	1397	1678	1	1	7445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxUtkFppFiniE3U8grEm7mvjijsf2gTXCAbcbCGYjDhNGqzmu
15169	payment	1397	1397	1678	1	1	7446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPSFMBDq6NhazjiLcoARpUusJJZHCH3xKYztj8JjDeEc2zsBD
15170	payment	1653	1653	2077	1	1	2	1436000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bobaRduZNjR9cEJ1KthKaevaeRRcydMveQF3DMuXFZShSGxb
15171	payment	1726	1726	1874	1	1	5467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6QicJvKbwLGvXTHXUNG2XKTUbEBvqYsmq8uQVEApTmAK9LsPe
15172	payment	1726	1726	1874	1	1	5468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAVx8Rbmu31y1xCuiXuF2m8t4i3dWbbUfituW9XqgyjoQyRcZ
15173	payment	1726	1726	1874	1	1	5469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCostrMUtbo7GWmb2wTova4PvNdt8VmnqYbMC81EV3HE3p4K4D
15174	payment	1726	1726	1874	1	1	5470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdVPi6tLY4rFyPbL3rkfWFGFM6xG8BdU1Hz8VxJ83DVE4ekA6
15175	payment	1726	1726	1874	1	1	5471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTp13pH6VTWfxUtciouhdwuiFTC4ePw1jdbmSY5C8JYm3qFnpX
15176	payment	1726	1726	1874	1	1	5472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdc2Rcy6131ztmdzAMk1sG4drdXSVTz6v9CqDvsmii8BcAnAw
15177	payment	1726	1726	1874	1	1	5473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtC2EuycAbw52CDB6prBdpSCATDeNBdoGpCcwiZCZ9yVxCqmT
15178	payment	1726	1726	1874	1	1	5474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXFi6EwZfrUXwnous7KdYPKwvpDXthAqi3Vj3AGJ9DNA5xRWN
15179	payment	1726	1726	1874	1	1	5475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENYUa9Y2jJYLBfDywPxmpRexe6Ao4P7N4PAKaTPq5t6z9eQXe
15244	payment	1397	1397	1678	1	1	7467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fXV6KcftZhNTZoRnqQ2G9KVk7o7Ei9W3asoXBNmu61vf95cW
15245	payment	1397	1397	1678	1	1	7468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfrvBiD6HuYun8dwYwo8E2D1Txkm2yQ7wftfhxtcaX6nfdwNm
15246	payment	1397	1397	1678	1	1	7469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7M3yyLvgCtcCgaBHFY9xkJ1pguwHcupHv62SLjpLmDsquQmP
15247	payment	1726	1726	1874	1	1	5519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnxXNqUdNMJSuUC9U1XigLyzcdmGftZT2iLZCbT7QuXCxkxEL
15248	payment	1726	1726	1874	1	1	5520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuYhhZCjsYST2j1Qd9WoXLcjyHBLnvHCFUX5Viji5mqZTmd4d
15249	payment	1726	1726	1874	1	1	5521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6hZ6YPAQo924urfRd5JKPNKtGL24M7bRVJFDkxydQYPe2wYj
15250	payment	1726	1726	1874	1	1	5522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXG2xsV2jm21rBpPtjXrhkP3qu8ijwCRbG54hGPF8EJs5KM26
15251	payment	1726	1726	1874	1	1	5523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqutRVSr8Tqutc2yiAYkP9MkkGFsdogYS1VvpH2gVuzTo4Y6s
15252	payment	1726	1726	1874	1	1	5524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyjtUn1V2y3G4hAhyaL7Qs9AeCCA9jwPZFS3BiPR4ZfV9gLe8
15253	payment	1726	1726	2096	1	1	5525	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHgALgjuHHxrhnGLrkmN1X3HnxZLmxXJS2MRTaWSS2fwL2QKxv
15257	payment	1397	1397	1678	1	1	7471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHygocjWoFaQTTGonVByL9VW5DQ3V82YAWZa94GsAycLGmHTa
15258	payment	1726	1726	1874	1	1	5528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VU5o6YohKTXbRdLfS3CZ5MTeqWApJCHG5zMB1Ce24i8M1ria
15215	payment	1397	1397	1678	1	1	7458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5Hj9TecHBMQ5JNZqqoKdrSJWxAAdxX73kUhQdXcF8ocgsMo8
15216	payment	2094	2094	2094	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9XyfTShJ8Z5WmqwZZT1np8y8s1P4RV6u191CqrrsKNJonCvh
15224	payment	1726	1726	1874	1	1	5504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14EimNgiJSnMXBe3CdFCVMTmsmkrxrveu2ocX4QT11SK4RA5s
15225	payment	1726	1726	1874	1	1	5505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sW7bnnJRSXQgPk7SqszmaKfncCpqv1qobzHfZKjb2g2hJYk6
15226	payment	1726	1726	1874	1	1	5506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdJpxoec97GABnwwg6FXYmgYTPxmEewLjQ7Ctnm6kQiGmc28s
15227	payment	1726	1726	1874	1	1	5507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5f1px44KqpTyd1DqxBLLpVngSpH2tyZPof5jD67t1RgGYg95
15228	payment	1397	1397	1678	1	1	7462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdnArCKtNhyt2UJSBJitL9AkVthkZm6RDnoVFDFpmTvQpWECS
15229	payment	1726	1726	1874	1	1	5508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPEGcw4ts1jRwQDv6SPNq3w4kFNGkgQZ4AiZ1kXnCDRt29kVx
15230	payment	1726	1726	1874	1	1	5509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsdtexXo8yvBHA6qJMiUXU78LTFHiHVM67h5X7eWPuVdaVmpS
15231	payment	1397	1397	1678	1	1	7463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPkjnmXxK46WX7Tr4LXhuejctqoNxsynRCzM4SGRjrJJrD4nU
15232	payment	1726	1726	1874	1	1	5510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SMnASDMvqKpU8YEa6YPvLR4nZrrtGBy1xu4WvtxuRk6S2bHz
15241	payment	1397	1397	1678	1	1	7466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgprwZUqBMaaZeHiZhk5LdrujgFNaj8sp4GwYvHwTSf4iX4Uqm
15242	payment	1726	1726	1874	1	1	5517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4w3YoJGWvnPY5qp3pQBwPAV1upuS79CycBjzXkJvxRsBtwhio
15243	payment	1726	1726	1874	1	1	5518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhS3DAaU8EYQR9mM92NfUJLsSwZWXFTr8mQde5CAxnQpWrWfTm
15254	payment	1397	1397	1678	1	1	7470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDN4SAUxNSFnsYqBDVpcJgVNSwVKE8SvxCKBHg7sc9i2skPh4
15255	payment	1726	1726	1874	1	1	5526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HAzh7MMkdToV65kcQVCKv61r6oLRm3zx4pJnWu5aeHyquJPd
15256	payment	1726	1726	1874	1	1	5527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JhKDGyDJxnj8h764KrysHDEpRtFHCmD9harw4QiXvVa3dLJE
15263	payment	1397	1397	1678	1	1	7473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm3HXm2dFR5RkswvqruWd6mg7YMWCzXzaMsGoXM3yNR4ZRKxd
15264	payment	1397	1397	1678	1	1	7474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xp7fXpTHDdghY6XfmE23Mq1rsGkFNUzfzVMWAHpspwEuKYWR
15265	payment	1726	1726	1874	1	1	5532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwgNJRjERvJCW2aP5EACtuDpGnRSMMxHKiQpdU42G7VoVV1nH
15266	payment	1726	1726	1874	1	1	5533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCek8pPP87K4ivHFM6qPVRTvCcP7mjJKFKbBY2U6NfgMQw371F
15267	payment	1726	1726	1874	1	1	5534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrhvq1BA3htaZfWMz16fFbyajgqPwmW1fMCarJhuXFukJLjNS
15268	payment	1726	1726	1874	1	1	5535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWFFd9HrwmGx7Xc2foyjHeNVxjmaXQSMmsAqvKX5RqqVge154
15280	payment	1397	1397	1678	1	1	7478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzQ3V6u4Jnu4D2Q5ASYbUSoFeiTjp4fqezv63RnAu6z5bYcXV
15281	payment	1726	1726	1874	1	1	5542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqvFXRSDeQ1utksyGAHz6A96fYEYiosUoC1pi1L56FBEoKoN8
15282	payment	1726	1726	1874	1	1	5543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBqep5hKuaK4HjaxPA4Gjv3iQSKiVk8hsCybNn6N1uzL5dhso
15294	payment	1397	1397	1678	1	1	7482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnspje3n2K1MtWqrorGDHe8CXGbXYqmr2HXFGNRrbHTj5CpHW
15295	payment	1726	1726	1874	1	1	5552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPhbDVvLpaFWm6pF46YiwsWFcmwHVVJ7mL346jrdKoMTrq8jq
15296	payment	1726	1726	1874	1	1	5553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UjtCT8jv6h5gCNicM8X6gWM5ESKWyzQUa7YVKqMccqnZ7q7T
15332	payment	1397	1397	1678	1	1	7495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYWhjCgv8FcottWbra5sYcgUgRVhBdh9dyJJpxCn6LyswQNZB
15333	payment	1726	1726	1874	1	1	5577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEg3uwciHLLV9WALrvW1BvEpHKc8m198pzsmqh1tdpssXWtsA
15334	payment	1726	1726	1874	1	1	5578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWuY458cMTaDwx5iPZLegKFXUn8QWLFfjqBfwB75DwvHphy2R
15349	payment	1397	1397	1678	1	1	7499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6hYJ1EgvZmnyPbAdbvPPRTk7nUV24dUfQ89TZjDUBGzgz5n9
15350	payment	1726	1726	1874	1	1	5585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjN83iqTh4vEG9EjMgTgt8nzHNeR45LW7sLVxYNfFQ2gvrb2j
15351	payment	1726	1726	1874	1	1	5586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJuGNUvup6ukocGhE9ihuQhdhUKFM56nkix52rMfUXGGqKEAT
15361	payment	2058	2058	2047	1	1	3	500000	11000000	65535	E4Ym8xYMC16hGsi8e7XJQnbeynAtrrE4ePtGP49YeusKY2nELHjsd	CkpZ542DBkVrpQZJKyPLuNRF8Ctd2jhY7BKVHjQwMTamo71fMkRSU
15362	payment	1397	1397	1678	1	1	7503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYgphCyBEfQ88gjH5jH1Nrudx9CycdUWfisbx7qgPDjhAZzDa
15363	payment	1726	1726	1874	1	1	5593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSopDA8uNykyXycpGzUhqy84neLavHguz1io5wSvaBWfbug5CT
15238	payment	1397	1397	1678	1	1	7465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtz3ACLNSw5t7PudZaPoG4qCatLu7Ug8y2jkFgGCjqiefSBfu
15239	payment	1726	1726	1874	1	1	5515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcDEwAJ7XrE4aXS3kK95nFqmJsMuWwf3kBXNQ9dn3BzywkvRL
15240	payment	1726	1726	1874	1	1	5516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUTx1x2VrN4at3yFC2TdLzkMoL6Tx5HALdhCZPU696dHpj6bh
15260	payment	1397	1397	1678	1	1	7472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5hyht4fN9SRn8pfnLajxhqXN9M3daYuQt2u2ppBvLsyXZqZt
15261	payment	1726	1726	1874	1	1	5530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUE8Gyumn9rfY33D29GFYhrq6BPupNnaemnb8CCDprDmMbBMX2
15262	payment	1726	1726	1874	1	1	5531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmmtFXeaaE7V6nxGcbXCPhh1Ro3asprpQP4mJEcckVK6Qpr5X
15270	payment	1726	1726	1874	1	1	5536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P7YfUAwmqCqXCfD1QEGpd4kgL5zoM8TSb6ta72dZ3f6AysCz
15271	payment	1726	1726	1874	1	1	5537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYcRiDNwu32wfQu7msFdeXCDomUdEgVH3fMjUAYrD5VLKfLs3
15276	payment	1397	1397	1678	1	1	7477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkgwk3mtJqMAnp3c4FJNY89LEKXV1wSGadFUqWupAuTcV1Gte
15277	payment	1726	1726	1874	1	1	5540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jf9niEuVQ1E1KMiim6HNWjAAH6urTDvL4R5kyuwWS8c1qGBw
15278	payment	1726	1726	1874	1	1	5541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXbjqqAjapq755Wg1s8u88rmcY87F9hcZQ7NKEhUwwG9vMUjp
15279	delegation	2077	2077	1653	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptQ9RUamkZr2P6ax7eB7LFenKgpP743UkktFYoZTFJMDACFcy
15300	payment	1397	1397	1678	1	1	7484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6nwuQt7PkRPpJeU5VZhX5SkNG2Wz7PQDTPRFEZ16zF5rNb42
15301	payment	1726	1726	1874	1	1	5556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQj6h2yEPwR4bi2PxAZk9EkfvBxjSwHi3XeHLKRuevzhS8ihg
15302	payment	1726	1726	1874	1	1	5557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54giRMaQkYTBaTs7F3UQPNLG2rXUEHuoPDH9n4YqmJi7rBozw
15322	payment	1397	1397	1678	1	1	7492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMX13MD6B3GVDLKcbR2myWxjci2JWC6tbTk6658it1bJaCDtW
15323	payment	1397	1397	1678	1	1	7493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhq6pFQPSwW3J5Xtngzmv3LCfeioY9BUb2eMxxzXhQXGgtiYB
15324	payment	1397	1397	1678	1	1	7494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqxsrTbXYX535y3uvBZ3jtKSDtHjSSTd8UBVJmmj69K8F35CT
15325	payment	1726	1726	1874	1	1	5570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdgc8hEhDbvGvQ6p3CyNcok6egzkAx8s1kG4eMYvGfRFvsuRx
15326	payment	1726	1726	1874	1	1	5571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mi9dxrXRsYwaaL9vH2EwtF9sdig685ZJ6mbMSNTh2gVDd61k
15327	payment	1726	1726	1874	1	1	5572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UyJWnEy5SRhAjytkkCfcuBBv8RbX9Trm8ZmZe8eRaDmzYGXW
15328	payment	1726	1726	1874	1	1	5573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZG2tGNf8qKdQnp44nEsbso6hkjdsbq9kSZfib3rAwFWU2Jtuo
15329	payment	1726	1726	1874	1	1	5574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd7GgXJREhDJVDXhogov53N9jvPzdVExGZKoMsrQfj2X2cZJG
15330	payment	1726	1726	1874	1	1	5575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAShDHDs2iKVhLaWvivF1vzcFb9gQtrvwL6BeE8Xh6C29mkb5
15331	payment	1726	1726	1874	1	1	5576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShAesEtzCx5rQBCZdS9XFcPMtzh6M8odF5sGCZNzzNLQFgpzD
15352	payment	1397	1397	1678	1	1	7500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQXvhC2yXDVvxmp47P4PrdfRpW8i3qAFW7hX7G9Gzm7o1AWBr
15353	payment	1397	1397	1678	1	1	7501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbJkmnr3j871NQtKnPzdxQAHjjWdMd334gEdMQQyjRE3sRLNT
15354	payment	1397	1397	1678	1	1	7502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBwBa55bTaSMgCqcZ93TjCdC73xK2DjmSdR1irxRuG6Avw3dh
15355	payment	1726	1726	1874	1	1	5587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yTdAUDS3vLg3Yiwxr271AhxcpccUwEZeDmiaQHv5o5u5s56i
15356	payment	1726	1726	1874	1	1	5588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiS6zwM88QQW7TLw1nz9u5d5Yaa2gaZDqqGM5JQGZesEpPRVc8
15357	payment	1726	1726	1874	1	1	5589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfc3DNb3q3eNA2kmsPNaF5JQAGriF7ntah8zwpkscTciVrrc9
15358	payment	1726	1726	1874	1	1	5590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMuAF8ya5oiPqx1BecuxNPdmsuFYddsLjAr7sVHuTQXrSmvLY
15359	payment	1726	1726	1874	1	1	5591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKa3srPraygTcy8LSyEeADnhAv6vdh9aUB7tzWdDV7AcKsxCt
15360	payment	1726	1726	1874	1	1	5592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRejRwe9xv2yvG519xdmwQ9i2eBcwYt7btAKZCeQLDYgCGygBX
15384	payment	1397	1397	1678	1	1	7509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRUfnY9Rp1Y3XPKUaECTys5wDRAZjCVPUCVKhcuRACLhtqK8p
15385	payment	1726	1726	1874	1	1	5609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3TTG5WxjGRp6EwzDvistQwQb7SBbMCA532ogQcf37DJvLvMq
15386	payment	1726	1726	1874	1	1	5610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqhMzEZSXrVGnhCYDuU17zVRKUEafoUJQCsRCyYAABDZ1cKxT
15387	payment	1726	1726	1874	1	1	5611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCovq4eqTJiCfnoqjYwjZgtPhj6FYArDewrrw2nSfdzUhthP2
15259	payment	1726	1726	1874	1	1	5529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJRii4Nu25XoY1RwVsHnKgkgoW9oVnbb4CgVkVjEJ5tdayx8W
15269	payment	1397	1397	1678	1	1	7475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzRxUNT5D8wPkexAXGw9WPGWNMVn6f4wfTcPkz2mgtSs1K3Tg
15283	payment	1397	1397	1678	1	1	7479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymMba8V3SGUsA5ev31LUBKe5W5jU5GD4RepVUKQk79wDvxkyK
15284	payment	1726	1726	1874	1	1	5544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnqbZZDacPyqgqZ32rWxCQJQBU3n7hvjcW8BpdFC4YD2APnSp
15285	payment	1726	1726	1874	1	1	5545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MpXdAE3Y47AQxnvjqUbmNkZqWDpu1KKyXPmk4M4sUT2a5KAE
15286	payment	1726	1726	2097	1	1	5546	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmM9rT973C67oJGCjQHC3EVL1tU9NcAzX9KfuN8eZnBJybDah8
15293	payment	1726	1726	1874	1	1	5551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHqBCcQZ6Sdf5qT5RtArei2MFwou2UXYVRvRjfQAW6Tm8gurR
15303	payment	1397	1397	1678	1	1	7485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4XiNfx9U9A6vc8hyKYvGgt6vHcfc9ckiCSproiLx13khQwav
15304	payment	1726	1726	1874	1	1	5558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8D9uLZdZGz5MNeAVAFp5CLw7LH8q6UnDAZsqwp9TVKdrBApi
15305	payment	1726	1726	1874	1	1	5559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQXQz6CMM7wiDja3iokiGin3Fpap2PJraP7tiBGkqh8SJpQzq
15306	payment	1397	1397	1678	1	1	7486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE97xmgJuhKTet1RF3ojaaB23L3xJCbWMX25zYCeiRuoCo2JPv
15307	payment	1726	1726	1874	1	1	5560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2NQaSjfGoevTxkThYwMHkYeb8pNAPyA7CnrPSj9yQzjV1Qnd
15308	payment	1726	1726	1874	1	1	5561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq77mbteAeo2Yh8fA6hXVmbr4zpgr9VAs7GPzrw54LuKrjGKip
15335	payment	1397	1397	1678	1	1	7496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevTzjPNsSXBYyiQeYicLtHkAeYtWGazhuHXrf9tK3GSJdWTRn
15336	payment	1622	1622	169	1	1	0	178742095387	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	Ckpa6oBgcDE4cy7wBoMTjNfjPdQcyEfqjbd7iX2YJiPfa33pyf6ag
15337	payment	1622	1622	990	1	1	1	1367708631720	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZN1hFmscGfF4BcbDrq5mq45PkgZn72nceQxVDNhZ4sVSRHPYT1
15338	payment	1622	1622	1110	1	1	2	2450922149520	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZPzJKBJFwRyR3Ge1DFY5XQXnnkL2szvFDmufQcpKkdiUYgjvuG
15339	payment	1622	1622	1230	1	1	3	1653686012355	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZHEBUckMogqMD1mbb7djw8HoEooz7AjggJFXasjfEuV1YSP8ZN
15340	payment	1622	1622	1356	1	1	4	4608143110980	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZTX17CtK3kYp3aRKC2a6ddfGB8yewx5FWFDodZTr4YPNdTpmsZ
15341	payment	1726	1726	1874	1	1	5579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUE8C6ibEtQK871DKkUdRVki4y7eKzETwkaowvXERan9RwScc
15342	payment	1726	1726	1874	1	1	5580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3aAcbv5kAEvrt7Sn2kaFGiG9dxLjL8qRUnmCqFgGoS2vnKxV
15372	payment	1397	1397	1678	1	1	7506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8zs4q9ymCnKNkvckxFjCbfbHjwB7ewUenShhBeteHrcLhbg2
15373	payment	1397	1397	1678	1	1	7507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeqxtuqgtmEamBwf2WixDzbvNShwxLr9FboPzQEKVqJFCEwr9
15374	payment	1397	1397	1678	1	1	7508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8GfRQ7v1CWLxi4BQPaVNzrvWriAYY1TFxzYHLw4Mfgk7sALP
15375	payment	1726	1726	1874	1	1	5600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjjPQmgK7UsoDTX8FDHRRsyRqMdXiapqAYxXKMFv63nuLb4jH
15376	payment	1726	1726	1874	1	1	5601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTsKE7hWWts5PDMYVpyHF8SvNJUWKKY9ywoG1pDNPerhXeVb5
15377	payment	1726	1726	1874	1	1	5602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9rsNf9PtkkHYjNVm6WdnDwu4oqtbd6r7RefQwbZUziCfDjGL
15378	payment	1726	1726	1874	1	1	5603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNBtXTTVCTQtQGDeLg1VVuqdmQrFf9sGryA3DJJTgB3C9GNQA
15379	payment	1726	1726	1874	1	1	5604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCPXBhU2P5ddKimVkgEJMqev96XMcPLYxKKk57SbccDvpw1Ry
15380	payment	1726	1726	1874	1	1	5605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGj5Nd6TKrEVDNuzgQ8at2EwkPVfy8u8o9TNh7gug7AimdW3Sb
15381	payment	1726	1726	1874	1	1	5606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RJ6YnnadejB3r1v8GbpQUESXFNYrvbXcxgP7Nhjh9LwJ3cnz
15382	payment	1726	1726	1874	1	1	5607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UBM7mK2hZm2bEuxZgq6WSdiy6Xt83sa42i8LBUiBMLS7u1iV
15383	payment	1726	1726	1874	1	1	5608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaf2ZYKfNQU6FnhCGgMjBd5rmiGnUTcq9RoGnCaqiSS593bmTt
15409	payment	1397	1397	1678	1	1	7515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvatQjnvQFGeqxMFJNJ1EiCW96c88ir5WkA1Vd7iGNuSqcgnkS
15410	payment	1726	1726	1874	1	1	5627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevRcWhzon8y8bxxo7ujZML39zjWAwghco88AwyDLRf2bYxgCU
15411	payment	1726	1726	1874	1	1	5628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VsectmF3JByqkmCFfQaNhFhFzetPNQUoWsWxVccNAtMPfhTV
15312	payment	1397	1397	1678	1	1	7488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqzkH1WMXq4zDUDFyRgxDP8YRCui521UdhcBiA6gPAC2sj1QM
15313	payment	1726	1726	1874	1	1	5564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8wLA3g4mCB7XsmAgDKxRMNXkosPQuJZARvt91YA5UsihzCp1
15314	payment	1726	1726	1874	1	1	5565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVcp7VcX4T1tPtzJBnzehoaTDeZvoqHMGSGgMraBqzDHKkMXCc
15315	payment	1397	1397	1678	1	1	7489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn797n2UbReyE3bpUg7dcHNreYJgJCrT3As4VZ74VyS5FX3WLs
15316	payment	1726	1726	1874	1	1	5566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHd2KfNxbwppqmwVk3fzXhvYSDpRafj4qwoQ2D9zY2cLbracU
15317	payment	1726	1726	1874	1	1	5567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnM9Fr1tzpGRhfRxLo1XhwjYQnJxg2f51ijZrne3hm3VcTxYw
15318	payment	1397	1397	1678	1	1	7490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnmaBhSRyyWTsvmY5FA4zK6gu8RwNtDCMfo3MtqyXxYjRXS6H
15319	payment	1726	1726	1874	1	1	5568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo7dkTfZEys3j3iCcS7HVM42xgqm5Ti8Us92kDnzitv1nWdiW
15320	payment	1726	1726	1874	1	1	5569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjXQxvxc6DJQNVu85kLhKQTALMx5oFGDDcupQ9VRZaBA8T6jz
15321	payment	1397	1397	1678	1	1	7491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMpq2pqjfgjaNpR7gP2i2LjSf6kU3vs1KW5JmoiSqHKSBqSLg
15343	payment	1397	1397	1678	1	1	7497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQH6QeGdheEnDqV82yZ3eQ7fV6RH6aBY8imbQUACBGB771wwE
15344	payment	1726	1726	1874	1	1	5581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQsamA1Mwz3f9hG1zYdHfV8b9DEF9TW4VF1dRG8pyfdeHoXFP
15345	payment	1726	1726	1874	1	1	5582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu1eFFHisQgkeqCE6avF3aonA8jhpz51kbTBcZsHdcpyGmii9
15346	payment	1397	1397	1678	1	1	7498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bsqMTt2pXvWjEmVFo7qqSGghyK2tMtJwFhKAiEHyjZzpuFhx
15347	payment	1726	1726	1874	1	1	5583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9LZK7wxEvyAsUXKZwmbAW1ex6u1a2jq4C53ske6HHRQtRXdq
15348	payment	1726	1726	1874	1	1	5584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3RBB9EpvbxMTjctHvhBCdxcEuyQ86Ff6y7iyf4kQbY2YfxUZ
15365	payment	1397	1397	1678	1	1	7504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYstQuAXeXMWb5Hfwsg37kLd9uPXFZrh4QDzfvCvkVEwEpQHeX
15366	payment	1397	1397	1678	1	1	7505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbLrp4bBcfe6SYtWmy7zANw4PmqXTzKGzxDn2b7wDM8fyERiz
15367	payment	1726	1726	1874	1	1	5595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9PzLK7z9ZK4vo4zMfgHYWZsrTkzik8KYY472E4BGzcUvG5aG
15368	payment	1726	1726	1874	1	1	5596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDztM3kzZFcvkGWw5BqARkxLXS2MV6WFMWQGad64fNXD51FKB
15369	payment	1726	1726	1874	1	1	5597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrFQsKLpESpJ8P3v1L1NXU2g6LU8upJ41hH6GcmgJAv5FcmQ8
15370	payment	1726	1726	1874	1	1	5598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6V8PRDHVKDcBSHdoAjWUGcA5UeyGwmL2VwfkZZETA4rafu1P
15371	payment	1726	1726	1874	1	1	5599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCr71gxkt5GyuHCYd1LMjKERsYgd8X1k4K1iB8QUKxDFZV4YY
15388	payment	2058	2058	2059	1	1	4	600000	11000000	65535	E4YZaEeQ5LsBZWgUMQc61A9snFW8Zhknu6TBPPaM8cbjYxv55nubz	Ckpa7ExzkWoNg2vrSxCArinK7Egg7uWqAUrwWGVYK2tRMtS44FwpA
15389	payment	1397	1397	1678	1	1	7510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ273EMa3fbjDsxYQBefrxCw6Q3Qg7D5gUyWigXLo4PmGZ7vhGp
15390	payment	1726	1726	1874	1	1	5612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWKRUTjJeMtpfUXSRnSFuy4D6aj29tNTL5fsC7rtnCexiGcCj
15391	payment	1726	1726	1874	1	1	5613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8UGB75Fsd37U5PECLGd3G2e1WcmGjPwJCcY8LWNTNtGBvnJV
15392	payment	1726	1726	1874	1	1	5614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoV9oBWh1qTMEsYo9aXNZ9NY5RurpmtbmdHBksbM4MGbkUb7aE
15402	payment	1397	1397	1678	1	1	7513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvX9Mz5Yo5sCMxb7foycWq68hr2oTye5ivyvn3cc9Qkg7cWG9
15403	payment	1726	1726	1874	1	1	5622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakYuyafbwoNSAkeTWrrMm3o5LLq3eKm4suEANHaPBivo7cKf2
15404	payment	1726	1726	1874	1	1	5623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBWvaWgppejZvjJ8LAhoUhRrz5d3Vum6wKcmunqgp7gxVtMJK
15405	payment	1397	1397	1678	1	1	7514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzA8tipYv7NnwkvFWkucWDGjaAFhoKEATv1NxfxKDN52nukLHx
15406	payment	1726	1726	1874	1	1	5624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDk4mnxayn8KYcdk1KengzNki3rwmuJ8jGKPmzGRycmR3Brw1
15407	payment	1726	1726	1874	1	1	5625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqiUjWk4DewaKZKTfxJwPLsPNNtqBsSnZysynkTHMmvhhp5hY
15408	payment	1726	1726	1874	1	1	5626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAvRYSKRdaJGa5N4hQavogB9p64j4sHJjtAD1CtqVbvWjAey7
15412	payment	1397	1397	1678	1	1	7516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXmRcprMUuyuxR9KpHci8B9hjjnbYSX48gvJXhLAjer3Ezxui
15413	payment	1726	1726	1874	1	1	5629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdq8BWAsFzooDJz7uXAxvLZyPZvdZXBqWm8GxK4x4m1s8RYBqQ
15414	payment	1726	1726	1874	1	1	5630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAaPmzmd7bS4Lqp1ToDk9ntu5CLzQq2cfZbzYLvnmYWEWMXps
15364	payment	1726	1726	1874	1	1	5594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtK5mZYqisDXP454yBpGuEH28Po8v49FFeTXLjg3wSDyKDteFY
15393	payment	1397	1397	1678	1	1	7511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyjYgcRbNWkjs9u3YUvkPDTkgd1auhTYwCfUYDqRhydGxCd9q
15394	payment	1726	1726	1874	1	1	5615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEEA2BJctPjfruBneTAjH3nASNQRipx6TjJVDZbfKjNELZGgx
15395	payment	1726	1726	1874	1	1	5616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GZ9owa3nhZLq2yGXRt1fJ6HDXwW9LacvDqtTMJw5K6i7AhLS
15396	payment	1726	1726	1874	1	1	5617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfovNL2HHrVZn6AqUL2Yc1bRRE85vRLRCBAsPfqf5gPgAkWQe
15397	payment	1726	1726	2098	1	1	5618	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYp5gmkmV2rpK9NznZP8nPyNbryWAuXttmWv2ASmeiXbWwVUS9C
15398	payment	1397	1397	1678	1	1	7512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dGZWZNj7y5p3JhSCqBFxJwSAe9EE4uQ3nkEvhLdQXbbrKbJX
15399	payment	1726	1726	1874	1	1	5619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFfoTryDvkgJXRv9ptAETL54ic4WV9j8SanpSuu156FGkW62k
15400	payment	1726	1726	1874	1	1	5620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGSC6BqgeKze8Xz34hY8LbMWgszdzbYEDyovFdP5wvLwQeNwb
15401	payment	1726	1726	1874	1	1	5621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZkfu8NET2SeMtbiZRUKqQxvjaAwqBjkLsFLuTGqehQJiaSRZ
15415	payment	1726	1726	1874	1	1	5631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2kN96r1fEsHFysL2h1iUaKfkPZqKXNRyAyMbjUZPeTp5Vjyo
15416	payment	1397	1397	1678	1	1	7517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3qdaLuMJZEERQf6o758X1cxJiDLMFHX4vfoSADVtwHDzj1sf
15417	payment	1397	1397	1678	1	1	7518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLyGoW1uKXZfaqHWdeCKJTfGKf6ZZEnTSMZgVodsbG6JJidCM
15418	payment	1397	1397	1678	1	1	7519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugSgTahBjYqYWEeBHKvK1pM7yPgYDVQHatQAXDJZbaWKdX43T
15419	payment	1397	1397	1678	1	1	7520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWM2m5GSNpUupbUaA74s1cQpatQFamEqUiqVcYQdp8PrRRnos
15420	payment	1397	1397	1678	1	1	7521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccvDQkcjf41vnd2cKQYuU3sYFXNPmRUfgDJaa1W9XGEj8NY4u
15421	payment	1397	1397	1678	1	1	7522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xTpSpsu1KmJz6vehJYpdHMgGmVj2xPDMa3bw6UapHqFsWME1
15422	payment	1397	1397	1678	1	1	7523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HRjuferjZ149D16JmzMHf19bU4VbjMqYwRcb5jwZjgPLMggR
15423	payment	1726	1726	1874	1	1	5632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxtgQvPKnn7hpuhtutadC2Cq6FhJDQUzHeAznQAL27dB3LuSe
15424	payment	1726	1726	1874	1	1	5633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBnLKFC1RhCpEndhsg7qLstfYZUn9MTxFY9shQXYVQRyDKDcC
15425	payment	1726	1726	1874	1	1	5634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWSNPMQXM5gh8mitXG2sPJQrz1dZmxmR93Fuas1eb2mTkYdV3
15426	payment	1726	1726	1874	1	1	5635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHPq7QoWkqBXfcgge18ckEyToVZU2JdXaxpSMFjzajc5cjfYw
15427	payment	1726	1726	1874	1	1	5636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mEFPHZ11DCckwmciGEeH7GmQBf6hvX3kyQMfk6Xpbo9AS1rj
15428	payment	1726	1726	1874	1	1	5637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjWCSGG4uVD8GCCid2MKCsAgMitPjNaVy3Ts9QTpaBBQFtCiM
15429	payment	1726	1726	1874	1	1	5638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKpn9VjZBULMLxupFKe1x5gnNfzpfQWUgY8Az1jKRF711vyst
15430	payment	1726	1726	1874	1	1	5639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MT7EX9DygS4JLgWN7QXsKYRQY3xySTKzXxRZUoWAnsAqahFV
15431	payment	1726	1726	1874	1	1	5640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1dgMJkVb3F1G5Jtq5mPbb8XhL7x1b9msn2gj8E6fHzPuHCMY
15432	payment	1726	1726	1874	1	1	5641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrKTjqeECm7FRUDusnGqkhGZrDWo6mamtnM3QDGJNbXKfzyaZ
15433	payment	1726	1726	1874	1	1	5642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gjwvKEmCtKQo18ZGfegA95CiURnVBBnwfkxnzuYBP2SZ6prg
15434	payment	1726	1726	1874	1	1	5643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjziFwBWntnMgoVF92JpMxGH9Fh3f5p4Y4oTvndV7UzSjgprc
15435	payment	1726	1726	1874	1	1	5644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wYZDDmB1Qi5XgsBmFqcWrVqwHneBk9UQxF4AgW8ma1WRrp5m
15436	payment	1726	1726	1874	1	1	5645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgedLeSizu3DptXg8Jd6zUVhJnBdmzP2KX4B2BiP5sWpuj2PZu
15437	payment	1726	1726	1874	1	1	5646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeKyDsKQSBQ2xiaUL1yWgXWUS9Xq9XuGmN9kP3rA6ezbQ3rbN
15438	payment	1726	1726	1874	1	1	5647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgJb1qXzokrYx8wqZs8NchxamXxMD2gNVZ3eb2zr7TWvCY11A
15439	payment	1726	1726	1874	1	1	5648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMweuyKoP4NuvDQosquC5gVm97Yr7WaKmsSC9SwE5dKhB4TPR
15440	payment	1726	1726	1874	1	1	5649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfWsBYLH2K8EhRtQKUGbD3mBMCMcn5fJtyfqq48XsjdaJ1nft
15441	payment	1726	1726	1874	1	1	5650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjmiM76TKTZTtpMugBvEZHddVQzrvHLk2C52jNaTPdpzYuW5E
15442	payment	1726	1726	1874	1	1	5651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjyN4tSKtZwQhjpF1Xtbq8AgXdqhpxQC8prJpAU5SR32DHjpM
15443	payment	1397	1397	1678	1	1	7524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpT7JSZLnahBFPUj7T1L3Kw7kUB75qufUbcG3DNWUu69pidZf
15444	payment	1726	1726	1874	1	1	5652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpx5YnRFHw5FHpSzUStXWV4qvon4j4T1NUu1p75brxLjUsReTc
15445	payment	1726	1726	1874	1	1	5653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RrE2MXhfEe1C6oS9bbvn7soVUXhw5uJDvhFwjjXUjwCKDz8x
15446	payment	1726	1726	1874	1	1	5654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEred1BPyPBRodpdbXcwh6vtm1x63wmsFKZzkcGrxhzrSMPzm5
15447	payment	1397	1397	1678	1	1	7525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mMTA9Ly2k8PYn52fkod29MnHnosthEpa6LqzCqQmEdGofrwF
15448	payment	1726	1726	1874	1	1	5655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LDmB9J4yh6PB8w3tU8h38KhvCDw4L7PUbZ25g9GqTUicDhqG
15449	payment	1726	1726	1874	1	1	5656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcGqJjAF354EGeUL5sRMZZcWJPNiWCWix8AWj1fQuDwdWHniH
15450	payment	1726	1726	1874	1	1	5657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv95sYqCTk3WYE43M4u36BmFS8DoXpZM2VbcwkztHgdM2hJJG
15451	payment	2093	2093	2093	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJCz6mZ6KPqs4r7UqT45L4BKYUDFW974kUGNEY7PRV1tK4ZYE
15452	payment	1397	1397	1678	1	1	7526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZiKNo88B1ohhQuCUSo7CQofkWZX9wSTw8okAjJVpe9WAWTfD
15453	payment	1397	1397	1678	1	1	7527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KmpvkoShHLxNyryvN4h8RBekp1bW7UmkR7MNtyqFgY4r1JjD
15454	payment	1726	1726	1874	1	1	5658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafGUzNrt52vRjta5LrYeXrcW5oigJt9keX9KyR8RBreVZxuTQ
15455	payment	1726	1726	1874	1	1	5659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QByT8B8GdyqufRXxeSDjBRFR9hivyZovxL3etp5iGegqsUGH
15456	payment	1726	1726	1874	1	1	5660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjA9UDRitWUa1jturumZXkeJ1PotdJMzt7AmQ1bPjNnMnZaEr
15457	payment	1726	1726	1874	1	1	5661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ktuxVHQqQcoBbvqXCGzkwogfamfeL4hXn8eH1xrVWbhxFB2X
15458	payment	1726	1726	1874	1	1	5662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLsatwLqzV12GDZsp5ZDCeKk7FtSd4k29VHRnGQDDdB8pp2ia
15459	payment	1726	1726	1874	1	1	5663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8xxQToqeVqYfUG6tTQb73ibrRvKvGf7g8inPc7WxoSoccxDu
15460	payment	1397	1397	1678	1	1	7528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDRbeuXAZLJkjhwzSvMG3qM42tHwYY87jhBYX4BGr6aEEdUGT
15461	payment	1726	1726	1874	1	1	5664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsJqn9foL3sRW36neQcF4b8uPuJjD9aD8A6DsHjHk5TFN21bQ
15462	payment	1726	1726	1874	1	1	5665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQorYz6eKHw26F9ChtcPDKXY7RLcdJ4oEX7fpCptGAt1zTKS81
15471	payment	1397	1397	1678	1	1	7531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKJr2DymncFv6G6bHCTdsQRwUczu5VyydzSwbeoSertNXexLf
15472	payment	1726	1726	1874	1	1	5672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJpqqcgbTCCLxSMR27kDzyH4Zz8SmJs5uBFwpJQVG3ofr4RZ1
15473	payment	1726	1726	1874	1	1	5673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6kGLcW5a9J7DWDJCCz8zgt9VC6C3eLY2vNah9UDeHLrLe93N
15474	payment	1726	1726	1874	1	1	5674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6J4zeabECwcVJkxwUMgnNoPyRHypdVzzqHaPtiqhAEPHx8p1
15475	payment	1397	1397	1678	1	1	7532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcypAT7p3XVfvNxyZk1BCKYaJWV7HihqHFLPRGjMxp4jathJF
15476	payment	1726	1726	1874	1	1	5675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3BYQ43sVbrnf7ov7T2RYuZhZNisHe8tv3MnQLQawaVfBnJUX
15477	payment	1726	1726	1874	1	1	5676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLCMZ21qBtivGpYxFeDx3v7AB4D43wvYVrWHDXMAW48zdxyy5
15478	payment	1726	1726	1874	1	1	5677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJt9LFFw1H4URYHfBcPwA2n9n32jfXBQZbXPW43QbFPn57rjXH
15487	payment	1397	1397	1678	1	1	7535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41pU8XpWP5nv1RrqaiXUrMH3UQcftnquB8WAwwzEgreuRQm6n
15488	payment	1397	1397	1678	1	1	7536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kKmEVUV5FmUEeqtrvbDiXxnC8DBSjuo2afMGJoQQMPXBzMkW
15489	payment	1397	1397	1678	1	1	7537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQATWn3XveAaYjVccKXfu7Fr839yviRXErgeVwEWD7v2Lbwhsz
15490	payment	1726	1726	1874	1	1	5684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrr5sz24UoVV8L25a6JyxtdPcNrgMeoRLct5zV8uwSUq8y1st7
15491	payment	1726	1726	1874	1	1	5685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwvs5LsS3pyf1TBVVkyqrY5NjCaaGJRYgDkiGQv4TT3CEjmwh
15492	payment	1726	1726	1874	1	1	5686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaNBDKd38gRiBDXXfRyizExPwwxRR9RUywqDxDcan9qP7Byr9
15493	payment	1726	1726	1874	1	1	5687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtXwRiuwPhXLaR7BoV3Sc4iGbwim52Rr2JKmhX45YH42Gevks
15494	payment	1726	1726	1874	1	1	5688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQCBxpgMgCj3db3Ryxx9RK2LjYtdYRt9RTjwrBGLDm9maq6Az
15495	payment	1726	1726	1874	1	1	5689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67TnuPSeMob8LUbq8fzWPhRsnGttyANTUCXLgQnE2dUad2nm9
15496	payment	1726	1726	1874	1	1	5690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9GAZos7V6UdggHZf4Hj54Hs5D2Hpa9AFne3zbyXi2wUi7bc3
15497	payment	1726	1726	1874	1	1	5691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uBNpT9qFTxuWfC8TLi76eN8zZxiQEFF1NQ4d9W2ht6dySy9b
15498	payment	1726	1726	1874	1	1	5692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2N9QNMmqhbhhJvLsvPX2YLvXhqd9Arptv5UomXRcntdMokmU
15499	payment	1397	1397	1678	1	1	7538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn3oU74jBEynEHvtBvKDjvDh6wPjZGASfpMX3r7SQvYLF831m
15500	payment	1726	1726	1874	1	1	5693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWpnJgzQuQ73hXvCsQPaYTbx1ckYwqbuedXKecSKA4Gc7ieYV
15501	payment	1726	1726	1874	1	1	5694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3QVe1ntGfJhgwbmQRmSXv125DNtHNoiSaRrxh5WdPLX19uzG
15502	payment	1726	1726	1874	1	1	5695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d2TKTsXCqS86dc2b3ASLEmrRswVJN24k7NM35vQkxRdUzY1H
15542	payment	1397	1397	1678	1	1	7549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtbsVbQLKPDGQ8midtdLh2a7mKtiM4mAzKjVCM1P9mU3YFkfB
15543	payment	1726	1726	1874	1	1	5725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobZHTDHgaPjv9pFo6ezvFM5puTYidYorrFjF1VTAtcEKn6Hk9
15544	payment	1726	1726	1874	1	1	5726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaq78aVzSVfXiTnPtji2BAifCA2XgmairWbeuhFZddqEhmboh
15545	payment	1726	1726	1874	1	1	5727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdqMQ9mbgD3w7bG7Sy4HFRtnWhA73XBsDQ6MeKwpkQGGPbKZGS
15463	payment	1397	1397	1678	1	1	7529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwZJNQ186754J2WMjPzVWKBSHjAeFkB2LsfyiEJtuBQRDKRN1
15464	payment	1726	1726	1874	1	1	5666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt4UVUeNDAg3gUNHjv1jznZRokXeXd1Rs2TrQdpRpcr7PRTjy
15465	payment	1726	1726	1874	1	1	5667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGc7HFCNnU13xqHZwWQTJyALFPy64Tf1gkvHTg3Phm4VKhtXpP
15466	payment	1726	1726	1874	1	1	5668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbaT6Y7LirFAWQWes9stuWeAE4Do8K3wKDVotM18XXMQFrNrzR
15467	payment	1397	1397	1678	1	1	7530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpurk6SuCPmLPQ7ykt4e2BqsZJ2rhwcjEmoBBdPfF4233oa5ZN
15468	payment	1726	1726	1874	1	1	5669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZNoHAMqkH1QKZ93YutsTtzk15vUp8Wg6GPkrvU6zHMqdumyr
15469	payment	1726	1726	1874	1	1	5670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1eLBbNk4oMtiFjQxug3iAY1u8amRW3SjRw1CEt9JpL7MoKt6
15470	payment	1726	1726	1874	1	1	5671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM78FvZSwuimFzh6t7zbj3PiVPUGpB8a2rDuK9RFqPHB7NfanT
15479	payment	1397	1397	1678	1	1	7533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC4z8HroYJaRvQKAaTx6xfaX9VqyQqp5VTv2SjR7LnkLksnAk
15480	payment	1726	1726	1874	1	1	5678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6Qzep3wwKDR6WYR6V8Qa9UapPspfsQmaciGfZNhg3xEqyJW1
15481	payment	1726	1726	1874	1	1	5679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3PT9V6zHbPaXXUEA6xvMMCGiq2v3oo7P8LC6QEB5MKq5srJ7
15482	payment	1726	1726	1874	1	1	5680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2ESkmn8Cya9JVJDECBC77ekvwiLko47TM3EwxsH1MBZeniQA
15483	payment	1397	1397	1678	1	1	7534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zsdBDGfdGaVGoRKsqydkeKYPmkq8S7LQHKJtypzdrkcVDQFa
15484	payment	1726	1726	1874	1	1	5681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKjfkZMbGf6vY4Hb7Af7XHkG1GEaR7c5RwjpKttQ1wc2vNL1j
15485	payment	1726	1726	1874	1	1	5682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQCopCY5RQ8bo56qxNeJxJ2BEG9C4CUECGBkbjfRn8ZM1NDjx
15486	payment	1726	1726	1874	1	1	5683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TdoKFpTuYQf81h2rPZZivyTL1fqCxXz5dj3aH997Gj9d3Ycq
15507	payment	1397	1397	1678	1	1	7540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAf4pe32AS2SdwWEuugoEKdEN4TTj9BknSRETiopkNRddbTZyj
15508	payment	1726	1726	1874	1	1	5699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy4jKeC2G22GVd5WfnqjSM89H7nDKB5oqig1ebxLE8pDCB2w4
15509	payment	1726	1726	1874	1	1	5700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mZXfcggJhjKfR72vCt3M77J1G5NGjzq92jZSZ9C6EQQnmss6
15510	payment	1397	1397	1678	1	1	7541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2pBY37n2o89YkQX6jyp8N2srZNa2exiyXj6jA2jqVLQpCSFK
15511	payment	1397	1397	1678	1	1	7542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BQHtWAmDFvrtGJMYHT58G86E2LypB2WjjPQNVLAF4NLtRvm7
15550	payment	1397	1397	1678	1	1	7551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdMsB1rxzkCbafcxZoKfB42ZAa4H6CvMdm6gqtMfsNc6AnRFj
15551	payment	1726	1726	1874	1	1	5731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8UburiFxQTGxQmgbubqVv8k4H4ANLgUPX5cM6yqyKxsPLkGB
15552	payment	1726	1726	1874	1	1	5732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACq5C7E3vu8G9AK3wRQvrowZGjLumBqiRRG5b95ypZyE34GRx
15597	payment	1397	1397	1678	1	1	7566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TAwAazZW75xDYEJ36yM5fmvKR1zEnuU24AD5X4WRmL7sq4Kh
15598	payment	1726	1726	1874	1	1	5759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf5pNiDS8HDE8vPahpwDvCtbJV9V2SzLa8TDa9Ptp9rJB6oDq
15599	payment	1726	1726	1874	1	1	5760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7gJzNicoZrVCorixV3b2LLLjNb49HadGPaTAwhGpjvtuQT88
15600	payment	1397	1397	1678	1	1	7567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyLT33U1iCYXMM5EvbSdJZfkoTED9tgGFQi2EF6C2T2aXnijb
15601	payment	1726	1726	1874	1	1	5761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaRa6g2KNrvwrF5eyNfN7j4BS8eCydpwTEZa3bKYntJFHpQuw
15623	payment	1397	1397	1678	1	1	7576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PVZWcUR3xFFMEXUfdcEzUTwzKMQU59d5qR9faND1Pq5X4LXu
15624	payment	1726	1726	1874	1	1	5774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F8HKKYDZDRE6hpc9ag2wmeRH13iSL84JSQyxeFoXnB3Q5rjr
15639	payment	1397	1397	1678	1	1	7583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdPVi7ToQ2U3mdveJBVbjQUvPm5zHzLE3qHh7yTMyJMqC9Nv9
15640	payment	1726	1726	1874	1	1	5782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXV78cJjXyVg19ZEZUW3UMW5wxWaw5vqZf4rn9wGa7fXWCxkCX
15647	payment	1397	1397	1678	1	1	7587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjySorQLhu9Ck7LjZWMxvacMKfR4ZU4H1HXQXfiyKLcY2oE1ta
15648	payment	1397	1397	1678	1	1	7588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmH6nWrugMMRrnaHbeMw7WVFqcPxvuCmLJnn69uuZAgMF6N93
15649	payment	1726	1726	1874	1	1	5786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwc6jrihweRXwakYbSdAsery7L3Uhvn2MmS3hY9nSoQvxBe4g
15650	payment	1726	1726	1874	1	1	5787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VmPM6zXqxyLRqGP4yWnE4LT7mqPQ2Pys2DSD5DG67p51u5gH
15657	payment	1397	1397	1678	1	1	7592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mKe5wtBkRG3MJKucYcboXNxM4sGSvoXztS42of74uqRHvhF6
15503	payment	1397	1397	1678	1	1	7539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTJXdWX9RNQg3aXmBWknPSJw6ZciShdS6msVsw2UNdc6wo8Up
15504	payment	1726	1726	1874	1	1	5696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXGmVhp1gy4eEBBNtpg6rTrQDGbEe196U6fd7y4EDQH8LQWCJ
15505	payment	1726	1726	1874	1	1	5697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4gvjd1XB5HBojtX2kHk3e1FgXdYnCrmGCgrsaA4GAt3WU7Nc
15506	payment	1726	1726	1874	1	1	5698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVkAwy2B9LVbeuQA5chxJxPtDpNhkuLi3DTUdc62uE9nW1hva
15512	payment	1397	1397	1678	1	1	7543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMT8AX2gurrknTKPhXU1rkaUYhc1NpqxAt6xk2WnmUdN6BZBDE
15513	payment	1397	1397	1678	1	1	7544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsL9QxAXqhE5ZYEr41N9HiEVyqvY33dv4FgbQDnTasbzpbzyMW
15514	payment	1726	1726	1874	1	1	5701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcg6xb3XhjYn1tk3WbBQMrq74tCnAb9mkdZWjQRMuZrLdVwu5
15515	payment	1726	1726	1874	1	1	5702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzCzpMrcyXrWvaa64a15zb3ErjxFMAnCpd2FNt2a7KMHk3hHo
15516	payment	1726	1726	1874	1	1	5703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVokj89gCNCsktN5HxdWbwhLjbmVgvTv4sE8ji3ctoybBgqVY3
15517	payment	1726	1726	1874	1	1	5704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCJwTxBDn5pnje1YXMKZGVAr2T4FHEdFGVZPfPLR2kWczyCQm
15518	payment	1726	1726	1874	1	1	5705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYni5bSymMcrWnWbg3cVq34pHEwEnhYC7rA8vff9aDhNma1neoR
15519	payment	1726	1726	1874	1	1	5706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYfWyJREQNutd8j2oyh8h1agQVhBxgEaq4kDhPYNrpeRWHzVS
15520	payment	1726	1726	1874	1	1	5707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXRJ78zxezgC3K2H6BdNucnSG4CRAcMgpSnPeqDNsSFW3ReCT
15521	payment	1726	1726	1874	1	1	5708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqtM36aWyttmSX51tosDQg3hnLiBXgWfW1R6KhmM1v17jdHQp
15522	payment	1726	1726	1874	1	1	5709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyZ8iio9MFvk211jjJmgLWYpEAGY3zswoyVbnCVo11EkrhGB1
15523	payment	1726	1726	1874	1	1	5710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUJ5ydso5DW8nTz96tmaha6jTP5MSfTpwRW8bXmEBaVW57emc
15524	payment	1726	1726	1874	1	1	5711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2E5zr6fU1rCE58H9pDMDzJt6fHFhUCJUgTgmzSKXUPkKhNyrd
15525	payment	1726	1726	1874	1	1	5712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5LFVL8JYpW3PYwG8m13naYioZeaBwHeBEDiMwyniDoUFKVA1
15526	payment	1397	1397	1678	1	1	7545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZPv9a31LLg5Ppk3bQkJE2fPBYg6oySFE9gq9VeyVEnk4EABq
15527	payment	1397	1397	1678	1	1	7546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLabA7HnDgX77WeJNWxAChF4CRgn76zC1NyDBGkDT8eWFaQ2v
15528	payment	1397	1397	1678	1	1	7547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdNms9oRW213ikQJBoVKQgLEU2rwhLTSAvDr3LHCF275AQLtM
15529	payment	1397	1397	1678	1	1	7548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hR813AdMKyTnt2nM8cE31Rcs3HjG5HtrcgHEWG2eKBqdVSpr
15530	payment	1726	1726	1874	1	1	5713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4GgxT5A21Lct2oXN8oUPgLobSLFLdUh6mWL3exUsiwgmJLF8
15531	payment	1726	1726	1874	1	1	5714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjsd2PCsrQQfu7pq5uXzW5B9oo2gYW7hz1KcGy7gixYD1QNih
15532	payment	1726	1726	1874	1	1	5715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa94S5NepE9LbGnfRBa1hE9PmmCTzL5WsJAuUWf4JZ6DZXw7dS
15533	payment	1726	1726	1874	1	1	5716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHPThGhRBchnygrrrB5EhZQL16bH3afbEEc2sP4w1p5RTnHWX
15534	payment	1726	1726	1874	1	1	5717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxH9w98qgrr6ka1SuScX4ZLbsMF44M1u2N47zz2ybomdYTkyD9
15535	payment	1726	1726	1874	1	1	5718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8thQKPgFfyAY8dhgE7JCcEFyhmBvU5tkeyK2a2Hia5PZUVUe
15536	payment	1726	1726	1874	1	1	5719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsuLHLerXYmCJeiFaYy5T7aUvhDsJAzmPHiEj9MPZ1pY5LjtS
15537	payment	1726	1726	1874	1	1	5720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6C192iPiaMGekFCQm3bxEZpXvuqUwp8D8sANXcUkyLK5RuGy
15538	payment	1726	1726	1874	1	1	5721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgPeLXP54hZPLWWwXu97QyyyxVE8zNDsii93qB8doDZDBwMDq
15539	payment	1726	1726	1874	1	1	5722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LUxfXgBcyqSjcL2EiUKwLuTL5onbkuAVHh8eripEKAt1Z6Je
15540	payment	1726	1726	1874	1	1	5723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoYzHzzEuXVdfuhJG3tETGtTn96qtALTcviyTKJ5XzdR4cUSA
15541	payment	1726	1726	1874	1	1	5724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKVVjZFJnxRGVuFHpYZDBavydH8zXqZgWb7vLnvYBYJdgk2aN
15556	payment	1397	1397	1678	1	1	7553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs43msG4a6osRNZsgN8hh8uoWAfHhxbv2ZF51zbg7WmZHJCb1b
15557	payment	1726	1726	1874	1	1	5735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP45RK2ZY7DEbgcLp7nv3FwCz4RPvjG3qcwGUqRuvSgT7DaHy1
15558	payment	1397	1397	1678	1	1	7554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSJ3fCMR5vuWHZRFAo3tMkaxk38oCRYea8TwcwkeabFDUfN9C
15559	payment	1726	1726	1874	1	1	5736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cVSdtorc2aoauBvHpJ5ZUJAQtubobY4M75V8pcEzXfoYWwiZ
15546	payment	1397	1397	1678	1	1	7550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7TEub7JweVXwKZuKKpqUcC2NKgf9pBX14PhxVCxiUMbiG3GV
15547	payment	1726	1726	1874	1	1	5728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pzHJNGfVVRKW69zwLYdh648DFND6AeYVbAQNqZG2TQ2QkNqE
15548	payment	1726	1726	1874	1	1	5729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3GXgeGQd73qxpeZ1wvMjARPXfNCyp84o2mqTahKAPT316tyN
15549	payment	1726	1726	1874	1	1	5730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfZPAmZDW1QPiFHtoWh8hARuY1VEfb8EuhR8iZ7Y54oY5n7Bs
15561	payment	1397	1397	1678	1	1	7555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc9t7tfzLFqjb8FT4veNfvERQDjjaoP8BTvSSAC2nzU7ywLdr
15562	payment	1726	1726	1874	1	1	5738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGvfhpVNbsuFXc9VoLpWfTtwrKLQAiGnwSZ3XwWm11vdFEneJn
15563	payment	1726	1726	1874	1	1	5739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXE1cYT2MzhrJY7m9xJwWNVkEYkP7iuR2wotfCU7jkBVh1ZRr
15567	payment	1397	1397	1678	1	1	7557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4UryCoNVLVpCP42P5hN3gtEbK8f5Z6a3ZcngV13CFbnq9whS
15568	payment	1397	1397	1678	1	1	7558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLr9fBxVE9VjUxCpjMrt5dmwTdGVfushyrbJvh5pa8FcwveSp
15569	payment	1397	1397	1678	1	1	7559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxk4kUxy6NgAUqFuXwvQhvP4L3yRbCBbGdrCw8zJhyPkAvV19
15570	payment	1397	1397	1678	1	1	7560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxpjrRuLdxnFSkaR5DPKuyCyUwPoKwFvLzkQBiSHSvQDGqCwo
15571	payment	1726	1726	1874	1	1	5742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAK7bsPYy8TZP2r6x2LEEctifzgsCYNSxVDgeywGEx2HTCEFkg
15572	payment	1726	1726	1874	1	1	5743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxBmZ5KMN9HXdHWDxmEby6uTkccWeUnm2A8xXB6ZF9Rz2H2VB
15573	payment	1726	1726	1874	1	1	5744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vPkxhFAb6UjCM9LaecPWcwJGPzZ8nsCCpvsydzgkfq9RPH4m
15574	payment	1726	1726	1874	1	1	5745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsffXUmn1QKXYi7Nc5JdPW2vTTXFaddo7RAY45q8pMXyjX7DGo
15575	payment	1726	1726	1874	1	1	5746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8FVEMaiiQWqicEqXn5y6o3AEV2oMwHzcRh4iduMFdzBQQBG1
15576	payment	1726	1726	1874	1	1	5747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNmgwoab8aZQXKQCv6eTzBbtsK6X6T9xNb9k5VZ2ZiQoCDxdB
15577	payment	1726	1726	1874	1	1	5748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoPTpQMSypafaqpKfV5QKRvpRKNExEFKPXxkzRXy7ZF6T4pjE
15625	payment	1679	1679	889	1	1	23	1190926465000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaF3uWkhiiv6mXjiRWofzCLEnBTwE6CQdFWGJy8uESPoaR3XmAE
15626	payment	1726	1726	1874	1	1	5775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXMDZ2hWb18DuVqaRoLaJshEJscNnWeqmAYSzQHdsMToC8pqM
15627	payment	1397	1397	1678	1	1	7577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTNzwBdarkVYUwfQBpEPDX4ktGyg34m37HVZpu2s2BYpRGQqc
15628	payment	1726	1726	1874	1	1	5776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVQ8hSKEyX1251gqR5pFzrwsp12vThubxyHv3MyLyZfqyn5u6
15641	payment	1397	1397	1678	1	1	7584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSmEZGP8btcvciskMRPogvFjhJ5FkSNYMMGJSs4GNo4eGTtK2
15642	payment	1726	1726	1874	1	1	5783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRvoyWoMsV7vVL2yrjWB7W1kDrC9Dzg9Ctm1iWp8SFLSGHyfS
15653	payment	1397	1397	1678	1	1	7590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbrNXdwSYU2sCLNg9ybVkqjvSxcAsJD1pK4o4BQPk1xArwP8G
15654	payment	1397	1397	1678	1	1	7591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVGrAn5WRfQVHkveZkDqfWkRP22TtpkhGs3Bu33a5tF3iiwJm
15655	payment	1726	1726	1874	1	1	5789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NP1tUN3y4m5EUsXhF3X8EYfVwCuXUepNrCBiXSkXc592G7pr
15656	payment	1726	1726	1874	1	1	5790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgyX4djfrWjwDWMcrRz8ovQ7kb4pC8K7Myk5qCwWt8sBV6W1i
15663	payment	1397	1397	1678	1	1	7594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrwwYq6XNtmzJkPyTXRTCWX87TyvaxHXCuQD1WeCziAArMwtF
15664	payment	1726	1726	1874	1	1	5795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXz46RQFz82kadHhw4i9nxFQeHZ35hfpwR8NDB6p442zwrwcU
15665	payment	1726	1726	1874	1	1	5796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmXR3Zc1ocVihjQxb5KMd61b1n32oVt7fzdA4jrhCbkgg3fWm
15666	payment	1726	1726	1874	1	1	5797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYdvWMUDYRYrYAPagnjfpHpGwHLWim1c9W7NCdrWVfzthttNG
15694	payment	1397	1397	1678	1	1	7601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctSR1vHyT8XNU4CoSdPdTrQjWEmxvsGf65auSbycms3SGDouL
15695	payment	1397	1397	1678	1	1	7602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYUBBgPqy5RVb3sT2xefWmr8ATp1V66qPsGbGBrQAyMJZDU1c
15696	payment	1726	1726	1874	1	1	5816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa435twQvLiFK2Dxe65vXRJy5fPDXtfHT5Ya1eeWE3LieR9fFr
15697	payment	1726	1726	1874	1	1	5817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmMQziPpJrqNQAGynEdxVmTWqQdvsPWGJsHofkVrGEx5qJN1u
15698	payment	1726	1726	1874	1	1	5818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyKA9BT6onjynKUh6swb4L8gpQxxyoZLuZ6aVUf7BHURCNo5E
15699	payment	1726	1726	1874	1	1	5819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZae2MbziAgaMVgZm84eZLYMUEPMkHRaiD7UPuK8BjEXEaJWohr
15553	payment	1397	1397	1678	1	1	7552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgoUsoWW8NXpeocWq7F3nhfK7bZfdFmcLwL8VxwoSTQMGobby
15554	payment	1726	1726	1874	1	1	5733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPTUj3XFeaE2gd3Nopg8hwWXDpP26DRqW5kd9brSStFcKS6Ng
15555	payment	1726	1726	1874	1	1	5734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVhC6LMJdMN6zQjhQMgVcJLRH3ebPxzzW5V5GWrkkwypD6sjR
15564	payment	1397	1397	1678	1	1	7556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMonGVEp1F76tzUZSYjH1M1T9qmeotkhjRiwUNaAYb1XdU2GA2
15565	payment	1726	1726	1874	1	1	5740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPng6GEYArDYWW3ffKNAzpJ7QQSTSjGdXXgmTh2rukwuLRMyqm
15566	payment	1726	1726	1874	1	1	5741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMt2RRLz978zG3Jk6fcs5E1fre2DtxBgGkbypyGcsx4VotHBWE
15605	payment	1397	1397	1678	1	1	7569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKP6S1eqBXuPt8h9EgQZtSQb4rYaW3Z3B4Cd5naoYKgVBQV7i
15606	payment	1726	1726	1874	1	1	5764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrndVhm1UV943Tujsjs6HNMk8WF5y7McT2qzMH2uNtfEYCRQX
15607	payment	1726	1726	1874	1	1	5765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrERCFr9rnVmsb564aB12sBPEj85vq4C984NP2sX8hkmU64jqq
15608	payment	1397	1397	1678	1	1	7570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwADUbEAt39pGDooxwrHiQfsdFDXYC7wMVZzgr5K4ERLeQ7kTp
15609	payment	1726	1726	1874	1	1	5766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMaPhmtNTKFXCSchsUDmrEHSdrzuoRq2qM3wXGvUVvu721uPi
15610	payment	1726	1726	1874	1	1	5767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBm9BGuM29vJfs4kbUUw4hwAh9WEauBsYpib62RtLxJ89vcBPi
15643	payment	1397	1397	1678	1	1	7585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnntStTzYVSEqP5n9bmjJL5JmvPSWnBb2Q17Wg2WVwzoPaxNh
15644	payment	1726	1726	1874	1	1	5784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqevQX7bWHtH6wnRRiUWVPDbS3tAfbHQeKmQpFpuHzmBBwD8ro
15676	payment	631	631	2099	1	1	1	718000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBXW3oCHySUF5x4ZHeHBWTPPrP7Lyc1wUFvbyrUf88mSv8mbF
15677	payment	1397	1397	1678	1	1	7597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KHiEx5JbtM75GiEfsi6WBzRpfD2Xxk92GRrJeH8cs1Arn8Zb
15678	payment	1397	1397	1678	1	1	7598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQeVFbpKHubyCzeC4SGMStLyhEHYcb5LLuekuBr9cZbsPEXbj
15679	payment	1726	1726	1874	1	1	5804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2NXuQ2psqiLWigNH1siBPA6qBC4dQGFhT5s637hAyn3xXjbk
15680	payment	1726	1726	1874	1	1	5805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzKJSZZd9hJWGSMdr12VTskYj3P3uhFwZREzLv52GLy3TumUc
15681	payment	1726	1726	1874	1	1	5806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQseW9sdHB6Jjppjz66onmtAhZB5EjZ6gSatZENQR93ASfcQhN
15682	payment	1726	1726	1874	1	1	5807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkkU9z25cfRuMnuEYvJ985262dwtCN7jtbJKWEupb7XM9G28M
15683	payment	1726	1726	1874	1	1	5808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4fakpGAcj3JAsJZDazAsmBcoyNoDhvRXZwRr6MJb8Ck5EsUw
15684	payment	1726	1726	1874	1	1	5809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7aCWPYXP5DsHFxQdaMg8Yru24sbis9GC7xYpDZSvDLjESpsi
15701	payment	1397	1397	1678	1	1	7603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeitdJ3N5Qh27vtqwYZDgjX6YhL3zPY8thJxgA64uCKGkG2KMo
15702	payment	1726	1726	1874	1	1	5821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurRicNVpCoe9QZpeRioiRenFsDcrVkrmnBZTov2otJBD5Cngv
15703	payment	1726	1726	1874	1	1	5822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBmsh3fZqEF4KWj6MfmCc6NWpwNkwGTUg2aXdrfpG3UXTcYzy
15704	payment	1726	1726	1874	1	1	5823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vtgMC1fGBqoZhAdZagfDjFxqHV59vPEJCTsMFw3ez8kwag9k
15705	payment	1397	1397	1678	1	1	7604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4D4fkBBWswpwyws6t6Hci8epVbwRErTJiDrY4Gf742zJcwvgR
15706	payment	1726	1726	1874	1	1	5824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDS2MyuSm64YJSH6JEHdFwKuH9nNP3Rx2mXqwHyHsHdaf6BwK
15707	payment	1726	1726	1874	1	1	5825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7DWB4rAPCWYLPREBTHkQBc6mEyjMrixSZEub3dnZmWUcxB95
15708	payment	1726	1726	1874	1	1	5826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYewZLWNpjNmEQof87bREBmeJYc2om67DsaxQymcZotKuKg7NZT
15709	payment	1397	1397	1678	1	1	7605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnEojKFUQgMgWEs4e6TBYCzy73n7qs3ucDUybbh9sENhHQB6L
15710	payment	1726	1726	1874	1	1	5827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRA4ynGQDrxG8PN3ucZFT1rYEyS46z4AQzCTcS4szqrk5CPYZj
15711	payment	1726	1726	1874	1	1	5828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCD5xjF9jH8LXYo4czmUfeudtrYCLD1jyhQPvbSsPky3xmDuAj
15712	payment	1726	1726	1874	1	1	5829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ39pZUpUZ37wJzqAvH9pv4M31LnCtS89ustPyyo8hv5gPzVo
15722	payment	1397	1397	1678	1	1	7608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Lraj1dGUkPVnc647JWApwfu6y9fwWnQBD5xS5PzvGgCDidzg
15723	payment	1726	1726	1874	1	1	5836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YygQ3tVzTpNQjgh4qHVhH2oYUTMqze9PxupYzYTvQ3f7sC43
15724	payment	1726	1726	1874	1	1	5837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26v6DVf2juRQwoNYLeMWYJv3aZrPcE654GdX3SAY5EHjnyree
15560	payment	1726	1726	1874	1	1	5737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfu38SNuqbgizwmKp7DnjiEzBUwsfMNykYPUJ33vt2y9K5eM4
15578	payment	1601	1601	1388	1	1	9	3752000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYQaXp2pp94YWyrFFGBArnw3rzrUoS1VYeA7nRP3Xpcmzg9BwA9
15579	payment	1397	1397	1678	1	1	7561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYd9P9y4KwGEHxcfPj7b7LUcBX1WjSRVqe7tGsArpmG445k3Pf
15580	payment	1397	1397	1678	1	1	7562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYzjymX7eRL2xunseztkcgqME2eQriXdECVC69kioBnwXopxB
15581	payment	1601	1601	1142	1	1	10	1996000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZtwn6QRJ4KSBKeZLvshDDf5ToTnHgvTTqSNUuKFCTUheJUerc1
15582	payment	1601	1601	1262	1	1	11	1346500000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZ46YRoaTvtvHzp2H93prJxAP4gv7nPz1Q5QJMkCJrUKcpKYitf
15583	payment	1601	1601	1022	1	1	12	1114000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZcZU77WcYK7Wa6dj6yE86ABhgj9KDqgchCwvTZBPDwzyNNPKwB
15584	payment	1397	1397	1678	1	1	7563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcdZQFmuskf47D7U44U6Q2i6cMcAX66a6syYNDwpsuqFitupm
15585	payment	1397	1397	1678	1	1	7564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZrB8fTwLtguPdE2hXKny2nN59vGcAhFxTvwPDi3o7NchpY8G
15586	payment	1726	1726	1874	1	1	5749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEZWZ53LAkmGLbTYoK6WpxjDNnFY16NG7YbCT8kS3x1K46F7K
15587	payment	1726	1726	1874	1	1	5750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbQwsKw939F48r4qQgwghabVwAjGKraeeki3XF5KRcGaEACEk
15588	payment	1726	1726	1874	1	1	5751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRggvYr9GW5GdUh5tPwvqpiKCLYh1eh3SBL5xS5k8ekmQSPcKn
15589	payment	1726	1726	1874	1	1	5752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrKMF2KJ3L6y9rq4HGEWmVRrygyqZ4VmufjiacvngdHcwGKaf
15590	payment	1726	1726	1874	1	1	5753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbER2aeaXGoUEGg3ogkqRCcZqGjVC16RUX7BWsC4SJG4EYuszH
15591	payment	1726	1726	1874	1	1	5754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsm6jW8Juykno4q2X96knmVWygNBT7LNYGTdC5Rm9acCGzD9X
15592	payment	1726	1726	1874	1	1	5755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MNGXZ7R87eJ2f3XAmMwG2TsoffsfnW2pQK9A9kHXivxHS5YX
15593	payment	1726	1726	1874	1	1	5756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1JV96xiBHZeG51F9TBiCB85JFK2jVJK4dnLBnqPEPreP3oE
15594	payment	1397	1397	1678	1	1	7565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb6Xy43vCmJPE5rCZhjok4Cd5KsZjau2GnJsBW6fJGbpoxB9F
15595	payment	1726	1726	1874	1	1	5757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oYwamrAzdLN2Jx3SKfCUhQY83Y8ebnFYqknwfmtJH5dVf5x5
15596	payment	1726	1726	1874	1	1	5758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGEWCXpMJChDX6SwBoZywKPZ9RiGBpGtxCSw5RSRn6HgoMtB4
15602	payment	1397	1397	1678	1	1	7568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWS9iwx7MvneFUvWtzDUb8TTaVUkydA1Usa1mTAQKBKVcpapzK
15603	payment	1726	1726	1874	1	1	5762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb9tuVfK9KfhXsFnSoF61KvyGtSwr1fzJL7ioa5ocik8NQm6M
15604	payment	1726	1726	1874	1	1	5763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCurKjzPxvMWdTrfgi5BmS5zyozcTWzKdAzTpsvSgwnt7LMr8
15611	payment	1397	1397	1678	1	1	7571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3w9SkpfWTt6UTXVqXZwdeDT6Uz6ji3fjJFz5BxeaVCcQfL7x9
15612	payment	1726	1726	1874	1	1	5768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnE3aBagjyXAUf1LvGwxyE53uGar2kqH6kyq5ceWeG6Q55U2X
15613	payment	1726	1726	1874	1	1	5769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcjNe1tzqyrcA3AdtpN2M341zgZUqY2mYCQinb7tZghLCSuSQ
15614	payment	1397	1397	1678	1	1	7572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYED29hbFNanDgC2oaEJZ7aPH4D7DfggkmBcVE2kV6TaRf16pM
15615	payment	1726	1726	1874	1	1	5770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD69CuFQxXeGM9MMm9557WmkUgez22HEHAdxSCu9YLxHqqmHem
15616	payment	1397	1397	1678	1	1	7573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXqEUqjzmgGjSNfJQjm1idHPeKf4w6dLu1YrBMuyoLRaF6eak
15617	payment	1397	1397	1678	1	1	7574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQGJHGZc2eQHYZk6kgX67pZozVachwnBm3c29qgTGdBmjcjiY
15618	payment	1397	1397	1678	1	1	7575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27vbMXfbh6nS3UpxkT8B3VMe7cFNBzee9QJZF8txM1BNzDiYm
15619	payment	1679	1679	887	1	1	22	1418704594000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkmAvvi8qakS6Dpcs8NcBMywCC33zzbJsSzgo7GbdN2GG9J3Z9
15620	payment	1726	1726	1874	1	1	5771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8d7x8tS3Gvd8NKjhUbHmL382kTU1ask7hwGGD4T2ctFBg8rb
15621	payment	1726	1726	1874	1	1	5772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwE24AezLt9oAbMNHrVQmxme9FocEjtqTjnuhDG6BfJuwkeSh
15622	payment	1726	1726	1874	1	1	5773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVMAKrRY1fAYqRkmeFbuVWHPY5XVGFMohbrf4nf9bMuaw742U
15629	payment	1397	1397	1678	1	1	7578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8cQB3aUPSP6iDaGwxkj2KnAMrfWN3mN4FZQEPQZL5pN4J6PW
15630	payment	1397	1397	1678	1	1	7579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3myrxsca25BXNmfxTUpUGB7V1bHAdQfdVBR8FfSeQuCrj9cu
15631	payment	1726	1726	1874	1	1	5777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4zVvrFyM74vVwyYykYoFrA61UFUjPmgntE3zpUL979NQk5Ac
15632	payment	1726	1726	1874	1	1	5778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo227X9xL2TEQ6s6T3Ewh18gxoJuME8dJSTsT7hZwNwubnyQM
15633	payment	1397	1397	1678	1	1	7580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUoePzhPpDSXcYqtn7gFw5S4kGgJcpHhd2Ar81ojaDoEZnWMN
15634	payment	1397	1397	1678	1	1	7581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKoj6hEgstYsq4By7eriAjpkYbk31zApVPX69UJwb3mQuTCuc
15635	payment	1397	1397	1678	1	1	7582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzxt2LgGw6Gs5uQhpSKAubQneifbZH3kgzE9LAwfuQHCrbRRE
15636	payment	1726	1726	1874	1	1	5779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK245gZB4fx5QjNS4o5d8uTpv7t3wgFeHENdaAFZLNkL76QMaw
15637	payment	1726	1726	1874	1	1	5780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpvfm3X1kMbK4GYbxtQEDx7F1XYGxjzz5QBqktzNSfbbq5MLM
15638	payment	1726	1726	1874	1	1	5781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSucpcXbhyo2Ppttswx7s4u6UipWvQr9V8PGoZSqS3i7s4Pphi
15645	payment	1397	1397	1678	1	1	7586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz88u3LJWSzQef7BiH17HZriw8ZqMWPQyvThV1VDxgphA5hGyt
15646	payment	1726	1726	1874	1	1	5785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkk3jTvGxqUi7NWwCnFHD5ns8CRFnQ8ysdEozhuJHfarugGK6g
15651	payment	1397	1397	1678	1	1	7589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk43R3WFyci4hjVacMnfsxSgnxudmuSDHcKpWD3kLPsiHnrsDR
15652	payment	1726	1726	1874	1	1	5788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5zXVb4Eua1jyDqtLFM5auUsDyRpjfDSczpK8NHUoTznix67Y
15659	payment	1397	1397	1678	1	1	7593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyELRNtCyGzMJYYt5gNZGgd9EcQwaHKRGJ8GT1m5kwCn97LoEp
15660	payment	1726	1726	1874	1	1	5792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeBX9pTcdswHyyCQtBQzZJrwGpFZvu9wuDs6H3B6MU4koDSnJ
15661	payment	1726	1726	1874	1	1	5793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHpoZ8U7QZ6jMRbzAQyfhY1J1KX1rWtHTCErhtmXFsJRg7ci9
15662	payment	1726	1726	1874	1	1	5794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZsLQzH8A8WHuX8vmvc4ZhhMMHQtQNo29UGseexjtTHbDN7bK
15667	payment	631	631	2099	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZds5S7iD6UByiyGj2NLpnj3wbShfA1G3kZT6Sz3dQTMJ15VK
15668	payment	1397	1397	1678	1	1	7595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDaQdR3HCwsAA2CLELS4aer3KS7FWuuE6PTEgeK8wZNtE4GaP
15669	payment	1397	1397	1678	1	1	7596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6fRJ41kAMdgjcHrwhq7V5nP3vofQVZA6sDzG6NdCGpm5KWKs
15670	payment	1726	1726	1874	1	1	5798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3CZM1PscpXXajCgwEFWbi7VMfK8WfNu1GubK3x16McpRBsLN
15671	payment	1726	1726	1874	1	1	5799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpdJwAzok95ZBp1dGDhbizu9Xts6cYkpiRppUxk7TxR93mLQ3
15672	payment	1726	1726	1874	1	1	5800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVz8UFXJAiqw2ryieawHQBAj3jSdFSKQKbnHabnrFmJQibwyN
15673	payment	1726	1726	1874	1	1	5801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9LkmJJ71J8ZbcdeBv6WAVWSHFyCCC8rLJBcPfGjxqRbWFxGE
15674	payment	1726	1726	1874	1	1	5802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6v3ckEzNaS7TgW7LxfBkXJcBhUhkXwat2mGpf77WFeq3A4VrR
15675	payment	1726	1726	1874	1	1	5803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3pGGM6RmgahuMAmgWW21tQ3ZkpaCTq8fLA6Fwa3e9bo5VbRG
15685	payment	1397	1397	1678	1	1	7599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKCtPcwwG6Ss6tuThWGLkxZpPWTSogCrANPJTzRbnqaLSUrKe
15686	payment	1397	1397	1678	1	1	7600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdnBgFz1GDQ6XpTZWWrXGgQ84rbsnqowmkUggvfB1ZvbmKDy5
15687	payment	1726	1726	1874	1	1	5810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWcBmS8hswnXvbNMSdz7L3ZmRC3FTmcEQ6BVPLxCyGJqF1Zxt
15688	payment	1726	1726	1874	1	1	5811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6i15HEuQjWDqcoSs7mFCTEFH1F4Pr2SfKcT1hPVHmbfJFyaFg
15689	payment	1726	1726	1874	1	1	5812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pZujE7f2RiP4pwNJXowMwwoUQUVpkpHdXnAvVgC7aJDP5Pza
15690	payment	1726	1726	1874	1	1	5813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbNNdEZyEovjHCWZGu64DAhiugjawfmLPKCZiEhTFgq1ZrX3b
15691	payment	1726	1726	1874	1	1	5814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SuArzo8hhjTwVRbLTN8LLMFBfNRURUsW7memv4zKESZnkcUU
15692	payment	1726	1726	1874	1	1	5815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNiWrCYvc7ZFVELYcsHmREfZTzk1kwHCsUb6VA9wWixxD6dpW
15693	delegation	2099	2099	631	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PHSemCutcY5jUkp81z52YbWwp8Ae7yBmdSiNQbaCeC6Skt1e
15713	payment	1397	1397	1678	1	1	7606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmdSAzfCpFdgCGisVs2hjgYiuvneqRgw97hpAkXkbBZiQuTuu
15714	payment	1726	1726	1874	1	1	5830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgpGjcYVAi9CYBJBNsmnS1gYT33P9XTNFu5nAEhnRtJsADDgJ
15715	payment	1726	1726	1874	1	1	5831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zenNpQV6iFJpY6eWP6zP1eXe4aCpnzgJzALKXYrhPAKLhG5D
15716	payment	1726	1726	1874	1	1	5832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1sar6hAr3FXaJwZko1ymsr6zan1RKUD84P1gw92Q3pF6YqSS
15717	delegation	2099	2099	631	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTMFCv6V1sJtJDdKDqxEa4uD51TQCtVTMXd6nKQinWc2895VW
15658	payment	1726	1726	1874	1	1	5791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXYDvqA77egh8rnSZAFdw3HvZbbpNjvWWCQep7ApRUNb4BvG9
15745	payment	1397	1397	1678	1	1	7614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PjKzE2WdB6SgyBJa5uGXCbYvKeZP2BUh4ouqgrSfqn8b7Ejk
15746	payment	1397	1397	1678	1	1	7615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoLPFaF5V9KAXFafEYyxBHYvnAD1FEkUphQtSkyaDNffQqpqj
15747	payment	1397	1397	1678	1	1	7616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNDPBT8XW9dTG1JKDBqLCBoKord9wc2wBqVsdYWqMJpP3HLp
15748	payment	1397	1397	1678	1	1	7617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfyVgZTKgWLQaUXR5sbC945GLjnGPGp9ivZYY5guwQuvPaGMKp
15749	payment	1397	1397	1678	1	1	7618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteihQTfk3NsFjEVS5eeYZgXyEFXNFhfLnFNKz73h5Mk2ULZWG
15750	payment	1726	1726	1874	1	1	5853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZFFt9zc1PpkK5ySY6RhW4qBMcgGiGLRES1TzKZpV2c91MD3E
15751	payment	1726	1726	1874	1	1	5854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf17XUPni7UpBsfDxbBTdeDs2Bd78hsdPBNB3BuA4TV8WsWGzH
15752	payment	1726	1726	1874	1	1	5855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy93e9NjQSDQzCDTVmtSgHdj6Nu1FwfFobuSzzw6AfnpHJFhJt
15753	payment	1726	1726	1874	1	1	5856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VRu7MTxhZm46RUfriN73yzG2vQe7LhX37hnnbCB3uYn87ry2
15754	payment	1726	1726	1874	1	1	5857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfefRvGC66JYXUzjotzDNnCqxx9fAr2e2MUjBHupE58u3UiXHs
15755	payment	1726	1726	1874	1	1	5858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4tVnV7t9iSwprzsQ8csyknHGpULoXP3a8AAma2NV1aQszFBg
15756	payment	1726	1726	1874	1	1	5859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1H1z1hd6nS4oa29AG2hDSdyNbBztjkPfdxB7jD3PSu3PJ1g7e
15757	payment	1726	1726	1874	1	1	5860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX8zjjJBUqYTzYcVNKnvrdECzgfUEivJFpFkNJSt71DvgWqKe
15758	payment	1726	1726	1874	1	1	5861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTBSDA1WJnmkbPsQJZcrWPYX47PYBTrFSSgSr7eR2RZSmVZsJ
15759	payment	1726	1726	1874	1	1	5862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFSCHbWtojksqwTPmkyf6frMYdFi8rkRwCUcwwCXAuDoBRm8L
15760	payment	1726	1726	1874	1	1	5863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhu5EHnxhhmL7BdpaBKXTSwZkXEAa3oftxLK6Z4wSJrkwuNTg
15761	payment	1726	1726	1874	1	1	5864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuknrYVw24xaqo6diZGz8owXBE73BqRmFuD9BJxSr8Ewr1TfRC
15762	payment	1726	1726	1874	1	1	5865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoScFbV7mfVEi3nFUrW5165umyjcagDDZrRuGziJuyGXifxjG
15763	payment	1726	1726	1874	1	1	5866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23mfGniaZGz1ASdZrp9UbVwL9hWkkHYwncxwuNz8Tvd2TiHtE
15764	payment	1726	1726	1874	1	1	5867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyVKgLkyJ73ant1cV2FweUn7NzxbutQGe5ozbtQ1jusbqFB7J
15769	payment	1397	1397	1678	1	1	7620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtFHgDcs6vQuRjq9mZ6VQBCeFy2e8GNxeDyztXu3AJeiNPwr8
15770	payment	1397	1397	1678	1	1	7621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwKNZLKyXkNJWcAJaFgnuG2aUHk9XzickDxuqhA858JryHnNr
15771	payment	1726	1726	1874	1	1	5871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRT6KbetPkZUDa4tkhFVoYWukGR2xy7RUobfboPBnupamd1srK
15772	payment	1726	1726	1874	1	1	5872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJ9CHpgyewbCjir7uoRsFVKUpjSVyYrgqEnUjhj64BFQ6zVBT
15773	payment	1726	1726	1874	1	1	5873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsFBpzwFNGmuw7J1FQUygCRt3qJqQVTVVLCpkYmMdkXwMaBg5
15774	payment	1726	1726	1874	1	1	5874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJY6HtLN3NoGaTD4hP825tPPtKz824hyYhkbNvsGQE9wTRMgq
15775	payment	1726	1726	1874	1	1	5875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDUjbcxxmKr8kn9MBssDCnt5ymyGs994Cs1Fi8xjN5Pmq9Y9e
15791	payment	1397	1397	1678	1	1	7625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVdtEQmPRkGNMz4iRvKgX1t8D1sRELqHjHaWZ7fxg52N8pcHL
15792	payment	1726	1726	1874	1	1	5888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfhpurs571C79TymAzj98kY3U7CQoRENHzccFQjNj1Dw8RVPY
15793	payment	1726	1726	1874	1	1	5889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZf4nyH8U99h7LuixTZYsFTKT3u8dcH93RbzG2Gdnq6oJjtWP
15794	payment	1726	1726	1874	1	1	5890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBPZ8qs53Wd36h4iW97NuNwT8U917ZaD2qERCQ8MRyrfW6NtU
15807	payment	1397	1397	1678	1	1	7629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytuo4N1Rbh6YizzY2BNhpJtdnehzdYGGCY1WS6pQxVfU7oJ1H
15808	payment	1726	1726	1874	1	1	5900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPziNdkhzx7TGytJ98bq4QVMRgEHHx8vDzbyraC8UaGPhuGr2
15809	payment	1726	1726	1874	1	1	5901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkZWtgWxD9J1WFwAMQpDZQgaw2jhM3GSAqsPnTYQwk1EcdSv2
15810	payment	1726	1726	1874	1	1	5902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBiHKrhxi4wkeBctUPVPAGN34M7pxeQAXHMCWMkNR8A4wUVZv
15811	payment	1397	1397	1678	1	1	7630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTArYromqB1he3N84xYVApUqxGHHiimCWKY3SuucRKuZ8ceRx
15812	payment	1726	1726	1874	1	1	5903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC5ijCHhhMabfTbXCse9S72YtrUUCqNAkByZ3o6EAFSN7CE2h
15700	payment	1726	1726	1874	1	1	5820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Mpn3piYqjXd8LFfXdx6Y48avaU9cWWT4U2ZuMzqeup4j3iet
15741	payment	1397	1397	1678	1	1	7613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYERKoTeAm2YgnKP7XSCHXDWMGckpZzeFiuS1fqVVSAR9uW3S
15742	payment	1726	1726	1874	1	1	5850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXU9M4XYusRDQdFbyV5wtrb44CSBmycmhnhWkxDGPKVmENR4Ce
15743	payment	1726	1726	1874	1	1	5851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuNwBkVzgN3QKWfbtgotVKH8AeQYDq9QXqTN43LvH45CgE246
15744	payment	1726	1726	1874	1	1	5852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtxhGmYLRKhzfH7zaSvShugN89rLUTJgVgxa7H1mgESgVtToa
15765	payment	1397	1397	1678	1	1	7619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWGQm74cymRPQeETkCKCJRKNAwvzzVsNcZimUezRGQBdG7VuC
15766	payment	1726	1726	1874	1	1	5868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckebRgbhUkEe6SEBuZnS25GmfewHoTwVozgtq2mNfzcU59TVe
15767	payment	1726	1726	1874	1	1	5869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5c7fKyKqbD5AjvBAqGoxNE9n6QbuRwiCjugFjAPyG25uEp7F
15768	payment	1726	1726	1874	1	1	5870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYucWo3NDBiusGWW6xUMMgWjJhUa2yhGWmTJqN3rwAEZTM9N2h
15787	payment	1397	1397	1678	1	1	7624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBX6PHcgZZzaRDN9W2P8psaqoaz8NMQfjBRmsVKt8awUatEgM
15788	payment	1726	1726	1874	1	1	5885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZFNM9hnJveXBM1rWB4cpeWof9jfPx15eA1QKiAkYubcqZApG
15789	payment	1726	1726	1874	1	1	5886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqBVLX3NauVw3QdordbCk3NiihyWJpwe3kpdSzxx29TXUJ9dK
15790	payment	1726	1726	1874	1	1	5887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWsQ7TQJiva9ipLUeesshPL3wvQztCEB6d4dZ2uYmBXG2RDc5
15815	payment	1397	1397	1678	1	1	7631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdwdkNQLGc2GD8pB8aHJK5RhdpZpNt8gKc15PG42UVcBVtjHt
15816	payment	1726	1726	1874	1	1	5906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqDxqJU7xqpmtPBK4xpu5MTp1BMMAuKUSTNMx7GfbSZxDzfKP
15817	payment	1726	1726	1874	1	1	5907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr6yKkMu97hapYVBqHPnXgcWxbB8WaRvQ8QTVnEeqbjreMrJ8h
15818	payment	1726	1726	1874	1	1	5908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9dkSQeDDKPFun7VmoygHscdj4MykAJiLBXH3g7cPnwWocvuD
15831	payment	1397	1397	1678	1	1	7635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe29en1eNoPYibixqVavhB3j4Qd8RDErixnZqmoXX47Zb5nDQs
15832	payment	1726	1726	1874	1	1	5918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj8omdQmgUg7N3s5MPEeAHJNcvfLr4ortM1VkppzfN5TLoZzn
15833	payment	1726	1726	1874	1	1	5919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhS242BcLSyLJ2zztuHyCUxmoVDD45c46E8wUqfGZKFo2bAwX4
15834	payment	1726	1726	1874	1	1	5920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjdR7GY6DCtea91xeswXRFBMSAC69L71NaPHmtmehhFGvBX51
15852	payment	1726	1726	1874	1	1	5933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmwTV7sSB7X4z25PH8TeBzGaWc27FNiFUq74b8o93LbjyLCQ
15853	payment	1726	1726	1874	1	1	5934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfG3iMCCLB2MdraSRwUwGNePn8rssoNGyxkf1LjG89rBu9trLW
15854	payment	1726	1726	1874	1	1	5935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7RXG6uD7R3jPB4U8jhiiS6wxB6vViZQ2pt3Muw9BszmY5Xpx
15923	payment	1397	1397	1678	1	1	7657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaghRYALpsRKNpnkzBZNQM1hsmAUY6SZFvrZBHBGtcTX6RMo3
15924	payment	1397	1397	1678	1	1	7658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyFNhFpPQmm9JWK3mRbQvLCCL575yZcsfP3LzQEMRnjSoQnc9
15925	payment	1726	1726	1874	1	1	5984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FzBrNvnBpNvCuHauPNr1QcDhUbfiSsiLXXv8o1uMeneFeoRU
15926	payment	1726	1726	1874	1	1	5985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNZGTNgvF4UjuGg9PXGH6NWbog8SbRs8JwsKQe8UoiYA3ahNt
15927	payment	1726	1726	1874	1	1	5986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eDEt8LTZzwFncogkTHu5xPATVp7nVZD2V69qPdRdTmGrtARa
15928	payment	1726	1726	1874	1	1	5987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2TdFpPxE4AyUW63YZLE5MEP4Pc1Uptw6VsgJtB7iMmLorAJP
15929	payment	1726	1726	1874	1	1	5988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23TpVCB2ugWdZ6jSUBC3h8fUgsmaikQ7DSrTZ74qVSK95b9tr
15930	payment	1726	1726	1874	1	1	5989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqSdCXg2Pok54ywzUtQTWxefxXpKHtjATaWBTm649w1FcBZAw
15952	payment	1397	1397	1678	1	1	7665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqrUA95LxsTvie5SQShLV6SonzQGNNr8ytkgkdCQLbjoafD7X
15953	payment	1726	1726	1874	1	1	6005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaVDbojjTeGE5LgVQn6GBdnmctCbBbc4qU7J6Nf8vKUBdixMn
15954	payment	1726	1726	1874	1	1	6006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdK5uMn3pgqfhr8Q1Z3znCuPqvsRzqyv9HsNUKyZusknwaHCjp
15955	payment	1726	1726	1874	1	1	6007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQCFgUEbMZ2bmXbqiFrf2NNwuS9UCUcPVkrNtHD9D2jLoUitE
15956	payment	1726	1726	1874	1	1	6008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQbQKVhVcnX1dLnQDFcRnJqVXLtdYzVzzfJLVTeguU7nqJts1
15957	payment	1726	1726	1874	1	1	6009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8GE3R7ABeBRadqzDqaPtaKdVGGCaVWW5VQxuFKHs4okLzSee
15718	payment	1397	1397	1678	1	1	7607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdDFeRKdBseFTM1swvc42C8nuYazhfBEdFRR9te9nVRjXcLCv
15719	payment	1726	1726	1874	1	1	5833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZnUqQ9CzcEkKbxdmTW6MSPjxo5z6hRjZEzcpcsydM6rMHu2w
15720	payment	1726	1726	1874	1	1	5834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAoQ32hueVELi193jpbjbWhKZLZQ9TJEymLK4Nk4S6n2kqWyG
15721	payment	1726	1726	1874	1	1	5835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsVWqJSncPygExK9eZTc1LxUiF4NRCYhR8fZSvyehk9JarJSd
15734	payment	1397	1397	1678	1	1	7611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19w3FrCxAaKbJjnLTzvXSomh2jpfQPax88HteEidqnMpWeVqr
15735	payment	1726	1726	1874	1	1	5845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZkKgXenzsPMwJefRZqKxwqCDVYq4f8eAqCFQh17rshsXe6ko
15736	payment	1726	1726	1874	1	1	5846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1pBLqFSLbXDKmcgvXRNmzuhHK2bbQrcExi4yS4tET69iLhKt
15737	payment	1726	1726	1874	1	1	5847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mDrWZTc4wRqYn7Uwxu3KiV9gboTVzpBDPd2QLEL2WNkcDRne
15783	payment	1397	1397	1678	1	1	7623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY1ou2oGifCyLQatKw23Yr8sEGbQGwvNHL9bcbrNz9buvzgAZ
15784	payment	1726	1726	1874	1	1	5882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMg1nJEa3zRiyQQ4RaxM5DbqtHRQGQ6SrEHeQv4iruLxMBhXf
15785	payment	1726	1726	1874	1	1	5883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHwAeLhAUL24P6T1dMH5TT56XcjQGmeYAxHES6uVKGYhoYDUw
15786	payment	1726	1726	1874	1	1	5884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeoEkQGmQ256BeTNgVM34ciCoWqczEzGwFTEWDyrWz5WUDPhW
15795	payment	1397	1397	1678	1	1	7626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsH1beXU29BnYFvpPPt8Kvotd7tvp1YWzy5zfXcjUKyA2pV1Y
15796	payment	1397	1397	1678	1	1	7627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRsDJ2sSxx9BL5JQiRaWrQYo5B56sFELSxrt6Ak7So1WyMrRqM
15797	payment	1726	1726	1874	1	1	5891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaL99MuKoDZwkxfKxCE6489Qd1DiykjsNg6if2TWffbAk1MoYf
15798	payment	1726	1726	1874	1	1	5892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRggTbZe2qtrYYHUotbWrjtuFPBgCfvwi5XMDES7SpMqqZYJ2H
15799	payment	1726	1726	1874	1	1	5893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNtDXTzsaLf7DhFXVj5XfbdCGxV9Cvxh2rwPSigTi1HCTrpRV
15800	payment	1726	1726	1874	1	1	5894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVcPktiGms8eGsdX7uBDF2v8HrhUsGw7GDkQHGr5Rw7qRh9JP
15801	payment	1726	1726	1874	1	1	5895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMfSwGNtLdbtenYoGZy5AZaQDcMq7dPWu3R9CgnSUjthaTTE
15802	payment	1726	1726	1874	1	1	5896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJeYpwPzpFYGdkhYhrnWFZPwxXg4ANipt6bGijqwxLDwd6z1U
15804	payment	1726	1726	1874	1	1	5897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPawGXUPHSVU3hzPRwvVcW5ZdYCymzgjDTtk9dGi9htcp4Ewqs
15805	payment	1726	1726	1874	1	1	5898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiu4w8iVs4vKDK5x2tjQycLBGCyxCvAhWnMzDSkYo4frgmxhh
15806	payment	1726	1726	1874	1	1	5899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeQahnCwPRjpmzUsU2Phygwee8ubHC4TKyAu7dKbwLz5JsjUx
15851	payment	1397	1397	1678	1	1	7640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3m49nnNCsFoo7Bw3QX56tJEdmSCrYcMFbaUSkki3eMxZZgkUX
15879	payment	1397	1397	1678	1	1	7647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTTjRMCzVFo2T6kJqHfhqURNeZ9mZZCu2FuDrsWPMFdiFUcu3
15880	payment	1726	1726	1874	1	1	5952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAy6P5Kbf5JoqLrCn5oD7qwU5LybvvUHDi4vYsW74J7L2HbFc
15881	payment	1726	1726	1874	1	1	5953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdM7eEgvfBn98ASQamWVREiaY8vqyrLeC3vR4atSftyrWQfZbj
15882	payment	1726	1726	1874	1	1	5954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyDYXqgaNWe9U87hLMydAStRqCJupbDXtLgKxNsAZxXi2EPnF
15902	payment	1397	1397	1678	1	1	7652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcpeV1d8soRdowZhRDMsXFSnYuG67qdesDGAGMnXMxx24w36A
15903	payment	1726	1726	1874	1	1	5969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Ryp7CM9wNkBu17PZAeh6f7cXVA34kViJCmVwFD3HjeJUca1
15904	payment	1726	1726	1874	1	1	5970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GDvqhPstxLminu8ntC8dxq6kTYK6CqHxqbt7jmFX8zw1ahXu
15905	payment	1726	1726	1874	1	1	5971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQhHGwep6TKPtzQU5zrSqiUmTgiQQzYvtCWKNbmZjL87tiD68
15911	payment	1726	1726	1874	1	1	5975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfA9CHEsVzNE7txkxxqzbCJkptecbT84qY5kbiDqvwDLQ9sKQj
15938	payment	1397	1397	1678	1	1	7663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5Y1vii3Q3BpPZjU8HrpJx2wThCtwy3hi7z5hAg1bWmxfcWvd
15939	payment	1726	1726	1874	1	1	5993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDXuiEXJdutYRssFu2YXJFbESi3wRe25uQUKPVjgUJDnTxxj4
15940	payment	1726	1726	1874	1	1	5994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTw2AsUVJr8ZLbu7DHjDJmMcwM8qt1AbSezwErfF2tiCRD7pG
15941	payment	1726	1726	1874	1	1	5995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZde1KWZgSt7s2aFmsaQXicfqB7N43fe9qYZ3mAagjGbVAcdhAD
15942	payment	1726	1726	1874	1	1	5996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7VDeZ7fnGQUWpZHLH5uCDUAoorx3faskLQgnrWp8CALRoi2i
15725	payment	1726	1726	1874	1	1	5838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXSJtYYVYTzBFcjqpYb3yKP1Zv135kzLNSuBs6uApJowYQJcY
15726	payment	1397	1397	1678	1	1	7609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKW6L52BeMpR1eFRwMtsdpFCpkhNH1V2gqBDcbJ6iegABE7Sr
15727	payment	1726	1726	1874	1	1	5839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgjNuKZs3YuTy8pWR2LKJdKPZYA3cFZbju9b3VkN5XSCbDPC3
15728	payment	1726	1726	1874	1	1	5840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdZJ2fJqtswKuKCs8Kp8XJezQj7bk5UP28h7xkGVeXfvAfCgG
15729	payment	1726	1726	1874	1	1	5841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3EMQuC8PdgPw2R7oDVGFZg8pDRkbJiGfJLjtd8EFxW4Aje8f
15730	payment	1397	1397	1678	1	1	7610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdgZPKkVsLsHbuXDnFNWpR7eT2r9UkQnPLHtUiayvJaMUBAHE
15731	payment	1726	1726	1874	1	1	5842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RogbEDa66p6d1LBdjC4pS6xRbvzCmtT7T9df2LfUnm66quLy
15732	payment	1726	1726	1874	1	1	5843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5sJk45En21XYuSgJ79fAsMUvyP5kAaG8FwLjRe7HjXLSqng5
15733	payment	1726	1726	1874	1	1	5844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmqEmDdms2M6wrsjbBHVZgKZMCN13bXuBedtdQGHsxjHZCBJQ
15738	payment	1397	1397	1678	1	1	7612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9VpSydkn8a6jvwPuWZZz6x7VYxzxNmfT9Xcfd3txPTEzSNk9
15739	payment	1726	1726	1874	1	1	5848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrmhrfjmVpdXEw6QCNju177ry3sSWERA4S8XydTwKqM1jw2iP
15740	payment	1726	1726	1874	1	1	5849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eBjN1DXLiYNWYUNfKPBMychWmv9KdrWhZwCQ58xznzuWAvqs
15776	payment	1397	1397	1678	1	1	7622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZabtiCrPmZUhhGEBQfHNqfL9Y3a63WdNGaENkuaV12Wvnf3Q
15777	payment	1726	1726	1874	1	1	5876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVSMXz9iTZ7hyfjBEH3MDs8orwpPjeq1EF4hm3AfAxg2bYetu
15778	payment	1726	1726	1874	1	1	5877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxYYY7U1QFzVqy8iepvi9FwYzC9BHXZvxGt7vBgFfHY7CiMkd
15779	payment	1726	1726	1874	1	1	5878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7PyvNErpNNF6bpgbyTG3ASZgi5EV1NBUH9Gbiv6eq6tAWNVq
15780	payment	1726	1726	1874	1	1	5879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JjCwsyXkzeB3xvv7omDZKJtYc4XjfRHVPFiE7aLhGG8LH4xm
15781	payment	1726	1726	1874	1	1	5880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZ7EeVoD9shh7xc86Kh8mbm12TjqgqfWxN7J2cZigXWDLj4w3
15782	payment	1726	1726	1874	1	1	5881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7u9yaWdjnpoH9Rf7H72DTPz5xDVs59M39bKBchbHHr3ytAeB5
15803	payment	1397	1397	1678	1	1	7628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyfEX9LwUUEnXVd5oTKb7GBdz1qQ5aMf8f7psCYb99mbuXKjH
15828	payment	1726	1726	1874	1	1	5915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVxV8xwbYDNnkHiU3rQUGfdB9vzRVZdZj93PMMhaCWYoS5tJd
15829	payment	1726	1726	1874	1	1	5916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3Q76FGR4rpnKJWZRNi9f2nXJTfxU9Liafs9yiTfwNUT8c8Jc
15830	payment	1726	1726	1874	1	1	5917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRA5dyPoeHaye3qwW5KTsASDSEZfdiU1AGh89X5gRCeB8pwqR
15835	payment	1397	1397	1678	1	1	7636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXy2Xueqdd1esJdgVBw4zYSnmTD2K5j8JyxD94ybtakFfPb4s
15836	payment	1397	1397	1678	1	1	7637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7UGYVkFq7sm2zeVHkifoDzTcxc3kWpJkGyafBXqGoTP9hb5K
15837	payment	1397	1397	1678	1	1	7638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC9wAsTexCJQTUh4s5KEzNeyVjb9H4Rk3RpmiJBd7M91P4dnP
15838	payment	1397	1397	1678	1	1	7639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCw6Z5Zkv1ZuHSyMRQYasTc2LKtUfY9ZHgEBP3vMbkj8UtiPkb
15839	payment	1726	1726	1874	1	1	5921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFNQZCorrrqUJtPqgwiCbyaKqK4Vg26TPsmMxPRSJxZ4ydZ7H
15840	payment	1726	1726	1874	1	1	5922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykuLKNqyYT3La86GajLuzPwBBNBByCuz2igKbbhhxyinAijj6
15841	payment	1726	1726	1874	1	1	5923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDJ9ZTAwDfUARSfLLYiitUcdLVGjUEEzGZi93WZKa44kAhJo
15842	payment	1726	1726	1874	1	1	5924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqbzbVZ5DGaXYzdsnCwDTWr7ZzwMDr1Qc3jDSYuucdYLvdUgz
15843	payment	1726	1726	1874	1	1	5925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pXPSTzFik2KbdENYuPo8bvJGtYYhZ5UfCmdwi7rGWd9LSpPh
15844	payment	1726	1726	1874	1	1	5926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2iNzduvpgP8yW2FFWSdLLpcwoPSmGkiEWjMoszb6nijXUguGn
15845	payment	1726	1726	1874	1	1	5927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuHvU21adQEWsekXEN2MdKNMwUnz8qNqL4wZZcHWCEE5LbpQr
15846	payment	1726	1726	1874	1	1	5928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZQE34faT3vSuTYcLq2682819TY7UDPYGohsg9D5xsSHwiQiS
15847	payment	1726	1726	1874	1	1	5929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQL9ckJWvHWD343Zn7ZpHoTxTLKNerjurYPBJHyJenZMJm181
15848	payment	1726	1726	1874	1	1	5930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnuPmdBgYpj7nYTKfAqrwHZxRTV4PqFXvNXCdFPtpgxyjWQrB
15849	payment	1726	1726	1874	1	1	5931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvjSFkosKg2VzZtJY1NJKGb1sTsVd89Dgqtn3Sw1ac9Etwsfh
15813	payment	1726	1726	1874	1	1	5904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRtZu7hcdpaRPNwZvFFPEBDuPh9weaETLYSumdhrHWE9TRpGn
15814	payment	1726	1726	1874	1	1	5905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf5ihVppdWdSq9uFE3RPwBTXQ6M1CcpxtVAvF324RSFsuZx48
15819	payment	1397	1397	1678	1	1	7632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LUttCXjupEwyMWCCyFA2PNC1k6q1NkkZ2MDyTftJRZeT3siS
15820	payment	1397	1397	1678	1	1	7633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD4rJkvCimz7ErqxuuHNpFMppEbLguSrz8C5gDUHz7mxk3Wmt
15821	payment	1726	1726	1874	1	1	5909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYyZgSsvxLWfAV6FDb4fCtivCDbYofEySa5BdqCCYPPb44QRy
15822	payment	1726	1726	1874	1	1	5910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJSSu9qNTzPoLXuPwP2Qete3LYyV6T9aVKC3N86bdq8e3zTgQ
15823	payment	1726	1726	1874	1	1	5911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbviKYXYrN5LisQA3rrMrMXd3dRU8qsaQXTtxpwjCkpRcwUKi
15824	payment	1726	1726	1874	1	1	5912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7kMBoVcFtk7En1TjZSEajReUV2xZZu2dTMcBpQnEUBnwUJ5F
15825	payment	1726	1726	1874	1	1	5913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6kYAyZanVd6GKSp3RN9Bvbx9kEfaJ9kdq9ZJ7hq758rbmiYJ
15826	payment	1726	1726	1874	1	1	5914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbbzf6DxNrXaABLm6chkogRmDnDT7GH4JDAuD2vfNLNWEbqAA
15827	payment	1397	1397	1678	1	1	7634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwQrT9Z46UvHunSFhVW1toDBgL2VSv2DmisNSwx8ednG9Y7Jx
15861	payment	1397	1397	1678	1	1	7643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9Q66eFdERPKS2t2Y5pxs2fZ17Tvg8Zv52iAsp6NKf3UsFPpG
15862	payment	1591	1591	2100	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ki92FeC7JZeJ2miT5EBgxR7npqfHKp4DfZ5nPWqTDBnTZvBh
15863	payment	1726	1726	1874	1	1	5940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZHzUwszrxFDKxvGE4NoVt6L1FgG3C9CYjQoHUMUtkf9FSdq1
15864	payment	1726	1726	1874	1	1	5941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ6mTcSQVhqw6Q4UQfhBLNBS12cdRKrCGLrS5WanMaBs8eBDyd
15865	payment	1726	1726	1874	1	1	5942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ABbiV9a2NY21znZ243RjLvvemH8DyLZ44NRNvk7yqGfVfsUA
15883	payment	1397	1397	1678	1	1	7648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJ5WwqTHh1H5QxsWFdwany6RZQuMbXxWVBAVFbyHVxNFuoWyQ
15884	payment	1726	1726	1874	1	1	5955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQXwnwWnWVF8vfNX7a6wUVEw3ktfsYtuayujM7SqcDsRSmUFd
15885	payment	1591	1591	2100	1	1	1	717000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYno6kLTV7Xcs97XfHCoZxnWYiQo2LrNYYYtr3kh7mmsQwvurFT
15886	payment	1726	1726	1874	1	1	5956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKFRkXaEouSG9HBUNNsTHRd1yo1ZLkjEGa1t3nQT3H4T6Y6cv
15887	payment	1726	1726	1874	1	1	5957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgr2m7UCExnihNw245myVUyPXBPL2c5pUUmu2h2cSHcyWAzpe
15892	payment	1397	1397	1678	1	1	7650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsvYLHPuEvfk9D9wLK1MG2YqByTH5iNrUsQ64Yt39wqv8GGgZ
15893	payment	1397	1397	1678	1	1	7651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYKuvNLVSRhRtnzHnBhCGZGxij3GNc68EcXkmhAMYEVswoHis
15894	payment	1726	1726	1874	1	1	5961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPM7nEa6ZQWokV7JT8vgtkrL9VQGZ8iZH4joPFkHXSsN8kKLnu
15895	payment	1726	1726	1874	1	1	5962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTu6YiJzAxpBatZYN2TrqLz3MDGFukLxNECS1oL5Y9Swsd1JVE
15896	payment	1726	1726	1874	1	1	5963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa13YhRF2FqqnZnehSQvJYb1PseBhWopybMTrB7R9CCc8gDQAC
15897	payment	1726	1726	2101	1	1	5964	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnfPK6EoQRpv8paWPw71Exb6Zdp6s5Fv2vphLgn9FWwNm7Ttk1
15898	payment	1726	1726	2102	1	1	5965	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoZRLDw2zx2ynZcrBsjPfdiZ4cuduUjp9JAtAwatW56Pe6m9Nx
15899	payment	1726	1726	1874	1	1	5966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTGjDuuszTWGb8N4hBps4P75XeQGS1V8wu5mnESAjJ4kesw6K
15900	payment	1726	1726	1874	1	1	5967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpa4CUh3BuHGERasvaBvqAi9spVj6RxoVpTXWmyjucsCpCpRCX
15901	payment	1726	1726	1874	1	1	5968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNfSUoJy4xk16zGep6tRP9oUrimeHXhv924WV3BcxhJ4i76jh
15912	payment	1397	1397	1678	1	1	7655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWgu69WDJUyetfKSYRdRZPRLWfcDZ8DzAD6kaibmHVATkexdx
15918	payment	1397	1397	1678	1	1	7656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTht4TC2aTd5SzCyyKsEHEuz5ZW3xsqt71pkuK1vDij7rUNwyZ
15919	delegation	2100	2100	1591	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdoXjSZGLvL3w8KFQ8Mgoi2piwQ1sPEVvqA4WtQgpyzoWAgAZ
15920	payment	1726	1726	1874	1	1	5981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALJRjcR4BeGBtkzLrU2upKPbDfpy4v8CAtCkXoXNCe5LpBKY5
15921	payment	1726	1726	1874	1	1	5982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8usHB6ubqTNQDKsJMN1nBg934CsUqdTENA4cFVRKNyih12Lc
15922	payment	1726	1726	1874	1	1	5983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAFuJ44ek39ZxRDfmy4ygyUG7WanTf4gAeUBtjyrzcH79FPTg
15931	payment	1397	1397	1678	1	1	7659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqt79gfLvp55mYQhtPUaJzjnmbjUvZh5bfWZux1zmj7hmoSTL
15850	payment	1726	1726	1874	1	1	5932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLZeBjoYgFvWd8rHSxN5YxAwsPZbdeMVLY3xk6C9j2tzPfucN
15855	payment	1397	1397	1678	1	1	7641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfbB6pbfNcLi5oaKuYxH6H9HJd2CxB5UsVjoCiEYDasAhjh4bL
15856	payment	1397	1397	1678	1	1	7642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nUNYVfxYPzPda18o5ABBKqSaAzRvmMD4p2HDjyZzjaz8wjBt
15857	payment	1726	1726	1874	1	1	5936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutpD4mmTpnucWaih8dWTxzHQMRG7WdjivmpAuEMWBe7vCspMA
15858	payment	1726	1726	1874	1	1	5937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGiNAZVomwitPD3fTuYvuZrkW6qpDK7Ljhnkv84PoQvhRUnG7
15859	payment	1726	1726	1874	1	1	5938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhzr1k1uYs9RQkFwT94xd2mUrGD7gfH4K2a5MgnheGuhQBbSi
15860	payment	1726	1726	1874	1	1	5939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndE8REvW864uMhqZ5DJZ26xvmLkNtfZvaSEVBhrxKmAuA2aGf
15866	payment	1397	1397	1678	1	1	7644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSW4Aaz9fDqwheLhPAqKsSLgmd7hFFXuFta1e5jhzhWsJCu3A
15867	payment	1397	1397	1678	1	1	7645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoySbHbs3mhEPe3Ran77tnp9LZ8po8ksbcB8R5rfY7o9J2Lvj
15868	payment	1726	1726	1874	1	1	5943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoozPCVkFVmUPXqEDQPzhjNcGNpSLqmoaSBALZrU8RfVSJRAea
15869	payment	1726	1726	1874	1	1	5944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWaCGiPUb7U9op5qYNYzu7unxZ2pcQSgDxjhGuHkJZRAxrhGJ
15870	payment	1726	1726	1874	1	1	5945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG5SpZPksPzS2MCx4jpivCeTxRxDHX8kHgHc6FfABxWutjDMA
15871	payment	1726	1726	1874	1	1	5946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMKyUDxNGRfvhhwyp1fxdcyarcpMzm5Gzjtw51gV87GBEabyg
15872	payment	1726	1726	1874	1	1	5947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWBHE75bUsNME3jXF8VxQVyksj7X1Lpti6g2vTYg8puDYtZPa
15873	payment	1726	1726	1874	1	1	5948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGkMCG8rtsLVbqoHR2npPHsVza2EBNxsT9jCTv7TTAmH1BgP4
15874	payment	1397	1397	1678	1	1	7646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3w2LEG8HJsF1UUVaGP8iKcDBom7rPwbi8Sk7BTRHszjGWTXW
15875	payment	2100	2100	1591	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNYzqhdPHNp3955QpfizbxUA93jbPniCwhjWwKN82xgfMsZwk
15876	payment	1726	1726	1874	1	1	5949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gAMmRihQtYPCA7wfhF6ycVR2o2cWx5kFRxre6ikKajw4r6NA
15877	payment	1726	1726	1874	1	1	5950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMWiW3FwyRWMBE9mFqQtn5WX95xRDMSKCVUekp1v9zV5zEzUL
15878	payment	1726	1726	1874	1	1	5951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvPJSQ1CKyBrzhvUVVveWgKBaReFuxtsxSz2M9QSz6D6uxKas
15888	payment	1397	1397	1678	1	1	7649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RstaSXECrZPUqX4SLdasY7jiYWaUML8mDg5HZSGBwNHJwcvt
15889	payment	1726	1726	1874	1	1	5958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CQteTGk9cwPKNLfRTTvsk1ekR3J7rEZm3ovyytLTHfieaUCg
15890	payment	1726	1726	1874	1	1	5959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcLDQw5oxqEjAW7JmHXn3GGqHJLn6psuWNBNswobUd5Fbexbg
15891	payment	1726	1726	1874	1	1	5960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbj1skqm7AEbv8BEHUgJHD1w2AK39BBzcqbY4khH4Jc8x1VfQk
15906	payment	1397	1397	1678	1	1	7653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYngeQ3kQXHj7iYKpdVggdPJYqHdcPh7uWKJSWA2KsK8ocagdW
15907	payment	1397	1397	1678	1	1	7654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJqVrG8TXuY7F2TNqSQvZoWJq3ckWK15tvpqMoXNCfti2aoUE
15908	payment	1726	1726	1874	1	1	5972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwxVXauvUXNejP3FZDPa2FAvqcEFXtz1Tcr3cdg5WaztL7myY
15909	payment	1726	1726	1874	1	1	5973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGK3ojWT6X8kmukXjtCUSYfUHcjgJsYEcYvdiM8fkAQGkS523i
15910	payment	1726	1726	1874	1	1	5974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2t6j2aUezWCqgqwagFH4jnYTorrth3Fx2q6nYKcSF2hhZTv3N
15913	payment	1726	1726	1874	1	1	5976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DTZuz4Gnzhej6FHrRRyYsviBZLdeNZjYCpbaXrt2MgdsJfaN
15914	payment	1726	1726	1874	1	1	5977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7qHEwj9PSfyYdjJE5SVyFffuomXwwFE4kWUm9MwCWHo6E4wy
15915	payment	1726	1726	1874	1	1	5978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6r156SNvjGpUy1ZgjetGEMNvWfSehDcoRSEk3cjeBh98XRY8w
15916	payment	1726	1726	1874	1	1	5979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUW8Z1vQmZy36zjak4AD3oWVV33HXBHZQoM4SoNSmfvPSUcFw
15917	payment	1726	1726	1874	1	1	5980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MbZwH5Fgy5mYqo5A7W3ipruCYvmtgQzAdLAfStGXcH7fy2wP
15935	payment	1397	1397	1678	1	1	7660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKWyfwFzZHJBGMnQoyvVCqTTGZq9c1QnCRx2ZaX2Jh3M9cxbp
15936	payment	1397	1397	1678	1	1	7661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YX7MuQZu1ZvmxVgDuxkvUvQpUz7mkuvnCsz4vfzjoYFvpUWd
15937	payment	1397	1397	1678	1	1	7662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnp3TktUb4hBMjs8UpvPGMRUgbXvtmruXi1DKsJrrNc9LyftdB
15966	payment	1397	1397	1678	1	1	7668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46cy6DwrufjjxqE8HJGH92vG571SpY6DkkCMrXxfYYfMrhoaw
15932	payment	1726	1726	1874	1	1	5990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6QGrfm7aoMyFrYCXX8DFx5FY5XM2EQyWumTW88XaZudGLHCnL
15933	payment	1726	1726	1874	1	1	5991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ5wyfDXi87efXygx8e6MLCUdpixSv8vuQaBKenDZngfc3t3B
15934	payment	1726	1726	1874	1	1	5992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Qg4Dd4MATLaGmPGqKqgpPReQesZx8vWATP6bWiQk1vyXghqS
15959	payment	1397	1397	1678	1	1	7666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTiUs1XCVyeMazyvvTevdECFEegF86d8Ls63zsnoBwZJTt8DW
15960	payment	1397	1397	1678	1	1	7667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQxmRG6tLrQCk1fcoWnaiYC6zmh75jKLvJvUZyL9gJfZz5cjC
15961	payment	1726	1726	1874	1	1	6011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCA22yAaF6ERxLK239ewbv47vwZ8s1ZdiAGri3hXAgsWd5CRW
15962	payment	1726	1726	1874	1	1	6012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGW4v98M1mowRZRY5vDmnswbXJHLxumW5kBY6AzpEpjn77qyo
15963	payment	1726	1726	1874	1	1	6013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTX8PvevvFLXCqducLyphgwetzifcDrJfo3vBNhYKNy58mXVJG
15964	payment	1726	1726	1874	1	1	6014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFKH5xYChqeQnLUrcXjDqrkiTWEGwDCJ28GHh5jYCJFagPSD1
15965	payment	1726	1726	1874	1	1	6015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRzGRDJ4zMnzoRmqVsvUon4NqryABtyUZrKgTPcvDpP5fxnff
16023	payment	1726	1726	1874	1	1	6058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eu5PXg1AnUxV2bD8AqtqP5TH3UKxJiPzDFykJrnfK1rjd5G4
16024	payment	1726	1726	1874	1	1	6059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqpew8k9Ez26oEhCLeEwRmPiWFCed1Heij6w5puUmnzbjautZ
16061	payment	1397	1397	1678	1	1	7692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibvJQf8KhLpLRWLVTwJPbhnRxziY8MXhJiyMFHpkTAGUSNvmq
16077	payment	1397	1397	1678	1	1	7696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmJMbt2FNN8ZCSGo3ZgL2f1XozwGTZSBGTB8asQoPjCvhtjcN
16078	payment	1726	1726	1874	1	1	6099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1MCkscd1WTbPkgDbjx1DGQQmYgD5T6qeNg2GuUvpoRxvWxNs
16079	payment	1726	1726	1874	1	1	6100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9rfe3QSNkhHb9QwSvCsUbSzaNkmsUqorfQnqisTSWwBD1xze
16080	payment	1726	1726	1874	1	1	6101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxS1WTeNthGrMxkDkk8Bp1BeTQ82gpCAcZ1q89q2A6ZdowZyuN
16089	payment	1397	1397	1678	1	1	7699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5dNi6VFycQzTfJbHFSrQcQeSwfAa5yZ2Hf8CxNpmCJRgN1Dm
16090	payment	1726	1726	1874	1	1	6108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJbnPKHbLvLyq6CGiMeJv4xQkyFAAhMoMf5Zjo1T7yE9K5Ece
16091	payment	1726	1726	1874	1	1	6109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdTvwtwSUp7eEwGmfPGa6egV2gye5oUjs3tCV7iyAPZZBfuSy
16092	payment	1726	1726	1874	1	1	6110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3fpe1ri5qRrQddN1AU4sAJVoy3dZZZuF3qrQUvhJAyLhy8i9
16093	payment	1397	1397	1678	1	1	7700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiBb94niiPnMXYzxz6RmPz7uUNPa8978xVjY1W19wQcoNoZ57
16094	payment	1726	1726	1874	1	1	6111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pMgz2r7zxpiz8mbyzyS4kNG1JrzCrw7dzH9bvAEA4XqipGaA
16095	payment	1726	1726	1874	1	1	6112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EfU1oMWbRoNLekDe3gqVLkqguDTPFTmhGWggKvaXGiY5GAuc
16096	payment	1726	1726	1874	1	1	6113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Xtskmd1AuoS5En3fHrzAwatJtizL4FbdKwqaaY1tQEafmzdZ
16116	payment	1397	1397	1678	1	1	7705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACsmW7CUXrxgGU19JVCBMR3LkvYW2Wd2w2o114huZNvnC3uAH
16117	payment	1726	1726	1874	1	1	6129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQ1qYjmsWw3dXKtuPoDDT8hao7rxgLRYM6QyojkfhLpYNtoWs
16118	payment	1726	1726	1874	1	1	6130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gwogfkqvhcKFWgch6HqeMRS57yXfXwokCbmoyPoZLhXkNwEo
16119	payment	1726	1726	1874	1	1	6131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQzz3kp1vmuKJWCK6PU3RkW9tJpgDoGMao1sQKsjriHvZxvQE
16140	payment	1397	1397	1678	1	1	7711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwb49TCv83LgU9XXbUzUQr4N4GqaNer7pqikiNyPVFEbf8RS1z
16141	payment	1397	1397	1678	1	1	7712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1phS5tc5yvym4e9L92gkbVm9PAq3GgAr1hvpktp4npFBkSoMU
16142	payment	1726	1726	1874	1	1	6146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjS7gZmTpGtYARNq4KRkYLWRKK8Uxzp4b53wwoY1KUB4KhrrA
16143	payment	1726	1726	1874	1	1	6147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuoLQYsKrFU9vuiqpfNrHqERHJWo1sBDahM9ArVb72TZ3Aumc
16144	payment	1726	1726	1874	1	1	6148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1FPnn3KRnQKcE5fHsMmnHMFu1abqmbtQ4YRDfrLhT2XzDFtX
16145	payment	1726	1726	1874	1	1	6149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM3HbwhhCPuxm8CXMgZfB7aXy6jhqXKN3WSEP7w1XzNkgeobc
16146	payment	1726	1726	1874	1	1	6150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiN266SNjphYxSUTrfA9a7hgn85FHGqiA9wTGwNxDnJfkpoKz
16147	payment	1726	1726	1874	1	1	6151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1oruB7m7CQ3YPCEaGXDovK2va2gY9qoh5xEzw86XEM4fyT4P
16164	payment	1397	1397	1678	1	1	7717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZuwMF6x3cXEnBu1o6521sNyVAs8USrHS55tqzYb3dbnKcMCS
15943	payment	1726	1726	1874	1	1	5997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8PQGDANU1NAmvo7YqKZUgjwXDA166Dh7by1S9AaRmAVzMTb7
15944	payment	1726	1726	1874	1	1	5998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQbeNbkNT3hEh9LCMKDV1GBKNg3vT39sUgqgrA88xTUn66u5U
15945	payment	1726	1726	1874	1	1	5999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufLNqM87f5jJJ3j7GQvBsds7VLFPBUtirXAyjFimqcRxQZYvU
15946	payment	1726	1726	1874	1	1	6000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb99zodFQsFPckB3PTbjXjiTJww9eFQNvj2Wn2Z2UzZ1Mvjs7f
15947	payment	1726	1726	1874	1	1	6001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdXDCn3X5vXFQkHWXi57vLRYtaRoSqRM2CqovZpH28cpYKrar
15948	payment	1726	1726	1874	1	1	6002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyUxAS51Fmac1sEdycsTxbJd243wvhqVnTbxzXuEHZMTMMGZE
15949	payment	1726	1726	1874	1	1	6003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDfsoYp2Bab1CSydV1YgPsiuSuYWxa1eeDSmmjhrPdAMfteEv
15950	payment	1726	1726	1874	1	1	6004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUmutjrtLgtyp9gyuQBZVjvBY1XPdN3DhhFDKfDL9gpyPY7mt
15951	payment	1397	1397	1678	1	1	7664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z4kaqYZetCmNYsFNHxMjPnX1KSzCW8ix5oTeY62HdFy582yo
15994	payment	1397	1397	1678	1	1	7675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9iF8T8HuwEhUM4qHBBGcFBLCJY8VzA6ogGjCqyETeF4JiKiV
15995	payment	1397	1397	1678	1	1	7676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAMbxaCUcRutYr86n1Htm4GkyiGXdXVV8caQVKpszdM6Rrcrf
15996	payment	1397	1397	1678	1	1	7677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2NuDrtkGu8ke6Kc5VKdGQqp8YMfWRuWnFoswBhBDBpjA4n6v
15997	payment	1397	1397	1678	1	1	7678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mo58esgH5PDhchq1e66YkwkatvFipn8NwLDPKBcYQMeps7K
15998	payment	1397	1397	1678	1	1	7679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRywu1PgugQ1HPx7vf9X6qR8Sqng19sMgTmNY4GGSJpfZdnQw
15999	payment	1397	1397	1678	1	1	7680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixDX9gTBQeXLCBZqGMUQjVW9kFbVoiMXsfSH34jcbXo6bj635
16000	payment	1726	1726	1874	1	1	6037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDxLgZcxQ5VBfJ53T2KpJDcrg7apwxM1i6cmFLYAiw4kXouZL
16001	payment	1726	1726	1874	1	1	6038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGjrZ1192sNryBEACg6PyVnwj7QWzk95CrtvkdKMDpX4kd9qg
16002	payment	1726	1726	1874	1	1	6039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL16VZDq9aTjSzbXE8mM58AUWKFCY1vt5u7R8tPJh3kg3i6Com
16003	payment	1726	1726	1874	1	1	6040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsthe8HJgXMhd7BcunuhfBX8AY5fAnB6TVDi3kvtQk9SBv8bt
16004	payment	1726	1726	1874	1	1	6041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNYPEuqLPETB3uBwAJkGpYAtkXgY8HpY9FYqovPktWG89SBro
16005	payment	1726	1726	1874	1	1	6042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWgnZG5ztJhEAX5dpbBkkU1ZzqVxiSRnfGJDLG4yFPnZkfB1z
16006	payment	1726	1726	1874	1	1	6043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yEWk4AxQZYVgSwBe91cBSdVTpX4Z9cys74dra4u9r4y9Kiyv
16007	payment	1726	1726	1874	1	1	6044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxAuK3wsiDYq1waUjdTDXsm4xbXS8EcFcPhfS7t8uXw1eLGCi
16008	payment	1726	1726	1874	1	1	6045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ocHmmfRYLqyiNQxLeQuNQWpB1eqxydh4FG4HLF4BFZeSTZoj
16009	payment	1726	1726	1874	1	1	6046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzDLu5Gvjjhc4qiPniYm7bGxiPzU78m7nVhH1s4NWXy5Khxie
16010	payment	1726	1726	1874	1	1	6047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJCxf94cQ6rnZ6AiGFr84DhQFMLFwkAF8NDf9oS7DvLs7MU2d
16011	payment	1726	1726	1874	1	1	6048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9GE7ZGxQagnp4tPZ24yRniCAuQtrgdysXEFCgqMAnCmyQJCY
16012	payment	1726	1726	1874	1	1	6049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeXtPyR1xMWR6vbcYPtDGtyEVcne3ayNxQveQw2HwUvW99vPC
16013	payment	1726	1726	1874	1	1	6050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AQohVyoJ7Q6XYJPYwmpB1aChnDykHUgt6BNYMZjbdNfre5ae
16014	payment	1726	1726	1874	1	1	6051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCbctUk1BvVcmxQL1R7NZLS4sxJ7MLrEYSbiGxUaUghkWpFGu
16015	payment	1726	1726	1874	1	1	6052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ax1KWWGHWcxQHRMg1TU4qgb75Nzbouwf78zg3fbq3ZnQvfY1
16016	payment	1726	1726	1874	1	1	6053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKhu3MTJE8BXgtpDVJuqfJEYhXt5rw6CsaPgRVaYjbMkL3sZy
16017	payment	1726	1726	1874	1	1	6054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshSZ5yKp2BdEtEUeJ6XpXTngmCn7EXEk7zQGprsyPGR4nCKUp
16025	payment	1397	1397	1678	1	1	7683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWJz71L8Q51qejmPve9sJprYTx8HRySFgJb2dGo8yjywKc9qr
16026	payment	1397	1397	1678	1	1	7684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ9wPQT9PQwA5XSavqEMi7zuPUpMTdaz4D3gQrvPnGWvTT2EG
16027	payment	1726	1726	1874	1	1	6060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNM7J5yZE1VkTWAD3HvZqfAfzVuCGL1Arhwh6KmFBEVm7bmBr
16028	payment	1726	1726	1874	1	1	6061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ28kBhR4yWScRkMZk5abcR9We84YeHG5neZKRTwYWbPdi4yG
16029	payment	1726	1726	1874	1	1	6062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpAbJrPwbGABXRpPUtCNpjjFfW8HBCNRCRwC13x78h1uP5M4P
15958	payment	1726	1726	1874	1	1	6010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc45U4C42chBWoBf3x98EwYP6G2W2QZbNhQq4WfhxpjZTzwxEu
16022	payment	1397	1397	1678	1	1	7682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTszpfSdLsQ9wnZGk3YnkiivTRythqzwNcLmDYeGwLsu9oiTTU
16033	payment	1397	1397	1678	1	1	7685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzRfoZteMJCXpUKTPMYQNhFhy9eviwJNdkGDsp9dkDyXkKaQ7
16034	payment	1397	1397	1678	1	1	7686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCMqHsstB1Ega5z1ZmTRzEQdq6jnb99yvQqvZ33nr1uHkvrNq
16035	payment	1726	1726	1874	1	1	6066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUdmk51HKyyd3P5jcpfA61F1f4BtvqSytZn9HYdntWbgdAfQ3
16036	payment	1726	1726	1874	1	1	6067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwegvnU8BHZJNTChd4fW9qrg5TubYH4JbBy3RsMt87izFt2FJM
16037	payment	1726	1726	1874	1	1	6068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QbJYdqt2rwAfLZqyiPoE2qK4bWcgTPwWwgkbXCYjYTLv59H6
16038	payment	1726	1726	1874	1	1	6069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxVYxCEbQjkkrUCJQBBEfHx4zLmSR2muXgrKWRv6tP7Siqy9K
16039	payment	1726	1726	1874	1	1	6070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD7SNjxzRUb9JDGst6ba7dhGqA5CdJUKBURrWXCTWpTz1WSEiB
16040	payment	1726	1726	1874	1	1	6071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnccQtocJjF2i7R4drdGqtLggQCnUmfnJnePj6QX2q86WRgf4
16058	payment	1726	1726	1874	1	1	6084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoeyQrB63iGKQ4b1U29YzMhc3gS7U1ajKVdBE1KfirGgmj2av
16059	payment	1726	1726	1874	1	1	6085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCtBXUFS9f2UcaQ9MG8otCH7JdQPsAd8hYVXpSnC1CR9eko9M
16060	payment	1726	1726	1874	1	1	6086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kmNJLcAVjUFqhYqtdDfxVsJvDS6qyJjM5KFnoByNearRtXxE
16065	payment	1397	1397	1678	1	1	7693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzzPWtLnwvXrPBU2BTQswAypsc2KpRDyDdhgoyVibQMhGd2gX
16066	payment	1726	1726	1874	1	1	6090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBTqhnyxTetqFtMNPccGK7qGU6erMRjfjfT3EWvrCUmrBkrsP
16067	payment	1726	1726	1874	1	1	6091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJyQSSVcvwB8f98UzS1uv8mxm5pdGZb7ujHCRk6ZU8PKwstuC
16068	payment	1726	1726	1874	1	1	6092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyDJz1y1DZ18RogUKgKLfVzhTLekmHSX2CX5E4hUQqzWxmgb3
16085	payment	1397	1397	1678	1	1	7698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpW6bfMiHHfquuVMYoLJAs7nW6QGBqMGi6iGYfLU6rcDZpW4Vm
16086	payment	1726	1726	1874	1	1	6105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDAREu8rxVpmwJguPzf1V7rGCiBmtJKm3cPLUHQaTgMjUC1Kh
16087	payment	1726	1726	1874	1	1	6106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWtzsPNyJAmcXmYCuohLiVhoP1XyQ9RQydGP9WwoeWQqqAn2j
16088	payment	1726	1726	1874	1	1	6107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmJJeazskmzxhAXFrx978MWnjYzvjedVejuubDrU7UtYCapic
16108	payment	1397	1397	1678	1	1	7703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtjoWiGuE7ubTgpPcdRSqrtr999F4Fx3iPxAUQnAaxYVrjZxd
16109	payment	1397	1397	1678	1	1	7704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkevzCNLtTCeSt7EVJxYYwp7N5CKRV926Ak6wcdwzJTNQ535tY
16110	payment	1726	1726	1874	1	1	6123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRayPaCmmKhPgqdFT4qgvNyun9euyg1oeA1CDduH7i1NYViSoG
16111	payment	1726	1726	1874	1	1	6124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBYnVtwhxMAMeQh7KWQpyAfMXLKr5VvosKMSwp75odYWg1wyR
16112	payment	1726	1726	1874	1	1	6125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNJn3dPXccs2ywZUPcszcFNbsMUVHbgjFUy8yPSN2rfMTqoGX
16113	payment	1726	1726	1874	1	1	6126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5TPi6fxRFDMT5ECFVCjKVssbxcMXC1umCSC9MXwKT3gvBs8N
16114	payment	1726	1726	1874	1	1	6127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaG2dyqrJvTKo3g9AsvH3sQRBNqQPjMwYRChgF2znds6switJ
16115	payment	1726	1726	1874	1	1	6128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YkBoRAjAr2uiMRG7zN6ASmBiNVukt7ow2XLZisGqe6QzDPUF
16148	payment	1397	1397	1678	1	1	7713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkLobeXoDDHPpBLfKCmQmiFZXrzbCs5zGJ3QjVHuVhoLKAPGD
16149	payment	1397	1397	1678	1	1	7714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxP9RzUTRdLaiHuWsmHRA7kT4KnxHNFpXS8D3qQTRHhBA43rU
16150	payment	1726	1726	1874	1	1	6152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4iMNgAUhZASuJY19DJiea1upVdXsJXEzb7V51wGkJMM7cJLx
16151	payment	1726	1726	1874	1	1	6153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm23BffrTWJaX5BZYtvrhdPdUC1tkDb6U456miS2FhRYE9LPQm
16152	payment	1726	1726	1874	1	1	6154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvQdohsNoi2nJ5DfdNpdGGEEw75r66vEjFEHzeodNqUjnMea8
16153	payment	1726	1726	1874	1	1	6155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmbYu7Wg33yCFvFrNteMUdNaMPfKPWc1SZdccRjK8cjYxprRg
16154	payment	1726	1726	1874	1	1	6156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCkbXYfGqSTFLCcBLrUPF4AyqFqq6CXw4XZKHFvQjxfhBbqLm
16155	payment	1726	1726	1874	1	1	6157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDtmBgBRJSxrto8ZKNtnhEwHpgQcmmvKmZhV7kXkxrrfFghbb
16243	payment	1726	1726	1874	1	1	6222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEJdzVbjf78ysAgrSahdNFPTQXTHaQDmRr4JM7AdrrSDTKXM2
15967	payment	1397	1397	1678	1	1	7669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGu4iB2scAaXD7cSuus7zQ76GESgqNEDDJ2mjZYatZLWNPcs2
15968	payment	1397	1397	1678	1	1	7670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwms6TddSkMywDjZHynJ74CRjPd1cfNpd57XDPRqtToaNNiRaL
15969	payment	1726	1726	1874	1	1	6016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oJ8ykq9nKEpeAWdgGB4VWBvPJm3KbNaDo8QnBMtPk2zUsEac
15970	payment	1726	1726	1874	1	1	6017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43ZQzzM5L4VVnTX5B2untaQt1CxewVVHbHMchBhja451BVeG6
15971	payment	1726	1726	1874	1	1	6018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnZRZoDSGu9fzE7hsgn6HhutBhwGS6qwsyKHEnafdpg88sqcm
15972	payment	1726	1726	1874	1	1	6019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GFZ4cgLQHdVodrbA3XM2LqHXt4PpPuq8w3qL6R6Vc8RinQzz
15973	payment	1726	1726	1874	1	1	6020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRPML9teDZxZuXWCKDjCA45hhURMcK8EeCHjK4kpG6BqHh3oT
15974	payment	1726	1726	1874	1	1	6021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHFHk32oHDaYRJPZnPtqKF2TxP6iosbAVAnZvxyJkpW7EqxQc
15975	payment	1726	1726	1874	1	1	6022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwyHw2L8Y84eULoZgpc9Vmun7xFR1bZdhKwfEajudMMW8L9Xq
15976	payment	1726	1726	1874	1	1	6023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZnGcxzx6tFGGbdWW8f9HfKGgdTAp27y9xzU2fMX78VH7uJnV
15977	payment	1726	1726	1874	1	1	6024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYta5H1zh9vQ7jZg5XXSJfAGBUB8kXt5orJ5CYUutrESwzvLNmK
15978	payment	1397	1397	1678	1	1	7671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ8i1oFS37eUBHUKKFSWu3D5zmEycWT8Ew7QDhQ7G5ggqNN9n
15979	payment	1397	1397	1678	1	1	7672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p5rZXmTKaz9o9QCXqfDzAdrtzvwon9NepVyUbf8cwDZ2xms9
15980	payment	1397	1397	1678	1	1	7673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuXN9ZBz6hfe8U6YB9KAEDKvGRvyPuz7bmhSY4k7MYSTEqAUG
15981	payment	1397	1397	1678	1	1	7674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTdQx9T66UjuoXTuDpo9YqQLTWrmJ1bzQBu4LB65V2UAhnfoA
15982	payment	1726	1726	1874	1	1	6025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTkZqfMmajsZVPqFNVBJZHttYmm7VExVJvk4CWMA2UE1h7TDd
15983	payment	1726	1726	1874	1	1	6026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumz3gh3MMx3EbNqqSEVwMUjMbbL2W9mGufhTyfr3CNBDGsXBk
15984	payment	1726	1726	1874	1	1	6027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngQsvje1eE9U7cxNARcWG4LVNLS511HMZ6ZgXF7pQXTLR36Wt
15985	payment	1726	1726	1874	1	1	6028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDt2ehVetcc4oRafX19DgCatbwxCqyz7D57qj13FnfACVFPauu
15986	payment	1726	1726	1874	1	1	6029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2mpoTqU7ArqpWXG46pKYMB88jwyg4wiPjLB4MdpWpSnst4xf
15987	payment	1726	1726	1874	1	1	6030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2ybxjZAfyU8B2uB9V8apowdDHMHwCfm2KLVzTcFTNS3a5ZGx
15988	payment	1726	1726	1874	1	1	6031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaUvsTMB1j1zet5vLAXnG9eSSyDnhAs5NtYRAEAV4weT43mpP
15989	payment	1726	1726	1874	1	1	6032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPvoZGbbVcUgAk2W2GrtZr2jA8E6STePyVYQcQCjrbNBS5ab3
15990	payment	1726	1726	1874	1	1	6033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6dhQqd1vrXufcMJQBExwCrwxDVqc76XXQbAeML2JiLWrLXJg
15991	payment	1726	1726	1874	1	1	6034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXkE5ovJjnzPvbdf1CC4v2AyZbd2YP3LCdWubAH39ALAUwuAA
15992	payment	1726	1726	1874	1	1	6035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhfrVHy8MK9tqNhBEqKUBdFS67MWtrRykhqKHcmCuS9PJFvyq
15993	payment	1726	1726	1874	1	1	6036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9nmDj8W7QUE62YrnK9SdvHAdKzCVTQ4tsCvkNcB4FyUDPQU6
16018	payment	1397	1397	1678	1	1	7681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ayBVLUmTRqsDGWdHXew8ddiuJV3AunYFr3rapC1MEbdNFNoB
16019	payment	1726	1726	1874	1	1	6055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVPYJYqgo3p9EJKRMr52nZ6HBbda7VgR4ZEiadPRGhWcEiJV8
16020	payment	1726	1726	1874	1	1	6056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5XhadrMMVpsynDrFTEY1H9msfwEU2ZdcP5w4rWwc7Ksdf1Ee
16021	payment	1726	1726	1874	1	1	6057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVC4poqyUfJTfgJgzSVWarz4Aks3x97qHuQfHuBe5AYfnTMCV
16057	payment	1397	1397	1678	1	1	7691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wm6zfN4hREWNJQ51x5Zj9Nsjfa7jkyvVH8UzmtMTHUF4J5Sc
16069	payment	1397	1397	1678	1	1	7694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGvjAaFcbk68amBceBoDs5tfwttiTXEcNwC1qJARwTiF71Pxj
16070	payment	1397	1397	1678	1	1	7695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVEhpeyJDr69KqBiSnhvCLFgtBSbrcYsGxDCN7rjshv3ab88a
16071	payment	1726	1726	1874	1	1	6093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSq2CePWxnVV4exJzf9wRwZZgXR7DKM1CdPiVmjMrYDcmTSFma
16072	payment	1726	1726	1874	1	1	6094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNCe5KDKV4XqhePySoBwjzS4pgJfe9YrBdtbUmG1EcFSJn8Xh
16073	payment	1726	1726	1874	1	1	6095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxu4cZxcien1u5xY16W8CXwcbCq169bWawWoQAJaWMa35E1VTM
16074	payment	1726	1726	1874	1	1	6096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4m2Gn3baX69UwpFCJf7mEjBpynjqoz1n99zyZEy8mgbSC83a
16030	payment	1726	1726	1874	1	1	6063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVFmG97yk516XGjwtUcqE9nVkHFU9MwE9u9nj2qVd99wP1fyp
16031	payment	1726	1726	1874	1	1	6064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukZvTWBwf5hVVmoLHWe23MjtVLcSFJXb3sfu4Aw3QxJNjW3CD
16032	payment	1726	1726	1874	1	1	6065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tPydHG7fWQZ6jVd6mESYF32LvBmHL9oi1sT3bX8iegsrzKYS
16041	payment	1397	1397	1678	1	1	7687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcRvtSEmK2x9KjUPJ4izDFCRFvMXhQC6KZcxU1rJfNCVwzTNW
16042	payment	1397	1397	1678	1	1	7688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPyFe8kF4DHVTB4vqjaGauDPFUzwPHuEJrLNMWZr9YcZsL5Kg
16043	payment	1397	1397	1678	1	1	7689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ekZNKuAngqK2FWZayo6mpoufTzTzLZAZ5NS7LCiwFWptH9vN
16044	payment	1397	1397	1678	1	1	7690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLWKCz3ntVFx71WzngYN2dSrSfqY4k6KbnPreCBLfYzDTrpXD
16045	payment	1726	1726	1874	1	1	6072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmaEqsPvctJE3qMJa5kfhPTrFrHamHm3Bt4QerZkHbsvnK2Fi
16046	payment	1726	1726	1874	1	1	6073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15R4u4WypuaeSrkYe9qvANj9dqTFBGHtr5ytES2zwge6AkAx8
16047	payment	1726	1726	1874	1	1	6074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dkGSyreHKCfJWLSnbh8jADPzWGxP5bieVFQhbneYKa9sRBMq
16048	payment	1726	1726	1874	1	1	6075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXskqVc15xvgUsHZGffyzuY5odkj75okxN1PtghRrgfVJSwhC
16049	payment	1726	1726	1874	1	1	6076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CCZzXHGtjyQzGHs1LpFL4EpenDktBovKdH6CAUdxwCcVy3yo
16050	payment	1726	1726	1874	1	1	6077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2S6QE9nL8V9b71eFPDH97RrorJ2VZm4bgNsSLoDDv6CTZLEk
16051	payment	1726	1726	1874	1	1	6078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXZDPeACqy3ot5JWK8iSVneaDudRYB43UPYLe6h5tvPED1TZu
16052	payment	1726	1726	1874	1	1	6079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZN9QJbMVTX5XvrZb2By8w5Cjythw7MRCz8UUSjDLCdUmvkqsr
16053	payment	1726	1726	1874	1	1	6080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2FA9g6LiFLhRMCarKeqEWBswZkHXv57gMqcPGpyQ4eUUoPnH
16054	payment	1726	1726	1874	1	1	6081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYz7Y4MkT3oNY8fp5WVHuAP1AFvYTyFHzHh3m7BuQxD6Ca8dG4
16055	payment	1726	1726	1874	1	1	6082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFhd37PsfFn78cYcA4keLXF43Vu2EZpqJiEMCte9smYGQ9jLc
16056	payment	1726	1726	1874	1	1	6083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAouAghbAtQpXk9Rnnv9EhkUfwqTfLbBz5FBnNi5pvQXzxffS
16062	payment	1726	1726	1874	1	1	6087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVAWEV1azY9fX17ERXaK7p8r1HfEzjYcXh89aSSZPLkfuWC1k
16063	payment	1726	1726	1874	1	1	6088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjiAQLvWQpBG53CFiUF5jvNT2edzikqZKRi1BgCuAKpBKQoM5
16064	payment	1726	1726	1874	1	1	6089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNTr169H9uetp7dUduzDyL9xdois8xqF7Z2Tsfb9SGt7YNDZg
16081	payment	1397	1397	1678	1	1	7697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnh2tQpYfyPYWpsy6MrrRpu6wsASDcXMyEwUzrNiG4VrjqMsy
16082	payment	1726	1726	1874	1	1	6102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9roPhzHkZgnAK7wzqDEHXpw5sWe89UX9s6Bvr8aBRGLShTM6k
16083	payment	1726	1726	1874	1	1	6103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhJro9ACMKqvmWsCtoF5zKcH6RYzZgBDduYvqYcqQ9NRd9ujy
16084	payment	1726	1726	1874	1	1	6104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTQcMogvYykL2SXUTNRTXkBBppiKW3TkFhWo9j5LLE5ptwPd5
16097	payment	1397	1397	1678	1	1	7701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfbnnoXER29EfUoNKNLzcUHZ2DDp4NGQBBZfK4GDVD2fzcBwb
16098	payment	1726	1726	1874	1	1	6114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3igUwFYzNdjzUiGxKjkvGdFcxCdMHU5UnmfJoniCfBuX857y
16099	payment	1726	1726	1874	1	1	6115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuUenxxsmEy8Ux7CDLfMPeELznLtY3ZadVRci3hvwPAnfGMBz
16100	payment	1726	1726	1874	1	1	6116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8NPsPhh5jjvqVBqPJuZv6apDUKUS7i9zwj3m6MYjkvhijksv
16120	payment	1397	1397	1678	1	1	7706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VwAkduMDkaRq8frqomhYZyki2aaFtTURfVhrGCREwZH64kgu
16121	payment	1397	1397	1678	1	1	7707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDYZjACPujEjG3FX2KNePkgkBBDS8cJRD247yRtNkFTQPVUyH
16122	payment	1726	1726	1874	1	1	6132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciDhYt6mSK81hvNAprPQinXgqriisfL45kTfwPNEbPn8Q1Y9J
16123	payment	1726	1726	1874	1	1	6133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDK3NrsSaSXtSkdPSi2BbM3MqUsqYvHiXfLziEdkUisw3J8yvE
16124	payment	1726	1726	1874	1	1	6134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kb929whfaqA6p61XYLS6wV8EUp24uUxE2tv2dAdY666aegxe
16125	payment	1726	1726	1874	1	1	6135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YqeyNdrGiVrtr7smmxG5V924c2q4MMyQHDdybLumbHEgKzZE
16126	payment	1726	1726	1874	1	1	6136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9UZkMhQ7qHwSKSxxUFSmYc4WXQG69c2CiNzCRj61qy7CYkn3
16127	payment	1397	1397	1678	1	1	7708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTGRAK1rMm4cvauPJRwJiMddNreonw398HqgrdUtLYbuSd8j4
16075	payment	1726	1726	1874	1	1	6097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpPHtXVhVrjp1XGfs5NEE4WMtfB8kxCnRxqHY51X4cdeeXaXB
16076	payment	1726	1726	1874	1	1	6098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCGsSs5nNJYTP3FtCjXL9wdWrbfQS3m6RiG7fAsNxH1qbncxi
16101	payment	1397	1397	1678	1	1	7702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgErDvbWrRkea7WTcAgYHUp7ywJ21BuBmroKBjPeSXDoThiQKU
16102	payment	1726	1726	1874	1	1	6117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuEeumFJYL9iJ3vQscAGaVDX6AsqNBzy2CSqAvnDjo3zZvv2L
16103	payment	1726	1726	1874	1	1	6118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QK22aw12ZM2ANQ4PPK2PNKcbMUsYKzebftXTRQU7EZst3ZEn
16104	payment	1726	1726	1874	1	1	6119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKeLHYT3hYk9LJkQ3hcLHmEqyzTXpfC3NoNTEaKZNraZKaWtt
16105	payment	1726	1726	1874	1	1	6120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqW2ruRBxYzimJ8UiEfDGQ4ygwvJK39JYky1DTSEgAKhLt2Z4S
16106	payment	1726	1726	1874	1	1	6121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtZjQWL3w8AhpjLwMnd3cPgacZdxJTbQcXhQ6BWXtXdcqbKFa
16107	payment	1726	1726	1874	1	1	6122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRMeu2ASU3iJqkvdFyA9CAX7V1RiNz1umCZNa2m9z2zTBrdjS
16131	payment	1726	1726	1874	1	1	6137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSxQiMRAz6myKLkqyyuY2TCffnZqJL9PsYD5XzGhCwyvkwtKa
16132	payment	1726	1726	1874	1	1	6138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPHqtAmdHrY7A6XMvN4UFMXakSiugXsTDUb8PfnoPUD9JwFwZ
16133	payment	1726	1726	1874	1	1	6139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7aBTeLB4f8ZeHUX2MxNm5VzzDwi43SCSA6SMm95sRCULNWqb
16134	payment	1726	1726	1874	1	1	6140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hNZfroSi71Y6tvWzQNM14Q3WBaWK85ncHbB7iQhMQxbzFRCY
16135	payment	1726	1726	1874	1	1	6141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QKVQQ6CLVdaVHeBoMujwtFX4uYxhcA6LM9HUgsL4CexEBxA1
16136	payment	1726	1726	1874	1	1	6142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G8fJhj7ZdG1xU3gd2RniLoowDLR9FCu7Vp31VD3eF11YC5yi
16137	payment	1726	1726	1874	1	1	6143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9QhD66g9yfQC66TFfoTY2Sf4mqLZBJW1E5jZRhx3cPXCrGPp
16138	payment	1726	1726	1874	1	1	6144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvzePbhafDvpB7wi34LnxNzkcrDdhtyNaoAST2zKzeSD2Wr3Y
16139	payment	1726	1726	1874	1	1	6145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVC1HH7HzNW4N3gr6oRvVg2KLRza6b3h6dQ1RXm7mHSHouwH8
16156	payment	1397	1397	1678	1	1	7715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsAhtPdd6m6aSBgxwreYECn9XE2xjVfCKh8158TRMKTVxbESL
16157	payment	1397	1397	1678	1	1	7716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnEn4igB3L2iAQHLoyGEDRWAX7BfxcSKxENBAoWDyqeQXe2fj
16158	payment	1726	1726	1874	1	1	6158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2F7j6BxyvZ6WKPAbDKxdendND1aFGMeV3mmkiUjdEud2voYG6
16159	payment	1726	1726	1874	1	1	6159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcahUSy2XTe2M492CTKv8JAx68rrSJsnaJy1MTNWR8u7cQKJXV
16160	payment	1726	1726	1874	1	1	6160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLY3r2yvc6uHA3TEBpTPMcqJ4G5iy9g7nwirL7RPRbiJCmsbeS
16161	payment	1726	1726	1874	1	1	6161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ENRZBKfDVx41MyrS4v7jrBdyxHQc4PTD5xMuPArACzM76ojP
16162	payment	1726	1726	1874	1	1	6162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61L4TwM1fLjsf7CsLqXWeKuaPMMR565ZNdQ8gPY3yPTkbpHdU
16163	payment	1726	1726	1874	1	1	6163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhyV42Ch574cmB7y3hBCzCs4E2t41wCvaFx2RzVPZzVmmiAHS
16222	payment	1397	1397	1678	1	1	7732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvC3c9tyWr5ZaNWDH7QpRSXbkEM24AdQuwToEcNCFBG3WwAULT
16223	payment	1726	1726	1874	1	1	6207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcZoMMem84VFhhLHNCyQ4wxij7jhkrfFqU9LSEhMeDvpvpHRK
16224	payment	1726	1726	1874	1	1	6208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRTLDhG9WSPs8gjNv6c7NKe6A6hZHBgeGTCG4H3gczbxXR3r3
16225	payment	1726	1726	1874	1	1	6209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCh3TYm17T2HofmiwgBBMZSx9V7TMptwk3SbH84oYnVjQtyUC
16238	payment	1397	1397	1678	1	1	7736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oYUBFC4LctHxmzaHaXgiMHgKwEvYy2PDm4yPsQPLtKapEc3L
16239	payment	1726	1726	1874	1	1	6219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76zLzMhLNB7Ek5BjrazwVtv7K7hFhiMbbYpJmCP6jgDSZZfaX
16240	payment	1726	1726	1874	1	1	6220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oTBgYmPUu5ycPvn1mXSGv2iijnqXCDUXj51TMFf6CUE6HHea
16241	payment	1726	1726	1874	1	1	6221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQTuWEYMDmkwBE5wS8YdU5UY8d6GMidzzn2jpf766m2gTJbKh
16242	payment	1397	1397	1678	1	1	7737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zbSUVNGZCq5pr9Ce6Uu45tB2QrzE2rgGf8ygrFECRSQrSbPu
16249	payment	1397	1397	1678	1	1	7739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXtWVL9eH24S64UmAKKPsWez81DTLfgG1D1iVgwFoxCEDfEX5H
16250	payment	1397	1397	1678	1	1	7740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jd616Uvthy32jrp3eCWVzbkCbFZf4uAr551p1GasBpcHE3UG
16251	payment	1397	1397	1678	1	1	7741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4MczdeARat7TKdR1adNMu6PBaZjfxCmRSJkoVkJGsCRTkFH9
16128	payment	1397	1397	1678	1	1	7709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZA7mbgg1DbhZrjRPgdia1Hfb1A6UEnDVTuAeZ8nMekM4hJLu
16129	payment	1397	1397	1678	1	1	7710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtz11ZYsnvAe1x3PoGp3xcuLASSBnjiDNUfkdz2TAeJ5uDdkWD
16130	payment	1749	1749	1950	1	1	12	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL2SoUAzqDF843UejeZ2v3eHB8jbbMspgeqZwMPk9Y6CCa6qD
16167	payment	1397	1397	1678	1	1	7718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCesJJihSBVEMsPPf8NkEK6t8jXhEWRwGce3e1JLYVV5Mf2oUd
16168	payment	1726	1726	1874	1	1	6166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChn1R14yHcaUqGcasdmbSCCrbVR73Sg2vgt6LrRRRdsgXqdrM
16169	payment	1726	1726	1874	1	1	6167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzi8q7GxcvLQ1duqDwiiMaMp27yhUF5WQPZjfgTLKjRg6pBE1
16170	payment	1726	1726	1874	1	1	6168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBWNVA3aFQiAgrHwWEFbwdjWoB22Qj7tV4qsDtJQyJmq7jqqG
16171	payment	1397	1397	1678	1	1	7719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5tAKKWhqNzn2ZmHuonJMC3uWKfDNvoVPPH8Vxdd3Bs7p271iD
16172	payment	1726	1726	1874	1	1	6169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTSS3N7C55pFYGc1HbJ3muB4cduR8xpvdvXAMUfi9k8HLXtCS
16173	payment	1726	1726	1874	1	1	6170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8isAm7TdKBTyE3HM9tmYYAMSVz2XR8xbZjAEQ9YFcXaDbbuhD
16174	payment	1726	1726	1874	1	1	6171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmAJPuAaF4eUfX4LCkyMAA7E86kkDiiC6XjLNg5JnyGWPFJrp
16176	payment	1397	1397	1678	1	1	7721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g1Ah3X1xcS2JoM1oxvxrZBJnxqeHywhfsUgi9Pjhs22NdTR2
16177	payment	1397	1397	1678	1	1	7722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXApquwm4RLzVo5XTG3TYoaBPcDYSBKwYtTReL26GrCswajwsg
16178	payment	1726	1726	1874	1	1	6172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigQPVeLMBeU9q3jCJCSiE3kzBZrCGHvihTfwumbXbgNt72LG9
16179	payment	1726	1726	1874	1	1	6173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEig5G3727uBhByPTNTQHvh184t5kX8trWeLgLbVgFi9B7dmML
16180	payment	1726	1726	1874	1	1	6174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxA73TL9sMbEQxGAjJPEaw7ce1DryXPYhA937Yv4bPLDy7JMdg
16181	payment	1726	1726	1874	1	1	6175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7amNZH9NkYuFprfD6VPFjqZVUQg1MV4bR4TMaevvm7QxAMAS
16182	payment	1726	1726	1874	1	1	6176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9zQtqvqoq7UETEnKsqH4H29ptEWppYACmCT6neYDniYE4PmA
16183	payment	1726	1726	1874	1	1	6177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcD26VxwQimLTYaSe67KGV7LpnQ6n4ZvgiGcCJRFLUnu7YhUtN
16184	payment	1726	1726	1874	1	1	6178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97Djpxumn3YAE65nGsdPtdXcWEddLhJs2QFvUPFjjXQ9StCHg
16185	payment	1726	1726	1874	1	1	6179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBsGd3FY4gNrebfRmgHQFWKLwoGjRKmCafxhzwE9vVp97vKBz
16186	payment	1726	1726	1874	1	1	6180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Nt8HaBYiRWxSngDySfc2KfcnHDdaLnc24mdXySauAqDsvDmg
16187	payment	1397	1397	1678	1	1	7723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqHnQvrue2FwU2Sj3VnJbAs1JFqWP19a7gTsZkGjqHtoKLLAQ
16188	payment	1397	1397	1678	1	1	7724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFPNP1QMxUXhXes71fNJjkuYouMaYzSCZAq2C7Jsa93ywsvyL
16189	payment	1397	1397	1678	1	1	7725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VZoAW43drQ9t6QLCUenJx5sWbhnKWx1veiFdQ9PkqV3XfsV7
16190	payment	1397	1397	1678	1	1	7726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwr9hs8LiSewoCWuZG7KkYkvKyWUfx8MSF4omEnRRJRa5X1oxo
16191	payment	1397	1397	1678	1	1	7727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbzHZTMP7rgw5h37QsJqQCZXqAoErqLJPNYhcsHY6GdT1wmrp
16192	payment	1726	1726	1874	1	1	6181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6qLHC1xm3S7QA14ykir134Um481pWZEXkPjTufeG5CJjwxpE
16193	payment	1726	1726	1874	1	1	6182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74MN2e5rGPDhcnM68KfojtZjvjnddJpPHB3CDNQpDrEVAAwTf
16194	payment	1726	1726	1874	1	1	6183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCJgPwg8bGTX3eb5thtiiVMzBjXk9eLrbbhRMMKc5mEt4Gt6N
16195	payment	1726	1726	1874	1	1	6184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HUn7FrdEZZrBUaE6qPEQh7NESnytJ7ynhX5uVvakNhKgbCH6
16196	payment	1726	1726	1874	1	1	6185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6FQeMAaeKT6egbreJEPm4wLc81VaFvqcnyCiwzoaAxwUeXVi
16197	payment	1726	1726	1874	1	1	6186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNRnZgVExER22XnvVGHS8ZxyHn5zTUQ8LFGJc5sWhSYtQiy2g
16198	payment	1726	1726	1874	1	1	6187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm66NKDLFyXFxaQVGpYrANHPyi13CCxG5PukogBN1iDBaDaL6D
16199	payment	1726	1726	1874	1	1	6188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPyr6XMQyRPdx67zvjnzpiNjo4zVQuV3B19HPEZ45gYK37K3w
16200	payment	1726	1726	1874	1	1	6189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZmEpNx7Hft969BCHtR9AjbaPMnTGinDy6tdB8cXZnCZSKENv
16201	payment	1726	1726	1874	1	1	6190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzWrzpCQcYSJxnse6DD9bAveTsgtA3hSS5HfmJpzzP8QkocTr
16202	payment	1726	1726	1874	1	1	6191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuhjE217VkVzdfuF5yWgWiBEboGBHL22rhmoWRej5f9KRwBAd
16165	payment	1726	1726	1874	1	1	6164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTD62jtvEeSbee9YApJMc15tfRmrWKbrzRXjNy4AayPvG7kgP
16166	payment	1726	1726	1874	1	1	6165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPrPeEU7W8yKuxb9SDRXbMY1UJZa6QfwukpKWYqdHSaktydrz
16175	payment	1397	1397	1678	1	1	7720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6HP5nrLFZwjTEMTxU58h4UaAcMRMy7iJ1VPN1QKvLTyqS8to
16206	payment	1397	1397	1678	1	1	7728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTj4Qz9UJXpHu7J6xNPcUaVyUH9uzySScbSABbT5wAwYXhCh5G
16207	payment	1726	1726	1874	1	1	6195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxieT3gRCsZo1qqfao9rnDibhway8N4tkAuvgLzEYM8fSeU6Lu
16208	payment	1726	1726	1874	1	1	6196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxVNA1vEysXoo8Z5inoWyRgJd9hix5wGCcvt2UQdrQLrGytmQ
16209	payment	1726	1726	1874	1	1	6197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNhQ9RbuQa5Kg6xB7926w19k7xMg9EiVfpbXszByGL5AJ86Er
16210	payment	1397	1397	1678	1	1	7729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgyoEYxF1bCQqKT4rak2Y7LSx6DYbNzSj2cNpaxhF2TA2UH1g
16211	payment	1726	1726	1874	1	1	6198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynEQMvKC9PV8pKb6KSq9EpmzRDtoSpRtzkXKfjnZwGTwD1Vx5
16212	payment	1726	1726	1874	1	1	6199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiwEcjTVGHevrZyYvksuYBX9puCnMrqLmrMACeSGUwxNHU7Ub
16213	payment	1726	1726	1874	1	1	6200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPe1cCxVnARYK5Nq3tJrj9YAkytrNYYuqb4M6z3XJSuqhPTp7
16226	payment	1397	1397	1678	1	1	7733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdaGmgbUaJo81tJqt6ajQSamLsDrQYTgmAPNpYPQAsvqhyYid
16227	payment	1726	1726	1874	1	1	6210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgrbtKucBdvV66ppLCePSpJDodiJJiN9VvLSVFb9UEEo8Sj8Y
16228	payment	1726	1726	1874	1	1	6211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqechEFNXeptHX5ZtkcBRFyvYts51ai1ScXse1qPoWch3NmR6U
16229	payment	1726	1726	1874	1	1	6212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHySVbh3ZgFTvrKtL1M5WfFT84S9MpQRvRZMij54ezszQybn56
16260	payment	1397	1397	1678	1	1	7742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLjB4vaVVnDbbkyZecwrU6FqRYvfKYR3UH8AnEuUbtKXYbxLd
16261	payment	1726	1726	1874	1	1	6235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhut64AST7xWpYoGH5MEVBSW6c1oNPukPizqB5ivReyAxgZSE
16262	payment	1726	1726	1874	1	1	6236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1ckshmXGHrTtLcuM64FiaSPKYTppKbc5y64M6JKPAboYzmN7
16263	payment	1726	1726	1874	1	1	6237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAffXjf58qt9FFEmYKv3MKpvV32X4mpHfAYxUdS129UCGwFXFS
16264	payment	1397	1397	1678	1	1	7743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuiyZVJxAiuc4sZPt8U3dykF43QnpXSv6AEuG39xaHm7h3Yzr
16265	payment	1726	1726	1874	1	1	6238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAtWFjhMRTBLYBBi1vvxX8iRqZAjK3p5dAdwiw7p7FcpQsEQJ
16266	payment	1726	1726	1874	1	1	6239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9HdzCew6w9HFTtwCm1vHfJftvNtoMyCET9zdv93DTiG6m3Yg
16267	payment	1726	1726	1874	1	1	6240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5iMFmbqUZZxceYnQ2fwc1Q5i49p75JkJgnmJhkf5opcZbYcA
16268	payment	1397	1397	1678	1	1	7744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8E3oE7dZixBEcMLQW3SK8ksrmEQ9BSrbQB6qdbSAQFSxPNCek
16269	payment	1726	1726	1874	1	1	6241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLcZ41idkVGeqtwrwTDARXLS9mLu6yBCzT7hdWMvN5g9PAeHx
16270	payment	1749	1749	1950	1	1	13	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzu7CgwSbGYYkhJbAKbYRuRJBKuSxGGP5eYG1B59g45hkCX9wr
16271	payment	1726	1726	1874	1	1	6242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgEpREViGqcgRuXm9YzytCq8t4kXoecodwx8qWshPkj7C8rEj
16272	payment	1397	1397	1678	1	1	7745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxgiktAEvaTMWNAXyiRAURTadMP563xWHnpM5X35w8RgXyNUu
16273	payment	1726	1726	1874	1	1	6243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLemYhWyGuLVa1CJafdeo9TAzC5nyh7NSRSAJsofTv3KdrSVGZ
16274	payment	1726	1726	1874	1	1	6244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnvUTNmQ1KcpkU2KcbzEVz8jaCKoXAyiiDfyR8FNDM3HNpZrq
16275	payment	1726	1726	1874	1	1	6245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiArG8AMrQLSQDbnA3K9FPc2brJDLXTbfMGxR5sr8BLnkPrBcB
16284	payment	1397	1397	1678	1	1	7748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxz5SDajNK53hBAvpyhYLbuLGesdw3fpvSRq3K9NmEHa4Pxxr
16285	payment	1726	1726	1874	1	1	6252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHd8F9SuSLWd4ikU5BdckP4UA7DEs2GF66wgq8wJYpDSNuDmY
16286	payment	1726	1726	1874	1	1	6253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFHRNhM2WfFngcaHUP8Tr9yinKC9asZoPLyCQVhAqkpqvVLwS
16287	payment	1726	1726	1874	1	1	6254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NGbemZkoZT2tp6iTY2yzcFPXEto6rXZiLXVZtUDGy4RNvai7
16310	payment	1397	1397	1678	1	1	7754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1PCpUhvtryszV8bysjnMbmYLtqD4jPiNBMDe1P4ijrEZaYLng
16311	payment	1397	1397	1678	1	1	7755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYFKq6Mesr3sHToEmwpsPdSmiWfCSQ5AowcT2UUVarhuc5APk
16312	payment	1726	1726	1874	1	1	6272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqszBZ9r1pHjUw7cmSH2rXoL7C7zktoKGaTHtwPjDxV4MQqJK6
16203	payment	1726	1726	1874	1	1	6192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTL9aMYVGXp1aotczuuwMemTR7W9xCCUzRFbAc68QKr4Libd5
16204	payment	1726	1726	1874	1	1	6193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwPgLT9YMgNi1XJB4XKtWanhuy2e4Pz87uEVXKNXr5TRxKHva
16205	payment	1726	1726	1874	1	1	6194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdKpP9itaHmsotLvNjdZE6iRQMwDDBYPFGwFk3uFAd8vKJAbs
16214	payment	1397	1397	1678	1	1	7730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA7HYPX9W2MDANsE3m9aVS2z3FNo3oa6ZhscKUMacyhATKata
16215	payment	1397	1397	1678	1	1	7731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpK1ppvNikAt7eu7yNG4cVSA6sKeMzyArvWNHntyAWFqLgQsx
16216	payment	1726	1726	1874	1	1	6201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzL8hGisD1a8bnLF9Ki1VxWgi1hK3n3ijCAE6oZwheYhCVAhz
16217	payment	1726	1726	1874	1	1	6202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JJTGK9Fb3T6tC1tpg9CDrcFjZaPQ2AJ8Ka5U2matND7PMEEN
16218	payment	1726	1726	1874	1	1	6203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxKaa8cJUg6bMLNqmC8cLXcKXbyHvAPMLcarkVtmBZXYLum6A
16219	payment	1726	1726	1874	1	1	6204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh8C1TnbUbm1z9TpytAvvcxv3wkYTDCHCrCZHGK4RB5JfVvTQ
16220	payment	1726	1726	1874	1	1	6205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXBw9hRCSbgjkgy466b51Z8UudsppGqbaLBAy99YKzNGqpayc
16221	payment	1726	1726	1874	1	1	6206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Ee7tpCNC15NTGL6vU8iY6qhfRaabopVjEYoJskNzm2rXCCe1
16230	payment	1397	1397	1678	1	1	7734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHTERvDtQnT6hJZmm3UUWqNFLsMtkg8wZHTNiA1aKqyYejaVS
16231	payment	1397	1397	1678	1	1	7735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7edN2fcfEVVW82T7R6BqYhUp7rBCL2JxTL9JKDoDsGNHr6EGu
16232	payment	1726	1726	1874	1	1	6213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeb5sX9bAhGimo54VHqNqagM82VyWRCarRKYQhniJ9UV7A3g1
16233	payment	1726	1726	1874	1	1	6214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTmmw165T7WYkzLDKZf5Q5zfYM89gDFY66bCZNmwVURu6jEpR
16234	payment	1726	1726	1874	1	1	6215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU52WLAZwdvUCd2Es1LCgkfgXUupyQWTdpz1VoGR5rGcKQdurc
16235	payment	1726	1726	1874	1	1	6216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dJfrnFxhYUJscTMPavmnSZXHJizinycrEbSJZnHtV1eLKxcY
16236	payment	1726	1726	1874	1	1	6217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMSyqdcKFRpcyXMKPnzpebmutw2zCG2jYEDBtkXWGATxWirPk
16237	payment	1726	1726	1874	1	1	6218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQSf4esHMHySN9sxcABxibUKTTnzG2BSH1L689ZvLACtsvjQJ
16276	payment	1397	1397	1678	1	1	7746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtNRC6hHVD9RxWQVAsnXuuipVQuZdVDxWA3wkDwYvSX7y9img
16277	payment	1726	1726	1874	1	1	6246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4fXHEjcr61jfQpyooE2BHpXPaUq2M9uwLTxURF9peqLqjy85
16278	payment	1726	1726	1874	1	1	6247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCSu2y8SAGN1qy1MZKH4wHT88wwd4ZhUufBqr2xdiXmDq7xqsZ
16279	payment	1726	1726	1874	1	1	6248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMGgSkMEyB1yFHHUANecsfDwFtGWZw7esytS7gMCThCfWGswa
16280	payment	1397	1397	1678	1	1	7747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn2Qd7Zo5Z5fUno6Bi5qdtiQQycDxTv9EwZjvyRDYMMz9S8Z6
16292	payment	1397	1397	1678	1	1	7750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbBH9UHazYzovCJNhWwsRrfRLKEyUzkDgna5g9q22X7DS6PDy
16293	payment	1726	1726	1874	1	1	6258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTAcWvCSAHcZ83yuBPMrvFEPDLTQp2HvN91NNz5jG1xZrNaDF7
16294	payment	1726	1726	1874	1	1	6259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9ZNywYDP7saVzCRwbvwnY46hnRpcV6YQ8z9TzgmVe6s637ip
16295	payment	1726	1726	1874	1	1	6260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAmPc4H6N4hf9bgR3PUYcU1JtAu15aS9zFBouR3m86VrnGbk7
16296	payment	1726	1726	1874	1	1	6261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DA6beMKJhLCLTSMJjzhh25rXzjcRkbGXaLdbrqUhsWC4YpLy
16297	payment	1726	1726	1874	1	1	6262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpbhRykR7HtDSgjVQ7oeP9yqoktxdWgnC5XGsZgps1BU34Qmv
16298	payment	1726	1726	1874	1	1	6263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHx7xREmFSByr5Yiwt22kRvRUUvZhYpkZjUtyyRBaawRKPma5Y
16372	payment	1397	1397	1678	1	1	7769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDmVbiMB7dWA4rbAZ1T2RUQh857awFWYd1P9CT1qKxu4VsGWZ
16373	payment	1726	1726	1874	1	1	6317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKm7JvBayXn5zy2NyEr8eCCBtTyW5BLdZRS6PVMGgjLCfMt2H
16374	payment	1726	1726	1874	1	1	6318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzDUqHvAVTat5XigtteAXHJzxeA2hW4FWt1zvNHCXxT3SyqKuJ
16375	payment	1726	1726	1874	1	1	6319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4rWTkrnPBPPPYz92bVNSPA6nxGqXGdHxVMKmMCGXC6vt44Ua
16388	payment	1397	1397	1678	1	1	7773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnKpqNrfLKuVwpSgQgaGsFLmHJq4bCSubmA84shbpaiFFZWZ2
16389	payment	1397	1397	1678	1	1	7774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNw88rhE3B3XqMF6jhKJzakYCshia7nFtaqkDxixctj74hWZA
16390	payment	1726	1726	1874	1	1	6329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsSAADWVzPE6NkYHCidVwP3a4ozteU1gbfPYUVzg5MVPABfBa
16244	payment	1726	1726	1874	1	1	6223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4shZzk9UrsrKcK44gdoQqDBN4gDby2oSEkpHHjTKAx3YqB1a
16245	payment	1397	1397	1678	1	1	7738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhgkA5r4RDdG9seVxv5xsC3zyFCeaE2DSQTPVv5Vw6pXq42bJ
16246	payment	1726	1726	1874	1	1	6224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaKjZHs9dYDdUu66uCRDYcki7ouLjuhiGutcJfUJYQ8tyabpd
16247	payment	1726	1726	1874	1	1	6225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgGY88Z4Ht8NkC5To5Aj1phRw4sZENupJmnfPX5aSrcDHHzMs
16248	payment	1726	1726	1874	1	1	6226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Zz75HHzCMTK8Yrpo3DFX7ataB8WamuyJgj4tyEYMhXKBjgGs
16281	payment	1726	1726	1874	1	1	6249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1Wd4JMyey1KxTQSw2pVMfqquwpcvyhr9qqoFsKQvgsKaBLFK
16282	payment	1726	1726	1874	1	1	6250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDL7AAbc9XN4LPdDKRJNGjEDf44vC7SKjQhpr7eS2M9i6oPgtb
16283	payment	1726	1726	1874	1	1	6251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnY4D61tZiUM4AvTwnnePRk45sJESkDwgsCKDndSFx31LXoyt
16306	payment	1397	1397	1678	1	1	7753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4MVgXeuRvQ4c1sYC91FcXcufcWHLhVsRfFXXmqTYrsKZsb2U
16307	payment	1726	1726	1874	1	1	6269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1QbNp8VWEJkgZUm2Sz8wTTSdodu9mbbcVKfiZwDfjPahzEJN
16308	payment	1726	1726	1874	1	1	6270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdzJ1oruwiUCH7hzswTVHpnDRRm76RJKcP9JfsLXEas9869Vn
16309	payment	1726	1726	1874	1	1	6271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xHseNWxznhaqK7Cehig7uThNhC3VCVsaNgaoc1Ga3gnpKvU9
16318	payment	1397	1397	1678	1	1	7756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLpBqkvdrFbwLXWpn3C7CGVyLsGpZHYXnFBLCjwKp4tZUccwc
16319	payment	114	114	1950	1	1	6	50000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQ918TCAkFPy3yGXdg8e7XMduMgRbqvwiDehSmFv8pheQBTyx
16320	payment	1397	1397	1678	1	1	7757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHomn9RrqTLjkPWhrjUjFj72DpcqcfPtt5TfUFKvKstq32Ez3q
16321	payment	1397	1397	1678	1	1	7758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzca6XuGrjqTMGttbVQiKUEHAqXMcUdmQWcwbwLqGjehcWhFif
16322	payment	1397	1397	1678	1	1	7759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9x2hzCnvmrHfMNUKDT4edzqx1NGv753JdFsygSpnUtxozsosb
16323	payment	1397	1397	1678	1	1	7760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrrs2mR1P2jCK5b8B7VTN8UuNT7DHpzVT9ha22TMUcmhstUNyR
16324	payment	1397	1397	1678	1	1	7761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooPa74g6FZtfjV41dZqbReLKuYktugfJAGk19k42LTyD6PZks
16325	payment	1397	1397	1678	1	1	7762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzd4TJLj6wyYkyoy8SHr8xT87SKjDTRbmKyi2pXoLJ1soyB1r
16326	payment	1726	1726	1874	1	1	6278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PgpKjzqzJGPP8tEjdhaRVXLuYQ5Qp11aru6aXVV8ojj2gXnv
16327	payment	1726	1726	1874	1	1	6279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8gKaZn2VxRmAidBcTmwyy4XSKS6zcqJLCG53YKrNgRgU7Mrz
16328	payment	1726	1726	1874	1	1	6280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2Vh5TciJwr8mM6Q37mrBKHM48V1sDgNW8h1xZnGgvcSfhpo5
16329	payment	1726	1726	1874	1	1	6281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJC7Rbk8NvVLLuNuHD2FUercbgyrmJGTRWrnDX2eyHgWN8JF21
16330	payment	1726	1726	1874	1	1	6282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3ckR76gU7ptgpYw5GZLoUUGZWF2oPoqjyzQAjfKJmQ9LJHWX
16331	payment	1726	1726	1874	1	1	6283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAkSqDvNoPSpPq1Tf8x5gNqQ6mKdudvjfF4kqe7Dt3sQXCY58
16332	payment	1726	1726	1874	1	1	6284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dPxyXzMUPVQsaB6gScs5g7MNHtfAdq6WakNuGm7tmH1s7zk7
16333	payment	1726	1726	1874	1	1	6285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3fhC9NNTDktQU57Wy5sVka3sVSeQD57fdcrtZXv9a2niV2Cq
16334	payment	1726	1726	1874	1	1	6286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1e6L3mzu8aHA9Hbc8hQR86aEeFveutrkUnBB9eX9iCQKpqrWs
16335	payment	1726	1726	1874	1	1	6287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJg9AJcNcuR5bJ9mrZXAHtDKE4f15U3Xox9Wg2d57Q7mWfYRd
16336	payment	1726	1726	1874	1	1	6288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWESKyvtouZ6umh63vBCF7856CiCipkVxPD8UajzU7tg2Km6T
16337	payment	1726	1726	1874	1	1	6289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SuHMFHt3D527pXHh4K9rCkAgwn9FbLvYYY2FPTsDJrpmKZNa
16338	payment	1726	1726	1874	1	1	6290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfW8q8wKXxv6ZyXVM8cXz1q7WXeVZcjvgUFj7n82EVUNrysMhd
16339	payment	1726	1726	1874	1	1	6291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzrHou8Ygjx74jGcE1dtFwt5bSbhMUw4ZS6XZWh4W1d6SKTqL
16340	payment	1726	1726	1874	1	1	6292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1rp5ZWgaNH1fs47PGK1Mkbw6xW6ioHgocfE9amGF9t6nZ4Tx
16341	payment	1726	1726	1874	1	1	6293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob6gyom4nHuc1ExmwAJmz4qhcdcUReerR3Nzho6CQSqLoE7a8
16342	payment	1726	1726	1874	1	1	6294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71HzhdJEiNmgec4ti5G7ByYW3DTG3mhgUHfcPSME5wQmP6kkb
16343	payment	1726	1726	1874	1	1	6295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA6CEDmEfiBaL3b4JDXFwbnHqrudv44z2HNdvZpuKVyHnsS9w
16252	payment	1726	1726	1874	1	1	6227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4ARitfTXrzVap4kg6kR1JfWZ4C5i6m3ohdRd3MzQ8Qu9NgxX
16253	payment	1726	1726	1874	1	1	6228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaR8tvzUtdGPLXHyiohc9daG29GJ17WXSxW4qXSteQNV5Ww2F
16254	payment	1726	1726	1874	1	1	6229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4UgwhXjEYaM25WW4Lp1AXySwCs4TTwnJsiikafhgXjJGAU8K
16255	payment	1726	1726	1874	1	1	6230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LknqJ7QqDhi8NSriyJVArTn6Py6AmG8Nj9T368cG848c1mdm
16256	payment	1726	1726	1874	1	1	6231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgb793e4vfcRo6kKY8PTGY8fgu1wrhQFZArUqSLg1jYHtXsKJ8
16257	payment	1726	1726	1874	1	1	6232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzby6YXCshdfRbbTp6ce3Zdr1DjPUUUKDZKYnnr62r9U4E1xc
16258	payment	1726	1726	1874	1	1	6233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67ynaQb5jQzPyEKW86zj4WBPizwTfmpxEukLjUv79UUi3QrkZ
16259	payment	1726	1726	1874	1	1	6234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLR5xrbEehcVRYYypQ75gHBZgHkDW1ampGkybXsgDXbN9dGpU
16288	payment	1397	1397	1678	1	1	7749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Ucu8HS1mYhUEYDzEfDcQUskZC5KGR8vdk9feF2Fd2oegRPY4
16289	payment	1726	1726	1874	1	1	6255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqSbUfoCif6ai1vPYgMkmnhsqN1jpea6aTFrQd9aMyKjVb5x4
16290	payment	1726	1726	1874	1	1	6256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3zkJEwQKjQCCijxTthYiaXxi44b7HsFoL3LfeDFN74r2YS8X
16291	payment	1726	1726	1874	1	1	6257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DTPdufR4FukV8WnQnNNj2BCF2443cGrHT8KUWuUet6yXJXKq
16299	payment	1397	1397	1678	1	1	7751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTHR6NKKnrypVk6YRWLKnrTZHdD9t8rwNESYzfQaRWnMntGCH
16300	payment	1397	1397	1678	1	1	7752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBdikBL9yNXhqww7otx741MWxWNeWRyomv3g9QPQTJmrHkXe7
16301	payment	1726	1726	1874	1	1	6264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfwJdw5dijb2ckzSKygcgbcxqaoGftL78oZdEYEFB8sBavz1K
16302	payment	1726	1726	1874	1	1	6265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGmse9XwUE8zEXocnXnx3Q9Bs55359f24RkA53Sfr6yTwTbTf
16303	payment	1726	1726	1874	1	1	6266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVUoDssdjnDum3wGgVC8nLu8ga4LeCpFx8k5uV9JWd5Ynb6zh
16304	payment	1726	1726	1874	1	1	6267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswPTxVfWfJqti2ea8qewKQFQCPzYhwuS777ugnK1PefR73Dit
16305	payment	1726	1726	1874	1	1	6268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTYFm46CEBPQoLWdn8mZZisRCXVQyJCgTCSv5aVz75jdX2Ysv
16376	payment	1397	1397	1678	1	1	7770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgweC1PFXR3vjVqKGEzAZtqWW9v3PyNGxAM5MYFZeqYAPFBwH
16377	payment	1397	1397	1678	1	1	7771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfxxpNfoaqn2tAKQhT4YGpwSp9vmi4MSmN4FFMcSCvwQJPShJ
16378	payment	1397	1397	1678	1	1	7772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TaHEDvMLRXiq3KM9vRqFbV2X3BQj1aQ6P34SpTCtfS4ZsMSA
16379	payment	1726	1726	1874	1	1	6320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhye7bLhxDNHuBvBEaV7s5uGnwWoLB2qHPYK6HnjcNg6LLqNGb
16380	payment	1726	1726	1874	1	1	6321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHXfbNVwy3QJtAN3Uq9fnSfGXVtAToidPRxF9VA8skyf34hw9
16381	payment	1726	1726	1874	1	1	6322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCQzKDYkYzfsu5N3aUL6aiuGXFWNn2M27RJZUFo7tnHALWnrX
16382	payment	1726	1726	1874	1	1	6323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWMDWcBHUcYgitE6ZL3VPupLuUhrHqi2td1FZ9VfD8W6oWyCD
16383	payment	1726	1726	1874	1	1	6324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGD3a3SXrYnkjy9qYg1LdCFKzjmZ46kperCB3Mid3jbkysFio
16384	payment	1726	1726	1874	1	1	6325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHh8r1cxJGWDjH6ujQFC5Wb3hNFTv5P6rXu9HU7JP289UPZnw
16385	payment	1726	1726	1874	1	1	6326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSf5kG5ubkmXmhUjpJFyhKbdUsApXKvogLXwSzUV9GdunGvJq
16386	payment	1726	1726	1874	1	1	6327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirhwd1yxkofUSxsWdKSoZqma4LCjNN99JLzvBpxEBfpdv1gwo
16387	payment	1726	1726	1874	1	1	6328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iNmmGrQB6YuXod1SWP5TZ1gjkMuJWbB85AgyrRTn3YSa1x5v
16397	payment	1726	1726	1874	1	1	6335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQ795KqQbAdgEAU6g526yfCMv3F6cRpJV5fm1X1micRjGXUGp
16398	payment	1726	1726	1874	1	1	6336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1htJBA2zyMTG4fCAcwQ8Xrf5p96BQL1XzpKiskh95PQxygd8
16399	payment	1726	1726	1874	1	1	6337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVRvcjvg6pe9johJLVbx4fqc7seaH78hG2X2o5Mw2jGkQt2w9
16459	payment	1397	1397	1678	1	1	7790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENHq2Ux1pEf8nXXdKdqjBTXko1Yh6MCGyqJLkbNNAwFq7HuaT
16499	payment	1397	1397	1678	1	1	7799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdn8a5mgARAZ9SqMrJLiv1usVYMaDswyrinpPgV2qWg5Fu9iqn
16500	delegation	1924	1924	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gTETsFJLPkjztzXX3YWKHn5xNMW8GFwkzqEJj6tvfXDe4Qan
16501	payment	1726	1726	1874	1	1	6405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5V5nmSHw4u9QUuu2Th8QAkNGmpuHPUwGHVhZdsy1dqKmN4xa
16313	payment	1726	1726	1874	1	1	6273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEnmz519xWSisamvbeXpVgYJdwJouV7mUFx8wueH97xmTbZtR
16314	payment	1726	1726	1874	1	1	6274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RggAbT6mkKe3gZ44Qx2sW14b5SMKnDDpyc9wsUzGERmV51aP
16315	payment	1726	1726	1874	1	1	6275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocCqk6gFiwxsdfYofNQKQ7pYj9hGcKyRH98LRSL3QMvcx8gmY
16316	payment	1726	1726	1874	1	1	6276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFo1v1PLdM7Sbaw8CPcKoPhJxVL2YLkeoDHCwhXFn7dRbv5dBT
16317	payment	1726	1726	1874	1	1	6277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuWiMSAeLfwioavc8QHevayDj25nUN2A5iWxzZsSYvHon9od7
16347	payment	1397	1397	1678	1	1	7763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNKWy3rby31QfH7iF4P3RwHTdxbMzwBwBF2Upp39DfFsQsRXv4
16348	payment	1726	1726	1874	1	1	6299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTtiXSHGXdNbBbCjHjPxX7q185vyHZrDgKTiyqia9mQryhzES
16349	payment	1726	1726	1874	1	1	6300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkqtZGmcctjXB3cJ3yvhPnwySEaQXpY6GvzAgrFctHVAfvM17
16350	payment	1726	1726	1874	1	1	6301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9eQP4jrGij2DMTu2dvQM4BxMjGqASa3QvgqWwDqMR1nZWYt3
16351	payment	1397	1397	1678	1	1	7764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoPKAyBFLRuwWUtYHUPbCqqHd6mhArkcrq5hmAwtdSLXFqBt8
16352	payment	1726	1726	1874	1	1	6302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE59y2fTTE3CRfBdBgxphpdNVPsT5jJYZFjjUxYEP4U3M1mk5
16353	payment	1726	1726	1874	1	1	6303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrjPaUSi1EYUyxAniHvWWTkMNZNqeXGQNa1uzYNmAk1sKd7TW
16354	payment	1726	1726	1874	1	1	6304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBG7eSebSkmqK9E3vPonvV2BANxjfqQRHiX9DMgxuxzhstAQNz
16364	payment	1397	1397	1678	1	1	7767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8pkF7YcfgV9hFxQyWBMbdtQadep3Z3QS6Z6QjWQmEiegDBmh
16365	payment	1397	1397	1678	1	1	7768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfBLdHiqbkSTn2pw5PrEEo3n1bZ2ivhqn8YG6LAKEAS75nerY
16366	payment	1726	1726	1874	1	1	6311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6XCbRdaMpoJ6jT6GFEDte7qBgxC4ezzUU11NWdNyjNBA6EAE
16367	payment	1726	1726	1874	1	1	6312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpi4BUr1RpfDWsSbM3VupJZiNUmcq9SGoLYHVYmRy7xv9eGHgq
16368	payment	1726	1726	1874	1	1	6313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfmdaXSHBCvJ3x6PhTRKwvcocsrJ5Nwa47CCchAbgYT9fpj6w
16369	payment	1726	1726	1874	1	1	6314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXrrvfXTvsKusyuaErsDBSuhLe8JBDg3xbvYZwcnoCGq6KUN9
16370	payment	1726	1726	1874	1	1	6315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WR1gYaAyrbEJJgPSWU7o6FXNSkQ2mKTBJ7q2rdgBGNgqvPhC
16371	payment	1726	1726	1874	1	1	6316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LRMa2GWC87HV7yozE37XY3b3KrvvSha2dDszkUMYZnZgbHwT
16396	payment	1397	1397	1678	1	1	7775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAipK1dTYGPBEaFhzHe2AksDykjqVcKUDBAgL3qsh43Y8sSAca
16410	payment	1397	1397	1678	1	1	7778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvutVJHcMkvWk5DHrPHkv2fMksiWTi7GPVdxhGC4RK8Ddwxmsq
16411	payment	1726	1726	1874	1	1	6346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7VYvMYCxnWAwddRQNBVQpMPJJaXPmbnSpm77JVzYBh4tMHPp
16412	payment	1726	1726	1874	1	1	6347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKmM4c8i8THLX3dsHvMd5qwpW9e5p99U9LxPwbqq2R4FgJLZp
16413	payment	1726	1726	1874	1	1	6348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZ6cuAMhnU2Upu5Riu387JVtmv82GY6peKzzMwxHEtq1Rho4S
16426	payment	1397	1397	1678	1	1	7782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWahQDYh4k2ThRShvuqbbDAix8cJpBUVL7umT9oUcuHu1d9M2
16427	delegation	1925	1925	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoVLY3TYdGDEW2ba7wVUCxeeSkNdsi6GbbST1T3cY8QT8wFnH
16428	payment	1726	1726	1874	1	1	6357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAqNcYJm9odvYq3BtTPRAPgvWwMWM3ELxvRAhqCQFefaWX52K
16429	payment	1726	1726	1874	1	1	6358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xoUDCQhuUDW4kw1ycbx1CJGww79Ep1y24zajze3z9PFScFGi
16430	payment	1726	1726	1874	1	1	6359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3TLx91nsBtZ3fDHsyBCbocb7w8D5NigxGc3WYsA7k13oFkYt
16474	payment	1775	1775	2047	1	1	16	90000	12000000	65535	E4Yb1MPktVG3thA6rpEqocNUVKTqNk2RAQSrT7gqveHQWcTwMdGFr	CkpZNrYfSNGYgxBPqL3xskYqy2Z3HPpzF3UyB69AGEzSRdosKF3wx
16475	payment	1397	1397	1678	1	1	7793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCvicUXXEdWzbdpyJNToD5jfyWa4Kmvc91WsR3bTeAyVB8R23
16476	payment	1397	1397	1678	1	1	7794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8tW1AWDgMVNHrPDWdV47LL3pjR1LRhf8HEoRn8B85ktYEzYZ
16477	payment	1397	1397	1678	1	1	7795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NEx33zTi9My9b1cPmbi6wWp4uEo1SmZzRjq9HcwqEVx7NWpX
16478	payment	1726	1726	1874	1	1	6388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNMWqJB2gGDh87MfAtKsx6cYgPjEzJ7jy9P5jkGDsLAyXLEJx
16479	payment	1726	1726	1874	1	1	6389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAn39BS2ryev9bwVyKeTi4mFw1bLUyPBxCBjCiKMJpXy8DmMh
16480	payment	1726	1726	1874	1	1	6390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rNNRvRzFjAy4toj8V4DwfiaY4CKQYihf3pbupWmUTVgUQ9U4
16344	payment	1726	1726	1874	1	1	6296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxzCZuABbcjKJYJP935xZMASp3LcjtEvvWUh6xypBcqT495sK
16345	payment	1726	1726	1874	1	1	6297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzUdBQLZ3T63BjHa6d85W6yjpq8uiq3G1wk2ftmqcDjDrECYi
16346	payment	1726	1726	1874	1	1	6298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CsERJ3f2xT4VZMkFG2RLf7BMmoHQ4z25EDADBvGG3KfN3vue
16355	payment	114	114	1950	1	1	7	670000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjNSGa9WYH2q1Zo3pRCV3hxYNzc3TNzTejogLkwZR6Uq6X3Rp
16356	payment	1397	1397	1678	1	1	7765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R8PtiPZJtU9Cob2K2uWMGmDeVmb7ZBsJBjkjb9EjYrEhAzwd
16357	payment	1397	1397	1678	1	1	7766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyricXKghMkJ9vxV9SKFWDYvYPpXWaMRFZBa2d8DSNhwpCvU8
16358	payment	1726	1726	1874	1	1	6305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUCaRGt7SwVBvsj7dMEYn3Q5kVwu9BqhnsQVLh8r7wA2sHkag
16359	payment	1726	1726	1874	1	1	6306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvxEfUhFYW1FXZwfe22twVhYMt7jusiKiWopNZ1orkch652gN
16360	payment	1726	1726	1874	1	1	6307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7riugs9UTS71nU3Dt3h2kEhRRLK3NDuhnkdwsZfo37eNKfASk
16361	payment	1726	1726	1874	1	1	6308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pDqn4F8ULmdxkrokviE67vMdFeTTkX4URSqCGQjn5UqvP7TT
16362	payment	1726	1726	1874	1	1	6309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZdd23BTtHsJajCFr7obmSj2r1ptdV3g19Wh5KovfeQWzAvJj
16363	payment	1726	1726	1874	1	1	6310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdv1AshE2FTo4tf3yzQaSYnRjRUmDkWRMus7epqT1oPi6nx6Hy
16406	payment	1397	1397	1678	1	1	7777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9yiR4vHrSduejDZB8Nu7TK85RXD2YLMhjvikopWNqzGiQbKw
16407	payment	1726	1726	1874	1	1	6343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TbEheZZXEqa3u9eCeXWigFmjhPkvruxk58fcX86qVFcrUSEz
16408	payment	1726	1726	1874	1	1	6344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp18Bc3F2tE2eKZkoDqs6FfNKrq2cowHsBm1dzfSwhPUGagvvD
16409	payment	1726	1726	1874	1	1	6345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpo2D774kav8oV7TZC7ZrdzhKwNPabWRa2um14MURvK9b3Lu1c
16414	payment	1397	1397	1678	1	1	7779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnBUwjSs2V5dWXfQfGkXnDVnR2a62fUKwH1sW9Y4zM7psANHg
16415	payment	1397	1397	1678	1	1	7780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8jxBvd49USe9pLJyirKGpNnrL7MF13GW1s2fPWR5DpxwfPmB
16416	delegation	1926	1926	1483	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE5GYkM5DT6ELG6Zbo1T2P8kuT1cquEsQb3655d3zZXjNPpru
16417	payment	1726	1726	1874	1	1	6349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScw9Bc1yNTr5SnheE4Ps6ELhiZFTbSYSYSYan5UPVMJYMKhff
16418	payment	1726	1726	1874	1	1	6350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtawSvo2pPpoTaJ7C35uEVgCMGDbNEUgjcw4xFpoUHukmaB9KH
16419	payment	1726	1726	1874	1	1	6351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmsb5DsNV5JkT8iJwqRQAg7eqVAs8aVUQvG2xf6JUprLk6ta6
16420	payment	1726	1726	1874	1	1	6352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRFpF4xkhNnXpkaFcESVtkTAUsW2v2ydwT97DJysAuJAnUkMB
16421	payment	1726	1726	1874	1	1	6353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwgCAvgBExCutHdrM1JWezEkERarcEHUPYUwF3kQHco9JLD9k
16431	payment	1397	1397	1678	1	1	7783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypSA8SnQGoP7MswUJPQ9Qxr9fLrc34P7PeAByw2L5DVCKCshQ
16432	payment	1397	1397	1678	1	1	7784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuf3CqSAvZpfV3qguvPv8TuR7pXVcABoPQs4PAtUzrpisNM4gx
16433	delegation	1769	1769	1406	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAxYhc3y7STy6x1LA5gGA1ktjjCJHwLXSY7BrU6gaV2QR5hEC
16434	delegation	1925	1925	1423	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZK4kzwwyvrLQSNGhUFDYbw7J8j7ZhdfrSS7BXfBZ4jj37kjG
16435	payment	1726	1726	1874	1	1	6360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpB577nRweUfqW8gLJjokHf7otzPdZFcWrVoGwqSEHExr1JUR
16436	payment	1726	1726	1874	1	1	6361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWmnaZuacQ5cmhTNVoiANJyj1EEBUFuxs3iDJR17MhYbNxJpY
16437	payment	1726	1726	1874	1	1	6362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JxHPdH1tPMeWUGBvTBNHWe64AWMX8bCjgGmXWNoWLeu3LG8J
16438	payment	1726	1726	1874	1	1	6363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyCUUm2tYoQjaE3vTkpxmWz9n3grJx4wW9bifrVktTLZJvsZR
16439	payment	1726	1726	1874	1	1	6364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogKfg47ZARZSQEh3qHCb8EqKHbquwxeA5mFwm2uE1XuQt4YUM
16440	payment	1397	1397	1678	1	1	7785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyiHV7YgK3h1KjPENaLwVMFhT1xZazWWQD13k9Q9WuZtcbYWVP
16441	payment	1726	1726	1874	1	1	6365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhoqb8vmk8A5gRxcnvhYe2j7YSxJU4ympP8fHTXpjhe7odiBT
16442	payment	1726	1726	1874	1	1	6366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKM8YfQio93gzS73LhVJ2uMo2Yys3RimTdscVK6XwC6izqaeLG
16443	payment	1726	1726	1874	1	1	6367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4h4LYpV94Dr2E2ai63Rdc86bFCxHm64fT9arAcj9zNYMd2JrE
16445	payment	1397	1397	1678	1	1	7786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi68yh7bh7nej6ReQ8HrB3rem9TzaCf4LLpSri9qXNX4gHod36
16391	payment	1726	1726	1874	1	1	6330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFyeVTj9QVZPmRX6ogLMtU2htfzVnJ5yrsGxedHmKdJfUNTyC
16392	payment	1726	1726	1874	1	1	6331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpnGgurHv9Xu9RXZnPXsgHfMAvEkm4NGMrKAjUbAD9vajhRqt
16393	payment	1726	1726	1874	1	1	6332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9LMz8oEp81btcRBuHG9NScnSw5rHert2EYYQZJd2MnFmT4Lu
16394	payment	1726	1726	1874	1	1	6333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYWVqMDE6ukHk3P4jKbqDFGyMSSTfaEEuJUturTsrLnMCqz8T
16395	payment	1726	1726	1874	1	1	6334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFQT7tcvxrAKd1vaNVaGgkuq9hHgb6ukwFhe58ASCg7TCDU7U
16400	payment	1397	1397	1678	1	1	7776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkENp9PfQhDewgpUzDgf4iBokEkkfSBbBzsTWH22PuqB5w8hRv
16401	payment	1726	1726	1874	1	1	6338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouRNxENasSGpCvC4MCxCtRCsmyJPQCizzcgHbtWSD72HrdZZd
16402	payment	1726	1726	1874	1	1	6339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTw7iFW42zh5Kc1mRF8N6Av1c3DfLb5UFEG3pmMwBPr79to3Tb
16403	payment	1726	1726	1874	1	1	6340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGjf9ZKFY6MrAM8RbEcUKH2gFHsXk5qLGSMf5xyV45Eo3oNcG
16404	payment	1726	1726	1874	1	1	6341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkPFW3UBHKL7PeyrhjWD5z4Lr61TQSsUC2CHs7qDMD7oT6vWk
16405	payment	1726	1726	1874	1	1	6342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PV5WcshTG36nWoeG3M3fgcXbmPenA8tG3jQMS9nPEQCfE4XH
16422	payment	1397	1397	1678	1	1	7781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZepoqUYx8Dp3U79ZJTy37RDSXf1Q7s3DbfUmt8nyPNyWtryo
16423	payment	1726	1726	1874	1	1	6354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxdF7uahpDhXQq8ymPDUAHPs5cbvxqpg14xwqXRqXWLwdnKzN
16424	payment	1726	1726	1874	1	1	6355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWSz2Aoan8jnvEt1Z43MUrUjKvTMSnaoVoCbjZQhoPRPRc6Zu
16425	payment	1726	1726	1874	1	1	6356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvU7rbzBTckpzNWt7BxjZryJcxRVG6UwkuLrjRfvA1wQWedFK9
16444	delegation	1924	1924	1402	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyrmbEpJG1H9NmdUqjdzXpQDay8GHcnMcurW6cCBd8BpqxNqr
16457	payment	1397	1397	1678	1	1	7789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCDYYF8SCuhBbLAU5rKrncjBqSQMdGF7Fvh3NPoVfyZWnwMg3
16458	payment	1769	1769	1769	1	1	28	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPnWLtFuMS6iJobDcVswNasJYsLv9PiKtyGLnPrZKG4WJZ7gx
16491	payment	1397	1397	1678	1	1	7797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99YG976P8Y84HTqM5oPT3g8km4GkhK48udJ1fXALwJiVZasiJ
16492	delegation	1926	1926	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRjqrCYyvp7vpxQFqN8o16mQ8DjTcYo3dA3os1AqFZGP6yEjm
16493	payment	1726	1726	1874	1	1	6400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3PNK5HtaikKKKA5jnkMFd86h473FUCwQzub26zQoZFRbXUkK
16494	payment	1726	1726	1874	1	1	6401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrosaC9EGMR46LeeMDXtcLnNFKrVKB9PLYqYmbtBLv9QK5W4dE
16495	payment	1726	1726	1874	1	1	6402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcLgRAGj4VUvQWjJvP7rhS5feynW7U7GQLZerucTAmkCvSpNH
16515	delegation	1924	1924	1745	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZbUhqAnLc25kHvShauW7wXfyZKu2HvmGZDzdrvXjYAKunyVj
16531	payment	1397	1397	1678	1	1	7807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kavkfFDxEKRuvjYM5qHMsK7XEFYtp5VrZWwBMpWLnmDt9Wxd
16537	payment	1397	1397	1678	1	1	7808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYbnyRRnRxAQ41yDzNeo5BvBZM4i9r5txGE7cv8QyfjsVj5EB
16538	payment	1726	1726	1874	1	1	6428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvQBFcBrdoY8TvCwYY3sRNLWouELr7sr3YaMBPrvq54NcLVWL
16539	payment	1726	1726	1874	1	1	6429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6R5h865vgCfQGjWLheBMXtah8148Qqx1ALHRvbCRiVnwUKyUZ
16554	payment	1397	1397	1678	1	1	7813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tPCanXchcjb4awitRCS1VCnPPDXV99iA3J9BGjKNyimTLQ5n
16555	payment	1397	1397	1678	1	1	7814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpgfks6G3hdJM3A1FacZGjXGfitLkCFZQdd7Nd6Pej1dCUYFT
16556	payment	1726	1726	1874	1	1	6440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcch3mNz9dSHpzckourXrvjhHBF1DFnod4f7QUs5TnPJqYhJ5L
16557	payment	1726	1726	1874	1	1	6441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8PEowcvsYwFU8x447cXgAdN3U83kkNzA2JbJMN5ScmTyfbt8
16558	payment	1726	1726	1874	1	1	6442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABzpVnkyXmUVcCfzGv5Uh8RPNUgoVdHYJvGAztnrCgfLSbC3N
16559	payment	1726	1726	1874	1	1	6443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTs6ikK9uY6GL9c3jcBku5ftAYrHW54FFZ7PLQZJjNYaz5Y71
16560	payment	1726	1726	1874	1	1	6444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwpE6kbAj5UhUgAsmZCA3Tq57h6iPSSWFjLSkSYXDHGVkrGDX
16561	payment	1726	1726	1874	1	1	6445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vM3GEWvxcKAaVZWATFzUuSC1oEyykZGAyv9qQSXo6M3r8qEc
16562	payment	2058	2058	2059	1	1	5	11000	11000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUo4PYSLEomND9ZpomGrsn9dKGNdxSo8VrFdUgno8uwVcwmBh
16563	payment	1397	1397	1678	1	1	7815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwLufuRycw88CfvBMPmEX1zb34YVbpTHDKXKfPtsJrfDXoCFS
16446	payment	1397	1397	1678	1	1	7787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXgmrJ4bEiMjW4hMtHHZ7iuHSqesMq6SQeyfu4uoezuRXiKdG
16447	payment	1397	1397	1678	1	1	7788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7auvMvBdUxmCPFbx18oofKB3itQoFtd9diR8Rpo776wKof8x
16448	payment	1726	1726	1874	1	1	6368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MgGXrMgZ8XaSQqfxPrLgZvRuH8HLiLNTLhYtbw78yvmWVL5c
16449	payment	1726	1726	1874	1	1	6369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNjJjHWvBnTsHLBaGL977rizREpcNGgq61UViuFfsmPWJUccJ
16450	payment	1726	1726	1874	1	1	6370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLL75pLmAgWSdNNDk6PSym1n11N4kDNBCpBLQFL934pQmpXsT
16451	payment	1726	1726	1874	1	1	6371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Vubb9enfxvoiXo31VS5PNqmS1qQpBhWUcn6zhmqfgASnJBMa
16452	payment	1726	1726	1874	1	1	6372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmDVhiKMMCvKzwiZD5v6UTFem1xDUfz5EE7uSJytVfq4ULMP4
16453	payment	1726	1726	1874	1	1	6373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEaPEMejsK6dEvPdUtPMTijjazEszGaiGvqTGa2PqaMe7W9rZ
16454	payment	1726	1726	1874	1	1	6374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yAmiX1w4MxdcT3tTh43VL48DciVuBup4sNfdGKHxr93dixt7
16455	payment	1726	1726	1874	1	1	6375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuLzKcaDTZRKVCJUuBgTPL7bENmv4G6FmezzfeZ6VWRAv9SsG
16456	payment	1726	1726	1874	1	1	6376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFPfQEn3QE5QxRtTModYafBtm7G9kkqWvKbqZn77w7jXNnrv3
16460	payment	1775	1775	2047	1	1	15	700000	11000000	65535	E4YVB8xuKeCWid85sFVXJYTy4DX9uX8hiuzUFPgk37BjYuR2BzAz8	CkpYSs8xxJtu6TxLHfFbpLErp4t1bAZPd59d7EyPzA7hcGtXyjkcs
16461	payment	1397	1397	1678	1	1	7791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPvE8JLDUg9pGJPKphC5n6UqmkbbFDbGWTui5R1tZs7U9sPU7
16462	payment	1397	1397	1678	1	1	7792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrwrEao2NKqjzNWRkQJg3du1L94ky4gfNtUhCVBYfk5DKxvUp
16463	payment	1726	1726	1874	1	1	6377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBoz2Rskb2QQDoqL2gkHVeeuYMdwcVEgo3xaNaBFZWfjNdLsL
16464	payment	1726	1726	1874	1	1	6378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgdREbKazC83gQZZ5vTR7tWG595Xzd5GAXykzRosWyZERLMwX
16465	payment	1726	1726	1874	1	1	6379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjvFajcUMFcPSKGa42LUL5kBdmPqPajXwYYb5jpCdLpf3xyRR
16466	payment	1726	1726	1874	1	1	6380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpEEDwGzdiD1WqUo1hZaYTho8YBHVfXT1LxJHAWSJ2VyXdR5p
16467	payment	1726	1726	1874	1	1	6381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFif223e1UCTRm9RYt7StfCZ4mPySw7A4A5H7nJgfRcQ4qzBj
16468	payment	1726	1726	1874	1	1	6382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzUtny3P2zxhvQ2K6vhGoxKZ9ciT8gyunp872zRQK9bfVR5po
16469	payment	1726	1726	1874	1	1	6383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8noXREthjeAJNHyME68FrcNLBURfe9A8a8XEd7UewthiWrF5
16470	payment	1726	1726	1874	1	1	6384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5PQ3to7yonMjd6p38HiZLvu49y46BXZPtKSYhMTTJhDv5k5j
16471	payment	1726	1726	1874	1	1	6385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89Hbi9PTak7uvecwRmKkcJgmzedpAJjDR1nqbSYcgtMppQY1C
16472	payment	1726	1726	1874	1	1	6386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKSweY5uCcaCCedFnQySZJa1Z3L4VPJUZ7pBgC3587uchCnd
16473	payment	1726	1726	1874	1	1	6387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWrsw6SfqeUzKcMFuVHpzhUdTBcfqXEc21iBaeKEqoXDQKa1B
16487	payment	1397	1397	1678	1	1	7796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZGt6M53QgHv5j9Z52dKmdcgydYbJhTCdYhnSdN9fzTUuoMzm
16488	payment	1726	1726	1874	1	1	6397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFntRAgP6f91USvLP4oFdpm5uNMWJrpee3Bh1HZr1wswcMdvA
16489	payment	1726	1726	1874	1	1	6398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tneoKGEy9DxXyWs1qZdqHwCecmLaygbJaobUVoTpRvvt9P2h
16490	payment	1726	1726	1874	1	1	6399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBU3NbpPLSS5kieE1z9tewwttbiZ5XFnHxTLqWoAc7fQ4btUCR
16504	payment	1397	1397	1678	1	1	7800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwGT9ueKy18DQh8DXDHM76S2jQhqCnaaebuXCWJoqAy8FZkYz
16505	delegation	1926	1926	1745	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKHSNpowbKKz2ngM57BQNXU461MKeiQb8vrnDKifypEUVie5t
16506	payment	1726	1726	1874	1	1	6407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENJUsBiX2Q5CBv2Ajzc18798ycdstJDLn4dSFSWXdtwhnNQVo
16507	payment	1726	1726	1874	1	1	6408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNARfNs1gDm5gU5ALceXtGFyRt1SqTk8DQ5LRCZo4RjAKVJko
16508	payment	1726	1726	1874	1	1	6409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgM7yWf8xSY4SjaHHqXt2SjXp8Aa5Vsrgp2QmB846GjQyw9vF
16514	payment	1397	1397	1678	1	1	7802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo84S4639CKvkaaLbvj1mDi8s3iHjpTDtmL7nfYqx7ZbNsE4yD
16516	payment	1397	1397	1678	1	1	7803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQqaxNg3zpm9zHAUYX7MZaYPfj2RDsBzWrkXH2RfYMXqzGy7o
16517	payment	1397	1397	1678	1	1	7804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qkAcT4xYFMkcadFzuiscRGrwxXNzN3kp18NWijh7W4zvMs1c
16518	payment	1726	1726	1874	1	1	6413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuApJzLcYUjcRiCd2wsFt3DjUJQpChKv2KaAwAr7o65c2vKHuS
16481	payment	1726	1726	1874	1	1	6391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Je8jwMKFMA417uyQ3TXtQxzc6Cmv9ZXze1d9KwtRYJWXjzdz
16482	payment	1726	1726	1874	1	1	6392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNSWDfHHNThXHP9pQGnNLSmPX9oYFSo2fEJRXxfZjjp6oSDN8
16483	payment	1726	1726	1874	1	1	6393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Jdiojz7GJnEE1kxFR6U3cZCY3Xno7PjySFK5fCcoescULFxn
16484	payment	1726	1726	1874	1	1	6394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLFiyi3imi3GBGudcresoXsnHHvpaj7wjxTHTut7j8zuDNAGj
16485	payment	1726	1726	1874	1	1	6395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo5HDzRTjtUie9cRDrMynxv5TH5kqobQrnypebZrfojFUmNLR
16486	payment	1726	1726	1874	1	1	6396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DSHDfDpUfywTAzwvtNyXoC7jq8xUhhSUNjogyj2jpyrJ7Hd8
16496	payment	1397	1397	1678	1	1	7798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFoy22ssT1p7K4NcGWC8Mq7puJEkR4g4Mmzc7FGh7oWW38hxB2
16497	payment	1726	1726	1874	1	1	6403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3a97aHDMzVb5kmGgTjzaqxAegFwYb8Rki3QtnyLbMzC6UuU9
16498	payment	1726	1726	1874	1	1	6404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwxsrSnYTpwWPQEMp8G8YE8waPL3tvGbXKLAL3k5QZN9DGDJp
16542	payment	1726	1726	1874	1	1	6430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsZ2cpqrmgYzLxea9nDoPg9P4XDRCULVNAEqy38t9Xj5LKrTL
16543	payment	1726	1726	1874	1	1	6431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdd5Z7cZaET2mWRPcUcTnRLFjwuNdRFCeyKWXtbRYC2XbrkJ9
16544	payment	1726	1726	1874	1	1	6432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EnVad1YkB7CZbyMtQ8UgzjoxtDNSSF3oNsQxSMJo6x3vP63z
16545	payment	1726	1726	1874	1	1	6433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgBwqDokTkn1usvWYZDUdLGJem2diVQT127S9AP6kSR9vkwXo
16584	payment	1397	1397	1678	1	1	7820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28bZrfBgVBwV9FcLkMrZayDV67sg6WtdcD7uguj4Vy48AZTHu
16585	payment	1726	1726	1874	1	1	6461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MjScf7sgNHR3j6Msv7Ehk4sY2pKKVu2xmpttXnEa82bJ6akm
16586	delegation	1769	1769	1652	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEWsEJUVQBWQUZGwSV2WFxubj8FCrCXuoFpVM6ehyhHpT8DiK
16587	payment	1726	1726	1874	1	1	6462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJi1NTwupcydYJsJZtWqd9LoyTpfnnJf8Fg4gb1FwP96Fupn6r
16588	payment	1726	1726	1874	1	1	6463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mJP5M48cKarYn9PzPiieJJzdg66hveQH5eLCh2Z3BnAZovuY
16589	payment	1726	1726	1874	1	1	6464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVAmfghEYz5dhLu3uAgCk7AoqapMWWBHFrg6FHmagjGon2eYc
16590	payment	1726	1726	1874	1	1	6465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5sSYLSL2MkZCzdcB5ehH5vmxAqRxAuEiBSs9wyehzY3CUQio
16591	payment	1726	1726	1874	1	1	6466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgd45aEqgNQwWLbYbdmmaTSsq3d2tJ7pAWYejv1jS3RryS1c92
16596	payment	1397	1397	1678	1	1	7822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaQvou5EQM1AfZQt2XMg3pxgdEEN5bCbon3mqZuZD3WDU136L
16597	payment	1726	1726	1874	1	1	6470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvXCbHRrg2jBPsAuqQWxdvvhzfXFcbyuM3DwNM7q87jQTjRj5
16598	payment	1726	1726	1874	1	1	6471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfQuzkvAKecKwnot4tnV5rVkyf2mULpeSSAEmxABdNcY15po1
16599	payment	1726	1726	1874	1	1	6472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU3UJZPSzJkjUdNkydCcrBJVyRSmboGTW62moj76LKGhhfGMn
16639	payment	1397	1397	1678	1	1	7832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekWGGqDLf6vWZrnTACRgpf3tNFF2sLU3hCMcxT9o7GKLL6bjf
16640	payment	1726	1726	1874	1	1	6502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XCxVpGkTzCDvmnuYzVDPuXqJAg5jRP9v1JNFtcriw1PmzszE
16641	payment	1726	1726	1874	1	1	6503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEpWuAL7Tz1Kgr2uBj5VVZn5Eq37bEc2S59KiMovCJaUacRVr
16642	payment	1726	1726	1874	1	1	6504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBUh75BjNTgwCUh9jMwWuaMpU6Mo9fY8FnMc9mZrssQzLKHfb
16644	payment	1726	1726	1874	1	1	6505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCXPCGiXXK9Now1BpthRHwhz6kRqsNLp6cimzdAJ11aneRd83
16645	payment	1726	1726	1874	1	1	6506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriPghRLhfekyFyuiEzEc5vqy1LxVsSpMGvspXFASfxpR24UYJ
16646	payment	1726	1726	1874	1	1	6507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZE8kYQZsymM2j67dTyhsiSy7WtEW4xuwyC91LR6ENZoUbQfU
16650	payment	1397	1397	1678	1	1	7835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93dUA83TBNCStJexh8WUUPyqAq59iTpSWPeLfJZuHV2y9pPH4
16651	payment	1726	1726	1874	1	1	6510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnubWyWJYqk9MPMHXs4QzoPwg5woFuweywThfnnt3Cb9c9JC93
16652	payment	1726	1726	1874	1	1	6511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwBp2i1fG8gGdHnvTTLs3tcuX6oUs5WdgGZCLKH4Y9zoCQ1y9
16653	payment	1726	1726	1874	1	1	6512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsMQjUp38fvFEG8P3eSBiUnYNSbVPZfJzz3FxC3iQTJGoxFoy
16658	payment	1397	1397	1678	1	1	7837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrt4o9hkGYiwSf1ENGKJKab7GCYnienAdd8vDDHhwZv6EfbCB
16662	payment	1397	1397	1678	1	1	7838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ3xkiv5VCTGwYNygWV45jYY2dG49xvB76paAvTQNBAXRsTJC
16502	payment	1726	1726	1874	1	1	6406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2fSQDMVjZhj6LeHNj5wbiFFVbHVv5zPoTjb5QQHJD5oK7pqz
16503	delegation	1925	1925	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mCePKWx3VJQ75aaC8sYbUoFEVdrxVbwoUuMt1DUHCPEox4bS
16509	payment	1397	1397	1678	1	1	7801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfJCkZz8Kz41M6y4EsFFJFphyoTdGiVhgRWFGZcMa1njotyxc
16510	delegation	1925	1925	613	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPRN132tZv8PkbaVQjoGLzNpWpZ6Drop2bcNcToAKFC5rmtDk
16511	payment	1726	1726	1874	1	1	6410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4zgZvj2kiqoUrruEf74jTrFM5w5kGCUc4yGMv6RefvgEoQQh
16512	payment	1726	1726	1874	1	1	6411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD41iu6CacuKL2dg85vbiwAuKdunhh1urMDD6oJLbGU7Uo6osY
16513	payment	1726	1726	1874	1	1	6412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxRZQvmAJYMQfBgpyD8KfCaQfkomU3ZXT9R55X9U7xnqKW3Hx
16525	payment	1397	1397	1678	1	1	7805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpxSpimMCRVDccNjYKXXiwEuHVHQW9FmeQtE7X8gWwNypbpqS
16526	payment	1726	1726	1874	1	1	6420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizEa5tZ6LKnBh1w3nFAQccKs1i9ZaRAj83GgCrRa1aGtgCdjX
16527	payment	1726	1726	1874	1	1	6421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6uXmYYpYxPYpbHPX3UPBVJ2eLREQzD5UGAzVzNz3TufjnjM6
16528	payment	1726	1726	1874	1	1	6422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcvm1KfZxQGhM2VSGakV3QpAd312KBnXDgGFviEW2VZPpS12v
16529	delegation	1925	1925	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EJnMz8AKY2WvGrvkTxqwDnKaxhQUAy4Jui7VmEJoUcs9Shvf
16530	payment	1397	1397	1678	1	1	7806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqyDpZMihVwAt7aGmX4oaGfDHcruGbfnMSc9SFXh7KyMebgix
16540	payment	1397	1397	1678	1	1	7809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZCs5UiCjAQTLYnuAkVHTsR5bBK6E75xcRxbGFv9cUQDZRSBW
16541	payment	1397	1397	1678	1	1	7810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tkgHmbZGMbenHoCQvACCKuhzCrPXMLxicECkSFrjY55XoyD7
16546	payment	1397	1397	1678	1	1	7811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTxKDoodCJbArGK79ERtGVUn9KWm5LaYx4dJPLdZzN9ZuCBVv
16547	payment	1397	1397	1678	1	1	7812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8tVdY5WgvLzA81HKu35nNCANUKG6tKupXn9sGrtPPxfpm484
16548	payment	1726	1726	1874	1	1	6434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmYcL7cuZf7q3Pii9ta2ATko7mcubVEQkhWZsWfWEYDYCPADF
16549	payment	1726	1726	1874	1	1	6435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkGNC7kDx6ZnBbyXGm7mTN4HWrNeFuVGJS8z7QY5d393v5Zny
16550	payment	1726	1726	1874	1	1	6436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cufQdEE9c9jbMAKzKXUtritpRtGajkhozzTCnQhqyZMMYzQw
16551	payment	1726	1726	1874	1	1	6437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEegHmbncymChqGWX24216RMG7JkEWEnZeQWKsHhHnQv8S3p7
16552	payment	1726	1726	1874	1	1	6438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTuR9BMF36D5gS9C65qnxZuf7Fi682Ys86JiuCERD1yYD9SzF
16553	payment	1726	1726	1874	1	1	6439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmXGhgNkYo61PqEEFmPRFWpPMtM2KX43hPTE3EvzFSmoMSfs3
16564	payment	1726	1726	1874	1	1	6446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMk7JwyjTNwWdXT7fxybC2C3dXifVhpeqCYwEY9p7km9oukht
16565	payment	1726	1726	1874	1	1	6447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCr573a49m8Vz3tn1FfpBte6Be3WWf8jL59i7TY9qJShv6aJC3
16566	payment	1726	1726	1874	1	1	6448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2nqbaKSjBFpVorq8zCjGQrJd7xd2he8Gyvprz7gQPcokiXpT
16567	payment	1397	1397	1678	1	1	7816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSED8GwFHAHYNGgCDQ7xBqrNN2fT5DrdHwUPMVUsoxWMV9yjom
16568	delegation	1925	1925	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQxtvfyewLjE1j2Tm74VuygjoKUy5BawLWgqPVoSztidrpQ4y
16569	payment	1726	1726	1874	1	1	6449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mS6qXUAQZAxcb7BVYMmUZ5XXui442Am1ExKR3BGFKnTWHehU
16570	payment	1726	1726	1874	1	1	6450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwexwy5vxVGHGiesKVat125jknsSw1tB2UHdJ9FKJEy8npkuNN
16571	payment	1726	1726	1874	1	1	6451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxz4jQm4Cr9pLMwmMi5frbKW8qaErBmEVN2u5Zqyt4V7S4Uk1
16601	payment	1726	1726	1874	1	1	6473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4eTMos6MsRKFoPrMxTZKFAGnfVzzejAsbRLLqwhoZ85gM3bM
16602	payment	1726	1726	1874	1	1	6474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdw2ZNsfA1qBWUgDsgUrGUL5oRAGEPiYYVhjjuBdwcPBshWZ33
16603	payment	1726	1726	1874	1	1	6475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5Eiyw57kNfUrEaygXkoC6b9EaoCEJrrJF6a7ZGs44E6PsKFg
16604	payment	1397	1397	1678	1	1	7824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TwQ6JCCweXEH8FycqHEbqwTooYhR7i6BdWeKHZ3syodgcS4z
16605	payment	1726	1726	1874	1	1	6476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNZT9j6axjfmjgMn4AseNqK51hDbYDrFgcuHDVt9z2LHFMojW
16606	payment	1726	1726	1874	1	1	6477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAebvFtAdVHiMJFEsoD8WbhH4dbVfsQDCBLrKZtbQL3vTuLzxE
16607	payment	1726	1726	1874	1	1	6478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bAXdbRGHLh35SjiFXsSStNXTbz6NA3iTygQKEh5bnnY1Ke3T
16519	payment	1726	1726	1874	1	1	6414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYE8RenqeMKCm66xnS4vyyedpE5jrctZ6TW8SgVwUwPe1DGB4
16520	payment	1726	1726	1874	1	1	6415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2T5ngsAZrpGxK3TCgSsFz8mx7k9vXY6qFnZxXtF1oV6eiysW
16521	payment	1726	1726	1874	1	1	6416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyE1YTB91BG1bK7XB2u2uubceAszL5NQ9HcCPKcsNZm7MQHov
16522	payment	1726	1726	1874	1	1	6417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsG97AR3hHpJUioDPT8AD6Cvne63YsAxineBdJwjJVfJe8PymK
16523	payment	1726	1726	1874	1	1	6418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vK9gWadgbhzcrMM5GTPc7SntMLJS7QSYptDp4HVaaadKfsDy
16524	payment	1726	1726	1874	1	1	6419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pQAaYHn2jdHuRyGMmNvg6Yqga73f5WW68c1FuFWT4M27C2tg
16532	payment	1726	1726	1874	1	1	6423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ioN4jGxXeKu9B2jQN1BQst67NytCBpX9sQU5NpWfmrM35xne
16533	payment	1726	1726	1874	1	1	6424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvjcyRFBfPhSyfpdL9qqajVh3iN8J6nk8HisPLadKVrv7hQy3
16534	payment	1726	1726	1874	1	1	6425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99jfY2mNnmBHzNZFvRYbuarwGSYNs92h77ubC3jKiro2Vdm35
16535	payment	1726	1726	1874	1	1	6426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmPJXopcnKUC39azH6fzoJ3QCwD3aSXT9zhqasADudMwExrhT
16536	payment	1726	1726	1874	1	1	6427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBJJye6C4dSMCztcKueeUqUQro5xSa5F5JHjsXcdDi7nRrjjA
16574	payment	1726	1726	1874	1	1	6452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRAKa7gzmUj2yW7hrN9zdg6P2NugQRtNdoz4WBSqWYMCEWG6Q
16575	payment	1726	1726	1874	1	1	6453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF2TffwB558XJzPxquAKGF8uyeSC4u9NsA3cqu1Z3n8PGVKD5
16576	payment	1726	1726	1874	1	1	6454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTWWJRc9h2xwrsngh9z64oPACerjiEVk2jX5tPqapdpAPNFA7
16577	payment	1726	1726	1874	1	1	6455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkdHAFTdYHvkQTzERKvByjYHnkcxztsTHYK4n224goXN8ho3R
16578	payment	1726	1726	1874	1	1	6456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbDV1tKsuYkFgknXYk4EBis1JL1ha1B9anLpCzAxWtVhrsTTf
16579	payment	1726	1726	1874	1	1	6457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehpUEizwwp4Yh4J1HU77oFUZqGGmyVaGxQRbRmyVwNC2TdPbX
16592	payment	1397	1397	1678	1	1	7821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBi3tmV7h2YFEHFDK2zyLd4DRFgUnWVP9eg3fogNyh6ugj7uVe
16593	payment	1726	1726	1874	1	1	6467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GYZAfxLjdkL3xtT8JQSJ2FU3ruhut7zboHkACbdW7tTQvnQq
16594	payment	1726	1726	1874	1	1	6468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8muQxmCzcqXran99xfFfeuQX9nWkQv7cnz96N1ZVEuKGTeLmt
16595	payment	1726	1726	1874	1	1	6469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ZbxCVQyD6VEF2ofFEKJnGYypCbvWuLXm2wLJqZ6emRHxFyF2
16608	payment	1397	1397	1678	1	1	7825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGoXv5b9H9rHaBBhNfHMAQBnGBh3pDsUEfJFMtXvfDKedDbwN
16609	payment	1397	1397	1678	1	1	7826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cVYKGoxRRUNuAnJ3eHwrY3BPActhJuABuDwhNfzdRQmvumxu
16610	payment	1726	1726	1874	1	1	6479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV4Ez6NiKByAvVunzCDUGQJCcUWeQRd32K2zSceawMc3xhVv5
16611	payment	1726	1726	1874	1	1	6480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTBbHMR6VQ2yAras2mpPqfVtLAE7FErEQfr6g52S44H74dQ7N
16612	payment	1726	1726	1874	1	1	6481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKYxLZtYNhSqGjrqAmaBSXuJ5XxY2k4wCNJjzMrugaMk997Ut
16613	payment	1726	1726	1874	1	1	6482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiTamMABxq3y2mLgVfoaWL7tKsSGu4eekBi83WmQTNGeENQry
16614	payment	1726	1726	1874	1	1	6483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71xnhfjVVyLw3ayx6RTvKi6RbpMdC55wFnk5x4ZqGZmWC3hmw
16615	payment	1726	1726	1874	1	1	6484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBt3LiGTj1d9XCoAw2emcDhmqLEybjtD8gWZicNh8V2YpRUUcV
16637	payment	1726	1726	1874	1	1	6500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fit3pPyeu1aLFtztC7p8G2tGx1EMhUNgiYiNz4mDrRWTGngb
16638	payment	1726	1726	1874	1	1	6501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUZzdE21sfZu3XMUzH1aRqoB88kQUJzhh6NWZmesUmTD66c4f
16643	payment	1397	1397	1678	1	1	7833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfaQ3hVhHkzNgmAhiJBP9e9k5qQ1EDUgewJUag1VCfyBfCf79
16678	payment	1397	1397	1678	1	1	7842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxysq2dVDRdhRbYPGQSgS9iMuXDD9QCET4wygmswJ69tTeVxjv
16679	payment	1726	1726	1874	1	1	6531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgQeeRwPkzG5EAe3Y5SpK78urDP3cM5xpF29txqzjuB7yfpGg
16680	payment	1726	1726	1874	1	1	6532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9wUnVwQMy8u8PKRuMtC4zVR9zSLRxaSYgW2ptNNiWA3u1pPH
16681	payment	1726	1726	1874	1	1	6533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8vypPv7Zg6zm3VoFVqZFtiYFsDStWUavpUJmsgbn61fznWWh
16701	payment	1726	1726	1874	1	1	6547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zfSC2o59gvctxYZxgNv1iaTYWpMbhZtwXaW42ZwDeQEsLoFb
16702	payment	1726	1726	1874	1	1	6548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhy6TKYEM6AMG4d5CHqVbTTJZYThjMhH8XKJD2RsvPJG2NaSRH
16572	payment	1397	1397	1678	1	1	7817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHLBv4p5QtWWLNnr82HbWkxawTVVJZHSae6cNmGgNvrgfszKD
16573	payment	1397	1397	1678	1	1	7818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgN29UaHs6JFTkBE6bTSKXG2mmQd9Vcsg8qMtG4j8fSxbPET2
16580	payment	1397	1397	1678	1	1	7819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmesGoZZdrviSasUqbKXhSqhhXuKiqpjeCxHpqQbkeLe7JiwQj
16581	payment	1726	1726	1874	1	1	6458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoM55sWoMen8NWRSZ9DuWtVGARTDsrpMXLuBoRmZEJjaXRqsHz
16582	payment	1726	1726	1874	1	1	6459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMnuE5d4LZf2ifxoMsvxH8bF3rPxAutW87K3H1yxehq7XQt2w
16583	payment	1726	1726	1874	1	1	6460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc8q6p5LM3yGws2fJGLDQyMPYtTKT9jG3s3HznNi5zYgNSEvn
16600	payment	1397	1397	1678	1	1	7823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTA9aZ9NHejHbUzxLPTuB8rM3UVXMkoMmyWfyGNevNG7NawMxZ
16622	payment	1726	1726	2103	1	1	6490	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAGuyQuUbDWMnNPBj9oG7uShzNERgjX1s11FMyWU6KChwcGZ2j
16623	payment	1397	1397	1678	1	1	7828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoi859T6kwJGnvfixN8wWCtUxGbELfDWSMbwcezA3guqPYjsZ
16624	payment	1397	1397	1678	1	1	7829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5yCjMZS3nBhHYFD4gvccFjsqnc3mB42EzqoCHv8Mh6pPCVVu
16625	payment	1726	1726	1874	1	1	6491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo7XwDqgDzEXQYiDYkcxw4X2zdAF7o8EyBv79A5zsgQXq1HLa
16626	payment	1726	1726	1874	1	1	6492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBLBYoidB5hZgJ17dR94Qj5Er6FAQQcRw4VghvfgaXxh5uDh1
16627	payment	1726	1726	1874	1	1	6493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eCL5e8Q8qjLDyUjzxfhWMXatNK3uiDibL9rHFgDs3GchQq1d
16628	payment	1726	1726	1874	1	1	6494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QdcdAzTJAJwiAz275PkZ65gYrSEgAthmQaXXgANqMP8VQkYL
16629	payment	1726	1726	1874	1	1	6495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg37CCnWZDi3bCG62NghwsMPnFYqncv8YzZpjqcd7KWsEnDAab
16630	payment	1726	1726	1874	1	1	6496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiJQQTS82u3oA2wsSCjwtWQV37Js7wprDz6zLUEG2mpq5ZmuN
16631	payment	1397	1397	1678	1	1	7830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDWdHJxnAx5p8zHqzk6GeS5PSorDgcg91MRZJHbjpckKCYNR3
16660	payment	1726	1726	1874	1	1	6517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1Dt1muueAAS1vF1ghpM6V6cjfNe1tcT9EqzfDQk4v64QjXUT
16661	payment	1726	1726	1874	1	1	6518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaZ41ww1DtLTVfrbqLrT16kUsRN5nC4W5GohoHxur3urvZb4e
16674	payment	1397	1397	1678	1	1	7841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AcLHqymiCvNG8bCsm2FXWwNWMdpALY1XY2wvho9GDmnuakzc
16675	payment	1726	1726	1874	1	1	6528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBx9Y1DN8eeCykVmAvNRbo61KbDXxxdfx7ZyuUB2GWMU3KchS
16676	payment	1726	1726	1874	1	1	6529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW6tVWL89YGGQRNALzgSsSE95vcXvrECk3UQQQSsx9XPUr22x
16677	payment	1726	1726	1874	1	1	6530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPsWA7RTwCU2nNZRFVX4wFz96wyS57yTYB8fFPhqrBucVz12F
16690	payment	1397	1397	1678	1	1	7845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsmGM6ez8WNC5kdLDNLFsJJakV562ZgTDathJ5cmEiKCQ7DGX
16691	payment	1726	1726	1874	1	1	6540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVDFwd9L2tNgthLYhAEfFRj8brxaH2cJ1RDWDfD8VQEAne3fJ
16692	payment	1726	1726	1874	1	1	6541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQQZY9hxmWXXksMtSvNzAKbnwxUfMJWTuJEVaSB23j5ei7FcL
16693	payment	1726	1726	1874	1	1	6542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MZDqd8raDxbATFtGBZi8UvauXwWKYAmATbGEj33ZwkgtwT9m
16717	payment	1397	1397	1678	1	1	7853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQ16vTUDC3KFERQpnunDasSH3XrtHopLUaBLfbZzTruuMXBGC
16718	payment	1726	1726	1874	1	1	6559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyoHxGEvniCYHqKktwC9r5DU32oW1jDAueEjtUinqrU4Tu3vG
16719	payment	1726	1726	1874	1	1	6560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHqeSxuMtepgv82tGD3G5vpCrzrpXau6iJphSJ5h5haExGEb1
16743	payment	1397	1397	1678	1	1	7861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsTdWrGjVLqYeS3wdMPLeci9UbUXmmdE4GuW4CmnNqw748QgY
16744	payment	1726	1726	1874	1	1	6577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi6xpPUgjkj34rRcvXQDg9SEa75NT2ALZT93PvbksmTi2f246
16745	payment	1726	1726	1874	1	1	6578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmp9N5Vq2wyXi2jVR1bQcxMVR4EXGN4GK71FhX4yLyv9D4wn9U
16767	payment	1397	1397	1678	1	1	7868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UvgzwB9UhYCeFZpvsA9MxhGsiCgvt6L1pSLR2w6j489j8ZN9
16768	payment	1726	1726	1874	1	1	6594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2Njj179qjhao6wkjHVT9zbeLhseCzKX3rXrY6mg7QGbR3Rya
16769	payment	1726	1726	2105	1	1	6595	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkG4YdcMiaXHvCaz8bUN2Y5cuc3RYcrcmBKEMK5mVpm7HLUgTF
16770	payment	1726	1726	1874	1	1	6596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyomRvzhFC2ArJi5yKAw7o2wDCjL4ok8Ngp8BJP8EkjHWYukn
16771	payment	1726	1726	1874	1	1	6597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGjMrxSp8A4MWZ91pvYXWZjzqph6UQG1yBFCdGS8BkPeXJJpT
16616	payment	1397	1397	1678	1	1	7827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjRLCgriza5QKFFGzH4gcutDtxrq9gf5ETnYovd7vikDvFy52
16617	payment	1726	1726	1874	1	1	6485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBN2z5XGiVaWBEywgfgN6B7eGpWFkTHa92H55RsdWZCowGmsQ
16618	payment	1726	1726	2103	1	1	6486	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2R9CGf3YZtM4ucsJeZiiM1H9GcR3mUFvR9RFcfhGehTKWwuHj
16619	payment	1726	1726	2104	1	1	6487	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdywUavbw8vB1j8vA9VtzMJTUN1ceziLJhSJ1HPGbiLJAh79ST
16620	payment	1726	1726	1874	1	1	6488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wcHyggCrdjvHLReaMbcgCUaQpPLVhky9P578J7i4BejXV7R2
16621	payment	1726	1726	1874	1	1	6489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFyZ6N1uiLfdJ872nme3oH9gUrQHtcbTKenHLJUeghyizWF4D
16632	payment	1726	1726	1874	1	1	6497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq7M76ZSr1HcKnXdiCV1gyRjUb59iVxuQiHdckBM3MzYAQ7v5
16633	payment	1726	1726	1874	1	1	6498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68hnHHaEYgh6XvJYaxxN32jG5ijTG5juhSgLCaEoQq6rHHyYh
16634	payment	1726	1726	1874	1	1	6499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYek5v26UPQMwyoaNRvnWtZPCcmsFpqhaEEL5gxfHceo56zSUoU
16635	payment	1397	1397	1678	1	1	7831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUdVfKKMRq28uaXncjCWG8F6Gmq8hPpjr1xep4hSounxa285x
16636	delegation	1926	1926	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Z2pih3nf6BD49NtVXbbm27ZdexibwpHt8re5HqryNtZbCGU4
16647	payment	1397	1397	1678	1	1	7834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpzZ6sXRW1tpjP2xxQyKoBq3BGkqE3GucgkczSwT7oah2T5Ri
16648	payment	1726	1726	1874	1	1	6508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvLC9PgaVFaVkZxFdw2Cy6nR8XvhaL5F6hWD7FAnZWx9TTAGu
16649	payment	1726	1726	1874	1	1	6509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj5MGZ873esdwnsNFdosny1EC2WnQSZytp5dUF8HBBcZeSzh1
16654	payment	1397	1397	1678	1	1	7836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AbP2ujcqG8SddPx6MCTkMVHWMj3EiVUWQKkJ7wbXVfc37tKx
16655	payment	1726	1726	1874	1	1	6513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9YYBEJGkEVE3s5hHYzNKdjCYrKUhhtXxTmyRJJysMBj71knM
16656	payment	1726	1726	1874	1	1	6514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8esq1PLZJVjK7QaDpXs6UNuksUrjysHEtpQ3WF3Jk8gg5mfu
16657	payment	1726	1726	1874	1	1	6515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkY4YQAcGwbgcuekWxBiFTKEF1Az7E6ztCUtuM1YAA5sneiM1
16659	payment	1726	1726	1874	1	1	6516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2nPMic1tNbQxVNmipmb2uX5STAswpzLvyM38GpFCcU4gQ9UJ
16686	payment	1397	1397	1678	1	1	7844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKXJhsDF7Sxvo2ACc8P14FQFJxyoYKSmdzpNJSQZx9C8z47KS
16687	payment	1726	1726	1874	1	1	6537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwv4y7DTo26XqYT5MjRM7KhXrMAGZAxTzoQsQUypBreSNZRL7q
16688	payment	1726	1726	1874	1	1	6538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpRxqtixLHdNyQvnNsuyhd7U7Li79SxnWaF3DXypeWpd5254h
16689	payment	1726	1726	1874	1	1	6539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4WSEZYVDqdhTA7QKjXJNPtmYuV8wLonyawVyTiZc1d3T2y17
16694	payment	1397	1397	1678	1	1	7846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthv1nyS1VdPaMPBvJKmn2rX82KLfC7T1e1xBdyni11je8ogzm
16695	payment	1397	1397	1678	1	1	7847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3HCuWCYB8rHvh6T5USTKnqCrE858fGfootEeM6k1T7qTwZKL
16696	payment	1397	1397	1678	1	1	7848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwChdZnTVNPHdB1Skk3Qww6Yb2qSmYVJzXLFAzDcAXB2eAu9Z
16697	payment	1726	1726	1874	1	1	6543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu2qkd3tSqxyxAn9WUKomZ8yWY9eS8anKCpJSEFBssrkngv3H
16698	payment	1726	1726	1874	1	1	6544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSeEZVkCrx53Ur4W2wFKGfoCEt6YfgV2zC3pooAmQUwiQpHW4
16699	payment	1726	1726	1874	1	1	6545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvr6prib6ehRrfQ58ZumnzdKWoLkfu7PPKWws9UxkAsXvoSWM
16700	payment	1726	1726	1874	1	1	6546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zHJaQNoBinci6zdyFevijyF1D6nMQ1Sjts6pPBo9PR3vmg88
16705	payment	1397	1397	1678	1	1	7849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHurkDhmBiWpeQ6fGMANE4pppLpvvwU6hFF4QbHUPoCZay4P9h
16706	payment	1726	1726	1874	1	1	6551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTBbUNbzbdKehnKcLCzaJpraVBpoGDKeCJQncUTmNkyEdXjK9
16707	payment	1726	1726	1874	1	1	6552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs21B5EFDjvpoerQ2tsXCoEMW4wKs8H8bTLjYRHwgsT3Mq7bJ6
16708	payment	1397	1397	1678	1	1	7850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcZPpH9Sxwff9ATBP2kQuEAHschtC9Z9iPUfMhHgan7tC6iH7
16709	payment	1397	1397	1678	1	1	7851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsURv7PBs8byCqXpySXvt3MQbofRk6Hij1vFvGVLRSeVgrBF9
16710	payment	1726	1726	1874	1	1	6553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LMzp3r8AoZ49Gu92bENMtpXuSa4xNCYZbsCokYLdqxZB9Hud
16711	payment	1726	1726	1874	1	1	6554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEp2SeGkykT6qGe5FKToBBHw5xKFSveWqZNtvVAHFfMSoZYRDv
16712	payment	1726	1726	1874	1	1	6555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh1zGR7ffwMwPkxNxSRZ2npom4T5kM8qCrpMJFe5wFBpyjWGL
16663	payment	1397	1397	1678	1	1	7839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweT6FmHdbTgSgqQXwkMk59LMRyVCtSYTNmqw19ZzHFZ29DDit
16664	payment	1397	1397	1678	1	1	7840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAixq88RvaBDDMZG1CkkS4vg6uK396TcV1ZMhQPh4h5LPcs3o
16665	payment	1726	1726	1874	1	1	6519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDirBsmySaQ3KkfRxGtPgMBazyUjrBuUbQsYWmzQ54FXRhmzy
16666	payment	1726	1726	1874	1	1	6520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfYZk9kJ1H2fGngEoPWEjnyGgGi9kGNwgsrTQHdJhQGtUXPcb
16667	payment	1726	1726	1874	1	1	6521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWnYgvUK7sguwnMWdLPybVXmxaiMBdZhtBJWtKdbkYG2DY4vsW
16668	payment	1726	1726	1874	1	1	6522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHJ7aDGK5em4Zr8ZQUNCyxdBn14GWXNRZ8dqb6AtXCwVr2DHi
16669	payment	1726	1726	1874	1	1	6523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9cjcTbMYN2k2h5D8mu9QsFEUxkoKNoefsDf75BZvdqNxHeTj
16670	payment	1726	1726	1874	1	1	6524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTJq1XwWiHMrenGmiwmMHGtWrzfskMJL75MRkM7hNM4vzxMCp
16671	payment	1726	1726	1874	1	1	6525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoxKcbdNQ5VrpS5eiedSfYpCTNUoFPTMfCXMdi5VDgYamQ9Ce
16672	payment	1726	1726	1874	1	1	6526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrupsYaRTRdEbNtxEx7DGDfcPmTy3bWZJjcY7BipYiAVk6ytR8
16673	payment	1726	1726	1874	1	1	6527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBPaESm7AYHBXWxA6yAZW1YqnB4ETtzJeByYTRn3dXJnx4FnL
16682	payment	1397	1397	1678	1	1	7843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdArdZKTcjdBUoPaSQ2GtvPpdmWHuBXRjPvLsznhtXTtQURPF
16683	payment	1726	1726	1874	1	1	6534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLPkwkVhEURsYZQo2X6RnJvH4aFMDovMKnwEBwm1prmXh1DKR
16684	payment	1726	1726	1874	1	1	6535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4giGdGTUCE1VEvMXNf3XmtrMCfcTjmKyUMsh3CFjdv5RS8W5R
16685	payment	1726	1726	1874	1	1	6536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsCQZiuPWPwDNvaYD36VTg6KxJKxE8o3xJGFdT6FHNNXEZ83F
16714	payment	1397	1397	1678	1	1	7852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxf64MW3YyDsZzupErGAHH2jvX2nNZstF3R69CViUBt4H2tax
16715	payment	1726	1726	1874	1	1	6557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwsrdaSUoLcVvLth5K8c72wVzZETnRgsmaPygJBM9T1jEoWQp
16716	payment	1726	1726	1874	1	1	6558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGXkZZ5LcRnZwX9T2NdVxBLCexnsVn2FbunYLFuSwuYX95c8r
16720	payment	1397	1397	1678	1	1	7854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8uDWB1jW23WqTtvN36WynfQaJbzaZ7yPoNoVzYXbDYB3oiSJ
16721	payment	1397	1397	1678	1	1	7855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxrUieM9HyBbCmyGQsPQVJ8fdxtX4LswmYZQSgsvb4ELeAQxh
16722	payment	1726	1726	1874	1	1	6561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWrPZvqJiCYJ12SSpmhs9mF6uzYSFG5e5QYnvtj3rGa36jAt5
16723	payment	1726	1726	1874	1	1	6562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75YMH8NmbEvzdugwthemWX5wX2BBXzd9pGaZKjZdGfYzkjjvF
16724	payment	1726	1726	1874	1	1	6563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BGko1KfBPy2Ly3pvo1MSiuoAukgKU1fCm5vuKYdQp9JEYEYy
16725	payment	1726	1726	1874	1	1	6564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUtXLE9g3om3z2aufC5SiDQbUSNenuf9PjC4RHzhg84hgDn5X
16753	payment	1397	1397	1678	1	1	7865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2gbtfDUYYBAc6XFMGZvEdEBnpB3pLr2jhEWioqw37MadP41m
16754	payment	1397	1397	1678	1	1	7866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9Zmh3Lf8mtarJ8Jq26TsY8kpgyGcMhKqLH2VSSfnp91CpkgJ
16755	payment	1726	1726	1874	1	1	6583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtwMPJtFjxKqaguZALfyr6XbqcUj4Ey8TwSEmGQnn8Dk234Yx
16756	payment	1726	1726	1874	1	1	6584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMw7nBuENq7aZhc4v5RG84XHf1Hzv4TcFqWQgW2nMf1VjrJzEV
16757	payment	1726	1726	1874	1	1	6585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cSxVQNZeksovRU5tJgcfGMNeQ359gDT4swMjxLDbnmGnmVDv
16758	payment	1726	1726	1874	1	1	6586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsM87vyuMWjRQh9vyuRmmaBLhgwZr4Xpnou8kbNzobiGxEpoFX
16759	payment	1726	1726	1874	1	1	6587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumG4yo14N95vhqoGaSJckTBnSvniLzQp2bjvQVPbvUFU6de6e
16760	payment	1726	1726	1874	1	1	6588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxw6V3DFq1aMuwVnR3b6Hx3jM1Mfod4pLpVwsmmyxVQ8ag8Lz
16761	payment	1726	1726	1874	1	1	6589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZgHHg7QyAco2MrC1KuA3TXNXscPFALZzEXEFyN1wtf5tVsmz
16762	payment	1726	1726	1874	1	1	6590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvbgjeLqD7eggSxkBjC6kiLQ1nGBivK6DcJ38a9ZYKqjZSsSr
16780	payment	1397	1397	1678	1	1	7871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfh9WiFAWiYeQHjTSoKAK5nJ3YUBHZki13Ri8eEAYjZATpmaZ
16781	payment	1397	1397	1678	1	1	7872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9h2STxAwjFmbMcshixZRFrSSixH94DCrWAb2W64oKEuQYKQM
16786	payment	1397	1397	1678	1	1	7873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRqnjusTe2Ut6Q3tYacNcBM9bqCGMmYT5VDtWxEmRc7f4hPcg
16787	payment	1726	1726	1874	1	1	6608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGapKikwESGWgpGqVxhZDnvLzE23V3NQQLEvuh5soZgJsudNQ1
16703	payment	1726	1726	1874	1	1	6549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2kk8m4pXEKFNLgEZ78q9QTAgmeQPQQJj97YWmsXRQFmdonwq
16704	payment	1726	1726	1874	1	1	6550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbgwcb3gPm5u5DvkfTgjkur7RCmvR6Zu2CabFtdYkJ9Eh43dk
16729	payment	1397	1397	1678	1	1	7857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtH1RVstgmt5rSJU6gbuWz2zSJCB7cczE8MwFUzBwwix2NddXw
16730	payment	1726	1726	1874	1	1	6567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxS8iebwsE8rNgEaWZJzVwBsKSZhbv6YxTWXkFMPUuu575pYbw
16731	payment	1726	1726	1874	1	1	6568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAQ4SBFChawKDuo8pueCxBqqFWKA5vQ5Rs6aj4BL4pFCE5Wz6
16732	payment	1397	1397	1678	1	1	7858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AuFVMGdBHsh7N8hS347d5gdfYJtF7FcguJKGnGTRC2U2T3TR
16733	payment	1726	1726	1874	1	1	6569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRobNTyqXcYjuQwK1GWf4skPNwgn78tFzafZwzo7mN9tzuuS3n
16734	payment	1726	1726	1874	1	1	6570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj97ot7ZWSmSGKAMEvv1skYuaEBKLFLjUQM9v13BMLwamjzRrK
16740	payment	1397	1397	1678	1	1	7860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoQLHtxoHbmjByAWFZWBvLdAwv17HPxMYfBZedYcvhop8YRTj
16741	payment	1726	1726	1874	1	1	6575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUsdDQrrdAAYUrwhx9BaTAoFQEZcg5bkb4C3g1BVjS7VhAA41
16742	payment	1726	1726	1874	1	1	6576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNrM1Mms7xMtk7EF5AEAK9eAXXg5Uoj8AnKURKWW3N4zXvUru
16752	payment	1397	1397	1678	1	1	7864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9mN28uiPgQeBCPvUhofgb6nxgjAL1k7BGKtTbsZvJKD8c7qF
16806	payment	1726	1726	1874	1	1	6621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfwe4x3d3UhGNDGE9eZ7XsJ6TEtfL1kmanPLHKYv7vixHaAfv
16807	payment	1726	1726	1874	1	1	6622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTU7dQxZR9hQdTJkRs1odVAqzmQFZCVcXHyNN9aosqQWyhFzs
16808	payment	1726	1726	1874	1	1	6623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtn6sxA5RwHYjG2md3iqdtXEeCGWELbGQ8KTXdSkRJiZV59gcM
16829	payment	1726	1726	1874	1	1	6637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcue11HrZZBykrSLZ1S5JLeRDGKFrBC3U2nWXccP21LyxVfskj
16830	payment	1726	1726	1874	1	1	6638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCg9ip4KMNLzoCbkJ4JpXsDef1dsxLzWuofQUoZsbLqQPzTPD6
16831	payment	1726	1726	1874	1	1	6639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSj6m6uciXCi1WtJFWFWd61M399ZmJG83LDRNVDaXu3iHG5ZBW
16832	payment	1726	1726	1874	1	1	6640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxUpxvsLXfoUjTwpDH7jqqkLLhoFGZz6WARzfNp9KtEh8J9p6
16833	payment	1726	1726	1874	1	1	6641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1g4LXWRS7mWgsjrRdDMdPwipnbP3cGDh2KePqMA19wCvEo5F
16834	payment	1726	1726	1874	1	1	6642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8szUQszC2gwCP8HtVugPZHShUkVDx93YJoXJEAcQ2fkNGjknD
16842	payment	1397	1397	1678	1	1	7889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHzsxWXyENr3tFQqksHShXwrhTQbdbDqHWny4iiCbMA4y6SKu
16843	payment	1726	1726	1874	1	1	6648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrNnwBtmbTvuo6KTFqGqRBYjfmiGfFsXhuYJQVyEz85rcLwej
16844	payment	1726	1726	1874	1	1	6649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjGJ5qH7qrMDZjt68a1WygmQndBzr7yGvBaYtBfhQfS2yjSAZ
16845	payment	1726	1726	1874	1	1	6650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7juFD6q211tu3qo9bYD34ztAQyz1pDkbtLzdmHE12ELM9gZ1
16866	payment	1397	1397	1678	1	1	7895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrGtR9R5uWUrLCfLRWrqmDfpxBs7UkmZiXVG65w44W29PLbXN
16867	payment	1397	1397	1678	1	1	7896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPdKVGSA92V915z3cezjqcyp7aG5WyEj1rF57Sa7tLoH5PS4Y
16868	payment	1397	1397	1678	1	1	7897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCV1H7uNfQnBVfzzFY3yL8UjArAedpeiHaZJucatbhQ3r8khSM
16869	payment	1726	1726	1874	1	1	6666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpEyzNrDdydL8Uzu7axjnHSqHqz4wiWmXtQjsua5tAe3ikb1G
16870	payment	1726	1726	1874	1	1	6667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqpvcxMuUs95STZrozDZE2MxSGR2KnP5XfCKTdoZNQxqYUUJ9
16871	payment	1726	1726	1874	1	1	6668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM99wHazpX3qYoufPrw1neoqbQYtjDfWMrScsBkkZcTWsPWZiV
16872	payment	1726	1726	1874	1	1	6669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA4LDWc6gwL7RjHmMQgbNoXFj3m7W9bo3gFxvhYhA2cuS5qbZ
16873	payment	1726	1726	1874	1	1	6670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgzJySWgUQFxdoPKMMUfkQpgxUx8rsQk8b2fJ7jSNcv2USQpe
16874	payment	1726	1726	1874	1	1	6671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzjYZmF5TQyxaCJYttJAWFTvYVYAuY1HqvjwENHXkeTmGnoGS
16875	payment	1726	1726	1874	1	1	6672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bbuPgDfdA5b3MvabGu4znMaPTJKfNx1JfgA7kV1RRBTfLsK8
16876	payment	1726	1726	1874	1	1	6673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8S97z4HicyVK3njtSqCYbjcwoRPXeY3qfRVLYSgr5b6BWfZE
16883	payment	1397	1397	1678	1	1	7899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDfJR8n5YC1SxzJaTs654aPvtNKNZULLabB8PbffunsmnJEfW
16884	payment	1397	1397	1678	1	1	7900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAdumtxFxQZzcbyQjrfE2Nq9WGuGWYpyxM5m9rceFqAir3CES
16713	payment	1726	1726	1874	1	1	6556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2vFgfbPXk6rxE58Tx2sTVa5eV8i2obx5v4pGEVNdbLEtofei
16726	payment	1397	1397	1678	1	1	7856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHiSqYJMW3rKEYyjrKMGtTWoH4gQW2S6Ux1dL8bZhosmUGSPQ
16727	payment	1726	1726	1874	1	1	6565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWLpNq3zUBbZZdtzL1fteHzrEpz1fGqMjYnwkuh5cwkkXE889
16728	payment	1726	1726	1874	1	1	6566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ydt4dh4XW3UXSWbYnjDZiwKKqTf4wLTfE3gtcVdzfFgjcZWU
16735	payment	1397	1397	1678	1	1	7859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkDaSNULjnkKEp9kPp6ubpB8oD1LZVYMevC1bThefUnjw94LAh
16736	payment	1726	1726	1874	1	1	6571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPLXmpKUgHPHR4Xa6imx5eAQW83w7Qzx2V7ZuFphYyBdH9E17
16737	payment	1726	1726	1874	1	1	6572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1smLJDeBuLHUD6ooPCJmrvNARhMczN7tNNavt5QJL43yT4iJ
16738	payment	1726	1726	1874	1	1	6573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZny7hCiYAMx9HwaGvLjSu87rA63W6HndG6HoJetGD2nSVmDfED
16739	payment	1726	1726	1874	1	1	6574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpUnBk4U3CFVEc4xx89HKx3BzkRF7dmZgnBr7dHxc9PWJTuX6
16746	payment	1397	1397	1678	1	1	7862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Hav5wnNApgEN4Sg4sYYtHTQr7CECZs8MeJyuoBuay4CEmux2
16747	payment	1397	1397	1678	1	1	7863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGXs8nn4AsMEAfEVW9f7ZonHepRuLnAwxTxStBA9fy1dDwpqZ
16748	payment	1726	1726	1874	1	1	6579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TtGenvWvcaiE7gbXcJHtMY5Yet3ML9wuso7ZLABMocsREDTc
16749	payment	1726	1726	1874	1	1	6580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABQzGE8dXAgM5WnujHJFnHPaJHJQPbFjndWwjX8kwcze6ARdo
16750	payment	1726	1726	1874	1	1	6581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rUX9xKKEfsW1CqScbu3PgseZXZHVjz4soYZ14hkcMdGNmwNh
16751	payment	1726	1726	1874	1	1	6582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcKNcBWWgTSWEDFjsp5ypg5aEB38eaDxdrWPNvKJEriuigdrW
16763	payment	1397	1397	1678	1	1	7867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFHWFeXKt48PaN8ZT7FRLj7pFuQW2uejuL9MwBHiFzfi7qkx1
16764	payment	1726	1726	1874	1	1	6591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaLVHbsfSoeezRYuDRwWS6nxF4wr7AtmE4DGqSfMLHmvMsAXg
16765	payment	1726	1726	1874	1	1	6592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn1ZCE1HHuzPTWs2SZpFmtCCJfNombTbWVwQ7emauMkFjqeP5
16766	payment	1726	1726	1874	1	1	6593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpe3ZgwvaBXt89vqK3Js8q4KWzTAPuiifXgEia4z38rCqqGErN
16772	payment	1397	1397	1678	1	1	7869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPos9p4brqyebvK92ZtBSiQEsKcXPdF3K5pDVD4nf4jbU5NM4o
16773	payment	1397	1397	1678	1	1	7870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEm5pGBN5YBJGp9KZCUstURYpdB52uhzaEtGm85EiEajQaU4v8
16774	payment	1726	1726	1874	1	1	6598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZ8SvvG5jHZvVGx4Z9iuyUPNs8QeKtFxDKA4zFfYkeDGVpbA7
16775	payment	1726	1726	1874	1	1	6599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPiUdBJKuWms9WtzxLNP1fNkiM7BmxrS5kRsFbuWKNfKK8psm
16776	payment	1726	1726	1874	1	1	6600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvobUmwEPA8nEv9tsf5NtcNzcSq4HzA195eymbyXDXWRMAmJa
16777	payment	1726	1726	1874	1	1	6601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxBT79on3uEoafL7Hvri5nAHHNkPqxAruy7t1aXmVe26nxPay
16778	payment	1726	1726	1874	1	1	6602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLMoGumN4sAt7Mu6imyYdW2C3P67ksfHzKSmbyUz4WXuso8HY
16779	payment	1726	1726	1874	1	1	6603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEd3RfKXvjhZiJFfFR5ZzXBrZuCJhuzd6AhbvnZ1aSKaHv9Y8
16791	payment	1726	1726	1874	1	1	6611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36wUSZvURKg249MFDiiWEF4fSYb4ffRANZTFmuDHKd5uExyJK
16795	payment	1397	1397	1678	1	1	7876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW3BBrH6sZcyJMoj8qzaDe6iDYLpkMaLdeNZJM4yNYFYbVAMu
16796	payment	1726	1726	1874	1	1	6614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5QxhZzfx1qiCDA5wwdWQSR5dPi3hR3zpXZvy18QHdPgHhX3T
16797	payment	1726	1726	1874	1	1	6615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjHXmDbqg1fYuJmkE5VPJzKktfFF3gHd7J3mkFxBWq8mut554
16798	payment	1726	1726	1874	1	1	6616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyEmbHtxpz273h7K1FXN9zjxAkq1xzhKnvQyhGMyX3V28XMgy
16805	payment	1397	1397	1678	1	1	7879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUV4EWskipiuyzQHd8sM61rTpiQgouJ3iDP7A4rgwDFoXBRhT
16812	payment	1397	1397	1678	1	1	7881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAYLANhQYDo6SKu78ADrsQki36DHYSv5nFKEipDwFA5SKtNog
16813	payment	1397	1397	1678	1	1	7882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hXvJ2tfbyBK5LbExgTF71MxgFgWqFAWBu5YujxTqiUj39oyA
16814	payment	1726	1726	1874	1	1	6626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3WPvCWnv8za2PJobLpzxMs1nyLD6SGoq1b5SXFzQs41QaWmE
16815	payment	1726	1726	1874	1	1	6627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQb3yt9RpDpxMbyQ26EpuJAjWHhaADsAtJQG46jzpqDeqcjfkY
16816	payment	1726	1726	1874	1	1	6628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHFxoYQWh36o5jTtpzSJuHwt6cUjMTicCr4XoGV399Y2jpf8J
16782	payment	1726	1726	1874	1	1	6604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWhWe914CSKgh4jdvQnZwD41rLPtosUwSRY4Be62EUzPARvra
16783	payment	1726	1726	1874	1	1	6605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQwx7Mb53bjDQe2nf93ghUGNbW42QRDX6V2PTidC5dE1Nqeam
16784	payment	1726	1726	1874	1	1	6606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMuoJLznXPajm5MGXNyb2tnGYXdvAkN3kru2CUUGmhGgDcWRY
16785	payment	1726	1726	1874	1	1	6607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnmTkpFFAabkWAy9rnm7ozgDHKHFYgD7zXELaF4K5spRFyh88
16790	payment	1397	1397	1678	1	1	7874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNoehLPxjcWfBRQpt7DJ1WscdG9kRkuuTNDccU8F4LMqoBZng
16792	payment	1397	1397	1678	1	1	7875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr95fzdM6KoGXDak5dEto5fyw6SvadxuYka3KmwV7J2h8aP1CK
16793	payment	1726	1726	1874	1	1	6612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMQZfa2PodeFZGGgEafdY1rF2w5WRxqcGak9Bc6jBgCcgQmns
16794	payment	1726	1726	1874	1	1	6613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZY3ino1tRVybjndsWaVtW5a1TftwGNCV8BgDFK463ftS6wwtC
16809	payment	1397	1397	1678	1	1	7880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcZ5yrXvLMJuJTZeRCFVPYTAv8mxM8hNzXMp1xs2hfTUSg9nM
16810	payment	1726	1726	1874	1	1	6624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFBXz9r92fg18hjXzDL4G9sfWZms9Vjehr2WPMhvdTc6fYzDj
16811	payment	1726	1726	1874	1	1	6625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfT1ViF78py3nF9zhvV8TVhwDPEAJEtSAjjANVzyV5vEiwmAsb
16821	payment	1397	1397	1678	1	1	7884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJw1VTuFyyA3geprzygcnKmkL2gHC1D3twuTd1PycFPS2qeett
16822	payment	1726	1726	1874	1	1	6632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFp6ei2FYyjGkqbsRkafo68WJfPqeDCGghsi6qwT89tdazH7E
16823	payment	1726	1726	1874	1	1	6633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvkAQcFJKX3irC2gohUK7GHDaxmLa9QEYkmBpviAR5jMs2qtD
16824	payment	1726	1726	1874	1	1	6634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZ4HwKWtTSiqhtG3s71CxfdG8i9oGUrGVg1eUUV9C6UHeCBjD
16825	payment	1726	1726	1874	1	1	6635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAebAMGmANv4MoP3fmYECgA9vwKQgZ6JivWmHRkGGRttTbHXS9
16826	payment	1726	1726	1874	1	1	6636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSk6e5t3seN689cfGXyqHhf5jd2FmE4yzmi6cPpgv332TFHU5H
16838	payment	1397	1397	1678	1	1	7888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMn8wukHVmjT4zRPEq8am5J2HMVHhuWpDRxt2bqn81ohRjRAbp
16839	payment	1726	1726	1874	1	1	6645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgBjkdn5iPBiX2y9u9dagQ3txJk9Mkq5nk5U6S1JD3fUWS9dN
16840	payment	1726	1726	1874	1	1	6646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseZTuzhGD3t8CbvPg3m6rNX8Kk9WR3JbExRgCtSZZGVXRHNip
16841	payment	1726	1726	1874	1	1	6647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79dZR7ArPUNNiVyXVkkydor8uGA3EdXiuAJKMq35Gh7kFzUuY
16854	payment	1397	1397	1678	1	1	7892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22BvZNWQH52NERSLS6GxTPs6dxM6F9V64UESYYcSmrZmff5NS
16855	payment	1726	1726	1874	1	1	6657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5vJzDi67vcumbNi85gywGLyZHT6qMC8fHwZvovjUN8XKSLHM
16856	payment	1726	1726	1874	1	1	6658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMpb2T8y8aB83ER3PLmZfyHdJFEsFFAC3caWyUdFTRmGVC5WA
16857	payment	1726	1726	1874	1	1	6659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAJYgm6LzccKSBKLrNv4w7qcErLD6eMU5v9WNuN2ZZgZFd9aL
16858	payment	1397	1397	1678	1	1	7893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQXwjm2Nr9LoCXHrxZe2nA2eQmKGww8aKmeLUspisKyYUSHCc
16859	payment	1726	1726	1874	1	1	6660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxwfKbHKHd3wYN6R7i6eMbYxWjXKg579H2C1Ys57CN8HPVXMG
16860	payment	1726	1726	1874	1	1	6661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpsUQ3FS6UdAioaGKT3aZQ5hZzqqC7HGCuUHTRan4LBDAVdUi
16861	payment	1726	1726	1874	1	1	6662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTKAZ1hwDKmDiHnAN4vDYbd2TcWdVCDrvNpj5v4c2ox4gZ5oY
16897	payment	1397	1397	1678	1	1	7903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXuPfVm62y6WDgHsGtyr6JgNqPscW6iTyZy1rZ8idnf6ZLGdYA
16898	payment	1726	1726	1874	1	1	6689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFRhE7TXrg47bzUSm1KJV7w5CSmE8DeNwRaxEwfCwtxWBwxgme
16899	payment	1726	1726	1874	1	1	6690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2MCqVPrNL1JR94ohnWXomx5cms3m113YUkpDEcYwwcKuUXJp
16900	payment	1726	1726	1874	1	1	6691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BDB3NG6f5BfHbm5NqxoTHJiNp5Cz4tDN7prMNPh3ZQyb717v
16936	payment	1397	1397	1678	1	1	7912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLo5zWfgvZiQyW3nAUu6CmdVKhJZdJVc7cPuXMq2YTD2CYzNS
16937	payment	1726	1726	1874	1	1	6719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71NxBAH3eNgf1Ky9wGugt1ocASaoEwjVGfLzabEXcGMQnaMQa
16938	payment	1726	1726	1874	1	1	6720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTxgcz1ZR8MJb8rAuYf6oaYqGe6qiqQ61usshvAqsq97LXrrj
16955	payment	1397	1397	1678	1	1	7917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5TtZcKB7a8vV3e4QU798KDyf99YJoAMJY6HpXWUQ6zSicVHi
16956	payment	1726	1726	1874	1	1	6733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXvXBpkGqMvRBS2xrkREbegizXa4rYexihJciEJaoNUJ8GaE4
16788	payment	1726	1726	1874	1	1	6609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHb81YhFNef86sfYLz2EjF7zzDECP9oCUav3ZKANxfudopJpm5
16789	payment	1726	1726	1874	1	1	6610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7bTqMLGg2oc6DjzwjR9t4bMepVaVrMuuFbKS1YTLLc39ZjTL
16799	payment	1397	1397	1678	1	1	7877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQ1kQGGVpZxiQZiwr5XMmbPiPWLYeHNDMUE4VShUtN7ZhyKGf
16800	payment	1397	1397	1678	1	1	7878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHWtQPegb9JvuP6dzA5FFjpAynSe6cqbpRPh9AWaQRGDdrzYT
16801	payment	1726	1726	1874	1	1	6617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzra2nJDx9k6WTwv3JN8sokUsofYjw58LEYAD9sp55wPp3UALK
16802	payment	1726	1726	1874	1	1	6618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7aKTMw6YYF9Kz1Cq4g1Ueed3aoTPZNAc8WMgqZhEdgD8TQf2
16803	payment	1726	1726	1874	1	1	6619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG5tvLvv8Lks9CG2fS6TJpH1fxW2NkWQybSMRpZpgWmuAQKPu
16804	payment	1726	1726	1874	1	1	6620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7gq8Qn2hRxNexKurku9fr3CdNvv9N7HkGdJgeAYxpTh6AYw5
16820	payment	1397	1397	1678	1	1	7883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGtC6RiBP52Sjpz1r1ayS7L2eexYPpq1bYbYKEFS6gLmkg12R
16835	payment	1397	1397	1678	1	1	7887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXLo22pa3qqNJTbdErb7FmML5s1T2MC8jZQ7KpAgXFdMfA8Y9
16836	payment	1726	1726	1874	1	1	6643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nXUddxKsKe411mjVvqQbNWBYbUbWjDDSdNEExQgNCZXANxAL
16837	payment	1726	1726	1874	1	1	6644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiubgFnJvwRt8xutGAbpyezfC24s9ywXcbSoRgSBzRLxVqNhnX
16846	payment	1397	1397	1678	1	1	7890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUStCizMSy87AUbSkpBvX1Cy6NhM6gaX3ovHtDnoU5UNbiPh5j
16847	payment	1726	1726	1874	1	1	6651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5G4jsvC6AihSX86K56B5LwLQXGGmYW55irXJ9ZUxLRA8BE6VX
16848	payment	1726	1726	1874	1	1	6652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwK9UVyPgieNbBpkAaScX7PgfNxEfo5ZXMSzoo6a3Kc9aVB7Nj
16849	payment	1726	1726	1874	1	1	6653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWUVxDGeKVLH1erh7eV5ZM1cqwNcH3EGaNqaNYwt2FXD4Citz
16850	payment	1397	1397	1678	1	1	7891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe37ydwiMM9C7F8mktBmf2w1ditj8SsWViy3pCZ57KUQ4SM6Ap
16851	payment	1726	1726	1874	1	1	6654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1Tb6agsnRn5rjnDXYp8HLYXHCboeTSJSkZ5Znk51igz9AhdK
16852	payment	1726	1726	1874	1	1	6655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfcZyTCT8nJfgKHvbucp1wgnA287tUbU85j6idkzs3wqjexA6
16853	payment	1726	1726	1874	1	1	6656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Tyqqnc9AtbAMsYJXstPQDNoHgQG28vbd2cJpw4Fycx8Ys7Mp
16862	payment	1397	1397	1678	1	1	7894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kHaCKszMzXiNeBCHbGj8EnwXwF9WkkzZSRmiXx9hLK4on4s1
16863	payment	1726	1726	1874	1	1	6663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREjHWLrvu9Jbs4kERfP7fKGR6XaaiLkZ2ppBn1woApW6WJjxm
16864	payment	1726	1726	1874	1	1	6664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ns5FFrfw9nSRjQmxYnXo2EteqEsxtoWY3NqG9wER9vuY6YWT
16865	payment	1726	1726	1874	1	1	6665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfUHrLpXya56NXuBXsjdL3ZQn5hNCGU38Ad6LAPrYFXVT2Lpb
16877	payment	1397	1397	1678	1	1	7898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AjV5WyXbsHZH1YqGwfZ9TraTMjofcq9Pv48DNFENCaAr3aWj
16878	payment	1726	1726	1874	1	1	6674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTq5AmmZmdKLC5uE9cmsXhpXYCDmpMqYxxKjQtW2Lns1hH7vTu
16879	payment	1726	1726	1874	1	1	6675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcBdXAJK5fohPz8vrxWpcHvKz3ftP4ZVF3PwerqxTxUHV8q1D
16880	payment	1726	1726	1874	1	1	6676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgBaWFUDgjqxwekMNttLyvGEVWPMwqTAQ2JG8YvBEwZtbk3ce
16889	payment	1397	1397	1678	1	1	7901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2p9MS4UseUsegCKui2vutPdtqhwTZBZNvgngdsARMu16unWG
16890	payment	1726	1726	1874	1	1	6683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPAPbv3ALkZ35MEEosTpx7Wi99ner7ziYRpzZvpePmnibRiVb
16891	payment	1726	1726	1874	1	1	6684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxskzEMyjaaYfHDw6XvHrm64aChcAkgLat3iAiFyVadMt2zDsb
16892	payment	1726	1726	1874	1	1	6685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYep7G1EDJEYLRvHz4bAwDjaedZWNCKCX25zYJNfBm744ChwN9b
16893	payment	1397	1397	1678	1	1	7902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8ZFKLFPY3M3oxApbNki3niiVv6cLpbQu5Kia468xaMRDPvhX
16894	payment	1726	1726	1874	1	1	6686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMAKMwjCMdmqp67YRVEfLRmU2qbaQio1MeYWU1kf4YBMQj8BX
16895	payment	1726	1726	1874	1	1	6687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXx5bh6RX1xwxaagWVjpeQnyo79vHs7r2XPG2RYQ7XR1phs6by
16896	payment	1726	1726	1874	1	1	6688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZJXiJVvxHybb7ZnL1caUswTBifpmrkXvfqTxxBfKb7uhVFhU
16905	payment	1397	1397	1678	1	1	7905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQgQorxSmJdV1j1hmNWvaqFxoxtJxNVoXfak787rwu3DCpURo
16906	payment	1726	1726	1874	1	1	6695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Rq6n3aQUYdC9HVupZdVSmKnHkhYoaXn3sDhxHpgkmegrqefq
16817	payment	1726	1726	1874	1	1	6629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ABsv3i7jQKXGbgGj7KofXK2Dud31kM8f9NyEwLqTMZHcJtUG
16818	payment	1726	1726	1874	1	1	6630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuHkK8GYTgjvLZ1BGeDdz3LrRAR4NLr2CWsvf7gUV326ajN6Y
16819	payment	1726	1726	1874	1	1	6631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Nhi4yD85MQZW43gFCFQ66YPabz2jwRyGjyX6DUtBqCNRRuYZ
16827	payment	1397	1397	1678	1	1	7885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCrFawkNrU3tdL88xwP94UU9rpJkubbg4wJsxDyRiqDT5xDJTh
16828	payment	1397	1397	1678	1	1	7886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tqv7YSqbZHec4ZvuhUWtb2PriNXXXiZ1zgp2cVrVYDyokTBZ
16881	payment	1726	1726	1874	1	1	6677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eSN1LzVMSMGNsxzzRaDnpTFD9nw6yGDxgt96pUpmBbTraVhx
16882	payment	1726	1726	1874	1	1	6678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ3xsdBGhWu4LnU8u3YKwWyBMLApzP6kxNRBJSrW9r2yccw3Q
16920	payment	1397	1397	1678	1	1	7908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwr6YcYgA4MCiuACRX4oUrvyV51dRjj6mSWpKSdUrxTq8uQZBE
16921	payment	1397	1397	1678	1	1	7909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhWRF6zbBmymmd74TFZEtGoZU1vkPYGmLqE1grhocxDeswWdW
16922	payment	1726	1726	1874	1	1	6707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcg5cGYSJnY3N5RM3H5vxuRyfRxXRpVsPVTKWfbmqh5YmufrvY
16923	payment	1726	1726	1874	1	1	6708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3sawoZAg9DefNf8Q5C3JfZ71YMZ2SsMNs6x97GuiE1jDXJRY
16924	payment	1726	1726	1874	1	1	6709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAQ8njJuXoLt6q9o1gxjJdcmse67t49yqT5ouqAjH4hrinKit
16925	payment	1726	1726	1874	1	1	6710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEYjFsGoeHJFVEpAZkVog2bdSXrJuykEYgqfVnCveSGKeSM4V
16926	payment	1726	1726	1874	1	1	6711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLCJN3RmL7jmcHNwLfZ9yRxKTNZ6fCsd93DufdkMYmLi2QmoD
16927	payment	1726	1726	1874	1	1	6712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8umYQ7jeTZ5XxD1giRG8PewU6iE3HPtk9Qrt7zWnDMC5a2zJ
16951	payment	1397	1397	1678	1	1	7916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQfWLbKpUUaJWDV2tFPEbjg3fPkjf48adFR9XfHSUXmPNufsY
16952	payment	1726	1726	1874	1	1	6730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkACcLMMfZkFxcUCDTtpTkF7oa9seGtv7ULKh9ePNNy4DiGjGC
16953	payment	1726	1726	1874	1	1	6731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6bmdhbUJc6G8wqHSy6VFL3K2zi7MVRbXiJA6FXeGkhj1eBM5
16954	payment	1726	1726	1874	1	1	6732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbpArY8sWD2DR5s9exNcGniYiTTAzuQxvG73DFmsrZfRm9yJG
16966	payment	1397	1397	1678	1	1	7920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxx4hQAR4mXdkcDMxBHv1Uaa3TeE3DchgFSmHRXkk9oA8d3WJ
16967	payment	1726	1726	1874	1	1	6741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkYHDTPwzbkxSt4RY8HB5J648ijBzYtDyjHTDrgRGQcdXYWYm
16968	payment	1726	1726	1874	1	1	6742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UufKskeFdqqGvhf4WbJk5EWm2eaSUGiKiypeQR6fJupvJaSx
16969	payment	1726	1726	1874	1	1	6743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxng1DrS3Fmi1Gb8NJfaoAZJAjbuKNtrYrKofFKwWJXtbsEN7h
16986	payment	1726	1726	1874	1	1	6501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFSmrM3uijZEp4yqsj8XUbKfG75E6smHbfwaPXyC974eeuYtM
16991	payment	1397	1397	1678	1	1	7926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszpmGBtnDMae4X75YctQvrdsdqiv4TzCHktYHKfCnzJQEQzmw
16992	payment	1397	1397	1678	1	1	7927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLJEKc3yr4hXCvMWimLhSVxKkg9PtnZpnVRdxkFBZQfP45Des
16993	payment	1397	1397	1678	1	1	7928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpNudExBG8NwKvKycTLPTvuLXRvico6aJCB81fQk2AiYMno5Z
16994	payment	1726	1726	1874	1	1	6759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvGAmrGnXSCqSrKuMLqXUucMR8ojQg86pyMN9eKUZzrwRszfq
16995	payment	1726	1726	1874	1	1	6760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouKZvCUrqvZVwu1a3KPqcbRNgZCZvMMBBUKsBnmAvK9UEXtzx
16996	payment	1726	1726	1874	1	1	6761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSeqZuquqrr9UCPtPACr7UCkGuWfst96ZMACBho124XwEbis1
16997	payment	1726	1726	1874	1	1	6762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuMzVRGRV9hnqjj8MDoBFPAyaH4RF5yraixKQQs7DUzBn9Nc1
16998	payment	1726	1726	1874	1	1	6763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQWUm4HBpsdZ83S3K574Ck279NzThwndKDq4kiWYPDFTY3DDm
16999	payment	1726	1726	1874	1	1	6764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWeMm7hnwvjibBkqe63qJEe8b2eErKmc8vXmrc3UkRX93q1vm
17000	payment	1726	1726	1874	1	1	6765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaETRESaBXYesvbdpY9TpZsjxeKgDB5ngP6SdvTYZ4wtbzfEmB
17001	payment	1726	1726	1874	1	1	6766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUkA9wMJmScH9XifUEHJgZkXD2CiHYYyz2d3xE55Dz2Aq3vrN
17002	payment	1726	1726	1874	1	1	6767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gvCS7F3VjQvh9aDnCkfVnNvbeXMxE4aG87ibLMqyM5G8UdSz
16885	payment	1726	1726	1874	1	1	6679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJsfiw39rGFr9Sk2LVtXLBgyLdAV7b1XGVkR7xdnDPzBB9b9Q
16886	payment	1726	1726	1874	1	1	6680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyykpYPDgMQDEYrWgoiAj397rEUFxDho3p2yksaSYsbgExwRB
16887	payment	1726	1726	1874	1	1	6681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFqsf4kCNuYamGM9P7Tz9YaYoWyQDvHgj6bqqxvpKjQ3o6TEE
16888	payment	1726	1726	1874	1	1	6682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhwNFtQSuxN4Q3Lnq2QvzhXqZMcvEfTPnXG7dRS31Lv4v8VgF
16901	payment	1397	1397	1678	1	1	7904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtdMkyxx8xTHaAuiBifqSe6GqyLokDjzNKEg6VVZqYeYxJf7C
16902	payment	1726	1726	1874	1	1	6692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UfuVLAUnrQYfyN2gfN1mirFcauiCGDvRk3KDM2HsjQBGejo8
16903	payment	1726	1726	1874	1	1	6693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoTA7EFeHibvceD6AsM7g3cY47KUYzpV7Kf3gxtHc6Ko2AAm4
16904	payment	1726	1726	1874	1	1	6694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYWWkBk3DN3M9jFNdch25ZtX1YZcAgwe3DUZbgA8K6jooz2Q9
16913	payment	1397	1397	1678	1	1	7907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonA7G4uyzkSrStGqFmp1tKYv8qQWZiMVpdWvpLqhKnhVG1Spj
16914	payment	1726	1726	1874	1	1	6701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbyzPvUFmv8Vuh83f4UAQTeoEM6Rsc8eMCfSe1FQEKtSCiPFJ
16915	payment	1726	1726	1874	1	1	6702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RBxDNopxvaBjdzgicFJtewnN16uYDobAavue1aM9eRadNgBi
16916	payment	1726	1726	1874	1	1	6703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDBdkhdrpKTeQey7NuWu94DpHLY7zSNdx3MQoRD98weUkixFZ
16917	payment	1726	1726	1874	1	1	6704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkM35ikAWXTBaP4BtxS3ECvyF8jrSAv32t6km11Tn1becj6m6f
16918	payment	1726	1726	1874	1	1	6705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA92XxtguNAb5G3xdRYh6g7n4EyDA5TLyv69t4eFvSPWgZDhXv
16919	payment	1726	1726	1874	1	1	6706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p91mqxT6fbhvx9vQvXFvKZeG9gZfSKfEpgKLXHa9LA3FCysT
16947	payment	1397	1397	1678	1	1	7915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywkXqVY7XVsQ4iwDgW3hwZLzaUYRtwZuEna68y6MxH1nVxPui
16948	payment	1726	1726	1874	1	1	6727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9dA1HE1axcrsywXedh2FQ5LMLvqmu2gZmmhEk3cpgm9oKfPa
16949	payment	1726	1726	1874	1	1	6728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct59yYvY78sMY8QycrT6JJFWb4HVsMPfZiP7HtMNS3SQUM6uN
16950	payment	1726	1726	1874	1	1	6729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexknunHA7XbQBBzA7UozBtCSC1NKiDHA6knNZn4PY14WBhLHq
16958	payment	1397	1397	1678	1	1	7918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfED7mYgbtVTuDfDFsnXNuCg78C43UUaEeDeaNjv5AkGx28cH8
16959	payment	1397	1397	1678	1	1	7919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa31gz9yd4xDskbZ4v2LGUn3uWN3FZYLeEqH8oCanLZL1aHAJLB
16960	payment	1726	1726	1874	1	1	6735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSqPg1964Cn7pCEACY7DLjTEmYXaMLSotaHxW1VcXyJjukwm7
16961	payment	1726	1726	1874	1	1	6736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtyjH29MyB1vQjuo7Gn34vdzyUiTfvv9muPxweYdnFTyXd1XK
16962	payment	1726	1726	1874	1	1	6737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYd2f3n3xHFL3mPZLdUhim2d3iKBMDAULbWbBi31GTFo5jLBY
16963	payment	1726	1726	1874	1	1	6738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxeYSH75bD8Whk9mTsj7MmKrm7YPstH6TY6K62dpFZN7DXhVe
16964	payment	1726	1726	1874	1	1	6739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLxXK6f1u4oxNvRkMVcgGFnBxqEYcVHAqdzR2mJBKjhrFX2N4
16965	payment	1726	1726	1874	1	1	6740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3dW8jt3x5fCVPrTBKe9Bpi9nz5DBUVvHY9UJPxoguznC5r9G
16974	payment	1397	1397	1678	1	1	7922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7QP3j5a9esPnspgCfMLJrQMhyZ929Kna71WvJ97jdCA2bXLQ
16975	payment	1726	1726	1874	1	1	6747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbmfnBqKEzJsV45sK95xiany1mmHiJVqHJAG7vvoajmeN6Jtd
16976	payment	1726	1726	1874	1	1	6748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19vnFUUg5F769UScB9isLx3LN7BbBU6953ew3rWE7fBRit9SM
16977	payment	1726	1726	1874	1	1	6749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHL5XsWm5oKK4EA3m4rhyjU4KveWZBvHonZHVzoioZibmCBgn
16907	payment	1726	1726	1874	1	1	6696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4Ac35g6uvFRCEU9mhkYoi6QcbkjuNNocuYGK7sK7DFWv8aRs
16908	payment	1726	1726	1874	1	1	6697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyExvd61KK7DE5iyWMCP6bf6g2VbKHrndLFhEpEfBjmyHRkndc
16909	payment	1397	1397	1678	1	1	7906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hDTV6QXBiRTHxBSr11XHoS6TigHg2Lo19HPJNsxrpux29NBn
16910	payment	1726	1726	1874	1	1	6698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQ3ozPpZgUR2gRRv78h2igaEwhR6rGGaccUo921V2JpCVUuTY
16911	payment	1726	1726	1874	1	1	6699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTuNdT71S2XVjKbtbPDfPYyEikk2yH5RhZtZUFgqYb7AKw49h
16912	payment	1726	1726	1874	1	1	6700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgi2awSgkq29xYH2wWFdisMWPqWLx2H4K8gvGNP2h4NstNetm
16928	payment	1397	1397	1678	1	1	7910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzL46xYHajDZ6teHiKGgjVMLy9GpbqVb7gVtLsb8CRZcM8Vt1
16929	payment	1726	1726	1874	1	1	6713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmibwxhpPJZKB7nUud49KqZSLVBQ2eBHSjYYzPWMzwrubeVuyD
16930	payment	1726	1726	1874	1	1	6714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MPdsGhiXob37zzNrAUBNP7JezVfvwgEinVsV9YG2mdKbNUdt
16931	payment	1726	1726	1874	1	1	6715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8niyVWfV8VztsmawzNqG7KaNE2Qop9e7Pe6dJsBFvKFUmDo6
16932	payment	1397	1397	1678	1	1	7911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbfhijXA6zz9nFpXDPWVEeZTQqKvrbSkHgrU6zdKWe816Lvfm
16933	payment	1726	1726	1874	1	1	6716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaf7PHRNTWCQChPu9wv3Pp88dUbqLyBAJyhNoh5XnbHw1QzBw
16934	payment	1726	1726	1874	1	1	6717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97qKvzwAVtPgbFk4TzFBowp7U5Vwfthw6rpQzxm4J4MUy9T8Y
16935	payment	1726	1726	1874	1	1	6718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoJmVr2MR1Piog5tQwRSnhFh8TejzFHgNZo6HLcTJeoyZFgTV
16939	payment	1397	1397	1678	1	1	7913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6RMUqdXMgxCFwx1HZvWMUKvakA4xqzMQWdYyt5gA6xMq8m2M
16940	payment	1397	1397	1678	1	1	7914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoETQrhHdJ1fauCrz9e5G4Xr6NkTepbmAGLtLPm1t4kBXqKH5z
16941	payment	1726	1726	1874	1	1	6721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUtGgiE6zgugdXQZ4oGw6PG42uVVnE166K2FmXFd2oSpXAvKC
16942	payment	1726	1726	1874	1	1	6722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgfCWK1hmZSd6Aud7qGzrFuezhBSnNwbfWkcvugEReJHk7D7a
16943	payment	1726	1726	1874	1	1	6723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZ9izxd4oHEj1gG6Q3WGo7jdFLQEWEinH1Kkff3igmpRDTzMk
16944	payment	1726	1726	1874	1	1	6724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYit8znZ25fqQFSZKAjjW1aEJMNxHHKy9fF5fEUQ45Smy8KrDSh
16945	payment	1726	1726	1874	1	1	6725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhtyyBEFivgBdoSgxNXmD7pSrsqRksAL56SAZ4exLDrNe3aJL
16946	payment	1726	1726	1874	1	1	6726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccDjYikUv8jhCSeWBAv4e3beTSaMFze49Xg9aMwznqrNBUd5C
16970	payment	1397	1397	1678	1	1	7921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2a7MSig4ugBtMBcqRmFJRsWJGZDMHEv6JDRfWLhGgECiCJho
16971	payment	1726	1726	1874	1	1	6744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLTV1NQZiUqrfx4GhitP8tbAS4q6Hnij1EZScaEp16E9dwN6j
16972	payment	1726	1726	1874	1	1	6745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvqgZoE68VMcGKFbxdMZhQhzQPUi89fHHYTk1U43UaXEcTfxQ
16973	payment	1726	1726	1874	1	1	6746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WcDBKK35S494n83G6BPXir2DYTeaPFDZXywj2DpwuwWP32D4
16987	payment	1397	1397	1678	1	1	7925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rnapBUysdeTVPp2iFdrAZUokN1DHpvBFneyfLNwyjtARMdq1
16988	payment	1726	1726	1874	1	1	6756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcu5cf5aQPARfhgTgEY6RqpNPE8eyzuJE5BnrTHFGhCHiKWbx
16989	payment	1726	1726	1874	1	1	6757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxvJLxwRfXVhZDfhQUTdES124g5z2gBvf9Xce3peKLNWyCsxU
16990	payment	1726	1726	1874	1	1	6758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUMn1BvC13gQSLzZJ1y7mV7Cb6BayQyCqKbaNvBCokCjaReCe
17003	payment	1397	1397	1678	1	1	7929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkUtRFLnGAquhjhUJz5fSdPc4iTEWfZjUWdeLx7KyTGw9k9b7
16957	payment	1726	1726	1874	1	1	6734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS327uFJXxWk55A6ZoWHs157xwv4DCdUQj3LxSNL4twLyQtri
16978	payment	1397	1397	1678	1	1	7923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGtXDGyzomsp5YewkCerjXPVfKYxZQbvk2TGBq1oftfGznds3
16979	payment	1726	1726	1874	1	1	6750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSr83CKjjKnx8cbu83RQVbJs3xMFPQXGb796LH3BwdwWKJRxZ
16980	payment	1726	1726	1874	1	1	6751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaemzG5FJCw8CnrSnkJhyCi2sHa3rvJD2KLTf7jTnV5yyvWH5
16981	payment	1726	1726	1874	1	1	6752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWdQP13xLg1GfVXHk92XA8d72JmGLEg3agWVUXopEjyZhjkiM
16982	payment	1397	1397	1678	1	1	7924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdhFXjyQHxMF3bs88sC3Kh7z9xd5QqL8Aac4BHifBbu64TRLM
16983	payment	1726	1726	1874	1	1	6753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb31fFhBuLrt7neyvCLMrqUPtE1C2V6U9gQbKdUHSghvKixizy
16984	payment	1726	1726	1874	1	1	6754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4N5dLB3KB6utN8kcF2DAYFqjBhJf3PucgZdeeS3b5JP1wAVo
16985	payment	1726	1726	1874	1	1	6755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa96jcjU5Rgkdv6XUSHj2BpEaatoyXxQb7442yAigqwXSxo7V
17004	payment	1726	1726	1874	1	1	6768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZFDRfQJnRxPf3goQpmxaxowAPwt3tPR7f233AxAVm7TBsZdB
17005	payment	1726	1726	1874	1	1	6769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpisPvQgsh2Yr74dqPCCQX8cPhwfbTEBkedoNcaiCYtzRYN3Vh
17006	payment	1726	1726	1874	1	1	6770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFczjRCmrTRhbauAMpBVLhrcfKxmDtF9Smisu74KpbXZSmNEc
17007	payment	1397	1397	1678	1	1	7930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JiBbkJ98uzdudhnjQM2aw5f1DdX8v2cxodxXrkBfBkErLmWz
17008	payment	1397	1397	1678	1	1	7931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTEfkb5dHrUHMHgqX4bdDxh2fFedQHjXgaRntuAq9RNtDhmom
17009	payment	1726	1726	1874	1	1	6771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEd8AGDZLaXVEcr62omnSPyNAYDbRmJxHzPj262pn4sTkcXaY
17010	payment	1726	1726	1874	1	1	6772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnQfNL8L3mg66dkrPN5BECeJurmCMWhF5hpH4EfYCo8NpbBsu
17011	payment	1726	1726	1874	1	1	6773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbDYZsLBzmCC3bEsirK89BpKRR1kio9kKdDh7NWQwrMRJLYtD
17012	payment	1726	1726	1874	1	1	6774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6mEqrYsdoUakGz4T4QyRHHYumZRJQCUedvhDwQb1MC1P5GTrB
17013	payment	1726	1726	1874	1	1	6775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4gF6RpkZ3WFXQ69ky8Kx6PkhYXqmMqQ9F2vvA9xg5Q59GudY
17014	payment	1726	1726	1874	1	1	6776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeiB6Wesf5LBbWjKMZ3aqjNi8jtRw6GConxxCd6rqfv8EqZCN
17015	payment	1397	1397	1678	1	1	7932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4WAE4eHVuCHVjYnM1UmgJ3HmaHPNuwigrYTiCCwuXCYYovW4
17016	payment	1726	1726	1874	1	1	6777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QeBq1ixJkNDMLxHEBrYBx8TVW1F4RerzdDxzAKpppRnSPyCU
17017	payment	1726	1726	1874	1	1	6778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV6GYcFqbvfXu3aPmwv7RQuGVNGm9WjjVmWQuk5vTrVFyb9u9
17018	payment	1467	1467	1010	1	1	0	3619378064601	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZmDGwRFpR7KHeferKqqZHvdwk53dFMgL1ieh4F8anZNyKAtqpc
17019	payment	1467	1467	1130	1	1	1	6485894480949	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZCfAGmum537wW8yPGK6o5qhsacvcajH9xoEDiTbPWX2CCVS4Tq
17020	payment	1467	1467	1250	1	1	2	4376162246859	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZ8dH7pX8PMYeMdmb7eFgDp8ZcCu8BWC3mxKSvxCj84cWDtYvLA
17021	payment	1467	1467	1376	1	1	3	12194565207552	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZLFCRkerHKZo6oAkS3tks17N5H3pHqU1j1FsjGPDo7hEqKD5Zh
17022	payment	1397	1397	1678	1	1	7933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrFKQLLHKwdUewvuPbuRCLSLTRyyDrYdPbVpALBxNXWbKY7t3
17023	payment	1397	1397	1678	1	1	7934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyELwvgjJoWPTiQZiVSD7ALjmELF8nK9MwAAQRnRr16eKDD5S
17024	payment	1726	1726	1874	1	1	6779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7W9BTNvbqY5k1wqJiSHyKjBrHZniaYZcY22oTNxaYR2mUdY8
17025	payment	1726	1726	1874	1	1	6780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4o92iH6Cac1EG2axDZ4Q6KJCtEbhCgnqWLFfkUQh3ncK5KF7X
17026	payment	1726	1726	1874	1	1	6781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iMp4ry8AcbYsM9Bq2z3NcWZbLQ3oNijWXCtzKfYTP9vNWKH2
17027	payment	1726	1726	1874	1	1	6782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77beXMhzTHuo6EqwjHcKrvtGMiPnaEFQb6HQHrdzpRXmzShnq
17028	payment	1726	1726	1874	1	1	6783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ35psuzaR6pmsBXMwXFx3si35cnqwfuEBkzcxPQJAtg5goant
17029	payment	1726	1726	1874	1	1	6784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWo8T6mJWpr5yqBoTtknqJLrCUoh5wSqerVXyaEdF1FcxoyuU
17030	payment	1397	1397	1678	1	1	7935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKasDU4XcGNvzh4yE916zppMNvgE3zxEHUN38wWDwds5rV9fh
17031	payment	1726	1726	1874	1	1	6785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJnotjvQKc8tHTkUFQ7bFeFL6hDQvpaAY1eSCE8nASrgc1Adv
17032	payment	1726	1726	1874	1	1	6786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9fDGhCCwGuyS73ezAGAYidoof8jPUvVZCeEanXQRW1kW2qQs
17033	payment	1726	1726	1874	1	1	6787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLGsveLwXmrBavGJUowXdA7JfWiWtZg72J2P4Zn4Uc6PDxApC
17054	payment	1726	1726	1874	1	1	6803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6T6nHBdaASs6B1p7R8i7VUc8couJdHRFWiWYLBu6tR1YTy5Ez
17055	payment	1726	1726	1874	1	1	6804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhB6EtcWm1SSbwZHJPiq7UoZJNuB9zJpCguDxAvAGUVza9Y7U
17067	payment	1397	1397	1678	1	1	7944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HmUPz6tUqjGqYaDgRDbJwLJxAcQZpRVbLb59w4WtuqyDryt6
17068	payment	1397	1397	1678	1	1	7945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUP2LW8NJK8E4zSXvx1K5CYzq52FNVxQgYea87G9Havyhs2h97
17069	payment	1726	1726	1874	1	1	6813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuGUZJYPzBH1pYecAaLGrJiNrxC7s4ajvoj4zHoanFvHAJ7aW
17070	payment	1726	1726	1874	1	1	6814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk79otzLaLv1Rd3g8MkR3YsA9Qk5pZALV9FjGqZhj5vtSDLsrX
17071	payment	1726	1726	1874	1	1	6815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc6Miqg85aBcLSkkeDqBTGhqzVP4t34rMcu9f1unKant5juba
17072	payment	849	849	2107	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HZPzXPt4jJ4Pino1T2TfWaLkuEGaynRwFNWPzRWzynjP9P35
17073	payment	1726	1726	1874	1	1	6816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDk4SsPCQxKspHebq8A6ckEPcNSU32SY9vRDoW57owiWzgK3G8
17074	payment	1726	1726	1874	1	1	6817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH98L7mUQ1H9F1juFUPtCuGoBZpXYqFzkjNj5NnASemiWwz58t
17075	payment	1726	1726	1874	1	1	6818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnpaCGFPnSQQcj3z3GnA1edYrK6kGaz4kV6kQUdP35E6Yj6ML
17124	payment	1397	1397	1678	1	1	7959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuX52beGHiZBXmSTyPTvdK3ENQcoja5HwYs2Cty1Q8kMnUKvb
17125	payment	1726	1726	1874	1	1	6854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPSfijrmYQJtSw1vPJvpSgpMZcGDuzBhiRZ5QwcsHmr9J9DnU
17126	payment	1726	1726	1874	1	1	6855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3AQ2zLsL5KGdFvBkEcCEXAN6wn58r6ZJteTHH31vvJmUg8MX
17131	payment	1397	1397	1678	1	1	7961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrg6WHJ25cwUmfZxuRSL7ac4ndmGXJWWBuVBWg43sxpbERY7b4
17132	payment	1397	1397	1678	1	1	7962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzA9eZFoyZimqb6YC9kBSQAiGkJ8YUpi2wVgYsBYCUdUi3Jr1
17133	payment	1726	1726	1874	1	1	6859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGzQFCE9qfoEtF4pLUAsYrD6N75UkXG1Mw6CMBkbYu1Fqt4jq
17134	payment	1726	1726	1874	1	1	6860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLK9TKQgJeNhYvkvE5FpQ35P3Ze8H2dGBNUYqWtYykjqYcBwG
17135	payment	1726	1726	1874	1	1	6861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXKQNhxvTQtZ66GHx6wBcVNQCZDVWEVEoNreZsH9Kw8yCHnVJ
17136	payment	1726	1726	1874	1	1	6862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xYY1SdyPHKDNtuQndTmL9XivsCJe1tYPhK924b9mcTz2c3zx
17137	payment	1726	1726	1874	1	1	6863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLqYGg3pRCfWU7AszsXqqvyoA1Edq1Ld41TuP4YnDfDsJwsh4
17146	payment	1397	1397	1678	1	1	7965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKVaUndAFJcppVooB3EchAJAEAZ6XR53jUdqKXCuLky3A35Y8
17147	payment	1726	1726	1874	1	1	6870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NKd4odgq6ZH5ixr52d5TFHLFeXMCgWWgA8ndESRCZRtTX9gw
17148	payment	1726	1726	1874	1	1	6871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDrGxmKXNbpKCi9gFGSTUZABLaFDEhRwVJ1m236XxWGR8pQTQ
17149	payment	1726	1726	1874	1	1	6872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBxpw6sZGgFzxSLCB1fDyetoZrM4BK2ikYpvGCfBvSnzSKmG4
17173	payment	1397	1397	1678	1	1	7972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KrkUxWRaQmmN26txHvtfe4XWHxxEnJRZMURfyqyQJLttNL8W
17174	payment	1397	1397	1678	1	1	7973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqCjgWr2gUqauhHhdAkXcMBVmzvE8XMYnN8xSFjwDYspRR1NC
17175	payment	1726	1726	1874	1	1	6890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoerUZKUL2ZhV7t6iF7hDuS618V6NBTHG5dyhNc5APHPFrEJoR
17176	payment	1726	1726	1874	1	1	6891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnDHVBRGGnXiMbMatYVWaoqZ9fSBR6ZxNMHrUNHxRBSCqoheyQ
17177	payment	1726	1726	1874	1	1	6892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkMHfeSd4XeWSpt3eyHFV9oaYbM5TjYKmEkfZxUx1sVSfnrD7
17178	payment	1726	1726	1874	1	1	6893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQE5Gmy6rTc5TWFXXEhy6yseuHrc7Jdwf9gSpgq7bwfHEHYcU
17179	payment	1726	1726	1874	1	1	6894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iTEmFHJtJJ9wKZstKcRsJABkxLE3UcYUpo2WBCWS6U9jgpyQ
17180	payment	1726	1726	1874	1	1	6895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSWcefj4Yog1HBFiVJt2bLs4RxTECmaraHYhcUEtFbacXavFJ
17234	payment	1397	1397	1678	1	1	7987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41K7bjZ8uiEVCTKCVf4R1Bu5ovn3NmP5kTkqHbgve2mL4tMvG
17235	payment	1726	1726	1874	1	1	6936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpcQwwkH2pwXCm52cpkX68g3LHTh3WAgydoUV57NMvdRiQXR9z
17236	payment	1726	1726	1874	1	1	6937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CPh5f2jbmQPJgcNuMQYrwrdkuyXGYjGcoRMC4AGwqUcoFgRD
17237	payment	1726	1726	1874	1	1	6938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbdZGZYD1FRhyUrsZBufmTgue11G9mpHpqhk5WtL9X4xsnAsq
17034	payment	1397	1397	1678	1	1	7936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGzRqsKPpJaTHm8myDthfeCoJ9m1WXbKCPijfef4wU8U2pbmV
17035	payment	1397	1397	1678	1	1	7937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8inoCxia35PKHa7SGFJSBeG8w81EdsQoVXHHamHqBvYrYivF
17050	payment	1397	1397	1678	1	1	7940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhJ6bnFWGrHokymuPomKUzULALSoMiz3gtrrpf8Pp85rxQLte
17051	payment	1726	1726	1874	1	1	6800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcj8ATwVMpvp3bhncTYYJFmJACYunVrwsrpxsnMwyhxDrgBB4B
17052	payment	1726	1726	1874	1	1	6801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbrpV3F4v59WF94ts2Kn4hVnfCS7Fqfha1KZu2UTU3xN4vMj
17053	payment	1726	1726	1874	1	1	6802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf2PAM6oiD6m2XeQLH1mDxGwEuyqmfsWMbEffh43PF6s8t3Ur
17061	payment	1397	1397	1678	1	1	7943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNK5cfY4VkMdn2Ad13BuJCG8nhe8i8QpMu8RPtyWihbBfYEBK
17062	payment	1726	1726	1874	1	1	6808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbkbuy3XCMddkVjnuFdys9Y5DbhKCHqonh1Tow3hGGzTvrRJA
17063	payment	1726	1726	1874	1	1	6809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW2u4GBTL4qTPHkUGoK64WwdCejTFPRK6j2LfC6tWcvdgiZQD
17064	payment	1726	1726	1874	1	1	6810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9yyEjiVoEsGLrEB98CKtF3jwdeNkpyjuqDx5QBQ1NqSop4bQ
17076	payment	1397	1397	1678	1	1	7946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMtXawvYpwiFACPYwCaGcNBzoGn36jLmfJk2DwXEfhNcqNmm9
17077	payment	1726	1726	1874	1	1	6819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1Vth5UNqMYVd553zdz8YZjDXyGJYxLbdfGwjpj3P5cPkybFM
17078	payment	1726	1726	1874	1	1	6820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEdAKaYvTx8symAQazAjhtZriGeXZkY2eHSydz7JfjZ11tt99
17079	payment	1726	1726	1874	1	1	6821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapG3tyXEggToJUN7H77TQho1tTVMyz8LonBegRSCVSKsASAya
17088	payment	1397	1397	1678	1	1	7949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaZU6f2cxuHFwv83s9zMtwWHSRgRjmVWoz2EKwkSf8yifQPab
17089	payment	1397	1397	1678	1	1	7950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUFfcVwhsdZmNwx6eiyhq1DDXLssTJaoLS1PPH1Eq1KkfJFNq
17090	payment	1397	1397	1678	1	1	7951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1LYfftV8GwvhP2bBdfQorHVhUseM1vG4xxeEUM5EXLb3iGbc
17114	payment	1397	1397	1678	1	1	7956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziht8HxnwXownK4gMszUsgSX5LeYuKJ67Bb8GbBabcPvrf2vS
17115	payment	1726	1726	1874	1	1	6847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4bgrCw3L86N88Rx6TLBnKwgEFr6hPkWseJCtFwA9nfz1EMLU
17116	payment	1726	1726	1874	1	1	6848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxK6GZVU7hdbpK15JRya1kzXkfzwLrSU7tuAfpJrKbgB92qVK
17142	payment	1397	1397	1678	1	1	7964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjewz8pFFmNtHuHUAFDmHhP3pU1K5V1adr1eB26TYUUh2kWRhc
17143	payment	1726	1726	1874	1	1	6867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbypTD45hbMJriGqFzqByXC5hDDKrpfudRNXXUZsCp24BzS1WT
17144	payment	1726	1726	1874	1	1	6868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWUZxSQ5dYpP1wGBBhtzoD47QemxHF9fS5ZGRiPi6sU5ki3f3
17145	payment	1726	1726	1874	1	1	6869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwp1gQpMLbMnVFxa3NontNwrvChM5eNgmNuLZoTT4Dmpnhojq
17150	payment	1397	1397	1678	1	1	7966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmoY6g2jS2ovce8H29s7DZ5AE7Xi7y1Rgx6Ktqso9Uai6whfW
17151	payment	1726	1726	1874	1	1	6873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzc1L2SoD1rEi3WNr9m3qpsR4omr65KAGuCnkJ3MBPFHBuk8FP
17152	payment	1726	1726	1874	1	1	6874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXdHD2FusDmfjxecWFdNaHBtck65aocui5BCDWdyThrb46F79
17153	payment	1726	1726	1874	1	1	6875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMThPp9YfTGWvw45trBPj4JBiEHfWF2vJsEhBMUPSTzBPv4k1
17161	payment	1397	1397	1678	1	1	7969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhv7eqSc8UiD144sNNrPsdERCzQPbvtqKyYWEcefwWbFVjg1Mt
17162	payment	1397	1397	1678	1	1	7970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVrxAV1Zc3EkptGbwQrZBhghCo2ep7WpNLSeU5TtomF6dBnWX
17163	payment	1726	1726	1874	1	1	6881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEomUSX615LsU93cUAjRsS5SaBrsGpHLdhfykb5KkXS1q15uy8
17164	payment	1726	1726	2108	1	1	6882	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdPXvm2jZ4aHg7pZRYxqQvwiMzAr9tGj7DFSrMUr84Xz3CpFU8
17165	payment	1726	1726	1874	1	1	6883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmapwkwEjHVQmWDKHd76wEutUNwidpsbFWbur5CE7gcnNNEYmm
17166	payment	1726	1726	1874	1	1	6884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk11ramW4Qvy77xVK8Ff4hPKQjfySzDPk4dzvwTcRH2t5zJtCT
17167	payment	1726	1726	1874	1	1	6885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcXWhX3VtvgxUJgwuiQ14tKAgf93ZhUGz7Qh8HgyDcSKSsVHm
17168	payment	1726	1726	1874	1	1	6886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFevVDCfUzDdK25qGgghqmUtDq1y5ZwHDRqhaCTk5HR3rD3nYA
17181	payment	1397	1397	1678	1	1	7974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLKGvXV6uAwg5Dfe4ESgjuxCqttKzEWh5gkc6E2pEuRuJhy4g
17182	payment	1726	1726	1874	1	1	6896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKTUrfCNvvhkaLdKLTVgdWYXn4feiPTerdoW6cCasDCfd5s6X
17036	payment	1726	1726	1874	1	1	6788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EUTbJPnvadEPv4kUHRN7hgwQao2GdGW8fNniswwLGh2V9mwT
17037	payment	1726	1726	1874	1	1	6789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5VjisfGU2okGRf4oUDFAxfGtYwcoqYexTV4kmbcxRi8nMXMF
17038	payment	1726	1726	1874	1	1	6790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEryXwoCAah9Lg1XKfQZDEzGkkivUYWp39G2FW9uor4EXM2Lr
17039	payment	1726	1726	1874	1	1	6791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETsdHqcaGGijYevS7rzVRbYXBzSVzxURQz1DNLuMaHc4nLx4E
17040	payment	1726	1726	1874	1	1	6792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6YpgifTMPQfCAZKRziEo164kMxfFT5FSq6ihuXeJojhhDomH
17041	payment	1726	1726	1874	1	1	6793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZuLLXqzVGKMsd5LdpYGhBu3aWLLRYG1xUMnFgRzGRUPekbiS
17042	payment	1397	1397	1678	1	1	7938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQub1wxQ1bfLDsiPU4QZij1NCeZkmAUsq19YSXZHjXabKhdgfa
17043	payment	1397	1397	1678	1	1	7939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQSfPD8fJafqAuqqunEvrydJwA71jF9GyjdXU3fjd42NMRUg1
17044	payment	1726	1726	1874	1	1	6794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebUBA2jsssav88ffKcJXv2VnjSahitq3q1qx8cwxqctrs73dB
17045	payment	1726	1726	1874	1	1	6795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnruZU5TkRQ9FcWsS6J49mnpfbVhXhKn3Cj7cWPK1m6PgrKHRy
17046	payment	1726	1726	1874	1	1	6796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqjTpb8QGW7nW9Q4ZPhWLpyDJVA2DqH7Uod1LL2xAn7e7D9si
17047	payment	1726	1726	1874	1	1	6797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRcMKMb8gAsqqXEY7bskUSrLerkJJ5BxjFrhnSNBQMHHXG7eC
17048	payment	1726	1726	1874	1	1	6798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKqJqKCYRVbsz5CommHhtHLGuB9corXYoHVUrfcB1tnB7tbDJ
17049	payment	1726	1726	1874	1	1	6799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pLVA7F28M6RRyRs3emZHnxE5MbkUujrRkjjh5oHbCkuVRJcs
17056	payment	1397	1397	1678	1	1	7941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6y1iabzVk6pPBgWHD7EjDHTCWX86TMTBzUt6gLt8xuEakGkrX
17057	payment	1397	1397	1678	1	1	7942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKvvbAq6MsMAWUpiciKfvCQwwtoSYrVfqunhctkbdFvMtFdqo
17058	payment	1726	1726	1874	1	1	6805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjQa1ZHccxDghzJXvg13aJAvc4xnb73HYD2QcG2LG9fYfcsLS
17059	payment	1726	1726	1874	1	1	6806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdcgRnT82nvsTPYKGgBL8TTsGFoeDUgs3Z4Mt3A97Dj4YUjNj
17060	payment	1726	1726	1874	1	1	6807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25Q1winnqbYq7LF9AbL7asiUpiLNJb8tTNGNv3pp26JmnGdQF
17065	payment	1726	1726	1874	1	1	6811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCk8zKX4y6UZ91eypBoDS5sG9TCDXJWaoGS5RYWpdyJFsqV8ji
17066	payment	1726	1726	1874	1	1	6812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn213VdViPAq7w5fz14vVwU85tCWGSTQ4Rj2ELaXeEoD8tADGp
17080	payment	1397	1397	1678	1	1	7947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8xJtcrHccEfh6o4ZUec4hLHxh3FFySpYDF5xh2XnNgNQH5hD
17081	payment	1397	1397	1678	1	1	7948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeAz75S26HHvcsJEcdWWwiH67NWsh3GTVx3nPxitdfKNRc6km
17082	payment	1726	1726	1874	1	1	6822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdh4naV3PTkMDbpfigBARkt9JpXU7evrtK5SMWZyz8Zkv4PFPJ
17083	payment	1726	1726	1874	1	1	6823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMDYGzYk6unY669xkFtZCw2YdKQBtDqrReK3VoGDGwDy2pUQv
17084	payment	1726	1726	1874	1	1	6824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctvY4KUpiZFTRmSqTnGGtaUUuW2eVcBFy4DrGnT49xL943TNa
17085	payment	1726	1726	1874	1	1	6825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjXP9bbXbW3dt79bYYzbmQbp8sxsN2XaJ4gKB3g3kfGmyKMcE
17086	payment	1726	1726	1874	1	1	6826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWTt2SJKW8vum1ZAVnXK1RmvQWucyidtgnt7wcKAkR99Z4eyb
17087	payment	1726	1726	1874	1	1	6827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTqi46KHZgR55TFxxH2qe1NaiSucQmMTkdrkgw5dbZTTLgpmC
17091	payment	1726	1726	1874	1	1	6828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHdD9AS4BQYfUPKEMLDsTF28z8vd4zcttUxz54FKJftU7jWsn
17092	payment	1726	1726	1874	1	1	6829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds7X4VuCnzfJSWBXPMUmeCpYCcz8hQJoABDeVDgpoVb3piRH5
17093	payment	1726	1726	1874	1	1	6830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkqyeH81wv2F48a8VdCCXAxLugG4qDfNwWp6Fkocn2ieHPE6Z
17094	payment	1726	1726	1874	1	1	6831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Nzgur9Qpw1HkC1AYmEuG7k6cEscZXZYKVqnBTywR8WneEbgi
17095	payment	1726	1726	1874	1	1	6832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WdhpqEPUJrrz55sp2n56725RbmbFakQ7oxkcpiNz3Ap7va8u
17096	payment	1726	1726	1874	1	1	6833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM24KqkSrxyXPPwvEP9coeS8jSyeguA11bAp9FVkP2Snjbed5h
17097	payment	1726	1726	1874	1	1	6834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYrmc4N7JdLiiSerM6gxeYLoxytPVERsgCgVk6p6995BXSiZs
17098	payment	1726	1726	1874	1	1	6835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVGjYF3TXcRP65QwDDyBdjbYxdJTBngcMNmfkQp8XRUzxgAzY
17099	payment	1726	1726	1874	1	1	6836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN75YL3g5LBwuYJNw4cQKCp7iChXugfB1HEmdtJU9LH1HPLuZC
17100	payment	1397	1397	1678	1	1	7952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Q7rKdeub7y3UaZXk3in6NA9yDbb4xLueHxDUV1CHyadoiY7b
17101	payment	1397	1397	1678	1	1	7953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DK7todm5JyYeJsvNP6CWtWjKzqmqW4wpSuM9WR4G8dxh2DBm
17102	payment	1726	1726	1874	1	1	6837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWqXgPajyDHw8caFzEr2Y4DgFtBkgL5FEJ5RgCvdmyYzc2fU3
17103	payment	1726	1726	1874	1	1	6838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrximCZfKzgcy78o8LLQbP5cihmEyf2Zmt3JqJHm1Gb6cTdYYh
17104	payment	1726	1726	1874	1	1	6839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcTi3SyNdPvxQmAEdw21vkYqxNw3hqMwYh5BS6xgBzhvGjL5W
17105	payment	1726	1726	1874	1	1	6840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Kr9cjvt1ipzto5CKUGNNLb3SLav2Jvf4CtRLfwyQws3sxx2K
17106	payment	1726	1726	1874	1	1	6841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FDjor8pyfDTyaPzYkW7gKJVLaqHFBa4iZUGWK9Rc5p7fEKav
17117	payment	1397	1397	1678	1	1	7957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDo43mdDTY6WVvS84PHiwHqmEwQT3wvjQGoHbqBCfzjRd8duq
17118	payment	1726	1726	1874	1	1	6849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCi2ZQFQKeYsMjtFYvohb7oWwEKCFWjPrby8fjQ7hxA924G8Wd
17119	payment	1726	1726	1874	1	1	6850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgVpQAuwi2ZUwxmksGd81NFnpCe47q3tnq6G8C5vMA9XbkTaZ
17120	payment	1726	1726	1874	1	1	6851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkc9gmLZCGmViXqjLnycMseQ7nroHLPMujA51KA4NTr1VtjMvX
17127	payment	1397	1397	1678	1	1	7960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YvYnB9HEcbwh7TrezPyWMkD2gFVQabjZzanBvvzyDBjs8Etc
17128	payment	1726	1726	1874	1	1	6856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaetAfyB8gWAVYvtqB7eFNHH2TNoiSpXbhfHVpzu9FfA3D255B
17129	payment	1726	1726	1874	1	1	6857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTCifCJRrcJvMiVyJintvGJbk8GhUg7sG5mGEJ5M5iuc1XZ7X
17130	payment	1726	1726	1874	1	1	6858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7aDM8VtkPzUHLnTJKmb3BkpBvUkmKfvvqn9f7chFy78phYVV
17154	payment	1397	1397	1678	1	1	7967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee5BVYcKEEwUSKWrAaktMBfYsjMksUD1D1oQUkccE7wGKq6EG
17155	payment	1726	1726	1874	1	1	6876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrTADULDxUhMpYKStgYhNVaYLN7dZqDgKA4GRQhKETH4UV7KS
17156	payment	1726	1726	1874	1	1	6877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUysrbXH5DDJQ5gBcajyUGoyrrQMgVtAL2bpyVdZ1vqo1QKYJ1
17169	payment	1397	1397	1678	1	1	7971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStDjXDPCwq4wAczPA74qYpkPcFRW9SBEADgkDvAXwKXNsqvty
17170	payment	1726	1726	1874	1	1	6887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHWmzYEAszxCA8bx9aNjS6Lzfz8EJZzJNVEgkdQAvxMJyRtvB
17171	payment	1726	1726	1874	1	1	6888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtiHV9xwMq2Je5Etb4bR3f7SN9PupPs4J7V27D3E8RYqiS94r
17172	payment	1726	1726	1874	1	1	6889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrje4WLYH9rJ5nv1EsLamFdT7896EganZLAm34WEDPt3GbKpa8
17185	payment	1397	1397	1678	1	1	7975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJX37o8KRsnSw1UyeLPZnQDcYHW8ih2JXZq4mvpNFkUYPxDDC
17186	payment	1726	1726	1874	1	1	6899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rfrg56x5FE3jHqaGnMVw2MUTM8j6kBQnhbCRddtqW6htAVNj
17187	payment	1726	1726	1874	1	1	6900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLKZcjb6hScCDVGre7ev8JD6gaD34AsCacuC65n5ej4oYVZBr
17188	payment	1726	1726	1874	1	1	6901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GmaPSXKgduukamYm8GrPQBbCBKsiKdpFcHdtRBRgUmiyxZvy
17197	payment	1397	1397	1678	1	1	7978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNkdAX4TGLktEK93SgWQAqZMqhQc1a36kiQfBugUKeqdiqcAm
17198	payment	1726	1726	1874	1	1	6908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD2zM58pkK6WuhMmV5YreQr3BGfMEJ5WiSzfdJmuyBK2nM1zB
17199	payment	1726	1726	1874	1	1	6909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDWHvt9763GarsRNGp8pD1J5DskuCWeNKQV3gqgXNxWhALcuN
17200	payment	1726	1726	1874	1	1	6910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEmaK73CgBNLDgzKeY49mcudnZTTfaY7zovt84AF4Kj6TgNSc
17208	payment	1397	1397	1678	1	1	7980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA3ZFctLoVT9arsDzLdmSoAC2SyYKpXg9MY5R8cK7ks2ASF3a
17209	payment	1397	1397	1678	1	1	7981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKxnt2z5XxeLjy9obW8dhahaiw7kbaQtWEzuPFiGY6xeXuQiR
17210	payment	1726	1726	1874	1	1	6917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snRYRZsgWAadpDPzFN23fxPm4YJu2NdrBsSyjs7geUCtD8vL
17211	payment	1726	1726	1874	1	1	6918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEarpEJSn6jWK6SDqi65e46KrxYqtJfACiLHmA3YsLW2YPszAh
17212	payment	1726	1726	1874	1	1	6919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXwPZFHhRgGReXYGAHdWJdnAv2Y5jeRmLBJBLt5EuNfKvTZdC
17213	payment	1726	1726	1874	1	1	6920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPpGbu53uT43E2vUdADzHoPGE8qiyjeFx7ic4oKeHZowXgdM3
17214	payment	1726	1726	1874	1	1	6921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebAwAquzKAeijwtao1r86UhAWKCrELZrNuCfZCeegdQH3mSWZ
17215	payment	1726	1726	1874	1	1	6922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HKtXkuQxwBGpaYTGyEMJwrsYmFSGsbwfnCSHeN27c59KzY9v
17107	payment	1397	1397	1678	1	1	7954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpYvHG43ZHmVjAwkS1U3WETtMnRhRUZqJsnjAKqwd8UA6LNUq
17108	payment	1397	1397	1678	1	1	7955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHKGcTgHtBy4oL35eepJyvhyzhxrQAj4qQMQ5GQ9FHPHxSPBD
17109	payment	1726	1726	1874	1	1	6842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniKRs9JuLcNq5UqUR7CwdTnz94y2MxrZLBd7ugPQVGQmaBCkn
17110	payment	1726	1726	1874	1	1	6843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzjjAxsewp6uakUmnmYKttBYT2dX5F7vvePNSfFH5rKF1m4yY
17111	payment	1726	1726	1874	1	1	6844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscpE4SBKMcQAi3cY3UHSxf2y3hgHBfk4ANRqJiB9XcwAFtCY9
17112	payment	1726	1726	1874	1	1	6845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjbaCpxj7YFVGDchmMyVzTcQnp8KxfusCyipdXCuv9iBeRr9
17113	payment	1726	1726	1874	1	1	6846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweQnRZbfANRcB1Mgu3F2p7Mih2GmpQPpWByyRfkXFKY8bx7tU
17121	payment	1397	1397	1678	1	1	7958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzCpbRr1ukPLoRTAxKy6BoYp1TNJ4KUQ9ki5X3XK6gsL2ouiZ
17122	payment	1726	1726	1874	1	1	6852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqAn1s3FkcLqnckiYc6dTMKHNuG9ETfvZyitg5vAjhZ7vth8b
17123	payment	1726	1726	1874	1	1	6853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaS1ycUNsEkfNyYKPR3r1htZv4DyXTZZcFoBPCHHVGHjLkwGwr
17138	payment	1397	1397	1678	1	1	7963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6sbnnTFpG9ZerQrsYHXR3cwRk1MHHvu8HPmQVxM2edFDXres
17139	payment	1726	1726	1874	1	1	6864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHFTZhf7zHQFbJziWhZuVhDgJfzpb1gjGEYTQSvx5upWXZ7ra
17140	payment	1726	1726	1874	1	1	6865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVdcLupCwZKVuLrKahVTZpVmWfUvW2PpySb3mYg1fLPFBbHYy
17141	payment	1726	1726	1874	1	1	6866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaqDhnFrDcYdg5A9ZnMvaiASvb6kG6tL314uBZ4tNRUGygaod
17157	payment	1397	1397	1678	1	1	7968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwM2M8rJ5Er9cNJRKpNvFZgSdMqeB5LKFDjiCnxYr2dJXdQASj
17158	payment	1726	1726	1874	1	1	6878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUokuWoF4iSfrGwvYu2jspLQBLcPTm4S9UqN4kvGUiQq8N16u
17159	payment	1726	1726	1874	1	1	6879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3BKRYJjtTbytFfm6m5AHDL792zVG29cuYmrhj7dtBXV2vmZh
17160	payment	1726	1726	1874	1	1	6880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe61SxYWazDgsgUZbZHQuv1f7vGkecqQrGvXH4EVmdAeWeUMpv
17189	payment	1397	1397	1678	1	1	7976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHfCeq7cRBDVKvqoH6QJ67XTqGbFwWT3UENbXByY3eh5qRvkp
17190	payment	1397	1397	1678	1	1	7977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWcwUCfTwm4SvKQQGaw7vh48fA8FrJN4kw6JVXSNSRA76W2FB
17191	payment	1726	1726	1874	1	1	6902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KC2WzANX6m4J3L4B6WQxSgpuFq7mBEMHV4VBy4qD3pZuQYHh
17192	payment	1726	1726	1874	1	1	6903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdFuTpYzsXT3S2rtSaN6TupbKAb54CwNzcswJ2ew7pprmBe77
17193	payment	1726	1726	1874	1	1	6904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42Bg1KaHEcZi76KJsaW97YHkbHkvsmc3AC1HKNMp5zHEFR9pr
17194	payment	1726	1726	1874	1	1	6905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ayQNzD3hwtEBxZk8yvQzTUSc1huJLJwL7aiPNX32WAVQoxeT
17195	payment	1726	1726	1874	1	1	6906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Cz3WMzWTLZvkHxZW7JJoETbEnt1e6Qf3hux18KUi3RQq3qzJ
17196	payment	1726	1726	1874	1	1	6907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLgpPFLVjSK6NHT9CQyEZuCrQjCbJsuncGJxFasCwkrsoLhgn
17201	payment	1397	1397	1678	1	1	7979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHsD1RjefDN6qHHqzB4rA9fqJcGwMpMrjrYTbXCvVCjsTePthJ
17202	payment	1726	1726	1874	1	1	6911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCmfat3yzw3dY2aA5sMT3VhPqkTGGCmYDrc3FRjJpxFe7Dxhd
17203	payment	1726	1726	1874	1	1	6912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcqtNHVv3dGu7F3o7kdWQ7q8a9gujYNwWZuo3fdARK14tdLhpV
17204	payment	1726	1726	1874	1	1	6913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3b2qW6NQFdRAhqe2UghKdww3m5FgtoXT9HuLuZpjCRjY3D4D
17205	payment	1726	1726	1874	1	1	6914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2eNq7cqXnPCc3yQ6xyTKkcH6EKFw6jR8987xpr3E3byvA3Mk
17206	payment	1726	1726	1874	1	1	6915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3V92bgfG1UY2nzf8mKhoJC4opXCpg5wZYY4LQgu2Q9GzkxQ8U
17207	payment	1726	1726	1874	1	1	6916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNcr9nsSx7p2oBKm7QMNv6Va4kzenctUYjo3mk4c5iiEvP6tv
17220	payment	1397	1397	1678	1	1	7983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmvEeoWfxE9cgvyatnukE1gyjH3nbLBRzN78LKi6WTznyQpW5
17221	payment	1726	1726	1874	1	1	6926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfX7t88P5n3yJkqPkCNKrbt4V9fPPFw6qLUSjCCJez2fycCooY
17222	payment	1726	1726	1874	1	1	6927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH6ZYRzWGH8tSvXik3rwrUGsa1E6Y2TgXHoF8bfws27LAQUEn
17264	payment	1397	1397	1678	1	1	7995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQwEo2gQGKgBzth8cUkaomDYq33iMqFXs4XHGqHggkKe9VDUi
17265	payment	1397	1397	1678	1	1	7996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7REu2SruuhArHH17S3KJhUpayTPBhooteVc1pjdhwdiaVcyc
17183	payment	1726	1726	1874	1	1	6897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfU8zYW6R7Ur2U4et61vwhjcttnJHM6hHB2aTGGuE6nX4MAhX
17184	payment	1726	1726	1874	1	1	6898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mjjRr4tc3cyZ3NVsC3Ur1436WdPPozQrmQHDCjxVPwxFKdu1
17239	payment	1397	1397	1678	1	1	7989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNuBBSeBZ3ibjZPLVSZ7YahDMQmSRq4tycHVaUYZFP3ZTzvuX
17240	payment	1693	1693	141	1	1	667	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZkiaB5QAgcDibNZEpNAuikbLVNLPmE16TkzAucwNxeA4LBqJrK
17241	payment	1726	1726	1874	1	1	6939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KUNJAEX81szm7EwNpWQKriTcFb47T31nMbYwsct3i9PeVnuM
17242	payment	1726	1726	1874	1	1	6940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJE7Hrse1qRQg4dEXRjKkm2aGCcjuHX9UUbAJarwh8roXnqL7
17243	payment	1726	1726	1874	1	1	6941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6v2iRgPLDPLD4T3FNB5G7xFVjREUkexiV4FiHv3bhdKcyWzx
17244	payment	1726	1726	1874	1	1	6942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fpfNUzA5r6seZ4ceDcmpm3q38eTfwUimfGC3FakBHPjN6Uvc
17245	payment	1726	1726	1874	1	1	6943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oP1JUUyFhe6HFRjeaJmXodAfqpdocZeAV4QGT6TDJBJEfSob
17246	payment	1726	1726	1874	1	1	6944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCptixpH7Y6gUyFwBk67ku2tpgQRoBc2MHYSTWAnoAcobSNuiS
17247	payment	1397	1397	1678	1	1	7990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkQtG3YRxveABVZZYirEZiuqcnTjRorLsh3HPD11LqA8guBUn
17248	payment	1726	1726	1874	1	1	6945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z4vgfBua4mx6CBtuXmdSmjohWaK371UndaQbxDZpvqyQEMF5
17249	payment	1726	1726	1874	1	1	6946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P6rNzDET4pfejoj1CzMpfh1uCE4f4VjJa5MrgfmTMHCx9mxJ
17250	payment	1726	1726	1874	1	1	6947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ8vHWejrQbYNzWcbGicK8XAMhZyEAFUHWbR2w1NkiiEEiSSg
17252	payment	1726	1726	1874	1	1	6948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS526NzFjmZyJi31WTaU1dgrknMwYvxJsJWQuvQdKoRGHPvdr8
17253	payment	1726	1726	1874	1	1	6949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVWNUUYde59728hNv6Q1fTUhVxd2PGrFqSNCyb25GodhiEKqn
17254	payment	1726	1726	2109	1	1	6950	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZe96GtYMgnETPcZWhCmA4uRU6nqLSyJ9siRUbxtjKwAAvHY6HL
17261	payment	1397	1397	1678	1	1	7994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJ8CHCfNri9K2WQ1Z5unSam2ypsB9QqgUzWiDoVDYXpjovWhs
17262	payment	1726	1726	1874	1	1	6955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9zdrUdqQMsE4jERcSE19CM5SSkEqjdomv78yYfWfHndGTHZg
17263	payment	1726	1726	1874	1	1	6956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSouec5Byg9zN8ULt8bckQ9dTawgCZ62ZcjL8Eh34VpXS6RqwQ
17276	payment	1397	1397	1678	1	1	7999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsjCBcRqPFsX7amXyWzaFoRAJzZ8CV3PCv9HC66ur1LGSRPj1
17277	payment	1397	1397	1678	1	1	8000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxgC8969it6hMh7H3bfQEgPELLw9SXA8g8MZ3umjGFeJ9S4ZJ
17278	payment	1726	1726	1874	1	1	6965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8GdQgpJwTm79W39FFsDK2ZH2KETjPjMjGtH2PWwZRpd3VZdo
17279	payment	1726	1726	1874	1	1	6966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvadccZX1iQYzgVnxcshJzo16qeEMwdHGwr7kAx42AdFCQqnD
17280	payment	1726	1726	1874	1	1	6967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhoGKztdFCLonDjpjETEqQJezbVAaRHM2JacHKmeCoXUE8LiR
17281	payment	1726	1726	1874	1	1	6968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhAVWbU5dCJ9kEFvgiQNf2r6vuSMEMHWrEXQwhv6XW4tc5vgW
17311	payment	1397	1397	1678	1	1	8011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQSWgjdQj9P8jgwV2AKte3RPdVuHtSZue8E8hd3jLL1qwua3U
17312	payment	1726	1726	1874	1	1	6988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPx8pXHzeUH3q8WcySMGDsnsnJUhtgHQvN8QBrkScrvPuhT7g
17313	payment	1726	1726	1874	1	1	6989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrGZxetH16ZgfF748DmB8uypbXuQWoZn6gG2SRjGKxq1tpwiw
17322	payment	1726	1726	1874	1	1	6995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWu6EoCqQzSQR2YV8YTfTkQ7immKGc9AB4P3MasGiBaNZvDig
17326	payment	1397	1397	1678	1	1	8016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ww4esiAvsw1q9gwsegtLkny6jyNsUZkE3bpQA3PoU9zF9gVZ
17327	delegation	1769	1769	44	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Yp8YrQAKDpYjRMT4mRzVZno7oiWzMvHpYPYgHeZ4AH4VTL85
17328	payment	1726	1726	1874	1	1	6998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vKHc75m28kJFUESke6GebzA47jfTLezfqFSr8AFKe5DT6Auf
17329	payment	1726	1726	1874	1	1	6999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqycDouk1fn3s1T4JzZ2wwqXCmS8bndYRBgaBRDHFJiVW7qUk
17333	payment	1397	1397	1678	1	1	8018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJyiwmDz3VqyXUpF2zJqAfW6vZZn1BqftYC29XjebknEPBJZX
17334	payment	1397	1397	1678	1	1	8019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MRG8XkUKSUxC8sXdmHCYb9qTq2Jp39SyQxEWfjD4UkGumX7s
17335	payment	1397	1397	1678	1	1	8020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoehqrP2WVi1F1BngGQGGfBZ2Y5jhLxNb3QF7BBoZeZgVK42Pr
17336	payment	1397	1397	1678	1	1	8021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA7r2AWBYV5HnzAJhrDeb1Xkvy6EpPwnnKC2eG32nLPU1PXxD
17216	payment	1397	1397	1678	1	1	7982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCCwGtPpeVTmSgvnGkMPJhgrBcjidsp8VSFt2ruz89FDAwPJE
17217	payment	1726	1726	1874	1	1	6923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDZPT8whdWnPzQn37PqBcPhJ1wqwq3oRsytMU3eyJSqc9JSYq
17218	payment	1726	1726	1874	1	1	6924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yzG7pZjX1frWebCADifwS6os7BLF8rM6xnru72E4761LX3pb
17219	payment	1726	1726	1874	1	1	6925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAC5BNToELcBYLh2prFRLuDgruVH4tGJUeT76wRvQkfRSrukQJ
17223	payment	1397	1397	1678	1	1	7984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFZvqnK49ZN6aZsPHuoU31jJZFLHRJ5scoV6AtqyCkdhnBVng
17224	payment	1397	1397	1678	1	1	7985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72nkeUmZUe7F7qmVMuM47UHgwrEGSd5iAUY5LgyjQByavGF7L
17225	payment	1726	1726	1874	1	1	6928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhsmfPNwtENRyxYyCDJXbibt4RreMZpBNHtE88dNLsNCPXmyD
17226	payment	1726	1726	1874	1	1	6929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFM97Hrvr9TFGkD7Mz1UGvq5B8fKuiVJfED541xvRBy9yaWRS
17227	payment	1726	1726	1874	1	1	6930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG2ugKMVSFZNGxXJgJruu3AGEuDFeNiQUBUbyMeNxvhummMKh
17228	payment	1726	1726	1874	1	1	6931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXwVuTKqVgmayuLvUFaY7qi7LsPuLiPoddqssxTnikDLZ2ZVs
17229	payment	1726	1726	1874	1	1	6932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pkf5qgcLPy2SNmiSW2uDwF1HYCW98Z8qmUtNTysa8kxxd4tc
17230	payment	1397	1397	1678	1	1	7986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYYCUiKFeKNR2YNVBz6dUR8zhNL5Rbvq9uEq9EnTQ68Bdbhjz
17231	payment	1726	1726	1874	1	1	6933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rBzaqkoyB6GRgTk2QejK3TmS9eTJC583pVXWSTX4CHRNFMAT
17232	payment	1726	1726	1874	1	1	6934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXsYWRokoVcoHWGjGq9ZMoLE9dqZoZK4r8izQdexSqmYAKbNp
17233	payment	1726	1726	1874	1	1	6935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGUgZbyms2MVB5zfNLHJVuRns7AMi5XSLRbEjykdotFqMZNH3
17258	payment	1397	1397	1678	1	1	7993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZpKTkhJpNUXrm2QF22kr39TjEgnJwCzJCGE54gfVzCogy4s8
17259	payment	1726	1726	1874	1	1	6953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy61ShRcbBhJd7yWoQGJax3iF3zGRdLYJPmk1kwz1jyxeAkiGo
17260	payment	1726	1726	1874	1	1	6954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XvKs2cgfvwYo2xRAh8FazSpbuSpd4v9FjqFaruWYmMEFPuWG
17285	payment	1397	1397	1678	1	1	8002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEpMqAcdmxxSQwJG3jMkniMiBcNfkQhRisdK7acp62n2xf5sh
17286	payment	1397	1397	1678	1	1	8003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdBdNSbLVTzf2igZEynMqzoAycQvjeAqMbcjH7G4aTHVsRqso
17287	payment	1726	1726	1874	1	1	6971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1bhaxXt8cQFQapVS6A2usG8yZ3FraAA3nWmcioFosR3NmoVU
17288	payment	1726	1726	1874	1	1	6972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaLdJVQcPVccdAcxFL9WLcihiKUxzxJjqnunweKBbGCzgkREZ
17289	payment	1726	1726	1874	1	1	6973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBk8H6TfYf4EYGTA6Yjvu2PXdkhEYMf2FvFdEWALwtRKXG7QL
17290	payment	1726	1726	1874	1	1	6974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLqo5fWpkJijtbitELWAQvGFHFdVSbRP81HBvtGiEoBkqtDAt
17291	payment	1397	1397	1678	1	1	8004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PGixcLebdrwiwzNpqGjCBb73xz4H8zqpND5ZpouWSrEGv321
17292	payment	1726	1726	1874	1	1	6975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYws8NrAx1gc838mcabqdLy1sXdHw7iVz5pePfZZEHb4KYVzn7C
17293	payment	1726	1726	1874	1	1	6976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXxSnwGgwWWtkZd7Bg8ujyTX7tNBQvGpjuEswETVLyF5mTobP
17314	payment	1397	1397	1678	1	1	8012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUK7BsFns4ETg4cwATQp8YipHv8iHZKJxef2xw8iamo1h5bMw
17315	payment	1726	1726	1874	1	1	6990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9Xxi6nDqDUgxD3jW95DGc6vy8pgTM15gbPcc68F7MMeFgqCb
17316	payment	1726	1726	1874	1	1	6991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKxVDDmff3egbq8ZTbgTWGPVGSuSjvBns7hxBbBZ3UV968EDD
17323	payment	1397	1397	1678	1	1	8015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3DpMdjNwUiz2v6hCW6rKKNtweSFJmUqmom1ND7wrZH6upY4x
17324	payment	1726	1726	1874	1	1	6996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1xgwAnk6Qq9y8LM86nr7krArDVnd9WJd6EFSqBEXLzXf6j2Z
17325	payment	1726	1726	1874	1	1	6997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVgRZQRxY7Mg47trzTf6McXSonFbdHb4PrvRfyCvkPnvzNKMD
17350	payment	1726	1726	1874	1	1	7008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuX83nr2ZbBDonHSrr7mqvMNYNdt2rB4KPSSuKNqHtVE8AL6P
17351	payment	1726	1726	1874	1	1	7010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdjwgTH3fT62wiWDDkg4qwTbhb5TRqwX3fLgVuqgqMwKsekqu
17352	payment	1726	1726	1874	1	1	7011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXH8oZzdE7GkT3BLAhGcWbGikBMWtk6n82GVnkiaonbYgoWX3
17353	payment	1726	1726	1874	1	1	7012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH83ATksz2s3gajaySuTVAvVgnB1ZhriUj58bQF5fhaEXWKg6C
17354	payment	1726	1726	1874	1	1	7013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM92VgGuU3YGSezKAKSjWoUifDaJEkn36ekgW5QkTVrurgXL6
17238	payment	1397	1397	1678	1	1	7988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8gcdvnsPYazxM5NxEvHe3hKiRTfLhwGPMxiE96kE93Sx55G1
17251	payment	1397	1397	1678	1	1	7991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwH6EYqYHJfPVWg8YPRYw9UCBpnYvC1RgPf3kDi7FpFcn8e42
17255	payment	1397	1397	1678	1	1	7992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvx218wqvtBBon5AsG9wYZB7j3HF9EQVrcek15sRe6WT9Y6VL
17256	payment	1726	1726	1874	1	1	6951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8ThaQe6wBXCs1grLjWzgxBu15K11yWfyDEqdzRxbGS6kXXpB
17257	payment	1726	1726	1874	1	1	6952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLECFnnjc9GEDmEgdqBsB5jKUGPWnDcE8ePCWx2Mk5SNB9wB4
17267	payment	1397	1397	1678	1	1	7998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KQkfyAtvqDVbeSBEyyBcoRVyBSzUMZFzzkmjYM8ji3kTwmiR
17268	payment	1726	1726	1874	1	1	6957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRi9G29aj7HWtgQx7cj5n6a1AdcN5xoBJ3HyX1n1auKFCwXh9
17269	payment	1726	1726	1874	1	1	6958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXRyovpyqirX382H6TYrvjaUQ4G3uVCoHUjPZzeBSqZS3VTHB
17270	payment	1726	1726	1874	1	1	6959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8N59kei53caStUYuN3QDVbFQVxHwdB7Gc55Cvr1P4oatjh1a
17271	payment	1726	1726	1874	1	1	6960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4cicpCdmpfzZhTzKrxXhVVYtFsHFkuuo54NF6zbAnXCJGMBK
17272	payment	1726	1726	1874	1	1	6961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLcYWMGbXKXzJhHqUR3muSsq92fmLJd6DzEYVHikoubXBgGg8
17273	payment	1726	1726	1874	1	1	6962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF3xmnWpuoeEoZMR8s89Y85ikPbaQfv96KGTMhJVqwdJYa9yb
17274	payment	1726	1726	1874	1	1	6963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMossBXioSCF25rjSryvfpvj7yvYnD84vMYUXwwWbTkYihxcjU
17275	payment	1726	1726	1874	1	1	6964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKsDH8a8YagkxcvL7e1A7k7dDtu4xT8RPAtaXT38ERB7pn7ts
17308	payment	1397	1397	1678	1	1	8010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSoDKpV1VHs5RGJPWMfe4A5TpTE7j1aeWdsCqc6jzK6VwRSg6
17309	payment	1726	1726	1874	1	1	6986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPqHwegV1E3or1rE6jgs5G5ordopWcPxTh52th6S6W3Vw1qxf
17310	payment	1726	1726	1874	1	1	6987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzh8UodeCd25QFi84QzPqHK6VPCUYDLnkZHPLTQmsVi9knLvD
17317	payment	1397	1397	1678	1	1	8013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaER9bvVZoc36x14e3FPqz2syPPzjwNmPzwu6V8P4FV6d2wgrSj
17318	payment	1726	1726	1874	1	1	6992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseu2yoJ6EHrXK31Zt18i4dKAntGnextocR7Vv2hexcmDAQb9n
17319	payment	1726	1726	1874	1	1	6993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvvemZmXxiQ4oQpbR5jRmZ2NFZrTwBLmyWLqaP5NNZ6D6JtSN
17320	payment	1397	1397	1678	1	1	8014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ZaT78DXmVBS4czQDCdCQhYkNsEaoQDdH4Vyccg5kyfgmzav6
17321	payment	1726	1726	1874	1	1	6994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWyfJ8Kh4naQ6dWEpc7LghZRbGksRp4x9PU5whn3N3gXgo3zg
17332	payment	1397	1397	1678	1	1	8017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhC8ByhfZSHL3TpCFoHwKh3SUha2EfWPWTZp8jSRMNvG3M9Xs
17366	payment	1397	1397	1678	1	1	8028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAyk52LQEDSY7J9EArbouCXvh7TPYnGfRjgjMQuRYnAKV1Ej6
17367	payment	1726	1726	1874	1	1	7022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC2U8Gwh7LKxhruFSPUZrQd2fZsULrQkvMm8xwuuEvcSMXQod
17368	payment	1726	1726	1874	1	1	7023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVzuNhujiKe5EWzWwTA3Ami2KDHvxujVezAiQvfa37JVA16g5
17369	payment	1726	1726	1874	1	1	7024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxFSx6TPCswb55V4bfv5YDSsoqgBMwmWeB4SpGS7zhERmBVEU
17370	payment	1726	1726	1874	1	1	7025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYum8AP913f1d6LMn9dqPgb3iGDK6xZX9uSFE4rGoPZquw248eW
17371	payment	1397	1397	1678	1	1	8029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPXbZMD364uuzH2Cpy4sx7tNc6crVLWC38FsYWXe6b8MTesnZ
17372	payment	1726	1726	1874	1	1	7026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBwdGJWBSCBX5ZVBSmjXWRfDCKp7PBE5DtdwR7vGuYQbnzkLW
17380	payment	1397	1397	1678	1	1	8032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQK9q5AdYGwzAj6TAvQTQRFrLjhBuLe5h6imuyDq4uG84yxeE
17381	payment	1397	1397	1678	1	1	8033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jVUerKqAUhyRukN8rrLunuj314JmfxDNjnGyqcXTKsSdgKRr
17382	payment	1726	1726	1874	1	1	7032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7Toz1UkB2pemx5mv4KU24GLW3srsuwj9m6mLLBF6BnYbrv4f
17383	payment	1726	1726	1874	1	1	7033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NdRf2fCuMtXvhCQqu4saQjA7Tj8eg7CktjP6X4o3w6p7Z5YP
17384	payment	1726	1726	1874	1	1	7034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNW36Z9pgQZWTSozy6jTuWRyDLhaGXWaatEVMebjyu1NN8EHK2
17385	payment	1726	1726	1874	1	1	7035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa99RLnkJVFqPHoCSR2yzQiVt4SSmbonGAKUtvnHF6onbfUxia
17386	payment	1726	1726	1874	1	1	7036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQ13ZTzF6vm3HLEn7BKWYLXMxJj4RpaGP65Zo9GQF8d6VE6rL
17387	payment	1726	1726	1874	1	1	7037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9L5XY7AKBmKytTVZMRCR7iK1akAkXFAph5pWXoxo8yYPLfUi
17266	payment	1397	1397	1678	1	1	7997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAtrmG8nCxa1YiFEp9WLBmSndAQLXtdjhmckctecwrDxBu7H2
17282	payment	1397	1397	1678	1	1	8001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJaKu1A9DyhV2ZjM9g2WrgKK8uFF5jgLUKSLaQbJ6xejHAYf3
17283	payment	1726	1726	1874	1	1	6969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPUuDxLh7GgMpQNo2U65oY7ewncE8WCe6VVoxcxVs2h3WX6dy
17284	payment	1726	1726	1874	1	1	6970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm12Qff7iCf4ZKt473Yyy62taEs3HjfqxVM2r4jzSrgfHu7Lpm
17294	payment	1397	1397	1678	1	1	8005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtvPzA4bRKtsy6AHV9vwh67CC65grDjuxdi2bTLZ3qaLiCTpF
17295	payment	1397	1397	1678	1	1	8006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1qA2Xm1sNdEQU5aBdiHi2Z7WVmrYU9GxbgfKPPaXAkM7iQBf
17296	payment	1397	1397	1678	1	1	8007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicTmgsDvzYm17CM4F35iy5aPCsHodzbCnEBA3bfaMn4Bh4tUQ
17297	payment	1397	1397	1678	1	1	8008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwYqCMs3ZQc1b2eagMuHMFJSh4BaqU4X2nbepkWBaetNmStwA
17298	payment	1397	1397	1678	1	1	8009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGY6xosye7rhH4RbabNmEYp1BGbHL5CvLMMVAxwdenzXj2sBAU
17299	payment	1726	1726	1874	1	1	6977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtdQVMmwStt3zbgPmgkTYtFcvzHT3HVZU5DAZXPC218Pd931K
17300	payment	1726	1726	1874	1	1	6978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDs6za22psmvX3ax3G2vtFAhrwVC1GqqF8r5BnFNaAWcpxdaHa
17301	payment	1726	1726	1874	1	1	6979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6TrpjeFKYRPw1NrFijmHLDgksDX5Qo45du3ifaWKFsgk4NT6
17302	payment	1726	1726	1874	1	1	6980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWJEq3s4iwoUa5TWxF6Rhk9QMBShhnAqqewaD5eaoeC4pci3R
17303	payment	1726	1726	1874	1	1	6981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KxannvCKxZ2VEHu4FntKHrQoHBDycvkSHX3kswSGN8v6dHiw
17304	payment	1726	1726	1874	1	1	6982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnp7XbheuzR2UMvjipdkYhNtJA26hxB3JbbMBWkDJFwxCJAdCo
17305	payment	1726	1726	1874	1	1	6983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AjQ2T2b4dsqamaHH49P4PovTRZ6k2zRur64TsNSnmcgSvBwa
17306	payment	1726	1726	1874	1	1	6984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZB71avbV4KrPPPZjPPNp3P3Jgvk5tANUdsEjRnyAkQpzU3PhL
17307	payment	1726	1726	1874	1	1	6985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJS58SfDXkGT1yWurjrrKPqL8MHuS3KqiW1XSjqgZCdX3jGHX
17330	payment	1726	1726	1874	1	1	7000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJFoievSDEDPekxbfL93sGCHMc8H3wPutBVWx4HVKF8k6SzLc
17331	payment	1726	1726	1874	1	1	7001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQQsK9WhioCT3YfCSJMESNqXc7wRGc38gPC9Gwa3vDi2tVMZW
17344	payment	1397	1397	1678	1	1	8023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EkdGfLRCJVoRdVr8DdhGHvZkeRp9mdodXo3vJTLoUucz9R5f
17345	payment	1397	1397	1678	1	1	8024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQAscfa1hvhcdX5fJKerr1byUeqUExh9Uo74m5itPSg8KhmMH
17346	payment	1769	1769	1769	1	1	31	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpxxQZnayKTaZhz2WSw2G9sst28SQxrKptBJp8HhVAX8a5RDB
17347	payment	1726	1726	1874	1	1	7008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSESPbQhiiVzaYzrJrKXSz4Uui7gWZEkoTeCnhZ3nETSt6Rtf
17348	payment	1726	1726	1874	1	1	7009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KpTdLbtzq1k8MzZnPvwgRP2NeXutxnUVMA37T9QP6nwEg86k
17349	payment	1726	1726	1874	1	1	7010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUgXc2rM8JVvyPzLbSh3mF4LkTMne3p1ET4fG6b8ZXqJeQcTm
17359	payment	1397	1397	1678	1	1	8025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8MsKnMeHC38VBbTr8XysMvsZUhaW5BWnWPezmxBh3Dz8MRxF
17360	payment	1726	1726	1874	1	1	7018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM3EBjP7ZzJEYLKVj8pBxtjewUCAbgdWRqoneVS9sifMVreju
17361	payment	1726	1726	1874	1	1	7019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9ftFWinFmvqr7FtAkdSd5gCXU3GUkrnqMmVXDwCseEUM84Vj
17389	payment	1397	1397	1678	1	1	8035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFyTEf1py88j31QkR45u6grr4eoB6A81M8d5h4q4LMCpqfqTp
17390	payment	1397	1397	1678	1	1	8036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65Nth5DqcVn8FJqMbF1bvccHXLB4Tgjy6aRgE5c8g2zKMQNLL
17391	payment	1726	1726	1874	1	1	7038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6yKLv61qAGqxN17iDjJMNf55ka3RzCqzt7ssFYPLxVMVpC6p
17392	payment	1726	1726	1874	1	1	7039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHyijbhRzoa4VWxixf2Y6DoW4eTBr5ktj4Jc2ToGXTT3Wsouq
17393	payment	1726	1726	1874	1	1	7040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGvzT7dP4Z9mfwGV8XV55ntrtSu9Gc1P3HWSAJnJTFvr1yXAT
17394	payment	1726	1726	1874	1	1	7041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiUQQY5LsBmpsZ9EcB72nqbFtTbFFGqRApJm1EiSbvUiqenna
17395	payment	1726	1726	1874	1	1	7042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ivbDWwRg1TimUbr6t8dpLg7qe1uCeV4GKz3WDsRyZaJDq3A7
17396	payment	1726	1726	1874	1	1	7043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZYLpL1T9MS9eNr7CdQTJ135NjvMjbwNG8UKTLiuPXDsaUmeZ
17397	payment	1726	1726	1874	1	1	7044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzdMCicaYVmtvJeW2xqCEpGiatRP5BTg3ZHCbAN6vxMEZAcJV
17337	payment	1397	1397	1678	1	1	8022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9pRMjJLs7bXNbXBQG2A9zct1LuTuvDWgEX2dkdmTVDTQEy22
17338	payment	1726	1726	1874	1	1	7002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQGFbLK7L1u9vo7rQbajBRqTLZ4UKRFyjQNZhGKyu8yyvTRDg
17339	payment	1726	1726	1874	1	1	7003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtWCZ6Vu9gEGb4VKQxR7iE46PXb9rVfsakBLGesccueX2bZSd
17340	payment	1726	1726	1874	1	1	7004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgJzSog5yQicrZjGti51guBPqhPLCPihUtQFDGr2bCcLLLSnb
17341	payment	1726	1726	1874	1	1	7005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGojuffu7TUocd7aS23345jMp4yZwuDaixqYg2nDPZ1hzT8gT
17342	payment	1726	1726	1874	1	1	7006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHB9s6cq8kpi5j7fr6TKCFjC6oa9Vg9XiLCtqtHWiXaqYqAq1
17343	payment	1726	1726	1874	1	1	7007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcv1yhNuzPMp2vrc7iSUKVHSSTskA9mzJfeGCw3CAXd471gdU
17365	payment	1397	1397	1678	1	1	8027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDtYxNyYbeG46Nuw4k4niQRcpDPSah89MJ4LDF2VQeLSmGHuT
17373	payment	1397	1397	1678	1	1	8030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nuPaELHXHM45rNPSMbHWxtJBcePh8Q656JRUjttTHy3Y6D4P
17374	payment	1726	1726	1874	1	1	7027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjJA677kTzfw9KvQ9dV7qqnn1xq8q3pXR7JazYfTVbQ1A7rFy
17375	payment	1726	1726	1874	1	1	7028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKdPMRrb49ADSYjoeNKL2g1DpoBc1sq5GbmHKczED7bd2MZJP
17376	payment	1397	1397	1678	1	1	8031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKd7SWu5Ywzm5qEfXeXcXCatWT7KfidjY1T6Fr9pUWA2gS3gmM
17377	payment	1726	1726	1874	1	1	7029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSh7PeAQQkXKuAgVBds3P4bG5yUMLpppfNHRGzrWduQKuHZ5uK
17378	payment	1726	1726	1874	1	1	7030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaBNjsiSkyk17gSsaAEJ6F3V8BUyvL1wEL75k6BP3eiG2Zmhz
17379	payment	1726	1726	1874	1	1	7031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRmKTEbwMQxEhNyQqW6JL4hd8zDyjHK3VctxDtyfrE2YVqq9c
17388	payment	1397	1397	1678	1	1	8034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6rYeSdRGq1yAgjwZbDeU5GhrGwfL91gQQNgNauEJqe7Q7FR2
17419	payment	1397	1397	1678	1	1	8042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakYg9kHEaqeARaiE9PF7sRqWCn3Qbo414Dk6NNbBEy6RWS9M2
17420	payment	1397	1397	1678	1	1	8043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB44UUA92eqSDZ8kNb9grUKmKkRu9cGV94YG1eySz4UeMArivz
17421	payment	1726	1726	1874	1	1	7060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJABcDrfqf6qv8zBfx1RCc7rjyJ32ugpUBtR6MnWAvKLqf9Z1u
17422	payment	1726	1726	1874	1	1	7061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQyfGReE3SZ7aVnBJL6mPqTm3WYTh4WwuG3rRDrXLWdJL9jQv
17423	payment	1726	1726	1874	1	1	7062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNuvR3SxLRaUBneTPBVVkbQKnt7bBL2LGzzPGU8QYBcMQJVeK
17424	payment	1726	1726	1874	1	1	7063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUB83DGaP5DXEvyauqdVHpVJFmj2RxxqgGgfp93q85red2VAq
17448	payment	1726	1726	1874	1	1	7083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUWeEfsnm7nUTHvBVGKQjWxWutbYqTi2EMehW6xx5BWZSkDHF
17449	payment	1726	1726	1874	1	1	7084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZpJP3oXfncck5Je8cVSZYokZTw3Yz3UWwqSxj7bpZVGGtqjP
17456	payment	1397	1397	1678	1	1	8050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rMygVYppPSnqsPyfFC2Peox6jUHAhZdh18RuDonZ2MQimbFY
17457	payment	1726	1726	1874	1	1	7089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHiVMBXtwua6Y39PpeGSMVWhN8qJXTyZQ63NsQd5cDuSBqVi
17458	payment	1726	1726	1874	1	1	7090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LtnbSmZH1h9pL5khzrAnoezpy8DBBp2XzoCSzeWRvxsDV2kg
17459	payment	1726	1726	1874	1	1	7091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMUL9nR8byjg1wfevMDfamRaeeqsrHKwbDE8VDHxqUd7ZED6q
17487	payment	1397	1397	1678	1	1	8058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZERdERbjXEr2dazW9knSgQS5BGzWsrjaeFcvHuoTwjerhM366
17488	payment	1397	1397	1678	1	1	8059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBBR9BgwbDshY99HUGyRHaJhEdRkfJC3iGFwZwxZgpGrgbZXT
17489	payment	1726	1726	1874	1	1	7112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUyLHkBgPHtb1L58dqVa2dHudTBwoXjNBQ7fBxJV1aYnuGSbW
17490	payment	1726	1726	1874	1	1	7113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2asHrAFHWhRvUvZ443EYd57mTfrXvtcuKDYyi3w328ULAzW1
17491	payment	1726	1726	1874	1	1	7114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEpAPp2jnGSEdg4mkz8dSBmmCSPu9R4RxiEaMRZNVY563jV3E
17492	payment	1726	1726	1874	1	1	7115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRtje8iJN6LxSKJER9df8ccsUprYGkorJRjfHZp9YPf43FGaX
17493	payment	1726	1726	1874	1	1	7116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxCJxgJoxzKFoEPpnyY4kKB1X2W46CTun2Zg6SBGkXtTFYc2p
17494	payment	1726	1726	1874	1	1	7117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARZyzuaVTVimT59q2tj9KT4tyJCsj2QGmNQpc5WE21u91gMLD
17506	payment	1397	1397	1678	1	1	8063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzv3syNoHSDWwxqdF7zSYyWJHJk1wXju5FFtse2LzLvQn9MYW
17507	payment	1397	1397	1678	1	1	8064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48kquwqJjXqNYKNQzLkpTFNHWNEo8DM9EWSSfcVK6QBVayhPJ
17355	payment	1726	1726	1874	1	1	7014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKURzHjMahostgfTU2384Dif4Lc7Uj4GF437A2sk2m6YpP9wn
17356	payment	1726	1726	1874	1	1	7015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31z3eC6roAjQ7V8Z2Hbw8R8qaa2Vx1qCkUbJNT9Eurv2prynR
17357	payment	1726	1726	1874	1	1	7016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVQvo4AcBz3x7Tbv32ZSu6xqR1nPTNZxUfccC6YUPx2HPstCK
17358	payment	1726	1726	1874	1	1	7017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzn3YHG2JMwps5YLJ96VZbRyfBj4tLttT8tzd8iRs1RACqwtLA
17362	payment	1397	1397	1678	1	1	8026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RVgj18YnGch3tS7fhxM2K1fh2KApFW6Lzb3QHnSdv3GphDq8
17363	payment	1726	1726	1874	1	1	7020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGDKbTwKaYuPjQAEJ1KJrYZUX81ApB3MAf2VfDbvDmYQFbcad
17364	payment	1726	1726	1874	1	1	7021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhPQw2uaqvVQjYyDonQHuP1WN1CHaGHtPGEJVBkykw4Ziz6xT
17405	payment	1397	1397	1678	1	1	8038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxteddrUZqwLBqxKEu7mxeE6hDR83Q5dvDqmAovJ5q3xQ7YRLM
17406	payment	1397	1397	1678	1	1	8039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxg6BWKgQ2QdWnDTjLBEw8UKBsep8Z15gxYm8MeenCswJ9wbYy
17407	payment	1726	1726	1874	1	1	7050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczsyC4TVLUmy3ZNu5bBSMSpccbSDWa2Tsv3giUaUfdZcKSk6b
17408	payment	1726	1726	1874	1	1	7051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGdzQd1TC4VVbjcqwoa4yPmKWoVEpJqeLfDY4JPyBVUS1Lv7Y
17409	payment	1726	1726	1874	1	1	7052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgF7tpo53b59wAqmy6zYzq1i8f6yofTPhbUn4BKT7XAa7EALVF
17410	payment	1726	1726	1874	1	1	7053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtS5WuF83ioBWspWsS7wimh42Y115z5evynPgbTP7T3JC5HXZg
17411	payment	1726	1726	1874	1	1	7054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYTz4yL3n7eukZUq1y6M7aTJEowaUe9dWwoA8ucJ8Zhdutanz
17433	payment	1397	1397	1678	1	1	8046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrKt23NKgJyuCQ8nudB8FN3ZXbg8X4vZyzDLSzbs9chXu9xQb
17434	payment	1726	1726	1874	1	1	7070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEwevxrPJFmLe8muY8bAh1S8n3naUsiYjHxJu76uYqPK98cvn
17435	payment	1726	1726	1874	1	1	7071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrWcwNyPbEYf51oy3kw3yogHjQUc6Zu8reM9GnbneTd6PKURQ
17436	payment	1397	1397	1678	1	1	8047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47pixzwQi5z41Rv8ptHVdFdcWNW1J1PAufLqqeo1zJNCvQvAF
17437	payment	1726	1726	1874	1	1	7072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2mbFsXzTao9nK5SFxB6ZNMahaGMfXqe4LwHnhcidUAQsiqzb
17438	payment	1726	1726	1874	1	1	7073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu16kyBUpP2sxxxWdqeFRU6WCBkTNYN6kTvLNVkqCSr6zpSrMB
17442	payment	1726	1726	1874	1	1	7077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkGzx8GkVTieqtoHjoZ9F9VFTQU4HVAQJwbJXZeFp1PwULYQq
17443	payment	1726	1726	1874	1	1	7078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjrSJZ85CKbyViPPxM1FB21cTJGGR9KTkWNtRFXVmDwhqMDVU
17444	payment	1726	1726	1874	1	1	7079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6JVkXH2w4gkU44NgvJfLAPf72tdijZ7tJogSUAre1tNWhr5n
17445	payment	1726	1726	1874	1	1	7080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4FRXrsVRYyVvafpuSDPCgggS736huabdZZzzfhRh7rmyDCba
17446	payment	1726	1726	1874	1	1	7081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC79BK8FvfUDQD6xWUM7NKtRUwDzqcpMjZGo2J7sKiMKoQEoz
17447	payment	1726	1726	1874	1	1	7082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSMwr2yj44AjyHEr2U4fYiBBMRfufDhsEaJdah76Sy2tG4EuE
17472	payment	1397	1397	1678	1	1	8054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGBWP7JQAGgU4698XMhPPv67H1YDyb2MsCxvoUaedPgvmc76r
17473	payment	1397	1397	1678	1	1	8055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpk3BcZNXKkWLiUDnRfWTyswdBzRVcVgeYFG8roHyv85DAtS6u
17474	payment	1726	1726	1874	1	1	7101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVWcoEBXsdAtLpy9gjn36G96HtpzScwnqYUACA3yffhbpJyYn
17475	payment	1726	1726	1874	1	1	7102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjRjsqoXsY3DykRp3SMZAzLpBMtNS3wKwLkDP9bX9EvpAn4XB
17476	payment	1726	1726	1874	1	1	7103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLJ7XUNnKme4zHKLWQJzxG76aokpQkThb4AkcRhNtfejDuvsP
17477	payment	1726	1726	1874	1	1	7104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodAxxFaGUtGMnzRooCdAXHh85fsjFGfnMSH9VgG7H2AdCL7Yf
17478	payment	1726	1726	1874	1	1	7105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4iPFfSTpi3a9mRmWuD9PVp2hUjgPaM7PeR2CY9rHwB4DWW9w
17502	payment	1397	1397	1678	1	1	8062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGVjyXz76ikSZvPZK3kuECRQjFwnVCzZ6uQ2fLSaqjoaC4zY2
17529	payment	1397	1397	1678	1	1	8069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCSLeRVSTHqUhnaame9cDqMwN1vdMvD2S4paNrNUuRZGNNq3ax
17530	payment	1397	1397	1678	1	1	8070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68uqw9qc6C8KCCAX5Gw3LVKjX8MsvEnzd2ftbGhUasfDCxwST
17531	payment	1397	1397	1678	1	1	8071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEuLrYh3PRQhj5DVdjdMivAfKPTBEu3DXraCJQnbiFhrj47L2
17532	payment	1726	1726	1874	1	1	7143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S9qP5ACaEskeJ99notUMofWzy5D3t4nnPPzjhYSp6j6WjwHf
17398	payment	1726	1726	1874	1	1	7045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8B6z5LagZRLvVJahZtd7jEL9NpxPcLFcyEzam8VoXAp3Xosa
17399	payment	1726	1726	1874	1	1	7046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AtAtdxYgbhyiC4QNXurRnXfkuRUCiW6bdbURoNZPA89w4iVX
17425	payment	1397	1397	1678	1	1	8044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc2dzY4TtPddmpj6zmpAqMvSQ16PsRwrKPoxXJMSzPKqkWyMm
17426	payment	1726	1726	1874	1	1	7064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctnTkTcKU4DbMSDqGQimMPSAaVyTMudr69ZiEL2koRHyXXV9P
17427	payment	1726	1726	1874	1	1	7065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9WUgHEn8UJy8bgbtyG22Utkgi38iPguewcmdJa7oG87jWMch
17428	payment	1726	1726	1874	1	1	7066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSvXGtk5hH4YATScH4DJXPveTXEn48tv2QSq66byufHR2XpC1
17453	payment	1397	1397	1678	1	1	8049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MdpiNrvECtaLWWFJFUpBBgm716Ys6zVW7cKm1ydgQvmFMVMn
17454	payment	1726	1726	1874	1	1	7087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazMsZjmESKEPBNyLsnDyKph6nc8nfGF1QS5hpyhoiocdkBMaf
17455	payment	1726	1726	1874	1	1	7088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeBFwGb4CCRLL2anMCefoDQk9cSZS4EyMXk8qUes8P9U7jrgf
17468	payment	1397	1397	1678	1	1	8053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuR7mRHozoTeQbqJ13M66S1ZiQK93N7SHbBZ6ESh9yfCmHu6Ke
17469	payment	1726	1726	1874	1	1	7098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1YiRGe2BDvHqEtJQoznyFfHw9kz7qAvTD5sLdz3C4EXeXePi
17470	payment	1726	1726	1874	1	1	7099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcx4HpGrA4ukdazPnTLSU7HPEoGqsdxd31XujFRGRHHEnPCjDe
17471	payment	1726	1726	1874	1	1	7100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61SdCKnGm7e1iUp6J7GGye8uRgjudki3U2YEXtYmgzzNqwkJe
17495	payment	1397	1397	1678	1	1	8060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcecE93oq8NDa7QC9hu8A2MDf3VRHTgQSDSb8y55XS4KaXeExz
17496	payment	1726	1726	1874	1	1	7118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm61brKFYBPzSEx5qLVrmzJovx8bEkT8gMcyUomg6yzp77XEn5
17497	payment	1726	1726	1874	1	1	7119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq7zxdx4tpXjTMGN5njFvUDsY6923vYt4ibtRAzCnPJZ7HSfe
17498	payment	1726	1726	1874	1	1	7120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJcFceoC2wSkPWhFo3ZySMwVCnyQHPQcvRJCr2F79HXqZXU2X
17499	payment	1397	1397	1678	1	1	8061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSFy39dAqGQ28gtH2b25rEo4CV9sVEhsz5kTsWCxLDnnECfL2
17500	payment	1726	1726	1874	1	1	7121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Dv5kjLXseZnUwGoDZzKRfir74CbrPVLPQCeJDEeGb7ykxDiY
17501	payment	1726	1726	1874	1	1	7122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vDTQRkHHtCPCDLM3p9fueat2BbzKioCBvhBZJ4nbpdHihR4J
17554	payment	1397	1397	1678	1	1	8079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNKFnXLo9EBc7GZKZqSieAjfp9MKABVcRmGYieH5Ym3FHQVee
17555	payment	1726	1726	1874	1	1	7158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRduGyuGLQvmQSFwz7LrbWLnaatQHBVQ3Gesw5BTaHqiKbzZ48
17556	payment	1726	1726	1874	1	1	7159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5qMKKcCE8GBHxZWHAa1caQ9eKgjrXhyv2key4h477rh7oP21
17557	payment	1726	1726	1874	1	1	7160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHumGbK3Vo32n5SsUXfgqxeHkaKiQEuXXH5mTz62CSfro9vnn4
17558	payment	1726	1726	1874	1	1	7161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5rBUidjduskztpjv5G2HihCoQeMj8coSZotJ8SfUfm2Hd5Sz
17559	payment	1726	1726	1874	1	1	7162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xU6RCVYgvrBhw8RgHpHf7oNNUJhZivZrbwLf1x7xbKHkRszC
17560	payment	1726	1726	1874	1	1	7163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXxAg14Y2TwYaK637YzZm2L6r6jBtSgKpWFLMPtiEWb9eEnLn
17561	payment	1726	1726	1874	1	1	7164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsndtabw5tAxdQu8gCodGC3QCKo6XsdGcJR2Umq8RWNqALAD1
17562	payment	1726	1726	1874	1	1	7165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrM8zswkwagsBSRy7uiZSRRxZnnm6g2zwbSsJv6kXJofJhszkX
17563	payment	1726	1726	1874	1	1	7166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2VR3RvoaXidtbM5AgN1d1rpGQbqEmGrahmD6hzEuuwFydXkCn
17564	payment	1726	1726	1874	1	1	7167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBA4WWsSNZpeUnJJJRK8YeGj4H3LoBR9LR6gf2eMw8Vf3d8Cbs
17565	payment	1726	1726	1874	1	1	7168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDZ1r4tdpvajQt7MCrSRSM23eZ2g5vChX2YnVvnzeCbPJsrFD
17566	payment	1726	1726	1874	1	1	7169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwM4AeGvZXUozTG6vEgu6UFcSefZiHyU4ex87YQZZNEH8UnB5
17567	payment	1726	1726	1874	1	1	7170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBCwptrXLxuZYqZD92yywNsXpNeUqigNjQhubgyrcnnFxa7zMz
17568	payment	1726	1726	1874	1	1	7171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmD3YeqatG2ZUXwRKvo8rRrFpmahsZBU1kfhje92TmxsUG8Z2B
17569	payment	1726	1726	1874	1	1	7172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysBkBExeZYo387gbTHxWieNQ8ZsmBa1z1qDg9juFJJUKgt9JK
17579	payment	1726	1726	1874	1	1	7178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rMt45HmyVn77AfusyNX6tRBWd7EV5ioFWuRWaxWy3xvUxZwU
17580	payment	1726	1726	1874	1	1	7179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Hvnt5Lh89hHX1kACUL2u8nU3Ax5Cy6JHgBNXx3DVRGcXzge9
17400	delegation	141	141	1483	1	1	0	\N	100000000	\N	E4Ys5NH37gKfEaPToDdfSskg5eXUoQi3D6xtbBfwy1kYskjE3zUHT	CkpZSUoRUHUrj9m4GvNctzDCrveANm9GvDtZR3iDi8B9gihY2Buqs
17401	payment	1397	1397	1678	1	1	8037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPaBWcLnSdaJri9NXacctcGJRhNjWDuyczJEVdPiKS729A2oJ
17402	payment	1726	1726	1874	1	1	7047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTVfYAMYHDUGYYJv4gtiFnLSnrJ7DXvam5udFAnXHZ7bafunF
17403	payment	1726	1726	1874	1	1	7048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCQAuJkCmmuzwe4c2khQ3ZEhikyWcAdHf4PpHtMv23bHwhMwV
17404	payment	1726	1726	1874	1	1	7049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4H5AQEq9eXQGUujE4MWRc4ERfk7S6qptbS85zWjA6A7avCnr8
17412	payment	1397	1397	1678	1	1	8040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusNg44VRixgppuidhzfS8E6BwxgT4omrDyLYVB2gcx4P7xQhm
17413	payment	1726	1726	1874	1	1	7055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KH66C7FrceU6Pyv934nUPUwcWoNYocnagJz6qHYfq1XPh7pH
17414	payment	1726	1726	1874	1	1	7056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRmTnidgNuck5LVuWVqBXi3ahK8nZAXzBGQtRZRCGaWAXSwPS
17415	payment	1397	1397	1678	1	1	8041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqFuzhjRePDo9jzRr2uGv7ZodYJEsCEBHGuQVrFaH4Gd7tWab
17416	payment	1726	1726	1874	1	1	7057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe8s6t2iEqEbemxSxcYqhjsZyb6kDLNzgTZ3G6B7w5wh9WqYU
17417	payment	1726	1726	1874	1	1	7058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pFEZPr4tMGcVnyxwi5oV3YKG6MK6s6XjCC6CFeuR6XLuB7tc
17418	payment	1726	1726	1874	1	1	7059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdfMWeuCXgnoAwHTJENUzbFHuWT9JMNi68S34cAfkejCqEGs6
17429	payment	1397	1397	1678	1	1	8045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKxYJkJEYcK6EbAMxGvsKfaC5FQ7CSpNGswmJ9QdfSwjvVU61
17430	payment	1726	1726	1874	1	1	7067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixf5JQg66ASeEQScaDSKCmjRLx7Hm6gJp7B24d6pQXtxvcaT2
17431	payment	1726	1726	1874	1	1	7068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybiSFbyc9KowaeAcwSkSFVqj27PMTx8snjPk3gfz5rJN2f1vb
17432	payment	1726	1726	1874	1	1	7069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4FbRTuykTAHxcKftjx4LKWaPLB63uTxooefnF2oUmT3ivyEK
17439	payment	1726	1726	1874	1	1	7074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVqLSEjsf9jLm7jPFWaYcAsEoSrKYT3K4B8EPtKgWpjDG8FFa
17440	payment	1726	1726	1874	1	1	7075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHTp9sikNotgcrA6wiAWM3XWCGiXzJzajCWHrD5w4WhXCei9o
17441	payment	1726	1726	1874	1	1	7076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEP2mu1bikrDokeQ7hbcRPYEjUTPnnE2SpZdey9ZusZBoDSY1z
17450	payment	1397	1397	1678	1	1	8048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAL48H8dVMwU8guaQjgBSWE2fBEopEaq4XFWQfzUN6QxjM7SvK
17451	payment	1726	1726	1874	1	1	7085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT7nRJ3rqcGMhbFLn6PXSaey5A8n6nL7AKvghVskx5WHv4w9k
17452	payment	1726	1726	1874	1	1	7086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT3ZoEVzgmgA9SPdpHq5YrgPmg5okGoPSyvPWW13mzEbziust
17460	payment	1397	1397	1678	1	1	8051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4BnbFsHvumqgCJaADZ2PL8TtnmGtXSxyEuMYuqwi2kVoqLE1
17461	payment	1397	1397	1678	1	1	8052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRLJ3hyDQUgEK6mNiAMLrhvBMLgGgEjXZF6nkwXwMCoLWxDHk
17462	payment	1726	1726	1874	1	1	7092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDejkJsJoXxH6T2XywWBLcWcM3UBPby3vvoH8eYxkHLFgBaauo
17463	payment	1726	1726	1874	1	1	7093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnhcEEL5Nf1aw1wsqGyiSiytYEwPAvtqYg8ivvn9vsHL2r4AU
17464	payment	1726	1726	1874	1	1	7094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8fkvaXCe6dtVvyKyYJhJXUSziJY5oMYyQ63cF8ceTjh3NxKe
17465	payment	1726	1726	1874	1	1	7095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3HKdcbHFqQ8NLSiuyxQdCDoS9WiekCEn7i8VBERuuC9yXdZNd
17466	payment	1726	1726	1874	1	1	7096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwSfoRwmWVNAj6HZyFRr2vLHFo6sjR4jZagXucwmXtJ3JAn9Y
17467	payment	1726	1726	1874	1	1	7097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSbbMkVndFEDV2wSV1nQwohFkWuNQFTocaq4ufM2KfdLudpTp
17479	payment	1397	1397	1678	1	1	8056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZboujLJtYRaf8zAn37MQgEVFUKLL7HDhyivnhnW3wngrCmu4J
17480	payment	1726	1726	1874	1	1	7106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7UrSAHRbZCVvUMWf3dcniwy5X8gbMjAUQXSVshQYAXSqiUMj
17481	payment	1726	1726	1874	1	1	7107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYedtGrimjBqn2nFNtpgvUJf1iUtHPRFreMJnKroNzQUBeqCN7W
17482	payment	1726	1726	1874	1	1	7108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKodVWvL591FFY4RWEFxW1BXYhtZyXMW9B9Ct6yEk1sWbSwC4
17483	payment	1397	1397	1678	1	1	8057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yhz1deQnwfacRjALZ4He3xbVEKmfdG2eHgC5rkW2Ab1N75Hv
17484	payment	1726	1726	1874	1	1	7109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT74ntXrY13vw9NaZt1PDSYrjgB1tsTTp9Cx42NRffRBiWB2Q3
17485	payment	1726	1726	1874	1	1	7110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuPGbF2dwF4VQ9ekb8bLHNxao7HCU6eDzxKHTq6RhULZaHPfG9
17486	payment	1726	1726	1874	1	1	7111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hFPx41awLdWyn17UZdHnkjzrURZSYGUY24KyGboN3CkQ2Q5j
17503	payment	1726	1726	1874	1	1	7123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9odTZMT5zyFgDHtMbxstuDHwi6MLfka8ZXLPrJyfZbuBfLvX
17504	payment	1726	1726	1874	1	1	7124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ddzco5HCDUUp4vWZHHjQ1PMkCnf2r9sy7SMXzKsvy3CjbZc5
17505	payment	1726	1726	1874	1	1	7125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRc9zXYimrPbJfbz6Z3Wqy7tvEBuEqoiPVuAMaGtFuwQ6QipmD
17521	payment	1397	1397	1678	1	1	8067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQA5CuzNFbPeUPkbLQRAB52LuK2Dt9NzNSbJutn8CGa2GFhpu
17522	payment	1397	1397	1678	1	1	8068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvhQTFBWzSuxhww6hnHPmCutGtDJSoRw5HwvpzQLp7qgMLCXk
17523	payment	1726	1726	1874	1	1	7137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvt8BQHVcZMjojwoG9ykGzSb9FstGUWeFZBA6i9LrtRWDUaqq5
17524	payment	1726	1726	1874	1	1	7138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9L9x1nVtpvijUQhoTh8By9xen177tTeFPkCBdtEWsM1tPHR5d
17525	payment	1726	1726	1874	1	1	7139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzk3saiEp4avqCc1EHeCtD2FsF4r1v2AGLPBxwNWMK9soSnFME
17526	payment	1726	1726	1874	1	1	7140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7bc1uvuXXXyM8Pp4ctoqhxSP1mXBXkP1S51PSidZLZy6FemA
17527	payment	1726	1726	1874	1	1	7141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbiQwWkGfQVmkMyXZs8Ffo88S2ycF9qEw75YPa5zxge1wwA9XD
17528	payment	1726	1726	1874	1	1	7142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdefuxYFk2WBLyaJ9W8fnimo9UY9SWRERSgyxfBkVqjFzcsex
17541	payment	1397	1397	1678	1	1	8072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWdTAVVy34CbxU8xNcDp99wsUVVXUkR5jtNqb4Z9JZRHu1XQs
17542	payment	1726	1726	1874	1	1	7152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2kogJNNWPxuJLSAVtgrv4tMw8WQKp47bwdwtkRHPSXtymmFe
17543	payment	1726	1726	1874	1	1	7153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC43n1LZ13dGnicL1uX1jBpqAK5Cjbc7KB6SpmVxgroAykJED6
17544	payment	1726	1726	1874	1	1	7154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35fVT79U3ob952BeGsTRomCw3wugLz6yJvcpKpbKRwq3asybZ
17545	payment	1397	1397	1678	1	1	8073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rC4WFVbKL9V2FRJ6aVWmCGWcMVPAVhPNUHmHsMPxMnQ5txtM
17549	payment	1397	1397	1678	1	1	8074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBahECNXgVoVk61svhsYqeXFq2nTuU7zV3CYHeFGNwnYNFjD9M
17550	payment	1397	1397	1678	1	1	8075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HwoCDdgkPWpjBV67QgR5iXeofv3mjMfvDyeEgj3M3HpTcyEV
17551	payment	1397	1397	1678	1	1	8076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wN4hWCwKZt2tX9e2w8vLzcz3mAtjDdmkfVAYXrDvnfjshb86
17552	payment	1397	1397	1678	1	1	8077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWcB6Q4B4KcDHuV1oiD1VeXY2pZHdzU2XTFAHtqwpour47nSY
17553	payment	1397	1397	1678	1	1	8078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3rjnSkC3BshNjCUx2Pp9UAekZto6eYAJ1RAY2RZE9bZjDmUr
17570	payment	1397	1397	1678	1	1	8080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKLZ47vQ51ukpgghcgifiATTrZyFgiMNr1sMfMWNydXRL5gzF
17571	payment	1726	1726	1874	1	1	7173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Dd9xWM697wfa1FeBAK1da9WgvNKBTccjpD2okYiTEMCRYQWL
17572	payment	1726	1726	1874	1	1	7174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4URR8QkrBHin7w3WhgziijWpoc1KowNUwLGYjwPNYHYAhHJ4o
17573	payment	1726	1726	1874	1	1	7175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBxFKHyjKtgWjpcxDDiaeQP8ApknkrGzdABnbUPpPE1oqPDjT
17588	payment	1397	1397	1678	1	1	8085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUo8H9RBCiWNp7ZRgVje1Kbqp2L3DUZGMm9CDWwyJT87zvmfF
17589	payment	1397	1397	1678	1	1	8086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuuKsXUK9wR5z2XgzU57AsSsAjvaW5c6rp6RbqqGGgxUEE5Ut
17590	payment	1397	1397	1678	1	1	8087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1P7L7KWGHnTVaXrasu4JdYiyrF3XgGupxvzqFtgNHZGibQAM
17591	payment	1397	1397	1678	1	1	8088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXSvrUTzNbEw6zThiCm3YVRWWruk4YhesWSogNgXfTy1NNR9R
17592	payment	1726	1726	1874	1	1	7186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXygLgX2d8oVeh3sWthn6JvKShpKwEaFVT5ZwKNFReZSGYMrxF
17593	payment	1726	1726	1874	1	1	7187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevPrxbvRBtjPreknbPQ6YmPejj4JPip2FLciK7WnLGEdzMwJX
17594	payment	1726	1726	1874	1	1	7188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ48WKzUvHYqp1SQJUnioJzenaMgDVHk5UWaL2YaRV3dtYukz
17595	payment	1726	1726	1874	1	1	7189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWcifGnAn5bnH5e99JEetXjRg2hJTE5M9ZLwkUEvZyAWHyDwu
17596	payment	1726	1726	1874	1	1	7190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfnEyeJ9nLNh8JFgxPxmg96fWSZf4gKKi4qV7aSXvPVKrT6wV
17597	payment	1726	1726	1874	1	1	7191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hC6624xXsZ79eHdvfyizCaBc4RFVpcNsqXvbAa7ky5WLd1tT
17598	payment	1726	1726	1874	1	1	7192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5fWQ53kNziNuSY8pXC6qiPTGTF7HYaFN5yPm5NQ4Pgjuon5e
17599	payment	1726	1726	1874	1	1	7193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc19XJrvNtVxbVxnkDGBSEeFtcekhDz3Y1XHXdqLXSVLeHfJLD
17600	payment	1726	1726	1874	1	1	7194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkXhpracXbnbC4NLixungNgY9PVhpnKFtTAFrGEcF6cCWNJvt
17508	payment	1397	1397	1678	1	1	8065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9vZjP98d74XJ5jyDbNewxMEhVsenefjMTAu8nYVihrh1wzyV
17509	payment	1397	1397	1678	1	1	8066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7Eib4qWBHa8b8A4NJdkpsTSWroyTpt2KDxotbgP7F7AfLkiP
17510	payment	1726	1726	1874	1	1	7126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbAHqbAu75JtkqiRRUTDnCmkQxAYytoui7k97stxeJKYxyHpz
17511	payment	1726	1726	1874	1	1	7127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkJ9uYh7QmFN7vnEKGwiuFjLKyAEXbNT1hM9CK1uAFHm5vSgt
17512	payment	1726	1726	1874	1	1	7128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBSNpmn5fwUshpNNLe6h9m5s6BimV1uHudGssQ5H1vuk4omY8
17513	payment	1726	1726	1874	1	1	7129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqkBeLVfrrrUi1WebxYBaiSTfP8uHuBWHLR7KMtbssbjCKuAB
17514	payment	1726	1726	1874	1	1	7130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmjKNsX7dAUjXVTziWGavvvFxZQaUTgEEzvqo3ezBLjhaaisL
17515	payment	1726	1726	1874	1	1	7131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMY19AiuJNqxqhf4X3Wd5s7eYiun8wrabnvzqA1VgZv3aVDRh
17516	payment	1726	1726	1874	1	1	7132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjfNhifqMhkSX1QeCL52LH6HRpk9VtLBE2KEXeDm1zaPTNd5k
17517	payment	1726	1726	1874	1	1	7133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXohwWBQ2gfWG8f4EkpCzM8og2vdYPo6doGXUWfsUUDrg57PV
17518	payment	1726	1726	1874	1	1	7134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisqH8MHBZUSjcpX6F5UYyPbqxD75StbaVTRNCZQLjLUHcr2Ek
17519	payment	1726	1726	1874	1	1	7135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hvgdeqsCf8qtxZp3Jgd7rxA2QwWxH1c2saXya2UJADxA7MT4
17520	payment	1726	1726	1874	1	1	7136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp72YQrBykhU5T4ToKRzP9nof4ADXAGvqeD6ABYmgXAnmPW91t
17546	payment	1726	1726	1874	1	1	7155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzewBdUddJqVMqDJwfr5dmQmMcSjXqbFNmTC6XbvX1ZyBQh8R
17547	payment	1726	1726	1874	1	1	7156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72pknb3AscwzdsF6CYrSySuZm3ruPquujQe7nPfNChnET2Ddh
17548	payment	1726	1726	1874	1	1	7157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZJZcwgqoygkNcEjm1bFb8EjstQzUDVu7s9BmjsvLj2RPwTKw
17577	payment	1397	1397	1678	1	1	8082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhiCyRLBuWDHUofLE8vKiRjANvG7EbdwYBk9YUrwMcmX8twe8
17578	payment	1397	1397	1678	1	1	8083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37bh48VBVq1jVbiZaKcPxESqB8fTskPEm9aFHJaPyy393Jxpp
17604	payment	1397	1397	1678	1	1	8089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31EUUTPtPowUdiAZDyBJ6JREXVMniPTvkMSqNPoBy2Mh64Gy3
17605	payment	1397	1397	1678	1	1	8090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMqJkUwNgKXBtRB779hmoagcCXjBG4ZWEKcBdEY7aiE2W3zDt
17606	payment	1726	1726	1874	1	1	7198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDTRAVchk3YeyAyi6yp6SqAphJRSZ2z5Dt7t88QqCcmWjXB67
17607	payment	1726	1726	1874	1	1	7199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvv8hkZMxW6Wd9KHPrxNvvW4jUrxPFjYbqfS7TNDRpmPwDci1g
17608	payment	1726	1726	1874	1	1	7200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXk1itt7GieMaUHkrioKHKz4m3XnqiH6CLsjFNNLwQnnLJyM1
17609	payment	1726	1726	1874	1	1	7201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5YNuZ9hiLD5FxDwuB7J5yU1Ms3PgGSMCRGaxsNHygc4jjXhB
17610	payment	1726	1726	1874	1	1	7202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqG9nAWcefME5TowevRMUWN5FdSPc1aWz4by8sE3x6RsbQC3kw
17611	payment	1726	1726	1874	1	1	7203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMy5JmfsHFU9zAEPw2Wdpz2DxwDXgq5edUMCMHUeBQR93v3LX
17617	payment	1397	1397	1678	1	1	8093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw47j5Ly6gtuFogj2JdcKikZZuTJ2jRPA4bztGw9ZLuHs8Duwk
17639	payment	1397	1397	1678	1	1	8099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkRWBEx3GNrVyg9x1aGnkNnKvpx3pXpAPzoQswEmcn4XNEX7L
17640	payment	1726	1726	1874	1	1	7222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyucdtbmu4AsPCoiE98wNP8xtRWvjABg26xfwZ1jpS5oASpPMe
17641	payment	1726	1726	1874	1	1	7223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWiQz5LknQrrctw1hbHnN1NdouH87PvpJG51Q9EG3e3SQ1oN9
17660	payment	1397	1397	1678	1	1	8107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwJUeJucrWbntqQxLksTkmaYRknLixkmMmM3C79b1tkneua92
17661	payment	1726	1726	1874	1	1	7235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZ5JZJ9MJvESrArEE8MyBEKuRHzP7oWdWAKk8DDwSxQgo7GDH
17668	payment	1397	1397	1678	1	1	8111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1nHJxpCR6tpuUWoKmUtXiLoeTiMuRzDqbfAAButETkrGwhd7
17669	payment	1397	1397	1678	1	1	8112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9auT9p5v6mDvV5xVsCxFoKChaiL2FTSTxnrj5w8xuVQPGi1M
17670	payment	1726	1726	1874	1	1	7239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89usnShgyqC6ZVedVsmtSkH2R5nZnSYi1ERAkC89cK2D33EDP
17671	payment	1726	1726	1874	1	1	7240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrBrvz52RDSJAEG3CQtsQy8maR1R5o2AkaWubQ4XrHaA1ALyG
17681	payment	1397	1397	1678	1	1	8116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQUeMWiRWZqZCyp3TXC99HWaqN8wmvMrWisZSVn5ALunnNyfF
17682	payment	1397	1397	1678	1	1	8117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2duxVzTV4tMr3SsGgvfzQjGT6ZE3SvS2D5cLQQLnsqyth2z6s
17533	payment	1726	1726	1874	1	1	7144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmaKx4itAxgYMnCJbGxfSN9ksZRkmw3THiXgWQkf3P4W8LMD5
17534	payment	1726	1726	1874	1	1	7145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSAXoePjDot2Qk98JGcr1QMt44SeuL87tecbhE96avZaswZna
17535	payment	1726	1726	1874	1	1	7146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdgtUR2nWfmzAFAS9jetMBLQkohYF3yG3pMkWFKVucwJ5h8MR
17536	payment	1726	1726	1874	1	1	7147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSa5BiABa7J8B5AHcXaLdJuvPg8ZdkkzuAGzcGo5Sp9UxZ2VYb
17537	payment	1726	1726	1874	1	1	7148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjv9WJvViVUrwjceph5jG7TtcfNQypBs47M5jYrWcN1SYVLk4
17538	payment	1726	1726	1874	1	1	7149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6XADt6YsW8h1Ek2rZT2nYjqc6CotRwPuymTunub3VNy2S3hh
17539	payment	1726	1726	1874	1	1	7150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNB6saUHG6xMftaFvXqRj73ynCG3MysEdfh6E5sieYeUZYUaw
17540	payment	1726	1726	1874	1	1	7151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wURVUnF3m66K35WgVWtVyqPfPDNVjXRTwzsaBENurQQPcvTP
17574	payment	1397	1397	1678	1	1	8081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZ8BM1SvNxmbLW23gXCEDLpJ4MaLgJWBaUMHPsoXGg5RHueXR
17575	payment	1726	1726	1874	1	1	7176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9vACZT88kb47QuCA3QhtVDPXPhfWKm2kwmemdeRwtHSfkeGa
17576	payment	1726	1726	1874	1	1	7177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMQkeK9PrWNAvtNaJyrYpNyDfFx6ZRK5S8QDvQCA31ugGrype
17585	payment	1726	1726	1874	1	1	7183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYAmHEJH84t3aEbeQ5KUumyQ9hFZYKRF4W7BrgpFp4tMNvuqd
17586	payment	1726	1726	1874	1	1	7184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcuc5VE1zwVzz1vDcpxsvsW4cTsoXhjofEpYuQnZBXEa8uotU
17587	payment	1726	1726	1874	1	1	7185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd93kZrPp5f1kADB2d92icb6KvRjFc7Kgs6hhNqhPvH84oktFp
17618	payment	1726	1726	1874	1	1	7207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJDN4vvRGPXQQVUfYYjHahBPAcSD2Dnxkazh3BVCFJwY2BbdN
17619	payment	1726	1726	1874	1	1	7208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qSaW9joSBqHjw3FMqT75j9qQ9d65oCfnyDw4HtdwcFomG1a5
17620	payment	1726	1726	1874	1	1	7209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEbzZwbNBGAZdoNHWVCayfiMmHoTPBKzAxJ2BLbgwG3wNndtH
17621	payment	1726	1726	1874	1	1	7210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi85RUN1njmdEfD9a2np8wAH6unJFxChdhNrCSSkbedUhifnjm
17622	payment	1726	1726	1874	1	1	7211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGg59yPnAq1BUXWyz6QmVvDZdekKp9bJRjBDWRtq2fDhwJD92
17623	payment	1726	1726	1874	1	1	7212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtofm294jLnjFg4zmkaZgocikwmeNmwNEvLHwvqz1kkbaoQ55B
17624	payment	1397	1397	1678	1	1	8094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMZUvVisGzEsaV8aoiegu8zo592SoJ4atccHtd4JbZdifv2Kc
17625	payment	1397	1397	1678	1	1	8095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yneqjs4x8iPD9iKpeofKZ9SZhDDXR6YeRrqqpVPZsfDEUXWb
17626	payment	1726	1726	1874	1	1	7213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAdhbNA6VGm3gYNxsVW7Bv1Ew4fPGKc8N1iXgewZcCHQDXjoQ
17627	payment	1726	1726	1874	1	1	7214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxWyDib6BoDyLt2oqRnW2NtpJi4zChACaxueEM6dJqgAUKxR6
17628	payment	1726	1726	1874	1	1	7215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqDaZWSgK7MZCEEYYTZYsGZGTh9tUaT9QrozQKePbyiqnHjMa
17629	payment	1726	1726	1874	1	1	7216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR1YgQRsCMfVRhjrkexKbDzCVj4HJJStEwwDdhB4a4DFeg3ZL
17644	payment	1397	1397	1678	1	1	8101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqRmxaviYAuQL5ckC4PfDyzTThVGhYNR5c7vEbaSmXqzvy7Aj
17645	payment	1397	1397	1678	1	1	8102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEiNsbcMQKpB4LEvi1TC4wPZcvb5QQ7nuuMbpGDzxAHDw612k
17646	payment	1726	1726	1874	1	1	7225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePJgzDV8F5LZMxVoJ7u9YAAHnsT9Y7CPrDMXgTNMZgNAGJDhG
17647	payment	1726	1726	1874	1	1	7226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTWD8RLK8WQMH9UgpZQxpu3kTBNWKCDFEegAPpxi5kBL8Jir5
17648	payment	1726	1726	1874	1	1	7227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJvAgaEmWwDFuEdxgmsDLZEMUY1x5dZ4P2Qs6mUB9cy8jXuV7
17649	payment	1726	1726	1874	1	1	7228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtA2JtzQfh6JWkDCkm281oBWyUf5d3rB7DxVVukRW965kvHfz
17662	payment	1397	1397	1678	1	1	8108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxio6u1qGXq9jT2CYMhL3YHt7oA9uK9fuctzDLCv4BFh8ZKrW
17663	payment	1726	1726	1874	1	1	7236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3ssz2zVRCT9FAzEtTngnCo1PQJFybyvZ3QFZzP9DpF9fhgSU
17689	payment	1397	1397	1678	1	1	8119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAjuHBsDvsqDtF7NQzP6WtgsNnA1k1wVPdi1656aPYGPQx9Jz
17690	payment	1397	1397	1678	1	1	8120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkEwFbq6nX2SBbXgyNfxdBf315X2C1j2rGhTi7rmcFkomxmAB
17691	payment	1726	1726	1874	1	1	7252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7341REZKf6D2pcA89hJw8PUVBwokuVeAX5h4qUWaJbg1FQQm9
17692	payment	1726	1726	1874	1	1	7253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDv8yAa2sddEZJLou6MxAT7auxGYTEPDHZfUMjeEgZNDULpLCD
17581	payment	1726	1726	1874	1	1	7180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuhwpPjGipAS2hSgs2HBF2G8C4XnWPKurp2qicChv9tHP9QMz
17582	payment	1726	1726	1874	1	1	7181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVoPqB7GPe84pXoUAr6XTRpc5wSJQuR5ymzXhg1UCdEvWHerUr
17583	payment	1726	1726	1874	1	1	7182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNXdrjAmkWTBRJa5f8Lt2t1XcCxHyKJkfKGQsW7DPkxcB2FLy
17584	payment	1397	1397	1678	1	1	8084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18GRc2SMY4wdUZBqSypVg9gHPkAPsB1Hf7rtwzK7W75UEtcHG
17612	payment	1397	1397	1678	1	1	8091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFppzCah8SRansUaKCmv8tNvzoRfkXEvRj4tqL6MJ7nKafUhMw
17613	payment	1397	1397	1678	1	1	8092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUy7EzET9xxmatVRCoaSTcGban1LztcpYicSKHuubNkGeRWnb1
17614	payment	1726	1726	1874	1	1	7204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfDeEjBZo1VzMwT5FvUAwxUgm4xvRb8EiSsZMfaDnREZXYBAn
17615	payment	1726	1726	1874	1	1	7205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrNTU29WHK5LkvmDmJXXKwmQBfhaViEsBmFGBe8Bv9BxReTJU
17616	payment	1726	1726	1874	1	1	7206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7wogWXNXrJ4sSRY9yB3oZAvtq5nijtN3B2JeLCcKNJ4y2hcek
17631	payment	1397	1397	1678	1	1	8096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwizokshE9uKf5TqRyTu8jZPUAoK4oiParBuZUdWGjQ7UQqwd5
17632	payment	1726	1726	1874	1	1	7217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYyZwBH2rFCqz9yUBqz5UqcFoDC1skMi8CRCqYDpT8VQqrgtf
17633	payment	1397	1397	1678	1	1	8097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYataurGsMMMuxuTdnXUKVQh7i23P8X2P4kc2AMEJBy8D2TBdu3
17634	payment	1397	1397	1678	1	1	8098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMd1LzY27S9d6Y899F5WUPXgfyjtgoHbn24AdbiErZDJQYvwFs
17635	payment	1726	1726	1874	1	1	7218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuo3jqBQSTQFc4BAV3EAQLGABt6eLBwaZtRzKkb3rVxHwgkmpn
17636	payment	1726	1726	1874	1	1	7219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKzUHzoyQBWtaVRvYCaSeBa7d7rjhfFiHsX91eXj7MG5ipWHe
17637	payment	1726	1726	1874	1	1	7220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVf2YrTiKtjgXh1VKy2Dq3mf1oGNxKYeu7oxuCzkGVnJ7xR1i
17638	payment	1726	1726	1874	1	1	7221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKh2ZNKzwL7LJXL5wYk3xDqef1yvemoTQx65vEK735tGsdGUxj
17642	payment	1397	1397	1678	1	1	8100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdahZvRfUH458ZEUtjb3XdEHQnC2BivV8KAuV8YCaxgATDHi2W
17643	payment	1726	1726	1874	1	1	7224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Je2W8XjfKxvq8wuKKYDSyKXTLeKArc2FxP82Df2VaopLd7CA
17656	payment	1397	1397	1678	1	1	8105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwdXXcm7Ga67mVjWKbZoC6v9WXvxAQMDWczSRiyoMYLfqXbxW
17657	payment	1726	1726	1874	1	1	7233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1SVCDDk2DGk5Q6uWJgUKGvetXa1wdZvU7pCZEd3LJg6isQAq
17672	payment	1397	1397	1678	1	1	8113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheVg3sHWkLfPzCzmNuNLi4jzGPk8DsWtoVeKqNX44hHg7NTFD
17673	payment	1397	1397	1678	1	1	8114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYfddfkz41raCU7qyz5uRYyHNC57wfRMEpc9iihg4GhBLaEJ1
17674	payment	1726	1726	1874	1	1	7241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAowfb2uBpvaKheuvZqznm9fSxF3i9RRRHm5EFWit8imFP1Pj
17675	payment	1726	1726	1874	1	1	7242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqaU4FCTn9xQkJp3NSpEyosGLLSHNthqaXuqruJLmd9u6cKuX
17676	payment	1726	1726	1874	1	1	7243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5vB5JMuQ9mHaq4BqbkQBb9s8bgoTFiy73r5XCkB2DYBdbhG7
17677	payment	1726	1726	1874	1	1	7244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNGYjX6CZU1BZDosoHVniFi2GjxhSKykWmcQpZTNwa6ACb6Za
17687	payment	1397	1397	1678	1	1	8118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKPPZyTLS9VadNUMbGYoESRNmxPvPoW5shsWRvDknxWBnsQAS
17688	payment	1726	1726	1874	1	1	7251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTeLKNdcH5c1YLQDmhJzV4yThmY78HLYD3qW6ZJ4CVaXGr9wS
17705	payment	647	647	2113	1	1	0	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr9bL68qtdAMJ6dnJWpPhjAnUfsGfyiCLXBeCgmfXs71g1aRF
17706	payment	1397	1397	1678	1	1	8125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zWiRyhjs7k85qUhg7Dj2d76PUrH1x7wBr1EqjtAEMPGp3SYw
17707	payment	1397	1397	1678	1	1	8126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdymfaZCFAUrS1g7GLHgZYYPV8tc5qti4XPmTUuj72RHHN3pwf
17708	payment	1397	1397	1678	1	1	8127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnY7aZk2N9eD3kRZEFD3YNpyQYAnFSL59KcVuEaoYXom58k5y
17709	payment	1726	1726	1874	1	1	7262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyctN14gaEJvRCf92L1QXZ4M8mbLQCUceVwhMUFNxP3KkSYtN
17710	payment	1726	1726	1874	1	1	7263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmJm3PkMdHumKaBJpUoLWAbGtNWZuNmmnmWR6dfUoCHcAxnGo
17711	payment	1726	1726	1874	1	1	7264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcvTEfgCrSPi9LbUP4fhNhXCaqMoqRXNtPjHrGJoE2K13ZpRH
17712	payment	1726	1726	1874	1	1	7265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWabZxwtjMf1noPiPs8ZFxZxantb2q7dp4Z4sYrCJa4EcZDSF
17713	payment	1726	1726	1874	1	1	7266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2sBoyeqrinyZGr8Z4r84whK3NpayVcbChx41e2wtgJwFGXWm
17601	payment	1726	1726	1874	1	1	7195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67VKy93ijiiQs8L9sBwJERvqYps4j7bm2uEAbNMa2FzrduURz
17602	payment	1726	1726	1874	1	1	7196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhY338HC1VdrEAe9QNbJdMFYsJWxtNqFggxgUc8wddFfGCAGh
17603	payment	1726	1726	1874	1	1	7197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FQECGPxybA5PLBLBqXLw7pLJRs9JKrNato9PywXDtm31reDj
17630	payment	1726	1726	1874	1	1	7213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6u7RZziiWKyFbw4JhrKoNbJzF9YXtqiQvAzXBGRirtpaCuiq8
17650	payment	1397	1397	1678	1	1	8103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5syVYcjfErHN62Q7mvhm9DGxwfEX3F45zXaFW77kYWoiAt1d
17651	payment	1397	1397	1678	1	1	8104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LofS3KgVhotYYC2X72u3FZmcMMJF85SJodneaBQBr9aBtigG
17652	payment	1726	1726	1874	1	1	7229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxzTEXLiyiiipxCX2JJPAb1ahfcKHX7pGEUmXUDBtLEzdLcJo
17653	payment	1726	1726	1874	1	1	7230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkhrdsB5quZade6k6aaFq9WqDiPJ88xVRM8Y7NWFuafyrAXoN
17654	payment	1726	1726	1874	1	1	7231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpLuhZWpR2ypca77QtvWAdSnuoZY7jkEWUJadRQuDpGpi28Zp
17655	payment	1726	1726	1874	1	1	7232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uh15GAzcsD9wTkd2YKTDNmQG3BfVVxgv1msjZwASiPj5QLHK
17658	payment	1397	1397	1678	1	1	8106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKr1bnNkcLcWaLAHGhkFpNvFM6E4r8JMZPxPmXv4597eoVQWHP
17659	payment	1726	1726	1874	1	1	7234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmonWC5k1UVohwY59URjEmAL13NBhtMUXsekxoENASw1BYsCH
17664	payment	1397	1397	1678	1	1	8109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdYN5UCvvpvR6hD8ho7wqRJMCjwPAuofbZN1fuwpFjfz4NEY6
17665	payment	1397	1397	1678	1	1	8110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm14uXuLfVr64NUoEutVuLBjZhNAmzdW3F9ShSLbVGAtKxCGS6
17666	payment	1726	1726	1874	1	1	7237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3csX3d4URfoQbGMjbT5jU8stNwuNwArzuVRWxbW4Ls9y8vA8V
17667	payment	1726	1726	1874	1	1	7238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbycV5uLPbpQGnwbhUPcTimXZESVBT7TetwNz5kUJSrdRwA4pp
17678	payment	1397	1397	1678	1	1	8115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4X7ZaYTU2wuk5QRrFnQxYuFHmUDdxYtdjwFxLEGupCdmZc4iu
17679	payment	1726	1726	1874	1	1	7245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY255rVAP4zCmC6ybUzAb4iHn2gZWuejasKt1HCPc33Ya8tY73
17680	payment	1726	1726	1874	1	1	7246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHSWqXVpTDBECXRRFb2nsRFYkVcvZkuWinLjLdwTDqtTEiqim
17728	payment	1397	1397	1678	1	1	8133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm5SGYVDUbgK6atG5dkn6ojHgMuaSYoQmMSvetPY71dgkbiwe
17729	payment	1397	1397	1678	1	1	8134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8YPJETULe2UGDyfwxzYq99K1B8bbr3wssrm1xfB6Hf73C8in
17730	delegation	2113	2113	1560	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9ZnhJGdZXNn51Tzxp9nTkW48cbRVaZ8VtYYdkvFDcMnJnSce
17731	payment	1726	1726	1874	1	1	7275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFADayoXZSsHwXtZtVQGG1HNayGfAetMqksLiFDRu1RbUtx5n
17732	payment	1726	1726	1874	1	1	7276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gBByiFZPpcFnf2ae6vD8nwTEuf7nDubw2rSonL3K5faNje1E
17739	payment	1397	1397	1678	1	1	8138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUxit3SwwVDLfGy4JPohfzeuxm98pompM5AMdQ3YRperbCeYc
17740	payment	1726	1726	1874	1	1	7280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVYY4AiBdbFqXbr4F9HLppxqxS7MCFFZic1ZtUob5vosj5EFC
17747	payment	1726	1726	1874	1	1	7285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1QxU7JQPe32L8zhpqUTX4SeJs54jdpkvMe8Q2cupTrayeWzQ
17751	payment	1397	1397	1678	1	1	8141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjo6B4Q9Rar8FcC759keDkcAqT1c2T4bjwUPEo3QJtVR7G9p1c
17752	payment	1726	1726	1874	1	1	7289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWxFkhtf2ifSm71PbSjkvGBoTpXfn7x7dNjRydkGstQZxBs87
17753	payment	1726	1726	1874	1	1	7290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2cpULNqzZ4RoEU7z14NdQbat5vVxDoYQMrCfdbDffeXeJcpe
17754	payment	1397	1397	1678	1	1	8142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkwDcjnuUK8FtmviW2fJxRzampELUgaYpL7nNKQrU5zuLx7vJ
17755	payment	1726	1726	1874	1	1	7291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDkKKKopKEDguKVgG3gemTTKAiobbCKmsBDifxrHbn776RHTa
17756	payment	1726	1726	1874	1	1	7292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN6c54NZZ7JciSRTQ9Wkca4YnNcRfcicd4Ayw4v4kU28fnCRC
17763	payment	1397	1397	1678	1	1	8145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuAnxyJGb2Kp16ZmqnpEHp294ssb5rACUiSNXCGCuurKTMUf4
17764	payment	1726	1726	1874	1	1	7297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TYn2vqJCCVe5HqAenLe2Cb24ptP1R6BTpYVqhSjzd1Dvivnt
17765	payment	1726	1726	1874	1	1	7298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPWEw6ESkbUdRKNY7nNfKog42RJs3fukH2HwqyxWvv8k7EzZR
17766	payment	1397	1397	1678	1	1	8146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYNnUJqnVLaRgK4c67my58GjRvfDiQ7w4xTkZrz96JvEwyKuA
17767	payment	1726	1726	1874	1	1	7299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78RQ4m8Qt7L9LtpyU6cDzVnc4WCXRUWnF5xHAUDeYWgJX8vDg
17683	payment	1726	1726	1874	1	1	7247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3kmUiLAMx2AySiJLNsT2frGEiabeb6QmaB9xa8vRmRbQut8e
17684	payment	1726	1726	1874	1	1	7248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBv8v2U8tRCjaTLuTBBp5xZ1FhusJ3UvyWdWBYh92adZ2gKwY
17685	payment	1726	1726	1874	1	1	7249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSYxhVcSDHdca32c9zUh9qs3rCVL5FSBzQaXfKqsif2uSfGrk
17686	payment	1726	1726	1874	1	1	7250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZid6xdQTm3sh2PbnxFzz8Ki7tegjdsVqgKHScQ6ukPFH5746Z2
17693	payment	1397	1397	1678	1	1	8121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mrjAMPFahHLTAA4HCrbA9hT8gpctTjzjJRyAXvVWxzPS6nJM
17694	payment	1397	1397	1678	1	1	8122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE3DJVGL9d94WkDQ9xx6UTKtFbz2tKS695dCoUFNvLAwgmPPn
17695	payment	1397	1397	1678	1	1	8123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW6iUaw7eSi9dZQuhbbDrvXNQeuvocKqMmUH1mEvfN5egHSoo9
17696	payment	1397	1397	1678	1	1	8124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHY5CZiYHoZ4P86LE6tVSU5hWAvgv1Fhk3hhf66D1BrR6pGpJ
17697	payment	1726	1726	1874	1	1	7254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDLs6Sa4Ki9cDfZZFqVEZhxhSVZpjJaY4sXQSKvq5G5Yv1jwM
17698	payment	1726	1726	1874	1	1	7255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBrRTLdcznBqbKUeAqrZJ3b8PLPLa8kCGjuaAqTcNRsLK3STG
17699	payment	1726	1726	1874	1	1	7256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEv32H46WG79XSVmtWkSc5f6VCYghR3B7qhqZGZYZxLgFABxm
17700	payment	1726	1726	1874	1	1	7257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UDpnB1CT7YRNwfLdGwFbuL4A2zFVQiGQqGzkbkELjy8a7cnG
17701	payment	1726	1726	1874	1	1	7258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFEkqJx6fn3ZDCcHhvkCEiXpfEk6mnbdvtTFxF9r6QDWBZyvi
17702	payment	1726	1726	1874	1	1	7259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8282Gk39LUg26C33npbrEv7dLcLG23YE6xFHLv9m5n9EqRE9R
17703	payment	1726	1726	1874	1	1	7260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRTyagbk9DYjtMSVh18m56GSmUV8QYHVarBd67q1CHY33uaLf
17704	payment	1726	1726	1874	1	1	7261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8QVvb3wpRzSa1XcGuuL2RUqeokJ3AmkJrHziQryFvzaUGBk7
17718	payment	1397	1397	1678	1	1	8129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbaj4nESVjUmM3BfxCEggYyhJyVxAn7n6fSYrMdaCvz7HjozMr
17719	payment	647	647	2113	1	1	1	234983938283	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8hwkS4pLAwEaTDDiUy2bzz8HWCrQnhmt9Km8TY3PSHLQJJuk
17720	payment	1726	1726	1874	1	1	7270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RJuD1iepkCvxzcLhZPR6oeMhLajsh8VThR2hq8Yci5EerXBk
17726	payment	1397	1397	1678	1	1	8132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNQKrwKVTQfR6cH9MvWkdMdmQP3nfgBfgg82AFeXbTAgooQap
17727	payment	1726	1726	1874	1	1	7274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgShtXiGHa439mEW2VA3puXt5mnfDiigHypUBTHnj1PAbD6MeU
17733	payment	1397	1397	1678	1	1	8135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxP7Ke11DAkgBVmZhkUYWSsjzmiMjKUNbd5JaV5nx24PcLHy9b
17734	payment	1397	1397	1678	1	1	8136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuh7snFApXvSZwHJzQhBXdkPeaSNRHSR5wkSdbEFwwpp3EzNMG
17735	payment	1397	1397	1678	1	1	8137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7Rzk8iBpo9hKNN2uczCYDwXaMeXQtuVyY4mK7bZ5NrKiWJhw
17736	payment	1726	1726	1874	1	1	7277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jZ6CAJaqF2Kr8Cw5Q6PXrQrCj6maou8bXErGvW9N9dYr2pRE
17737	payment	1726	1726	1874	1	1	7278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgS8fFn4Qhj2816UPCJeZL6aBiDsC77FAfbbUYkAu5wJbuPwr1
17738	payment	1726	1726	1874	1	1	7279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFSdGrNEmv7geiY7v7Yj8Gee1Jbo7kUpyZLZvrNULmZGGepAj
17743	payment	1397	1397	1678	1	1	8140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeuDhuwaAdmxJSQLi981n2Y5kMozQbVEmmcCedP2WLhpw2anCY
17744	payment	1726	1726	1874	1	1	7282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySAWzY6ewZGHsyPXSc3hLLoi2CdUTyDXXCfo5AVHHKTzHp5E1
17745	payment	1726	1726	1874	1	1	7283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGUcGxHbfyMSykBMiqeD9V74NUXPGDTPJpvPz7RQJu6SSZeEA
17757	payment	1397	1397	1678	1	1	8143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuzDpqz8ugANqaRa86FeXA7ixvthdvSaTZyN3iiPHRdbCzkYT
17758	payment	1726	1726	1874	1	1	7293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ9ipZuAAcDDAnfqhrZqUAqzm3rpb8uxXKBSW4E767TnzAnodw
17759	payment	1726	1726	1874	1	1	7294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymJNiddUEeLSYD7Ra5ZPRASH9ePHYJW7iQxGyw5qiLBqgAaiD
17772	payment	1397	1397	1678	1	1	8148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P6sA225FedrBYEbrVyXJ6gk4tAeDUjuDMSu1txEVd7RFuvWk
17773	payment	1726	1726	1874	1	1	7303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu27erMPPYtEejocSRj8FXJ3XtJbT4JVGQv2fwKa128zxoqXx8
17774	payment	1726	1726	1874	1	1	7304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hNVyEQTujSh9iA4gWsP75sQXSfQU9UoM5Us2bz3nx4HMTcna
17778	payment	1397	1397	1678	1	1	8150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbtY9yeA9WDhCJ8ArML4RCJ4ULieboAqCLqPPzpmUyAN9tYgc
17779	payment	1726	1726	1874	1	1	7307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfrHEbxgaNc9GMP7Cs3iu1RmtkTMaHbZcD9w9yRFREECtvst7
17714	payment	1726	1726	1874	1	1	7267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpGoyYn8k39mpeS5u3hb1Gs5SEkjCD7DbJMHFA7ycrmAoev1J
17721	payment	1397	1397	1678	1	1	8130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDesQN1eRJpDwSjPUfGdjFaAdHawrgnk4JMdXDJoJYKnPfPq4D
17722	payment	1726	1726	1874	1	1	7271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGJV5nkuXFbsjojs92vUg4q3A9Rp7hBv3uQgQCai9ZCPxmVL9
17723	payment	1726	1726	1874	1	1	7272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQXEhWAYPQRxWZTN2Yp8uaKEPyLeHhhYKyi8ubGWY9CSJULjE
17724	payment	1397	1397	1678	1	1	8131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdaymyCG9fUbuRXB98PKKRREYath7U5Kneb6bF1JbrAmnG33n
17725	payment	1726	1726	1874	1	1	7273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsWLFZryWn1UPqvFhptu5Q7RTF1rtyZXyMkVnmYoR7ft1Kit4
17741	payment	1397	1397	1678	1	1	8139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiqxfQAQAeE51tVwJ8NYWydbJLjSFptd83Y5mityXwQhzLcfU
17742	payment	1726	1726	1874	1	1	7281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEpn5Rxriqe2KKYwFXkMigNQ9weTovj56YSCxjBciFL1Y6KxB
17746	payment	1726	1726	1874	1	1	7284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqdpTudY6ovfsFeuB6GusKcsqEiM4VRKkRL2uopZtVbBp4dNe
17775	payment	1397	1397	1678	1	1	8149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRHAbjdTWHK7fkb93oYdMqyXrepbadyv7TyDQ3qS85Dc76Xpr
17776	payment	1726	1726	1874	1	1	7305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZc1S85WoAzZjQpCPVzVibFjiwUTDszP6RQC88PY9mrRZ7Kr3
17777	payment	1726	1726	1874	1	1	7306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5Mutj2jrW6XZyPRfLd3CnFXinQ7Pw9Uo2R2n2aFWG7QeX4qf
17809	payment	1397	1397	1678	1	1	8161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCRstZSXC4Ui9BdDMtRnbSssvedhZ9njBnmuuBPz9hptESniT
17810	payment	1726	1726	1874	1	1	7327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnzLLa8rKoZcP3oyCm2ubK3ktGGt9qT1wjbMmiGhj2RKwhWNU
17811	payment	1726	1726	1874	1	1	7328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXR2vfoUpEpx7aKkCf2Rda33ZqDgYMSC7k7d2itSscTRXNv6z
17818	payment	1397	1397	1678	1	1	8164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yagEjGvqBhaGAXGCTFXTEFFDC14i3vP2Z5PxLqZFTs5k8zHa
17819	payment	1397	1397	1678	1	1	8165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6ymexroiPwvGiRHZSXQP5cKgxg8Q6s8t3weQpPzDuszYNBR
17820	payment	1726	1726	1874	1	1	7333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPaWGm2uqrmb4MY79119SwkLrrXM5wNGNTVzcU5Qpx9va942u
17821	payment	1726	1726	1874	1	1	7334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58EXwK83at9VULx3bJVTdwoc3ntk2WAbs9MzorNmCUYu1MJSo
17822	payment	1726	1726	1874	1	1	7335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wa59tbBidGew939kNL1bPkmwmimFZRaHLKhviACh4dWKyWdv
17823	payment	1726	1726	1874	1	1	7336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3qp9FWiqsk52r3JMnPNBVdgJjpdFhXbg2abKGLU9vjiTxxvC
17830	payment	1397	1397	1678	1	1	8168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt3v8yu1GL1oDRKGnihqYkPxF9Xw8BfPjFWeLqDDjSWTpWWdL
17831	payment	1397	1397	1678	1	1	8169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdi1HqVctT24R4VGvBpF8t9KaovVbrDfeDVpfd9TsbnkH8zbp
17832	payment	1397	1397	1678	1	1	8170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFs6qrohV885YPuGqSW2VaN6iMXZqWmCiYuh6HQL811Lok2AS
17833	payment	1726	1726	1874	1	1	7341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmpecx2mWmdgs7GELBQqd7c95gTrq7sgvJpNNLsZ8PSKDiXoW
17834	payment	1726	1726	1874	1	1	7342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBCpp3F5FoxpJHBouEJyesuWkijr5ozBxW1cnoTBC2EPPSGjL
17835	payment	1726	1726	1874	1	1	7343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtq4EFq74vVR8MWKeWfTYAgU77rMBAy5LU2PXhnnvz1gwhanGb
17836	payment	1726	1726	1874	1	1	7344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTwyz5ypxbNEvUGwRmNAeMq5fMyxUW5Tnz7M1NThc1y7UXobP
17837	payment	1726	1726	1874	1	1	7345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtANorNFuVxaqC1TPGvXshQ9bM7n9LPUFvqtfr5V9cEYRWS1dK
17838	payment	1726	1726	1874	1	1	7346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BF8H4RCtVUpYHrheBNLWBmTzf4rc64h2HVewfs9rRmYd6KEC
17861	payment	1397	1397	1678	1	1	8175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZ48TwPCi66Ua8VgprmLnjh7zqMzv2YujLijQWf2tkoGq9Yxu
17862	payment	1726	1726	1874	1	1	7365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZbbKpEMjJ5vmuVDH6i2J5DdfdB46v98LEu5KQ4h3ANCfBKrP
17863	payment	1726	1726	1874	1	1	7366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTyKRVKJ3hKadxo8azKuDe478uamKCuzEMG6h4sYHFAQUvu1c
17873	payment	1397	1397	1678	1	1	8179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyutjA7f7XRHrFuFiftMcbtciMkBhv8sDJrmvW3GkztCzt4Q4
17874	payment	1726	1726	1874	1	1	7373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsE1Rk1iBSwHtJm5b9uUQoqaFPPoG51DyEm5eFBddXDth4HrX
17875	payment	1726	1726	1874	1	1	7374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4i5RVLxPypatgmAx972HAdGjBaPXKC7sg9N5QjjDXpjyd44P
17879	payment	1397	1397	1678	1	1	8181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJMg1WVmaRSY2MCnD56jK2sRAYKwCNLKzi9N1ReVnGmBcne5R
17880	payment	1397	1397	1678	1	1	8182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYws9mwaYGPj5rjvVRT1j53MLCdA1GbxVQdaiVJJRw9yDqvBSqu
17715	payment	1397	1397	1678	1	1	8128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC23siQhSyBcattYLsKdBcj2Wdx4RvzXijqU4UQcDFTwWhQEon
17716	payment	1726	1726	1874	1	1	7268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EDLqgvMR1JfGanUa1vdRQxJic7fAgAuBLMaYa6ozYbsQVeqF
17717	payment	1726	1726	1874	1	1	7269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqFS4GF2UwgDWXkLRPusU2m6mpZDgAYrQTrVTNArVRCXmAzVd
17748	payment	1726	1726	1874	1	1	7286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1LrFEYqLVzPyG8a4MwwJghHjnSJUPDUh1hiahqM9zqY5apvj
17749	payment	1726	1726	1874	1	1	7287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvJP9gK2ZxFFDybzvi6iMARaWSc9cya7wJkr1WBAw5BJHPjeY
17750	payment	1726	1726	1874	1	1	7288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcgEdrtrrL8sLeRe8zBeqPQiMHZubarhLrJEQr6P8npmgLki4
17760	payment	1397	1397	1678	1	1	8144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4ZrYCm5ThFygQWx4ajRWwG8R29nHirTNHM1ku6kHFUNS3PBM
17761	payment	1726	1726	1874	1	1	7295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbchExEH3mHZ8YNubkaoXpndmSiq9zw9Gx22gapxoyKA7Hbg7Z
17762	payment	1726	1726	1874	1	1	7296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPLJGLdkirfjscob7gZcqqcvdafpYyj3yXg4itrYUt2gGMR5p
17769	payment	1397	1397	1678	1	1	8147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hGRUtgyL68raJBne4xpuyAFs5ckNJQ72TVxZdD7wg2zYodDP
17770	payment	1726	1726	1874	1	1	7301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4kqohvypf6ZHBb9xgx9y2mGTSycU28Aa9QwuJZp81DttGvni
17771	payment	1726	1726	1874	1	1	7302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbXToisygYJuokNXg1tazArjZmGLghihfiKHJJD4eqT9sT34q
17792	payment	1397	1397	1678	1	1	8155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq12bvs4aTcY5P8kYrCycNjmNPkndE98HCNzXjZEhUTeLWebP
17793	payment	1726	1726	1874	1	1	7316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDT8JDQkYSLm7rKpFfia1jq8bQ76NjmLLm3gZKXFFDpTgpVNa
17864	payment	1397	1397	1678	1	1	8176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekZCEYWAaEryXvEosdDEWJ2y2WtkFyMaWqPeczoYfJDeQUW7s
17865	payment	1726	1726	1874	1	1	7367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFk75ADBk3jmhQMGFfguKRwLCUuiwUVRXguyRkPNa4J6F3mJo
17866	payment	1726	1726	1874	1	1	7368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBfiQuY2uZQj2GKoY9Np7WoYtSF36V4F9GJdJpucQ4XXao3Zr
17887	payment	1693	1693	251	1	1	668	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYxNPriz49ZnnBbbrWhBZzbvncXnXaekchK9Y8V6xHjKDkCaZkj
17888	payment	1397	1397	1678	1	1	8184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Gq2PkEJ1VpcMp7FCRGREVuYqkndagBHCcxEyL14mgy5T8JFe
17889	payment	1693	1693	35	1	1	669	33788775438	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaB3hNTqx4kYVc4J7yuDDGbScYChy8cWZQCRYGm1pjcs9fhdtDW
17890	payment	1693	1693	49	1	1	670	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYTwBxxnb8pYgonAMoranLTkWBL6eG6ev1hwMa6RG5RRXfeTj2N
17891	payment	1693	1693	1030	1	1	671	1585516072700	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZdmqt8CjWT4ETn7nffBMQHor6UvwFPWFSeuT4YGupaLfRW6841
17892	payment	1726	1726	1874	1	1	7382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWf569fmPg9MzvGsPShah9sp3FWRwsn99BSVeTXJNoFvFr6qy
17925	payment	1693	1693	163	1	1	696	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZn1YCt52EsmCYFfeK5KBJ3mqzdJaKXtz9yV1PxbRtRFsEBKHRx
17926	payment	1693	1693	275	1	1	697	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZAFJ7pURoAshj3cnPu9nyzNFfdLCj47AWUTySpmNaczRkvJb9n
17927	payment	1693	1693	201	1	1	698	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZLDMgyajvy2ANoVc2ZEYYgNo4L71saxmqcA1p9moMbdAkbQsP6
17928	payment	1397	1397	1678	1	1	8189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUzaMVZ55mmfJJTPTd3xpPNobyLs9ABx4Z2iS42h7H2BfeTj5
17929	payment	1693	1693	1962	1	1	699	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaE823yXFBR3rHMVKzC2nygxJtamS3YFfk9sgJZXeGzn53s4D1g
17930	payment	1693	1693	309	1	1	700	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZvXHNSDk6yFko1AyGiYhFFV3EsCK46wjnyoTvURhk8hozkDkFu
17931	payment	1693	1693	82	1	1	701	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZoEGvvtVzvapjhp4ti6XVXKi8npSdBtauUJwnxzbxUjxde1W9V
17932	payment	1726	1726	1874	1	1	7387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fxzHjTYGMc2wZRBQGJAQ2jz3d5ERwDuSBZ7Fz8rDhup5SkiX
18014	payment	1397	1397	1678	1	1	8200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9jk5YZ3JSSzxQM8mLH5bN7sHdTPQ9iAQXJ6b5QiuSQ1qRHjg
18015	payment	1693	1693	304	1	1	762	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZSYiHnvrLyobjZ8SxRU5R8LrFxjwp5VdZeXn1vD6KmE2kgRFhR
18016	payment	1693	1693	399	1	1	763	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYm2t3Zx6GgKdpQBw2aQn8M4oBQtinNrXYYnUEvXhXtvKoUfWLd
18017	payment	1693	1693	611	1	1	764	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa2fDsnZG11bzF5HazbQwguQw4tkJeG5U1b46qRRLZeBYcypwh8
18018	payment	1693	1693	206	1	1	765	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZP3N63XMDyqKAKzKcgjZk66zjB69CXhr7FnsQi1MEFWyWzNHYT
18019	payment	1693	1693	622	1	1	766	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZjJjASiM5nmMVHWQnAyAXrW9YpHZ9nHQdFU6Q6Vxo2gyptdEH1
18020	payment	1726	1726	1874	1	1	7398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLHXVVwBJpr69KaatgbKnjE5UjURfZ7mttrxZ26qaVCxzCdXs
17768	payment	1726	1726	1874	1	1	7300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMa51i7pmuk4C9ucLe5UCzJwE5Kbz3YvP7Xqewa6Ty1bqrs4N
17781	payment	1397	1397	1678	1	1	8151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZMiwTWoZvsJEB6Ej9qERzuX1jDMLRQPUZkKWzEY1ugpgLsMt
17782	payment	1397	1397	1678	1	1	8152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bbyiNzB2E7JoFJqcbkvmay9NXwGf5oqsvveaj4zx71Pn3B4F
17783	payment	1397	1397	1678	1	1	8153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2ZiU86wn4o8KchWwUDJyvDRnVF1c9VSpbL4DagpwLGKv6mDH
17784	payment	1397	1397	1678	1	1	8154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoFBAXvaVSzzVy42UYvMj42fyQWueovdvNmrKxF6azk8gVbae
17785	payment	1726	1726	1874	1	1	7309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7i4FEGjMM2Dr3B2USamn8YXMeLoX1u9UXQYKFAgZCNS9Nfgi
17786	payment	1726	1726	1874	1	1	7310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNpLke5Ry4YjFgCgNzHzD8Z8mc2T5vy1CGacMY4iKmBQXwEEp
17787	payment	1726	1726	1874	1	1	7311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDA4QqAMUYf4f3kQk1jGnoZPGAazdnCsruiXMNjviKZqtJPBxu
17788	payment	1726	1726	1874	1	1	7312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyK91SZA15vPbsEiz6t7NZ7Uye9DBaQuQJUcUHNnvX3MYQL1Af
17789	payment	1726	1726	1874	1	1	7313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFe9Kh5CnZhS8whXBKkAVKadcZBJJze7tbYzK5hM2PMyrHFyg
17790	payment	1726	1726	1874	1	1	7314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzQXFzp51FxSKpcSBG5h33XkgG1CEs19HUf3MkK1n5pvhVpnk
17791	payment	1726	1726	1874	1	1	7315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtffNe4QQCzAD1wfNm8HuHdHyNGA1Y8GB9pzSxbPKgWgcQ5P7Z
17797	payment	1397	1397	1678	1	1	8157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW83KPKaPiQPFUhRXCq5UFz11Gfh77EfKV675VRDhrk1mgr8FY
17798	payment	1726	1726	1874	1	1	7319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPf8px9EchVrCHLNHTvnesp3Pr5n1fbp58K6ZotdPNxxNFgfp
17799	payment	1726	1726	1874	1	1	7320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwa1Wq5bLAEb9hVRrpq4CZyVcXiLRuSTx91NrZj7LeB43aAx7
17812	payment	1397	1397	1678	1	1	8162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKY7FRkLDub527pv1KeB2npMW6rBJQtktyi9q4fp3VMBLMSaAZ
17813	payment	1726	1726	1874	1	1	7329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MKDYH4YjnAJaN1bMYtaMZtHAkocqD2J2fM73XYggsEo6LCQ7
17814	payment	1726	1726	1874	1	1	7330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34k5qR7nCQeR3CYBntevE8DgNyWmgwsXE8CCuoE1XNeqfddVz
17824	payment	1397	1397	1678	1	1	8166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5snDxm8ZjPRhG6ovoWA26opkmCAUJXVRTP4pb3wyP64zTety
17825	payment	1726	1726	1874	1	1	7337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeH71gwC2j7S9uNubGqtdZD6eQoYG4Ly3GVvHwMGEG2F9DKSe
17826	payment	1726	1726	1874	1	1	7338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgwf3vE2UPCX5ewTVpq1VDHipWSK8x3U5s8AViX2YSVj5Ft2x
17839	payment	1397	1397	1678	1	1	8171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcvFJGmGz8KajEpRYUSNZj4iZaCRaMUouLdXXrhLEaTrjEmD3W
17840	payment	1397	1397	1678	1	1	8172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8GtcjY2zzM8GyVnx1CgCGciJQVSZYHGRzeLAHa7kbu2dwNV2
17841	payment	1726	1726	1874	1	1	7347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuhu4evww1xNe915E5VXKp344BAPAvG77EVVmUkNQdwEP3JyvL
17842	payment	1726	1726	1874	1	1	7348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdM2qTcyrdfjpi4brwobiGvsdbjR5M2ewpTQSCwHoXrF6eoGJv
17843	payment	1726	1726	1874	1	1	7349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcZApKTcBxKp1xXP8et6phkgZfu7aZDu1SSTj34KVQCSNQoUr
17844	payment	1726	1726	1874	1	1	7350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzB6TVU4JsKj9nqUSCKA3KD8dGZ6euHgi3HwQjLgEPdRSnwGEB
17849	payment	1397	1397	1678	1	1	8173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDEqSCD7An5AhmH14gJpV8Kka6nppLBhWfm5a1iHFL19sssGZ
17850	payment	1397	1397	1678	1	1	8174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TC8e1AxBrtsLpJGZ1wSnsELGGoKxw7m5QtJD1o4h8ZpkFZgt
17851	payment	1726	1726	1874	1	1	7355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLwqz9J2ZFSA7ouy16jRBfPyA1CwyQPW6nmQ7YUZueXRwTVw2
17852	payment	1726	1726	1874	1	1	7356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBSktiVTQzbrppFjoy8Dg642P8C6KZYqbW5qEWo7a1UPyL3e4
17853	payment	1726	1726	1874	1	1	7357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZni1y8ao9GKseo6eEFAPFLXbjv6dh5dy6Jq6xe9CyysCx15HbS
17854	payment	1726	1726	1874	1	1	7358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqGtprqNXHpsFefBdgDA6osiwJz5LqmAk3C9ggVTGvD8yhW9K
17855	payment	1726	1726	1874	1	1	7359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5UDH4FCGaGCyKt4ze8DLAt9xseTAm8Sh1kycvdYPukGcK5J7
17856	payment	1726	1726	1874	1	1	7360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwVU38AnciSU6r38VQQ7YDB7bM5KwwRjwkmVSW5HwT7T7jq8G
17857	payment	1726	1726	1874	1	1	7361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyF4xTzAXsW9RnyWEn1qq1TLqCCXL6XVsYLXge9f1eBLUuKtZR
17858	payment	1726	1726	1874	1	1	7362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7rTgzzQZ9RupdqkiuFQmpAUsR37Yiz8haHhsEK1rSLHxaF2M
17859	payment	1726	1726	1874	1	1	7363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4VmzXg3EAmQ4wHmLkrwWhANBm4hWWrfiVQd7Hqivf5bHna1y
17780	payment	1726	1726	1874	1	1	7308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEwCpha7KSVnsxZdxHwMh9Hn9jbPAzgBMzfukoYdVPXKK6K7Z
17794	payment	1397	1397	1678	1	1	8156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNKygjmLZ3bueYTFFrYmCdCFtYuvRdrwuw3KT3QSh12umBtG8
17795	payment	1726	1726	1874	1	1	7317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqrfnbKWoxXktGb2uSzXx2p1kUVbn6F8EAwXEqs8URbkjheR3
17796	payment	1726	1726	1874	1	1	7318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1pHdgnugiqXZ8ajyiCE9WcBnyuR2cjoM7hkVomFwvZATooC9
17800	payment	1397	1397	1678	1	1	8158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJt5pWo9PSfCNXiPC2KNDCjNBM1tp6gRpHRDZZogwvH9m8Y2q
17801	payment	1397	1397	1678	1	1	8159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVAe9aMcXDv7vpVdELGdYcP6K34cmpVvaoCb9yuE5MZx5e64b
17802	payment	1397	1397	1678	1	1	8160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gkYuejLBLxYtgGGTruYq734CG24mbSAS5ByK5pECrvoZ5Rbk
17803	payment	1726	1726	1874	1	1	7321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPSfWhoLo9VJdF8a6GB5KJiML36FU4Kq6W5EJibNLgpZtcLMt
17804	payment	1726	1726	1874	1	1	7322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmQukiQ6uVvmRtWEVB7wPquwwxHDVqR5TWgbKKcrqDD12v9hZ
17805	payment	1726	1726	1874	1	1	7323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7mk5E58ukA3MXkqkLaURSc2btFCHSUENQGA1SF9QXHStDire
17806	payment	1726	1726	1874	1	1	7324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLAJkC2N6k6rXP1AKYFmyMHYcG7PynVb1RMsB9SssT8GNfS16
17807	payment	1726	1726	1874	1	1	7325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrRLz4KL4MS4qcKrDb9j3RCp1Eq5xkXWq6njx9C1WB5ha5oTd
17808	payment	1726	1726	1874	1	1	7326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jffXuxFJFvcY7R24AjzUCxFbM6ENN9gDpmFGhJKceKbDBHx9
17815	payment	1397	1397	1678	1	1	8163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGWRbiL4YiYRErojeNpBQ93fsWdp9Vn9ZKuSqg9Pm72ZCjxjL
17816	payment	1726	1726	1874	1	1	7331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoamurb5qTrg14A1CavowD7yKN4QEdYx5bcowBdMNMa6fZpcV
17817	payment	1726	1726	1874	1	1	7332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89iUrBqEeB7A9KAf7V9KgpJhGb6xxVqxqEKC6X1FEt9x2wia1
17827	payment	1397	1397	1678	1	1	8167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LspV4TchRjz45nXDHJb4tAT53LzZd8DRyYfegDBvX2Q6tvvM
17828	payment	1726	1726	1874	1	1	7339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRYzftuKA5vc67pCmftz9uz5nMQbkJuoJ9BDu79TVzJQFfKuh
17829	payment	1726	1726	1874	1	1	7340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGVmgSForXVdx8j6hyy8SRt5MzLwyaJMb38XSRoqNsq7SP8kK
17845	payment	1726	1726	1874	1	1	7351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdqn1ATfGSaJXnkUUeaLGg2tzq4AHf6YawqUMFRCPM43MnQua
17846	payment	1726	1726	1874	1	1	7352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGGyhv6SysSawCTbQ3WPajgtzY9d62orPtJZyqLdxCYyV2CsF
17847	payment	1726	1726	1874	1	1	7353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5hm992VUBRXCMJraeWXyiemKNXG38LvnbeDoA5qcTDyVtYVJ
17848	payment	1726	1726	1874	1	1	7354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nK5tGhxUq3uT148qd23wryAm9cgK5vdy7hhXQvvDFm7thxVY
17876	payment	1397	1397	1678	1	1	8180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFh7g3Gnur4xbSFvh4bnNaBHzomnZgznmcJTKRqykcduQmB8x
17877	payment	1726	1726	1874	1	1	7375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vDmC4hJ6PkWj6xtUuCvjLhchzdphTZxN4BjxKWzfGzvjwoqs
17878	payment	1726	1726	1874	1	1	7376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPPsxAekMdRErSfnwg2cFa9ukWjCauMvsmYHhVDAF7UQYHkv9
17893	payment	1693	1693	1772	1	1	672	830827858416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYX8AFNifrzpfhEjKSXB6QdivWBUM55UFJeJRRif3gcrzu6sSbU
17894	payment	1397	1397	1678	1	1	8185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTukZaEkWxKawqMugX5vhqDVXdN7ZyoLk7eeNCJBXfT8Bbvjr
17895	payment	1693	1693	663	1	1	673	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaG4WSngiWw2Unz8fPLfZJJtL5HomgADfePKnuZBGNfwqaXpmWW
17896	payment	1693	1693	320	1	1	674	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZGihiqNsWZhRZfUivfG6zsZ3gPsCcA6g9Z6PHEsJJzzkPFUdMX
17897	payment	1693	1693	54	1	1	675	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZf3jT5gpp21VYBZvjqHQEWSHqqi5cTtVibtYkgGNYtBYPxtRQG
17898	payment	1693	1693	710	1	1	676	8799160261	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaEsknbAQbe5pBvJg1iEEra692uHXDbkJNoGLzBhcPBnyF65un1
17899	payment	1693	1693	499	1	1	677	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZED7wmbHJNFJijiAwz14mJ3HKqrC9ZZQ1VguRS15AeuHvmrjXw
17900	payment	1726	1726	1874	1	1	7383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaZyECEubEf5eWDvuKrMpE5xyMrEmfvYCQnkcFcJmsjWL77gw
17901	payment	1693	1693	217	1	1	678	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZFV55CsJfBnXfcYJMaRhwjsoXhE83w2dA8yWPt3CviLjrxEcrs
17902	payment	1397	1397	1678	1	1	8186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqe1Czjec5oJz8v1AeJMibptNQ3xtuKXPLs3d37XL2Q7jUmpyh
17903	payment	1397	1397	1678	1	1	8187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUf2HXzmJSgfDDdLS8BJyzwQBYLSTxXWukBMbRKEc19KTiWznx
17904	payment	1397	1397	1678	1	1	8188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfytSF4sms5rC2RCpKQmJVugtygcsoRoSi5waMk8qD6eGSAzC5
17860	payment	1726	1726	1874	1	1	7364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG72tqYagWqAYVHndj1P8Bu93azBBhaUv7PKv6vtCvKySZYskH
17867	payment	1397	1397	1678	1	1	8177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVFJ37AoWEGhNa5PpwLCiWhon5sb45BzyV4qf7N7uD7s1SCky
17868	payment	1397	1397	1678	1	1	8178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNpChYTM6uZhdG2qF5ndt7R48VD7bmECL9gXg3BVxTHDte1LV
17869	payment	1726	1726	1874	1	1	7369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SbYzjf4qf8bbpHdyMB734hU6zY34u5K9crRD81t1pNTgkjin
17870	payment	1726	1726	1874	1	1	7370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJhQov4MgkMpjbJXnFGa52uGRxHJcmcrVGez2uQPTt7GDH6J1
17871	payment	1726	1726	1874	1	1	7371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTqLt1QTcBYYLhZ4yGgVDQr5ekmMVAq7tkvbCyxM4qVt1p6KV
17872	payment	1726	1726	1874	1	1	7372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQPsdD5NsjYdCxuu1vGQ8iLmzvnbmkz48tBGeyn6pucW53LAj
17884	payment	1397	1397	1678	1	1	8183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKmRdf7TcqNWEVkwLjXojpMmuvWgmSFfRkQYkeVLXj9xvS623
17885	payment	1726	1726	1874	1	1	7380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9crqMjiKrwgCSkuVSYGrfqZchjUVimdre8UeuL9Mec5ce5t6
17886	payment	1726	1726	1874	1	1	7381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38gGP1M2L4QRfBNokWhdJxxb3t6bT9oMo9x9txmHH1AUSuPbT
17965	payment	1693	1693	691	1	1	726	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYfY9NEQMQCcd1UY6NAJGY6jFQhYtNJ4HH2Hv7SY55SYxdALLzZ
17966	payment	1397	1397	1678	1	1	8194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoz6MvYpNC9JznM98rF41T8tnEshhdB8W8imt8LbYAtgN8fZR
17967	payment	1693	1693	731	1	1	727	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZwKLFCjX81sqz85Uy6H1SaTjPwYP2tZRJwEtShXkveAra2gYSZ
17968	payment	1693	1693	1150	1	1	728	1069779287892	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYx6xP3tSsRdoSqzeV5tDCKuRxTDMHWfpMfjd1PSQ2ZLRugZPfD
17969	payment	1693	1693	84	1	1	729	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ1q4JMhKcCiLSt26NWvQ6kMvAGw4uCMJrxsyMPZXBex6BVo6S9
17970	payment	1693	1693	520	1	1	730	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYgGp1MCkgN5GdbNGfCvUU98ddQo3hbdXetJ6U9BSve9wKnST9Q
17971	payment	1693	1693	551	1	1	731	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZe4fAeztnNfrkQHU5RLnBpRkDa4SaFNK9Fuxsg3sUUstZn8dRQ
17972	payment	1693	1693	2017	1	1	732	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZV967FwyD5CKPeVaEMjGycx8WCzMJLtjXXHDTadh4B6xhhF7Fv
17973	payment	1693	1693	63	1	1	733	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZQhqVPZUFRh9RAuYjRKqmLBrNyMdgcCKigHctfWoYxRReyZCpQ
17974	payment	1397	1397	1678	1	1	8195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLJH9cvd9Jr5qucB7keRmPM8SnyYb9r76mybLL5MAQTeknUSX
17975	payment	1693	1693	150	1	1	734	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaFXPCZeqfFqsSkLKL5Xvpaw4n8XEQQAWjQmkLwCiJoY3qxMx1d
17976	payment	1693	1693	92	1	1	735	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa4NM5BoQjPsZ1xFstnJmR29rkV53fFY2zEwXA5ss4XyYTHAFG8
17977	payment	1693	1693	322	1	1	736	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNcnPq8EZ3AsJCw5mpAgHgDmViKForD1p6FFqQ7KQeZjgjQn3p
17978	payment	1693	1693	373	1	1	737	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYXFHtuEdr9Fo69DpZNXK6RJhZFGc5mjb66kP9fFj4BFWqHiC72
17979	payment	1726	1726	1874	1	1	7392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSRvgYnBvaryY6jM5nUcTL5ujUrE5fPMesiwkhBi4XBmi4HpY
17980	payment	1726	1726	1874	1	1	7393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1nLATg4PtQQpEyjRqXYAokHCh4THYoPh1gAiAhpMw9h7kpj1
17981	payment	1397	1397	1678	1	1	8196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQssCYufV4ybCA4qwqJSNz3cmdRvQWgPz3aJ5oyS1UAfjaKRAF
17982	payment	1397	1397	1678	1	1	8197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt39Vh94cAr7uDNqBC1NnojZ5UQ5uxFWb2nGghD6K8Ru7tgtU1
17983	payment	1397	1397	1678	1	1	8198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSnkgYFxkZFE6EsL5BLon229tcuXsiFASx9BNShnbCiHAmmKu
17984	payment	1693	1693	450	1	1	738	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa22Qnm4oq5R5d58rUeoq7Q7jCtRMzE1uyT1q6tXJbPzDPvpgHL
17985	payment	1693	1693	453	1	1	739	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYWR1XsV2ddPiUJimYsGdFpXYQxFqPu5yjivt47ghcSP6t9FquN
17986	payment	1693	1693	593	1	1	740	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYrkeZDzoCfFLQPdzXEUemaCNDdafqxkdFUVebC6kV5FeT8WQp1
17987	payment	1693	1693	91	1	1	741	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYY9az5PFAFyZa7m2vwaXPWFxD6R4h4WxUehBKJZnn96aPjB55s
17988	payment	1693	1693	408	1	1	742	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZsWYqHNwsFGNyfibT8xGvLcf7Nu5M1pwXkEYh5jWUUqN6TPSvJ
17989	payment	1693	1693	438	1	1	743	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa3cJsNk71xxRtRqCLst4Pz9k3Z19GRBpF3X88uKQAfutdNK7GH
17990	payment	1693	1693	601	1	1	744	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZZ7si2txrJhg1uMh9aQC5HdNCCiP15QX7YQL43NZg2H2z2BHab
17991	payment	1693	1693	745	1	1	745	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZBGZ3c6qC58R8K13Gfg1XA9MtvGtCDFyKVZy9pQj9dUYg9FQNh
17992	payment	1693	1693	339	1	1	746	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa8k1JEhbG4U4got5r9qZzbKSsSNe6W8V17Ky4Z1TJwxdQJSNcm
17881	payment	1726	1726	1874	1	1	7377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LktBmcCB6Txwrb8wHcXhCmZQ8QYGnrS2wqP1Hxu7CMf3w18g
17882	payment	1726	1726	1874	1	1	7378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiatsYjDnvMAhA4eYPbDfN7zX2mqgTWgDR7woU1ttmT8qMmthE
17883	payment	1726	1726	1874	1	1	7379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7te3Kv3bXhBrzQKpxPPEhWJNoirEsFoGe8NyYCCQhc2TXTmzu
17933	payment	1397	1397	1678	1	1	8190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAeLKhKGfchz3FtDTKdFrL2YhV1DEjXYFcdttJN9sTarTW9NJh
17934	payment	1693	1693	361	1	1	702	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaDWq7RB1dDHGnVsks1c5f75TkAvGMmm92uctzCWxt1ZX2fJb4r
17935	payment	1693	1693	452	1	1	703	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaENA1qQUsJgCtW93NP4xFKRwugD9Mnya4jao5ab6q7UtVKfgsd
17936	payment	1693	1693	594	1	1	704	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa1ze2qxeRZnDSBBfgXkUQhVJcA8nbCQZpXwG7BgyUYbAZ57aMP
17937	payment	1693	1693	534	1	1	705	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZcJiRLa2ZSb5Mzf3gDf3zktrqrmvKaq5U8NkCWyrR3V7Sdezvo
17938	payment	1693	1693	245	1	1	706	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYkHbYxTAJXdXp4Qia3USvFVMMLahH3mXX7eHsVoNoNPtQSLVmo
17939	payment	1693	1693	191	1	1	707	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZskZ3EbgYKXEQqY5W4Rad6BM1v9TsFuxse86PEhTaS6F4C5gMM
17940	payment	1726	1726	1874	1	1	7388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVokkPPafuHQwrKzzmdMs2SLpdAJjTSX11YSePbeKybH4KTvsR
17944	payment	1693	1693	266	1	1	708	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZknN8ysbMKMBWQwrRTDvjwUt1ZxxFZnZmYuiAKRt342weG5o34
17945	payment	1693	1693	352	1	1	709	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYzveF9goU5LFnNmPn3QoYEjDYnBCeCEkgCbXdVEg986KApFiSs
17946	payment	1693	1693	421	1	1	710	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZH3vXquPGGJDDo5B8gwgPxdNc3kimXyFcpyvRDsgkLd7tTVDs2
17947	payment	1693	1693	420	1	1	711	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZkKS1ZkVS7U4MKM7yaeWdvAzS9Y4Libr9iqcoqLdLDtvBrmwgU
17948	payment	1693	1693	600	1	1	712	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNKnMr2TnbTMueewjtxz3cU32ZfEJwpfx1rdk8iGGQW4bHAXK8
17949	payment	1693	1693	353	1	1	713	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZcixri1Uxg2or18GztTzMCxjavoRCt1FNZ5qcU6U6gTBHhyN6G
17950	payment	1693	1693	620	1	1	714	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZRwHu22HPtu1iyZxM19tn7U7oaPAdDTo4WtSRPEk9mxxFgWJ1y
17951	payment	1693	1693	180	1	1	715	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ4eYBDo3cFsoDKpg7rCaVNn1s7E37ytzTZmjcuBEgkvYwEBcCo
17952	payment	1693	1693	112	1	1	716	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYhWnPiP2Hdkb9E4nVXA7E96bDxxaJwcqqj9XRCBwC8LmFWpk7q
17953	payment	1693	1693	652	1	1	717	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZfb6evEzKQSX8Sm2iySWtLYQQHA99zRbaBspgPgaBAoNdk4Guf
17954	payment	1693	1693	680	1	1	718	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZu194dMQrQSBKDyhFafZ2vtYbRfaezHj5mDZ1moNP9VM46W5YE
17955	payment	1693	1693	690	1	1	719	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZeNncRMug9kaF6SzGhLLoyNJJiBxgdp6VrCEQYexs1phN64Xxq
17956	payment	1693	1693	89	1	1	720	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaGh8LF4CWaFB6LA2biGPybsVBV15i9QfTc7zQTvkmyThHQoTkK
17957	payment	1693	1693	186	1	1	721	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZT9bn4JD8FKuSyLWF1rkRp2EV6zq2eRHft3S5Kkqzw2LzMd4K1
17958	payment	1693	1693	383	1	1	722	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZyjYTUHXjx9E3XfwrVeywr5DGqArzw7pBzgehRmfEfMCShtYtu
17959	payment	1693	1693	392	1	1	723	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZaMBgxuNGRCuuww14GZd9vihp4TPHpe2PcXoEVjoPY3PkhCkz2
17960	payment	1693	1693	308	1	1	724	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYouxipZpdgQJ7dAKzS4MGAgWYcX5hZDpiKmjG4QExeVfiAkXxX
17961	payment	1693	1693	678	1	1	725	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ5yddzLw1QUByHh7uxQwR7DoNoK8SKvLcp9YSCFt88SYqf8quM
17962	payment	1726	1726	1874	1	1	7389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9w6bNxZrKPRFAHq8d9qZwjFQ6FjqDEERdZWYngV5WfCgf9kEj
17963	payment	1726	1726	1874	1	1	7390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAcQrRmiTHUsmD5C9YjfuDygm949CyE6Uoc275p4TNSDAcsRk
17964	payment	1726	1726	1874	1	1	7391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqq2DQvn515LxNXJggpAD9uwPs5G8QjCXDTYRKodVXXxvbXt5L
18035	payment	1397	1397	1678	1	1	8206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQo8wCaauStPxpzHv8CBWZYMAZbD2o5GVvFbMcmj4RrswkYtpr
18036	payment	1726	1726	1874	1	1	7404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9uMjRYvGVMpACZxUGLTmdRC64BaA4P9SFRayyyGgDn9nsYVJ
18043	payment	1397	1397	1678	1	1	8210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPNY11sXEsjSqGbZKsYvDVEvMALNWEKYTSoJPkPJMeNfb979M
18044	payment	1726	1726	1874	1	1	7408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta8JwpnRPpQAvqFKpMUTT6WeEbbDDbhhRkb8noQ7s1iL9DsiH
18076	payment	1397	1397	1678	1	1	8226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJT1ko1EfvAASNdUag39foSPbWA7Bhjr4HvxTLUPZXKkWmUaBy
18085	payment	1397	1397	1678	1	1	8231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerN6Z9QvwfPKDYtkM4B69rQ2y6Rmy3BJUDdYgifqfEVQVn4vJ
17905	payment	1693	1693	103	1	1	679	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaEE7f23gAxSxT3rnhLUC6tkoDeg5WQ3jPHuLVyrV6yHejdxRe7
17906	payment	1693	1693	1811	1	1	680	317795751869	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaH881tchFXiT3BPvGUv7vc1JsNLePFPwBdTwkUSb6JByxcM2Ax
17907	payment	1693	1693	893	1	1	681	539956803737	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYxkrAPaBQbjKghowpLfXfr5m89ckkmJo15edSLGCgx78uUZ2gK
17908	payment	1693	1693	225	1	1	682	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYenGqNyUYFxcVcXV7RMDZYRXfqrAXpuZf9pvowuyknngEQ9Yon
17909	payment	1693	1693	377	1	1	683	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaDj3uJ26SSQni86mQkE6gJgxoAnxMRE34G8S9bSgbKLxPAiJZq
17910	payment	1693	1693	560	1	1	684	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZWLAr4VJGN1B2neMkuKrDgpVBN4V8uQgbpdu4hmHen28oqQBg2
17911	payment	1693	1693	252	1	1	685	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYhf8RNhTdSfBFqdM6QqW77acZ7YN8zj49qVRJB9EwFk8arnB7v
17912	payment	1693	1693	894	1	1	686	539956803737	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZs7VoLSKRZoVKYYVKVKrvrAYKY7T2xYqeyELTNnFQ43TNmbQVB
17913	payment	1693	1693	569	1	1	687	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYvsRFK8qk2X6fVybEGy3vci61auz5wrDmx38DQXNxBX7R1HYXt
17914	payment	1693	1693	390	1	1	688	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYdV3Sv12qRANnLcZXj2vJE4bzGqnV9j8secyRaTfREQGkmEH5T
17915	payment	1693	1693	108	1	1	689	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaB8KwpJ6uapHwLetNfJxHQ86LLoax3NnBFmcRcqyNnAoCrUvgT
17916	payment	1693	1693	99	1	1	690	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ3Gy9T5AGxTqRNBfcWCc69tBeirnKSWFAsuqniUELtq7nE8Nqy
17917	payment	1693	1693	570	1	1	691	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYwi8Bz4Y3Ju71W6XCcADVUc9VfTquXrbHBJ4Gnosb7cnAe4c7W
17918	payment	1693	1693	2073	1	1	692	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNeP5FgB42ycMK16ScMUy67Yc22czzLzPbe5GeHwGdcDfF9eMg
17919	payment	1693	1693	391	1	1	693	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZVWfVuEQaKLhJox2Soem5DnSNmK6VumxsxxYo7sXrqWLaKJmWc
17920	payment	1693	1693	397	1	1	694	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZiGZ6ZiS79kajeX1zWrQBQHHVzZqQQCDARdSdUWkzchZvWzn5Z
17921	payment	1693	1693	402	1	1	695	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZmZQzinzrfdN9UUKkCFayXAYx8yTUT2QETjzszGqwnQvPF1a2S
17922	payment	1726	1726	1874	1	1	7384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64MwmhtFEZ1rvHJoHmSn4i5E78JgQH6rpBpCVVh4jPe6vcav8
17923	payment	1726	1726	1874	1	1	7385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Boj5xoVk4vZw6qKC1yQwn8aF2yXQQ24bfWgQBAS6Rmuuw3sm
17924	payment	1726	1726	1874	1	1	7386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwXEjhTQn8FLHvqZkqHK5xrgMnFMKdPWyBTVhKLBVns5Mnwe
17941	payment	1397	1397	1678	1	1	8191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWirYGDT81PoWENoimkW57Esxav2mm6Q6Dfx2KcdioP34RWQmY
17942	payment	1397	1397	1678	1	1	8192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR9u2HcG95JBrAU7yEnP1tXWnxLkXptXuBZ8njJ2ksMJokXVp
17943	payment	1397	1397	1678	1	1	8193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEAAHzXECRyeYwA6T7FGanUVZcF3ZfpButs3fPMEtmz49qw8X
18005	payment	1693	1693	138	1	1	756	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZDzkHpzSQy3GxxxA6qSTjAN9NzxCnfQLokGvFkcEwj1m5PkAye
18006	payment	1397	1397	1678	1	1	8199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjCht4DBXKnfpX2S1ia98iuQkRWUNVNSdtsNWbVpSmhXS9ziP
18007	payment	1693	1693	146	1	1	757	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa4JE35R1twLUSL7CmQmVoP3Wi4QHJTnYhDygdfaAbPeaos6Pee
18008	payment	1693	1693	122	1	1	758	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaF4NYMnP7wqQNkQYr233LkfaaimLau92h6a9HatQuGWmAiSSNs
18009	payment	1693	1693	105	1	1	759	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaCE3FfcTsHnDUHSt8h9iz8Z75hAW8xsoLxpGAV795o478juePN
18010	payment	1693	1693	500	1	1	760	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZm6qjnKsC43xi9FwDe5NTS1C3PiaqcqtQ5x44X7puPnLeBFCac
18011	payment	1693	1693	587	1	1	761	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ6zTk8ApFxCe6DQYxWsTnq3DvfUpubjLRDcCS2rueGRW6H17nq
18012	payment	1749	1749	1950	1	1	14	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw88RtSaVnkerwbSSBYd4hZVGPqtMTXTqTgRhQdkbHAczuusP
18013	payment	1726	1726	1874	1	1	7397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiuLy6ZhMd61ueY4QKwSbwtf7EVF13UzA7jVcB4ToWNZPtJBw
18041	payment	1397	1397	1678	1	1	8209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEAv13SbY3Aj7ta2SmoHi4nDjA2J6m9hFq39oKv8Lqx3BUoPb
18042	payment	1726	1726	1874	1	1	7407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE8zZkVbc64X1wypLA6g54VsR4SaPvfDbP9oEnrkhLak9mRmW
18072	payment	1397	1397	1678	1	1	8224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4pTduY3DVHJ1C6TGncGEdVkLYyUrQz8tF1MxoDu4gQ2W7Js7
18073	payment	1397	1397	1678	1	1	8225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqFdpPpwa6bxozCnmEu4MmSa9oXJqaGhzfVrPYbMuNwxgcrq1
18074	payment	1726	1726	1874	1	1	7422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxwf9MLn9wHYystbLgeWPEm72SwtvT86MLAon6AnUCDdufT8F
18075	payment	1726	1726	1874	1	1	7423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsARBajUkXYPqKDuEQ9Jkcf2tAeP8j1ZDaELG6gCRXx1kJvXcD
17993	payment	1693	1693	504	1	1	747	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYTpVT9B2qQJNwo1fjRsyPTeDSPwsCsbpa8k1akBXtqWtWnCmij
17994	payment	1693	1693	1961	1	1	748	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZpsKbhM7HubdPGTyBUS8ru4KkjpZkazmX8VZ6n6yHaxAwfcqRK
17995	payment	1693	1693	658	1	1	749	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaH4QwMpsnj4kFb3eiFSJ2g2Nbkn9t1xqDJZuXvyfNGzs15q9Hk
17996	payment	1693	1693	205	1	1	750	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZWjrfnhskVFeY8bYML2WeCrobiZNztKuvnspEYgYyjDduPgJgL
17997	payment	1693	1693	660	1	1	751	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYaCkCRUeJu6EspXzVfQvgBMCsa8ak8QWhD4YxVM65W1tF1vxxb
17998	payment	1693	1693	78	1	1	752	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa7p4613R11NVWRXxsvSJdkekFZCuhKGCZtBSYanFv4ceMdtkTe
17999	payment	1693	1693	395	1	1	753	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZT9tBrDmzLW83Qm6nLm9xQBFrZaHQ1y96oG6rxFA3dyRe9Td9C
18000	payment	1693	1693	29	1	1	754	12318824366	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZbVBB2vGztbZZ1pPdgtyicPWt4T1NUHfUhYgEjAgNqeEZJf9v1
18001	payment	1693	1693	910	1	1	755	884778824468	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYgaB61Y3k6xRS9fnJQADHmovQfjrcmj2gsaoXjKTqgfPsoAHMM
18002	payment	1726	1726	1874	1	1	7394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDejCTT22mNN1dydZ3f1kKT2t9vCqcT1HapnGQEMbRb8fTe7J
18003	payment	1726	1726	1874	1	1	7395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF2kDFL12LccNBwSoKY5jktbPhANVDuvwWm8nWRxKG1hSpt1U
18004	payment	1726	1726	1874	1	1	7396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPapXdn8n5mPL1D5ueK52NmimjLbGDw8cHkRT86N36qvR6JHs
18027	payment	1397	1397	1678	1	1	8202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAWj4CW9DJbYJ4KmihYcHFDC6Vzz4ZeV8PHioysB1VRhEN4nS
18028	payment	1726	1726	1874	1	1	7400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL4sYF3RXeS7bVJoZVjoGLKmi8iU7TY8viVzRrP73VctkBwwU
18050	payment	1397	1397	1678	1	1	8213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qCLReCpm3VDpMsArtLdJoHznDhthGZJDZyTpoAapT4i9EvCm
18051	payment	1397	1397	1678	1	1	8214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEjZvADL3P9dYMKoQpzri8oQ9B9G8stBuMN6z2j6BZiRiSpho
18052	payment	1397	1397	1678	1	1	8215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCprPTpYGFfbSmEM8UDXoSChg2mCQBhheR42DM9bSicJoYwiY
18053	payment	1726	1726	1874	1	1	7411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJibaZzhn4VTqNgBZoBPPnPBXvpaT7UAL15mLfrFwQUBy3Kyf
18054	payment	1726	1726	1874	1	1	7412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybMD4Qg8ys2Ng7SbNGmhc5VvZKNtC4L1GocxbEe9YR7bBcfiV
18055	payment	1726	1726	1874	1	1	7413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDm7DC2A4ie6qmyARkLqW1M8H1aPM5fsHBwCtsen3mWVN34g5V
18068	payment	1397	1397	1678	1	1	8222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPD4NvKnuWjhP2qGwELHkdkYbHqfi4X6FX715o3zn3jowMtU7K
18069	payment	1726	1726	1874	1	1	7420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sW23a4hf7f2CJ6wQcMmdmK52BhjR2X2yumZbSApWoLVMgAjC
18070	payment	1397	1397	1678	1	1	8223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JL6usVgvJSh9vdUbBfZABVMVNjnvRECKGQ8ZNcwBoJ7U5GQu
18071	payment	1726	1726	1874	1	1	7421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7Qgr7idoi5ibkZrSGeXw8Njhm57HE6Gf4ayM6PSgVAv1HkmX
18077	payment	1397	1397	1678	1	1	8227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SXmuTSSYEw38a9Ge36iiBvCNnBHuUfvCdjW3bbizwtqiiUVe
18078	payment	1726	1726	1874	1	1	7424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajqGtNTZeW8wsmHQ7okV1nrREc8jtWDYHgy57YFfnvRxBVd9
18083	payment	1397	1397	1678	1	1	8230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRZm6UHNH9fGz8rojNZZXF78XkaxcX8y8rProcuxbbhsFgEBd
18084	payment	1726	1726	1874	1	1	7427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAnj1XhCxJDTbTLtCBe6tDsUqMmveroJjVrJv5ybVv2kfsJ4Y
18101	payment	1397	1397	1678	1	1	8239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzZFNNrGea7YDjnwH2MACYW99YCbn9NatoygjJinzadF1Heo1
18102	payment	1726	1726	1874	1	1	7436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtrGKaJNS7nQrrGLizHknTYWbpm4yANCwiNAsSbjzawu1hQwuJ
18109	payment	1397	1397	1678	1	1	8243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbjyrcWvPAeUREA4JaeL4c9JDHykdh3wMjRC4Wdc8W4CwTkRF
18110	payment	1726	1726	1874	1	1	7440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvKRxi8AxivYHwduEnmvcntsfyiRLNbumU3VcifLDaB66AVzF
18117	payment	1397	1397	1678	1	1	8247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPU9bMvAv2WMGgnyTNAQBoAQRcZsF3gd6CeQdzHe8gBKD7jWs
18118	payment	1726	1726	1874	1	1	7444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoaWdMKzGvzhTz8PJWbdR3VjRjL3qj5xzHXBtYwejYkni3Zwv
18125	payment	1397	1397	1678	1	1	8251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMArFYWJAwvBWxXmJ3ktbGLqeK3vtqYWGo6z27PaXN8CsNbF7
18126	payment	1726	1726	1874	1	1	7448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLrjoNUgfxhQaD2REj9Nv2byTtR2DXjcrXWpgeak4Gk95VLLq
18154	payment	1397	1397	1678	1	1	8265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwY4jTjQsH8n23NiQKnEL52c3gcHcdQQ9Ara8dqwtUJ4x2SxYs
18155	payment	1726	1726	1874	1	1	7463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbEm9SY27rgx66Cydi732ULfM6fquCvQYhjxEz2mtY7F5rF5S
18021	payment	1397	1397	1678	1	1	8201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucgjpkYmyXbAiimD7Qc62qMJ7iSaufSxVPyswhWD5REhaoFUP
18022	payment	1693	1693	653	1	1	767	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa8aL1kZuuJcexTbQ2BFvbU8bRG2mcJijkEqpfoM7HWJbkMfPsG
18023	payment	1693	1693	194	1	1	768	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ8T1wdR8AMhsQRpu8xfNco1riMixaS8vyjzqXRXMsMxaNMKaPp
18024	payment	1693	1693	1276	1	1	769	2981035105160	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYri8c6s15b2A8WEWoiQQiGeFKSk6FkJMjhRrz3n7AVrxLqHWmt
18025	payment	1693	1693	721	1	1	770	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZyUSmPMBkviUSubkwUzjAstwnTUMrBaXe8V4ERcc5VawFGdWGj
18026	payment	1726	1726	1874	1	1	7399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pmRtxpVudcMeq7Urg51UaHm8gLR2tWRK7Xo2gj8brPs83NT5
18029	payment	1397	1397	1678	1	1	8203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBqpbAbGMyi34riqsi7wfYyqRUooMe3HhDADxXnM8qmfc6RQz
18030	payment	1397	1397	1678	1	1	8204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VuGY8uDwTqMqzvYQRDeECtjXAwottCthVJC5wpkhZwQAVrQY
18031	payment	1726	1726	1874	1	1	7401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEt4Y6yByh4PfEWdV8K46E273nSeZRxUt14nGPih3QfseWwGmb
18032	payment	1726	1726	1874	1	1	7402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHMtikL1E78hZSRrd1ip6yRWZ1RY3g4WWh1Vqk6dusYuuEkhv
18033	payment	1397	1397	1678	1	1	8205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkc7LXPnRaCJ2TXEab3gwJN7bivegfSn4yXx2r2knW9SUAbTm
18034	payment	1726	1726	1874	1	1	7403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxL8HAmQxHk5WBfzPtqLYFjCD4Ay4EHGyru18dhtGcB6v7YdJ
18037	payment	1397	1397	1678	1	1	8207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyuwaVcUzyjJ5f2xd6gnJfza7m99Ke72cqn6aJ1LdMLX8bLDG
18038	payment	1397	1397	1678	1	1	8208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FdULR3dfHnb81bTNosqYQ9SUYgKfrZkFkFp6LX54KLE9ooZW
18039	payment	1726	1726	1874	1	1	7405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1uM886grxb3mqXRcNdcsTMwNVro6JGoULdf7oCUZBD9U9rZ3
18040	payment	1726	1726	1874	1	1	7406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuAvfoyhonnk7nGoGYnFhpdmoH6cNy5XfyrePLcDjK2zqsCG3
18045	payment	1397	1397	1678	1	1	8211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyo1neHgYtrU27EoSQLP7DbB7DoUDHuDxcEo4FuFb4G59zhFp
18046	payment	1397	1397	1678	1	1	8212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2y9K3okSq9ZMwDCLcPwuaXu83wZEGW7kYyWEeT9hjyeHjb7ca
18047	payment	1693	1693	1778	1	1	771	1500000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpaDzBw7iUeCVBEPgEYokWpxL9WV9PTjvso1dv8RkP7FpVffUZuE
18048	payment	1726	1726	1874	1	1	7409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3qA99BEtGgcR4Q2WYszBTsCYurKcZZNM4N5sjmApr4dzXV1d
18049	payment	1726	1726	1874	1	1	7410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzSNm4KvcZTjqX4k9guzq86k4iHtHJqj392n5SSiAbGgXCXgW
18056	payment	1397	1397	1678	1	1	8216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUQdGZx2bUQLPvoHkCorNRns1Camss3WqfGGiVkApmZMqZQw1
18057	payment	1397	1397	1678	1	1	8217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcSNUCnMccnTi11zcawuvkQ71GHGKwzgDLKtof4KZg7pRG3G6
18058	payment	1397	1397	1678	1	1	8218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7E6X3MoLPGyYDtn5MRwoDxtkTRS6rUQ1vbfzqtg6Q5sZXBAm
18059	payment	1397	1397	1678	1	1	8219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKfUqmDc7fSEe9KMemtQ3cQEz37UPr8KCTAph6FNkDb7oGidW
18060	payment	1397	1397	1678	1	1	8220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvem1hxrUFJsiMtnPCDaUntzqPFi53ngMEDUp6g5qpgtXAve4F
18061	payment	1726	1726	1874	1	1	7414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyof6rAFEM9XUFJWzaWJiS431pf6DTNKvCdoiPkgJgVK1p8CY
18062	payment	1726	1726	1874	1	1	7415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZi1omoPKa5YyeH3dcV4QRj26UcndbFzNQQKewqqanYDTbFjq
18063	payment	1726	1726	1874	1	1	7416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtpBw4MHECTrLGetaFXpcgUWodMcz9J5TaeWhAQk77WyzTuJf
18064	payment	1726	1726	1874	1	1	7417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY5yefJYRbhvKRMUPgHtkAsMGJSui8yk7UX9AkRZmA82f34Wk
18065	payment	1726	1726	1874	1	1	7418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Hqgdu62rXgjyPPVo8AfygUYGEGUSoLiQnHx2gCMrBD7qRCBE
18066	payment	1397	1397	1678	1	1	8221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHEunsv4xVCYN2qvsiuQudPrxptgyENAzFGMyNoUiZjT7J6SR
18067	payment	1726	1726	1874	1	1	7419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cRWmBNtXdySn4PeWhTawy7uGXE6a7UJsD9XkRLEQv7uvpiKE
18079	payment	1397	1397	1678	1	1	8228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7hUAVr1VMDudVDqiv9xafGnaSaVWjycGh21xMDPXZ9j6rTNL
18080	payment	1397	1397	1678	1	1	8229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XRfQQJEcgGnBbmXCV7h6AfoeXFiiD8xuSLymdh7UbCyJT46y
18081	payment	1726	1726	1874	1	1	7425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnjLDK7hmTwHpTbbzMmSFj5J673RN57tCGBGc1yK7KQ16YMKL
18082	payment	1726	1726	1874	1	1	7426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3efMtjHPNxBjua4WyBKEdiKnuYccJRPxyPgDKLHcGL9cYdYRS
18103	payment	1397	1397	1678	1	1	8240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1cYqz8BDhs83mbY6tvCwCXT1hYoNvUaBeJFR41i2hZoJWLPm
18086	payment	1397	1397	1678	1	1	8232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkBMRXpGBmkwtGGVhR44q2Djns1chQmKLw71HapPX3p5CY96S
18087	payment	1397	1397	1678	1	1	8233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZr6kDX9oXeJri1xsVZWgLgFz2BmLRbh8fq4AdxAU9jaCUJUP
18088	payment	1397	1397	1678	1	1	8234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpobyJxUZiJUHtqVSkQWZctu5zkyBZxG7nd9z4V6r2TBGvriK
18089	payment	1726	1726	1874	1	1	7428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNoQUveAskQto7FMUF9fRLMmTGoDJ2oq8wCjEfSXA5PbWNDgk
18090	payment	1726	1726	1874	1	1	7429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6EZvZhA7bbUBGiCdD1PLTgDugBU8xjjESFsbSWi5JFJjCBio
18091	payment	1726	1726	1874	1	1	7430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvjuyA1eza4cTBNFVFw8W6Ekf2yg8Ufh86Gfaiyo1NFJSzvpE
18092	payment	1726	1726	1874	1	1	7431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77px73KagyqNwm8CwC3Qa4YLsEZSqMz1t87EgsNJF1eepgVQs
18093	payment	1397	1397	1678	1	1	8235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1TAzazDjVx7eWPyQY6LWMXaHPTm63Gm7S8XMEPjzQ1ZtRbfK
18094	payment	1397	1397	1678	1	1	8236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCEUZuDLuHmsAvNy1HNC1kipE3J7VBeZAJHW2AtX2gH4ajdjz
18095	payment	1397	1397	1678	1	1	8237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjMEYf1HRkbwSF2HB2nSGbXMFAQi74yUkT7yXMt8VpPEpcBWP
18096	payment	1397	1397	1678	1	1	8238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjXPhgeA2QQHFaeaU6hHezgcnPP4fyWoyWzArQY4PqrtZieTP
18097	payment	1726	1726	1874	1	1	7432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQuwz2kGNuPRkjttrpNaDPnpSbcDZcwFY9wQtFY8KFt7i6G7m
18098	payment	1726	1726	1874	1	1	7433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNnEQteMszDGGCM1QQ93gK8r98YTFWupoF6ZTkD2qCZcwbQn1
18099	payment	1726	1726	1874	1	1	7434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPzhqMYgN9tqyq7wX7MX6aXbJd6mtR8kSxR5kTqs5EsVL3De5
18100	payment	1726	1726	1874	1	1	7435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmos6PjiUz6tkajEAQpPiMqwLcP82KU9AVm2k8iGXpCAuNVLa
18105	payment	1397	1397	1678	1	1	8241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa84sZeSyKhTuTXXdNLbsdjBbYPyVASNNjsjV1Ycm5QiNb7NjN
18106	payment	1397	1397	1678	1	1	8242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6AssZJuR1qWHj6un1wrRBFUCWJfkyb31vUBQwJSYaeEN1PKP
18107	payment	1726	1726	1874	1	1	7438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DXJLBe47hTqnAoyYA66fVDrhRBeN7XXUxcQcUqwWxDdsdKpP
18108	payment	1726	1726	1874	1	1	7439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBh9xN4m8F9naJkNbzfpfcv9eoMGfe2Wi83rjp1CEvqTrsaVpN
18113	payment	1397	1397	1678	1	1	8245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7A2aHSozpMMMq9buVq2XKzMYUyJNnktFrnr9SPdg48vAH793
18114	payment	1397	1397	1678	1	1	8246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1zJZjHM7rXp5tJFY6R7modsZkNdNC3NhTrUp7LaVSCW4CEHo
18115	payment	1726	1726	1874	1	1	7442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk3WgqZfVEqzKKX4WVP8MrfpwLk5xU78F5o9BTLtpsD42ZYzQ
18116	payment	1726	1726	1874	1	1	7443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU6BCG57QkVvgzq1H25ge8935U4ScFLLo1zhBLd3FPEMQ6yVc
18123	payment	1397	1397	1678	1	1	8250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qn7sAGvpJMizur7Wk1a19XqYzrFC7UDfLcPZgrYLUrVqLWsS
18124	payment	1726	1726	1874	1	1	7447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGPRAozLbwhmcKRmDeJYsHvun9HzgeaMxc2J9UnMHDrmYvSct
18131	payment	1726	1726	1874	1	1	7451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DmUqBxi55MPB1HW4VtZrRDJLfGfbKuW8Qmc4zQLGnAn4GZvW
18132	payment	1397	1397	1678	1	1	8254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVFz9zkgwnu7Z3AkQGN2zSVWodMYqZX92QY1d7VfSSQEESZCm
18133	payment	1726	1726	1874	1	1	7452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjuVUur6gYYJxbFRmSWz3o9EJ5LnyrC8XW6wdqDyNyUpQe3Qt
18144	payment	1397	1397	1678	1	1	8260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprtzKvC1Lkcxq9Vf7zGCDgW6maJFpJRrqC5HeYYoxLyMuZoLf
18145	payment	1397	1397	1678	1	1	8261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw499M36ttHKxqvgLuerBFUii8MGYndaXuj88bgkjx7BgKX7e
18146	payment	1726	1726	1874	1	1	7458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeaQdYeEJRo284MATE3aUauHLe5JSdQFLWF27w8Hadpd3LxHH
18147	payment	1726	1726	1874	1	1	7459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4sWfQkde7SQXakRQ3zM5ffUPA8Au5vcGjS8JMDodMSUr5niw
18148	payment	1397	1397	1678	1	1	8262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfpaNuGScgMNdYEKa8AQ6RDaPMVaNEc2YMLu6AYbZVeDiWMyG
18149	payment	1726	1726	1874	1	1	7460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbN6BtAC2fVvPwbr4M3fJs4NU9us7e4tRw3ny6bh8jAAkiqGx
18156	payment	1397	1397	1678	1	1	8266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ACdknQvtk6yLkZwG4CU5n8oPjPZvAA1XwwW2G2YMh55F8rLW
18157	payment	1726	1726	1874	1	1	7464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTD2tX9o6MrCtdzW9KpGfB9yjX6USaM5JEHEWNJtEqr255FPGr
18158	payment	1397	1397	1678	1	1	8267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wCJsM1MbkxqZY9tZQZZtnFep2QTL7acNKKMPbV3k67AAptvd
18159	payment	1397	1397	1678	1	1	8268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW2kduL97ntEkReN8M4yhPoMG8weejQSGHbDLntsJEFpDpe5s
18104	payment	1726	1726	1874	1	1	7437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxRMv8tbw7QfCtsFQamFVdrvXDEJHRwN5hBJM5UPbCY4BdA8j
18121	payment	1397	1397	1678	1	1	8249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1BkAjTwDm8Cjk32Bypyw1G6mV2PcCU3JoVmjVWxFRyAfE5FJ
18122	payment	1726	1726	1874	1	1	7446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zKxaNi5cLWjT27yZm42XmsQBxygUKQGyXLArDFiwPsfC1Chu
18134	payment	1397	1397	1678	1	1	8255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYs3gjshXo3vP3hX8SFJENTdvfxiAcX5sipsx7bE8qu34438v
18135	payment	1726	1726	1874	1	1	7453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrsxDK7VzjqCzeaT2RS9CQiZCspDUeiJMc88inVGHNrvCQwoV
18138	payment	1397	1397	1678	1	1	8257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn7XARHL5Z3zPSSwXni6HHHebNPtZvP3qBxd273kAPyMypWS5
18139	payment	1397	1397	1678	1	1	8258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaYGzqeEgsiJDmjSxyQuzoHaop99H1UXkcH8bFuJE9NZzMeub
18140	payment	1397	1397	1678	1	1	8259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMFfHw5ioaeHbnpHz5y2rKkHrKvFLgs7XeCzYT2XDhcUxd2Kj
18141	payment	1726	1726	1874	1	1	7455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXT24jcE431StEaY7AvMpRDCgj9khG6HifkyS2q1KWmLxTy3qr
18142	payment	1726	1726	1874	1	1	7456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1mq8ZV1Kf76xPqCERgmX9Cs8ZYp9Y33Cm7v2uG24997C2bT5
18143	payment	1726	1726	1874	1	1	7457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nFmgZSw1NUw87jTe7k6F3wxGBKpG5w4puURkeKSG4Age89F7
18150	payment	1397	1397	1678	1	1	8263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9uH8o18mKaywDLtUgNgH5qNRCJwtc3oxoJnv3nDZtpwM6Qsd
18151	payment	1397	1397	1678	1	1	8264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU478bxuNtpsHvardy4omaZpGRChBu1HfChu8685SUMX13rF2V
18152	payment	1726	1726	1874	1	1	7461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEoLSJ6ewHC2UymB3wqdkEovVzurq3vDj6KbZfsmoSaaDoqJB
18153	payment	1726	1726	1874	1	1	7462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHS7zMu8braDLPkmYRagHa2ejYvnmEhgDP8wYubgXs4Mk5sean
18166	payment	1397	1397	1678	1	1	8271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLe2vfv86DSgQr6SngNJ1km9yKsef9kNoqtP1Rwj37b9zKjeJ
18167	payment	1726	1726	1874	1	1	7469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKoATiR5L9vUVwhPBrmvvRuCxB25yjdCyFYV4pWJ5uY8EqbCZ
18182	payment	1397	1397	1678	1	1	8279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9WivDycwLzgZ8HWDREftrSyvkSuWUNx3UhupC8zH6YyQqSiT
18183	payment	1726	1726	1874	1	1	7477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGABPtYHZdt9MmVjiXBxwwcYTtwKt7jJsfAGdhRkBUH8gDQ1ah
18188	payment	1397	1397	1678	1	1	8282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1WF2ESd2N4A8X9RHrhMha1FngZ5Eof3unRqn5J3prxSkaoRr
18189	payment	1397	1397	1678	1	1	8283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmAuQ5gQ8hSRky2TmCN3TZz5VNEEwZUADF4DicZhpSMadaKn2
18190	payment	1397	1397	1678	1	1	8284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26irjc12KgUTLPksXxW987XP7gssHygjvCw3EnotZupmkjwie
18191	payment	1726	1726	1874	1	1	7480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3X2apj39TRruqCKAdoPnJAxqHGwL8CgqzSJQk1nsnkpkjFf7i
18192	payment	1726	1726	1874	1	1	7481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TQXPdJvcQCouNqpZmqXi8snRLX3LS5xXY6suhDo7MPUj3psz
18193	payment	1726	1726	1874	1	1	7482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQReasaePnG13cTGhwsF8AWUQw2LALCp273iMfoAGkm7YFnA7
18199	payment	1397	1397	1678	1	1	8287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh1sKen86rcSW9oY7CsTC1zRjLgNvdJYqHwa4iBXhRmxRyFbX
18200	payment	1726	1726	1874	1	1	7485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFheiAkFRR7btYn2aB9zi6djyeocX5tuZ51B73nBHbvf3erG2
18220	delegation	2085	2085	1483	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAQpJngBzGUcWXLS75hcpCwuhJ1JzgXAVFss3P6eT2WKxCyZ2
18221	payment	1397	1397	1678	1	1	8296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiG6rJAsYLMKu2NWMEMFMB24BmrfMGwgm1jQAYaX7USSPKhVj
18235	payment	1397	1397	1678	1	1	8303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CjdTCVzt6sZkhF39GcRd79ujRCRy7JUF1UKdks2bp6rVvmFq
18236	payment	1726	1726	1874	1	1	7501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQVos2PGXrkTd7pRJpySEeANP1rV4iCi4ZmBM7e7BWfnuT2D8
18243	payment	1397	1397	1678	1	1	8307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3c5SDoRbVSs8CoGN48jmPWXt7eToKgPWxXm2pfTNRu9t4U4Bm
18244	payment	1726	1726	1874	1	1	7505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBQg4hmeaddDaT3epzDb6Jfj1mjP514DqTZUGavFVFragCNkn
18245	payment	1397	1397	1678	1	1	8308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3jov7K4Pene5x7iHcbaDrAweLEVPfgawNuiVd6K93mrVqF3f
18246	payment	1726	1726	1874	1	1	7506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJHLwtoaEoshKmtjSjpVfTomfWNgFpDvdkDHyaWe6zg3HbwAi
18259	payment	1397	1397	1678	1	1	8315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4VcERaZnmozUCyogWRCxYDcLJy89LaAfqR6W7XNWsMgHiJtb
18260	payment	1397	1397	1678	1	1	8316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdo4s7RGA5DXDibgbBNJhrgRGr7vtrdnNrVJBcMWZim7w3F7Ws
18261	payment	1726	1726	1874	1	1	7513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7m1eTBDaWn9jtAbZTrhT6WJ3nPhmU5vN8wanEHBKkBaqutXmo
18111	payment	1397	1397	1678	1	1	8244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSiEdFTTwj2iCvjPtsp7g9WCJeB4amomo7a7sr1G4yePLFoe9
18112	payment	1726	1726	1874	1	1	7441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5Em8s5u8YBioSntEbyG7S6jGicmT7rvQvG3NxYRyjcrjZSmV
18119	payment	1397	1397	1678	1	1	8248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHKSdT56HCXRf9R8YYPvVzWsDSUmcCBKRMXnPx8FGfBPzEaRp
18120	payment	1726	1726	1874	1	1	7445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26e6s84K8FQ5iZ82ejEwNSooGPRxeAzVJpfvLThvDKtGwanwC
18127	payment	1397	1397	1678	1	1	8252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKFHN68JDUG9Te1bKBwfCNbqwRTarrzhmfDH1yepzWfiWaXz4
18128	payment	1726	1726	1874	1	1	7449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJiBnUjawbzLQqqjDeZkMNtT2BS9PyM6U2XGRSZBFU9Rx6cBc
18129	payment	1397	1397	1678	1	1	8253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSh1yKwH6UmqDdkFbzULfWKptzK3cqM6hZeWtqHLatYX6F2nH
18130	payment	1726	1726	1874	1	1	7450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWD2UeNHHEzEV5ZgijdJXsxKDXzeYQ9kwRTWJteafpsS2a4g8m
18136	payment	1397	1397	1678	1	1	8256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMJ8jt2563nHicNHcUna6ozZktbBgTJpetA7kHsqhuDmqRFTn
18137	payment	1726	1726	1874	1	1	7454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuxDGKyErhW62RJuyUxe3ok3aGqYMEUnQRa7JWRpCJ7sWwFMt
18168	payment	1397	1397	1678	1	1	8272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucELk1FJeju3VNKbuQMpL4e5w3D1FnuNki6JQ5iQ3HvqVQofp
18169	payment	1726	1726	1874	1	1	7470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVmEk9mB8WmX3YXJkjdZp48D2u9sZfUHihATP1W35KNigQ882
18174	payment	1397	1397	1678	1	1	8275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRu1G4c46dDiWau2icEGJUSSjPZDADnEuy2uJMac7pwxvJc8XN
18175	payment	1726	1726	1874	1	1	7473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQucGZQafmYcADpETPewuDymbjuscMGJ3nAShySJVDyt3Gbq52
18176	payment	1397	1397	1678	1	1	8276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ6fjdFGfS1eM9ZmEo4422x1wWsBZBiUDgunj6RuLJizHPcYW
18177	payment	1726	1726	1874	1	1	7474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtm3JXzcFcEJYspBpVAjWFy7gVBi4GbfnJR5YLHYacc1ZiqGn
18184	payment	1397	1397	1678	1	1	8280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWv8nCikn1Wv8YJ7eU1VZGeZRPu7EorkQatcuTqW8pdW8Ydy2z
18185	payment	1726	1726	1874	1	1	7478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPbxPptqMfMaKgNyHkbMZcQHdR7omSR6MNYnssQy1m6oj9Eix
18201	payment	1397	1397	1678	1	1	8288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TyvnY51sLHckMviUV5dVoaosxznAEqXJSzveJrt3kDCmGR6P
18202	payment	1726	1726	1874	1	1	7486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pWLdTSZdV2G5aTCXBDYZ3dig8TRFHRGrxZCUakSZZRhKCt67
18207	payment	1397	1397	1678	1	1	8291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos8SexGj2wXRWPd8ps44EWH5XHpWtMVsNpHLGxtpTy7wWNZib
18208	payment	1397	1397	1678	1	1	8292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcht9Bsja4ip6GEiXuNxr5EQ66KZrxSW2NNNo3ujib9257GVs
18209	payment	2085	2085	606	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbckA1RbDtMov1s7YgVKRDzi3XKXMsy6pgeNRSXFbGXJgxd7r
18210	payment	1726	1726	1874	1	1	7489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziHaBRLi3uwog2rCDgTxsQBYDtEEHxnSGe452nqj6tpZGT9K7
18211	payment	1726	1726	1874	1	1	7490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3DDkpvdS85y8uxNQEQ4hbU4yE2k78ZBj787mAqa3JQGnbywL
18217	payment	1397	1397	1678	1	1	8295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1AoFhb7DJaoj6HT9TLWhR4bxBxR8nJynjmW9vB96aAEAfqbv
18218	delegation	1926	1926	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGtGFsMCzs6qTapEbCNFJFQ8dxc6WooDMN4r6ma22F7Mv56vU
18219	payment	1726	1726	1874	1	1	7493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeN7rFbXhzcNs4C9rTKYwrva7YcKqiMhVnxzTbWCDYaVkbAfB
18222	payment	1397	1397	1678	1	1	8297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iate8DzNu8vbxGtt8TDYwMPx1vePvhaeRVtkwizzczdRpuxy
18223	payment	1397	1397	1678	1	1	8298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU1kbMhhxWZFUzUHhj7J7QvgvGow95v6h7Y82848CfDya6f4r
18224	payment	1397	1397	1678	1	1	8299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRb5HWXx8A22ELc8cn9V4FBCoYZJDvdYwe5ZkiGF1UQorjdnn
18225	payment	1726	1726	1874	1	1	7494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vDMpe2j3xvJD7HA8vck6SBZLL55rvQ3ivawJvSNqedqaDcMf
18226	payment	1726	1726	1874	1	1	7495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtMJxuLrbhhZ63U7dnfykikiBrFax6p348sSG2TyivHPTB2mQ
18227	payment	1726	1726	1874	1	1	7496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQtGNH1ZRKp4qt86FtQCgay5p56VNkABcQnyxNG3MUewWpmcU
18228	payment	1726	1726	1874	1	1	7497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoL4d8zbdHnZBkXeEBJiNnDnwhjkFPnCkHXtATb5VVfDHbkPMW
18229	payment	1397	1397	1678	1	1	8300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwrMar7Vti3vJ8Bh5hbj8p2sceZixM8Z6fMEvhBE8E9hAH1Kp
18230	payment	1726	1726	1874	1	1	7498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKz6Q4zht9bXpPkZfMMKioXTNGfqmLpuxTDfoSZ4GgRASeZpG
18233	payment	1397	1397	1678	1	1	8302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST1SmS6Azj85HRnJpAKXSg1BW3DeiedBorJ82QASpRcCTXQie
18160	payment	1397	1397	1678	1	1	8269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpvnZmL2wSgCQEzzEbCJR76xcVSxSRJkDYrtYLML431jWKCPy
18161	payment	1726	1726	1874	1	1	7465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqpM1ujgY5uhBULZtPMN6m3nK5vTe8AHSCi7UQdFuTifmwJnS
18162	payment	1726	1726	1874	1	1	7466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2S9wrVBrYvF9TrqXReM8xqtaHhFTMzV8hHs4nSbbU3NpDqRP
18163	payment	1726	1726	1874	1	1	7467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa397GTX2vshJ28uCDdUq5bpYEVNhNPvz3Ss5tyVRv4FRKCqnno
18164	payment	1397	1397	1678	1	1	8270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwRMkrNoKpwFQnVTFqhtRVcHwVb6uS74VnBYxrVEeRWZjNRTC
18165	payment	1726	1726	1874	1	1	7468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPTeeqLBPuJvBM8QPRhCePpJzTkZgemtkRoD81jWH7gXNQcUq
18170	payment	1397	1397	1678	1	1	8273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CABodF1uiJmgzEKDB1rK1TNTiTrZZxFFWhcrNRAY5wjLe7sD
18171	payment	1397	1397	1678	1	1	8274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYGQ9MHc1LuKqC2uuvoYDWNZEPDNNqqQq4MwyvpBmXmnVw2jR
18172	payment	1726	1726	1874	1	1	7471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbowXULBRTQpkpx2tHXxhpim654SMm6ZnD6CtGi62E6yXKhh2p
18173	payment	1726	1726	1874	1	1	7472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8fniVPMh65u8MG11T9vQ3Bg2EnhV24x84H23FT9asy6nFbdx
18178	payment	1397	1397	1678	1	1	8277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLJhXmDhjUd4wb92tdmYokLzk2i8AFBmmktvkb9mH1W399FCn
18179	payment	1397	1397	1678	1	1	8278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcE5rwNV1o9QJrrZQ1W7SutgAv1h7h2DHUokJsHybiRnYN7SwP
18180	payment	1726	1726	1874	1	1	7475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugfGk8VFbUW3ArDQ8QamwKHmMpr9EqHAZxyU422NT8JaxoL42
18181	payment	1726	1726	1874	1	1	7476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfRXWYtEAHXV9Xo6bQCEK2QXPGMwbUTEPfF7z3VvbFxDkwKqN
18186	payment	1397	1397	1678	1	1	8281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRp4HxozmqqgcVZbxgVAVHVsZFQ8XFfnSc91yDkSTDisHsNq3
18187	payment	1726	1726	1874	1	1	7479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpzXTcqUFxqj4aTLXuXqcRm6CKbmbTkYTWdBxjyXBRv1ee9ha
18194	payment	1397	1397	1678	1	1	8285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3yiL5gUXheaQRRKNcRCgvK1bEGQxLQiytrHENFM9HzZYJcmm
18195	payment	1726	1726	1874	1	1	7483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGejmjQK3aUMLDThVQW5YnUjehp8oZvpCm1vpSntegCuR9xBUA
18212	payment	1397	1397	1678	1	1	8293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJLB6KCaVFwhp8uaxZFTspWygLrNzBedwsTZvY9Z4hQeGLnK9
18213	payment	1726	1726	1874	1	1	7491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqa7gjeEyuJZDs3LqUu8MXnsqBZYhitdb5CeQd5FU9ynW6KXT
18214	payment	1397	1397	1678	1	1	8294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdgZ3gV6Ydh7JzxrehjrvFbqfR5TphdSWCSM5oKQC4D1VVJJQ
18215	payment	606	606	2085	1	1	11	1100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKYEKFRQstjRTEAPxLjwZXcr2mwKsqSiieMN93Nko2AkAWRoC
18216	payment	1726	1726	1874	1	1	7492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRCtfqgumWhHwEh6jcYFQiof6XuBEgPxMSyrQXMnms9ngYpfx
18231	payment	1397	1397	1678	1	1	8301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQnDXSCZ2VyQRNEubmbuzukma4ZYyouhZrwapqTcGDAJoCeaj
18232	payment	1726	1726	1874	1	1	7499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UdAebyETzvRgs5QcaGHUFHvCmQ151aBXRRtcUnKnTsf3cUjM
18237	payment	1397	1397	1678	1	1	8304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxPAPRPeN56Np8fs7DxBm4Gx5ZXRsFXV3NFaYgdy9y2nJ372b
18238	payment	1397	1397	1678	1	1	8305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofLCEGkHLczcSjieYq8YHPeC9yTJ9HPCxJKG7nbjiexJzjKTx
18239	payment	1726	1726	1874	1	1	7502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9bUR4omQD6XRetyCaD61g3tVmgb6LFTvaJiquauNvNcFL6tt
18240	payment	1726	1726	1874	1	1	7503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8A6VjW6ZvHPH2e8viLjcDp2iuebF2Kq2d5n9dpda87L5iMZC
18251	payment	1397	1397	1678	1	1	8311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkg6AvoXsciEKNNZqtckkVsmjXvrZ1jUvtxqRNWyQCp5euAy7J
18252	payment	1397	1397	1678	1	1	8312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYvxzNrHKXtoUGGusQc9yeo937Hmj4CLnjKbGwqPCvkKH2Lmx
18253	payment	1397	1397	1678	1	1	8313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUEsKtwuzkNfEGAEHBfJwkfhagDgFwzBWUcoTDGwowF7V8ycT
18254	payment	1726	1726	1874	1	1	7509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBasbpdNYZS9Qx69PHi5uTA5jA5WhzaaHY8MfQK71pqenkSZbp
18255	payment	1726	1726	1874	1	1	7510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4FZMqLdexWNJ1QVwuHqr5FrJmrypNic4KsRYGQE4Rg11MMSv
18256	payment	1726	1726	1874	1	1	7511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaBb7w36ESYCZb8qAC5sLD5fKXh8XdLKuBVAWprkk2mFfjxEx
18263	payment	1726	1726	1874	1	1	7515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcpoo7tHRM13N2z3qBeFiSfgeW8dEtZPY5Vuh5tj6Wa9GUtE9
18282	payment	1397	1397	1678	1	1	8326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAag4ottjQYM1Evd8ioWE6V7BxdxhpXeTxwo9pE3bUC9yzhoGe
18283	payment	1726	1726	1874	1	1	7524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkfGLhqD1S4MNF9ruS4DkM25mRB6XpeLjiJVW48nm4f5n3KBY
18196	payment	1397	1397	1678	1	1	8286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FeefFa75nBWShpWuSSdQkWJGd72tveXc5jzschuEET33B8RY
18197	delegation	341	341	532	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcwq7k7WnLiLJ6GJAW26mfDKXncPw4nE7yLQiKpMaNnatg8K4
18198	payment	1726	1726	1874	1	1	7484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoDVAbF5WTpcZPgSsDtZCQuuNmULTJiFigH83umQJPoV67VYa
18203	payment	1397	1397	1678	1	1	8289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU48unJ1y9veCkRY1poxVbLNhAwZUhrdJKEDJRLCCH61Bhz3fD
18204	payment	1397	1397	1678	1	1	8290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxUDLLZLaCM8GUrkV9THeSKu9ZxXcGFvCn6j9kGo7hCz741kV
18205	payment	1726	1726	1874	1	1	7487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGydgPiG9ogM5uEBCPPrA3STj6p1iNKTUiGXmjAXxbG2nrgW3W
18206	payment	1726	1726	1874	1	1	7488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarrFYrEomB24pbCXHnAB6AekBRVgiaAyjg14zJiv6vVjDgTe3
18264	payment	1397	1397	1678	1	1	8317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YxtEaK1ycnsub85ieGT1XARud7csCDsuE34QZ9eCpZkG57a7
18277	payment	1397	1397	1678	1	1	8324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7s1qN7NZZBRbdcXxYXPwDUBh6KbrXsc1JVz7AK34opPWN5oj
18278	payment	1726	1726	1874	1	1	7522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCakdXMsmCeEQMVqDRp5bsD8PppgkqtYYatJQDo7DK9NPJhWi
18279	payment	1970	1970	2114	1	1	0	100000000	1000000	\N	E4YXdVUAfyak3PB79YwmjnS3rTmv2hnNrRBzPFVWK9jsHuj9Q78Nj	CkpZiTNRbkdJGwyAecTYX8hgeSeEnwbgenpYb8NV5Y7REcxwSydH8
18292	payment	1397	1397	1678	1	1	8331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBEdCoWienkdMyuu5LkRvMKQ23GBhWfV7fyN6UjAiS1xQYUqN
18293	payment	1726	1726	1874	1	1	7529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZBLZDmYCW6eyeS1hUrT6vAkrb1KS74p2hPRYuWKMWA9F9QoN
18294	payment	1397	1397	1678	1	1	8332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjnPjherZcg3yYPC5JcUk4KuD3qmsvxW8w6kXUKN7SkH9tsqT
18295	payment	1726	1726	1874	1	1	7530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEE1mdRVaFUSxFXJ8XTP5RJCd5HxzVPJM39jAwBdBQWj3Vdmj
18296	payment	1397	1397	1678	1	1	8333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDomX58G2a5QZTbvuYLfi5umXoFgzZzRJPojAtoN6c9cgicwJH
18297	payment	1397	1397	1678	1	1	8334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQbW2CBMpVXYdVvUnUcNbAam5NriQDdZ5LYwUi4YpDwUNLwyv
18298	payment	1397	1397	1678	1	1	8335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJKgESPqYUztV2W7CQjidnjfFMNtUMnxTGP1Sb3qEd4vwX778
18299	payment	1397	1397	1678	1	1	8336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSn4HvHTBsj2T1kJ7pmASAkwHuTXsp8CQTqQ2PJpVQVPb2yaP
18300	payment	1726	1726	1874	1	1	7531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboiRHMDN4hpJ2db2iDToX3eYEFHdicAkc7TuvXK4EgCyh4uMU
18301	payment	1726	1726	1874	1	1	7532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGmY9uTuvaXzQYF3L85Bdge6vpCMtabT8jr181RaaVEjra1HH
18302	payment	1726	1726	1874	1	1	7533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvPJof9fNBFFrfS5uYaNCtGuAm32WRX8Q7EhaV57CzeHcj3EM
18303	payment	1726	1726	1874	1	1	7534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLk7pZL45t1xnm6CNFHvYzmjawtrSRKHXatJpt47LLhtq2T3Xb
18306	payment	1397	1397	1678	1	1	8338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH9TrJbPEgwEdZRHFWbyymReodJxU9MbfRinJnFrNsh7jtp5M
18307	payment	1726	1726	1874	1	1	7536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeypV5Qx9x7oQ7Keykn8eYBwNGtgRyUQm65XjibsFk6pGRGYk
18319	payment	1397	1397	1678	1	1	8344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3KjEDFszbYrumnQ5LpWHk734RmwQiHzUuWmNrio46P178mno
18320	payment	1726	1726	1874	1	1	7542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYfnpMgcKGA5fBr5w6QYchvCXGbUnxzSxFBK5abjWGNFZauXs
18328	payment	1397	1397	1678	1	1	8347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA79y4oACH74i3rarLKgLsq26SPAKC7NgZAm2RzJX27F1cndPv
18329	payment	1726	1726	1874	1	1	7547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65DPEqgYE5mqxNTiw4Q67ABF4575PjerKsytDPGnTWx97hbQ4
18330	payment	1726	1726	1874	1	1	7548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBTTMLc8GE1wZXvC9vYNKVrxcUkYzUEdtPwj59kU3JUmhuzLU
18331	payment	1726	1726	1874	1	1	7549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvCXZh2T6pdWofkbLTWm2SCvmqSc3wjBucx5obf7SJU9kjTLR
18344	payment	1397	1397	1678	1	1	8351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDmo3joXSMfZiX829p5czKkCLxNPUTfA9qSorHeoQHo5XkFhV
18345	payment	1726	1726	1874	1	1	7559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9LbGwheFfeypCvNFhzSrZWL1epxUP6YgfA2tM7M9gvj2Kkkw
18346	payment	395	395	1760	1	1	1	500010000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNgo93k9ko48ctgrUT4jRdbLjwp4hY6vALZNMDsruPAAo26Tz
18347	payment	1726	1726	1874	1	1	7560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRhKjNBVqLMbFnm5As5NPEcPhijWyd2jgWGn6mqbo4ZArDDV1
18348	payment	1726	1726	1874	1	1	7561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ8v6bf1QKivcjJK88cBkRiSHv6ebKdiWoY4P9SSXYCe35Qo8
18352	payment	1726	1726	1874	1	1	7564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYQXYTBkFGBq8chytJHy3NA44gbDCsoQouZRXYLGxpGQ4MGbK
18353	payment	1726	1726	1874	1	1	7565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfUSywgy8ubLm3GsRNotbvDiDTmbauoYMLqqS2w3cSdJrf51J
18234	payment	1726	1726	1874	1	1	7500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2NMmRFQUha4UuvoT86h2eusYh7qXfUFsvTkoL5CyaoaAbeYZ
18241	payment	1397	1397	1678	1	1	8306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7J76yB9coLmmvQFuZEQGaGoFYUXF9g3iXTLwKdy9629gAvRn
18242	payment	1726	1726	1874	1	1	7504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AsjjwGP5zwMie26Hc6r5Z4YTr3tcpoFtJkywystHEx3owYqm
18247	payment	1397	1397	1678	1	1	8309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoeNni2xYBg8ZvoknJ1CvMWhfprAzizjGi8ZzNUhyv8aCfydc
18248	payment	1397	1397	1678	1	1	8310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgNUBBPaefsejzYVJcqeK7XxKCSxC39qyhpHufJAvzmpT2y4k
18249	payment	1726	1726	1874	1	1	7507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rC5LrDFtN4oyDPQeviQMX83vTeh1ovtsh6cb63VVk43eZkvi
18250	payment	1726	1726	1874	1	1	7508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3u5YgAe5HACssYJm7X364FGJaHKyGrptkcVhxeFmmpo7F5TDR
18257	payment	1397	1397	1678	1	1	8314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjiDLDvqDFn5qAMp6XPmXLTV2kRoFMxviLNcHVYNTNyJnQ51C
18258	payment	1726	1726	1874	1	1	7512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBHUbJ7FGwEbttQ6xqFP2eVyjzgXEVinAinihJgnGkMkPwpwp
18265	payment	1397	1397	1678	1	1	8318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbVsGB8qyfayGwXVTrBrZnt2UDJtvSfswXrB9bPNY8FJPNCaB
18266	payment	1726	1726	1874	1	1	7516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KZUcbag6GXjs4KjCqJiQUhkYPHqqDf3EenJ1kBMXDxibYv4U
18280	payment	1397	1397	1678	1	1	8325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyKsDGb9JtMYqoKf9G1ma9cRpZU88t5TNTha2t2GULf3BE8PB
18281	payment	1726	1726	1874	1	1	7523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZem3QiS4m4TsBVWqHiSFcPEYt2ggZicMMJocH9sw2e42bkhPbh
18310	payment	1397	1397	1678	1	1	8340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnoWXFoQWF2Mpbrfh1wRWfGWdarc29sAMAiCCmZ93MLrhU5Cf
18311	payment	1726	1726	1874	1	1	7538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYiTajpT949dLRibJRtrowD5X7E2Haiymk3MXPvy85jbKQkdW
18364	payment	1397	1397	1678	1	1	8353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1HvND3BMUV7sL6sysJvuA8vYZPN8cHPtkLTRW8Hv7G87LBz1
18365	payment	1397	1397	1678	1	1	8354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AabrEqVLA659EwpbPyz4HUC9UBefwNvKobsdgTYN9LLgoGHq
18366	payment	1397	1397	1678	1	1	8355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvKJ3Kgk3Du89MkBUtEZZvxDRJcykpFi97Fspp3eZx5tcHhXk
18367	payment	1397	1397	1678	1	1	8356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm63p77AGZaLabtzcUrShUCENjSWe2CBSX4CqnewgdGybZ6Ls
18368	payment	1397	1397	1678	1	1	8357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbmVGNT24hh9t1UCnrTWTcG7Y5bWr9wUqP792jPxwnM9vqJxX
18369	payment	1397	1397	1678	1	1	8358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn7B6LHHUUBSDRPvUnwaCiZdry8gyoG5sKfr3tFshpTdsPhom
18370	payment	1726	1726	1874	1	1	7576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShEoyNpPh5i7hNuoAhi3C6gSJYgm1oty9kxPDEPpxDFzFuxJZ
18371	payment	1726	1726	1874	1	1	7577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CabvXhxifCTu9ZwvWi5uv7dcE9CXmMbUUHFkUb5R81GXnSqd
18372	payment	1726	1726	1874	1	1	7578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrjdWtFv31h7MYcrC8ec8fyhQeg5c97R2aA186rJU1d7Xw1PH
18373	payment	1726	1726	1874	1	1	7579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJucrsaN6RxNaQWNqiJpH2nbqF2nABCnbeGn6RphMY8qnfw7Q
18374	payment	1726	1726	1874	1	1	7580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbnmEeV1GE2QYSXb7c6urcTvFhoboicJe5UMUEJqhbtqAUP7G
18375	payment	1726	1726	1874	1	1	7581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NGtoXx1WWkQQfRecphxciMTth5AjamL2xtHT8xtFqAED3njw
18400	payment	1397	1397	1678	1	1	8365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrvsFatyNY9y1XNu6uMujFhLGrL6paaMsMBDgDFFDvKhKeBVY
18401	payment	1726	1726	1874	1	1	7600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeXZrGvbYnQGzQfYqVqtpxnnSionsHKuMTm1RE9QEQsxwSkTu
18402	payment	1726	1726	1874	1	1	7601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdL21B8X1nygfbUTCGAUoFNLuU9m9SRD32X1ZoGBJiy58jD5i
18412	payment	1397	1397	1678	1	1	8369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9m9HeJjw6KRVVKVKTaoEXnVgWYFKBUaWhgTvr9ZsW1VWrmmvw
18413	payment	1726	1726	1874	1	1	7608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbJY7TCZux4RwoxVnde5QrAcrSQaPcgGeWrGN8yd4Mswy76Zx
18445	payment	1397	1397	1678	1	1	8381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiWXfqVSwhaFMZDoVe3bSskg39SwTETZLnvRqtvdfev9uXraV
18446	delegation	2114	2114	1970	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8ifv1DxELpp4xPz7gT5SQP1TEdQZ4RJHWeJ2UfrfnFKWWTri
18447	payment	1726	1726	1874	1	1	7629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTWWzWT93FqZ9DvAjF9L7zmquQkjM7Ssevz9xPTvysRHDLTgp
18448	payment	1397	1397	1678	1	1	8382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP7AF3qi1zL1aBqmCjBmcaAcib6xz17DuN6ong58KSp9M1Msh
18454	payment	1397	1397	1678	1	1	8385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTaC7bigMbKEFX3WuMLqYhJQbnuychR8RkbLrc9VeYM1EaKQQ
18455	payment	1726	1726	1874	1	1	7633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezTwHJPNuaF3YmW8A7wxAYCkUAt8tbMDdyhx8eshg8rCGqypf
18262	payment	1726	1726	1874	1	1	7514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8M4o7UdsvNy55jC1VcTRZD4Zhgw8WCqqQ2nVd2vj4KijpkSbr
18267	payment	1397	1397	1678	1	1	8319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XfHYnQ5EWttaYqE94tscBS3HTKARmQaNDmB32s2ztLRozvbV
18268	payment	1726	1726	1874	1	1	7517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ342i1FJjYipD6uXyDQNXo6eu2H6ZsEPogTeSx2MsrdtM3vHCR
18269	payment	1397	1397	1678	1	1	8320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSerktMjKtxdRdgtQnLErDTvWsaFqo4a3oCsQWfw1Nn2oXb5A
18270	payment	1397	1397	1678	1	1	8321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFfRF6NUFXRpjiJGJwxmSp5zmrQCgnkThrJprHxZoQwZBN1C9
18271	payment	1397	1397	1678	1	1	8322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHiYCy5g7qMvxwpRL5fJXHANzgL4LBJ2JKTi8WZ6YdQPadn2q
18272	payment	1397	1397	1678	1	1	8323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj9Qos4yetTLzWue7bb1btf7zDvpUtVXLH9h5CTF4UFn319ty
18273	payment	1726	1726	1874	1	1	7518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtraWRoaD1eHAhnFpxAW2zHQVG5Shn3HTd7VCczvoczwZpr2Wd
18274	payment	1726	1726	1874	1	1	7519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dk29JXwCaweDPSu5HnwFwsKuUEX7TsaZY66szbW9KbaTcasR
18275	payment	1726	1726	1874	1	1	7520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SFAHMgHewdYGGrtZ96YnoT1ZQtuvFcnshBUeJdfBnEbak3je
18276	payment	1726	1726	1874	1	1	7521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifsV1c4AFmGizjpFvFEpT7353sy5yM9xXEpoTWTcxxQ8FzLVz
18332	payment	1397	1397	1678	1	1	8348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyw2eRw45MQJs9WNcizm9eBZ6htFZfKfi6rr6cP9sUFkVx3aB
18333	payment	1726	1726	1874	1	1	7550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrJ8kX5vBMa1T59JaGPXsiXboZw358M9LDYkqD6Qp19W2CD2L
18334	payment	1726	1726	1874	1	1	7551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpQJHHpPEgqCmHurCLRBPVauDAAZre7XmTMQESfnVu6GX5gEK
18349	payment	1397	1397	1678	1	1	8352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4qFBkP6ZYGHv2vKL6ZWBhG1hxMFdFbtup2PPg1JnF6TWpqWJ
18350	payment	1726	1726	1874	1	1	7562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayJTHQJ5ga5eQ8SYtmViEdJ34eHSYra7WEm1nM6gsVatDKWVx
18351	payment	1726	1726	1874	1	1	7563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCszZdrMhsnQutFL4mpwGBzLDmHUyLmSD7Bz6FwvPCNWpUu9p
18376	payment	1397	1397	1678	1	1	8359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwALjLxtuYF6dJE6j4oYYXRTpAvsKH6mYNABtzeXhELRZ4YaX6
18377	payment	1726	1726	1874	1	1	7582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdUQowpMa5DX9Mw3TN7Kkm8kB1YNwBcCGzB3Dac1BWVwfH4Ea
18378	payment	1726	1726	1874	1	1	7583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWPvCWT3H8f2cNE9CNEnwpqp2trvYRSykYB31fNQHHK8dZFmn
18379	payment	1726	1726	1874	1	1	7584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58wB3xrVHB5LCGv5MhdkNPk8XXNZtqeyKE3dXUv4hcDV73Fs4
18418	payment	1397	1397	1678	1	1	8371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMDZMWtsFKEUfasoz7erpRuS3X2BKgT9XpqkxRd6UzVaMY6qZ
18419	payment	1726	1726	1874	1	1	7612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZage7m59w92RapUFaAccFXzqUgFeJVW33fQu9c3wPPvxMadDW
18420	payment	1726	1726	1874	1	1	7613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGCEZCBf1wrWWuMofmTBJtyv8z4nRfn5swJD8pyeT1SETiciR
18421	payment	1726	1726	1874	1	1	7614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLg5JCkASsmZgWftcrdUhZ5SSKpEd1ZN41HSuagyMHksX6T4j
18449	payment	1397	1397	1678	1	1	8383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XdepvFRMMY27t39QtfNG4xdhTuQXUjotKCBuFg4PSE5eqPLe
18450	payment	1726	1726	1874	1	1	7630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXZKcBDZeTa3ibWTTi2akzsLHeDqD281VY5HJxssD1qk9Mr8G
18451	payment	1726	1726	1874	1	1	7631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzizZbXJMtkBq3jLJUSLgebjch7oGJQf3XaETmJpgrFLSvFc4
18506	payment	1397	1397	1678	1	1	8408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehyWsLAgAQPZS1nEd1oZxWia4iXGgp42YQJWjPA5UbXNUf2y8
18507	payment	1726	1726	1874	1	1	7662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVKc2hFtxCZ9h7vbCBB2eZtT6AVFVb4BsERW9fbADPKxkRxMB
18508	payment	1726	1726	1874	1	1	7663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBX3VgN1NEqdJeyHnNhajwJpW4zTJSzxm4pwdphZSLJ1ixjYG
18513	payment	1397	1397	1678	1	1	8411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZquqdnK9Tqf9e6soD9PUhyA1x2Ms8iyMWADGYL8LsX1GPcHi
18514	payment	1726	1726	1874	1	1	7666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz5WWNcaiRJ2ftd1FWGS5BC1Y8hmHt2Gcd4xAQqKyoSey47Rs
18515	payment	1726	1726	1874	1	1	7667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtbkcYksnJVsmE3qmRNZC3rZFqKBjuGEmgDMN986Ln6a43pDH
18524	payment	1397	1397	1678	1	1	8415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpY7DG5fCTy2F4ZgMMffbj3xWAfgPn776tk1YeRzB1fjZYBMz
18525	payment	1726	1726	1874	1	1	7673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC7KCGoijXCz9ix9LYSWsUQpY8LCh76pVP8yg1oMwToVMbauv
18526	payment	1397	1397	1678	1	1	8416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmV8zNssHyGsEM3fFvdAdMt31BCXajzXuumW9puzZvdTrNaYYL
18527	payment	1726	1726	1874	1	1	7674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrZSRHJRMCxSQgPksFs54AWB9vr1zASUMs8DGiJgh84gT9xor
18284	payment	1397	1397	1678	1	1	8327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7cjpwZiwi5PPXBZcz7U92TALC2vByyqmtKhNkXB2kRovkzE1
18285	payment	1397	1397	1678	1	1	8328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjBmRJHqoZutVrKLVQmGyXDzsr3ZQgaQs4bjZ8ZiiTzTDbJyg
18286	payment	1397	1397	1678	1	1	8329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjr9RmkZZH8TUD9L3pVvks5d3auPsZRDwhxoNA8C7gt26koVG
18287	payment	1726	1726	1874	1	1	7525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvrpiR1UBiVPnP8zK7osytddMRYzyqtTX46m3urmUMFK6xnpR
18288	payment	1726	1726	1874	1	1	7526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruJTEx7TUFePJhmjmDHpcEnWaJqCxC5RRzQKsxakWzjiofCrR
18289	payment	1726	1726	1874	1	1	7527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgdFpMCiRuysnyVP2zDejaJw5whFFsv18yDhvCUQayXU1hEoQ
18290	payment	1397	1397	1678	1	1	8330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTjswCTdEHxgEteVADmzdwDXDucgFHfYLjtUr9kQKfYN4Qcej
18291	payment	1726	1726	1874	1	1	7528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaeGFJRMCN1ouQbrmTALYnZEUYxtAHfAtApC4mo9XNFTdUxjf
18304	payment	1397	1397	1678	1	1	8337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8A5wvAJWoxhg3nBKjpAnstTRA9VsAcoGh22G8mtasojQPULJW
18305	payment	1726	1726	1874	1	1	7535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyGGWQaaos5tv6VPMtPqZwcKEstaB4EfnkNo5sYTVMKUNqeQ8
18308	payment	1397	1397	1678	1	1	8339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsff1HseFf9QQAxDZP2XfZvVLZC9sXLwhuH3JGTktLPZbvmPg
18309	payment	1726	1726	1874	1	1	7537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXZWDN8qWLrdtkFr7MMujnDnZWqvZ85P4RRA2Ba9tSEzixPzB
18312	payment	1705	1705	2115	1	1	18	2000000000	20000000	\N	E4YdNRyrfKF6tz4UgQhdLmQQGXbEZe3sgWksofaqmhFRoJ9d8CTVp	CkpaFxupCRgxmqyr58ajkQCpY1oR4SHSftWVfCibWMB6uoWCs4Ymn
18313	payment	1397	1397	1678	1	1	8341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11b8Z9uyFWK2n3QWB1FF3U5fJ4XhFTA2LiPU2DHqunDEvWpR6
18314	payment	1397	1397	1678	1	1	8342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3fFe8ErPkhxm19tsg4zsBoqxbdnetLda6odN5FEWJm9AHLTr
18315	payment	1397	1397	1678	1	1	8343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjaZm9zZqwrCbaTTN3d3YY8ULAJrasXRURDR9j1LrqMMPWcCw
18316	payment	1726	1726	1874	1	1	7539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodxwxKNTZ754RZo7NR1NmGy7FH8V9tPgVQdT9p2DP3TLkaXgK
18317	payment	1726	1726	1874	1	1	7540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQw3YmAyM9PfiWBZUyFa6k45DLaAv9Qf7a9ufFcJjsWpWYyiBT
18318	payment	1726	1726	1874	1	1	7541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjUgLxpwwtVHADXBNdj9KYfk9VUDSsA4sj7qxrhW7aHXMyFVa
18321	payment	1397	1397	1678	1	1	8345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB4rYTBaZCFvBqrJW1NXZDTVGVwwB6XHV68uq4owtL3dpFPR8
18322	payment	1397	1397	1678	1	1	8346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQyVeyJ26mCDU6fgi6MLCLAZ5HRDNvTxXELdQ7MAD8iqVkrvT
18323	payment	1726	1726	1874	1	1	7543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWY8gkJ37r7pduCMRexsSnsgnNbZuaLt2FVZ695XAod1REj1pr
18324	payment	1726	1726	1874	1	1	7544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjD9adHWHVcLRVejgCH1j42aafVC8TMcJtcQyF8AfZhU4x4Nn
18325	payment	1726	1726	1874	1	1	7545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiwPQN2Ui4F3hW69a4fftTLCy6sn5AXFd2Js6B83XapmeLTAc
18326	delegation	1950	1950	1483	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTKaaTsUeZrHhMDDWAH1GqYVMBfgsRpz4uJ1Voh43Dk3jCCdJ
18327	payment	1726	1726	1874	1	1	7546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4L8BLHU99z8rN8SnXjshZgwisAa2EUC34dDyCyEDUytEzQyNm
18335	payment	1726	1726	2114	1	1	7552	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfekDvP9S4di2evUazHYjSNPKZ481zT2kxWqbA4dkMapkkHt92
18336	payment	1726	1726	2116	1	1	7553	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWHoGJitJWPhjrTPTeoaFr9Ckoae28c8RNTxjkkLVY6o35yCSw
18337	payment	1397	1397	1678	1	1	8349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFrpLx5QcLugpYMtwG6VfGrGG8uaJB9pVo3ZyRzov3zEoMLgk
18338	payment	1397	1397	1678	1	1	8350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgAmPUThpUWFWtfpTPBWyZCLCPdAoaYviA2KK94npKmTpG1pD
18339	payment	1726	1726	1874	1	1	7554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbaYo59jQyHr6t4FfamBamdERMeMxBZegfCZ6pExQP1nRuxj5
18340	payment	1726	1726	2114	1	1	7555	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpjHb5myjjiifpJxNNwis8YP7NKcHJrd9zXvmjbjAZuYrtcSDt
18341	payment	1726	1726	1874	1	1	7556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAdyUU4nM2Mr3YPHeYHmzVkfUHWEmNrTLuTRk2v5JjofyVj2U
18342	payment	1726	1726	1874	1	1	7557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtGbJ2tWg8AWFrca7nCLxm122DidD69nwhDMCVMi8X8B3hSaq
18343	payment	1726	1726	1874	1	1	7558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXUafp5HWH6WrenhkwDfD5PnszHoH28RBgsZ52MLWxT2LcvNM
18384	payment	1397	1397	1678	1	1	8361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFi2pAdPx9AkoL36tbbkQp2GWAGkaxnr37Akds8R4ZydPQqC9g
18385	payment	1726	1726	1874	1	1	7588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ112wSiBeiBcE6JiQCbSbxWxavdvSZXFhyWYQ8CAnQdMn42WAh
18386	payment	1726	1726	1874	1	1	7589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMh9GBKNjPGYGC7xw4ZLLhrs2vi2M2KNU3VGa1S2nhtfiRLxN
18354	payment	1726	1726	1874	1	1	7566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4RsKs1v4U6pFrSJy4xvYVhrhXVw3fXE3PyWqtQgtYbAaY4jh
18355	payment	1726	1726	1874	1	1	7567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iJXUz4c3MhCR7NG2PitbSoMahLmbBUjCbqs9gZTFfqXKsxpE
18356	payment	1726	1726	1874	1	1	7568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7zyQBLQJkksLTksxa4ugjs5rnF8wzQ7gjrV52BX8EwdiQHbz
18357	payment	1726	1726	1874	1	1	7569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvGNc4Dp4vAd7DD3TUeWKTH1U4nFUWyhSQs491JK8Z3kPBU6d
18358	payment	1726	1726	1874	1	1	7570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX178crduxYRbKLo67zXZV79JS7gR7b6qdw8rp2MoydxBKJDP
18359	payment	1726	1726	1874	1	1	7571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3qxooPSfDMwAMbfaaUumnN6GmdktZ9zm9kZCgxEfXSPXiKJ2
18360	payment	1726	1726	1874	1	1	7572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2cofwU2DHq2eMy66Vdhk88SAwPHoKv4ywoRi8HwEXpEYGMid
18361	payment	1726	1726	1874	1	1	7573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaqjrApimvyuyTA9eNneQ3iuM4dUcQwGz3yqLvDA6CTVs1Mis
18362	payment	1726	1726	1874	1	1	7574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtojN1yEeAU9nC3cL7uSJAnKTXUAJZb8u1d7raZhoYpvntCMca
18363	payment	1726	1726	1874	1	1	7575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Sc4NnG9edya7tjPyC6rvK4kVyJAiBnyM65x7qu93NyN9emN
18380	payment	1397	1397	1678	1	1	8360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJstAVawg2hGwJDWwQHKyrovNNFNHjUWhw4FnrKSLTmVmkzW8
18381	payment	1726	1726	1874	1	1	7585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jJkuon3jc2oZL8Bc1D5Ahxk2oxf8jJQdsFonsGgXuxUidpN6
18382	payment	1726	1726	1874	1	1	7586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkEgCYA12ZwnG1rCMNpVU441L3tqnXYu95JnhR7AoiGMqcXnV
18383	payment	1726	1726	1874	1	1	7587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4MbtJGU6sST1v1rxYrsKevwDsDqrdiDwMJFwVEzP8fsoB7aV
18388	payment	1397	1397	1678	1	1	8362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNu36t1TJTjQMVk9AfnBzpPSRJZ25q5NAJTkNpH6Z3jCwCnstQ
18389	payment	1397	1397	1678	1	1	8363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qYW3ckEKMmnYBp8Yboh1iwDs3wJM45Vv1jGuMQzzcYxv1xNm
18390	payment	1726	1726	1874	1	1	7591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPLEdVJXufcV9p6XPMcAksVp7jnBxovVFiwKstjLxWpDHTYXQ
18391	payment	1726	1726	1874	1	1	7592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjVsYqHd6SiMuWYCdr2oKZvDVoakyw3SdCUQnCJnWccnpAUaF
18392	payment	1726	1726	1874	1	1	7593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97Mc5dtFpBXJ7UVqgpDuC68PAPxvqR2QtFmR5uEZxCyvxovXj
18393	payment	1726	1726	1874	1	1	7594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW5Kur2e8NDpt9W1k6gQXc5bHLcYHLNjDLmWmeEJ5ZXVyBPUM
18394	payment	1726	1726	1874	1	1	7595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZBMa64jCYZKko5tJPG7c2gbGRozenAdcYNqeFGLHubtmhJLT
18395	payment	1726	1726	1874	1	1	7596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqKHcfunizLSZFAUTEJw96ci89V8Ko2UycxCfU3acenG6yp988
18405	payment	1397	1397	1678	1	1	8367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWdSTEEXUt3NxRgGod5XCwNGwPCAC3p7hTHuWCxC7QZWjMtHn
18406	payment	1726	1726	1874	1	1	7603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1goiqbF6Caod4sNQG7e1nRpPijRpYkuLuTaM2ChcEobfpEefX
18407	payment	1726	1726	1874	1	1	7604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDGsQiQcsMUg6jc8bfYj5yX4HFLLGW3q1ZfU5njUMSykywc89
18408	payment	1726	1726	1874	1	1	7605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpTYfTVSKXbL6EuwsUWbZpNFyedgzoTwZv676kfogNkgMDxRt
18409	payment	1397	1397	1678	1	1	8368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mtrY4i22ptLjik7zK2hiquvVdzCqisSjYSyiJkhCZR7kwXye
18410	payment	1726	1726	1874	1	1	7606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACmkQGcW62ozxkQcdUCgYKiWsdPiBpDZCgk39fctXQo3JcmoP
18411	payment	1726	1726	1874	1	1	7607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRpue3dS6ESsdZFi8Rik2tJb7SSrRrbTt32EFPypT78bHBQ2t
18422	payment	1397	1397	1678	1	1	8372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND9Q7Q1r4F92SsMHPC4iWUgoUzbdPJBhAAePkNJhfdSzUXHmW
18423	payment	1726	1726	1874	1	1	7615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRpVadCcerVkYPAiVkMyWxWi8wUMG2hoU24ykY8K2UuZSiKwU
18424	payment	1726	1726	2117	1	1	7616	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2iRfpDDyHqfhRfs9gTTQ9TgtSQMFFcxPwanvKwqnsU4bKDA6F
18425	payment	1726	1726	1874	1	1	7617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXjgRVfncfJENcR1uKskfez5TvpndHG8LpuVSPPNDb1P85JXh
18440	payment	1397	1397	1678	1	1	8379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnLbuMPrRmK27WcmBs1GoCvhF5iWE4tzCsgFeKVXvfgovfBP2
18441	payment	1726	1726	1874	1	1	7626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsKfzmkYPXnorr61bbo9eDGBq2567Vt994yhUegTKtvYSpjTL
18442	payment	1397	1397	1678	1	1	8380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y1Dd97gwQgWpErFMzmqf44BQWYSty45Q11QUxTGP1fzE6Hnd
18443	payment	1726	1726	1874	1	1	7627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfiYaT1d42iP1XgB7MRqvuHSawRAPMeJn28zxiwJqLL1LnuCu
18444	payment	1726	1726	1874	1	1	7628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaLrdvEbxxU7uzGDMtn2FduftwDVe8hQkgH2vCgyANTG3cj1W
18387	payment	1726	1726	1874	1	1	7590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4ig2g9JZf588LH988bRMaqKsiLu9YtjBtYcK2yVkNWGUcsSn
18396	payment	1397	1397	1678	1	1	8364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSuxAqPeF6nK2rLgcmXTotgYuNdFyYxd3Q9NLhigGNYAUpd8M
18397	payment	1726	1726	1874	1	1	7597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFUA3C8FAVLNcf9pu8P5JFLvpZfEw6nfuZxbLUYNoGJ3h7heN
18398	payment	1726	1726	1874	1	1	7598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBsEeZCrgKxCeMrEMaiAxvySDNFwpKp71wkLBftkYPPvrpeK2
18399	payment	1726	1726	1874	1	1	7599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9M1LLfY88KBTW63pQanxsWqHoFNzxHwkPJodUdtXPjLxJrCxq
18403	payment	1397	1397	1678	1	1	8366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpdpmZfPmNdiuhoYrkmXUcRyvGXGhfMrFfVYMqnzdUkWwUowr
18404	payment	1726	1726	1874	1	1	7602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUyxX2oPd3WNKi5jg5Zguuyhd1jZ1DdcXKc2aSYq71KRugnDG
18414	payment	1397	1397	1678	1	1	8370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuCiyEywGb7H2iaRLx31jKfXcxwjr6g8XNucjedAsb3wfVtTx
18415	payment	1726	1726	1874	1	1	7609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLQ9t9WmABR4BUcmjB1fUU6sHz8mUYKu8n8axAB85gFBbnXvh
18416	payment	1726	1726	1874	1	1	7610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfre37DGMEQ9VCbe3uzSEKtHwBhK2hwjd1H7BY2zPpXpofeq4
18417	payment	1726	1726	1874	1	1	7611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8rYvEwGdGMDDhxonMQZwc7CmwYqWVZcWrKpGnfNhgfbiQjZ9
18426	payment	1397	1397	1678	1	1	8373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3PeJuqtPRWdwCeewE3gykpRUydqzExQoMJndR6HMiPnW8rus
18427	payment	1397	1397	1678	1	1	8374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVE9rQBk1EE1JFxRfobjR21bjKbtnR9EjNz4DsnPZZeJXGx8W
18428	payment	1397	1397	1678	1	1	8375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPERkxCKkDT9tnfTCEiYnEumKbvsDWmXawQ2SwDtvYUkmrfbA
18429	payment	1397	1397	1678	1	1	8376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7ZPborWHXNUhzPKo9TiyeiAxUbLGZh7xfjMtYqxhPMyVnX25
18430	payment	1397	1397	1678	1	1	8377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxEYrTjkWkaSSc6eB9HgJXHH1LLfoUR3nkNAfwAijTbho8Y7a
18431	payment	1397	1397	1678	1	1	8378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiMThSDqMQhn68tTPeFrdjwdib3rK6XchVduLVjbU5BDdDPHn
18432	payment	1726	1726	1874	1	1	7618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGvtwjqepbX1XJbZZzzDhiJxCq6NovFWrPhsWrSVLEw496UYd
18433	payment	1726	1726	1874	1	1	7619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4cadoyBEJaawX7BXUgZUHA2rbZ9jye47hhYvAJ9DXfYfafeN
18434	payment	1726	1726	1874	1	1	7620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgz2tK31svHT32c8hjHitusWCoqtj5oMoBuvJU73oN3j7Yh9cn
18435	payment	1726	1726	1874	1	1	7621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1q2Gmx1H7GScoVd66FXBkhAKSmg1wdQ1nv5eVjphSjMQzhSH1
18436	payment	1726	1726	1874	1	1	7622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctWosXu13nXuC2Pxz8xU9TLreiktP3GXPT1jiuVzXfzctab4L
18437	payment	1726	1726	1874	1	1	7623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY88ZvD9pjMbQ36WbC9QjVcJAB2gdjbqDTrh2jXYEE242J8rUB
18438	payment	1726	1726	1874	1	1	7624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41rD5YkUH1MnDhLnGmpzPDs5Be6ceopzpQq8Hs6SbTNPRaHtD
18439	payment	1726	1726	1874	1	1	7625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKybH1rQVYNpgV1dCK4HWeL9ZymhYF6AQfWQQFWa4DpBXHMjsy
18456	payment	1397	1397	1678	1	1	8386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWRBrifN2KkBKM9LDk8p4iTDym2DaV5ZvyH3ExwXiWNYyVJTa
18457	payment	1726	1726	1874	1	1	7634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYse1Fm2hvEPfnNidZXSoxXoHd5faHPuNbjKPo6W3J6BPRoMfPx
18458	payment	1726	1726	1874	1	1	7635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkowgcHP9uCKhuyurT5STQbNGRMk9fWXwyq2m6B1P1RYwGapk
18465	payment	1397	1397	1678	1	1	8390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLysF4AuykwKZ4MzhrrBuvAnEZeEzUDdu5w5gAvxwUKdmyQxX5
18466	payment	1726	1726	1874	1	1	7639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43NnD7EyYW7Ss7wgUXHpJPK1PonuCwiC9Rk4S8waVyr2n9u8G
18470	payment	1397	1397	1678	1	1	8393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRc53dNeK9XBjs1QZSh2HypS1JDNkY6R4qfQKtz2FZTmK6mLv
18471	payment	1397	1397	1678	1	1	8394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPmgvYxfWsubGVpJ2qY2fgeymq41KYNT9f7RTdioTKEzsUoLr
18472	payment	1397	1397	1678	1	1	8395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7Jh2jt6h1AKiU5UZe4NfacS9HqF4bYWfECSpoTwrbzH2kHie
18473	payment	1397	1397	1678	1	1	8396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQq6EYp6AMRN1uUVk5koRAjLU7C7W9sHJi4p7HpweiHZJWqKH
18474	payment	1397	1397	1678	1	1	8397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV16ipBGGjQojhoBFyudEpujL9Ezrq8agwito4EQVCzGZxZmXW
18475	payment	1726	1726	1874	1	1	7641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJNxXsAErJziGMovX9c5pHxDDnGURX6hebLDNXkSXVxRBhQhd
18476	payment	1726	1726	1874	1	1	7642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftTmvghLk4z4BJb4NCp28ZdR8WnPRsAYAgcBaSWApYU9GSNiw
18477	payment	1726	1726	1874	1	1	7643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DEGZL47Cji4SjHWZXgDFSm5hJQVEmFxiBT6t5JYc9PFagfKQ
18452	payment	1397	1397	1678	1	1	8384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXbPqAu2CH5xx3GDqZFUjzuiLa3z91DVn7A6qr7DPEYfbyRvE
18453	payment	1726	1726	1874	1	1	7632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHjUNcno4pi2DgtUAgWsFEXMri92cgiP4W32y19KnQya2ucoy
18459	payment	1397	1397	1678	1	1	8387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApWfxWxMM4n9eA9S6BzJaQ8zoe2XnAjokqvBxjSeMX8BqyoeL
18467	payment	1397	1397	1678	1	1	8391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UEEtUJ2fGPf36C8fg7zwcbkpmcTT9aZdq963TWxWyZB8BYsn
18468	payment	1726	1726	1874	1	1	7640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvU4REPTWA79KmmyD7sovNLmJwAzSf2jXF3suVHYicVpVjw1i
18469	payment	1397	1397	1678	1	1	8392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7z5N7UQkRopZn3mPZmMG7SpmJgN6aCQztJVk1ZXhPyCEMTsM7
18485	payment	1397	1397	1678	1	1	8399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4g9N8mUdk9RBuZJEvLKX2FNzxntteYankKaQeySunsFk6zSSb
18486	payment	1397	1397	1678	1	1	8400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNLf8Tk5kBZ1PruBzJPhCQPErqNc6jZL6zK3E37bkJbHhvxQG
18487	payment	1726	1726	1874	1	1	7650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtAweHFmYYvxj679ra9FWcp6cPjtS7d8EvDQGYZ96bCNCAwPy
18488	payment	1726	1726	1874	1	1	7651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uKwQ6EoTJUsFPGcEPiwCgG88biDt2HFFRumgeaKC54N23518
18489	payment	1726	1726	1874	1	1	7652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37VezwHZaaVtxLnwAnFBfsmp99Bbhmewq5Ddf2W4zANWD2m9u
18494	payment	1397	1397	1678	1	1	8403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsaL4FA22DL46AHxiUD3gbFE9wjCwA6yJmCpa49FWkbfWY9Dg
18495	payment	1726	1726	1874	1	1	7655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiHH3Cn4UTzpB1dQgJLmNqCeaHo4jcPxTJDLkVt8EYJfKshsH
18496	payment	1726	1726	1874	1	1	7656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7mp6mHWmMKSmyzePfzyVUSGNTNspp41V5y4DPgemjcXPxzcZ
18504	payment	1397	1397	1678	1	1	8407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U35qcnLR374ysHDa2KGL9Y3LzfTvfTZkimGbbcY4itBY4NZk
18505	payment	1726	1726	1874	1	1	7661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgEhJGZPvwPt7CtnCKLSPzGKnGLHhjwKCcd76j8kcqMcNfXj2
18533	payment	1397	1397	1678	1	1	8419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XwYXtUd99MXfqbZgcTnxL18sWsjWkpwwBXcdQNkAtkk8Fmft
18534	payment	1726	1726	1874	1	1	7678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjMCVFVGYDhk6jKzb6zfjj7FrSBJbM1jCb7mHroYPxgMTqHVu
18535	payment	1726	1726	1874	1	1	7679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LZ29i4vSoYHV61TwaLAebdbG99d71BYchzFrSrqM8bSMWQpn
18536	payment	1397	1397	1678	1	1	8420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8vg2pFQ2hKhQjCdCrYoqGDkmKQ2LxM5nHJw2nP9vndGt2afM
18537	payment	1726	1726	1874	1	1	7680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPXayBQQohHdHirucgPHVZc8bRpXcpKe4bJJVAzw973nCFGSq
18565	payment	1397	1397	1678	1	1	8432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUChrdruqJVzUYZRTJqxhmXJRDwJZ817hV7MM3Tf6GkAfXQxrz
18566	payment	1726	1726	1874	1	1	7697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8E8S6YKDzT5nrq9woNc1tT3gSzWW9WsbgJCdLrdBHSPJ8nF6
18580	payment	1397	1397	1678	1	1	8439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxX5qirvnyrs1UUzoafQRpcehMmPKMYBDvFrJs7Wuq2jEztJWi
18581	payment	1726	1726	1874	1	1	7705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zdqQCtjRpRyciTDGhB156QqQVhUFFTLaCnEPJL65ykBjSvkN
18582	payment	1726	1726	1874	1	1	7706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xre1t2vY2S5r16LJoFadMrSEVN9zF2TtKqhuGRii9jsrPvDY
18592	payment	1397	1397	1678	1	1	8444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsTBGJ8LDa3c3kiPSs1HdBsrPMuQ4UjFZBkg8NN2yiXZaR2Rw
18593	payment	1726	1726	1874	1	1	7712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqfs8NqnXynq26QD2yB9uUqB6ZKtkyfgkiK5wFUPdNpMapzii
18594	payment	1726	1726	1874	1	1	7713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCaeaerHDSNScjR4BU1umDJA6JjxA9miyhn9NmykgdFZbZ5Bb
18608	payment	1397	1397	1678	1	1	8451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcN621SD7kLJRBo2HqkgKeYRQeMDXFjeTM4VcVbCw1j9XoKCAN
18609	payment	1726	1726	1874	1	1	7721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhembhhLMZGpmN48RGsR5SmyQRJWURwH9meKi37WN7Dm6cdrH
18610	payment	1726	1726	1874	1	1	7722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Xvra7KMB4wLKpc2gBB6yx1KS8cfdJFrYmni2feaCaXruHsV5
18627	payment	1397	1397	1678	1	1	8459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8MDpiTbNA3GpKn5PWa4aBDAsH6SYD4mtg6RcHKMj1q9KZWaZ
18628	payment	1726	1726	1874	1	1	7732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhtodn89TuppZYzhLbH6d5XktKRhCdWqBPKyVDvuJH8VXBKmQ
18629	payment	1397	1397	1678	1	1	8460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMLnKSBvRe76LQEsAiBg67xrfuzZPaDaBHMJSWP5i8EXtrZA3
18630	payment	1726	1726	1874	1	1	7733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4vNSVtksQGGZK5aHC5SvS33oJ4ckMABWFssirnJuWhzAGRs9
18647	payment	1397	1397	1678	1	1	8471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrvbkDaaDoLfmtKLYNBP7CMr2gw4bLVRz3nNg4kvTZ9uH9nzH
18648	payment	1726	1726	1874	1	1	7740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEo76ciiZ6XsqBLQyyjogYT3MRT7gPgGRJPQ7ehS4NtH8WUZan
18460	payment	1397	1397	1678	1	1	8388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSVw9rJ6VQSFem7LbHh2vjv9JZPUH9mozySNVWPb7FqSvsCGk
18461	payment	1397	1397	1678	1	1	8389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicT2xAesZ3SDkYBgdDaXfAtDzGMVH4RCqa1cAbjoz4aynQvgU
18462	payment	1726	1726	1874	1	1	7636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ELmnyVvmb5dmtAVoqWRQR6ZMDBPsKvYpCw5ee38q78ud2JV
18463	payment	1726	1726	1874	1	1	7637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cp1QtJn2k8cJGJD5uWNYUiiwLRxtpYkormMjUohnhnEAfjhM
18464	payment	1726	1726	1874	1	1	7638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwytadbaGUz68zBcXwc5h4GxS1xZb2ZpZWm9g2433JpLxSins
18483	payment	1397	1397	1678	1	1	8398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1zADavnEgZxXdYkRgqxEWdWAV69KoGh5Nyrdp9BYC8V3J7ba
18484	payment	1726	1726	1874	1	1	7649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbEmKPXPehWDu6eHJKqunNZKpx8QjE3m3bMu6zu8Dre3ebsBc
18502	payment	1397	1397	1678	1	1	8406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpQTeyVeEpAvDNm2p8xZKFd98UU1LxgJJKHAGpYAFy1vN3Gkf
18503	payment	1726	1726	1874	1	1	7660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yy4HnLRmWrYE4pFn8sd1WwusvehJaZyCKGvbnFTXBiJrt5CN
18512	payment	1397	1397	1678	1	1	8410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UwtGo79assfXMSoRMvDd25F9TLsEX6hfXCKqzMnVi837rEzi
18522	payment	1397	1397	1678	1	1	8414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTnfBLCpRazfVQUMhVV3GYckVNP4pQgzpQXBsLkwGAgyo6xoC
18523	payment	1726	1726	1874	1	1	7672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdisMadVVoKT95AVjksB2syR1KLE18x9FN7fad1NDhccMmdX2u
18541	payment	1397	1397	1678	1	1	8422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8g6dmaVgLV5pjvsUtkVpgzYsPdmRgYEa1NZiZwiDF7LBgyV4
18548	payment	1397	1397	1678	1	1	8425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4PcZt8VFiWhi4niGRPh9AuebfbXUyVmo6v5niec4CwCDJWiM
18549	payment	1726	1726	1874	1	1	7687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9cZFyBaofUfYMChXdjp62U92teoZNGR3CQq6kR6ykguxmAKk
18558	payment	1397	1397	1678	1	1	8429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEhMZJnoTMA93nScHeMKdYyptnmQGoHQJPTNmd4UPiw1ArAdm
18559	payment	1726	1726	1874	1	1	7693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhiigaiW6Y6LmPkfNunszoPFhyNLPnBCucBbzwpu7q9ipTQGn
18560	payment	1726	1726	1874	1	1	7694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAjeQhkYSyHDdTWRVpAuAdSUBs2zYNtDW4iNn5FxFNySYzcAz
18576	payment	1397	1397	1678	1	1	8437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpMUXKxPBZy4GQZvJ8LsVeQKLxEDAo4xkxEZqxzxNxsTXDYakH
18577	payment	1726	1726	1874	1	1	7703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkKB7EEp5t5Rt7VfsX3DHWs1dDBPp9Rsykik5vwptonDtLqXW
18588	payment	1397	1397	1678	1	1	8442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5sEZbhi1KEWSKDs9vKK8mK2aqyKdULemU8KDFC3fGC9RYcEg
18595	payment	1397	1397	1678	1	1	8445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfCxQkBBrfZ1Dxksm2Aid2sGP7BkPcVKvNQdr8fTTzapKvD1h
18596	payment	1726	1726	1874	1	1	7714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHb257w3WVM9yUM2Lgfd6bLKwWh3BZAC5DvbJxNXdoZ6ooDUt
18623	payment	1397	1397	1678	1	1	8457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2VX5pdvtFqG8JmQ8riWCiPT2jZ1xZaBNd393iskUr7aSB8dr
18624	payment	1397	1397	1678	1	1	8458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJvSZ45cTV2XehpRWgXqvwsHKiyAoks3dNK8FBpiws3cztF4r
18625	payment	1726	1726	1874	1	1	7730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD78NUNJPo8DNP5jKbsGBypnnS9UzSqxhk4DogeDiU1o7r45vy
18626	payment	1726	1726	1874	1	1	7731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XDf9dRVz2R1XjktTyHuwATKYaFCdjm2HR7StVGydfprHwzMK
18631	payment	1397	1397	1678	1	1	8461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ij4WtmovhnDJhxVmcTJt8qQxZoVkAJ2Zkeg3aAYQKuEsMpie
18632	payment	1726	1726	1874	1	1	7734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6XH8ukUgHcpChfnEZ5QkaLt1KToX2tJ7v7Fv9KmuyMcez4kK
18636	payment	1397	1397	1678	1	1	8464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62fPoVo7EHkZSdFQHMtA1rexS6X11n8hk2nHnMTVAgG3MHKrR
18637	payment	1397	1397	1678	1	1	8465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxh366CZMokSypq7miVLnvEkk2ez24LxhjnbJWHMbj2pFSnEz
18638	payment	1726	1726	1874	1	1	7736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWaoyin1JJ65Nf4idacmGew2mYcjKF19XW2r67x2jM7cKLrTr
18639	payment	1397	1397	1678	1	1	8466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaaqdJ6Y4fZM4mWa8RNMzn4Y3oFEYkszTTgRnWhX6J8dA6kFB
18640	payment	1726	1726	1874	1	1	7737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U3MGYnb3533qFFvoMtMABo6u1HWZQqcQ63Fdh3ZttuRxhVed
18645	payment	1397	1397	1678	1	1	8470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKgQx5gMCJ5skB4Fk3ejVsBej1u8N8z4tbF4dJAEnYPA7jgzy
18646	payment	1726	1726	1874	1	1	7739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysbdEJoEfBw3MW1Qit2jShqiRmpBGzaKootCH4wTfYdB8qwMs
18650	payment	1726	1726	1874	1	1	7741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tz7Xwb9Yg1KHgXC2asiqx8G5BeDx8TczTEytFsruNwqAk8bB
18662	payment	1397	1397	1678	1	1	8480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9ot1c7Vv9Scg7pK4o9jogwaueJV5WcRpJdECcn5vQMKgWYP2
18478	payment	1726	1726	1874	1	1	7644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9KeTmqUeY3qUHWgWdUnFwHAUxAs3pj2gAZ8w9VEvoGBHgGUE
18479	payment	1726	1726	1874	1	1	7645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FB6iJGnFMk1adWg96M2kf87xF9cvA9RMMMXkoT76KDaffbtF
18480	payment	1726	1726	1874	1	1	7646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqsunKAVcwmMjxJoLrtz2MLbPZy28bzeP5HDAJXjQaobFsVf1
18481	payment	1726	1726	1874	1	1	7647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mhr5uJWBZG1HK5FKcaEqtVdrJTaWhRd2KB7USbTj1cjjJPaH
18482	payment	1726	1726	1874	1	1	7648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WgHvj3oqLwKcc8khBgmW4WbbAydVBm2WsSmPyc6Wm2yxUsPz
18490	payment	1397	1397	1678	1	1	8401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkc1w1VrfWa5ycaeAMxhd1DEjbZJMXje79tq8Zej4TFrbbaDL2
18491	payment	1726	1726	1874	1	1	7653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE47kXjCp3JEArigx1PiXiEdM32riDgBZGYjmW9VG8W4CStjC1
18492	payment	1726	1726	1874	1	1	7654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiAXQ8puYsSHuMtCrdyficwigqrt1Hh9WXpkFgtTtsfGoz3u6
18493	payment	1397	1397	1678	1	1	8402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVnq5adVzYUB85WwbjC5UTg7kMubXnMXoq5zNeJbPxXZWsmbr
18497	payment	1397	1397	1678	1	1	8404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4yKNnXL8PaG8hZvebyZFuYKQVjY1eNVRDeWzjaTXwLTZnp5u
18498	payment	1397	1397	1678	1	1	8405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqKFGcZCx2DBw7vprcZT2p5ssgAFcbWG5XQbAXbzAA9GnDWjM
18499	payment	1726	1726	1874	1	1	7657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsjDGCuVvrnRzryeQspQXmoNXCgR1uDPfyZXBHejoXNePrY2W
18500	payment	1726	1726	1874	1	1	7658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqSet1MNacFbK6K7MQqYt3Z18mmdLV7qrGBQJxyUFM1y8vxYAH
18501	payment	1726	1726	1874	1	1	7659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoWVFHKWczAW2kqQx9a26R4B3wiq8rm9PhxNV4BA2wSTDJwMG
18509	payment	1397	1397	1678	1	1	8409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wL8MPuefnuEoAfxjaS6SvaoaFfYfcHW4Nz88NhaXEE3N1Vtq
18510	payment	1726	1726	1874	1	1	7664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QxTnSf5Q4qgkrBEprLFY4VDfQbGNKuCV3pDh2iBpoGTBCi8o
18511	payment	1726	1726	1874	1	1	7665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSvWEv5uM8L3qcLKFzQEtFFmBAQ6p8PKq1DuKu7M9afYrh8t
18516	payment	1397	1397	1678	1	1	8412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWWGDMUAdJPWyxQS8MB9QjTmkzCN84BoGc9MCbFcAAzJAn8SB
18517	payment	1397	1397	1678	1	1	8413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GWzKFJbeKB1sv3xM8B1C2vahTre57yXAro1QkcyrPiGkXsFa
18518	payment	1726	1726	1874	1	1	7668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWErMkHNYsMQxXAVtq2hkjX9Tvq1MKdGFJ9sF1cg7q15qLkpk
18519	payment	1726	1726	1874	1	1	7669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgtFjckm6T9PqZuoRCPTuTJU3DrtRAkQhmu8kutzFu9swArGj
18520	payment	1726	1726	2118	1	1	7670	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzYxnUYzPNb2xBSeAj3z3CDhXGqtoWxi2HnrwyUiF4ygm4kenx
18521	payment	1726	1726	1874	1	1	7671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYiTUJfAcjospW6KKLYWog2z9iwXTKjd5BYCzePAaK7auTvF55
18529	payment	1397	1397	1678	1	1	8417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCgwdvsbmpjCkUBQk3EWtg7CjwvBKDHsctk1zAGZAc7Q27ycK
18530	payment	1397	1397	1678	1	1	8418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmM5eDuVAVUcCXU5X3qS8CFyAvsedoEmboVV2EcpLDdGKGpo7b
18531	payment	1726	1726	1874	1	1	7676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nLSjmZtqNq3hP4pBMDSxybYpmRL4TQtw7dYiceJ8QkTBV4o9
18532	payment	1726	1726	1874	1	1	7677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvavhbB8TyRTiec5Z2PXQoQwXqim6tmPy4HbyqgCrmYXZeYkEh
18538	payment	1397	1397	1678	1	1	8421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BJxPXzGqqfUsbRHdx9jEScfsCr4unyxajoUoPhH4z6RTpN17
18539	payment	1726	1726	1874	1	1	7681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKdcwQtaaFhM4NUo8zuPYXDFXQDfc6uSCHmrpgQGYiqKPB7WcM
18540	payment	1726	1726	1874	1	1	7682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRAXaJLpKc64or32WaoefFnwrut7PK1xw8TeGds1XuHbX3NNW
18542	payment	1397	1397	1678	1	1	8423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWmHACuvqqLKQStwXwDkBeJZNG1EPGmLtL1x3xRvrhtsZ7nwv
18543	payment	1726	1726	1874	1	1	7683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqyEUcsK3CJ2HT6P333Hiayc9tvbCS3vYtURMCPUdBxKdyMKA
18544	payment	1726	1726	1874	1	1	7684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGg4JcAXwLuGCKpWiQeuuPwCoKBLqe4BH9VE1eNV3xhYaSgbJ
18561	payment	1397	1397	1678	1	1	8430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq27kWaaoQ42zgV5yztehY7zmJcG5i3DKMFxdm5t6S8wkyuMnU
18567	payment	1397	1397	1678	1	1	8433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWJHwA8UY7PunSddsPvGBtSuB2z2MtscfpuyaowSrvFaqdUS2
18568	payment	1397	1397	1678	1	1	8434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LBwrQe4kUzefhtygVY22K5Xdz1Mq3JceqCCRVgwDm5f5Yhcd
18569	payment	1726	1726	1874	1	1	7698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAd3vgosuK3z1Smo1mmV7GA5bknqxoXKfey4jy2AFsVwtAmXBT
18570	payment	1726	1726	1874	1	1	7699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn4vcmKM25dmW5BDRGBqQhBRkzb4LMhhNw2AEZdwDyH1iGpBG
18528	payment	1726	1726	1874	1	1	7675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZw4H6VJLHnTqZW7SXW7TN93U9HG166xpuLb9Ay3fCWa5aigJf
18545	payment	1397	1397	1678	1	1	8424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG4nxDkZXhtvRfhUtk75xKQygxbiaiHszzUozBkb9CUDKisus
18546	payment	1726	1726	1874	1	1	7685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjL3Zt8TwztakKDXn4SDwn6wH6Why8E1wJfRgAHWZ6eLSJdLE
18547	payment	1726	1726	1874	1	1	7686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FnbRutPWQWPCccScsCChBSBWJ8nVkjC1vgmVEdQCumrZv3Rd
18550	payment	1397	1397	1678	1	1	8426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEEN9vTgE7bwtERMLrGWLCT9dzxJzvTjLeuzutnwB4WDak1Qt
18551	payment	1397	1397	1678	1	1	8427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1ahn6GQvHMDTWiBE1JWrfRRF2hNzBKAYZDuEaux7p9Nav9Gs
18552	payment	1726	1726	1874	1	1	7688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GdHdLXNy9Yyf7xgmwEpepcjZQcsWHbzHgRf73TR7SQ2FPzfi
18553	payment	1726	1726	1874	1	1	7689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxntRMcgY36XExWtmVjVywypMj5n362huNU8GkfXChDHa2V39w
18554	payment	1726	1726	2119	1	1	7690	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWGLCUzUHit5iv2vYbxJ9wzWJDnFJurTEYysefG99baKj9vsys
18555	payment	1397	1397	1678	1	1	8428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptmC3FwnYQvT5ahM9DrA4LXyZnA4kV4qPBRZwZXdZ9YbpGqdk
18556	payment	1726	1726	1874	1	1	7691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAA6UNMdVRjuPRP8ZRQvrNozMehH4AXUbXn96mW6DwyS8yYUB
18557	payment	1726	1726	1874	1	1	7692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkYMStMdkatv61kdJeY73R5cdoMnP4Eu4BJqHZErFjx3a77Bz
18562	payment	1397	1397	1678	1	1	8431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoYZ4p3ay93ncNxrXN3xUu3sGpTuVHpBx94CXNQrrRoMdG1Wx
18563	payment	1726	1726	1874	1	1	7695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CpNvVFzht2r9wcfrrTXaBwSVp4iLggcps6zLP2qY4rbg5g8q
18564	payment	1726	1726	1874	1	1	7696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdk7mgrDgNE83C8LsuQ5CBzGfEJXuHaiP5mF1KnhWHhgfdyojh
18572	payment	1397	1397	1678	1	1	8435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPabE7SZ4LYX4mgXMd64nruj4Uxv4wXQiH6eWUYYqwRn1Ruq3
18573	payment	1726	1726	1874	1	1	7701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSWkHaDtotnuND8uW5zMRLdm6wVTbAv4Ci5Z1Xvekhpy5MC9r
18574	payment	1397	1397	1678	1	1	8436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG5JNzuWpbh5MKyBWYwxZsZSEgrrNsP5VgZqU57DukGSxnpah
18575	payment	1726	1726	1874	1	1	7702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wLGSxD6d9XGAzPrUfUcG2go4Hv1fr9pJ12ZrEB41AkJuxxX7
18589	payment	1397	1397	1678	1	1	8443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmRk31MV4wrqTqRiyTaXUhA8RnxEmGYp8FZgWJHgALMnwaDnk
18590	payment	1726	1726	1874	1	1	7710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrbC6JGXPv2ouwoCEYarW3MHpJ9A9h9W28qLUcUjbc6RdJJDz
18591	payment	1726	1726	1874	1	1	7711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA471kBx7cFJ1qxx8L9ZGGPjs4AW1iBWzyxsoeb6oiJdtjqfR
18611	payment	1397	1397	1678	1	1	8452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZto8hRyFLRzg8MDWnQnNrhNQiMEgh9G89ok2Yn7YBn5tXZ3a7a
18612	payment	1726	1726	1874	1	1	7723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSct2XRtcLr4S5Wc9hYzfndmvoeABTa9J2LKce6C9qUEv7zQ9Q
18618	payment	1397	1397	1678	1	1	8455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXojE262kE3ovHafRRxwWKKFj1xGpceqL8eremfAMVc7TNr6BC
18619	payment	1397	1397	1678	1	1	8456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9S52zRcCFJe95pVdouXA9hThzyHxySuK3isjPonCTzNUjk9c
18620	payment	1726	1726	1874	1	1	7727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRQdTAsmwtqw1PEuwJFwiG2xxVq4NYYLQRs7iNoz7Wo6cT1Lc
18621	payment	1726	1726	1874	1	1	7728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mreCSWmpGvDcFzgshzGfQrdbwFGH7UWZ7ryfKEAWg2cMGpWM
18622	payment	1726	1726	1874	1	1	7729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pf95gzf2qK3Z3DQbyPdpxCu4iFrCwHhm5hfGwmbiTChAgdHG
18651	payment	1397	1397	1678	1	1	8473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTeuDx9NprTWmGpCraURP8XkkoMDZ1aZhRfqLuxEkUtPpdFjY
18654	payment	1397	1397	1678	1	1	8475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8CjH9rtseGKQb3MBrb4eYVDP6vcBnw4zhSyzhrmX8AnbzgEt
18655	payment	1726	1726	1874	1	1	7743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnAnxRFer6WgghX5MomvYWwdfcV2FUTqnKHVDa3zPCk3WL21Q
18665	payment	1397	1397	1678	1	1	8482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYq32hkGiYdFBHtHQ8dzuzPqy8XS8FwSRJZKPJPJKtkCjFLNY
18666	payment	1397	1397	1678	1	1	8483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmGsVNzCrgftoVnAHfSwGBKeoRUtnNx8nC6sEWMKjjZCh5N7p
18667	payment	1726	1726	1874	1	1	7747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fEWzWNdwjAhwhsN4hD3RJH46C2Xjoa3aQ6GX6m3pMxgdqTyD
18673	payment	1397	1397	1678	1	1	8487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwZSk7CXB3XwDFPfELrcyunBD8xgQrmJ5irUaPodfLJERUZFd
18674	payment	1726	1726	1874	1	1	7750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsnXYKspF9moJ1pU7UYyABnNvfWoGLL4MtVXpytPWcCGNLnkp
18678	payment	1397	1397	1678	1	1	8490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5phnWNZSej5Ko7Nsb3f8pxChEvxbFYFitgM4ceXjQhF6kXTXj
18571	payment	1726	1726	1874	1	1	7700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCosGrgifZBD3d67WbE9F5CeZZJNkjETRKoGxAuYbhDhS7GC4
18578	payment	1397	1397	1678	1	1	8438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFdFLjLjHfdHTsscLYdGNPBd4M6ExzPCUnPyiQPsRw3GXE2oA
18579	payment	1726	1726	1874	1	1	7704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1CSDJ9GnBcDddi7G6rtq7BZWBBVn8qtLcfwdMZjmzSJphVb5
18583	payment	1397	1397	1678	1	1	8440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC86hEqahjmTDqeJ7Dhh53CEvBYvUUBkSziGjnXDtdJRFQARJt
18584	payment	1397	1397	1678	1	1	8441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkHW4i9Jdi3uv1hybEkQNsVxAJDren78esxUUqV5ig6AtGk6k
18585	payment	1726	1726	1874	1	1	7707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWjnUpCHRY8k2ecxHAy6tKSnGbfRArv8vWqkeiMvJeFgfd44G
18586	payment	1726	1726	1874	1	1	7708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSn3zXYvtsW4FZp3UqVCDLGuBSSAUDZbs6F46u5KvbWcNXVjcD
18587	payment	1726	1726	1874	1	1	7709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw77xTp4BK5Vf9FBBGP2TJZ1xyciwD6wkBF8gdyp24Ubr83DZ
18597	payment	1397	1397	1678	1	1	8446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3B2miv2jp8EfjgB44uCpeFBYBaDXQ67aAK4j4tLAhq6qxx6U
18598	payment	1397	1397	1678	1	1	8447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2Taban9mRyDJfHveo4qfgaFBqnERcVSx3xMRB1SCV7a116Y5
18599	payment	1397	1397	1678	1	1	8448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipttZ7iUV48Nosp6kCjJcZ6MRsQntmrtJFUTLFuk9t7wYLuyR
18600	payment	1397	1397	1678	1	1	8449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZsFoPihbH93fPHdnQNgcFWBSq4C6JRAbXxfFxL7QVoNuvbTx
18601	payment	1726	1726	1874	1	1	7715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2vdRUcTTdZu4X8H5JRWWaX6U5fyWq2ra5jbTyZT3k1JmU5Gt
18602	payment	1726	1726	1874	1	1	7716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDgqbM292PYR54PuxVxvPRWmdGASSgzrmpLeWu4DZSBh71MM4
18603	payment	1726	1726	1874	1	1	7717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU7juxDu5N8jNM3QPbsu61GZuNXyjyCTbBVwiDb5YvzG9iyAc
18604	payment	1726	1726	1874	1	1	7718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDNaTjbBAxcWLoBjB314ivNQ5ybtjx7qYygmcE8ggidDqHQHF
18605	payment	1726	1726	1874	1	1	7719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVCVsD5rc4arEdo1TEx1gkrxkPfgMsi5Un9ft7PYn24RKqCXz
18606	payment	1726	1726	1874	1	1	7720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZzjv9DRMCgcMTMnZtdKffumpJ7vkEp7kgDLLGUpebEkN6fBw
18607	payment	1397	1397	1678	1	1	8450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdQQCtsnzYVHLDGCqz26ZpDKP7jAY4fue7GWSEWCRcpNBwnC8
18613	payment	1397	1397	1678	1	1	8453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4X7nMh19ekhRDieHDUBBDvB8GoAGAiKsQ92w9gXvpmiNZ7ks
18614	payment	1726	1726	1874	1	1	7724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4yuLZ78bc9gtyoJZUGdTH92mTdc8pZHLv9SPLN3djqFaS3Hr
18615	payment	1726	1726	1874	1	1	7725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsVpcVzet8nM7PAERSMtH7ZG2MZft7YEf31mAbT9YGNUgpY7n
18616	payment	1397	1397	1678	1	1	8454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRDa9qnv4BD5mynx2VYCa9n1JB1HcNx9BmMP86HoAqn5EJfEF
18617	payment	1726	1726	1874	1	1	7726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGprALxk62AsbgXWLRH4NFKSEvzPw781rjKUXiRBGtc1iDEE9
18633	payment	1397	1397	1678	1	1	8462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZMmUDPtuxysawVjhKiFrbFgHeJv6t34UKXhe4bx6eiV14poF
18634	payment	1397	1397	1678	1	1	8463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1t8n6BbKB2mupAkEWX3ePnrjKadttCuh8q2VbaAt6eeit1A8
18635	payment	1726	1726	1874	1	1	7735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEhH9VFdGofzLKPShPksPuoUtBGUZPKKTd81HEiWcQaFJGYbY
18641	payment	1397	1397	1678	1	1	8467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUQcgvvMDrhcDWzMMeXbCa5FhRQkyp6SL3JtM69gJ8nobESHJ
18642	payment	1397	1397	1678	1	1	8468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSARK2ChK9hZyefsV629kbpcmVVQYx9kv43gqNmuvpHMsVaysa
18643	payment	1397	1397	1678	1	1	8469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabZ6xhejZ1B7FHa6qjkE5SXERzyHbdkT9u6znMLoFrf8L64mt
18644	payment	1726	1726	1874	1	1	7738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQr33ZspUB7oqGNiR1z79akbCYo8fwa5sHvWjrBNo8fR6RXMJ
18656	payment	1397	1397	1678	1	1	8476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHUSkEyNncYh3m8DphNo298qumEX8yC8AQiZcMDAWUojksLx6
18670	payment	1397	1397	1678	1	1	8485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiueAwsKdxyRFirzbqbRuxdt7sbFV9P5YzDsb1it7fypS7LF
18671	payment	1726	1726	1874	1	1	7749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJG6Tt3Lwvf26JGQDtN78mZ4X6yQdZaDwQ5m8XinQGWzyQwHH
18680	payment	1726	1726	1874	1	1	7753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9M2QmqoKujkwEafNb1sGPuSB4Aj8hJ4Khj36uLGpB8pRAvWnc
18684	payment	1397	1397	1678	1	1	8492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9qer7L6hvbndFnKnf3DFcupaKifkk7JxkdaswsvkLb4Q1yVZ
18685	payment	1397	1397	1678	1	1	8493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfeayW82HJ8gVz9E9ubhjJmEtoj85kiKMnt6LLaSwni3cNRHT
18686	payment	1726	1726	1874	1	1	7756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCHDhLZDyf66EjVJ8nyQrSBYNFAkqYWhuQk95PSB9z9KciM3y
18649	payment	1397	1397	1678	1	1	8472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFCewmSJkzzDv6jFVqexmKR6HshyGbGCfHFe57iuC5MCnY3v3
18652	payment	1397	1397	1678	1	1	8474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC2fi4vaMPy35xyz67f9ngsUVfhLTxqFsgeX3e9zNpJsU7quq
18653	payment	1726	1726	1874	1	1	7742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSorzduWHgrh7bQCM3cxDYon6fyady6qva5WBQZEEcThVSSEw
18657	payment	1397	1397	1678	1	1	8477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wAYMnZT7or7mbgiCgjAWWLtL7iscmHSNA59PHy4YhrY8zRmh
18658	payment	1397	1397	1678	1	1	8478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrFzwscs8UKbUCV6o5fymhESJLBWawkoE7BhNYk3fmuWV4Hcv
18659	payment	1397	1397	1678	1	1	8479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcriq3Lda7h8RYmtFHuc9RkoEYT6usWhZ6yjzXcyorCu3K3jwV
18660	payment	1726	1726	1874	1	1	7744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SPAvVvfs3W1wiQKXYvvNYJQbTFKHmMpdzKwkASkEJL6B1wZo
18661	payment	1726	1726	1874	1	1	7745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATiGuccCyomxYhnz5bBDpDDg6hx5ycNu5p429tzqATmeWDjSv
18672	payment	1397	1397	1678	1	1	8486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYACD8pb5qRJWHTn8bSNuESckBqLEvCnJrZxKQjDtAL5SWSgyN
18682	payment	1397	1397	1678	1	1	8491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9p5Yi8UvfgRuGpAfXtL3zdaqzryvLYDkLf84cpoFA1J3JN7k
18683	payment	1726	1726	1874	1	1	7755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QbiFTkXTw48PDZUAh5sTPZ9BkYbwHYGQhU9kCL5HvgnxNjNC
18687	payment	1397	1397	1678	1	1	8494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgfYVbbYgeZEohCco4xiXNCn44pRyMfFoqYKJvQgm67TBPQNv
18702	payment	1397	1397	1678	1	1	8500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaU1LiTp37j4JP2DSypBQHuBuT2pTnMyoebpEv1NJ5Ht6CM1V
18703	payment	1726	1726	1874	1	1	7766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhszRqj3i3fPcecphCupkuvGt1rKGYYoKjWX4gxVWfX2Pftd4
18704	payment	1726	1726	1874	1	1	7767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WLPP627nU95nuwzLk5uqWS1kYndC63AkewpRzLL8YZ17vtTH
18713	payment	1397	1397	1678	1	1	8505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbA1o9wW8ZdWnkrvYaWG4pxe7D4N4yBzza3eqjcWLhckD96xzv
18714	payment	1726	1726	1874	1	1	7772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTARXDjkJGC1PWyxfYZojbLwKYujT98urhP5w58tbjfDXsxYz
18721	payment	1397	1397	1678	1	1	8510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZjyS42zAX8z9bzh1zkXtL1hQrTYcMPZ4f132wuJkMhAL7pKo
18722	payment	1726	1726	1874	1	1	7775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6952yaMWRgwgYiresrcCovTy2kietueRGsE3RoLi5GoxFKdJ
18729	payment	1397	1397	1678	1	1	8515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPCtJZXE9Q4hMWuuPYwc8n4tLo4oMVzvBNA8vYK1GDi7KmReM
18730	payment	1726	1726	1874	1	1	7778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xpQZciV6Bpdwih6yiiKUxfiEVqMPR8nqW6HATnp4NX6Z6sbb
18741	payment	1397	1397	1678	1	1	8522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1YZG2z7patTVtGGFABLGudaHB597LBMw3Wu4iumQvAgoSUjW
18757	payment	1397	1397	1678	1	1	8530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32EZasHAjuHgWrNFZJHhdCo9pg89PeWDwVYVJgb2x4h5xY39D
18758	payment	1397	1397	1678	1	1	8531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfuAe5UtTxVuZFZe671ifDi2z8erAvvkWZynFdnao9VtCtesX
18759	payment	1726	1726	1874	1	1	7791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR66NU9PfVc1Gu1gx3Z1CkhACEn1b4ENThwjKDCp7hq5kzNQGv
18760	payment	1726	1726	1874	1	1	7792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnU7jZkN5hZDLx3DpVEumk2rPjsQhwGJb9UfBtHYHfMMbRGbn
18761	payment	1726	1726	1874	1	1	7793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTA4jqNLCzR7SEPbs8NiRorMUeMVyQZS1RwYMXYNkSbeQaNYsx
18762	payment	1726	1726	1874	1	1	7794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyffQb1WW4PPBsreioS9nLNDxw4WWZmd6oetkmFVwBgYyfcTrv
18663	payment	1397	1397	1678	1	1	8481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4s32NEh7H575T5pr56abiz5S1JJUjb31Y4qUghKRs2PpXDob
18664	payment	1726	1726	1874	1	1	7746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5S46pRSJ4T5bC8FczkVWbAHd2XKS6dbiFLEnASbgD2tkwim6
18668	payment	1397	1397	1678	1	1	8484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhSq268cngnCbNx2YLCRAJvNUVEt4CyPqaWC4Wx9Tx5ELiqA8
18669	payment	1726	1726	1874	1	1	7748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7i6fefc5xHhEYZDVYK3zguBHo1MsmtogtD4SbqMZs6B51jBA
18675	payment	1397	1397	1678	1	1	8488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVenXmP915zjbDca4g5WCh2ko3cWkSpTdW8Gtfwz4tE1ZHaUw
18676	payment	1397	1397	1678	1	1	8489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE5cjikhmckNjddwbqsoRvyAzRoLpYJ95Z5WuDFBoBToma3Su
18677	payment	1726	1726	1874	1	1	7751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4k9rX1KctmkdNo6JR6V4DKbyyNbNo6TNtS3dtAXBHUXaGWLS
18688	payment	1397	1397	1678	1	1	8495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnpWANsijwpjisJLtL7ZHw9B9vWeDyoXx5CRH6etRCDN2hqzw
18689	payment	1726	1726	1874	1	1	7757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sB57StWn2wvCmrMq9xv3h1ZVcew9G1w4Hu7NLv77iojURE1x
18696	payment	1397	1397	1678	1	1	8497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnG3wyyLTGnsMzUjUWdAUeQ9FeZ3ZWfftHFmGKYVA19e8N6Uq
18697	payment	1726	1726	1874	1	1	7763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDCBnTbRFDA5nXjUanEPwkkNhunKVaLBEB3Rxor833qGUTo1K
18708	payment	1397	1397	1678	1	1	8502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyMjX7dtGANCrDKWCFcUMBkfGUHQJNyhNhB5d394gg2GQpvUo
18717	payment	1397	1397	1678	1	1	8507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGCmM6fF1bEogDSeYshUD4uZksbcQeoiq4qeKKtGp7WY5NK43
18731	payment	1397	1397	1678	1	1	8516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTKM2Xncpo8z35cTQ3tQaNWGcCvGPX9kNwQdf7v8vT4p5xThM
18732	payment	1726	1726	1874	1	1	7779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFH93TrNKEtfqrvLL5tyu4Bpkeaqs1wGpygzaY2amFiBdpJS4
18679	payment	1726	1726	1874	1	1	7752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3e36etFAGRbkDM6iM8ijYmLNYctX6EQ1tNAzwgv4eSxtP4EkQ
18681	payment	1726	1726	1874	1	1	7754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMaQjkXF7LFmGkQzYLhZHbE4d3SCUvH3resiTDL5qXNNaHGQr
18709	payment	1397	1397	1678	1	1	8503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkCwx3sKxwjt87NX8thQ37f76uTFPsnopFSETuddzmc6aBzF4
18710	payment	1726	1726	1874	1	1	7770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7DVCo6wvttK8sDhLbUqfYhFm4U6yx4hhJ75UdaZhQcHPpqc2
18711	payment	1726	1726	1874	1	1	7771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZU8f6bbC51XNeda7XGDQaYd2Aq1EGP3oPpaWrbxNwYga3CtW
18715	payment	1397	1397	1678	1	1	8506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8CkWVVDQpx1kQ8PNRjCRUBsx7K3m5iKfJ6zDnA6SnhNR7yJz2
18716	payment	1726	1726	1874	1	1	7773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJpPXVKf57wdyX9otdhvCx4kjcJcWGQ8Sf1xxUFyjwhC4Sx9M
18718	payment	1397	1397	1678	1	1	8508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVDzC2TgyViz515wwnrJjXsWq5aveMHq4UfrsNiM57jEfdbfe
18719	payment	1397	1397	1678	1	1	8509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxpX8gWNvxdANpJazsz7Ws9xYCREvSc79XLr5VzwJrBkKpQfc
18720	payment	1726	1726	1874	1	1	7774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnNVYRBodtB3FM2Z58bZfzcTetxk1QWS74A1qN5FN7PjtUdfo
18728	payment	1397	1397	1678	1	1	8514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYMWNQSWuckWNMrGtMrGCRprDZzbisHovKKWJzMSwT9Fd5auF
18733	payment	1397	1397	1678	1	1	8517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRkZWxm2cCqbUnbtAM9ASjLy1fijwoVFSj4KUMm4U3NKpaC7D
18734	payment	1397	1397	1678	1	1	8518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgDuf6bdrJdML48jcSMBJe5t5LT2qv3HsRWK5eTUC2pYJyhURy
18735	payment	1726	1726	1874	1	1	7780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ6MVCMDAjamjk3VkXjn4UwyEG2b3vP9sT7kwCDR4PSNJZZSX
18736	payment	1397	1397	1678	1	1	8519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSwvk2soT4wMqyCBkuGci9Ba4CuMyqYPzTye871MKf1WRKTeM
18742	payment	1397	1397	1678	1	1	8523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu8x1namBJcSYHFWPP9FtjSXFKSP4d5CxxgjGFXTb5Wq7ebh2
18743	payment	1726	1726	1874	1	1	7783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQf1yVUuRyHEX7mtknsdRiM1mJZSAJYM9XbL5z6nSYBMat7Ap
18744	payment	1397	1397	1678	1	1	8524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzS1PQ7KMtf4k8j5rUWLsgGbKKMdzLAC93kgZnpRWvNcc4EUtM
18745	payment	1397	1397	1678	1	1	8525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeuK1Q3aWRV6p9QrG75wtU1e3GR6RGPPnJAcwN5jq3m7DNLWu
18746	payment	1397	1397	1678	1	1	8526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3Nb7QNCQXdk65daee3EN8p6prAUvJmgT9x9BD4RY9Xp5U3Rx
18747	payment	1726	1726	1874	1	1	7784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopb33386cuX9dbNc8aPE9jyCrWCGQMJERQRddLNk7sTLzTeRU
18748	payment	1726	1726	1874	1	1	7785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1odnYR4igyf65pVhcdTX9psWzq3LdgDeAJTrcAHe1PzuHJ78o
18749	payment	1726	1726	2123	1	1	7786	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAbNex7hwnznttoHWEcwUUTp1McmnDP2J2F2MxWvCjD73XGs9D
18750	payment	1726	1726	1874	1	1	7787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HpzANtKogrXdfvT5C8GAnG3PJHcW13bEt3fBF2tprvEMNdB3
18690	payment	1397	1397	1678	1	1	8496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZqSBQHqHTgCnUFCLgcS25vp5s8fykX4DpPzQFysVv1RCA2PB
18691	payment	1726	1726	1874	1	1	7758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZ5EXHwmDS6SU5iP6bCJvcybaPfjxviP78bsPpEEwwq2eoVSq
18692	payment	1726	1726	2120	1	1	7759	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYYHJQWMtqt7shDxsPtzkYo4hLbUJtj4KixBgoDyQbkmsJ28aXd
18693	payment	1726	1726	2121	1	1	7760	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZBdAoor5pTTZwWrKFAFX4ZqcFqo1XyA45Kmgh5zcmEMHMwwHzQ
18694	payment	1726	1726	2122	1	1	7761	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLcBrn4kZvsmpNfF1N7vwnzyVKb3oymFFu9SAuknkx2mtpsBVy
18695	payment	1726	1726	1874	1	1	7762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NfGKv1nuuSkPEowr9W8Tnnxe6MrzU4K6Ko4to7hAUnn1v3Wr
18698	payment	1397	1397	1678	1	1	8498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYBN55x1ZG8Evk2wsj3jx2DBzD7pVSwbb7pHtRFPFjxyGSitr
18699	payment	1397	1397	1678	1	1	8499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KpgH9pKbECXbpkmM96NVNRAymX9w2iPuWxUjoDTTX1QmLYe8
18700	payment	1726	1726	1874	1	1	7764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5opHvWdd8XDE6EP2tsi83MPQ27xPhEMPWVp39TFMQX5CMKb15
18701	payment	1726	1726	1874	1	1	7765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75JR2ypMTPjfkC53wUvfPQYA6Nx45LqdRzVvQuH1u5YdVuUh5
18705	payment	1397	1397	1678	1	1	8501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUVNPLdxnnwR6esCpTvtA5Hj7PyuB5U3wN4Cqi5CSkVrYShMv
18706	payment	1726	1726	1874	1	1	7768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAhinW9zcYeSXzmJ3vznL7DKwUv1CaKLtYzzWe24TGHKCQ4mF
18707	payment	1726	1726	1874	1	1	7769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nYwLk2YH7Pje9BLGe7JS58t4ZVF2NEDD3dy9DkpMJstyoRYz
18712	payment	1397	1397	1678	1	1	8504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3apox7CgrgMURpAUARWpC7gHoynuwRUM5uNra13rbKN2KtSR
18723	payment	1397	1397	1678	1	1	8511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XYxWRWnaTKHnFKPaAD22FUoZ1qWTGVKE1YzW5e2Chy63ewVW
18724	payment	1397	1397	1678	1	1	8512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx3pGupfCtF5aZMRbGA1pUkEhGM2xBCa9UW1fixqcbCLCLJTg
18725	payment	1397	1397	1678	1	1	8513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnH7DHQzh7C7xor44mY4Uxb1SvsSnX38Jwd2TpWHyhkh7dgWW
18726	payment	1726	1726	1874	1	1	7776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8bCvAHCPqRjfMgTJPEABjyYvydpYELnwPa3PYAyJTeHQj5h8
18727	payment	1726	1726	1874	1	1	7777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrcmYQHAtH9Jhz7VqArHy92mXXeVyJG65zTt7RuKv86PJJxWW
18737	payment	1397	1397	1678	1	1	8520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazH73yuQKpmzz8yCdaFxZYeeHK7nfEdMGE9M8LkrYaSwhHvcZ
18738	payment	1726	1726	1874	1	1	7781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYi4pFKXxryZy29BWmjkj5sxquKj57rhkqjfz6HpU8LpbfA2F
18739	payment	1397	1397	1678	1	1	8521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpmzGebGd1QkSFHG3UpsjVMcsjfddHFq1Qc8XWmzFfUwhMY9E
18740	payment	1726	1726	1874	1	1	7782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTfQwmZ5Lfyiz8fJgUbQAcWexkUYJwEhigv3scn1vNcXmGuUG
18751	payment	1397	1397	1678	1	1	8527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKP6fhPLMa3aVaTAcG9syAJyCVVneWZVraYrCGUwHHTqY9NDG1
18752	payment	1397	1397	1678	1	1	8528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JbKWB85vueNrWsnTeyvwiketc8EpAceqyDgotCYYmPRyv9w3
18753	payment	1397	1397	1678	1	1	8529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVHhwZXWzu7K3QxiieQpKz1dWUuQxYCQrSJGrCDFUqVJ4xTSX
18754	payment	1726	1726	1874	1	1	7788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9scp5afSnQ624QusH5oe1mj5cdMPgRS69gcdDYkjnCWHnbcVB
18755	payment	1726	1726	1874	1	1	7789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtXTD4JENdamRFMomdj1tarz4hSPENhbkdZotKv3rbGJ3Hs7W
18756	payment	1726	1726	1874	1	1	7790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh31r5oGNMiHvoG8Vp2TDA8EMPNhgTiCjBXHV22YRuBM2FNfHD
18763	payment	1397	1397	1678	1	1	8532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9eRtCacPdPwHuqJU5gNhJUSQYhkBarqSwq7pJwSSUpEMBd5L
18764	payment	1726	1726	1874	1	1	7795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVQfFjZwYurYvMRmQsn9Zrn9Z7wWJtSGL6LyGJUSXvx79tmEK
18765	payment	1397	1397	1678	1	1	8533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedgB9157NMFSRxCmaA24ueq3Qwke3yxCkvmubjpRxYXXYask7
18766	payment	1726	1726	1874	1	1	7796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Hd2sr1ddMbvQaMTnmHQpKigtsCe6WTLsRRd5bob8rUx3aCnD
18767	payment	1397	1397	1678	1	1	8534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYj9oueyK36SNXY9bfQTLWZbwRsmu5ujvdykyhGHzdfbkDHTY
18768	payment	1726	1726	1874	1	1	7797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXGdrUBqERRQSnPXCM6Dgvq9wtkq5rNYbrvZNLWEbLPKysLpn
18769	payment	1397	1397	1678	1	1	8535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uc1FJExwsn2iQEAC5bwP771KQYK8DyUbAtPFWkzYLaUSAcVr
18770	payment	1726	1726	1874	1	1	7798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kMatgWCYcqQotSqhinV76W5DEedrUi3dU25DdjmrRU3hkbJn
18771	payment	1726	1726	1874	1	1	7799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2dxW2UNvZQJXqFvvXMwrqj9Co7nDrSWGaWw1KbY7JzWhYLTP
18772	payment	1598	1598	2124	1	1	0	300000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBHs8ynBWbn2mmQxnhsTiAjKFdXtFJe4D4Pc31QvZymvDn3aX
18773	payment	1397	1397	1678	1	1	8536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqicc1Cb9AvzgWMJsepSt5LSn6WUU88iXfuD74rvuhij5KJLeq
18774	payment	1726	1726	1874	1	1	7800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDzVLaT462jhjnuTVdu3mo89g2xhZUAqGXPephGMn6S7H4MVv
18775	payment	1726	1726	1874	1	1	7801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrnL2ML3hW29MKnqzgWEqfXqSg23p5ZLCL3NLR6BGLFkYFtNm
18776	payment	1397	1397	1678	1	1	8537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERdvs5ZCu6rkezEkNt2GVj7HFmBxtbBHi3VNgxNApWMxfJmWP
18780	payment	1397	1397	1678	1	1	8539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZb8Zn1FYR5F16UeAxpjHzKAzGRjQ6g3Tvz5p7HhnUqnohWG9m
18781	payment	1726	1726	1874	1	1	7804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGhLjw5Kx1xXwQXhWdNJUaAYvZMLYVoCKy2FQVCdHvjvSTQnx
18782	payment	1726	1726	1874	1	1	7805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiCmXUpASaHxw3v6Qf8fw5grPUj845r1ydHMnMQvC6aYoFpRs
18783	payment	1726	1726	1874	1	1	7806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvNi3d3fJsXgFgjsatCTRiD5iW24oSehNJMaGYA1hLHwqrq8X
18791	payment	1726	1726	2125	1	1	7811	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2pbEJGGx6NmhwRovYoUxCqJqHkiFj3gy8EQdtXTz8cjfuAJZR
18792	payment	1397	1397	1678	1	1	8543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmWPwm3zxwwbMQKRvCja9GVSYNxa58rvwjwhaNtQVcf1PxpsG
18793	payment	1397	1397	1678	1	1	8544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAry7tRikKv1G7xQGmu8b7D21sCvgiXXzv28m6z7mcukzbMSc5
18794	payment	1726	1726	2126	1	1	7812	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZb1bun6BwdK36Svir3Dj4GaNr5ADymPutrnY9fqMvFUFk1xDLV
18795	payment	1726	1726	2123	1	1	7813	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSSUMoTYb87KYhXeCJddTnipw9TgjUY67sNnEb78Y9UDRNjhv6
18796	payment	1726	1726	1874	1	1	7814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9LvdxVCEFZVeKWgR4L9R12i8vjPLk4UK4D56SoH2tbLexCWc
18800	payment	1397	1397	1678	1	1	8547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGpdi6aH9T6UVzXKDWhD9KhuTLmd2VgMcB3j78QeaotimL8P2
18801	payment	1726	1726	1874	1	1	7816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3LufAJUy7X4fEzYarRfQbgToVWo8WkVLSQ1XSzJ33D1wokJJ
18821	payment	1397	1397	1678	1	1	8555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Tj5Lb5Di5MS8wTHftez758qdp7N1a3UQ3LtSXrjJi9W9d3m6
18822	payment	1726	1726	1874	1	1	7826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaYpQ2ufhXy12tV6ysKmE5FkZU24tRCxjWtXXPXQ6JV8NhgJi
18823	payment	1397	1397	1678	1	1	8556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxtvxq9TH5TdAXU44H6KK4mE8hsgRvuwqGMoZxNq5sekgTMRFJ
18824	payment	1726	1726	1874	1	1	7827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMEVHPwCx4zbdDJgmqpDFu6QPwYsqKe4BiwKFaGuuSrZS7HH1
18840	payment	1397	1397	1678	1	1	8563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BJ2VNxEyY2bjqJkAVkpr2vcdDY6UsUcp9vZL33MUuiYcWRga
18841	payment	1726	1726	1874	1	1	7837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEhTfcwsYtxBqVEjfXVLfUdusX5rMYk8ZbngcMDtaRwvMRHWL
18865	payment	1397	1397	1678	1	1	8574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1juhLtYsKAYV4a4ThHAs7RZc1oWwxHqU3hvtV1WjYX3FdXXE
18866	payment	1726	1726	1874	1	1	7851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwqhthMwuN9EWkBf5zn5waHFgh4pSpRJxULKASvApbFJ6pxGR
18867	payment	1726	1726	1874	1	1	7852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHFJsWnvnAaA2au2awcP6qDrCrVYJUoM1cmK84QrCzuSyzMkh
18881	payment	1397	1397	1678	1	1	8581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxoo8KYsf1WXSeYtpDWyWDHSj3KZYT6U9G2FETupsBTBsFMpd
18882	payment	1726	1726	1874	1	1	7860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PzTe9tbkufZBox5vWQ8QgVPmgc4Y4DakiX6UG84SBTC9g2Fs
18883	payment	1726	1726	1874	1	1	7861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZRKecb83EovDByAiepWZyxBrDMHPvr5o5fV4qpikceTRuLAB
18928	payment	1397	1397	1678	1	1	8601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwpAW9eRPQudXuhePc2kx6DrasV15JsaFxsi3C6CiFg7kyDH2
18929	payment	1397	1397	1678	1	1	8602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtpj3AeET3rLu9h7Fzr2yhgvW1UJDwyMMTabm8GUGinh8MLV7
18930	payment	1726	1726	1874	1	1	7887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sJjGPALLbcnP8CKTHizMLBhp1BkaERfecczurnwhnDNeENzr
18931	payment	1726	1726	1874	1	1	7888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUt43B2BN7vXR6xUUC1GQtRXxidnaa1QcN3KomEKVUqEDBPF5A
18932	payment	1726	1726	1874	1	1	7889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrF7zZ8iUcdmzsjv9yZaNwSaRsYBCNTf45vTDX4sKa6Juv7pAp
18947	payment	1397	1397	1678	1	1	8608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhqAy22WHe4BQYzM8kRaAhCy71oLRdHS7NZqi3DYn9FL7fZ3m
18948	payment	1397	1397	1678	1	1	8609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYej4XrndnZyw8ZHYJ3piHXJrVoW65qAvKhdzaSczbWjK3HG6Y8
18949	payment	1726	1726	1874	1	1	7898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzK4dneFrLCE1F5gnTKp6ipnSnJuVqxLKm2iDibNoP5U96ZcrT
18950	payment	1726	1726	1874	1	1	7899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTiuXKSnQBtbYX9sQLKUo3sTNePNhAZ8pzBAzC2DGUjhNVGMy
18777	payment	1397	1397	1678	1	1	8538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mqQi16n333Y1XWu2eD1LMPU5kEDtESdnDzP9mfG3A2Ts7t6H
18778	payment	1726	1726	1874	1	1	7802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DDzwWiaMFym3xM1g6QLuryap9qVyUTVVVaUBRkUUX4qAeiUJ
18779	payment	1726	1726	1874	1	1	7803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZivrCAJdhotePAmoymGimL277AbwYTh7Ui2Nvq2UHTNxER1V
18784	payment	1397	1397	1678	1	1	8540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa52XW7DN4hLxUoYYtujBA85ULR1qCsKALmNBWLJQc61BhqvVm
18785	payment	1397	1397	1678	1	1	8541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoAafGeK2NmG5f8MfKgmvbqEeu45bHkSgtmpMPTEjKc3ppFZ9
18786	payment	1726	1726	1874	1	1	7807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND1HnvemwY6fpHpn4tauxxMpQ45MXH7kd9Fi3TmqbU6XRxcmf
18787	payment	1726	1726	1874	1	1	7808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY87zrCSfnVX71bw6tY2eUgW8xrATmWvSCytrrVnkTQqdnebi
18788	payment	1397	1397	1678	1	1	8542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59doufV1TMuqyRnMQxijYr1EqQg9JdVK9j1Yj67aevUgm1Mbr
18789	payment	1726	1726	1874	1	1	7809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjArHKPS2dVwwNTZcWhU4K1eQJeJ8xzehiFboeA8kwruXG2ubf
18790	payment	1726	1726	1874	1	1	7810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegCVjSiLN6xoRPBNoXheLayeWtuSqSdJENywkZvN1NFi8SUSc
18802	payment	1397	1397	1678	1	1	8548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzQ49Atmfc8baPogGePiDmymGAX3dR6p3ih3tHf5N3ff1dmdz
18803	payment	1397	1397	1678	1	1	8549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGujUA1YFL6cjLmJkAVw9hXXU5SCGLL9e75bi8DZH9nJ5J3UNC
18804	payment	1397	1397	1678	1	1	8550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2H14PUg6hADChypThk32oKpig79ZG24wGMhMzQzc3b3C4VCGh
18805	payment	1397	1397	1678	1	1	8551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6oxv3irjKkd5BNjdyBVD8Q8smTAKcqSRDiayZmSwYxMcwQQJ
18806	payment	2125	2125	2127	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEj63gziPqkoozgF6y8BMFYJ1RUg7ZKqSKWdEYcUGBbeco39B
18807	delegation	2125	2125	1407	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwN6tnUzjLB2AkzjGJppYhZgSpd1iuWCcisX5jUvrvvd9Hq8Q
18808	delegation	2125	2125	1403	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycgTvQboBQVwo8Hb8xPrmRVY5an7fYoxyb8CqBcAi6ikq5ady
18809	payment	1726	1726	1874	1	1	7817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2faSxcc9pYQCJMvKpVD4MVm59XBQj68XghbgCYugHmZYDpiPF
18810	payment	1726	1726	1874	1	1	7818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iyucoMgisdBay6rShmgoULaacwq5HNzAAD2VPkZhGAyPGuen
18811	payment	1726	1726	1874	1	1	7819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKnwVT4wU4eGngjqmgBwQbpoHAoFVPfQDvXqEkQVSEzJzLhpg
18812	payment	1726	1726	1874	1	1	7820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5XMfhqKWdE4kEuZGMd77k7ULg8cQRQmhXTBcSu6jMrG2123f
18813	payment	1726	1726	1874	1	1	7821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZrzUKVR5QAi3dRMYjaRdBHkKdrHYkX7dwc6KBpB2sCYin4sV
18814	payment	1397	1397	1678	1	1	8552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTDEc3ah7HUy55mEMjVozFWVZBEjc3BGquyc8RBC71uZ23ADF
18815	payment	1726	1726	1874	1	1	7822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBtHM5K8jLyzmAiBRuWrpX1GYrokssb9T7kicsUrYfqptTaKc
18818	payment	1397	1397	1678	1	1	8554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MqastXoChKMEUAVm1iV3CPFf5LrMdZFm9H6s4qRCJhaVpDXb
18819	payment	1726	1726	1874	1	1	7824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMe5APF81Y5deiH8Lm147HiURKbtq9RAPfrWmHiNHyhKnzfjU
18820	payment	1726	1726	1874	1	1	7825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSGK5uzm2CXTTujCtN9prgXFbKZaChboAE3BZAGnRPmnf8EJR
18830	payment	1397	1397	1678	1	1	8559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATDcwkep6c7jjgyZfLS7Re6Aqh8MM9YtD5Eyjq3jpyCXXY64Z
18831	payment	1726	1726	1874	1	1	7831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MLLPvrBtUDJEn1dYVBtEfKTovC9kfzHD5EMN4Qon82VQB2NU
18832	payment	1726	1726	1874	1	1	7832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41y4JAf4vKJEwDz2WZMpJLQoTH35HZEuXt9CXGuJLH6zpTJbL
18842	payment	1397	1397	1678	1	1	8564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawpvfFbfjSLjkuAsKqexaXLocdPi4kYRUMMEhXc8bbvB6Tuy8
18843	payment	1726	1726	1874	1	1	7838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpMyJQbQRyvqUeQTNS3EQoryTuWudR58yyj8YqHhNFw3oQFKk
18846	payment	1397	1397	1678	1	1	8566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SZiys4mwPpAtcATFGzQzEVh3gQFKESybEHFjs5UrVKn4knqH
18847	payment	1397	1397	1678	1	1	8567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4X1b7iQXHCzFzXWsPnJwCrvfDhiPLWrPkWfys7JCR4whkSt4h
18848	payment	1726	1726	1874	1	1	7840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ4yiZQH8QsquSgJBQPdLc5rucTMGC5sNJ9RTs7kH9uihFdsT
18849	payment	1726	1726	1874	1	1	7841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWVGbBqhVQhASiNcTwVffmE62oCMfWP8rXCQgLibRLbCHYdg6
18850	payment	1726	1726	1874	1	1	7842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAzfp4MfeTPfihUEcKieXbgKx9QKUipzpmUmA7ByuHy3otn37
18858	payment	1397	1397	1678	1	1	8571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoDFZkEnjmcfC2YJeotobt3DrxdfqDG5VqMsDCFmhEKKn9WSd
18797	payment	1397	1397	1678	1	1	8545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAZGNDXvv3aqZ6kNbmBpevvH91aSbkyrh42hLn62vVkMk95Ai
18798	payment	1397	1397	1678	1	1	8546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnunqf11iu4jjg5o9RDgidnHxuDXcmU4CLd7UapkRqsjhqrgk5
18799	payment	1726	1726	1874	1	1	7815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqUAmjaKr82Tqg5sy5XQcGmvtMMqTUfaBW1fBsx51G1P68QJe
18816	payment	1397	1397	1678	1	1	8553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxmz4u8MGP3DKX3VAQVBnyMreaVxqnz4wDqns4m6ktwrArFz6
18817	payment	1726	1726	1874	1	1	7823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVzxfCqMnDT115ybyH2erMfodWAWzLxS2d3hpjB6gFth3vKw7
18825	payment	1397	1397	1678	1	1	8557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyJmQCoWKS23LNmoFJAxG8YbyvoXT3XacTSa9QdGDL3PV4e49
18826	payment	1726	1726	1874	1	1	7828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkJjR19VeVeFXtCsR9cezyk6QcfGQr43kK4ikrgbzujE3J77R
18827	payment	1726	1726	1874	1	1	7829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsSFPSgJoMyAA2uwzvc99aPk6FRFFAZmyd9kou6ZKt34PWmPa
18828	payment	1397	1397	1678	1	1	8558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAqQHcxE1kewQUPbFSMuDqxqWf4bEMZnpuwiXE5cpiTr2J8Gm
18829	payment	1726	1726	1874	1	1	7830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZx8RSag7hZQJk8cpwgKVA5zjmjEYCvtcLNUWroXnLW228fPFc
18833	payment	1397	1397	1678	1	1	8560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivunwRkKu1frA1nDKGsWX2XjRgJwkt3akw5cUpkhNGGQ7TvzK
18834	payment	1397	1397	1678	1	1	8561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JoNxXJEGKEuDuQFKjoJogH1jS6rBzjykHSEFMLh3JfQ6Ag5n
18835	payment	1726	1726	1874	1	1	7833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yfSrEog1UL8Tkg1keUauH19acfJBpQkH68hxfj3g2VLBT1bp
18836	payment	1726	1726	1874	1	1	7834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYcZw5KQtFHhpG3FXnqmzR9Dwb1TgHb97kYMFBA75DgEQdvJg
18837	payment	1397	1397	1678	1	1	8562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsw1pcSH7iaY2tvWNMxq1TYDHHtFzGDVrLKxnEambZ8W7KD85N
18838	payment	1726	1726	1874	1	1	7835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGSjsiNgBh71qjTfabjjwkASQbA9uFkPeVSTmijJZPVSmnNw7
18839	payment	1726	1726	1874	1	1	7836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VLTptHdCe3TUaNb5cJiRYwj4jSsyXhyzPn5Qzs75XKKP7AXr
18844	payment	1397	1397	1678	1	1	8565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgEQeSUTcmeQWNDyx1c2spL3JQpntCjgMkoo37DEscoLhEAtL
18845	payment	1726	1726	1874	1	1	7839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUAbKgdzCw4PaYDP7wujHDZkpT8yTmrGHfP1A2ggvdgn4bnXx
18851	payment	1397	1397	1678	1	1	8568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpH4YdVe3pYdagu9YKZj8jZuWG7e9B7LDGsEJjV1RBbjQAK93b
18852	payment	1397	1397	1678	1	1	8569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXESb1QdH6oR4CbEt3Gewerg8SZWQv1CL8RedExqWALzn5nFyx
18853	payment	1726	1726	1874	1	1	7843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQPhi7MzSFYhDhfjbXrip2547CAkP3yscqAwNZND3a8T2MGzr
18854	payment	1726	1726	1874	1	1	7844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaw4tfWh2DzugUxsUxbznvPAZ11Vq2ogjhcWL7aEEWi2jJM6p
18855	payment	1726	1726	1874	1	1	7845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1muqhmj7p4x7soCatp1nWr7GYQQPiyLCgsZbarJMVmdgbJQf
18856	payment	1397	1397	1678	1	1	8570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiWFhQtdwzXcJRx3miB1J3RtHwM1PyL1Tk6R7e7MeKJbtC1Qq
18857	payment	1726	1726	1874	1	1	7846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjozbpxiX8jx7kPjnQbc9S4NVAut7fxPZnYdVVQp7j92S6CEF
18862	payment	1397	1397	1678	1	1	8573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiz52a3SwYJ4XevwRPgV8wxkSAqijMmW74SDQXA2L5GeCr4F1
18863	payment	1726	1726	1874	1	1	7849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWt4EALqZuZBBU93eNfuUktbi2VWqTSoyCznmxtd9zEEu8iRFE
18864	payment	1726	1726	1874	1	1	7850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8JodPH3CpFEWAP1z8GjMKfqxnSMJSadaB6WxaS8DHBnD1QvA
18872	payment	1397	1397	1678	1	1	8577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZED1amWjtgaZh9MHeyTZxG6hm97WrRP4gam16r4t5R7mFXv41h
18873	payment	1726	1726	1874	1	1	7855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrii1fbviEDCwJsVxzpeFQjAKtNc72ygr1Edxs6aaph2NpWXm
18884	payment	1397	1397	1678	1	1	8582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMBdkFxXm55uoLttg36hVetwfAwuLGeikVdm2XN4DLCNj9ybh
18885	payment	1726	1726	1874	1	1	7862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5h5inTNM6DKLUT9YuwPJZbrcAYPcsLoeHjBa3hNaFhcJSr3E
18891	payment	1397	1397	1678	1	1	8585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihacY9FtAw9aL2DqNw1TLNpVEbJ8zQB1MFnKBJAvVafaW3ZaM
18892	payment	1726	1726	1874	1	1	7866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxLpEwUQjHs9YtnE2ZxiofrWX8Cmg48ECFJtBiuFgLED9JNVD
18900	payment	1397	1397	1678	1	1	8589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtwWMYpeanNxGhkjayw5VqZjZuRGopRYJxDbATRb3Dhfygp6J
18901	payment	1726	1726	1874	1	1	7871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv5XcmuNpLaBXnrUts8wn2MYr2sBCAmpreU45hX8AFHzc4ASa
18902	payment	1726	1726	1874	1	1	7872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nUUd1dXcpCwgVk598xVjEw3BNUBcnwowSG75bjo1wxGybwWF
18859	payment	1726	1726	1874	1	1	7847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV22xYybRJvzsccFw5Ftys5z8Pxmood58PJjiHKfK2TxAdnFz1
18860	payment	1726	1726	1874	1	1	7848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeTJ6X3tL3fEei1PQ44VgNiqM65jQmgBVDBd22gheTsmGJG26
18874	payment	1397	1397	1678	1	1	8578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSXMyMtad2SKWwjrvYjxi7uz7tQfbntU6gDoneGks2bqBurQ7
18875	payment	1397	1397	1678	1	1	8579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhR9XqGf1VEVgUL8PbhXAwYePvcXyHiXYwG3jCSygZt43WGEHd
18876	payment	1397	1397	1678	1	1	8580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixNZYMPEudkAKPKPkLDT5Wvyntc3e98BaLsdjffpv79ocgoHa
18877	payment	1726	1726	1874	1	1	7856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5VCetJ9LPGE19fL3MpEKzqn9E1kAwbgYjhtHJYw3UTvn7ujT
18878	payment	1726	1726	1874	1	1	7857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyq31fH2gZiFmvvWERcjbxi8fgNYwpVwKmbxHa1XPWi8GX8wm2
18879	payment	1726	1726	1874	1	1	7858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36S99iCW3rmtGSXMxtphPuHu6UxLt7fNVuZDqDVNx8LXpGhD5
18880	payment	1726	1726	1874	1	1	7859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCz74btSGsiRyFheXJotW3K5yXSHZujUQ6Rsok2tLeVBf1YzX
18893	payment	1397	1397	1678	1	1	8586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwK1ccMWEYvpszdkFFQrULjtVZ3m8Xk5TfCMEfzQnUh7BT5Mia
18894	payment	1397	1397	1678	1	1	8587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVxKVs2f5YysY97SjPnZEtJ2oMDvUVocHXdANvoqZjkmj6VPm
18895	payment	1397	1397	1678	1	1	8588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SCoHJjTs9GH5jEp6HkeM5XJSURdbZwXH596PrtozjVwqXm8r
18896	payment	1726	1726	1874	1	1	7867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfLRaaY2pWoPkTuC76an4PcBhnKaQs9CL7FdnopUnje6HHoU8
18897	payment	1726	1726	1874	1	1	7868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzqyN3bZGYFi9A9i9y3xJAauoT7FNr7jcHM7ufAzmYRHGxteK
18898	payment	1726	1726	1874	1	1	7869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjReAPP3tC6ArcxZe6LE5BBQfg8Psb1vW7VVHQSstmozfCEEG
18899	payment	1726	1726	1874	1	1	7870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXWBHe6E9MGR8TFVnDaL8EJFFYAfM2VrZEjo8jtFUJZPehf2k
18905	payment	1397	1397	1678	1	1	8591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF27puEM7czcaogYkN51pZRHbiksmmhSnGrf9FVaYPcuqTCTaF
18906	payment	1397	1397	1678	1	1	8592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCkHhhoUE8sWRK4fYZRRczTu1bJpRgrRXsjPDDBf3YFoALAHq
18907	payment	1726	1726	1874	1	1	7874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDZp8gZ2J47RcFxZ24iciSDTNutSnKrapY5vvceXZTuKq58sd
18908	payment	1726	1726	1874	1	1	7875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAomYWCtaZusERFZSqMsPX6ZZwT27T8pZfGbdVumh97HHY37yv
18927	payment	1397	1397	1678	1	1	8600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHBHDmUKjTFqaZUKNgESF9EyS9AqzQv8V45aUAn3Z8bwMZ4fX
18954	payment	1397	1397	1678	1	1	8611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15uN5zUFSGUpzdYoqF6noTLVqtGVSEqQAshmepTwL4xJUqBtm
18955	payment	1726	1726	1874	1	1	7902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ygPttnZrPng7zGyeqRp5RH3e4PThwZhnvbbwwkzJaAv9o56C
18984	payment	1397	1397	1678	1	1	8624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQ4qknBBNtesBurAMtzxUjytDfWfnq77q8qMgVaAzjyHrHmgV
19012	payment	1397	1397	1678	1	1	8636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1FYsYCuFgr5SCUavXYBfdxbiKbLsT8k5vCkwnbsxKVfwK3cz
19013	payment	1397	1397	1678	1	1	8637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa91T2c3usq1TWkZLzDH7NWRrWqhGz2beYiaMCtuyZy4vRKftsX
19014	payment	1726	1726	1874	1	1	7935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDU1KnRNmtJJhfK6KjNGMD3H6ouDTagKZZKYDj3wXEVSiC3em
19015	payment	1726	1726	1874	1	1	7936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyNV8g3r66mtW5k3PpB4iC5hUP3s2RuvdwJYRzNyDh85F1SqS
19023	payment	1397	1397	1678	1	1	8641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmQPQ6GfBpzvj6VdCt6F7j6FGRKViC7WvwikthbCKRKbYej3z
19024	payment	1397	1397	1678	1	1	8642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFU1xM3CTZxEoRBkAzz87FiXxdiuNUoZvNCVnbQd9bW1XrFWJm
19025	payment	1726	1726	1874	1	1	7941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGJYCVkzNKXXdtKj9NG8JB5aYYaDr28vo4UzhYJSiJWby3LTP
19026	payment	1726	1726	1874	1	1	7942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98zTrVG4LW7mmRkFLg53XDke1cZKcqRSLCZ1sECvCwbJo345i
19027	payment	1726	1726	1874	1	1	7943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNyybzWdYuSCVwEd6xwYQY4yBjaaKLRjdduJcXVVjN32JBKmm
19050	payment	1397	1397	1678	1	1	8652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6uU57sAUhFTqrn7Bcrc49REbYedwmCqd5z8NY3TmzhgMZrvn
19051	payment	1397	1397	1678	1	1	8653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaJZUoSQjvMtKMRK6yrkb49AQ1JQ1wHekACS2eo3TV6gG6bUZ
19052	payment	1726	1726	1874	1	1	7957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCAN67ptgaBo4WxwvKsi1UeEuFoTcaQd6aa7a6SEFXM94zHEe
19053	payment	1726	1726	1874	1	1	7958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2ggfUMqYJMQyihYrfnmBvYCEYFJWCj5U6WU9m5CNtm8woy16
19056	payment	1397	1397	1678	1	1	8655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTAvFJLiCHQa4vRzxaPurhPSCUQBE8T1hY4PK1863vmyeJGy3
18861	payment	1397	1397	1678	1	1	8572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwdQWTzf8wVyARfw3j8zRpTXHtjRZzsT13GjVQW8rPcQJp95d
18868	payment	1397	1397	1678	1	1	8575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEe1dX6jufxKwPoAmmFJddVhxmcHxFjaxGVJstP513pxqXKR2
18869	payment	1726	1726	1874	1	1	7853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyALk9bgHXcHZGFQ4EYCN5vSF9A57Nipk3dwkpp51jENgf3Nw
18870	payment	1397	1397	1678	1	1	8576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7WSYeB8gWvg6CKdf5ZVvvKRdXJ8adPksEJQEP3FAPBd9YfA2
18871	payment	1726	1726	1874	1	1	7854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcvpgaWJmXcjjjLyvkKmUUoZ9yBQJGY87PJBEBTkMXHiFjayW
18886	payment	1397	1397	1678	1	1	8583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XSiDxofkczPQFGjTVhptfN1qjPHyBZkjVGKQvrxZVpKytjsi
18887	payment	1397	1397	1678	1	1	8584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaewpU5jA8xxs5YLovb4UKbNFDxAAF5M44jEWCpbkbZhv91GQY
18888	payment	1726	1726	1874	1	1	7863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPb1GAXtyZGoiRPgL5dkoKTuPzDRUV4zEr7dNWuY9QNMSaejvQ
18889	payment	1726	1726	1874	1	1	7864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmASyZFnQUGdQRc8W7WWpDD4UZdnjJ6Cw6aYWMdVCQYTWJfzpR
18890	payment	1726	1726	1874	1	1	7865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYhm7oHWdzS85JbcDuwSBLvo34tLwS7HDmttNk85WnsyK3ZF1
18909	payment	1397	1397	1678	1	1	8593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtqZeCxu6dgJdPojnFykk6xQVUsrb99FXnDxE4ER6Ku6LE9cVw
18910	payment	1397	1397	1678	1	1	8594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VzibjBppKDHUDDakBNxZBL1KRU4QJbxPhgLumCrpMH4AE2gB
18911	payment	1397	1397	1678	1	1	8595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UEvRo1YvWKP1yk5yZVRhLTjj9vmNw3WzHUL2UDzwdBmXyMSs
18912	payment	1397	1397	1678	1	1	8596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMD7ZyqQ2FmbjsxYioTwCvyKt83VpmtyQApNcbafmADWUcoJ9Q
18913	payment	1726	1726	1874	1	1	7876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1heyAiVvmASm1L8VfBz8EBEkGeaEZzBgt1YHi9MnekvuryRk
18914	payment	1726	1726	1874	1	1	7877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQW9f9RsbYaZV5aAj8eqkDcRb8m48yR9qx2XFLXwMgrJtPaX7
18915	payment	1726	1726	1874	1	1	7878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vs2XBaHnbed7EaKNWSeFnzvJ5PE4ge2ekrTHhnmA9dRrGGUy
18916	payment	1726	1726	1874	1	1	7879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfv6EVcoVeYA7K3v6Kk4u5EGuYxivW9gCSwycFGjr9L3FNkHui
18917	payment	1726	1726	1874	1	1	7880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrj4TdPu9EpQ4VLbgJ6BJ6FpB87X2LZdG9qkASLjj5ysQ1aJWp
18918	payment	1726	1726	1874	1	1	7881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ542tR95VJNQYQaQerz5mYswSpjVNMHsQE3P9pTswDGCfiBZW
18924	payment	1397	1397	1678	1	1	8599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiMvFDgE8Y2osiVXk2CrkE2YGKXBZeSSQY3WZKTnA6Cq5hJiP
18925	payment	1726	1726	1874	1	1	7885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YBxquYaUPJ9DW36g5bF38sEXqnaQy1rhAst73piW6uuaPLXs
18926	payment	1726	1726	1874	1	1	7886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDT7gPXn6dpY3AYUfodwUvZPi5fxiMrTCpFAWsYfGG6G71dgr
18933	payment	1397	1397	1678	1	1	8603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaS8VP6PTyh8q8yVUBoXa52RVZom9qvfGJBx2rCLiEyjhW8Us
18934	payment	1726	1726	2128	1	1	7890	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmzatVp53AzhQdBBACfZVAcgzsN5oYRvAefNmMR9osixCYuiFe
18935	payment	1726	1726	1874	1	1	7891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8mvK6PqriXPdCzDY7EyT5CxvZtJkTVuSye39MM44DpNs3zdq
18936	payment	1726	1726	1874	1	1	7892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjuHVC1homWfqjGLf8W5AosdDvTJiceR295J7ZQ5ft66oCKM2
18937	payment	1397	1397	1678	1	1	8604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcgnB38C8a3RsNWe4Xeq6QqVhsDvQMp1BqofQ5wU8kZQ46pQL
18938	payment	1726	1726	1874	1	1	7893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSJsTVUJDVaYeWCXDt6rPzivNVcWBAGqd3Sa9GKPQMx4KThmn
18939	payment	1397	1397	1678	1	1	8605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdai7W1Tmc5vmjmo1HZMwVCb37tK61k3PGdztFBT3Ujcie3jC
18940	payment	1397	1397	1678	1	1	8606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9pSwP9jrSVyw7ianQQbtESChwvWUzWnV2eWeLkRNuC7L9vqP
18941	payment	1397	1397	1678	1	1	8607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGK8bVvhKYz4WvPLJutcTeUVPjzxJ5A6R89SVEGmngHZK5T1a
18942	payment	1726	1726	1874	1	1	7894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYvWwr1BG7eKQmxA3ixw46uvHvfoUGqx7Y8YMrD4UTxV6DaR1
18943	payment	1534	1534	1694	1	1	0	4320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kaia6dmHhmkvEgU7yZbcKCirsfVLmi1ohie2yQv2Qt7n4a1i
18944	payment	1726	1726	1874	1	1	7895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAX6wCk358cqBDxoMoTeuKVcQNsR4qv4R5Pgq17BaD4ZLxy2rn
18945	payment	1726	1726	1874	1	1	7896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX5WkEUX3ysKYE9Z9P2L1n4G2xn52pmUCAyPrm3So4QttkuSJ
18946	payment	1726	1726	1874	1	1	7897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDWLFJDr6eCHaJ6wgKzZ7AygcaPvEDoBHfPprkAf4Zu71eYVJ
18956	payment	1397	1397	1678	1	1	8612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9nezH7ggrGC17iZXTJPGkqoEMQ9ToddA62gCDNRgxVWuZZR4
18903	payment	1397	1397	1678	1	1	8590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEP5aqRVKwfyaX9RSWvfEi9bpGFQZ6JKJyYdRkKD1ESEArDgY
18904	payment	1726	1726	1874	1	1	7873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaVSFTY9gThieikWyneJkRDDdJ8BVkM3HQmDX77EQ5cEpoqeV
18919	payment	1397	1397	1678	1	1	8597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjbnV9mBEkqvwXRpbrxR3im5GRBHpJWLvr9RimcX8NSRRtv7o
18920	payment	1726	1726	1874	1	1	7882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHxxegdp3g77XghzY1mWHteRaSsebUreaUegDMNSuWNKrtMpx
18921	payment	1397	1397	1678	1	1	8598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rgs443pAsHuGk7q1qmVbgmMBa4fC2hrs8oq3Pb35c3nBk987
18922	payment	1726	1726	1874	1	1	7883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QHPB1u9bgQtY6doXd4bPwrz36jAsfAmTrPVNYkqtpHeVC6X5
18923	payment	1726	1726	1874	1	1	7884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVWS5iheBBb6SNy12xVdN2CRUcfhCoUuvX2FHEir6bnzJ9HxR
18951	payment	1397	1397	1678	1	1	8610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQaTZZwz2nu2UuXcY3Mbbv6HYMGzyByyJJkdZbFYK1uLzyyUx
18952	payment	1726	1726	1874	1	1	7900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxchEnVdJ54eEDDuD5jiVHuhUouC7QkzeGPXMcuzzgLzd8r8di
18953	payment	1726	1726	1874	1	1	7901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJJQ4ofamw2P94KyxvYVtyrsZxdV5qQxhyZRkgQniGomQiyUK
18957	payment	1397	1397	1678	1	1	8613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa5ThLRMF6pLy4Kv1XKWBPxvBEpCvoQnPCvEqUgaavWowPaki
18958	payment	1726	1726	1874	1	1	7903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUyL8q8m4Eo4UJB4qFAgJduofKXZu4pmmoXKadWS15deCiLuh
18959	payment	1726	1726	1874	1	1	7904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7puaWHogTQ7gFVHVXYNaMVaX7Qkca2niqsBFSHee3oUsu7SzU
18979	payment	1397	1397	1678	1	1	8622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUNTU6Vcr22Gvm9CSeawQE6WCQiCVmffeAmHxCBqUc22dagU2
18980	payment	1726	1726	1874	1	1	7916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4P361HVDspjYqXkanhZSvtMcbop4HfuvjBL9eaM4Vhx7qtLoo
18985	payment	1397	1397	1678	1	1	8625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85GunK8w2xiY3XxZZSuLrhHa5s6koTvUmbvBW22P3gPF8UxGi
18986	payment	1726	1726	1874	1	1	7919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybrfCGrRas8uCVsFE28qSS83e2vpyZjULenzZTjjrVNrocNJQ
18987	payment	1726	1726	1874	1	1	7920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxd8xeb6UBJYUyJC6ssCKDfG4sFYxfL2XuurNuheaVHkSVezv
18993	payment	1397	1397	1678	1	1	8628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp33p3s5HZkXmxtRPDEehC69vwWu5dmRU1Hgsf66622VeWMA7
18994	payment	1726	1726	1874	1	1	7924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qP8Nan4B5gTwiszDNinpKaFygEv7tFBoCAQ4MxVUwMhYiESY
18999	payment	1726	1726	1874	1	1	7926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEuVJxtfukomuHR7tjToGUayqvPSZMhGLjvnRLaegpo4DvixPp
19000	payment	1726	1726	1874	1	1	7927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj1w4SU6MaoKjZChNrhc8DEkejDaEdRCDzd26xMPNpSP6Hcg2
19001	payment	1726	1726	1874	1	1	7928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gSeeehdLHhxr28G8E3LnGtfytdsXq973wdbkbUtCDYyZtYJX
19002	payment	1726	1726	1874	1	1	7929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjdhvVFJaBLkypgE2ZcktqDnMN4D2RRxvHizEC6fHM6w15yTt
19003	payment	1397	1397	1678	1	1	8632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWLFCG9VgFNUBjwJ7jawxoPQ6jfj3AhavbwwmyD41ZTmyvNN7
19019	payment	1397	1397	1678	1	1	8639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWZN98Qmq33MNQAS4hokqyt6Y6qiizXNf9KFBNc3Av3UwwGsP
19020	payment	1726	1726	1874	1	1	7939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTFVXoqL5L7LUhTpUKKCFczcqCnh5T38sVP5NJZPZK5xUjaps
19021	payment	1397	1397	1678	1	1	8640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hD73XEvY5TQg5twY5DrSGr23SCjJFQj8o3RrvErMjAF2qvt4
19022	payment	1726	1726	1874	1	1	7940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy2tmeRn358mNRBUmDLv5LD995mjehCKbpeBeZVxLyt5b6S9S
19031	payment	1397	1397	1678	1	1	8644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyViNHoRox17k71GBGBMQrbbC4fTXeFunNemSE1xuuvz2KEmH
19038	payment	1397	1397	1678	1	1	8647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYuWUzhCd2QtbL6Wg4CSsfKLNdccEgJ72aWLcWziNuam5fiiU
19039	payment	1726	1726	1874	1	1	7950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu1HXNM7u5ahTXsFxKaZdWLLEKfM4eQn7N5TT2xRwgjhGJBQj
19047	payment	1397	1397	1678	1	1	8651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jwErR5QBCSyQnLYDLBDE8dMCFAgkXbPtAPW5ADWRnY6LRJTG
19048	payment	1726	1726	1874	1	1	7955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H5GNy43xD5vfEMkBy1mKHz8ATizSYQJnwNzBM2R2rvPGpb9s
19049	payment	1726	1726	1874	1	1	7956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDCJ49Sp64u7kRrHjY3ymATsnocJAfd1UwAMtbtirpHognsfb
19063	payment	1397	1397	1678	1	1	8658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRC6R3GfFo7PaEWRdQmArfjb1bkiiDchYJzszCXvNHEt3Urm34
19064	payment	1397	1397	1678	1	1	8659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfh8ePKvG4iTVhdwceXEpyawz8s4CVcAAuuauEMU7m8qf1ShV
19065	payment	1397	1397	1678	1	1	8660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDc5c4zDxikYjoSxSJ9ju9wZ7rfhUEviTUY6AbRG2uZWkifpr
18960	payment	1397	1397	1678	1	1	8614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1GQ8EcfrLN9JDJMNNbucze5kngNqMRfcER4o5isgyXkWAjS4
18961	payment	1726	1726	1874	1	1	7905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJqAjt1dsuYB19B3wmyNmxtAEfKxrUyEY9KQ4nmimjyFs7bjE
18962	payment	1397	1397	1678	1	1	8615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj739tw1hDV6U5mCLxtNBb74ATYxayJh3AUBoGCEpeNaAHvJxs
18963	payment	1397	1397	1678	1	1	8616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZooVdATJtyLqnE9ozGCRrhnADaufXg7dacybsZEARLJPiW8w
18964	payment	1397	1397	1678	1	1	8617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdE4SvtL7JvaisL8oiWhWrj9TScADtSrUTA9p4ZDQqw9XQkmu
18965	payment	1397	1397	1678	1	1	8618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2y4hsi4FavtFLRDVysWjpkFZMHg1CGiQo4x1CkJ5iGpmiYU9L
18966	payment	1726	1726	1874	1	1	7906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5DGkKK7EtEqKdcEh3qsgQkPRBirrvfnYPWSxyq4VvnGRkzgF
18967	payment	1726	1726	1874	1	1	7907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjzi9ziMtjg95HomgRaJEVQV16KZjNUWzhhohVsfJo1EKhGrB
18968	payment	1726	1726	1874	1	1	7908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcn8wWTN6ficRoNGtkQo9EC5aVGyM6sUNWXqH7WVcZGa3LTfb
18969	payment	1726	1726	1874	1	1	7909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjZ2u5SfUZJWGmbgCa6bQ8JnjTJJUcJxzc1JMjgfXPQy6kUrS
18970	payment	1726	1726	1874	1	1	7910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYDehbXA6HZfAR9N8DET9oJCEMhhS79iP3Hu6hKjcCsAhqqa9
18971	payment	1726	1726	1874	1	1	7911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfk4mLArdifwXfNZqx1SPXRERQkVaTZGNkZJ2GnujrA9yGS1mQ
18974	payment	1397	1397	1678	1	1	8620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PAPduvLhZv2qTCazr7YkBcuFRyVp6FDMaguhopLe9iEBsWbz
18975	payment	1397	1397	1678	1	1	8621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTp6sU9Vs3RsFbsdRi2imiuuzpMQibrkDJjxTMVxKnLPhK6Cte
18976	payment	1726	1726	1874	1	1	7913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yLkJtafaTKzYQP5vwMMEwfiXcGuaNN9H8hh3Cg4tanF5gnit
18977	payment	1726	1726	1874	1	1	7914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15YBujrMceHQ5JHrdoq5inHbG9KdPUfD1Y8nM6DvBHtEWHvG8
18978	payment	1726	1726	1874	1	1	7915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQyqMtWUYQjr1DcfCy3pAMw1nBT6vmJGARo7em4vR8zSQiMG6
18988	payment	1397	1397	1678	1	1	8626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK47TLvFvpHu5HFExhpNB7YcHGdurTjJqvaNoVJwXg2xcyQqaH
18989	payment	1726	1726	1874	1	1	7921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJXJgPbK3tKo72i2LdQvvgBoxNxDUnPMj7nQRfNS1xxCuHGMm
18990	payment	1726	1726	1874	1	1	7922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt6vkA2aSarcmWVEkFoWeW657EamaLdtvNCL5BcaP4M7Rm37d
19004	payment	1397	1397	1678	1	1	8633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExr977nRBvWPj1Pogd7bSojuWmssp2Jt6KVaZJxWyWbpRQLV8
19005	payment	1726	1726	1874	1	1	7930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd867Ns2sdjQyZBwrcHEr8RpaWfgWqeiFNhKKApNjMD3eGcXY
19006	payment	1726	1726	1874	1	1	7931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHRSSBsWuUxycGGwfhz2suSCuTpHJimBQ2w1Jk4qRLSEjhHwV
19007	payment	1397	1397	1678	1	1	8634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtYXB9RUgDozNZAnGrhgrREQWtkq72BvZ3d4TKzMSSEmuD1eJ
19008	payment	1726	1726	1874	1	1	7932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHw26JREavde5T5yPGnygWBuemVKk1We86HE8fcN2zwsE592o
19016	payment	1397	1397	1678	1	1	8638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHysXTasZYyn8UPu4PdjiGqwsKAPiind5xJZRrN1t82EWi3HN
19017	payment	1726	1726	1874	1	1	7937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2Lr8MrqTkPvjpoVwmyhWVzcrqRKPAhtTPgRTcEPqSpakQtUM
19018	payment	1726	1726	1874	1	1	7938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVg62MRGe9pc66omqSdTNzFd5fgP5oAwWA1sbxrYQscG52sqkA
19032	payment	1397	1397	1678	1	1	8645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJGuB46LfVnnw31MAnbwYxwr7XePaVrgU2UThpM4qF9JAaKRN
19033	payment	1726	1726	1874	1	1	7946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qeZEaCHc94gYt85ahYZgqQgE3scRRJye9ma5Bc7ipaZ3nWsB
19034	payment	1726	1726	1874	1	1	7947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizsDghi6kCn8CbbWdM3WAnKX5iycZSRiDdoLpV3THh8Dmva2q
19035	payment	1397	1397	1678	1	1	8646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4junY1HQa499MYJcTVaUiR2vVqDgeQAd6VeXu6dpxij6sbX8
19036	payment	1726	1726	1874	1	1	7948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7WE9AXwrE7aEHsDPYTWiwLyXuNWLx35KGxw5CTesSfA9byCr
19037	payment	1726	1726	1874	1	1	7949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsa9XpEUZZD5CN9UXbTBo7Wckrw2DmP111pLViCvQrrrJgNEde
19040	payment	1397	1397	1678	1	1	8648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKjmtWXiC1K1A462F3GJKLsnRnbkzyZme3KCUkQoMqpqGxutG
19041	payment	1397	1397	1678	1	1	8649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLynifag6m4qBHYgZNLKW8s4sMSpUpYFSxcbivihVb7bPw6Cm7
19042	payment	1397	1397	1678	1	1	8650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzozt3XgQLhT4ubTty87fvERovkvbCKQsM3szk3t1rMWNpZN1
19043	payment	1726	1726	1874	1	1	7951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WwjD2qZ4ua72uik5pcmHTDCCWzs7zY1HJ6Xk1SmQ9ktvGsFr
18972	payment	1397	1397	1678	1	1	8619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wmczRPGDwJGBzaprRhUiB1mmzXJXLLxW2CCiSVjaSweSSJBM
18973	payment	1726	1726	1874	1	1	7912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqB8aZkyr3KpqaA4byvPEYVyuar8jpqfSG2oJZyWkMYDeCpHZ
18981	payment	1397	1397	1678	1	1	8623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtDRbsN8eaNBeHZ6tk7JpAGTXqtZZ681pe6UD4egmSuvHpfWf
18982	payment	1726	1726	1874	1	1	7917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ec2BUif4MoE4DvS17sND4h4hHuD89j161ZUgX8NGyais5tnr
18983	payment	1726	1726	1874	1	1	7918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKJjYmt2ivixT2yvaT8gYLRFw8WK97sBvnUhVTsn4V9Nq9cuZ
18991	payment	1397	1397	1678	1	1	8627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxi5TkjwZ1Vg9yvBUKbgjHRQD7ab3rbSqLFiLAwX4Ap9576uh3
18992	payment	1726	1726	1874	1	1	7923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACvTxorLJUTDFLKx7iGwJA7LMmis13cND9f5Gc6WhFefk1MCC
18995	payment	1397	1397	1678	1	1	8629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1cGmxhtWVrHvmqMVsdMDJJrMeqhFPcy8yxrf6gvJW69EMUaW
18996	payment	1397	1397	1678	1	1	8630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJKyJoyHjjyQntuzCCmuL4iyQKmfetdaotNdmEZ4JxpejKtXQ
18997	payment	1397	1397	1678	1	1	8631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERp8qQ7ArU6BCUJ8xCThGqAVpVV5ZY26eSP5JQKt5YoD23TK4
18998	payment	1726	1726	1874	1	1	7925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWZ4w1UVB2L5DJpa4iFhrmiVohecF3QueMGcRaYkXizLPDabq
19009	payment	1397	1397	1678	1	1	8635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53Ua8sz3ebYMBvJRjgbkLC5eaj9WZdtS3KhZrAFJh6N6P4gMx
19010	payment	1726	1726	1874	1	1	7933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB6VzTUWvzHGTj9TdDhAvUn44K2H3ecyjJvTRWJANUdEtZD9oW
19011	payment	1726	1726	1874	1	1	7934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5QkuWT7dw2Ac96Ky1TPp5s7j68mNZAJa4S8XDZ17zdgHpdKc
19028	payment	1397	1397	1678	1	1	8643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mLKLN3erLcScPcBKjsvJcF9dnmCeiUvtKcGAaehXvT5ETLXj
19029	payment	1726	1726	1874	1	1	7944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJqhYxX4Tb9fhZXqJhHL75xpnoPZUUTMYLirjbhCkeeNGPGMD
19030	payment	1726	1726	1874	1	1	7945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArGNqqsg8WcmExs6sSTvyFedZepvFJWPWs23tgNzaPERCGH3e
19075	payment	1397	1397	1678	1	1	8663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZazoVTeAG4Vxedrt5iYLT7fdBCuY988qgfQT2CA29cfoRtPKq
19076	payment	1726	1726	1874	1	1	7971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm43BZQxogS7qB6ESpVR6HPzk5sjZTxtEHGDRSJssVuoNCX7vF
19077	payment	1726	1726	1874	1	1	7972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffQ4UiLtZ1B6oyyRkvH2B6eKNMUnWeofVNBNPxMwZuKP8t4K7
19078	payment	1397	1397	1678	1	1	8664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68EnaNtSfzWJrocqrwW2sCa6zLG3rHJsmdSPTGA8CEkvjLdx1
19091	payment	1397	1397	1678	1	1	8670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYB9B9CtyHeKaj9zo7cPXAFmR6W7c12StwMEucRReGPb1x1P4
19092	payment	1397	1397	1678	1	1	8671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6gq9dyGTKf1NUuFeegYdXEuhxHM8JEhDpzkcUUCNAYNy9jTy
19093	payment	1726	1726	1874	1	1	7980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsudZqgTfeXmQzjddPDCysLFExc51Qi2oSHWZmogVwHcEFfqCo
19094	payment	1726	1726	1874	1	1	7981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWpXWKxR5GHkwQEhPdioPbKB4ULCdeSvRAt2LhWzxNGLRHCNj
19095	payment	1726	1726	1874	1	1	7982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvYjzzXg2uh1afRdL7qU7Dywcnb8jgBFx2radKi9XmEeuWgVh
19103	payment	1397	1397	1678	1	1	8675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LcmHR1TH6XC8HcmMVSVLWoTfySxnZvncxStfiucDkwTsxLRa
19104	payment	1726	1726	1874	1	1	7987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsprLLaACHkJw9761dnK9fzCc15EqrEnfgbqv4o8qtY9BKU6A
19105	payment	1726	1726	1874	1	1	7988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzvrGu5kjw3igzLPRkhh5bXpoZX1znoffEyciqVMAFakrvBdR
19106	payment	1397	1397	1678	1	1	8676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeQMVvtRC6DdEsL1mj8DPfvmtVGKLeq7A2m6ZYuCtKiSbMugw
19120	payment	1397	1397	1678	1	1	8682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddN43UnHfWsGVShyeFoMEfZMoWBdVg3cuVcfCqGfhPk9C5YJn
19121	payment	1397	1397	1678	1	1	8683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa3SxWsWuxvjgc8qZjLWZUSaWr51Qkn2v8owLMh6K4ZP9iqMS
19122	payment	1726	1726	1874	1	1	7996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6xgDydfMYdBZfZMwaWZBMFh4WwyzucKJGtksuZsjDqtpC2kY
19123	payment	1726	1726	1874	1	1	7997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsDKS2vu1EqNxJA6oYS6awmiQetED6kkPAxP7GPwY9oqZLHkC
19124	payment	1726	1726	1874	1	1	7998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TBWeGr6ApQ3dgzzZhUCiVmvG98USijsRmnCeadswgznyue2Z
19125	payment	1726	1726	1874	1	1	7999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnhfJQxUVgAdDaATsQxeWMQDRrnsxZe8dmJDw32HTXuSmxFAK
19126	payment	1397	1397	1678	1	1	8684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcySn6YxryvwxZ1iHmKeZmmjUJ87TiGGwwrotbf5peQajia1ZA
19127	delegation	2119	2119	1403	1	1	0	\N	1000000	\N	E4YjBKt1tTWPKDLGw4k1D8o8ZoJ9vmSfo8Wtwy68dsxcMAdWjvcZk	CkpZjViYSLJc5B1etFnNWnTXMwQhFp1Z7coEqfDD823AEGRgeoGBG
19044	payment	1726	1726	1874	1	1	7952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUtjNHnBn3q9pbNLwKFmChESCeDsLiinYYykoVW8YzjsJrexW
19045	payment	1726	1726	1874	1	1	7953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SsBz5tYJ9wDLkDxxfeYPiELLM4beHreAo1nDSj2FXQZGJkAR
19046	payment	1726	1726	1874	1	1	7954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf3egrR3LqtW2gQroPToqYvmoGFgATgeGeb43taSuLRMJsiUo
19054	payment	1397	1397	1678	1	1	8654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXusBcivGhsuFkwKcTr5qQYzPjug4Wt5gpjXGw8fM1MnufNLK
19055	payment	1726	1726	1874	1	1	7959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPikZLPipTpUp6REYyKtWUqHPwQKhvUTRmTtH9PAQeY1kj9LAj
19089	payment	1397	1397	1678	1	1	8669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEJ5maLTk5v5CtrutFqJuFDJM4BkPdGgUCRRuSyVmeV9PAkRD
19090	payment	1726	1726	1874	1	1	7979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuyhXhh3sdjgA98R3FXCw1uvBEu74aT36sfW6UxEkaEYHFfpm
19113	payment	1397	1397	1678	1	1	8679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTaLD3Xwwfbi8rGM3st3ccS3vgjzd1uC5BWsDt1mr1AiyCrKH
19114	payment	1397	1397	1678	1	1	8680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc4pZccKpjcdKGzbqmuMK8W7nt1ZbuzA4858TmgjaGnNiKT6A
19115	payment	1397	1397	1678	1	1	8681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYdbELLc3zcJwopaJ3cznu3t2U6vPamdRSp3VeVrLowLdDwA4
19116	payment	2058	2058	2059	1	1	6	110000	1000000	65535	E4YjCfWZ2JV5f1D8RVzmiHGC4mobfyGF1MrQGfSgiVFEE3amHamHJ	CkpYVkdDZE5gEXFnYvwSbp8oKmRcvt6n2SS5wdYjaXY1ns4BHjTeE
19117	payment	1726	1726	1874	1	1	7993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5YYnztRCEHBjWP5KSav57JpbsK3LiXMD7SbiP9DWR6LfWGSk
19118	payment	1726	1726	1874	1	1	7994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaeRmUio3cnspVh6deKPbudyRvbethhn8TaBQxQtwS14VPSMN
19119	payment	1726	1726	1874	1	1	7995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFxqCTgF7nMHseTUuB7wfGZ96J6vAvU6GCRuR1diktxUmufT6
19168	payment	1397	1397	1678	1	1	8701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCub362VGB7unQVaaec95AAs1YWtbvLaL4iom2jQ1mER7GgmV
19169	payment	1643	1643	1173	1	1	11	1299265444000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7Cc56cqitGShXZtTZ3MMUfpPW7TqBYe3RxuMdq73uHvvQKBB
19170	payment	1643	1643	933	1	1	12	1074579182000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3c6k2cVxs9sh7tBkmX2wz1Lh8yqx6RkbmcEVnKyMMUNEVARZZ
19171	payment	1726	1726	1874	1	1	8022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUaUaw4rX1wY6GGeXXXWQStgtFtjgGQASFiXBCd3yyKm4WLau
19178	payment	1397	1397	1678	1	1	8704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5U73Z8T55uRQDmoBs5BKkh1hquMnr8phXMcSFP4n1WahaGok
19179	payment	1397	1397	1678	1	1	8705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfn2SrK1wsBRFZ57HZy47ariL6UScJ6F32kbHeDYDdTd44MpJb
19180	payment	1726	1726	1874	1	1	8027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW2wugPF1wyc9Rn7H4d7BrahG1NiVqo13z1HGymPdgyxskdSs
19181	payment	1726	1726	1874	1	1	8028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvtUYiGP7KTpu6CYAGsX5BpRGKDZDSZKpoCb7yWpbBBffF3Bq
19189	payment	1397	1397	1678	1	1	8709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMCTbgPVpqNrC9ct3vwgxq61Jx51VoUSEpDjkmj8M2DKZbevB
19190	payment	1726	1726	1874	1	1	8033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFLh4jBUY8ZUKbWrTPWseEkoCKJQn4hwwJkkQ9bphUhNMyrhc
19191	payment	1397	1397	1678	1	1	8710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2L8AEAYyv6F7qfh3CxgAjbzSiiyStVKaDhtA8x61PwaXDSUt
19192	payment	1726	1726	1874	1	1	8034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoSvT4QZojgMc9GjmpQ3ggZhubt2wGJnTq7twamtYaFL3zuaH
19193	payment	1726	1726	1874	1	1	8035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb15AzzSzjMLStZwWqhxeiZNut7MCc1B2GrG5ar9jsfT4mL5c
19217	payment	1397	1397	1678	1	1	8721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fPsnzMZfHy5AU5tHNV4c9W5wDiVX5Et3Kn2VXp47v55U9YqE
19218	payment	1397	1397	1678	1	1	8722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcvCpRAWXEJjvcKjvPR37Ton2VG9ShbpJqfzQBWqtzMKJkuQn
19219	payment	1726	1726	1874	1	1	8049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNS9nt9YcoPxexXK1uSd3qWJS4tTyJipx9ZYDTrQCFseH24v5
19220	payment	1726	1726	1874	1	1	8050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBK38pLKCKNsiBhBiPD1WrYHnDRJ61ButaJysMp91B7q7KcC1A
19221	payment	1726	1726	1874	1	1	8051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLKZuE4bgTT5wiLR8X2DgF2PrYSDepq2JVv6iT7jsWZB5oQmP
19247	payment	1397	1397	1678	1	1	8734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXv5XZ5Tbh13uvbWi1mLQGLanr5wHe2W6UDQLmg3FxJyfijfPH
19248	payment	1726	1726	1874	1	1	8066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fWSnduQshBHpHQzavyJnN4tS18ieyymiGYVr1rGo5ZCixq4Z
19249	payment	1726	1726	1874	1	1	8067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRho6DsdNFjXAp2b7rKgxjEEfqD7A3yHbomUhYWG1dcF1mTQPJ
19255	payment	1726	1726	1874	1	1	8070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpJTYH14DoTPWSGFVVNyjFwSmAA6T6veHxyz88X2JjrGUZiYP
19256	payment	1726	1726	1874	1	1	8071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8yqqRZxqcNpaQJqrdKMpXmbV6qLxweF5WRf7cZPEE3BGduoQ
19276	payment	1397	1397	1678	1	1	8746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLzrsR4TimutBRyKawVh9kKJ7zvdJytj2TXoUhzhtR99hPmbz
19057	payment	1397	1397	1678	1	1	8656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2gEbF3LjBtLt8gptsKteVKZXBAtCVZTWDb4r9gD2oBPaDbop
19058	payment	1397	1397	1678	1	1	8657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmk1RnT5nrYUbjWT7GghJUr3EPbrJgQ4ULCckvdzX1xqqiaEAG
19059	payment	1726	1726	1874	1	1	7960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcb1wcXYghkbUV1ZQdiRXLYC6ZdQiEZPb85HZLYRRVq6X8NjrV
19060	payment	1726	1726	1874	1	1	7961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaqD2fD42aJtxyq2na9EGfmYuSPXVEM36DTEv4rMi6EGR2kwz
19061	payment	1726	1726	1874	1	1	7962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93mUExSFaBitKiBJuiqqj3wxYZHxz4zUVfyBLSKqKhNS3hb2V
19062	payment	1726	1726	1874	1	1	7963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4FRozC2rFuRfTkCMHwyRKVA2pQK5CdqdKT3VrLGyjBzFvY5M
19070	payment	1397	1397	1678	1	1	8661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjKuVb9hCdvm3U4gqfAeRuGK3yhALHM9j3pcxPEsEdEy7RRax
19071	payment	1726	1726	1874	1	1	7968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8aY75SqRiEFRC2kusjKj5LLzzNhv57vLqo4HBTNjzaCBEdp4
19072	payment	1726	1726	1874	1	1	7969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSHce9FN4NrCJDVQKirbfyHnNnSCJsBZCaJuEuQkxYFUfynFX
19073	payment	1397	1397	1678	1	1	8662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqZLsLoDt6vzHDsKT8oenLuDbv7sEshCUAxLHHxKVSvepxQYE
19074	payment	1726	1726	1874	1	1	7970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cofHYSTjPyfZ95n8zXqjYVRzJjWdm17vfKaEwq2JmFEFdTC1
19079	payment	1397	1397	1678	1	1	8665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKSrUGw1u5WSmPcL9qoxmMxWaxD8JAA5hPUvP9Wr1scoBc3af
19080	payment	1726	1726	1874	1	1	7973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2kn4Ltuqjt7MiaGzyHgP76hftMC7vJtvGS8jT6Z7tiYby6RC
19081	payment	1726	1726	1874	1	1	7974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNPrEbzcVC2VGQcfG3HrdruhtNX9aVpBRfNqN1MS4G9yBkr1E
19082	payment	1397	1397	1678	1	1	8666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9m4e8iuQrddZ6xojrtYvAGcXo4a1x3rUshUa9p3Yc7AWshSw
19083	payment	1726	1726	1874	1	1	7975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwF4Xb4YCpKgP3pHcxj94UgwTZZTjc2Rs4Dv9Eibd44MxLudv
19096	payment	1397	1397	1678	1	1	8672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjLrEyZifS3ETWWZg2JYVcgdnuhiEFQtBSMyT11FoTqbHecPi
19097	payment	1397	1397	1678	1	1	8673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsU7b7xtiLe7apLMc6hvDxoP4kyKpwxPpHFWrcfj54w9Ghcams
19098	payment	1726	1726	1874	1	1	7983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonDf6sHEnS3Sh8yU2ndTWpqTUS4MZqb9QXCHzwJucHMEsRvoS
19099	payment	1726	1726	1874	1	1	7984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjCCCxdxmtwmJj8f7TDumL3shio7ujNikaowUAVaaCxJXucio
19100	payment	1726	1726	1874	1	1	7985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8BT9oBaqh9LUrErdQz5Sdh14KR5cwGRFt78aL4WWF6CKudJ5
19101	payment	1397	1397	1678	1	1	8674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECmivmUS2P1DEHB1tAF4e7MoZJB6f5Q1z3qisb8qH61MSTHu4
19102	payment	1726	1726	1874	1	1	7986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjT77x5EPrap4TmjuhzqzmoYkcSzCYkGoqoUYdE6szZ8fwAusS
19107	payment	1397	1397	1678	1	1	8677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NpRXHqKELa1zy57MFSqmB7xWwJhvT8UtU6R6CeXAAVQ6jCxC
19108	payment	1397	1397	1678	1	1	8678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr81Nao1suaMVYHSsRhJMxpdkMyV2mBjStKhxmh5tFSL9gHJWK
19109	payment	1726	1726	1874	1	1	7989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gz7tG83qUspP9EqBL1NPXWZkDWBF8RjU4CCoHYgYv4ZtV3qv
19110	payment	1726	1726	1874	1	1	7990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzLFf6yruWSaZVbCkMfj8Mec2Cp1T6KEHZgzW3L1Pn3xHMYmc
19111	payment	1726	1726	1874	1	1	7991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaSGXQysHNp26pnqS9yDkTZghj9UHo9dEyZiGVhHe7G6zjdS3
19112	payment	1726	1726	1874	1	1	7992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3DbQak7JyP3HQ8xJDPLvnt13gskbh5WAiqLT7TwJhWk4pjWZ
19128	payment	1397	1397	1678	1	1	8685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQHHJRZwKPqpwTLWxSGeMQgbXATK5r6rFkrERPxMDSsTApMSn
19129	payment	1726	1726	1874	1	1	8000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37GmQgMVTy7qmKKqUutLnJ9EWajasB8w3gq8giAwtv9wTt33E
19130	payment	1726	1726	1874	1	1	8001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qZ5SecDJ5f1WmpWmVDiBVTydertQscUT6mz6cJsx1fdccnJ3
19131	payment	1397	1397	1678	1	1	8686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRG5QpXis1Q2gzqx5nFiRhpzfFwSoXtcTSnR6rWq9ykx39KaoW
19132	payment	1726	1726	1874	1	1	8002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3FyoiE8GEePYdt7GpQjpeczb6VSS8gweQSAY4H3vhMz99Qi7
19138	payment	1397	1397	1678	1	1	8689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFZdPz2tWtZ8EDnFCdbn4h8eKpnUhe3pNJXBRws3c1qRRAGqB
19139	payment	1726	1726	1874	1	1	8006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BtMdUx5WFufweabhXsyCK82fgoq7iqD8CM1hzUWUa7f4JRT7
19140	payment	1397	1397	1678	1	1	8690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEQjDphvn3Z4DQf6ayPej4A14QBA8PH9MAME2gouptVNCusgk
19141	payment	1726	1726	1874	1	1	8007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdrknga3nH683CqNcXbgkXDNe31A6dcPC7MssZUSo62BjFkc4
19066	payment	1726	1726	1874	1	1	7964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe29TdxXUaNSqyCFXTF8Exhv8uM28ybKN7QK2qthqfQKrYSe8z
19067	payment	1726	1726	1874	1	1	7965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPUu7HqNUP987uD93uZPNF82k1BMKW8FKU7WNZgBdPNn9sAqc
19068	payment	1726	1726	1874	1	1	7966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4BY1JWmbXMPqz3iGLpVL8RWreoMhL3A2zg3uLizqgCscXB4d
19069	payment	1726	1726	1874	1	1	7967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSums4HFHkqe4bKPp723NyZWN8usPBJ1D4RSiSf6Wzy8NvagSi
19084	payment	1397	1397	1678	1	1	8667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXF6s8r5E1VExcLEQCQXVm3taLkRTmc47h3GF7DrBTVo3vnS2
19085	payment	1726	1726	1874	1	1	7976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HUpdz7DGgBL9MjBDzF8zhAmmHX46tjy8KLa4buE3NWh2RgEu
19086	payment	1726	1726	1874	1	1	7977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1pKB3TYTrt7k9SUpt1x5Q8Gqvky8vFmuJ7xwUxz7anaSGfGq
19087	payment	1397	1397	1678	1	1	8668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZXWc7dPQbrLCBNhSYbFSzQdgQteuPSGtDa9bobdHo4ARYFVn
19088	payment	1726	1726	1874	1	1	7978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3ZrfAR1UoS4wXYMzAATQc2ytgHSzPgo1LGH8UVLg5yPTboZc
19133	payment	1397	1397	1678	1	1	8687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1UwaFfaYPP9yUB74VpqV8TQ6hQJ1QPUD3C8N2iF3YMk63pno
19134	payment	1726	1726	1874	1	1	8003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjAbnm9oy6jt7fFZDukfhXSFuWCUAwBKoqeYWmmh6qaDckQG5
19135	payment	1726	1726	1874	1	1	8004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzx9JrVgtwW751gjgwf4EMNSw1vfJiZwjKezjdqKvRsNnz3GCN
19143	payment	1397	1397	1678	1	1	8691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTp3uprWVZdLpZcCy8bwRe9MjaQtCq2NnzqvPVxEV8C1sxvhq
19144	payment	1726	1726	1874	1	1	8009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUL5rkJqyU8VuAywjqbBi6JRNpmkqb8ZEEEZeRWxB4oBRBADb
19152	payment	1397	1397	1678	1	1	8695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjybc95n6qrZQRAedyHcAnt7PrRv9Ee6az6cNtRxr213pEw3o
19153	payment	1726	1726	1874	1	1	8014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwez2ZRhRheLfi5YdB2WYtwzLbtw1cFGxBSXL4ViPKR7q4VGQ9
19154	payment	1726	1726	1874	1	1	8015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H74yjuKrpWzeN4uSreJmzn8ZNct5RMp7CrSNDHnpVpptFCdz
19162	payment	1643	1643	1299	1	1	9	3620518685000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf9Uthdk3pm2FsUneY6LSiKSUCsxbeu7bbQGUXJXUCSW84HLw
19163	payment	1643	1643	1053	1	1	10	1925636688000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSNjJ6fPuM8HefP64NydSEpW7L9KufxH5x1qg9dx3yFHytcar
19164	payment	1397	1397	1678	1	1	8699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54m6b4jY4Em5cjAwMogAxjM2o3M1Mk4FbsMt16PM28gJwbxut
19165	payment	1726	1726	1874	1	1	8020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvnH2hEJFU25srTB4LK2rfzLgCe4NdPVVysjcMh8PXDcPvF3XB
19166	payment	1397	1397	1678	1	1	8700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5BKbLmYKBBU9TwBonUAWxrzwP2tPYwUgfSvCaskboe8rPMot
19167	payment	1726	1726	1874	1	1	8021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE7FJaaopctH2W5t4gvxbTfSmb4i1XADf1ZzKNwnaxAnvwJyA
19175	payment	1397	1397	1678	1	1	8703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEmcZ2F2zHoZnMMi3iHEATYDwJrRkHUooeTddPGRToSxfjbCg
19176	payment	1726	1726	1874	1	1	8025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRFTwXJzCJWWJXPnrBG9UQ36eSGieosf22yjdCaeKv9e8912b
19177	payment	1726	1726	1874	1	1	8026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjus7piTqNKhfrRXhbSXRaocV269JhpDatwmShCXfny3vFDD1i
19184	payment	1397	1397	1678	1	1	8707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBnwgMaGha9mACVjc6LhPXuVRsE9b3a97LozJv7M4NpCZhnQx
19185	payment	1726	1726	1874	1	1	8030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpK8knQLMC2m3g2jCWL4NcXKKhFf7nyQFcjVqzL7TEupucRsh
19186	payment	1726	1726	1874	1	1	8031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZRWSu2b1TLBvvQVzDs26pnnfx8FQ8nJo7HQMoE7Z2zWP6Xhe
19187	payment	1397	1397	1678	1	1	8708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVZazmjeMtt9ABeojpAWjs7DZaGKmsT9bhp6LUqmpq5UY4cD4
19188	payment	1726	1726	1874	1	1	8032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyHzHpbszHuo9TeanC4Wu8bhidTyjCN1NnYUZF3geBok3HvEP
19231	payment	1397	1397	1678	1	1	8727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g3UPzFsY7MAmGszc6kG9nj19JwqiRkDqnwAaoUst1YX2HJpu
19232	payment	1726	1726	1874	1	1	8057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1itWi7Mb4RJvzfFwLrhKwTrbYLXZjkM9a5iQ8D75GmYJ7QwA3
19233	payment	1726	1726	1874	1	1	8058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWGJ3PnSqDGi2fRDTrye5N8T3ShMQx2LBHuLk3qUvZxZodQD2
19259	payment	1397	1397	1678	1	1	8739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcygEy5gJGJiLoi5JkxTDxJKiEPcdrPSoHqPQnS3JGyoJBxvPW
19260	payment	1726	1726	1874	1	1	8073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Dj8cjbMBdooQEmEzFG7qYUmtyXkBNZEGkfukggPHZgXSshBg
19261	payment	1726	1726	1874	1	1	8074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3prYE3CgDEW2Bbs2n7kggpTEariS2MnXCtYPakQPqwtfpz8KA
19281	payment	1397	1397	1678	1	1	8748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzwTkhRqeDnCy4aE5s1WYu3AzLFpXCFLkjBa7jTbwA4BuTtFU
19136	payment	1397	1397	1678	1	1	8688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFumB5U6T2eiLn2HjJqExCS2NL2FgR7TRGtmcQHnLC2YWkgWnQ
19137	payment	1726	1726	1874	1	1	8005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78U9CjjRsjYUNYCV6fjmTCKk7GnvbjyE6HMaN9rjHKjyoJskZ
19145	payment	1397	1397	1678	1	1	8692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3FFFoSgbMVtr18iHLY5AFAtXthRC2dqDJKz5JrCjibBgi8yg
19146	payment	1726	1726	1874	1	1	8010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSacxJRSNvdhgGQu2ue791BaDfgM5EpAt6HDVZ1xEUFBGUaUtm
19155	payment	1397	1397	1678	1	1	8696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxvFA8E5be9YNgF9vhoQuB3oHyy3AzaN1rrzgWhvmYUvRC8fN
19201	payment	1397	1397	1678	1	1	8714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NyqTKHgDuonA1fUGDEtFD1ETLdYxRV5R7T58bQzEqtRQ3xGS
19202	payment	1397	1397	1678	1	1	8715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fwoq47gwmAacjQbh9C45JuA1KkQ9zytPgVm2KjRe2SFL2q23
19203	payment	1726	1726	1874	1	1	8040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXYXN9aU4cpaqq1RbV3m1gxLBGCVyptFwR35jvYGFaPyCt11c
19204	payment	1726	1726	1874	1	1	8041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVuYPjYuHPXtUbhQzU4BG1DeXu1Ut98awwLNTFkw5oXTQJ9Yx
19205	payment	1726	1726	1874	1	1	8042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NoTCXWq72sFMojcyxHjANz6S8WdVtK9YT1RgRAq4JB4F8WcG
19210	payment	1397	1397	1678	1	1	8718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzzVNpGm4pEBv6sL8dDHhCUQxnanVzTXfaXGVa7zUWf62qHkJ
19211	payment	1397	1397	1678	1	1	8719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY22fGY3v6WTAHjsr54Doxk5Up2RwPBkW8nJ4bEu5yB4VfH5QH
19212	payment	1726	1726	1874	1	1	8045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaeLaUt1PgrPY8aii1BnEKkfueFt647SKe9qrsiqx2EN5RRMV
19213	payment	1726	1726	1874	1	1	8046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfWhyXhwFduF3wzfqs5UPvBPByuepFiJndhjUtqZySY8e4RGr
19214	payment	1726	1726	1874	1	1	8047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTTkbNpCHqK4Py7X8RjVRkFd68Cqa5zGiMEVDTF4PT5ggdtBr
19215	payment	1397	1397	1678	1	1	8720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pMG3hEuiuEkUQtTBeUDMrbrrki4p4BPiESt5rj47rUUg3ETE
19216	payment	1726	1726	1874	1	1	8048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7q7gXkGMemiagwzp9oFy7SrN8WbZ21mrSsBChngFAvEMBdrg
19222	payment	1397	1397	1678	1	1	8723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFL4kLxdvxpNECF8an7E78xSJ73B5TKhogs2jdYWNfrBmJk9bk
19223	payment	1726	1726	1874	1	1	8052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYEsyeLS1ARhuh7cH1S2vEZLKv2dYFZA1TcdPBKcanbDiu9wj
19241	payment	1397	1397	1678	1	1	8731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEbVoNY6Jcg6KneCQQGJSpTBA3SfrhxcxWetcAGFNT5K1eo7j
19242	payment	1726	1726	1874	1	1	8063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54beE7FQjuk6v6RnjtiVvkHq59XsAZeWF2VXvsRPua5HXxiN8
19243	payment	1397	1397	1678	1	1	8732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uUzCr788iMmbwsmtBHcuSo3awwn3BHkMUNXsUKhHB1824p43
19244	payment	1726	1726	1874	1	1	8064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZNMvzNyWrf6jDiRF56soqYvwGMTVJudesQu66Yx6AQV3HDrj
19250	payment	1397	1397	1678	1	1	8735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSegisqBMqNQpYce8DwMy1gWaX5jyftLFa6TCcGJL8kLWYBm3o
19251	payment	1397	1397	1678	1	1	8736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLhpRPCZz11AY1iwfdfTbAMkXhaANcGVvYwUBaARxgfjrpux8
19252	payment	1726	1726	1874	1	1	8068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZyL2Hr7Sfavb6oFasUC8ziMdadYGPKRBAgjLtZvEXXHCrZCV
19253	payment	1726	1726	1874	1	1	8069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hmz5djyth1rXE3L6PDiTRHpBxCZEmnxYa2uZ81kW5rheGRxu
19262	payment	1397	1397	1678	1	1	8740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW13cSR2pjLBDxJok6xZyyCgxquWTHohYkjwTQb5hGtvcmAHM
19263	payment	1726	1726	1874	1	1	8075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nmVSpAaUA4r2KCfywewsSFNtsYWfyMUmwpKaMignvasFUKQ8
19269	payment	1397	1397	1678	1	1	8743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9vGRYkKUQp3JQNHoQPMQi7bv5zN8YDJV5fs4k8LNNVAMsdUW
19270	payment	1397	1397	1678	1	1	8744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSDzhhwQqVsT5NuVQ3gb4fZ6vGJoBj1X2VrvTHjinng3TMMLW
19271	payment	1726	1726	1874	1	1	8079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqKTm3f2ydUhnDUqTF4BQ5nBR2VbCbsLUqjZxAUUe3QbjuaAW
19272	payment	1726	1726	1874	1	1	8080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTHiEq2mS4v8Ayhr1rhduo6HmxH8nMc9NNAMLxgQoEmsmXte5
19278	payment	1397	1397	1678	1	1	8747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLSSQeckHjxW4kFd9YfaEzbhFQuH2ffEBdxPzvXMiVZfrLnsF
19279	payment	1726	1726	1874	1	1	8084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi85CKgXfHb1YmXaWYhspkJ3x6MPAUYBoVUwKPrPW53sGuhkm8
19280	payment	1726	1726	1874	1	1	8085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxzj1CpJmT4rKCqoiFkrVZhoMHpD6xVFziG6ZchiJHQ3USi5e
19317	payment	1397	1397	1678	1	1	8763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeYTxsgsbJREhnyiwui2Hwy2Wm5P9tXbRbuke1fHbBqXujALE
19318	payment	1726	1726	1874	1	1	8106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6R5dhEJzoSRj4JEvQpzqrxWbaJFj3Qqj1VdNmAWBZp8PzCD6m
19142	payment	1726	1726	1874	1	1	8008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvPrEKKZtw1tyaj4DWRCQ31ghHGmkhyEb3xV7vBCrF9e1e6XC
19147	payment	1397	1397	1678	1	1	8693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgJNhr14eoq7j1x1VamzEQ47EvwCrYtt8dvGCY8dyGdNHiUmb
19148	payment	1397	1397	1678	1	1	8694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZVwbN6trX8edhmLukCKUNX5bzkoK7bRfMkkAqbcfdY87Mfqk
19149	payment	1726	1726	1874	1	1	8011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfg86srib5y9TAQjp2XkMDsuw4UrVpuwJbztxNeikmc7FykwT
19150	payment	1726	1726	1874	1	1	8012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAkFxxmit4vE9Ey3iiRrM8CmpJktZnZnBz2gvng1MmCL91sMY
19151	payment	1726	1726	1874	1	1	8013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYP9Ajd5ipdu7EHwLPUkBTweetPKGjPpMK8DQMMvf2Kojok6j
19156	payment	1397	1397	1678	1	1	8697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgv7ZDg3k5tHp2iVnKBLt6TQMRBK5qPPCzc2MwwoXkZybUVoL
19157	payment	1397	1397	1678	1	1	8698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm5BsfovYhCTNiC35HGGHM75GCYP2K8VFpTS8voSFxp9wrdyP
19158	payment	1726	1726	1874	1	1	8016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67n5QMEdo8JX5ntyVfqNrhqAvAtn2DFit4sbHC59G6bPyBYrP
19159	payment	1726	1726	1874	1	1	8017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrj2kPmNUBpbPtgoPynrmie8LtNWF97xED5p9M4pztsEjCViE
19160	payment	1726	1726	1874	1	1	8018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCu2Xnh6LoszfvbznBwPBTkDC5Dxe83qzSmWoAkTsqBKxcQnE
19161	payment	1726	1726	1874	1	1	8019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5SDLSKpNcrLv5XWAfRAzxo77mDYtL4i7dJJvuZrqFLbgrEEH
19172	payment	1397	1397	1678	1	1	8702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyTJpfCXVaA7c5GGSaDRhJa1c53TZ6GnrG8cDtfgRk9uPVg8u
19173	payment	1726	1726	1874	1	1	8023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDWhHUXMHpYJRc4o6cnaMZpzR9vCFYnM2GX6L3U9wsCnJq8FH
19174	payment	1726	1726	1874	1	1	8024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhcEvBRfGdf94gektNtApSxfEo13rhuXiSXMT2qu6whDYZj46
19182	payment	1397	1397	1678	1	1	8706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVueYmKRA6KfekkH6sHDH95zVNMMjzizAMvLXNT49iSJKDV1T
19183	payment	1726	1726	1874	1	1	8029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwmvaanGfDdpxaedsNn7czBqcvWwDugR1F847KwALkesdqv4G
19194	payment	1397	1397	1678	1	1	8711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaLvLUUzC8Rc6e1geVHXdnHgomVN8V2eWC5UTZNPso76Tvf4m
19195	payment	1397	1397	1678	1	1	8712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2xWuQTj5sAe2pN1bBGmomQiZsqXjz7jmXZTdSZgEcstzPBqe
19196	payment	1397	1397	1678	1	1	8713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSHmeoxNCoN9usqDDJsNkcC2AAJKLY2hYXUzM8DYTWgZKj9tP4
19197	payment	1726	1726	1874	1	1	8036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14J3A6sQvPuip4dJqejg6VJNga8wBUsLxLkm3C2uQm6MkVR3F
19198	payment	1726	1726	1874	1	1	8037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuC8FJ3WzmHKGaU3wkUPaPXsAs14xtyMmLvHi29XwJrTAncGVF
19199	payment	1726	1726	1874	1	1	8038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWXxKqQfT1kgYvE1v3Sf3PVQptKHbsfiRmkgWarke8c1Rv2X1
19200	payment	1726	1726	1874	1	1	8039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuetqQ3dNYDej4RZavDyN4HXqTVnLKLM9J8ZBRFcZyKDiM5nG
19206	payment	1397	1397	1678	1	1	8716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNuqCnZzjMkkDRx4YxNkCVuBFZUgwKpaPaWZ4d3fCy4EbNWDs
19207	payment	1397	1397	1678	1	1	8717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8cViWp6RTNvEiCHkSA1peWQeLkf38DetAcjyMNpVrhMaPPG9
19208	payment	1726	1726	1874	1	1	8043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CHpaJobrQeVL6MVW7HBJNMC5hBbBrszdLdsf3bPyfuYoCjkz
19209	payment	1726	1726	1874	1	1	8044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZePzS3SJPj49HGDRVk6sov9rwz8pP6VsNeB2vLiS3x3PRV1TTR
19224	payment	1397	1397	1678	1	1	8724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtxddaaTrDA74JVAgyaNQB6sprQCzrqbbrbQn5Btua7koyrpc
19225	payment	1397	1397	1678	1	1	8725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3Ck5Rip5CNrWWTZaoMuqUBN9TBb9SYxK9HGaHcySs2y4P3YA
19226	payment	1397	1397	1678	1	1	8726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPVjivmuzvgqwfLXMH4Po3iQCqmLHsv3vhZNrakvFBynynsad
19227	payment	1726	1726	1874	1	1	8053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXo8bCdzgSLmo4Y81Ehs768BWk3wUziRJHdDuwRfJr3m7Zb8B
19228	payment	1726	1726	1874	1	1	8054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKwwsJHb76LyX1Jq34GvBb4jrYCGZe8JdPaMt6LeMB1piH6aT
19229	payment	1726	1726	1874	1	1	8055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBBjXU97Vn4ForgsiUkvZnZPdpDmNC9hCjwBvkStbZFg8mpye
19230	payment	1726	1726	1874	1	1	8056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJznT2pN4RjMQQz2Bzk8gExdRFMvHB2BDQczkLPxKpED2MWsE1
19234	payment	1397	1397	1678	1	1	8728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot4TBZkRLCjhFEgbW2hsFvcxDPhsbhgYfn1JMdePWNTTBSHqf
19235	payment	1397	1397	1678	1	1	8729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz6TKG9uvN31W7vB7isz9Fqa8H8LBo2v4RSqNtidMA2vyAwET
19236	payment	1397	1397	1678	1	1	8730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQYwGeVeKgnojZ6nXUpXkhj57g4qsXuLGYTmY7oxZ6cEX5P8X
19237	payment	1726	1726	1874	1	1	8059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgX7EbGZWkvv2mSQN4Fy88sBqhX9kW9kMRBs3aZJ8nNB7FTewi
19238	payment	1726	1726	1874	1	1	8060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2k7VMECJcjdYtXo4naiGL1pM5LU4165mdB5WHK3KfREuwfue
19239	payment	1726	1726	1874	1	1	8061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2pMt36bzB1gFTUtp7qiQG7m6dC4cttUt6K4aoR4DXLBV8UVZ
19240	payment	1726	1726	1874	1	1	8062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkADi3i5MKnzP9JF1tpFNtbFVyV1Gt8iwFHnzuWfimyJdsKgr
19245	payment	1397	1397	1678	1	1	8733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TpDF1fhBViC1oZzXGRW4gTxM3LBqFsYpv78mYvF6T21ED6HX
19246	payment	1726	1726	1874	1	1	8065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHJCjVWiYChnBkuSehFuYTRqnmACZaa6b1nCuN3BsFY4Y7Dro
19254	payment	1397	1397	1678	1	1	8737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDMUDSJkZ6aAxA58ay6JTNWo5TFcVDGEAaVYdE6dSDhKG7j6F
19257	payment	1397	1397	1678	1	1	8738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVBU8eDStNX1sAktXVuNjw3HUemCaCP59hpaozg6SMkrsv6QT
19258	payment	1726	1726	1874	1	1	8072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcYT4xTNAB17h2CjZygkzsqDHuyj7RCFc8vL89rsKTcNpFEGn
19264	payment	1397	1397	1678	1	1	8741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7unnmgETPqoDJxhCbZo1AYgGVT91aojvPSaE1LLGNixTBEQx
19265	payment	1397	1397	1678	1	1	8742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7QZHXAPPmJYjDzev69i6P4BPUGvZWdcuGsCpq86it8i3AQzj
19266	payment	1726	1726	1874	1	1	8076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmm4aRq8Nm8G42FCCCn4F7FChaktXuS54ysmwKWUWvPdV2xkCq
19267	payment	1726	1726	1874	1	1	8077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s6jwPrVzknkiHSBhXPbFhhDi4H13FhJPbR7e8d7Cr4TdapTs
19268	payment	1726	1726	1874	1	1	8078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEetrSkEryCtJoYeX6uNiuiHmggJmrHGjq6hPFRRCWPwP9Fpc
19273	payment	1397	1397	1678	1	1	8745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFsBbrK9hnrdk8N59PU7Y5tasLVUGhhhYLTrAVmQAfK3uEsbV
19274	payment	1726	1726	1874	1	1	8081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69FxRq52L1spX85TXRb8AQpeWsS7uWE35qfctP9yPaHS46dt5
19275	payment	1726	1726	1874	1	1	8082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6BvFUCU7ia25rdoermNLsx7r3qA61R8cmz2mv8poKnTUt3MJ
19311	payment	1397	1397	1678	1	1	8761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHENhaqCp1Cc9Pk15yYyvkXNB3HFaBsJbBcZizFvgmvvSRyGcP
19312	payment	1726	1726	1874	1	1	8103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSADJKFmX4mYfiE5BVR3HwAjgbXnTy8TafiqAafjdHiA1fRxd
19313	payment	1705	1705	2129	1	1	19	4800000000	20000000	\N	E4ZEURhzma68F7NjrZEFmxG6BXun9Uh5cmLqGQXVMBgbzZVF2gAcC	CkpZR9w1tUqEwtErsUbkNGmagZsm5Wdhe8rNb8r9WfjZnY5hHbyMc
19314	payment	1397	1397	1678	1	1	8762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuVGjNr1XjvmPRKLk169TVdVdhJKJMk2MjFC1CTqynGU3uLpK
19315	payment	1726	1726	1874	1	1	8104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyt2RPSjvLAHStDXr3M79wWuBQtFXF9CVSnmniCgUwTgcXEsW
19316	payment	1726	1726	1874	1	1	8105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuPJCUzJcr3kKCeLF3LMNXLDtziZZeomodJYEuK9P61ER4u2Z
19319	payment	1397	1397	1678	1	1	8764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHRkQSpdtfHKRgHU297bAoVYb7TBbrxmp5wstEqmvvTfyqG6U
19320	payment	1726	1726	1874	1	1	8107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bGJXErdQQJNrUvMJ6NHcgHgdMdMjZgrBM8W7rCPFGR24CG5H
19321	payment	1726	1726	1874	1	1	8108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnvV8qNkXmuziuDxWM4NX9eMenDgx8RwzGCq5C7e8iMVP58r2
19322	payment	1726	1726	1874	1	1	8109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsKCNTu8CkH2TkqobSedkT6PC7JGNwuyrTmash6FE9xPQC9tK
19358	payment	1397	1397	1678	1	1	8780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKQMPXjTiNYv7VS2wXZNocCzfJ2Qdx8Urtu3iFQnWeC3DmKoZ
19359	payment	1397	1397	1678	1	1	8781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2Q9HCn9BQSuPj928A6wT7DfaqpEdKM9Xo1wrGMnKbWy1oHgP
19360	payment	1726	1726	1874	1	1	8129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wVWZd11kWyQ66iBqYfaoA8Vb5cRg64CytZSBRWVhPrAwFZUT
19361	payment	1726	1726	1874	1	1	8130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAss7WnaVDqGmEnVsBFZExj1DVLPApQXFVXkAB9ej1XPCp4mp
19362	payment	1726	1726	1874	1	1	8131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQR7ktZM9iuwBpKY1rVKCMRZjPGWcKYuBcmzk6R53U9ADoBkU
19363	payment	1726	1726	1874	1	1	8132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM2HfmhNoRNbKk9DBpzNvWxRsobSsGF6fvTqZ6nTnFQtvGxNN
19370	payment	1397	1397	1678	1	1	8785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsmJewAmkR7cpqWxS1EmupzPotxAethRFznRQgGQovZE8UYRm
19371	payment	1726	1726	1874	1	1	8136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D4pf9bpCabGRp9BYkvaQ32Y1q8xaCttqrUrYeAusLGqffvJy
19372	payment	1726	1726	1874	1	1	8137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoWgZntfdMT7Uh9ohxNNhyDJmMTrq9LHAGsH6NaLctDfYfxHQ
19377	payment	1397	1397	1678	1	1	8788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuhD21cbEovq4wx4U8CfRtMJ5p6DBjXU4z8KDk4mKeAd232TL
19378	payment	1726	1726	1874	1	1	8140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCG2Kh2ELUk4nZ1cUohatQ8WRKfnyqKsDitYJ5tdEibakQYeJf
19277	payment	1726	1726	1874	1	1	8083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hTfRnMuqhpfMC9eicXwi64Hm1DPL1fGTSpbVBT8d1NE6iqQ1
19282	payment	1397	1397	1678	1	1	8749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4jdWCPjZzAtSutDuv3EJX1j5AJydAZ7BtH7H97yR7fz68PWj
19283	payment	1397	1397	1678	1	1	8750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfspTegUXNcPHU6ZXufW4tbw7FK6HUyxw5dEyLUTJ4MAXyp9Jo
19284	payment	1726	1726	1874	1	1	8086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RMEiFePdsScf9Ux7igSdBEct9AKxGJfbpeef64bCXtCLy9Wj
19285	payment	1726	1726	1874	1	1	8087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTd7tt5egTZAPovaVWjiZBvMaozY9vRA9nT5a7622GqPq296F
19286	payment	1726	1726	1874	1	1	8088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8agQAMcmtJmmadR7nzYSSMRUJqchNXgofWVroyfUDVRDM64s7
19287	payment	1726	1726	1874	1	1	8089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYig6YFwtBB3a8f4vnKg7qnAWADRxraJ5DqYeBztGo2qFg9821w
19288	payment	1397	1397	1678	1	1	8751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3SvBjM9gMDY2R2VUrA2Fj9VJDqfx92P9TduRyiibfm6Po6aN
19289	payment	1397	1397	1678	1	1	8752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pTiUSRaRs33MZrvMigfbcyCeWsBY1iJLyujtk9G2gGntyHDu
19290	payment	1397	1397	1678	1	1	8753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HT53egFgZz4GLLbHTxtfNocEYkgLskgHNAuirLBGHCgES1Zw
19291	payment	1726	1726	1874	1	1	8090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqzZux2JysE3tvmvQ4qKpnUThe6vmX9Qds8NQAYNGqUte2qNz
19292	payment	1726	1726	1874	1	1	8091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYT5hejmJgGe1cxZWwu7R8ZHnuLiGzwYgZLA4L9yvH1BVhAhi
19293	payment	1726	1726	1874	1	1	8092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMCSF1gCySczHFn2PxAPr2m6zRQbj7RG5d6UMq8VAgChQgZNR
19309	payment	1397	1397	1678	1	1	8760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpeBP1XpiLpp5hXw98Cop4Sp5iip6udMT45EP4YgYeBhd2ej5
19310	payment	1726	1726	1874	1	1	8102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCSFEbG4fAwagEGV5z3ipsFViK8rDAL2bGacwYiKvW8crufqW
19323	payment	1397	1397	1678	1	1	8765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShMT3aLjcvPNpyLhjexPFBZwHfbL2LcXhpYYNb5CDeYEKZcqS
19324	payment	1726	1726	1874	1	1	8110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8RNnkaKgaP5X73Ebi5UCTHNxGaFZ4BiDM4R7HsS8eLU24jiF
19340	payment	1397	1397	1678	1	1	8772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKzRPKTdFLF4MztET5Z31KgXSo1GpEZyH9TthWQyXEMXvvk2q
19341	payment	1726	1726	1874	1	1	8119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyw3Q2Kz3fs71bFR7vvK9iCWAKHBxaWkYX8AeJT2kNZkvbsW9
19349	payment	1397	1397	1678	1	1	8776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckyuEv8iTiELnTABXSExgmVfxgAPfE589VAEQ5JaTZZLK87gY
19350	payment	1726	1726	1874	1	1	8124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8A8xHdrfFW51YC2kFWXhscs98VCnMwWb9JEJ8SgjzWxdd7p5
19351	payment	1726	1726	1874	1	1	8125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrM2MPfDnf2MbNZ4XVM6TyUURtQ1qNStWPAquBpmA9hdD6BsCf
19366	payment	1397	1397	1678	1	1	8783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67uHjP9mCLaMyVhZPTTUp699vuBWJdEa8nWu3P1AejM6ZwKNe
19367	payment	1397	1397	1678	1	1	8784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDzWX6DCGwFVMBVGBJhywcygmabm8AtmNmdsH3CyJPo9kqugN
19368	payment	1726	1726	1874	1	1	8134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHe9P7ZijKfGqpiKYsvofGsye6JnRjLytPsX3u7rRNnFJu3Ad
19369	payment	1726	1726	1874	1	1	8135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8f7XSYi7aEghPioXgnRdhHHakXbYPFygVvUvAR5hJboFue4kt
19422	payment	1397	1397	1678	1	1	8808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhof8JwLwLrLqzskU454xxesU61AKzKmoWeWvTW8f8MXSzdeqQ
19431	payment	1397	1397	1678	1	1	8817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBMHgRpT5jPPPSfiiPVVvv54WwSfHcPsdDtypNNu6QpaxztQB
19432	payment	1874	1874	1726	1	1	1	4778000	1000000	\N	E4YgyYcRPZdhKqQRyKezP8ixgNHPEh5ZW9Kswa1W2eciBPGHC514B	CkpYzNtQxkpDbxpcY1nTz7oKpE54rMcPakbGymZGzs26nsJ1iaoag
19435	payment	1397	1397	1678	1	1	8819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfS5QZQZhhjT8rW1C81EAYQ7GvVf3DEy132k5YzdTGxhtRDGR
19437	payment	1397	1397	1678	1	1	8821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyW1y921DoiHuGPzNZDGyDa5qkV5KtR9CsXnfrPQ4c5jwTTP
19438	payment	1397	1397	1678	1	1	8822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNM4cnyxBaMhYJriGMv5AKbrEH7CDtUew7MMnbPUzoJv9MYHm
19439	payment	1726	1726	2132	1	1	8166	150000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpZv81WEbtEaoMjkdsjM6PLpMeCHnRZ1M38oRnWXL68n6FgMTYRi
19450	payment	1397	1397	1678	1	1	8830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfH8HiFQ83GFJyPb9gTUx3Ym6W3P5EWNbwTdhXtHquRi8wyrL
19451	payment	1397	1397	1678	1	1	8831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcMNwW1qQLtx42mWgowbq2YSTFp7T41xaE79nyscTpBefn8rn
19452	payment	2133	2133	1874	1	1	1	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9sUvZtMhwfa2mi9W2Dd638rKhKTRtZURUeSLxtuUgc6PBSM8
19453	payment	2133	2133	1874	1	1	2	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvGPaBWMqwBuHYy2uy21JZ57ifjQXvn7PK5TBdJboN38iKER5
19456	payment	1397	1397	1678	1	1	8833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMDCMWRnKfEAkrk9rMjGbFoVshTeDc2ZcRDxhsf2LPsxUGjBC
19294	payment	1397	1397	1678	1	1	8754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHZJLCUriFz1nq2ctfo5YUhqeoDpVUZdrxiWwrWXpRVoJ8rGf
19295	payment	1726	1726	1874	1	1	8093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUbWCXERYRBehkwnrMQG1ijdqxwTYz1ax7A13Yi71FPrLitvw
19296	payment	1726	1726	1874	1	1	8094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBJbFJy9J4MraeZFWzz6R5S7Lo1HTxiSEkAM4tDoHzqdT9fTj
19297	payment	1397	1397	1678	1	1	8755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEatSaCj5bsf6saZrLPsdXP3oEGe825FnmWKKSNdQwtqVawYQh
19298	payment	1726	1726	1874	1	1	8095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKicV4BFWeNVfHgY12eZTvmC3ury4iwpfdp5x3aXMF2c7oRU8
19299	payment	1726	1726	1874	1	1	8096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtWZPb8Y9SiK9sUnGqm2eFJpW7MChXuzHEpz9XnMQmz7gHqYM
19300	payment	1397	1397	1678	1	1	8756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZit9sjPZmzLP1YMU9MbPcEYX13pYkTzLPyaZf91XYbPcjvvRKo
19301	payment	1397	1397	1678	1	1	8757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooy7LUceMFvZNAq1HdscLydNtF6oZw981aVpjk8PyHER7MdrR
19302	payment	1397	1397	1678	1	1	8758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpobgbiMbHUGrYQWpD7WhaXRqrLfDrtkxXE15wpsk74FwQZHGa
19303	payment	1397	1397	1678	1	1	8759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ7QZ17BczdsdRjGiQMuinSB9pvhHZFrKPKUypEePMhYr4Dn8
19304	payment	1726	1726	1874	1	1	8097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfbNagbmc1VuCiajbF3mbcqRvTbC1vfk3utmTF4UvkaQ62YY8
19305	payment	1726	1726	1874	1	1	8098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhrY81oFuJJyKi9E52kcgPvByX73xELbFBPBjWXnXHrdvFzXs
19306	payment	1726	1726	1874	1	1	8099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmUgro6Lj7jPS3XF1ncL4tuBqeTWi74XLHQHUyzsHtyDxYv2C
19307	payment	1726	1726	1874	1	1	8100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2Ryv9scj6XM97B3qyZsBVL31JVYigrMcaoez3rQV1ttQ6jR6
19308	payment	1726	1726	1874	1	1	8101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDFGfbu8F38Y1mtfPJFcj9jfBNNB2vFE86q31xQdM78YDqXDP
19328	payment	1397	1397	1678	1	1	8767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBkRKA7UbULEMcN2kxHKfZ6iWEx6H7mu5PbJ431AtAUP2ZCeB
19329	payment	1397	1397	1678	1	1	8768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqax786ehQzdQd37QpwgtYoRxvb2vbFoj1jHwFYDXf8dAssTGG
19330	payment	1726	1726	1874	1	1	8113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFo3oUQ3zEtfaxZh6UMbBrMY6xyAAnbT1JBY5woY3cfdXJe2N
19331	payment	1726	1726	1874	1	1	8114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTZjyfoT46iCAEeBm5Yyc7hfUZiqB1RXda1tU9FyyVc7nMPQU
19338	payment	1397	1397	1678	1	1	8771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgETrXaCHBTH9Yq9NWPaaxCPrK8qjsUChwqsnFnTEo7W9UQzH
19339	payment	1726	1726	1874	1	1	8118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GviH2WxNzaX99jeqWw7hyHp57BX2kMf1NAW9tYmxhFUGiC3P
19364	payment	1397	1397	1678	1	1	8782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FgKH1DdDPL3HzPnCvZT8jenXnRYRPW9qNfBKkRgXGotz2TyW
19365	payment	1726	1726	1874	1	1	8133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow5whRzweWVfyyJfb8CSGBjGYQYwYFuPLY3eANFZFo8yM9SME
19373	payment	1397	1397	1678	1	1	8786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKLxNRSyT169kwBBSfCYEXxz3jQ1kGRzZhHTweyFsKghQUx3U
19374	payment	1397	1397	1678	1	1	8787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrBZnubcoHXYKWwDBGQignRir77AiTsipcbPcccviFHzYUCgd
19375	payment	1726	1726	1874	1	1	8138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsm1kDTfBsULwEMbb1vyEM9DyrMhvi6yNZJZdisDjrs8GyxNDN
19376	payment	1726	1726	1874	1	1	8139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuQ5kYrNoagLDsXcGerAEz6kdKHdTbNpvUPZJpEcSMZo2oGrU
19389	payment	1397	1397	1678	1	1	8793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7WGu6YKAiRBuAa7WfwU6jr6Hd2Y2gJ8rBYkm2m6NMHZNt6ch
19390	payment	1397	1397	1678	1	1	8794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbdqLES3PAtRVos12YsNibLVnwh9co9SVFK4TCSicEuXUjSqJ
19391	payment	1726	1726	1874	1	1	8147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwmThP8oo5VzgEbPvz876TNZEJ1LMh32cp2kD2iQi6iHkbjxY
19392	payment	1726	1726	1874	1	1	8148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gAVUs1LQKDZbuJ6JrivtExeX4Aj6vRRvR83T1hWMczak7vLc
19393	payment	1726	1726	1874	1	1	8149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8sZFvyyowuGouFpjdQqNgSjHiLWEkofQGdufjxVdUU9biC8g
19394	payment	1397	1397	1678	1	1	8795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVJYt891pQtx8ZmLnTf2PwfeLdJsbQgW81CHb3gebM4tE485Q
19395	payment	1726	1726	1874	1	1	8150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaUFhkmWgqRbHLzNjXqsYTq2oqQyGA1FpcY752WQK56Su7d6y
19404	payment	1397	1397	1678	1	1	8799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWiszcDupM3uYMsxXMDtxJvEqghTo4KTVSrrmTJkGhgfjM7Py
19419	payment	1397	1397	1678	1	1	8807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLZvgH2YJiEfB88hF8o2ouSs8CheXwTPL7nynaDfKgFEUCM9K
19420	payment	1726	1726	2131	1	1	8163	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzFodrBCm1WAJFv4fpt4dgzBDtuu1mM2S3nSWX18N5NzQrX2xG
19421	payment	1726	1726	2096	1	1	8164	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAvLameQgrvkNZL2Tnka7Tv5dZHF3xa8nNY3k2Gc3rwmEsPZda
19325	payment	1397	1397	1678	1	1	8766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v9c2HyUURw8xxRg2Tkwju9CqwWvmHPmTLm6SQX5gsuB1AW4T
19326	payment	1726	1726	1874	1	1	8111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwFUCGp5W25wzCoM2UgDSShcTwUcJh8viGSLnDQ5vZWT4sBXA
19327	payment	1726	1726	1874	1	1	8112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8jV7qM2dipgPciBhoUKNnbTEGU3Vd6XvCTe1VmQwT12pT41e
19332	payment	2129	2129	1705	1	1	0	1800000000	11000000	65535	E4YntGBojNhZt9X2GmQRpsNwEHxWWDrtitdjRU1h8n6UVqBQ1TeCS	CkpZsn3GgWc7N7Ry64rC6Ew9d8e5eJAKX4MiCokAsWMX9R3yqggTc
19333	payment	1397	1397	1678	1	1	8769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtxTY9ckqDKsjNK2nKoBLbdhuzyPhWW3GaAdg54ggPBNK2CuR
19334	payment	1397	1397	1678	1	1	8770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iJXeKEWnjsAGVUUFQ3pEsimH1dEHNyrYteuYrNbcEmPJfuty
19335	payment	1726	1726	1874	1	1	8115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgzsWfyNXRGRAuouWV9Ews4iC7teKqKY5yez35y4qqVy9YLj4
19336	payment	1726	1726	1874	1	1	8116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kUVCvWiFRq4HJF5Zz2G2wJHZ2V3mhenXbq7nC9wBnNaE2GEx
19337	payment	1726	1726	1874	1	1	8117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7n7GZarUEh6zuArj3Mt2sKbyncfp7E8mRqmV2ceW4Nr5Toau
19342	payment	1397	1397	1678	1	1	8773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDyt6UBEy9EncQbkM8VyCyLvpf1Rc1kfE5x7vmk2xNB5dySdW
19343	payment	1397	1397	1678	1	1	8774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfK4G2MCwHAEUHveuWLjQz9C2DjVisvdzeVzkWCVAmd2mVAzg
19344	payment	1397	1397	1678	1	1	8775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUtet8DhoRAPudZkk2czyqzPmUoA3gzoGzLW2XxTPbw9NTEY8
19345	payment	1726	1726	1874	1	1	8120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbLa98fpRFA5bZruqhDvkhKBUjoHxbt2sdoY4iedXWLKAfcpd
19346	payment	1726	1726	1874	1	1	8121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjV9xA48Evfyn51grPjHTwaJcsRYF6VnL7AF3rYeWfXWdan19
19347	payment	1726	1726	1874	1	1	8122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNkWjCrrTKDndXkpLoWsHL2V33cAqDwm2RtmViU1zKwAzBLWg
19348	payment	1726	1726	1874	1	1	8123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq6e6dCdNs7zBMoKReZuykPyCqmPyYmcXE56wNACZUoLcGWUo
19352	payment	1397	1397	1678	1	1	8777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaCUm7TE7PSrVbtBRExVhknH9TaU5Qui9RgKPTsJz2dF52zdU
19353	payment	1397	1397	1678	1	1	8778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqT81x5UzVQTWorz4Z4MqLXDAjkN6uANzmbUhU8NwkKQQWZxK
19354	payment	1726	1726	1874	1	1	8126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5sBvMxTQScEMK8HwVXfPGp9DumrNQh5ntHA3t7rnvvviW1jo
19355	payment	1726	1726	1874	1	1	8127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQUPMyro8CWSnnrDaNEBqYhof5qvNoxeMqZhZKivkX6EqVBoJ
19356	payment	1726	1726	1874	1	1	8128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5svCJ8zf9RUVF3LoyJj6eZZMtP4WHNthDC8KsY8UmXzJjhHiu
19357	payment	1397	1397	1678	1	1	8779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6bZ2quS5qWLXBP6DYoCxuGwXWngaQdN1SB1XHV4q5AUB7p1g
19396	payment	1397	1397	1678	1	1	8796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XzqqiQtDUNXKYJRhNr2ghg4Lh7b7hZX9a1dVqG3qL5ABZtf1
19397	payment	1397	1397	1678	1	1	8797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNW7p9scHABPgCvRHiTgyvZuB5e1xwJbHeVz3Dpw6JGsb3oK4
19398	payment	1397	1397	1678	1	1	8798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyrtkThc3pxPAynPYWCwBN41sWbgdxLoRD8FFtSHNNdbYdRp8
19399	payment	1726	1726	1874	1	1	8151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxiFxvct9MHESGavsQBLxZmuQwnZ9U8ZEis2zEpAXUtCCENbgh
19400	payment	1726	1726	1874	1	1	8152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NH5ugB5rTs4AUMoN62wKSunaYW6GrfLy57yLCs9ceihkSn2L
19401	payment	1726	1726	1874	1	1	8153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5X55wQ7SPQ4ReQa13B5dfamgpYLUnFPrsZsBEZ4tbETczWtX4
19402	payment	1726	1726	1874	1	1	8154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPotKTGLg3R5gyzZf37zVb2naPvgw1R4Pd8BEBmuK4EMFxT12
19403	payment	1726	1726	1874	1	1	8155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTxUgNtLDdoGtAgfGKoVMQkKxX9ZAhG1o2WhDs8t7twtwbMsm
19410	payment	1397	1397	1678	1	1	8802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsixepnmvcL4vwio1pmbb6uadnE3AYVeLo41VJ1V415Zrgpts
19411	payment	1397	1397	1678	1	1	8803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9p2tv8S5vzmWK33Zmo4GPAEexXidDizGWxDKujGXCVJYae9v
19412	payment	1726	1726	1874	1	1	8159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBKXnWDX3Dp81hxdUavLxsqFe7Z9wtLNUCe2XgZ5UU3CQMgVf
19413	payment	1726	1726	2118	1	1	8160	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKiGMNBR6yjUc3jDgJY21Vd6et5RwMwM6zSh9nqdWXWQGpXf4A
19414	payment	1726	1726	2130	1	1	8161	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm7uD7V3KQRmLR6dpCnm4zUTvKELmfjNiey8GNJpVVcJdXNwoU
19415	payment	1726	1726	1874	1	1	8162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9thYDrTHTaKW6iAjjTEs3RkTUhvUY6cCJ8u7Wghj8jRYFgsv
19416	payment	1397	1397	1678	1	1	8804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSbeMhFMwfDacaUmnyj7UkuKG6CDSkWnNyTzNrvWtb5iTAdbX
19417	payment	1397	1397	1678	1	1	8805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1iZTBW3PUx12BTcxnTdL16jaFMk6ppxZo4hJaDLSkNVPPTgX
19379	payment	1726	1726	1874	1	1	8141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSsHoxAZK9CbTURwhuRxHmWYXfVtY8izpkfhVwrdqWjebgSqh
19380	payment	1397	1397	1678	1	1	8789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtBJ3UFteVjYXY4YWRZP2tQzdJoQAneJJE94GB5amqTan7mk4
19381	payment	1397	1397	1678	1	1	8790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiikxD38VZqaNA4DXAf4V7r6VVSU1PQNrv2o2BdLtJongrD1cG
19382	payment	1397	1397	1678	1	1	8791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpriy65QB9iWorq44goNk932ktAiqiGxtNS2ttyi15mrkeZ5GJ
19383	payment	1397	1397	1678	1	1	8792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3bipGauiuqxEQpHemhRbp6HRSVNJv7zu7xMLie2w251WBALx
19384	payment	1726	1726	1874	1	1	8142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgdux85QCV4TtiJWBcG7zXcNeLihen8xU6UuwHkqeV5bC1zy1
19385	payment	1726	1726	1874	1	1	8143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraeFzgYhAw6GKtYMuT3qJ6MEyvp3N7KKSFK4GCHzpHG264qC7
19386	payment	1726	1726	1874	1	1	8144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc4wwhKR1pdnrhEoRwwsPSyxBm5tqmgfYj3WRnv7LGF7LRMof
19387	payment	1726	1726	1874	1	1	8145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1waaAJ5piMXY5LYh5Z62uw2E6Jj8s8mxeTixhgQSNdr1HdSf
19388	payment	1726	1726	1874	1	1	8146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwWivn5BRD7F8eJz22YBTDaWVLDQe6ixyypimxT6kfYsYuHjE
19405	payment	1397	1397	1678	1	1	8800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdQqCzDY1fHfGfRL5Tphjc3yE6pFboPwGab6WQukQT6PeNuD86
19406	payment	1397	1397	1678	1	1	8801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrGJ6ciTQSNVLjqbs6GSXgY4NxzkSYFYXWjTYPVnQLtmT9p6C
19407	payment	1726	1726	1874	1	1	8156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpVWGMqkr3EkGgWXyn7iwvDGELTp4sZw8XeNPPNf1y7MnA6dp
19408	payment	1726	1726	1874	1	1	8157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFXgvTEn7toSv7F5BQW5Hyxrjr4XBjXSRfFS7ZeQwz8s3hM3T
19409	payment	1726	1726	1874	1	1	8158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVgSmG9zAn6dwcXmBamv4c7LUNxisqdRCfDamUXQNz2JMM961
19425	payment	1397	1397	1678	1	1	8811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdekWjwkyx2SP8EMjBcU1EJstdvvrMFJ3ZGvdQ3ysCRcgHPr9w
19426	payment	1397	1397	1678	1	1	8812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yaQMBwy3WWMpBoHEEyjP9YYYttWcJDyif3FhLmBH6XYWjJTC
19430	payment	1397	1397	1678	1	1	8816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWn9hebfE1LpSyjPqkqGVtETLK2WCt9oUFzuNRBqsFxva4TVvG
19448	payment	1397	1397	1678	1	1	8829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFM3FcaDfVmFo76RXshmsZy1oTfUH1TqyJE9YMbEoJmPLDyFm
19449	payment	2133	2133	1874	1	1	0	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTEKq7of1AZRHC9ngFUQhrpWbG3Txz2RjJ9k81Qe786gCJtLv
19462	payment	1397	1397	1678	1	1	8836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKh3xXTgaEqjd4onQBovLk2jEHSTdoTG3C8HebixJ9JZUiHdX
19463	payment	1397	1397	1678	1	1	8837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcuB9YfzhEXoZGuBNW5JnCKuo5gS1cauz98WmPdpbnWCDzQC6
19464	payment	2133	2133	1874	1	1	7	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCjvTE4iWF9LYYnFXBv9eR3jxPJyqYsa4bThhX8YcttedpF3B
19465	payment	2133	2133	1874	1	1	8	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJx9W4qhio8fobdSvwKWVrQK3yGQRAiXqPDeh8hwxk3GVcgNrk
19466	payment	2133	2133	1874	1	1	9	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakU2HGWhZRhfVCqE5rq2MP51SoSGVYsxRr6kFHwGRUiZzUzAn
19467	payment	2133	2133	1874	1	1	10	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7G5SGozoo8vQzt9FgGCV8ZD4Dkhg7S4pA5pK589mRL1XDrAyC
19492	payment	1397	1397	1678	1	1	8848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AXnRN1pFpGhBuaNH5eHBtny9RaDiUhLiKoeZsuie1aW6MS7r
19493	payment	2133	2133	1874	1	1	23	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDuXQAqr5F8AnuEQffKiGyARcGu2gWMZshM4Zujr2Eq84sSVE
19496	payment	1397	1397	1678	1	1	8850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4XPAF1NP4sDBiYecRoWFja5SkPxLyMdfbJf3d7kbKgbHQde5
19497	payment	1397	1397	1678	1	1	8851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mtBeQZbaXhJNV7oXSZPqqiPr7jXCUodWvJqGx8oVLj62pmDs
19498	payment	2133	2133	1874	1	1	25	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCM3RGQatq3QUcGumQQphb3mWAF9TSnjycknHkSPmpVKt9FzP
19499	payment	2133	2133	1874	1	1	26	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmr37UPTG4Htfpo6D5XpZRxA1gKNbKRdxhF3drW5tEYQ7fomH
19500	payment	2132	2132	1874	1	1	2	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3ihiPKgZgbUSL3LpgysYd71MCpA5Je6RyZbRkNaGPoSoLJWL
19501	payment	1397	1397	1678	1	1	8852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QfjWRDTB8SWFoKTJRPvYiH3mrJmKzTrq4YSBMugQZWGTaF5J
19502	payment	2133	2133	1874	1	1	27	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwafzzvuBovK2oZAJpjcdWg8h5md3qCwaLsWMX9cqS7ch3LLga
19513	payment	1397	1397	1678	1	1	8856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSika3P3W6RZauZQhAsnsxXdYXRCgFXwbJ4BKdYkuA371sekF
19514	payment	2132	2132	1874	1	1	4	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Sd9WFF2KKjJRLSrh1AfwzEUhQizA1TSXdtuWk988utHnW7wt
19515	payment	2134	2134	1874	1	1	3	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2UD46ZTRZd5JwpuUYtMFr7xdSgj5FSKLFFpVGu8zwUwJya7h
19418	payment	1397	1397	1678	1	1	8806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkvti175SwRiUhcPLXN6f3i5FbxB1m39jfKKZJX2jZNuCYDnb
19423	payment	1397	1397	1678	1	1	8809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SnVL1bYrddKozoS2F2k1cCJr2rsc3W2g4335qGFaZo56E1Hv
19424	payment	1397	1397	1678	1	1	8810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujDj5afGMoTcdxAcv4PRGTwcZersCsvZ5TZnPZ7mAkgJPp3V5
19433	payment	1726	1726	2132	1	1	8165	4778000	150000000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpYnNaYJnUdgYai6ALH5YRtLXTC83dFaZULJL4MnujZJQEB6PSQV
19434	payment	1397	1397	1678	1	1	8818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrNCFhiJkfrzWu5cJzSh57Ky89s6PkxxXbeguTS5N9Yh5G9Xv
19440	payment	1397	1397	1678	1	1	8823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh2HAjMkHWTbcq8CTMdaFFNaBZmaW6y6aT6bm7RPkvACvKzwo
19441	payment	1397	1397	1678	1	1	8824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCV1pyAfdk683EX313cuxZC5BmKaaMDeRMjeLVUZLRpL56jzeD
19442	payment	1397	1397	1678	1	1	8825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54uWhT8mP9ZTqqowSTHFbLfgM5yrsjLo44pfuPFK8kLQRunrx
19443	payment	1397	1397	1678	1	1	8826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RHq5mQqhqmMn8mRXjRigw8nrTpWYN7CfUoct9chXfEBkd96A
19444	payment	1397	1397	1678	1	1	8827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAwnwkkWb9y4M12Q8zek1pBG7YHcVAfzfDhe5puZ4XNhYGMYa
19445	payment	1726	1726	2133	1	1	8167	100000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpYS2QCMJJMA98Dr4dXHphcLY6QouoGTiGU3SKKZqa7BjMmrJgwB
19446	payment	1726	1726	2134	1	1	8168	100000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	Ckpa3JfFqDv5359RqFqYCZsshMQvDignZuQXBEf8XaWQiwVtS9mDb
19470	payment	1397	1397	1678	1	1	8838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68kpKYSaEMLmkbkth8ZStMj8xqhJmAFCSUaGLLmANJqzpiENE
19471	payment	2133	2133	1874	1	1	13	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPu2XAaWqRx6euRstnEmu2XxKS7PqwP79Sjf3oRJH4jYWG1Jce
19476	payment	1397	1397	1678	1	1	8841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhF4V78aNJwNenbdesVWM2cpEybWUDNrMKJy5Q6A1Mp7aayyzZ
19477	payment	2133	2133	1874	1	1	16	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9nmRHkJLsH64RA7sVSKxnhAiD1E6KzDdZxYgR2UujEr7EaDn
19478	payment	1397	1397	1678	1	1	8842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjfjX5siHQ67rzSU5BwP2ZwboRsjL41Nu5zJYUSGZUCNkvDRa
19479	payment	2133	2133	1874	1	1	17	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGabhSDdgNgxQDsdFf3NbgYvCJopdUEA9azk6Zs4a3KsuXYKc
19480	payment	1397	1397	1678	1	1	8843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaY5kYpYJnYnwVSUh7ntyEHRWsZ3sZcH6dJNZs4m66bmR7qVC
19481	payment	1397	1397	1678	1	1	8844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYP6CtjX2VdV5pUkPL7nUfSqrKGd9j6R5F1p1k8Zh8QBkSmZB
19482	payment	1397	1397	1678	1	1	8845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAg8BqB4aV4jQrMHKkqbvCyvzCZ9FEWspsfoXey1R6WqSjRRy
19483	payment	2132	2132	1874	1	1	0	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEX92qRRCspQahTmDHTMy2oKWkYLt1y5f4J8KeQU3diTvnPAz
19484	payment	2133	2133	1874	1	1	18	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsuLyFTH3pRvTVE7xifLdTrq9gBs3r7VAv5Zwn2qRG9V4DcaA
19485	payment	2133	2133	1874	1	1	19	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQj8HZVDLyRVq3JVMbqFhcZtYbENsJXvAUqoUw77BHqB9gxGM
19486	payment	2133	2133	1874	1	1	20	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGbvaYYJ529TgRARHKDQhH6iQuPLatABhKSzvNCMF3z5Bh97W
19530	payment	1397	1397	1678	1	1	8861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkP5aQaiRTMQdpGrV2mtA64kD1PbkUkKbEi8SSoAYzakEbbLZ
19531	payment	2133	2133	1874	1	1	36	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xDTt2kqfAVpgbK18Fqvpa8pQSALpPEyFdGgHGhm339ZtMuNX
19532	payment	2134	2134	1874	1	1	8	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYo859kawboYpP9FY1Akzrs6EFg9kYxqKe79LeuVnp94axrKc
19533	payment	1397	1397	1678	1	1	8862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TTC4nMn9Re9W8rSEQ4JL7Z9dXTcEuaSA3tVrDMzgsJzr6hPa
19534	payment	2134	2134	1874	1	1	9	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgb5sMyLhecCt6jKj8QtwRBWkHrrZn9ionmCJvE1N68ogAFtZ3
19539	payment	1397	1397	1678	1	1	8864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTqY3Bwpy9dx4t4jqPhrAN1fcqJYi3FP6EN8ikypLQ1fke6ZJ
19540	payment	1397	1397	1678	1	1	8865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dq4qBUNwnnveyLf3ixXvfNxAqcYXGrbfqYqjcMedgh9FPt3d
19541	payment	2134	2134	1874	1	1	11	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4KdJaG75SkDL3K3E3RLX5aW8hxMRtzuLUYXyECoFLrxWxLRK
19542	payment	2134	2134	1874	1	1	12	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YopmaRGJjSDjRWysbcKE3KkZ3cJ2nVAPCEky2bUkj3PAFQxn
19543	payment	2133	2133	1874	1	1	38	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kxEgqcoZhYrusRUFhVz8yxTz23apuiaPfwtVLsqgMeVb6iFF
19544	payment	2133	2133	1874	1	1	39	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hawoQFgFPbD96p8RkxTRKoS8ZRHrkWRobaBjFCjAyx2aQdPg
19558	payment	1397	1397	1678	1	1	8870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkHWwT6jrjKkwanAyegquqUY37SJr2ycfGagii34dcnUzUXqz
19559	payment	2133	2133	1874	1	1	44	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKLsaYwwhdxbYUq4HxVdGV8cmtp5LWz9U9DH5PencvPQKdekp
19427	payment	1397	1397	1678	1	1	8813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVkWseRVeQgzSU9J2CkRX5vaYAGRgHE9yCUsxwzfPMaBNDFTQ
19428	payment	1397	1397	1678	1	1	8814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmD1Cb8b1pUqBQhChGtQcYynDN9R9Wx4mak6nkVqqtB3zBXi9F
19429	payment	1397	1397	1678	1	1	8815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4q8FX9WcZu5CGqJvfqw7tVxPxC2srttjytyQm1DP35VmH639
19436	payment	1397	1397	1678	1	1	8820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDR2LwDza2QGw8XCtrEsLFySEYnZCTwTEGK8NUqmCeFLML1Lq7
19447	payment	1397	1397	1678	1	1	8828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzHpfvgWXZb7ntMMNzMzPGG56UQu6WPynXyg6jazNJoFZ24Jw
19454	payment	1397	1397	1678	1	1	8832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP9wQHQtEjqBe6caVE9VSJcAwrmoLvyxbzPbzCndRRN84FbxW
19455	payment	2133	2133	1874	1	1	3	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrweWsh1pKLXepRJSTmwwsuwewNc7rb4zg1NFEAgTfNWR8Zho
19472	payment	1397	1397	1678	1	1	8839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgLy5vVGXhJMDr2XsntydnhTEtzXp8MaePdW4w719fpj6cqNB
19473	payment	2133	2133	1874	1	1	14	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5U2GPLMQDRa8oMDRQLsDBhbHmmz1fp2qFFFtVNN631bAxXZgZ
19474	payment	1397	1397	1678	1	1	8840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmbzobcUL1CmmAsVnPGZFWWCaz71aXQfMucTaW3fZmek5oUVV
19475	payment	2133	2133	1874	1	1	15	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16zszYfJA839xbyit8E8ryZ17CnmqiW6Rh2GeaE1URWARpVXn
19490	payment	1397	1397	1678	1	1	8847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JXssgvHAA9kUtqhFer8LifeCoDK7mEhj3YeMWxuZ4Rpf2rbX
19491	payment	2133	2133	1874	1	1	22	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZpawjjkZTJbnMkFfoqNDNdwUUrdP6eSgka2cADp6xrSFuFbs
19507	payment	1397	1397	1678	1	1	8854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBgMz1dj4C6ZkDvQkY2sT3wWX6DSQrfHZ8abZMAP4M8wfLuc5
19508	payment	1397	1397	1678	1	1	8855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe82FJeCetqTZ98cAhVKwqgJdZFdJ93GeobCmFdWgL7mE5xC3
19509	payment	2133	2133	1874	1	1	29	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZWoHzqomALiyQJpeo4g3gSp9ie8C2LH2Mk1a8miv3BbHVMFk
19510	payment	2134	2134	1874	1	1	1	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5JoGXqZcXr2B1GoiqUStWF1N9FkrqFd8ErsD2cVmDdf9BZNd
19511	payment	2134	2134	1874	1	1	2	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSU4FJkAwJF12d9nM7Mkj53Amy8TNP7ahEKmzN5eTUaRSsCqsP
19512	payment	2133	2133	1874	1	1	30	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3TPYWZFozdvC8L3pUPY8wG1TrX8G8cdp4pbhm9ceqonPumyJ
19523	payment	1397	1397	1678	1	1	8859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1MEX4hQA9oQ7Q4rZX9MZvyybKhoQUs9ej5gc2vvNd8wbGWL8
19524	payment	2133	2133	1874	1	1	34	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHktSMvaKwyVMirNLjkCpMcwDiLYJ85BgM4bwdxRWzPuXsBeE3
19525	payment	2134	2134	1874	1	1	6	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYjBZmvoy68fPFMva4EBNywnHga6eC2sE9tZGLpNp63TLnG44
19526	payment	1397	1397	1678	1	1	8860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Muux7SrdYsNxAw6Kk2yhruxBprVxWKN39A6cGKXkNm1uQSUp
19527	payment	2133	2133	1874	1	1	35	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTvCGuR4Pmb8H23FW4H3XEPvzn5Lr2t4bb3vfB1wWT3q7piPh
19528	payment	2134	2134	1874	1	1	7	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi64K6tGfzYAjp7NWuH96Vq7ZHGAkdY87Rwpp8dSdTrQhadWJY
19529	payment	2132	2132	1874	1	1	5	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbwVpFXYtXrJUpp4XNWufSMTRN4favS9xSyKgtkymqUGZXkBo
19549	payment	1397	1397	1678	1	1	8867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL62NmDJNJjwv2JMHWQq28x44rYKkxekrb3n2jjfPxTAatrDSp
19550	payment	1397	1397	1678	1	1	8868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUYEYHENxcDLhv3T5yYrMRkMjqUY5oJKhWHmFUMs6dmqDtH2X
19551	payment	2133	2133	1874	1	1	41	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7Z9XirRZbhXdWyZxtguB7LxtCAGytmE7qhdFe2Q2oe2ZiPSg
19552	payment	2134	2134	1874	1	1	14	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P1xSo9YRntkuVb4FsbAgaKvNpX9E1n3kMSbRxLrE8pBtf4Cn
19553	payment	2134	2134	1874	1	1	15	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcHEvZMW3jW1cbPT1KKzJaejH2i6xw3ph4MNfw8VfKX2coAYUr
19554	payment	2133	2133	1874	1	1	42	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJomGcrpTEko9DHrqKukCDDs9vjwSBdajR6cEgk1Bg2qpjFrJ
19562	payment	1397	1397	1678	1	1	8871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUmcEx5vSa3fGrQaVmrGHXim2Z8AdPvuzwu4DV9oeGXAWfVkKd
19563	payment	2133	2133	1874	1	1	45	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3XNaHzzGTXuVUe6r2Y8ErnaioHnwSRKTaVYuPZLJoVdzuQKW
19564	payment	2134	2134	1874	1	1	18	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3VGTBKDhrXhkPst4zTHfQjBkP9Zv6j8TsFkSQpjwBYfZJXZX
19575	payment	1397	1397	1678	1	1	8875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjophm9oUZBaXN9eqsSKpjBbr8xfGBWXc53H1Hrw6jcKndMdoY
19576	payment	2133	2133	1874	1	1	49	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7NDufFU89kZEF2S4iuYh3f9gJV7dLUaLaoxvhQ5G7np5nVHA
19577	payment	2134	2134	1874	1	1	22	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkgev6NQbL7XXtW1KFcjpQpd49qVy5qqmQfATTumpGyC2qNU7
19457	payment	1397	1397	1678	1	1	8834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5pu5x15196xyABZnTo3QAqHXN9bwZRRoGKfpnzzSN9Af21u7
19458	payment	1397	1397	1678	1	1	8835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfNxkgibcfYcCCkkp6DGFyJszgTjYYkD32hKgCNz8BCkWAYKW
19459	payment	2133	2133	1874	1	1	4	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx5SLtvfVE8p6p6APC1jH37qN4vKQsW4HzJWhkix1yw9Vjkse
19460	payment	2133	2133	1874	1	1	5	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcSH5si9gDnRiPbgLvuuSbEgnM2p14puT7VsQTEsfvHKQkrYw
19461	payment	2133	2133	1874	1	1	6	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYCnQnoN52FZZH51KeyE4VLg1TqDUvoqBeFtQcZu4ozWrCJFB
19468	payment	2133	2133	1874	1	1	11	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUYBvPRfyUchf6LcsSWY5yKeBUzfXSFK5jn6t5Mza3aNRTtF4
19469	payment	2133	2133	1874	1	1	12	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosFmdFzC8kZtos7mm89ZxbspYQzFCQ5DEfkezRbT6gFzFf18X
19487	payment	1397	1397	1678	1	1	8846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gye768tUi1emWYdwmxEJGL7WmtVQ2hYu5mLz7G9CD4jR5Fh6
19488	payment	2132	2132	1874	1	1	1	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCvgqtcKWwRu92P3RYY38Pu2V3dEWAfgRiFpPExnrtdm6sVus
19489	payment	2133	2133	1874	1	1	21	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagDkkm3qMxDt5YVMKB9Do1H2PTVsKs6k1ARWVk9rm8LxaSwBQ
19494	payment	1397	1397	1678	1	1	8849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXXbJ3g2diNfhozAitn8J9ibXHLLBciMJUZg7icRh4jPt4J3M
19495	payment	2133	2133	1874	1	1	24	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHNeBUfURp8YVyFd6sJo6DMFTV4o7sBYjKZ6WFasRPa97cYSa
19503	payment	1397	1397	1678	1	1	8853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jUf9KBenV1Jz5WnCV38VgRFXkD4gkkF1fS1itSGSSdhpU9p8
19504	payment	2134	2134	1874	1	1	0	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fZH1QrbmBaQuzj6aDHYQ5NPLAp1dxbYb8H6aVHatbPsTMYkS
19505	payment	2132	2132	1874	1	1	3	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBAvTSq2jbcD1oL1whkJ6gnHktErvyv4gpdQJSRCABY8AB4Ds
19506	payment	2133	2133	1874	1	1	28	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3trcPpF6R9b9dVxa9xtt3PkAu8nacFr3a1AYUXE9QHf5hshD
19517	payment	1397	1397	1678	1	1	8857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExn13znCt6LnX3s5aYuPtB4CiXENm1NSz3PBTaFx1T3TA5xMP
19518	payment	2134	2134	1874	1	1	4	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMDqmcBQAd3eUNyKKBPwKdbYyFwNUsV61NaoaovweNeKGvn4z
19519	payment	2133	2133	1874	1	1	32	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfksFxJyVAVswY8pbhT9wXMutMCKVyuMAX2LgCmT1qYkKs11X
19520	payment	1397	1397	1678	1	1	8858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXWd5cYQJznmitX1yjcHmZE4Rs6VxBjLr4eHvPt9eBqZxA17n
19521	payment	2133	2133	1874	1	1	33	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnj35AnfcwQ7PDK5g9iKYkMtTMJ7eou6Fs7AQd8gNBq3gaaSJw
19522	payment	2134	2134	1874	1	1	5	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ687Mv7JCaJHYTztbn4XhwFdm1359F17JoZb55ivSJLMP65KhN
19545	payment	1397	1397	1678	1	1	8866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vkdM3boWRHpo8AK72YfcHq3qpp17F94cXZuHfm5SaNmkbyuz
19546	payment	2134	2134	1874	1	1	13	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBMr56J18FQsGFuLnTp1t9wX48ymY6eX41mon3KqeU9pfH1us
19547	payment	2132	2132	1874	1	1	7	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrFEfFi8mWGCjDMRckg3AVMNuPqsBHaRJyoxpd3fYm9oB4e75
19548	payment	2133	2133	1874	1	1	40	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6zcoBCCKP3vYi37gUL6JXJDYjt93LX8sfymWL6Jcz9vEorF7
19555	payment	1397	1397	1678	1	1	8869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoULepahAYwPgRxWo9ETdt6nseHy54uNXHzHsX7fTyiYC4Vct
19556	payment	2134	2134	1874	1	1	16	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRc8towDonf7CrJ9h1f6hYFaG4oJ45fuCmFvbCWaBbDYo6aUy
19557	payment	2133	2133	1874	1	1	43	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dZx8x7ghVsuU1a3YuF56Z37dSLvNmFi2Xam1FZkDHvLQswJo
19652	payment	1397	1397	1678	1	1	8898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeeHUymDdyZxH7sQyRqCp7WRxToCaYAocMymrYEDDXbWHjFxT
19653	payment	2133	2133	1874	1	1	72	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1NYWRfsymHGXLd3i5usvWaXzta9wTYqAfhjZcGAHFQFzAnmR
19654	payment	2134	2134	1874	1	1	45	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2F3J36gnmtgcoLsz36tLkT4V2vvKKhKnpApwUmggpHq6WMPY
19672	payment	1397	1397	1678	1	1	8904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUPDWhHLciYnkhvacGU4maKR1owJK9LL88czYAKxtfesKfCvY
19673	payment	1397	1397	1678	1	1	8905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtos1PaVTwtmSfS7S912rKXu4CATbVctDCtRsUfN6akb7Kts14
19674	payment	1397	1397	1678	1	1	8906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdzRXTuzCqEtc2uQSRLgwqasqaKgGRqKCur9X4se93JXFvbJZ
19675	payment	2132	2132	1874	1	1	19	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeduw6Hxkhj5nvXRRSjrC5Jyw7tpJ9KaizfiA2izejcwPBkNhd
19676	payment	2133	2133	1874	1	1	78	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEm3shRW6xnNHnKuKKWy6vrpAKHvaiWXkicr7PMGxK2viNYTwK
19677	payment	2133	2133	1874	1	1	79	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD5F9tm5ekBJJH6PP7zFzCK5wxNmhX6rVX7ESU34ed7AS5zSs
19516	payment	2133	2133	1874	1	1	31	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbjGY2sYVb8rh94Vz13gC5BwFuBLjF318WWMED5qPmVz6WDXy
19535	payment	1397	1397	1678	1	1	8863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFuELr6eCU7fEh1VizwbZ48QHmQq2eTtTzCfXED8FgzpyGYDK
19536	payment	2134	2134	1874	1	1	10	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurF5bQfzCCz2J972P5e1PBh1qijUnYSwYDxhJR9UPiXT8whjr
19537	payment	2132	2132	1874	1	1	6	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5C9YKt35AVxsRpJAuhUrJoGQkfbt1DWXmp53DEYAkxt3cfS6
19538	payment	2133	2133	1874	1	1	37	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXkSNSVk7LH27v5QuSaa2k3ehLy94Bvq875SJeCZkJTj2Qdsm
19578	payment	1397	1397	1678	1	1	8876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22C6fMGupe7fuBe894g29mQc4o2jbeotKRXbGDKWM8mXjYXUE
19579	payment	2134	2134	1874	1	1	23	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kYGnBuX8CgRkLD4hpRpP85DDHkwvuSJw6gJCGz1fuXT9E8rp
19580	payment	2132	2132	1874	1	1	10	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWP6Fv1jApuuT3YUCDRjsEKjPxpN8me6tRFCrjiaK3tm7BeNC
19581	payment	2133	2133	1874	1	1	50	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4q37iBsdojEnVeEKXki9VsrHpN6qiud6HKqiQQo5fYJGcfVS
19591	payment	1397	1397	1678	1	1	8880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcLi3tKLRsAuFyPHfgnmCvxmJEdU2ZmVe4krgroCrs8zETieH
19592	payment	2132	2132	1874	1	1	11	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqKuihvTbUmXS4WugYAEzwLM4Q7CpESQZ5Kvd386jfKSAmeAq
19593	payment	2133	2133	1874	1	1	54	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGTDvP9qRhcasKgDH3PJwY5JprUEbSpqV7TggR4D9QxEQ2yAA
19594	payment	2134	2134	1874	1	1	27	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7dFYMZR6FH5RKKNE57BfsrTfS6kNVceR7bANroPHxqyGZHy2
19601	payment	1397	1397	1678	1	1	8883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu8exVScMo63wvzj9CXg1giadSFxQsPYgQUkXZaVAHbJaDkFo
19602	payment	1397	1397	1678	1	1	8884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQJ1cY8dj72RiXFBueuxWFFB5uQvGpdo5Qtggi1Y1zojvMFHy
19603	payment	2133	2133	1874	1	1	57	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFXJkAwJdrGPoTXhtg2vErnqSLaCz8iWSpJKp9ghd4tPUF1gz
19604	payment	2134	2134	1874	1	1	30	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxD4BNgsmss4oJjUcULWMGhJuvgTJ9kf7bH7ahVgaoo18W33f
19605	payment	2134	2134	1874	1	1	31	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgM72YJD8kCcrLXJbv32yDrxvtM2njKQobSFvHhTKvpvUsRRv7
19606	payment	2133	2133	1874	1	1	58	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EoN9ptD23BMzzXKnXQSNeLqHUU4tDgg4rbF71hTen1pQkezT
19607	payment	2132	2132	1874	1	1	12	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5QFmKeAPJp74HCcP8CupRMBeVWq6ab8yT2iAxf6C8eQxHq8j
19628	payment	1397	1397	1678	1	1	8891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrH2PgnzeKgtTnZvw9DbhyqPP1ATKgwHd9KUcMacyh7h9ChHP
19629	payment	2133	2133	1874	1	1	65	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iK3ajAhU8tUCAjrhaEoKasidC14SvaAssDiCpFaCXcbmtb9n
19630	payment	2134	2134	1874	1	1	38	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojBpzWRPQakr3cnspsr469X6dHYBAvSpn4ooj1R1E5YFtuHWd
19638	payment	1397	1397	1678	1	1	8894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJMSHYTZHb1zutMr8PDkynmCzCV5Jiap1VaCHWegR362LRt92
19639	payment	1397	1397	1678	1	1	8895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXyE6CJgFfE97BbFakSiGX7TheHMQrvFU69Rpu56BGFQmgnza
19643	payment	2133	2133	1874	1	1	68	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVjUWZ2va9ezB3TYh7vMpAU4TJxHvhayJjb55899h4DSRinfa
19644	payment	2133	2133	1874	1	1	69	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFpbo1zTGQKjj6LDVZ3RN1cbq39ZmZfckSKsy2RJfezLJeam9
19645	payment	1397	1397	1678	1	1	8896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjMWZzQo37EmRftZB2imgXRh1ouDn1bXyCC4AJpWv2X7eftRB
19646	payment	2132	2132	1874	1	1	16	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwWMcTEvQk96ew9JPiGtzm3c418HeEmE9ywCcFMCYNgQk6wrT
19647	payment	2134	2134	1874	1	1	43	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5CNT6N2PaAbKBBU2pvXdWo3tErUvLFqbZW1EjFKBBbCfwLkh
19648	payment	2133	2133	1874	1	1	70	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfF2qDw4mVXmjfGaBrJ1ocv4ZUdBvx672J1qfCFLXmDz2EzM5
19685	payment	1397	1397	1678	1	1	8908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa1t2zBfm4TayFWEw4p6D7TRW4aYxnopzBCjBD7FvrZLmQuM2
19686	payment	2133	2133	1874	1	1	82	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJuuZtegNaFNiLQS4vFUwT68FRd3u1NYWS4zLbM5zoVB7B1RB
19687	payment	2134	2134	1874	1	1	55	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2r2JtAmd3uKmTLrq64Q8SfAmKeFqNVetcSCvB5LEzvMJkdjWg
19695	payment	1397	1397	1678	1	1	8911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabJDx5aLBZRXAeufqG6zGZtTZLZT33ui8mbvXZbE6VLrWJoBF
19696	payment	2133	2133	1874	1	1	85	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSMgBeFuRFVTB9gJ1z25WCn9UvRi3UR3DJd1ufvYSHgzeW2ra
19697	payment	2134	2134	1874	1	1	58	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7SCjKh2LXe9tDfrCAws1GfzXfeWEK6CDuAufSNsxsdocmkJ4
19751	payment	1397	1397	1678	1	1	8927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsciYMQcYAraK4wa21LfMcr9t4p5PNpBbby6b6mPFEzvvAxLT
19560	payment	2132	2132	1874	1	1	8	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aEeA7X7EiVEz68KZPPDN1u37AkkTD4H9gKViWkv5YFmt2TGs
19561	payment	2134	2134	1874	1	1	17	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiiYZr1SR8CB7zTKk8pQXjte6hLrH8t8grnyqf2a4o3BEv5h9
19565	payment	1397	1397	1678	1	1	8872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhvpvHtnb5Roc7LYbZ9atThbTeuCb3Z2dqbMRnYFyrz1xU82o
19566	payment	1397	1397	1678	1	1	8873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSfNjSQ6hstyHN6xmxZdvP8SCj1ApRuFZJA48TGs5nEGZeAdE
19567	payment	2134	2134	1874	1	1	19	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvfvDx4Ff4bT4qkiGST1HjBtCFpjazy6ujpZmsUJii9R9yiZ5
19568	payment	2134	2134	1874	1	1	20	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aaajpVwR9q8h7ir7UkWAAP32kFVeH88T7Rxwnggtpi98ySa7
19569	payment	2133	2133	1874	1	1	46	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZocX32r6bxa5TKjXtdZqUwm71JfbhwEbwk7EWXfjPji23KNv9
19570	payment	2133	2133	1874	1	1	47	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPhkMjLmEAFN4yA7xsP8QLN84N8K6Me99csGdVYKmQXZMDHPA
19571	payment	2132	2132	1874	1	1	9	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzksrXn2qoAqmMHWws1dTsKvqq1RihmN6MJXevmm5UieoWJQnC
19572	payment	1397	1397	1678	1	1	8874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoQoJj5U4sWWDtDAchBt6x2N5meR55ZwwQpcU8819JXanBZkp
19573	payment	2134	2134	1874	1	1	21	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzn9TgYNsJ6RkwNjEVH1yRrh8YXtQBWxobEsyZnkVBA43SP8oX
19574	payment	2133	2133	1874	1	1	48	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3GHcb899hbdr4BG58z9kdFZYbjMuRycAkCBT8y4e2YmCcrnc
19582	payment	1397	1397	1678	1	1	8877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4Xp2JhtR1dgNCDgB9qHXhs8Q6vzRmWGkDZMcKDb6uZsE2wS7
19583	payment	1397	1397	1678	1	1	8878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfC3A6Xmo3J88RKPJ3Vde2Q76axrR2gH5yM8pV57871fqipvc
19584	payment	2133	2133	1874	1	1	51	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS2Fq9GAmArKtT2h1aXTZFGpJCSD5zBb8Hcy5SAnU9Q7Dqvk2
19585	payment	2134	2134	1874	1	1	24	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gSw1amYEaExFK7KusQch7d2qxcSvhfveSX5DnBxLF8frtrNE
19586	payment	2134	2134	1874	1	1	25	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEMmtq1vnPJxdcvxH6sTemZWk3bMpAeBsai2X8jmrHmJKb54Q
19587	payment	2133	2133	1874	1	1	52	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGvdSMQ8JgvGLx83aMTGtaXWFZHWgC3GmjqJjcX4xv8fPjDuu
19595	payment	1397	1397	1678	1	1	8881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAnRgKdBPF2reVBuC4R2s8hcwjsiAsxbfgGT35wyqHQrhhoSk
19596	payment	1397	1397	1678	1	1	8882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHuTgToaUF24gFauyPxJYrRm9EPP3b4nFtboRE4ibJih1a8n8
19597	payment	2134	2134	1874	1	1	28	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYBC92SwSCqL3ERVdgf3oGHbRDQRodpHviPuME4BuGtLosfq7
19598	payment	2134	2134	1874	1	1	29	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBGAyxFjUEDcppP7d7KHcCWVhjcs6VPkjHVXNHvsuPrKvgacU
19599	payment	2133	2133	1874	1	1	55	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4GaLZW1Kpe91rniUBMH5HK5MDcEL2bkCbhJBGLnu845CkA5h
19600	payment	2133	2133	1874	1	1	56	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp77imaSsrT1qaH3yJkKeubH9TG3th3ZwAaadSmobWeURSdwHc
19608	payment	1397	1397	1678	1	1	8885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW2p4DcBLyAAfBLnYwxMXh7wSa1jwzYiszek5rb11qm6PX59F
19609	payment	2133	2133	1874	1	1	59	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimki8iAMmMwLmmdaXicPRcm33LJwA73B3hQ4CmoW53zmJTsHB
19610	payment	2134	2134	1874	1	1	32	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfRid5YD7xBQwYKatDsE5D7n5YMXyGSqwhyKEgQeRQumQuTpw
19611	payment	1397	1397	1678	1	1	8886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYxFAHPsx4kRXsb8KTQ4dTmcjvZd1FwbimEmY9U5GvYoTSZXb
19612	payment	2132	2132	1874	1	1	13	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94jbYPS5izGWbPcFnj3FMSf9gxbjoVaTDu4uuP5GC6JyhZUP7
19613	payment	2133	2133	1874	1	1	60	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzCDFFctDfAPULvPY958a7XAVFUfkgq5Nub5zi3TsouLUFk2c
19614	payment	2134	2134	1874	1	1	33	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPrDLRKnqYGZuetf7W5swopTVYibfW6mWPf49LJhEbBUV6XEk
19621	payment	1397	1397	1678	1	1	8889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHrDjz9pMxxrNC61Q2JshcwdzNdB7K2MuStTt2dUJc9kHzn3W
19622	payment	1397	1397	1678	1	1	8890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoEgH4WJfJTsA3r2GVTVqkEL9adyX4Pvxo37dYUmX5qGfVFKQ
19623	payment	2134	2134	1874	1	1	36	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEvGMF1imCwTuhwAHGsKk4GXiXKNdtCS327LNoaosPKPdKgbM
19624	payment	2134	2134	1874	1	1	37	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExkPzd1xVQUhKve1PnWcBEudgx7y81E5YubhjnDNeJDhiv8uc
19625	payment	2132	2132	1874	1	1	14	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqf2bvyEDu21dv1mx6yxVexzdPXnwaEgAPGdD4Xw4pxsjLx1R
19634	payment	1397	1397	1678	1	1	8893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbs7eHHgdj6pGktLbozt3hBMcaoSV2zrDUmadnJzXKByg6Sgs
19635	payment	2134	2134	1874	1	1	40	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPzYAWBigkJ3k264Ldcd7dVBtA6YpqmJZiue5LGgNa711cufg
19588	payment	1397	1397	1678	1	1	8879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCP1z2tgGgdwVS2a8W6B4dGpTZK2M4DYj95NVsdc7nAcyEbZW
19589	payment	2133	2133	1874	1	1	53	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJNyZTe9Yp8dBGJkLEDXjjbG6aT3TSvNZNP9LciEKjGapFG9R
19590	payment	2134	2134	1874	1	1	26	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqL6xQgFrJ6iBzReDQ9N1kHGCBPv6n4UQFAJ9Z3RatgPP6ptE
19615	payment	1397	1397	1678	1	1	8887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSMhnmueiFrRDT8Wuxof3m9s2banDpw4iWvUWgXVq69wzyYKN
19616	payment	2133	2133	1874	1	1	61	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjjFBMvMbbjh1Pj4PfTJH6mD6B2xLFig7La45vJUfs54JoTK5
19617	payment	2134	2134	1874	1	1	34	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJcY4tU6KTno4hR6PMtcro4s9LELPq3egW9mxRKWi599TMFAs
19618	payment	1397	1397	1678	1	1	8888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjdjtVcXymSZikqrvPhQ6WfQnkwfVvbPS7Td3wZjeH2t5hWao
19619	payment	2134	2134	1874	1	1	35	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvDWg2WusbPVwP8YDwVsdJ9wC7aJeWjnT4Tai973qoaHBkxS9
19620	payment	2133	2133	1874	1	1	62	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ7Ac28qDH7YdvUyCnWxiXfvjkJAnDBNPGD9UrfZQhHCTgdUz
19626	payment	2133	2133	1874	1	1	63	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbNy74DwSYGvadsEKbrPrGyLWZjsLsRf9g39d8jnM82u62dj8
19627	payment	2133	2133	1874	1	1	64	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVRXi6icN75nhYf1m3wwF1inQUErGoDLebhkoHbhYm6Cpo77T
19631	payment	1397	1397	1678	1	1	8892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mZSXHoqCYjPWBHVwWiaEeAnsRcVFhUCr7z5oX7gQD4WJNARn
19632	payment	2134	2134	1874	1	1	39	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDfgUAssY6Y5vrrVWXWoWrJUwmcfL64ytoLc9G2gBXvaGaxHn
19633	payment	2133	2133	1874	1	1	66	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmS7imFnsX4zKeXQ6EbZFRtv7zSTeUtWgoz69CvDc6nZfy9Rn
19640	payment	1569	1569	485	1	1	2	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtciwTd3To5gh8qHzbZZoCxokxVqtBES2PaZ1SCCwsvX3X37AZ
19641	payment	2134	2134	1874	1	1	41	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TmjVkwP6swb161S6TdRzKk79aMqNumVYTxP8PXJveXzdpu7k
19642	payment	2134	2134	1874	1	1	42	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9TWck8Ee9zcCjkW1T42Mw377Fv3jkAGFA1U6aag1xG7KuGVB
19668	payment	1397	1397	1678	1	1	8903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Kt1N6tMPWVVt5WdZQkMcCK6QZoiLWsMSF5yFaVfnhXuoFkUY
19669	payment	2133	2133	1874	1	1	77	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dWD7fiqtNedUx1wY2yXGqmbcwhiDD5KARPBo57vvshWzY8Gp
19670	payment	2134	2134	1874	1	1	50	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWFy82Pb9K46KbYSGq1XmfK8ENxwbi3hFC4LJQjN9maVe68rK
19671	payment	2132	2132	1874	1	1	18	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKpsYRF9Szzyfssx4J3YQLEuZBsZoADa1kE5LRLRDmkbHAEVz
19682	payment	1397	1397	1678	1	1	8907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9mbc7rDVHVwoEbCwthJyyg8Vf43UwNSKXmCidfMBp5Hog1c8
19683	payment	2134	2134	1874	1	1	54	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsRjEzuE5PEwru3RtXgbyMfWji8oXJi1PtNqh3s9qLxEBfjPT
19684	payment	2133	2133	1874	1	1	81	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUH5srPJ4aDJUr1vEJ3RP79dtyuvw1agLXqEdtECXooVang25J
19698	payment	1397	1397	1678	1	1	8912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGra8f1CqQ3XPxxR4hKtbForFF2nfrJ8z7BCEtiD4KMT2WX7EQ
19699	payment	2133	2133	1874	1	1	86	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fFCa4XmLvJ6iZVuVoyHkGHzACt52pFKt2qisyYwovivxEh9v
19700	payment	2134	2134	1874	1	1	59	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bBfK9FNFXMxzScR6GrMxQeRLT6edDyx9z1Xvf6mpHfT89P4w
19708	payment	1397	1397	1678	1	1	8915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt3ZMRufg7MZfKyhSREGSanbhhFE4ky6LnkbFZGfCjtwtmQgM
19709	payment	1397	1397	1678	1	1	8916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ku1Gs3wNh12mt1fYw7r1WDJkqQpSdMJYTWgciEEb5sSqeuhM
19710	payment	2133	2133	1874	1	1	89	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqAvVq6gCQR9tsAvmrb9nA2F5GbBd2SJptDJktkaRq5Xuz34m
19711	payment	2133	2133	1874	1	1	90	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TgerJyE7MYrEyGcg7HAvhSjRqjYAhrVbYzsXzuwyNWyUgk5Y
19712	payment	2132	2132	1874	1	1	22	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfVNRn8PvBZPoeRkFFeTj5SBYpejAFNRkfDFbXsTgCg8J7RqD
19713	payment	129	129	2136	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7W6mGdhGyTFFTebJY2Roxry6SzAzt3k2nMvj3r1VmNrPrkBV
19714	payment	2134	2134	1874	1	1	62	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTaEKECu4h1fw8cHq1WDtLRtLFeCX6c6T2gkvmaZJSSGgV1P4
19715	payment	2134	2134	1874	1	1	63	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQNfjggmHUTudSunju9AsThjH8FG4eSwqbhL6XXmsxVDYcMEY
19736	payment	1397	1397	1678	1	1	8923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucPP82JJMMWv5H3QCwz8bJUthycKPe5v3sJAHSvELLvZq31Sk
19737	payment	1397	1397	1678	1	1	8924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhjRc5ThTFTxL7MRKW3j7DhZ2JHZRfBW8VcTsiJHjftpysLz9
19738	payment	2134	2134	1874	1	1	70	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvPUSxiyXtTfqGeFDcKwfxwxHkqxFsdUf7nhmWdVCMTgHz3L2k
19636	payment	2132	2132	1874	1	1	15	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqismKAiwcBpYkaUrXNeKChCYxUvkg7UrNWMrioNR3of8MVrj
19637	payment	2133	2133	1874	1	1	67	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtgs2piXrf54X6yjQ9dFKPzAcHvtdU4ZboZB5AXGiQjj55GBA
19649	payment	1397	1397	1678	1	1	8897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWSRXE81xu7aBQDSiugvzHYEMjtTdAWdurGe51jtGAgUtepob
19650	payment	2133	2133	1874	1	1	71	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ838tKWdjuRJo1b3R9WaBvY9F3DjvoLyckzCkzWzGJEqdCsrjW
19651	payment	2134	2134	1874	1	1	44	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvzJiD2XhUBzbSJYhqwh7avFghS9PUFKd5PH1eFkEqhjWxNYD
19655	payment	1397	1397	1678	1	1	8899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6uRbSjiRG3YSjukQGbJ7LbRmzva2TybfA9qMqzJ7vKE6pbFw
19656	payment	1397	1397	1678	1	1	8900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v393NpeRVinJfGGLHrGhaov8e1pubQPmKKnfTgJdLkL8w2XS
19657	payment	1397	1397	1678	1	1	8901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLr9XwnNYingjNWohoc5LShZjChv5bRskm4W7RTq833AJ4B8q
19658	payment	2132	2132	1874	1	1	17	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY18X8RBTnEeTECxDBzo5Vz8tnTUUVqqwYKegeQBRuoYBeX7j
19659	payment	2133	2133	1874	1	1	73	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy48GtLwMBc4JXrw9D8xZExwFb2rbRRVqNiGfTLYEZJkyrGcRH
19660	payment	2133	2133	1874	1	1	74	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sHJz3CXB1o6NhDyPWY7PPuVzpoDfDDysNSW8tTuRhqp7ngFv
19661	payment	2133	2133	1874	1	1	75	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWkP7C3brZSyj1N7BRiiqbjvCLqy1oA3qs9E9WomT8CYZbb6a
19662	payment	2134	2134	1874	1	1	46	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCiuinUyiiRU6VoXzu6xfLJT8LgnH7s9GgqwE1mbMF2rrhYiHy
19663	payment	2134	2134	1874	1	1	47	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnMRT1wqiAPDpZZnVKmiAxNBcq2sKfiajxEmgW9NyUMcRTabT
19664	payment	2134	2134	1874	1	1	48	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoaK6A5vdm6bGWw4E7ngzQM8Sg79BJKwECuisRq9ujJ8QDsAh
19665	payment	1397	1397	1678	1	1	8902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYgrV8JhfReHhyDb1cHbkHgsDsYr4HoVwKzHMG1FsY4PszBCb
19666	payment	2133	2133	1874	1	1	76	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjX26TGdcqCCiogahFgBAf766MRYa1q5ZHzM3gG3UYXrpciW5j
19667	payment	2134	2134	1874	1	1	49	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPSW1HPwSsoJnxtGYAnjnuM4G38gyv6yStnaEtVynpMBuMBF2
19691	payment	1397	1397	1678	1	1	8910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREUNhMgqijvnLxb6tCaRsAzxFoR1G3YTwsMk8e5s94pxNCQBi
19692	payment	2134	2134	1874	1	1	57	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhxvEX2c1mDmQAEsWRZzgCmheRDnJWu821HhUztj2BU85HX6X
19693	payment	2133	2133	1874	1	1	84	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFMcAKVoc4umXFsWspNjnX8TPkiNMqbEJUfiLTwfChCAxfjhh
19694	payment	2132	2132	1874	1	1	20	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtbstUtD138YBpZdZ9e1yx8eMWDoDz5nUbLojaisN26gzX2MJ
19701	payment	1397	1397	1678	1	1	8913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEdp7sMSmG43uA611h7QrhoLs2Yk4c7LwEPdfNA5hbQ3shGAa
19702	payment	1397	1397	1678	1	1	8914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhaBzRJr3U3n6MiusPFBP7cQ711T2ABrVSAmKqsjAmsAMSFbG
19703	payment	2132	2132	1874	1	1	21	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshKLCBH2XHSU9opF8Vj8n2y6LR5qYMqhxct2MjWNaCUtMD3wn
19704	payment	2133	2133	1874	1	1	87	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt1g7wfyP7GQdXMve7ndvZAzKHq3D86zE2G5Hv1KNrjUdZV57
19705	payment	2134	2134	1874	1	1	60	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uQAXs4pqVuWHQUVR9WfM4VwXaaozgZQv33FJm1SB2pH9b32T
19706	payment	2134	2134	1874	1	1	61	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKxX1SL1hAF8eAq6sqCemzWDZS35czmGdaGMevgyHnoL5DwkB
19707	payment	2133	2133	1874	1	1	88	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtiEc25cXrnwubYhSc3Uq6U45gv5P6nP2HbdgTymqTTcgdhC1
19719	payment	1397	1397	1678	1	1	8918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeggyUhHrBoUfTnXMGH7A5ANZP5B9bNeKH7KN5h8RTtHKMMHdM
19720	payment	2133	2133	1874	1	1	92	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfQ3yRexwjnfHHroZwRMcQhiQVaAv3sucoa8pQKk7BVMeZtxT
19721	payment	2134	2134	1874	1	1	65	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SUGajK4Pfhe8TTj8JFjrtewPdaEjPfHkeZeHNgXgKsk4nZuS
19743	payment	1397	1397	1678	1	1	8925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZwyBo8gCQyWpLJ4w2NGFADBhzGRgHosvP3HBddzD62bUk3Ng
19744	payment	2133	2133	1874	1	1	98	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskugjHdQwk4GPFpj8Kvt13SQDTYTDte4GMH5yuWpWgi58rJxj
19745	payment	2134	2134	1874	1	1	72	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaSmkv4JfRGEUAzgFNgNv4C7k1ytHphYCBmSAJMsQ9q7ZPycU
19746	payment	1397	1397	1678	1	1	8926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrfdXkK1Cw1YcXpsnQoP3y42YQMUYvsvMqCpWLiL5fig2U2Xf
19747	payment	2134	2134	1874	1	1	73	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxeXhovZ7G4LBx4UeUjWAHYqizHftXcaAKGVam8HuVWRuFbk2
19748	payment	2133	2133	1874	1	1	99	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqL6yfdq6ZFe4dVagH4mSqiLu7zvS6WsrA3tVCVkca4wkg5iz
19678	payment	2133	2133	1874	1	1	80	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKm3EGN81FJsNMVdWuCCBXKgz4Sv5sXQxTuSNTmRLoEUtAsrx
19679	payment	2134	2134	1874	1	1	51	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEW78pDwyrEVdbjqAenBQMS7GnaRJeRzjyPaPWXwPCaRapoa4
19680	payment	2134	2134	1874	1	1	52	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKXAk2UYpQi1fbAbmeDs1kS6dYgf6zrqdyBg6gJbTibDRhNCY
19681	payment	2134	2134	1874	1	1	53	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEASx7twzt75CH5cdXNGn6rFna8rt6Q5Zzb18UL3DozXBvwhmT
19688	payment	1397	1397	1678	1	1	8909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcerkMEK4BErYW583rN7tQYP6r3DNmhaTqxNCZRb2i3Nzirh2Y
19689	payment	2134	2134	1874	1	1	56	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMStamm1AVepgzDaHmRW4Efc5Lee6G3UqqtccaCQkcREzdCrYA
19690	payment	2133	2133	1874	1	1	83	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6Qc2WbAsmkDEj5QycAHrmDkNK6aLAyodkbsdmq3SqzKz5QMS
19716	payment	1397	1397	1678	1	1	8917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuS1nohEQrFrrHdQp9ZZCUAb1CugfRHN4XRjAXKURErbDT4TD
19717	payment	2134	2134	1874	1	1	64	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdnR16pFTWqwtKrMjzMr3zwdPPbbJHsFMfWZbG7ZpCPDuxGm6
19718	payment	2133	2133	1874	1	1	91	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBH2ZrmqJkxLbpfk9voFdWb5GQT7w6KaAsTWZYW9hKfRGTGC9i
19722	payment	1397	1397	1678	1	1	8919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQEbRHBQQ9Vx1iLb3StLA5QDsVWbm6Z6DqohKNr9a8hQA5J48
19723	payment	1397	1397	1678	1	1	8920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sDPV7c3r3zHkB7dLXYEmti5a6EMSy9mJK7bSMXiAGLCgARkX
19724	payment	1397	1397	1678	1	1	8921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiCM83Dm3J2xGwAxMgzrDTtTYDZHvetZRRpMgrHfdR6EW9dBt
19725	payment	2132	2132	1874	1	1	23	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMtkMqXjj4SbK7r3QfsPXHVuAD14mZuZ6EHMpYaoHNWzUgNVu
19726	payment	129	129	2136	1	1	1	444000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfphVu4KaooarEJL8jSkQoCrcVFN3JFJ1xgvXJYz7CmsAzvrHP
19727	payment	2134	2134	1874	1	1	66	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtNkxnU9G3YsCgMhru7SyMoiXxcSJuugzejfUqn5CUqQuyuHS
19728	payment	2133	2133	1874	1	1	93	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW3b96rqZCm5b1q56635o863RW87Lr3oJ3rmv71JqnNfYBpGt
19729	payment	2133	2133	1874	1	1	94	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gHs9w9LZDUA2kmXwB66SbdPLUNC2muQMowSLQwy8bWz1Uthb
19730	payment	2133	2133	1874	1	1	95	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLYiXuGjVVW3Xnxj177E1ijRyd9EMyg9NkNtHMUvtYBJkso2B
19731	payment	2134	2134	1874	1	1	67	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9quUaBfToThprzrUWpsj3CMrK2ea6L5CfaHTtK6a1yyBCZtjW
19732	payment	2134	2134	1874	1	1	68	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUA9pv4K3iFVmTbyauzYizR6qVSk6iFo89TegLT79Fykj9mx3N
19733	payment	365	365	2137	1	1	0	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxDAziwqMsjjfo2HT3NrBmtt1LVuyEpCbhNzCphYgaWQydqSP
19734	payment	1397	1397	1678	1	1	8922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdbJgvaJoFEqdSq27SrDYdcZTEomwgkQBzDLHjmGkonLC68Hb
19735	payment	2134	2134	1874	1	1	69	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaJpF3frw65ugx4uwMqqV6ev7z2E4zMdAH7t2dF4XmScgWXiY
19771	payment	1397	1397	1678	1	1	8933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LbizW47aWf4grHcGcsnoeuxQGnKmibvci26AYSMg3GdmQDwR
19772	payment	1397	1397	1678	1	1	8934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLvgESTQAqasbKh169J5HhKVowee3yFRWPQgBJNyHCKN2YAzH
19773	payment	2132	2132	1874	1	1	27	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfox1btEKPEhnCa5Sewa9zf9SYvDzedBxsR715765eveZfVdj
19774	payment	2134	2134	1874	1	1	80	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8KsKz7tbgfcKzGkoEJZkueU1r2kw53KjqcHhdirSHLtk8o5i
19775	payment	2134	2134	1874	1	1	81	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VFnpBq9qsRWjNMjJLXQKAHUfwcyBusW3rFNRzgswxRcT4XRc
19776	payment	2133	2133	1874	1	1	106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cauehu1yCHJSeWsWWrNvH6fdgmHnvjYnTJ4LXLPHNEnGt81v
19777	payment	2133	2133	1874	1	1	107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmuUZSEGLt7tGuxeLZJzAhwQN2UGX6qWxW4UvYQfMRXgqQEHk
19786	payment	1397	1397	1678	1	1	8937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWGyBrLXZQYUaUgVEcY4CUY85Ro2eG63ooKjFDLZ7X5QKJcLi
19787	payment	1397	1397	1678	1	1	8938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HdctW14q84MUHWem7ketadrpNAkyyUuQ5gLuhTjvr7R5nJZE
19788	payment	2134	2134	1874	1	1	84	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipHRVcYHrD2dTX8uvLMBPSwghYyArAfQbM7B4LTL4YoSoEVG7
19789	payment	2134	2134	1874	1	1	85	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfAYQr6gYHSaRN7bhPJBjG4aVYvjYpN1KbeJLGDT5WzVe3KpS
19790	payment	2133	2133	1874	1	1	111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7RhTfvpmkrn4GrJh1rEJyo6ctvgUoFQNboNfGSMHPj84CwNe
19810	payment	1397	1397	1678	1	1	8945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVAjUNWAAeiRN3bTjh9jb4iRTWSyDDuc6QuYG1CvirBvSy5Xj
19811	payment	2134	2134	1874	1	1	91	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRAV6tLPvxJSj9oPMg6JNjT3vUZJjGAJa8YupyXh4birUzt5L
19739	payment	2133	2133	1874	1	1	96	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkr6maS6Cby2gBQjxGL7gq9iUKQFtZuNRYdYZMHCoLxooJCwk
19740	payment	2134	2134	1874	1	1	71	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcrJ6Lj9r6GGQPYyRoT5VsPeTE2hdiGKZbhfRAS1zMYXqx9Ln
19741	payment	2133	2133	1874	1	1	97	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXya8vr325w4T6ABhj68GBtRDowLaQKR5gej78BPwqmN7DvZt
19742	payment	2132	2132	1874	1	1	24	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p5ANjtTCwFNPktezcZX7Dp8qkc7S78c3x3uj88YBBjSFUNfD
19750	payment	1474	1474	688	1	1	13	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbmwuZCz5wJ5z2CPTdUVnJa3euMDcvdo4uGATqnq6iAq1S5mk
19757	delegation	688	688	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLJQ8AK3MVze7VbzsoQXWagLjTnSLqLnyGYbT2AvBJVAT3qLL
19758	payment	1397	1397	1678	1	1	8929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZa9KKutSimkeCt1cN5M7gVAnSUkFu4ge3xEUTVy3wXazGUqB
19759	payment	1397	1397	1678	1	1	8930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7LG5Ft8Z4FxgrehVo67Mk9JnTYE1nSZoHnY7vY6yAFxxDnS7
19760	payment	1397	1397	1678	1	1	8931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcsfbBatkwdSbXsBLUPtzo1Cw4KykPvzcAS8VH6XyTDXngzBN
19761	payment	1397	1397	1678	1	1	8932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EH2FAEH1uMdAhSBuzXTLez3XYdaLYwUvSPJNYyNpBpRLRgHN
19762	payment	2132	2132	1874	1	1	26	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8A8boZ7Gq7YDdPJwGrMWktGh7mwEC36Xnm9AW2YDB3Vpr4Jxi
19763	payment	2134	2134	1874	1	1	76	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEUeB9Dj8hcd7CMkStDTyrBJxJnwRSdZSiRp1YoLgmchSxQLx
19764	payment	2133	2133	1874	1	1	102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoc3LcVspLjMjiBg6B8TpqUoHMUZL9MJN57nqZG9iMbkP9zFgE
19765	payment	2133	2133	1874	1	1	103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3RwAisJ8utaY4T2zxXQfYtbp8fahSaJpj5bsweEyyNw4uJN8
19766	payment	2133	2133	1874	1	1	104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixq7VgxK3KbaSvj6ddEqyWAk6hUeADKHGUYJQwru8Kix2v7dv
19767	payment	2133	2133	1874	1	1	105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8NHTu4hS3QqFAdfvFRPtXECYYZn6C5KvwM3JpPvGM2LqHspT
19768	payment	2134	2134	1874	1	1	77	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzMD48sq7Sk2vPgCV5LoKe42okUPVYXNe2mGu9p45ZBw5gReH
19769	payment	2134	2134	1874	1	1	78	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7QQtDD3J2Uw7Zonyn5n7iPS1mg8kWzGH1KqpevY7iAFoqVj4
19770	payment	2134	2134	1874	1	1	79	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDZC52u5Bs4Z4SXokw7GCLE2BSyjnxGLhpi1iqAHmLTq9LLhJ
19785	payment	2133	2133	1874	1	1	110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TvyTafgjtjWbiA4miJsP4LnYJTdVnskCYagSqXK3uvHMPhmP
19798	payment	1397	1397	1678	1	1	8941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5oL3KBmnKB8wB1KQNhsjcEUubBPykFmS1CosG9UX6Gw4NUkS
19799	payment	1397	1397	1678	1	1	8942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vJwHYqYJZbAey6aXx6k5NX6gYrhA5aEsutkMn9VyVhWJi77M
19800	payment	1397	1397	1678	1	1	8943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSo99DMhR3PhqxEDNNSxcCDHFD4LwnxNZzbTLmVo3ACBsR59TR
19801	payment	2133	2133	1874	1	1	114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1qx9xEPL2FkGbCzBtwPzbGh2gteoBJ2vAMeMTbGYUA2Vgtud
19802	payment	2132	2132	1874	1	1	30	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2iXABa7j7pxRx5pDaQGoVMeRzv8x8YS3dnW71xiEmS7M142M
19803	payment	2134	2134	1874	1	1	88	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnkdf4AkQ9qCWfXxgMWZxpncMDnydpDHCWVeafrZi8KGWCnjq5
19804	payment	2134	2134	1874	1	1	89	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk2PsiUPpfgnqtZAjKjULqwnMGLxo9yrhfHbkzVoYuLiCeaif
19805	payment	2133	2133	1874	1	1	115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVQLxUe4xE163fBTPbDpxxCDo1nNHiHCBqbowXww8bZXtP5BP
19806	payment	2133	2133	1874	1	1	116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vaPZX3mCpTrW53w6NBpoNtgYR518b1QTNRiHQm1NkXCeSsSi
19817	delegation	1697	1697	1504	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsT4F9Ch3e3NuFfWQnLumsZjHgJbJAYLYBdw6GYEmNgxKFwPR
19818	payment	1397	1397	1678	1	1	8947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9Ns8VpwKra1D2eeM6B4NnbrsCPcimM2SR1vGAD8jgKYLQPu1
19819	payment	1397	1397	1678	1	1	8948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Vo5P7zRoHdfnMBQswqTXGfEHsWUozRZqvQ9Un5yRdZJjHCgK
19820	payment	2133	2133	1874	1	1	120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpN9ogYH6sAaTDWAi5GdGDrE4a5q2qcRJajnqVzD9QWu696xi5
19821	payment	2133	2133	1874	1	1	121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8gV6gxu48gaypgiMZtWTNBMb7DRM1gCSJn81bfP8zrD3gAXt
19822	payment	2134	2134	1874	1	1	93	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8DtUXpKdWQFVMNSJDwPwQGNj58ueSwHAoRvwVCRtWPEEksYW
19823	payment	2134	2134	1874	1	1	94	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvM8nf2aKK1QqUXUF51sMJnKXLXzvJ4rDqBhhgBtJk9TwEY8Aj
19832	payment	1397	1397	1678	1	1	8951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCTUVaiyCEA2fBq1KuchTzZNyT7fDGZ8ZMdxAcHQG2G3hdAbo
19833	payment	2134	2134	1874	1	1	97	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDmstef7EdrvqjvWzJTuURvAwNn67ancxyygs15RZW7k94J8t
19749	payment	2132	2132	1874	1	1	25	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1suqGEzenbVmpADL87bUH91wfaDxpsbCYmXzjVSzm5MPopiD
19813	payment	1397	1397	1678	1	1	8946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXo9Ccy7eKKxuwMeXUNc3aKqYbAnkJqVqrRQRWULG9mtp9nVG8
19814	payment	2132	2132	1874	1	1	31	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fKRTfU2VpKpq2uoSnhQGhQtNy3RRstPRa9u1ArrzdTgQnrFg
19815	payment	2134	2134	1874	1	1	92	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyefe9diFJMRpxVRSDGiSydEMY5mZaxmCJqZiDCKZBjiML8oi5
19816	payment	2133	2133	1874	1	1	119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGK8C4EyofKWSDnHGo9rmRNVUGwnahHJWhpMvrmyFb45pRtHsn
19827	payment	1397	1397	1678	1	1	8950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPAUQ22S4u8hWp4Pf67nRFRUZnd3FNVd59QujsrqV3gGwCdva
19828	payment	1504	1504	1697	1	1	7	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5quiQ7SjQmfbakwKPCqF53m8BY7Cs84dcyX6iZKxisW44z7Kz
19829	payment	2133	2133	1874	1	1	123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ619c52PTvheeCk5ipeQDo76XmVDmMKgMNyXRajysTb7j27JLZ
19830	payment	2132	2132	1874	1	1	32	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxqLretJum7MQUfkCSdK32hBHXFqV8CtNvvizyFdygnPTjQ7G
19831	payment	2134	2134	1874	1	1	96	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtd1kNZxBLf73YAuWQr3FiUBtNLMNLmoeREfv9ynQtFzk59kYT
19853	payment	1397	1397	1678	1	1	8957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUaA62RjyVh6g6QeR9G2zzcdaRmmpfP9p6kodPb2EaVRi8xp3
19854	payment	2134	2134	1874	1	1	103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjLrMUevsmzapGFZ2qEVmaj3H2msZ1vPrgZP8qwDLsc2cduH2
19855	payment	2133	2133	1874	1	1	130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgC3SHRRNLyj34iGTZZrisikvQMxNUo1FGtMZoiDFYSZN6mRy
19856	payment	1397	1397	1678	1	1	8958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5b9i4XkncEkJW4kjMPx499EDkng7euqCHRh8sWpuc7yHeoTSv
19866	payment	1397	1397	1678	1	1	8961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnirDsf55qBverjWCW6rtiAenQZBEU5H9Xdq3zpuEXBEAGnhoU
19867	payment	1397	1397	1678	1	1	8962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB6NoZpMxjYXvnvE9psUnnbDwtV1SHGKqdMk6jgav3taA6xCp
19868	payment	2134	2134	1874	1	1	107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVEVMeqmirQT5Bu2iYQg1Q77ZKZ8T43bJeZashkPRU9MSxLid
19869	payment	2134	2134	1874	1	1	108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWrAGpMyve8tdzdGKwsQ8etUzovS5cBXS8KhwFnGmVJEbzfY9
19870	payment	2133	2133	1874	1	1	134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXK6baPKEEktZuLHzscAcAUpXnu9feUmznuE6LHadxmtbVhYD
19871	payment	2133	2133	1874	1	1	135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HYwcH1PDgJSPpjMj52CXrVf3YAqhWYQb8b9bsA6TmuC2o3Qn
19892	payment	1397	1397	1678	1	1	8969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzV83h8PcwaLPRx114SCsapZH7WHLhxcWEj8kiNy8ome7HZH8z
19893	payment	2133	2133	1874	1	1	142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUBHsuSLd2REeH5zWiDcJgqSxPbMu3wyCs2b9kbyXZmnFirgG
19894	payment	2134	2134	1874	1	1	115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaR3oCYFUvriUswYku2okdBXMjFQWuLxKU8LfAXE5fBsaTfy1p
19909	payment	1397	1397	1678	1	1	8974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FabXYYwAQCdzPPDD9yF2r7jAUJHPgiYVVZ3pofaAGK2WD8W8
19910	payment	1397	1397	1678	1	1	8975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonpwJjSmUaH8zffHKdXzzMsZumDndJkPvkU8WoBN8cZFPKf4z
19911	payment	1397	1397	1678	1	1	8976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSYm2PYPhhy21SxQF2gtVJRtfnDLa8ZTV7iZNKzdUPsv3khDc
19912	payment	1397	1397	1678	1	1	8977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA3SDyvgDSNLyffVenXjyCTV6Nmrfb1Xeg4qAE89mkTBuqBXd
19913	payment	1397	1397	1678	1	1	8978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo6dKyc3QUbCr4PkojE5gfv9bH66JHbCfEohesdcccRcSQAUs
19914	payment	2132	2132	1874	1	1	40	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsDyr1E4V4SbD9KYujeA2xKfsPdZ5pwjesUovL861H5Xe5xvf
19915	payment	2134	2134	1874	1	1	120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyASnfPtdkxeMVvxWnvgYFhw5HL5cHRAmURG64ncqCJYXr874
19916	payment	2133	2133	1874	1	1	147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMbDZwdY95ss1UvxENKcTx5ToPx8xDZe2vT6QBC5GPbBRpE2c
19917	payment	2133	2133	1874	1	1	148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhomT9f7voquHrFsGfNFfBnXqRQSqUphtZemGCMhW3VT1Sqgvf
19918	payment	2133	2133	1874	1	1	149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJWe4i1fymJDm1LLTdyJpp83eLzA2tXVbaoPDhcY8TUGpRmTZ
19919	payment	2133	2133	1874	1	1	150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZi5apgqJQhysFiiYQHKazbR6PmdKxr2YyoRqmCm9XVcGi9F3W
19920	payment	2133	2133	1874	1	1	151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXQKUW1sFxsgyUr5RfB2FTdoFcdr91Y467YWz4SUSSLAyv5yp
19921	payment	2134	2134	1874	1	1	121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVNCQwQPyPygZtU4CLwG4SqDvMM9x9Gmr5eUGEbVMgewRaVCY
19922	payment	2134	2134	1874	1	1	122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF9HZJLXbuDqzpLFs98MihEGQTyftVg3Uqcmsu73bMshQ3esA
19923	payment	2134	2134	1874	1	1	123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57K4jVhD4eyAT456368d2WvKe7hhP1E4S3EQkVcH7uuFfgnGk
19752	payment	1397	1397	1678	1	1	8928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBqigBwufJVRW65e2bCzKfiUo6ihuTvbP4aNjTGYh2YhQt7iP
19753	payment	2133	2133	1874	1	1	100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwBrFeBEGwLnPHGDxovhBrqU96siPABb9MhL6mvkdgmcUvEdn
19754	payment	2133	2133	1874	1	1	101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiQskk9Xi6yyNkMXcyiy8wTzPm6bnC1MwkHURVfGMsbxzwfCV
19755	payment	2134	2134	1874	1	1	74	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAwftkubqFBpKb9ao7r9QjsU6ga1JMiA9ytf7cLtME78Zv5HB
19756	payment	2134	2134	1874	1	1	75	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Cyq4t8gzbF6a5ni8yK3ys3bqYZSJiUqDSfSFn1MMZrASTcKt
19778	payment	1397	1397	1678	1	1	8935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhCh1SzdoRp39tBoCnVWbDgvmfrpyAwP2HCUNHhbXRqXFNDuK
19779	payment	1397	1397	1678	1	1	8936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeH1P715N6DKhys12iYaDjUQWCmyuF1K1vHwBE38jVirrqQWRc
19780	payment	2134	2134	1874	1	1	82	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZudv3dCKM4dhdHVECwTQWpiikFY5NcHCKxBo9PQXU1sBNwBp
19781	payment	2134	2134	1874	1	1	83	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdME9PZsVunEnqcnAxskjzUKztSUvUgfNAqbCWbqYuYqRE2qtb
19782	payment	2132	2132	1874	1	1	28	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KpVcrgZ6EGaozGpFgPf1Bg3juizwwB8trs2HmtEMNddWt2ja
19783	payment	2133	2133	1874	1	1	108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxmjCWSEefhu25V8miHPbftFP4RfmUP3GJUVChPsdwf5YCGgE
19784	payment	2133	2133	1874	1	1	109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyXKCBpmSyX1Y6wQvJYQLHg27xz2AMxqNnjoGRcxbLn2SCfog
19791	payment	1397	1397	1678	1	1	8939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6hefC5eDroF7WwjLnNBNVwc9cxesRkzMbjEhxJhSJfRK4mzU
19792	payment	2134	2134	1874	1	1	86	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUEbrMpMZ6xaxvX7iyzYyjWGr1885B5vTTocpyER1nUekE6nB
19793	payment	2133	2133	1874	1	1	112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukmtKfoVY7nUnuSDV2nouaSMmuZ7rcJfE1dEVaKwe3Sb4v8QC
19794	payment	1397	1397	1678	1	1	8940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsDpHSLSsVr1UrcCtgHAiS6EDWKEyvL6pVyaargeYQrTmKQNM
19795	payment	2134	2134	1874	1	1	87	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfyK5JuiDpmoKASbQKCGoj5bQb2YCzJdDgukXcdTtBhCZeHCE
19796	payment	2133	2133	1874	1	1	113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKntKjKahFYHPDzXxa5AnR9vQLB88xZWcrjz5dqfEcTS7WfSxt
19797	payment	2132	2132	1874	1	1	29	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH996tZC3ut26c9gKvShsoUF3piriin2cj2qLRDW6vfEdNsr9r
19807	payment	1397	1397	1678	1	1	8944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvYCZxd5Hj8P4g2k8cxM7WuYMxZTu8HuaMFHgYo8nwvM6qwKT
19808	payment	2133	2133	1874	1	1	117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKJUfSDuaMHiA76KNfpgVLBPinWtxpczatMcbTQFbYiCy9w2n
19809	payment	2134	2134	1874	1	1	90	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURGeigFyZQ8Awv71uZ37ynMMGwc5jNLH2kie83DKcaaGZc7iZ
19848	payment	2133	2133	1874	1	1	125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GXJ59SFzCigoZ65myp1AWrPwYw8WDyZdBpz17gUsqunxC9Bb
19849	payment	2133	2133	1874	1	1	126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59NgRaZEd1kHLxFK7XQoBCugJMHVxpprqkeAiU4jx4a4oRxdw
19850	payment	2133	2133	1874	1	1	127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT8LRRAzBv51EtkUymBRG4yds9dRTV5feb7xSteGFpY6cREED
19851	payment	2133	2133	1874	1	1	128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQap66J6XZytq2jGNJTypggdmu8Jio9WZnBVv1ytyhDm2kN1dy
19852	payment	2133	2133	1874	1	1	129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZvFk5enWP2mbxfEZiq7KcsEDEhtdYtAJCbupbx7euocWcZBC
19859	payment	1397	1397	1678	1	1	8959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnz68tU9yj1ebpAjC8Fdq3bwpjNf4TF6QryQjEoPXtXoFxq6Ef
19860	payment	2134	2134	1874	1	1	105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjRb1mJVriz7i6Z1tNoVdz2edUyJUo5FcNU8FXLak3TwMvxuY
19861	payment	2133	2133	1874	1	1	132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41Nh2k6gogtJCYMoVFJuVCEFzNpMuzm8KDcyTCsDvut3zZY9U
19862	payment	1397	1397	1678	1	1	8960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtWunG5Tx2YVvyU3TBqShKUCN7zHpAXunPwx6w7DWRMYwZK34
19863	payment	2134	2134	1874	1	1	106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp29wbvi2Ldd5Vr1Tt978ELX57CsYXMd5AZhET7K6RvJSnQJq3
19864	payment	2132	2132	1874	1	1	35	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ag5SKvviMehptET2utqAmN8PiUyqU4EY7oHzdS1VPwEscwKp
19865	payment	2133	2133	1874	1	1	133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAqKeLJUf5cyR3NVKgbjxDL4RDZ9NsFMTvcDBKeSK5a22bCet
19882	payment	1397	1397	1678	1	1	8966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciuS5zKVkC3ZfqSSDuNfc9138WWppGkon6VPrWCHt8YJhhdVq
19883	payment	1397	1397	1678	1	1	8967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfiM9iRcTtUGP99YNK54xaTkiE1cR8wvgDFce8vrPRSJ56GD8
19884	payment	2132	2132	1874	1	1	37	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHNvNyEfQFEq4nKtFDVCPimvkFMCaUrKi5BCs3UfTB6LFzGbA
19885	payment	2134	2134	1874	1	1	112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NCBb2vRXfjaPSMUYc2TncbNTG5Q7rvEautDeM7pw5rqAv4bA
19812	payment	2133	2133	1874	1	1	118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Qa4U3QjyNeEwt25k5Uv5pXujwSZs7xXMbzLPvjDsmZjbBBja
19824	payment	1397	1397	1678	1	1	8949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgufYX9ScPFi1PsezAwfYLNxWXT2u7CNzi5w72mpBRAdeoBhC1
19825	payment	2133	2133	1874	1	1	122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLBWUmuU6zx5xiqAnHXcDtKDidWGoVWA4PNYadPY1SXxQp3px
19826	payment	2134	2134	1874	1	1	95	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNneZKsUiN5JFjnFUCrxZDkHmaRDBE1jFSfVUMasdHnEFQiKYv
19857	payment	2133	2133	1874	1	1	131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrZpRLujKSXLevPP7t1f5sK7ckPrWsbhBpJ4zVfdUJWjQiJ1D
19858	payment	2134	2134	1874	1	1	104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnVDdZUfAFDcji1NXp8saxyoeqnFAAQyykqJhCCkPXDbHMd4r
19876	payment	1397	1397	1678	1	1	8964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRW2w9q13G8m5hJnutaKPSXTgm4may3dT2ZhXx8gw6fnxKBcb
19877	payment	1397	1397	1678	1	1	8965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf2TihMnwtcJacWjDpfUkNSzY9SNuSubgWX6A5MBu9oZD4gpk
19878	payment	2133	2133	1874	1	1	137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUB2GqUXh7GvNEcg9uHzDKZpskZJmsiMpyq4VuFtqWhCjCYVb
19879	payment	2133	2133	1874	1	1	138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBLptQNifPJnoNoyEcGYRnF7JBwvEKYYzBpBv5sc7RSKP6G5Z
19880	payment	2134	2134	1874	1	1	110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWQUNhXhvSjX9n6HSHVkdytUbWYq7C1RhQW4qLdtF5ZUwnDs6
19881	payment	2134	2134	1874	1	1	111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoPvo3SXwaKpjpDD86t7aJ5eP5LsEubM5rxWFqA1K1SoVSg19
19895	payment	1397	1397	1678	1	1	8970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgkgfmokiYUQaHgwcajpWfBpDcFTMGTMnYCi2Ks1pEcQR2pSp
19896	payment	2133	2133	1874	1	1	143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRFwzpVSXtWU8treFwozybvkC85PrBjxtCypypgRaAmaV1LU2
19897	payment	2132	2132	1874	1	1	38	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6mmyKmkDf37jthb4ehPa9cRHocMBaAkBVh7VPopTCMYKQjCi
19898	payment	2134	2134	1874	1	1	116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fDyprhZuFvqps6ko6kT243WmACUUhUiChCr9USoxwTfJV5Cb
19899	payment	1397	1397	1678	1	1	8971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3rzcnAKekEM8va68NUN8aHEhMTNoruXmSyBqWkoNyGiyiK7c
19900	payment	1397	1397	1678	1	1	8972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuL1NpRyzqNqrsyiunpUquHJbaXrLrH6kaw9xsGRwjm2ZjF73D
19901	payment	2133	2133	1874	1	1	144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bhTLhgJQ6RK51uxZMhunjwKRocfwjn6jPXbagRF6VjwiYc4u
19902	payment	2133	2133	1874	1	1	145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4VWqbnaorSgEnbg9XsnaUrL4rCMjQ7dyk3YWfwSyr5heQ82K
19903	payment	2134	2134	1874	1	1	117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiWG1cxgjED7GF72WsmLw8bKRdSe6UFEC7P5wqtYmBvQUU9FQ
19904	payment	2134	2134	1874	1	1	118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJTMx6tgXvtGrMMaaMKus5QDHT3WSpCp33G5X8taxSiq3C9b1
19931	payment	1397	1397	1678	1	1	8981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6PVd79gsiwjFKpNtbdbZAuNNWcm7ZdFATA1Pf2rpCKffHHEg
19932	payment	2133	2133	1874	1	1	153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7CBkSneQnLYKtw4EfjHPETBTGNwEq5FrTFrdSyGGt3t2kdn5
19933	payment	2134	2134	1874	1	1	127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAZoLEhedkBXWk68xoJLfHPyWazhtwgzQ1DE3dEqDYJ9ds3sz
19945	payment	1397	1397	1678	1	1	8985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbn5m7ULwLooyvvPsKicqgMMFMzUKqxuKZsCei35bxGVZ8w64
19946	payment	1677	1677	1395	1	1	1	122852906474000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYmkxtr5vLkYTGoCjKuCWuV9VeabaeNhTftTRthTjHEFBGQHNUj
19947	payment	2133	2133	1874	1	1	157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MHRgT6bzyizZrbCZ9asobFjZoxmTJbRKzgZ2DD7eo3jdzenF
19948	payment	2134	2134	1874	1	1	131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee9YPAkV4XTUNr12ZjJRVUbyJxHDNGemtF5NvjaU5P7qQESes
19953	payment	1397	1397	1678	1	1	8987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK22qq9zpwimpyQVtYocNXPrHvNt3uuMsF9vmStt3ARTCbf8tk
19954	payment	2133	2133	1874	1	1	159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpYjDvSkVfzeSx9RExjGqaKLEQ8Qftv6Q3zhxibgNhKNZE28Z
19955	payment	2134	2134	1874	1	1	133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi85Htt5FRVT2ZF5JaddL2gVTm98WoRqKJyWxsqsfJApJ9M4f9
20036	payment	1397	1397	1678	1	1	9002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYBJ9XpGVot8hNSpzSQLyn9JVsVNadRJ85ygRtfDHv3PfCwox
20037	payment	1679	1679	879	1	1	38	297667693000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGRUE9fi2X4hqZoB3Kvo9LTikqYzuJJV2GhBQVKseHvcpieTLe
20038	payment	1679	1679	881	1	1	39	1289893338000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaBN9cCa3W7NiT3RXBXrDPSVYGQDzQRYqaGnVsFr6qk7xnXGr86
20039	payment	1679	1679	883	1	1	40	198445129000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ7aHoJjGGxT4kPmhNEQQ5Lj8idLdQWLqssC6EGkRQvccieheN5
20040	payment	2132	2132	1874	1	1	48	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLMdmfPWmYTt22YhdV49hpmiEwrzePadvDxRCkJGiTjA89KP8
20041	payment	2133	2133	1874	1	1	175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJutcwuNkdi6zACosPvviFw6qRW9ueNHsBKwt7dZY2vZsNmvp
19834	payment	2133	2133	1874	1	1	124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWaSmJtpZ18Ph1QfHkammasBaJuRLJiksNu8NQNBE7Us8YpJV
19835	payment	1397	1397	1678	1	1	8952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYf3yGFsejZ6suCJv2yhs72SuaMjdfJFeMP58rsMVbHihypG4
19836	payment	1397	1397	1678	1	1	8953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkzLaoCq7ceJXxe3MR9TBiA8FNw1Y3HF4a2fVW9PbLDNpnAJ7
19837	payment	1397	1397	1678	1	1	8954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBPWoUiNy9d38TDrspWKVDwK4na1KDFhHKHxdFFd1acksQyHV
19838	payment	1397	1397	1678	1	1	8955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZJpmYPDmBLnaRkT91AXjW48D2DR1uvzivQAxf6jHrT8b3gvZ
19839	payment	2132	2132	1874	1	1	33	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvdphLjNDYJRPW9e74bM5UJeseQFax3FGuuZdfvhSUd6g9WnD
19840	payment	1504	1504	1697	1	1	8	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsKTjnXGzyQHiRskyRTnTMkJWzWEC4FYonBpa2XmDHmmFoeHB
19841	payment	2134	2134	1874	1	1	98	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZ1s8NrsTvUYx9z77qYjdWZfkJjwr2aCzgPnbQgSPTXfo56WS
19842	payment	2134	2134	1874	1	1	99	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U2kdaTKfaceARX5mQRewsx5Zs2ZCdk6FxkEjpMqWDpeZDAYk
19843	payment	2134	2134	1874	1	1	100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtShdWZCmeCTpG6yTmJHjLWcgTWKpBgEcPHcLhAShQYocQ5f2
19844	payment	2134	2134	1874	1	1	101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKv5N6XWuAJS1S923ceWubd4bxWAJJ2MVa6wUtLM1sAvXV1xhF
19845	payment	1397	1397	1678	1	1	8956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLza8CyZkiV1nZUU2hjvqACTEZ4wGM36djQdQjiJc31DkUM5GK
19846	payment	2134	2134	1874	1	1	102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQwtsqDpnWr428Ardi7CpG2CyTSg2EQc4by5wjotf5iJuMWRv
19847	payment	2132	2132	1874	1	1	34	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YB63BihcYimSKUMoF7bdjdnECTEVSGmHMRjedEuFVQMtE8YP
19872	payment	1397	1397	1678	1	1	8963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhDmUHnPRfQGnyVymh9R847vCQun6jig6r9s66Ej67BEGYB4J
19873	payment	2133	2133	1874	1	1	136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQi2jZZq8zCTRg24EYqRiehdg5WXjkn6FmnZjhnuCesomQ1gGZ
19874	payment	2132	2132	1874	1	1	36	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34HPfEoj98nBDwPWWsitTRSamNPY86M8RsonivxLx5TjZnXRb
19875	payment	2134	2134	1874	1	1	109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxvQMvozqNrmoeoyyvgPETsfUZPDkwNaWYCt7s59BVPsQnA9V
19925	payment	1397	1397	1678	1	1	8979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyS2KcLkxunKuWbuixLUEjjnrhNi7h13xixkbodVDfn1WeD9z
19926	payment	2134	2134	1874	1	1	125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRabk2uCB9rR9RhyDYetY3F9oTwADtm3tWzCxHxa11dntGiAi
19927	payment	2133	2133	1874	1	1	152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdeqZEsJefh3KT39mzZehwpgFah4giCd522miYY6hyQZqMAvM
19928	payment	1397	1397	1678	1	1	8980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGcEvDTKidgJ9rS2gzqWhpFmbDVcH3vm6ANpq65r4FFmDn2xc
19929	payment	2132	2132	1874	1	1	41	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsScN4KLMRfNZxUtm2Hi3X4gTYDkczan8LZYM8YRqYU9hf4hK
19930	payment	2134	2134	1874	1	1	126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRrFxqz5L2pR72mRGUC7qgzMBANQbGit3Mqohv8cvFSqKjEeR
19937	payment	1397	1397	1678	1	1	8983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCX7sKPwuqSCRsxV4YgyVubRf4ASt8aiivRSb4yZRAhym5ftT
19938	payment	2132	2132	1874	1	1	42	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfzzTCheZJBZ27QZfkA7e4Eq6FCFheHz32Xb45crk3jMSbby9
19939	payment	2133	2133	1874	1	1	155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtaf223b61C17dbrTrj7zTdA8RTv2JpAdyY9Ccb2Yuei7WqKn
19940	payment	2134	2134	1874	1	1	128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKND8sYaez6NGhQH12kcuF7xpR6FjnWPEeGAWQBz9tKyiCWMpt
19941	payment	2134	2134	1874	1	1	129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRQyP7kNTcfzVGmTGcwmZQoMbM9BrHApcedw9KhFbn8Jhtakx
19952	payment	2134	2134	1874	1	1	132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFUocX19CB1n32WXQkgi5gAJB13o3HpeKk9Vb7z4LTr6XFGN5
19967	payment	2134	2134	1874	1	1	134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMpSmKHwUcX3Gh49gLEsjQnyAgsBiXG9WF1Rw7mNCg25DUAHh
19968	payment	2134	2134	1874	1	1	135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S7eLp4dehUQ9tAG6y3LF929p397xc7x2X6Td8EdXyiA1D81p
19969	payment	2134	2134	1874	1	1	136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLC8YA5ScRiWu5oX9PeZiEJvyn4dVDc8DgMtKsN5LwX4VEqz
19989	payment	1688	1688	802	1	1	31	384231596000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfJVrwHjDcMCtzDR4S9oxhf2MJjg279cSbHRimGGKvCcoVQb2L
19990	payment	1688	1688	811	1	1	32	270329721000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa8ZzoPg7Y28hK5zsa8hXriDJZC5wzXxjKjXewTRUgjLaufoyu1
19991	payment	1397	1397	1678	1	1	8994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjrJoKv91hw9LVXqgGKNDR6kQdQrHTH91RUPAJZDvwJEurESL
19992	payment	2134	2134	1874	1	1	140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4vc9D6hpbayxSjHiyKfdCjPAo8N9J54psj366he61TAwfoYL
19993	payment	2133	2133	1874	1	1	166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8N8dabDJFruA75qwWb31Dz34hUoFDDLHuJ15FxqTLTCqWFTi
19886	payment	2134	2134	1874	1	1	113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdmMTAFMGfg2HRPqhKYKDmNMGX1j4Yy2KcEfgXUAXpxnznqWw
19887	payment	1397	1397	1678	1	1	8968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAkbG7YnMV2rj8S5LZ3Ld1SBK1Rqbto4mcmehUgK3ko3Dn1fa
19888	payment	2133	2133	1874	1	1	139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6ZGquf1ahZPEU6Zm3bFKrvJVNixMcYZ4vVh7XL9i2epWUMwf
19889	payment	2133	2133	1874	1	1	140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS54DrTrkNFQmyjjCbjHfmyjKS3PNXDCSVYRtdCAVU6UD6fMZm
19890	payment	2134	2134	1874	1	1	114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTajHy6y2u7EriWg511BmiELNvX5sgWC1aTEHgqw4CvDVkCFA
19891	payment	2133	2133	1874	1	1	141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Xf9xqhbn4vT2GFLk1oUix8vC698zfxWxZXFYobhUC1u1HU7
19905	payment	1397	1397	1678	1	1	8973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ89UcekZivcofyXPqz9aXzQnnMHF2NzByuAA9jcD8QpdGx3Yi
19906	payment	2134	2134	1874	1	1	119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9DwmTRq4FFiJfACVpQEjuoTp5sN7tqZTFaYJ2nQwoiHLNthi
19907	payment	2133	2133	1874	1	1	146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzvmwNKoLVTQHhbubiEh4XzrXTaZ3CE43LMekQG2D7NUZktLp
19908	payment	2132	2132	1874	1	1	39	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JuE2N81zv6RpNcRohVvQd6gvskWPjzp5puEH7bzZ1FzQNyRc
19942	payment	1397	1397	1678	1	1	8984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgx8acvoTiqXkp8ZsxhtqNcc2iw3h5nGKGnS9qwv68PzMFe52r
19943	payment	2133	2133	1874	1	1	156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4ib6ftBjY2518K77FPNN2P5dTHJctzEx7yboET1AiEqRmUp3
19970	payment	1397	1397	1678	1	1	8991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNjb2py8ejRSqAdMCNxvE1npXDdH479qQBriuLc32k3yd76ZW
19971	payment	1397	1397	1678	1	1	8992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohehcmWa5JxRLhpLnd99aasgiRbjKwXVrSQhGd2RNYguWzt7p
19972	payment	1397	1397	1678	1	1	8993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s5AC74HFSTLBmbTC5Fb5HRKLrsAqUo6Gw1vFHT4FYrpAyEZX
19973	payment	1688	1688	780	1	1	22	768389889000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfUwYXfVddP9KULkU4zB87GNLWCCdZVvg8MJpBVRpK8g5stAm5
19974	payment	1688	1688	782	1	1	23	6146994786000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZYgU5HobVgNgQfXJwydG41z1TjnnK15faLox3uajbU5GooQhZx
19975	payment	1688	1688	785	1	1	24	558818195000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ6sG73U1HwTnkeaEhGxZFuengWj4HRyPYLq1ZsbhGTbp8tu1gF
19976	payment	1688	1688	786	1	1	25	6146994786000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkTbaXAs67qbu6VX5UXBCZ3zPzgsgaBVNY7fhgQMJLCUhnd1TS
19977	payment	1688	1688	791	1	1	26	139707374000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYh1mVBNpGvatQETuAC4Mxq4br9MBuRm6R7Jb6ChJH9181hDDyH
19978	payment	1688	1688	792	1	1	27	1536779778000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaFJRoWJ1yjkM8Ah5GfHrgG6E9mxGwrxGF3RknDXz6uYUeqQtXS
19979	payment	1688	1688	799	1	1	28	34923714000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa3bjzL8TSKPHUJvsHtaXJDUCtHwWCZXUsNx5Q4bLfbMVV8BPUG
19980	payment	1688	1688	800	1	1	29	384160521000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYhmDunp9vy9A7huYvqaVAdbqW8u7NJCk1TsHBYsMZBzGnhw5QY
19981	payment	1688	1688	801	1	1	30	34930175000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZUcQtmHsmBdxxMW1s8Nfb5XDaQJ4PP8TrdrhqoB6EuGQ21sKTv
19982	payment	2133	2133	1874	1	1	163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyimsWW6zf66WGYR2PYzmBgGJXJfsdbJLzatgBBEXs8GAkiW1b
19983	payment	2133	2133	1874	1	1	164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy92oV8F2L31RfXYQ6NsT1Chvg8HUYdSTNL9C8fFRB3EZ76F3A
19984	payment	2134	2134	1874	1	1	137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dc1fHnG1Tt9nbCAYWAC29Add9nwVYQCmjgGrfzWAgpg5hZPg
19985	payment	2134	2134	1874	1	1	138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5EQuQpEyqvbrefyHiJrhK1EBy86S7NDR2X4CoZWwniTAd2H5
19986	payment	2134	2134	1874	1	1	139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSb6XWCY6CcdbvbBhqbrhyR8B8kgSng3ecVLNTHwcqZPY5Tq54
19987	payment	2133	2133	1874	1	1	165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mULTfHpk5ZLAxffYMjwYfxc1dNiug5RbGMc13waoxCJbhcwP
19988	payment	2132	2132	1874	1	1	45	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGW5oVnvVVzhWvHeeHNY8x6MtoWo4sJ12AG3EFWkXhbHBTfmWd
19994	payment	1397	1397	1678	1	1	8995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZU3azw1tecJHVk3MKFc1hNkrz3skW24iEZEDuttXQJsj8ayJC
19995	payment	1397	1397	1678	1	1	8996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSuEjp4mS6A7yHcmhQgrN6yYZ5trSavQ9wPvrFckgjew3m6LD
19996	payment	1397	1397	1678	1	1	8997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTAA5PQSN3kDuLpuUpAKLSyrRtY7MPoecTktqPtQ4LuBuHtJgx
19997	payment	1688	1688	812	1	1	33	2973624334000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZq2rSxvvJBSxzCJfNMAjd9ajySgKB1Fhi1nZZ58WLa67gaqnLt
19998	payment	1688	1688	823	1	1	34	4337850201000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZmc8uZzMZERmbG7WC2v559mvhLZjVxEmEzo1y2N5Eca4z9N9my
19999	payment	1688	1688	824	1	1	35	47716310565000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZTEpexz96hHxqa3a9rfnHjMTzqL2eMD1AeypsHSCwEqQVjz8Ym
20000	payment	2133	2133	1874	1	1	167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEMnjqQMR4HX6wAjJvGCp5tfmCf57vgoK2Avdo92ZiyLD8A48
19924	payment	2134	2134	1874	1	1	124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2xtSPgS5BeqiG58euhbRLvPRFfm28N765YegDyZz3d5VFBB4
19934	payment	1683	1683	1393	1	1	1	314501157750000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYk25LHysbEGt1MXWUf4WFxxEFzaeP2Dsihhxr2eooLWfcoHKNR
19935	payment	1397	1397	1678	1	1	8982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQs5jhVXMKwuYQotsZ39JGj5o1nKgas5nmB1AiDCzDt4rfrxW
19936	payment	2133	2133	1874	1	1	154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYUXJy1CHA3GycD6UcmF9JEWX9yWrj3bcBerY6TuRtxnSwZLA
19944	payment	2134	2134	1874	1	1	130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HDiyAh1tnVZTdosdki4zF8C6pH69BrRvkBE4dFraiy85Kesw
19949	payment	1397	1397	1678	1	1	8986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dyWtPHZKLmaCm9pBmAvjpdRrt1Z5V1yJgwLtWf5k5Zibtsrc
19950	payment	2132	2132	1874	1	1	43	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrte8i1HRq3ZMJoXXu1gGfkPJTwfXatPY4FPAzSRWSnHmygbTH
19951	payment	2133	2133	1874	1	1	158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCY6KdtoGiPwNT8An3uN5pGtQwsqp23gUfHgzeSgcievsVgNBu
19956	payment	1688	1688	31	1	1	18	3315886828000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5D3Qt92rCrzZnUnBT1KUb4RqN3adLe4YfikgiF5BWEWm4UEd4
19957	payment	1688	1688	32	1	1	19	185149305000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZHM5cktAmYQqJy3ZmC3whRGGimSXtPzZBzvT73aXcgg8okoNGq
19958	payment	1688	1688	40	1	1	20	165969741000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYspBoBq2mvVbHU6CoHwnZnCfoMKGB7WrkYvPnuqVePrYBz3P4N
19959	payment	1397	1397	1678	1	1	8988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRA6A9YumwTgVoisaQa476EBj859s4bVkfTiXaQtQfNs5b6Qp
19960	payment	1397	1397	1678	1	1	8989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqYs7LjMkyMrC51bnrEYZ5uepEUPFgekPfnB8oPtxziWaK4dH
19961	payment	1397	1397	1678	1	1	8990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxx9ukgUH85impBYJgQ8CvjKVCSiTvFP6xRfg5T8vbnGaEKNS
19962	payment	1688	1688	779	1	1	21	69853687000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1VpkVcYscHzrd8rDcsRk3ne5UhAbGUr29BNhqhq5gn11SMXaU
19963	payment	2133	2133	1874	1	1	160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4kxJhoZ2pK8eYcvkf5xFwJHixCMn95kY4dSAcZfRhN8YZrFo
19964	payment	2133	2133	1874	1	1	161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhjAh7nK9PppaNuGS5MWLbKqMtTWJYQKPUqyJhVyvJTw9Khic
19965	payment	2133	2133	1874	1	1	162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatzeLg7c218BpwV8FCuLBnK4mvStXSFEbtVLXLF9gMQTgoTbP
19966	payment	2132	2132	1874	1	1	44	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPFFpDE86U3pwCPxMfLdsZv9q4roWvRqEoyD9nDtsRj9orJTp
20007	payment	1679	1679	1	1	1	24	824260949000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZBWZ6MYKoBjxFFZf6EfjNvM4Wb9sPwQBjaDoRfsvc4cMpfydFN
20008	payment	1679	1679	841	1	1	25	184498405000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5a2AbmSPn8V2KWXLhAPerRDopMiphnakgrtSQMrv3NLrkFEJW
20009	payment	1397	1397	1678	1	1	8998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEoSA3PAZZMAtnJH8Grq4GEYWCw8J4ZFRQSrKVcqykDY2CghZ
20010	payment	1679	1679	843	1	1	26	343971557000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbQYtXjU17sWCD6wFdUPDVZfTDdzEiBgr9h9ev7P5k6gLxB5gN
20011	payment	1679	1679	849	1	1	27	2546701905000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ4FbAjgtxdxnFsZ7TKHVXdNU8Pe3Y9wNuy1AiUH2PYebwaBkLs
20012	payment	1679	1679	851	1	1	28	4933345906000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYgPynYoV6YrQjfahRri4Ea2RLiqfntDpv93cAY8GtqMm7uiEMi
20013	payment	1397	1397	1678	1	1	8999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcPDKzgJrR9G36DnTVSutd2MS3AU9HBYiQyLWNJJErmNbmiBX
20014	payment	1397	1397	1678	1	1	9000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQbCkrUEgtsMZBZsf5oqonaNW4attcHSGHuQjBiw1xBhrnFkh
20015	payment	1679	1679	853	1	1	29	543980764000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaKa2TqLMXjRDo4NPtv6Ypdb7UBvNypgometo8QDRwYdMAkzXB3
20016	payment	1679	1679	855	1	1	30	287745437000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZHs88kAEvbNCnaHhEQSnPCdMAgmvGNvVdviHbXHEU6CotqaHNi
20017	payment	1679	1679	857	1	1	31	725545820000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYj92FviEpX77HSDhEFEKdWkvAeTrT9QYFS3keLHo1PDSFy7pg3
20018	payment	1679	1679	861	1	1	32	1002147901000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaDWSTYJJzNtvWcfZEMY4ApmqJpF3CWuMEGTP449movFHb6kY8i
20019	payment	2133	2133	1874	1	1	170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxRdJ55dbAd4CZJNbRJKeJ3FoYarcEq1vVPhwghwyDH6wawpZ
20020	payment	2134	2134	1874	1	1	144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8EmHXEmvX7YAp8ovoNgkCyMy3WUs7YFcz918LRpZnqnGMEjQ
20021	payment	2134	2134	1874	1	1	145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn2bqsqPKqaGuTKTdbsvntVh5v4WeDTEdtdT5fonz2Q23vBsd
20022	payment	2133	2133	1874	1	1	171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXtJWDkzJyoVgu62f2FLCPSv9SoNzMzd6yqnBqehLMa6Y6P9r
20023	payment	2133	2133	1874	1	1	172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGC6AJUzCK4Tq68ZSXMKL2qdky477EoBcu4GZ5t7fEWVnnoiaV
20024	payment	2134	2134	1874	1	1	146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gUbnMRtQSnR299jPuMPF6jYG7R5zmmDfzRzECFqabbTmcfdb
20025	payment	2132	2132	1874	1	1	47	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUNcJpYrhCyb1zSAtD73V289VaGowpYdLG6fKVcEMDASCaLtb
20001	payment	2133	2133	1874	1	1	168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCRFxNdomEv3Dus4SJGSCiEt6HqcgshJNxgbnF8Zn1xNokP1K
20002	payment	2134	2134	1874	1	1	141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxLafhfnJK6yShqfYMfD1Ap9BVn6jQp7Aqzhshwm7sPkwU1B2
20003	payment	2134	2134	1874	1	1	142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nsw6xzb2NdJ79frGjPWHHYqFj8R8eCTor7sgrH8VZu7ANjaU
20004	payment	2134	2134	1874	1	1	143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1VzimV9bEyYFNEE8vKvmuqXakptXRryqpWXvzUSigsoBZK3e
20005	payment	2133	2133	1874	1	1	169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzS3ehRihtd3CXwvDxpJuRpkK9DWCP5odAKFZ8hQCHc5QkMyU1
20006	payment	2132	2132	1874	1	1	46	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sfyyy9bmvohS8ih5FZEPLScQTdw1hEsf7oq8ZUmYtYVPitVE
20026	payment	1679	1679	865	1	1	33	879773405000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZwADt9oqAcPdac12TbbpTAXyUsUdQmSHBVRhWtW4ynKqrNgZqo
20027	payment	1679	1679	867	1	1	34	5358018483000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnqqVEZC5roMffQWsfF34T9ZRd43C87JpAtZjsLfFhfugPYfK8
20028	payment	1679	1679	869	1	1	35	572998403000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYvjNZkwA3DVRWhrZbggCzLdeYK4jbV38q9G7yhWKQ5JDjkVfZV
20029	payment	2133	2133	1874	1	1	173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3iYkGRfXnMazUpaUfYWRWnwFLJBixwCARfru1RJPrs9h9zax
20030	payment	2134	2134	1874	1	1	147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PheR1oRG9Q53GDwBSdC4eAsrojGZ5g7D37KD3XR1sy7UadqM
20031	payment	1679	1679	873	1	1	36	5358018483000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYQ9KJctMEhY8d55JAUkmYhrRgZYbJeGUDVkJRWfdMDknSnmbsL
20032	payment	1397	1397	1678	1	1	9001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSTeFVdoteAGNR6XJDKWm69Uxu55FrfpPbKJW9jQ1MDdyeswE
20033	payment	1679	1679	875	1	1	37	469653472000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaKZ1ruzQTS3dJaYZrvpMuXmLFEuBgwS4NyEBHbhHHExVb5RzH8
20034	payment	2133	2133	1874	1	1	174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14ftKTH9GrZCJ6Fu1Wyd7e7x9o5xzbviWHbKTPBxFuKn22QDL
20035	payment	2134	2134	1874	1	1	148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxLBnSV16C7n2kC5jc8UpAiXB39ArMQ6xSRXUYj534nmFgPau
20066	payment	1397	1397	1678	1	1	9008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2nxMgTYjjQSb54qJFpSXY78e5r7n4m8RtJewQrkE1QLjCBod
20067	payment	2133	2133	1874	1	1	181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsmhdBjsKGEZvDj6K6m9HTPJi2ViPKyzThRPYw1b7Q438KPo2
20068	payment	2134	2134	1874	1	1	155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxsGEzCXm5eUm2DXyghAbMuhKD4Tqo4FTR38EHHAyqGFx241bx
20069	payment	1397	1397	1678	1	1	9009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7wzHRqRcYwDnVJpn4K9C8XwecHd8CvG4X7manphuUDaGUPa6
20070	payment	2132	2132	1874	1	1	50	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj3WGyFFtLeSjR2mpK6djSxwLWY8qtk2WTZmtdzGqvF2b3NST
20071	payment	2133	2133	1874	1	1	182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfmCsqt3sxLYnfSAUSQ6kTT9cxxrNK433PJeDdBnuxpDkyz2i
20072	payment	2134	2134	1874	1	1	156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9HJqxsCgMfRzNZRypzpFsrFN7ug2uCxvkM6PUacn4GYwvv69
20102	payment	1397	1397	1678	1	1	9019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaropooDJbebME6epnhCgzWtoP7NPAUEPV2Wmd1mP3UZVUMU9v
20103	payment	1397	1397	1678	1	1	9020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEEcyK9bWH1aiAUiDKqSuSkCuhNfMXYSL9WiGKGcYBLTgZcEe
20104	payment	2134	2134	1874	1	1	166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5tmbAQkYKEdnPEt87G96uygvMFLr3V9VZzrHU2nZqkHHgtCxe
20105	payment	2134	2134	1874	1	1	167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a8NUspmBib5Eo2C8vbTVZYyYF4q9B5kFXEk9WzvD2XYQAd88
20106	payment	2133	2133	1874	1	1	191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjaGYMeHFFhF29f6yb8z9aoZ8nsV4zCr62yikjQa9DcX8jTP3
20107	payment	2133	2133	1874	1	1	192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkib8m2rRuMPC7Q2mxZchzAoVk8pqe9qHgdVGYgrdeJ2C3iGa
20108	payment	2132	2132	1874	1	1	53	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczifTsyQwrM8C8FRFT4HovVioHEazxdYuJkLHYytD1NhKNCUS
20122	payment	1397	1397	1678	1	1	9025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNAb5owFq8YtQ2vH8jvj6nnK6Y4LPFMhzAhYkDtv2pPCv7e77
20123	payment	2133	2133	1874	1	1	197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGi8KcaTELUN7od5FejA26BzeVYUUKhTQXwhQd32rWJ6UfFnbc
20124	payment	2134	2134	1874	1	1	172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjLX61MnyEpYN9CZyjdJCdWpeNkgKzK3HJ5Rc22Qxv5qVPZo2
20141	payment	2133	2133	1874	1	1	202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmciX6xCgHUmHDeoBiUgctwQkrtdsL69UwU5F3mpkrRrNq6hef
20142	payment	2134	2134	1874	1	1	177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51neEY1dzE3fSEkmXzj425KB1fdeBGK2fBbsxeumPY9Fs7dP8
20144	payment	1397	1397	1678	1	1	9032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4iRDFEUuM841NVSGqGj6PMWvBFFWmPDFfrxT9CcS8DtK1WBn
20145	payment	2132	2132	1874	1	1	57	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5X1MtwZ8o43iN8GwwQ5x8Uq3s1C8n3TR2NnFkiWw9iv6eVUM
20146	payment	2134	2134	1874	1	1	178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYku52kRkRbpirZFdUvH39Ae2W2bvaptNTjeCDsDQA9uJznPYNA
20042	payment	2134	2134	1874	1	1	149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA99uG922M7hga2QuRLg48aNRjQnfGXtSiCjsG4gzDMzHFVSeB
20043	payment	1397	1397	1678	1	1	9003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC7ZHmupvh2kZewsd9EFNN8RYgvXJZJvAw9aVBxR3s4iih4YW
20044	payment	1679	1679	887	1	1	41	592277347000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYcFmBojZq4y7Q6xsAdEQGrTnJBNZqkyovuMkpRw9Lav2Q8RNkz
20045	payment	1679	1679	889	1	1	42	497185088000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZgDdmJn35F1rgihfeXpEddY1DsZpPa2jSGJbm6Matqc7UPEFa1
20046	payment	1679	1679	891	1	1	43	1091448209000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZxU4ddLSnmZSYeCwPTWFug2cMGTxDUR48jjcyte8hefZMxepQS
20047	payment	2133	2133	1874	1	1	176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwy6TS8sH5axmrFvc1954FoEYpoSNsbB59h7ybGBGnV4MGKud
20048	payment	2134	2134	1874	1	1	150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8281S1WTxS9aupZ5VJyYHoafW6mDyYxx1SvHJ8wMLgEqyjaU
20049	payment	1679	1679	897	1	1	44	143975910000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYc93DNhhPp9DJ3RqQ7cV2UgVp49eC7geBMSDAeb51piYaPGX41
20050	payment	1397	1397	1678	1	1	9004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8BmqNdcN5a52Nonnu39JFNR5DBhPYEHToPaTsgjJUCNyCJSS
20051	payment	1397	1397	1678	1	1	9005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdV4qp4gpBqET7x224yvBSyQbeLqtWUbB9nSFVdvwyDFPzC4EG
20052	payment	1397	1397	1678	1	1	9006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVtiUsVngdk17u3fcUr4vA7Um745EqvLbQoEVQpV3bcuriXqj
20053	payment	1397	1397	1678	1	1	9007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJhiFcgduWiijebXoTPRTKTDEDapM6ktdiXCACbqtd2J9PjCo
20054	payment	1679	1679	899	1	1	45	85823549000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfJmL9hA9rQWiyafV94oyBRaYmqoWMNiQSAMx6KKcZVZTnERR7
20055	payment	1679	1679	901	1	1	46	257978668000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYW7K4jrSuoDB9ewJ6NqQuPPBktLpjmPA8nF3Er5GEfjpFe6yfu
20056	payment	1679	1679	905	1	1	47	927730978000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYRhSoPjh35586iU7hoMwVwXw2oktEyjGha1dfkrM8L9hJPxx2C
20057	payment	2132	2132	1874	1	1	49	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBq2DAQQN1BYQm7sJqPRFxzkHDevbgcbikZmP1KhvmpQKRjgh
20058	payment	2134	2134	1874	1	1	151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75PULpUwG4ikHSijABb5TWZPBzu2ppF3d9mZ42KwfeQBPXp1L
20059	payment	2134	2134	1874	1	1	152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAW74XiFLF3CKHcss8dhtxbAf6Cqo7s5DW9pnqGF4qRupHg65
20060	payment	2134	2134	1874	1	1	153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eSzJeYn4DKaHKEgxTc9GUX4jAzUjtwPUAZTA6fXmhFyniCem
20061	payment	2134	2134	1874	1	1	154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71e1ZzQ2q7KUKfqTtyZqBozqkghDbeSFPt3YgYmKPJwvovUzF
20062	payment	2133	2133	1874	1	1	177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVhi7CNemhNHrGppYa9oH9HcSddauvpPL8v5vUPezxborysGH
20063	payment	2133	2133	1874	1	1	178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACPffVK2XwJZka74BDp1CJDziUkWCQL4yD6weTtcqDZ75qCfk
20064	payment	2133	2133	1874	1	1	179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFagRg7xDQaYU3a2cj9LNYbfLdYF6abeZs4TBGZXXxyTqbiJux
20065	payment	2133	2133	1874	1	1	180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYrKfqjD3tKdZ25H7JNS7RfuMoZNQ7ateaQMUNtVjB6Eryhcr
20073	payment	1397	1397	1678	1	1	9010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yPs92hphg5G6dToHhN9bmbSp7zBY1P14cNkxsRQMVRCqk5Zk
20074	payment	2133	2133	1874	1	1	183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAVfMQVpoqoT2Q8B94e1erN1hr8wWiGksaVKViM3eo1KtppPM
20075	payment	2134	2134	1874	1	1	157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUtbkqnBHjMEJtNT1sigVmP3G77aEkA6BsN8BmFdWVKJCAeha
20099	payment	1397	1397	1678	1	1	9018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9C9rah16cdDinyxyqqqKRNmcwXQk92Da1VC5kEiCMALAKWeu
20100	payment	2133	2133	1874	1	1	190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq2b3UrhZiC3fBunUo9fB9oD3LK8ZgXRDaADnoTBJknfnzpsP
20101	payment	2134	2134	1874	1	1	165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWmhhEmGNUXDkboqjDY5FxGJq9wNUPTqss2ZifmQwM1SqkqbF
20112	payment	1397	1397	1678	1	1	9022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZtqS9mhe3WSThnS3r8owL23jFtGQPCU4WnMSz5mvsFkR83Th
20113	payment	2133	2133	1874	1	1	194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXtBWXQanCPv3VRYaPBQs4Lp9ZmFrVH22Z6G9gwkrQk82zuxN
20114	payment	2134	2134	1874	1	1	169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBURDa9xBLqhNUAZJfaKgb6pm68f7BR5n8Kx3WoLaC64J7SyB
20115	payment	2132	2132	1874	1	1	54	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KsyV2xgteSi6EoAxCab3FvLNehYn4ten1BMZU2rJZyF5gVsg
20140	payment	1397	1397	1678	1	1	9030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd29qRxrHwuQcCrZ94ZtJvPN1cR7hieBqQcmKNjSRxaNPtmHTf
20149	payment	1397	1397	1678	1	1	9033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurU3Fuu7wnMryZbLNUZ7SPoEVPmUzs5gyToosfkpzXxGH8RVr
20150	payment	1397	1397	1678	1	1	9034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMuHxJoMeeBr3XPEBeY2uprNnfXKCcQbHKJmwDVTXQLNqePDj
20151	payment	1397	1397	1678	1	1	9035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMimdHhxnb3HQbrbxnnf1e1yLkENRT7WFDXV4nZRLeQD3Pnw9
20076	payment	1397	1397	1678	1	1	9011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiisUmAS6JHHG4CSa2JqmnPJtAT39WNuZWuaCSYXXZVgCDTpJ
20077	payment	1397	1397	1678	1	1	9012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1UhFgcRdrmsGGHmBtTLAwMQiZk7Tj3PKhJ5D5SCEJPGCPN23
20078	payment	1397	1397	1678	1	1	9013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbkPFrTbHdq8vyy1rRefyRofLVgoh3PBAbF34Yf6emRXj8htt
20079	payment	2133	2133	1874	1	1	184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDNvjnq2Y4tSRELy3KGL247dx1PzWMPL4yu3N4SYJu7X5VbVd
20080	payment	2134	2134	1874	1	1	158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThs3eaqEJNrurfUr3ZDWMHZnrsAQD8TQfg14ZpriGkv5ZE5eu
20081	payment	2134	2134	1874	1	1	159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9zN7SXVBjZGdP4A1uCk3hySKXjDw6zPDfPgA8o7XeP2HeiMV
20082	payment	2134	2134	1874	1	1	160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxphHDQzM7cQrkmzHYD1VxKiz46KQycjcpFazeY7fagmSkaXj3
20083	payment	2132	2132	1874	1	1	51	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjELikLEVMBKHBRretj2hce6Ts6h825gPSSj36XpRgrcoRh1u
20084	payment	2133	2133	1874	1	1	185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4e7X429TYsRfMSjLPqf1PaTaTpheWtoruuNj8mdL73svgVBL
20085	payment	2133	2133	1874	1	1	186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYho7DzMvwjoFSrogXPotom1pxoJz6z444oFeS3YuB5XckYJzoG
20090	payment	1397	1397	1678	1	1	9015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmc9f1kA5rURrWS71LBN1LcikiChymkZD9SnVYgtdXMFcHRY3
20091	payment	1397	1397	1678	1	1	9016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTASWesUG5ox7b4VhEWqR9b2uoM2VaHRZDqMvmWSPPwkqrCde
20092	payment	2132	2132	1874	1	1	52	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAk6xVPG5mS9oCNNhnJAf2FwoBnkMnQSA5HoFhiK7SA4N7H2aD
20093	payment	2134	2134	1874	1	1	162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMH32A8XrXKDVWdAcWcSBGfQhJxAVophJ3Cfbf613BkaQSg7K
20094	payment	2134	2134	1874	1	1	163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChddbGi6KDcUJ2Y5bcn9WhG699Ki3iLxEGu7UXGZ5vgudHm97
20095	payment	2133	2133	1874	1	1	188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3biVfMpa1iQF6J2KwxQgg3t9KNUAEDpGdD55HVgPUoKcevgA
20096	payment	1397	1397	1678	1	1	9017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJL2af48PDmKA3LB34PepsT8WmydZgwAHwvkqGei95ymitY5R
20097	payment	2133	2133	1874	1	1	189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVoW8zu3Ya6wbY6gCiyR26z36BNgnEHBWDTkRTWDGbS2zSDC1
20098	payment	2134	2134	1874	1	1	164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJjmomAjDjma5QbeqyFtECNu3LtDmy79ckWpsNQsw67zjbr1V
20109	payment	1397	1397	1678	1	1	9021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnHPi1pwAphxWBiRWSrwkHHkGhcuBoChDSYwB93NtzXYNbSHC
20110	payment	2134	2134	1874	1	1	168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83pUTD3ALrNqC5o84qhPWQREVpKXFHSQ2yjodjnz28jJn9dCo
20111	payment	2133	2133	1874	1	1	193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdgp3p4QUhwmrccroGe2uJGrAbKFUjEL1L36cuDu98C4bLNrS
20119	payment	1397	1397	1678	1	1	9024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygQBSvqMSH5vKqguqCCRagLnwcoxzetS2ofTrtfE3S66DaruM
20120	payment	2133	2133	1874	1	1	196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbqa1ZA9pfaWVDobUATEp95GSNBoE3YEg2aSMc4abSydCXJMx
20121	payment	2134	2134	1874	1	1	171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtM7PXVrf2MbPrShSa7hdrDQQzXXSyw6uEmwU6CZmmGgiD7Eh
20132	payment	1397	1397	1678	1	1	9028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfydz9BRw6WGF2ithCUVBVW9wHLxGuczaf8euDqzo43ZWZ4LSt
20133	payment	2134	2134	1874	1	1	175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrQfVed9jSzcPv3P8yiht4wu3eyP8VQuCKd4rCXcer85ybBw6
20134	delegation	1893	1893	1519	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mZLCnuy8CxU7EhLZV9tyTtSNX6uDJhxwhmKoGzGaLbz6AT2U
20135	payment	2133	2133	1874	1	1	200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNkk1xmCZVJcjT7n1PY6apQgucimtXPESPgUSdiL8Nghy6fu7
20136	payment	1397	1397	1678	1	1	9029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsscWLRA5iESrS2cCQj3M9GoqpXDBFsHWEweEsRD83b6mkAQb
20137	payment	2132	2132	1874	1	1	56	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgf9DDCs7gTV3kDtguc1fwgtdPYibDJM7k6wSdLLTStCYe1sL1
20138	payment	2133	2133	1874	1	1	201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZaFMXQwhmJCwqjPcsz6MnqkESnQVBAPCZtZs5gzP5RsG31US
20139	payment	2134	2134	1874	1	1	176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zQvMwDaWcftYDfqKKgFvGtrpVQeTS7AMUzC8ecaAuLQJ1spc
20162	payment	1397	1397	1678	1	1	9037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZwQSuVGogC5w9qgpMMDrc24xHBdWKNV9qsVBd4KQQmS7tCCz
20163	payment	2133	2133	1874	1	1	208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUDemVHdGZrxPk736q9s9VRQjMXAGZbrdED5B41uHNtfEAXiy
20164	payment	2134	2134	1874	1	1	184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ufsgXQeo2jvoeYMSmKYonG9chPbd1f5N4QGaR3NeewfwaVXz
20192	payment	1397	1397	1678	1	1	9047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxFZyTk8tSTPd4DEcwHZRGaJzeq95bXchCpTEFXP17WZUAmsp
20193	payment	1397	1397	1678	1	1	9048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3mqtLhvWc4LnqNGENxcFsAhck6p3TEBWbQ4zgotnUPFjzx6x
20086	payment	365	365	2138	1	1	1	50000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbYRLzu4Zkg1vLFQgXtEyXWpXAwrbp89mbsj9N9cCVcvqSk2c
20087	payment	1397	1397	1678	1	1	9014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2C73ZJFMJvEVRvXuCNZAKCh3xW4szpEhcVV3XNLJy1EzoNEo
20088	payment	2133	2133	1874	1	1	187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTawqJEhWGwHo4JpTvcBCRXQ4PPMSWV47Hn22PS5jemM1jnPub
20089	payment	2134	2134	1874	1	1	161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifJWoZi9o94bv4hX4cKz38roZT7eXxV34p9TMVp6gDYvr3AU4
20116	payment	1397	1397	1678	1	1	9023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2UGM2vkxgJ7Z9pebnQUK3AzXmQhmPHB3L9HbCAA5fdLAqNGE
20117	payment	2133	2133	1874	1	1	195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z8qeJvVHwPRnBh25z1avnZZCaaRG4TTQmjSYcgkW5zbx8Gh2
20118	payment	2134	2134	1874	1	1	170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjUrBPWPLjoLeP91H88avoi1j542s7djxTVgspdAQcDzeLXCS
20125	payment	1397	1397	1678	1	1	9026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYD1ppv344g5pvhu3EsUayWTvH4fKfYT82mqqyaJJ342T2tZ1
20126	payment	2133	2133	1874	1	1	198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3z6989uLv5bfMbwkEPUNEjjZYcqVjDoQQPSWwUSGvpPqSHZY
20127	payment	2132	2132	1874	1	1	55	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoKrbgdQuVbdbJNrzyL9HK3ig1nLqdGtwgyCuE82z45mCCaLW
20128	payment	2134	2134	1874	1	1	173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1u8XF7T2u2RAoVSxRrXTAbNF9KRPdNTC6mFs8n5qKCmQbrAp
20129	payment	1397	1397	1678	1	1	9027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYD7ZwFooJRZpowz9P9t7kJ84tScDTAwxsWG7iERRpW9BudCW
20130	payment	2134	2134	1874	1	1	174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW2DBDdDy7SMNJqcEYhV9j2vPBdfEH76Xecg47RHvNPmZ7UKE
20131	payment	2133	2133	1874	1	1	199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5FNZaH2pzYuCE3CycDYYBmnZC5oXZrkbER7dPGqbSYsemEKE
20143	payment	1397	1397	1678	1	1	9031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxQYNGprBmSParJcRXntRYgFXQZ6QvVBpFKkSArgqPqRz3koA
20177	payment	1397	1397	1678	1	1	9042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwheiUSCgbNGQ26LwNYUd9FM8foQ7MfSayrd2Ki6t1RsRVAYR
20178	payment	2134	2134	1874	1	1	189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEhpGki6aAC487EagbhHsbD9YezNUt2VzFYuSE9z5U3ZHqStQ
20179	payment	2133	2133	1874	1	1	213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKm3oSfGpnU8A3aSvCMrx945bhLyVQZmgS51H7tsqeRRvnZss
20186	payment	1397	1397	1678	1	1	9045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCY4hkZuhXznigYd7LMGBbxXxQWArEdnvmqyuRjVjd3UDmhJgz
20187	payment	1397	1397	1678	1	1	9046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRF2ZYArSUTHZ4v44jkgJgPpYtFB7kxewXwanKzjYDYMfdjmM
20188	payment	2133	2133	1874	1	1	216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7qomagZEjwLPTjuvwfhDVHjbkRhp8fBaChbLUd3G3e2iccYW
20189	payment	2133	2133	1874	1	1	217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCmfN6v8YRxdSzc8SuPSGLQE3TXsjNhaTnNsBq6jSzm37eYXt
20190	payment	2134	2134	1874	1	1	192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuk2CQHiNejU9yLSypemaBpe92Pp2WHwKww7PnEb8rNF5CcFTd
20191	payment	2134	2134	1874	1	1	193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZka8kXTkD66agJNNYJKTU6CTABX4W8panc75a9LPevPVmPCbzC
20200	payment	1397	1397	1678	1	1	9050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUCJoQAVvSgUJp6Z6quk9kMzcwKQ2fxfeAbiDWppwLkehTB9e
20201	payment	2133	2133	1874	1	1	221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKqZAGvGXAcBaKoniK962SZwvXdqjUnszpxgGRY9UEh7o86oS
20202	payment	2134	2134	1874	1	1	196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoP1czMzUCi442mkDAYsNvnZSu24jVtC9arTH5M6qVfjeNbNd
20203	payment	1397	1397	1678	1	1	9051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZZcM4YM1ZA1WQAK4NWBNm4Ms3p1C8fVFqZQs3625aiGcysjT
20204	payment	2133	2133	1874	1	1	222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPt4yt3p7r8BfnVrbm7XAHffmSd9598aChnStU69obQST9gcD
20205	payment	2134	2134	1874	1	1	197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxyZpZBGZsH4bvW4oEXt5o9YcbjyoCAjjVAqURCh6BobptWFT
20247	payment	1397	1397	1678	1	1	9066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4qNXC4MfPw5ViqLowQrvCRjZZeffe9wNqqYaDy5i9DaeaPAB
20248	payment	2133	2133	1874	1	1	236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVCWn5w6XdeewXKCMNqAcAmLci5RxiyahrRTCRQ1d86htjhCx
20249	payment	2134	2134	1874	1	1	212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W96q6BCQ4AT8ajkTUWVTHHvJ9o1uuGmR6NbzHG7mDJJ1t4jE
20271	payment	1397	1397	1678	1	1	9074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudzm285XV8AhcFNCBou1QRZyJ2UwN6W3uwykrmV2ujU6s8KyQ
20272	payment	2134	2134	1874	1	1	220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9ni6VjdKg5X2wQk7ccspzzZP7d77z18EAbzmxqgBNtGdP5oT
20273	payment	2133	2133	1874	1	1	244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJ5nYvuZgMYt4PtJ9nFvMf8XiYZoHrzYUR34a2WVLfX9Yh78s
20274	payment	1397	1397	1678	1	1	9075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYkP8Zp6boB4fFpcRimfMoGWfL7qUDaYn4o3aCR2R3zcbsh6m
20275	payment	2134	2134	1874	1	1	221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbmUJck8QeiX541ojpLCb7PJtgkbTtt6s79oEgEn8XPnc1UBb
20147	payment	2134	2134	1874	1	1	179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Dmu3YEW3A2R7fqR6n8aeYn3xucW7igENcKdF8bv8ift8kabE
20148	payment	2133	2133	1874	1	1	203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYEe3StT6JcJKPyoJMaUB1Xh52EcV1gunjNsuTCQ2UtjC6WX7
20158	payment	1397	1397	1678	1	1	9036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkhnzXQ5x4j28xKNYHaK1X5A9tR7tmxc671CN5Hypx3sNDqvc
20159	payment	2133	2133	1874	1	1	207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5eE6M4hwGzn4GtUFsf95YpnF5jdPUSxZALyvNw3hbo52wDe3
20160	payment	2132	2132	1874	1	1	58	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr495thqPc5pc4kwnnsm6MwW7CGJ1JU3XJ9bxYjd7ZtwQcGXcp
20161	payment	2134	2134	1874	1	1	183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6mVxbobBhdhodAtJckGfDVpQxndtUr7zRvFynf2UVhYGfxjw
20168	payment	1397	1397	1678	1	1	9039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxUEkCag4VPmdsEjpRrLUHJ7vqA3ozyLP1ZgFU7xbjuC7BBBK
20169	payment	1397	1397	1678	1	1	9040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWC2BnjP6h8z6SRarqH4sUt2sfrvaDiUNume6CtX32Kweeyyd
20170	payment	1397	1397	1678	1	1	9041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWLdDCac4pLgNnwpRzprsxxBjL5ikzbfKHpCR4PFQKX76MVfS
20171	payment	2134	2134	1874	1	1	186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqCCbgT7johq85vuoQV9sJJjLVgnt5fHrwJUPqRzCWSBgGHA4
20172	payment	2134	2134	1874	1	1	187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByP1LVJn5VVEC5HRksY4mdM2VRhULr82XVBmqbVnLWN9UvW8b
20173	payment	2134	2134	1874	1	1	188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC4xo755eG4hvqLBCqJD4v3WqZRPY5p5QpLqzVsURnewodXxM
20174	payment	2133	2133	1874	1	1	210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfmqZihZWNXRTJ56RcCUN13HZbDDA9KbBcSRdiCtSfYxwLm81
20175	payment	2133	2133	1874	1	1	211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSiDGRrj3JBy2sMZoNKvM99QrDn8Yq6thruRX4iT9VawSp1zq
20176	payment	2133	2133	1874	1	1	212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvovaGZbiGEuvrD7GLbyw3RfXwYieUjrKi5bUjNBR2abs7A1F
20183	payment	1397	1397	1678	1	1	9044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjsFmzFJDc8xN1xkQmgR7zRy3vzDpPweoNBe1843jTDayMBNU
20184	payment	2133	2133	1874	1	1	215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qPwwAQ6wr7DqTAfKohPVnUXMHLKxwJMRRexdPQ4Wx1hyitTi
20185	payment	2134	2134	1874	1	1	191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaDMX9tjs35jcg8QwpfuhqsYiiSZR2maeGqPp4CRobarRDt4N
20265	payment	1397	1397	1678	1	1	9072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VTQQJntyzvS8ETY3rr35ZioyFgPrArm6h6QrjEDG5jXDaXa7
20266	payment	1397	1397	1678	1	1	9073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDcu3CVP1ZWao37VMots27LyeeYgAkfxbDnpDs5rL1MsoQfjn
20267	payment	2134	2134	1874	1	1	218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Aebpmacon2eRE9zjftVB8stmxuJw9V4ppyE2PyBzqZDxcMx4
20268	payment	2134	2134	1874	1	1	219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJeAHa19xhPG9wPuKmc2BW1q9SRJ9WMkGa4gP7brnGX4Q2hTz
20269	payment	2133	2133	1874	1	1	242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4V8ntZTdmzwsEdrL3NkinhHxpQJBsHkNgLJnDWyBUK5HysSAP
20270	payment	2133	2133	1874	1	1	243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTd9iB2YovyQAiPdNMtvEMoHdDiLKo5zgMbuwmtL8nRQH4Dbew
20289	payment	1397	1397	1678	1	1	9080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxTprKqH5BMPPvhJfHPLCoKV748oeyuFLBms8pMEiQGk3kpud
20290	payment	2134	2134	1874	1	1	226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtJo2pMXj7gmCbbT5RqVdk7B8VEWtz31HkJ97zAR77LF9vxGw
20291	payment	2133	2133	1874	1	1	250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75hLe6ztF3GzYybamqsxHgNx1cUVS833WJG9ceFmY9a7AZV3m
20298	payment	1397	1397	1678	1	1	9083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCC8VPsyjebg9ZRUg3q4B58ahNpbuaXttbggnCRyXkXGWsUH7U
20299	payment	1397	1397	1678	1	1	9084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2QQKv2NQfHdno4p2uLMjpt1PqyK127kprnncZe5fydLL2ms8
20300	payment	2133	2133	1874	1	1	253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgf8gkNdfCw4CuWikYoKBMSBhoMuLCYCEokCivQSTABdYbD6j
20301	payment	2134	2134	1874	1	1	229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLocAonDD3s2BascvvVe1SRk92UEu1d8sw3zjFGdNwjdx8ocEG
20302	payment	2133	2133	1874	1	1	254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwPHhcdg3u73kbTDCqifvTPM2NgjXLP8VpZvdjiMeTXtoDzQJ
20303	payment	2134	2134	1874	1	1	230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvEQaBm1KJRBr8aPZJGtLnaqviRxUDUVwPrcmNVeQXeL4zUJn
20316	payment	1397	1397	1678	1	1	9089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBGLq3fB1LNY4tveUQhuuhvuN7RRpL43JrjUYUW1rWjscW6hZ
20317	payment	2134	2134	1874	1	1	235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpByLipPia6mDL2s3YS2w92dxkUyHs3mepArYfDorWPRHsNfyP
20318	payment	2133	2133	1874	1	1	259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LgTbL16hZuSf3GbmVVjoigkgCgexjcdqrojH8m2e9qRHcgch
20341	payment	1397	1397	1678	1	1	9097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjMXEepRzVB613nYd2q5TqFMyBfPS52kjWb41NDqnQZxN3PvH
20342	payment	2134	2134	1874	1	1	243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6ajQWykzuh7ANZKruzCjg8euW8N1YE4hcp8rC8JoHrnREZSP
20152	payment	2133	2133	1874	1	1	204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGAMjVBEp3JSW3USykSMRkmQUXVZSM9ThQKyCwr6mMtq9iYHE
20153	payment	2133	2133	1874	1	1	205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25fKC39BLtG5Gg68qrKPABkSM6R3dmprRwHw2HuM3XYyTQ6z7
20154	payment	2133	2133	1874	1	1	206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtsqsW1Li6mKFB2PU2ASHF4SvMjmCeV63n5ne693PDui7kcWt
20155	payment	2134	2134	1874	1	1	180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMb9Xy2QcWTmHMFz28n55oWp2192zrv21JEg6EX7nWVWsNySGd
20156	payment	2134	2134	1874	1	1	181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGKgMmCsqyqgouX6bduhVFfPsXobJp5dXxwGtaqiJAntEjURp
20157	payment	2134	2134	1874	1	1	182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXowiu7rCw3jtozzDmME2fsKWrRHgnErCLjtJUGy5pLSfpeVG
20165	payment	1397	1397	1678	1	1	9038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzL5wNk5VXVe4v5bxTDY12pQC4nSMF7KnncmruqKkmP12chC8
20166	payment	2134	2134	1874	1	1	185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabemqsfDimyf8w3nv9s7HCmNNSNxhzeAcKvHgN7gyqoNXoXea
20167	payment	2133	2133	1874	1	1	209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe646fE95UygbqkSt4foSNeAFi88XAV4XL1WaHY1UpE142ciL8
20180	payment	1397	1397	1678	1	1	9043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrm9ALTmWKWPvvMG65XWj9tHRuirX6AaUFqcvor7RS7ogP9Go
20181	payment	2134	2134	1874	1	1	190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZED3XrThHpyKnzejWfsgMe1cexLFZ6SpUJTwWUxyuZqeYaC4u4
20182	payment	2133	2133	1874	1	1	214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwG3JmSrvUAXC2RYJPupnjVhYwAZ3RFQ2wXBBWCGNivUmEdUH
20209	payment	1397	1397	1678	1	1	9053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcdgxomMwLxTXGYNvC4HnguSouzGtNhncWDhXumba42tiEbyv
20210	payment	1397	1397	1678	1	1	9054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWtoAa3gKcd49X84dJtw7UKfV7hjBdUGq6GtmjhqeN5xUbjkN
20211	payment	2133	2133	1874	1	1	224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TaXxo8eXpayuyguvoXNG6wqzGD7idg7A4BTWjmKqBczEpi75
20212	payment	2134	2134	1874	1	1	199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHeyBvpN4cFb4SPeRfohu59xnxuyW9Ck4FcvFNGtQC3r1Zkc5
20213	payment	2134	2134	1874	1	1	200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYLDmnauwcp2qzVa4gF72W7BJT7q6HpYLa559QbzBkcbTDEJ8
20214	payment	2133	2133	1874	1	1	225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpo8aPrASSXZ35a249pLeChnXQ1urixQphzrGejiA9ioG4XSrW
20220	payment	2133	2133	1874	1	1	227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAjgpTSc6dCoJpsT3CQa9VTEcM4KgjmfPHKC9AwYw1JJfTVAb
20224	payment	1397	1397	1678	1	1	9058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3q1HW1Zw7mTsbiL2AqdJLC8fNpRaQnRuK5K2q2DdKKFhuTfE
20225	payment	2134	2134	1874	1	1	204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjSJ7Gb8UdNyMajwPePu1eRcguY4FBAxCGCyQ54BPgHqfJ4mn
20226	payment	2133	2133	1874	1	1	229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJe4qLyvsf5KgM1T1uUfUBXCXKeNKK1oBZvSeqWB5WDABYwqj
20236	payment	1397	1397	1678	1	1	9062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1o7CjhD1DjxQhkSWJqwmVMC9qNW7cPfwV9LLFsU7vdm3eA74Q
20237	payment	2134	2134	1874	1	1	208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrewR1L4Uht8u2iLVq9aEh1FVfopfpv6tBRKedsQJQmsjEnWp2
20250	payment	1397	1397	1678	1	1	9067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQXQVro1cRGQiNqbN4zmVxoENfBwcyYLGpM7WqnrNrKmApTBv
20251	payment	2134	2134	1874	1	1	213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAc9KXoFVM1vG9fHpmMR8c1p8njUXXivnijKt1QfJDwGKytWj
20252	payment	2133	2133	1874	1	1	237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcadEWGkkRdeVGYCy6XUHLRBxEmkwpjpCdo3x2zqfamH3YgMSt
20259	payment	1397	1397	1678	1	1	9070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pUBcWikFB78MvwZtKZHagGynu4PpAxYTVUHAK9C4McXZTKmr
20260	payment	1397	1397	1678	1	1	9071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKk5cYs8mzxp1gj8BGW5EwNUhUt7Jz5LUxfKv3exFB2c73XYLw
20261	payment	2134	2134	1874	1	1	216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FgfF5TCHDm5YGfZ8g5KhUn9PqLUyg9xryuEsNGU9iQt84FKV
20262	payment	2133	2133	1874	1	1	240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikSgg6F1rXQbABQUYKWp5G2TJ4QkVuQGRw4sn9P6AGQEPTCA6
20263	payment	2133	2133	1874	1	1	241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkWFCD5SKGGKqYKDpTq7xWX53iwJMMxemzUCSxyzcdoEagWJr
20264	payment	2134	2134	1874	1	1	217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8U7SnJZWz6p5s1aNRi9jqHUNbp8ukD1wn7AMcfAib1zQz7zD
20286	payment	1397	1397	1678	1	1	9079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeYiKXu24v24ejC7UDCNus5eMCobWbKdSmGXf92xXs39gHxGt
20287	payment	2134	2134	1874	1	1	225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZxJuL6khrYHa71R65aAcfx3NocAMDZNdJkDgRDeAYApCHTM9
20288	payment	2133	2133	1874	1	1	249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28Xb6PmghUci1Xydmj4jG3tiaCQ6N9c6iN3P5njRPxP8UDp72
20295	payment	1397	1397	1678	1	1	9082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHR4gNRRRJWYtHj2WfMT4tyBKSdJCk2zaqCHz74cs8boRNRHiX
20296	payment	2133	2133	1874	1	1	252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXPGHkqZUkEsEBoPnQoHS4WgVYCopW3sKrafLDmYogNXJxDMb
20194	payment	2133	2133	1874	1	1	218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNsyt2iFTkoh8JcgAPegHyS78e2RvJqjhck58r4Yivnz3uGDH
20195	payment	2134	2134	1874	1	1	194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UAM5DYWkBMNSheb5n8kXV7qXTV2HjVRcNCz4q5vCmQDipLmc
20196	payment	2133	2133	1874	1	1	219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTyo6AsvJ2KDopTn11SAY8fPrAXigcCnquKHs2AJ4FMprgrHj
20197	payment	2134	2134	1874	1	1	195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmaVarfG7KiMrodsppAfEyC1cfmhghaB4Z1B6NcVjBrqEvnLZm
20198	payment	1397	1397	1678	1	1	9049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuPzLexnC7WPF6pgCLumAnsKsjXhccui6gycHnaxWk75pFLvYz
20199	payment	2133	2133	1874	1	1	220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBYK7nms3pqnFR2nKiHz4etVoJ9kjwcycTig4uVHVWbj1k1mt
20206	payment	1397	1397	1678	1	1	9052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXrgycj3gxXiGFyi5gcWLBt7djLJJ73bA723P7oQp9UktearK
20207	payment	2134	2134	1874	1	1	198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfYt44MQCTJYaHiEir1jQ6nEtpiBQXq4yXx8puWTJvhaY3tQr
20208	payment	2133	2133	1874	1	1	223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX48aSzTi3mcM3hSheYXe4vKoN9qCi2tdZVMVacHMiMDtFu46
20215	payment	1397	1397	1678	1	1	9055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xi5q68AZGdtXAuSgTYCDvuu7NZ5QZEBsgwo97PMMHfhnpczi
20216	payment	1397	1397	1678	1	1	9056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWusJR3oR7pevmM7wj82Ubftsu6fnW2TB9m4eCbWYNLQG7iu32
20217	payment	2133	2133	1874	1	1	226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8Q1e2oq7rzs4smEnVY65wrzZwdoZ7nYrRNpsZZSCuWw9foNV
20218	payment	2134	2134	1874	1	1	201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6E5KWs4tuucwxxCw5zLCKJPwh9XKBDZ7PDvFZXidEXuRQhpjM
20219	payment	2134	2134	1874	1	1	202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnxcphcwuKPuVtCzfFHknZDJMQjgwHt6J2wPTvswa2YW6kjwS
20221	payment	1397	1397	1678	1	1	9057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEN9DqrzmWx9xFNooq7C9NUZ2KG9EJ2WKmQXqyDUWPfU6bXFT
20222	payment	2134	2134	1874	1	1	203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvr5U6P2bX8BZ3NWLi33ocnQmz6mAFRh4pjFs5bXk7Qt4Qx94f
20223	payment	2133	2133	1874	1	1	228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcHjVTDrnCGJmwAT3vMp1m9gdfpXW6xb6qsJoErNbPusApn1v
20227	payment	1397	1397	1678	1	1	9059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBM5bqx6nHmmW8SuLLrbWdXUSRMRdCEt5YcEATopC9PArvnes
20228	payment	1397	1397	1678	1	1	9060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UB81Gavzn8nX47ScRLuf2yq45oZyQS11YstZU3KMLbSzWkET
20229	payment	2133	2133	1874	1	1	230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSqKuvmuyQDwDuB1tUYpCiSZFCCMDbvsop7ZQsYZR8WNJvtyf
20230	payment	2133	2133	1874	1	1	231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYHL3X41XQRF9eASDG1VjaJRLNUAC4EhVLsr3Mk3e9H81p4P8
20231	payment	2134	2134	1874	1	1	205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVC5cn2WHdZMmWurcsghaJ2arm9Hv7qP9fZGKM14qWzrqdNCL
20232	payment	2134	2134	1874	1	1	206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8CAjmtvHgMiHFBzEcrVfngsTBDuQPfpm8ur9gcEpkroSBqEg
20233	payment	1397	1397	1678	1	1	9061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvhEtjpWciXRhwAKFCvW5dzzGHjDHNvqdntLxebyEp42CxdeB
20234	payment	2134	2134	1874	1	1	207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiAxLKg1Ady7hzP7eMTyWtgShdD4bkctQZvwgTPpoZ2bJrcJ1
20235	payment	2133	2133	1874	1	1	232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhJ7Po4CLf2D4BMRNgczD8RJMY1498Ce3ZCPujH53qaHyuq7s
20238	payment	1397	1397	1678	1	1	9063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYpDKj7GCfsrc3yQuw6ZN8jBKz6PvdavdPQvFGqoHG9kxURWM
20239	payment	1397	1397	1678	1	1	9064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH6iKB5gJNK6WEfvK38MY7kc9Skk7Pg7KzWTKVhqdtXZtYbxy
20240	payment	1397	1397	1678	1	1	9065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5qxzFSsfSegg2hai7GHjxE5FStzYuSVAqnvpiT9G9nL9pSSi
20241	payment	2134	2134	1874	1	1	209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPaqMRqbgtqsGC6Qzb3Dq51H9FvimNubVD9wb4Ph5Fgw7n9CA
20242	payment	2134	2134	1874	1	1	210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8jaFKWDxcinGSmfHNrMq4x15NAUefu3CzczTthb5HsdJ2zuc
20243	payment	2133	2133	1874	1	1	233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNdXx8w7ZPcsasT6TWFRQjepqRCgBqfeK4ad25r8K1UQ7HHBV
20244	payment	2133	2133	1874	1	1	234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD4PxC8dgxUjQxKRR5qTcf78Nnk5pNtsiVRpnycCh7y5H7JMd
20245	payment	2133	2133	1874	1	1	235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWdtb3hz1VVQrAWQcBaHvXVaWwswSUxF3CAB29h7R8Jaykr369
20246	payment	2134	2134	1874	1	1	211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7y5nvzfepvcWLQezbQq7QriVQnz6LUpBWPvNfWfx3XJAebcq
20253	payment	1397	1397	1678	1	1	9068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKQUxjPbNhyCJFmExQ6Uxhawk9SfXRbU3nmDjQKDGVuktwLiy
20254	payment	2134	2134	1874	1	1	214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANjhp9PKHXpmXgPFgLgd1WBeMWQniR5Sn4AziHjB2XJG971Gd
20255	payment	2133	2133	1874	1	1	238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyL2H9FTrQcatiTVdcPZ2JCgtSKX4eCbSSixkWPmxPr4qZHTcj
20256	payment	1397	1397	1678	1	1	9069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9AMqEjh1oezmvkmBTZWrf1ofcwUBtmoUirSFprFioTFp8cXB
20257	payment	2134	2134	1874	1	1	215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRYy2toNYVZu5WEBLzKdS6wAAGfdvWkv5UsKUJoZsmZxVgsVa
20258	payment	2133	2133	1874	1	1	239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNVHreTBtHcAUKRfKEdauQdmiCMDEfJiUVuiXyo192NLCM5mK
20277	payment	1397	1397	1678	1	1	9076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmfQXbbKZUDBW4FeD9vMHYSCch2NFH68oV35YkHzyysqbA5qj4
20278	payment	1397	1397	1678	1	1	9077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY281GPUs78CAK9C14aFX2T6usxKLTH2GKVvw6ynG5CUbH8Z5
20279	payment	2133	2133	1874	1	1	246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMLSkeuoHuZv8tM17t6Gf7t3JLsXdo6MPuVaPvDeUSvEQ6xk7
20280	payment	2133	2133	1874	1	1	247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxX7deSGN8wfpmfZPc7rZ9itnCwBTV9f8KpQcKe9wshFPWkzJB
20281	payment	2134	2134	1874	1	1	222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxj6DuBborskvtb5MhJ43ngG9WvsuqBiVa6VtY6hMhNiJUn27q
20282	payment	2134	2134	1874	1	1	223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQhJfTcP39hEXEgxdLnvatAHg2z5dcaLhMz58PnoZdSqKgzxf
20292	payment	1397	1397	1678	1	1	9081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpT5xcVsD4wcph8CFcKzRLmMMuA78Z5zADr1Qdij92FcBaQHLy
20293	payment	2133	2133	1874	1	1	251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYk8oJ62nbVTWTtxaPytjthr4cHezndFrNCezEQA7s21efMJA
20294	payment	2134	2134	1874	1	1	227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAkmgmsMgAupJ4uMg9aM4TAqr9RNK5ueqMuG3NqRs7vYM7ep3
20304	payment	1397	1397	1678	1	1	9085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaELQYjdEXrtWrxhyrArmXRzc2a1TKUCkJvgwRVuNKXvRCHmFGd
20305	payment	2134	2134	1874	1	1	231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvktZpaumzSFFm5Kj2Wf9aNc9w4z5gvA7jCeyzB75VhU4Z7GKW
20306	payment	2133	2133	1874	1	1	255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTeUPVAjSsAs6vb2P9tYojCZCqMPZSUWMUfAAHhDkHngRhiCX
20313	payment	1397	1397	1678	1	1	9088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJL7K9KYmeQhtpa3gGSJnYu2BMPP5PGLFBdDxf8NsrEKh2S6Vi
20314	payment	2134	2134	1874	1	1	234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzgDP6VdonrEvxkAyBduXbxh4EsWok8FUBeLqeKNhj5LknNKg
20315	payment	2133	2133	1874	1	1	258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvSEdWdV5SfaEd2Kvnt9UJxCNxh1vLyZEVwfTG6e56ZhpQuqd
20338	payment	1397	1397	1678	1	1	9096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVkWME6o7S8ib8mAUHw2aMsQjsVkaCgtW5n3VtRb4pSmju3BF
20339	payment	2133	2133	1874	1	1	266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWkmQVcfhgdGwZoDMgaqrfdsPyofMxze6ckWRRLyGy9FkPfMp
20340	payment	2134	2134	1874	1	1	242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaqSL4HEX9w8VkWVE3oud1Ft4rodXhrkJb8KPexPJP3sFaKqL
20350	payment	1397	1397	1678	1	1	9100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdZTjW3NqGSRTJrGtKVt5SBjiHgrVFkvwfsssCh91jPRMSNjo
20351	payment	2133	2133	1874	1	1	270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQf2b2UhjzmzS1j989SPCwZ41zuwY25ALhwPZ24hF5962c4hw
20352	payment	2134	2134	1874	1	1	246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeH6SGXbtkHcv9c6Ub8UKxdppM2iiidGtQsgNfWNpYCjmNqM1
20362	payment	1397	1397	1678	1	1	9104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEa6JYfLjmncYZgoUV3U8ZE4nwqhi9up4kEjsPqesJzJEaEGn9
20363	payment	2134	2134	1874	1	1	250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnMRvBDFCeHyLqTpLAUBcnnnrvVj2uXJrj2miWUjbMk5JK1i8
20364	payment	2133	2133	1874	1	1	274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLc9WWCf3zdeFjYgrCrW58KwgDPZyCiUCDe1nYNanagQ1oSXW
20374	payment	1397	1397	1678	1	1	9108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjr5d2XVPTnM6dAXhEXcpoDoQmYswmrhohct28AYpei4xumXa
20375	payment	2134	2134	1874	1	1	254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYasiLKPFbfTnLysRc7KyVfwmVNH7WadPr1tMBkpXj3CyKHjBVF
20376	payment	2133	2133	1874	1	1	278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nHTmsVd7nUf5vXyWAnjB5yMJ4rjaTn3fg6SmJVgKPvPiqM9i
20383	payment	1397	1397	1678	1	1	9111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeBQpeAMSMW2Rum6cZcMCCU1JFF2uKH8YAuUZmkhJrw1PrxxL
20384	payment	1397	1397	1678	1	1	9112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPPBdhJvimSs1UjsAsg1T46xjbF77yMgUckXumCzqDxb3Kfi4
20385	payment	1397	1397	1678	1	1	9113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWq7mvNznrgk7q7VNifod7ftpmP8gzFjrwRhRF3XC77xZfHTzF
20386	payment	1726	1726	2139	1	1	8169	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzKq7CdEz4YmmT7QnJjn3j5Kz3NSZaBaVAJvfC6YkJ67Pkk3P9
20387	payment	2133	2133	1874	1	1	281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwh1i1PDF1GfWJVeFBthujr7TYY1nchHpLW9zahyf8dX2c2v9
20388	payment	2133	2133	1874	1	1	282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR6MefBEAt6DszU56GRkXGQuc1HnvGZwfFCE6nTQm9GKXWX24
20389	payment	2133	2133	1874	1	1	283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsxGi6uhvdP8PJcbTFCDSdbqxTbYfYbBoSw9yNmNc83X8QKUg
20390	payment	2134	2134	1874	1	1	257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVrXonq9JPt5rxxM3YqAXFncoE5GCQgcmepHJMm9PooQMGK9P7
20276	payment	2133	2133	1874	1	1	245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHB13UY37b78dMMQ7b6aCQ5QpPgX2ZuS8MHq7Pucrx11MS3xPD
20283	payment	1397	1397	1678	1	1	9078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRvPeqBTSXVX24M6a1isK8CQDsUej1xPr47Nc2wob2FmfGuH3k
20284	payment	2133	2133	1874	1	1	248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdJtShnJTN8shx1mKarAoimhqaXEKAxYPgdyhLe86DL15CZpz
20285	payment	2134	2134	1874	1	1	224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbuYCJJZipVxz4fVwAWHAiBpNSVRMbsDs7aSBxmkiaLDLKfXo
20307	payment	1397	1397	1678	1	1	9086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjnah1VgkP6HAf5CkUciH5ZsvZTXCyWWFh2zBfnfCNg7XKSoS
20308	payment	1397	1397	1678	1	1	9087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbLtQ7NxLeLBsNC4mmE1Ry5ZUtiBMKUaKTEiEYoX75fpNJgTJ
20309	payment	2133	2133	1874	1	1	256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhGDWvkDGc7WN63LvQRzAN69jt6jExDUGnQsigG6ZjNkRa4tU
20310	payment	2133	2133	1874	1	1	257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMZTgDtJCqErW8npaFJgdM8EZKRSLXynbiKofDuCnRhnmSWc9
20311	payment	2134	2134	1874	1	1	232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZndH13nzEzWpcFbvSHZibXb6hbd9EvB5wsaAzfF35QUYbBBBVE
20312	payment	2134	2134	1874	1	1	233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJsj6sKDVWrhim3TW7wLM3qGqShzdksCsnJd9tAm2epJNXpge
20319	payment	1397	1397	1678	1	1	9090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDAG7mW1SF8WKXS65ZtuQhoDabFpmMgERvri6D8d9pNBguiu8
20320	payment	2134	2134	1874	1	1	236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4vSzLw4nbYkpBnmfHaM3taxcFa6Rq2PSpsRD921k1QyEMnuE
20321	payment	2133	2133	1874	1	1	260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoUAN788neZ8z5gpormAECm8657PcD3wxhSgsn9M8v5tXmdgN
20322	payment	1397	1397	1678	1	1	9091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgnzM7k9XfCdGqrpCcvrvQPi9UoEjGYCQAgF2x3hPArA2EnsK
20323	payment	1397	1397	1678	1	1	9092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoa5AKacxtaf7a3VGzZkp5bjrJDxw43kJ6UySRTFpkJW4UQxjs
20324	payment	1397	1397	1678	1	1	9093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooaqpcWjWSVGUHDromVCLHL2w98BoWe2jwmPYKbe82AuHF4vZ
20325	payment	1397	1397	1678	1	1	9094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxeN1cLVuw8HNRn5MDkRk8jYKFGMM2XE9k4PB3kxcVszPP576
20326	payment	1397	1397	1678	1	1	9095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRvd3Ej7fAR4pepDV2hngcLNsP4wiUwL639Ke5XyaVBBcLkkP
20327	payment	2134	2134	1874	1	1	237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMtHEjZnMeL3zT8RBBadTcwRHAi1VGct4WY9e7SfwPM8UJQ9L
20328	payment	112	112	1821	1	1	4	186000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sjdwzdfUBHBECah7nA7E2mbxz3312CmZNRD25hXBRHDLqq82
20329	payment	2134	2134	1874	1	1	238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8Q9ZN6FgcG4jnvoSX92FwJS43JnapBgJTtYp4aTs4iVU8D5Q
20330	payment	2134	2134	1874	1	1	239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UVFCCG3e4PNeKU5EgY5WYGwAKHrE9cL3oCeLUV1DqKSk7YXm
20331	payment	2134	2134	1874	1	1	240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBodSva8pkDTxRsWXx1xXasqp7hbSoojfjMiEB9ZnzZdcYxKT
20332	payment	2134	2134	1874	1	1	241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvaTmstxNi8ArDdaR5DmqPju1PnMrttxXBLfxikQKaPbiX4vAv
20333	payment	2133	2133	1874	1	1	261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgGQ74vuqvQSBmUfMB45Moh6aDTyDrXPckQGUmfZpHsGZrXcq
20334	payment	2133	2133	1874	1	1	262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWjD3gWxnRRHeCxJiPqiJh9w447LCme8NsCx7tB9PDrnSE9y5
20335	payment	2133	2133	1874	1	1	263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxteWWtQn6TrJA4MV5RUnTPk9XbbRUjGHiiUhyvnU1uNRU5Au
20336	payment	2133	2133	1874	1	1	264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6SmywtXArQub2ebBeW1NkJ42UhmEgsdgMqzaSq1osnetVkHx
20337	payment	2133	2133	1874	1	1	265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZsUVQzLYjDDKnDVZgygjtSNHE3kGV7V34UXm218jNcMxZQ6A
20344	payment	1397	1397	1678	1	1	9098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJAsGCKe3q3NWJ2943zb36EMw3LU9DEn7ckcSViq1zjRsUHfR
20345	payment	1397	1397	1678	1	1	9099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwq67W4vTSiwxG85xScaunX5rCxyAeqemof6Na1Ub6q3BjQjgR
20346	payment	2134	2134	1874	1	1	244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcrMy4x2CtsMRYMMmxKanxwnoFq7PXRvgDZ57houa7gXwjVwV
20347	payment	2133	2133	1874	1	1	268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAzPyf2KgCUWVERcCrjN9RHrAexhYJKqMs3rRCMLu5y1rRzRn
20348	payment	2133	2133	1874	1	1	269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1SBiWdu3wnQ57d6cHRpkvmEUaFUhQUVLsKPHStSRXdDYpsCU
20349	payment	2134	2134	1874	1	1	245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLsqydCJMnjsjZvvyZTy1JR6cCULyYLbM8xs15v33LuaiaFDE
20356	payment	1397	1397	1678	1	1	9102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVgSYTUvgSorfrzsHJk7Q1NWMURo5iYJRpPrf3ZwA2R7R88nF
20357	payment	1397	1397	1678	1	1	9103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj4zyh1jQeaL8GDKsEVijExmVRULAX6dBnPE7psBeRZVyibL2
20358	payment	2134	2134	1874	1	1	248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzAtLRmD3o5QNR3TeZ95tFQmSBTUbwBSKEcRMD8FAYz6de7XA
20297	payment	2134	2134	1874	1	1	228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRyaM5aq7wo3gFhB9ihvifQHRKEeEnMSNvDr38iNRQ4KnPkXh
20371	payment	1397	1397	1678	1	1	9107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJm18Lj5aXGcSQayVNvtpL8UvD2YXYGnJXyaMZqqxGgz9CuP15
20372	payment	2134	2134	1874	1	1	253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypiTiy9ED5XqeDvMCoRcTRPULg9wfPVEF6hSySQ9WnHbnwmDn
20373	payment	2133	2133	1874	1	1	277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yw3jzqXQ5fHWWTze3mRS3rAkU4qMHVhJaJ9JJ5mNEFRpN4N3
20445	payment	1397	1397	1678	1	1	9130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4TUcZZAZQxKFX89DtYknGKi5CF8RjByUpkbajphkJPN79sT1
20446	payment	2134	2134	1874	1	1	275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8VpNp7o2spYvXC5Mp655V91sh29aVQk5XCdpGzAip1g1ikwS
20447	payment	2133	2133	1874	1	1	299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ApqZY5VHS9c23pjghyVf6iFnYpQEgmP6ANvSWA8QrXXNcyhH
20475	payment	1397	1397	1678	1	1	9139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzQ7cLnFgmqbseqBvHjtDKunwXSKDVLRLBCfazvhjCPKD5sdM
20476	payment	2133	2133	1874	1	1	308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsyUnR1qPQBk38Y4soLgM1wdMrqUxoHgQfH6EZL9VVirDMerN
20477	payment	2134	2134	1874	1	1	284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3NZcdYRhajiBpF2bwrQntVe2QxDemxBCAbwhM6ziGg2tqr8b
20499	payment	2133	2133	1874	1	1	314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7q8iYu7r4Y6tSrWgU5UGQcBegAESeZkQSxCJ69G4SHfCpGA6
20500	payment	2133	2133	1874	1	1	315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sQ9NqdqeRG4KtjxzYRiQGEJ3oztRhkAkWD3MPbGZeubjVypg
20511	payment	1397	1397	1678	1	1	9150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4ahmaKKnB7Xn1rp63vzb26d6SfbQpx5qPePFFfQNcjyimS4u
20512	payment	2133	2133	1874	1	1	319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BLHwM4gX3kNanRR85kM6XGNxLgug8uk9B8eHxwMTZHnMzsAx
20513	payment	2134	2134	1874	1	1	295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAWdv5kbyB49RTPDFbpCtsZp9gaq1k7qzYeiWXKLR6jHjCu7F
20528	payment	1397	1397	1678	1	1	9155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKiaY6BQYYhGyxX7ADg1NVfAyMHddyqjrBSip5QvEe4UMPtD6
20529	payment	2133	2133	1874	1	1	324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyxAbJQgecz8Mb5RYWa6yejtHueHHyajmZoFpi8c4c93EDsYk
20530	payment	2134	2134	1874	1	1	300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR43Uz47fJrggyuXeqntZurHBwNbjPKgpNiAfJ4MRJifcz4eha
20556	payment	2133	2133	1874	1	1	331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuwaBXbnHGzbop84SFU66y53P4d93dAthRTgwSD1ks9VhfRH1
20557	payment	2133	2133	1874	1	1	332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAErFfzqeZcu33HWDuuBLiPVpYPZQ4KQftqH9w8GBBAbNRUYH
20578	payment	1397	1397	1678	1	1	9170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfuh8XttRU5RsQTw9gFi49d9CmHwbkdDDV41jTFvqYz7Eijts
20579	payment	2134	2134	1874	1	1	315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsgxbqTqd1Qqf3AXKVpt6JGnyXnMB4K1kaSBhfax513c9JKiX
20580	payment	2133	2133	1874	1	1	338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ33Z7hrJUfUhCrnVi7G8UsZRTKK7SJw4rgYegcL3nM6YnfVz5
20612	payment	1397	1397	1678	1	1	9180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnahWxq786AxF7bMUFX8X8mz3R3QKZ5BCRXh44HraW8qHyu77
20613	payment	1397	1397	1678	1	1	9181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9mhQm1jMvtsNkCocJq5PXzzZ6g2WVx7y3BswrdR34bUiRZ8L
20614	payment	2133	2133	1874	1	1	349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oKpQ4pMKd3qqzgYKBP2PtLpdNQ4skoXpehQRuEjRVEy5WyrD
20615	payment	2132	2132	1874	1	1	80	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvubpedQKdeSm2fox6qKzRDbX7S8xvZp49h4XSXxxNn7ntKXn
20616	payment	2133	2133	1874	1	1	350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1eW5d3s2FLPZhbLtm6vQQQHGvm2JDY3Mox1PL6UR125jSYUT
20617	payment	2134	2134	1874	1	1	325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8Q17TUQfR7Fg745UKJbrAtuzTJpKUdFXGhQqxg7nPnp1tmTE
20618	payment	2134	2134	1874	1	1	326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahw6eZrFCJGHmzYzBWtcqM8aHnoujJiVH2TXJSEVo6w5CohU1
20626	payment	1397	1397	1678	1	1	9184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBxLJakGuxua91HtKKw13exVAXsTPD8VMuBtGT1iLsCSijgGR
20627	payment	1397	1397	1678	1	1	9185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52yvx6YUzZ4Faif8P6xAPz88963YRCDDZpDKBDXYvLj7bNvoZ
20628	payment	2134	2134	1874	1	1	329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ287T3Sip2uzsu9DMzW5WJnQ6gqPHMNFGNNMD2woe4moU2bBC8
20629	payment	2134	2134	1874	1	1	330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSLSH5qkKKht1RbAL9atCZ2hgNGy5ZbvHjKqJwWL65EyMPpbg
20630	payment	2133	2133	1874	1	1	353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiHF5r2vdrzPjN6cdJtdt9SM3WHy8icca5BAvGo7tY6KGRLyU
20631	payment	2133	2133	1874	1	1	354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwokrTCv6vJuPoFBg8xyZ26Qmgx5kKHSFpBiAk7JT4e6yV8ht
20655	payment	1397	1397	1678	1	1	9193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nNYoLjSJjD4U4P9GsTKAvBpenGUgiiNuRrUjPgsBSQkZufcu
20656	payment	2132	2132	1874	1	1	84	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SBPqtWfez5biM1rRLygFtvXL5yrmErtQ2ihyzLCH2USmso9D
20343	payment	2133	2133	1874	1	1	267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS3nVqFaW2ymLT88wpSNokMKSzh4xVJyw9JbWigpuhddo4BUw
20353	payment	1397	1397	1678	1	1	9101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbq48KqCUZEFDL3xphmRNRXe5mnDuHdKSCwiDsJkP9JYN4gAv
20354	payment	2133	2133	1874	1	1	271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTa9oAEaV1vUJJNAJGDotAFR3P8dKNUcNNdwUMqfn3bCDu4Pu
20355	payment	2134	2134	1874	1	1	247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQswNUJaZFfYskYRua1XMtaJxTUcybnjYuEa59x5gyDbeXMF2h
20365	payment	1397	1397	1678	1	1	9105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xSP26o8bv5CzM3vq3KpmKa2cmjb7qqG9wP7ZK7kBsv6KbKd8
20366	payment	2134	2134	1874	1	1	251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohTZuZDRR9YUq5jBoWniM6sXtUj7aSbbTpgRtC8J2Qta2ugdf
20367	payment	2133	2133	1874	1	1	275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5DLq2ovZeMXNaf8G1CazTQSkJZQLS16JPeEtZCPe3oGnjXEB
20377	payment	1397	1397	1678	1	1	9109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzq6G9LScc84d5JbUnTDgPQKXiocAQheFvvrTmGSdUmATHHtP
20378	payment	2134	2134	1874	1	1	255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQBhD4uxLoaM6bWXR5uZbgHT657rMjy4PEycHpsEFwWqWF3LY
20379	payment	2133	2133	1874	1	1	279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bjRDnqwnpV8dJKnGKf2VbCPvfs1AzGN9i5BLWRtqRnX9BvaV
20393	payment	1397	1397	1678	1	1	9114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qDGCtCUhPCuGBwKWPPBs2BQmXsDiR3m393ra4fZdkqm3gbBa
20394	payment	1397	1397	1678	1	1	9115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSwgd8k7C6JpeQPiVpGefQ7qz459G2V6HEpybxvcUYFCrn1MY
20395	payment	1397	1397	1678	1	1	9116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXaGwSWg9193YD8eoNNrNRyNg73VYLZfqESY522Crcaowrt2T
20396	payment	2132	2132	1874	1	1	60	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhdHDkfvF3Qw56hcX53VYLyWqAKb4BxbNC1L7mxtBVa12VrBt
20397	payment	2134	2134	1874	1	1	259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXt3uZ9b1duUHs6qVXspQ2jncuXiPoao87bLhcZTNeABVY77CY
20398	payment	2134	2134	1874	1	1	260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rCREEMagpJHXXL4pLUrUtMvvWccaEtc1ozqBDyzpqkY1xJF1
20399	payment	2134	2134	1874	1	1	261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVUTcDCeXMKuNL3cnDDP8wfVJk5TDspjazbNZesPCCKeRQiJY
20400	payment	2133	2133	1874	1	1	284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHUCspXrJQcGg6FoKzDseRJwV9DGtDpQmmtdFAwB6NcE5zdz6
20401	payment	2133	2133	1874	1	1	285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxALiGAiQkmPCjTvRTVrfAHRrHdTwfwvXDxLujnvjLPQoUjRB
20455	payment	1397	1397	1678	1	1	9133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAipCUFmBEQJ63Qm4aXZ5yooyiK583QYZ8RKD3fhfSEKZKdozX
20456	payment	2133	2133	1874	1	1	302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvy1sri36qeUJyWEPd87mP1uS11QR1MVyzg4tht6i9TkuuRSyn
20457	payment	2134	2134	1874	1	1	278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoadKjdpgXqHAqaLsajPFJvNBpBgyr4xHHhVYUbcxGuS6fYU2n
20518	payment	1397	1397	1678	1	1	9152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG412ir56K5kSHUWZ6bck7GFqdZBWEUuYRWgdckD3iP56UQr6K
20519	payment	2134	2134	1874	1	1	297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoR2XVbzmyzj2bzhoPCV8AVCSp4wFNhvKRJssA7kw3vZTQBgeT
20520	payment	2133	2133	1874	1	1	321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTg9eQLnAcf5aM68ny1pnXLXFwpEmvSpABdwQmREJNVSoeq4p
20531	payment	1397	1397	1678	1	1	9156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1tpEpWZtrSNo47zar5X6grKKNBnPRRgQf59iirX8YzETS4v8
20532	payment	1397	1397	1678	1	1	9157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbS96NWc8xSzWNCeRSLr9vPGHo3rsB9F2Z3qpjFyXnZ8QSD61
20533	payment	2134	2134	1874	1	1	301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1meWZBLRt8ytLrmQdvAAAT983cbVk8q99ytu3uQbwEoAyNLST
20534	payment	2134	2134	1874	1	1	302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17USSJAVMPn1uqBKUXKSVTFW8uXDddaU9yEJvW2ewoG27dFVd
20535	payment	2133	2133	1874	1	1	325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPrrbRfZ5MqY6pGagvHdSuDN11ccDdW4kS88A1J17DzNw62Ng
20536	payment	2133	2133	1874	1	1	326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHazZK1YAYmp3uW3br4qUndMeT6ENtjLk8qX8GXxUensDtDN1
20541	payment	1397	1397	1678	1	1	9159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ58yB4inwFySm3jmDcLBw9NBtzBYYWuB7UbtigykuX4WBVx2
20542	payment	1397	1397	1678	1	1	9160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjsi2EJbTq5daHitDJVcURCjKfCMF4JZz15FUdM6Cr33sMjtL
20543	payment	1749	1749	1950	1	1	15	1500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZava1BtMsvYqgjwDGLf37kj9pZC1N33Xs8TKCbaB2YL8mkuweZ
20544	payment	2133	2133	1874	1	1	328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLaxy2JrjtVRPzG2ZienDXYRpBmZKcRMPAPpR2nyDrahrpDtA
20545	payment	2133	2133	1874	1	1	329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoGPSa1EceccomxMXkwvcAUUsf2m8SpUKmPyao1aeMoHV39Bt
20546	payment	2134	2134	1874	1	1	304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgztrfuStW1mEJTUFPidWVX3F9vzj5XCeTyKeBVsc8Ec7EWrsd
20547	payment	2134	2134	1874	1	1	305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vzuYsWpG3CRqHGk8S544Xmq6zGVkNUuEsRaY8Bh6ke4XiDKr
20359	payment	2134	2134	1874	1	1	249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxH5SDjBrnDKNcmdK19nCHvR6QG5NXyWvNXokHFfiYZQfxB1C
20360	payment	2133	2133	1874	1	1	272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHJMB1ssdYaWTyYbR9jy6razHtPXyGGTRTZ9yRZVPFCAP4fJN
20361	payment	2133	2133	1874	1	1	273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACbumf1tHuAtuLhw9GVi3p9RYc4npqRRAt7HZTDLffhdVqEAQ
20368	payment	1397	1397	1678	1	1	9106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9muoXRHiJxSDeT8xjawpegFsGwgzCcB5AYYwEkkQogV4P8Fjr
20369	payment	2134	2134	1874	1	1	252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGfyuSkJkoeuDBaZugwHe7vEdZ6ouFSdt3BWyBToU2gzHVk3Y
20370	payment	2133	2133	1874	1	1	276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3JXQN3GQkeTvvyFp3MD6gxPC8zUdxNdh5qYefGCEEkax49Ly
20380	payment	1397	1397	1678	1	1	9110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqajQkJQ2Hex17L8UiHgA34ZH3HfURHT58nwrRqXVzzFRDqoW
20381	payment	2134	2134	1874	1	1	256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEUuuWAmxSurmJe98gK6N7RsLthCYtbCaV7iUAPiGvS2uCr3d
20382	payment	2133	2133	1874	1	1	280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvFnEkJ1oJhd5Q8hF94SJZ16qT1zGurGSGq4Vi3hgdEaZDQP3
20405	payment	1397	1397	1678	1	1	9118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijGvXrHenWrLsr2WAZCgCpKFefqs2xgCzEGZsJ9GdrSGrzbaB
20406	payment	2134	2134	1874	1	1	263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHoT66c5JHWTy9WPQxEAHrN3bBdkZ4VzWM5hqkDnNF8qsdUCL
20407	payment	2132	2132	1874	1	1	61	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpW6wEDsJtoQ6h2jSez5kNiS4yp2KzUWda2UZ9ALqGV4s8iM9u
20408	payment	2133	2133	1874	1	1	287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybpyGFgJno87Ct743Dn9rvyMaNbTmRmhpt7T9Q7npVjjx2jUB
20419	payment	1397	1397	1678	1	1	9122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpojp5f72g4UZEnNHW7gogJ67Y3AYh2f9eDGLVpVGi1nwCeELD
20420	payment	2133	2133	1874	1	1	291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAyxj8Gon9GbY51M848ygqzY5J2YBfhNbMp5zYqXgLFLi3KLi
20421	payment	2134	2134	1874	1	1	267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63DfY9gQ7tcpkuQtvT1d2YNppLGSWdhEkxVTXd53hbptR5Wyb
20422	payment	1397	1397	1678	1	1	9123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmmSyRWeDq6CxZpzFfq1i7YXjXrLTtcCjXq8E6HB3gayrCiTY
20423	payment	1397	1397	1678	1	1	9124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrMEroKunHVDqyQmmwceCmA9qNtsBkGLyeq3kPbeiDHwgmd92
20424	payment	1397	1397	1678	1	1	9125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAXXakiHo7QnNCVp8sV6e3RQ9oq7dhZRdPdoQj8zTZjGofQn8
20425	payment	1397	1397	1678	1	1	9126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4j5bddytHMiU3KycaKDCRfywH8suifNsy6XyQ5aGGxF5dUVX
20426	payment	1397	1397	1678	1	1	9127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc2UZinxGoqrZ45MJnoDsAbNDFQwjJaHmon2kLpcA7ZvxcBwp
20427	payment	2134	2134	1874	1	1	268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRDbJx35GLPhuSYPfNWAXVtSm7dqnNNX1aMXBBSR9N599srXf
20428	payment	2134	2134	1874	1	1	269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HngE6A4YcSvCaV8cNr9PsHV6bJtaHXwrcTp8kLYr7xpGTfcM
20429	payment	2134	2134	1874	1	1	270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai8xM3UziMRSHrFrDysVP4RPKJJAsFUi5Bm2rFNeyKtvEjC9r
20430	payment	2133	2133	1874	1	1	292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHtYBegP2PnP3J1mCAQRNJRgCJMG95v9DyMGQDy9B67kgFXne
20431	payment	2133	2133	1874	1	1	293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfpDK3pfWuWVAikt5SmLsSX7KGGg5Xu2Qji5cFJZjxR1ECSrw
20432	payment	2133	2133	1874	1	1	294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6qsussNar7pk2ZsGPoiVuK1VTyJrdreMzzUn7NKMfvqSzXR5
20433	payment	2133	2133	1874	1	1	295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurdbSxwLZvZ9cZEJofbme5dmWTqRJSsCueDTaPXWy8vEfeC75
20434	payment	2133	2133	1874	1	1	296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFAcZKbcnCSJeeg8Lk26DTfYXNq4NY1RgZCmq5tkRZbtcnudW
20435	payment	2132	2132	1874	1	1	63	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2EnRhD6ruWibZnYjxrBza3BKJ4tVz6iLDga8mhMbHyyB6D1z8
20436	payment	2134	2134	1874	1	1	271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bkfEV3ewqX6V6nxCfeb7KEGbVTiVuZDKhnQzZyAGrpDz39r7
20437	payment	2134	2134	1874	1	1	272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjzTeQdqPpNrpin2Y3KrmRzjPz3gsLmxibZqSuM86TFMwBUtG
20448	payment	1397	1397	1678	1	1	9131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSv5uJgUbYWSFx2aFraRqMnvV2XSBXJ1SuRgTfx9Yp4WkhRykz
20449	payment	2132	2132	1874	1	1	65	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZCWvTDHNrthjmpiVGyAZ5qMBHXbstvtQ9pe8ThZy4KBv8KT3X
20450	payment	2134	2134	1874	1	1	276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo85VeZma5AD9Tn6HDGoR9gr85fQVLfjv1v7SBjwhHyaewakC7
20451	payment	2133	2133	1874	1	1	300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuiJRT8x728kqaeSaD9Dwr8NNoB4mY2tdfmSTghTWBTdsTExb
20458	payment	1397	1397	1678	1	1	9134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFHkKjMpfAyYYkzMaQck9ABvnycpNHnUSDVLzxta7U4vXtvcq
20459	payment	2133	2133	1874	1	1	303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfL5wKrT7N2R68DsLQNtvcKaWWvDTiM7Tg11RLkWbCJoSa6iT
20391	payment	2132	2132	1874	1	1	59	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9zVKXzH2CATBmwPomK1Hu4dbsvXQRbuPy81wZzpqHsyEPaL2
20392	payment	2134	2134	1874	1	1	258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NQ3bb8UoMMoX7zVGX9zNK1FCHPFgSw5XQFkFAGXTfogNF5EA
20402	payment	1397	1397	1678	1	1	9117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzG2HpPE7bi3RJU8TXmhCiArDZTmvoJBUxr3fc6oi3fiPukz8s
20403	payment	2133	2133	1874	1	1	286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvg71T44AArLUk6F1WGvBGmfEoaS5UjHz9vtyesY6VME9JntE
20404	payment	2134	2134	1874	1	1	262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHB1Sp839hDCDkrnxzpXWAUtS5y23zAa9pVCQrmwxU3ohpsMB
20409	payment	1397	1397	1678	1	1	9119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHoSxMspcZhSJYCdDdmQBctXTwTexBf4AqcsGYdmgHmqGMNyV
20410	payment	1397	1397	1678	1	1	9120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFzQRbNX3bYAQ3uZnvgc32XNGAwkKEyUJ9eGmg4mQ88fFfHDL
20411	payment	1397	1397	1678	1	1	9121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqHN77inRT7W1ggFA489fmxmMqejYN2sSYwFPcWGSysnhmsRj
20412	payment	2132	2132	1874	1	1	62	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JB4g687bp4HfAE5n3nPjiueYfPyEgKW6NRi4mQUnpaX2ZvHL
20413	payment	2134	2134	1874	1	1	264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGan98Wa6fTopHqCTg4cMajqVpvURUgzHQxLraKQ5Hmu8UZEQH
20414	payment	2134	2134	1874	1	1	265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKDtFEmynEKH8KGKLUtPL1ddtMVfEaGZLipVbfDdSUKgGmdTU
20415	payment	2133	2133	1874	1	1	288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ow6vRLzksQW46ZXtzC3c5ewqropdY7pi7rX9deX2diZyotXo
20416	payment	2133	2133	1874	1	1	289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7wWx16gHewfuzgA3U6zULXuSAkvhUMo1nTtzYAC2mLRiGqAm
20417	payment	2134	2134	1874	1	1	266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bkdMrp5WFN5mtF2MR3T8tiPM4SrZRkWsSKhGWRdY1ufUv5e6
20418	payment	2133	2133	1874	1	1	290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeFYUcARfVvGv72dw1kJgAubgzjwQ95YvUU8Grqd3tTGEzthy
20438	payment	1397	1397	1678	1	1	9128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdhwHctPor4L5sq2HSfPro2bpA7GNtuTKytK3stSuGq1KwaZP
20439	payment	2134	2134	1874	1	1	273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpspiyojJYUEkBB1aroxhAajxcv9kT64XDU3rH7RFN7Xvr1sa2
20440	payment	2133	2133	1874	1	1	297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHJSBNnun6fLSEevQ1FHYavkMWxpjRZDhPVhSQzRCKSSqckoL
20441	payment	2132	2132	1874	1	1	64	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLWTkoUp7EceDCNv1JrL2jqqkhJFvapC3E6b4LUEGNW1yudeT
20442	payment	1397	1397	1678	1	1	9129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUn9bFGY7JPh7ffHsyaCF5Vy7xeBXcHCycWcrrAmd6gP55ve2J
20443	payment	2134	2134	1874	1	1	274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDA6k3sKZDMNs7hBdBBh5UqW6hgBLLv1HPQzkGofQYu7Bwyc5H
20444	payment	2133	2133	1874	1	1	298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXbkJPQ76Benffen1aUbkBNHGKLjwAt1S5Xzz7gasrboWH4Be
20452	payment	1397	1397	1678	1	1	9132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7995fvzoeugnUw166w1zppyeq8csjimCqsgfPj1TSb822mM5B
20453	payment	2133	2133	1874	1	1	301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pLhj1rLueRYh1LdLZbgRPtuBGkYfzrURPvFV2zM3xii5GqMy
20454	payment	2134	2134	1874	1	1	277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYpduz8qBZLZYbYJfPyyppnLWG3EoZhhYKTFeqqzSB69tpqGi
20462	payment	1397	1397	1678	1	1	9135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhXLbEnXPvsmSiaY8zf4hycWSUD8biPiCqwqd9ngRToNPHhyp
20463	payment	1397	1397	1678	1	1	9136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BzT85UrAbixiAsksRoteFYEGfXR3tDEj3JSMBA1qXobVRQiG
20464	payment	1397	1397	1678	1	1	9137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLEA3LUW4KwN3w4tpEbnNDHQvLHTUYrfAcPzZcsxx7xjxA2dX
20465	payment	2133	2133	1874	1	1	304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eTf7BCW4DBNAv1cgGc1wQ47iCCv6KtZiMzo6CK5N7XyqC3Dt
20466	payment	2134	2134	1874	1	1	280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFA1LL3erGvd3KWVWqYgTqrRFLNDTFHhThMtEupnSPLUGHwE1s
20467	payment	2133	2133	1874	1	1	305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvb13UbSoVHiBCWi3sXm95TAjv6B6ecDgMede8yoaUAuWZZ9fZ
20468	payment	2133	2133	1874	1	1	306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfCzDvkNEU3Hzv332PfwbALXRLjy4dWBmURE1hGzigLk5vggv
20469	payment	2134	2134	1874	1	1	281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDefmHEwaDDhoqqFtb7VaUHsbz5e3ymhrSQwvFRiXevmUQa1mC
20470	payment	2134	2134	1874	1	1	282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBs1GhdnS3KXyzCvkp2a5Zybagf72gHNQc6x5WWwVTqHDs2bU
20478	payment	1397	1397	1678	1	1	9140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ428LMpYV2kpeCXrsppWQzuhiC6F6tqWa9hemSnKVUMsQjSxDD
20479	payment	1397	1397	1678	1	1	9141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BVfjCzWkxWrKEP44wLDgjdDExdFpQatsfsALwCyPk5PY14qg
20480	payment	2132	2132	1874	1	1	68	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2bEaTBfZXuiuY4jho6hxXiuF9yXRh5WLFKhRuaoy9qdPUKib
20481	payment	2133	2133	1874	1	1	309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmc9GXd7DSWzNMMaZ9Cy8rjLDGB3Ybto6FYf7cdzQAvXjpsm8J
20460	payment	2132	2132	1874	1	1	66	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56zyZJVP1aanqCRRjGKdUKpgKLheY7po3McXhPEAMrqES31Ag
20461	payment	2134	2134	1874	1	1	279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6o8fc1nxex9SrJ7oCQ8ZzvWChNGDedebMWknMT5P7VY2xRKvj
20471	payment	1397	1397	1678	1	1	9138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2X7xQVk1wXCAusoVrWbZBudtgLKipkLxvcRV9FkQes8H1haf
20472	payment	2133	2133	1874	1	1	307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaRQ8RaqYixg7SwZx2ZeaogGhGqrgn9fqBEMm7ydytrZnjjpZ
20473	payment	2134	2134	1874	1	1	283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzmyhrfk24ZS2v7qwbTH4USgxP46Rg5VW9YojcZMLYSkaNJZz
20474	payment	2132	2132	1874	1	1	67	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabP5Pf1SNWzWMZfHMmDpAd1H97PZtbS8cg1YcUHmPycZpb4ph
20485	payment	1397	1397	1678	1	1	9142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaABbH5RJe4XeJvu5PHR4im8AfEoSmqMfdBRR6a6u34qYKP32
20486	payment	2133	2133	1874	1	1	311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJAkN7gxmTf1aWPQcn9vkUcJbky2VhjoAALai4xaPVDxQ69Xb
20487	payment	2134	2134	1874	1	1	287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fWKguUZBeD3y5jZvQH4sqVQ81zDH1jujcGZiWoPKknqRjqSB
20495	payment	1397	1397	1678	1	1	9145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Bub5wWYYJcfCik1fQro9HkPWUeqpsxvV6HZLBAGhtJ2yNMMj
20496	payment	1397	1397	1678	1	1	9146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMcP93G8MbAP9i4mpKfrZRUF3bUBKS99uNLGA2VSQ8HWN3hHP
20497	payment	2134	2134	1874	1	1	290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopgNc9AmJJTRVUhJXaX8bVy6Bq1xqkGU8EqmgkznrXEUgJyad
20498	payment	2134	2134	1874	1	1	291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBrkiZfYJcGq537rj9iCcdSQ4J25JvxwchZXccMC8wNMeFhS9
20501	payment	1397	1397	1678	1	1	9147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfn7fVp25bQS6Zuqt2FpDXgndkYuffaWLFgTjEVxAJh7UeHZg
20502	payment	2133	2133	1874	1	1	316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGCpq4yUNpERweWBvRz5GBMSJeGJEAncX9P4hPrfSZshSNj5Y
20503	payment	2134	2134	1874	1	1	292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpziSW1m6pdPhM3zrxwVekqgZhVMoKxoGKWVfoZXZJKUm8CqLX
20514	payment	1397	1397	1678	1	1	9151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHrNr9q3pyuJEgqQf7EX2LDHyTuP1kX3PMJZosVzcnxgsp12i
20515	payment	2134	2134	1874	1	1	296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX54BooChvJ4cCuF8VfXJqwH4ybX8CpizPzFUA83mceH2P1yby
20516	payment	2133	2133	1874	1	1	320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCWa3cAayrpQp7ps7NSeGGbPxqffozuef5yhy2DjSh2CnAiTG
20517	payment	2132	2132	1874	1	1	71	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewngTqXkBLPHbwm5srkgEq5rpJQr4w7o1apCUxA1N5s6dLEf4
20524	payment	1397	1397	1678	1	1	9154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLFaCg2g6FcNnu1dWSTn1SmZENDcydNAALXefVCaN5Lp18Yid
20525	payment	2133	2133	1874	1	1	323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE2jxDebQy41P7N29hznCCWc7x8i3ocSFUj2gPrsU9Pn5wZHb
20526	payment	2134	2134	1874	1	1	299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKZCzjmtA9kb4FKT15bVNSr7B7ANGGkbjKyh7f7mVyNTB9WFE
20527	payment	2132	2132	1874	1	1	72	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBv6vHqvvRW4JrpNXN3hoa1Gq5mDu6C9GvK1TEBwZvRQR72q5
20537	payment	1397	1397	1678	1	1	9158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxMdjgG99GuPmKVRgg7J3qQRH3tM4kK2wvcsqtzA5VQPgbtzV
20538	payment	2133	2133	1874	1	1	327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSLXpg1D9JMPWVm5JcjY1YFUBFfJw58fkJjDveF4vTTnbBsST
20539	payment	2132	2132	1874	1	1	73	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Cp9Cb1J6s7H1N882ZRTireYrHFdiCsSicgwMK9KG8oiqJ6wt
20540	payment	2134	2134	1874	1	1	303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYAUiFv4fMcuB25kbNqv7BHbSsda8jYi3a29xwTj7zrw9nH7M
20552	payment	1397	1397	1678	1	1	9162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjDJvxty7zSeJuoMD5wWPu2EfacUs5MY5P3H4Mkoj58KxRPor
20553	payment	1397	1397	1678	1	1	9163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxff4uzXgWk4sMCRzEVh1KPZYt77wHuQEHF8LafG5A528FddX
20554	payment	2134	2134	1874	1	1	307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPbdwE3YaXtzisu4DqeQMRpEMmgo8qquMtE9DqcNV2As9By3o
20555	payment	2134	2134	1874	1	1	308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1wEWCtrQ7XCw2xa5dqWmfwym2ReqVRG5sp4oSK6yDNPE41km
20562	payment	1397	1397	1678	1	1	9165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5wN6uSgCFrCVrVdU5DooASxvCxbJLJnSLQNmbFD8CKAbCYFJ
20563	payment	1397	1397	1678	1	1	9166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgVmEfBkz61KX9YNjviz2nchc8tLdxDEaZ8VyeUwMQwhCM7av
20564	payment	1749	1749	1950	1	1	16	1500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYPx1a7zjirgqghSgr8jzgJg7Yxu9orBhomgmnK1jZH9xVfRX
20565	payment	2133	2133	1874	1	1	334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa3bv2T5ZDQfA4DtQpAisTnYJv76uYhT6BemJ7Xe1K11WmXak
20566	payment	2133	2133	1874	1	1	335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqsKn94f89ofHgS4zv274NEHNHrGvTrtAKQ6EMuSTFV6TMotr
20567	payment	2134	2134	1874	1	1	310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbdY2YZVCSMREjbgmahu7cRw4pwJud2FoPh5Vg5ygH2eafJyJ
20482	payment	2133	2133	1874	1	1	310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihL9vFk7e7XrcJzTmVrMeoo1FR4RSAk79T19RKFm73VosWAdP
20483	payment	2134	2134	1874	1	1	285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqgZnWc7XwjtN9k1ME5sMB7WdiY2Tx1pbdLE5RFz71j4sCZiy
20484	payment	2134	2134	1874	1	1	286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNdmVcHT8Yej1a8dCmZYjGQB7kiRASwFsKtUEPZKjMDGhhSdy
20488	payment	1397	1397	1678	1	1	9143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFS271j3VvBgFa7ToXkuyaBCdogds3eUf2qpKezAhGaSWcdD4t
20489	payment	1397	1397	1678	1	1	9144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VAozp6iKuWpPUa9hptkAoMSkrq6FTUeuZhn7F1uYx5sanPwc
20490	payment	2133	2133	1874	1	1	312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaNMfQ5YKsduiy66in52QmJ1ZEvaD1u5NJEqzpPmwZM8AXNcL
20491	payment	2134	2134	1874	1	1	288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2yWyvxPCbHJynLdzDS92JXWYZjhekuaqqQmZnnCSa9MNLHjs
20492	payment	2132	2132	1874	1	1	69	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBm9cSA1D4Fbc4yX9hpHVDZzNVSWq5DfZQDvpxK3fiyJ35n4M
20493	payment	2133	2133	1874	1	1	313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZj6F4qkNR2yxG46diDnJEKivp6vmWgMN6v2weJTCXSHApXRy
20494	payment	2134	2134	1874	1	1	289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFHGbhXaRpUSGeYd37A3Lxpu7rtJVu7fEDwvmCBkaZQk8b178
20504	payment	1397	1397	1678	1	1	9148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g9FzQZxfic681njd2f1qrK3We6MmzYcXgjiwGFSnfXkETcTi
20505	payment	2134	2134	1874	1	1	293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65iPm7BUd4RaSEYgJ2qdtnxq8AAiKiN1jyN8v8oPtxRmmMb4v
20506	payment	2132	2132	1874	1	1	70	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa78TrKX4QvyzoAMWupPPgHz7Wcm1m3ukFtxcb2c85JqTUu1j1
20507	payment	2133	2133	1874	1	1	317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiio2LbhieoL1sNBrmizWBmptLCJGxVxcJxxozcveDuZzoGC2e
20508	payment	1397	1397	1678	1	1	9149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSZihPrX6t5qNbWMGjGTbmwBbvzsUbTaQgma9qCpFn7zAmwup
20509	payment	2133	2133	1874	1	1	318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPM9Buu6ym3YmMuzBXNE38qdQhmrm6VWsbUsSa7cVdQ6PzzJz
20510	payment	2134	2134	1874	1	1	294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa656QJM6jAyLTq253gfSpXpmmu675AsG75FEqecHUa2CP4jSS7
20521	payment	1397	1397	1678	1	1	9153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMEXRGov5jg4oVFiqna9XsZSRGpvY7gSbGPT4UeVpAnxevb8r
20522	payment	2133	2133	1874	1	1	322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw37cj1jrXpFuMEb1M26YogUuikdiCEVSwPbSuzm3qMAW5dChf
20523	payment	2134	2134	1874	1	1	298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwomxzxRXus3FyjAhvaVYSczU5wTBrxaRDw3miTVd22Y1B1N3
20569	payment	1397	1397	1678	1	1	9167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggP3M5SsfBvRb5fhAkYbXLyL7Nvky2coKVWwpK2uXr1We7TX5
20570	payment	1397	1397	1678	1	1	9168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyAdLbz92Uu2A4kXdbVJZySD6x2QG6yMjaN9ps11ztNd5xq38
20571	payment	2133	2133	1874	1	1	336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUUEuDuWdx7jPqUUrDupphftXKCBmrPPM39dpCsFai6L1ANtC
20572	payment	2132	2132	1874	1	1	76	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBUEwenj7UTy6DFs7A2o9QR4bGXeUXAs1ytmwNv61gW8w2BxV
20573	payment	2134	2134	1874	1	1	312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4UHVqtu1uomT4Qqq5rNNyqTMk58LoMngnkYTmn1CxdwXFfiV
20574	payment	2134	2134	1874	1	1	313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNxaQmci7tpQjpeDfb77L6ddtJqZ6WBWux5jddz2ubYTMcKG4
20575	payment	2133	2133	1874	1	1	337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jLndja8rvNPgzZrG6qWKbkJMPBmnJmZF7UqikQHJ1ZEH5SNG
20576	payment	1397	1397	1678	1	1	9169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfPjXWNqvJbfZKw1sB4eXvSH24LXuX1sHpGVg6JYdJ7gfnhus
20577	payment	2134	2134	1874	1	1	314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7QvKB3JebTmyGRYFtXdkoyA6hVd74J4sUjdU7pXV3uPi7yaK
20584	payment	1397	1397	1678	1	1	9172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T976DVwoXU5f9UWJ8sFrd137upXtgtMA5CfrJaxCJvoFUzie
20585	payment	2134	2134	1874	1	1	316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC5FjsDmdi5v4wJsKZ2fxKxpWaPRRj5bGnPTujJeEPP3oCZQ3
20586	payment	2133	2133	1874	1	1	340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXetbNE77GGCEYWS4DS9Ax7s9miiYZDB2HUGR8eP2DwLRHaPa
20587	payment	1397	1397	1678	1	1	9173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrWgZqBtpS11rKAAt8HVEUEXYzernMtV4FiHCR2qRdX3qsERb
20588	payment	2133	2133	1874	1	1	341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPqobhcpjnrAqZtVRGURJUKx8Ud162AMwVfsAFnJhN26DyRBL
20589	payment	2134	2134	1874	1	1	317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyZTJajkJU7aKMvFXV7f7C8ZWq19KXF52AiquCAP7WwcuqPX2
20622	payment	1397	1397	1678	1	1	9183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yr3u1sMsGJryqgdh87SScKoSs5ZhJwfKwvXFwh84dqqiH1eP
20623	payment	2132	2132	1874	1	1	81	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDfHHhWvhYBEoZFcrH8gdqto9k7gHdbe1ATjFgqvMjuBJYkmE
20624	payment	2133	2133	1874	1	1	352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7D2MmBUVMwPXXTjM7x9uHxz8G2GAJYGLDX2r3m4A5TM6Rf5r
20548	payment	1397	1397	1678	1	1	9161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEYGsSs3KaVsFrUCteSAhURYAQguNwbnuFVWRdW69vPHnwjnR
20549	payment	2134	2134	1874	1	1	306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkwpPXdnyxs2c1PLcmcip6NRnDa1WbKu9JpnKQDTxWZvWMQtH
20550	payment	2133	2133	1874	1	1	330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhbwzjuZWEg3conxtP1jCLpP7pkaendYBj42K61HQBr6r45Qt
20551	payment	2132	2132	1874	1	1	74	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEK5HvhrshFEMFE4ik4xkCTKU1Nc7mgejFGYg5f3N6e3ScjPE
20558	payment	1397	1397	1678	1	1	9164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33j6xHyM2M9k5w76bojdT5qXrkVLEVfrC3a4pB8tGzKXvh3jf
20559	payment	2134	2134	1874	1	1	309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbFUJPRZ9c4Gzo27RaSP34XNjfT4Yiaf6zSZLMaAY2cWBiETM
20560	payment	2133	2133	1874	1	1	333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZinmiDbppWYEtYnRZa1FRamzoeh4LXEV1X3L6GU2fMwUMe2hz
20561	payment	2132	2132	1874	1	1	75	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSFKeDFY1km8x4xVVWJQhbjtHhhrGoxLLq6qUP7B3G5zQhRkC
20590	payment	1397	1397	1678	1	1	9174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMETpFZDszxtJHsVtnmRCdwLBG8298NsBDr3PYVy14rtQthHT
20591	payment	1397	1397	1678	1	1	9175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAy8Tm6E2vcnhKTf8R8g5JX3QtruXWSgsPC9wx7BE7YNXbJRbj
20592	payment	1397	1397	1678	1	1	9176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQzCtonS7jcgEzcvjFqqV5qoXEtz1B8NGubnQF1yhGJn8bnpe
20593	payment	1397	1397	1678	1	1	9177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDDo62nV7ribddaVypcCog2osCjeDnsUoYMLBAMVQZQJiFjBJ
20594	payment	1397	1397	1678	1	1	9178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpRLxjQ7df6iCmtr4AvdRq3QRUaujhn8fMYM6pkapZVCicN3N
20595	payment	1397	1397	1678	1	1	9179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87jkGxGzvbvyJzHJxA32NAgGnUSBYbBuGqM5BHtD7ndcMF23g
20596	payment	2133	2133	1874	1	1	342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgrtPx79TaRmXvQf5JHDswC5p9a7cDa6UGTf5uKQZuhY7WekT
20597	payment	2133	2133	1874	1	1	343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuSmYYo6MJaxYne6CN4PJF9XUpXyjHSnBrYbjxBnpELtyAvxh
20598	payment	2133	2133	1874	1	1	344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKsRnmzV2sF3F49qEw3Yt7FH85Li3TAHiA4uztB78NapkL2cz
20599	payment	2133	2133	1874	1	1	345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWRotSzswa3u8bKQkm9BAZkshxuaWF8JcwiehqhDWw3z3zmvp
20600	payment	2133	2133	1874	1	1	346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSshmbYsz7napJrAY3z5aZ2VK2w7PoijKyPUPoNEWRjaVDvgE1
20601	payment	2134	2134	1874	1	1	318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQYAHpHdioPmvSEHmEs1nUd8iYKuwNM1YktFEwFTWTf6pZEDe
20602	payment	2134	2134	1874	1	1	319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbHpTeMTUw4Nh2Bs9b1VpS3WhTHXgAbLP5CqdyneRTqzpGnfT
20603	payment	2134	2134	1874	1	1	320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMsHofFoTktKwyoLcYLt6aKTUHpuEx1gM7sXrrfpqLF571DQF
20604	payment	2134	2134	1874	1	1	321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahyTJGAsynPU4Jf5BasqpLH1ChJUhtKFcojBqnAnH54kBLNNQ
20605	payment	2134	2134	1874	1	1	322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyMR6V61fnDPPJGYqArkrcyAWJzMckUMyxSaPAEGJWCepyoMm
20606	payment	2134	2134	1874	1	1	323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct85jN5KhtTjioz9R9tMCNgu7wHNotfRsDw5qS2K6WLo8UY1J
20607	payment	2134	2134	1874	1	1	324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLm1dj47czh53msMBqcQgs6Wjf1s5DcAXPrx2JFTAvjt8soRF
20608	payment	2133	2133	1874	1	1	347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ntYgAVZH2Vh6THG6VGBysXUYKx6CEopEX6w4AhEjKGRKmKpw
20609	payment	2133	2133	1874	1	1	348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGM78EA37uCZ7uefetSkSw7c1ZDwLsXHigSyQtaYSKPJaNwsM
20610	payment	2132	2132	1874	1	1	78	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6kyjHo826N8mcyA5ZNCxjnW9K4jrSpwCmhosZv3n4qH2Wv4u
20611	payment	2132	2132	1874	1	1	79	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcWRtPP9owPbmb6kXT85R3qXeGe48s3Fi37hz9w1D2x29zPoS
20639	payment	1397	1397	1678	1	1	9188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXS4D3TH8CPqq9usLveGTu7VxZVyxxEiH5b8VX9D24j871jL65
20640	payment	2134	2134	1874	1	1	333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1xSei8ktqaJ9SckmRucYQcxDHKK9jy1xghgesfKBUcaP4AeE
20641	payment	2133	2133	1874	1	1	357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkRBXYru22wHZKWS5WWrrHCUBJzfsjJ5kLMf8VWPwrNWGD7UQ
20649	payment	1397	1397	1678	1	1	9191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboYZ9svj6KUPKLhrtKEpFk127LVUqZkhpVQrawGGbAqjLHJMh
20650	payment	2134	2134	1874	1	1	336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTAuCqnR2i1PSJbx9wwjJXQJX7G2cDgKzGeakvEr4b6pu7yti
20651	payment	2133	2133	1874	1	1	360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvKRUQk1nDkfVC7cRKePFmboPcfzKNAGoMnWcDRQmd3W5HRNr
20675	payment	1397	1397	1678	1	1	9199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTsaHVHw7TxZiECyja2scx9m5DjVGDwbjPrbSHsos5H3K5xVa
20676	payment	2133	2133	1874	1	1	368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENc26PwZ2mrji4xekMeE1m7DAkLYb5rdj98Pj6NY4PBGMDkQA
20568	payment	2134	2134	1874	1	1	311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WjBUJGRiLZNwY9KcLyPenVvrAzWrz99amyZmAYfmDBzREd6v
20581	payment	1397	1397	1678	1	1	9171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u5TtaUk92VFezjX4fCj49fz4jiARDFrk8rEjhvovss6Txh2V
20582	payment	2133	2133	1874	1	1	339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJq3JzpuZXcSDmRtYzK9ajGYnqQZfF5Y43b576gNzCZVPTpKr
20583	payment	2132	2132	1874	1	1	77	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX9Pv9AMYbMK7zCy1mDvf3QVc6A5CAPGPaML2jMscThAbqwwy
20619	payment	1397	1397	1678	1	1	9182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa277EKWVKaLNvXBdFsRKmnTiRZ3u3DuxHBbDeeWAjvcZj2N1mo
20620	payment	2133	2133	1874	1	1	351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjB57ndbNfQmG7rgY5yBzMT2Yvr4y7ghAZmnNDdQzhoou31Ce
20621	payment	2134	2134	1874	1	1	327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySZ6eio9tBFZa7VyKNk8t6zhuca2xPpMTh48Gh6BzmWXjVfj4
20632	payment	1397	1397	1678	1	1	9186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtT5FJF8zdcZVV81QsPb92sUcXJXcvZw1GPQbwUaJEfJsmgHiW
20633	payment	2133	2133	1874	1	1	355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSdSspsaQTkKWd3tyjWhj2QXrra3ng5RTx3YjqTxcCuWkVXs7
20634	payment	2134	2134	1874	1	1	331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTC2LGqfKdnQgoPcR85yzzLxpNz1Y1sHHV9MJinjANHbeA61p5
20642	payment	1397	1397	1678	1	1	9189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5QSALcCDp1ytr852W52WkrUYAoq2ajA8VvPZjyhiergWTuGd
20643	payment	1397	1397	1678	1	1	9190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUHcD5dUqMcrexbtDSDaTgb9qKrUAbj3JBiciY9VPTzW8yYeC
20644	payment	2133	2133	1874	1	1	358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSoBA7zivwzrCv5vfwU9qEb2xZz1SEfr6ffJA8TH9TSoS4s3H
20645	payment	2133	2133	1874	1	1	359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6EaLNBWAoMByhF5NmN7CwmBeHjS8NdPUoeXupYxz5wequRB4
20646	payment	2132	2132	1874	1	1	83	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGffD9pfQKRM7JTq7X99BrgzV45ZFmLwTBCTCbR3fR43x3uzgW
20647	payment	2134	2134	1874	1	1	334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL36ywDArLdKTQy6AmdxnRSJR3gvunvU7AbPU9HKQQBjZXitc2
20648	payment	2134	2134	1874	1	1	335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudxGxzVvYs5JRDm4dYWgQLyKoygCMYaq4Hc4Wg8gDj4K7zcjK
20672	payment	1397	1397	1678	1	1	9198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFqTSKowARKnSSSJgxcBipNL66r3NvUT4MMb5NVzajbZVEyKx
20673	payment	2134	2134	1874	1	1	343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJiUCq6d5NYTk88VtkuK54NLWDTV9NscFj7dszCn3c5TeFHvf
20674	payment	2133	2133	1874	1	1	367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7ZkufAzq3gCdNptqe72hav67rvDyDaDKF7V2ww9AXp6Yacfq
20682	payment	1397	1397	1678	1	1	9201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTJPmDGQsNJD9hQfXyMre6xLB4WuJUesee1U9MZKrW7zRa6Ei
20683	payment	1397	1397	1678	1	1	9202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgzyuGoRgmSptB8AfPWcfpYy4VucTohwyGJZ5s6NQqPrLA3DH
20684	payment	2134	2134	1874	1	1	346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESrMSxq17U5ZnmwmrvmmTkLiA6pE2mrzPEArGSoPbLF2EVqxb
20685	payment	2133	2133	1874	1	1	370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4ST5rF48kDRZZjvNxZxRpMmZR7FB6sjZ13SaDYzyQXYX28E5
20686	payment	2133	2133	1874	1	1	371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwasKi6WYpeaTbvzaYVy91oDDJ3G17iNsU3sqVpjmDw1FwRCTj
20687	payment	2134	2134	1874	1	1	347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGaEFBX1kANohHukMJWDjArbncecwQXPSEBPGFxieqt46CYNFh
20625	payment	2134	2134	1874	1	1	328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4jqTag5ahhDtGqaAAnW9NETd9kU2CgAje7NVdLRoPEA5pkm5
20635	payment	1397	1397	1678	1	1	9187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7V7kfuFJSpXJgU2evpMczvU5FTY8RYDuAi2fK6J9d4P6qv6r
20636	payment	2133	2133	1874	1	1	356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5yFoYPohSH9wmyPyfQBV9EiTDavb2wp5zYpUAigAtDBHT783
20637	payment	2132	2132	1874	1	1	82	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCUGXzwPJ21x6Tdj1ayPF2YEGuw5xQ4AtH3eySg9j9fTig4ZC
20638	payment	2134	2134	1874	1	1	332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjfMQKq5TwWwUpTx7bmxGCxfPVudBKUVJcJDoztBnUYyG4VnR
20652	payment	1397	1397	1678	1	1	9192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmCibFbENhaYqKhmHWyrSeVmyhYmA93XwFWgcZasU5T58pxJU
20653	payment	2134	2134	1874	1	1	337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgXEBDcahVd6Y8eKsueCi88phfVfrYqXTCNpjTqVcZfGY2b8k
20654	payment	2133	2133	1874	1	1	361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkBedogzUcUH45nvJdzfRtgsRQJ9pxYejiQFHuAstJbPcuNQ
20678	payment	1397	1397	1678	1	1	9200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpx3A2VE8enxY1CNatY9ppNoG8N4KeutUpCtCDyMa6GSPNAibp
20679	payment	2132	2132	1874	1	1	86	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxmN7K9S5SeoXUZk6BxR61ydZ7q5arjLS91gPzTmK6HMW5Ni6
20680	payment	2133	2133	1874	1	1	369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4FUBwfzqf1XFde2qcMvmz7F42MA7giyxGZjuKYU297yM2mbV
20681	payment	2134	2134	1874	1	1	345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12F8VhUQyrG7Ka3fZv76SvgHmzQeBU2YX7vLrxSeWXoLbWcAA
20692	payment	1397	1397	1678	1	1	9204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCc9rFmV5a9MWas9BrmcavJPgF3QDWDczfmgTqSYT6uqnxi2i2
20693	payment	2133	2133	1874	1	1	373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvqK9z9KucEoNGHAwbrHcXksj57bawaAFCVr1zhPHxtiGneKG
20694	payment	2134	2134	1874	1	1	349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jMtX1R4T6tvzxRMkBQ9gZULpZ8g9roNrDnX2jcumbR77djQp
20657	payment	2134	2134	1874	1	1	338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9NwEcgApAo9rmVrdMDZkqYn6d6VwnipGnoM6Py3QoNKqJtHu
20658	payment	2133	2133	1874	1	1	362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh2DQkiLUrqmJa4tGHKFKrapxR9V5JgseZRNCmKjXCErTSBmj
20659	payment	1397	1397	1678	1	1	9194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3zZYVJCU8Xtm6y12BxAUhvfHisD2hNCXNExWCrkZFPvvKKvC
20660	payment	1397	1397	1678	1	1	9195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjWwvxwUrDuHc38wfDXMLAfngQA4bgnKak4JrAPJBnKbJaMB2
20661	payment	1397	1397	1678	1	1	9196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTU4RfJr1685GHPdwVh8p5jibD33MFnVS49NrpbM4haGq5KScr
20662	payment	1397	1397	1678	1	1	9197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrBWEMH5HmbUdrPd4U5ejUjEjd6fKy4q57gKT9J3kMtHb9daA
20663	payment	2132	2132	1874	1	1	85	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuC64c9qpZkPp5viPDRb5mLxofKmnWTUvcy1ke5WUPZV9KMkiB
20664	payment	2134	2134	1874	1	1	339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5KNB28qY6LKTXfU2uwb8sqDjZmS1F5x3BmHpUX1kFjswAWik
20665	payment	2133	2133	1874	1	1	363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXuwf67dV22Jr1bERLutsYoNEv3JQxAeXGWMfcNZ8TppEdikmu
20666	payment	2133	2133	1874	1	1	364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3trJeYfkGjGBwry67ETdsXpJkKfHVgFzKVY3z2bLfWuvX64Z
20667	payment	2134	2134	1874	1	1	340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6zrGqWBMMXqgnnmK97ZizRNtasiWN4RFS9pAjMNbmdHqU2W3
20668	payment	2134	2134	1874	1	1	341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgocsVWVKcEgfq7zvxpiPtxiDgBGW5YqLduEhP6T99DYQnud8V
20669	payment	2134	2134	1874	1	1	342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvaCxHCcYVpGiE4k4BGAdnF6tVxw3KwEaFeFdBeQriVM6LV1x
20670	payment	2133	2133	1874	1	1	365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmreXVxkg6F3XusBdpuJCFzw8BMZvgBmYUEemifcGZgZiSA3gD
20671	payment	2133	2133	1874	1	1	366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjafxmRXcYpmeTJkvaK85YvHApSugtPMrmRghsvnVvDvmkRqvt
20677	payment	2134	2134	1874	1	1	344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxAoWs6yXhUzcptpEtamB1KwN53S3JtvTCTtuw4AF59cVR4Rx
20688	payment	1397	1397	1678	1	1	9203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4WM1ZppUkwCh8cL9BCyGUCATL2DDubspBUAfrvjkAKh7X4SC
20689	payment	2133	2133	1874	1	1	372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwqYawsDhe9Ty4x3fEWj7t9i7zhxjB3rpwXedNkTdcgAGNWVb
20690	payment	2134	2134	1874	1	1	348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweQNoquPKzEhSJikHQF1Pc46iiTi3QJabwmVuYSj5rKfuzdR8
20691	payment	2132	2132	1874	1	1	87	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pAECmqALQHXHEA3vXk5t4ry9ZrhHe6WLmhtoeYfkUAeyEWtk
20695	payment	1397	1397	1678	1	1	9205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZLNuAXkfbJdWk3MgoCpBPhHQYA3RaYzb9cgjhHatiqxTtn8o
20696	payment	2134	2134	1874	1	1	350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYZyrN9LK9C2UXK5BTyGRxjitR1mSCdrPyybakKnNaWofNNSk
20697	payment	2133	2133	1874	1	1	374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AwuxAXKqyfe6LnYwQUS6kXg8anWew6pSBkdNBJB8CupYyida
20698	payment	1397	1397	1678	1	1	9206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G5rCp7gSYAsVAaX2hQSNYDCcSosnDrkrZJx73rv45gTVSTuK
20699	payment	1397	1397	1678	1	1	9207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjGofz79ZBNAxJ9H3DtA4PTPMvotYPLrCnLc57YnVw46Vwc4k
20700	payment	2132	2132	1874	1	1	88	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvLDxM2phhSRwTb5rJYsmGzPLNoc92hC8TR1L1BazBWTE1Cfc
20701	payment	2133	2133	1874	1	1	375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqKChrust6ERhSZA4THJKJqqYi1Zim3z1PDapkKMQvjmVcqFm
20702	payment	2133	2133	1874	1	1	376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RU9GQ1pDddJGTVkhFUzDPqCfrcuZFa3Jk6dn4Bsxr1tTvgfX
20703	payment	2134	2134	1874	1	1	351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa946w1rQuTKzpjM5SNmfDQsLaUsMAVX4BGeb6E1Ko8WnL34BZf
20704	payment	2134	2134	1874	1	1	352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDAQa3CkdGibptLd4Ea3mFUEJr5dmZP5ktJmnUDJ9fFp29M1M
20705	payment	1397	1397	1678	1	1	9208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnifqYLwsGmmzFhmvLsvSoTPdxwP4vHGQitvTETGjEy5VyoZwi
20706	payment	2133	2133	1874	1	1	377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFKxp19wQRCP6tepjcJn9ef4jGzLisA7YNPAy6yTYKAz4UuMq
20707	payment	2134	2134	1874	1	1	353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTEUPJ873VJpu6jrHteQcxQJGZgrYa3T3eppWtAJu3TRXtYy1
20708	payment	1397	1397	1678	1	1	9209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPdKt9ktFM2KejxGHnVAEVNiZSKjiLNExbeJtc3M2drrLMrq9
20709	payment	2133	2133	1874	1	1	378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuauuejPeFaXP5MbPAQFod9c3Vpx7N3ocnf1oBP8yPgfMQ2Tat
20710	payment	2134	2134	1874	1	1	354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8njGtDmwhHK6N6Uww6P2Pg5YB8Hd8zowwQxUEbkoepNLzFdhX
20711	payment	2132	2132	1874	1	1	89	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gi42AW8XMLxeiYEG3ip82qV8ErE5BxWMRUBQsgfMhS2zYUwo
20712	payment	1397	1397	1678	1	1	9210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwo2Lch3YRKhstxRmCQEDPtCQC9EEjK5i63REwTopqd6nEv93
20713	payment	2134	2134	1874	1	1	355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgMkJLfzogFqWedthSauagCrjNBdxDRJZytq5uKKpe9LMCygv
20714	payment	2133	2133	1874	1	1	379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2veTL3aYvGQpNzht8jNpWNbJ388R6WAqTJELhAC9aLJz3gLC
20715	payment	1397	1397	1678	1	1	9211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVbkxEP9Ktc1uH3ZvM3b2nBhoTU41iN9Dk93cuxoLa5qbGqYF
20716	payment	2134	2134	1874	1	1	356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwZaWnHh3xeeo8qXUCozKQgUfA7gQRkwALsVfshk7nGS2gvWm
20717	payment	1397	1397	1678	1	1	9212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMthHhoRiBc11T4KV9PTVrN1TvJfW6r1cyde84xpaCGVZ5Vkdw
20718	payment	1397	1397	1678	1	1	9213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FkyPemZzPD9Kv3kMGCmuCK3pnh7s2KABs5yk9sMvhg4zZbkp
20719	payment	2134	2134	1874	1	1	357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbAYKk52X1ZYG7zeUpxbCbyPAny87tYCRt1msGNUs2Zz4xne7
20720	payment	2133	2133	1874	1	1	380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6d5tcndENhSS1pjWKkqSmSCw3h1p6LCg7cq7HxHoMtkv1cBUE
20721	payment	2133	2133	1874	1	1	381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMMYodKHithWDxRaccdmNhqcEZpohrzMFRaoUXPrh2LJq3gXf
20722	payment	2134	2134	1874	1	1	358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUHdvw32eG6wX6ERtAtKJNunb5LaPMPSANpY3ReSbtV3B479k
20723	payment	2132	2132	1874	1	1	90	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsGCuQ5wmT2uP55Hyugif8NSEik8f6dAbodmQHsjAb2t83AWo
20724	payment	1397	1397	1678	1	1	9214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaug82j7BrZ7yCbgPBYB8YmTDdsfLxdSg5ehg5My9vL8hf6cj2
20725	payment	1397	1397	1678	1	1	9215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9V17eyb6jinDXKE1Ekbp9swHL66o3Mepxvv4BK46Xda5FJXk
20726	payment	2133	2133	1874	1	1	382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWYgZtX1UWQTNYggZ3S5xnLU3iYwZxzCCZaS8PcRnSgo4HBbz
20727	payment	2133	2133	1874	1	1	383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt57P9xjYQxfoqek1Zify4XGGUvmXpVeqsLT4PramESzae2LRg
20728	payment	2134	2134	1874	1	1	359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLeaypTdPsEvtRVsJxN4H9rNMctSqA7qoiTDQBMR57Bthkiuq
20729	payment	2134	2134	1874	1	1	360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHf2wZ52BxfVXSYDx7BMmqUFRA9c1axZv1BYMY57rSEUW6ktE
20751	payment	1397	1397	1678	1	1	9223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPv4yHkdZhJSfn5yj9hpcoHAKGPiz83RHd2tRCqyad2CJPybF
20752	payment	2132	2132	1874	1	1	93	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkRRHzUUFjqKCUCC84n7hrLExwtj6R6oRCvwVhYuTAkWuf1iq
20753	payment	2133	2133	1874	1	1	390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2cwWYeeJuwuViUkAjpsitJFPuSorNjTE6k62p9y6o34BVW4Y
20754	payment	2134	2134	1874	1	1	367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxS8u25LkkDAS2DN2HvLGhKMG1hP8wc5XQaPg8XtRxrXQoth4Q
20755	payment	1397	1397	1678	1	1	9224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfK94Wc78dWdancXbeXR82kbMmzHChveWLygGBNA3PAmenrquw
20756	payment	2134	2134	1874	1	1	368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicgtcZigPUAjGWJDNxqCCyTRGkLbckA9YEiRUPo43fMbshRtL
20757	payment	2133	2133	1874	1	1	391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4zmEQPBYNhHz6H7XctrxRyf3RduqUddXg8mki8kGUyXZuRMw
20768	payment	1397	1397	1678	1	1	9228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvkibHKufQPCHaaDWLzeKFbhzz2wEf9vcNAhHYvoqyeLPyeaM
20769	payment	2133	2133	1874	1	1	395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUgcGARP3ymq5KpvEUZXx3VQBYJgWZvgedrfHn92YsU9r2rWA
20770	payment	2134	2134	1874	1	1	372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Q2DKMrvKKJvsccSzpuHrCA5vqA1TQtVeo7TSoXWwvzyj5rws
20778	payment	1397	1397	1678	1	1	9231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1FWcwXszD5XrubMmCmr8vfzaZ1bTysDvk61YmqCsd7ks4t4P
20779	payment	2133	2133	1874	1	1	398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpYM8rULjACQohTkHVod9xx5MBSvukdv1q19r4JqaWZrM2B7k
20780	payment	2134	2134	1874	1	1	375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9Tgekfb7UeNbmKaM42uJtc2Sm3hf8JRTdFXHfgCSDvuPAYa3
20793	payment	1397	1397	1678	1	1	9236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKawXaKpGfTDU7Hz83Qwd3S8D5reh9KQfAYSEU9XUC9y4fEqeZ
20794	payment	2133	2133	1874	1	1	402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiVQ5b5JTFoar8esxj61VEgBRmwTmGdpnDFLiCAhfuZGY7ejm
20795	payment	2134	2134	1874	1	1	380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuppb3QHHxrimfiqvQHXXXxMfTrhdEzuvhWRJPm98oyHV93AC
20817	payment	1397	1397	1678	1	1	9242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnPnCdaaQS15NDLgnvJ9gWJ2CiziVcKR1hRLGk6pzAVbT7VzH
20818	payment	1397	1397	1678	1	1	9243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1RpcqEMcd8Hog1qrTPHFHfz9nc7pr4iDYR6ZNUjbjyjvhkcG
20819	payment	2132	2132	1874	1	1	99	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBvfgkhWhHVprKtMo8R78h9AP9napvR1bTUQkdVoLqkpqe31e
20820	payment	2133	2133	1874	1	1	409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF83UKwHQHRAV1cZweVkTZzaCN7dpbGcfT4M8NPaNprpQP7UEN
20821	payment	2133	2133	1874	1	1	410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbS8eePdiRJ1d4q4sy4KcWVRnXKm87adUcFC6xRJzeGuJ3kNH
20822	payment	2134	2134	1874	1	1	387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvsJnNpvM3tNiQpMm2w9LP9iGD9bz72UagotFjVahamK1j3L6
20823	payment	2134	2134	1874	1	1	388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbn3Rkhfq1Fq6zFKuoFfnmeYaV5KaK6rNSN6fjA8mFXhNLFzd
20845	payment	1397	1397	1678	1	1	9250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesx7M1Xbr2KrR2cBxtdomULwHNVUWF8tCDAWAffvLSxedX3Rt
20846	payment	2142	2142	1684	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTAYCKjRDa3HgdXM1XoXbE3zj76S5rFbpYZ52qYLF2PCjbLwc
20847	payment	2134	2134	1874	1	1	395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdg88Bi3wVxuAhN78Ha3E1yacTC4hQN5dJdYZDDQ1fMEXGCK78
20848	payment	1397	1397	1678	1	1	9251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDjBUS5CB3bhsbeuAXvu3GZBrXTSBx3ajbVTcAeib5ZL8dqet
20849	payment	2134	2134	1874	1	1	396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpR11F9Y91dYSJRpmmVH2f13cbqUy1sv7CXr16xh1AUQ6KUbNN
20850	payment	2133	2133	1874	1	1	417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9XvyLc4HBndNQ5Sm9aB9EACFA1PQGtCRp7ciuwc4gKxZnXgZ
20892	payment	1397	1397	1678	1	1	9262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReNTQ8EdXJTjLHtteyVqMiP4SmqcmiLkBvLFQSo4UFDSQ3CQK
20893	payment	2132	2132	1874	1	1	105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR48UvqydLeAkV9gP4AxRP52rUFHAytPFXJxcRPiZ1H6PJRX3
20894	payment	2134	2134	1874	1	1	406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrNX3MiB2PVaV3g6Xm3uFkAGfeDyFgD6k1h4N32QvGbMey7o9
20895	payment	2133	2133	1874	1	1	428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9J47xbtcCiU75pczaPvBoVrpfmQDzazH1hTyhMVXuyL4FMLP5
20896	payment	1397	1397	1678	1	1	9263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TEjNAns9FPj6q1sGN24yNKweZBuYnxutAdpBcovNGEnrFcTA
20897	payment	2134	2134	1874	1	1	407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApTXa41jhWDKEHDLAF9gRbkhmJ8gCBVhn5z1JUvfA8vr6exD2
20898	payment	2133	2133	1874	1	1	429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2BJdmGZ7L41UsuH9mTtPBC7CSZbPtYXGUwzrQhZHvHcgvtUJ
20730	payment	1397	1397	1678	1	1	9216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbQ682jEiRiRYQ3MtHvr9xrM9PXxVXG92DzM6SjHK7FPKkSxW
20731	payment	1397	1397	1678	1	1	9217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq88pDuUyeJQXqd67o9m2tgCpVJJcjR4SCMXXuv5gjZ32j6aY8
20732	payment	2133	2133	1874	1	1	384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKkkMf1MGbLMXLGbtKX9s1WQoSkk4VC7ypvw7QHaWKExeupS8
20733	payment	2133	2133	1874	1	1	385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo7MCaFePgt5v2o3iUDUqj4fEc4T9ZUntqo3DnPRtDd6oHeMT
20734	payment	2132	2132	1874	1	1	91	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CpaZ2Jb3phaEqrnyXaPxK33LjvNM7swwYcGfh8v8dBxDXeTp
20735	payment	2134	2134	1874	1	1	361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrkmaoPCkAAYd5B4d96FtpiJdFUSEVhTG9sFntMA7ggSrcUvF
20742	payment	1397	1397	1678	1	1	9220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtAD2XiLgT8oqEDZo5HogkoC9iNHu3SgSPwhLkMvyFWnVtyAp
20743	payment	1397	1397	1678	1	1	9221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabyyndPs3jfMxGCTsWNHpQBxYhVyhRRctBq9m9q1EUx717GpE
20744	payment	2133	2133	1874	1	1	388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTLfedQZzCDJgboaNRJVmkvy7N3EQejPjxQmomwxs8SeyX6gf
20745	payment	2132	2132	1874	1	1	92	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd16cZ1b7KRbBznfNBDsq1ZXpBQsQm7QdskMFU61xiqE3NvRcE
20746	payment	2134	2134	1874	1	1	364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqTWGRtVQFcn2USVQ91pjTiHYwTdRizuzNEHLBgFvrdcqUzni
20747	payment	2134	2134	1874	1	1	365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKRLDxFrkxDMnyoCPu4wV7feND2FPXKFkLcUmBkLuVL6k6GAx
20748	payment	1397	1397	1678	1	1	9222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeHzRmjrkpSQ5izh5DQMq2yAXt2Z1bBtMhb4rGTNhhwVbYsbe
20749	payment	2134	2134	1874	1	1	366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVddJq3gVtW1ivQ317Ex9qrFMSEPq9ESerNGodMgm66kQcALRU
20750	payment	2133	2133	1874	1	1	389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrx3RmnWPiRrT1uhT4728VTks7ZR9p7jWg7kXF4XF7qarxDZD
20758	payment	1397	1397	1678	1	1	9225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvdoMfJDXzxgwptCw1RruduX8VB84C52ZRUSbUPTDgg5qnEpP
20759	payment	2133	2133	1874	1	1	392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTKtQoUwLEkpmEKemoeZ6trbG6nbkQqQqdxTFJRoaZxXmyRy3
20760	payment	2134	2134	1874	1	1	369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVauA2VZEA5r4oi981o2jkrfQPBM4vvo1bxFUteAoTp4XPyRFX
20761	payment	1397	1397	1678	1	1	9226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2Mz7Ci9sGpkqTEC3squfaDZkJ2LoXHZR11VpSY6Hnf428SUh
20762	payment	2134	2134	1874	1	1	370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrK2o3svtyxKHijyLh95yFK4BpaGBUx2eDz58evGR4RqrHutC
20763	payment	2133	2133	1874	1	1	393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8KRbyxJbQdJjx5KPtWQ9rJEtpcLJ5Z4cYr9sycosME8e53TZ
20771	payment	1397	1397	1678	1	1	9229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8gbsrktwYSyKR5axvbjb4xtbd8n3h2SgeKa1BvyYGXFWsuK7
20772	payment	2133	2133	1874	1	1	396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Dr547VyB3YnTMvwaocg2N4vavtf9NWNVWHyXd2JfGRnJKtxi
20773	payment	2134	2134	1874	1	1	373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGYMYzX43uQdEqGDQM9UP3SQCoU6aV4TH9rAZLyMKAkGzHAhA
20813	payment	1397	1397	1678	1	1	9241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxn1FVygdxgiyUMLw1Ah5Bh6oF9gVmKdFJE4PfEP7gH46cqhZu
20814	payment	1684	1684	2142	1	1	67	1001000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgb4UTHsNpqr3FQfBt1riqdo8ZuhYxWZ2QnWjNP2itjMHziMP9
20815	payment	2133	2133	1874	1	1	408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPTJQ81m1SWi7hN9M4PDRWfbnrkidFcKWbo5aYChPhwtEbuqj
20816	payment	2134	2134	1874	1	1	386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQSQtuNdUYaGJSok3x8VktcFjgFme2wXhREbxY87J4qqkbHSC
20824	payment	1397	1397	1678	1	1	9244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkZSQEyFxNEP55BnPbSPfBA3FBCwB2drmRUwx58J8ggTQkEGi
20825	payment	1397	1397	1678	1	1	9245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4NX41mcncExUSzuykgoNXrrZwtJXsAFRy3R6gmK992gsnN3G
20826	payment	1684	1684	2142	1	1	68	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9jwpAm6UVoLVxxQEoBrz7gYJ6dLStRPUCMisUjf2DzJz1gRv
20827	payment	2134	2134	1874	1	1	389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sA9cJUewWTCi6hLXcUKUhYxwkkXgMgP2cRE4aF7TNN3gPNt3
20828	payment	2133	2133	1874	1	1	411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyo99gW49CBMYqEAErzK18u8H4hMt2oo23yidj47G2saM14KF
20829	payment	2133	2133	1874	1	1	412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxN21xQDkzLo6wiDZbdykUAA7JsTtMeTZTZKL3FxSzSy1n6McR
20830	payment	2134	2134	1874	1	1	390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwLrciTuZCCtDTAqMoKKwpJBqTesfEK2RNvkw4ZA2ZdJAFtdV
20841	payment	1397	1397	1678	1	1	9249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfbGjToCZj8EUU8oMriqTDeVFyxnQtTErttoRETNawE5JVeja
20842	payment	2134	2134	1874	1	1	394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQ7oUtRDrv9nQ7UYoavV23TxC3y1bqJUPPaWrMyXsRU8Bynko
20843	payment	2132	2132	1874	1	1	101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDSpP63FYYTocHYsnnxoYLiAaFXZJmW9npJex4TkHiKZa4D9g
20736	payment	1397	1397	1678	1	1	9218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfY73yjHmVaiJ7pfPQH1r4pBuMQ2oy3VGiJLUpKdqq3vk7XEh
20737	payment	2134	2134	1874	1	1	362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbdTBCutZUFXoaQaqHFajuNfrizkhqzTvo6BFYj3k66cwk4R8
20738	payment	2133	2133	1874	1	1	386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujkV3CcujfeZZ7Y1KjDnvXyp9k8bMCSfcG4JjpuFy9oMpQa3t
20774	payment	1397	1397	1678	1	1	9230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqHXgoYVu5NTKBjmEV4EkHPFJH7xJ21cMxWXwScGtrxDdRFgK
20775	payment	2132	2132	1874	1	1	95	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8pserqYa9HqbvgHQWNSacYnBRwbZHj6WojRiS34utewRsRkY
20776	payment	2133	2133	1874	1	1	397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpRb8ratMJpErvCdRqZYkuPWotdMwXB59BCLeem5LeFxLnmET
20777	payment	2134	2134	1874	1	1	374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAcSJMVW6iAMAyZoQ6X8d3FxdETSwRiEKEfPZZUrofJdjH2Dq
20784	payment	1397	1397	1678	1	1	9233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZ2GH1DoKdYYBFM81cXM2K8NRVdBkuEDFrzWfvnthYYbc4EKT
20785	payment	2134	2134	1874	1	1	377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhnc5PZAD4XqRvtn1fUWngFfdLH5P7EZASjrkybePWdBzovLJ
20786	payment	2132	2132	1874	1	1	96	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGk4s5Qof1uKi2zMdd35SNKjp17hBFG4ZStWK9tLsu27yum7s
20787	payment	2133	2133	1874	1	1	400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRJ9VGVRbDBCBMpFG9TVUqG24MX7AFSmVBk8GMBr4UrPL9QY7
20788	payment	1397	1397	1678	1	1	9234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4obvoLuba1dbgA8kgPTumdXbGsAxrPfcFfLKhSoqhzB2mEco
20789	payment	2134	2134	1874	1	1	378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1A1XGfToyjJP2tExEA3oKnMdqxGd7E38ueyyWgjHJognqhZNh
20796	payment	1397	1397	1678	1	1	9237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcXEmqkwLuCLeXLxA9GTaEKFtubc3aHzuCdYYQx99Y4nuJPZP
20797	payment	2133	2133	1874	1	1	403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9hQXeKE6Lfu4KRMHzPdnoZBC3S6o1CNC1esyEFu2zCJQs6tr
20798	payment	2134	2134	1874	1	1	381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8Px3tUQCbFtj88sCrgCfHoLkXHp1hnouz1X88S8b91aMhVV7
20799	payment	2132	2132	1874	1	1	97	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKRGSLkA9kZu35DufWKs7La5tjs8vRDS5cXsSH2mbMb2FTcWr
20800	payment	2134	2134	1874	1	1	382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxMEuU9zAv85ThaPYB7sa4B8SkvtJtnYV3yGd9h9Uj4PoY3zH
20801	payment	2133	2133	1874	1	1	404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZHAQNjoxnBe2X8yhW4A257pcPPEhLf4ttratxBYayJWNxZY8
20802	payment	1397	1397	1678	1	1	9238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3Ui9CuBKkdESDKCpapdJtBAK8Hgz1Dc87LPhGHL4bM15s2jB
20803	payment	1397	1397	1678	1	1	9239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCN1HsVy8VKa7xjG1vJAiQEjuo3SEMVvEpFh3FzsXAkgFEofzz
20804	payment	1397	1397	1678	1	1	9240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB7yNDyo8L49LhYrnU1To9CSTinbtCEhwmrwbUDD4qKtf2aXH
20805	payment	2132	2132	1874	1	1	98	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAGSrsi12YW4EaBXEtRSxMvTevgrP4M4X6FfbXf98nFjXDuWa
20806	payment	1684	1684	2142	1	1	66	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgz2JZ3HWujNgYLNhwDNJ5b8pYzd413Qr7sWkFb84PGsyncpV
20807	payment	2133	2133	1874	1	1	405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYTCKhinnbjA3TyCqRPy1Kft5NJZ3w11P8XKcNsuc4d8AE3Mb
20808	payment	2133	2133	1874	1	1	406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXxEqEvyG1ishTTWzQSWqUakPvYQgpS6UMd27hz1qPNWZeU98
20809	payment	2133	2133	1874	1	1	407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VoksqwWyHy8DFcBnCffR7Mvvsjd2bZvQp1ypVb1eoyAwvrED
20810	payment	2134	2134	1874	1	1	383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMbroEHxtgaEcR1WQSmVTohDQJ5Lqv9sR5vDaBMEsJr7qtcKU
20811	payment	2134	2134	1874	1	1	384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkdH92XWAyW99GNK7XnSMTEuj1dkTxN5u8vbrrJ3qQYtBuu1t
20812	payment	2134	2134	1874	1	1	385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NFQT7cvRSri4ktAtJ6A6A3ViprPwb91abHgPworSjdbqa7j9
20835	payment	1397	1397	1678	1	1	9247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2mK2i2SSik8QAFcSPtfPDKYdm3T7vtFozSnGH7jQZ1Kjpqt3
20836	payment	1397	1397	1678	1	1	9248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHNnoLieAE5UyHYCNX7BN4LkqVyvPdwmYQ22DJ3t6qoPbRXtC
20837	payment	2134	2134	1874	1	1	392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYqqHroaFBEaAvFFrTwtYs8brG2pab7Td9N6Gw7ShiDm39z4A
20838	payment	2134	2134	1874	1	1	393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVzay9xDKfZCnJE15q7svV8jSbnNpbqPfNxFmyHZKWyETQ8S1
20839	payment	2133	2133	1874	1	1	414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJYUkkLwig55WqgXMMFWvRxib3JyMzJcofbeA1HAFi3w2UhiP
20840	payment	2133	2133	1874	1	1	415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQERYWHPy6bJDs5BUHsDhjhEZVr2ANLiizmh4pLrQZSYhVQpA
20882	payment	2134	2134	1874	1	1	403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSY6UPE4Gge4fobupDZBzSgv2QC25G6eGz8zcoD5zgYMmkijj
20884	payment	1397	1397	1678	1	1	9260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijHb2bgRXQrbszgFKXv5doBvdXcmYkpohwPcaZtrkLCxDzezG
20739	payment	1397	1397	1678	1	1	9219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8HxKRycf6k23PCaCE52ErduQ7ybBHQceSj9tyk8oH8x4rGej
20740	payment	2133	2133	1874	1	1	387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT12EF4HjfPfpHnRyKYdfiq8RTWT9e6RdrG8V3fqrL3T8W7jEp
20741	payment	2134	2134	1874	1	1	363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBAhhJwC9CGCvjU9jiQH1oJgAxbV8qNmGpXr62hKhkeyr9jYF
20764	payment	1397	1397	1678	1	1	9227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyDKBLD13KCu1re7DpB6d4u5cRZBqap8yUXtnVxchvXeyXW5a
20765	payment	2132	2132	1874	1	1	94	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmR7dcWismjc4DMipA2c7ib5BzwwwjBRud23P66UwW93NypWx
20766	payment	2134	2134	1874	1	1	371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfxzg7WpDAqy427ripLzwh2zdgisKFTWPPVz13ZNXxYAGBvwU
20767	payment	2133	2133	1874	1	1	394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PSHqgjqKLQ6CEeN8XLG2PN3XPSogow1zub9Lxt6xteJB9dre
20781	payment	1397	1397	1678	1	1	9232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gHX18KmaNsZxgCtXmXRPGPSaeAwEcReCQtJAdKG1erRMLoUz
20782	payment	2133	2133	1874	1	1	399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhB2Eq7ZNWJ1bTv1DajMmEHPTWP3XJYiPCKCERuSt9N2RAKcJA
20783	payment	2134	2134	1874	1	1	376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TYsomgZjXJm58eYXXPCu56bSJ8siRxE7u1ZM2SDA5ZNVmCDi
20790	payment	1397	1397	1678	1	1	9235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9saiwKtDsQJH13Bd8hKpVipNs5h6Tb6yDU3pDEh93WanDaMF
20791	payment	2133	2133	1874	1	1	401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyxuDwp2GXuWgcpn7FT8qhDfvQFxzXrXbtuCycniuAE3ohz6a
20792	payment	2134	2134	1874	1	1	379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TKkZzNvqXXnyPEBthdssYFsD15pDLdyUPircWwjfsAqHBQP5
20831	payment	1397	1397	1678	1	1	9246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gbfrHYbWkZDC4kq16EQEeX4CWpFsphnFu4xXZ573a9mkb5k8
20832	payment	2133	2133	1874	1	1	413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2gk189MSNfN4kgpR6nU8Bey5trJCnczsyS7Fdo8HnyU4eyK8
20833	payment	2132	2132	1874	1	1	100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVecmgr2y2zd7vbA8pwtmNAv8rCrqu3BsjJFfEcgP2ixu1Neur
20834	payment	2134	2134	1874	1	1	391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2RDcTijRFGGGwDjYwo8CAeRaP2MymgmrfUSVs7DWZYjTU3wj
20867	payment	1397	1397	1678	1	1	9254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkamqvxv53N217CMKCbUAqFF6rc6Y8THyuXN7mxb4HS6ruYvj
20868	payment	2133	2133	1874	1	1	420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU121hshY5gxzCBSDv7tRz8LZEmJdk6EbS7t1kWWZpTt5HYY1g
20869	payment	2134	2134	1874	1	1	399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Emmm5GytjCzr6Nj7FFjp5AoymwDG2c2nMjQhBfxqEUzJYRuv
20877	payment	1397	1397	1678	1	1	9257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1uSRZc2QF76fsYk1VtF1Wsy8JyDEQa9pf8R6h8PwxQxRLJJP
20878	payment	1397	1397	1678	1	1	9258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccj3H1uJLgZGyAiBX12xYtC1rvZcA1n33Fe5ahErwz3ujKW3z
20879	payment	2134	2134	1874	1	1	402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FjdJtzyyKCyeBN9K7Rb4mQNXxgfHxyUV7hHY4u49duAdhr6b
20880	payment	2133	2133	1874	1	1	423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRAsZBrQtqDkLmPVu8V6776475bh8VGDwZiEMQW9vY9MSY7E2
20881	payment	2133	2133	1874	1	1	424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuHczY91naMCRGXVmD39iRKkCZuQAek6Be3PNunk3di5L7S8N
20883	payment	1397	1397	1678	1	1	9259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8abd3aEYscdFm6domfdiosKCyeUXBZYadFTh9ZfKnhTncVVEW
20908	payment	1397	1397	1678	1	1	9267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ2MfMAnMGsCEZVUMptiuGjGLorV7XLeRRWfA1RZ4kdGECTtG
20909	payment	2134	2134	1874	1	1	411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudq2K6KjJ9Bx3yRbDhs2H8UxJFQScaYfqrLtg1K1NMwQM11Mf
20910	payment	1729	1729	2147	1	1	8	555000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XENRkXz6assC3rdWxZQg4M7g2iLxZhUtJ5vL8PM2XA2nB8gW
20911	payment	2133	2133	1874	1	1	432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9VXYB8xeLw61o6s93T3toi7TReW9Ly6baWZctgdxSe7c1bYV
20922	payment	1397	1397	1678	1	1	9271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY92u6UdSpakWbGBUZ2CGKLoKbJcgM4aCumqUQyoPxt8qRYH7q
20923	payment	2134	2134	1874	1	1	415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7WEwvqDqEzjSdDxVjZafXeGvtLJXPCDsgBdVSRdey5EBHsCB
20924	payment	2133	2133	1874	1	1	436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVHiCF77X8CBHozLEZChAzwCRVRW8qMLxv1r4UDZ1mySscxFM
20931	payment	1397	1397	1678	1	1	9274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2J2mh5ETR8yWDHcgo5vSxr4wEu3rq6Ceya6PDui139qx2or3q
20932	payment	2133	2133	1874	1	1	438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYy56a6y3fzSkgvQD41frhntnxbkZ8cSmfUiUEqjWL8QhSzP8
20933	payment	2134	2134	1874	1	1	418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZjz23WHZkymbtVjpMGFu1RvTwCCuaft5Q3H5wCNEY9SZwNJh
20935	payment	1397	1397	1678	1	1	9275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6icJeer85B29An7RrX7ddWwYZkCKqmQU3WEPwLWMsQSYnmSY
20936	payment	2133	2133	1874	1	1	439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmm7Rww8XdM96HgZ6RXUvGa5kG8Z993nn2DDCLconn4hSYLZEJ
20844	payment	2133	2133	1874	1	1	416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJmEKhTP3FWDyQZd5dx7Sh6JMoGrpoH8d845s1hyLcRiER7Bx
20851	payment	1684	1684	2142	1	1	69	2850000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5v2NUNGMKtWp6Qw1sBVZKvgaafQxEPridh1MkbRgr6KqVGKMH
20852	payment	1397	1397	1678	1	1	9252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrYG9pkMnjBEh8XcRFLc5NtLDUPn7oxtT9i6ApiMBBA1kic9g
20853	payment	2132	2132	1874	1	1	102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEstSjTUEkxdVfJPoxnz4kb3V5QeCPqsxWuETdruEJHFqc7q5
20854	payment	2134	2134	1874	1	1	397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzXzhdwe2YFZDwvgCMpwSTLwtcXaUDPeemBD296SHq7YQ9oaX
20855	payment	2133	2133	1874	1	1	418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyLtCeNkuWhVuYXZmbcwcMRLfZrJabVtvTA1CuJat7pSEAWtj
20856	payment	1397	1397	1678	1	1	9253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjgBAU5y4nApWtfovpXTGimxesj3j8K2E3fXoC7YaZuGKFAJx
20857	payment	1726	1726	2143	1	1	8170	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmkLuBpyCRByLnyX2ktdfxTffAMwerkcSDqPWpGDhSKb84d3jB
20858	payment	1726	1726	2144	1	1	8171	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ5B2UUEQjPfbDo6sjvzgU8Br73PtAZ2axYHZqDKjBsg5UGjoZc
20859	payment	1726	1726	2145	1	1	8172	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDhbsqV2EtRdqbaoBqYUL1p4jH6kC36WTkrFi2jxbShXPai2Pw
20860	payment	1726	1726	2146	1	1	8173	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJZcrr8SD6gCyGu5ewuZ4da8BELytneRPAJjsLMLRPrKvi1JBQ
20861	payment	2134	2134	1874	1	1	398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWtozoudFrAnop8BZQ5MhgEFJJHRXQuJUgmrzenNjtSa15Vm3
20862	payment	2133	2133	1874	1	1	419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeDBGX9udDWFaM37PGbQUuLQnDYpvF2VoUp7K6eUUru5rwsQq
20863	payment	1729	1729	967	1	1	4	84100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAMdjwycJSNdBgLUk36AdJCzDX7hgR5LmJS9Cq2aNj59v2iCT
20864	payment	1729	1729	1087	1	1	5	111104720300	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgrPzuFGLQjwkS1X2bHAbo31UaSgUeKS4ndX3BRMRtzYFwidY
20865	payment	1729	1729	1207	1	1	6	91225055850	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWV4UQ93EhRoG4c2F1rKjmUSMr9biBDFY7kAufPuiZH1UeCtt
20866	payment	1729	1729	1333	1	1	7	164804343100	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwGCExvfoNsDGxdbtLqirM9iS8LJhmagoSHPaNyvcsBiayxU3
20870	payment	1397	1397	1678	1	1	9255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepBst2kF4H7H6DDd7vuhy5cx8VRNX9bHd8i99BTS8H5rRaEXG
20871	payment	1397	1397	1678	1	1	9256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAapGEBVjvaQqFnc2qYrr8pUKqU2AD58e9ey8WosGTzHiYKuB
20872	payment	2132	2132	1874	1	1	103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUcsAR6PQ4Vy1iLQinsMyYtd6SLwoaUfPnyBopUvMzzbnMTJc
20873	payment	2134	2134	1874	1	1	400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DXEgdheqByoEpTCUhkMYfyYQrhCuNcYrja7gmu3Ry6apVGLJ
20874	payment	2134	2134	1874	1	1	401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRnE2u3gJ6kZUimugdLo6WWPFAuhMjwaM86j9caZxUxJa6ro2
20875	payment	2133	2133	1874	1	1	421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiLm2uGZXxPKU9XjR3DdwRepe5m7XKhDs2WxoWRB7NLqcyQtw
20876	payment	2133	2133	1874	1	1	422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeysWftMdD5419XkiyMm7NpRFGzko5nExyGTh36V95bQvoKWiN
20889	payment	1397	1397	1678	1	1	9261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9EFMbgY75pjCwTDhoSyudKXXP9UVo7mfc3QBG53vi2p5cjc5
20890	payment	2134	2134	1874	1	1	405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSwp9DqSUs1pokfMN6LuWgCyqUS8EyKQELd8uoTybGqd33Stf
20891	payment	2133	2133	1874	1	1	427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9pAnr2B1ohzUoKR4nFZU19CfhkpudwAAEQmvRoTKejU3wX4x
20899	payment	1397	1397	1678	1	1	9264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa232RzW9NGb2v8duwH16or2Nj8uegyBvuBQNx5wisAM3cW12PH
20900	payment	2134	2134	1874	1	1	408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodhnpPBMSwdniXeEHnkar5RyTpBwaAxMCo5eyLqMrDZkFjd16
20929	payment	1397	1397	1678	1	1	9273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYss5sdMENNejnoPykVPbBfJfQhRFCUo81SWjc91cj5FLf6fZN3
20930	payment	2134	2134	1874	1	1	417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxv36m7p7jDDnK24nfodhPXB4ctf4pEMVZLAUtqFJGrRWqSxt
20978	payment	1397	1397	1678	1	1	9288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNzG34Qh4jehTd64kcX1MSCWww4eu92E6GDCtvSTXRKRQEjT6
20979	payment	1397	1397	1678	1	1	9289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9iuoxQ2ts3RT55EuYGHbzfPBGts46dqXwPi99WgejKPJqZ4A
20980	payment	2134	2134	1874	1	1	432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoNzqSevxLCJz79zJhkB8dr3tkVwFiHstwMuW4EpdiLnRYU84
20981	payment	2133	2133	1874	1	1	451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhpJchsQaqzTfTm22TdXSo1QU99zxhAisvQgWQgcwvB6Y7hCJ
20982	payment	2133	2133	1874	1	1	452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXbP2aG2mmadbke9BN4Qgg1yxLsGDK9naqcgtXCBt7pTaKmCp
20983	payment	2132	2132	1874	1	1	113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAqqk7a6BEVofegDytsPpNU6haTS4LiyUNHWnpaK4EEvS7STg
20984	payment	2134	2134	1874	1	1	433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLHjeEwoVTSDhszkutsPi85cTE1uGjwK65s99KAvW3e5GHt4R
20885	payment	2132	2132	1874	1	1	104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ563oGMaJbq85H59QChhL8TU7HyAWsiPUZMbK6KGFLUtNFiEiv
20886	payment	2134	2134	1874	1	1	404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7w71hUrn1bBEcuv7HddZ7p2WS5Bqqdk4ntWUy9qnk5h7DQFX
20887	payment	2133	2133	1874	1	1	425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnz84a1QkdFDdCXkdSsczL3XyEjhUWe6vYfy3Fk7sBiVu4kDF
20888	payment	2133	2133	1874	1	1	426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xVU9umrUoDgyqsYwv4BNnUEE37Vw5nwQmGbH1vMN4XkhYmR8
20901	payment	1397	1397	1678	1	1	9265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4hM1CLd4Kkjfv6naDRudCJbibs7g5zR3JvcqFfnYP7qUTLZm
20902	payment	2133	2133	1874	1	1	430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YFq6LJfa1UFFXjoQXvFvnyKV4RudEgccyho94jVVTA9X1tdy
20903	payment	2134	2134	1874	1	1	409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADkvukYcZ2KiKhsavYr9kdj1UGxumJLX8xBPMndsAdVLK9rw4
20912	payment	1397	1397	1678	1	1	9268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ2XAbUjsv8jEAP2bWnCzs7Th5uEfL8WCxSEJvQkPDJqtZZ1M
20913	payment	2133	2133	1874	1	1	433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkayyqRWMBkDKjopKbd3fiMnoYNyqvn7DYjFdkqHFf9xJ18YsW
20914	payment	2134	2134	1874	1	1	412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDxRBJj6N353w1MgTkphXppbUwKDxrFH6UuRzGHbuHDNaD8cb
20915	payment	1397	1397	1678	1	1	9269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbnyMsP7Tz3mwcWR1vzMxsGvYZrvHVkmM1k45hzfuaAFr7fFm
20916	payment	1397	1397	1678	1	1	9270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6Mcp7Jn8ETX9uohjV9fkMutgXM4TStU5MyENU3s6A5S17uAb
20917	payment	2134	2134	1874	1	1	413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oF5mDqf6VzEqdtbBsZeNa1Xi2UQvwpB67smRCwZcPpuVtiLf
20918	payment	2133	2133	1874	1	1	434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3H37ozaNXWF4bgJjhnRsgfjPmix7E8U1BvDHNyJ2rcjr986o
20919	payment	2133	2133	1874	1	1	435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdPWbyyLxLzyVnNH6WuEzqsRqH7fg6187tfJ9AXckHht9CyJJ
20920	payment	2134	2134	1874	1	1	414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRZSgYbsxRkF23v14tX5TmZxwUXBPYp7YUA2jYKZRnnxKkcCG
20921	payment	2132	2132	1874	1	1	107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaspGA5snEuvobRUXt3DAWxvb14J3xumBLAw8HjkNDru8vQMT
20925	payment	1397	1397	1678	1	1	9272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryPuJLMeDXS9Fb7JpZoyddzpLbArifSjoZMspPqx8ZRc4f3Wb
20926	payment	2134	2134	1874	1	1	416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv81ptvfJppieDPLJkm3Cfz4AtqiPMaq5SiGEQ5TptCTVEqdbn
20927	payment	2132	2132	1874	1	1	108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZE7TWLnmN1UKX1KksKPTReNgRwTPSdbD5zSL998v5jsMadjX
20928	payment	2133	2133	1874	1	1	437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsXgHNeuVXTkYiNzKhzBtdu6g86gp3tR57SoHby4U545VN26T
20938	payment	1397	1397	1678	1	1	9276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm34xpWSnSBkZBCSjBzkqp6Uns4TVoxSWrAeyhYp7sdQa9V5yW
20939	payment	1724	1724	937	1	1	8	1000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZ3LPufkEdPHcQ3UT4Z5o1KBAJaLuRPKBpDcH4bBsn2dwcKgLgb
20940	payment	2133	2133	1874	1	1	440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiReDEKy4NWpyxgBmm9NJrrEF6EuyWpXY8XRLPFqZuLL4ZsJrv
20941	payment	2134	2134	1874	1	1	420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59YredC4Wxm1TDi15norVWn2oHpL4PSRcRFqW14u3ChXHw5CS
20942	payment	2132	2132	1874	1	1	109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJboxsh6AUo1faxhhLLRHhDKTx5uyHDMmQJmhB7EaKdb6JK1qd
20943	payment	1397	1397	1678	1	1	9277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZud7yXoJwQEBoZTXHEymxq3BNQBp2JZCwBNNsAtCYvgz5qKFJ4
20944	payment	2134	2134	1874	1	1	421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLWXtGTvSf49hsuaM3y6wC4vutMtdbFGXBzN2ddrskKkPEwKt
20945	payment	2133	2133	1874	1	1	441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGypqJHbdjkCJLunM9RpSoWn7NEkZbXCMUnqDtuFHnhbEaPiRQ
20953	payment	1397	1397	1678	1	1	9280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSP7i49JcdrG1w7Sz9zfxPVB5qtWbEkc6oDv3wFCtDD4TUkgu
20954	payment	2134	2134	1874	1	1	424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUa6QJX4ypp8z9PTJVfJ3kK1cATpDoXi233RaXkNH9a4N3q76j
20955	payment	1397	1397	1678	1	1	9281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoYLCqrsV4SMdrYeiStGEcb6S6fN32DviMie5EZ1hYqdNVKuU
20956	payment	2134	2134	1874	1	1	425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2xmkCbyg9FUDRR2BDz6qnCz2Lztw7LFiXy9Mumhqoc6iireR
20957	payment	2133	2133	1874	1	1	444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedVKsixcjeu5iHeqbNXcmQ1oVKohCAf2Zs1k658cGfUPEgVxL
20965	payment	1397	1397	1678	1	1	9284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnocUnY9WjXqH3si72UNpLdqfiSutQvAMagcEnsNrTu5ciCoC4
20966	payment	2134	2134	1874	1	1	428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKBxwGnQUcpyYg2nsBUybqjJv8Yn2DqZPa6AF9uawwju7Nzb3
20967	payment	2133	2133	1874	1	1	447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf8rnKixAF8auX2KcHUTtDgiphWLCGEm4CkmpePoBYD3b7DtJ
20968	payment	1397	1397	1678	1	1	9285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUhJ5BMo4hhnKjLnRUFFHhXvS7cpeFdMyK9Rk38pCmMQBxP9k
20904	payment	1397	1397	1678	1	1	9266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXAW1v7sGhp7dMt33ckF2wTKDHPp4eEiUEt1GCerPyDj2anMw
20905	payment	2132	2132	1874	1	1	106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXoqDEHVYqtL4a6k5SsQeRXtSREsK1p3LVdsjYj5QuoiTrXSf
20906	payment	2133	2133	1874	1	1	431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGxrJThqZw5qMj8JD1QSsD6fSgaTupLcP4H5NJtdgW4qwgzbG
20907	payment	2134	2134	1874	1	1	410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv48JSQCR6fwdhuPQMCoK8j2CtfZPvTP9aysXUHUnyhe2ra7d
20934	payment	1724	1724	1303	1	1	7	1000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpYdxCGF4bjmRCeCKu12WsVfJytHdJo4Kyt3LSSfy5rCzx1qGu3s
20949	payment	1397	1397	1678	1	1	9279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYC9EdtgGMDj8aiZmxdGMfeHNB1gMcNV2eCkWvyCqQ6DBC13H
20950	payment	2134	2134	1874	1	1	423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5XiZkgtkzhx214Nv2QoKBjSrTzBrSmzczAFFVRJEJHAAUKgz
20951	payment	2132	2132	1874	1	1	110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrMawZnMEE4H1veUEawiNQZ3QxDUikhRBktyyiZoHvL22ksoU
20952	payment	2133	2133	1874	1	1	443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGUKkbuK9gW8jatJkiMLUnm4UGMoLbxbCFcqVdAY2QgiQpFuC
20958	payment	1397	1397	1678	1	1	9282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrFRSDkgsuQRebtEjAUMYvmkLGUe2h8udvWBhceRbU6S7e3iY
20959	payment	2134	2134	1874	1	1	426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJz9sLkHVh9qLtH8muBo9oxfYtFmyV6iChBCVLkxk8AJMUoVU
20960	payment	2132	2132	1874	1	1	111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvW4f9ZpVvw29TDby6hRXc6cYyRgqDfruKFLSf6UEed65t11JD
20961	payment	2133	2133	1874	1	1	445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UKMDR8V9BcAofhZpLHxeayaEnvbkFFEksDmCZyH2u6mixcjo
20976	payment	2133	2133	1874	1	1	449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrAJt1wtTEoEJ8nyX3aKrJu17gVuESSZZtDeVkhSb2q5Qv3jH
20977	payment	2133	2133	1874	1	1	450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGeLFD1nk4NnyGFTZdY7zDejATi4dDTnRCsDF7drziZUTFcZw
21011	payment	1397	1397	1678	1	1	9298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfWEfPqhPw1MYLpFX3fuuddJCa9FihrX4bXAhG9BhPfp9KoiS
21012	payment	1397	1397	1678	1	1	9299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2hVYG7MZNVRG8Zpodoj3hEnUgZUE49znauXeT5KSNxj2odm
21013	payment	2132	2132	1874	1	1	116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6FcwnjLf9uV5GtJaLFYQwkAS4YZ18HbDNejgERfN6M42NBJM
21014	payment	1769	1769	1769	1	1	33	20000000	1000000	\N	E4YPiPN94DkzUvkiy9YfDy1zax1wBaiHNQ5WRg5zspB7Tyxngw5MS	CkpYnqfAnsUHmwL2khJdyNKf9cV4Pv3zwN9mKijr8TyLkranoqEEE
21015	payment	2134	2134	1874	1	1	442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshCYqvamCtNwSrMF77VNBd2wgLS4RgWiiwjCck1HwYQn4pQ5L
21016	payment	2134	2134	1874	1	1	443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUths3TSvKR1UtapmEDK5ek2jQL7VLnLscWGRNn9wzwtNkxS18
21017	payment	2133	2133	1874	1	1	460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYRErp9UgcoAVc6DAVbPj2v5onJVopCAbTwsimFaS5geGb1jY
21018	payment	2133	2133	1874	1	1	461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n1A5mqAEmjoPP7UuM5TqpZauNzS3w3v2NajYgQGu2GxnpwhH
21019	payment	1397	1397	1678	1	1	9300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i3Yzgb8cU2cxAq2xsV4pknazft6GeTPBJd9LXwfuLEt2Yq9j
21020	payment	2134	2134	1874	1	1	444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4vZDi344BqfaMJ9M8facm43nzwTs1qedrvYNBbDWzcUc2Far
21021	payment	2133	2133	1874	1	1	462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzX4rBh2q9joFcJshi8Mmu61U3VsiD8wr7PBN5zVM3vdVnhnv
21032	payment	1397	1397	1678	1	1	9304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzHqW4iBLeP3hw74bKYbssXWqF5kWUA8DjVfjr5iEpg52HPB2
21033	payment	2134	2134	1874	1	1	448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYum9FHaRPPX4RLPbNpMuSfSCtq6wSYRQkAvuWtaekdjzKsEmcm
21035	payment	1397	1397	1678	1	1	9305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdb5Yh3rqsoa1hcXM9XhdWjdrNjJNZcRzY1aK7F9PussNXqqu
21036	payment	2133	2133	1874	1	1	467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yY5zd7ch3huk99ZD4YmahUdhLfpN1cLHVqDH4smFDNY4PgZt
21041	payment	1397	1397	1678	1	1	9307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqymd3dpPuywLRnRgNCqANdxGpHrXXfzqCARJLvpqHdao1NHVY
21042	payment	1397	1397	1678	1	1	9308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPbTQFMg6QyHyUa8furcE2RFDWW1hrjVr8nPA44EteBD1Drqd
21043	payment	2134	2134	1874	1	1	450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmADBaRm8g9rpXcvckcHsrJPL8BmaukmuS1UBRRH8UJ6XJwoq
21044	payment	2133	2133	1874	1	1	469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdyg3gYuUfKzhTm8TioRt1Qe4z24rA5g2kr7GW1hbj1bhYyrc
21045	payment	2133	2133	1874	1	1	470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAXupUvPAKmNib6r2XqBWNxNCvyeVcRKJzXSEyKioKf6m6ZVe
21046	payment	2134	2134	1874	1	1	451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKi2w95Bhuf93Tr6d9cmDbrYd4rsgdw4PTS6gAjMFtmFYTpzqi
21057	payment	1397	1397	1678	1	1	9312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4L6GXBzE72UewbBnseya992XGM3gkesG3yyP5AgiT1kvN2Kfg
21058	payment	2134	2134	1874	1	1	455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiDkiY1XbqiNXBNdeHezVRDM1Gt8q4QjNLbgtUvQgHVgFjxgd
20937	payment	2134	2134	1874	1	1	419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv8hHXtDXm4aEj3YxBFMA1NqWhBhDWeV9Cy4Rnqshfnn48Ybh
20946	payment	1397	1397	1678	1	1	9278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu46Un6rNy8xz9VYpWhwuxTkhsWfyR24YmEchsPns5bMR8gryi
20947	payment	2134	2134	1874	1	1	422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwYzRyEJX8UUWHQf6CGx9S7vhrCXbNKt6quSQZKLub6iMSAr
20948	payment	2133	2133	1874	1	1	442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetMWhpD4ApmHGVbxe9MsCYEfvQEG61dNQpDCukCSFa4hQK1kN
20962	payment	1397	1397	1678	1	1	9283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn96Bf5bi7JtxwZkvwrbxyY9vCDmm3akLgpkG6rwyVk59WKbD
20963	payment	2133	2133	1874	1	1	446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdHsQ1t48Sd2Nc8NeUrDwuWvE6Sttt6dK5JxWsxrTevjLdnn7
20964	payment	2134	2134	1874	1	1	427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9Nu5QN5fmQn8eQi2WrDXw7ARABzeomKDAb7ZfeUttKhieizJ
20971	payment	1397	1397	1678	1	1	9286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpH59y9ZMt5q9kWXiZBjhN2N3b95RWxYtfFkDAz23kSy2YSiJ
20972	payment	1397	1397	1678	1	1	9287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MHnkdhHv1aX88ZH4UyHeMK5PvKoGU72MmJWGdkv1BD68e5Qm
20973	payment	2134	2134	1874	1	1	430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruLYfKYyyikaoyMLfdUXNfa6M9QqYadhxP1gHwqZB8Uu4rGAD
20974	payment	2134	2134	1874	1	1	431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaumr7fmmJfnAvJdUtzxp1WLhXstRYhnTKtJ4KguA5WbZ4JQCc
20975	payment	2132	2132	1874	1	1	112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyUnKh781JZkrtWcawBUYwCAUSucttgD4wz3R3ubC813F4rjq
20985	payment	1397	1397	1678	1	1	9290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHEWXpdEycpdZxG6mjgmjtgGGh25r7UvtzPwiiMphfQr1Ku9p
20986	payment	2133	2133	1874	1	1	453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68eaxC5679xe23S1eAyoyKMDePyagDCjLSDogkVLc1fJtN568
20987	payment	2134	2134	1874	1	1	434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFF4NacScHnaVtJvJRJrBm5q8GHJ4Sd5NY4DKjLVZpNEdrzUv
21022	payment	1397	1397	1678	1	1	9301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPwGecEBiRq3hvtvWk6cYDSja49RMoSrTfZsTLZHvchs7aqyC
21023	payment	2133	2133	1874	1	1	463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXdkFzASDztWWXUuJvAZ3HK9NvzPAczfgrXffPEaPK9MJT8nd
21024	payment	2134	2134	1874	1	1	445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbPV4Uakqn171YP9WxeYzdRRJ5V7fqqpNy77XBeVd82qgDe4h
21031	payment	2133	2133	1874	1	1	465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwnrwEBsS8PeF2ZdKjVmAj5ffQ819qvV9TM4hg94ztGLNVTYA
21047	payment	1397	1397	1678	1	1	9309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHisR2kYt2BcHBHtL41p54kr1aEcUtoH8oEqUTL9PhudoT5Qi
21048	payment	2133	2133	1874	1	1	471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZFAQjBhpBe7teXPMqZe3aPmkhw5UqgPEpBKescrNXTDn451s
21049	payment	2132	2132	1874	1	1	119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiHf5Zdp29xheAs9pz5tT3wcK6fMRjxNziwzv1mFhS4jtnB2k
21050	payment	2134	2134	1874	1	1	452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKw3uBMsgquT2xHbX2DCs1cQcmfG3LLtfJd3sUgDpnRJhcorcb
21060	payment	1397	1397	1678	1	1	9313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbCQtG12j4EYbipr36aqLG7GYz4atBQmAtdK51jusXaNh9er1
21061	payment	2133	2133	1874	1	1	474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH8KthEzS1CDyeugTeG1XFeN5jST4nno7pRhV1rSigkMqtL4r
21062	payment	2134	2134	1874	1	1	456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SCLCVX6SgvygEpk3YHBhvFbLH38k7CBf8XGdfJAraR9c97Xy
21097	payment	1397	1397	1678	1	1	9324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQ1oWS5bvpWFUaJWZ5rPB1dqg2xwYNLH3Hb7XyzziSMiC4Gor
21098	payment	2134	2134	1874	1	1	467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCFFDvjEarZDNPaStyYoKyxMpD7CL7M6fCv4LgFGuSUb78DmQ
21112	payment	1397	1397	1678	1	1	9329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYayZQM7bCwgVJAQ7c6PKwypUvMjUq9W2rSjzGRSNEMHsH1nwVN
21113	payment	2132	2132	1874	1	1	125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLM3nyefuPbdFpgayh9ZxVsKJdt6vTTR25JSYf1qrBouacEJs
21114	payment	2134	2134	1874	1	1	472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJAwePBLR667crUKW7MqB3aJvJmD2gxn9USdvB72u8mxZbMSj
21115	payment	2133	2133	1874	1	1	489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCSb9WHb5wGvMXQrHZgL2QTc4ax8vtg2BkXc617CAFEZxGDHJ
21150	payment	495	495	2149	1	1	1	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWwhYcQRTEehZH1GY5qye8AAtXbkYUk1vvirtpEizpZMq2pBf
21151	payment	1397	1397	1678	1	1	9340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsgv9oZDEh2tTJxJSiKiWtrj8GrMo8GHKjWXvwyVkcxypmPiL
21152	payment	1397	1397	1678	1	1	9341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6Pv5zHUfpdaZF3W4D41LdgQM3KSHz92igZaPS5dQ6CY1qyM8
21153	payment	2133	2133	1874	1	1	500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQm7B3T6FzL1JCnGGdkQ2xXjD83if5a3nys2Mc4u9DAvJRQEH
21154	payment	2133	2133	1874	1	1	501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLb2SryBmcZp3kYk64hFV7GdB8115iWWVxz33K3BjG6grvuwA
21155	payment	2134	2134	1874	1	1	483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyGsqSPDxU1dT1GNKovfqEJVJcqzt5iYcWavzGA1577H4yzGH
20969	payment	2134	2134	1874	1	1	429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhG4GNMyVbnzif39EWh8opXaeBBJ3PoXMzeL2CEnWkfFiNZeJ
20970	payment	2133	2133	1874	1	1	448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4dynbXyXA6GkBFXU7cXYu5MBUUkLWFHS994Uq273SnGQ54vg
20995	payment	1397	1397	1678	1	1	9293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLWZFkphbbXhZxXoAb6FK7diPbWA5RPgMaY95VQ76tBLVWVR5
20996	payment	2133	2133	1874	1	1	456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRTr7Wd9Z1iQ9Fm2Cks39tzw4CsjhnJkZroADm427BhbjwSnq
20997	payment	2134	2134	1874	1	1	437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6YkqAMZoHkp17hwFuLB4VS6qicVf9w9j6B2U6bLtAR6JhsXU
20998	payment	1397	1397	1678	1	1	9294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7afoVfb6bMUhfYCgaP5oyqz7oVqz73b3mqF4dqzqUj53zhvy
20999	payment	1397	1397	1678	1	1	9295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wZ9Rbcd4J2ndm19qmopGrt4cnAUCwQf72rYNroDeoK7d8fMC
21000	payment	1397	1397	1678	1	1	9296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKH5GRB2sUTS8wyXwddW92cmUJ3DkbuF28w8GikDFEbaDTHc4a
21001	payment	1397	1397	1678	1	1	9297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQurH2W7rutbp22KXY73NbLYX4Br4uUG8NBwPgBPXG32KHhC7
21002	payment	2132	2132	1874	1	1	115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrLpHLNJm1o57TJfS1neTH7VnqsrGnBG5brV8axbpCCsnrPwe
21003	payment	2133	2133	1874	1	1	457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuwN644a7f7eX5t5UNgA4vpKgee9bREjs3JLpaCyF4qjx1ane
21004	payment	2133	2133	1874	1	1	458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27yYPHo5RzhQAJb9yMNMVa8PUDCHnbm3Ns12hXDTpywxLcbxo
21005	payment	2133	2133	1874	1	1	459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fCWRzhSh3xRcrMbtUrauZegnkqVCMFtGeQjC2ME6SJgFEY8y
21006	payment	1769	1769	1769	1	1	32	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEskq9im1vQMKJghMohgJNVDrNW5bPSVPHw73rDggfmdB8rnrJ
21007	payment	2134	2134	1874	1	1	438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP8f7san4ih3vGU5M2aHoaYhCyjrXEgEHKZbXoY2YQCrqb9Q3
21008	payment	2134	2134	1874	1	1	439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXak3LY7Dm6cbFArNE6ABJuyPc7dN9Hbe9s7rGqXxs65Ztm6T
21009	payment	2134	2134	1874	1	1	440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCy7yU3QDStakvxYo4NUmppN3PRVnYRevXaPh6ttADW3SQcuXm
21010	payment	2134	2134	1874	1	1	441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudxsoNEeHkFPEHHHDKNZY8hsALscYHuSikDXVeFvYh36ZHezF
21025	payment	1397	1397	1678	1	1	9302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYD2JSzJLEvf9Jc4yndFmongJNgQb5oCjxDZNqvDdVx76A4oG
21026	payment	2132	2132	1874	1	1	117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fDjLvxfNWizvjMjpPSGe2qpSC5LMyXTcLSLRUafq5v2dDE3H
21027	payment	2134	2134	1874	1	1	446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWvmaaCGMkXbTDVuuFfjjCj3tAfQc1CSGCKc451uhKxZVzPiS
21028	payment	2133	2133	1874	1	1	464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh23pTVgXbngjQtxsiM31Nzvk6oDKzxETN6kb5bw2Cz8qorrW
21054	payment	1397	1397	1678	1	1	9311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeuy8Qax6Rxr2paXpTk9aKX4VipUnXhmNi2A5wCWY3thmRghSr
21055	payment	2133	2133	1874	1	1	473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuu9KBgNEqJB9tyiQaksPtYwZbNqXZzWdoms9ut7UKDFk1NqHf
21056	payment	2134	2134	1874	1	1	454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRAyY8fUDvr5g4V1Dy9Q6Pb7ZHhESWWD2FDiV9csMfDRAQPyb
21066	payment	1397	1397	1678	1	1	9315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRGMGkbgjgEbYiYMQ8Q5zgmgLwJTjPFhnucWcQpYkf7mjdpXc
21067	payment	2134	2134	1874	1	1	458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMYUm7yHXkB1GfSbqJTpjBgQNHn14HYk5oHFsEgLHhhNbbUDM
21068	payment	2133	2133	1874	1	1	476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mMd5Yv6SVQbr6RhaDLDknWPyWqhGohhfzWsC7ZVxgvEZCinp
21079	payment	1397	1397	1678	1	1	9319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bhT3gEBrPwcsWFYpZj591ZCgnyFcwoi9JGujXFLnA7t5Ez83
21080	payment	2134	2134	1874	1	1	462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzLc9mGgdxmDz4BLGH8cAMBYbZs28S7BX63YG8wrUvbA2zvBj
21081	payment	2132	2132	1874	1	1	122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJisSuEETumkgPuovSo46RVN7LPjV4cbysQdxDDMCMEHvYqiEc
21082	payment	2133	2133	1874	1	1	480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMupDs45mVs8odkPgkBYJZX5yMHybDGLckFjJ5RJJxNDWivLf
21106	payment	1397	1397	1678	1	1	9327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7unRj9wubhDLUiWAD4c9KbJuUbAPYeT5MzyZFeQayKa7pGiHm
21107	payment	2133	2133	1874	1	1	487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRYFePekzfh896S12yckVftoqXRA3vjwni3ERsb8XCHAU7St4
21108	payment	2134	2134	1874	1	1	470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNoPSiNMZHwvEmQMXpHqniuvCsS47BjripwxvfmtoFmTrXgHA
21143	payment	1397	1397	1678	1	1	9338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5M1bEQKq1Y92mqHm2eCD9tVkBrzzxGwL8wkDHEyJWncrYFqC
21144	payment	2133	2133	1874	1	1	498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREwBToRbiHcAdkQPrXzw9RbNbbGu2e3U56A7UfT5ZvCc4NUj7
21145	payment	2134	2134	1874	1	1	481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XJ3yAXmgvvwMBuFd2Q2K7YbSewQ3q1gMx9cLJqJ6po8WNCaR
20988	payment	1397	1397	1678	1	1	9291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqZa25jUwacjfcJw8F9s2orXdF8wDn6sG57f77VBfUp9ebNW6
20989	payment	1397	1397	1678	1	1	9292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtCNA7ve4K1sJ171pMBHTeswbNwRCW6gVukJaUKMtKTuLNmDT
20990	payment	2134	2134	1874	1	1	435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRftjYgwnJkHXMhnDBpTFmf7aBu7NWX9HdemFvPjUPgfjip4aT
20991	payment	2133	2133	1874	1	1	454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgRtwUPP77ab89oLmpuqaxZU8ZJVeFMB5ci8PuwLn81os5vsF
20992	payment	2133	2133	1874	1	1	455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzzvBBZEXfmowCiv6Thhrrks244xLefBxjRsJF4hEa5u3kC2G
20993	payment	2132	2132	1874	1	1	114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQUcYqMw3ofKVxdLh94dPqkQPNDA7yJHPhGifh3JjQ9BUH1wx
20994	payment	2134	2134	1874	1	1	436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoRHL47P3YSD4qfooTVkH5or7ZiHaT1qiuPvdaAwHZoqPYJ6y
21029	payment	1397	1397	1678	1	1	9303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5hf8akJxTS9AUgqB7uq2q7P1g7mD6ZDpgxiQ9oJvVPBXp2US
21030	payment	2134	2134	1874	1	1	447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBwXYjB6RvZBie2Y54oSKku5mPX9mGjmpS9vhjVsFfqsSXpQN
21034	payment	2133	2133	1874	1	1	466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7dtL47yzK3M9JmTULMHX8xJLhrNEz94pGM1Xo15tytZxwste
21037	payment	1397	1397	1678	1	1	9306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugefYvPcJWuzmBLwbUanvTfPAXb23dZZ3vouQEFXCrWdhrkA3
21038	payment	2132	2132	1874	1	1	118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3AEV6xEiJTKERK6qwvCaZjJupusFrrCCcgLZ6DY4KF2D77BP
21039	payment	2134	2134	1874	1	1	449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUXoqJF7iGGY5bypp3kC57dNAP9CjBAi3EQmQMRwDFx8NPAYk
21040	payment	2133	2133	1874	1	1	468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4eS9hoLZzhzqt6frCmvMrNoctjRVn8bbjkvyRei1bkuGLRXo
21051	payment	1397	1397	1678	1	1	9310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoVh87rsAi6USdYqwKiJg5fxszkWCC69vn2fSQZPJQh1evd2t
21052	payment	2133	2133	1874	1	1	472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSSnCPD4VVSZJVkEGZqVjqbyUyB1xKNVkXKzdVHD7bsEeRn72
21053	payment	2134	2134	1874	1	1	453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAVkZPKTAFENm3DSvHYigsHWSFQDLUj4JUewQiPn12jJC67Ei
21063	payment	1397	1397	1678	1	1	9314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYCTFeLrrvFHncbCo3nViq7tg8tiTzXTq3hsr29tEQ9gtvpip
21064	payment	2134	2134	1874	1	1	457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTygnWztqU3eikzxodAJ4TGTBpwPQd6zXxdE2yX1BbzBk2GMCo
21065	payment	2133	2133	1874	1	1	475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1vyErPVkZMxXeFc6AiQBWELFXNs8yfgjsYphiRgRFZVfEPnD
21076	payment	1397	1397	1678	1	1	9318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEnnF78v9PZPm1z9K9Hps1ug28mStT9gB2eGDRAn5FZpvDAyxE
21077	payment	2133	2133	1874	1	1	479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyN25kDsaRSuKoVe22MWPDXVfvtvn8jqvh7HN3Lwsg1Uq8cx4w
21078	payment	2134	2134	1874	1	1	461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9C3SU4avC5TrKnoxZLsxsVSXAQnTxSXchmXchLBf7RTzye9k
21089	delegation	2144	2144	2144	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7SFrswNtWYSwhxeZZ9a1HQUAJsncUbao2kAhGvxfnqi46Tam
21090	payment	1397	1397	1678	1	1	9322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wy3aE4Aii7i8qXVDE1zoKxDv9hJMppPDqiMseNhdsxvZcBD3
21091	payment	2134	2134	1874	1	1	465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yjp3NGvScMuZUcm4kX7XxhJ4XZvxCmDFqFsVyfYEth4S3CCZ
21092	payment	2132	2132	1874	1	1	123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhoJX79Wn3B6Qs2GF8yp3n3FJCDrnmznS4TCRcDkVfHdtjy6y
21093	payment	2133	2133	1874	1	1	483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvjVGSxN4sxndngdYNBtSAzrpvt4v86RtrLPKpMtr3gbuyrFK
21094	payment	1397	1397	1678	1	1	9323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5BbPJxjEdnuSJ6gVBnnGkmTRTM6EYNkR677EiqruJrjnEgm6
21095	payment	2133	2133	1874	1	1	484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS7XRSFpk4jgxRkKrsXbYdnf2mWSYD6UWRaSQ7PkDnSkurRmU
21096	payment	2134	2134	1874	1	1	466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUKtfV5Q5BV91W5r84TwA9pGSrXQNkT5Xihq9bk1R8MReu2HQ
21102	payment	1397	1397	1678	1	1	9326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGPzazmHUdhxb6yypaKB8ATz9WRSpfUCroaCtrtcTpHj6Xd1N
21103	payment	2134	2134	1874	1	1	469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6TpbzR3tUhb46CFTvS2fWYUQzjhKEPJMvzeQ21D6PQ3zaWd5
21104	payment	2132	2132	1874	1	1	124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6TBAK98W9DzJ2nbPkwsJRQXX7eEm4VcorikbYjyzvnXX5paW
21105	payment	2133	2133	1874	1	1	486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr69Pyjv13CJQhtMLc4bgGvn8ownNG9ooAYHMbZUwuSRnyrtdy
21116	payment	1397	1397	1678	1	1	9330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWPmVmR5waPrRmac1V3VdoFGdSwA6cumMRNES5zB4pVk7bvcB
21117	payment	1397	1397	1678	1	1	9331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5DyzhurWMSmbRVrfLNvJp4x8r4csFPuUM4k9VBQvWWHuiPrM
21118	payment	2133	2133	1874	1	1	490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyJFbpukzogCP1XEQEx6tChu9S2hg86NYrgMje1qC1M8H6uBj
21059	payment	2132	2132	1874	1	1	120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnaC2js5PHQZqmfVJEd9oKNy8Tro5RPuhJbuggxfXF7rwAF2C
21069	payment	1397	1397	1678	1	1	9316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSjSviqNH5iTWQJJhJ9Fuvt8THdM35vNdNGprbgjfN95Y8zV
21070	payment	1397	1397	1678	1	1	9317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKuY4VTKvzFxKZ18AxYN81AZEN4wYt4Wq9jL57Q3f52wZqfMX
21071	payment	2132	2132	1874	1	1	121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRErZcj9Yk4kknq2785R4BUyYkhVQ1d3hdrd1nSE3bCXfZ6yQ7
21072	payment	2134	2134	1874	1	1	459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4g9h7qNoXYpnsvtfuqMa3QWTbGWkRZL7zhDW2KKFSfYpnu4vb
21073	payment	2134	2134	1874	1	1	460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqGMXQAiz7cpPVnmE82pT2paSduBG5jMy1X1jEtqGzbrvaSwV
21074	payment	2133	2133	1874	1	1	477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pUgm9rLn2x8ggBkiQgpLGZ2iT3VmD1ZLC6twHfqffhXmwhgo
21075	payment	2133	2133	1874	1	1	478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpH8oR1bUQi21fSJyQTAyNiwMZsfDVwsAAg8ysED8Bk3ZQ882
21083	payment	1397	1397	1678	1	1	9320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaxqrBYdKFwAJNMdYCEZ1cXajfMA25N7MhxwErQubETFCt7Y6
21084	payment	1397	1397	1678	1	1	9321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKZMuqeZzhiv2SfGxKUwgBj5vPRi8G9tE8hTHD1TzSVaMCyD2
21085	payment	2133	2133	1874	1	1	481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDhYaq2A24jYc4cXdn2kMxWyiV2Xi6k78uRH2KAkk9akGqtEo
21086	payment	2133	2133	1874	1	1	482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdr1fRinbYKoguLSCmwFYQkYe5vaMNJBtkqUanvpEyynb9Dys
21087	payment	2134	2134	1874	1	1	463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LA8HY8XN312Zk1Y5qd1D1qGuEwXs4S93LnGDmEAgQMspU1ud
21088	payment	2134	2134	1874	1	1	464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUCZWt3LAqopne7ABFyBuDTYxt7BAkDGhb1HT8vHEDPWkmTqE
21099	payment	1397	1397	1678	1	1	9325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrMtfdYYhAqdzRGDwFue5p5Mwsw85Mo9je5XK7DiwFT5UGyQr
21100	payment	2133	2133	1874	1	1	485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiaSBjFPHze9K22jdACaz8i7KTpMFnLgA8GfRMv48FB2DW7mu
21101	payment	2134	2134	1874	1	1	468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLL5aW36i95ZgDcvLX9pUfpcoGH2Bkqou6YP7s6RrizVZYVsb
21109	payment	1397	1397	1678	1	1	9328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7PSNA3Zcyqgyd8X2MdVWJ3he6yWyEE7tzpQEyeAyrQq2QYXX
21110	payment	2133	2133	1874	1	1	488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqjwxViZjw2ZhP9vrXSDNKU7QtdxZi6fHRjP8Ei1vd5r7sWeZ
21111	payment	2134	2134	1874	1	1	471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZkXCYS3STmzJcHEmBrhWzmPiPeGbu7qXD2m3uLxUET7jZXUZ
21122	delegation	495	495	2149	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgvcKhf6tRC7Tnt5h3bUsqFTCmGQxqhWAH5qz4HAnfiMkS3fX
21123	payment	1397	1397	1678	1	1	9332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ky24ueWr8NDHQKPPys5L7yBbfcUjMW9QK1DtdPwf4uciwyCk
21124	payment	1397	1397	1678	1	1	9333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjS4snvcViHWEJ1Aajk9VkLVpFzYa3qCM7UN5i2Dp1PENc77gW
21125	payment	1397	1397	1678	1	1	9334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h9fsq4mAwUyrMVCi7Tax3rAC9c8W6rNGdi6HokyS4xbhSz4n
21126	payment	1397	1397	1678	1	1	9335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopmkwhZPCdMakLuYif7MCJy5mKbHedTPEbmn9zkwqPbqeAuEw
21127	payment	1397	1397	1678	1	1	9336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgPcXiw92a14baGjmJJ1bazWmUqXKFucPJJTj7pPrEDCsDUgH
21128	payment	1397	1397	1678	1	1	9337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGqe9fn7CdfbkkVpTzd3A6VzJ8p42NtMiy9WF75Z5r9w9vjG4
21129	payment	2133	2133	1874	1	1	492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aKG3KJUJkCSv3TMpnrXXpt5K9eJjF9vDdeJY6HuyT93EjRdm
21130	payment	2134	2134	1874	1	1	475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcVkvmrPWgko3ubP31H9mMJYYbjb4g9raRxPYyc3ZYB3RW7gWS
21131	payment	2134	2134	1874	1	1	476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2d4wbsaDGvfoUXCdPzGZS7Ruv7bvsRLkpN4kn3mSjTvfWEwHb
21132	payment	2134	2134	1874	1	1	477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDyoxboZkjtr325JGLypQy7gzWXhScGZ4xZGdXDqSkqpvsGLU
21133	payment	2134	2134	1874	1	1	478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6Uo6TnajNNCqnBKprrQwAWPjCHT8qL7mDSA69e3gxHcFgVz
21134	payment	2134	2134	1874	1	1	479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhobtAs86Cx45Ehs2MFew3xPfiuc9f8ncxaoT7FuxEnm6YDRfF
21135	payment	2134	2134	1874	1	1	480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHcY1QbdK8gguQGxRbYH3giv5HU3cPxSkszM64LYy2pv1TzmA
21136	payment	2133	2133	1874	1	1	493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j3Ly57ovhZNezpvryrKcQvQEYnPC7vef1R7tsretEdWKCL2G
21137	payment	2133	2133	1874	1	1	494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUrNWbtdncAhAdW3f8Yv6LoHzqPSQuNKLWzVGF8JndckZcQue
21138	payment	2133	2133	1874	1	1	495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHecTB86hyFxDgH23cxir3Wh7PexWyrfMNLzom4eUFiUUkA8q
21139	payment	2133	2133	1874	1	1	496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk2eWBWhisUCzkDY19JWTW1DvWXfb24yJWXRBdgWtzZadfBFu
21119	payment	2133	2133	1874	1	1	491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnpBJRAKcGQnTt3AR2zicnFcQir2ER4vKuQyAyAuHeFd2cJd7
21120	payment	2134	2134	1874	1	1	473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUT3mXXmJLiCVk684byPrLDxr1gxJKXkBiCXQTiYMGm8pQ4zf
21121	payment	2134	2134	1874	1	1	474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPddguG7wctC56JnVjLH4pjTgKchj2TFgqJW13VQzL4GHsTj5
21146	payment	1397	1397	1678	1	1	9339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyucZtQqLoo33phE27dVLCiH5ayrjiri8t1rPQFU3Tn54Xxx1B
21147	payment	2134	2134	1874	1	1	482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVLefazx3zQmQBh3Qihb4kkz1toNCA95xhP2drAPBiFHjcpkV
21148	payment	2132	2132	1874	1	1	128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD6vbMycKWHQUzQ4vyidLiHj1gj9hrj67zSp79wtV6Pu5k6m1
21149	payment	2133	2133	1874	1	1	499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTWy62GUV81KAvSJRZSQ4m4camtkemwG4YPrgHdMWX35L7Hjv
21160	payment	1397	1397	1678	1	1	9343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UhGK2LefaKeH3H3bfgkDPJcYKtLUWnoAQjdPhrb7CLZwKBHF
21161	payment	2134	2134	1874	1	1	485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7tXVjkCgYUgfJBqc69xm5mYtz45DEuKJ4aaTpzW3ZQtqY65w
21162	payment	2133	2133	1874	1	1	503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2jjb134rG5Fixgn1mjAKaHLHxsrMdPCJBquzL6BQLinBkqe3
21170	payment	1397	1397	1678	1	1	9346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQRtsBfojpXLmeUWQsTLU391PV1DDNaN32ekJPMWZLcKKnKxy
21171	payment	2134	2134	1874	1	1	488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAS7k34LuaeMdGAcgVjgkikM9xoPzAhZj4wduhQPimrUDHX51
21172	payment	2132	2132	1874	1	1	130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQyAH4VP9x9hTPovsgqomyiCptNXEs6y1M6g1cWviSBfNrhhm
21173	payment	2133	2133	1874	1	1	506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCuG1cpNpgMRBrnZNTcvzNv9XFGg2aG1oBbnLUsEFffeLZTop
21184	payment	1397	1397	1678	1	1	9350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANFFUYePuYHwo7PZGod7mTXmmewGKz4EpL2gUKgjwSyPUthY4
21185	payment	2133	2133	1874	1	1	510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb245amRH77DVnQ5rJsFoXAyHWA8twucZ8RH9r4TqzSpDJSNC
21186	payment	2134	2134	1874	1	1	492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq95sU9W3QVd8WEXRm21hReKC9wveCd3nDvWkM1ZDd1P15Tjt9
21187	payment	1397	1397	1678	1	1	9351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAHqXGU1VRWSc59398nGt3Zja1ST7vE7tM9Q7TVMnmcDYrjKY
21188	payment	2134	2134	1874	1	1	493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiS5e47PxT3AAtDGqARt7ffSEzww2389Vgy8HuSobgKLjLaCqh
21189	payment	2133	2133	1874	1	1	511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZid9BcmpUFH8Z1y5jEUbJtLdFySFJTyHF5amT2x7VtybAmHHxe
21207	payment	1397	1397	1678	1	1	9357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAuqU616g7TtZQb55VgU52NR9wE6aGzysmZmBfHAS3h4dHQ4g
21208	payment	1397	1397	1678	1	1	9358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pRhBMbqCmL4NjvEcx36opCCgm3hzXUTkMMgAgaM3oMkXBD5z
21209	payment	1397	1397	1678	1	1	9359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBzJTMJWdhZptfYzE7nUsCw7Dm2A8tw84hA2AousvyvBeTLkZ
21210	payment	2133	2133	1874	1	1	517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYnmPoCGxeCnCUiXh34ALPQpw567bWWmWBVYGKroC1MqoNSeU
21211	payment	2133	2133	1874	1	1	518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a5R7PieG7BaTMXVtLTsf5U1cfer5xx8RWgq73MJ89p7ZL8MK
21212	payment	2133	2133	1874	1	1	519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapkh9Z4a3vQpmqyv33iCc91ywoEZWHpKSZJNMEmwVZhKHaEGv
21213	payment	2132	2132	1874	1	1	134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdzR5x5xAaSKrVC5oGatZGT4rbja3XtDPVvz9G2foLfqJjFkj
21214	payment	2134	2134	1874	1	1	499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiuRNLhNizajzZ6q2vHYwmv53QL5aCc651TTYTsp5udeUz5Wr
21215	payment	2134	2134	1874	1	1	500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQkxLAUt8dy7Bff9rAEbepEer8S3RDPL79RkecoyijPdeDVtQ
21216	payment	2134	2134	1874	1	1	501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJdg9cUA4B6V85Xgp1R6kzgLtAE48n6e3TyWK6HD7sGF2Sx5o
21226	payment	1397	1397	1678	1	1	9363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4bdVrLrz8ZyfGWW7NsHU2oFH5gNsqCTfAM3zqF326nN3fCGN
21227	payment	2133	2133	1874	1	1	523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3qFdqcoGQRYPCXiFBToaeKmDjPUTa2oSCyTaNoMBE2hmai1U
21228	payment	2134	2134	1874	1	1	505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEvUvs1JFoa3e2ooDA71YFXTzkxmxJfBP3gd8y9HgwTGFR4Hbm
21229	payment	2132	2132	1874	1	1	135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7AnTAkm97ayKjXfPFgTVtRGwz1M5nsrP8qNxQZ2GALXm4xfq
21254	payment	369	369	1312	1	1	3	8909100000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpYQjt89XNXsv2kGz2bWE2qA3AKL1p8xdJmhTyh2y1SN4JGEaboi
21255	payment	1397	1397	1678	1	1	9370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9vjAYLL1ZA2yVDdroHwpr1KkYJPMhiu4Y73kXenj8r3z6n64
21256	payment	2134	2134	1874	1	1	512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbKV63TAMJogDZKuKtp9kiWBSNk6iEBzecq1mKd2N5EpsmY8h
21257	payment	2133	2133	1874	1	1	530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJiS2JsQjX84aAX5zdwfp9nAkmbtydywFw6q7PsBWoLoySJ8Z
21140	payment	2133	2133	1874	1	1	497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdZ4xHRzkU41MVDxW18XN43Hvk6cp6cRsnDBdqBniwb2wdCWx
21141	payment	2132	2132	1874	1	1	126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZA4DvVqYUsJ1Cea1KbeGu6pdoCpZjRfZANLqZVkSxEVCeqp5
21142	payment	2132	2132	1874	1	1	127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZFF9RKBL2MWegDWieUP9uvEQh2eCQ54HFFcALEopVtWpHq7J
21166	delegation	495	495	2149	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT61i48hTPdaeHQgWeXqwLoTCaADSBAsFnLC3KC88J5XGpfi3v
21167	payment	1397	1397	1678	1	1	9345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUx8aVywqAdiFanbQzKwEWjWrqgUok4Bxz1pBAs3H4eEtWDABx
21168	payment	2133	2133	1874	1	1	505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpD2wfpD2aNrmJcWZS2XdrK4jW7wKAGpLYknzV8MMnvyovcJSg
21169	payment	2134	2134	1874	1	1	487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTupaWKdXCxwYYdYDx2nWKRRapzzR64U96KKvEViLNRvgLdB16
21177	payment	1397	1397	1678	1	1	9348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBPMH2CpchX9UyWFVHymG8SGZV5kLvRPMbMtCGNGpqgJqvJy8
21178	payment	2133	2133	1874	1	1	508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLuJ4TQxrsycUy1j6Kcp2fXyfPtofuQkwLa8wG9pBZEPCnYHR
21179	payment	2134	2134	1874	1	1	490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aLs9ECCh52zbuWWb3FocdNrJz54VHtqistbHoi6zaFwLVGY8
21180	payment	1397	1397	1678	1	1	9349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZw2ekkmudRdPoRQmATni5ZZ5r2JnTLBNnntgtwVCuVfsBTcC9
21181	payment	2134	2134	1874	1	1	491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfc1BnvknMaYghUF1aJjtnTE319WpapbGqXz7w8baVd79Smd4
21182	payment	2132	2132	1874	1	1	131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVvqUFokwkhJGY3jeiCpToTLRSVnBHa8DFpUUxJA7TcpwDw3i
21183	payment	2133	2133	1874	1	1	509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr3dMePF8iMk4QbM367FXTEsevNxVSN3Ni4GvAfAgnWcGcebE
21193	payment	1397	1397	1678	1	1	9353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWqK5SCLm8wpy9bmwdiptzjuH6b7ETMvnqoD68GaZqTW3KaHj
21194	payment	1397	1397	1678	1	1	9354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkPuZbVwgmWSMnHuKvi7om28n4fuRJohbbZmm399aWcqGxP7P
21195	payment	1397	1397	1678	1	1	9355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVYiPTKswcELFWQBDJiYKkygGDiToi4XkrBhd3fodVW99L7i2
21196	payment	1397	1397	1678	1	1	9356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFaAsd8oE8nbsmid5bd4rUPEFgSXDwTY85CmvV3wgLhUdFs1H
21197	payment	2132	2132	1874	1	1	132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSd7diWjEkFJvDmh4BW7BEaW8XLH9JqroDYh1p2pAuGfKpG9x
21198	payment	2132	2132	1874	1	1	133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmxQTiSrZm42JX6v4Kz1G6g9hoQAfePz4TeRi1kuUcdyecXSp
21199	payment	2134	2134	1874	1	1	495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMSm5etZRtqKNWB7Ja9W9kpFQkSwJSK6uSjfotZp5rz12quan
21200	payment	2134	2134	1874	1	1	496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyyg7tiU6c6QW49FRRUX6TgMwjLyCb2NnbokaCofbuPQUBbtf
21201	payment	2134	2134	1874	1	1	497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZrP9mqpC9LtFUXC1MNYaSVUxpmRoS5ktCTmKHZuQb4mc9Mhs
21202	payment	2134	2134	1874	1	1	498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Zufoz6ZYDDnsWVGNMLNTsYD8AqyP8JLfcp721AnHqqmVshb
21203	payment	2133	2133	1874	1	1	513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKrrpEGH6iRy1si8NcNCwpCqyjRWXQi9t8WoD47upFF2Y6etb
21204	payment	2133	2133	1874	1	1	514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZhYnr83gHNb8mEWgTUTjr1xfVRfdAAezKxmrQNbJL8Mk7L58
21205	payment	2133	2133	1874	1	1	515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZXq1GDikjrmfttEdGu35RyqdfNEqsiVad14VndbuZHoqyEEa
21206	payment	2133	2133	1874	1	1	516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWr6nU81UuRMxREfmvED71ynKoCtmr1gew43zKJrSgdK2cvy8
21247	payment	369	369	1066	1	1	1	4738500000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpZeHbhWQ9cE6eByHSmWRgQtAbpVvVDEyuEFdhTv7NzK9G8nNvJk
21248	payment	369	369	1186	1	1	2	3197200000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpYmvhewAf2BeEK7itGtsSyuB7x2WYdnwThB9aSiKCENYLuWBskb
21249	payment	1397	1397	1678	1	1	9369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKpvmNBGu6k4ip6NDYfmPeRPNQ9PjBa2hSrjFDUani2Xe9mEa
21250	payment	563	563	1359	1	1	9	800000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpYa23ETkRQReA81vMnQAvXTEz5QKURxfcmrzurfFfy7A39FvQb8
21251	payment	2132	2132	1874	1	1	137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvVaxN5K6owF6ik8vALVnBcxQqsuEXp5Bq114T7ZMVAFH2hBb
21252	payment	2133	2133	1874	1	1	529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XPENxzPW6MT1UJpPqrwSRGxAmUo9TXCTWQpSjx19PHF3A7aw
21253	payment	2134	2134	1874	1	1	511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYo4MrUhTuTLYxn1pakcmPZtTMWYnzRByzUKQSPzVZVoKTmqNr
21260	payment	1397	1397	1678	1	1	9371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Cq6YtaPMsqQGG1s5FNrvqCzKzCJwo7WqEKZw6c6GHy6bqLXg
21261	payment	2133	2133	1874	1	1	532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuWvUYn8psu8sCZGvVfVUcQoTrwzLxbRprRGL5Q5AY8diADzu
21262	payment	2134	2134	1874	1	1	514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8Hu42FP4r5qXvumDE2sSTDe1khWiDgX9oBhkLhp5fyCTpagu
21156	payment	1397	1397	1678	1	1	9342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUoDjozPGaUAX9bf7DpAwevePFnN7acn6xUwMLUFa8RadCexR
21157	payment	2133	2133	1874	1	1	502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpDbEC5SbtdQ1k6mXgDjvv8RQrH5y6JAakvoWzGE1GbL6w1W5
21158	payment	2132	2132	1874	1	1	129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJU9Q6wBjAPwkCT4NJZWUVCpAuovaYLrtbyNVhS1zjxZSbkyfZ
21159	payment	2134	2134	1874	1	1	484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWU7vJ9kpsgMgkkSZGfc2ord9NsuCKmd2WbDmpddy3hpzamdM
21174	payment	1397	1397	1678	1	1	9347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJG4PjrCYFuSZq1iLfkWPgJCnKYTsYGZMBJB5tRKnawaSU3cB
21175	payment	2133	2133	1874	1	1	507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTThLZuNVN1KnRwxPizzBCgff2xrtD5AgRKcipL2UTFkgeJmhL
21176	payment	2134	2134	1874	1	1	489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8bbB1VgcbV9XUKG4FSU2KbpXexZGv7LgDFV4xwRFpZnit64C
21223	payment	1397	1397	1678	1	1	9362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4U8VrG9ms8vWwxsJN3AswYRiHQpiZz4TaW7h4okP8e76S4pig
21224	payment	2133	2133	1874	1	1	522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYom3wHVFNtyqf31xrTS6yWRwPQAqGns77hegU8iwsLs9dDo3TS
21225	payment	2134	2134	1874	1	1	504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAfweseFsxEPjg6uauWZ1ctbFQeLZFGjbtceTQ7e8nZHZqJVa
21236	payment	1397	1397	1678	1	1	9366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3rJvPPRk1zYJs9KoAsoqPTrrRL2HfPazazNeNR3segyXugiH
21237	payment	2133	2133	1874	1	1	526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ5re7Pjxuquggt4zSNFfe7Y9WXEXV6L2joW9TGz4bon9eJus
21238	payment	2134	2134	1874	1	1	508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkaqwNvBbdFCdQNapi7tzMGLBmt7Sdj2npHGa6v1SXx8JQhQt
21239	payment	2132	2132	1874	1	1	136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRd8HTVnHNcgAfwkTBAqi1tvDUBn27q454Tjm4coFJp3afZ2s
21240	payment	1397	1397	1678	1	1	9367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBq8ERAj1t2RKEwVW83ypEenMLLGSXkMas1nPjFYyMMUg585E
21241	payment	2134	2134	1874	1	1	509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6cYxsoWY8jYpXqEWPB85MCYQp8CVpoZPLGmDBVSLUSrC7TE3
21242	payment	2133	2133	1874	1	1	527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqynmDYA63BW9VeimnKahxtJGDokF4gYP5fkgQcSK4JbXd4Gub
21258	payment	2134	2134	1874	1	1	513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgWKNmLYNDYHswoFqCDu3aGZy84g42MxJsSkkW7fghv9zroii
21259	payment	2133	2133	1874	1	1	531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdcDadDm4DSPs5ewdNxnewPvb4KbGpHLY6DDFWAu1GiZiUbxY
21291	payment	1397	1397	1678	1	1	9381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaaokzY7BG8yaffFbxQVMAaGKQCtHncXzD3iDuY3GEUmQK4W7
21292	payment	2133	2133	1874	1	1	541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PDPnDns5VAqN3g8M1Pgxu4Z2xisHRLhSFJAPM9PAJLgwd4nW
21293	payment	2134	2134	1874	1	1	523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN95etUB2NBdKoaegdtFw1xBoKAJawvAQ1yJuSEr5XRq99RGA2
21319	payment	1397	1397	1678	1	1	9389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfd9vWJ7cMb7Wy8Qq5E2cxouox7Wo9azQ5MVpRray23GRxqmco
21320	payment	2133	2133	1874	1	1	549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUyHvc3hZBFUp6fwtQ5PfNX1VhtH2XmFb3fGgft9oC3DyyaKX
21321	payment	2134	2134	1874	1	1	531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi733DKkh8npBnZZguY35tWy9ZKwJEtvJWZZsgAxurGdW6f7D
21322	payment	1769	1769	1769	1	1	35	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7L4Lqh8LxniNDYNkDw1szW6bPzmc5t3ooQHv8KD8LTc4k2jkW
21323	payment	1397	1397	1678	1	1	9390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqwfz5GzySzgzKji4C8wLN5nZJcefycUUuvYBWE3WPGoRmjGW
21324	payment	2133	2133	1874	1	1	550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHMr4Vf4gDyfhTYToDiibH9p7ftCEvXNiYggVbGVhvqe7YcjP
21325	payment	2134	2134	1874	1	1	532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgXjzjcSqNJyfLV9A5KiiYLbLkQXjfQ9BVr7RMiuUtVVVoQHM
21363	payment	1397	1397	1678	1	1	9402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyA6J3X6c7HAJCYEx467PTUDjQbR6NTCg78gsxomHTd8an8hz
21364	payment	2132	2132	1874	1	1	147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6rhLdeUppj4e6TXdRGk6fZjQykVz5p3AhdNaBQ3waCwHHqY2
21372	payment	1397	1397	1678	1	1	9405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfiJGWhDwNZagMkDM25H3Y6K8EUdvL2AV4y34SKvWF5NJxqip
21373	payment	2132	2132	1874	1	1	148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGkqpu6TLF6jV4cYVMNHLbNztDXQHpFzWHpBRQFvPjq2CVgrx
21374	payment	2133	2133	1874	1	1	564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRQ3TEqCsLiCp1ePcJyhNyzKuwqvjTDpNk6QdKCGwsrg4PGMq
21375	payment	2134	2134	1874	1	1	547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VyUkWxmiLGr3RaPXDzPNFpH2KaRSDb7GKmihpuPWLJtAQw8s
21376	payment	1397	1397	1678	1	1	9406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupPcbhuUVVA96beUuRiyfh4uxPSDfQiqGCupRAXhqZNgfCdv4
21377	payment	2134	2134	1874	1	1	548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogAs4gtw2ntEK6MPu1mP5gGayM4YN5XvoqpABfiX5MEsTrf8G
21378	payment	2133	2133	1874	1	1	565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhfUSTjHmjnjU4GzHRtr9Ac65a9iVvChCvY14ms27iBm5KJn2
21163	payment	1397	1397	1678	1	1	9344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqw663kbwUBHQsRV9YzGcAvLRZxEkS33g5gsgaqyMWY4eRoWf
21164	payment	2133	2133	1874	1	1	504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdkYj91dWGAqT3ZUUWuVQyZNy6t2iJvS3wno2HRwiCBjXinq6
21165	payment	2134	2134	1874	1	1	486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TJmRi88NbE34smpF7nqr468ZpTccbUTHhRyuw4bprULD9wkP
21190	payment	1397	1397	1678	1	1	9352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiKoUd6XBHCyGeapq7bUeiS1171PqELGMjbYTTzWyumNU1J8V
21191	payment	2133	2133	1874	1	1	512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxypPgENMnzw7Hnmkt3QPikVD9bkDM4524iHpWUKUFYn9oJ8f
21192	payment	2134	2134	1874	1	1	494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3GBZGaUx5dmHgLuJ5PtquR8vG2wwfbL9X8mU9BBkZnXHDQ5S
21217	payment	1397	1397	1678	1	1	9360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiKaTP5HM5SPbPKXjGF2LRYuTUErjT37NgnKFiNpV99BzCH3R
21218	payment	1397	1397	1678	1	1	9361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsefRvvm2pB6eqFZxQrzum2PrHq9uaXNiLWB5tEbnZKQ3tmru
21219	payment	2133	2133	1874	1	1	520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4QfSCpDdPsGi5a8rGvhsEeBJS5F9gezceEDxFRJv7PzvQjqS
21220	payment	2133	2133	1874	1	1	521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGQ77KBp9JAYzhVAzJp5obMdbX2acZsWVA4asBqocaajRiRZQ
21221	payment	2134	2134	1874	1	1	502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FS5TSDceAsHUVPcaoFzhHct88xHubHANCYXaRVUiceWqBC9a
21222	payment	2134	2134	1874	1	1	503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4mw3o5wLsUq1oUdj13cS6mBJyBbetwDuLh9GsuPWzNoRFU9q
21230	payment	1397	1397	1678	1	1	9364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnD8feLL8J4vrqyaJiAV2rT7zwohDN2vhVRPMP8ySW3nUhNcV
21231	payment	1397	1397	1678	1	1	9365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yPR1GU1yqL63psRYAvGUfQq43pmT3ktC4aHBejUmvU1cLfjx
21232	payment	2134	2134	1874	1	1	506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBYzYqZ3usnKtPcqGE1Az1nAd5CFhCHQyqRm7mR8xMQbSX4nM
21233	payment	2134	2134	1874	1	1	507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUKRrVFbqLmta4553v3Pk7xcGVfKLhU3bCP67NN87xud3EPgH
21234	payment	2133	2133	1874	1	1	524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dEE3EF55YjcgGW1LbbDh9yita9b392X5bQzW5P2Db9i5JXch
21235	payment	2133	2133	1874	1	1	525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsT23PPzotjGWfJuAdQEc1KAwTCjc4sXi62UQLbjxVhiykNum6
21243	payment	369	369	946	1	1	0	2644300000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpZTAXKiRQ93J4tG88hPmu5HBJDVgYmju25zTo4B9gBKruZKbHdm
21244	payment	1397	1397	1678	1	1	9368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARHv1EQGaXd1z8DF1wg5nZi6e94nqH23Knquw2a7RQyrsxYSH
21245	payment	2133	2133	1874	1	1	528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvGQ2bn5TbQgHaAeD65T9doMJ12j1GNoc1J31hTAd3ozZ4CJj
21246	payment	2134	2134	1874	1	1	510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24MZXhQqVRRZSCutBYM7PUiiho8JL4Pi41oYmm6K31ifDCoWz
21288	payment	1397	1397	1678	1	1	9380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cTNHGnFxboc4i474NaPYiAY94d6iTWsQmhheacg3z1shPa8U
21289	payment	2134	2134	1874	1	1	522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jA7oLc4KEQ1uqJEpny1wGd3LfPGkHELuMpXYoTYyoijDZ1q5
21290	payment	2133	2133	1874	1	1	540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4yPYLiNf93CPCnYcBDVQSyokRbGtdZC68SoAeQrVEusXfE1V
21298	payment	1397	1397	1678	1	1	9383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7mvys9HbbhsS7LVzeq4AEoPKt2QHW5Bs7fVwWoqPQRyJehug
21299	payment	2133	2133	1874	1	1	543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQeg62G7hyjD1MkQxfre1mup8LiGKMrE7FvSBGfsEmp1wB4RJ
21300	payment	2134	2134	1874	1	1	525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtf5evoshFCwhvisCeMQgTgByLgu91otWDWPCmNt2BVYsLJpW
21308	payment	1397	1397	1678	1	1	9386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiGidgZxpXZhGuxg5dJNsVecjWBsaVrRF1WwNwUQysueV2PHg
21309	payment	1397	1397	1678	1	1	9387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGf82XWPqbNSHCeweW4obUPMk4oykhdVZqe43V2922kUmJEnY
21310	payment	1397	1397	1678	1	1	9388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EXz13Zfwr8YEtJLfJXbVRnzDGhsr54zA2zMqZ9NkpNNBkR4S
21311	payment	2132	2132	1874	1	1	143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhBScXCtzJWHpPgX6nXbyJA6DEMmE4Kkb5GBY3jRgFPLCywyG
21312	payment	2134	2134	1874	1	1	528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNa2YWxcArBYPk9AieLi2jmxFkvf5Pa9Zv4eAVhwHPP4TtCtZ
21313	payment	2133	2133	1874	1	1	546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ1HvbsaCJRmhCeAW1HxsJq1a256U9uwY5JZzQm9rap3J1444
21314	payment	1769	1769	1769	1	1	34	20000000	1000000	\N	E4YPipufvPjbhKEd38aDyqKCfci1y2vteSzhfxspVK9kYWs1EUUwM	CkpZ1xgyRmcbgrCUz6Z3Z6FqrjgGamJ3ETAEYSjfeVDywDNEJAsEs
21315	payment	2134	2134	1874	1	1	529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuEkcXRWWBoVXhYisZzqmFWpNun7sddwtszeX9cSexaHTmPqb
21316	payment	2134	2134	1874	1	1	530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4GJEkemTzojqfXLS7x7skTAeegXVGnorUoWQxydN1xUjg39z
21317	payment	2133	2133	1874	1	1	547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHbPKCnZCv121vqhMQPqN7iXToAi9AYV9EoKN2LaKXMv5S8NA
21263	payment	1397	1397	1678	1	1	9372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vrSBMkMyaiTsfL7XtRgvvEHvukXtVCEnjduUXg9zyfnXWkBa
21264	payment	2132	2132	1874	1	1	138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGzN5AoYNcq1oEcJuKyF3nmwjFxNN19J5nZSzujYF6fe85mvo
21265	payment	2134	2134	1874	1	1	515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHXqJFhkSuMZF6NsGrvN7Y8wDakNLUQMv4fsXWE7yiGQtxb1Q
21266	payment	2133	2133	1874	1	1	533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcUZ8aoGyBPSXCDB8JdjqR3zAauQwuawoAF1Pp7tVPto7hzqX
21272	payment	1397	1397	1678	1	1	9375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGVrdA9ACnxZiE8z2P1WFs8o8AEdNvjGKRnhyiAg9HdsjiEGT
21273	payment	1397	1397	1678	1	1	9376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvKw324yRgcvyBnJXaQrTV8sX9aFkSs3mwCguRjedJjJBPhov
21274	payment	2133	2133	1874	1	1	535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyxESCJobhCwoBXyLUwy93EQQqnr4uyofzUZ4KmnxiuXFg6PH
21275	payment	2134	2134	1874	1	1	518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkMmUkpC7MqcNzSWuo1jMtWaE6SNy3SsenQmnP1LXc4oftsCS
21276	payment	2134	2134	1874	1	1	519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3DYWtr5BSEVJwxRthDKnnWGmVNT8DWYDiyJSqeha84Cyi1YW
21277	payment	2133	2133	1874	1	1	536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVY99pM2mgJegUXdYqzBHHEzg9fRpqcKeohe779YoPE9jRRa6Q
21278	payment	2132	2132	1874	1	1	139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVLrLNor7HFgi4jG3HLTaJu2JLhNMjJCAxgVmtiwpokuBzAFu
21282	payment	1397	1397	1678	1	1	9378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLBTbxnVbWC4Gbor7ocpNK5ZLK84bhquoe8Mbg7g5mx8WsAnw
21283	payment	1397	1397	1678	1	1	9379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VsygYztHR1yJ5VEsygUTNtGwWEmaxpxpgeFbc2ogULuxbh24
21284	payment	2134	2134	1874	1	1	521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbxQUuA78hxfiX2upHn6Bq5Xs9nBWSXhXuTbubFk4RJcgJvRh
21285	payment	2133	2133	1874	1	1	538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYXdrwKGGRwvxsunSNnWisC3RusAsXCXt8QXTzQhYSwzD2XcQ
21286	payment	2133	2133	1874	1	1	539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd69tTKL6S17z4ufAheaDBDq9xF42bAKRzHTLA9QoxrHo5amrS
21287	payment	2132	2132	1874	1	1	140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwNGLB19CGfjNiArPSzb78AeptCJe8NisGoUMfw1yh6W3y6Dq
21336	payment	1397	1397	1678	1	1	9394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JgqFmypyMbyMSn3xtwcMZE2jRre2h1K5CF6zCtJu7NH6jp4r
21337	payment	1726	1726	2150	1	1	8174	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWibGu8XfGfygZX9qi6kx4MXMg22urGEk9J1ZHkeFrCPv8HZrp
21338	payment	1397	1397	1678	1	1	9395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAk6fMvDeFvg9NUfFobLR6A4ti8yrmrxdwxV2nfbt4LFMtfnQ
21339	payment	2133	2133	1874	1	1	554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPBpLVMYLaqcDW6kv95VKMuRFk5BSDFXibwbRki2pDih4oVih
21340	payment	2134	2134	1874	1	1	536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6U5Y4Vtd7j1mrwZW2DEeQ6Y5u6eAvAv9xvmhVoXYFPs7iHrR
21341	payment	2134	2134	1874	1	1	537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffpwfuahorGmw6PSBwsybKSYYEGJJicUn6TaduNdtNRxwBrnq
21342	payment	2132	2132	1874	1	1	145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwcJH6UnqCTS2BLzTJxvRNkAyzPkK6nEatXXjao9wNoibhbbu
21343	payment	2133	2133	1874	1	1	555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZfRUHBEy1CaZnc9XSzKVhG6DoBHrEJbptP98hsDDfvd8c8Qs
21354	payment	1397	1397	1678	1	1	9399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63P4bimJ3ZK7bE13xyPfVxqiZzz48B75dLZYtiUhmRCmv76mP
21355	payment	2133	2133	1874	1	1	559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmJf1Jzk49dn7NZhk66rRU3R58WgnDfAJz3pzM6qKDLrjxVfY
21356	payment	2134	2134	1874	1	1	541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtf5AN3msCfCBhDSgiujmmG6mG5pRFCwhMGD3AcvUZwao48ENB
21357	payment	1397	1397	1678	1	1	9400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1TgbCESTbwBnDDWCNpiNznj5hksaMHP3aKf1wHyAVHr4fCCb
21358	payment	2133	2133	1874	1	1	560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCvLZiSEGLDTRXyt41sHQfZnQgfHPQ8iCuQ5eN9RkgXLrXW3r
21359	payment	2134	2134	1874	1	1	542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZd6qtejj1PZpNHjzFLnqEKeMWSQVHFCw7KF6Qs792spb1cvX
21365	payment	2134	2134	1874	1	1	544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDePgUhtfrBv5xWErHbzgCTVq49vJ8ANXj49J1eUnvF7JEQkXu
21379	payment	1397	1397	1678	1	1	9407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkW53ApsFGb19Uev6bmuevNSCPLZ485ESUy4Hbb3kgDkafBef
21380	payment	2134	2134	1874	1	1	549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdvnpUJrLNiUjCcGnv5j4DCPzuthdQ253nbeYG7LZ5kiqudxg
21381	payment	2133	2133	1874	1	1	566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxaBfnRK1LmNdaF8Ku836db3f4QDFs3yhCSAB1QC3Uf8ummNB
21392	payment	1397	1397	1678	1	1	9411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAd8R8zuoYmr9G6cfHYLrvrpxpofWTDuiB25Qx3KsWffuUGoK
21393	payment	1769	1769	1769	1	1	36	10000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpYmDuURmgGKmdkKhx1x49LQt3URigctYSwhGdLure45RcoL3Py2
21394	payment	2133	2133	1874	1	1	570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdcrnkop5YSjkkLxdSF3AjqD2U9sWgnbq13hLHWHNtu9rVb4W
21267	payment	1397	1397	1678	1	1	9373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmF2wdAzttnd7kRDU74A1QTkXXzihhP7rk68ccSwgYXtANaP8T
21268	payment	1397	1397	1678	1	1	9374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnERcmzZFsPhLtkcEjUcTBWEzpoh9Vmt99t7PpUNc62hY4HwX
21269	payment	2133	2133	1874	1	1	534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnubgy6PRvWa6fknKttxGxcN8fvsrofiUnFPsGjZ3G9MkVhtoj
21270	payment	2134	2134	1874	1	1	516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4U2A1dRJnafqve59hKd2buaRY6sqn2xWetERsZZjStssF6uzB
21271	payment	2134	2134	1874	1	1	517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpD5dn6whttx2bsJy6vXAir8RfcFG21Du6zzd1kZ6Hw5mJHxx
21279	payment	1397	1397	1678	1	1	9377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18am9XCwvmqzMtNRcCMiesh3JAdNvHWSutDhT9Q7eZR4NFfa4
21280	payment	2134	2134	1874	1	1	520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX63T5AiizPWtZjDoisjx2Ezj5iCJxZsmPBkVYCTtkt5q4xHL8
21281	payment	2133	2133	1874	1	1	537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkovRnuYo4vSMJgkwdD5KPwaBaQY8RkwnKSRKc8cpiBCr7vj2G
21294	payment	1397	1397	1678	1	1	9382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUKiBdm9ios2m4pj3Lgwp7Jq6BLMbryXPyTnRrpVFNZeMH8tQ
21295	payment	2133	2133	1874	1	1	542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvxSUaQ5kexi9Lc5XcHCkVVaPiSapm12237nEbJMDqppBk59i
21296	payment	2132	2132	1874	1	1	141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmmfdmHuLcGFtuh3KzxwGVkgfubkczpZFiu1btQ311EQUEQRt
21297	payment	2134	2134	1874	1	1	524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYnLrgt1qxRun3ERQwxcxJ8tX3SHLX78SRCZtzXybm7b9vYje
21301	payment	1397	1397	1678	1	1	9384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAD2PLCgmA39eAXnWNMfAqDAJynqjExw8Z6Fv718kTDKaMjnLX
21302	payment	1397	1397	1678	1	1	9385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJsp7MKa9i9z17NUAwEFvMQh2MfHUaAQEg4YprTbT7Axx4jGm
21303	payment	2134	2134	1874	1	1	526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ns4KcEm5tx124mpGqcWQa75k82ETt77D8s1shYeznMwkXgtR
21304	payment	2134	2134	1874	1	1	527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98urQDLq3GfydnQ4aTDFaLfwEQnsPMYz9qWrxqZTyTawjE45H
21305	payment	2132	2132	1874	1	1	142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1w6JAK6hCovzRFeCd5ukDELUhoVgTfPvuVMtYAKhNGPwkwWX3
21306	payment	2133	2133	1874	1	1	544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLxpBuFNVveX6GfquxeywzfS4XDzRFsebjLBUDR9S59NhLx2
21307	payment	2133	2133	1874	1	1	545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmWH4PnYz4waLcNs9Cr5R8bxHnrWHYaQ8wMsMbznjk3rREYUA
21333	payment	1397	1397	1678	1	1	9393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZzHsUjPU85mZucSXnzWvoewnk6Rb5yJQQ21aZWjWm1Qt7zqm
21334	payment	2134	2134	1874	1	1	535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFec6Vx6Gn4hszP1DbZ2cNXpX1eFx5Awz1TDGvvcPMRNPHVVX
21335	payment	2133	2133	1874	1	1	553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXB2zSPGzjJju3VtN4MrQFAr8gwim8N1gyrF8VGFCdUeZtavA
21347	payment	1397	1397	1678	1	1	9397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8Fcyqmkk2H2mHEwV4YdXMTcGwb69fJw9y9g8sXMGfX3qMrxv
21348	payment	1397	1397	1678	1	1	9398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYtTgTWYdqVV8hB7AcyJqJfRagUXYnHRfC3iHYfHjJvNmF4W2
21349	payment	2134	2134	1874	1	1	539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCLj5Cgd5H81bCJf8S1vNSE4dXYCjUm2m4mPraY1zPenL9mjX
21350	payment	2134	2134	1874	1	1	540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEDSVw7mc1eP132HLmqtKrSr2isS1wdDsZh36y6Gbtj4iSvQU
21351	payment	2133	2133	1874	1	1	557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRA5gMsxAr9gxrKx49gr9VCzfnCR9ShSUkvGx9ps3nvHHUMJS
21352	payment	2132	2132	1874	1	1	146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMVMJVy45j6HZNfzVK7KCJ9RowPYiCJaBtEzxCAaPVMrpFezV
21353	payment	2133	2133	1874	1	1	558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6rFFBrYFY7nNoxqq3DApw4ZTRM3LBLMdtgr3cuj8fCQtPhxY
21360	payment	1397	1397	1678	1	1	9401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5sv3PAtjwAy5jG9dGWntPVQ4tUwn149aBiXRwUTqPRAtQxe8
21361	payment	2133	2133	1874	1	1	561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNoiMtQxeQK4pa8RUWqP7LcLF1L1R3TdVnumpUE1tm1s2FgXp
21362	payment	2134	2134	1874	1	1	543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGJvqZR2UByPEwKFfbrSAowBi51XVYdUFQvLuyVJpviHa7qP2
21400	payment	1397	1397	1678	1	1	9413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucjaWs2Gt9NowtsU7kqzk9uHpasGx4DdQ85KSLxALssHoJH56
21401	payment	1397	1397	1678	1	1	9414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFz7eQ4CUaDWcTUwUyUAXvMPcJXPsfZkUiSFGixnTakSMCYgvP
21402	payment	2134	2134	1874	1	1	555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEG89T2VzksqhA6TUYJvhCSgu3d3ZGgFFuQcphkVe3RUGT4ej
21403	payment	1769	1769	1769	1	1	37	1000000	1000000	\N	E4YjA2r9h6ReNRESkoVjezFpTgnbRvyw6wwGMkMYJJXbWQmG8GHd2	CkpYbir9yggqws7DaNF6VSPeWMy2ZTiSnhR8S1TcxV33PERSwyPQT
21404	payment	2133	2133	1874	1	1	572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKHNdAwcvELdBx3cuiMm8CkCTcVtYeSk2aD5wfEvdEPHUnPrT
21405	payment	1769	1769	1769	1	1	38	10000000	1000000	\N	E4YVYpcXYqGw1TihHE6AVSsn82GVn5WHobQWqTeNgrNxSkqxMs2Xs	CkpZt74bCb9UgwBLaVbGsNzhKQXfGAZrebE4ER7v7K8XkZTDBA3kz
21318	payment	2133	2133	1874	1	1	548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQCff2dKgfz34Ja4cm3oygrraYugN1bMtEtwT7CTvtmHBN36S
21326	payment	1397	1397	1678	1	1	9391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyh7ghCgD51XYaA5fSRr2CUwnnNW6pNsbVCN5PQc9aNFEh4gZ
21327	payment	1397	1397	1678	1	1	9392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TcAqQPNyJ4otKyx915jGEj7p2g5TavUaqDvcg22L2AiLZWu9
21328	payment	2133	2133	1874	1	1	551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUJzodaBmfrCC1SMCxFfGqM7Ywo9ZFdYp4LYyGn7XEkmHXS9y
21329	payment	2132	2132	1874	1	1	144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtxmAMvYUfpSw2rXGTbxbRzGSCgQz1dmi84xGkFxQaRMPES7M
21330	payment	2133	2133	1874	1	1	552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo475Qk9YHASHJJ4NuqYP87JncWHTAKcHg7icQr7Dyk5jwXcF1
21331	payment	2134	2134	1874	1	1	533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kVg9DENovg2UiHnGnBD64Yji5ayVWwECP13iwXmd4pd5XUvE
21332	payment	2134	2134	1874	1	1	534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuFLaTs5N7jC3Mgf2mhC3u2Z3RBAwGtUfxPdqLLceyms1ZoSQ
21344	payment	1397	1397	1678	1	1	9396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ54dvG3R55sFSdriPDaT3RoFN5ZFXsH1p9wCvbGkZhpCVf5bz
21345	payment	2134	2134	1874	1	1	538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfU5JZHVVypvnHrfG9inbHio3KrUNd8ieKp9iXizD5YTBXjit
21346	payment	2133	2133	1874	1	1	556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3n1PpSFJ5RXGQE6XFATSM1xt9LA5GM9AK4xNPCjYaxAeKUBt
21366	payment	1397	1397	1678	1	1	9403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikAYmB4YZ6diKmTEJp8knThABemcnPSFXnMAteWTHEU6PD3nf
21367	payment	1397	1397	1678	1	1	9404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ynyb7XChUGjZWPkuxpPTzxfVmT2UeENqqEJ4mYsdJHWV8GVi
21368	payment	2133	2133	1874	1	1	562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPLHRQJLjQYGf9yfdxCo5mbnhgi8Zarz9VwMxLfXPK48zqTAf
21369	payment	2134	2134	1874	1	1	545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSBGpW9n3AgMsWh1iMSGCeEidPxrdz7T6en3yoWVTm6nFdG38
21370	payment	2134	2134	1874	1	1	546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBNNj5yCzDWxWNFU8UDEV3jdHzvTA2KPgKVAwLENW5mUz7eeP
21371	payment	2133	2133	1874	1	1	563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGaHQdFNsnXUCbp7DKRvpEsENDP23BJ8sq5QYRAQT2XFgjrpT
21382	payment	1397	1397	1678	1	1	9408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxd6KzmUg4TLCPrS2po3g19oZQojuCHfGp398bbUfe9WffN1hi
21383	payment	2134	2134	1874	1	1	550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyX6WhMWmP2u2jntttig2KnCBxUY3TcWsQ2hohAfMkkTeyjxp
21384	payment	2132	2132	1874	1	1	149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfUSDg38dFavkXNSYmKCX987pdLQkK2gvHyQn2xH1pm6NNiNt
21385	payment	2133	2133	1874	1	1	567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyT1QPD6Mw5fHQdXJ598qzdQJEAAjeqCazE9RsLSRFWfV4Eszo
21423	payment	1397	1397	1678	1	1	9419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9qfQqsPKSd6cbQNRJxxD3GZuqmVG2uEuzdfD8DdSiX7g6us5
21424	payment	2133	2133	1874	1	1	577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaz2AB8XSmkAX21ELDj9oDSNWCPWvfTQhugRaaJkR33Ez61uv
21425	payment	2134	2134	1874	1	1	560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzSiEXtqCf9zi7ZYVGVfz2bGhDCi37si8vBiy5YG3cgzoWmox
21426	payment	2134	2134	1874	1	1	561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeKf43vqv9ua4QQnvKWokSrpUhe2SaGoyE88NP4ez2WUrwZZr
21427	payment	2133	2133	1874	1	1	578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMZwj6YFDRAAqgqgXUnwGwt5z7SfpLVGKsjGNaz4vfZ9D2i8m
21435	payment	1397	1397	1678	1	1	9422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqobmzg6E18epLT8qd7ZXc35tDjhEPYTMCRUXeWUyTxubumbD
21436	payment	2134	2134	1874	1	1	564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKHYxBThq7hBA7H16kTQFcYYvFLd3YfM1MskKTmRKgV3dr1iB
21437	payment	2133	2133	1874	1	1	581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoP74tQFqgw73Tdy9ziRS5k72ZqKgLYceFauLCcFL8jVBiHU3q
21448	payment	1397	1397	1678	1	1	9426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv575c6M9EqXkLepQ5mXVh2EUeooRsFdbkosyWRwHnyPdb3N7S
21449	payment	2134	2134	1874	1	1	568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSekknaJhdHEVpLFTQ8MnU5dSWozKvsFaeAro9mP22unk1vMH
21503	payment	1397	1397	1678	1	1	9443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRJKcQsm59fkZeZFHpS31df92pbaZUUeagYDhqK9JVjAaQhZ4
21504	payment	2134	2134	1874	1	1	584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WJ9ZmfykTPMhSCLd57WuU2xNZfDczovS2X8X47LtxsmfyZYg
21505	payment	2133	2133	1874	1	1	601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iKAn64aaQTw4f3gqn8H2Tg53UjKB4LsTf7QMRCC7CJaV9LFM
21513	payment	1397	1397	1678	1	1	9446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5crXXpx92GjGM1RZRmXRiQhRst1TihWdMsBquYcNaZs46EEc
21514	payment	2133	2133	1874	1	1	604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRVywYKLuwMP7V4eAdB1yCxtx4kdGaUqG2F6Ez35k8JG6fA1u
21515	payment	2134	2134	1874	1	1	587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GeqednZZJKw6yqhrkQh7jpj7Rt1ALv9rFmpcyi8EYqV4pxRb
21516	payment	1397	1397	1678	1	1	9447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqF1kH7619qXaqDMAae1NZ7qV43okPp3LRPNrFWasZvGajJyD
21386	payment	1397	1397	1678	1	1	9409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPzaW1WVrhLpFKd4bEBr66Hdw3JLCvUkStBbYhfYr1QCEbERS
21387	payment	1397	1397	1678	1	1	9410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKatVD1zPNVgKppKQcMJtguYaRwemR7a2Ds69wqidau7pTMw3
21388	payment	2133	2133	1874	1	1	568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLNvfwXf3RAhenGFGMCRgdkHSKqhi8ASHrUF8T3KFKuDY9ygs
21389	payment	2133	2133	1874	1	1	569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS69eYnDEZ727TPP6SJs4XBtdFH2WVMpvTEnB6VqhSTAxL9aFh
21390	payment	2134	2134	1874	1	1	551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82uVvSe6Dc2Esw4K1ybVfBJp6ce2YG7CmepC4gLW15fC6yznx
21391	payment	2134	2134	1874	1	1	552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSrr5DVVZTe7FvYP6nFfm9LQos3LDYaa5LwHdvC8C2op9kyEB
21419	payment	1397	1397	1678	1	1	9418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSKJ9oYm3KRge8aZQkmaGpYC87WkcDBpT2b11N2hj6koy2QPR
21420	payment	2132	2132	1874	1	1	152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4D4mozeYhZ8J1dx6N8bPZ2zsmY271tQDRastbGutf5AehWRrk
21421	payment	1769	1769	1769	1	1	40	10000000	1000000	\N	E4YhDHfvF4aDhC6Z2sBFzV523F8Xiftoh6pYa8ChqazXWfoW5ZZbF	CkpZr9hCKCs1Wh4jwQrEMyXwqt4UqfurtqdRZarURCaMxFuiv5gvi
21422	payment	2134	2134	1874	1	1	559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GCYHkVA6zZr3VJz3Gvgrq3uMP11bxqdZVmePukdZFazSHEYg
21428	payment	1397	1397	1678	1	1	9420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bQm4oV6aSEpvmrDz2ZAtMo7tcHYPtxddDuhHncwuofD7b4uS
21429	payment	2134	2134	1874	1	1	562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigym2VuuwZpkopq1wMNhUp9kd1Bs86K56BpacE51y1h5roeGj
21430	payment	2133	2133	1874	1	1	579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeao5avRWdZbJDPeDfB3azAjLCrAit3HY11KK9DxQpYeEgiXLd
21438	payment	1397	1397	1678	1	1	9423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJveNnqdeiqzAHn3fPBBBhd7BaA3zm4m8v9LmcTH1bQSb84Co
21439	payment	1397	1397	1678	1	1	9424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWwVnfgGKEiwqevKyUZT8Sx57muEfSjHTossvEiRmekJzLMJP
21440	payment	1397	1397	1678	1	1	9425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GwYRwtADiP3A17x1CWJGVAKmnq24nqK8WH2hfxFGNrTV7gDT
21441	payment	2133	2133	1874	1	1	582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSB62634yW1aucuQLJmkpxPERDrGn9Mmq4FW1m6ph6AoYw5uy
21442	payment	2134	2134	1874	1	1	565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpC3BhsY1eFr14wS68ssnFXou4dQ5a2VjBVeVS1TWPypkSLzE1
21443	payment	2132	2132	1874	1	1	154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZvo1SuKC4FUTEuGLgZJWP98noiKtc9VuRvUALRUYdDYotQJQ
21444	payment	2133	2133	1874	1	1	583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRH65qzuePCvQeeAd1HuD3jLmGDwGVY3WJHt1JbhZA2uRtt4wY
21445	payment	2133	2133	1874	1	1	584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYz9YUSnYsu339SBKVZrugoQL52ftxLzGTQRGqvrDV5tm9ahSU
21446	payment	2134	2134	1874	1	1	566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ERaErhjy9aM4jjyeXkb1Te6PP1wAKQnzfnUiZhzkdm4PfhWr
21447	payment	2134	2134	1874	1	1	567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoJAGgwKaCBv9R2cT97JAARuxPJU2onzi7Cf57orq9cCNt1HT
21450	payment	1397	1397	1678	1	1	9427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNef6vgMGCkJZe1ciEv5cyqvQm5bBpWu7RJRos1L24TzP896UH
21451	payment	1397	1397	1678	1	1	9428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNpjxt5QrRBuv6A5chMz4aP5p3H86WpALyhWmtWwjnKG3zS81
21452	payment	2134	2134	1874	1	1	569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFHGHXXL1bNZQbcGtyahQ1oZ5R4hCQDPwZK9r2oS47iodhess
21453	payment	2134	2134	1874	1	1	570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ET587vMMSPbVq45H4QYwr2y3UvkCedUYzro2ckN8HtbSSvu2
21454	payment	2133	2133	1874	1	1	585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyQkfm2KUyY87Fp5BzZTQshw1EQ4Tcq1hmqbdQpy7iig127aE
21455	payment	2133	2133	1874	1	1	586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSnc15D8TMznMMxkQ5XGSF1QtJ83hNNfmcYgSmwqkJ8EY25VV
21456	payment	2132	2132	1874	1	1	155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSocwwgWZx1CzS2PazkqsFJjVmWG2wxdQ1KFTCCKoZHifd8tK
21457	payment	1397	1397	1678	1	1	9429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6kh9Q3FnAw81mMTEiQ9faSfCMkxYMRt397YStc6skb6rFWbz
21458	payment	2133	2133	1874	1	1	587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhW65F9a83otxtoPp7PsxEn9iurjwF5HjkUiNsY8eHV6cF9tH
21459	payment	2134	2134	1874	1	1	571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQbz3DVbRp7RyZm2mRLcvJxfZxtpuDa9cRsWheKQxkV9ZW3Dx
21468	payment	1397	1397	1678	1	1	9432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSrBrJXS8D8u5E4i4XZmf3PhNMGp1s7dzLBRRfYSzU6GrAK7W
21469	payment	2133	2133	1874	1	1	590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWdcD74Xbebbz9KVHyVZrm4oiucZ5TUjFZm1tWH2h4p3jsarN
21470	payment	2134	2134	1874	1	1	574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV2H3bbNip1UZLEqPNHgChezZbQs64G9Htn8UCd8ok4ayuCUJ
21474	payment	1397	1397	1678	1	1	9434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhFEkG1Dq38g9pKWS7gTGiHyGDUtxa1SuiDMFnD4ymXFdThun
21475	payment	1397	1397	1678	1	1	9435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vM7DA5R4cgmBXGxUZPHiMJ9hYpVSDNLUh6BhZpXAZZMNG1U8
21395	payment	2134	2134	1874	1	1	553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyEZt7P4k6FmC2yyd8mxvJaYkqwSyXGuqHxWHyhXdN1mLFbGj
21396	payment	1397	1397	1678	1	1	9412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8zonNBsDz6xu8KiR2j933XoppauMuopiZNj5ZWv49mHQDruy
21397	payment	2132	2132	1874	1	1	150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvu5LgE2WDbSkEL1wZyaZNL1DeyhMVowipefd3JWBefUuQHGB
21398	payment	2134	2134	1874	1	1	554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNEEFygV34gJ5sRpSwgzkN4uPe5PJz8qPdF6noBGHZwQJbBYS
21399	payment	2133	2133	1874	1	1	571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADoR7bwugcw1apEyXCAL3NBvywXmCrYQZwD5ELCyKfmg3pxXR
21460	payment	1397	1397	1678	1	1	9430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7bK6d4gXEZ1mLnX6k98Xtgfz8UJjU19ZEub1Sq3nd1qsYxA2
21461	payment	1397	1397	1678	1	1	9431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2f2Ge1UqVCwEzGQ72ke5tawMjDg9Xx3ayj6HURGGYH8Kt9Kv
21462	payment	1726	1726	2151	1	1	8175	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9nySxrqcjZKJfhHWxwsZYSdexAvFbMz4Ng3qy9xydTN1LnvBh
21463	payment	2133	2133	1874	1	1	588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUYnAQJVHcJdCneWYALG6Znibr2dn1CaEPFYGPXs3XWxmq71kB
21464	payment	2134	2134	1874	1	1	572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qYQEGYBnbZV8Bsmw8DUFrwuQxzzUuBKGqb5GfExTstKqxZ2z
21465	payment	2134	2134	1874	1	1	573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYsfDNjuVk7o1jREuJHbUqpMURAMXCXcT468Vw28KtKgDq55k
21466	payment	2132	2132	1874	1	1	156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULur4tEig8fdkCZLPPJgFj7sTM9bibB7vAB34pA6pomcfvhGA
21467	payment	2133	2133	1874	1	1	589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuDnCN2tuwaZWZ3dzDR9Hypb8yXxkQqzHx1Y6zk9UeLpyNjHF
21488	payment	1397	1397	1678	1	1	9438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVtS25QtymP4DJJepoAoZ4f2KUVTavPAT1rFWaqmk7bw8YcV8
21489	payment	2133	2133	1874	1	1	596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjewmJLAMXRaK5byVD16vvSBcw5wmPTm9SR8jj6Jj5pViDcrxz
21490	payment	2134	2134	1874	1	1	580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcErU99SkUd7V4feut1JggeriEtVkGJCi126otFeNM15JybzYb
21491	payment	1397	1397	1678	1	1	9439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6keWGACc2Shd8mNPgRLiixBRtXcSk2eEK9TxwWyPEbQMQG7b
21492	payment	2133	2133	1874	1	1	597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wh55DeBRNhdcviVt2AVPURGDvu1nis4dWNFGP9LtKSRwNwc8
21500	payment	1397	1397	1678	1	1	9442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hcuhHqPFrS2xhxSL1Q5JuAA65zm5Ec4gwfY5QGfMkaK9eyra
21501	payment	2134	2134	1874	1	1	583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTsfVdJVFbhY3wdiV3fnKrTbRUfoXCzUkp1njqGgrHccaWQwy
21502	payment	2133	2133	1874	1	1	600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpRrZbxmfWeeWaLdjXF6zHSBJMb7M7SBRCzC4iBjSe1PhQ2zo
21544	payment	2152	2152	1860	1	1	0	1000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKdag7GMhQ4PMyQno9nR2Xh1Ccpb38Rdqf1W2ZEFrHvvpMUhB
21545	payment	1397	1397	1678	1	1	9455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabyBYk27Mm9socs5eCkPEPRrd1kRKHgmSQmtAuLuEHz12gEki
21546	payment	2134	2134	1874	1	1	596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswkM3Ww2JfW28VULUKP441buiF3SKSeQGTsZfmKUEsfNNEACe
21547	payment	2133	2133	1874	1	1	613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqJhNpdMZZUSxposnV4Jrt1BWtUahaxNAgrTUdwPsRW1pgt7d
21554	payment	1397	1397	1678	1	1	9458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJDT6P8rxixssA71dStfTBY9n6oWr6t3tJh9HDUsCbnGEZ3io
21555	payment	2133	2133	1874	1	1	616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQta6q8A9mjUsQbqkkZ2zbVbGzmqujaoPknDQcUbHJttkUqSEt
21556	payment	2134	2134	1874	1	1	599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2pS5mP9syn437vVb9oKZ9zvrwkGwyBr7Zy51E3pMw1CyeGBB
21557	payment	2132	2132	1874	1	1	164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhmvDxmtGAHP3nLWbcwxihqe3ZswsncfsKqUj8TTjwt8Xpzu7
21571	payment	1397	1397	1678	1	1	9462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfodPEZh9xmK4nobL1zbmFkWxohjYCuvPpMyKXwSMVVoDeoagV
21572	payment	2134	2134	1874	1	1	604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGGuPLbSne6ow2UkHctLhkDxiwmdys13c6cSc8knPfFkAhpAZ
21573	payment	2133	2133	1874	1	1	621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZb9aQz74ufj2QJamuMJi1hXpvfdP6oogxCFV4sZeEmVpFHGdk
21582	payment	1397	1397	1678	1	1	9465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KphnbHXL9Cyjwh5qTRrKzHYAcNwiD8ZfSDsxTGpvutE3JJ5F
21583	payment	2134	2134	1874	1	1	607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAJyCey1ycKH2SZZ27nG5rvgQeTvD7jYuuNu5AqS5gSKpdPHD
21584	payment	2133	2133	1874	1	1	624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzJLqdQN7VSWtLGF9bLLW4MmdNi9gVfQKMms3pGJNd8oryhwp
21593	payment	1397	1397	1678	1	1	9469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRk23NsD2i6Vh1QUSM9bdC2Y67p8HUAX4aNgKxt9YikqbpmDu2
21594	payment	2134	2134	1874	1	1	610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xy75UUY3sEFiXZDiNciyLnvK7qBEZtNaseJ1iSiw1eWtQB1J
21595	payment	2133	2133	1874	1	1	627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnidEme6nUYaU6t9BRFfdPZbg6dKkA3EuAn78XY2FeGP4LbFu
21406	payment	2133	2133	1874	1	1	573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zVF3aWUyCm7ueHzWn3oxbFv4HRqY1SEsfKbrUvDXPce5jPQE
21407	payment	1397	1397	1678	1	1	9415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcdcXMaTrSxYF5yPs9ZhvNrhKemRFbd8oMHRicTjMria6SNxi
21408	payment	1397	1397	1678	1	1	9416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASMj1W3ZqFyatBu2EKenJjtUqKa14u1ZLnL78ua31RNYYrtFM
21409	payment	1692	1692	1860	1	1	4	63603032300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKmprMEkMQQHioW27UPz4kX592YQnUvn1W6EPy36z3Krwd8xA
21410	payment	1397	1397	1678	1	1	9417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEavV6fz73ykNo2nraaTP2WDgvVCApyadpGviskUKfgGPAQ1nt
21411	payment	2134	2134	1874	1	1	556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmbS1dLcDSmJimGNxYih6tyFnAkvVof8rXo5pLZjtxMexynFy
21412	payment	2133	2133	1874	1	1	574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLJx89NzgYHbwFKFmLXASAkGJYn5miyvpQq3obabaP4Mpxj4D
21413	payment	1769	1769	1769	1	1	39	10000000	1000000	\N	E4YXVZnkzvRdfN84ziy16TizTiufGfZWr9fqgASWoMsixoto1uiVB	CkpYnAbWgU2YVcn3b2n3xXzxk6tNtN6XbyxfgUf7ju4cQPBg16nnZ
21414	payment	2134	2134	1874	1	1	557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsk6RGpPnMpUTpPsrNot1uTCfCsCKrMWFHwcjzS6dz5jeMKVK
21415	payment	2133	2133	1874	1	1	575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uaTvA45GFyhAT7Has4Ghmnb9vQLEb2vgAeYt3guijpUUQZLR
21416	payment	2133	2133	1874	1	1	576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAniavU48H8yUUPDK2sJhEXg8b7gTF1oBkQ9FxfGfKhkxupjZH
21417	payment	2132	2132	1874	1	1	151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiTUXLTAjcWw5ufw9T3AVLPv9PqmRTVrqa5mo4JZvh1PAAnHi
21418	payment	2134	2134	1874	1	1	558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfeu9cV2g3CHPCGJR73FsYPZUpMyq9MBVodchHcT23sDy5nba
21431	payment	1397	1397	1678	1	1	9421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyPptrWkdv13sYZiCkBEc3z5HyDfxebAYe9GSRRjuCovS6Ddn
21432	payment	2133	2133	1874	1	1	580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeB1dwGM1ucibZtnJHaYcxhAMVcHCAcUdYum2Tpr3heBscsUyJ
21433	payment	2132	2132	1874	1	1	153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm8WoVi3qxeALhGtgWBD6eWGfP29ky2HsxKei73QWAdYvVYYp
21434	payment	2134	2134	1874	1	1	563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQUby45Bw6PP8pNvu4uWq2t5Jvhwf4ky3cfT2UaAtC4rFQh4d
21471	payment	1397	1397	1678	1	1	9433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gxvjX9jXyWC85vxnEgxZd9fy9aexVg1mkEByoTt3oU2By8rk
21472	payment	2133	2133	1874	1	1	591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9tBvmidrMSQRK1TjBcjoNpLRKVTuczhi2cmDc3oospdXi96h
21473	payment	2134	2134	1874	1	1	575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH64sL7V4HYGHUce2oEjFMgQYeUdgW7LvnFAGreDQtcQquqSB2
21484	payment	1397	1397	1678	1	1	9437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydDcZcPTWa7virEB4SSoQAQF7mdjPrYXU3chRXWecheLK3CGv
21485	payment	2133	2133	1874	1	1	595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7vgwE24MRLyMvoSDH5M3RQbW2phjAwzJJ4rWAxyfs4uZ6g6c
21486	payment	2134	2134	1874	1	1	579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3B8Krjm18n16p4DsSfdkYTZoCwqfPcHxPU2YBSKgHPpnm99a
21487	payment	2132	2132	1874	1	1	158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EogxVE2DPLEMnDzDbW61TUFrNmFeJwAmS1n55CrxmKNZuuhg
21496	payment	1397	1397	1678	1	1	9441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSED4U2MnZvGiykqTcMFuof1FfB99Thc5ckUoKFQVZEgMdCZ6A
21497	payment	2132	2132	1874	1	1	159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxbVB5LuMExGCDxVqLeH8Dth3y8T74fT1YAxdYGCoGioKuUrz
21498	payment	2134	2134	1874	1	1	582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYs61f9SgGPTB13NBGPQqkCojJP8LzS4r6pRpaYDhw8FKSjTDK
21499	payment	2133	2133	1874	1	1	599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZuQYRDc9qxYkouUV9E8R42wZiGihs2RBVoocEozV9aLoo1N5
21510	payment	1397	1397	1678	1	1	9445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMobZZqPRR6RCY2m1defrf9o1Ttv4vwoHBgTUBpm8zL31HE5T
21511	payment	2134	2134	1874	1	1	586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxqowRhmqM8GQc9msawdPvbBeBWji1wcSnVCMgLNZ86CLMupK
21512	payment	2133	2133	1874	1	1	603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZey3C5UnXkwwxfhsyMbxXLazi4NwxhJyDgdfxN1xpBnKkekUok
21537	payment	1397	1397	1678	1	1	9453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzGPj8FaDg1W3rCpRdfJFK5ECsTmQHrk8hHx3Q3JYJQZSPzht
21538	payment	2133	2133	1874	1	1	611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVVkSyvVe816PpJN7LkYXU1H9P58ms9zjWPKtYjyp54bgtrT2
21539	payment	2134	2134	1874	1	1	594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQ1iu45GaQsLCfShHhfwFp2SS9gvPe41aEuqWaTCWHqYAb5pa
21574	payment	1397	1397	1678	1	1	9463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpynAFcv4DGvb5XJv74gpojbftYTktZfjmoYKKdXbGQ6niemkx
21575	payment	2134	2134	1874	1	1	605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCEWC81KhHpSVDJTS1fscciHDTwxsKcUyVeCaAwx7sDUkyBV3
21576	payment	2132	2132	1874	1	1	166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQfb8Hh6gXWGrKxvkzZhKtroC2o9gVTCNvMaPHxLH5uubXZfF
21577	payment	2133	2133	1874	1	1	622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXed8rs3enLi42nEJWbeRtedzXoCUPJ9eqFL7tPRsXGjbjngFq
21476	payment	1397	1397	1678	1	1	9436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58tYgLRcHg6KFdQFKVwi1JQgnssSVdWNv7DTZL3QFdAp7nzaQ
21477	payment	2132	2132	1874	1	1	157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNadzgu8wFiTb1JLyr1aQNVn91bDQoMXEnpc74BuLJdTNMD7p
21478	payment	2133	2133	1874	1	1	592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyDsZaAB24WSHHtaXAJ15d5qXY2M1YY37ytgidpx7HpuszjYd
21479	payment	2133	2133	1874	1	1	593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCUmbPirAa5RF2a8ysYfoUYVVSgkdGJ8qovff41UTF3pXtC8W
21480	payment	2133	2133	1874	1	1	594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmm2DamzXdVMvfqHgNp3SAHrbgpoVPweesbreW1DY4tq9HaTYf
21481	payment	2134	2134	1874	1	1	576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvhBS5rZEjho7nioLiNZ7zTJr1BTJQRxpeSM64dofigEMYjMQ
21482	payment	2134	2134	1874	1	1	577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgP6uguBzASeZVE9Mk4utw7FVHUNHK8ktUDH69epQLPbiBhh8N
21483	payment	2134	2134	1874	1	1	578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgJjJEiuetodZ1EecAn5X8ha4opADyYHr7Wbr2nywbbUN5E38
21493	payment	1397	1397	1678	1	1	9440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MSKsfBCATsW4PMVJkHXupNmCipNgLFucNU4zE2U1L5AHc3yE
21494	payment	2133	2133	1874	1	1	598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEwcuCMygBbJ8qTVGdjFRLxLJ79dUWurAGciwcAianDW4B8iG
21495	payment	2134	2134	1874	1	1	581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FLLQyscuXh5h18gfVVHS1Yfoy9o44dmCP3ThZecgKDWSb9W6
21506	payment	1397	1397	1678	1	1	9444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMYkBpooRHTqYJoG5RUeQ568gRQ42phLLGQ7pGnWcqnn6dFCV
21507	payment	2133	2133	1874	1	1	602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jqfNzBhpSN7yg239wP4CYQGu5YhgEX8YxQavyszGfDdXG8HS
21508	payment	2132	2132	1874	1	1	160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MvxE3sppT1MhYZRtCRFhEeApkhdtmPqA1UBQAgRa3ki78eex
21509	payment	2134	2134	1874	1	1	585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHV6zgRmprKgEvhyFTbpoJb9TMUV8zH3Z4MNmQYfcGqFhSrdHv
21534	payment	1397	1397	1678	1	1	9452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GMau92myrFeLZnF6h7HVKviP8yK7guKrZ4qedE4ZiaybudaF
21535	payment	2134	2134	1874	1	1	593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGhvZRHdq2ZDXEP3CBP9SZwLRQSytT8b6JZJAd6Q9f5PC3ECp
21536	payment	2133	2133	1874	1	1	610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PNFr39vsnqrh5fqgwvsUxu3sD4AS6JAe1QyscxXHg5q5WTZ8
21548	payment	1397	1397	1678	1	1	9456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGCuxNjtxmVgj1uUMkNCQ9MusLyGmD9qz2x1omPHK44mo3T8E
21549	payment	1397	1397	1678	1	1	9457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR5arHGV13Jm4TZ7eHRVdhY1dZgmh3ZkNFaH12gxs8rgTPacq
21550	payment	2133	2133	1874	1	1	614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZf7QkdPdi91ZFM68WRs8x9faqo3rBf2NmB5xk4GYJJ6aRkm4
21551	payment	2134	2134	1874	1	1	597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKzRHmbpV9a1HCSTHqRu7FdPYj3n12wynWH3sNNidCz5BUGKE
21552	payment	2133	2133	1874	1	1	615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTRm617x7JzykKg3GMEgmLBKwyKD25cKyLACEUPbKHC76ALLi
21553	payment	2134	2134	1874	1	1	598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9j5f92Uz1wv6ezEpCEx7zpDuzha73SKvwZM1Tfo3eRxMcKh8
21578	payment	1726	1726	2153	1	1	8176	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKSWmzx15M7fYY3Y6YSSK7K4EiMsE7TMRKQjyNSL1krEPaCxKS
21579	payment	1397	1397	1678	1	1	9464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7gbcyoiT25injtYY89GDzndzxEmzguG3uMuDAi4hBLJaif45
21580	payment	2133	2133	1874	1	1	623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVufT3wfc5BCNpwWRtwFQLr82cwqpGqDT4n3DW5VUqugcdhPMH
21581	payment	2134	2134	1874	1	1	606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFBcswwFxta8axTba4GkQwYudqZ6x4HaMAq48fT4N4iQdXJLP
21585	payment	1397	1397	1678	1	1	9466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GJFtVgYXUkk2VyXBMJd8a4eUoDX64Dk4Symfe3Hydgx5vfH9
21586	payment	1397	1397	1678	1	1	9467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjXybnQFnG1RAyvRcZ9H2MgbNdeNUZSJAnCtxg7LzD7vGhSRS
21587	payment	1397	1397	1678	1	1	9468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuy9NVvgB6kfbmT8rKPsimRC9q47JgKnKNyj5M7nyCYkZGRyQ
21588	payment	2133	2133	1874	1	1	625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8efRLvGyoc4UeJwUnB66wmVLwkToFyxwmdLWAQHtYugHpGWnE
21589	payment	2134	2134	1874	1	1	608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Qyhx5qGbZNMiBaG3n9nH6rcdVJsQSQgmJgG6x5CHBtnQEa7w
21590	payment	2133	2133	1874	1	1	626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrM7n95SCJNuc36ATAP2ozPWM949qhbsxt4M7bzppnkDbGEv4
21591	payment	2134	2134	1874	1	1	609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxt4v9Tx9giALu5z3zYZR4MMJJ9ydwa2PXxGQviSGzZCqkx8r
21592	payment	2132	2132	1874	1	1	167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprz9bVfEfhmTtAzWxEHgYYQsyjzziJpbMs1rSUhpJeqmeuYLt
21596	payment	1397	1397	1678	1	1	9470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFyPTMnfTiurbqTMrcv3FzaLC15W7XGavPQNaaVspZczXjfim
21597	payment	1397	1397	1678	1	1	9471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKosukohvJzLc8tUCh2EnbfgJFmyXWRuoE4XFB6iCG8MRq2Zp
21517	payment	2134	2134	1874	1	1	588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WhUmT5kBdmWVJ8XKZ9BuUvy3hcittawBgpWPH3MfWy9NhhY7
21518	payment	2132	2132	1874	1	1	161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3fYUE2Gy5jcjRfUrdGGQ9D3rtCrQJGNZSa4Hps2UQuJKAmCU
21519	payment	2133	2133	1874	1	1	605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYXwqsPEatMncNj6QYbXJ2NoFKDkecFx2YKQKtH5HZfEh6vH8
21520	payment	1397	1397	1678	1	1	9448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPNw5WWLLCLk7cEPdnHRLn168QnAqU4DTGkjBDrCLLKEznMwB
21521	payment	1860	1860	2152	1	1	2	1012300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenQiknPGinDrVCNur2oSzjHzpYArzfXJtAF6rGLCa3KkvYon6
21522	payment	1397	1397	1678	1	1	9449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiHMNyiVkJv8HSXNN8U28QbR2RxQUB1h3Z5ZX6VNVQ3Xu5LV
21523	payment	1397	1397	1678	1	1	9450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wy4uUopr32BymiD3eenCZgiFLU7Nk6xdmGE439D94ca114Cy
21524	payment	1397	1397	1678	1	1	9451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bPSYqnpLR8dq6cjodSxEdyxso9jP6AHmpEaBHGwoMPyzq6yF
21525	payment	2133	2133	1874	1	1	606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusSPNkF66vGwVwyUHH3wjXLp2zYwX3tNTTHA9K46kpbH2RVS1
21526	payment	2132	2132	1874	1	1	162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uQfHvi7QtiRG7z1E8xUoM9cnJnGyVfALf1xSHMGuoQy9rR6f
21527	payment	2133	2133	1874	1	1	607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMeJZ3HrncwEgkL5WTbe1vfdKo6wobkZcvETVgMSUz8rXosRoU
21528	payment	2134	2134	1874	1	1	589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrp99NdcWbCRRSEHmvYfbkUftwk6vZ6xEYdYa9wjnCGA6SybhC
21529	payment	2134	2134	1874	1	1	590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3KonVGPxqG9KT7JsnFLGy2mMnaPXiGteJ2azc3NTrcrr3SYQ
21530	payment	2134	2134	1874	1	1	591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa1r5vJbp8rnxBpTKMpvXWWAre5syNJzPwsZewJkyjrqKc4Jr
21531	payment	2134	2134	1874	1	1	592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U6eJZbqRPPKmNXdJrPXkLPwjMk4uKwwAqzCcKmuLpVhnZQAF
21532	payment	2133	2133	1874	1	1	608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WK7tVoU4kT3pgs39gfPe2G5T5i1qmNvZdvP3RHvL9MyZNqCY
21533	payment	2133	2133	1874	1	1	609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmyKX4xbM9HXGxvPRn7tpraXLXDZ8S8DW1mjaCdJ3deU2dM2t
21540	payment	1397	1397	1678	1	1	9454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRs9wYhVauSdiYraLt1sD958bbRKT9DKjY4FsAwTFMUPdzMsbm
21541	payment	2134	2134	1874	1	1	595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M5ec3p1hKANifsKuuzdp7h7NW3n5iHUjmt9HJ51qFpSkHAbX
21542	payment	2132	2132	1874	1	1	163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLqnv4xZL7X2s9BckHYwybJMCH7yWigssT9KxwzpYWWhc49ML
21543	payment	2133	2133	1874	1	1	612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYedNVKxSH658kiGG361hoUzpKQFjvcGwpZAwzKaFdyM36NVh
21558	payment	1860	1860	2152	1	1	3	107499000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKPqjLosUQXWP74M78CqxRketnx9C7EbVaKAM5DMdMtic7fJ8
21559	payment	1397	1397	1678	1	1	9459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk2GwsgSiUr3YbEwrtMYGo41e64VrLGrwnQQ8EPHyBxxbPdYA
21560	payment	1397	1397	1678	1	1	9460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1G6ryioCDp4BdcXKXXS2WrzVkX5U1ztZzfHqK8xfNnN3uimX
21561	payment	1397	1397	1678	1	1	9461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvw9D6zr8XjnDGdhMDSpPEncGAjht1Q5pt95QFwvvmt89tTSfW
21562	payment	2133	2133	1874	1	1	617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUTQKSykvJtaRKU1AJGXqFEjGSQ1vV3BCQak5nYxMKPN2ri6d
21563	payment	2132	2132	1874	1	1	165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAjLyxLhxyrJ9NdhZ71LauA6peh8ZLSFRLy3zKd7fDmEyC7cT
21564	payment	2133	2133	1874	1	1	618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf5Xiu5q2rcou37dTpY6y6utuLXft5oYzpsyBjAG2JfoWryX5
21565	payment	2133	2133	1874	1	1	619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQENRBgY8WFL18DMRjyx4kBbNiVdC9evDkk38ttmaoGC9BzMt
21566	payment	2133	2133	1874	1	1	620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwUcEqTh9gXWjuPrnGrn7Y3vb2kzKPfpzV579N5RnDEM4Nnwk
21567	payment	2134	2134	1874	1	1	600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFDQ5f5zdiKJyxRghmijVeoCC4L6rsX9z9KiVNqKLAaPZ19SZT
21568	payment	2134	2134	1874	1	1	601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KN8uG57J1i15h3x3vuYDWw85uJPHQJHTGJ51TbuX6PRmnQeu
21569	payment	2134	2134	1874	1	1	602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgaAQdmyB33PftjbZqyXy8UhFBP5yaoVTS4ubQNSYfpHHbTDU
21570	payment	2134	2134	1874	1	1	603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvd42bkqEwi6os3nTjz1EynjKGBrVCBQCT4W5jXi5ZSrCgdRh
21637	payment	1397	1397	1678	1	1	9482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVRpaVkXkgwznuTvjXaaoJBfeKMZJvN9p2RJtfsCHE6uTQ2A8
21638	payment	2134	2134	1874	1	1	623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXvkaYHuU8TxFC62UVUdZB6J97SjE8Qyx8EVXkiuSR2oR4mp9
21639	payment	2133	2133	1874	1	1	640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EgQyWgt5W2CAGyFxZnpqn7EWuXpRWyKssWVkg5QJmNQAZpCk
21647	payment	1397	1397	1678	1	1	9485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqabmY8ip2DYqbuxSG7BxvXmqvychfB3eUQQ2fFaWTsPZ1i7NP
21598	payment	1397	1397	1678	1	1	9472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BamXPzyB79icpuuCYmrGjKj92SHWzAwwuBHa61kDEDUyJGA5
21599	payment	1726	1726	2154	1	1	8177	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFYnuiCQ7RuBKkQgrRLxu9p1oVys2Dv4RPop8uqYSDaJR8jJvm
21600	payment	2134	2134	1874	1	1	611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN97D3E3r2hkuhuLhAsFgYpUnyhwWWaxHTFNRuowhrn9uK9Sh
21601	payment	2134	2134	1874	1	1	612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75XoqUjcLcDF18GR2iF9MXnrPg78HFUtHH5Pvu7KC88wDpX4u
21602	payment	2134	2134	1874	1	1	613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrECNq5MX6uaKcKbGK8aaANHBtFWCSmUWKrL9kGsn98pEdBxG
21603	payment	2133	2133	1874	1	1	628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFvPLCVJwzfDwP3UfFBZ6sGabdWvjnwp8HwHoCJqmWsjPtaAU
21604	payment	2133	2133	1874	1	1	629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqBchsXpEJPJjaJLaUgXhQCaVuW7RrCgNdeWFGVvrq5VJrH1f
21605	payment	2133	2133	1874	1	1	630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpqaQoK54jimQn5jpVV8dB2KRFETu5EdSqEBgDiMUTcL8uraE
21606	payment	2132	2132	1874	1	1	168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3fY377raSfDyrB6kMnwRic2kxJRnWaB2AgNysxPxR8ncUGWD
21630	payment	1397	1397	1678	1	1	9480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9CmpAywtvTCiNbFqL3Ai1u9KWnZH3FRMoQDmzVQiemncD59u
21631	payment	2132	2132	1874	1	1	171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NdVriuRbhMswJny7kM7pnk2FLVyan15RcQrFkiWbLurfa1oG
21632	payment	2134	2134	1874	1	1	621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdre2oEETEdFyXtoeWmbbZvsUejHgGEGMDyh27dZ64grXDzkb
21633	payment	2133	2133	1874	1	1	638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw94zpaqZEvov7VwdFcvhz4fU6NEeZnF1nzUcBV5kAdhKE8a1q
21652	payment	1397	1397	1678	1	1	9487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLMAQDD6iY6PsSCq8SaaZmrJ3Exbne57Fr5QeQNyMR6GC46pm
21653	payment	1397	1397	1678	1	1	9488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerjchovFQbFLeLuQRYksYbeo1i8LLiA1QLBmkg3jHfKhLCFCR
21654	payment	2152	2152	2088	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVm4yWsmST675YQoUXG2D44jC35G5rRbkg5d9dFYBHVtPBB9i
21655	payment	2133	2133	1874	1	1	644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEv9hEQ71PuENZnSMCNgs9jwxf7BWjLeHh4ijieGvqAnkW7eN
21656	payment	2133	2133	1874	1	1	645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfeMhgZzJmcennKu89VRLLP9n78T1ryPN2Ve6T7rZro61TGzC
21657	payment	2132	2132	1874	1	1	173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoeNTt2Yao3FSkGU2Cg7WCJCkCcwj2tBSurkXWTb1NuDvq3y61
21658	payment	2134	2134	1874	1	1	628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GCjNTAcSwG3sks7bXe96Njigv9BKJqquLKZLArhxpZMhbkja
21709	payment	1397	1397	1678	1	1	9504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKN5b53fMrEar4MPPPEzBbVwn98rHtxFmp4hjb3RW5pRGp5g8H
21710	payment	2134	2134	1874	1	1	644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eJwZWY1XzDzFcHvnExS1x6WHVnVvVLPcnYE8HtAmBBVj9BfY
21711	payment	2132	2132	1874	1	1	178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeU5rMUkj2Z3GvSw8VyWLYCQiBsbmRpVmA8cau8wXDFH6Ropb
21745	payment	1397	1397	1678	1	1	9514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyLn72LtfUEb8nvMDvu1oRtu9Tw5jjkvnbywPdNYp5ouFms9Z
21746	delegation	1597	1597	2155	1	1	2	\N	10000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	Ckpa2pz1Xyj88BD8YY2xTcpoHfeDj664nLayxQeSghquqjgxzAFJo
21747	payment	2134	2134	1874	1	1	654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEqL2TZa3BdoSLMu4TpDDXfxvkm48qpow6oij4nRrgXR3VVDb
21748	payment	2133	2133	1874	1	1	671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hv2KVitY56dZZnEAEAmQDB2bAQmE5jmSAQ7eWFA33nPh8xJD
21749	payment	1397	1397	1678	1	1	9515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDY7EaLXBW2maaZPe7D9fRwxqfnUUconmtzgAeN6yWikpUcp3w
21750	payment	2134	2134	1874	1	1	655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK8jPeotJsWUb2719Mb8CVFYeNaex3GodWAAtggvxYMgZ178s
21751	payment	2133	2133	1874	1	1	672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMikfb1j1uTaCWbwvk3MvQvvtCpdrZgNCG1jDuujVgw2WjtVF6
21770	payment	2134	2134	1874	1	1	660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbBpRT7q53euqjrEw1KCMjCcbgD5dGdEX14mbXRnK7z5Yjgzs
21771	payment	2134	2134	1874	1	1	661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUiwn9vqbyjYcKDdabezX1ZUT8CfosGg5W8WJ4L5ay2uMmgJQ
21772	payment	1397	1397	1678	1	1	9522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEPJpjUHtY4qbqUAwUwUoZ3adRJSx6YwbyqiQefTp3wYTKpuE
21773	payment	1397	1397	1678	1	1	9523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCWeoPmi4NX4LTP7cpkFjsNwH4w5GHqoWDwLDtRgx33XnPUo5
21774	payment	2132	2132	1874	1	1	184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAUwtcosGmLNZHMLjpAVSvwVPTezUBrfSimTR6fm9eXfkD697
21775	payment	2133	2133	1874	1	1	679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgXrE1hpnp7KWm2WUqnQJVKcV92qzRoBNsdiXGj6tLZyDdzbk
21776	payment	2134	2134	1874	1	1	662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4f5aPviuzMZYJAsDTnaxDgMbsjGZ6oB1LXH4APD474g3hjARY
21777	payment	2134	2134	1874	1	1	663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdV8qzHbgoT7cqE1MLtaHwDn72Bnx5m1Pn8XFGdTCY45B896Bo
21607	payment	1397	1397	1678	1	1	9473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFuVce5rrmaVMFaqATWyUrtBhFFvwRtLhLhksB9KvDKezGB6e
21608	payment	1397	1397	1678	1	1	9474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuULNM29Zz1dHtAZ5t8rFiB9a56ZH3N95cTBowkBECk88QHEPs
21609	payment	2132	2132	1874	1	1	169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAuXF7qW7SxTe6PNEe1NS8LkCNum8XLxmF1q9mcHfFR4icnmK
21610	payment	2133	2133	1874	1	1	631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCneS5VFrFyjqwTkh1qpyoopZRZkSDiSGfRHU7XUANdh7eQ9F
21611	payment	2133	2133	1874	1	1	632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCxUSd8KZVB2Fy7v5yNNjRzB3nd2gJuTVAKrc8fxSX6QQqjWo
21612	payment	2134	2134	1874	1	1	614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzfmN6FZ4CFshmqvacBtVNetr1ZmRwE5T5mRUDaTqD2u2rBi2
21613	payment	2134	2134	1874	1	1	615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ouRr8jfCwb9sbfsTGahjbMUd3PFiWknNdxpzmGpovCnw8H9L
21634	payment	1397	1397	1678	1	1	9481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbvgknha19CPaFdHZBRXJwmgq3YiQqQKB2aWwSArg7bCSGztd
21635	payment	2133	2133	1874	1	1	639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAbZ5hj8Qdct7Un1Lj4NLDyGTgNKXGjNwPe6KCrC2HWvXvaca
21636	payment	2134	2134	1874	1	1	622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjY7RHjybSHzCdDGvoPFw85myeBu7xuBX5oYmmtLp7f7vMW1iP
21659	payment	1397	1397	1678	1	1	9489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X1eouJ97jwJam9i42oHHJkvGWtpW7m4m3Fvanotfd97X8w4K
21660	payment	2133	2133	1874	1	1	646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHDo8q6RWE4xdczvJnoHLcr3sC4cPaqa175YyDJTSbvosn653
21661	payment	2134	2134	1874	1	1	629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19jbkRbLM7xJsrbv4sTZu5HN9pJZ6YkmZmLTr5DPf274fLdCQ
21690	payment	2134	2134	1874	1	1	638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1Qb5Dtrzuwsi5JwWkkTRV911X7BhHCCHbtGuAhTSkShqNbKa
21712	payment	1397	1397	1678	1	1	9505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaAKCNWKRGgyr1MzbviuHXBvCQJdN5PAFyYKyf68MhnyZ5zFh
21713	payment	2133	2133	1874	1	1	661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZdPdf3fgryqQoNpxMSoDh4v16zaPmqMGDZpczasZEgh1ZBS5
21714	payment	2134	2134	1874	1	1	645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JsU6TZc586vhAckKF3uqZmGbNgufyLPAF1MXxys3ut3nV3Bp
21715	payment	1397	1397	1678	1	1	9506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTgu1n5GHift8mTiAybkW9jaDZwPtJtjPcrSy4a5VnH1zFXrK
21716	payment	2134	2134	1874	1	1	646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG1wYBhswijk771pZduAq5rBFw35ScZ31T76ZTCoaMzDLfN3h
21717	payment	2133	2133	1874	1	1	662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkrE7Dn3PSz9yuZy7ooZjnfCFRobPa7bHTbpweamMT67qC2Jk
21727	payment	1397	1397	1678	1	1	9509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQNWYSP6dzRyq9eMj46TFJtFtKHW7W6QZBmTGqh1S97w7gRYx
21728	payment	2133	2133	1874	1	1	666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwfuVcsGU6BGqAMjNst4DUHCHRyGe6sonKTCZQaoWMkWwdNoq
21729	payment	2134	2134	1874	1	1	649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHeCnbgP1PoYatBRU8HdfhVz7wyRYKUsff7873VocP2cNtwqZ
21730	payment	2132	2132	1874	1	1	180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvbAXPKnpFvV32sftqn9aVGCtZn6BR5d9Bk4xYda2d7fZBTNg
21737	payment	1397	1397	1678	1	1	9512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz26tR8J1AmLsCPxYhQ3HrZogh7C7YYnvgzBZUYkR3YvJA2Ay8
21738	payment	1597	1597	2155	1	1	1	1010000000	10000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpaJdhsFTpwwFC8oVpDWRo19pT5DLny1rHcELCdSaRpRAjpjsHMD
21739	payment	2134	2134	1874	1	1	652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuodVvWUfqWz96KMDawtvMbjDL7jg6vuzfYta8qouiohrNMK9Q
21740	payment	2133	2133	1874	1	1	669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLB8R8n6oj52WT3Ae7KeDvV1LE3Ry2rvsvKeTFcHJToWQwNudJ
21797	payment	632	632	1016	1	1	3	4377000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYs6ZthdPHgmBPh5HiAMxs746D8jmG1SGChDJ8SPx22y7a1ue1w
21809	payment	2134	2134	1874	1	1	672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvjFsrkh4oeQaFJzT9ptwTr4UHjUjD9ebKngnjjwcnxMG34n2
21836	payment	1397	1397	1678	1	1	9540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDuiq568AKoHYW1WX2zXH6env8HL54pzqCD9388chpo2mftdg
21837	payment	2132	2132	1874	1	1	189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirw8ezYGQKYnYXge4Kp6rdtjymdtf2QSU9we1f8VQuq8zxhPA
21851	payment	1397	1397	1678	1	1	9545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25Hrhgtr335is6AtA5HKkRoKD62PCi5snZZa1cwX949vUzeeB
21852	payment	2134	2134	1874	1	1	684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8S4deeutAtizPXcyhrYCJucwaq5MxNNM14kCs4c5qWZWUoD5D
21853	payment	2133	2133	1874	1	1	700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC98tHYF8N6a3pgwdmGEf8LWouw2WGTLtJaHXdcyW4BQm4yyQ
21864	payment	484	484	1073	1	1	1	6373000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZf4miw3WLUepu3bAtCpU1yzmYdYULwoqUWnQ3sXG7tTPzQ34cN
21865	payment	484	484	1193	1	1	2	4300000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZ54BfLkMP4MhFV8VkAysDYCHqHmAN1Q8n4jkGUWK8grAH64iKt
21866	payment	484	484	953	1	1	3	3557000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	Ckpa181HVKhSxs7G269MvM6hojc2mLXEXv4nTFsC2T86mqunZnqRF
21614	payment	1397	1397	1678	1	1	9475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbQWaB5hXebFk1fSnw418BJwqfKRebhYo2pH7z8AdwEMBYo9L
21615	payment	1397	1397	1678	1	1	9476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDVcatzsuALNNecsLfxuQ68Xus5fKpZscMEEK2AbmxTDkYe6u
21616	payment	1397	1397	1678	1	1	9477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeDk8oKG1NnKjYgDXiC3GcqvcLK8rLb4QCx2ygHcJBvJZL3cD
21617	payment	1397	1397	1678	1	1	9478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUi2oebnXgrXAVVVCrSvNYeXYJQeZegtMRN9qshrz4QzbBFGU
21618	payment	1397	1397	1678	1	1	9479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfq8EH84ig9xkCzhX3HJie3D2unWRc7h7cRhWgdWaSvjAPJxg
21619	payment	2132	2132	1874	1	1	170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnZDMomJcYa7ZWYkp2mxCBs1tccBv2JymhMkLcfaK6hra1Q5C
21620	payment	2133	2133	1874	1	1	633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzsTN4a6RJiQFb23JhVNTx7RM3FUXuMdJUYmV2EorHHWRqbM1
21621	payment	2134	2134	1874	1	1	616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwusN9faZnBCdfjL5Q2eXcWUrDtwCpfZe3M518ts1yYMhrNDc
21622	payment	2133	2133	1874	1	1	634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGERQGyRkS5FBvwhMYFTnFuqUhWGHyw5rrAxLtaGgVyAHrzto
21623	payment	2133	2133	1874	1	1	635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYXoWF3mECKwaxW1sC4kigxa3GuiyKZK1wZuhQA2fqg5s1vTF
21624	payment	2134	2134	1874	1	1	617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGBELiQQh9v6wzViydJ4FtjhdbU1TKWmiJm1tR2k8iKd5hmyK
21625	payment	2134	2134	1874	1	1	618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKCiLFRK1KDQzvSVEiidSmdqBBG68Q452DDtERnANwK3FiJaC
21626	payment	2134	2134	1874	1	1	619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NvhMsm7FQQzhqUQECxJhiuqZ3ZDgfyL2Lg4RYgPX9YC3qmd4
21627	payment	2134	2134	1874	1	1	620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSemsw4r8DhJP2xL8aHk26Jcs7wRYLHg1in1rctohHf2pxkMV7
21628	payment	2133	2133	1874	1	1	636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvThFqxudnVH9QaAyEbuQWp3XAtaBLTPprtmHip7Nq4jMCQ69t
21629	payment	2133	2133	1874	1	1	637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsVndYK5kPuSrWsdNWzDAtaZGiH9fK42VnEG2T3C3AanWL6Ed
21640	payment	1397	1397	1678	1	1	9483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNJKGHqm8y7U35qtuhLUsR2EzACsEF2NZrvsqkZEi2xT6nQND
21641	payment	2133	2133	1874	1	1	641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonjnUg5vAjnQ5CE72HgLvA4EE6XpSU9rfFFBoaN7YN71psKKZ
21642	payment	2134	2134	1874	1	1	624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3E9ogyddD23eK1PaDjh6e8ugNmrHMc47r9Jdbjr5227ANnUb
21643	payment	2132	2132	1874	1	1	172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeBysi7vnwcGcA1ZtGk6WZhgG7tr4bapkW45GWPtdeSxZjQ5K
21644	payment	1397	1397	1678	1	1	9484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpNKUsqCBPfoP2JkuAefKRWCpt8n4CX2jtcqoyoa5S3YYQp92
21645	payment	2133	2133	1874	1	1	642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpJpXHv7TMPj8p5httuMVnfVcnwrZNfpbYuJSQzDpx4AAV6FM
21646	payment	2134	2134	1874	1	1	625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2vy7Ee5yLKNZwzLbKkdToEjYQsbPpUr26pLCvLfteq3Yh6q2
21662	payment	1397	1397	1678	1	1	9490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8NuH4FabGVSf9uoWCBpiRPsevbmSrV7QVApZByEs3kSeHzLj
21663	payment	1397	1397	1678	1	1	9491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuzfLr5oM8E1T1fEmceFwpGFiCt9D8yNKubaa4YyVDfvySbXE
21664	payment	2134	2134	1874	1	1	630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb8HVyqxVqEjp2qvNtBKJRSGQAx86bbawjgCMV3bA28VQ2FF5
21665	payment	2134	2134	1874	1	1	631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeqgUQwi3NHM8UHbGAihckt5qxHjAJKQYJDSMocFyWa5xQtRu
21666	payment	2133	2133	1874	1	1	647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCALUJAJ8zH9q6pV3EUmgYdDRPFSYJ9yXCyWUjcA498XpjAPFe
21667	payment	2132	2132	1874	1	1	174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTzwqEX6iQ8T4wHL6ciJMFtTifNvgPxt2H13JE2JEaFQzPrsM
21668	payment	2133	2133	1874	1	1	648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNeoNrbq1CP1pZsevLz8UQMdUU5EZPuch292dVpXAnexcvFAF
21669	payment	1397	1397	1678	1	1	9492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLafELBZnnzjpdikdvVSEP8zM7rBF37rtZPbdbVcKU5jZsBtPz
21670	payment	2133	2133	1874	1	1	649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPgwpSaBrMMiSbSn9LLxLqcmfrgRwpY4bWs7CciZxgYNcbX6L
21671	payment	2134	2134	1874	1	1	632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm2nqW7AUuDq8NbiqiicHAyM2TE78PSSULCZYMVWRm6x1xnqe
21672	payment	1397	1397	1678	1	1	9493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrssc5ir4xAz5znEMUY8fV1wgF5fVXqtTBH4GjuwVcsUcP16ia
21673	payment	2152	2152	2088	1	1	2	77748000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyEEVQ96rjNyxRhmQokWwt6nXnEQpjxoULCb2amrqYX7ecpC8
21674	payment	1397	1397	1678	1	1	9494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyCcH3j2AR7RvncyJEqazNxNH5NVcNtDDraeFsBdaA6RdeGxS
21675	payment	1397	1397	1678	1	1	9495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcg5YHVR1XEoMmyZn1Fk5pb9YMMvfQKtefjRYAkekdyzFRVs9J
21676	payment	1397	1397	1678	1	1	9496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9utSQhV3E1H2Fj88csvtyhKY7Dx8WNUvYZVjWqDvxu6Hj2zR
21648	payment	1397	1397	1678	1	1	9486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUk3UZSb4u94cve5RxALwt9yBkm3pdPQZf7Rt1rXHZuSfwuDy
21649	payment	2134	2134	1874	1	1	626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkcQcgfLVSgnw9P4sLVL64AEV857DB2Z9uvYdHTFQHjVSTBka
21650	payment	2133	2133	1874	1	1	643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEqcCq9QMRA6LXrBTwqz65TCjdnnpVhgWMBuJoZw1S5WPLXoy
21651	payment	2134	2134	1874	1	1	627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbq3ydR55ffNY5vcgrQjwpCFJwv1XBhBwjCScG2FKH8iMYoYSk
21686	payment	1397	1397	1678	1	1	9497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1aBhacngQxqqMrRyxtpvoUCAHTc5mXQY6A6jmspVA7rJqrTy
21687	payment	2133	2133	1874	1	1	654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsw1pn3MjxgZC5XC4pZLwxTTVMZGCdUU8tt97m3u9Eig7wkWok
21688	payment	2132	2132	1874	1	1	176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkx5ZBu7or2dFY582UAXDUFaBEXTSHgRhx8Q9vHQA3jFWtHtWK
21689	payment	2134	2134	1874	1	1	637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AnD3y4NK8VZuURrK8YYZ7WjNkQwGWDSzPxXTpFJxyZM5RvNT
21724	payment	1397	1397	1678	1	1	9508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEx57juJZMbCW1wKRo7qSytk5akwH1J3DUduzJpL6gYPfLvu9
21725	payment	2133	2133	1874	1	1	665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQMiP3bq7pyjhBDc2kah21mxUvKwMcDmHUZrMT2Ey6T2ryf29
21726	payment	2134	2134	1874	1	1	648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuN6g7NMFPUxYxsH9Fy3Xub9ZNpFvLswACsQge425MgrNWQq2
21731	payment	1397	1397	1678	1	1	9510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6KVqJGTACjSyWykVkYbqDYVRMPzp4hrWB19CJxP8G9Q4wWUr
21732	payment	1397	1397	1678	1	1	9511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgGSPv7YE35vrhJMpUBPvNBQM71ZvbiQtaUsuDLUCiHDRRFi2
21733	payment	2133	2133	1874	1	1	667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAqc8xTvnnqEEhPtd7A1mVxPSNUxDmgaRbDBZNF3UHqrhaYJd
21734	payment	2134	2134	1874	1	1	650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYps2HF3GNFCdpNVZ5mHuQ68GkHUjmUTRgzZytJSff36x6dkF6o
21735	payment	2134	2134	1874	1	1	651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJnT7rpnUte9gHmCzaRpe9RZE3gUSoWdBq1zgjZHCmEGatWqd
21736	payment	2133	2133	1874	1	1	668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimHoGH1AYEeQYFk8fnx8GkUF6BPkeFGs5GXcpt6GeYj361bmE
21741	payment	1397	1397	1678	1	1	9513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibiLm8sWthYrtZgLFbRmD6ey2E8k2adHbhyjtT95X2HJdd7is
21742	payment	2134	2134	1874	1	1	653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagc3B45twSnK5L4hdW2qKR79Rgz4mcgSE19m9YgidVwG7wk8Z
21743	payment	2132	2132	1874	1	1	181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWWyHeeJbEbgNLftNj4y3A2irsuUNcuTg3ZF79GJTLWrYjPzR
21744	payment	2133	2133	1874	1	1	670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mz1A2KGFjAEYecVWCnAJGg2mgc7cBEgjncNGCHQYZw7yba9P
21752	payment	1397	1397	1678	1	1	9516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfv6JhNfwky1qYKZQYTUov9KBs3P4Yt5aPUr4brjbBkRcXZXT
21753	payment	2134	2134	1874	1	1	656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXzJsBypskYxrZ21jpedTYiZhp6pCCDup8Rm1GzcWUePge4vR
21754	payment	2133	2133	1874	1	1	673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGp4yjxJwCLWNGwhciZZDAZHqhbgNZQ2ECzngKSLNQDZnaQPA
21755	payment	2132	2132	1874	1	1	182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQVvHBhsX2qeQ7FjWxvoKMzLgosiEZXTHUbtDLH6nfXwB7gMK
21766	payment	1397	1397	1678	1	1	9520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqNQPMxz68AZ3hSe9aoJPKYakRbdRqTtiSmhweDvuULERJJLN
21767	payment	1397	1397	1678	1	1	9521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GcywrrqAVtVacwh9sRcEfHejmqC3meYryPJxHnS1YWkrpVLS
21768	payment	2133	2133	1874	1	1	677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7fmxiFgszKqWXXmhDz3tRMTL1k6Zz6duuY73Ruecw91S5ePQ
21769	payment	2133	2133	1874	1	1	678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3samCxahRAjUmVikKcHsdRrgrKGanuQNrd3TZLHGTbD1JzU8X
21778	payment	1397	1397	1678	1	1	9524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7xjZ9HwssqHW8jfJEv6nh6yiSepdGA3QSu4Ny4zSVWm4X2eu
21779	payment	1397	1397	1678	1	1	9525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDN38PZhkE8wfeU8PWaCiNvL6mKxV1hkzcLiNFhNFmXRSg8qM
21780	payment	2133	2133	1874	1	1	680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGy4fDVyy59VxPwi1jrRxbPVQQhrcVbzedjso3mroA7Bc5wob
21781	payment	2134	2134	1874	1	1	664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13sWr3PrRbLZomwvM8jMhiB8eytj9p5v2krgXSHrgjFoKouN5
21782	payment	2134	2134	1874	1	1	665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYag2wfjuNDoBxu54baWvgx4QsU8ndda3kDVidG7Fb51zjLgudW
21783	payment	2133	2133	1874	1	1	681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNhHujNZx9iuxVYw836YzmyaB5Ew7n996GyDjGGyxuN6oS48R
21794	payment	1397	1397	1678	1	1	9528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpoKHy33u5cpkhoHCciChfhtDf6jK9wHwA1udWsXJMQ78yR2i
21795	payment	2134	2134	1874	1	1	668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vpodZUtT99Mj1wnWMuyp1hsr47tDcy6QtVbJuk37KCbsEBV7
21796	payment	2133	2133	1874	1	1	684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctQnE1uGCAF9QpKe58818uxHhFapr2YyCc8Kzk6YysgTp1rLT
21677	payment	2132	2132	1874	1	1	175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZt5bAhqRGm2zwtYZUYoa7LXAJUoqnKhjGXJCvaCnYQp1JCbNh
21678	payment	2133	2133	1874	1	1	650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXWbR9Po67M2HJGSbqn2TW3U2enUWq4JWF8SJJ5GVmKX8DK9S
21679	payment	2133	2133	1874	1	1	651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3roeqCRE1AqxmC4B22LTazcUfAnQY4Us41zjrg6ZoJyVPnMs
21680	payment	2133	2133	1874	1	1	652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFwiwwDb7djuzWFxHciYMNKY7LrJCHL937ns97mVtYLm2e3fj
21681	payment	2133	2133	1874	1	1	653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsNy5r9xVkzk8sY2cXBJZaQZU3QqDGWG8eM25vU8DTN9EotJq
21682	payment	2134	2134	1874	1	1	633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ReMzHwRRkbJZVCkmNyN9sg5AQsTcinR8nxszwux2JVrj6cLK
21683	payment	2134	2134	1874	1	1	634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFogziKQG5HQ2twH8ZpeVqTiBKiMnC3kAsTJgJyn17H6WZskY
21684	payment	2134	2134	1874	1	1	635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkHVsJLUZpMZcSQRFVcxUoDTGC2CbxTtQri5cjoPv8eJH686g
21685	payment	2134	2134	1874	1	1	636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5HawoGucUgW4CaW8Y2SDvkbqb3q3d8s7msttLRYmLL8yQcoE
21691	payment	1397	1397	1678	1	1	9498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHazgit4ST5xpYHjmYgw6hRBvMPEpFJwUhN4JAgtoVZCZFwg9U
21692	payment	1397	1397	1678	1	1	9499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nnuWCm1PnRWjzUBPjxUe6VVqMGsnk5Zs3fDWUto8LThH3DmW
21693	payment	2133	2133	1874	1	1	655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEzuTfHtAmVgjCA67VPu4mEAaQeP8tdTeTmMNo1mgxAYs4K4X
21694	payment	2133	2133	1874	1	1	656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchtJKeNFU7L3Hb96ba9pXPHzx1x2ks194L1qLEZKA1fLuik9R
21695	payment	2134	2134	1874	1	1	639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZhbZqtKtapPXdurYHZ4UhFG8eeg8S2Dx4YdvboHoxfLU52sQ
21696	payment	1397	1397	1678	1	1	9500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtogrAdR7w8SSt6rHR87njFTrchWBvN2E5UtcuhqdZPQupTGQp
21697	payment	1397	1397	1678	1	1	9501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRDnB2ZfseTvfGVsUC2jVC75HSEA5viJKEaPvPAyXrGFe8Q95
21698	payment	1397	1397	1678	1	1	9502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtf5fNH1rrXVDvVQuD5By266DMMXJMQCy8iNWxXaicwxKweZ1e
21699	payment	1397	1397	1678	1	1	9503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQM8UZKLyxva2Ad8GrWo55yg4KR5KCnKdm53f4KeEqUgv6bLU
21700	payment	2133	2133	1874	1	1	657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuryr1FS6a3m2b3yLaCrTfTwd7JeCT4mbvoaeRL2KMKR27kE7
21701	payment	2133	2133	1874	1	1	658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYyVqbtgXpgeg8aLqKbnTauAJY5XTFrYYRBgWx2bx2gqfzvcq
21702	payment	2132	2132	1874	1	1	177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNtf6a5ci1wqjPUqfmRub1MB8qL8DgCsW6FNEAnbwvVEzDk7N
21703	payment	2134	2134	1874	1	1	640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBMQMkpBSDCpedpMnzHzavnoYMshAefDumeFGWWEsjyP7DSUh
21704	payment	2134	2134	1874	1	1	641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSTB94pm3CCjNxYD6TC5ZvALBv3FHggBatMkvDgVajQxJHdwS
21705	payment	2134	2134	1874	1	1	642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkk9Lk3BtEQGSSP1ixLy7bvyfY5Tc8mqD557uqtiKopofp1zAs
21706	payment	2134	2134	1874	1	1	643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzLF7mLUFMKBgwH1uErdo4N8rmnP7bK5pwo56KFKrghfET1Dm
21707	payment	2133	2133	1874	1	1	659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuFFvfYgXjo39ZwGxfM9PApEeV3WGiXFMjXnG8daUbKY6rdHy
21708	payment	2133	2133	1874	1	1	660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDqBjoEGRpzjnaK3Uj9Gissp1MznMoV3HxnHHWinsYX3GXhLS
21718	payment	1397	1397	1678	1	1	9507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QjdJ12pkBW11YzptAvmRnuu4qsCQ6ZmbnhT9dnu4JZ7kLSqY
21719	delegation	1597	1597	2155	1	1	0	\N	10000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	CkpaEC6BF99zdkANC56U6oyLTQuLGithEv2eWATRnX1v1RRH4hy4u
21720	payment	2134	2134	1874	1	1	647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDxd6tt7nrkXEmkukepLQiAALzCVaf9iJjVuvSPCyb5vWaiHF
21721	payment	2133	2133	1874	1	1	663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrWFoH1ro47u9ieeQJSAqUx4pUibFWyaxp9QkUJ5Z7cVZ7j5v
21722	payment	2132	2132	1874	1	1	179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSx87tNLRcHKqoiSY27JE2H7CPYKTv99FJmXmBTYvbhZ7m5yLk
21723	payment	2133	2133	1874	1	1	664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeCRrjSEHMJhq3ixGVKaRiNkgWzia3RuHq4dRFy8Qv5R1wJU4
21756	payment	1397	1397	1678	1	1	9517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvK3BZYqzF8pRgvitXi4HdAkt5Q3oUHSWfKxFYRP9eiVwwQtka
21757	payment	1397	1397	1678	1	1	9518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKG8EWdcRsffJB31kRbzrFE7NhXgq7iY3kkZzpRMGLQj3fWCUV
21758	payment	1397	1397	1678	1	1	9519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVxVgyBkvx7irGoSEJ7UYzF7U9dDjWPsfukRLEW4iRaugsGN2
21759	payment	2132	2132	1874	1	1	183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduf2XmrFBb3Dac1BATUhbgPiq2RhM1WUmzQVVwURBtcFZbKeW
21760	payment	2133	2133	1874	1	1	674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tF4EejL7PdfmgUkBgkFPXrxuUGMNin9B22QTQM8XoEpyKiLA
21761	payment	2134	2134	1874	1	1	657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9fTbek12qmKoNQm5AYZwhmh3ZyPjoXmgmttoTgY1GVEW2UmB
21762	payment	2133	2133	1874	1	1	675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDDu8M7M2CuvMacZQTevmJ3q5UcoQY1y74YjBDsxZzbR1p2Nk
21763	payment	2133	2133	1874	1	1	676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiRirTwdtUtuzuhoiCTLvNepGbjF2wgHrAWREG1pTgTMZprim
21764	payment	2134	2134	1874	1	1	658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1HBUe5D9WnQxqNBWYN48Tys3wgs1H7chzgPiuQG9YVYULKDt
21765	payment	2134	2134	1874	1	1	659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsE2reHnS2q3zap3hWGmx2xyA8RDF3M9zyLgj1grLjbTd8RxQh
21784	payment	632	632	1382	1	1	0	14747000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZoDSUSLvvw56XZpZWimy82xHUJwj8PoTHPKJGr67ynfEy4zHM3
21785	payment	1397	1397	1678	1	1	9526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqkdHSex5XT5DJAagvYofyXN5wVRVTjYGmCkLsFoTPFtLwJYw
21786	payment	2132	2132	1874	1	1	185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHefNTqYLTSJZk6grq8ukNWdbFQtwQcYRaBjcSdeyoCnZENF2
21787	payment	2133	2133	1874	1	1	682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTExAPky9JMmhmcUP6UjgocvXjJGrSwsTczTMKfXKtAF7bVpA
21788	payment	2134	2134	1874	1	1	666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4SnUGdYXWYRF9y4xjXD6s9rCop1VpAwtqUSEDCzsBs4Xpdi3
21803	payment	1397	1397	1678	1	1	9530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4XvKGQuCQbKjysrKQzSjRwGz1qx6dcNBpf8Bs6bYzsFqBrbd
21804	payment	2133	2133	1874	1	1	686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyLfmnYisktMW7BwHYC4K5SX5FboYimQV3ViVmZSDyN6gTd2F
21805	payment	2134	2134	1874	1	1	670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHE29ShXBBXb5DRuwSzQ7TjgqdfNam77KzuHqemanc9mWqCiN
21810	payment	1397	1397	1678	1	1	9532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFxZVMhopJkSXQkeEnhx59z3q98mQ1iHJojBMziST36UVr3JW
21811	payment	2133	2133	1874	1	1	688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21DjR8MWWA3Szjup9cNeEtCzqXABXDUFLzNpVTdSYBZhhtduz
21819	payment	1397	1397	1678	1	1	9535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCEDwSeGXk1rsGC14xkPDVHXCbTBzzMcnnC6Pqp4vXnpZZeDF
21820	payment	2133	2133	1874	1	1	691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCM5b67eTLjD8HTjh1gaaj1oGDscMPjYs4v5MYiJfwcHBDuz2
21821	payment	2134	2134	1874	1	1	675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvdKyFgqjQZFk93PsXgvL8Wx1inUPQfGfAuxns5b2DPNZ62hq
21826	payment	1397	1397	1678	1	1	9537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyRU8BKrGB3WppWCLSvbVGWWMiVRRSW6VcrSGjDkCwP7N56EN
21827	payment	2133	2133	1874	1	1	693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMQyb9Txo8aDcDuvoWjxFbxYsWeZqHrDSLygARiLbiWC1MeoJ
21828	payment	2134	2134	1874	1	1	677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmtMPN6nfSTWU7vPpPAzEkC5LvKfgvdscrfJNnQGQifcbxqkL
21833	payment	1397	1397	1678	1	1	9539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFbDo3K9hrkJM9Y8VAtekGYc3HRndec26f7zjdwjuikyoH9x3
21834	payment	2134	2134	1874	1	1	679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6k2FGvM9eLxGDPS4hpGgZMDf7pinLJfXnBoLngY6gb8YDer8
21835	payment	2133	2133	1874	1	1	695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSjXssnsRvUHWABEYGerKH3ePZfuW2ZjG7nG746vpSJe7xWB3
21841	payment	1397	1397	1678	1	1	9542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB74aJPpXBe7aMyEnAcxpoSEibByUhCySRs1gRGwHLbWBYLhzK
21842	payment	1397	1397	1678	1	1	9543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1ntT16bKnLmHzmDMBWJLDEvQJHQNd2EWrFmpx2mdmpuKtyDL
21843	payment	2133	2133	1874	1	1	697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1x8QSe54Tkp7Jc8cyHpX4mgLjfrnvAvuFrgHsBSQ4vFuwCgD
21844	payment	2132	2132	1874	1	1	190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HeCT58AUq7rZrtVoG8APVv2gUc1fRrcockrxP77NMC9dNGBX
21845	payment	2134	2134	1874	1	1	681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11LaRhF9YCxaBEPKrcRoWQfSc5jkqnWQayLSrgjP2UsfAPjJp
21846	payment	2134	2134	1874	1	1	682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnX97k7ZWcunC8KokgatMtPmVWHR4qYNQtWPnT4BCQcReFh51Z
21847	payment	2133	2133	1874	1	1	698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUz2DpXr9DjYSppn22KcU6B9GMVqzL4qKtLvMqbWyumhuaKc
21899	payment	1397	1397	1678	1	1	9558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEnL29gF92hSkb65jxcYJ6U11vRmbVbNz8cXeyLi43gP1PhAc
21900	payment	2134	2134	1874	1	1	697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqp3hDWKCPHftFer4kBFfqmStpXXjnXAb7a9xYix8xN2fazC4s
21901	payment	2133	2133	1874	1	1	712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKBWHHZj1pXCS3yi97YkzJzu8Dv4wYbaUbwoMyhGBGnrcaVWq
21902	payment	1397	1397	1678	1	1	9559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2a3Lm7hswU7Sz5ZJs3K57NR5xXSmyhaEsJZavbqRyXtNCTLDC
21903	payment	2133	2133	1874	1	1	713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTjy1TZSpyhjC6RaqYB4hvrAVj32dZhaVrUM9Ge2KPKFbiKhd
21904	payment	2134	2134	1874	1	1	698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJbBpT9TPSQ3aaadrtcwRsfovuUv9o3NiSy7nY8ke1w5gxhDt
21911	payment	1397	1397	1678	1	1	9562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHFo1fAkFd8cp5VnLi8Yutvfo1C2HkcdbXtgwF3uW8shCdagQ
21789	payment	632	632	1136	1	1	1	7844000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpaFCza1nh1DcdhtCW9vY1qFPeDTyx17BAdidQdxAZN8tnHiyJoD
21790	payment	632	632	1256	1	1	2	5292000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYfQ1w3tJoLaNuChEP7C6b7tVELB5mf7VAeVrLwb7i2V1LQ4wV5
21791	payment	1397	1397	1678	1	1	9527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcAoVuYhTZUEgJe7zYPcqcUCiHW4FK58Hsv9FiH7R4DCySE4y
21792	payment	2133	2133	1874	1	1	683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQB4cMDvsz7ytCWe8qrGUUWfxnTv3PHcwQf2q8H7kyLanx9WP
21793	payment	2134	2134	1874	1	1	667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4WTZxCECEWYj8sgQLC7txmSyDZw67HiUKBd4uAwQisPhYMTc
21806	payment	1397	1397	1678	1	1	9531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcPpZKy1aV61wEgBntnDoWwXf6KihmTpMAxNasMZ9Ur9xchmR
21807	payment	2134	2134	1874	1	1	671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6Hdn7r74gHj4b8rxgKL4hUSKJUQnuRMjwvViUkF1Y9uoM4Yy
21808	payment	2133	2133	1874	1	1	687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtSzZvzscBQnm4MAXHRryTFZ6PjSuz4wGfzzeXN4KfPSq7nih
21816	payment	1397	1397	1678	1	1	9534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GZYFJJhoRDVaaE2DfgJY2dWSMcsmXAEMytiDcvaQ53WmWsvy
21817	payment	2133	2133	1874	1	1	690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJTQKet6rc9b19eNf4BJNE3CyfxBYyNYDbmSL44wpm3E5E7rk
21818	payment	2134	2134	1874	1	1	674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tQnnQ4JZWaivFSX9oCa5ZcqPqfttFMrMWdjXxdJnLon5oWxE
21829	payment	632	632	1016	1	1	4	4377000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZtJj7QnFtDdXyLeAoPWnDxKxPVHEUKmqtgco8nycs3sFidWvxt
21830	payment	1397	1397	1678	1	1	9538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKyk3WknvRmNFvTeTVowdVaJSMdiCgEmqcUaFntmPwoq3LxGm
21831	payment	2134	2134	1874	1	1	678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRT57aw6ckNTEZRdPdWLvAJDcjNxYDgb5UVKLJjS7T89ASm5ty
21832	payment	2133	2133	1874	1	1	694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkwaXcNw2k15L8eS1WQLxtLajXvpqafxHSWeZMsnR37QdTkrn
21854	payment	484	484	1319	1	1	0	11982000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZtEsMyZmKsuzeAM6ZhcaqDXh35FJ58R7pbmsukh2shKqCoacCo
21855	payment	1397	1397	1678	1	1	9546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNn8u2dUyTCDYMdFe4djgnm6cGpQyL2BjARxQRJvL4iv1RUHq
21856	delegation	2087	2087	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNXz9CuXu3zTvq7W2tJ9igw6RJA9DW4G3J18mbSb1LtZgpksK
21857	payment	2132	2132	1874	1	1	191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4SMVb4DoDYHFXfBF8ijF711SzjTSsPfaERbSdiPbh8kU7XiD
21858	payment	2133	2133	1874	1	1	701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHRWaNy1JKrkmdf58r3ZetVA37wQ84RVxdsytv2V2XXGnkGy7
21859	payment	2134	2134	1874	1	1	685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP5muNnBMWiaBX52j4Av5q6dB2Sy3stSaQRnSpfp7qdwTB9Ku
21860	payment	1397	1397	1678	1	1	9547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46ugSsy6xxaJ9QThhF2PJqsmkT9PQjNLTH37ue51Ar8L5NdTT
21861	payment	2133	2133	1874	1	1	702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpz8aLc239Gh869txA8eEcgEUYwEEXW7tnTit4bGYAybYFxVV
21862	payment	2134	2134	1874	1	1	686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs6dTkdam1CvrBXF4e6rYFKscP7EMX7kR4za6xi5UJTmhDS5Sa
21863	delegation	2086	2086	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQAv7nATtbNAHEmfapQGZQ8M4LaBaazwhQ6kuohB1r9hiYwHA
21873	payment	1397	1397	1678	1	1	9550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2yvWN9b9sQYyPVYQEMxtFwZhHVzPMERqj9aJfdFb4xgmR4aa
21874	payment	1397	1397	1678	1	1	9551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstJQ6HBANb4XGarXq5rVEKohRm4aNXdr2NES7Ev1saE7R5osd
21875	payment	2132	2132	1874	1	1	192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnmJJntM7XXPKQqBKLHMsFdqXxpyiN8cPpWygUEjHkgUyBzKg
21876	payment	2134	2134	1874	1	1	689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtq9BUoFSnHyq2ayn89e1ESuTYYffzG8BvR4YXgqgRoT2ugTZb
21877	payment	2133	2133	1874	1	1	705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRtBESniLKPuyASAn4qZteNE1KRCnQVXjHtNdkyWuMrwzwxYD
21878	payment	2133	2133	1874	1	1	706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJJTppqjPYi4oz5RFzPmMD3eQqtXU5418fyxSr4WFmpFYg9cF
21879	payment	2134	2134	1874	1	1	690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDaamgAN31KMbUuoRajKN5d9Jogfk3zEoxPdjbzxAcNt4Zt8e
21887	payment	1397	1397	1678	1	1	9554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkEyTnDeU9c8KhbVxc3xcMNdStBxZs1snafktmW74byErUAbJ
21888	payment	1397	1397	1678	1	1	9555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvRtGQfYAe9fzc58PyMDPFMBRLCESQzwPMaYtTz5X9Ds821Sr
21889	payment	1397	1397	1678	1	1	9556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfWV29zYdX7mKTDJcSTFS6Q1AP2JhdkL1SWght2TgDV6KwMkY
21890	payment	1397	1397	1678	1	1	9557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTHV3Pw7RcsLHnsBcnCv8J9ENyR8XpeXtJ5j2r6cDfBFaugYT
21891	payment	2132	2132	1874	1	1	194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtw18NtLbjfjLmK3Gbmf3diVu8CNutDJLnhVNz2ZYmYjp37Qd
21892	payment	2133	2133	1874	1	1	709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5sSPnu33pAPn9dEV9q8XRferNnG9YsLEFTiig8pBjVG7N89k
21798	payment	632	632	632	1	1	3	575000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYc59PD5eG6kUEvMusstbDGihH2T9T7rAECf9jpKPjXWjCR6btc
21799	payment	1397	1397	1678	1	1	9529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFswBJe7bxwPGAmdp5DZarKZvbDyHBYxdVKXPeEggzScNPqhA
21800	payment	2132	2132	1874	1	1	186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpgieVtzsRxj4RvnYJrk1wVowwMmXtzDxnHc5TBaSizocbfmz
21801	payment	2133	2133	1874	1	1	685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh15xvrcTqLpbD4nKP4C7Y1cT65oMka8qJmHWh6yvmdNQSQ82J
21802	payment	2134	2134	1874	1	1	669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqbiFMLznk4bgGzVetdnZ27FSfNDQk1Sap8zNd68E7YvM9jqb
21812	payment	1397	1397	1678	1	1	9533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuJzcXze1TuFKhtGXhyydqcyLcGqHtyktz58tAQ853cWQtFhKA
21813	payment	2132	2132	1874	1	1	187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNAq69Tbfbnk4SP7SkDsSwdzNBKhAGVgay6FYB8vLLEV9BmwA
21814	payment	2133	2133	1874	1	1	689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzsVG1FFe34tpe6X4HunYhB7aWGA4VCs1n91wZuK4FmqBviu4
21815	payment	2134	2134	1874	1	1	673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1akJZvqdSBLoLYXPh2G5FmQsDto7PnbEPqyk8dcr3FQT3uuC
21822	payment	1397	1397	1678	1	1	9536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XmJneTvrL8DPUY33qF8ygad9UhpL2BYasTkHhsqqZkAvQLo3
21823	payment	2134	2134	1874	1	1	676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhJeytoUMfS8tdALaHyWkj1qXTiZSsLaLj19M4eZnH96beC1q
21824	payment	2133	2133	1874	1	1	692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPdfx5ZSVE5fk4rX54KbnXorY1Mw2E9qmvuVXahp2inpYexbS
21825	payment	2132	2132	1874	1	1	188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YHvqiPW2YYLMCoSQyUrNyfkTUiQU7sJroo3K97oGkMrw181i
21838	payment	1397	1397	1678	1	1	9541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRsEP5E8GbZNgKV2j8HAHp2BNSbnPzeLGtfTtryJ4QHkeRAVa
21839	payment	2134	2134	1874	1	1	680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYkjxEwFhzKWFiPmyr4UeKZgJtV1qUabu6xRYwmH3Pg5C8VRw
21840	payment	2133	2133	1874	1	1	696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsT7Ed3NHy6bG1wRGT53qGB998dZyhREmboiv9KFHs73UZTovW
21848	payment	1397	1397	1678	1	1	9544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTYMirRPeuoSYUKspC1VbBqxLy3qteVCqvV1j3mbDCV2deyBa
21849	payment	2134	2134	1874	1	1	683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnbF2Pz6NKFy7ASiD58QbFbj3Yg1QqvhFSHzAPXABgzEdSaAA
21850	payment	2133	2133	1874	1	1	699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyyNCxYSNbySXZ2CNx6R2aseUFKu9griJDmaNadoh8pwbXo8S
21870	payment	1397	1397	1678	1	1	9549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxSqjCkgNr5nt8P1Q4Cq2tF3VHezdE8dNqJmmLCTewXoz61et
21871	payment	2133	2133	1874	1	1	704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8fwAJpNLLDWmK3EEDaRKwzJiQeGZ8jQa35kfUdH8g177nA5o
21872	payment	2134	2134	1874	1	1	688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa95Kgh29epzdUGh5JvuF637MnHomX6i6owVScyC2LP1BBCLuWf
21880	payment	1397	1397	1678	1	1	9552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBiJiLocTzmdHKKNvEZHVzd6ZT1iS9DWeNt8tiMc2wYjN9TJA
21881	payment	2133	2133	1874	1	1	707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbfwt2faAHhFYJKtFiRUvAiCZMLZ1n6j9qWJzG7SPsNUcfqQr
21882	payment	2134	2134	1874	1	1	691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVtqdyFJeZAD3SK1E6ToWyuHZPNmmZWgRzv2YLdyYcEe8p2Fy
21905	payment	1397	1397	1678	1	1	9560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZypGgsAXWPXQ6XGohJKHkzqZSkDKCJ1xP6coLC1TR2eL3UH79B
21906	payment	1397	1397	1678	1	1	9561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAS4R6MjCNmLGyV93ZAc9Nx4PFovPc5bnv3GJHKanQan6RoFF
21907	payment	2134	2134	1874	1	1	699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1rorayTfKUoR2WA8FfG8gRSmFBgyHNo53nNS6rPzgC5LUrD7
21908	payment	2132	2132	1874	1	1	195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQJ27acuZ3NESLCQtdz1J6J2PJyzDkFiLJ5GVFCErPDCAuFnK
21909	payment	2133	2133	1874	1	1	714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydvhaDXUKjRceoDf9uyKVcNLH7qZt1A99m6HFtGJPyWVid4H9
21910	payment	2133	2133	1874	1	1	715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4E2AWa2YWSc7tV9J1iRF6ZrmVwYDQdMWWShE7MZyNEubEJ9Jj
21918	payment	1397	1397	1678	1	1	9564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkQjqPW2zwTzzCmR37Z92M6KmGCxwDntwMB69g6Di5nDqL7kJ
21919	payment	2133	2133	1874	1	1	718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjV6ti82LJpbdFQYXPDGxqTX6EHmP4uo1FW9beU7EYuetXfhQ
21920	payment	2134	2134	1874	1	1	702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnMtnUkqbTBSwGVrRyhhd5apXU5cVY4twpJVD9EDmhqmVu1qU
21943	payment	1397	1397	1678	1	1	9572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4jMN9sknCzoGqk64N2rdLVC22dhYdWfekdJA58XZgZNuPKe5
21944	payment	2133	2133	1874	1	1	725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUmN2HF6hsVGT8AUvQAUkEYr1PPwgnLAzTeMqvik7MyNA5upaX
21945	payment	2134	2134	1874	1	1	710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bRLg6CDedJ8tuTP6oN4tHRErEss2jJkyGa83eaJZHtoipbrQ
21952	payment	1397	1397	1678	1	1	9575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPeRxB4kyQpZbJjrJhCqkpZQW5KQMvp5ZiXDCEN265YdH64o8
21867	payment	1397	1397	1678	1	1	9548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtCdr4k1CZAgZejNWQHHKUyAgYNoMKrzezdZnpU27fUUzxBmw
21868	payment	2133	2133	1874	1	1	703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWo9xrhm5SUerZojXysMKfqrFHhQDri5kd3MFmwjom4pXsTJXG
21869	payment	2134	2134	1874	1	1	687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdaZB35mer28di7FzGac3tMc92Vw7B3zGxARX9EaTkR7P3WuJ
21883	payment	1397	1397	1678	1	1	9553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQK1i8ew2SMHyP7J4WnVZUMBeUKCkJDWse9YhTKnJpRkimieVx
21884	payment	2133	2133	1874	1	1	708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaEM2enRPgaceXTvZXuW1Z7Z7EdotZW4X9m2FHhi5a3GqRcjn
21885	payment	2132	2132	1874	1	1	193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgKWDpLTdb4PFbGsP4aSZrD8UQiHMAsf2adsA7na55fhPbSK5
21886	payment	2134	2134	1874	1	1	692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZZsgSZD4wjkVrve271wwqQypP8vLmvCvxc1Pw8xMvjGLGfg1
21921	payment	1397	1397	1678	1	1	9565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTauZjMDdAHQNha94kmctg89GdnXARRivJxNyvBbaACjVonkTN
21922	payment	2134	2134	1874	1	1	703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUyMbpMG8EidfnnXLUu2k3NLbEZMB3Te5QvJyyfNVRaUjZVAp
21923	payment	2133	2133	1874	1	1	719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfKvjS8Khf9EyfnWdQXqmqJCuwBwvq1yFMk2yXpnrj643CuDF
21924	payment	1397	1397	1678	1	1	9566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyS5Ynuaf7cmzev46f2yqLffU6KMFDRGDKRbcAaYUB5rARQytU
21925	payment	1397	1397	1678	1	1	9567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdeJSXTsoDTKW5VfKQXR5ArjiL3PEkcEx3TPdA7c1fG3QTB3h
21926	payment	1397	1397	1678	1	1	9568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcASi9kLv3KuNBdXtKGvQzNPV17DYdpymMKMLatdemcsLdJGKP
21927	payment	2132	2132	1874	1	1	197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2wsoDAEPkmeJr3yxLmeUnpF9vAhwbbjpZdEw9Z7wsWUCuaLE
21928	payment	2134	2134	1874	1	1	704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPa8Jp2KKUiSUUt3pqejdnLcxwsyQbqFBw8gaz7eTBWXPjEvc
21929	payment	2133	2133	1874	1	1	720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRjPHZ325zPPHCPpdmnJg17EDKd8wyRdPQmpCiM7B4rC3PzrF
21930	payment	2133	2133	1874	1	1	721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaRzrMKy4c2UE98oKQ3xwHkdekHxq2iMiANtjddQtWJNWFQ1R
21931	payment	2134	2134	1874	1	1	705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83WA1zB7T38rjGGdr3J6P14WD4wCDv1wcaWCS5Bj9nVFGNTqE
21932	payment	2134	2134	1874	1	1	706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoD6Z5iq7FLWKYUtMa4ZciPERu4JkL2itQ4SHoT7khUCukLyb
21933	payment	1397	1397	1678	1	1	9569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzM83qRVSouLtSBGzhJNQnKkvY9r8keSvcA5WrRUS2mSwaGyiA
21934	payment	2133	2133	1874	1	1	722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnw4Wm4aaULaPxtfYpkKpucECLyhjZsti5kcBNMtbH29Ct38YN
21935	payment	2134	2134	1874	1	1	707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENhSLDgNy5YAJDoaH2LnGeDZYqQde6VTBeLWEXF51rZPQ8oas
22035	payment	1397	1397	1678	1	1	9600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tJ4ef4zSWonD3VEb1vQ9dP4wrNthfGBDCim2p8fWeVQwNnKw
22036	payment	2133	2133	1874	1	1	752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbQV5FcNNaJYhHpjmGgTRExN5hEhPxwXpbQfpqBvjhRbsHVhT
22037	payment	2134	2134	1874	1	1	738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRG3mmUsj2zupXXDG3SvcDdhVSiUJ7By6NhkvCujwif1mtJb7
22054	payment	1397	1397	1678	1	1	9606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKkMHeEk48CLKK4AgnGSjxJEHDeTpz4rnRo1vMuq6msUEnJDS
22055	payment	2134	2134	1874	1	1	743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZ6cpeKhMCzL1DCsGBV9czqECn5gCETsKB7nmeipwUZTHmR9d
22056	payment	2133	2133	1874	1	1	758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrGWpntmmB7AtXc5NbGWBci6SXKdckcNR8uHtm5iiVieCJizA
22092	payment	1397	1397	1678	1	1	9618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxhhT1hDJNpEsYrMX3UJtMjit3oosZdrZV3Y9KGnR3LBwVxuo
22093	payment	2134	2134	1874	1	1	755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQHMfpd1Ujm5PTTVmJfH2MPSJJFBzS1X9YzoSKiCGwAATi1Tf
22094	payment	2133	2133	1874	1	1	769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzJ5YDh2XCJzfV7M8RXSEU8qb2D8LqEJfdGroTvsdNso6yGwN
22100	payment	1397	1397	1678	1	1	9621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThM9jNnpMLWLDvtmsXvJFcmXAHBRwBeHnVKu1MTZyagysxZBx
22101	payment	2133	2133	1874	1	1	771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvEQi7Rs2NBxS3MGdSgCpfDYrew9qbQeXEdddHoKa3B5pViF9
22102	payment	2134	2134	1874	1	1	757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZMpRzyodsNR6JBQhcYgHDSuBtyvwxjrGLAqNdRbqA95UhNAj
22103	payment	1769	1769	1769	1	1	41	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tup5cCXayqFZnhjdHZXJijwEzWd8MU4pH8FtTw5MpNpngAih
22104	payment	1397	1397	1678	1	1	9622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBS7cEGQsFS1Xq4tJXhZFu6TukJ9ZebjZhUSnQuP543QZTSS6
22105	payment	1654	1654	1340	1	1	4	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86Gxxxh83bcJ7hRiCS5n257GBGHuYbFgk6ugeDMFssX1ZZcVY
22106	payment	2133	2133	1874	1	1	772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrWfRXD81mBLY82ijeAvSBT6rztY6kMSV3P32bdAog6pspx4Z
21893	payment	2134	2134	1874	1	1	693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRYj3be4231Chu8Jw6AQVmRoEdLfoWMQUrhR2EZbbbHqy8PBa
21894	payment	2134	2134	1874	1	1	694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeQnxPJFqLmt2VYeto2eaG2t1mcAoyaQcm832q5Z1uaMMWZLy
21895	payment	2134	2134	1874	1	1	695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9vdkP46N2qqyCi77UtnBs47jDbs2nv5fMQTC95K2WiFpkkCD
21896	payment	2134	2134	1874	1	1	696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ywqjWLT24ZoQ9LJiVAm9UVvbaMV4iMZf8mHNPoEuL48tfs4q
21897	payment	2133	2133	1874	1	1	710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cZYSPSFGej9r1i14CQxTAhsL9MCRxJ6AUa4AnzFrkHeXFhj8
21898	payment	2133	2133	1874	1	1	711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aCRDh7eApcQ7s4eRuxgZcvm4ZeMFVis7iq2wmUpZrhVFuwoe
21940	payment	1397	1397	1678	1	1	9571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFYR4379FvwxByWWEBttm6L4RUNV6vHHFLjX9P7KAjhHBALaC
21941	payment	2134	2134	1874	1	1	709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoctJVZtdKwRfhgdQsLU4joeAEdYxHPnhrcLMmtfnJ1o6E2x5
21942	payment	2133	2133	1874	1	1	724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8We2rvTDtFzHdxQQ9jBRmAWuuCYGXHbyBcxB8kBCMPfZWwm7K
21946	payment	1397	1397	1678	1	1	9573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3SUCQ2MgVmefvtxnM4TzSDsNqTTqfLiKkzc1AHB7bDyF6cp2
21947	payment	1397	1397	1678	1	1	9574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrGxh3fL3Ci7WBnP6TpA4S4SHxqKYtEgXd8Sg66bSYrqVQ1gQ
21948	payment	2133	2133	1874	1	1	726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePAkdKGu5mGd1uhrrKwsmVUf3SXYCTaYD7UAgfjW3zcBCrKyU
21949	payment	2134	2134	1874	1	1	711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdBXNVbwWVMfWaHkk2kVur4gvCNtG9ZGKxPhdcezQsdQUzACD
21950	payment	2132	2132	1874	1	1	199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj4jHMapHZsCq9aDHdHUhjRu76yp9gWr7Rt98yY44Xj8ppS3v
21951	payment	2133	2133	1874	1	1	727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUAcWnryqDzUxN3t3FU53jXGrFzQPTQ6gJqi4ouEcS8bLxeiX
21975	payment	1397	1397	1678	1	1	9582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XMKoskYrhfy78AhZidkg5crfwT6YhYrr4KQmymREheupCkfa
21976	payment	1397	1397	1678	1	1	9583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQFDoeqinzsjbcvEunQ6mGaazvkxLseh5G4AwkfcP8jKY5WfG
21977	payment	2132	2132	1874	1	1	202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwJ2eGtTTu93Qox3FkF6NJMrPgNGaif366jxYFH4EKeGxnzyD
21978	payment	2133	2133	1874	1	1	735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJq3KY77Jtx83fFBD8mQvaA6GFzPqTxuj8SAELkhiAh9Ewf9G9
21979	payment	2133	2133	1874	1	1	736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJdBcu7DYUPeJuMiGx3LkGeKGRnnunMLRh2iRxqVqWFEyuZ8o
21980	payment	2134	2134	1874	1	1	719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQexFiib7UNo7YdaKawWojNmkGBBuSC5E4QDnPgPM4cdEUB9H
21981	payment	2134	2134	1874	1	1	720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQSzhbB9hEPknEKtUSpQDqASzhssCtscGf16Bj8pN5wqW2MkS
21984	payment	1397	1397	1678	1	1	9585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LRpuwfM6S4sHdwUEFTULjwMabRXomgcSiZtWbrQgDsBVCfB7
21985	payment	1397	1397	1678	1	1	9586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3n7nNmUycn8172cvmRURe4VL9saUv457SSvBQ3VQWHwqAivzk
21986	payment	1397	1397	1678	1	1	9587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesQ7Yu2rdmWsLXvLzvc1nnVriabQcHqCeSqG79v3UiejARtMQ
21987	payment	1397	1397	1678	1	1	9588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4EqisEbS6AeEJTNNAFr5Q6TeufiavDGx7En4Ggtjbt6AB8Qz
21988	payment	1397	1397	1678	1	1	9589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2thse7LVNLZfyWTMR1XWPh1dV6rwm5jLq1w3LTbt2XFapWGTv
21989	payment	2132	2132	1874	1	1	203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeW2bTdrCwGbMTPCYCzWuxvnqAJs8MxjN8sud6z1supNPT6z2
21990	payment	2134	2134	1874	1	1	722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6pbEQqduDE44PPK5W9mBMQZR1gurrLS8PYWhYGobgXB6W4Lp
21991	payment	2134	2134	1874	1	1	723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8ewurCKwcHT7hxfGqiheMwVwnvD9J72mAeg1mgLPn118mDyX
21992	payment	2134	2134	1874	1	1	724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvoZBCYpqe2pRgTRHzYhS6ijY5YU66PQL7yVoG3YzJPu3V2q5
21993	payment	2133	2133	1874	1	1	737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrx2hEjy4xN1miPkPkKdXZuJwmCtJ1urnN7ZAJxxg86tNHNypm
21994	payment	2133	2133	1874	1	1	738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR37txQXWvgK2nDjhYGSup4YCrbs6Z3Agh9DeTRVEtg4hjfduJ
21995	payment	2133	2133	1874	1	1	739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMpqXDMrhAqBvSecTJViNrn6xD9afcoXGWBQuqcw8BmfVgEUD
21996	payment	2133	2133	1874	1	1	740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSy5t8vjsvWEpQUrTn3HzHrNvAFVJTw65UddAbsd4x7eXqTKhv
21997	payment	2134	2134	1874	1	1	725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3MCJF7Pj5mfudQGf9KjhUUr8AeFQ4pY1my2XfxZq5hhQ7hji
21998	payment	2134	2134	1874	1	1	726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjSWPHRbUVQCDmZxpv3CL8wrEC7oTEtFDFDXPdQXxm9MwCVHi8
21999	payment	2133	2133	1874	1	1	741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmo8Fy7mTVjLDxcf4DgtnKonevV9rvLihxXvUaabs57BBR5Kt
21912	payment	1397	1397	1678	1	1	9563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU3vWXcnoCBFRRoYM51yKd6zqAMvvgvzxHL9Pr1yV7A19TG7x
21913	payment	2132	2132	1874	1	1	196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5mq1wnKhqRrbXdPANjRRh5ZPeXy6mi7h54txwmzwToMFeemf
21914	payment	2133	2133	1874	1	1	716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6yobt2TQmo8wkhPD3N4LpkWDLBubg13r79m7kVgA7j5gkwVk
21915	payment	2134	2134	1874	1	1	700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpat3wY8dyRnF1na3MNiub3kjfrpAEa53rMKD96xksZbCmfQ3j
21916	payment	2133	2133	1874	1	1	717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RcmJFtL63mhfkBCszokCkPaxqYZzoyzYHH384u392aiPAZDs
21917	payment	2134	2134	1874	1	1	701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbpPpp64QVSCSghwk98dKZzb5PCK8NM2wiKLYCGmgRr3ZXMM7
21936	payment	1397	1397	1678	1	1	9570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczB5ekzDUAVEWiDGL2kHw3BjWfKo4A9ccbG9Z7Qe1kMj2ZaCg
21937	payment	2134	2134	1874	1	1	708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqCgFnT5JmGqEo1QiLcCYHt9umhRTJGPmbt3NavwMSCyXMLLu
21938	payment	2132	2132	1874	1	1	198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2Ci9PBGKi1dP1bfUb3hyKtvuY9QMtv1yKREXuJ7LtZ3Njx4V
21939	payment	2133	2133	1874	1	1	723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxd8Vx7aLBs8uD6rC3ae8pvKeDbtHuU1Atwcec8GHpPZLXZWe
21962	payment	1397	1397	1678	1	1	9578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmsUhzgYCUzKDii1nHj6Qep4tRPMegjEH2bz7fNQaanwTY1HS
21963	payment	2133	2133	1874	1	1	731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshfDsznGXcowmHe9JNR4g9fydzF3gzTCL2WxxerumTE3aWGH6
21964	payment	2134	2134	1874	1	1	715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17S2aCGZR1i7Pdb9Kx1jjuNjni8NNLzaRPLSS3ubXxyrQ1jDr
22000	payment	1397	1397	1678	1	1	9590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdexwu8x3rdY9cYgE5zecDNMSmZE8L1FXuB9aWT1FFr1X4hZx
22001	payment	1397	1397	1678	1	1	9591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgoYoAYnpfiZC8cTRbaKJgEwKshJpS75s4PoQPmx8DUkigqfP
22002	payment	2133	2133	1874	1	1	742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiM23C8oLuFAgCtzAzw9F9EuhrfbTBSBRUUHYRCTN3dTSNVbLx
22003	payment	2133	2133	1874	1	1	743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQ9zkRX2XTxL2rd8SZhNdMgMG7WvpN4z7qxvQDpgyu6ZVGiPM
22004	payment	2132	2132	1874	1	1	204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZup849WVeV4bREwRWEHeQ8BiWVeCbjeXKCESVyGb4v8KKFrxvB
22005	payment	2134	2134	1874	1	1	727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvKxBKAUSUU42vhw52h9sDh7YE9ZzcZcfDQv4DSdtuxxVH4AS
22006	payment	2134	2134	1874	1	1	728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxzYHERUxwKSevFQJdgiQh1dVeCDU2L1y9S9syATfA7rxzhHb
22017	payment	1397	1397	1678	1	1	9595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiPCJdJzrxMWH9ULbDJ8xmBU8jKPkS2rKxavfjuMnaLTcioPr
22018	payment	2134	2134	1874	1	1	732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsd1xXC6Hi4r3PCax33ZxcGhsgcmZc3z3mU6Rn1tCjqGSzNtG5
22028	payment	1397	1397	1678	1	1	9598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cwoyytJ8wKkajoWCi5iXSGnvnCvqVW6YjhGQmfcrwXpNdohy
22029	payment	2133	2133	1874	1	1	750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmf6y3PT4ZYrbK8TmLHH754PqWR9Cr3gvW3WUtj8WJ7ACoFmPL
22030	payment	2134	2134	1874	1	1	736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUz2P4t2GauKpWJASr7NHGtwt6fzJb7s4hRkq8MHWSLAUznvE
22038	payment	1397	1397	1678	1	1	9601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAucDHKrb91b843QJcDWBr7KkrRsqdVqLzuunjq82aRjTzhNnr
22039	payment	2133	2133	1874	1	1	753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1b3neYVwPaaaNsFPWfstQnVy5JBF2q2MPjc16XeYvwMrEMBG
22057	payment	1397	1397	1678	1	1	9607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5muhPxmCBdhsM35DLaeWGVPi8ttheVkuZsrrwirHKybCe4Koi
22058	payment	1397	1397	1678	1	1	9608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9cYWj1Gmg8HF4Er1EPURSZzDJxyHcWxgKNFD3PynSR96Ys4E
22059	payment	1397	1397	1678	1	1	9609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxo9v72hR7ztgtfggE7ZPnj3Mi7sctC1co1Czzrut1UUbJqtir
22060	payment	2133	2133	1874	1	1	759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ668Nxy3WQTCrzMYTEd1mL3YcP47sVhXGGiY39T5QSfrGuNsRf
22061	payment	2133	2133	1874	1	1	760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksZNG5FaFPCXQcrPBgNmK9ciPJVnXcvg2c8Ybyw6ReiMpfctV
22062	payment	2132	2132	1874	1	1	210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmAqZHMEKTGWWr8i9YujvsgLcUwai4cFnFa8aPYk8USEGXvtV
22063	payment	2133	2133	1874	1	1	761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeymhLK3aUivRmxRorekn1KSttvWnjhWko1ZmVfK1ZTKLtp2j1
22064	payment	2134	2134	1874	1	1	744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RBPG5DGwXJKizx7MEN5FpDsr5zioc9cA6AJQ6uVYDQUDbZLR
22065	payment	2134	2134	1874	1	1	745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqTgr5V45Af3qB6LJRXHgtApqzHTDa95GCaWYNwBUYzLiwQbY
22066	payment	2134	2134	1874	1	1	746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dJCdosPSkBDSmRMuEzg3KXifGmzAjwN6Rwv47AAP5XGmryPE
22095	payment	1397	1397	1678	1	1	9619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxx1aCABT5hphxtsQqgkWNsjehzgPkrV2FKwAZFYaqJ4KsHjm
21953	payment	1397	1397	1678	1	1	9576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4Eggh6neZ82drqPF1pP4DBufTmmbE83syDyVD6SyjMBnTn4K
21954	payment	2132	2132	1874	1	1	200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWqw2Fg8QBrDXVWaxScwFbnhukotbKDPzBrGqKCjoQh5UT4dr
21955	payment	2134	2134	1874	1	1	712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoP3ZYSa2PkEdLHoXoQ8pTNRL2HKavAoPYc4DkpHtc6odZhsVN
21956	payment	2134	2134	1874	1	1	713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxssCLDZCWxmJr4KvZbmhy85EzzC9RUzVTDYY9LEbxeeYTdGv
21957	payment	2133	2133	1874	1	1	728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4xfFXXDZyhb3QC5cATcMePu9Gg1jPDrZBc8pfawNC2cajpkEL
21958	payment	2133	2133	1874	1	1	729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPgLK6t7193pQ8cRAt6amqCdjabG1CXMf4JY76nGFuiicWkVW
21959	payment	1397	1397	1678	1	1	9577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uBDAc9Z2yri6FUpevakrbwgj3uFaakbfEuktCqDx5wb2vtjy
21960	payment	2133	2133	1874	1	1	730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNV4zEF7NbWtAXPrx3xKS81pLAiuJUn5nWV8Mk32Mz99WH1RL
21961	payment	2134	2134	1874	1	1	714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVYACjbcqxyMFoKbtfHkgdizamwsb6J81sxPVdwUsVzdkQG6B
21965	payment	1397	1397	1678	1	1	9579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoJUprY9N6tqCwu981fbeyiPNfm22UCgWscWRHXTHJphdVf3X
21966	payment	1397	1397	1678	1	1	9580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SvYdjniq6sBShPyYJrjL7F14MVUrgYjJYbNyJaAC8dab3uMt
21967	payment	1397	1397	1678	1	1	9581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2vGw49UDVcYBeukUoKaBv5mLkmMS7LC5zHyBzj8g243uUkaR
21968	payment	2132	2132	1874	1	1	201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyoT5FZKC8GwY7utsemXSCQLXCgp4BktXe8cJFTNm5SsTrWPr
21969	payment	2134	2134	1874	1	1	716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9WLv3MvUWPU5c8DFUu6wpn9kREyQS2XxA1AXXvtC3sUW93Su
21970	payment	2134	2134	1874	1	1	717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqNyKuNqn3UqnCWZMweMcQgKqTBTH5yfcTbn7CAYeGzPCnysF
21971	payment	2134	2134	1874	1	1	718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikvL3MDBfJY6txiPXz2H3sU9HEWy4Yd4jY56rgCAEk3TwugD9
21972	payment	2133	2133	1874	1	1	732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BL8fvbxGDu67g79UZYSiLSbvHkynesCEEpa8s3wTwzfauc1y
21973	payment	2133	2133	1874	1	1	733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSraqpZJc5miLsFED32VXVQQS8oEhyQ7o8eEhYocw96d9pR7h
21974	payment	2133	2133	1874	1	1	734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASD6e4KATaV2mghCABeVsu4cN843vycqVhS8LezrNZP523YsR
21982	payment	1397	1397	1678	1	1	9584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqVmXqgsSGiZx5nwqeUgJAgmTyFb3Nrryc3eBtuyyveS29RRG
21983	payment	2134	2134	1874	1	1	721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUMomWe6S3bPYG1pGiivA4Gs6G8AzYHgWZSFFqSe99nfVkpd8
22007	payment	1397	1397	1678	1	1	9592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUBNVqv3yqSbXis5SuVHoAu34XrwkTiT8pVVfsNyG7znYu15S
22008	payment	1397	1397	1678	1	1	9593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzuRFqMiBDxShneWgPSAsBF8JfKJFKJnTHHJVLohRs7B4CN2W
22009	payment	2133	2133	1874	1	1	744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMPxr7EpKcqL3bpVVCZ9j4q9Bdrg2JQZoTGpxAU4Q9LZkdbuC
22010	payment	2133	2133	1874	1	1	745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkL1ni2xHSaVrGPxzPmxbNnJRFihbtSyZHfP3uQyU2ZG6dkQ44
22011	payment	2132	2132	1874	1	1	205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyv5yXiqo4QuX6wK4mT11Lc6bpRJCA5NUd5XgTKDNHG7gJHwZF
22012	payment	2134	2134	1874	1	1	729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6FQ65wqC9L7jVqNWVe5qG2ayZ5SZRG47sVb7s4rkLJs2ZNDu
22013	payment	2134	2134	1874	1	1	730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymovhiWUb5tbtcTbcvWviphCNFyZpzGNPXuG8NDh9FrpNBX8N
22031	payment	1397	1397	1678	1	1	9599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty8bHCSUCcf7My6VUVERHvJjL8U5AXYJjzEXrUs25Q7egt3zn
22032	payment	2133	2133	1874	1	1	751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBmd7nECezoQKGxYhkksUnq3Y1qvMuqWh3zvR5KAapeMxHvZe
22033	payment	2134	2134	1874	1	1	737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8WM5oFkjCg5A87WQDy14k4j2e5uzsQ787FZ2WXR8R9ThAgnR
22034	payment	2132	2132	1874	1	1	207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceZ1P7GpgUqBbmV6rVc7FRo7675CVACa1Gvx6EoXwQQ3yx41a
22044	payment	1397	1397	1678	1	1	9603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb3EUzrHRVYNW7EeFj2xmTYcjxHxuw4qbvy9NG5AKHxDP4MZa
22045	payment	2133	2133	1874	1	1	755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG26U8WX7KSvXddwE57ZepTvJp3WRvnDxe2gK7w1nGAudbUJK
22046	payment	2134	2134	1874	1	1	740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSohAMYwCvDaC3ujxs76jVUoUFdBt6GnFMLTycW4Gk3JTHScFS
22047	payment	1397	1397	1678	1	1	9604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpHkgpyJYVooa4Wf9ZiMUXk2x27YUbiDPHRyd1TaUGYKQhJhj
22048	payment	1397	1397	1678	1	1	9605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6DC4gpUqhGRJxX2SCufzvacq5TpVZZUnHj217mRLceu9DG8v
22049	payment	2134	2134	1874	1	1	741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfh6q47Kpzenfq34wcK23SLmT7FAu5Q7Bxm6gr1sPRqPVHpAWR
22014	payment	1397	1397	1678	1	1	9594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUxJKT7iKH6o4R6GEwosnrQJRbbt8jyqiut41AYkroEoYzoNa
22015	payment	2134	2134	1874	1	1	731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxewhaK8HCF1yXkkzccqJQQuGjfUDMq6SUt8HjusSaCvEessjZ
22016	payment	2133	2133	1874	1	1	746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugvvS2DFETPHguTUayj46pon2dHyVnxGALc3FWddxMYpsrwXV
22019	payment	1397	1397	1678	1	1	9596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XxKtDvT5aES2poixma7zFZzvGtE8WBaZADKwCRmbbyVWSdZq
22020	payment	1397	1397	1678	1	1	9597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HS8hngB98MSKeUszVWctFkdFa93DWfe7ocFLcTT398HfEEhJ
22021	payment	2134	2134	1874	1	1	733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuX1N11abE3c7XW5cFtcvADw2EpzhuH82M596LNCNTLMPS4RBL
22022	payment	2134	2134	1874	1	1	734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVMmYiZKa7gGHUQkmzBxH6M6XW9ks2f8WCsUYve4CjhiYKMMi
22023	payment	2132	2132	1874	1	1	206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnzGJxiE3VeWcTQE6D7uyFMFcDgt3h7gKDW7wybnvDXU8v4Ea
22024	payment	2133	2133	1874	1	1	747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4j99rvHJAEtFuXUc9pycpwheVF74i9ZabX8DP9E6YbS8hX4rq
22025	payment	2133	2133	1874	1	1	748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5QGDsvUCAN71okyYAEZDTNZ4WNUqrcY6p9SPBseCZ2BABVvG
22026	payment	2133	2133	1874	1	1	749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbpjU4cPWkZ233evRs3jdCv5JfDZ1ezUqzmaz6E6Hc1yfn6S3
22027	payment	2134	2134	1874	1	1	735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJofKd7BvgjQWZy2YGcHphLXXo6bd5smaGnu7UAU22Qo22q3Go
22040	payment	1397	1397	1678	1	1	9602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFrvbqW82Zazj11EFRiqPuey4ofStNzMEQ2u26yXU4PhjgFm9
22041	payment	2134	2134	1874	1	1	739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHazb3JKLdmBLUXoBB5UwCa6R7raqKz63kQeUxVrFNNixpjDL
22042	payment	2133	2133	1874	1	1	754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCErrLRMNo9CKQEgakXQeBTC269ciQmrQqxaz1VdpJ5UeEMTjZ
22043	payment	2132	2132	1874	1	1	208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWKDSCszR9dUr9f2B3CuohvAJnLWvPVuVxF5WGHpG2sMzB1ZE
22070	payment	1397	1397	1678	1	1	9611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBi9YMkPmpt9bT7n57cN2CaX1u9yJbdfh5Zp94ToA5cajuSbgd
22071	payment	2133	2133	1874	1	1	763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekgFEtvBGevJ8JHn2x3bGmAxKCdftqB4g2RYgPBajeSJuPrvf
22072	payment	2134	2134	1874	1	1	748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZecVNEy1USuUS8Hau17ygsqcFmaBAaa4a34T3KE2AYw4oGDC3
22083	payment	1397	1397	1678	1	1	9615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB7sTfAqRUHnmFKAXKfizTpxLiGbNshByAHq2dyUGsi3EWQJC
22084	payment	2133	2133	1874	1	1	767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNbRzMUB8DbERKJeeJHD4Pm1cJ3L5HA2Mc6YL1ANzg8AQtDTo
22085	payment	2132	2132	1874	1	1	212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQnzE8jEdh1Z4x1UqoaKAUwr13LSwjZ1WQoHpBMYV9LqFadZ1
22086	payment	2134	2134	1874	1	1	752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4yUp2SjtSaqqjF4Vjj1QrVbvGkYDvPGSsMgN2sgTiMcn5e5r
22109	payment	1654	1654	974	1	1	5	1000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZHjSg7JfXkhU5V8Gqg4JZ2CjVBbkv5iAivVFpuUkz6vuDDNEip
22110	payment	1397	1397	1678	1	1	9623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGPNgunUcgNjCDYjdrW4u9fRi2WvhGHNXL2M64Fe3sTQynTp3
22111	payment	1397	1397	1678	1	1	9624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ8q1ME2wWSwPfA3KNnVMSpnjZNXGFvjMB8MrhxTicTkPzDa1
22112	payment	1769	1769	1769	1	1	42	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzNAC7azYeqnyvwdCDmV5KHqZSEDoxEeqss5QMKpwGW4RVYrw
22113	payment	2133	2133	1874	1	1	773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLdr4Ahr2eVRhe1yWxSCoUsM52K2cTt9JAVKJxomNZE7u34GR
22114	payment	2133	2133	1874	1	1	774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBeuE2EJKjTBZqaio37yE6dvajQRUwPnCWyhP6Maipq9gaFvy
22115	payment	2134	2134	1874	1	1	759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSxibouMw23NGBQX1XzEo4JB7y8sWiNqE6jrMJygzerbxP5Wm
22116	payment	2134	2134	1874	1	1	760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpU3ddkye3cCoMLYtjJjRYeRLvBZ3qpt9T464FfUQs6ingcYJ
22117	payment	1397	1397	1678	1	1	9625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Lg4cNQqTjHmVToeo8JMtc5dnjwQTBox1tMx7CN3neELaKSVP
22118	payment	1397	1397	1678	1	1	9626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC95JmtSuNwKrtZtA6Lxtn9tQTqc5DHgS4wNfRxV8Zqvp3eJj
22119	payment	1397	1397	1678	1	1	9627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVAxZtiGkUWEn26QwDqFRSk8Erq6rVLjVW4aPeWg7MYk3DMTU
22120	payment	2134	2134	1874	1	1	761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNx824Z8sKEb6BFGegHVS5esGwQFi8N1bujn19C9joGgBe5vp
22121	payment	2134	2134	1874	1	1	762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNMvDANS8LoFwZTYwc2zSyPUVFif8ibcYCvvx9mqbsy76GFzk
22122	payment	2132	2132	1874	1	1	215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvJ3qM32K911rTNpdnAPnk5Myyf5ydZ7aupM7cqVRaWuUQxdV
22123	payment	2134	2134	1874	1	1	763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23tYvPpVbZHMnCYeaxhVidD8o1PfHDtCKxKPEpxzDr71xhx5p
22050	payment	2134	2134	1874	1	1	742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMjMggmJx1XFANHXND122tAW5XA3CvPDQ5sfrdcwGGbGTqYPd
22051	payment	2133	2133	1874	1	1	756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwBc4htGNTARMc1rRzpu7gCWAqgdwsib2WXPsFrJNTpZSiQLQ
22052	payment	2133	2133	1874	1	1	757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVYbqmAMFGW9qsHhiamqtBGPgfbHbR5bGqDBMSj1EN8xwJpQS
22053	payment	2132	2132	1874	1	1	209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1aJW2VGtdT3tCeFooj28BP7zbSvXr1tXUTPBW1dsYJZCJxKXs
22067	payment	1397	1397	1678	1	1	9610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvdteeDvsun85SzS31fAV9qw6LA376or9UsqUBs2wi4GiVCHB
22068	payment	2134	2134	1874	1	1	747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY2KueW259mqEBtr3sPhzq3j1kVxW2yWNUGoZQFpnRNhrSwED
22069	payment	2133	2133	1874	1	1	762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAy2eYCN2EKWu77rPHiV1zxgtCaxMQXjb1gFt2LEMavQT3wYEa
22073	payment	1397	1397	1678	1	1	9612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8SiymT5pzRZke4w7jR9iAtUUdCbXjCYgNDDMKE9pQrtUS8J4k
22074	payment	1397	1397	1678	1	1	9613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8c6guMCs6oEny9GsQD3bcTSjPokyiN7VU4aP5VCWR2JAuUrmw
22075	payment	2134	2134	1874	1	1	749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVAba5K6BPnSjiQb5EN1yfPLiUodNWhVyVkpa2QW9PpCUtKoo
22076	payment	2134	2134	1874	1	1	750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnqAcQkNZifF1KoNACS8fa6MzNdNRqqf2R7Zs4XHsnDb98xPq
22077	payment	2133	2133	1874	1	1	764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6Fhz1geEhSCZifN1VnvDjNBdxfWpcxxFP53VnV7nohNY2s8Q
22078	payment	2133	2133	1874	1	1	765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJJwPYDYuhHyT1jDRSUeYPJG62f7SMQw6NvdqZYteAtKwf5zQ
22079	payment	2132	2132	1874	1	1	211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmfjLNZLJ7X9dAu43KLLrPj4oxiJ1ymGzwFUvt5NqhF9Ce4rwV
22080	payment	1397	1397	1678	1	1	9614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4k7YqBBDhiNKQdw5yGQRWLSAUvP5xuXWnWPr52QFufFxc7ev4
22081	payment	2134	2134	1874	1	1	751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cJdHhfntrf5rVto4Edg4c8fMcQL4pV6BAmxVxUHX6685nRoE
22082	payment	2133	2133	1874	1	1	766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxCgDvcDAkS7EKWTHmaDKpngNR71b6QSLBthdMgbdh48J35oM
22087	payment	1397	1397	1678	1	1	9616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDneF5LrTJTqG9shwu97Tobzy7pNxRFc7GTk3wgpohTMWDJpcg
22088	payment	1397	1397	1678	1	1	9617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5iV6ccMXbyaS8VrjAJjcU6jBPJH1JUFyWytFEyfCQVkuNM1P
22089	payment	2133	2133	1874	1	1	768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6bwxGsHEa5Q8mVJPGzrKZ17DykTnEkkagGZsYBVr3LsFgcUH
22090	payment	2134	2134	1874	1	1	753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiYpDmKzT87kXRLWYFt8gxWsDcNKJv5T5K7vSf4bTxhhDhq41
22091	payment	2134	2134	1874	1	1	754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p4uuZKzTEERjn8NhwKPsEAVjrmi4T4Z57arDyu4ktAoJnbQv
22134	payment	1397	1397	1678	1	1	9630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjc892S8tXrn2z2gAGbWzctcGtSNsdS3XUNnqRriR3HTq6hv4
22135	payment	2134	2134	1874	1	1	766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebo93xrTDJwEXxP7KM8AL4pi25b8kQuRA4YnjgR1i8Xrv9rwT
22136	payment	2133	2133	1874	1	1	779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MhzKGPacd4hh79Nh3yNuDfZDggJKrF4QAHyvM3c7qDYitbNd
22140	payment	2132	2132	1874	1	1	217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLcCVQiZA9nJXSQrhX5Qx7Z6Ub64CTvhBgzCsqATSEQsw8y7w
22141	payment	2133	2133	1874	1	1	781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe858sp8BjhHvjmyQoCP8aCdSA8JK32Si6JGS5JmsR4ZAPBWWt
22142	payment	2134	2134	1874	1	1	768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoMtqtKXQ2jo4DSmfzFSYeaoQebMDZ6Go6SjSVHoj9uT7Ydca
22151	payment	1397	1397	1678	1	1	9635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrbvRrFTxxBJaJvrBozYE4DatScsgVB4xXFttdwTi9DEGwQES
22152	payment	2133	2133	1874	1	1	785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSMjyzQt1nF6MD4E1GWGtjZNroMm39r2EvdYa52rhE2vYgqZc
22153	payment	2132	2132	1874	1	1	218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGFFYk3onUQrmYoQNS25UpMd34T51tWF1u83LU6nvZbBmTANP
22154	payment	2134	2134	1874	1	1	771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYfNxw3vAWRcVc2Uvb1xFEC9PE9gguPGNphguwyPRwiWqvheG
22181	payment	1397	1397	1678	1	1	9644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD12mDz1s5VrrW7fePm8AnXdZCctNgL75A6YPE4C5zLGekx2Q
22182	payment	1397	1397	1678	1	1	9645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcdNiD4u5V3pymTr7VTThkbhzh2gxcKzZhVgfM5iCpnvPMJG5
22183	payment	2132	2132	1874	1	1	221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF4cowWtCsn8oYyHyu4LCkGJLaK1AeH2BhaESyZ1cChU4Jeqo
22184	payment	2134	2134	1874	1	1	780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ieXYvYTXPokcPC4GCnTUb9y837zRWmM16ARFG6b2iF5W2FM1
22185	payment	2134	2134	1874	1	1	781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufHCLkBuinDqi9gcdpvvgBEtTxRXtwmm4o9V2SKMd6XSEa21w
22186	payment	2133	2133	1874	1	1	794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2XytG2vb24mMNjb314qSNAVGTDdYNFsa3CS64cigF1WqUbDM
22096	payment	2132	2132	1874	1	1	213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZSziYf9hd31JnVcuzyUNtNfcXkHUxmhXeaydU8NBZjbjjUif
22097	payment	1397	1397	1678	1	1	9620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPgPfnyDzaHD74CKxSkLaroPYqFFzZKKzK2tGnuMbZ2DJ8kWC
22098	payment	2133	2133	1874	1	1	770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6i5vkbWWpjgtZ867f8Wf4H5gdn7KGudiSdd7zbCZjmLRSe55M
22099	payment	2134	2134	1874	1	1	756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZjs5tKNroVBYbfCCSaKukmRi8nvXDQ6bwz9zwky9wMFyGEZC
22137	payment	1397	1397	1678	1	1	9631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNV1wUuzr4qjzhGNTTUcFHBcxfn6pLQD9mdkLW52oefppTaAi
22138	payment	2133	2133	1874	1	1	780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySGNtENwbjRPTiKDUvJTGSabBu8qhQ64gitiPpMJws383ZmLe
22139	payment	2134	2134	1874	1	1	767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECrxQEoeYC79irkBEiEkknjaXAxBt28Jt4bRgkJHtiEbuZ864
22143	payment	1397	1397	1678	1	1	9632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BhWF4qqmkSZgrVvsozVa7sTrHUd3ebrvBozJhCneFJYgkV7d
22144	payment	2133	2133	1874	1	1	782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3J6tnitFs5czLDijXDaeHJBVgQ81SgBJHYm2sGRQk6mYYWLeF
22145	payment	2134	2134	1874	1	1	769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeaw5RKHXgGZvLSYiVA8A7jyGNmacWQssiTtGDdHFvqYVu91mK
22228	payment	1397	1397	1678	1	1	9657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xDbgG9ReD3X4ApkrBEfcP6y1Cfu2yrodqF6on8LztconHjtR
22229	payment	2133	2133	1874	1	1	805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JMZTs5RnTRGU4iofQJYbrDYzmcaZTza2b7yK3XUYkJdta6Yw
22230	payment	2134	2134	1874	1	1	793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhPN98ubLjTJYLnx91yiGrUcZ7LTEV87nMcHLHAPMUSbm68uA
22238	payment	1397	1397	1678	1	1	9660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JPNZ7kCLcT2RFecHZnAeANCK4keJNUYzamtBCh8rFq2stZaX
22239	payment	2133	2133	1874	1	1	808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJjbmNP4Cec9hGvkN71ChMHomy3csAoxNQ23RM9j2oHTWhqyT
22240	payment	2134	2134	1874	1	1	796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmuRSf8g8zekFNenWjimoR5LFTBDQtXPhi6HjJPHaU9rgwNNo
22241	payment	1397	1397	1678	1	1	9661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMuGvHkWzJYYbeSGuvenFNxxiJQRkRqtjNba9mYDKFgf4RLptL
22242	payment	2134	2134	1874	1	1	797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyDhhh6e8vX7mCLweKLvMUi9DeCPzBq6LixmYvVcjcujPNVfC
22268	payment	1397	1397	1678	1	1	9670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWDQwWQqxiYjNRNKGqHwzyd2bSAMNvr3BkQH32Jkx7yZMUfgQ
22269	payment	2134	2134	1874	1	1	806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRdgQgLUkqXuHabJ8VqK2tK8ryAkT7UcMbvNKsC1Cx3D4QESE
22270	payment	2133	2133	1874	1	1	815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfroFm1c36gMFrTFEXEsHnRHrPcsanten96soKcRHDXH4GeBP
22271	payment	1397	1397	1678	1	1	9671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcis1BMMEXZbQhx9Cynp9SEivyL1DGC3NMi1z1j6WTZjR4vbS
22272	payment	2133	2133	1874	1	1	816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXHJvYvHBRsn3EzuT7PFdGdHySYGsExiuCXL7HLMxNGiubp1M
22280	payment	1397	1397	1678	1	1	9674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgrFrdV9LruG9pnWcKQWpyPgfGz7RZFEuJjWa9BZz6oyuEhfu
22281	payment	2133	2133	1874	1	1	818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPbKmoL4tP4SikkSAf3bNdGcCYWjf2png9QFEzS5dCJmhwCPJ
22282	payment	2134	2134	1874	1	1	810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YP7dbqc9MYv4QZzsPWGBaMNwoENwJcR7aJBdiaFAt7aoRqvX
22283	payment	1397	1397	1678	1	1	9675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7adcar6szPgipG5aZa6TKSrnTM3Mn5JVkF93tXJn84RbAq6u
22284	payment	2133	2133	1874	1	1	819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnabUHKrsK4euVQJLmKGtN9wwk24jf9rwP7qjCDYiDxKD6A3x8
22285	payment	2134	2134	1874	1	1	811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkQ4ra3WuERnsuLgu8kZgzRiXVnJDf2jU1rQVcYhZofqBDgWp
22286	payment	2132	2132	1874	1	1	230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4WDxCnyC5RQwFyHHJikAXwfQK5JgsvXzaiBx4BFu1yQvToE7
22292	payment	1397	1397	1678	1	1	9678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLztR97qcpbAwfQo2LQByFdzmXeRNmfFJRWqVWK5BCiLX6e7n
22293	payment	1397	1397	1678	1	1	9679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvKDbgb9QVkCizsqQe24VCFrBX2mjqPsSkVzziM54nQkpxSBj
22294	payment	2134	2134	1874	1	1	814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSE2a84PBCii72GJ6zE7BzNxjgGeD7czLm5ApT5tJ1JBeXkG2
22295	payment	2133	2133	1874	1	1	821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWXkUfiGzz6Ud6bxfLgVZU16rnDNRQHJQZAMit1heU6Nv5Pii
22296	payment	2132	2132	1874	1	1	231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwtxd8NUa2c5SycdjSNhMXsJJhQdba64c83aj4JAuoDqynTdq
22297	payment	2134	2134	1874	1	1	815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69qhBY2Bi1qCUc7vgqbm7NDcX9qQhW7UXb13FLpyN13Ua91e8
22298	payment	2133	2133	1874	1	1	822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKerpmH8JehF6PPPpUsoKGb8NYULZ76NuNLWhVZXojQz7Pc61m
22305	payment	1397	1397	1678	1	1	9682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSZeEXYjcL9tuZGbM3KXEsj7qdpqTwM5MYVf15jbDHq7x5QZr
22107	payment	2134	2134	1874	1	1	758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyK1GjeXnnzvBW2U58ciAQePc9CkmBTg3QS1J778QkdEHoPhFP
22108	payment	2132	2132	1874	1	1	214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j9spPcP7xgvaJZRYbvkXvPA3fW4WXCKtMCCPa5CKxEHYhrdZ
22131	payment	1397	1397	1678	1	1	9629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhivUnZTZZowRYMxA7pcWgCVb4iVqW8QEKVRggoiWAb6ySHE7
22132	payment	2134	2134	1874	1	1	765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvMBkdBmrkGsYFGjUns9kVprMQQqbKmLYZg4JTsqNFAXiRFC6
22133	payment	2132	2132	1874	1	1	216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYxMuNn4yL7GCBiLy8HFcRauDfuXD72hbRbL4yovxzNbULHmY
22149	payment	1397	1397	1678	1	1	9634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgVDTVXpcjMiGEGiq5ZYAjaXpNyeqZbo562MHMfi7YM7ZBCsY
22150	payment	2133	2133	1874	1	1	784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tcf1xoBdoovaSA26xDr4PVwQ8BSASmGNtffkEnjEaNRUbUUT
22158	payment	1397	1397	1678	1	1	9637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZ3RVmyYYtU3LAQomnDxydkqZaWHCdPqtusos65ocbm5RzSS1
22159	payment	1397	1397	1678	1	1	9638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32MWB8Q6Z99YtWtwdFbqMWm241FbJZvXHWrh7qYaRVbQeaQCM
22160	payment	2134	2134	1874	1	1	773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHxRJHX7YfaQstcANnhUNRhSjfTRXi1spXzT9p46DiNXzitDC
22161	payment	2133	2133	1874	1	1	787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsce96TUoMoeECYT5gG4iWj8HdYAbFCNHfREpDPXhpRwSwX8no
22162	payment	2133	2133	1874	1	1	788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZrYAoRMhPEbvn8u8RBsDSSGzX9XLPNiC9sywVK4hxSmU1gVD
22163	payment	2134	2134	1874	1	1	774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTEnnHGZVd45rhqZyaXtHEhMQHyPP8616pKgQj3D5FpZpfShr
22164	payment	2132	2132	1874	1	1	219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BMQqNW9F6hhzrKijXWKKU9y6bmDq9SPciqaYWMiF24gFH3VV
22194	payment	1397	1397	1678	1	1	9648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCXdqRXHCYzaT4N3fMrACNX6XDgZNCU2e7SEap3hYsJhkCFuH
22195	payment	1397	1397	1678	1	1	9649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXy1YiDaLXMxkLinkePQr4p3v2actdeT3kUTCaAdBpiV2x1EtF
22196	payment	2133	2133	1874	1	1	798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbc2hiagSVsn9V7FQ1WJUvQBCj1DiGCz672okxekYDzPfv15n
22197	payment	2132	2132	1874	1	1	222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75EMzv7vaGDEMxcZmVdGAsDC7mgnbeQXiSXrcDg43HKF16bUN
22198	payment	2134	2134	1874	1	1	784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfdfFmMxV6pUiZ7PHgzbo8YYoujdQ3t8CAauH2BK2SjsBaVod
22199	payment	2134	2134	1874	1	1	785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKj267ijsKEJ91RSUcQAtLk81jvLpTtgtBdo8A5uN4j9HLTL2G
22200	payment	2133	2133	1874	1	1	799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxmQHrkBGVLp78u9gsU8SGdvHRTpQU2HGfj7e84PW3c5b6BKT
22243	payment	1397	1397	1678	1	1	9662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSzyxwgPEzPMMXX2fk7rGAzpqjtusASd3N9LQdb7KR6JrQQw4
22244	payment	2133	2133	1874	1	1	809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaKrbzYBwULCvXw15BMGwFpavXX1CoTDEB4vxQhqzikZzRd2Z
22245	payment	2132	2132	1874	1	1	226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDouCp1ZfhDxcFN618w1Vgm9VfGWbac1xwt8QX5KNARFUo5664
22261	payment	1397	1397	1678	1	1	9668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvusdhgzZtZs1PojsWXBzwnzre679EKvjWGrtcNKmuECAUZfi
22262	payment	2132	2132	1874	1	1	228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8g6V8p6RNZTRz62StVX3TiMNE4TaRn5jUcTAZyNRNsggV2ztV
22263	payment	2133	2133	1874	1	1	814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZvBa2RMbjLmXw1JdiWcH8m1yT9XGPtJzm2DbYD4mvvwxgpLb
22264	payment	2134	2134	1874	1	1	803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XzaUYhUDsBbTXdGEDQ2eqbDYhoTPyYaKHbVrQcW3DMbnfQ5W
22265	payment	2134	2134	1874	1	1	804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzdNbmHZNEuBMgMvkBT4YpyvU68JZ3bNqVFmbaxeRan2ZkMb7
22277	payment	1397	1397	1678	1	1	9673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvXXzbJQDCN4f78AhYyFo6FT4CVy34FQqW441D8n85BA2BWNx
22278	payment	2134	2134	1874	1	1	809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKZqWbjPjWESftT7evipa7t7Xcrs9Dtg9d2paYgJ24kNPzN9B
22279	payment	2133	2133	1874	1	1	817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9TyGsQUMFMr6Ezo6EpG8ThER6ArzyzJGGETxkCPaWZDphHpB
22289	payment	1397	1397	1678	1	1	9677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhgbyiUjdHAbnjrDRSDxshtzsubNrZn67ncRvZa8BdGM3AcTs
22290	payment	2133	2133	1874	1	1	820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFDEKrY91f72rV2pnT3w2rvFyRZV1AEZ1TCaztsmS9xjnQoKV
22291	payment	2134	2134	1874	1	1	813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUdo5stHYz38YsdbKSvyzGZ5At9DWRajJGxKfHNPWk1W9wsEC
22312	payment	1397	1397	1678	1	1	9684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbAS1gGYTEBf3NWPTZ64UPc3edpK69ySfcS5Xpj3T4qxVoXxF
22313	payment	2134	2134	1874	1	1	820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3e43iuRwXLJwBegAQdn3dv7E2WGLi6xh2MohUdTr7eGNpBKR
22314	payment	2133	2133	1874	1	1	827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7S9VKCddqjWe4JNwMXekmq4VYRsn2DHzA4b3NbWYbXTrDNM4
22124	payment	2133	2133	1874	1	1	775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PDpKz6Fs4GYmr3ywWByAif3xDjaizGwdBiNBErMUpQLohXDT
22125	payment	2133	2133	1874	1	1	776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYqw9B4nAXCJ12w6PJiikeGagFhGUNZE9aq7M79y7cpN8GGMJ
22126	payment	2133	2133	1874	1	1	777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4AXEbf23m7fFGRzAX5TkZRsLN7i5fCTAzMVSdspDKd8K2civ
22127	payment	1397	1397	1678	1	1	9628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocxjkDGKd5EW3Z5hzSUQdh1NMNQNsL7nyjrBE3BHDv1LFBWKs
22128	payment	1654	1654	974	1	1	6	1000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	Ckpa3cqqhbXh1V3Cd3E2e83z5X27TSg55SqbKc9qfApm8syYMUoD6
22129	payment	2134	2134	1874	1	1	764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi95o7LWdvYiCTU7oPkmFntd9g7QZ4rNN9Ftf6CxsT3QancrWz
22130	payment	2133	2133	1874	1	1	778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3F2Kbt6EnR736QcTsG2EmdU7kZ34E9PrxJCybs9isfbhx4RC4
22146	payment	1397	1397	1678	1	1	9633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQKkFdqbWtScWigqjfK25EeqhRxKUfSp1hdC33Qj7zbXCeY6d
22147	payment	2134	2134	1874	1	1	770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYAoTYuBhDxyoe5DxPZG8xBY19d7oQYPpVmxYgNeUpb2ZM1Er
22148	payment	2133	2133	1874	1	1	783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5YhX2DwJkSyH6RGPmeqiRAGivrzGWCbMDCApLERLXWS76jTo
22155	payment	1397	1397	1678	1	1	9636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzqxcCbR3qgfdjCbwqTiBbu51MWevEnRJKnVZKEZ95SsH1Yon
22156	payment	2133	2133	1874	1	1	786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmDaWWZtHz4geL4BjzGbxFCFns6aQvsThFw4yUrvNwwycZsip
22157	payment	2134	2134	1874	1	1	772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bDeT1Uzr6xiDDCAmvxrsKUttsfVqbxTytWAvpDZXZK1kwuu4
22165	payment	1397	1397	1678	1	1	9639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3YJRRxqU65iVDCL9arkZpM6Vyq9rmP1x1Z1wVVQemop8vQte
22166	payment	1397	1397	1678	1	1	9640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQbmhVMU4UCzb4yWxVQdcCbh1pbfGMugXuhkon4N7iMjGiRpi
22167	payment	1397	1397	1678	1	1	9641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFXa7w5tYzoFVmsQsouQciHN9AtXC3a9anH52ss2vUscQLTE1w
22168	payment	1397	1397	1678	1	1	9642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU4DLXFqvQ7ToaUjZugpiwnuYna3jAg64mJsbXH9ZHXVCerp8
22169	payment	2134	2134	1874	1	1	775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ377crhxF9StDYG3CV5u4V1CAQt1bz4V1uqViqfroSAD2w1kr
22170	payment	2134	2134	1874	1	1	776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrzxEcUZjuEZH34U8fBFSdt7xr8Ty53eBQZcwgwBcUrYH2W8m
22171	payment	2133	2133	1874	1	1	789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinRUhwXn6dBgyHB3r1KJF8MaQmHrbuPzqkzxF58g5b1Fm4UtG
22172	payment	2133	2133	1874	1	1	790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdHQM8TZ1wJ8ggX2kGaWiMVa6QwYLS4ZW6XnWGKAgi4tkHPSv
22173	payment	2133	2133	1874	1	1	791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJVrrhUC4dpHgTRsG9YPc73aLFfDp4yWA87GFZwYn4YpwcH3T
22174	payment	2133	2133	1874	1	1	792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBNbUE69eX9J8tR187o92fMdGSMavm5WbdSEZvJnBLWFPCKkZ
22175	payment	2132	2132	1874	1	1	220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgdsRA2jJy173k2HBbyWQJaL7Y9agxGs9orQMnHuzD6LYzBHy
22176	payment	2134	2134	1874	1	1	777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46unXNQVZoAynEZUFoaA7WD5nhmsbt8HLCzqHtzUFxwp5Fbzh
22177	payment	2134	2134	1874	1	1	778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dovGnaAfRS1Cvb6WsXz5XMwvypfsGsaAHaYW7fifA35BCRiW
22178	payment	1397	1397	1678	1	1	9643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sFieBYnPU7LQYtXycLcoixy5tqTutkNuZuqSYbVHLqDwKH3q
22179	payment	2133	2133	1874	1	1	793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2VmLgN21AwFNPtnbcB5WLGAFUKnTSNZA3PobBABcJhHQjNAu
22180	payment	2134	2134	1874	1	1	779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Pm3fxYrVQcAv9gi3Jdngg3n5kFmTA1vNwBhKgo5f1o17Shd1
22188	payment	1397	1397	1678	1	1	9646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGmEY6aonVnHRHDdt5G1CyQLbB86MX2ENNb3NpeDT9NZVzTer
22189	payment	2133	2133	1874	1	1	796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ175JxqBLQd65Vt12aYP1nfQEXqCXEw4Rta6YHZyjX63qv9HFx
22190	payment	2134	2134	1874	1	1	782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4snhcV6cjn47e7ScDY5WU8YsezWHpxA5cz8EA44BTSbgfvbjk
22191	payment	1397	1397	1678	1	1	9647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvt56KBQtxQQc7UvrKoGVn2XfDxPAaFUVzQqgpT9pigSb6jgJ
22192	payment	2133	2133	1874	1	1	797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJcwuuu6bY5DNfBafAos976xrh43Hr4tHFainzvDbtRHNFshx
22193	payment	2134	2134	1874	1	1	783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jeeTJ6DF3saEanq5memApBBgTKm1CLnK9C26XJehVVkPt2mg
22207	payment	1397	1397	1678	1	1	9652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfuomzktS84LN5iZe9oVviNogGBmJoyg6yg4sDJQVhE35j89J
22208	payment	2134	2134	1874	1	1	788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBRnXBUV64fk5apR7M8untCsjjrGfyn63AAywbSEdxcGG8CEB
22209	payment	2132	2132	1874	1	1	223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7ZRWQuLAE9f3A9rrNytqtiN5kxzibcwyMjAyP8TwERrFbecn
22187	payment	2133	2133	1874	1	1	795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgExzmDCShhBcv1AyBzwF571TeChwnMmmxtcQChSUrHVMtUoqb
22201	payment	1397	1397	1678	1	1	9650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1t6dMf3b5kBHpApvwnB4n8aFv9e9EVmxhnRGX3uFerSN3Arn
22202	payment	2134	2134	1874	1	1	786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuXwtenzRs7HcHMEWcXqra5G4kMRrAg5XsFKcpn7Ue7cHiEfN
22203	payment	2133	2133	1874	1	1	800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TaXGz2ZcvUUVHeMz9pUYkZtzK7YC7dniNGF2dWrUraduHr91
22204	payment	1397	1397	1678	1	1	9651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjR8VEgKXVQBj31PciYQaHfpmyFuVRofzA3uWddxudfgJvZ35E
22205	payment	2133	2133	1874	1	1	801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMmPUQQy6xhdxPTC4hUwLBKtPmeLDV8cGxVJXQCAfyREbC9Lx
22206	payment	2134	2134	1874	1	1	787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMyyFArYKfXfJq11VFQiRn33MV4WjbeFsKDVZxU56GFqHJ9oX
22213	payment	414	414	2156	1	1	0	719900000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9xiWrZD3cLmn843W8qoNuUe4VwfDpxL884sjEsp8JC2WFCgR
22214	payment	1397	1397	1678	1	1	9654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoFkTnZhhai393jqyeeyJVByWt4p6KGsd2S1XxEHsK1h5jptP
22215	payment	2133	2133	1874	1	1	803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTfzkYue6uu89aMM53YEJoYz7P7WAJENcxA9316BcZy4Cb9zH
22216	payment	2134	2134	1874	1	1	790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FxFutrzQHfsmmHCxf4xqumxfbXyHmf1NmBPhCoVnZMBSfqXt
22231	payment	1397	1397	1678	1	1	9658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKPCgvW91ULsB8NE1cHAXCFEz789AP86avxD9VGrLQs3Weckt
22232	payment	2133	2133	1874	1	1	806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsi2Ds98Z9u6YNB7uk4gYNeGYmYVZW5n41EH7hzg5UnmBuzEh
22233	payment	2134	2134	1874	1	1	794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgkjyzBqhs8HjHRfDJJSd41v6SW4V44ce5ZMNiSV6m8ViA3TM
22234	payment	2132	2132	1874	1	1	225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpfAoTiXvcFSPWWp8xg7EwCzpRsUQ7DvxtZShFVimrLkcUGyX
22235	payment	1397	1397	1678	1	1	9659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRcS3kx1csKksTbHMGUVcn6rq7C1toJ4fVqgZfRzH7EvZXyGY
22236	payment	2134	2134	1874	1	1	795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnWLzSAFQPZcgx5WzqheHsUxC4wdLKKL1uT5nrDzc2yVhTAvt
22237	payment	2133	2133	1874	1	1	807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmXU7t4Qbki9qd1uFMprXK8hq3PQSSGnrJxWF2Uvt4Ma2Kxat
22266	payment	1397	1397	1678	1	1	9669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJeneoJHqAenqLWEDsoxuSHF5sPy29smm8Ev7akKRhEdJFQe8
22267	payment	2134	2134	1874	1	1	805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwipJotPfg7t5GjetimSvCrpVYobiGJg1BYqCtHNaaAqzvCr8c
22273	payment	1397	1397	1678	1	1	9672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaCg4dm52fayDWLNCPi2XenmiHx4rHJp6nyhUWLooGAVGz1F7
22274	payment	2134	2134	1874	1	1	807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFoMQP3YJactzbAi5XeTAPaae7Uw1GKEJvYLnNuZVbiFGNsPs
22275	payment	2132	2132	1874	1	1	229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJiHpm873tLoLkL2wPMpi1J77He512EaynudX5MD8YQMGezYr
22276	payment	2134	2134	1874	1	1	808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJET8AMZZWeaoZGzMJ7Yge4gcsM5eKj5YHLbcBmYzAAzVdFkHu
22287	payment	1397	1397	1678	1	1	9676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4M4jtkKe4fFbtVtMLaxnwzsD6Vagkmi3FsKkiSbRFo3TNn9Zh
22288	payment	2134	2134	1874	1	1	812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4K5JUC5H6AqKhKzp5ACMARvbAenSMzBnRAsy7BLSzpfR9NEin
22299	payment	1397	1397	1678	1	1	9680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWiwJNzkmgfWMymo9cWNrrvPZxyDpg3PieiwViG5fcNctq9kW
22300	payment	2134	2134	1874	1	1	816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Lz6HRswRFy3PR1GzCVee9LJsffHuATy7rydx3gytbDG5Shux
22301	payment	2133	2133	1874	1	1	823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9ZD6fh6Q8FKHuKBqKS75cXkVFWNLAK3cptfeskXdgj65nHFN
22302	payment	1397	1397	1678	1	1	9681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1decMTAgxjy64go2Hc5UJkRvXwAxksrqh9oyb1xH9ieGqgBAA
22303	payment	2133	2133	1874	1	1	824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrZRLzoCRCFbcLYQ6Z49XZAXRDTunubQ2bhTvmyZcBXht5QHw
22304	payment	2134	2134	1874	1	1	817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW9VTV84xdpjJu2PmwhMrEMP24vn3kUKnkRN9EdgmfxeqoejP
22357	payment	1397	1397	1678	1	1	9698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCr3TJ49G3qXzFPkSeSrv1rHJ8mNgb6pAyk3TjqsxoGhCUcLx
22358	payment	2132	2132	1874	1	1	237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TbTvywb25RdrinhwX7vwrqS4CjqMm1AYkTS3KVTPGYwznLTW
22359	payment	2134	2134	1874	1	1	833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnn4qpi2NPUeKwt3e5GzV9tTWhkCoUgcENmr4h9UzGfGuuGzhL
22360	payment	2133	2133	1874	1	1	841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHagq7TRYsVuJ8CKabtuDmoaVZkfJFaSkLSsnb7yic7TRFpPeK
22372	payment	1397	1397	1678	1	1	9702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPcKtZNB2SqAByoy6ZAb3JF5EosMFaGurh7jAGxosJDkzX4JZ
22373	payment	2134	2134	1874	1	1	838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWzT6xe8wGYzcm3ar9S3LCwRFrZAfFKkn6okbPyhFpCzuPw9e
22210	payment	1397	1397	1678	1	1	9653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrBwy5SRQWfLtqQ1VPCVibkuhgCVjZQ3pFyNbLMMj2imEqVvW
22211	payment	2133	2133	1874	1	1	802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5QnF6VUFnqP5HDr4AwYLzPdzDbRMeDMWVSkPd88hNsHCpVa2
22212	payment	2134	2134	1874	1	1	789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnt9uc8St1ZXARAUHfy4xzDQ8TCduyqEgYK2eJnmmy6zEEz2pS
22217	delegation	2156	2156	414	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdgpGFpVmTTNNY2213w9DNa5ZVphJiAeizyWUDrDKDTpqVhiF
22218	payment	1397	1397	1678	1	1	9655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHS3i7VhVGvy2t5gQZp1osRQqQPSaX2d8hn5xzzc26ZAgvE1f
22219	payment	1397	1397	1678	1	1	9656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzukvwfzydWfJwerS8pWa3qfArq3NrBtBbpLzZYDjLE7xJiWiQ
22220	payment	1643	1643	1299	1	1	13	807388252600	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWzswPf7zp1oXXHxmRGHDNu55cAPHS7Y3HJX7yhi5m9hYhNbC
22221	payment	1643	1643	1053	1	1	14	429891807800	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAt5vuvdvSNkoxtnVzGVi2L9EFC8VmuS25ubKqrLSrozPQFtiM
22222	payment	1643	1643	1173	1	1	15	290381849000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1Tna3B6wHRnEaFQBxji5oqSH7a2VE5LhqdKctaSbBHU63ea9
22223	payment	1643	1643	933	1	1	16	240338090600	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiNamUBeDyL1Chy5GcWqJQLVPfb5YgakTBCqaJsz1PPiMeFgG
22224	payment	2133	2133	1874	1	1	804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3MPmQxkGSv5NrtVR2yyd7P2UVkSVc7DiwY51cH77vxnXDbEy
22225	payment	2132	2132	1874	1	1	224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziJceRHw8grD5NMsNDHaTP1omudQtyxhU9BEDEDqKnnE3Q2xK
22226	payment	2134	2134	1874	1	1	791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RuiiwiLMTK1zXDcLBSmS7mibUTgUjdMyeobx1BqvXRs4JaFu
22227	payment	2134	2134	1874	1	1	792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCF2dUmCRwtx51wfCN1ze1F6YdM7ygiuNGyLiaztE5bYkZB54k
22246	payment	1397	1397	1678	1	1	9663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtgyMQeUZiaE3CsBr8yH8ZCmWRProxBYXBdghT4DYmFup6f7j
22247	payment	1397	1397	1678	1	1	9664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC1aSLTuNycNJKE41WxdNXhho86XTQHtN8cwqpU4xYvp95Pka
22248	payment	1397	1397	1678	1	1	9665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqTaVrwptZE47Nqk3YAjGJtWdCu8MJSExWghq8wMFAsw4FYpJ
22249	payment	2132	2132	1874	1	1	227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHskXoRP5vvmUPRTDKabXRn1Zjz8HjAuSUnwHw8EwREquJjHu
22250	payment	2133	2133	1874	1	1	810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3T8Jxrqd5y3bmobnsYdC9jz5maZrFynoFLNcGDqBpoBpqWLo
22251	payment	2133	2133	1874	1	1	811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84sYnu28imHThwKFtxnfY1Xnd7x3ns1aqg5abgpQaSsZBJPXa
22252	payment	2133	2133	1874	1	1	812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrZ5DkGxjGK59JeJSW4q85iDY9Nb78qv1rDTjawr4ZZmqkM61
22253	payment	2134	2134	1874	1	1	798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tH19KEGLwkvCHsBS2GoBpaqpcbzxwfADRA65n9RdX6E9rJTH
22254	payment	2134	2134	1874	1	1	799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqej4qcuhqwKyrexqpdMCU8TdduUc8hC2UVBop8cLfyFbymwC
22255	payment	2134	2134	1874	1	1	800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPhm93f7ty66JXsU6CbDfRso5KrdeejDt7YEgeD7ZTayn4ZF
22256	payment	2134	2134	1874	1	1	801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7hy9GbaCtUoGggyf6K8A8793bfkRJ87dn9FPUic9Ug1JG16d
22257	payment	1397	1397	1678	1	1	9666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1TGQvQBtQ7ne9VbzaZuMwVct4pWqvYgnVD8ut6rSJdv3ejzJ
22258	payment	2134	2134	1874	1	1	802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeojQRJ2aKxkcmWziddP5thq6n9w7hvqi3YyfmAe6262x18zeK
22259	payment	1397	1397	1678	1	1	9667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdd1F4cutGtBVrrB5Kyd4xWUx8huHnWPTYZW4XGy37uJgeRS2
22260	payment	2133	2133	1874	1	1	813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiR5osEH5b9Qs8XpHaeeNnjP4YDkw3RtnnBGQgajMfwRz6xQL
22309	payment	1397	1397	1678	1	1	9683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nfS1v6MS7qPy35NmSPWkp8WZM4zm1ADzK5BCofZyEvTuWMdD
22310	payment	2133	2133	1874	1	1	826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCAxsdD6qd7u7YSq2TaXRGyTZVJ9YxQxUXyF9udWLEZ2sBZYy
22311	payment	2134	2134	1874	1	1	819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJifse1sRFuzRDSm6zYbDBaUasVZhRFm6ai39kM1Fo5LwiFRp
22329	payment	1397	1397	1678	1	1	9689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6av33wsbdrV1WvXhwakfjBv81h8eCtFecxfGRyYNicTFoUqd
22330	payment	1397	1397	1678	1	1	9690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76ZPDmLmCH8gCNJ2BaduSoX2s5BhXKNoS91wR6PzL2LRMNqHT
22331	payment	1397	1397	1678	1	1	9691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNDirym2sBWA4icLtXAHwf96XSCCdPQD6LZ3HjG4tHG9SmyKc
22332	payment	1397	1397	1678	1	1	9692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGbkNGkYeVVvdUM8s11UkPAVT3udGZUyBR6t2xMnwzAQUAz7v
22342	payment	1397	1397	1678	1	1	9693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn4TP2U5tzRm5BmUqHcxNE2Yn3xCaMt9KGCjdLdcVug5FpBrR
22343	payment	2133	2133	1874	1	1	836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nqwUud8EVvfavpdQHFhz15npfU9WVfNegzRM1H24vu7QeZCM
22306	payment	2134	2134	1874	1	1	818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePgM9gPYVr81WAi7LJFrLygovycsvL5uRujfJMaDPZV45xS2X
22307	payment	2132	2132	1874	1	1	232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQxm4ZXbYc31J7DYtFwpFotNUUZbuTxJDMDAQb7cgL6H6CiNe
22308	payment	2133	2133	1874	1	1	825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPd6FxbioXZ1V4H17NyquZbXVfUHq3LUFX6SCtxthWLuG1CcT
22325	payment	1397	1397	1678	1	1	9688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRJkUQb1TAb1ZfvbKKNLreYerKxvAFj8qivWccQ8HCZzXXuZ2
22326	payment	2132	2132	1874	1	1	234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz19emnTmeVyG3eceprUzpMffQ1YRcMiB3Nn8ca7uWj5sL96oG
22327	payment	2133	2133	1874	1	1	831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLungxGupavmo4QyVQ4vNuKrkrhhkJ6fJC6F8KYKKSWmeXguid
22328	payment	2134	2134	1874	1	1	824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3GneR38CUFYmwFkpHPTuHudJ5B4d3gzW1W9188Ni48wQjpa3
22348	payment	1397	1397	1678	1	1	9695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FhxuSFWr3uQUWXqiF2NSVZwjHLRdMTBirND1Ma5KuXGe3xp7
22349	payment	1397	1397	1678	1	1	9696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUjNCxvB19JX8igC7N871VfiuW1P8mHQBcFDnpj1KZK76jpSy
22350	payment	1397	1397	1678	1	1	9697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBots7LmyZA4GPswuyPg1ggce266BRUEyY1E9FMoQ5Tj99FJXw
22351	payment	2134	2134	1874	1	1	831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifaWqpTPxVB6fpGFW7hyNHyHTtSLUzjHRdV2boZe58EY18dDM
22352	payment	2133	2133	1874	1	1	838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBNsfTCcjjzjwQSe5jHajwn11dApuJJ6pQ1ywpZ8X3tp9nrgC
22353	payment	2133	2133	1874	1	1	839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQASGiHKJYuPUd5Gyz2hJHxXcPfXpvL3zZazSfEtVM7RCdm2hG
22354	payment	2132	2132	1874	1	1	236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGS5kxPZED1TwLtoSdTffQqcEaFg3zn6QLFwSpCi3L54Q3eEZ
22355	payment	2134	2134	1874	1	1	832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthDGBaK9XScSV2BWaJudiUWo9ncjmfLUedXuiwiXcGvGeQvTe
22356	payment	2133	2133	1874	1	1	840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aBSqFeRT9cSkpGyBCcoFF88XLmtUJtVRjviCvobFuMbmVU2w
22378	payment	1397	1397	1678	1	1	9704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFy4CpE5uWnQQh222h2dP7e2EfqeySb1v54TQYGoDUdD3esKsG
22379	payment	2132	2132	1874	1	1	239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1CXiTV9VidpEu4ecBCmWwkVLWQsHvBhiabfNeDN5VTvoXSkB
22380	payment	2133	2133	1874	1	1	847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtj229TazmSAdpaZmjiaK1hkjzw75DLkyRdjCphihqbvw9qTw
22381	payment	2134	2134	1874	1	1	840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKUABqudJnodGimhaH9bk8doX6jhMvo7aoQVQkNmLpQArpwrs
22391	payment	1397	1397	1678	1	1	9708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CRbhJvLpTq1mSZUXkkToeU6vdR4QUd7zQ7QsSicv4TDN6xz1
22392	payment	2132	2132	1874	1	1	240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZq6xSV65kEuib7Trkt9GeVXPFud4woWzRWvjhkxL2vNwuSSm6
22393	payment	2133	2133	1874	1	1	851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxkmFYV2EzKb3mUnAW14xMZTWyJs9wLYi62UFp2dFhFvTsivN
22394	payment	2134	2134	1874	1	1	844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63CtvgMr4SEahWqztyeggPfDDxkFyKi2ZWURMBjJ2J1Roo7AE
22402	payment	1397	1397	1678	1	1	9711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrG8XzHWJ4Bd4ePwpqfRYxSNZbn9d4Eww9anZQUtKozxrpUPbh
22403	payment	2132	2132	1874	1	1	241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7eqJGS86n8mdrS6jnmpeKanG9bSNRN3stMNANNTpUjG192pe
22404	payment	2134	2134	1874	1	1	847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSvk8ozivMSsTD5RHoDvStfAkVrETHMyxS487T2qk3YKoJa19
22411	payment	1397	1397	1678	1	1	9714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSgPFJKDnSQv7YfurHMTS6yx5uxJzi5awBw3ckQXgmvoDNtKM
22412	payment	1397	1397	1678	1	1	9715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGB7stdMYSPqDxYBwPZByJpdA8qxz4otdNf6jxwXZufcGqyK3
22413	payment	1397	1397	1678	1	1	9716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1JMgRoKeFMCre6VwgMHPevMUFyhU914Um1kkP78MaN1vBUPZ
22414	payment	2134	2134	1874	1	1	850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQuELd1A7G8j8TNxfcPSuziJVQF5GR9EpMwweFzmgFEkE7aooG
22415	payment	2132	2132	1874	1	1	242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbo2G4HgGwfFM3nX59Wb8wRFXH7ay2UUdPHJNp1YSNmXm4cjt
22416	payment	2133	2133	1874	1	1	856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSUBbqwL5yaxrjYZaqYTYeoGwRnnUWDYsFHHs6b7bbAiuzhn2
22417	payment	2133	2133	1874	1	1	857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZebqPMNyV8dnF4YocDUM2QrEnijyCutdJjfftyxzfDiQLvnqU
22418	payment	2133	2133	1874	1	1	858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eoeYmRpzyxrh5WhvZ6i4ZN4FgSDE7CpERDRYQ9NqmNLyHuvU
22419	payment	2134	2134	1874	1	1	851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VhYLJNFWYTo7Kbt7TexSMShB2VXYsbk1nJstyzpMrwo81ucW
22420	payment	2134	2134	1874	1	1	852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvqaqQBf8qfUrMktDma7CM4P5oCEi1jovZxDuYScMYqECkgAu
22428	payment	1397	1397	1678	1	1	9719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweCcmnAUf5HU68zr6jNhgN5myzLiois4FBatZv2p6uAxqjzFi
22315	payment	1397	1397	1678	1	1	9685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBVrLabqgxgPfhEZ1tCfrYc2gmtmMfqZH7D2Mi6anxgAoSp7G
22316	payment	1397	1397	1678	1	1	9686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcybvTGStXbhVF6WgjXh9B52ckZHwG5ZQYbDsJHQBUhjCEJJK1
22317	payment	2133	2133	1874	1	1	828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejMg2FyDDBzBA4E2chS42ssRH92uhx1f3Y9Ymj8Lng6X2LT6q
22318	payment	2133	2133	1874	1	1	829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwrWdDkFsG6Z2otfj2K91VzMBPbMJTrxvsWakQidi2QEtfHq3
22319	payment	2132	2132	1874	1	1	233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6LzwzHuHPdnpf4dtvmDJfi6Pu8dyaoMoUgeYNvsRfCwjvrZi
22320	payment	2134	2134	1874	1	1	821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89x7KSKTch7okk5daJnCemgg7ozfgLiahmvG73m7y5jwjMrvx
22321	payment	2134	2134	1874	1	1	822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQ6d484yYH2oY4hJKfVDEpKFkeVatqDBECAhpvXhd2S6axn3E
22322	payment	1397	1397	1678	1	1	9687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1Bof1ddPpWMtPmhV3AMeQBPV5qR6g88XhpCJNMN65beRphap
22323	payment	2133	2133	1874	1	1	830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTao85Eyh7hwfsGevveja3beas5EZZvfzQgNGP8FtEh3juricN
22324	payment	2134	2134	1874	1	1	823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkY9Lbpmw57hRJ31999FgaFkbqqj5AFyGhqRCmnr3XjetGaUAX
22333	payment	2133	2133	1874	1	1	832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwMmYqWcoST5L6Vi5YG6Kc8Azhd8Lu18oxL2wSr27rLvjFeHj
22334	payment	2132	2132	1874	1	1	235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptGjTyaPjrLPjxbeeR4ZGghTMMMNnshvdp5SVvqmVUnVSbVVy
22335	payment	2133	2133	1874	1	1	833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnu6h7Qe351NFKXfDc3zeL1qhFtVJyxMSeoVPdJBSp4QZvvhM
22336	payment	2133	2133	1874	1	1	834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYiW5HPwdMH4KMVyQrY6eHLHsef3dLbHj5k6xKVosZb76ubXM
22337	payment	2133	2133	1874	1	1	835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GDptmFSLw563GJvsgpRv7hq1bZtRVcqvp1CdYRN6dFk9wQTP
22338	payment	2134	2134	1874	1	1	825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf8YCbRFf3J1AP1j6LLXuJEcwjcKqZeL6CQJ79TWTFE3JnzVz
22339	payment	2134	2134	1874	1	1	826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UzXv9bp4Lb3UhTjwfpMntYKsQCXiGPt9Qb4dgXs1HDEHVPAN
22340	payment	2134	2134	1874	1	1	827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GQJFd7KRypnjputXubgwP77HWR7db29sVQ5sEuyLzKY4RnrZ
22341	payment	2134	2134	1874	1	1	828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28EYREXj9oXhp7zEh7fRi6nkUsSDQ4EvinKW3SX5Y4KKxYZ3k
22344	payment	1397	1397	1678	1	1	9694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBdmoFasChjxBRxbHQHpkANXg5Tjsk66LdRb4MG3HTdoJRg5n
22345	payment	2134	2134	1874	1	1	829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTx4jVMD9NPxZzDbQ67byyTcwADmPs21ZHP5nrXgPKPWf9ibi
22346	payment	2133	2133	1874	1	1	837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmLCLrqgKaUH4KXU1Q9jnTifST5KdRXihVkHcdePupuusi8St
22347	payment	2134	2134	1874	1	1	830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgegSBUH4E2uthmZED8fDS1EhGyfbcx1zyPhNjHEJoLPrudsxf
22361	payment	1397	1397	1678	1	1	9699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWh1T51TbEPoLX21UAYc3HWk6fnUV6vmftwRZEdHjoE8XA4Tku
22362	payment	1397	1397	1678	1	1	9700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4pKEqLVovnRinyJazH9bY76cDmRY2aaHyShq1qSztZFzbLK2
22363	payment	1397	1397	1678	1	1	9701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8L3BPE3AX6VacjpciTzCLrL6LDzBBKrqiuxch8BJARKuAXTH
22364	payment	2133	2133	1874	1	1	842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcE6rSnmqgZgYFGhzcZUTB6LSaJDnrEkfCf1FiqRK7kNAz38ed
22365	payment	2133	2133	1874	1	1	843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32gYYpcbJRLvos6V2sgRE1rw6gqZ2dGVkDLdQQ12Sh9iaqhhn
22366	payment	2134	2134	1874	1	1	834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZ9p2wUMqJcDHVmUFHbzQH5UKXtoT7VBt2nLjLS1PVkbpWki5
22367	payment	2134	2134	1874	1	1	835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrraojBUovp6Z5wsZvuaUY2QRjJ2JjRxGBmF7iua6eY5kVgd34
22368	payment	2132	2132	1874	1	1	238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtfrS38SC8guWBkTTMcm2keBaUcjCBG3SgokZ1YEZAnYZ41Je
22369	payment	2134	2134	1874	1	1	836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxTjo5L4HkU6SEAE85NHQfuPz2yqxKa89oAXV9RZGGCSpGufM
22370	payment	2133	2133	1874	1	1	844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hqLcYqMUe9HuU2BQU9V9CPzUzuVm6oSyPVTbBGoetB8sKLQj
22371	payment	2134	2134	1874	1	1	837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NRaTEGbPtSbwQbEY4EynDNdBnd6evnxExQrSrUrqaWAkggpL
22382	payment	1397	1397	1678	1	1	9705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnK6QLoFaXGknPmhnJks4SiNQxQUjyeA1QtCJsiPB35cf8oon
22383	payment	2133	2133	1874	1	1	848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZao2LosahipcS5YPQdsV2eYMBS6LZFToEFNDJ9NdcRoKbQCBsa
22384	payment	2134	2134	1874	1	1	841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ryEYAe3DcV2CBPr2nWX4A2Mo7EyiG3TxoabAfC4ordjfQiod
22385	payment	1397	1397	1678	1	1	9706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDELuW9q1TmsuUevQsPoL6QmLdABAdmRQcCixrhKNoRpaV5CRx
22374	payment	2133	2133	1874	1	1	845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NJUjWFaBWiunDJY75Whpv63MqNXyRLXkVaMRpjyv3M7zJdUL
22395	payment	1397	1397	1678	1	1	9709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyfRhdXQhAw7N6ACkGhPDodEY8DfkFsMWW1UNZDgZnzVWeERx
22396	payment	1397	1397	1678	1	1	9710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEx1ermTbKV7q4R5jxxrERmph9aZZwKKH2HwFdPBaMJqCPvAk
22397	payment	238	238	1474	1	1	3	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp5MCE6nc4aP7LVnULuysczgoKMXhyVfh83pvPZwSWRShPsqi
22398	payment	2134	2134	1874	1	1	845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcBGEowJY6ca4oyJYJ1PGfN1KyQozAJgm2DQ6XhsBXREAQ8pV
22399	payment	2134	2134	1874	1	1	846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSqYo3smAhPrL7JxoieJVvcpDQXuvg9LprhP9U33ooTrrftdH
22400	payment	2133	2133	1874	1	1	852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JN5wHoguJbPtmXUomvhsP8HVkFNHnhp6GkXeb7mutcsj8b4x
22401	payment	2133	2133	1874	1	1	853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVGFJrrbQzaxdVGuodPT1HZjW7Gy6Vhx5DBBpHpDbFvHovUJ2
22408	payment	1397	1397	1678	1	1	9713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuq8mPeV2pqtjN6j965Vmy5QtuQnNGfcNCoGWmEaoRN822Zd3
22409	payment	2133	2133	1874	1	1	855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcDRpYRGGfeUZf52An9BYv5vGyjr3aW9LPTSL8D5pKAZL64F3
22410	payment	2134	2134	1874	1	1	849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YJ7yKHURJadUbSoaDnPQDQhgX6uhZtokeyNshHcu9aW5Svwz
22421	payment	1397	1397	1678	1	1	9717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xDav53ixDuXB3vTkkGYpmf3R35mP4z4s2Aoq7Q3SrBWDC8pt
22422	payment	1397	1397	1678	1	1	9718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGp1n4JVCzGbmqB29U512HtULNwz3SiV8FYj9VB58veRfVX2k
22423	payment	2132	2132	1874	1	1	243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaVR25XZu7YTttozTwa9SgZcMzpyFE1B7QCyxWAW1QnzXWzah
22424	payment	2134	2134	1874	1	1	853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzzX53ob3ddivB1ACJA1ikHPHQnV4BDF5iPiAqCXGCK3VBuFr
22425	payment	2133	2133	1874	1	1	859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMmyu4NLoBrHnZnGJvCX1Htw8tbZJDXUdWvUtt9QYFFXA18cu
22426	payment	2133	2133	1874	1	1	860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7Y1bfbkQMTLwRNhsWf7c8fLRQps5aAuSA6MhcMAHhxNJdDfv
22427	payment	2134	2134	1874	1	1	854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmKjf8kDHf8UWAiSbQLdf28v9NMeeJVjWA2rKGprVp4WFgxs1
22434	payment	1397	1397	1678	1	1	9721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1W4NMQJSwkW4LaoysH6sgCSkPiRqFasq5TRZnUmSnBcHjH2LU
22435	payment	2133	2133	1874	1	1	863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVs4E8keidU8dCj9e8MF75EdkmPHoK8G2qVDP4uZ2Ch4cVWN89
22436	payment	2134	2134	1874	1	1	857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyj3DDh1qVzH4UBGYg9pjAjVZ7ASKidTreuTgG8YG5LaauAdUB
22437	payment	2132	2132	1874	1	1	244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSthaJCTEsEx7AbWt77FVRDJUjYfJcFoReDXuhkchAwdqnguH
22475	payment	1397	1397	1678	1	1	9733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1jkwYaivsmXUPHQK3F3xaSAC6t4mheLcYBBJncJpihQn6Nrd
22476	payment	2133	2133	1874	1	1	874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKBwFaMVd22G2ELCfoktGvRvCmYhKFyMuaiTLFjAJpALJvN8h
22477	payment	2134	2134	1874	1	1	870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGSscqJfmN9m6n8Jcr7zv69bf4QtGo6HQLY9LpmWqYfqhSfDo
22482	payment	1397	1397	1678	1	1	9736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufewYfKAKewi8CfdGhMgwe55hpmkpC1MiWv3hy7G2KmeN3thV
22483	payment	2133	2133	1874	1	1	876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZno5iUgdZecJFnyTu2jVL7V8BjzdCdkNc32WJ2Yq4oV6wMJBvd
22484	payment	1397	1397	1678	1	1	9737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gGXmsjemJ4gnSUZUyUYydejKm8cJPtpuhahiyH7w3SJt8B8t
22485	payment	2132	2132	1874	1	1	249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB6wZNGCfUt2p1hybccqKend4ANanpzCx88t1DkryzcZNjcbY
22486	payment	2133	2133	1874	1	1	877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZjEXKKt2pebky7MBjU3ANBNqrdexUiJmNBUfTFbYggKBRntY
22519	payment	1397	1397	1678	1	1	9752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpjABnxvrq87TbdocEzddNHpBr2nyo2s4dwFfwPfnDWirfdKd
22520	payment	2133	2133	1874	1	1	891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRM6Sx6qQgYw1BtBXNDU6SuHTqEaYBbQCnn75rKnw83x9xaLh
22522	payment	1397	1397	1678	1	1	9754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUR3fVY9WD8SN7TQ58hutqYLcZSWuEctJ6rZpyq92FmLnHzNSR
22523	payment	2132	2132	1874	1	1	254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoM9i4GqzNsBesBaNue4mEEfgzQJvTHDqEfZ1BaVtd8U8kfHPW
22524	payment	2133	2133	1874	1	1	892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT7dZRxwaTSFk72hwYpxY2yRMMQMSDXQq5aCaYdtGz6888sSz
22532	payment	1397	1397	1678	1	1	9758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfLdLC1C2QhKiR517u8ezEz5qFcBWMSsxPijXTmh9a6tCdSiC
22533	payment	2133	2133	1874	1	1	896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHX9VmC7bWa1TfBsUvkkczBuG2xYzn8LSENSLFHxLVkuBGr6Ya
22539	payment	1397	1397	1678	1	1	9761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72ENV7aqjhX9oM82hVt6fVYgTRCTJWdx7FUW7hVqY6K7qEdPt
22375	payment	1397	1397	1678	1	1	9703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99AUZXpFmt7e6MhfeGPjgN5CVoVDw3C7Zoz2Hv11nL2KMfHmh
22376	payment	2133	2133	1874	1	1	846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7czmMmFttzeZSPpw7kYPsnhB9zgyBQgGTutWEMKEVwV8it4ZM
22377	payment	2134	2134	1874	1	1	839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESTzPqaNGpGp8r13jWEt2uAPZMTSXjFUotXpxhjvutqnrzAzX
22388	payment	1397	1397	1678	1	1	9707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpGD3RUJLMHAFtg2wqoZ2a6LzN5wjNHy8HkDz2N3U9dqtFDb2
22389	payment	2134	2134	1874	1	1	843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3yf7bdkkyX1dJ83oy1hXpjbQ45DWzQccb7gHwvrE2YYcp4zy
22390	payment	2133	2133	1874	1	1	850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuprEGViCaGuEWp4XsqeR8Mr553VffqwgHvinuY3V1YxiVg99R
22405	payment	1397	1397	1678	1	1	9712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5fHKXe5gxrMEUnNh8jqPSgM3eBYHKcMh7zFFjkn2tRavxp19
22406	payment	2133	2133	1874	1	1	854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpApKkukQGeJnFmDFuRq15FWvKzNygUZZyqFfHaYa5yRbyJzhH
22407	payment	2134	2134	1874	1	1	848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJWf9rrjozdEQfj2NgZTpX8jRuAoZF5fRbSKcdpszywnyVo6L
22431	payment	1397	1397	1678	1	1	9720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ8jCcwupHNGvQUkM9sk2YAvqzCJuhJVYYe4HQV4znN8QcpmY
22432	payment	2133	2133	1874	1	1	862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyyKneJqj1bB4Vw7hecAkgN6mPbNgbPXmWhDzz2CA1PikPq8j
22433	payment	2134	2134	1874	1	1	856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFSwZtHEZgVSVFS24BPKPFJodEyWPFG7P8G9YXdZHTPqjJCtp
22459	payment	2133	2133	1874	1	1	869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaLabp8XcHWpHMLAdJCjLpmDw5sp3gVREg4vq4fi7XeHcPFPz
22466	payment	1397	1397	1678	1	1	9730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDcbBMdgUa6cv6cm6HJGKaEXKUeoXbBLc7LWPCGUuabTiF5o8
22467	payment	2132	2132	1874	1	1	247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TEqehhBuFN9SgALpuEr6EgGBhCkBkSjTpBgyBJZGebtAky7X
22478	payment	1397	1397	1678	1	1	9734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99Ak673djDneett8cinTkQfrgWTNpe5XXMH1xJKfpgkt89wuT
22479	payment	2133	2133	1874	1	1	875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREK8SciFN5pVCUR51LZx24dRfBAYA5GVNA59Mi7BKk8svxYPL
22480	payment	2132	2132	1874	1	1	248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Xnf7XBGFdFCXCmML9Cm5EKkQbx2aVQnuRnvqFyyhNuoeE64x
22481	payment	1397	1397	1678	1	1	9735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4rehbWUXUhq93c5zss7fGhM99M9eqJ5KYRyqbD7HQfNJs8xj
22487	payment	1397	1397	1678	1	1	9738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7H7RSry5duKzagM7UvkzCMXNcxiEggdr3WQUKHwVrjwybmma
22488	payment	2133	2133	1874	1	1	878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgHL6JCnebiubvq2TpSJyGVofXFJCJtkktCdJzSfk3NHWbQpT
22507	payment	1397	1397	1678	1	1	9747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttPr8W2vzeDj6u7fkmubmewNimDemjbPeFPvSpSJrZhbf3FGr
22508	payment	2132	2132	1874	1	1	252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNaGCSpSbyvTpK4oGxTYbCNVT1j9kvhiVv7uVumiEixXCpSNU
22509	payment	2133	2133	1874	1	1	886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBXzF8Pd5GRu1xryc6QyHx376E9XozEXp1Kt58LxDssN5RGgw
22516	payment	1397	1397	1678	1	1	9751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HtMDRFg4BmsSp5doHVEbzYAEanb1WJX99c9FCNiM6STDZz8i
22517	payment	2132	2132	1874	1	1	253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrUp6kSK5mU3sDHYePQpruLf4NfvM9KkGogz7g2XRVkWtdtMq
22518	payment	2133	2133	1874	1	1	890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FSMHWdKqBQaEkgr6hiYiap9nBuaA67ycJHqULYLpkYoSEq4r
22521	payment	1397	1397	1678	1	1	9753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJjHH6HNsnXw29HzFqP9Gf5TvNX28TW3HzKTZYfq5gNhVZVYc
22525	payment	1397	1397	1678	1	1	9755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbtmbDC9syYwDTvkEfKot9siVnT5FR3F6iyYXpoLd44X8TeEC
22526	payment	2133	2133	1874	1	1	893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxq6QDWcGtLi2hp3gS8Qmuf7yNLBt2ZVht66TXiKZhk9hXoAh
22534	payment	1397	1397	1678	1	1	9759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uxE9n4tHBYWXF39bJVckpawsVoGazhjimYJ6QgedV3eHsdnp
22535	payment	2133	2133	1874	1	1	897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQ1HuSjiEfxePBDwTdfp17a37FMatBykLDjxGWcPcL5jSUNTW
22546	payment	1397	1397	1678	1	1	9764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXtoDwaBEeai7wF8FW1ExdSi5J2C3jMPyr6efYpaLegt4aDzX
22547	payment	2133	2133	1874	1	1	902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTPHpWZDb2SS6jFdP2W686YR8kVefzNshXLPStNXEy3VgofB1
22553	payment	1397	1397	1678	1	1	9767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDUWuNyjEa9CWCt314PiCc4iLgUQ3mq4HUn9Q4wSjNNmAronX
22554	payment	1397	1397	1678	1	1	9768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBJZzbHcRLwKcF4zaLFjmoRjfVMkcSiofAHfkiaXn1yNX3XDQ
22555	payment	2133	2133	1874	1	1	905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c3poXHMthKz8iXWphNTzbdLar57Z5oMCDfvg6cQm5GEw2eKA
22556	payment	2133	2133	1874	1	1	906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NEU4KAc6z4ptwMn3P2m3qjV89bXatvozfX9mzQgNHz4ijuoG
22386	payment	2133	2133	1874	1	1	849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPn3Xqxb2qyFQQp1mh8Nnv7G2epQEZ8S7KLNRhNxGRmEjxusF
22387	payment	2134	2134	1874	1	1	842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2Z9KLgkT2GQbyAhgnrzdpWMhKo462BnJR2pG4yRKPGo1TEJN
22438	payment	1397	1397	1678	1	1	9722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuGX5tdYh6cHWbx8Y6pjFexPVfY7YB99jGajZ52rUJa38MZ4G
22439	payment	1397	1397	1678	1	1	9723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVE5qQ1axt4Q3oXBxKq99Futezvnxo3mD8yZA5zLHyioQAdJVa
22440	payment	1397	1397	1678	1	1	9724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXeRqduoeWyAqiV3rhSbKw63ZEAAvGXKWNvvymShTNB43TiEv
22441	payment	1397	1397	1678	1	1	9725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPjEuDjSjCd6of2gprHJ6vLy1q5opJqaQsE8jy24iTmdMhD8PX
22442	payment	2134	2134	1874	1	1	858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd7crtuHj2UnoVuD6PWP1L4QWqETHApcwgiAbpm1LpTam3H8k
22443	payment	2134	2134	1874	1	1	859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb61ueXtXxNz2Wrig9DLbJearHUbgYbTppzsp6NjPVhChem7JC
22444	payment	2133	2133	1874	1	1	864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2o3XhAZZmzw8SL1XcWk88GC2Gw6XVgPkscCapD1HA5saDWSJe
22445	payment	2134	2134	1874	1	1	860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFAHKju5CZwZVRppKxjDPQ79ZqXRkxasBL56A7ihFz1ifGj5k
22446	payment	2132	2132	1874	1	1	245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpTX1XvDD4MoMmk3Jxey6JtpT3HfmfLU88tPBHo9EwNKMnJnE
22447	payment	2133	2133	1874	1	1	865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8TNKjaYN9pGbcddo53TwNL3nWiLTzyDGhNzg52g5KtFCcDh
22448	payment	2133	2133	1874	1	1	866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV46c1ptcgmW2mXVS8U6wgXQN9hHoiNMZHjSz44KP4zb7JCzs
22449	payment	2134	2134	1874	1	1	861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6aro37oL6WV4eVdmaoqAuiheMxrNeKE1QAEwmgHQjub1RTcE
22450	payment	1397	1397	1678	1	1	9726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS2jQ1Hg6ekBegNC8hwRZ1MgMeNmFv3zvZrSPYCLp9sQVBJb9
22451	payment	1726	1726	2157	1	1	8178	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYrEBjjgdMKGqLpB9eYV4sF7N349ALX6mSkkyabfxaxz93bNLi
22452	payment	2133	2133	1874	1	1	867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGie8qKBJHCfDf9csEdNpUzTpicEmrGJHuU4Wj1mrV8mpEv6H
22453	payment	2134	2134	1874	1	1	862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMs7PpQ2bCdzMSHArJgRGaLT8NnmngSstLnEybt9du845F6uiC
22460	payment	1397	1397	1678	1	1	9728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqs2TtPjA57NJoqbdg3GeL5WMu2DmNeyHTh7HWF1G3VR2VDDXM
22461	payment	2134	2134	1874	1	1	865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iTunQ3AQABsrTKioDZHqK5HrmUXA42SxR3BeNkCJc396p29j
22462	payment	2133	2133	1874	1	1	870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6ConJhuANBfvJVLvS2tVBi5HmfGyymmNUHLjiZn9gMBC8u8G
22463	payment	1397	1397	1678	1	1	9729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQF4kGFAABfb5skyLB1YaL9y9j9rnkMwaDnZAUKfanwyuHQFmv
22464	payment	2134	2134	1874	1	1	866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUsmvL7eMy19hugJiMAYX5ASxQzxG9NLWgV5zJk9uMJWQcr5J
22465	payment	2133	2133	1874	1	1	871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWMPf7P927KqchxUugDCRW9NxYQXMzUH2ZAnaQgrsy6KEH1nr
22468	payment	1397	1397	1678	1	1	9731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLJ8yPUTVeDHqVyJEXW9ZJ8YYvqq9vJqAwK6G1FKobszwrNuX
22469	payment	1397	1397	1678	1	1	9732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6RH5h1W6LAGdwaVtEYxe8uipo8aiTLUuU4ED1PNH191PCBeD
22470	payment	2133	2133	1874	1	1	872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMFbxDVVCvbrHL8s1Jv7toueXUhbJugRRozQxMuM6HDpa5Eya
22471	payment	2134	2134	1874	1	1	867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeewosfLFWoiaUAPWoXjViYrjht9KHtJy6znVA2kF3AQpXpt5p
22472	payment	2134	2134	1874	1	1	868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn99qfDBQVoL3E5xsvNnz2tHM9x5vha4fhuCSzCisPfoP2VoK7
22473	payment	2134	2134	1874	1	1	869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZ8jzNJBvkF6n889y4Sx7mkbmghkeFdvNJnkFcE6DRRcgdHn9
22474	payment	2133	2133	1874	1	1	873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9oEn1k4q9MBP4n949r3HqhpKBWD9gPXXgBvpjgwvGuaFwbts
22498	payment	1397	1397	1678	1	1	9743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyFqUv65DhrJE2VXND8apwpeWrzc1EQrzdSVddJpGSxwfjQSD
22499	payment	1397	1397	1678	1	1	9744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjJRjXA9BXWHm5B6SpVrJpxH2Vz2E1FNysjdyD6YVdkEXP9o4
22500	payment	1726	1726	2158	1	1	8179	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZig4r4WBUBrHeK4cDRhj73Fi2vZ5jCpt4Z2Nk925xRLZC7KMvY
22501	payment	2133	2133	1874	1	1	883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB5rryvDZpMneFwwBhg2rVEvaEMvF5sUtV5SWco3pUzP7mxcV
22502	payment	2133	2133	1874	1	1	884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKCACFViVp6CV3HqWHAPsrXnEyygUqa15JMAWXjbfTg7itK4b
22503	payment	2132	2132	1874	1	1	251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5RvjUTx2JZaPKDFtA86pvRnXv7wRxQkev7MyHgT8Cfm86JNb
22504	payment	1397	1397	1678	1	1	9745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBV5QAPKNsPWU2vjYXkiA5ZYrfpi2SwMVQh6B9DbxxPAtUCF9
22429	payment	2134	2134	1874	1	1	855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAis8KDo4Ce6x6LuozP7xENoMabt9JQwefX4d4d3U863RKAREW
22430	payment	2133	2133	1874	1	1	861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUvn9hUK6DEyRyoPzsSFLiwiroqzVpPkyw3bmBzg9mY8Bx3yq
22454	payment	1397	1397	1678	1	1	9727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3115nrYXqyHDcGQmG4qG9SXUc8tw199taTsYvTNzwgHgCs1xM
22455	payment	2133	2133	1874	1	1	868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SAUxRKZNYvj7VXwfXjv2YHFW9qJbNCeiv4yK4nHPF5qV5ASN
22456	payment	2134	2134	1874	1	1	863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZfKQsq7kTJYVjpseHn7LDRSTJCLA2JbDj1tBhLHJxrLdR9Ks
22457	payment	2132	2132	1874	1	1	246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu3U5Qc9ts51VeDB6cagfa6RAP9xNFSZbhUiTiy3saECBg8B3
22458	payment	2134	2134	1874	1	1	864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eRPAbVYXWsUoXSpPjcQUmozg2LRd5FJDoqoUvmRiCe1sK47G
22489	payment	1397	1397	1678	1	1	9739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDtbU776aehznTj5NZqs8bNMi3vdZT3TPYZ98mxRzerSL7HAE
22490	payment	1397	1397	1678	1	1	9740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcGv9ZfWqd575tZTaUNBq3Aetuny4aJT9kcHuYtfavjmrc4Pw
22491	payment	2133	2133	1874	1	1	879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZUUPvsssdpUKbohG8K7RDnkTXPxqp4DLAXFwahWLRq46nVLD
22492	payment	2133	2133	1874	1	1	880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYia8JktQwRCkMXUDULHDnUosZ4BbmgcNaPVBaw9KUcYdJZPdED
22493	payment	2132	2132	1874	1	1	250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiRdCC6NbUpuTCKLBsyXcuJoefy73piKBvSSntQEJ16naJL8k
22494	payment	1397	1397	1678	1	1	9741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbY3PX36gV3SGP7kediYx5bfZC7RigukmYXTAgfPARcaukKwFP
22495	payment	1397	1397	1678	1	1	9742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqKqET5UFX847n6MmfyQ3SN7bDqLQ7qsnYS3nKndikfAgpuWc
22496	payment	2133	2133	1874	1	1	881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC62vPV6MmjhcwkheixFJ1bvLms9iH3ZnW8FmuFCsjrDdFscyH
22497	payment	2133	2133	1874	1	1	882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUBSwTR73nswaKksmCs4dz5ScnFJC57ipQz6huhR5xRWbb4Zr
22506	payment	1397	1397	1678	1	1	9746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwfZGeAYMH2JcDPnqUFwR9ow7pg7HH5W85qnsiaeJcMdX7Hvi
22510	payment	1397	1397	1678	1	1	9748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcW8qz8ota1RQbeaNrdmp2Egoxi41jMBaA19yqb9pyaNeTgcE
22511	payment	1397	1397	1678	1	1	9749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ak5CX8kXBJ38PamKFto8pJg17hmMiMqQnkkhbfoJEywPrC16
22512	payment	1397	1397	1678	1	1	9750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikk83Pr6mLUp851fSDuxt6bYxMex8EMYKxFKXg7PntAFGGidZ
22513	payment	2133	2133	1874	1	1	887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5CgJCx6AxoYf1XdwRZ465S18uhTDFgaCByXAq2y54kfVDy2g
22514	payment	2133	2133	1874	1	1	888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsbRiu7qHzjpxYChV2qTWqwZ3CvQcrsUAnAc5L6dpXGfxkHuV
22515	payment	2133	2133	1874	1	1	889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JUNn2Rk3s9LuYxBXbf7x8fZ1JjXHdgHy25gTXFQv86ftkSjd
22536	payment	1397	1397	1678	1	1	9760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRXZXqwV8tRrJVecmyjUzjLMUKPSb24Dkk7PUn1vAX4bK8FW4
22537	payment	2132	2132	1874	1	1	256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBN3ArpatSPYi3xWVjyGBnseedpaBUwfPHTt9DHWgpK7u3UUNk
22538	payment	2133	2133	1874	1	1	898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7rxY43QDcHc6PCBSCHPD3zobhvia56BSJtpzPHc8HK8WYLXy
22541	payment	1397	1397	1678	1	1	9762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaVcJYgNQatce51cwRqpJNioza5y7H83satLri1SQ5Jpara5k
22542	payment	1397	1397	1678	1	1	9763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8Y589EBKxMKXNFdGeMwS2PprDZJt3LeeBKYBJ5NXMdg5Q9Fw
22543	payment	2132	2132	1874	1	1	257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52dJ2uAdYGv6UGUPp2iqjfvHz4azYjRp1q7UQfmfFby61VErY
22544	payment	2133	2133	1874	1	1	900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxT6KLDtwXZEMUnPcG3F7xtZbuoYhehApFyY7fzoA7GgTt1fJ
22545	payment	2133	2133	1874	1	1	901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRebGtRQX2HTH1MUNxkYepuCCr4wNakoEcxiy6aYacf3To7ET
22562	payment	1397	1397	1678	1	1	9771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKC5ehhdZt15pTd1ozMd4SgZmuX9NVBchYUgccu7nXEAYm5PXH
22563	payment	2133	2133	1874	1	1	909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dmxYjzYcwgQzcZvJ4GPt8XUJRjJmJwsb1wSVBY8MzdmghLRo
22608	payment	1397	1397	1678	1	1	9786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbmnBYLWNNcDC2CW5yLT7fGmjBmNMRJPcMyrZaUaYXcqYsk1n
22609	payment	2132	2132	1874	1	1	264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK88QRzKkDm9P3Ab38HiWtMzGPbiS2stc3Skrqh1aRhUM7GMTR
22610	payment	2133	2133	1874	1	1	923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKdt1CXAPjGmq4HEpZU3vZa2iodaFjbpReRXjkSu81s9vpxMAf
22611	payment	2134	2134	1874	1	1	883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBVxb5ZE1RVcvbuGfKBhjSjyXLqBYD5zyprtSqRRnc5aC8cgq
22637	payment	1397	1397	1678	1	1	9795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VEiLyATazZPKvv8xCyFe8QKhdGLttWc9kULJ8hoZbwwy8T9J
22505	payment	2133	2133	1874	1	1	885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwaJpgn3mWicAnLFTNPwSLKvSAmBnbxYiwTqi9XYekLPxAtyU
22527	payment	1397	1397	1678	1	1	9756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6GnN3DyWpYWNSrxnVTwcigBWDoR7jSBkqoW887Kdg6tVygdM
22528	payment	1397	1397	1678	1	1	9757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdpErQaB4K7aSSa7N2mTVqDagB6mGy1MXba1z1LienwwsdjJW
22529	payment	2132	2132	1874	1	1	255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHuDcu9e9YgzW7rjf1bxfb3CEgoaW8bzwr9QKzDHK27HWmMkE
22530	payment	2133	2133	1874	1	1	894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdrgrKvsiQhLydFCHSxdJGJpaM7LPX3wUBdQD2H7rgZvBcH9g
22531	payment	2133	2133	1874	1	1	895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSB8DCde5zJHBdKmhhueD2qeN64BCrTg3vmDknRYzHNvaq6NgD
22548	payment	1397	1397	1678	1	1	9765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YRZY7SyohMhxnp9NgunasddKUrECdqRqo43ubc6NipMh4dsH
22549	payment	2133	2133	1874	1	1	903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSr6uPW8js4bghyWmaAZhLP1CwDcU1rMMt75uYWqZgfnRCy23h
22557	payment	1397	1397	1678	1	1	9769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdioct8NhmMVbfEg52wx9jjzoUDpdbWRurK7hgMzWYheTxcz6U
22558	payment	1397	1397	1678	1	1	9770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdceDmGdVnjohe6nfUQaYQi1JR3maKJk2gB7Go2h1ioW4KYHZd
22559	payment	2133	2133	1874	1	1	907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCD5EdVDbSre81aoDgte6qQwZ58xGnsM4sRTD4reVYN7rsogc
22560	payment	2133	2133	1874	1	1	908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1V21vJRWVDSkLk8DxgZ1BxZowQKyzx8wHLPxLW8Kv12p4jpw
22561	payment	2132	2132	1874	1	1	259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwwBfTkbVsq1cBJJAQFqPdBya5TXR6CrxSHcPdScdeuRkbixd
22582	payment	1397	1397	1678	1	1	9778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHv7FeoD4UZpx3rBujLbwegimy8hPnC13RbLPgEKF3CeMur4y
22583	payment	2134	2134	1874	1	1	875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnDkXGFkrHUv8JDqWCWHyfvA5HWiJM3A5c8iPCiQUHioEEM8m
22584	payment	2133	2133	1874	1	1	915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHAamyUhc8mD4Ht7a8CQNc75BAT39z2QvEWvbzNBX19d5NAyN
22588	payment	1397	1397	1678	1	1	9780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgHyaeNUH6Bbsr8v1SEsLe6gchqRUq12y9KVfEsW4cp8hgauS
22589	payment	1397	1397	1678	1	1	9781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2gTZYf1boorfYnh2TRsACqzqWeKP5VTQQxrotYku7SmWMMwT
22590	payment	2134	2134	1874	1	1	877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjnfboMoZPBEV5d5isFZmvvjmRuZaSRnjnCbJxrZpenRe39up
22591	payment	2134	2134	1874	1	1	878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakAJGezNCKc6qjxCTrh8kwuQ9fGEDnPjemLA36rfmF135VVKc
22592	payment	2132	2132	1874	1	1	262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSz8VDLvucYLBKXn7xb715FSYMR9wLBn6fbvU6gecJ4zUKAP7
22593	payment	2133	2133	1874	1	1	917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGg7oqHcGS1mzanUYhSeA8BFUf4bcJ2o77R3iBpJRtyu52RiTg
22594	payment	2133	2133	1874	1	1	918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLTUxCEA1WsS36CYCRR8vr945UqU6ayLbCK5tZ7EmUHSU9pTN
22595	payment	1397	1397	1678	1	1	9782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXuxU8KgA5Uw71LXPFfANxDsWdukqzJqqFj1ZZHaNnTfGKRmZH
22596	payment	2133	2133	1874	1	1	919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdFBCheUFWMtFY9BHM54s4NMGjFkrauuyndVRqw59mwvHkqvt
22597	payment	2134	2134	1874	1	1	879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqL8jqmMjS8TeMZf1urzt6Li5tiP1t6NN97drHpdvrYuSQw1K
22615	payment	1397	1397	1678	1	1	9788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LHSjimFApgvr7MSiiNcYpfQuCF7QPkn3jrcPjG8M8GaCHdb1
22616	payment	2134	2134	1874	1	1	885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5N9iape3esPp2VWwRRbwHCtM8curmmAJyN9CZuH4ZGi6A3cd
22617	payment	2133	2133	1874	1	1	925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbdQhkwQWTafTXQsZ6MEFvVPBX7PWAXw5rjxPT58rtqJzxrWt
22627	payment	1397	1397	1678	1	1	9792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JfyCuKYh9yr5tZAhMaxBYeyCda9vwx6rXDpxjywfevLxmS8B
22628	payment	2134	2134	1874	1	1	889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXA1PeHcx7pznZqzZjbnE66n8N48jpLRFQFFWngDYpbxAJv8v
22629	payment	2133	2133	1874	1	1	928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJBYgbzyp41apjvLGou2C7jWx2RSQbjkgkEMxXLmNCandeEzp
22630	payment	2132	2132	1874	1	1	266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdoj5UPtKWbv1BBpTKaMrdkAJriYLnf3dydRiBhUCsi2s5zr2
22631	payment	1397	1397	1678	1	1	9793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPo1Sa4P277sYWhXzsEHzqonN9JMg6aPnxj556QsRTwai9AjtT
22632	payment	2134	2134	1874	1	1	890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakmHzAAwHy2DZTMvbFcx9XzF4EgiYNADkzxKaSphc5Ctbzvp3
22633	payment	2133	2133	1874	1	1	929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBggNGwbhfpEYVH27ExLQCSeMHrCb61jcUGQdxJPUC5h71GJ1
22640	payment	1726	1726	2160	1	1	8181	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZh61NY63p6JwZMTzxitf76gVw7W6Teb7J98F1LYd7kedeXY4TU
22645	payment	1397	1397	1678	1	1	9797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGv3EZH3RGymFkQbahcS6qsCJWFVKoL3ZDqVD5jZJdD5rEnLLA
22540	payment	2133	2133	1874	1	1	899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kFLeNeWYVKtRf6NNgTnoreWfHmV8Ud3MNy7ifuHNjwbCwd6o
22550	payment	1397	1397	1678	1	1	9766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFqbJ4wy8ee5NoQYdigmBPfw1FmgC3pe8s52n25DwMeHJsox2
22551	payment	2132	2132	1874	1	1	258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7qxhmguc17jzd7KthHwNEuaouguppgw2wcZwT3BFPmrB7fUH
22552	payment	2133	2133	1874	1	1	904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCrDBcdp2YBKZJbvtBd7ZD4tDbZPcTe3GoajBg71U7htp6XxN
22564	payment	1397	1397	1678	1	1	9772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3u5oNNP3GzAEBqYVWY7ji1papPmyCdgeTXTpcLd5GCAZiPx7
22565	payment	1397	1397	1678	1	1	9773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYDds8KGQN3aeV3V16pTMBg9J485XcN2mwRZzHzBTbvnnW1Sb
22566	payment	2132	2132	1874	1	1	260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv67vrE3HshqDHdA6pG78K2SPadzmLkZhM7tNmw7zKPGfB19xF
22567	payment	2133	2133	1874	1	1	910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCeZKcqHvXWWuoBJwiArpVfQWgZAPZt25FuzYPiZX9MYnS7NA
22568	payment	2133	2133	1874	1	1	911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpY7LpWdxy3jWSR2Wb1AdHtWZ47SUYecLXDXAJ1ZTiT72oavW
22569	payment	1397	1397	1678	1	1	9774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh6C7wU13eBBDRsRzYAYjQnSG2pYMbNGWarwpV7hph9x1b5HU
22570	payment	1726	1726	2159	1	1	8180	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgwCTcPm7bVUDUEqQsDzd2ZSuzXGiGf8HjmkyMNq4t1R1eg339
22571	payment	2133	2133	1874	1	1	912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbUrukjszFidgZFPSLG5d2PBffqGMNthQZJ3ZQwwLawP4N6Sk
22572	payment	2134	2134	1874	1	1	871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXcNCirrPzCr5AY8s4JgDJs1kcs6zQtGBQfVqGsgGvQNb9Z1m
22575	payment	1397	1397	1678	1	1	9776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeHzGYRiPqdgwxWtin49seVDQFZgoXJegmAJhF7V4TJELiPdT
22576	payment	1397	1397	1678	1	1	9777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmnLzK31aV3vENVSUF22Bn4cxRKNvSKeMZBpXLnkC974ZZn5Y
22577	payment	2132	2132	1874	1	1	261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbNqYAzqez4hR399jmX77FTvW5XtunhF9RKcJh8EQCQepZDV1
22578	payment	2134	2134	1874	1	1	873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZc9RSf8HujX1vwSLQ3otAthWUi2uwHB7FoShadyQtdMostjw2
22579	payment	2134	2134	1874	1	1	874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8SPqAN8YSS8XpAThszxVJmkdgHpJ5xEDDFZPqUDPdGpFvjS5
22580	payment	2133	2133	1874	1	1	913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GtxNfzWhwwJwkCLpWEQoYfxeF5E2nk2YkZpyYUtUU7aoLngc
22581	payment	2133	2133	1874	1	1	914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FKsaHdj6xWXXeuTzDReWpYM398UiEMn5azSwPx9jGzneSVLC
22598	payment	2133	2133	1874	1	1	920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnYA7dSpgXDgmq22imrBpHdgTtQxhKAzH8Zy5CiXZtEXfBDJt
22599	payment	2132	2132	1874	1	1	263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPk1XuzZQwL7z4hhiMKx7zKBW8YcwpBFY5KduA3BzFLho1RC8
22603	payment	1397	1397	1678	1	1	9784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGqPLg79jUFENYNigGPdmsFDZ3nvjn1Dnia15cLyDsbWAfaw4
22604	payment	2134	2134	1874	1	1	881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdmY8L3r3kJET9d7Pt1M9QxSbbR1wtPe6hzTrARo26KyxGCSq
22605	payment	1397	1397	1678	1	1	9785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreKHcvnHxdUyXHmRFq1VKRDWZLmxUgGPZ2eMUMYrkK35hzbv6
22606	payment	2133	2133	1874	1	1	922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbWd6g6rAnQ9nv9pQaSDAegy7TRCEHxz5rJbtjojR5eofikZJ
22607	payment	2134	2134	1874	1	1	882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNjNyBcfZ3xCtTgxoPvk2EvpoFD5M3NEeoJ1fqvrR2ZPGhZdd
22618	payment	1397	1397	1678	1	1	9789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9Qb8yZcwwUByGygWBCvf9tQP7KTWo72tsBne8oAdJCwpsejw
22619	payment	2132	2132	1874	1	1	265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCdMRPtYq9eNmy45bXY9Qe3ndQoBHsyWdQ5t1Ct4wxM5P7Mbf
22620	payment	2134	2134	1874	1	1	886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5f7XwMGV4qq5nTuRhyZZQqxfbsMj8jc9hfTRG1nvnyqqW1zTj
22641	payment	1397	1397	1678	1	1	9796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFduSz69rCGgU1PRMMBeazUmCfcD9hi4oF89zZtrjkzc2yqm4
22642	payment	2133	2133	1874	1	1	932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FJJgzyHd21yZ7nmdyAmgnNDEW5rwNhLP7U3toThjkamUPrVB
22643	payment	2132	2132	1874	1	1	267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFg3vf9w3LNWiPzoNvAnG71pnajyB7Wgjv5cPjDaEyDJzXaSf
22655	payment	1397	1397	1678	1	1	9800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVxJf2KPftUmM5EN2Lav2wTzXfKktQcq4xS3ZHW6kxWnd1Xyp
22656	payment	2133	2133	1874	1	1	936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoh11iSbW8sGf6Fj4cTXGEnwMZq1LCJF9rc45gxv79Ta9mStf
22657	payment	2134	2134	1874	1	1	897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8Coe7it7YFHy1XMdh1S18pwLN1AG4oWrszkViXfjibW8y8Hy
22681	payment	1397	1397	1678	1	1	9808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VZjyLRLJhjLKzRuvNSm5eVnBDnxT4hBJfUcyBV5eyerEmNKq
22682	payment	2133	2133	1874	1	1	944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhgFm6d2fukSKpCs8DpPbJGRy2bvCZkPFa1ozDiPCgCxtWBbk
22573	payment	1397	1397	1678	1	1	9775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRBZHvGnoKsHPwyk4ELydvbW5RHtrxVBLz7V3Y263928mZQUY
22574	payment	2134	2134	1874	1	1	872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnU9fpZSkP79wUvfpGHCg3px9LSVwyYDeMMwveuyRYL6o1qvrr
22585	payment	1397	1397	1678	1	1	9779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqizixS6ruhCqMrAwmVg4kVp7UNX8pM4ELDkd9LUfiAW2k428v
22586	payment	2134	2134	1874	1	1	876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy4GRC8rYXATJu36HzD8eZVXT78SLBv7Lm6SR3EgTCEFKNmvA
22587	payment	2133	2133	1874	1	1	916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpNmoAkBg7ffYcFvVBMmhUnBV2V9FkApNMBbnYH1gNBNzQNDV
22600	payment	1397	1397	1678	1	1	9783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKU4eX2HpAvCHCf7rvUdjtVg2SnVMRFGK8sr2EucM8MDpSVBj
22601	payment	2134	2134	1874	1	1	880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGuJB1E48UeiFv2bbjU82qFaPraZFRQkrzUrRVC4buVhWiTsp
22602	payment	2133	2133	1874	1	1	921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgmKCUK8CjqyzqwQ8DRZepHEJUUhHmEHsfmjhvq9gEKZb3ogh
22612	payment	1397	1397	1678	1	1	9787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDcuxShajPVLxXvXiNBERHrNKnDo9YutHqB1Lwct8bTW4fkES
22613	payment	2134	2134	1874	1	1	884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkCwBcVqp5YR7kwDQ1TFS1wWNsdiY1DoDcBeD6coNMuRiyqYw
22614	payment	2133	2133	1874	1	1	924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxbKNdH3CLyeqsTKgK6NUD7wbNmk1sFggd9TL2bANMCGUvrgJ
22621	payment	1397	1397	1678	1	1	9790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyiWwr8QWWU5ykrwvHLiaHWQJPXGGya9mJeLfz6uJkM9xnfUwJ
22622	payment	1397	1397	1678	1	1	9791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYi2NcUisMguZVn8xYVtZ4NJTyCXCiEQBMidfzNDu3Taa7cWuf
22623	payment	2134	2134	1874	1	1	887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZw7FsnUr2Qj5MnDADKPMK362PsmqtcWFRdgnWcS3wrkaxP2sL
22624	payment	2134	2134	1874	1	1	888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14deQoV7Y9Qh7rzSgf6atQPrcPrcsUvQq3jLndCNudzSM9Qu5
22625	payment	2133	2133	1874	1	1	926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QFgNdT8mUJM1pr9Q8LooUQizYAtAUKk3a8ee85ZhPdVzSqrj
22626	payment	2133	2133	1874	1	1	927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdd5XTc9pmgoM3h8v7XGBY4tfzqx41bjhU5RQrD1FHhRbTU5NL
22634	payment	1397	1397	1678	1	1	9794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFD7dqDBEbvrsJDPSZa4jUuWtrM1XbkMzGbVeb4UD5X3DFpWr
22635	payment	2134	2134	1874	1	1	891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qqh3JHBoS7owo1Xzh34w62YBL2S8gj5TawF3wkyN9x2zWSUe
22636	payment	2133	2133	1874	1	1	930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UQpBmXypJprUgGb7x6ikKC5KTLTTjvEwZnBmAM5SqcYtXSqg
22644	payment	2134	2134	1874	1	1	893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8Z6KqT3esgpGdHRTPQNTFoSqa5wHpE1eYmqsaGb8x6ny8oWL
22665	payment	2132	2132	1874	1	1	270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseF6Yn3A5RweBJtMHt3Zj3qfH3GJooQGL1UiM5DfkTtB2L2ud
22690	payment	1397	1397	1678	1	1	9811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbc8MTRAU89HJQWrjsoB47orHXQ61PvcBqDfp9Px3JELHjWHLE
22691	payment	2134	2134	1874	1	1	908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBuXYWzt1Ffs3upEEVNY3nfzUYCwQjJv9hzt1kA6HeAMrwda3
22692	payment	2133	2133	1874	1	1	946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2YUQjX4sTnVfH7Ugpr5dnRkQZ6WiUmeNZ9GaQwew6gDCtgoJ
22696	payment	1397	1397	1678	1	1	9813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY9tChPqVWG7CchCwXQzbhmckmRAn2uGSQVyv9bxUzN1LFXnm
22697	payment	1397	1397	1678	1	1	9814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j8c3mxn5gQVpBR1y8cgUWDTMoEZCvJ8fbVUzGqqZQdLHuMRE
22698	payment	1726	1726	2111	1	1	8182	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtsZhqa9PwB7ggek6ovENUy634ETEg1kjzhwfz8KJYGshWkze7
22699	payment	2133	2133	1874	1	1	948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXQMVNvqrtocWu75BdQRnWChvmGGszmxhmAwZgEXEcSMWbxba
22700	payment	2134	2134	1874	1	1	910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAb4XDcugExnoZTszS43e49AjzvTn8j4pviwBq2xWtK645ZdE5
22701	payment	2134	2134	1874	1	1	911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvE4ykQceAajQAj411p43Nun2eqWQj53o5Cqzvinzmwi9ZSUZ
22702	payment	2133	2133	1874	1	1	949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQve7ceckBfW2x68AEMo4nHTB796EbZyR46VTprERhVYjvV68
22703	payment	2132	2132	1874	1	1	272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ge3LWPVpWXTscFYnYcTgKwNeDR3hqZYnWyaoo1pjCwavehmq
22726	payment	1397	1397	1678	1	1	9821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVdAvYjkX8XPbyg9dtXDG4KtzMGB9GS283dHeU773kBDTivET
22727	payment	1397	1397	1678	1	1	9822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKXnSSrYAyka7nbgneqYdVJasiSr5w1UqnKyeas2p8kmgfHaM
22728	payment	2134	2134	1874	1	1	918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkBuWK8HtnUe7CfngiAM9yaEaNXfqMYN7vgRbGwZpjKXkY6cv
22729	payment	2133	2133	1874	1	1	956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAhCgXHB2rDGbvaPjwkA6qxM9q3fM7UNg3zgP8nTM3BSFHfZk
22730	payment	2133	2133	1874	1	1	957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXbkhKEYot37a9gJ926oyu755Dd2vEu7TWwQwrivwvCFXSK95
22638	payment	2134	2134	1874	1	1	892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYNmhQuTMq5dLF4JHwQ77Yt3dnPrx24KDcrwUZrfwHBgtrftJ
22639	payment	2133	2133	1874	1	1	931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMWNPp9Kdk1SWHpwxoiuQBZqzUfeyxQwBukdyExFEgs5phWsf
22648	payment	1397	1397	1678	1	1	9798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnr2i9M1DnZYf2oQmeP6LLRc4nKT5zkVZhh4jKRFDHP78Gt4Kx
22649	payment	1397	1397	1678	1	1	9799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhrGMb4HGmAjUfkXap5WrWHmkrcErwLfwLNpcPTsJQ7XQiLaP
22650	payment	2132	2132	1874	1	1	268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GLT6EkGXVgX5ago6tw4c7HF4hK1q1xQM334AxwCTWTV6p7zm
22651	payment	2133	2133	1874	1	1	934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcB7w3RzqUsZY8VJS8wHd3w8837rJ6zMdA5t3H2y9PnfxQ3xJ
22652	payment	2133	2133	1874	1	1	935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmFSNErBRAoR5GhULi3EjxoWpJdzTchmNuBQkpT5T1Qt2i3Bj
22653	payment	2134	2134	1874	1	1	895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcCVQCJHmT8yNEKm9Z1NaYf51srBkb5WRcYZ7N4me37QD9dXg
22654	payment	2134	2134	1874	1	1	896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHJjaFdWSntZrDTYZak7kcx5nubTD2PpZEA65a2yWcbUy9MY1
22661	payment	1397	1397	1678	1	1	9802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEZwqbdBQy4soNypNHrkmEVVRKfVAPwMBZ2Tyu8J7Wx3aP9EX
22662	payment	2133	2133	1874	1	1	938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyStRsUJfySXudb92r4ezaSYDUEoJtTPr79waYRN6B6AngeSBP
22663	payment	2134	2134	1874	1	1	899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhvoWr3M2kmZzttNxhXzezaRzFsHE4YaNSGGQNiKLAEsvmivY
22664	payment	2132	2132	1874	1	1	269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bA5oEmuDQS7wunnhywt1knjLRMRzBhMN8XGq1og6B2qGRMCa
22666	payment	1397	1397	1678	1	1	9803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56vrvTzLCQBzBw1HosEkqGzyApnYvEt6gv9WLhw1zt3EEWDwW
22667	payment	1397	1397	1678	1	1	9804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeKhWon5Rgbg4D6yq4GHxR2si88PskFWGBFBZpaz8Erb7oSzk
22668	payment	1397	1397	1678	1	1	9805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaMXAvycQxSr9JTwGe1GePMTeUd8Xtqwt8447ib64ef9EMJFz
22669	payment	1397	1397	1678	1	1	9806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Gn1Vd1Df2dtmLfjFtKMh72qvPw9J295pxgBCRqQW75ZmiDT
22670	payment	2133	2133	1874	1	1	939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7Y71dj63zXEBnoASYHDsTm41PAkVf9N6YgfBxgS3HGz9piHe
22671	payment	2133	2133	1874	1	1	940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWMvhS5mjb7acVXGWZYKtFgeh55t74gAunNVFiod2HqoJkjkN
22672	payment	2133	2133	1874	1	1	941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiREERf2sUeeLpySnFxxSfQ2pzc2cxzFH3JEbTYGKC1WQFhYp7
22673	payment	2133	2133	1874	1	1	942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBWte3fCPVVcbvaQgxozKaEMQXLPPYDwRjBBEpRZLfiyksdZu
22674	payment	2134	2134	1874	1	1	900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PFxB8Fet5KPgAnGQFhykLNa2J899VNasoApsAmkTCAUKV1pX
22675	payment	2134	2134	1874	1	1	901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuxYUoNAPpfBgrSJKjxpAKsZk2sFxdGCR4vjb6CXtMszajSC3
22676	payment	2134	2134	1874	1	1	902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7v2EWABpW3Z3vDTZjABgPZyH76dQbjLSLUdiL8SZivHUc1ro
22677	payment	2134	2134	1874	1	1	903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ6btuv2pCCxdSEAGzzzLEn5aj5yWiECgN3L1jEAs6pyiqqdc
22678	payment	1397	1397	1678	1	1	9807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5m6htf8sXTjc9UEs76xPo8JNS8wgnbnrXiuhmraEc42o1USi
22679	payment	2134	2134	1874	1	1	904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFbGt8FRht8AdezWjy5MxfF9eMCmwi2kqUv5XP8nE4ngpVz4E
22680	payment	2133	2133	1874	1	1	943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKRZShG2yftQppEGEC7XDQtN2UW9hc3cRTBSWY5D2vDM22xSr
22688	payment	1397	1397	1678	1	1	9810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns5X3i2dGHJpbMFr4hHirD4PsSpkYAKKNvvsnveGxLPS3DxZJ
22689	payment	2134	2134	1874	1	1	907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDZWMZE6MGrT6ogyDR9pcPFqQhvqVZKST8FpijsJLrbAhhvDW
22715	payment	1598	1598	1958	1	1	1	2100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnfVfietgTknLtmYNRitwhsiXfvrnjkTBjCKNQRfCFZk5X5Ko
22716	payment	1397	1397	1678	1	1	9818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMpUQ9cZXYZ4szQtqc1Exz7wJGiNWfJMsHAKyE2v9BiXyramg
22717	payment	2133	2133	1874	1	1	953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmuu7uMfB7XZWHFchdD3cBQzQXE778DZQwXThMgLpEyfN19vM
22718	payment	2134	2134	1874	1	1	915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9eiXHRk8CnCk9UUM8yRuFcTymDcan46ZfvtCq3Z81cJcWvJT
22719	payment	1397	1397	1678	1	1	9819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmSTAatYbEejQZE63c81WsXq3G1EvhSASvVhTjwqiUmZKSB1V
22720	payment	2133	2133	1874	1	1	954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNr12QTmoX77nP3uqN67UjQLRwCqnVzRNdCD7xhoEXw7YCxZL
22721	payment	2132	2132	1874	1	1	274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54ERnpTaArcDdQTrDnie1EcKjN2sqewyztrHxiDBhqQ8eLP6r
22722	payment	2134	2134	1874	1	1	916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCPzkhs6Wtd3hRvx1SfXtNQ5PJz2xE1GvoBiYJ23TCMWtVKgeg
22646	payment	2133	2133	1874	1	1	933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHjQdcStMTppeptfSAbqHWGdWM5CLuvYYLJZN8PMeDE8rBGAu
22647	payment	2134	2134	1874	1	1	894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWUC1142jhAAxFUvz1AWvnL5pw8M4i6x6vGdRZyrtzH3unCr6
22658	payment	1397	1397	1678	1	1	9801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMHqR3RHg1UYtJLopbEgYb2o4Jt6CzRZXUWrsDjMUzC3rM4Kw
22659	payment	2134	2134	1874	1	1	898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdqyDRVocgteaceFfSFzJZFMwB6p3S718hUibw3kC71rCT2rf
22660	payment	2133	2133	1874	1	1	937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97c32vCvZzTgwYkBwrQJrQVZJ8h7v7JNznG1tSSQJwAc3YokR
22684	payment	1397	1397	1678	1	1	9809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBUdWdHecMNzWY9fbPSnuKjuuoU3fvNXoeGW7ckJSenu6ot5K
22685	payment	2133	2133	1874	1	1	945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g2bGXBMhHygkGmmYhoTfREZ5PJUgVpEEsNrkCspdVgQEAuaD
22686	payment	2134	2134	1874	1	1	906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vDj73x3GT9kx1tRxXf7fSwXyGLQh2KfF7WWLYRVqdTBAqAvk
22687	payment	2132	2132	1874	1	1	271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHNa6ivrCD4katShJUDfDZedYvKNqWQnYH4oKHHNYBUFYQ15d
22704	payment	1397	1397	1678	1	1	9815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1zv7C6TmkihTj2BCd8JctZGNPXkRoB8c4ybn62zXv359ShdB
22705	payment	1397	1397	1678	1	1	9816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YswPqfrM74kmrpPNULGiWCrLbZufK6WwqfriDWs9Q3q3wdeN
22706	payment	1397	1397	1678	1	1	9817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCaziC1ChhmsrP3LydK5tjuWgoR271C2vWqnNaj7UkWuncfe6
22707	payment	497	497	1474	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjYvva3sJQ1nRqs2R5uJsvWV6NecrBeZG645WjnkSx3rek8hy
22708	payment	2133	2133	1874	1	1	950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp5mzwc3wBM283114sUDyaygXTZXCaHVmEXnMnp8wCEA7hMDo
22709	payment	2132	2132	1874	1	1	273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7NBAeFzeFGoiCEUdEQZnRfP6zUhQh52H8CCuTuYKECy8WU3f
22710	payment	2133	2133	1874	1	1	951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmo5RMWXNsNSy5tEdxSauHcFghtyRuybvU2DQqAszwRQDgqM4
22711	payment	2133	2133	1874	1	1	952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHnr84wLBxoWKA6KUKCUfK8LrUQUPWsZ3AxebAZqq8Y1cJhPj
22712	payment	2134	2134	1874	1	1	912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCbkYv3sRMzQbdsgPUd9XmGn2VNMA6n73gAstwAYGxoBVAF3d
22713	payment	2134	2134	1874	1	1	913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKDcKAtDr65KZXGs7nVTRX3LsQsH1tfo4EhtskDr42upSF4au
22714	payment	2134	2134	1874	1	1	914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyndxYKv1G7eAFfxj4dy8wcwRwSDucCz9t6MKq1HTdE8QmLWB
22732	payment	1397	1397	1678	1	1	9823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDDEhdnsTkTpANsLuLZY88cum6aRc8uwYiWAaY9Y2eEXFw37p
22733	payment	2134	2134	1874	1	1	920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHfq1rTJRt8iqYbMyETpxZuTiK5aqF85HMMPwwRwfxNXX2wsp
22734	payment	2132	2132	1874	1	1	275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDufuQJJC3NpTpmubB381PQ4UuqMU2ZyqMsbFQEiuELU5hLv6H
22748	payment	1397	1397	1678	1	1	9829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62YdvKiFrTCgx7pn3LR7adhS92NyMzDJ8SUc3MpgBkuhUAaby
22749	payment	1397	1397	1678	1	1	9830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMdk9HFRgpaFfzB7nwwaYUnCpunXcciFDcV12LN98h2dB4baH
22750	payment	2133	2133	1874	1	1	963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGYRwkBN54whDwGjSGiMG5GCpwRXWVdZxniSL91TcGDwBEFFp
22751	payment	2133	2133	1874	1	1	964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKrpDUipVMV4r4bbBpWwddgk2Kq7QEtiCJ9BFzHPXD2GKzxgc
22752	payment	2132	2132	1874	1	1	277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYeg5nvQWpcZMcsnnpRdzz7izVTHX5xVa6oXHrZvaNPX761AD
22755	payment	1397	1397	1678	1	1	9832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeHJoe1X38e2mzZB6R4P62Vo6eQ4QugjAJcjYLevRaNmWmWBZ
22756	payment	2133	2133	1874	1	1	966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPwLu6rKZqLQ8biNKZg9fe93xdWosGPFUnfXT6oPwDr1TjvC4
22757	payment	1397	1397	1678	1	1	9833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2z7vFJr9hiXFez8z69ja9B3NR7HTnHEd8JypQcJzEHye2ESg
22758	payment	2132	2132	1874	1	1	278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotH4J4EtQNNdJ6UdsXSHrs58w2Xr1bDyt8D4mPRiZqKamWMbR
22759	payment	2133	2133	1874	1	1	967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHKsfZnR9ok7tMcZ3PuSzNuHTz5eQdCgDgJPuPcF569TPJEJyk
22764	payment	1397	1397	1678	1	1	9836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYAwK93nB1y1e8udefz9kFb9MvuBAjcVxibfhhfJ6D2KXgVhf
22765	payment	2133	2133	1874	1	1	970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hCRc1usJ9526CJc5Jq3bAtsWXZga2kQwwNVCEPuiAuGAYC2q
22766	payment	2132	2132	1874	1	1	279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP2LApLZHgDcsn1y8az2E8KYMEmhaTfX8oUn3TBLAGN3TEHWn
22767	payment	1749	1749	1950	1	1	17	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceygSPe4K6nWMQVPHRKDBdEJC13atZAricejEbBv2hKRnPWqU
22768	payment	1397	1397	1678	1	1	9837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmANaMQWWTgxqf5LdypAYEGYthnvGvqmWbyHfb5rFWAsMTFqR1
22683	payment	2134	2134	1874	1	1	905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPdXK2XN2Z6bGCG7okdhKiiWwv4HV43oTcLMw8PWVedA76bgt
22693	payment	1397	1397	1678	1	1	9812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktqVuyMvmPaDmEAeYKPtT6sbEHNHifMYYHfxFbmcJ3o2QMWwJ
22694	payment	2133	2133	1874	1	1	947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZMNm1Sia1eopJuo79UVfGgpWcWyWCmfzGTSP5m1tb3KE4uDe
22695	payment	2134	2134	1874	1	1	909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUknFCEHzdMwtaWZ6KxqAWkZRphFJcSzdCq57K5GYcNpNxHFgm
22723	payment	1397	1397	1678	1	1	9820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Xj7QeBuWvZUtfXGtUWFLJpxDBerz8F4qK4gE5AxRBqr8e2GT
22724	payment	2134	2134	1874	1	1	917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFoSfbnwMwn5MvKgCYLRDa87Ra7akZ79YL539c4dBdfXaK1ur
22725	payment	2133	2133	1874	1	1	955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hVpNA1SdaouNKPttD4gQW2bPmDNE9HJPzvvtPdoRbEMm7emj
22741	payment	1397	1397	1678	1	1	9826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sB8BJqyKsgJqDmRGq38LDx6wwhUTrmxNznDGRRHhkcpwjwha
22742	payment	2132	2132	1874	1	1	276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7a4YWH5D1q6fACMVXTu7iLGqapXqFjDiuWSGfeyAaU3wAcQy
22743	payment	2133	2133	1874	1	1	960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRRMHvjUhCXAEUzVM2WhupFLAasupa3HzzfYow9Ku4ALswMBD
22744	payment	1397	1397	1678	1	1	9827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsScTN12SPSBtFju3W6GX9EzBaibaK9VUSnxXQ75oFxD9gw88Y
22745	payment	2133	2133	1874	1	1	961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEJxTQEc53P6sGLQyRQn2v21QKiHwAb2GTBQGz1DBoeGrcfT5
22762	payment	1397	1397	1678	1	1	9835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW67pMpo9wRLyUQkGhL8PGPYfh6V3j24k5moL32Dh1MnrKGsis
22763	payment	2133	2133	1874	1	1	969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuP1ntMmVc9iAnnwSbQDw8kYpPWmY8h8vUbTdumHWhwnJ2UgxJ
22770	payment	1397	1397	1678	1	1	9838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGx9m9BWKYfwHVe4rDehw1suh9FBepw4wfxW5gk6zL3f8aUrU
22771	payment	2133	2133	1874	1	1	972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoSJJzQVswnskwZGQ7Tw3Nek4NqdxNQcctUh4RHTNdXR5oNpa4
22779	payment	1397	1397	1678	1	1	9842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphuCJwjdeRuuuVc1SYVdHyim15G5DYkMYKxS4YWsHhFrhVJoM
22780	payment	2133	2133	1874	1	1	976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbXKCznghBRtnjCg6SUrpSac2sL94NKPJdqoMDKUiMo3G1vZc
22781	payment	2132	2132	1874	1	1	281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEydEEVeeKdDGCFhgJzS6JuqZRvBCZXghvp8euiUDPCSt5DcKv
22786	payment	1397	1397	1678	1	1	9845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fRK3i1xkJ4YqKw3HPg7vWpRAnbLQzN3nQw3si7renKunkNeE
22787	payment	2133	2133	1874	1	1	979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg9pSAWYBqRKGcWQoCuJVYu4sbxtivka1LcthcXDU1sZTnKV3
22788	payment	2132	2132	1874	1	1	282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8W2v7xEQSBLS3WbegBrhgCPd93533CvTuZ3MMbpmriNcg3zEN
22789	payment	1397	1397	1678	1	1	9846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9g76WDsV77fJvYSZ7cWSUWNrmtmkdGprSTTESQkCSs9fypBQ
22796	payment	1397	1397	1678	1	1	9849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLeTsCT53b7F7U5RVMnxuU8pcSFBvKdCycQiSsM2tCmqYdeYt
22797	payment	1397	1397	1678	1	1	9850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxXtTQF2ioTyJhVbqVwN1k5qsGDb8mBksUWV9PzmFJVL2fF57
22798	payment	2133	2133	1874	1	1	982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oab3YUqoLnpFBdqqStnEK1EDXdkxJ9QzLJXtN1wzQTY5G6Tt
22799	payment	2133	2133	1874	1	1	983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNtfBdVsH5PvFCGvcqNs2ZCdp6gztojVwfwXPRHqESCgEQdGj
22804	payment	1397	1397	1678	1	1	9853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9p6dnrMWQbiy4BSkj9cGJNr39xhaA9djbDxpMs7JPWEoKZQ1
22805	payment	2133	2133	1874	1	1	985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Dkd1MSPY2y9ULiuCnpUf1caWZ1G3LQyiwrkVtztKqXDFvWbY
22806	payment	1726	1726	2161	1	1	8184	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbsN5g7JaVUELg69qnsUF8vx3xuJTMQRHwXsqtgK7ECjn8ySy4
22807	payment	1397	1397	1678	1	1	9854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXowcdm2r2KtZiXaFPSCFmxqajRigW4eB4j6zk578WHUaZT9U
22808	payment	2133	2133	1874	1	1	986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8CL6oK63pD6VKipLKz2BTGmS9LZhvyER146aNKHnmAqax4rX
22731	payment	2134	2134	1874	1	1	919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6z8tYrg7kcbgCRNFmUtwuazxib1HPs9hb63bMeW23nFmWTxB
22738	payment	1397	1397	1678	1	1	9825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJAaPXg1QvutkTxGSzzKREBEY7RspG6bmT4wE1YRiDQzuMQVW
22739	payment	2134	2134	1874	1	1	922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXDHqmajuTej7HtXnVsMhw2UZEiwq5vjVdrMqZZKZMiQ5DjCg
22740	payment	2133	2133	1874	1	1	959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7khXYaLgDKCPQ1frSdwg9dbTzz3mW7QvPnepJEpzbgntGt6e
22746	payment	1397	1397	1678	1	1	9828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqf3RYJYJcrx9shdVruriuJ4o3WEZW9ffdvLzxBzEcYF8cm1Tq
22747	payment	2133	2133	1874	1	1	962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT4JMGrhrwu59rvUzUprdqvSy29oSPHcCzFuJ2WvYMP2XcDad
22772	payment	1397	1397	1678	1	1	9839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkAgUyLEeGUyCVm2wtV8GZTbzQ4RiQCnHUCZJdrpmJ6YUFsZb
22773	payment	2133	2133	1874	1	1	973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4qt3vo5LtPoPMsZoDfDbJt4rpX47gJjSWtgxe8JtHcCjKZxa
22774	payment	2132	2132	1874	1	1	280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZui5gRKB7iiMtfwvf9x3MBcfgycKvgY3dyx3AjrKyZVGpE8ahE
22782	payment	1397	1397	1678	1	1	9843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYeRChNLuXdQqkwzZzKqVDfwxKeyom3yYqKKJ29STwTYwQ6T6
22783	payment	2133	2133	1874	1	1	977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWum56MLiRsmmwdA9tuJyi9fSqGfbH2YsgfzeQ7mLhfjXMrwHw
22784	payment	1397	1397	1678	1	1	9844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcpxTYPsxmMhMZ2KhR51vaKEiYzSRpzk6WxijGU4WsetZ4gLg
22785	payment	2133	2133	1874	1	1	978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVd4vw28FcCYmPNPfytiFDsxPeMez732UrBng5ZFmZSssfTQu
22790	payment	1726	1726	693	1	1	8183	10000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbfR31ohUHBHAn22zm1RRYgWtupGT9utFnm3P8RAEXF6rvscnP
22791	payment	1397	1397	1678	1	1	9847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCMpd525VSYWqHvbh2xGJ34vvZJgHaqxhdHmNDNFKvKaTExZs
22792	payment	2133	2133	1874	1	1	980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKXLg3jL4JKwofFqQL7NcTjxoCZubXUSwZGQP7tSFRWVmYVi4
22809	payment	1397	1397	1678	1	1	9855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzBSDTJo8iE3h8jaRGPtt37ZpqzmhEhJ713wJpGSzuyVyj55M
22810	payment	2132	2132	1874	1	1	285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvmMvig5tBC9D7ffCL9aVf95g7S3WP6aX5cjWTziS4K635zCh
22811	payment	2133	2133	1874	1	1	987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQueQDrYY6mVDtzrk2YaJQHGwsbX1GipqYcsk97s1kMVnPcYMJ
22812	payment	2134	2134	1874	1	1	923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoy22HfsXKDr4PGKdyZEeFNiB5AUygFQzDMMkSgck5x3yFFim2
22735	payment	1397	1397	1678	1	1	9824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVvnSWMSE6ScbMAkTqnt8fdsGv9sCdt2zNYHRysAVXAw9nKkL7
22736	payment	2133	2133	1874	1	1	958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfj6dce6sC2RAK1n9L7aDGWKdT1Kskm5sEDp7rw4GquzvGKpt5
22737	payment	2134	2134	1874	1	1	921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3rFwgTBT4WkYGuL1BdhB3eVuH3H63q2zieKrNnXoZt1pLMEZ
22753	payment	1397	1397	1678	1	1	9831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCdCRwpecaj4gXbFEBoYrABemvfK35Vzhdu32BMkZue75YKYg
22754	payment	2133	2133	1874	1	1	965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkmfDuhmArxLMhmrhDpLMVMSsJFvJ3waniPdXLN4UvXtAQeGw
22760	payment	1397	1397	1678	1	1	9834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZR6meZEEmYXsYNpqZqqj9Bb1jhCfit4gHY2jCL3F8nEW63zC
22761	payment	2133	2133	1874	1	1	968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdLdCvssDsYQiH3Vp9iHsLnkSriGHQjLCtTVLJsqGy7GLgmHi
22777	payment	1397	1397	1678	1	1	9841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47tttmWwqZ5ncH6RV7yCuK6yF4nNbqihmxfBHp8XuuixN4fQ4
22778	payment	2133	2133	1874	1	1	975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycLYojMnGHhQBZYkDWhkEpNp6gDQAtErLEfPFH8vJooaL2ZNY
22813	payment	1397	1397	1678	1	1	9856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWrwtY6tikP1tM482gUSe69D4LZqoQQc46fNAFJyJthe6eh6P
22814	payment	1397	1397	1678	1	1	9857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEKU6yUMTGii235iL9CVDsqY9nww9DoSdYMMhamruoJC4aQkE
22815	payment	1397	1397	1678	1	1	9858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1VYRjJZpAdVNeEg4wLpP8XbpvXCPzwkP6JRpRDCXDmJQugRZ
22816	payment	2133	2133	1874	1	1	988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdpALtpA9y1NBrBixwkuMuRLZbkrn86TA3HqCLKQy3gzZLLZD
22817	payment	2133	2133	1874	1	1	989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ237cV154ruk4JAnjiHbVrN7Z6zSME97koeWSvzNV3LTzDBnNf
22818	payment	2134	2134	1874	1	1	924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9qk7WZ4A4a2fu82pxDJfzQbyVvcagZRp64KchdPSB25eDgC7
22819	payment	2133	2133	1874	1	1	990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAKZmD6LLyeSEYMrygtAh2J3XgkuhCyWx7TMrR6pfMFyeVVcp
22820	payment	2134	2134	1874	1	1	925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDS9fB3gnxZtVnFbqTyUhG1UwY6YpWqxULcYwuwXoyqqmo4po
22821	payment	2134	2134	1874	1	1	926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwjTpsZ1bzYiu3FtdVHCd8Hvnj6FM4ebQmwWffGkmhfrmFoY6
22769	payment	2133	2133	1874	1	1	971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyn8mQNUvM3a4dsyE5tZDpLLicipyktLE3GEAkXKHrLZeh8dP
22775	payment	1397	1397	1678	1	1	9840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfdqZyfyfS8G4iWqYP5kqGGtKVa8XSZGDwgX5LBGW3ngcojVB
22776	payment	2133	2133	1874	1	1	974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSuJx5yxfXgHug5Pt4QyWiZNpT3jbBEzTnY92pgNgmfJia11F
22793	payment	1397	1397	1678	1	1	9848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW7fr5fWHX2WA66AneSUDWd5mEPTi6hBmqiwDUw7njMydnJ62
22794	payment	2132	2132	1874	1	1	283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSnL7XaDVocu4EpyCMBD2p5VitLQYjjuHJjVRvaFQThkdrsoS
22795	payment	2133	2133	1874	1	1	981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDU4AF728AXbJXRbdC7x5w228rAiiHAubXcTYbzo6qb2HTJcpm
22800	payment	1397	1397	1678	1	1	9851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU82WvBKsQ4u4LHaeNCVZPPoxBA559Cx3GQjRi8AANbrMYD69m
22801	payment	2133	2133	1874	1	1	984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Bcy94zChGbuD3vAQftCEfM6913KNh2RrudGCVrjZa9zCCmCU
22802	payment	1397	1397	1678	1	1	9852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCUkuLWis71Spd3CPypZnTDzor75distHpc5zeuGSLmjYEqqu
22803	payment	2132	2132	1874	1	1	284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhJmvBGPvThGDKX1sPs2eWEMsxnNV7H5U99VnrS9KvzyQiPsC
22822	payment	1397	1397	1678	1	1	9859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3NbJxESYSP9SN9ghBnstwz9eGbj7PAEf99MgME6tpp1SqNUh
22823	payment	2133	2133	1874	1	1	991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhAHZd5qTcv3EEHobyiEC4fgw61XDuFsVWVEVoU3CAt5e5a7F
22824	payment	2134	2134	1874	1	1	927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP2mzA4J3Le7HccuWwU3h7ciwtJ97MAt7NsrZPkVCGu4oPsRn
22825	payment	1397	1397	1678	1	1	9860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwn4BuYhBkC5T1o2pNPSyhJV294J36oLupEmhS7L3zmZ1gffpr
22826	payment	2134	2134	1874	1	1	928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYYt598SycCDDLAuL5b7BPEEhLFhFys1TQ2LYFewK1uTr5QXs
22827	payment	2133	2133	1874	1	1	992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6JaPhaky42hCWRq6n3Uyy8fUR1pekT2goVE7MXsLD4kx4Ark
22828	payment	1397	1397	1678	1	1	9861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGicGsT9ErL5FhSwC5dSovKTKGNoD3CTdE94DiTFvf1SDTrQLw
22829	payment	1397	1397	1678	1	1	9862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjimu96KLQocGTQVXoXrxmktFYembxnACeo2NSYAhuBQcrj82
22830	payment	1726	1726	2162	1	1	8185	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtTF7UXshj38nPxQ3FEFsi2cGDiCCs97oD5TWthvV4sdK92iRp
22831	payment	2132	2132	1874	1	1	286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFhyfUJ1QWvjbusmdpvJtPpcjXzgetvAuWY8TGpW5pUmh2mAx
22832	payment	2133	2133	1874	1	1	993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnJf2p9HUJWJAaLB2qHtJNY8tXgWbmJDN8RcwcroJZ5MX5qyu
22833	payment	2133	2133	1874	1	1	994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJ5cQhkHZzTZk9FHh6x5ouRmhWjs5XpUs4KqZR8Hjo7CBdpbB
22834	payment	2134	2134	1874	1	1	929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tW8MJ4xsrTDwchoqUDHiWX4eLKBNvvdBMRptc1Pssgggre8K
22835	payment	2134	2134	1874	1	1	930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZRzSoNbJnRNwGoErxkKBzak8Y3xVjd8RWLYkgujLnZAk6HiZ
22836	payment	1397	1397	1678	1	1	9863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiaGGKVadN1d4wrccijGvojAvfC9ohw87Bj4fRVdQgNF65uoZ
22837	payment	1397	1397	1678	1	1	9864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3prLnF1AeJiDppSwXTVp5kbZ8KfBVqxRrnH4xmJbkXFNuobd
22838	payment	2134	2134	1874	1	1	931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1wWm2irB9hsuXYg4j2YepKPReEDVS7FRZgaHUPhPqyhU1EL8
22839	payment	2134	2134	1874	1	1	932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmefvBcBsAJ8y6UuwQ8zwJ6sbg5S7vkkrDvPZ7ANbenoB6pd1k
22840	payment	2133	2133	1874	1	1	995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZd6Y4e7NQHLjqNcBzVj391yXYe3gbvkxYqD5Wyv2BWwJRB5x
22841	payment	1397	1397	1678	1	1	9865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYD1s1rnQ2cEB4MeMkPXDn7jRXWRsCihC1iFLUXXeLBcUK2Kx
22842	payment	2134	2134	1874	1	1	933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfErEYtKeYJonGaAFmXuX31gc7NtnDbpKFWMyHXQSfYFYLwWx
22843	payment	2133	2133	1874	1	1	996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dU6S8Antxcuyy6ikCi6KbfvHHcpkdWG77fkpADa8v4AG2tid
22844	payment	2132	2132	1874	1	1	287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhjmEaFZ6D9gCoMDDZWaFXZvE99RmXKiteeVkxHpzmEjKrYa8
22845	payment	1397	1397	1678	1	1	9866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumecLjaUvTyNRhaYgJpnaJ62ir9uhba2Ae3svXCZE9NNmmPbv
22846	payment	2134	2134	1874	1	1	934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZNu2C7HEETQLJNg2zURgxmbDFVoumVCQ4KftzbHoApQQwk7S
22847	payment	2133	2133	1874	1	1	997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsn1Shna9TqyqviE29o2YTUrahVbZMfo9YnqsXyQoRWUqmRzBT
22848	payment	1397	1397	1678	1	1	9867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpNARPBaDRqGLKSpJsBFfGY4SdGArjTPTCjS8ypgv3jUjeaBc
22849	payment	1397	1397	1678	1	1	9868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7urMaayj1QbYDJM4XLmgms5FwN2HEkXqYcz4xMNij6QEaz9Gv
22850	payment	1474	1474	188	1	1	14	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M8AtPYnPDnqkGDE7yhSeVEhBNhSnXRqhxMvh7Ls3Y7WpMeNN
22851	payment	2132	2132	1874	1	1	288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSPSfL875xqpr5eEn81CNCx236QMJ7gS4jVcRBuB6zmKRfz4K
22852	payment	2134	2134	1874	1	1	935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pK7vaPpXjAVVASpWWT4tgLQLUZ2KuUhMfiECtXRr8JFd7QcH
22853	payment	2133	2133	1874	1	1	998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ujFXVxhnNY8SzUUQSuQhBw5weXTWW7FfdtmTRTrV894w1wFt
22854	payment	2133	2133	1874	1	1	999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9u5H8QX3XtKEXnjREBALHhubGeQV1V7wT98wTgbg6aWw5cX4U
22855	payment	2133	2133	1874	1	1	1000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCApmVbwdttNygfpjaHBAnK4BnspB5bkhEgNBQvcJerfxDoDPr
22856	payment	2134	2134	1874	1	1	936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGasjqdwEdQoU1RGUfmtB3Lasag8a6vbc2xYx7v7dM7tRCrcsr
22857	payment	2134	2134	1874	1	1	937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XNdbj8YRvaKBnbMe1EzrLVzzp3Zno9Y99tRTAyyf6ia4RFox
22882	payment	1397	1397	1678	1	1	9876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1y5PUapumRsGvZb8HNUUstKxDCCYHhGUdGwSD9dzXS2v36Ux
22883	payment	2133	2133	1874	1	1	1008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDNd7Bgi4ESVqpoAnJcYmpHy2oH2PXUsVqUY7iyBQ4EFTgtBk
22884	payment	2134	2134	1874	1	1	945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrvuudnds7HsRwWBxhwMUtjWHvtcMMi7PdMvWrniLJTeoWqyj
22895	payment	1397	1397	1678	1	1	9880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5fiT9XuiKaBdM5YQg7ti5rJbWtRrVJEWYtdNCpGR2nXA99ZZ
22896	payment	1397	1397	1678	1	1	9881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsctX5ncrpJtS91uejLKiEocXAp5wisPV73FrPYUSaxNCD5ios
22897	payment	2132	2132	1874	1	1	292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Gx3ZvLkpu8NGZkaiGSH5SpmQyNLAM8bsd6mVDBfznGrC3Fef
22898	payment	2133	2133	1874	1	1	1012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJKT8DzFjP4oTyPruNMgr9Gbz2GyDT32HSEVW4kWc7ckrafSN
22899	payment	2134	2134	1874	1	1	949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutwYUAH6HmcwhNNTJgPsrGYMQTjzeWcaNPgmmwEqrnc9nZWz7
22900	payment	2134	2134	1874	1	1	950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDa8YLAVVUiJsTJS3sMWRgfZT2zK7SXU82o2rnyyzsNvHXtAi
22901	payment	2133	2133	1874	1	1	1013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpGsPBKBni45qKPDPp4dBabANwULMXtdbvuzrPQksrxD8HZE4
22934	payment	1397	1397	1678	1	1	9891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnA3hbLC61DN3xzrSgWHovHpxgfwLc5YLUqD3nG98p2eHKJ2t
22935	payment	2134	2134	1874	1	1	961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgMmmfG9Dy4da4XuZXQQBNxWTrzdk7yWXp4GzJRWjio9spFSr
22936	payment	2133	2133	1874	1	1	1023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMgF8YjC4fUxjmwk85VYE5xN2VxuCRgb6WHjaNRPZYmqr2U1X
22959	payment	1397	1397	1678	1	1	9899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3SG1y2Ufb198h9phv5bUhfBdR85jbCLEyTGGLHQa8qp2ingn
22960	payment	2134	2134	1874	1	1	969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGWkmHYFM7vrwHQyoRY3xNceF1gw8AjxsAY92n4Tsvz832fXr
22962	payment	1397	1397	1678	1	1	9900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24JLNPnUMdFE3xxuZyZRqUKX5Xng6N41j5Z5SgFHLBXdAagBm
22963	payment	2133	2133	1874	1	1	1031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLr6akTFSCgZMaQ2bSvJj7ApFAvmKvyVgrqUUpmur7v8uJVPx
22964	payment	2132	2132	1874	1	1	298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzyQWejhdua8CKFC7AMDXsE1YgZPhYjnrTmeUkjvaydQSjekt
22965	payment	2134	2134	1874	1	1	970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRBZ4GT7ocMfKSrn2QCjtQbZCPnEByGJhwwwDM8XJTSs2UkG3
22991	payment	1397	1397	1678	1	1	9909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMbTxwqn3Ldq3bbypNZLAmnQwHS8hhwhq7VhKBXjjWHFw7Kef
22992	payment	2134	2134	1874	1	1	979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7B7a1Q33h3ekCthRzmcPnVVQaF2AXvjUPLwVSPf7vtjjgFN3
22993	payment	2133	2133	1874	1	1	1039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBfSBMLBMQrk3nkgmQ6kXno6vQR5SMyd2rta2JYjKbeKQN2ze
23030	payment	1397	1397	1678	1	1	9921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1N7kNQXdh6Jk6D9RBLFc8kZwFoJv6fXayrHUsNaYZgguUgRe
23031	payment	2134	2134	1874	1	1	991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMLLifeiJb73e6RaUMRFQHdxFf2G7vCmrxfKxYZSDbyvE82sp
23032	payment	2133	2133	1874	1	1	1050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxTpqgamfx2EW6BaJGKWCvAghtWBgJuKFN31aX66K3kJY9NeU
23035	payment	1397	1397	1678	1	1	9922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDqZA88vdDH1QDf9XpD3skwfxGjALx1dKizddW6xviktVaHYH
23036	payment	1397	1397	1678	1	1	9923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5ZJ8ZpFmojfxo4HxNnkkN3wwGpVmkabR5njVsQsM8DeXYrqj
23037	payment	2133	2133	1874	1	1	1052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B4gyze9ZomrNgCfDBnTh2Nop3mkZha2bF8WfcTD5tnTJNk9c
23038	payment	2133	2133	1874	1	1	1053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPLRCNdhQHNpz4y5hw37FDcMUXRthq9d75PMCQG3C76R8Etby
23039	payment	2134	2134	1874	1	1	993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtT8m5A2Ni4CC6J48TXGgs29g8Sc8fY9iRUWMDefrxV5V3CjY
22858	delegation	188	188	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqu53dUJdTByG1Hsv5j1GyxF1nir2incLzmb2niLMz4aEAtQpe
22859	payment	1397	1397	1678	1	1	9869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXM5QrmaZmpFNeEHQ7n2kzQYvmyDAJaRVqbMeRXZsGit8ctxVG
22860	payment	1397	1397	1678	1	1	9870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxP1ttit7KfbP9NeVxHqbwPEGFUVYmNxwuPYnimnkBtPkcsR1
22861	payment	2133	2133	1874	1	1	1001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpd8MQsLTMoDhMkhGVHru5nymDKUodLkCZw1nvr9UWGJrDcDC
22862	payment	2134	2134	1874	1	1	938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpiEY9g4mRmrveR9FJP9XY6P9rKDQpJDWuCCg4WR6ZaZXKq39L
22863	payment	2134	2134	1874	1	1	939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1EQZDLvqAP1B9b98vMVs5p39uYBmtsxrRsZVjHYnKw5DpnWs
22864	payment	2133	2133	1874	1	1	1002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9gW2DeYFgxh9tQvH885HrAsUa85nffsEnzzFWhauuMFr3Z43
22865	payment	1397	1397	1678	1	1	9871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgW3YJLPZxafrBFqMb2zKL1YDrMbTRmxP7Jex5AxdGh2o6Cqw6
22866	payment	2134	2134	1874	1	1	940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmwUhWn1tFGfbxNoZLemQv76RerE3MaZt6C4NhZeRBrsHwWk3
22867	payment	2133	2133	1874	1	1	1003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbyjZ9J2WL1N8ypkzs4LFRLM5qQ71iY4YqhBhGUrejVYYWAip
22868	payment	2132	2132	1874	1	1	289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAi2pUkVa6Ca5Yo6FuU3xQGjH5T1wy5YKV8arvRr5PLmdFWeLr
22869	payment	1397	1397	1678	1	1	9872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1hp1bndF9YcBK24duyh2CjZx6T2KKwmjxr6BLnW1bZKBQTrP
22870	payment	1397	1397	1678	1	1	9873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupKwS7ZHZ7oChHqEFWBVKK6oPjW1gynqAGz2jmas1NXJitoNW
22871	payment	1397	1397	1678	1	1	9874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1R5EzDSvJpeBCDSPnKGqfVQBeC4WKAG1o1GpYsJJRK8yaUmx
22872	payment	2134	2134	1874	1	1	941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxmYGF2WtSFTvrN6tGVtYCcMLggCX9yma1AFxTAn8cfhmmHWS
22873	payment	2134	2134	1874	1	1	942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTiuJ6HZcMnn3z1Sx53hJx2QAV7zefDkZexnKdyjR7rLNqR7R
22874	payment	2134	2134	1874	1	1	943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDUmgRMiw59db6XdszaiuUN3ivP6HHj39Vgs57CrRmmuntjJZ
22875	payment	2132	2132	1874	1	1	290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXMbRbJceDTCaYqj99CjZPugQ2AC7HngwA6Ey4th3vxqNhCzw
22876	payment	2133	2133	1874	1	1	1004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekHQPf2BGxMeqDBUcAhZR9jmxGwF3mKo6EaREnKdFP9RDE9yz
22877	payment	2133	2133	1874	1	1	1005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPzQkM5KrDLnwAC9ZsgBmFCibnpmsJDvU3qCsCG5FKGMNpg1v
22878	payment	2133	2133	1874	1	1	1006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhViC5fMSYD6MCTrgWzQECa2TT6rLr5gT4qoEVjvHCcH33zjzc
22879	payment	1397	1397	1678	1	1	9875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigpEKaQEhRb1uAywLKh1rjrFis76jR1kFEvKCVvgo28R1eJae
22880	payment	2133	2133	1874	1	1	1007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKecfCFZqaFSLcHuTUZBh4xJJ2RKNRd4Xn7bscFAkjVX6JpmUJ
22881	payment	2134	2134	1874	1	1	944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAVGEPY9bSDQb3TA4RfpbG5k7gDYPQybvzZ8A9cojAzCnwn4U
22885	payment	1397	1397	1678	1	1	9877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfsj32rcpmhELPMW8tEjKdoMT79XvZpLMSozKhYigntvikJRE
22886	payment	1397	1397	1678	1	1	9878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfE6cs5Z8w25hupfTpzbhs5Gr17AwSpDfjAUPgXqYWxzjLFiHc
22887	payment	1397	1397	1678	1	1	9879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xa5Sz2KKMpG9ivN1a6RFgs5XoxYakNHBwM9zJ8XxFnpzKndT
22888	payment	2134	2134	1874	1	1	946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSh3jpC6WrhKjZ19j7m7eHzdusiQQMdW62DxuyLPXAWMZDSBym
22889	payment	2132	2132	1874	1	1	291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAqwMKnhsxfsokY4EbbpXutj73sXEgyBr6NYGC6qu9KVKJZpQ
22890	payment	2134	2134	1874	1	1	947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExSZ8uuPeXjx1jx2X8yfzRk2mxr6NbEucPKQbvT13zAqcJbSH
22891	payment	2134	2134	1874	1	1	948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPywRSogpDPDfkYYKuzVedpU89PCNffddGutm2aHX5RcX8525
22892	payment	2133	2133	1874	1	1	1009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFJAiFBqAb8XrimTNRt7FBi312WvqDw2XnXwNsjN2fz6Lojat
22893	payment	2133	2133	1874	1	1	1010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MjxtBkRAjifYquwv8rfWSUH4H1c2esjN4oNbD4tADSnC8h9g
22894	payment	2133	2133	1874	1	1	1011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNpbb5q4K8npm1EfMg3xVwqEsxYmyYStyUTdhT8vUeRTe7hZy
22902	payment	1397	1397	1678	1	1	9882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVpi5Jc1kisA4QgNLbwSueCz1cqDr53YPEa59SUhmCEEegLep
22903	payment	2133	2133	1874	1	1	1014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoS9s3oEkjiUPC2uCrZNXgC1d5ZXHmscM52QY2X7Vr2vBW8NC
22904	payment	2134	2134	1874	1	1	951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsMa3XGfseV3SfPY5QmhxXLMZ5sG4GiyCYgpouAs9BXmg9RW2
22905	payment	1397	1397	1678	1	1	9883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmG34TizqZP64EJhauQoYsmSW2ShLU3pN5yzHbPobHcXhkfQDo
22906	payment	2134	2134	1874	1	1	952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuv9XqZAQLEWQZWq1GZapyTFgfZ96V5t68h36j4deiesAuuB7f
22907	payment	2133	2133	1874	1	1	1015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunnvmNPxuNrkVCpwPAdnKHEuAE8VGzvZFUfiRRQoqqAxgaBfV
22915	payment	1397	1397	1678	1	1	9886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AQASxe2qw9e2PXbpZbj4LVzA3ywvjW6X4EhfWn37bZMKvxqt
22916	delegation	2142	2142	1460	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6jmMDoEPDqcKe7XA58zZDYmKTPsCVCTVVLMDiNUkmBqZFDbP
22917	payment	2132	2132	1874	1	1	294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoudCidEALMZReRuwr7LVcpTkoT9ciYh696K9fQDheDau6Qugt
22918	payment	2133	2133	1874	1	1	1018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFLKyUavb4tPaY4zijbargQVpeGMr1asodEFbXTJmfYgzoPsc
22919	payment	2134	2134	1874	1	1	955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87FRx41hzmV8AsfwtXTiCoXGL16VfDFseJgsRC1aWzjf5USJR
22920	payment	2134	2134	1874	1	1	956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnLpPbmfuKfzknrD1KWBvrBGezs5RcZSVjkXMH3WChv16KEnX
22940	payment	1397	1397	1678	1	1	9893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdjgg3xJ98cyBXmK3uKAmgKwPjrKpMJKsJyb4fdaeNAV51qjN
22941	payment	2134	2134	1874	1	1	963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFe8yvgJiwNNg6Vq5fMu1nFB5ogAF11TEcXcgY2Cuzonaq25C
22942	payment	2132	2132	1874	1	1	296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iWujC1cYpTvHdH9h1q2Q9Cz4RpndyhkirjtxsNiVmKGQnH9g
22943	payment	2133	2133	1874	1	1	1025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESgDMCb7TTMt1fdy4q2DcEHvbL2XESPHsWpcrDYpU46Zphqzn
22944	payment	1397	1397	1678	1	1	9894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQktFV2GDMfksq65QJ4e9B7gVqpVpuN4s2jcHgpTvbpeKKNW2h
22945	payment	2134	2134	1874	1	1	964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiXmy2H7wUgF7mLhST5AWzGCjYhHXZHr23UyA9kWXhUxn52C4
22946	payment	2133	2133	1874	1	1	1026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFn6Bd6LDLMTSxoAe3RV6q38YkFWUJ1TVqdB5P1vzmfpZZcd5
22956	payment	1397	1397	1678	1	1	9898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMA6mQbEAQGG4pgMEEnpSup7NGdWhpre9Ebsbtu5YJfTjAU6B
22957	payment	2134	2134	1874	1	1	968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDBkiBnomq8SatAsGgbnjdQkQfA9ZWUufXEfkALoMWrgok3n6
22958	payment	2133	2133	1874	1	1	1029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWDuNyGhD54tagbYrXaPgzBefANNByQbU9pDpHBqtcpBz2Bx9
22961	payment	2133	2133	1874	1	1	1030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVmBXtuAXP9faEkrWVrkJCT95uQK8KSiWZV3bDBmUuFszsxth
22966	payment	1397	1397	1678	1	1	9901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNzg2911EsLZpNCJ9VU63q3EXPjxfbHXLtjF5caXkVVGT2bXc
22967	payment	2134	2134	1874	1	1	971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nwSJo4aY2vPuy4pUieNujyevircxw935bRRwqo8pft556nzT
22968	payment	2133	2133	1874	1	1	1032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6afgkyGG2CW61JZQT7yNZQ2uVpefgtp85xGVhu515R8mgYqfr
22985	payment	1397	1397	1678	1	1	9907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBk5yRk1gyFPTrcny3LmJbu3caBC3YaSmZErQ41NKfv95zbFX
22986	payment	2133	2133	1874	1	1	1037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uxBs8CeFvardM28WwLFY22VBb2NaPdKkTN2io9nD2d7qBHHL
22987	payment	2134	2134	1874	1	1	977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P31Pv6888zpwoEt7KKzo1k3nvRKFmkpCjsvwahRgDc7FzbCd
23011	payment	1397	1397	1678	1	1	9915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D3TfPe8ff8Z4j1b6RM4KtKHP9nNCh4S5gZHLdgYiCYvwuoPp
23012	payment	1397	1397	1678	1	1	9916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSzGy6uEWzY8LWGtTxxfi8u1mUDe5d1UhHzMZcMY4M1iCEtAk
23013	payment	2134	2134	1874	1	1	985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7rixbqd5XpnpK9gzVXvrbqtrwQL4BjkUwqPjGbLcKQNx6EZP
23014	payment	2134	2134	1874	1	1	986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmq2aEzyFkQHGNSbYrxH8a2uDvCfsxobqKcQC5txmREsZvfTu6
23015	payment	2132	2132	1874	1	1	303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJHoKUz4v6ZsRfqPfU74KGEqhGhGMB7PwfEdnj2mcYp8GsM3X
23016	payment	2133	2133	1874	1	1	1045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58PxU4cX87BAJPM9DpCUg8iwzQDRnddC2mmFvkESpYDKVJAhC
23017	payment	2133	2133	1874	1	1	1046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkbCuJvCMkcUcYBpDGJ9PfebEStEcKutX3ABxo2Q2h3y52hBv
23041	payment	1397	1397	1678	1	1	9924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3t21Ffd3eKMyrr4T3zwLsVH7LyppKgCsZpWvXJvbqUZZfede
23042	payment	2133	2133	1874	1	1	1054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYowHwGSPd5rrppLWvFnGRJ2UipvuctkPGaHTrtYy1uYNVZNce
23043	payment	2134	2134	1874	1	1	995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bmkVR6cqeWybS5VZxL4N3bnxQnff981zTGyTMXVyy4j9LH6e
23081	payment	1397	1397	1678	1	1	9938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9q9mZtdYiNWoH1ErwLvgi4mqMbkSAppzi1ifwiQEw5qELU1y
23082	payment	2134	2134	1874	1	1	1008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgoG2CLfEhRuNPFXds9vVaMBQ3SYxjhsiRqa65i6JexXZkCnE
23083	payment	2133	2133	1874	1	1	1067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnvPGF11ihQ3hT6boR3JdUNyjUUdgDmugLp5KmMWp4rARM3M78
22908	payment	1397	1397	1678	1	1	9884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9WnRXA9XtgADqSfgcnqRcYsNG6U4AWv8vGXv9Xoehv2HZyHs
22909	payment	2134	2134	1874	1	1	953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHxsodoBekeGpVY4HzMefyPvGo63xKBLckZ5jKRiaRoHtGhcM
22910	payment	2132	2132	1874	1	1	293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpbadzw5U32JLiGT3WdcW5yHuRjJ5MGraRtYd3KRBPxB3zYc1
22911	payment	2133	2133	1874	1	1	1016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88Vyh5zPW3jdkg1hMTmscBzmuD8jnoyyXdf4RK1Uc3qAw25ti
22912	payment	1397	1397	1678	1	1	9885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QRTfuHLu2vnFdi8eVfCPPBqjCC47atPDsVUVTUWBgbfNodvF
22913	payment	2133	2133	1874	1	1	1017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2syg2zyEWAkJz6aZE38ThVoZ6J9ZvUD2pzcAU5aZVbyCh8uyv
22914	payment	2134	2134	1874	1	1	954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFcB2AXysmbHuAxfrELgn1G8qzPtbdGP3mn6Rug2AeXQRJmx2
22937	payment	1397	1397	1678	1	1	9892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDWiVEYDyJiV3Q5DaPE7rnUWdgtEkSvqqqNHGw4yRwBm4g8uP
22938	payment	2134	2134	1874	1	1	962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyfV5SLvXjar3ChyWLKTXadH3paSthvjcjVARUBbEeJ5n1Bfk
22939	payment	2133	2133	1874	1	1	1024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rNjCsGPf6UEf4mhziTEXnNi7yjg2Gsz9sc4DQ6DM5KprrxJx
22947	payment	1397	1397	1678	1	1	9895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52bQSQ494xHYiSyn8ZXpSAg5guxqz8ejbpF3VeictvqRcahCB
22948	payment	1397	1397	1678	1	1	9896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmTvMn8EmTkgUQQnKKfNpPbx4gMQ5P9nP7zZNt2hTY49mMZgi
22949	payment	2133	2133	1874	1	1	1027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYft7Fg7EzpCAyMzZ4e22dRgxfcGprhwDRXGUjkacWYkuK6ZiB4
22950	payment	2134	2134	1874	1	1	965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHCeDnvBH9ki5fJooaKkMVQGotfwebCoDp7DtjZRUNf2bfSXJ
22951	payment	2134	2134	1874	1	1	966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21EpUBvmFj5cDsPdYLL7Kt5e4UmaNngqfdXuL8fxg3A1w2aDm
22952	payment	2132	2132	1874	1	1	297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvciLjt5HTG5ERkadLCgmAKNXthUpToe85hXqAEGxEkXK8kmHS
22972	payment	1397	1397	1678	1	1	9903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJF7yFp5wSBxBrQd15qp1yVBWQ2yxhg6zDwRXhBKuBaT79zcS
22973	payment	1397	1397	1678	1	1	9904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJG3vC2MgfcPFZRG2f4kHx95FeykqNcxSutfc2fGPHYF6hTK89
22974	payment	2132	2132	1874	1	1	299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5kis8cxsjcFyrSjsGUf5SpHx615vgBaBuLPPbPvJVznwSoMH
22975	payment	2134	2134	1874	1	1	973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNVSRURwZfwrHkHtuhTXETJkAx2er9QFYVrug9xPb5E7Drf9T9
22976	payment	2133	2133	1874	1	1	1034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNowa46NjAudHCZ1FwAzAyCQN7XoRQFLkSMepK11n7s9Yitv4c
22977	payment	2133	2133	1874	1	1	1035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBou5k51QHsPGs5KcvZi7eXZKvseNgtBTD5Bu1vhCqTfpBEe4s
22978	payment	2134	2134	1874	1	1	974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyNmx7qznTkHRMo3iCPRLgGUR2HqboJS4K7LUhTdkRVdmx4E4
22979	payment	1397	1397	1678	1	1	9905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6bcdC86TqwtWkJVATqynWXkSKFomMqrd7RpctEDotEcZgSWM
22980	payment	1397	1397	1678	1	1	9906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NKgwjsQk7E2FRrLNUoEpbNZdTt9qdhggxm94nCK9TwoXSev3
22981	payment	2133	2133	1874	1	1	1036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAMcX2c5hQPh5HG4vfWkS6j6Uehc9H9iZmdGwQgW2BqjmkfcN
22982	payment	2132	2132	1874	1	1	300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEY5rp5TLHsEBiyEE5c9LB6Y2wdgqjXNSVqsVXuugy7GTuMaeh
22983	payment	2134	2134	1874	1	1	975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJYbdom8Fdvzbo1FXiLRJwpm8goYTfyY3UroU9PXXT2PPz7LH
22984	payment	2134	2134	1874	1	1	976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4QjhX67qZiLRM1VSSLib4hVg9PA4fzgdt4731Bir5Scy69Kb
22994	payment	1397	1397	1678	1	1	9910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhkjXNUuHJZqE28Aifkz4LXRw8MueofhbGd7NpCUmakef5eBj
22995	payment	2133	2133	1874	1	1	1040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43qUo331b3XAvrvLjsYiXDK4s8qQ9xvLvGpN4iHoTfd7LE2s3
22996	payment	2132	2132	1874	1	1	301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGgfmZ75UbSCyhZKtj4cJF35rzETjejDCH7WDkouDL7GfDjfF
22997	payment	2134	2134	1874	1	1	980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPsgs8cE7jtvjGYxsL14HX9ihrhe48hHhexkBYrT9gtS1s8K1
23004	payment	1397	1397	1678	1	1	9913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27VQ7AUQ3iBrXZQP4trpDK4KLWzaooo9JfFSWxcoq1ox4vyMW
23005	payment	1397	1397	1678	1	1	9914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKNFFTh6BLfShkDCmFE1dJjkhRP6TormvVuNCTNde3Lgoy7ZH
23006	payment	2133	2133	1874	1	1	1043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixtHCyLg8YH9CGr9m8xFtoUGpzwN27M5njaQDFFEtbpCc219r
23007	payment	2133	2133	1874	1	1	1044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBCXn61iqtxKNQoR3F4Ka9FCuNvd7MsbdoKE1uQTNDxoQ44Rz
23008	payment	2134	2134	1874	1	1	983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZKQXrqpRS7xRdi7u5DjbBijStVhhaf4SpqcJtiLiEVYnxC82
22921	payment	1397	1397	1678	1	1	9887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbySUUDUXPUEEsQErwC3zPWTZfcX2tSCy3QTSmbboPM15Bmta4
22922	payment	1397	1397	1678	1	1	9888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xsw7iw8ZJ6Kq6gjkywEYpQaqHwCxSQax7GDfxDDJmJvoXH3S
22923	payment	1397	1397	1678	1	1	9889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDFnyH46kmuFsw5Tmohx9ofV9VUNeYmND5oGseb2T4ETswCDF
22924	payment	2134	2134	1874	1	1	957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7epVmKThMVZw5MeH6qXLwSUCYtNQHHtJAEo9q36PWGyYYXTy
22925	payment	2134	2134	1874	1	1	958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgJbL7WsLx4t1MXLqDXLHaUA3NcN3pourEE7JDGNG5RY4YqPx
22926	payment	2134	2134	1874	1	1	959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9iDBa6dTTvcv7s142uAfpevQVAtFLAhJarRum3tJYHTQN57L
22927	payment	2133	2133	1874	1	1	1019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDD7BwD1sVs3u84KFSfB5Q2zmgLaMpt4221iCYrV3n6js4JaED
22928	payment	2133	2133	1874	1	1	1020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXVyh9YVaqmfbua2Eis2Pzh1E3DFwR7jbpyW5TJ3JLzd2CUKv
22929	payment	2133	2133	1874	1	1	1021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRqfCcPouYUFEonuJpBZkwob5HED9csQUAN9bdXxutYNLWJxF
22930	payment	1397	1397	1678	1	1	9890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5XfKBHkBwFdSqDhHP2uvEjzVHvpF9zaRpGm8BqBUrFGpZbME
22931	payment	2133	2133	1874	1	1	1022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThQZJrfSogyaGz6q31LWQcWjxtWeWvdZZH4EwCHjjKAe9S7qc
22932	payment	2132	2132	1874	1	1	295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutaTJwVMFP83zkyRsHvP8FpyfpanY99FsjUfcZLBbQauVF4FT
22933	payment	2134	2134	1874	1	1	960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJB4eNuTDj4dhMeFjsm6v6oQHvg2VBCteUCrZ4Zt2c6QVbucCo
22953	payment	1397	1397	1678	1	1	9897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrQEgb41MWfUoezjVzgLc1VyXofMkvtXsWSBA1pKZVdQXJC1f
22954	payment	2134	2134	1874	1	1	967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRMvpmCoUo1uPrnQ6bJpyUc8rGQdhdvsPDahoDYc4nW8Qgaxz
22955	payment	2133	2133	1874	1	1	1028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYJqK9s8tnErGxHTSHoUJx7fTbbTHvXw4NCs12ywcmyAKxuZH
22969	payment	1397	1397	1678	1	1	9902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2yfRrUntrPm4vEc1nkGDPHfu8oae9G533oAffv3gvNtjSeJu
22970	payment	2133	2133	1874	1	1	1033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSjgkfDqQhzNbF5TqUrndKGPy767GwxAcRarcTXQAVXGu7PhU
22971	payment	2134	2134	1874	1	1	972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLc77BPCu2fiJNcT9gPk7p6wjgSaGU4Ax88fSFiCSdqbhcbiUR
22988	payment	1397	1397	1678	1	1	9908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyZMojDni1HDghGUzD4K1Bt4BRjbZcmwmiuZsfRS32eY3ABYb
22989	payment	2133	2133	1874	1	1	1038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLBzrGUND8RXK8yicDk19ncbPJJaeuBKkXDnYWEEKaH8PGqhr
22990	payment	2134	2134	1874	1	1	978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVGSuQXZeoEgydAjGocSjh119hTyqh5BccF66GYL6MgkGoUeE
22998	payment	1397	1397	1678	1	1	9911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVuLfYUg49T1FKKtnbW6G6DxPwUfvq4hB9vqLmdjzntgHPAes
22999	payment	1397	1397	1678	1	1	9912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBFWK2kMYE7AfTtmc8v3YFjdRpdS82fps1teR4eV2RvpvMNy3
23000	payment	2133	2133	1874	1	1	1041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkM9x4uNQd67g4M4WqSJTnEqP79mFsDheF5SnXPGFBFMroqeq
23001	payment	2133	2133	1874	1	1	1042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu9YjgUiYAJ53hyHdDXSdMJnWGCoP5UJ5m9f8qygnTt5MGNpN
23002	payment	2134	2134	1874	1	1	981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetCLXhFzXwf86uvAHNHGcHdcNP1LkNRV97tUD5EJJipfKMiRX
23003	payment	2134	2134	1874	1	1	982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84aDV6SFYcjW31ERUEwPT3KYCBiFEveJaTaG1QtVbLP3B8sGx
23023	payment	1397	1397	1678	1	1	9919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NPKmQS8azsUFdFgR1DUmDf4aauaq7kYtMdLotd3p7kkTtUky
23024	payment	1397	1397	1678	1	1	9920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4Q7htXpvp6cqgzwjuhCCP9WmGEwP8pPqXArrLTuNgtAuF9Lz
23025	payment	2134	2134	1874	1	1	989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehNMGxbyoPaNwemeKyXPJFWyMNJYqNhNhQZLMRa7Pmy1yxwjF
23026	payment	2132	2132	1874	1	1	304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroNTPpr4KEey4KYbHodoSKSvZGcuyDTTnH2kaKZo3fp2vnx69
23027	payment	2133	2133	1874	1	1	1048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4qggUMLUZy1LaMhoH6uUfVuLUQLsb8PDuHgAJo6XRwEioTe4
23028	payment	2133	2133	1874	1	1	1049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfpcRshDD7f7LTr8JYtYeySWAFGbaptxkSKccEgw5dtkdSgzJ
23029	payment	2134	2134	1874	1	1	990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENwCoE4vFFYqWQxXaUBQFwLDdHr1cSfm9VoufVLSYrBUPZke4
23053	payment	1397	1397	1678	1	1	9928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7czNRBTHE6BwPTy3mXRQqywZTf5CMVpYGkqbtXRLqSs5Jr25
23054	payment	2134	2134	1874	1	1	999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSaeLg6nqmxCCXVJ9MR1AwLL1VoxMYUkZ61jnrzCtrPDBp1m3
23055	payment	2133	2133	1874	1	1	1058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB46H1tEQyu5c48Rb1B3eTjgA693PWaVH3zzpbz2kQ3iXYaM5S
23009	payment	2132	2132	1874	1	1	302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjoU9Li7ZdfX7s2h9X3C8EKDKtAPMaCeHrRALJAGJnvFRHawV
23010	payment	2134	2134	1874	1	1	984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9eNX1wLnMwaybT8WP5Bbq9pqStgpP37FdoekrV1SFPAnweFb7
23018	payment	1397	1397	1678	1	1	9917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQzUPiioPjJdAUygy1iUk7rD6ZHfbggZNXDPK63D6Hiq1XYSg
23019	payment	2134	2134	1874	1	1	987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRWYwByiJuo5DBdcoQFy4e9DNLwA1B3ACmSvs591T8pkcWXUz
23020	payment	2133	2133	1874	1	1	1047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaD3jW15Q1jTkZ7KjCNFcDKbgzifDqhfFcPY6JRW1fh6gcW99
23021	payment	1397	1397	1678	1	1	9918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Pe6qksm4DTFhBQo6oVtip4sY2EUrewSGCLoV56D2WZ4HR3x2
23022	payment	2134	2134	1874	1	1	988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Wme3uaHRukhn9ZM1swDw4cy64Tj4LP8y4VXkZZoiWidVkq6A
23033	payment	2134	2134	1874	1	1	992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFbfCmSpqJsYktmA1YWzTzuVEqyBq1F5cN3fPqxvMN1hEuK6k
23034	payment	2133	2133	1874	1	1	1051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJcYDhBNgDBovXuqHfuEoBcPZBuVNtAkhaCqY2iDRPgCkyB7T
23050	payment	1397	1397	1678	1	1	9927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AU87wLgQXGSgv3W5Z7u4oXtwUjkomJoBHEE2FV2LWwKkHcRk
23051	payment	2133	2133	1874	1	1	1057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxEg5Ynp6X1kj9fYyqAPnJnk3gZuLtRRS1uU5geCacYDGJFav
23052	payment	2134	2134	1874	1	1	998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SjhbeFrmrPaYkiej3egoc1yYRanKFYCsGN1C3YJGZvGtgbcY
23056	payment	1397	1397	1678	1	1	9929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePph1rXo6LSzcg18d44poqSSPuNsi2nc3gfJNsKR9KooNFfFj
23057	payment	1397	1397	1678	1	1	9930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z2aEFWsgSoV4uAHS3L81ms4vEYVP124TUGGUsSjtX59AvXrD
23058	payment	2133	2133	1874	1	1	1059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWwH9fkNekdVfVteRPHMBbvgDjcmCczmKS81UJnAHGRRrgGz2
23059	payment	2134	2134	1874	1	1	1000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmW7BKSW5ACnBbgXSvDs7Mp2j3ZMHCGwhEPbHMi9C8W7xARKK5
23060	payment	2133	2133	1874	1	1	1060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XBqHJs6ay43onHvEgot6ts5tBzMD3oVASYXbDM7EpUKvG4WC
23061	payment	2134	2134	1874	1	1	1001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLwZByLYy13e2yFNeVcdLBwtvwjdFR9uGYukX5nkCwHc6w85f
23062	payment	1397	1397	1678	1	1	9931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij3bhZverHKLWiYG67mjRpcKfHorRKU3oZm1dUS226anGdebn
23063	payment	2133	2133	1874	1	1	1061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCg4o6mV7DG9C944NE8xq5ZojYBCfHGYjtCJHHLkWEcaSjbvA
23064	payment	2134	2134	1874	1	1	1002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzmidda5r6gy24ThcYR8xuvhVUE2oenu3YyWcmcuLNquWRdqw
23071	payment	2133	2133	1874	1	1	1064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfNkt12xGTyeETirtqawSPu78PtjNurP7he69JaagdghnLUSq
23090	payment	1397	1397	1678	1	1	9941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6EJGKh5HpLiNFpXEgdnUGJsG2q4bTQqHHd4QYqVwKqZVenYb
23091	payment	2133	2133	1874	1	1	1070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZy8Qik1VwUU9piBfNCu8ZpmpQnvwJvSuW3RtQEz3yTwMrXdS
23092	payment	2134	2134	1874	1	1	1011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RLaDyjTgNcD9c4KYDW9H6wmZ3ZVEb5N4tNymycbzGecPkfmn
23114	payment	1397	1397	1678	1	1	9949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYQCgTjZ2xMdgtx4EtW3cghUwKwAZXPke2PRaek9ipoR33UEy
23115	payment	2133	2133	1874	1	1	1078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9fAnWVtZFKg6aKDGohxjGAFJw6Kt48wYu2EauziYaCP6rdHJ
23116	payment	2134	2134	1874	1	1	1019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZoUWVCQZ8s5jqRtLNgWnTifqbPqBLiuz2JBGTbppZgh9tcBH
23159	payment	1397	1397	1678	1	1	9964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSzuP7GnkfYBGYJ7rBay3KAVA3W4kXDGGvGVxUcbHytH1fvzJ
23160	payment	1397	1397	1678	1	1	9965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5QUb1UQKrPgpZ5naSNhhfy1bTcgFQoqVdoyXFrdtNn5EpaLB
23161	payment	2134	2134	1874	1	1	1034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTZUDxJLG8FSJJ5Bu7k5Sk5F6WaBSagC398w9HXBdyqJrnBoo
23162	payment	2133	2133	1874	1	1	1092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGunxjLFtDkpqUZtt61SBHG92Fc7pyA89QnBsS7x3BD8k2V4A
23163	payment	2133	2133	1874	1	1	1093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yq14cxjhksYqJ47Y5J9o5nKctzJci78CQoRTLCd7JiydRdVF
23164	payment	2134	2134	1874	1	1	1035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3a6z5dde75jVaDxGWfuMYYAoQxj4ZFKhG67STX6UnZfewLg9G
23181	payment	1397	1397	1678	1	1	9972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxc1AnKfMVtFm8gCG4jSSUEnpF799ZHkdg6KqzDBZHZSdof2N
23182	payment	2134	2134	1874	1	1	1042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrPEunNFSSnReiM8c7WhN84GALncPpTyBNGp6RE3piXVksGEt
23183	payment	2133	2133	1874	1	1	1098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3BgfWa8eV7n7JhdrGdFZkjEoKNGDpHFv4pKFSQwZVccsJ6Fd
23219	payment	1397	1397	1678	1	1	9982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJgKSyU4ugcrj5PfVntYQMif12RA3d3s3TxrgZu8hiWhc3nEZ
23040	payment	2134	2134	1874	1	1	994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EKNCLQRHoNdBqxJkcH68ijejHgxqFLe1ZKpddc2e5WaVSqFU
23044	payment	1397	1397	1678	1	1	9925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof8SbkUuSRHsWbUPry9gRrEisjNQW37gqVtBGHdGa1MDfaLUs
23045	payment	1397	1397	1678	1	1	9926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxEvsEPK842BAt8MpvG3KouXYkpZaP5XEhypAdsJka3sSoaae
23046	payment	2133	2133	1874	1	1	1055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcHig9Z7Szj8M7F1QrpoAtFaz4Nq1SBdu9PnCZtA5xouiCsXg
23047	payment	2134	2134	1874	1	1	996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXEAPgMiU5r63PRE6CNLFbZcj942qngWmZ6bfshCJAhbrAsFk
23048	payment	2134	2134	1874	1	1	997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71445RLj17BfauNVV7sy4rQaLCA1EHvMzY4pnEK5coXAc5EkR
23049	payment	2133	2133	1874	1	1	1056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeAFiGe7SEyg1brs6nyZDXGj2cW6bGonWPDovPH2uUR8sjh8p
23072	payment	1397	1397	1678	1	1	9934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLqhsHQfieqGtEigdCXcrTdfgtUhUy7Q7NptNGFdW11agZZ81
23073	payment	1397	1397	1678	1	1	9935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQqm6dXAzAJgUHCppqB63XDeqwpkftsbLeY1DNYKAJdHJYw2V
23074	payment	2134	2134	1874	1	1	1005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPVLZEZrW7L2Urmpyr7ym3eBsrWu4Dea6HeVBZHDoWM176QR3
23075	payment	2133	2133	1874	1	1	1065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzTdLMDgrjzfbwDTDivTYoUwDdRJ8pM9utHRQoZwaWaGLCpks
23087	payment	1397	1397	1678	1	1	9940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSch2PAfAH4JAA2nVuNwAeoL87wX9EeFyNxRV6kKRc88iVUpg
23088	payment	2133	2133	1874	1	1	1069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYQehhZyPRzbb3paTk9zqvd6Tu1754jTKr9j7W7Q1bKyo27Bq
23089	payment	2134	2134	1874	1	1	1010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ooeyfQejRqFgJXL7XCCYtCtv21ckwsV2S1QkdUqK6u1rVcHz
23108	payment	1397	1397	1678	1	1	9947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJY1PJoNVLtXiaNtSLtqPnNtDsZnxBCf9g53H3WoXsrT2WDSB
23109	payment	1397	1397	1678	1	1	9948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDAukkDqRoEBDSP1v91CiYnVNyvRzRSt55skFrkFJLmuEQu4m
23110	payment	2134	2134	1874	1	1	1017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtHs4DwZu9G3FeStgLgmRrZmrDQYMqjSVhxbd48Qmcz36eeyh
23111	payment	2133	2133	1874	1	1	1076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qCdw6moqihHivfVEyJWsxt75D3PHp8mEQhvN156AkoE4Qr2x
23112	payment	2133	2133	1874	1	1	1077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3QhazyWq9W1qUZjCx6Vp7bdWtftEbzSUm56wncXSpmxuzH3P
23113	payment	2134	2134	1874	1	1	1018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87uoddxY3s1zYuFhrzTqyW3wn3weBPmoo5w6JYjucx5YbTeEn
23118	payment	2134	2134	1874	1	1	1020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJRThrCHRzHFFQa5Tz4bYoTzzb7Wxaz2QBBhA6U9s4kvpQwR3
23146	payment	1397	1397	1678	1	1	9960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfwNN85KDLz8Ccscq6dGcDj3mdTud6HTFFYUW8TDUQT9UsY4P
23147	payment	2134	2134	1874	1	1	1030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTCsxrmhc7BZuBV35mt2zu6dp7GP8PBRBxEkD7Hy8pmPwyzWe
23148	payment	2133	2133	1874	1	1	1088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NoB7FbCgeXDzU55ExZpNCtJGBoFwyp7ws6uP7jkvcSh5GdZL
23170	payment	1397	1397	1678	1	1	9968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZ7zEZ4cse9SgBZ7W54C56X3qeS9W5xLbtnxzhogyXXpn1ieL
23171	payment	2133	2133	1874	1	1	1095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFu8XL9WF9eCGUqu4JawhwbEieiFf1nGFvgEbV2pB6Y3pVpyL
23172	payment	2134	2134	1874	1	1	1038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JY11xpt1dEMCVo5gzRANmutSNArEPNdTyGmcWxWD9Xooz4oP
23173	payment	2133	2133	1874	1	1	1096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZ1DXitbfUmweGSbCwtZi6DQs61LVyh4ncCpCrKmqVb3k3vEa
23184	payment	1397	1397	1678	1	1	9973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgX68JsLhtgSnSs8mGNuf5W5rivHAK52TnF1wPm2soK5Lcpfp
23185	payment	2134	2134	1874	1	1	1043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWSGtXNxPvHTHKxKmT5YdWAk8dLecWhcFMPzGMPPr7zkUcX5T
23186	payment	2133	2133	1874	1	1	1099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkuMHCt6JYvSZJCd5zuTULU9iJQ79tEDKy9Ehnjx7wzTRGyAM
23192	payment	1687	1687	1866	1	1	5	9452631301632	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6ktdTXWQ8z7Y5EqX9pausDbSw6CQQSTgyZrNGFzbbAJVcFU3
23193	payment	1397	1397	1678	1	1	9976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdST17JaKmX6qu8x6UAQKfCzhMdkxcntfUScG9ydZ49A9tSYT3
23194	payment	1397	1397	1678	1	1	9977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzbtv1LP1TNsMUdFe8mAjkPnCc7NJb3HDHNFEuXXsPjs6VbD9
23195	payment	2133	2133	1874	1	1	1101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxxBqnUWCBa2fg2ZTCNAFKXgwF2X4UBC9VfraGbztjbFLbizp
23196	payment	2133	2133	1874	1	1	1102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbUo3wz3VLm3qxqJJ2nCXRrEDNuWeCEbADJA4HzckARBfPbU5
23197	payment	2134	2134	1874	1	1	1046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDuw3gJ8UMQVy2gJN87eCqi6X6N7ErXPeXGEM5a2gbtVJqy8tS
23198	payment	2134	2134	1874	1	1	1047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK59X4T7uJZaqgMNwtiCAegKrXSBECQFu6F2MPN1oQbd6qYMJg
23065	payment	1397	1397	1678	1	1	9932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZvdjSDpPmPWQ6tBgEiAxzXzFJz5XSQ7Rtjmz7unSb47EP5oB
23066	payment	2134	2134	1874	1	1	1003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQMALk7rbmbEZdmZvMBurzeeLqvuMUKhbDVL9WEs1WTAWWWz4
23067	payment	2133	2133	1874	1	1	1062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmLGDuYLm1bX42DCdT4qaLPrihAMvyi3c8UYpLLFZEHBXf7fA
23068	payment	1397	1397	1678	1	1	9933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg69NUKHbcQavStMyBj7BrTJV2n1cgoENDkYPcSezoZnVoB8cz
23069	payment	2133	2133	1874	1	1	1063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEErsgr7ZHJJVqVHN8cLRwFVgwTgwszEtcYiRc2wPU1pJdG2V
23070	payment	2134	2134	1874	1	1	1004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBq3MQddMZj1HaiKhFpi7WfYuvvHY6oLgJL2T9rEi44UKuZde
23076	payment	1397	1397	1678	1	1	9936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJP4nrKnuSbADveSdSAJoYcpddkPPP6skCQqauxRiYwKp61deT
23077	payment	2134	2134	1874	1	1	1006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9xzkHMQ8uoGGefvs4pPvEW4XR5Dfkg5X6wvGNYFXaG8sqd8h
23078	payment	1397	1397	1678	1	1	9937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyK9fGUjZL2jMiYMu1PVqE9fndfyCZUzTbG2Xk4zPt75As4KR
23079	payment	2134	2134	1874	1	1	1007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvLCXoJ224kjCbPycZBhRdZ4wMNmc4ya2u76XXxYt4ctpyHsL
23080	payment	2133	2133	1874	1	1	1066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Sjx3TsWmoQZJZ59kCPUDuUH2HG18GGnsHm8MRP79FT1PHcBy
23084	payment	1397	1397	1678	1	1	9939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8G68aTQ1CoBsUd7RL9Tkb8FS2XNPbojTSsQxWswnwUW86hLvH
23085	payment	2134	2134	1874	1	1	1009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGC15Xhp3fWpF5AscK62J1xNnFjLijZ4pzoChesLAx7mFUzVg
23086	payment	2133	2133	1874	1	1	1068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD14EKDzpWGivMrmzTr36wA1ccXGT7Awv1Dr9XfPH71KoqrC8L
23093	payment	1397	1397	1678	1	1	9942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1oPGE2CWkBjtKi4HvNUCxoUfHw1jE1VHvnXJkhQxpgz6vdkW
23094	payment	1397	1397	1678	1	1	9943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1LARd5g3rLKTeob49Ch3zvjYLcp2Utw5ETu2nH3AjwgroRwq
23095	payment	2134	2134	1874	1	1	1012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rDaiV8Sgb7LVk2wekF8FwY1LzrsUW2g2V9b7Q3ZZ4jz4m7qD
23096	payment	2134	2134	1874	1	1	1013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwo2gsdwXJUpUFpm9QfzyFB4uCZxZ3wEETjQxrH4sQ2Wy8Lci
23097	payment	2133	2133	1874	1	1	1071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVyncjNBoKq5oKrEwRRcdaFnijscyWbdiSAKeN5XQPfxoTVqD
23098	payment	2133	2133	1874	1	1	1072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2ipQrJaLBa3EujtuxQixoHmP89i4i18XASHRk2N4mAK64waB
23099	payment	1397	1397	1678	1	1	9944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxPYBP5S6ZXaShryGKFbBccYvCx8fe9bCDhB5qGNnZhpi6qWP
23100	payment	1397	1397	1678	1	1	9945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ421FGHefhcAFr5yBBY7FMS97mQWcjmrhwYKo8ByaJjyozSVFh
23101	payment	1397	1397	1678	1	1	9946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ywexf758pXAzd2f1o4b2PdoyK71UgYCE62boTGdnu8hdXHKt
23102	payment	2134	2134	1874	1	1	1014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWv96qgvnVpnpEnTbkDweyJXFCRPY2wB1YFeUxHR5LcPkLqPBZ
23103	payment	2134	2134	1874	1	1	1015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyL8EWYr8CNxRSR92UxMy344ZHmKo95ytS25JUNTVxdBy8vLn
23104	payment	2133	2133	1874	1	1	1073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkLooBefVQh2zGhG7nCiw7RJAx7zSuHKNUdJXpayQPdaLXnDz
23105	payment	2133	2133	1874	1	1	1074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLVG7LS6MMTuynhLKrH4N3ChtJUEMEobcS26veqAven69Dwzo
23106	payment	2134	2134	1874	1	1	1016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwZ5tdPePZwwRGtqH3dpKGWHJmNfY56xdfam2ruSSmZXRkpRF
23107	payment	2133	2133	1874	1	1	1075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4NX7A7NRY9TnT5yU3bHRSyiTidmRd5LJFmaxgNRxg4nBMANT
23117	payment	1397	1397	1678	1	1	9950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2mbqhD8KFWbLrXZxRP3hEZTd4Ecx31u8E4yoWwnFkDDdvGxQ
23119	payment	1397	1397	1678	1	1	9951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa381YtKLMEyBCSkaBsCkZNtfSD3VcPXD8gsgEKKPgojL2kek32
23120	payment	2133	2133	1874	1	1	1079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp88tTgSJs4Ym9wkNgTrZS1DWnYiA3LZU2X2LUFMN5ZGzFGXw8
23121	payment	2134	2134	1874	1	1	1021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhunG8sTjm7MF2ptTa1kn9xBJ6pZZWm1rAfpCcXuTRFqibHq8
23122	payment	1397	1397	1678	1	1	9952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ35vVRgqV5qDk1PPsEsaAgmSPkh1dKgDdePV3SPBVKHstFWXs
23123	payment	1397	1397	1678	1	1	9953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfXcK45fj6ezbUTqS7oW7sWLcqgZUuDV3BxAXmnxSD3A51HMR
23124	payment	1397	1397	1678	1	1	9954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3K67eo7S5TM8o5KAyUD2dQbgMTgSkotRh1mvmHJhPGzSjLvK
23125	payment	2133	2133	1874	1	1	1080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDujCLSKf75sgitnFjzo3wv7Mr6uGzFDmfHoWDiqmeSvY5N7c
23126	payment	2134	2134	1874	1	1	1022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYM7jQnBwHcEy564Fqrk4i1MQgJhirYpED7KG2paxVcQjoNp4W
23127	payment	2134	2134	1874	1	1	1023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLW4QiTgCCPMkgEtSGddnJx5eVxgbgC2QKEzFCqmKSVjos4JxH
23128	payment	2134	2134	1874	1	1	1024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuMxRsCkEzWno1TubhLVBZjKkx4zkq5FXQkwp4ojEgAFEfvnh
23129	payment	2133	2133	1874	1	1	1081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtDWWEZ7VSNVJTMMz7PpqxMF8B3v8S4PFyuDUoR4EC6GYnMz6
23130	payment	2133	2133	1874	1	1	1082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgM2ZAPZyuzJFHJQsLVnmMimc65nhU3KGfp7ynDGNkqmsnxrA
23131	payment	1397	1397	1678	1	1	9955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpd6JxyKmDPuYUtVPY3zjeyoRUWaFe2ypVeXh5fLRWLYAroVHR
23132	payment	2134	2134	1874	1	1	1025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQa5UZLeUMbUWVLrWa2NFF3LFcTGMcKQUJocGWi9HBf4Tp1ED
23133	payment	2133	2133	1874	1	1	1083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFTYmScj11LHcZfjdhpi3mfwCVzj4y3mamVh649242d84zWQJ
23134	payment	1397	1397	1678	1	1	9956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyf4pKGexrRpQi1riaizDcDrbb3vZU7bHMNrro6JqfvcG59Xqw
23135	payment	1397	1397	1678	1	1	9957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2wCjUBMRuJDrKv1QP95ZAZmS6BTsuTxAnYC1iAy2SGtVuGa4
23136	payment	1397	1397	1678	1	1	9958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9yBtk8MLBLvdAt8F1AmHVBmbj5neghAygfcCV8fkYVAogsYt
23137	payment	1397	1397	1678	1	1	9959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSwHHLhJAVGmBbrLjJ2fBGUR5dPApSE2KhRZK1HYcMzD4gEfE
23138	payment	2134	2134	1874	1	1	1026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8coTC4U3ptp9afCZZAgS5QSPpuGNu8oonP4vTN7LPnNNcagFQ
23139	payment	2133	2133	1874	1	1	1084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4AnKBdTMovgcYGLzBQuzVQEb4XDzuxj2ZCvDCFgN4D4sz3zs
23140	payment	2134	2134	1874	1	1	1027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57EJPVU5QMrjL9McXgCBL1bw4ixMFTGprqoQsgUGrqBwzEjUw
23141	payment	2134	2134	1874	1	1	1028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6M4XKDfoS1sT6HRw6Bm29Bq27V2ZjTUcaxibvZwYH12L7u2m
23142	payment	2134	2134	1874	1	1	1029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KT7a8u9GzUo5qq5FTd1MZBkVoZNR6ptkwMZG2ZAZgLJGPFCa
23143	payment	2133	2133	1874	1	1	1085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB57rWB3hPQsVygAVdAvjvSTX9LvsX3JGVa9DHnznWGuQWDMX
23144	payment	2133	2133	1874	1	1	1086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEM1q9HdGSzmCfcE3b3tFq26Ef6DwZC3eL24x7vLYcNh4VunHz
23145	payment	2133	2133	1874	1	1	1087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnsC8TtszuF6k2gn5Y377quuSaLfTrGHAdzpoRs5R7bn9t1HX
23165	payment	1397	1397	1678	1	1	9966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMgs3V7z5uxdugN5sVXzPACZZzan9JVEuqX28XcSdddv3SCUi
23166	payment	2134	2134	1874	1	1	1036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjY2eqQrZGzhTr9Xjy9BhFxwEhpJ4Ld4Bi7D2t5ALKujRyPmtk
23167	payment	2133	2133	1874	1	1	1094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeEGoi3efGTw2G1TVSFX5RnaWXpEXB4rkhkvkBaUW84gGiYAC
23168	payment	1397	1397	1678	1	1	9967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr16RKzZEs1YR4KbugmNQ7dPgoHVgQPKfdBqsS7XAhy8fhaKMJ
23169	payment	2134	2134	1874	1	1	1037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumHHkZuzPiB3TMK757J9GPnWCJMwMYVauhvd85oqDNgigsx4c
23176	payment	1397	1397	1678	1	1	9970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLA3RNNJv9NTpskp6vH6hhLT7BYPePSP4FhoRkwS9bLYYtExG
23177	payment	2133	2133	1874	1	1	1097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUi63Lo4dXLYZeU7bUBcXB2n2vmdGFkhrB5SSrDq6GE7jS5oa
23178	payment	2134	2134	1874	1	1	1040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBqhv18tuEBBzrvLqtyWZssNuGqdQFBZLAYCtxV71cM2KJW4w
23179	payment	1397	1397	1678	1	1	9971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYbf4KbQ97d5SA4KzUxzjJLxXcJtB5Jr95VrgRiJiLhB1gWgp
23180	payment	2134	2134	1874	1	1	1041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyYoC5zMSEyD8TCD8XC1WDADF2zD6b6MZ797ANJuEhXKpcvNR
23189	payment	1397	1397	1678	1	1	9975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgivjJCPy2tzDyiTeAUNMSJcbUrNSBDjFtL3azxVNn5Ps9qxbu
23190	payment	2134	2134	1874	1	1	1045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qgDBWDyJ7f38mv7w1X9Lu7wNEwLQw2ioH2k3bEeTJ8PhJ5AM
23191	payment	2133	2133	1874	1	1	1100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUUN1URBnjJ3cz7rbmqim4PVS2WgKbH2Rd8rAFvkbdCgvXvrE
23199	payment	1397	1397	1678	1	1	9978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sxkvrgawDS8ZojbNizkDESQ8wkqhhRk6a1D4yUTgdvNCguFZ
23200	payment	2134	2134	1874	1	1	1048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Qz5i1jtPDwLNBdqSDrLByAYTr5H22zJomujcG9nVYJ2Ku2Nb
23201	payment	1866	1866	481	1	1	16	121703800914	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYSGnqpoHrf3yW7dCYJxVUks1JU1LzWzz1BfC9UX43V7YHaLhXB
23202	payment	1866	1866	734	1	1	17	3687993946	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZvRZXZTGegjtHPcadabzKnZAbjDxmGUhRPrxbp23hn4LTSXuHa
23203	payment	1866	1866	845	1	1	18	1057224937032	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaAva5DWTLoBLkGFFwcYExPEtb2KRcZEWD8af1dN6XNBjGWAj3v
23204	payment	1866	1866	846	1	1	19	1057224937032	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZYEomMmokktPFGA7Jc8fjW92j5HX9jLRTvjQagZ7qVfZEa9g2f
23149	payment	1397	1397	1678	1	1	9961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpqQZ2tqg4iDNs3yiDyF1ciGij29zRkuf3VkfPRiMiPk3kd9R
23150	payment	1397	1397	1678	1	1	9962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQL1xhvwd1fDSa7b9VWJjEwpW2ubBUDXCGQwXDdb1Mx9AnbTf
23151	payment	2134	2134	1874	1	1	1031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5nDw6q9DB4EywcAayRAkDAwDiWL4FfpWqTPYj1MhLL9kdEFE
23152	payment	2133	2133	1874	1	1	1089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddgVwQEpbUJ5sFte4FBnzptjsoKoYixVFUcnQ4N57ad7DEKfD
23153	payment	2133	2133	1874	1	1	1090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDxAhutGPBHwDWeeZ6q3Q3y6q1Am1vwkyhcpBbHG75LM8urEt
23154	payment	2134	2134	1874	1	1	1032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXH2LmAcNrvRCbcbrtAcCixHp8hGpRYryKugiHRpCLeWZRrzc
23155	payment	1397	1397	1678	1	1	9963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrdtJtadStZixGZS9dQoSLFBLSw6RfNnvFVqe4tgsH1CMHrfP
23156	delegation	2135	2135	1505	1	1	0	\N	10000000	\N	E4YXR9keVZupY7MB5V3rXkjo3myt9igFm1RNovKdSHNdhee9YWBrk	CkpaDHiKvEUoUvmyfdptwEAvG35zEgxcMkK6DiKyM6y1HuG3Ju1J7
23157	payment	2133	2133	1874	1	1	1091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7gGBGieHmhN5NNGjT3N6YgqbbwGLRDkHkSGsWu9hPc6c831f
23158	payment	2134	2134	1874	1	1	1033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiQ4LZ3ZW7FUxxHvMUdL5N5po8evSUTvq6d3yM99yj37iASZv
23174	payment	1397	1397	1678	1	1	9969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxTBRJEhpjmUaS2SbVR18khFmrXJbJse4LhptzuCD5SMjn84X
23175	payment	2134	2134	1874	1	1	1039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPHMYMAar9tJaAmR4cvepYYf6eYpNgAsQ4kBxenQiQgM3bP7i
23187	payment	1397	1397	1678	1	1	9974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sLnu4h6wMTmhFeF4iMq5Gag6UsGnV8NwLz4E1jU43yqptvAm
23188	payment	2134	2134	1874	1	1	1044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSznBqXRnEUqMQUht2o6HMWyy5qxpgVZhmrVu3K754EZffsRu
23216	payment	2134	2134	1874	1	1	1050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQ4vYgs53MvPU3JSNC96TKXTK6RSWZkvPqdkX9dUrt7fwuonJ
23217	payment	2134	2134	1874	1	1	1051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYg31Gc8GK2AwGWkLaa9Qyib4W4QLmjM9zkNMkezyMie1ZaXn
23229	payment	1397	1397	1678	1	1	9985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ5DRdBxeWkFzhxFnnAHXX3YMcq4mqq5bCKHCGBhTRZ8B1iZM
23230	payment	2134	2134	1874	1	1	1056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZs88D938ssFSvDpowGVt2VZSXPsoBb7rEC6ZE7soFPnSpNs6h
23231	payment	2133	2133	1874	1	1	1110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5dg25taESF9WDb7YqN3UDXpgA9yUxgx73PyWajsbW5xiVai8
23269	payment	1397	1397	1678	1	1	9999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbFGSdEpMJQZbRFQiM71oq3CvSLVKZPGt7Z5Jgedek7QPPHoK
23270	payment	1397	1397	1678	1	1	10000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZ6QY2PFJm2T8QntGhY6JjRp7DoytTy4ef1LhqGDsTNA9vS2i
23271	payment	2133	2133	1874	1	1	1122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMYDeamH6qzaxKdr4wgx1SWG4ZeRPxb38VxahirrwH4Tm2265
23272	payment	2134	2134	1874	1	1	1070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzFhe1Ap5WPV46BKDvNFvBrktsvNqCmAWaddPWWYw4Xqy2GRE
23273	payment	2134	2134	1874	1	1	1071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimkoWyVqUtzeGNhtwj1cybeq2BBP3rYfWsH5m9oSd7EhCCCmz
23274	payment	1397	1397	1678	1	1	10001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULCV3J7b1tLgun138R7MuYKPJwrbD9Kc4f5891LtUou2MYfNm
23275	payment	1397	1397	1678	1	1	10002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BtksHNTp3EDyivyBQE22ZXrmPgauJXSCVqSB7SQ3PJogLeKj
23276	payment	2133	2133	1874	1	1	1123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRi9dacDUaoKE2tpT6dWuomCtFVrWVpocZyW324a59uxGfHjM
23277	payment	2133	2133	1874	1	1	1124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhY3uqbrqSeprbfeRtLo3oCrmUBPo6nrjzLy9MvJMMDcvVKS6
23278	payment	2134	2134	1874	1	1	1072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZEwHYY11NMUB14H6rTnmfCcA8NdRVviab36BD7ZPrggqjsgy
23279	payment	2134	2134	1874	1	1	1073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUabqhPV6he8cwAf8kR2ardauGdkYhNVMRSMc31CvZNiNo11J
23297	payment	1397	1397	1678	1	1	10009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmTvQx8uFrYMUjKT7u5TaphQiqvV2ANEKXNrN8juZG8yBS7rJ
23298	payment	1397	1397	1678	1	1	10010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKK9mmLYPfqJoa87kaLpxgbyKsffJzoayUrR6fSeHgFtxpvFtS
23299	payment	1397	1397	1678	1	1	10011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eUEwo75aRHduvxtuAHPQosTMq9u2kqfjjjP2KFZEyAYFE3ty
23300	payment	2134	2134	1874	1	1	1080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPoMXqiy7Zx6R1cVExWCp3gVScANtux7eTSRJUjzdC56dccYK
23301	payment	2133	2133	1874	1	1	1130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxAhqs6oRiout2mJFdDJB7iU6SD5WcUYbX3zee169FJetdRp4
23302	payment	2133	2133	1874	1	1	1131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgSe5goaVmzMeYkirxXvbHwcTSNqU5Sa1xG9cJyWoJDmsvzUL
23303	payment	2134	2134	1874	1	1	1081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZap8tPFQ9nSzaSwGTts62XkcGhqn9SXMSPGa8VeWxReTvfANjE
23304	payment	2134	2134	1874	1	1	1082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcQypUKXiRJPUz5Nu2ny5JrKmU8Hg6U71BWckV16VEvFmZ1sF
23205	payment	1866	1866	936	1	1	20	978516909538	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZxKNNdtJpAV5ikWTvEKy2X298R7cCGhYo7x61tETC2QBr2F7Ko
23206	payment	1866	1866	1056	1	1	21	1753493917952	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYhLSxtwjaDmgVRRrsKMAyKotTWXkoMphY5XdrCZHnqe6Lqc4MT
23207	payment	1866	1866	1176	1	1	22	1183117287282	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYRW1HqQ6FkPLHGb97i1XVTvJQvxvemUL7H9yug8oEdkbobJ3Z2
23208	payment	1866	1866	1302	1	1	23	3296861517936	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZouW7mMAmnUFAZ7ErnZUeyRSe2R7DREw8bbmHFcrsm9SLjBS36
23209	payment	1397	1397	1678	1	1	9979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFJmUXHtcRKvyzMtHHo6cXJA661Vbp4FhckpnmjhcX6ErZfEo
23210	payment	2133	2133	1874	1	1	1103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8VWc25MTARgQ2rbeqzr76v4gyNptJC49uT84tNYCLtQ9kdgo
23211	payment	2134	2134	1874	1	1	1049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ485AbRrehUoPcrwskMXXSufV2jBRSxYQFhi1UxH6CXZ3FMtLM
23218	payment	2133	2133	1874	1	1	1106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjw64oPoHnE2MoD8pMCEhb9UwmFLwQoybQCCWYQnUiA7Pvch8
23232	payment	1397	1397	1678	1	1	9986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdx9pkhU4C9wKiH45QujjyaDRp9YubUfLKmKwHDvPLn4cUw2XT
23233	payment	2134	2134	1874	1	1	1057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxUztBzkTv7XikEPa8dA95k2eKmdM2AZwjgSj7suJ2DAiaYDY
23234	payment	2133	2133	1874	1	1	1111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXmk2nfSpnCzgA4hvS4GUhjXZejir54qLC6zfLvvcS43JY5a5
23241	payment	1397	1397	1678	1	1	9989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLhaxNg5ciTvVUfzcB4nVpEbFdTANuMjFyMdMyUuE7ya27nJt
23242	payment	2134	2134	1874	1	1	1060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkS4mSJrPGSnCTNzHAqE24okSzGeXk3rNSa6or1XSpTXrcwfy
23243	payment	2133	2133	1874	1	1	1114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDGa62TrvNMDG34vuTesLGBoQ5V9jsPWCnET1PwrSQC894n1o
23252	payment	1397	1397	1678	1	1	9993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8L7KHMzGsLKHs7AGaYCPQL2h91JwzhfaLy8ZPk3spVbEedDZ
23253	payment	2134	2134	1874	1	1	1064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19ZDxzdD87UKYFFWqgHo4NuJwNEmu8PCZUaGtD3mKbBY1nqR3
23263	payment	1397	1397	1678	1	1	9997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sFZn5tMMt34YMxzHRTNwDBnz1gcPrAiACGbVnTmBrht8nnoj
23264	payment	2134	2134	1874	1	1	1068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKuGPsAkGSbuqDtw17k1GSpLZhjTdYKiF9i95MMWsQiknKSAV
23265	payment	2133	2133	1874	1	1	1120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrq2eswvuEKbkh6Uov4TdVwsUJazj2bbLSGPapHCzttorUZEY
23285	payment	1397	1397	1678	1	1	10005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAqkc1RD7tE3qFSMJqMRy4oVjkaFRXm7dYkUHFBWXXnabzRue
23286	payment	2133	2133	1874	1	1	1126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFZkKRwPH54YFaXYoHvqamcAvGjt2FgqqcjKLh796Z6f7MNai
23287	payment	2134	2134	1874	1	1	1076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9hdVkxbBDCpL5wqQvkDER71KCY8NG1wp3sPVPTjq4sUYd2cE
23315	payment	1397	1397	1678	1	1	10015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GVN5Zd7jp1bhNn6K7EdEUG1U88HWUR4i23zcm9sxSGHS9tS9
23316	payment	2133	2133	1874	1	1	1135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SPUKSt54spyCPW9Axe45nnbAL7rEqcxqGm2fQuwXcgfj2RuP
23332	payment	1397	1397	1678	1	1	10021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DNXuHqCcKZMgEzDZTdna7m5qVN4oEXX1rKKA1chsxaLT7shV
23333	payment	1397	1397	1678	1	1	10022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCEumpukiocbube6azBKgi1fyxfRT5L4sNufGLGMN7Zw3eBje
23334	payment	850	850	849	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2EroXi3EsosAqPh3SYfGHjfVPrFmE6pE5GyUSL53bWto74seV
23335	payment	2133	2133	1874	1	1	1141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ8BS8qkXCcKBLcL11dLe4JA28TkEHQj5LTYaFF5kE57RJqU8
23336	payment	2133	2133	1874	1	1	1142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwm8ZArUYbotFhNHDZpkapfN9k2mXXiqP5JrUUKa2ubzhRxfh
23337	payment	2134	2134	1874	1	1	1091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEscAMEcra2DA83PGMGD5ZiuHJRXbTtxZa96m86ZHTPUmHzn8s
23338	payment	2134	2134	1874	1	1	1092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmov5Gf5BE4XxRNPbnvjkrMG9BYhoZFuTMvU13BS68fCeuCpWj
23367	payment	1397	1397	1678	1	1	10032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99Ed6GF9Siwjonavvv43tNWuoJsU5yLGZJd3AWEannDhq6QG9
23368	payment	2133	2133	1874	1	1	1152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1NwrvTxgdus8kJ2kqVh8VJEfNdD5isfZhtmDcc2UrzQzgrZS
23369	payment	2134	2134	1874	1	1	1103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQo5HR7f792aFV6UMXvoNdYyi7ygVFFFgEU9R9YeupZZ6SGWe
23392	payment	2133	2133	1874	1	1	1160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXkh3LX4myLJAVFL3gxyZrKqi3vmD3toBKqeVNFz8oWQGiPKx
23393	payment	2134	2134	1874	1	1	1112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aZddVZnkYePWnFTRMrnBv1YGWq7jetSdqdTQppkV27sh4Pxk
23417	payment	1397	1397	1678	1	1	10045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEAAttZ6mCYZ3Ykp2RLJGnuo6KTs1F5a18UnVGZ9B8PLQSdaU
23418	payment	2134	2134	1874	1	1	1120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc6TgPZvE76hMR9moVjuzbgdEs7uUVTue9Jbeg5LxJ2cX8hWv
23212	payment	1397	1397	1678	1	1	9980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYozdmVbLtac6nFZmzSaqjrq7PbXr7WEhNJyw3b2tQTCPeVZhR
23213	payment	1397	1397	1678	1	1	9981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjVPTGkZ6nc92hwoJQFtGdhYKtKESjsuQqk17Z54qmg9Ma8D
23214	payment	2133	2133	1874	1	1	1104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEY5SNWUfSGLkX4g3xgjsR29BKYFVZNan7qeYZEpnJduFf6vD1
23215	payment	2133	2133	1874	1	1	1105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoysWEE7wykfxaCFWbR7Snkq5Kw9LYTTbsud4Q16DphrvdyW4N
23226	payment	1397	1397	1678	1	1	9984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9Giv6Jmpc5TfdvZjaWGrAeCC1F4HiezcU28P9EiQc3N3VQAC
23227	payment	2134	2134	1874	1	1	1055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBmEcX8Xyhxco2dRReyxPaRWDQULjdf2KAT1jjPhBQF3wq5dr
23228	payment	2133	2133	1874	1	1	1109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23U1qnVi1PrQfZABNdTAABTFRL3SMeVy2vBDFUVeoM8aZKhea
23238	payment	1397	1397	1678	1	1	9988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgfMjocVuZg3aq5Mfcmt6hAXDAwsuW7vFXguvyH6GfXxw7y9u
23239	payment	2134	2134	1874	1	1	1059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMtEMF4rQG77DAYSq4PxkzqNQukaqzKoXUn2sddho7kBgzH72
23240	payment	2133	2133	1874	1	1	1113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBBXE2pcb11wHSLphRWR8caZocY1FQsERarsXJFkpb2hKWM8p
23247	payment	1397	1397	1678	1	1	9991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCbdKmChVeCPBcXWxJ4Um6VY98tqUCUrhiDQaMBtNsA4sgydg
23248	payment	2134	2134	1874	1	1	1062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjqFCD7DhphWEiYrG7asM3huA5GbczwMkwgejPNgGctkeNXRP
23254	payment	1397	1397	1678	1	1	9994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgFziqheTJC1UJd74KJiGfLQjqSgPmLsV8fai9M6kwKywyyg7
23255	payment	1397	1397	1678	1	1	9995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3WYeKEuVMH52x18tivrKMn7pqxYMr3D8izqrJhHXLqSaXndf
23256	payment	1397	1397	1678	1	1	9996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamE9mKbvSGWtUD5RSbJkWMGQqSeCsBGHWuYuZFwHfww8DB2nU
23257	payment	2134	2134	1874	1	1	1065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkN45eVDHWvF9TWrovmAeivFMbz7SRygNU4rN6ezQVt1kKhVgF
23258	payment	2134	2134	1874	1	1	1066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUT7kpeGA9q4NHArTYemDvNz8SFAHodCohchwgsKYNaChJH2sz
23259	payment	2134	2134	1874	1	1	1067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV32wbqR2iFcsKarLjUyV4dD6qgpWX1n2UyhiieyqtHqaERic
23260	payment	2133	2133	1874	1	1	1117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6i3M2MTAnEkkUrpqGCCX9EYYRLyU7biuUu29YeW9imfDcHHo
23261	payment	2133	2133	1874	1	1	1118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwwG4cztjHs8y6Tf2s93bCvGAtD1hK5kuyQmCgKNoz9wY3jsA
23262	payment	2133	2133	1874	1	1	1119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G12PypC9UZB8DPphzRATBqxZArj2i41Q5HM2bidEWCJX1YFg
23288	payment	1397	1397	1678	1	1	10006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YrPUHvX9gmQgDuuS2yfLRhtDmbXVLGLYcDEw5HzGcv4N92EB
23289	payment	2133	2133	1874	1	1	1127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCGgSQqyN1qNkNuxy4y9gedyLHpHEU2DhqvcB7kYE6trNvjYE
23290	payment	2134	2134	1874	1	1	1077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4d165Qdon7pyTbiXMfJxEMv7426R3tF7YfxkNXopFadGxZBh
23305	payment	1397	1397	1678	1	1	10012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yQPc9qijxHgPAU41vbqjBbA5sMqRkV7GhiPCYnsUaKiHESdR
23306	payment	1397	1397	1678	1	1	10013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYZQbi8nLSy7LqZjYa6qz8uX7dpHQCB1WuBRD8ig51HRygQMS
23307	payment	2134	2134	1874	1	1	1083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQiL59bNwpjhBrZtonjUt1sMCpfPBHG9AH4gpYX2NmY7piw1V
23308	payment	2134	2134	1874	1	1	1084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzxnRQ4kaX6Gg4jhvDZMiCurTv9tLyY1z3rd4RfBsMfaSr9tq
23309	payment	2133	2133	1874	1	1	1132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjWjg5SgkEXrQ64ZDpkMVM9GBMvciMHMxUNnjYPvU9tX8Eyzj
23310	payment	2133	2133	1874	1	1	1133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX7mD2PjFpA4MctBJUDLSf7uFR2SwKe5qHR7h9Mq91xRQnnXu
23311	payment	1397	1397	1678	1	1	10014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRebf4tfG1BoxJNydwtvY8SEiDGCdQprne76r7NvhEaWuf6pV
23312	payment	2134	2134	1874	1	1	1085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmtYJtskS9G42znxJDGW1kEwQtZPbvSkypywyaJdB7zJ2AuHH
23313	payment	2133	2133	1874	1	1	1134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvSCJ6PEsiRQspYz3Sn65bPC7ibo2WeKuySduJ91L7k7m1phM
23339	payment	2134	2134	1874	1	1	1093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1fHLP5NDe8UiBYwiRb534rMqQ69q1ssZEJi3svEh7ewFRoUo
23345	payment	1397	1397	1678	1	1	10025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhy5FUvXxEjgYAwERm5pWi8DxHiPxPRnDNzKGWakE5xz6wFaW
23346	payment	2134	2134	1874	1	1	1095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZGQ5FUHp8kSdmQhvKFQdttLSig4eq3bVdVMcVTrz9A3qYheK
23370	payment	1397	1397	1678	1	1	10033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5sGf47nx86ZEA2PdR7v1owSZsSNywHZ16qKhAdm5vGSkVLFa
23371	payment	2133	2133	1874	1	1	1153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkD8mnaihbwodFFCtesALadyuNJQgnbWk7YiqQrJ8o8Cx15dJ
23220	payment	1397	1397	1678	1	1	9983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYony7ewY9VpWtcNELNqjFpeQ1uGctbwSz76dLGnu7WQRK4c88V
23221	payment	2133	2133	1874	1	1	1107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9rZqwKG6PdTSEAUTgdkVR9pPKRha2Wp7JUjm1jN46iqVVBDS
23222	payment	2133	2133	1874	1	1	1108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVexE4A62QkCGyBbPiKoPjomWqi1QhGcEatFUb8bsFHWKjG7N
23223	payment	2134	2134	1874	1	1	1052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMv5LDtCZJLYTcZ4tE5UMJUf3vmoYHiEkS6kKUhySuS6ZapCr
23224	payment	2134	2134	1874	1	1	1053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5QmHjvTZj9pWGJk18pJwcEsLGWmDCwCAGtWbhprCqfqzykrs
23225	payment	2134	2134	1874	1	1	1054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt19VUTmoiwaQf5YX5uPiTNhTxZz3JcNiCXoBTDV8iFNZ5Cecg
23235	payment	1397	1397	1678	1	1	9987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD5T2amy6XFXyi4MmiXjW7j1GsHLGbym9VV5HZo8DCHy2XtyM
23236	payment	2133	2133	1874	1	1	1112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mAccX6SY7mkToxy82RLHTW8vsdtQjC8dgHM39Q6NpFae1AeD
23237	payment	2134	2134	1874	1	1	1058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAnGU5v2zsargaepYfdh1ta9hYogacyfT9L8SovgDrerbH3Zk
23244	payment	1397	1397	1678	1	1	9990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTte8Mvjny8AR8mWJLRKp9fKNRX4GDa8FXZQ5uUX2WjvWWu1HT
23245	payment	2134	2134	1874	1	1	1061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXBn5EHkKwqPqiukwwH2ytZ1EwSMLjohPqBYAF4gZgzTEC2wb
23246	payment	2133	2133	1874	1	1	1115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TndNzMZpXfap6QTsbQGpiG1tYdx8jMShw8GxdTW4q3Wb3pUf
23249	payment	1397	1397	1678	1	1	9992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLayvE6GhSNT5GZhGTf1yLYeuiqk75yzyH7TL1ydHsTqkPXz1
23250	payment	2134	2134	1874	1	1	1063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3nyd3ShcMWtc2fwwemS7stC3uXNZTJPPpymHCPnVDiNqyJEp
23251	payment	2133	2133	1874	1	1	1116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv68ciHZxp88sRsFJc7jXQE5eUFfxsc6u5jP33V3SuS7FxMn85
23266	payment	1397	1397	1678	1	1	9998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNkaaoJCqpAAcKiwxMyhTFgAUi8cCXsLwgqDo5ssQ6Asw1F21
23267	payment	2134	2134	1874	1	1	1069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMUxXfe3GZe8h6nXt3E1mxSBF8c5Jbvi5bgDwNfJ8wGbr3vZ8
23268	payment	2133	2133	1874	1	1	1121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51gxiqQs4UmAEKMdjmr66vtxtVuDnBmi81zVtdQj58DGc6tVp
23280	payment	1397	1397	1678	1	1	10003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbk9ixp1XzSNZg668kXv2jY8f727HTnJ4S4vpMXxthc9GYu3s
23281	payment	2134	2134	1874	1	1	1074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawVvtk6AmLX7FeovY2cZtfPjMb72BKi6BbwNszDy2NSHbbdne
23282	payment	1397	1397	1678	1	1	10004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupvztLTcE6VhXCDpgZUUQdtGVQagVZ7zFkBz4e5UZVCWCZTXr
23283	payment	2134	2134	1874	1	1	1075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8Qey21rw4HkJPJ6Bhmyz4VDSjfa3pQyYaifHzGpYDu1hD1je
23284	payment	2133	2133	1874	1	1	1125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFjdHvXUYkBZdeeC1KJfncVSEzLdExhmx3riqhLjrXBHXFhzE
23291	payment	1397	1397	1678	1	1	10007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwP3RicixGRZJPqKwFx5eaFWxHXS2kY1Gpz6HuF1jHmFHpw8ws
23292	payment	1397	1397	1678	1	1	10008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN56hswTD5iN2oKRwUghgAEgzHM4qPfdUk8x1Ed18v7K2G7yv1
23293	payment	2134	2134	1874	1	1	1078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGRDA4dGmGK9GtfYjDZypxDaAHroKgNbZTPthTq2xeiSVJqNj
23294	payment	2134	2134	1874	1	1	1079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S6AndaJyoThB8CZFwgpJoWVNV2Fopdu8MUJBrRSY6H5viZwU
23295	payment	2133	2133	1874	1	1	1128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6oNc5K1vHqLuH57RCWtuQ1TU9hro2SFUKche2EggHtJXMPxe
23296	payment	2133	2133	1874	1	1	1129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPquL44NcdZrazZLSa6Tqzna9bRtiZ6tjPTtLN4zVrwr2tYmY
23314	payment	2134	2134	1874	1	1	1086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5893ZQp5Mh9U58WU3owHVCmXW1iisVUzdizWEdyY2vKBZm6n1
23329	payment	2134	2134	1874	1	1	1088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3C5xkqvBqJLhxrG2AVVUTHXCdbftomBE6MACPwxbKHhLKCq5
23330	payment	2134	2134	1874	1	1	1089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtdBpXnZW8ai7rrAAEUSxBxLR2nWafT3iDgCZfmkF9mDs9R2z
23331	payment	2134	2134	1874	1	1	1090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXLjoD133xTufrbFUaje6TqukNJ5qS9J4xm5oDsbjxPkDmi4J
23340	payment	1397	1397	1678	1	1	10023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9KUP7XMSjUZW4T3c27fc5b9UjYY3NesczGYdCNxX5m2gaDKS
23341	payment	1397	1397	1678	1	1	10024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZbKdZvKsguLTyhjMMJVf5KEKPk9EHEztoAmBYb3sf9DQf9mj
23342	payment	2133	2133	1874	1	1	1143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZRESAsTXrvjsJgkj2BEp1zEzP11oCoJtemc37LsqxCjvkdSR
23343	payment	2133	2133	1874	1	1	1144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRRkAGzfgPqMR9C59v1AjCV8Ky8JD5jVMjiMkGcwKprUCrZ9kx
23344	payment	2134	2134	1874	1	1	1094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84HEdjXeFE3dnswqj8DpPEgHHYKcMkdwTMbpEoBRDo6o3Q7V3
23317	payment	1397	1397	1678	1	1	10016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuupa28giYy4dViwr3H9XNPk7Z8w3oaUnQJWLxiMCNHj8FeHkh
23318	payment	2133	2133	1874	1	1	1136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH1PNLAJEARheyA9w1wvz3abfNHGPnJrRzaMSJTbCgdkuim7x
23319	payment	2134	2134	1874	1	1	1087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsPcmkTA9rTU2KU4F94RVyyWJJoKBadUWCtrwu3zp5dpkKyyd
23320	payment	1397	1397	1678	1	1	10017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJwhoAf41mLB9BrRuWjkPs2kLc31Ujq5gwyH7bG6vB5BiikK3
23321	payment	1397	1397	1678	1	1	10018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmb51HjmpMXH2org9nJudaXphAo428xXnYPCYGPDLhKAd34kP
23322	payment	1397	1397	1678	1	1	10019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pMZ9rwexFJhKChRQD1sw7wczjR3sLpXTC4CYQM48YB1CNo5e
23323	payment	1397	1397	1678	1	1	10020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBD41aiChf3Zd44XHsYsWPNhXGKj4UvYSGyAP1nHRy3fd1xkG
23324	payment	1598	1598	2163	1	1	2	1200000000000	8000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfuoguwukNervGSBozKGyuwqGDmKmiZ55j81yvneNhkupDJEx
23325	payment	2133	2133	1874	1	1	1137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVbP8EDLVhiKmvfzu2WiM73QEnzbaw3N12rQznKubW4bkewXS
23326	payment	2133	2133	1874	1	1	1138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9L2WMnHDQcMgZsFZbe7hFpfghrpAMPuEodJxqTyqppUKxTq1
23327	payment	2133	2133	1874	1	1	1139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnELgyhWDuncEFsRf2QBa6S2XUzkb9VPkUa5ypBxfRwrKukjn
23328	payment	2133	2133	1874	1	1	1140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYmuqMpamKd83JUC9LuJgroFFzmrjNxKyyT5wMDRNNGYjkDQx
23365	payment	2133	2133	1874	1	1	1151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1W9aSGuo6fLSspH7cfJw3mkj8pghNJUBjWe2dabe9TBaSBX5
23366	payment	2134	2134	1874	1	1	1102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8HMb3omHwsyZtxrcwJefbFiF3RaBmBpvV4rqGhsFEegDCP9j
23382	payment	1397	1397	1678	1	1	10037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAe29Q6Gwq6Gnf1hbHkoctfQ1taJprg5wV2oMPoxhAZ8JvRV7
23383	payment	1397	1397	1678	1	1	10038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWnig9QfaXmzup9fa7nHgFtRjn2pniFj8TyYNWouupibu92ka
23384	payment	2134	2134	1874	1	1	1108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcntLmkNNKXhnCSHidy2GPxNkpE4EnMPqLqYzy7UGhW4q5yid
23385	payment	2134	2134	1874	1	1	1109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4YCTD3PPhhe6n9NyX4iT9tboZkgETTwciCcpuGgbTLCnu2cX
23386	payment	2133	2133	1874	1	1	1157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiwHAQYh1KyddM6GqnUs6gBHdSCbRPVwqUvTAL234E1BMrt6u
23394	payment	1756	1756	1516	1	1	3	1298566290000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4f1LKPVaZNKYjcfr1cdzGzp9b6w9HT6Cz7UAa5WpNE7aMkt2
23395	payment	2134	2134	1874	1	1	1113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4DdbqDd5BjFGYF9ndE7td2wYJCJJjPYZwFgU4w8rxvLKsAxZ
23396	payment	2133	2133	1874	1	1	1161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32urerPAoyTuyNhbDKVBmXdS2RwocimKsDZUc8SX1DNnC63fA
23422	payment	1397	1397	1678	1	1	10047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVw1F9CEu98RpfR4Waji72tQP7bcDghCCrDe12sAMuRXY9mwL
23423	payment	1756	1756	1516	1	1	4	176152740000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WhLJoToGcFNVv74hAEMo3K7dcK6Vsc8v1rkGxzBpCm9xCDix
23424	payment	2134	2134	1874	1	1	1122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFc7kSq6oM72Cg5o6a3H4g41au9nqQLzf7it3RqDPBRhaSCyA
23425	payment	2133	2133	1874	1	1	1168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbtAe7nQL2K6G85TSBcrR9JtXg7Rm594Fugqh2bhvfWsbKRG5
23426	payment	1397	1397	1678	1	1	10048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvErrL9TcU1QGNrSRP5RiND7GDFYaHiCeGzpxaAPhqt3vrThZ5
23427	payment	2134	2134	1874	1	1	1123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgonxF1CjejGbuspLghiAs1jARYjqwqsJK6DoVBPUG7cmu2YrQ
23428	payment	2133	2133	1874	1	1	1169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucnB9zV3hh2hdEo4u55iEPPXb3Kr7kkRx8h3V8vaf5tLgksJD
23446	payment	1397	1397	1678	1	1	10055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVock6fxsums1zwhJc7vGeMGZCKFTMTBcX5wJ4wQMTXguFt19
23447	payment	2134	2134	1874	1	1	1130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5bmU13Z1Atau6KEvtq3mbLpomiTXnW66YJNVf93kN2evkfXo
23472	payment	1397	1397	1678	1	1	10059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLzy76ygT9hdewRintHZyzPWPdonCiBq71tS24ppudHv6fzFZ
23473	payment	1693	1693	91	1	1	787	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZtfK3PBgHV3TNR22T5JTG6t7Th78phTP8JdEca8DzFCsnvVa3f
23474	payment	1693	1693	438	1	1	788	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYaaBoZUa2kBvMBNuecicLnEXRhepFnh1ygv7tKRpoFCubpjNmF
23475	payment	1693	1693	593	1	1	789	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYZMrGqSUdVzGre2F2L7DK2LditE5LGznsvpJHKBV4Jwnjocax3
23476	payment	1693	1693	408	1	1	790	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYfrzqbUYLKwMoMJmp6vkRkcCZvvRdoeW8eJr4MNbM1fJvuj9iw
23477	payment	1693	1693	601	1	1	791	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZHYapST4yjSmnggfGz2BLa7rKa6CmiQb48QeqwJravFgtGEftw
23478	payment	2133	2133	1874	1	1	1176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s4QBXTNLo1VGK5rvQmpZiFSvcNJj43K58nwKJA9Q3hpmP6LW
23347	payment	1397	1397	1678	1	1	10026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfR49hDhD6N3QSojC7uCCtAjqMi8LaJKnnHrdKso57bYy3VSJ
23348	payment	1397	1397	1678	1	1	10027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhvodtEtQP4YTf8ePPKqqURqsGGbhYZ6hiYNaMMUzHt4xG7gH
23349	payment	1397	1397	1678	1	1	10028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoTjBdaHGffmY7uhk7FUvGePXtn8nNULZpvPWwdzcXrkFhs7g
23350	payment	2133	2133	1874	1	1	1145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYtVNWxHs7xN9Hjw4TVbzDsmWPKd8oGtpdRF4YgvDsQNGFV3Q
23351	payment	2134	2134	1874	1	1	1096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPSPiMV4FPq1P4gPg88RitW3FWNkRXbDop1E2Y6TtAviuQcVh
23352	payment	2134	2134	1874	1	1	1097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAX8d8KGMTnq3qHTXRmEikqwgqbP5dzsww8FN8HmFrASU1mYN6
23353	payment	2134	2134	1874	1	1	1098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMg1ov6vpWXwhox5upiRS5ZF679rXQgj4dZDtDLRu9ZnVDEyo
23354	payment	2133	2133	1874	1	1	1146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpThMGAx69ktMEepXbZT2DNJvxRgrEWbAEpWL1Prhoe5KAGWRh
23355	payment	2133	2133	1874	1	1	1147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8Fkd2DJJpx3qcLrvaWYnNkJdPf34FnNbgJWMjRHhzkTbXp4m
23356	payment	1397	1397	1678	1	1	10029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMVX2ZKJfChZht9Gc9qY1JjUVSgGLz68STE2wtKb4h2KVQc2B
23357	payment	1397	1397	1678	1	1	10030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhftYhggCe8au49gn3JTnnBiYgewRUy8jdHWKN3FRm8UEqE6Cp
23358	payment	1397	1397	1678	1	1	10031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhhHnVTSJqJFbEaGBeM9iTzPM5ffE3QSN4n5Hwu1bMAVJFvb4
23359	payment	2133	2133	1874	1	1	1148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSYwT9fB9JW1BJX4ak33CNsKuebdMcUHMMFXGGxWWbQGGxwco
23360	payment	2133	2133	1874	1	1	1149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpgpLVByZYpjTuN4Q2UWR3E6nrfABWQ6MG9VeGFX1jfpQ7NQC
23361	payment	2134	2134	1874	1	1	1099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbRS1CAsRTB5WgBzsdQrHCWVuMphSq7tTMYcSoU41FdtikuZs
23362	payment	2134	2134	1874	1	1	1100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrLvi9UU9r64to4i6ejKKbRvcWZngatwAciFAKfUNVubpiER3
23363	payment	2134	2134	1874	1	1	1101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQzhjTKN7GYJNZzardnesVurJyAMGLzkBisFnfPynYEoEX5FG
23364	payment	2133	2133	1874	1	1	1150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuXwPdW5mRpGdtY9272RVPZkST1Et9HoRqud9UQZkTyZw6BCK
23373	payment	1397	1397	1678	1	1	10034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRZJ9eBnW8dokguHVC4vAURgqgpQg2Kqf8AAiVfTW8kTVPru9
23374	payment	2133	2133	1874	1	1	1154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVrpfh5rGUWSfjBmTqBfe9NzREKFAkNqXWkURKvdEHZbHoFF1
23375	payment	2134	2134	1874	1	1	1105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9hHLNVCauYba44NVUPDY89iQ5wubpL7L4tVwvMsitoEgnG7e
23387	payment	1397	1397	1678	1	1	10039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj2sjPxvU7zRCem7JwGdQfuSwbP5jaVnELCx1tGArht2qvHWN
23388	payment	2133	2133	1874	1	1	1158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEzafSwf3TenodmJzvBZz82ZLofdDrgGifmV4rsXLWWwVzduU
23389	payment	2134	2134	1874	1	1	1110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXtnA7KX18j1NKUth4tBETGePRqEX5Ve2GERPpG6fz5tgfg53
23397	payment	2133	2133	1874	1	1	1162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJrywuwbaTjfqrJRYLpjupZG2drhfJebq3TW6yeXMCEaWTh4R
23398	payment	2134	2134	1874	1	1	1114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzPFjSqrScaptTetS2x9bShiuW7h7GEHfdWpgLsQYrNzvQb5s
23405	payment	1516	1516	928	1	1	7	176152740000	100000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZoDH23uHWqAaCPF9HobftVrwJB14rKvJGS9kS1KahcTAYfWzNy
23406	payment	1516	1516	928	1	1	8	176152740000	100000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZPjsojYGnfreKtcp1dUn6TFJTDPfq2Jbs97LasywVnWdZXiYgb
23407	payment	1397	1397	1678	1	1	10042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB21TquzES4HRRMHEkTHpokPJfynfSJS2MpsX388LMqwftE1hB
23408	payment	2134	2134	1874	1	1	1117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N6G7B3VyVAyKwiBPdoDhHfmFSNNzMys3ikdQtJc2296e9LVm
23419	payment	1397	1397	1678	1	1	10046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkfo5G6f8gpd9XGu3Bu5sSd2F5rkWc5Z5M3RQFbhQy5EJqCxy
23420	payment	2133	2133	1874	1	1	1167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSAR3nzaT98GgLWyEUxkyHCYaDNudqSK2rNeNjE2t2bn3peFo
23421	payment	2134	2134	1874	1	1	1121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ9uHeTXwMusx2ZusJyPirnXfY3Q4dwyWADQKQAhGV1U77r62
23432	payment	1397	1397	1678	1	1	10050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78HyUtr1a6fpa88MoUQnjWc8PC2BLDayEHwB26HwTwdyfLSmA
23433	payment	1397	1397	1678	1	1	10051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXD8gAykuQJsCnGdSbWULDf4wXdhX1NDNHHPCpUXxrnsnRD4R
23434	payment	2133	2133	1874	1	1	1170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfavwNjHnZf6FhDwpLy4FztqkaEZrZFyPA1CeszqSspx4huk4p
23435	payment	2133	2133	1874	1	1	1171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvapXobjJkNNAKtNec6wfQg3sAP1a6hEVb5PAJESpZf2A3Ap7i
23436	payment	2134	2134	1874	1	1	1125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio6UfwnKgvmMdqRPXjhssj6jNtRLmFq7xjUb2ts5KZGnDZz9R
23372	payment	2134	2134	1874	1	1	1104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHskWpDhmDyCuRug61ETcLxdJwFfUNGUmdmSUU1sG4GbxrMjUB
23376	payment	1397	1397	1678	1	1	10035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDMY23hE49aegGuUWCBLM2hTjGeA3w1iCJuSryNqvPjAAHM4k
23377	payment	1397	1397	1678	1	1	10036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYBHzdL5qujSReFgYQwZWB2EJrbGys8SCLcA7gCVCsXMjq1cQ
23378	payment	2133	2133	1874	1	1	1155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpXzKi2HJ9PY4XsjvTcUVbHF5rj35XGw8xnE6Cgd4bqbX4Aav
23379	payment	2133	2133	1874	1	1	1156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLvqp1VwhX63B62YvUfwGWQnZz37hVr59fTXGU9Z1SJNLpmTA
23380	payment	2134	2134	1874	1	1	1106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzGnnhB2apnhsekC6iRRuAm3b8QM1hXNdXvFst7WXVBbStbWx
23381	payment	2134	2134	1874	1	1	1107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZJDajc9WaNvjNvB2hErjgHeQvobZX26KCXqEj58CofoQ6RTW
23390	payment	2134	2134	1874	1	1	1111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9NL2xTWekJbdwRBfqeLqT1pgnQntna9ZyeQWigboNH7JbWSC
23391	payment	2133	2133	1874	1	1	1159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MwEVVASN1oy6S3aQLXz5CpM4qWz37m3fxwepVDXhYLeDKc9X
23399	payment	1397	1397	1678	1	1	10040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5zAdHwnWScq1J2ChZq5Vtf8VtLW74uQopGpLzUCn7nQpFXCw
23400	payment	1397	1397	1678	1	1	10041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ejMyZRNbM4tiG8X92qzbWRKpagozcyHn2D1KP4xizfV4ceeY
23401	payment	2133	2133	1874	1	1	1163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTD876yjbkBoXvSp8ZwrK6xRMVEYBRrkfh6tpQy5LQ7Qj17Z1
23402	payment	2134	2134	1874	1	1	1115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5YjMVKqDxayjpGsXtiT5gViJqUzMAZ5YbUVyYXZrNb287vop
23403	payment	2134	2134	1874	1	1	1116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSX1VLLUUXZ7YmpPxn7oAbvE6YS7dEbuXD3VVm2nbtmgCN8ggW
23404	payment	2133	2133	1874	1	1	1164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8kREPqJGEe6SsogNgAbWa6edBjNyxnJpA3dR3VDHfY6aCykQr
23409	payment	1516	1516	1048	1	1	9	315585010000	150000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpYhySR1VeRtMkN73zCn6NUULKb52Amv6rWVyK7wqS16QQ4YGCea
23410	payment	1516	1516	1168	1	1	10	212964020000	150000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZDFSAvMZgZNhH4a557JB91NHv3ig1xCeeD4CdSnLoc2TyftEbk
23411	payment	1397	1397	1678	1	1	10043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujobgVkVFPazgGgjQaiAA75jn5AH4pdrYSo8DmP9gcJbLchhM
23412	payment	1397	1397	1678	1	1	10044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckmWQrpDBcnLNGMjJkJRLGGtgcBFtHRmFRuW3oJtgxZKEyU7n
23413	payment	2134	2134	1874	1	1	1118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwj73YVUB4CEDcif3tW8sZ1Gzo4Wfa8X3zou3jN4u5Jr81Mmv
23414	payment	2134	2134	1874	1	1	1119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5rS9sGNkW167dRFjLiD8USePvuxj11WebLdVY9QrpyaZ3Yg2
23415	payment	2133	2133	1874	1	1	1165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcT1cHVsUyqYd4TcWuaDfJoneWMyitWtxW6LmQGxK3kJwFstp
23416	payment	2133	2133	1874	1	1	1166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEx3CiJhtthHmHb7Hmr4X8LF4vcG5QEodFd42EMgCdDZQVtijm
23448	payment	420	420	2164	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQohxWQ1oxjfepRUk7X4xjjxD5cuaoceFEvynTnL4WQSqXKxc
23449	payment	1693	1693	352	1	1	772	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZV2jWXKVbJ4A71Zdm3itbyiSQB7NaDvfxJoSeVR6xZNUr6oG7J
23450	payment	1693	1693	600	1	1	773	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYm9TSHphtnMnRkwxftKH83frwKKij2L1kjoVJf3JvmuMZmQsbL
23451	payment	1693	1693	620	1	1	774	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYePKeZHXf8Yo8nyGwLeCWG1oH2RBC6w8c89ZbgzDNiD19PqixZ
23452	payment	1693	1693	1150	1	1	775	764128062780	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZQHkVVrYi2YhMmwdJ1pcRFPUDYtufUaZ6waFiz5NoTHMryjkB8
23453	payment	1693	1693	1811	1	1	776	227001554708	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZVbdNjdfEbByTCwiM44YFsTay9huQB39LZitU33usA1Lvbzn5z
23454	payment	1693	1693	84	1	1	777	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYV7D1aQARVVCBPhS1wVy4L5vNBwiQ7Ka9cYMCJhWqXfTVNc9bL
23455	payment	1693	1693	2017	1	1	778	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZX5uT6zzjNP64oratsnEJp4iJQ4n24vJS6sVoSNpVDNhZKc9tM
23456	payment	1693	1693	520	1	1	779	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZhWw64aDs6iEVE67zC1JBPbrEo7mmcNdd1NFYU9T5QGviMKaZi
23457	payment	1693	1693	89	1	1	780	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYoJY1SvwpVsujUUcfGMJw5i1JsU9FpDmUGtsH8VM72vxPp9Nb3
23458	payment	1693	1693	186	1	1	781	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYmVC5KQEfWSu865bDbAQGgQCUWF7hfjLGx8Fvz8pxwsiks2cCo
23459	payment	1693	1693	383	1	1	782	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYiDX8F7gcXYpriGHS8quus98C1NpgsUKYCUiUMTWVLvYRFdunD
23460	payment	1397	1397	1678	1	1	10056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXQbzScza4hPsVQyGHWoxQsut3mA84yYFoR5KngDkQtbcr1bH
23461	payment	1397	1397	1678	1	1	10057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3hKuueCzPxXh1cDdEPgnBNsC49aiK3NZAJoKFP3PLYsJ1BQ3
23462	payment	2134	2134	1874	1	1	1131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCc43gpCxbuvmqCSxV93XDfFmjiwijuF8n7Qc45kK1XS5XXp9
23429	payment	1516	1516	1294	1	1	11	593264520000	100000000	\N	E4ZCVuxjaB6fRpQNomLVumZGFDnFWhm3uNrU4iigiwp292xBGkuXP	CkpYnpcvcb3j85yHzg7ewyPRgu7KxA7zfgkt9F7FECKoEK79v992k
23430	payment	1397	1397	1678	1	1	10049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5bRYoDtAjSwarn71ZmDRfxnzrpSAikwYiM5fBAypsht6q22y
23431	payment	2134	2134	1874	1	1	1124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSANRQJuCPupianPKKzStXJEp7oKuzmMFJHPzHU1MFbjjCFd8
23438	payment	1397	1397	1678	1	1	10052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaj7AhuXdmMuSDxbm5SmH5Q3fYJxi3FkGHG6pDCv2fYTqoYQD
23439	payment	2134	2134	1874	1	1	1127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdUABZ5r76gZwVN2szDVs53pm72Ts54Ftq4iSnrc5kZFgHzDQ
23440	payment	1397	1397	1678	1	1	10053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S9MgPHgxLTbq44ELgb75Rh4d8Zjmdacrwe5RD8f8Aw7fckSP
23441	payment	1397	1397	1678	1	1	10054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSZi3qTjL28p8SCKzjpbJhNVTp9gZ1SfGhWRYHtBcy4CQuwXs
23442	payment	2134	2134	1874	1	1	1128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDLQnUrCPnsqHQhXZfWrvNGg5amjU3fvS7zwGkmLEYjLTwEfs
23443	payment	2134	2134	1874	1	1	1129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFNYEndt2vevP9Rkc9WzNz66881yrkyTUYThVaLuycu4RW4uE
23444	payment	2133	2133	1874	1	1	1172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVRL6dQvE1J5B14VAmkdDE3APdSVDpakS9nCNdhQuxYRP615U
23445	payment	2133	2133	1874	1	1	1173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dFAFgCFBu2wG5SZQnZHixGJrnyJ3mpXu2qZ462PshLukcvEf
23466	payment	1397	1397	1678	1	1	10058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZoGfUYwRxwEVbQcJJMiSFzLCdqsYyDoGxoCHXPcxzA9vNmfV9
23467	payment	1693	1693	392	1	1	783	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYdnbLBzC6eSkRagCw4c1zHE61J2AUrprjMkLJ6NUypX8S7qFcy
23468	payment	1693	1693	308	1	1	784	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZU9LLsYV6jfWakVBb9cnSrXsHAg8VVxJoSVaAYtLHoWY8SoKPG
23469	payment	1693	1693	551	1	1	785	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYRJKYQi6tm8FFYe9ehCFgXRaAugK7nkvPRvPprp3QFrSuFUzuq
23470	payment	1693	1693	678	1	1	786	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZqw7MoABKfxjbjRjxtDiNGrKvpMdYjvNkcmLn22ZpkfD54Jvpc
23471	payment	2134	2134	1874	1	1	1133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTt6G6HowFVFg3gpEPZrrxzs4yehSsBm4TMwpMiHYo6CAbYZcD
23532	payment	1693	1693	54	1	1	826	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYu7XuqUZswKV6GnRxBqiXr1eE85KHwEoAWyNZPwwD6Jnkg2BnW
23533	payment	1693	1693	710	1	1	827	6285241536	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZxjornQvFuwEBhqj2Dj4jS4CxfiZWVtx9FCJZ5i2aJMgUZudco
23534	payment	1693	1693	499	1	1	828	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZPNcxLs84fdH5VXfXpSj74mXJvtSiSADJBa7N7WH1aRoWB4jMf
23535	payment	1693	1693	721	1	1	829	2514096608	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZppc1ddb7V1g1ci3cPo5MLAufWzcPTd53ioPF5qUGharxLoAwW
23536	payment	1693	1693	103	1	1	830	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZsdVEQQh3AtzdiRP2SHveSNP4eui6NjrHEwMdXSQAaKP5G7X28
23537	payment	1693	1693	217	1	1	831	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZtmLsR7F8QajfKmKpUJGnsWvR3oD5s2mWcpq5X4GpNPrabQeXE
23538	payment	1397	1397	1678	1	1	10066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqaQ6P4TwV537j6AUadtDGVrgbXMxiS249EdsBnvjVLpa7vWj
23539	payment	1397	1397	1678	1	1	10067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTtYYfPvcRFwbnZAcfEQRvDYU4dNdmUSCL83jM9asQhTGbNts
23540	payment	1693	1693	893	1	1	832	385691228416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaEjqiq8dcXDpjzvj8VZnWg8F5nEN8wkn7tYQhSRikFfQKx9v21
23541	payment	1693	1693	251	1	1	833	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZbYuxvvwUW8ApGatZcs4Y7v8j2q3NAf9sshtyjYVTZ4tnm6ybn
23542	payment	2133	2133	1874	1	1	1183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaS2mgukQzEdLLWXSKvrhyidjSTLTDF3nvdCQ3edvkLWJJhzv
23543	payment	2134	2134	1874	1	1	1140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVrHQEqZNiGQGWBRyxLzSMio4yAdFrYnWGGEkmeUPn7QveqVo
23544	payment	2134	2134	1874	1	1	1141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbHaNqJVP3hhfaQRNoN3GMzKHwKUFFzUNT27BfMyeeda4Qse1
23576	payment	1693	1693	82	1	1	850	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ5Erz5YXYYUsBJzMhcJiyLkRLDoRwoV2AFGos1azd6CugvcTLY
23577	payment	1673	1673	1242	1	1	8	500000000	10000000	\N	E4YkxNha8sZLHffMgj2r6ZZsHeKbRjvJry3FvGTrrMtjp8uHECXeU	CkpZfJHBB2c7SgjKzvoTc1wVgT8arGZNYWj1vyDmPrVSkaRAQP2pg
23578	payment	1397	1397	1678	1	1	10073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkDnKSCWAq5KCnwNy4GXLikDhjsofshGkUgb3hegFjztqZrHx
23579	payment	1397	1397	1678	1	1	10074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj72Fci6GJ2Guux6aaHc5EbFdQsrgULFoyGi7nr7F8UYmXZg8c
23580	payment	1693	1693	361	1	1	851	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpaCjYfHa7ik1yorwo7UvRZxQNqykkAPjrormD5Qv8Gq6PvJRUj7
23581	payment	2133	2133	1874	1	1	1188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpKaB8x5CBRAX9Ut8AdCuL6cBLbZgKeAdeC24Uj73spa9yPZM
23582	payment	2134	2134	1874	1	1	1147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy9oX2kMh78E13TvkQSukXU61NMDqdTBQYkvoLoaLqCJ5o6DJ
23583	payment	2134	2134	1874	1	1	1148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeXR5kng8dioEu5J4i4VE4fDxkJTMtQ6Hdgj36Yn4LB2W4FVf
23437	payment	2134	2134	1874	1	1	1126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32yoEqxVg2gRC62ehmXeiAvL7xag5KWxLBWFe3hPpbJBWTVK4
23506	payment	1397	1397	1678	1	1	10063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpJgxStBUumL2w7qGyTZZ9bhNq9vUu2ShLuJvSRPpg6UQ7fYK
23507	payment	1397	1397	1678	1	1	10064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKWtsegxGX2VWLjAqWHqSPJvkeJaVnhXKg9WmMRXzBbsJTBcQ
23508	payment	1693	1693	504	1	1	809	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa9YbTa1ZeTxD6HUHNxZtfsGSDKHz5nN2SsmkdmVQQ8Fyg2sddL
23509	payment	1693	1693	587	1	1	810	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZLYU2piiSwXSaMQqGiYvtKYofNVBrFQEWELQ11TZTsG31zi91g
23510	payment	1693	1693	1961	1	1	811	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYuXT4dpbRc9TxaiUiF1rfZzeCUaYLGtnDfa2owQpVzFHTEX8NH
23511	payment	1693	1693	611	1	1	812	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZpB7nEbou5SCWcMAEj1q3W4u8YXyJvq5EmK93eFknHzZATtSF5
23512	payment	1693	1693	205	1	1	813	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYncJYLy3p6pmgmczGnuhnNbJKLtc1R9o75m7R2AzwzP9Yrw2d6
23513	payment	1693	1693	658	1	1	814	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYhSyCFhCRwDa5iTwoW5jupJWH1Edeb1nT12b3kA71aj9ubbG47
23514	payment	1693	1693	78	1	1	815	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYWJ3puEswGCm2yMatx2GrzL5BmtyeiVbLudEH58X4MFyf3XiWN
23515	payment	1693	1693	660	1	1	816	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZgoZDJteKqUgappWh5d65PcqTSZMsx1HQyoL1ajPHMRfqkqGL7
23516	payment	1693	1693	1276	1	1	817	2129310789400	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa8BQUD8kRkUMCVBDfNwqs69jVqaHEAQ92p6UxGEdXgJspVBj7B
23517	payment	1693	1693	194	1	1	818	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZvynKwBoMv3g5qhDjQ3GMUcZpDAteRfcNiBgHbzoKtSQTVNLme
23518	payment	1693	1693	105	1	1	819	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZAcFHt8DXTjEbEYnT48RmYrAvRr1MY5BezG9F146CGeH9N7MAk
23519	payment	2133	2133	1874	1	1	1180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwkzRBa21eYC5bQZ3hxG7eR3z83wTPsxoxU3LvGEUk81BnXuq
23520	payment	2133	2133	1874	1	1	1181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbvfr1mpbybYtSAt9D5AnFpV8YQYao3JD2FaCjcWcXxq1p3qo
23521	payment	2134	2134	1874	1	1	1137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEvnuBMQgndac4jd5fB2w4A9dZ86wX9DFmNRRFRwqF95FNa5N
23522	payment	2134	2134	1874	1	1	1138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4ZpfCMrNaaqahu9SJeBTnuEck7rL7eXzEhM5mvNx9L89NZpz
23573	payment	1397	1397	1678	1	1	10072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSpdkpqHGjLTQrhQNAGPyLDshD1keBT7aLbo9KhcZ6biFZL4r
23574	payment	2134	2134	1874	1	1	1146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGhCEam6TrEeiTsDu5Fo9G87wc3K2qjwmSgraWeQ1vopybbBV
23575	payment	2133	2133	1874	1	1	1187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhkyALFpHWdiCshovQPWKoxbDCHmL2TuvB55sLGZa5fDLZ3dn
23593	payment	1693	1693	397	1	1	857	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYwVePTGQczmkQjo2VDCG3Hzpyo5i1FMoRWKDw947f171MxEdGZ
23594	payment	1397	1397	1678	1	1	10076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3qmS1UZCh16vT89F8LqKZNkWV3af1JzCmd7cu9MYTb5DtWpc
23595	payment	1693	1693	402	1	1	858	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZrQYoPv9nZXnUYWS8kVhqZt4uMnMsKXYaXWFupgrtjn5WWutxP
23596	payment	1693	1693	391	1	1	859	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYX5PiJMNyWtwbMwTDNEtuLX513ndEh9Nqpqf2nabbyRasJtXTD
23597	payment	1693	1693	452	1	1	860	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZXjXvkdNCgGa4E9BXZ9UP7gSCcM6NKr6fs68zNXQBY4w3p478F
23598	payment	1693	1693	2073	1	1	861	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ2boTLm2c9FQq1MPp9xzKfygceaf7r4nhDvApopkZPQupmJiKk
23599	payment	2134	2134	1874	1	1	1150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFyRNQ776SDgz3HH3MjUqq6DpXhYam5ce8PrHCTCdYEtUYfxp
23600	payment	2133	2133	1874	1	1	1191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9L3AFmVz7uBNxRmJRFbSQQq2SETnsaazZ7KkCLccKmaQTXW1
23617	payment	1397	1397	1678	1	1	10079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbFtTmtGkLfbnApEmjZn9znWauMDBFCBMV6Af5Q13a7posjCD
23618	payment	1693	1693	191	1	1	870	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ1QZNLY19R2nYdvXFTLSbYBYEPMuQqHkJS3MaZdKQaWR5ZvW5L
23619	payment	1693	1693	266	1	1	871	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZdCqSXqiv8QUT17XqPUMXhK4ef39q7XeVwHfmtatfwUK9JCvJo
23620	payment	1693	1693	534	1	1	872	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZDhUziECTE5GwpgvJYp4mxPpSzs6z6neMwReseN3fNV59WTrcx
23621	payment	1693	1693	245	1	1	873	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZByNz2YxafFwfcJUqK74pcrhhPznvEogSHvDP4RZ1WHdH6Ybe8
23622	payment	1693	1693	421	1	1	874	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa3ygWKD6gJvMDLqav8PP9ASDe5yPe7GjdW1FqtammZRJyLMsT1
23623	payment	2133	2133	1874	1	1	1194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPkQmPw551V56dZLnZt1Ncx8A1LJPonrjThJgxzLFHufmyWvV
23624	payment	2134	2134	1874	1	1	1153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86iVicjiKgJJypDHU6z6h9btRGV42qy5w8Nj2xvk3ibVExorA
23631	payment	1397	1397	1678	1	1	10083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfx7vJVUQNmBLgk4gK7xD9jbLQ54meuAT384M7HoVgDY31SVg
23463	payment	2133	2133	1874	1	1	1174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YHzJGi7minKvk5BH1xhDmq7erWU7kz9qicGkbTiZDAvLyCC6
23464	payment	2133	2133	1874	1	1	1175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqPigo2Z4b44zSLERFsVvJ57ReA6wTvdnDn6t13PEubFYQ6wC
23465	payment	2134	2134	1874	1	1	1132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEormBjcDCyvEQ13iz3BGFymusotPFDzCwNeWs2xrQdFuEXJBL
23479	payment	1397	1397	1678	1	1	10060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A4gWbkb3KvqxCG3VKzLPAdZHVoP8NCr52FMsz383ASkbgKXT
23480	payment	1693	1693	691	1	1	792	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZmivSPQU5q1LgTE4n726ba5qXHuVTcBKW8cteYDP7iPBfm8yui
23481	payment	1693	1693	339	1	1	793	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUDh7xi3wBKBTdDGK7Vq9CnjLckVT3SWBedSvnPE8CTVvuXcx8
23482	payment	1693	1693	745	1	1	794	2514096608	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZE7Z73s6o8GDYUEdZhTYo7PdfHyYatmqvM97MKrHb4scQXjQPS
23483	payment	1693	1693	63	1	1	795	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ3tLsXHC54TBTRwC2CJSJnDW9eogAz984MQjjqX1WfLykYSD4B
23484	payment	1693	1693	1772	1	1	796	593460467759	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYj9gqr1ZPuhwc3HakZW2CNy3E99ZtUuntX3F5fivJVHSSxmHGN
23485	payment	2133	2133	1874	1	1	1177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYei5RSvVVTfvuPQBN46ZbCzoQpqyD2gZgu8iij7u7HMhgqZaoD
23486	payment	2134	2134	1874	1	1	1134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdk9fygGTtmFYwnoj8i9CH3B3rjyCPXxdh2zPexzRjxtK6NDTf
23523	payment	1693	1693	122	1	1	820	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUxNWGVWEUZpLELLtUhFwymxpQEgqwjMUYX2aoyNwpYJz67ryC
23524	payment	1693	1693	622	1	1	821	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUqzYA3jUomW7rVH1Yu6sAY77di95ASFmbiEnrUkhUNhFRcgtW
23525	payment	1693	1693	653	1	1	822	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZGpZZpvs4QgsfVKJ5Egh3pmVbhhFP5Pwgx7rWD9Dnn1DrFTW8o
23526	payment	1693	1693	304	1	1	823	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZpaNQcYAP7nF5izpFX23rP3idhbRFAL3tUr6r9vTQX73FnX3Ad
23527	payment	1693	1693	206	1	1	824	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYW1d4RiErJbpVtHrB35RgigEGDoY2fqe6JrK3JEuJA21MwkxqV
23528	payment	1693	1693	399	1	1	825	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYx3sEAHzWTLW9ArS2h1H7axJQ71waSoU5BHmy3xmJATqDFCVi5
23529	payment	1397	1397	1678	1	1	10065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa78jMZmDMhqTeZoaVy5gBuP3FRYLybZ8CCRYah5wY6xrAQZGh4
23530	payment	2133	2133	1874	1	1	1182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngthdc19vsxsAeaSjtmJzGtKeNqFN9q1C89kRN9EGXjckryYT
23531	payment	2134	2134	1874	1	1	1139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpLKmgL9QaheCB7UC7q4Nv5M3NTztsJ41LGVoHEYdJnPpBWY1
23545	payment	1397	1397	1678	1	1	10068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rcN42oBdZeVs8sjgGqj2yq7amLxfKB8uE82A9gmL1ZzsSYwg
23546	payment	1397	1397	1678	1	1	10069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55cwk7jNa5jKJ4H94TA6T3Z5aQ4mS9hDYr47Tc1SSHYga3R7A
23547	delegation	2164	2164	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLUR8YD3mv7RCQ9ikiDZreFws13SyHUcTbgHU5QgGGtpUePop
23548	payment	2133	2133	1874	1	1	1184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2heZmCbLnpS7AoEwNGKFBUcfCci5j6EgV3auKzVwVgvsfMEk
23563	payment	1397	1397	1678	1	1	10070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERTwUDb3rnaem8TBm1uFPqRVV4DPH9iB9NEauggSkX9rEbX7h
23564	payment	1693	1693	225	1	1	846	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYwVTqHeR5mvpD13z6HvJSRQrhW4ZSTpnRzxHNgupb3CZizJ2o5
23565	payment	1693	1693	560	1	1	847	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa7XTzuKSP8yJU4xyc1QzxEbFyS5x665rZStnmL4hJAbDMeQGEi
23566	payment	1693	1693	252	1	1	848	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZEmXjy4935DdoHBwQqzP89EM3fHKc1R59hoMgYmtD4jri79p5j
23567	payment	1693	1693	163	1	1	849	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaCwUebDBbxokBqkunCpqaZ5NQSiQBjMrmZFuFrKcnMc9xhLMZm
23568	payment	2133	2133	1874	1	1	1185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbpLnUWkc3PdGE9b8LU5Fyee7T6uPHeC7pgYstpaF9TPVdHM1
23569	payment	2134	2134	1874	1	1	1144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjoNNTq6TSgdsavTou8kf2LGkRGrNEH12HTdpQCUEMDFeyFzG
23608	payment	1673	1673	1122	1	1	9	520000000	10000000	\N	E4YkxNha8sZLHffMgj2r6ZZsHeKbRjvJry3FvGTrrMtjp8uHECXeU	CkpYdeP3Lcg7CcRDjgaaE8gqqDEszEcbWR3zz6P8urbs9o4beKLMW
23609	payment	1693	1693	112	1	1	866	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYibRxCUWu3QDutga7KLrL8JuA1uDBj1cjXATvj6z8X2xghZj7o
23610	payment	1397	1397	1678	1	1	10078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA19RBTcbgFhzNqVNF2zBKWF5QYTFZUAkFLnW6HTHTk79AdMS5
23611	payment	1693	1693	353	1	1	867	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpaFpzTcCW5ngezQez7EPqrtjjs7sgBDL3ME1aocDJM5zTz3zGyo
23612	payment	1693	1693	652	1	1	868	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYowdb7GuuVAuUNxqfzTthZiTRcTtUCJqtjUW5Lkw4PMRTKKkV9
23613	payment	1693	1693	420	1	1	869	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYwb4qGAzGXV8qzUNzMMWZumzhjEc1PB3sqGXooLATTB7sjyjqZ
23614	payment	2133	2133	1874	1	1	1193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVcAmhRrGNmWBha8SWraJc8N3ecVY4JPVbccZXjcqU6g1rsV2
23487	payment	1693	1693	92	1	1	797	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYZ6jcMe1y86HgN9AEZXZcwE4hWebuCoKSHH2ZAKDatGKm4K1cq
23488	payment	1693	1693	150	1	1	798	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYiwn25bYZbKwaSb8ZVyBUwMdvYMNZi7PRf4HqpLf7rctkoiBQi
23489	payment	1397	1397	1678	1	1	10061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGK3zs7RkXc6UcT1igpoJYVpMkZyKWFm2nyaw18QVCS3zjn3bx
23490	payment	1397	1397	1678	1	1	10062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6hKYYiGCpkbYwFDWTwvFLmmS6LK23AQQqViMma7wRwzbe6nQ
23491	payment	1693	1693	373	1	1	799	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZTpvdusrCQRsCiNoeVUtJo4fN7kbiyLABKdcFxn1CmM3Eid8qh
23492	payment	420	420	2164	1	1	1	529100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVmHFMY5xe9inYvMzwYX94TeQksXz3oRwFakE7QsG55GQDL2q
23493	payment	1693	1693	322	1	1	800	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaFKQ4ZTrdwgoH6Q57M1aQvb17YYcPndH84ADfrM6ZMTDnmJkMT
23494	payment	1693	1693	453	1	1	801	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYr69fJjuTtkYmaeogz6HzZbMgK1wwTQJ5uDcjWS5FWTZYbzg8q
23495	payment	1693	1693	450	1	1	802	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ1QpN2NyTAjhXsTAdzMBrc2w93SXfA6wNbvHSwddKci8cNpMBM
23496	payment	1693	1693	395	1	1	803	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUBBXCkHakADv9A1BbVZ7koFxoYNjeVxSNcGNoENdeoGkGGc5Z
23497	payment	1693	1693	29	1	1	804	8799338149	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUTjAQip7KTmd4buzv9oe6o8oxEuwCxox2cohNZssVzb9FP3tJ
23498	payment	1693	1693	138	1	1	805	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUNRftMpmMkeHmgb3NMXNS4PB5JGX2QbZUUvokyj89S3vS2vT5
23499	payment	1693	1693	910	1	1	806	631984874620	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZhxpkigpW45ygmJnp2dTd63pMh6ADPKezVv1FEZtwtB5xCaDcN
23500	payment	1693	1693	500	1	1	807	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZQ6L1A7W9RLui7CncAAhGNrqsr8uAthnyTCTrvUf3c4JfbAB85
23501	payment	1693	1693	146	1	1	808	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYhgPSDPGa66fFUCSNAQhfwfvdnEKMvSrbf5262tFFqgzxefw1v
23502	payment	2133	2133	1874	1	1	1178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgydRhLsv18VaFBkZTVPy1A4mksm8ZNGFRPcUFkr8c91rPrEXr
23503	payment	2133	2133	1874	1	1	1179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTU7KyTYJYrCfMagbhk9DRWST9kBXzzCsweFuNkZfZrtREi7m
23504	payment	2134	2134	1874	1	1	1135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyFR3vSF8vN19KzxgVUJumBg9xAdrr8jGZtTrGgczhqpn5hX5
23505	payment	2134	2134	1874	1	1	1136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj8Vbk8wHp551hbEH7da79swC8tKFd1mfYrb4BJfgcM73Bo4u
23549	payment	1693	1693	35	1	1	834	24135327520	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaDYSYouXFmM8R17YyJuB2Fdfxob4BQP4WW1n3xyHwAH4LxToYL
23550	payment	1693	1693	49	1	1	835	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYRymioAqdVxY1Ake8mABHALFSa1CXkQZf4RYkwa6wbZYXb93oM
23551	payment	1693	1693	320	1	1	836	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa4rS6Zc8e7XYves1YQLXSiXpyicFMScU8MLz7DSeJSYM19k5DU
23552	payment	1693	1693	1030	1	1	837	1132511480500	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYaTf7HLa787vBJJ4b4iZQb2ofS9NGQBcU8Hp2BLfaCjTtVenDB
23553	payment	1693	1693	569	1	1	838	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZx72dpi4qaNC2MejpMYrzuyiNUaoSCnyAfR76MpA7Gwn43yFxK
23554	payment	1693	1693	663	1	1	839	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ4ekhSwRLy44P2KTUUJWBmkZAg3sZbNKeeEEzXYuqaaEpMCeCy
23555	payment	1693	1693	108	1	1	840	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZYujmzDSXE393rrBE27RJvHZYzUBomDnSNMUKR4rwuprBQmLVk
23556	payment	1693	1693	390	1	1	841	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYQVJRwVCo8GpeQrPE2yRXqm7T9zuj5F95DkSEYeEoJzztA8c5h
23557	payment	1693	1693	894	1	1	842	385691228416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYsX2hQFDWGNBbzZdJdB4mBkKcuGsTDM7dUrAiREQ5sSzpk6HbT
23558	payment	1693	1693	570	1	1	843	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYri8Xg9xR4YE6dTruzfFqBEwxPBgcpx5edub95q3rBN4dTA9Qp
23559	payment	1693	1693	99	1	1	844	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaKJDLsTAV5EGzDRfZjrWQEPsPRXksCKEBN5J3wxwE9A8djfmF9
23560	payment	1693	1693	377	1	1	845	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZA1boAc4XEiohWEdjC3iB9RvHRYbYFPAvF9tqoAVxrCmW8dNYA
23561	payment	2134	2134	1874	1	1	1142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoozdjfwj1sWFBy44sL9j169NsvrcbmDTt3ejq9hBRrzLnQNr
23562	payment	2134	2134	1874	1	1	1143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDmXM5d4mCEBBQah65mdknB8waMiXs8eHfyV2amTt5pnfnXDs
23570	payment	1397	1397	1678	1	1	10071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwu7c19fgJ7j6JztukW9CUk1JueXdkdTYBtNxDcGnifYc6LicH
23571	payment	2134	2134	1874	1	1	1145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGjCYv9vGvMwSUU1ZM73RvAMPJarBmK1zpQ8FZjciNzKWRxnx
23572	payment	2133	2133	1874	1	1	1186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAmg6QEgqvfsBJe43urNc92uHNcNm2ZRaAraXLJtRr87sfB9d
23585	payment	1397	1397	1678	1	1	10075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFvFAUxXUyxK9mqUqoXmLhEXacbjVpZLsw8soPYtn7qGVJrDR
23586	payment	1693	1693	594	1	1	852	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa7vzNCuoLKnUuLTmwX7ZNGZ3xenfJmbN5EvPtwCBtWh9x8f2ou
23584	payment	2133	2133	1874	1	1	1189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZF3N8rbMdyi3KjAPCpXEjS2FbmCoPQqbwgQTwbhpLXzRVf2t9
23601	payment	1693	1693	680	1	1	862	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZrVgrYQb2bsR5howDt5UK8L6XcFbb2ZvptUj9ThGzzA2AHXaaq
23602	payment	1693	1693	690	1	1	863	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYsNcYNaHWSxTXxw3ZvBNkM1RKThEVgadXwVWZn6Hc6FPbFAyXr
23603	payment	1397	1397	1678	1	1	10077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvje5CwrbqbA9QsApJ6A7FPRuEJpuf3EnfDSiL911op24YidcV
23604	payment	1693	1693	731	1	1	864	2514096608	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa76rKyPnxwvn9shhxSW1MLnmbTbmqBpZwRJEd2HWYntEZi4TGF
23605	payment	1693	1693	180	1	1	865	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZhoacaW1CBrjhZRuhCfq7YU6XxNhivumksBJzvFbaRwwUMKo3q
23606	payment	2134	2134	1874	1	1	1151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS6EwfZckxuGvAzns9676wnpsXdeFfVBZ95TYRYC5fEmn6rUV
23607	payment	2133	2133	1874	1	1	1192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBnxau8Zs7qNH1ZwUMN8RsuvXfJCYpEgTSTQwXez7WmJVGcku
23625	payment	1397	1397	1678	1	1	10080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY66NFfTVSsXTv4H4B8kNs6wHfiKZMrd1zLsqpfyAJbTRfQgxW
23626	payment	2134	2134	1874	1	1	1154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizwns4fTB4gaJfy4ajWvkEzjxRLmRuixQbpBgS9qgvbHCbx4p
23633	payment	1397	1397	1678	1	1	10084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLBsGmvxkKVy83Uc3W5J2d64XWtiZ2EfiToJT9ivbH6J27Tci
23634	payment	2134	2134	1874	1	1	1158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtqE16vgrgFpdP9aTVecH3LaFZwkvbPJcGeKRzXBFczQUtNx6
23682	payment	1397	1397	1678	1	1	10101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYAapb3wrgS1uUFZ1xh1PHqtvQSKTMWSfMnQPWbj89aBgRdxp
23683	payment	1397	1397	1678	1	1	10102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoMbhSwKv9YFvN8dvLa93LC7WezEYrNMBGqd9nejPy7dmRM7o
23684	payment	2133	2133	1874	1	1	1209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGP6G3mxDqv1E1Jrx1jkHdosg3tU5FNSoRSToAztoW6cv6RtkA
23685	payment	2133	2133	1874	1	1	1210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv544YdxU7Y56HeBi8Qbu798oYN8JA5WwzoDZD7wxXEG4LbQh
23686	payment	2134	2134	1874	1	1	1175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gw7kK2iJWmFb77afiFRQhNusQg12BTkcDWYhLUWnCSSZ1JKt
23687	payment	2134	2134	1874	1	1	1176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa442MVGqUCCpyCVWqxwQSJU1iqa7ovcvKfvDRgZ6LpMuJ1pBJu
23688	payment	2133	2133	1874	1	1	1211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKAPox77t54HuViQoCv65qkSwZB53KiUdGsCjtRVkuJEQTBQg
23689	payment	2133	2133	1874	1	1	1212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzQDXkyDw5hZ963oLb5qLmSCSBxPPxgjAEbpsZomu8ddTzfHi
23713	payment	1397	1397	1678	1	1	10110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAo64HbkjU9Umb1cTXsLJdQ9K4EqHbJKFpZcHf5aFkbWt3Vdp6
23714	payment	2133	2133	1874	1	1	1221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5vTuMPWg6FjhvS5pbcE4Rit8tJUmtcxeVkd945etGvbmt3Hd
23715	payment	2134	2134	1874	1	1	1185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmEr184RXRf9D27YXrQ1hDnUgajQnDutBVwKbLnhZXXdeucag
23716	payment	1397	1397	1678	1	1	10111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3BwTmak5NZzbj7XzRdmDoX9Hpp5HXmzc4MZwTT6KTRxikifA
23717	payment	1397	1397	1678	1	1	10112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhadUdp9yYowdZi1WsdcTrrc4LfouKNYs9Pr9GtB5ZhSkrR6DQ
23718	payment	1397	1397	1678	1	1	10113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjxUs3gryUrEUZExeT56cXbV7k49uD9mDR2tA4pLEtndMLQhx
23719	payment	1397	1397	1678	1	1	10114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqLczjyVnEsgYFhpwWVMzN3W2ZWwMZ57NxwRQQaWfGmKXqrCd
23720	payment	2134	2134	1874	1	1	1186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbecLDcKgWuJwMssHiTV1KqB1EXd8H8Z1XsWxYeYgMxeHGQ2u
23721	payment	2134	2134	1874	1	1	1187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJg1REvaje6AvDtK1nuhNzA2N8T2iw63Lhk4ZjDUsGX1aeafv
23722	payment	2133	2133	1874	1	1	1222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWqYeD6gaJiCS4tcgde3HABec2AkDso5vjARuPPqYy4aWpa3J
23723	payment	2133	2133	1874	1	1	1223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyNoGUAsgG22HciXPfzDfsZj4oKbBdCxiDm6tfuRTZPSYCiWs
23724	payment	2133	2133	1874	1	1	1224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVHpeApmxKjfSCKMo7EAtWHNnpTG71EBKqjGczpPtC4ffivhZ
23725	payment	2133	2133	1874	1	1	1225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqLvX9rxAyCFxqmtz9pATdGyo93eSFhjz9eXUUMhdBvRSEhcc
23726	payment	2134	2134	1874	1	1	1188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkd4eRvLR3Xy7mZqPMhgXMmVtcc75MJMc7MYDcey3GciY6DcW
23727	payment	2134	2134	1874	1	1	1189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJURV5ZRrNXD3qgJ5otaHKd5neHfLoztYHL2RETMCZn6wMeGY1
23734	payment	1397	1397	1678	1	1	10117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGQERqimw5k8mosEzeL4sEydcwF9y93neFtxj1SAUK6UL7iQ8
23735	payment	1397	1397	1678	1	1	10118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzfGvX7xSxArjZgX8NFfUYUxqkfWHj9jWTBQM6uMMt9Qyhj8h
23736	payment	2134	2134	1874	1	1	1192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAj9TtxmpRdCNvdnzc8xBtCxAsktqJ36FVxiokQVHCZWDMojDi
23587	payment	1693	1693	309	1	1	853	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZp8pTu6pvnN5ebXXMqMaj6mo96ieyiKb5McTk7N316gWH4ZyFV
23588	payment	1693	1693	201	1	1	854	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZbbmVpX1XesxzdmACj3qmARtL58EVcSULWKJszuDfxFdy4eWvm
23589	payment	1693	1693	1962	1	1	855	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZnFp6rDchr6R87bKewz9ZEzJrmVbRXzrUWbZ1Yxfaeeuaiaxi3
23590	payment	1693	1693	275	1	1	856	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ1Kikm1T9nLRJ8Dmsmuu2vrLDuaLHXvNbWiVNHvf3paezcUfnD
23591	payment	2133	2133	1874	1	1	1190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmuABu3n4SQhnaygiPTvpaeVeigo9j7uJWoQkYnMcENF12MTN
23592	payment	2134	2134	1874	1	1	1149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSgHSBi98psf4ZG8mpGiVsJFEwxde5786Aiv8r7RwyMDbuajj
23627	payment	1397	1397	1678	1	1	10081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WXmDATzGczgJaaDFHpHi8MMneSqpLSmaxmJnsK1KTUBYzzwm
23628	payment	2134	2134	1874	1	1	1155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkppX5DrgVPZHegXnGWgjWV6SkKj9YrZXGJjbSh5MoYYCSx99z
23635	payment	1397	1397	1678	1	1	10085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjg7Kq3wTPKesi5sotsSUP9UPV3kU7GNP2Lh6Gnbns7EdcTuP9
23636	payment	2134	2134	1874	1	1	1159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRetWF5t1QoSLcBU2r17m6Y8LYsbVFj8gbtyNfeBUUr6cwQFLu
23637	payment	2133	2133	1874	1	1	1195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrp8yePq567qjD7NTmFLpAaV4iMrjHkZ2fYLNR7s1BPHReAeN
23638	payment	2133	2133	1874	1	1	1196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKg4s4PFDDkPM2g4J2zewD23ZJte73FvM1siAWSv3K3VdyVSZy
23639	payment	2133	2133	1874	1	1	1197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutt34B5PMY41faxZQSnZhxsBpPM4TD639beADw1YsppyjR93k
23640	payment	2133	2133	1874	1	1	1198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSEv1tCiHtG267HHBYRH46zGzSmfx6SGJP6f1v2xc5khUHrCjv
23647	payment	1397	1397	1678	1	1	10088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxz2TXbskfhuLwijbxdNHn2tvW3Nb6776PWM6HuKNEqAjDGVvs
23648	payment	1397	1397	1678	1	1	10089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKyrjU3bnKMFjkft8bs3WwbuScHA1Gmwe2ofSayV1uNW1CtJh
23649	payment	2133	2133	1874	1	1	1201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRh1Tj8c8N2bg6ejdcUvXuoN3TNKqjuBbNkCVGF42U9n3fBTh
23650	payment	2134	2134	1874	1	1	1162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFvoyFSTwwXF4ve65EDgs7BiE9EyHTSsU4Fuf58xaRtatnDCX
23651	payment	2134	2134	1874	1	1	1163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNdeGCgQtVXb19UA5FYEjo5B6V8hFZYbwoqH6XBKoKvQ2TRVK
23652	payment	2133	2133	1874	1	1	1202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvx3cNBTXHkV9wjbrimrxtXkFLP8G6LrnoJ9vetwEGABcVzFh
23670	payment	1397	1397	1678	1	1	10096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4w8yqEsxv9q4sZggyoGUD8DgFCrJHwkGGtgx8YtKZSLxJgwhw
23671	payment	2134	2134	1874	1	1	1170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8w8LeyrAsmSLXfyabrtJ2b8d8b9ZFTA41LC4tZTWHVi7fyVWQ
23672	payment	2133	2133	1874	1	1	1208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsHNwob2W8x3yevy9GgwSKTaZ5ZZ5ispo2SbPYE7xQHKABNCm
23673	payment	1397	1397	1678	1	1	10097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeM143t7oy4iLx7atwJ6HGS4HZoyLisgRCD8rhfFcW5ztWx6KJ
23674	payment	2134	2134	1874	1	1	1171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXbhvPCetroyhApkMSkVRVJMS6rd5ZC816hBMWfJZE94DETEN
23699	payment	1397	1397	1678	1	1	10106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rHKFkTmn9BrcfZiGJMLC4AhZMcodayp3242YsidKGJopX8iK
23700	payment	2133	2133	1874	1	1	1216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn5N6z5RAtwg5NzwWtNikFtZcicyBfhU4v8y5qv1xdmCewZ8d
23701	payment	2134	2134	1874	1	1	1180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDby4wayBm41ffNEMndEmmKZB64pcg1qZLq3W3LxD6DSaRCTTu
23710	payment	1397	1397	1678	1	1	10109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4x6EihWBXoAGmQB756bTXcU73Ng9ERqCBLUNoNMPddrLQZ4U9
23711	payment	2134	2134	1874	1	1	1184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpqCaRRUTkvFreRAFjaREu6GFP6Yt8KkQFuPvpmkazQGdgiaD
23712	payment	2133	2133	1874	1	1	1220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SZUqZjreyEQiAQ15PCmvnSGtauWXTHzUPNz3vkrNqa4bmHMs
23745	payment	1397	1397	1678	1	1	10121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRH4mDGaWsiYvyR4o5LgzB24G7AsrFnBNGmseSsUvF6kJJwT22
23746	payment	2133	2133	1874	1	1	1231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAML8h7wLk7UmJ7RoF4u61g4eVievn6LaQB8QeXJ5Y92ATwSX
23747	payment	2134	2134	1874	1	1	1196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pRWKWMcWqtxknpVGvWVaS1TXDHzpphNcKzsXf8uUscH4bRW
23748	payment	1397	1397	1678	1	1	10122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBLNaDQTF7QEkWhgkmBiSsx811TvcdausnrS2Thcp8gvskhcd
23749	payment	2134	2134	1874	1	1	1197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mRjF425dsWqxxC8excFp2U9xXHxkSwkAqXjkB4APX6f6zRxU
23750	payment	2133	2133	1874	1	1	1232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6q9dbA9X4hxd2J9LA9n1DYt96MhTQkx3V1UirHcicow5GLbf
23757	payment	1397	1397	1678	1	1	10125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCrFmf5c4a4Ef5MJAK66FQx8MSYnWpchdpd9K8qJu4pSVdiF6
23615	payment	2134	2134	1874	1	1	1152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJh8eWQoYcAffFuQfs64kyfiybGcb4XNsdUPBxnmkXWGgfy2hj
23616	delegation	1926	1926	1745	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZep8XnPRMQKhmdy5bAQosTBYqUj9DrMLfcwz3PQPswhZvgfPfV
23629	payment	1397	1397	1678	1	1	10082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEfkWrLGFwjoNTR67G3WxXkVohqUp2LrpiCb2Z3HixBesqzaN
23630	payment	2134	2134	1874	1	1	1156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCM1NzR56K4ubmysBSK3PFs8vyQJEDgw13VynmrrrkAvAcTwL
23644	payment	1397	1397	1678	1	1	10087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeFuczGeiWNWScmWG4nc2dDBiTX1LXikgXqqXo6Q5WRXeVFWU
23645	payment	2133	2133	1874	1	1	1200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrd3LmnbRQ3PQs8aafF2cHfm27JWEraCAPSsVRLTC54ihNJYT
23646	payment	2134	2134	1874	1	1	1161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76Pqu8VNXMaRdY8AL496ofLUXGCB7KTF6hsebBNDiWnNxEE65
23668	payment	1397	1397	1678	1	1	10095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUNfZ1yKdpSXNhnkJs5o9APeQTVGBg2dw9BDdmoqsUokVstJ2
23669	payment	2134	2134	1874	1	1	1169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LsX57nYoik9rW1npvB9ZNfdrDbSvRiVuDXx4nZqPLJBS2ksV
23678	payment	1397	1397	1678	1	1	10099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8r5pHAPn6qoSLJ6E5mZ9xK3aZc5HBAoGN6W5zWPEM3jtAJKGH
23679	payment	2134	2134	1874	1	1	1173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqTY1NE5zk51Fcf95aZ7AopHBC56YSYJzCxV9gb7MdXACAuM7
23680	payment	1397	1397	1678	1	1	10100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgACFQCCWdtQQtLDEWYmL43x1YfW9nhKkqnJkji6iciJhjmAX
23681	payment	2134	2134	1874	1	1	1174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWsGT3Gv1ZTVj74PvcMxuWrox6YmQeu8RQbD5HpT3ALJdrXHz
23690	payment	1397	1397	1678	1	1	10103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYai6RYv8aursnejg8pqTtKU9js6is6rxNbNKHPyszEnXYkutVo
23691	payment	1397	1397	1678	1	1	10104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sH5ziTZm6qHr7YEHvWcpSmysYmQepbTvj8aEfQ1m5xw5v4zH
23692	payment	1397	1397	1678	1	1	10105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZmGkRW8osrG3i3SV8cnLjWqLYYZ9AnQS7D8wEvDYnduUmaki
23693	payment	2134	2134	1874	1	1	1177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLApjdghJebqEC7EsKLtf3jacZX9K4bok9yvwk6SdUsQnfyoW
23694	payment	2134	2134	1874	1	1	1178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsdLUDvYLGBtH9fzw2NeRpVJNsZWN6ftzUMTrKpWVSrHqQHPJ
23695	payment	2133	2133	1874	1	1	1213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8DNiHuf5X6Ssss5tWaaKZBftAE7Pt4KFSqnfRhD1g3dXuJYe
23696	payment	2133	2133	1874	1	1	1214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9j8FakoKcUB33J8DDZW6VsfHgXHh99hckxcr5hRzBFXENQ69f
23697	payment	2133	2133	1874	1	1	1215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByNvXsNArhwwd4mpU9WV5krkEAcCuqTDmifRHMSRuc9uR99ER
23698	payment	2134	2134	1874	1	1	1179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7g358ZP43Phh3qsemq2714JzCf9SQQWdxh5NZandLEQQ3bg6y
23707	payment	1397	1397	1678	1	1	10108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJd7ZuXvikkQQPSHJe4y9XYfZ5bcwy1LbvEG4H3xDVpNq1vkkr
23708	payment	2134	2134	1874	1	1	1183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7w5TXVaiGPjoJxiXjuhGdXS846GdVNwnDAJAs2kNZgdW6Cj6i
23709	payment	2133	2133	1874	1	1	1219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6rx2w3dAjHAfAb16MccHd5ix5BrdPc4ND9PCzyoJ5N1rwgbE
23731	payment	1397	1397	1678	1	1	10116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMiUh4vret8kFr846GCF2NRovtPiRxFauKjNdMV78hyssVamt
23732	payment	2134	2134	1874	1	1	1191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjAugqi3MNdnPfavMEE5BmRAhLH7Pw3x4J9CQ7bx1wPJUmtY
23733	payment	2133	2133	1874	1	1	1227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSLSBVjqxXjadzW1uE1hq883p82yhbJ8ZsX26G5fnz7nhnVqa
23739	payment	2133	2133	1874	1	1	1229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVspdZAStZgStYVvtUDoYfSv9xjZuHgsZCyZQ7sPzC1RPhW5J
23742	payment	1397	1397	1678	1	1	10120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLwiuRFcg95DyheywpvYLkL9QF3ZT6eex4hwnZNNk9z7j2NZA
23743	payment	2134	2134	1874	1	1	1195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQLGuc8QxTDwx3R6vLFRsY4bmoNA4p2oW9f8jqF6pasqWFN8A
23744	payment	2133	2133	1874	1	1	1230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazP26E6cF6m9K9AEnzWyNPsHkaDWJJwSERvEhYsAM3p4XBGBj
23754	payment	1397	1397	1678	1	1	10124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuevRMDzwKkURFTCqT4EKDESChRnDK2EUS42ga9Xy4itSHxH6v
23755	payment	2133	2133	1874	1	1	1234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfCsCG9tZPcjPtBgZ192Zjx4ZLBQ4CUeo5DcH6p4gHjve14ro
23756	payment	2134	2134	1874	1	1	1199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTAg39yJM2DE2ScEhmDmpEGLFshQKshKsRtYue2zqDdoHh6Y1
23760	payment	1397	1397	1678	1	1	10126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgHhhrKXRyYSHLcJRtTKq5pf8PZtH3Doe5Z2wpy3nUF19c8yh
23761	payment	1397	1397	1678	1	1	10127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKFhVce42b7E3sQTNtrEmStXQFxbvRKoGAH6BavKrFJrthYkZ
23762	payment	2134	2134	1874	1	1	1201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwzRYJ3LdYtnPAaxCBHP2te3PK2Fdb4A2Qetou2x7u2YW6LH3
23632	payment	2134	2134	1874	1	1	1157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWfXGgDRgqr77uTXsjMDjmk63NcZQo6oAdnkJKPqRdZZu3FFE
23641	payment	1397	1397	1678	1	1	10086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXBZ2VFWbVtfJtww4D6kdVFJcJvfv5tYFUCERC1LoQSyFak37
23642	payment	2134	2134	1874	1	1	1160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x3w6TF6teTfjH4g65jKgN8NtZUmAPaAS696ftfdwhrSiGPYm
23643	payment	2133	2133	1874	1	1	1199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDreZHqfpZTicWPFrbsdr1wi5EPE69D6sjMj1k7UBNmEgUSjNu
23653	payment	1397	1397	1678	1	1	10090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYykAG9uDgmKbB7MMn9aU7F7STc4H8euwUZcaR8Y286Sf5pVLj
23654	payment	2133	2133	1874	1	1	1203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoEZDyyUiRxZ2EUMCvm3L7iCSNJ4TNsmKj9jjiPDNzKwPN2uy
23655	payment	2134	2134	1874	1	1	1164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC5ZHdi8uZPZGqWnvWmFqbtRuiFXsKZdsKUTtQ9B5pbFvX1Y2
23656	payment	1397	1397	1678	1	1	10091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfan8gsq8dvcVt8DuKFii2QYUxwEFLY6iToo7w5DCdN3Rvcn9d
23657	payment	2134	2134	1874	1	1	1165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpSp4xQhRGx3WjeViQR7YMBz52jAo5vXn6fWQuJX8kqNSLjvE
23658	payment	2133	2133	1874	1	1	1204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2UCVkgKyG2MDy2D2KwnEkDqPHXjPwwddSCbLZ2hbGphiVsGK
23659	payment	1397	1397	1678	1	1	10092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdMjBmfKma49KZp9EDF7avm1JG5Xa8e2qxAkydBwUt5Xngum4
23660	payment	1397	1397	1678	1	1	10093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrgRL9fhHJdrirtCdfMdg1coCXUaJJSNykwv5V6sRXGLF2ou6
23661	payment	1397	1397	1678	1	1	10094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24RGsYq5qHcSShkExkLAC71To5EfRwcnGKfhJBDyCtJ5UuKqF
23662	payment	2133	2133	1874	1	1	1205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocZvdK2GaD5jQi2DpaocHDZd9ZW9DAhkXpmTbYJPbXGLrsd7P
23663	payment	2133	2133	1874	1	1	1206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXnSiZzf2m3rEeLfvyJif4E2t2QrXavCq2AyY1VDihbLjRgEV
23664	payment	2134	2134	1874	1	1	1166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsksZmP95vpvAXV7nf21skzbM43C55U9uU7opuVQSNLduEegkW
23665	payment	2134	2134	1874	1	1	1167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDz3rDmbdEHDK9A4nYhY9cd6zZMht67rAyaMvRkistSGNkwd8
23666	payment	2134	2134	1874	1	1	1168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7L7atXrdGZEwttceinheabRfvL81XPDMEAkqsWELUJfeGtkjH
23667	payment	2133	2133	1874	1	1	1207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMzrqd6iAGJc1AYoy2odjABKfjtdM6e7o5RDG8VGKSfYs6kf5
23675	payment	1397	1397	1678	1	1	10098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqw1rqXwnZ7osnoXF96mdpTGLBWzS4i3WtxKYjVMkXe2M25uKn
23676	delegation	1924	1924	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYietEbQQsnR8f6sfeZ7cZFZtC9SdFa7xYdrNz4VxSk4opnPhNt
23677	payment	2134	2134	1874	1	1	1172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDFDrn3FuWQ2U3DT9Jhfismx7zYocYv99RkeLfnpYjBPZwyFc
23702	payment	1397	1397	1678	1	1	10107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqk8n3znmyfmM765K29v7QeCjqy3BRNKQDTQjr37u8ZXtnScyR
23703	payment	2133	2133	1874	1	1	1217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQFwsSnQbHfQsMvGwGpJJXLbUXDeLCtqLM9toaT9XQsfE9TGZ
23704	payment	2133	2133	1874	1	1	1218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZsTFiRZQw42cCzFdtpuhdBEH1gg9LSNacRYgLUeTFwnXsepm
23705	payment	2134	2134	1874	1	1	1181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1MBgjh6N97jgepMmCSM48NKFD24v834ZWJBuZPwoX8dY7UK1
23706	payment	2134	2134	1874	1	1	1182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJhaMy8xABb9rj52JXLizzgEGKXGjKYbZECBnmXmaVei2C1YX
23728	payment	1397	1397	1678	1	1	10115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrfoqtvT7Luhypcjd35pPCRX2tDr2k4UVrTvSPqAAwQPHDX8Q
23729	payment	2134	2134	1874	1	1	1190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpPmvWftueoZM5hxjQ1ZvNVfPrYjdvHVnKKhzW2taGjfY8ugP
23730	payment	2133	2133	1874	1	1	1226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLg28TW6mMjNRSJ39Vrvr5va9tHv6Sn7p346Dw6KPbi9wLYAm
23740	payment	1397	1397	1678	1	1	10119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YsuQYfPZGLbBytUb2Sof5cmFB6B5a4MHfc5bWGw3ayMKb7yy
23741	payment	2134	2134	1874	1	1	1194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68RxF6NdqRDbBKEJxotnVMmQARF8WqSakFnekmhgi3Fq1ehMe
23751	payment	1397	1397	1678	1	1	10123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHz5GwU4fpNZKTZW4c2ta7vEVmfa5yMawJ4768KfvRyAZ4Y2B
23752	payment	2133	2133	1874	1	1	1233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ysWkUb1Gz24u5LevPBVa5DqNHvtw8gg8ZU7EmNXdHGuTFBer
23753	payment	2134	2134	1874	1	1	1198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUtAxvqy3DQ5xFXnbbxgw5ghAvqEsqxEyHTKS9wGkNGaCXzeu
23775	payment	1397	1397	1678	1	1	10131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanSX9gV3yJxtPZMeZCGtY6aW5vAMf9uEhgdQprujTJxoaXVWP
23776	payment	2134	2134	1874	1	1	1206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr1wktXD4xowSZijTsrvbxVsnbWfCTSDkWpTa7pQmVZz74Xtq
23777	payment	2133	2133	1874	1	1	1241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeFpmnZzFVPASC8wi7cptzT7xKQZfywXJ4hgtgG7YdFev4kja
23737	payment	2134	2134	1874	1	1	1193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHkuSyJ81ffED8EfdK7aYK9Gq23ENHvwHkEuGHMr8TQ6a1izD
23738	payment	2133	2133	1874	1	1	1228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZib19FZbK7wRprYGFYoKvsJzD3kLSzKNL1qRBxfqjKnYAGZRZu
23778	payment	1397	1397	1678	1	1	10132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uA6EWhpULgPuWy3ECvVUyTEPA5ZxTbEuYY9kFRmzX1PAH2y7
23779	payment	2133	2133	1874	1	1	1242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeUNrwPCCyfP5ugjJUKeoUPjDai7biyxpBN9NpFwzNZSaZ6gp
23780	payment	2134	2134	1874	1	1	1207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCb7fJRyE3HxLsUBMYoUgkhBBMXb2ACw6V9Z3EfmkccLLH9mb
23793	payment	1397	1397	1678	1	1	10137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1GDS7x2TqJiZGn8e4tZ4s2kMaLfEygq9Hn6Gsos8GxL1g5m8
23794	payment	1397	1397	1678	1	1	10138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYfmEF3mP7pEYvqDmGcSZsWLKA5cgk3ukuWJ6vh8bh6SgLqRs
23795	payment	2133	2133	1874	1	1	1247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7snbiDbHC16cPbjfNtspYMz7AyyLh8pULjkxQeQ2byb9qaB1b
23796	payment	2133	2133	1874	1	1	1248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJsePEJSACA15xGNGWtDZdLMcUGpYVrZP7QVFzJUWb9pnvFEy
23797	payment	2134	2134	1874	1	1	1212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6iGsU92esGKdtYs6tPu2C4dL4TwYoUmVhEwtWFq2jis8m4iN
23798	payment	2134	2134	1874	1	1	1213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDHL1FBhqeoethbMvDs29Sp2dntkw3AezjV2sJJCQKFtTPs77
23812	payment	2133	2133	1874	1	1	1253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs1J6QynGnT3xiq9myfYmsQLxh8Sgqff76mgJQ57dhBxAQU5S
23813	payment	1397	1397	1678	1	1	10143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE88KeGwLeYQfdSVLruaxwobkpUe2nqxMhZieqeLwoMzynUz2Y
23814	payment	2134	2134	1874	1	1	1218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYxf5ED65sSqnK2frgL8ndCZqsRLmKDbEtdfhnKiXZ3zuN3MR
23835	payment	1397	1397	1678	1	1	10151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1y7VjLACVAEdAQBtQDWmd2XSn62pgCd72TNdFZyEBspj9XqdL
23836	payment	2133	2133	1874	1	1	1261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnfPZ3V8YPn9ViWYkVE6cjtpdyctqUxXss6EUv5vyGa4UVqsg
23837	payment	2134	2134	1874	1	1	1225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKA7Hzmd3oF2iGXmDiWPg2Ly89bB6tDpwtNFbsySBG69LXHxsx
23838	payment	1397	1397	1678	1	1	10152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cKWexokL9fu8EokphssZMxzRLL3niHHSgWFCHwJtktH1uxTz
23839	payment	2134	2134	1874	1	1	1226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9E7yBNts8UVW1h9fuC3iy28AEF1saBdKo1eZxbhTRWgWowFtK
23840	payment	2133	2133	1874	1	1	1262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm3dwLe2M787DnAUZa9CeKpNZbTaCVLH4d2BW742Muoz7Y4D8
23859	payment	1397	1397	1678	1	1	10159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo6TfMYrTQvmPbwU6QjVSyyKmakajAPvwSiofXkKRX9RUcjNs
23860	payment	2133	2133	1874	1	1	1269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd3hojaC5jqT5SQusR2oGSfekRvWiULCJjVnTXd5fKwev5yp1
23861	payment	2134	2134	1874	1	1	1233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKamG97gMxkbQyZnJCMjXCRxPXQPnNSYvsQJ1gkQNDyvMiudrS
23916	payment	1397	1397	1678	1	1	10181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJ2VWsKcyqwSi3dkyo8CcDqvTVRBD4iXmLsSH323p5HmhH7EJ
23917	payment	1397	1397	1678	1	1	10182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBRTYVG9SqDjeuo4UqVZ7zPKscUhD3zxoJdZVmiUmNvtviuKR
23918	payment	1397	1397	1678	1	1	10183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPpbEE5N1JsR1jmM97FkM8bS5YUBZ3qNVDqTd8HjC7WTb2JUo
23919	payment	1397	1397	1678	1	1	10184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzzDCoAxoqauHTDcfrxRL9desi6f5qL9zJXSfocb1MsANMj9W
23920	payment	1397	1397	1678	1	1	10185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygbTQLmZdwbXEPGJjGiRX5Fxg4Px2EmkvY9gbKLLT4r5cVsh2
23921	payment	2134	2134	1874	1	1	1255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6qtfSktXA3aKaFZLjsHw7fcLWevM49q3naU24ozMgfKq4KFS
23922	payment	2134	2134	1874	1	1	1256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJffXQZgYo3xc6jPiusN35y6XjhYk6UgM49frMiSDG1BQMCGz
23923	payment	2134	2134	1874	1	1	1257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaR45hdzuZuH3cPHW6EBy2Yj31yk3mrUjDLd1gLTpRswLv4bK
23924	payment	2134	2134	1874	1	1	1258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6ktGjqzsoAkdGZQANp5pZ9hWgG6XHVC198eztSRnzknYpdzF
23925	payment	2134	2134	1874	1	1	1259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwckNg8Lg7DHXW5oUM7VxUiz1iQNYs4Q96yqUQPYSwhAaYVAWw
23926	payment	1397	1397	1678	1	1	10186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3waeDS9C65FjyK7f6X2Hc3q2g2c6iLTbLbuUBBuqcehUPon3s
23927	payment	2134	2134	1874	1	1	1260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoSW2GcDmjmvBg6oKf2wTdQHbgntU9KLdHsUqCvVsKznqcEDH
23957	payment	1397	1397	1678	1	1	10201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6u6KuCvG6Huf5b8y58EJxNXEG86i2S1rcMwtyoA73Zzdv7EC
23958	payment	1397	1397	1678	1	1	10202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5qFyJirM67HbejLcSHLfrFk4RPeadx56Euv7CPDzprEzhjQW
23959	payment	2134	2134	1874	1	1	1275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFjDyvxf1yjuc6qsMjmtVkWfoM6n1KcXfjGE6t9A36t4JdRNN
23758	payment	2133	2133	1874	1	1	1235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmZk4X28hujxJNyGZshona32iQSYHQKE1jDxYLsFC3eRrW3NE
23759	payment	2134	2134	1874	1	1	1200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBVcXyno13HFdj8Gezkmyy6uLyDx4wpA7eZ25Z8TqfpX9kAFX
23769	payment	1397	1397	1678	1	1	10129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgyAyfgN2BdbJzqEhqaHjAV35Z9VGiygT5nsCFR4CpgaMoHvJ1
23770	payment	1397	1397	1678	1	1	10130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqeCQ9iZYV3yNaBaDzEvM8fA3vEs2n6vam8vpH7FKUsGcoxff
23771	payment	2133	2133	1874	1	1	1239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVPXaZn4joJG7uzf3hnkpDASZfCjPXs8FimhrxTi34YnzfdZG
23772	payment	2133	2133	1874	1	1	1240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9kttMTihd7A2dzqkoLdudUtZPi32eXcgnU1Xu98x5Hghkapw
23773	payment	2134	2134	1874	1	1	1204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqRaNYdhnFmnpzaqX7vTRQi4smeB1ZQR1uQG6u6RZsR58qmkg
23774	payment	2134	2134	1874	1	1	1205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVX6cN2Yb73skJ9M25iye2s2nqdb2bBV6bCxpDi8c4hdwvMMx
23784	payment	1397	1397	1678	1	1	10134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWDMZQEoCJkmJeiP9c8xhrtNFckaF48EuG9hGvJ3rau2x3dP1
23785	payment	1397	1397	1678	1	1	10135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChd85HXdSXkkxswjd1XEiAJyLx2wroXQ2EFCUjeeL3isbPejZ
23786	payment	1397	1397	1678	1	1	10136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnmhNco1UU9viqRBMCzRuCFuSdMPevGc7KZVhsHzALjLajnUK
23787	payment	2133	2133	1874	1	1	1244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9cotBkynD888e6LFuJFvu8bvSjqpBzhYNrDQTFfmcNf97S6p
23788	payment	2134	2134	1874	1	1	1209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpL7T9gj8xDKyh2Uti2SaCkXKdoSb99dm5W8oLzujBRDmk2k6F
23789	payment	2134	2134	1874	1	1	1210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KijNHtmScWYP3HcecmRd83Ao8N2omx47EHEPeMDp9yWcJvZo
23790	payment	2133	2133	1874	1	1	1245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRM83KYVeRLbaUyKN2Lgg1fWpf9vEc51oKaB4FoXQbf9u8mrYv
23791	payment	2134	2134	1874	1	1	1211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYc7KLq9tDWQZ9AdyPenC7HuyiG71Yi4wUrkdUK2yDgL4ubSyp
23792	payment	2133	2133	1874	1	1	1246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bbLYnVRAwAMQndDFzf2Yy16cAycTNb71hG4PNx4ojSpTfY5W
23799	payment	1494	1494	1950	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6tYdXY8QuKrGtxm5X8bxbGCYseha3qsBCtvmqiRRWBqyrpaq
23800	payment	1397	1397	1678	1	1	10139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwRCZBZs3ga9D9yxeq99tzrY2fkjHc3eogmfj1QGGeWjRr5tW
23801	payment	2133	2133	1874	1	1	1249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLfJqykynGyxJifH77c9x8bV4ey47dhac7Scz6ZUzojgVLmGP
23802	payment	2134	2134	1874	1	1	1214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9UbwhuhgXGgg2S8r5r3uHoFiK9WBZKQh3SY8k8vCaM1tYRrG
23803	payment	1397	1397	1678	1	1	10140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW19ussBTPzqw237qCevSzegeGwingj4jmZiAoSnY3TSoieTgp
23804	payment	2133	2133	1874	1	1	1250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXP9oH3KJUSBGH9mvwiNz7n2v3JAJUUrWm4kqyBpL7jv5kpG5o
23805	payment	2134	2134	1874	1	1	1215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhDF6FNH7Z1H2ANXdoxj7eZHGeeFgmEnHfYmic1rA5f24vpk6
23817	payment	1397	1397	1678	1	1	10144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvfmeLmjnqcqH7oDiZXXqhwX5aHccsHVrUAd8BNW2T61VyUsx
23818	payment	1397	1397	1678	1	1	10145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKVYaCjzcPnYMtNPuVxftthSZWCtEZbED6nKLXpmig1Z8C1Ua
23819	payment	1397	1397	1678	1	1	10146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QTYu2VBdCEUApnMnrZtG2ZBobi372HKztrXsB2Cc1WWqXnmZ
23823	payment	1397	1397	1678	1	1	10147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEktF7myCeywBbECLbKbmqDQR2DcnvyJ6gnawtyEicFk7qbny4
23824	payment	2134	2134	1874	1	1	1221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTBAowW1Vf3NHAZRBNYmoS9WiU8V6Yej8K9yqSatkF2vWcmio
23826	payment	1397	1397	1678	1	1	10148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84p2Hq4SZxu2deEsZxEp2xu5cTJFKAMXzQFBUahEX1x18i16E
23827	payment	2134	2134	1874	1	1	1222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bYtCVTybESEbejRGEnp4rrS7TnrV1uBc6V65V8aCwgYiYXXG
23847	payment	1397	1397	1678	1	1	10155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqZ65vHj4pxVn4GW6RFC8WoeajwsEAkJE2E5jGF4q6Y1YFfMp
23848	payment	1397	1397	1678	1	1	10156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXNsEdZWipjfPGoFqrLcuPsUNaof9PHzjv8PKFfeKPrJH82C7
23849	payment	2134	2134	1874	1	1	1229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaB6Xkrohjo4fMWvoFQrRRX6mDsyhtsTe9N2traj5jAXbscJjn
23850	payment	2133	2133	1874	1	1	1265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3QxEzyB83mMkbhxe78HyDEhnJyFSj5GC3Y4PTRDYrD5ccYSz
23851	payment	2133	2133	1874	1	1	1266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUZv2hnKa7i82mUNKGTdMbj5Y5oVWL1cYvH5NsexfhEdvadMf
23852	payment	2134	2134	1874	1	1	1230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLMe8EkD3M8XNpiTgzyEHe6ENwVKSiQXg19MkStHcCR9ZPi2E
23865	payment	1397	1397	1678	1	1	10161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv9QbkNRqwhc8EfMhqqX2YwjfBpZsMwPT94RHw9r3uy74NhUc
23763	payment	2133	2133	1874	1	1	1236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2jf5hNp9ahHu6Dqr8TPpRB8d6vzTqksx8vF1Q3HUj72Dge5S
23764	payment	2133	2133	1874	1	1	1237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQYEL2M41HToWMJr4aMuyNxhtpGdUUV6hLosG1Ux3FBHVMQmA
23765	payment	2134	2134	1874	1	1	1202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPNX6Hv1Uf1mQiGQ2vu4da3CPmJAuXsT55LbPeaqsXUwN1d9e
23766	payment	1397	1397	1678	1	1	10128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqdnyPx6yotioSVwsYWVTrXP29E3nKVQ9bBVGS3RxiLRbrhnQ
23767	payment	2134	2134	1874	1	1	1203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkzk59vqCCCsQa2HHtK6nuXTSRWcN74tqiitWQpNeiio7yvnw
23768	payment	2133	2133	1874	1	1	1238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFt53GYuLW1EySqYYwEanih6LcqeEw3ctidsdN3DzREnoB4Ehp
23781	payment	1397	1397	1678	1	1	10133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsF3Lw6p9gmQwtGhvGedt1xEBy3cY36RZ8BL3ZdomUptmnCvoJ
23782	payment	2134	2134	1874	1	1	1208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPS4MhL1xmr1jnSWAzjtAV5fGuXB5ZaDGh2XU9iTUgLc1Q6nU
23783	payment	2133	2133	1874	1	1	1243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMTjyNU1mefFmFb2zh4Zpyv1LbZvZ5iMyzovf9iuBEWdDecsF
23815	payment	2134	2134	1874	1	1	1219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42LMqZcrYBrwkWda9c8dKZfADmzRaLEDczHoSRnQmAbBdcWu1
23816	payment	2134	2134	1874	1	1	1220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxM2NHeCMgBkrK6y2exunqxbSJZ24Zpjv9ooiWCeJbyHkok9z
23844	payment	1397	1397	1678	1	1	10154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYfmvYMBAtuWdT2BCh5dVE8nxXsD7CBCk3iNgtb4CW1FJVgom
23845	payment	2134	2134	1874	1	1	1228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4HesMKzcQwBYE549tbfRW3X6pNQhK7en9T98EZCzhQ2iNPxN
23846	payment	2133	2133	1874	1	1	1264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcSTUte9TntDNbGtA7ZBM5xKrxEExzAi3B82kYhKXaohsbDTU
23876	payment	1726	1726	2166	1	1	8187	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmT4QNZQEzdGb7KKL1vDRgUGMLgCsDwDtcpL5z9fD6UTXa1Xej
23877	payment	1397	1397	1678	1	1	10164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxjLDv67fYofH1AaBgvmHpTEJ2ogf7V27ZwYVmqDiH6NjpH7p
23878	payment	1726	1726	2167	1	1	8188	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEkhT17ohSt5eWZ3T5zHaxucirF7B412y3hvGCtcZHWHUJAymm
23879	payment	1726	1726	2168	1	1	8189	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYucNVF1GHWSw6iXhs7TEb98J7ii3VPrtsy1L53AF7HCShLms7x
23880	payment	1726	1726	2169	1	1	8190	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYePAPzpg2S18jTxMi3iPyofoUSwVMEShyvW4N81Fbs7ymxceqo
23881	payment	2133	2133	1874	1	1	1274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17GreMvpgur4qvozde1eHHb1DygjSDGjZHw3xZXzkZK1zA1RJ
23882	payment	2134	2134	1874	1	1	1238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr5efLnqfxEbzhginobB8HHrmSfrNVkJMDc4oeyok34JDCN1e
23890	payment	1397	1397	1678	1	1	10168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT95cqRM1P5K8mCdAK5zmuGiSEtqhqpbeP9u3U5w23yKaR6BQu
23891	payment	2134	2134	1874	1	1	1242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zGLdXMerFuzFQ69ZGNuUZ8npFaYi44iejHAV1CZ8HZURc2e7
23892	payment	1397	1397	1678	1	1	10169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmB2ZehvZYc5ASQ4whUT1psUAhmx9pnyCYm2eH4Cp2VxdEzgr
23893	payment	2134	2134	1874	1	1	1243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvpWiWQggVq3yckvYhPK2qDbP75MMG92vsL9AaeMnx9qrtgSD
23896	payment	1397	1397	1678	1	1	10171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb5WGTBBabBZoujj1Z39zycUk39YCKb8TnWHSECte21JSk7GB
23897	payment	2134	2134	1874	1	1	1245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hf6ckt3mYorwRJqCLXwKbnXPwSFNF3ep8jdnrbuUPE1WES4q
23930	payment	1397	1397	1678	1	1	10188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJap2RSha6tKHE8fh1SqWQjcRHg9h8a8nVatoN7YA7Nfto6TND
23931	payment	2134	2134	1874	1	1	1262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNi5oKHUSfgo4NEnpHaK6h1jyqGX3mDPhWThsvcnXFKKHWiu5B
23937	payment	1397	1397	1678	1	1	10191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ498pb9Y9dmMfzJejRhgfu46zVuLe3qN1VQn9ssbYWC9zpqR4s
23938	payment	2134	2134	1874	1	1	1265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPgtK4FrCavuCfUJ8tpF8VhL9yW2dTBJgJh6LY8khrSVrjT9d
23939	payment	1397	1397	1678	1	1	10192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RRV8mwvBsJZPeNoAHU2ZYSum3BGwGg2phFVZ1pok6FTLM7ou
23940	payment	1397	1397	1678	1	1	10193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JhW6nNskYmJwKFH34Doy4VHurj7WonoNdbDDMRgj9wAd9uqQ
23941	payment	1397	1397	1678	1	1	10194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe2ZpSjSAR97iD7ur3TYmY67rLYsuXJD8LxaFSRosUCQvnNMm
23942	payment	1397	1397	1678	1	1	10195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCg6BzK4UvSueNhdPGxRmSiyzcYDfUeoQHH1FL9Aj2C1RhVqJH
23943	payment	1397	1397	1678	1	1	10196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zj5WKZQ4isStugS38dAqxrgrurmu8RXyPfiu8vzYuogK3oJ5
23944	payment	1397	1397	1678	1	1	10197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrM111HmHHTrttPzUZu7coESir9Uo7ebWDiForFMnzfEhVnmcX
23945	payment	1397	1397	1678	1	1	10198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiWFWp7FnfgtNPCiUWWa9Jr7iPsYf4d8c6v6w3jzZHVapq612
23806	payment	1397	1397	1678	1	1	10141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHNmJtJRbK8j4HkVsVsq27iXidK68fnds9YMNBsDUSQbg2w1h
23807	payment	2134	2134	1874	1	1	1216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFZ1JYGx336vPJ6bi9zBiBjq1cNQiCcZ5BXkN8tyqicvYTXMJ
23808	payment	2133	2133	1874	1	1	1251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEXAZYFXewtWuzE5ia1uY2tyT3irhYNUuDNBiiwfYi7XA9oNW
23809	payment	1397	1397	1678	1	1	10142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXufMNGpQuX9eaRH5CLAw2ETjXYtU8nLZNGar8as1629NMjFav
23810	payment	2134	2134	1874	1	1	1217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AoCucsmWHkZphCnZDV3uJhi5KbwjKCzZEAqGnebbQwfW9cvx
23811	payment	2133	2133	1874	1	1	1252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUWF6fbZyZephNbuQjYmjBDpobE6t38NZ3sCLGKyLtn4AMTSw
23820	payment	2133	2133	1874	1	1	1254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQf768fyWXvsEamoqeRVAirptaS8Jt3TMgK48rsP4ijt5ZuKh
23821	payment	2133	2133	1874	1	1	1255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrZpzfZjrdKEDCzVqnHQfRd6qzwPiZxVCjw8xvFEQSAFHU6Yb
23822	payment	2133	2133	1874	1	1	1256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2cqLGXGiyU2AC9Zzx7aQuRdRQx7Tqfu2MzGBgZpgQp7JqE8q
23825	payment	2133	2133	1874	1	1	1257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDyHCbJDSbwEiJkebVLjz7fmmcLH3V8xAYzLCKwNMwSN5bMRS
23828	payment	1397	1397	1678	1	1	10149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunYjoit3AcKrrYP5TWVWD8LdyTY83A52xXkw7cigS67xz5oHn
23829	payment	2134	2134	1874	1	1	1223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb83sPTZb78Zxn6PTDJYTRaLaYR5ovJXd2S8ny8dYrpAXeeCa
23830	payment	2133	2133	1874	1	1	1258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhccbeP8oh9mLPQrdjHAdvSzPo2TH2J13yh4Kyyn4iuavcN2a
23831	payment	2133	2133	1874	1	1	1259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZw9JcVYpnhEcVe7AqaPhox9o8LJzHMWQgH7GWyorQf8mMAJpE
23832	payment	1397	1397	1678	1	1	10150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUwCps7ZWLpyaEFZ6DhTkSsJuJy3LKB83vwbgPwzAzb4cw19g
23833	payment	2133	2133	1874	1	1	1260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBeCsKM4d8sEyw4TqzG7hYBd11kmWzK49GpdzzzA67UuB7vdK
23834	payment	2134	2134	1874	1	1	1224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUp8qrKpvxWribvFBbEeHzgaxcW5me53ZVPSkrBUfuoLmX681
23841	payment	1397	1397	1678	1	1	10153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDv91UmmKCGUyj8SYHua99poixH3Q4AZVLb2F1MPuk2iaZp5Q
23842	payment	2134	2134	1874	1	1	1227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPZfV6K6qoJeqzNQQ5bJaRH1o4Zf3STw7EDDqsyEjAX7fiHaQ
23843	payment	2133	2133	1874	1	1	1263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfS4eBs6xETAN7qegh25Bipj5SphpypcFmJhn3MLAdVGmDQMUz
23853	payment	1397	1397	1678	1	1	10157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHp4TPCT6XwhmYUneduQ7SiWEufwGLxd5mN3DnZnfwkiPLLgFL
23854	payment	2134	2134	1874	1	1	1231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4ww35g14JhyQFhFLSb7Z1W4jo327BgVnTmmhngxb6Ujf61rm
23855	payment	2133	2133	1874	1	1	1267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrevoSP89H87ta8fqBmD27JwfsiuUBPKP5n4opjwTGcXwbdF7
23856	payment	1397	1397	1678	1	1	10158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6BUrYYH2fuagb5LjQdQczEytBjrbYxAu8a6eipHa4Ncv8GSN
23857	payment	2134	2134	1874	1	1	1232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmjpZz9RUBjZjbU9BAPhqVDKSASzTqDQ2askWb6Yjwouh5Wra
23858	payment	2133	2133	1874	1	1	1268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94soomHE4uXgE4azZdSnD4mHo2CNKjHH9DhNSgmBesuHH7V3a
23862	payment	1397	1397	1678	1	1	10160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fDMR4HRHpKnmNFGgNThmGSKqEZFtLAEeBE4VwThtjN2T5EUg
23863	payment	2133	2133	1874	1	1	1270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtXPJoCHUXLhC7f1C2XSfFqZVn2LhRqGoPtsSFCR6bt2BuqEX
23864	payment	2134	2134	1874	1	1	1234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHXX5moSnWjCx5CNzuxEBG957JcsWaAK1Se7n775aBNNMon3R
23871	payment	1726	1726	2165	1	1	8186	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhsdKEurPjBLKTudysDKyNN8GAfQnxGNkg6qcvfAhvp8U3H7Mx
23872	payment	1397	1397	1678	1	1	10163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtHLqxV4WtMYfwtDfsSvX19Z23v6wU4SMGeygjxJ5LGvcFnhY
23873	payment	2132	2132	1874	1	1	305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjQ4NZdxrxwA1qrd3AdUvNzC4yCW52LZKNifWbt5YnseT7HXv
23874	payment	2134	2134	1874	1	1	1237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Kg6FbnMcsF6CW8cnAjdABrBhPBddk1kzqewwqbBvxgkGyd8M
23875	payment	2133	2133	1874	1	1	1273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYPBVQ8nLLdDREmpzQBoMSWyzWYHjASCZpTJCNEHEYiBNUSMm
23883	payment	1397	1397	1678	1	1	10165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJB9iztZS3AUTpFQiHLh2AahahS2gH4DrCyv9eL3vBUYBcvWcf
23884	payment	1397	1397	1678	1	1	10166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVT8XsKF57QYHS2RS5XUrAP85wzSfJgSGn5rsR5YRMNgVFRci
23885	payment	1397	1397	1678	1	1	10167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LjLcp17ZdUHRm39gj1tebSGC1A9sRsvDc94qa6vLZxihE7qb
23886	payment	2134	2134	1874	1	1	1239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivBXbYY6CXpqRqAv1rea2mZm4ZyvnVYf2Rsy9YBzHCE6Z1HJp
23866	payment	2133	2133	1874	1	1	1271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1vq7vgLuKWyKbLXWPgD8s2iBw7KtosBNbq5EhYYo8B3nkKJF
23867	payment	2134	2134	1874	1	1	1235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaY7KrQUgLkc4qzJeLNWgcAAgGkyhoWdNz3ujjoa9SwFVReu35
23868	payment	1397	1397	1678	1	1	10162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nVkBUcCfybpAwXTCk93HaDumuppsnJTnS4fb7BzrXMBRmy41
23869	payment	2134	2134	1874	1	1	1236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wkMqrz71H9SGH2tYhEx7B9rQkR3qpPxMSPHpJChJCrSnbVj7
23870	payment	2133	2133	1874	1	1	1272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfeYd5vJ8Ypk14NFQA2nUH4HAveDrKxnkgNAzMaYBtpnSmby2
23894	payment	1397	1397	1678	1	1	10170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XdQp5bt3kK26cYm3YFTGEweHkdab7m7WKT7haLJ73TsrBWqY
23895	payment	2134	2134	1874	1	1	1244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3iJvUW1oErotBRs1KoYYbjQqPya9gdFYXk59qenevcJMwGGUn
23900	payment	1397	1397	1678	1	1	10173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3JiF75EGLyWgwg8mi1DtNbKwbEbZC5oZPG14LZxEGuXb1jUx
23901	payment	1397	1397	1678	1	1	10174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVo6vRrJvTFcPSHmM4sGcvSbfTesvehauuUvZPTxPfwexWUyB
23902	payment	2134	2134	1874	1	1	1247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6K2Xhvq9JAHMohyrRydzREaACJ1dEhYXivxZAAEHwE5a9MXT
23903	payment	2134	2134	1874	1	1	1248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSwbYNsuMqHXohxRYYYhfwYYk1czmXCdbyNndEHp446Ak9WTe
23908	payment	1397	1397	1678	1	1	10177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMcJ5dASXSDQzftZ7ePSyRgFDzi237mtw5KhXHrgjSsUxKFfZ
23909	payment	2134	2134	1874	1	1	1251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTv6cTQbDQUkSGcqUxTAmVBMfWkuQLFZTjPRhhVaKzupb4a15
23910	payment	1397	1397	1678	1	1	10178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSofrWzv6uwtC6y4dT8S3tt6jfT36ykjontBVGLL5mE2CgyZN
23911	payment	2134	2134	1874	1	1	1252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa284Uhvc1U2xrJ6P3V6fRLinYiD8T1M9cWah69JPz1a5ERTp1d
23932	payment	1397	1397	1678	1	1	10189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfeZiBRHmaAB2Gs5CR6Sw1gNpvAygVHUHfkPNM1zfRMVmnQAC1
23933	payment	2134	2134	1874	1	1	1263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcu6bGzcKjf74q1F1ZCnZf7uUm8VGNfKGvCVSVbQKofhBQdeC
23934	payment	1726	1726	2170	1	1	8191	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbtzkCg51EYrqu1EBB43ivukwqLjB1SCtqBj3gkZw1qg5XRAXL
23935	payment	1397	1397	1678	1	1	10190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PSGgFx2yDB8zBurhFd9nEPmfrJ4qV3iNED4jtFpqRdtmCy3r
23936	payment	2134	2134	1874	1	1	1264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG6muKB7UF4HbvCxbropLh8tLncQ8G2mqbxauVBPvaiGEgUp8
23973	payment	1397	1397	1678	1	1	10209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaPtRMXKnsJzkpPwsijUAmmWWC1fs7m8D1WwvA1ridwJV1TQj
23974	payment	2134	2134	1874	1	1	1283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P3yYM3EJzqkrQAhzmde9tuw28aq9i5KDnYLyRUeH5xsvrysw
23981	payment	1397	1397	1678	1	1	10213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDv4DDJ1VTGvLqAh2WDwhaUWWDtebmmPrLm48Zop67fpXS4Bv4
23982	payment	1397	1397	1678	1	1	10214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQk9F7XfgPJ3nEz1nuZd4N6LksC4H3ceuxsm4zocAcrAf1hqB
23983	payment	2134	2134	1874	1	1	1287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuGVS4FRmarWy4vvy211JxrR6rjj8gHT1FLbtocViEZnvMCn6
23984	payment	2134	2134	1874	1	1	1288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVa2HPi5PRFH9mqmRxcWQZMGaxw1LsFCeSySZ4gSJqqDvBaX7
24002	payment	1397	1397	1678	1	1	10222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdcG78QXD6iwZ1FzWQ1idpo7t2eZcehYcwCWhwPV6PoBxFpbu
24003	payment	2133	2133	1874	1	1	1278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4729wp157cW6bwodBdiKRxSeFW4LmqaGAsSVDN6jHfTRNspm
24004	payment	2134	2134	1874	1	1	1295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyB7gFeeot8b9fYgxkMUVkUofKLC2sbTbdQPARXaMFKXezqCU
24015	payment	1397	1397	1678	1	1	10226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp2yDFRQyT78Dq2bbwAW8s9kL3Xs4yMPCHJmEuNAsySWvxycYk
24016	payment	2134	2134	1874	1	1	1299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYx8VWoSn5kEK4P6LNJmiCriW4iidnX34p6UtfVTjYW9gkbPLg
24017	payment	2133	2133	1874	1	1	1282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFozb3YQwUzcVk1pv9xsWJKEDC5aNiUDpiA9sW3gCSY1tHoqeB
24036	payment	1397	1397	1678	1	1	10232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1UzutdsJwoc11mxqjRiJds7F3QLurCEzDmSnQXcFeK87EDCR
24037	delegation	329	329	329	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rbxcSdJAu1zUCg8eQdJp7952ZZeoGCD1YUad6HLU1wNMzPTf
24038	payment	1397	1397	1678	1	1	10233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTpfLXuLQ8EG2R4FNaZLDcssn6isu1kWmBXds6BCi3m73mmya
24039	payment	2134	2134	1874	1	1	1305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeEPN9g1GGEERmToQddNC5z2arVaEXKvhYx9xi8cJrzLVzrxj
24040	payment	2134	2134	1874	1	1	1306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYaDEndCT4WVdPDw6eP2w7FRLFfT7TKzrGKyig5PRw8Zfs2jy
24041	payment	2133	2133	1874	1	1	1288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDyjJBHgAsfDQ1bmtjmJbiF6tLdKFLrQHNXNKJ6ALLGmoQihV
23887	payment	2134	2134	1874	1	1	1240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1W5a6h5WyiWUkDs4RLCc3dEBxuJRoeMExFdNcJvCRGwBNCPi
23888	payment	2134	2134	1874	1	1	1241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5x9Ti1D7oftja7pKmNkZKxUNThDtR7u1F8EugTRumhY4HTdyw
23889	payment	2133	2133	1874	1	1	1275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTnUAzogTGyqnCDdL8cDJGgWDjvn9HE4RQx4PhbsvJJa2XV5N
23898	payment	1397	1397	1678	1	1	10172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK17aRn58edHMhCXL1gStQHDYP4xoS8Nwgf2MMG1EYqmqCao5k
23899	payment	2134	2134	1874	1	1	1246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3VEez2jJ4VZSubHiFjQ1BnLyAmJxCuRQS1VD8NfgNxJfxzuE
23904	payment	1397	1397	1678	1	1	10175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9avCkdpTw2gWguEkqFD7omyp6pNuVUz14EA17fd4u1gY57bXt
23905	payment	1397	1397	1678	1	1	10176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCbpWqesMi5WqCfxaDeM2VyEFgCYpT6pjTQeqPpKAuuHS1G6q
23906	payment	2134	2134	1874	1	1	1249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TtF8a8xUSdcdzXb772NTC3VvBv3QzKuSRY6Y7PMoWNriNMp9
23907	payment	2134	2134	1874	1	1	1250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qLcNj37W21DcbTsRm1c8vydXJz2nwUN8RcKkgGZNs2QUHSrz
23912	payment	1397	1397	1678	1	1	10179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUpqEVs5aWu7dz7WVTQbdC2x2fPRpKevycz8nDtmtWBRihSbX
23913	payment	2134	2134	1874	1	1	1253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjANMHFu3U6Q4bPgohTZ1DXHCxbJq31uSTV2LRGRt9GUmRcpE
23914	payment	1397	1397	1678	1	1	10180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsEsnKkj7XKshy3iNksddHxTUfbMpyzH1BhUbafgQiqgkuYPE
23915	payment	2134	2134	1874	1	1	1254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSuwsbZxjJGfPZrGWFvsYv2ypyxAjZubitnqNGhGCkfKDdv2t
23928	payment	1397	1397	1678	1	1	10187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYi8ADAcpqpKhcpPYbzBmRKtTCeJyvhRUSCiktntyjQHYJYiF9
23929	payment	2134	2134	1874	1	1	1261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3KsEoYANk23uXDvtbSRtJBLTFBcvbuS63FmWqehmNZ1GqgCa
23961	payment	1397	1397	1678	1	1	10203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDqLDay1cBWchJFEiY4exnJuaw4PG7AT12CYYyi71AW3mooQ3
23962	payment	2134	2134	1874	1	1	1277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBo2V8WreYLS1aUrS8rwB2NSepooLF13ABxqYyh75JSHdGPXdx
23971	payment	1397	1397	1678	1	1	10208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHiY1zeBvSBpVhG4aQVERgMQCvsa9nHPtbMSkbKQsNEt8RHJW
23972	payment	2134	2134	1874	1	1	1282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmB8rXmQUNNQUJtn2rmaHnkhbGMfHgvscK9US8cJmZgaC5nHL
23979	payment	1397	1397	1678	1	1	10212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9mJQCpiQXUWgoXVFXbuXV6cJXeeKkm86BuxMdd7rxsrYTHqU
23980	payment	2134	2134	1874	1	1	1286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEZwZSMCa45eQRAuxnbwCU7hRy7yXmopgUGJpT4wvdv7aMUxoq
23985	payment	1397	1397	1678	1	1	10215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPVUvUXX8mU8ocHgd2DMJfPa5DAvMGCjNQqG6YQUvrGwoNFAr
23986	payment	1397	1397	1678	1	1	10216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eH2yHJYHiJL3YN6drsq2MAfLvVRgNiC2gQgHnFNGmQ6VUagz
23987	payment	2134	2134	1874	1	1	1289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAzcfNUBHYkMdeNHR3tYRPjvHF5SojDCDgwRZTxncw6qHcbhu
23988	payment	2134	2134	1874	1	1	1290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPpRgGfz7xm7bNHHkQk3qwHqvqFSnKLcoVoTZwp11js7SjTqK
24018	payment	2132	2132	1874	1	1	308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnwTFtszkzcWuf42vpyxoXhVWbs1aLayvsJtyFCxF2cZSQptG
24019	payment	2133	2133	1874	1	1	1283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4B5j2yZb3TSEpW9dTqpf3LPvbEsSYfF6B371PJu8sEsBtJBD8
24061	payment	1397	1397	1678	1	1	10239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdmZh2zQNsjfX1MS5DyTPueTCtXdkE2DSrpBJLNe7Eeto7AyC
24062	payment	1397	1397	1678	1	1	10240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFv1CXZpSj7SpD64FzLRfwfypoF6oLPS5RrxSMsSFWBsNeWxaw
24063	payment	2133	2133	1874	1	1	1295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qW6gzxXACfjYcirdioHXKBFu6vqR2vmyFbQh3f1xXR7o1YW7
24064	payment	2133	2133	1874	1	1	1296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYAhk3jw63FGg7Ch2gpj3iL4pm4ZCTMA1UVBVo6VaTJwzAjP1
24065	payment	2134	2134	1874	1	1	1312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93ihFbowRrzJYKkA8mNPnkCoBRNKbCYzJHeqzvmGTZUNeYg6p
24066	payment	2134	2134	1874	1	1	1313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpSNEjY6v6RdesxPEGBNqajs574bQmixu1BGT82t8TMUwoB4A
24077	payment	1397	1397	1678	1	1	10244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSd9gu6sSoKpe2tKtJNZs2B9siiy4GBTpBpzkAhV98q8VZh21t
24078	payment	2134	2134	1874	1	1	1317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigVzF7qKe3YnBrSPhvJGVwraZjQuMVF7c6VeFyELAfQs5Ld4y
24079	payment	2133	2133	1874	1	1	1300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaGMDAEzdtgZDtzmAMJ3Nvah4hy6G7Mfg5rYNEVPuuVRCrnjy
24080	payment	2132	2132	1874	1	1	313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1771oUDn5FbBXBcMZPkCpB1JjwCtgAQEqcEdXExkxfQsLoFc
24081	payment	1397	1397	1678	1	1	10245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYSetCWxLty3okWsi1iSrW157AHrbrb6ht6N5J474avHKJgaB
23946	payment	1397	1397	1678	1	1	10199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwfek4o1MvP9nDcjnL9QLmM3EmyJ8nFQ3SACXxuGxatRqqtSf
23947	payment	2134	2134	1874	1	1	1266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrw3cJDjKd42dV5iiNHtnqkLc33BRFa5Wv1tWcbn9xK84bV9x
23948	payment	2134	2134	1874	1	1	1267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxQqWaMsbT3qQiUtXC93HWV1ysQ6HhZEbYFL9RtFh8u7eHcJG
23949	payment	2134	2134	1874	1	1	1268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ844n4jwe3Vi5NkgCD9xGzrmkdQVakM3j4YFeTxLPcfNr6HzMJ
23950	payment	2134	2134	1874	1	1	1269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZradLrNpNJr4jFYPhVRj2aZUfSAWLHofZRKWaZKD4HX6rW9G
23951	payment	2134	2134	1874	1	1	1270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxC8btEdtA7EDeHW9LPHtUGTrWZBWq7YE6UiEjmpv9xVcrPr4h
23952	payment	2134	2134	1874	1	1	1271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKD7xcXRhK1ZH26ABff1mY8sZ9CnABpyvcYQunsEvwCpFexqVX
23953	payment	2134	2134	1874	1	1	1272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4SDKkGz4GChD2HAfmbrRRDbJZHHxVbYZZRJUfJjVaEogEus1
23954	payment	2134	2134	1874	1	1	1273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdJVFHNotCz2pQKaWfEideEnd84UHzazi92mT7zpY89wiF29X
23955	payment	1397	1397	1678	1	1	10200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN5CfCM7pArjnhZwsyzjMXDw1cmwqUeCsLNPqr9quGBvQ1oDp
23956	payment	2134	2134	1874	1	1	1274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiYFJSyFwQNjvyxfY3BT2EPBfhns8Hmbi3RFxJr3PorzPsxug
23963	payment	1397	1397	1678	1	1	10204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZBJBn5xp69uLtbsCi68Lm6h93uf3ib7rHpcyeD3NrbvwJH5v
23964	payment	2134	2134	1874	1	1	1278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPs2KYcygz8WLCWbDiTX8JfksXwxV6BF7Sdouj6b5pegqPWmF
23965	payment	1397	1397	1678	1	1	10205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhq9V3EHv9HU4kdjvkLAWysuQAehB5GoJWhFH3hU3PC13iLJR
23966	payment	1397	1397	1678	1	1	10206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCvAsYoRTso7SK3hKDSk8EkM25pN73ZjzQxVo82MftCMaSE4z
23967	payment	1397	1397	1678	1	1	10207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBgRVpXBVQZd6R43LgorGn2z2UjoQhnPzyrhjm9dDNAMKVjY7
23968	payment	2134	2134	1874	1	1	1279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKudZnt2VGyxdvey1uVYJ4x1LTbd9usdm15gPzSEmFuKJDWWX
23969	payment	2134	2134	1874	1	1	1280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vVwmE77yF6JK7X8SzeKVaXmjqDuLaq18GbFv9L1Ckk4KuNRZ
23970	payment	2134	2134	1874	1	1	1281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJeCwJCnBYCrtCbvqDCkLFysmobc2G9dXbCbMFUEcGVNX8tga
23977	payment	1397	1397	1678	1	1	10211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyCpqYBrvPJrmhmF4LHDuMW5pLCKU3ZZV29zUNN18LqSaJ4M5
23978	payment	2134	2134	1874	1	1	1285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhzDNy86FULkCjmsqMCwRWaTaGeydBx918KxkoHrDGRjUVWHL
23993	payment	1726	1726	2171	1	1	8192	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsrncaaTtD2gBsk9fBcuqYiQVRHPetpDucRQdU2sLpyEgLpNGt
23994	payment	1397	1397	1678	1	1	10219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs5jhG3aC1zfBkBKoN69GXNqAsgXC6WzFqQv4xHGvQpTL1sS1
23995	payment	1397	1397	1678	1	1	10220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwzsxUMWWxxDiKHQ5pdVquFNURa5319kZCYGH8Kg4nnnePDFM
23996	payment	2132	2132	1874	1	1	306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVwrjKvTQy3R1tYyTLdpgCHQMyVWSQHVGqvx35rP5yLEKSG1U
23997	payment	2134	2134	1874	1	1	1293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbo9xyH7Rz1zZYrvKZmFhTrmTvYnvPZPK8eP7Ch9zng6Nd1QAU
23998	payment	2133	2133	1874	1	1	1276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4y6CcnPN9BexTvbzFhRGkguvBhWBbVw56WeY5Gr7XVfmwgXk
23999	payment	2134	2134	1874	1	1	1294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMMdXLEfWp32x5cYPLgsw6V9CP7QFsbbxPNkdDdu4db9WHAwA
24005	payment	1397	1397	1678	1	1	10223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7N8baRVe2ES4KHmdLYcTDAHFaB5DbMHwAYfwEuG3tvDhU1LD
24006	payment	2133	2133	1874	1	1	1279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RjCvKzMTA1p32yv5vpWU147hs22wyEJvmkXKfzN6PDLqTQou
24007	payment	2134	2134	1874	1	1	1296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHQYXwrDWfyEJ2b5BxbDnnvZyCtqyViWUdwYrCBV5QYQVmTnT
24020	payment	1397	1397	1678	1	1	10227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUix8t14k8NmXCMPFaepesP2cXVAuJ5EnzsX9SETHrHr7ze9aU
24021	payment	2134	2134	1874	1	1	1300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bXN3L1sa81V3ERSRGyypMU6cMvU9ZCSZx7EJHGTKaZ9FcUSZ
24028	delegation	338	338	338	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAqYnmwJaitf8wVDiWUuMfBKPmbK5cHz8iHT6Egkm9dqs1H6A
24029	payment	1397	1397	1678	1	1	10230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFsXiDJ18GEYu2wh8QUaShps8PQERDtzh1xgLX8TV18kDE6j8
24030	payment	1397	1397	1678	1	1	10231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahfcBe2X34m4NfEzLq1JxADkJuLcP92y4cygvkMjV6LedMKHB
24031	payment	2133	2133	1874	1	1	1286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWaauCTbtaCa5bAGdgh3oDVv5YUK34gr1RQJtDrwkq8pziHVS
24032	payment	2134	2134	1874	1	1	1303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykvpuFxveENYFq1N9jeWkiM3fVo12tUo4rX5M8xMUvddZQnDG
23960	payment	2134	2134	1874	1	1	1276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SCc3uJWFzxLKFSe5o9giJfHcYcbhSzBUbTPghNmmEN6thpkL
23975	payment	1397	1397	1678	1	1	10210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HqgNa5CN94jMJAZBLsSyEdGE2LD4VkafxtnUZeXoaN3Mf7SW
23976	payment	2134	2134	1874	1	1	1284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpi3LSZvpNJvRfvEHXYK9AyLFfnSEGWpG7vCw1eQu26PoZ6Xo
23989	payment	1397	1397	1678	1	1	10217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYUtB1mfoVJMrjBSwQENxoVsGWcUpyT4hWWUK7QxqeKRximDe
23990	payment	1397	1397	1678	1	1	10218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfVqYDKSgrrwc5dXWEhjqmJP5BBoaW3WzXu7GLgdAVAFZD4e4
23991	payment	2134	2134	1874	1	1	1291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7BNJHfVWxvc74JvfLfgBPoXKiUeM948mKLQRRnBnMCJQZc6o
23992	payment	2134	2134	1874	1	1	1292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY5xAhNFSHHirpkwugEMqpswPM2u69NNynyDZFvCMStG8MGbK
24000	payment	1397	1397	1678	1	1	10221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpds2rLZtdUHByTQx3VD2MSYpBNitaVdS1L7qh8CJQbH8QeMC
24001	payment	2133	2133	1874	1	1	1277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvpwBpSc3aiEiYzApm19sPkpGoQjsbNXQxmvPwtbfrSU6Veex
24008	payment	1397	1397	1678	1	1	10224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3esvbqCa7goZMwZoTR1xivL5y83eLSJkHBL9dDKzuvRSt2Ft6
24009	payment	1397	1397	1678	1	1	10225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXk9jv5ukq5RH2q79ghTvdJjsEStsrcrSB9kZ277BEjyQ84XJC
24010	payment	2134	2134	1874	1	1	1297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwuBJdBMo7YwMdfRkHXuA8Evu21J1oAT1aaiB9VbZSgrU2TT9
24011	payment	2133	2133	1874	1	1	1280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvnNdBgRAAa3dLqSexFgV7DtacdeiwmvskKa6QVYqR7xZ4hm7
24012	payment	2133	2133	1874	1	1	1281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUFKRjGU7G4jaCXYf3RbspVMdEVGdkBkf7T9vVAG4yLRea1qNR
24013	payment	2134	2134	1874	1	1	1298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoh7KKuyQxNxpjbAxLAkFUm8tad6pS1skJe63VTPpcLiaBtcG
24014	payment	2132	2132	1874	1	1	307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAB8Hs6mMfmA2kW33pCeriYEJ4of1dSTHzNJGn3C2Zj6fovtuQ
24022	payment	1397	1397	1678	1	1	10228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWWeBiDYQEptDh3WfgMLEwigTGkaZjcNDSHt4MGQX9uauwUKH
24023	payment	1397	1397	1678	1	1	10229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfX9UHVGvPvmUGZqqkMNwhjjyVgwXR8WYZ7mVfcxpd6sXt2Krb
24024	payment	2133	2133	1874	1	1	1284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYavC7NZqH3RksSNTZbLaBbPsSBZfsZvQN844YNTSGjShE3my5
24025	payment	2133	2133	1874	1	1	1285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweDA1G9SumZUSFvNkGXuyyBEtrG4nSutqaFz468rAYGGWyrEf
24026	payment	2134	2134	1874	1	1	1301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyibdBEe1r7UXKcCmbUbWusQUdeAyNjBmUp4o9LJRstvnE6WT
24027	payment	2134	2134	1874	1	1	1302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4d7nkRN5ebnnVNSxTZ4eve74XRBsReBckNr4t2CiXQtk9dFrg
24067	payment	1397	1397	1678	1	1	10241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36mRaPHpVeKNajMNmbZ7F4v3JbNjyXCSbcffESJUQYzi1bYKn
24068	payment	2134	2134	1874	1	1	1314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHA7MMLUqh9MUpPY6Qi19jQLdbgcPV1eFQeBV44E8r8ZCwBS6
24069	payment	2132	2132	1874	1	1	312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuhH8HrHwKxW4ehknjMaKWRyRXCsu2aGhgCBpE9oSBvJMrgxJ
24070	payment	2133	2133	1874	1	1	1297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM5rg4gkFqJREsfeaMNCGJTWXeZYaFSMn4P7frGTtz7vMjZvi
24093	payment	1397	1397	1678	1	1	10249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAmjSdK4u2GKpULiqLXw3QhBobYQCMEej6r49pDvx7877yuTj
24094	payment	2134	2134	1874	1	1	1322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQQ2K6konqPWUhaPU3QQoKaJRDskKBREcZiLRLoFWqvTCtGN5
24095	payment	2133	2133	1874	1	1	1304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb6PGP7uNJKuG9Cio4mGcZfr9bfUbBSUs6uwHDANPVN6hPca4
24096	payment	1397	1397	1678	1	1	10250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKjeMh1Eh2kG6kTw3TqHPYxXY3D5eFeJxf8bxQNxDd6FAtKPG
24097	payment	2134	2134	1874	1	1	1323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LUXuEmiXeNFBF4F83Jmf4vYPn9KRdms6ALWpUM7m6MxC13KY
24098	payment	2133	2133	1874	1	1	1305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9scKDhPs837RyWsb4UeoF98NXChJqkCmMNDn6wSEdoroRnjF
24149	payment	1397	1397	1678	1	1	10265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStGbc9aJFEtRnDuQdE4GnuZZN7pV5tSzBKqHXsAsPUioknh4k
24150	payment	2133	2133	1874	1	1	1320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuedE6k1X2NCpqiNY3Cqm9QwkKzJCLfRoxhqVqjfuW9kAF9xw
24151	payment	2134	2134	1874	1	1	1338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX67w4HBQmVSAAXs6aGsL2mRSEhEE4kxWgMMrY5gUTus1fW4kw
24161	payment	1397	1397	1678	1	1	10269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVapMCdVeu3dJ2U7zUtPvDwysM8VAt8SgQvFT9qQ6RPC7a1ag
24162	payment	2134	2134	1874	1	1	1341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJHKNrEt9yjGq5dc97udbGFw4wWNjMg6MUnjy5BT3haWbDbEw
24163	payment	2133	2133	1874	1	1	1324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLkFBVNd1pXXPYcyoRpGeVujykLeiqpcYwXQRgm48Wcqmm3bsa
24033	payment	2134	2134	1874	1	1	1304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsLB99tpi1ckr6SqFvZN791oexQaAzYvGJa3qNxiLm7b2sahK
24034	payment	2133	2133	1874	1	1	1287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQcgmkHcioUwED334nFNf9zCpFmG486mWef8XKDNXnoqteCPE
24035	payment	2132	2132	1874	1	1	309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmC3hs9z8dCb8Md7NmL2QU5ixehFgwvXpFUPZ7m3W9WkYFzkGS
24043	delegation	1789	1789	329	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhYp1eirkqtj7MzoDHc94Wu1k7LmKzYrTHjJghwKQtGb4rx2e
24044	payment	1397	1397	1678	1	1	10234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sZEgzNShNT3v8on6UBxvRk4yWt5M8HYjzAyXoc32Ei8SrVGd
24045	payment	1397	1397	1678	1	1	10235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vt8kAmg1B6TXnqkXK1xAeY9SDPh7oWLFmFF2mDSzJDtSzmo6
24046	payment	1397	1397	1678	1	1	10236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4VSRwG6KsCzzdxKYq7CFtp1TpKBXds8tCKV1Mfzq9T9H7V45
24047	payment	2134	2134	1874	1	1	1307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpAVv6nJ5eEcjhiFEu7cBNVAiUTcDZtKb667cE86AsQuG2tPQ
24048	payment	2134	2134	1874	1	1	1308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpEYV1gnvZC7SftSgjmZXJqWRcwn83NkM2BeCjWNSvALyuMZn
24049	payment	2132	2132	1874	1	1	310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9txeJVKFLS4bwdPeCEPrRToL6bGnc8Cm2m4V5L27vRYQmq34B
24050	payment	2133	2133	1874	1	1	1290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDquUh84LREtKPr313CMVWpBLMNPaJX95dcxthG7dUsi4n9ka
24051	payment	2133	2133	1874	1	1	1291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN8uHwRQ8gVexZFWFyRXoXmKRwpF8tfXeAKLw1dneSc4etS6v
24052	payment	2133	2133	1874	1	1	1292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmeyoXEKwJLbeoC8oYLhrDV7u9zRpuJrfd5fgL6AXG1bs74Yb
24053	payment	2134	2134	1874	1	1	1309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aRMQGCJTkSg3axa31TqjsjbccSVmsqJYhXvZnr3zooYeEuYw
24074	payment	1397	1397	1678	1	1	10243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALcQEqootLcc53cw3oaTqrmjfBSvyrPu42zw172CNsoY2NXT3
24075	payment	2134	2134	1874	1	1	1316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXZCEE6MUc3ghftuYC84pb3TLEpuX19odzMX2DwA5ATGJJF9s
24076	payment	2133	2133	1874	1	1	1299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HSDzgFV4Kg36cwfqGYFco2nJrgRt3gyFVzDobiqax66hkZcS
24099	payment	1397	1397	1678	1	1	10251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDJnhJnJbNPyJag5FHd2SCQ45aMz2NYzjdsDRNBTdmKH8Ndbw
24100	payment	1397	1397	1678	1	1	10252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJbsHmB3uy3dM1AykQDyLyp3NbeYq3gjvbrPfuYexfGRkZLUA
24101	payment	2133	2133	1874	1	1	1306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoS5C3gnQMSQcddd3whSPKwzec13qintpwRXTGaR1MjZ7pH64C
24102	payment	2132	2132	1874	1	1	315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFra8Kzm8Z1hmvpwp7gLciq8VHVk8m8o3r3qbWAxJaLqvCudwv
24103	payment	2133	2133	1874	1	1	1307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpGXy9FArxwy2RCVyneYCa8sAGkUSJFzsCr4xr8u9Qt9NRuQn
24104	payment	2134	2134	1874	1	1	1324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpdeBnphP8aLweR6M5X8zjnHSKEvXJPuYi7tmCVG6JRVfdC9q
24105	payment	2134	2134	1874	1	1	1325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisGdSmrHhDiaPXqkiUhP9ok43VjUA95B8sZbtTzVRHaTsRmpU
24113	payment	1397	1397	1678	1	1	10255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpE56vJ8vKb7n55ku88k2vmqAS3vYuMi8q84dAyATmuLdnmhu
24114	payment	2134	2134	1874	1	1	1328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiw4axSCLfCJ42UDKmtEehFE1HjWckqZfk7tXLcxRtXrKAgatR
24115	payment	2133	2133	1874	1	1	1310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrcbkyV1HzMmZbtjiwu3atSin2UWRK5XH1a32TCfMDVS7njP7
24116	payment	1397	1397	1678	1	1	10256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXAVgKbxaDdxnwCurgvZFez21KecwPCpmPxqY2VAsd8Crna9n
24117	payment	1397	1397	1678	1	1	10257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBGdDoyceDu6b2SBwL7KrNWHZGTzDLTUhcZzGNHEH4pbaCkaF
24118	payment	1397	1397	1678	1	1	10258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDRtNGzP5s8mkXs4kp7YvrSrTvHLFPH6GkRrMwiT8F8DgCRUG
24119	payment	1397	1397	1678	1	1	10259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5K9fGCUHCvTwQd91zVVk2aDvY5V7mnfMC6XkTh3hcMJwBFsh
24120	payment	2131	2131	2172	1	1	0	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpYii1xw89hhqi7gStJPoZNX7AvNBW2BsonvR3Kq8K3myxmQDWXA
24121	payment	2131	2131	2172	1	1	1	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZFzGojWTuDqj36D53sZhsZnJD6RAWBSxe6gkTWtj6FFf5YANY8
24122	payment	2134	2134	1874	1	1	1329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzYBKfBKfyPY2byeWYVau4rTWWpaBN5fvp8kQ9BS2ZZ7vygDr
24123	payment	2133	2133	1874	1	1	1311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZ5XbwYzTUDhQThBNvUyamH48Sh5chmt5zfFNdFR9dP6sKbKx
24124	payment	2133	2133	1874	1	1	1312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge6zASdBcr8F2NwYuH471RAz8yW7EQkjXn9KEhcDYqxRZ9bTr
24125	payment	2134	2134	1874	1	1	1330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9WBAtxQZS2RMs2Cd1fqsvGJUJhFbzDa5VrM7trNTpo4wZqj1
24126	payment	2134	2134	1874	1	1	1331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEwaNMkNi7H44T4Bc3xpStSn4Y8ntFdwkF6DkuEpuSeCLzg3C
24042	payment	2133	2133	1874	1	1	1289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbEz5znQS7VX2LvQPcv9QnASNZNVcqpU4gUMRDyEQQVaP4Ctt
24054	payment	1397	1397	1678	1	1	10237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFqDqQJR8ssWY11EqNE8Mn624WXjWAexqf3BH5cJJ8UBGpMCTz
24055	payment	1397	1397	1678	1	1	10238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqMVJTwckADtBzYbs9vzTvTd8uHn2MHyPN5hsD6U272K81kNJ
24056	payment	2134	2134	1874	1	1	1310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWK318zRXtaejHAJm36Rg9ixmHmFzgcXZJRWx2uhKoHZaX6HBW
24057	payment	2134	2134	1874	1	1	1311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYit1wpdpQjd32JXrWRga88gwdkGDWHbi7sYfMK4vuBypR4APKs
24058	payment	2133	2133	1874	1	1	1293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxrNFdnZMEnbnU16vmodGxKYTAyYCd2c6bfjnAj1ypmpN1eJf
24059	payment	2132	2132	1874	1	1	311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVuWEheS4vydcXYTcNdgKqhHM1p19cUk5ffFABmcpBsqSsKVv
24060	payment	2133	2133	1874	1	1	1294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGSNWDogoTBw7MX4eXM1RuzzNYxtdKKzXbdLokvaVNqo2Lb3j
24071	payment	1397	1397	1678	1	1	10242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZdKd7oxQoLUwG5Rpc97HnEtnfVBv7L1TJM2ZbHhHNRJRi9SE
24072	payment	2134	2134	1874	1	1	1315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpWtBrCXXJ9iZfMwMWXCUnWTwpeBPsK8m82ZJokYvsWBNi9SD
24073	payment	2133	2133	1874	1	1	1298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVjaKWc6t992HfJGtBsskj9Vsrh4cVczVLSYf4fwPgB7cQ8Ep
24106	payment	1397	1397	1678	1	1	10253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXM9gemaDBRoyS46kWfW8SD4stGWv7gZkw6RdxySKLxndDh2jY
24107	payment	1397	1397	1678	1	1	10254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTUaCY5wV6YxPxF2U5gv38JpoyzscsBsfnnzTZwzeyuzWDfU5
24108	payment	2134	2134	1874	1	1	1326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7tqp4WZRW1d6kepSzwcvhfJpa9QwLbWTZ8qxJcRZPKWpS7hD
24109	payment	2133	2133	1874	1	1	1308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EndX7nzKd2bs5isc3SKoZhoBw2VRDzPhSa18iuWpaF8Pm6SL
24110	payment	2133	2133	1874	1	1	1309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA7dGRHe2c1MFM7J1JHKc7hpNKh99q6N41eT2KLTSLkx6av8f
24111	payment	2132	2132	1874	1	1	316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbNsiQCx9aeLFeHDP8yTax92JhYwo191XiXdTbS6rn5mKvdGy
24112	payment	2134	2134	1874	1	1	1327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpvWHrvksrY9GY74c7sxUnnpJAVQUXKuAChLrrK4wcFuvgNxo
24184	payment	1397	1397	1678	1	1	10276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hhdMPy5fpFzbZbtdzVvR1ajjaupEnNwLyC1qe1NmHus8y7z8
24185	payment	2134	2134	1874	1	1	1348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM824AeqCK2E1aKEosW1ybgXprYC9bh66Dpt9hrxj2XH6g3v5J
24186	payment	2133	2133	1874	1	1	1331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdxg4PMbC8bY21h6sWS3npPkKxUffBk9apr8wSzwtxBK4DUuK
24206	payment	2134	2134	1874	1	1	1355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPX8P1SrCRVmgLMjBEP6XP8X7HdXHwX8wbmaSR7b7JzxD6dV7
24207	payment	2133	2133	1874	1	1	1338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEejKcT5rGFPEp6LUKUk8DzgURXg65FmEop3MW1iN4qvQddRRH
24208	payment	2134	2134	1874	1	1	1356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTE3X1FNopDZ1BHX2sEngCwByUUReUPzHZsCQ3LkepDHfhs3ND
24209	payment	2132	2132	1874	1	1	325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqzuEhbiu28YzziZbrV6xdhhfCVYBmpF7LaXJE3AsTCAdhPCb
24210	payment	2133	2133	1874	1	1	1339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEBZJ7swgiE4iRb5PgNvqaVSZoamEUTVfE3uaEtfoP4cNgXxH
24217	payment	1397	1397	1678	1	1	10282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cLTwY2SPBA1PAfZQ8EWYoD7AdVnsMyd3a4jKfJA7pKScMAPT
24218	payment	2132	2132	1874	1	1	326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9ysQGLvFtED4ceDRKvpTxs46KZdW1Z8Egc35VH5UPmeV3tKY
24219	payment	2133	2133	1874	1	1	1342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj51vvzqtZYcSQLxzpPYxhNtijBUEYTPNcrRziLzJHXtrRy1VV
24220	payment	2134	2134	1874	1	1	1359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZws3NfqkAhvSskhAdud13V24rozB12jqCMAomsUzJoxBQV9MNS
24221	payment	1397	1397	1678	1	1	10283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rCd2UvGXWWaeJ8iN3oqLNASK6Pu4jQpGg1V9op17bg7j5rnH
24222	payment	2133	2133	1874	1	1	1343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9zUVKjzZM1naxaLE61bGVe4hQ5PVB6HehJnzL72qUeS2uwW6
24223	payment	2134	2134	1874	1	1	1360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwT77UaXnHWDV48u4sFsiGVHyeS6NLLp8aZkkynVgqFf3e3Ag
24234	payment	1397	1397	1678	1	1	10287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouv41nrzZrwa6TuqLCs7ZynCRNrjTFfRr81G94ZhyrqSTo1H4
24235	payment	2133	2133	1874	1	1	1347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRVjM7hppWqzRjfJpNnQDCfYxSE8jHKVQVkN9LZHMqKKakLMk
24236	payment	2134	2134	1874	1	1	1364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo678Pq1SX3hwXovukjVPfZiU4L7bQgBXYmk6HbdANuyq98x17
24237	payment	1397	1397	1678	1	1	10288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4XGtJhrYQD4gqW9xUXLUWAie7NQF2V4mhBGLV4RfXLC91E8j
24238	payment	1397	1397	1678	1	1	10289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4c9ugwDRjgi6imKAeBqgUrLhkkZBRdUicektc1VXNG3nBc8E
24082	payment	1397	1397	1678	1	1	10246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaekhtGwKZ71CsJFMCoSbTpiT9s9keveX6mjZDmhPyCr8xei1
24083	payment	1397	1397	1678	1	1	10247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNxMJNQ1qDEYf1fgtioEHAjJUB6P2bdr9oFxe2ibRgkCCNgMU
24084	payment	1397	1397	1678	1	1	10248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19WYxfiytWDiSh6mevXZ44c5Vk5tBpVM28TERp3T5fvLPDzi1
24085	payment	2133	2133	1874	1	1	1301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSrUDRdJJekdAjX3ABUcq9htudNBRC8ZLtoBB5jHiNE8k2jcr
24086	payment	2133	2133	1874	1	1	1302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZdorWLxMaT5Zc4hJk9HPBAUgiM2rpXrh1nsf9Qe8vyVeGfxP
24087	payment	2133	2133	1874	1	1	1303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sb6c8PwL9EVf7TVhNrfRMoEkumHEyzNAzTYbfyyb7dXNL181
24088	payment	2134	2134	1874	1	1	1318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9UKAmYD8VokZNurhWw45mk3MP5nGWkYmq1N5D2fmDPYKt6Qd
24089	payment	2134	2134	1874	1	1	1319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtEP1cJ7U12CXSRK8c5fXWpKWi9LgnLbRM4aWsW5kcewCgxzb
24090	payment	2134	2134	1874	1	1	1320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVycgYgb493h5QxQpBNT6dqbydqbpxKqvwBASqjJDg67yauUT
24091	payment	2134	2134	1874	1	1	1321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTR9Rq4QxUBaLfkzqrKjJ9GriMNBZomonEMteR6CWJ3o4LT6J
24092	payment	2132	2132	1874	1	1	314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTkqf1BkHUDRdefs6JETnk4YW9GLdsUa5TAnJAXTpSzAzBBsm
24135	payment	1397	1397	1678	1	1	10261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCZ5okmQn8oSZ9agh7mSZwFq3vXFs7JUgqesTvKxL7pnwoCes
24136	payment	1397	1397	1678	1	1	10262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaf1qkjsfxrnf3dqLy4Eps86qptThxUCSuPTKkGPtnYP9QA7A
24137	payment	1397	1397	1678	1	1	10263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF365jn9UrCJhKWoc8vDvR7LdJkFDWDQFWAZ6K3JhtcdHf6WV
24138	payment	2133	2133	1874	1	1	1316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkjzEnqLtWyVoFsjH2PKy8HJqLgjYYpaiDRTJdBiYpoGtv3W2
24139	payment	2132	2132	1874	1	1	318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfZY1Um1gpMukj3mv1Gnqw5A3j8XAhy7szMAZcgqhMFmWXQrk
24140	payment	2133	2133	1874	1	1	1317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAyTGcpGApYH3Lqi15wR46tKLe78oqHSatLM9KEfboCmudb3e
24141	payment	2133	2133	1874	1	1	1318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMUc1hPRTxrWyeaUsR9u2CZCooKJg7ERq9zdHQhAmCF5AZxU4
24142	payment	2134	2134	1874	1	1	1334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwGMoBn2LmpU8gLvFGbmFPxK5vUHzLxCqn5XE5t5dejJW8XfH
24143	payment	2134	2134	1874	1	1	1335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjyYQ6JCjSziLkb6kUbQ4oYe1EWRwMJXPXoLN8oKdUwWLAsiP
24144	payment	2134	2134	1874	1	1	1336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb6Sqv11fGBqpN9s2TvBfnBEBtCCk4DiJ6c5AoQgRr73dwJ76
24145	payment	1397	1397	1678	1	1	10264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8j9aWidb1RuJVHTFeALKN7dACZemsgSxNeDFf2x7gdDcRXd3
24146	payment	2132	2132	1874	1	1	319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJqNLy8ttgT6Jnym9PqGcBqZJDLN31YuABxAZuqas1oziyadw
24147	payment	2134	2134	1874	1	1	1337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhH8qXZ5FDMcbX1Ut99MScGMp55FcHBCWBEubUW5pZfkmpURGJ
24148	payment	2133	2133	1874	1	1	1319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnw9yk51pTSJ7wVDZPZZ3GSBRDdQoH8CEE1TztWB71ydAUtkrH
24158	payment	1397	1397	1678	1	1	10268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNQNdkK2LujLPbVQxPLm5Qz6EyPkKFuxa5MGqaAhqw6AMW8XS
24159	payment	2134	2134	1874	1	1	1340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsZFrCrF4Pa4U66BSVgQwgncs6ri7WvJg8ASJtLTZ4wyb5ERR
24160	payment	2133	2133	1874	1	1	1323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMvr1R3teRFHGjZASE2CPwMnNxG7qSUbZmQHnjCWw6GwydKcU
24181	payment	1397	1397	1678	1	1	10275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeTAgLAN9xwuVYv26ademqXaL6tDYDUDdaadWLJsGx6TgDfFq
24182	payment	2133	2133	1874	1	1	1330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8R5SZJT3rfyGgpXT6mNJkbscMAWrGZ4LU4xoCuN2nAvQsMQ7J
24183	payment	2134	2134	1874	1	1	1347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJb25Km5BxMiKW5pM7DBaAA3g34EdRivZUEDTzmyHPwKJYFPe
24194	payment	1397	1397	1678	1	1	10278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cK6jW9mcF4yZ2uhYokiGVRiqqs6YLGspcKaQwExDRVFis38y
24195	payment	1726	1726	2174	1	1	8193	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZR8TiEmpaBSzcMPRRRTC8Ddw7YLKaDGFkmb8QyKs6vcSbYdsTy
24196	payment	1397	1397	1678	1	1	10279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVRFL4VZkctzCb1uGhWsWsP6zcLztsNwYRU2dcm4TvXPmmc6S
24197	payment	2134	2134	1874	1	1	1351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6zENyQG5T9ErfvJmkKajRJ6sW8fuTt9A4xMF4Y7Si59aKjtU
24198	payment	2132	2132	1874	1	1	324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXyrrJZhR8xs4F1PaZNrDxmD2Yn8ZXSqpF2QhVxMn1zhMWKHr
24199	payment	2134	2134	1874	1	1	1352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEr3GctNErWes7Nn33mmXdYdS7qEJV3Ygq4G6ycScFN2T3qpU
24200	payment	2134	2134	1874	1	1	1353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2HCD2oYK1Qrc5D3fsr5VSjnb5EVUCmhWVKcTaPzyAJcZg15p
24127	payment	2134	2134	1874	1	1	1332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gF9oeePBb5Lc3nd43EHAnxCRTS19HaWHVCiGF4k6mofrNYwR
24128	payment	2132	2132	1874	1	1	317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83XtGeS2pXb3gAo9wsWHmg5nWFMiDMBpY347Ybb6bP4pvwLA1
24129	payment	2133	2133	1874	1	1	1313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbdLS4rEdeokYNDgtzWQx2tcbr2CLoHXpzJnkzWqac1eqaFBh
24130	payment	2133	2133	1874	1	1	1314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMDqua936Tdb3o9h2HFfGVGxKEzSNfGa6fqxTqVAKkm7Ugvbp
24131	payment	1397	1397	1678	1	1	10260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQwohJMC4uWxFZFNkBH9cNRZm7juFsfzQHewmPE5UsGvGatZ1
24132	payment	2133	2133	1874	1	1	1315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPFQJEQcUzZ41LcQX1THhVzXiS5h5dsYPUgiiA7p8xwhTJ7WD
24133	payment	2131	2131	1726	1	1	2	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZBQHreAMwLzruMqhX59fThqHSnwyXdfbCwDGH84W5BQ3y2PDcR
24134	payment	2134	2134	1874	1	1	1333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtpnL1q8Zqw2DFWTzraU87u3EaAnxd8rpvczBBAyeENeBv2qg
24152	payment	1397	1397	1678	1	1	10266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5phvTjdHmotLEGYydmTJeGeEhsaH4xm8ZunizNXikTQtZcfU
24153	payment	1397	1397	1678	1	1	10267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZsjKWX5bzBLrEbkTvwVqZnsyenTL2R8Tb8mSrsGtRVojDwFz
24154	payment	2134	2134	1874	1	1	1339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRE9FbJBtkDgw1sWnFrzyQ8kUMi1nfTaejzMoGDKUzqeBBZ5iG
24155	payment	2133	2133	1874	1	1	1321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5Yp6VmApxj8PFiy4Bd7iH3tVpqdPeTtunAzC7nrCLyaXCGoK
24156	payment	2132	2132	1874	1	1	320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuH8UQcbtRmmkBU7FoUPj4oVsjSag3qq4h85whc4HW4GsyvWB
24157	payment	2133	2133	1874	1	1	1322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8cxQ6oJKicTiEsX6G9nqPgS2URQvBgyK4F3AnZsw4uXSULfG
24164	payment	1397	1397	1678	1	1	10270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpmmggcPXP2FYZHrfvKZ5HF4xkSBV47ojtHdoXvkVJF4LVRVW
24165	payment	2134	2134	1874	1	1	1342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHXQU47SEZkRUp4EjbAiHuvxD18tVNbzMpKW5xCEu3iNx1SmE
24166	payment	2133	2133	1874	1	1	1325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BfDStFJHvQtsc1koasQ4fyMHpLxqwdTM9HKjXfQYcCFc4zyx
24167	payment	1397	1397	1678	1	1	10271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkg1iY4AyRcDUZf8EXqNio7EwwJSkirAQwSDyA7syudekddpxw
24168	payment	1397	1397	1678	1	1	10272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGHmgYqGx4chMkZtVT1RH6aYigF6Se1VXmd6e54qCkB5TL2Dc
24169	payment	2133	2133	1874	1	1	1326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyH2yDoFKPQwW3jDEUQZEwUSxyP9YFCaNtcWpnF8zMBrm8Sfd
24170	payment	2133	2133	1874	1	1	1327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwEDn6Sn656zwHnZ98VhgZk4sLe6jYDwugyE15637QDCFuepY
24171	payment	2132	2132	1874	1	1	321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYcabvR99xE3ozoN9KGz2kcVM8MPLujZ7xChiDes1P6Fe4Wrp
24172	payment	2134	2134	1874	1	1	1343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLhpX83htN46KM7MT2FDvdrVMXWFzPKQPdqQ2UGxq3SJ2m2wN
24173	payment	2134	2134	1874	1	1	1344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFvHbgd4NFTP6YmUcDd12geJkCkzLmJvphqkGswhpELEJcNae
24176	payment	1397	1397	1678	1	1	10273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2LQjETyE1hrPNVFWiq1gZrug4VPmxVcrGBvhxSDwZ1NP8n1j
24177	payment	1397	1397	1678	1	1	10274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rHzmgZTsw9noKRwpLBBw1Wf41h6e41kK53xZDgPGTU942WdG
24178	payment	2132	2132	1874	1	1	322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEuVPM9GZjQReqvdsYLfmnFzaWg8N3t7zyHqbTvVvperDRHKR
24179	payment	2133	2133	1874	1	1	1329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFaLxLqc3Z15pDC7QGaNDEjxRfgQkUXATvN24h154fYNvqTFR
24180	payment	2134	2134	1874	1	1	1346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXtRAvmdMB88A3vG3chp5xPivDc6vimPQ8ffFpfpZFUFAMKzw
24189	payment	1397	1397	1678	1	1	10277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDE6RmPZuYLmKSnKonwpHBdb9QZj4f9Zb5zQmPKktpFkdxjuuU
24190	payment	2118	2118	2173	1	1	0	2000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYyDUUy46xaXi6R2a6E1ewe3ik8Fv9gcrboij3LvW3KvVSkc3V1
24191	payment	2132	2132	1874	1	1	323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJRHsQw5hvJp3N9LKSMF9Fwc5GP4TVY9xQM3AJJC67U4QRsoy
24192	payment	2133	2133	1874	1	1	1333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBniK8Wzfy99dRQdwfwvviXFfXco7zGm8rv26PYUkmxKavBRNV
24193	payment	2134	2134	1874	1	1	1350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbGvhVst5uF4GJRDGeywjmVrjFTwS8BCHNCgiyZgQRkqDHgJ9
24204	payment	2134	2134	1874	1	1	1354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdvVTR6eraZuUKiSuLtamPF4kcQ7AcSQFvAYe7MSH1CWRdjGv
24205	payment	2133	2133	1874	1	1	1337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49R9HEJGPcgmVGb7VJNz1a7J6E5Ry3iY98SkQng9eYw7xLxht
24211	payment	1397	1397	1678	1	1	10280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H8ELReKQ4F9iJFrZcSx6x8RwbNzCMkSYHvuoV5ExdgRwiYjs
24212	payment	2134	2134	1874	1	1	1357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwjX5ZMUpgFS89TeH75tek8Je1Xv4jnC7t4YdW9kMvxRN45Qi
24174	payment	2134	2134	1874	1	1	1345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfS8i9WLK2Vfx8bL4GvpKhMcf1EgrqPAySe9QRkz5cXeTnFPz
24175	payment	2133	2133	1874	1	1	1328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRNeLGTMGa3whL7eisD8ZHxq6jaUGLruCK3QhGhFkJhSrzofq
24187	payment	2133	2133	1874	1	1	1332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzrkn3WH8PFJREFwQ89XQFwycg6GDY6TEs7fYJ75EfEzcWUqV
24188	payment	2134	2134	1874	1	1	1349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JkHf9LAwdXmkAndD6GBNyLkJ61fNzf6DVhnZoWsx5CXVEa7y
24230	payment	1397	1397	1678	1	1	10286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvETr4ohZf9eag9V4W5CJdABwj2k4NhzQRb2uDR4zPFavqzjv
24231	payment	2133	2133	1874	1	1	1346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z3YPjL6WEC7mTVb8meYvSwu2Gor9WfuoLZSqMUQf9kciMcB5
24232	payment	2134	2134	1874	1	1	1363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGD686UkNnNi9ErZWhFJZoyaYsKRX93xQBUtvngGjvej5fJ6JX
24233	payment	2132	2132	1874	1	1	327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGQoJfHX21MNB4vFwbQ5TmuHLVpmkC7CrwVAF25Ap8NX8mwhx
24244	payment	1397	1397	1678	1	1	10290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhriTok5gMAtqHMfzZrfj9BUAYHzRkfyewBTMaL76nh68UoGwK
24245	payment	1397	1397	1678	1	1	10291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DKVpqEEf94nfotGwQS1xawHt5oEEF8GY9ab2WJYSrZkh36Lx
24246	payment	2133	2133	1874	1	1	1350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrzVMQV3DBsxfxaXxcgKHvosQ1BxgFwCV5PmQ8NwQZtEiQuJdq
24247	payment	2133	2133	1874	1	1	1351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrerdMTzZrHs6JUCYS2qmGrTUWny4ws83fwYJxaKZLTgzxUupm
24277	payment	1397	1397	1678	1	1	10300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWgBtbNnUJ3VHPwfKkqQQCCWaEpVnUAwro2uFpTKxnees5j83
24278	payment	2133	2133	1874	1	1	1360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWdUgH19gwRHr5xP5ARtzxU9WdKpDK4CtQ788BzyvqT8n79oT
24279	payment	2134	2134	1874	1	1	1376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJfaKvwmQxxajMFuMNNtfgJVKioT3qu4MUd2E74CsJuhE9Hb9
24281	payment	1397	1397	1678	1	1	10301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78eCVcGpxBBCSHKZYyeyqbHsrZYC3XQ4j4Jb8xm52PcAMkkN2
24282	payment	1397	1397	1678	1	1	10302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoW11os8gMvcwCYAZ23ELiCBoX2pj4hp6NujVJYQTCeNwb9R2g
24283	payment	2133	2133	1874	1	1	1361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXSxM76jdAwhN3sF9gFqc5rPGjrpK9N5CmmdYYeAt8Wynmc2v
24284	payment	2132	2132	1874	1	1	332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyLVavjbqJbLF6FkP7PdM1VerrNcRdnZTjzB7JAC53hw9PGtm
24285	payment	2133	2133	1874	1	1	1362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwWt11RYt2DzQNuhvqWXxeCJtD1pAWybv4vMTLYidCVXNCmyy
24286	payment	2134	2134	1874	1	1	1377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABqqUFPn8vuTb9yuJdVS5LcbuXTtLWp4Kq132dtKYwLPuKj1L
24287	payment	2134	2134	1874	1	1	1378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XzN9LhmT67FMRZvae9aNDPiTJ1cCE2zNqD7zJdXduLs6u2jS
24288	payment	1397	1397	1678	1	1	10303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KXFGM2551f8b4GQtZ2Dda2Ea5q5kisbZLXn4kpeEF5XHjTuS
24289	payment	1397	1397	1678	1	1	10304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyUJuXurs9MVB2zwgEH2ryZakcwXMG2W5buJ2VkGgAzSMRh1s
24290	payment	1397	1397	1678	1	1	10305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEz3X6k4NoP1eqXYCq7TGbT83HfqKzrghn6nhntgybF9R18Rrc
24291	payment	2134	2134	1874	1	1	1379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjtrxPJjKfPzrNeSJ75CBK7vY5o23KhfbSXzRtgDVUYdnTY3j
24292	payment	2133	2133	1874	1	1	1363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5z13eC6kAiKc2TjRPtBe4iJhEiaforwcip9MmdhdDhcPMuoA1
24293	payment	2133	2133	1874	1	1	1364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39WmyVEymdnQGCqtJ3e9EfssobsLGH9ZsPG5V4CUwwSsyqG2S
24294	payment	2133	2133	1874	1	1	1365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8S7ECJtKQqHZQNns2VaYgjVwNai4hwfFqzXUz9xDBNdtgr5FW
24295	payment	2134	2134	1874	1	1	1380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZke45LcNJMYwoUePTG1RD6pFvQE5J27n9xEV4pETrjMAUuLgd4
24296	payment	2134	2134	1874	1	1	1381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D2goXFtEbbeYxbXRyEd8jVrcnJJULnXFYBmR7daFmDDU8zvg
24307	payment	1397	1397	1678	1	1	10309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvzfMdtdgNYkV7t7AhUnuJpqVho8C9cDFxfNgNYC1xpRQeUgZK
24308	payment	2134	2134	1874	1	1	1385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17ZKdtjzSnQiedxjJNzwUGoTyYUu1DHAQtRMPJak3Ni5uM2LM
24309	payment	2132	2132	1874	1	1	334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ195XNMzaJ5eRv1t732fHrsQuoFm38DUoofULvvMdG9ptFgjnz
24310	payment	2133	2133	1874	1	1	1369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78fVRuGK7qp1ayF12uqXrZXvTwEpjNsz3o4LCxhpp16JqwuaZ
24334	payment	1397	1397	1678	1	1	10317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1taB16sJh3eZTtEaTUkVJHMVeC5DNNgkASrbdZMQoCDhx7S6e
24335	payment	1397	1397	1678	1	1	10318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3XRKbiJp9Jz7qhLvWhaq2B3sRLkCxJVjK9zhHMc9AgdJoYsy
24336	payment	2133	2133	1874	1	1	1377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqJkNk1Lxr4NsF9SFbKD8c4T3NdTWdNcqJXUgoxYqvCzKWCQ9
24201	payment	2133	2133	1874	1	1	1334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TxytqrCC8NtFtcoCZ8Rkumv832UbD2Pjcn4Be1HfB1TRrFRg
24202	payment	2133	2133	1874	1	1	1335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywahCFnm36WD2z17chLJkL5gVKF6suUMLWPwtcYEXj6xCcd9a
24203	payment	2133	2133	1874	1	1	1336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jppH9f5yDbm2pLsM84QMLo63d6CCH8sBRvsgp37JogJZNj9L
24224	payment	1397	1397	1678	1	1	10284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCdHhBuY9ZBRXG7nruTE9SyvGpKs4XkMtGerJkucm462gJdSf
24225	payment	1397	1397	1678	1	1	10285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxjDfUetWFW8JcjTAr1RZ9EETV8YKB4oAmNXPUWMRE32RkE3U
24226	payment	2133	2133	1874	1	1	1344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Xgn36MNs444Ytr1LyZenudi7Dn9pPJD2YHviJNWwQLnPrkb
24227	payment	2133	2133	1874	1	1	1345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMAWmYtQGmRVHKHvKzbUXA9BXJC7qpcSDXjYoEy7Usobh9av4
24228	payment	2134	2134	1874	1	1	1361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKj3dg2zn8b9ZXgfjYgZadTSFi2Kg7aNehcDrrG1xxGsEVkMu
24229	payment	2134	2134	1874	1	1	1362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstxfACMc2F41WqW6jhqoiTMRstCzJFWn1sZGpLoefaccFYYo4
24254	payment	1397	1397	1678	1	1	10293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn28BCrVrkDfB3aCEb8t6Wzqvwm7Eon96R5zgcbGqpboxWM6aZ
24255	payment	2133	2133	1874	1	1	1353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyL1dWjM4bGKhmVRVqSayfadYWYitgsptRpqaAbZKKo86g5Wbe
24256	payment	2134	2134	1874	1	1	1370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJawHaCtCR8igskXGNNsfxvwHaHLdSvRzRzNJ1oLaG8D8waRS
24264	payment	1397	1397	1678	1	1	10296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcxR51EuMJJCGonVjULtVR4LhqiUgHDcMgJtcVXJAwpYyhuZA
24265	payment	2133	2133	1874	1	1	1356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX3RVXAvSiycX1sv925VFTGNhTuF36tCdo7y2wU6VTVSLbo8v
24266	payment	2132	2132	1874	1	1	330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZcjjp78rL9s1r8UbW9egWKhuaDBrK1A7j1T7MDETnUoadubi
24267	payment	1397	1397	1678	1	1	10297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mP4LuUhVVWcKoewdFHBmM2mfn7gG2jtatUee13qNgExSAdL4
24268	payment	2134	2134	1874	1	1	1373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjpPdeidYjLTHDjgVgqQEbPw2MckPyE97XTZrqBvsf6utzthM
24269	payment	2133	2133	1874	1	1	1357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNcUn37b1Px2MHbM3n4vkCbto4LNMrCZQ6U4oApLzBWXxisiG
24270	payment	1397	1397	1678	1	1	10298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHhGA8cBDzTTjCHpfTDJiCmYKxoENzXxuv8DQFpeb3sAj1n5X
24271	payment	2134	2134	1874	1	1	1374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqBNULpE5WnXub4GzCGMAh8LyBFNedbRKsLQu8B1z1U7NRb4N
24272	payment	2133	2133	1874	1	1	1358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV14emTx9zDdAfcDrfM6eVhWeUKPS6K81bi6NChwaGeowbP5CR
24280	delegation	2141	2141	1567	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXUBei7ifBY2RATJjutXXyg2D85MjtuXuqvNGFiL2axToG8uc
24301	payment	1397	1397	1678	1	1	10307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGkP23a33oxV2rz598NsGyuR8f1Fh2AsNCXb4QNKKWmH3hU7z
24302	payment	2134	2134	1874	1	1	1383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7jfD9D8P7TowCBBLDnpXJpmMhYDZYY2XTGEjGdzUrPGeSKYm
24303	payment	2133	2133	1874	1	1	1367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8tiBQe8axUtsFZsBgDLmeMDVtMoLFn3UoX8gJd9jeaapKY4
24304	payment	1397	1397	1678	1	1	10308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Nen52Vvk5dP4mgkARHXNEox8ScQQVAK5ciAMAvwvo1Ja1a2d
24305	payment	2133	2133	1874	1	1	1368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGNz2NShwLFMSGW3nWhYU2YtAXPxyoaTW5QFwcWuZyo8s4XFD
24306	payment	2134	2134	1874	1	1	1384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5yh5EVH9kWzAn7Xv66iw7pKmSGLWvXnuxC4gqmPRtd7ssJheT
24314	payment	1397	1397	1678	1	1	10311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ah74tPDuRxzYM6GoCQ2N4iAkTM354zGc9pk4WTqp8b3hCFF1
24315	payment	1397	1397	1678	1	1	10312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmA7n8fsuHwkyrDEBd8Ax3Y59tKTc3M1zpRYN7RAmGnvCc7h1q
24316	payment	1397	1397	1678	1	1	10313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMELuME3za25vLmW6yiCN6FDxHUuL3GUgJUodCaghCJFHqDKV
24317	payment	2133	2133	1874	1	1	1371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthw5yH3QRu9kGRMCAxxhtm7VFQbk81eo3LHmwidWqTbuCYAJM
24318	payment	2132	2132	1874	1	1	335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WFrZoqe4pmKQr47qbbwdf9FxG1pBA8f9nJGC94pPpAXSRqqJ
24319	payment	2134	2134	1874	1	1	1387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEGvG4Wm4QVKf4yymzZYAVj2rxTtt38qCinZgg7ZUphKhYVb8
24320	payment	2134	2134	1874	1	1	1388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUtz9BKnpTLd754MqDD7PWgcY3nN7xQs1HNSeh9VBDwrVe5mx
24321	payment	2134	2134	1874	1	1	1389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB13PyADLv7PX7ogwzatfup8N5e9TP54QUgsrbzfxCezP3ETxp
24322	payment	2133	2133	1874	1	1	1372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5isR9U9ycnQKCH4kxwkPnuZB6bn5w2waCRCAYduamqU3AsHm
24323	payment	2133	2133	1874	1	1	1373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtx6PHcPB3j2B3Kcs853epGYipvFTXEFupwuBS888YcCZFz9uA
24213	payment	2133	2133	1874	1	1	1340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZvksx8WmEBGHsRVFB8DNwFiCJYnsDwnPF7yWzDp2SeZBcPTZ
24214	payment	1397	1397	1678	1	1	10281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vhpJiV16DZV31zwpV7h6jzcjZinDS1dWJ5WN79CnDxsJzrFU
24215	payment	2133	2133	1874	1	1	1341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fWCCKoi5m9VtEhVocw53To7rcNkZHUadeuLXpYb33BrNpktQ
24216	payment	2134	2134	1874	1	1	1358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZv6UocJArt2zn4xMfjU1JRYPF3AgN1jmayq6ZzKFPsCE9eGS
24248	payment	2134	2134	1874	1	1	1367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckeNDbh4FXhE2K2xpnryC3PCBzDkaQqhXfjz14zGccrz71LLu
24249	payment	2134	2134	1874	1	1	1368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhjuw48HRgUxDcCywRwpEgY4pbWKqEwTRQKRyAxwk9taRmrq4
24250	payment	2133	2133	1874	1	1	1352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAzUsGkbw8gBjLPYT8Q43wPBdC3Dvyon3jrioukHBXGJd5xAY
24257	payment	1397	1397	1678	1	1	10294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwk3Sgne8WV5cYHkiL4a786criCeAPuaU69omBntMKu83jwY4
24258	payment	2134	2134	1874	1	1	1371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty8PnBVrorpLRm7xJGocM3erUhaNmC2s28btfBGXKeCxHzcQ7
24259	payment	2133	2133	1874	1	1	1354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmbjG2ryU3VoErGgSw2RUoLzjBjLmYxr5RY1TdL1MWBXLgcek
24297	payment	1397	1397	1678	1	1	10306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyPz9XEZuhQ3dHttSPkZrXKzvust8PEVExPLxFiyxV6GB354k
24298	payment	2132	2132	1874	1	1	333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfL3zUJMK5U7DUtAg67JAT3PkuoFPVjwNaHgpiB4kyHhcf2RJc
24299	payment	2134	2134	1874	1	1	1382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3E5GHognLe5gpMR8bi8iARRt2r1Jnzy3hLzPGqB94boHySFn8
24300	payment	2133	2133	1874	1	1	1366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXwqA8h2kigbbXuUHjnoiiixfnWtQ5WUL191rQibi4bpcpdm4
24344	payment	1397	1397	1678	1	1	10320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5Mi3ehEQgA3RoHiBxWyQ5qc7QbnhwtBWnGovY2Y7kDvW68Et
24345	payment	2134	2134	1874	1	1	1396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqXJp8eWjXG31vNp7C47WHet6MAfojA11ZMFkor5i5kCqPQ3i
24346	payment	2133	2133	1874	1	1	1380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QhXXs5xgTbtTBFUnraX7vBZ4GGcYJY5XTMVNS8gfurvasis8
24371	payment	1397	1397	1678	1	1	10328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJBBqL36DeEiJMmjyyt99zPkXFUthA31RMD8gUdwz8ev6fof3
24372	payment	1397	1397	1678	1	1	10329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmipQDeA1g4XD9GbsWPq85vpeAe5CNjtLG9JeuBRa4et3wSRd
24373	payment	2133	2133	1874	1	1	1388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpX8mwqQDSiBayqWr2ZtmxisYqGfEArDXetD3bYnQF9WLfSxns
24374	payment	2133	2133	1874	1	1	1389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5PP2tx6vKvYbw9n7FAVDDaKdrUpAdi8vJb8TVfU797ZpSpRR
24375	payment	2132	2132	1874	1	1	340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrzhMgsAvosEThNVwek1b81rw5HburRQFD9mAPW14Fz3TAp99
24376	payment	2134	2134	1874	1	1	1404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4gzmMbfKvLTgw7e1x7PN5MQ9oxokNXW9vvANCBo3Gk87P1Ez
24377	payment	2134	2134	1874	1	1	1405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZvQ2JbEp6qv2szm4tHWuz95bYoeUWDXVDz5n8tUkF8xmpqHm
24378	payment	2133	2133	1874	1	1	1390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjZkPhmsVukb9zFzgd1JKDQpp2jwAPvfjVaXwPWayyJANpzx5
24379	payment	2134	2134	1874	1	1	1406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLupL5M5vZBLi5LSRjUbiZVvAbPdSkj1qwgC8YBmbXBnFe9fsS
24382	payment	1397	1397	1678	1	1	10330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqDCgkinKm96129bMBcpPkmbkXzN6dY8LsLbB8GDBRANK2Y2s
24383	payment	2133	2133	1874	1	1	1392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNENGtiH77RSRBo4G8jKVsCpm1ooTUth4RitmKiLq8XHkg6Gn
24384	payment	2132	2132	1874	1	1	341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1ixekoCag53cCDyCjx3B73wZhM1FS9KjKbu24S872ARRiJhL
24385	payment	2133	2133	1874	1	1	1393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhRaPxLKy4jD18sX81EE4suA2ZJJU4YjtbBUa4DUbbuWZifM9
24386	payment	2134	2134	1874	1	1	1408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJ4fyYSbwa1dkvgNxggNZNYxzQNZB5JrV6yK7UYkmbnmCqxbj
24387	payment	2134	2134	1874	1	1	1409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEP9o9Z1JmsMeLVE3khd22ifhnToeL43ZtV8J6EGLVxfaB1c3
24398	payment	1397	1397	1678	1	1	10334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSfAM61CguCFZo6WAjzb2bAoi7m9pbGF6DmeqQJ6cb3wWWqxF
24399	payment	2133	2133	1874	1	1	1397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5fYT8Px3gNhjAgmHucQx4ieaigQkDF33qkurjGBU4rZTcBYH
24400	payment	2134	2134	1874	1	1	1413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kvTLroUZmyGEYLcN8stRiqHeDJUstsYUY2BNe4qtTfSm4DCz
24434	payment	2134	2134	1874	1	1	1422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYss4z3rVtyWiEqoZJ6ftaTSHnpc2FNNzgrL2p76wkY2NbWR5ST
24439	payment	1397	1397	1678	1	1	10346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28jXzdQa6AhHgpiQzTSKjjPh22hS45yGBRURdCNcbe18CAiG2
24440	payment	2132	2132	1874	1	1	346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1hEFXVGDJN811FTh9yPLY7H5tCMcCx5ggJ32xVfYa96xPnWr
24239	payment	2132	2132	1874	1	1	328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxqqaJrjTQLpxodapR8iVCMcUoiFfxCzdcLRKrmRyxWMUEniX
24240	payment	2133	2133	1874	1	1	1348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDrhxo9ovsupLyHMAAq8VxULQ7LaYos2HR9ESfmYmFgLQzsw9
24241	payment	2133	2133	1874	1	1	1349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyNGaaSvfD2gAddDVeuZNrdoqB3t8PYZ8maRi8Xxpdi7QjF6Q
24242	payment	2134	2134	1874	1	1	1365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNMLvNut1atwMdVMZvS5CsZztyFFFGMnq83uxroCm6Aq96VW3
24243	payment	2134	2134	1874	1	1	1366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJigLtfz9Q1V47F3ZY5UZRYJaDXRDz8jk8To3rnfQhjnhYhzR
24251	payment	1397	1397	1678	1	1	10292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAuvkAZWCGuqMCjZRYX9JUg6MDBL3oHPgq2xSVjjJktwTG1oB
24252	payment	2132	2132	1874	1	1	329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYraRbTxd1LYQLWqehKnQXhKEcziTMDjUqUT1ixXWeg7rVkZpxY
24253	payment	2134	2134	1874	1	1	1369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhutEUqnppV1QAuSeywKEtLpLGDUnVfbuTcaDXu9nNN7gD5kNP
24260	payment	1397	1397	1678	1	1	10295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9gxoiptPm9E5BWk3r37arUUCHbDxhW9kEqto2rYm89f4PuhF
24261	payment	2118	2118	2173	1	1	1	2000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYSEtfsuTBSeTozSjXXJqvukMuxknVyMkEwEAr3XRT9m4VKwuMP
24262	payment	2133	2133	1874	1	1	1355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3kTD4C7HCi7V1AiyBJTo6yhmcDq1bWaLR8AZJhYYXQ71QNUm
24263	payment	2134	2134	1874	1	1	1372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStSQFwfYVc9PvTBHFNWCs5xE62VWzLrqsphAEyWiPq8UQ7ETo
24273	payment	1397	1397	1678	1	1	10299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4tJmEW1K85nJwCdq7MpWo9mJEzchQ9e9mh5QVXFBD5BXpBgc9
24274	payment	2132	2132	1874	1	1	331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjXj8E8ZBFMEd91HkW52LVJxWg94xuW5Aci7k8PjZkUyoQz8n
24275	payment	2133	2133	1874	1	1	1359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYWYqq7tzCKoej6g88MjYNjrycD9TuH3wMr2phaiEiUapFdyu
24276	payment	2134	2134	1874	1	1	1375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsqGcc8DR9vyWGGM4pmAmgtqc3xDmG42433eNYJ21oSSo5cEr
24311	payment	1397	1397	1678	1	1	10310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYXXJRcthNVVuxVNQXqbviRFwxfUAStQCmdfhnK96oh3PMLfq
24312	payment	2133	2133	1874	1	1	1370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTc6k63GbmCuvvSCDxzTDGuqnDKePj1R6TKU9du3qRY95sMgic
24313	payment	2134	2134	1874	1	1	1386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSt1cz46B9LxxAtgQTXhDwjusWgTamLDrruxuUpzQQDWv1ynL
24327	payment	1397	1397	1678	1	1	10315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxATcZV4Ekui2ZiGjq7Ef9VStuv7b99bEREArc3dn4kBSZ6gk
24328	payment	1397	1397	1678	1	1	10316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaXtXuXiVZZYd7dyCTW1tjf4EUC6jmkety6duHerN4xrEKT68
24329	payment	2133	2133	1874	1	1	1375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeNdYV31567kyig3ZoE9u1egRfThLEkL1mYzxifcV3NAeDR7j
24330	payment	2133	2133	1874	1	1	1376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1qsqV1QdFrJbStQAJbjWhx9Xd8UFWpoFmsxmWr23jANNgRy6
24331	payment	2132	2132	1874	1	1	336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMFs9aDrMenip1GTRcVtMkNMGD6HZuqRbmmeWd4zvotJom6Ej
24332	payment	2134	2134	1874	1	1	1391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQX14GLG6A7KhQd6YrSCXXZc4Pmyz4CyRGaoEZXpLdcgEEAuWU
24333	payment	2134	2134	1874	1	1	1392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfxweB3VEsG4A8wPzSUDV6RzqEPLpznZZCFqXCBV5hFAThMpn
24340	payment	1397	1397	1678	1	1	10319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Ded81pqt4QEPZFdjKUSmhYBxD4xxyw4BXBSsApm7FtaNYqgs
24341	payment	2132	2132	1874	1	1	337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVVg37dKAVUkdqLxXWZDMfQzwzT5ocUpEzJzZLTudcxq9UNuG
24342	payment	2134	2134	1874	1	1	1395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMU1tB9HR4oK5nhACPWMmWwtvLqgj2Ldpwz81Whfa2Rvp3n5CC
24343	payment	2133	2133	1874	1	1	1379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczDpUGVYnaBVcnjoVm4iAEFeKP2icnVWQ1eRXRM3C4wzkjouG
24410	payment	1397	1397	1678	1	1	10338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkauMTuWB9qwYP4MHCutW5sAUhHhcWfhyb4A7qZcLtiMj77Mi
24411	payment	2133	2133	1874	1	1	1401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVCcHNKkruK8zWQH2msbDGQBBk9EKoXCoHgHweuLMuXkPNBLLT
24412	payment	2134	2134	1874	1	1	1416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQMg4NDiFiCA4eT4xfLERXFRd8xsZKTnZwbqMLxdzyLJEsptP
24417	payment	1397	1397	1678	1	1	10340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfCsyYcLTi4BYECFy7Tg4pTB5bMBXNPM6CLUUo1x9reVvq6EN
24418	payment	2133	2133	1874	1	1	1403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2TSTfRfTPq9jU1LeHP8rNqTVds3QvL3NFDYiWLdDYjRfY9vq
24419	payment	2134	2134	1874	1	1	1418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvF6LMxDp5M5H6LizT1Kjm74EMzoGKdfFE3uP5YkJ54KCdDiMq
24420	payment	2132	2132	1874	1	1	344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uFjius7VpzcrbXJRuRKP1q3cs3hjZavZL3kWjAJLfa1gJpJL
24432	payment	1397	1397	1678	1	1	10344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbMzTwLAVqVc4hiT2RyJPMJdDkKSngPf5MkLHb6tCLNZG8Jp9
24324	payment	1397	1397	1678	1	1	10314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzo6HKA9yAQWX7eEWySWKez1t9UurepnkdmAUCjvqTJk9pC7u3
24325	payment	2133	2133	1874	1	1	1374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2atsDN8faUrUi4BMUunefBAieWDLnM2JDQdSw2tPJonaia2NZ
24326	payment	2134	2134	1874	1	1	1390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa864pnWqyH8kqmJrMx4HtphPbmB7mdJVRmRb5LtR46hgSef5FT
24347	payment	1726	1726	2175	1	1	8194	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXZ8YKxNqK7Y3KJH5ZbB1s4pd6WxkHVd721CHuJh7JukeGi9JK
24348	payment	1397	1397	1678	1	1	10321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7WoGYepKB6RMZKrtgW6Cro1WkWX9HuWvERQA4BL25by6FEMo
24349	payment	1397	1397	1678	1	1	10322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVcjCVQ7ihndCfQDMDfAunX34aUhwiJBkUXyGHQEWP9XjnK5P
24350	payment	1397	1397	1678	1	1	10323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5oTgw9tzFuHv9ns19p5UML5G4qx4zBpbgESsBBRVkrpESpdB
24351	payment	1397	1397	1678	1	1	10324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk5tzNqDZdQMR7yjg1i9ZNzCzn8X9Mk3DLepr972ouf6U82NJ
24352	payment	1397	1397	1678	1	1	10325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Won3WVyaeNqDM58tUcFGB7xasubopEaDokwjkBKDrYgLZnTM
24353	payment	2132	2132	1874	1	1	338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1649e2vHUkUDWiboUetTTPcBRWnR7UoQftdbnrx8u1o4FapdG
24354	payment	2134	2134	1874	1	1	1397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKChKnmwZVMuhSg8LZ5Z5sBsUvQZqiVJcaxFaHWdyudwWuL7UQ
24355	payment	2134	2134	1874	1	1	1398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCrqtAnpWxZh4MVHR3eMD5nkSvaxcCJLQBJByRyh9ZB2hpRC7
24356	payment	2133	2133	1874	1	1	1381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wKcK8jCNk1emjK65fpssSXfUK7qaDDe75x9kmG2sGoeRrQYp
24357	payment	2133	2133	1874	1	1	1382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAWiyiiZ8f21YuzdTQJS8cLK8bosvpBstgriJyqPoZdQesuTj
24358	payment	2133	2133	1874	1	1	1383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYregnG3s6DSETwDTVeV4Qt7nMXCfyzopFLTcoiu6h4kvK6Je7i
24359	payment	2133	2133	1874	1	1	1384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1A13cZeDSUQFkyBG67VgKzEJsds7by3Wh9LSZYejuvbGr4WCv
24360	payment	2133	2133	1874	1	1	1385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DHFhijRQ3kMJ4y1Hw9keZojkaQSp5JMb2FZbDhwp6RxCbjxS
24361	payment	2134	2134	1874	1	1	1399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCq4sX71HERsMLEnE9MJKLdct1yE1iVeAXcGZs5REHywHY9GLy
24362	payment	2134	2134	1874	1	1	1400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpKBdSCM3sDwxUrgbJmvHzKqKSZpeg9UF29bc9ZGAo8fiTCv5
24363	payment	2134	2134	1874	1	1	1401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPj23yaoFm3FpYGwBnzESkPw4oSMj2MfPAhvLTVHjuJu66o4M
24403	payment	1397	1397	1678	1	1	10336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzRWj3dpTvvPdx7Z7DTPJziFGQcZUqeFqU6Fv2cdAwDtp1TMa
24404	payment	2132	2132	1874	1	1	343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTrMwvRjnN2J35ZfJWabTjRHKpGuXxnqZKAcUcArmydYjUUmN
24405	payment	2134	2134	1874	1	1	1414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7UnTm1bmWgcxLfmfpxQ7ofFWLSCksNtsp4hhsY1wbYbVnSTJ
24406	payment	2133	2133	1874	1	1	1399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgGQcKMN2RvTSRz4Ed4FYKiZ6b8P5siRMrD3GjUFgpPFcJ1UG
24407	payment	1397	1397	1678	1	1	10337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bbqBQ6ApuhEBCMgQYG91qwqHk5WSyq5Ezv214JTbhRCrmmX2
24408	payment	2133	2133	1874	1	1	1400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRLUJ1ztMCXQStHnCpUJw6ym9FLWoeWK1sWGKkPVtKgNHZ2ya
24409	payment	2134	2134	1874	1	1	1415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83dZot19Wao9YYDMd9WA2qKzLRNQ481Vu4f5cXBVr4xoaBbqb
24421	payment	1397	1397	1678	1	1	10341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjE3Jfo2Knj2baUHjgxduqTqce2dFYb9hko3z6kBHNqQGrLuE
24422	payment	1397	1397	1678	1	1	10342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XjiZn2kRpPkkekFYxpa5oJztPidpEbPvuMj1eKzZ7uJREZq2
24423	payment	1769	1769	1769	1	1	44	100000000	1000000	\N	E4YPrK9idKKvKuQtCr2pqaMk2xTRHidEMJazrtJmtokcsaAmX3C6P	CkpZLGRyL982LcbwyvguxxSrkcqe8AcdhnKsMzEVAZ3eZbKWjUvVx
24424	payment	2133	2133	1874	1	1	1404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzqjN1CVRmRGDyRS1yh534BkfyrZT2JhZUKZydGWMAmWSsvuq
24425	payment	2133	2133	1874	1	1	1405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFiFxywJbsfkRNv1bGQqUp9nKWGmnJ4wQB14vPR1tg1osxjvw
24426	payment	2134	2134	1874	1	1	1419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fMgUpqJFZMy2rwG9KUZzJP1JjxG8xMxWpML5CKqrbkSXTNEi
24427	payment	2134	2134	1874	1	1	1420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQ5V9na6ie79BhtDFJQCfwSwjAH7acqLArNQt5HgGkVoZySRV
24428	payment	1397	1397	1678	1	1	10343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntPEzn71mwxycpgVmPD6QsMBi9RH9WJqYWmeCirTG2sqzNWPc
24429	payment	2132	2132	1874	1	1	345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4x9rctLcgSpsxETggsK4BUS97WTGWvN4i81pwF4hUSnZoPUr
24430	payment	2133	2133	1874	1	1	1406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg1Puz49t6qysaBeiXkjLfreuu75Br3UJXwJxnYJGH6szv8LE
24431	payment	2134	2134	1874	1	1	1421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7DTwhJmW3yo6Fm6uD4PJxMekTjxuhfbF9FnVdPVtYgwZeWGV
24337	payment	2133	2133	1874	1	1	1378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp56MFk9Mf66skZ6htNGXygWMQpqqrfyDiFXwXUcTU7HEx6R2A
24338	payment	2134	2134	1874	1	1	1393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHAX5kC78YvutWiPHbuDCc7WGcsw77hiTkASQf29XeSM2vgrk
24339	payment	2134	2134	1874	1	1	1394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4eMUSDDhA5sXqR9tyvusNiovCzLEHeWqjsaJ7Hp1WFmK46emJ
24364	payment	1397	1397	1678	1	1	10326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoMjbMCbDqe7Cs1QfHP8djJN46QyAtdwQL9tMmVihP5oCPRMa
24365	payment	1397	1397	1678	1	1	10327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3uSfLNT4eH1u98cw6Dcgs3MYaattCu6JCBfYMirfdECLJkLQ
24366	payment	2134	2134	1874	1	1	1402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwmLzUB4kVoLWP2KJF3XMgBHiWhoiKq5Qtr7kULeYFRYb67cx
24367	payment	2132	2132	1874	1	1	339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2xXvTRkuWzY86wukET9cL3A9RaxYTvZhZotjnPrMjpJkVsPq
24368	payment	2134	2134	1874	1	1	1403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1oAtEFHH49NftT5oH5X8HdtiFYhufWnsRvv787KtBvfFgGGDt
24369	payment	2133	2133	1874	1	1	1386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BdnQWBFsoWW5M4yBkiPG7vUzfEVDP8FMzosvTuwQuTtvh9bf
24370	payment	2133	2133	1874	1	1	1387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysFEoeRktr4CNa5TuwjscBsn12audpit9JkCva9zsnPk4tfKJ
24380	payment	2134	2134	1874	1	1	1407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUm4nRXgCCkCPB31hcgGqz2hv2EzQHk358JDhYH5NrRVgH3UXX
24381	payment	2133	2133	1874	1	1	1391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMRefdhWQXzrUqFe5beKnSMDNfSQrTu9u4TqXQMh3Emva2k2o
24388	payment	1397	1397	1678	1	1	10331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPNdTNM6GtYBZkp912S1G9RhSgqPUN6xacpwgFRcfzzdHzpKE
24389	payment	2134	2134	1874	1	1	1410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGjyujjxg99X8KkdpXt22o1y91Rg1SRuZC4pGpWaVPbYtEgWi
24390	payment	2133	2133	1874	1	1	1394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fYnH13j1yDKjkZN1LvnVjn8hh76xMjgLJeyC9w3SCk4zrEh5
24391	payment	1397	1397	1678	1	1	10332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBu461HQQJQm3ajhe2X4RA7oVt7coHwF6K5k9NUp839EPsNKC
24392	payment	1397	1397	1678	1	1	10333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MVvup5nFVfZ79tAX1vJVGBrFnkhFK9Ldb9Kisp8P1eETrU1m
24393	payment	2133	2133	1874	1	1	1395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHkVApAQnkeqrWBa9frasBFhWZDV1eQFxrpkgGy2CmLe4StmJ
24394	payment	2132	2132	1874	1	1	342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfALcLsFkchovqtiHfBSNx7XMpumw8jgLDPHdxhym129J5bg8
24395	payment	2134	2134	1874	1	1	1411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCoVqTJjYHasifyEGS1Dq8YiT8wapFTkdFohdw9JHEd3WnMxz
24396	payment	2134	2134	1874	1	1	1412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRWB1xtj6FJ594ksvf89QPPKjCs1SmrJVmHDsTwDY6Z8TQdxd
24397	payment	2133	2133	1874	1	1	1396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQEZvrCJPoXew6CNPNPPGBTH4zjxnpMucYVjVuPtYZmzvrSdG
24401	payment	1397	1397	1678	1	1	10335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBpcwZLJD79i6LFufGozNLSP1NAQDdnAZVfkJrmRr9t9HVZWV
24402	payment	2133	2133	1874	1	1	1398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogd5Nom4uhsaGjxSyN3fRBzhuKEtfWZohJL1hemKwYrxmsARs
24413	payment	1397	1397	1678	1	1	10339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGtMGK5yoCWDZzFiqtcYMqbumKC2JrS9KwVfqyRVmfanAeK4H
24414	payment	1769	1769	1769	1	1	43	10000000	1000000	\N	E4YTjyE9Hxey3Sr4nKzuPdj7upfmuLACzFz6BEu9RYPcXYvMjytwe	CkpYt1umsJqDehRb2FE6BvPazPvj6xyJu5iCXGXtfL45cvoc1CiRS
24415	payment	2133	2133	1874	1	1	1402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8JiKcbccbaxT1R4CCNex615o1hpMANMxb4aFjRfDUVSZEA5N
24416	payment	2134	2134	1874	1	1	1417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6VAJqFYYRNLANYd9yeXSPH6h8XjiXZTDmiYVRif3sEEutsbd
24442	payment	2134	2134	1874	1	1	1424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Jd8LkabWaX2daWGYjTjdZT8bHaouJX9sBQsR1fdoQERt2Zty
24443	payment	1397	1397	1678	1	1	10347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6RRMjvQDbVwTRACJoiUiz8QcEx2zSwFFFokK9e5xAesJ84hL
24444	payment	2133	2133	1874	1	1	1410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvFCMut7CfNyi3b2HzGPmGdm5hw3v7EQ3Mzv4k5qfQrkbmfDa
24445	payment	2134	2134	1874	1	1	1425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHQ287xSj7uqsrrSW5UE1LyXtcoBqC9FSssoTLX28NArikyNV
24469	payment	1397	1397	1678	1	1	10355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHkCwPB3EzmoUMC1MmixfuiH43R2gYwR26Qt28Y7Z1ijonwFf
24470	payment	2134	2134	1874	1	1	1433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9yxbbrXAgaVviFaymBpyGxsTc6T1W26bTzbcDdzYVHBs9bZ5
24471	payment	2133	2133	1874	1	1	1418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZsasvq29R7DCCB3bfGpPbP6EAxNFgcGrXskYTByapRBFPgDB
24511	payment	1397	1397	1678	1	1	10368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbEWNfipproG4FBkE4rwE1ZRQMuVeArtUoZve4rZwC8Q1pL2Y
24512	payment	2133	2133	1874	1	1	1431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sbVmFAE9E9aduhyUz7tJvvERrPzn9Z8fiZhEnwwMPjBtnrXw
24513	payment	2134	2134	1874	1	1	1445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMj7abLVSHoTdXGER8cUPAKzLJiCKmsymBBkm8kEB4PPgHFjwt
24433	payment	2133	2133	1874	1	1	1407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFU2K4XqBgxp1EbADBC5MKWRJcbeuLwR4Q6qaNX1b8xH7gLykT
24438	payment	1769	1769	1769	1	1	45	10000000	1000000	\N	E4YRJ5LQJfNofP4JsK2xGipRVCv81GhoLYphB8VtcsnbUV8vr2vSQ	CkpYxs7Ky43F5giVbri4msoB4tGoVdTdp2sgxxTK1HH9TuCcJvUoF
24446	payment	1397	1397	1678	1	1	10348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9FVHG8aK5MGSmXgKEjuVjQJjq4VDxKXari1f5HY3mVuxRewc
24447	payment	2134	2134	1874	1	1	1426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcyHvgZEjmWoP8WjbLkmzPEiLyAxuXhvpHk8fSpU6dWBmb3HG
24448	payment	2133	2133	1874	1	1	1411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyE2QCLp538bVx788zHwDcW7XU5t4q8dKoosiN5C9C3C8Hxna
24449	payment	1397	1397	1678	1	1	10349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjhQXz11KMrcUdhkxdMwcsHQY2qydAK7cPEzSKLRiTkyLRHxc
24450	payment	1397	1397	1678	1	1	10350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3ZqXfM5DNaG8njdndk4PHEU5Prwc9sMeRHrQmtdwjPpAMoiH
24451	payment	2134	2134	1874	1	1	1427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbmj7BTAMVH8yNV1Guo4LJSEbUmQ99XkWVUbxSPwciSsCwXu9
24452	payment	2133	2133	1874	1	1	1412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbQpeceKfkdUaWUMGfXn4HBb7BQx48vVFdt1Ju3fnX2ozs6Y3
24453	payment	2133	2133	1874	1	1	1413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfc36yC4rwHzCkDjvEoFmgsA79D8UeC6iJfvxrsAPzZUDFQbM
24454	payment	2132	2132	1874	1	1	347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UhcBMCsPZQFzp3xDdcFDXWhu4cnVsmg93BzFr2ABYeDw2JQ7
24455	payment	2134	2134	1874	1	1	1428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF4gkCUCd2kRh4DTbXsobZPetdcn5J4UqdVFNRhrsc2fvtbe5
24459	payment	1397	1397	1678	1	1	10352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFxa8BuFi2DUvb6FnBSfAxEyE8bf1JdYbhGw1nyE6NGwuLgQG
24460	payment	2134	2134	1874	1	1	1430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhamHxXHyD13hVM82Ajk5we5HvDDcwxrWVDDb8Ypy6cpaSsiUX
24461	payment	2133	2133	1874	1	1	1415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAxQtGdpv7KQU7ZvSgGdWPdCQxHmWU287ZhWAehFWULPyBqQ8
24462	payment	1397	1397	1678	1	1	10353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrzqycEFukKbJCAQXuriN8Waqdz2VswBUJnRfbVuKkjC4qeq5
24463	payment	2134	2134	1874	1	1	1431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwc4kQdMctuUcE1FxeuDShyp65GA5FEabfBtCam6FrdCunD5eQ
24464	payment	2133	2133	1874	1	1	1416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Mm9QFsohvswV4xjKg3Lb72e1aDoKL1xcWmLMgoi6g5sNpdW5
24465	payment	2132	2132	1874	1	1	348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xhf9HhR8Qd9QxWsf3tA6SHqTtYuDPwRnhua9Gs6QgZrv1Lw8
24504	payment	1397	1397	1678	1	1	10366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GXdZQ8GbNNuLW4jHRQYQtFzn9f2KpvE9YVBFQcbfc4hAcjzB
24505	payment	1397	1397	1678	1	1	10367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmT9pg9BPLsdDEqxAY3vR9DtEqnXnqWCoXJCCHtqs4NrEjpZ9
24514	payment	1688	1688	2177	1	1	36	8352322800000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa2m7DDqDPdnEnicx1qCD2vLhNRxuMD7wNp8jM6oSdbuHwN4nK2
24515	payment	1397	1397	1678	1	1	10369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhuada56UDFwdYHqFn6HXqKc3PDVVDKqYMBzLK6fRLqtFwL2E
24516	payment	2133	2133	1874	1	1	1432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPr7NrQuzHHuTrfuHmRqqMqKojibUCQbUdKg7CXx7fc1PFUemD
24517	payment	2134	2134	1874	1	1	1446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdp3mp3Ht2hoeSy4335ygurcwLFTWf3dVPxjRNu5hXVGJvpLws
24528	payment	1397	1397	1678	1	1	10373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGhggPj7gj3ykRFfpCtSJ83NNVzfYdrUdf4VxzoqAYod6tW7G
24529	payment	1688	1688	2177	1	1	37	13320400000000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZaaVsBbJdq8gQC8kPNqgExNBYYttwEvXrUE9BWvKCHaQBGhhPA
24530	payment	1397	1397	1678	1	1	10374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLYEg31DGoh4FanC4ksDtUdUEaXXWcNz4t2H2hQcNBD6cEVzY
24531	payment	2132	2132	1874	1	1	354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpwTHYENhWdFQnmm1QhgpV2JJgqJMi6xeZgRF7dta4gVJAtT2
24532	payment	2133	2133	1874	1	1	1436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB77BqSgR45yTSBho59fem8frS6yiZsr6Z6zA6xi8LUmKMJnC5
24533	payment	2134	2134	1874	1	1	1450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbjxtcoh4TL1au2TBhTPhnGDxdBqz83ZahD6oyjWDMBVqoErD
24534	payment	2134	2134	1874	1	1	1451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFob58q8zPbp2Hpp8J4etdQ8sn4VFiKgkjuuUJPC1MqjLiJsJ
24535	payment	2133	2133	1874	1	1	1437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc3ZzA3avM4o5J9baBBgYdx8uTLy6555xtz7WSX4VcBHxQgBp
24536	payment	1397	1397	1678	1	1	10375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsvhyFAYdZBaG9fmbA599toeUzGzJVG3BDUqX6SEdNqmiYu2Z
24537	payment	1397	1397	1678	1	1	10376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDsq1r99WU3xxGDH4azEbpeARG1Wz4cChL7w75WXJt1qrhZRR
24538	payment	1679	1679	2177	1	1	48	1548057200000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaA6z9vWsCwEBvKnuEbguw4H6UKLTt1tEP3V2F2QZ1VB1y3NvkK
24539	payment	2133	2133	1874	1	1	1438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsuAz4HJf9JXxM71tRj8GapQ7xYdGPERjXCQuCnw4wtPJyCUm
24540	payment	2134	2134	1874	1	1	1452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZd6YL58EsBNXCQp69tcGxfCcRQNAenSEjKt1D54xMo7PLwGf
24435	payment	1397	1397	1678	1	1	10345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3kL6gwRWtcS845RZ918nqLVBavensyEFD7Gt5qbbN1hXdYVo
24436	payment	2133	2133	1874	1	1	1408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJLqQ5SPVQi2Sa3xXwHpYbYuQ1FmsHiJQjnwosLCcF3p7Mpd3
24437	payment	2134	2134	1874	1	1	1423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVDTN4Yv2BZX4pDh37GKPTQvabW8mqkoMK17oPuTAhTEc9mDK
24456	payment	1397	1397	1678	1	1	10351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfc6Aavt2CGW68a5qyf5J28KxAEi1sTshxpTQLrMdWnikbNa9
24457	payment	2133	2133	1874	1	1	1414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSiWFARELraEYkm37YeEVa7LDw7koJ6fg8t1mPY9XiKp3sr6e
24458	payment	2134	2134	1874	1	1	1429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NwDMKTSGyG39yias4Li8AbH2xSvwze61zRQr9vDyVRGsVP4f
24482	payment	1397	1397	1678	1	1	10359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSRTsun9c9JwwLCcQH4Tn4Vvu7Y21abZfmU4wAJ1kHChsEoMS
24483	payment	1397	1397	1678	1	1	10360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZsUuQnqk5KREr3xypjHnnchWpkAJwWnWx2W2tGWig8A3wFKU
24484	payment	2133	2133	1874	1	1	1422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxh7ebY11t9qWPe9mBy4v194wydrCMfjqDVGDL6Xe5fMhcV1Rt
24485	payment	2133	2133	1874	1	1	1423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgUxQ2j3Be5FRHrHhMTxPDRSVQQR7tKNjE9GguUWkTSLvVsHc
24486	payment	2134	2134	1874	1	1	1437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8AsELTmrnDnB6DSvbUVvHZ7DKUoaKYjiFH8vpxHCTMeXCzB2
24487	payment	2134	2134	1874	1	1	1438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL2rkNyFX1WBETxkBPqPMXotUzkBAhYf9cFoYR2ypiFyUQunm
24488	payment	2132	2132	1874	1	1	350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme3Q9pd3hS1sd3uFDwBWbLazL2DxDfyqUzLA4piZHroBSYp3w
24489	payment	1397	1397	1678	1	1	10361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQi4hN8atyw1vqmBUX5iU7P3WYUwKyohgM2B1LKtwpJ846kdJ1
24490	payment	2134	2134	1874	1	1	1439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoWhNjCeknscwUS68ha1gBNzxkQXLyzx9wPVTLtci9LGqWZyN
24491	payment	2133	2133	1874	1	1	1424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDJbzTgrTNcxoJryiFyCMG29F3EaHdxHRuuMtepBb4dmDYoG9
24492	payment	1397	1397	1678	1	1	10362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DC3F5ehPkoh67E5tXB1hYwzoKAH5xAYiPZNfFCqPCn69mBWU
24493	payment	1397	1397	1678	1	1	10363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9H1HxsbRXrZb7gj4ptPRhsS6LZ6HUHYfCGNNnvaJknF46CJc
24494	payment	1397	1397	1678	1	1	10364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkpqA8FMn5esS31bDn46ueXcdzSiY8yRMQDvM9v3dw8zS6Vri
24495	payment	2133	2133	1874	1	1	1425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeW22vLCvESqgX2g93yopUmanbHg2qas4SVq4LUgvuZ3k6BsM
24496	payment	2134	2134	1874	1	1	1440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzsmnt1SAgpXmpF9EpEQX8ew1xUsZpTG1ugTovPxBKMCFJGVq
24497	payment	2132	2132	1874	1	1	351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhazZM5B5Mif645Q1UoYqUqQPE6TVXUFxfzXbTcscGVxViJoyo
24498	payment	2133	2133	1874	1	1	1426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vusi3kYwpUNREeGLXZhNDWtKRbNTvMAYYsncceHw54A2ZYa6
24499	payment	2134	2134	1874	1	1	1441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmDasbdykNNKGimMdecu8fSbouXw7mjrqMLDoUwQmR9epi8Kd
24500	payment	2134	2134	1874	1	1	1442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQimCfmnNDn6s1KJwYv6RJDzBzQTmWj8xBfkM9CXMbZWtBBKL8
24501	payment	2133	2133	1874	1	1	1427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBuD4HBJSp4CYjk3qu1rVrHUWXhDn5CCKMckHKpoa3qtvysAL
24522	payment	1397	1397	1678	1	1	10371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQeG43yJsiU75qvBMzkVVZNxAfhEALZCx49N7Pvomw7o485wD
24523	payment	1397	1397	1678	1	1	10372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2PywWEV7ojGfqcXmASjSL3ot5oXeLKwZS7Pg59KE8a3eXYBa
24524	payment	2133	2133	1874	1	1	1434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgetrnpEiRNh4HKtCHJbARwHLcXbJVNrNpr9W1hkNpLFjYzvm
24525	payment	2133	2133	1874	1	1	1435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmNEHYMgLKLTHnEXfw3f1GhuxYEqhVL3XRfifYFFnqRP1JuNX
24526	payment	2134	2134	1874	1	1	1448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSmQQr1bpxM9mhDu2nt21K7L9urZBgBs99wpG4f1b8MnKPETe
24527	payment	2134	2134	1874	1	1	1449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEGyqzg64E3kzCp8qf9mTudeK6zgNeigKMZsRa3oUAUh7eoeA
24566	payment	1397	1397	1678	1	1	10383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU23AzmFCi78v7xK9km2WEazfpgNoMHDMtEHF5EaLfH4p8uzy9
24567	payment	1726	1726	2178	1	1	8195	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfsaTzZE7fBUdokDZP9WDSBZ5dSn7ECFEcvzzHca3sG9uZQe9V
24568	payment	2134	2134	1874	1	1	1460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1rcfWaH1hTRmjYEHXrh3MgJqGbJys4bbbhT19vnxwhsSmvmE
24569	payment	2132	2132	1874	1	1	357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6X5ZGHdYPzpnK23w6NyG4nXktd9neT95XwbGxv5gWsmwXbJRD
24570	payment	2133	2133	1874	1	1	1445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFahskio8fxo8wURTALSUTChzmTFMQxLwSrjXW74Dta4xg2HMg
24571	payment	1726	1726	2179	1	1	8196	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYf8hawq2e8kpKYoahy3jKqvEDmMoRbmy9GmyRZP58tyNPTsuGF
24441	payment	2133	2133	1874	1	1	1409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1PcfXQAkKZdjFbG9qKPmpAvFxG8QNN3D2bqLJE3o3LgG13uG
24466	payment	1397	1397	1678	1	1	10354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxNrLjjbdf1mfSRxxJ8TZ2Db41vqeR4k6GLQLQMUFTBS5nx3R
24467	payment	2133	2133	1874	1	1	1417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeGYcr7SpiiJ53c7ZR5846bBHSF7QEtxfYf1KJq83xpZjtPUP
24468	payment	2134	2134	1874	1	1	1432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2RKzJYr5qUMJF7TaXwATwmdPvcQEebTGGn4vQvKjHZBybiD2
24472	payment	1397	1397	1678	1	1	10356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoofCqo327dsyaPCHfgN33B72mySYvDQA9jvzLMcYvoBB5Mbq2
24473	payment	2134	2134	1874	1	1	1434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEPcTFovEg5GSDuVyD4QhpSrPLpaG9o2BiquUcxj2p5AcTxvY
24474	payment	2132	2132	1874	1	1	349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AuJsmaEooP3qSo2Z5bjeJJ8U4HnjA4nkFZB9VQXCrUK9hfQJ
24475	payment	2133	2133	1874	1	1	1419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KUGNnqfU7ERwB4UHuHhTDTrwn3ZtiuKGMxQj4c6zE1gJmW2c
24476	payment	1397	1397	1678	1	1	10357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUmWdwpHusZ1qcx7B1grYzyTU9tNBbMM17jYyRSCyxCiuBrAi
24477	payment	1397	1397	1678	1	1	10358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWWtZdRWXCiVjpH1fTKvNPdwAco9sSxz3aDkTmEjsuJjV9aFq
24478	payment	2133	2133	1874	1	1	1420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEJ57h58eaEB3SSKKGkaRD8A4gDjJCNgRFxfDUDKxJCEFjm4G
24479	payment	2134	2134	1874	1	1	1435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmiYsi93srbfmEDibtNxukYNP1RsvQ33DFmexwxwf3zaCSxpz
24480	payment	2134	2134	1874	1	1	1436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQkXEqSpfADcUQbYvgcwjQK6x2XJnLcrsaktD32BVMSdYoRG9
24481	payment	2133	2133	1874	1	1	1421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCQLxmZtcSkn7jZe8c6DYUDKk2ayVyBUKd8T2oWMw7CR2Rq5N
24502	payment	1397	1397	1678	1	1	10365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKxJyxTmjjWTsSPY4vhyALyn4e25GsomtFzr54UdrPyyZa4Hz
24503	payment	2133	2133	1874	1	1	1428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmEJ8EfuEqiuDvbhBpSVCPePGxWcaR8LDjfZhSesmurZqvZcKL
24506	payment	2133	2133	1874	1	1	1429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4s2Hf9ezEWga8HNRM5X2b75Ep6oS7RXjC1ozyHQfnaSYLxbR
24507	payment	2134	2134	1874	1	1	1443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrvBit66b2UC4mkmWkK3iep3L5tUMKDqsqFqfXqnderuJgNhR
24508	payment	2132	2132	1874	1	1	352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZTN5djTQQmi8LWcCF5jkSybBTU9dHBbrgfMkvUot3GTpmL8b
24509	payment	2133	2133	1874	1	1	1430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwmbLyJRZ9jqe8Ub8WrHeWzcyrWvY2TKKFGaNyw6aj6yQRtXk
24510	payment	2134	2134	1874	1	1	1444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFK4BqV3aQymgmJbcjdwATLYBSoZDMyDbRXcSHyY8Ujz6st1vu
24555	payment	1397	1397	1678	1	1	10380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrejwP5jfuqgRgBRntkaSXdLb8VQwHA324Vt9d7ScAt3tLgtHi
24556	payment	1683	1683	2177	1	1	2	27215439399541	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZyZseGh6iNEddBADYLA5WA2r9wRqztxF3Y5fSGpzA1yZr67G35
24557	payment	2133	2133	1874	1	1	1443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRjHVthuATrWReE1p1fs5jbjubYmuwiBvtsCvLNbnRQ4VStnn
24558	payment	2132	2132	1874	1	1	356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46BZsrwsgWvSowUUDAQHoJrpddeTrFQRHtHuonkwdvH7TRbkB
24559	payment	1397	1397	1678	1	1	10381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhKwS4NSEu8aoEbc8jGTmS1MhF1SEhyGLfiygY3bWi173ZrD7
24560	payment	1677	1677	2177	1	1	2	9557246850100	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZZVfftazHopb81tgC21ZgBjMe9NCx9ipdehnnb3TuJyX1MnYYo
24561	payment	2134	2134	1874	1	1	1457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtP8EwbLPWwsGRaaTsusRfTptp69kVoQUk5rPeKdLXeXyakQq
24562	payment	2134	2134	1874	1	1	1458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9KAqhWxxSuMZkxEuY6F5H1vdrAsyZ2uVeYPCBbDeqyJfDC1j
24586	payment	1397	1397	1678	1	1	10388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S5ACB3ddvnApmu6HezN1KXWngo6tQViuZmq51w474J6TZPEc
24587	payment	2133	2133	1874	1	1	1450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuGgDBsBJxCpRAS5kVe4bN9Ma3TNwga3cqHhMae8SYDxoz5mR
24588	payment	2134	2134	1874	1	1	1465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjXUvCAF9tuigVTuv7SqvDnVZL6igVyUEUfw1WTgxHGNfvgZ9
24596	payment	1397	1397	1678	1	1	10391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7euim8yVH2wMyECAdXMBkrhsiQpBtQFT55v3B2HqEUVq1KwpD
24597	payment	2133	2133	1874	1	1	1453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZwdhgYyTNc1kZHsSke8GgUUXequete2X2r899VoTeW3xQ72s
24598	payment	2134	2134	1874	1	1	1467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLxQd51xKjB3YxRd1EQicgU35wa4Y4NjWi8CZbMhobnbPfvR7
24613	payment	1397	1397	1678	1	1	10396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2nZYpK59XTFeWFXheGCKAijMckfP2g2FnGckkzbqgfvCUjH6
24614	payment	2133	2133	1874	1	1	1458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkWWb3yfo1VWduvjp2yn91JXqzKeCXfy7qpFCyBcTk8FnP8iQ
24615	payment	2132	2132	1874	1	1	361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBqej7Pz9UGbr4RHs67oorn3pQGESYhpLJ2CYZeYKr1KFfG3G
24518	payment	1397	1397	1678	1	1	10370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTHtFwBBEF6jHoQZqeWKDfYo8FcPQaEz18DkzCrPPbX6x4xQV
24519	payment	2134	2134	1874	1	1	1447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhQPif6f9xEHLZ6tcxg78mMj6BKMXfejmaS93ryqAZ3b48xjm
24520	payment	2132	2132	1874	1	1	353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi9dah2w9gEgCFWfE2XbcVoyvVnsM3veCnVemYiAwrEnd9AV2
24521	payment	2133	2133	1874	1	1	1433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UQppExGv8BVbovVtFwjPA8i9AivHteLsi16U4J2oR2TMqxzA
24589	payment	1397	1397	1678	1	1	10389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGXiTdn4oMh6fv5v8nb2uhithQuVfR39ndjMvGaa63rZTMtRR
24590	payment	2133	2133	1874	1	1	1451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMNFA5Mf2XP9kKuSpGhiQ9dD4sbu66DvmtckAQi21iGudSiFN
24602	payment	1397	1397	1678	1	1	10393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUAcWSgybEbKaDfEQAcKMr5pcPrjhBUKgMiTnwY4iK8hXAiUS
24603	payment	2132	2132	1874	1	1	360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjk4P5iRQmwrR6EMFsH91KTvsCkaGHpKUUhVk4TaJL74dSq1c
24604	payment	2133	2133	1874	1	1	1455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsdpLpneQnm9R3j1ZkaRnYKm3j4gzed89LxdVuggipm7dfGwc
24605	payment	2134	2134	1874	1	1	1469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurF8U4xkpngsBcrmes6bVbWgdFEZjJnDKEBNSbg2TvjhGuSXo
24610	payment	2133	2133	1874	1	1	1457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgEwmwC3Fg3wS23BcHNh1Hkhgcy8tv1StSfju85xTo9fb22Af
24617	payment	1397	1397	1678	1	1	10397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrFHcPm6W6qky89AZgob2ZtEGGqACMixwVxRv84T3J6jKfSiW
24618	payment	2133	2133	1874	1	1	1459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVazTUk2N2rXtHx4sR6sXHDZYMHUxkGH1rbxHFqfhgtJE17pf
24619	payment	2134	2134	1874	1	1	1473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4GNFttFkTq2cL4jvG6Ai1F5DoCNx35WiPjR6LrCWnkqjmcLF
24633	payment	1397	1397	1678	1	1	10402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEAuJLLngfYLFHvZtMiYAFPKrTTJnHLTXBy5potQTcQ6wvQtZ
24634	payment	2133	2133	1874	1	1	1464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvARVUD8pZd2Fha9Ahnjo6wc6vxdcefaR9jtRDkZtkDG7gko7K
24635	payment	2134	2134	1874	1	1	1477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihxHy98jxSufejcY25xjSZmqfwS66bZpfi5Kdc6vvVSk9AxVR
24647	payment	1397	1397	1678	1	1	10407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp9T8Ec1Zph91ooxQYAwR3DLzE6QiHA3PB4zq8ienpHuemtn8
24648	payment	2134	2134	1874	1	1	1482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPkoAbnL4uEd2YBcD7qE2Cf17LopJ7tZsx4H2WNpCMxkzRP98
24649	payment	1397	1397	1678	1	1	10408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9BezDAb8W15pFcAbqtjZ865P6GBJt5x49z6pw51bttDu52j5
24650	payment	1397	1397	1678	1	1	10409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbyXzfrHJDDPfLccj77V31ySk3EnmHj8isT3FFUXBpWWHFSFsX
24651	payment	2134	2134	1874	1	1	1483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtgyU4sLzyf3dXcxDFTDn8fAnLNULLmrRY99kREUzzGTdUys8
24652	payment	2134	2134	1874	1	1	1484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk4fR2pvn9a3WtC58LQhebPj2x5JqF6xo7869jSe8NaGaB1UQ
24656	payment	1397	1397	1678	1	1	10411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJtf7PvxEa9dPpXEdPbuCVDvZgvbXyk4WvyENcUQYcbhCL4TM
24657	payment	2134	2134	1874	1	1	1486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYmiLB2Qt1u8BF6cRuQz9Ax8psG8cGTDegCS7i8tJXVhgDoyh
24668	payment	1397	1397	1678	1	1	10416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YhEgK3rRVusTqSou56AgSmDcHWfrAUyz44sZvzaaQkxgS2X1
24669	payment	2134	2134	1874	1	1	1491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5Gcgz9To2jPn2iZMzHPJUCtc1g7tAFzpWV3JZUFTvhoJ8YXP
24670	payment	2132	2132	1874	1	1	367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEkubexSk2sFz14rW1tgfxJcNDcrAXSUNn4VAxiSvrrUR6T96
24690	payment	1397	1397	1678	1	1	10424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHK4Ggitb1nDrNPhZaUCWSSLQQ5np9RegPTkFS1d3qJaTifWDv
24691	delegation	2139	2139	1560	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8HCgB1pjSqHCWUrmq82TaxMnngNxJFvPBCsK2dZAysxp4KFN
24692	payment	2134	2134	1874	1	1	1499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oBxRmwy9SA2Kd9VVezCdsPiqfJhpt84miUWSwS5witgJuCnn
24697	payment	1397	1397	1678	1	1	10427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtdxd8WSeJd81RwC5NcwkVxZkRVT9mdXUFqWXw9pnDyJor4vn
24698	payment	2134	2134	1874	1	1	1501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa614DxkipiFChDeMSpWKYKWKhyUYsqj64SVzDKh9pJCVMQU1gE
24703	payment	1397	1397	1678	1	1	10430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7raawVV2byvXgRngRhsBJzeHHHKegRQwSn1TqGxpWiuGEdk5
24704	payment	1397	1397	1678	1	1	10431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfiHmTtH8Ruuu6hZyUMFgLbxX58n2XFm4cYVZiY3owDg2xhJoJ
24705	payment	1397	1397	1678	1	1	10432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcEa7T39kmsKJz3wKm1Sjr8YQ63qpiYv5HHm4vXmExhLpTpNK
24706	payment	2134	2134	1874	1	1	1504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGGxK8a4x15dTEdMsnGMhCfuahyzK1NNKfFuUcv97kuvxhdSC
24707	payment	2134	2134	1874	1	1	1505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfLZSAya734DRMzvpeWxL6Twa854XcW6e3zN2LSyHki2BB1r2
24541	payment	2132	2132	1874	1	1	355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t4tyspme3MPqKDF1Cb6WNRjLdcSPxxm8MD6wscmNmkC4xePo
24542	payment	2134	2134	1874	1	1	1453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9B8ovsw8SyAnctqcLBQmAURe9AixtXF9E4GszDV2C83cKgj2
24543	payment	2133	2133	1874	1	1	1439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUfQf8zVGxby1sbFqwLrFGbhDRPEHYJCed5khKnnS3AuAdwtn
24544	payment	1679	1679	2177	1	1	49	3708100000000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZqoq1GtDHxSQA5ak3rWhoQkb9Sa8BW4ReTnnzxpmWt4VaoUcEX
24545	payment	1397	1397	1678	1	1	10377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyK8c3mrfVZYBCvG1uDhQUBkzHb3M3B81aGN6jPM7u78zskwxx
24546	payment	1397	1397	1678	1	1	10378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDq4R8zUoV4jA2yrVBGezvh7f34wiDFnZUhUy5LW7CZzS4tuN
24547	payment	2157	2157	2157	1	1	0	5000	1000000	\N	E4YXYczkh3RDn4ayEo5fLXQf3U1mZyAVtadozsT41ftMqkqsJxvdM	CkpZ1xcLTb6pULrYKUQKfYGbEMeqEffJa4CwUEdTS98oRSdsWDWwH
24548	payment	2134	2134	1874	1	1	1454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdLLDJipYuhCGKmk5FWpMaLkK3MUKeHphMh3LSf2umFshCwMB
24549	payment	2134	2134	1874	1	1	1455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuyipy5t5x58sMToF8V1wgkjugfaVFd7ZyAHp6E8emn5NJPq3
24550	payment	2133	2133	1874	1	1	1440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp29nJPAzQfb6dkDyB4bRa8wobNq5DQBBoeVaikpGrjgaEqMH4
24551	payment	2133	2133	1874	1	1	1441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPgzdiqFUheFcomaXvrCQfc1WVs6jivvpoVfxcncTNubBn4Ya
24552	payment	1397	1397	1678	1	1	10379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2YT6q8XjrLcPiv2XXXdwkbcbH6JaYssJxrVthFsYnWUgsKd4
24553	payment	2133	2133	1874	1	1	1442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXtsLk5iivhcAMQPVH5kKS7gWfrV8Fs1gjYnKh1nsxQ25wqAB
24554	payment	2134	2134	1874	1	1	1456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pZjFcGmVvsFiJYvS6moqH7nAEe3cxi8g2eZBSJXLjDgFZoNt
24563	payment	1397	1397	1678	1	1	10382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWofA7AJ6PxG1ZAndpyiYqmF6CxWVdUDwzV874wSSNgF7i9fN
24564	payment	2134	2134	1874	1	1	1459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzmVyiEBHuAkt8WRmt37uHkMx4Fpg8YiPNxJgbqNynQsqFAQk
24565	payment	2133	2133	1874	1	1	1444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6L1JcLnb3wdtphMdSiyeixnBZXh6LtYBWG8Nomcha2fAYaszf
24591	payment	1397	1397	1678	1	1	10390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxaDFcW4exv6WcjkwUkDR8vdpYwqS2Ad21Fw9Eu1S38XDyvQf
24592	payment	420	420	1483	1	1	2	0	10000000	\N	E4ZRjvbHX6e16ZXnLT3AV7kagDtpqmgJyVAGj5iMHAHq7fb92dEhq	CkpZoXTL9cacGupXL4Rg169XyxVs2K8zbHw2EH6FxSgVLtyToFqyp
24593	payment	2133	2133	1874	1	1	1452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjdxwgetuW6pPGN5pCiPBtR5hptDdAgTz7JVnxJ1NapGSPgMy
24594	payment	2134	2134	1874	1	1	1466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgFyZAxsMEXD9CtMiTsTUDAGKPfj9CfGQ7sBV69jMeZghgp6k
24595	payment	2132	2132	1874	1	1	359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nekDL5P6XvBNCd2Zoo4pVBXZ1v9Jn7NmPnnPK8r7V8kY4pEF
24606	payment	1397	1397	1678	1	1	10394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHUAP6Zv6yiWcidFmNrdVYdgFJYyXT1wGdjhAoe95GusWGDUM
24607	payment	2133	2133	1874	1	1	1456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnTDhehR7mC9cGYqrT9EJwAntDTJdSgCBdUbpwD6HeNzsZajT
24608	payment	2134	2134	1874	1	1	1470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYmqck5rA3eu4v7N3Rkc8aA9vyU6uDETjK9fhXazsHSC2VqKv
24609	payment	420	420	2164	1	1	3	83000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7YCu2jh2pYUKagQCVLcPT8qVuj3qCLvGHjroGogSN7EkzaMp
24620	payment	1397	1397	1678	1	1	10398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF2nCNYp8qsjNtdgZuRHxhPXFNZeFhWLU6pb4DsxfG4sgwyZk
24621	payment	2133	2133	1874	1	1	1460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1fg13JjD8XqfXqPtYm6cxBnkCDKR73D3VZoHMnQgPPtAmaM2
24622	payment	2134	2134	1874	1	1	1474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZaAEyuuP5CX2mby7cHTVHU5f4XQwVwuQoE8VX5cQ5g9eMzQT
24627	payment	1397	1397	1678	1	1	10400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6vFRFxEPaaWXGBnEFkF4p3jwEnEwdZMVCnKd6jrQrk5sj7Cf
24628	payment	1397	1397	1678	1	1	10401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hcAjBxqZvn9FDpMfeLRcB1gFox6wFZrLZcYD4QC1U6VT2RhA
24629	payment	2133	2133	1874	1	1	1462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVjhDQzm8k48NZbX7YzzS1uiDoezui75eS4MXjTxqmzvfdoRy
24630	payment	2132	2132	1874	1	1	362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gpFuYZDF2c8XgTDHhJqXKSoBNyZ9GxYjjWJz8Z7NPjyt9FUb
24631	payment	2133	2133	1874	1	1	1463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ntdXK6eXGrZrXB8BKkALhueHX78NcZkKdqMq6yhxyLBQHKoY
24632	payment	2134	2134	1874	1	1	1476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfVKktUG6SBSvRFCsNc1bdFTh9dReA2nZJimJHLqxnHPdt2H7
24642	payment	1397	1397	1678	1	1	10405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PEZsZuDCi9GqjGqPbqAN7FiQ5pKEDqBAXcFyU61fMc9w3CfS
24643	payment	2134	2134	1874	1	1	1480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRW9x5iBqVzQvvhKbhz9dLacdn5ddYjgaAMxZcBCCkqcrayzQa
24653	payment	1397	1397	1678	1	1	10410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnadMSASbRtTiyFxktukU7t9bgAGXCcQEJ8ME87MJ3MopBF3u
24572	payment	1397	1397	1678	1	1	10384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcsWENxkRmdXFHNezkpTPDqyJLkiZ3enUwisYLpBkQrUALTmx
24573	payment	1397	1397	1678	1	1	10385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYywWdYsKbFVdabezrCdSfqsBisAMKq2hmpUTJeoxVw8jGWc8c
24574	payment	1397	1397	1678	1	1	10386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgnAZ36aTUQB9qy61w8uKA6GXQ8g8YpkGTs3HGVYFjL6fBKq3
24575	payment	1726	1726	2180	1	1	8197	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1W7KXkmm3eyQ6LDzKDStqEjgyvRoygNgM6BWYLDguB5ngc4wU
24576	payment	2132	2132	1874	1	1	358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9cN4gWzobFWPAqffQ2Z56xbHCEVTncySYQ8ayxRqbggPmz9P
24577	payment	2134	2134	1874	1	1	1461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7E3kGyVQzDYKzjQVauom7DASqWMQqsStRwrfX6K6TKFeS8mb
24578	payment	2134	2134	1874	1	1	1462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6nQDsBqVqmr3ogo96Eo2Lo3LtpDL9iUocpT1MFKm59TG4Vq9
24579	payment	2134	2134	1874	1	1	1463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYLmzq1fXoDGC4Ay8yiH8eyYKcm2EwaGtiuQCb242J1EqzDnt
24580	payment	2133	2133	1874	1	1	1446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iT2gtuU5ov4kji39MnVYMRvsJVR8DbdQMzC9wxWQyVG6Vtck
24581	payment	2133	2133	1874	1	1	1447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuBQNiSvtkMdhG8dQyf9HzhgjQjg4f2BZhVyNMviFEEABMqjN
24582	payment	2133	2133	1874	1	1	1448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSYcqYgxwoAZCq1j5G2wW6bZv5WhAnzJm33K6RJiJbBSK6agn
24583	payment	1397	1397	1678	1	1	10387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQBuHY6gkfUFXUyP97JMGAGQStXTKwjCEToxQn4um62djmSuf
24584	payment	2134	2134	1874	1	1	1464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeQgJsqB5QrvQefn4bh5AbiATULk9Rgxq4xFQeL97n6tzqRSU
24585	payment	2133	2133	1874	1	1	1449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB3zWdYjoWXanHzCd3Giksqq6auAfCLpdSrff2FzE5V5FuaHa
24599	payment	1397	1397	1678	1	1	10392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaeJ1jWLdJiBo4ZEtxdr9cgD8h2JKU1ngiQrgoqpUGCu4kyfH
24600	payment	2133	2133	1874	1	1	1454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXvMV5MkRhoAgSE5wgjrKahR2rTdEyLgnv29UH7JCxvPMYkzG
24601	payment	2134	2134	1874	1	1	1468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR1WNuGTkEy2f4zwrZLQvjiAtmXa3uURttae6CMDDUYRfBRGF
24611	payment	1397	1397	1678	1	1	10395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAtGZNgJfXPBA3RErVda9FyiBQhLXsHJShRdobcwGQA3MikFc
24612	payment	2134	2134	1874	1	1	1471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEthxqjAkNp77imNYGNF7miE9dD87B85PiLUXB8szWP2Npkbmc
24636	payment	1397	1397	1678	1	1	10403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTiXYDDzo9VjZWJg9efN27og1RHTDXMy4ymK2gmea54JNSM2P
24637	payment	2132	2132	1874	1	1	363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8XpaqUj6HWZ1b4s3DUUbS2nXGhcBKZZoWdmRoktxVb1CzrbF
24638	payment	2133	2133	1874	1	1	1465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnp5bArZznajo6VqKb2TaMHhmbNFZv4G3MDKtdo7NpJQNwGJx
24639	payment	2134	2134	1874	1	1	1478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1h9QqEXHkuhJ7xJYpgf5AsAYwEs2mgJMu4ecPioCsoZZfonv
24658	payment	1397	1397	1678	1	1	10412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1VJmR37thBXrvhYzyBmbLksrXzEVrurnQ8hfo4C8L4SaduLJ
24659	payment	2134	2134	1874	1	1	1487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9AXcqpn69XWmEf2QFF9o1DsaLBUmMhzmxHBTVKkrpx2LFrXj
24663	payment	397	397	2181	1	1	0	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkB7dFFz5pE9wwtduuX86dp1bSJLi2ne61LNMREMKzPE85h6p
24664	payment	1397	1397	1678	1	1	10414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzBgcEAp1rrFW6Yy1ybFSugCTy2T5YLrkqjocjTg7j1xTyR4t
24665	payment	2134	2134	1874	1	1	1489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXHLWvw331iX8FgVZDxz4XdNSz841iW9u6gQA2trK6iiiQESsd
24678	payment	1397	1397	1678	1	1	10420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4jGdfj2Kz2xEC4oghjHWQY5wkjpk5FzBx4WwmLH2NrC1QZZa
24679	delegation	2181	2181	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM23c21GGXtScfdurP3LhfthQSzNvodVvr1LWE5TPQ2bx5xr7e
24680	payment	1397	1397	1678	1	1	10421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqJXSyQMStLEopvdNydUZMPHJj2fjFR91FQCYoYhUTb9dMsVA
24681	payment	2132	2132	1874	1	1	368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY72oERm3AZ1ecBBMhCaPytzusvpexAN6RSmPxJ1e4e1eTd4Mc
24682	payment	2134	2134	1874	1	1	1495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZktLPa65m2bpPotT24Kemqcu5KBT6fWGiB4estkqM3pKnaK2
24683	payment	2134	2134	1874	1	1	1496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyoP2KqQigLPMKbobHyf5tzSfN7ttW7rhzNyV6AHqpmgS7aDY
24693	payment	1397	1397	1678	1	1	10425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58vstvNobx1HtXkwhBZM4T68bVk82fFQbLeBgndWt62apWEe1
24699	payment	1397	1397	1678	1	1	10428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1FpDnBLSDbWk6vgMdrSp6Q1N1o9SpFadZZ763uK9tJjgma38
24700	payment	1397	1397	1678	1	1	10429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitmPWLV8ZEdjgwceDCS3f1uMPgTKswxiNR5eM6ss426V5Svu4
24701	payment	2134	2134	1874	1	1	1502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCb4SmAt8zJL5CW9G7yyHqdVA3Lruv77xMHC66jnVi5DmdMfC
24616	payment	2134	2134	1874	1	1	1472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaF14B34UEfvacbsEzTreoyihdH6ydZZEnd3LN51rwBPJvZoS
24623	payment	1397	1397	1678	1	1	10399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjDXoygDPpQKFU82RdvoywE15fsxEsKqFKYE1NnhQtJGdJoBx
24624	payment	2134	2134	1874	1	1	1475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt46iE1YGYc8kfxspkbRPJDYaVXFo4XB367AofjHxXb5mjF9K
24625	payment	2133	2133	1874	1	1	1461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdn1hX8nFAKfg1gLB5xFhkeY2oLuDZcCdFMV25f9gVWgje6HT6
24626	delegation	1804	1804	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NFZDJCac6cHnXhaQrLB9tPiaAFC1TFbkmPYn6v6F1gdqgpVy
24640	payment	1397	1397	1678	1	1	10404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW6Hp5BWkRxtRYNtnWK19EQNCNNodRVFmhWd73xVZrd694KFW
24641	payment	2134	2134	1874	1	1	1479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1HXCCDgwrLcMZmoaFex94KECdPjCbTToBgEnoVbU75RDgtpY
24644	payment	1397	1397	1678	1	1	10406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQid2dgmEm82Sc2461xHVJCXJ2pTzsQVWwXU7e78H9P9iTyrT
24645	payment	2132	2132	1874	1	1	364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8sfjBZb7SzUejp9tDfe1pFdiy2rq7cyrphXkRhAMFi53Ka81
24646	payment	2134	2134	1874	1	1	1481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8d3wveSAoxw4pwSBnYG4i1ovb3nfRmsLWNnZVjsP8B8M1XerB
24660	payment	1397	1397	1678	1	1	10413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErNy87g2xufCTfLP2u9bzd3Bf8fmzGUcJWCaMUyuC4FHxoue7
24661	payment	2134	2134	1874	1	1	1488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1zvUVYMGMaEj73RFTuF3LWaGs5wGwaTBFpRiwedJ12VH6w9o
24662	payment	2132	2132	1874	1	1	366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXzivrY9CS6XuL3X385b1FALLLF7PFb4MgpKHR995Q6Qrc7AA
24671	payment	1397	1397	1678	1	1	10417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1svB6TfhmfzopFJ8mfd9foqgxg5UCkCi7Sja8AhH4iAi5uUsy
24672	payment	1397	1397	1678	1	1	10418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4tUnXgQ2bov3SH8cix2PuKAkKSxEpjd3CXGiQgk9GF2FjoTg
24673	payment	2134	2134	1874	1	1	1492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEjvvbj8RZ4eophqb2EKVnE1pWfJSKSAnTDqXk5akrxa3CEDz
24674	payment	2134	2134	1874	1	1	1493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBfHxBJmwhQUcTBQDzaGzd1JNmnE6WLYMLD1cGJGcU4o3F11f
24694	payment	1397	1397	1678	1	1	10426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq8ixEQhQH5m8sWTe7GzbozRNythNk9crvPbHsX2TxNy3hsfq
24695	payment	2134	2134	1874	1	1	1500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzVXnih5zAUJpGBWorXbyiULWF2UWwp5x68kG2juQGnY8xs55
24696	payment	2132	2132	1874	1	1	370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJ1TCtGH9iYQoEWSgZ5zGXaFNPm9WBqE3KKhC2fyZvLXSdJ1q
24720	payment	1397	1397	1678	1	1	10437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWe6hVbriMuPAVXnTCnfiRYt5y15hiD1h2LUA3fyLV1c4Ettf
24721	payment	2134	2134	1874	1	1	1511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z3e1GmXsY8tptbZoLTpUb66NSxxQ3bCiim3E54jLrGoh2JJp
24735	payment	1397	1397	1678	1	1	10444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpvfo7FDwJSLZ4X2EsnqLmxH6XDQQaPyiJC15wXuA2YVq97mH
24736	payment	2134	2134	1874	1	1	1517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRwEFAiqoaHYZgZicBF7wphrYK7KFi8KUKPWWo1DGti9Zxr2M
24744	payment	1397	1397	1678	1	1	10448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMjejiZqBrWiE22uAV1BY4PorHj2AF8HoA9UETnpqBsASHZga
24745	payment	2134	2134	1874	1	1	1521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oLTqzCr4RtbV2Yq1sLy8vmLAa7Un4c62GDgkqLwo5CzeWSms
24752	payment	1397	1397	1678	1	1	10452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZ8mbyYb61BL2gF3EmkrSsZv8xpmPu6AyzCybZ54hVVV4BnQX
24753	payment	2132	2132	1874	1	1	377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPtmXDenHq6B8VRCgSVqsTdCk7u4vYY5DxVg6ah7Kc3GiCBq3
24777	payment	1397	1397	1678	1	1	10463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUuajkgpBwH7iXyPbPHfS9XDY7s8SB631zthxk3j5j3NeRtKhS
24778	payment	2132	2132	1874	1	1	381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbGFCRewyuE8rr9SKY1Ri9BsnqXFaDwamJY3inUwpZFhbXwt3
24779	payment	2134	2134	1874	1	1	1535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1VhhPn3QRjU5u6hAEudEFYeyU1Uynnd2gE4WsFerxV7UpHSv
24784	payment	1397	1397	1678	1	1	10466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36K1BzQE3pLYtsPFQogCPq1E6XQHdFkiXf6sgL7fH255tWdZ8
24785	payment	1397	1397	1678	1	1	10467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupdZDwpWra4iBfJFtPRkbjD5d5393GSH1CjghbefBRUPtqQ5V
24786	payment	2132	2132	1874	1	1	382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfgUvaARY5KGcbxzgUKGm1nExAhn4rj7DhSBM74mwfhHBu8xm
24787	payment	2134	2134	1874	1	1	1538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnsbL24K1gCKUm7bAQuAH3mssKX3VxgyJaHd3kYfqzXoZ29Uy
24788	payment	2134	2134	1874	1	1	1539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwz26QsR9mp1hcHwwGvuSRpdu3dCTX7XaoQjKxJp9iMwoEAof
24796	payment	1397	1397	1678	1	1	10471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmGJ6fu3SdGmrx5DGEVhRtWXBdwXgnzQWV3Utj7gDfZ3H8AQX
24797	payment	1397	1397	1678	1	1	10472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9Z15X8he9ysyxFNxDtfqe7ed5W3GMvj8M2xUApvK7ffNvChV
24654	payment	2132	2132	1874	1	1	365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDasH1ZiRsP5qRWHv4e3wNnKHpc8fhtizBvYE4E97NL9Upw6S
24655	payment	2134	2134	1874	1	1	1485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHtihgixUN6dDPhVrwPwKcFVkq5PHK165tB2N898f3ADcZTgP
24666	payment	1397	1397	1678	1	1	10415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuB7wq3VcWYx4KDbrBt39wJJEXThBtAJNpiztvisZ5DjyWRMVJ
24667	payment	2134	2134	1874	1	1	1490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EjHpyuoqaNSNagRy8tgmZXadt5DDj3YJbwrzH33Q4swTajry
24675	payment	397	397	2181	1	1	1	612000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsi1qxrdoBrLR5aNnkjQstgi6Wg8wPoQBFGaPgqz5ovfspZ51
24676	payment	1397	1397	1678	1	1	10419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7LhGEUv8FYcBVRD5faMwPTjnj3UsYKePTYJZeGZBfsh5NSkN
24677	payment	2134	2134	1874	1	1	1494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rgoB6d7VkZRrK79bnmcJrdVVDTgmHGHeQ47Wm3oDoDxUK5hN
24684	payment	1397	1397	1678	1	1	10422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4igHzRPbgP6GHLHp8jSYyUJQqFxKk8bFiQZR9FEJCRTZ8jJn9
24685	payment	1397	1397	1678	1	1	10423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSU5eXkdTxvdj1bcSxZeQpqwszmVsy9CBhtWCSCG58mXXvTwAT
24686	payment	397	397	1483	1	1	2	0	10000000	\N	E4ZRkn5kfqEwjP97kiGDR8rrXb3eTCzYgUaPzq7DzXk935zaeNAUv	CkpZCs1hZtgN8oHRRLTpowVtq8K11RE8uXcZr58ooi24CM4D9a4xr
24687	payment	2134	2134	1874	1	1	1497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1txVZkhP9nq8AipdfncAd12RcKyxs2cFGF5WxDuBag9YA7uav
24688	payment	2134	2134	1874	1	1	1498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxDoYWokTDBzxkTZE72Y7HBXt2g2bEsN2WySMMM44UTTEDwi1
24689	payment	2132	2132	1874	1	1	369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNe5StCm7gfxPTm2pSE8tZANqcxwuXJy7LjBc222qDxbq2ksd
24715	payment	1397	1397	1678	1	1	10435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7oUvrWUQM4tCr5kZcxf6oywRT1BiwgYAtksiKWooeL8LuuDgd
24716	payment	2134	2134	1874	1	1	1509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gofk9FPGwwjLv3fEzevsSxcBz6krijcCs1b9jyB6yXEiVg8u
24717	payment	1397	1397	1678	1	1	10436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzWmXmgtS47ssY3HySUxRdNyfiy6zcQnnYS4hBgWGybTApFbL
24718	payment	2134	2134	1874	1	1	1510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4Fvshu5pQhkqEuhsrFroNWNcbojaFc7q838WH8G5fKjYDSTd
24719	payment	2132	2132	1874	1	1	373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hkjLpV2wKdfnfA1PMRnZN9iajSfBenj3Wegq4j8EAfp5Ar7M
24729	payment	1397	1397	1678	1	1	10441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9NUBbWN72XUrAxVH1Janhd7AdUM9sX1Harnna3i6v4TipC5S
24730	payment	2134	2134	1874	1	1	1515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpyQj44FXCrYNx5Mw1GnRzD6kzKA2Mgea4eWcErMCvnpA4zBVq
24758	payment	1397	1397	1678	1	1	10454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExyGeGqVuVU8qpJv1Tb6nCkgcJABwcT1ZKrGGgNsQ1bECqMtb
24759	payment	2134	2134	1874	1	1	1527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFD4fAWhAvqGuMLJJpxSDxSexPadWi3ySHXtGmwhRReiueT6K
24764	payment	1397	1397	1678	1	1	10457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtkLiABcLuabUWQHhPZPU2XKbpWDfUnz7bzAXBmPwV54hxnXn
24765	payment	2134	2134	1874	1	1	1529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHkHay69eEq5yx33tHEe1pzc4YX5EVvuxtxcYH1Mh8xESK78a
24803	payment	1397	1397	1678	1	1	10474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEtULc6fcZRjfFdhtWZGYvcdqYRoNy4Gw1ESkn6RKE1BRjrNB
24804	payment	2134	2134	1874	1	1	1546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrhxbwYMxiJMFHaKQXrSBkjasGYe35WCo2VyvgvEzLpvSMun6
24814	payment	1397	1397	1678	1	1	10479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqhEKE4wiJ1EKhYnueAqAYhnPprPwbgdSTXhdVHVR1upQ6LxS
24815	payment	2134	2134	1874	1	1	1551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQ6GsziKjCq6Yu7Ze5KJUrTRGPuUhoYtmZucQPaFV8cCozWNK
24825	payment	1397	1397	1678	1	1	10484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteXk3gUEBB7xqjncH5Je8BwSnEUxd4gEV5ngqNzeUK3nP5Qkm
24826	payment	2134	2134	1874	1	1	1555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs72BZPQLP8Mx2vqzh6GoJdPBLPxVJvpZz2fnuhdy9u5nRQdUR
24827	payment	2133	2133	1874	1	1	1466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9YAF9yc3pXGgszz1GDeuo6fGT28hQTvFf3P72EF1Rv6TSFxz
24883	payment	1397	1397	1678	1	1	10500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBGJE1YtJxSMBi42PwvcuRkYnJoScczvw4QXbkxzzrRZU2KNY
24884	payment	2132	2132	1874	1	1	392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmAVUYJtNGqJbQobZNQ1AUQPw6EQAcJsNEwi3Fs2cvU4hVEeR
24885	payment	2134	2134	1874	1	1	1570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSP9XrcyZYBYTsyWAcf3g2DRLPDsj3BnoH9p5TNykFYW1bw1T
24886	payment	2133	2133	1874	1	1	1482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTZXB3ZhW2Vqf4dfCnoHUKCt3RMDvt77PBdf5o1n9nBQ4Rgvd
24918	payment	2165	2165	2165	1	1	6	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHau86174jRgmjgxsQvbWLrBxsRrTg7psz9s4JLdbKjPGuaEtS
24919	payment	2165	2165	2165	1	1	7	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4EETiYUoYo8wFfWPQa8Xa5iHPu7QArkKaHDFQb2rm2DMoXtb
24920	payment	1397	1397	1678	1	1	10512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmuAXUKi6NcCL3YZsYj1WrCTXub2vwFuyLW9FKKSSRsfLVKV6
24702	payment	2134	2134	1874	1	1	1503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKm7GscqB1iAq2FviZbNKKD24Pbrd4iXDgqF7MMrKPFit8dE2Q
24710	payment	1397	1397	1678	1	1	10433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hnSawAav61gtKDMLioyxpg1H7dBztoeqgpwznSqARfcmuJHA
24711	payment	1397	1397	1678	1	1	10434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8yuDDgox8U8NQUhoR93BRBS5gRPV9FFcZXwRVECbWSL5E3dv
24712	payment	2132	2132	1874	1	1	372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBBes8BFSTLJXtaPqYtLHPQfEKfmawkGsQjdDFHJYeJWASohh
24713	payment	2134	2134	1874	1	1	1507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvo5gXUA2ZLs9iMqtsZJVhpgAvteMKTHdodXZfMHoN7rsqXWK
24714	payment	2134	2134	1874	1	1	1508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiX1TcLdQeEyujgXrkRcrPZfpfFE7ctidxjub1zpGP3PVSX4W
24732	payment	1397	1397	1678	1	1	10443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCaCAWedGjdc1N2eLaC3KR2R7tytgKP9BWgcKBJkw4M36z74A
24733	payment	2134	2134	1874	1	1	1516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdzKkLKXXFyabxZEdrqr1W4fENRPgLJ5ZZN6dvF6uW6uMynq5
24734	payment	2132	2132	1874	1	1	375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Ae9oUQyPLCActv9GvouiQjijytpuDaJNDGDADLJNgEkijbqU
24742	payment	1397	1397	1678	1	1	10447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ59Ty5aqiUZy69CGfq2GEJodfz3asPZMLtgsbiPMP7PLabd3d
24743	payment	2134	2134	1874	1	1	1520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYab3m1tThjHRJ5hgru2FHZU41zrfPqY3QFsVNBeAmipuLQiLcZ
24748	payment	1397	1397	1678	1	1	10450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNskNVJcHzvnZGMJK6TjWaXas2oTecwoM7sGT1wZWwjh21jMg
24749	payment	1397	1397	1678	1	1	10451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXMkDAyubwRZaM3iPWpMP4TXuU3Hf2GWZrufcLNBoG6Jchx28
24750	payment	2134	2134	1874	1	1	1523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6Zs3osTckmcVeVkcxTJzD7kvB5eZj2ceABaLytG1g2Jgyapa
24751	payment	2134	2134	1874	1	1	1524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEmc6X8uVd6waZj1JVDWAEbmMk4qSXSotAYkU2gx2qSVpwZTJ
24760	payment	1397	1397	1678	1	1	10455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGcqKEW1aBKrv4MNq6Xryndkyr53WryAdVMdMHx3xEEoyryMg
24761	payment	1397	1397	1678	1	1	10456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDAy56e1DNGVxz6z33tURFFaSKj8ko4h3a8u7E2SM1Xs8rtpQ
24762	payment	2132	2132	1874	1	1	379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJz14zxe71ZpqogUtiz4ZViERthfyEVRwt63yFbzQZv2mSm1z
24763	payment	2134	2134	1874	1	1	1528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwRcdWsmjEfzdMkPkyYDiUtrBgxy7DFaPpd5yaU2pciBz3NECK
24823	payment	1397	1397	1678	1	1	10483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4nvEsDgLcZciEnvSUsyUM2HkwH1Bt3HzpoRRVBNJTjEvQjot
24824	payment	2132	2132	1874	1	1	387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4fH8EwcrrqBDGpojos6n5CC28gU9ArxCop9V8Q3wZFYWn3iA
24828	payment	2165	2165	2165	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFANrW5owKnGDz96F2yJGJNedzgFpj7cbdmFU3sbMkd4w2vSsU
24829	payment	1397	1397	1678	1	1	10485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvj83CivSqXxHUmBUHt6Lv5etWgdg1RUnZQ3bjVGcHn3VAPBA
24830	payment	1397	1397	1678	1	1	10486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw1MwdWbpoSaHHwDxqQpdbywGiBo9aNTWgsnpyYczmGuYe7PL
24831	payment	1397	1397	1678	1	1	10487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC9X9VmZuLdU7VLQHz8LUPdd5cGchAhM9XT7pj32UtzwJT185
24832	payment	1397	1397	1678	1	1	10488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3zA9gyBgG7KEr3UyY6VbiRZsbtE1XaYjFQYgD4ej2ZQNRbaS
24833	payment	1726	1726	2182	1	1	8198	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiK8KDkRKfGNRS1W6BLZ5ut7PxGD9UvaBD3i4XgJ3PxAYYVp9Q
24834	payment	2134	2134	1874	1	1	1556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdM1FqqCFMZdfZ6NHihzUxdKYSCLzZP5dXnCRvA9C9t1MRUFCg
24835	payment	2133	2133	1874	1	1	1467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5uHptGaVwzLnEtdL19SqqP5ehtmaFt2PiS4bzridNraM78zQ
24836	payment	2133	2133	1874	1	1	1468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnoG3rcEgAuuGv2NWCN6h7RpFM3DHc9WsKTjcuLGLAr1kGpFN
24837	payment	2132	2132	1874	1	1	388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc76YphsTSZBMM5ugWnHvUzh1YCKRhs4pMYTUqVubBhT2JWeJ6
24838	payment	2134	2134	1874	1	1	1557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbiXoocnCdC3jpoZ7xycvhFvsBV9XF6CcqrL1pudyzush3msn
24839	payment	2133	2133	1874	1	1	1469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJute5aRv2x8hvBFuVww6aRVyiw3m1hCPhLkygTnpXiwD9pbB
24840	payment	2133	2133	1874	1	1	1470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLi1Ada3hcafYSu84vPSvBnSsuBQq4Ak2FRWzKepo2wMekp39
24841	payment	2134	2134	1874	1	1	1558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6oz9Jc9e8oPD7gfGvSyWZRT5jB7qjcYogix4kbEXVV6RpZy2X
24842	payment	2134	2134	1874	1	1	1559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHrwxicVPvyHdoW7Y1VqGyoTH719H993YKwhKpBwBVoruswqW
24843	payment	2165	2165	2183	1	1	1	10000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe22iZXpWd8wp9p13Wd7mj9tDrnXa89nvGPPNQBmhLuKgDUr2v
24844	payment	1397	1397	1678	1	1	10489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwJmzKZCq747LLUT5npdpmHtz7QGFHS2UMo5PQqSPJ8vXoP6A
24708	payment	2134	2134	1874	1	1	1506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiFsGTKCrw6o2Qypab8MPKEWcXE2zhP9GnrbEqsq2VgwxDUty
24709	payment	2132	2132	1874	1	1	371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYJZE8D5RF6jA55p3eMXjyRTCzgTNYXqaG6QMTbiHmPb94QeK
24722	payment	1397	1397	1678	1	1	10438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsE3uAtgUrgLzDCBx837BbwwX4quqFSxqwSjQwnUmviroCnUL
24723	payment	1397	1397	1678	1	1	10439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2XZdFfFT4vCqzHya1e3UFN8EDvBThsscGkSewbNjPF3jRbNh
24724	payment	1397	1397	1678	1	1	10440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWKWSQaKEkX6UMcaBYJVcWoQHSv7mKzqU7VWXyFSG2ZDPxR8h
24725	payment	2132	2132	1874	1	1	374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj91db9HkhrAJTfePWUjgPtVSwBcFpWN7ZpnkrUV8CDuzWS2Kk
24726	payment	2134	2134	1874	1	1	1512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMqhTCNHZspYjC82S2KPRj4aafC5xWdY4P5qAkWvsTHuJDXax
24727	payment	2134	2134	1874	1	1	1513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgJeMfacHFYxRhLSWYs1jzKyiH1SKBmTPJvKZ95RjYh1FVTwE
24728	payment	2134	2134	1874	1	1	1514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwgjCanfSn4DEt9D3sUsCG8P87FhSJvPNfkLYJhtH2gq54XAm
24731	payment	1397	1397	1678	1	1	10442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGpWYcukE9ocC1aLtHKP92Y9ujbufeieag8Tpw3NQKR3dAFem
24737	payment	1397	1397	1678	1	1	10445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6bjWNrtHLn9n7k7KCn6MEyiwERNsJDU5Co81AVHyXmhvZR2r
24738	payment	2134	2134	1874	1	1	1518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYgVAL91aUbVdwdLWSKTAb7KnsJT18aPW8JspxYXDnbFRnFq5
24739	payment	1397	1397	1678	1	1	10446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwewV5drZs24X5ru6vWbhuFSvHsCfAtnmDXrkh49pK65hdCKPC
24740	payment	2134	2134	1874	1	1	1519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoExmZ6e9HGKrgXXBNADvjBC5xWDLZ8zMV2qaocFgJEAreU8T
24741	payment	2132	2132	1874	1	1	376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQVkzWGQK453SHTcNX4moC4iZTVBdR9mPziJU2h7xBTi3BNRm
24746	payment	1397	1397	1678	1	1	10449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJd2KTG89kfPAZokWrzR85h9TDhQKBLK82p9tqcFPDetikdpCc
24747	payment	2134	2134	1874	1	1	1522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV87AnJLFuSxiQZXk3FgMP4KbgxF7YayWCcvSgyK3d33LcSCA
24754	payment	1397	1397	1678	1	1	10453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XyLowYMdAQ7AoMKmvnFypq3HSwp5WAsyptqnN9geBsbYDRes
24755	payment	2132	2132	1874	1	1	378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Z2bsVzhfmFwzQfv7j73iaebiZZzFXdds4ohoJDrpgzdrDvJc
24756	payment	2134	2134	1874	1	1	1525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ankGRbtwJcMSxHnxxmbunA5vFGE4FXXM3ysh8x86SbKpebNE
24757	payment	2134	2134	1874	1	1	1526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqWGCSJZbUWT1wBotai2zDDSVcJcdwgZUWqJn437Mi8irRnJQ
24766	payment	1397	1397	1678	1	1	10458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWCsSeesTP3r1UziRGhQXRxo8LZj3X1ruGEBhB8aWqJsxHTFp
24767	payment	1397	1397	1678	1	1	10459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqJmD4dTdUFx9GqBgREQVTx2ZoBy6wYKKis4z8ofrd39uTAiH
24768	payment	1397	1397	1678	1	1	10460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJRgx4jDrjjSGt4V21nhj57Hp1xVf8qTh652T2xmXaGLiabCL
24769	payment	1397	1397	1678	1	1	10461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbtNWEVzwyJeWgco5vY1utZRU2C5iaWhkCJYLhx3BKVgQn5Pp
24770	payment	1397	1397	1678	1	1	10462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFRfCwqiUiEDh3zNq4EavwZddwfhoV2zJDHrR1ELrWhoK7YTw
24771	payment	2134	2134	1874	1	1	1530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdJZEh22RWByBk1RJ6Lqu4jMFeSch4v3EGLUCKLakPMW2xRFb
24772	payment	2134	2134	1874	1	1	1531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKw7u73RsB37bLrLinUzVcsxNHBPdiiHDP4PHuY7fXxGBCThQ
24773	payment	2132	2132	1874	1	1	380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzp7bzrUMBSaFDbM23WC9pVuF3s6p7jB73YZEwZmFMrroC32s
24774	payment	2134	2134	1874	1	1	1532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYuvV3Fp1dAZvyvMSJtbK9xwRq1iYrJDQWjVyr5S18QDggqBB
24775	payment	2134	2134	1874	1	1	1533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTknow5kt7btqybWG1dA8ERLMchTBb6K2TPmsfUXSnXrPCAxz
24776	payment	2134	2134	1874	1	1	1534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KGkdjNYd5EC5wEhwAE42DTCrGuQKtN2MDLweTUrXaRkYaFRW
24780	payment	1397	1397	1678	1	1	10464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2aAZ8ph2XrTQ2qBbb2edssUvKZ2ttBUhxftze4yoyXSxFbh1
24781	payment	1397	1397	1678	1	1	10465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6cQGz2io4TWkKw8hCcR29WXeNiLgBvZUi9RzrrCzTf3MjQjQ
24782	payment	2134	2134	1874	1	1	1536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHsdq7VnQ5NUmTpRxo1TPbsHrJNxsK2Y7n8wpuHQeZ92gEsnCW
24783	payment	2134	2134	1874	1	1	1537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwrKu3B1zKhemNWAvAjke8Pz7k2Fsb2Zg9xe3DetVj9pZVcmw
24789	payment	1397	1397	1678	1	1	10468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiV9REGue8vhGLcAfY8PJkE1qTZFiWuPTXX9G6sbrhPVobaQ7B
24790	payment	1397	1397	1678	1	1	10469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cfjC2bf3QEEajkMtNpdtfFUgHEc6KaRg3kQUTmRd5gZ1Eit2
24791	payment	1397	1397	1678	1	1	10470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGWiUzg7UsHcJYqv3rKvhZdVTk6HYAMAJpwGwhAJWZ662J7sp
24792	payment	2132	2132	1874	1	1	383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYJqPfY7t763d52x6i6DXukA1FM5XFoXQ325YuGChaoXyxQaD
24793	payment	2134	2134	1874	1	1	1540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXa1xu7Q8qncC8fcWueRAmsdnLFWhgqv5GgC4aXkU5yAZ8ntbJ
24794	payment	2134	2134	1874	1	1	1541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphV4WsSPtk53EGVd7WtsaTWeC3Ab2JUsEVFdcSdcVPUA4Hr9V
24795	payment	2134	2134	1874	1	1	1542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwedyuAu3YWFskJyGHTG5jTcAk3dT61HBzcyQX4Coeca6TgjS
24800	payment	1397	1397	1678	1	1	10473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBapyhJ1TeSQrxL7LNm1HkrhtfFKX8HcBhH5DN5aexFc7hTo1
24801	payment	2134	2134	1874	1	1	1545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6jYRsUoXa8tLMy138ujK2FdGEYA1uz6Q3j2oXu6rJphcrxw6
24802	payment	2132	2132	1874	1	1	384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7hQ9Srwi3MriyeKd48LFFZvnv47xafGuGNx91oamEkSEwa9t
24812	payment	1397	1397	1678	1	1	10478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUbpNQcq9FE42XTGxR2LXbrXUnxF3XHcush6gZgDutmM5GNRH
24813	payment	2134	2134	1874	1	1	1550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCFQ8qeZYnV4CzrVfxE5ehMmrUEkfk2tahLyn8pBnv276CG49
24816	payment	1397	1397	1678	1	1	10480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofbTh2hfbfwbcVfUhTt1NsniTKkQ7aJVL4n1XHfAdSTfaw5Nz
24817	payment	1397	1397	1678	1	1	10481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5agW2iDcnqoNH4Pa375NujNf1Q2mNiCEQ6Q1FqLJsy5XxtvB
24818	payment	2134	2134	1874	1	1	1552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nkRuhuTLApCTgrvW9bn9WhKK6rEDrJQfkBrKRuLa9MuVGjei
24819	payment	2134	2134	1874	1	1	1553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg9WuU1r53FN4UfKpMU8ehnKfZS9WSnKqi2FdqzTMLJk2EYkV
24820	payment	2132	2132	1874	1	1	386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9e3qKEVYuJZWMMe6Mga7oAdZHbKi8h8nc7Qc2RbXXZR3utQxX
24821	payment	1397	1397	1678	1	1	10482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5TFbuMaQbM5n6niF6qCta7m5u1TvZo6eFh3NaPwaeapEbREt
24822	payment	2134	2134	1874	1	1	1554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu5BpBqUuLkMSKs5EM7ohnsxpZLBQButjwE1aBUHpoAU781NA
24857	payment	1397	1397	1678	1	1	10493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJ2uiEE35mpUA7QZiAdqr8gk5pYEsPQSZhDxTdGrQsS1Mhuux
24858	payment	1397	1397	1678	1	1	10494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5emDyXWbQ4FdVVvhvWeg7g4vQb7cooV3WdSTHsDntLqPx5Tg
24859	payment	2134	2134	1874	1	1	1564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFD4XXQy3pzTM1cx5UaztvcSPTuDNxwVZfYWX8BoR4ifG5oAa
24860	payment	2134	2134	1874	1	1	1565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1T2Dba6AhisGjDArXMG8248GmziXkuFcEC5CppK7JPMrbchdb
24861	payment	2133	2133	1874	1	1	1475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MHMbyjbT6FzL4fyNLo2pQSQHmzANWVPQQn6YdtgsuXtGZpAD
24862	payment	2133	2133	1874	1	1	1476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYci89TAqNmQ1VjHimUHYoBhgmin1oc9MWdVtyBGBftgZs2g7p
24863	payment	2132	2132	1874	1	1	390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ECmutiVyTtqfBX9oHwTHsbvRPRhJ8cpjXdaeH3YF8FL6kFyV
24874	payment	1397	1397	1678	1	1	10498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMu2PXfJAfzPpCJW9XfZo6ZTnQ7vYQgThTQQF1R9zsth2FcjmQ
24875	payment	2165	2165	2183	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9Za7KT3mS9LVrJrcoVwYm8L4BgvyZjeh74jooFvpTY2TdB53
24876	payment	2165	2165	2183	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9djfRjSitjQ1ik7QiN71M8hyUQwurtHq1pysH1kUk1PoVWbG
24877	payment	2165	2165	2183	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdLp8ArCjZPn1YXE67qwyStbabao6WaVVyCqjMoXwhCC28QTB
24878	payment	2165	2165	2183	1	1	5	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHLCYHgjMoJdb3Ma7XmrT4ARCBQv6WpvSb9QBVC5uQ6kaCiin
24879	payment	2133	2133	1874	1	1	1480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4HrqxyAxpmbJvrevn9rsZFAZd7StvuXta6neZ4dg5rvzHsxA
24887	payment	1397	1397	1678	1	1	10501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjB8NiN1tSz8vqzNTDgcc6md18FwGTKCWZvybBN8hgMoqN9Zr
24888	payment	2133	2133	1874	1	1	1483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3B5V2Q2M35Aq2PkQGzD2weN1UeeDhJyVgT6ZTZxQLvryjjQm5
24889	payment	2134	2134	1874	1	1	1571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFd5yJzpW55noSZGpoHoCnjJRfpj1AomQUK74TKMXaxU7r3A7M
24909	payment	1397	1397	1678	1	1	10508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeJ1zyrKk1NemqBwhhQfs7znuNTLMXkxiskmmKUnTgU6v6W6x
24910	payment	1397	1397	1678	1	1	10509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9Jv6eKew3ZnYkU4xqZXY7GGpBmUu1NiJJa8GXjhPkvRXE2xN
24911	payment	2134	2134	1874	1	1	1578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkAZrGWCfJ3qjM4x9DKf3j88cC8PYwmDFDjuahzhorZhsGQxE
24912	payment	2134	2134	1874	1	1	1579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV1EDYWTjfwe4pMsmNFLp3kHF8QSMLmTKpGr8gQYjrfHiQh8A
24943	payment	1397	1397	1678	1	1	10522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsNtY4hhRNRTHowqAr5gwjuWSJTEXDB4TE3QJ2wWw5DUzpXo8
24798	payment	2134	2134	1874	1	1	1543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUbMCZSADGyxzigw7JWch8hbZ2ouEfyQNzJH7LtY7ktnfhtDt
24799	payment	2134	2134	1874	1	1	1544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyr45jPFLdmyUWM2XsKiiw17vdhfndUym4W5JJQpLTpqnc2cCt
24805	payment	1397	1397	1678	1	1	10475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgZdywB5BpXM5sBp9fkYH9mPcNbTd2Hk8GcDfrNx9DxkFY7Ly
24806	payment	1397	1397	1678	1	1	10476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CDVQ2XKSSxgVyQHeS4SUyCzGeeP7kuHJfwN3oRXRGvcU1mLw
24807	payment	1397	1397	1678	1	1	10477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaQfgXoBHFcPeoLZeupR8BqXa7ejNyzsVEUb23j8zh3eZnZq4
24808	payment	2134	2134	1874	1	1	1547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6Mak2tRiHH2GAwCxBhZkFxBrmjXDsUUTJU6nPLy7a6RbXCHV
24809	payment	2132	2132	1874	1	1	385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa887kMYFdMsuXzb176jNdDMCtVeArfKmJ38MsE7TzgjRVUiqt8
24810	payment	2134	2134	1874	1	1	1548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZyEgqcqREGP4m8tGYamJnq9PfWaCoaN5UfYxtsrgVPF8s31C
24811	payment	2134	2134	1874	1	1	1549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkeZR7Pg7kwRrw1jbSCxrKMiBAVV47LB3qqX6n7Axct678eUA
24870	payment	1397	1397	1678	1	1	10497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRJDyaV9yeQJt2ECHuUXiwcsR9A41Pw7YnVX4u5m2bFq3MBX6
24871	payment	2133	2133	1874	1	1	1479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkJTCdJL7YZTz51wB3wgTM1CZG95o35zdTihei5nRQbw9QSJR
24872	payment	2134	2134	1874	1	1	1568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbS2GVFJ7KMbfy3AePVGUH2sr8aVyd5pTFWg1n3UWPLd3CUGw6
24873	payment	2132	2132	1874	1	1	391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAA3aDP7figS5idZrANJif4qftZGNeDnbdMtc2ZMk2jEwUbWvj
24900	payment	1397	1397	1678	1	1	10505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGL5dFrAWKyFZwANasm3Jn2bpP4xy3usPe25XDvfJSppHYg4o
24901	payment	2134	2134	1874	1	1	1575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXkbYaHJc4rU7KiTqEiq2uf8Nz3BW73EhUzwzQpJgYhghWrVQ
24902	payment	2133	2133	1874	1	1	1487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwX5XnjCn95qfZtcXmFkoDL79TdZsCfZwDKjxj9YwjSC5tU5uw
24929	payment	1397	1397	1678	1	1	10516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHxL53pYhqjzDGidVrYQq8sNQrBzqNsvQit3aLp4cbBTUX2W4
24930	payment	2134	2134	1874	1	1	1586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbk86U48ZB9CW9T14RFMsDAx11RBi7cwMBnGLNBJu1uHQvpNyh
24931	payment	1397	1397	1678	1	1	10517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNqtie5b6pa7ebP39oG6CzWjHfmzSuDbQDZ4UCbzHnWq8UyBW
24932	payment	2132	2132	1874	1	1	397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpnJHVBfzFYS2H23tx29CmjdFs4AhCVkfsokqpMvdry1r4fud
24933	payment	2134	2134	1874	1	1	1587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMZEVrmycF92Gjh54TJgUwWG1R1n2NeGtrktEGGN2dfrAKZyB
24966	payment	1397	1397	1678	1	1	10530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZDsgh7tG2BUo7Pqt3yyKEqtTT6geQrJTdaNzoMEDQfE4hRiW
24967	payment	2134	2134	1874	1	1	1599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvAx4GZReWSpgPUYoDaAwmHSMzRhC4LLdhkmkqNcsLwZiKUwk
24968	payment	2157	2157	2157	1	1	3	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xwQWLzir19qZujv71idiXsFAwuSrvTWX9kHXgfNAWWMXtnUC
24969	payment	2157	2157	2157	1	1	4	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinFuW7PjZg2c3mJoSjrXk2XP8bCJwo7Jov5Hy1PYGrPpVrAPE
24970	payment	2157	2157	2157	1	1	5	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPxupDpnTNMSi1ZQDKQXNGAgphHv435ujPVxPVBWWXMdYnEu1
24971	payment	1397	1397	1678	1	1	10531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiUvH5spxcoGJDP4tkM3HbqKdzn44z5kKaZn4UkVET8E6Lvbs
24972	payment	2134	2134	1874	1	1	1600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfQru2FMw47RBbNBexvKC3XYu3ZNs6ZV7STcvcbzyhCk8fo6b
24978	payment	1397	1397	1678	1	1	10534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FzfneggBbrEiziVHvxSN2ykYggTxEXMzxQiTiTcBQt7EPoAT
24979	payment	2134	2134	1874	1	1	1603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9fwizq3uZiy6EnVKWmMmbnsoRdYKewM7qt41WJPbSi6mTS6B
24980	payment	2157	2157	1929	1	1	6	2000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn7ep3AQFHG669a1MBCvnkhVa1vdFBKorXLfs1PZbVnzWoVhaM
24992	payment	1397	1397	1678	1	1	10539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9Fihgab5yYCTuj4puAq2bte3PWvntkFUC11U89mC8JdwcpLY
24993	payment	2132	2132	1874	1	1	404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeHtS7TQs7adrwijTnzjo6MKovKtU6L1WLKRGXWc5KV81rPnn
24998	payment	1397	1397	1678	1	1	10542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwjxRR4au7XbY5Kn5t3b5xGi6eK5CokfzLuedwfDmKUiT2zRT
24999	payment	1397	1397	1678	1	1	10543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3dWReuSUn8agm9sFoVtmnESu82352e83Lt543L2Lzkns5Dmo
25000	payment	2132	2132	1874	1	1	405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPwwJtcBSKa5QCPV4LGBjsu958f5pdwMEpKMwszPgpPqdLo3c
25001	payment	2134	2134	1874	1	1	1610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21Q2dCBbMZ5koFEvi7Pz7rcMFCZHVG7bvodgp7xpVbiZy21Kr
25002	payment	2134	2134	1874	1	1	1611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6Hc6AnjjTkxKfjqkLRwN3bhqgd2vPxrTjYTALCF2JUzhnkbi
24845	payment	1397	1397	1678	1	1	10490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvfygMgpuNqByYi6FZy8cJ5XaJBVYjNn4ZSjDsf4aDmr9gEiq
24846	payment	1397	1397	1678	1	1	10491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkBjTRdvLxVtsVfSqjByXJ4QzgcN2giLcd3C9YFDQWr5wvjxv
24847	payment	1397	1397	1678	1	1	10492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiu6SHPZHTZ7JtygCsfNmhhPfH2XmnytToW31T6B1QVKomTF6
24848	payment	2132	2132	1874	1	1	389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMj5gx56A4cUKGvoQuYpGQuyppdXi59DPtEKFb6zfbLLpiLH1
24849	payment	2134	2134	1874	1	1	1560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFRVeeJcjUYUs3keqnWLLeh5rgLWusLp3sbDUBaKKh4pmLQWf
24850	payment	2134	2134	1874	1	1	1561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFLfdyTErrCAW3BgeZoKG9bvpF9tHJtGLq3uCshNHBaapQfzm
24851	payment	2134	2134	1874	1	1	1562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXmqbo2cUu8SbViDN3zHne4Yf9V5QXPB2MB3Txhsz9duJD5xu
24852	payment	2134	2134	1874	1	1	1563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpussFHRtWiwmWY3Gmw5uGaxtNJo4vxyr7sAJbaacLq1agpUd
24853	payment	2133	2133	1874	1	1	1471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXjxxkMVz9Bci6w1QBWxPv1YnEkG6abG2MfVExq2b6C2JC7at
24854	payment	2133	2133	1874	1	1	1472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ci24o92VSBLMJDUXqXwWY8dfgS42a8bbrVTycZW8UknuDZqo
24855	payment	2133	2133	1874	1	1	1473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77bQ2HwazgJN7KNFrVudrPD4HtYBtcHrmHwtq8kocvJccNEY3
24856	payment	2133	2133	1874	1	1	1474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWbo9NMcXhUkPrdG2M3z9pBEhME6jan3fxf6aAHWPiyaAie3V
24864	payment	1397	1397	1678	1	1	10495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HYHPUtoLiGRW33V4dEjMNT8w7tyeFY1oDdV5GQqKKeAGRFCx
24865	payment	1397	1397	1678	1	1	10496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9wDjz1j7sYeE8QTB6MuniYG7xFTNfCMGJ3ihgrdthtvG7uF3
24866	payment	2133	2133	1874	1	1	1477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYurH8Y5LbMhXNYjMbgDwTGUxU3Zkfn4nD1aQxKDFfGikXFwc
24867	payment	2133	2133	1874	1	1	1478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwN313f5afajrYZb4bcqdyBsqHsMVq2JVXYHY2d4UbHm2rCcF4
24868	payment	2134	2134	1874	1	1	1566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VGv7j9kcCqJ6WPgB8GXA9Vgywx6RGc8kbAAfS4G2JqeK2hbN
24869	payment	2134	2134	1874	1	1	1567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZNPkqaBgcPt6mKaYDbEtUv6urp7hKkjsv4yVya4KgNua2AK1
24880	payment	1397	1397	1678	1	1	10499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm19nRhyygAFD6tLDvmimDVtKJEFgrdQN4pHk5MwXHDvx7SM4Z
24881	payment	2134	2134	1874	1	1	1569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EztGW5ercaBvLpysBttHNN3Ufn9vZbC7R5Yh1ZCXBqEqGyoc
24882	payment	2133	2133	1874	1	1	1481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVUb1wjvFsvAYj3eTG7VnRdLcQNHcay3rHMkidLAuqAQQZxzr
24890	payment	1397	1397	1678	1	1	10502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4cw3iQNhNdGRvP6Er7UbudFXT3sUVuuraEfH5BQUdrUp8fwU
24891	payment	1397	1397	1678	1	1	10503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEvH4Rgzz3NzBhrfi1RSxVxswfNM9KXbotNqQY8XA9DWUQ98M
24892	payment	1397	1397	1678	1	1	10504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8dQRitP8HvMnW18zkw843UTF2TPeoPYbd86q9PHv8C4Mk8hJ
24893	payment	2132	2132	1874	1	1	393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVU97qTdTEvCQBqVMyK4tyLo3RzWoa7mNKJiu3SXDCJ1CjbZk
24894	payment	2134	2134	1874	1	1	1572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5pW7yUGfAS46cNHwzbaAbeWdk8o4S4Vp7aKxcygfEx7YoDbg
24895	payment	2133	2133	1874	1	1	1484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnJJWEifKGk4W7UTyuFRd2Yag2Ngti7MPUS7fEBXAb7ndZiwZ
24896	payment	2133	2133	1874	1	1	1485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYURLommnvcGQrJAHkY2VXVSQHLKSrWiGD4tHZ3G8t52xYkYQK
24897	payment	2133	2133	1874	1	1	1486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29fXmywp51zCRbKiye8VsviMF3b2KXJjx9gVaRHGm3ZWBW6By
24898	payment	2134	2134	1874	1	1	1573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1mSs2GfGPi4xLJ3Za14K41i7BE9BNnYCudKJm3LhCt4fLd3X
24899	payment	2134	2134	1874	1	1	1574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tDzDqMyjZfqpmWt3Va6agbu7wVu6kPtNPaTmdreK2Xtpb63F
24903	payment	1397	1397	1678	1	1	10506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGY8qDMd7VjUM4TiTRmhTTop58TsXwCzexxzih3ejj6rHwCNLM
24904	payment	1397	1397	1678	1	1	10507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRs2jrzEuLgAjxVhYx6xZX7636ycDKcEeyajCs6gjtG5ZU6ewY
24905	payment	2133	2133	1874	1	1	1488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTe1pzvGekM7WSntWmPyapAZV9cEzui9yrbfeYBLuhZjuc9T21
24906	payment	2132	2132	1874	1	1	394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjJQyGpE63sdxCqKeY3QPVBJHcofJWhwhNv1BUsC8NxN9o9x3
24907	payment	2134	2134	1874	1	1	1576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgiTiFAHetqo6oWvFRjRrzeyy3a7QWKQVYR5PS4UBjEqxhzmo
24908	payment	2134	2134	1874	1	1	1577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjfhk2NSayGgP1HTGETpnPsT2vfuQUTYoyJXF8HGDjaqfdXjU
24913	payment	1397	1397	1678	1	1	10510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6HZAYPcRApJoJoiHSY2AnaAijH6uFuVSsJmByRCpgwt4QXpt
24914	payment	1397	1397	1678	1	1	10511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUSL5N8qne8yWgKs7JUmdMwioZx8ih8SNdvu1ugvs3VWjvfPT
24915	payment	2132	2132	1874	1	1	395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRxNVJGMcGNPTXiswZkAtqttWnF2dWmihtrWrsibi5kFuzXdv
24916	payment	2134	2134	1874	1	1	1580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcVwcbazETVhPGznwn5FRpRjTqYdQj1dDq4NBVCPdUAZVRBbw
24917	payment	2134	2134	1874	1	1	1581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4tZQHPDMu7BYNCQXqixQ2DSxxLGcQdemhvAeaQkd6uLCyJHE
24939	payment	1397	1397	1678	1	1	10520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSar9R1anQQnyAJXDpF3gbKYBz2XFQv5VQYsusBUsbYz1XFJ9m
24940	payment	2134	2134	1874	1	1	1590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPasEtEtF1jcSqNb5LYJoXbPzsMUszsEhJDCHut65RULydEnJv
24941	payment	1397	1397	1678	1	1	10521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCwcnBx5sd3oNxz24zETAoyYGxcXDWfgTjxVX2RrYorZPkgap
24942	payment	2134	2134	1874	1	1	1591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uvg7VUsDZcSWHbFB7a3GjJKLA5UqRPUAfdGbgMS8mkZcR7nR
24951	payment	2134	2134	1874	1	1	1594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2wNn6Zonkuw9DGmrgZ3sUZw9jzojEHCqxCasbewuEJwfmgsL
24954	payment	1397	1397	1678	1	1	10526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsLFswdVFc9DPJ8VDX1y9x3BfR7F2XbpWRag7p2WnM5cVAKjH
24955	payment	1397	1397	1678	1	1	10527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQrLhmtGKfbwAfFXfT6cRQvATwPZsn5dXqqT6YinpK57L6oBC
24956	payment	1397	1397	1678	1	1	10528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHVs3dGb52vG1NhnrnkXMykhzuDfBEKW6h7tV4fJbRVNTN1AP
24957	payment	2132	2132	1874	1	1	400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhGFxTd9Ys9W8xUe13H71D3zTS9dN8dQZHx5f7UyxRT5vVYM8
24958	payment	2134	2134	1874	1	1	1595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNc83qb8Q1Rg14ysMyvRTZJ2SJPF3txMLhuhJLmL22PeWHMEg
24959	payment	2134	2134	1874	1	1	1596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXbjVShZMoJyGX3hBTfjF3m6VvJ78f4zEs6QSGid7jLh4TFcm
24960	payment	2134	2134	1874	1	1	1597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJmbTEJpBYHsCdoHE4HLP2gZ6NuVhvBuuEAC3WHyUKMcsDfV7
24961	payment	2157	2157	2157	1	1	1	50000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcz5BUvrMg2ra8j87PDAKsz2kkgzAWofmJsssAmXXvh5qaYQZ
24973	payment	1397	1397	1678	1	1	10532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwernRUQ6hPSxzNituWmEj6T9rX2Wnz2URou9yhYgTt7MbXvyc
24974	payment	1397	1397	1678	1	1	10533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpddmX5a7PH8GyYGNdo3BcZbTWVcSQzWmVXSnyQB6ENuTrHZu
24975	payment	2132	2132	1874	1	1	402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsoJ4jYZ89y6FKZ1Hx2NGGnvxatVMHfAXJCJ6DuRE8Q12HGDJ
24976	payment	2134	2134	1874	1	1	1601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozB8tf6tRHJ9JbPXqfDjP3SwbMWRBTX2tSUnrSoFm4oXgLLKT
24977	payment	2134	2134	1874	1	1	1602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNixcneE1XiSxE6PMVxBGQJpoY4YqoMmZCejRFPfUT2Dd6FUth
24985	payment	1397	1397	1678	1	1	10536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9nw5qYi9utB4KVL94wQb7NFvWU13DWzWkoXf8rCT1zrCQFpz
24986	payment	2134	2134	1874	1	1	1605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN1CsVcfLcGPpyhoxBMhqpZcUHRmyu9CfR55p4TpSykcscg6J
24987	payment	2132	2132	1874	1	1	403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKLuK7C5K6u3KBsuuAcXCegZ5tfPBgcC4HgwvN1YDqJLB4N4v
24996	payment	1397	1397	1678	1	1	10541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSEALP6EKaqeUrKoKpxDM1uFvSBT8bLiraWbh1ukwJicAaJ3A
24997	payment	2134	2134	1874	1	1	1609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuqzJSoAX5eC3wM62QUiX5VZq8p8grMMDGFrFiCYJuPoXZ84R
25014	payment	1397	1397	1678	1	1	10549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztGUkGTrEQmpaxnoV9rYajgeTjorH45zWyY4pNjExhCb8UAqQ
25015	payment	2132	2132	1874	1	1	407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNSjPuarSa9tmbKA4VEpPZeCtjJTfjFe5besUPtYinzbZeyb6
25016	payment	2134	2134	1874	1	1	1617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3RbqCcihS48JZ4R3e4gzwXagrSbq8SHd98kNYQbv83zyDNxC
25021	payment	1397	1397	1678	1	1	10552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZystX3JhHR94NUutw3bn3H6HroLyEnp3wJnbt2D3miMCwPW9tm
25022	payment	2134	2134	1874	1	1	1620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEkGBdrjdQWQM2atTWnX8ykwNa3Yp3xe8ifcrnA1TGqEAUbHV
25023	payment	2132	2132	1874	1	1	408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNW2U19Z4WsRCrKvuQjBCiSGV49BhWpDZXAp6LkGK6zZ7vkhF
25040	payment	1397	1397	1678	1	1	10560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYapQw1YfyW4kS4aGyrAPNdJfZNFgUSGh8j3aLpFPthzjoJ4Fx
25041	payment	2134	2134	1874	1	1	1628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4thGBtyN3QMLuLqai8YGa9qCcrYKsDaFyF3YPxzwYZ5tZj3jP
25042	payment	1397	1397	1678	1	1	10561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNWiKjESwmkFSkbwnJ691Xj6sUEMs9F8fPif9BaaTf3Xj4hqZ
25055	payment	1397	1397	1678	1	1	10567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6cySgfvjiMkRUPp4edXMG2aykcX8RNNZSkzii2UhN9UCwteQ
25056	payment	1397	1397	1678	1	1	10568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEvJJZunqL7M9U8VxD94nDmeuCXSTpW4XxHbT4ojdiYth5DRY
24921	payment	1397	1397	1678	1	1	10513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB1yPREzZr8xyrXTo4oTbvKwYJLEKU5ydYExcXSGUh3364Drt
24922	payment	1397	1397	1678	1	1	10514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SFY8nMqrJnoCSZuzwJDzQQVLFnw1syV1EvmShrTXuhdCvd8f
24923	payment	1397	1397	1678	1	1	10515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacNNpSfj6VzdqAWUaKY8Y3HuGysnTFfK36XBcqbCdEma2T4vp
24924	payment	2132	2132	1874	1	1	396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqnND7rieie6XqmgTXZBM2gLZRH2mNtkBzp4QhBFN3rXvvptE
24925	payment	2134	2134	1874	1	1	1582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkt9fFWj5C8VJiT7vPneZEeY3dCkLFW69dbRbqkGnRJG7j9Rwp
24926	payment	2134	2134	1874	1	1	1583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoBYhfQ4vmCSjzhmCNDmeUzbT8wgpWMahELbpHytZAs8gr8dK
24927	payment	2134	2134	1874	1	1	1584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPmVEXXF4vMUj27KXnocajFKTLebzr7jUYYzHYegWgVLyETAA
24928	payment	2134	2134	1874	1	1	1585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UPnYpMtgnX1faA9HFNr5C5gMzxKjvsqNxN6XDPcqY13QVUuY
24934	payment	1397	1397	1678	1	1	10518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgo4b5Z1oGTzfHGtv95z3J27FFcz4wa2xZg4nCmiiXtxHRF8X
24935	payment	1397	1397	1678	1	1	10519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vy7bWHK9pH6yXBuUxn3SKBdhfDUKmUkWyBZU4Qp1Ltk1tNZs
24936	payment	2134	2134	1874	1	1	1588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJjiDRXBGBUoYr9YrPZpa8kYWNsVCaDm3XUyNtYuoZze43bLZ
24937	payment	2132	2132	1874	1	1	398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQDhJf8PA5f3rGH4c8TTv2c98KUPJNtZdeBZg3rkPM8x1Y8A1
24938	payment	2134	2134	1874	1	1	1589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSBrdAmFZjY6WQPL8ped2h7tjex2z6JnJEJzdaRNb3bcbV3G3
24952	payment	1397	1397	1678	1	1	10524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3ZQK5Lt4bnVnfNb64U9CC4kSefGSCtVXavNJoSJMddJpZBzY
24953	payment	1397	1397	1678	1	1	10525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXb5RgmdyiQK3R2wFP2MWTvajRY2QUPoxZaFg6shLCpdKE1oi
24962	payment	1397	1397	1678	1	1	10529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLDDtU4xRrA1aHvzfq21KaEiGncgeUxRteLMXH9TL8gDhBA42
24963	payment	2132	2132	1874	1	1	401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9wppFt5M2siDCFNz37WiaVVro6bN6F2CRjz6brCpkE9nCwKV
24964	payment	2157	2157	2157	1	1	2	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPTRLWkVHQfgjAWrKhTSJQHbFgJiR3HXf6e8nDxifohW455L7
24965	payment	2134	2134	1874	1	1	1598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XAR1WLAhGXsvSFz959grWiMvHW3dAa2LFkwrA7ejmALQVMeR
24988	payment	1397	1397	1678	1	1	10537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJYrSa4yRZn1zjZsTsz4xuWW8px48cq3CBR9SmDmB2QmMZePS
24989	payment	2134	2134	1874	1	1	1606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ698mCaeCVQZsPWWyBDeCLUQtJqWCzJeK3mS6ugXZQbmbBJw2n
24994	payment	2134	2134	1874	1	1	1608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJS6CE2jcr5cKdZiFZ7WnbPpJ6si6D7tVxa38MgMjizCKqAVMi
25003	payment	1397	1397	1678	1	1	10544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1xsdqTJHfYhSW13DYgJhgUirqQSz6aGY2yrYCdYXdL6Asayf
25004	payment	2134	2134	1874	1	1	1612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagw9RbzYNNfc4b4TY9CM7CtDfsmNojPaQYHG4DX7hcgsyxC1L
25005	payment	1397	1397	1678	1	1	10545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSduWRm3g1A1ouwwyMykDd19XzLzNbbQvCGhJFyuJDo3ju6Pqt
25006	payment	2134	2134	1874	1	1	1613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdbHyUiVmNcaveSSsFoQLh7s5gZjXybDsvDAhdGcg5y6FYFTh
25007	payment	1397	1397	1678	1	1	10546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcYF4xMFrQu8q4NT7azN8oK4M6Z1uTMRPnt8eZe25KfvHtzJk
25008	payment	1397	1397	1678	1	1	10547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaqrYdR8PWBED5sv8dqNmdXBsoiVAA4jXU3maRjeE2wNNFNHs
25009	payment	1397	1397	1678	1	1	10548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2K62FPTthZdXSdMhxGfSDBPKjmmH1KVWFKAC3fbf2PbvHZBp
25010	payment	2132	2132	1874	1	1	406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHwZf2nTFmSoSajrgtSxbnSYG6avykrKSCWPyinY5tQsD8ikf
25011	payment	2134	2134	1874	1	1	1614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEmAjK7xAxWYyKgnhn9MGgjbo1YADPYthRZfBq6LmdcBsD3ao
25012	payment	2134	2134	1874	1	1	1615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCzXpmwGGGkb2e4PGQ74Ey2hP28ZAuvPZQvirTNSm1t6wFore
25013	payment	2134	2134	1874	1	1	1616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzEzapWKdrcshYdc56UykH7iy9KH4uc6egg3sFLmJpzAQ298M
25030	payment	1397	1397	1678	1	1	10556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78mzGkCdnh7iJ1y4pD9Bao3gnAXED8B1JHxPg6VckrxTvvq5d
25031	payment	1397	1397	1678	1	1	10557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEcqwzZyfy261AJLfBhtSHKCPW2t1Er69XKs3BVjvj2B5iH77
25032	payment	2132	2132	1874	1	1	409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcqNDUDcVqYYgC985TARnVGyuqUoybfLPTYhAiyEj8TKZJo2h
25033	payment	2134	2134	1874	1	1	1624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAaEjZ7fuTd8e9UA2XSrNCwuzDonNUYxcaRxR4opS4acJTnfm
25034	payment	2134	2134	1874	1	1	1625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnL7foX5RRpCPof2vvFvmJMicvB69ZKxTX27xBy28E25K5fHtu
24944	payment	2134	2134	1874	1	1	1592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6s1YaR3RVUrtcK5UVAauthfjoNmrprVPayLT8g8ycf7G8rpP
24945	payment	1397	1397	1678	1	1	10523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZQ8eS6Hh8p6Q1275x25mG9iLLvRrybJ7cDjWK46TRKT29Bpr
24946	delegation	1740	1740	1899	1	1	11	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz7jV4mTZFHQCs8w7tngybEx89Lomb5ueTAWc2WRhEkSVeU8X
24947	delegation	1899	1899	1899	1	1	1	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyqr8492rszAKy3UxUFkAYSsVufYP7JUdkdomaRc6yk2GUeuB
24948	delegation	563	563	1899	1	1	10	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYCsbo5nfx5e6B5sFDYcAtefguFAF9hq1heWVtErDVPWFNobo
24949	payment	2134	2134	1874	1	1	1593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtg1zTKVJn7QtSoRCk35Gd6c6KrTcEahWzBNdc9G3TKgXh2DBU
24950	payment	2132	2132	1874	1	1	399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoRkEHVr2K4eAf1Wpt9zUAS75n5inBnmaaeAusgqDQSbzQGZF
24981	payment	1397	1397	1678	1	1	10535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vH2HzVBPntAmFfVP77sE7RRxDbQRY6U5sxMXjeYFzWiZVAef
24982	payment	2157	2157	1929	1	1	7	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrU8RNebyWGRc59ZQYYUz51CdhFHhRydRbSo4egS3NhGrtXjN
24983	payment	2157	2157	1929	1	1	8	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RQVz8PxUzZ1gXEa8RwLmEei61FM1q4DKxvmWQEpUByUG6n7G
24984	payment	2134	2134	1874	1	1	1604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Pzp1ZCuQdGApqWQ8wNetHUQW1kcm5XX9JaiR38CUJBrju6H
24990	payment	1397	1397	1678	1	1	10538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfNz4LWArmuzyoJqcUEqTPmkAmpiYAxzuCz1yvQBVLKfwQ6X5
24991	payment	2134	2134	1874	1	1	1607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1wfxXVdcDgkC2hKS7Yd7LYQHk6K2bj5yZuFu6dTpED9t58s8
24995	payment	1397	1397	1678	1	1	10540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnrfrVm6tgQCZd1SQ9HP1qRR1capJTNk8iMCo3EfT3J57KcFQ
25019	payment	1397	1397	1678	1	1	10551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr9PFjfTdvLZc2igovKwYb1gdMnfg265rNAECHDXMcqDXuNSb
25020	payment	2134	2134	1874	1	1	1619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5bLQsWxDqgkSygoLnEYYMi9Xrw5KEtFfvDsGujEVbJz2Tn1y
25026	payment	1397	1397	1678	1	1	10554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UBCihv9KYvNrsJDzDdoSFS8MbaeGZWCEk9DpMMtNuKWpNo2o
25027	payment	2134	2134	1874	1	1	1622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWryyFJSBaZiYbHqwihEt3acsgZR9v6cyYdWhHfAYNAy8ufMb
25035	payment	1397	1397	1678	1	1	10558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1HXD6dWuGvdwT4iK2iZFpkuJvPhxrm2CcAVy11io513FMBrG
25036	payment	2134	2134	1874	1	1	1626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR39Nt9jSckogf2RweGkZdSk24XVbkbU4ibAhtry6GbbR9SXdP
25037	payment	1397	1397	1678	1	1	10559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvY265wYWgiNx1oy1zhH3VczH8F1Hvcm25j9H71Wd4qGtr4v7
25038	payment	2134	2134	1874	1	1	1627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekbAJYhdy8AAPXqVAzyandUzbkZok1USSE2XCZKfRiYZGR2Ha
25039	payment	2132	2132	1874	1	1	410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN83CpQqAmne7RZw7qKqSGxgNZ8nPC6xnevwYxFkkqiNqXd7u
25050	payment	1397	1397	1678	1	1	10565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuioHaDthJYBMr3oy8NZMTcCkMqDN6EnoBofWHs9wLF7dcDRbd
25051	payment	1397	1397	1678	1	1	10566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBF2jR8AAHzSThZxGQPfvNS4AEHCPbUsn72qiUGEm2RqcPa5rd
25052	payment	2134	2134	1874	1	1	1632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFRxhKj8pHcupSwur9JT3ViYCeADDjprfvmb5R3o72pzLSdw1
25053	payment	2134	2134	1874	1	1	1633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7q7ANSDcmpEe7ixJ7JNPJkJpnNGo64RNtDk1ucXcCMEGPjYA
25054	payment	2132	2132	1874	1	1	412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCyMRUtjSa3fismWbGP3nBsTBQtpBXXwLzGP7pn8wkm6eHM79
25091	payment	1397	1397	1678	1	1	10580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftKaSKhtpZihXR8ckZQL9kw3cPmMWVjZZPZ9k5SajBuKUCzJH
25092	payment	2134	2134	1874	1	1	1647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FvGd5FQhVsNbqHm26ao9PmLU5MKjLY14ZGgYryDmr2kobsGV
25093	delegation	1924	1924	1401	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2RZp4L42Mk6QxhdrjZbtqhuLkkmQpPRAm9NS4QhAtQPeBdT3
25097	payment	1397	1397	1678	1	1	10582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk1iNpJPx3tbgiTPNbQUMHh7KpM2iqFe8GfK6SU7hVsX3V1ks
25098	payment	2134	2134	1874	1	1	1649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTQU9X7pXxZg19i5zySJeJ7chzjjCFJxN2kY9vchRP7unoXZe
25107	payment	369	369	946	1	1	4	132250000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqQm2AMtdWjanem1ZuZJyGChdfA5v9HLdRBVqD7aJgE6XKfHe
25108	payment	369	369	1066	1	1	5	237000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsdt2FwN4jP92yuQmkaAqceMfMViWZPUWhgSXuHxtfq84rvkL
25109	payment	369	369	1186	1	1	6	160000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwYCKz8MkNAaogCnQyRJQrX2swgi9V7WCdetHTBqFuiB9hexS
25110	payment	369	369	1312	1	1	7	446000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pcXFasWc4pYNEaT9buVteYkymrNTTxAVZDar7WCWDoyMYPDk
25111	payment	1397	1397	1678	1	1	10586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fio4Z1SgPLr5VzzecRzpUo4DA5dMcW28MC7q5sAgM39mJf58
25017	payment	1397	1397	1678	1	1	10550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fVrncXYCjzBtAoTaK46kNXWBJnmk2hpN1Hg2VtnySqd5CzWj
25018	payment	2134	2134	1874	1	1	1618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DPku4hFBKmKKcznyG7fjURRZFzxJPCCGSrwxuN52mHuVV8GF
25024	payment	1397	1397	1678	1	1	10553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB68Lgnj6byLoKQs3vuUgsQSbK8uHUV5uxBhWdCYB35UatNXEY
25025	payment	2134	2134	1874	1	1	1621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyvt7uNkSPdTpvQX4gYmeF1LjNvENHtXiL8qqjLBsprCt5Lnp
25028	payment	1397	1397	1678	1	1	10555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDwU9jGQk4uCEe8fQ52hxFTXPYzBnLzcC1r5GiHAskftYioNE
25029	payment	2134	2134	1874	1	1	1623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46NQLy2QJWg17xToU5c5QfN7b15RMwKmRB3HwKiNtmn3sQ3Yw
25043	payment	1397	1397	1678	1	1	10562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiViqHfZ7sBwPCAzvMuuWaqkNj1WioS4US62gDaJmH3ksLALAX
25044	payment	2134	2134	1874	1	1	1629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHwsx6He2F6jJdDJhLsv2nV5sayA7oKBdqqtKeAkqu2JhwcSx
25064	payment	1397	1397	1678	1	1	10571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdNcv9WmU1bijVNB6M7i4U7FSRDF9kNfDZ6j4Le9cAS71Muc3
25065	payment	2134	2134	1874	1	1	1638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1SPHxWoGS6wzZkvn9WrbovU9LjVPfCnBqjqp9fhgSqXutJmP
25066	payment	1397	1397	1678	1	1	10572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7S31FrKJ33hgkd6Aw7R1ce7wT6iRo5eBZrzzLFwDrjbZoxYkT
25067	payment	2134	2134	1874	1	1	1639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxYRYRkk7uRMEeeeDFMaZF7QSHL8WRoRYmfcxcNSM7Q1Z4fPb
25068	payment	1397	1397	1678	1	1	10573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhxfgGsQBPWjQJAjoUrd99WJHQnpnRw9T8uEwMK8umbCQK1UV
25069	payment	1397	1397	1678	1	1	10574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L2mM7cLZJL7jyCy7CGsgQ6Uive5YysQ3QxFCUC2f5vJDEkRj
25070	payment	2132	2132	1874	1	1	414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2281vgpxSzuJbZ3iAMMF9khWJS2cih7AbKbeC7EqbV9SE3U8
25071	payment	2134	2134	1874	1	1	1640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosMLQSbA2brmjjpLi2UjdpQeBXhPESzV8nuenokRBDFWFidyv
25072	payment	2134	2134	1874	1	1	1641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uksiVmLbWwRqxVjQJVPp1m3wGw8PpqiWVmRHWsEtNxUJC14S
25085	payment	1397	1397	1678	1	1	10579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XGhbT1nwqVcnohhpjLRJ8Wk68HxZrfAGdc1ifQtfFbpj6ggY
25086	payment	1643	1643	1173	1	1	19	224352000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGoJha6AgffX5NB8VAcpYCp9v4WugxZnR6e3h6qdJN9CNNJtn
25087	payment	1643	1643	933	1	1	20	185637600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YnGLTyTr4N1ZAqb4B5yQLgPPRrHNpM5BaP9fhgDzh8hrhkBp
25088	payment	2132	2132	1874	1	1	416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK2eizJXAW7CMXUyFbkGmotyWnYiKjn8HtjAvNvza2U9yT4bw
25089	delegation	1925	1925	1401	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmXaxvDPQ26YztU1CEbULZSSi3EEzhSqq8kfyDKXqFmp8fKjA
25090	payment	2134	2134	1874	1	1	1646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEBfEsKDCzKozaBKhdM1p4xzBjgMyABXehzBpCRVphWpTmbXM
25099	payment	1397	1397	1678	1	1	10583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeg7Y8XXNMASNKDCdCcuJ2sGaVdE6LLt3oDQkzGNHBzhx8KWUA
25100	payment	2132	2132	1874	1	1	417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZH58wSDK7WLSnSci5FHMcSSCY1q1n5FkEEikVhnd3Fe8j1b7
25101	payment	2157	2157	1929	1	1	10	4200001	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD9wQSoPSqVsYtHGxmUcYeXw9UpgcGzRcqeLB2inEVTQhVzNQ
25126	payment	1397	1397	1678	1	1	10591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYau5QfuAYhfa7SVfRiXvCjv8cbArEB29nWZ9njAvuRMAckpAqm
25127	payment	2134	2134	1874	1	1	1657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1GcmQFvQJn3waFk4mnHQQw6J2wYctearQtvWgHajPNu4nPmM
25150	payment	1397	1397	1678	1	1	10599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEkjFUZpXpKDdpkXrgL2CyefM2qBrHAXB1niYpAiLdWuXJrjx
25045	payment	1397	1397	1678	1	1	10563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwgSCvZFnvDno7LJSTa8Mf2PdyC5su4hXq737B4brGtToSuvf
25046	payment	1397	1397	1678	1	1	10564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkE1hiuawrzJ8v54QsHUtoQt6ErB3dW3Xye8Dvrn82AvfDBwyH
25047	payment	2132	2132	1874	1	1	411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11yNu38tHyMfTCwnnVxwXhUjgSLsUnZ6bh8vcP8knLzLsQ1g8
25048	payment	2134	2134	1874	1	1	1630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4S9aFHtxaHNvNKJosqUn2nU48sefVdu2kALu67EhTxZs1JWi
25049	payment	2134	2134	1874	1	1	1631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymWcBVbhPr9uxMGMv3mKpFKSXKZTx9PagtJzNp27eENnuUJBD
25059	payment	1397	1397	1678	1	1	10569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPmivYBGhVMQ7KhYxo4KVRUVGtRuiSpyC7bGMoyRVjg8Ud8BA
25060	payment	2134	2134	1874	1	1	1636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiE74NEnqJLwAdLEc4NSZCaHZ9pKpCVwMjS3EtpSeYNRcapzQ
25061	payment	2132	2132	1874	1	1	413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mEm1hTXwNuCjobuukK29HmzLK6YDMSGgPHKw4k1ydmGGr3WD
25062	payment	1397	1397	1678	1	1	10570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm88cuK4Mv1C6MUUiEHvdpehvw896QpPbatsfF1uP4mtBfeSUW
25063	payment	2134	2134	1874	1	1	1637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxWuBo84MZpTPFH8jYmp8HMVmWde5pmrh3JqgJFGi8BPZDRq8
25073	payment	1397	1397	1678	1	1	10575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDH24P8esmL4GkTqgF5gcD9RrL1xzMY2Qrj8uV2TnWmACALqzH
25074	payment	2134	2134	1874	1	1	1642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUEAxsgg8j7LMKNSjzjYzC8BXYbMEapTvqpgRgwqZknZpT89C
25079	payment	1643	1643	1299	1	1	17	625312800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWrvfEgXcxQUGuWize9Eum9mRp2burffACwceioCeeVKztG6d
25080	payment	1643	1643	1053	1	1	18	332560800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9Sd9mmi4owPjooE7kAwm7CSUN9JM4qt2og2jyurAzWSBtKmB
25081	payment	1397	1397	1678	1	1	10578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSneYUrtm4aCDj2tQ6ou1BSqoSbEHqSXDjuvXC9Wvzrau5Jdfs
25082	delegation	1926	1926	1401	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHnU1uyXLygKoQDm81Z2uZMQFW2eTvsWU9wLcPaYLpYoZMia8
25083	payment	2134	2134	1874	1	1	1644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2rBAuJE6gc1PMFd11rutEhQCyoFuvwvDy2YSpdLjvmFWtmzu
25084	payment	2134	2134	1874	1	1	1645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZje6EwQSD7AQN9WGqJAUEwvmnsf9tXJpKLYw82wLHKQvCLTfx
25094	payment	1397	1397	1678	1	1	10581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvTYJhdY2s2MF4uW7mS7Wcfpm8Naq8wU22sGdxRkwmcS2DmUw
25095	payment	2134	2134	1874	1	1	1648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfiTaZ2Kdz27kzmU6TZNL8BT57ioueQn4u9dGxXsnzTYRgo2a
25096	payment	2157	2157	1929	1	1	9	5000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdmVRoNykPYZqnj9V8voM6wENWf6bNdpJR15qTa47t9ZSbivp
25102	payment	1397	1397	1678	1	1	10584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnQuAKZHoHCY7JMuJCGNFurqrXKoRERrC6UmkL1eENaSoBCSw
25103	payment	2134	2134	1874	1	1	1650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHz2U7GpnpPbSVpVTDUmF6rAVN2Ynq8ueaG75VDxhnaVUJckc
25128	payment	1397	1397	1678	1	1	10592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4JGTGEd4ftkwtkXKfTSmVVEU7VN4q3d8r4Ecbc3URUKDKkng
25129	payment	2118	2118	1726	1	1	2	1000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYinGDxRDv95U9dRo32xCihWGjiLcD2HosRiwvYgXgvynXRh9rr
25130	payment	2134	2134	1874	1	1	1658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwshbUL4aAwLT4ga7oNK31x9ovje8jWK4CaZd1RVLdiWR1DZrm
25146	payment	1397	1397	1678	1	1	10598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGTnjLRNJcePTdB7Ejq3WEd2dAKvjLzUzFK6Vu42Pxh12BNjb
25147	payment	2134	2134	1874	1	1	1663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZuMQ2Q38WSWgRod15yzTSfQNJQW45hroUZgoJfPFyf2ve5yJ
25057	payment	2134	2134	1874	1	1	1634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb96gjt9GyY6XRLoyfsY7FDtW2LCdrXNRhLrYN5xQU32yKTKH
25058	payment	2134	2134	1874	1	1	1635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwXQ1KfxxaqZKhY1tVQjgf3KDjZTCaxQxftkGdwwsdMasHjoM
25075	payment	1397	1397	1678	1	1	10576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeePQwNXFdxPvH7iGJztTznPWaERW8C69b8daL4j3Scp97MLG
25076	payment	2132	2132	1874	1	1	415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6bGWXqF6inhK8BhhdUvHkEuGMSu7vz76yUjt2JbcBHgJVBcz
25077	payment	2134	2134	1874	1	1	1643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5QowzwGBLVmkGrMbCoZ6Cg2XmuY1EB2D2z9UmDVxK7TvLb22
25078	payment	1397	1397	1678	1	1	10577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspDcygsqvzc4ouHfhuA1WDAfzupZqoXPMBMnMZWGCVLP6xGbt
25104	payment	1397	1397	1678	1	1	10585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEJTzDgcYjVbZ7oMTS4GrCAw8MUXxozZg5FQMZxUBCokS5cNE
25105	payment	2134	2134	1874	1	1	1651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTGiCU4denDpHpJYgyxg7V7dLTywanqgv1HPUj73eaEyEmjsF
25106	payment	2157	2157	1929	1	1	11	4500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPd2VJUyzHU5CkwUEgvD2UPBBRjD9C93KGJEJTcvp795yRiLJ
25140	payment	1397	1397	1678	1	1	10595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQpA7LNMNDi2TE1UVzdR8dx8wM4x9mxhGW2kLTLZqyjERd4nW
25141	payment	2134	2134	1874	1	1	1661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pUVPcMm3vaBhbsLW7Bt5A1JdchJfztVEb9qG1ebR1f7duidB
25151	payment	1397	1397	1678	1	1	10600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiRe2rmoihV4BNaegpDQpUuStHuQDzcfvprzaUaroTdXFEKtt
25152	payment	1397	1397	1678	1	1	10601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKX2KMcDfSpuQvjuHhKWF3uv8GkcNWnqMy8WWZ1HeNdiqotNg
25153	payment	2134	2134	1874	1	1	1665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKmPSiqK1MrkiFVVeDYa5j1SGXdrWLqf8XEbHqj6bxUSQpXab
25154	payment	2134	2134	1874	1	1	1666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQ4XR3jXzbzx9jfvJP6HDzqBaJ1XNB311Yu23QHt8bZN8NW9U
25112	payment	1397	1397	1678	1	1	10587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrXFBXUPFjond8T8a36eVwYvBQaDqHZnfcf2G8Di2Kn7U6Ga4
25113	payment	1397	1397	1678	1	1	10588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKbEyP5kYJyHvzZtHTyMfsLNhf5txeM9J26tND4AATHgztfby
25114	payment	1397	1397	1678	1	1	10589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzat8q56Bke362y1ME6kuj5kpAD5p7rx1kQfBqHVN5PCWZ3v63
25115	payment	1397	1397	1678	1	1	10590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFL4FTKDMzyiWMuegdkYzcBmXpXz1ei9FYCeqJbeV6JuzpXoK
25116	payment	2134	2134	1874	1	1	1652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxgSAJgiQ98z4U7WzUkSXp3wwXKc1LLzF5sUXrVnvRa7yvYcM
25117	payment	2134	2134	1874	1	1	1653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZ2ERT38DoWha9L6GUJdBSso7XntiuTQ5CFpZGjFrG4zkt7GS
25118	payment	2134	2134	1874	1	1	1654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PoJV7kzyD4tMrGUYBc7pWUUYphTZV6Khb89uBVSy7QMPMi3u
25119	payment	2134	2134	1874	1	1	1655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYinVKGtss1cJcFiX89a6GWdshMpzbv4qFMt5gv7KYn2L5v9w1
25120	payment	2134	2134	1874	1	1	1656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKPDMZnuzom89j4cnoQQNDn3uT6j7mbNDwNysWCoxPoH9YoWr
25121	delegation	1750	1750	1401	1	1	32	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguA5UM46ooutQB8Hfyibwyy2HR6CWz7SJXkXmgjaR6Tvq6QRB
25122	payment	2132	2132	1874	1	1	418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuy6a7Yz84NJf8nJW3EMsEYYFJqnyX2jB6WH8xR1z2i5Kz2BMy
25123	payment	2132	2132	1874	1	1	419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYbfjS3PfLF8tCCLXKnm5kznuTT6WBnogzz36R3zYdrHXvqBX
25124	payment	2131	2131	1726	1	1	3	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpaJZ7U7Sn77gtpd4Uw9m788vBfUHCKALcCzWRHL82a7Z39rAfEb
25125	payment	2131	2131	1726	1	1	4	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZ6hXp8BJAzJea4qg2g5k3QpYFeZ4rxTGC9o7iBoEoQUCkt8kUS
25131	payment	369	369	946	1	1	8	6620000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6jFrTjXFExbKjB4ztLomwYEW4RWRDVGQBJ7imQE412NGR9PX
25132	payment	369	369	1066	1	1	9	11850000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLKAr2nymMH4M7pChXUMBHacWaAdL2ff5rdgdusVeXwH9expf
25133	payment	369	369	1186	1	1	10	8000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAQV5wtqHq3ja4XVkFhRUVsDEgpeaD5e6FGUpVdzK3k22bEuq
25134	payment	369	369	1312	1	1	11	22300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZunzPpRZbFbR6YRQw4oytzzAtb8jk3mCkvEv9FwMA7ps3y3q9
25135	payment	1397	1397	1678	1	1	10593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKVVyqAFKDVVsu6aHoB2NH4LETTePaCydSW25ReZXgeEEDf6P
25136	payment	1397	1397	1678	1	1	10594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeH5dBCCnEw4icm2XAzfDmKdrZmqQVccryWLmPrfrPADrp939
25137	payment	2132	2132	1874	1	1	420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSLS5ZQRmuGE661fqwDhCfY7AC4WjbeG52X5LZAVnZ6dMJEVU
25138	payment	2134	2134	1874	1	1	1659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLExQuWDMTvLLT1QnKveFRpjMfTJfZVHXZHqXtXAdctNSuBn3
25139	payment	2134	2134	1874	1	1	1660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQ9Bv7fd7UdrvjbafMyRwGEuPsCUfCvtLUCnhi5swBGCKugqx
25142	payment	1397	1397	1678	1	1	10596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CGnh9khhY4oU2YroqHaN4pXE2W6Ws6JDBLpUTnjmN4XYm4Cu
25143	payment	2132	2132	1874	1	1	421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7CLCfdiuF2QgG8yWkxkHo79HUYZFBdMN9QMwbCNT6o3tqKRj
25144	payment	1397	1397	1678	1	1	10597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA7gHDnxGt4QHMrDRCnXUVoHNKBCt2oTs1zYc7Mzum1dNMugS
25145	payment	2134	2134	1874	1	1	1662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEe74C3SBzws6aeGjEeB7AuFHwytmBtdJJBYoDEACy2aKN21b
25148	payment	2134	2134	1874	1	1	1664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1doZSXYXRwb5iRp9kkB7xRH71Az5vhYpmKR7Td3SKdNeDwpo
25149	payment	2132	2132	1874	1	1	422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGTLJ5thwmN42nt446dun69aJ2jmtypW7SLiK3Kw8No29SwvY
25155	payment	1397	1397	1678	1	1	10602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6o1a4xE685dRWYGeQwdrAseQdXAWanFTiMo571funBtqspfe
25156	payment	1397	1397	1678	1	1	10603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbsjdFBoq9xNGWbD1hAJoUd1e4kzqA65GQ3RLakWuLeUKmHgo
25157	payment	2134	2134	1874	1	1	1667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnbUd7zR4rAotygYbQXsieQc5WsJgVisCPcxw38bRQRCtpmEP
25158	payment	2134	2134	1874	1	1	1668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUwPywDhpqqtbD93QfCqwqcFEbTaJtApR5VuBrQkMZX8KqJbG
25159	payment	2132	2132	1874	1	1	423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLr1bj5mZTAkiRn631R7eox2ntKeJqjDVigEtR25dNTc9pEKWg
25160	payment	1397	1397	1678	1	1	10604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C6KuVuAQAZq4tcs3cjYCvHMER3nzLyiVJa85Rs9XF7ZbynjS
25161	payment	2134	2134	1874	1	1	1669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZkaTyr6ucqbd8SAd6Z3h1piZFSCKDt8Ayev6NF8EmxJXLYM7
25162	payment	1397	1397	1678	1	1	10605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvWf7PfhrxDJJJo3r1sA6NGj4B77d6dyEXCNaaC2TBtptQVJi
25163	payment	1397	1397	1678	1	1	10606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyZEQuk8MUWuLDrHScsccK3P1Q3uLPmzNYaby74NcTumzxaYn
25164	payment	2134	2134	1874	1	1	1670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61j9x4sBr6YZSiGPCDY2mV2prCiwxRo9JsjZcntjAWqjShJfy
25165	payment	2134	2134	1874	1	1	1671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZmzWDP4pATpF8nQPifwuwYZvwpcnfix7HAE16rkDru9zDgj7
25166	payment	2132	2132	1874	1	1	424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHL2qwUAAjoDNkBwjeXtMWh3WanEkxE99sMjXrfd8Rz6gdioT
25167	payment	1397	1397	1678	1	1	10607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguidoXSTYsuo7o3YdgX91wpKE6pDAfzQFQxPGLPGQ1BUiAQ9Q
25168	payment	2134	2134	1874	1	1	1672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuiS358PBnqYaN4bJ7PMue2nArjdT7FVETkVMrihK2BDihJhH
25170	payment	1397	1397	1678	1	1	10609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkYswMvC6CryrrzB5vJNnwyeGWuCBmVsvvggEUnk8zqxPpuir
25171	payment	1397	1397	1678	1	1	10610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdfz2j6Vn33i7hbDD47Att3iNCoVL4NQarQVQhAUhu4m2JUNT
25172	payment	2132	2132	1874	1	1	425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiPh5aAymCN38twkWU5vEzby9H5ML8a8AbN3S5Zay1CWdVY3o
25173	payment	2134	2134	1874	1	1	1673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pCBi23W2Gpx47aaKh3fKuB1fgmUNhckTHYC4juQ5EXvrhRej
25174	payment	2134	2134	1874	1	1	1674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYpusmdyF6z5rH8jyQ9otTsbBBSUQ9HP5vp3KLz4MsqhKjEk8
25175	payment	1397	1397	1678	1	1	10611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnU4NciiyeNq8nnjfutEnPvxQfJgmNZArycBKvwbvV1iAWPGR6
25176	payment	2134	2134	1874	1	1	1675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49SU5GNSnSr3bab4aMMp4vXS5RK5GC3V69PQK2VXyrzRLEEHk
25177	payment	1397	1397	1678	1	1	10612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YLJ9oL64VMHkjnPR1nJW4XGDvn8rSeXoEgatnmHxjU6f6LXG
25178	payment	1397	1397	1678	1	1	10613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZux1agMksRJjoR8EzotQf3nVpPj9SdaV8XDFvnwHVhdCna1S4F
25179	payment	1397	1397	1678	1	1	10614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyfPrpS3Xk77Bwd2XreYwqMxHMUd5ehF2XLGgHt8AfmCm1Xo3
25180	payment	2132	2132	1874	1	1	426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjkfixwnvawEmmP582ECsgwPEBoZa2dxDkaGkesPDhsV8cCNH
25181	payment	2134	2134	1874	1	1	1676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9eo4soAx1r6npwNJgufWMHK1s2Vxf9xi9ExYutErZHySVWcZ
25182	payment	2157	2157	2157	1	1	12	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT241LTadgCoYasfWPe8kJugjuDa745cHZ18AEBLDiqtC3LPG
25183	payment	2157	2157	2157	1	1	13	4000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcFcxNWRabBr7Ft5uxxcUYqXA2Mmt3drQttLabGrbCj62s5Yq
25184	payment	2134	2134	1874	1	1	1677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2tr1tu2mjvRkHjZmmW5kmeEn2rvHnGKxchFwZzhw9CPHhMAT
25185	payment	2134	2134	1874	1	1	1678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UbBpSZ76ddjZ5RvqWiwUj84Scsd6a7kr5bWMZzoPVvdsnMXu
25186	payment	1397	1397	1678	1	1	10615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdraydLRcCN2hyEogdaZgS9B72k3ntezqRJBdM6bFm5RNAC5rZ
25187	payment	2134	2134	1874	1	1	1679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmbHhX1ZdWksyqyvtEiESukYKsEELQrDxZj5Rd3sRijEjRumT
25193	payment	1397	1397	1678	1	1	10617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHHfBLC9uUNoFwFeEdkF4UHLLUgFam5FTQXNLR913fvUFtgwL
25194	payment	1397	1397	1678	1	1	10618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCaQiK5p9HPMfoFNJzxh5DzHnfygxF64EudLS4Pq5TDB4rBEQ
25195	payment	1397	1397	1678	1	1	10619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAqdWHamKjUnQ3BhJSTrQvLukk9ruqa75wwT5parutsUjuqPQ
25196	payment	2134	2134	1874	1	1	1681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjn4bioaFCncepEDPUq1UsstpBjo6yCiFiY5iLqRpDyxriVTM
25197	payment	2157	2157	2157	1	1	16	44000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1W2jP4V4CzcMM87TdhEAZqLrtwemFtfMYkCc9awpLBbq7Px7
25198	payment	2134	2134	1874	1	1	1682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFueGpAWAbX6G7cD4bvF2X1H6oEvZRHs7gDhQSoCrZQyHhR1ob
25199	payment	2134	2134	1874	1	1	1683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkWrbSsDcKGaU5nbgw3G4maEyTF6nCkEdoLJUseLmqkG6y9iQ
25209	payment	1397	1397	1678	1	1	10622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VhSGJjqrTSeEbWP9f4CKwyGuKTxdnEPhWRvWH2o75XsADPrM
25210	payment	1397	1397	1678	1	1	10623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpzpSmc6Ubo1Tg5poq1WkAJehK8uqKR3N8ZJMRY2Tjdu3XDSG
25211	payment	2132	2132	1874	1	1	429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZnrsG5GkYmCzv7B1hxRkNYXcrBvKKeKRK5ZFiDyLuGdBWfDJ
25212	payment	2134	2134	1874	1	1	1686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyi99b7USbrHcaSQNMQAi144R8FyWxz9tzKfzBkYdFDtC32rmT
25213	payment	2134	2134	1874	1	1	1687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQVNMmpJJG9PfpmJTn5EhWPB7tBy6yvcDG4qVQ4uyB59y9A5V
25218	payment	1397	1397	1678	1	1	10626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4SCNK3J2zkBbrE634dv1geYSoLdsYh4P49qpPKKBCihdXq6Y
25219	payment	2132	2132	1874	1	1	430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvezWUnBuEhGt6pWetwCZYmgPzcmNrUz7pEgoFaZjrbCJrWZe
25220	payment	2134	2134	1874	1	1	1690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cLo9FsaeQtP5wgMJXKDEyTWBMQ4XDzmmC6NF3UpV8VQhzFVE
25169	payment	1397	1397	1678	1	1	10608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYgFaKMPbDeY1Q5hcnZ11sVKpixoZamQMpf3xqqzeBQZuxYR5
25188	payment	1397	1397	1678	1	1	10616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoVzcDwr4wEvAigKe314WNwf1pVPTfDLqs3To8w8vRN2MviGf
25189	payment	2134	2134	1874	1	1	1680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtwkWsUbyGE57w11MDQe8FWipB6yL3jMFLUQrWXXGUxpBVYqP
25190	payment	2132	2132	1874	1	1	427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCrNxtEoWQD1unne81KzA7CbdoBznVR7zMTHfuoDb3LRiZzBu
25191	payment	2157	2157	2157	1	1	14	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjYKxMJfrRAgpxj9zAqCuEWrWjxnARLP8xN7CC395HVdopBmW
25192	payment	2157	2157	2157	1	1	15	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3PPjskfyxVggmZn6LQ9bJfuU6GC4vVdBaz9p7H8TeC5TCjRw
25200	payment	1397	1397	1678	1	1	10620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNHoj4qxRUPHW2QtWA3mYrjuko7k9P1n89KEYUBxLW3znfMYZ
25201	payment	2132	2132	1874	1	1	428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSa3d3UvK3rC61Sg8ECuX2k5ZFmnRfLkcLthHwwfxSSpASQC1
25202	payment	2157	2157	2157	1	1	17	52000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPSnKgQWBHz32bnWgjfSjyz57burtVv6ZQVNjUecVVbyxMGEh
25203	payment	2157	2157	2157	1	1	18	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa193mBPx5PWMPuRQcwzH26UcrmbPknkyFkfoE2NzE9RexLhNzX
25204	payment	2157	2157	2157	1	1	19	21000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbj8v7JUouCZ1f35Kme8myrYDCkM9qSttmdM47RZ7gQ6EcyYyL
25205	payment	2157	2157	2157	1	1	20	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSRG1G3Eyf4S7i5E1HPaPMbMmkkWxhrtVQYdkGmCQGyicuiHb
25206	payment	2134	2134	1874	1	1	1684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZSUGPrNLWAsF1h1vceRfWc8iPiYYgBMCAbtUhM5qtwBR4PNv
25207	payment	1397	1397	1678	1	1	10621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUkznGp1nBfEruVumMgzd6hiPbaboUCX2G4AMMsS7QjrMGWmo
25208	payment	2134	2134	1874	1	1	1685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFUV8g4X7W65Z8Jb9yhuUHQ2sH1DjPVP9zPyDatrKqG7Vw2CS
25214	payment	1397	1397	1678	1	1	10624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMLV7i91v8PWa7cHhk8vzsRQjUQvo1ZeU5LD2z4AqqgWPwKEN
25215	payment	2134	2134	1874	1	1	1688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3TfpqCGeSChHMAf738KHpsGKCYzrez8ApHjcyJXwAHsKMmTE
25216	payment	1397	1397	1678	1	1	10625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEbBYJDVVucJbBLrShtotposB9sK3RsZL7yrFpuAgU3tuMUVw
25217	payment	2134	2134	1874	1	1	1689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKxdiXHpUjmcW1VM6AyUPQSqE3mdQDUZSsonqUeawKEGA269b
25221	payment	1397	1397	1678	1	1	10627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwdndeYxzb6eoWKq5r9rhtjyhpx5wTzCAWoJGy4s4WbEArxZz
25222	payment	1397	1397	1678	1	1	10628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqi4zJmnonAQ81pNYgF2MkzWQferrC9sTnwoSfBA7CrSMuTct
25223	payment	2134	2134	1874	1	1	1691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9NyEu7GvS7FDn4fwaAfHUPptTw4LhUq9uQrdTgxaU9wFrTmj
25224	payment	2134	2134	1874	1	1	1692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStNGRt4Wfra49yirN5sFoc3XU7ac1AHe2iBddn7y46PbXNPnZ
25225	payment	1397	1397	1678	1	1	10629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cofxxDNQBzXF6nqwfGZQt1XoHjmvjfQc4qcmisQedWXHtAfp
25226	payment	2134	2134	1874	1	1	1693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHntRVAdecF8FHUWGmgRFVTQcqTgmY9dkvBh1bgqzH8GZn28Z
25231	payment	1397	1397	1678	1	1	10632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqXta3rJQjhSr6wvDVJJBdSNsrcH6ptUHHHJnsnngp9RXm4UY
25232	payment	1397	1397	1678	1	1	10633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiVW5qT6tdkodjtKMNpUFthk6qgRJmWv6UA8YjU4uYvLm3UXw
25233	payment	2132	2132	1874	1	1	432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHjWb7mHq6142kbTccaKgGENraRG6FvpEggMNBJXaFDVpCiJz
25234	payment	2134	2134	1874	1	1	1695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt5G4gaeVPjK4xvkxN8pHHE5FxH1hcKLRSSv4qzNLzkkF1qir5
25235	payment	2134	2134	1874	1	1	1696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRqC46HJFz2WMx2c9w9TFH1FVNveUq1pbeieYnmwrManLxPxK
25238	payment	1397	1397	1678	1	1	10635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6M2E8rURNu8Hm2cR4f1xfVV8zpUvwhKPhr6HSdPQNuin26zLx
25239	payment	1397	1397	1678	1	1	10636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoaEaoraND4YJ7MZ3aurFvwmFgirCDkJr716TRMobKHqgSGdL
25240	payment	2132	2132	1874	1	1	433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGFeGwxsQcm21Mw88d39B2erjTWGEFVV9DN7UB5RuspKwruCd
25241	payment	2134	2134	1874	1	1	1698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbBopgWCh3mPhd7ZQP9WY94WXVTcDeARKhMX28BCYs9c7LVT
25242	payment	2134	2134	1874	1	1	1699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFwZkA8AozPxYmSrmxeoA5yxzX8UcxFGSD6wgHEyN15L7Za1F
25243	payment	1397	1397	1678	1	1	10637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexiB5Nq2abVewFB4TEjZNaPb4Hc8EgEsuamTAU5B6zW2VBXEc
25244	payment	2134	2134	1874	1	1	1700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSBFGdqNrNY4N1NY5HdMS9joPmR9ZbaNMQ64MTvwKGA5or4MC
25249	payment	1397	1397	1678	1	1	10640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfzXPbcXCtWx6MxupR2agBigYMJBS8WSmFXwVxn2yLcvheR8s
25227	payment	1397	1397	1678	1	1	10630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9DhUH3A8D6FKjdsSnkGQaNZYB8ch3Nt9JyB9hw5QkhoVuCZQ
25228	payment	2132	2132	1874	1	1	431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32JjtMp6jtTuWE1GDfmVXQ3wKLbRT9PSt7VofaLGL2cr8aKUS
25229	payment	1397	1397	1678	1	1	10631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28uhowZ3VYjQWvmGj36Aj1AWoy4QfgUw6mWAGzi5ZwUTQrjDe
25230	payment	2134	2134	1874	1	1	1694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwbfhdErNsKL3h9QHz1KKH4jhKexsQrQt8vkAv8rL5YuqM98E
25236	payment	1397	1397	1678	1	1	10634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4U8kzXXK5bstoLkshEJQizQyCohWK21z6LxfuPaNJBEs9PZG
25237	payment	2134	2134	1874	1	1	1697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsoTnGVrpe398yoKTa89SU7VG1B8nxLApkmdxyUZGPQFyPpb4
25245	payment	1397	1397	1678	1	1	10638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmL8zPkWkNdwumVXrPyxGknCAYYuqcFpnqYrHGyPytgmWH8TZ7
25246	payment	2134	2134	1874	1	1	1701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrP5jJg73Nm9cCo6ffqTtzzPDduhio72crZETdU7ACSnPryL7
25254	payment	1397	1397	1678	1	1	10642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpB82q3bk8ayT3FDtDzqcnARVVM9Jp8fdgPHR5szi44DeNj91
25255	payment	2134	2134	1874	1	1	1705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe76v4pHW5novuNn1x7qchbePzxbmWmGbD8vFJpYSxBphqwiTi
25261	payment	1397	1397	1678	1	1	10645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QpDWnmxtpVYMbs2HJf55Ktai7RobMpg8MyYbFmDUUsCMnoEW
25262	payment	1397	1397	1678	1	1	10646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRLfhRaztFUmH4Ef3N3duqZL2KR7aj6YsqhgF8es769m8oezh
25263	payment	2132	2132	1874	1	1	436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSDXZMnusRdTBZzisfv4N8ocokn4ydE1AgtyJCrUmkJ82KZbg
25264	payment	2134	2134	1874	1	1	1708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzgo6goDvYxLGNpquQb6BQv27AYuC9vswt264doe5UdfTgTFc
25265	payment	2134	2134	1874	1	1	1709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmCW7i8ucjGA5C4xUdmT6GhwHFFiopRf7QDpNPaaiuANMtqhT
25268	payment	1397	1397	1678	1	1	10648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFN99GU2HfMvvxaoXgrc5Mgbfimm6faB5XGzkZhTEfAYnP7fW
25269	payment	1397	1397	1678	1	1	10649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2mVuWpMRdHnfYTRENvbciaiZPpMprXut7PvH26pTfAf8qJ9U
25270	payment	2134	2134	1874	1	1	1711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyLxxDX7XApgS9uGGPUCfvmTD1eQPgyg18qXYbivWswXDj3K4
25271	payment	2134	2134	1874	1	1	1712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKt2PWjweWAYZVsM6PvokLssJzMvn95CU63XpNitjYnhsoYVCy
25277	payment	1397	1397	1678	1	1	10652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNgZ8QixELpVwHQBtv7eovFRnDFCiuhmEaoT837K3smkbDyyC
25278	payment	2134	2134	1874	1	1	1715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczziZEHpktphqmkwAh58gzfM6nCBfbJjUKNuWcJ54u9sUFRx1
25279	payment	1397	1397	1678	1	1	10653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZxxt8M9capEHkq2ddPTskzPaVxvStUeKS6XT3MUhNkJkCJUX
25280	payment	2134	2134	1874	1	1	1716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTt6rhCsGeSU3RYUMaAy7UMj27tC3Dvn4Ue1S2iXVuNpan8Rg
25281	payment	2132	2132	1874	1	1	438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gq7HLim9A2LXbWiVfbnQT2v9nfJFjL9TFfPXhFjqRHdWPMRk
25286	payment	1397	1397	1678	1	1	10656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYPaStVifhx5WtqsLRqcPQgFgFxZ35YmdXwbbmqjKRZ1kLgEA
25287	payment	2134	2134	1874	1	1	1719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPL4RhJbMh3hGChpJW8THsg2pMSfTTB2tHYKsZdimUrdVbGqC
25288	payment	2132	2132	1874	1	1	439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZfNktZfdaPZ5dZzbE2KgGow58wBTrJMgkEG6UXGkcfV22ocF
25304	payment	1397	1397	1678	1	1	10664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURg9WpEGg5XYep1jAzCHR56reCTRHo3xjYAnFRwchDujZeA2F
25305	payment	2134	2134	1874	1	1	1726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxgjecCanTJLSmFP1m1htc45WqYLuKx7MSAiUXgdJbs3TiB7Q
25328	payment	2133	2133	1874	1	1	1494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhgz7wZm77PJ6i5SEnnxrVC3GWSNXiQjsidzmjxb35z5i2mNX
25343	payment	1397	1397	1678	1	1	10677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvwJ8Mgcpcbfdf51p4bTGAgcYpFzBuCfPEqm8EVLAb6RbW7gL
25344	payment	2132	2132	1874	1	1	445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKimYcCw5XBAmBiewcpKAhJejLhtnfDYPMNirjBwES17DfW1k
25345	payment	2133	2133	1874	1	1	1499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdszwugKXctZLnCHbvrdZhZhp4T8ruRWrbvQqebqCyTXNDVJa
25346	payment	2134	2134	1874	1	1	1738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDVefNZ3LyTKDupbV7d7s9CPm38jPuhjupVjLAk9M6JvgTLUv
25372	payment	1397	1397	1678	1	1	10686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS6ypEU4pv1q9dQTsbUCfJQPEoDEh6LyVe896aGcKpSbXKJtr
25373	payment	2133	2133	1874	1	1	1508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ935bdbugThN49nyPta57i3Ji4w5WgLeR5khzrc7APSWjfJx2P
25374	payment	2134	2134	1874	1	1	1746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaspsYFuoJpp16JGaibBFUWifdT6itwG1uTfMzA71bKk112NSr
25375	payment	1397	1397	1678	1	1	10687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8r59iKutrdj2mWWGdeXYqis6zXfpCtTSZ6pWQV6u6baMsBFdm
25247	payment	1397	1397	1678	1	1	10639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRWPDTShSZLTprMGwXguaVxSvQtpmGjaEcz54shMvUJPTNJyT
25248	payment	2134	2134	1874	1	1	1702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2biktiukPz5aawfinVEyVcB1rUYmJAgWHxygfusEmHXTiiM6
25295	payment	1397	1397	1678	1	1	10660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8uEDbCXVtLbPiXcttVes4KjQKULVuhNMzmnUh486tmYDchPE
25296	payment	2134	2134	1874	1	1	1723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM712syMqtQwipiW9sbvoYYPecRYhzLYMgM9DD8nJs3duRrBJR
25297	payment	2132	2132	1874	1	1	440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNdLpVRj1Q53uDs144HofJqvELFBAZkYUTbKr1hNLT4JESKJs
25306	payment	1397	1397	1678	1	1	10665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvmedGZd78P7JCTEBHgso1z3WtXtHYThzutFL3ZxnBBjccEPp
25307	payment	2134	2134	1874	1	1	1727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqFUBHb9n3QXex769WAdDZbpKF4rdM7EszvJZho34H4hFoMkF
25308	delegation	1926	1926	1483	1	1	8	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLD6piM2V7mGv4pPrKoW3V2wWTyYj4oy84eR8RZhS7En9QRNC
25329	payment	1397	1397	1678	1	1	10672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17hqNTcAdLqX2HWbpa94x6W4GhrTCyWoH85UQ37T8gH9vP2hy
25330	payment	2134	2134	1874	1	1	1734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVyQmchSZkLF3JDDWEKSbTophkxg7YYzXvqgEsV9KCe9BsTmfP
25331	payment	1397	1397	1678	1	1	10673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKsS9pHsC33MJocjyCERdjr8p3bnVsxdm2FYBdVN1t9hdGKu6
25332	payment	2133	2133	1874	1	1	1495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAW7ntXCN1MGTSJUH67CusSCqysXQeJH52EjhCS3YjmcoP847
25333	payment	2132	2132	1874	1	1	444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbpZLxVX62J6YPaxudaG2fiKjHCZWPSvw1hh7S8SGYVtpUpG5
25334	payment	2134	2134	1874	1	1	1735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoezquafWqPfDPYKioRuCUxXQkUDinjDRgMGDTtbhgBdsswBsr
25340	payment	1397	1397	1678	1	1	10676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisu46aowEbUZbxQBZSuFfBwHeXfAnzesXYDrxfMusZMiGLf8S
25341	payment	2133	2133	1874	1	1	1498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbz54AbKUuCZcVmnNUHGWdcLjCeJRNKwgJtwhBXpEbtQuCabU
25342	payment	2134	2134	1874	1	1	1737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cjrNJeyVYN8wEpk5CvEG5wUMrqcPYwz2g2fdw6nCapw7snbg
25350	payment	1397	1397	1678	1	1	10679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzQfMcqp4LLZAY5a1miuxDtP3pFmyPoM7JwhvVgCRC1dJw8m2
25351	payment	1397	1397	1678	1	1	10680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXig5izfQZbe9y5tHF3XsbGvo1hrYzHaPQj27MXMyCMhJSqGg
25352	payment	2132	2132	1874	1	1	446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAk69Y2YD6knEd37zmfCpvyRXdGDxgkwdPkapAMWnokY6cJYC9
25353	payment	2134	2134	1874	1	1	1740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGZxxXWYMpVoQYMM2SKaKZqKy3n1xcgvUppeRpnHZsMAgXvdR
25354	payment	2134	2134	1874	1	1	1741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinuddLSdDXJD3p3ZKcU2z7qbnE2BPNCievcEMTvQSuWT7P8UF
25355	payment	2133	2133	1874	1	1	1501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApnyBWKTiRnyoBYf3PvMCrSurDzjENe9ucBJ5A2CSzEXqyB3W
25356	payment	2133	2133	1874	1	1	1502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhhECPv7yUnQncSYm8yAHQ1tJmkcDoMimZepeJSJjBZEN8SGK
25360	payment	1397	1397	1678	1	1	10682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehSwbny9z4Z4oQEMsYLEU9hbn3ArxyNz56chqjkT68pGM3eK7
25361	payment	1397	1397	1678	1	1	10683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUeqa2horMKTvaUKEV5nNUtvi6Df4q11u3w8ssKcdsaCKsmJW
25362	payment	2133	2133	1874	1	1	1504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiDqRSzPWGwRjqxvxeYHF9rgmqQ7dNbQYC8ibQ1XVhN67P3xG
25363	payment	2134	2134	1874	1	1	1743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKJ1y9mU6wn2mmtL1nwmSE23YvfyXkBg9cvDSfQsjPyCu4MAB
25364	payment	2132	2132	1874	1	1	447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCxkb2qoeVoChVk3mxfauMW8JrZASSDogJV49oVtjKLC7x6op
25365	payment	2133	2133	1874	1	1	1505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrxXmRx6wNdeiuk9fxmw46z1i25tdUNzrPWKywsL2YECFotx9
25389	payment	1397	1397	1678	1	1	10691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHoM7JgaZYpjxwdEHCRXXuKNq2iqe8ugLFA4ZHe8SZwjJsL7j
25390	payment	2133	2133	1874	1	1	1513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFY2JTwvf8CnD6gofZ6g8kky9MRs2tkG689F7cnY9SJ3FfFyk
25391	payment	2134	2134	1874	1	1	1751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qfgAZmhx8xEBz3SqdfE8mgfXsG7NJ1LC9YQM7wS316c8Sb5U
25394	payment	1397	1397	1678	1	1	10693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiM3B1d16zFbUAiUA6EmRT1fT9v28nqUw7whUj4dC2A5zA5YsQ
25395	payment	1397	1397	1678	1	1	10694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVM3b5bfXB76VgKrxgvcgUzsuVkqjPPSiNcpk2wuoMU88X3jo
25396	payment	2132	2132	1874	1	1	450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBPp13MaFYhsfTtjhB2nHXrvHt3YydirjyuwqiMXxyZ1WUAiX
25397	payment	2134	2134	1874	1	1	1752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gkDHLjL4qniJBUoe7Ma72oH8MBj1qYoegViezGDZQHFwuhsv
25398	payment	2134	2134	1874	1	1	1753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmP5MDJkXg8Lofbx9gpD1ffdRtrPiXKv3eQu7GWo3oRdQoVAQz
25250	payment	2134	2134	1874	1	1	1703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4gXH4H28USyPkNfzJSVdbBwtHjtJyq7JFSDA1XhX3QXA1mr6
25251	payment	2132	2132	1874	1	1	434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwAoceaEEpAiLCZihcGW7kKaW4CMomirxbgNmHGvapDpSq8aE
25252	payment	1397	1397	1678	1	1	10641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTHfAzNLpYYtVMrwtgZyAGRozQ34e8NQADA7dAb5ZEPEdifgo
25253	payment	2134	2134	1874	1	1	1704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2o8MyqDR9uUMfGLGXS7sUq8vf3yo6GK3PkZQkBRPvEp6eTSr
25256	payment	1397	1397	1678	1	1	10643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNXWoXuprKVz43QHhJAiRUjsL8pswzDzYUsmN6rtKkxuFuFN8
25257	payment	1397	1397	1678	1	1	10644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkER9qGv3UgxWnwJxNikM6A6DrjDhy6PmDydp8Z4Qvpf5qzMi
25258	payment	2134	2134	1874	1	1	1706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBDYZKwgnBaqHxSWrY8aorHR6oQBGZNpHyT3MhrJFtqwmyGXs
25259	payment	2134	2134	1874	1	1	1707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST5SsVd1zMpbziNyxVHJkhYFXdGmACCeWuguofkBGazGTF1VL
25260	payment	2132	2132	1874	1	1	435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZde6mGCUzSg4F6To3ZpaJwSTfE9yV8tEBKieF5nRsCshurYYcm
25266	payment	1397	1397	1678	1	1	10647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTN7oTiGs4nTykRaQAz1kXjw63r4wnA3vgVfwgThGw3mCZY2V
25267	payment	2134	2134	1874	1	1	1710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRsZSE8DSpxnVsNTvEVF8DuEvbZb4bGaPfLyVFe145MRCuJqM
25275	payment	1397	1397	1678	1	1	10651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5th6Km9TF5ZZQcTmSxbYUKb7RbBtkcqDytgmoQeMiykXt5wm
25276	payment	2134	2134	1874	1	1	1714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsXZwoaYpWJsSoXHd6Z3i673NtdvC5giwjDWokofuYnNz37YU
25284	payment	1397	1397	1678	1	1	10655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnz2SFVqxowCKKrvdG3BwNPdM5Kc31pdGtQnLkXXb3AmmXFag
25285	payment	2134	2134	1874	1	1	1718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fN6Pme9L5imFSpmSYEvy5y4vqaN12T2fvbMwFS2qDt29649t
25298	payment	1397	1397	1678	1	1	10661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hV43wVo56zavc4xMjHTEL7P5vncomYzas6KviiNJFBKEBzZg
25299	payment	1397	1397	1678	1	1	10662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcWQj4bDvuPhGxms75LpZUY9aBeBVxtqq3Etx4dvkSBaTJ2E5
25300	payment	2134	2134	1874	1	1	1724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuqejqCwd1KqFogxQWr2qDv9aXPWwmKKEytCKqQw6qLh3vvoR
25301	payment	1397	1397	1678	1	1	10663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizuEmWL7P3kK2mX8jHGb13RaYyiiXZzK75ZLbvRq5AZjwbiAB
25302	payment	2134	2134	1874	1	1	1725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhvDnZ58hjNqNHU9XUevpiPhvD5vPmauif1YNKZoixnuNvukZ
25303	payment	2132	2132	1874	1	1	441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVpQnhGtEVfTUi5FrNMafLzrYHpKsmWQfHfZ6sgnD8QfosrET
25309	payment	1397	1397	1678	1	1	10666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf21M6CN8ECjkDAgGz1XBqQkfuqwBqGGJMNsQKQZvAPSNd1Ew
25310	payment	2132	2132	1874	1	1	442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA5UacPm5Ny3TqSFZXefNkdsyjqY8kJziKqmKAWDNm2emZGpC
25311	payment	2134	2134	1874	1	1	1728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6nkVjM6zxjTdMNHVkB1bB8eLADLxfJkVGsE6aq4hU2eq3V25
25325	payment	1397	1397	1678	1	1	10671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2dWiCXY2qhzrAx55BfFgACbcRhPXnyFwSmvBTwdYn99m56BR
25326	payment	2134	2134	1874	1	1	1733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhddRReTVR9fypxQcSAav9GPsu3YjXX4Y9zY9M7pAKfZsHbgXi
25327	payment	2133	2133	1874	1	1	1493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWSsaA8yVZVD2MRrdi5g1mrfExTuLtacdduDsSqZraDep8iVi
25347	payment	1397	1397	1678	1	1	10678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeMBpeA6e27GUP8vuaycs378MmuYTmNFdMwUtEXkM2UdnLRAc
25348	payment	2133	2133	1874	1	1	1500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyf6jtochefWBhG7GKsrvjzZxmtjVWLyp5THZLstSJZgmM7wom
25349	payment	2134	2134	1874	1	1	1739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9eKQ879rwUaocCqjMfFBXoMWi2N86tXfm8NdZcmwZWmjRr3uK
25366	payment	1397	1397	1678	1	1	10684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcBNfpkMSKL3riUW4cthjXiEVApX1Dr7jW4aLxHwkrvdF8aNm
25367	payment	2133	2133	1874	1	1	1506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYf3DpA3cun57QBjqSsQmbodQKgYAAennqqwdWknLX5rm88iq
25368	payment	2134	2134	1874	1	1	1744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4xc6YG495BSy3cUiLMD4jhS1w165gyHCEPYmT9TiVQPoZveX
25369	payment	1397	1397	1678	1	1	10685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG2H61XaXLJJJqkPyZQHHN3BU8qwSW4j5kD9zfpBqGEvik1zQ
25370	payment	2134	2134	1874	1	1	1745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbddvqa1qbGga7u766GuMeq4HqcRCpFcDE2WfWJbimCDg7Xv1X
25371	payment	2133	2133	1874	1	1	1507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7Nhbjx9EvZPqZS32ZZnszR7bg17uEq8tNjZrtYN7y2r4gaQe
25392	payment	1397	1397	1678	1	1	10692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwsGAPzXWuWzhn8QyYhPS1KB7F78cjKEq94pmknibwotQZf6z
25393	payment	2133	2133	1874	1	1	1514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRv1aW3kvjSqXUm3b77kKR2viP3U5rc6JVvbcuvN7AAZEBU9v2
25272	payment	1397	1397	1678	1	1	10650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QigEU4NSuiZSMhyDDcwYp2qRtRjbMG8WJSWf65TeJAow2L9E
25273	payment	2134	2134	1874	1	1	1713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6wDdZACVHNeydaeUDjegm7rxmATqjKBaNiVECCJKivxnk8EV
25274	payment	2132	2132	1874	1	1	437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68uigMLQRkip9V6dc13FmrxCGJQqSakp6uv7W2UiFuDJAKiBy
25282	payment	1397	1397	1678	1	1	10654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7Zc4UYzwgza3o2jUtN2E1hUTJrUecXtqvVAN6BmWFyXvCj5z
25283	payment	2134	2134	1874	1	1	1717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwGhJZbUtY5SD5R9MjALLEZUfF4abdK1e8LVoPxqptSNtA4CS
25289	payment	1397	1397	1678	1	1	10657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrQFg3JkwF3MtkFP1G6GuJ1VywVqrteVqSAnfh36AmM1u4EMs
25290	payment	1397	1397	1678	1	1	10658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjes6RGE1maY17tShqmKdxMQGmA6a1ygCp8RMpyxXxFRxCqE3J
25291	payment	2134	2134	1874	1	1	1720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wm2ovZhQ8BSiWjJXfi5TE71T5hAN3S1H1m2qLBrdcGmeqYw6
25292	payment	2134	2134	1874	1	1	1721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpUef5GSvqK7q7vCt6NaCRvvWz7G6nmJvehjVJ8xkmzSru2K7
25293	payment	1397	1397	1678	1	1	10659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGDYRXtNUbxeHLmh4FL72a1vKbxxVtv2FtEp9eub4ho2ANZH4
25294	payment	2134	2134	1874	1	1	1722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyKC5rPVbHesPreViM8YzAvsPVRqAAZg75UCPAFMQZknzPokG
25312	payment	1397	1397	1678	1	1	10667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqRXn4r5NSMURTdWhGpa75s2b9YAiCiKsSMs3i3Q5CxWMJDRZ
25313	payment	2133	2133	1874	1	1	1489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRsxdwMp5X9LShnXxqYnYi62aXGoLv1kinbnHwQEfc9tUo9fT
25314	payment	2134	2134	1874	1	1	1729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHuxmJYcyMM3UerjNRyWybnh782utWcuNDtK8rcE8M4iewJbM
25315	payment	1397	1397	1678	1	1	10668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Nvec65nZSLkrxXAMgaYhmz8egeKSXexMGmY8RourueZsKJ1N
25316	payment	1397	1397	1678	1	1	10669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCVF7HET7TQhKm7FtV8imz9qFf4hWferz6A1Xyt7Sfe4F2bGV
25317	payment	1397	1397	1678	1	1	10670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMbQhUumhpFyhNR4eBs6ca959YRKeTQWjfJPq9dXvhzX8fmuV
25318	payment	2132	2132	1874	1	1	443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUrDrESgfwFg52htcGebepy7RjVN6ri1QzBEbiRuUgpKw2TQU
25319	payment	2134	2134	1874	1	1	1730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQscJSXSPE18igHsMGz6nPyUSbZe9BZTqKUaSrjVVjoZaNDhU
25320	payment	2133	2133	1874	1	1	1490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tVMdFi2rkjCScEZVth8mNpGZb5s57gCe4vjfhDKCAANvEPsm
25321	payment	2133	2133	1874	1	1	1491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVbze25qBGH3GS9DMUgtK5NaE55MxLHyoLfeMwoDhfAXkXZkb
25322	payment	2134	2134	1874	1	1	1731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYr5AUxUuoDM2hRSsfo7ki242G7VRtRB4ioQXtRVb6XDhu2WBs
25323	payment	2133	2133	1874	1	1	1492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrMMbAHVBwgjLHEXvnM8Nd6HCB8JM5ikFAyNx9TW2nGNakvBw
25324	payment	2134	2134	1874	1	1	1732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdpwPFpy8erhpNPsShkRPS1MSuw5nFVJnrURFYagREGB1ZjPH
25335	payment	1397	1397	1678	1	1	10674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDGbUgh72DWg6ePxG2JNLU8jQLLSHzJmPJT8JJKJomzsNKRrg
25336	payment	2133	2133	1874	1	1	1496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgeGWCyPNjL9mv1fNCeRLHVXZoEeKwSv26dTXi9tyn1nVkz7J
25337	payment	2134	2134	1874	1	1	1736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYpDQGXzEfrYfLwfbo2SsPzavfgdEDzvVZuy7ovjU19LMB9va
25338	payment	1397	1397	1678	1	1	10675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Hoxx4hjBtmoMyoeyrqBV5uFemDzSR97eQn8Zskkgq7CeNDT6
25339	payment	2133	2133	1874	1	1	1497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwA27ULkGfeXQdN8wzHT235Xpjc4frwpFiUM57AY21Dhug8FL
25357	payment	1397	1397	1678	1	1	10681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLbsQqVgnkLw8MwJvsU67KVWumnZPHNqrTtGYGWsFFYeThSru
25358	payment	2134	2134	1874	1	1	1742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGk4y7cESUuP6z3UrBU8AANkVdNBmBmfA1J1ZN3FqwfZ8KdLP
25359	payment	2133	2133	1874	1	1	1503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZ148eCsY4sq2KBBW9Xyx2apAXTZRzGy7UfCE2ZFohiFz67Q7
25379	payment	1397	1397	1678	1	1	10688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpbP4sgDAQCYevB25DMjV3XnEmXsMALz3ZGiFa8LzmPeJ28WU
25380	payment	2133	2133	1874	1	1	1510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9gfpBE8HtFehNitesrJwps3xF6upFjuxcB261BsLSgHPcHyW
25381	payment	2134	2134	1874	1	1	1748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPs9DJGE6DfMg9vrhNdtLbHC4x5YoAvASFdyeZwijR7vKbutcN
25382	payment	1397	1397	1678	1	1	10689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkamPJDsSbLuvSU6jHiDbUVdafEgjWuLyj6SsHMmBMgzZfFjwu
25383	payment	2133	2133	1874	1	1	1511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeShHp3NDBS8AEGvEjiQBXHNRWUie4vBZ5AfXA1MYDnfAHauMB
25384	payment	2134	2134	1874	1	1	1749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZB9Gw3rtfZS3b2LEbiVs2UBU6TgcWXJ5R3vvPUVuHjJdSCrrX
25376	payment	2132	2132	1874	1	1	448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngaZZA7a7YNgujsiSivvhjhgyYMy9XuVx1k2cDyEiM1N1oa8X
25377	payment	2134	2134	1874	1	1	1747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LGLde7uxy96rR6MCVgBexxfDm6Riufs5CgbhsY9oun8JurVo
25378	payment	2133	2133	1874	1	1	1509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLabojkPJ7vdUyDyww7Mf37KevtuYwYzYuxQFrnSRAe13b7Hah
25385	payment	1397	1397	1678	1	1	10690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpjHPB7MBLLLL2EHbsVjWYNtKTXY4qvLtG6HyHb7W7vmfWFaT
25386	payment	2134	2134	1874	1	1	1750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwJokpUBKbd6rbSGLwme3L4JQYiwCfBTfFAFnhd6xHDrSfqLv
25387	payment	2132	2132	1874	1	1	449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRLW5ViPksDFvXHZjXzTCdHGXAHU3uSSo74hPoGNdtxa18JDZ
25441	payment	1397	1397	1678	1	1	10706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK87z74CvktgD5MDBdAGRs6oyG1LT2x1H18LsHqMQJbL76LBCa
25442	payment	2132	2132	1874	1	1	454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mPUpBT1zNqVo7DVWs4QoNH856ox3Wt9nKjD5H5PAqqyM3gg
25443	payment	2133	2133	1874	1	1	1529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pyLnAqL32xpzLVbdqkecVnnZkjaxd2c2oaAVacGqfhN3FKx
25444	payment	2134	2134	1874	1	1	1766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwsZcKrCVzkYBjRmaw31ckEgw9wAcSEmu12CtThDPqGvbi5Ai
25490	payment	1397	1397	1678	1	1	10720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Y1GKzpkxyvw7KAKEUtmb9cc9cu1bCRz1kVEBBa6mDohHTfQW
25491	payment	2133	2133	1874	1	1	1543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJAJAJPjbAhn4fuZkp1kDVhNRxj1cevh9fxJvTafMoSRx1CiJ
25492	payment	2134	2134	1874	1	1	1779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5gtKNn5z84eTCsN5troWyyqyKm7VaXsSceshJvcUwisPRaoJ
25501	payment	1397	1397	1678	1	1	10723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdAAXFU5z12juYHyFMCQ2hLyTSbQ8DaBtTyny2gm9Wy1keu9x
25502	payment	1397	1397	1678	1	1	10724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfdbedY1w7JbEhEqBS2Arj1fDKhFadr1hs5w7c7rq6PWH7fCD
25503	delegation	2185	2185	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6W2chxiBPbPbkfKBuv4VNpEx8vVXnkupdoQUNrbV4GDc9swmF
25504	payment	2134	2134	1874	1	1	1781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhS3AwFTBGngPcZbA1aJBZxAjNFCT9qe5gZXa1ZqiydJEgWCLh
25505	payment	2134	2134	1874	1	1	1782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvv3csAnsNdebo83SqScCGb97tXhJzN9RjCroyyYJWGq4GhCZe
25506	payment	2133	2133	1874	1	1	1546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67wk2tUop5UYEK3UZtgwvjLbKj9AqFxpf3JF1UzR9uri53EqK
25507	payment	2133	2133	1874	1	1	1547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS2v4wATLVicRLRKweiA2fSpffBsGRrfEg1CyemU7E9M3F6uSC
25518	payment	1715	1715	1715	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT2SsNqbZAz8FiBXsTjYkA8ia1uEjRF4SpA1b1P811AYa3eAs
25519	payment	1397	1397	1678	1	1	10728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFnjrrvcQUV8n2kp67j54EM6dMYmoPVnoP3pbf4iiki1zwHx8
25520	payment	2134	2134	1874	1	1	1786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRruJC47bEN7hUdV9hTims3nN4fmup1uSP73RpqjssHZRYG42w
25521	payment	2133	2133	1874	1	1	1551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteXHspfytTTs2Z7zy1R34hxNJf7hV86LcurdaXdHWFt6XH8gJ
25529	payment	1397	1397	1678	1	1	10731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeV6JrvNqKW38itJLUT5C6pP9Axdi4sBhHgb95i8qH8v6nrgz
25530	payment	2133	2133	1874	1	1	1554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XJgejSjk8s2g5ga9JfQDsqqeZv3JcMvXNfCLrvLyxGtDJxqh
25531	payment	2134	2134	1874	1	1	1789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QVqkwWdLMqFkQBBjrB5W5GdSY9mE2557ZQS1PTcF2Ha2zsN7
25538	payment	1715	1715	2186	1	1	1	1100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZ28SHp516TJDo73Uv6gUdvT3We58sbAbcW4whQns2aPLwtCe
25539	payment	1397	1397	1678	1	1	10734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPxCS2RL6pnFkh3ZjbfQrw4ca4GBm2qZmTAYMGshLsRyJrbRH
25540	payment	1397	1397	1678	1	1	10735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1obnKFg5Jyv2j8xc4DSwvGVQLaH1iVmaf8G8XCMvzChS9gtj2
25541	payment	2133	2133	1874	1	1	1557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSabAhWVd6cx6PbY5YDzbkYfP6s86UrDvZVEavSoJqsgLQ3i2
25542	payment	2134	2134	1874	1	1	1791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVypJx9f8BuxCAnd4mriKmwopwbsb3wVWznCLBLgJmgzNbCcw
25543	payment	2134	2134	1874	1	1	1792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwUrZeXVJ2ob9x23FV4kcTitU4TwmwHkAjaBJ26LjN3mNxARv
25544	payment	2133	2133	1874	1	1	1558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnriCUDYkuYmoDqe2Gzs1k1wcFvMMJdekDmsSg77YPkn9wSuH
25572	payment	1397	1397	1678	1	1	10744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcdHJXQFAJYrCV9vhR7VYodzkW6PS3rLYiTNSGN5maKBZXVLw
25573	payment	2134	2134	1874	1	1	1801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxmnRZY62nwjezagP88ZyXqp9UZwaCFH6BMyXZV8eU7DcLqJZ
25574	payment	2133	2133	1874	1	1	1567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ngi21BefSaBKhpvKMtSLvDSvAgdw1sjeWX4ph9CA4pfXG7of
25582	payment	1397	1397	1678	1	1	10747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWXdHZkbfpMG4U6bdVU586C2zmYyyM6ZTnHF6oUoYRFQpTqAb
25388	payment	2133	2133	1874	1	1	1512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7fUWkxk8UZpPxXX3Hni5bq2414T5ukCkpjcvbjS47NwQSXhw
25401	payment	1397	1397	1678	1	1	10695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa813QaKhYhYDAcfiZfreE4bXdkHU2tFnbpjx5JGy5w8bNCh4jN
25402	payment	1397	1397	1678	1	1	10696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JSboDBjZsRjmvC2PMdTpuAV4zcRMMfxMkvvikKR9a39pS2hw
25403	payment	1397	1397	1678	1	1	10697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsonCnbEvemXp9JwPSQRXbziVjWmYYSq5SMrv754PjHX7LNwD9
25404	payment	1726	1726	2172	1	1	8199	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaB3jLWXjWhuBYngdsJHp5VKkCrQaqPE9KVHzbCGbae5Phxc2xy
25405	payment	2133	2133	1874	1	1	1517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwaGwpzbLSumRU14riSyPHKBKYmxhvruetxMqNoenXRK9rNgC
25406	payment	2134	2134	1874	1	1	1754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgupyiTvy9bo4Ht2uoqtT8RgomjEyyFij5TTvz29imbbPKBS9
25407	payment	2134	2134	1874	1	1	1755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFCPXvq81ZVW1DpXW4MVfBU42UHG3Ryebrk6oSXfscX7jC8X3
25408	payment	2134	2134	1874	1	1	1756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9s1YnLRnCF3eumk3mhAR4pY6RoahdKvkGECXcCcnLejZHUyC
25409	payment	2133	2133	1874	1	1	1518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQc13XvWRUDaKshx6pDNH16GRXCnn8yQ8i91xymhjHGiqzonLp
25410	payment	2133	2133	1874	1	1	1519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGwQAz3VBDhnYVFsBhwUBbFdyWtKzLu5Rmx38a3ZYxzTXBWym
25411	payment	2132	2132	1874	1	1	451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zJR75DmKprazJpzN5vtisb4xAvMrvGuUtapNyCvr3h7ZvS15
25415	payment	1397	1397	1678	1	1	10699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFE1xDdjqDDBEXeEd1491f4tFt2QpSnAP9A9yUL1Durv4iSznh
25416	payment	1397	1397	1678	1	1	10700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRBx5ZN648JhcCAKAshFSZM3n71mhpSznA7EiDQ561PB4FGqr
25417	payment	2133	2133	1874	1	1	1521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LRCaQXqdEjfz9DyMQpz4ua5DtL4P6hmoTgcsc6h4r2G2ntt7
25418	payment	2132	2132	1874	1	1	452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jAZ3aiqJr3PVEhB7iC56LmZ2kswMiUwnQrbx3LwRtM3wvq2c
25419	payment	2134	2134	1874	1	1	1758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8EJjVFe5hLVo5fTzLAjrbkCXRUbw5iHtbbjnYWiRjicUZYyo
25420	payment	2134	2134	1874	1	1	1759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbaDnc3YRvnCjwW42QPFAswAxRGZfMbbEXUQo67miva2x5Wx4
25421	payment	2133	2133	1874	1	1	1522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvR9ju1hLYDKDhLcL3MCEEYEe2gbt9bvbTszqDv2BzbFRz7Nh
25422	payment	2172	2172	2131	1	1	0	1000	1000000	\N	E4YcySJT1WGmuhcG6AEJxqNugEZpwzw37YqJxFbfoULmQKUCtFYPW	CkpZdVyPkRJHVNaQYbkctxA284wzMBf4EDrw7HNCg3c1oHMqbaQRE
25423	payment	1397	1397	1678	1	1	10701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctTZFC9G4mTx42YGHrVtRxyTFzctH6uggbp1EcxpyB29srvBB
25424	payment	1397	1397	1678	1	1	10702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDdBU9KGzfFZwspS1wC8fqnraye5tFHF51CCSNMCjAqnGuQUx
25425	payment	1397	1397	1678	1	1	10703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiqsiVdjxw7B9XCVGbqA9jvcnvwWEgQWqHiBCKZ6LVhEsk8Nw
25426	payment	1397	1397	1678	1	1	10704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp977wqxnnTxqC9LDZbr1MrdtWvjkN8n9zmJxKiL1YAarDPbkf
25427	payment	2132	2132	1874	1	1	453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UsHzGhoSnwbs8ryjJjygr5MkFto7DQxZyv3XzmyGKb26kVcv
25428	payment	2134	2134	1874	1	1	1760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WbDxwJKv4S7vvNMtRgVVBwFrGKRTp92JA2QBNNE9w2Nmw1m3
25429	payment	2134	2134	1874	1	1	1761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXVdBRSqBr5vefwapRJASgu3o6U7emXjVNShBnNr2zprov1gn
25430	payment	2134	2134	1874	1	1	1762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe6Gdr9VAKqLCWfZtra2V7oZGnUJbPWbDVDht3b8eb9bwZGq4
25431	payment	2134	2134	1874	1	1	1763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNK8CdUCvLfdQAA89S8WZGr88hnibUk3Hv54uDXGZccYRgzSo
25432	payment	2134	2134	1874	1	1	1764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56zCKsMPcdZgUbPqCSBEttjictWUMdFhqXfVJJryvSV9ZBFao
25445	payment	1397	1397	1678	1	1	10707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKPbjJUkeCoCa9hY5UsLaf5Njjvrd7vZMcWq6AxJFYiSJ65Z2
25446	payment	2133	2133	1874	1	1	1530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZKc71HjxZPN9ZFMHfDijcd12pkoimKwXXEWRSaD57e3o1igK
25462	payment	1397	1397	1678	1	1	10712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfQBDz52RwNwMeAjpPKYFX5gSRkYc9NxGhQwmkwQNZGdujn32
25463	payment	2133	2133	1874	1	1	1535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnmmDh8VxvGk6yjTwLafJ9Donhkms4GQArWgTN9a32gqRvUdK
25464	payment	2132	2132	1874	1	1	456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4xRp8QddYXm3jzYFR24T1XAtvnjA3Q8HLaMXagZjjaWxjbZa
25465	payment	2134	2134	1874	1	1	1771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrpbhsKKqWgBAEvpqSHxSrXydEmBn9AftQG8dfXPbMsKMJLjg
25493	payment	2035	2035	2035	1	1	0	100000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77oCzL8ZvKb6Dag6MNMoKzwD5mZi1FymP1Tq4Waqtg2PEPYWc
25494	payment	1397	1397	1678	1	1	10721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGTV3PFE9QJLN9o3ZAMVG12GPcBZFSwNnPxSbPB5Y6GCYyrhM
25399	payment	2133	2133	1874	1	1	1515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpnRhbQg3at6mvqerF6xtbUTH1Bu2js2P3vyWTTvPmfFRUYu8
25400	payment	2133	2133	1874	1	1	1516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBmdMKMNQ33NVBFttW72vZ3tJAdHefvYYq9dfPeAmdWgh2XMF
25412	payment	1397	1397	1678	1	1	10698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRudh5zCKR3J3wJrNkHo5yCbfsposCWBtWLxukuNeXYM9Dbdgj
25413	payment	2134	2134	1874	1	1	1757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHdp1zae1EtgWAsV2gQbUeCZoQiAzVAwJdnT1jeF8x57pEsRk
25433	payment	1397	1397	1678	1	1	10705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JTXJyrcb9Nwy5qzme39cdR9m9UDXxETD267tMW1VGW9UV8Yh
25434	payment	2133	2133	1874	1	1	1523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3thJEBnrvA7c1ucBwKFMnaKcGP2jhvDbcQswYU2911ZzUrVde
25435	payment	2134	2134	1874	1	1	1765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdfu35yM3hn7tvQXG86s9L2xPyEV2PipmEMLRerTDNkvWfgTP
25436	payment	2133	2133	1874	1	1	1524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXigFfLnGprCKhWzdommiiAd1PKLkrbs17Erj2zsdHJNGKzPCT
25437	payment	2133	2133	1874	1	1	1525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirXXj8zEJYtT6qjfkDoz2TM4TnQ5dMXaqeNbT7ASiAk2A27Na
25438	payment	2133	2133	1874	1	1	1526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxAV7Qj9UdmHWCZvQYFevczJb9uneRHfDC5iiYGncMYe7unNC
25439	payment	2133	2133	1874	1	1	1527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gLKj8A7xPJ42hxjCYuSXjdAujWJZPHhENeCk1LCMnRy2nzWp
25440	payment	2133	2133	1874	1	1	1528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqUcjpmrfL5fDiZtkSxoMPPfkT3nGTfFC6EHZVvxig9TnCuK4
25450	payment	1397	1397	1678	1	1	10709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oHEu1s5RNKfcQphqMcMSK2kkJafjE9BHBE7Xy467v1wvrTFi
25451	payment	2133	2133	1874	1	1	1532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXuxaYJuY63q6C6ALPyfivvRC2Vctg5edFBZSV98ZQR6i6b2CY
25452	payment	2132	2132	1874	1	1	455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonExnTgMk4XVzGrZcyuaCywpdnrXihimnXNJ8dQa1Pcq3W2Hs
25453	payment	2134	2134	1874	1	1	1768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rrTUPSEAcC39S8aQuwx353JXh1UVgevA8XVXqNkGmem6XGHM
25454	payment	1397	1397	1678	1	1	10710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBsgdiucnSGdFDGWFJj51dp3HJirWkiNXpUfQBybCAmV99JRn
25455	payment	1726	1726	2184	1	1	8200	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiEkEWwpUkm2MQZNSgjoaMAkaoFbRJMRCNFoWhxgSTgMPx7Zbw
25456	payment	2134	2134	1874	1	1	1769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ875JESrGDdHTC8Pruok9P4GwF8ejUgBci3S17UGKAWmHBPiZE
25457	payment	2133	2133	1874	1	1	1533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJ4yNp8ZjLwuVBTLJnWVUMk8YEB5DTsd52DRkhTRXY5s9wgaJ
25466	payment	1397	1397	1678	1	1	10713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfAcH9UR9wyCzRn7KAhRgCrxdXcPgmnhs8TAdgmkEReQXPwtt
25467	payment	1397	1397	1678	1	1	10714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCaZ6UwTEjme2qMy4ukscJ9GGQaHGXtfSFjw3wXThxwGrJSZC
25468	delegation	2184	2184	1402	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6JpRGkWZ3DrDtur54tJ1ZNXSJpiQtZ1N3F4ki1WZHi2CEEJG
25469	payment	2133	2133	1874	1	1	1536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCgMzLBWRr9e7u6LbpvAT17dKowFhss8ZaNY1FX3Yi868rWi6
25470	payment	2133	2133	1874	1	1	1537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG6Hajr1Y8WvJh8yAMwqazngPSUoDGp5XoqyGLKk3orf546Q8
25471	payment	2134	2134	1874	1	1	1772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkng9frj4bjuATQBenKfJfSnsnoQ5d8YD6STRoNLDkBP4uAnR
25472	payment	2134	2134	1874	1	1	1773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFWFPgpiPeoz3VQpwpWss2M1dYWYPqLMBsvE3R2iUYShDCiWu
25473	payment	1397	1397	1678	1	1	10715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CaRNkBLZxera3s88SYtBUVvNiWig5MS6sm4FzRpiXJ6rVkj2
25474	payment	2134	2134	1874	1	1	1774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8BfKz2KxKRujbu4Wavaz896LKkGgiHcEjtojqJw8jqAYLVS3
25475	payment	2133	2133	1874	1	1	1538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHsJvJyL4g2xnXStkKDmCpKc53u2rhU2baKiPskY15mNFkFBG
25476	payment	1397	1397	1678	1	1	10716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TFSowFNHEf4neeyKNvumzbBZqi7DR6mSdsYEsRH3SX5BWiCg
25477	payment	2133	2133	1874	1	1	1539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTh8EQLNeJUiTwZsxkJ7MEaVt1Vg3KdZuKn5swMcFe4kvRsXU3
25478	payment	2134	2134	1874	1	1	1775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedNmW6E5RQs62RH5GeTgR32iNWHVsWzh1sfmKCRGnYiLd68WM
25479	payment	2132	2132	1874	1	1	457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoH2aVftBSfoYwp1tJh7rGejd8Ks8i9WK4YrVC79s6yEEcYmGW
25483	payment	1397	1397	1678	1	1	10718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguY6ek6rrcUwrjq14kko2DyCvPmRyxVApKLQENA4C95vdVYxp
25484	payment	1397	1397	1678	1	1	10719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyhV44MaCoL79hmDDhe6V1XaXK2bRYXQs5EbgzNZLLNE5ZG5j
25485	payment	2132	2132	1874	1	1	458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKMi3cMsnc7vzKXta4FmsQgSHr8EJHqM99hBPLUDSLaUbSwr7
25486	payment	2133	2133	1874	1	1	1541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQn2FC3rAF7M7wbH6ZYsuSQBHSDz38JDYofR4v3uUCyVETo44
25414	payment	2133	2133	1874	1	1	1520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsy46obmg89aaszyAjzPaJF1r4odrQDSTpd7oZoexKpZCwQoE
25447	payment	1397	1397	1678	1	1	10708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnoSGj4JjFzRd2G5LGKG5gXVCgmkTuAPWCtZYq5CApG9Jk4nx
25448	payment	2134	2134	1874	1	1	1767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cdH7BFs1cJrYNmWG3gf1zosJbdDK73pLWjionsYqthtiYZSy
25449	payment	2133	2133	1874	1	1	1531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nBme44gANq5KYner1Nd5vSin935ou29cp24tU8WkfuSmMRiD
25458	payment	1397	1397	1678	1	1	10711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJdN2kDwDGbR2zNNqYCVWRVHRM1CX2cEsLc9moPEVZFnBknJH
25459	payment	2131	2131	2172	1	1	5	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpYcCdTfVhwQdYHAAfHur8ejwt422UNxdGQP68cvKPgy8ZdApnXj
25460	payment	2134	2134	1874	1	1	1770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYb9bgytLr3xvpAio2UgbFyntVnsCsNxz1FAHgu5soijZAf2x
25461	payment	2133	2133	1874	1	1	1534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9UqZXJRz5JFtpdep5kGZuEh2YPoyVPW89biis8JgiBK8Nuk6
25480	payment	1397	1397	1678	1	1	10717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYwP3tJMEPfTBe2UTeqHY4fYnHTznQ6M3EPXRdMPdkLH9L6e9
25481	payment	2134	2134	1874	1	1	1776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfTKFgnj83Uy342seNJGPeU1M7yssHJ3dmP8Q4PsAqKoPdszR
25482	payment	2133	2133	1874	1	1	1540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLYTgugh3BLDLKsCfRkRFnmUqfLPNuY1ARadykMB9nidvzWSP
25498	payment	1397	1397	1678	1	1	10722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9FPx3Ed1NnnCYKXKBH7D3HKyo4av2AwQAvwehLgAW7c4Vuv7
25499	payment	2134	2134	1874	1	1	1780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkQjUvExfcpp5voKFPnTPCVbrKVqUqKVFKZwRnBkfEQTR7WNU
25500	payment	2132	2132	1874	1	1	459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPTjEdNm8QofqJC2c8noie7TEggRkeXzNFLYUG2Gk7HdLn9Md
25509	payment	1397	1397	1678	1	1	10725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyn4VgcV76y2DMHw9HD4DYk9kadia2J5bdUqaHbxint3MhExU8
25510	payment	2134	2134	1874	1	1	1783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4gDKudxBgdSRAzcu6PMDQSzLj6W53XJGkwiDCtRbrMoBQhsv
25526	payment	1397	1397	1678	1	1	10730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLEz4CyNjjgvwntgviMMWyVrVx1Lhbf2j73CVsbZSo6He3etB
25527	payment	2133	2133	1874	1	1	1553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMUYWNbxQ1yNDwLfpRbSPztxQRNcVPWMB7pTEPBnWTsiQzy9W
25528	payment	2134	2134	1874	1	1	1788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgU94Fpbp2t8fAiw9acJEj8EbHC8aJeMS3kfoRvAZGdMBvtrN
25535	payment	1397	1397	1678	1	1	10733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8V3TNkhQg3WJ5pbRfrd3rvJLLH4Jp9DkRDEicEoANiWNn3Wui
25536	payment	2132	2132	1874	1	1	462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbk8SeFFRTHQDJqB9DQaL3YS8fxaToaYwJ96T7rTNYsM74STg
25537	payment	2133	2133	1874	1	1	1556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorNQb5DDTsSP8EBdwctdhAfpAn8KYL2QaLBkyFmBxZtnE25DM
25552	payment	1397	1397	1678	1	1	10738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKw8Xmj3ezLDzq46afztr8KinWXhKN6qjq3Jc3UtPvqNMvuva
25553	payment	2133	2133	1874	1	1	1561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaKK38oGYwt5MKvXdsrR2GSDK7WpSyGbq9We8rQ4LtqsaoANp
25554	payment	2134	2134	1874	1	1	1795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYJT4y3oGoQbavUY8EsuxNZyLKYTZwyPdEonR3XNPxQEmboHi
25562	payment	1397	1397	1678	1	1	10741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TLoi9z7HznKe2AwRHwAcn8HqgqL25PafQ39pqRzDLJTadbJH
25563	payment	2133	2133	1874	1	1	1564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVA1NfB174f4JcfX1xm6A5yeew5yNH8jfGJWiTAEjoBygayFS6
25564	payment	2134	2134	1874	1	1	1798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzCNvZjV2ojomm7Vfa2rikEmQUyQB1qH5x9cmCVWgaectfKak
25578	payment	1715	1715	2186	1	1	2	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3nCLe2BHYTK9UYmxx7ccvuKWRie4Awp5815Z5bwsceppDBPV
25579	payment	1397	1397	1678	1	1	10746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyQLUKQbFsBysHosMdpRifpyQyUnNWrLJVgpEahh1YAt37uTS
25580	payment	2134	2134	1874	1	1	1803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyqfBVSyhbQGoCK7J2qTaZJ7ZjnVbyDq9CkRLr22jsZ2Cgtb5
25581	payment	2132	2132	1874	1	1	466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhM12J4AXMDHx1i6SEXFvs39cuZBtLHg7Hyde8pyEB9C8pUBS
25650	payment	1397	1397	1678	1	1	10769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGo4FHGoFQjnspKWxPC2edMoPcxR64vr7SzJxBapEUB1iqa8oJ
25651	payment	1397	1397	1678	1	1	10770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxAz98W8CNHwwtJQ8HdN4XFcZDic4bewvi9CDGuiNvBv3W3kX
25652	payment	2132	2132	1874	1	1	473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwJx8taSibN4XaBRNHyRMfrgb1jrvGyYjrgT1oWaNm7GBkcCm
25653	payment	2134	2134	1874	1	1	1823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4JTym35vmWNxgvabqcfYJq79FUmzHW55wVnWPgwMiwf8gExU
25654	payment	2134	2134	1874	1	1	1824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLCTCQuhyvXRcsaYBKnt7QEjeu4KesqCG7DUTjskcX7UjZft7
25668	payment	1397	1397	1678	1	1	10776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAobFY1BqrJQLYpNEFifDCxtp6nCi9Cf18SWE7SghejL2oo9j
25487	payment	2134	2134	1874	1	1	1777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHBc3hG4pec6yRo272dLGYPeBue767fnnegz6VHnULMQcqaNo
25488	payment	2134	2134	1874	1	1	1778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeVDnLTJtGsZebUYsNtP4Lun4PZcLAZ51tkWeUhjfD1dNst8V
25489	payment	2133	2133	1874	1	1	1542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UiPEWonbAPK5w4N5w4CyJDjM6fxKkEfQQNo4rR2qzFpiCVgx
25511	payment	1397	1397	1678	1	1	10726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAuczY6XVEbvUWjXeHSWiFwYkWA2vY9WnX5wC87yTMqSnwH6E
25512	payment	1397	1397	1678	1	1	10727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfypbeSue2r3yfPqDfVZn8qomTmiomVBp2vZepTNMKC8e9LxE
25513	payment	2134	2134	1874	1	1	1784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPYPBNcquavn1ZF7bsgsMYXkRX4gU55yCyQS8wY5wA3uzUBYk
25514	payment	2132	2132	1874	1	1	460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPeYjytwps5J1X4nqo4TCXw49gZQwGMsUfwJsHrTHnW5Ur79E2
25515	payment	2133	2133	1874	1	1	1549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTKrUnayk6VFyg7wzxXcAfMdqrsdKRo3TZ2UqUu36CJfvKpup
25516	payment	2133	2133	1874	1	1	1550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmexipiq1hYV7XTeF4Mp8TiJethwR4MUuMLLunEq6Yw1CVmguv
25517	payment	2134	2134	1874	1	1	1785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFphC8E9dmQde5dZPgu8hRAE5LyuPhs3zrBrSM3EgMUcGGWw2g
25532	payment	1397	1397	1678	1	1	10732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6QeUr9kwN7oGch4JcLMBnuuRYqC84v5Lz4pRQUKf9ugLzjuv
25533	payment	2133	2133	1874	1	1	1555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDrPNS4FUbfVLWG6o9qzJv2He72diYWHkmGhiybBkbc2D4esN
25534	payment	2134	2134	1874	1	1	1790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPzCDXSXkPL8HBRor9XqC2ajJAGdVWrdkhE1PSfqZRrFTVsHZ
25555	payment	1397	1397	1678	1	1	10739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8pk6pkxT1SEYUK2aFzpjSnb11uZyAvMDjXC1z6wPuk1zXr5P
25556	payment	1397	1397	1678	1	1	10740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5gYq6Z4X1inCxZeg3BALoYnurK7xGhYAqCgjxdkdTyYAryxY
25557	payment	2133	2133	1874	1	1	1562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y69SsFKKqmQKFSm9v2BQB9JgFiEuaQnSMbD36KzMsYDASQEo
25558	payment	2134	2134	1874	1	1	1796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx2tNRtasotQSxvFKe61mpigb2r2A8G4VXbcjhDF7qTBGA6yk
25559	payment	2134	2134	1874	1	1	1797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4LN96FaunVTSkimjNNUB8eocKMrqK71QUgSEfMS4EDzPx5eM
25560	payment	2133	2133	1874	1	1	1563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkxrQjVaNyCU97qf8ro9JVcHyvb76dWquxgcwwU9fhjADnosy
25561	payment	2132	2132	1874	1	1	464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83SWWzX6e87cW82u63pwAWDL4EpkmVH8a12gFjSyvxfo1YzBZ
25568	payment	1397	1397	1678	1	1	10743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gQ7ZRdWB1aep9LJ4LF4FvJPn6h9B1qacXQ6JvXMTNV1N6HiZ
25569	payment	2132	2132	1874	1	1	465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEtekn6Dh19Sj2y3165g6aVGJt4LNRq1txrbx9vKsxa9zAfEJ
25570	payment	2133	2133	1874	1	1	1566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Bcv7i57GRepqRt2YgdsErE2CvQmanyTZq9Qsj3J52BsFD2Ft
25571	payment	2134	2134	1874	1	1	1800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAac3PcCwJX59ZbQLFrbw1APWXdMZ57yG6UXAbUKvy6CMLm7p
25594	payment	1715	1715	50	1	1	3	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wLPDbhsKL8WH258pXgnYyuhDgeAvpN2ke626EydMoJEyBWsh
25595	payment	1397	1397	1678	1	1	10751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYky9tJWBKUZmyKiTRemekV9oB2mo3h9MvXeu2b1azUTaSFHrxd
25596	payment	2134	2134	1874	1	1	1807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJR69f5UyWK3f1N6TwqXpp5zKEYgdCiJXQnMm7rLBFKS5R5oL
25597	payment	2133	2133	1874	1	1	1573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFh3A4gstS6FtwqJEPN8PTD15KS5ybs5UEJw813YWgwdbXceis
25631	payment	2134	2134	1874	1	1	1816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpwucJ3kpQxoyrviqd8h28nmzAyCk48ZRtMVCv1nnxznrRkQ2
25632	payment	2134	2134	1874	1	1	1817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWf7rkrEoJ82gs3pnzoytfp3XcSCNKy3GAoU71D2ppVUMaXHSf
25633	payment	2133	2133	1874	1	1	1583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ygeQ949EhL6CoCFYVhAZDfkbg3x3R4toioxt2k2g3hgeZKu7
25637	payment	2134	2134	1874	1	1	1818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvU337DXhWQX8BnDHXbjy1fDA62EcDfYwcynMfqTBtTtKY1EN9
25638	payment	1397	1397	1678	1	1	10764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQH6zZm99YrCWQcA77KNq9puJsan3ccy1kvWL6rmG6YHf4Mw9
25639	payment	2134	2134	1874	1	1	1819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJwJB82UWAsTs4PkZz9EUgd6c1ho9BuoETGbkjwCAFZu3uXZi
25647	payment	1397	1397	1678	1	1	10767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wJkswLEL77CTcVE7YnRVawyv5sWNfEVVEgqTvPtxfGCC7tLs
25648	payment	1397	1397	1678	1	1	10768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5ZWiUE1zQcL9N985hvjKQRYyyGXoXdR52e5fyMKnz8AFwoyg
25649	payment	2134	2134	1874	1	1	1822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBUzyDykyYqvuHLknVuFhPkgG6TJ34bXnC3cHvhM7SMRzVKNh
25657	payment	1726	1726	2187	1	1	8202	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYredrP6y7HaJnzzXKJ5DXmHnN8bRxh2wCnSdbExtZKZr9Uoucg
25495	payment	2133	2133	1874	1	1	1544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdPBkkk6xVJaxLLMH6bQ96DpowkAix3bhwpj3tyFdpzGgVhFi
25496	payment	1726	1726	2185	1	1	8201	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpmJpLmnjbdPB4VpSJfayLGhkMZKVdDkRRHiUDM4gHNveMtrmN
25497	payment	2133	2133	1874	1	1	1545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hGSyhhcXhdLfk8JunbWHTuGm7nmZWJhy5ri43rssmiNGJCNP
25508	payment	2133	2133	1874	1	1	1548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qoPLLds4R3VwpkN72UNWTneKeyzfsRBTmks5d8Baesfr39KQ
25522	payment	1397	1397	1678	1	1	10729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa368egyJSgjVNU6fsnFr8wbyRLCJZzN298APFkSskPG34SAbaM
25523	payment	2132	2132	1874	1	1	461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPqiifEk15EQhG9z28qkPc7GAh3q6mawpxhCPuBdsyU5phVPh
25524	payment	2133	2133	1874	1	1	1552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvezCC6U7qSwP4BYFG4yMMesiQ5uii8E6MHwJNnU1cbQorRjRU
25525	payment	2134	2134	1874	1	1	1787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oq48wRhNd4E2bZmynkjjuMEYBubmTGp2psimw6UtXY9DtvUM
25545	payment	1397	1397	1678	1	1	10736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKJiQNrE9wu1Ug5Ujy97V9yL7BKG8fegb5wA55MEjVt43zsFE
25546	payment	1397	1397	1678	1	1	10737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxxMb5XL91wSZfVQxJsbbMEVJwec8xsF5vv9m2NDBoQbT3RY8
25547	payment	2133	2133	1874	1	1	1559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP52nmPHkEYVfQxfDQznhFLDCf96WRZoPj8gKA9XzcC26VtJw7
25548	payment	2133	2133	1874	1	1	1560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAossiXVNs2ZaoTZNpWJ8GTX4FxvdzpHzUpNgNVRuhtPRHfGH1
25549	payment	2134	2134	1874	1	1	1793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMSS5DonAmVZKWnJRoREgfvc9iaBYrow9Hgj2YsLppzcezgrC
25550	payment	2134	2134	1874	1	1	1794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwKFaiTqivHSjT1WPH2hd9okuxXqCdRLDVbCM2iQ6X3iEkc3j
25551	payment	2132	2132	1874	1	1	463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAZ8spZF97DtHcGoBignXJstJ6uCn2v7nP7a1Y1zyy3f7w7Ys
25565	payment	1397	1397	1678	1	1	10742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJGAWHPJy36SsdUHP5yoRZ87T4CNj6ZmXBuuwKdvaWDcovrH6
25566	payment	2133	2133	1874	1	1	1565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzzaCXWubrsMYgCxjQtvzD6s3QBR4PMMqG1m8pgxdjJgF8cQR
25567	payment	2134	2134	1874	1	1	1799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkAhQK6zjeMvubNa2a8KPH2sJfv1XfpYpr9bgcyMQXzgte725
25575	payment	1397	1397	1678	1	1	10745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47zW9aftDSZazdjiGdZNWLxWAxsHZGBPjTa8by9Ao34tjNaCn
25576	payment	2133	2133	1874	1	1	1568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8tCaJzgviXC3TM6Jt8TkPGb7opWm9gQTCUR4URRJDaY1i7B5A
25577	payment	2134	2134	1874	1	1	1802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxX25nbaRJywvFsiRTZj58A8DHUMmJ193FqvPwLEqCiuWvqoHG
25584	payment	1397	1397	1678	1	1	10748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGY1axk9TU7qvbckHdKYqesQ9meuEn5iH22jkQDiA1jPvKMB1E
25585	payment	1397	1397	1678	1	1	10749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8RVGk3BUWMUNAtvK1f9sHUgUepS9vnGyUe2yfVS6KAZc17xq
25586	payment	1397	1397	1678	1	1	10750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTE411GVobFeRH6jNLofKeTjFnkLiHS3UceJReMPYxMM7wYaRq
25587	payment	2133	2133	1874	1	1	1570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5R2jxKarnHS5oBUEtF78GUQ84nfDYUqLDQ9SWYTydpSxGPkM
25588	payment	2133	2133	1874	1	1	1571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJVUzHUAgu1DP4Mz92iwH67Kf6du1xZ2NsKG6R2T3XEqhWruQ
25589	payment	2132	2132	1874	1	1	467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV6FNpd38RBLfdVjSrDVepTBiyeBSCsvFNgxhAqQ6V6mPgpXE
25590	payment	2134	2134	1874	1	1	1804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMqU4xqkgHRFeazow6by4c86tPEDgpiVQNoaEmp71zpij1ckX
25591	payment	2133	2133	1874	1	1	1572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkE4WX3A3BBg54nbFL3qtG3YhR3ptZcBTg69KCfywn54uDqGU7
25592	payment	2134	2134	1874	1	1	1805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCz9S2PJaR6mWyvHNN1wak9RRmDWdWN8jAJR9m6ffYHh9LkWu
25593	payment	2134	2134	1874	1	1	1806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fhnW6pF6xguCFnteQQD5QRWVZeSUamrviz5mNkmbTpfMxeyp
25615	payment	1715	1715	694	1	1	4	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTGbViHAH6EB5zSE6NJ9f3qi8Kh9ksDXQjyjZZnmH64e8sxyR
25616	payment	1397	1397	1678	1	1	10757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzdVAUgjFY2FthV3wVYkxzoC8EAAjhC2SuouNhJko7pRPH5bJ
25617	payment	2133	2133	1874	1	1	1579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AKZCqhF5wtAJohVAK4NZJHU2YgWp9rRge1xuLTzLRMmozyXo
25618	payment	2134	2134	1874	1	1	1813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBKgCeaJvKRPL7QGEQGug7SGM9cicUGKDzMEW4esXYFxAiBAev
25619	payment	1397	1397	1678	1	1	10758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvq6L4RUnDd1NkhZ6r4He9tbPnJMNcUEfF4dyK53NruJ8jUfpG
25620	payment	2134	2134	1874	1	1	1814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAes8oiXKSJNxkQyoQ7Xv7zCgTSGYaPLqJB3ofDAM1N7AZHcZu
25621	payment	2133	2133	1874	1	1	1580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKD9KXBb6E1RfnAeoZT37uzdS5Wh2rinPcoBBACdXnDpcaxcD
25583	payment	2133	2133	1874	1	1	1569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCsAeQQXvNyPAArWCTLss221JHcAwwbhZBbYodQXxTJGiXuUN
25598	payment	1397	1397	1678	1	1	10752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfaET5kf1TjEFuVB6kCgkv7ti5XU5Y6ASm6hFjp6SQJMFsuSm
25599	payment	1397	1397	1678	1	1	10753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkzj3XTDbpSpieNxnK9BAT9qdQ4ngmfrwPgxdL211rXKbsJ6W
25600	payment	1397	1397	1678	1	1	10754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJuAQmUXeiKPYSdCnmMbyTf8Tb7hK4cxozd1gFLFxJYQZu5Lq
25601	payment	1397	1397	1678	1	1	10755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwphDtn15m2m1hZReereDd9FUkwrtkVxUKsnLNB3wwwgt5t5C4
25602	payment	2134	2134	1874	1	1	1808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5NR4h6XeLr8qSzytipz1L4nmSbCfFjGhRe55ZT7EopJsGYxk
25603	payment	2134	2134	1874	1	1	1809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZBciVgqh9LQJUHTWRaEvmwEw2ACLr2jp5i9DCkmZkNSqopoo
25604	payment	2134	2134	1874	1	1	1810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtiqPeMhbtAoCZ2mdRM9PEUfZPADBmkSJZ5R5Ti4JPhMyurXp
25605	payment	2134	2134	1874	1	1	1811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiGqx9LuHDpWydTVNaBX2sqHwEr85MBLjPAAzGjdY5dPNvkA8
25606	payment	2133	2133	1874	1	1	1574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4C1hnDpxedQkSVXpk73JUUnjJJdvX8SH8FWaESYEgXtQxe7Hf
25607	payment	2133	2133	1874	1	1	1575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xZL1y6kgeyDFoEPRfHE8EUmsj4k497z74dys8F8hm96T1bbZ
25608	payment	2133	2133	1874	1	1	1576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJ84F83SDXKXFYBoXdFurYniMe7qEfCVyagmdeeJfeRcKL4UQ
25609	payment	2133	2133	1874	1	1	1577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6CeKJFvEUa9Wp6fUpoqh6n1UtYjBcBK68J4o9Wt4kGyyoDst
25610	payment	2132	2132	1874	1	1	468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvuoKJNFy4L71V2awtzoRvszdhS2zVXftNnjKmFfKESbgeaMP
25611	payment	1397	1397	1678	1	1	10756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqKLFzbjtFSwuGq77XtALnEEeVVXXUu3jSq3cATir77TPyVmi
25612	payment	2133	2133	1874	1	1	1578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTKPmSYKNguYRiGAMsDW2PZ7DX78G9HgTtfca9jU6XdjhPVuu
25613	payment	2134	2134	1874	1	1	1812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25U9khB5eQ5YtbiB8iZ4kf6zZuEmSKMnsmuDmSG23FhrgTfEa
25614	payment	2132	2132	1874	1	1	469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94sCTenThHFBWPPAVyczYWtyXMRMcq7JhTar1tfQjPXKM25Nn
25622	payment	1715	1715	1006	1	1	5	3788185563455	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQVFL2rLb8bVW38cTke4gMR839tp8YKUxfG8tx1nE2j1Pay7a
25623	payment	1397	1397	1678	1	1	10759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgh8Nw3YQbNBgGgzGZRnwtLZ8myux9x5JjE4vK18nq5CdHncdU
25624	payment	1397	1397	1678	1	1	10760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5kr4Uj8WkhTz1K2MwY9MijTzZAPtoHBqWTBEbexg3r3eRQEq
25625	payment	2134	2134	1874	1	1	1815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfaHUaYW7ucrJabpvhCR3jXCZWFb6YnJPzqN4Jue4dDseUyF9
25626	payment	2132	2132	1874	1	1	470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsKiTXAxwA34euUmW8PCUzuP3W6XsAkZSs5gizMMHBWDmAGfn
25627	payment	2133	2133	1874	1	1	1581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKjf3bJ5Yxaa2JQU4kk16ZU87xjkkzUZvNjXFqdSdMrsmtTcV
25628	payment	2133	2133	1874	1	1	1582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7yALcRyU94o2gQvvmJwtxsYF8bipANacrMYrzoBEZZmJEfiX
25634	payment	1715	1715	1126	1	1	6	6788396072558	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67Nyj8sjw9T7rbJUo9JGMZJ2C7YVgs3fWKY8xtqw6qkwSNZq4
25635	payment	1397	1397	1678	1	1	10763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2Qxs8hTJNw6EgcM2zYnmRDpkmvjz4aXMeAQ5moxpAkaxNmug
25636	payment	2132	2132	1874	1	1	471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPiGJLvKoHHz4uXXZFmL64EjsFrJG5Ff9tEBMiNihnvPz1kFy
25655	payment	1397	1397	1678	1	1	10771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ4EVdHMsphNieDC98sduYH57N8EwHWBQyRpaJHXhkoGnCBHn
25656	payment	2134	2134	1874	1	1	1825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPmYiVYiMDbuV5t3RxSuZEDvqB5LXD3YC7133JohaJLHL7hFJ
25674	payment	1726	1726	2188	1	1	8203	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqoGYtco8rZ5uxbfYfT9Bb8Pf6M8NsNWdJJKtq4emcKeqc5bjA
25675	payment	1397	1397	1678	1	1	10779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuC7k2uGHh9aXviAFo2d2oB24MC6JPzkn73X2Qd1u8SFeAsDmD
25676	payment	1397	1397	1678	1	1	10780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSzYN8rDcnNG5WCCJfHV8YMTU1hd4LmCXroKJ9QRmyhSyUzy1
25677	payment	2134	2134	1874	1	1	1832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrktY1csA58FW4JUreRwowkiUD4PxWvgM7PWYRFatHehu1nJb4
25678	payment	2134	2134	1874	1	1	1833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cSo8ayW1Gucf3pkcFWs2fkVDqzyNgXJ6dgPs5YpB7cDc933X
25679	payment	2132	2132	1874	1	1	476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD239vYNKQu2aAhoqxxnVxgts2NGNBHF8nKATbYJfSQoXExFMu
25692	payment	1397	1397	1678	1	1	10787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ze6iHHcPUGBmNHGrEQQ4LJ41Spmcu3yqk6LZoiruf3j5V2wo
25693	payment	2134	2134	1874	1	1	1839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTFQ3zGLti6u1F7aMANc4C5yzXc1kmXQo6uSGD72r3CVw7D46
25629	payment	1397	1397	1678	1	1	10761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcidcFJXeU52qMxbs481LzF5u82raBv8qU8xfu5N5P38ygqveJ
25630	payment	1397	1397	1678	1	1	10762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRU6JR6pVbb1R6gvQjyRWVCGz326E7jU5jHNA5MYfy5BSrPtb8
25640	payment	1715	1715	1246	1	1	7	4580266098492	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FrFf45Qf9kkCc9BWEu6sb3N7XidJEkPRQYg4BfAyNrTABh9y
25641	payment	1397	1397	1678	1	1	10765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA92jk9sAdqqZMKgzU74Ls5RZ4FBmqABDNewkt5pjLw78TLDY2
25642	payment	2134	2134	1874	1	1	1820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZtTBLke5JZBJLHGL26iKd8YsvcNUv8NvfxzG65X2w1dBprcJ
25643	payment	1715	1715	1372	1	1	8	12763318738043	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNVoC3grM5doENUcH8JiTAnDw9EFm65C2yTT96pWjCSfuvPCQ
25644	payment	1397	1397	1678	1	1	10766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdNGZeDt3N8FUR6fx2nNZfj1MK5XHLcdD3QnExywPqWmgAvbb
25645	payment	2134	2134	1874	1	1	1821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1ahmq2dWQEKVowzTE5PLngm8kp43RU4BT6xfcaxvNeWmsPqH
25646	payment	2132	2132	1874	1	1	472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wDA6sodK5jkHw9QuBJxM9XZQhjLoRXzeXeFZKzmWN89fXwN8
25680	payment	1397	1397	1678	1	1	10781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRtd96AQXZzeqNNpBg9i7NC4e4hqPayNcbdoec6nGaXjvYBNn
25681	payment	2134	2134	1874	1	1	1834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWn9pqDuVc1m3CNHuMzZiZ2ht2SrLRyhx18pNx6FCnPr6BhmA
25689	payment	1397	1397	1678	1	1	10785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQ81xbBHRJQiYoxCwgZTNhVaZ8U1daUvwiurEaRC8LM9YBbou
25690	payment	2134	2134	1874	1	1	1838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3qpF8mB4mVHQnK3jYqbHEhHBsRiuNjxETq4eEncZHdJc4KsC
25697	payment	1397	1397	1678	1	1	10789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXU7gekTVyJQHqhSXiRXf8CUmEeC2kPVdLrjYjDtrFFrgLLKL
25698	payment	2134	2134	1874	1	1	1841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYwzts6yyhvHdY8cpzjRj1Su6txTzvThj5BygezsKM9g1x9jR
25699	payment	1397	1397	1678	1	1	10790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMv5vfrMPwMdkr7kd9CKMWSuy8Ub8BfLDxdLodyw4wR12R9LSR
25700	payment	2134	2134	1874	1	1	1842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkoED7F7EbVLNTdVcsDuSnDV1BAUu2uQYGb4Pyrei3gst7k2x
25701	payment	2132	2132	1874	1	1	479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfUgQrUmzbvbCwnrqxXpYn7JhDbSFXzfHDuWw3b544QrtfZhZ
25702	payment	1726	1726	2189	1	1	8204	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8eqE1GkGkjnr66BQba6ZT6js29Nk4DPrEbLNxHEgWG1YEAbTU
25703	payment	1397	1397	1678	1	1	10791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cGTnRjhQC7dSaBa7Z2jrkCp6C1hvMB4uZZfKKwp7nev6ZMkP
25704	payment	1397	1397	1678	1	1	10792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuuaKnuuf7XoySEYNHfZkfCfJdJSSgDoZgKFmPJeR49ZEP4Hk
25705	payment	1397	1397	1678	1	1	10793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7MtT9cutJV2URdoAfibdHM3jvMiujgvQo3aQNJv7quEQDCU2
25706	payment	1397	1397	1678	1	1	10794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZn1Cjb7zZkjNmFYna2o42LimGx6nKdmvPWPtyzBEz7vhvALJD
25707	payment	1397	1397	1678	1	1	10795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTaK7mpMV2vq1X7PYjGzm9QgwWoJrt8sS28t41ifN4i8zATKW
25708	payment	1397	1397	1678	1	1	10796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2q3BK6hhhMQEVbWHoCvQCYgfSxs958rYqjWEgvRA42fUNXQ3v
25709	payment	1397	1397	1678	1	1	10797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFceSGzfd7dqM3Rc7EjEGpAGpY39s13ZFx5xoCxkjorwyGbMHQ
25710	payment	2132	2132	1874	1	1	480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfTLtqKX3GX23sarDsT72BjqSDvRJKewV4isAPYEg1DkGBbT9
25711	payment	2134	2134	1874	1	1	1843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5D8dGii6R3wmFuiN5RDrKB4izUJ1XhPwyvb6wC2A3ireU2WA
25712	payment	2134	2134	1874	1	1	1844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LvQrauVpcjSZmxX1gRtGWQPdtez56CW7NYpQRq12jnwVEESS
25713	payment	2132	2132	1874	1	1	481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTo1DyCHCdPuepP45whUgdfab1S9hph9mzw53PZhocw7tmV2K
25714	payment	2134	2134	1874	1	1	1845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDex7bbL1qU3HJCzvjAEY3ovPTUT1TNfaNkHQPjs8MbH2mcNAn
25715	payment	2134	2134	1874	1	1	1846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLbTznj453uw45ziYEUCQFkzLbTVtVoPa3Pf6FNVKjnaiCdCS
25716	payment	2134	2134	1874	1	1	1847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvWyJgrXeyWf6sGQipnk4s29rRySdxhzK3GuPgb2W18y5JQn7
25717	payment	2134	2134	1874	1	1	1848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qEgNvkevxQyjrQSaLk7XmjjxjaGckd83AWkMrfhpDTvw2cis
25718	payment	2134	2134	1874	1	1	1849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXxA25jKb3Q3Uzb5WVenJGHCZvpJmfYXLCffacaUakjtbWdVC
25719	payment	1397	1397	1678	1	1	10798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvgBtMDxYfhjqwNHzEHVTkLkAmfRXcLuPC2SxjB2PvUg1Dowe
25720	payment	2134	2134	1874	1	1	1850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvU22kJedvn6XoSxwZBs4rEsHv8dDyyviULKDVwKuniuDPSwVv
25724	payment	1397	1397	1678	1	1	10801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogEW89iv3haRStzrRkViALUPYR8PrFjcbye1VT4eMx9C4dTXY
25658	payment	1397	1397	1678	1	1	10772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1L1BhTnoaFvCVcFnqJ1KfzYKcLgGWyuztLNzVVPqWqjkAU8rJ
25659	payment	2134	2134	1874	1	1	1826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuj8HWjVptFRtu56fxbaRrNFpdccGCLsw9PFgDKY9X66f1Pke
25660	payment	849	849	2152	1	1	1	18181800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pdRLgNSVE9dFspckJnF1HJfdZdRM84ZseNucPte8i4yy73GU
25661	payment	1397	1397	1678	1	1	10773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzpSJYzhLsuBmWbF6DLFVDNve6W23a3sfXGE8wkNxSAb2msHc
25662	payment	1397	1397	1678	1	1	10774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFySbBykiG862oePeJR9Q6Uck9PBv6nzwYocTYa85YkjrXRHDg
25663	payment	1397	1397	1678	1	1	10775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uSii9NDh2vDVVpeq4WEsBSid3ugsayYd7ydskobLwqGnHA3N
25664	payment	2134	2134	1874	1	1	1827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsBsiij34TzaLVKGMXaam6YQezUPfYhCfkw4G9TCdnxEALnBB
25665	payment	2134	2134	1874	1	1	1828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDVuaefZevw8aC46tqnXBCHJVFdY9Tf4NZAhvd1tQWBujpeAX
25666	payment	2134	2134	1874	1	1	1829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZgD2BjsuNyD88Mm6cD3h1Rh1Wqqio15BgNUDcrUiWahQqDQc
25667	payment	2132	2132	1874	1	1	474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNfN2aBTeiJxqF3cpzVp4xc4mmkaeXhVbHvaDX26yTVHQbDB8
25682	payment	1397	1397	1678	1	1	10782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BytDFtXHCSShGDtKSNDmXsiz7bjxNCFWw4pxheFXqNkrNoF3
25683	payment	1397	1397	1678	1	1	10783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFoN8QqLtbVGNDZCEmpb1GeYQQNCLa8Cbft8pYGFC9PjcXKir
25684	payment	2132	2132	1874	1	1	477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT99W74LBAfujSJ6iznXbhVDgEVdjTTGK1HyWHEVmLxjALCB1z
25685	payment	2134	2134	1874	1	1	1835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPri4Xon7j9M6pqENo8dXk9HZALrXim6dq9ih21VUted8Urec
25686	payment	2134	2134	1874	1	1	1836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVVcpJLGyvDcA9gZEkHKSgmsFwf69vrWDLhszbTxS6FBCPkC8
25687	payment	1397	1397	1678	1	1	10784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpY28JHu9xuNyCjrW5KkR6wEoAtLweZNuz2icqs4RACf8qeSy
25688	payment	2134	2134	1874	1	1	1837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDgTRivysfVT9x42qban3z9Wm6mHq3d3xn4mEXqznXLPRtGBF
25695	payment	1397	1397	1678	1	1	10788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7x2rV1JYoXkWYKgjEQKPvcqQ7TZc3d5Y1gm7ad6BFXovZpBjD
25696	payment	2134	2134	1874	1	1	1840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTqiug42kfaYh7LweK5VRGtJhU5f9nSFTKGr5wZ7hya6KRLsj
25721	payment	1397	1397	1678	1	1	10799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3ZC89Mna48CEBgt7cDtdhi1ZUK34Pn88yBVaJgnzfjwxiwSp
25722	payment	1397	1397	1678	1	1	10800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL61dXjXNCmokGzEMXypzVM3LGN67cy5WByDQpkMrDAnKzmDym
25723	payment	2132	2132	1874	1	1	482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEfzpFuv4KsbmB18wZqBDSw78SfRAHjTEGiaZXQGbukoojAHb
25729	payment	1397	1397	1678	1	1	10803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qTwq4Cu76QVtjr1eM5vh49vzY4Y6Z4iDjP9LWm9MmESQX9YQ
25730	payment	2134	2134	1874	1	1	1854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs15ApHB8jcDG2mW6MFrDaktyYfx1bKLEu7iedGWByatEWJCfD
25731	payment	2132	2132	1874	1	1	483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbq6mfvvtwg2P5dpYbvWLXGrjTSgRAtJVnLJ5MACQtc4bzfRa
25749	payment	1397	1397	1678	1	1	10811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5vaE2P95j4dUfSQbsFYxASxLo8XB6jNr5rxiP58eP5G2e1ef
25750	payment	1397	1397	1678	1	1	10812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvvzB9w8j3P2AkUK5C2i4nWKCekgUUkEmP28cg8QEhE2ji4bG
25751	payment	2134	2134	1874	1	1	1862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBzjTLGj3umDeZskxUNTtfAuWooCA71dgMTVPnWCwBWmvZuXB
25752	payment	2134	2134	1874	1	1	1863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYUpKixqiQmNcSwa8sTezyJ8QgGpmoohEqFRL637apUpq27UZ
25758	payment	1397	1397	1678	1	1	10815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwz3rKZSdcDDnZVVdqPzx52ajHhLs1HbFt8Zv2W5nozRYxcXdv
25759	payment	2134	2134	1874	1	1	1866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFwGc5LkCSmY3N2nLmbzA7LT3GytFTKKbd5B7ahQmqkWUR4Mo
25802	payment	1397	1397	1678	1	1	10831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtxucooRF8BAgS97tssrmxWm1GvrH3MeDdCVCzqqYRdsUP2Yo
25803	payment	2134	2134	1874	1	1	1883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31AJNcar5vtxCQCDsfoHoj6tTsJBCMsTHzjR4YSiLgWMXL4jH
25804	payment	2190	2190	1597	1	1	0	10000000	1000000	\N	E4YZZmcXsCRpcaxxB3FEydi3WJattSQQWWCcMmwR4TgJDk2CW1YMZ	CkpZ8qj2oADsvnx1q1z2of3XtNipCj2ggQ1m1QUccsRXsYztmrxBW
25814	payment	1397	1397	1678	1	1	10835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsZw3jMpGraSPGWGjr9obTjZwd8Dpj43psBcyL129BorRfqoU
25815	payment	2134	2134	1874	1	1	1887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbE7D3Wt9Hbb8ngd5U2CYbkGCaJ5izvYyftb9g5S4EhguW3V1U
25823	payment	1397	1397	1678	1	1	10838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vwWV23GaZvytAokQCMtbHXJyug9XFt3Kf9VegniYPUWe6NUE
25824	payment	1474	1474	2193	1	1	17	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2Yuk7RtEnp43Zw8UmGgmwS4qNLnaB8c6RTUS73ELtFJHaidM
25669	payment	1397	1397	1678	1	1	10777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8HdicxUakfabQjZFYLkaQ1qMQdVQfctHgZnPEpKp8rz1ngN9
25670	payment	2134	2134	1874	1	1	1830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCffYH6kD3xxJhbdFBj43WhxQzuM5u2fVVjFiy7nqLKEz1R6N
25671	payment	2132	2132	1874	1	1	475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaKX9WJTssreCe5QxFxNvN3Xu48mDiybCPvz5gT9SZo8ucijE
25672	payment	1397	1397	1678	1	1	10778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8ZPn71Vk5UEwJkiMv9Ww1hhoo1oj13GWQ7wKokxj7LQioPLG
25673	payment	2134	2134	1874	1	1	1831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6FZK3Ab9DF6JYjvKUYJD3gmV9cpv2tQAFh1W6JVfjXh7BtPT
25691	payment	1397	1397	1678	1	1	10786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfG11kqpKQdaUXzuWa84ocyuSDLFoSPPmQs5BZ9vpMm8rSj2J
25737	payment	1397	1397	1678	1	1	10806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3F1XUfoJLuMofDm6zDqFX1E5xWMkxQSBgTUo12Bgd43v9xYcw
25738	payment	2134	2134	1874	1	1	1857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEHPGs18ryDuRTjZteguZdNxZjEiX9g4kp3cro3e7v5xEUXHq
25753	payment	1397	1397	1678	1	1	10813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9Riq9pYK58BWZLds8mW6djUKeycDGTPzPm6K1Z9LL9YVALJa
25754	payment	1397	1397	1678	1	1	10814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8HJypFTKjWnBM7BmxyEVsmAFdhApbFveJM24PyhmFhpVCRqV
25755	payment	2132	2132	1874	1	1	486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7RaNQXuiyjfouTdPyoASEL3BfZLRsZ2AwchWm33aeuWSVFaj
25756	payment	2134	2134	1874	1	1	1864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZc9WQkbi9UdihVpwKoPwhCyiZdyxAtDFQBszRspviHTSzUi9
25757	payment	2134	2134	1874	1	1	1865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDwBhXeLceE3CETatW5va9ThNCdF68a5oYdjdnxS29rZCqi5q
25760	payment	1397	1397	1678	1	1	10816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDTPt3pki4XYyKme3JocwwHLCyMkYqP3VKDdXqyVRv9TTYmX3
25761	payment	1397	1397	1678	1	1	10817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRa2z7aoBk98PLnm9Nokb9scijaoieHLA3LJ6PypwmedauQwa
25762	payment	1397	1397	1678	1	1	10818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJXgXqsnLLrR62D6YPmrxubKoHotQR1XqHWNgwYNP5KTP9j87
25763	payment	2134	2134	1874	1	1	1867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYTTg2zaC4Q5zHNwPp6MmLqtv4ATkJjr9VFgwUD3RMfngNXKG
25764	payment	2134	2134	1874	1	1	1868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF9ti8hYBheW1GHUVyHPaw8BXsz3KLheEnzBCXN9k9oUx3SxV
25765	payment	2132	2132	1874	1	1	487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9pNSfijSM5U76LuvGpQVrM7nrdyC6XS4mgVCM28zGNTpg4wk
25766	payment	1597	1597	2190	1	1	3	2000000000	1000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpYvGBGMargQwaXSVjipYodQQJdx8CXpKD9zPHbHxK5Njdd3opCY
25767	payment	2134	2134	1874	1	1	1869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpkq3NsSiKV2rmdJZJdmPPzQQqGDrnPz5dRBLvsFY3XkYaRoT
25772	payment	42	42	1235	1	1	6	2646259200000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJszwFdQc3oQMU2Y6hf1uE2Xr9eLWJtUzprEmWKFU2yy4XQBet
25773	payment	42	42	995	1	1	7	2188252800000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUY2nSrKqAbWXoQ5FxkTD3NGbtAmhnSFAp3WsWUGSKRTnTrqMN
25774	payment	1397	1397	1678	1	1	10820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2A9Rwo8PJPkhWj6CQzWzvabd9VqS6dUXaybyEPJv6J2PB5FFx
25775	payment	1397	1397	1678	1	1	10821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1xMALzfGoFtdoZQYzSyQN5Pd94o4a4xkCLcr8vG99Uiit4Vq
25776	payment	2134	2134	1874	1	1	1871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbh9KsVwSQj6gdsRzR148EQUN8xz2Yhm2uzf9zkiNPpaqaY134
25777	payment	2134	2134	1874	1	1	1872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrd5bLWj826QFJDBfZjKCvZzQ5qs6nw4t3A4uzUENyU7rsGwR
25778	payment	2132	2132	1874	1	1	488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2A6qxoKQYqu3zcsvyK75UWgH9LhchtTQLnE55GYP3nVSGx5KM
25779	payment	1397	1397	1678	1	1	10822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUa5Y4KynJpyQNiBFDioeerDVtTgZsjMjADjnzWASdWq3FNPT
25780	payment	2134	2134	1874	1	1	1873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkEzQVu1oEQnyquTPFxEkjjuaDfzYEsDUv6eN8X2t1C2nt24E
25786	payment	1397	1397	1678	1	1	10825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXULnXLWK2gBgUzsnutZazYXhVR71DX9SB1MLYb2ACRspf84gT
25787	payment	2134	2134	1874	1	1	1876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6estnVqvrcKdCVydUpotL1r7N2kQ2ACBy3SDhJbhA7WVaHMN
25788	payment	2134	2134	1874	1	1	1877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJWbi78EyeDbjXYNh5zpqc6pkuhCYyAp7NVverpNSRi9pZz9i
25805	payment	1397	1397	1678	1	1	10832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgr2tBbtv35qWLXdyW5essLfGmsPScHZVMR7Syrxuk1ym4nyB6
25806	payment	2134	2134	1874	1	1	1884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTCuqw6QWTrcDvvJnwyAFWzJCu5c2SdnVj7fx9J94YZ2LX99U
25807	payment	2157	2157	1929	1	1	21	162255000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe77jbA8W37hmueqWRiVAY9YSfWUA3pkDKE8c1YF3evkaS8dx
25816	payment	1397	1397	1678	1	1	10836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2FmgT3TYg8ypBiJtgYTxW5ZLhapVaV3XEvwRcdYBtYvV7qSi
25817	payment	1474	1474	2191	1	1	15	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6nBFnWdYBssFzVPdThiR5ivd94dPTssmoJhaQPoW1vGoXjh2y
25694	payment	2132	2132	1874	1	1	478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatW64htc5XqCoNYty1cFsge2kHZwaHz3Pov17dvozUnWv1rJm
25739	payment	1397	1397	1678	1	1	10807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXwkPZjg17AgkqEk7TRf3tzURVzEuVEHgU3cAmefupfcL1t25
25740	payment	1397	1397	1678	1	1	10808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4h1bHaifFUZvWpVArsXq5HJ24EiJ2b3ZJk4KbgD8PA6o8bNi
25741	payment	2134	2134	1874	1	1	1858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbLtzj6WQ6cMBx1VCGxSpbvAosKsQrBS46j1heXgD1HYRmhkW
25742	payment	2132	2132	1874	1	1	484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSVVBAjzwhzP1RGH3xQBURRELtFCGWPBQh49RUTVf7EA1sXoc
25743	payment	2134	2134	1874	1	1	1859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBJZdzy6Q56iQduYUaMpGsNWeHRfGyJBf9osrA9kHEG4AmDRf
25768	payment	42	42	1361	1	1	4	7372425600000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoxtiZEixN1SLK2pVSpjrdft6S5FUAUwvn4XL8Wu68BgYtKrW
25769	payment	42	42	1115	1	1	5	3921782400000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLBVPLLAHqAJ9xS9FXLRAt69pGWwEZPMCroboQWEq92GFhCc6
25770	payment	1397	1397	1678	1	1	10819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YqCr4XVb8Lj4HQ8kVGANxQfhHN7KwhYinBM1NqUkJhB15rVo
25771	payment	2134	2134	1874	1	1	1870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknqw1dDTwdhqrPVgxamK1YQ5p8yMHR3BvDqMbfzcdUWnt463x
25781	payment	1397	1397	1678	1	1	10823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhAkhwKmEcBCtgV8EipQvwKAQr6EUYH81zWt9E9VoAQSe1soU
25782	payment	1397	1397	1678	1	1	10824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLfdL2wRT7NFHMTRNkimr7tzMqRrKvwzdfvPDvi3s5u1PAwZk
25783	payment	2134	2134	1874	1	1	1874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZikiTSX14LoMdmMwTFn7zkBBf7cjjGpdruHAg6UkrghwAfADB
25784	payment	2134	2134	1874	1	1	1875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQRmGsg3f5HTBEMrAX9UKWKaB8grWnNZFn1L9sadudbBP9Rix
25785	payment	2132	2132	1874	1	1	489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgWP1wiEdgrFgjR2q4b1Ek5aBLojJP8Gx5VEUXY5nGYbfiZao
25789	payment	1397	1397	1678	1	1	10826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEzKR3tiayhLyLMZWKsc96iCm1cnd7Y1bJwgsgpNsQ92MMxDw
25790	payment	2134	2134	1874	1	1	1878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVphQ3Krew2tTLDq9ehxKthWcL2BooggPZREBtXJ84L7sFsaiw
25791	payment	2132	2132	1874	1	1	490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxD1deKUGd7oXsf4nf7jf2Y5nERthCCzkY9NeYQy4akujb6DX
25796	payment	1397	1397	1678	1	1	10829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEMnyc2isWqXJMvWk2UR31mYBp2aA7pH87UfCZmnVY3FVsYbC
25797	payment	1397	1397	1678	1	1	10830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ReRF8iibDDYzbV7YNVzNNBb3GAtV56LBd6QUk3QxF8PHGu9Q
25798	payment	2132	2132	1874	1	1	491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXudWrmgNdPfXLd9e4vHpgkKBSCSnhSodir6pfXRj57DhrGzSC
25799	delegation	554	554	1611	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHi6Yr2pTeKZAC7FYXu4ocspYhHfj8vak1kaCZtHbn8pnYdc8
25800	payment	2134	2134	1874	1	1	1881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJmwbCMs6h5CkSHCZBfcrpzMRW3jmoWEokMucrR3ENiRsEXTT
25801	payment	2134	2134	1874	1	1	1882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cNKp7J2aGEuFimJ7RVSUC1Ppqfr2yaNoWYk3iaEmg8o24u96
25811	payment	1397	1397	1678	1	1	10834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnrcjPXe44S3xRwYjJmj1oxUdt896PPf7UK6ZFWyookjtDuz2
25812	payment	2134	2134	1874	1	1	1886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJupChsCQYeqKxDueJaqNmPBunnBDy8J1Jo8vdqavFFXoFhBG
25813	payment	1597	1597	2190	1	1	4	2150000000000	1000000	\N	E4YVe6YHEj4aA4ezSEaYkn1zMHYPNW7HWkzaudRUSLMMsBU6f6xbA	CkpZcgRskgtf3Ku6z8abgtHXtSJU8UtFRBvRJG9DfE9pTRXyJLkHU
25828	payment	1397	1397	1678	1	1	10839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwErPfu7uEHgf11FApwLbLaNP3v64pUzC8DhkjEYy2uKrnULxa
25829	payment	2132	2132	1874	1	1	494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQafJGf3EUQpVTuWJ94nmP6diaeXEZyYocL6UeGG8HQX1cUHu
25830	payment	2134	2134	1874	1	1	1891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54bXpkAunTMdmc5aac7H85QnHXHw8jXFqijmabXhCKyb8kASW
25848	payment	1932	1932	2196	1	1	3	598000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWC5ehA5MrTuB14D1LDJZySW9mpPkMskA9DF8x1oC64X5KUV3
25849	payment	2134	2134	1874	1	1	1899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTHtQjQQ5Smy16ZW5AFtXcBa4XcwkfAmvA7Qs36RT4u3JcHGb
25876	payment	1397	1397	1678	1	1	10859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnSXjT11xLR9n1y2oMJXY41C6jJcopB14sCpsyN1pwF55jQt1
25877	payment	2134	2134	1874	1	1	1911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZ5mqNVM7T7JWbD8NU8GKtYRKirBHL7oxoTeBSNQ14zeax1oV
25878	payment	1397	1397	1678	1	1	10860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Upp9mwf7AQabxAxgkoZ4Njr1gDXCZxRvc5AJnZau7tS6za8o
25879	payment	1397	1397	1678	1	1	10861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwD4weDggeHAP4TbGQg46xHWEkpJU27pUXVH8gXYgvPWvthBF
25880	payment	1397	1397	1678	1	1	10862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5dWRfE9EHrjZGxTyoN1XAEnos9TUgkPH4Aa5sKfY7z13diqE
25881	payment	2132	2132	1874	1	1	500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCjCQkVXvxCXdetywLXQDTRFdbJ7XasiLZteRpnnaZKc9KWiW
25725	payment	2134	2134	1874	1	1	1851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8zd993CU3XxDeNnXRaiCmD2xkviSSx7t7p7Heyen4TwqaYy6
25726	payment	2134	2134	1874	1	1	1852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDi42uK8r7cuwniUQQ9kHK9cXHhFdKJ7D42KYmnN86c3oVX7e
25727	payment	1397	1397	1678	1	1	10802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxJAj5YrmcriXP7GAyY91NjPwn64mUHHxXN8MS2NnfQDV5rWc
25728	payment	2134	2134	1874	1	1	1853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtgkDSz9ngvxzumZQd3g6kHb4tqmqd9DFjz6hjKiYNfisjRML
25732	payment	1397	1397	1678	1	1	10804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNt6kX8jZmTKCUQobnA4btktjWzSLgvBXRmazQMC5Gm4CqvVF
25733	payment	1397	1397	1678	1	1	10805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTV6z7iJYJNzT3Yaynhmaw28pL1ToQg5GsWznJuVinRToca24
25734	payment	1611	1611	975	1	1	1	2041700450000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEv7Ss6UNW3A1MC5BpjNZpQcAHXdZ2vJkhbXDGCUPvrftFNbM
25735	payment	2134	2134	1874	1	1	1855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSxKXwBFZ9YvuJthdBXRhEitpfMKaCb1XqAWb6a5ZCky7Y6F9z
25736	payment	2134	2134	1874	1	1	1856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgB3s6cvnf1wFXmHhBZaP6neFCXpuRwXc1p3H8VoW6useYKmXE
25744	payment	1397	1397	1678	1	1	10809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbrMD9d4EGkbrMf8fW7W7816VxcmWXRRKBhRzsFKwoXkTtSeF
25745	payment	1397	1397	1678	1	1	10810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9YkTXhPhWVA73YND9X6WPcEYQZoA3wPUGKjjfFDvB5LUP3AX
25746	payment	2134	2134	1874	1	1	1860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmhzR1S5z7ehqQtkfG9PfPCmUwwC3z675qiHtNEea5jqrN8Wg
25747	payment	2134	2134	1874	1	1	1861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiqK67hb4LJFhBzq5JQeMyzyvRnVL5VGiFNwV4SPmrm91oNfB
25748	payment	2132	2132	1874	1	1	485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zDDdCP8bKVxCJUyLsMPjq8kU9LtVK2vjKuam737JDbxEX6EX
25792	payment	1397	1397	1678	1	1	10827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHi2KBZUwHXtaXK8SqSexi9FqTDt8VMHrBNRwPLMnFEa9A52G
25793	payment	1397	1397	1678	1	1	10828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQYB3tZzfHaBEaqJZsjqkJ4RtpRTKub6GJFSNaLLfXD9zaYav
25794	payment	2134	2134	1874	1	1	1879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QiQytSwdv9jCj2g8yzE1oqxxgPWtv5f9iF7JnzZ3a5ig6Rqf
25795	payment	2134	2134	1874	1	1	1880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46oCVZa6pFiwMkhBTJByhzMgwVgG8v8viwXeF5PMPp3WB1R1Y
25808	payment	1397	1397	1678	1	1	10833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sPnRtisvk1mbtzcbxw6Vn8XSH3kbncj32nos9VMggqWyNyGD
25809	payment	2132	2132	1874	1	1	492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWogM3h8BDuzMSBnNav8QTL5VCZeMHgwLBn8ekUwuQAzmT3yZ
25810	payment	2134	2134	1874	1	1	1885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdECVECGVpsbqcm7xfPFgchGvUvLp3hd9CxADUNELsZVzvbsR
25850	payment	1397	1397	1678	1	1	10847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQEnKVfcu1gMHbDB1ju5VM21oWwpKNBopkMDno7RiB7aB2u6Y
25851	payment	1397	1397	1678	1	1	10848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXAyh7zVPRahiQRCANzFeLQA5SE2hDTbs2R8TABJfD3gtbYw8
25852	payment	2134	2134	1874	1	1	1900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MCfE7HQj39bNLH6z8sZMrjE1etwAVkMP2HyJfPeVDCvAhy6Y
25858	payment	1397	1397	1678	1	1	10851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GWMeSSooErny1Em5Zo8hUgTRdHT9SmRzt7QPVhXDiVnggAkE
25859	payment	1397	1397	1678	1	1	10852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYhkHim78MtkaWR77Lc9DSSPjrer4CHUEpCfQyZqA4b61gPUb
25860	payment	2134	2134	1874	1	1	1903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76FdJyAARfNP3ieREnjoX8Cb2D9MXpWgCz31uBoeQViD9jxbK
25861	payment	2134	2134	1874	1	1	1904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL4MBruXQpzqdzE5Wip2D4AvKguykZaSJ8RMhTvbDA841CXXA
25862	payment	1397	1397	1678	1	1	10853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeuWHZfBjspZKgNnXvT325Pb3RvFnbBUxEkPTiVgxcWXUxbHf
25863	payment	2134	2134	1874	1	1	1905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsZoBFkgH5zL5h1BgbHZVrXz7uorAVMF1xqVAoQwhXWpW9ber
25864	payment	2132	2132	1874	1	1	498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhdVvfxoYrf3ySAooFztUjhJ9MAyMpZ3KBszwCWympkbvCkAr
25869	payment	1397	1397	1678	1	1	10856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2QTRcmmAuzzKSohmRMfjxMJBh6C7KrRwVVz5FWyPcYEMPZFW
25870	payment	1397	1397	1678	1	1	10857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfuTeT4yjJacYbs1y2PQg9XNqo3vsjqr6obXNf8AnSBU1gg1s
25871	payment	2134	2134	1874	1	1	1908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPht47mJL7zXxPQMTknwNr4SewYd43Rg9dFEUb9YcfQ1hseec
25872	payment	2132	2132	1874	1	1	499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvn32nMLnoe2c64uRV2g3nE4UcsfnmDerJ9khm8WQvzkNewd4
25873	payment	2134	2134	1874	1	1	1909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmVkBF7RwkJRS3JFMd6xjapDCuwPTbL5XK6Lq4rMx7gcG4k7y
25885	payment	1397	1397	1678	1	1	10863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZX8CbEaXdMXj2dKFD6TwZzW7qkR6Twf5rq4hEgfHnecY9AHv
25886	payment	1397	1397	1678	1	1	10864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TJ9yoqSrKWd5z4xSbuFBJLRQrahzDH8pUhFcyLxXQSePSmMP
25818	payment	2134	2134	1874	1	1	1888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT8f4qNrdqLRQpxjq9ghHJUXUK2FjXuFR1b3MzRhmyn9becXF
25819	payment	2132	2132	1874	1	1	493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvL1wUt9QHY4ofH7ACiqJwPH4AqptYUMKrHeCoajDUUdDtxrpE
25820	payment	1474	1474	2192	1	1	16	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa864C2aAe4oyVvg1ES9DAmTWkG4DNgfuz9W9erGE6pym4N5ccf
25821	payment	1397	1397	1678	1	1	10837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EXMJtETjaZU9pp1TTsugnEMk5PiinYNS1SSHbbSPgTfYw2to
25822	payment	2134	2134	1874	1	1	1889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6Lp4hp8LKnN6JGsTB8pDD3CHSVqSBnHnuP6UWxsAKHsohsW1
25831	payment	1397	1397	1678	1	1	10840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjChi35Tqd6cgj9qdVGAZycBG8y4CioGYXY9ehE6MVNM3dMdXz
25832	payment	1397	1397	1678	1	1	10841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6ceNmLD8swH7HL2Bi1gPkkDLS6BDqe2p9wp8Fkri5pjx4kci
25833	payment	1397	1397	1678	1	1	10842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXVhLzkPywH7TwXeDVTjPEQ9eUDyFP5oKzAGAvExpCmoCGn6D
25834	payment	1397	1397	1678	1	1	10843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykWHME8bViN2WQoeAujLoNCkCoHVi4x7rTDqqGPRXyizqyQVG
25835	payment	1397	1397	1678	1	1	10844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNy5ChhC8S7opJrtKSvRt1JBm4MdYteBviNtXfb747Hqq4aFd
25836	payment	2134	2134	1874	1	1	1892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdcTY8b8Sei12KLVTSSxZ8XAb6c1wPXoLxssF5Gt31ESq4iez
25837	payment	2132	2132	1874	1	1	495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5J1HXLXm9NBywRLyM2QGqjKJgv3hFnP8qnEDsnZthtZuKnsE
25838	payment	2134	2134	1874	1	1	1893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXyDmxsGutqqdHTWjwavDVhEukR6J49cbUjoKYtVw7kdghrA2
25839	payment	2134	2134	1874	1	1	1894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuhnGyxyV41SxUguFkNLFURW9LLuVS4W8UH4WrRyvbm5QREXj
25840	payment	2134	2134	1874	1	1	1895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yvYf12M4cKvpuCDxrJNB9NbK1FeYJZsgZP1mRRjTL9EhVXbc
25841	payment	2134	2134	1874	1	1	1896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGN79ibk88SN6hT4u76jUn3yvMBMiT8w3sfuQ1KSsaxPMxda3
25890	payment	1397	1397	1678	1	1	10865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEcSAwxGUHa38JcLKwb8vuybt1Snr6G3o192XacxHDHiHX8oD
25915	payment	1397	1397	1678	1	1	10876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT4yKNFfeLi7ZPBYfTouQTaxGdj7Emjs6bMd5DF8tkmRmpgjY
25916	payment	2134	2134	1874	1	1	1927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMbq5hAPpGPwZ5sGN6QQVe2TRKUfuY5jasUqAPQ8nW5KWiYvg
25929	payment	1397	1397	1678	1	1	10881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5qR533AUaRmNnvFaEMke8BH8vPMMV7779YUAjmG2zTYHL3K8
25930	payment	2134	2134	1874	1	1	1932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFn16YLdS35TYXmSYW7ynKsoHHBT4kqD1iqXRLt5P6LByfpw5Q
25958	payment	1397	1397	1678	1	1	10893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TkMitjUHTB9R3WDZ3WcKNBao44wfkVTKvhebnnZRE6UDDF4T
25959	payment	112	112	1821	1	1	5	83000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHcDwjo5DVtnqKkSH9qfxtKy5Wz1di57Jz16PQXtQaHBjQRVh
25960	payment	2134	2134	1874	1	1	1944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XsRJksHYL3QEQDaenuh2xbHp8wzbMzzhui7PmzhaxPMPgQPj
25961	payment	112	112	1821	1	1	6	1904000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwHzrJzLtkuNeMWXb6pWka1pFo5Hyyj9L1akts76L9nvVKesv
25976	payment	1397	1397	1678	1	1	10900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLK8hfHjewfNeGEJS2fHK1Zv9hNMyhQsGrRKWkc9o2FwGmGh8e
25977	payment	1397	1397	1678	1	1	10901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5MgZysDohcJvJ8zijPBanTRRy76SDuAy3PXthEsJMHkqGHTw
25978	payment	2134	2134	1874	1	1	1951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQmf2kfeNoEPCC13NkZxSKmkBDceszPGShZevPvZ25ocDT7Kb
25979	payment	2134	2134	1874	1	1	1952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRtryq4sQZFy2XmLdWaqshb11iuVsr1LYnngLbf2ZKZvJEzoX
25980	payment	2132	2132	1874	1	1	512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXsnLUZNn3foaC6DBg8hadZrM9sWCcTsi3vCCfoGmapiEoxGSn
25985	payment	1726	1726	2198	1	1	8207	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYk2jE98DQHnKecSAxJd4iCPgMmLovPrDJV416n3iKgXB6v1vwh
25986	payment	1397	1397	1678	1	1	10904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf5v4ZnFxEM3PoHzvwtNuQYQfS2tUNdx9vnctjGCDnjndfmv8
25987	payment	2132	2132	1874	1	1	513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYRtm9BaWiJadQhnM8nXLajchmTZknwkbVJuUs4tSATCCYdER
25988	payment	2134	2134	1874	1	1	1955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmrcA3mJrskxELpNEgdaTZjbhw2tePKKJCG71Zpoks1xrp99U
25989	payment	1397	1397	1678	1	1	10905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHMRYrvVjj1crdwNzLQxmpGu1hrEat1fTNt9A7yKT34szhgS4
25990	payment	2134	2134	1874	1	1	1956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW8hGED68195gPymaP8wLDAQRb2fFre8qjN9XaeKZJ2PbxBHD
25996	payment	1397	1397	1678	1	1	10908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55dfrupda42NPLxc9avzo2ATMtSBKBLrQKbFustt2bGrps9qC
25997	payment	849	849	2152	1	1	2	5000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXZUPq8BbTyQLvFW3wShZpqCBZM2EB438gahTuahki743suje
25825	payment	1474	1474	2194	1	1	18	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5k9bsYYmnS7dztAYkWFs4AUrweyM8QixxQtzvZg9En5zunWW
25826	payment	1474	1474	2195	1	1	19	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhs8PUB45hGDPHuY5TpY7L3jZ1tqzY3x31XnmUtPEovv3CbfW1
25827	payment	2134	2134	1874	1	1	1890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdTADeA1bJxY3wTqJQ8Ndrhy8oMvChWzzAzXyTN9sgDjYRiD7
25842	payment	1397	1397	1678	1	1	10845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDHBy13HEL2U6jEhb9x5CDYqDzp6adfmZBmG1ot2r3my6jL3H
25843	payment	1932	1932	2196	1	1	2	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvXeuDau2UEZiVPmZMgY9AqABAAjD8ZA3PsHKzrtmx7uK3wCL
25844	payment	1397	1397	1678	1	1	10846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdktP3ecQDBYcdqg2tDoLWEMfxvbSkj7RGffTLEmbUQxHxt4hw
25845	payment	2134	2134	1874	1	1	1897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNPEXBGzFvuQ1yEYzTgyRUZjiRtKhpQcyRp6E1ATKb78mssP1
25846	payment	2134	2134	1874	1	1	1898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYv6MvN5FpBEW8svv6PQKA4CWCD8RpRx11zKBUSqmT9FZwFt62
25847	payment	2132	2132	1874	1	1	496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ip4eDRCCYMZds5V9kPSFdF8saQFfbWF8kiEsqbTq14TRAqh
25853	payment	1397	1397	1678	1	1	10849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNs4CYGyu22UkBAynum9HsRq4cRpaY8JKKQFiSRBHvbz8V2jic
25854	payment	1397	1397	1678	1	1	10850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1qP1nM9sRBFWuC4emZJGQncu9bGCgqG5RHPX3rLadLd8Wfp9
25855	payment	2132	2132	1874	1	1	497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zr4NqYxoeXcVuKnwEDCY1PtJ1M9GujU85tAWiYuyDTE5gabn
25856	payment	2134	2134	1874	1	1	1901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Uq1oKiUgCUe4F4HN5kTGah3CbozSkEvMfmBDBNzr4U2MvWxa
25857	payment	2134	2134	1874	1	1	1902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxSbvqnxRwo4imfugr2KcfkJw9DLwDJYUmuRP1eaDrKFz1AJw
25865	payment	1397	1397	1678	1	1	10854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UCqFVrtNd7izU4CwqqEkzEgKH85Eird1E1n5ggmmwHds1FKu
25866	payment	1397	1397	1678	1	1	10855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDXLbV32yD1YoiQ9yC6VNgN2fYjyBWyngpBaCtu98UxAWqYKF8
25867	payment	2134	2134	1874	1	1	1906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5r6jrfj3kmNrHsvdP5mUjLxz3pswWnejZPtKPQnm3p3U2dw6
25868	payment	2134	2134	1874	1	1	1907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnTd8HZjnfiJ8kAVw5i1o7zLg8yExpsxrMudyDnrPj4t2S7rd
25874	payment	1397	1397	1678	1	1	10858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1kuysi9DegqTVTx5T4ZPCemSZxcnCUcv5CSd6rYaeJJKED8Z
25875	payment	2134	2134	1874	1	1	1910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6wJCCpQ5KcZVfYq3BvXVwGMpxLNUJ32JyeJ7LT1yu9qSpdYM
25891	payment	1397	1397	1678	1	1	10866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfJYZJuPaQc3JnkSjapRyZikyqUQVB9FEBMMXHs97cKvuuXWR
25892	payment	1397	1397	1678	1	1	10867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmF1Bz99wmkeMTZvCKuud4j3A9Z9cMCYCdefLKWxeLzwekY7rP
25893	payment	1397	1397	1678	1	1	10868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2fydCnvLTuykzerg4tjcFuqiaNJbAkCGXicV39oZTdMfimi3
25894	payment	1397	1397	1678	1	1	10869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTbuymL2PeS6Gq8UvBkEUnj6Wj1DvyvG9JvzQwzrQhFUje7Hd
25895	payment	2132	2132	1874	1	1	502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVZdXpahb7oJjWW6nA1NrGnTGkiQxDbWVApsmzGC1vevwExMk
25896	payment	2134	2134	1874	1	1	1917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T34eJmMWsE9VZHj6nC2hZJc7yCGamEk4Uo8HgagCxAqNXMf7
25897	delegation	2190	2190	1597	1	1	1	\N	1000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	CkpaA6L5oBbNubcKogesa7w9uoxJau1Rrt6cDUSjS787UqgypoZLH
25898	payment	2134	2134	1874	1	1	1918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgagcur7kodpsK5ncxqiSTycvAnvnRuPRZsCJfeLGLjkujvqe
25899	payment	2134	2134	1874	1	1	1919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApDgH8oLBEvW23L5f8PtpThFPrAXLWBqf1jrzskHyfQmsZUYv
25900	payment	2134	2134	1874	1	1	1920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXXLD5AiuBziDVPkpzzNkm1nRd4asmybxM3hRyivxiwHvNgqd
25901	payment	1397	1397	1678	1	1	10870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN8vs9SAhRE4nXbS5mwPw2Cz6ZGJHJWJBqLcYhN6hGMgFbJqU
25902	payment	2134	2134	1874	1	1	1921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQdrzbSxhBoKmvMqiFYCaqgr8qkBdJkWXVFYLefWAY18oUVdV
25903	payment	2132	2132	1874	1	1	503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5DNsCgcZkkx6PQZZx626XsnqBgDurs5Njj8SPq8voDYap4F7
25911	payment	1397	1397	1678	1	1	10874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxPyhBs3CVKTrG1siSdXXUE31oATMqakQvQoWCUwiv3tB5bgv
25912	payment	1397	1397	1678	1	1	10875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLZ16E7bMcYm4BuZXArR1ULCKD1gP2bRZK4SR7BSV1L7GZJRo
25913	payment	2134	2134	1874	1	1	1925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXcpcp64SYK6VJckiakMmkpWRFPSeJD8i5Kri7c77wzu1jz7u
25914	payment	2134	2134	1874	1	1	1926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHLrTLKPZbnzLVa9DAUz1qB6d4wHPqjB2umRf2bqYoThfneft
25931	payment	1397	1397	1678	1	1	10882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPXMKv5ETR7HrNhS2eWJfjGesHAUQoAfm8m7HAZ8bNFphQz4w
25882	payment	2134	2134	1874	1	1	1912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQQWQsvGK7M354HW7gKzcmch9Q5NkhPG2AirNdN9j5hjFSsKF
25883	payment	2134	2134	1874	1	1	1913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXiiL2cVCh3NbrrgjCFu9gUC882n1xXuXcfemD7X5gZKEkVBj
25884	payment	2134	2134	1874	1	1	1914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfN9MY2ij8U6WK5d4B9uWbhYMa6BUWVMZf2VvttZoGm26MGid
25904	payment	1397	1397	1678	1	1	10871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FRU7p5vUicUg8cWdLmah1jD5mqzmVjXvn1TVBYpVGifs1Pau
25905	payment	2134	2134	1874	1	1	1922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeWcTf1vVvc42QKoz2r4q9kVYGziRPLUMj1r2h39hd7unSbKG
25920	payment	1397	1397	1678	1	1	10878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVddynK1H5yDFUi9DUqXbUpCuggb6ydqABZ9JvxKzgc9AWqLYV
25921	payment	1397	1397	1678	1	1	10879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekHyDpaaUnHBnKDEvQ4DmJ1uFDRa5FGvNzTnjXSLsFYKq3HKS
25922	payment	1726	1726	2157	1	1	8205	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFWoVMV2DLS5AktxWy8RCLhawkxVCjo38c28HCu6hiDZMuTd18
25923	payment	1726	1726	2197	1	1	8206	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYidusLngXUWyCu4R9sKs47TRtC5wUmL1kV3oWxNDTk5HgFwbCR
25924	payment	2134	2134	1874	1	1	1929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNDxSn2ZE9DcQhgEvdXzJftygLK6AT5eKKexPNbupvb5oYJpq
25925	payment	2134	2134	1874	1	1	1930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKdA7mRce7ZKYyNtfu72B46MTfv3DmSKb4wcLSuU9Xf77tGkMK
25938	payment	1397	1397	1678	1	1	10885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3bsxBTTUH1qvLkp6v1hbdfWQ9nBpD8uf523v3LffvKCKqihD
25939	payment	1397	1397	1678	1	1	10886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1njUrk4WzNfN6sqKGGBPGrFEmiqRvYk24V4KwH6e6mxRiDe5K
25940	payment	2134	2134	1874	1	1	1936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSa1nCefYJ5dagJEXvkNexpdyRdw67qy5A7EQNdj223CZ25oUo
25941	payment	2134	2134	1874	1	1	1937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82yrjAR2DfKndr8gAoPvY812PunPvQcjykQmLE87jPju4qA6i
25949	payment	1397	1397	1678	1	1	10890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjU73JRb5VY5ZQmtDvPPNHYHCU1ZXEBryxdKQBxuHtn2Qx338P
25950	payment	2132	2132	1874	1	1	509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYparWGuAwWrLAktR2oAy9hgCUufXbo6M8t21YowSniNybxoXfC
25951	payment	1821	1821	756	1	1	1	500000000	1000000	\N	E4YtmZXB3QjBG7X5diSUBKkxjUPwbMS4YQACmYfGSqLvf4dtsQfpE	CkpZxeKZU8LurLU4bDntKjM9asCpPrHqr378B4KNwb4K3zyYf3CsS
25952	payment	2134	2134	1874	1	1	1941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9D8spi8qEqajfrLQUrEEXs4GoGoM2RHRbshdmqvXfz1gWPb5
25965	payment	1397	1397	1678	1	1	10895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgFFX4G92tuoBvBGdYQpLaJGezidPLVp5fkPjaFZqVxjNair7
25966	payment	2134	2134	1874	1	1	1946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw9faffK9HYkQbtiK7sDVNvUeEWAkvMzcteaLNkXsntrcjjGC
25981	payment	1397	1397	1678	1	1	10902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyERrfYAViCo1NnzuKpr7PK3AyNLxAwLNyo81ZVMtYe7im4mW
25982	payment	2134	2134	1874	1	1	1953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgq3oaXiyvvNt6VZbp8dMCQPCkajvMrCiUU2KjZpvNbhF6F1m
26039	payment	1397	1397	1678	1	1	10925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoYymdqbd4F39gCJKhuxqxysMfmQkEHhVVm6zHz7rHhFVAQym
26040	payment	2134	2134	1874	1	1	1977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaV5s3bUmU5rnXfiKYxY7nR7TC8tMcMUTnUj3kHyXMsWKYFbSP
26065	payment	1397	1397	1678	1	1	10936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ExB5Ckm1R7Ffb482pS14t2eyJY3EnkVfY1qChs5jnGB2Ba6U
26066	payment	1397	1397	1678	1	1	10937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJSnm6c5WA5fsqLtPQxKYDEAaDv31tc9wM1ZsGYN8hhmihtVt
26067	payment	2134	2134	1874	1	1	1988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9LcqJQjcNwVyuonUpc3kMvQpTkxKQzipni5aab72FzQyJXBt
26068	payment	2134	2134	1874	1	1	1989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7yQXSyW9TQQCtHvgvFHktL52YsQbVQZhCqxDmWJychqpqnmE
26069	payment	2132	2132	1874	1	1	523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSpVRodAKquzjnWNkVSPipshe914wtWfrfeYkjAYvXAt6UNRq
26070	payment	1397	1397	1678	1	1	10938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzh5UrxYgaWT5oMJTV1FjCCcfq3WjKsY7iBhJKuyW2cskgkZ53
26071	payment	2134	2134	1874	1	1	1990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAWejPaEncDVxm6vNCwCCbNCs2a7Z6WT93jcvWzQVHSdn2Jws
26077	payment	1397	1397	1678	1	1	10941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPsz3d7F3wpd972Fu3oM8Xdeh9aYgTFFdWmmsVXDJ2D1pqANJ
26078	payment	2134	2134	1874	1	1	1993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEQQMFERZkUMzJfVH7fNucDwTK6ipGk2VUJriVDhrUSg7Cd9k
26085	payment	1397	1397	1678	1	1	10946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrJxq6sA3j7L9sgWbG25EsSpXNhPb7u3uEsFuYCLvQqDYpoBM
26090	payment	1397	1397	1678	1	1	10950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYotq92ZeBe2n9UfbicE69VTRWaqNgSoyt5K6nvMVTjFCCzDWJ
26091	payment	2132	2132	1874	1	1	527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35fGhAKzK4AYUjvLUNzQ3EY3eaEu3XQQ7cMHk96geLNTrAtWc
26101	payment	1397	1397	1678	1	1	10958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoY9vZdzqP5W5gnv6EQuEspjV71AQFymnSBdpPGeUjZRJCHMk
25887	payment	2134	2134	1874	1	1	1915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMrbvrUrcvcMQYujaaGG22BV5mQK7WX1CR9ybkwqX2BXafDCf
25888	payment	2134	2134	1874	1	1	1916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WLJNpH4TkRT5PqKoYLnvrakRFCMwHxxMXZ8YSvAY8PrBmp8E
25889	payment	2132	2132	1874	1	1	501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzozWkwvihfGwEr7A2bafY4fejvBtTxCc5zWbNVTXNZYnuRTth
25906	payment	1397	1397	1678	1	1	10872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLgt23nphUrC5e8NtNwjDY65gS4P9uRd45oGCHxygeZ7n5bUh
25907	payment	2134	2134	1874	1	1	1923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVLCFADDds4Jjq3YwJrWVK3h7wszhkBpSQhVTgattvpcQFWHu
25908	payment	1397	1397	1678	1	1	10873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRYnanzuYK1WAyLPdUEB2gjh3BXjr7eLPEdhp69HgrGP7AZSS
25909	payment	2134	2134	1874	1	1	1924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwerhS4MaYd2uPVn4EPHPY8UF2zUrTYqhQGa1sQ5WftCbvh5HH
25910	payment	2132	2132	1874	1	1	504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3uNuvQC4gGsGhvC8dEG7rXgpAEPDC7dFazu65E73ZWcRc2QK
25917	payment	1397	1397	1678	1	1	10877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwDS7Vdz717hz7L33nbTUcTwxAm2LBYftqSeZQ6nDcbDGjZv9
25918	payment	2132	2132	1874	1	1	505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzBqvMK1axsZBm9XErG6hpxb8XHjjvceAqk7dcbhSMgX7fhDB
25919	payment	2134	2134	1874	1	1	1928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bC4WDQh9vkTG2ts7SQGcPeXhrt91cgwt3FN1BoJw6XGEYQBA
25926	payment	1397	1397	1678	1	1	10880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpiFCh8EEpZeMtz3dbfSgF39LnD18HorhkL6FUe3eJSabSx7N
25927	payment	2134	2134	1874	1	1	1931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM6HLsDwuvpwy8HR2VnBKtY7Uswxtj9s8zCM5bBhErKHbrHBE
25928	payment	2132	2132	1874	1	1	506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ScjrM63A91Ab8HD8rDM98XELrXuZwWW816JnXJoRJHB3DXrd
25933	payment	1397	1397	1678	1	1	10883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGc7VqrGAWbXWrWGHniH9BwBa9RJQVR6wqqpqyquJ2UmJ68Uw
25934	payment	1397	1397	1678	1	1	10884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3uq82eYmKZnkfxDfBsFvddLa9KGPitfKTdpivFc9Fu5Jr5KD
25935	payment	2132	2132	1874	1	1	507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxf5b72uCuKb82urbg5D8giwJWZqCmFiEJhbpoWMPC8yfpAuvu
25936	payment	2134	2134	1874	1	1	1934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rLFaGZA8FWUByRQp15ouLsno6ZfZ8VPnPuEH3cwGCPEYmr45
25937	payment	2134	2134	1874	1	1	1935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYog3S1MY723SMWT6ddW7drTUX81MqoFL2rT2m8XpmsUE21ZcSM
25942	payment	1397	1397	1678	1	1	10887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78493ZgHdYXnYWduaWCBVZ7vWqpzde2gPMRycpzPy2zUDzt2n
25943	payment	1397	1397	1678	1	1	10888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsSTuopFt95NwPKqU5EC2nSbt1YggdQAr6uL44sLTLP2FJitX
25944	payment	1397	1397	1678	1	1	10889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyhsneV1htEcNfw3P35rGMFDGePezjNFdYJeopvq3SA6JVgXm
25945	payment	2132	2132	1874	1	1	508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqiQAE2QVdB7tDAvGt6yTHJpkonYWY6BDWb5bavJ6xjknGbPr
25946	payment	2134	2134	1874	1	1	1938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85MmKyVpXCWEKxac7ioP4yxC7x5PatAFCajCCSPN3vXSAKwcH
25947	payment	2134	2134	1874	1	1	1939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqAPbmGeKyCh8wAa7Rpj6PWFzRQ7JVvzE5ZgnWjm7BPJuaxbS
25948	payment	2134	2134	1874	1	1	1940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HPtu4tiQhxtzMPKXEPGe5hTsGkB5a2MUQAhnWvwWpeB4NjFN
25953	payment	1397	1397	1678	1	1	10891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8t85RWCrTvT1yzvv4NR7WFYSQyjBLs2KxAztpBGnFaJ5rCfD
25954	payment	1397	1397	1678	1	1	10892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXDQ4emYUFjAdTqMLbwxYGB4pUFbydxN9L4kVevDCQbhG5zgk
25955	payment	266	266	2196	1	1	0	613000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPGrXRCNbhoFW7BZRhF3rUEtEkHN5hceJ4oeUAN9vLrNGbSEp
25956	payment	2134	2134	1874	1	1	1942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEe3tZhsHpT1tgPWBAvdBu3KLkVVDGpaBxaHRNuv3P8JdbyNV
25957	payment	2134	2134	1874	1	1	1943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtZ6nWjos9jpkRvt7BH3C9E1f3rCS5Pm2PUWGHBVPyYKJh2bK
25967	payment	1397	1397	1678	1	1	10896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQp2BSTRvWKzeksiqg3Pwgx5AKiwLHMrjtonEVpD3sU3TaeH15
25968	payment	2134	2134	1874	1	1	1947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmyKyZRyjocon9W4TFBdCr2bgH8FwAdT691FxCwVB75d4H8En
26019	payment	1397	1397	1678	1	1	10917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJkArdwPyo1AaVPgL4xt5A5qgJYfxdiUvf9teT2F5bdr1ahnB
26020	payment	2132	2132	1874	1	1	517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtW3p1dQowcucbDTyH9B47MLsgzvD5P8JfvNw2gxMPs48yrJQb
26021	payment	2134	2134	1874	1	1	1968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyH4RQDx6NW9R4TYWYi5xmNm7DFecqzwGnh4LwcCjEsKj9u6N
26047	payment	1397	1397	1678	1	1	10928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pzG5EMU1qwZ5WpWTxAF8Pt6kH7icf2sgqhuubuaH1HTDq62e
26048	payment	1397	1397	1678	1	1	10929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVHrYMEXcQtGmEUwjUHYet2BZJK2yyynX4iNaKtYcbr5eGNut
25932	payment	2134	2134	1874	1	1	1933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPCUR6ghUACYHCHxEyYs42yCEsCSNB8F7L9KBpYMtfkRyzRKH
25962	payment	1397	1397	1678	1	1	10894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesaireuN8eWvTH7VaMonWW7CHmKfYzLzQR6Dt4sP9L5ErRf5m
25963	payment	2134	2134	1874	1	1	1945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7psViWT2YzrsyWMH9QqxxNfoALuqPotcASmvHyvtrx48SRHfg
25964	payment	2132	2132	1874	1	1	510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCbBAYTgdVQbyZDAsQC6XReUpNWr7aU5AEsDfFrdoMUG1FXdV
25969	payment	1397	1397	1678	1	1	10897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmyUGZbuXJvt8KCPotTyb8cE2QmUmZrycaqcRhKLiaQBQqDJ7
25970	payment	1397	1397	1678	1	1	10898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cZ93QeWWgXRk76Z8ZzCXBuZ4Rq2pc4RkeRf9D95ANdjCf1gr
25971	payment	2134	2134	1874	1	1	1948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4HzkdGeL8uCWS2ZRHXZ3wfN7j6uhk9rADVsLSHW9d9JeiGiw
25972	payment	2134	2134	1874	1	1	1949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQdHdS8uyEba7HxBL4AoctBK8boJPAd3NsiH74Hrfug5jg54F
25973	payment	2132	2132	1874	1	1	511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjhmrR7htfbJzEgQLWxDwFRpRp5ptdjsRPZBCyC4fmJCQFmdC
25974	payment	1397	1397	1678	1	1	10899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMHJZ53bEZ4Xz3S5LggsiPuFHwU9XGX4rBfWZbqAvUKFCzyCL
25975	payment	2134	2134	1874	1	1	1950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPLrbB3xFVMdmBxV24CwLSpBXSmDTRdrtGQucd7UgraFdGJ8z
25983	payment	1397	1397	1678	1	1	10903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8TbpvvXzHUJsansokSeTMjuAXEjZ7tEfCVLx7uLPMV4sL2Tu
25984	payment	2134	2134	1874	1	1	1954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxVKEBfjV3dFATM4tmfwKuywYJNFAHxt8VcmnY9pcADZdHdtC
25991	payment	1397	1397	1678	1	1	10906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxeaFfDCUtMBy5ccACrFRoh9xhELfMK8LiE1qSyRVzeUopWZC
25992	payment	2134	2134	1874	1	1	1957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTfssCSUqKetZDWSWmhmWMkGhjnr6Y7cGGWRrykgREhWRAGte
25993	payment	1397	1397	1678	1	1	10907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4Zbn1ND7VXJaJGqB2LCLcMZV8m7y2c5PfGhJu3uRgx2bzjXo
25994	payment	2132	2132	1874	1	1	514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WdJmi9KRAHdwDT8xHYMjK7C1Uf4e3PSLFV16CJmbpMr4h3kt
25995	payment	2134	2134	1874	1	1	1958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9DJv2VrArpW4K3g58CcBxdb6VL4eYruFyd8MrM3c2bZosiwt
26002	payment	1397	1397	1678	1	1	10910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgTZkpoaXxH4W6NutezGsR4CDCy1xviH8W827wkPWxV9sSNGX
26003	payment	2134	2134	1874	1	1	1961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtP95BHXCxGCkNCAnhnxu78Ap7XEzqcmSoy22azVuqKbRsxDc8
26004	payment	1397	1397	1678	1	1	10911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme81yx4TGzPgyF1q92xzLs7NimqQpCYbXZ7QWhyArcQ1MBvYv
26005	payment	2132	2132	1874	1	1	515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9AzdkdUC34beACrrpG4nNpNV2DfVUwLdUA56CeWzUzDy4yxx
26006	payment	2134	2134	1874	1	1	1962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMeQP2c4TCdG4nDRpGTMQtY8AUYqKEg7s4wDUQMQGN6YZU9mb
26022	payment	1397	1397	1678	1	1	10918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJp12wTbAfM1GZj4JCPXchzYoNNU1VjEcqBsgHHwbrxJCapdNM
26023	payment	2134	2134	1874	1	1	1969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hqvH2NyZj7opoVNdnULXM9jnNCfhgT6UtonmDjqRgCK5DCxY
26027	payment	1397	1397	1678	1	1	10920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYio4AUfherQoq5AFdfpdm5vR4FTqQVTYsP4WvnUxxzDQa35pGk
26028	payment	1397	1397	1678	1	1	10921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZjjD44AEc16mgYHR9cRbeWEc6QkadDZAdFX74ZtrQ5KeVFSZ
26029	payment	2132	2132	1874	1	1	518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYge6TS8MWximTxeFDXdhGaiFrDbhavDskNy27cXmEia6Eax5
26030	payment	2134	2134	1874	1	1	1972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pYkobDCTiCpZrj9hSP6XtSu3tVwd31CcMm9nz6CQLCGMrvkQ
26031	payment	2134	2134	1874	1	1	1973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrghp4Cd5aK2DhL4iY9SSezK43X3GV3pgfRFjT5SMytSEtC7p
26032	payment	1397	1397	1678	1	1	10922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1w5kJLYLgBPArBsSRVWjdNPJuJ48jJrv6tK35LjVuMZnyw4y
26033	payment	2134	2134	1874	1	1	1974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcyGSxndnwsXLfDfSHHWpmMd4UHdPNhZoikzUdXkHh7g2KgSPS
26058	payment	1397	1397	1678	1	1	10933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG8gNxDvA76MoNEqgtjqx7oNr4GQt32eSMWmat7zdcqBPa4aw
26059	payment	2134	2134	1874	1	1	1985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8rnYZbkeYQKUBXxV1kv17gqFXfdiFB4T79Rj1bTwHDQq3379
26060	payment	2132	2132	1874	1	1	522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQM9AscU2Dearu2ecYV9dM7EjhZ33eC5CxY8wgjxongFJ1wwU
26061	payment	1397	1397	1678	1	1	10934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6aTurLaLcVvRaajtAbRcmuooMB88BH6vPv1pEGCHZvkAD9Lk
26062	payment	2134	2134	1874	1	1	1986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyL3CeoMUJ319gPr76QjYbzfPJXung8qaYsvvcFGsuhhkiCxf
26084	payment	1397	1397	1678	1	1	10945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6PiSmZpJFAEC6SzgzsGVMtVEASbiV5Cvohtv3EAgXoap56GA
25998	payment	2134	2134	1874	1	1	1959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzB5oEedfkQPzFAuf6Em57DLQYzopViZ65fGN5AhNe35oLsDdW
25999	payment	2198	2198	2198	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9A1WZFAPBrtqELSDWgaNa4kRn8aUbt9yYAKgfpEZ6qhWpYkN
26000	payment	1397	1397	1678	1	1	10909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQtDgBbhYkJqcBP4f9ns6gTadDeq7ZDnYHvYrECQohWR2fNQP
26001	payment	2134	2134	1874	1	1	1960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohntpT7Qzi37i52qeLqTd6j6P21V26QAsrEFsZKCdAgULKnR6
26007	payment	1397	1397	1678	1	1	10912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PMQtTaHLSD8xgA6LJUQHZCzDs88oFUUfiMhNZXeDRXGFTLKi
26008	payment	2134	2134	1874	1	1	1963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnbckYezF9zMsdi1SdVcmAopVh9rTy541QWAfRyRXMmQ1PCwv
26009	payment	1397	1397	1678	1	1	10913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HPCz7s7wVdAHLQqCRsg7bqHHT1HSAmrpk2e2X77fMThpDeaY
26010	payment	1397	1397	1678	1	1	10914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5DUvpxbrcHg73mxwQdd3KNQ7wGmJffmq9JLPoU1vrJbZhxJ
26011	payment	1397	1397	1678	1	1	10915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjxQPzU39vQCTRLkCp7e23xyABtgzvvLGrVzaoP6R5qFqu1po
26012	payment	1397	1397	1678	1	1	10916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJAg46exRMTiBbFQTEwbhZCG2zusKocLbaG94NWjrYYDg8NT7
26013	payment	850	850	2152	1	1	1	5232836900000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy8s7j7odJVjN48oTmXG95bhjgPF5e44cKnsgngPPcjW5uNyY
26014	payment	2132	2132	1874	1	1	516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gq7Pstv4Nmxo998BHmqshKByn65crgnNvHxTGHMGLBwBoy68
26015	payment	2134	2134	1874	1	1	1964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDbYdUuLxYM4ov4yWAWaubuZyHAtjYQBFew3pXDGnQK9EQZBw
26016	payment	2134	2134	1874	1	1	1965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qzHPeMWNqZq1QpNjNxMtew1yDETQrUkjXZJ39HyiahVXy4f1
26017	payment	2134	2134	1874	1	1	1966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7eP42AV5nMoc4uMfxm47GiMHAzawap5FBjjy8sbDLyNR5LEJ
26018	payment	2134	2134	1874	1	1	1967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfazTcPdazc7PvKdXdXnpKAfdw82DFuxDohxz4VWx6DhTZrpa4
26024	payment	1397	1397	1678	1	1	10919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZoLMuA2FJCwLYa2Ho54vZaU7fZYpRGmd6CLekpip8DVPsBND
26025	payment	2134	2134	1874	1	1	1970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbxQjwZcqTDS3Wi9u8pFJMKf1PyAMUH8ATyx1fps5CPEk8hCN
26026	payment	2134	2134	1874	1	1	1971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Tms7ayFNDKNeLvkStvvnKQoia3beyy7X5DVDpJj3EVqGF3XB
26034	payment	1397	1397	1678	1	1	10923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCwJpXWR8YH6ghc9F2By5CxbjG85YEzDPzTqdS6BPuDT5nGBw
26035	payment	1397	1397	1678	1	1	10924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxBxrEDkgJqKSTsHYh7V1XtWS6ZWhCYaLvNdQjfxzhiwwMZBN
26036	payment	2134	2134	1874	1	1	1975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa66dkWDj5ESUyVWLEfeB4u82hiY7bhdhDUr2TtJrVehVnnsKcF
26037	payment	2134	2134	1874	1	1	1976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNK9GrhbDELHKzuyceqMh6TBun25i96X61s3hiu3jXKah1trr
26038	payment	2132	2132	1874	1	1	519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH8UbANxCVcLevSDuWmf8SWWLPGhzy2Mqy9hoWhCEV56znR3z
26041	payment	504	504	266	1	1	0	3000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ73vAoMkSCuFfCSBfZ8GFmxU2kndWVpwqKaukwqd8GqtGGAt
26042	payment	1397	1397	1678	1	1	10926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfe75mkLycZgVdg1dkEv41wWd1zKGGuYx5GsU5dFbaWT3coEp2
26043	payment	1397	1397	1678	1	1	10927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbdDzWHfkpVRosj5SE8zrM1AaeFPAmeV8Qq13L3TjobkMGVYP
26044	payment	2134	2134	1874	1	1	1978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjkiv8Am8PNVvRYY1yv8kdZtuGbhB4upe2GXU5LDGhiELGGRw
26045	payment	2134	2134	1874	1	1	1979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmJ5EP5RRQQ8LbHfGEkRCrwYZAy6HseTodU845jSYZwc6GRMt
26046	payment	2132	2132	1874	1	1	520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBQzfvKdowWMcBMSdMrD9h1eUCXaY2tLnzuLQ1jN8Fmto9Msf
26063	payment	1397	1397	1678	1	1	10935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTz9LHKRu1rAN26BtSFo5gjLxHoxHKxVJbtJE5f65qFAZ116EA
26064	payment	2134	2134	1874	1	1	1987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBfjEukmJRG167JkWoKc6HFqy6mWhfSAzLGmhFzxfEA8BCWpn
26074	payment	1397	1397	1678	1	1	10940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oU14SPNGE9oZNoE5xy4bWeTgRVjGhLXzXTwjeAu3kjMZw8J2
26075	payment	2132	2132	1874	1	1	524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNr7vjMAtpDa24Qx5SiKisUQVJDF96gCFkXX5ZpHGabWi2EtA
26076	payment	2134	2134	1874	1	1	1992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwErYHvUkg1hahFoyzCEFE9Hwkci83SjJr6CV8HTUsDTJnM5V
26086	payment	1397	1397	1678	1	1	10947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxCqzq8W5crT47kzweHxy9V5pxtMrb3CoqrM9TDDX3MBGncnT
26087	payment	2132	2132	1874	1	1	526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6wUcCEf5bWfgDnXxwX3Fag3HHBetkLjnbojs7QC77HJiWwtL
26088	payment	1397	1397	1678	1	1	10948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsCQMYkvdc1N4wFdr6ghkNDLiuVq99YmZydfqAnQkeAS5svEq
26049	payment	1397	1397	1678	1	1	10930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M5CeVkdadSqgGpeyiDL2iNaY6nRufu2NizdrqY7nsWot1obh
26050	payment	1397	1397	1678	1	1	10931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MGVCSNusmuNJtRtePqDuEYuWpk3Zi5X1KoZyu2z4m4ou7npJ
26051	payment	1397	1397	1678	1	1	10932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwBmxfrSsThSnB13nnQcqcAexnZbQZzx3VMyJyTXESKDuKTw8
26052	payment	2132	2132	1874	1	1	521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ4iC3PAuXdkxqa4y7m77pQSQniMmaVX5CqjGyLQcm46DRVjF
26053	payment	2134	2134	1874	1	1	1980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPjrkJ9DQdoerqfTNX8rAThNVb14K2qQ2pBP4vtZkYYS5YvN1
26054	payment	2134	2134	1874	1	1	1981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bFFN3S3ioGZrsZqpGYBCBtrBDPspR8MAbnFxmcAYBrFckDzM
26055	payment	2134	2134	1874	1	1	1982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTv2fzxgcuVg22cu3XmUYRZTpt5WZ6fmJReqsUgbwDY9ih5tA
26056	payment	2134	2134	1874	1	1	1983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7X9HXZZeketzDHuRMmpQQWwYp1yjgcPWuACEBkKYevvarPis
26057	payment	2134	2134	1874	1	1	1984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4844BFi7kXfxhat8qcmtVQt5SiWd8ijtzUWWR8TdhmpVtWcp
26072	payment	1397	1397	1678	1	1	10939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfrrSzJYaAJZmMVrry1XjvuJnGYfhCLJZ2zohU8owakwaqkUJ
26073	payment	2134	2134	1874	1	1	1991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9aUv8WxnwnpuX89ai9EmpJdLKp8f7j6uXVsHAytMqHamzjm2
26079	payment	1397	1397	1678	1	1	10942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbrWuTRBbxSV4ZHgNkAMbodGRWMVSk1WQQLotTnChYj993u5E
26080	payment	1397	1397	1678	1	1	10943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3BC2tkTL9x6fwwPAYrrBNw4e9H7gZvoya2jCAD2HJH6eWnu7
26081	payment	1397	1397	1678	1	1	10944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oNqdNxfpi5Epfq7Svd6asqVGkPNZBDQpVwfuTjens9AFHAby
26082	payment	2134	2134	1874	1	1	1994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffeNnVpWhLSXwJk2GTnjsC5cMnsFgod2F5ucPJENhWNXfrmzd
26083	payment	2132	2132	1874	1	1	525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiTosGxvbpFkraoF6zs7LNUCHfBNxDNYQY2omQGvLokYFteNK
26092	payment	1397	1397	1678	1	1	10951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbW61pDVKDxaSRWAefC2foLWmNj3iGRjnK4FEYihqmP47n4xE
26098	payment	1397	1397	1678	1	1	10956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvLCeRMmP9do5kkKSEmnnHnfDPwT7WuRf4oqfwy6Hy1veWHsW
26102	payment	1397	1397	1678	1	1	10959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg47gd8BzFT2PMCxp76w6NETXKDiwDuFtXQtJFSeAa14s4VYvE
26107	payment	1397	1397	1678	1	1	10963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGUboxqE2Q3VvNPkG8ZnRbQQCvWGwcrVbwrDBB9LrhpeANnfK
26108	payment	2132	2132	1874	1	1	531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrRLPkDy25T7j7q7BbxewLPY1vUrjd6zZBDEeJ99PNk2w24Wm
26114	payment	1397	1397	1678	1	1	10968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZAXfBdLeLc5yyU8EJtMTqLiDeX4eP6GjxNNa3cmDYU2695MW
26118	payment	1397	1397	1678	1	1	10971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitSs7U9CfTU45F9LfBaznhUSzKry3vk22DrdBrb1kdSMSDsqM
26132	payment	1397	1397	1678	1	1	10982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaisEDMEdEdaTcWuomMQBzE8Q7xthnVBPHhXYU4BhxC4ut2mXk
26133	payment	2132	2132	1874	1	1	537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBQS4bdkrBzTQbUn9F5agtALyiTzwVgRKWRKANYpyja1govmr
26137	payment	1397	1397	1678	1	1	10986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdMGpNvwknkvbpNvbs6rCNJAKEKuPbJtZkeaM7s9gNpAFAV9q
26138	payment	2132	2132	1874	1	1	538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUTN31EodsJbSKZ6SkFkLAQ71SrygWxE6fo6CpmQXkiVtpN5C
26143	payment	1397	1397	1678	1	1	10990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnntfD2AyH2bCmZSpzaPZiwBNwrdMG6YujoPpijmhW9Ntdpf8T
26148	payment	1397	1397	1678	1	1	10994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwAhjZKEzRjGoRse7R3J3zV6XadDMVnQoySxAGM1v4wkerVKV
26157	payment	1397	1397	1678	1	1	11001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AXFPC9PfiLy3tjaekHzYzBbXwwCZ6nSVZv7KBNcXTJeqFvpC
26158	payment	1397	1397	1678	1	1	11002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmimDfeERszTEqTMyt7QGetS2GaqHiha3yQeFLSsbgrpbV8Qu
26159	payment	2132	2132	1874	1	1	543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNQgXeb97gqRJhdhs6KxpPVXbvc7MeGxr3SRv8JxTPDRXgiAt
26169	payment	1397	1397	1678	1	1	11010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy52MbVkXYXyYqU4wSwfnTCpstjWrNnBecqmMy9K5pd212Qgq6
26180	payment	1397	1397	1678	1	1	11019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRNdMP4qBNLCFhLBGWV9mVNgbUNx91g7iQAc3KjZf8G6zPufQ
26181	payment	2132	2132	1874	1	1	548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3FjMS8gyhgzg2QakzVvmCvdGgscd1o55v7izKi2sQu3z7P1Q
26184	payment	1397	1397	1678	1	1	11022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5hoXa7VVKMHGikySBsJks4uabkL1QiobMPmUYF3LbzfWhUWX
26185	payment	2132	2132	1874	1	1	549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmDetTh2XC8ghLL1qTa244KRWQnbYgKm2UGkxHGpMUCMPqc56
26189	payment	1397	1397	1678	1	1	11026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZzqxB6obhHJnfrKZixRbGWt7NUjz2psFNv1Gh8yrFVy5Uqpr
26089	payment	1397	1397	1678	1	1	10949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnGa2XEcapXaqRC6By483LyL7bMfmA2gPeysCLhd9G5jhWg9W
26094	payment	1397	1397	1678	1	1	10953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgS5FpM9vP9dfKmA9TmCXETNyvqKhq8y6DkqcGErCVmbGSWqV
26095	payment	1397	1397	1678	1	1	10954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr6eMXs7sQ7jmr1JAb6tVHX4F3zzyeBgkyv8kcELuZfyJuKqa1
26096	payment	2132	2132	1874	1	1	528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjymDV5k4oki3vpZ9YSLftPB5cfqHUhPFiZBE28EYV3Z2nYpB
26099	payment	1397	1397	1678	1	1	10957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVdBwgpFFCCMBYHxW3VM2avxVVWqaWAmcuVBGNYJXdhAmc9Lk
26100	payment	2132	2132	1874	1	1	529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtST692bnbksjFNkTmfgAnd15pRNHdtMkEXajwUjf4kCHg6eKy
26106	payment	1397	1397	1678	1	1	10962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ91yrf4KSgGqymzu1eM1iu6jpFoTTkW2MgeytcZBK19sP69qX
26109	payment	1397	1397	1678	1	1	10964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4XsrEqbgCmfEScUyyRJVXKFrEZ95S2C9tnDQUwEez7Bs4BBk
26110	payment	1397	1397	1678	1	1	10965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF29bCe4yqc4ULT9RCnT2UK16bmocVBg5ATJVt3WtikVzmtmpE
26115	payment	1397	1397	1678	1	1	10969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGS1WsNFXkvHBnJuvFFiN7fe62ppueXCJdjwqNBtpa3Djys6CB
26116	payment	1397	1397	1678	1	1	10970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJaRwVpZxonnoeVyofaAE5P4TcVHUr9gy8gDyd5r6CLgVeejK
26117	payment	2132	2132	1874	1	1	533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZ4E93ZUE3qLG4uvvTT8JLicWFUdfpiAN5cZVJwS4S8c8onYF
26122	payment	1397	1397	1678	1	1	10974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XQe8bcCauBGVUPHCvV3N4PzwKZKBJY4QoST6TkE5LW8tpoPr
26127	payment	1397	1397	1678	1	1	10978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSW4DEsiRUEhP2CXzYasUFXvWKJuQ6UcY8kkBokxztQLNfzKt
26129	payment	1397	1397	1678	1	1	10980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Xt3H21H8KeruTVCF4goieTbSaaiTpJqAC2HPRpjpjNzPaigs
26130	payment	1397	1397	1678	1	1	10981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAphua3BGHmpUm3H3JDkNF7offRcSGh6v2TDmtWgN4kKWRMDgT
26131	payment	2132	2132	1874	1	1	536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8yXRgGtcHD7kyiMHdXbhopgcqfxqQscSzLAWn8pUL65mdhk5
26152	payment	1397	1397	1678	1	1	10997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUX3QKYDhETVbhrhqncesJbxuDomdWGq8KMWPEtTLFoXxBZep
26167	payment	1397	1397	1678	1	1	11009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWXbAi3r27tfDmXFHUtgwMTWZDsWAXQQsKzoXzLuhzpPE7yjf
26168	payment	2132	2132	1874	1	1	545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bZ1usEzjJEAXJbBQ2idJD6kqnZDit7kwH843Bu72LhX8bJw7
26174	payment	1397	1397	1678	1	1	11014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGsRg4AWLz5AddgGVDcDt5VuzjZxx9Ri5B36bD7E5FsGALAZb
26175	payment	1397	1397	1678	1	1	11015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sEMRLxsgQDUf7Xw6cB9gQGwt78zQoZC6Mnz8vS1qPPd1vodC
26176	payment	1397	1397	1678	1	1	11016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87zcTx7RHEbPDLiqhCdjBdjZZ7kZBJ66ASJnwh1ky2hi8B3qK
26177	payment	1397	1397	1678	1	1	11017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSHA24145Emh1ATnMhFTwWsc2Xi4jiZnZf8iHJjRDpKvdMtKC
26178	payment	2132	2132	1874	1	1	547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAHttRdWzB3zY4g5GFhGN3nZ1D9fS12b5Jc9XzbH1htCp7JW6
26182	payment	1397	1397	1678	1	1	11020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFixps5akkCCeDb7KurVFGotnvS9t7kZcEoS99c1btDcq2JK4
26183	payment	1397	1397	1678	1	1	11021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoTMZ9sCdMmwqcD4sMuqd9bGJ3DsNd4Xcw4iktpYtSmGDDgUF
26192	payment	1397	1397	1678	1	1	11028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFdm9LJbarTxQJvjzJY1AwbpfEfBqAzKcCsP1RtDXbGihxK36
26197	payment	1397	1397	1678	1	1	11032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQL72BC9iy2hVoQrHQdLU4TuNReEw4sRQerM8aE6ogxebtRyb
26198	payment	2132	2132	1874	1	1	552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwap5sCm5g6opkJUdhCMz5nC37jMSGYAysQJhZRBy8s79bjwMA
26202	payment	1397	1397	1678	1	1	11036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkgHtHwz12kTcurAoEFiJaejAAe7TudjgdRZLtoD4TuAS1Yk3
26203	payment	2132	2132	1874	1	1	553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mu8T5sy2CzCrAToxZ8rHE5RoksESPciGPtsGS4UShrejNwic
26204	payment	1397	1397	1678	1	1	11037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6iavHpRCG2mnYjMjUZrnExhQAWMkhjZhuUjw7BQMAc5zxs3M
26205	payment	1397	1397	1678	1	1	11038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrepTpsHvQcsTpdToVavwbcPH2bTGvKXfJGHdoxyNBmzUZDcYK
26206	payment	1397	1397	1678	1	1	11039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8LXfoSSKiptkWtNpGVmKUBdSfE3v9eybv8D3nfzQZapmYHty
26207	payment	1397	1397	1678	1	1	11040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBkSsAhbPVbRubfPFXVGw3tJJLvcrYnMhhti9AvfGBJgUHHwr
26208	payment	2132	2132	1874	1	1	554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY56ekk13uzkFqPZp1Ug5DNpKzoU3cpxmqNGjUhvG6ZnYXxJng
26209	payment	1474	1474	2200	1	1	20	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfMCfNbYpvz2TMu5bPp9c21hERadhJRKiAf6ERHUkEF6ywBHU
26093	payment	1397	1397	1678	1	1	10952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iLSQSX4AHXsxAQNiowHFfK2ZAevbshFhNDwhygyAR9kG2JyG
26097	payment	1397	1397	1678	1	1	10955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoQvDmPzz6N1oWr9ovekW2NRxskjkwdTU7qUMdSLTtcc6wTg1
26111	payment	1397	1397	1678	1	1	10966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH66E5aHHkizbbqJSpJ3d6AyLPx5xY2TSGQVUYxYtZMLF1KXWo
26112	payment	1397	1397	1678	1	1	10967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXUfWGERG4zpRgmB8jTnaya4fTumGboLDXjoaNtX7QSSwuPBk
26113	payment	2132	2132	1874	1	1	532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXctHBL98RUSCssxLEcYCFugEigYrL5McKy5mB1wXTtnoJGRdH
26119	payment	1397	1397	1678	1	1	10972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EUwi53nff5QCDEdx1AnnEndNeFV3XBZXdDrg7mfgJPYypSqy
26123	payment	1397	1397	1678	1	1	10975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrjNes9tYZ1zpcM5j2YvdBZj4FvNjHc84iZQxR5BmenyktPJH
26124	payment	1397	1397	1678	1	1	10976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeHCxFaqvShn21fT1oFAzYbL9peZHHzqf4T4w1zbe1Gzz4Dfh
26128	payment	1397	1397	1678	1	1	10979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mmyczCXdwMzPE7Jnkrn4ScVVp8Rw4EFYGbejd9j2B1PEGBqq
26139	payment	1397	1397	1678	1	1	10987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNd2ZCrF2CJ1MY9fvviez1v4PDQtv8EX9Er4sddXAhF6dCyzY
26144	payment	1397	1397	1678	1	1	10991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK4HaevVE3CqMEvDzoo193gCG4PZ5RS73WraaB9dLZG4Rh5Bd
26149	payment	1397	1397	1678	1	1	10995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfHqEYhSZJxnp5vnAChakEdFABrP1CnWnqMuGye74hMGZDQGS
26153	payment	1397	1397	1678	1	1	10998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSh85pZ2YoTHT9jitHTfKG6aRga9WRpzdHRdPLMfqEqESg2Skx
26154	payment	1397	1397	1678	1	1	10999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNQJneh69T6CdacdJwGvwzV5FQkQcSuLCdabYZUw9bJ7mSnak
26155	payment	2132	2132	1874	1	1	542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUU2mtZg1hLmiWmTUYzbhe2XDQtVVsUijgtkztZqAdCQzqtP5G
26160	payment	1397	1397	1678	1	1	11003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5E1zrn5x8MPrJrFWiXe5XdpA8VxKEmduSetKLN2QkDXV1kfM
26163	payment	1397	1397	1678	1	1	11006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorq6B7wWcAU1XnLQuWtRKU53ZSUpHFZnnMXbASpR4Co3P1beM
26164	payment	2132	2132	1874	1	1	544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yzR3a5xujUfdQK2eoC3g3WjJPSbwnXRRpmCXYLWp5BorYf8K
26165	payment	1397	1397	1678	1	1	11007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiMNzrR2y1W3AuoAPf7hdy8usr97A1d7Cco3sZR4GJFXHeQhW
26179	payment	1397	1397	1678	1	1	11018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdAv2359SshgMMoxZQMKmJpiCviPdFKaVXuLUovgzkmFRLazg
26186	payment	1397	1397	1678	1	1	11023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7uEajmjGi3BvwnuEB8WTycsLEwPnsTafiTPBFKBsyitGq64p
26220	payment	1397	1397	1678	1	1	11047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVWkWXcSwKPojcwThustQMAJk82VJPpyh2Mp2DjNarFNswm3S
26231	payment	1397	1397	1678	1	1	11055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSMbQ9TJcCKs9qkwvfhLD9M7noooKzYScEs6nb4bAd1V4R8rF
26256	payment	2132	2132	1874	1	1	564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3iAR8iHtE6MwGjLZdrfNLQrhosKBg6Lh74xgt2UpADPj8dyQ
26258	payment	1397	1397	1678	1	1	11073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU87UQHs8qrjNnvgtua5epQG1u3KTVuCvGogDWDuDZ1jJLjr2k
26276	payment	1397	1397	1678	1	1	11085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYautHNtfVNcs3SiiKW1iGmsPoVS1b6n2w94U68V3GKn3mPrfge
26277	payment	2132	2132	1874	1	1	568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpt2UHs8jo7roRfGRPf4UDtu41VPuKkvG86P9fbGxBo7DuUYN
26282	payment	1397	1397	1678	1	1	11089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvPvwKJNty5JWYC31HexH193FffwrLkxwNVzoRnQvWcVqAuZA
26288	payment	1397	1397	1678	1	1	11094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUcKX311uiyc7r1WrKF5ue7Vppj9vEa6ZETpWVbryLQttPuEe
26303	payment	1397	1397	1678	1	1	11105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTeyKP9ChXJG2Q6JnzvvRAe8hEdzgNdmpK6Ydkhes6neRneZ2
26304	payment	2132	2132	1874	1	1	574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgeh3WJzFeYhLvNm3XVAA326VxasRm2dHg2Rnmmru7j5mM6Tz
26305	payment	1397	1397	1678	1	1	11106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNs2v9dBfdBndPdGodbiuMys5XeRKYiBYdpGabPBoUtBE6craD
26306	payment	1397	1397	1678	1	1	11107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUgcytmHRWFcJFT8JXZUtCZq1UBgk4jTd9mKTQwCWCjfwrz7S
26307	payment	1397	1397	1678	1	1	11108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7Vvyu12XELonRvZh12WTRUm5JYogaXGLhZkV1yrMz397ZSBC
26308	payment	1397	1397	1678	1	1	11109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksU92zVJtYkGZj4yFSmKpbVUMp2HEX43VV3CJgkKir8GX3dWh
26309	payment	2132	2132	1874	1	1	575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wxT5iNkCWKtoUtToX4fKnvMA8QjitXLMufcc3zYhhz3zsEte
26310	payment	1397	1397	1678	1	1	11110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQKi9MG2KD7QuKAaoPqhjXWqh1P3yxEp61etNZjTPznErF8EL
26320	payment	1397	1397	1678	1	1	11118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrphNncG3eVTBhNz8dRNswiFpvoiwZg8Z3rjjKbk3Mz95NUfn
26103	payment	1397	1397	1678	1	1	10960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Er56bta54r6qF62k8V5mMqiwKcrbcN1sNG7Lttn3BVhkhZx6
26104	payment	1397	1397	1678	1	1	10961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9R3AtJu5NPxwMa2Ca4GQcfzyBhXP9D8vzXcGFJdzLwZuEK1x
26105	payment	2132	2132	1874	1	1	530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpdPvjMQrxzgL3ufU9cRdD8M6udhFZAodkrFBjsFk76EktMdR
26120	payment	1397	1397	1678	1	1	10973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeHGv3JmLMhF8MeU5LAfPbd1hAWW97yo8deeSMRo71rLnojSW
26121	payment	2132	2132	1874	1	1	534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQufudQfwr279PbYZWak62e6WUQpv9wRKonU72CccpWN8dT7pJ
26125	payment	1397	1397	1678	1	1	10977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw28QLh1jkoATyifuttaTMAbUMwsrtdfHJa76xnEGz2qkUYTD
26126	payment	2132	2132	1874	1	1	535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzQvyFUD51pp2T8NygdLxzX4ZxonJqS2qGt1XpCLMyF6tjB5k
26134	payment	1397	1397	1678	1	1	10983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJQr6sWiunbVk5UeqyQr98UHhGHE1UwfNivtz5fpLiFyvAMvc
26135	payment	1397	1397	1678	1	1	10984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LHvFWmvro7FveoMHv4nbY8sMD4NpftpW2qWHddyxgBaCGCuM
26136	payment	1397	1397	1678	1	1	10985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGAGfzsfhvXV5CtN3BZPkPbv2nbtVGhbtVRahZ4GRoA8HA2Q6
26140	payment	1397	1397	1678	1	1	10988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JdzyWCaskKgJxHN29eAJs5Stsw1X4Nb8fYJMQPWcjeEofYTm
26141	payment	1397	1397	1678	1	1	10989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57tRsFxxmKbtGksrzYWqTmg1k2pG7chHv11Wp6gmKVTtJZi54
26142	payment	2132	2132	1874	1	1	539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Wvwj9FDPQKbrxtUSHyqcYxXQ95RWJHowBjoFrrnwkZSVeqF
26145	payment	1397	1397	1678	1	1	10992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9XTWcmUWtE6Sfedh7eY7xd8juwuvf1DLTggKJ8iqvGyne9tV
26146	payment	1397	1397	1678	1	1	10993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQsMRFwRbcFqaJEA26azUsoHqX72j2Db64RZdJvaGM2rwMKCXZ
26147	payment	2132	2132	1874	1	1	540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4ccCf5roEYSoELmFBcga5FK5Uia67qUp5omZJew2qVZcFLyY
26150	payment	1397	1397	1678	1	1	10996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZVSNd8MBPYthcyxgkJamnpuZ7pv8JrqEeJWQoAX9sgdauFHS
26151	payment	2132	2132	1874	1	1	541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNGpYE2TbHFuGhpVunPM8R6sa53Boq7hhWeWBLkfTRqZzvf6t
26156	payment	1397	1397	1678	1	1	11000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3f8cteV4sy6sDPY975bcRGiX4nyssy9SyZzhNUGPbg26TmAH
26161	payment	1397	1397	1678	1	1	11004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX85FW2qkAGXCxbDhYf7iyeW955Gjj8vUnfhD9sMBByPTAeFu
26162	payment	1397	1397	1678	1	1	11005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefWbDYXck3SX8xHDY5kvVpu9mBuTGt88F3XiKPfXcBLsVGCcf
26166	payment	1397	1397	1678	1	1	11008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjacPU46LePMfuZRxEwFV95v4t8XLJ4ueX21mK58KmhruJTFh
26170	payment	1397	1397	1678	1	1	11011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdGo6oYvbFyhrbvtMQWi78CsnoHoTGjw8dAfhiwdXksjtaYLC
26171	payment	1397	1397	1678	1	1	11012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKtbkx4w7vZGKQZhtRvZWdVrDWdoX3yc1SfvvtdwL7vGPc8m6
26172	payment	2132	2132	1874	1	1	546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7pPevKEbYnVsdEus14YDRZE66RpKemcS1f9vtPCRhKES3yTj
26173	payment	1397	1397	1678	1	1	11013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHZBdKnVTgceqVavMkqpVEWbFqbQgsVZAA2TqzrBhg5f3FLJY
26187	payment	1397	1397	1678	1	1	11024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQRkzsP9nofNppbmM9n2AJX7CneUwXBswgMVb3fSUMZdqUJCT
26188	payment	1397	1397	1678	1	1	11025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsAXnCLLvAA3BK3V7VEjxpoJws7bp2q58C4DdFa4huWiy6cku
26193	payment	1397	1397	1678	1	1	11029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqNeUUFniBxKxmERhZK3Fym3DkSUaHRgddsVWcuWkQyQcwjkn
26194	payment	2132	2132	1874	1	1	551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjQWX6oEcvcrMAaFKjy9AEnvjsCrckDRH9FQSVtWMFrxr1SeZ
26199	payment	1397	1397	1678	1	1	11033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3624nWgeQznTbR79df2PnvktDvcsfczQAuSwgKHcx4akLEjRF
26214	payment	1397	1397	1678	1	1	11044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSP52wvyMuJV6mAKLqswxQxqHDd3yPG895gXrsoH17SjkmemmB
26222	payment	1397	1397	1678	1	1	11049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWicMiFEuWvicEe4WSmsbTn5oKknt125d8jNYmjs5UHWwvS3F
26223	payment	2118	2118	1726	1	1	3	1000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpZzv18Nngd2oKrALERDdbdzarHJ2QqVfCsoQRy4zZfLeHACrtdd
26224	payment	2132	2132	1874	1	1	557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdXgWTFnW5eusoP3RtsE7YoU8VdMad1ziuRcoiCaiwTsLWcAR
26232	payment	1397	1397	1678	1	1	11056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmTTNuzmfEWsAzJzuUdmZgwMk9tZUgeuk62WykcwxQo8rsQR1
26233	payment	2132	2132	1874	1	1	559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdv4okn786odXLbLS1wchHh5iosns8mKH7GKiEqVvik7FuRVdH
26234	payment	1397	1397	1678	1	1	11057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMkdBPaPrnYF1XbxRjCF4NBHgBqdfsi1cKFCYv8h4rmtfNmsK
26190	payment	2132	2132	1874	1	1	550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93BQBDv1QZVWkdYNgXGXo5nzzr7QhMNoz3n8gmZumw9sAHKcU
26191	payment	1397	1397	1678	1	1	11027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNoH7v6BdpQEeRR6StzCvFmqqFANUzzPFv7RhPEtLJPdUMjsC
26195	payment	1397	1397	1678	1	1	11030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumie3CtrPWrJudozRub3eLSrVvfH8McAxMepCAbTN5BtUeWGP
26196	payment	1397	1397	1678	1	1	11031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowsbK6yV16ffLW51cBzpprsQX4atCqU13T7JrXk4RHSDUee9Z
26200	payment	1397	1397	1678	1	1	11034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzcgq5sDkarAYFPeW5pxBjH7ntuD2ytxzRucHZNXTmGM4DjXWR
26201	payment	1397	1397	1678	1	1	11035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczREPQpWhgPBTkAc5NhNuBSaEgDZ6EnEUGt2j8BkVeQGdGAXM
26211	payment	1397	1397	1678	1	1	11042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNa5ehnJH6NSXXvuvyJ8AyubEvMQsz1ouFW4ntTnkZjC4hVkQv
26212	payment	1397	1397	1678	1	1	11043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhQqeNXx6xANCJD2PzTsw2DcjQ6ZaKT4G3viesffWriy66N7T
26213	payment	2132	2132	1874	1	1	555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YRuwTG4dDypUJVqCXqFCzEKmPcUiob5BDVUeasPsuG91QtiX
26217	payment	1397	1397	1678	1	1	11046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMw8tXudahtb4cLgcLANka3MPuHPPc9vLxLBJRSu7M5DoPS89
26218	payment	526	526	1474	1	1	1	3500000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77Dajd1MDUy1wzBtH2cBiv4UYdxShHjpaCjgeKEgbR6Tc3BBm
26219	payment	2132	2132	1874	1	1	556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNWyYxWj2EUbb2CMABQvp3o9hwgQSxoYBzJfyP7wtJgZznaSo
26225	payment	1397	1397	1678	1	1	11050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwFAtz6rhsnHsd72y5in3agKc6V7PJunj6RnSfAaCVCwixD5G
26226	payment	1397	1397	1678	1	1	11051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpPHQwcZgjyTTipUiJ9oBJ7c3Hri1LixPtPU4JVF3aZCxt81o
26229	payment	1397	1397	1678	1	1	11053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoCLncwmssgUAQ1MiExZzRYGnY3vyMoNTvZ1wf15N73VAsvKi
26230	payment	1397	1397	1678	1	1	11054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnHtPdaKu6mt5imm7z8Yvpy3ARdbpMR32rNFzggd1pYmdiTLY
26240	payment	1397	1397	1678	1	1	11062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpRGSiA7uSCbewvVYskFUgBccVfNZRNQ9Q1QLKXeJMLutKFPi
26241	payment	2132	2132	1874	1	1	561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvsm977MkcKAciyoS6TZyMmqhUFay5k2D1SGAhd6jAiJRRaV3
26242	payment	1397	1397	1678	1	1	11063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczQHy3saziBBocR1CN2yGTbmj4gjjWxrv5Yubu3jrDRwe1DJR
26248	payment	1397	1397	1678	1	1	11066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3D6JaDqDgf6YqATG73Sjp7oqJ1NdiF17yP9scP2oR6tJidjW
26249	payment	2132	2132	1874	1	1	562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuosFSDyshZ4wwPDBTS29KZZyCGnN1jHnzEME1o2KqdhzCczuc
26250	payment	1397	1397	1678	1	1	11067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxjD57BjmyZf2BPfxo6XvLDNU1n5pJzqwMxfzXpqymm9ifBXA
26254	payment	1397	1397	1678	1	1	11070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3jnwaP1chcBZzivzNQU5NxRr82tBJmwbLDbRjjgZHCun1bZu
26259	payment	1397	1397	1678	1	1	11074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZGdeQEHV1hZrzuhmfeUiTEjQbU2mg558MgRzwH4Cjpn4CzSv
26260	payment	2172	2172	2131	1	1	1	1000	1000000	\N	E4Yd1BmvxuSwpvYQna5DCpkvJsc6am1hZ9U9yhxwnvtqphU4RzSmv	CkpYeeJ2neYC9YDvyCbnEkS8LTuEZZZAmWKU8V8qaAHiX9hTCwpnW
26265	payment	1397	1397	1678	1	1	11077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtkEtpo5zaVKt2TMLTgeb88A89fp5G7iAsH9vM2LCunzjJqwu
26266	payment	1397	1397	1678	1	1	11078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa154KJZzPZofTAXfqcs72LK9pq5K2KBYhTg1UDHhdZiAtQYLvb
26267	payment	2131	2131	2172	1	1	6	1000000	1000000	\N	E4YcxYWhANMuAaXHTgW7HeNuqyqUsSMoQ4HBpXg3VvCYhzKQCvAge	CkpYqZFnjPZV9Wx91BYoBrHWpHpSsgM8FULZFVscVYnod4ciXSk4v
26268	payment	2132	2132	1874	1	1	566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rr1ig6AyYdHjCKEhPDXZ8Bz2kdffgvhZ7zwPA1qmHCpi5UAj
26278	payment	1397	1397	1678	1	1	11086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4p5CtZgfBErHBK2qhDbxgQcW7tQZnCJQMoRvwr3ebafKytsp
26283	payment	1397	1397	1678	1	1	11090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyhFa5wGzgy1tuXwFgmxtBhedvSmpZ6TmGUATamDEeSpr8mLK
26287	payment	1397	1397	1678	1	1	11093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7a4A5KfdWz3n72VB5M9YC2Ndp39snKZ5trfZeE5N6GbhxHsi
26314	payment	1397	1397	1678	1	1	11113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQVh81PeWtgEvdxAL8QZBbBfYsercdos6aV5N33ym2A3TrsXV
26315	payment	1397	1397	1678	1	1	11114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKd7cxKgHvmPJkAoughEezt1PU3S2SoopYLqWuvn4UpZWZJsng
26316	payment	1397	1397	1678	1	1	11115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzphrLANkCs3vvUfTxBALXuHBxmvuGpYU3Z9C5C7CTa73DLw2
26317	payment	1397	1397	1678	1	1	11116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRDnpViR2Fq3bEnBUEgj9GC879Vtvf2QjNYZQk7oMCPnqXJ6h
26318	payment	1397	1397	1678	1	1	11117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7FiTWWEYz7giajkcGdYQT1AEmRHQuG425fmiVEhPvp3KHxrU
26319	payment	2132	2132	1874	1	1	577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nvap1vuC88tvJhFrJvRXP6n39319GWSRyEPRTHjEPLNaCDqn
26210	payment	1397	1397	1678	1	1	11041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeNaqKvwgDNLQvFMKgtENEJpzLxgfN1WfReNvrRWgMuh66NeE
26215	payment	1397	1397	1678	1	1	11045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS7JoYoceFgvTvsCk76axUnw2Vc2ZJQHmHXExvvmyqU38sJnZ
26216	payment	526	526	1474	1	1	0	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtJDMCxNgoqUSApEGz415yWNT2AKDmVeBbfD1p7UB3MrW7MYf
26221	payment	1397	1397	1678	1	1	11048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeyUSNSFmYbBCWuqoUzvbkoKLZhiGEUGSC31Y9EFyrnEmoVAh
26227	payment	1397	1397	1678	1	1	11052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggi6pZaefk3NMtva91jZPRZkZyHC5o17JfMFLohWJrsz55ojE
26228	payment	2132	2132	1874	1	1	558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdxijLwsDAR6TgZTR96TywU1cAS21Df2pPxNDWZKfge5DcBTS
26239	payment	1397	1397	1678	1	1	11061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYux9Ec4d7P9zLP7fMJTH2NLDhoTCtb2wPnQrLvvYtaME3mWaiD
26247	payment	1397	1397	1678	1	1	11065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4VPob7ajVg9UtQEBchYVsETeE7Cx6vRyyyWzYRVeWht254GR
26252	payment	1397	1397	1678	1	1	11069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZzZcJ6xJp1GRf42PqirK29JKs7SMJE8CpGV5zPy6qc9DYXss
26253	payment	2132	2132	1874	1	1	563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBKXAroaHyQiPiXNvKo1fkCSFfWC9JYp7o2ZaQtC37HYrFV41
26255	payment	1397	1397	1678	1	1	11071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5M5viiQasd8SpkQUEcLejhAiWnH3MmnxD4fa8ffaSbQ5o8wv
26257	payment	1397	1397	1678	1	1	11072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcA49VXoZjUwogS3WhGAQrcP5zjeiFosTB5aMA1pD7wRS6kX7
26261	payment	1397	1397	1678	1	1	11075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ72YwzULrE8zB9APe4X2N532TTPT7eUSB2SuFcP4ccfTuyqwJ
26262	payment	2132	2132	1874	1	1	565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1w4AKtpMi8SgsPqUoeZjzw9x7wzXNywcGBfoLgC215j2tL4g
26263	payment	1397	1397	1678	1	1	11076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dgWoHcJ7crHyxvttDgnqU6ANXCfvcc35vjGf8S47P4wmSDor
26264	payment	1474	1474	2200	1	1	21	1502000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpkrKGNG2nzDGHdMBbr7Y7BxiNfqhDe3iX992M3p771CHrdb9
26270	payment	1397	1397	1678	1	1	11080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iqQBiwJnFQgWnBr3ya4qNVezMTpeE5LFs9dizbsTowfGbrnJ
26271	payment	1397	1397	1678	1	1	11081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrkV4psmar3dyVuLZXCAbSGWZykznvJWz4reQM8SYKPzLcG7p
26272	payment	1397	1397	1678	1	1	11082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpd1E2uNSQosAe9KtosZ6KR61bJ43RW1EFcaD6kt5ai6TXkzY
26273	payment	1397	1397	1678	1	1	11083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnQK3mnq6RDzZ6oGXa9fnUTfUpTA2LmN2vzR1x7ekyexX3fiK
26274	payment	1397	1397	1678	1	1	11084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmLcJJVTMenCM3yXRCu4G1Bi8n2DYT5LaKpdKzxmRjLu3gW4w
26275	payment	2132	2132	1874	1	1	567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3j57RLpax6qZhamTzRSWUXa5hGb2Hj8HJzMZLAhixuR6DExat
26279	payment	1397	1397	1678	1	1	11087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmWHmcHXLfbHKnnD9bH8Nnxfa21Htj2EtJAt5VwXQ2TdFdsLG
26280	payment	1397	1397	1678	1	1	11088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsiw3DcQWdbEsQMWzS78w6ibmdBRnBBBsYgdMLFhXErbnhjYi
26281	payment	2132	2132	1874	1	1	569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyC2F6Hn1YwmFZzZjBa6RB3t7YtPwaRViZkqvxYi5bVKyX4Vef
26284	payment	1397	1397	1678	1	1	11091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrVokuuF4KwPhDf7i5wQDbuPFJWauxFkAxdkHkNJK4PqNSwvv
26285	payment	2132	2132	1874	1	1	570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GJ7jZQenaPGKnTbgrCGzgEmKpjJ7jGiL7D1wK5smmwr9Y3dX
26292	payment	1397	1397	1678	1	1	11097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2sS7bPTxorV6xAu4dxkGAQgWxqS4WCJ8rGhbvkLyW5S9YxnJ
26293	payment	1397	1397	1678	1	1	11098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz5jfjmTsRLBj2t112W366zhCKPhTeFSk7RWkvTyFV5d8km3N
26294	payment	1397	1397	1678	1	1	11099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xMVcVgR5uTFfBzo2pztxFkNVpehhNLLjc8YVArNBfTHRQYDi
26295	payment	1397	1397	1678	1	1	11100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7EC2d9Md4Ck3hiNcmNEk5FaDsSg4QHfvaRJeqASn1cRrSW5h
26296	payment	2132	2132	1874	1	1	572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwt1bzCkdgiunmc6dWkSyVTTeHVjdW9p1NSafCtaTZMuxKQPxn
26297	payment	1769	1769	579	1	1	46	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1VoDpyGfJziGvqiHwm5tWqtCNQiFh1L4o3vvB3nTgrS23C2C
26302	payment	1397	1397	1678	1	1	11104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyEnjjC87ot2e5dUpw5svUtt4q61WuuyCREfWjJkU1E12Mpid
26339	payment	1397	1397	1678	1	1	11123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWorfQNFc7TfQmW2egMPStEExQEe5K3GvTWkgerubLMAKPKFQM
26340	payment	1397	1397	1678	1	1	11124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbuKn8EEU38D3XxQQG3ABES8yt8oS4XgigQMNipfqGXuRAduk
26345	payment	1397	1397	1678	1	1	11128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZi3VMsbnGtdrpns4cKZcWhKP2MuMGRrvqpwrk82F1WBWBZoT4
26346	payment	2132	2132	1874	1	1	581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsdEJdCrbivqszFk1mi7XjN3okYGXKnhsFSWquaaqj8BEwVqbx
26235	payment	1397	1397	1678	1	1	11058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqB11JdJ4K8TRL3M1yq3GB5JGRY9sr1EtkRdH9K6VkNo7iFjJQ
26236	payment	1397	1397	1678	1	1	11059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTeUgJnoE3saVMCLTZkiJ8tgouFK8BiE7jFJSb326SHRLc9Sp
26237	payment	1397	1397	1678	1	1	11060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2tyoa55DBDJYD6QpKSVrsANE8yp3XDfZV37Qe74GjuWGBBKe
26238	payment	2132	2132	1874	1	1	560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcHFm9rMHVCqaWL1pzXa5c7wHzifdxZEQ2QqqZbjostAtTavF
26243	payment	1397	1397	1678	1	1	11064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjepQ5TdrhM1rqzDXpdTHKhgkzZJVkuMttmJ6tcNyUNtuQB9j
26244	payment	1611	1611	1095	1	1	2	3658709710000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCpvY6ZjH88J8YA1xTn7sxG4Adr3ZwsotohTouXhEJoypuNVP
26245	payment	1611	1611	1215	1	1	3	2468604340000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRtiTmDDRhN8riFRZ97zv2HADKwM9p1tcQb2D1YUPqwXFNFdL
26246	payment	1611	1611	1341	1	1	4	6878985500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKsCHDcFVWSrwyu6wfMisJeAAWoc1c5vyXPcciru7BiQSGvQp
26251	payment	1397	1397	1678	1	1	11068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELkauXMt9w8vSzL1Xq8qzSfrAkEXtaKiNCM9qzh7KqUXsH4ks
26269	payment	1397	1397	1678	1	1	11079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2g7fYvynzTXwrjMwC84vLGJApVeJar46qcx1rkPm9SMYGKhg
26286	payment	1397	1397	1678	1	1	11092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Fb1cCeJ2HQc6YZwLnNEPUi9a4UFamEj6Pq8yYTYgfjDoMcf1
26289	payment	1397	1397	1678	1	1	11095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RedjcGzNFTny4dXaaqicE9pKhg6kRvDad4jGM9zyi2yY9r1c
26290	payment	2132	2132	1874	1	1	571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2cU3jhHzdDWFTCXTJLZgvoaJByTTLtuRPaaMLGtgi2z1j9hr
26291	payment	1397	1397	1678	1	1	11096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvm1NttMfMd2CwKq1kwPFZY6PD4e28cm5wRYUf5Ytt2WMKqVR
26298	payment	1397	1397	1678	1	1	11101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPfGyY8eAMwBATPCUb68hatsH4fYJ1nLWm3SfXQp7Stw8r51S
26299	payment	1397	1397	1678	1	1	11102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG7WtEDLsGxboef9E8QMry47PqNA1WsqjHBPKBnahE8nptFSb
26300	payment	1397	1397	1678	1	1	11103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJuudP35PemLAnbfch75sdcLtnho7mMJv3b1QyWe7TzZfHkdU
26301	payment	2132	2132	1874	1	1	573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfD8ZaUa7MSpSoTWTZoput8Tfe3AxJAKQexB3Kkf9Q9pW1Anw
26311	payment	1397	1397	1678	1	1	11111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCo7TUegRwGCGC5xdfxaHi7aBsdoNAZ2c1SrT81DKFrKfSACG4
26312	payment	1397	1397	1678	1	1	11112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpgjQU2zCYLVVATS1Q13s3Tzc8Tm4HCqXyeCjWbntK7Dg9AnN
26313	payment	2132	2132	1874	1	1	576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSwTHqBGUXxHDY95CjEHFBsWmbRQEDs4zbftdp3F2wzZBz3AM
26322	payment	1726	1726	2201	1	1	8208	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYYzbRMUHoghNSw2H2Q6jXzoMq4jm8JCqbbKBt93MgxoXizKiST
26323	payment	1397	1397	1678	1	1	11119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pkLsEHC9R8ABezSAn4RdCbb9D5yawkPX5PwD4fJqvwKEyuUb
26324	payment	1726	1726	2202	1	1	8209	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDxdK5KsbkGgXCQHr3B8PsdjZjauztUJP5YfwwUPHMoL5DPASz
26325	payment	1726	1726	2203	1	1	8210	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnWXNTw5QYmAxL1sZmQp1Ri4wrWNrUyXkoh342bHNMYyJ3j1KY
26326	payment	1726	1726	2204	1	1	8211	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZDEF9MiCyCiuXDeoy1CZMFwfsK44ocw7i2PAczA3gGMwhwNDm
26327	payment	1726	1726	2205	1	1	8212	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKju5keyo18JdSbYnnK4kNMTZHEDZw9eV14eyJ81kogjfR4Dki
26328	payment	1726	1726	2206	1	1	8213	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfLXf85ymTpKXZNPAuBULSfe2zjxj4UXdgGTkaqA8k9CeGCFym
26329	payment	1726	1726	2207	1	1	8214	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZejiEYnbZncz9a8TDzd4DuCHBiJxhFG9YDxKppF1nKt1CjYVGD
26330	payment	1726	1726	2208	1	1	8215	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT7qzHX8NvbdY8UhVg92BKhwXcEb1vZfNao5nu37Ms3fbQr5xn
26331	delegation	579	579	44	1	1	0	\N	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsLocMb4XAziRmvnofo7CPYnnaJDDrpEuzaPyRGC6BvRnYyvu
26332	payment	1397	1397	1678	1	1	11120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQVXLmZGkoYSvo5GUdcU1tXzZbyyJm98ZDmCb6JwC7LU2sbD5
26344	payment	1397	1397	1678	1	1	11127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh59cYG2chH51F12HXuFEgb9CKsWfHGAfEmLDbqyNk6xzyXTf3
26354	payment	1397	1397	1678	1	1	11134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2S2R9MM7tpn6qebRDQE8AQ5FRckih6TR49MZhRBPeduj4EcX
26355	payment	1397	1397	1678	1	1	11135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidNNhKVy6nj2jtoK5Kpuy2SyqPPhzXaEekvmwtDfGrdS62KUX
26356	payment	1397	1397	1678	1	1	11136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqbphPu1kTfYgKEttnHpJBbf5GJbxavmeHGGNzJN46YWVnbq7
26357	payment	2203	2203	2203	1	1	0	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	Ckpa2cdTwzAktAZpga8UvWSSzfS2HGMPk27bsTE6jCzSf616L1EfT
26358	payment	2203	2203	2203	1	1	1	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpaHf7psrhsjTCSNWtePritBH1rsUWuQ9XUtiKbK6hcw4yYM2w4W
26321	payment	2132	2132	1874	1	1	578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjDB6zm5pkPrTwpfPZuW74HE3BLqw57Jdwrv5cNqHgvx2vnmd
26337	payment	2207	2207	2207	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJsQzsVEmJWsMnraX3uxNNo9Zi85GmseNZBxP6n3KRrr6mzM2
26338	payment	1397	1397	1678	1	1	11122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCYDCcELNo29bWiiApTBLgWDYb1ZZH2ErhL79xJd9cN99fMFq
26341	payment	1397	1397	1678	1	1	11125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjBXt1PbBohbrwTF8TRWWLs1Kjt6S2eR9jadMCTsQHKaaNUEL
26342	payment	2132	2132	1874	1	1	580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1onYStEMLXD7F1w1wRsUbuBLYrtgZNsQAoMqvmk6kE5E3Wkk3
26343	payment	1397	1397	1678	1	1	11126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qodYziQnaENzoATQB8KSEso2vR2qT7aYriTkrcCzjfXtzvYw
26348	payment	1397	1397	1678	1	1	11130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUv5zUoQwkqzNDb8ryfe4mVnibA5FZwyRpFfss7Y8vwxqR34
26351	payment	2204	2204	2204	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKWfUByDMXFagxKoN9j7XomESDUTf7ugSG58nfpvnWgzXVr9S
26352	payment	1397	1397	1678	1	1	11132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6BR268HnNt9TdBNQ6BhPM8sDS28JviQLhX6F6BUTJU3qGieE
26353	payment	1397	1397	1678	1	1	11133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ3k1qHuLSvQyAY67anVQZ5bhXkcETxniS7cAbU4VWuQogWf6
26393	payment	1397	1397	1678	1	1	11148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBcLPJE92g6rJvxUH7AXLtcAzJSbhbDC26JRRJVpgLMTTzKJp
26394	payment	1397	1397	1678	1	1	11149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYK8wHfYTw3MGZjRA7iEu5BDekP1HVtFCCb3gKrhd37jivcsX
26395	payment	2133	2133	1874	1	1	1591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiWmxrAqWRoXH8GUAtnWwDAwiXsZQAT7M7GY8cdHzj6B7C9iP
26396	payment	2134	2134	1874	1	1	2003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8hTdpWYVLRfBtyZtLPTewMNogyeUQeEk9gPt6uoD51SUaUep
26420	payment	1397	1397	1678	1	1	11157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwb3XhtK28KVTk1Y6nWCiJK7j22VoKq4XYyNGWC67dGFbmvz3x
26421	payment	1397	1397	1678	1	1	11158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aPJf2GZnpsNHRuaChoE46ZddeSYY2X1yVX4ivpyeZg83WGkN
26422	payment	1397	1397	1678	1	1	11159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtCnXQRS3wjxVGrXoU2Qkq7dTodWhUYcuU6fvnLv5BYvSMySv
26423	payment	2134	2134	1874	1	1	2012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZey4E7rhoCsAMe1eLwZtD1UzWqdGkmKs5JLyEFererLFYSwG2Y
26424	payment	2134	2134	1874	1	1	2013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdqAGc2FM1KDyG2jNgyAvfwD58kGkVZCoinFwLiWNXoETo38N
26425	payment	2134	2134	1874	1	1	2014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHniph3Je4r1s7BJ4b16bQpxXNjQJzeLDu5pwANi3iE7Y1mn4z
26436	payment	1726	1726	2212	1	1	8218	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYz9bKtf89bQGb7LVmMtNMyjJuiF5dwu8zVjtcVATbLzfMQGfsZ
26437	payment	1726	1726	2206	1	1	8219	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMWPpLZcqNJBPD8cJV8Fj2cyekLYohgfe8site1RLKQ4W3KYqE
26438	payment	2134	2134	1874	1	1	2020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UcW6NZQ8gVds3Mm9pwt7NGDXurJ4LRsjRf8D5AwZN6pBLdGx
26439	payment	2134	2134	1874	1	1	2021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyBTfTxGDQcwdBCFwB1zp5hEoHphstYbLoAmt5vQQsGyFswDp
26464	payment	1397	1397	1678	1	1	11174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYac8sd1y6UD2tFxt9tox75Qe9SuBGduHrvb3hJg4s681nZEW14
26465	payment	2134	2134	1874	1	1	2029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsY5NGyc9UbKkacCknorBJsQurijapRjhGNzjjia1tjg9hWzgr
26466	payment	2133	2133	1874	1	1	1601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ie6nCQpSGp1fGvyg6zHUBJUg2yq4YjXUxq86jyHGm6PVwF7U
26467	payment	2132	2132	1874	1	1	588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQf8JDNCBsTAJuV2peBfpEuTnbegMsSAgD2skhD4oMZKHzqqGT
26468	payment	1397	1397	1678	1	1	11175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKS2y1K6GBLu5NNfwq1kAmATkojejhsezPF397cqBT1a4ibvc6
26469	payment	2134	2134	1874	1	1	2030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkznZiQqyxEyAU8CtDahoDnmUYpGYudsZw2XnH1QMbJA6JFYsS
26470	payment	2133	2133	1874	1	1	1602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXrdbP8oMyHhyabuak3SfwcJWV3uvqC8aSw95rtobheAVtLB7
26471	payment	1397	1397	1678	1	1	11176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7KybqCeZRxeX8g2QJgoU3hMzy5H6XXfeM3PGyekaAfxQ3xjY
26472	payment	1397	1397	1678	1	1	11177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RzWXXPrAfa8FJutQvKZa2dZv925e8BP3D57ZadX9ufjewvR3
26473	payment	2132	2132	1874	1	1	589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkftoxvDXNPqeuydNrYqdnRaS5SA23G71uBuS7VWgxQkKLYWo
26474	payment	2133	2133	1874	1	1	1603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKgG9TAauvR6H1gQaKH8KCGR6Crsk5TzDDoU1nX1dgQ3p6x46
26475	payment	2133	2133	1874	1	1	1604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mYj8tN1baTmypk5e2B6w5aGW47KZihn5nvsBoNyK3P3uHZeQ
26476	payment	2134	2134	1874	1	1	2031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wthpHZM7N8zPpbmJS8sW8BMiSXhSv1efMGTB2VF2LK4aHo4v
26477	payment	2134	2134	1874	1	1	2032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshSdrowE58RHmFfz1iG3WKcHZ8qgcfHLT31qkhPyGV94bwUks
26333	payment	1397	1397	1678	1	1	11121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHvwz3r3A8VavH5ZxZ2EmcMaRR8L8QaqxJgzQgP8DhnSvYyUX
26334	delegation	2205	2205	1460	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUdUJbmGSHejYHia5kBRJKeAyg1fthiJXXfDHPPvhz5e2Np3N
26335	payment	2132	2132	1874	1	1	579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRELAZfgEwc4mGUcxkbyuhmgt2HDncBZqzRhXtkdBbf6ztxK5C
26336	delegation	2206	2206	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnevb84bGVrtfdHab2Gn2gm3iQdkfiWhHd4EnpQMEN1FzxPVK
26347	payment	1397	1397	1678	1	1	11129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjer2Kn6sFNZzK1PzGpXaMx9MnaAGaXY4nxX2bsjGLSga3A1ST
26362	payment	1397	1397	1678	1	1	11137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cfFXdzXYuBeQLKsQAUPGhdrNb9pEbEgsaHwf8m7vYcxFvUsu
26370	payment	1397	1397	1678	1	1	11141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXqZEJnp4TvkoTCJegM6HBpwsDtf2sgo4S3xG968bmLU4gi1w
26371	payment	1397	1397	1678	1	1	11142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEntLVsgfVuAgqoGsxBAFHTBhuBTCN8e8RyavzVFbQ8zdhV7L
26372	payment	2133	2133	1874	1	1	1584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UGztLt4UUMJM8v2aqhaoFh8Ra5fAVpD7BJai15NZZDySwho9
26373	payment	2134	2134	1874	1	1	1995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVDPTvDbAzBFvnQWpBNcj9kyCSS3giqDtcjd7Rzy6wptDzxp8
26374	payment	2132	2132	1874	1	1	585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ED1oGepq5oJeJzQm9K1kujvE9syxvr4zV6kRV7GzrtEeubHM
26375	payment	2134	2134	1874	1	1	1996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWnfsJkdRHQYpDfJz7G6Gc7HqDmtup4Y8c1wtvMTwbYc2CSRL
26382	payment	1397	1397	1678	1	1	11145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkzsaQUjgtdfkzQq3ruhJw73MLVEBNQLCfCUeq5T1GYcZ9LsN
26383	payment	2134	2134	1874	1	1	1999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbWgCYrnbJq2CKDEMyS65uSfmchiwXBppK6NmtJq4W8MnLii3
26384	payment	2133	2133	1874	1	1	1587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1etLQLnjKPpftPPbTaNmGi5pvzAfsMinUMCmCkkYNMr9tZEh
26405	payment	1397	1397	1678	1	1	11152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYtrGVKvaLaecFNjC1mPyda9sxNrT62WpxboLZKp9TmCfhLTd
26406	payment	1397	1397	1678	1	1	11153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLyNyc86o553bWLzRmX343Q54afm2tgoTy5WfBy8HAQ3NtxtJ
26407	payment	2203	2203	2203	1	1	6	111	10000000	\N	E4YTiE9LRQ1ER73UuUJXbqizqzzg7k3JN4wBsUvsN9SDpPVGzwbx7	CkpaKfUw5JqzhuukMovtiXNTYeMiQtcdQCJaZycDdm5cDMEq4Mksk
26408	payment	2134	2134	1874	1	1	2006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk81B1SDtZJjrH9gsnJQEsdjRs9VrmPpMA74JRZtzgkeFfoEm
26409	payment	2134	2134	1874	1	1	2007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcg7KRzG3fc99ZDY8rQcUVUK9A5vWpdYWHbgZBXeT13r1AB3J
26410	payment	2133	2133	1874	1	1	1594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6bU7V1fX4yNPbWsD5uuCUfwVqXDj41hTG1YLDkiDWaybnsPx
26411	payment	1397	1397	1678	1	1	11154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWsZAaVqheFn8BmX51TkvYFnLSUnX6DX8erryBW1VdMjo8LD2
26412	payment	2134	2134	1874	1	1	2008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoNiKimygCTZz5uMxTnr17tBUSpLLsW1poNYRtR9SNe6Lej6p
26413	delegation	2200	2200	1540	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsD32GcqPd5TjqBA5KAcud1mJPVaAYmedAS6T66kS5PPZk5TQ
26419	payment	2134	2134	1874	1	1	2011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRRwQcbcrNEUwJ6KPfALQ76FX1NpZ5hZAoV9CbhDKHFmcq825
26426	payment	1397	1397	1678	1	1	11160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaRJYy6cHFcgwzgyq8H5mTjq8Got8ZgdADEVsPw6YugJgJVba
26427	payment	2134	2134	1874	1	1	2015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDz3ZU1TqNB3khxQqFkZwtWmigSZeyPFHWBaUag46cKS2r88aD
26434	payment	1397	1397	1678	1	1	11164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXThLTPkiCh3ze3LwTZxbmRZzufK4BCeEyucnSzhBXmxY2q2TE
26435	payment	2134	2134	1874	1	1	2019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpegMbugQ5DpSFV2jbhvonHFMSL8mR3s2xpjWUjfm9k2WTjLdx
26442	payment	1397	1397	1678	1	1	11167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN53wLdGU7L3zTAyDxDG5dsEdjNtS31dUFMc83BH1bWVCzKDX
26443	payment	1397	1397	1678	1	1	11168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdEoQ4wbrSP6YVgtBSUnvgsLd7XLdzVHjmou1EqXyZRG3Q7rW
26444	payment	2134	2134	1874	1	1	2022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhKyGPwvE6cypRcf1FTm5rdmRpiXF9AZ9MY7DmJZ4vUATjJMD
26445	payment	2134	2134	1874	1	1	2023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxk5KKzqSzypCURRwo5q3Rmm1b734PvfEk43bR5kHaBe6Xv6d
26446	payment	2132	2132	1874	1	1	586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2eWjec1jVSYqmK23HKEj57KuDYeckjHcQvUWo4ivaNfbBrXn
26447	payment	2133	2133	1874	1	1	1595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqgqCZ7JHhKS6CkoFjb7KaF1RgcYetCmn5F3dCHVh5Rog7DoX
26510	payment	1397	1397	1678	1	1	11187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbsePzZY7UrciUZSXnq1K9EhZ9JTX8Ehyzi7PtycFPN6Bsdf1
26511	payment	2134	2134	1874	1	1	2042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Tyw3Rg9KMGVtf2GKn2hkcjYTu2gumTNFjueBHDx8JRudZQ8o
26512	payment	2133	2133	1874	1	1	1614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbTJMZ7b3H28wJGCVRSw4PVyye7xrGhQ3eY7BAPUEhaJfNeWT
26349	payment	1397	1397	1678	1	1	11131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXDrPRpUQwALZkPRE8oYuR6CdhXX2tJMqcBRWXivUNVpEChxn
26350	payment	2132	2132	1874	1	1	582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYA3aafcowbH2mYBZG3wt7L884jjFMUjgJJSHDCvZLzjtukSjF
26385	payment	1397	1397	1678	1	1	11146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbKFWvpNEikjH2Fwc6ZvppPKaotvm7kBScieRTqCPRKtBjjue
26386	payment	1397	1397	1678	1	1	11147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TRadgs9qtWXUdxL1JdZuguPKHmrxZePLsY3NjdGsHJWJh9pB
26387	payment	2134	2134	1874	1	1	2000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfLHeyu1AM7GmWhor2XUyLyEZ8WKyLAXjL5SmN8tLB4zBtaKt
26388	payment	2134	2134	1874	1	1	2001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2E4y7RXeayisyt1CyCzqg5ozUdzU2PupP2QzYkYWhDoTKUSkK
26389	payment	2133	2133	1874	1	1	1588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDnY4NgiLai4XUWvNk9PnMHHrGHdZKZtGbJxq4CPKxnEuYXgW
26390	payment	2133	2133	1874	1	1	1589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvHvkSRUpELpkwYh5kRGVe9EKgwgDBYb8otdDCBTJpMzDn1k9
26391	payment	2133	2133	1874	1	1	1590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezr7YpJ47o3sQdUpUHB9ToVwRb74pkkXazk6SrC8Q9Tqty7fx
26392	payment	2134	2134	1874	1	1	2002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYoWdtyDeGRNxedyoGvKrAQYsPa3hnqqBjpUi31ypiv7f9qsz
26414	payment	2203	2203	2203	1	1	7	111	20000000	\N	E4YThmuirKrS7KMqe1RnMzpTLcWDEm35r7qayPpYhkPmL76rMMUVp	CkpYUTDpLykJuze4sCJAwymHm5NPnfMB6NiugMhz48rsK9Z6uaZTN
26415	payment	1397	1397	1678	1	1	11155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtDiXRJif2Ktmx9H9VLq35sVcP9Wguij9zAQnJpHMNgNJqmw3
26416	payment	2134	2134	1874	1	1	2009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8oLGtLufBcpzVSFM3P1HrXRqb3JGkiaJr29R61Cvrhyxvqfv
26458	payment	1397	1397	1678	1	1	11172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QgSwYg53QjzJM5KVtmzPrC6JKZNvVfMKTVtzTWLVws2i1PF2
26459	payment	2134	2134	1874	1	1	2027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1tTwqeP4WSPVq53oqFLvwJUz1LmjoRJQtJYGTddzZ5Ldci3S
26460	payment	2133	2133	1874	1	1	1599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EB5fppcgQtDgDKuWfGa6XtW2XhrZtbcjmtcuGbjw4buc5kSE
26461	payment	1397	1397	1678	1	1	11173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1TocGjUDpVAqHW5nEHqCjQWkWamsjaBdU83FQeL4dxAiCZqA
26462	payment	2133	2133	1874	1	1	1600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrwbAuDPgcNDXbkKpAa1ub5tpM5TMGRjuYknoVpB1hbvut1Sc
26463	payment	2134	2134	1874	1	1	2028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR98KPrTFB9bEknjJrYRdxR3QeXUPumZKsLUDGzRQAX4fW4T4
26478	payment	1397	1397	1678	1	1	11178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrYDeAzEwch8djq2U4z64vmRyjdj85WKRm65G31xW6oR5xNY2
26479	payment	2133	2133	1874	1	1	1605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBgwJ5PDk7hNPxJAeoUEaedGqkWWPNjCzjidR9pEXJJi49H62
26480	payment	2134	2134	1874	1	1	2033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnB3ofWGRz5hgfs6yeHRCsJVNnxdN87TB6hzad3qB7XKw8GiQT
26481	payment	1397	1397	1678	1	1	11179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYam6T7BFeuFJ289tGQPsJ8vxmsRMbuN6jYBDfwyhFn1GfHqW4
26482	payment	2134	2134	1874	1	1	2034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQoBjKEn1gZHCG6hW9SiZkE6hja3asFRBJ7tq6Vx3hPdqUtqG
26483	payment	2133	2133	1874	1	1	1606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbau4aAP7HKrNWqKo8AWrjxsAFfHySvaN1iGvvzHdu7C6CqEUt
26491	payment	1397	1397	1678	1	1	11182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKT3r1jYre12abLMwKRTGovvZ9zpB9Xb3kTAEjTG7eru46wzp5
26492	payment	1397	1397	1678	1	1	11183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UCsbr4HoGqoZhNr5aziVEXFoqjFgw8fp4oEb5zYjKdA23eQj
26493	payment	1397	1397	1678	1	1	11184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2J8AVPHN5vwtsfQMDBhc42wtFBU762C6n1z7CRVTEAH966umr
26494	payment	1397	1397	1678	1	1	11185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQft7JAGgK1X4wnC3JnfmUKp5y1SGFtzQcaUHxkbgzHK17oaF
26495	payment	1397	1397	1678	1	1	11186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKeuh31dBcFnUJdPsKpDacj2kf6bUNcBq1tiPQ6zmK5MVbRaC
26496	payment	2132	2132	1874	1	1	591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrf6mtd2BCCi9YutZ4Mpiw8LsFtodGjzYJAFZSdfSJ1Wt4Xcxu
26497	payment	1729	1729	967	1	1	9	2505800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLW7rgEhYCPxf4ZgcJXYyHBN8wCHoq6RTzskS7G5WjpwSquC9i
26498	payment	1729	1729	1087	1	1	10	4490300000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZRNpztafMUqybegbLSPGjuJYMdLuovP1bbqVCpMkPjRV7q8u11
26499	payment	1729	1729	1333	1	1	11	8442400000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZL16fSejdcQCRhWCRZoRg3HM7zBDcDkyXwiBykXMsEMuAMHYu3
26500	payment	2134	2134	1874	1	1	2037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCj2rK29thtZqbZLS3H1PEVLLP4WEt3QJYL4z5ZFC8ehgzZpu6
26501	payment	2134	2134	1874	1	1	2038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCqkfLzSMGx1TEGh7RPXqVYir98KAXRcQXmTHGhwbNFtj48va
26502	payment	2134	2134	1874	1	1	2039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrVG8L9UMnx5uZA1cyrQpyoAenK5Ma4bGvk1uKB5e96GJwMWD
26503	payment	2134	2134	1874	1	1	2040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1Lu9MrHtjPuCpLBi8A2r2CvJuXHfb1665v1z3rjtdsiZAoHN
26359	payment	2203	2203	2203	1	1	2	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpYntB7uxRh89xLTCssAXkPnL35eqvTEm3N76dpwbMKFj92FBC87
26360	payment	2132	2132	1874	1	1	583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAqePY2tHPXJh3jUjGikwuq5WBHsbd48mLCkzs8FhtN1PvQYb
26361	payment	2200	2200	2209	1	1	0	709000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqww2ZCbmYUa6MZgsHHmQN3TYFx6PNuYQqP4NszUy92w7xpNZU
26363	payment	1726	1726	2210	1	1	8216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSakUqEodW93vRQE664N94VsUxCQKszXgk9sw9iszwuLGFCgYE
26364	payment	1726	1726	2184	1	1	8217	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYf9zQqyVRxej6CZuSiDtRF1XGD7oW5yM1WSbXAHTbKbVFZ52ha
26365	payment	1397	1397	1678	1	1	11138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcdKTrGCgSgUT7cR7paMStGw9zm6TH71NLo8DW3P1A3kjydEn
26366	payment	1397	1397	1678	1	1	11139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidBvEPE1WQHwFYjAmuuwoNk6YrtZSsSP9ED41UoJwmmJapkux
26367	payment	1397	1397	1678	1	1	11140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZgUfew8oJ1Wz45Ery7rwvWHWUYGacDdBQ4h3yaCvEgMebPU5
26368	payment	2203	2203	2203	1	1	3	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpZzGwCREWoRUVqQBbp9eRfVTdBL3cpBVb87SaFCsUrb5R1AQ1vU
26369	payment	2132	2132	1874	1	1	584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXR5wYZjMe5MaTgup9GCqir3ZXD9nAiQhXtnVShePyuof7ofyY
26376	payment	1397	1397	1678	1	1	11143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1FbCRjKaXJ4i5y5vzFAW6FPdK2eDB3DY1G4LQzAk2m3oPXpV
26377	payment	2134	2134	1874	1	1	1997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZmcXCW4TkhBVLSEworphvZAfU7aLHFHgrcj6y4oQHR5Feuo3
26378	payment	2133	2133	1874	1	1	1585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdUV2uwV1Y6g5cfQ523zogKfyFbBwEaQpVwt4afxcKu1iXUQZ
26379	payment	1397	1397	1678	1	1	11144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmJttaQ1cZAUgoPu7FzyhhczYSHUimC3H1gL7esiK6c4JrBBf
26380	payment	2134	2134	1874	1	1	1998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1r9vjCtfdRpMDQ8JTWS2bdh3hR7r9yHMe4iPiALhM8xeyfUH
26381	payment	2133	2133	1874	1	1	1586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzx4B9Ukq2BkYa8SvQhsEVMUMD37pfMZyBLz5AZhBZkJ1Vvno
26397	payment	2203	2203	2203	1	1	4	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpYccefZu1crxAJcB4FhXT7S2sy39rRisQQK1LP53QHgPMhdAoHR
26398	payment	1397	1397	1678	1	1	11150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVF4jxT25P79LiuCjaZqiXySFPiv5cPKNoPNFVDKCik8C3H8n
26399	payment	2203	2203	2203	1	1	5	111	10000000	\N	E4YTFhibPeG7K6SQQ35rNJMo2EGY9K4MMFXTLsqne8Gg49GBDpAM7	CkpZHfZpCGz2RbwpETzDezk7BicmeELTdCa1qotVABptuHn3RYuzm
26400	payment	1397	1397	1678	1	1	11151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKq83jncCatqKByB583At9GNodxgUMfGKynZzXG58izGchafj
26401	payment	2133	2133	1874	1	1	1592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZpAfBArHsbxei9DdGG91AUFKqUpxy1b6cZWrAKSLV8spw1R1
26402	payment	2133	2133	1874	1	1	1593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbSTLF6J6mWBjHnWmH1CK9nm3DvUCD9ybpcAZdQMmmvaPgXSQ
26403	payment	2134	2134	1874	1	1	2004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj7bGSGMBJeYFfJuVqbMe7zuTms4gSPHKpJRnQNcULbXtWDNA
26404	payment	2134	2134	1874	1	1	2005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeCqDjAQTuGsqbbwntrQ5w3SX56ajb318nZMVAJhwRKm9Q6UD
26417	payment	1397	1397	1678	1	1	11156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXTcxDEfBsucGsQuAgurHJXmmTnYEqHnGLyBu8u6EtSHKdxqi
26418	payment	2134	2134	1874	1	1	2010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CFEy83MYgoJzrVhKSszXtcLUTZpaK89tu2rGbW3qPeG9ioVU
26428	payment	1397	1397	1678	1	1	11161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQHqETC33Po6zMvRavjEYetV9k6xBxGi4DneKh97wLeV5aEpN
26429	payment	1397	1397	1678	1	1	11162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoyAXWMVjmiy4Sxv7RokN2PPMCsgnWXQTKxqKqrfrd51aahUg
26430	payment	2134	2134	1874	1	1	2016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xFvRpYeApHyfHHniz81ZQQGj4mPtEKKcTp2fo5gicinwqZrV
26431	payment	2134	2134	1874	1	1	2017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFefUefA5cuMCaeSbkykL8m1dCRifycHjY33fJiTktPqU6uvKP
26432	payment	1397	1397	1678	1	1	11163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGthYjn6vXAVcTdABRAEpEcmqE1Y94nsuaCoTm1gCzbGyetyd
26433	payment	2134	2134	1874	1	1	2018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1DvpEuQ8fjrp4tpchoq6uaw7HCwrCpzjdNseY8FKYxNFMR1V
26440	payment	1397	1397	1678	1	1	11165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWwTPkTqsjw9E6t2Ao773q9PkWuxkHSNyzurfzNxpVQziqbh8
26441	payment	1397	1397	1678	1	1	11166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NNrxJfzYSku3eLpnMC5VnDZiQtzPrDnytRj4qMK7vxFkeZfv
26448	payment	1397	1397	1678	1	1	11169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYGmDXWyf3c2h8ZRSkwQRZp9JJd5GigZcABCBjqiCpgdqtZaM
26449	payment	1397	1397	1678	1	1	11170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9q62pti1EbzmbW3HKXNAhvVEbA1kiyJjMU6ec4noWx3Kc6YKx
26450	payment	1397	1397	1678	1	1	11171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGcMRCJ6B2cK8empAWSzVHrR9DZZM72rjm9hX9hopAH5mLkfQ
26451	payment	2132	2132	1874	1	1	587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxspwfGDBBB9pxZ4V6diikpsBvSkichhAogVJQ9DjTkySczKd
26452	payment	2133	2133	1874	1	1	1596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5zimsMsEb1Hsxq56Tm4qfsnCQhH3fAu5StnhDe7q4hPDTcTE
26453	payment	2134	2134	1874	1	1	2024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jxJpaFADnUedn3CtpCm1jifYeqBE6UxF7FG3SiT41oDTT7qz
26454	payment	2134	2134	1874	1	1	2025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5PSzxczdrBfHM5UxkYmEvjFwytEvXQurkTshoJc2rPeanj5w
26455	payment	2134	2134	1874	1	1	2026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSg7QD4h2NCd77Gz4sx2BtEzfJTgwaWwQ6ryCFHYAxpNMV386
26456	payment	2133	2133	1874	1	1	1597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsHjjBWFAnCZ3HkeQLNvyLwKHLEeMhvSgCFwh7zctrq85AeJo
26457	payment	2133	2133	1874	1	1	1598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6csbwTB5ft9xyJqdrTa1WkbzdcSSjEcYm3VLdrp8mmstcH3K
26487	payment	1397	1397	1678	1	1	11181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65tWWWemtmKacZE4iUSuh5hMxXgZEpABKZ8MzXN73RJvfGacc
26488	payment	2133	2133	1874	1	1	1608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH2mZ3N2EK4DaQSC8hdsBmSfCbANaFjKNTDRS396bpSLXp5pt
26489	payment	2134	2134	1874	1	1	2036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cLR7wiN4GyRwc7vXJzi9sFP4TEHB4BnYJdK1f9UMdRePLGAG
26490	payment	2132	2132	1874	1	1	590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxNTJUAys1C8eTzvcmjrcfjU2MQPHfxchgv1ABMGXY8c1vb2n
26514	payment	1397	1397	1678	1	1	11188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteEeTUdT5zSBFVD6r9ASXq4aM4m1ptsjrDu2jEVjaFzkPSJ5i
26515	payment	1729	1729	2148	1	1	12	1842438880750	1000000	\N	E4YhKSNxjBMxJV1xfrkQ5TetPDfaDK1bho3nohc5X9sZ9zaxeNzd8	CkpYhsn4Sie1MvsoBJa8AoWGm21H9QMgLHuNPbi1ePEdzL3KNbtbA
26516	payment	2134	2134	1874	1	1	2043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSfZNA18wXuAf3NZ4qyXXSVfJTgkHSKyt4kY9Hh2MQkUtSNmr
26517	payment	2133	2133	1874	1	1	1615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUj2T4qxnLWjTvhn9NLrzDpMrMfHBpk3TFhRtFCE2xCixDvMo
26543	payment	1397	1397	1678	1	1	11196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvnnbVtDh64XNrEbVdPzZb9Rcrbzq7a8Y8G3PCQQHFuzka85z
26544	payment	1397	1397	1678	1	1	11197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJhvFjqGQW1GUwrLJbAkCACL4twvPiQkkkN5jfT8TzjyH4Rg9
26545	payment	2133	2133	1874	1	1	1623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3hu2ayFYPX5MA2v9FE2DEoUVjMsQz3QCkCVQTb4dwHk7gYRU
26546	payment	2134	2134	1874	1	1	2051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJqEeZisZs1yebCf7PrWT6Pmutjy4xbpvmtQDMHwpp2aoVRdc
26547	payment	2134	2134	1874	1	1	2052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYciVK4q9C3Gv8NQJs2jZJdjReGy5yFMtFgwhor7331WKwDyqvW
26548	payment	2132	2132	1874	1	1	595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUHY2ovmc7htRpE32cHGTKuu46qTwJ7c2sPUqBRCLuq3sYv8G
26549	payment	2133	2133	1874	1	1	1624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcp1cHFXxHozAcydnWoEQ55g1jp1nn5AeLMKb4bCKpfyRZmyuv
26573	payment	1397	1397	1678	1	1	11204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJapDY3wFc3J9QkSgQNprznuG3cFu6yEjzfhsKgdAmHZ8VLY9
26574	payment	2133	2133	1874	1	1	1631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn7cx8AzfWqPKjZLZoQrCNqLXEbHYaH1Pxp5ku22hV2cqZhqu
26575	payment	2134	2134	1874	1	1	2059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEEMJeWZQiT1EMbJkdLxHcVSh3igaEEoApCEMgyorTLKBxEJ5
26576	payment	2132	2132	1874	1	1	597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByjFsxYvUGZC5A2BLomsPsPMMkxZ95ptqwwaUBVtRS1vs33NJ
26603	payment	1397	1397	1678	1	1	11212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpteVSAWjjJLuP595xJvPrh4K9BT8qAJWDTmQGVoEQZQZ3KPK
26604	payment	2133	2133	1874	1	1	1639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejebPJbYevjVmSa7zqyA2WXdA332H1xUBsX6JrTanoR7pv4ad
26605	payment	2134	2134	1874	1	1	2067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJDrHCVRAZHs52Gg9hE8vAB4kYr6G696XBwTNbHc5295TYrJb
26606	payment	1397	1397	1678	1	1	11213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4XAi5TGYUv8QCiK1kNeqvdjJffWM5jCFFwDDHymoroQY9dpjN
26607	payment	2133	2133	1874	1	1	1640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWhTdVWCmAvQW6cEc4ThxnnAL2cWgzySk5YCfijfm61Vddniv
26608	payment	2134	2134	1874	1	1	2068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39Fb1wWr3WP4SpajakTAow4PMKAyaAsv8qhYPfYa89Nreybyj
26616	payment	1397	1397	1678	1	1	11216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5UgH19MJzsm75GLRYxBLELdf4nPbFdYoXQDB9iYcTiF6F416
26617	payment	2134	2134	1874	1	1	2071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqmRBzThYFQ697VfsNcWDpkyP8tJuuBkDXBcweNsUTgjApw1Z
26618	payment	2133	2133	1874	1	1	1643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmvhGs2KFGvJUW3azxuSYP1TG8G4wfcPGer9pEQTWjistEwrj
26659	payment	1397	1397	1678	1	1	11229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXeSU54L4sj1zN8ugLusxr4bTEvyqd168kbxjVVAhc1HtNyH2
26660	payment	2133	2133	1874	1	1	1656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9Dpw3H2bYCzyNqmGq4gLUEkfh7g7zXLCKq5nqeFFxFe2pMu4
26661	payment	2134	2134	1874	1	1	2083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtZDKnrNcoSwqKozBA21UkHc4mwwncyu1txukt2RiHnFXVMMS
26669	payment	1397	1397	1678	1	1	11232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe14PnsBT4u1WjjZaK87UpEESJzmpWRJSAX1jY1gmBbU9gt77Q
26484	payment	1397	1397	1678	1	1	11180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLQR1ThCdu5VLfd5BLxWnf79r1kKyCvBURMoeVSVSFahvJaz
26485	payment	2133	2133	1874	1	1	1607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniaSEcg2JNDuuCX6fZfxqEdKtCgoiBYNPRMKnhGrnW4ZbNpaV
26486	payment	2134	2134	1874	1	1	2035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU6Jx6YS9DFHvF5hNoHhakxbpCnAKeSMDQPeeqt9KBD5EG3rE
26518	payment	1397	1397	1678	1	1	11189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jWTpYrMkPVLwKe1y2KjF3aeyUZDbJhYCpV2UWFpB7kzErKjL
26519	payment	2134	2134	1874	1	1	2044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdWg3WHeKnoVXwNr26UQpVeWU6QPZSACL29S4hX1Fu3HYbHSK
26520	payment	2133	2133	1874	1	1	1616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8YFvLZ7tEVuQXP3MQXZUyNWxG7r79VisuvfTvscXTGK5Z82R
26525	payment	1397	1397	1678	1	1	11191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKq6p7Kwwq8ixNu6GKxUUNgQS4gwbki2g8h6vZniuvFuTuzdJx
26526	payment	1397	1397	1678	1	1	11192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8ZjEPdBZVuYcXFUYx5jLfV5U64Zpm4LaWnB7NFN7hwAejguA
26527	payment	2133	2133	1874	1	1	1618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxhsU5knEijv72jAo6J7bzEKfDCPbM4BQBKTSi8DefRA3QuSu
26528	payment	2132	2132	1874	1	1	593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG5vinbte7YGec5xbXm7KL2VxvoA7NmEKTJ8EaXVaiCrKZofdv
26529	payment	2133	2133	1874	1	1	1619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmS7ZHrfsoF44Xfd5MgzfzrRgcxUKyo3L1uLUgaSYk6aYe1fSQ
26530	payment	2148	2148	2147	1	1	1	971800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWXqeBsCpKfknrgaGsjj7KggfRS4528eKu8zYXWJV6sixE8TT
26533	payment	1397	1397	1678	1	1	11193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EPeMBu62Eqzzo4VZqbtzf8iT8Au5Y9d5MYhURYv3oPKbcQBe
26534	payment	2134	2134	1874	1	1	2048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPw1tqUYaL2dKmqq9N7n5VhLDiJdkEAXugyaEMjAT3xDAPYvnt
26535	payment	2133	2133	1874	1	1	1620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDfkVyFffuJAEDNZWvarjo9nxCtNKNBLLXpJRG6kGVVwhTNd3
26556	payment	1397	1397	1678	1	1	11200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcT9k1vmhiWB7hVP4Ya46D5mUaReB3tyN4DaGLXaSUyvXYJom
26557	payment	2134	2134	1874	1	1	2055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimckBmhtp6haNT4J4Ffpybk6ddZMEvYa6F5CWNTPJZ36yEe7U
26558	payment	2133	2133	1874	1	1	1627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLfBfoMq5NubQ1MXnavwthv2mN59yXYdaFKNFZEfTb8F2dyHk
26577	payment	1397	1397	1678	1	1	11205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1yRkm13L4DcVw99cVtJx2mjNo5GCvTSqcJ3pSnGzpbjEyX4E
26578	payment	2133	2133	1874	1	1	1632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6ZiuHWxyXvF7irpKyJBwxkBysdEZkKLgmP1H53QjHYgMnJKV
26579	payment	2134	2134	1874	1	1	2060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGty8g2Stph1v5v7Gd5sRgQkghQwoHK1ncEH1JH44tnKD6WBn
26588	delegation	1502	1502	1502	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDbUFxqwPZ7CDqcutfttCod5GPSJsYfary9epa4zcmUopafGF
26589	payment	1397	1397	1678	1	1	11208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYvDMyD4r1dsEYDn7WC76vXqWGo1tFYtoH5PsF61QxJk1CNba
26590	payment	2134	2134	1874	1	1	2063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpMQqi9tW3nrR7Q7nXcnXxjekELWzJX6Q7WeMyKY5HqJMi6p3
26591	payment	2133	2133	1874	1	1	1635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CSVtKVQ2SJjKYTWcYEcjJaiS7a6q5rudihvcKw8Zoc6yfNQF
26592	payment	1397	1397	1678	1	1	11209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns5eUTkzbbAPPihXn8irNPE5J9RFoapeAQSuGm3MyDbEzHvwy
26593	payment	2134	2134	1874	1	1	2064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC6FUEfj7mSfnmq1HhvP6wwbD4jsPpbsZzsD4mjwtM1KpRZBBZ
26594	payment	2133	2133	1874	1	1	1636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3hUZ76TfcZ4n9W5yvPLqvYrxTNzUFhSsR4NnKYbg8j1V5FDe
26619	payment	1397	1397	1678	1	1	11217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSKfVhNmfWYWgzF1kYN6divbD81VjjYG3reRTmG9KrvVfGc1s
26620	payment	2134	2134	1874	1	1	2072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUby1yReyCRJohgMvNAnoVX2CTGM65wyvNJUd3tihxVBbFQZdx
26621	payment	2133	2133	1874	1	1	1644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqtcwD9FTGH7PgU7nhQmuW88voGHbPLDR9zXdctmMX67kG2ZF
26629	payment	1397	1397	1678	1	1	11220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTZ7NKvLANT57Mq5hzeEeyAmYiSmk1LgtMez7F2GnxdXGTMRc
26630	payment	1397	1397	1678	1	1	11221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycLxU1ZDQbozjuQwDAbQGPSpzYNK34PQLFKW3SWJ3oWjCEQ2v
26631	payment	2133	2133	1874	1	1	1647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYha2fBBJqoseUahGXnVAGw3D94VLikieQ77GjCcFeFFBYp6qLH
26632	payment	2133	2133	1874	1	1	1648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn631PF2Bo5aUJ733V94Qf4DHU7w3JHD6pTP58P2mhRXSDVhJ
26633	payment	2134	2134	1874	1	1	2075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NPRx6pnUZm1BBomPZt28EN8dF9XRnwiJY1AmEuHUcaB3SjNP
26634	payment	2134	2134	1874	1	1	2076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruDVromeCJzQE9tboA4JMWnCzFr9o4GxhhHovMmY2U2tUo2rx
26635	payment	2132	2132	1874	1	1	602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmMY4CEVeyKaEEEh7ehUNDDYgTjmELMowDZDTATpQcqqDekFp
26504	payment	2134	2134	1874	1	1	2041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfk9rT4d4ymBg52gttHpor5ffawEwZ1NX3tp67FdyQHbyFTFh
26505	payment	2133	2133	1874	1	1	1609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJVwVTqYSRgQudU7HSxBJLhotiGkeusKcQeRE3DZdze7p1Kgc
26506	payment	2133	2133	1874	1	1	1610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypkyrQ2q7B9ZsJ5irj2f5tepFyDq77MmQ2q4gjro5YayswWhH
26507	payment	2133	2133	1874	1	1	1611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgy3QPbksN2acQv6pr7U4AWEiRCdYPtUX1TZxkbgheGENveLLC
26508	payment	2133	2133	1874	1	1	1612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9CdYMkQ4gvazJz5jsRmJx3WeXBjrRRcNAF5RdWB4sbNDSPhg
26509	payment	2133	2133	1874	1	1	1613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmoFP7XWAZyMJ1cS43LQiDuhwKjat64dqukjbw3RMdhddzVYE
26521	payment	1397	1397	1678	1	1	11190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRQtW7kGm46oERsdKzkE1NG7QMYzhLzYpNyQWWNhzVuqZpcgP
26522	payment	2134	2134	1874	1	1	2045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXMeSVUaMstkaw2UjnKRZdGwaaweqn1v4rCJhbqVJRjQM5pmm
26523	payment	2133	2133	1874	1	1	1617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNT8nCABBVrrwHPZowhYUTLx6WWm7fjjQ3gvtLfmeYrQExtja
26524	payment	2148	2148	1207	1	1	0	3029700000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZCESvUoLTUWUvUfitb2HMEJvmUBV8f3Y3BybNCtrE4y3VEAJqy
26536	payment	1397	1397	1678	1	1	11194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHstyWUhP7RqRtcjmcrj67Jzw7JJyDwceFC5UfAraTzyypvin
26537	payment	1397	1397	1678	1	1	11195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfLMnRmWYfvrqgUDpfqqxGySDMVJK3i6bzUwLDGCf4oxt7QTp
26538	payment	2133	2133	1874	1	1	1621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8k8xcyQExCATxmVUst85Xk1Ru3NZKctyuHYmZbQsbvKSwegY
26539	payment	2134	2134	1874	1	1	2049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEDuZiyPGDERSXPmQS3uoDuXQBvEY3zahNRGxhRhcsRzG9c8J
26540	payment	2132	2132	1874	1	1	594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmkxEftgvgf17caKQJaASoMoj8vUFCy2jDXTkqfboSYwYwWRg
26541	payment	2134	2134	1874	1	1	2050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8yaBDMRWTRhAddjD5mk3jviqjyH5sQs55CEMCvhJBTen3Yw5
26542	payment	2133	2133	1874	1	1	1622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAq76V4pydtwf9ED57oobMR9aCNP1HWyC4XtGdr9k6pts8qHa
26550	payment	1397	1397	1678	1	1	11198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mC6egGwYorN7LFh2NKpV68PvvvjNPRs6WTSUdGB7Eb8ipxA8
26551	payment	2134	2134	1874	1	1	2053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnypF7SUPKySFPJbFa4WHpEyJXFGraKzcnMFNNrgZkQ6qub6J
26552	payment	2133	2133	1874	1	1	1625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnh6X1kSdHx1tbHWZ6bvXnwpYvjWoCZEZM5sfGovxyka2CFrsj
26580	payment	1397	1397	1678	1	1	11206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XJswFT8gLPAWo5kYWvGCTRFzg8df6Fnmkdu9tdvz1SuQ1n6g
26581	payment	2134	2134	1874	1	1	2061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahaPar7vKMbAeExG9aFCNQXXYQNCBj4iogyKGdZxekmiG7miF
26582	payment	2133	2133	1874	1	1	1633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2CoksA3SST2cyUPJYiF4D1PtMMMJgkVeqpqC1P6UZDZw7pw4
26583	payment	1397	1397	1678	1	1	11207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgegARRn3tNymRseU8nzKtwe2ahTUStrPzKaEfVrnTjKPJSdyv
26584	payment	470	470	764	1	1	10	1009400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvqk2gKi1LCkAYZYookcLVKmLUUmfk172WJesLG55MKUTWKQv
26585	payment	2132	2132	1874	1	1	598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjwf3LGfBcjLh9syM5csjzpayyRn7PAUW1jSShPikpq339CPg
26586	payment	2134	2134	1874	1	1	2062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeaxx76c9BzKh4RD1YcoAoihzdwyHwbNbLcXCUZFc9ExCjuExG
26587	payment	2133	2133	1874	1	1	1634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhxfZwM6zAN25erMx5kPfpLSg7wEdxJYppogfiF6Cnr79Xj6a
26595	delegation	1502	1502	1502	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBq3iN5vffkbt44XS5qCYB87JP7mEBBu1VnztHZ5hMz1fEqvv
26596	payment	1397	1397	1678	1	1	11210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7B3STEcoy1fxDx9RPojYscNAXGYFP4Ygk1Hcrfmss5UKmzwCY
26597	payment	1397	1397	1678	1	1	11211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xcrt5An9YvjneTo4d6jTGGZa7mmo1CS76gQ2donKtJUkjrVB
26598	payment	2134	2134	1874	1	1	2065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNz1aJJRLr2K6QQa5tLaY9rvnVjxqEGqD8myiJ9kCtiPpnWs7
26599	payment	2134	2134	1874	1	1	2066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyqx5gf3PPGmXdmV4msPUgz1JLK8gV69kpAXXkbXJvrWu7vS4
26600	payment	2132	2132	1874	1	1	599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzub7vEqy9RxqRqfhBGcJuST71yFoxmsCU36qbsuxwhZbYkZRD
26601	payment	2133	2133	1874	1	1	1637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiMoma9URJtLTzjnaEUkyAxsUo21JRa5d4nHVNodo5ZMzCGcg
26602	payment	2133	2133	1874	1	1	1638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPR4rTee7L4e8kvGokYGjZipS7EEHfKMDbHpkPzMFrRkdUW5A
26609	payment	1397	1397	1678	1	1	11214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmYt6MUstX2WGQZC5kbmpb9MojVehp94mqVdERp8vhAiFszQk
26610	payment	1397	1397	1678	1	1	11215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAna3WLf8HVFUf1NzxWsF7CjMC1kJXgoabTDs7nGDkdSYE2vud
26513	payment	2132	2132	1874	1	1	592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Qk7vf6MeSLWNvM1JLMxFx4VGbiToCGHK4iS8b27ph4azEJe9
26531	payment	2134	2134	1874	1	1	2046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2SosHGGz5ELp5kKXMLUsegbLDPigKdaSoPpYYC4yXtpioneL
26532	payment	2134	2134	1874	1	1	2047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VCZqugBPZCAaVSHBXaM4zTcmBg4rivWQjq9X2EWGXht636ju
26553	payment	1397	1397	1678	1	1	11199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzGHZ9z1jDkbzCjrRzGxpcKhHFEJwrhAaTMzZjJGLgZihMQYi
26554	payment	2134	2134	1874	1	1	2054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFq5VAx3a22PQazAGMtsLcQHXEUNE1ERECHCVXxoCnV9sGpuD
26555	payment	2133	2133	1874	1	1	1626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBi1QfGN3SGStBotWnw7UtYTWb3rbGorABQ1d5g5y337YUAgZ
26559	payment	1397	1397	1678	1	1	11201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPWXgzra9FHEdYgGzK9dKz4thMjGTPtMs94kLHrDsXrP2B44i
26560	payment	470	470	1309	1	1	6	6450000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgarsSFGxvjPWLVMjMCdhciGDPs3Nv8EKxLA6ez7UeoRXsvdWE
26561	payment	470	470	1063	1	1	7	3431000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWkvXoes4F1nyWjM79M5XYyjxYXmrnbMZdtJroQU2gRSQa6kk
26562	payment	470	470	1183	1	1	8	2315000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAkXcbBjyVRmtJpTGcSGHgKLLNumGAK8nqSUCowekmfaPDLcS
26563	payment	1397	1397	1678	1	1	11202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzG7dFE2eRSdQC41XScBsyw1yuU16zi5THcRGUVbGCnUEaxAS
26564	payment	1397	1397	1678	1	1	11203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYWAFXCH49pRZqEsKu4f9aNsqDXZgMiFYZTqmzjGTifFg7JKy
26565	payment	470	470	943	1	1	9	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumDLJhkoJPQSMXeQGc7tmiEiDpWuKo3ZWvphUqK2f9NX6mMs4
26566	payment	2134	2134	1874	1	1	2056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AGNUgfibAMvy9qWVErwFboSXsoES9RV3YTVFfMBiGJ1UHEDX
26567	payment	2133	2133	1874	1	1	1628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9YdqcA9GDpqx53QF55byrkox473mNYhygEvaDLsXCM5rRDRx
26568	payment	2132	2132	1874	1	1	596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjC8CiWgjMectCZYhJXbWVDoq5CEghkekX4KVdnPP4bJ4ibJc
26569	payment	2134	2134	1874	1	1	2057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQ7v3KfFSJW1Vx4YZdeVdXQm1s4ZMoHGPXYFACXopR53ph65X
26570	payment	2133	2133	1874	1	1	1629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZST6Th6cu1rApk6XGCmfwdQsRoNA5oHgFnFDKti9rfAFkPUtM6
26571	payment	2133	2133	1874	1	1	1630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurqBSzYZ2vKjtmGiKTViWo7epjqxnNf5iPd9xBdUwAMeT8KaM
26572	payment	2134	2134	1874	1	1	2058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHcKX4PvQ9dqsnDbpdx2u1Q2ghS5ywWz31iiEZ5VXQDCNXdg9
26622	payment	1397	1397	1678	1	1	11218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCvGDiXRPmVuTZwd7ipaBajz2j27Q35B9zWrrRwwZrz6wLcbe
26623	payment	1397	1397	1678	1	1	11219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJErCGskV8aeNKv4Tb7NedeqbSdLieDTEyuC93mrPqDBixo6w
26624	payment	2134	2134	1874	1	1	2073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUqgz2uuoJjLXZX5ETkm9hf4k3zikhwgiCDLQzPZTgkKZAqZy
26625	payment	2132	2132	1874	1	1	601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jYRs6U68xMd37LsDnZP6Ht6aqXKRazaHMAoPxrViRfbASLnz
26626	payment	2133	2133	1874	1	1	1645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiRmsbMeHz3QpGJbmtARr3YPW5VayBJ4Qjtse3JjhgDy1hzk6
26627	payment	2133	2133	1874	1	1	1646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8vWMWWQhJS98dxbZa7DFRGA5FMeGKfA6C446Xub4DV28oTbq
26628	payment	2134	2134	1874	1	1	2074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83BQMRFZh5wyZXqHsJHWyuMNjamJpDkdV2pE7JdckWmhJmA4f
26662	payment	1397	1397	1678	1	1	11230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CqPvFDLMXUzjNDdq9cD1giTnbRjWGbkU3Vwd1pG9GxJH4Zp9
26663	payment	2134	2134	1874	1	1	2084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7DwJEaT6qnpHPdFCoohcV2RT8Xy51pX5CeYMLAKWfGC4P5rn
26664	payment	2133	2133	1874	1	1	1657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutFuKqzBfUGctM1xMuWTvKYmRhdVu81bz5WNFzVarw7CdGXix
26665	payment	1397	1397	1678	1	1	11231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaPUuZL2L4H5Esci6MCayAkpasFtB6aAW6c1yeoRRdJ9FM3BDb
26666	payment	2134	2134	1874	1	1	2085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZYhDaLQGJ3xw6ugEsyk386i6MpwJuDFygxtHh1AR2qHJhZD7
26667	payment	2133	2133	1874	1	1	1658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTmwDVdrvY2mpCgvZNRQeDFBARcdCV7SHsiGW45AJ2Fv9SzSh
26668	payment	2132	2132	1874	1	1	605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkVpCLdwq2ajGQ5F82eiBGWw1MudpWHjH7E1FLTjZj6dwj9RS
26672	payment	1397	1397	1678	1	1	11233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJVXypeRFAkkJBtmRRcY2oKf66d1u831DFczat4wEirKxhC1D
26673	payment	1397	1397	1678	1	1	11234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCb6DoybJ2oTTd7MmhnQKaF45qRer8GrrdFTGe6HLRUtWLHuc
26674	payment	1397	1397	1678	1	1	11235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyPGwerD3qriJFFq3LB7B5hBRyW99ZwsGsZYxDczf5d64tVAM
26675	payment	1397	1397	1678	1	1	11236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfjz2gUv8XGbp52s3FsWyLJ6ipboGdD7jHuupqBwTRWPWUpuN
26611	payment	2133	2133	1874	1	1	1641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9Ug4nJ7XT1FRGvtkPsACxe6Nxh5qZ3euJrJ47ei3vkdDPKVR
26612	payment	2134	2134	1874	1	1	2069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogQCDUoi2Qjxp6adWsN1F7t3e5ZMpGAcwTW1Vd4TghfZ4Ls7F
26613	payment	2132	2132	1874	1	1	600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPHG1nUBYY3rkkC4PvLnabbQMTnBTQ5iBf2eqPKnBL8dcVcbT
26614	payment	2134	2134	1874	1	1	2070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9XJrUpBhWfYcLKoidtSfT4vQnH5R49EUBaoV65U1tKYeAYg6
26615	payment	2133	2133	1874	1	1	1642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrk9M9qRjvT1uExmQnJKAbc1onm4VcDa138AFy7ZJVVkpp5Q9s
26636	payment	1397	1397	1678	1	1	11222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5phQrw8dBqVBuSK1vmMUpUCDBH6Xz2TCaoXfS8BCcM1jD5m3Y
26637	payment	1397	1397	1678	1	1	11223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdntQQebHRQRKQzBuryAugHniFDjbFVomDR1fFo5tBaZfjUzP
26638	payment	2133	2133	1874	1	1	1649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgT3eAX8Lcz4TsLhEDbxpMm2gdaRTLVBPYn695fiRYa5paZNGf
26639	payment	2133	2133	1874	1	1	1650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSE6F8Qaby2TsSGPQdyAwUZC9BduH8FWjNDjsMist88AT1PL8G
26640	payment	2134	2134	1874	1	1	2077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazXBU3aSsXYJDhNHGnFPY96RVCS58HGbMRJStt6oFuC6wTy2p
26641	payment	2134	2134	1874	1	1	2078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCMkh5QkEEMsF4rU9r7eVKYtv9cJQiySZWcn9hmzCc8XMzhWv
26734	payment	1397	1397	1678	1	1	11251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zfhKLviygxnjCvwepq68cQUCNytNJzyCx2AziCPD83GPRoa2
26735	payment	2133	2133	1874	1	1	1678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeL2VpeUBdEbvayWNuGSEGGoki7DVH9VpqK5emTWjwfBXkYVs
26736	payment	2134	2134	1874	1	1	2105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFDWnwLWGw65vdwRNhnnvQh3oL8BwUNYkaYNYaK8RWxxGTyUN
26737	payment	2132	2132	1874	1	1	611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzizP7xe7SUNaacEZDW7wYqekhqxLP33DRNcijP8rWP3Z33pu5
26748	payment	1397	1397	1678	1	1	11254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CoFsQf5HieqDRqh7CxT57yYbiQDoNqgJ9ECQ9p1yHA9vnY7v
26749	payment	2133	2133	1874	1	1	1682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Wc2aYnxN2Wsv5erVCVadPw7ucwtEULrpdfe2j6gDc7q1fKkt
26750	payment	2134	2134	1874	1	1	2109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyaeMxzzkLbjZ5V1F59Mg3Vnx1BRxa5RjkoqnKBRAKPVoTFS9
26772	payment	1397	1397	1678	1	1	11261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVPtemXR8z4fVjMGrFnW38gtuQ2qzqP1DH8fEDDFtFR9CBsKc
26773	payment	2133	2133	1874	1	1	1689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5YJ5t2VjEpj26DK2swcqHZ9UNonFSpNQC4KaKnVnwgCJ8vGD
26774	payment	2134	2134	1874	1	1	2116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPdr8pZiAYHVdSWSCoKh5qe1cAzdnX8mVYRZyYuvAs2nYLimc
26788	payment	1397	1397	1678	1	1	11266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYNeSHiPk3qJN6XEFGs6Y9pNRxjVjWCk7F3HkfQzagfEUNJuE
26789	payment	2134	2134	1874	1	1	2121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvRQs3CRCyrLtePspqqNPRr1a9LtJYo7PDgAvTM48nw3QxG4b
26790	payment	2133	2133	1874	1	1	1694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJBHXYvNHKefWVvqs6vpQAhfKj25mujDvP4c8BdwNZJ9yurvP
26830	payment	1397	1397	1678	1	1	11277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisVQFww8QfWFh3yF6CbpceV3Qnfa6uiaYeGyYRGVTFL4ciE1L
26831	payment	2133	2133	1874	1	1	1705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5mffjaVd8iwe3Bzjj23B2UCrk3xUDTtX4X7qUvsFPymxK866
26832	payment	2134	2134	1874	1	1	2131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mrdDzYynp7TzQ8zWqqDTfUGiLwkppV1sB7jMLr4fqVAxvvPF
26833	payment	2132	2132	1874	1	1	619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnVuMLKjxn2UPH1Kie4nGUwmLeZ3DvEXSErGrBnHaKABXtivT
26855	payment	1397	1397	1678	1	1	11282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmr9u2ST1wzBVntosFJqM8ppSCYzaevEaWG349mT9etHedBkc
26856	payment	2133	2133	1874	1	1	1710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9LJ7aXGJYvxUCjCDtbvhif1R48MvaQAe257yca9QRN8CtFT2
26857	payment	2134	2134	1874	1	1	2136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXZrvLcXygQ8wmLhNKeTG4NQnGf2tBRfRuKZda5qhA3ni6KmE
26910	payment	1571	1571	38	1	1	11	71854038164	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYhUh7i9u7hQ3xerywDaTa655YoKK5YB4573X4xyyVt217ygTpn
26911	payment	1571	1571	969	1	1	12	547083452688	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYsbvZq7HMgmjBJoysgacAYLwksdgQcqZg5UKEFNkvCAc1RHLFa
26912	payment	1571	1571	1089	1	1	13	980368859808	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ3dMemVgv9yoN4pbjEvaFk8rkzTdEVAJFrAvbiMKFPRHLWzMZr
26913	payment	1397	1397	1678	1	1	11296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDq8ebHyt7E6c4NAMvC4MxfLsZsW7FkAxRiiD8XPFxFmq5GH5
26914	payment	1571	1571	1209	1	1	14	661474404942	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZZvdfvaDoKatdW1TKNyD1qfmd2VNwmsdEA53v1aTj6Ex54zRe6
26915	payment	1571	1571	1335	1	1	15	1843257244392	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaGAKJYxKCERkzUGj9kDwQ5vb5t33LpsiPnn1v8ymikZXytfdyX
26916	payment	2132	2132	1874	1	1	625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSRop1BMnVsdQtv2wGXWjRMEp9JoBtpm7D1UABhPxyZhGVAeK
26642	payment	1397	1397	1678	1	1	11224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcPQRP4QbLzy2P3oSF9nBZzViPnA5SJrCXxhzhhRn5x3uAZx8
26643	payment	1397	1397	1678	1	1	11225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovudwm6iQ83zcwhNpiWToASimV9A8dc7D9wot4f75Unh9zfPm
26644	payment	1397	1397	1678	1	1	11226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Sby2w58P78ah4CggAfhsaTFeebDXCUUKsw8HUpcLNc9Tr6m
26645	payment	1397	1397	1678	1	1	11227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyiPrAukZJ6prT2zbJHjpjioM8ThdMnuzFiCqBpgFpzH4zqqz
26646	payment	1397	1397	1678	1	1	11228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Zvv8JiV5EazbHkVvkzhuUXwXmFRGng8hkUFTtyuipBB48fcA
26647	payment	2133	2133	1874	1	1	1651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW6f3Qo98pMwXEh4z6oasvaFfgkTjK9MnCDQE7DUyCUEYQ1uo
26648	payment	2132	2132	1874	1	1	603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTcaMChpEDk1Bncf4iSThbuqMKUXwzkFKqu3jXznzaJirGxfX
26649	payment	2133	2133	1874	1	1	1652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcmPXPFzpDz6EaWkAj99cuDq2guDSw4Uy5PZYYm2tCMp9NQTf
26650	payment	2132	2132	1874	1	1	604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpu2RBf9sKZSnbmnPtU6eLhu7tQYRgjfNVaHSQPC58joX3xnC
26651	delegation	2163	2163	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXz5xeouPDJYerc8BCLHWYFNXThkChwexv6Sp1qQmTNswdyua
26652	payment	2134	2134	1874	1	1	2079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufFbAu3S6B2vBTYoQn2ndFa5VU6fwzVDLeLvxnaF9zbTcWMeN
26653	payment	2134	2134	1874	1	1	2080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyfP9LzfgsfetRWBAYqgDj4aRNkv3vNKMAnJLG3R8iM4Lfwtz
26654	payment	2134	2134	1874	1	1	2081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aBXyyo4XyMH3D3FF35Bdwn9orgpit67wqATpL4mLkeZDKC2n
26655	payment	2134	2134	1874	1	1	2082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUW867kTF5qZ2FDwBMQjTWmLYDkGApfbPqtQhuEKjy9W5RxU7
26656	payment	2133	2133	1874	1	1	1653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13dmBPkT7QM59TdfsKyHUArKRi85mxnWbYzH3GGRotq7mPurk
26657	payment	2133	2133	1874	1	1	1654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CKscTfnUNC1PaUZz9brE4najt68bYTQdmXYrRWqQCHwv6jnn
26658	payment	2133	2133	1874	1	1	1655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes8jHR4wrUqw8ZYemD5g8MAPgJY7fs8j53RmYCiB1Tmen2913
26702	payment	1397	1397	1678	1	1	11242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fZPxHFf23D7dvXiU2gvgejw7pMQs7S7EXbALXsUow5g181WN
26703	payment	1397	1397	1678	1	1	11243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49jkfWiEsSjv5Q637Yo8z1pUERS2n6FViB45zmxQSv6pHdc9j
26704	payment	2133	2133	1874	1	1	1669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbthZwCUA17FsFudbtYDJZPVAbdTt3hNBYBdmairyhX4Prbuk
26705	payment	2133	2133	1874	1	1	1670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgjSRdrwXwWCVQypRqZyQW4UCACDraLVGhHraBptJxkw6g9mX
26708	payment	353	353	2213	1	1	1	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiqwhqykiSa8HNH8NDjChmSfFSspw1ifPXsgRMa5fpmHBMdvP
26722	payment	1397	1397	1678	1	1	11248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgN1vJo1c4nunNyWJzWB3wQkkfMzUNZ22tQLZd9i3x6Urnh2K
26723	delegation	1993	1993	80	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvBiynsUEtuLs8MVZWARf1czcNt5mHQSBinU6Ah3jA7L7QPSQ
26724	payment	2132	2132	1874	1	1	610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cAvAQNEaXqZmNEh6c56QraJNHj2MPYgvsvU5DEkhsX4KF7Nw
26725	payment	2134	2134	1874	1	1	2102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiUxoNyZWbAdaY7kcAbSpsaJ5VPnv2owfTneQYim1PrZNav7B
26726	payment	2133	2133	1874	1	1	1675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxUadMexpAK3wtFsUZ8uuMWuCqb3eFo6RvCNJn8yFu6hzpd75
26738	payment	1444	1444	2214	1	1	5	1000000000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZh61XxEWFz5V79HP6my3i3hBq2PQG27h7XnSi3FkVCAAugDfuK
26739	payment	2133	2133	1874	1	1	1679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWNpjFeEDPZjLtW5usfBKEZdKaRFbVa2CoBvp3cx63yE2dH5c
26740	payment	2134	2134	1874	1	1	2106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cs1UHQcbgSPVEeky1tpxDDs9TBXKVQwpTShciih1qc8Sa7ZA
26782	payment	1397	1397	1678	1	1	11264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ48MgS9gc6EWQc1pEYU7ezMJCsYN3mm6pTpoLks5hyhhozs9
26783	payment	2133	2133	1874	1	1	1692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvR76NkeJRPdycqZLhQALYRv69z5RYzQxCqNhHquWZ1tzrSFzn
26784	payment	2134	2134	1874	1	1	2119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTtpCbzq7h3MA4uVLwee5fSqyerd1y7d8s8929sQeKNYD3wA6
26791	payment	1397	1397	1678	1	1	11267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAhmbk8Pm3ww9GnaJKK6kEFu437TPPwPCMigwUsk37V2KhY9H
26792	payment	2132	2132	1874	1	1	616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKo6QmtehimGSCpm12aswM2csD2bJQKzdgVshA6gpHBrq7D3q
26793	payment	2133	2133	1874	1	1	1695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYnL1QeH7AsUaDAdP1aLThJSqq5tmKzYzzGXfipz3HWQjKfMk
26794	payment	2134	2134	1874	1	1	2122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkMDN2AzHx7fS145bD6P1XnrCrC9ogZcaNdiCBoB6EdbCXrWE
26834	payment	1397	1397	1678	1	1	11278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqartwcBEQzBitqDnL21se2iGxAR4oy7PR8RfFoyi8L6qCsfmP
26670	payment	2134	2134	1874	1	1	2086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymS92m5JCsw6w1cyiZQSjei5bze9NdoaojFP3sNX7C52D79A7
26671	payment	2133	2133	1874	1	1	1659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8mkSRnU8MXci1PjerTjXTbbqzqBFFTQ6rnj7ZN6wGzfhdwQ2
26713	payment	1397	1397	1678	1	1	11245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD5V6BVMtzMH3CrjVDb3HRv3mJSL89iE2MLQ5CkFByV6zkmPW
26714	payment	2134	2134	1874	1	1	2099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZbw7DeNmvFHsz37JbdscLodczWeuCQ4maJ6FjSrhT52fc3jT
26715	payment	2133	2133	1874	1	1	1672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8A5ViEvuc1z7LznsRjgw5znzrbGSpMBz3qrksw9pxJPZbwv2
26751	payment	1397	1397	1678	1	1	11255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b6pcXQBT3vCCgwBvmVwidy9fWcsaU1TwwwFff4hjZhW4mkkc
26752	payment	2133	2133	1874	1	1	1683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9sbeo1719zRQ3jkKwoRxbcy4Xo8CAPfwbE1krnRnyGpDFsfG
26753	payment	2134	2134	1874	1	1	2110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PivA7N3TT7fNz1fpt5KhqrL8iy4qTcJj5M2xhP3hVvUQBE8Q
26762	payment	1397	1397	1678	1	1	11258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbzqyer2tAA4MbEnQFsafY1XskdcBrA14QjKzadLtM1T1usYF
26763	payment	1397	1397	1678	1	1	11259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLT1ZhXypjkJiLUEKZdS9FRHDaKog5R9CztYo8GnzYkBqxS4U
26764	payment	1397	1397	1678	1	1	11260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CoVC5mWyt1ravwoswsBGSkehtmQPLs27qsQhaoqwL3rU7oh5
26765	payment	2133	2133	1874	1	1	1686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmtXP7MziJVVRt5qFBBacrE6sUFH3Do5z1ZYi2UC2gjTwh2H4
26766	payment	2133	2133	1874	1	1	1687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyimJvRXPUuhjerKfSb3AdSGvCdFLpjvRQSjW6ru61YRnCqUj
26767	payment	2133	2133	1874	1	1	1688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuQc3gAq8QskbFptcUGfEgkGv4o6XqCDVCGzMvzkgr3DKRVrt
26768	payment	2132	2132	1874	1	1	614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcPQpWDRGYbNozamGR4SVKiGxQEtEjGp2ndkPigzKrodrHDAg
26769	payment	2134	2134	1874	1	1	2113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVJSJb24sMbXvh2RmtJkthdfmgEJvHWnzYWqV4CAV2CtKf6Hj
26770	payment	2134	2134	1874	1	1	2114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkUMRjRs1Q52YGMvRNyqtjYD77iDsqLEvZK6HqZj2BtsuFFzG
26771	payment	2134	2134	1874	1	1	2115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6JmwLjLboy7BcY7cVGaQvsJC74572Fncg6EkF7WNxZGXNsNZ
26778	payment	1397	1397	1678	1	1	11263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpz3CEHpiFydWuL1CPByNhUEPbiMUbADGhY3UsbMHs3NC3dxsw
26779	payment	2134	2134	1874	1	1	2118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJGMDN8M1gHA3dgi7zg2GBfto5fM2MBBFpPhUjkHQTJer9HZs
26780	payment	2132	2132	1874	1	1	615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6GfDZNdfG78igtcNFDnEKmTjCQrnWGCzQKaMnGFttRr5NtjZ
26781	payment	2133	2133	1874	1	1	1691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpjLdsEgVvN3hd6AYteTh9dWfeYFBNWgAgBHNfHtZtzJxC7fp
26795	payment	1397	1397	1678	1	1	11268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNz5iHDrPU74Tz1wJeELKYmeoEg1DVmruztHXhxhNsQuyqfJjc
26796	payment	2133	2133	1874	1	1	1696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGEiMQtaQYEFE8HM8AWcT1xqpBG86iYfxBnnzj8NDVoUP7dph
26797	payment	2134	2134	1874	1	1	2123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyyNJ3S6X4b1myFAFmQ2zWzasMMjRxZ39ucCSwJniV9dVJM35
26802	payment	1397	1397	1678	1	1	11270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4nyEoC6McDfHvfg9sD7qydWE1HUCRCtcbuW89tuuDtcV2buM
26803	payment	1397	1397	1678	1	1	11271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiT8toDpT1ZAtR9c7nVwsVugTqJgGrfdfspAk5a4tJLDpQugbq
26804	payment	2133	2133	1874	1	1	1698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEriwT5yNS2hp2ZD93zf92VfMkQZ7koizSKXEotuaYkH6Vidg
26805	payment	2134	2134	1874	1	1	2125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaEMjhA3CKPDrBy7aeoXEQUzhoggsQEdTRjp6y9V24GqSFVFz
26806	payment	2133	2133	1874	1	1	1699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqisy8MqusEhvQ3MPHmxg9ayHnojxx7YURHSTZ2ASEQKUk5JqQ
26807	payment	2132	2132	1874	1	1	617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjTFUsw8cXzhAGgEqrcZUESYu3cetJjW8mWTJqGkN5uzp7v31
26808	payment	1397	1397	1678	1	1	11272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9BFvBuayuLKhdw4NmzyiwRmwkDHAvbpanqb7Cu6uFC3DJvAB
26809	payment	2134	2134	1874	1	1	2126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxifT5MkfB5AMijKYEGVgy69NKTPLPxLqpKCEMJdQFpUQJ4Cu
26810	payment	2133	2133	1874	1	1	1700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ4EeELk9N9WZUzxHS2DiE3JT5f86qtU8weS75CJk7X3TewF3
26815	payment	504	504	266	1	1	2	301000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuDjjk2Wc3sECRGV4a5SMmDgLr3o4EPEiZXJKCJPhzNtL9Yio
26816	payment	1397	1397	1678	1	1	11274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRMxok74f124x3JyBPftphpaYEPWUEcwXyv358pivGbFeYqa1
26817	payment	1397	1397	1678	1	1	11275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE1e62PQh6N41ar2Sh9ufQ3gMFhXD8K9RAVeQJuAJRujDwUQ5
26818	payment	2134	2134	1874	1	1	2128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyWUi8dLzRjqmTXH2iLgKGDw5bdQbMS3hdjvAhupqAWaHW8Bk
26676	payment	1397	1397	1678	1	1	11237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9PENw2UKzwdyxsQid6hNRQ7d7sa6QcXysP7rdgB9YpcfgJou
26677	payment	1397	1397	1678	1	1	11238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9b55kKTsUzWJFDTdqA3V587s77BEHRQECPdt4P6NgvTAK35hh
26678	payment	2133	2133	1874	1	1	1660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2km4NUhf5Sfw58yLAbRmwYcgKEYxRsJUbAWoUCDgypGtVFk3
26679	payment	2132	2132	1874	1	1	606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXG6ZhdF4gNSKfyMW58nDowM1T2z8BHxsbpkVaPYLoByPh4YAP
26680	payment	2134	2134	1874	1	1	2087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4B8rLjVcb2RNCiD7wMJxZu5Dqr4wpHg2MyrJ7ww3SGgfMd7M
26681	payment	2134	2134	1874	1	1	2088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtsujw9HrhkQEiWsHtqKyeyPVVQvAWxGD4mdzCnC2d6xPKngk
26682	payment	2132	2132	1874	1	1	607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mjgCytxxSGodfPYB9mBc81K5mtzgtUSjN9GGaDj6w2MfmGno
26683	payment	2133	2133	1874	1	1	1661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HzCt4uBQUZF6c7ZeyyTLXCEP2w1dMidHza9YH8Jrm8QeriFx
26684	payment	2134	2134	1874	1	1	2089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MwcNzuGHCiDDenrZjQaUf7FbXiW52uXVbLts6R7zFNmkR3tE
26685	payment	2134	2134	1874	1	1	2090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Rk85ezzsCccPi8dovsmuZuQWECdzbdFeniMEAtqAAf13iRiR
26686	payment	2134	2134	1874	1	1	2091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXUpKc8ZyFnsbEv5yXhHv3dgPFKaSou9DZpK1No5cDDvWcAvQ
26687	payment	2134	2134	1874	1	1	2092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6ScH7ivuceuykbpUYyzo12Wve2iSJSX6WzAHQhAMEz1ME7rB
26688	payment	2133	2133	1874	1	1	1662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGTienvypGXUDKTjMoPJYFuoVEGafiR3d6J5GnjdgLcAKH5w6
26689	payment	2133	2133	1874	1	1	1663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1D6MXur95zNtVgQdpWtcX9moRrzuPiuwRqs28RrrupKm38dj
26690	payment	2133	2133	1874	1	1	1664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEJUYo3afNexR7PB6uDrWZKZZymaEMg5ongxtaYJzVhqNGJec
26691	payment	2133	2133	1874	1	1	1665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEpeW3wBHux8KWehH5AEDYvVwWFu1MCBv4WGJuYRGFDEDTcwT
26692	payment	1397	1397	1678	1	1	11239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNmurqU55xiSfv16Q9deJBKkaqE4eCumvUjUrDfaE84V21M95
26693	payment	1397	1397	1678	1	1	11240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDd1Gaxgqs6HxHn8JKhcGDiDBiKE3BkHzs6YUCtWkp7s8JBpiz
26694	payment	1397	1397	1678	1	1	11241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKYbmkNc6zjzFvwPMS6z2R8k8k7uuoEDMBkngF8CFJSHgnta2
26695	payment	2132	2132	1874	1	1	608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6EUoFJEYcqTGDvAqi1WvK7p4jaaPKH1p4MaqenoEcM4sYqnZ
26696	payment	2133	2133	1874	1	1	1666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP2CmAEthELiR2cFLiWhHKASvPaPNVtW4yFDLH1v6R2TEwhrK
26697	payment	2133	2133	1874	1	1	1667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEUP833Wu6FntANoDMQLa2Sg6RBAKoXPBMuw8JRVf6rVgrHeK
26698	payment	2133	2133	1874	1	1	1668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2tLioHgZSuKGDJ5zvTAULDhBvEHMM5VKAavtQjnmRzpNTVqT
26699	payment	2134	2134	1874	1	1	2093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DuZonv9Uvip7xDDqQTs7eKKQdJJTgfVrXt6G6UsEj94hHV5c
26700	payment	2134	2134	1874	1	1	2094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwnu4sPvWu7ZGKuNmiMrBwvaSmgp9JwGB24gCihPpG6J6cfMf
26701	payment	2134	2134	1874	1	1	2095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThXSf2UwdT9LLFvMm6s3ikU3AyBK3T8GELLbAyR9yADY5kouQ
26706	payment	2134	2134	1874	1	1	2096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWe3p7atqz9XBeDmGLxtrQmuASfkNNDcD4qE7GG7ZS8nkkAezg
26707	payment	2134	2134	1874	1	1	2097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bfJj2zJsopGubNNu6Zm7WNTiwRu935Xmw7jQGKYr6wpscCYC
26709	payment	1397	1397	1678	1	1	11244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQdV97GegkPZdBkEQEEH49ReH8nNgHYuXX3upA6nGP2mA1M7M
26710	payment	2132	2132	1874	1	1	609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcVJ4BcuWD4S6mwnrk7ZqznqSyuvUqDo7fVYzfjogEF2wpXGd
26711	payment	2134	2134	1874	1	1	2098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECDfFFEgZkeo6MpYyxTS1yAyaFiWsrZY21Rqv6cnk2THKDpLQ
26712	payment	2133	2133	1874	1	1	1671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvZT1TgCm2RNJTceqAGhQkSVRyJAveANaCJcefs8zmHxqXagP
26716	payment	1397	1397	1678	1	1	11246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGu9Voi51YYL5b2VvtqFnaSnAYG4hXrQL6ycvaMfv3C4V1nM6o
26717	payment	2134	2134	1874	1	1	2100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXDwUZzjd3mWgwtkv2DFokeUZT2vsYXzUqAVxYUdNUJHtPZyU
26718	payment	2133	2133	1874	1	1	1673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYp98o9CbGx6Umq4xVD85mtUTapuqhTnVBfXyUyymDthET4GU
26719	payment	1397	1397	1678	1	1	11247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqympnYNueDtwKXorPvYAKbPBFLXyC9XzvXfVRZHhwChM4xm2u
26720	payment	2133	2133	1874	1	1	1674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHwu1aZDzb6q5nSgP9ATTDXCqkDH9Tgq9uAMHABBCpA4i62Ad
26721	payment	2134	2134	1874	1	1	2101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNjtjrrsaGnZXkqzLRg2t9smQWVCzffsRQo1CvTF5HNjpdz4f
26727	delegation	2213	2213	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhR1c3BrGWVgyqnvDEH1CnGi3YdVpPB7Tu5fXLPGSyS56gHZUq
26728	payment	1397	1397	1678	1	1	11249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWx3Pfu9mFcyyoz2HAg3hPfprDMEgU64F8bcTn4yc4RRkb8ff
26729	payment	1397	1397	1678	1	1	11250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJtkK2xXFg5fzj1Pk8HtZPjEoYkxXaBztTAFaa9vRYK2i1QCF
26730	payment	2134	2134	1874	1	1	2103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfQf2HaNtxGPhAJM6BemDqEM9My2vM63qmYAqe4GCMWraZSB8
26731	payment	2134	2134	1874	1	1	2104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPN7tm7tVNAfLdLFdhd4Y6dTCmPCYYDdMWgeRjjgz4wJmZyvU
26732	payment	2133	2133	1874	1	1	1676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKx6KYaDUzE28eCkSCPtPXAg3RJigq2jL4KDcbHi28U69NetZ
26733	payment	2133	2133	1874	1	1	1677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HN7hBHG7tHLxasdQws55vkE6AZbkyS6jxnVoavVDGmdAUjir
26741	payment	1397	1397	1678	1	1	11252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfrM7krVv4BqV9XHfo8n8EUA6ySFcSaj5pRi2mbvqEaMp8zsg
26742	payment	1397	1397	1678	1	1	11253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa85BykUNL3gZKDcw6B8MMkXWjSyECnkGcLFgddioc8s8odKJT
26743	payment	2133	2133	1874	1	1	1680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCRMJciF6LqJb9NYhVZzyuKrv3ZKjH5MVzcucP3nzmCT262SA
26744	payment	2134	2134	1874	1	1	2107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTG2pnbY4Tbgb647uvmCnwLHM6sxB5wvYCKBqQZtHvPTvPehE
26745	payment	2134	2134	1874	1	1	2108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKF4xgD9q8ankVsbBGrimoUVpzbWFnndY7czr6DY2n5ePLEzZK
26746	payment	2132	2132	1874	1	1	612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofCegGySaiFokUMzBP9bPU9PRXbQphRXJM1CarNZ4BEjdh61V
26747	payment	2133	2133	1874	1	1	1681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjPVKMwbmZDzSWsfzy6CziyMUF972ybTSoDFDA82zN1DThhek
26754	payment	1397	1397	1678	1	1	11256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5d8724Kmjz3Tv1ZdGDfeqLUndSymjbpaN3qCh7ZiRPLQcCA5
26755	payment	1397	1397	1678	1	1	11257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzC7oaRyLPJddo2oaEKmh8wNkRrjAkwknaBi3kZb4LttZ4TyDh
26756	payment	2132	2132	1874	1	1	613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDz4oFTLfJ6AueomVf3hxbKbTEpPSp5HTxZfNZQifz1N64trzu
26757	payment	1592	1592	592	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmX28srnkTyE67BbNivGLd2xuR2KaMUHvJbBbrjYAqfUNdrJr
26758	payment	2134	2134	1874	1	1	2111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbvSqKfC4fBsuWPrTYiKA9t9BzYg958NjzVMHWGW1X24fPWqc
26759	payment	2134	2134	1874	1	1	2112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGoQn5smWfUwjdEAH67X1n9j9XQ3kPqGSjAWsUp4P3XQopJoE
26760	payment	2133	2133	1874	1	1	1684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7scoxmhHCsnnwsojTAnRRA6rSqi7B2TjDut8mGzEKGEvH16Nt
26761	payment	2133	2133	1874	1	1	1685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpkRc1PNWL4Aud2L1XPVE9tvocGLXzr1uug5Qk9FLJjxCVVma
26775	payment	1397	1397	1678	1	1	11262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmZCCcSFuFTjvzxBZf1Z1vffj5UmLcUCM2KeQyWRXNnmPhCmw
26776	payment	2134	2134	1874	1	1	2117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3MCV7E8S6EKJp8tbDzrQKYT9mdJKR3vNkieHYskrka3jwUGa
26777	payment	2133	2133	1874	1	1	1690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHb4EyfQp4V4n5jDJdcdxT3Z6QUyEQBUERiHSggNycnsL1zoE
26785	payment	1397	1397	1678	1	1	11265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH76vEv1aexNEyWDraGzXZh295TxSb4YfLfcuraArfP4ZT7VTj
26786	payment	2134	2134	1874	1	1	2120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdz3RUtXxEMJLDhQVzs8s85SYdJjdi1zParKToTp4L6d8ZzFWo
26787	payment	2133	2133	1874	1	1	1693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pbUa29osSrhCTGtgLTumVa3JjpMur7CsfdRC16nzpiowoLen
26798	payment	504	504	266	1	1	1	309000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyV1X6WBLzZimPVyiQs26AjSE4muMRN79gYcEZbTiVnsvsfgX
26799	payment	1397	1397	1678	1	1	11269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUFHiRybn4EpLCjYEqcMUs3vYv6rsrD9VXNnwMiZbtfAvySNF
26800	payment	2133	2133	1874	1	1	1697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjrpk8uwMz4zo7YTdr75hkML1A4Qb6yssyXD3qiSoa1WvQKsw
26801	payment	2134	2134	1874	1	1	2124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVr1HF3zc7sg65MgSwa9MiNosdjGyiBmJq55pGDAxsh51bUD1
26811	payment	1397	1397	1678	1	1	11273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFT3gUCpy1xLToWkfWqBrxHiX5DeD1SdNHxYjMFJC3Hz99nhk
26812	payment	2133	2133	1874	1	1	1701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMS7toKRLSJYaX8Y1awHFYJdXYUxkeKQXvbUmhw1HkpJKHMELW
26813	payment	2132	2132	1874	1	1	618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeD1cnPgXitbeLGArPvDEoUthMUGSRnieabLyacNce69hddX23
26814	payment	2134	2134	1874	1	1	2127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37ajmggasq5cpCetWjWx3yhzjRp1K7Q4Cq6HiCe7kL2UnrD8t
26848	payment	1397	1397	1678	1	1	11280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdMHK1KTGcMUv3twmEEVrwGLXg7VcKD2nmVBqqJXeN59x5NpP
26849	payment	1397	1397	1678	1	1	11281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9873z8mCqhwwt9hg9rmiDWuADzkfqma9w3xtxVBE3srfeNJsK
26819	payment	2134	2134	1874	1	1	2129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8V1s5WwqR5aa8v36caEBuRzF1TeQf6ydc1uNHMJEyAwMPB5gB
26820	payment	2133	2133	1874	1	1	1702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGPpc7bbQgcgWj44p1kL2Sq72uxWj4VCg9KqR9Ch1XYTg9KCN
26821	payment	2133	2133	1874	1	1	1703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUmtnJwPT4iPzbDjawmL3YV4t2Qr2wJEF1x17mQk6CK2c7Q4w
26822	payment	1397	1397	1678	1	1	11276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUK7sEmoaRocsddziP6GRJn8m2DoYVGNjvpWrVFyNr2BDUtKP
26823	payment	1571	1571	38	1	1	1	83861377858	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZnwBobftuU5ZttVnneDuBhugnrU7ZuTTRcNeEe7gvW1Qne8z8m
26824	payment	1571	1571	969	1	1	2	638264028136	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYjdwTNueqm1yaXcNU3zQhZpys8CoqY1wA1TYfyT7XmEVC1d4Yj
26825	payment	1571	1571	1089	1	1	3	1143763669776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZyFHVFZv6kfz2CLWnUchUuryDRbZj99fyAQJxz4UVVZkKcNjYk
26826	payment	1571	1571	1209	1	1	4	771720139099	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaLkX4fNtQjvxB8Zcwo7ZMzxPqLgh2y44dkaiX8dNDoXm3vVGQj
26827	payment	1571	1571	1335	1	1	5	2150466785124	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZpvkS58Qp6BNdYVLbWSUCuV334XWNKdYVAkoPBJgrkA6wjzgVf
26828	payment	2133	2133	1874	1	1	1704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQfkHwhPXW88KL8VJjXykpNrg9Zk9aQPErLMnCP7Rc38cbCji
26829	payment	2134	2134	1874	1	1	2130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7e9bqGEEqhaAw2fMXyc3oBnPBi714oWKytJqLEiVTgCmsxLhC
26871	payment	1397	1397	1678	1	1	11287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUfx7d7Ww3KWDQrZe32v5eqPf97uGTXLRLje82FabXiygSQAb
26872	payment	2132	2132	1874	1	1	622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxmtyNUv88AxF4y6woi94sSBKCg2kjRVyou6qpD3mpRwoaKYK
26873	payment	2133	2133	1874	1	1	1715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXrDD2DAmPxhL7C8v9oFHVqtt4V7rYmMhfvZgZin9hDeWW5v2
26874	payment	2134	2134	1874	1	1	2141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4AGgsjcqD4WJcrJ6dkm28eFXR3gnJFadT1G7336StYTR9HQ6
26878	payment	1571	1571	38	1	1	6	35946969082	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYSqZUwVunxp6kdSwsYwr5gDvQeKT7Ehvd7vdvXu65ZE8XTB8we
26879	payment	1397	1397	1678	1	1	11289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRcCUAaEYsj3a2CcazyYQ4299P115vsZdsaTJ5cJt5o7wfqWq
26880	payment	1397	1397	1678	1	1	11290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUBuS6L1munvGknPsaKFoS5K4QFENxLzyRRVL4kirS3suYB2U
26881	payment	1571	1571	969	1	1	7	273541726344	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaEML2F7Gf8SbHM7A7NfJvki4bUoyXcD5UfaehJvQWPz2qZzqHt
26882	payment	1571	1571	1089	1	1	8	490184429904	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZS9YyuAr1d1o3o33AhjsPChzMNQm3PTzZd6uAZM8yvQ7kkbrUy
26883	payment	1571	1571	1209	1	1	9	330737202471	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZj5sk2meWDbJmoKwoBHX8kz1XfNi2FxtCYGmTwVUiwaZHzkz71
26884	payment	1571	1571	1335	1	1	10	921628622196	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZzvWpszZ3iXvsAevmwK4YWbrZknDYMwmESXppys7FJyvsJQgbm
26885	payment	1397	1397	1678	1	1	11291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcL1RUJodGWoLDc7AAs4KE4kTd9abjEaAESFkmQKUwaTu8biM
26886	payment	1397	1397	1678	1	1	11292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpMhwEh1pUfpUXrxUh3b1tonbcGGb8qWvQMYN5zfG5P3QKdQM
26887	payment	532	532	1724	1	1	0	3590000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpYkVjjxKkcwuduEbw4upahWKy1Rh3F2vcSZZZiqQbJvAL3DpdQU
26888	payment	2133	2133	1874	1	1	1717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVR3MkcGAQhxfeFrMQ6ZiyyRxPpu9HffXRw2XQkyRR9dtLKWk
26889	payment	2134	2134	1874	1	1	2143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47Hc3EhEBSv9Bpu4caVzrquBddB4XfWtcM1DFFUa1aTPvDHkg
26890	payment	2133	2133	1874	1	1	1718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMxpnaWEeTeqYuJdFZpNu4nWEWsSHYYV8GGnHmfXAdYVa5wU5
26891	payment	2134	2134	1874	1	1	2144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM91SkDyszwRkmzi6sborJ3eXSDEvkJwgDssgWR3K8qUz2MMUK
26892	payment	2134	2134	1874	1	1	2145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYfaYiyCPrmHtw9r1yjKDhXrp49Xawvtk71Jenrodxz9YD7ww
26893	payment	2134	2134	1874	1	1	2146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarrw6jw7P2cR5cVQU7zkoRw7SmYeZotR8Jf4uDnR56iP7RpdX
26894	payment	2133	2133	1874	1	1	1719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9nKxmzrwHun4F54Zyj9QpBqWgs1LBgHAU8v7PdTqSo4js7tY
26895	payment	2132	2132	1874	1	1	623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21NcxHc1QnuhwTuzoBxrY1xnEtbJWDsQ6ARGbgFh7jbSp6MQE
26896	payment	1769	1769	1769	1	1	47	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NPvfMLGYb1t7otyzDuTzQXzfm5LsF5HCRqkGf78PRfvDru26
26897	payment	2133	2133	1874	1	1	1720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6UB5dTDNvq49YjT7KxxQN1gjfKQ1zRMomtVaJLVUtP4jQfb6
26907	payment	1397	1397	1678	1	1	11295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4ndyT5PkUbzRWf1nfHHJ2MvaqWD989Aph9dZqkxbZ4c5f5s2
26908	payment	2134	2134	1874	1	1	2150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkbnKn6u54KiUvS6TZ8jgQ7XUHsERKRmuxELRWAjUxaLp5b4G
26909	payment	2133	2133	1874	1	1	1724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaknVysGSDrE34iJwbotxV6NpGFU3CTDAJQAJSJme2cbVUdYY
26835	payment	1397	1397	1678	1	1	11279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm6G7icTU52bvq78HBvPeghgCdLdtcagiATQTzwL4ACzvwrBD
26836	payment	1749	1749	1950	1	1	18	2000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq91NG36F4Cy5GpyMukBd41kFTEV8amUZX3bnuy9omSfa1KVh5
26837	payment	2134	2134	1874	1	1	2132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf77Dk3cnCrxfYELUsogcFa4f39UsN8e4rCeA1sZhTCVBHMtU
26838	payment	2134	2134	1874	1	1	2133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KiuB7eyUxjHvT9EFmrD2tiVBvHUVV9ajHzTJyDtHhW1NkQ3X
26839	payment	1726	1726	2215	1	1	8220	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZY5f9LGRWu6Gr4dwJXxuP6v67r9C9MaGpfesYJhdHMEv8rreSs
26840	payment	1726	1726	2216	1	1	8221	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZP61ePAgG5t4bsnfJnTqPATbQc1hwR6vEExLJDkiFKEj5YvJbb
26841	payment	1726	1726	2217	1	1	8222	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYay3yKEYZyw6s7C5HqLLbANgq8vwg6CyiE34npSMeAiavyYABh
26842	payment	2133	2133	1874	1	1	1706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJLTr5G6YT3sDstc95WNxppWBqhchEHmv4ZHeTAn48cXukjdE
26843	payment	2133	2133	1874	1	1	1707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEzDhpcygL36vUTLNkPrL8PJWhCN4UpG77TUQ4FzjSGaPdp2e
26844	payment	1726	1726	2205	1	1	8223	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvNgKide4UdXhv2EEBHTCajguprBvGtBNrA2nyBYshRZZcdAKN
26845	payment	1726	1726	1930	1	1	8224	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSFM4Cn5GSRb9uXLbbk6DMgh1PD2Qtt9S3T53kRFaC6WkASi5H
26846	payment	1726	1726	2218	1	1	8225	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcNZHFQL1oUQsAyTetHqERUFish3117fZGmTd3pc5LWyn3GnCY
26847	payment	1726	1726	2219	1	1	8226	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhpwswM8Ei7VMdxqxiMvY1GtCX6WoXJkGsoSN35cR9ekrksZbu
26858	payment	1397	1397	1678	1	1	11283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kfqeFRUEJ4UQcdf9ZTmfHRMgPhzRuQcBKdGGjzWDoQbtgavn
26859	payment	1397	1397	1678	1	1	11284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMNAYhqwaT5if3V7frvJ8NAXf6wGEsbun6YVX9C79CnrLBZbf
26860	payment	2132	2132	1874	1	1	621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEPVXHfopQbjQLL8H4qPEXowBUm7kFQkZYaj59KPhQKKTYDhp
26861	payment	2133	2133	1874	1	1	1711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2aSpVH1uTctnNKRwcxcNbJQWtJDWrCqU5EPZNVtP2JsXz5Dq
26862	payment	2133	2133	1874	1	1	1712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WLquigZLKZbufpypT5pauq38Zd7SKgatL2KotMXeHDfkCWBL
26863	payment	2134	2134	1874	1	1	2137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7N1VGLCzZedspG24MaU9rQfXi2CxZUuaatLPQgiV8oBFbN4RD
26864	payment	2134	2134	1874	1	1	2138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAi8uNtkCBnYUMmfZr7xmCJsN8476wz3XuHsg39b1WX9eYpU67
26875	payment	1397	1397	1678	1	1	11288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZTPMz6LiHniGrQSxjCJgZ6qAWVoJNQebavQL5wxQrkQko7Bh
26876	payment	2134	2134	1874	1	1	2142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLRixXhhku7udjaBEdH9DkWzKB2uH1TVcipcF3yK3sgi8W8Po
26877	payment	2133	2133	1874	1	1	1716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwKFT2vtvbpbGV2ymXbdbSQ9zJdt6v2kc7yRNmMv9ZcZqaocP
26905	payment	2134	2134	1874	1	1	2149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfB3nVPYrKDCm53TdZj68NU3HWPfTTFXzWtZtJCRzDhWq5kR7x
26906	payment	2133	2133	1874	1	1	1723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMY64sLQZNftLCHLr9ysEktSzYcSfb5EZSt3d8cLFND77PDp1
26924	payment	1397	1397	1678	1	1	11298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDykgeeLWAR7TxXPuGHDkrNyeF8zmYcRcuExMwT3wUarTomrnP
26925	payment	1397	1397	1678	1	1	11299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJvmF7shmxxC3PqpzedvPikeBauGxWQx4vE498nrhXvFwRmWs
26926	payment	2132	2132	1874	1	1	626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuB7etzbVY2b855cFWDiVLwjgSmiC88oDpw6SDCYsLBAHQAo21
26927	payment	2133	2133	1874	1	1	1727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24yKDTnMVNQ3Uxjitn4Mf2XbpHjx4PuFQUQXBZND7r4iMyc7e
26928	payment	2133	2133	1874	1	1	1728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4pCQiW3HSjfFbG9aVQPpg9T55gGaayNWGGEnkNMmYQCgFXpj
26929	payment	2134	2134	1874	1	1	2153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52K8fVu33wt71x6c2YJkyCuKR2jkikexCFPawKXHK67yRy7Tw
26930	payment	2134	2134	1874	1	1	2154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLj3HfeiW2HiEtoRYAow7h3tY9XieZHwnN2eZK46kuu2x7UbA
26955	payment	1571	1571	38	1	1	21	59979698470	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ2ewukjDzAGm3FGGwvjaCbvuqwvAAHCrEbZrNCSzMZL36unLw3
26956	payment	1571	1571	969	1	1	22	455902877240	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYcqYuA2gdL46fjFjgDV6uSKeViGxPCpkQjGUfN2pitAWNpw81T
26957	payment	1397	1397	1678	1	1	11306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnobQfJiuaXPEdNJ85mgUx97EugK8je4BWdB2HKsq2TemvCkQi
26958	payment	1571	1571	1089	1	1	23	816974049840	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaKn3HhPvtsPtqthtmPa8PNaPsFH3ELK6cxVt53LsaVQSQ95Wsu
26959	payment	1571	1571	1209	1	1	24	551228670785	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYowo5goL1hKdBAoYTocRT9N57yJrdmWLhkHrSC42Sh7CTA74vY
26960	payment	1571	1571	1335	1	1	25	1536047703660	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZpkGzbfnLuNHcciBHUyEdwScCA4zpntW7tz47eiEweRZ4E68uK
26850	payment	2134	2134	1874	1	1	2134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgXQBgwxzoVaYFqrqzwb6gW9nLfk1LXZTCW94ab6MhKaZQzdf
26851	payment	2132	2132	1874	1	1	620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNezNUKQKRD8Vtud5NdZ74nHkEHKLth5Jj326vAaRZz9QJRNsc
26852	payment	2133	2133	1874	1	1	1708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVVbLurSgdQPhtyGdhpoKm8W4vm1FK7MZrXu5ueHk4PVaKcJG
26853	payment	2134	2134	1874	1	1	2135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Hn6F6Bf2ci3BCjsNqpk6gYcjfCXGgmnMWPFTDwySNzxQ9KDg
26854	payment	2133	2133	1874	1	1	1709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAP94gKFQh73Hog2YEpDHj1W9fnP4S45gmMxCy67AJ2AnEtz4W
26865	payment	1397	1397	1678	1	1	11285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmgq9z1xv59SZ1Bs8HpsYGUCYxpZvCExi23jZgZ8t6DzJTFor
26866	payment	2134	2134	1874	1	1	2139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPy3o5Hyygre5R2nFS8d2h5tt92gfH2iWBq4ZX42hpyv7QXZq
26867	payment	2133	2133	1874	1	1	1713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTjmarcuRrPf817Un9Pr94JQ8bCZsMPsZezk6GRpd1WzD5S2G
26868	payment	1397	1397	1678	1	1	11286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvZcnytH247k2pWX7QwNfFtoWoopk5vm5M5y8MnESBdndHfLC
26869	payment	2133	2133	1874	1	1	1714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQb8EbozEG3oQ2P2ANtb6xfJcXBKhj1j1cGmty2ZRMR6AXEPmV
26870	payment	2134	2134	1874	1	1	2140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHDYf7Y2u9EyAWWw6i7UbJ3KtVvpiAb1j5ePdZtcXQ4uwNY3g
26898	payment	1397	1397	1678	1	1	11293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ejwc2YA91G7iPCP2mvyoqJXkGcF3KqmSuVuxotyAB8kTvkTm
26899	payment	1397	1397	1678	1	1	11294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDYVUVvYPjwpf7k3eZEaerAo88KzFzVwjC4g2Qaw272Nfu6jE
26900	payment	2132	2132	1874	1	1	624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8QVfDUsKUFi57QFUHT84RoNibMxycJteX63n5UjRLDz6TWBj
26901	payment	2134	2134	1874	1	1	2147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6VijfpCd8N8UN8xZkLfDJyyaDZiLuqdeBLcWmQXYe4g5Hjv2
26902	payment	2133	2133	1874	1	1	1721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypgb8Pzdbvdi5PnD75FKQe7bcYGYKZJTFLnzyhwUFV3gJy8ey
26903	payment	2133	2133	1874	1	1	1722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZbPGvLCsWmXuB3QkMDhqenUwmaJdWYCJQX7sjftbAENmCdao
26904	payment	2134	2134	1874	1	1	2148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowXS9vCXZU3CdFFax3DphwpSp7igZyUYk4keUy5uprZFuUeVb
26921	payment	1397	1397	1678	1	1	11297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2C2kKZLzxXSz7G532HcRnhjj9VfoWUAsa3kBHBWM6Guoid22d
26922	payment	2134	2134	1874	1	1	2152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMhLCcqevLudmKHC9B5Athw4r7NJMqceSm7SVvRkBb48wPR64
26923	payment	2133	2133	1874	1	1	1726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrJhYJf7rfK2jq8NLanTdEWAqRXkYHiFndcuZ7TL3tCk1f9qS
26931	payment	1397	1397	1678	1	1	11300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZXjvwzs7JSrEenwi68hGpnydqDvKz353AtJZ1akoVFcr735R
26932	payment	1571	1571	38	1	1	16	11978839694	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaCUf9F4Eyvuz8AUvLMWbuGciDvkjgDZD8N4GLysiYydgrkj8qA
26933	payment	1571	1571	969	1	1	17	91180575448	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZYgbbcYNU8JET7z7LEG5CD2MGX9n6eSM5Cfwy2e29GacL46VAz
26934	payment	1571	1571	1089	1	1	18	163394809968	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaAPsdSKe3QSpYU2Vjwy5MESoqxT5twwuswpomkTxckMNVQtCdH
26935	payment	1571	1571	1209	1	1	19	110245734157	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYQ4DJhKanp8UmJkkxzW6ERupa7oNYcVXbXX1ikRXtUGQTWQjxp
26936	payment	1571	1571	1335	1	1	20	307209540732	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ3qM1kVA42sy2NyzBbptCym7tRFyJYGzzZP8ZzQd6dNfQMpNaL
26937	payment	2134	2134	1874	1	1	2155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHFGzUnzYxnBVy8nVC4d9gAGP3Lu8wZeps451dDEcASccMYw7
26938	payment	2133	2133	1874	1	1	1729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFC2dNr42xjojjsnaJbvZug3L2m26Vm2NA5V3RfyTyRhcsTUCr
26939	payment	1397	1397	1678	1	1	11301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnNZKAotrnpTBaEoWfTNRaxMcXnhvDpoqdtCwE994rhwmbchj
26940	payment	2134	2134	1874	1	1	2156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxxcX567QkTddK1chk2mZUC2wse1HfqYH3o1ehyeyu5LZ1DpY
26941	payment	2133	2133	1874	1	1	1730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9foyhn1NzH7JGmSNJXEWtCcnC4sA14ur4ixUK1gWsHArW3Te
26946	payment	1397	1397	1678	1	1	11303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8QB2dGsReYgLRG6cZZQUdp66Mp2CGbxpfmSUHWvpfnRSbF1t
26947	payment	1397	1397	1678	1	1	11304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS6D7KitL5ECHBkkzWRbvaHvKKMNSAMVTD3qvr4YNU1NkeUUF
26948	payment	1397	1397	1678	1	1	11305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFP9F8PzzyG5seCR384VbGGSZdgnbsSahw7i8Fe7ZKhNZ5pms
26985	payment	1397	1397	1678	1	1	11312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjFTBiqY3DT7amh1vxiR3FfQaGpXdCA3bWJcBBKYXzCQqMBrd
26986	payment	2132	2132	1874	1	1	630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcvGvMYv7qSpzsdKuCwCa4eXBkpXrNqnjvAun4tT9L21bXdYF
26987	payment	2134	2134	1874	1	1	2166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxhrVRNWhqaFuKmT5xHppDLUAvsr2hYjiCuW25De5uXnwxESR
26917	payment	1726	1726	2220	1	1	8227	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYqKJj4Ydj435b4AvYodToozhRJ6Do6t7Dy7YohGsYudxumNmEi
26918	payment	1726	1726	2221	1	1	8228	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQ43bakwKtHRZ3ECzz9tEA4N3z68ef9yiQi2zQdEU7xuAohcGZ
26919	payment	2134	2134	1874	1	1	2151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjhkHRURwgM8oy4ndLYubtXdGf63YarSnvbZZ7GXXsJqYxKqw
26920	payment	2133	2133	1874	1	1	1725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbjXSDxMcwSrhGnYr8xCBwdo1JiuUJiB799EXo8XQHVZ43sbq
26964	delegation	2216	2216	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNZHp1pbCgofhUq6kRLC84VYC8Lev45fHB1ymQQT9rw3AyHsr
26965	payment	1397	1397	1678	1	1	11307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKCbSSRFnfdDPW9Pjc1PTXgPZJjpz6WrKUooyEzJbF46xGHm5
26966	payment	1397	1397	1678	1	1	11308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmQPeFWsJjYWbtFQDTGj2vVXMhP2tVSxvC5ErpQ6t69LGF97Q
26967	payment	1397	1397	1678	1	1	11309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUqG7u88gqdmSp3mzHaubNVxivysg7JT4xJ2B3LZ1JgeVv6Ch
26968	payment	2134	2134	1874	1	1	2162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDks44vEnkUU1nUgRkVZLSUUBvvp2KrRDEUhCDrwSEYttAypR
26969	payment	2133	2133	1874	1	1	1736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKChWo2iRtyoKQS7k4v9EFuMNJehrt1JXdGXLcKPGd4BrxQ6q
26970	payment	2133	2133	1874	1	1	1737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCZPeC3vuw3vGLyZpsF4YjQ8ts9Ug7odx1eveoYpoqYQ77SGa
26971	payment	2133	2133	1874	1	1	1738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18VW76YNYqhK7iZUUSFQ6UvqaFMCivskqeXiNSrRMeu6td23Y
26972	payment	2132	2132	1874	1	1	629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Y1HYSpRfc4drBn8QVRGA4KooK7dpSfopvcuGho8ZSi7WAMND
26973	payment	2134	2134	1874	1	1	2163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzGrFzNajdyCA6pYiBaSoXu9FjUaQ393kLZHt4iaKibJJQsaQ
26974	payment	2134	2134	1874	1	1	2164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPUwVY7kHzFLYQxyXKf6m4Wv78paZnQppMBjWruDQx7U9ZyjH
27004	payment	1397	1397	1678	1	1	11316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccQY195NxqXLT1o2L3NtgCVY6TGgysKwchXudRYuUPQdS8Pqs
27005	payment	2132	2132	1874	1	1	631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLq4VcRhbGPprEzQzKhGWHN6eMYXH3Wvx1EmjicnLfyxspPDk
27006	payment	2133	2133	1874	1	1	1745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEiZjAf5kULJkR5sGqF3nj7P6zwcKyMjBxSGvKKbRAjrgk1zx
27007	payment	2134	2134	1874	1	1	2170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPHpG53Qwa11MenfzWWcvj9yAYo38rqPbHeQUUqNFq1waz11A
27008	payment	1397	1397	1678	1	1	11317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgtubz3wpDsVUfiKwWn9o7V1w3ZVeto9dqrBpae2vE6KsCD9L
27009	payment	2134	2134	1874	1	1	2171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aRp15WWsytaa1h3mojLJXyTpV7qi5F8cpYR3n9hAx52kPwCo
27010	payment	2133	2133	1874	1	1	1746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn9jLoFPnuQJiEoRNZ2CWUuKUdTayKPeF41KxCXCQAXM9XCAC
27011	payment	1769	1769	1769	1	1	49	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysuRcWqFAyPyhhs18Y7EKPtCopdgS23yYpGLrcWCnJWqrbk2Q
27025	payment	1397	1397	1678	1	1	11321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zFziMC8mbsKrG8qn3R79XhNdygxZMCYv77bDyAifZgsXqe2E
27026	payment	2134	2134	1874	1	1	2175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbBay7PCSBFKt1R16tPKGCtcMCKTJdYY78yiju2yPYE52jbzC
27027	payment	2133	2133	1874	1	1	1750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2yKvFZdKGTzTmwFF523xyQPd51ppN5MhvZ9ndvwmRT5CzAZR
27038	payment	1397	1397	1678	1	1	11325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRoNr3KG4mb4BiNEAesAF4jHFzuViRgc63vGeMks268WXJfpP
27039	payment	1397	1397	1678	1	1	11326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNXPabZ1NxZQvVfWRjngDz2WGRvShax5CGdFjARjWrUCqh2cc
27040	payment	1397	1397	1678	1	1	11327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSvTnksWqiiLMZgSTi6CJixKWt4e41ts4t5ift8BC2x1EBBc5
27041	payment	2133	2133	1874	1	1	1754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbohsMgy53Xiy23VksK4YctRumM8gsZV1qqHfksdvpg5DrPx1Z
27042	payment	2133	2133	1874	1	1	1755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBVBsFrvXgpLXsnezbmPPGmwBdmEBYjbkpMKbhpANgG25tczv
27043	payment	2133	2133	1874	1	1	1756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXTGFPujfbXaP6ccQDyS9ysuixJzeQYJ8q7BbXniepfmzrYRe
27044	payment	2134	2134	1874	1	1	2179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfbdW4LuyTv4uaeEsGzh8yzpjyYejfEv2oyam3kSaaRD9bvRP
27045	payment	2134	2134	1874	1	1	2180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfnLK7mRHPTXweMND7RDqvUmPtMSBKwTDd5nguC14SxSBokeN
27046	payment	2134	2134	1874	1	1	2181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zVAPaDThrbZJQwm88WHw5nR69N1XsajVXHsEzXQpJUeDLLdN
27047	payment	2132	2132	1874	1	1	634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsvLKEzdbDv8XX1G1mmmTmYm1EwHEeRUQzDA25nnWXJqJTR1c
27048	payment	1397	1397	1678	1	1	11328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9C7PvJtismyD7c2QrpBv3hMCS7V7j84jDJPpcWFCBSn6qbwAV
27049	payment	1397	1397	1678	1	1	11329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdoMufGjsaCLoxfvahkXJSuKE38wghCnWTBTaWdda7Uepbq1c
26942	payment	1397	1397	1678	1	1	11302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rQ19BpWPaVN4fgmXQTdmbqqhwYGKEmfGzQDofK1gYpVjxUw1
26943	payment	2134	2134	1874	1	1	2157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdJnMVnLJQsc67DVN7fJVGBcfFRmWQ9mFdwXgNdZJU3fwQv2q
26944	payment	2133	2133	1874	1	1	1731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4GjYjN4FPB7kZqAnUH581LSJf6rkBL2q3XtQydFJL8ZaiCtm
26945	payment	2132	2132	1874	1	1	627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVKYkugEUyiFcm1tXZDbPaPhXQ31ZEnNEH4LYRW8KeEm32NY3
26949	payment	2133	2133	1874	1	1	1732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXbHX3YjhyvY4hD3JBMXPtRkWpz9JJGUgNmdScSVe5w3JavUK
26950	payment	2133	2133	1874	1	1	1733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRY8xfpxha51mG8yamx9aSQ7C8bCeAL9WFfoYJW7LWrpprW95Y
26951	payment	2133	2133	1874	1	1	1734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUubrP8QRPUMGS6zYcJ1AMJ9kjkCfUYrJs6pWvYLAunrGssu7
26952	payment	2134	2134	1874	1	1	2158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGU8S4yB1B2fVSAbqPohV7ortrs8oqfXhfe3SoEzYmvEcVWpb
26953	payment	2134	2134	1874	1	1	2159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1B56h63af2wwcsPxA2Lw2QsvSPHwYu8fyKqzbGLsBFrPWqrpD
26954	payment	2134	2134	1874	1	1	2160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhAX75ytoyQJT8ikapCAPmGqdrn7obTjEfvu6sbe5eaPD3Xir
26975	payment	1397	1397	1678	1	1	11310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkuoGDrKdJNNevVcVnEqAqkfr8zCJkxRXRSVVKk8KpQVRYCBh
26976	payment	1397	1397	1678	1	1	11311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYop3HQdhDdTs21M8pv26KiVA3QP7TxiNRW3ncNt1JuAxY3MT2W
26977	payment	1571	1571	38	1	1	26	47928658776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZp7vcJetSFqtKDVtfzPj6XKYePnT3r6tEftPfaDda9e2irDdoY
26978	payment	1571	1571	969	1	1	27	364722301792	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYzSpSuUypD95ykieYRzCcbdo351qgxH3j5Kjs7vSF6AowVnK5W
26979	payment	1571	1571	1089	1	1	28	653579239872	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaLZgHPCYLu51AiEU6znmBYKVDSmndW3s42ScBDCg6fqAtxMGKp
26980	payment	1571	1571	1209	1	1	29	440982936628	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYoHbwJenY7jPUZfC74ivp2DrhtvZhRtu7QreS6roZUvCSJsEs3
26981	payment	1571	1571	1335	1	1	30	1228838162928	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa8ijHdf8PEk9mnqrEAWjJzN7sUj7LU6hfXtpia4P2qbab4mLsY
26982	payment	2133	2133	1874	1	1	1739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZbUn6WheZiXqwYw1TeM8tWu6ffCh3s7ggxcHT6xHw6wuMQw6
26983	payment	2133	2133	1874	1	1	1740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeksFWEavP2HEanPwddNxkwXCCcYMZFsP4VDKLcVSWmo1Sahuf
26984	payment	2134	2134	1874	1	1	2165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mgsJwCnRanKQ6BZmT3ud8Lk9qVJGoetEWNoMQTHV7e4xG3vZ
26989	payment	1571	1571	38	1	1	31	24040329388	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYYyzRjyzwhorC4AWgkhKi6XJVRyMVdNqsoFdJdeb4qCNEUn9Jq
26990	payment	1571	1571	969	1	1	32	182361150896	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZWAYJqRdbDDgz1hYdaT8kwyy2jbTjsj4jv7eJd33GgnPZrJhw5
26991	payment	1571	1571	1089	1	1	33	326789619936	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZwzHHfAyjxV5mSj3E3KNN6HYDCCaixfUv99aEQ8gpUEiE7m8Cp
26992	payment	1571	1571	1209	1	1	34	220491468314	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZgZwN7NUJNmCHmMEmkKdN9tp8zDq5xbsd5AjTxmBHBJDNH14iE
26993	payment	1571	1571	1335	1	1	35	614419081464	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYjn3ZzmcUVXhxmxyKFW5uVW8kkmh7EzMUU44ALirduEE79KmkA
26994	payment	1397	1397	1678	1	1	11313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiZAv3eb2y6ztNhVyEeqWnxQugT9fivk4dE2h1wYaWAocZamz
26995	payment	1397	1397	1678	1	1	11314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9n1foWXzx2ZR9zGZtPZTB3NNzaL2CUVke553meqq2y8U118K
26996	payment	1397	1397	1678	1	1	11315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqymrH9JRpcXE9knwqvExzG9kWa6wBrzSD39oUn82Qq42ir7A
26997	payment	2134	2134	1874	1	1	2167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvbCQa1epnZ2wjc9p6x4hoLZArH4DZuEVaN6DSbA1FfxDK2io
26998	payment	2134	2134	1874	1	1	2168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoZJ2qme3fTukHFfKssobVjT1qU22mGC6GTcJhp8efuGE3jFZ
26999	payment	2133	2133	1874	1	1	1742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hkEG9Dqetc7nmaquu88rsS4VMz3jpHxQkrDnsU7xVDRhPFnM
27000	payment	2133	2133	1874	1	1	1743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRs1UQWRuEjbtXGk6nrvh3ipEY3BJkjZey1j9ZJUVRDGMVNht
27001	payment	2133	2133	1874	1	1	1744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsETnZ68kSW1Duwh8TTksGHXJKGiv7YvVrd5vubA1WmWJUN6j2
27002	payment	2134	2134	1874	1	1	2169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dHE8DC2vCcRBuDBUXgFYmG6fay5qL1goaiBFWNESvc8qcS9z
27003	delegation	1769	1769	1406	1	1	48	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMbi2R39b1jh2xPvbCVaRPxiw738QexXrNotexEBep7i7ZDou
27035	payment	1397	1397	1678	1	1	11324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCSsVmcCKhQGd6quNreUA18VAjuQoJwhTusQ7pHy1QJDwjA98
27036	payment	2133	2133	1874	1	1	1753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JeFy916zL4pEkmThioXUjJhQRcAEGeE9nqwbZzpR1HCLrpmU
27037	payment	2134	2134	1874	1	1	2178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqrPZBUVK9ioQ3Qnrm2RuUmLtJUg88vW7hLWnd8LAzEBskSuo
26961	payment	2133	2133	1874	1	1	1735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvW69zs5wGVGkw41axZUTEK3BbDdJHJDTPdBVAavnSRSfxFLk
26962	payment	2134	2134	1874	1	1	2161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WZ6UMsR4AtCsAHniLJE4aCaur71V36mcESj1944ScT8dcTkC
26963	payment	2132	2132	1874	1	1	628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dvC8A8khp1EH4t5HHcZ1hDPfCeHmZUqPr6sDCZUSva2g6ZF1
27012	payment	1397	1397	1678	1	1	11318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbP892NsrrqtFKoLETUCNTEjvefFJd3RU3nSEJh5g12yPEBuNM
27013	payment	1397	1397	1678	1	1	11319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYascJLuwRGUjSkYhKSDMo6rhHBba1ztkgyyX5yHwszz3kLg5Ub
27014	payment	1769	1769	1769	1	1	50	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC264MwbMrULUDyD6x6Gpk9EVzecBUZFUtdNLhSHgPJ6a6zLG
27015	payment	2132	2132	1874	1	1	632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmZqwUnUdKRSTeSupKjD3b73YevoQy225WWV7EZ4E452dpZYL
27016	payment	1769	1769	1769	1	1	51	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2w3MLk5YorAzNqrLFmuu39qKupwYEjwA7SjBKtsibhnmKUaY
27017	payment	2133	2133	1874	1	1	1747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR961n9C7h9MyZp3LxLgGe84uw7MyqMcTtfxsrPaMCVB5uvMAW
27018	payment	1769	1769	1769	1	1	52	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4VLKWsQEQtNNENKjLbj5QhdQ9vFcQZ24ubj4v3xf2gMozy3b
27019	payment	2134	2134	1874	1	1	2172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAZqNjWEe8XAzcErWEoiXprdde2rBbetnP7KWuNQrftRJXeFA
27020	payment	2134	2134	1874	1	1	2173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKAaXjoCKspqV2czcarR7GyeNugLcLyJysAgJgiQm1BfWgGEk
27021	payment	2133	2133	1874	1	1	1748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHunDoa3zysK6ZWWumiDxS81PGZ33198wF2Rwe8b8sKLZYrJ5
27028	payment	1397	1397	1678	1	1	11322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMfBirW73gTWe5gwGUrdEpHzcgxuCtaBpinrYsbbELAtDQ1sL
27029	payment	2132	2132	1874	1	1	633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUjaNtFWJ5st1ZwJhUNgLKKN33hs63vbGER7jdoFWutAspbVn
27030	payment	2133	2133	1874	1	1	1751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGinuSvX3TVFp887tpKYmyScxPywjbZmuEzeQBxhCne47mecFq
27031	payment	2134	2134	1874	1	1	2176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxNFQVUG48WHP68mwSNq8ZHHdp63Zb7yULccuvt9kdjQhc9Sn
27078	payment	1397	1397	1678	1	1	11336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NYmRXvKcb9RiqjtGYMNnETKyHwLyQnH1XCPEzhsW28Kpfzro
27079	payment	1397	1397	1678	1	1	11337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZJwVFaBXWAYuKaT9PiMTRDSbfTL52DFYWyXpA4hc56MZXUdN
27080	payment	2134	2134	1874	1	1	2190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsrqThU9nmisrPosriZvwaLi66LrFeBF6FQWrd8b13eBtDCy1
27081	payment	2134	2134	1874	1	1	2191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4HyCrVCVKSZoZicW7vDpATN8bx6S6J5LqtwQ1DuxKg4nK2ga
27082	payment	2133	2133	1874	1	1	1764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZvVV273w4ybkT2wWpLAfoFV28nRVDN1FeGLri3hgb8MB6gZq
27083	payment	2133	2133	1874	1	1	1765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBF7GdcFRe5G5vKCdLXFcnvdv6i7qUf8sb9sRMzf5P6V7F3Bb
27084	payment	2132	2132	1874	1	1	637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiifE5GFb3qGinM4d9pvtdogSrkQLUXLidKCKrFNxMWmHLKhWN
27093	payment	1397	1397	1678	1	1	11340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNo2uUGdQWqN2vwcAJb1YJh8hc6vFcEc3KuXkQjJhjpXZzMWY
27094	payment	2134	2134	1874	1	1	2194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuJyU3ytAjQ5pKjGchxvdgPbjNEyxmrqWVJqfZZyPyiwbPjoF
27095	payment	2133	2133	1874	1	1	1768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7Y6LpjbZWajm5FFL1VqBhp8NVeoxLoNYtpjm358Nogfuxiyn
27096	payment	1397	1397	1678	1	1	11341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHYmQf7SrDdo9b7PjeNbhp9dRdg2JpzkYHMhyhjfP8UyLhLgJ
27097	payment	2133	2133	1874	1	1	1769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBoaKYVvPqqPP9fJ6qLCeoebss3W5Fi82vzmjTt8PDsYTgZyP
27098	payment	2134	2134	1874	1	1	2195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mEDcaVuT3Q657DMpduLfypso54yoM8VbHHCiFkiNmSwBQm92
27105	payment	1397	1397	1678	1	1	11344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQUgJNjFYngXoThg9uRnX1FkUzY7cuDDd4UfQa3YHzYQcT3W2
27106	payment	2133	2133	1874	1	1	1772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp8xjgHifYuXyQqWPeeVSzEJ1dYD9iHPu9itMjZ1RZeHd2qrt
27107	payment	2134	2134	1874	1	1	2197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuPm35DQdDEc7gHNb2rEKDnciSiqZrixPV5bZWXJgGz19TPk1
27108	payment	1397	1397	1678	1	1	11345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvxyoUJUwc9W4wZbyKT9MX121GHrXkB2jHr2oV2hibi3YsZiW
27109	payment	1397	1397	1678	1	1	11346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4ZZoqGf7d7AVvVxMBDHcUNw8p9qSnzN7uabSmNRBu4Cmar4A
27110	payment	1397	1397	1678	1	1	11347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6CCPKhdFCkLCpgahu8Fh4qNwgroCGUdChqD1YvMNfdVirfsG
27111	payment	1397	1397	1678	1	1	11348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UptTd6wHV12UCZCuPhPrw6Q6nf5Y8X663R4qJjsoobCjPKNE
27112	payment	1726	1726	2223	1	1	8230	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYVQLE92a4ZDALSFScsKJSSaA1rBP3WkWJGnTQAJFTw8pnJot4a
26988	payment	2133	2133	1874	1	1	1741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J5wGFJhrrnZgQHMDPYjKS3LGiwoZLvjWVr6HWHJk3oEBgGfS
27022	payment	1397	1397	1678	1	1	11320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazD7EBRPCFQEgT7AqMwTW8V949bvoJzd4uyQA3EEFQ5ttYb2K
27023	payment	2134	2134	1874	1	1	2174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHrKXNkoazAMcMLtQJr3vYZiNr2t5yrypYeKSgxUNBNLvGabG
27024	payment	2133	2133	1874	1	1	1749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eo3JuNhK8B5PGqaKUPFTrQGnz6BT19qPwVZv2AdiAJ2rTESq
27032	payment	1397	1397	1678	1	1	11323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPX2GHZQPMPw4QDTDzeodQbC8RePidQZU8xwVbQ4DvbET7Xmta
27033	payment	2134	2134	1874	1	1	2177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsg1SzyuCQEfQmg26Q4cvBkn6QwShHSBiA2jscjbweBUuxg7jV
27034	payment	2133	2133	1874	1	1	1752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2iwk496waQ88ebCn3WVYGfJv7VDkMPJGbknR6hviLHLb8Xnh
27063	payment	1397	1397	1678	1	1	11331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZge1fbWmbgb7MjJW42xcUCvmKfhJrR8APEPEWGZHFL6DHKBTpu
27064	payment	2133	2133	1874	1	1	1760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimjbxuTmYrUqAGe4buhEGBCFWgvzoYCGHDP1aDGFJPKRj4cXp
27065	payment	2134	2134	1874	1	1	2185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQndDmZKQrnbbpbh5vbKrRQu1YqkFXjhesQwHXA6uAEcZrRj6
27070	payment	1397	1397	1678	1	1	11333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEPDm5hV34JhyCnNvFzbrrJyi7jHFKuQFxAwB2wF9yzbQW5s7
27071	payment	1397	1397	1678	1	1	11334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyGrNYXkuZZKoph8hyahQBTSTnaRZcsYYDCM3QCkaZDPaCt5o
27072	payment	2133	2133	1874	1	1	1762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuqDRXsaJmcXcE4Lj4JEzFVBYqXGkSofmfZEMsNRqS8VDBXf8
27073	payment	2134	2134	1874	1	1	2187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoohpneks4TrEGhinNNxPh3uMo3aowxNv7ihoMbP25oCmtbns
27074	payment	2134	2134	1874	1	1	2188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNuLJ4u6Y7oYKCidVVrLNHSMTysrs2rPBk9sEFi2ivgCMNNQy
27088	payment	1397	1397	1678	1	1	11339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61SqdSHdJYydGBtYvww1ZWCNLtZtrGgAk93mRb8cTnrvcydMC
27089	payment	2132	2132	1874	1	1	638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin6U2P6Z6FR7vFmoDR3NDNnmCBhqf9y9tegKjW8K6vuXajffa
27090	payment	2134	2134	1874	1	1	2193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaM4t443Pz8JTuoemXquFDuoMN6Qj7QCDe1hThNzSoVa5FcyFf
27091	payment	2222	2222	2222	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovTTHSWftkP8mwp4NiJ73CVU8MPrLnW2j43Qch9uTFXKU29fE
27092	payment	2133	2133	1874	1	1	1767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4apCs7b2ott1mCfGLhvnTd76uQxsU4e6HjbaMVNCTuMF8VXdL
27127	payment	2133	2133	1874	1	1	1778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXTr5v2twwFFadtUMzCvy9zABLEXesUMGRs1RTmBYxkiJTbdc
27128	payment	2134	2134	1874	1	1	2203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Zirt5YeBQE6q9PpsDJFEabDtDm4CnQ4Vur28LCAtx93Yytbs
27148	payment	1397	1397	1678	1	1	11355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiyfBeqmvhsh5FLYMEj3CthR1GYeuRhFhPTbGz3V4tzJXzBwV
27149	payment	2133	2133	1874	1	1	1784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1jPqMRMJnBseAWkgnbXR1LKe5E95NreGLeoS5CitpzGWXesz
27150	payment	2132	2132	1874	1	1	643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMffhVPYhYe7PpuM9sBuFjgHX8KcMusMygAEKLGE6pYDZhgas
27151	payment	2134	2134	1874	1	1	2209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vUvpRmyMP3LrJAdgQkvn9mMznAm5D94t2AqB714bsvzJcH6E
27152	payment	1397	1397	1678	1	1	11356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxyZ3cBaYwCKhLd5zLkposZeWaFA1Nc44C1wWoDVbAoYt8ESe
27153	payment	2134	2134	1874	1	1	2210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9cc9xDFRYxg6Asn5LznMdptFUD2CvEQJEDtRurzofAXzb9r4
27154	payment	2133	2133	1874	1	1	1785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMkQT9eekdgDrvhudkdAuQNEsUq1zYtN26aPpSD1diWv9FjhK
27191	payment	1397	1397	1678	1	1	11368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC1V2y98ehR9y6fifg3xVH3u67mtZJ9uHQuaBmN8Dzrar5TiH
27192	payment	2134	2134	1874	1	1	2222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6mdDsRtFkP5cEAh5tkfQKaC8cBsPv8Qk4MHX97ok3MimXKK2
27193	payment	2133	2133	1874	1	1	1797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMd7dxrBmDAiFvUWTQykXT6YzCkqkBSJjk39ecf5cLPAx82EF
27194	payment	2132	2132	1874	1	1	647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNwXKhi4YwQuHzhySRce2rVQw8KA8p3qwCENMv4NXuDkw4cAv
27202	payment	391	391	2226	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8XdsNh8a7hAAb8Vmzz87NJVM3o1goeTfsyCUuqCGLcw3Yjvq
27203	payment	266	266	1958	1	1	1	613000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5eGXhts3Tfpyo8Dgj4GoR94QMi1vmVMk146qov7Yhf4rshSc
27204	payment	1397	1397	1678	1	1	11371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb2X3u2oyxjJEBPXG5NFDGSXFBVioDBaLhiUZDYpi2auyLf6p
27205	payment	1397	1397	1678	1	1	11372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJwFZHESWqj6QHLRGXZCnQZmVhMV4ELKvofRqTjhDBLG4MbLg
27206	payment	2132	2132	1874	1	1	648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdAZ21tbYpDUDpBve5oU9B6h1sw4tXHZdPuiF4aM6XMtEnJoK
27050	payment	1397	1397	1678	1	1	11330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqicMnu9Q2THSimqgaJLyDAyDhwZVjBsfBXjnGfs6ejomUc5V
27051	payment	1601	1601	1388	1	1	13	5941000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpaB19fbbS1gDABkBDrMEZXeXKNzXm5Zgf3qd8541H6LRVpCmaGW
27052	payment	1601	1601	1142	1	1	14	3160000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYnmdnueHnv1b86GGtLCiitord1uzdcoKVjVuMREKECkLCgfMZB
27053	payment	1601	1601	1262	1	1	15	2132000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZ1uVrPjvwNB7U6vSa9EwBBNtjP2VasWqWhH1jaU2o1JP4H3ckH
27054	payment	1601	1601	1022	1	1	16	1764000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZofXXCjvyu4D1TCT8G5cQE9uSJfns7JqoG3BJmGP1VnJSgc9uE
27055	payment	2132	2132	1874	1	1	635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gLS5gEN8ycrmcp5CG93ukXVMp3f3hJngjjMw5HsayYDfYY9Y
27056	payment	1726	1726	2222	1	1	8229	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZVtK5j1sv14X7uSyNmsC8a6bdnKQCaPmDd6jYu33WinJSMsUUZ
27057	payment	2134	2134	1874	1	1	2182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3acAZRds8NMb6d9Zn7cEMMkxYe1HygHEJAxzZJKKhSccrnzc
27058	payment	2134	2134	1874	1	1	2183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFC1yVyRzvcj4LLkRX4RrR4SUes5U3a9DFmHENRtX1GeZAjof
27059	payment	2134	2134	1874	1	1	2184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysn9zHGiMEqJJyCAuuL7puQXLqJuzBWGD2t1biQ6qpBc8wHiC
27060	payment	2133	2133	1874	1	1	1757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSvt5viXgQWWojKpJMV3ytHyW4VmNu1xt2aHXXuHTmMS8kcAq
27061	payment	2133	2133	1874	1	1	1758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEqnPT8MjrgwJ8qssteCERQWUG2KiU9QZDFENXN64c39G6CSk
27062	payment	2133	2133	1874	1	1	1759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzZpoEPjNX3BftDXgBwyNjJN3Vu3mFBR29oCTYD66y9vGtfJj
27075	payment	1397	1397	1678	1	1	11335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7qswjfRE3kQR83KSBxLwb4W8PZqvSoncWPZzZkdFMLGnSY1R
27076	payment	2133	2133	1874	1	1	1763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaADvpt7bbrgLRBuZtLfeeUa9zpVbRyeQJhgnUkfyyTAoJQMzq
27077	payment	2134	2134	1874	1	1	2189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAct9twhb5Kdn7b8domtX9pMx3LhsSzAQiC4DTcLiQ8wCpQhMw
27085	payment	1397	1397	1678	1	1	11338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZF7S5pHNyLUWo9vA7KSPs3gomnHjurL6xyFGa3EeL34KrsMac
27086	payment	2133	2133	1874	1	1	1766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuGGkTNwntAtft46B4M3RDs26SqYUc45KdwTSbz5A22CapVV4
27087	payment	2134	2134	1874	1	1	2192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW5GoqC3Wu3Ufm2nZ37x1eyFGqKsE81rCJwfVD1DaMGCwM295
27099	payment	1397	1397	1678	1	1	11342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34sq8DQWvs2JpJLwL2XSjsxgZYrChhnzEpP4mhBWAuKvVZWMr
27100	payment	2133	2133	1874	1	1	1770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRf8RhWwVE2vnznvrZuyskcb3wKPxb6JuioD8yVkFt85RdttN
27101	payment	1397	1397	1678	1	1	11343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuXajKYGSWe4BjPTEYN6rySw3bUktBMhs3AzKVDrzKc4ibFtu
27102	payment	2132	2132	1874	1	1	639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKAVVrMeNCs9Npdhm4oAVCrL1Kq83ofxn4Ek1GzwcE2Vdt96c
27103	payment	2134	2134	1874	1	1	2196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G9GdhSQGjPRguwvYayZTN4TP4ZZQDfN7LeJ6bnHNddN6qouM
27104	payment	2133	2133	1874	1	1	1771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNiSCHDL9antY7wqPdzXUH2onZX9NbUQ4sr9zasvKXkUjD29m
27129	delegation	2224	2224	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLUcBrYvjUWL9edVwF4a48FfGe1NZ2WTwxkQ2ArApSVZZgxNQ
27130	payment	1397	1397	1678	1	1	11350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoYTq4QpbeXabfT8fTCKXE5woh8nmxaspT9qCGerx2Cv4JK2jX
27131	payment	2133	2133	1874	1	1	1779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBhcicDrRdffhqmrUVS3PMR7VnzgHqjssrBRbRbRv5cr8tCM4
27132	payment	2134	2134	1874	1	1	2204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XsW1a2QaG599QRc39NiG8hyFDwYRTxYhcrrZQyU2kLSRar9e
27162	payment	1397	1397	1678	1	1	11359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjCYGqQLkfeFPwtCJ4ipLhXPdEvJEjN7j6rZbnmCyRHUV6kzh
27163	payment	1397	1397	1678	1	1	11360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSguibXCaeuPTVzecQonfsjjqohneMqiEx7s73V2CTP4jG7HhW
27164	payment	2134	2134	1874	1	1	2213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmbHW6sYoJD7Ff6z21nRy73txr13AHJatSJCaTJX68ECLZi8F
27165	payment	2134	2134	1874	1	1	2214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnvgMS2RDye1zZjgRXS6HWf9W7ircgjN2R8E8285PG3ZaQ3sG
27166	payment	2133	2133	1874	1	1	1788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiprhzyUdPxbDREesqK1AwbyYYcqurVoEJgBmi7NpZcC6PgL1a
27167	payment	2133	2133	1874	1	1	1789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAyKv2GpRUNQ1JWhaeceeh1yWZxFMPVrAM7M6iXehZQvcYsKF
27175	payment	1397	1397	1678	1	1	11363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7fXB9TpXtZbDPjk7vp1tTdvvvZB174AXkxva1fseCwYnPyRx
27176	payment	2134	2134	1874	1	1	2217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVymckyxF2ivAZtTKdsc4KdgKYHPA6o6gRV4Ph9DLADDnDBFzs
27177	payment	2133	2133	1874	1	1	1792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMYrmrXynTmnvohbCeimVZCFURmBRjkca86ii7M6TXs8achL8
27066	payment	1397	1397	1678	1	1	11332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NGDEELs64TAaC75cgW7eJqVADMHMNSjxUynBEFJ8Kzu1YWWJ
27067	payment	2132	2132	1874	1	1	636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxw7Zogaq6dsAHMrvoXwYyLH9CaCrkejYTQcEESEPF15VXvYXX
27068	payment	2134	2134	1874	1	1	2186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYTELMvLAQEvATvuQrzGt3kFFTXrk1NxTFndevyrpPaEHCF6C
27069	payment	2133	2133	1874	1	1	1761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxx6PQw3K6dRUXRjmtCW6Am8Zzd3yJJbkaqsRoC9VNySXF5v2z
27122	payment	1397	1397	1678	1	1	11349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAGPVyZuRLxjLpxUfSGv56EfHcfWPQzeECjeC6zqVx8KgskEU
27123	payment	417	417	2224	1	1	0	720063000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoJougQbBYEBpbAg1wa2iW9bAMj7PZMMAPTQBNsmtZuetuDp4
27124	payment	2134	2134	1874	1	1	2202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTvnTuTa2CQtgEmBzB583AnCzd1XXhiywMedNfvQV2TuYYRrRU
27125	payment	2133	2133	1874	1	1	1777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFVGcUG38qGWp1THtgeFDJVPJNLjp8dng9A6igsjqFfZgiwvY
27126	payment	2132	2132	1874	1	1	641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMnK5FHjaVE4nfAEpeTvyhhDDuS9FVK1uV11Hk3sxUeXD8KRS
27145	payment	1397	1397	1678	1	1	11354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENzuisjg6fn4NEGkYMRmXymr8xH1Xf7ETRSsmrgmMc23e3wJU
27146	payment	2133	2133	1874	1	1	1783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQDA39fEzy5pFPd7XFU6cU6VNQ2BT8u9sYiyDcCDgbzseYXSw
27147	payment	2134	2134	1874	1	1	2208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjnAPATkkmrwaVjPRx42BjZLBxpTR46iM6Pqhq14arxNU9RES
27199	payment	1397	1397	1678	1	1	11370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkWsmB8n7NS5q8wb5rPfN4R4Zm8MShhystWcesV3NXDuRk7jB
27200	payment	2134	2134	1874	1	1	2224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGQipjWF7BSQ7t2LCC56hqvzVyb6GHvRV1k25DzbJjnvAHpeH
27201	payment	2133	2133	1874	1	1	1799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUzsJEpnTfuxGP87jgopHwM5fVExLyezTPaj14EJa1LAnSRkS
27212	payment	1397	1397	1678	1	1	11373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9e3CBaXVaJhLqwhuPjfxpPb4TXQkKBqzVDt6aW1krQ1DYatK
27213	payment	2133	2133	1874	1	1	1802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mprsZ3nsxjPAPRfCc5DbRQ8yWVUjRDkqYaebmkB839NrUGxr
27214	payment	2134	2134	1874	1	1	2227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBPyKbA76nhhZHkH4HhpCVyjc2bPc1dLbm2UU1vWc9SMVoTCc
27226	payment	1397	1397	1678	1	1	11377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59UkqA2dN1xBUG6AC2qxG2VW5LMmTPNi4x8X2QmVQEHJsftnh
27227	payment	1397	1397	1678	1	1	11378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JVU3oeHSFM1dz4F6ixZardVAypvAtxEBUpxcwcGKcaL3dF3q
27228	payment	1397	1397	1678	1	1	11379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPVrZwFrUDXibbPWjefM2oN1pdYD5eznotE5UpLzQkc7aTzFF
27229	payment	1397	1397	1678	1	1	11380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKWVHAMivNcKRx4huKBVnFxJtbXkqJm4Vdi6VpCWPcKL1SwGm
27230	payment	1397	1397	1678	1	1	11381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNoNU1gqH8zkdbDuWyYmB4tMQJ8YLeQcQtFxscP2rYf8Szouo
27231	payment	2132	2132	1874	1	1	650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaGr8MsqcSMQuzLHyVhzP5Kg838JiKuj9vkRC5taw3beqBZ3G
27232	payment	2211	2211	2225	1	1	3	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYo3vmcG46z4As7G27rbz5q2U4Kf9WQu5BraPzeJZEfvjQRhii
27233	payment	2134	2134	1874	1	1	2231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEE2BoNxfjrJjyYcQMs6soVrg2emyujQDmpcquQgQuVzfHBpB
27234	payment	1726	1726	2227	1	1	8231	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUBrgBKmxyJLLftsKbE6dbyUbUtbNMxpgBPy1s2oQAWZQv353H
27235	payment	2133	2133	1874	1	1	1806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdfSF7F13UY5keTVnhY8KFRNsEi8HqtkJqKnLhcZ8JkyoyXpp
27236	payment	2134	2134	1874	1	1	2232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2DgMx4s3E5jz5TKcrmnhfApsvJdKPifgoGKaCyawRQ19tgAi
27237	payment	2134	2134	1874	1	1	2233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVcPLFB8UwUeHydG7HiJTAuq8tiRTkxFJsArmCoCrKRnMHTQ8
27238	payment	2134	2134	1874	1	1	2234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFgAKSvTSkZGCup72q66xWJqhkcJqMVCfBoR5HYvCBuD4mjQf
27239	payment	2134	2134	1874	1	1	2235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwm2kLRi2AHPBRcLRnzH8dt5bZmPDNVpy2G4LmgiBvY1est2y
27240	payment	2133	2133	1874	1	1	1807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaJTPjYkaakrQJ7ZKbLbiYsLqFsdpRDV9Urkgfh37QJMZLR8D
27241	payment	2133	2133	1874	1	1	1808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXpKeVUvi8VqH6BWvu9Wiuf1Xqn4xK1goZYJAb1h1orutAMEC
27242	payment	2133	2133	1874	1	1	1809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqcXDMggga3NwjKMNgqVM6ptUUbp91m5itc66i6Lv764BELew
27243	payment	2133	2133	1874	1	1	1810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvdjU2J1TAiCCzBsGt5W43yPyZRYsZ8vYrUzJXwPrgtrgkHYd
27244	payment	1397	1397	1678	1	1	11382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2wup2fY5sP24e3vRfNEX2Jwawv5V9Nm2D55Xf9gdzjDMpxYw
27245	payment	2134	2134	1874	1	1	2236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTV7jiGTXCn3PwibWazdFinLMo26YePaM5Urh5zzKWmCmqMaV
27113	payment	2134	2134	1874	1	1	2198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8R2E3MsU7Q1W6rkucvZt34BDsZZzkQ6teyNCXFBJg8jKWpCQG
27114	payment	2134	2134	1874	1	1	2199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4Kt5zuZBjUVnbtEmAmP7owNMijWmNDE3CeaZbsyYbCsYtoid
27115	payment	2134	2134	1874	1	1	2200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkuDuVK8Cg3Aci56vTH2ZiQKk9DttgYytZTjPErAetXcEEhHT
27116	payment	2133	2133	1874	1	1	1773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKebGzEPeb4iCTX7iAda9xZ3sye6cLdoA8eWxDUheLsX1wMjX
27117	payment	2133	2133	1874	1	1	1774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhqqYeC9TJzcCdb6qJ3harn7nsXxcHsgvvnKso9YdSBz6wg3C
27118	payment	2133	2133	1874	1	1	1775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD98yk1J83kXGPUntAk71Dvd3HYLrp8KLbzqVLZbZqyGWatBT
27119	payment	2133	2133	1874	1	1	1776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzPpV8xzZ3vyyhtRgiHB8qakUjpeEqGMVxF8n58P22RkbQTta
27120	payment	2134	2134	1874	1	1	2201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcWDYUT3wZj2AuTcFuRLzuCQSR7NbYGJk5ycdXuW7pxn98w6j
27121	payment	2132	2132	1874	1	1	640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLauST1Cw6bQs666n2fKJVKoKZEj5m2NXFD35ohh9pVwV6XQi
27133	payment	1397	1397	1678	1	1	11351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZcMPajH3qYFDk5zYskpUBXrp7LYqekPPH1aVTaKJ6A8gHVCv
27134	payment	2134	2134	1874	1	1	2205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcc6VMhXUZkaDAdnS6Q4qrZExcsoNYYgyDAcVmBe3FYVowa8b
27135	payment	1504	1504	1697	1	1	9	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dDBfVZkd9eXhcCSFUyeStTKGijznbJaFWAJSjk6KJHGSpL3N
27136	payment	2133	2133	1874	1	1	1780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzPNVnZD7Ch5wDqGri8af67g8LDTjghMjCHWQ57PPTPKF3AsZ
27137	payment	1397	1397	1678	1	1	11352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q7DQBGXMUCSxRv7P4yVB6x5e7r5t4S1geWyzDm4K8gk1Cuhd
27138	payment	2133	2133	1874	1	1	1781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUp7eFCJWGWuSECRJNBLHyQAPAo9yxCm9tA3E4ZGUYrzkexyzS
27139	payment	2134	2134	1874	1	1	2206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAnPQ2fjkSZMgfj9o2MLK2VR5jX3eZEw7AGqkD1wNStLWPDZs
27140	payment	2132	2132	1874	1	1	642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfAw71WEf7hZKJNsErmkoUER7Bi5oBm7gPj2jmr6V62HYVxPb
27141	payment	1397	1397	1678	1	1	11353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNvjFG694i1TpyjQXCk2FaGt1obraBQkdrMNn8y9KJA3MAxhD
27142	payment	1504	1504	1697	1	1	10	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qDcw3BEYc6JQnGqEVp1Ggd17bfL28LaM2TsE9Dog5vWRVdCv
27143	payment	2133	2133	1874	1	1	1782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERoE8CgRxCRJLmHBLTwwWrnNVB8ax2xApLcGQHSSSmp5aC7Gb
27144	payment	2134	2134	1874	1	1	2207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQuk6gR3oAgakvEu1y3aw6TFyHGL7ciCLQKWei3S7fhx8GKrY
27155	payment	1397	1397	1678	1	1	11357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwymKbFPByw2XhEeQCGDxmZmdwr3A4WfFnAbqq2YoGCsxo2wy
27156	payment	1397	1397	1678	1	1	11358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRvpStQNvTM6PYiiScczZL3uGsKufBU5kgNe8qqbQANuii5hR
27157	payment	2133	2133	1874	1	1	1786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC568ZF7FWD5pj9tqkx4QGTrfSwgsjg75GpZYiKET9V7okLBQ
27158	payment	2132	2132	1874	1	1	644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzg5RbiFBTjq4kkbhe5cUUFR836W1XErjvwgMWXpEHCreAEwD
27159	payment	2134	2134	1874	1	1	2211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX668FESrn4BLB2bCK7itKvoWMXPwA1rK2vkprSNAvzKVxjXDV
27160	payment	2134	2134	1874	1	1	2212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFhPJz6AePHSWUdwirhzevJzBBDHZD4mk5tKFk5jCoH4CR3y1
27161	payment	2133	2133	1874	1	1	1787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceDWGq7rGZCjB2ZR3gQ3DKNMzAtdpyCUa64navHLCdZiM6rwX
27168	payment	1397	1397	1678	1	1	11361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCg9uko9Jf8R2EtqM6RxzfTWKHGMqULWc9WJqZ975gLFbF7RPK
27169	payment	2133	2133	1874	1	1	1790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ynK74pMDytkGBzcwRbneiSY6Aynd9K33RRgBum94XbHgSPRk
27170	payment	2134	2134	1874	1	1	2215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ896rVuZ43Dva5b5tgj4sVb3b2ny9k9iqforq9DNnYaL54kDwb
27171	payment	1397	1397	1678	1	1	11362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3UpMXk4Y5J2hsSVg8EQgmmwRHTvMY9P9hHNXa9AxBjNUkmfs
27172	payment	2133	2133	1874	1	1	1791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57eyULiGsR7bHDnEZTztG4hQbjsCyndHE7VAv4okyrW3XHffX
27173	payment	2134	2134	1874	1	1	2216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrx4wWY9bzRkLr2hSkc23v8otk6ENFjbAuYFaJJoc5CSDDZcX
27174	payment	2132	2132	1874	1	1	645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYttTKVnssjgsQHx1ZnmDd6ZDUADe7Um9Bcw92iy4tun24SVH
27178	payment	1397	1397	1678	1	1	11364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcM89EbvxWbL8SgSFj3X2hV9u9NJKVhtCwNvERTA6MhLJxTT4R
27179	payment	1397	1397	1678	1	1	11365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kzMkT8CSQYPEZXbxRSfi3aw4eHAkCBQLQvWUTigFhxMwjNDZ
27180	payment	2134	2134	1874	1	1	2218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycEa6AnHGyJ2fqjYTajBayX5xdH23h5fVB4ymqg3vtvLxx6iZ
27181	payment	2132	2132	1874	1	1	646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8k741Da6DAg8AEAaaAPqNZstjiBb7Ky5MwzyRa9DHC1GvaDNw
27182	payment	2133	2133	1874	1	1	1793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLofgadvoHiJqjgwPynkJp3ewUyFZDpDJqqhJVimLttcD4vSPv
27183	payment	2133	2133	1874	1	1	1794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQXoBGMadQcGgHgkze4LtDUw48UaKRBH27VNJeMhQz5UAyNHo
27184	payment	2134	2134	1874	1	1	2219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4jSsgKuZ2fkFdNuEmMSv55ojZXfjuLbSFKryTKGzCoyvDv9z
27195	payment	1397	1397	1678	1	1	11369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPNGDn23kEMPX1m13rxFZsAa1jvbxLVeFfwnKvz8RMpZiYK6V
27196	payment	2211	2211	2225	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKWgBDECRZqc8Dw7sXPePc1R5Kyjyz3cpBhRZ9HpHStK33mRn2
27197	payment	2134	2134	1874	1	1	2223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzBgh5u9NDkhwgJthNrveEE7yMeQuCVTfknT3Gx6bMeymzTps
27198	payment	2133	2133	1874	1	1	1798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2G9kXVXSRiHT28nRvh7XqEf14cncVhQo67TYNoASVs27r1W6P
27272	payment	1397	1397	1678	1	1	11390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfHo3ZF49Wdz9DG9PZiRrYtt6tRJcvdLXnt1YGSwVZUeVTqfJ
27273	payment	2134	2134	1874	1	1	2244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjGwQ1YPCujJjfch6Kt5sk8NGuASTQut1R2bnEeoLVpKKt2W6
27274	payment	2133	2133	1874	1	1	1819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8fpGLAuXF3u3buKm1f1UaGZJsGmK1YyVwEzwFkHru3gtcY7c
27295	payment	1397	1397	1678	1	1	11397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvocDK2H2GNqVk2wNTxk2xCtJUBC5sxTDN9WAayMM8PinMXqH
27296	payment	2133	2133	1874	1	1	1826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPknMQgwUWibypm6rAfYNUy5yE3T6bg2Uu7gyTcHvtQgi1MNXL
27297	payment	1397	1397	1678	1	1	11398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N1rS2Jh9Yemav3xfta5PCFbYVEFJR9Mo5vsSJcwNDqN9WZxJ
27298	payment	2132	2132	1874	1	1	656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufvySuCjDuNjYJxiZo4LSxm9yS3z4LY2A8mdNvoXLvLraAkis
27299	payment	2134	2134	1874	1	1	2251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49CQ1Bq6o43wrcfhs3vTakuv5Zg8ZvZusiCc3sstuqcwMELiw
27300	payment	2133	2133	1874	1	1	1827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvuxGix6t7r2ZcxDcyGxKtb1fzoN6jhWLm1M9UWj3WWquB51H
27304	payment	1397	1397	1678	1	1	11400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2r7uivabwdaeWey8XJQzUfmNW9EC6b5j82DQW63DUnk9urGMF
27305	payment	1397	1397	1678	1	1	11401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBL1z83odgfGhiSMHL42jbsuvGndLebtMmvFv4vucTpiGMZ9SW
27306	payment	1397	1397	1678	1	1	11402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWHVzh7C8fbUcvAdjgkayAkz46rEKCFeuaCnKJSVpW1pJ9NDJ
27307	payment	1726	1726	1982	1	1	8232	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYc1YBRA43YzznydbQftgiZ3HCm6tejQDPJkXNCjeTstf8NWSG5
27308	payment	2132	2132	1874	1	1	657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wRHA6ZS2bqksXHrBbvXXYEBdKiAfw5UQVRcUmem3KqafYXjm
27309	payment	2134	2134	1874	1	1	2253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHvPiN2bH8RaEuAfUPwNSdpSxQ6yJYznQd7XsR3F22JwsTX16
27310	payment	2134	2134	1874	1	1	2254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmnkkU3i1idtTLb571JQQHZbDmtpGDPS9hXtsLkiEEbV3ZNwy
27311	payment	2134	2134	1874	1	1	2255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eMgxQRZbkTfUyFxb8Jnq5F2EbtXq4pfe4h8fcpvV2UY7vX6P
27312	payment	2133	2133	1874	1	1	1829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfk7swr1eUNJ4xY29rxcZj7LrmFfCSRF97fcHBr1oXmmQmgwg
27313	payment	2133	2133	1874	1	1	1830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwFvvFpFHQFa3ALKKyso7pJLcLuz9yq87rcBbX9ZGVqFUzEZk
27314	payment	2133	2133	1874	1	1	1831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNxUy1zwrXhntEWcE9wi1aa2Dm8TEzY9bBRB3Z4iH2CAezMAJ
27319	payment	2133	2133	1874	1	1	1833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7nEqCqkTp9ZVvnHCmAKqZZn97gFT6x7BJW1y1c3pnK3Ea159
27320	payment	2134	2134	1874	1	1	2257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4VpT9R3NLRAX5Zyv4QoqzWqpDgNA7XAuBRDtnaofaCeRUCA3
27321	payment	1397	1397	1678	1	1	11405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa365JH1CgUXeS1FkaDRbLenkyvXvqTFZgWdfd3CGAWGFCgVdKz
27322	payment	2132	2132	1874	1	1	658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2osL9khiEeW2bvBnLSjxRMDGQVhQLHQjbYwmXz6NtCe1EQgD
27323	payment	2133	2133	1874	1	1	1834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgZeM8CZnq4NRsxHrTuuw6C5TY3n2iQwnXdSnyZKockfJSubW
27324	payment	2134	2134	1874	1	1	2258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHLQfAPmJqeL9dMftVNiNhdMQQX67w912roUyQUC68Zm8k2pb
27349	payment	2134	2134	1874	1	1	2264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEEfz2L6yNtnzfq8uepXkUQcLGfF5RqLNr6ka7bqThYjCY2X1
27352	payment	1397	1397	1678	1	1	11412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLGWrUy9dQAEkVrSjNH5jpJNabfVXjUMGLxtMiWdrNQ3SNrUK
27353	payment	2133	2133	1874	1	1	1842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgexTDrLk4yYftZk3XCYAhr2vWtB1gUdxv27kchRYsxknB8aF
27354	payment	2134	2134	1874	1	1	2265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhuVbzhXpe5D3r1rFvx9jQHMZw7zgv1u4MHzqrAC2TJHTJBEZ
27185	payment	1397	1397	1678	1	1	11366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dVMHCp8N2QedpHu9E9TGh2hRn852rpRCViXp35tsLqRFhHKN
27186	payment	1397	1397	1678	1	1	11367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdTbgiq1Le5gd3mXMJRnmhiZhr8iccc8QJGWYdYp3V5Kqj3o6
27187	payment	2133	2133	1874	1	1	1795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfV3EhGSTNseyNG9imTp5tSBQbjRhEfoXHq6JfANTwD3tQu9t
27188	payment	2133	2133	1874	1	1	1796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqx2S1GXZtSW5ZUYLUTpbCJ1AP6QzFV5epg2kUAtttZg9wJB1r
27189	payment	2134	2134	1874	1	1	2220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXJrqCSLRwW2R61Dt7YKfvGMW3e2YFiu2CYn8PfGN3vJui2Lt
27190	payment	2134	2134	1874	1	1	2221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam3JhnHsBj3UWMESHy4zusEgu6sbqVv6fUr5JQeBdAjPSczTF
27223	payment	1397	1397	1678	1	1	11376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7usLVhNWcmrETgN9S3U1jRHm7q2mQGmYbeu3VXdTN9DTwrdB7
27224	payment	2134	2134	1874	1	1	2230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQw5Mp1XzdKbsZbDid3eUdZcw1B4zyBfSimTvEvej3R32G7Rvo
27225	payment	2133	2133	1874	1	1	1805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkx7zLkqmGbHHh8iHXRPBRe3iL8ZPFsTC6WhKvERykdusp1MhA
27248	payment	1397	1397	1678	1	1	11383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYug1nUbsM4muUFbBJa9ekhoo2cdUkUgB9ZY3AV18XY6maEnEXC
27249	delegation	2225	2225	1645	1	1	0	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA3dFK6GQ8K68W8wwnUsjyN4GyEKFBenYocuukjk6bAqGAqqt
27250	payment	2134	2134	1874	1	1	2237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGG4V8dfUP2n68cqBxdhh6vvGCTGWyv1s7XqhPxLG4Ae4oidL
27251	payment	2133	2133	1874	1	1	1812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Xi3YEn4WLYX5EtBDuTcX7aKZmj9Fz4wCqERNkXv689nxKRXE
27260	payment	2133	2133	1874	1	1	1814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDBmRXfxJKh7WffxfaeHhae71HfXw89wbngsdLn1E9tcimco8
27261	payment	2133	2133	1874	1	1	1815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVkXobvJ74Zv87bTNuoru5BL1VEVLToUVNBA7qqax9yuvBg9G
27292	payment	1397	1397	1678	1	1	11396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCuU8MyxMsKEts7D1SDmSyboimdi4v2y98rP4pFvirVmQ1YDX
27293	payment	2133	2133	1874	1	1	1825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUW1kkN3P93n3i3v9sA8Nk5kbU17ig7H2hbPwsXQQ7hj3XNgL
27294	payment	2134	2134	1874	1	1	2250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpkx6d4HUfTz67ufyJU38E2HDcRy8m6xCou9omdidfW9joaZ1
27301	payment	1397	1397	1678	1	1	11399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDZg4rrJCtfhQ8ZMAGR3W5R9f2YKvte4BNjhSEjXxLtG4cSSm
27302	payment	2134	2134	1874	1	1	2252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHnvV29Mcabsm29d6ynKrrD8tw8mySu3M5FsXzRgx29kdPe8i
27303	payment	2133	2133	1874	1	1	1828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72jLy43a8H44Gpyst1Dn5yusR3zY7aoFW6SXCfMH3Z5FNH69A
27318	payment	1397	1397	1678	1	1	11404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghc6rRd972HtotmqaxFpzGfF1FtzhxsjXQjyZ5Ub5wC3SD4Hc
27328	payment	1397	1397	1678	1	1	11407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqLMBoAjRwCBD6AZxYVoGhawjgEDiKgsRqSPTPEp6oGzQgUE8
27329	payment	1444	1444	2214	1	1	6	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQrhCkstogbdWm8eX9oSsVB4hmJHrNdGTeH58drvanzPfivuH
27330	payment	2133	2133	1874	1	1	1836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsK26154Z9J7Dy9Tz67Ug9FdhaXq1JcTi2WFRLyuzQm9tJ921
27331	payment	1726	1726	2228	1	1	8233	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSvrVByD4J7dS3BzpCMwCCmrQnsmmjK2EQoUXUgmeZEu3EFkrA
27332	payment	1726	1726	2229	1	1	8234	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKHD2q4m2VNx629wT4YTyW1tdYaupANxauVaBLKQbYhEQhqpjP
27333	payment	1726	1726	2229	1	1	8235	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8SsFaDJzUwzvr1oKfkCoyi8Ce5eStwoAPn18SHtM11ReDdiMX
27334	payment	2134	2134	1874	1	1	2260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7J2eKQC132T9j4ZiGU1nA3sK1uGbd36PZow4LV2gfgACHdzS
27359	payment	1447	1447	2230	1	1	5	1000000000	10000000	\N	E4YfKBA67Fyih29oMDJHkWnfBZHwHmwGAS9TkjmntAh9TqzeUNjS8	CkpZDsLfnn27oCHtCBTKQ3V3n619AGBaczmihtcCezvpx3F8QQsYn
27360	payment	1397	1397	1678	1	1	11414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aY5uiVRdebMDs7wxw1WZh9LVy8W5ZTcect7Va6HHRB5d4mER
27361	payment	2132	2132	1874	1	1	661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXo385CNTskS6CSTc5S1bE9ACTTUPL9r66g1dzfbgDzcDwcdb
27362	payment	2134	2134	1874	1	1	2267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzR19rDkVQak8krYTxAR4TQPWgG2DUepGP2vZ88FwcPWc1W9bY
27364	payment	1397	1397	1678	1	1	11415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDk47C7d8Aqp4fNaSKydfcpdReHbZALEf9epvPSV69GxrkEH1
27365	payment	2134	2134	1874	1	1	2268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpxZEJZLd6AquqCcPwqmMRqhMV6KUa9XBPNbh8byLwnFMSrD3
27366	payment	2133	2133	1874	1	1	1845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCNxbfCkYHcjcHfxp1PH9JrV4jx16ufXE7ei7tgU3NNuEPH3T
27367	payment	1397	1397	1678	1	1	11416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2m5GriToEHc3Bsz1WCa3hGNAxW3deAXqEF5i9ntJtYAhMEdS
27368	payment	1397	1397	1678	1	1	11417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTygXz3k9e9gPAPqHxnouoGAUzhpDGsbuPJPdDrRcM5Qrbo8M
27207	payment	2211	2211	2225	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeptHp13DKb5jhfqXVqnMqr7vmWwygSLY9zJneC5j9nvQd7h3
27208	payment	2134	2134	1874	1	1	2225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrriz11JunsQe8XQkHTvVAVt6nUP6nYjkGXxM3wJwqoMahmcF
27209	payment	2134	2134	1874	1	1	2226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UnJiUA2Ae4TUwXUifH92VMEy99cpin8usxDUTWzQoB82mQQU
27210	payment	2133	2133	1874	1	1	1800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9h9C7WkFzkH4VYfFQaukVgVfyCbRmuDtRgRpbJ2mDpzuVjr2N
27211	payment	2133	2133	1874	1	1	1801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHA7GjhvF3x718hmDf1UUXTw3crcvVd3BbhUXAC8M44nQ1vfM
27215	payment	1397	1397	1678	1	1	11374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8Yw74JQDq71MN6U3ro9qndWNLLiBUV8ePjVDWo6KXNzo8Nwr
27216	payment	1397	1397	1678	1	1	11375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGJdFp3ydx1gxiancGBMZxbEqN2e5vBQM6k6hxj6GNxQrQRKQ
27217	payment	2134	2134	1874	1	1	2228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjteuLJtJkpYRMx1P8W81bueZmGggSZwM7nKUgPh6MQBbHcciv
27218	payment	2132	2132	1874	1	1	649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJiv5ZcskkFPZLiFc4GTizxiioV6s5oFVUxn6jY8K5k2aAv1L
27219	payment	2133	2133	1874	1	1	1803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4kdEt57BKogUeiuGuk7s8xGZKDzgQTtSbqLiWCjzWvtFPEP1
27220	payment	2133	2133	1874	1	1	1804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQW3hsBiqvxwLoPfB3dVdGahGvNwvJLLxoqWvtP9dz4mkcz2o
27221	payment	2211	2211	2225	1	1	2	716000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7DPhyzETWVHirWgyB8tzydh6C3ZS39hpaXJ6FW3REkDVYS5X
27222	payment	2134	2134	1874	1	1	2229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRhaTZdLUHTvqEcPKR9WGReLiTjP67TUoXM6KEUkhL6FykTRN
27252	payment	1397	1397	1678	1	1	11384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6n936riF5D8itr4qtnPvVSgtRUFx4c2WgvFJA6ocXyXRfqPSJ
27253	payment	2134	2134	1874	1	1	2238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTUE4EqjcQFRJ4nL5bjL4y5mj6BZvVGM2Eq5UhHr3VHog7EBx
27254	payment	2133	2133	1874	1	1	1813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UceusxHjdn6epGXbvvCXGkqFowAiKo5dguUFAPZYzwPTLPJN
27262	payment	1397	1397	1678	1	1	11387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDBiohxBXVyL9BtvxFwt9FWAZ2HDwenFXo9sfqu19fuLFfHD4
27263	payment	2134	2134	1874	1	1	2241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXztzXB1FXhjxMx5iWvGASNJ3GRs3UnAVSeLMuop8sPZNAe3nX
27264	payment	2133	2133	1874	1	1	1816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQH4depXchnEgQ7s1sJ3JVrG8yR49Hmsen2ZpWradSCeBCuJj
27275	payment	1397	1397	1678	1	1	11391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTSr8P4yJo8WoMvyWJATCPvdzyqzFTDTC2j4W9byzdVpqbQtR
27276	payment	2133	2133	1874	1	1	1820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigYiMs8suU4JRGDHSGphsKggasCxs55LLQxE8tTDNvA7atU42
27277	payment	2134	2134	1874	1	1	2245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZoKQLR1KB4QNtdeRSi1yGxkmTDN6MNajnCUBRPaeVGbK4KW1
27278	payment	1397	1397	1678	1	1	11392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXDxftC91Mh5Wgb9ZfvQVf1QGr9PBEyp1wiK1FTkWSYREU3xh
27279	payment	2133	2133	1874	1	1	1821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJGxLkhP7bH8rxbzHyKV5tDoaVH4Ud5L9HBebr19sMyx9KtZD
27280	payment	2132	2132	1874	1	1	654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YYuBYe4ABxsxMjE2fpWr6xBiacxTCwUkRW9WoEHPjcBjXLDr
27281	payment	2134	2134	1874	1	1	2246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuHfG96ZHLBDoSarWF5NMeZYNWZ5wb3zEXVZhBqNqnscrYHEB
27282	payment	1397	1397	1678	1	1	11393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8kaDq4SNoyy5BLu17VvzegAAZF9df3Wz59wCn3i4FQxVdBJu8
27283	payment	1397	1397	1678	1	1	11394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSgbDZjEyL97iEWQ4VbvUewLwYtFhHevKSLokLLCfdAQwVQsn6
27284	payment	1397	1397	1678	1	1	11395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTHxpN5a95Ss6AaWdCYrx5FwN1v7ZgPZKhYdtm2etzvg4u9LY
27285	payment	2134	2134	1874	1	1	2247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4ALLgu2LYvQcfUZouw1NumYM85X89FwvC68ikwoN7vCQGzAY
27286	payment	2134	2134	1874	1	1	2248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKuMtWfkhyTsU37wAebFhj8rbY8fZd4j1PDZiK9LoR41ScXJj
27287	payment	2134	2134	1874	1	1	2249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZJpLg7ybJTWwDwuWcG2wRRxenVGLwG8xvHFVJKHpp1G3uhmU
27288	payment	2132	2132	1874	1	1	655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwMeakoP7paR8ZT6BCBSLVj6hJ8AGPv7uvRnV52EoA3qxjTZS
27289	payment	2133	2133	1874	1	1	1822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhqv667MxNhVv8fme8EJQsHYSdx7dr9wawvAm1CsJGSfYDPpn
27290	payment	2133	2133	1874	1	1	1823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjZ7LLQ9NDmJikjgdi4wxe5ReaKSPP3vAbkeBjQMrnTXFbuCb
27291	payment	2133	2133	1874	1	1	1824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftF1rj5iJFbChjrBWW8WW4PGdLmZ8gstfwkYBXTnnqC1b2ht1
27315	payment	1397	1397	1678	1	1	11403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwrmtNN197xt2M97Ba2urmCW7KJ5xrPhkdgpn3gnMmCoA2cLK
27316	payment	2133	2133	1874	1	1	1832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpZ8aTp3zWZ9Qa51UfGtAdLeGJ642owUTTAfENG52v8ug6n1X
27246	payment	2132	2132	1874	1	1	651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2QdmsSJZeq6pPen3gdSaGWFDwnZdRgJH3Yf6inUnfBrwCQaL
27247	payment	2133	2133	1874	1	1	1811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXhU49q8s6kKLmitjnygvQ5TS7Zjx2oqWAVpVFunRdycxbjkM
27255	payment	1397	1397	1678	1	1	11385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZketcWegCep38c8VNMTpFUHMCaxcRYu5j4Q3i9JpNty5Gs8toi
27256	payment	1397	1397	1678	1	1	11386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CDb7FCzTa8CfCG76bjA1n9yXackwMQNZamXVCMrQKSyWCKPT
27257	payment	2132	2132	1874	1	1	652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSZrq4YfvmAkKSQ1DxCrhPCGK2GgNxVERGNipcFsNQFdwdxEo
27258	payment	2134	2134	1874	1	1	2239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89GYD3oUanbmaonyjdR26qxctYhvM8vt67JHYc1Y2sByFKp7m
27259	payment	2134	2134	1874	1	1	2240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnyBcMrdtm8x4Kj2MisGDPCKtbiDqaRs6aLejSNPrcdzEXg2c
27265	payment	1397	1397	1678	1	1	11388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWZ5MW8iG6th5HpuQRGddhgBzHFqKSsXtqyViH3Jm8tjDZawd
27266	payment	1397	1397	1678	1	1	11389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJf7cSogtg36Baxeece4Jg3AAnqs5Xik9RtvPknZYALsf89rH
27267	payment	2133	2133	1874	1	1	1817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9Xb5eam1iB96mowFb8dx8nxv2oSCC7EAENdTjPyF4jUjFLHa
27268	payment	2134	2134	1874	1	1	2242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjN3BhqwoLh6BdRs28n1mfE5Ep5wgsj3Xve8X1c6ZwtJGmrBK
27269	payment	2134	2134	1874	1	1	2243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pyrWEwnVkMGwRW8qHeLPxpmg2MBT8hoN5xdJ53qtJrRzjTbJ
27270	payment	2132	2132	1874	1	1	653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuuep1JY4srVDAiP6GXrKTJf2TVh4KQt7GHaWeyd8V47yPRBQ
27271	payment	2133	2133	1874	1	1	1818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFfAWSd7SxH5Dy9JBtw5D6mRcusbmRnH8n1ajA4jt5ExM1AUZ
27325	payment	1397	1397	1678	1	1	11406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVh1EQJ7prrrdp35CkLGofk3eCxnXgX9prP3RB7JfpKbvsugb
27326	payment	2133	2133	1874	1	1	1835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbMsH3KBWAmRQ1ZHJAWhUhZXgkEB2q2ZUYxDH29H6kzw7U5TU
27327	payment	2134	2134	1874	1	1	2259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvraWLwhpd5gkbA97gi5vbDic4ZEKkF5H9ciumxYMj5gxh8ngo
27340	payment	1397	1397	1678	1	1	11409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjcm7D1x3j255LhQdwHSGoXvZoPtNkUJ1jskzgarNearmWKCV
27341	payment	1397	1397	1678	1	1	11410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZia8Typdn2TvSEnNKXyhgG8R2Fs2teew7BAyF2L4UTCNU5pJXt
27342	payment	2134	2134	1874	1	1	2262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicw79dNWq8RgNrdVd1W1AxrEvev6ybopqqUivU2oTrukGixNE
27343	payment	2134	2134	1874	1	1	2263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWhRmXDizaJPANJLnutAwMYtRUQr8qjgU2NvAvFHEyYdzPgyd
27344	payment	1444	1444	2214	1	1	7	2500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgBxSDW2qVY8wF2syCehdRFRFAo9LhgMG1UMHBBtr3qpEGLNs
27345	payment	2133	2133	1874	1	1	1838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4PywXeknMjAhEGSFGD21Smf5g8phrF9pjitRmbGgvWntT53S
27346	payment	2133	2133	1874	1	1	1839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhPsFxXCQ3FGpLNmLyq4kCHsAFKfwpZhYZATQs7MK7YCxtT7L
27348	payment	1397	1397	1678	1	1	11411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZxJpdKUDVsDLRPdezg5tVbhgoymLUURYyJPqTGqQxgs8xuXJ
27383	payment	1397	1397	1678	1	1	11421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC4TkKkGxPtcyUtqRufT2oxoLFAJLdsVHsSo4kC1b7LnSWpiT
27384	payment	2134	2134	1874	1	1	2274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3UUugXAmxXmmLHEuJ8QtveMhwn3w9SKxPLvRJ5ipXYF8keDj
27385	payment	2132	2132	1874	1	1	663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZTCbKzWRt4TEaezRXJp7DGm8VpPcJZLonNH8YXNRn4RDgP8b
27386	payment	2133	2133	1874	1	1	1851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoWjAMesHT7vG1QFLK8iWGTYysGsayBZvKah6d7eChupjqazs
27393	payment	1397	1397	1678	1	1	11424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZym9jejCKt8yisS6dQVUpiqYzVXSb9uFXUjRDS9R8veRFLRSR3
27394	payment	2134	2134	1874	1	1	2277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q1dtvTdubNAhndW4R4m7mKFr2hEs8D7wYUMLRZnbmE9wj7mm
27395	payment	2133	2133	1874	1	1	1854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5arDmeHpyszvFYwvexhZkjiQ2h9VD3CF9cGBCfLTP6ySHJSeD
27396	payment	2132	2132	1874	1	1	664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2sHGAaK8hpdFfYDZRBCErZfYRrF6Gvdj27ZZcJrvsqCkxxEA
27397	payment	1397	1397	1678	1	1	11425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjfWM3FnGEQqbdBSDuwRS7JSVZAHjJaDzNC4fr2oMWRWU6pR8
27398	payment	2134	2134	1874	1	1	2278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBdrH5mU86P8HFDb87ihfySCKy2yuNQUnbG3JwoEHV9bRiwQp
27399	payment	2133	2133	1874	1	1	1855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLg5LNhfKwxqLeNbm72MNNYLA7MhUcUVDzo51b6MsHfHjrfxE
27407	payment	1397	1397	1678	1	1	11428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAW4bDvB2UtSTnw6gw5YSzn6pALruce14tkxfaZyovbTiqH7W
27408	payment	2133	2133	1874	1	1	1858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqiyAaHQXvwzgrrkLc4EXUijRPiJH4ixdDeBDHS2aaVAdzboKt
27317	payment	2134	2134	1874	1	1	2256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicikrU7zQjX8FzcJsmTMxLcS8UhjDbK5hwtMPFSj1zMWMfYQr
27335	payment	1397	1397	1678	1	1	11408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsppR6UykLpu3eL1GpAuptnagBrMdd9YMJDunHzPnprnE2pDPM
27336	payment	2133	2133	1874	1	1	1837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDvGt6rgptreLtYxSnAvQ7FR973na6u5oebJvVdKNDxkeJw4g
27337	payment	2134	2134	1874	1	1	2261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjLf1ASNCK1gHNaxq1UaS9vs8z7PLw2DBALWHy9X6vmrWf8ox
27338	payment	2132	2132	1874	1	1	659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LKjVXL4uyh35Wei6bJ1ECK7S948v8Jt2SMfgWrULKS8gqQxZ
27339	payment	1726	1726	1982	1	1	8236	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwTCiXuZGXGfm2n27LPrqJxngD3CyMV72gd7jKxv8D2UndUBkf
27347	payment	2133	2133	1874	1	1	1840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YM3iH2tSemy2vHwJg2XFzMuVz4oNDgu6ProKFAYDtBEYa4j1
27350	payment	2132	2132	1874	1	1	660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZM2Cez5MFPLhd6AjoJEtV8gSofkGQqKNGZaLqc57v57gmkL6
27351	payment	2133	2133	1874	1	1	1841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmw33XZH2ZTYDPSdxLREurQREzsL9HC2HouHYB2xDkx9MMaYT
27355	delegation	2214	2214	1444	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfBJdXDQZ8i95HptqiJEKDU1E8VxtbstBw4uq3krJRKoHLi2L
27363	payment	2133	2133	1874	1	1	1844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTidBF3rvVQv86WibnFVNTpWctgNbTEp4tPDJTQrgBNVyfZ12
27377	payment	1397	1397	1678	1	1	11419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4GWhTP1VNU2EgKcNHWwcncM7CzmHnPh3XEDsXy6kSJH11itp
27378	payment	2134	2134	1874	1	1	2272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yixaN1ApHKzvvNsAoeft5VYobwNNP8MzgjX2cotcr9ZzavFn
27379	payment	2133	2133	1874	1	1	1849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvj2Gd68FiTE2jn8eJX7iPErb7oxvXtzHkBFgZm5rjoQrfn3v
27403	payment	1397	1397	1678	1	1	11427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AkofcvnSFTaBjH4vaoJfQV8QYtjbSrrYBcKspxPWAaqP1K2h
27404	payment	2133	2133	1874	1	1	1857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyCrz45E6FV61Gqs6B6bheYwN7LDnhMvY4zxpW7DY743GnksQ
27405	payment	2134	2134	1874	1	1	2280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd7mNWQGdgqVvcu5yPoCNgz5vaMHCbym7xZzvEhe7pcDwjBc9
27406	payment	2132	2132	1874	1	1	665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdsQevWsmZrM7PhccWnPri1sSdvMSkP3mnhuPT9esMyah2ubZ
27415	payment	2133	2133	1874	1	1	1860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCPAu7frMYkZcM14nS5cHZjMBoKx8BtQAZa6NE8vHC6yRkh8Rn
27416	payment	1397	1397	1678	1	1	11431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohsqKhNH2jBsuRVALNLqEoK1CejjwkZLm4hoHDDCbFQSywcT5
27417	payment	2133	2133	1874	1	1	1861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmoj8WtAD8dEZ3pu2cVFNsjcoxy3qNvfq7tHrNxijjBiUc8d7
27418	payment	2132	2132	1874	1	1	666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkLocV6PZzx8b6UbdxafuUXs3kwDERXwVJRPH8ZNZyTc33UAH
27419	payment	2134	2134	1874	1	1	2284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnAyndXnks62nQpVbyCxhJ8ZndUJYCKah2iCYRxz6vT5r96iq
27423	payment	1397	1397	1678	1	1	11433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJaZLfREEB5zJVmV7xNRWLVXM2RbthHLkFrML7Pn6rSGAESCh6
27424	payment	1397	1397	1678	1	1	11434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9QXUp4GPEUBxTLGP27fRAc12Vdft93eumUTTW68cj45nrnhk
27425	payment	2134	2134	1874	1	1	2286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEggF55WLvRnvfCfrsmfLS166ANvwyZ7vTVkz8FWN1VjjSyNR
27426	payment	2134	2134	1874	1	1	2287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfE417ftsU6jXHwU5zFvZXQX72cCFFNBUCYRM2RnQVQ5fnETZm
27427	payment	2133	2133	1874	1	1	1863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrePMVPG6Vd3e9QMUYZju9NmtqvT2YRueWV5kqZodFZdDvcH3G
27428	payment	2133	2133	1874	1	1	1864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKCpwSN9mmoUGFWkeB2hWRKwRcEbfjXcAtXLXrMXqesHkfQja
27429	payment	2132	2132	1874	1	1	667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jRJHtHPsTMpxRg4uRMHRXq1ModHf7JSmws6DvFDvdMZtExA6
27450	payment	2133	2133	1874	1	1	1869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuCDbxS2i8AeywUwLZMLBDKLv9yhSRU36wp48NabsLbHhq2vG
27451	payment	2133	2133	1874	1	1	1870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszFEVvgEgrBGFbdWSZ4GZzLu4nKwN8JUJPSkhDXUrs3SVZu57
27452	payment	2133	2133	1874	1	1	1871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncnynPLob6xioDijN5CdAsHjZRWvwPpBgt4qEF6i44TsPNyo3
27469	payment	1397	1397	1678	1	1	11447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpFK1KcTa3Bxi8XoBTE963trbB45fEvKY7pczYxvNEptVhD4m
27470	payment	2132	2132	1874	1	1	671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqaWfkGyrnuhx7AXEE2FAVdfRLP6UiFxx9RKkLhrvH1ysLbRU
27471	payment	2134	2134	1874	1	1	2300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M5xPAesVhCApAAixLUX3uoQ3bxe51FgeRqq3BYYrsXpUSVaQ
27482	payment	1397	1397	1678	1	1	11451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLNdKJpoAh3DJhD7mDv9WsvyZ6pTBYzUQxC6LVaYZv15HE6mS
27483	payment	2134	2134	1874	1	1	2304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE55xaKujgg7V8uL8aeDxcrp6Z54vE541t3jrHuvg186Lgvge
27356	payment	1397	1397	1678	1	1	11413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QXACQG8HTH9PLuvfRMEdJYvC91aaEZAYwkRZDvmD8hCHB2KA
27357	payment	2134	2134	1874	1	1	2266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2UyZmSz3gA7LVaVMySs63QjMW1LxXdxa22FawmG4ZsjQnpxh
27358	payment	2133	2133	1874	1	1	1843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLmGKE9r1vkk1DzkS2g9JcXUekaGpDt8EBbkH77mkP2PBLC7f
27380	payment	1397	1397	1678	1	1	11420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZo98CVuhnmiJGnTdCRZhdBRmXdF1yxwMhCnaQtAVW2CxW85t
27381	payment	2134	2134	1874	1	1	2273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifdWdunNAaDCB92KqdxjmgKUrpQbLWPrgHnJkkwZCeCkTPaab
27382	payment	2133	2133	1874	1	1	1850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfy6qs79L3GshvDNqD4kAymHJByNZL6i14HnZZ74yCS4rnKpY
27410	payment	1397	1397	1678	1	1	11429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNSoL9H7YrXfV3oQFE7bVVmwomtHtgmhk7bax6t5bkJpF1Kj4
27411	payment	2134	2134	1874	1	1	2282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbi177B5VvQnTbdqi7RBd6i5BKnWSSNTzBg2t4pD51pFwHSTH
27412	payment	2133	2133	1874	1	1	1859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgk3HHXqqotvGUNDHBtC39F17T7UDzHUkP1YsDwegLe2gBe1T
27420	payment	1397	1397	1678	1	1	11432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3ytyJYuprFKDiRA8ed3EGNQL1th8ML2pGcAUqb5cwbQcEBtw
27421	payment	2133	2133	1874	1	1	1862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmvjzh7fEfprpiS6qdKdgJDJQ3USvc5ZunysVpMZ9YHSTJvmj
27422	payment	2134	2134	1874	1	1	2285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLoVMXZj9PmKmr3x2n8ohCEx3U5qCy17f12ViVMB4j7WW7f9B
27433	payment	1397	1397	1678	1	1	11436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhayJAvxFJaGoKofZpz1Yzzt9GprjuVws2RYaANWudqHKHjHA
27434	payment	2134	2134	1874	1	1	2289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbds642fa2ni1mjtzcgoFoabmkDhiKCjVarN7wq8jweY5oLYT6
27435	payment	2133	2133	1874	1	1	1866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HgKTL1f2HCzyeqsikkMnF4gU37YgTBqReq542x6WSdW79t6m
27443	payment	1397	1397	1678	1	1	11439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMgyZmg9NGZgJBDkwPNT3mCM5qee7oUatw6tdL62P8Q7vKzUS
27444	payment	1397	1397	1678	1	1	11440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5E7Q7jYEVpohNKLKxCg72GGxbbg8Dnwd8fbexWQ6NNy4WCxiD
27445	payment	1397	1397	1678	1	1	11441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJ6v5esrskK6UJye7tgTq4urEsJApHKR1ZGmQbcprjXCr8p2M
27446	payment	2132	2132	1874	1	1	669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgswVrBcWrJafMUNpuAfNADomHmSiepfp25DXQ4rWDUYhG5KV
27447	payment	2134	2134	1874	1	1	2292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9M6mKgn3rBDZF2WVFaBfgUCJvH8eg67qbDxtWDgF9oDuKkBMV
27448	payment	2134	2134	1874	1	1	2293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiJEHaG95WbTSjrT5kQg4eYxuteg9Hk4SUeoknaWdzNG54iBP
27449	payment	2134	2134	1874	1	1	2294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NMpXwZVngRSXbCunYrKkgsWVxTbb4EGw849QsKTHgSgnCKLB
27472	payment	2133	2133	1874	1	1	1877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLL9XMkc4hZf8d37Cn3n99QiPiSoiRaevWSTRXMt6LCMDsWYMv
27473	payment	1397	1397	1678	1	1	11448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhN4btKjRYhwo9XUP6GPTU8TS3icLE6Euzvz8QJEixXuMWuhr
27474	payment	2134	2134	1874	1	1	2301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MMGyew6cmhkeH3wTPGBGKSYwVijSVNxio1tJJFYVUrnY8fxL
27475	payment	2133	2133	1874	1	1	1878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamBUbHoZMyGkhxGkti5hfBmP3aeTRQqx7ESHr2sB2VhUHpKN6
27476	payment	1397	1397	1678	1	1	11449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33B9o3fMaZMRNaMeBNHUSmUD4txExqBqbhAVp7o1RUzVUPvuZ
27477	payment	2134	2134	1874	1	1	2302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbkcxhzmb4qzrFLTKoHy48DQ2jRV5brHaJyWDqc9uLPww58a1
27486	payment	1397	1397	1678	1	1	11452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj7GHdFMemtUKfRCtZFSQu5ksA1obZzerxKFLhwLiNNY68Q3M
27487	payment	2133	2133	1874	1	1	1882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG7tT72xPkmyWE583iqiiM2Re2wZvacMi4mHJv8AvqipUa3H8
27488	payment	2134	2134	1874	1	1	2305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHe6Q5Drz5F7XEFy5Z4PnDV6HhnruXTcD83gsDtpnmQ7T54z9
27495	payment	2133	2133	1874	1	1	1884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPKQtNYgddVErKHV4QfQ1i8po3uFfNmZUyJcVbnXgGpoUmM7K
27508	payment	1397	1397	1678	1	1	11459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLBgimw2e4o52WNKAhEWUBGErJdv5zECYZiHfTyavf4kdFNKJ
27509	payment	1397	1397	1678	1	1	11460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes3HmvTb3QwBecaAs1LDGawqYuW3LCp2277VcdWT6fNvSeVGn
27510	payment	2134	2134	1874	1	1	2311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGdCFdSGEV8ZaDnq1v43EP3mGqh9vo8dRnFSgc9JpsCG92vJF
27511	payment	2134	2134	1874	1	1	2312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr88AjgNVS5eZa9BwW2JffLgTSg1Xw8MhG4VPqeVv1YUAVvCy4
27519	payment	2133	2133	1874	1	1	1892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDdqLhUYQPLphAe2xgtZBgwv21G29DHizEhRRFbL5oaQBLXkd
27527	payment	1397	1397	1678	1	1	11464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqsiwnSoAc5tmqwn58PbuuzUN8YY1qfw3kdf5Vm71rDiBTjjn
27369	payment	1397	1397	1678	1	1	11418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJMTNGzbqDrzvbTVr9ULBpCYZdi2rPMdoQE7LcGiJmQ53BUSJ
27370	payment	2133	2133	1874	1	1	1846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxsWmopQ1161tJFuDN4HYijfpBgRfzEES7RVCkQhBdEWFH3ES
27371	payment	2134	2134	1874	1	1	2269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7aiPctdVtZ4MHnt6DNxqcqWL4RHdScQuFQSLvGubAqaobXVs
27372	payment	2134	2134	1874	1	1	2270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYJsMqbiiGrpmqRfKfR8mmCkxiU38AAJZQiLKFGSDTEckLmLe
27373	payment	2134	2134	1874	1	1	2271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ5ZhiAoKDoX27ze1S4hrBC7dJKeRUwrvx4BdAv7LP2vyoBEZ
27374	payment	2133	2133	1874	1	1	1847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEA65uWBzXfvrTJdp9zBDknmwfmVHgn5xQEtVnCoC2AHE9R4c
27375	payment	2133	2133	1874	1	1	1848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkySdsFdcqAXARt6PwZ9kjTTr8AEah4gFffKz18BhgYDMeCi5F
27376	payment	2132	2132	1874	1	1	662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPNmL4dLRWegb4GRkCG1DUUgX12oghGCFe3LSVwAW8enaxTpi
27387	payment	1397	1397	1678	1	1	11422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3J7D1o4MArqD9BStB5HRk9nyuRsnPqFZGkMrY8qPScF9nS81m
27388	payment	1397	1397	1678	1	1	11423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhC7zPxrtWJBGoy5hbvyTwEQdxY64HwArUDiQ6N7zih3dqWck
27389	payment	2133	2133	1874	1	1	1852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AkWsC4G8N67wVMXBFjvUXGKTE5ZYsziPwWqYqLCyQxmsMAWc
27390	payment	2133	2133	1874	1	1	1853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8rEQjYAEM1FmosdSSruDzBqw8a3jndJQ1wn5TxLStSGgmCLr
27391	payment	2134	2134	1874	1	1	2275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6cxsMqMt7CmkgWPjCzZYqMgBTH2QriNc8Zp9Mmp1h1xpe7qX
27392	payment	2134	2134	1874	1	1	2276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshqRfW6KpfK73cQsrKrZZwejwLiZEN5sL7GnrAyDLiwdd4smd
27400	payment	1397	1397	1678	1	1	11426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH89JqBmBGfo6BexHYjP1ZjtmLNRTeCtQ4mPZtpEf4GLCZFv9r
27401	payment	2133	2133	1874	1	1	1856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCWUXn1QBF4oLpzEPsBQsgafnvBwD7pDyVGYeTthsjXrejdN1
27402	payment	2134	2134	1874	1	1	2279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsD4Pi7p1A9hqoiENd9TJ75HTxBWKhVb1YXQMKwfJrBnTRUb9
27413	payment	1397	1397	1678	1	1	11430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2qscivbsQHCRn8qMwTVSNmibZ9yXkuYb1rLEUUU5u4yZjLMB
27414	payment	2134	2134	1874	1	1	2283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeFeWR8hGcqN1UorvMtCHvs43EHfeXyvMQNfZFWCaMWmj3DzV
27430	payment	1397	1397	1678	1	1	11435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDUFxtuyka2ZiPjj6nh2TH8z8AAQZ6daC2oxsyDN6mD6q2Tqp
27431	payment	2133	2133	1874	1	1	1865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEFkPPoazvpzZQMdQRT5uPwNKzN8VXqUPydJfrU2deTowk3Rc
27432	payment	2134	2134	1874	1	1	2288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikZHFdnDc7vmNeaLFBjmTiCtYhYwGs98H2CQm48JcCuJ2GkdQ
27440	payment	1397	1397	1678	1	1	11438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWLMkFmXStshhU3uqLEmJZWhcvkdGi91hTsbsLHny7VKCchsK
27441	payment	2133	2133	1874	1	1	1868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoDaYLC1Z5exGq6fA1kPHsN38dY3dc6AQNPmh4XhhQ9zzjmKP
27442	payment	2134	2134	1874	1	1	2291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrVmvYvs27cXCwNC22w3psjJX4LRH5QSKoV1hMhoT5Swii55M
27453	payment	1397	1397	1678	1	1	11442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNQ1bBLy5NNy8PNF9ujTr5VAQ7AU5LGLBAuR7uznrBou879HN
27454	payment	2133	2133	1874	1	1	1872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5H92eunDcuXkGpY1hKnsgSj1ZmRGCxZQijssXqZVeAV1SyrX8
27455	payment	2134	2134	1874	1	1	2295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TVmWQC1PRwjuyGTWTGjEwydEAUZyN4f1G1yka5QWCKpc6bDm
27489	payment	1397	1397	1678	1	1	11453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQeFaPwePHLTsKmFAL6us9qEJi5253Bwa2LLvBSErKKbMYis2
27490	payment	2134	2134	1874	1	1	2306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpr8q9WC3FLst5S1UEHFXvqCqphFPRyWvTPxfcSSjj9CBMBBf
27491	payment	2133	2133	1874	1	1	1883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdDg2CrgbXYEJgrF2XoW4uZzcqUEDDjxfhPypDrP4fT6xstrd
27499	payment	1397	1397	1678	1	1	11456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8UYWUitNXQJB1Jf9ZXJQLPURgvuxgxWSsJbSKpX5oKE8uNZx
27500	payment	2133	2133	1874	1	1	1886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvpPQjD6Qoa3ipb2kKYWwrkFtVN9w9YJM1jy64xpoFNB27WXX
27501	payment	1397	1397	1678	1	1	11457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9ug9NrYrAnCodiXxskW2Fh7raoQhA8ZSgFGTAsD9vj67XhHu
27502	payment	2133	2133	1874	1	1	1887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2BbdbD1JCv4ZMpjwRg84gJPx2vBiSYiJpRYtttRTHu3c2fDv
27503	payment	2134	2134	1874	1	1	2309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqV3ZoqSEsm4nUHfKWf19GbRdtwfmYRMxkDNrDPE1fZNamVhv1
27512	payment	1397	1397	1678	1	1	11461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JBAjJj9voXurzWrPgK3vPfJRDy1DHBTcp5T9EYpouq3Kqzhj
27513	payment	2134	2134	1874	1	1	2313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqjjK95cmE1nK3gzpiuZmMwhpWtrN3c7nC4A3CPw4BkV5G67Q
27409	payment	2134	2134	1874	1	1	2281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bFCigPquwCfDCM6KhCowK2U5HBXhHDD9THiSbPu8haEdktEs
27436	payment	1397	1397	1678	1	1	11437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow36cX2qXQooKcozdqn9L6mTuB4LQTABGQ5S76NzFKo8txeWD
27437	payment	2132	2132	1874	1	1	668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95hLLQE8KDHDzcmA7evjtmJYEP3L39HX13REtUVhaWf2Z3XhG
27438	payment	2134	2134	1874	1	1	2290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQepWDvCE2jNPFjqMTrGCXWNfeiaAcRU6ZJiQca6eDK9BGE7mX
27439	payment	2133	2133	1874	1	1	1867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YnyRBmHkZM8YK7jq8wWv1xcVcq67NRT1aKQdnFsRv9Kzaiuy
27456	payment	1397	1397	1678	1	1	11443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZURFBGaLDbvMZXGkPEoJUexKvghUWWk8ZRpkXz6K2cQR3cvYW
27457	payment	1397	1397	1678	1	1	11444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZMDAXL6PAQ4xKWrNRTsaZDe7qeD2x8B44YTTFMvZC2fD48af
27458	payment	2133	2133	1874	1	1	1873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt17uGoxTiwkkaK1QKLWGHJkGsu168k9sRVwX1U2VcQvy2yPWY
27459	payment	2133	2133	1874	1	1	1874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUhEBtxpnWKgHBdAvUcQr85PDsEydzKzSawLZXqqoaXkGoEAi
27460	payment	2132	2132	1874	1	1	670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQah3YguxTsQRZ4F2YugcsC88Sff7dH8oD1rK7gVKugoBh1aX
27461	payment	2134	2134	1874	1	1	2296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxteW8UEVVhcEQto61dVKLC1gUNDRA7iXNKe6qKSrG5v1jPsU
27462	payment	2134	2134	1874	1	1	2297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPMTBFekW8v9jK4iLg2dcrEgVkLZBeyscaCwCnuXGBFvisbmf
27463	payment	1397	1397	1678	1	1	11445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93Ef6G7cnuVKLAG2bnttqXc9Rffe1zUsRBiNHUUWMHbX47Vy7
27464	payment	1397	1397	1678	1	1	11446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyb3PzBZmvKpBBU2iwFnkFoBA5ECWeGWmFPEZRQPxo71VWz5x7
27465	payment	2134	2134	1874	1	1	2298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy587tTbcJfVzixqjA8PxgEuxyVBXqtwoDRprv5eoQv3MG5gHe
27466	payment	2133	2133	1874	1	1	1875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZdnkQUnM3ctH5oVD1hrRSUsXLruSpwPDLrgPppmsxzM6orB1
27467	payment	2133	2133	1874	1	1	1876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BmULF4CD7byNUG7EJ6USHaYtM1bPDdqor5NufVk5AixNYLe1
27468	payment	2134	2134	1874	1	1	2299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDjs4e8sizXdjsQYnrgzva8SUMBWP2HWJKe97KBDcCVP26k7W
27478	payment	1397	1397	1678	1	1	11450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6JBQ49eLywAX66s5hDwD398QWRkdoJ2BpLhz58BkST9r2SqiB
27479	payment	2134	2134	1874	1	1	2303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMa1aQ98AWrxLtReRS1pTsshN8yGNMy1pTFXaMf7huUyAGLkx
27480	payment	2133	2133	1874	1	1	1879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYeXNTmKDQEaxXuZsLi6yQtoBCipwgSijKEH2jC3gQBUa3gVZ
27481	payment	2133	2133	1874	1	1	1880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAxEyem4foZN1U3rarTXVnEAU4N6aapuGVP5BUEDCBhEveDiA
27530	payment	1397	1397	1678	1	1	11465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDcuuxzxW5sLRvH52Uzm4jdCT9Awuc3C8G78Ropm4VKUPg3C
27531	payment	2133	2133	1874	1	1	1896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdNHStaqmzXnQw1FMmRcTf2cw7GUSB6YkDMT3rJA6TFkicDNG
27532	payment	2134	2134	1874	1	1	2318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Cd9T8kt2idfQ2C2x1MAXuX5Fq3RYyGwQtp4As5qwd7FiT82v
27533	payment	1397	1397	1678	1	1	11466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWqgCxuVANUMgqEjp3D6dMgQawdiEtM3B3dtGfkBL97QbZ7zD
27534	payment	2134	2134	1874	1	1	2319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkzsPc9sxYWogWDMWP6kYBytrEFRDfPevNtEQA1qVTbqiHEc4
27535	payment	2133	2133	1874	1	1	1897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4CiEHiY7N9AdR3R2FFGTPfGRWEzbLDhaJugrByTeJFXtewPxQ
27569	payment	1397	1397	1678	1	1	11477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36nfqpYke6Q9ncXehBRMbwWDnqxA4JMufVTngaE5w2tQxu7BG
27570	payment	1397	1397	1678	1	1	11478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWs1MjmsTUjXdcUoBmBqX3GtaSEB9exUhCFB4mCK1BzaWoBU6
27571	payment	2132	2132	1874	1	1	680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPaZNuvwQCrtRbCjfRvRhHnKLicqcGcRDqShxmQzD6XRi1RQQ
27572	payment	2134	2134	1874	1	1	2330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGbwzRrJxHQVGYgkmr5RhX5iS4nGi4QvQsdihoCFqFaEtTyt2
27573	payment	2134	2134	1874	1	1	2331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSg92CApcMdqtPmpzCnSmFBaRCzkwNBLyLwBkK1XotbRqmgYz
27574	payment	2133	2133	1874	1	1	1908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KRR1Fwhk1pEFcAi3EUUhkfUksvT53C1f6uMAwbcEpgzd5xqE
27575	payment	2133	2133	1874	1	1	1909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGx8t74q3VTZpcMLpei6ZeM51QfFVooAmQQpm3T8qwWdGxLKj
27579	payment	1397	1397	1678	1	1	11480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD9AyfYR736DxgZWMeD5WxJXyVTgi7uMnye6RCnY3qRjux5BR
27580	payment	1397	1397	1678	1	1	11481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfiqtT1zN66QjC4Zd74BhaV6RzkAdK5xvJtS5pK5wppv3EKSi1
27581	payment	2134	2134	1874	1	1	2333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TBDxHK3LLQwa9kKxsuaGz4bY9Tf3vZhnyLc3JnfTPVW3nVdg
27484	payment	2133	2133	1874	1	1	1881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPVfMJEEEqETuqE2k4KhQ1zco2MTTag4C4geVbMjYjbqqQb2D
27485	payment	2132	2132	1874	1	1	672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuctjgAXcg2cgW2LnF3XUeTSekFoczj7wme5J93aFzBK26Meor
27492	payment	1397	1397	1678	1	1	11454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzC3Tf8bHxTWRMwLUbvhK3a6rfQ5xkBMNPJmUNCvFQjzh5T1h
27493	payment	2134	2134	1874	1	1	2307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbckpTo8bw9MKuGBwDD65kHJ1ttqj4saoCKS82FSq3gPwHThg5
27494	payment	2132	2132	1874	1	1	673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZroJMXGi8GMqA9KQyfZ62tjmBn36YyCQmf4ycNm18ssyPA17oh
27496	payment	1397	1397	1678	1	1	11455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvaXkFAwcDdZEfwReUDppCFMivKLxL1YitXupRbPdDcVhrsc1
27497	payment	2134	2134	1874	1	1	2308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDdC9FKoGafhTD7L7t7NHZ9Bfv6MxUA13o2gftzHRbvRRKF1T
27498	payment	2133	2133	1874	1	1	1885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6V2CsWPtUC5WG5XYQVkyWvYLhYdoZngr68apfAovN3DxPe5C
27504	payment	1397	1397	1678	1	1	11458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDNiY7NqycdHMfrmcCH4RHtHhTfTaLQYE9APpkvvsCQ3KCuSZ
27505	payment	2132	2132	1874	1	1	674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckf3oDfYy8QURbtr3TBthnokjpRYs495gtsv3ts1j4JhMBNqH
27506	payment	2133	2133	1874	1	1	1888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3RVy5sdE478XuWFusxTXTyKYXaH9C65ynkfJdhzTcB9pzMeh
27507	payment	2134	2134	1874	1	1	2310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3ws8Cj7Rvwor5aXFijLn8zf1mjCDdgen3yGScciaxcLtLJFd
27518	payment	2134	2134	1874	1	1	2314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3BWYZtyM9M3NSj3MDH7C5LhfnDtSStC4cZHXcnobUbLp3Y1P
27520	payment	1397	1397	1678	1	1	11462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhx2g3gHXUxz575U1KNYosk8sBNKF63kijZB2qyYBfndPJG4BD
27521	payment	2133	2133	1874	1	1	1893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHJa5jLMtWtuoqiW84RPznp5AVHR17THj9WkgEia3vwq9ea72
27522	payment	2134	2134	1874	1	1	2315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uwCKzKNExgwmLZwXGkrSx2VXE6tkVfiduNUznf5cUFRuhsuq
27540	payment	1397	1397	1678	1	1	11468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVDGM33SnuNPU1kxW27xK7Dd7jvDtWLArwmb45ErumBLjnHgL
27541	payment	1397	1397	1678	1	1	11469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjqvYpo26iMKffCUHYsXYqQ1jE7G2wCCd13huYXeAz4Ws5acB
27542	payment	1397	1397	1678	1	1	11470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6tovHiTsjunB4wnNKsDNazYX49gP64qNsSKmb4eipP9GT4Cj
27543	payment	2133	2133	1874	1	1	1899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbfKiJfBr5JGRNQK3wVPuaX6UBg2PMr1bMFCz2wDS4dhcPRcJ
27544	payment	2132	2132	1874	1	1	678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNK2uF7CjrnTuFZfNZqnP84BeBgY3q7B7gxBWUJEjtogzsreeF
27545	payment	2134	2134	1874	1	1	2321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUwWHnBkEBhMq5PRyxRM7J1erB3HDBp8Qptp5yUMeCsVYGbb5
27546	payment	2134	2134	1874	1	1	2322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifMk3xCCfPYxe48xK64Bw7qtkJ9s4McVug2rGFWy4z7eNBoqx
27547	payment	2134	2134	1874	1	1	2323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfRPnLHBwgKd5vvAQJKLxge8qgdyMnKDMypAC98JvADwL3X43
27548	payment	2133	2133	1874	1	1	1900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9T57jtoD6WG3zPYJeZx79GGoJyE57mPdcdJHa8HWtLHTAmNNV
27549	payment	2133	2133	1874	1	1	1901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNHYHnNhjM1pQdcQEtLTBhDztbzxNqJEiWuYVWJjvXciueTtz
27553	payment	1397	1397	1678	1	1	11472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZids6LYVc5kvhhsBYWa7QDhWPNhCHEATDLyuU67juXX2p4xGfq
27554	payment	1397	1397	1678	1	1	11473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6d6NJWUVCYkHJ7yfqLarEteVcarA6gLAhrKAgu1SqzWoyZFK
27555	payment	2132	2132	1874	1	1	679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYcrEZWwBcmhNcFe7qnPYsve45Ci6qBk6Pz47i5q7toLtCpJW
27556	payment	2134	2134	1874	1	1	2325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzyufRCAHHh7Loj7fMsDtTsCfTJYnex5NjnvY3DmWyd9NqxmB
27557	payment	2134	2134	1874	1	1	2326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPUTXM4o7sayq7B7bjc8PEm8qVymZWbeXybhKd7b4W3MeHEfS
27558	payment	2133	2133	1874	1	1	1903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dqg9m2Am1Lm4bm3S6yURaehpUh3PXTJJUj3eA4mNhdM5Yyns
27559	payment	2133	2133	1874	1	1	1904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6GHZdeK47DrnXTmqYHAJtn4SUK8aQuKTpihC1gRUXot7b6fy
27560	payment	1397	1397	1678	1	1	11474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxBo5hBVqK8SAUrx6KS3rda9EqrFJ7o3xqMocjXU34arRDe2R
27561	payment	2134	2134	1874	1	1	2327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5Lv4pVo3URsi3bvmxh9i6BXvfnoHQzJrxpVkHkgkFenEcsHA
27562	payment	2133	2133	1874	1	1	1905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcieYydBhYY7DL2k8GrbApV3amVJ1Et4uGewe8uZPficLwGk5
27648	payment	1397	1397	1678	1	1	11501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXy98MBwzNwpTG4rNceVFzU4iDtu4JpJo9VZhgFQmz5q1W4zwa
27649	payment	2133	2133	1874	1	1	1932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd33ELTpeNRY7Ny56UYBU4YGAaLNH1YtsCcKCGCXDNM5ybsBLu
27514	payment	2132	2132	1874	1	1	675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8myAx7wXAy6Vk2j8KEXBTFnKqzaMRxtrN21RXw4j8F8PTeko
27515	payment	2133	2133	1874	1	1	1889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVusrnaECyDHpMSGgJ3soMGCzcwmdtDML935JdUbgogHRQSd4
27516	payment	2133	2133	1874	1	1	1890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzXDvssfmLxiZTDP7NsUcBUTzbmdi4azA3Tj54bye5QVjFijA
27517	payment	2133	2133	1874	1	1	1891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzHtTMJk3xp8vSte6rLkxAbCHgAT7CLkikYc4WXUgU7X6Mq4b
27523	payment	1397	1397	1678	1	1	11463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBYUcQnpfT1Tc6W3dVkHV5VYvKVevgHzSSNqADnbFGQ7jbUn7
27524	payment	2132	2132	1874	1	1	676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWU34kmyS4xZx1JTu3UKDHXoaFe14gHsd42fTRbbJAERSPt2GN
27525	payment	2133	2133	1874	1	1	1894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJC7K98BaWD41Fzvm7RpjVnbUhUTt1Pe34E3sjnTQo21SFWbE
27526	payment	2134	2134	1874	1	1	2316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzD7YdWBjd8kYxKWGoUeAEk5SVNgkrzef6MZW1aP78CanzgYKT
27536	payment	1397	1397	1678	1	1	11467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjjTEKqF9VDTrxhAcFfjp28qVQqGkfN33NPZarWCcSX5D9eED
27537	payment	2134	2134	1874	1	1	2320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eecr6z8Vrde3grUucpD5Jwm2hiC5rHm1PMbJZsRZMGkjVaTX
27538	payment	2132	2132	1874	1	1	677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVqvVq8sGre1YZjPdeiAxr4ek2MZ5415aRCZc6e5ihGAufDrD
27539	payment	2133	2133	1874	1	1	1898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1Jxa59tzbhkwahmzQrnV8wxMYX2eYCWRsqcoTjWXdNqJwLuL
27566	payment	1397	1397	1678	1	1	11476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXCHRA61DC44qNEnGhn6dfgQMiAjHcZgZRp4H4LktPt4g7d92
27567	payment	2134	2134	1874	1	1	2329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjopWJdbkLt6PGad9JsZQRFPCQ76vmBrjuXSAPVEPq7MUy2dK
27568	payment	2133	2133	1874	1	1	1907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3GUrJF7v5yYjNUC7c3mAXiE4mUFkA3mayMz7HbdmbK7e1WVd
27586	payment	1397	1397	1678	1	1	11482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL77i9VMyibPF7kjJkPUxq9oePWeFnJQa4rDD2DP9obZHSsT7
27587	payment	1397	1397	1678	1	1	11483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDp66W4Xd6Jq3RNxt18CKjMYQLJvD5AmdjCJSyp4SFkRwFMpK
27588	payment	2134	2134	1874	1	1	2335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPj4znPSw8RduN3j5emQvRow82r4Jv96ZhkFBBdANaHZEqY5n
27589	payment	2132	2132	1874	1	1	682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9gxaYxPmchb8DX5br8LpwGvFEqdCGedrikQJTUiEh1A9kHPK
27590	payment	2134	2134	1874	1	1	2336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSEb1yaRyQ28rkCkKQjBNyoRZ4Qh6jLtjuPtif2UB87nFFeYH
27591	payment	2133	2133	1874	1	1	1913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qwCJMet7nQxWPQ4boZ6wPH24M2bvQEhNQZobwM9emBK7sRSA
27592	payment	2133	2133	1874	1	1	1914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkqKcXzW3AHYRTu3qCxxLVDPu8Q5zaUdDiZcRqiiti3Gi2uUd
27641	payment	1397	1397	1678	1	1	11499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrUDnPHwMTcV8r6CZLmZUA5tmRsdwmPp4kmwytZkYuUxDYQgQ
27642	payment	1397	1397	1678	1	1	11500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7GfH5AwvB2T5oY4v2NmoT29TmqexL9Wgdx2q2eQ59D5UoJE9
27643	payment	2132	2132	1874	1	1	687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo21mkoKpoqmKjvtddUrCL5BfteYcSzMQG9rK3fcAoNhLB8dJs
27644	payment	2134	2134	1874	1	1	2351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21j1X3D8i87j4efqYcKW5YEfYU86KptYtbD1o9t6HhAwzyM9H
27645	payment	2133	2133	1874	1	1	1930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXjWSTBmR9N6uBivxkWY8iKUFMTmceRpKhDLmsah3qSqK1psc
27646	payment	2133	2133	1874	1	1	1931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfudCm1ECZZG3aUSgNmi6pN6hppuAvHBZMBB3sjzgfbZxfF4QD
27647	payment	2134	2134	1874	1	1	2352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMiBtujnr16Wq6AaDyj6fr6zfVPAnwMHPv1zC1a2HXVSQg1DF
27654	payment	1397	1397	1678	1	1	11503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXEmErtZeeapL3emmyv98LE48obnWrpE9X7834MNu6gfJcEcb
27655	payment	1397	1397	1678	1	1	11504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWadwvrsLp7yS83hEP85Wbu8QfZUT3LSYEEe43Z8pQpagBrZo
27656	payment	2134	2134	1874	1	1	2355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhVV8NhQ5gxqxydhuDBuz8xqhHvwAv9a66dDyMaDBbytAP42F
27657	payment	2134	2134	1874	1	1	2356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnt43K46jJpUuekfbwYFForJ8YJine76iQrxEK3JvztvdvQsK6
27658	payment	2133	2133	1874	1	1	1934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7U4R5zS2tt4MjzUrgbQKFBZWUysERRMkuQj32ESNXdczbPGL
27659	payment	2133	2133	1874	1	1	1935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPQNdN6xUb2L4ityjpa9wZda2Tgz1hj7qSy3sFudHVDnDiAcj
27660	payment	2132	2132	1874	1	1	688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwoUSQ2n7jAjxsy7vYmKeKjKy26YZJfa6yoayru2cnm8QAP3z
27671	payment	1397	1397	1678	1	1	11508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fZEggnQQ89keyenbeioF8Rg4AHkZhctCxFPn3CYuF1dR5Qzt
27672	payment	2134	2134	1874	1	1	2360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCvTP5adE2TR4hgUiVub3aoSssn7n9WEL2nASkn44R7PXUvH6
27528	payment	2134	2134	1874	1	1	2317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Dyu6nWQGpNFbGBNhip1nTaxy7utBwaWBFy7BdtSQzh6cL1i
27529	payment	2133	2133	1874	1	1	1895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kQafjR1Ld5z6HUXSH5WA838u6ypwtBuwNsF55Nvtjah88hGL
27550	payment	1397	1397	1678	1	1	11471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJwTQ62dNuKuiFrnvDjGeYxynV3zxiPZM9pKW1h9qfS7rVf87
27551	payment	2133	2133	1874	1	1	1902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zRmfPJXV5Cdd18bdr6oSD3YBw8FTmbKrXLQb23s12dDBCrGG
27552	payment	2134	2134	1874	1	1	2324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Gd4JYPQgdXxQKpVyCtxrH8ZxhVUAuCJrWqg8aUbtTLFsBhiJ
27563	payment	1397	1397	1678	1	1	11475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRMENKZ215asK5syNbT7MHNDQrsimEKy9kBcd134PCY5EFwPF
27564	payment	2133	2133	1874	1	1	1906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfN6wtseeHUMYa6tmezUGfMtuo12zsEsEhz3z4goXJDnzwCcN5
27565	payment	2134	2134	1874	1	1	2328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pmWSQ5kMeKXnBg8HkWWKyuKGrAT2ZCh8VL2Hxy7SPnKFajrE
27576	payment	1397	1397	1678	1	1	11479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQT2RSo6TQ1C4LvtWpcYbAD9Hfgce7cBe8vCvstbkRVXyh6ic
27577	payment	2134	2134	1874	1	1	2332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxtLhoLnzMwP3mk472NvRep2dcREje8UL1NtgMc6dqTDvWvFW
27578	payment	2133	2133	1874	1	1	1910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAavf8P5EPguDmsfwArwbzqTs8SETMZaoRx6NS7BRWDX8xWeXe
27611	payment	1397	1397	1678	1	1	11490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ117bhmCDSp1ioBb9ZTvxd8ED1AprvRAe9rZxTSyygcCjipga2
27612	payment	1397	1397	1678	1	1	11491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyaK9XzjiFZ1ejjYgdKgg7zpFrUuAc4rtYZh3UJ9MWFKHXKrj
27613	payment	2134	2134	1874	1	1	2342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8McmeJYgdHqwsgdE1zqTywT4ppphrAu8JSNRA1tTyMCZFPd5
27614	payment	2134	2134	1874	1	1	2343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA3XuHdqznyggntYKvS1C645tZyyG9PHtdMx4vVEKatn2GWer
27615	payment	2133	2133	1874	1	1	1921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZjG3Bttq3EP2t1Z9peD6iYJaknRkdvZvggm3yWUWHQR9PaDh
27616	payment	2133	2133	1874	1	1	1922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6aBLdJHcJvt5vggKB23UW9NcTZ4uFYjj6BwMHABGYP4DHremJ
27617	payment	2132	2132	1874	1	1	684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVfNQjzkRn1RigqWDgzdgWxTTr9njZsnTqChGMzQReqyu5FDG
27618	payment	1397	1397	1678	1	1	11492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gfbsJzn5jGmXQUH14AcuWimCK7jK4GP5u5KFR3BymqGu7i7d
27619	payment	2134	2134	1874	1	1	2344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniRQsx6zJPMJskXUtWMWoUKGgLYvJRRiZaZc4GoWeKUTf3ujj
27620	payment	2133	2133	1874	1	1	1923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MAvirmxztVUjqsb8LDMgjr4CyDwWM3Hw86wYAR6bWAM2TZcz
27664	payment	1397	1397	1678	1	1	11506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQnGukT86QrMrwdohL19YPuYQAxn3a47ygZRSnz6EDQfgH9cB
27665	payment	1397	1397	1678	1	1	11507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oZZ3fQDxxuZXBiTgCpJepJokZBZEjwwMzfR6un1VJSzJEJvo
27666	payment	2132	2132	1874	1	1	689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJDjkn45pdqecePtmUmczejtgsG9i1QHHWeZJcWwyt8bMvqV5
27667	payment	2133	2133	1874	1	1	1937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sgCYgkqxaqwCuAZX4JravETU545NtPvvTEeZFBKXj5cka7KR
27668	payment	2134	2134	1874	1	1	2358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmBYYFpjtxPm4Taw3nrTs6cQU1nByUo9A3WcY2oCq8uT8pjch
27669	payment	2133	2133	1874	1	1	1938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkvrCHD6mFFcU6qKkU9bfpcymvZFgAahePURwcvjbcdBUtg8J
27670	payment	2134	2134	1874	1	1	2359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCn2bcC3vCpRB2zPMAnegMLKUFBT4J4YrNqiXf8AqVtychyNzq
27694	payment	1397	1397	1678	1	1	11515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLKLusEDT3QnQhLT6fppJTrmvaBnFTT2Yr7dQ12SmhQ79fKiE
27695	payment	2133	2133	1874	1	1	1946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8rTRVKNiYr2L15qYBf5x98NLuwX8HPvWgvWrGcS8a8YJN6Ua
27696	payment	2134	2134	1874	1	1	2367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuKXAxwsZbgH5snhbeTzL5vewuDSAiLQd4jpj7Gy21KPcgtDk
27706	payment	1397	1397	1678	1	1	11519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszf5FPmysmLR517Gz68hYBdiwEahJKVWppDUXHBR57gXU2ziA
27707	payment	2133	2133	1874	1	1	1950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTv41m1RaHMACWt9caHqw8SGakK8yrLfgyo4RX3XND7D99D2Bp
27708	payment	2134	2134	1874	1	1	2371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tLqoxM6gADZr6g8gGcchjWamriW3NWUzuyPu1vzYtJg8doAp
27582	payment	2133	2133	1874	1	1	1911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3nJmPDpBb82C7AGcwwDDc31yAhcEaECcPnwTF4K7zQJHHRbE
27583	payment	2134	2134	1874	1	1	2334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHDRnNa77cQu3XKjqh84YMLJAvfuwKhSzCaj28bENhruQQn5G
27584	payment	2133	2133	1874	1	1	1912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaLjpCqsr77cqxyQJphUsW9NtRFw5UJU9yeyiGYFXcFxvhRob
27585	payment	2132	2132	1874	1	1	681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2FH1zEeRra5uDdASJ4n7sBnA95KHndhEg6yiMVVBoiXU8F8
27593	payment	1397	1397	1678	1	1	11484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTov59BXYNdjKDzoUATjNhDq5mLjMqTbniXWDmqNLUUiDCVTze
27594	payment	1397	1397	1678	1	1	11485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzK9gLDwsa3sL5Ef8kkCqYdwS8uwpPjFBGArHBdgmrgYdha4A
27595	payment	1397	1397	1678	1	1	11486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXAwc8vZD7cSduaCAssERjewFUnYCxS5nLeir5sbBFTM2uiCp
27596	payment	2133	2133	1874	1	1	1915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU86qAXM27F1DHJeHa6thvA2D5Q2EYEAGSBu96qz5wwQ7x4JHK
27597	payment	2134	2134	1874	1	1	2337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB9EptUn4Yr2taMn7HE88w4Gv9xHQqKWyS5G17WZ5yEx8TpLP
27598	payment	2134	2134	1874	1	1	2338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtxo4DRU6FCSBqsVqE989vm4boKe2po5MHgerCqfPdqxHHhe
27599	payment	2134	2134	1874	1	1	2339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdYVXn9MBiAH8yziiYMD6kscqDZzs4ibAKvdN3YxRAjMpnvwP
27600	payment	2133	2133	1874	1	1	1916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8fyQETTejX25ndhLFv799d2BSoqsPRhHscbNg2hAEPdX9drP
27601	payment	2133	2133	1874	1	1	1917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JnmjkMFvtPNFL1NCrmfzvNJfhQWP8zCtt6p3Se2E3Bj1Y9a6
27602	payment	1397	1397	1678	1	1	11487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTsVb9N2iuNW73YH2qu8w7cNi2mBPBtewTDAvaG6LrJFdkPa3
27603	payment	1397	1397	1678	1	1	11488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkvjDKnYQBJn2hmjNz5MBHtWvDeExxFEAJpyC1tE6ehChpVqM
27604	payment	1397	1397	1678	1	1	11489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHCk55EcAsXfvcNVcdsqGSvvjsPa5Bovs6ZKmQ94sFFa3kApg
27605	payment	2133	2133	1874	1	1	1918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHrABUVy6yDNPHy6kKXp6FJTjReiVJ18r8bkh6HvnxtVp1HVK
27606	payment	2133	2133	1874	1	1	1919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsdAAQAbrMXHGetgFZszhHgFuWtkqHLMpwuWc4GkQYcDAPTpJ
27607	payment	2134	2134	1874	1	1	2340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxLSVBH3f22fVWWiwrzKUDa7qLfNLWRV94yAuqNcv8tGgmarJ
27608	payment	2134	2134	1874	1	1	2341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcVsAHbLsCvcuTKWoeVXv7SJXpw9ME7XJyF9hHbtf2HgCSGSx
27609	payment	2132	2132	1874	1	1	683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FVhGJY2eX9ScNwaVRWkxVUN1jyiZ1ZpxmZxjz7nLuzQSQhpH
27610	payment	2133	2133	1874	1	1	1920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85TGjP5bJunk2sBHZ7tf82Ng9Vurf31CWKBbn952ZGLLWzP9V
27621	payment	1397	1397	1678	1	1	11493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE5NfVXQUS4bWdFJYanvPjk1FhTZb21MZoaibQqkYDBFZk5m9
27622	payment	1397	1397	1678	1	1	11494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXefK2xMYUGVSQF3PCZDz15rAZiTHXmDJYa9BdqqdRaWiJZ3gN
27623	payment	2133	2133	1874	1	1	1924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxex951FpoTrxXM23F69AMPxzS6VermCkPbxMBQZPW1bod1gb
27624	payment	2133	2133	1874	1	1	1925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqb55c4LgpuU8ddYwq2wFj8LqmAR6GaUTqjTJwFLGm1kupLTTE
27625	payment	2134	2134	1874	1	1	2345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HbPRgNzkxbF76rvKm4VPXeDjQBT2eLC3y3XCqQVyoK5G74Ft
27626	payment	2134	2134	1874	1	1	2346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KnyJk53r1pJivVHZfSASghtrSrPAnXh9zb8P16n5FCv6uDBY
27627	payment	2132	2132	1874	1	1	685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhX3ZXjjYAbmx6VLE6wmYam9axEpVqA6WkApy5oUFCo9j44p9
27628	payment	1397	1397	1678	1	1	11495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF1iCbe4E4kMJcpuoJq8xV3W8BnReXfVp71ZwamoiyG3mLonT
27629	payment	1397	1397	1678	1	1	11496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXt1ovfVKGWM8ncwMWUeYuGr7wGoKNTzY96WQCBPmxEfKdiqV
27630	payment	1397	1397	1678	1	1	11497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXseysJcYZ4EHD6BHWtZcR2dZo5wbQTZ3ykiQvQ7sBdTSEUv5B
27631	payment	1397	1397	1678	1	1	11498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwttiRnS7E7cG5dUdCjNypJwGdSEm4aZn9b4hjz5qhzNgPWio8
27632	payment	2132	2132	1874	1	1	686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxxfPptEz6xxaYuFLCeDGv2aGNkSETsUy4WYiaAeHEuzcnPt2
27633	payment	2133	2133	1874	1	1	1926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1wGuXQQccnxdVzXpKWJKjQHJFnCViQfGaGMG7BMA5bCSgE8F
27634	payment	2133	2133	1874	1	1	1927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcSUiYt8vTTQ2c8yH5CNCCUAyo2ZfK8eb41STKFj3dqWzVgaC
27635	payment	2133	2133	1874	1	1	1928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oMzNP4JYfRaqAar7i49aEZD15Xmjhnbx6oNmSNgoDgKupHch
27636	payment	2133	2133	1874	1	1	1929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5T437X7wRqUnt8TM4VABPyX7rY7hkPA8xBGGMVLce2QGyPYW
27637	payment	2134	2134	1874	1	1	2347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hyb3BjundapUXDs1ZmvhjFHkeh4pFn7SCKF73Hmbquctb5ZZ
27638	payment	2134	2134	1874	1	1	2348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMA6npHg4eZ91HAu8RQPfg1mFng93eNGteKSgTpPmMwFQgP2Ax
27639	payment	2134	2134	1874	1	1	2349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdfJSXSDTNWe75nSihh8JjRfU9h2pCtZfeE5LeGmNgCv2EcnW
27640	payment	2134	2134	1874	1	1	2350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UUK5PbgtB846VhsMkhEwWFMCRBViAa73Btew8Rew71iJgNXu
27651	payment	1397	1397	1678	1	1	11502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkwSSgEKt5iM3SiK6QLf6jDAVu6tTRf8kC3TvSNFkkCtXb4RX
27652	payment	2134	2134	1874	1	1	2354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSPv7WCiEV3qQTVYFkVURvoybXQZHr4UVkUKTP4C9badg1xXk
27653	payment	2133	2133	1874	1	1	1933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU35gGwMznVkX1ggztHSvaKt8Zp49kEnguscLzYu6zBmz4jeXM
27700	payment	1397	1397	1678	1	1	11517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wES5Zu7A35sJrCvuDSFFEM8uvQ5fFaDR6v3nS8Tm8K5Gr535
27701	payment	1397	1397	1678	1	1	11518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwuFuzaTFJni57pS1tVrsEDy9pZzcAX1MebMoYNDkJ4hcU6fwZ
27702	payment	2133	2133	1874	1	1	1948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCBgv1E5TnX5iKKXRTa1AmiWXuQjvU2JspSERw9ws9RPDkzxA
27703	payment	2134	2134	1874	1	1	2369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxyBmEokPMq1sjFX9nwJnByuUm5JhPEvhvaQjGn6UknkGRsh8
27704	payment	2133	2133	1874	1	1	1949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2TcsAZn65LThyp78y7yLQLJUBubDQ1rPLgZFEodoFLECxVCE
27705	payment	2134	2134	1874	1	1	2370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvXP1hisFnL7H8ZZgHGMcwKCwvJLL4EjS6qv7sc5aRs8L1kvJ
27712	payment	1397	1397	1678	1	1	11521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JkvNqDUMNziPrhKr5oZzyo7Fnz6JmLNpC1QoDQA4WKaJG4y8
27713	payment	1397	1397	1678	1	1	11522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgNyxoLtxGWyyt6cyLJhejaVVhFgSCmFamqUXJpp1QWhUFVoJ
27714	payment	2133	2133	1874	1	1	1952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7w4wHMDTvbdJLob2BJMiaDgvd9wpH3uJYwN3f9EMvxzUSUfK
27715	delegation	1769	1769	44	1	1	53	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQp1nHuS3SD3ycpqhkD55g9hVJrU87n7ggunu29zEpY36FrHaP
27716	payment	2133	2133	1874	1	1	1953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyigp2ZSY1XqG3BJxg57hz3GsRzi7TDCmnkFyDmSdWNzyBg3Bj
27717	payment	2134	2134	1874	1	1	2373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Mfm3bhehi1Rw1m6kjvzDxh9H68yYTEGVkAR7ZhpkB4mfd9sE
27718	payment	2134	2134	1874	1	1	2374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vbwADMnYp4joDLzVvKnsqGyasD4rH9ki33VydM69TGuToVFA
27650	payment	2134	2134	1874	1	1	2353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsxgSxkcaN6Bn37qAhpseWEH2p7YjE3kgf9ngFw93832faQwK
27661	payment	1397	1397	1678	1	1	11505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsA5xRwCAxUr9bGjejNXVb4ou5BVVMnPd6eS15fjhMV8CR92Vc
27662	payment	2133	2133	1874	1	1	1936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtnk4rercSSD54i4315jdahiX1kojP8ty6J6hYmMW7g3YCLnN
27663	payment	2134	2134	1874	1	1	2357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgpCJSsnqdCKxdKgBdzqXhPEVA7pxwrqt8zhv2jrvxW1Y38Yv
27674	payment	1397	1397	1678	1	1	11509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1RY8egysyhdzKxTSZazkMHfXF16Ykyxa1ETjgLovN6CZswgc
27675	payment	1397	1397	1678	1	1	11510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXGewPEMR2e7iKQizHXXL3zjZkqFdFLRejtJKT46rWwFfvFmP
27676	payment	2132	2132	1874	1	1	690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASgRgMPxUiL38B4tMLXvFPbSftB6NKTP8oUwHcNrf3baB8YG9
27677	payment	2134	2134	1874	1	1	2361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYN2Nd1rqsEvxKjASGfyFS6tN6cvwDJo5wEwxREN9X5QD7K42
27678	payment	2134	2134	1874	1	1	2362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53dwGimvKXdoKApUYEnMtPcsiuHaCrDMLugHEohKzKedSfSF5
27679	payment	2133	2133	1874	1	1	1940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPdWuvYCf1y2j1ZdJFNmkqQwGc4WLx727z9XWDGNvfed7LCJM
27680	payment	2133	2133	1874	1	1	1941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDDcs6xXyzEqopo1a2afJgbN3RAiguEtnudb8s2GokzGKDXNf
27687	payment	1397	1397	1678	1	1	11513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsxxBipJaHTFmybhUMh3g6b3ayGzyePTmd7noYrubizmkuDsp
27688	payment	1397	1397	1678	1	1	11514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNjvYPjkbWUG7rPhsCJypcdGfqnxHe4iPJMJ4Y9opzNWEjcsX
27689	payment	2132	2132	1874	1	1	691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq7i2BRcRxT7iKG4tFXrB3Sw44ZcHC5vC5cxnbjuP1uXWbLHw
27690	payment	2134	2134	1874	1	1	2365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77zvYrbk895Z1Phj3kAdZT8BpLdhaFhznsR8ZWEPdYvBPQVCT
27691	payment	2133	2133	1874	1	1	1944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7T2kZvhU8MatW8FntdHSGAVDS5vCku5nBzDBWoMTAUtXYXByA
27692	payment	2133	2133	1874	1	1	1945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpVjwPzsMiZdCbGmzv4oPqniJXGKpevzdffDr2tiuKXq9HfrS
27693	payment	2134	2134	1874	1	1	2366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLS5Kjz1guUPn9CcPiVLDFQp3PBvfB9uMXrSSykZYuckVvsNY
27673	payment	2133	2133	1874	1	1	1939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8JKZB7b8uZLPBGKx2fLzJKWjeoXn5eQnebLYYHHVZULDpg36
27681	payment	1397	1397	1678	1	1	11511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShS4mogGtYvx4VCrLd2fBZ2uHKeQRa4mvAYRAVE1mYbwF2MeR
27682	payment	1397	1397	1678	1	1	11512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJwihcEKMpMBUo8buT6sM2PLkKFpUFGThVgVidCgqi9G4RjaL
27683	payment	2134	2134	1874	1	1	2363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbisPmKL8KEL5W6Nd5QQMHSUdzXy39yQjvqVBj9jzf3cNZef3
27684	payment	2134	2134	1874	1	1	2364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fok78progVrgDKfVLTBCaZSovZBrHgz7g826PmNy8cjKhjPV
27685	payment	2133	2133	1874	1	1	1942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZsXLYLPd8huWSaeqWeYMENnQ1eMiLvHhXMNaRxyA9uztFSYh5
27686	payment	2133	2133	1874	1	1	1943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhahqiUBLNak94kz2iMma6oygX2pX4J2tjNzMbmgp9zMsPFop
27697	payment	1397	1397	1678	1	1	11516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEkQttUtxfBdDcmZRRUQJUqJ6NPK3WymgwHMQBkewJPMgHmZ7
27698	payment	2133	2133	1874	1	1	1947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDVJM3vyM6oRmCxEfXsy4jsjfwowfojRwHSzZEisEJ9dJu43K
27699	payment	2134	2134	1874	1	1	2368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBq2Qhyptm4vQEUEuefKFtLZptgeScdoKnEYnMz9fjQMNtGCu6
27709	payment	1397	1397	1678	1	1	11520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFg6ab9m2dUKEL5GHVnJv5LobytzzBbJPcGjg21BbT76HGiEJt
27710	payment	2134	2134	1874	1	1	2372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwDDaFeAs8ePy9znNY696Hqtp7VxzvTuetEQmeDkGMPaUxiMX
27711	payment	2133	2133	1874	1	1	1951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxT6aqsVkkuDPp64KvUtJBBk8WMBpaPizLTmCt21Bh3bAAwLN
27719	payment	1397	1397	1678	1	1	11523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjU7dPLMDuQyMd1Q9UBDV4BDqVrZtDfPMSPR5RdrM4bAcRD6k
27720	payment	2134	2134	1874	1	1	2375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfidWES974ZLXTeZmgkjdrW9EH5MA3nn2bU1UwGqNDtwoyBJkL
27721	payment	2133	2133	1874	1	1	1954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD64Cjc5qmhDzgE9zLRJ4mWDPhggno338cSbUiEUWMRSmXNim
27722	payment	1397	1397	1678	1	1	11524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu641Nx6R9ELDvQJZiizUMXm5KVwBNiTg5XWXNDVEdwF7SjYSb
27723	payment	2134	2134	1874	1	1	2376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQWVkwndYGGUkacnEsib5RX8VQfUeL2edv6RF2uQ95G2dkNCX
27724	payment	2133	2133	1874	1	1	1955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rh6CTRqtaytwCWRT4q16qAvTvYy9XLFApAdWBkaUYTTyANby
27725	payment	1397	1397	1678	1	1	11525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29KMWzrT2VfWrtTssJHxntbDQQE6aCvGgevBneHybhiuiyGKR
27726	payment	2133	2133	1874	1	1	1956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBXS38x6fg6fBG9vYLyoezRqme2SDRepzoFQZ85ZKTsvjLouK
27727	payment	2134	2134	1874	1	1	2377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvMKopF9zWuQcUSmXyP5trvBoctoP789DAJebZCQXTv9SVDND
27728	payment	1693	1693	399	1	1	875	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZDsSdZgXsyvwwSS59KdZRy9hmv1ohvF18Ne3a9HtkEx1K6v7VK
27729	payment	1693	1693	499	1	1	876	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYVzYztiSwumzXXwFZkiPBS6bCcjudLdEy5dfS5yYkATCVh2YSm
27730	payment	1693	1693	1772	1	1	877	267054264228	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZF5AA9aWRiyzfu5RgZUPdVxH9xqRaLkAtakBzqwCahCjPwpA1x
27731	payment	1397	1397	1678	1	1	11526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pQa3hcFn26aFthqUSUbsAr9Huipu8Wx1MyCopCxyiZy2V6rt
27732	payment	2133	2133	1874	1	1	1957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRtbKpwaQXeLXfvSSgozaEdCqtjvtqV3CL5JdJjUcUkqm6aH6
27733	payment	1693	1693	54	1	1	878	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZFJCQaCsapdDwYqTnKa8Ltw34Uhu2yB7ExDBCKPgqqd6gZAJ41
27734	payment	1693	1693	710	1	1	879	2828327488	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa3uWWgdNpMQNUGqKwXi3NCAkw4kxC5XY6W5FUUk3jQWxqE3jFc
27735	payment	1693	1693	1811	1	1	880	102149572657	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaFPcvkQVz2b1tC2rVEJJHRK3LWhWHDjt1z1UULixL9JYzccukL
27736	payment	1693	1693	217	1	1	881	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZGWpkwCQBTEb1YWgt8eyCk4Tw7UtVbUn4HiGMoxcFKp5cngdpW
27737	payment	1693	1693	103	1	1	882	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZfpxT3mFmJw46RKf5EAdtYtGugxFpYy3saSqep71GwV7MC6Bjk
27738	payment	2133	2133	1874	1	1	1958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhS5KbCuT9ENugP7T5ARGZhCob1sgM2BXdx8oBPKnYeFjqEuA
27739	payment	2134	2134	1874	1	1	2378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hwvMhCt9Gq6oFhpAEwmK68xzBonpS8FZfdBVZEyDoAfbPSHX
27740	payment	1693	1693	35	1	1	883	10860777564	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZhnEAfEqQPyLf2kkhRgFg5AjJ9J39ecPs2GhnCMy1qfym5xvJR
27741	payment	1397	1397	1678	1	1	11527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnjgbTgWhHeVBiqhgCWnfu9a9Y2KWaiss3YW7NkuHuERpY9jB
27742	payment	1397	1397	1678	1	1	11528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15jrRP5U17HQUaXi9JEAWv5aiqWQenN9LfNYDWY4fKXjpdsCb
27743	payment	1693	1693	49	1	1	884	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaE5A1gKyPGQ6PUymLV3ZkpQtv4fSbFPB1FsYiaxsZ6MWQoXa4u
27744	payment	1693	1693	251	1	1	885	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa4L37rPtnmXRCm2QQaNKnc5Ack3i1KeUunc7a7ra61pNAbbDYt
27745	payment	1693	1693	893	1	1	886	173559138004	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZqSXBwZiCtu88n9UJp2phTLToCrsEpTRiUm299jCCS2UvAvh5u
27746	payment	1693	1693	320	1	1	887	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZL7SvmDTDcjGjDDVUNG9TrHSW97wfMoGzr4xmQMm2HpADEKnsZ
27747	payment	1693	1693	1030	1	1	888	509630166225	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZk9tdqoQJfNf5EkmJBnF5ZZ37bFiQeAHzyZ81bbLAwVg95egez
27748	payment	2134	2134	1874	1	1	2379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxaoMGcv7fCSxA5EFZQW64DQfG4HF5xy96w1Fvsf7x3TzKBD7
27749	payment	2133	2133	1874	1	1	1959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJfevXFBzp5xZdddV2RfAu2dGH4Yz438xfi3r11q6dJEJvR7g
27758	payment	1397	1397	1678	1	1	11529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkQCCvXoc2RPdgkS5486HGhoKu8YneD7xMjF2e9GWGtQpPQK6
27759	payment	1397	1397	1678	1	1	11530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx9Pf2WDAHn2kVrvAGN5MrF5LsSGcyVhYERQcLbE7Y42rLzik
27760	payment	1693	1693	570	1	1	895	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa5kHCVJVoedBhaoJmsZ16z5p374EXyVmoxAmsJi6DbjGpUkWfA
27761	payment	1693	1693	225	1	1	896	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZPfQHGCdRvvkVJaoSbijdiVUXYG9WmHWj8Q6mcGaqsrtt8bgc2
27762	payment	1693	1693	377	1	1	897	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZCeBpjT5AXNbvxJzuQTNdq2mYZHsbUmVNfBLUpWkfh3x8UhJsT
27763	payment	1693	1693	560	1	1	898	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa13taFqGJTohy5ZouDD7pUSramWG4nyebhncgnxzjn4NL3TDmr
27764	payment	1693	1693	252	1	1	899	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7wWACuT3rZsdyhysHzcCRKtEBGSPD4xBGBTKiEix1Ra6v4N9j
27765	payment	1693	1693	1962	1	1	900	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdPbnZR5rgbWVNDUPg1SersHHdL5DHmVxSoyHjBDbzqbJjpcwn
27766	payment	1693	1693	201	1	1	901	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa9Czegx5g8Xo6E8cNEdtMCUtq1KzxmH8GX3kJbMFq3HsKBqyjw
27767	payment	1693	1693	402	1	1	902	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7UghxsdswSfJ9FrC2Lv3LmzeLgZ8QcKw6ZMZb8SxWQ39r2hAP
27768	payment	1693	1693	163	1	1	903	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYWtrMRSXdYfMpuv3APxPoZVfzBoBqkeKnBpoEVypE4YJULE9WY
27769	payment	1693	1693	82	1	1	904	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa9A74GZKmQn7A9rFjyF7jPLE7fVCXqxBoFgs4ato8e3Q8LuWuB
27770	payment	1693	1693	275	1	1	905	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZqZdyzUzgf3hLuCExcR2BrxkqomDY8xPD2UGKumxzs6g2xVsyh
27771	payment	1693	1693	361	1	1	906	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaEYXhniJiDk8XEfieiPzeY9RJZpyy3HuKaE6vSqFTrdjkv5eDV
27772	payment	2134	2134	1874	1	1	2381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkx24DA3qz4aY3fjxvQYXH4PXJhms1xH3ujNWLjxA1nT4vzUvP
27773	payment	2134	2134	1874	1	1	2382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtKt7RvSqVb6aFzy6Rq6en27uicuS3VYMM77WH535bQm7jKL1
27774	payment	2133	2133	1874	1	1	1961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATJYkqcu2621vDPczm94YWGps7mNKYK9A1VsFMw1tKZ3LyTcE
27775	payment	2133	2133	1874	1	1	1962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygUJ1EaiziJ3Aop3AsqUw3PipUfqzS8KYxEFyyaYaVZAty62x
27828	payment	1693	1693	593	1	1	942	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ9ByUbMcC6j1nvsrE1HYKnTGPgUuyzuXXvoZPNoeUX6Bc5dfBJ
27829	payment	1693	1693	91	1	1	943	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYotncVSxPTfgWGauwZASPRqGkHKn9HDo5E2i9nLoKcAXGMxbDX
27830	payment	1397	1397	1678	1	1	11537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjq4H76jZofwJ6e5YFkCaXUw7GaTVcxD2tKSbCfApSQA1FXSd
27831	payment	1693	1693	438	1	1	944	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaCMP3bEXhj6wQ9HLeRupQ7PP9rfbz19zHM3hBuB4VEbbmPENMm
27832	payment	1693	1693	339	1	1	945	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZVToEvd9qyqTfPfJTLrv5m1F1wpHG5YhVuKGZ7yEMCsuKJqWEd
27833	payment	1693	1693	601	1	1	946	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa8WDG4MMdMmi5ULaqsWirkQPphFjTDYu9NUJVMSomeJaeR2FWh
27834	payment	2134	2134	1874	1	1	2389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEeMGrVxacMK48PRGVmzRif9fhkkKRbmEggQBajdWk1D51Gp3
27835	payment	2133	2133	1874	1	1	1968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEqgtDDT6KkAw14d6xYKHntEtrsuHy9zQogo2exrmyBfUQoLd
27900	payment	1397	1397	1678	1	1	11549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBabKii5saTz3TSDR9C5gu1F9ncJjnKyk3wCVq3hFPqySoNMB
27901	payment	1693	1693	304	1	1	976	37333922882	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnrSSUncJdNKFgbPMuBwfzu	CkpaKnP8becdqyjtjdke31haUTnbiMBEBVPwfGpYMmzqRTCpeLZ1V
27902	payment	1693	1693	206	1	1	977	37333922882	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnrSSUncJdNKFgbPMuBwfzu	CkpZMVtULgMeaTatcgGE7NcLs7zwcUdERm8FM44FqFtZaBN4dncYr
27903	payment	2133	2133	1874	1	1	1980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPqQCRUabhMbKW3MEhqvVxBENy4ZZxQA35CQgVGb9jXgsxpvm
27904	payment	2134	2134	1874	1	1	2401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwcBMiq6McksGmBRNcc2FiC1eExUuGkoKb5G2MtxcsEuqAcP6
27908	payment	1397	1397	1678	1	1	11551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGJCEzcF3G8Zed5VynUVv1iWo3r2ySqyt48wzxshmA2ouaxMA
27750	payment	1693	1693	663	1	1	889	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZkeMCHpkvQFAtR2AJirj9TExnrJDXoyh2tpoFXHeFQ9UiJovK8
27751	payment	1693	1693	390	1	1	890	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdBhWc2aU3AczZuTNs3QrAcwoywfnWv1MtAbt71ZttdWE9Uiwq
27752	payment	1693	1693	108	1	1	891	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmxtiZh847Vp3DNjS5zTfdwLz4iTuzQ7nYnzVLvxg1ip1Dx8b5
27753	payment	1693	1693	894	1	1	892	173559138004	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZvKEd5JB4RpQAEULK8BTLnEXEYHPNVXeiFauiFDN4YiJCqsptd
27754	payment	1693	1693	569	1	1	893	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaFSrkfMvr7zL3QbuYnhumvCZve6bFo8Jb8b7bE4F397Zk3wxyg
27755	payment	1693	1693	99	1	1	894	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZTJvX61EV539gKFQtxoKA5ExKGWBnnd8HL2nFTgJMW7HpcwdcX
27756	payment	2134	2134	1874	1	1	2380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xofKuYij3wY5f6J7pnamAxw1QTZpMsUnoQioNd9k8U67Vdvc
27757	payment	2133	2133	1874	1	1	1960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1GXNYo2UrQ3asFim3XomnEJQoU6EYRHt3JNq4cEd8vnDGZ9j
27794	payment	1397	1397	1678	1	1	11533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJKEYdJRMwAinS8SuChwzAbvbyZYP9oPr1DFATddk16z6eLVM
27795	payment	1693	1693	112	1	1	919	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZwDj1KaT6LFduPEvsep8PeUQezB7cXDXaDXg8wraK2BRCQvxjy
27796	payment	1693	1693	534	1	1	920	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZiTkAz8warM5JcjzZxH3s9P2EkJQx8kpGcuMdJommZA2Nt1K6x
27797	payment	1693	1693	245	1	1	921	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZoV3gQLNdrWH4ua2DAvYMDsHVTWpUtAhvXapBr59KtNV4TBvEA
27798	payment	1693	1693	421	1	1	922	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYQLyPjiDDaxZd9Qi72PGV9m3nYiSo14ggpv6jgvsfviauvcatW
27799	payment	1693	1693	620	1	1	923	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYdbNMJnxvk4EPKmuJiMgj2Gx5ujRFpdu4WErU2u5s32VtokQ5x
27800	payment	2133	2133	1874	1	1	1965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpYq85eCTSLpXaG9i8GdHybN8cfHPXkK8ziCgjx1uQQDeBwf
27801	payment	2134	2134	1874	1	1	2385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNMacc62NQFSHCMjtHSSzEbgrTH9yScN2zHw6GBJKuNSYv8SZ
27820	payment	1397	1397	1678	1	1	11536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpAbsYTaPET7PbLYbG1x1TeP2PZKFEhTYwCRyhpYXGUZad9iq
27821	payment	1693	1693	89	1	1	936	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZp24GQC7DE9pAVEophEpC7MVt1V7827oachfjMrBpKgQ3Tbogj
27822	payment	1693	1693	186	1	1	937	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYg2VQofsd5rus7azisdXPFgUVYPp9jCnHcbhRKyXtTHqSwjp3z
27823	payment	1693	1693	383	1	1	938	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYS9c8gTihyvQKc8ka8JaZAxGzLnakSdVWve4TWmVQMhfBy9B2L
27824	payment	1693	1693	308	1	1	939	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmJZXZirBNtxy21PGeb5QNshmAaj8VsuvByaSSN6QYGUaPSGZe
27825	payment	1693	1693	408	1	1	940	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZW6NhzovPRJNg7M1Zv5RBbrpFAYTitYoseZGPpxP4Vk4Qv9dUE
27826	payment	1693	1693	678	1	1	941	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYhz4qhqPxC7AfDysLMmrbYvUkxqddnfS3iSkVmDDWC5bEvCFSo
27827	payment	2134	2134	1874	1	1	2388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQdnqQc1xsakiJo3V3iY8uXCZE2ievGXn9ExACnkXDkBgTcZGt
27880	payment	1397	1397	1678	1	1	11543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUz5paxd45jMLTNQrmqGwH8zMqbj6YXhbrbzxe1DYTaWLwY9wB
27881	payment	2133	2133	1874	1	1	1974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqLHJnCg4EG4dvTigA52b9LyrdigxvDUQiB893BTd8VqL5ACW
27882	payment	2134	2134	1874	1	1	2395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfj6jxvVrCdpnewYq1L2PZDj55S5SrRsjDQC2544GtFoEAdmZ2
27886	payment	1693	1693	206	1	1	976	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYotg9kCMqA4ojFBA6HzdYR9CFLZqq4mmfLgiG9DXAzbB6GS7zT
27887	payment	1693	1693	304	1	1	977	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZPWcJSvkSxCDwZxMuAUYkrG3LaMgSNRMVmUT8youDGYgnX7D7n
27888	payment	1397	1397	1678	1	1	11545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkr5vsvHS8aD5V3iyNVwPR3zfTmSEd66fhTwXzVteVt19umra
27889	payment	1397	1397	1678	1	1	11546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAKG2m2vKkp9J9tT2DzGFZo2Dgv1Wih6TLpENcu78BYaEibxs
27890	payment	2133	2133	1874	1	1	1976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjVTdazMaMt9sjS2wc7b9adtfDU4kcnnoWN5ao2pHUdgHKujZ
27891	payment	2134	2134	1874	1	1	2397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYSLsghDxZxGjax6bP39ozScaCp68R12LrmUvu37HDmkdJZke
27892	payment	2134	2134	1874	1	1	2398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc5eRyQthfQVkmfgrBa7toSdJhYtybbasfumrB9bB8xhKtdHD
27893	payment	2133	2133	1874	1	1	1977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffDW2Nrc5e3aESwmjztsPDEWZ1sxSKwHAGyCa3uqc6oD1eQmE
27910	payment	2134	2134	1874	1	1	2403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUYbMxpG1gXAxJmRhAjGy6XdatzZZJtugUjQXJXmvsF2afdRx
27911	payment	1397	1397	1678	1	1	11552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarSMMaWwk4XTeEqeG8p2VN2n4RD5RqBy6s2rKRYvz7dEuKr3k
27912	payment	1397	1397	1678	1	1	11553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKWC45DxQTkEyq1AxGPw7rBhT35gtc11ti8cBKXxDH819EPf3
27776	payment	1693	1693	309	1	1	907	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZAiidmtodi56eKYqjBjhTA2PhptNfhT9UGfg8hesQ5PuZHt3xh
27777	payment	1693	1693	2073	1	1	908	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZrpLDJvYrbPgqYFW5vBnebwbVGjH3sMVay5avhQKtw4XEpzqQS
27778	payment	1693	1693	452	1	1	909	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZatx43XqYDciz6vF8WMxchqNVLf2V1JotuCNc7GiDaHvQ4JU2j
27779	payment	1693	1693	594	1	1	910	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYV19oq7exGEuRuzuyjkQ5pq7j81Gt9Fk7gDvDWfAa6dyVuoukz
27780	payment	1693	1693	2181	1	1	911	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYbMb7RqZuFp9mEhUXfLuoUAPpdWBAMoMz4wmL3Vsc5tAUpD1Y4
27781	payment	1693	1693	680	1	1	912	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYtTVSkutfVu8fhamKEod6qaDLxrbPa3Bw271qmczdTFZPowUbK
27782	payment	1397	1397	1678	1	1	11531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wgTX9NjbyUBjQNkQ15eLEbaGGM7A74awuAJvbwyc8m5zi2cw
27783	payment	1397	1397	1678	1	1	11532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBU8ySMAb9HiacPK5iiGqwnbQRVYwvKBc28mporTqrzsCBMxpn
27784	payment	1693	1693	391	1	1	913	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaLBftYs9yJ64e2LZ19Z9BqPZ6sQxF6TaTX4dYZDJgz7WTY4TQw
27785	payment	1693	1693	690	1	1	914	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYnnfFYUG5RQLd3U9KtQPMo2DZqNyxLcpcsKKkyLgA32y6XKTe1
27786	payment	1693	1693	353	1	1	915	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ8nuzf2T91QJZgbG1Y8sSH6Js59k2r9ePpqExd9ALDngbgC8Ve
27787	payment	1693	1693	731	1	1	916	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZLVaV2U96DfqCCTHqAkHnyHA94f8CyA4mfYzrwsAVriz8Gxnbs
27788	payment	1693	1693	2164	1	1	917	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZn1Q7ZZd4XmmPY6gLTw5V6WuHncwL3icJXoBM7U3KZNkaxCg3R
27789	payment	1693	1693	180	1	1	918	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ1ydaKXhFZbfxWVZnjxxvubbL84pkmLmFtAWfSNakrJ8uS7mQm
27790	payment	2134	2134	1874	1	1	2383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDfox3hWCKFsVPPcCuoptaZZf9J7fTtshS9vZZu2ipqUphCQK
27791	payment	2134	2134	1874	1	1	2384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkTmqw7FC9THFmLfwyG18nz3b8p7dmVwCahdazkXweLDth2F9e
27792	payment	2133	2133	1874	1	1	1963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNFn8wPJHmnXLi9C66WZJPxfsvpYfsLPWWGcoMEd4TyG8JUsZ
27793	payment	2133	2133	1874	1	1	1964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86KX2jCBowP8fjwcnaWnWQHcaZb2CvBaza9oo2nDqTTPCUt7Q
27836	payment	1693	1693	745	1	1	947	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYsGBoYjeRBDeepwFgmxvYd4FEKfQzexH9XToM9kc9JHE1nxhrh
27837	payment	1397	1397	1678	1	1	11538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeYxFoRWzYEgmiZ4zGrjRrMCnTgqiudSgZqnrtjXUM7k3RwKC
27838	payment	1693	1693	150	1	1	948	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZy6vb6mkw341WUDzN15CzE5dWAAVgoqCVCX3yrZBw3wCNAgrny
27839	payment	1693	1693	92	1	1	949	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYsyMDonP2ZFtxWDJGCb6f8iHZug3vbdx1fgNRXBF38sxG2BN25
27840	payment	1693	1693	63	1	1	950	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ3JZYo82YTZHH3F2Q5G4EErheXJshpiZSsYnkp2TWerjcFmSXy
27841	payment	1693	1693	450	1	1	951	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZbw4ntertjJZMD9P8rkMFQRapqjdztKdCVa4gkwcEcCPFirSnT
27842	payment	1693	1693	322	1	1	952	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaDrafa9Y1fTF1pFowiijLrG4fawSqSAYBg6ueduaubMhGGmR6r
27843	payment	2134	2134	1874	1	1	2390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde4hnkuW8ssVepHZsHDptcsvZ14Tr1BwHbHWGKQhk7WkFkvs5
27844	payment	2133	2133	1874	1	1	1969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxSpiazCXYDKYJZYqyQ3wgBd9j68vjq6WNTPcFHzybefr3g2q
27862	payment	1693	1693	78	1	1	964	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZjniyMA7Nz6bpt6j9hkcM3x52fK9XCPPLDYjGAsKd5NU3xD9mQ
27863	payment	1693	1693	611	1	1	965	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZDb2UJiDRzHzPwXa2KNp2BnH2qRDYzRpaRV3fv6jpynUkhgwwe
27864	payment	1693	1693	205	1	1	966	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ33ARVai65DgEv82qtaNv6Lseq7v7PHzHtkpGdWGWNyK16LzxN
27865	payment	1693	1693	658	1	1	967	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYs9vXLjSRuHshVNFtkcfgZ8TE82yMQTH9Paz2Q5TskENPcGhvS
27866	payment	1693	1693	194	1	1	968	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZh4Pvm6AGUYPmareBPmZDwzZnM1y13KK1h5TUuhAf3AWD2UkJq
27867	payment	1397	1397	1678	1	1	11541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9rjWw7fGW2ty4Buz3nW922PBhAZVa52AfeHrY2FAfFyQeako
27868	payment	1397	1397	1678	1	1	11542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUWaSyZBWTe3mqUAPDooMVtB7LuMLWGfc8JJtFj1VY8yxVKug
27869	payment	1693	1693	1276	1	1	969	958189855230	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa2EgXFc8qABXwWH4bqXyrmdbrmrq3ePCBV2dr5tGyCt48GVWpX
27870	payment	1693	1693	660	1	1	970	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZXYGBKVF6r2wpE94hv3rE4r1yejFNJiQWeF62TVkb6DQFCehVA
27871	payment	1693	1693	653	1	1	971	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZTgwucyQ2cf75eYcqawGjrEYViwzpTNy6vTqHh4VXFq4Y5Jv4e
27872	payment	1693	1693	622	1	1	972	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa4UF8isErv8jd6pv4Je5T1C7b6V12nHrUEcjtg1Kp7NqZEyTNA
27802	payment	1693	1693	352	1	1	924	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa44kei1ozL7CMCEPMQXTxnLdSgUvTHziV6PUSR7zbXBT7GT6d4
27803	payment	1693	1693	652	1	1	925	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7PnUeQgBictazavFsrNs4QtyXFzzbCeqv7DTTnrS9pgE1Jjof
27804	payment	1693	1693	191	1	1	926	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZkhfRfNWZvR6XuEZTRT2EegfpnpkFh1L4TJr4CU8rVrMCJBurU
27805	payment	1693	1693	266	1	1	927	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZu7cVQL4CFnbYTFJB6M4r9PBNq3K9csWN9oX4aiZY8Bm5yDt4u
27806	payment	1693	1693	1150	1	1	928	343857628251	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZRobk8TGkpoxoemTfBUjmwnVYHKHCvoapHQQvFZ5CywuWTkHH5
27807	payment	1693	1693	84	1	1	929	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYRoWCxU6uzFN4c4hEchb99DLdjvemniCfMfYt4aTzjDh2nusx8
27808	payment	1397	1397	1678	1	1	11534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHU83yGFs1gj5RrXxFaGcGcLUtrkfo9Uekr1H2H2rytDr3x9q
27809	payment	2133	2133	1874	1	1	1966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcauRweBTHdP8qRbgD62hX2hZzFa1cLjfq7jFDcDE6mqXm2Q6J
27810	payment	2134	2134	1874	1	1	2386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzywm9WNy1EwBpJ61ASMH9iA6c5g8URbebmtu3UVk2ZdHH3ujs
27811	payment	1693	1693	600	1	1	930	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZMWEmqST8BAvrkPy7gdp9bNHqkXT2Y6JoFd41oB6NChbJdp7JQ
27812	payment	1397	1397	1678	1	1	11535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEbJkjwpVQEAPzP16CM7RXhktiKDGVHf3Qn35uEJVYCXqWYmz
27813	payment	1693	1693	691	1	1	931	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZrQum93aAvCQtQf43Dsoa6etASonjQLbSyheend23CAj8K1B4U
27814	payment	1693	1693	2017	1	1	932	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmW8UJWWFwrRLUqKAXth6bdASNjRTn5CVn39SEh5EXmZQQsQqH
27815	payment	1693	1693	551	1	1	933	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYSSGosr8AXPfgaQnVe31hAbA4odtGUBhavegUEkwxv14hbJ6tk
27816	payment	1693	1693	520	1	1	934	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZnK3tacoTRB16wHSUWvPtwAAgjz1e63fUw768fsreurtfVYgSN
27817	payment	1693	1693	392	1	1	935	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ6DfPqj9pue5wV686ZMM2UosiKyiT8jWSLqTaKiA4TiZD7C886
27818	payment	2133	2133	1874	1	1	1967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzT6r74ApsLhuqFao75tq4zMfVX2H4z8HgUzsGeDMxL5UYjUw
27819	payment	2134	2134	1874	1	1	2387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7mGmNYx71c28vLeC6GL5cDPcjvEyipnDCNWDQ5j5o3rHYLV5
27845	payment	1693	1693	373	1	1	953	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZMoSMYR7f1yHcTHfZZB2CC1pwcadekzcXiSHPhK8RjeonC3UAw
27846	payment	1397	1397	1678	1	1	11539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KLsVMUXNqnb57hN8vPniqNbK4wiLnxHz4nxuEv7eLsfJNRbn
27847	payment	1397	1397	1678	1	1	11540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLyF6LDGaTuyJaKXVQUqaFEfWsQnFpwR8umBy1KRCk1ghi39D
27848	payment	1693	1693	453	1	1	954	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaCdBJjm7c2xG9Gg3d2nskwcBa2ScDaq2Mrce3vc3SCE2oZrHtY
27849	payment	1693	1693	29	1	1	955	3959658482	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYnbu5cEB8vwzC5BsfVFTvrZaXCuYrLZy69ViNhtyouM3KWdGLu
27850	payment	1693	1693	138	1	1	956	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYrVDXVHwNwmZFveyU9sraHhiaGch5VSucxVoAZsFWEbw53wv5W
27851	payment	1693	1693	146	1	1	957	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdP5dhsVzmSBJ45TLjUvYtCy7Sd4Evkb955dzBi6THdpfXjkam
27852	payment	1693	1693	395	1	1	958	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaH7Rs8CP8xjoeY5L3KWtgcCx7GEWuvqrREfCWpS1MkUAHRRaqA
27853	payment	1693	1693	587	1	1	959	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaECwSRPvvEhFbjHS9w5MWjrVjLHmVrYVzcFpaeG4SqSxo1EV26
27854	payment	1693	1693	910	1	1	960	284393193579	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYR5ngUJ4wN3TLkSiWShFet1PHcvioc87nuE5QuBGoL1JT3vrXu
27855	payment	1693	1693	1961	1	1	961	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZFrrg6QB5RAuE3YftkQULsxgfUuNAXThXSHF3EQvQDX8AoC9Ut
27856	payment	1693	1693	500	1	1	962	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZa3Bcdjxd45qpkXPKzEiTZhkkvc9rt1FsfWEV4zNGQPf75C9gu
27857	payment	1693	1693	504	1	1	963	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYgwJGDrW4d23nM7eWN5M1XhbMzrCyjkuTyLujh6ZpGskFMDGFd
27858	payment	2133	2133	1874	1	1	1970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5UTrmtRrV3pqJnrP1iFZhi9v9rwDAkRjYL1NgPRaA11MgdXh
27859	payment	2133	2133	1874	1	1	1971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD9FrTHWKfJVGWigz91wWJ8SuF1Ngsgg4kLbXGEv3HxYZ37aY
27860	payment	2134	2134	1874	1	1	2391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJsFuQHndtgVQqS6d1hmvRMnHE4RXgx84VTqFuP9yVRgb23Jq
27861	payment	2134	2134	1874	1	1	2392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtG9FUh5tWSb5CXZ5rgbzLMkXbezCnj87P6cHTMU6AB9tALmU6
27883	payment	1397	1397	1678	1	1	11544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxRsLnHsZ62HZZZ5uhUU19ueaLMWEvsLnHWS4UsAcRjmvNNMK
27884	payment	2134	2134	1874	1	1	2396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUaXDEogxwQ6xCzn7mKeKmSZUJ4FWcFxstSmBjTAH6wi97sR4
27885	payment	2133	2133	1874	1	1	1975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXfAC6fwQc4dz5qDfVqGZkgx38E9SkJAnnDXexqgETVhpaT1N
27873	payment	1693	1693	105	1	1	973	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZn2FWcReprQR7E6Pi9dGLDMfTdCTZSG7hLANh3JPC8xqkru4uz
27874	payment	1693	1693	122	1	1	974	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYWiVUy4NZAFZZGAPhQPxLHovbJD3TkN578YWLJmu5C8PXavL7m
27875	payment	1693	1693	721	1	1	975	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYqQwKZkf9wrzDBkoZ5JhmRdqdL5oPMDAay4RP6DNRWedTbLtrB
27876	payment	2134	2134	1874	1	1	2393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykXFdkmdqXRPjYHQk4EhEZCx1KRWpBHCBx88zH7ickvAWHfqe
27877	payment	2133	2133	1874	1	1	1972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4A2a4SXBRKuq5o1DtwR1tMm5LHdFf1MfKXAs6s8bBJWyhQLGm
27878	payment	2134	2134	1874	1	1	2394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGt7H4eiWP5Tm16Q7jVWgha8GUNW1n1mxBcphJ9x6RJnS4JiTp
27879	payment	2133	2133	1874	1	1	1973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZPM3qGH4nv5ekkSnQsBW3eU7Nw9rG77PKrwvvHshdvvf7SYS
27905	payment	1397	1397	1678	1	1	11550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GjH2pnVy3wYEn54WWEDPj7AaU4XcFyFAFaLvVoARLfdGJjpX
27906	payment	2133	2133	1874	1	1	1981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dxkuvXUGDhxKX12y5nxgJ7L1vxhPyZESnM7YxKhGkzTZKczh
27907	payment	2134	2134	1874	1	1	2402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7B1NDNNpnfXHhoVaeJPE54Q4CzDfCYjaYz4dRTKzE62N6B1Ft
27920	payment	1397	1397	1678	1	1	11555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQNfypyzC3RZCv7k12uWxrXTNCm5eqSjxzySuYhiZzNvAAjfu
27921	payment	2134	2134	1874	1	1	2406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWm3Dn9RXPpdCa5VgNRKdSrJnjoSSZ1qh4RRQiKoBP1H2mN1F
27922	payment	2133	2133	1874	1	1	1986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvvaWVZA1FTNXtj7i1SAbnfUie9XmsqFhRDwCDshkziEHAFew
27941	payment	1397	1397	1678	1	1	11562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WGYXD4KQvaxxUDLDnmkRJr5vZqVpvqpdxPrc8JNajcQSZ96f
27942	payment	2134	2134	1874	1	1	2413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqaRhYMfbTGx1H4pHoExGitKCz71nMrkh2DtSipJaNsBZUG7M
27944	payment	1397	1397	1678	1	1	11563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXf9VZE7q8aha6EfQM8TWs2pC6Ni7LRYfSb5BDPEJUVQqwvJH
27945	payment	2134	2134	1874	1	1	2414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjJpL3YmbbkbnbeGfhZQou4FeZKpiHrssfEfMiC6V9eEVkZvX
27946	payment	2133	2133	1874	1	1	1994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qWkf8ybQwpuJwYYuCV6LgDA9bLN5ZwvysS4Q87tXP9pWrSQx
27953	payment	1397	1397	1678	1	1	11566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDd6EKjeiSWgG6ZGpiJvHzqCPf5LnWowLY2FPs2qUyhuFVNdHo
27954	payment	2133	2133	1874	1	1	1997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyXmjkFPTEGTiWmrmo5cJZLSiEjrj6RooMB27cmENsUJ7FmJU
27955	payment	2134	2134	1874	1	1	2417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDs5p1UR4uPVLKZToB57oWej4LEw8WMiHqACCbEPZqrmtfUpeF
27989	payment	1397	1397	1678	1	1	11578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDeS4sqdemW4E3gHQKS4Hkrymcfrxmwruu2imJ383XyFKB5ZW
27990	payment	2133	2133	1874	1	1	2009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwwEixsPMFvnSQ8EZU1nYDWTMwqRefuj8RKFkhMyMYo9wp1b2
27991	payment	2134	2134	1874	1	1	2429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuTBqbCVZy47whbfVkcJPSuiLYWTNU8DxjPoKiasfsbHVJSjV
27992	payment	1397	1397	1678	1	1	11579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRE3gWF8qDDqGiMY1tP98hSx44feMcaTxigT1PCqMoqUkNoJjc
27993	payment	2134	2134	1874	1	1	2430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRt7326PaKn6tjhZpuCQSrhBHWFmNh1rTQAD2Bj4ktjSk6vCF
27994	payment	2133	2133	1874	1	1	2010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzbtNCX8XTNy5kMYkZAGBW5Z4X2eAbbm4AcfXXpNHzK9Eoh73
28001	payment	1397	1397	1678	1	1	11582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJGAxVZZvYdWkmZXzeL3m39JW9ntrFyfNn9kXFogZG566WRfw
28002	payment	2133	2133	1874	1	1	2013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18EYedvMxYDEfNrcnLTKfToRNMR7wqcSRoKd5NvZubHdfRFiw
28003	payment	2134	2134	1874	1	1	2433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8qyqZ8UGQ99evSsAXTMHcM3XX4eLRE8fCGtbYELj2FBrEi1v
28004	payment	1397	1397	1678	1	1	11583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZch47Go1qWHJtRvpfwsDV9tUZ9WTLHog4szpUMGnERVej5rK3N
28005	payment	2133	2133	1874	1	1	2014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HvN5NekXy5x9uPJQ1DvyYfHYhY1cRSP6PhF77GeRska7PPeR
28040	payment	1397	1397	1678	1	1	11592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j1Je1acm3Jf799rjrTahtW3JoFNYhscdcmb2ZTKoJkSr6FCQ
28041	payment	1397	1397	1678	1	1	11593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNMwsgRgMKKrcVSyo3qoLfzq1CXMiqdEvGqSZN6eLAGz8PBxP
28042	payment	2132	2132	1874	1	1	694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1ZfMsC5SSLkLc7XCV9g23CNMjSKjbT8A2L6S86LYsWZYZAMT
28043	payment	2134	2134	1874	1	1	2443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzULZyELbTPjPnNxSbu6Ex4JqafPGkzE5ixYdoakpAAJWBruTC
28044	payment	2134	2134	1874	1	1	2444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KnhpXCMfeDA3uuVmgnF6r5tiJNLgDuaTt1vqKkMM35xxdAdH
28045	payment	2133	2133	1874	1	1	2024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHZ3yfrgsgCL6bUayom9GtkA51KeMaRUdFAjB52YYNpvgPyLF
27894	payment	1397	1397	1678	1	1	11547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghWrQVDUo6TfNXo9UfuDwLoiEzogKokYJWM6cjRfMeCvGZp2n
27895	payment	1397	1397	1678	1	1	11548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4PLD6FHX2sAfvsN1MpjzS1sGU3atS7LRvmezonLHGgCPLRhW
27896	payment	2133	2133	1874	1	1	1978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YwSiE8VAxetQ9jNgB2qTXVaTiDQ5PcNYU3s1PrntEvQWhTM7
27897	payment	2134	2134	1874	1	1	2399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8qRJmtGmV4A9mH7pFZMvsxkDbUw3T677cph5o8pZXvpcWSV8
27898	payment	2134	2134	1874	1	1	2400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9aAiPeKtowLRJpoXdiUZ9sJ4Qq5brqbse9g35vekd5kx3Dkk
27899	payment	2133	2133	1874	1	1	1979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAXHF7SiQb7kZx7HxuF6B5cgXT4iZsVqWNJTZr49BMZm6ECcf
27930	payment	2133	2133	1874	1	1	1988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJz8BCg1W3ePyEdyUkbfSFbeX21KxgMddYQhqaMGH93mwFCdbq
27931	payment	2133	2133	1874	1	1	1989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLe5tidqwpznytkoNN1GbvTFeuMnMkmUSepXYvFF3vFUzB7tVg
27935	payment	1397	1397	1678	1	1	11560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiLffeV2qAmFTjvtNNgcVKaqcQWi4VQvPvCKbfujn9AyCmcmG
27936	payment	1397	1397	1678	1	1	11561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMnQ4svGxHDgc85GhGfCTU1Mda7j4qiDFLWswm9TFtteCJdRi
27937	payment	2134	2134	1874	1	1	2411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4ESCooXdmRiFH86VgqaKZWdkqwxgRX7Z9aJU8s9NnsuCGs2b
27938	payment	2134	2134	1874	1	1	2412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZK6ChWSB2uitPWRqmzNHhpRCpmvuhhVdh78wPrxFtp5UT1apx
27939	payment	2133	2133	1874	1	1	1991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUt8WX1Do2feFet3WUGQVhdS5rf5EL3H3v3uAta5YjF1sCMSp
27940	payment	2133	2133	1874	1	1	1992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7XkAq2o1FWHDxEq11sucAryrEFqitsZMUFUUEG2Vc86221HS
27947	payment	1397	1397	1678	1	1	11564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgxN6TfP2accYmytjB3QYh1QJbedcKiiFfaUJV7VNdB6KFchr
27948	payment	1397	1397	1678	1	1	11565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfM6r2dzQy9hS1QYmXLbCspTBkoWwpJinVTqdDWQVWfL5AX8g
27949	payment	2133	2133	1874	1	1	1995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAS84b2hSPFqxFSTEhFDScwGPZ2qPsu5vn57kxfGjBwKVRWdn
27950	payment	2133	2133	1874	1	1	1996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqz5VjrGSWD2U4stvg5pYmnRGTKNYHjrdPhom7TEhdvxSEUetf
27951	payment	2134	2134	1874	1	1	2415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WHFTNCJyTbNWjkhBYPrYF6hVyez34D3B9Men8KaYvCF3pJab
27952	payment	2134	2134	1874	1	1	2416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEMHUPivey2uq7gYgMRv8qvrAgBmNWqVfYD8YDnHR5LMHEKHD
27983	payment	1397	1397	1678	1	1	11576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfk789Di4jSUt41nBHAbCpwanwU6rdbz9xNLBGBFYpVScePm2
27984	payment	2133	2133	1874	1	1	2007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasjPB3g8NzbcoL5d2jUbsM5H9BmHyp2m2YYhwTUggEfo21Hdj
27985	payment	2134	2134	1874	1	1	2427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupUhKa81kdRUcE8Q6CT5Fq1Wsh2XSyVJhqzWEGvJHTUt7pjLy
28018	payment	1397	1397	1678	1	1	11588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTPwsLXHSe94nVbKNknnTRx3z72vrFCUrUaPffLf3XaUrWtTC
28019	payment	2133	2133	1874	1	1	2019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw7cuGwp1Agtgp2Hhsu8La9HGzMnhDDd3sjaadTYuALnhybsV
28020	payment	1726	1726	2231	1	1	8237	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJ2K8H2ihhU5u8B499drJ3Zd15YiUvs71AmYRgp9AHKVcPs8JS
28021	payment	2134	2134	1874	1	1	2438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScQizqcWpMBChqn1dA3QXAQ1ZotLcqi7y1WrJZbeZjg7ScbcB
28022	payment	2132	2132	1874	1	1	692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYe5okZefyj15rXdDnBDPzpDCohC41SvqBuG6G3cfWYP4xZGQ
28023	payment	1726	1726	2232	1	1	8238	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkpk9f5NPewPUxNJFgL39hXE75r7SsVYLTzEq16FauF29eEZaB
28024	payment	1726	1726	2184	1	1	8239	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiMRSdxeAuJG23m6B2ZcF3MAt97NbBsCZ9WqRqCzBF6ptu93z5
28025	payment	1726	1726	2206	1	1	8240	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxBtxJQYgctkiP4GdZuB2r1DHi36zP3bcBdcFFAW73TAPsjK6R
28026	payment	1726	1726	2205	1	1	8241	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmnSw59z4BrgGXJshWcJEQ2jS2MJFbEHvqoAubnkjm5TSWi8J6
28027	payment	1726	1726	2185	1	1	8242	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4RkUbmia8bPKcNzyHVrHhfuiWb28BBsyAyFu9Gor1v9hw1wKv
28028	payment	1397	1397	1678	1	1	11589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW23s5bMvVRP8CwkwxzSN4qdFb3GmmbnZoYgwW5ingEL8T5Ek5
28029	payment	2134	2134	1874	1	1	2439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmpTiX1P1ovrFuBXgcD6qSq1bEY59b349T9XhvqBFwpVCcZC7
28030	payment	2133	2133	1874	1	1	2020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbtn4ApYiCn844SandooRs1BC6cyNzjoyJWhKao63KyQW8X5X
28034	payment	1397	1397	1678	1	1	11591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNp6m51CpFgphGFJjGSxMm9oVPGU1RP7Sb7JnE9xFDusvX7JX
28035	payment	2133	2133	1874	1	1	2022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8tSLMcsdxvvQpyBF88aJyqowjd7mszWWoguSBd9f7vCaPxFx
27909	payment	2133	2133	1874	1	1	1982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERAT8v45VRfYw45aDyt79uHwkdvmohqRfgmVLABjcrE2R5g4z
27923	payment	1397	1397	1678	1	1	11556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy749wCVGgMGknc41xpkUXp4ygu7dr3i22iUvg5F3Bb8xwhfKs
27924	payment	2133	2133	1874	1	1	1987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cnZsEttD1RUeMCrgcrD4bKobbpeBUdATk4rSefQtRx8QK6ZJ
27925	payment	2134	2134	1874	1	1	2407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5jmg9vAuXsbkLG5oNMfcaypnLjAoTwbXoWsmJERDwTmn4QUVZ
27943	payment	2133	2133	1874	1	1	1993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpq9nxkYAKyGCF9YaQURit8B8E9TgkvzLM9MmFzA6Ww1NyzrQ
27959	payment	1397	1397	1678	1	1	11568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk57ZLPkHxFrr1Xz5HKSPMQ3SSeNutTvBG7abjExVrAmMUQFCr
27960	payment	2133	2133	1874	1	1	1999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbX4WkkrNTjfwxFK7JBjtNoRvxvjQGWJi9XagZBUvkgE4arfNS
27961	payment	2134	2134	1874	1	1	2419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGc5HQViVRX8jFZX32gNu1oe5sb6RJi92TcTGUeCvBQgFtC65
27962	payment	1397	1397	1678	1	1	11569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQLnkpRPviGGtQWCeuAjVmyNs6riusqVCk7s9omDNmmZ2JwPu
27963	payment	2134	2134	1874	1	1	2420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWV4h2xobviFfXG55xNd58B5Drm2i1WTHkMPDtUH1XyXJCbU7
27986	payment	1397	1397	1678	1	1	11577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhgPmoQ9EQ5HxZsbC5C7wkz5Crqz31EmGPyF82xKxDvnhNDPJ
27987	payment	2133	2133	1874	1	1	2008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKS67XyVoGFVs2aKTpj2x6M27Y9kxYPpRsisoBy2jtDrzPD9n
27988	payment	2134	2134	1874	1	1	2428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cGTLxMmTu6H5N1WfUHPGpquui5CNymuLbQgr9KnmD7aLd6SG
27995	payment	1397	1397	1678	1	1	11580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK9JEN33s4TP64FNvQpw73W4QwjFWUYZpxxM4Qoqq3u2peMfz
27996	payment	2134	2134	1874	1	1	2431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCWY3bvCorqJ3TsBWwr4dccvrJuSW2kZNzuCXdzCMNfW1vtwq
27997	payment	2133	2133	1874	1	1	2011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfaZNWX8xpCxkn9HAN9nMrFHAnDJpqYUTnhynRQvuQyCVQv54
27998	payment	1397	1397	1678	1	1	11581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGSc6bnDHd93ycDtmH2fsQ4J1jvL9ohP9t7dttCR9hHMYvVXt
27999	payment	2133	2133	1874	1	1	2012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwApyESz8rcTWkQLWTb7empDM2LbdoWjcnGAbrC4JScXEkjoeS
28000	payment	2134	2134	1874	1	1	2432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojkZSCgvHhP9eLcYBWKCoS91Kw6uJwtnWQb9UG1WFUzCM6wNP
28006	payment	1397	1397	1678	1	1	11584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4qtsURMGGNzS1AAVsQxdSW9Gc82PQbJfHikbXaENvpY8oibZ
28007	payment	1397	1397	1678	1	1	11585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUN4o3XZs8E9h5DvoWDVsuBu3JbRgf3TQ2ZY8rA7g62baV4qB
28008	payment	2133	2133	1874	1	1	2015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaJfYC5pgFtJjnZEKaw5N9wYFxEDuxtQar78Mmv8ixAH1oHrU
28009	payment	2133	2133	1874	1	1	2016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAEwxsmLGNyVkDG2Tsq41SmzRpxJsHgQdBbj8h5g3Ztu8Ck9d
28010	payment	2134	2134	1874	1	1	2434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc7ZkVL7NajtbdW5Zqkrb5wYsuQXAQd3EhFSNbVNTRwVr5Sb1
28011	payment	2134	2134	1874	1	1	2435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JQPryF6uoaMrtCst42yQKhQw3S1oGEaiL8kDYERJtnN8R5rd
28093	payment	1397	1397	1678	1	1	11608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMewAf1bvpWw5S1ed6zquSm3gzEQnME8HTRAusXefRMm4hpZt
28094	payment	2133	2133	1874	1	1	2040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjjiVHgn325cxoRqjCqud8xJnUJ89tgpP7Sx4epbZtDMQuE5X
28095	payment	2134	2134	1874	1	1	2458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrDtzwVNSEEYSG3Ks4ALYebKzEhqyy3BV8SPMNHgsddBP5zbg
28146	payment	1397	1397	1678	1	1	11627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFcpVw8orFLtKGsT5GMaFjNWxyEcDAoUoQrJo1hzYLBHHJNCD
28147	payment	1397	1397	1678	1	1	11628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35sxD667NyEjYNcM8maGsnZsAmJ4YDauwYHQN5d6CeEwTFeTW
28148	payment	1397	1397	1678	1	1	11629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3aPgNxA1zGCccpPVFWkWD5AxS3ikcnPfkghBAzEhU5pZeSAq
28149	payment	2134	2134	1874	1	1	2476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7U1XYAyFgUrRJLcgMMJMD7nf1c3La2rSBaicaV28WM9SWFMX
28150	payment	2132	2132	1874	1	1	704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtq4PmWbLoUDKXVxr3t2h3rfzb7oNPFYq6PJu6A8YGJVnhmRgK
28151	payment	2134	2134	1874	1	1	2477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpSrUmSV2nBSarnXZQZ7FuLVsiEZrk244ezg7y2gsVbkYXgeZ
28152	payment	2134	2134	1874	1	1	2478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5P2uqtRNfpVieWci1PJE5UrpjfJWNYWV7SpM8WieMmxhcrHA
28160	payment	2233	2233	2203	1	1	0	10000000	10000000	\N	E4YVB8ToqRLaoEX82BXdNjrkZoDLyDj2bL6sqydKmPQFfUb3ExXwz	CkpZ21tdHw2Lpan9okBTSMihNAKJvGVKqsCxqFai5Ck8Kk6Kz7g5U
28161	payment	1397	1397	1678	1	1	11633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T8GqkkjW3fMgQtyWipGwDxVqKmnLdhroE7FgqzSKEzrmtPXP
28162	payment	2134	2134	1874	1	1	2482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1mv6pPuL7gLUUydifBX4KFPYHdqq8EB7P2v8GYJvxj9CXehp
27913	payment	1397	1397	1678	1	1	11554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMh6v9FC4CJ319nx7oYK4AeGpnZkxhhFopjqjrMPiAaW6A6tBB
27914	payment	1693	1693	1778	1	1	978	1000000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZssCVHsDoazBhitswMqF95SYsG7EZVSLZJN3ZxNccF4tH5XKEs
27915	payment	2134	2134	1874	1	1	2404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmA9615tbBmHdGv6pqDNUASZszjuHJLtJ8p4q8p5uQb2Mg2VqF
27916	payment	2134	2134	1874	1	1	2405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FWBAn3RkTLwM169YzwViy5RMRxFjwz6B4TDp3UGuEP4ntYm7
27917	payment	2133	2133	1874	1	1	1983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD23Pq2wi74iL1JtjDCYanvvnduUNrooxChi8o9r9ZaG4JgW5X
27918	payment	2133	2133	1874	1	1	1984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAJDtae9hAVUmBsk21PQnzEpMzY8oqrxJ9nMzJw7FwvTrpXfy
27919	payment	2133	2133	1874	1	1	1985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBK3x8Bu9GmCTyebYvn1x7qYo581qM3JSgRr96P3qaZkPJgva
27926	payment	1397	1397	1678	1	1	11557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc4MiVKJ9ReyLNf9aX7RDkrfNdHsZKSAciN93DtyoZ6MByF68
27927	payment	1397	1397	1678	1	1	11558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhZ3MGUQDfMrvazZ463ioUHAPAZ5rVKYqR2gzbJSDpxU5X3oG
27928	payment	2134	2134	1874	1	1	2408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFYtgmTujQeKMFdjfbJuzvLgLhosud43VoU9ehwr6pJBdn69a
27929	payment	2134	2134	1874	1	1	2409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQZ6KFwSxpaMzqjj5213BWUhwnNfuXvFZqCUHAojvKDY1BpKk
27932	payment	1397	1397	1678	1	1	11559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByhpB3tJR7G1Gxzcz7iH9BcjaEXcKuhXJTFAuWYRJzHBPySC3
27933	payment	2133	2133	1874	1	1	1990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8seuzTdB5Fr53af6k4PRfvoRvmNgrvXzqMoq4R5Vbu9nMYWL
27934	payment	2134	2134	1874	1	1	2410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHqgcmiyzzk82dChGUgyx26UBazKGHEDvQbtxmKCXGX5aEST8
27956	payment	1397	1397	1678	1	1	11567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKkmEtNuPCR5WKADhGtBo2JquQvRJrvauSMCq1Gvho48RgzwR
27957	payment	2133	2133	1874	1	1	1998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMCXPRi8yphiSwzRxx6zCpPGMkwHtpFyASRjkub8oWxRTSFtX
27958	payment	2134	2134	1874	1	1	2418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjiaGs4GjyHCSPRbapKNA749mKBSyNNVMCLJ2wTZpg5JBRcMj
27964	payment	1397	1397	1678	1	1	11570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyU5VqtsuHd1x3rGz6fNNvLewQFPdz4acRqgbx33GRCaj3u8Dg
27965	payment	1397	1397	1678	1	1	11571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyT2NtknspjcQn8deecLqZAZQHiJVLs9HJW3nNMY8YhVMYvfC
27966	payment	2133	2133	1874	1	1	2000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKTMJRfiM2YGw5Yk5tCzsG9YWK6VvSxJ9cqGiuGuZQRJrz4T5
27967	payment	2134	2134	1874	1	1	2421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLX8FYuKJBB7P69yGpyyCy3zKRJ3bLbXaJzwpFCJSvB18MU5x
27968	payment	2134	2134	1874	1	1	2422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQNDXZJRzharzctMKziMPwTyStjispaTHU1gEhCzKRjcPoUyY
27969	payment	2133	2133	1874	1	1	2001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nGvtcWAAzM1LZ3HZ44zbQRFdVaVCrnPK8LLCvpKhRA5huPm4
27970	payment	2133	2133	1874	1	1	2002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuz3JwMiXhNkv3om2f3HHNGgPk3X79wVhkHA9nbdUu5UvmxJNH
27971	payment	1397	1397	1678	1	1	11572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrJcZHJxocy4w3RFdiDHmHPXzMzWdiJPSF5xq3RpRJKiVMva4
27972	payment	1397	1397	1678	1	1	11573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BmF2WDJQNy8Va8rDPNDjK2btmuAARtYd8sA5DzK9iz1gHdca
27973	payment	1397	1397	1678	1	1	11574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCcKo8kXCm8HfGyjjBgGnHRybmYEkeJ3hDMkjpUqsjJQQwvUQ
27974	payment	1397	1397	1678	1	1	11575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6X6qpHNowDbCt4ueRdB1UkLXcYnCHZMCWMw8VmQiFf7ZTb4o
27975	payment	2133	2133	1874	1	1	2003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFg2pB9CaN4vURmGET3zR8uefSANFHdPryVndMejADNPeFdFB
27976	payment	2134	2134	1874	1	1	2423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbebGPJ9AfZPhZZhtUz97R9sNSKZgypJqpNWtB9SEpj57iRwX
27977	payment	2134	2134	1874	1	1	2424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquVakVqiKnKNYWeGbiCKfi8uTvGC5Ld9jkvwSh7qzm6k1LPoq
27978	payment	2134	2134	1874	1	1	2425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZAUe7vUxUi87HvoyMn3MnbESgf1reHdAsTofXu5rnNAVx69B
27979	payment	2134	2134	1874	1	1	2426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9f86z9uvbzZtAs9xg7HSdcrmkD8VyQSVxh18LrnKbZNBiYE5
27980	payment	2133	2133	1874	1	1	2004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4wCQUoGpLmvx1ddKsEduhA8aojxzSzBdUVAajf9x4qN7ZYps
27981	payment	2133	2133	1874	1	1	2005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnahhWaXMLxGZtJHuvwMbnen7pZPVrCjfa2tHGbjkcyVLeQf2
27982	payment	2133	2133	1874	1	1	2006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgnvg8Ztf2tNSvcNLzrKhnsYpMekKtRy1mRLTeB6g2xwZWcU6
28012	payment	1397	1397	1678	1	1	11586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m6nKfPxxpZ2bkGxJsM72YYjryRbGfwTwyXMPdcm8nBFuXZDm
28013	payment	2134	2134	1874	1	1	2436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD4J8QvSwfhWbbkVRGcWhEYVbwzmsDNyUHiahVvwDjCpTBazpJ
28014	payment	2133	2133	1874	1	1	2017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycgJxBxggT3GuNF2DmdLJzhwwu4KV1ZL3i2hRX3QeEJo1bLts
28015	payment	1397	1397	1678	1	1	11587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAsPjswcfLVgE6Q5tdMcWajSPt7tLmrRUiUwRrixgQsNJywmc
28016	payment	2134	2134	1874	1	1	2437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxWpA6p8C9S7CcX2fGFkAkeF16GMQXengkmWV1JMJ2BCxNHhr
28017	payment	2133	2133	1874	1	1	2018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTuoabfqAYqLWBHQ2Bd7WHF7P3KzTZmYe9T3icHkeaUsTZduk
28031	payment	1397	1397	1678	1	1	11590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETXMB5o74DvScC8WwJr9knVaLscdh2wBcoUZfPvZoeQkkz6u7
28032	payment	2134	2134	1874	1	1	2440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtBJdgdenp5sPzw7ngP7e5fh24g6U6ozrWUWVjAvRhqaz13Gv
28033	payment	2133	2133	1874	1	1	2021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSvydS9ysh6o29Fbt9tqfFny1XP1EqWB9FkTsC8jVQfVDFk58
28047	payment	1397	1397	1678	1	1	11594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49hPGAtxWp2MeXDbKZ5Gogt9bngm5QrdkJfG457utgqQ65ETZ
28048	payment	2134	2134	1874	1	1	2445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hhS1aYXZJz6tbLeZZ9Zzg3rhZ8XtRp3iphxiQFVR85mgNP5f
28049	payment	2133	2133	1874	1	1	2026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAE3g2LrYaH8k1eUoZ7gdB5EatW3ErAFPdEM4WYFdhfaeQKGSo
28096	payment	1397	1397	1678	1	1	11609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cN61og2bAi9M8MYPAVLpVaApmBjVVAVcsUhRzhCau9kLqwAx
28097	payment	2134	2134	1874	1	1	2459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Anbvci35ZBBGn8X6YRc3hvASeWw9DEA6ReXdrVx5F3b4Th6t
28098	payment	2133	2133	1874	1	1	2041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MyvL1U7mjEwoqUzWcYvQ7KVEyxarDSG62rLZeyk7hSGQ1xnP
28099	payment	1397	1397	1678	1	1	11610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzrPpK2SJHPdnLBFYByiuBpoVPPLhq9AtQrW22FisfCjhKzfr
28100	payment	2134	2134	1874	1	1	2460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz7wRHaDSzjFHLyEjKsZ4rbgSJH4QaCWVpYgA2meYzBnJqdDX
28101	payment	2133	2133	1874	1	1	2042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3huwDmdVTGbeo7DGa1hw4Egs5r2WFaBnBBa7id3cWXeHamjJ
28102	payment	2132	2132	1874	1	1	699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ARHvRmjdyMP8MsAFpaBCidjTi2tcCTyMfG6Pq87DRz4DUAMs
28158	payment	1397	1397	1678	1	1	11632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3eyukJwBpc7d1ZGX2HVrLHYPuC6rKgZQoHPts1dBrxg1qE5M
28159	payment	2134	2134	1874	1	1	2481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDEaaHh4NMMX8UE2gSGKg9Qcu7tiD3cFngAw8vfvHfpDvnNBt
28164	payment	2233	2233	2234	1	1	1	5000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZKNTBYRHGVHezJ9QSymSDBovmjSqhbcCAWWUFPNqB3ih7T9K
28165	payment	2233	2233	2234	1	1	2	300000	10000000	\N	E4YbP3REp71wXfR8mBqQN4qzeytRquD9PfhBN84X5o35L27aweUrV	CkpYttS5Dn3LLhqsknekxUQZCaB6W3jMiaQRiQFZMaWgMf6hdzk31
28166	payment	1397	1397	1678	1	1	11634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRjihJ2yqyr5HdgP8f2VkCguQ2MqeR3p6GsHTpgnx3VAphsdR
28167	payment	1397	1397	1678	1	1	11635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9g4WvAQYESEKDtaTHzWnpAqzj1tndLpmvnnx57sZVtuuuP9L
28168	payment	2134	2134	1874	1	1	2483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBngMHcRf2uERNgBUtuakNDsvfGEW8MZ5SvzxVDhkXH3P2ufXc
28169	payment	2134	2134	1874	1	1	2484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkENuzE3qUcCfjCem9dsJQKF967RUBzNV5cmfQhcYmYC75abpm
28170	payment	1397	1397	1678	1	1	11636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5BPKmZ2JJUAzgyHAah4fHTyccF8zKbQjE3wYxxwJbwkV1NyF
28171	payment	2134	2134	1874	1	1	2485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NQFm1kG3GGtk3EFETo6X74pgeysi5WuAn6iTEZMkMgbavMaP
28180	payment	1397	1397	1678	1	1	11639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjJX8GSeudb8uwaKsHkwub9nzpkR9rHLtuCcgKpszbCnojQxq
28181	payment	2133	2133	1874	1	1	2048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8SYTJoP7wpb4XBjujEsWrrPZvmbvKz1qy2e5suUNtLF144bF
28182	payment	2133	2133	1874	1	1	2049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB7PGAFFFgLtmk989hngHTAYeyEYtVg3KC86PkQ6YdjLBUsRP
28183	payment	2132	2132	1874	1	1	708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyDpjaThVurrs6nFLz3fKJCg7mmuoAKNBQcgaWdLY9Zx4mXNV
28184	payment	2134	2134	1874	1	1	2488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKGbKyQFGSfY72wUupNWBA4SWZ6G8Xn1kkeSGq9SzTBjCJZ13
28195	payment	1397	1397	1678	1	1	11643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9Nv7RxaoREZQ81bfuz2yzjF2BqidtkCfn9D1hZZxnZ9rfvUB
28196	payment	2133	2133	1874	1	1	2053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmWxdhEyZCF5FNgjeHoEjEg6HF928PLw7nxLtWYdxF6LjbQs7
28197	payment	2134	2134	1874	1	1	2492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzAGuFZ8nf9LbDwsQmNKxAv6vDaQG5VfwMgfb8XkazvZvbJqK
28233	payment	1397	1397	1678	1	1	11653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbozP3o1SJcyCwfiDpEYJd2f1gZASYkybYvUgStA8g1xmVuKdk
28234	payment	2133	2133	1874	1	1	2063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6Endntjr5E34EeXBrt5tt42BuXWgBNgCtjdPXsu8AzZpToxs
28235	payment	2134	2134	1874	1	1	2502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzCNuDRjYbWV4EQEvAV4Uz6BDdsu76jkXx2QSwDYE4EQUbZ4nB
28036	payment	2134	2134	1874	1	1	2441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB94F27ts1f5dV3DoD54zmWhCYFUQ71PguoNSdWFjgX5Unjus4
28037	payment	2134	2134	1874	1	1	2442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp84A2BsyFzH4p7NJrk6tPLHBsHZPeQaASbyYahakEUkSrhGHY
28038	payment	2133	2133	1874	1	1	2023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdvitkKVXY5wzbnGPArGPA4V1NtucWwiH9HnscD1FcJSi8Wph
28039	payment	2132	2132	1874	1	1	693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHy3TKYAGShfwN4a6Vatc6Ro7Vh4q2EgBLXtcV6HmDans44Q2
28050	payment	1397	1397	1678	1	1	11595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7GskbnXQt1His36UBmrZ5FuvWGZpxaGyerbJCV4fiEVZNWrD
28051	payment	2134	2134	1874	1	1	2446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAspPMTQYEQQFzsvwPuyawLyDXMu7nRUdU5JmR2MTLgf7bYq9V
28052	payment	2133	2133	1874	1	1	2027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwrHWYeRRR4ZJkuT7treB4ofNhJ7WK4CUUoJvfCH9AfNFPWsv
28053	payment	1397	1397	1678	1	1	11596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wwHaEENFD6uyExAgWB8B9hRti1wAhsovTzcEZnrSdbhzyU81
28054	payment	2134	2134	1874	1	1	2447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpWY9XhVkjCzyxGMKmicLnPos3arnaUEw5NA6nsXXqLHCXFBS
28055	payment	2133	2133	1874	1	1	2028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJfH19WSSZG3FtLrXPt9TYuRGph2463QxycoxptjbrKCq95YS
28075	payment	1397	1397	1678	1	1	11603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpFbfqSyVD5SafUxzqpPKUq5vSu8FZNfckbEGw9Krppw5RKgk
28076	payment	1397	1397	1678	1	1	11604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwaGvaYqgSSkg3eSi2CSTojCzUnLMBukRi6Tt5oLSmNJ5QVVs
28077	payment	2132	2132	1874	1	1	697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYhKhCrLGDt3Y2XeWPH7fGS818rXgFUFYyrV9F8oeQtG4g8ZP
28078	payment	2133	2133	1874	1	1	2035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrBJA8yaBTp2drfJXfFpEZP5VtRJyohHLSeT9mspyx8hn26sR
28079	payment	2133	2133	1874	1	1	2036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4yWZQiViTBJv9LQE1KfuweCSHjyhEZtift6y4cUQukU4WngH
28080	payment	2134	2134	1874	1	1	2453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBy9CdEqSvkvh51WCYyiETK7hYPb5zuZmfBue9kNCPp5QgYFJ
28081	payment	2134	2134	1874	1	1	2454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGwnbXHTGv2WXyW3YFWxxnx53ssqQRRCu1LMdjKZFDUqFrFyW
28089	payment	1397	1397	1678	1	1	11607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xD2gsKX2X5byHPTsQNybARBCVsriMLHNepqsN4CNbfiTUSqR
28090	payment	2132	2132	1874	1	1	698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5DzbybmymFFuEyyg9VotPmfS8aQHwQuJELzJeFdLQbPHkfsg
28091	payment	2133	2133	1874	1	1	2039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhMTma9fvA4Mp29d1jBuk97Az9CjgeT6Viw8uDosAZaJv1kvr
28092	payment	2134	2134	1874	1	1	2457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PGCFJ6s8MVAjtQKNPx3Sfr8mdEBQed82PTEwRSoykEU7W9hL
28103	payment	1397	1397	1678	1	1	11611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJ7GSJ3jUEmkoymDUgBq9nLJfvMVnjr4QZCQ2tfcqEnSjqQez
28104	payment	2133	2133	1874	1	1	2043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThpvojjBKs7mjM5SyCZkWb4HRZBJ4sZU9VAcVKQBjVyX92h11
28106	payment	1397	1397	1678	1	1	11612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU8UMcv1yBkCTkL5JWaT2jn7bFTQWaLjA7FKwUWEfHfDE5wAW
28107	payment	2133	2133	1874	1	1	2044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4UFpLsVdRR9gsY6SUJhGamb9GiTdSQLaqWEBToWcxxr2wW88
28108	payment	2134	2134	1874	1	1	2462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv63JECPBpsJKdTmncTyKxEzF2G8ySVYHFwRF91ic3qqB8nEB
28117	payment	1397	1397	1678	1	1	11614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRm72tPaHG7DGUGPAFDm7Tw3ntfhuiVGZ8stciPHV4czoSvef
28118	payment	1397	1397	1678	1	1	11615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8Tu5E85P8hRHFTTSKguPHmgvYuj5E3cuJaRR5LkSwoY3jq93
28119	payment	2134	2134	1874	1	1	2464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJFyd2qehZURzamZaZxFjEVhJznxhQSBcC2F95A3wLay4RrKE
28120	payment	2134	2134	1874	1	1	2465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUt1F1CKV1gmy1oB8UELGhop393zNcztTfqR1R4Cgz6HDvJdEq
28121	payment	1397	1397	1678	1	1	11616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTh7DagrfHp4BW6Q8tnLAjms3dssuWv8QGUj6JJA868oUma5y5
28122	payment	1397	1397	1678	1	1	11617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuPqoKr1YDEzpr34WGxN59D9vUtyMnnG1jzJTiYU8trdF6SRx
28123	payment	1397	1397	1678	1	1	11618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7iJZHGBgN4NzSA5mFZVENsSYyqiA7XzasgZ35Z399h58fY97
28124	payment	1397	1397	1678	1	1	11619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyDmGdGZTiteZccUrnMv41R4kTfVpZcExSYMEbwhqLUrjkzwb
28125	payment	1605	1605	1931	1	1	0	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdcBvG8CaGTC5UyCEBeHiEM7ZnEMY8WrUtUfHM1GSgH8hyGbs
28126	payment	2132	2132	1874	1	1	701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSvXdxQ9zLWGCAyWQzFrDjmUL6kiTsvzjQJUK6c36TXphmAvj
28127	payment	2134	2134	1874	1	1	2466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrVMMPUmsWNqbWmCjmrVXa6bZBRFUsjkYCqjk6oR9a9otjaQg
28128	payment	2134	2134	1874	1	1	2467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthsosPKNqDeKfHRzPimWwVZViYo5uabBhdSngw3rPAopBpFG8
28046	payment	2133	2133	1874	1	1	2025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9w3k5burZ97HAUJfNqwgf6nWCsCyDMC76c8rwTmdvEkkEmW8
28056	payment	1397	1397	1678	1	1	11597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dpKYyASDgDygKLkf92Gdzv7KZxkpXYCdwsi6qTtyK4Xz4JpL
28057	payment	1397	1397	1678	1	1	11598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4VS9e4kVCyJ5dxCgW8zxcYucph7Y6oYuYZ7bbMg5p1jJHNRC
28058	payment	2132	2132	1874	1	1	695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSg1oTT2EiQGAXnsyaQDyT11k2UsqQKpss9vZLp7JiXCkXb1c
28059	payment	2134	2134	1874	1	1	2448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTWMeKnwNfDUvAkwEV4onRVb2iJ7T17spRDWhBZknMozF5paf
28060	payment	2134	2134	1874	1	1	2449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwjE4CojPwrM1C377V8bGv9qHU6311KwBr2BQZUXL9csN2TcS
28061	payment	2133	2133	1874	1	1	2029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFe6EQL1Bz27SKbqfsqPpt3HLbKVZYx3G9DcfBGM4P3p9HhXf
28062	payment	2133	2133	1874	1	1	2030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPPE7NsN4DKzBmKD2qqe6XbRP4t2Uvaot3VgsL7iG5j2MvK6p
28063	payment	1397	1397	1678	1	1	11599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhxG8Vg5ynScEHMBp4rEa4AYb2vwo1rBCJcchwph4EjZ62kgN
28064	payment	1397	1397	1678	1	1	11600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKEbjENVVuodfrcCEfJ8T2bHjWWb8TaTpB3rMqZmrF6fv27JW
28065	payment	1397	1397	1678	1	1	11601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvz1pEArbz1nfgL5abLe7Xth6cfPreiKYtbrvTmX1NSRpmrv4g
28066	payment	2133	2133	1874	1	1	2031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJzEpvdbViKVtBWoRRXMcz8fG1cHa4rEySNPBCXDW2MLUeRNa
28067	payment	2133	2133	1874	1	1	2032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FXSb16gUxEPiRC3bsfdRyaTrD52pAh8CxLKJBZzv3fKx9abh
28068	payment	2133	2133	1874	1	1	2033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm4TBHtpgiakkgo1scAXpxD5g66ahST4zbSuZBmKKjjuDZts3
28069	payment	2134	2134	1874	1	1	2450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWaCS3KeoXyRUHHNYbpGvPkcT5zCcrxyo687B27YV6siEw296
28070	payment	2134	2134	1874	1	1	2451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTDfJiQrvjF7e5erUgve7VHJsRZeGBzQazjrZNeCuik6CLmxc
28071	payment	2132	2132	1874	1	1	696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQbRbKxNo6kUBxhy3yqbLDFtf1jKhG8o6XJ72VbFmuMg1f5tn
28072	payment	1397	1397	1678	1	1	11602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRv8HKGGgu297PKA1M4xB7v3yxC1NEhTEZ5bqkxaHv5nTuqibQ
28073	payment	2133	2133	1874	1	1	2034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvk9CjgG44xqgctHr7XBMyMjgPobf3YtyFt9Vdb7ezz4HvEf7D
28074	payment	2134	2134	1874	1	1	2452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjQ4uuWxV7tkvgyKDVBUnFmoJy6s9GS3WQFrtnvyqRxnrE7CZ
28082	payment	1397	1397	1678	1	1	11605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeXLzfhAwtU6DJGSXX1vViys3T1cdS2iMjw9vfyPPTfJKRTWv
28083	payment	1397	1397	1678	1	1	11606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oWHvfL1Y2WYak2BoFzYJvbsrSfm3obmKewShWnq5k6NVhqBa
28084	payment	2134	2134	1874	1	1	2455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD2STZkgFmsbWoDHjYdU55jsRsdxuhRTjii1qmVAZuwxwub1c
28085	payment	1726	1726	2233	1	1	8243	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbBWoS9AkQJVx7Cm5f45p2zkMbZEP6KvwBs91eqdL8MtP5ZV8f
28086	payment	2134	2134	1874	1	1	2456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPCPR3hVnRf8x7Lum3pyEZkDsU2Rkws3gXUKAt8kWJeNbfxAx
28087	payment	2133	2133	1874	1	1	2037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMyrxQwasZPWXoEPmbaPVb6xQ86Y7euasnFxYpEhZd4FQPPqF
28088	payment	2133	2133	1874	1	1	2038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbf2eZQzS9tAoEaMAsyyBXho33gsX4HAETVHvf6iLcHpgUGPiK
28105	payment	2134	2134	1874	1	1	2461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCvFFvz7cnJXduEkaZx5Fpgha1hDyRrQqjxfxBthpQ3ijxKJT
28109	payment	1695	1695	1330	1	1	5	6430000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJzXRHjNN6j1XnJpp8oVn6E2qLQ9LWUgcMcwd4PhRVayHvR9x
28110	payment	1695	1695	1204	1	1	6	2308000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7QTsA471rvW11q5LK2bpGusZkPxjy8UJs9VSjNsev83tbQsx
28111	payment	1695	1695	1084	1	1	7	3420000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcitphXceiT5QnsTQrYo9bL7Rfz2zt1rw8fhQEG3dPCmtrEdEX
28112	payment	1695	1695	964	1	1	8	1909000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6LzD5pcfhcpjfZUf1MkfCCCBgAzsSZj4xep4KeY5RqvZoLr7
28113	payment	1397	1397	1678	1	1	11613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevd3rMfiCSsk3pbKN61TxPBEHecjGdLa9p8qEM5uU7Y4Bmqrm
28114	payment	2134	2134	1874	1	1	2463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWyz2jQwvN5e5QCJ3EcStkF4EiSDPKjDrFwrQuN8qZvjVtGtb
28115	payment	2132	2132	1874	1	1	700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubpSBECQMpDvQRUMBe8wRcooYDZDaZyjwcB3g62muUxwvASDT
28116	payment	2133	2133	1874	1	1	2045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38mci889zhagWgrD3LZbmtPUYU7FvUmStYBCvQ7WH7XrBepz6
28134	payment	1397	1397	1678	1	1	11621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfWm1oHYprdCi7AnEwZjg7x2Q2BSiizSLWAMnzpH68cwPsnze
28135	payment	1397	1397	1678	1	1	11622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNU8oqbsRNtvCajodig92E5PVQktLq5dwkXCdpkeWDFjruCdA5
28129	payment	2134	2134	1874	1	1	2468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9iF3LUxo6hnxd5kmbyY5DD6zg8TR1qGSoZjXLf38yku25ajk
28130	payment	2134	2134	1874	1	1	2469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrsZoK87dHBTZmT9jKaWb5vuVy8jXHGjsYZYja7jKEnGPxs9Z
28131	payment	1397	1397	1678	1	1	11620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5afzVEmRReg7SUxiMYNCUZ9nTRFhpJXEJ9KwRnsUcQTNTMqwY
28132	payment	2132	2132	1874	1	1	702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniTu4Y2YxBC8ejvBPoA9QKovwoqPztFYAmW8iPczKncNnCGbj
28133	payment	2134	2134	1874	1	1	2470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23mTEHvLoNxGYBFe5khSStpLA3cxMdU5cvpApyayxDVXY7Lcd
28172	payment	1397	1397	1678	1	1	11637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjNP4npt49Qy92A1nxegzBkZa7wy1JnHR7gFxokf7xSoaDrdY
28173	payment	2233	2233	2203	1	1	3	1	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xqgfY77y4nRjDapreTNGZPLb3BxafouDMZFMNrDkVgFzHNcN
28174	payment	2133	2133	1874	1	1	2046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHH2EEAyccbsXs7RNaQmW4yCa5ExDMCiQ5XYQEAfwdwec1Yjm
28175	payment	2132	2132	1874	1	1	707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxiJEAVzVF8368hLJ3rkZVMYYZRudmZUXdqvPWaRv8Ct69od7
28176	payment	2134	2134	1874	1	1	2486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTkvdt8WGCUoswdyUo1Qeaujoj8M9RSxfXmVbBuZXdPDP39H2
28185	payment	1397	1397	1678	1	1	11640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6G86R4RjfEJw1T82gMfCuWxa4yGPrwsnyU6U4BhWspYPRVkpM
28186	payment	2134	2134	1874	1	1	2489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb1eZsNBq2xKvV85HKVmBf4Cd6C7ZcV88viU2uN6DEJfnrLCh
28187	payment	2133	2133	1874	1	1	2050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7km8LM2wCbX7b4Do9EDcMvKVzcb8QhxzB7iCztLszaE9K1z2
28198	payment	1397	1397	1678	1	1	11644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkqr99dtmNhFgPcrEeoz9BCgYQsaicEneq6qRHfH5njDmNuzq
28199	payment	2134	2134	1874	1	1	2493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjdZrAqfgpHCA8C1EdY8PY5pHu6BdjEyrpUzWWPv48z39vZ8r
28200	payment	2133	2133	1874	1	1	2054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw88aDWBBMctomisKC6znkm4W8tUu8aGDg1CwTney3s47JnFD1
28201	payment	1397	1397	1678	1	1	11645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhqiFS76363epWgKZmG4r8fDJRRvURVYUrVspreoKZnvGEAqG
28202	payment	2134	2134	1874	1	1	2494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkPXS9XaR7qAq3bkh6L8MLksKE2cRg63LznFpnJzmezf3XeKV
28203	payment	2133	2133	1874	1	1	2055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdwfU3dejkfN7EXmVEu3vDVGiy5pDT1ePmUJFhjuMmu9HUW6e
28211	payment	1397	1397	1678	1	1	11648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPqPu4V1AZSLDRCb5PNL4po4FCHdnd4Lqzi4wzxh4o1s4Z6wy
28212	payment	1397	1397	1678	1	1	11649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF2CkqLAwFsiureEFh2cw9yafHUSNhp3zvCbMR6PC5VeS9t7b
28213	payment	2134	2134	1874	1	1	2497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRfVbQjBHFnb62mc6hiWnBNt6xBDUiXrvfaE6P8eT9RwtvMoY
28214	payment	2134	2134	1874	1	1	2498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9sK5eHKFz3CiCzCT8HtMRRKDwyvjDs35M4BnNV1xSUR1oRnv
28215	payment	2133	2133	1874	1	1	2058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqMzfbeB6jN5Yupz7BKmm5BSjVeFUECPhc6rgGQTxof4p2rgH
28216	payment	2133	2133	1874	1	1	2059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpnfvUy6q5v6kf6yjWCvcTQyLtvopNWtdx5ic24cpwqSKLaxP
28217	payment	2132	2132	1874	1	1	711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyuiKhsUmT5ug2MrfDvfzppcg5Bo7KEmCkzyS7jrWx6rxWqxr
28218	payment	1397	1397	1678	1	1	11650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfdDC3h7qyvxnNyCN5uTWQJhk5WNqeyVyhvCqnrAF2jDAgHd4
28219	payment	2133	2133	1874	1	1	2060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnV6GRqZBRWF48kiWNxAhcpPiLAK1kgjJeCF5YT256iAk7q1W
28220	payment	1701	1701	267	1	1	9	215456725760	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZhvEYxb9YFZULWEw61khrHAqGZhTktZSiGQ1CKfe6n2TcnxdgD
28243	payment	1397	1397	1678	1	1	11655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAWA5HQNZjw5oyqLRoyyfe6EmZ54pVzaxJzLp1Ru7D3CWPmKJ
28244	payment	2134	2134	1874	1	1	2504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWznpX2wcZWGPRwjb69F3i7Qr3DFztepSsuAZUrMezZQj4hC1K
28245	payment	1727	1727	908	1	1	7	2240400000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHyZYBtFsbm7Mtm1pQ17kXMC6AUGz9LRJbDDtTnFQ5BFCkZbv
28246	payment	1727	1727	1028	1	1	8	4014700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKEbZc8LxUL6zoZZyxsmzXi2uueStbRKBnYpRQxuUqxkrKARs
28247	payment	2133	2133	1874	1	1	2065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXULkEvM4fCb95cAKtDEYJhnAtP5wdN7fJwKC6gtb3mHaFj97
28286	payment	1397	1397	1678	1	1	11666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMzZWWPu7PJ6rBW6JALty6kfWEXoa9xwSWFoSzisSjsTzyLQg
28287	payment	2133	2133	1874	1	1	2076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTtsbQrVuqmtZdAgrWYNnoZpF2JVy7omc1zTHGfQM4VxwqKdX
28288	payment	2132	2132	1874	1	1	716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhMwhJ4jDUcHCbbsqCGQkiVNpx4PBAXKC1LjZro44vhxMXa93
28289	payment	2134	2134	1874	1	1	2515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidm8W5j2UiJEpzAKepwV3JVxS7htwKkd5gHcP5ohpWiTkq4f2
28136	payment	2134	2134	1874	1	1	2471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnR3Zj46kbatATyEpLLCLSW8z1rm2W4e6MiHkXTPyZCUBqGxZ
28137	payment	2134	2134	1874	1	1	2472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7P3U1cNVYgdN6D22i62rbveXToeAFCuYqkxjAQwReSAM6Am9
28138	payment	1397	1397	1678	1	1	11623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eJM7dCipVb9zSg47uAEyX7Yd3zpRmJfGidiKe5TXWGwnYeUm
28139	payment	2132	2132	1874	1	1	703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6GJAvJfhryqD9aELjB2QNA2PoXzmpC4USvGkvUjRsmwpBguf
28140	payment	2134	2134	1874	1	1	2473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgLmGtE36jABTvpqNLo1RkuaUpDdZCkM4w9kZCsjVabzYTkT1
28141	payment	1397	1397	1678	1	1	11624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCi2T4mJCNHZQXpKqhjnSanNEJSgRdR6VYFTCnJ5okNCsFgQLa
28142	payment	1397	1397	1678	1	1	11625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZG4x5nDPbWpufdCsLMCy1aWax3sXix9TBo6FiZZnDyMFk8pm
28143	payment	2134	2134	1874	1	1	2474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaZs3e86xFZnpGu4VFGMCmkRdKDkG494tFP14DTRMKUMW5aBq
28144	payment	1397	1397	1678	1	1	11626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8nZer3eEcGHxMdhg319R4eVAF4C9W1Fdcf1wMV32UCSNAddm
28145	payment	2134	2134	1874	1	1	2475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3zHk3hxgmAn9Ejq9SAqse6sBLdMqLz8PDGX4BUSf971HHmfV
28153	payment	1397	1397	1678	1	1	11630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcESnYWTh9dkeiBjMN3TGk1MS8As2xbHBxNQaJNwRfqAiXoFB
28154	payment	1397	1397	1678	1	1	11631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkQQGSxwfSfVa9QVj7sfeJwCVjrd8b33dJqWmpaX97oqPNvdu
28155	payment	2132	2132	1874	1	1	705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHVK55gLTPYsoJ7ckA1prjPB62bq57Wwx2RsYNhbycahJEP9P
28156	payment	2134	2134	1874	1	1	2479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzoSPvNZ47LLwggkxppfu1MuepzQh3H9prb2G6APCmQMPqjFJ
28157	payment	2134	2134	1874	1	1	2480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JnPmSXW46nxTxDexWBm9GRz6JS4hqTQoy6MqGiUnxv2UoCVM
28191	payment	1397	1397	1678	1	1	11642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWb6hHNVsjXe9PPD6nQhBHrMMsmw5LREKQhPiPKjmLp96wgPc
28192	payment	2134	2134	1874	1	1	2491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGo5RM8s2qBtrkSCvgNR9zozo3c9u2CDJB2ty6Qr4sLqDbGYC
28193	payment	2133	2133	1874	1	1	2052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDUDMVrW9QMS5skU5gHT2ArMMH3xMRgvtoAvknBrwmqpTKCpj
28194	payment	2132	2132	1874	1	1	709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXXtZQHZGwZzCvincaV7Qd3aMEgBv873dPquWkKnYv1ZkZTcg
28204	payment	1397	1397	1678	1	1	11646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbx9yYYfXA1Q84KnEwQXaz7gxxKrGPRwfiHVUdxahHk6BWZvbc
28205	payment	2132	2132	1874	1	1	710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkn4dpyXeRyNkAGCbQS2M7yrM1R98Gw4oiJ92ArgEomMChe5rg
28206	payment	2133	2133	1874	1	1	2056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS2hWtWqLn71cJJKMPw1nFTebUuF4eN4z1vKUF3CwG453sBkix
28207	payment	2134	2134	1874	1	1	2495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHBRQwShNPPLRs7AjqDQfknpX2tEQMyiSLjF4wLcjvue4UdyT
28208	payment	1397	1397	1678	1	1	11647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2Hz1EkSyp52LVsdJYGaNDkf3sfDBuyKQzdpzkLuG3G7xoDJX
28209	payment	2133	2133	1874	1	1	2057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenzjQrL7e6kDkKN75vT9a3dANvwzbjs569jppqqTQdmhXRfoC
28210	payment	2134	2134	1874	1	1	2496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9FUFRWttYVbTT3GnaMnYjbtHUbt6ATombDQi5G4guiE7xUvQ
28227	payment	1397	1397	1678	1	1	11652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wGkNwnUnfwCVQrjRa2X19YFH7J5FrvKoy5hRGyJiKSoGASQE
28228	delegation	1985	1985	1594	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa865bhPnFqFCLs22ZyZbi4iPWvYKuzjmySaGVkpAVCHwCNcMLQ
28229	payment	1701	1701	1042	1	1	11	2941224132904	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZHxFA2CeuBUnoFmyDMHoTnD9Q2611vM8XJWNRQ37fh9FzJySZP
28230	payment	2132	2132	1874	1	1	712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4GMz1w3QJZyTMPpQEVmmnedN6B6tWoZ6pisFh2PwdZVUuxXX
28231	payment	2133	2133	1874	1	1	2062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEeqbxEP2gG6Z61xseSPqrg6ucFtmZCCRdJgAZGHXsEuETs87
28248	payment	1397	1397	1678	1	1	11656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD56wSHWTnTUP6yApc7j4rGPVWwVakZtYGM9xN12696qhPGz77
28249	payment	1727	1727	1148	1	1	9	2708800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cLYYUKK1bRZYjx1gyAFMduqT3A9WqYcR5mmirjR21CZZJv5X
28250	payment	2133	2133	1874	1	1	2066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxq5nB2JbidPi8beEwcjW7Z4TxTn3g5XNUh7w9BRr8QYH1ivL
28251	payment	2134	2134	1874	1	1	2505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcJSzmNeVZPC1ZRsuqGnQvacedjTNQaR94SDu9mn2m7RZkNX1
28252	payment	2132	2132	1874	1	1	713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnuNaD1hrYiNtP1JDmFwFT4FnGh85TTvMjXMVqYAciSEpG5n1
28253	payment	1397	1397	1678	1	1	11657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSadEWdvtzxCK46Lq3WAKtTuHKTXfAX99iHTCf3DEmMtxZMkh
28254	payment	2134	2134	1874	1	1	2506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49AxDMQdLVkiXgqFwL1wS6DNTsR5vBx84FecHXMPRzqHTqMTr
28163	payment	2132	2132	1874	1	1	706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MAUe7FngNvHzPw4qAEFRuDrdDG5hKPY5242QzSzhcffV25zD
28177	payment	1397	1397	1678	1	1	11638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStYfrmWsuswDRwzoWKP1vKY4wSLQpTKX1YH1Qoq7pTWx6cNTw
28178	payment	2134	2134	1874	1	1	2487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjQZdF9xYt31eFvUy5CT2VyD8KyveuekBZM2aUagaudCNsV9G
28179	payment	2133	2133	1874	1	1	2047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ePAa7LPTQUvRKPQEvTp2svdof9HfmuNHozh6UXSc5rFLtnQ5
28188	payment	1397	1397	1678	1	1	11641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBTBJyNAwx5DDGxkDAXAC5kt7RYzES2MDFjh4JJWtMBAfwfif
28189	payment	2133	2133	1874	1	1	2051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCrfU3WygrSiwHJiBHd5EF5yxLQ51cUJgwEtyeu3rXYiiTpXS
28190	payment	2134	2134	1874	1	1	2490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSVZd4rW6JmtSsghWaiSH4ABTcWavdLzpUdfBy5UcAhKFzLab
28221	payment	1397	1397	1678	1	1	11651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68d8wDvBWVmVbHXyfWnXCxMyB5Py24YyDMkp81NF5U5AsXNQs
28222	payment	2134	2134	1874	1	1	2499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKpQFqVhhQCLjfXEMoJd3THuD2jUjQoRdDA7Jcfxywf3JCHXg
28223	payment	2134	2134	1874	1	1	2500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdp5SQbztjBgqA1DH3umw6Ue7DWJeweKx3LtkhnhdimKMpezm
28224	payment	1726	1726	2235	1	1	8244	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZob5gV8h8NxHTrN3LpJLCboenx8EjDbS6Lp2Cz2m2LbAYindQF
28225	payment	1701	1701	922	1	1	10	1641315957416	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZxtfSEfiSbRURUwqm9v2v6dfu8zinzLafQPN3uBW5CxBEKVze7
28226	payment	2133	2133	1874	1	1	2061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEBdMnMzxARoBns7JLmktLrkEnePFoDRnKZjg52XoNHHZafFn
28232	payment	2134	2134	1874	1	1	2501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oyRC1StdYvGGjTVTVSEGry2WLvBtZp3gQCDtCBj8hjG84bi5
28239	delegation	623	623	1460	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe9XB3VUELVKYWCRtXTAhFGctrNeR37L2C3w6qtL51DekfwzE
28240	payment	1397	1397	1678	1	1	11654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWTZod33itTpfG4mCjrfEaewsKdnmxkyy4kiEyyYThDDvL192
28241	payment	2133	2133	1874	1	1	2064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wsYf644hqbnmtGseUNfvGb9ThtMdWvKumPyZtKKmCFd2fDn4
28242	payment	2134	2134	1874	1	1	2503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGsmh1ZeV9nWZE871CMSUiUWgmyWkmwCUVXMDJHxsPb11zJXx
28256	payment	1397	1397	1678	1	1	11658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYff7fXV13Gfopvij5y7TYzSVNtFQft9TfX4jzM4ijBohk44NRE
28257	payment	2233	2233	2203	1	1	4	20000000	10000000	\N	E4Ycxyrg1Uc15DhdNW58GnVuLNTxC8XbJnZ2EbMfTWWw69PLv7iYi	CkpZ86oPXPYAEZw69VZGcBVtaFtkcSJUnU1y2pgu1hLwsMa2QUbFC
28258	payment	2134	2134	1874	1	1	2507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAVfWjpV7Gah8Lst8WoVpU3HD7VRzNuB5KgFkVJUFCTZjAfVN
28259	payment	2133	2133	1874	1	1	2068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWjKP64ncoWAvT7phJ1CiVBtM8RAoHPYKNJ5NxzdLQuLFq4e8
28260	payment	1727	1727	1274	1	1	10	7548200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTswLmCMr7QgJPUrD4tZdwuuJP4Pd4X9RaxwSdXtKEvzUqQsyL
28261	payment	1727	1727	1986	1	1	11	294100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqt8WRZctNH4MxZE5gpvjKUM891XZXiPMVKc7wiQUMjYhSv3b
28262	payment	2233	2233	2203	1	1	5	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjpGw7Q6BS1Quu1N8n3KtCvwaMLSejpLmf5rN3je16KeaVzsN
28263	payment	1397	1397	1678	1	1	11659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc5N3QT4sSw7Loba1omaYkFNNrp9dBFbHAKvdhwSf4gz9SgoS
28264	payment	1397	1397	1678	1	1	11660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JtDbk7zVfKaEKa62VCv5b1Ue19A34M8tyXHogrepEwjWSnNq
28265	payment	1397	1397	1678	1	1	11661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd3ALfiuTRXxxc3d69xBfMHLPvWkcrRV9MtjDcPp2JLMGrbA6
28266	payment	1397	1397	1678	1	1	11662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuQBPH9F3RZtBMEta37XrTf5qEFQJggwpU3r5jMkLCEcoj49e
28267	payment	1397	1397	1678	1	1	11663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQF9stLvz3uxJQJ4K2kHB35Dyj7zSNEESXhYGu9ca6fYwg9Ckk
28268	payment	2132	2132	1874	1	1	714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiE7A94iJGEZMfJr5mrDw3JXcvV4QczPdpJhnLqULtzgLegGU
28269	payment	2134	2134	1874	1	1	2508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZTRRcczNcKFsMZuCcvsqq9taVb49SShNTrMxKqfx6PeMgVSK
28270	payment	2132	2132	1874	1	1	715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGTARhzKzr18QtxcMB8KFWvcrc8XYynfncYUSy35ZWwzipeCm
28271	payment	2133	2133	1874	1	1	2069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdR85TgJaadMFyriW3VQBzeHaq3Vhoa6DNdKCPaEtd8jC8rWVF
28272	payment	2133	2133	1874	1	1	2070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHNA5dQjGJTJDACv9bmJZ84Zyf1NXUumT8QnKE9WAuocrDg7d
28273	payment	2133	2133	1874	1	1	2071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVT7617CHKfhvc8DqG127UWzcECA7QiMNTJFBt8amMzHkRprQ
28274	payment	2133	2133	1874	1	1	2072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfctCLTo76P8ZFYvnA3FKxVBp4P2w43o9x4yKVR2LKsmdx6CRJ
28275	payment	2133	2133	1874	1	1	2073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuSHArw7AMwZcix523zcY1Wz2BnHDZnjbiA6Kcb4VkUVUfw1M
28236	payment	1726	1726	2236	1	1	8245	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYeWQxdSwRc94zrcjECpikG8yLsVt9WZU55SDiMv7LhJvr6ELV
28237	payment	1701	1701	1162	1	1	12	1984502530497	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZys7xDEz72nV3xMhJdwpw986C676B4Jk6ortULxDu8LTqQRLjR
28238	payment	1701	1701	1288	1	1	13	5529992753376	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpYnq3knXYGfu7Z4Vr2F5jH3AxWnaf62h3f6oVHG5qKy3wqKt5q8
28280	payment	1397	1397	1678	1	1	11664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXtg3dKkkLZKMhoJ3F9dAK9FSfPW3whpMsnARD4i5U9S8XHvd
28281	payment	2133	2133	1874	1	1	2074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3YioqqnimpWH39pbUcWVYN1uU34vSveHszg3i7x59d8V7og4
28282	payment	2134	2134	1874	1	1	2513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnySPJCWVTcAweeErUQoqRgomXrDucwFU3gwi6rQvQpW9qTgL
28294	payment	1397	1397	1678	1	1	11668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxietbHt7MQGqS4QsaUBDY8fYGkzd9NLbwAtF76MA46DbFyvcx
28295	payment	2133	2133	1874	1	1	2078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMZGYaGXJu99xQr8uBP58ysqYgNtiqFAWqrUGUqHZUa5oq77k
28296	payment	2134	2134	1874	1	1	2516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TN9MeRTkhrbnic3HdmYBWgRsqEXWn8LUvXG4DCTaBDW9yjaZ
28304	payment	1397	1397	1678	1	1	11671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzNkPybQwPQqKj5FHaU71fmBv9CnD976tiMpWCjNqWXAxYqCY
28305	payment	2133	2133	1874	1	1	2081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39U3x44dFMUthQtkAPNfGdbcqVkBMKXBzXRhowX8ErQrcUWNZ
28306	payment	2134	2134	1874	1	1	2519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdu4xXrQHCYzHHYY5NaUuktUC9ThPT8BicZenWe4j848JQUcAS
28307	payment	1397	1397	1678	1	1	11672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABbhdywxwNMnxiRKoVR1XSDqtp41Nn9jpJqxYYDMgCzPyo5XM
28308	payment	1397	1397	1678	1	1	11673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZcY3bQgcCLjyruNEXBxzmQctBvuKm1biqg6hkHAWFpZJ386T
28309	payment	2134	2134	1874	1	1	2520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRSZg1mWkLoRgR4NrHR4Wt292TadkP8JmT9oCQDTi4XHfxQHf
28310	payment	2134	2134	1874	1	1	2521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsWBcx1rQM9X7LTyTx35u67oEz9H7g6DahDorbBbsEv4ioLEt
28311	payment	2132	2132	1874	1	1	718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zvrUzXBCd7RZXbCBFZ8Upk9YcE1TjJ9DnZpG4fSJkCW9VLe2
28312	payment	2133	2133	1874	1	1	2082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN7WhmbTjNAehExkxoMHeZ6mPhZjEMpUgCEkUBFqPBg8Z1Lre
28313	payment	2133	2133	1874	1	1	2083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxDEB634nj1LSuxLXCUHcUaDMosbXBFEnQThShvxKLe8aneZV
28320	payment	1397	1397	1678	1	1	11676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDZ5wmMrMVUuX7rciJiSzwZ7n3GG5xvJYQxzZEHpgHsZjN2xa
28321	payment	1397	1397	1678	1	1	11677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHg4RuqZBciSxyRi5DEgkku95HNRETktCoqKQh4FU2rrYw5Gt
28322	payment	2132	2132	1874	1	1	719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuMfSn9EVY3HuUAxSeFLrLjRU3oGCerXqnRy6R1t6oRLZp3Xx
28323	payment	2133	2133	1874	1	1	2086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxErkLdZ4g7CbB3JzBpzyJcRcMfs78X1n3L1cNnbw78VimUxhc
28324	payment	2133	2133	1874	1	1	2087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVBJKFne9Vc5pa7cgZ2LZ9etMbmcD8y4e9LzB5UnyYtCLcdK4
28325	payment	2134	2134	1874	1	1	2524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2igPT5iEpeZ1FjPHBEpy3aMTboaBQvGyEYbiGA7wETa6aqbEC
28326	payment	2134	2134	1874	1	1	2525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQyWRskH4koza5Q3idVdVHMyFqJvt5smzaD2rwPHoc3FRPUuC
28338	payment	1397	1397	1678	1	1	11680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KuawSjzCcF1wAo92CWGhQS7mMYWQ3r5hEAEEA17oaP9z8hxQ
28339	payment	2233	2233	2203	1	1	6	30000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdygRFFhPvjw7C2UyicEr3c8inKdr4bBPwUKmmqDVj5xY6AUqg
28340	payment	2133	2133	1874	1	1	2090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqazqEoMtcjUsy552YU327s4VnPsJKn1qXC9FTMiL7UKrVySj8
28341	payment	2134	2134	1874	1	1	2528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHpdV7JK7U7ifhWG5VaPT9pTouDSRhoQi1Utnpyp8VjQNHvrt
28353	payment	1397	1397	1678	1	1	11684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk6Dt7k3REY9DQ2zfmUPwSd9QbmgcTYSkubxYBvsdgVQevqus
28354	payment	2133	2133	1874	1	1	2094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjLi2kx9DTc39DruMMZ8hqHEwkcxVfqqtizUSAv55J8cKtXXC
28355	payment	2134	2134	1874	1	1	2532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoXtU8ifc1VkS82RmMu5yoMKaPLRNdySoGgUb3X3k46P9h5mQ
28366	payment	1455	1455	2011	1	1	5	576000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB8pqMQdyDX171htLwCgnstspq4AZ86LRQzqTd474nw4Sfdvt
28367	payment	1397	1397	1678	1	1	11688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSj97C82HMyKGRHXSNfjZGPXUoSzuw32849tzWvWRwZFGswMS9
28368	payment	2133	2133	1874	1	1	2098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2RRbH5KxRzezFK6NdhpzyF642WeYi1CAmsDJTwhS7vzhJEoj
28369	payment	2134	2134	1874	1	1	2536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fc6q5Zy82Ka1eBjUve8mqA9XiCZUX8qQ7DzSLzhd8nafz9mH
28388	payment	1397	1397	1678	1	1	11693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoapwStMLymr9dTdBFuRRL7W6tgUz1GraMY3nk6eVqZ2micfm5
28255	payment	2133	2133	1874	1	1	2067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BodeZmxQpvsFnkNrawc3sbcNwMEp1SfhAHAHdoFrdixyNngt
28283	payment	1397	1397	1678	1	1	11665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAEMKqhmyBa5uwqQnoUk91FR96gwgbxR5dJtr2kuL2ftnJay8
28284	payment	2133	2133	1874	1	1	2075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqUdzEcXY8LpDBxNZVsDGWS8DQvPeUJv8wsbTC138WwVUBm4d
28285	payment	2134	2134	1874	1	1	2514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiGZyJrZg6BLrtWrriDGVnYa3YE9wuhNZJy6PKEphDkt3DvX7
28290	payment	1727	1727	1274	1	1	10	7548200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PNrK4fwqPWU6fDV7SfBjXVXTCaP4orTDvcp7cjRJ7GjEzXYy
28291	payment	1727	1727	1986	1	1	11	294100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYm5KesxHmXSkVtApJ4iX22ZZN9qYJggXTPZrv4YD9zTc6qN2V
28316	payment	2134	2134	1874	1	1	2522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFUUYhzwxmHWEP3ecFFwsBjWyAZKW3PwtdKfi1JBUjbVQGYxF
28342	payment	1397	1397	1678	1	1	11681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCbcFwxfWs6qQPKv98YeU9kBCWWwzzp7cbCLPYJ9mKbAe3Lnn
28343	payment	2133	2133	1874	1	1	2091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzwR9WqASApnwjPWT1aJviTPfehawx9seqBt1YePJdy6BK3jT
28344	payment	1727	1727	2237	1	1	12	2101058999999	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h5wLmygZHDtDnWj1jrRpjFz38t1Qsk3WwjDk7jNfbsi5JYi7
28345	payment	2134	2134	1874	1	1	2529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAta6Atx5m2P4MVz9gVWVXtkcoYCLkQu6Rt7DwJFGXy3NgEP3E
28370	payment	1455	1455	966	1	1	6	1485000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLezKu7hYpN7fozkUShGqaCrtpN9iPXxuwrSdJAuTmwGfUM8vA
28371	payment	1455	1455	1086	1	1	7	2661000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2s1GzJ32HCMsnm9MT693aY7SEkEfEiEpwCwdAzAXoLRULvsh
28372	payment	1397	1397	1678	1	1	11689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLH1qZUPB9ktzxHWy5VaYssGCGRSC7PMczv2DnCPiHB3TpV23
28373	payment	2134	2134	1874	1	1	2537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTvdmwjGZq1vGwNnRbju2bGHpcRGVzQAy6ABKTDrqGkte2HwK
28374	payment	2132	2132	1874	1	1	723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCLzJVSYRVRBAK4qPeAc52UFmg6eE9Pah5nWu7GA7sPvMmNSk
28375	payment	2133	2133	1874	1	1	2099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxxZW91SeFshBoAGxbHhnhAtxdi7KieKtrNuFUgzygRtKrZLG
28383	payment	1643	1643	1299	1	1	21	938043477500	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTM99vhazNCubWVYjQVv4moZmfFs9VBYPhLx4pqF9BBL3C95na
28384	payment	1397	1397	1678	1	1	11692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iPFVtpPPfkV3yqWnbLezbzhGof6gGy1mPePwg7MALR8A9qPD
28385	payment	2134	2134	1874	1	1	2540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MMmsJLvqj4rDjsnwi5YPuUUsnczdegvPmoVbmWjPi2ThLiAF
28386	payment	2133	2133	1874	1	1	2102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuvka4meLroSb5UicSNRDCtnTKuMFbFPPP54F7ae5y2xeG8pJ
28387	payment	2132	2132	1874	1	1	724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM76Vp594Tj4C916xXcrfkwW33Z5bK1eSohmrYnMVSUMc8zVhG
28405	payment	2133	2133	1874	1	1	2107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFV4QPTwcdz2QQgFm8or29DfmT4krmwpEEMiYJBWBpCrRZVbN
28413	payment	1397	1397	1678	1	1	11699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCVGruZYXLGxgH4FpMaZZSkz5bDhrixEd6g7PcWiPzgKmeYU6
28414	payment	2134	2134	1874	1	1	2547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD74EwvNxMXBqdBKEujpP5MgEwwAvX1cVkJxfAuR66Z7pd4Ys
28415	payment	2133	2133	1874	1	1	2110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUmtCko7nRMaZQFihi47Wd9mjQsezV8YgA1C2JF3tMH8uDJg2
28416	payment	1397	1397	1678	1	1	11700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTk4SA2vYannWtDRzbCXkm9r8Jeca3FmXTAaK1Bk1M8yJiW84g
28417	payment	2133	2133	1874	1	1	2111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQhq9LBNw26nTtGirV5CDhdhWXa1zFdEQ29SuR8FV6m7e8Rt9
28418	payment	2134	2134	1874	1	1	2548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFTwTitGVTcj17wHrYbX85bLp3jszN1xEq6P7bAKWPXPsKsvS
28438	payment	1397	1397	1678	1	1	11707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXJJgmwmVm42GQ7JKCoSQkCty9zeczNjF7vhfGLwAFYx44HGt
28439	payment	1397	1397	1678	1	1	11708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeime63D71An8CGmadGTdst2Vp528WHDVZEZkWuRpYZ1oMygDS
28440	payment	2133	2133	1874	1	1	2117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrgfhBY4VahdykXphM47Y9qbEjE1oYhGhK1z83XYW8rK6sWr8
28441	payment	2134	2134	1874	1	1	2555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzrWaAspXFwWqXkpVz8tnrSpaw6K9kQ7ScXP91s6gMH2LKfjc
28442	payment	2134	2134	1874	1	1	2556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVncVkBQpRvaJSfnwVa7jLfFGWB27ekaMWhKLKjjgQsDjDsXv
28443	payment	2133	2133	1874	1	1	2118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDaKedGLtGKN6L6JDCLokATF84XGBnvA5BBZezpdbpzGADgUP
28444	payment	2132	2132	1874	1	1	729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuc4RToSxQBAMyQgNAiS2fZSML6zy3E7gmYZajg3HvgT75Q6c
28445	payment	1397	1397	1678	1	1	11709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCbsjebKZLBJuJ83JMZU7eQmMAQ8dErhNcQaw87xxrC51oHLN
28446	payment	1397	1397	1678	1	1	11710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLG5Pcre24HgotKgRuhbrtDwKPH3qQ2WSkJp7Utcy5rrgMBXct
28276	payment	2134	2134	1874	1	1	2509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgtissBjjpMfNHauTFVDG1PbkrQ61qdJzHQ8Xync6kNSUHimF
28277	payment	2134	2134	1874	1	1	2510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvFtng6ESyvg47XLUqCJgTDgZmBo7AzCXV6MLJZQdZNvCJxyC
28278	payment	2134	2134	1874	1	1	2511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMGUtZ4H4aw5ZTsHAfRBmGQtnehkHP9PJysqCmNcJvK5gYyXP
28279	payment	2134	2134	1874	1	1	2512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTyGfCppDWCDjeLusHpMsiHzqBtvemqCUJ6vqQy8gGwB2ycod
28292	payment	1397	1397	1678	1	1	11667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWs6JY5Rm5g8pqaJtupahCh5Gs6en4S9CgxsTkg9Ra8VVbux8
28293	payment	2133	2133	1874	1	1	2077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZed11fd44yvGZMKombtth6TaCRS3pPM3tGgXnSoBhyKRQqJDJx
28317	payment	1397	1397	1678	1	1	11675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nmz2NJZYHpfUhSnMCv467SXvtUcd1mru7h9LMC9xUCEjWQM2
28318	payment	2134	2134	1874	1	1	2523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwKfmQLZDs1DUoP9Gyxn9zmUbjCkdS8V1o7t41iGFeksPKE6Z
28319	payment	2133	2133	1874	1	1	2085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYS5nq1LkKCNpx4ftW5Ame6Lamkaf1Wg26uPLYGNucuSLLEsnP
28356	payment	1397	1397	1678	1	1	11685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVKBnBGuS77jbEjBp99Te9664nheLV9Rt3ZN3oGGiyS8b67Pz
28357	payment	1397	1397	1678	1	1	11686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJbh2NcekVSBJEKAJMkwEDJMsxwvoARMcVyBSyy37L3jsQQR1
28358	payment	1397	1397	1678	1	1	11687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9GSw4jmXCG5ne7UNCyz3QzxnSQhNSxp6gq8NU7VHMwymUdcg
28359	payment	2132	2132	1874	1	1	722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdiSDCPKJSyL6BR4LFMmUx5gzn4f7qGUgyS6QBviXEF7Pf9pc
28360	payment	2134	2134	1874	1	1	2533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dN6XYXH98rtgkhBNzz69yFVH2Li9jZb1k6ECPK6PMeVtrPyz
28361	payment	2134	2134	1874	1	1	2534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFx7gq6y29rWowd3yQsrb92881YjhUEDc2o8VTVzLG9GdfwNT
28362	payment	2134	2134	1874	1	1	2535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaruF7nnRNkWBZh4xLMMvuPAo5syXdiecJdAZZA82HrNnhTmD
28363	payment	2133	2133	1874	1	1	2095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz63c3uxGRq1nyTZ8oNK6jZARyDpUdA4LK2koMTCCTLn1MPJV
28364	payment	2133	2133	1874	1	1	2096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEV2SN57HGkxApu7vXsNyEWv2aBx2zPAw8hS8LQvtkVURhUdh
28365	payment	2133	2133	1874	1	1	2097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6U1cK58irYk8E8rqwxqxVjmLhyuSMKs4cLbtj7xupZ9EtTCLS
28419	payment	1397	1397	1678	1	1	11701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7X2o3yTmPSWHPpsAzmbTnFaXm5rYihJQYJBoX829Ao8TPNtTt
28420	payment	2134	2134	1874	1	1	2549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBjkL9a8xQ2ZBboFsRhyjRVoXrzdU51FsrNhV44Bs8ddFf86k
28421	payment	2132	2132	1874	1	1	727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurgpMEfnu3bVPSPRpdwWHFPuKsk51ytAAxm2qzt2uqEd59Eiv
28422	payment	2133	2133	1874	1	1	2112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5zRJNuY9oLwgk1cxDmBXGHNyDLuBvSFUDMwES7VNANb9P2js
28423	payment	1397	1397	1678	1	1	11702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKu9jVShf59hefHqjeM3LacfBL8SV9FdTSv5uDJ8W4mS7JtQjf
28424	payment	2134	2134	1874	1	1	2550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4B3igmsuRqqKtpkonmdCd5RDRP89NdxDshS72zcfXxF3Tzbx
28428	payment	1397	1397	1678	1	1	11704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtF7TkNr8kAsXLBHva3mJiQhxM1BRBHuxFN2LPr3zra6K36mr7
28429	payment	1397	1397	1678	1	1	11705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapsAYrwagqxQ6nFvNdGXpQBCU7tKPLYe3WN3B7JNESvvpKvE9
28430	payment	2134	2134	1874	1	1	2552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMdqcnD72W1bM5gCA6sL5ybghHNXidifjc5jeQPXLDZMqqveD
28431	payment	2132	2132	1874	1	1	728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFopsLF1ZDoTDzhCXQNV5WkbB7zTU3BmZVf11noVC5S389WNc9
28432	payment	2134	2134	1874	1	1	2553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnLSrsADRbTYsWrWwtWRLyf2oQVzz46S1JCpmnaJgMN1wJ5FH
28433	payment	2133	2133	1874	1	1	2114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vtZs8XbTeL9LFRcbdWUEdUvXFK5bfDZo71ePdk6ACieAsDYk
28434	payment	2133	2133	1874	1	1	2115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57e352w7FTczxsy7c2iBH7f3HHPTgXmXHzRFtjtQFwZDKDzoC
28489	payment	1397	1397	1678	1	1	11721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRMph8vana1XoweA7a1LVp2Zpnv636X9DfA7ZojBjrPsCSDMH
28490	payment	2134	2134	1874	1	1	2569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6piwLNtrTGk9x4RFxFVBRfJ3ovpFtSMaoA5k4s1edUYNGYNj
28491	payment	2132	2132	1874	1	1	733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDHZU3pcBx5WSM9MY6SsgR6FVzQ68vhPmP1PjzCT3DkRiQEfr
28492	payment	2133	2133	1874	1	1	2131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f2NWjxXHnXkZD9VUgtefQQxXRyuzwtE4w9skNRNf59KdbzPW
28493	payment	1397	1397	1678	1	1	11722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Qtpxjo7A83RnfDYdcNGXzPnEQ6oocNKRiRFKkSZBTyUYodvP
28494	payment	2134	2134	1874	1	1	2570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13TQCNHqfadLKvKmFMeog26KzRNMnrpHgrvfPoja4B69YhVmE
28297	payment	1397	1397	1678	1	1	11669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fZ66cs4C68FKqTghf7jz44AjoeujVVETNC8CcixXwd7XYnwS
28298	payment	1397	1397	1678	1	1	11670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHAAfqPBqRb3ANh7yKePeQqMiXcJqZHzVy3p6awnsqxGwyGsb
28299	payment	2132	2132	1874	1	1	717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy8pFXdg6aS93MhVjTVhej5KDLHgqvwPqULuhaKyYec2YLZq6
28300	payment	2133	2133	1874	1	1	2079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69zShv9K2WGS9xGQbQN3WRGLsNbzDx6eKmpnMNQdBYs8LzoRL
28301	payment	2133	2133	1874	1	1	2080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFu8fDT11NLLt4US1eoVrbjZCaQ6MNAYf6TQjmCD8zFLWeLfn
28302	payment	2134	2134	1874	1	1	2517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FFVzH5wAZSwxjohh3nDbocEHsNfrkyEuRQbm1DkAo92jpo5q
28303	payment	2134	2134	1874	1	1	2518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKzqsGgqqC9JbRFuqG1uWTYuoHVSqQQvtAc2rRQTicZy7cQi7
28314	payment	1397	1397	1678	1	1	11674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LWBJFWts2idznrojTetQ8nG6VpEUGwiLPc86yHD8xXDhq8vf
28315	payment	2133	2133	1874	1	1	2084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrn577c71spUE2UTByZFJQNrtmvUgNgKQtzURQ667Ph15BAaE
28327	payment	1397	1397	1678	1	1	11678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqprDSy6cHjhHdGTopJk1XofiiLKxTM8ViXZJ7q29iNuxZ7Ez
28328	payment	1711	1711	1001	1	1	9	2553500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpZBWnTxPNzqAXFiu4J4AXWnUSX6rceno44GqqpKfpZKSTszeppW
28329	payment	1711	1711	1241	1	1	10	3087500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpYva4gQAkCdk8jD4XKsH9oCs1o4YMDgtH2U4BACW3svmW1mmqgg
28330	payment	1711	1711	1121	1	1	11	4575500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpZTNYJqBWrSeRDaChjPnJRi1yPtc11KMefQMEcvAW1gd8YbjeuV
28331	payment	1397	1397	1678	1	1	11679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41tVSYip4KdkRqZFzWaUCZtqnR1E1jGuaKt9BLGRuCqAWCc4h
28332	payment	1711	1711	1367	1	1	12	8602500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpaJ4WEeTAh8BC7arRNmmjdTQC5rm9SckzNeoJNmSKDw7F44eHNa
28333	payment	2133	2133	1874	1	1	2088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSNzCtPvpjB1jDVFefJg1VFBgmvFjEuK2m1XnKMrHChithMzh
28334	payment	2134	2134	1874	1	1	2526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyvsGtRhSVahLhN8bGVtyKSpnopXL9Aw2ZsyNW1Z81sNLaK19
28335	payment	2134	2134	1874	1	1	2527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmSqoWm8HWMWAgM8kz1LuZM8mkpYfA9WGYbFCLB9ba52hf2Ms
28336	payment	2133	2133	1874	1	1	2089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu88U9gUGV1BJtsgeWoYBV2JL51HGaChzzXTFP5yxCdd6Rk92m
28337	payment	2132	2132	1874	1	1	720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWcFqetgDUEHQSHZcU9yjSaFtDnyVBtzAeehThp26ayUANu2k
28346	payment	1397	1397	1678	1	1	11682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmLutoJT9n9cr7Qg3YFenpFESvZK9SEzriUfMBzu6sHLVX2LX
28347	payment	1397	1397	1678	1	1	11683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DZDRCywPTA4FnbAVcZzs1bQQwEroJdhfQpPmpdQuhawPxgLy
28348	payment	2134	2134	1874	1	1	2530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt4wcTKcXb9Z1ncdrR8HYqe3oj7GeuHJsLmtVjosnSFeUNgXN
28349	payment	2134	2134	1874	1	1	2531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQzwPewBX3PkM88SzGQjqgDofixM2yf5j5eYVnenmoFeK2pWi
28350	payment	2133	2133	1874	1	1	2092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzW9iLzWexptUy2crhAJ52gKA4ZR8SmNRGChVJ3w4YA7b4j5SL
28351	payment	2133	2133	1874	1	1	2093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWt3SxwbfyckMFPkrq92dobd1xTgufhVdnCexNdXWXqMwMrC4
28352	payment	2132	2132	1874	1	1	721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27CmiAH1WqWnEA8yymhGZ6kSnyqFkymiJnieeCWpAXkRxie8f
28376	payment	1455	1455	1206	1	1	8	1796000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8WV9A3q4qC5BUyQUgCmBC1J9cqyCQu8Gg1gMFNCnhMRM288V
28377	payment	1397	1397	1678	1	1	11690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnCEmPBpCqxALEE2SKMo2Mc89vkf7PZXXfMx1BX2mxoq7uTrP
28378	payment	2133	2133	1874	1	1	2100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3ThuMUVZtXnuatjVeudymKh9CGwYqRnvuLAJJpC7CYzqFuPn
28379	payment	2134	2134	1874	1	1	2538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Qi4pupQrBKSjM3Q3jwZXBrHeRTcCHQVJi2knLM4TVGMTgc12
28380	payment	1397	1397	1678	1	1	11691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Tsx7NGTsj4tiFXGWpuU7F2h9VyWsYkXU3L7E3cj71j4HCYx3
28381	payment	2134	2134	1874	1	1	2539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3fLswP4h7fNdPLa3BcA4BwpMojFtooGGyJ2YgkxwD73XEHJ4
28382	payment	2133	2133	1874	1	1	2101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTL1YNEM5J1uTDtA3pHVQdRvcaow137rmZ1tPQXroGTBvUzdw
28393	payment	1643	1643	933	1	1	24	278413697300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNWqPBt7r311LPzxoBaUkijfbBarwevpF7Q7STt6oRp8Kxovu
28394	payment	1397	1397	1678	1	1	11694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF31L6zqMcLC4D4aby3pMwzffgfcHevazqnxhF3eX9pYEHPfUF
28395	payment	1397	1397	1678	1	1	11695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPop5XotkTPeJbiWKenAnm793J8YVzGFVnrYUbYb5BBSsi9vwi
28396	payment	2134	2134	1874	1	1	2542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qpZQ6P7ptJuggnCaEQJ1Rq5TpBpsZKQGBcjNVN5vizvsKc2S
28389	payment	1643	1643	1053	1	1	22	498914960100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpedELfz5UwFn36eh53X79e97MchVurfZEEtpk9XkdMf9aWwxu
28390	payment	1643	1643	1173	1	1	23	336627865100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKs1fX6kWp4EwRnMACBgp7NTuNWsSJQsKVuyy1KSKfFsmnTjo
28391	payment	2133	2133	1874	1	1	2103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A5fH3zUbQAqGPHdAz6GoP9bpPQpyTnWDVrfrDC4f6mYyPC3H
28392	payment	2134	2134	1874	1	1	2541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuVVEDr3VyvUoPcsXMAWqHk6ykqsWYYJAMPR4P9WZfq7HFD9Y
28400	payment	1397	1397	1678	1	1	11696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tnMt5wn9E9g2h3fDx2nGje8oVudc6RpcZfFueHp9mnLfaX9N
28401	payment	2133	2133	1874	1	1	2106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYas7RzUjvYP3X7tcPxTpi4WG8AARMT4dP71YhUgkvdKsWDJnbA
28402	payment	2132	2132	1874	1	1	725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNv3zDiUJ17izRJnPpFtv3cBE8pwZKPDnmTrPWyAuENnyLVCxm
28403	payment	2134	2134	1874	1	1	2544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNWC5wn8dA5CJng2c7qsAz5P2rh27EHNJuwhRvsxfxRszuYdu
28425	payment	1397	1397	1678	1	1	11703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19BMsWvDVWyTjbUiMsxqJriWnc5e7pmUPtA9ZzXQAtDMYZtke
28426	payment	2133	2133	1874	1	1	2113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLZpwjay56eo6PaAY3zvNRGY9THZBA1gvuP2CvKLpL3W9GpHy
28427	payment	2134	2134	1874	1	1	2551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSKNiwjX1ro5cE8vJZiZwAzn1EoCobrzSzguUJvzht3pt62BE
28496	payment	1397	1397	1678	1	1	11723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsaFrfmMD9oNZFCCx8izZb9fYs8w2XhHU4KfQEZt4eWWMABjT6
28497	payment	2133	2133	1874	1	1	2133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXiqgLpT3T2hAPfon9xbnEwDXipNbyYQX8BSG67Q5QJztv3Cc
28498	payment	2134	2134	1874	1	1	2571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLByvPdf8EC5zQ7JtuyzdgbjabR3eqjJ2ovkrNBGM79jNigP4Q
28499	payment	1397	1397	1678	1	1	11724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjTqgnmcq9ifkxQSchKz8C9sBXTVwSGR4ifoMKoaW2HkkMEWq
28500	payment	2134	2134	1874	1	1	2572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRpQbqY6tvgYjt1jNdNuQDSEfpBFuimwaLR3is95oDVSPRvLa
28501	payment	2133	2133	1874	1	1	2134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqd9LMS7VJ6yghzU34KxRiRfSNyrTPat8cLT4Kh9Mg1EF38NZt
28506	payment	1397	1397	1678	1	1	11726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5r5kYXRUu3wmy1ZZYKpjQokUxqKEXjdshteHhVd2uXvdaeFH
28507	payment	1397	1397	1678	1	1	11727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJGEd4ETsDUfbq8dLm2HVE45EmKwMeSx6i2zWxJwwasTQukbu
28508	payment	2133	2133	1874	1	1	2136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cVDRh3L3MbWzijR8TF8yamcPu66bRLKxHUthjesUdGXRw5oA
28509	payment	2133	2133	1874	1	1	2137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiS2VkPzvcAUA6j9zXJ1YigA5igD4JFSJv5DMBCKCK54vLTUet
28510	payment	2134	2134	1874	1	1	2574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUyzRmu4NepDvnRUwR1oWFveawY8Z5mz7vvKWAC8HBdH3Jn1z
28511	payment	2134	2134	1874	1	1	2575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHsSYowYwJs5hBRNpYphDp8FrBkbQyhmKBtdbrxaJ4DPmFSeW
28550	payment	2134	2134	1874	1	1	2586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTK51mnnKSyEbcEy2rVR5ju3sfxCN3C5iTze6qHkPkqfJNXg4o
28551	delegation	2119	2119	1406	1	1	1	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpYkwmKVeC2jLvoE79JAACPdVdRqfxm7QpRDT1eKjR9wjk1n44tZ
28552	payment	2133	2133	1874	1	1	2149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqoExgshUTEmGQ3JxBsFd8PxnDsMwQSCEqYoSmKj3QbnWdBsM
28553	payment	1397	1397	1678	1	1	11739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh47zi17qnH4a9brSKJqwPr51Cr6iTtP9SPwRYR938zqBShjg4
28610	payment	1397	1397	1678	1	1	11752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVykyvWZZLrZLQiywvMKZRzyRLMJEywDsx898ARXpQJJbtpAjb
28611	payment	2134	2134	1874	1	1	2599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHATP5oTQJfktTjoDBQUBv8o3dKr9DWGofUcbhyeBu38aqm4G
28612	payment	1716	1716	1070	1	1	5	4411700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq6v85uywHCB2NGKmCPB7Piw89kcE9qgdYuqzFgPRhNc3cynZK
28613	payment	1716	1716	1190	1	1	6	2976700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf5Q5E8cpBRjSHHyKt6vfwdBMbRNJ4zT9SV19rGtGEnUiAYcH
28614	payment	1716	1716	1316	1	1	7	8294700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqKN1F2WMUcJyCqrQ7CxhVJCAp5WFbUasMW65hS7i1yiRftZU
28615	payment	2133	2133	1874	1	1	2163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYcVwLVFuhaRVcUtDfyp3tZrE4esTFVmb9u2hEXprB1C9DVtv
28627	payment	1397	1397	1678	1	1	11756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6BDFDLvwB3z1H7An7aqBR2aZi18BbKXk2mmzTvc9mD7kA99w
28628	payment	1726	1726	2240	1	1	8246	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYs4CtKbgoLg89QD9ivmiHm4q85ZzEUGMTydLejCWFwG2DaDZA1
28629	payment	2133	2133	1874	1	1	2167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpyoDA3md3iWQ97RgmMDetiULXUMdwU4WoAmKqJCPwa737Fr1
28630	payment	2134	2134	1874	1	1	2603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYm5JVLjD7j9Yits8tW96qYLrrJfSYybn1U2uEAGh6nHPoTsxD
28650	payment	1397	1397	1678	1	1	11760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VTTfSy7pHgBzM33vvhb7HTEUNedo5YYdD8uBezFkyCdZUqqH
28397	payment	2134	2134	1874	1	1	2543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZ6dYBB9mCkaM3yZFyfMRCSoiJbmrpu7q3Ka8FYA1g9LuhVuu
28398	payment	2133	2133	1874	1	1	2104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLM6Sa53u9oH6qN239uevyQh4ZgeheRtj95TySnrhExtrqafh
28399	payment	2133	2133	1874	1	1	2105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWdL2FbWA64p3CtnYh9bLUiVot63jjCjoFiVygusyAM3Nk8kR
28404	payment	1455	1455	1332	1	1	9	5004000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiX7mXD1w8gkH1A4NUDBVHmG4q1FYovZEqj8HFAXBXEg6TfSbF
28406	payment	1397	1397	1678	1	1	11697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbEZcjDw137yTnm7aC2UgtLs7zDwHXvgnFa7shU39kvuw6wbP
28407	payment	2133	2133	1874	1	1	2108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKuJNNvyCugNseUgifF3vbzdqzqZb1XQCnsdzWFJvighNwmRB
28408	payment	2134	2134	1874	1	1	2545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxPyriuNMttNLUGXodP5b23MjS5CK6F2EaD4aKQQkcxsG9MJ2
28409	payment	1397	1397	1678	1	1	11698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LFNk7BSJ5MXY2otxjCQmub6RigmhDHhydNLNdLLoAASJ3UX2
28410	payment	2134	2134	1874	1	1	2546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxcfdkHj2H1AdNcKhUKnMWnx63hU1futLfAwrzPcPNz6wrCgP
28411	payment	2132	2132	1874	1	1	726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUJVtEee2zMKSDk4ixrk6uJ4JRBB4npmVRS5ktjAmnXSBPwax
28412	payment	2133	2133	1874	1	1	2109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNejGq41QspzgAncwZfnpBGscfKLF6tJ9rWZQeSPq6vWyFXCH
28435	payment	1397	1397	1678	1	1	11706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpAKnBupCSjqM9YJ84qH5WKVEPodeEpA8woFGTVTjk7WMnBwb
28436	payment	2134	2134	1874	1	1	2554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWd4QbFTF7S1uYptMqqnfFW61xjaUiLqyrpvwWgVyBZqJ6TtqE
28437	payment	2133	2133	1874	1	1	2116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwEPaTRgW9gWTiAyJBdzB5BpWxBusvkzDiNCZZJn4NkJEqGJ6
28502	payment	1397	1397	1678	1	1	11725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xMkxJwWRPFFrcbVog57uR1VS9QECLWAZ6A1fGf2MYpGxrFqa
28503	payment	2134	2134	1874	1	1	2573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRW8fqh56cmcyiWuNtvGNF6m2UYvd7iuhE9j7bzWMz4JXFHtjb
28504	payment	2133	2133	1874	1	1	2135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuk3pKTNLBWaF9HGRg9yNygLh6zHzkeSAuaHtNTA1bx14S4FNd
28505	payment	2132	2132	1874	1	1	734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAp7U1vYAQPJL8pVPFtKQzRpaiGBZ2u5XR7hmKBrE7bidmzQ1q
28512	payment	1397	1397	1678	1	1	11728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnBqqnpRZNJjERfhPZ41ybe8TFK5kErBPqfkv8rKZpEJeRJHh
28513	payment	1397	1397	1678	1	1	11729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX216mUHMtZZJrJ5LxJnyJax5jwEaYQTC3TTn1yTsxQYvPX8Cd
28514	payment	2132	2132	1874	1	1	735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58BmXNxkD6FwZs4HVmoKC1fyA5gW7rsiijcPDJCMZ74EFgfV7
28515	payment	2134	2134	1874	1	1	2576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwENHPUT3dteg5D5nSugfJEu9fuFLhSwHJdLRKLtXbmotygQaF
28516	payment	2133	2133	1874	1	1	2138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfXcdxFUuWMD4CWCtu28hRtXrTDdqq5a5whMMpnoKRh2Vjdws
28517	payment	2133	2133	1874	1	1	2139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkPn4QuSmF7TuhkZTaQc6a57cnjCQiVgSscUWeo8VV8tMRM6x
28518	payment	2134	2134	1874	1	1	2577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDHxquQeZmUmR5xNcxSemPqk86HqFjdftEtP96BtyGWhQKZuv
28538	payment	1397	1397	1678	1	1	11736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgWCthcYyji1qsdNNypXjzhiCDkphUEKX3Yk3USE58DqwepWaU
28539	payment	1397	1397	1678	1	1	11737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpU7ntSWyjZ1JbbgXJrFXYWo349FwYWZ7G4LXGyKTVMmZh6sV
28540	payment	2133	2133	1874	1	1	2146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyc3pG8vTSZbLZfuDne67PzhzNrHwNjqbptEfR9T7MXxajmbt
28541	payment	2134	2134	1874	1	1	2583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEus3fxQeK9wjSkQUAqiaSEse8m99rrjiVJTVKFRkHi3pH3yTn
28542	payment	2134	2134	1874	1	1	2584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6Mufjh3XxJx547J7JzWmcWZPdhkJLz2r8KeQjWxwynYrvKJG
28543	payment	2133	2133	1874	1	1	2147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDN2bzHRzyzo1E5DqzrsM1RJm6hb88DgYWPzdMWogUpne33wS3
28557	payment	1397	1397	1678	1	1	11740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZMKeBcunDdNbbKa5p1wuY8jvy62bASYgFTMqTVqzuVAwAMAT
28558	payment	606	606	2238	1	1	13	1000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQA8u4GYye3ZfPHcZGWscVb58Pqn4AFniPexzWNcxeF92oXRj2
28559	payment	2133	2133	1874	1	1	2151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPD3j3ghXNPHa4dJUJMNzoCV1nzuiZDMTbyYKmX4KajjcP9Sy
28560	payment	2134	2134	1874	1	1	2588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BippQqNb6RRXnJjN3Nf7JFQR5jf9UeScTYSTszRmsjxgiYXt
28561	payment	2132	2132	1874	1	1	739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKesoxPTBbcKgQuMA1875Gkwz1qRK3eQeK8yEgKM4NKstLKAVB
28619	payment	1397	1397	1678	1	1	11754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqBJz5HeaFodk9YnGfLXj7SXDWvu3RnSLnREFh85a64Xx7qpB
28620	payment	2132	2132	1874	1	1	743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4hFo817LrhpV5QMg8msSdsP76ZaBZrvTL7HhXjPFJB1WAS9C
28447	payment	1571	1571	38	1	1	36	47944808776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZoCtYU8mC3aiq4d898t2JyTYeqMLvwirsTZR51sS9W59QRsCTf
28448	payment	1571	1571	969	1	1	37	364722301792	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYi7Ah1wo5WRmjaGxbZGBounDuVCgPPqTd7utKuUtHiYhDzAGqH
28449	payment	1397	1397	1678	1	1	11711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXKheAipzGVkAnqxx1vDtNwwxtp1fEmriFqNjmWinHzqQtujA
28450	payment	1571	1571	1089	1	1	38	653579239872	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa5XsC5HBEYyqn5pnSzJneob5h7AgiiEuXS6RT5Fvbw87j7YmKc
28451	payment	1571	1571	1209	1	1	39	440982936628	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZMvuKW3sVuZvVt8bcfjuJg67fPTukwhJVVT8bMiPwt2pedgfwo
28452	payment	1571	1571	1335	1	1	40	1228838162928	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaHrJgfJswn8tEJ4Y1S6T7gW3fyHKYSQVbcd4iQgVj4Cj9h6Jai
28453	payment	2133	2133	1874	1	1	2119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n8JL8nCHPgf9kfkFM16PshRbznyYCgeaGMcJHcEtLdTEfYNU
28454	payment	2134	2134	1874	1	1	2557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9m4pXzXQ9u7HDkk8dHCukFpFjKDdJjBtvGVMgf2EiM5qESAo
28455	payment	2134	2134	1874	1	1	2558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2j5uneNmm5sfuiZpvjvG9wMWyhXHNbUknQpsNcSMbQYYzqHy
28456	payment	2134	2134	1874	1	1	2559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ887fWJ6YBwXytbMsp3H3SGjYut8yFo1iKDYQepugYShWxYaAD
28457	payment	2132	2132	1874	1	1	730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYJciAjSbfgnjYdREE8bDpTrxWiLtbRWyyo32giFjpsD7dcWJ
28458	payment	2133	2133	1874	1	1	2120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEBimf5QdGGUfGRy3Q3teKn3rGHwoUuYW1ZN6TcGUFV1tjM7J
28459	payment	2133	2133	1874	1	1	2121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhDrVbagYRsW9vaBcYHcnzLnERUdPUkNdxS6co5mwakrp8TNm
28460	payment	1397	1397	1678	1	1	11712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLxkAYhXtYQ6Lb2RMWS1G16VMq8Si3iHKrCbco2J1pYDbnm5s
28461	payment	2133	2133	1874	1	1	2122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5892S1VpztTB5mSaTpZiDRKEFMd3ThPgSrZpQdAwfJurpGXnp
28462	payment	2134	2134	1874	1	1	2560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNrjzGPrtkAeePxaAYnBAknT8svwvBZ3cTCaS4ceGEkvht28R
28463	payment	1397	1397	1678	1	1	11713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXy5bZRtFahV8Du4i2wA1y84tJiWYRp2xXByrFrGHtzyTwjeoP
28464	payment	1397	1397	1678	1	1	11714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHYSDaEZ3kxUTrDKjNgQFaDU2SSF5pRwgowBoxdKfyCB8MCuq
28465	payment	1397	1397	1678	1	1	11715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rw7Q6juS9ENsqe7zCViC3oPgvMNnLcD12twJsgQmmF3fjbAT
28466	payment	2132	2132	1874	1	1	731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhuS6UMnu1t6txbd2LUHRYYyWokyMmgsR3WrkdirzvCDxEavb
28467	payment	2133	2133	1874	1	1	2123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvGgKCF4xk2DQR1Fj8tQrPQhgvA2mu32stRofkEMK1gGEcbaL
28468	payment	2133	2133	1874	1	1	2124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMXu6dCDjYD2RAaPVNvsfG8dmnKkxHxPQZYdGjqFpFMdDzMJy
28469	payment	2133	2133	1874	1	1	2125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd29ySDezyFeVGDJWBWTTpwmkuiAhXt9aQYxZBw6h6VrL3G4ZC
28470	payment	2134	2134	1874	1	1	2561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwvK29uDjR6aju6ZL5M371K8cThKWLLyB3vRqaS7bM4pXN83H
28471	payment	2134	2134	1874	1	1	2562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNoNamtGcwF1FKKE9YqcPxJgMefJEENFRLhAX2Vn4EuEnVouA
28472	payment	2134	2134	1874	1	1	2563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RKAL8CnvDoc8RaUZbTvZo15aaUJpm4j7upV5sRv4322jLTLQ
28473	payment	1397	1397	1678	1	1	11716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTDRoevmRaERQkSziUQEMnMkn5yPKwqw2WuU4vaLhJ9SL7kBC
28474	payment	1397	1397	1678	1	1	11717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHy9TFBb5GWV8xjpM5HUvL5xvrW2VTaqxD6YrRVE8YgrFX7huJ
28475	payment	1397	1397	1678	1	1	11718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTybg7pGjAmFvk3SPMphLHjZvyFbSLFiEuLJRqoYyFRce6NkkT
28476	payment	1397	1397	1678	1	1	11719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfkCqbKuFLhUrWJLtqz4XBpvbDQwejcDaLqoxYiLfX6QpGNEM
28477	payment	2133	2133	1874	1	1	2126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGi8RAvC4WUvHqfEUdTWFEVKiuCm6AjMQV8xQoNWPDeAxrPDo
28478	payment	2134	2134	1874	1	1	2564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdT8DzmZvEyHEkG4iVaXrovsTb2LK3nYrdodhfnUac6A3yE9Dx
28479	payment	2134	2134	1874	1	1	2565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4PbqZaKME3ugyPsDewteBRYFQNktmf5nXAH8Mha7TGeVXs9S
28480	payment	2134	2134	1874	1	1	2566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNR71UJaGduRoJUpAAkSRz4EFUt6xXBmDSLZVKnHRg2v1zaJT
28481	payment	2134	2134	1874	1	1	2567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5byq7MbjJZLy9TBaJspKrYQSYoVC8Dh8Zy292S7J5KoTGfavJ
28482	payment	2133	2133	1874	1	1	2127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKcgJdj6PVrnnTqHtztDDxrKMTXCRxgBu6TTYyGF61t1RvvVN
28483	payment	2133	2133	1874	1	1	2128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxUKyGkdk6mNHobCQpffMXTNQdBbAtCQgX9msUGUPVeS8787S
28484	payment	2133	2133	1874	1	1	2129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVB6ajoQjV91VyUTaM1318CEEnHMt7xqHj8EhU6vop6vB6yBMc
28485	payment	2132	2132	1874	1	1	732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNndhckbca67rSKNCHDLjXWPdJMUnyu8mDnAPfMaTe3fi2Ncg
28486	payment	1397	1397	1678	1	1	11720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegHHx1LStAyKg7arTrW6ozN6TXRUM7yQiRgkL7ctkHV13EcHr
28487	payment	2134	2134	1874	1	1	2568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwg7nWsmrYQXcDgumJQSivdhjJ9T9K5Zj6ioH3Vgdb3fYFDE1h
28488	payment	2133	2133	1874	1	1	2130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVftTZRWeQWFLvMNEKZ8sZVzUYS8aqutrYZt47BKMbsr91wup
28522	payment	1397	1397	1678	1	1	11731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzZAAFFo3GfCjKe93mFssqBN1sN44rzihbAawcVvgCnzspDa3
28523	payment	1397	1397	1678	1	1	11732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FVFEBxjYYKY97hnAXJr1i2wLzN1EaAjurjCtrbMxZkkxn22g
28524	payment	2133	2133	1874	1	1	2141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFCKd1tKkvUaWeqxAhJcHWeonoVG34MBeGDkPpv3KfGA6hP6t
28525	payment	2132	2132	1874	1	1	736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGVzeZcoacSnM8xctmi4fXX4vzY2GtkQsFhiAGSyy3vSgojHp
28526	payment	2134	2134	1874	1	1	2579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzHvQYEVxbwndszH7mWt6iDdBB8Ky5STLBUnzishmL2xjYXHA
28527	payment	2134	2134	1874	1	1	2580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVWWCifgP8h5BXxcMVdv9QUii5j3g4re7aYgFoeKtT2oatj3Z
28528	payment	2133	2133	1874	1	1	2142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWUfLh5qYUnEnPeompoUAMd7gvxVCw1dbtyUP2FR32exfZcYX
28529	payment	1397	1397	1678	1	1	11733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmwZzEPQcaD7ni3H3VjoesKPpj8QhdF1BL1B1RX4c6hpMJnKc
28530	payment	1397	1397	1678	1	1	11734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89vcJ7S7W8ot88BQ31WF35Lha4QXSk2zC21QwikD9XZxZfTew
28531	payment	1397	1397	1678	1	1	11735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkVdi1C8ueqaRcECkW1mqnszs6DEmw48C6GpBfRwX8LR3bEm5
28532	payment	2132	2132	1874	1	1	737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbgraLe3iadDkYyBCjJoMeL1bVDQMHvPkchqQShu82awWfkJ7
28533	payment	2134	2134	1874	1	1	2581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1khHwBPRmwPUo5FYkzMq8zvKMLj3W5ev3WBo4P46QrrgCqbT
28534	payment	2134	2134	1874	1	1	2582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyNDUtyTcQtx4N4kRokNUftrgdao7rDZp9usk7epwDzc6GyBS
28535	payment	2133	2133	1874	1	1	2143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7WNQkeUXwrmaGX39gFYhpLeoBE1U4kBF4hutd7yx2gRZ5916
28536	payment	2133	2133	1874	1	1	2144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4qzbgfXULQzzW9vrDWEhwb5xbynAVZs5QCK4m5BXTqCBFNW4
28537	payment	2133	2133	1874	1	1	2145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7ooGywBvzC76KUzuCCUnQKNd58GE3obSSji5sjeBQd3uubJg
28554	payment	2133	2133	1874	1	1	2150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3wFAjbLU2GmAvw4PArcAgrwid7Y9pkxJLrT5phM83xpvax1F
28555	payment	2238	2238	606	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3RqJZ5otf2stCBLvG9gPKZ2xm7zYDvC13GRxVLDQ3kN4YTHg
28556	payment	2134	2134	1874	1	1	2587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa997sNzxLokzDJL6PmZ6tYkD4F3VS5KS3SYZj9HHWt2ASjYANf
28580	payment	1670	1670	1036	1	1	7	5157000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4K1yhYrPgeoZ6QQ3jM9xRkVL2yZSCXwDXLfnaVKfuGH5D8HCx
28581	payment	1594	1594	1985	1	1	5	1103000000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpYUGmHNMAjqiaDtNG4NaD5km9uyNfWoC2VKdZJL1DUZtKwnbuo9
28582	payment	1397	1397	1678	1	1	11746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJYh9iZobdyfGwisPNRaJWX8YkkvE78Bm8o4cSBB7a9Zp2WKY
28583	payment	2134	2134	1874	1	1	2594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotfrgzELVEsb7Qz95T5ABe27PaEHMNRgiLDa5SfzDy7PmidSY
28584	payment	2133	2133	1874	1	1	2157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6srynHsw5dSRZXn5EXGSsX6a5TMExSQmusBLUszRPPRa85iD
28585	payment	1670	1670	1156	1	1	8	3480000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1b1CbBjgGB3kcBudRn66tbv4RGpNQLTb1asxifLeNzYtu8Hy
28586	payment	1397	1397	1678	1	1	11747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXSBudtubxwjCVFqbdFrhnVQf3hpJ1xaWf1VRSGuNuvA6FjWL
28587	payment	2134	2134	1874	1	1	2595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjLRr36j2SEZj5VQexD3PF6iwFUMnqpYAVCYYGAqwceHBVoyd
28588	payment	2133	2133	1874	1	1	2158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuoVa838dWzaK73Wwcwt4utB9YbpTC9RqDYMhsemxZnQtqohj
28589	payment	2132	2132	1874	1	1	741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLVk6XeyS9inUmz5LWjEoFvFUSchF4RhpftQ4cmw2ASvB9FCy
28616	payment	1397	1397	1678	1	1	11753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJvXXxVJc7ovNrtaEXE6kTmRAhaqTR8wF3WhuHXSf2nqPhdfg
28617	payment	2134	2134	1874	1	1	2600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnWS6bVUWVWxXNUH5sdYAfYF87cVw1GxmpRg3V3eb7G3A76Bb
28618	payment	2133	2133	1874	1	1	2164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HJG9UWnL21PWb1xmVQ8z8fXw6Z9aYm2HdxNB4YjH73ERgRv6
28654	payment	1397	1397	1678	1	1	11761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3sB3bpyobBUSEVMzvDx3oDwyXHcYH5ZR5amU35PLbSdGt5oa
28655	payment	2133	2133	1874	1	1	2172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwy45fC1Kf2xcp9idaNcmJVbx52JvxitZyxuskqwLqWGVykZu
28495	payment	2133	2133	1874	1	1	2132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPCxxqMVdDniQxwokXagREASNo49dcbLEsfxHGvWxe5XRn45h
28519	payment	1397	1397	1678	1	1	11730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9PR5z9tHEAQgd6qj16s3zusJ8bqqP5LfoUzAdVAMJxCsMmAS
28520	payment	2134	2134	1874	1	1	2578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3Lt2AB9Ng77uBadoDrkwyTfsSYnY8Gv7Dop4SYhKHa3YUQmo
28521	payment	2133	2133	1874	1	1	2140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvxmpZMuZ51TYeG7AHek2mveLaMbdsHkuPrWekwwXUrEsjm8u
28544	payment	1397	1397	1678	1	1	11738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxPaVRLaV7QyC7KioGGSurqtjUYvDaSJoNZdtmZXvu7eUp2RM
28545	payment	606	606	2238	1	1	12	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBz91ccwsZbMet7qEeGC4qbMqvhhLva4BNjeuDzwT65VCbnKs
28546	payment	2134	2134	1874	1	1	2585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwytg6mZvhaLrPqDnKiwScxkpu3EPoJM4Utk9t7c2GuSGhrC4
28547	payment	1709	1709	1979	1	1	7	14400211999976	1000000	\N	E4YvmjpxdAWTfw4rxTCWcgVUSFrEooSJgByrHU9XwoM989GCRAVm7	CkpZM5TXmmPALtiA8opkQmqo2QZUZv1o5pEbVKnpy5uzwXffFa16g
28548	payment	2132	2132	1874	1	1	738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeN4Fdn2ypVfeF6RowWn8bzjbJCTMc4UkfbVBCWKQSJfNMVKV
28549	payment	2133	2133	1874	1	1	2148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2rTCLYgbdn6fi83ppt7aMzkCpgjK66BTfRM3S6qVJVPGqjA2
28562	payment	1397	1397	1678	1	1	11741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJTXHxoFmZ9zoSPs9pKR2QxS6KhbS4M47NBhtVzhPKawgUMPy
28563	payment	2133	2133	1874	1	1	2152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsHJyecWySHmt6TKCtVU8e5TDJ57dtQ7M7XG7wuPPTETBdDrV
28564	payment	2134	2134	1874	1	1	2589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLw1cEqzfTmCbSz8cMxXxAwb5Cuf4vBTgis2EUtWjNtFvvZjt
28565	payment	1670	1670	1282	1	1	6	9695000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybhWq1gZv27ZaYoLpnYdLHjozWUzrktbbpCam22X45fC2bV7g
28566	payment	1397	1397	1678	1	1	11742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKq3LTaPztHVTCpm9rniMy3XC96FNM8qbSfkNZd9kT9Lsxk2k
28567	payment	1397	1397	1678	1	1	11743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD13f2zKbmQeoTgmjQRsoUsWmPxyKbTGbtJemDptdDzGPCVFEB
28568	payment	1397	1397	1678	1	1	11744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjk4E7sBYUBPd4Wwjs6JWSiu2RsfMgaKx2mzcdbKPw8C2hQxm
28569	payment	2132	2132	1874	1	1	740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSDsz7JccCjx6ok5bMutPSz6MbiuZ1HJa24YhJjydT1WxJhnz
28570	delegation	2238	2238	606	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGoKJYDD1WazzZLLFVMmEdywfmwJeqmJgUPnACdxnQrLbRA8V
28571	payment	2134	2134	1874	1	1	2590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBqxz5gfk5aVj5pncxPdaQBrRZpfB3SP7f7H9oqPJyUnwr47Z
28572	payment	2133	2133	1874	1	1	2153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjTecG17BXVxmWogpSz3EPRYtxpZTS2f8BKM5Yd3yA4uYP5z9
28573	payment	2133	2133	1874	1	1	2154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCH9v8cJ6rsHdk4rekbD5mQVdFnuhowm8GgyxaKv7ejBLUxmWn
28574	payment	2133	2133	1874	1	1	2155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadfmbRv9TjRSetox4dDNFE9xPRPoX7CG2PGfaUNhAuyTJzqvo
28575	payment	2134	2134	1874	1	1	2591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKMk3HpnqmemczqJ1k2QYhFU6h9dWNLtpi9fF1PijMPUiFVGy
28576	payment	2134	2134	1874	1	1	2592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUifHGjGfHennbwFfo8BTN7XV4bU1BC1FNjc7xULfAa2E7y5vh
28577	payment	1397	1397	1678	1	1	11745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwAeVnDZiRhZxbXEt4JXSsExEw8bBXMXx7J7Jr7iY7xKTS8TL
28578	payment	2134	2134	1874	1	1	2593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAtCZZdPLRdUUpktFoq7znTNmZUPofr89MYx1Gftqr5AFJpcp
28579	payment	2133	2133	1874	1	1	2156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2Qh9FnEPhd5t6EpiDAmXMNzYoLXn68Pvf5TJjk4yqZdCixF7
28590	payment	1397	1397	1678	1	1	11748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeymWjQ5nyYeocNn4723fxHcpQ38pEGxZr8bSDHYmy6YkgfpCs
28591	payment	1594	1594	1326	1	1	6	7680240000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpZTguoASPWmZJ551bo6JPHSJp3xSJZa1uCd4phTZ65xjGRGKABY
28592	payment	1594	1594	1200	1	1	7	2756150000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	Ckpa8eVAcbvZ8NqQjemMGjs31Afx9nPVGtaNzirBHu6WEc7qhuvXd
28593	payment	2134	2134	1874	1	1	2596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLkFKyPJVUbNWVbWjXiDarZLTizSy8aYBqXG8btK7xVxCzPyW
28594	payment	2133	2133	1874	1	1	2159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ1zm9GTZPmWyg6W8swnZEqWkCqdLnEwKomj6amx6NMVkJiv8
28595	payment	1670	1670	916	1	1	9	2878000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj25YTxwosQUW32YCnsR1gXc51v1597TdPNdDm9xDof7PcjmSB
28596	payment	1594	1594	1080	1	1	8	4084880000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpYkrLaVS1A5qM19Lx2wGk6jSknGw8zqFnNqW9qpnrS3bivb44UZ
28597	payment	1397	1397	1678	1	1	11749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGNKqGGi1GZzSmaDXaDY27tQkix6HdtYaG6mXK5qNACnc9tpJ
28598	payment	2134	2134	1874	1	1	2597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHgA5Bc4ScFL41rmcgBSe77VpqBCt3RNBHjaENdLwnzYYTJ4i
28599	payment	2133	2133	1874	1	1	2160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirssxK2NtRXp1aSeWNdtJBGhj5YYhvSUfxTjoj5kHmmwjB3fm
28600	payment	1670	1670	1977	1	1	10	1110000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJAoxwpWSDKzDm2YM8XeBWzcyARaD4UmkwaydSTNSuaLSVq4E
28601	payment	1397	1397	1678	1	1	11750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PcuwrxXZuiCab6Dso7LjqiRfQxnFcdgdsgAQLF5AnRx6M1AF
28602	payment	1979	1979	1776	1	1	9	238757449881	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZWTey3ewkKNMh5FvbRF3MfYCmwLeJS5ZpArSuZ1VkxJpedsoHv
28603	payment	1594	1594	960	1	1	9	2279520000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpZeb5pXV9wihusNBLuoEH2nzeBXGKe5mPYU8PJ2NKL5Ps8YVzAS
28604	payment	1397	1397	1678	1	1	11751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDQGUT5jYLrBpSeacAL2PKPQTcVKdXi6a76zyv6F7owwU18fN
28605	payment	1716	1716	950	1	1	4	2461900000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jZeJwxixPEgX519UThohNYrubgysFu2Pb38Gzgs6rgKJd2qt
28606	payment	2134	2134	1874	1	1	2598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEZgjLDt8wv91RdupkNZsieMf9DLa9WVPBxt8e4Y3jWSYLWig
28607	payment	2132	2132	1874	1	1	742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5n373KhDtyX31W3Je3MwsnarsurLJGSRBMaSybNRF8oAU5HM
28608	payment	2133	2133	1874	1	1	2161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC57bmrkYy8VXzgDuvRDrpBqD1v7R4n9gQRbr7ftPaV6YYTrvK
28609	payment	2133	2133	1874	1	1	2162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwXqFTsdTerDnRZBEyNUVeAr6pTKEqsn5t2PWwkZVZeLZSpje
28641	payment	1979	1979	1776	1	1	10	36175371012	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ7PAydKQS99FVcXQ6BqT1EBf5X7gmtfi6LYuoVwBcbpJjyWksF
28642	payment	1979	1979	931	1	1	11	1818817266997	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZqPmV3gbPJAtXb3ZaQNvcNupbFqK4hyVg6sJsZ5JuFAsZS8FKJ
28643	payment	1979	1979	1051	1	1	12	3259304959497	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZin4f468HBiBKEurkmGmhKDNGZdLKtVJpFReci6vrQNRRx6JKD
28644	payment	1979	1979	1171	1	1	13	2199118001210	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ2Bgx7TkX4GbHATcfere8t4NoL2gEuezfuZ9EVLRKDxtnyjaAu
28645	payment	1979	1979	1297	1	1	14	6128037848523	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ3p9mnaS7hSjGmABVn3GDA8D87aqsQ878DuoYpaw2rqZm8F8uM
28646	payment	1979	1979	1776	1	1	15	718941102856	10000000	\N	E4YrZixM92Xxfea6ZwvAF9pcWjs33DttyW6bhC1nxiGLqknyXSqMx	CkpZWLpWwhKn8quVv1nbCAAnssQKec4mXZPmKy2RpBRaR6K3vCaMu
28647	payment	1397	1397	1678	1	1	11759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiBfGHQfgbNzDhY89qXPFiVLY3GsDJkeooqEgrS3RuhhNAT46
28648	payment	2133	2133	1874	1	1	2170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFkZPuz6h4LndcY1TN7oeRjyiH6rhXGy99QPf5JspurgSfNAc
28649	payment	2134	2134	1874	1	1	2606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1wLrNNS5LaAv67NiPpSNGk3fVHfecc5hrqdrQ21UPmnLFofA
28673	payment	1455	1455	1332	1	1	9	5004000000000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4yuUxjnTBdrBBohKPuEsMzi1XyMba9QswgpAz2hcSFLEh7Mw
28674	payment	1397	1397	1678	1	1	11766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeboeYTmDcDJmdTv4RRibGRmeF5ABLDrqdWxw46ghY7wKc4e6
28675	payment	353	353	2213	1	1	2	650042116779	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZHBZEKwqFQiWKvgpRpVYdbwwP3adY3ha6QzxZgYCYGyg9rr6
28676	payment	2133	2133	1874	1	1	2178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9JrSpqKGx8Jd93YQUZjV9QWrFdpqQym5sQbzPMAULrcPeo75
28677	payment	2132	2132	1874	1	1	747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy88qzVF4Bb6WtzKvA4iPwgqJEZgRr8vX7QB9Z6zKNb1ssvDtr
28678	payment	1397	1397	1678	1	1	11767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjowmZVMLJ79xJ9Ximp64AMo5ctynHh8PBpWQtfcr1qExBM7nd
28679	payment	2133	2133	1874	1	1	2179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyw6qLni3tjtcxc2TAGLZ9v6WmoUNgjtYns6sUKsuie6e1nVp
28680	payment	2134	2134	1874	1	1	2614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrHacQ4RiASWCz6yEMUU8YqzJCkE6eFH8K6RZXyevcDaSpm8y
28698	payment	1397	1397	1678	1	1	11773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXC6GyWFDYkUMhGT3Qz6Lj7ku9eJVGyDK4dPXgh2g8Un5Uwh9i
28699	payment	2134	2134	1874	1	1	2620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSARkkUP8UxAmHRkZLLr7A1ChxYCFGy9vsSvbhtd4rGcNfJ85
28700	payment	2133	2133	1874	1	1	2185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkXjk9cEn5akQjXsW5G1fKkjLwx9KLnXXpbXkK3PsbHM9PYNw
28701	payment	2132	2132	1874	1	1	749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwNV8r3iaTzoysxLTroTvq3fCTfFK4x5n2eFLbueXkoThN89r
28740	payment	1397	1397	1678	1	1	11777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5C151JhnGcqrWoT6PW2MfDw4DYZcnt1SqcNacyvsbbT626ZU
28741	delegation	2119	2119	1672	1	1	3	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ6MFCNuneHNy1ZQDARgNjRLbs7hpWA64C6SrQbfxHdK2PwnyZC
28742	payment	2133	2133	1874	1	1	2189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE73CUJt7kwDMotWKz3rRGpVhEnCwfpmEXz9rBXsKaGUYieeb9
28743	payment	1397	1397	1678	1	1	11778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8N7nRPy5ZgxRM1TpSjEdhuU1m9jaD4ruaQP9yCzS36Jo7FDoA
28744	payment	2133	2133	1874	1	1	2190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZePLSDKeSMCdncazeiNfSF2b7FinK7BxtmUhLyEACUKDGe2x8
28745	payment	2134	2134	1874	1	1	2624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBv7GuhWVGg23XF9viz4FQyF7Bc2DFRft4DPcPniTzgp2N7mvW
28775	payment	1397	1397	1678	1	1	11786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTjDkAUDUgqdDcSzvUS6e1BEvEcS8cSiitHyaHBsshAvLY1Da
28621	payment	2134	2134	1874	1	1	2601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjkgKt4qqnK5KoH2bVD3GBmv4ZBCv3UJjZiq77QrrvoS1TTeX
28622	payment	2133	2133	1874	1	1	2165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwEuTBYzV3Zhq9M79Fz8YNQzX6E9Jf8hUufWHdp6w5hL7AhBZ
28623	payment	1397	1397	1678	1	1	11755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtB3sTRsgpt8AF7N8EF4d7JpbsgKrak1EaQcrmgQtpBszrWn7D
28624	payment	1716	1716	2239	1	1	8	2781956000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtgNtonNSHRNXyUemJvAMMPLxyb45nKaHjRwjAhzmTn616zCd
28625	payment	2133	2133	1874	1	1	2166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTWjTQ7QnUsBVTcwFq3gPpZkJZHVkN6KfjLNA8V1a7Kcma45R
28626	payment	2134	2134	1874	1	1	2602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DxAGgj5CgktWVqERbeUDzkreQdYKzUfmx295Gqpj1kzHfEwL
28631	payment	1397	1397	1678	1	1	11757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXncTvtwSfkQ8NczPQxM2CtoHhdhhnGXjAnW3XPJbRVB7jzD5R
28632	payment	1397	1397	1678	1	1	11758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cc2L8kqKjW48KsfUAZySHwSZQgBQge7QwK2zvP3jqkRaSPkZ
28633	payment	1726	1726	2241	1	1	8247	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDAWbX5LdMLZevEiy2KPDsuuFdxxyyLzUdpc8h1pRHAbJTgHXN
28634	payment	2133	2133	1874	1	1	2168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCc1hrXc5o2PZGbJf7QiXoD2fFipgEaYqJk4nvuTDG3e9idD3
28635	payment	2133	2133	1874	1	1	2169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwDQttmj2U4b9tpAvyLZjMHVjtgci1bKH638NeGaQvSrQ1kq
28636	payment	2134	2134	1874	1	1	2604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrA8ThMj81HvvA2FvH5puVHtzjJxq59PNHQ8AHTnjWbGLCFsE
28637	payment	2134	2134	1874	1	1	2605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEuDM9DUv8EWx2KvjKFxwk9rAiQEors7KdrMPRe2Z4RDwcB8Y
28638	payment	2132	2132	1874	1	1	744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7mwq9ES8w33hFTQKyrUz1Pi1dKNTfukxhAKez5KmXQSmLmAW
28639	payment	1726	1726	2242	1	1	8248	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaH2bWezh7oZUwGyEvdWEhxpcfDtazHe8YDxcD6dKJNKCzknWcq
28640	payment	1726	1726	2243	1	1	8249	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvzaWE3GVuXjnJmMDQViWYGdgn2tWYyUGAuFaSpUMcGXBBKR4T
28659	payment	1397	1397	1678	1	1	11762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1RtM6Y9wHpmb9THwQD7p8yHVxBRTcFSACjj1EJVK1Txoixct
28660	payment	2133	2133	1874	1	1	2174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6CDrCvK83gW6k5K25Mkw1kQ3uuCnyvyhqqrGHkWKeK1Md2T7
28661	payment	2134	2134	1874	1	1	2610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHx99egsmbR2nEQQwNr53V2dxiMegyN3n1PhrLJ9etteDKmBP
28662	payment	1726	1726	2244	1	1	8250	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgLgAyYifyhncT4qdR1D7vYSE17APuMJbBNG51CXYDCQE4opw9
28670	payment	1397	1397	1678	1	1	11765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMkkBiYwi3Zzoi792dujLCVAdg66P7AYV3bZ4SbU7WnqHczje
28671	payment	2133	2133	1874	1	1	2177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGLjCoeNPqfCH2dXgDpaqA41xF2uCy4CA2Nff2DZgT7BThK77
28672	payment	2134	2134	1874	1	1	2613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuC3beM5XwaREGSUmKJStuvsLZkf9RYiZEkWvAJm2oT2hA4WE
28684	payment	1397	1397	1678	1	1	11769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgV3t71Ff2Qdf6CfT7MNYDTBNqksfEkheG4udoqStUeLfVNfPa
28685	payment	2134	2134	1874	1	1	2616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamdqtJUgQSqLnu2U4rHnyxvQoQeXt7pAxrMUfM3UtyQr9WZTe
28686	delegation	2119	2119	1483	1	1	2	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZAvGg3hvmQah4YmrUC4r6u1WcMLwKq9bXjn4nijjK5v2JHNMit
28687	payment	2133	2133	1874	1	1	2181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8r5vJMtreND8Xi8Y4EUyS98bQos9NA6gYtgNnc1fhkMRSuFV
28702	payment	1397	1397	1678	1	1	11774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRoHq5bQHyuZhRzL5oHpHmCYn8KSyUjivSUAD7oUWiLpygVxu
28703	payment	1694	1694	21	1	1	34	128580863891	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaLAM35NqNBPcxpjfhVReLdXbV2o3BY9uwmNESBRyQTjvVbQy6m
28704	payment	1694	1694	52	1	1	35	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ28HMTSjrhGaUxmLah5XU6SbcQh1vZBJdXmnUATtuh3izFbaNq
28705	payment	1694	1694	57	1	1	36	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ2zm3ghFDoct13J3CdQWQZyvzwFt8AgJMGTCYd89SrmdAvkp7G
28706	payment	1694	1694	60	1	1	37	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYy1t5LFUG4F5CTqRjiF4qPpzgfPskPfNLsAeGAqwCM2ikS1wU9
28707	payment	1694	1694	61	1	1	38	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaDEem4WsjL8ieCJzcsWcmn17iEHodrmKJHEU5ZdU3ZrFCZkzHB
28708	payment	1694	1694	67	1	1	39	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYjcqU81RBqeF8GY61kvBoSdoCc3diNLF1mKxXhGqoNdrYUyYX8
28709	payment	1694	1694	68	1	1	40	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa9tyjEvEWGLG8nVybwHSMqQYA1orNfu6UVvgYuxRENCP8qqy7L
28710	payment	1694	1694	73	1	1	41	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa8eXoYfxdTKrqh8ybRcEKLAtCJXKpB2scdSFeJEX9VLc94wcj7
28711	payment	1694	1694	81	1	1	42	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYQYfDLwuzA68VKCKnJBRuQrsyMcrGXpfhxFFx6KixXNb9kXLMy
28712	payment	1694	1694	129	1	1	43	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZhm8EPFL4G1dtD7opiEVQPoj2Lri6yansBybv8e6m6ZkinTUxz
28651	payment	2134	2134	1874	1	1	2607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdzhcxcQudpZTLdCj8VBeH3mSJdPYi1nkcwsXWCsrWTL1hTfR
28652	payment	2132	2132	1874	1	1	745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJ5R1zrNs2TPwnnR9aEHSzep7ATJHLik9eNVpma3EptVkoG9r
28653	payment	2133	2133	1874	1	1	2171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR6DN4hkk9dBY3sheM7juPbeTBhtFAyWyTsXU3iLaNfPWsRLw
28667	payment	1397	1397	1678	1	1	11764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuXCvjZYnH6Nnx9LkghGiRuCiXY5ChtYLfxDgN8D8BKBkDXLQ
28668	payment	2133	2133	1874	1	1	2176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUps56Z7aeu1VooVKPB8526jMTUgfHJKVeMZDLpMvjvL2VZjU
28669	payment	2134	2134	1874	1	1	2612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjeAfL1BokzHAKokRvXkVRazTUyN1PGP8rUmFz2bNDKawb2ni
28681	payment	1397	1397	1678	1	1	11768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ37ykuu2t7MUKEYFBiqkBdcwbYnWDbmM9SG9edkMtbi9s8jCK
28682	payment	2133	2133	1874	1	1	2180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5VE7FDoD2fX8zAKyZdm3gZvn3v9p9JBLNVJL2fbrNcrJJqfX
28683	payment	2134	2134	1874	1	1	2615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYCP8QFLiCH56YFfADPNk18E1AHucBB1w5KrsGkmuX1t9Fipj
28736	payment	1397	1397	1678	1	1	11776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NubWRNpNsSEgZCAGmjVku4Rpbnrx3JosiczLCbiJW6PvJu9F
28737	payment	2132	2132	1874	1	1	750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMpCnkPdVPQGMs3CbAaCinBPfuLnA6AJRTYdSLmUSv7ryNJjM
28738	payment	2134	2134	1874	1	1	2623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM4A2zMC9RvyBmJ1yMyTDU5LMKccsTq14GfWBtviJuf1AENP1
28739	payment	2133	2133	1874	1	1	2188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCj3JuVjsR2C9ejVkZyh9TFZEsCZxs9S1pCUEjYrtSbUTMfgEG
28789	payment	1397	1397	1678	1	1	11790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3R5pFXbBFiTjLqRqiDs6Jr5ManvAA3qoeVcQX73TSLgvdDsY
28790	payment	2133	2133	1874	1	1	2202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDHfTX7QbNNxTgtRJDW5gHUfY3xpgNiGqVU7vRjLYDYuTJfDx
28791	payment	2134	2134	1874	1	1	2636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtmV18CPpAp98QB6kfXHeMj58hF4m2ymVVLc6DHWUFt2QYgrh
28887	payment	1587	1587	1357	1	1	7	11171270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLeEsLCXrdEgVzEduDpYZ2bGReMQ1uG9CrFYz6LKL5ogybx3y
28888	payment	1397	1397	1678	1	1	11801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26Kor6gp4sxtN3WzMezXnCMEkzv72xJR6WTtrSRXS91zTKBmt
28889	payment	1587	1587	1111	1	1	8	5941640000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq2Ty8JSS1rcth4TVS68LoaG4GZiThuwYYRKcd8r14dgQbAnD
28890	payment	1587	1587	1231	1	1	9	4008940000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAezAkPcLC97meW6k9sW9xfHNr2K1BvLjZksgABjmM8qp9qhX
28891	payment	1587	1587	991	1	1	10	3315670000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1rM3gRuXM1LDjyZZY9HSs1kXRig2heEQcapigx8kuVbP8FHs
28892	payment	1587	1587	272	1	1	11	435250000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqQ3rZyJ9t3Rj4hhoQBDe6v64sqN1RqdZNEm7xE5gJJdAf4de
28893	payment	1587	1587	319	1	1	12	435250000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbbahRis62WkAz8mrkALziog8HapFXGBGMpAvYTppSj4prFeX
28894	payment	1684	1684	637	1	1	116	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa3LTwSio2qjWjThEg7pM4ZWgVAkTGayMTxPKpqM2exya3vYNW9
28895	payment	1684	1684	647	1	1	117	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa1iS4qHWiFbiWQpapeNC2SEMfsH3d5LLwwdSFpV645jCRbyctW
28896	payment	1684	1684	656	1	1	118	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZoM7nw3zkKKSZWkJ6G9xFc4iZGspEoKeztTj192n5XmaTi6cQs
28897	payment	1684	1684	664	1	1	119	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa8jdYpHLcjrdXwMyWRJtEiCHY7TGvHQAR2ju72VBU1Hjy54Rvt
28898	payment	1684	1684	666	1	1	120	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZE7tDYRvs27uUf1XmvXnZk9QxeZ8JU7L21YwYgUtbMwMpvs93x
28899	payment	1684	1684	670	1	1	121	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZydNqx9HCwk19xKfetLejqyGMvjBcY9EGQowF4NyLhgYUHH8Zu
28900	payment	1684	1684	673	1	1	122	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYx2CoAPmeUTfREMRLH5MtaGgffCUrp7QFWSbukDGzBBZwFVmAf
28901	payment	1684	1684	674	1	1	123	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZbC29r3TrYhUoSkya6oKSqmkrTEZD5x7gGEB7n2QtEJVEwFYtU
28902	payment	1684	1684	681	1	1	124	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkVSppX6QsTxuLUf7qE6pQrMpGtYjckdjYTM4KbC6gAwoBN3tS
28903	payment	2132	2132	1874	1	1	754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6v1xkLczdDrCpCqV62DWwigtWf5378YdoxFaWsb4ycSB7HosU
28904	payment	2133	2133	1874	1	1	2212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVF6MPQc3BRCUQi7JLvYH6yNznWbYLoacZvQZCWfA2auVPzk4D
28905	payment	2134	2134	1874	1	1	2646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgra6XYpq8TW5fVvmxAfgjSnLrbCfLuiC4KeL3Cp4PbGJH89u9
28923	payment	1397	1397	1678	1	1	11804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eaXJZHT2dW8n2ejRgnoi3nCFmVQhmMx8bY5e4hQ57YKsD5Vs
28924	payment	2133	2133	1874	1	1	2215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcHVrYvueugu6BeUuXGThT66vNTExfvqQHxJgEShoZBQ5Xi75
28925	payment	2134	2134	1874	1	1	2649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSp2UbD9xpz4zjNmRA46W2RcsX54pVkvdHdGzi225Toec6dkF
28656	payment	2133	2133	1874	1	1	2173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4ZCgJX1hoSmff54ymiyJvFCemti7tGbz87ciJtG399tme9HT
28657	payment	2134	2134	1874	1	1	2608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxCEgpz3yrpJjvsyRKudhpXv6fY8AHJjWSqJpoWk971hK9LEP
28658	payment	2134	2134	1874	1	1	2609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYPpAas4rDhUCGiMFA5c5jN4oWR2uGowvgwwWdWR47MajpAHj
28663	payment	1397	1397	1678	1	1	11763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T1uUaiNMAdDvjYbhreKSy3GbcG9m4P1oNNyyicgMPmfJ6sJX
28664	payment	2134	2134	1874	1	1	2611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULG2RsurUsFu9uPY5w7kjBHv1BdeYyknGajSx3aqtiEaoXWJ9
28665	payment	2133	2133	1874	1	1	2175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8moYuxXQa4XYKnmpJJVDCh73daGyq4gC6Z2ASmLRogfEkPtt
28666	payment	2132	2132	1874	1	1	746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAdBbD3NvZHBvzCg828eET4FQSgwfkNmmxK3ukLq9nym5Hf64
28688	payment	1397	1397	1678	1	1	11770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuS3Fon8J5WcnKyWKsBnMzdDuKasC7hRKQyKKXiYYrZoiugk3
28689	payment	1397	1397	1678	1	1	11771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSff1BavhC7NLmNZGjdbXzkUDEPei3qBVSA8AA2y1JqBJRN8KM
28690	payment	2133	2133	1874	1	1	2182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrhEqfd1Z9sTFeYURDQPwGvV3aCdvsiVDC7CstT5AGzK6e3tz
28691	payment	2133	2133	1874	1	1	2183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKA3JSRemgY559yFKthLnRrmah9LVLK8urafrBipsFqfBVX79
28692	payment	2134	2134	1874	1	1	2617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcj1wVjPFoF8xiLhs2Yau4KbaYjWhC4W8sVk5xpMJEiXggmVrS
28693	payment	2134	2134	1874	1	1	2618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweHUJdQpw1yUzyiVYyU6SQYpCstwJbEYHLg1cMxHZBARX7A3N
28694	payment	2132	2132	1874	1	1	748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHz1o3qVsK7aqbwZEFindwp4o9oJHsz4icT6jCLPhUSBS5gNtL
28695	payment	1397	1397	1678	1	1	11772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUAScgApkZeViSu9WJzZSR3CF3jkTE7shmLpe1nn2xYXUjxGX
28696	payment	2134	2134	1874	1	1	2619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3nYsvc7rWPcmCcVdoJf35Ex9J2GMUPB3hrpJQJ7mmi2qbMqr
28697	payment	2133	2133	1874	1	1	2184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zTW5KsLTHdWLtA1orWce9XJgW31mBo8pxNW1byn2QCuA1dFm
28733	payment	1397	1397	1678	1	1	11775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsePJoDNGcDcQN9ScbdMC5FBgghZmN1mRVtSWkH1bVpcwN7Aq
28734	payment	2134	2134	1874	1	1	2622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVTmK57phsSHCgGmJwnTAR1a6PGEeHxst16RMDAT8PsrBTc8P
28735	payment	2133	2133	1874	1	1	2187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA85HnYh6tFV7xdy7MXyxD91Ey3VExgVyyofpeRbQjhJ56HTy3
28786	payment	1397	1397	1678	1	1	11789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWQ7JxYdtcuLEJgvHKncr7KpDumto9s9YVondwiNP2qCR8PfB
28787	payment	2134	2134	1874	1	1	2635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BNAsjYd7UwU9881zPx9zBhFHv3LRnswuvKnSwh6dAEaihg9u
28788	payment	2133	2133	1874	1	1	2201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAJ3nF5Egpni8k4gkh5AiWsTk6FZJjjegfcs5B2fDAxnmu3Ma
28800	payment	1607	1607	242	1	1	11	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcViZZihKXGMqTXAGxHBRiG8VhoyTVsMchAEzKibbQqgjXGGX5
28801	payment	2112	2112	1222	1	1	0	2121135436180	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9mcoR2MipFjDvf3PbvqLKm2jCpzGZYpJXT7QdhsPjGtxqztf
28802	payment	2112	2112	982	1	1	1	1754320483721	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizhzriNo7B26MUPgJyCoVr1ZEdierY9oQF1nkwc2VkiMvQCDC
28803	payment	1397	1397	1678	1	1	11793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvMzjifKYNUGarTqHpSmWtdM3M1umVJbJGGns8HSwsMFYLohf
28804	payment	1607	1607	372	1	1	12	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4x2QVuT8uukmoyyWZNncyYj9jPAZC7ZoHQDJn6ucWPTyCerY
28805	payment	2134	2134	1874	1	1	2638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCbbW7NCDr3aaiLQNjgMiFot9TVVc9Pi9rj2TACpHUx6NWkFx
28806	payment	2133	2133	1874	1	1	2205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWJypi91tr6moag7Ntm1UpNjHE99W8qhZp7rCGwVVezcJcrqf
28807	payment	2112	2112	271	1	1	2	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiLzyBbpyNGVP5EZYAHZKSEuqaRBr5STQpR8oaXoNnk8B4NqV
28808	payment	2112	2112	269	1	1	3	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99F2SXp771XzGQQSuC9TEZrTrj77ae2oRPuJjAPHag3xvFMnv
28809	payment	2112	2112	577	1	1	4	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvv4asNCNo64duUc9mTLQ5CchP9iESDMJvD36aHbygPrX5KaSZ
28810	payment	1397	1397	1678	1	1	11794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoFjHDjsLzZfP8jWijWpP9cBscGi6QoBz62jLonCY3xv5jMhv
28811	payment	2133	2133	1874	1	1	2206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmdrc4U8VSBv42Y3Gg9hH4Fr6qbhouCSyRhjFCbzYUdu3sWYp
28812	payment	1726	1726	2245	1	1	8251	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwFDvkG3dwpyf9Yd7o5yiX7acqstqzKH4Mzp5sdhx6rzUFAkMd
28813	payment	2134	2134	1874	1	1	2639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXWzTe1PjCWfFq9WoxVry8jzutLmEQC7ikMnyuxgddFn8yBR3
28834	delegation	271	271	271	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpwkbro1DLyzxmwYjH9rYbXiCig7t1urT3e61X8Ysj2zbFw7N
28713	payment	1694	1694	156	1	1	44	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZhPeqyH3JY5PndjSQeH7bEPCsBd8XsKHqagy4sKfUX2pEHD1Qt
28714	payment	1694	1694	164	1	1	45	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa7227zzYAxrnqzinhFDYBZmeZLRASim3TkGR6VvDSHfd16Ehsq
28715	payment	1694	1694	220	1	1	46	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ1q8Tnb7KjPX1e4EWZofkN6dKSMZUoqKRavp8Zz2PSSGzbyosC
28716	payment	1694	1694	222	1	1	47	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa67XbSvesS5vkzca19NtPHT8YPGLHkCzVqSwrv5MB9VSaaWdaR
28717	payment	1694	1694	256	1	1	48	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYv9aSTnPjzs9Z6gRajAyGXBeuTETh46trrP32Nk48pb6iKfKsX
28718	payment	1694	1694	371	1	1	49	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZmGeYV9rzLLsZuJZxHvxZ4w2CoBuDu13AxmyfhvpkdkBLACbAp
28719	payment	1694	1694	428	1	1	50	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZMcuZCsfRfLcyrB7P4B9Ey5GxwcK1ZoQ5eDUEbGNne74zUWaix
28720	payment	1694	1694	431	1	1	51	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa4nWmxAnb3nCcW5HPyhr87GRUiUunDyH6Uu8oqcTvQgm6oWgeS
28721	payment	1694	1694	432	1	1	52	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ26EYwYL1mhWNkNEvN35k245Aqe2RXZfKa1NdPX6js7j712Ro9
28722	payment	1694	1694	433	1	1	53	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZKCtTzmGuLwfqhXnit1skHGvrXEA4iFCNtCfVN9FZ5ogacFWUh
28723	payment	1694	1694	574	1	1	54	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYipnJBbiVEVJyjcWeu2D58kbB9wHjq7MYaoze3GqwQ9RhFX5tj
28724	payment	1694	1694	604	1	1	55	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa3L8yMJASezHNv3M5wsAxByQmyaVmk6w34qrJVxbUne3RKWttf
28725	payment	1694	1694	628	1	1	56	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZS3r3Pxp6qSZxtRcjgCvKycor2P9DQDkV5rqC4xVvJ39fF6Qjr
28726	payment	1694	1694	638	1	1	57	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZpCq1tsRrmdhhENzL5jvDHJ5EPQvD89MqVPfm5Ngqt2eHJVBSE
28727	payment	1694	1694	951	1	1	58	2028511623668	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYiQSvdcoBtSuGnFd4hUxdsJXJ8Js1TAfGGboWNZa91Kt5eoKDV
28728	payment	1694	1694	1071	1	1	59	3634920777822	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZvByhMr9BNMDfJfwtRFCJyVuGaBRJx62hJn88Aq44ULoc62ry1
28729	payment	1694	1694	1191	1	1	60	2452616775776	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ26YRZoijCHZ6Gb1kkFcPT3YfApxzi2aAEv8crdso46375q3FH
28730	payment	1694	1694	1317	1	1	61	6834083260892	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaEEC8F1RkrNdckMY8smfHpmxgMGRsAxX5A8QJpjpkkkcVaPTVx
28731	payment	2134	2134	1874	1	1	2621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYcsEg2m3b92EAUQzqaX52SRzDMcQqPn46tjB9mhj4MFEgeyM
28732	payment	2133	2133	1874	1	1	2186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQNnVveKr87TomtxUXj3Tm3cwEvevKxQMfEerm7CMLWhoUhuu
28746	payment	1397	1397	1678	1	1	11779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhKRPXWF3T6qrcvBL3BitUhzX6rBAbNUgb8dGcySPxsUoy7nV
28747	payment	1397	1397	1678	1	1	11780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqd7ZtVVrXkSzPhnHBw2vdC1wzSN4cs51zq5ZpohcqomnpT94
28748	payment	1397	1397	1678	1	1	11781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMQJMTYkBiyrUb4ZzH6DLo47PesAVtpa5qNsEy6VezhCTTwYf
28749	payment	1397	1397	1678	1	1	11782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCrxWRDC65zXp8BigsgZ2Xi323DeevgJRmVR6dpPQZfdyXkK2
28750	payment	2133	2133	1874	1	1	2191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMZhqigctCkQ9ainAwVGe1SN9JXBRYrJxmwkES8TBo5S55tFB
28751	payment	2134	2134	1874	1	1	2625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZvp1Y57wD9cG2wkrj28ynVJmJXVF1gHzLmr7SfYbnCoTMgQJ
28752	payment	2134	2134	1874	1	1	2626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqe4RSvHHpYLEWWzDe3v8poNtfzcadGYdRx2Qbxv375VA3RKL
28753	payment	2134	2134	1874	1	1	2627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrsDtMEa3D2USdJWxejDoxuMFJD3t9Upfu6G9qS2sgKeySeRN
28754	payment	2134	2134	1874	1	1	2628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjuJvds4onLkCxTBnCRZ4MZy5vusrkmdpZVGht9tH229ZRz8v
28755	payment	2133	2133	1874	1	1	2192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9yo43ox2xERQyXJT5vQH67YGH8fDYQNYbVnAXZVHTJeAGVEY
28756	payment	2133	2133	1874	1	1	2193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHCGZrtqkypMgcaseZZgad7cJhZ7pe6M3fgN9LYKQLyPAxpbT
28757	payment	167	167	1816	1	1	0	0	1000000	\N	E4YxcqkofrmGd6BUTHK1YjKa8sQmT2FXwcsSsK7w2tvdJBa2FGSLo	CkpZQaGY4qQXjoTi1vyMHX2UefsvncMnxAzh7EZnDAzEuEJoKp4e6
28758	payment	2133	2133	1874	1	1	2194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5Us6XWGXv7YFzeou58GuRWue3HpxFKMN5Cnbh6UAkocsNpia
28759	payment	2132	2132	1874	1	1	751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYsXDyp7jVcQY3oXKwrivgd4DgUUY6XkTjaUhAxCbgTXZHPT5
28760	payment	1397	1397	1678	1	1	11783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuGFnEqWUMMhFu8KEevNXL7V5MgxXvcv5i8JFRhBjPxRG7jwo
28761	payment	1397	1397	1678	1	1	11784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtUEKgfkuGkzDeYtwYPSoTKzG1itcpvYDiXNaDh1Ez35cgp23
28762	payment	1397	1397	1678	1	1	11785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3E5GGFVD8xk2ZwZvtD14nHznJLSpD8X9JRb2HAC727mpDpcyW
28763	payment	1689	1689	909	1	1	7	1913777258517	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYvB1wcTrnCeQEA1dkXr9T4dt8y9AohZA2s6WJcUBbJoYQLuYZH
28764	payment	2134	2134	1874	1	1	2629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ257spm3jSBhh55wFRuLmV6G7AhQFeq51U1caHUmo3LJohhGZW
28765	payment	2134	2134	1874	1	1	2630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5vUJXLUDtRG2wQacCgYYRvhz7wEqpahqhb5RjmRew4oGzBjh
28766	payment	1704	1704	581	1	1	1	318000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3a9PWLD9Pc11ZpD645XrWPXkVMXXZGdp7Uisxo7e2E8YENyQx
28767	payment	1704	1704	698	1	1	2	318000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkg53ta6G2GeKwNLw2FADwtzgND9tb5bfLLJoYisprEzKWYLvJ
28768	payment	2134	2134	1874	1	1	2631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJPJTmgfnqQpBec67bz72StFwRXdfK4HEthfY7rYi8M5RMwQd
28769	payment	1704	1704	742	1	1	3	25000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3qWnwRmtzser8biWYkj8S5WCdb6rfDAFnAkcSU75Yqsaj9UL
28770	payment	2133	2133	1874	1	1	2195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoSqZj8Jbm3cycxpTjss46drY2MMHDxPVu2w6pQp8N35cesdg
28771	payment	2133	2133	1874	1	1	2196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2vgiN8gfnbi3fnxkbMJXmFNzMRZv1ZGeXwxUyVazxqpYV7Gk
28772	payment	2133	2133	1874	1	1	2197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsDafCXXeSvgqjGGf9g5LC7nuCVqcPoaszmhgNrRgNLZYfVCD
28773	delegation	2119	2119	1672	1	1	4	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZpMFrJMgFHZ2pMeWeYnyLvgVVGJnR1yWZGcgyW61eKx8Lp9UuB
28774	payment	1689	1689	1029	1	1	8	3429472450019	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZs16p25qqMKURFrTeGSXS8SUCruqBCeACccpiN9Fxeq7XPQyLx
28795	payment	1607	1607	1102	1	1	10	3143727275810	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWgvDd1HfuonF5NiDsuwAho4T3WLQY5bdR6VjpN6prbUz2bxW
28796	payment	1397	1397	1678	1	1	11792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnS2iZDL3qhc6SdwHjn4jrEu8z2b8YtWSjKPgN5nJbcxWtm6MK
28797	payment	2134	2134	1874	1	1	2637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhPEBKpwe5N1TjXvB6vKqwHr6d63bEKtsLEJ85tdaCPQp7wt6
28798	payment	1689	1689	1984	1	1	11	1015330732316	1000000	\N	E4ZAGSXJ4SoaDoWgdpGBmRHywbkvHX1g7uZVVuPjcW6qorw5rPKCu	CkpYnbCSoHyUUhg9eBexrwLPq6HUwUKkkngdzBFzKvK4Mp3jJ7LCR
28799	payment	2133	2133	1874	1	1	2204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjYk3QVWRvgcct3MCDhPpXj1SGj3Ld3ARLnABc1jWApWG4ypB
28822	payment	1684	1684	258	1	1	72	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZhQBF6sLWBGrbGTXmJJcma2rCYoVtvrYX9T1xe523T88dMAnc9
28823	payment	1684	1684	273	1	1	73	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ5HrRNKHLZgPdyorKHGJvfuo4TAEj6W1taNTgX9qLMntrb6ee3
28824	payment	2112	2112	2246	1	1	5	2603651968305	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRwiLxg6yjbD1mX9e4ijY81HeTYZxJ6coqNkj4u6JGHeJijyy
28825	payment	1397	1397	1678	1	1	11796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuc3QwosBib6mbxFfPW4S5p7MaTXxYY7L5QZRxpnveXKsAoy3p
28826	payment	1684	1684	292	1	1	74	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaFn6tPW8zbzrYqhLcV8j2pUBTAz2yXPXgKf6KNmqs9aW6DkGC6
28827	payment	1684	1684	293	1	1	75	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYXXYi87aVV2HomK8DsoBGQEgyEKQMGW3u5nzQQ52iY9YLEUCGa
28828	payment	1684	1684	333	1	1	76	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZQSrGNmVeK4u41quuW5BYqzKfttjiTZMimZHxRH5Lw9vvY9rB7
28829	payment	1684	1684	376	1	1	77	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ88QZDHp2Ax6qdzMK53dhTj46tciRwfn6h3k5vvrqU9xNoHAXJ
28830	payment	1684	1684	426	1	1	78	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYyWrxJ9NL5LYvsmcRWtKUZtvdU7AkAjae6SQs2gYdkRXkmZf3M
28831	payment	1684	1684	429	1	1	79	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa6LUdGkr2YbDcPjpphQayHFvUsSx9oTUU1UsKjQP5aJcr3DMvT
28832	payment	2134	2134	1874	1	1	2641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKxHpPgVFkqRsRJCAiHbavYjgHAP9b32dA7DQ72bnfuGbSS4G
28833	payment	2133	2133	1874	1	1	2208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHYxaC2gbBBuDbVmBM17ktRSZK5Wj7mS7exXniVfaBWKmRoLj
28874	delegation	1895	1895	1497	1	1	0	\N	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfAC4xM8PqJEXaQyvinBr2qMw6LRjNNiw4cCTSfnxUtiYRmJL
28875	payment	1684	1684	612	1	1	107	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZcV8x1JB8CAH1WsyGKCvWCtdDUQvCgRNgP93fLfEcet1erPCQd
28876	payment	1684	1684	615	1	1	108	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUzevrMUvZm9f5WGr2hYJ6DEt9PJsiY6ou1Xw8ARaA3xcfBzzb
28877	payment	1684	1684	616	1	1	109	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZTQzQ5p3euvWvtsBetuEjnUHH82U447ZzJm17QpPM28SEFWjRn
28878	payment	1684	1684	617	1	1	110	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZZsK7RGcmcXQaRXH2feRfpQ1DyuhFvvATcx18t3TmCw6Nwq22o
28879	payment	1397	1397	1678	1	1	11800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxDns21Z5Tq94pioLzueM3GDhmTvfh13Rvqjwf5fWKtrhBcue
28880	payment	1684	1684	624	1	1	111	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaE2wXh6Qiv7fuchei6rhmay8m1t2PzRmkhKuLwsnxa1BZvRBvu
28881	payment	1684	1684	625	1	1	112	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkahrWwiF9gYtFQJxkeJvw27yfFfAJ9Uw48G2EiPAjWkFqNhUM
28882	payment	1684	1684	626	1	1	113	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYzAkRkpPQHqMeuku1hWBcxsrMSfVeDQ1qz8SAy6RMjo2DDVL7A
28883	payment	1684	1684	627	1	1	114	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaBSUp9VPSH1oeC28nxXFv9KMUNej2Gv6jZLR1UiFmi8yvP4Tzm
28776	payment	2134	2134	1874	1	1	2632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShZBq21xhSMLoZudyDMDTnZkgpSsC9BkW6RKat7cAD3tPpxG3
28777	payment	2133	2133	1874	1	1	2198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYnwTRMKm37tp4ybAs5Lzg9QdpbcUVRbPxFLCnCNeHcHus91v
28778	payment	1397	1397	1678	1	1	11787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcC45g3Nd7WkLCaZ1uxf33BWJvip9SKwZAkkikFHpEtwnTNz7
28779	payment	1689	1689	1149	1	1	9	2313933399094	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYictieUqn5ATcAfqcgTXzWUZNj1tXjnhVuQmJgJCfGEdbDBfe1
28780	payment	2134	2134	1874	1	1	2633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUysqAtNJBznJkPowDEd5A45Q9YUoMCAWbhPGDdNqbtgTQhtK
28781	payment	2133	2133	1874	1	1	2199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LXUacjpqLXtS9LavNwSDgWGDGtCRoCCo3QnftMCDz6NtHEbF
28782	payment	1397	1397	1678	1	1	11788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgcQuuUcL79KTj8hpTdA2PTYAq9n96EAuPEWmd8CUrkKHudQf
28783	payment	2134	2134	1874	1	1	2634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZTPQo2Rq3JBazUgxqhmMrrVWTpQw6t3LCGhwj3X5dpaER9ef
28784	payment	2133	2133	1874	1	1	2200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXPBtc1sjFnrQKTnfCKA8wJZF9MuPPdhj9BDKwgjYbQsxA4F5
28785	payment	1689	1689	1275	1	1	10	6447981160062	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZrbxJeUtRaX3sRBMCz3jgerxdSL2jpiFBg3F56tGW2yCRLz9Pa
28792	payment	1397	1397	1678	1	1	11791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQK6suPguz3i2k8KwAT8cJNdFZkbHVmWw3m91eHDmaRaZqVrnM
28793	payment	1607	1607	1348	1	1	9	5910732493763	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtMpqgbpsgLiPLqJC584saPk8vp9wk4WMS6EMHfSgwSXr8jVP
28794	payment	2133	2133	1874	1	1	2203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvozh2fMCLzXE5UPWqbkqEGvV7bEfyGPgFWsPoLq4KQQsCs6A
28814	delegation	1981	1981	1981	1	1	1	\N	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMo11hpSzUDpo2LACguJgBXJzFwMRgvtSF8AoTsANxDTbSzmH
28815	payment	1607	1607	2246	1	1	13	83779133619	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KiK9gwneY4M66w7WpCPCugxzF4at6Gu23AbaqxtkoY9pa6rL
28816	payment	1397	1397	1678	1	1	11795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvNBcSPHMnkwEopThqUGsv8yHCWK1XbshoKSLYtpomrjz537v
28817	payment	1684	1684	22	1	1	70	70843032675	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa6e9RZHp9w8vz44dpSsMiBVvJ7rQrVxCtVGEaoyhVBCRJ7hJtZ
28818	payment	1684	1684	190	1	1	71	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ38JVMk9ZGxcDU8GDTXELy9FPV2Wq4MDWfs8urgbcvoj1TstTX
28819	payment	2132	2132	1874	1	1	752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZProPrsV1JjFJFArhpaaCnvWWNTqK5KzKMGyvu7XLjTdjeqt2
28820	payment	2134	2134	1874	1	1	2640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcS4UhG4GECuxRGBSCpbJTQvbRarhrCMSZUUTFdXdZX9erNHi
28821	payment	2133	2133	1874	1	1	2207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzphdWH2BtyHhuXMNooGcLKSHYctHujFXbA2C36ZVYSHR1Hzc
28861	delegation	2246	2246	1607	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZX3VPgA3UUCRyHfZ1aJQQE5CSWFsjs4ejrNmxmqWGX1d2hwYs
28862	payment	1684	1684	572	1	1	98	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUCMXZo1x5uKZnujdTGV4EgAdHP6FS28F4DVEXWmp2A6JZD6kc
28863	payment	1684	1684	573	1	1	99	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZSBKEQevbwEUYwj7grCaq2vce24mzgiH3EoP7mVSPQKYJZ7v5M
28864	payment	1684	1684	576	1	1	100	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZLsBDR3FNsEi6ArAab1ZRm2pm2798jXNu5dDU1nVqUVWYBN9Nr
28865	payment	1684	1684	584	1	1	101	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ3dC28dsKTokDJq2zA4eioaZBnkBqpgHcPEhwjjVvCvgFZPd9m
28866	payment	1684	1684	585	1	1	102	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ2xHPYuUdqeWJCAvP1JJP9UCFq4C9D7iNVFXJVBzVPPnrLww4S
28867	payment	1684	1684	589	1	1	103	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZApmBC47kU9qZ8aAHNhxkYQFyMaReCSa2YHiJfH5Ff8vRFBikc
28868	payment	1684	1684	595	1	1	104	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYWHPQmeUZLcCXjEbDYrHqABiW8Ka1gV9B7bP4s8wLYdia54Ynz
28869	payment	1684	1684	597	1	1	105	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZnnnM2wqEPh5zRBvzvaEPrXvUrjN2GxGitQkBbbjkPkmTR3BGo
28870	payment	1684	1684	609	1	1	106	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZWDohBDCWAyFwrGTmCtR5JuquxsrkLN5j9XyDiZ6vVkn3ugqk4
28871	payment	1397	1397	1678	1	1	11799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7r8D885RZuCHyU2CmWNwQGRG9vf381SY9oGSyhUDWameEctMD
28872	payment	2133	2133	1874	1	1	2211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdp4nRp43e933a4hAdTCWyJoYpWPpbPCdNNPikNBxGgpoFabx
28873	payment	2134	2134	1874	1	1	2644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyW2MY7JuTRecpJaPMvQ1KbFi5M7qQra6G7pXCbJBPvm3H8nd
28906	payment	1587	1587	272	1	1	13	1332755000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNJRd1Bo6hHuHZSiRP6awxxcucANvZv9bjyNzhUgdumKTGRMF
28907	payment	1684	1684	720	1	1	125	6346236018	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZj352CNPWQS4EZ5FtdNwdgPBTeg1KoKsKDb2GShNzXsqmUWuXi
28908	payment	1684	1684	722	1	1	126	6346236018	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYzmZeZNNX9e8eu8y4raCmUXtPp7i6eepTJUGeTGic6rNihtBcv
28909	payment	1684	1684	760	1	1	127	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZzdXBRoLy3yNeNHoAZXSpPSHWpxCvs7MXYdx5j6Dd2hyeTbHMt
28835	payment	1397	1397	1678	1	1	11797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9H5JpgJJ7i78DhAgS3btB6WsRvJKJiLnB6nw83Z1Rwn7JU4VM
28836	payment	1397	1397	1678	1	1	11798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhV4VzyCqX9Xa5qTmt1AcfYTYqNLpXxTzvpbjbtjQxZRBvWuDA
28837	payment	1684	1684	430	1	1	80	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZnq4vtwwnvhGVv8ngnpWHZfSVc87gXLbKQkbrHiG9FBjqoXDBL
28838	payment	1684	1684	440	1	1	81	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYgVDZZ5ziEmib3DeBrpctgBucar9yVxdNED7QBHks5Au5tSY1D
28839	payment	1684	1684	474	1	1	82	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYjRGzAjEtXkW1QKDjBQQihaHoAPkpYKgeL2dcz5KbmKgN7SPf6
28840	payment	1684	1684	475	1	1	83	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYooT9B2CNVCm4ceA7BLWtWzhLAq1Ja7h8geLuVKvreakVQJsCa
28841	payment	1684	1684	476	1	1	84	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYteEN1BLqyVW7rARpigsssAMzvJubT67Bvo5ToXSXQAsZjzP7y
28842	payment	1684	1684	483	1	1	85	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZBudkipBYN9W5Wz4a7rnwvXeRhf5FouBoT7Mh8sUNWG4MiBnat
28843	payment	1684	1684	486	1	1	86	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYuiYXJCt5f7S2dfGQ8bQaKQziQHh3dCcJkZuuwuyk2PQjDJvHn
28844	payment	1684	1684	490	1	1	87	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUH2pCzu32SbNJHmzAd12ChgiAv8QK2JUiW7QPN47ebDyxoKhz
28845	payment	1684	1684	496	1	1	88	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZja1sj1H8G7SJKjnBvWDTXyULhweeygVF4kkFPcnkk83RJTDH2
28846	payment	1684	1684	511	1	1	89	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkU94j93Fsy1o8TZ8LoW4bQnapE3doCpgMzzqY6o9cN22BUvBJ
28847	payment	1684	1684	512	1	1	90	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZvUAYbZoz5fwg1DN6BtoEAK6W5sz2RmQM1b9iFWev82GidqYy9
28848	payment	1684	1684	522	1	1	91	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYvo3mreRauXAp5z61hUzjJszcuXfsbHtycgM7Hei4mCZEVL2vA
28849	payment	1684	1684	523	1	1	92	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZNVHuuG6B3pJyyKDYJggED8vbcMZBrJyCq9Yo9i9fn8QbmXGoH
28850	payment	1684	1684	533	1	1	93	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa549bRMzPsD3kCUUf838YPZCgWVLW4sqE2TnYTSTbRhKM8edy8
28851	payment	1684	1684	539	1	1	94	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZug8ZSWFjAzdsRsThhRzPHigavcqwLGhnV7fqSiFKn9q4Pgmi4
28852	payment	1684	1684	541	1	1	95	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZStDdXkRzS7B4mt53B2HKYFDC9KUA8QVP29vXyhcp9F2s4Rgwk
28853	payment	1684	1684	558	1	1	96	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ9BBsidy2McQFibXTK41nSojxt8g1DWh3PiGQP9HUtZxcDfmSh
28854	payment	1684	1684	565	1	1	97	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZHA1TkD6zc8GnCwuBR4gNG9f5ab8GgwcZBCBMYmewemTXmuG3h
28855	payment	2134	2134	1874	1	1	2642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ953HKWrJmUrCvev4KsZaSvsM7XnAFbeBwVh2ZbiGyc3Uh3C2f
28856	payment	2134	2134	1874	1	1	2643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyJ63VFqkxpsyYLQ2596yJBaB1GhDSxhA3ghvW24BN3EjLhaM
28857	payment	361	361	2247	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9jcQHeAHgDUnUxBo7BZ5rXuHojKbpzWxuiLwVHLJyV7vEida
28858	payment	2132	2132	1874	1	1	753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYoAveA7gH3hDCZo4YCF87zJnLc4jPEFosjMEA1naW7ZaSZvW
28859	payment	2133	2133	1874	1	1	2209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrY3R9Bfiya1vHTqoF3tKJW5eS74g3ZPY3z8QYk9UXSp7TU4J
28860	payment	2133	2133	1874	1	1	2210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8s9TuBKxUKYWVomXAUtNedq4ZD8yvdB7a7L2cFm7t1fLnXnC8
28942	delegation	2142	2142	1460	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbD63aYcGuoRDDbjzpe3NXaUvR3QgvcGhvSPyrDcxr1b6MJ3x1
28943	payment	1675	1675	976	1	1	4	2228000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpYh29nt48k5aqJeR6PGQ7y1Yp3gXTwviEQAtXP9q8gJ7zRsfySb
28944	payment	1675	1675	1096	1	1	5	3992000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpZVdpXmb3H1w8uebGnwaoJv3wqDKNCgDGqSZqYcU29bvTt5E1QD
28945	payment	1675	1675	1216	1	1	6	2694000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpYazAwFz9Ty7fNX5xnmrV9eVBQZTZk5JKHb1J8WBtQejtZ2Qbg9
28946	payment	1675	1675	1342	1	1	7	7505000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpZG18FdsNzgfhvBNWsosCpdi8hRomjx3fDvsjLcFT2ZkDwHSxsL
28947	payment	1397	1397	1678	1	1	11809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn57ENXL9rTYY2xgU9mgdyxzaVF1Wrj7nPfxFYXsNjVFtk7Aep
28948	payment	1397	1397	1678	1	1	11810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxDtiqxEtp9dNka76REBHxnNNC5hJsYpEUCHkBkoGFokPVkxJ
28949	payment	2133	2133	1874	1	1	2220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUxQzbi3NTiXhMLZ1miWMHSF13hjpWVbTBcxNtYx5jCgVyRDu
28950	payment	2134	2134	1874	1	1	2654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTEGpQRCXw1LqsG7xLH95izs4aN4D4gAwcPfW9JcV6kSwBLR3
28951	payment	2134	2134	1874	1	1	2655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmo9f2t93c67DJrhv4dvxJ9ZnSW5MbS5rimmPf6KKjDkkuMBW
28952	payment	2133	2133	1874	1	1	2221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7mHdME3BStiHtBKDZmaQxXp993zy1jvRpt1BaFQDnYjiwjDR
28968	payment	2133	2133	1874	1	1	2225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxFmbhwMv3svbaN6grxDhyvCnRnHG2X8cqGya5AXj8a33keUY
28884	payment	1684	1684	629	1	1	115	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa3W4czdNFT8s5XwH2oiTwkZjenxjprZKcntcGXmxS5qUY9LrvL
28885	payment	2134	2134	1874	1	1	2645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLLRcF6zpG9Td3kuyGMey6wuqz5yuBQt9Xm4H9mAMDMpr8sbS
28886	payment	361	361	2247	1	1	1	640000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPD2sxLsfYcqmHNLP5id7efbLKyMevXrtGRxZ78W2GNmv7UxK
28926	payment	1397	1397	1678	1	1	11805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jx85dnYNYG7HoCLi4iP43w3HngGgSc8T4BhXhYguF13Cik83
28927	payment	2132	2132	1874	1	1	755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW57es9eNYztTDGByXPCdqfbxFo8RNAF91cgRMc6c4WfxGK6FU
28928	payment	2133	2133	1874	1	1	2216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LZPNbAMUBcG98j3kQSfzvJ8JH6soi7HdfyixzcAkxcxDVsvE
28929	payment	2134	2134	1874	1	1	2650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDTeM64w89SKGmKUqrqP5wtJq2S7Ja7gyqxcGtvgN7dTKDZscX
28953	payment	1476	1476	1371	1	1	5	8601900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqTG1nsxjuJUZCLaPoRPrRiVuxXj1EeCF5RgigwPPrT1rNfQG
28954	payment	1397	1397	1678	1	1	11811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqf3ZJsu4P57M7PKcUqyzroxrEFxVRKBEZ557RtGr3hudvUZF
28955	payment	1476	1476	1125	1	1	6	4575100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGnafAfc4jMkejwKyVwuLKF3ro1mFgfPFSY7ScwZSVw4irnLJ
28956	payment	1476	1476	1245	1	1	7	3086900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSJXSotKZsXyBMACvTZhnyRnX7TXaSA15ji7uYNQKBk3VhBbC
28957	payment	1476	1476	1005	1	1	8	2553100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDvFKx3xh7JP83Xt5PLJs89fSe5J4BLJnyR8BVc6XZniJ1KqU
28958	payment	1476	1476	538	1	1	9	335200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jRAtrS4iSpgGj6Z2csfhmGh9iJrua2ioADsSnYHfZEstkGNC
28959	payment	2133	2133	1874	1	1	2222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDpV3hFwcw71M6ph5sK6YPhZXYBFiJW7cWiQw5TEh8nBhQZVZ
28960	payment	2134	2134	1874	1	1	2656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3JQdNiecXjWoTs5zPXPhJrFXBPMmBjubgDeyyHvQAGo77XAi
28961	payment	2132	2132	1874	1	1	757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK67qZCgqk2WbwtCkAdtYgf2v6EWDjedhJFhjkTxQXP69Bk2d
28962	payment	1476	1476	538	1	1	10	1008137000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpqkv4yfKCa4DmRc3fR4LaMqCA9UNnU5JCJHMEr4Hjn6e5LCL
28963	payment	1397	1397	1678	1	1	11812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21qP2kYYcMGAYty9EgQAkE155FbsSUM27t1VbceHavTJiHGnQ
28964	payment	2134	2134	1874	1	1	2657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JW4ppMKj8aaoGXuyLXkaNSAfdz46HF1SiFNpsvmZHWVWfHz2
28965	payment	2133	2133	1874	1	1	2223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LgTXo3jVJ6qtuL21czHgeX5VnNHjU7K9sJ5BhSPMa4iCiveQ
28977	payment	1397	1397	1678	1	1	11815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5v7f4rvmTs7F9V9VAin3qdzwKEbbBYbePYdBS4iHstcgDGty
28978	payment	2134	2134	1874	1	1	2660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74UQ9YRu5Umer2RqEAFH5nj2HtzppEu9rvzjd5jhxiYuixSM
28998	payment	1397	1397	1678	1	1	11819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpBNeLaejFPSFwUVCQpT2wurdPz15gzWuaDAqT93KNuiBUAuK
28999	payment	2133	2133	1874	1	1	2231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZUbjfumKt8mreYPnN8AJFFkGEkEsSpgvFyhHFSrbWRcMpV2W
29000	payment	2134	2134	1874	1	1	2664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgqFZBnUb4Ks1ppyFkTovKMvxn9q4wTBhZUR8fqmnjYrHqeXU
29007	payment	2138	2138	365	1	1	0	48000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6XnqDcEkzsgHbjaqqo8LEazBB2AzhntW7cVg85jak57JbKq5
29008	payment	1397	1397	1678	1	1	11822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfNSm6bf2FwjLMME2itEotVrMMm4343cKbYoxiSvS7Z5FCdQs
29009	payment	1397	1397	1678	1	1	11823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaidToMUfe326fFQH585NRLxYJeaKE6wAvy7HJ5tHB4V9jUmx
29010	payment	2133	2133	1874	1	1	2234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvu6g3VkvgY4zMaAYHojKxiA9dMUccDCfru9qrkAaLoP7YQ73D
29011	payment	2133	2133	1874	1	1	2235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBim3LszVhP3W1iCRqERs8k7tcv1E6TXhqnU3u7HfqEQc4SmF
29012	payment	1719	1719	1352	1	1	8	9830800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoTXXvN7soGPWKnVDFTk5btHqTEeHufPv59TWJsbzFosx49Uy
29013	payment	2134	2134	1874	1	1	2667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpAmcgLhXDBWz28M1nY3i8xnfwNEFeMMyhMumqJizQVXjuPDz
29014	payment	2134	2134	1874	1	1	2668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXHnq1VZKY1C6Kv8jwmJTWpVnDtcF6b4JyDxvvo9J8edDfQPDd
29021	payment	2138	2138	365	1	1	1	800000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWuhZEqUzmarnqc3tCErhNJT7TgvT5ScM1sHx3FRsb9PXpFz4
29022	payment	1397	1397	1678	1	1	11824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YeqK2YtpyKLRdgct9B2ZstDVKPfPfMo2gGMpxJYTYpgErMe7
29023	payment	1397	1397	1678	1	1	11825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQUsBzKV9ChLGXJDn9D68ZMHzyvoubpS151fJctnRBdDipZZa
29024	payment	1397	1397	1678	1	1	11826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQf9om6exMBfAJsru5u9LVFxH2aX2hVH5MMQwM23YK5sBWb6w
29025	payment	2134	2134	1874	1	1	2669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc3vJ171M4vDfWMUqPcbirQ3t3bJfJsK93nMT3QFonF13ivwS
28910	payment	1684	1684	763	1	1	128	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYdUYb7vceJbUPYDkgvXb9HMfgEcQ1FszFrb5omwLJeyZnQ5uuS
28911	payment	1684	1684	767	1	1	129	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZXDXgNSv8XQm93MYEmLMXR7JNUTXMBfr1jPRMfxQaf8vSzBa3n
28912	payment	1684	1684	769	1	1	130	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYxFFoNPBq85WndHh9rHz3t5gBymjrcbd66FcQZ1V83qxa8hFyx
28913	payment	1684	1684	958	1	1	131	1629879801811	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZjkL2BfRgXtcXiv8fGE7RApaz62xh1RzKzP4SPYmtMYop93dhu
28914	payment	1684	1684	1078	1	1	132	2920575236094	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZXuKMqw2gavF2z6yaH42BZ4gvAcRP1UqeGeQVdGoRTrgx4VMJX
28915	payment	1684	1684	1198	1	1	133	1970633950321	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZBpjur4JHrrE9cupF79Lu1bqkDWmgeWYdXmhtjNpc64AtMYo4C
28916	payment	1397	1397	1678	1	1	11802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBo4bZtSKrUgB9YgiHEWNxYZVvpFqUtn58gP59Z9kYZVvffwTp
28917	payment	1397	1397	1678	1	1	11803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgK4EbdesF59rftBSCMuLfWKerDzrTApFmL6Ngp8u11TYirMQg
28918	payment	1684	1684	1324	1	1	134	5490994110854	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaBxRheyQqxu3KvV2bGrAbUeg41tCbQdosa6uTUmW9QfGp4U91c
28919	payment	2133	2133	1874	1	1	2213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c5rTdQXtFoTDHwNNmQj6aMq2whvDKoyUgNoWhWoiLQrGp2Pt
28920	payment	2133	2133	1874	1	1	2214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCRDtdnuQVZstU3tq86myDaqiHkmQJoPXJgH8s2oiKHgUKjog
28921	payment	2134	2134	1874	1	1	2647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKmiv4G99JorwyAQUM4YyJEn6TxKq2vWpwoSQcMt7XNQ4p8dt
28922	payment	2134	2134	1874	1	1	2648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLPiDouSbXxSqFPwhhb9UGV9dKMbYEdRbSYYuc1Rg9BvqaUUs
28930	delegation	1882	1882	1484	1	1	0	\N	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTBuCJywtowhEK8b2AWvgXwCHvtpXvxgs7hxbGXDjLjLwuAsM
28931	payment	1684	1684	2142	1	1	135	1780000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymF3DuPimcj9WVFAqUvj96m5odzrmuRBnCfJVUsKgJXZG1CRV
28932	payment	1397	1397	1678	1	1	11806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyvFfZ6HzkYw6S6Nc6SF4NK75Hpv8ciHUbjb6cVrpHBvNoZ9h
28933	payment	1397	1397	1678	1	1	11807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrATgxia9Zso3FYeLxKRFcAWTygxXQeCtyXtdsee8hsnHL2ZgM
28934	payment	1397	1397	1678	1	1	11808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY6QpD3QfniQMxRC7Ca7xLY274WJhSTGKo2qz7R5CgTmuC7Xw
28935	payment	2133	2133	1874	1	1	2217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCegVJMZ9FidVrJKSLG64HLKQbBaUu7ioJXjCAcC2Sj31yu8y
28936	payment	2132	2132	1874	1	1	756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLcFCGTKAvkSVi91ujWXyMtmksgLmQJYm5J7HcRmMDeLH7V1S
28937	payment	2133	2133	1874	1	1	2218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96EGsqCPoWvPzWRDxriHYGppG8VZBMYiVrXHpPXfe7Vr8Ludd
28938	payment	2133	2133	1874	1	1	2219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZskYPFYsvvPYV5igca1b6U1mM8FKzK2XgVUj35Rk8kZhvygx
28939	payment	2134	2134	1874	1	1	2651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjvytctKJiffWo1oWZBmpF96q4gYbWaWqjMHfbnXXNzWLkS15
28940	payment	2134	2134	1874	1	1	2652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UmqWEQp8eooTxJN98Z3dSR6LufY9ryPhzYbV4gGkuFUnKu95
28941	payment	2134	2134	1874	1	1	2653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18FfbQ55tfVFvn7KZjvrpnGFpUppmZH58R6rqC79SczVXWnap
28970	payment	632	632	1382	1	1	5	3686000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZdk7rgmZ8frNfcbrkRhDGRSV4FjA6VPbfxEKwec4DUYj9qmnto
28971	payment	632	632	1136	1	1	6	1961000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZCsp5jYkbsbLMUgMnLwP1a4cnn58eipvC8QkyE6qeSwAWsakLA
28972	payment	632	632	1256	1	1	7	1323000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZG7ZMyg2eapi9naYn3w8LqsyvK8QrFv7WUbQrGrqBxHYUAttaU
28973	payment	1397	1397	1678	1	1	11814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8hHzbuw9KSsX75DJrn4qKBtvume3eDqFE49PGA14jVmvFu9u
28974	payment	2133	2133	1874	1	1	2226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRGszKToyFaMQtWKcXwxxG6hHDs31kovouQEeHMcTResaMXaE
28975	payment	2134	2134	1874	1	1	2659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sbpFEDnN8eWSnWT3UhNVuKSSsGH4ntY55BnofmArBs84u5ML
28976	payment	2132	2132	1874	1	1	758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6muF74RogwCVRpNieMGD8wCmt5JXEoDqjNgdpWyHtZDU65X4Z
28991	payment	1397	1397	1678	1	1	11818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpdFGxCZy1BCeiroL5WQvcvgNbMeBws4zUQfpsGzne5oEpA6Q
28992	payment	1671	1671	999	1	1	7	2005972659860	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SwUM5gL9rnmySFGaUGxKMwB8RQSQ8KUKjGsP86ZgUBsW4SHD
28993	payment	1719	1719	986	1	1	5	2917800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqbhhkBtbL5BFxXY2vChibS4SZ63xLXokvtuePCkkdZQoc7rz
28994	payment	1719	1719	1106	1	1	6	5228700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1aDLX2iUiyJNUwab8avwQCYJEMaepmn4jJZyX5s9Umzcxqy7
28995	payment	1719	1719	1226	1	1	7	3527900000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2uh8DinevhEGxnddvVja7z6FmXm26gW8tiKRPojdLdediquB
28996	payment	2133	2133	1874	1	1	2230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcoELWcQqWXTLcSMj1y34mkPFHhT5Ko5od6eTECkb7YuhBCaX
28966	payment	1397	1397	1678	1	1	11813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dENau3dzHN32WgbGfFD95jBnAmvbAabYUixtuTdkEto81kao
28967	payment	2133	2133	1874	1	1	2224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVVNytccXkL6RPAHTrLCHv4PgJjg3HuWMRrcn8KCvN3fcS4Ut
28983	payment	1671	1671	1365	1	1	4	6758609896120	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhPf8eNytrS5sSKYSqAtVepL7X4DYUGTf6CGfgaBpEnEFG8Su
28984	payment	1671	1671	1119	1	1	5	3594685819300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfFd6nw6Lv7B4apVfNAtFYpdg63LrTrRypDuhszez85wg5xJq
28985	payment	1671	1671	1239	1	1	6	2425406151450	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppyRRoaNziNxVScpvVYsw9unKVppMpAdGQztyftvLNDbq8x7z
28986	payment	1397	1397	1678	1	1	11817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevBJwqGzqwLGFsnHQr2wK7QxACExp4RrQKYjtnhUYedNybXc3
28987	payment	2132	2132	1874	1	1	759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7teu6HtibjGWgXAq73p9BDgyUsxt8zuqGaSwKZn1ki4nmLKYf
28988	payment	2134	2134	1874	1	1	2662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVpWamrU4ZXQhELGPYvqmJhka84LwtsPd8iDnYdcuKjzm6mPe
28989	payment	2133	2133	1874	1	1	2229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvUNS3HwMvtEppAQ1wgEA6Ad7bfE7MzPzsfsjSvApjkQbSJnB
29015	payment	2137	2137	365	1	1	0	98000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG46YdtgPwkrnARpoQqP8DsDPe94MgCTYFiAZ2xm8BZqMC4CDo
29016	payment	2137	2137	365	1	1	1	700000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2CchxtCHZ3ycD3w4zYJvCZMEEFGDXTB91kdNXVYFeYFCD7y3
29017	payment	1536	1536	1313	1	1	6	7373030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Bof1FswmhN4AVhuvLZVkdFydPMojzLGrJM1nq5gavbw7ocfM
29018	payment	1536	1536	1067	1	1	7	3921480000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5FBVXQjkygK6UoonEkN93qJdbJkhWkgydycnhv9f6814wavqk
29019	payment	1536	1536	1187	1	1	8	2645900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskeQFJCXmyQyTziGSGsGfXuU7TAeRdubJCGxwAArsUvrSGEFY
29020	payment	1536	1536	947	1	1	9	2188340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WXRMUWugcHPt31tH1AiPaJo5UfxVNVQLj12T2qvQZiBfJDPS
29054	payment	1397	1397	1678	1	1	11833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBBx7HfAC1H1wk3m9s6q5m4d9kFJLtW4hmUREjwWQMKq2wqpg
29055	payment	2134	2134	1874	1	1	2677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11XXTDhz9UtLi9SifBFc3Qp3K9JrsAgFT5K9E34LVPQj4eymd
29056	payment	2133	2133	1874	1	1	2245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84UFGadzbvKUUcGJ95kGPC5857Pz3DSiKcL2pHU8t9Q9sGdGU
29072	payment	1397	1397	1678	1	1	11837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWNe89iChRsy16jfsrfRngT5GeJ1Xzej1z5QNoum6n2DD2Vyj
29073	payment	2134	2134	1874	1	1	2681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFfPPiWGgnAdUkztPMgD5S8e1XV4XQ7GUpeD4SQq8yFmHckug
29074	payment	2133	2133	1874	1	1	2249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ghyc8aLtop4AQwEoJ7THkecNEbSSKU78uXYFhz22DBjAj57D
29094	payment	1397	1397	1678	1	1	11844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpeVj5NkBBeGwD6zBaJJ3mqjVeLx9wgC24gd9GkHiZ8vSmYs9
29095	payment	1397	1397	1678	1	1	11845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSZSiG92UkELFSX6DGTHpNQTCP5CrCD7qS9ipxHsKUJ2nZchY
29096	payment	2134	2134	1874	1	1	2688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyhL6mQ7jVhKqdVFAbCJVoSrjVUnKicNgUaAkX3Gqm3BQxVDH
29097	payment	2134	2134	1874	1	1	2689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBBLAdCFh3E3Vyd69cSjnof5rbqzp6qGJs9FXFv3v3rYrFF8w
29098	payment	2133	2133	1874	1	1	2256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2ZDtV1c6jxqMBJmAWG7TM6h1HsKddeyRxLCL2Ak9xCDKGUAt
29099	payment	2133	2133	1874	1	1	2257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9s6r2Ejw2ZjuoZXhZMshqvHZa5UmNshAB3ghYSdaSf7hscSU
29169	payment	1423	1423	104	1	1	28	284000000000	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZNEa56TUoZC3EBC8dgUbcSjJhqSu1MHkRAM9vEzoUqmaWf8zey
29170	payment	1668	1668	1244	1	1	6	2981321000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYAfSaj1PrW92ZfLsu8ZY2yyqBegsxrxbqc45ZHMshHJ6Qiqg
29171	payment	1397	1397	1678	1	1	11857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34kq6uYGNoiStSDMSzFkMghJrqg35aGKPnLj6R9QY91Ctw7A9
29172	payment	1397	1397	1678	1	1	11858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViTDj5d7x6qbGBhuxnCe74kz3LebLc6SBemrTxnU9ecxmqnKD
29173	payment	1540	1540	1963	1	1	5	367204120000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYq7kBN7XqmPnQTYgtEUK9WzGGJHLwYoDZ7Zy6iPjguhu1HprM
29174	payment	2134	2134	1874	1	1	2702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteyJ3fD7px6hb96hwkcueKkEoDTYroW2kVDAFXHwragc35g27
29175	payment	2134	2134	1874	1	1	2703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsq3TytD3mSkkSESVs7ERwZajDvBUYSoxHX4U6hG8Pc8SMp3Ew
29176	payment	2133	2133	1874	1	1	2270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA99MxFcY56xeK4TprgMXhwvas3ms2kLjoo5hjP52opWBeqGLt
29177	payment	2133	2133	1874	1	1	2271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtForyZraw3aCTcLTwgfi8Fzgd3QsvbEhHHit68jMym9m3gRLy
29190	payment	1668	1668	1004	1	1	8	2465751000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyWwtbftXFVtzbaTqrPnkBfFpH838mny887TmBTLqps6EcQ9q
29191	payment	1419	1419	139	1	1	3	338724292166	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBVzSNaxKwMvnqeVgKKaKMyYDyPSK8sms25rdPB78ytn77wej
28969	payment	2134	2134	1874	1	1	2658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTRuQWxCzHDsp9Qpn8AXKkQq7PJruBKAY9yrKBYPxRkPZ7mk4
28979	payment	1397	1397	1678	1	1	11816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnJpkXR9LWh9q6uZMx2U1syGEDSVsP3T22buSU1HqAHS1Yoje
28980	payment	2134	2134	1874	1	1	2661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJjm7xaBfTEULMPN3jW1KN6wAegzzRXdZoyJAZaPmsrakqHU8
28981	payment	2133	2133	1874	1	1	2227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aGbFZxN87FUxPEYF74JxgKP11RuxLa219b2vxPQxMJ9j1gH1
28982	payment	2133	2133	1874	1	1	2228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xXXeDSYan3tXuf1BygGTjFNsMUCagXJ9wF6m2UFUu4wSiCv3
28990	payment	632	632	1016	1	1	8	1094000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	Ckpa6wqScRpRQA8GJi53rmhc5JGBtPADcaNmuHERPrMmVkpYqSZLn
29001	payment	1397	1397	1678	1	1	11820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7CbLtovvohugzhRdpF6dyUQbUEmGzdNKXyWrD2fQn96qbg4Q
29002	payment	1397	1397	1678	1	1	11821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YWnqNrKQFZFr93uevWFnD2LnXVQJd5G9m8X8RNqR6GCr8u7p
29003	payment	2134	2134	1874	1	1	2665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H2874iR2RaL9L4eGZqZbN9f1nr9zksQDYjZDRHrsPjjFtpLU
29004	payment	2134	2134	1874	1	1	2666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MLyPmT4MPD17csyHetvG9c4C9YoEmiDPFYiFkj2iQc5wHqLT
29005	payment	2133	2133	1874	1	1	2232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgT2QfATtcFvLX965GygDY4wga6o88BQVxaLzHMhW1UjaSSmy
29006	payment	2133	2133	1874	1	1	2233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgWCyyhjmHP1QZkRF6U7ezs7GktCqz8GXdpiiWYDzD574G79V
29029	payment	2133	2133	1874	1	1	2236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3adcJcym7swfkueYVtC2bcQJbe9sufncCCTR3aY4wtFDpXMj
29030	payment	2133	2133	1874	1	1	2237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpcKyruY3ozy46yrc75Mv1BbjreJKpiNVrSN5Nmu3BEYs8DLb
29031	payment	2133	2133	1874	1	1	2238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMia3T8VLUKPtAH99pMfEn7i3gNGXEroLDtp66NQbTRcmejjS
29052	payment	1397	1397	1678	1	1	11832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSMz9QyZ4k8ogNVJcuKud5a3qjxbVJFso65QE1VCCeTibDC4Y
29053	payment	2133	2133	1874	1	1	2244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtZNdDaow7bPvUqCfDme66RAF3KT5EW5gWLN9uf8twrAWJ6X6
29069	payment	1397	1397	1678	1	1	11836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAn4SdXVCQUmMiEcKsVFGK27vQUGM4ZMGqRHzuUXiDyKLWe6H
29070	payment	2133	2133	1874	1	1	2248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUyR7DS8sf6ZWA9tQv8uhcorgvoDyneWn9vsaQxGEfW6Yquu1
29071	payment	2134	2134	1874	1	1	2680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GvSinGx78qWm6gW8sUpnX9Wj91BHkyU4kc1BdY2aB8DMJ4mn
29082	payment	1397	1397	1678	1	1	11840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjSGdaqg7UrrGUsfMrQw4c8YFPqUNWweamCwBYfdtSKZeQAaR
29083	payment	1397	1397	1678	1	1	11841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuszxUwa2NxXmPyMvZPzMkwqSDAHndtPAD9AL5iz3d7Jus9oD
29084	payment	2133	2133	1874	1	1	2252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16Rs6Fp5jw8z2M2rjBLJ3D6ghC2VBMxUGsxhhSGyRabhtM7Gs
29085	payment	2134	2134	1874	1	1	2684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fSVtwRe1dPCAorXrtBiTRtkLenZgjcj284X5UyDjz1qDHzHy
29086	payment	2134	2134	1874	1	1	2685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX63p5mPYUAEEdKwUnuf1Lc8S6zxfbc9Bm85CGxjsyt9MP1H2X
29087	payment	2133	2133	1874	1	1	2253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yA6SRZ2zb3fin9Bcp49upePFC5kc4NRU4q1iBBoqToo3W7pR
29100	payment	1439	1439	913	1	1	6	1702636450000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9iwZ4xza2hmLEzegq7HxSa54HWQCSifMx6VVAqh5murapViz
29101	payment	1397	1397	1678	1	1	11846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL8FLJ4bQNYPijnYa97b3pS2gbbe86D18gj89DjyD2oHhV2Cx
29102	payment	1397	1397	1678	1	1	11847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXcPYAuxY6bECxWaA264uWpiovds4TDHrv1HPS44FTothUPDv
29103	payment	1397	1397	1678	1	1	11848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZR6KjVWwECBW2P7UwFDi9gCiQd8BH9j3Fgha7yTWiQ3G1of5f
29104	payment	1397	1397	1678	1	1	11849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY89bHYBhi1e5tX9RxZVyNZYp1b8yujyL4Z9WWnEiYcSb9Xo7A
29105	payment	1699	1699	1773	1	1	6	7990000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwexn1G1DRw4WMEdLfrzAaTXprBotaUUKAXBsysAzMUpwoEzM
29106	payment	2087	2087	1773	1	1	1	5759000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ195esV5d45Jth33H1tBcYYyXZN21ebwr6eBaWociD1pRNPfuk
29107	payment	2134	2134	1874	1	1	2690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTWeEPfgh9Nzq9KUJBuL8JXfjsHTcyWNbAnKyZcQxpkWTpiky
29108	payment	2134	2134	1874	1	1	2691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtz4P9voqWwPskguVgJdJ7uHj4NyAG5oCC2CUUAXeJDGLFKx9
29109	payment	2134	2134	1874	1	1	2692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbLcN2SucJUNC2WwzpaBbR5XApNzNUxo3bUX44ScJqEVBT989
29110	payment	2133	2133	1874	1	1	2258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53rDMCCnzJMG4cz2wPdKhrZtYuVGy3zqp4em1JFXBofAA6dzj
29111	payment	2133	2133	1874	1	1	2259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahumu7jmFsg52RRBU2iJknUwhNo8BC5xdXKKEU1T5FenHKj5x
28997	payment	2134	2134	1874	1	1	2663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzga2B5qLpFVz7Bnqg2yC8DV1xqAWbA3L4LPS7Q3aPwgVU1niA
29032	payment	1397	1397	1678	1	1	11827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAB3iAkMRkJnBgjtYrJVBHoQ12bq5KZSwgVaC3SN2gWfvKU63
29033	payment	1522	1522	956	1	1	10	2189000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpaLL16PTV7Gv7q43J4zSzSuL49e38mx35Czx9zV1WmpPwr8CMvX
29034	payment	2134	2134	1874	1	1	2672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoYU1BWiaMqyAy9YWdJyT4kjqCRc43cJ9wXNJXmsHDsDSwWh7
29035	payment	2133	2133	1874	1	1	2239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDPYpEiw7JGqowcnMJNqDNKgvqqL9Ta5UGL4UG8PweuMU6Cma
29057	payment	1650	1650	1009	1	1	5	1650000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGDu2Gn5PYdNn71rTdp9tBMfxhia712dEUsA18kLTPnCcgoY4
29058	payment	1650	1650	1129	1	1	6	2957000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNbt5rddVSRc7LcpZegcheLKSjb6AxWfej49rtfaXG1Se9hnW
29059	payment	1397	1397	1678	1	1	11834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9e8DVB57CFWmYtVum4EreipXCayT5vb8RQKnVMJESBgB2tYS
29060	payment	2134	2134	1874	1	1	2678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpkfuPr5LCnXb1Wec94fYNzE7QSzXdBJhbM1Gpb4LnqZCoF8k
29061	payment	2133	2133	1874	1	1	2246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRkVJCeUg6qTptt7jEtV3McrvgG91YcgAaZjhC2HfmoHsCrt7
29075	payment	1397	1397	1678	1	1	11838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CnQv4sJGtmUMTWtUPbuA4jzunH9ZM1ztatkB8ALaZ4ddLCGr
29076	payment	2133	2133	1874	1	1	2250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rxc7Kpc9cgBNvL6LepLWN1abcC8cGTyciUYc1ah6G4vN97D7
29077	payment	2134	2134	1874	1	1	2682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6cGk2khfK882dqKcjTUTMQBFK3rN817Z76QnNx8yART7Js3x
29088	payment	1397	1397	1678	1	1	11842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFzSfL4hdKWqHTTqrZVKFzkakbJtfd2RYK7BPjDX8YHxWKpJt
29089	payment	2134	2134	1874	1	1	2686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6R7EcSZ762sWUNNaUPFyUvQJYTBSmitTk9qa9YW5aC4GUKds
29090	payment	2133	2133	1874	1	1	2254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3DTMXS29kiUqyQusJKtmEhDPzRBG7Lkhow5ZQ7tncXBkyQGX
29115	payment	1610	1610	948	1	1	6	2553056130000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcmcTMVbZoQG9ibPAPPy7Paf7UaDg5tWkMCpHhXtov9eouApA
29116	payment	1610	1610	1068	1	1	7	4575054700000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuCmkJ5FMHDv4DaYLgxHfa1NDesdHyagBnHdy7i6J1S71wmNH
29117	payment	1610	1610	1188	1	1	8	3086880580000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZ9hHE1rWKjBLTgZs985bryE25JB1Zv761SemKrG4q47ZdbEN
29118	payment	1610	1610	1314	1	1	9	8601867160000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDj2wzgLr7cYX3iWB83LGaLHdKXeLEY8DKqywUAYrWsmapsQ3
29119	payment	1397	1397	1678	1	1	11850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4zWCXXtMgfW8HDwda6k6ZzZcgWVkQLZfBUojhww54ARkoom1
29120	payment	1439	1439	1153	1	1	7	2058644660000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUjyt76dN6AYpi6XMqAcwVT7GsU2EPtC21nGvT5mn5dSDTBox
29121	payment	2134	2134	1874	1	1	2694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbgp6GgRMfCxf3uJDLz2zE7u9RGX4cCaYTkHSGAGoRSUc5qBf
29122	payment	2133	2133	1874	1	1	2262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTGhWHDvpZJZom2cWWrQzSTyi1agcjmy4tKo1zhDsViy6CgrX
29123	payment	2086	2086	1773	1	1	1	1983844699931	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhjo4aSpUgSizPzMxEH6tkHBBvZvRKpvYTJEXJYFZF5wqWc6y
29137	payment	1423	1423	104	1	1	15	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZkdJxiujfqkCb8QGQddLykhMbay6Bm9yDS7db3UQKc8fqTpQPn
29138	payment	1423	1423	199	1	1	16	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa4VRqyikFVPrTrTwT9YhkCZTSKkdkiVyJDKfhYqCLGFz1Y4Ljs
29139	payment	1423	1423	214	1	1	17	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa4g1ruhSsBiJuAPGWbvjLhAxDxHcNcVBHKzBpmXGbpy7SVGmMP
29140	payment	1423	1423	234	1	1	18	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaBVEMHBGMa8DgGEkVk4QuhMPtJ1X1ZAjLdABjK8HdvddwfyAvU
29141	payment	1423	1423	282	1	1	19	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYSLKvZJ6ECGBk758crJDeZKa4muQVRUw5ztJi6Wd2nwMMqSN8y
29142	payment	1423	1423	314	1	1	20	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYqGhT99oyG34UXknrJF4TWxKK87uKCXPdTvMxtJ947U6aTMbns
29143	payment	1423	1423	323	1	1	21	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVrkCqmGuLicb9R2DUu77cwTB2ARWoeqWEBveRx1QnwkxwGqsb
29144	payment	1423	1423	330	1	1	22	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZTL6Tb7WBSugqQZm9aRRTkDQvEHKPLjh8yb76A9kCAPurf71hW
29145	payment	1423	1423	332	1	1	23	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZBmW6biEcbv228BWyTjjM8bePoKbMKfh1CUTwHAoVXV2Revudt
29146	payment	1423	1423	334	1	1	24	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaFtRzdaieZD2VSPKHLF3C414Bf6oqaCgZvXwhjBB45WZoGLcum
29147	payment	1423	1423	343	1	1	25	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYocfkGHTdUNEAH72eGYcpfuCxT8ik4xs62u3VZHxjKAa5mfTQ2
29148	payment	1423	1423	559	1	1	26	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa5QTnqLXqb65iubDTHhTzH6hLncjWa2oAQUxiBeJ2WzssDJRV5
29149	payment	1423	1423	561	1	1	27	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZWUs4ZS2t3xuGSVUdgr3awMf7FULV9t3rHKWiZVWqnfh3Yyx1o
29026	payment	1719	1719	2007	1	1	9	835688000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPeYd1jzVjKZP3c4iBRQxHKKE6BUXagt8wKBH2yw1gyx8F2g6Y
29027	payment	2134	2134	1874	1	1	2670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYSrsYaYwK2CWuJ4xWHmyuJu8VdTvgEh2V6q6kdxcunMNbMF8
29028	payment	2134	2134	1874	1	1	2671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkv6xnrYb8WrBwu59aW8MhB5R2Y9nLgmfAbpeBPYFb6LVaUSHD
29036	payment	1397	1397	1678	1	1	11828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoV5TQWKhQtWtoHPQ6iHaQnXgdfze7srBqMmTU9BBxK6iCKKev
29037	payment	1522	1522	1076	1	1	11	3922000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYpHnVnfaPMYgpQvV6GvFeUKvTV6fBjqDbpYQxWaRKsYRUfpZ3K
29038	payment	1522	1522	1196	1	1	12	2646000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZLeCmAxmop9GQ71F2JwyNsRSF6Prf4QJKiHvmkN3LL7TdDG7Ek
29039	payment	1522	1522	1322	1	1	13	7374000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZGD2SsHtdxyJKN7y6vpJ5UqWDKTG93yUWXV466UrHnFvGz5w6v
29040	payment	2133	2133	1874	1	1	2240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLhoVshPsXfyvyPfSaazGJKTJ21Jo1ARwn5m3h8AKfiaYqLSV
29041	payment	2134	2134	1874	1	1	2673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNPa6UQAZGshteg3wZHNovo2dx46XXDVdTbw7q3KCDHjrMtFm
29042	payment	1397	1397	1678	1	1	11829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5gB1B1pr7ce9kVNZCqU4B8dtN1ZCaSHoVKEvoGSqHeGb49TL
29043	payment	1536	1536	260	1	1	10	1152100999959	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKYQHCnvPaJrRAJcUN7j5D6tkKUrdxBgZa4gU5pw9QkSVpRZh
29044	payment	1397	1397	1678	1	1	11830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxb1cZDHJweXdnUXkhBwXZA2jnQ7FYCgdyh2Dfm5x8R8ZTMte
29045	payment	1397	1397	1678	1	1	11831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKs6zuvcabcSgnUDwgy2g5FNuVTXvu6K7HtMDNtohaK2EA5aB
29046	payment	2133	2133	1874	1	1	2241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCWwLSphj8Q3mFeP9PTS9NKrouX2pjqTGcukfzq6MKUnvXDpA
29047	payment	2133	2133	1874	1	1	2242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUE4YQxmJdqoBid1Mifrkt1APUNcWKVD8vWt1wXK4jUcRfLU7P
29048	payment	2133	2133	1874	1	1	2243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacG2GDHMyfWdduW8RFGbNHaN3rWW4RVh2UvXbQ1kptHtZM55K
29049	payment	2134	2134	1874	1	1	2674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJAPUF1Gx7cqriS4hfVt1Qawrg8UEqGSNx95A3X29qPKb3pU4
29050	payment	2134	2134	1874	1	1	2675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuM9Tt1KsapzxxQBr4F3tZL5C9tGYt4Y4Mgz21rSzxRzXNsseg
29051	payment	2134	2134	1874	1	1	2676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNnmZCp9QQjyESFBiUSJCSwoH7SadU9xLAgxb1tsg7HdZMhu8
29062	payment	1650	1650	1249	1	1	7	1995000000000	110000000	\N	E4Yh779zw5ogHYm4q8CeDU2cJQMFX26oAfBHUTgFmAbbEnJPndDVX	CkpZwjqMo3tz4cVuj5DSAkM2NYLFmqwpLYJVQFQpLY2hVSjQRGvjZ
29063	payment	1650	1650	1375	1	1	8	5559000000000	110000000	\N	E4Yh779zw5ogHYm4q8CeDU2cJQMFX26oAfBHUTgFmAbbEnJPndDVX	CkpZ8ZNcpmXVFft7fBewKKDxsT1TcsVJwD34mtJfAno2bWSHW8fdY
29064	payment	1397	1397	1678	1	1	11835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSDz2q8Q4vJ1dLRVSVMdNQNAvWh9yW634LQKuhQqRTkh49KxSj
29065	delegation	2242	2242	1276	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3h87e31MpbVPbPtjuiJR48jUv9gzmVxnSbQA8Ct8kCcXLm3ks
29066	payment	2133	2133	1874	1	1	2247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5foYMKKi4YivKcVLuMsE6fqfv9jBcyBsmHyiuiZ7CUPBxGMke
29067	payment	2134	2134	1874	1	1	2679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qG8PiPa9oM2dkiLJoRZiAFXoNPfMUwkcjtZefkr1o6rdL8iv
29068	payment	1536	1536	260	1	1	10	287270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNWd57nLSqEUup6h3sETqKyTKcxGSUo51GMNYMZVJWEsaGKRU
29078	payment	1397	1397	1678	1	1	11839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJZwJDWKuDrWrRoqgcvLMzxifk1JsWZ7C1jJLyXqgKssunAzV
29079	payment	1659	1659	548	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EkotcDRfXHyTx6wFmxbYyqg1vm8aLsioFebjtKZPYGWUDpZA
29080	payment	2134	2134	1874	1	1	2683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD7zerjoPjndqfpKFaMWoFN3yuPHWJngw8sF1xwoBZYguTPZQz
29081	payment	2133	2133	1874	1	1	2251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLPiCSgjvyWJBFoKDgzgjuGSqczeUgEwGLo8ChqGR4FW7CJfR
29091	payment	1397	1397	1678	1	1	11843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwXtm2iEQCFQsLrSd522BDt4XQnpmvt1kNV3J3yBjjXGvuw2h
29092	payment	2133	2133	1874	1	1	2255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpqRViBfQ5XpND67U91HYN8uyvRVYFVAuE7LyPKkJFfBrwEM5
29093	payment	2134	2134	1874	1	1	2687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MDhTJuRYjbxoKeoVDENRhUW8AUuXQ4cm6dedw1g7NZctxRb5
29124	payment	1773	1773	182	1	1	30	272591071808	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ3Gh2JVQxS5HpHY7eu2RfxghdNJSpfG7uti6LYxTNjNPuywKH7
29125	payment	1397	1397	1678	1	1	11851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgqbfzGuWdYyRpTcBnY7x8rWRkACDNtTTPMQkJ6CSzYZ5MPgQ
29126	payment	1773	1773	702	1	1	31	181727381213	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZwi18PV4sPkL6yGuG9BfrNzUDRyGzRnCGt8J8LJnsMWnNgvRy3
29127	payment	1773	1773	927	1	1	32	2072969920333	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZbajLCZtxbyYKoNfN6ePqJMEiHe3wAk7TXFxzKH2C3qa3eFEAV
29128	payment	1773	1773	1047	1	1	33	3714744336038	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCxZ1XtvstzxNQjZwaMXo6My8ue4V4Sg9NRjTdXB33FWS8cYF6
29112	payment	2133	2133	1874	1	1	2260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAbhhkZh4ezfRW6bWqgzWeJS3BnKLZd82eB3aXon4fUAneCR9
29113	payment	2133	2133	1874	1	1	2261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sqtPTdKSv1Hg3YxjXwzALW31dNisvExT3C5TJrMS9uVBx8hH
29114	payment	2134	2134	1874	1	1	2693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1fgomGK89Efe4WHh2WuiTtNDbSWnukkVLSB5guNBSPggUijD
29188	payment	2134	2134	1874	1	1	2706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBPm4DybMArzvXHjx7pBVj9kcBB1ZuZdXnFetnT4XiMm5uD9n
29189	payment	2133	2133	1874	1	1	2274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ehjJfF6XLnw6Ps2LPDXqv4D86ibB4GPm89pJNujhh2KPsTRV
29198	payment	1397	1397	1678	1	1	11861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDWJuQrPNViZNCLcaNst6ZEWK2xxzSnbqpMcXKPjP7Edhmzw3
29199	payment	2133	2133	1874	1	1	2277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyxk7KqJvQxvYEDbnJo8HWF9w2Bbxh57Js7JHBTAKjJezVdoy
29200	payment	2133	2133	1874	1	1	2278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzjAcwaPKmVRyj184xXbBGTimzGkMb8jx1NHfFA39Vmouzwn7
29201	payment	2134	2134	1874	1	1	2708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkcdQ9PU8ygixJD32T8bLhcDiCVHMgfXixNgQCFJxCS1rqA4T
29202	payment	2134	2134	1874	1	1	2709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRn92kimfur8D8KFHyCmMGZoU3KyZDK3yLAY6DaLA42W1Cjxm8
29213	payment	1397	1397	1678	1	1	11865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffkowD644pE9ioc2ygsowxNwotDRZ91HDFVvp76Sg4MKenLg6
29214	payment	2134	2134	1874	1	1	2713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxgUt8GvRex1DxbqJAcPJZUdiYtkZFhpv3FyJvQTaR7XSgwEC
29215	payment	2133	2133	1874	1	1	2282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvF94cH3NCqRj4Dei6SWY7JjpRMjZjEKbEx3HUakvdxp6xPQv6
29216	payment	2132	2132	1874	1	1	764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZYRgLAtVdBhquPdEJh8nAA5Li4te1AAxXDbp8976VFWYu8rf
29217	payment	1397	1397	1678	1	1	11866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcBDmbLYuubQi9VjzbYDX71YimNa4GiVrBNrWBdYXLynkTY8D
29218	payment	2133	2133	1874	1	1	2283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6SHKC8bD7NRD1bZPix8b3xKTYjaHwyqQQgcLPa7BmWsGTjZe
29219	payment	2134	2134	1874	1	1	2714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDerGbMKqNBMQxkGXcwoGauX3ZTEZv7zZ856BxZWDvz89zL5eZ
29230	payment	1397	1397	1678	1	1	11870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8CCxYTz1r4p7mqNBswxPKT1FmVspUn6X9YtnzbUp8LcWGn8c
29231	payment	2133	2133	1874	1	1	2287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdpkE1jufeuSTrizE4C4bEnWRF1xLN8kQA95Ga2Pp8et9eToi
29232	payment	2134	2134	1874	1	1	2718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkFkEKenesQuZaG4W6ahW8AfeZnCGE4Wnpj19u8isRkkVmtED
29243	payment	1397	1397	1678	1	1	11874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqmALNjPXM3h9rLP3j8DWvme1JmHNKjQbsHF5piShckAvAmxF
29244	payment	2133	2133	1874	1	1	2291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcZVgfskPC1T2pnGdiyUyoG8hzmWCVo8iaSdEhdpFcxrbstgJ
29245	payment	2134	2134	1874	1	1	2722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytNqExeK8rssc57Bw5tz3RF7kd8m6FT5DpDrh6CftR31kz6pz
29263	payment	1397	1397	1678	1	1	11880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFDwAZTac3kKg1VXnbGwcX8Pt1wC3wWWVt9z6DaYBXDkexzbJ
29264	payment	1397	1397	1678	1	1	11881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsCoK2v64MNyL3tcpE4RPCuJHj18JGyR5xoxKFtJRbc63m2n7
29265	payment	2133	2133	1874	1	1	2297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wLNdTqyxU3JkRHtWBUwfBQp1Ef7h1fSeFgAPSaK5jh6zdxyk
29266	payment	2133	2133	1874	1	1	2298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQ1wbjg4abtW8ouF6cVgrdcXmiKp3ZHuSgp5JpppzQQKkaorg
29267	payment	2134	2134	1874	1	1	2728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBc28d3Vw8Hpt1hzB7P1s5ynsUXmFJDyv4AWkdwQyuFfPrHd8
29286	payment	1397	1397	1678	1	1	11886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HY7Kzvo9U1eQAaaVEFHD37ZjTZQPbPNmPChtzm6SUcnWhJnr
29287	payment	2133	2133	1874	1	1	2303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CDNviDCSPc967LRUkYff1F6wuLMp1StRFtQJueDq4RxpHuuy
29288	payment	2134	2134	1874	1	1	2733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TJvZ4P44Bdk26fYto36pZ26qnswqJBZBYm7zRDk8g56rpF7H
29295	payment	1397	1397	1678	1	1	11889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqJkd5TrjQRRcrfjtFKHQ8iZr4oM7AQCTmUWP8XGTSkZMdJd4
29296	payment	2133	2133	1874	1	1	2306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyrdFDPQkAvSkeJWqfndgKFkDJ2JBa3xyY5aQcdpw6eLqU5Ct
29297	payment	2132	2132	1874	1	1	771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnkLGVjP6pegfi35T73NNfkvKPnUvqKAJ9PJDQFQ8WyFXawyc
29312	payment	1397	1397	1678	1	1	11894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5z2LRWwZfbYD6YtNjMDFEftrTg6gCe2djNH66akZjR2WY4Nam
29313	payment	1397	1397	1678	1	1	11895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHKAtuJVUfmQpAqN5oMTAKm1wkRjTDSnEiWpHqrcjoWTKF2PQ
29314	payment	2132	2132	1874	1	1	773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7TDX5YRqHfnd5FjQH9569KoMJXqqF1vEUC8rprLPRqBfsCh5
29315	payment	2134	2134	1874	1	1	2740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstgWiD3U3jWtAmWPn4w2PCQiwi2gtXK3qrAnegWVaBQvcowow
29129	payment	1773	1773	1167	1	1	34	2506412025033	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZNLy8gUwrgg2tTKgVTRrsoZUBNtEKH9ZqNg42N2N4vkGH7CChi
29130	payment	1773	1773	1293	1	1	35	6984339965506	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZPhGWsbv5zfo4e99Azovm2HNr8KadDEXC1faQBeZpCnGH7W2Kz
29131	payment	2133	2133	1874	1	1	2263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1GMhZNw2998seNUsY6cRKCExPJu7rQuNW2HDvjTjsS9QKvtE
29132	payment	2134	2134	1874	1	1	2695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1xJ5k3BV81vB6kEMyZymrCojEFE6qx9dgREuz6bgcVbZ2m2K
29133	payment	2134	2134	1874	1	1	2696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m5pwRhVCXkK5ZkXfYmSGtqUfE8cbiFbqvVsRc3BDJhMY6mA6
29134	payment	1439	1439	1033	1	1	8	3051109920000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSECw5PbTmQAf39ovhgL7zYacZxR72tyySQkXdXrTAXMtkaf1
29135	payment	1439	1439	1279	1	1	9	5736596390000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK18LnYSSNP9Rheusms78R4o11FqsqaJji8d6YYp1UAQgkYK2k
29136	payment	2133	2133	1874	1	1	2264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E6E6bFMwBq687gXRv1FKxw6Nqfc5f99EG6Bg8R4wgBoR92Yy
29163	payment	1668	1668	1124	1	1	5	4418605000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8maxeZWMe5Q9ctpc7GxkTdGeXM7A3twVXX5otopB9UEwKBSi4
29164	payment	1397	1397	1678	1	1	11856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDGfqRg8YoY5KFkeJezQVKCcj3VBHSVbpwb7dDxFmyX2U41pM
29165	payment	1540	1540	1876	1	1	4	352803880000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKYvGrjcfmg3iv1fbU4kh3WDCukzranwPQoRLsvRtUzH1qCT9
29166	payment	2133	2133	1874	1	1	2269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBXySypzJxJJCdgvopPbyq9iVYqnCn9P11fALhfn7wrkC8etu
29167	payment	2132	2132	1874	1	1	760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNsjAMRiixNCNrFWt38TGJ2uHeKsgWEiFuu2MxvNHHyxb1MRt
29168	payment	2134	2134	1874	1	1	2701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNugRi9cLtckhjjPm6wUZcJUnEgEy58BvXpFQp3QCwBgk1ZgHz
29184	payment	1397	1397	1678	1	1	11860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaaFuwuoZo7eo3iDwrQ1WCWo6FRAztRfcjRBKe5AzfRK7uKCz
29185	payment	2134	2134	1874	1	1	2705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3YBYxi16S1JQKbZdEGEWQzq1FHESCvYmP8gmJAT9obHJEj4a
29186	payment	2133	2133	1874	1	1	2273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzuUsf2sF1p5JG3BygbW2NmJjz4rFkZKhVRzA99NsoPokfNan
29187	payment	1726	1726	2250	1	1	8253	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAwAaAMTNCs57J7sZaDVrkvdGdV55g9Je3AS1T5eXKoBWC1JpT
29193	payment	2133	2133	1874	1	1	2276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUs7NDUrRCM4UNiMEaRb38CVDehECr8nyuw8nyNN5eTz1GMFv4
29194	payment	1419	1419	813	1	1	4	2566101505173	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzDFjyAT1Dp8REdwHkmSWjxE12MQJ1TX5f8GzyiyEvM628Kat
29195	payment	1419	1419	814	1	1	5	28227091922595	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXoYSjv73KAMZ9RuNz9ePf9qmVExFw18ZqPfNaTTezsfrQ75W
29196	payment	2134	2134	1874	1	1	2707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFgvetxm7gkp2urkc64zRSeX7SxyXzSmHKj8p2muLyC1mXE1R
29197	payment	2132	2132	1874	1	1	762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Aho8r4dkTkj4Yfx8fxYsCBtnv7eRgWdWfnZEKsf3X95XcDz8
29203	payment	1397	1397	1678	1	1	11862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6uJfxA5NXB94eHjafm4xpPKQZitdiz8jBdazaDRjRnV9Xy88
29204	payment	1397	1397	1678	1	1	11863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqvBYBz5Rc2F7BpqLuPR9K21XZHAtNDRTHtLMo2X6Bn7xuZTB
29205	payment	1397	1397	1678	1	1	11864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4Q7FFxCUoYtboH1MkY3hko2gpsaqqtphEEJ6wTQJAsNf2i3C
29206	payment	2132	2132	1874	1	1	763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdHYdyv8EkDvnLSz8Z3rhA8dWRyuTVsbTDiqEBX8YRUxjVcKc
29207	payment	2134	2134	1874	1	1	2710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bXEhciYaGLBod66P75uBks3p6SP7AV8RQ3Y6hpWbhtTZZSJ1
29208	payment	2133	2133	1874	1	1	2279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Tj9TWH7CqpGf72i6U3khVF2DfUUYSShDWCsGQG43nBRQayMU
29209	payment	2133	2133	1874	1	1	2280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5m6rc289bxRk5jZZ47PJxWysEJHTGHj5NBcofpvMmuTHj4rUr
29210	payment	2133	2133	1874	1	1	2281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHvPk1QPyVKiwAr4aqBiw24wsR2CJZagDQYz6TdyyiwsAn8wm
29211	payment	2134	2134	1874	1	1	2711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiNuLq1FyKkgbECV6Q5ramQmfxZfC9TejVBsYoomumib34uw3
29212	payment	2134	2134	1874	1	1	2712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HsqPLoRgNH84ctx9sWtU3c4jxvuizSHrNxY9ckcmABi46Qnd
29259	payment	1397	1397	1678	1	1	11879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbbCERsrgEdi21KswiLekBSo48cTCQ8VnBsvELdjPxaUzp75U
29260	payment	2134	2134	1874	1	1	2727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8GR5xwzG7pFkmC3HD41fjDSBe8tuSZd4iN4SxDDZ4gHJTQa8
29261	payment	2132	2132	1874	1	1	768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UA2G4cqbzStuY8Cy2585PML2gdU6bh6n6HCc9n4wvKXpAjV7
29262	payment	2133	2133	1874	1	1	2296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGChZsVrrqgbyvLY2FbYeo767joVAJWjMfVmSSEWytrFz8hukd
29274	payment	1397	1397	1678	1	1	11883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBrs1LQoskn9CbeFnT1s16sUf66ZUtoWykrfytvqdPyqTPa9X
29150	payment	1397	1397	1678	1	1	11852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTW1taM5qo6ufgCof8LzdJTF6ALzdNManw7n5a7D6W81KWPJBP
29151	payment	1610	1610	1983	1	1	10	1344032450000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyFrZiHBaRijsKALHXKqhmL3m3Ndo25JP6de61sVNDwv6e7Fs
29152	payment	1397	1397	1678	1	1	11853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeig8RLipbSbyhMiBrXcDKDvo1kZDudn4BjxN7YbeMStJWa8PF
29153	payment	1397	1397	1678	1	1	11854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4vhwGbTMd45LiC2jq1W67ahFFCYFshNH4hCUujzE9HGJnp1X
29154	payment	1397	1397	1678	1	1	11855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCb7smBdv5rcBFoz2KzeFDHZRodsAGZyrtUUGd4uaca4qd7fv
29155	payment	2133	2133	1874	1	1	2265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvTwQTs7BmHRAs7NpSxbwG9xKUjKVkDwWYgWUXowm9iirGB1a
29156	payment	2134	2134	1874	1	1	2697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAp3WXroMB2Ks37BYiiKszvnpe5v1bXMfaRgYCWTpD9ivnE4FL
29157	payment	2134	2134	1874	1	1	2698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLBnyiD7ZKASByiRK8F5efwZ9FbHCmBoe2aZmmYV78a52L98U
29158	payment	2134	2134	1874	1	1	2699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1Q5yjpeQTH38ar4f3obcar7UHjFNHvt5LuJZRxzwv8RkQXYe
29159	payment	2133	2133	1874	1	1	2266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirG7MakM1nWHwCadqJkRLcnh3hFPf3JThFEd2vpy95BxScFdK
29160	payment	2133	2133	1874	1	1	2267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCQ49a2iSAqshem7xD93Z4JjoAvrSHuWxwZcH4j463DXeBc4i
29161	payment	2133	2133	1874	1	1	2268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5Y5Dp3Duo77kccdTy1UxUdWvi2udoJj1kJ6SeZ1pA7mwYDFZ
29162	payment	2134	2134	1874	1	1	2700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UDbPpNBKaWoyGLyyAEL6ppq1mj4QfBNQPpyD6xAGdhoMTQbV
29178	payment	1668	1668	1370	1	1	7	8307716000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5ZDpTTVV6kDPBi6pUoNCVdvJBM3LeFfLs8nss954z7sXupXL
29179	payment	1397	1397	1678	1	1	11859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYbutJzYR122wyBAhenPUvoHbnLFzxLmbH6ZHmErRnrJ2qyHa
29180	payment	2133	2133	1874	1	1	2272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW3z9kq4g2K5nHXkqQMbcoksXDMQEUhHARfKgHS44mMnuE91E
29181	payment	2132	2132	1874	1	1	761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjS2nqMaksYhgxjpUxo1DHeVB67zTfPxgqWDhjFnvbnxpmoqAE
29182	payment	2134	2134	1874	1	1	2704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWpAAmWRqVe6ycp8h6aZ3k7smvFujF5N5L3chjW8Kh4qv53CR
29183	payment	1726	1726	2249	1	1	8252	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWVkiUFuSrSJ2hU3F3P5RZoUr5Xq99AuEGdb7JYqvCXLj3eM7D
29246	payment	1397	1397	1678	1	1	11875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1tW7W42AVyd5wKcBW4JX7dDJvpf45y6YZUYfsB8ah4iFoGDs
29247	payment	2133	2133	1874	1	1	2292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBYsF7GKDX2ybQonbP7D8RvySBMLGtimAXMe5poZdVxVb6u8g
29248	payment	2132	2132	1874	1	1	767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5AJec9DdRWJjwHKinhydspovY8YnAGQommippTo241Uz8sTh
29249	payment	2134	2134	1874	1	1	2723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBUJ7D2VTG8Q3fJkyRKahnnBhFFxKwpnumtGM5qEMUEvi6qVs
29292	payment	1397	1397	1678	1	1	11888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3P4WpLWQY3hxP188EQQeVEF5nFLhHgPxhCx41eFnpxtWX1TGk
29293	payment	2134	2134	1874	1	1	2735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2f9MNaFUd1STrEVmmVE3XgQvmLiYTdLdzqvvHGqUZW37Wt1o
29294	payment	2133	2133	1874	1	1	2305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSX9iV3a1xg3DYvCHBER5tMHbT2ZsDiiP1q7TToYVgkqLcC84
29301	payment	1397	1397	1678	1	1	11891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinjwFLEQ5ABqCz2iomyKX9fWp15bQsFhj7oqhMyh6HoNg2tvG
29302	payment	1397	1397	1678	1	1	11892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4prk7pCC4EL533QqqrCTtGpgPyfmpXTbdVBceS9AqJ1G1yMG4
29303	payment	2226	2226	391	1	1	0	490000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCUckcZh8pFdCuG1rt2VVa7nSRazrhzsHuocdohqqdLxuirgF
29304	payment	2133	2133	1874	1	1	2308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBsoFrjebhtfZW66gTCKPSr1E4KEPUuq2YwEunbY4Uc89E5rU
29305	payment	2134	2134	1874	1	1	2737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN74fk7Hao9LpUZJTmDaGtf6TPPqgjfvNH5dQLEbx5obEYsZkP
29306	payment	2134	2134	1874	1	1	2738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAnRi7JGRhutxtE8N3iy6CZjxzeqxwryojXtoZvg4xCJXWRLC
29307	payment	2132	2132	1874	1	1	772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R9khnfFvRCpZGUXnXidaPp7rj13u4EE9yF7Nh7A1oRAARfuu
29308	payment	2133	2133	1874	1	1	2309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBH4dbYV7PgtHog1DGpf8sLV15PigEsCzYUR9byWkDQqcnXGg2
29319	payment	1397	1397	1678	1	1	11896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos6YVifYHRcb9QhnJuymqFzsGygRH8nwwVSJyujrzcZN4DyfT
29320	payment	1397	1397	1678	1	1	11897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvi4iGKMrqq6JqgVCdQehpdmNxFv2ih3jW6rmzZZGrHbkMYK8o
29321	payment	1397	1397	1678	1	1	11898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFHUnfRP8oX4aZTHMbQDjsM6okiT7o41Fa87xn4BhwTzu3Xax
29322	payment	2133	2133	1874	1	1	2313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXxwqWJNDvBUArhBakikGQp4Ufa9gh9wJjYVCdsJEmsiFF7vN
29192	payment	2133	2133	1874	1	1	2275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfzH2i5SUsTD1tA6ZuMd6v69jpb8uKwrMyzNdyV7rMZvkmC5Q
29220	payment	1397	1397	1678	1	1	11867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj6m6Han4Ft2qRaw4gqz7XCuEBRhrX6cVuUbpNggzbXijsT6E
29221	payment	1397	1397	1678	1	1	11868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL37ytxEhwEfZGjoyerX3bfg3pVUpVKz18dZPwwiZnywWLZG1Q
29222	payment	1397	1397	1678	1	1	11869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5RpLqJXkx7MyoZJtnSJuoQWQeX9286WSbpvD4ApBHec9tnZx
29223	payment	2133	2133	1874	1	1	2284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KrA5eMfMYWTME4sLYpmCXCfGzFFeHQbE9sKH9GGbjdumZN3X
29224	payment	2134	2134	1874	1	1	2715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrE84RNty712mgv9BztXpoNQKtfo4dcRB7Th5z4vThYUtLNfe
29225	payment	2134	2134	1874	1	1	2716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA64wdFTNwLVwLhRw7jvr4Hs3yibzJUodwHd1GUQTGHRHEzP1
29226	payment	2134	2134	1874	1	1	2717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xg9T1nXoSYNJrwhcnkvo2fPQU8qsdQEJgRaLBYovim7zoeyS
29227	payment	2132	2132	1874	1	1	765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiprvxMuXWzro3WrxqH8kF9xwC4shQTcdcWFM7Cfjp8CWMYoWz
29228	payment	2133	2133	1874	1	1	2285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ShcRXHSmZJKAfebGkNAbfVr34W4vdjoQfcCiTS2QfJ1DEb8g
29229	payment	2133	2133	1874	1	1	2286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQBvL4ZbnnG9wAYbJk9MY8t8uiNZuzPAfLiXZRWt3RRo7KiKP
29233	payment	1397	1397	1678	1	1	11871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQZr48mxWazQeMFtcTF9kesD2VZREJZvA5rUmyDjd95wWhQLf
29234	payment	1397	1397	1678	1	1	11872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTnw6QycFMz3vhehaF1sm48MjKLqGjguJwGVtXCLBo7cz6cCg
29235	payment	1397	1397	1678	1	1	11873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWjj1isP4pqXHMdB2bL8JGo6PxzykfgY1VyMNCLCfd9s67BcV
29236	payment	2133	2133	1874	1	1	2288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3sqmEi9gSrbjZ7hwLdEXpiwKFNV5X3ZW1WPDTPe5rRa1vyBR
29237	payment	2133	2133	1874	1	1	2289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuN7WuKxFa2ns57NNo4NBjGgLrdkvQ88yb8jvhgvKrATqzzo5d
29238	payment	2133	2133	1874	1	1	2290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5FJMqbdxMbMogkf3amsMz6va5RbxEGrYeC852sAzFhYqTE5F
29239	payment	2134	2134	1874	1	1	2719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUdpmrWdK3uGQYFaatzGJxFxtzpRfau6ZpTCJLqk7aYVhPxex
29240	payment	2134	2134	1874	1	1	2720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9pohe1SFmn3b6bSLfncffkAKucz7eNs9QEEfgzRmdQJvDpr2
29241	payment	2134	2134	1874	1	1	2721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttwMXfzEFxxw1N8ZoEJwwj2ujAbQjm1o5gF7Gyte91ajWpusb
29242	payment	2132	2132	1874	1	1	766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAN95zjJf45NkMEhCeRoQAfbLaj3ASGpvVV92EP1ko2f54bJ3
29250	payment	1397	1397	1678	1	1	11876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLpDxcCzUfs6QLtJ3mBnDr1rRS2Lrp1dJY3ggKUY28Tc7L8pt
29251	payment	1397	1397	1678	1	1	11877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LcMZHYcUFtUsCwcWhbE8HwPEvxCfb2xgxyMPa8PEHFCG9QDc
29252	payment	1397	1397	1678	1	1	11878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHhtBzK8kyTkWhTd6mPuUq2KNngUXRUs7MkkmPJhShK9fyWw5
29253	payment	2133	2133	1874	1	1	2293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotyckhMrUjTTH2wYjpWuva1jTUD4xTEkKzKm8SrkYWAjpAV65
29254	payment	2134	2134	1874	1	1	2724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxR7ikbp417DTacveq5rpbYV77CMgREH8H5ZjnVBP3KPA3PeN
29255	payment	2134	2134	1874	1	1	2725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4XYrSoiyWBAQyFeAb3hPfwCiFZhp9dBYu7iHbGUpnaBG8UAp
29256	payment	2134	2134	1874	1	1	2726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ55ZBjkNfGE4J6oZJpziVJFt1zPTZhXUbgfsv8LgT7Avf7LG
29257	payment	2133	2133	1874	1	1	2294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsEJVCW3xrbQc9rhyQxuWkTo3vpTFEaiLeiCV6SznmDaWRYtM
29258	payment	2133	2133	1874	1	1	2295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtRGNFoWqvTicx59h1T24KJeFFsenSanAc1pNGAaVrpNjBymh
29268	payment	1397	1397	1678	1	1	11882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG4yU4UkknMSJvTQ8uxyFz1DDsPVpGEJfau9uHG97Jq33rvK8
29269	payment	1700	1700	1305	1	1	6	8590478876308	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZKrNhdiVYnVjELZ8E1BzbMJEjzU2jr4eFaLN2M3z6rP69iriyG
29270	payment	1700	1700	1179	1	1	7	3082793744688	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYpNBcn2tfEEstSWCdhV8qbAbxepD6MySjRStdYSqJsgRTufSe9
29271	payment	2132	2132	1874	1	1	769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUj7jcLvnAGXhX8rbXdkJGX9LMqo169hzQfKievMNZjG2jbSnn
29272	payment	2133	2133	1874	1	1	2299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZJBV6h9d3cXpN9f56H7arvtMaS9xKG64v7ZY2ak1DzxjFkNh
29273	payment	2134	2134	1874	1	1	2729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyoeeccFfG9c9UWg1dWaMpx348qnW3eA7avxPbrbiYJ1V3jnB
29278	payment	1700	1700	939	1	1	9	2549676046680	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYt8H93wKA6LoRBdB1uyNQX2ZJFC3FEbRA2oEvtUuwAeoyA2b6h
29279	payment	1397	1397	1678	1	1	11884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QYngzyTUAsVPuv91ML6E1i2feRU4hYZUdbGQpnKUjtgGFPDa
29275	payment	1700	1700	1059	1	1	8	4568997630008	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZ3s6NwESRsHAgfLVwSUpzvMtkLGXwEuXPtGoMsDxADYfa3NvnM
29276	payment	2133	2133	1874	1	1	2300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrVajwYeVQos6XEgmBsNShXX9o4K5xdnqVovsb98UFejXtHPf
29277	payment	2134	2134	1874	1	1	2730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyhJom3D7wQP5fNjZVC1ZZj3Syo4Fh9v9RPnstX2xhv9U8Gmf
29289	payment	1397	1397	1678	1	1	11887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FVNDtUB2jb6nNY9GX5rHYUoLfhRCs36hGSLG1jDgMRfUWVj
29290	payment	2134	2134	1874	1	1	2734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJ6xUehb6QqM9cyjkiED5G9uybJmCzM92bL9TVfb6QPA4gi2o
29291	payment	2133	2133	1874	1	1	2304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnpQmPzXoeYuuLDQ8n6X8kd24RHUyCNJzWTvUxUX2nFDnLiCh
29309	payment	1397	1397	1678	1	1	11893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKwXcxfQrkHGve4CpfYH1fuqUYuKByeqQC9gjkMuDHoMErgkB
29310	payment	2133	2133	1874	1	1	2310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFQuRNZdxquuXjjhj8Qf4W2Histb9ZTjGN2cXDBm552HDPk1U
29311	payment	2134	2134	1874	1	1	2739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMDyVKEwAd3DZvWwbpFC7TzgJoZzNCP9ygMJVaejKF2iUcA9f
29354	payment	1397	1397	1678	1	1	11906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtH2Eg1sGLZoz1TwS5apb4cQq6nCSWknhKbpwzo7GWFhTuGpP6
29355	payment	2133	2133	1874	1	1	2322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjemnj3hSbBJxcKMw6kgzvnhvWJt2pbjsU6KBjp1BbEiCLGmEf
29356	payment	2134	2134	1874	1	1	2751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwahUu1xf9qAGqxTWn8YTPVuz6d78bQDQGqDzazAFMdptNvrLv
29364	payment	1397	1397	1678	1	1	11909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xkfDxkhQ69QCkE2ZR2SZk6iWQV55DnxF9TmWeVPPsMz4egTE
29365	payment	606	606	1049	1	1	15	3595685819297	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc2MdDu4LMZS2mFXoF7yqq6pfMSkrW55HEoj2KfmUsuzS34nv
29366	payment	606	606	1169	1	1	16	2426406151455	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiitrEBZeDHWxHshfHwfWjaBn6QJKn1SqNa4StEaiUJ3nmzh6m
29367	payment	606	606	929	1	1	17	2006972659861	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUEAxyYuzJ8FhmPj6StubtD8g9DAyy24oRADZVFKGGd3BsebJ
29368	payment	2134	2134	1874	1	1	2754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpJxpn1DxURiXny2HxY8dn4pGLnKnHPzqQcUHK381vNyj8pTt
29369	payment	2132	2132	1874	1	1	777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrtVqPk9eUr5CQ7QsaQfWGc1oMeWyGJNv7WcTpSqoT7LDphJS
29370	payment	2133	2133	1874	1	1	2325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SjxATzARKVEsKTPmGb7Cm3THyCinqbRiFLEfiJH4iciAmnpg
29382	payment	1397	1397	1678	1	1	11913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9J35ssRReamCVAYVAuC4fBf6334ooW8EWGBpVxJjpmxzSvois
29383	payment	1397	1397	1678	1	1	11914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiii6TKiwFX1mkXgrQJhXe49xm3RnzfnNE2R6gxFnDmDDoVmy
29384	payment	2133	2133	1874	1	1	2329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBnikVwcfqBq291U4xcpDCahu28P3TDSfpG4Fsinr9bN8zqUr
29385	payment	2134	2134	1874	1	1	2758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVtNPQ3KJfLtmPGNqykjd86umd2YqxtDsNzTGbf47EXVHiGzj
29386	payment	2133	2133	1874	1	1	2330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshR8rN6nWgFrneTvYEWcGxsbx2FvQFso7V8wyoNVJmBq8YabK
29387	payment	2134	2134	1874	1	1	2759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z1M5RujTi882TS5FytyY55mFMscs44We9pksyM3fz4txL5zG
29443	payment	1397	1397	1678	1	1	11932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREFDjBTNrRvQfuE8rM3zyHJZvmZL2dGrguMpBP14iZv7agEcD
29444	payment	2134	2134	1874	1	1	2776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHDZBfVE3iSERfZtsN28Xnn75XG4j4aM3EfVQ3KvvNtYENmop
29445	payment	2132	2132	1874	1	1	784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBZR5T2gsaXbqUcfd74ERxtKu74m3NB6bjPB7ypkorMti8G99
29484	payment	1397	1397	1678	1	1	11944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwZMDrj4EbvxSA7U6zoPzfFXuTFcwePmVSFFvdcYHaAhNQadL
29485	payment	2134	2134	1874	1	1	2788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv9q73RydbtVWhiXt2mh55XRQfUDw17heBZTAbi7hVNbAzAzw
29486	payment	2133	2133	1874	1	1	2361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8LRq2NQgDpByEFtGmPcHj9F65gR1xrazfSZjsuBF1k7T7mAt
29487	payment	2132	2132	1874	1	1	788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwX9SuiXaJ4n6BnwAtHsFkHAQHTcZk4rvTq3TwHVpSAAdmpX8v
29523	payment	1397	1397	1678	1	1	11956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbKGMar8BDAawFXDRPf1Xgy63SV6AkbsFwq5nHtN4m5RaoPq
29524	payment	2134	2134	1874	1	1	2799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dw1nePqf49nNP4y9SddXWmcqXg1BrPqjiSQKrEU7uEF2eMLY
29525	payment	2133	2133	1874	1	1	2373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2WxuVwxasnS76euUxo2yuB3yH7evS1KJ7AYQ7LmFY9SsvXXy
29546	payment	1397	1397	1678	1	1	11963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfXiUaF4TEfeGTdWhrtAJZSHWDB4kmrqQ5BQHTXTsNooFEybX
29547	payment	1397	1397	1678	1	1	11964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvjw7FwKSPGo1C1YaoPxPw3akgdJAsCF9tkYHthPH5E3yZH4A
29548	payment	2134	2134	1874	1	1	2806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVikYALR2Rj1Ra46QxSC1r5axSczJZGZx221y3ALUBz1dzsS1c
29280	payment	1397	1397	1678	1	1	11885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDq9zvmnVtYnidDk627FssZFxLB68zgG8nTzuB6GYBnBtX5d5K
29281	payment	2133	2133	1874	1	1	2301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNfKtE5P5bCJFvChzS6oLJEE9Uky7wLwu6zvMXk1fSAKVvqkv
29282	payment	2133	2133	1874	1	1	2302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42tab5cuWkMd9kCca29jRgP25rPWSjFfRVibVLmo8YBuNHASK
29283	payment	2134	2134	1874	1	1	2731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8Th1gyGvHgbuhffwMy7roox4zGufWy3je4KbUdvPmnhHuSG5
29284	payment	2134	2134	1874	1	1	2732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKxmKMNk4VwDKsF81vS4c4dJkumt9k2G9v1Zraq5c3JeDhPW4
29285	payment	2132	2132	1874	1	1	770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGnkeM9i7DEygT76fVbhvoJfNVyNzAPby658xCufbdDT46T8A
29298	payment	1397	1397	1678	1	1	11890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfKM3uN8T1CTXMWuef4JJie2wgExqkoGV4z6nsUnLdBKGd7wP
29299	payment	2134	2134	1874	1	1	2736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjMV7YKi69BkEsKVJJFKiV6P4BcfGjDKpVMwKTVJziJagKyg8
29300	payment	2133	2133	1874	1	1	2307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBvr7vusiSkxWTXNDiT8oDNVADaCuawMWmXXEH85WyK1dHz8Q
29349	payment	1397	1397	1678	1	1	11905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GMJRTD9Q8ufyg6CGrGkWg9VPofQw27BPwoXdUeYBHH1Nt1fH
29350	payment	2134	2134	1874	1	1	2750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFf956JFnc12KdXWFXchPPvtY22MZZmC2KqTnCxCJJMs8S1cH
29351	payment	2133	2133	1874	1	1	2321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X7ooN4ZB8quPadHqCU3jWADuCETJSvFTPKpvJnMLUzH9gQFg
29352	payment	2132	2132	1874	1	1	776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRNjjHZFSWMrsqMT8avXtfmAq2vyFFqzknJzy6VsdTg6YhpTW
29353	payment	1710	1710	1280	1	1	9	9216286221960	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoK2rNMUgVtQe2niakkxrk9XKkRoEz2vAWJ9HmDSVUDrVU54W
29360	payment	606	606	1295	1	1	14	6759609896119	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmL9m4WKUTmivG8v56KKG6DETbp6VY9EuFoy69mtQQnpYn3sc
29361	payment	1397	1397	1678	1	1	11908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfUkdMHMoBZNQUzdAiDZFgR6tFqVBUaGSfLw6wCgwbqpvgryx
29362	payment	2133	2133	1874	1	1	2324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBzUFa9LFi2nS3tJ5D6LcsCNJ6Z3Tm86sBQCrE4jvdjCMxrmo
29363	payment	2134	2134	1874	1	1	2753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDz6HiQ2a5YoXyPwpZ5y9P9jtTVo69uo493B525vaweyT6E5iB
29374	payment	1710	1710	1280	1	1	9	9216286221960	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYJBWrZBXHpTCZJGAdvHP4y6MbYpeQtrHDYNEuKdxv2opjUQU
29375	payment	1397	1397	1678	1	1	11911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8H6mxZhW2fjeG6NkWsi4Es5pRwzMRxKrYGLGdaMdSNky7DoVy
29376	payment	1397	1397	1678	1	1	11912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroqs78ZD9occBz5H6nY4j7v29icsPhds5nQFSzcxFca4g9sNL
29377	payment	2134	2134	1874	1	1	2756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RpeEJ7nAX8XfjktK9mnNDy2QW2S1RxgCwf35xTSs3kuLJmfq
29378	payment	2132	2132	1874	1	1	778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M7L1gLYarpfjXLFAMn31QsYNZ7YGKMNpNG4ncaHMDSCPwm6D
29379	payment	2133	2133	1874	1	1	2327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS9wu1G3KWPnsnvMi4JyR7rMmQs7nmLUdK6u3opWqXTJPcnYS
29380	payment	2133	2133	1874	1	1	2328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghS74HkwPDeC36BsKAfUsUNdmnMHb61NjcD1Gxc6cD34roS91
29381	payment	2134	2134	1874	1	1	2757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBBiEKwmTewbpvb8PypA9HJWghnDHv4Xs43dZyq2r84Afufky
29410	payment	1397	1397	1678	1	1	11922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAths3S9bRiTM7Wd7cZPAnxWrfKeKM5inBX86FKkJVmCkCmkfr
29411	payment	1397	1397	1678	1	1	11923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwb2bzKehxBPxnHMvansmzK3h65qwrJSXzf9Xvaf192ezyCpm
29412	payment	2134	2134	1874	1	1	2766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YwaNj8tzpwA9Efwb58zHrsAzNHE8K6gautLLGKEn4EWFxgGP
29413	payment	2134	2134	1874	1	1	2767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXufNUnXXY1yWdUWP411ftUh6pUU2m4bwPivJEyzLPjRGzz9p2
29414	payment	2133	2133	1874	1	1	2338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfcZtAmRp6B7tio3JLQXXk9KVWZMY69t7pVe89w9Q7VigBo3B
29415	payment	2133	2133	1874	1	1	2339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMg87qB9aGczDRsZsELritL1PAfQ9iDe5EpRtLVxMEhH4Fmd9
29416	payment	2132	2132	1874	1	1	781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcknt2kXQxL95KABzsEKy29rHGvctCNuw5AGeSsQBiHSmwFir
29447	payment	1397	1397	1678	1	1	11933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14ZdF3AiGqgffLQqT7vGetvra2fWweiMBniQukmMBq2bhwALW
29448	payment	1397	1397	1678	1	1	11934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5pW2CNbu3fTuBN2CmLB8sEbW1Xb5mgWhbFkSc3hLYNhDrVTR
29449	payment	2133	2133	1874	1	1	2349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhh6no9Yd1mAHHMn25B8pnWcq67NJ8mKUjawguqnYrDGRNJ3v
29450	payment	2133	2133	1874	1	1	2350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnM3E9tsWGRbTjPDGbsAGWdzV7a8oHyx7U61dpndm6omkd8ayk
29451	payment	2134	2134	1874	1	1	2777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTewT5xwpggzKUPPgK6hCmzmSqFspY3EdBks57QUyJDR7PLNY
29316	payment	2133	2133	1874	1	1	2311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUWiCsmewg5WBRANtNkPHz1AXxrbfCWaNVQYTNrMqAtE2j9GM
29317	payment	2133	2133	1874	1	1	2312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjStEifjXojaCW5tMdAiwWLZ8XrtH9ceD6aphE7Hg6MHHfpgeb
29318	payment	2134	2134	1874	1	1	2741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eTCx4ChhCteXGRcXrXrhWqDiAis7kSgutvMuhEQDkhWyphJ5
29327	payment	1397	1397	1678	1	1	11899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LuAhCHkeQNK8tRSpLZvTxDgDQGyQrkJrt8yrMW4RtRxFnM2p
29328	payment	2132	2132	1874	1	1	774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2UVVLpXGUFd6XSUTEVNy84g3D4oWrmhhBgoUQdA1yBUG1ih4
29329	payment	2134	2134	1874	1	1	2744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YBM1LshS8JvnWDDjbDqCKpAfn5yUDBYT2Q4QCkjLakVuDtUi
29330	payment	1397	1397	1678	1	1	11900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMbbwp1qjk9hsmn7yCNVRFZY6inSsQgoSYX44X8d3btPNL1UY
29331	payment	1397	1397	1678	1	1	11901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEJVoFd2HTGwx5WTGwi1RMRCGX94KQZ67Ks8LoY5v77J13ofA
29332	payment	2133	2133	1874	1	1	2316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5W1WBWhoAMXLiNaicZqefcT18qtPnhdHz4ToVJ2HWcq5yQekF
29333	payment	2133	2133	1874	1	1	2317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQG1fuDaNkwkCozMNgCukpop1pX85VS6PuZK7SEsu4Rb6BFhA
29334	payment	2134	2134	1874	1	1	2745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxNGtbgM7Zk8TC3MaGRcfWiRu9sNkxhy6s81TapdXD7RnTQNf
29335	payment	2134	2134	1874	1	1	2746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXqaUKvBGaGN8q7KWenZxugEPvyUhWqoaCC48RYMatWGMdHNb
29336	payment	1397	1397	1678	1	1	11902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4xQ23dGMQYCxUxQtTM95i6Kq7Df2ZaFYtWP4qwV3QxKL5ez3s
29337	payment	2134	2134	1874	1	1	2747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5cxXo8CbJ9PdXHZ85aRehE4F8L4waiw8tEbnReAY3Np7d9KL
29338	payment	2133	2133	1874	1	1	2318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vFhinLNMxTM5u3QHH6bVabT1Xvj8bfmX9VBcxP4oKkuvRHfS
29339	payment	2132	2132	1874	1	1	775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa223T794sh5D9cgVsMxobir72p6aVAfAU6vd2LtiWDSMYEBhQ5
29357	payment	1397	1397	1678	1	1	11907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKyYF1UBTkwJAkgXZjy25D8d2kduBb77nDY6CBXtEhWZviRao
29358	payment	2134	2134	1874	1	1	2752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTe18sDXZqf9svfieKGZSemafs37oiigqpdHj4xkZ1YTVTK5kx
29359	payment	2133	2133	1874	1	1	2323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9obq49PPYTNZ9RLexDFXaTD7UWtP6echNvioBFKYBGoX5qvG
29388	payment	1397	1397	1678	1	1	11915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqakArjExcNuEK49MvXLmqLiomrDGAVc6n1tZbef6Mqtc6krGJ
29389	payment	1397	1397	1678	1	1	11916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpk4XPX2LzWqoSQ6GZoHEawaL94h9BfcLE8vJLDGvEPCg27FM
29390	payment	2132	2132	1874	1	1	779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqbVViK6zcLx6E6MGqb946P1rKRoiiEr1k8rjuHf3tctVxYvX
29391	payment	2133	2133	1874	1	1	2331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJRytpZQq4sBPDUFTXxda1MTL2x717saQEEHEFUDJeNXVnaVv
29392	payment	2133	2133	1874	1	1	2332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYke8vJWnnVAYFiwkPci94MYbtH9Ub1QTTX3RJzKb4M1uT3xAJT
29393	payment	2134	2134	1874	1	1	2760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopbcWBbm3kiyjgmu5HunaVDce4sY4DJAXPmGyN8S61bvzHzYv
29394	payment	2134	2134	1874	1	1	2761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYXQnQZYnFJnTUEjs3RNsBg2d36rZUitDthNH8Xi4W42zxJu3
29395	payment	1397	1397	1678	1	1	11917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ23QMU4HYEFQZ2zBv7ZGt1fkQXuNV92VmEFwFPAF9vSHxnNVpc
29396	payment	1397	1397	1678	1	1	11918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDySGbZXduuWEk1DPRtx19fRp4GwPMMn5UPqk9VUVtaxSQhHiT
29397	payment	1397	1397	1678	1	1	11919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmkcJj5UxAgysD58ZyPKq74CeyzHgdm1emYmxAe1z8Z5csqLb
29398	payment	2133	2133	1874	1	1	2333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmH6qP5xk2gzvVH7xFGL6CuJA6sofmTHdEi6iyKJmPfeYNTKrV
29399	payment	2134	2134	1874	1	1	2762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntbA1rGyRo6ouoBA51i8nbk5DhUFX1KFEk5mxRnMDxnxhpGQe
29400	payment	2132	2132	1874	1	1	780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDEBTPWCgb5NqnuzMwnf4Racr2moqbamoikCpkvF4cxhcSRiw
29401	payment	2133	2133	1874	1	1	2334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzY2f9cfTTDbpNrKpdSgyYuxFoF5gr9fRZJAk8k7WgcB99RYMC
29402	payment	2134	2134	1874	1	1	2763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uZcdM8xtLE6eXcJgBt7LNAzWLzpg1HwequX72QWphcv1wayB
29403	payment	2133	2133	1874	1	1	2335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJ7yrNZahwV44YPhSKTG6rUhVZqYwxUD6VwPb64DZJygFjuMU
29404	payment	1397	1397	1678	1	1	11920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQC4qgrgyRuxa26mZKfyDCtBUhVMUVg8mwgbqv9CJDzzqCm4
29405	payment	2134	2134	1874	1	1	2764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrHwoiiG2dAaZRLGKvVpSgnwbtVu1ipDeoThU4Uux1AWw6jQbp
29406	payment	2133	2133	1874	1	1	2336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gDYCQg3V5K2zG22JSPtHeG2vh5ub8wMhUPQaTraDbb8dyreX
29323	payment	2133	2133	1874	1	1	2314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgoLjGYvvfd65sdAEYcUh1Yzs5UP6gudxno9eKAXPVwZ452rB
29324	payment	2133	2133	1874	1	1	2315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb99gM8R2M4FP9ahDZbVizBoudLxJiqjwyiyeNzQf14ZyEc7T
29325	payment	2134	2134	1874	1	1	2742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrx4FTKM3g2QsY5AcQV9jkV3bRyggn6y7XqwGHfgsyVTYSCbG
29326	payment	2134	2134	1874	1	1	2743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3njAYyXKZf1tv5qRXidPqAjzFMheUtJzMjYsrPcP7pWcNWBv
29340	payment	1397	1397	1678	1	1	11903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPwB3RbugLMRvo2DjPtWHKC3Qx7uvpvruoknZZu1pHqJSTUz5
29341	payment	2134	2134	1874	1	1	2748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDPGKeSBYq21eHZkTzNeyzGpJdKFbpt5ympboiwCe8gG6K2r6
29342	payment	2133	2133	1874	1	1	2319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvra19zPSfbdZYV6kzz8y6ADufx1XnLXinXu4M9iMTEVVRjc3r
29343	payment	1397	1397	1678	1	1	11904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8DrGiRa6yJmvmXb1fT7X49L9pnNqbHaFuLHBm5Y1jxMAHpan
29344	payment	1710	1710	914	1	1	6	2735417263440	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLzsMqpBGukLyrwDN8dZ8bGCdbqM9WdsycbVmJ5nMJLtNEt2F
29345	payment	1710	1710	1034	1	1	7	4901844299040	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWHpRoahZvv7ogVhLJ74jZN5M9tT1Y7kfTwmuBL6WhCqv7m9c
29346	payment	1710	1710	1154	1	1	8	3307372024710	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZyvhpo61Cs6i8V5U6EzM7uG6jG4TJE6a5VD6r4KW5XSZKs6Z
29347	payment	2134	2134	1874	1	1	2749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFDAMdD12rCf8ywe4QzpcxEQTyKULfH9beVUL2DdG3wj9CUfX
29348	payment	2133	2133	1874	1	1	2320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqVxm13Enr6yscY9yghPrDSG4t8me37GTPjdJnC9aP54rWk7Q
29371	payment	1397	1397	1678	1	1	11910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RHubEnSB9jUMrT2MTxTrpJuZuF6ias16CNDUrxVTHtJL3YXR
29372	payment	2133	2133	1874	1	1	2326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQbu7WZ7zxMN973BspovNpJSpSxgQ96cmfdgDkRpcVdedrHxF
29373	payment	2134	2134	1874	1	1	2755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZui9tU2XkVpfTPV1TdxP7G7EfXNzc6LNjsWoP9JVRW2ScxsgyS
29407	payment	1397	1397	1678	1	1	11921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRcUkvv8st7aWWP3VnhDrnR7Cv3m1H8Aav2icH2RjiEoTSB6A
29408	payment	2133	2133	1874	1	1	2337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46zC7Z423t21guKutkubPeBegVHcURA2eMQrpacP2uyHJfzd8
29409	payment	2134	2134	1874	1	1	2765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAngigxoWFyPvZ3fMBFtDqJ4incNkgC3mLMpjzTzkLdXRT6n1Z
29440	payment	1397	1397	1678	1	1	11931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnWYtRuKR3g3hYgYVpzmcAV36RhtswpZCwtCDtSsMf8tVKMnE
29441	payment	2134	2134	1874	1	1	2775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSwWwjSsTbPHPD3RqpgKAvPNdnsBztK3pYZauxDBbm82MupU7
29442	payment	2133	2133	1874	1	1	2347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa553cp71a4Cp7xsw1wBQePtmCLRs8JvPAcvEKkY9a7U9SofWEK
29453	payment	1397	1397	1678	1	1	11935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofwwCo7U7CZkpNEAtYwzdXGgWSzD7n7rNTmQW4atMS5Fmdxd
29454	payment	2132	2132	1874	1	1	785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUWfnzLtasVqvkMrD1jVQ8KX4QHUWw7rT7dS1UEQqbcSsuPW3
29455	payment	2133	2133	1874	1	1	2351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eWebCGjdTx2ZgvVLGrYLdJdfyY3ZZrSZibtaV682kSERoZpC
29456	payment	1397	1397	1678	1	1	11936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtibVtLzYL48BeyRuL2PZK1xyBcHgvSWeGDumwB1bKxAX6AV7
29457	payment	2134	2134	1874	1	1	2779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrW18Gg5G4ZKHvP8X3ymXUjE3VgSLAsHzLZctYNWtACzEqtha
29458	payment	2133	2133	1874	1	1	2352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVHsBWBdDcQEdFZAZZTRD4xeYehu2JjdEVqiJt77q1Ybctdxw
29464	payment	1397	1397	1678	1	1	11938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYet8CKuxQqRiZPzhEGVNvvrebFtqdK4RRdxRTauCc5t2Z9TGRr
29465	payment	1397	1397	1678	1	1	11939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4VwZq2a122U97EvfWxygZt89wo7a5SKrCynkdAXa6g9xMm6d
29466	payment	2132	2132	1874	1	1	786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVEC18SKcMQQXafgJyb3kogtSFZ2j8m131mDL2zTLLEjRUbK4
29467	payment	2133	2133	1874	1	1	2355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkd8wUPRPmSB19RDPGiebfvMjxKy2qu5dANczLt4xxwcgj74Kp
29468	payment	2133	2133	1874	1	1	2356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsH1WCWGCQavfsTA33epuwPtqs3ynHaDDkvrt4JhrEbB2sBPy
29469	payment	2134	2134	1874	1	1	2782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhuBPBw16wqFdsbAn3BqvRea2ADRzK9Yo5cBjUJHg1VZVaJP6
29470	payment	2134	2134	1874	1	1	2783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVabmumthfiHe9W7JB9kvrvaPxtxX8hDLScYhfX1hr81NEQTR2
29478	payment	1397	1397	1678	1	1	11942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48WPKQcdj9meUo8eMdvkYG6yNMVJP1TeNwa7SvPYDgnQQCjLy
29479	payment	1397	1397	1678	1	1	11943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7v8pgZx7vKpSpHkCNjKhn5HfP7wthdigeZ3eNBNWA655zkrz
29480	payment	2134	2134	1874	1	1	2786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgBt2yU8V1vYAjcFpuTDzBUmWDGFbCZ1471qYp7U8fYBmPMFu
29417	payment	1397	1397	1678	1	1	11924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLUtBfsjqSPeQgE6gpeNAWeMe15yfZ9YZaxV5FAJHG6BZhoan
29418	payment	1397	1397	1678	1	1	11925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwqdH4ris7LVyxbTDCm3XLjR6NLN9q2rVqwgFXRrjc5bwEdpp
29419	payment	1397	1397	1678	1	1	11926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKp91hbEcAY5sitUW1jWtFfKhtAZpULzpomvXfpsauBTzVaR9
29420	payment	1397	1397	1678	1	1	11927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8L9F4nazFnzRQHQCtg9hcc7s6ttYiStvW2WoKdshHidHAp2Kr
29421	payment	2133	2133	1874	1	1	2340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA6J3RTwd8jWzhNY8NUJsSoV9ZP3zMab9cHUYgAt2CfSq1Jsj
29422	payment	2134	2134	1874	1	1	2768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNbwzmcwbui7JgX4BAsq7NXso4LQxo2tBv4tPYmnq67Ntn1kw
29423	payment	2133	2133	1874	1	1	2341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNrPbc3hoKspWTTXR6L7CAWdFVCSTHtzf5AcqYTDKefQtXXPp
29424	payment	2133	2133	1874	1	1	2342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNp21WyBRQJZiyStZnhm4ShHeuWgzumXjN75D3xwYhmWnhfvV
29425	payment	2133	2133	1874	1	1	2343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJSEse1mGqJaQ2ik6pMt1vbDmxeTuFs76cZrrf1F2EU8QBHzb
29426	payment	2132	2132	1874	1	1	782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17vonTwPLGHsYwnLEF4iwqFgetRKmK5cDuyZoEq5kj5LeR8RX
29427	payment	2134	2134	1874	1	1	2769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6V58PbKe9PfRjgrXtfhmDHFnk2VLH5K3P4aBvwkcaLDGYmEi7
29428	payment	2134	2134	1874	1	1	2770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxQp2hBjhtH7eLiG7wJz3T7Awp1wycsreTWNz5VgoJbDXmshV
29429	payment	2134	2134	1874	1	1	2771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9f74Ky62DqT5HHwQnoJCffX6fTo3LKgfa5ZHL1LV4sW1NL5m
29430	payment	1397	1397	1678	1	1	11928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEjHwpP4iVJaphqd1bEsJoRka157wsm9Ftp9HQCJ1pNxr3JMs
29431	payment	2133	2133	1874	1	1	2344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8L9gEzBd7kdfs2RMA7eekoJoQGkjWJgGXqdmHDKMZ3Lyxfex
29432	payment	2134	2134	1874	1	1	2772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oPXYQdSrh4wvLfGAGgP8kY6vNxDFPU1EJuyuVjHNiwrTgLEa
29433	payment	1397	1397	1678	1	1	11929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzvea3yg4oebT7dt2jR2gc4EA9U679Cvz9pC6xJ2yPSUGQJf2
29434	payment	1397	1397	1678	1	1	11930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iSkaVoNh8v2Lmnq5Mx4dVRSJgpyxbMo22XaisaXQjqbpDiQP
29435	payment	2132	2132	1874	1	1	783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP1Xj8uABowEbXmXjVZHasCagKkuhX34HgeS8PM4nY9pwNfEi
29436	payment	2134	2134	1874	1	1	2773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicQWih1zBuQJrAcKF3z4oUu5LtLKardW9Brn5LeLmy1kkCDc4
29437	payment	2134	2134	1874	1	1	2774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDsWFbfYYExLbSQ9rmjxfXbTHMoUbDkVszQZEqnDYsuw6P5wu
29438	payment	2133	2133	1874	1	1	2345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUagBiRfVLoNhDExWw2ifR2ZrHGb6EN7WBsYVtV9ZYUimhgaw
29439	payment	2133	2133	1874	1	1	2346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNNxd8wAkGbLoEAJmNFnXZAziAiZ5DhYRiw8Huf1NeAHgPU5q
29446	payment	2133	2133	1874	1	1	2348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPQs9NfmgBkrvVGxw5FdRb5aDfkpkmJAhsaE9kSwfxftfUUvb
29459	payment	1397	1397	1678	1	1	11937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqg8zA5iV5q9jXgvNVqcLvQSNBFY3SPpJdJymn1rT2fpkRqGR
29460	payment	2133	2133	1874	1	1	2353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2F56wXyDPEUp6VhGQzzW56MPoPHPSeyHa5Kwm6YBd9ZNGpUj
29461	payment	2134	2134	1874	1	1	2780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxLuZJ2t47yK5QxKLAihVABWbimVnky1NPdovbnMnLgGCu2dv
29462	payment	2133	2133	1874	1	1	2354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Us1nhvyephjhhtPchFkcfgNN5o7RN5dbbLKFW4WGEF1QrPBt
29463	payment	2134	2134	1874	1	1	2781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANaTQySav6eWtrfgUPbVJsboxuXSKdavnx14KGNyzcbfa5qUW
29471	payment	1397	1397	1678	1	1	11940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbJpo9ztUwoKPnAhEbnKgiFM6xaMq6acSZyamWKypBGRnNM7r
29472	payment	1397	1397	1678	1	1	11941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mPX1ieaDxkhwzzHKGyipMYqCBacMEPS5PoCsgYuVK9GyTQnN
29473	payment	2134	2134	1874	1	1	2784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDas7kdUyF9kJaNhg7wqpsiCACg2EdwwqVGpk7RNR2gQnM19t
29474	payment	2132	2132	1874	1	1	787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquWM7MZHEDfGk8TNai3BykmC8nWA19VVL9mKYrrYXuYqkwpSE
29475	payment	2133	2133	1874	1	1	2357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjTsrrLHutks9jqqMYrcGiEL4ETnP9NvfDLcJSd4P4U7iTqUx
29476	payment	2133	2133	1874	1	1	2358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfeeJZia6k52eHgCwyGsR6sXbrg72ufLE5t1ZPwVZFbZ2oZ54j
29477	payment	2134	2134	1874	1	1	2785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa164HAgMmELr5ExKvqxsDqSxFx3Sz77AKjKZ24tHrW6f8Ppxw7
29491	payment	1397	1397	1678	1	1	11946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXgDU4Dak1wVvQuaypn2B138cyZuucprY46T3Eh6s5BihEPJX
29492	payment	1397	1397	1678	1	1	11947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtNYnjaBZJcLGJb8WKMS9Z22ojdQa6yPYa4s2sJszaP6CmekW
29452	payment	2134	2134	1874	1	1	2778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6qDLuW5SVDRGSy9qaBNQwZdCBzAVURWxQNT7AocF7qZr8QbC
29502	payment	2133	2133	1874	1	1	2365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKp8f1ZiT1bNX7BcKLqUQJXd4c3ahWeYft9HKVdtyr5UdCrEZ
29503	payment	2133	2133	1874	1	1	2366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVipcsfGLS8vzQir5Zg95QeQEJqUN1WA399ZzRsgcknbKLs9a
29504	payment	1397	1397	1678	1	1	11950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJE6P3dj6RdGtknEEWQxcWn77mNsMFx3QANNVcA3r7va6czPwc
29505	payment	2133	2133	1874	1	1	2367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvznAy6tsJTUvhzskbWYXMxUg9JBAsFH7zdtTZxxqprwvPDh7L
29506	payment	2134	2134	1874	1	1	2794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU3pLtoGdzjT5KAxFud6TxTMEdgG8LHDYferxr4fQ5HMYvZ6t
29516	payment	1397	1397	1678	1	1	11954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMauWFJpPikh22MXBGf4qM5rFxTnuBGXi6Az7KSyrgVuhAgr4
29517	payment	1397	1397	1678	1	1	11955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGdLpY3btkuN1vaTHfcBipgZozrdeoZaZt3ANTgg18STU5nf8
29518	payment	2134	2134	1874	1	1	2797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYus8JikpFsKMZZ7gLcmtkhexyQXc5NgCWbzgjSo5ijvukZZSAY
29519	payment	2133	2133	1874	1	1	2371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vsbiaksAP4uNWKtdmJRPpfHrJN8mCrTy3iaZ4RXBzdSEhgiF
29520	payment	2133	2133	1874	1	1	2372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwzJp5254EQ5f6FuAb3gKpctCjEka4HQNWekQ44AJedTr5Sm9
29521	payment	2134	2134	1874	1	1	2798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQkro6QRY1SjpvCdoTWMuApqGVEsNCNzALhvFZ46KguVojfx2
29522	payment	2132	2132	1874	1	1	791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAcCXksiZA5N4ggnDaT2EQmg1AsGV4TvhRjBfhcV9LLyU5boZ
29526	payment	1397	1397	1678	1	1	11957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqST4cHjNB4NxZvNSEL3qiKYCk4LsXY7DvsyRvxKbakeh1uWsz
29527	payment	1397	1397	1678	1	1	11958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouuaZJrvB9CC4Jc4wvtMFK18SGqFX2dhFP2MWTqcNZtjmdKBg
29528	payment	2134	2134	1874	1	1	2800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6wHjEcoaaayS8JMyy2AaLPTgoFUVS764tnBmveVT8ipYK2Tu
29529	payment	2133	2133	1874	1	1	2374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodv3Jm1iGXA8fqkcETBYNmeDZYpUmdnrJdr8ySR6PEPrBhNgn
29530	payment	2133	2133	1874	1	1	2375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtwZDshhCncyRgJkkrszgYDfbnu4CRXERCYRedyLTWGSX21Ru
29531	payment	2134	2134	1874	1	1	2801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuUzU5JRS32ERpT6wmrQ49NTvp6kzp9txwkXupz3XNYnep5mg
29532	payment	2132	2132	1874	1	1	792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByxvxzjtHxNxHMgrPxVZKcSvkERMcaswWGX3YFXQBDPDwkEJT
29543	payment	1397	1397	1678	1	1	11962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qQEw8RPrh5A7XGXJxGqfyt9SR1zZYxCq9rRdMY7DQ3c2oUbp
29544	payment	2133	2133	1874	1	1	2379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetzGtZv5dm9NwZZJM4S79RC9j6TY68R32FRBLarf5eTzcXJ1S
29545	payment	2134	2134	1874	1	1	2805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLcuQUEtfvpv33wCH34RrkFXbedqpC9U8sSEVkBMvNMt6dMW6
29572	payment	1397	1397	1678	1	1	11971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxEHQi7rYtLM9jBLERtdhYJq2BtJfaSkxGMgrtjvpMUYHAVkQ
29573	payment	2134	2134	1874	1	1	2814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPFpzYdDEo8yLCiDUhtYFaByPd5e1VQvzcu1Mh4cxC3JcCREo
29574	payment	2132	2132	1874	1	1	796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHFEogcJ9rgRSVp4SR29iGtrALqRbbVwpbd1ZmT1cRQDATVey
29575	payment	2133	2133	1874	1	1	2388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnteREuJcRW1WrNyL5QwvVQaGLdufZGsZSkXaCFYxvWkzzzFu3
29576	payment	1397	1397	1678	1	1	11972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8MNttVCUxyg8gQ3Aj33VcwKjwMUb7Yy6eQT3U2ydS16yQnpX
29577	payment	1397	1397	1678	1	1	11973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAyFCQmoVsRux3S2gTPTM4Ncnd2YtJ2kPfsjVEDZYJESw33Mp
29578	payment	1397	1397	1678	1	1	11974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjo3VShyoX3GBWLpbsDik8W8M144ZEvEFrHGbu3Kr3ffMJBWF
29579	payment	2132	2132	1874	1	1	797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqrLRCjMs8sKVHL6DFBTgqvzKnqzSgmS2T2zLxgQVYU962vd9
29580	payment	2134	2134	1874	1	1	2815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBd2F1CY5rf2ipk7XuYwxSTrFkaYiFjGAnXomd5vQuYasyxCeE
29581	payment	2134	2134	1874	1	1	2816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATE5rLKg6RF8wcNWCzB6fGxZ7ZtwNZMPvba1tFcy1KSuo5kh5
29582	payment	2134	2134	1874	1	1	2817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkqDuDJzRC5FNnEXp3k96x4bcu3m6QkTKyVi5PWUZNvU6Kw3D
29586	payment	1397	1397	1678	1	1	11975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZZZkvZKZnUhx5Mdvr4zWU3XkPRHCofpq7U2tMpMwExGae959
29587	payment	1681	1681	531	1	1	6	275757462962	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpYiwxAEUozoEGBL1keNDSyeVBMoKHWLuiuqx415MmhdLBLDQJv5
29588	payment	2134	2134	1874	1	1	2818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsYNgFa7mRDaCPFGACVmsj7fLvTXCSKGLNEQic5RbHGRcaCGv
29589	payment	2133	2133	1874	1	1	2392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdUf6ShsC3WgWeLtcJSJ2tFPoKCRnLpCfu34C5zt3M3zDNqD8
29481	payment	2134	2134	1874	1	1	2787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw3KVoydsHEAYs6f9RT4ViB2u7jcwJ1VdG4NhdSFGfi16iNS2
29482	payment	2133	2133	1874	1	1	2359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmF7tMsBP3d9cAQkuXXetmK8fB6cB1AXLmEkzGrwqC6KWz8jk
29483	payment	2133	2133	1874	1	1	2360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtik8zbJiLR7kSgjooVMa8QqwNCYiQgTtbCPY6ib6cztbWPdfC
29488	payment	1397	1397	1678	1	1	11945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4Voy7oeD4YXuQaov3HZQAh14zekB4njedCBuJypaGvhf2ZHG
29489	payment	2134	2134	1874	1	1	2789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKP7iz6da7zDjTFBBMnfctR12nKvyx2tufViupEStyJhrfTFwX
29490	payment	2133	2133	1874	1	1	2362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrj9MQHMH9EfuHmrtQYKmfE2a1tyLFmEcaczxcVadUuqz66uc
29497	payment	1397	1397	1678	1	1	11948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSweDKrtnPx8Jq3EmKjLibSwhfNpFYzC8CxSe5d8AoBm5DkbE
29498	payment	1397	1397	1678	1	1	11949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsft4aCLAYq6FwysKSUS42YHuMxzVQ1MTgBG4dGrzHxibe9NR
29499	payment	2134	2134	1874	1	1	2792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnuwoXgCSdDaroQWW2YCPQEZQJup2Nt5JNvLymJG8gScVdCBr
29500	payment	2134	2134	1874	1	1	2793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3JD1V4Z4pNc4yC2yAGDNGxUeRX2bwhnevkWco95bh2EEXEiF
29501	payment	2132	2132	1874	1	1	789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dJZV68X1KfgKMQi6M5pQsKrs3SknTzDzny2cypkqSr4VE3VT
29507	payment	1397	1397	1678	1	1	11951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChtwMvdq5GJngDBP2nV5QW58YjexEGuCSeCKQpFdvszUsK8ES
29508	payment	1397	1397	1678	1	1	11952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUH5Fhy79mmSQY4AdnvuZSw57ujCNpYjzKmB9V76B2Kho7N6n7
29509	payment	1397	1397	1678	1	1	11953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8pmH67M6X9t7ymhqqHeECPg5x8XWint8TrJrgnNdL8TY5XNP
29510	payment	2134	2134	1874	1	1	2795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhavcVsmGL7U7TmXWFYgPX2fVu1Py1AjnMj4wKm3f42RK144gP
29511	payment	2133	2133	1874	1	1	2368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmYTdcacmPzBzD5AWb9irKTCFhFfgbcgdPgpfv9Jo2YCaKi4V
29512	payment	2133	2133	1874	1	1	2369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqu2W3hfQ9ThmLDiQPFizR1e7dqQjoQS1N2Jko4xpqSUqBj5sD
29513	payment	2133	2133	1874	1	1	2370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW3Z4SinxhjHK46dPpymdM4PKY1xU2KD8MKgBgsvXmBM7oTNG
29514	payment	2134	2134	1874	1	1	2796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZri3jVjV5zFCLbGYVJNaMkoBUy5etD7gV1Q6QTKHtnLCpXy2A2
29515	payment	2132	2132	1874	1	1	790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsULiK9Agi9rrL8N2RDNazeVn7nNk3X6iEd8WyJRcvXstCWd1
29536	payment	1397	1397	1678	1	1	11960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uCqGEJUxvWQcPxHacp5NiMtuybBAw2dZvAuVw8iHpFcWpVQn
29537	payment	2134	2134	1874	1	1	2803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrGrc88KjabqNGhmjNJSDuKnxrD2pAdTzq5cvry4tgruzUaP2
29538	payment	2133	2133	1874	1	1	2377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsg3r5DBVGfodCEduacn2kLhLawdhWJGkodzoFArzNMLhCpQEk
29539	payment	1397	1397	1678	1	1	11961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CY1nbiWukP66vZZYeFWp1AJTpYKETsdHYFzRs7wyq2TnefCY
29540	payment	2134	2134	1874	1	1	2804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjijF2bTS1KZ4YYv82Xt4Kiwivb3E6Dr8r9x19LJnPbQj9sRR
29541	payment	2132	2132	1874	1	1	793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTKH1MGzfQNDSSygYTGqNYuiYnGrdxDww76k9nGMJu4afFzod
29542	payment	2133	2133	1874	1	1	2378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoaQ8WNyGAE2CjZTjv3HTWJ3uoRGvQB5ehSmatud5vL5qbgzL
29553	payment	1397	1397	1678	1	1	11965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4kDZrQ81w3eJPjEZAnCYbsdvJmM5vDVEQP9fvLSV5DqqVCYr
29554	payment	2133	2133	1874	1	1	2382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLKuYAH2eRgeg2rm5ZVcn8fEswAZL417eXUXCdV5qd4xMeDvb
29555	payment	2134	2134	1874	1	1	2808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvShHtNSJE4D69GC3So1NvCuFhNE4ccFcHmnLDSeYRiL6uAefp
29559	payment	1397	1397	1678	1	1	11967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPYTwEHaPH4xAvXtiimoSmqwa8j2x7RcVrwN2bfwwzn7vAVGb
29560	payment	1397	1397	1678	1	1	11968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXopxsdD9gUJCBT71W6xQm9BKEkf8SrchcykWB6RitWoZz5f4
29561	payment	2132	2132	1874	1	1	795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYr5LSEME4LoWw3x85HrQzbnxWsiB6aEDUvrzbqsuiW57ViYp
29562	payment	2134	2134	1874	1	1	2810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzgruGsBLLPAbSohVgPdzc3eja8EMzC5zr4XdXfdsyG4sBWPf
29563	payment	2134	2134	1874	1	1	2811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHCuDaFNYSauBcLPCXbbF9Rf5rTTb8fKJRayj6HivrDycRFR1
29564	payment	2133	2133	1874	1	1	2384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBLYGzr2FYW66KTUTuGuXsapmPY11yiRr8rGf3BNrmA7jSW87
29565	payment	2133	2133	1874	1	1	2385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMWdPpS5bLVapKuNf25tyM5Jd1sXKSnaCr5vPjaJgWWSBnd3z
29604	payment	1397	1397	1678	1	1	11979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwvH4eU1hhnt571Wo4YtkDQaK3BUuP5o9wu3tB7F9Avb8XtGC
29493	payment	2133	2133	1874	1	1	2363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6J4ijoaNwBDNn8dfdaPCkvVuiQkLgS38ZNMnv4WHWuHVuBw2
29494	payment	2133	2133	1874	1	1	2364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2F1RGFdw4kuT4THP2RvYBk8wE6hnGzqpFyHKhiXwokSJhEgb
29495	payment	2134	2134	1874	1	1	2790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszCFenLWrKp4nwEtLQ1x4ZbVXmq1A34McVfPZPp2S41cBYRdX
29496	payment	2134	2134	1874	1	1	2791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3yvBgDxekwLe22MT2yd9enkzN2msqA1xctqW6zpYRYQD7qnZ
29533	payment	1397	1397	1678	1	1	11959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSexRzkbYkfhKsp1XL4PcuvGmGuQSkcbj4Bx7V3xo89DGy95rf
29534	payment	2134	2134	1874	1	1	2802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqxpbDd7Ww2K7fBhDYKwKkASZWeb7katz2KPu63fRbMvrWMhb
29535	payment	2133	2133	1874	1	1	2376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZj7VYAkWRVat9fyXUwPVFZXUWDKghSZtxXxXwHxbrAWeGDFR
29556	payment	1397	1397	1678	1	1	11966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusSKL7U9AnuVwnq46d45WyfjgSS9ttJVRwgHoFqeKXY1NVakg
29557	payment	2134	2134	1874	1	1	2809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFocXCq4J7cSwq4PN3feJL8uDwarja2J6LobV3VmZcbPdazKZ
29558	payment	2133	2133	1874	1	1	2383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGp67G7b23YaL1ioEpUkjg3kJXsfCNgMqfdB1ESkCfinV1mwkt
29569	payment	1397	1397	1678	1	1	11970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe96kK1dHuYn2D2HEXUwTNmqAwi5Q1ksvbrudfJz9Du7TYnT6p
29570	payment	2134	2134	1874	1	1	2813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vg9Cb62cMmTvYa1c48Gzi9wzeMq76nqbpzGqJj33R7az1G1L
29571	payment	2133	2133	1874	1	1	2387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAiWqXfqGunkmRstq1gPSCYmA5Se1QBYdRdzmh3R5Y6shzEcF
29583	payment	2133	2133	1874	1	1	2389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYcVegy4dr6tV5enA7KhSfXv8i9LTon3cyDdpp8oQXV9zJtFQ
29584	payment	2133	2133	1874	1	1	2390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QiH5ycWbZ5hCMNtdHb8cbNY1P9JyzJKM65BCF7jNw1wqkwhB
29585	payment	2133	2133	1874	1	1	2391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1WJGeWNuzL1XEr8GTiUiDMpQCZfsmGbgWBjMqCeygzVKm1rz
29600	payment	1397	1397	1678	1	1	11978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24uejLzHftJorfvi2cs3mePS6RdpYbFf5THHAU7EMYX3kXfb7
29601	payment	2134	2134	1874	1	1	2821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMZAM2zi1sjHaK1wj4Wo4YvJ5PzYpwJ6ngkkfLeRzsbQegCEb
29602	payment	2132	2132	1874	1	1	798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kn2EcxUHdCntabFV3ExKQMWcSwhmXYrPtztDxzQ3XzhHKEw8
29603	payment	2133	2133	1874	1	1	2395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMCLHrgaGnMtFsorhGmFQSgxLZ4XpzzibkmLdZ757GBUVeYws
29616	payment	1397	1397	1678	1	1	11983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUDZw5GUFFFyWpXpUf6CP5KxQHgiU5LBmC4wiaSnByx3orkSZ
29617	payment	2134	2134	1874	1	1	2825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqewFcEMouM3WTMvUdr1eNd9J5faqWp3GCLK12TkHMjzKg4eY
29618	payment	2133	2133	1874	1	1	2400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJg54ijMV9rym4iA4s8AcxRKb2WDQy6pfL3F9dERDq9ExwBceA
29668	payment	1397	1397	1678	1	1	11999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQz53aAUSE26T7N7TKsZXeKPo1b7VhYPpJBHsaMFT7ndTQ5CS
29669	payment	2133	2133	1874	1	1	2416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwaCQfVaoESqPWF1rhmrU36BzoxmeijCdQBxPv91eBkbo4BPU
29670	payment	2134	2134	1874	1	1	2840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ggoNSwvJUDPUWaJ89ET2Srvhj1xTncfVjnwM6ZrYJVbZ82qL
29688	payment	1397	1397	1678	1	1	12006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyUWNU79YCku57s8xWSLC5y16GBaeNbY6uiG4xykNtJbSAbzH
29689	payment	1596	1596	1363	1	1	11	8601867140514	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73sDgQFXN2haQ6natamHkRnyewpNtWCMPP4NgEJTDhzRU9Voa
29690	payment	2133	2133	1874	1	1	2423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5Frnws6EzhHhNLrvamyvzhVbHeYY8nyQptfBBzi5JTx6bnvR
29691	payment	2134	2134	1874	1	1	2846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcZnTaj7SLyYSKXJw3hjZHeh4WF3f6vh5jbv4oGwqXbDuYKQA
29734	payment	1397	1397	1678	1	1	12015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVB7RYaLqeNR6uYdW6quaciCB2kJoQ2HYrQLsSvLyvcZDfwZ6a
29735	payment	2134	2134	1874	1	1	2855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVatKidD6yz7QyFksuTebgbQvQDUaRpLy1MwS1powYqztieUM
29736	payment	2133	2133	1874	1	1	2431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8CkG9hSsAvQ4UaNPqDMTBpPSN7iFgVbKpXvqzMfh5aDHRYKP
29740	payment	1397	1397	1678	1	1	12017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8vq2wEEwEPKVYEPBhV3tsUuMtJXtAfrWTMVW3LSH1tYtapwa
29741	payment	1397	1397	1678	1	1	12018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjePJxHsYw1cTvbZyxySTGSNy7RJ5vF921BYUYZJSnF2nV6zck
29742	payment	2133	2133	1874	1	1	2433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShUbQCre5XmxooEPz23oXdGG7C7XRjexXunWWvfXzFVgwUi2N
29743	payment	2134	2134	1874	1	1	2857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVjBShsXRshH9rAmoApaDBKG5rRcAuWUsXrUjauAFzoMGCC5r
29744	payment	2134	2134	1874	1	1	2858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDWwC1aHBQSpoCqexjabhHPQxrL433vMeGzq6z9xWwfSVaxafw
29549	payment	2132	2132	1874	1	1	794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQwSToVJAWnEG7omnKcbww2fqQdnnG1vq76542DLMrFi9Cs4c
29550	payment	2133	2133	1874	1	1	2380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfz6XfAGbDv4d1JmfPmgwxzjjG5TVP9x83kwmwDiv4jpjg3jV
29551	payment	2133	2133	1874	1	1	2381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXvsgCGD4u3pb2GMv3qkM1zpn2sSD2Sqf4oeuZtSsNPnGK3fcz
29552	payment	2134	2134	1874	1	1	2807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3dcNbHH4YuXjQbCgpvep3kK5PguF8ZctET4bASQ5RfGRnLpN
29566	payment	1397	1397	1678	1	1	11969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwMG8EhJXZMGe7VHtEC1NWciPHE3Q3oGnpDh3phtrZUpTjJRr
29567	payment	2133	2133	1874	1	1	2386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxJg4mBMhYs6jpzWHMNmiNTZ5hKxTBUhL3PuQoLhQguKmtzpA
29568	payment	2134	2134	1874	1	1	2812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAiSuxTWfGU6FUXcd7FdfjUCEseyMYM4JMmQ9hKVjUS7bFRkJ
29594	payment	1397	1397	1678	1	1	11976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfFvwGuRFwhZXYQwi1MuUPVDF4HFExEGeDUDoeP6QQh53DcbE
29595	payment	1397	1397	1678	1	1	11977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzaU7LYWiKJomX9RphMmac1LWDt2znTiYoALs9hHs8r5wMPZs
29596	payment	2134	2134	1874	1	1	2819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEQqbxtWUQootSNUA9DVS4xHiG2KtYh8UELEKMEfDkiQseSak
29597	payment	2134	2134	1874	1	1	2820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8uwdsmMFem86s8tin1G8GBeR7BY4XLepJ5M4YwdNLGGmngzZ
29598	payment	2133	2133	1874	1	1	2393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVK7bqyVf6Jx6Gqs26MCxPrmnn6DU1jUBtBG6GAFnLDT4Qe1z
29599	payment	2133	2133	1874	1	1	2394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpRK9QZ5ubTCf7RH3odzjn6jYyo9UssjFaZSYxDoEQj9MSVqL
29609	payment	1397	1397	1678	1	1	11981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKRSEqHq4sK2ZUo5o7aHDEfW4WP5Pd9Q375gDBV3RvZhreiiF
29610	payment	2133	2133	1874	1	1	2398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvWMq8vstMS9E8B94DCZPndMxt6mALnUoiqcxMrBYSn4Z6fmJ
29611	payment	2134	2134	1874	1	1	2823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXfSHXqAxkGw13hhM1uEZTjZZ4bB6i1FnTjZjCz9RkmtdgZSQ
29612	payment	2132	2132	1874	1	1	799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNAsDDiWAQa4ZVqrgfuuvKxV9mk1NM5WFzKVTkisiBYR2caSC
29636	payment	1397	1397	1678	1	1	11989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoR3wboP4iGB1fQ3N7qPg4pkrZTCp1zVZN2M5hTyEJD2jCyp1
29637	payment	2134	2134	1874	1	1	2831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabFHNU2T6RCLZcWmUjKMkdtyX75YGc2zncekzQTeLJgqaA1L2
29638	payment	2133	2133	1874	1	1	2406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzeRPF5qJw7YfKemzMWhKefKaSe9m5Md6vffF6xhUpGshrzBa
29639	payment	369	369	946	1	1	12	2735417263440	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGe6ADZoyBgrNge5toDpGcGaZjF8AqkTFjyFk1mJeT4y19bdQ
29640	payment	369	369	1066	1	1	13	4901844299040	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8WzGEuZNSa5K3k37kEuV9D1DKmruigZzSYwMdVvA7onQ7BCQ
29641	payment	369	369	1186	1	1	14	3307372024710	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXbpranqp7S793DgZ2w7EnS3jaqdg5wQZGNUMmDdSsXoGfGUd
29673	payment	1397	1397	1678	1	1	12001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22u9jWDAdwyxtsxiekuAuvyxR2WHXj7E4q7ocjYzvjeVs2v8J
29674	payment	2133	2133	1874	1	1	2418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFN4VMcLWbfTjKGdCz1pTb2z3vCXG7tnNBX2ZhetXsY5hXWiE
29675	payment	2134	2134	1874	1	1	2841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9iyVHZQYEpcqHxTvfpSnYJGPVDCkpB5DVdeVi5RYGLGg5EAb
29679	payment	1397	1397	1678	1	1	12003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCD5c9C4j8p8w6WkcmUaFNK8HUcWhozRE4AS71xtawJ6TfMsHv
29680	payment	1397	1397	1678	1	1	12004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPbgo8JNCgLRGtrZero97Rq2snQubGcmuLoq9Z6dPcsLSv5u4
29681	payment	2133	2133	1874	1	1	2420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznAKvkAe6izaDDDvdY56ACy5wA1WmgazcXcna5YYUwKxjssfG
29682	payment	2134	2134	1874	1	1	2843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJXZdjvnWdZwEcWBQ4ATWEzUZrqwUNF3AmU7dUnxbRwYyHoFn
29683	payment	2134	2134	1874	1	1	2844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YhNUJmoqdfQgvL98uDeHAcYnUQ1Hc5KZ7UEXi7MVvCttyy9Z
29684	payment	2133	2133	1874	1	1	2421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSByGBFfWufxMapsLoNkbB2XYneCQsjgpVSSckk1SDcb5WauSF
29701	payment	1397	1397	1678	1	1	12009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg35BG8bDhQiBV2tZoWZqbqYnshVrjDdA73HAh9WCLET78S4M8
29702	payment	2133	2133	1874	1	1	2426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2hoB9N1w7CjhBdCw5sgCXgmvC3dwDb3NQNfPue73PqR4vtj9
29703	payment	2134	2134	1874	1	1	2849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo6ZcXfqnyu9qqaiiKph7dMu5uqbrMiueYTWJLprZ4ExLSvMU
29707	payment	1397	1397	1678	1	1	12011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpiKhhf7sD2F4ygpzJ8dZMUrxsF8PbkMsxkkCaSD9wygLGnH8
29708	payment	1397	1397	1678	1	1	12012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXU7k3ikgcZR7QrVwo4a5yxBcpV5x6E2ahfRehJGPvwYHFCwm
29709	payment	2133	2133	1874	1	1	2427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwHmZLM4fvUbqhQQ1KpAa4qC5fEMjsRNttX8ctv5w9bZCDzdo
29590	payment	1681	1681	984	1	1	7	2097153235304	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	Ckpa2tn2JQqZZ82tht5VgmN36vqftoKf62oRC4nRvQDQMa9dYCf31
29591	payment	1681	1681	1104	1	1	8	3758080629264	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZ1xk1bo3EWXReKGGGYUNTrK2CkJuDcxptJ45u9tukFGfifmkC7
29592	payment	1681	1681	1224	1	1	9	2535651885611	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZFJcERitsN6ybafW6x1YNmaovCD1no1yPL8whaNyzA7Yg1ZNpo
29593	payment	1681	1681	1350	1	1	10	7065819436836	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZumFgqFHpUoKC7wqmX9azBsJE1Xmgg9YTYfUxtujT5nAkDSHek
29613	payment	1397	1397	1678	1	1	11982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFp7mZ3GsmpHMs6oRCsgUBjJwKAZxcfzgrCR5ofjm2DcWj6kQF
29614	payment	2133	2133	1874	1	1	2399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaKLT9NuTt2197kSkxFxqP77dZvadYwy6PWaAUU86Z3gDkHbk
29615	payment	2134	2134	1874	1	1	2824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaELgoXrN6yt7RnYMSgY4FHdXd5WCxzfavRzNQySzGDwsbuNTkj
29626	payment	1397	1397	1678	1	1	11986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgdk4WksHoDpz6NcM2P3xTtPH4FHRgocJbcRQesemdgYmiVRF
29627	payment	1397	1397	1678	1	1	11987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWKN5dYGXB8DRe6YapM9QNAgxc42AumSkSqpWM8n1V39EM8hx
29628	payment	2133	2133	1874	1	1	2403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrJi2GGD9GcDhPXnRqMfjJWRqNmt3wY3DCqXUGbmL2heqE3UZ
29629	payment	2134	2134	1874	1	1	2828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxbagoR5VrjXjBfY2RBMSdwRdNbqbNuVPTaouZschrFwHx1Yi
29630	payment	2133	2133	1874	1	1	2404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCdzbhnZgb9ZcMTUVjsLyuecZqGYvD2uLPYWCjEbsPbymr4VEn
29631	payment	2134	2134	1874	1	1	2829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJJeNF31jLWwLpm45P1hFxqXpJjKADvnzyWUutdE4Z9thvrsU
29642	payment	1397	1397	1678	1	1	11990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2y4nAmX6exXe5CHU1neVzBfpX35CBwSj53mKBqPeGajM2M5G
29643	payment	1397	1397	1678	1	1	11991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7w9j8nwscDsg4BtaGWeZF2j7maCb6Xo5Uw9F1MG224SPSn32
29644	payment	2134	2134	1874	1	1	2832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7zuvsov8NAUhYjm7grUq9yMjQcGTLhZUWv8sBFyaAyV73j3b
29645	payment	2133	2133	1874	1	1	2407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPxTPZQCyaNVBDj2TVSxLVNhkEnjM2QA4VxWi9FANbaHa8X68
29646	payment	2133	2133	1874	1	1	2408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAGQAntu2Q1FPN4P8QjcX73PSN2RftYz6M8yc4YaVfeFD8QZc
29653	payment	1397	1397	1678	1	1	11994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtkCAd1MgYjvq5EuHH75vmZ6ogSRSp4JwAky9U4i6uYYHWSKC
29654	payment	2134	2134	1874	1	1	2835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKahLBPhApB8MKjvd1TXUYqmquM69qNzMUzb5gdQ5VLLcdRQw1
29655	payment	2133	2133	1874	1	1	2411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjozK28QAMVRESrDZKsDCzcgpD4tSmpk6T2ecjz438PK5wS4o
29665	payment	1397	1397	1678	1	1	11998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKiWaLDr6wkBGFSQCAGfxN8evP2eVgkbUi2Z1JsAn4EChd8n2
29666	payment	2134	2134	1874	1	1	2839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW28RhNefMFVXjKSCu1vEGaBh6uh4Gns6EsxrxKJ9tmnU3rM8
29667	payment	2133	2133	1874	1	1	2415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVby3n6eTWcDzHQyNBWpbux1Dgd6SyHEZ7V84GUEGCpXbYQvi
29676	payment	1397	1397	1678	1	1	12002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BVE2uUY2dEcz3DutitDh27drYtZNUjXEpjZkNjmFTCyJ4Y3j
29677	payment	2134	2134	1874	1	1	2842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdajNSDosPBxi2y6bD7KrgJhNzZzt7KAfXFce3bephsuPfMPWh
29678	payment	2133	2133	1874	1	1	2419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UMiQefu5WGj5Xg4HQ8qYA6eYGG2cRSwMkFzKdq9soc4qdRwb
29692	payment	1397	1397	1678	1	1	12007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi351NHayGHW7uEQVbHnJdgn2Px4oCcBD5DZEgmCeERS1zcQkJ
29693	payment	1596	1596	1117	1	1	12	4575054679105	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcxCiboKwTwVcevHYryU8gGNhCEioSkDStJ9iyZyXKbkeBG7g
29694	payment	1596	1596	1237	1	1	13	3086880556396	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtFDrvEXJyskipYEtNm1SzknVAsnjzazizZNsZHBp8GAvhLhS
29695	payment	1596	1596	997	1	1	14	2553056112550	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCAmmUs4w3vMuvkMwHi4o9tuphmHbffU43KzR1xXV436X5fn7
29696	payment	2134	2134	1874	1	1	2847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzukrfpBtKsMexCXxWcb9uxCweRy9cRr66Sov4aGcL61JrdrE
29697	payment	2133	2133	1874	1	1	2424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZJeUKy8Lka8bw7x1Bm9jdvqsUf7h19h73DHVYSKpLiQgdRB2
29704	payment	1596	1596	1932	1	1	15	1344129511435	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9uFQkHp9FJxasXqTMzqedRP7xFbpMeiMh7nXMffmGGaZWFrs
29705	payment	1397	1397	1678	1	1	12010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa6wwjGRkPpXWTQgNBuLTqw5BXLeYTK3TRtDwzWfNRHyYg8Z7
29706	payment	2134	2134	1874	1	1	2850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2oxB9ECwtAVDmzezjRh7Q2vUxD2KeLrHNom6Ee6CqVqF2V71
29729	payment	2134	2134	1874	1	1	2853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqzqiTZnDLxpKYxmT8sEPqcFFNRSrzNoZqv8EWPfhLT2TMPaQ
29730	payment	1397	1397	1678	1	1	12014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbgmZP3xgWnijWcGjxDpwZ2exM27kcDtga4SZvVQpKDUJ8oo1
29605	payment	1397	1397	1678	1	1	11980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk5iN62YFijVY4XB32cUthnwMQxnCo7M444nnP6aWWeyE6YfM
29606	payment	2133	2133	1874	1	1	2396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1b5NGM6XfWjz9nwcsK51K7trEh6hWivkDZSwtzUJy1TL8i7z
29607	payment	2134	2134	1874	1	1	2822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLczvF4NNJ1oxZSh1WDPT75DCE3mrt45cBSKLdemdR7GUFxqi
29608	payment	2133	2133	1874	1	1	2397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmh21d21RqnHPf9K2PBET7YQ6kJYwvN7e3Ak4iLdqw8bADWDP
29619	payment	1397	1397	1678	1	1	11984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGbzfzKD5JZEiheFxsKLh15dHqapsRDoj8zx4EdfFcHoNjV2r
29620	payment	1397	1397	1678	1	1	11985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAjFqhfWtD1FCapsCcYx4xexgSx2sS4xgXcgt3TQJJecHCUt1
29621	payment	2132	2132	1874	1	1	800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTN5FhPW4FNsucbmnn265xD6CH6xyiRescUtiLnYNPLZ1WJTec
29622	payment	2133	2133	1874	1	1	2401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDn9LBeSVQm7kT7vgbKgVF9bT1EYsr189hATUAVktGj3XbgSp
29623	payment	2133	2133	1874	1	1	2402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXBKaACDGq7j2U67hh9wjW1wXQZTB1FTUsVKexEAmxesQRA5V
29624	payment	2134	2134	1874	1	1	2826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuhYn6Nxsm66KqRXxtsJfdvS96AiYqAUqoEjHPhJ9wKLABtS1
29625	payment	2134	2134	1874	1	1	2827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YdDLAK7e4DjGUvKhPcUscsdHBRMVhPwyuoiyKAhcwXtBpYp3
29632	payment	1397	1397	1678	1	1	11988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzWv2kKF4fLbiqKo7YMBvW1jW5xhLNZntGojVeyXUoA8VTqK4
29633	payment	2133	2133	1874	1	1	2405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkJkQtDRC8red58QFbrdDqocd6nmPppNgDKXjaREL3BXHGatq
29634	payment	2134	2134	1874	1	1	2830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgv3BfrXcYjuu4QkXpShyrrjqaqpd9AcL8QM5geEEftgQokJt
29635	payment	2132	2132	1874	1	1	801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAHAer8VRAjZQRDWyyFTypZbmR1e9tMNmJed7Weu9EfpchjzU
29647	payment	1397	1397	1678	1	1	11992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGD8oBHsfjipZL328rU6U3zKrBSeP1U7xFFTEuSjhbjGqCgths
29648	payment	1397	1397	1678	1	1	11993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDLCbiCbS5rx4KHu2B6UFRKN7QqQpXT88cbMe3XrYZX6sYSeF
29649	payment	2134	2134	1874	1	1	2833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySptVgb7bF8AmUhTYZB6Tis2DnUNpzqAmVHqxgV3xRRX1vigb
29650	payment	2133	2133	1874	1	1	2409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWxzuqJ9K19MwBA81rzbkVm5BctM3xiS2bH8m2pUi3YdDyFGx
29651	payment	2133	2133	1874	1	1	2410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvP8VWNCMMM7rNSszqLCo3FWfGMN2WNrW8TD4ooi3zZWQwphw5
29652	payment	2134	2134	1874	1	1	2834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRQtpcX68aqpJXwCJxzYNt237ziXQmu7PK3koiBr338eE21WW
29656	payment	1397	1397	1678	1	1	11995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYTiBkXsDuNmshoBAJJZxfEJjVyimqPhyeBDBC3DRHHPvuKVH
29657	payment	1397	1397	1678	1	1	11996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AEtU3o6EpWqeLwoRGVQXdxgn6zmvFzcjac5zUKfGpfN41WS8
29658	payment	1397	1397	1678	1	1	11997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKf2if4H5k2kz452dBkW5bydrrQRg41FXbzGG1KaxJEWXJwsh
29659	payment	2133	2133	1874	1	1	2412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEsFxfmV1yvc8ijnZS3uFApeUEWSVBhVam68yrZtBapKpxpMe
29660	payment	2134	2134	1874	1	1	2836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGmPWf5F9ZReSnASXcSTswEfW8gsZxKJvQpSXYeaXeYM3Dtqd
29661	payment	2134	2134	1874	1	1	2837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeinp3pkbRN5QxQ2WNyuEVV5Q9aQyLa2F3oRB85KyVhJLPHsaG
29662	payment	2134	2134	1874	1	1	2838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAihJDEthWyRMQm5xrbHdRpNaxhWKabTCDrQKoTVdtWkeusEu
29663	payment	2133	2133	1874	1	1	2413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUPHjDfUYv999zwC87AqW9HJpB4wTZc8d7HqtsXmNWzYdrhSV
29664	payment	2133	2133	1874	1	1	2414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsAXWg332foNohn7KBDFv1ouFe9bWXepRhS9AEqiwGWYztx7x
29671	payment	1397	1397	1678	1	1	12000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBWfya2o22UM8iL2cWHSATYv6GRZLiaujytJwDLgixtZHbBtU
29672	payment	2133	2133	1874	1	1	2417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7k7zjzcehsNuQpW8bs1YGoFuDSk37HV187HCQ1eq8TyjUbqyP
29685	payment	1397	1397	1678	1	1	12005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFczWUSa9cbkBXvQ9NQnNTeC3obJqcbcrA5mZXyi97epbzuJe
29686	payment	2134	2134	1874	1	1	2845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXnm3yh2eAaTBDHEiFNk9N2ysEaMBppUcfcLUxfnZ4MnPF55Y
29687	payment	2133	2133	1874	1	1	2422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GmPqb2EMeG1z8ttAWwGQk5Gv8fNKmZ1Z1W3qHct57NemVhri
29698	payment	1397	1397	1678	1	1	12008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT44Wz5PihKqB7tRaTvsiFhcDnRnAKTgbiYS6sXBdVmtGgMxaq
29699	payment	2133	2133	1874	1	1	2425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xWFzHFsPpgUk1tHAsFYsYDGYisntv6YzfV9kZPBKCBrhtQ8m
29700	payment	2134	2134	1874	1	1	2848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLsNJsToawQQPuZGr48QYN4CzpKcSjYG9XUD3gPt5JZk4F8dL
29710	payment	2133	2133	1874	1	1	2428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTCQG8cY7yyWVvXRWLwvDBhtiFgYPjQar2nE5oLpz3HQxNNpM
29711	payment	2134	2134	1874	1	1	2851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdNcTEwpxEdnNZ6zA7hDcDHP6vDXFc8xGrtyqSF6dSwMGd39j
29712	payment	2134	2134	1874	1	1	2852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtHj4qqbDdW5eWJY3KwrzN2Yq5amFz4Eg6czjKW84gQr4DnNC
29787	payment	1397	1397	1678	1	1	12033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR49QFv7toSn3BdpMuman22iASwbsAnMNRKYxuDhhx8r7sRG25
29788	payment	2133	2133	1874	1	1	2449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bBus2sjpV1jDftp65gBK2VuzZFby52P2uMyPFQGR8VD1ZYvH
29789	payment	2134	2134	1874	1	1	2871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aquhGuMgRW4XUVR6KLiGHZNPHcng2vvgiLtx3nr8uUFBxLMU
29819	payment	2133	2133	1874	1	1	2458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRtQmq7RiLtTqMQCn3RQJsU9MqpWBz5BGJFiqBgiWHnrs8Nzz
29825	payment	1397	1397	1678	1	1	12044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8owg5UVF12BZPGsC8r6tUX6e9NdGJN97GbpHY4Wi6nnB8UFkV
29826	payment	1397	1397	1678	1	1	12045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhvv4xExrG3nnvGArTkKG1DPgjmj8PE4UNkyF4uUnArAJbHJk
29827	payment	2132	2132	1874	1	1	802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVutUWbbe3W1ZgndJ1Eid4MXS5aU6C86ofd997cDMA2nyDVM4q
29828	payment	2133	2133	1874	1	1	2460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSWeSry3QoSKtckxigPS6GMhJTqYCXhDDzEXFLpmafQV48Eik
29829	payment	2133	2133	1874	1	1	2461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfeNTwCKKpAFnEW9ESKQ79ENJ9CKV2szbk6j5US2xmoyhNjee
29830	payment	1726	1726	2251	1	1	8254	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkS8g3WAYA7XrxnfKygsggLrnZr3oj7frpapA7UyrKCAx5HudN
29831	payment	1726	1726	2252	1	1	8255	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZTPpKwudi2FbRqSA2ZRQpC225QUYFZqfziUqwWoz14uJebvvSz
29832	payment	1726	1726	2253	1	1	8256	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZibuf6Vqd1e4i7aVKianXqc4hPyeYiEUUQ3A4bvN5mdz1nAEAG
29833	payment	2134	2134	1874	1	1	2882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6vPe6eNmeYwWMbtQiLVvZSivdb3U76HaEJfpPy3BUX1HnKPR
29834	payment	2134	2134	1874	1	1	2883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMXmSfTGnnEpFeiRg7uBgCmubMVCsVwPMcLxmBYLs5freTrbU
29846	payment	1397	1397	1678	1	1	12049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAV2GdFA9Gbmd3TGMGBNxMRZ3GKKBQY4TMiVYqx6RnqfaLofcf
29847	payment	2132	2132	1874	1	1	803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsg32q3qc1j91TPHhU91igny8t8VB1BkecrRomQVP3SuUdmFz
29848	payment	2133	2133	1874	1	1	2465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMyuec5YjQTyVAayLzSYmboRHsoW8VwGAzhJnZA11PYyHHrc1
29855	payment	1680	1680	1273	1	1	11	7373028977568	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYQ7N5JbySgWubJrXFWsmEHPkTsqxJtdpJ37qpcYWV3bwugA1C4
29878	payment	2133	2133	1874	1	1	2471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgcv9U5WahSYzekkZnsyhipmWKW7U5Sc8hCzubYcp2UCi53VA
29882	payment	1397	1397	1678	1	1	12057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUsXytSoGoofeQAyFTjq7PLzZhownujn48xDRTUsaiQmJvN9k
29883	payment	2133	2133	1874	1	1	2473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqWN8SrF66zSGowXtqgSqAE6YbtHzjL1SVGcLEJ49qD1yNqaP
29884	payment	2134	2134	1874	1	1	2894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yoacacwE2f877DfAfWzrr5dRjEPffB9QDqAC3yjgH67hSfFm
29891	payment	1397	1397	1678	1	1	12060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetZJcmaP6x9JB2bSTdDT4ArZp19vsGmCyhC2yXne1Vnk3Pn3u
29892	payment	2133	2133	1874	1	1	2476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT11u1hXa9d37mQxZk4rvsdeydRJ6gFMJka8GsNQK1RR1SCDxA
29893	payment	2134	2134	1874	1	1	2896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KgBdEXjastkzvFXr2W74fv7qCvQXpPCRDtfKe5aVXyJnsrfW
29894	payment	1397	1397	1678	1	1	12061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicVABeJ7LJ1xiUYwiCgRkHGeBPySvtSjc2VXExbSX5dWk1SZw
29895	payment	2133	2133	1874	1	1	2477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzZ1hSPVA4x7uwMc1M2VNi6nnqSGcTYCNrrVyXpUzxtsj2gZX
29896	payment	2134	2134	1874	1	1	2897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNPKFLpohppbs9R9Wp4nCGoLJ66uELwHjinY4r53iPPy9e24A
29933	payment	1397	1397	1678	1	1	12072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQNaUKEuxn4Ndgno3ufFTbU9vVSL2xRm9qR1SCaPrnFyU9Tee
29934	payment	2133	2133	1874	1	1	2488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsqERzdsy54ZCwNBpB5CNLJrUraQVckeKCJD8BVo5hAakZJCA
29935	payment	2134	2134	1874	1	1	2907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYVSsGnepY8nPwaeEyb4ejBh4YLydxSetirBtBxUsctemYhEb
29936	payment	2132	2132	1874	1	1	810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPi2wYuAEj97v5Ebd5qXhWBmjEX5U8xLRwgLsGkZcrodzdrmS
29937	payment	2133	2133	1874	1	1	2489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGCCDrHShKeqg1UAr1bs2qEDRqRHR4KkrwwWVF9tFJyfXRHV5
29943	payment	633	633	1384	1	1	5	8308000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZrfgnbx3asZANm3pNpnfCpsoKSXyBZiRzMkW4S1SMSQeC3GhRD
29944	payment	633	633	1138	1	1	6	4419000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZFudnAVStw7QCP2T6EThnsE9CPPJ9nak5zU6eMSnzwLodh9fEk
29713	payment	1397	1397	1678	1	1	12013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxyLf1AQN6jw4JnshekM5PMAdSPbp22boUE3PbFf8s8s4wg4K
29714	payment	2133	2133	1874	1	1	2429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbecmv6m5oWusVfnLRtx1H8kXrKiVFux3xiRuMZ476SS7kLKC
29715	payment	1560	1560	135	1	1	15	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ328DBcVRZ31geBjDy8SBzbVi9AaQSxazyWZ1XHHUZfZkEKiyB
29716	payment	1560	1560	170	1	1	16	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZc6hZKbgJRCxZik9NGVEVFzfuKMbYxy2AhL6KiT2ue6es1iLgG
29717	payment	1560	1560	202	1	1	17	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZKeCbxSCtXbcSwpLABtVCNBUgSMFPRDc4gHL9NVAN7BLcjyTF8
29718	payment	1560	1560	264	1	1	18	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	Ckpa62JGCKREXcNAxpga55KaoQeEYh7Lyk2oHz5KQkag2J4E8rZEr
29719	payment	1560	1560	279	1	1	19	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYeAKBpwpXs9xNrNpcNELBvVv3p8dSsZqmvrexPhuGsZZchRi4C
29720	payment	1560	1560	331	1	1	20	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZuGkvuf8PXETeELcph7X1VCUZZTcVfcetJsLhJcd6Nfx4kR75U
29721	payment	1560	1560	382	1	1	21	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	Ckpa2eWuV76jJSRynfz3zCNkrbLzUdph4yDxVXppAc4KfZs4mwcUT
29722	payment	1560	1560	388	1	1	22	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYYVcy817ynwCmD7sitZymg7MHhxwAL8y65NiTvs3cRuxRQCs17
29723	payment	1560	1560	400	1	1	23	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaBNvpquXtGhveQpLUVsdbTCpxsMNQ9CgiBP27mst6dyPxG4NDe
29724	payment	1560	1560	505	1	1	24	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaFhUKTPhbUCXS43vLnPwPSiha7sua7zQS6gzbgKgT2pTeEf1ts
29725	payment	1560	1560	925	1	1	25	2205680584016	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYqqtW1JiZ672gjCKfgJcEyHVgrKrMzSkra7FsbwVsXX9MjgLmx
29726	payment	1560	1560	1045	1	1	26	3952560708320	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZNCmRHLLF7SaGo7TTEnSf6eUAvhPVRc3EtWHd4cmnsWV2zX35g
29727	payment	1560	1560	1165	1	1	27	2666871470228	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZJTbaqiHTj855rFwPRM7zDm4okXFRQHNwm8rvBToggicZRoCN2
29728	payment	1560	1560	1291	1	1	28	7431474476804	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZxkNRWxx6VQzATPPXDQbjAGDebztAScEJRFmNky7hXusndkWe8
29737	payment	1397	1397	1678	1	1	12016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWDziRWfTmk7FnfSF4XmTSnhp9orG1SN8JfEAhYxFDQq1ZwiS
29738	payment	2133	2133	1874	1	1	2432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7B1syi3m5zNczMgPuGrchVxBwPb3KVHojyTmmjsGHw2RgF8Q
29739	payment	2134	2134	1874	1	1	2856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7vVvPgeJUYrXusLQti51AAivvQ5CnzPfT7ma9AFGaZ2pQPC2
29749	payment	1397	1397	1678	1	1	12020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76YvWyuVwTZLzUxuRj1K628dxbQYgabKW73qtqNWwhuFv8f7S
29750	payment	2133	2133	1874	1	1	2436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWtwrMZXFduBPGrG8JN74YYVzEH1B3VPvumuP2GUveMmiysTz
29751	payment	2134	2134	1874	1	1	2860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gmDf7vDnKKNcqyXrCV5BsmYBBXjWbLmqChUC16y7EyBKaJDd
29752	payment	1397	1397	1678	1	1	12021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYie5XrxRNcbRKNoBM7nGyaRhggVAo3FFMZcR8195uNqm7g7X
29753	payment	2133	2133	1874	1	1	2437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwYfrZU2vGYrnDHHTdGmX1piMcmaDPVNaRptFVJJAR2r2pj6o
29808	payment	1397	1397	1678	1	1	12040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EP93C1HHi1MsnfgNjydriUTr4Jmz8E6f2zMsU3YVKQHrZEZi
29809	payment	1397	1397	1678	1	1	12041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXepWbFc6KVmd79hV3YyLwFg1hfVgzB7xNK3L2GGydEk66pSXQ
29810	payment	2134	2134	1874	1	1	2878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWim3q8Pt1mZ4Yi8Wf8XTARfhMBBc9ASxonawU1ndPbDuyuRE
29811	payment	2134	2134	1874	1	1	2879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmvtMGu4Hf2mWmnUrh6xrRgoBkxdpTrLz78QRiD6fQg9P4BeX
29812	payment	2133	2133	1874	1	1	2456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWoWWVnrik2GCXbRsd2C1yC3vHsgZXWdTxX7YknuadEvyPkzn
29813	payment	2133	2133	1874	1	1	2457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKv5f8y7j1PL8JG6eZciJRMdS7zPCKe5B6RTPNCmrtFJBBinM
29840	payment	1397	1397	1678	1	1	12047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFoWChHCRtFeU7DT4gwhuvrw5pzczs4NyQ2QCFmJHSdLy7DCH
29841	payment	1397	1397	1678	1	1	12048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuYyV9SSZN4DKnvMJ9amBMvC6CsxjuVXKJf9KNdjorNzS96hJ
29842	payment	2133	2133	1874	1	1	2463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBuAkzv2pgCsuiJKEfW5n11gauPduhGQyUVCqVUpv52NeJkjF
29843	payment	2134	2134	1874	1	1	2885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUdVtH5c3PS5KGsAfc5jmxmhWyNBUQajKsz7jLcJtvnp4f4mg
29844	payment	2134	2134	1874	1	1	2886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEHvRyqj1Hz6T74sB8HVseppiVeNNTaM1xkDKSEswEHEbB3pA
29845	payment	2133	2133	1874	1	1	2464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VifUtnqDHSrGwuWut7EdSQL6JpLHBYFtGgV96dF7TZCBSv6i
29856	payment	1397	1397	1678	1	1	12052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wF4DWhrWzHoUXDVwivxakw158hA1ti4QDYBgNPZBETmd5ixg
29857	payment	1397	1397	1678	1	1	12053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqSYQkT2UYbjj5zpMcWPcXhagT1EAt9THG4QnUAJcJ7LE4MGB
29731	delegation	1932	1932	1596	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cMgNqeafNj424w8epixKvvR6kRmmr45tKtxtqu5DfVAbbRNt
29732	payment	2133	2133	1874	1	1	2430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZft3787f5DP2TpAFGPX9yVgF75PDXwRJiBUhXYjKh8xsyMmXqw
29733	payment	2134	2134	1874	1	1	2854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wMpgtnKBhzCKaZcqXzBwg7Ai4ezdRoN4xpdby3gvvdWNGNLC
29754	payment	1397	1397	1678	1	1	12022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nJBFnev6oHuLPzLu1Et9VKQAmM4x2tQ36KaL87CF9woug2Gd
29755	payment	2134	2134	1874	1	1	2861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUFmnh8HQ8zEfuXSixpeMuKF1UHXeFLB3haEbVQqPd5Z9SpbN
29756	payment	2133	2133	1874	1	1	2438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9s4WWfjPwDejDr2Tg7vpQnzZR6gS7igctnydkMsrXw33TyYub
29758	payment	1397	1397	1678	1	1	12023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eo7yv5oooRg9i1PZ4yRqPqck5JUep9zLBgvN8kgHGAYw9ewV
29759	payment	2133	2133	1874	1	1	2439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h3AQugGUeGJwGth3TJb6xKkJo2fjwaK3Vsv3FsdUYgMxdZpM
29760	payment	2134	2134	1874	1	1	2862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38JpxqXK5dqDaxhrvVkCSBAvdkVTprsgm2QCFiNHnM9w4vjZr
29761	payment	1397	1397	1678	1	1	12024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKcnmf2xpVGGsVzHNz4YM5rCxcUc7juysgk3aFaYVDdhEdP2t
29762	payment	1397	1397	1678	1	1	12025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZVPhc7LXPYDUYg4XqAXXHTA8xwkffEh4Ampf8hoBW9Zwf8K7
29763	payment	1397	1397	1678	1	1	12026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1FkaADDW284euwXjbZ4rk65bqVF9ZFMXUUfJT3S1QRF7ffnF
29764	payment	2133	2133	1874	1	1	2440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3HsS6hFAszXoQcQ8xR5qgJTWMpg6QmsravkhXRn9rgbNWd64
29765	payment	2134	2134	1874	1	1	2863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhqJJiCDyED1Jhn3EJuMKn9xvk5vCBNALQFQqBCWidhhruz1e
29766	payment	2134	2134	1874	1	1	2864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxr6SAdXXoKjdkECCKgdF3wf1hGTAqaQ5kbHJNjfh5MprtsWK
29767	payment	2134	2134	1874	1	1	2865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRr5GnUuHPa2Ay3fx9GFsauqkzSjxb6GV9TyDYWKasUfTYfaG
29768	payment	2133	2133	1874	1	1	2441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmAV5H66fRj9YXgkwaw28FcfQB39Qiej1N6VQLMR7FQJP3tCX
29769	payment	2133	2133	1874	1	1	2442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWNsF8d5n9SCHy4KGHgLwxgG7WproPFPBpXusirLXtRRGkDG3
29790	payment	1397	1397	1678	1	1	12034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLWx1UxQRE2GwMbV2Cavodg4ZfKqEYFqaUdmvWR4R9SSZh9zT
29814	payment	1397	1397	1678	1	1	12042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxQ15FHrkKXU4aGbsfVCZKmu3brf7YUnECH94aRwPQemA4NXj
29815	payment	1680	1680	1993	1	1	6	287948143156	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYudURernuHcfkWw2qvuJxbXrATtCeBeboUxsYLZ5a6aedaCpAB
29816	payment	1680	1680	907	1	1	7	2188333810752	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaCihHxBPhz48ioakMbXr73FXg195K51KnBuVtrMD2wK1cF9Ytq
29817	payment	1680	1680	1027	1	1	8	3921475439232	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZQtP75tzeHtVAM6Bk8e35e47Ziqjm8mpASpoHZriDdcBhmD6rD
29818	payment	2134	2134	1874	1	1	2880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiZnnLEFs557qrDf6HeL1Jc5ez3b9XN8tMGCvcVf1EckBy5V8
29820	payment	1397	1397	1678	1	1	12043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMQhkStgQVEFsXuzR7myLNM1TARMs8AK9JcB8kFmWiexjEbpN
29821	payment	1680	1680	1147	1	1	9	2645897619768	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYXGmG8DT7bueQU8yh7W8aCvs6okdY89BdGQ6Y8Qm8YuRZiiym9
29822	payment	1680	1680	1993	1	1	10	860000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYjJxvG2K8KG1r5BgYVSsNXSDK479gMcEZwRsxU9fT6YZtrn91J
29823	payment	2134	2134	1874	1	1	2881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor1GG1SBPLwDQGhcYaYxFLvdYAJZgx6MCCzMPsH2s82intGNa
29824	payment	2133	2133	1874	1	1	2459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6DqZsTRJuGXn1sn9PHJ5ndhG2vqTYTyGHwLq4UuHii3wPvAE
29852	payment	1397	1397	1678	1	1	12051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNPYirar3hh92X4ANccwPZCtyoia7RvGUyqeBorUZcV92Ny6J
29853	payment	2134	2134	1874	1	1	2888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa46xJ1unhmQGXYiq67DQBWE6DDCLizXt5artqeykYoae7GW3z
29854	payment	2133	2133	1874	1	1	2467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDR6z19ipQNsGmrRYtrd49jUC1cXRXrdJLhpriQFcebQ6dbo47
29869	payment	1397	1397	1678	1	1	12055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwak1B1ZE8xdqwhGoDMv3pqpyN5KBzEbV1PeFHo6ncN7qNxqsE
29870	payment	2132	2132	1874	1	1	805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB6iUDtjdH86K4WhngDn8jdYjAy2TbMAtipv6GpkNyxhdxUiG
29871	payment	1991	1991	530	1	1	15	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBw8zyJDiUXZZpoXUgH3zJ1D2jwtPV3qVsn5kN1JbotioDfVYL
29872	payment	1991	1991	675	1	1	16	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPs9f87MDFDuV5Bp5ARDYtBBTbrEzPBQjEwdMrm5o4rWX4WxV
29873	payment	1991	1991	959	1	1	17	2493452391090	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTQr7XCbK7qvX7htrK877gYyX66om2c73iBgkiWaDknFfBJgT
29874	payment	2134	2134	1874	1	1	2892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdX3gJ3nBSBEy8y96RcbkYaydwvcp64AZKLcsJZtXkSvnNUc8
29745	payment	2133	2133	1874	1	1	2434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcHmQ188q9yV3H4jw77viWfc6hwm5c8RYyYVDH5urhZa586DJ
29746	payment	1397	1397	1678	1	1	12019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRP5aqa4ukLJZkJAyW4W72MZMUq9FkaAcqqaXV6xLLVaHvUkW
29747	payment	2134	2134	1874	1	1	2859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzQgYuf4sQwzYvAJzDeLZNkugha12m3ByqMToDUfTWZWDV1PV
29748	payment	2133	2133	1874	1	1	2435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4nsgTAGYdeCZR65no1VgiQad9pM8EcdHGcWKCxQGVEFhBMvP
29757	payment	369	369	1312	1	1	15	9216286221960	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9pf1a3MsdmLPe5YJEZ1prXAkFDnSFFgLGb9TyQv1njaciqom
29770	payment	1397	1397	1678	1	1	12027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo4nW1vHfiNQt2ocojkSKjhRprBwaZ12DkhkNjw7huWNenBRK
29771	payment	2134	2134	1874	1	1	2866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWFgysTKJbTpqTMfKnEefN8bDRADdXN669pwydHNUCYxboGaF
29772	payment	2133	2133	1874	1	1	2443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eSqwnswSHPTmVMu9JfD2t1Br7b6RrsaoKdNKzPLjqSb4cn4D
29773	payment	1397	1397	1678	1	1	12028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmJFUszevp6jCQXQ7zESk2LX6RfKkDSmstbydPwz7oRE1T6wT
29774	payment	1397	1397	1678	1	1	12029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMa4EAm3saxx9R4pDztjQDJqaZU1BY7Cq7LrvAoL7EDgkaJCL
29775	payment	1397	1397	1678	1	1	12030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5qejmV2pBQHuCXKydYssSFSyFywycKRMh7UbhGaRwvJyfYmu
29776	payment	2133	2133	1874	1	1	2444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjevt9HLqrcB2vgEz2RXdqD8A6oYvM2pYsm7J28dHWU46PuTKa
29777	payment	2134	2134	1874	1	1	2867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiXB3qF4HM53j5vEPaRVJCYY47oXj7sipTuE6P9mKN2au43vs
29778	payment	2134	2134	1874	1	1	2868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgekn4CCBoVx4j1B5Waou4EuhzTcDQmppFaEkgU4yBq9yMiyx
29779	payment	2134	2134	1874	1	1	2869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkPXR1Ce6N4foQhLzxLhWKpnATAvWvrjK1tfJvNeXvFFTBMaL
29780	payment	2133	2133	1874	1	1	2445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1Bmmw1JJHiz3pA2Z3mkEuK4EX1bqcgXKvLNczy2RNoCn6TQ
29781	payment	2133	2133	1874	1	1	2446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kWAaSw8EsbG61H4XGNCbzivgXR7D1jJW61jde7iWsb1nRSZy
29782	payment	1397	1397	1678	1	1	12031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECsit78aKGxxHw57V4CPcqzb8FNrkmBbsAVhgwafEXVKTMdDW
29783	payment	2134	2134	1874	1	1	2870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFY4Ax91tDDyFCPHntds7G2d4zzHGU4UAhSo47zHfjkXEeieK
29784	payment	2133	2133	1874	1	1	2447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZDDBbUCkAYe5BPF1xjwKJgojBFZVzkEi7z5bqSf7kMyqLuuN
29785	payment	1397	1397	1678	1	1	12032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgBrhnem1L8PhGycGHvrsjLnv1gFXeKu1ReTfNNuoCrgnrNen
29786	payment	2133	2133	1874	1	1	2448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcv2caXLqwWkY7yCoCSDPmvr1XFrS1B7wEg3fVzJkFgcHfwgo
29791	payment	2133	2133	1874	1	1	2450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh24VY1wqu32qbxC75mNBg1pwJdNGrFWNNHk2Gt4A5aLdnBq5F
29792	payment	2134	2134	1874	1	1	2872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJes95CTw6wPcBQQrZa1meT5C7STAGgB4LWZc5RRAMu37AQfRu
29793	payment	1397	1397	1678	1	1	12035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWemxR3MMprhCT1f5rxMN6vsxy71BWxme1jUEJLCtsCpeJBcq
29794	payment	1397	1397	1678	1	1	12036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjereFrFhDf6SqzoUH9zBGq491YHq9ckXsU5i3DQrrrGgb8WW
29795	payment	1397	1397	1678	1	1	12037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRD3BbfPDGsasJiBfrFv1frhDRaNNvdsh1AKEUMF4w19A5SCPL
29796	payment	1397	1397	1678	1	1	12038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufBbsJ6AbEGXQfStptn2dUG4tKVjsm2ELXR935wkjVHMWvw9h
29797	payment	2133	2133	1874	1	1	2451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNM9xiRwbhHc4iFT7yZGzJegA2UNhe3wJjwEZHeES99ftqDSE
29798	payment	2134	2134	1874	1	1	2873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiF9JdPp4ydvLkFAvxwvcZqYt8vMq4HcmNytEJGSVPPs5so1eH
29799	payment	2133	2133	1874	1	1	2452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RetDaz4f67v2jmuQg1n94KWYxqdgHDBuxBBMLBNDQgrn3VUE
29800	payment	2133	2133	1874	1	1	2453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YFdqDRbUuLerERJqW6RUYsZKe45jNdCmbzfJhjZmtLmKbkkN
29801	payment	2133	2133	1874	1	1	2454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtbVb5NEiupL6fcQ7mAyJGoW9zbKVzq7DVWfJwQvTL8UdNqwU
29802	payment	2134	2134	1874	1	1	2874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgM48kWxan6x3RhtB8Y4veQpvKU8dgdKiWJbJUuNEKgfgVxGu
29803	payment	2134	2134	1874	1	1	2875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1f6fL3ckqoHAP5KbipfyHAagrgWggK4wPCPmJx7NRmLeJYJV7
29804	payment	2134	2134	1874	1	1	2876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmKPqq4MjwNBDt7Jd4tTxa9yKW8VPJjTLqPGB2Bng87chdiEW
29805	payment	1397	1397	1678	1	1	12039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXVBBXiMncS7LpAE48dxhDDxM5cTtkvRKxy4QeVNSfKJSu6rH
29806	payment	2133	2133	1874	1	1	2455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsxi8TeMdgGYZmpWH4WfuuX7v66oSfivRQCArsxHT58eZyEG5
29807	payment	2134	2134	1874	1	1	2877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpUMGvCJxMqoR1nBSygGugDaVYR7nifkXtBXxTWtAZJFAcxjj
29835	payment	1397	1397	1678	1	1	12046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhimNEQjfStgnAAFF853AfNLkebfFbxz2WwNMABuy4CFqHGTLG
29836	payment	2133	2133	1874	1	1	2462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuCCMU83wUzsrscBV66VS13g3WpoRBedvYxSHPctX5M4XD6pn
29837	payment	1726	1726	2254	1	1	8257	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjsX1puCJskmpaCvpFi57abXZgehLxr4kvYHFKCEPo2TFc379s
29838	payment	2134	2134	1874	1	1	2884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F67wUTdaabLPduVWc5HoijGhhe7o4z9Si9yRpHtixUpyQWZS
29839	payment	1726	1726	2255	1	1	8258	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgveC7RHkykRA5S2LvSr6UY5pbXDJkEdTx4zjpeTsKz6RBFR5y
29849	payment	1397	1397	1678	1	1	12050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXj25MrAHaYBZjS25aQZ5FK46DmrdZ1cFWDyh8X6Q3ofB93LG
29850	payment	2134	2134	1874	1	1	2887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe14yQXhxQTC2vqu3cuh9tNMsq7JJB6QVjkdBddy8nXDgi4CC
29851	payment	2133	2133	1874	1	1	2466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmGargzFWi66qL4pWLRbiwTEMjjoinLWajjYNyNaZYrQgunD3
29863	payment	1397	1397	1678	1	1	12054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DoX7PUPCXyFKtTPVQFkxYbvwaC1KEd2Mzbq4opXRcd4wkMT8
29864	payment	1991	1991	83	1	1	12	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesLNwwg95mMH4N6cyKRX6RoRinQbTjhi6VkFTt7pbp4XjpSrR
29865	payment	2133	2133	1874	1	1	2470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bx8cFK68TgjEHtcR56XJpdSZuHCpHxD5qchFYAsDxFK9y1Yi
29866	payment	1991	1991	348	1	1	13	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrd6TNjR32q3Yo7RxosYedb7QEcsiKvRGRSuvtapWNXaRphht
29867	payment	1991	1991	380	1	1	14	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFRnyh2KFTm6CUPeUs6vuc1cD3TLEaX23diNtzZ8GghPhgzow
29868	payment	2134	2134	1874	1	1	2891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4u2sVoC5TPW8ZKsXCsoUCgxRsipmgAgfLtFsAxCRvkWJD2AP
29885	payment	1397	1397	1678	1	1	12058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16jB9XQBsuDeGi9B3QCXHexzS9Guf2hegnM443gDDkfsNbwFs
29886	payment	2133	2133	1874	1	1	2474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXddotzHu1jZBmmS3AA7s82fHWvdf2EUW6gQY27EEzpQfsx8w
29897	payment	1397	1397	1678	1	1	12062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLg91r61zC6vrG5exiyKUqwF8UkQuPPUuWpNTqKooAHixKzj4
29898	payment	2224	2224	2256	1	1	1	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZuUuynayrA4mxzvdLLjKnZpUuLgKuLbaWAtmFf268vGgmyXs
29899	delegation	1993	1993	80	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5NgfQnvyCezLG31X8WSwpUihEf79Totz5Qj6VoV9Qj51ZEMz
29900	payment	2133	2133	1874	1	1	2478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4pkL7fWaSdbmbirEJhsmUAkLsaUbeXixAbq5FsPcGJLmN4jL
29901	payment	2134	2134	1874	1	1	2898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxMt6Hyy9pe1dkMor5sE2adQ2b4MyS2fjDghCmZU88gjveh5u
29902	payment	2132	2132	1874	1	1	807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56HTc9zTm7QkZX3S3QKPdX892TdoBbpgrLoNtumEjkwNFH51t
29903	payment	1397	1397	1678	1	1	12063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE1RB33ZKBgcSz1EuMTPcS59naM4dRJxvfmo7YvJSU4uxBArq
29904	payment	2134	2134	1874	1	1	2899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1sqiXbdupaWGBuBrbJpap8V78SSMVaJr582r1JjV4cgt8X3a
29905	payment	2133	2133	1874	1	1	2479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeuEceQpUzDtfGJzUZPmqBZutEpKfUnXXz6FECjjRHQnJxqqQ
29917	payment	2133	2133	1874	1	1	2483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLNW4oQm3Q1bABTJWgfuDUbpd5AjcoQNK1UuEZGuFBSPzs4jB
29927	payment	1397	1397	1678	1	1	12070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbWgTTUrkJSKdhiAVobYByXjPQqR4PASnYzcSG5uxN1uqvNMb
29928	payment	2134	2134	1874	1	1	2905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6joXPuEeKKfJ9sxDNNU5ztYSDG93xvQVH7Qgfj2YG6afyZQo
29929	payment	2133	2133	1874	1	1	2486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKZrpqEeaJHZCsGbAMPhM6MPcj4BMnTpYTE5iou3E7S125AaS
29969	payment	1397	1397	1678	1	1	12081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowQLgzrhqXJ8aGbecpupAajsWn4LkvgjsNwWFN19SGePq44xY
29970	payment	2133	2133	1874	1	1	2497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGNnJBoV3CY5qE8fSU1s42suDJKrYjjCSuSC8WGcSEuDjCYm3
29985	payment	1397	1397	1678	1	1	12086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CjtK5GrAHjMCetMBSWPEi8EMGahJPJoTfX7qws4tP7om7WFf
29986	payment	1397	1397	1678	1	1	12087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fLkC1sWXagVMwEqmtJsRcdcjLMkFykw3DsKvngCaG3QZpKh6
29987	payment	1397	1397	1678	1	1	12088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvf84oGSgix5WJ36sa3Wbt3Y5DqK9DDCVCzuWoUKgkQnZRx4ug
29988	payment	2134	2134	1874	1	1	2919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7S9yHnvS2YBZ83R8jygfJS3TgsyWq8Tamj8VSLN4pTe2afjR1
29989	payment	2134	2134	1874	1	1	2920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yV4LQGLxozH8SWb89s77d2br5LMPBvJoaWHb4MQ3fLBqZ57Z
29990	payment	2134	2134	1874	1	1	2921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadd1HppKobNaSNXd2gKrNsKvNUr7HNmrTNECD6uivreCHk1wB
29858	payment	2134	2134	1874	1	1	2889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVk4k79eYPDf2HoNLJPJvAC9cFiTLv6WZhPFuZUq9wEf5LA6yk
29859	payment	2132	2132	1874	1	1	804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo31tXsfimLGFeooRYwE4auXc4QinRDKywv1JX9HN4ZThd6rJ3
29860	payment	2134	2134	1874	1	1	2890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TrbUnKNS3SPXqhSMHMS5CgCpSvL7HwShnmE8LixpaBhUkXjQ
29861	payment	2133	2133	1874	1	1	2468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwVoJUrJvgxRiBhKfQshifqKbum3jrT48eTf5GKxs6dScVe9M
29862	payment	2133	2133	1874	1	1	2469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjQexSPLWruwM4pjbcRiZ3BBPAQaDSEvUqdgRm9HcNeWWweuJ
29879	payment	1397	1397	1678	1	1	12056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxMECvPTM5ptUa6erfCz38U2cFyHFqk9jMjV1DF1NkuXeWuJf
29880	payment	2134	2134	1874	1	1	2893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3jauS9Ruhe6dkYZ2jt5cK3Pm5qY4JFBnbMcdpZC2FpkiGTGx
29881	payment	2133	2133	1874	1	1	2472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuypyLY1YXAYZi6PftmzGB7BQxCXnxtryYBGaaHXszXrdZFQc
29906	payment	1397	1397	1678	1	1	12064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquCSEei4GUJ5YPZ4gyBXd3k168ErHRB2PtxDpz9FYJUXfyzkz
29907	payment	2134	2134	1874	1	1	2900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxneBAaRLdSmspuLu737M8twVoK8XjJuKdE1eiKPsuRM5A8dbp
29908	payment	2133	2133	1874	1	1	2480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCMGGTqaKGXuerSvuJBRGikqARBXkQ4EtjeGw9xuAgknDmade
29909	payment	1397	1397	1678	1	1	12065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqTbuRDygmvJ8WakXQVqdwsvgstwXSwZGvgzMcKQBvQLJJ2Cy
29910	payment	2133	2133	1874	1	1	2481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDqNdYFnZHzRgLQfbHgG8SvYhTp86BsZ13xN8RxFc3hDAJqdi
29911	payment	2132	2132	1874	1	1	808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVbdYV4KkKiZsVitn4ixmcAvstBt3GQLs2bTxsdZeUiTn9H9e
29918	delegation	2256	2256	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSBvt6RfP35LyYtJ5yf1HzihaiHrKMc5S78T5eLm6Ctt3te2Z
29919	payment	1397	1397	1678	1	1	12068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwiLVA5NKZVLbCyuBu2rrV3Ji3SotGwPsbFphY9eq959M8r21f
29920	payment	2134	2134	1874	1	1	2903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDR3sVfhVKAg79XRWihy2zQgwYUYDwcLkDQWCWGqd4wV8aQvw
29921	payment	2133	2133	1874	1	1	2484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQX6vwpbJid9YNnMNvxpyGgg8D9TvmunbbpL4WDjFgYT3wDNjb
29923	payment	1397	1397	1678	1	1	12069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcg4TFpkQSThSPNsgwfY1n7CFAXe4wSjMgjt9fFocjKj5o36SU
29924	payment	2132	2132	1874	1	1	809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSWZ9ngP15EVKNCawWquFoDuL7wvDnbuuE9kRdc3vQD6VJ1r3
29925	payment	2133	2133	1874	1	1	2485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaYS3EotNuT3ckpEGunbUski7YjSWmYainm1jLcJ4h4ypFZ7u
29926	payment	2134	2134	1874	1	1	2904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUBsp1McpUCrzvTB6CesZxjCs3nBV4HPeoEG5YngfwkBhmqyc
29938	payment	1397	1397	1678	1	1	12073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu45NwmHEvbJbGE5a3ibW9S3oKFpHQGTCWJzTt9wBETmRF8Cc7
29939	payment	1397	1397	1678	1	1	12074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJrvbmZxakZQozXsrzmTuj6PeRiM3RxagGCDjyZMZdttVmEfj
29940	delegation	1703	1703	1651	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrya5WSih9mQoyuRWoMT2Km3hoMssPqm86NSPDStWJWGZu6wy
29941	payment	2133	2133	1874	1	1	2490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bF6NqybM6piAkmmhgojBXBFDsxBT7E3KkD5H3ZhDD2hzwJZW
29942	payment	2134	2134	1874	1	1	2908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPgNvSLpzZ3LqsnmMqEzWZzGNgd19yHF5d9NyYivPQjE8pAr3
29976	payment	1397	1397	1678	1	1	12083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6CBaiq85c8q8UVZWP15AbW9UGFpBAGvTTaVaSRp4RiCjjQDh
29977	payment	1397	1397	1678	1	1	12084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDncvzyJs5eLr59W9uL5e4VoRraCL54QiNTdkf16njJr87fDG
29978	payment	2133	2133	1874	1	1	2499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeW6Sjz23L6TgKgHy1s6Y57dSrAWkcDTdV5wpGTYAXA271fhs
29979	payment	2133	2133	1874	1	1	2500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEin9b3DsJbNLoThZStxZe15FiXiixMJaXvD3wAgpEzqFUaLr
29980	payment	2134	2134	1874	1	1	2916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDWZqUVbQhyg3m2ZBHL6eoXmHrzHLv4S8gU82rciADGojFqEg5
29981	payment	2134	2134	1874	1	1	2917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgCVnHqVrxsD6tN2baditMHMJf9NL1tTa5UwV42oKLhJkcr8D
30001	payment	1397	1397	1678	1	1	12091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrj7xH8bkzVShGkJ6yvdfdACvhbNSYpQbD1WtZQ277WuoU9x9u
30002	payment	2133	2133	1874	1	1	2506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYax2NeuQbZEARFfK5zmLqtfH8bACUtNtBb7DxyM8D28jch2iq7
30023	payment	1397	1397	1678	1	1	12098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLs7DYAbtVicNcKRPNHPhy4H1kmMUgXV79kaZpuRXSy8SfTCJ
30024	payment	1397	1397	1678	1	1	12099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbVoAvhEgPqqCMNMN4djvdnhpex2g5YF1LZtUHU3qcpNyyBg9
30025	payment	1397	1397	1678	1	1	12100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcazMx28Eb9qbVRL7RLr4NeudZAibwakyioisdqDrpcTAB4En
29875	payment	1991	1991	1079	1	1	18	4468245320940	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxD2pWXGzy9WEhyC1PooRD7ZYKXY2gNGx26KbLKCT7kyfxdgyi
29876	payment	1991	1991	1199	1	1	19	3014814154110	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2prTqLNdHMGPcnKQzpwiEqz1QrHwaZuZRTDVQn6H6qrEMeJH
29877	payment	1991	1991	1325	1	1	20	8401047702810	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH5o899YsmrHgUTqYz11evKyujAiS3bWG6gxZb9HEv99RzKz6
29887	payment	1397	1397	1678	1	1	12059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubRsACzssECsuh6dZYfUuTLCm7fmFuezudezhMo6MJ34pgnVQ
29888	payment	2132	2132	1874	1	1	806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYst2aEQdSznhiJU9vxBDNDovVkQDhGsksvQSdpLCQwgQPoK6KL
29889	payment	2134	2134	1874	1	1	2895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwkLwGnPYJ4qxafw66ZDDaX9fymR8gJ4SdQxWvjGYteDMxM5W
29890	payment	2133	2133	1874	1	1	2475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk8hLEeQoM63yhvcAjGzBayJC4BmNVR2tuT3SQEJJzsiFcb5x
29912	payment	1397	1397	1678	1	1	12066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhsGzAwgXaLkrS3YhAXBG1iw2acN3RwAbADxzo99mqxEoZxed
29913	payment	2133	2133	1874	1	1	2482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzfwWJwJdqq8sj8Vm8jXDgAmbTMPDu11hiqNJJgoHKhReziHF
29914	payment	2134	2134	1874	1	1	2901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54mkqARTgiufjFMCF1ZLMW5QgHEAd2yytxbQrqv9XKKnyeH5X
29915	payment	1397	1397	1678	1	1	12067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwZJK1BFX5bCQ4eqWHrqMc2HmAwJmoxhMs8aN3EJCRDrP8DFq
29916	payment	2134	2134	1874	1	1	2902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjoydTiEYL2kZwukniUKh1PWBjnkzDFAa5aCHck5ULopDbUvD
29922	payment	1680	1680	1273	1	1	10	7373028977568	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZUG7PFw1mK4EtR6Baiy344hc9tHrUEFspuMkF493wSgW1JjHBk
29930	payment	1397	1397	1678	1	1	12071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaU3oKow5Sqhk8V16ZWoRs3wnzuFyeoEoYnJJskxVtEFFoBSJc
29931	payment	2134	2134	1874	1	1	2906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC4qPRtEWY6e3PL7S61LhvWjQ81CqWDLwj2Ufni4xcU5T3sCN
29932	payment	2133	2133	1874	1	1	2487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXFZRyn6XapxoHBTsbsc3fjrjaw73WVmnmqhVTjFbNpmymroW
29982	payment	1397	1397	1678	1	1	12085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxYUrJDAg3wAThknYxijiqHoBjM7J8ABphARnwspK4fWzx67A
29983	payment	2132	2132	1874	1	1	814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds7MUY5RpnD7WyLrGyg8sSvtvsvugu9V9GaHxvpqrQ5CfQjxL
29984	payment	2134	2134	1874	1	1	2918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MFeEHLGSMpYTo6rtY1PF5RZJwSF7JQ2EWdjyAJmMXCNahHJx
29994	payment	1397	1397	1678	1	1	12089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVqpQLoi1TZZtTzsKe4jQwaREcXxFc2tS5SvDdW43nbeMSHUt
29995	payment	2134	2134	1874	1	1	2922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmC6kJcdtjS4uoZkZLxymnTvfXWvqEVYAuuSTTxavsjr93BGu
29996	payment	2133	2133	1874	1	1	2504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSxAAWbJNW5VotkF4aFSeuu9r6yY3jzMZ5EkdLPbEym4JJAFA
29997	payment	2132	2132	1874	1	1	815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfaRjjegGgx5nr38X1bgPAU1F85jJP6hpzUUAmJjUyzM5wzWBt
30007	payment	1397	1397	1678	1	1	12093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxFHMKGy5pL6Qj27RS7w8dkhSqMaNrm6wNvRQaD72hqbEb12P
30008	payment	2134	2134	1874	1	1	2925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1Vw2KrviiqT6Uw6LYHXeAiLqmXm4yhPJWwT38BiVDc5228CT
30009	payment	2133	2133	1874	1	1	2508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwYo9pgrs8gyx6K2AWCfieUUFfxch4HF38GUxLehVNmxDpbe5
30013	payment	1397	1397	1678	1	1	12095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTNkCM72Xt69aGK8jQhGebX9ZcvLM5ZXFW1m7YFnYV4BW9JoT
30014	payment	2132	2132	1874	1	1	817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV98KuWWZraX9nksAvEw2DPk5WNxCidATy4KzZ45Qmad8qxeEy
30015	payment	2133	2133	1874	1	1	2510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEJxdAvvuyhkQoY1fWB6kHHsNykWCXc6B1jss3NsHUGAmMaBH
30016	payment	2134	2134	1874	1	1	2927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimNCAo4NxQAgZ4PgDp8TCiCQYv5pGHywN1P8cW1L1RgwAiyB1
30049	payment	2133	2133	1874	1	1	2518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1Tcu2orcYjkHXfPfJPoxYr7H7t45kf7THs798RN1L5ZWtmtV
30050	payment	2133	2133	1874	1	1	2519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZze6zsZPR1tVY7oKb2RmNSScZqxVGCy1efxukHGcMKEsecTcWR
30084	payment	1397	1397	1678	1	1	12109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUR7wz4gmBYHVyCCBjQ7KbmvHwSvQAmyaJnpWLXv2vZ5ZHQhdh
30085	payment	2134	2134	1874	1	1	2941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSrM3Md4hAmAMixxg341p66RcWNLz62kMr7g9gVMbVXMDhzLP
30086	payment	2133	2133	1874	1	1	2525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJbPNTuQiT18MJ12ebQs6qytNpvjABA4uuiQVQChFS8EPr6vT
30101	payment	1397	1397	1678	1	1	12114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqv2DbNDDgFgKPpKKcLBMHpAZeC9W9qdnAtWewcRdsPCQhRuC
30102	payment	1474	1474	1329	1	1	25	6254623183360	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpaDA5xAthfEJRxqSxfDXZSC8UnGsNts9xFAzfChN2LbsvwAZXrR
30103	payment	2133	2133	1874	1	1	2530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzH6t1WNntSNKt3nRF9ydsHC3gsfa9FwzNdyHnDzoutKVTxSCj
29945	payment	633	633	1258	1	1	7	2982000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZMwNqUbcWjUFEDrd8PooSsqEDr3q1SXYvy3oFEXG38CKZQUht3
29946	payment	633	633	1018	1	1	8	2466000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZGa3EPRizt7XMHbJww6V3qCNMbcQedcE8g8bM4wNYyehXVZGJb
29947	payment	1397	1397	1678	1	1	12075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2xaoQQ8uCWTAX9PW12TriH6HrDSs5V53gK5yru5iAQLE9RpY
29948	payment	1397	1397	1678	1	1	12076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomaakirjdJVbbXsYeGJtmYgUKeNzELHFirRXSgWtQcW6R9LNq
29949	payment	1703	1703	1651	1	1	4	10080000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizHuSpu1J219XRoJrvnJiXDLxQF5T4Dpge5HD2BtnTFVUS6Bw
29950	payment	1397	1397	1678	1	1	12077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJx321G2codz37iMSePF4NBbyPcEjMeLtnDsKxjwKjCH4WoHU
29951	payment	1397	1397	1678	1	1	12078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TsjJT8DSjN4QuctFU8UzbrDaTBbH61rL2sM9yJENzWQw3B3P
29952	payment	1397	1397	1678	1	1	12079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4uD5PD1oyQ1mzuWyTohsHGSbfPCKeJu9vCovGaWg2qEEinMR
29953	payment	1397	1397	1678	1	1	12080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MkJMaznojEbaWrBkTLQkYCehvE51cuWrbPUoFEHG5fXhDhpY
29954	payment	2132	2132	1874	1	1	811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVZnzidPArapfYcWjdPy6PpVQJZzdqUyG6waWurN63XbCWiwP
29955	payment	1726	1726	2257	1	1	8259	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeUVP7wkWXgxGYZaMXXrzzpiMUq3L41WNF69GmDWsjnDpHHtDf
29956	payment	2134	2134	1874	1	1	2909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsUXbNLCzed1t8dA9FZ4fkDE4w2NmiXSERWF3op7mBB8ALJD2
29957	payment	2134	2134	1874	1	1	2910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3iB3X9xvJSr7cRYrDr193Dfu1qbDTb7nM2Mdeo1WwSMEgnRi
29958	payment	2134	2134	1874	1	1	2911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjs8z5A5R5DsWYyMNDzw8dU24nSQevYFNu6JDXJJUvSENficC
29959	payment	2134	2134	1874	1	1	2912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7ExKyDFzQd6JnFi4nmSqAaZR1woLaBe7XXiTKFevo38WbeEk
29960	payment	2133	2133	1874	1	1	2491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgupRAtdGvebMiMfKn3katCf7y917QwTX5EGbBztrH8oYndT9N
29961	payment	2133	2133	1874	1	1	2492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Ecsx6UWyNbeudTYk4f8VEo7FpBgJMP1g8Kb2etqgmMahgX7U
29962	payment	2132	2132	1874	1	1	812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjEX4bRxVF2YRD7PUQTMrNnZ4PQtp69Bp5bXkFUEf8t9LFZq7
29963	payment	2134	2134	1874	1	1	2913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWFyZWHozmoFNfU8fiyJokpijtZ6wUHBep3vwwarZ38CoAvsu
29964	payment	2134	2134	1874	1	1	2914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbdTqiyexwknvxqcc2X1mubc9qF8QkZbf9z7sP9GBDRG8CCeD
29965	payment	2133	2133	1874	1	1	2493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MTm4wbyJ5sCVnvxbLPKD9UZ9gQ9hjVmumr8QvPj2GaoPWXmv
29966	payment	2133	2133	1874	1	1	2494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1y4bpC56Pu4dTsYdBGr3B8GpzksTWQ524TysP2cerCKbmrpxT
29967	payment	2133	2133	1874	1	1	2495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P1GZo35Hwv6qL4vnEpeBoPgAuaHEU2jHxnfwt2XyLWbSXBUZ
29968	payment	2133	2133	1874	1	1	2496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7Qvu6fLRMzMSouoBWqYbWyx2sc4qmAMoUz5NJcA1Q2VxhTMR
29971	payment	1702	1702	1651	1	1	3	9756000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKj7cqxRXuHp5YKvHMWYEgnUasHBYcYPBWpreFSekFKHKpsEy
29972	payment	1397	1397	1678	1	1	12082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRPvU5dQvgnjVZJDoSZGZQeTstVDQsvpqwDu12LLsLVvyfx8k
29973	payment	2134	2134	1874	1	1	2915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93Pe6zdbnyUFZemiSaKd7xCkjdnaUGGejbNayKzHdSv77Pqzr
29974	payment	2132	2132	1874	1	1	813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvaorTCM3DiSjHgcFCdQYz1YSpKJapWefrTJbtECNm6RoSus8i
29975	payment	2133	2133	1874	1	1	2498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3GCJoM9tK5kwNp9xBeF83tuwQ4QAVNZ5N3Q3Vzh7LRE7b3C5
29998	payment	1397	1397	1678	1	1	12090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjP5kGi66TobVTN9WXxMkiTCrKDAwSHR28yFmpFk7EbNKGKRM
29999	payment	2134	2134	1874	1	1	2923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgRPnqcEuXMLERio6WA1TsJBBNXbdLLFFqpnxGtWJzAfH7ueP
30000	payment	2133	2133	1874	1	1	2505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8LmxGm8XchNucDaEKKypDppfKP3QFPsyq2YuPMGyS8zCaQt4v
30010	payment	1397	1397	1678	1	1	12094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYFhyACpwrG1XhbCWZcUQffCFTpswY2ttpspoJkRMKQtYH3qc
30011	payment	2133	2133	1874	1	1	2509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwP723734PQ162kdowmk5oKsgmsFk4mmUXAr9g9EbBt9YaYmoL
30012	payment	2134	2134	1874	1	1	2926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYcxnLv2dfLfvxKNoTppUG22ZasqXyJmEWDmgoxSJvTH1dstY
30017	payment	1397	1397	1678	1	1	12096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWFV5bRDqWPsbqfkSHXF6TQg7LYn26DzDn3pUoRw8Xibv2fJP
30018	payment	2134	2134	1874	1	1	2928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeizaNEfAnjikHBa3G3n7Unfw1Ehh7YwzPpyDaP5f1P4i1uH13
30019	payment	2133	2133	1874	1	1	2511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6udVDMmSQcZL26mQHuz1uF2YepsB4wwV1T2fkCULBrkd5yVQJ
29991	payment	2133	2133	1874	1	1	2501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLggFd2RLXY22Ds5Rt2sXgQ32aXwf88W5wqSCpZK3tEq6KMaZZ
29992	payment	2133	2133	1874	1	1	2502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWNLonBVL6Rr8JZMQryMxJiugEesBLmUrpYKqBiT7gjhDdbT5
29993	payment	2133	2133	1874	1	1	2503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoQeLggQ3VRo5xk4cDWukHZLbC4RS9ZBa76DuNTvH1ecsLL8D
30003	payment	1397	1397	1678	1	1	12092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DjL69pHXwdV6qgXMpwi7diJSwVQnVcX8uXBEAkQjQdJ8sF7X
30004	payment	2132	2132	1874	1	1	816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEiwN1J8BG2uDXmmYoiUFLHk6gA8bXboQWdd7KbCtUSkmZudc
30005	payment	2133	2133	1874	1	1	2507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipDkDcCuDQkPhpBDo1CbmEYwo5uRRVoYLTLR5CFXYwxjXSv5Y
30006	payment	2134	2134	1874	1	1	2924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVygS9gpBPVnxuCe61EuoncPhxJRTq1aoJLZsuLcaT6gnnieY
30022	payment	2133	2133	1874	1	1	2512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYkAwZ1WioSxbpEQWKPmHoDEXVK614eujoXGbT9guywb91jQm
30045	payment	1397	1397	1678	1	1	12103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsu951wzysbGuwYALNdNVhVTgg3fdhtmi5aJKMZfJ3fgD2EgL
30046	payment	1397	1397	1678	1	1	12104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWKsxinhpbc6uStWrztNccfwRyaBjEEYbt3FCKsMosdSDdGPc
30047	payment	2134	2134	1874	1	1	2935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUu8uF7eJfAtTEyaA6xAY7B6H93NxS2b5iPLYKYmFohRyXKQ
30048	payment	2134	2134	1874	1	1	2936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQPYFLNAUm3UF47vR3vFoXtnT9Fz59aGqNgXBy2QwggRn11Re
30051	payment	1397	1397	1678	1	1	12105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEfh6i8pWD79vbNMbHxEBHVUz3UxubZNKvw3zRdyiyTRRTzH7
30052	payment	2134	2134	1874	1	1	2937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVYW1ZPbmrgHETQsLbwoRvvh8waSamsnjBDETC4xZVKbjNsAt
30053	payment	2133	2133	1874	1	1	2520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDNe8zXufSVrUJGttmfsRm7m28uW3dgzs5BsZEfxJ6YGAXxus
30054	payment	2132	2132	1874	1	1	820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVJ91TXs2pv2J2mrVWMddx9vJukeArbtV21g3vU2aRdX6pA9A
30080	payment	484	484	1073	1	1	5	1307000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	Ckpa4G5yEzScXRkRgNvvVJkN3T1ozbgtA7cZJT9HuxmoMwN6YzWgu
30081	payment	2133	2133	1874	1	1	2524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p7aFGrrdLjUZv2Vn6xkAUHD4fA7eX6CCtroVj2ub2FWfGZDx
30082	payment	2132	2132	1874	1	1	821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbLjqburSHpUkLfEf4CPT1n4CYMwwAL73yPrxSmVZYXggpVAG
30083	payment	2134	2134	1874	1	1	2940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGm8hM4jWbfhUmMZ7J4e3K6zJ6oDTDpW949Ficwwd6imt2Z3hC
30098	payment	1397	1397	1678	1	1	12113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgKzZWFAPLqHvUCvNtg4WqVVtadMy1hskHPc82UKYBRvk25ZL
30099	payment	2134	2134	1874	1	1	2944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVFAXvGxa6Np9mD3bWPr8Du76qV1NkrwheBjdCXecRppwetsJ
30100	payment	2133	2133	1874	1	1	2529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFJAMDGW85wqQqwyyc9o5pbxoxdFVeMeC9wgEh3eKT53BfL2o
30127	payment	1397	1397	1678	1	1	12121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZintFkkLhx5dFUfetwdcmn2xkp473cY4SJ2Nk5L5Yzo8GD1tmj
30128	payment	1397	1397	1678	1	1	12122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nC7yJcgNqX95vtVE3W2agjoA1DxPak4eCrZtq1deTCqwEi37
30129	payment	2132	2132	1874	1	1	825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKCnjJMdzyEQF5HSuK5iu1zmxQ9gnRL4GxcKpZ9QquCAiBQKg
30130	payment	2134	2134	1874	1	1	2951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUb1RFGHtHHgJsVBH4rz6oXpAuHUsb4t1pvCA8S1nnxDPQXoY
30131	payment	2134	2134	1874	1	1	2952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkX4YeN6LdQZmrepXuHh2iqgZ156bZtmANhvxfFkP73vaSpyrw
30132	payment	2133	2133	1874	1	1	2537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNYbxyJZd6dT5vnFKWaevXhsFPHpsPWu8eexoxxkAuuBkryYn
30133	payment	2133	2133	1874	1	1	2538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyrvz7LG4wxKhi4regFwfAhD66hymjW93eP7PAHenkSH6axG8
30134	payment	1397	1397	1678	1	1	12123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKR7fFQCHCj1GeveTAr5nK9qop3EcyijPoj56ct7EFmhSVqoLN
30135	payment	2134	2134	1874	1	1	2953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGTjdWDd6cxXSpNio4zwhVdk9RXGkMEZ9cgQx9c9CUB7NbyRZ
30136	payment	2133	2133	1874	1	1	2539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2fgZzeNgR9jb4cqXqsYfEBbyKRUC6xERKB3P1kEGJPurfeKD
30199	payment	1397	1397	1678	1	1	12137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCnQyACDpyScp9PgmNFsVNm1scSJJnRHhV3XJYEN2GZyHfnYm
30200	payment	2134	2134	1874	1	1	2965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzTC1wroX3mpj1MpqdBtwvMSLZ66eJ6cuxZN2xA3ynhZPDMBH
30201	payment	2133	2133	1874	1	1	2552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxM5Q12GUjHg1JooKH5LzCSinfMJDLCv2oxZYgS333rjf75M33
30208	payment	1440	1440	1131	1	1	8	4157500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsiXcURGWicZ63hXV4Pnz5NfYgL7wohjGsNoSoRXyHVBVtTv3c
30209	payment	1440	1440	1251	1	1	9	2805200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwvqnVZNCgN9PFAZq58b2ogBGoLrzXePXfigSbGJx5wW8ASzb
30020	payment	1397	1397	1678	1	1	12097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphppHoHrCjKi3dpyU22ai1T8Sc1E5WMoQV748B4WE64MPwGRX
30021	payment	2134	2134	1874	1	1	2929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokxjVXr4ePqhMGDwT61EsVx3XLLF7YRfqkQw4Vst76mA1Ziyq
30068	payment	1474	1474	1203	1	1	24	2244185767620	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZTR5wsbCLEahZ11UpLnjX4JdZXoi6Ej2JxJ59Vw7v96K3tygG7
30069	payment	1397	1397	1678	1	1	12107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ebTqZfX9WbSwYSxUi3M9f2GxAPdQ3RoY5NcpEoVXwMBC9yZC
30070	payment	1651	1651	1175	1	1	10	3196278839126	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpaJd2Rubb8ek1Y5J2hGiKj5bvFxgtWP4umF4RqDYf3qgQ2mBbrr
30071	payment	2133	2133	1874	1	1	2522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhiZdj3uLLfcJ35UNaU87UE1DSbY8zQoca3gzJQz6mx93ufVN
30072	payment	1718	1718	1052	1	1	10	2287527339552	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A3XGg1saxhrFRx429wkNFe2wvd952xfPXNzJszNfhehs91n4
30073	payment	1718	1718	1172	1	1	11	1543440278198	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHwKP6CPYz4J6VKVWZ5muZEvJ9pJHVdQjHEpXKGyVihyd94No
30074	payment	1718	1718	1298	1	1	12	4300933570248	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEMW3ixPp8ztVPNoa3YxU5xY3WzRMUFQT3so1WKNg9zkBnRPx
30075	payment	2134	2134	1874	1	1	2938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkjjBAAjZiqWguR47ck3iVM1H2uFUWwrt9TiV2FvHc7qyjThh
30076	payment	484	484	1319	1	1	4	2457000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpaEEvMzgCM8b2FWCkcWuAPGXG7MG891e8E2r9UPAmvmQA1bnLon
30077	payment	1397	1397	1678	1	1	12108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84LVTPtwcQG6PBD7rVqW1kLZbL6sn9ZSCacooxpD8LSxDxq26
30078	payment	2134	2134	1874	1	1	2939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfTe58aKvMm6Ab5ZQZ42JLyB7hyrkooJkYRuiWvedF66vEEuw
30079	payment	2133	2133	1874	1	1	2523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3CQUUaDbGsq2FUpB8GnPyUwxhrePxFxyCiBwCKPTk5RP7Bzg
30087	payment	484	484	1193	1	1	6	882000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpYW54xmeDdTG8tXvro9oCf493E5rQnZCQi9J2yTyBqTY5WJrjVe
30088	payment	484	484	953	1	1	7	729000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZrPq74jM74XiYabwhFQZTdx8c8PJEJTDA6ygen6wYs7ZNb4k9E
30089	payment	1397	1397	1678	1	1	12110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEpn3S2Gmoskh3BHwDmsKVY4HrgYhQcM3hjA7R1hzVbYHDhkF
30090	payment	2133	2133	1874	1	1	2526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA16hKyx4jXFZYj1dr6zvMs3BmBwaGp8YpFp6UJomrdaTXZuv5
30091	payment	2134	2134	1874	1	1	2942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrg38BuFiJzvpbuXRNCockBVGt8HxJS5n8ATXYe41DJiE4tsw
30092	payment	1397	1397	1678	1	1	12111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwBQxR6DqUm27y75vyiPZtjfToDTJb4tH3qXs8QcvMF8ULyo3
30093	payment	1397	1397	1678	1	1	12112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7cPhRaEUxSgdNLbrKgNdVpZugjnQMak3eVuvbgusCQZWnicp
30094	payment	2132	2132	1874	1	1	822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyNQTReEuVPGXGkfZDD6toKLtXqBPXhYwoBZrzaQHd6sDdVPM
30095	payment	2134	2134	1874	1	1	2943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaetb8ETVUMkBv5ErGqqC4sfqmc3rGkqLqVX1tW5qHGrSupo9Z
30096	payment	2133	2133	1874	1	1	2527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LnqEEsX4uvSUaz4vYXjMRHrMDBh7NdJ1iqFeXqdoVewkprRz
30097	payment	2133	2133	1874	1	1	2528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49445mQjMQWea718EDxk5W6KsoWqU1hKEhUiDpk3JKXdigD75
30124	payment	1397	1397	1678	1	1	12120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjkF8DNWZy4qWAcX3cKaedbdjFHcxH7FKMeRB2rdXf1GZdjGP
30125	payment	2134	2134	1874	1	1	2950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxTrdrkeWY9EbyK1mBN9pRJvWfgRCvLUa1iDXaS3hwgPgNUNo
30126	payment	2133	2133	1874	1	1	2536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYgkjwFPHbrG2oAHTuxC7WTFPBt2pHgRJAZJK9k5jnsF8womGE
30137	payment	1397	1397	1678	1	1	12124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zE3hFivupmvvBzJUeL2pUvjAQDxofeqCCwv7ukj9VE1W6vAz
30138	payment	2134	2134	1874	1	1	2954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCbSHZX57BB5PVS4skvapDZRd8FwJb9NEo5gHdBF2xDWTyd4o
30139	payment	2133	2133	1874	1	1	2540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQHZh2owAncSf4CoXNxNsFefnGadmvy1j2tEuFkXHvxNtzq5N
30140	payment	2132	2132	1874	1	1	826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJqvJ7mjH5AchymWyb8qSTyeo8pfPp6VQnqmud19a5Tzjkh7r
30156	payment	1397	1397	1678	1	1	12127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruajrMZ9QAF5G9jhY4m2ux4Pqimb1i4smzABYG354pS1FSvwP
30157	payment	2134	2134	1874	1	1	2956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYUVhakYiWHvsutPKbLn7pZBL26CikyZmp23tPNtUkhiQgDxi
30158	payment	2133	2133	1874	1	1	2543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSQ94fq2rVfAazKiyiiyZZasbSi55iTju4AGQ4TCpqNF5pgXe
30167	payment	1397	1397	1678	1	1	12130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvHpPnQHd4JTFRiSJPLbpMgET94S1NUJ3RZazNiFWAynEzyWF
30168	payment	2133	2133	1874	1	1	2546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDT9WPRyauUaEkhhjXUaqSUcUsDMKgUKGZUhjEvxBKbJ97mUeQ
30169	payment	2134	2134	1874	1	1	2959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrxYAvQMcCvgtPgbm1BT8bYNWbBN3yo5oBrnvMKNhndwFrcMS
30026	payment	1397	1397	1678	1	1	12101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6o5AVXwj935cVZMAJwWuNh2G4BQNFC4F8jPQEoq4LqT2aTqbk
30027	payment	1397	1397	1678	1	1	12102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoDJjbCo7qF2AR4oiwFipThJrynDX3zoxSfcfxvSQWVTqtfw6
30028	payment	2132	2132	1874	1	1	818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUuRdVvGHp8UhEXug1xbfAWxiSVP8W4tWJUnNcfxBRn3Zd1Q5
30029	payment	2132	2132	1874	1	1	819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsZEjjpb2xgvrRk1zS39cx4jBENPa8ib8pBZ6APA4FEfSimmT
30030	payment	1726	1726	2206	1	1	8260	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYzSRuAyYmCSuRkQPiFvoU3egjhLDjr3uDTscwhSTtBnEa4Qy9T
30031	payment	2134	2134	1874	1	1	2930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQyUNS4DVN8onmBQLLvVoof2RoWBEoHSKqzCbRHYuh8GTfKNg
30032	payment	2134	2134	1874	1	1	2931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzuJzCPLhw1sNyacF2WhC6rvBnefwU69T3N3ugJPLVDYNxp4Q
30033	payment	2134	2134	1874	1	1	2932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajSSaTDCzjRsRL2U2XM41SyBipYb14cCTnDPgTojjEEvdgQ2Z
30034	payment	2134	2134	1874	1	1	2933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmNB6SvYCpuc4WqmHZikQ2Zaqc8aMUE2AyVJSBuSV9b7Zbc6h
30035	payment	2134	2134	1874	1	1	2934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcZjiApgnd8GeYw9DCjmXX7kA9bdkzb1pdn6NeYPi857hY2LQ
30036	payment	2133	2133	1874	1	1	2513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Y3Tw1YxDcpn4ya9rn1adgczRqWf5PGfGKinopv59MruUNaFA
30037	payment	2133	2133	1874	1	1	2514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65PaLeMwodaqRxowP3LTYd7jDXUHKfYbbTbozie8QxHz1iJoX
30038	payment	2133	2133	1874	1	1	2515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73L67ogXhw7nFKb5rUHSu99kG4hQ8zALfqjpABuFtjAujEUoC
30039	payment	2133	2133	1874	1	1	2516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZV9BuP5vJQt2XZEnP38reookKvKUcg3GcjVwK7F2GPG478g9c
30040	payment	2133	2133	1874	1	1	2517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aiEU6aDaTvKujWwJUfkgdw9rxZ1g9dZFmWXzwAKLJn1qzzVo
30041	payment	1726	1726	2205	1	1	8261	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHbEDmAT5846HckboWHcebyr8cTc5nCsmvzmx5f1scx1QhnpJv
30042	payment	1726	1726	2184	1	1	8262	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMcvWwRSvhw9G6XY8YVuF1yt8njZnnspB1rupCRzQPQmXmZXxZ
30043	payment	1726	1726	2185	1	1	8263	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCeKAzxe4zzxv2FtmeiT2CKbFMKykb76Hsw7ChAfQQmtAhqeTT
30044	payment	1726	1726	2258	1	1	8264	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfcQM3kgaxyztVFWzAc9xptXMaVWCPPDxQT5oqdYPEZPYddMAt
30055	payment	1397	1397	1678	1	1	12106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7krWLmNH65BXGD6Shqt11q7JvFKsBXw23FYufHTZVcGcEM7R4
30056	payment	1474	1474	963	1	1	22	1856091315180	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZDJtoR4xoSDhzSQgLkcNaSGXpvbsLhfx47yndohY8WBKmfVcF3
30057	payment	1651	1651	462	1	1	6	347494240603	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZxfKLqLnsrG8u3VBYURixnSD1cALeMaYbgm9SDFrHYCHMF3KTe
30058	payment	1651	1651	754	1	1	7	5265064217	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZqvNbYgEgENDTj4xtmg4AiTGTCUmSwtvpzjNoVo887X1cZJseN
30059	payment	1651	1651	935	1	1	8	2643535789138	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpYgXxbBs7vb8WJ8MGLjyPmmpcwZs584NgcxAxtY2zLKUxhYu8k1
30060	payment	1651	1651	1055	1	1	9	4737193484311	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZ9TRZ7wVRDq3SSMYsqEsTBASwR2AV6W1sLnt9vkJfFbXnjKH5e
30061	payment	1474	1474	1083	1	1	23	3326099733820	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZyvaeyJ3tjbCRZRw4a4LsZcGJpAp81Qd8egp2XifPcqK2Xnkdg
30062	payment	2133	2133	1874	1	1	2521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVsQLzZLZRZv4DtLpQXQcshtxARjPuENn7ggmrXpLfDQaNYy8
30063	payment	641	641	1090	1	1	12	3758374800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkd1Ur6EK4XPQ4XiEo5WkevYQjLrV7U1X8cMVzEwsLVBWNkt1D
30064	payment	641	641	970	1	1	13	2097075600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28L2ySpmJA3rwRFkW5EWcCjqvoRQdir3sbcM5CeMTQ6TQPPE
30065	payment	641	641	1336	1	1	14	7065241200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxbUkeB1nAuQomgLuD15Nhqr4LKQATFXx3SNtS9GwVoSGBvmg
30066	payment	1718	1718	932	1	1	9	1276528056272	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SBg8dKVyvbKk57NfkAuBD57hCBCm6nixFWfYYU5L3JrgyERv
30067	payment	641	641	1210	1	1	15	2535998400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJD7etuMPhygpo18omqGLjxzj3u7huRBaY5Y68sQWyLu3AxCF8
30108	payment	1397	1397	1678	1	1	12116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXb5Y89YyQ7jF6EE3nXDafbcYzVLpbtyCdjcjTp9NqdUR2TuXG
30109	payment	2134	2134	1874	1	1	2946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfcidwhqEsj34jBZQqXtdMsySMivtupdH6Hh8D85JyRfemcug
30110	payment	1958	1958	2259	1	1	2	499800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajZZCz1JCSNbdTbvuZnPPCjNRSy3VLKTZn86PXekxN7PRJewj
30111	payment	2133	2133	1874	1	1	2532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbrrp43qGzJgppez5WWQou5yjE9AUoSq37LGZRYTVAMdb8TKY
30112	payment	1651	1651	1301	1	1	11	8906715182489	10000000	\N	E4Z2gV7MyJzJe2z9rDhn1Cyd2GBLvS2Uo9wdJnuuV16FVCTG4C5h9	CkpYW9zHcRBg7ApxsZyfPubLTVEiuzbFNMJShmsYp5SQMPnCCSsFt
30113	payment	2179	2179	2260	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvAFrwSVvoau9z7LYCCxTge4nyG5gXjrLuzHBhreAahDZg6rH
30104	payment	2134	2134	1874	1	1	2945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhkRTkZXZJTzapF5vs9vu1d5eKySQtwfsCB7Aj3Gxf5pmeHBg
30105	payment	2132	2132	1874	1	1	823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoaLDgAhyprQBSroMAmQowSBEYZF43tFoHwtVw3dqZnWVNANh
30106	payment	1397	1397	1678	1	1	12115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx57zJ6aczGD1pJ5RGfZKmPb6agVA9E5tMiUi5NVgk3pdnbFaA
30107	payment	2133	2133	1874	1	1	2531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7qekLdnvsgsDmkeEHjZPLAvjsAYV6BZh4TK7K48YXp6Sxcrj
30141	payment	1397	1397	1678	1	1	12125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoALck41JwCdjpHg3PzAs8jUxWwQiawwU2fgQ5AFxiAmiixSz
30142	payment	1634	1634	13	1	1	9	21728930621	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZhdbJmGyjtQNxM2XACzyLbJMSYmvdmyeyfk2hzKvVUp6ptoD5t
30143	payment	1634	1634	19	1	1	10	10866801244	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZXg5cLi9QmciYjuq3wNEsZqBQvQ2tWA975Qw2FNeCuy4whJAiM
30144	payment	1634	1634	203	1	1	11	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYTSxbQXS5xb5RRJz5wkLMW7NQ7AknX1VnnTXgjFNxA9bibYrVv
30145	payment	1634	1634	241	1	1	12	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYdLNbg4d2Gn4quZ9YHo4nUFPg6oKSKeDipWCvy4cFueCHaK1xL
30146	payment	1634	1634	313	1	1	13	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYVaQdgaF4XrH5rHoRk2e55wcbrvpMbuENLhpBBYhxN3tSRKJEX
30147	payment	1634	1634	965	1	1	14	2286444226326	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpaGFUtvhCfLH1bX3DGj7VExGG7fDSDwU9vRpBJPRzac4dMtoms7
30148	payment	1634	1634	1085	1	1	15	4097288463320	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZ81jdiEFZFQb5tcvejMQocsNQRX3eLsGCGqmfRhhpnSRY8aZXp
30149	payment	1634	1634	1205	1	1	16	2764522170436	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYXVvQYKiqjGiigEE9JmtqxBCUCw9N8GNgkFbPwG8a3avbf1X71
30150	payment	1634	1634	1331	1	1	17	7703586835568	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZuFJCYobVTg4DbsZvKdGDjYPqsyQoVCiLUkpDZ1qMTBFvfmAR6
30151	payment	1397	1397	1678	1	1	12126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrdAzsHtjycAH1rXXGd4GiEga3Hwznr32pzftHEWonhPVbZCr
30152	payment	2134	2134	1874	1	1	2955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRiDFEcuBfFBoZEwWtuMVsR8MXxZoEtuXvk1wVANGtdFeLb4y
30153	payment	2133	2133	1874	1	1	2541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk93r9GMQ3CL8qyvSuRXiZaVeQnmNa3o1d8Q4dhU9mruuMNdvw
30154	payment	2133	2133	1874	1	1	2542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdM4exMTWaP1XC2CHgiRovpzqD6GaHbktLy4aqKnYoXsfT1Nd
30186	payment	1397	1397	1678	1	1	12135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWB2uWQ7vFzRmtah4jpXmfu2Tbusq4FhBgPKvUk3gzYrEcf56
30187	payment	1506	1506	2037	1	1	17	684000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHJhADB2FncoW5owjrvCn5RPUVrqzqspUSMMMjC6MBngr3DES
30188	payment	171	171	1128	1	1	5	3336766309110	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpZ1FoLFYVU6asGeaj25sCTUbu8zUMVpXsuc7J8Ro3C1YDSBCTTV
30189	payment	171	171	1248	1	1	6	2251382718519	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYgR9UaSEaAKSKmbgnmjAXscC5NbM1VTXTrn4hXSSe1Y9J4eEUk
30190	payment	171	171	1374	1	1	7	6273678126963	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYYGXJc1wyVBcZ3YKj3QuUG2rGxDdaLdzxA34ijP4JPXjLamxTg
30191	payment	1506	1506	1373	1	1	18	5837500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfPMouN4beqnhURi7mNJU7iQcn1g1kMGZHp3UpMGokk2GNrwy
30192	payment	1506	1506	1127	1	1	19	3104800000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAs85VtRmozsnyQunadkn6js1ESJckswWzbN5MJHsgrUno52o
30193	payment	1506	1506	1247	1	1	20	2094900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdnqLEkibXvCX6LPjEyU2SdLkKMWDYzYHAdMRBzyzdjFk8e69
30194	payment	2134	2134	1874	1	1	2963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzrzZw99ze4FPQwkt9sxwuA1ZRPw3kqMBHhBrjQyTbtriWBCw
30202	payment	1440	1440	2040	1	1	6	900000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNcuSoXrp3tWMbi8C8me8g6K5n3AMxQduKFUfJFHK5Z5U9aXM
30203	payment	1440	1440	1377	1	1	7	7816700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtWpSemeFn6NN8ghAFkdjFYxrZaaXrz5rfWukKiD3mopip4aq
30204	payment	1397	1397	1678	1	1	12138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjSN58qxddse4hfvhuUgxRSkutFAfoLpNMEPVTmJPyGcxtDjP
30205	payment	2134	2134	1874	1	1	2966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tuoikC5YfEXKyxSgNjudAdcX8h1g24zXYyQnzqJpo1umQt5L
30206	payment	2132	2132	1874	1	1	830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY2DrbLzMaaYzsfVURH3fHv9bPgPtxyhBXAxsRtgxgF7Ae95V
30207	payment	2133	2133	1874	1	1	2553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbk39CmRjVThgPE9hmtdFQPtc6EevkkxNRLnrmvdcRJHLTmyZ
30214	payment	1397	1397	1678	1	1	12140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBp3dSyZjoz2YVhfhiE9vsqxd7Ekx5PJ2f1qwqGQaspZWEN6St
30215	payment	2134	2134	1874	1	1	2967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ253dNLdYy1v2DSsHEUXtUFEi6rm3e8urnCq97it3SrMUBGxFt
30216	payment	2133	2133	1874	1	1	2555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofyBDJfyYH6aSnpdLnTJhSdGksb4zZkGxwZv3fQGT6E7uncsq
30217	payment	1397	1397	1678	1	1	12141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgzVn1emS1abvqDYtF2LNmBAmGBQbzMFStvP8hVarBeUQe7x4
30218	payment	2133	2133	1874	1	1	2556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7wBu655oDYbfVJqvvAfuAGDGQNATBo44968HbKr8snY6YASo
30114	payment	1397	1397	1678	1	1	12117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsFJA15XsseZobbv3EgHGMqdv3R7DCqhhoMc7ayTTMAkJDrwT
30115	payment	1397	1397	1678	1	1	12118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPxPgWKoiaTQntX1f4WEjYRatC61L5McJZJGAmt3sSM5Sdccd
30116	payment	2134	2134	1874	1	1	2947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmysipFuQKLcDZpsf6MBWL99hg2ELKzPA6wxszXUKAs5ChDkb
30117	payment	2132	2132	1874	1	1	824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrH7ybn46PFB4Y3LTsJqPTsoAXu7mNGfXqqbno2qgG9UR8Qou
30118	payment	2133	2133	1874	1	1	2533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYYQnM2QK4uyTCvU9AUxLnk2MFZzsh8vzsaesshcK8b9TDpSh
30119	payment	2134	2134	1874	1	1	2948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEX6H7jLuJPBQCqXkE2vsVi6eRi2368bJcztMGsaFHCXbt5UJ
30120	payment	2133	2133	1874	1	1	2534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6dzDpPaNgYRfaXpEHit2TANgJnrBE2JvCeqTJhVgdamHGz3t
30121	payment	1397	1397	1678	1	1	12119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZN99WnHSMGXLsZ9tVuLyAaxhfmCQzuTsffBGkWg2STnUEKxf
30122	payment	2133	2133	1874	1	1	2535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqTQYcmZpdgKCtuADc1AVCyPujakevck7PVcCzbWU5t1KcrBt
30123	payment	2134	2134	1874	1	1	2949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5KFQkGj2e2V92RtBDQ5W9P2FXFAGokGUiw5dMTbpeLF1QrJ4
30155	payment	1474	1474	1329	1	1	25	6253623183360	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZjwuncuNXTdBaZdkUhegAv7PpPTztspehiKDkiWZugaXAnmgfc
30159	payment	1702	1702	2003	1	1	4	1044000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVD9zuAX9g5KAvPBECrbNuwkRXg4Uo2y5DVgj1P7sFXsBLZKc
30160	payment	1397	1397	1678	1	1	12128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzi4252ZBB4iHihUqmNCGisURHR4VKf7ZnVCumhja6dy2ujogz
30161	payment	1397	1397	1678	1	1	12129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyfeUCiann3TwnvTWKtMGVbswmironi6gdxfEk3YeCmtXnhzK
30162	payment	2132	2132	1874	1	1	827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCUeVsQRVHgmeoL6jgXs4iamRCw4q6P9ujKZqKmqp54Cz4p2n
30163	payment	2133	2133	1874	1	1	2544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8kh2SXsyuhBAp6rDLArNHPQJi5k4iEMJ8UaJLKQbFkhzPu3j4
30164	payment	2134	2134	1874	1	1	2957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpyZMSnE8ViRdEMexqvx3Wg6Fq7LK3Ee5uhPUcQnUbGTB9iyq
30165	payment	2134	2134	1874	1	1	2958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeEu16bAtBhb4KjSfcMqRPrZvCvpWGdHWxZaFchZqzg7D1Tpw
30166	payment	2133	2133	1874	1	1	2545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAzHUNRF6AKZ2ejHKgGPwTLaw5n55LgaSbjYs2gGpexTuBt5q
30175	payment	1397	1397	1678	1	1	12132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqb62aAPHiXoavWweozJ3ezBctS1F7Q13oFVMcjtVgwfwWWp7
30176	payment	2134	2134	1874	1	1	2960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw92eAmheDVfh4QdQnVag6do5MFp8KSJVVh4xwDVoyQNPUrDhH
30177	payment	2133	2133	1874	1	1	2548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhYGiwbj9zS1cjforPqEjvjvtbus8uc9SPPTs9yVvBHRoFU9P
30178	payment	171	171	1008	1	1	4	1862043673602	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYVoQWeGwPGV3Eu87uaT8oqSKVnVkjhkWtsf5me4fiKYhAKx83t
30179	payment	1397	1397	1678	1	1	12133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNVntvRhC7tM1HciNoLpBSaUPKBgU3qxdUBeaHwDFXrH9VMUk
30180	payment	1397	1397	1678	1	1	12134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKozo3D9GfHYQLnZDGGrw7iks3ZMKWGcZLugTrnysfBfsp1xW
30181	payment	2132	2132	1874	1	1	829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiNxehMcu2JWfyKcBSZahsR8e9HYrsSSthkpbvdNZZE2gU1KN
30182	payment	2134	2134	1874	1	1	2961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82rbtZU42cWB2S5v1QWYpqF626WYTUYusaGq4nxGiqyarbXR5
30183	payment	2133	2133	1874	1	1	2549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pFeNRpm2YQWrGykZGygY8j4N16wNg1dZmgSpMghhiZg22thR
30184	payment	2133	2133	1874	1	1	2550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxUDV2LtphHmHKdudpdg7r7C4VkeiJVyux41u569EuwPt4Tp9
30185	payment	2134	2134	1874	1	1	2962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJDEom4BkLjoZ9q8uCDaeCHpFLkVoyboDrNiaSZZtfGyFp8fJ
30195	payment	1397	1397	1678	1	1	12136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLka99YNL1WD4S5u1tbPmBYQGcJz4TUjAhaWqvrFiPagtcGjg7
30196	payment	1506	1506	598	1	1	21	227430000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZAUGmPKXfQr2cWoHpacvZQ76ddx5cYW1kVMULXrBUrjVaPVD
30197	payment	2133	2133	1874	1	1	2551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZET7ebGhkX9e8wPtyPpJEYcbiUdr3SThytYYfezaYdikPX2ypj
30198	payment	2134	2134	1874	1	1	2964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZueivgehHc4dkEY1yJc7Bc3DrFpGrPggPXiz951gz82M8ziyRM
30213	payment	2133	2133	1874	1	1	2554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcWD2oc8hKvHPVy3cY6UdHYb8yjJrG5eSf69Eg5oh4zkGd43L
30245	payment	1397	1397	1678	1	1	12150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAJzff4peHqKogsKMds11NPg8rFRPtHBH9PGhMHFxhczRCyFk
30246	payment	2133	2133	1874	1	1	2565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY25sjxaLQqYkgpMj96wzTNP7fHunCAjD7r2UAQceBj6EdC67X
30247	payment	2134	2134	1874	1	1	2975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoFvRMxFHkhbsef5HdjSoxdgYjXcf5FApTezMARTpYNy6SpGT
30170	delegation	2245	2245	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G8FdY3oKVLYzLJZumJyD3idV7TrRPvtNXkgeALQXLJPAu16x
30171	payment	2179	2179	2260	1	1	1	90000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCptn4svD6NXSfRBwtqxNL183DFX4NjkW8vdHeNSFMXyHGKCvv
30172	payment	1397	1397	1678	1	1	12131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKufxseBido5tdowdXL5cxKvM7D3Z5nPDewMbv3wSu41KeF7oh
30173	payment	2132	2132	1874	1	1	828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9APmt2gArVAGjK6X1YbxxjaxNvyhWtiSwYtbj8c4bACYMZms
30174	payment	2133	2133	1874	1	1	2547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQCVPmZmHYxDjK62NMUwj9aw8CxMW7qFotbtK1Y8PoFpX3tYF
30221	payment	1397	1397	1678	1	1	12142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgz5PTogC7ZRThJpPpdueq2tsk7279ahPuXwdvwarW7s9PqZKL
30222	payment	2133	2133	1874	1	1	2557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJDEmpyeUEeB8M4z9gBfzhxpXCGHa7xkPWZ77YroAJoQP3kPs
30223	payment	2134	2134	1874	1	1	2969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZQRGYfCdqaZwA5qeqseZq9dARTg47A8pQ3ZvMqdisxoFgn87
30242	payment	1397	1397	1678	1	1	12149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRPWF8UecqLQFXDJK72b8Hf6NYhyz7tvZxsKKT5Hv3UWLGcPp
30243	payment	2133	2133	1874	1	1	2564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSTi2A1t9j4H3MSmTLnhuPg2CxhesKupQdAKB1ADciVKu3Y6b
30244	payment	2134	2134	1874	1	1	2974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeWptWxVTWNCDUZTzRGXGDHLjTorRY9H613oC97diwHPvJMNe
30258	payment	1397	1397	1678	1	1	12154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5weSJK4fbygBPyWkz5ejatQMEL6abhnSreomErPc6MHhkLzmo
30259	payment	2134	2134	1874	1	1	2979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2RB2BX2vTkV83w4BJzKqgJF1cRktnbBZaAYcD9htY5UopiJQ
30260	payment	2133	2133	1874	1	1	2567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eYDoU6XmRT4NKnrNwoaCo3cUhRcGvbjhdUxNC45wSFmmZpSs
30261	payment	2157	2157	2157	1	1	24	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvvFeCDnHKvVpkZy6foye3gWmmkhmZDUtRtuvPMFyA5ZDdyRy
30262	payment	2133	2133	1874	1	1	2568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1XF2J8RMZdQgwEtqQQ3iAhj7W33H33TJpcv9uY5vWc81awPB
30263	payment	2133	2133	1874	1	1	2569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZfzYQebL9pbVLqD8cjuuT5xQRAzjueUQZTu7ML9HmW7wUKej
30264	payment	2132	2132	1874	1	1	835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkZhgXyUGWfz86BgT1jqipRSkZqivEZBgs9yA2mp8Vhi3ge37
30265	payment	1726	1726	2260	1	1	8265	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYd24H78ptupFsZFVuApvzKY3KBtWzGvtfCcw2y8ihL3WepqcyM
30266	payment	1726	1726	2262	1	1	8266	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYj5SX5J6Sax6jU6gNtdP4HNpzjMErujeaxY9jaj9MDQ9kYyzbE
30267	payment	1726	1726	2184	1	1	8267	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgo1EmTUwLUXE7Zi51gKHxKdRWqRFZhibepc9mucrW8SUrBS3c
30268	payment	2133	2133	1874	1	1	2570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRo985g8Z6QDGfd9eUdrEHCDJKCvaBi2hUswMavKBcDGhZizr
30269	payment	2134	2134	1874	1	1	2980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5A3jDYexE7Njzfq22FCBKbYnWHCDjUf9TBuzpGf3UDPdo31u
30350	payment	1397	1397	1678	1	1	12168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAivL7LzphXD56PLt1uUpinzqSfoJkVGRhKsaNAV6zcggyS56
30351	payment	2133	2133	1874	1	1	2588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KRoKDfd4tANCuiNSAwGG21iAxNd4VSLCseDyVafC5J4qFE56
30371	payment	1397	1397	1678	1	1	12175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5oWK9ibwpjkfGsrCT9kEMwMUKskaCVD2mppQj84E5AkG6yry
30372	payment	2134	2134	1874	1	1	3001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicMJtV8qLDhPtA4cdBjseTHw7wW3YaEW8HG5cCHNQZMXPoP5V
30373	payment	2133	2133	1874	1	1	2595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR5JcaZsAWKdjhjidPtoWCcrVXQsNQx2sUUH1HiCM6aPDBess
30374	payment	1397	1397	1678	1	1	12176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXqVtDsS8CBdyiafyrPFV9vACjVKXS6AQk2kKL82UhV4qMYDf
30375	payment	2132	2132	1874	1	1	843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbmTfq79J92NYEaYtFsnqMsR6i6LvdeRAgPWtP8a9LEtmpZyQ
30376	payment	2133	2133	1874	1	1	2596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrUiPtNraPFR4TLFddH7G7Du26ofcHnzYNsMgH9H8CASHpGwV
30377	payment	2134	2134	1874	1	1	3002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzkxtvyWArrR4c58YsC5nQPLneFULxUfWYKLRBcPWrENemBxv
30446	payment	2133	2133	1874	1	1	2617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAmb8NKRrgGqbPtvQxpnJr2jVR73rqwvmJoXP2a92ZBQSx85i
30458	payment	1397	1397	1678	1	1	12201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXab9drTyS1THhVnmgu4nhHCurggDB39ReWHGBQyGTA3zsJJ8y
30459	payment	1726	1726	2267	1	1	8273	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbd1P3Y4tf3Ha3UJLDESUft3ekwL4LTAovCR4E7tkhawAdUUJH
30460	payment	2133	2133	1874	1	1	2620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2h24fqT1jTmUDA816Zc82Y9zFKTp6KaYAGsqtu7ZvoCptXP5z
30488	payment	1397	1397	1678	1	1	12210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5rdfqJ4nDMuFSeH333oyDNvZ3msAWD6csPy4uhfkEBqK7h8
30489	payment	2134	2134	1874	1	1	3031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZbvXLnQSsGhUVtsdAvRKi6Nqo6K4vsZtUjxam5LjN6teoQfm
30210	payment	1506	1506	1007	1	1	21	1732600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr44JeBKTqSxxS9nExZMDhpQ8BH14pFQ6px1z9Ei2o1i5gPtE2
30211	payment	1440	1440	1011	1	1	10	2320030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kUHzXNrDUmS12TBw51WSJWPzffd42BVpCmByeunxQq5831uC
30212	payment	1397	1397	1678	1	1	12139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZjRQXtQ2wFTQtgozox2Snrvp7AC8d31imD5b5mgDPYh5Tc8e
30224	payment	1397	1397	1678	1	1	12143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyqm7q8puTqC7zgysxyMcX8y2EXybqw5YCM6okTV9QqcU7Eab
30225	payment	2133	2133	1874	1	1	2558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZfarpqLoRuPjp69Fg4hDVivNoG5XuRSVcWZsptdbSHqgBK1P
30282	payment	1397	1397	1678	1	1	12155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2JXfFvdacFCBVSsN1mAPbejms5XqvxsDcgWSG6wEHWECheJh
30283	payment	2157	2157	2157	1	1	27	300000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5MZMP1zVLkRPCg8UHyUq92XkF9BY2a523PRu6yz4GRTyvpAo
30284	payment	2133	2133	1874	1	1	2574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxjmbGXFAqG33hJnYsqEi6yzTj1xe5neojgsNNT6jbUiBkm2E
30285	payment	2134	2134	1874	1	1	2983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQ3Pn8rM4HZ81Emkv87KMDu99FLvZsYKdcGqZxxS6eevvnMpq
30286	payment	2134	2134	1874	1	1	2984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaw2cH5wDz4jgEtur7hQhn5XQdF2uhFwMxC95ruAoSUp6Bt4Sg
30287	payment	2133	2133	1874	1	1	2575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJAeHW3k7mFG4eT77YxgtARbx6qtUoujLHT566Ca2THf5NeAC
30288	payment	1397	1397	1678	1	1	12156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBbEDssNoJv6SgPcXsL7dP8Qtk9g5NrwufffXWv4e617Rc4jD
30289	payment	2132	2132	1874	1	1	837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYAoC3QghZPoPC6SQf9FaMQ17oq52cUU72N7c1ixHyFmBivvQ
30290	payment	2134	2134	1874	1	1	2985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs4L5JNLayw2dARhtt1N4EcxGroWZvEA3Bc9Z5eFcJE8MdvHk
30291	payment	1602	1602	1003	1	1	5	2461875540000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUy62f23tv1aC7sYMoZFJYS1ZJ17su6Kzti8R6CdvseCeE3cnb
30292	payment	2133	2133	1874	1	1	2576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVCCsqMpnnvv1DXtFNcZBgvyVBwyi93XpfrS7xBSUk9XznNFE
30293	payment	1397	1397	1678	1	1	12157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuE27FW7Pmdwg5JZDc3BP26MH5W6TtX5CwmAiD1rnouNfQQPB7
30294	payment	1397	1397	1678	1	1	12158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySYbC9wazrv7hihZQgwqBEPSuMDLyxqsABt9cAPMdktPZbMP5
30295	payment	1397	1397	1678	1	1	12159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxdkN56sprVVzDnXLk34c849uoCXjoFX5HqcSd4n2nauX76b6
30296	payment	1602	1602	1123	1	1	6	4411659870000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkA7APZmieEoFmqYvjqFSB7zqVVzh1pDdNaXkwE8NVUZ688rh
30297	payment	2133	2133	1874	1	1	2577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWorir9kWuSAxAXNgHbWTd4qAkht8DvP9UVwrLiWQRdwC8L4r
30298	payment	2133	2133	1874	1	1	2578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqekebLamMJHY65hwfQ5PspP8amB3EoCaaLGhD8cA3rVhy7fz
30299	payment	2133	2133	1874	1	1	2579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaTaVoLC2Dwro1egT8V8E4pyW8jz1mcty9UMgCB3aXbmfVMaf
30300	payment	1602	1602	1243	1	1	7	2976634820000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX3pUHNyK4EF3GXkMMbvyLPpzCsoyX8WSu7buaJd1mrMPUk7B
30301	payment	1602	1602	1369	1	1	8	8294657600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC7ubXXEprFKi6k27kFZDLcRadi4r2vLUeRsSLLKfWfHdvD6i
30302	payment	2134	2134	1874	1	1	2986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bvdBmsYd6u5Lc2v9Nk24qiX9JjxNBByJrkdWLygrvrqnfgnT
30303	payment	2134	2134	1874	1	1	2987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUMkquyuATT5AXKogLDR1bXsFTZTFci3XTcBK2Sv3mCGWamZg
30304	payment	2132	2132	1874	1	1	838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWws3bbnfRrkCsdT5PzM9irTQ9BwUhdy93gZbVwdsRT1WSf31
30305	payment	1397	1397	1678	1	1	12160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WhD5vUZrUypXujrnkgU4RBbnnw13d1A8poU1iJwdBfiwcTgJ
30306	payment	1397	1397	1678	1	1	12161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7C3GQ9KnaPHpRz3F9DUGunBsRCBmPWXADoJaVWDVVa4LUcqLy
30307	payment	2133	2133	1874	1	1	2580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCWjNfi4KsNUiGK9wJYcBBb8z2SGcT9wTgnCxob5f5qj71FfT
30308	payment	2133	2133	1874	1	1	2581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7L6sHAamrVCUWiXTjgbwWKohhvcUvQjWuqigwA5memnNxsNA
30309	payment	1726	1726	2266	1	1	8271	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaFjHFN4uXWwmPq4V1JWmTdebNmbREHHn3KAsUUg7v6QmEuWLUg
30310	payment	2134	2134	1874	1	1	2988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUtVdxCT4Yk3gGv42hokj51TUqe6PsyABGxT5B8ebJSYrUT8T
30311	payment	2134	2134	1874	1	1	2989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRJSGgY9zdL8C2rUxF5kVXweBSswxMM3k3ADjF5bB22HaixWY
30312	payment	1768	1768	1308	1	1	6	7297200000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpYmQQcDg45YZbPjBiwWmYrtg31WTYh9H3hQCvLwQkFxvQ8dnaDe
30313	payment	1768	1768	1062	1	1	7	3881700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZKf8Fmzs3HaTGQT9JqWHp78Gogs9Xzb8YhP8eh8pRTudL9ziPh
30314	payment	1768	1768	1182	1	1	8	2618700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZmYQaRDhuDtiY2W6HE1NRvYLvYxGi7x3oJ3hgea6bTLGX3scVh
30219	payment	2132	2132	1874	1	1	831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEzSqGBqbT4y5kFkcJz2ZAWSDwRfhbotHPSTgmHex3FyqjZEP
30220	payment	2134	2134	1874	1	1	2968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtX7wQd5mVnosXccETg5GvcvCYMqvpxwJQzRXUy7kkuxZSqH3
30226	payment	1397	1397	1678	1	1	12144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqC1PTWyK7djaJ8TdvgMkp4b6EfrB3jqANHLEvKsSFgc83f8C1
30227	payment	1397	1397	1678	1	1	12145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhkPswLFnfCtB75iYo9U5Pqh137Pvn1RKpwLuxoFUFxom2dLw
30228	payment	2134	2134	1874	1	1	2970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYadyRofLJwGccFs99cH8TU8fhNvACTEKYYB578Vx1GkfUGz8d
30229	payment	2132	2132	1874	1	1	832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbiYFcaHx57bvdVVLTz6N4GKbYExqpTcSNTW2X9so7By6Veox
30230	payment	2133	2133	1874	1	1	2559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5BpyRWEnsAnYoxJtkmHUVL41Srdxh7XBLnEcKjcnzTrf3nfW
30231	payment	2133	2133	1874	1	1	2560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi6U61XpPCnove1QqrQ9FutcYdSkkzo4XgJPz3ysJt9UpZDBt
30232	payment	1397	1397	1678	1	1	12146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzS6CoJpPU9ex8694JPVdE5Fo3XXwJjkrQk9NgraddoVzMoUq
30233	payment	1397	1397	1678	1	1	12147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3waBKKKWR4gaPuJVRuh58NtX9fuzHpt9Rb2xieNGALp1E7ZUQ
30234	payment	1397	1397	1678	1	1	12148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a53oQCR76sP4yiC6X26J5uXBy3CqZPFhGv4YNUBLiz8LxDeV
30235	payment	2132	2132	1874	1	1	833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9jau8FxhihAvguo57YkX3RLuyVPnocx846PccihyupusZvhH
30236	payment	2134	2134	1874	1	1	2971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY27SAjFNsLwEHcHHSKEermn2NaZBKisn6MjrDfwPM14nNjhgf
30237	payment	2134	2134	1874	1	1	2972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7n56pw51v1MXsvjEtJjzbXXaBBBMhi8BSa22WjjG853Zr8zy
30238	payment	2133	2133	1874	1	1	2561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy35Q16x1iQBBbFygh3QsgFnBMdxjCqnFALEZ2Fq44dpS7S1DH
30239	payment	2133	2133	1874	1	1	2562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTN2nk2QFYW9yBmcYt9ePzaRgeZi2NYZkC9UmVknMMY2Zxg2m
30240	payment	2133	2133	1874	1	1	2563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq8crdjFBRdkS5yCyUf8eoRoZ3TR4ZEWo3U9PGTVh3dfPNA8o
30241	payment	2134	2134	1874	1	1	2973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8rtLZBWejhzNH1BTKFjsWgXmyFzr4viMQkqNNurwb1impksi
30248	payment	1397	1397	1678	1	1	12151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyHcabaPKMPnpdijbGWJMSyabj7ewdPJM7PwCG3sxpA7AxFWd
30249	payment	2132	2132	1874	1	1	834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAt59KYSA7wd4DmiHHV8QMDeXUGiYYbx74FFSZynyAA6QECtf
30250	payment	2133	2133	1874	1	1	2566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqeDXCd3p1hb3FAo99YUU1zmuxgyJTYCGardtTbsQ8YbrJmzp
30251	payment	2157	2157	2157	1	1	22	5000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqUaBBGthx3MyPbwhP5PLhNd1HTZcQqTTAJT5mfkVcywKwyEQ
30252	payment	2134	2134	1874	1	1	2976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKH1PAc46QPh78cvWUJJHZ8TEACRrKUsSm9V1LaSVu3QNhHnoV
30253	payment	1397	1397	1678	1	1	12152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnrM8TYMVpXM6SYVfbjLgpmn5rUtnE5WwgEVpcji1SwBsnqq7P
30254	payment	1397	1397	1678	1	1	12153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY52JGjUb4XcxrnoWPF8DUfBAGVtSWaf6CLoGvQdPK8ZBSLZqj
30255	payment	2157	2157	2157	1	1	23	5000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoHMz29EFYFTRnL5eVm2sot9J918iHByM6RD7AjYuRAaSks4K
30256	payment	2134	2134	1874	1	1	2977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLpXbuFtEFd5ZkB3VFqydibFpUeAAzFXHjxfmWhy25Jp3Pi43
30257	payment	2134	2134	1874	1	1	2978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJAFHy4efmKJQaKVGLX9f1AvZUhs5mo61nty9uyzmgnKRiuvT
30347	payment	1397	1397	1678	1	1	12167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1CebxCghgm3vubE35wYfC5jXnJ4F5d6fn6dywhA4GCono62Q
30348	payment	2133	2133	1874	1	1	2587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzjDbv41iTwXTammQfFNG7BKsunzDejCUBhRJ25V6AKKdN8mJ
30349	payment	2134	2134	1874	1	1	2995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmENXFFEp6MiHWNAiwgUnixVH2apN4stP5tD5CBKfadVZ1DfZ
30359	payment	1397	1397	1678	1	1	12171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKSu3cueTAYFfmMLb8SGeXCMjjbK7vZUuZXGrkj1hU5DWoumS
30360	payment	2134	2134	1874	1	1	2998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6157Q8TBc23BNMx4162KFXnPruTgdwe4JcugdtpAYkRCnssU
30361	payment	2133	2133	1874	1	1	2591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zcXj7tjcxBioSvv2tNkuDbqeWDyEVt9bnnuCHeFNAbrXCb5w
30362	payment	1397	1397	1678	1	1	12172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Bj4QpW7ZDu9vrBMxfhuW3g6wZhLbJhKktDtj4s5sH7DscjYh
30363	payment	1397	1397	1678	1	1	12173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vg5sjrz3cWEie3EUX2PADsdeTRoKimABLnCYVbayusBE2Pw9
30364	payment	2134	2134	1874	1	1	2999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMbNXKZibMSzgxhDAoXvP6ai8D9K1ZMU15uWARTTeM1Wu6CPZ
30365	payment	2133	2133	1874	1	1	2592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJamf1gQkZZNvjZSWaeoNNaAZBV2gMGtsBurdAMBH6EdjP2j3
30270	payment	2133	2133	1874	1	1	2571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfk8Y69TXoJZvFJ5n2Ur1a2qYjVyTyrVbGiU5EYkLqKoE32RZ
30271	payment	2157	2157	2157	1	1	25	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdGJP6ER3KyjT2JHxGy6LoZdRxLuNZ6J5QwMdR9xd8uHkXFQU
30272	payment	1726	1726	2263	1	1	8268	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZku7U4rncN79BvoUznVGjQptgL4rMwa9hbn1n73AWCAPDfF9AC
30273	payment	1726	1726	2264	1	1	8269	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZA8L33UP97Wfq94UWk2Ks5wkmPJjjU9mXeNANqGNYd7BxYrevN
30274	payment	1726	1726	2265	1	1	8270	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxEMYHHAjEWynGQkxoyhwvZ6gBoEWbiWLGLSb6NsK1cmC6m25g
30275	payment	2179	2179	2260	1	1	2	80000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtYxrNJCCK2Ys6ZuscYeNkcciGrhJptAXjJ2pWt5P5MBBDyYW
30276	payment	2133	2133	1874	1	1	2572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMDXeiLQ3TJJw7axqHeWo6pPervbnT4snMoGx59WmtxPeRCSz
30277	payment	2133	2133	1874	1	1	2573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEnza1VBGkEbxMMWkvbX4zYNbq8E5qjQzZ1Tn7XoiJQiw2UFr
30278	payment	2132	2132	1874	1	1	836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQoFg3nfMoxi3zZ6EdoqDGmU2d2HcmjZ23iNWWrhEhL1nMYXb
30279	payment	2157	2157	2157	1	1	26	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWSwWPwkSe68j4e5pMkQe9KvhhEeGT9XLGZSc82W5PyG3SoQ3
30280	payment	2134	2134	1874	1	1	2981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinJmcmTAcyqgYURNvQXLeJu8CuzgSszp3vtyx5u3oFjJ6GD9g
30281	payment	2134	2134	1874	1	1	2982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38efCxGELnTr1NckYN2UsVkAnWcoYR7k1SgEC4Xvz8xiytLVy
30356	payment	1397	1397	1678	1	1	12170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ47KZNzNwYt6P6RvFk7MyEiQKA7pHDedde6zNGRkRrGr4g2ct
30357	payment	2134	2134	1874	1	1	2997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtYhscCdd45waASNYEBJBPfzgMx2ATmAodcs8tvH9Yd6fQxAk
30358	payment	2133	2133	1874	1	1	2590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kCCoQbadTbiAHLvQdgxmV88KwAgPmp4MCsV4AHPaoDWohSU4
30389	payment	1397	1397	1678	1	1	12180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83WkBMGaDNBCDrGVb9sjgYgm3caa4neWCV7xtjyQNXAQuYjgQ
30390	payment	2134	2134	1874	1	1	3006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73iAKRYaawfn4U2tRjefYz1UT9G8Af4JDPkSeadQFf66PBFUv
30391	payment	2133	2133	1874	1	1	2600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4x2MfuB74PyS7rcdqs9yukHcgRCGJbSurHX3byQjhBvpXrgh
30413	payment	1397	1397	1678	1	1	12188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkqtRTZ23yUpyvaH4oz6EShwNyphqPNvw3ehW664nqNsUMxVa
30414	payment	2133	2133	1874	1	1	2608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dtQC7GrjKrs3knn5xpi6uEmz84D1NYWw2Y9dtVVsgNo6vFby
30415	payment	2134	2134	1874	1	1	3012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDGMRV3o8oCYHG7eR1TEwjk2eAJo5KrymEpRuZ7tBZqUbUFWQ
30425	payment	1397	1397	1678	1	1	12192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FMd6nD9w7K4ipKKQ5eKAaNiKbzeyXajrc722vx1Cjvk3TKiJ
30426	payment	2134	2134	1874	1	1	3016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRHaHBojMmaob6QE7qHs9JhjyfR2oztG4HiaQDKpRxx9JXP5K
30427	payment	2133	2133	1874	1	1	2611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZijpVWP8YbjZCXz6uGQwMnsqgdvmvJoF8TvBUb2WLxdAK5vmc
30437	payment	1397	1397	1678	1	1	12196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNGT8NBSEtug6fu7gkJCPLpqzfawXF2ahSd7uEFEEivqnHGSd
30438	payment	2134	2134	1874	1	1	3019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVP9sbmnwpPPuKFiyA9UkpTY4vi9Q75hK9Q8QsgDV3iq1E8h5
30439	payment	2132	2132	1874	1	1	849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSSjf7k5Uxsb8GgKBc1wntcszKhykqEyrZuyxELwzA8uF1U4P
30440	payment	2133	2133	1874	1	1	2615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcLSqN1Rgzai8fv8S2feFxLZ4Vv4oXQVVpRLZW2AkufLjZDdH
30474	payment	1397	1397	1678	1	1	12206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQSmF9yM3Cs2kxQ743b4wz4AH3rZH1Dj92sWSb3Vi2UKiLuXY
30475	payment	1397	1397	1678	1	1	12207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgq7ivciD4tJzM6G8Uob8qxj2rrDZ5ppLCBbeAx9zB1rKyGuU
30476	payment	579	579	1469	1	1	1	90000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTnNbDHDbuGDNGtXDeVjy5XEYbMi575uSjMbghq7L1XkLRPPm
30477	payment	2134	2134	1874	1	1	3028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobS7A5VnHSap2zRsTY5FRs42kzpao24febZCDKTutcxbUfzwc
30478	payment	2134	2134	1874	1	1	3029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaWbx96BoRmng4xTrcS2x78fbCp4HjUT5NL5uvbrNTfrtPAoE
30479	payment	2132	2132	1874	1	1	852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG6XLCBz8JHYSjE6uHQ9GXva3wefMqpuvn9n9d19e2MZL5wbu
30480	payment	2133	2133	1874	1	1	2625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPDQ9DWZGW5LDDfgRyV6Wze42gUHPMjXYExAwrebA7BcHLTbY
30481	payment	2133	2133	1874	1	1	2626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PnzvUXg7H5SbpbcEFAb2EA5UWCJsTeaVxmxSLqgxvbrzA5vN
30482	payment	1397	1397	1678	1	1	12208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HVJ3jhrKeEecbmt6U5tJK7NBFDdtzjmKpVmZHe6cHyGwkfpj
30483	payment	2133	2133	1874	1	1	2627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgz5YYj89Craw3pfAMTcuqJfH8KZufa5uvcY627hxZgxPHf86
30315	payment	1768	1768	942	1	1	9	2166600000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpaG9ZJboF3z7Kh9Aydw9XmMAyuTjHBu7suzFdxZ2hD6prXefSnU
30316	payment	1397	1397	1678	1	1	12162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdKT5u4fhSVKbPsg11yesuyEeBjmJJhLi3E22NziJhJiNySbD
30317	payment	1397	1397	1678	1	1	12163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcmzYzvNS68BHgbvWBFoCqgrTWiRxaQuPAHmiUfJJCNXxqqMY
30318	payment	2133	2133	1874	1	1	2582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoapGgQ6Kfdxj5gbcEzGS5SvQZeEjfkRL3iVgQYZQrdkC1nYuu
30319	payment	2133	2133	1874	1	1	2583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4pBR7USqZLqByJPBKaTTsSxepCYf9f6b6jGz1yEcSuu44zCJ
30320	payment	2134	2134	1874	1	1	2990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq8PN786Ek7itTtthonXRwFSKrut1NkmHg1M1nLGTKehP6x4E
30321	payment	2134	2134	1874	1	1	2991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLoFihHrcFRAxGTNxK4wgb3cfB77eMUQcqomseargH8197Mgq2
30322	payment	2132	2132	1874	1	1	839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjE1djNo4Wq1QygatCfTESm1BBdp32GrfaWjvXC8KZYi1458m
30323	payment	1726	1726	2262	1	1	8272	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzoEK6RJdNS8PSDTFetCwLJMZosvC35V5bQ6noDrKiSsFZAKgE
30324	payment	1762	1762	1307	1	1	4	9067760000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpYgPj4qrzRBJRXoLVtZswJh8xwNHQU7Fiw84GNyfh8b2LmhPGSZ
30325	payment	58	58	149	1	1	7	364670000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfkVNG9YdMJ5K83khCHbofJJe4GTZLGyo8wrCCeYkNw8AFsoW
30326	payment	58	58	1281	1	1	8	9359710000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot9LgBeYVJkQGHYtA3h3MXnPAJNq2hom4QjAFghFnwZRwwwnp
30327	payment	1397	1397	1678	1	1	12164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVeTARQSgYc1JjFJRXsfzMv6D2Ldx2p9vz2PusULYrwEwvKEn
30328	payment	1397	1397	1678	1	1	12165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSVkNqBEmp9FotqDGokKmffqYciLaVyQ7sr965Z2YDMCuWHpC
30329	payment	58	58	1035	1	1	9	4978130000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rqeXhR7bW6Q7a5uof4nQBN2YuhUC55FH6vHWRMRPj9cqZyN4
30330	payment	58	58	1155	1	1	10	3358850000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMGYn4DcQzcVFjjzh79v3VBnwoLNTNSMPovUEw2aThMqga1vD
30331	payment	58	58	915	1	1	11	2777990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa5BN3wQui6nn9vTQnvFcC3wkB4jMieWuRTh4QMA45N4Nbbcq
30332	payment	2134	2134	1874	1	1	2992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy3VUQoLAhLw2WUXvdM44D2D96YY9MZG5CLFjhj1xAiNHkZAJ
30333	payment	2133	2133	1874	1	1	2584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g2HijKnejTNJ7eafzN7Yz9YDRmksXjEuGuSN7nQpstm3oU2K
30334	payment	2133	2133	1874	1	1	2585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjH865M1Ea5c3gf9zHhmtHdvxQtJpbjXBFcyxG3JQ4THMhtTfc
30335	payment	2134	2134	1874	1	1	2993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUnAXKVmBrdPVFmXbntTG26o59avSubjjoqEaVj7FAwhauBGw
30336	payment	1762	1762	1061	1	1	5	4822850000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZrUcpKz9n5N2fhSFtVXMWi4HamVbeCvzp7NFumbiCx1WvgD5AB
30337	payment	1762	1762	1181	1	1	6	3254070000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZDBozEGrLJTwkhbRWZnVpw5DP3SC1TG3cvXBRDYbdCPFD655LR
30338	payment	1762	1762	941	1	1	7	2691750000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpaCfao2MeRk2PpMYBoPeMq7maSNFSDWfMgQywMZbriwRsstQhnQ
30339	payment	1397	1397	1678	1	1	12166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7ai65RXoi1Meczg2CvJ9C5ym4aWC7QgPgGz18iMu6cZjF8yx
30340	payment	149	149	1283	1	1	5	7817030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bWccTeGz5mZLR1t6b8Fy6opJDBJbFmckgagnnZ1XjL4DisHL
30341	payment	149	149	1037	1	1	6	4157630000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDGVV3dmr9PXnD72vYS6eEkRcBLgiU7m5m2tGz3cKWSyPtYgs
30342	payment	149	149	1157	1	1	7	2805240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN9hFuoCXkGnF96mYdMqZ422d5hiqKqtYVH2qJDe3QBJduNpd
30343	payment	149	149	917	1	1	8	2320120000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqSUiv3dYkKHGcxrG2cVsFKGPPdH5d9QXZ9exqzxVPtEyrPC8
30344	payment	2134	2134	1874	1	1	2994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYNvVP1j2nXvviPsTVs9bhMs7RfHfnSavJjwsy281iYgEmfKf
30345	payment	2132	2132	1874	1	1	840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpggFfzXCcMce14dja1zANQhFgkETgRvBfciAbVS21KE9KMLq2
30346	payment	2133	2133	1874	1	1	2586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSYFf2g9fXpY5GCxx9AneyUWouV4jXUUsRxzs9VbLRo2WABjw
30352	payment	1397	1397	1678	1	1	12169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SNPh1JMk59idijzWZjMgBpmfLDumtD15yamQ2tCAAmzEWJNP
30353	payment	2133	2133	1874	1	1	2589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2LUWZw3L412omGfhiVx1Ast81L1KoyRiD4ydyEQR9cZ6hf8m
30354	payment	2132	2132	1874	1	1	841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1AFF3VqjoWm7od8HFZTWFkujKouCKoWb8VHdwkV55uMSfZYm
30355	payment	2134	2134	1874	1	1	2996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gRjTErcwzGDJ3bwZuzu6Ahw3jV4P3V3haw7fyqNBHHJaFPkU
30379	payment	1397	1397	1678	1	1	12177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzp4AqChSEhFSeyAzxVsMhQ3qPFVbjGCavjErvWkCwf84SZcX
30380	payment	2134	2134	1874	1	1	3003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2PWYKfYRFmaje9DWSs9huUKGB3RF8wV7UJMyHvDsefUYTNTm
30366	payment	2133	2133	1874	1	1	2593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zP4ucxaAD8uc45C1reT71dcmBwGMBkkGb7peCjckMFsnGfiT
30367	payment	2132	2132	1874	1	1	842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEfG8Ndxe6vvibofzMhxGSoSTgC5qWv5YnqkUxn6R7FswYtWx
30368	payment	1397	1397	1678	1	1	12174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBkSM3GpUukUxpNxhcoqtobz5ua7uuBFHGBiXVGBbty6YsgX3
30369	payment	2133	2133	1874	1	1	2594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqe7kTikKQtB5AVaNtV43c2aNniobeaAqSfVwxMYw8sAtJh5v
30370	payment	2134	2134	1874	1	1	3000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vPimepuaj9iDpM7ugrtpuqAJ7HX5zGzZikn9ymKQR6SaFiZY
30378	payment	1651	1651	1301	1	1	11	8906715182489	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZtyDGZxVo4BtfiZ1XuGMhQ3LYcDRuuwSM1UTRgFhiJ5MPPiUzt
30385	payment	1397	1397	1678	1	1	12179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9WGKr8gjK8ksYWaEQP1xrzVm5jqWUpYQKBXAGKHfbyHwyHyw
30386	payment	2134	2134	1874	1	1	3005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXVVPj7DvDS4cqjXDuKLsJHUVSTJ1hxcertf9rMjZACC4gC6o
30387	payment	2133	2133	1874	1	1	2599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PxczwSTMwoDneJrtE6tAHFgFGJgEmTT4iH7dJ4273qFcqPDx
30388	payment	2132	2132	1874	1	1	844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54WpQcfqZZ3MtKxdwWXiFoFe2NG3XzLu6taXUGNrHwt1vYhdX
30407	payment	1397	1397	1678	1	1	12186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvyGxWhLSC8Q4Vw9vx6WT8SELn72RHCuPLESEeUWbdtnRzGqw
30408	payment	2133	2133	1874	1	1	2606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Z2jwgv3kiC2EWiMTHDcZyRkMb8SYDf3BsWgzRU5NqR4epFib
30409	payment	2132	2132	1874	1	1	846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zZAkZ4wuHeAidcVs89xUyzporWEwtT7YBQ786QENsNw12XWt
30416	payment	1397	1397	1678	1	1	12189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhQv3Q7Yanuw8tx5dZGCjVZYMcB4iPyHtvN7WmgMyK7nk96N9
30417	payment	1397	1397	1678	1	1	12190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQzBwv7hCfxGYSmJujHpnoYu6PC7NAFiAfM4Xqf9RMnKd9vhQ
30418	payment	1397	1397	1678	1	1	12191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCnk4u6hJfdzoNcK6weYUuEC3jQrU6oN2pFfsdkDb574d1Ci4
30419	payment	2133	2133	1874	1	1	2609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJk8u73BroQUALQpB7UF1AgrCdKi785KKqLaviH6QkXxNtm2ht
30420	payment	2133	2133	1874	1	1	2610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5n3BZMrieVaSBV7yhWASCv7bqpAX9fQioHrVibNp3CNWcZY2h
30421	payment	2132	2132	1874	1	1	847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP58GzH4ihLpiE7aY1cjVZiL2XLLd2ZUco5EeVHJNjQK4FpRyG
30422	payment	2134	2134	1874	1	1	3013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vjP99Tbkssarqqj7yzfbsZ7Vy4H4Ez8T8R8JEapoCdFZ4QGG
30423	payment	2134	2134	1874	1	1	3014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhAvGpQVPoQLe7Jg7ZBrBZJyqBmT3Eu9QXx3q2N14EHnCy46d
30424	payment	2134	2134	1874	1	1	3015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZnt44x9Zar3vECvPh2NykRE7zteWZSNgpV9MDSjv6kV9McPk
30431	payment	1397	1397	1678	1	1	12194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJru329s7M1mBgZZKh3tuy47nmcjNkJQZ3Z8Q19p5Q5Mtidtv5
30432	payment	2134	2134	1874	1	1	3017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddXHHtxL8vMxzhxfDm1LAVUQCoL5TYPtgbe7AnMyYAHmMRxKv
30433	payment	2133	2133	1874	1	1	2613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oyXcSdxDxPmg9atEPsXebKyJbei12zWnCmSDdD5Ws83wdW4c
30441	payment	1397	1397	1678	1	1	12197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqehzK6MosLuGs9YyFZTiPC9B5id6XiDwMgGVmaRLH93Q1DuxY
30442	payment	2133	2133	1874	1	1	2616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiN96HsQRif7i4cUbrNsRSiYpNS9SJ1aCsxEPQsVURVfWiXJs
30443	payment	2134	2134	1874	1	1	3020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6gxjUGeP9TjDrH1vdU6SehLcMfjuyPS24Ha1G9B1KUXPruy5
30444	payment	1397	1397	1678	1	1	12198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP8H9wkYRofKJxFx2qU8ww84PmKxXM5FX1fugo2okfzsoFwxP
30445	payment	2134	2134	1874	1	1	3021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFZCgxNhMDRXXmkUTk7eTMPnBX78LZSiJM9kFhHReRypwwyBz
30455	payment	1656	1656	1097	1	1	5	4412000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxUt3f4CceGUEyqK2uYJRFKkBQUkQhUKZAtnwi2oAKAvNJL1S
30456	payment	1656	1656	1217	1	1	6	2977000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8EFE7eY3js72dY9LZgaqoKhU2Y8DAKhFScJutif1C1MgyA7d
30457	payment	1656	1656	977	1	1	7	2462000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGtRpzsAE3sXU1z8dsZiJatw7yjP1sTCaZXYQiCsm8TTD1x5f
30523	payment	1397	1397	1678	1	1	12221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4R9yMbiUSGvoDTwUGju4KjZEFEkv5JUNPre5mLidA71hryFdE
30524	payment	2134	2134	1874	1	1	3040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5MiocfpAVFFAgLDSv39MwTZpHmQsvAVBGjLHFqoTYeCY4x1n
30525	payment	2133	2133	1874	1	1	2640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmi8k8zJSTpSSrEHK2CUeJrUphg7GrQredW6gTYJA19Jz1Evvz
30529	payment	1397	1397	1678	1	1	12223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8m6BHhaY7rmXC1u2sdXLLp67SD7SzzqEiXAtE7yu8ue4peAQ
30530	payment	2133	2133	1874	1	1	2642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCpgXZsEKAvPEpbzZqXcsUbPdFmyGqrKJUtisg7c1mKmuf4iP
30381	payment	2133	2133	1874	1	1	2597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDvxz6y3NKvVvDuochDK7Ltb8yWTAuRWDp8vf8gKGy9wxfmVf
30382	payment	1397	1397	1678	1	1	12178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNsyLEAMzeNGVjENre2VvycfRUMRpyHcUNgW5vD42usJuHNdb
30383	payment	2134	2134	1874	1	1	3004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHnNJTdxbwaLbum1yRMWDCxoDGJs3LuKLBHdbWVzoUFH3mkEh
30384	payment	2133	2133	1874	1	1	2598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtfYKRv5fhZ3FqxaYEP6MuxFVqC7qCrSkDe4BcWf3KoJz9sXN
30392	payment	1397	1397	1678	1	1	12181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sKSb3qmGv4jmrTHb8eenXPi3zHfSiQW3UYtBhRgHt5xZSgvM
30393	payment	2133	2133	1874	1	1	2601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmteqX247tZ88jgETHZEuKwenGKyfD5kt7UiUGfMRBPVZgceX
30394	payment	1397	1397	1678	1	1	12182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwjSWd3SwcTp3YBETHAHkvWN2bw4voWMVS3PvEtwjRV6ifbFV
30395	payment	1397	1397	1678	1	1	12183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFCVFnAa75NjTTGzFx8xYvf1CZupxentCj4syezM37M4BWpzR
30396	payment	1397	1397	1678	1	1	12184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUj7cQoq1gFUQyFF5JMpkVZi8BC7MLwXmbcopzbowzGueCH6F
30397	payment	1397	1397	1678	1	1	12185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhdoRRHkZJPjLJvVp9affz6Q42bpbyh3WCK8hn8SnJomuGhaT
30398	payment	2133	2133	1874	1	1	2602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8GMdbAssBRfm57FwXxsWmtmT4GPy8ukRhTiD1dmqFmRDpyES
30399	payment	2133	2133	1874	1	1	2603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNymJG6iJ5t3HsmXkwXRZ3nd9pnTCm3SDdK322SiXUzAarr5x
30400	payment	2133	2133	1874	1	1	2604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMb6AExDvS3ARqFxvM1zR4hkxXwbTnoB2DVsanMQjC1MkYSJH
30401	payment	2132	2132	1874	1	1	845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZba8RzdzRWHuRXE359MayLfeHr2RmQ3kbfuWyngVfvtzVxebbc
30402	payment	2133	2133	1874	1	1	2605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UQJnWf2m4L4WmBENWu8HxK34GnV8LZtuBbvwUKsdhwkDzebR
30403	payment	2134	2134	1874	1	1	3007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKc2aNYR1YFZ3Ln3RVCob17VtmzqMEkvMz9EnzHWArN4uuegx
30404	payment	2134	2134	1874	1	1	3008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qTsPavHZoeAAwzc7cMgdQkgggW598SXsXeDrFycg8YH1ZxSv
30405	payment	2134	2134	1874	1	1	3009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHSN3vQQMPJWoZUHuM6ywcFTQFrsUV4RGbH24KNwAW8RN2G2U
30406	payment	2134	2134	1874	1	1	3010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KZ2EAMmEJsakR6h4XmYsy4o7Yc6nXQdmzWz43CdYuccUEhje
30410	payment	1397	1397	1678	1	1	12187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfud5ahQvkZy1xJkxQUXUF1XH2aEP1vnbL3idcbN1WM4anwgg1
30411	payment	2134	2134	1874	1	1	3011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypyvmgMRZUJQxMq4LD4u4Haf2qYn1LnDPnQsJsJkgSABSBmof
30412	payment	2133	2133	1874	1	1	2607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqtohuvUSLRA6x2Fn1onb8ofSLVgRi4HSajrQuTAmprqAh1HL
30428	payment	1397	1397	1678	1	1	12193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoxGn57LV6HnP2xqFbPz63JPmzy3qJwTEe7QPMbp9Zo6A392k
30429	payment	2132	2132	1874	1	1	848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhepHAHiLx8CL8kGw5rrPQeBeiBsq9RAotup7XAmFD78Q5njn
30430	payment	2133	2133	1874	1	1	2612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNHXtt5X5XvzrJH4vxvJygYhkFGDCKFdb2fYRkgYn9n9mY46m
30434	payment	1397	1397	1678	1	1	12195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa351VCtqTzxyMbhCmrC9GJ8xuDZWsMjPUtCLeyaxJELumwqPzx
30435	payment	2133	2133	1874	1	1	2614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oMVrZwatDAGYczxWkFXcZeZVL6eto9jN6TJBDLziQ37YcnCx
30436	payment	2134	2134	1874	1	1	3018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92menNf9SyQdCAayvA2fybpeqbJKFyev9dvG5iwsM5VgcQtNq
30447	payment	1656	1656	1343	1	1	4	8295000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPiHkx7rcjUnyDqBYfdevvTpo8XDW2J21TWJfj5AcxE8DQFYr
30448	payment	1397	1397	1678	1	1	12199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UuVz52CSk1hMBMGsutZWGQ4x3w2cwa7aYUHR2HsTDP4px5ng
30449	payment	1397	1397	1678	1	1	12200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9njaoreBNL3mX9hTWrcL1qqv1y3eUjHP1gedkQkJTcz56CaFU
30450	payment	2134	2134	1874	1	1	3022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1QnJgqnG5ne77ULKScCsv1THZWt9bBbJHG7tpwnyRATMonBB
30451	payment	2134	2134	1874	1	1	3023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwpKmBFpgQMsXn6otAfWHBN1eFSKsmnPEw9vFFfEj3qd9vxnA
30452	payment	2132	2132	1874	1	1	850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkpv9AL1hZaM13unbFqTVKYtuKKkDBAuvJX5n6UWiMUbLMLve
30453	payment	2133	2133	1874	1	1	2618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNP8eCQYmWKXCdU1SJsEvJZSXcvnc5Z9BsUnNTRFN4N65SB72
30454	payment	2133	2133	1874	1	1	2619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabyvejguRWtJHifFLiX8iqBGQ4f7dt5443aCgbuodFNgyRUPf
30461	payment	2134	2134	1874	1	1	3024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbbSKVK4E972UF9kGLLAgYEErRPMU47vxiPyreC9Esrojifxn
30462	payment	2133	2133	1874	1	1	2621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrzcMwZPvEvr96g5vvg47cQUtfrgKbDMbFXnN2iAWxPCxeUsW
30463	payment	1397	1397	1678	1	1	12202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDeizYv1LGBfbzf6ikWQY2YJr8CCKhyYqKJckxGxGgPgGeuGH
30464	payment	1397	1397	1678	1	1	12203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb61jaW1AgseioZBkQUuVfSZ2uxumzNJfZ4k5MZcN4KivHPAgx
30465	payment	1397	1397	1678	1	1	12204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmRu5UudTUda7YhpC9zNfkpZXYoEoUj3Cmr56NbtQvH3RnU87
30466	payment	2132	2132	1874	1	1	851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgXNsNu4g3ePxewJ1qfLgjxPyX8kCT8HiVnruAkZJbsaW6mxM
30467	payment	2134	2134	1874	1	1	3025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwjLcVZNGSx4oH5buGD1nGnA9EdibCo9utYJy8fkDSbnbyexg
30468	payment	2134	2134	1874	1	1	3026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvaNpSgezktKXfpGmL8Vxtu9SCZ9rntHuZ7CYxTTuSUmKRqoB
30469	payment	2133	2133	1874	1	1	2622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHitTCzLzeeaJNpXhCjyhxCL3pguHNzrMz6nSnbtBxjoUEZe9v
30470	payment	2133	2133	1874	1	1	2623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFs8YWp9eUaGu5sMttFPH5ggtnPdaBhN8D1refEmNQXHyfEbw
30471	payment	1397	1397	1678	1	1	12205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFV4PfUmL8M6vkLuhVPR6vQCajwpMmiT11i8WzADj54VFsLfr
30472	payment	2133	2133	1874	1	1	2624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBxRv1xSPPfZAP7JrNRPrm8bdUgCmg7mzP7hn9yxVq1RRta8p
30473	payment	2134	2134	1874	1	1	3027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqwVztYHrh4LfhDU55xZH6c7GdHRew15jpdR814JXZsWXtP1u
30496	payment	1397	1397	1678	1	1	12213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxXEUZwS7vFjAwYaMReu9beyvQv7MYGh3UPpK5248dMQj7LMx
30497	payment	1397	1397	1678	1	1	12214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1YP9ufyUhWxFYDakyDJRC2uRtdypV5BN2rrXA29HdKL88xKA
30498	payment	1397	1397	1678	1	1	12215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvK8B3Y5hyuHe6kUyregyXD7X1rFGkRCgHvsGETpiwaGMzL6Mq
30499	payment	2134	2134	1874	1	1	3033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiqj46TJurew4tPVH3oFZXS6tng6CDynsiytTLav9rrUtoa7M
30500	payment	2134	2134	1874	1	1	3034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyLwTXo4gemmnG7wFd3znyNCT9vqBwyQKsBjeLpKbTs936mvo
30501	payment	2132	2132	1874	1	1	854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy52k62xVm1sYSepw3GASva2R4DNoC2aioybx1ptKeQ9n4Dytc
30502	payment	2134	2134	1874	1	1	3035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1t5Y6RX64upktRj9tNB72U214QKUgcarzw6hipi198QpYJWut
30503	payment	2133	2133	1874	1	1	2632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJetUkVHGeLMr993ef4pyKbmi85zFDeyyopAKFPMsxYp7iGaEu
30504	payment	2133	2133	1874	1	1	2633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqq1EYYF38fzvUet43UXkkee7HsUxmKRQvD9Vk8jxkAW7NNdq
30505	payment	2133	2133	1874	1	1	2634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPsh4SSnBvaejcw9RP5kRmyUJpUHFHR6NNKwapCvZBooeqteT
30506	payment	1397	1397	1678	1	1	12216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQftfS64R9ywyXxUn8rZPNo5Kq3iLAVX2PqXgE7GBjqoGU69A
30507	payment	1397	1397	1678	1	1	12217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sWWihH6W1gb9BCen8kmavs4Y9QHnwhgmUqUrfmkRRqjJ24zV
30508	payment	1397	1397	1678	1	1	12218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ADHRve6Kb29bfdRSy4a3rJ7UNDdNmUqNuM64R9SdERRfD6iW
30509	delegation	2258	2258	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXQKzkk9huEFQowGfL1hHn8KMf7KngHajznUSx3QPKZ875qnj
30510	payment	2133	2133	1874	1	1	2635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAi2d6xGRMzpqzK71BJELEgkwpvSMDcr8768zhGDBJFisLUyR
30511	payment	2133	2133	1874	1	1	2636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1NhmFddDVn8CFXvV7KwK564uEBupuNQ6RDBnELR3ZiMRi6Kp
30512	payment	2134	2134	1874	1	1	3036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6UY2mKjMWQCoQWitdgttZkNVG5GdVBLPcZqTtehrVRKk9xdD
30513	payment	2133	2133	1874	1	1	2637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPkGyJoymG9N3LW6e1jFvqen9SGa8wHsFfLYwqXCmhjR7YgK8
30514	payment	2132	2132	1874	1	1	855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4RhhZE5ixTSxgjEtZDp733xcdyHpqA2yc9toQjSgfkYqfsAs
30515	payment	2134	2134	1874	1	1	3037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcYR9nr9mvPEMon6m7Fb4UVcbTMABJh94TNvaPB3w2Kp7hrAy
30526	payment	1397	1397	1678	1	1	12222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6skWK2ZdbbXek4gqMt1kPRBZisbeEsMjqra5R5JoU2aUMf14x
30527	payment	2133	2133	1874	1	1	2641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYun5VXjUqbp2dQGopHkF68iWXi83azNodTCxmerdt3MGKGSers
30528	payment	2134	2134	1874	1	1	3041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6riv2MDLAwhkkaUv4B7ADmhzXCUzXP1WEH43CvigyWo8VYrdy
30484	payment	1397	1397	1678	1	1	12209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDYyNbAZ1ePmLfeZpzihddDKpySsoaXrJBHR4iXoefswoVrb5
30485	payment	2133	2133	1874	1	1	2628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMuHsuA6oppL4Mh4mbs4ejKL3DbMSKa2pKKX7hZnVHojwTMGn
30486	payment	2132	2132	1874	1	1	853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9yzuQZZeysCujtff6vMkPktEpmv8PvwbT9jAvbp4A9Pabzf7
30487	payment	2134	2134	1874	1	1	3030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucwPyBX58nLVcEMfVerCFvP7VkFQGbfF89svmwhnzaP9DsCed
30494	payment	1397	1397	1678	1	1	12212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ9yFi3zwbBAqgi2pYhcSUQGyii6W8QXmYLTQMRnsCu4cs7WV
30495	payment	2133	2133	1874	1	1	2631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmBZeHpNn9ucUkUAVfzyVw3Zy4zkJiybHVndksSRhY99pUo65
30516	payment	1397	1397	1678	1	1	12219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75WLB1xgB3hSTjdMrKMGsHCU2MLWwCP4UF245VZ2C7hxuYmRr
30517	payment	1397	1397	1678	1	1	12220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dqvjE4CRLK5NL4YKY8btYwmb4oruu5SjUMEWCGHxYMvMsH7o
30518	payment	2134	2134	1874	1	1	3038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjBmnr7ojgPrHcz3mCjnr2yaLALoqJBRA17drW4tYCSVE7red
30519	payment	2133	2133	1874	1	1	2638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHcp2M1QVBq8DstegghWHQ9ujGAFTsZbMqAjs6KhgWeopjtan
30520	payment	2133	2133	1874	1	1	2639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYov44JrDs9mU8BYSiAuPgaBzkvStf9v7pGD8e6QBojybnKkTg7
30521	payment	2132	2132	1874	1	1	856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnare6tkNvrNTbrYLJ5gAYJgzuqJmv9Ruj9tsyoHpAuTpxB3e
30522	payment	2134	2134	1874	1	1	3039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwxbbQHmHJQayRBCKBNrTSQsBgebzygGcmJV1eyvUzxj81nki
30490	payment	2133	2133	1874	1	1	2629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG5tc3ukTH9zjtJ8RbL5jJCj4jKK8BMUABb9cFVjtNG7p8uwt
30491	payment	1397	1397	1678	1	1	12211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoApEWr9vCdvCH9wuWDLfamqjLTj31CZ8TRGWnCG2jHE7E5uj
30492	payment	2134	2134	1874	1	1	3032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTrdEEvUYN7aEnxEE4YsTybYeJUKNycMqPeLyVohogYpsdxUV
30493	payment	2133	2133	1874	1	1	2630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbgvFp5Yh5ohq42rM6rNWa8BueTgHvcSGHtCw6JTDMspZKPEU
30543	payment	1688	1688	780	1	1	42	642526519000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYXH26H6oG5dRoTQXtXaATFyBp9bC7dpyDfjuoFNhYDpWKxwvBL
30544	payment	1688	1688	782	1	1	43	5140108190000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZndQx23rg4oJiSQmy8XYutDdzbXwoVSAqQajqkcdipGZ8H9ihw
30545	payment	1397	1397	1678	1	1	12226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXoLhjmQWD8nqmwCtkvp4ixxfYySB2kCV8gzUaLfNmwHseNyw
30546	payment	1688	1688	785	1	1	44	467282970000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1KSjog8GqaDv3BzenFXf86smtwPcZTQLq6JKAs4rXzjKd6gzV
30547	payment	2134	2134	1874	1	1	3045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZf3uK6EvmMBawSUYZcPRpvx3jXzan4cSmfbyNZBydGrpzArV
30548	payment	2133	2133	1874	1	1	2645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4LfVXheq3opxRhsAh8hx7gHwV96SMr8pc1PVkuZJgz3f5gRX
30549	payment	2132	2132	1874	1	1	858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9d7W9k9Ee6uujhsf2UvtKmDwkKxWpjpnzM7STwB1tCRBTKMu
30531	payment	2132	2132	1874	1	1	857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVo75DPq4Dieodae3nF5mSKjZtifsFP3fjD8bUoLjF4yCXHQ4
30532	payment	2134	2134	1874	1	1	3042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTD4okdCdsBHMTJDBp3CuM6A6T3vA5wUNfW5pJgQkYFFLQ6zB
30533	payment	1397	1397	1678	1	1	12224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQEpZ9KtrVRRH6aAYQsn9dDSJ2GBFxJZ5JXd7qt4xdLGwR7yf
30534	payment	1397	1397	1678	1	1	12225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjiT38WUqcT3Z4GxoLuLdf42B2Q2VDB8A6ubpdCBLGMobo9jF
30535	payment	1688	1688	31	1	1	38	2772739792000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGyAh8VRyomoHJgniJwMRN3YsiWahXLDn2nzstGCT28ufkizy8
30536	payment	1688	1688	32	1	1	39	154821582000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZKVy1w4uoNPXeicq248QSgVmNdh6WgjCCdgsN4vuCvT319o3y2
30537	payment	1688	1688	40	1	1	40	138783659000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZmQFqVM1xJEzRQ6MPYmP5qXnR4anRZUMAgWCsouTw36ukgDGb5
30538	payment	1688	1688	779	1	1	41	58411553000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZX3ZqaTf6Emz3Zkrrz6nftYkogMPabUwVWAQJNEFoyDvkXxpve
30539	payment	2134	2134	1874	1	1	3043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSNjzCpBuEEjm8pFPo11v3fyjkKHSjgZR6xZ5vQQ2Nig3M7BU
30540	payment	2133	2133	1874	1	1	2643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9K6JGzCLHGDNaV8FVRhtPqmLpheSe8f9JQfnTwsapwYbJ3mvW
30541	payment	2133	2133	1874	1	1	2644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiqSMRsKTf12hsHVVfP5bcDV51BvTNsu2A7RpFHXJNJEzLewc
30542	payment	2134	2134	1874	1	1	3044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes2vM514hDFuUuexjCgPuRu7twNh6TG61Hyxu7pB7LSquCABX
30550	payment	1688	1688	786	1	1	45	5140108190000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZghoZqdawojk9y7JxM2H2bZo3MQN49jJFiriz1W5mh35vK3bUv
30551	payment	1688	1688	791	1	1	46	116823105000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjgh83r22Proy7d8RV9RCv7xcEiNCbW6f2c3t7XfCgTA9A2bZQ
30552	payment	1688	1688	792	1	1	47	1285053038000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYWxBTsapwM52ubZmWNfQYvc8xRAUe5MaU6TxQtSQU3BUTatwV9
30553	payment	1397	1397	1678	1	1	12227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DLB1hxs6tWeHG5dZapeskCdx7qTKiB7EpEEECRCT3kUtqb8q
30554	payment	2133	2133	1874	1	1	2646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkz7cMJ1Rfoc7wPscjCeEt4y9e1y8Py3KumQ8sFPHhriGLVQr1
30555	payment	2134	2134	1874	1	1	3046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUbuDPQyCahqeuzHxiqD5eZbJTnxJkjp3FgYp2JsuZaicxM67
30556	payment	1688	1688	799	1	1	48	29203159000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYwMsR9Qa5aSdAYR7k2n3cEA1SPwicwLxstA3Ze9BZgpvmofTzN
30557	payment	1688	1688	800	1	1	49	321234475000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZqtKTKT4gX5bJCuDkB7RP6NZvdWSnR9QTeSefc5UpUC61Y8s46
30558	payment	1397	1397	1678	1	1	12228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aM2azqmtCgnN9fgp6SGGLABuk3DtCV4p4jE73XghdB3Swhsx
30559	payment	2134	2134	1874	1	1	3047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGwGQ7LKaSiyUq6nHzgXZUACLqyiMKzEfAt49KKQbDPmjhajY
30560	payment	2133	2133	1874	1	1	2647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGNbJApTQVqngeSkticA4rjxHa7Pn7LGU65Z9fYFEdFe3HC6u
30561	payment	1688	1688	801	1	1	50	29208562000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYxGB1HS9ozNTRrTywSw4T8dkrDrkSVFqroJNXUEvdjLzUegw6k
30562	payment	1688	1688	802	1	1	51	321293907000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYpETB7wPVhfSjRequoTqJ3E8Rpzg5Y5NysqzBHLWSGu6jC6X38
30563	payment	1397	1397	1678	1	1	12229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aAhDsUVdQAK9fTE9bmp4yLz9KCFJgCAihBBsKiE2jw9GEWrf
30564	payment	1688	1688	811	1	1	52	226049323000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaGVRpmUbDPNo4AsGeV79gJ8T4D6qNXUNn1MpTfgxhyUPdSU3zj
30565	payment	2133	2133	1874	1	1	2648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSCYGHDq65aZt5gmQnNYMAdPKBLZacmURKfuo68iYhDkqKMmx
30566	payment	2132	2132	1874	1	1	859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ97P6WAS2v49EGyD6GovUoCpom77pMvwvBDmwfzvdBUXBFrCD
30567	payment	2134	2134	1874	1	1	3048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7jCk118fNnP1ZK8mPbqv8vD2Bt6RZ61v2oh9yP6jGwRkctXL
30568	payment	1688	1688	812	1	1	53	2486540387000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYXTwvVBfMgyU8eVQ78FqwDBJ3PDpcqMkrVjhCTXmnSoYJ4jg3j
30569	payment	1397	1397	1678	1	1	12230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeCrk1YZp1NtWbJL5RAySdL1xTWUi9dAoXrtYUp2a8tKHkZ9d
30570	payment	1688	1688	823	1	1	54	3627304092000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaAJfHYHamtF8VBhRaNWnAWQLiGZqpBLPTwpsrdXiizSwbnVrk8
30571	payment	1688	1688	824	1	1	55	39900310192000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZXfETzBtTLHcMopQqB14d3YXNHgLF7ieHVind2kDHJsmrQEJr8
30572	payment	2134	2134	1874	1	1	3049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58GSUqJZCp3dB6BvLsqYWF6sSV7ACRW2K68my9FztfdCgr3X5
30573	payment	2133	2133	1874	1	1	2649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBKvoFNs8h6NQDp6XEKvLiWLM1qfwD11tXuree2v4wupFW3R2
30574	payment	1698	1698	556	1	1	7	323571171738	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZPCBr7gBeiBXSWmZtfaVWRy3XoJmuQiaYenaVFhwdzbq2V6Tdp
30575	payment	1698	1698	930	1	1	8	2461875537096	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZijk95CiRPzvmomjC4t6V2YnRZ3Eg5rRDoo5PiRrDtzUGaS5Uv
30576	payment	1698	1698	1050	1	1	9	4411659869136	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZSbJaM7FVEVF7YCj389n89AH4FXqQSTS72xg6rd9X7poiiZUcE
30577	payment	1698	1698	1170	1	1	10	2976634822239	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZMoM6BWC5rpikmXaUTZMhxWbLSQWR1LM8EgZfyfLQzLui3UbTC
30578	payment	1698	1698	1296	1	1	11	8294657599764	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	Ckpa6pH8mCBzN7cTC7JzuTh5cWfF1AMMFWDjXJ9RXGhUB7wPbG1ws
30579	payment	1397	1397	1678	1	1	12231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMiCCSvifzTJDaL2pgAsD4eMnzYehrcBMeaZjMs6UYRGExxD5
30580	payment	2133	2133	1874	1	1	2650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttTHMNAseEBaCEGu6yFk55J3qCqAUZd8BjufP3grqHfZV2HSX
30581	payment	2134	2134	1874	1	1	3050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLhM4ES6svq2HWns6FrGHEQUx86KwLshoNiridL5SMhFen6qH
30606	payment	2133	2133	1874	1	1	2653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAppRBK6w64ZMQsyN3csyVDSwTFGZTAcnmvJ375GYjMi3dNMkS
30607	payment	2134	2134	1874	1	1	3053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS85RaGiZbpbdsUxrCSG16wyjNMyCuVBuiKPA2rCg97R7QFj4x
30608	payment	2133	2133	1874	1	1	2654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQ8BjFmvMLehVChTMbuoDG1oE9rsoApkLyeuSqwuUYfAuq5DC
30609	payment	1679	1679	865	1	1	59	716090223000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo7TDX6nPz4M7LSk6ojjcsT7Q645PeeNirQSpiHzGhT2GSmdBw
30610	payment	1679	1679	867	1	1	60	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYrQfxujHM9B1ZRbtC7RBxrDRysnUBgFiq3KP1Jxrx3CXHoWrg5
30611	payment	1679	1679	869	1	1	61	466391177000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYkr8dtmSohBs4ivkq1b9CMni7JJRsU24RrWN4eoXewL1349KLB
30612	payment	2133	2133	1874	1	1	2655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGy94V5fwQhnp5VH8rqrLbyMMy8FtnEtRaoFzjatcDPTSvWFAW
30616	payment	1646	1646	1706	1	1	2	1436000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouXYSxFigU9EoACLGV7Gzt9tezbE9huvqM1eG5XMEYCsNUy6d
30617	payment	1679	1679	881	1	1	63	1049906718000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZu4feriLLnXFgHS6dNWf5pRSb6LFWHKw4SSf1m93SRvTR8sBSR
30618	payment	1679	1679	883	1	1	64	161524110000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEMehnWF3JaeKMRYisYbnB6v6CyykSade6Uzj1UadKkfxUhDA9
30619	payment	1679	1679	887	1	1	65	482083245000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEhoP5G5qTuFMw6XSmi2br2AvgPKwGSor1vEF8fwUvkW9UkHJQ
30620	payment	1679	1679	889	1	1	66	404683045000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZn9tQGdUxQSZHgWpFNttwBPRvgQPF9yicrUQeioU7oGs96HDKH
30621	payment	1679	1679	891	1	1	67	888382607000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYaqDFNXGZfFfPeYEtnAgbW7sVboEZVZbBW7Cn6HnMBJU8gAnLY
30622	payment	1679	1679	897	1	1	68	117188973000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZnpud22m87VhjWCFN3vU8Ty9jZs7SiV9Ymaat4XPYEBJoKYoWr
30623	payment	1397	1397	1678	1	1	12238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa464ULyxvC6HpXNH6PYfreBu4VUwoAV6eGFnEb3cApi4xnuKA3
30624	payment	1397	1397	1678	1	1	12239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvGTFxyJSToRjMKp5DPLec1WL2Mxtbnqp32pTmNRhCQYG61gD
30625	payment	2133	2133	1874	1	1	2657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEHyrgwwhSCp4YngbvACiuB8D55uND9j4sKsjuEHh3aBxuj2N
30626	payment	2133	2133	1874	1	1	2658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ62Xvc6pTSn9pbDw3APoC37Lf7UuFSPVHfAL9aziXaHMWph9J
30627	payment	2132	2132	1874	1	1	862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hjtxws1N2uNmzCFo4ccuWv3LZWnLhkMK97HKBQFnqycgRhNu
30672	payment	1397	1397	1678	1	1	12254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPw3YV6byX7Wm4XCR4WFLCp5nE1D4DFQSo8s5fjsc5UCXEvhV
30673	payment	1706	1706	451	1	1	20	258838378919	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	Ckpa6xds42PhudLWQLD2HktFG1n5gxSdL9cUhJGpN6sdqVJhcXofM
30674	payment	1706	1706	487	1	1	21	258838378919	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZtSatGXwEUP6Ddod6upmkJWGkqdgvxntGp7SxdBTmV78W9MUSp
30675	payment	1706	1706	744	1	1	22	7843587225	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYVdWZj7E4fLrUgV6NQNPvErRK7DLsA5iRg73m11RqdeBEKmdAv
30676	payment	1706	1706	988	1	1	23	1970446865596	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZxGxWYHKUnqTa9z3ksZqBoy6TbSrZgzTD9WuVWiZKWVsKjaJ4K
30677	payment	2133	2133	1874	1	1	2672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MouDwNiR5JSjjUDq435Xk72dVrQLg3aJc7B5e4WWtNbJQGvd
30678	payment	1397	1397	1678	1	1	12255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGq7Qb4WFrTwR87FJ7ygQJnGkj1YwZTTE8yeqQAAKhSeKtwF9
30679	payment	1706	1706	1108	1	1	24	3531023900360	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZsYHdv3QtzEdt4iJQS7Ji3zYmNgLdnSLzM5qXHnJw12ow2yBkk
30680	payment	1706	1706	1228	1	1	25	2382452186180	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpaEqr2bPtzz1xEzNtZe2sx8QbBaHYgqTWKFS1F1X9Vm3mUSHJh7
30681	payment	1706	1706	1354	1	1	26	6638914852680	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYTNBUzsNTAVa6eVWi67m25tJmnACYbor1LoFW6MY93w3vDkYWP
30682	payment	2132	2132	1874	1	1	867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGzzqdMHVgsFB1bsxRGjVtLMqTqs4Zj7MLSAh2LTAU5pdTwLY
30683	payment	2133	2133	1874	1	1	2673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3ZGVM6dTCKAZGx4o34CubSa1EEDUFWetjmuFYjKsraTRS3GL
30684	payment	2133	2133	1874	1	1	2674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyikNJz4pQiqNteGC9wP55mYAUBQpBF5SYVUVCVj5WNhjS46u
30582	payment	1397	1397	1678	1	1	12232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRBqwi9UZM84rWr9R6Nu9aoAFSHwdccZLMTSNwtkPnM4CyhXX
30583	payment	2133	2133	1874	1	1	2651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRD6RKnvLKkmUoTer7HdDfsLG1op5RCgCHjuC19sYqSg9XoSM4
30584	payment	2134	2134	1874	1	1	3051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJSGRB7KDqneA49EgjmyUmGmp444ADAw7ktJfaBSWpyeNHVER
30585	payment	1726	1726	2268	1	1	8274	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiug7Me2KW2saYV7uV3XawuUeNfjqqocARw5g5mPyZjXVpDLNL
30586	payment	2132	2132	1874	1	1	860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRhpuReF8bLPpzBL3bg8fuLbYpVMf1WLyu4izDn5aGEzUbvzg
30587	payment	1397	1397	1678	1	1	12233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxXgX8PSTgaUQ3JsJzJMZhfcC4diMFcxZdkKmtpJRwzJDnkur
30588	payment	1679	1679	1	1	1	50	670905944000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ79XUib15DtQJmNtDM6k9dmPooJuMvwzm8BiAoT5fBAWno4ZmR
30589	payment	1679	1679	841	1	1	51	150172196000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZPr9TdV8kybQWN9vCWwPuDan8AR6m4CfQV15MvZZyKJSdQ8NQp
30590	payment	1679	1679	843	1	1	52	279975125000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZkU8pprLBdMYzG2nk4v8CyLZqwATUknxj9BSUKBw3snmY6bDH
30591	payment	2133	2133	1874	1	1	2652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsAMLDAbZCepuTXJce2WGwStwYyu6YVT7rqmnkyzCKi6qUywd
30592	payment	2134	2134	1874	1	1	3052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt65qpgRR2XMdxtqCuQUcAnvFeUruHwuRxG8frWFo8ACKZ1489
30593	payment	1646	1646	1706	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpRPJqdfWtHq3T7bLaEaXHuGiJmv9rasYmAFswLevyfs9QQxr
30594	payment	1646	1646	1706	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAMBoeVV5DFrPeUcPND2jcLUpTFLP4jkWz4pE75F6tQ6u34Rt
30595	payment	1679	1679	849	1	1	53	2072884136000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYUoX7yQDZmby5e5RZUC6g8N22MMfXMfFwjNNQwLBefjGm6r7Ja
30596	payment	1679	1679	851	1	1	54	4015489386000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnQULWQKBtzY8DJCKXgsood77xaqvk3UZn4XemeRnm2vDPbrK3
30597	payment	1679	1679	853	1	1	55	442772314000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa9QrEssPm314FEXpBfJGr1wtdDezofJ14ErhkmT9xjAy3QhRj8
30598	payment	1397	1397	1678	1	1	12234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXCZCrmg69qM4gdo6X1KSUtCwRMWEgxG9oi7vfUcixKVn1DkY
30599	payment	1397	1397	1678	1	1	12235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKeM3oRWK7y9GtHmtdzWQpYr1LKG6do2eeR7g76ybGLtgo2Vh
30600	payment	1397	1397	1678	1	1	12236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pfbUHtt6JfYXo8UgiA5gUVk4KEVnnoN1b7SpspDXSNBuhq6i
30601	payment	1679	1679	855	1	1	56	234209960000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaDp5kShNXNK1ZAwHTbdNaYjZLd7qF9LbTN8tEP52qaMeKvwnTY
30602	payment	1679	1679	857	1	1	57	590556915000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYSz8S8yWs16cyttUaPNEoTxYZS9GkcoPtnih2Yyv2R8HokinXH
30603	payment	1679	1679	861	1	1	58	815696758000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbEtbYhwprfUxWEJcUtFJoYGQE6x13nxKqsanNr4L8cv7RpcmD
30604	payment	1688	1688	2177	1	1	56	6984200300000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5uVtHU8V8Uae8TUT2z5qxGE2WMdmsE5v6R9Hvokp1GYbsWbuD
30605	payment	2132	2132	1874	1	1	861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2Gkr2tH6meXipntgy2MsaDkmMpRKVBbJNfK2wm79iVSkFJ4z
30613	payment	1679	1679	879	1	1	62	242286166000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYgpjKsEzuDEaLZce1ZcQJQMHTmGDS33ZxemZRFs2TwtKVnGFyF
30614	payment	1397	1397	1678	1	1	12237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEqHLPKRU7urpyo9x4zSU9JBfYiewNEwjhV2qryPJuURPVsY7
30615	payment	2133	2133	1874	1	1	2656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tQQhg36YofRXg6weDK5r1UeU5Wf3UDHp9kJdwm2rwb5cgBBo
30628	payment	1679	1679	899	1	1	69	69855947000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYfvzyzZXuaGfqnHwamw3tfzeVPdDf82TyJFFy1uJP3rW8JRueF
30629	payment	1397	1397	1678	1	1	12240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BBvr7nuVoEa64rQFHvAAaGTMrXoUhT97pDSETYfpGqB3BqP5
30630	payment	1679	1679	901	1	1	70	209981344000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaEpPTC4q5SFu8dukwjpZUmwq3vEGm5CcgxSU4C7aPfzDFJNdfy
30631	payment	1679	1679	905	1	1	71	755125216000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnJtwVzuGyyqnD2ns3Rn7bmmfeEjqsgNrMWFRHeSzxDsN7B118
30632	payment	2133	2133	1874	1	1	2659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZsmj6i5F4D1buuUysHsd6P3qoj1iP2E8KjcRkPtNSMe6jT9W
30633	payment	1679	1679	2177	1	1	72	1260038800000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ42GZoM3qjRD8vxSU633jXb5JdfzTdrqWB2e9pLn8xcpCrN8tX
30634	payment	1397	1397	1678	1	1	12241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ3oDUFGbP2N6ku5iz9Ew79kYgTPTrUZxc9tzXKLzeDtwKfWz
30635	payment	1397	1397	1678	1	1	12242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoGtJRZdizViJuR1Sk9qNVqY7AwZeoavDvSkiUJoqyp5AKXwD
30636	payment	2132	2132	1874	1	1	863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC932W26c6NWZEsUGSjhi46MmL82gnXqQVQ98Dq3p3xS9vyov
30637	payment	2133	2133	1874	1	1	2660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAdzM7enn2LfpBtTTtYrrxG2P9GcFnDWpPrLTeTS5oeEESTLC
30638	payment	2133	2133	1874	1	1	2661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4KcgBxytGDy97fbhVW1M345mAwvKLD7tpFZ2d9vrong7uCnv
30639	payment	1397	1397	1678	1	1	12243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCBwM6htsV4fjAyLPynpm7RX3Bsqzb3fhg8mYKFJSD8m7hyB8
30640	payment	2133	2133	1874	1	1	2662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzXmYM4yWQo7uGTUqCzM1gskVbjAzku8kLyoEgzWRMWVPwojh
30641	payment	1440	1440	1131	1	1	8	4157470000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8s9XSQ31X4wfRLn3n1M9oQSLQHsf5ydM6T9NgRQBU38KHJLw
30642	payment	1397	1397	1678	1	1	12244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YmoQxXN4m8uDuTZ8HDqJLWF2DXTZVzvN33EreCUp44QMcCgE
30643	payment	1397	1397	1678	1	1	12245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVtLwFmtwZYbGzqukEVZ2BfrvSTZpg6GmRprX8QuEASqe4Rae
30644	payment	1397	1397	1678	1	1	12246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtNozPCwB13hxy29psqUX3kSTkpzqNrDZx27hqVdnCXw1SxzX
30645	payment	2133	2133	1874	1	1	2663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJxXbfmsg1PRcJTmAEuwF4qR2S19cpvdHnABoWVGnZksAAJXs
30646	payment	2132	2132	1874	1	1	864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJC9keGF7Gz7QZMnyBYToPNoMXvtXfLwpjXoXvwUtGTkurGCy
30647	payment	2133	2133	1874	1	1	2664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5nsGwuu8aYWHEEgrbFR8hvD9c3daHvfWPxYubJ7EZNSfARfw
30648	payment	2133	2133	1874	1	1	2665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYricGwzpeFxEgT2ksVfr2hRjJ6QGiYqf27Q1PjNmp1sERZ5jtv
30649	payment	1397	1397	1678	1	1	12247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7KjE6D9KF51kntY2DNqcp5Hm2uv8zRrpUW29QtdbBvVawT8b
30650	payment	2133	2133	1874	1	1	2666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5ezdQb8MK8dEJDn9C7DVdZmSb2oP761r8EZ5oYjD7sSTWhqj
30666	payment	596	596	1981	1	1	7	200000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYrYjx2RdZDopo13dpyQ8ggSr6NoWKZXHaAZprqVhpQXM16i5SN
30667	payment	1397	1397	1678	1	1	12252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMYFHT6QiFekNu2FVkyBeB48hmaj7RS1KPN6TLWMZhUjhcUhD
30668	payment	2132	2132	1874	1	1	866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRj6mJ3EbXVHiuM8fwuGMwXCKNS4sTYG32Yk67TL5HKP7qwXe
30669	payment	2133	2133	1874	1	1	2670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRUPYU3jWzamaJDBhP3ynKFKCFUM7DthK625vwC7Lspy3VD2e
30685	payment	1397	1397	1678	1	1	12256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4scuxMC4Ydq6Y9DUHYfwaDYgyyhARLjNHiqDWYcRSbHL3UDB1
30686	payment	1397	1397	1678	1	1	12257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fQRYJ8ZcYsy44TJP7DhyMpokeiwpF3iFYL3tuTC6wWk5xGgr
30687	payment	2133	2133	1874	1	1	2675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8zo4jifoKLChvP2DYGVxtG4GVYitNYArsvV6pPsYvQpAceME
30702	payment	576	576	1355	1	1	4	6878985501703	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYYSxEkQdy4sKMgsWfzPxBZQj2PuBCcCKr4ccg4DUQEkJyaS5Bb
30703	payment	576	576	1109	1	1	5	3658709707202	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpZSy3cwkTCo5G5MGZ2DsD1ytpiEehp1cFn6GKwzf4cD9c6ZopiN
30704	payment	576	576	1229	1	1	6	2468604344390	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYrw1zSFpuGQRvpUmyCghfH1aqQ12KxqLAaa5uhCtMNoK3wmjjo
30705	payment	576	576	989	1	1	7	2041700446703	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpZQVU55vSM8idwnvcXrzL6tUB59F1XbZUAUAbvccsQyTT5JNE6b
30706	payment	576	576	576	1	1	8	0	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYtw5rDrBpq3567hm6zNHZwKgZrrkzh43oVXNdS8cRyCbsrAugR
30707	payment	1397	1397	1678	1	1	12264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwX3JdoLoV2csieoUX7cJwcaFb26hMSPRGWMS8N3kc4NpkcZW
30708	payment	2133	2133	1874	1	1	2682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoUogbYjV8cvESKdTHmPi29iF9kZbv2wPPFeRha117BbtT9oq
30709	payment	1397	1397	1678	1	1	12265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDJ9akzEmVZWfz3n9PssHTYmqV43kCFgwSiSAX3scJqsFndev
30710	payment	2132	2132	1874	1	1	870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZycR3Stc8pWMA4nw5dBdMwXyUojnsKJQM3f1oGJP7yWT2mL7x
30728	payment	1397	1397	1678	1	1	12272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtEGBRiesKYDenADQgM1qFph2uTy4Ufzdp2AeN1UjkgBd4xiK
30729	payment	2133	2133	1874	1	1	2690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4ddrrpR1WQ28mL3U1dgx7N1QGXYLFNJFegvaTiWVF7xMD24p
30741	payment	1397	1397	1678	1	1	12277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfyysAC5UA6UWwpYyQyUNueQS1aAAHMiXvg1WUtUDNXif6PUq
30742	payment	2133	2133	1874	1	1	2695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGKSdpMkA5bcw1NedAz1WQtJWAvtzAMwAqRd1F1sCRyFSyV5
30751	payment	1397	1397	1678	1	1	12280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQBv1pyMvp244cPH6sMjFF3kz2b4vgjvaEkf3x7TFdBZ3UtL9
30752	payment	2133	2133	1874	1	1	2698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcZUteUYHc2HJ7t4zdXwD3hy7f69FaNmDahN3q9rW775oFkhK
30758	payment	1992	1992	596	1	1	4	1244000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZh6y6vxHZccj39LRFv4RLMNVHpswwG6SjQYEkSju7cb8N1iC
30817	payment	1397	1397	1678	1	1	12304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m6nAA8u3TdFcGNhjwkrQvnaZ3TZmTer4eQABTMGsWPp3UyGn
30818	payment	2133	2133	1874	1	1	2722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcvkJpSvcTCXwBdUckNYwaGwEPn8bkA4JAmgBj9zcFVbFhKCj
30826	payment	1397	1397	1678	1	1	12308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYV2iJbMk3wFE8rdCsr7zc8zSq2HXcNLmHfd5ygCLHAJZBrb6P
30651	payment	1440	1440	1251	1	1	9	2805000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj4uocWTB91e4aJw6MyESQoPVapvQKBBfLzYdzKakXShQ51oc
30652	payment	596	596	1981	1	1	5	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjxejT6rvTaD27swzkBDSUBqf3KqzeiXC4MD5uNsPYja8LyXC
30653	payment	1397	1397	1678	1	1	12248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXiy1GXQx4hBuspAKPPGtXNUQc8SMqTmCJqcp8ysNEAB73qUg
30654	payment	1688	1688	2177	1	1	56	6984200300100	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1ZfhfDdXKmCsQt2dF73Ru8DYFHBVWdSNihVUtjHGpiVgjKGen
30655	payment	2132	2132	1874	1	1	865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyWH4GMWJkbVu493aHqb4GzRJncJeZaDxD6E1tdcFfw4cjcNo
30656	payment	2133	2133	1874	1	1	2667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yCWAqwKzDiUDeLHdoc2EkF242w2kgYAgy9gWFdJk2GFH5Twn
30657	payment	1397	1397	1678	1	1	12249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFhnrZ9VV5xoUekmjkf53xoHdkGQAzrcpCj2uFJywyVGnZ3ff
30658	payment	2133	2133	1874	1	1	2668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAdYFnG9JVPZbSDWeGtETmfhgRXuR9bQTbSmVwEnej92NZ23V
30670	payment	1397	1397	1678	1	1	12253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhi1Pmv8txzXcFGfdSGFVT66tZA7CorXqSgab2g37LZpq6HT4Z
30671	payment	2133	2133	1874	1	1	2671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwhGoc63x3Ep4RAJ4P1xTcLGHv73XYApY2SQo4YwUCFiBAMqF
30711	payment	2133	2133	1874	1	1	2683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu18iAZUuogKngw58Yq3uQi1w9KYQQd94Mv7GjLs2jGK6xpTd
30732	payment	1397	1397	1678	1	1	12274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd5kvKSC7AsWFB3v7qsiCv5L8E6zrAnJvhyAUaCL4SrXQ43u6
30733	payment	2133	2133	1874	1	1	2692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB25xwPxeQet3Lu3QrJmAuaCZoWdiCE9CMRH6PQbTyWBRMzonN
30734	payment	1397	1397	1678	1	1	12275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd1JbMuGEpZavBsm9pG18stFPvzQ5CtG1a7iBqryieyUtE1yd
30735	payment	2133	2133	1874	1	1	2693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfy5PFqQPPS1HpxT9EW94fqsZUY4abs9ZknEbaLKQZjVD7v68z
30736	payment	2132	2132	1874	1	1	873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaA293mJnqKxMcHXapN3tyiMMam5cJpGBpeoH5QigL3mSSrYm
30737	payment	1992	1992	940	1	1	0	2371000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYvBfMTQQRSBrPTEb6nScUgQRDZ2DXLaUjF1ubqVgNZDsTZGA3r
30738	payment	1397	1397	1678	1	1	12276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTimNQT95ojttfV3dQQWPnZqHMFF5W9nCvJkfGNMr2QVHsEixB
30739	delegation	2268	2268	2268	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwMLNtz3xH3fo7QPwW1pnBS3iSZhopnueo8FB926j5GP5hAc9
30753	payment	1397	1397	1678	1	1	12281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5syDSju8zZMgnnGUf7S7n86hGzpMiKDrEqTLicMt4ySsiLvp
30801	payment	1397	1397	1678	1	1	12298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcQtHRybcdDgHB8manF3t8RiqYzSoCXDhP1XhVkhRKTWnq8mw
30802	payment	2133	2133	1874	1	1	2716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSedUfKBucFMLuVCksJWHX2WEvV31RiVgHemkp9CJ21Xwtsuv
30803	payment	2132	2132	1874	1	1	880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxKnvNoFpRHp47tdkK7eTuUEURY45Q1npbas8bBxSqfximfUJ
30819	payment	1397	1397	1678	1	1	12305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP6f6A8Psi5oEUTwF18QzUHnCquW2VQ8LQpWEXtrChXfQgAJP
30820	payment	2132	2132	1874	1	1	882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3aSDsuZcTqYX3EUCpZhkSh9LcJvzvA76Apnr6a2qmCUGXAPK
30821	payment	2133	2133	1874	1	1	2723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCw3bs94yXp85XLTbgxxgVjS9iY2EEJ3mFExUnKZi5swDkcEV
30856	payment	1397	1397	1678	1	1	12321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA9X9LejN7gmiDLHm3UV3VR7GbU91ra6o2UKesmLnjmZF2Vmv
30857	payment	2133	2133	1874	1	1	2738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbK6XBqFriE9zyyX3XyAWJrukf7eqTBGoLudR9ZstkL3jigjaJ
30865	payment	1397	1397	1678	1	1	12325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3PdGcwWrTKHk7w19yAkzE68AMNo7tegS6f7t4yAckZGKNHPr
30866	payment	1397	1397	1678	1	1	12326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7JrbxKWsY31DbpVTY1afG68GYCMn4Cif8uzgkL9GLykPSVqY
30867	payment	2133	2133	1874	1	1	2742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrb94wgnu2y3tx8cMb5yY2FmSC87RDrvnAFoTJvSYS6NANF5o
30868	payment	2132	2132	1874	1	1	888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoYEz66u1pr3Un396K4WCw13fpcUnWL2CFfiCL3QZYhJnWJsQY
30869	payment	2133	2133	1874	1	1	2743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLG38HufGYKVtfHLVfPPcUuwDZhit6GKKtkgdWqfNbd8Dm6r8L
30886	payment	1397	1397	1678	1	1	12334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZJqfwwHGwiLfKectUqMbcj6o49SxSvCF4epCUfirT4sTkQQH
30887	payment	2133	2133	1874	1	1	2751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXhHtL8k9Jnm1WqS4DX91UEEezyg6zrgi9dcwNq8TpNbLoPbE
30892	payment	1397	1397	1678	1	1	12336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUKXVZBztdH8bGFSwdTt1HctiJKMP6E3eDjZAsgGUrnENMhzy
30893	payment	1397	1397	1678	1	1	12337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8FSXUB26dW5uoKjScRjfdqPzmK9mxm6R64g4X1u3QFt8e6tT
30894	payment	242	242	2269	1	1	1	647000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbmBtfSQPrqVoaFLgQnmc1ThxxiwwEpe3rzScH6G1kxGE4EXV
30659	payment	1440	1440	1011	1	1	10	2320000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6GUZVi4ksaZanowrf1RXkqaaFFYp92apSw2HKydsKkSfjhS6
30660	payment	1679	1679	873	1	1	73	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZkWNYtdPMEc7ZXaRYdPHG6bJPkuZgz6Upf5HZPe9QkxHYjEKc
30661	payment	1397	1397	1678	1	1	12250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgBY8mvPFw1DMr8ZkxFQn7JtBtR6WF8aHhS84SUYQoJuLC9Dg
30662	payment	596	596	1981	1	1	6	100000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpaHvzhgeTzzV7pjdizhbK8YY8cKiF1D8uSbCXa8xJYrP6YyKBAq
30663	payment	1397	1397	1678	1	1	12251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eDmcgskGwpyChDqkidx5821Bsr7Sa3RWPM5VGLg3dC8rYbDe
30664	payment	1679	1679	875	1	1	74	382273728000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGQ7JWSt6DboHtiCWWg7YfFnYbxnotnEGvNenxxMhRnESTXQcP
30665	payment	2133	2133	1874	1	1	2669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNypfdcZQCDRskzmEHcNya1DdbcmTV5CMXVdEf761kmVQiFMmE
30721	payment	1679	1679	873	1	1	62	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsPpo2XXQVf7ySAFVALdAcuYCXWWh9jzUncrzRRMFeyyUuq7ku
30722	payment	1679	1679	875	1	1	63	382273728000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZxDfYbjpmXXZoRsMshk8UN4AT4QnFkKyueL5qJEWdMFpEoFgXp
30723	payment	1397	1397	1678	1	1	12270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2gjQ6ZKHF3RMCpD52ngDBn7vh4q6nV6vZ9HuEbDH38Bc8ZMA
30724	payment	2133	2133	1874	1	1	2688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLaSKBUEYYGSFMo75deqXtY2Zjz9YRf4rqLqMKW3t8sSTFfjv
30725	payment	1397	1397	1678	1	1	12271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkoqoRpFFQfrGfpxiff6w9H43GJiLdvoYZrGHMsvqxJC5bt4v
30726	payment	2133	2133	1874	1	1	2689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadTUYQE4U5PLG1CGsp5xkjopXuqAWe9MDKwsxpyrqzm56jtuk
30743	payment	1397	1397	1678	1	1	12278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9g7Ha793h6G11cvyqpcjQHbaEHQKmi6nP1fSa7Mi2P5Bnshj
30744	payment	1992	1992	1060	1	1	1	4249000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYpaqW3htza48LmRHDFt2KfMTzcwfd7N3DDgXfCGjk3WgpzW5r4
30745	payment	1992	1992	1180	1	1	2	2867000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpZQYW743JdkR997wNJxy4zG7hVnpps52ndyVZeey2pLVJt2zUUZ
30746	payment	2133	2133	1874	1	1	2696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoaMFtWJQ4eDSKEjiKQpsFPUVAV8qjNZHGxHWDzrhgUHbBxZP
30747	payment	2132	2132	1874	1	1	874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtQrC7toNz5NbcXWg6CNXpUnQP9ydfn6SUY5aGCeXZQBn5Y8Y
30755	payment	1397	1397	1678	1	1	12282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8G4LEoCBNQaQUvsJn5wNARy2njTku3gGa6mhrs214QuoN55ry
30756	payment	2132	2132	1874	1	1	875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QzSpGodvEuy2gyaJbehwMGQSxLgsnur7cCVsRHpfiNCZhUTM
30757	payment	2133	2133	1874	1	1	2700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebLJXxiQe8uJZ8xs45xJDZX2EbGsTg5tmZiLah8tKLBzDVg4y
30763	payment	1397	1397	1678	1	1	12285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjSAsDcc3LVJ61PGCcd5V755c4LnRYtgoFi1wcbUjTrt2Z4XX
30764	payment	2132	2132	1874	1	1	876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCALMoKVLe99nTW3C3QK8ux9KW45xPihxpkxdSgTaPSNr1dycW
30765	payment	2133	2133	1874	1	1	2703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyN3MjKuBX4vshibuf41JoBeieuVhLGVL44jbB4euVkYpSxCN
30784	payment	1397	1397	1678	1	1	12293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYxp8LhVeLP3UZYPStKkY5NhjFDnUoJTXBgf81uWh4nVocdzT
30785	payment	2133	2133	1874	1	1	2711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppbbF4jyyCW6fE3yFZDmTZkwLeLJesRsB7VctVKyXnjAmfHhj
30786	payment	1705	1705	1234	1	1	22	2138396100000	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpZxHvXHT5DjyxGdTW2bq86ataKy59AdNUg5dAtR62rqgi8ULZWX
30787	payment	1705	1705	1360	1	1	23	5	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpZGp7MLum2AgTTQXELGYrA3MQEiTE5fDKX8hoH8WryaLPG7Pq8o
30788	payment	1397	1397	1678	1	1	12294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyF6PUvjRYKi3Z1suCoN1PB8a3qihoZmWeeC44agLjajDNd9Z
30789	payment	1397	1397	1678	1	1	12295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgJ8ePc563J6qHf7Y7PoxSwZZMmMKq2GyT8pSSrjfqtdFVE6y
30790	payment	1397	1397	1678	1	1	12296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErBmfxKzgXTMsivSF9yFBsoyyNu6ribHLt8MBrYiYhzZd1YRu
30791	payment	1397	1397	1678	1	1	12297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpnqCbGnnG8damJJAcMrtsyQpjJDNn6PF9MAgL3cCULdQJPrN
30792	payment	2132	2132	1874	1	1	879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2fMR4XDhuKtVG42xMgvw1gcUQZsoDGzd1SLfzgfyFqbte7Jm
30793	payment	1444	1444	1381	1	1	8	8294657600000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZNTiSL6LX8TxJ5oZHv7oCFXatTDk5xzdDEnWQeWjasBDMHJDBP
30794	payment	1444	1444	1135	1	1	9	4411659870000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZ8WNfYNBPxRHdgasHkDDBLaXirLuuSZ1S7r3ceMuQ39e4cXowe
30795	payment	1444	1444	1255	1	1	10	2976634820000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZef7fnM4aMGFvsCVvZcxyXbuaMXWSU8jGEq9HXmjspD6wJQVFi
30796	payment	1444	1444	1015	1	1	11	2461875540000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZkeoTVsGPWK4sm5ttQHDwnkTV3Kjp24U5879CNeUwgXAQPLuQS
30797	payment	2133	2133	1874	1	1	2712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpKZm1jb5A4H5gEGUBaNVhYh2WQDrr4XCCdyH634ksHk3qV5P
30688	payment	1397	1397	1678	1	1	12258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnMZpQ9gAbYcBR4SZStvJKg5eV9GYTtD1kQ1XWWv7UDPcbkJT
30689	payment	2133	2133	1874	1	1	2676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJJcFJCFSmg1bN51JdNQJQJGEf6km31zD7bi83PdUNnLNwzJK
30690	payment	2132	2132	1874	1	1	868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuibFfxitejx9TkCvPq8jTuDEjjNmSPmU9GpefYtgjoJQP1d2i
30691	payment	1397	1397	1678	1	1	12259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUDRSSFdPtke7m5LM45shvqaF2m6rVbDwSK22pwhersJA2kMS
30692	payment	2133	2133	1874	1	1	2677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxTk43gQYzRAgiRwousdyrMAo3i86bTmomfh2xYBuNWjsXTTb
30693	payment	1397	1397	1678	1	1	12260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnC39chWzo6TC4A4uuFTDTPrfQHwGgmGEe6AXVvS2V2UXuBEc
30694	payment	1397	1397	1678	1	1	12261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHt8VBGvmZU31FnhLkjdK87x118GPTVdk6SpzBbURwcf8mXjg
30695	payment	1397	1397	1678	1	1	12262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Km8hr8JUCgXyQA5fZVUJygk9r8Z8L4Y6cX9DG1BUQQjeCfdC
30696	payment	2133	2133	1874	1	1	2678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1EU2x8F6ZQYcsNDcnCvKHDWEYUhuM3HrVL7bSBxBfopguBjR
30697	payment	2133	2133	1874	1	1	2679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzJ3YS8K4i4GNrDkdYuRZNM6TKjZGsC4vzMLdixUpohRpNprx
30698	payment	2132	2132	1874	1	1	869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEB9GjioWfbYe6EVKnfWcSrMmvhxUoGhP6cyYiWNXbyKUKvEq
30699	payment	2133	2133	1874	1	1	2680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAE7RkuZZevPoeKTNZyv88FJXj5BF2gkTDf5QAYWdgzM174Tx
30700	payment	1397	1397	1678	1	1	12263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsddrHQbFzqgxmQuP3GwEeFVnf4jgMsVv3oH6KwQmGGeXYZr6Q
30701	payment	2133	2133	1874	1	1	2681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf3cvQQjp2kgp1jYoG9zCSJ5r4gSxgYRbPsp7CZ1vATFSNEKn
30712	payment	1397	1397	1678	1	1	12266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3F9kRFm7jG9ozoRUTqtY5cchjqbFnAnshRjkw5XADXjJRYGSa
30713	payment	2133	2133	1874	1	1	2684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5VqLaAktvZfvkPmQnBfuDvmVRzRSaZkn3cGfkuzFkpYBTgY3
30714	payment	1397	1397	1678	1	1	12267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpcmMkUPmd9i1Y8e2cDZy6WeRes7t1EgDDeUofH1kuTVcMnZs
30715	payment	2133	2133	1874	1	1	2685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZmrBtmcxgKMe31mA2fGjqwKwrWUFqUR7yjybjtWwdePHoChW
30716	payment	1397	1397	1678	1	1	12268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikxJpr2rSAjRYNwr3XZ3LPzxnwE6gGNTMDeRTk2ZNK4N7Zief
30717	payment	2132	2132	1874	1	1	871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHNuFhnikM5kqEapNzCzLMq5etQ5tJqP9GV21ZhhDbNU5qiX3
30718	payment	2133	2133	1874	1	1	2686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44MxGBM9rYGLY67aUUCJULtpxAuQVGx36Jvc9ANtXBkFcdibs
30719	payment	1397	1397	1678	1	1	12269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qZvXb9eJgiYPoh3mNweufx3iepn1o8r5CRDuSUvCBdnS2yxA
30720	payment	2133	2133	1874	1	1	2687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejC2tmp5NjmHtqxPGgkjmfNabT6fAwb8cSUhKXG3yhqLxxUM1
30727	payment	2132	2132	1874	1	1	872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1rdmC7RyLna5LwTnX3SSiZvj5cEuV1BRRAz4Q2EMotQSmLro
30730	payment	1397	1397	1678	1	1	12273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7ZfRkY55AWd9pEddyi4Aur47FH4XcSdnSBih6HQgysCjLb1R
30731	payment	2133	2133	1874	1	1	2691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVKefYXeazFJtXTwKL13gWw3U1B49Jumfmtch3Xc9Gscb1biN
30740	payment	2133	2133	1874	1	1	2694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckbWeDBfWewxjRYWG7GsMYQFAP3pLACEheQCmqVnoyb1pzHEj
30748	payment	1992	1992	1306	1	1	3	7988000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYpeKaoDYhhoBu1ZNowd7XdJCWmdGLyNXUzFjsTfxdq69LiWvvk
30749	payment	1397	1397	1678	1	1	12279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2ephzztmQtCKyjU4UNw3cQFvBgUs8WVU2FyJwTbWhppwJFkp
30750	payment	2133	2133	1874	1	1	2697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1Lrg2x6iuHe4NJbqY6NGsCXmWRiqP1FB7vinrpiNaHcdjXgz
30754	payment	2133	2133	1874	1	1	2699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKmrjpsdJA4eFs47jgqFMvQT5bzrhCKtWM7KKkgkdcs8K8jqF
30759	payment	1397	1397	1678	1	1	12283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktoC9mYYpMVy8xSiYhsmWw41W1Q5GAkEb6rerPiyKj9fXfTWk
30760	payment	1397	1397	1678	1	1	12284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiwJemekqSqn5iKWWtunEen256SwWAWiK4ahryHBJ4qSkyU6A
30761	payment	2133	2133	1874	1	1	2701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrqRK82hzXGqgdVHXohzKPU3b8QDfn8ZhQ1SXTrrLXgRgVA9D
30762	payment	2133	2133	1874	1	1	2702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zs4JY3C9vBFAQ4RnJ6EnNm1DfqQpSUb47qSHaqfz6KwgLdbA
30766	payment	1397	1397	1678	1	1	12286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm35Ky4Zp2oVNVC1ptfcic17ByuEGeKsh8f9TNuzTngdo5pCmz
30767	payment	1397	1397	1678	1	1	12287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKLANtKvqddic8FVTWThfdCcEdNihqPMafukt8AHvzEwcRJKW
30768	payment	2133	2133	1874	1	1	2704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvtHvqKpRXnVfQ94rm1BBmH2FWVjDugqEeRksPbU3pfYydsGL
30769	payment	2133	2133	1874	1	1	2705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSF3MToqHMujoLhHaEzHxkHvFqUEHAi97XczgicT7UiDHqR62
30770	payment	1705	1705	994	1	1	20	1768615010000	20000000	\N	E4ZADNPtAsHbh7QT321ZjPMfenp9LDc6Rqv5F7zCT2vQGcFpAJfaX	CkpYYitpzmKJQ2UYmr2jk8VL2Vr5j8fcsS4u2D8wtNiKfQpgRQcqd
30771	payment	1397	1397	1678	1	1	12288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKHDKbgFBTShFMde7bD2s1QwpGLA2NBk7QGEYwbxAEu1p1w8h
30772	payment	1397	1397	1678	1	1	12289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYf8mPGxmo7s69WyknZ5Pg1XgqdGJFdvVRQC5KYpvtbVQrEznb
30773	payment	1397	1397	1678	1	1	12290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGxCTx89t3mpqFcJZ3S9oVm9HPnE4vv2a6JHEUaBoWWcudgUQ
30774	payment	1397	1397	1678	1	1	12291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqY1G2vCmLXGwUhy23Kb2KrMXYEHcbnDa1otsRjBhu9KxggEF
30775	payment	2132	2132	1874	1	1	877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhynPbhBzwnvYxJTjiaz7z92FwKLLpGx93GmeKjATjJ9XgmbRB
30776	payment	2133	2133	1874	1	1	2706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpo2AbChXieEZPtrJJUmqXA4t8ADyHBrtYZH2QYFDu4Z4gyWnh
30777	payment	2133	2133	1874	1	1	2707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoMJc1iUS8yAH2rzvzH7sXf15FL8GqgKJbsFMo9k1s9u6Pgi4
30778	payment	2133	2133	1874	1	1	2708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfdffThAcVUj89nwkzU28cyofGnxMkvZehp1QWK5Bw35gC9fq
30779	payment	2133	2133	1874	1	1	2709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86ZQsEbAgLnuea8wkptM3ePbQPgz4HASaLNeK8UzdG1tATPRv
30780	payment	1705	1705	1114	1	1	21	3169295350000	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpYw4Jx11rmXTGeo3TRpzzptMdpcm8H24MBJnoSPpTtaV8sLGDX4
30781	payment	1397	1397	1678	1	1	12292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm4Pv3d4sANTF58L6AqmtqYYyyiEjhCW7gBAZyFfQFt6Wm32n
30782	payment	2132	2132	1874	1	1	878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNxrguX9UiSeTsDTqEXoku1Rdasis6xzGupWNrKA18zG3E7xZ
30783	payment	2133	2133	1874	1	1	2710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssG5gH4NxzavvPAzNpRvmcV8kogPQWHaLmmcWvCBV7j6cRMcv
30804	payment	1397	1397	1678	1	1	12299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4e3i2v3UfeSKFktvnMKyCw8t7nvrLv6F1XGoCZps43vZvU3R
30805	delegation	1932	1932	1932	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmrqzJz3sUggrjoE2nghHLovUFpAdVgKSUyqvsjJBFuVsiztp
30806	payment	2133	2133	1874	1	1	2717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5rvAioJDiYisTPiN1h6yu2ZQnYhYLqrHQL3ZrZLqP5mgynMP
30812	payment	1397	1397	1678	1	1	12302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHisFnt8U7po48hkfQ8pkX2U8zbiioemn2HEeQMrVyTx1DzNeg
30813	payment	1397	1397	1678	1	1	12303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkMb9rKhSkpNmgqRtCfsr4nnx7ZBAUY9UyrgZCfroZ8ds7Vbc
30814	payment	2133	2133	1874	1	1	2720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcybbh5AwFaSMKsebBAkRXaNFPCUN3Hxp18auSVb1X1S7X4EK
30815	payment	2133	2133	1874	1	1	2721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoVZUAoFes7zeWQviMKHrLjezPUcforpyTXf1ZwJizbQob6Ft
30816	payment	2132	2132	1874	1	1	881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFdKSKmQ44oCTum8w4UdHEkYdDzrs7JBz66Ab7JHe9Zz3KgD8
30822	payment	1397	1397	1678	1	1	12306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKy2k2tQ93A9nwBMdKvtaEPL5pfpgABX5WXyDs6xVByGBtweoE
30823	payment	1397	1397	1678	1	1	12307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAbH3i3ojAM4v9RJfnrhyfXGzt59L15NKoxKonFeY8mTWpyUP
30824	payment	2133	2133	1874	1	1	2724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEsRrdyRPWtpxv8piFUuMjM18Anszm5Zu3SifGgd865wtgNiu
30825	payment	2133	2133	1874	1	1	2725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmdWy15EY2bnWEgg852k7B7X2YZWUwh4YpcXB5CkYXfwEakd7
30835	payment	1397	1397	1678	1	1	12312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpcw5CwSZdMYxJUkmUSNn2ppzma99BkugUCKnZ8mEvhhCw7j8
30836	payment	2133	2133	1874	1	1	2730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNe9iYC4rx2PMABEcKJ8EAyh4kBUkT6iiEEiYyr2r6yz7eugoz
30837	payment	2132	2132	1874	1	1	884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeoCcorVcj2ydjGhwNFsFo3cDiGjTt9ZaCQ1fybdvUh9mrAvW
30861	payment	1397	1397	1678	1	1	12323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7tXvvM4Bgysrg6mUvPUKKG48ruMSCTMtW8dFEtax96KG2sfP
30862	payment	2133	2133	1874	1	1	2740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuzZfB1iPSQBBgc5wasAKPEsBAdL3g2ZoUdJP71YJGdSTmyKp
30870	payment	1397	1397	1678	1	1	12327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfU1Y2tpHN3Yvdf87UhhHy7hug2qtX3hjqh9kwHubjC199aWo
30871	payment	2133	2133	1874	1	1	2744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbehc4a17SAnUbcic7gvxd8L97XUMzs2uK2WGLxtyZkYXoUhJ
30903	payment	1397	1397	1678	1	1	12340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynsFeJTTL1oACpuQkZawhH6Eq4jiKANqg85xWiBT2hVpsxb9o
30904	payment	2133	2133	1874	1	1	2757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRp1H1bPYhLafzQdh5cyrUQXtLGEzEBMA79hJ5yLyydBxom2q
30916	payment	1397	1397	1678	1	1	12344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUc2rg5LYfAK8sbSDbQQkymp5nHA7EiiMSZUVfjji56a4D2hnF
30917	payment	2133	2133	1874	1	1	2761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq5vtyNg8mgUymhPAst6MhRQdNT2RMUWYegbNGKGJM7zqCae4
30798	payment	2133	2133	1874	1	1	2713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEEjQaCqzAtL4HeRFrVRDESXqpH79R6DZJZGEHMw8FMuG64g6a
30799	payment	2133	2133	1874	1	1	2714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxb68jSi9esEVT9sNFR2ugTd8kjBU6PE6JDpJdzHoqu1krgL7
30800	payment	2133	2133	1874	1	1	2715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAKyRFgTgWYQu4pJqA66MJhnkyhzRqjtpUW24KjQg6rcGDWWF
30807	payment	1705	1705	1360	1	1	24	5958825460000	20000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpaCUUGimtxtA13LiAdSmvWCnbbiNT6VijRS1XmHCachA9h3ZxhG
30808	payment	1397	1397	1678	1	1	12300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTv7xCSaD6utJSdMFxHewcWoeenJvhHmbbdndRDzWZW1tRaef
30809	payment	1397	1397	1678	1	1	12301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieJYGUdb4BnobwacEmFZ6VhWkRMHCLuAEfBz2ZurKuvTrPF9Y
30810	payment	2133	2133	1874	1	1	2718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGndBxoByBfgZ1eSgDLhWwjgstqJdi8eNm6UqTW4PreeXeSS3
30811	payment	2133	2133	1874	1	1	2719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3yjkWxfhmnAbQLvT3TZZds9k647K7gGrXmdUsD8CYTj5542w
30828	payment	1397	1397	1678	1	1	12309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ55y3WL3vx6ipg3WJBLQYdHGTq4Fo5DbvAPYjecanquUAjYyz
30829	payment	2132	2132	1874	1	1	883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRW7hLrTzppDPP57M4k3apb3TvS3MRhBoR4fwpdmzKSMXrZyP
30830	payment	2133	2133	1874	1	1	2727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1bV367yXs3ZABPsFbPY9AeB1qp9GM1NLFLQ9juhKAmpmDnnR
30838	payment	1397	1397	1678	1	1	12313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjHZSPpvtkiKvhZF9TprtaU7A1axEdDtWARE9jKSuKG2Sg7KK
30839	payment	2133	2133	1874	1	1	2731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aLfxmPjUXJx1Nsy779owGB82azct6QVFUWzqvp14i2cMWfdy
30840	payment	1397	1397	1678	1	1	12314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vpWT8xjZApkJmqybUkYQVzouCSN4tQSG1rWQ3GNTgDFNZPjn
30847	payment	1397	1397	1678	1	1	12317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dby742hCUR3vm8hf27r9haRJ2rqoU2Xhw8MYepKb2Z1KDxek
30848	payment	2133	2133	1874	1	1	2734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8AXtGrm7SKf8GLQF2tfqf9nnKhaGH3qBAsqtYZtbBJnP4zUJ
30849	payment	1397	1397	1678	1	1	12318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56rUeGPdV7d3DXA8LaAcguv4wpZr3YBd5SZxemRxEob1wWYiE
30850	payment	2133	2133	1874	1	1	2735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPQEFLk4cgPZv7o6uRtsque1syhxyRtB5u8hKgGmy8SMRduQH
30858	payment	1397	1397	1678	1	1	12322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LVNNVhCWANsezhR5eMXYigpE1QWqzdiPeFiqYeSJP33uG5Kg
30859	payment	2133	2133	1874	1	1	2739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PUTQSGYrdyNPG4QSM4NhqiCspFDyA6qt1pXUQaqmWnLD837U
30860	payment	2132	2132	1874	1	1	887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFEG6APccgCyDoMfP144bAnght1iQ5127ACJbQBjAgVyAdWxy
30872	payment	1397	1397	1678	1	1	12328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgooAdn89s7Mp2jKcEFXh6xGcREdh2aP7rXzjD8fm3X92dDms9
30873	payment	1397	1397	1678	1	1	12329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcrKwZw1LvReEBvoVkbucPn1aJdBjBUhQTwof8meTR5ZBUYQb
30874	payment	1397	1397	1678	1	1	12330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZacQgtChABFqtYpYwW4z8ZK9kkKy1ZKsSy7M6xE5akDo8D3zK1
30875	payment	2133	2133	1874	1	1	2745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsQVudPDoE2Uu5t9NpLTz2a4BR2dSJbf4GhSw6xJckEkgsbAz
30876	payment	2132	2132	1874	1	1	889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYEJ12GvZr5W44QaNR77mEMgSnFSmoUuL7oUatFBRpxKEzUGE
30877	payment	2133	2133	1874	1	1	2746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpeGZpkYWxL885VnZNKVLZkTwx2n4uBP4nFM7jEzZBJJ7zKFV
30878	payment	2133	2133	1874	1	1	2747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpt4bQEiizcWQeJtxRp4XYRec5DZkVA94gkpmhBcvMVGKY6W7
30879	payment	1397	1397	1678	1	1	12331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHcnxxphek3JzosHxVLnrA8etxnNstVxZZC229mUQJxbpteHr
30880	payment	1397	1397	1678	1	1	12332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFAWSmKW5dZhJaCkXsDnBksou794vsTwWGTSoH9P5ozCzYjDt
30881	payment	1397	1397	1678	1	1	12333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqo8RBnYDa4HAoYH2yZtMrbg2Pxy1uHYKCUp5VpKirVHSWu1SD
30882	payment	2133	2133	1874	1	1	2748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TGwz4XuQQ5faZnGpQqMHohhS4w81MoWMjvJJRhnr3BK3ncLU
30883	payment	2132	2132	1874	1	1	890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4P6CDhajbQBFJvLoPMaWySU9B1LrmzFtLJPEFFCrZ5VGCa7vy
30884	payment	2133	2133	1874	1	1	2749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zrwvfWD43QfcZWQSWxWh2UTpZPrNUnknbcsbM42FTJ2qWv8s
30885	payment	2133	2133	1874	1	1	2750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMktBJkF65trSosGAG1GTsCSxTJNMkGb173ezyABaEuhhSQj61
30908	payment	2039	2039	1164	1	1	3	3087600000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpYx7xKYYDm6WUBxPdWGb2UfhmTgYAvumxTEtKX2jNEvteLQwtSx
30909	payment	2039	2039	1044	1	1	4	4575900000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpZ2JsgPGVUW1Gj47FESnFFjERadUzaaQYobb15F6Uzm3c78an6f
30910	payment	1397	1397	1678	1	1	12342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwtfpCpjbfSSYMRkUBT17XrZfukqhoZKFEGKTtvgbUeoDhugP
30827	payment	2133	2133	1874	1	1	2726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBNPiZhYGFcr3qV3kEsmDMPX4QzfmH9BTdm4rMNB5z3Zdxvy6
30831	payment	1397	1397	1678	1	1	12310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaa4bxBAHswifEsDaeeoxZu1pyBKNrtbBroaVQppDbszsodbo
30832	payment	1397	1397	1678	1	1	12311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz6KA8TEmJvNnepDg9LDrMPrRX26RqPCD27fmxY2YSAF3dUK5
30833	payment	2133	2133	1874	1	1	2728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCemCL5xERx1QKYGRmwZTmaWWzA4fUDsvgmoFkMqm3ew7tp2s6
30834	payment	2133	2133	1874	1	1	2729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3yGSc88r9jnJbnPUUYRUqHvceqMBZSFxY5amUFgS5gY6eA6o
30841	payment	1397	1397	1678	1	1	12315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNHmkdMZRcnKMF5c5C6C78cDDjdPCziWjTtDKUx1UMEDomXhE
30842	delegation	149	149	58	1	1	9	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5r2Pr14HUvo6XZxJywQjnVuXWTVjytXvZhYcshU2Dd5SrmuTt
30843	payment	2133	2133	1874	1	1	2732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxYivfy7r3bLrnCMKKi4P5Lk7m7dm2YsMfT8bKBh6Y6xqSFKx
30844	payment	2132	2132	1874	1	1	885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFbg7v3LJVVX1NXsRF34WFkCx4ET9kLX4Ukj3xkq8tfrZDA56r
30845	payment	1397	1397	1678	1	1	12316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JtTJfdbW2K76bqbSG4fLbAygjkGMKRhxP6UL7HpFU5wmcvrW
30846	payment	2133	2133	1874	1	1	2733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4VfqCRh5mcRkYrxiLoDYeBy5nYHfgBL671uCF9CpTmgwr6EH
30851	payment	1397	1397	1678	1	1	12319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVbnTCuz36n5QfqxJGNtymNqLcs48UjKJ7io2LCZAf1hNhvfD
30852	payment	2133	2133	1874	1	1	2736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xASJbvr9FaaSv4FZssrq22nxxkaM7RawpTRiYErsL3TwpHx3
30853	payment	2132	2132	1874	1	1	886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsUuBqdwkjiSxxF8TC9nCogrNzxXR2gdfPeTuWZV7gjf8PXcf
30854	payment	1397	1397	1678	1	1	12320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEDtTApJ2ZnE2rKCsjy6hoTgb1MHF8qTXGFhKZDoieDzFKXsm
30855	payment	2133	2133	1874	1	1	2737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTM5Vt3nuxPqvNNdYAVEEh7EHmUWzugBXh4rwWFcndBXqe7Bc
30863	payment	1397	1397	1678	1	1	12324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa67nnfbrnv1ie1C2hq3fdYUKu4iTVYTQMd51ibfgtsvPceexM
30864	payment	2133	2133	1874	1	1	2741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyCWVnnWsjc1KCHyxk5yqp6BcjWHGhkipFb6FX31iK3B17J92
30888	payment	242	242	2269	1	1	0	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11hsD8Gz4qydHBfUSt7KNWRcRucEHh48xsKAazvVmwhgP9zTA
30889	payment	1397	1397	1678	1	1	12335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBFAo6hHnhLGCPZp7SgzNXbzLTWxHdhV6H1SxZqsKAMK4Y7or
30890	payment	2132	2132	1874	1	1	891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa1j9c4ekELtnP5JZhdsvMqETFyUA2WmLFhph3E7MTCSGSHLM
30891	payment	2133	2133	1874	1	1	2752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdxAUKxmYGMVYgJBHpuYttjMJeXGA1Aj3ufBjGHGC3LHFE8Xe
30899	payment	1397	1397	1678	1	1	12339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6krNKPtTS281cX7NZg61J7wjC5QDNf7uZhpCkLjteUfydE3c
30900	payment	2039	2039	1445	1	1	1	2000000000	10000000	\N	E4YXduXJHkEcC5XreEX3NJXDUpsnt7dMpwyQuWdfL1Vu4DdwqCH4a	CkpZxi9qeuGn5fdycwDyiAe2RMLA8hkvmqW1TLmmFd5KQJxvNpetX
30901	payment	2133	2133	1874	1	1	2756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g1Sr96kok9FrQ7TBH7twdAmPPd1jkCywV7mae44AJQ4wBU54
30902	payment	2132	2132	1874	1	1	892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa91CzJd3kqt3mVboiiebLcSFEjWaSqZx8idqFYe3izgv4fVixu
30913	payment	1397	1397	1678	1	1	12343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjETAT6y37qUFY5mDYUzfeEP8xbz2ehkXz7rTGH6BY2GRkt6R6
30914	payment	2039	2039	1290	1	1	5	8603000000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpYwx1H8y2fGPrNvFLGkkoef6qwGXe7vZcwhTnah5tNqvszDUTPq
30915	payment	2133	2133	1874	1	1	2760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4RLFjQN7MeVhVa97aPya1yL9UWNmnMhekoxMHDZZizGc6212
30951	delegation	2270	2270	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6y7n2fPtBDAGbBRzXcbGp6pixAM4VH8H1UbSwJdqsKPymAo4X
30952	payment	2100	2100	2271	1	1	2	3000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuuvuYtgP7dxvLETF22xmXZHMmABQyiouMnw2hj4dVinvWPpZ2
30953	payment	1397	1397	1678	1	1	12356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1SviRwSuQCjW4no7CLVAVLEAYzQWsvia7VHeiwQSBPJHBM9D
30954	payment	2133	2133	1874	1	1	2773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uekzxaUdCNBrsmwwaZw728VTgXBqcWMsvrsBbWSHWMAxnmGJ
30962	payment	1516	1516	1168	1	1	14	1278313790000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbA4TEsLf6EE7Nqu2AQyxon8YuFoyCWhVrLerYVc1k7jt3p2r4
30963	payment	1516	1516	1294	1	1	15	3561956390000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbfL5sciYg4pF5DYJwHng2n176fbx3aaMa6GWtFiUnmanPhco
30964	payment	1397	1397	1678	1	1	12359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uuzSRHQn8BFuGHcuifccXs9aoJGr9kqThUqgMCbCFjp4PSPT
30965	payment	2132	2132	1874	1	1	898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbagDrp1KMNmfhxpGBVwE5Z2TxZkaHgoweK3RpUfJHsfqKUUEx
30966	payment	2133	2133	1874	1	1	2776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEu9KuKT8CTjNJMQ8NGQTSamSmT3NUkPRYK2xi8VfeuZ8uXLYg
30895	payment	2133	2133	1874	1	1	2753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtM7XzKsMD6XFgoZtsU8SEqKNRg7AhSBQWGcq9uRyvHEypUue
30896	payment	2133	2133	1874	1	1	2754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaq1pFjgCB77nGfCnz86T9rJeBwhFXDdeJcTmYJgLQssbUQcCe
30897	payment	1397	1397	1678	1	1	12338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEk81D22REDFDLnjoWt7E4Zqx3hfbyEn42HLNnoR26315eBjPY
30898	payment	2133	2133	1874	1	1	2755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pPyEwSFi6iw8hyizb7PjeZPQgvoju9h2ye8T3EmVJEVJuhrR
30905	payment	1397	1397	1678	1	1	12341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKnoajt7jdva2hmPAzV6Q4z22LndsHBGMVKPzCUNJR65DSM92
30906	payment	2039	2039	924	1	1	2	2553750000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpZT2Bmu8FJGKpmtHb6xyRBuyRcrTP1qFMymZjCteDe431Vdoefg
30907	payment	2133	2133	1874	1	1	2758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zJ3wj3jmSQuS86x7ZEAAFn6cEfhccJ3y6SQoH2eJHbpSYF7M
30918	payment	1397	1397	1678	1	1	12345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvGP1xLojxksSFtPz74Tk4GBCCp1cjZeZaeX1EFLJG9nJP3Tg
30919	payment	2132	2132	1874	1	1	894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRNoAUwi2aDFm9ckE2mU4e3M5kKcdGhAhMYzzExwNdYdRpyBS
30920	payment	2133	2133	1874	1	1	2762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPuLDgZt2JrQyZHyM7rJbXThuir9ft4hkqT5KPGLPXWZDSVkT
30942	payment	365	365	2270	1	1	2	700000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFmmLXPp3jWwUh2QVGU58sTz9Jg9aicBy1he3UChQCjYfnC92
30943	payment	1397	1397	1678	1	1	12353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNA2rsjbJ6tXqiQ3fDynYdWQTyoNaEHW4dKLQiSEe7DwPvaZP
30944	payment	2133	2133	1874	1	1	2770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ECmThh4cCfkrnbTPmotJzsKneKJv6aNkqjN2BzshWvYRVsV3
30955	payment	1397	1397	1678	1	1	12357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASZss39Z5Q2eGiYKAKSxjYdr2pwhbnC3mcamJ5XoNpHuCtcY7
30956	payment	2133	2133	1874	1	1	2774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7NVM1BetEKHk1t31p8PS5F4on6mSvDASVWivGvSVMMUCZV8yi
30967	payment	1397	1397	1678	1	1	12360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxheW7cPcyGR9TCXavBuAM6rZDooA2giuKgCkYppDTMVvBLG1
30968	payment	1397	1397	1678	1	1	12361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2knusNi3XVoMWoSMLs31AYExX6NfVS3y4FWYFoYQPJqqgP1J
30969	payment	2133	2133	1874	1	1	2777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1n9b7GuWfpoWvNGLXihFsbvW66HoN898dXxhkFnRjnjMsaqx
30970	payment	2133	2133	1874	1	1	2778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjGFyEbuios9NMGK1x2FSBnw31Yoo4NGvT9SfbDuqQoHbG2ey
30981	payment	1397	1397	1678	1	1	12366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzw6XSUn2sqzoDgxdGxwNpArA1nAXnnUnHT6QVCetQChZXNBP
30982	payment	2133	2133	1874	1	1	2783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofkKi9frCqKUn1Ch2noDFhHycsWkkBiYkBiSdd5LQshexCrGZ
30987	payment	1397	1397	1678	1	1	12369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCEE3mxttr7TamKuYPZRvDsdxWQkncUei59FUavSmngm6vvWW
30988	payment	2132	2132	1874	1	1	901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuQKB8hxJT3oohV9CNhoXEyo7dNoBPRq1kh2BkPNQijNpZCo4
30989	payment	2133	2133	1874	1	1	2786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zjZgYpmixK5iFAveKMyvjsNWzoPpZftF17upog4sdBujvvSR
30992	payment	1397	1397	1678	1	1	12371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgAiF5j11KWB6aJYNdXWDi4CsVtajdFNCPwdrJWZNM624GvfP
30993	payment	1397	1397	1678	1	1	12372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJV1wTvPFDhrE5mFyyexfuzQB3PmcbhqeHcAxvCX4RdnEDy5xJ
30994	payment	1397	1397	1678	1	1	12373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuWgWdTHH4tXgBKw8r9tvs3NWQQiHH9XX31V4q3PA9M8Cw55S
30995	payment	2132	2132	1874	1	1	902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgTWLATibXwLDsmJFe4waKxR5g8MKyVztschYyPunABsyKQNA
30996	payment	2133	2133	1874	1	1	2788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17pqQzdfmuX1fL8qr4eV15PfkcsEr1qb67cxrTigSdeqWsGKE
30997	payment	2133	2133	1874	1	1	2789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT2WQ93wJUfgeN3Xuc2rW5rsAWm8yN9nz2XaSGkV66ug83ZE6
30998	payment	2133	2133	1874	1	1	2790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1tzMPDZT1ywfTNr2vWZMoynfC8pQuyVYNBZdSKyzn49n1qRF
31008	payment	1564	1564	588	1	1	9	468000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjmVTYBTPN4ozv9ejXuXomwQJo3gZiezEv8yPFyhpmd4WVhK7
31014	payment	1397	1397	1678	1	1	12380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWDEJngHTVqCzU5XMqi4Zf4eRKWVkprykTG4N8q14RhLcbLDY
31015	payment	2133	2133	1874	1	1	2796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBXGpVZ7SvZiVUnKctk1YkbF5pDBJe7PuJtgH4fYEVqGE6QMh
31016	payment	1397	1397	1678	1	1	12381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXi4BZ7w36YEmgoaw1drFf13Ak2Cyr8TPu21NN1VDrJm1y2Sj
31017	payment	2133	2133	1874	1	1	2797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwRKNeWqLiyJGfspqWVr7pHgfmcnxcTw288MetwTwpNWVkwGr
31026	payment	1672	1672	2016	1	1	9	1328000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbHqFN2twVxeb9wAxNUwQJRKZfiNa1BtDd9WVwJEgqBw7W9Lm
31027	payment	1397	1397	1678	1	1	12383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKZZWYs7VWBBw1MMQCfX2nPx93Ap7HwJ1Nsq4jPcDEGTQxzc4
30911	payment	2133	2133	1874	1	1	2759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8eaWSdGCygR3psUCWg8DydLXc7U6q65qWMa6YjzcaKZiGtDW
30912	payment	2132	2132	1874	1	1	893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSS5vgzToEu8TKjXvF7oNTyCmRd4oH3HPEqbUm5B3TZwyd2po
30921	payment	1397	1397	1678	1	1	12346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CWjjG6JiPZmXpADMaNXGMAVYs39N2LypWCshv9LKE2k2gtE6
30922	payment	2133	2133	1874	1	1	2763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtaz172QxrZG8EaEFjvhHFc3CCYnABg2MkBcDPMXvNNygf3Rz
30923	payment	1397	1397	1678	1	1	12347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtn5WcGCNSSHvPuKkZ3yoHBTfcQy8BKSAiMUsFg6iB4RYjb77H
30924	payment	1397	1397	1678	1	1	12348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDwPtVRCP4xKH6bT8v5BLqDJdLP99o1ydGw1shEKJGy3u5YAM
30925	payment	1397	1397	1678	1	1	12349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLRnEvU2auysodBjsYQY89hUQexAuF4vHokhTVMBvPCTNx6qf
30926	delegation	2269	2269	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaziSnZXyUa6ZoFbSMWLCsXggChvpDs4cmVLhdGb3EVsfKcw6
30927	payment	2133	2133	1874	1	1	2764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtE3dJMtNkdMV63UiJTV4VPc39N6S8EAUbpu4ZHHuTiTXUn429
30928	payment	2133	2133	1874	1	1	2765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUB96CRm1TfH3wTJY9kmdtRwxGvM9GsRW3894Z2DKT2VaUBGP7
30929	payment	2133	2133	1874	1	1	2766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriGizDD3eR5mpTJ3qAVezuGD2rHeaBS6k5LJs2thWq4RS3pNo
30930	payment	2132	2132	1874	1	1	895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFN3H2zSwfWJNo4tng5sdDM3M4dHKAA3MaP91FNxS4rgWBqfZ
30931	payment	1397	1397	1678	1	1	12350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL8NCix96VmkqyfKeuzDH6FcFr7TBGBuJgr62134MzGZDk83s
30932	payment	2133	2133	1874	1	1	2767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFf7Qci4EwUmG8ojPMtGvh8yZvnWnenQKenTVXCZ8bHSMgHuLt
30957	payment	1516	1516	928	1	1	12	1057268060000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U8eJVxtqTCHAPJt5ToRCSEoz89pWJRu6VYgchVY7QQJ6np18
30958	payment	1516	1516	1048	1	1	13	1894536110000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6ARGwTRaNQf78GHP3PUEj5WB6EngHciQwqgPM2czGoS2QKKw
30959	payment	1397	1397	1678	1	1	12358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p88bCJi1DiAHE1gBtiYnxS8TFLUtYBFvL2GtxcCJs7pQ49nD
30960	payment	2271	2271	2100	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8yxWSWXUpyfyvJZKjbqMizhGxnQSW7fqvHojS1NeihNCMmVHk
30961	payment	2133	2133	1874	1	1	2775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GXsVHrNDtdrBVunFiSc7b1xesxwjYCfVcUwBasoTWek94Qet
30978	payment	1397	1397	1678	1	1	12365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdZJLepoun2cr5EJpzNuxADmo93ncxE5ThBNNoBCrDsEEkvpr
30979	payment	2132	2132	1874	1	1	900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy2rqinXHcQAgPipPS7f29AempGUiG8myVxxNkA2bXjkguxz8
30980	payment	2133	2133	1874	1	1	2782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme9aGNosnrYTjNxhm6uQ91fabMYhrgY4g2Gmp5J3Yto5GMnGx
30990	payment	1397	1397	1678	1	1	12370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ7AziAux1ntMmbqhmLDjAc4urTm5fGSXPENFgcNJPCWmNPsW
30991	payment	2133	2133	1874	1	1	2787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84QX4YepcHaUqTD8YHViiYkz6bsAvwgtDf5W9ArBRuyTFDb8b
30999	payment	2100	2100	1958	1	1	3	1432000000000	30000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9CmsfBnTLQevpwwHrfonNPV6c4jiBPcFwXkGbJNcdfNJSLHz
31000	payment	1397	1397	1678	1	1	12374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcge73gAAricBdNGrLDiwdo3TPrhaVv2wkFeqS1gWfQUQGRMHT
31001	payment	2133	2133	1874	1	1	2791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAx9Bye2pof5Yt8c33TUrWZpQ5H6Bu3gCSWLSyjsdygXaNXsL
31043	payment	1397	1397	1678	1	1	12390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiWEQbez39thhWN5NsNfbwSci1JReUB3g9jX31B85nEnkeAPA
31044	payment	2133	2133	1874	1	1	2807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWfPS3CX3D4DMv1hasnBQdMjCnWuBUzGdJmpehDLVUAsgUUpH
31050	payment	2133	2133	1874	1	1	2809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F7e9yk5Er7qzJZ4BjrQhjL7fnh9iodeymqteLdEhQBpueLN2
31051	payment	2133	2133	1874	1	1	2810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYMqyTWe32nwX3Nqcqbp5Hs2NMzgGZtXE2Q9XJQJLcJHxk1Zc
31065	payment	1397	1397	1678	1	1	12398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoz6cNPbDqL2ABNEx16UZtNt5M91foiWtqgBxwqaZ8yG8pWru
31066	payment	1397	1397	1678	1	1	12399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftciFsps2hY8DHnxnH3CZheQDoKVNTAmNsuemUGm4AxzPaP1y
31067	payment	2133	2133	1874	1	1	2815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjKyLf2sdzvzEV4rAZrdNiMMB871iUxu1zsAk3DA5vzsdwywZ
31068	payment	2133	2133	1874	1	1	2816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5Q8vKi4pzWLrqWbJmfBczJA7YbSRvnGXZFwSB7Ju7d3VhxEw
31069	payment	2132	2132	1874	1	1	910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKeXSb7cTxdH7jSkTJsLmC6FT6n9X7smeS9URwuLfN1skL8MYd
31077	payment	1397	1397	1678	1	1	12403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ouBP27qso2gDYpFYqLWoB14qcqKB8fMfsMfZd914d6P2vcS4
31078	payment	2133	2133	1874	1	1	2820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeza8QNEvBYMsqv1TfHC6pkimiSvZM62gdVvmffHr7NQXiBjV
30933	payment	1564	1564	1338	1	1	5	6145000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmzNu2hcEvNTPq2ZrzzHWMdzdpexGED5DbF5irEF3287iZ3m9
30934	payment	1564	1564	1092	1	1	6	3268000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYni9JBHcC7M43LDf6aGVYWVwzRCQkZB5ND72mytLzMQMyhCfiz
30935	payment	1564	1564	1212	1	1	7	2205000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcRK6vEf7VkjG8aZ6XN3U9FpWW7EJxV8pSMDVmD1ugvKavoh8
30936	payment	1564	1564	972	1	1	8	1462000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTpe7QTmUyBBam2CKeMX5pn6Q6kBaiJuHWQo6hQ1HcEtbgu8B
30937	payment	1397	1397	1678	1	1	12351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTD9FrC4eLmtWsePVbNAVgtneTd2K7tyBEmdcwdgxzqAp7QjP7
30938	payment	1397	1397	1678	1	1	12352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYc5ZW9gmTrac5sddafRsgqm1qfTgSdv2s7Y6xVP37rPGiPCW6
30939	payment	2133	2133	1874	1	1	2768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ivCK7jWzwwVmGhatcV49ySXurHibMvUdqDqAE5g1WzpasrX3
30940	payment	2133	2133	1874	1	1	2769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kCEmCyrYJ3w3fnpPyjWbnLk767htSBdoW9J1ddSQUxEPseFc
30941	payment	2132	2132	1874	1	1	896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GLL1p38w4pjGHT4FR3YCLwpAUTyPyieXwWhj7r9o6LpKrE51
30945	payment	1397	1397	1678	1	1	12354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvheXzPwReKj5MBnGSE2y6xDWSkE6cYBeWmHxrfPySX8uJJCr
30946	payment	1756	1756	1516	1	1	5	7792474350000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmhVPjUPs2aqPNminQfkSNc7TXk2QMYumGC6bJzjqftRp3Yno
30947	payment	1397	1397	1678	1	1	12355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEXr78Cned2SKwuuegDc8MpBYA71V2Keib1Xd1faFPMfqh7NB
30948	payment	2133	2133	1874	1	1	2771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYd2aiTVVKoQm4Ewr8iQKMNu3F5JTYjegi4N7H4PizGtHPZ8X
30949	payment	2133	2133	1874	1	1	2772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw95wTQb9oz6hJHcEzHULnQ3YvRxG8QhdW1qw7BxqJXjgKHicK
30950	payment	2132	2132	1874	1	1	897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZSYwwUErLDFinUHrNH26fKSq3Nbv77KBtmTgZjffBXnbUykG
30971	payment	1397	1397	1678	1	1	12362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzWjmuPJ5ntsrcmxzEiRc2zd5swLYkFvywMh8bFZBb6hHrFc1
30972	payment	1397	1397	1678	1	1	12363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58H4p93hdBMwWFPAjJp5e4R3E5TYYgFAERccwJLwxMJYRirnU
30973	payment	1397	1397	1678	1	1	12364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYithPLz8oQBBtn1E42X7SQqWYVoMvHHrm3x964oSmP9mVuQncT
30974	payment	2133	2133	1874	1	1	2779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGsswRuNPYDEH6aFawQ8tx2Dy8sx8YP6waMCyjNJLMAsczxNt
30975	payment	2132	2132	1874	1	1	899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSgWEkrG1wtPrhp3B9buRk41Br3i94cz13p19fRVCdVs8QgGU
30976	payment	2133	2133	1874	1	1	2780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaoDsxRgSJSVDDra65gpJmEWfAG87aGjkwqv7YjYoZvBj5SVn
30977	payment	2133	2133	1874	1	1	2781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5Wte9om5QnkaEeSk7Rs4vYV6xo64Nen4gwHN3U5CXNzZu7Ak
30985	payment	1397	1397	1678	1	1	12368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKUsgQirMskGbNGSJsaFzFEYRGrD3aTsDUa5sPqcgRcThgJzo
30986	payment	2133	2133	1874	1	1	2785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCSEYy52ybxFaEur3Hw13g2a7v9L69daLveAPPAkryhXsA6oh
31002	payment	1397	1397	1678	1	1	12375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdr1aUu6Ls9qmXLYUsWV9hbXS3FRvavVAkEdzuAKEZC127gQU
31003	payment	1397	1397	1678	1	1	12376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4iBVGNAFgB3BNZdUYkueEJNmDrDTZi3U3W1xD5DanuASSSTZ
31004	payment	2132	2132	1874	1	1	903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5FocFu4CUNEY2Ak2UoMEv5rbofornB9NhQMYREg5J9FZmXGk
31005	payment	2133	2133	1874	1	1	2792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinH8Rr7NmtCMSUeCqWuetkzrKzbyEzKasbs1mHut6AaC3VLct
31009	payment	1397	1397	1678	1	1	12378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7qgU74Q44ish4VNA1NApEUt2EEXN5UmqpoUrJww2Yv3CjqD3
31010	payment	1397	1397	1678	1	1	12379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34WXzqh23eHQBNguBQv4pcBiv8sh9pKuWHLgjG1i4GfJkgzRY
31011	payment	2133	2133	1874	1	1	2794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgkpAp4vgZaENkTCdL2WtNQHBZhxwpMPFXieHpcZkRFkRXhFN
31012	payment	2133	2133	1874	1	1	2795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDkv2eT2CdEUkLQmoKi13K8TDVjRcrCfdxJSGbyqx57U6bMnm
31013	payment	2132	2132	1874	1	1	904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCMVEWTsLsMA2K98k8aeB4p5N3BQWcDoeqGmaxUUFxLKY2c6Y
31032	payment	1397	1397	1678	1	1	12385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSEvj7j9VW1jjhQhWvv8CHkVSSqYSMRZo8sHGgq8j7coNDztr
31033	payment	2133	2133	1874	1	1	2802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZFG41B5r4tipZWhWBS8kKwRk21px8XYf2iV1RXBhnrUjXxEF
31038	payment	1397	1397	1678	1	1	12388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPskdEK4Fvff6gUvHC5PkvLiA8MGVvkmTw4znhAkVofJyDCqE
31039	payment	2133	2133	1874	1	1	2805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEc5KJpCFhNJYdCNzLemxCqQx7LVfQMCuuVT2BZhHSwdU1oi2d
31040	payment	2132	2132	1874	1	1	907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5XoWQ9Lg2ZP6cuHw5s7Jg12T7Kk6vV6eAJRwo4XQVcefgi36
30983	payment	1397	1397	1678	1	1	12367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp13ENaxC2bi2qkJxGKkyWVrhaUdLVvUqScjX8LV3GCmvYtGsZ
30984	payment	2133	2133	1874	1	1	2784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXHm8rsJEocp4q7YFMKHgHxbTcfXWSSkDiSU9zKTmpood95pi
31006	payment	1397	1397	1678	1	1	12377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY1kQR2i5RoJL8TEN6QZy6V2NtYtRBxuyxgThA7Rq4yshUHXu
31007	payment	2133	2133	1874	1	1	2793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9JhwGGRK6s4N5Hn9aRvJGVXafXJNs4piiqH1NEActEEwLqo6
31018	payment	1672	1672	1285	1	1	5	11571000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5KzdrPTeyrCJEnT7ssfZG2oU3jVKSY8f3GBWx6vKLwe46KNs
31019	payment	1672	1672	1039	1	1	6	6154000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRjxLeST5JZbZZHws7GGQ6tbiQftNM8FWDjQ1nk4aWABV2HtS
31020	payment	1672	1672	1159	1	1	7	4153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4ySmp8yGopJ9wk2bizvrnQtTUWoE1WPbvWPy6QJQW8SNSJET
31021	payment	1672	1672	919	1	1	8	3435000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTz1Qen2LaSLbJQLL4vEJGfrdGsEs6Dk6kASsjnZsrJRw3Mrrr
31022	payment	2132	2132	1874	1	1	905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuWapFwcJyhHj4rPYrfN6MxMT19rJj696Tqoph7nkyJu6k3by
31023	payment	2133	2133	1874	1	1	2798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2GSxBVboGW86of7by2sEBBRxhc71f1XsoPVYuABP5PiHUKYq
31024	payment	1397	1397	1678	1	1	12382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGzS9XHdbyqWtpnqLXh6QgLJLxKrrAgzUEtVBea7A5aLD2siC
31025	payment	2133	2133	1874	1	1	2799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVYuVE9KVY1HMwG3N82kZV7GmQ7pb8gHjDZXW67HR3gVQncTF
31029	payment	1397	1397	1678	1	1	12384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqK4iR4dSB9LbpAmzwdwdrVivj641Jttipzp28pbAmuuTf57z
31030	payment	2132	2132	1874	1	1	906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjQqFQ5sEx9Cjz7VqTCFgtP7Pc7rvukJG1Fa2fuRqjJme6G4W
31031	payment	2133	2133	1874	1	1	2801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqbiRwqWSwKBqYywMxiFwGcbh7hJpnszw89Pyq99Tz6PgkiPK
31034	payment	1397	1397	1678	1	1	12386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsVjb4fDvbiTth7b3Dc9WT4kk5MYhZgtvLoAY6n7X6Tw7BSgP
31035	payment	2133	2133	1874	1	1	2803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46365xszcDQ7MjSPtQiWosjNGiw7V9PqQo77SBmPqSNZ37VV1
31036	payment	1397	1397	1678	1	1	12387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSsm65VKmwN5eVNvmH1eBuzbVVTM97NSpyo8KzmY1HaoVJuyH
31037	payment	2133	2133	1874	1	1	2804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQX7NQqJbT9zQaqzXVFQBcYZoVJz1kwqxjvWmJgyadoAFLQRq
31045	payment	1397	1397	1678	1	1	12391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uKE7z6S2xA289hbJ4kmuu3JFCNZKrmMAwq4c3xtCTT9aQZ1Q
31046	payment	2133	2133	1874	1	1	2808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYY1Rhv9yezcmaaRAPsxJ2Sf1oCVoC8sUToUAqxt7MHz5fvXq
31047	payment	2132	2132	1874	1	1	908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpcQJTA9o9qbQgzQbFP1F4cqSWCjM8E4XvYPuU7BDrLQjtn3z
31072	payment	1397	1397	1678	1	1	12401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUN3yR2nTPgpSEipiqZxEmvf2FgUZmMbBvQ33Ur5fY489orvA
31073	payment	1397	1397	1678	1	1	12402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPBJbzK4hR9cMUsVanFSVt9xGWMgv7iGKH7fqzWsPy6xka7VM
31074	payment	2132	2132	1874	1	1	911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JjxRQnZRforTu8EGeh9VQCk1qhvAMExHJoxok3D3CWBCo3HB
31075	payment	2133	2133	1874	1	1	2818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVwYkkqEEzMVHuqewcNAxoxaje8svV912ncXQkxiTHsHaZwTT
31076	payment	2133	2133	1874	1	1	2819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipecBbFKN3vWWNeoZHLbkX7TKDosDS2wffiqF2mvD9BgcaBhK
31109	payment	1397	1397	1678	1	1	12416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrtyLDfL5K4Yorj9ncRWBoaC95jG8AbmfTTuSkbAFaUZjEXkm
31118	payment	1397	1397	1678	1	1	12420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFrAvY5EDYN13s25pZ6WRFW6t9y53bZtWqjUCn1D2UhEF96NR
31119	payment	2133	2133	1874	1	1	2836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAayUeb4be3UbGji5pPXbHEZZc8kxa3GzV1FeZrEcGRsakzK3
31138	payment	1682	1682	1850	1	1	6	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWkDkbvBV826x46tYiMGEp4q43cYofRZ6ijykusfMHESuoPKG
31139	payment	1682	1682	1850	1	1	7	1000000000	10000000	\N	E4YZaehXjmA8VjXa7Y1uHa7djBifMPV9GTxWQphJnnfFLTSCg12FE	CkpYq8xn2Kr787pCEzYrgBv3y863mgvMXk5uiRLo6Z241xiZNFnmx
31140	payment	1397	1397	1678	1	1	12429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxfXT2YCA6amhtPwiDMd4jSJ7VgYZFjbp21oAQjJ4JKHi6Xy4
31141	payment	2133	2133	1874	1	1	2844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfrJ2b7SRjsNJDzLjybHC1wyayG3VD77GNHHLRzHYMPwTX5JP
31147	payment	1397	1397	1678	1	1	12430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bgkuJFvfjBrQQ2VwJWvFLULrP9AHxquyLhhN8bqjmiyeTnvR
31148	payment	2133	2133	1874	1	1	2845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MRKCsaDWNJHcDP3HQMm1jDYNSJVbXLTRqKdFtmmX5uRLhYSN
31161	payment	1397	1397	1678	1	1	12436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqiC1NZ9K2QR6mh24UPro5G7okmyNr14CydpmntWen7Jbv5hGB
31162	payment	2133	2133	1874	1	1	2851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSfwJHKKjMSxa98tHzYJoJzau3rpvuMQRuemTVK2PZ6bxXvN4
31028	payment	2133	2133	1874	1	1	2800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qesbZ4kPcg34ec9GPraPb9odqmpGsygwZh4GKmSBTgcCGBt9
31041	payment	1397	1397	1678	1	1	12389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwPPpqih3x49LPrYahBeeQPkwyjraNo1pAZxeuRo5D5JbRAhF
31042	payment	2133	2133	1874	1	1	2806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84nizRWbwoq5tMTdbenZChSA3ZzBysb1exXd3FT4584tAb6AX
31048	payment	1397	1397	1678	1	1	12392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yXdffprd8M4zXqidVccS9jkb1qqEqexSEBE5PFLyr1YTcYhJ
31049	payment	1397	1397	1678	1	1	12393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPEND8miEAY35cAFaWRPZrkDcqYrY4MvRZALvCwHePsL7XLpM
31070	payment	1397	1397	1678	1	1	12400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnHVp7RSZLRnie75mkEEZn86s8exRVvdnLgng3iScEqbUit4m
31071	payment	2133	2133	1874	1	1	2817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGKpUbDrVAFvGJx81GThGEiVSPiEAQY9e9HjTUhgXGqgxuMnB
31082	payment	1397	1397	1678	1	1	12405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPK1hagqjbsqxYEvWDMt3Nmeop743SbymgTLyC8TAVUH4BH2y
31083	payment	1397	1397	1678	1	1	12406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehh9YadpSdngck2vtDHm9ieiCxY2SifB6L5K51tu4q8Z65S2h
31084	payment	1608	1608	1289	1	1	4	8295840000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMMFdesq7gg1W35trK4zVCZ5kib1aDyqxC9GXL2DXghWKvjxM
31085	payment	1608	1608	1043	1	1	5	4412290000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8K529X5L26Jx6VSJ5E8aXBJ4cc6xTWmfxwDsvQbMyEMQcZ7hB
31086	payment	1608	1608	1163	1	1	6	2977060000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA2ebSdtBgseZo5UBUn7TmEJ1H73Wh4TM6wLpGtHnUjJF235e
31087	payment	2133	2133	1874	1	1	2822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyeeWchLCb6pi8dioiQr9rYeDLyaZYiCQ29vpcfebxwiTue49
31088	payment	2133	2133	1874	1	1	2823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5vouaB5enNdFtD7UvgG2WfKb1pPNujTyQLFNmY1JHSUStcCM
31104	payment	1397	1397	1678	1	1	12414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTej8SFSucAhqpS6AyJXb3zTX6GKRf7wbAkp8LipjRUvhFoiL
31105	payment	2132	2132	1874	1	1	915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBicpLqcs4jgz1y38Gh2kSUsWLMNjKez8VHAeh8UGWnTD4ksm
31106	payment	2133	2133	1874	1	1	2830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwQVYFXtcQem7cCgjAwecT4QPeXkULnW6VMnHAk5iasuZtAeN
31131	payment	1397	1397	1678	1	1	12426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRoYwL5qTwbRng6eAPd8xgh3HJp38j2os29sqLaufCgwgowoZ
31132	payment	2133	2133	1874	1	1	2841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22PWzNzh8PB2w5KaK7ox8EPb1dg6VgBTwnK7YzFqod6ysyhKn
31142	payment	1850	1850	1277	1	1	5	8203400000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZbC1hs3pfwypK7RP8imUAZk43hzWYgkjs9UpW4y6s8tuYc73Xb
31143	payment	1850	1850	1031	1	1	6	4363100000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZYPs8hvcZA9QuiB6ndwbRuD4w9NWVtu2MAiCQSnRYgQXsXD498
31144	payment	1850	1850	1151	1	1	7	2943900000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpYeknPCxnmhZmaR1MzYVMzXdUWuhL2ASCcQmLWZFG9nnfAoEWYW
31145	payment	1850	1850	911	1	1	8	2434800000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZc6wHKmFKYpHPc4tfMAzQ9VJv1yrLXb83tmUH3JmHAHHfVn17B
31146	payment	1608	1608	923	1	1	7	2462230000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcGAeEycz4Eb8Jpc3nh6Kkpu9RPg8L8dncWg9y5o3JNSFMei9
31149	payment	1397	1397	1678	1	1	12431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxt8tKmooZRETkumCXBCKtqfd41uXpNgDLM8hCyChkTzVwsFeN
31150	payment	2132	2132	1874	1	1	920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rMfuJaMHDYarGHqjUvsMGx9tf5nhDtupaUsjcZi6wtdPA6ia
31158	payment	1397	1397	1678	1	1	12435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6v5932dJAYXSVXbvceFDnyqYwAEbfycrFMbwoYwgP6LuUW18
31159	payment	2132	2132	1874	1	1	921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ566uJ481JuxouvKrbsM5Dp9hLdZdz1TtwyS8UrrNYrccXQZJW
31160	payment	2133	2133	1874	1	1	2850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzRRUSBMZC6k5xscT3rJfrJBsYg4HYXYRTWdhc3tBKHWooi1q
31165	payment	1397	1397	1678	1	1	12438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBqVG8aNzXiweV8X7tLwWkLe6Au5s7GVzUY8yTNU75q4a3Fbi
31166	payment	2132	2132	1874	1	1	922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR78UmzchABd89CHVTQSe46NDyYEnPKQkwEnddipR33X47N5Xt
31167	payment	2133	2133	1874	1	1	2853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHytTVwqsRixkM27GpT4mEjM6zoGdv2a1oGefvpQHe3AwpKXS
31168	payment	1397	1397	1678	1	1	12439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTewhRokiqYBhwDMGFNkVBHpQzQC2skVVV2D8ixd5t3YYrQbp6
31169	payment	2133	2133	1874	1	1	2854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad99ii88jothHpjgK9NJhUUkSmGRbmuqrrMCivb95FzUH5MFC
31172	payment	1397	1397	1678	1	1	12441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gymCGANFzASxTHtiRneu2XpyN6fuqDVAqEAtXHHrn2gvjRbU
31173	payment	1397	1397	1678	1	1	12442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPnarUeLsUudqZGjwTGrRea27icSeud626nDELuzAS8uWPnM6
31174	payment	2132	2132	1874	1	1	923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRzXQfZDPFGPjkxoEoXqNKVaDANgWjp7ikdDnRJt3S3Esy95h
31175	payment	2133	2133	1874	1	1	2856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK47M7gJaGBe4MNmihQ9YV2yz3hYAVF5Vtp9kXcR74ccU6pXTK
31052	payment	1714	1714	1300	1	1	7	6528397663348	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZzGqw7tMKw9p6A1mJUZSR6xDaeP1cMDkkLwWg1PHujySbUxDuu
31053	payment	1714	1714	1174	1	1	8	2342791801152	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZnJe5zMFLWmJEaoYZhDG2PzheirXBLxLHcBiEid5RKfrQNCnzm
31054	payment	1714	1714	1054	1	1	9	3472243384940	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpYrTtUiUqvRxCfsaBSfneKduAxX1WT2gytBZjhr43xR7NzpnB4H
31055	payment	1714	1714	934	1	1	10	1937645081856	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZSE48FQLyPzdLbEEpdb9UbdnanSUUVznCVm2E9HKXrABn58fQ9
31056	payment	1397	1397	1678	1	1	12394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2Um2vua6Y5y2mshnRsp3r7UcLKPpA2m21cRavNsubLRsetUL
31057	payment	1397	1397	1678	1	1	12395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe9s7pFKRUzUxxnpEi4443iWCiJKry74fxcHUrdDymWeBdo2H
31058	payment	1397	1397	1678	1	1	12396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5yzwgjbCQfJNYGhDERaxPH5QWNGTSA2qRecYX7KsLGvS4L6T
31059	payment	1397	1397	1678	1	1	12397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbG4osb946SoqgZB9nH3MbeyuWiher13pxxTnZ2Xb9gbwDpbx
31060	payment	2133	2133	1874	1	1	2811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQvMc1fhY2m4XGNGEkWFyFCHu3TKuWCiVFPAqRgUVftNDzcnc
31061	payment	2133	2133	1874	1	1	2812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iSbdKJQDjVb8ZNWffi7AjCiUrV7BZ9kh4BUUw3w26MLskX11
31062	payment	2133	2133	1874	1	1	2813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWzHxLNvRDLeEjdSaQ1mPk118yLhZirrQKa5hhjCF3mGg3YPs
31063	payment	2133	2133	1874	1	1	2814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk99wS6W4BtL8ykzxcbTUkEuHJckuPV65HMumFyQ8C5uBxm95V
31064	payment	2132	2132	1874	1	1	909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEXuGRp6AYpe3Y3vhy8nj3YTNGUmuaBXMBoZBFMNLXVQ1pLKa
31107	payment	1397	1397	1678	1	1	12415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLiMAoG2Reyur67JhdUx2zX8NbXjNUCbNrHHne8EFjjYrqoNa
31108	payment	2133	2133	1874	1	1	2831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCsP5n71wPtqvHgBs5v8KBfGQx6ae3ig3RgeqNFDRU7b249PC
31113	payment	1397	1397	1678	1	1	12418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hfQ17BXKWYS3CKQe8u5CnhzihSTgWL58qVupskynbQUo6q6A
31114	payment	1397	1397	1678	1	1	12419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68iRdFuMPz6jmYgcwzSa5WqohNtbN1n88Y45grBqbDtGaF1tK
31115	payment	2133	2133	1874	1	1	2834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoir1FTUxkhvchgY7EFhxbtjo4nJdAGjepfXFqHtXLdLzGiBW8
31116	payment	2133	2133	1874	1	1	2835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgmux8WH9TfUkGygB2MNpydHjusfUnNxpLNQWhW1qYeWx7rTb
31117	payment	2132	2132	1874	1	1	916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3guaMGiJ2Z9stYZupNZesfFnHm517EDmjHLxMpHxYvLF3Sbo3
31123	payment	1397	1397	1678	1	1	12422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPLe5uoeV9fw5buMvxPd2noy8EJZmCurKrsri2FQZfKrKcG2d
31124	payment	2133	2133	1874	1	1	2838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5NRw9dWNHku2HMnn6UXXStVXSkoMdgNMPDAvZDxobvC7Hqenk
31152	payment	1397	1397	1678	1	1	12432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbq7GT3KYxh4t9UEKW2dXuMZkvuhq4YxU7G74GqmkGJL8p5KZ
31153	payment	1397	1397	1678	1	1	12433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUfJiRV3CGFKqCfbT99ppHtMS5iAKHzJEWTzY9czmVgvxgLYo
31154	payment	1397	1397	1678	1	1	12434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeC94fUZ1NEGeUCdfrt1J9Ce3fLkNAiDMpeREooB1eyy1L89SE
31155	payment	2133	2133	1874	1	1	2847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FMSg9Psw28k9UGFr5171hLn5kfdFDVKJAdEw7AveuKu1y4NQ
31156	payment	2133	2133	1874	1	1	2848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtjzgd7sdzBjikWo4QaeXPvrs2wTtFNh943kHhgdH7LaDoNbM
31157	payment	2133	2133	1874	1	1	2849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQ8mcKxTWbH8yZjEeHJKQqBSbe73yRAC43j7F3HYdaSw3Q1ap
31177	payment	1397	1397	1678	1	1	12443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiC83q5LJbtk6moWU9TtcAnwBfykh6L7g2zDR724Kda7ftdVZ
31178	payment	2133	2133	1874	1	1	2858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uL2dXMqfM32aaf3h9u1fUw3tMgR37V7vHRYjiawYX6oCyts9
31194	payment	1397	1397	1678	1	1	12451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2pzHSZPJBuFYSfy1i38cLvMGFBwgqzGwbgMcp3hW8RRr8Gze
31195	payment	2132	2132	1874	1	1	926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipi2Hh3gTYTGmvScgqrbyhvk5vjrRVgjuK1Um3QzPGp9fKwnr
31196	payment	2133	2133	1874	1	1	2865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Tn2vWhXenYF5fbSMa2w5zh1HAPG8qTQx6ToS6tN8Lr9TNq7E
31209	payment	1397	1397	1678	1	1	12458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojoJ3QbT24xzQ3os7eaHiLY9JQCfffsNAUrsxGKnXzhk2p74S
31210	payment	2133	2133	1874	1	1	2871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3ezjyY5CFN9nqGtux4UwzfQycScUgWMReFD1qSDMuo33CajW
31211	payment	2132	2132	1874	1	1	928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwezpvmbztKjMCk2ewzyhsbzgbJrUiZwUhT2ACaX6BkfwinBmh
31227	payment	1397	1397	1678	1	1	12465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhQHNYH6gSSknaJjPTcJRbViCLnKbVtReUjWvWb7Vrs6XA7tj
31228	payment	2133	2133	1874	1	1	2879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPNSc13QcwwWE7mpkEHidrFHeiUPkXSd9a6bsgSBPBUfmPTHr
31079	payment	1397	1397	1678	1	1	12404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYro4sfiWKFwsku8gYK7f24VMQvRsPoAx3NaxHRBr9QzmgednjN
31080	payment	2133	2133	1874	1	1	2821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU3NPAdQZgvyzBY4fWwSdE2VBYgb68zkEj3nzAsq7CY9YXSKU
31081	payment	2132	2132	1874	1	1	912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBhTwwXjCt6E6ECM6ma7XCbGv47N8eCUJFhsXfetN2eNQbpMe
31089	payment	1397	1397	1678	1	1	12407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAKsLsrzb82dR9dtFvfaSJKvQoV8cRYhZ5CFWo6JAD7q6MJWR
31090	payment	1397	1397	1678	1	1	12408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdX72PqmeKhQGvXurfBXbAF5qSAKAqNsUJnJ1aWfkd7RT3fMes
31091	payment	2133	2133	1874	1	1	2824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a4CZ1xmisGiNX1qj52hG2TQ3Po7Z2omAUiZSsCkGAQ2DA8vi
31092	payment	2133	2133	1874	1	1	2825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYeibKbz9MoP9AVDATMY69QZxqJFMVcZr2QBpdP24rTHkkFYa
31093	payment	2132	2132	1874	1	1	913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWQAKMGqmwBs7zCChiCk4wQPSWFBmR4eZ8en67Um6gsw25xtt
31094	payment	1397	1397	1678	1	1	12409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMieEdiz1vr1CRojVw2ndGuPyG2KLuxCCEDFdmzcF9MJj9zCh
31095	payment	2133	2133	1874	1	1	2826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvX9qgiDe2jTjxXv8qSqCXvANhFQb55vGQm9Yto98ThVoXFzo
31096	payment	1397	1397	1678	1	1	12410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51qy4M6Uep8xhpxGQZvoCZefaGNTofC3PHsCXdEUwBfLGXSHD
31097	payment	1397	1397	1678	1	1	12411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCf1sR5t6JUrtQspogonkLnhLTVMcMQGHuRwLKjKH3qgJEBB7
31098	payment	1397	1397	1678	1	1	12412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29mwQMyq3ckhLc2XRkN5NvgZC23K3NoqxemsJMkxArWt7x1zY
31099	payment	2133	2133	1874	1	1	2827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpPuXEyyh3e2ubyE9A5SHdc1TWYxb44pyt518tndpSURX7mvu
31100	payment	2132	2132	1874	1	1	914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuEgyZXBSVUf9561feNLcHLmPNWdUZ99Xs31hj2P6osbyk5Yf
31101	payment	2133	2133	1874	1	1	2828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FLKkGX6fcQAPaCGGdCzt9nvoxog85vzCWiJmaJ8Rd1oHaFa7
31102	payment	1397	1397	1678	1	1	12413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyouxhV7QVTzjMB7hJvSYYfhRwbLCismkc1Lvn3xp1UfGzVKq
31103	payment	2133	2133	1874	1	1	2829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14gkhTzRZ338pPiVt4BLZbxVsCEk7Dn6GY7Q21K6bsXuDmHVm
31110	payment	1397	1397	1678	1	1	12417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXyj2xrRzAW9jA9qrEiyxuVWEunwBu15LmVJgVunTWVQBwWGP
31111	payment	2133	2133	1874	1	1	2832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhpJVTzTkspo6RsKXDYQo56NzrWx6i6o7EdTtyGKzxJN16cBY
31112	payment	2133	2133	1874	1	1	2833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9T74pRamiDbfPhPmrfDBAevgvvGa6EhAMecEZ7XaSgwyy3uUu
31120	payment	1397	1397	1678	1	1	12421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHq3fPEYiiRMuwrTVXuE35UVPHhVX3ebsgV4MQaLF3ZYp6R3Q
31121	payment	2133	2133	1874	1	1	2837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQGTh48hc8vPaZF5sfM5mZmFYjxmzDL8ujukmSAhhD8h3WRTM
31122	payment	2132	2132	1874	1	1	917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDDs9UY4uCzDMzua2B9TraXX24ruvYWNKHxLJRke3HuhBTeEH
31125	payment	1397	1397	1678	1	1	12423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRPaZPRRj9ktg7M4fxHP1L8WWDXdakz4PPhbRX9h9BABa2cu2
31126	payment	1397	1397	1678	1	1	12424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZBLSRs14YBWuGY6HEpgW5dgAphnWBSE4BaE4VqVA917YtMm6
31127	payment	2133	2133	1874	1	1	2839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dyUdoxn4apBneoP3CStkRe8ZxxYS5hj57DeSqPR1eDjxCmbE
31128	payment	2132	2132	1874	1	1	918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3n53YkqPnoDYNYRZ56hZzE81wDnhPwTVrkbkwNK8GDWzhgnz
31129	payment	1397	1397	1678	1	1	12425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYRNpibRMARmvG7v3a8T7BbxQwaYTNhX7faqxxXLL5GuC4CfD
31130	payment	2133	2133	1874	1	1	2840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmbVMxJEy6pZnZsNWrA6w6GNymbpoqN7bToPFvfJxUaZ28ZFh
31133	payment	1397	1397	1678	1	1	12427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSwSWZK5Gy8zu6x7yXDFCtixTbWzUzoh4ee9wVq4TMo64veUS
31134	payment	1397	1397	1678	1	1	12428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUiUTZFi5VkLTUUZ7c1762bY58gUTCKS4zjF44RbpwsPKDjsX
31135	payment	2133	2133	1874	1	1	2842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQB7S1mfPNRXSbWfPZVXHmbNWY7vhzzZWZa8PJPiTdfK7qQXPt
31136	payment	2132	2132	1874	1	1	919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NFhNReT8Z5WF1dhWd81FQbvqZvmdzbj97u1d4aMJs2hxFywx
31137	payment	2133	2133	1874	1	1	2843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HJZyRPXx6J542gZW3AsobvBDoEx5Z6MrHRkeXDner74MkCCp
31151	payment	2133	2133	1874	1	1	2846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2mWEANyxzc7HDERbVZq69Gg2GPkgCwWqj3hicvPu3HPUmS9V
31184	payment	1397	1397	1678	1	1	12446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzzKkut1esA9kRm66jWsotHVW4cNoY1m8hgxNNUQWqaj2Y4Dt
31185	payment	1397	1397	1678	1	1	12447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34sTWQ8HbSVXbeiCfDk5KefTeaFNDNUpHS7njTq9FJ5CyjNb4
31163	payment	1397	1397	1678	1	1	12437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeEspqfMYgCkZ8ZPkFuECMPYhN9mHFFQeoSARBgrLyZw491i5
31164	payment	2133	2133	1874	1	1	2852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZHB2epQKtVRWenkjoZPjdaU5e4AzQZRjQ7XhUrnMGAAdF8mg
31170	payment	1397	1397	1678	1	1	12440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dnPqq8rapysbPG5vaU2CQwTK2Pmi47cy8qzGtZy1tKxkL8AX
31171	payment	2133	2133	1874	1	1	2855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHKCSAFLU9goXoXaM7rLqFkCFjvhBFHmA5Pyb3t531nJT4xoE
31179	payment	1397	1397	1678	1	1	12444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD59MRoPrBnkwhqxGYJzzQ27PmmiVywh7FRsvfr5c9UQ6Dnx34
31180	payment	1397	1397	1678	1	1	12445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdGWQGJgaxrV1p7AsZYL3NmmM6rAQX8JxgNXLeYa22TPwipiU
31181	payment	2133	2133	1874	1	1	2859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfodSzchTRzqBHMA3z8mse8LQNVUTTXSC5H9RsZGoawzPfem6
31182	payment	2133	2133	1874	1	1	2860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HNShS3AxVPCsf2CiBoz5ciPRrUhxf3nMH1NYcKwi51HqchTR
31183	payment	2132	2132	1874	1	1	924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoziCWqPFm5VM11UW6KxBd1boSFKj7oS8rZxbuUJ6KnPsvJUi
31188	payment	1397	1397	1678	1	1	12448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3t48Cvj1BQUJj7UN55KcWz5k9TUyY8yP2McZtD7dzsAVBtmZR
31189	payment	2132	2132	1874	1	1	925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudGoanqA3idEwsRG5BqYASmWLdtVDEobVFDArfVSuMeozzyYx
31190	payment	2133	2133	1874	1	1	2863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ9oYwNi8rndWJjMmPozcjfcRnFVhSshBPcQELLuBv3j3kUN3
31212	payment	1397	1397	1678	1	1	12459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4egUJ84rf1FMzkNG2Kg5pwZKyj2iGtjNRxBTa13eoXTntQTsy
31213	payment	1397	1397	1678	1	1	12460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8JmXK2J73sS1m6iV2mPwQLU89RmuW2BZ3yECvj6VrT4UZc4n
31214	payment	2133	2133	1874	1	1	2872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPU769vU8F6oNHjXMNoqSasiL7JYoUxrdGFN5FLwkGPTEEzHuR
31215	payment	2133	2133	1874	1	1	2873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPDAMGdQi1E5R2FCkp1qdVn59E1z6ordjWyEF4xyykvzNuMRi
31219	payment	1397	1397	1678	1	1	12462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4fJRTXdfNh4mVusvinkGJeRcjKr7HDn9jH2EZZbZkJXUDGQ3
31220	payment	1397	1397	1678	1	1	12463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5FVhTME84yhu4yj6Vrbhh4yjex4TKEGqTSc4sd2sEzizQD6gy
31221	payment	1397	1397	1678	1	1	12464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx52HT5qQWPaHbQfoHuLNbXJMWoaoKFijkuS3B2xFi6cDz9pu4
31222	payment	2133	2133	1874	1	1	2875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKGmjuM8gXBL5Vbc8LZqyR1UvsJY3fmLuj2dSzhZX4KgDranx
31223	payment	2133	2133	1874	1	1	2876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwzsaX6WZMp9VDuZamagKm2QeMYMtQknFSdzUuFiGSa7yXZxq
31224	payment	2133	2133	1874	1	1	2877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhhv3toWTLcFNj5zta6HK5T8kBPA1D3rkNEpQzBqVgwDgF3X4
31266	payment	1397	1397	1678	1	1	12482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAWb3VBo2qaFjs2j1tsPbDKzbwQB68tzZQpTwAduVVr9JKQQz
31267	payment	1397	1397	1678	1	1	12483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNYAXYNUn8PTfTfYHDpnDTPC2eq6C3FYMAN7f7FxAXm4BEqzc
31268	delegation	1932	1932	1596	1	1	7	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrHDV1PYh7RZ4d38LdUihpy2iDqkqKoCEiceZnxNXmrF7jtHL
31269	payment	2133	2133	1874	1	1	2896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUiYYPCKwsAPd2VB9L4Ywa8dq33HicbDjUZY9hpoVmyorkBDLM
31270	payment	2133	2133	1874	1	1	2897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RSfRgDiigjV6hGXNWsFLVUGBxfheRtH53Y2cKJGg7tVXoBUF
31277	payment	1397	1397	1678	1	1	12487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ6tGdTgBLsGSWUbxbFdN2EDfkGXPBn2FH6oYBQbQXspMMfa7
31278	payment	2133	2133	1874	1	1	2901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12Asia3HmgDVDxdX7xnCEsiCGDSDr5JhZM5yjbW8P5JchhiSp
31287	payment	1397	1397	1678	1	1	12492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWW5aq2rHhjqz3zctUuBYCFrPHesJVixsLnPj4P8y75RmFRd8
31288	payment	2133	2133	1874	1	1	2906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSTEoDLtyqiEBczk6h8hfR1ssxUXLvjsbP2YPgqePXRuczeH
31304	payment	1397	1397	1678	1	1	12501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWPiujhH6RZU4kyyctYqSW89AEfzxiZQ7SWY2qLxZRmwzzDMm
31305	payment	1397	1397	1678	1	1	12502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonTXS2NwGDDgskzx96J39yy7bjGwaF1SrUq8n2XRJaKsYamjP
31306	payment	2133	2133	1874	1	1	2914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3qwrkrtCqBJ7w7hH3E1PS5CGPDvU3GkPEQNptjQGVWUAmsjH
31307	payment	2133	2133	1874	1	1	2915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZhVj9Ud42V4LZsRQ4kxcaRRcdU2SnyYAhQvbpEVSLwxhJjif
31310	payment	1397	1397	1678	1	1	12504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eUnewFR8kJQ34vxbFsKaec9HASUWTtM3o3mAM4tCPohMFD4n
31311	payment	1397	1397	1678	1	1	12505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7iYRuX9SPUxitRsR11gNqN59tvRCF3n2Ph3dfRL8Stua3FXL1
31312	payment	1397	1397	1678	1	1	12506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFUKfhtXxNQ6rSihzPUfvwanB7UBk8hu5Njzz1WRZ6HYZ6z1p
31176	payment	2133	2133	1874	1	1	2857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wjCr2u1yekyX2x47Qxu5n2ENMiwXaCTbbiGpBsowUWWF3DdT
31192	payment	1397	1397	1678	1	1	12450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEQuv8fvfFuDYhxZuiR6eaNo1zhQJGbv46UnBK4zx2S31hVVQ
31193	payment	2133	2133	1874	1	1	2864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nZrEceKUmfuWoxyyQavmTcBrgpN9JPjaBdCnwemaiVVy7MCc
31201	payment	1397	1397	1678	1	1	12454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FZs3vLwVUVAG6anJazzJk7fSVPazptuekKgrcLkfScMXzwjc
31202	payment	1397	1397	1678	1	1	12455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcdXV23s1NKcJrc3jJqSTJ4ib8jPbZaErt957sx8FGQdEGh5cS
31203	payment	2132	2132	1874	1	1	927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKcV2Hjeq5RkhPdjtzcFHye15vRpAzCQhxfhdZHh25FddQpYn
31204	payment	2133	2133	1874	1	1	2868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykax7tqp3LJC1urYh4AovdXvpPxJELP4CM7peri9E4xrYno79
31234	payment	1397	1397	1678	1	1	12468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd16QscwexNR8Mp5ArHtmwmyYNDiZCyKiknpWqZQAwVkJzuWGd
31235	payment	1397	1397	1678	1	1	12469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97ksvDYDCPDg9qyAGSmEm93iNJq38RaWFWcijcuJP7ynhvzJ6
31236	payment	2133	2133	1874	1	1	2882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9c3ZXF861XQVRJmNrJR7aAvvxUZGj9qxA3BgSYes7ekLL8TPi
31237	payment	2133	2133	1874	1	1	2883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdq8NzZgfKdYyyRAi9BC6wrrsnCtQg4aiQefaM4F6aepE5GtP
31238	payment	1397	1397	1678	1	1	12470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFRrWzhgSCFBJ3AiEqQk7SukMnJd9FsfiZJ2PVZGZrTD8hPvz
31239	payment	2132	2132	1874	1	1	932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPdSR9GKiwSeMqw4UUfYVYX5AVyQw4d5jXYzNVFGkBo5swcM4
31240	payment	2133	2133	1874	1	1	2884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2N3urdpJvkX1nBqfZP3MTNSsYSgM2p2cNQkSGNACupFzE47Wg
31247	payment	1397	1397	1678	1	1	12474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2GJFEgqBi6GMtTxbiKvVUuoJRa9CCfn5jYCBWjQ2R1fKu7oc
31248	payment	2132	2132	1874	1	1	933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnKUaKxonfBWcaLjYBtUc9cVnR2mhAstJqgZDMkxQcdUwtD6J
31249	payment	2133	2133	1874	1	1	2888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqG7vdukUDE2TdVeS6AXq1HMYgAE1KAPoapJvw99yhWTYifjAp
31250	payment	1932	1932	259	1	1	6	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBTrgtpz615cEofo48fahBVHksyvEb2cYEsYnFafYTr4k9xiJ
31251	payment	1397	1397	1678	1	1	12475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NgjbXP2AyfgEdiXG7fYtgBuB4ZYYHXj5f4X8uq6c1JHgJTg9
31252	payment	1397	1397	1678	1	1	12476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41BvFwHC49hR8tT5nix6aRJHdM3Uzv5AfgR3hXUeDTsueVYpX
31253	payment	1397	1397	1678	1	1	12477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJxjUtu4TmmfcLNK3ok7LJXjAemivLB9eZXmWPKPqisnyoFpw
31254	payment	1397	1397	1678	1	1	12478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hYMAnqsmEpe2GRw5pxbtAgx5GDsm3e8rdPyKn8nS62FoZ32K
31255	payment	2132	2132	1874	1	1	934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaJ8Vu2zUuizFropS2w1gEn6PondUS4qnukDetbB2p4WzRhPe
31256	payment	2133	2133	1874	1	1	2889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkxFRNUiYTEvLwUScM3SVAwDuEn1uJHbiVyzYdQodNTb4PpqE
31257	payment	2133	2133	1874	1	1	2890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKjT64YYdquYJrt7bLmVHFZzPbY35JnrsqUmA7fR6RHvnDiwQ
31258	payment	2133	2133	1874	1	1	2891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9WNmDQCBPm8XsmPTricHi1yAWTStuRunRhVqsrLD6CjWpsFc
31259	payment	2133	2133	1874	1	1	2892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wFgr6XGcsCDEmsR8hiMwNmuogwAKJSKTvoUPgqHVM6hcXTs8
31262	payment	1397	1397	1678	1	1	12480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFihFXa1rFkFDUfP1aYVoncG9WBrgMAye3hYKA3J7bgTGwoQfa
31263	payment	1397	1397	1678	1	1	12481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcK42Gt4zYcaZRvp2gLEsrucsXrzpSusLwHEi5vbfP6ZsMrXM
31264	payment	2133	2133	1874	1	1	2894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2CMKH3uRMuwzFyUqof6AMrPsR39hE3NWXDvQVJcyTH9owfTP
31265	payment	2133	2133	1874	1	1	2895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxRZb2xiDbZRPjMnxz824TsKMDKEpnt4UwEBw8PkH2duqAYgh
31273	payment	1397	1397	1678	1	1	12485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUSXRA79NXuUntdaR3bTbJxqVgqMgCC9RLA6D1cfvAkh4oSpf
31274	payment	2133	2133	1874	1	1	2899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3kMCaWeALPpn7qwjufs838BTCn9B9thv3y78WoZbNkahadVj
31275	payment	1397	1397	1678	1	1	12486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cyTAntzgYWjMbjAx1tcg3sn5KmYxDE5XaSdTBsGdg2SYk3at
31276	payment	2133	2133	1874	1	1	2900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8u8avHiezqZe6icXcqiJrtjofgRmjDryNty6vU93kjwmTKtzF
31279	payment	1397	1397	1678	1	1	12488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSav2sfeeBN3epsvdyYnAfquTjM3BYYsApxBtgQdnC4LZ4R8u
31280	payment	1397	1397	1678	1	1	12489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzj91JLm2dVb1PTRsUT5ZuKWH5m1JKLP8ejsCVv4tNNnSPN8GS
31281	payment	1397	1397	1678	1	1	12490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhqWrfEBqDvaK23REpCWCvXqL7udBSHUndQBmZhJ5hJn1N4h7
31186	payment	2133	2133	1874	1	1	2861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPd7EXcPpjoYW2LCG7u27Y6QFb6YxS2cW2icev6bhWKvM6vRTZ
31187	payment	2133	2133	1874	1	1	2862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TuqKVZsiBP1WomdXYGCG9uvNU3EMou2maoJE8h7zvzNyuEf2
31191	payment	1397	1397	1678	1	1	12449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQw7XGWyaLRXpBVgyFARgJArFwwcUi2FWKq7FzDBNtU7qVUVkX
31197	payment	1397	1397	1678	1	1	12452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB9dwCkHSw1qXBEHSpeCd6VP1XA7wZ3Xgywps7P2gJAzSYxDv
31198	payment	2133	2133	1874	1	1	2866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRAShLpKsv64jXb98hpNhmJvegN8aJ2FmYuardnAxazPhfjrK
31199	payment	1397	1397	1678	1	1	12453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDoxhi1QkcfpbK1DezGLeuRNNcnRzvPinVCCRtuj7poTgZuVon
31200	payment	2133	2133	1874	1	1	2867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5ZCJdiQ7K7oKCX93WCRA44ME1uPtdpRamq8fPuWjABfrNGu5
31205	payment	1397	1397	1678	1	1	12456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbw91L3GvJUsXyiH4TbyToLE61fYud2Hqq1XvuyUvQNNZYR2AP
31206	payment	2133	2133	1874	1	1	2869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bwvGse3qNLw6QGMq9bMfQM5Dfx5h4nmPUdF7522dAYk2Wpy7
31207	payment	1397	1397	1678	1	1	12457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9ZfVo8nnMT1Wgx7LJg94abQKHvX8tYJm2hiUXvmqmaBdugAR
31208	payment	2133	2133	1874	1	1	2870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFABxHKjLU5yW3W1iwdK76ZU15tCAChihZCqzGpnK7Ujd6Jhg
31216	payment	1397	1397	1678	1	1	12461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpv94PpDfjEdxuoBFNsNqFFZh2BjxQsyeWgq82ikc85cv2Qt1X
31217	payment	2132	2132	1874	1	1	929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVorjw3KRxmvHJokaJr4TARCkdiWdZRzMqMsstLNtULAx3WABL
31218	payment	2133	2133	1874	1	1	2874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDBbdNmwDq5uq3F24gGFfYK9bftcHoxkZdmpBzYsT9eKDTDvG
31225	payment	2132	2132	1874	1	1	930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXnzhnvGPvttStFwdYNgh8tSxwQbzMzzQgg9dr7qvR2RJaxfS
31226	payment	2133	2133	1874	1	1	2878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFwFK6D6j55dDmd7K3ncqSWZVJ4mAsQPVMVzSj2gJzBMcnJHB
31231	payment	1397	1397	1678	1	1	12467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGh2ZdtJshjDt5ppfCgt6yS1VQfemtYC58EyrLyXvzwbWaP1m
31232	payment	2132	2132	1874	1	1	931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1GjE49wmVk7qJhppuGDDNKTTHZZK1pRBtWDrw3acGDHXTHrs
31233	payment	2133	2133	1874	1	1	2881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKVg83CHWnVDycjqWAJMQKVsNyiUmv5ctz26ZTMEckG8ADHBH
31241	payment	1397	1397	1678	1	1	12471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQEA3NBqvVTVgJed5FnFW7Kmt4p4SZ1EExvoNNBruHJBTJhXx
31242	payment	2133	2133	1874	1	1	2885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCUQ7Fw2SnrzpEK1R1rL2TJJuNLehjWkHoRTGBwwNN4aRxAJi
31271	payment	1397	1397	1678	1	1	12484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSS9TstNs7cwnv21M5THQ7PDZ5oLToWiGut4qKgWim4UEAYZB
31272	payment	2133	2133	1874	1	1	2898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEC5R6JWPQbafq4QRfKgvHsJti2MXmMe2dE1idABnyHdjbSsTe
31285	payment	1397	1397	1678	1	1	12491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbSsDEjR1QqLv4v5Co1gQAkpi9ZThKYrJyMrnN69PyyXrJZLU
31286	payment	2133	2133	1874	1	1	2905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqD2HAHbBLx1sB7um1A1fk3rEeYD8fhccwNVj2yMSaK5CeFhS
31293	payment	1397	1397	1678	1	1	12495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPQB7hPgfer8kAuTDvskVSyJB4d9qujzXZ15HfAEaB9GpyS7e
31294	payment	2133	2133	1874	1	1	2909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8rxY1DWaxvn8J4ty7uYPU7X8z3EDWsW91k9uYQYthzjQ6XxU
31318	payment	1397	1397	1678	1	1	12508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXz4qxD4oqP9Q7PeqXapG2ndPhfgo6fctHzqPfLjrxPfxbu4g
31331	payment	1397	1397	1678	1	1	12514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsnRgTMrSCYVHiWbudJzz63dxrmVCJzW6sv1c532WGY1K7aSG
31332	payment	2133	2133	1874	1	1	2926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9cFFXAJTwxHsLPqMEvbQFr9RTjz8mB62LhcQQZQZh6Pf4L1A
31353	payment	1397	1397	1678	1	1	12523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnQvHm7TY1m43pVm4iYti3E9zfxwYzMScWZpu9zHU4GG1BfGh
31354	payment	2133	2133	1874	1	1	2935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYov7yNdFfFqLkphJjRLfnf2dw2XaaXsrgkcU4rePPr9TPWNmks
31361	payment	1397	1397	1678	1	1	12527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHR8CEZkAjYp8E6K26Nc2NKtUoEGjSvHiCSkjPM2f1DQpBjZp
31362	payment	2133	2133	1874	1	1	2939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AbyMGTn3918mSWZxaeSsyFdHcVnhNJftkihHwq5wkndPjo4b
31363	payment	1397	1397	1678	1	1	12528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbKEW1Suk1pGR3PoPXw3QaEWoQ3VozWz4PgRyeGgkDKUrthLa
31364	payment	2133	2133	1874	1	1	2940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ZXizLevoyv96tAbn989ns2kgjihQGJyKxqckWGxHaTaEXJD
31385	payment	1397	1397	1678	1	1	12539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKMqqiC6C9Z789oqRzRBm6iocDePm3eGA19tvqBFbAFyYhPtr
31386	payment	1397	1397	1678	1	1	12540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8r4Q1t9npbRaMHW12Et8CTvC34opRNWprwNQqum7YAvpRpJF
31229	payment	1397	1397	1678	1	1	12466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJGDpSKRvFh9PT5z6uUQPUpmMnmBHXT5663xjv9JyQ762w9Dc
31230	payment	2133	2133	1874	1	1	2880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eZJZUcHDxdi7y7Yp7HgQQfoxG6MXPcGxC36yU5rSd5KNK94n
31243	payment	1397	1397	1678	1	1	12472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsgpNqDrqqThJ3GnTywz48yVWrrF5JfZ3Y6W67ssHjJpiv8Ut
31244	payment	1397	1397	1678	1	1	12473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6dXsBgqkFAL38G2QxEbkw5qSN8L9r9W5oA87DeidM9nq6zv6
31245	payment	2133	2133	1874	1	1	2886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJw5owpBLQ44AtUKMzCBNTno4jR1BSFN6tcNuA3MH1Zn9tSEa2
31246	payment	2133	2133	1874	1	1	2887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8Tcjzu2J37Dvi81vQLGhyDMXaCc7XVY88gECqc38zopy9VaW
31260	payment	1397	1397	1678	1	1	12479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9G7MQktUiTD1A5Nrk4WKRnQVZyZwTGBVN29ykLws7gsoDw4U
31261	payment	2133	2133	1874	1	1	2893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFaaPppJZaEQi6iYWpzMtEYWvkDfkPHByeA36NtgtqVhQv1ZS
31297	payment	1397	1397	1678	1	1	12497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDwH2AdTdQkWzehnycYSydF3NaVYqqaeppjdYfPGqoSJCQtkB
31298	payment	1397	1397	1678	1	1	12498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxgfoNFg6Ls9yLdkXmn8nBKNvwNVBBuDNPtVj7ce82ZGUm9U9
31299	payment	1397	1397	1678	1	1	12499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnRF3q3BJ8mzBnymKzbErg2JZUfEuKucQe5MZUaQiH6ZK7ZP5
31300	payment	2133	2133	1874	1	1	2911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BsRkVBgsEMQWyZfDshNV58qUh7uqLaLdtPBZ5MDd3HLKwM6h
31301	payment	2133	2133	1874	1	1	2912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ginmesgawvTYwPwKBojfd1xbzmK5RaajT8gqPYdrp3AXpfmC
31316	payment	1397	1397	1678	1	1	12507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZHfpSb3eVhHV9V2eNAZ18JDXUZdLWcUVGEmRR3AiCsjYzpwD
31317	payment	1740	1740	563	1	1	12	17475000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZYr2M4pjUkNewwqb44wngC4aFHF5abqFt45niygHYxqeEgeANr
31333	payment	1397	1397	1678	1	1	12515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrYCyKnzG9x6RRoo4YtvC33DGYYjexuMFSye3Duooej3Up9VR
31334	payment	2133	2133	1874	1	1	2927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZK661ptZ3m69GnJGsaJMKWNNuK9onkgqcLPVagKUBawgzgsbD
31357	payment	1397	1397	1678	1	1	12525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35y8oTARqhMSD13n7xtvVxkMHpegr8v5xPK94rk5SMt61uxN1
31358	payment	2133	2133	1874	1	1	2937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQwfjihC7H52wB7sTiC2CoTJ2cY44BxBcntKg912yYHta4b2U
31375	payment	1397	1397	1678	1	1	12534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GmbWdE7fLLYHNc85Ci69krDrnRvynKeLAx665uFieZ8HpFxk
31376	payment	2133	2133	1874	1	1	2946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSQjsEBJYBsExBgj4VrhJ4d7T3DKjc9PiYQYEvQ1hUMgyGVJR
31389	payment	1397	1397	1678	1	1	12541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsoeG5dmQXgUUkK9QDDY3nHCKv4cpddSwKzZmdfEJ7pT2bNscZ
31408	payment	1397	1397	1678	1	1	12547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa932WLA1QMKf5AsrBgZRLp48mNKVGqEeAAkaeJAsHPoXvgnqE2
31409	payment	2133	2133	1874	1	1	2958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoZrXj6dY64zffpDnRFdRmcWuMQPxWaNnqf2k84Q4SrtnJS3z
31510	payment	1397	1397	1678	1	1	12579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJctU9X9R15jiX6s74snDPCTs8aLDNR4P9a4KPY3XNhZ1qHmi
31511	payment	2134	2134	1874	1	1	3069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWULNkkpMxBQ619G6twTHsLyxGtvvn5hXqhUBxbAxkjrKauf12
31512	payment	2133	2133	1874	1	1	2988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmMftB3GAfPn849CUj8aRHXeTm2NRXGWoaR5veQRU6PRg7Hw4
31539	payment	1397	1397	1678	1	1	12588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYi56hPXCesd2bDCEnHc99jZPTq47q7Ax84SqXHRjFpbkLPdVj
31540	payment	2132	2132	1874	1	1	941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk4BkGDkoSQcc2piQzaVutUpQie5q9yTqwmYsPN6dxmJZ31HP
31541	payment	2134	2134	1874	1	1	3078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYgBUkuymb4rqePFssavh19bK6r877Fe2AKY1G3aMSxrM8hcxb
31542	payment	2133	2133	1874	1	1	2997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9M24GztAEc8VTLdGVgQ9JNe7w2jBrP6ANWEPJPXthhzGoaA4
31555	payment	1397	1397	1678	1	1	12593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJicYB7t3pZxSxYKZwnpSz2ByCiKEdNsBMnfPAxLwpiPVUPgGi
31556	payment	2134	2134	1874	1	1	3083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpdCEDeELAwtwBc5AUhNaWuNabJoCF9QU6YMAzayAZXBuoosb
31557	payment	2133	2133	1874	1	1	3001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9wmev3XGvA89QLbZj1eAH4Y8hvf6WDeGMckULUspRMjAFREc
31558	payment	1397	1397	1678	1	1	12594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAprSoiu1AQ73avX6hshHZ4b5kmuiVMx2UVRHj46hBjUYAFE5w
31559	payment	1397	1397	1678	1	1	12595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNooAmPkzc4zFu1VScGBRfVhtfSDUKZFDvJrAuNGY75YAhYog
31560	payment	1397	1397	1678	1	1	12596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTZNb2EbE77SGHo2JeRuRboNNRNf5R7FE74faegst1exviVPA
31561	payment	1397	1397	1678	1	1	12597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmhtyhZgm5wv5DhYiCKDMpRNvnZnVyiYhCsyaGQVxiv6Jncbb
31282	payment	2133	2133	1874	1	1	2902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCGEaJcQ22yFffrpiS1XCwiyYcFcsFmSCNj11HWCaQvmt5kLP
31283	payment	2133	2133	1874	1	1	2903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYtKvY8axURWcuskHMGWPequJGydaL63UakABzdUt25HEWDrW
31284	payment	2133	2133	1874	1	1	2904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstsJSZg8PKhFzcA8fZkfTzt1Qp5RMvUbb9234NvaUWWeRQ7ze
31289	payment	1397	1397	1678	1	1	12493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24fpDD2PxWbnZxCMEsjwVYsBQXiPsLf9N118Nu22PywJgzLTe
31290	payment	2133	2133	1874	1	1	2907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZVfJVY4GMw2y4S3LVCG27k9MUuF6ZBuXjkfv427ZVP2RymQQ
31291	payment	1397	1397	1678	1	1	12494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBEn5Brfp1e5NMJDGwntzeEpYcoU468NqFSpHsuEjKGVBzSSy
31292	payment	2133	2133	1874	1	1	2908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1k4fAbetDPbukNQGaPYJiijEWM6yRUwVCtgHNMkQoRyqZQGW
31295	payment	1397	1397	1678	1	1	12496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTHmEMTm3Av2T1cTFHVX3BeVczfZCm54g569moLKad9NNJtps
31296	payment	2133	2133	1874	1	1	2910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSSJHBsYakVJx9JQZBjmaBnbFuFYvMvfH62hgruejBa3kTNHDw
31302	payment	1397	1397	1678	1	1	12500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrufY5bBDxmfi7FYM7tDKiFkTonL2CMp8eDp2NeuuhdyKoFN1
31303	payment	2133	2133	1874	1	1	2913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRXMNLMYgrWDc6m3Xr7sPwaYut9zdDvEmyVrBPE7HsdeExPSa
31308	payment	1397	1397	1678	1	1	12503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpJhPV1d4kjNqD73FjpQeuYJQopmNN7jPQ8vtvm3GeMYqXsxN
31309	payment	2133	2133	1874	1	1	2916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fni9i8T9PecBVPaFkLeqNkdV7VK8e1HrYsLzKJVyHTuZzdRJ
31319	payment	1397	1397	1678	1	1	12509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NmPc9jXMUKSbALL2a2TtQ1mWRTZ52qTf9EjVpd2Hy68DQnoc
31320	payment	1397	1397	1678	1	1	12510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MRoPaZWHxV5Ko2AoiRX41zbX5KhaLiQRZUGM4r5pL1eGThfn
31321	payment	1397	1397	1678	1	1	12511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bLXngeUcZLPwcLrwdy812ebLor1UcNX2zPki2E3m3M23amfm
31322	payment	2133	2133	1874	1	1	2920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJntqH7dccMgWJ41NP2p44CejaX4bF9bKPNoS6qw8ei2WAYd2M
31323	payment	2133	2133	1874	1	1	2921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3WCmtyyqnxLLLmG3xt3vmgQxzmyYHg6mX1jVTYz8ox3o1prC
31324	payment	2133	2133	1874	1	1	2922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvkhhPZuAeqfkbwafPeAzaemQpryNF1huuQSyqAHQzK1t1CDu
31325	payment	2133	2133	1874	1	1	2923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERirsbmD88hfofv8SBkkwWfKqFNZit7oxeRYgZke3CFb25sp1
31326	payment	1397	1397	1678	1	1	12512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQseoFjNps1d6yggqWyzMQoUDoK8w7JgMv7KVnnDzRp887bZFc
31327	payment	563	563	1359	1	1	11	7988000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpYWcU38JaCqb6wmBY4doJDkNDcFjjK73ixcvV967dXVZTK52ShB
31328	payment	2133	2133	1874	1	1	2924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zp7pPg2UcyhwzLUPuurGcJUBdhXNJJ5rRGJNnUJa8jB4nBUf
31359	payment	1397	1397	1678	1	1	12526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4TYkttcJ2SvSKdgjfZ4jk8TfKubN19FhD5VEGv9VzBtRfBuo
31360	payment	2133	2133	1874	1	1	2938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf33BJo5m89qr7vBqZAi9PETrF2ZMU9wBoK56zWo6z5ZhBpnt
31365	payment	1397	1397	1678	1	1	12529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKB3pWobwPbFKiaqEvnPLrrwvpJB5NBHr4WuPPGHwTYG92QGx
31366	payment	1397	1397	1678	1	1	12530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnkgw48T4pXmdiczjWGgAiXx1qAyLUnC1tJPy9vAeyKRZcq7K
31367	payment	2133	2133	1874	1	1	2941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbgCzGgLx5ePYTgkaP6tjLmmsKkKHqHUFMdEVThbXkLJ3JfX5
31368	payment	2133	2133	1874	1	1	2942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYb6XMy933nfrggZibJVuQZg64ZCpNG23ydSv256DmwjgPe25
31369	payment	1397	1397	1678	1	1	12531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6N1xJhrrtporhdYFxLNjffY1hMbcdJQarwQMH8zu6LjXbdN1T
31370	payment	1397	1397	1678	1	1	12532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YGDashksdyds8Th78u8YerTBkitUorVZhQJ1pJS1zjpNy111
31371	payment	1397	1397	1678	1	1	12533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvMVmkrdLMm8F2axvH3aPRqhyE8yc1wmbVJAr63Gd1rMpvLRa
31372	payment	2133	2133	1874	1	1	2943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7MBpLRUepciewSgNBw2ecB2LGjqjtcXTEPkfKGaFQ9SPZcJ5
31373	payment	2133	2133	1874	1	1	2944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYMPCbPkM1eJToy2n8NnFXXjr8PQM8esivDM3xF8HamM7XyHN
31374	payment	2133	2133	1874	1	1	2945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5V4ZwTeSS96WPZefbtxugV3TnkH2zdnTgSWuHkvjYspASTdG
31381	payment	1397	1397	1678	1	1	12537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskyvwakXmmPKtsXBQyrdY7n4qR5bwNdfgcJjYspsrR5x2G7Jd
31382	payment	1397	1397	1678	1	1	12538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtKgHBiwSSpoDRyQFtKb3RHfcc6A4WxrvaARGQzBuMF9YAXGB
31383	payment	2133	2133	1874	1	1	2949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQ2LDuzM7UVMPUcoDcuRPHjM793PJF4U2Ttm36egQUMrRuRtH
31313	payment	2133	2133	1874	1	1	2917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6QAR3QsS7iGWjtw7EpYt38xeXcnymxMptkgJ8jZynjJph2rb
31314	payment	2133	2133	1874	1	1	2918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sV8fJbjAxy4VwZTVA7AmS6kRD7CvSom3Qy7XZffXuTBMSxND
31315	payment	2133	2133	1874	1	1	2919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokQLqyvVh5t2vJVKyH7pyGzWShoAJY299246aFhrEKeCXftyr
31329	payment	1397	1397	1678	1	1	12513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJsQ1yvMc9TStCeR8185S5AjNUNDp3Fmh3CsxbirtwU42HzZK
31330	payment	2133	2133	1874	1	1	2925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3Wqs7WF3H4RLjZt8u9FiCz1kpx18cLP1nvDdQz8UXjLpe99a
31335	payment	1397	1397	1678	1	1	12516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4UL44CxLzSPvotNn35d6xaFWTBGC7z2ujtC7HhwD6ELAQpmw
31336	payment	1397	1397	1678	1	1	12517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVJ6AoehP48z3bmeWK7Y6oFUiQgBoguDwiArwH27TWpb3TZid
31337	payment	1397	1397	1678	1	1	12518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xn7PxvioejDMf4PcwLDf35sbFCoF3ZisZuQLthSTgGpJttNi
31338	payment	563	563	1113	1	1	12	4249000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpYcgBmL84nF7n3tYTePFuKuxbz7w47kFvQUcqYSSiWwFMR8BeHh
31339	payment	563	563	1233	1	1	13	2867000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZ16epT7kTgrv59iGnQ3xrNdfhUmQ19jPRoiJabFTCqiYH7Dazm
31340	payment	563	563	993	1	1	14	2371000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZpZxnvsJhLybAEYUCtAfLZ1X4UKAXXDEUVw78b3q6enG5xhnNn
31341	payment	2133	2133	1874	1	1	2928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcr3Ymedo5vT3gj1rZZU265QZ4CVkvFAk6JpR7kgFpSBuFENWY
31342	delegation	2247	2247	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRtJ7NVuUMxXb5HNR4CEcc8VdA8Ey7sAG2abxXZ9tcVmmK7KN
31343	payment	2133	2133	1874	1	1	2929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4fxNxzuJeXYJ7nzJHsJAv6upfhjW2beK4smx9QMY17GdU8Wx
31344	payment	2133	2133	1874	1	1	2930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4rFLiKQZpucUN7hfWgYBm4gnXwBS58AVP8WWA7utYpZFQdV6
31345	payment	1397	1397	1678	1	1	12519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vBBCJeHPAVo3kMThMXFhkQsbybuPk6Jz3JE43nfa9JcgHH3N
31346	payment	1397	1397	1678	1	1	12520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpLJowPwUk7vK9KNchrtRJRVreGYNW2PzYK7ivbFTZZorAGwZ
31347	payment	1397	1397	1678	1	1	12521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX36CbvjrDPco4yjRBAsromSsZ6VewYRAkT3t8UFoYwX2dRyiW
31348	payment	2133	2133	1874	1	1	2931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURXXiJ85XzXUJnhvpWtfg9DkbZAoSRxecH1GMbKHbBGDJoH51
31349	payment	2133	2133	1874	1	1	2932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9EANmTKDLBinoJU3GmVuGDdKty2Xy6RBEmCcqyQMSi8FFhV8
31350	payment	2133	2133	1874	1	1	2933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LKEjdsznk7WSEi7aX1KsWzYWtQ1112juS6HUp9nvzvU6J1iS
31351	payment	1397	1397	1678	1	1	12522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTtTBuhv9Uwbw6e2aiRg5bWeFYEbEmhcv8DPZsKQJCoDYgkY5
31352	payment	2133	2133	1874	1	1	2934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLb8fdm1QHxebRRmpuC3SYhAfvBiSeT4g39oaM4qzRKAV2vDG
31355	payment	1397	1397	1678	1	1	12524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNDGdpMKJ1q7nVCuakHgaYMvJYqipp5o6ierATBM3iSaEFyqR
31356	payment	2133	2133	1874	1	1	2936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeHavrdCrh1buiyuq7QoNvYgVvnWbKxEgMKVB6G8JfZvchUDR
31377	payment	1397	1397	1678	1	1	12535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjgJ1Tz9Tr1mH2RQqCKMRr5HhsNZhcnRtHeptb4w7sexNS66e
31378	payment	2133	2133	1874	1	1	2947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNxTAyhote8QKSYfkoJPaoX9bUuCq5RbR2upRPWmMMVR6R41W
31379	payment	1397	1397	1678	1	1	12536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwUFuqxftHUj7mjs4aNuwrSSFTtEbWdzSSDhApR1fDUHKUFXB
31380	payment	2133	2133	1874	1	1	2948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKzEEPGqP4f2C1yvoRArcZx2R4x4SbR25td6nor3QhD4bcfdx
31390	payment	1397	1397	1678	1	1	12542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYxWeSDhQdZ65shBhtnn15xqQuatzaV2xgRe8ML2HrUZ72th8
31391	payment	1397	1397	1678	1	1	12543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwp9mdwSAzEjRhfxZtitkB1HPb3yGYXSmudZC5N5h9hgRuSjQ
31392	payment	2133	2133	1874	1	1	2953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpndGxZd3RzGQDYebhvHaPtrdQJsWr8D2Qr6mo85a6AHxG3SU
31393	payment	2133	2133	1874	1	1	2954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKNjDfbPrUdJo1CLbCnaRAxdrx93fKmjMvNsGhTSppiNvkp9e
31410	payment	1397	1397	1678	1	1	12548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u61v9228nu5iTjb1t12zFxd6qdLmrRGCha3yQ9Aj2j59YtXk
31411	payment	2133	2133	1874	1	1	2959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Jhw8jr6kc2HJYnU2wH6coQy9mAhwXKVSWdC35ErqJ4GAAvjb
31414	payment	1397	1397	1678	1	1	12550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVqrkJTNvuywYL3BQ1ak56ADfjMXxG3aHu34BrJAgHQtTVRU1
31415	payment	2133	2133	1874	1	1	2961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkHPCG5sC3cBYExEuRPjEVWd2vNp9CpguJwfJX7cXszYr1UuG
31437	payment	1397	1397	1678	1	1	12558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93X7uL34iWpdjvLVPbaRWRvJBKDyFYHoLEtZDw44GbB3JfRyV
31384	payment	2133	2133	1874	1	1	2950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcLS33RmS2ev1ryqk2axBmmJSehZ7tFL8wmjY63WrXujbHhA5
31396	payment	1397	1397	1678	1	1	12545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QzTCzprx7PQqcVd8KQrosi55NoMviX7JWN5kR9sWyzs5v7nn
31397	payment	2133	2133	1874	1	1	2956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnKiCyE1oTE29kX6N5a4ybcT7pnh1bfGwbvip6LR7huoFXSxn
31398	payment	1397	1397	1678	1	1	12546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMajLY6fzeR1KHC9zDEpyJuXe8aHZwu3n7uxsMhiN4fiwHK3g
31399	payment	2133	2133	1874	1	1	2957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9FumFUm1Mkg2Vzv6ybjmYUc483LLi6owhV17EL5Cr7LNb5Sz
31416	payment	1426	1426	1364	1	1	4	9524000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJLQxpS9gtSQwZhUKXqeBgLrypU3Cude7xoeewfTeRQzuJBqz
31417	payment	1426	1426	1118	1	1	5	5066000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8Mztcx79ixb25gZH8DmTo5nnGv28sR8oarvWGPNjk75vg7Ji
31418	payment	1397	1397	1678	1	1	12551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgpstWc4ybPML2gDiNvjQ1TBf2ZBqpCfSqfy6k2HZVTsjdmSd
31419	payment	1426	1426	1238	1	1	6	3418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXkmVDtCEyf1MkafFER9Nnefq1xm6tkm3V3AVPdWfaj8ZgHU2
31420	payment	1426	1426	998	1	1	7	2827000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uxXJcxNSdMQCJexG7mEnvsKti1Xp21rNR3ko4C3cCmEpp43t
31421	payment	2133	2133	1874	1	1	2962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPbe1RNrn9CLw6Nnr3UHSphW9RRuSzdgqZhgzZC99oQaR1gfv
31431	payment	1397	1397	1678	1	1	12555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkYNLtagWCfQH3M2vT4ztoTcps2XMTo8AfY4mnrx5mNVPk7Ga
31432	payment	2133	2133	1874	1	1	2965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2A5vKsa9gAosRpZHK8DMA3geaux8s57xtrtxh29MKjSWeYyw
31433	payment	1397	1397	1678	1	1	12556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYwzi8RNyKvNYF3zSefUX6f7UzarYq7bdvuF6UhuNLUthrRc6
31434	payment	2133	2133	1874	1	1	2966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJMcxo8WyUxJqiBrHU3SNz3HpNECiRe2erGSyH7hsocSwYksf
31439	payment	1397	1397	1678	1	1	12559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzUAsPVxgDrJmZgBrnwN6y2DELfcex8pRUranQwuRCS7rRaNe
31440	payment	2133	2133	1874	1	1	2969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2xtPPErw7CpuRFYjZiEgcBBJMBe89b8kYL3V9TZPV4A2NuT9
31441	payment	1397	1397	1678	1	1	12560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquaZpVCiFLew4K5eh7mXdDUuaMY2Gwe98BmKBkmDBk44ZbnLy
31442	payment	1397	1397	1678	1	1	12561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZZSP8yLBFVQfBdwf64yBTkJP5ZkbkyVrzyGkUKEx5bEJtRGL
31443	payment	1397	1397	1678	1	1	12562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4miQszKjBaNXnjmNZazmqfYiRtm1fsLADQL7Wfrpe7xNdqdZg
31444	payment	1397	1397	1678	1	1	12563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyAinguwcG7GJdQhbRVsLQT3drq5FSvUDpmrLwaPSj3PTNBZy
31445	payment	2133	2133	1874	1	1	2970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVZCmzejzsZFsqGvD9MQ4WD3mxKHJKPTBoL6XjL5rKcXdFNZV
31446	payment	2133	2133	1874	1	1	2971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJmJmp29bFRFMNiboJ6NZFq5Mm4UoXKGZy8B3LyXqofTKQGJz
31447	payment	2133	2133	1874	1	1	2972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69tW6xpX51PQPL7ryaeWbuJiEPab8qHepD3WDqLtWdtw3kRUi
31448	payment	2133	2133	1874	1	1	2973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JnbdroVRMoxrgPgATa2SE9P5So2CdGF5nvAZSBoEbxgkhvQy
31497	payment	1397	1397	1678	1	1	12575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6u1g55fRnhfY9FnCKvDXvCswbgNSCqxPBTgTevPq5xNQbGEA
31498	payment	1397	1397	1678	1	1	12576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7SPSt9ypRupEdx8HsLts2vXfQbzZ6VAxMjrnSHgtsJg1BcKr
31499	payment	2133	2133	1874	1	1	2984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLRCUL52ZKGcFwnyw4ym2txJeWWRedLNcZzVpnUCx7posWvYj
31500	payment	2133	2133	1874	1	1	2985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWrvFedK1B8PETUuL9BkpX8fQTdY2gaHU52rXpzticZdT4DoV
31501	payment	2134	2134	1874	1	1	3065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAjF5oe4wHnPm8KyMn4ti5Q2mjMBL69MNSGeRdqWpCfty4Dfm
31502	payment	2134	2134	1874	1	1	3066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWny8iRdpKPWgrLyEwS9YbWsoFh76B2qcjpQKNLro3ZuZ29ZF
31513	payment	1397	1397	1678	1	1	12580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQWaSw7hYfth3jPZMDAWvExtc3MK8Ay44EDJ6TqkopbboS52Y
31514	payment	2134	2134	1874	1	1	3070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77yofEqNEHJ2rCRC1kTsnUKezy7LXmL4Phpg6XLJbemjLYoTH
31515	payment	2133	2133	1874	1	1	2989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq9ratyvMUEbuyJLpg3weQWGTsshFB22nTCRims2YiDcb6r3Q
31520	payment	1397	1397	1678	1	1	12582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTH6iEK6743kURtos2v7LiBvSF89WioaH5rNPAYRiadHakpaR
31521	payment	1397	1397	1678	1	1	12583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfR4Z4CXa9vCGdwwbQMgchyvCZJHmmzNMeHdhxF2eQMWARTtts
31522	payment	2133	2133	1874	1	1	2991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ6w4APQvBiUFuoaxQdwSN5B3eUpScSdgpmGzjf82NvWXiGvoY
31523	payment	2134	2134	1874	1	1	3072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYaSNmqkmT5ey4Gb98TDdodNJ4FSuQr5b8HurcENVZqrGa4Y7d
31387	payment	2133	2133	1874	1	1	2951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnNy32Mp5Ju4hb5JxKHAaJP9yqDVWNky1KqNN9yooHZ2MYdMH
31388	payment	2133	2133	1874	1	1	2952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjz5EaoyvEM4Fy9kEz53rUZcFF888ZDgCoXyCdWTG5hsfL2VMv
31394	payment	1397	1397	1678	1	1	12544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhpyCadUYEyQgUfHynfdZZBzwQgDoQ2kbccFUxeMezBgYuZcw
31395	payment	2133	2133	1874	1	1	2955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvejpxTNwV2iEyHEwRZUBx3gUBweYW42gXzpqqYBd7ZnxAZBSY
31400	payment	1471	1471	1386	1	1	4	9524000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxro87qoVQtmmaQTDuQXYhkUdiYTvfVM8s4FqXUV2Y6oHkUXji
31401	payment	1471	1471	1140	1	1	5	5066000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFejNqZTbxBaLNV8uVB5w2n17jj99euJrDqtzfbWPkwkjo3VzJ
31402	payment	1471	1471	1260	1	1	6	3418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzScxFA51toRbbZ45UQPJ22An7Wdey4GuZkRAKjSdqbcYotmt
31403	payment	1471	1471	1020	1	1	7	2827000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbrsKp4xE4q3D5vM1macMxd743hujaNmT1MNhUUg2uiZSebEB
31404	payment	1611	1611	975	1	1	5	2041700450000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D36sRmFuVjnnYuFAxsPceHKo7UC5wqB8W61TUZb5Ed7nsgDb
31405	payment	1611	1611	1095	1	1	6	3658709710000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNxRWxuDpePThPdpdywF5Zq6XogFQfxCSb3ekW25ahoX5zqet
31406	payment	1611	1611	1215	1	1	7	2468604340000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbwXKZKVHCv9kWAZeYwR2a6NX38vVme3VH6yuwuSRnAiQeP3c
31407	payment	1611	1611	1341	1	1	8	6878985500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1N6UVuVm6T1gouW9hUVTwrCbp5YdBbZiExzqdoMjV9qDErck
31412	payment	1397	1397	1678	1	1	12549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsgLXNYRCGHzLK7vUEwYWUqGPz2DoEU3ZSsb28pphBU1YqWjY
31413	payment	2133	2133	1874	1	1	2960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BLbM9JnwqXogiEYcXzwQ5sK6Xok13Dve7qPdxbhfvDKauzna
31422	payment	1649	1649	1383	1	1	4	10446000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9u7XemP3L1RAQAknyL71SugoZGx9A7P5E13xkT6PfcYT3PSHz
31423	payment	1649	1649	1137	1	1	5	5556000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRTzANSKj62z3dMSmYQGanfhSwsQT6wECbCFSt7k3EVphcHq2Z
31424	payment	1649	1649	1257	1	1	6	3749000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN73JUN1fu6Mozc871dG9GKk3rjwdBxddKy1owCq7QGBERFhn
31425	payment	1649	1649	1017	1	1	7	3101000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRq92kLGXCCqju6JnBnaSM9zo1vmh8gtyF3UgZ5YjKAcHngKQ
31426	payment	1397	1397	1678	1	1	12552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxcxPrBeKGxpn72Dz5WbDPC5ET5XDp7pHcBHP9sfgCe66q4iB
31427	payment	1397	1397	1678	1	1	12553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1VR9j5maeZ7pjfvSS4QTsFCGewcc5C4AR6hVaEMmUG5semFL
31428	payment	2133	2133	1874	1	1	2963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEjZgsRLLEnEZAA9SJbbVGXNRkWA5gSM5kJfvQM78oVm5pHyB
31429	payment	2133	2133	1874	1	1	2964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE1PQRuBLYJ4UqvDpMzakqfJkJFy3HemfyuRc49cckTVZ48Rp
31430	payment	1397	1397	1678	1	1	12554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aYPMX8MDdRaLaRXAPBSdEhKDJMtXZJStbskVH1ppSv5Z8Siy
31435	payment	1397	1397	1678	1	1	12557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJhNUyFAtbWyLnC9wwoqoj2uRYPSUAhKzuDyZF4YDuonofe6k
31436	payment	2133	2133	1874	1	1	2967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bqNCPKRdCcpzYWxi9ajH8Tc3umppPTNt6kuvwmGesXBHyso1
31449	payment	1397	1397	1678	1	1	12564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBvSgNsiBJaanjLrVNXQ7qykK8dbeEMGA5WfXRJtqGsoj2QwE
31450	payment	1397	1397	1678	1	1	12565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfLj5bKwYczesq3QrdELLBgtggzrsnACxh4YZNyYXcjhtDGPX
31451	payment	2133	2133	1874	1	1	2974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJV4ux7pXEVzeoD7ChaJtTev9CfG9DA54MbU6LMf1DmMVh3Rc
31452	payment	2133	2133	1874	1	1	2975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXymZxQ3PYmubXet4bNj9AHePWBgXyuGWeXvWGsrg5R48xDVn
31455	payment	1397	1397	1678	1	1	12567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TnTCmbSAtcf6k2st6Ue7rCSqzhHrLVAiF8S5idJ9SFVrkKbi
31456	payment	1397	1397	1678	1	1	12568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDw9s3ygLVmeYGvrdScgsdHRSV7b72yBiPorLS9KVZ25BN7d3
31457	payment	1397	1397	1678	1	1	12569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CLbSbePix5PhxzkUi8WGG83RMhRQQckirMsMn3QCusf442GU
31458	payment	2132	2132	1874	1	1	935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntu4RC2x5uh4Eg8Pu2Js36ebHo93mxhLTq1EEbAKAxy2PaKCH
31459	payment	2133	2133	1874	1	1	2977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD4Ab7apWuz8iG5obiPNV1Y51TSDh6E1FWcmG1Ph2d4bUCVvv
31460	payment	2133	2133	1874	1	1	2978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHvWXixdRU7PsgAM6WBJuLyPgmkgcq9uPbvcTy4SPUQQcaiGD
31461	payment	1726	1726	2272	1	1	8275	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4Tq6vwyirsa2rFBxQGRN1XgxbLhoAEBPGkerBQYL7WyoS3MSa
31462	payment	1726	1726	2273	1	1	8276	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYJhVkshFE7Ahx5xYyENuX87bcjPVA6FiHhK2ZUT7LxNjxGwtz
31463	payment	1726	1726	2274	1	1	8277	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAtuspJLkZMXn2vU4sMhqj1knFwD4N1PQ8Kzdckn9Hr6KfCGcs
31438	payment	2133	2133	1874	1	1	2968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFeBVraDFRx4hC1VUn2BwW9E6xaW7UEMZsDGWCAUc4oBYRXDQ
31453	payment	1397	1397	1678	1	1	12566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwyQA4Hj6k76dd98xvRtF1fJboEc1WUgJEWjt859ffUZ1yJmE
31454	payment	2133	2133	1874	1	1	2976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9VYa3d1LENzaJvy26LPhjK4wi9zGZ7UH8JqqDiMKTbtXbVgR
31464	payment	1608	1608	923	1	1	7	2462240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgEHEk2pZ3vL2c2pJJfg6vXCQaH6Th4vdD8UpRos1woqZarYV
31465	payment	1397	1397	1678	1	1	12570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWsBHKsHNZa7DuovPmpvi9pMPHYqyF3JUz8Pi9NZoYUoG47kt
31466	payment	1726	1726	2275	1	1	8278	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8NqQUqCUFP2FB7jjXLhfo4i3YxX56yy7uyhk2BMKFu7fzZbxc
31467	payment	2133	2133	1874	1	1	2979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcHjkHVeyjJg6Srfs8S5ZDKexdz8n9PgdzNCXBGnxAvQr1iQh
31468	payment	1726	1726	2276	1	1	8279	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9Tp4sa9mzKE6byCbn8RM7Ws2NpdbuGApA4Hhf3f3N5zG7QJT8
31469	payment	1726	1726	2277	1	1	8280	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwrgKckeYKzJBBSwg28Z2BKTnCgS4heptXrpFwK5zeqRNYxd4p
31470	payment	1726	1726	2276	1	1	8281	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxQhYz1dHNX1M2nGGpSG3FPuFRbfwcryTLcLXou3hndvMVuc5s
31471	payment	1726	1726	2277	1	1	8282	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtEXjhTVrBhSYKKpUWYkqpKhP9LgCanZiviKeJmVWTYpWatpPa
31472	payment	1726	1726	2278	1	1	8283	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYo4m43FruNZHU9opGV2BRjJ5aKJAJXDP7rHPvZJt7J2XhwecrL
31473	payment	1726	1726	2279	1	1	8284	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLk3V1K2BaYrzxDtSwMWgWycY4bJyf8WtNYndCZReus38juKjL
31493	payment	1397	1397	1678	1	1	12574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNe5jNKG8E3V1HEr2MbbBf9xkkUvZk7FjG4TrZt8wTy1uUHd9
31494	payment	2133	2133	1874	1	1	2983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwVzw69szXigXmTLsU5kAcZ9Vz8DTfu5Y3DZS6CNCYjrSHrh6
31495	payment	2134	2134	1874	1	1	3064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaGFU8CtE7BhF1i8T7L42cX43Lo1DvN37CYeFRJFi6AF32XCw
31496	payment	2132	2132	1874	1	1	937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRk8KvqGpheYo59XvoMMDV1d3No33awiVZSTfwmew6xtAsDK1
31503	payment	1397	1397	1678	1	1	12577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA8Za6pnF2q99UZEZJk7MttT7nNANzoUHpnwTKJMqs2231baH
31504	payment	2134	2134	1874	1	1	3067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRthHsSRbep1t4mJPjoQWeavEzKr1MTLVtPwrGEaVsVEMd2L7
31505	payment	2133	2133	1874	1	1	2986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AtxXJ4VE6mb2uZvp641rWQ79q1JnsB93ntjjDYAcuvzh6LdP
31530	payment	1397	1397	1678	1	1	12585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEtKXAYAYwDM4EFwnaTrCpoY9qYePGSf2PA4HDzHzLcxmsc9g
31531	payment	1397	1397	1678	1	1	12586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMzhgw9QnHCutmKurUhZRCnoGjjcBeEjDyoGhoiLepsTLqxyh
31532	payment	2134	2134	1874	1	1	3075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXq66iKFkvBUSuN8W2eb52b2U98m7K4iymUBc8kpACQdtbGTp
31533	payment	2134	2134	1874	1	1	3076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWmxffNSxivTHpqVg7ayQp5qSPB8mpDiAmmYVo3TrhHg6ALuf
31534	payment	2133	2133	1874	1	1	2994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3rHcHnwpYrWYk7WeLt89LKz2xEPaC9BBMXxQPDBAaM15pDqD
31535	payment	2133	2133	1874	1	1	2995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpyFW4vDNXCv9QHYPtMxScp115z2vy4zFnUrQZCEht7j79jUJ
31543	payment	1397	1397	1678	1	1	12589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkcSov5v16vxrnUp8o9mbfLk5h6QUNv4K5TWpWyyXDcs3x6F9
31544	payment	2133	2133	1874	1	1	2998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwKLsiqCU4cDhk8Z448yqeJMrUkc9vGEpQuGWcZ1usKyfyKAq
31545	payment	2134	2134	1874	1	1	3079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa98cMe1KtZBtWvMvNJEoHq9Zie4ub98jneaAKsLJEnfQhkVs
31551	payment	1397	1397	1678	1	1	12591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGid3hPBqSbG7tSyjYdsuBJ6iPx3Tb7QFZz3hpxfrro9Rxg3Tq
31552	payment	1397	1397	1678	1	1	12592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjRU81oYtKNEAnLaDzBLfLM4GZbdf1nUjgMnGhA6UYZeEGMcx
31553	payment	2133	2133	1874	1	1	3000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqQp3RegK6c5J8EXRi6m7TsKBsbdRgMBdAiK4NoEpakZQALYg
31554	payment	2134	2134	1874	1	1	3082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWA9hxAtcqyCeHX3q9LJKpA68YncnjdHNKsSjT3UYZvydyEb9
31579	payment	1397	1397	1678	1	1	12600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSAY4r8H4xn89FVRvXfLrw6mxvyhLK3DrwKRZ1rYMaUiSypG2
31580	payment	2134	2134	1874	1	1	3090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkZLthM3KhAQRHGK4HrTKPV3knAdP28Fbj3GVCsEZ6XMRrmX2
31581	payment	2133	2133	1874	1	1	3008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1qpAnpNRCLXyCkU2VbHFRYhtGznXELwAhimy4CcQxk883svV
31589	payment	1397	1397	1678	1	1	12603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLzsPACrFH3AdFah42BQkSjxEShen2n9ciWfT4aFngncrV3L8
31590	payment	2133	2133	1874	1	1	3011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnU8Q6GDAXSGGEBKUz569CTXP7oRi2CuD5mUivzhSUW9SLu7X
31474	payment	1397	1397	1678	1	1	12571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3FcogX4KzoJu7R7cCRFVsqnxbLK1dXW8d5GvAHzKTRnL1giv
31475	payment	1397	1397	1678	1	1	12572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtBppNp4whgSTmSMfFG1MTGaMSSrh1vC2Qd4zWEbGTGJ3mdEJ
31476	payment	1397	1397	1678	1	1	12573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkTUShvVFBnpr4puNNQ8EkvTzTVQ6p36UQmSuYjaR2JJC7zzY
31477	payment	2134	2134	1874	1	1	3054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j1zQJKqMJFLu4YLurwLjysf7yGMkcU6yTSNfG2u5RJ6wM6jt
31478	payment	2134	2134	2280	1	1	3055	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LegaqjS4w6fuHwtUYmhRgDtgYkigx1v6Y8WCv2e6BjhWFfrF
31479	payment	2134	2134	2281	1	1	3056	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZG23shDTjgvU2dspyq1jQKHvuzvMtYoZ2HRHgbB6Mpfc4CJR
31480	payment	2134	2134	2282	1	1	3057	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUnwTK7WurjfvWWiBJEYAcsx2LJCtz8YMcALyMauGDTQmR2so
31481	payment	2134	2134	2282	1	1	3058	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64FY1GkLSWwNyaPiLiawnumLof4ukBt2j6d5u61WSxfnVvZRn
31482	payment	2134	2134	2283	1	1	3059	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAJsFtQ52B1h3pSYEN5ZnzfXQsqo3WQcMZ9g6V4W8soGsCmiA
31483	payment	2133	2133	1874	1	1	2980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNVAU66MGam5u8T2pgStdUcG72f9aFQzqZeS2XKnrcgxii9R
31484	payment	2132	2132	1874	1	1	936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxidZZeWo7pjSPiaTTeYXVtHowvscUCJF4tR543LLwhEkP1QHY
31485	payment	1726	1726	2284	1	1	8285	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1BKgPF3byFBCLJgBF8ZzTjKY4svq6eYMgQKUkSGwfSF7LgRL1
31486	payment	1726	1726	2285	1	1	8286	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYuTyK8ps6Ye5c7kKXSNnovXc4BRp85XuAdGdLaY2rLQm1itN7z
31487	payment	2134	2134	1885	1	1	3060	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9bFTvH7Vc7UyM67FMxcyenrmcwQR96btWLRYzDJE15GH2Ap3
31488	payment	2134	2134	2286	1	1	3061	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cEJav1Cvzoj3qpSHT4wJjSzGn1i4MhJQJQFFHfHMqCaBvpRq
31489	payment	2134	2134	1874	1	1	3062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41p3oKB9W9Xi5HjxaLdV4PW8GApEyxnqcajDbfaDWaQzRtcdH
31490	payment	2134	2134	2276	1	1	3063	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5kMSunt3r7h1SJtcZczhRvZXqLfDTske5hpArNfCBGmyZUU2
31491	payment	2133	2133	1874	1	1	2981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzCb4ouXMJb7Uy22yoY6aL7m4CGd6EtDViLi7eMV7kXroSnAn
31492	payment	2133	2133	1874	1	1	2982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6s17Uez7R9QjRn91nN3Y27LTvsbztLHpzcU8afFnWYvKuiotp
31506	payment	1397	1397	1678	1	1	12578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzNZJsBkciUdLCi2qgvQnub5nJc2ALyU6S7mHHx8PkgsAxKRq
31507	payment	2132	2132	1874	1	1	938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJmnP5xjs7MZJeuL2mEvmHYE58Xz224yc82awjuUgtAHdJbEk
31508	payment	2133	2133	1874	1	1	2987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KxkSsyKTB9fi3bKLDUQGiYNNuNMZE95RQ3V9F83ADV6513s6
31509	payment	2134	2134	1874	1	1	3068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hH2tRMTLJr7PNW4XutpCoRV8Wm7RvCepFG47A3KTdCHCxXnJ
31516	payment	1397	1397	1678	1	1	12581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFx5mHkKGfUWSLBj6n2pUDNrCxSxPUxuGZJyk12pdDkaE2tUz
31517	payment	2132	2132	1874	1	1	939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFu3NYfs5s4rqY1zGvuVGnTgr2EmXk2EL4YA5ovKBEyXdgw9D
31518	payment	2133	2133	1874	1	1	2990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7zuHuUDtqVHWE8hnN9gkFeNdjwkZLh9usZbMVxbEVV9qT8Ct
31519	payment	2134	2134	1874	1	1	3071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKwiSaTfapbkUdn6Xaj2svxsix8gn5SrphJe5iAWRdC8CXin3
31546	payment	1397	1397	1678	1	1	12590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbzF4g7c6FxqprNUuAC6MMsExkWzB41xnjg7Kp2EXG8iGi69k
31547	payment	2134	2134	1874	1	1	3080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKazZwXJBLF67kPeDvJnYgeMxEF5o9RMBiSkQq3Mv1JY91smeS
31548	payment	2133	2133	1874	1	1	2999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTtd1U2UHbHmDteThSNMzZUNAMKPcD1pUP5bzueikvVwKNGM9
31549	payment	2134	2134	1874	1	1	3081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiL8iRaMDYCZYw2Mhb7z9WVVDToz5M1fpesr4a97LeqkyWhcR
31550	payment	2132	2132	1874	1	1	942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wwwsLCUwwRnpKNQPPiUDsf2AxiZoa3TEUhjCq2EQqnAY4Rma
31575	payment	1397	1397	1678	1	1	12598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb4JCPEM3dB11SxV7GoMZZTSZAFB95sBGgNnRY8hAxLkt5wpA
31576	payment	1397	1397	1678	1	1	12599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKazhrzfyEGEMFtAbHr9gmbuXNPwsQ6aEoNBo6Dc11kGe988aJ
31577	payment	2133	2133	1874	1	1	3007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFCJqie9FLwVFgwRbmWjnbkYXWoi4oXuYeVbLXWne3hcmp7vr
31578	payment	2134	2134	1874	1	1	3089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiywa3tLAWEs6KvHBJzrn2QMfd4bWeG73Sgsfq6xkEUBkuEznh
31607	payment	1397	1397	1678	1	1	12607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaQXgmsWB2tSeh9tXRHBcsEeLbUjF3TDrr2yn8csratJDVfg6
31608	payment	2132	2132	1874	1	1	947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh41A8dhhGEdrqTUN9qAkTKsdfaSKKi3WA2jJFVznkyWJABQ1h
31524	payment	2134	2134	1874	1	1	3073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ533enGNHbNunKsK7eWQemL1rxoN6bXzyvP5uo5anqKxJog45N
31525	payment	2133	2133	1874	1	1	2992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidixtccBJfVqNx6ScP24o2Koeq8KzuVQNghHX7JeMj7BuT7Ai
31526	payment	1397	1397	1678	1	1	12584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdVUimAZfTPK5k4F6kdfmW5q6CQNG4u711gnFpqatHkkKZja1
31527	payment	2132	2132	1874	1	1	940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbj1QWnNK3fedZ2EhDr5gmivMemN1AQjr6VBKbr3e3tVd1ebj
31528	payment	2134	2134	1874	1	1	3074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BmbiDgJjP6hrnxq9bhgG5A33rDYHgT4jkwuiHWWjHGp7VhbW
31529	payment	2133	2133	1874	1	1	2993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgU76SzAf9ZudgZ6jMpt3X3mc74FbLTz3fyuv6zFKUmUCLzDX9
31536	payment	1397	1397	1678	1	1	12587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kD1Av9J1TwetgWxMGCTGidEUVwLpHTtskkTj1D5hgeD598Zj
31537	payment	2133	2133	1874	1	1	2996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wbWuTX6MHBTVBVtYE6SiZJPbhr4J4iyeK58im3b7nZf7QSfZ
31538	payment	2134	2134	1874	1	1	3077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwErmAun3pFizdWwXLnCpoMPaHPkwebPVABuFqDf9y1NFyJAd
31571	payment	2134	2134	1874	1	1	3088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFWePYvKGdiDGghw7uBxinphKtnARgtpsFuUkLWMtiKmupypM
31572	delegation	259	259	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxdNt9cnYdU1muyQwKDKi7dzNkBF2hTdeasehgKbyassU8Jmx
31573	payment	2133	2133	1874	1	1	3006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzs6Je5b1DQ18dmdSULRuErLY1Z5bpGGLU91Z8T2JWfoC6vV2
31574	payment	2132	2132	1874	1	1	944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZKfTmnhQAacUvcq2ovQuSBUgmxhzWCoFQUk4cJ5ytdpNjZWv
31586	payment	1397	1397	1678	1	1	12602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCt6Y38ppdxTWiKAnrpQQRhCLdgYr4iYtVCCxQyJPRCxAWTvW
31587	payment	2133	2133	1874	1	1	3010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLRkaMDr5xm6TqerucfrqVbbx5eFCs4bhSyMZBnMAfs7ade4G
31588	payment	2134	2134	1874	1	1	3092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLeteBSYdcBndE2LLzixn1T7U566mE1ud1b7pVad9VmU2CFbe
31597	payment	2134	2134	1874	1	1	3095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQR9QnDCeUbrKVyuqqznUYxuihh26qrbh1Zdi95N86myQ3Py8j
31598	payment	2133	2133	1874	1	1	3013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprpJCudS8Aefbadnv6QykajDFmmwcW8VZiJQ7vGihGZQj6ua2
31599	payment	1397	1397	1678	1	1	12605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcLajYYF5UjxEHRZWBHSk9CutSidGhT9PsE6saQthEPhtNm7z
31600	payment	2133	2133	1874	1	1	3014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhC69wKCjFaxhbWdfycimSefwKXmuYEeG5oSdvjBer9uW1gC5z
31601	payment	2134	2134	1874	1	1	3096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsokgLSvv99LfxC8RGumzDMNusme1BRf6om5DN6E68gjQhMUav
31610	payment	1397	1397	1678	1	1	12608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSddh7sQQMeaH4udDMgg3GDUkj8wbAZPVJDMSbMrNWg3WpSsAw
31611	payment	1397	1397	1678	1	1	12609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA2MViJyX7vU1bdBMznT5ffSqs7x35fC6pq1tyMSwBYmityjF
31612	payment	2134	2134	1874	1	1	3099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8foCkRReYz9N51fn6h8J4LQWgxGUK54Aopza1bJuWZLwwpNr
31613	payment	2133	2133	1874	1	1	3016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU9KyRGWkEof8wipabnjqMeZeWF5EffKQ9UoqY3BTKQhUZx9A
31614	payment	2134	2134	1874	1	1	3100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTLu6NKyEvpgiQFucpurZTeyWpnrHDxQZpMx6aQgoz4mvQJNi
31615	payment	2133	2133	1874	1	1	3017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDay2hE3cx9wrB3CHLCCApRwwuV4BeVaVAeBswvsWyx1qGVfbp
31616	payment	1458	1458	1323	1	1	7	8296000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZSc1jUXcF9s6soZGnKhWHsb3oCr6XzNbteDkC3eUNtLnLPhSiZ
31617	payment	1397	1397	1678	1	1	12610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNbGRg1GkvMugub8eSfQjNEFWBEGJ6z3Tb2dvu9BbvCGUdnTq
31618	payment	1397	1397	1678	1	1	12611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ8Wmup8UnawQWwg8X2cJWGCvW6V3b1jf8C9traULbWACTwaX
31619	payment	1397	1397	1678	1	1	12612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLf1Z5M199Qk3i5fFWdH2tgkWsdLjH3jwXeT9bA1ddHT48K5xf
31620	payment	2134	2134	1874	1	1	3101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStErZxBEA6RD84hvmuX2Pmy6uVYu5zw24LXcNqCxE9TUTH65p
31621	payment	2134	2134	1874	1	1	3102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRn3bMqF7B97UC82eDwCmMB2Ych2p26CiocKRhL1fZDzDDT5ie
31622	payment	2134	2134	1874	1	1	3103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3fS8D8Yt7Vh36mbCiztoQL5tcaL6zS85RrdbizFSZMQ1Rycc
31623	payment	1514	1514	2287	1	1	0	20000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3NSNZ1Pq7EEdUoov7WUGQ9s8K9HReJvZXGiZULtMtJSH8tVd
31624	payment	2133	2133	1874	1	1	3018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4awmFaNxdix1fWsqRwasMiiTTYgfTSyDBTc79kJmdef9ishn
31625	payment	2133	2133	1874	1	1	3019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSg3rPTfYHDspQ3HNcQtBhMq8pqxMNsF64EG5Z66Yq8nir4FUo
31626	payment	2133	2133	1874	1	1	3020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJc4J4qCvw6ejmQs2nCEchaQmau79CwjNAMfCdcHHznT8RpBd
31562	payment	2132	2132	1874	1	1	943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTPvGzESRZUwt6uUNEB7NoEBUy2fWMrvLif9zi8mM8mUefsSu
31563	payment	2134	2134	1874	1	1	3084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTHoFH2iypQ6dopvxchvDoqQ8v5FQcuJjgB94VHLhNsfPyyHm
31564	payment	2133	2133	1874	1	1	3002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEAa5nBFPvNEhdPkzaY6uFiyQaieh2NhhjtAU45ci9P3hDBKC
31565	payment	2133	2133	1874	1	1	3003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLfKsgz4CeLjdeJiCZeAgnpifSNbgXE1XFgWyF8yhAz49eBjS
31566	payment	2134	2134	1874	1	1	3085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSVyfCaD7bFov9tJnaanqt4EJsZmv2KHFoX1dX2REZqBQjph4
31567	payment	2134	2134	1874	1	1	3086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5axiXVbuZ66MEAAEyncMHfH9DpQ9cb8rpfcNMrNfSP8kev7y
31568	payment	2134	2134	1874	1	1	3087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6GfsX1BeBvYi2PTAcpgXSBerEu5XRVJqRotM51jqmSaWkQsU
31569	payment	2133	2133	1874	1	1	3004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8zkxY9PvVgFYj5iacM89YNfCrWDmPXwSAJ285PbPoCBxqHqf
31570	payment	2133	2133	1874	1	1	3005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGR7F6sWUgjkYiq96VpGYkFZduBgGohzrRiAGV9ig8AFruVj4
31582	payment	1397	1397	1678	1	1	12601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcfz93Epj4WrbSAMntxrCU8EEAm2j8RP1jQP7pyR1XCd9pf6a
31583	payment	2132	2132	1874	1	1	945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNemsFE12oRMQUaoS12Xncin37bM9Erhpdo3dvcgBLPDVEru6
31584	payment	2133	2133	1874	1	1	3009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLcDPnSCEJavi3wgQVecQPn83YK9jfk2BxtXEMRYAnXUqhuzR
31585	payment	2134	2134	1874	1	1	3091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gbG5q84oiHCGUF9gPGy49mysstg5ZWfKFFQb2w8CMtTPEDMB
31628	payment	1397	1397	1678	1	1	12613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTNpECMPDPGRwtc7AvyyL1xup9JxKcnY7mSovL79Q7kyYWwo5
31629	payment	2132	2132	1874	1	1	949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVtvjTU7NvRkv9aTrWpD7e2JLkPEQZBkPxNFUHGb7Lj5WNdwC
31630	payment	2133	2133	1874	1	1	3021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TyXB6dqs3sjkg7aMppGBbWs4qSAB2auyJLnGAY38sNJyGYXx
31631	payment	2134	2134	1874	1	1	3104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1G2JaxKctxHbFsaKUfQNpkxYEaJtcCnNyowchByYaSspBaj6G
31642	payment	1397	1397	1678	1	1	12617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pYheXNa4Fyv2TfXqcJVocUXb7Lv3ZczfH7UGESANMFXS5atM
31643	payment	2132	2132	1874	1	1	950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfEiJP4439JhKtsZDXrHvL7QTv9qah8qKSPggqoujzDJgmQxD
31644	payment	2133	2133	1874	1	1	3025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSseiGgGehrFApkQ53C5KfC7HVVYa7eQqcLfBBcvzyMDr7W7jW
31645	payment	2134	2134	1874	1	1	3108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1BMLWt5WbJnJmvX4Y5Qd7n21XCxNGW8XrK1zxqS3eth7DKQV
31649	payment	1397	1397	1678	1	1	12619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowfaJ4cS4gu2JYnH2jNFNM7PN33j57xJ33UjLdEuiE8K65uWy
31650	payment	1397	1397	1678	1	1	12620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEr1aaXEcdimzBREvbbbKNVxSRPRR3AiseFqm4VdwWMdLa8Eoy
31651	payment	1397	1397	1678	1	1	12621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6UXyL7seWMwUW9PTJyQ6mb8h3LDrrXxyEkxFcMnibQAZepYy
31652	payment	2133	2133	1874	1	1	3027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREq8YkPHAdvst1MdxFH1Pf6DvWTsN7VNvAnRB2fFhrraumvtN
31653	payment	2134	2134	1874	1	1	3110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9B2fSZuac1adRLSUx9QWLmwF9aLCqtGns7RxJBTQbFqsRWPo
31654	payment	2134	2134	1874	1	1	3111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVXeJDgEf4nap1dHMmq52iuZaD1XsxCVLaBmoxFVagTHSdNe8
31655	payment	2134	2134	1874	1	1	3112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDapatb4iPTGawhhmQ3JsMKKVYmnHPMKRrUPUBag8pQer1UBZ
31656	payment	2133	2133	1874	1	1	3028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrVeguBMVQqCh5AaFrZERVoPayag11xUF3C3bigzwGBcn8Kh6
31657	payment	2133	2133	1874	1	1	3029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwsmRehw8Yr42ACnfgVcYQYd55mv9uqQmkh9ugZgm5WhdY2Zh
31658	payment	2132	2132	1874	1	1	951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQm56E4mkVUZZSmNex3G7YusbM27dXJ3BWoiLYRAkMaZLotat
31678	payment	1397	1397	1678	1	1	12628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1qinGjpNaD7oSAtRZJD9UydXt4t35cuoxTTyMsbKogzx4QTs
31679	payment	1397	1397	1678	1	1	12629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2Hs1jHcV95sRFVGA98A3taGxtjcA5iq2DcV8yxV9cuBXnWTe
31680	payment	2133	2133	1874	1	1	3035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChpAPH3QetKrEEYn8GDZDRzigNXSKfeyzQRQJ4SnksPQ7ofH7
31681	payment	2134	2134	1874	1	1	3119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpuySk7HTgfSVkXJ7iRYxQYC2dX8XdYwGCEoi1rKwqzsbWAtg
31682	payment	2134	2134	1874	1	1	3120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ77UrK6FpUWL6wBSp9vLKCY6bVAHH7XpaahkuAfc3XEy1PGj
31683	payment	2133	2133	1874	1	1	3036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEu991oJmoW1jB3hX4AAnsms1oRt8R5jeoyfFDk9R7mEhyLfQ
31688	payment	1397	1397	1678	1	1	12631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHiohDoAiMvJMCtVaT7MtLcFZeBXqpP3nSHAJBdoGgmDmj7GR
31591	payment	2134	2134	1874	1	1	3093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4h6Fcm6PbW2zjaW8r6Zx7VNPoji2Rxu1ts1sBZVY9AN2F9kAu
31592	payment	1458	1458	957	1	1	4	2463000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZakxnFs6ePGVYDotQ9a2gzoF9g5UJ4MjuoJqKZnb8ebzafLKVZ
31593	payment	1397	1397	1678	1	1	12604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t4rV8b7cCgn2MQCkkmqoWHWQsbnW6rcF88S5i3TXYFfif8RU
31594	payment	2133	2133	1874	1	1	3012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCeJaBwAdbtNcXSpjVqBsHJ1hHxbSr1fcmPgLMfEQYk6jNqxq
31595	payment	2134	2134	1874	1	1	3094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsjdyTA6ZcFogHAVtaNQbX4EUzorAPPf5ibEStajZ8jnWnoj7
31596	payment	2132	2132	1874	1	1	946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsu2UeJiT9qMEgiFZJB2WmgrwZy9WuJqfVjwENVUNnmcqwY7x9
31602	payment	1458	1458	1197	1	1	5	2977000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZyGDt2QUEgTAjvwMZBYYHRaNdqKAatjDrpyuoG1kCMXQjtTCEj
31603	payment	1458	1458	1077	1	1	6	4412000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZ8WmEXUGXy8hsyVnGSjRHGZve71yp3FZCtR5rjZDyUDuuT4gB3
31604	payment	1397	1397	1678	1	1	12606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwds8Tp79wtPKV8eN3FbGqqRZJtBGMX3E4nKRYjLxGVcpQNfLC
31605	payment	2134	2134	1874	1	1	3097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5kJhY1gxaoNVDQ4mzH1jFK7KjgKCgsByacY9pXa1Faf8gcHS
31606	payment	2133	2133	1874	1	1	3015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hJdhxoLSsVBdNxKeZyiJPz5GdGoPDHuBWtHsTe4vcvH4aFrs
31659	payment	1397	1397	1678	1	1	12622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdazYfz88UsyjZ3WChXcbrSWqZgV2kaXdtJueeZoyJ1Ja1V6hf
31660	payment	1397	1397	1678	1	1	12623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EQJrTDBoit9kEnvZi4LFxGTv2WSpbA5DWqWnCTauqh5VyF71
31661	payment	1397	1397	1678	1	1	12624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2Q5F12qCkG6P2DqMRX1mg8FYYryUUh6WknkjzMbcMZbr9dLX
31662	payment	1397	1397	1678	1	1	12625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6P7aNr4r51s4aSjpDHX4m2pUp2ueVBXVRzvRycnFquUEjfxr
31663	payment	1397	1397	1678	1	1	12626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyfpRMtTFYCH6x3JpA2oAiXoWx4u8VNWpS5JW84E61ZCcmzNa
31664	payment	1397	1397	1678	1	1	12627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNLuniSqA5nM3zsZKX4W6g11dNvwdsNyc2PSwLicNGwSc7WaS
31665	payment	2134	2134	1874	1	1	3113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYfXtZRv39dwwTCcsKiSJ2sroMcSMnQ2t98sT6C38DG8ssGZ7
31666	payment	2132	2132	1874	1	1	952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqDEHMhpvEjd4cYikBWBvH6riTaJnoqMer2jrLkmMwkCjebp6
31667	payment	2132	2132	1874	1	1	953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9vfbUgLD3hr7VmxBZGcAL3qqcsRyERRRAvB4CXPqeToxFeXJ
31668	payment	2134	2134	1874	1	1	3114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ipnWtCgo6N5qvWv5ueJ2cbqnDuXB7jHNmYNU1oVuehrfPmTt
31669	payment	2134	2134	1874	1	1	3115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Yd2wP1awSftkvM74phrFS1WMaXpTSayBd8ZvZa7qNXLrdRg
31670	payment	2134	2134	1874	1	1	3116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZaxjE53vLv7sFhagdFbZhYkSadvcyy74V32H74pZcGbntG3jt
31671	payment	2134	2134	1874	1	1	3117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3ZFGYjdeoCcF2QNmN9D4Hv7LVSrZzXHyyz8MmWehaxDsKwYm
31672	payment	2134	2134	1874	1	1	3118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXuDp9wC1NyUi19gNSDx3HVqGYKcGNWaKH1x9o9hhNL8koHWc
31673	payment	2133	2133	1874	1	1	3030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCyWyc8XqCyPBaCq26BbHYgRzQ47YN9Fvyawo1xtuZ6mU7WPZ
31674	payment	2133	2133	1874	1	1	3031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiMJ6RS4SWM2FdDiRJM8Q18czXdQ5eDRioFcGgrxm6MqhHy8s
31675	payment	2133	2133	1874	1	1	3032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNtQD2wjs1zkKoAJpTgjy7Sf7sBajifTuy4RYM7oemKnSWjez
31676	payment	2133	2133	1874	1	1	3033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPURw94MYDNiqomDhKSKCquohLK7zTM8AgG5unLvXy3baLYr9
31677	payment	2133	2133	1874	1	1	3034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuccrwgjMvfthNke7ToqxpMhNKrYsrQC3Dm9PiqDx2ACGsaGZ
31732	payment	1397	1397	1678	1	1	12644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGPXAVN8VWC4GXT2bVF3yNjbj3F5eeCD2JfLk2HQjKXvxvWCe
31733	payment	2134	2134	1874	1	1	3135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TkRMQXwd92aDUWZPhBEEXQkTrSZcrMh76Navgcej1v2BGB8Q
31734	payment	2133	2133	1874	1	1	3050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzrJoXHYcLYMVz2q8fF8iC6of5wqVnc4kzwFAq5w5yruGuqV7
31746	payment	1547	1547	683	1	1	7	287000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZpb6snricKW4zdjHq4ZmZttWUzJ3YwPSMn1TsdmaYTUTCdg8bj
31747	payment	1397	1397	1678	1	1	12648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HmwfDsFgMGQ8Gj6XD8cQEHoU9M8ZeaXnX8h49c6dV6AybCog
31748	payment	1397	1397	1678	1	1	12649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1iSE6Bzq3z7PNEZoSJFtgDgVrv7YhoknYarqhZVRuRiiJJW9
31749	payment	2133	2133	1874	1	1	3054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmvTvJe9FeL6khiLh6S41tjHwgsgwZqFj8qaCfRDthgGaXJZJ
31750	payment	2133	2133	1874	1	1	3055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkY9QBszPxhs7SDqsT9syhX9ETZQeaQJYHwLxeGxZQ6vM3BQC2
31609	payment	2134	2134	1874	1	1	3098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqbDytJ57eQ1e67dwN4gtK5b5oJEX1VC11Au94qidDbkU6G3k
31632	payment	1397	1397	1678	1	1	12614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiG8uLj3pjQWwpNQESZcR827aCW2yHiDyf5r7Zne1RcFc7MCS
31633	payment	1397	1397	1678	1	1	12615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kMy98XBc11BPM9SCi3bbZT4chhBc27hMRhD4Kk8ZFSneWq2c
31634	payment	2133	2133	1874	1	1	3022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA7RegLmNUqiqAckXMZWzfRhSei21tVcymwLjQDcgZMJeTh4bv
31635	payment	2133	2133	1874	1	1	3023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bxni5KVpeKuHSqXpoPBAHDL6TLkkcChzrP9WjcsL9aDSHKNn
31636	payment	2134	2134	1874	1	1	3105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAENKh3fVsdfgqkZRcDP3mzwx5gdoMKrXz6e9fybbATbVeZMeR
31637	payment	2134	2134	1874	1	1	3106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHNzNzJBW5YDbeeCL26FWhXGb8Szr1r71CQAc2FS4JDVC8Run
31646	payment	1397	1397	1678	1	1	12618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiemRgQQ5s4GMzmHDat7gxwfcUD6tDVht2evu9ULYm22SefWfS
31647	payment	2133	2133	1874	1	1	3026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aBy8KfTx9PULVn8N8D9AdVK4imEW1t9LHf6vvp2JBRGujLBD
31648	payment	2134	2134	1874	1	1	3109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizdJdvZRUM7QvqGCKt5RUJup7Zkt2JYgnxg82ayx52imsijYe
31684	payment	1397	1397	1678	1	1	12630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9BhUjQMp2FPQ14bg8RJb9kQPhURpv7i8ndLu5U73Cx4N2DUq
31685	payment	2132	2132	1874	1	1	954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCFzQu9mYQEfjHJaEEUoKfgHdKU4ecddpEsP1rXeaZeNe8WoQ
31686	payment	2133	2133	1874	1	1	3037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR1hci8NMEFjnPWZ8KQg8JdsXwh9JiGGji8TxHgzJXVxJAn2s
31687	payment	2134	2134	1874	1	1	3121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8eWsWEKrGR3TV1LDzcsNrwXS4WR3GnQh8GcLzSFG32FFJCs
31702	payment	1397	1397	1678	1	1	12635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsmzcFdqzFx4578Zhx35sUTXyyEs2C879wuNHq2qg7fn3Vu1B
31703	payment	1397	1397	1678	1	1	12636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHdssGWj6v8WwG6M5dPKJcsG5AdyvgmSjM4GbtPFbT8T6G8Rz
31704	payment	2133	2133	1874	1	1	3042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89R7HpFsn4v9ZcDJqPMsPzwvELJPcNXfvhWpTbYdxFYx8d6Mj
31705	payment	2133	2133	1874	1	1	3043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZLYTNaxQvB8dSWnW9h85MTVxhuJMa9wEKnJwHb8cPomASvyG
31706	payment	2134	2134	1874	1	1	3126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9VTGdbrDKdGwTRFF381koL6zbDmZAtGTbGAdQSD9rsouZSmE
31707	payment	2134	2134	1874	1	1	3127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxPRpu31kuq8GwRhsRbiL3a1LTvXNDgzgQCEg28U1bskA1xdy
31718	payment	1397	1397	1678	1	1	12640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLRB3Kb98VupoH6sN7MzQHxHvcVLifTsxexS9YKAAxziYcUXW
31719	payment	694	694	2288	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8s1WrzcaSdHGJzCK53Jj5pVXmAJZCvRHtvnxCQsUtoAUd8ue
31720	payment	2132	2132	1874	1	1	957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdbRYzbNn2zvVNAfRgyqnPJVP6Yoh5e1Zu28LBFLdhfuj9TZ4
31721	payment	2134	2134	1874	1	1	3131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmoJx2PNGAksooYDxiKSbmYs3ZeQeTc6xfUHYLgUfZaCs3Aq6i
31722	payment	1397	1397	1678	1	1	12641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY6V1CX4ErRyQeVSKHjTN8rybpKVWwPDHvdeWDU9V4XH83RFs
31723	payment	2133	2133	1874	1	1	3047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n5WZteVQmg1kaKmbPSrMqdSChVrs8NXey7pdMKBLWGANQfGW
31724	payment	2134	2134	1874	1	1	3132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XxxEdKb9Hiwgnu3u59DuhCy2qu5CHFDnvJyDgubkTif88W2e
31779	payment	1397	1397	1678	1	1	12656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5i4XC1hpW6Whu6FM1ehEg3HPWvpBGYQwf7X37tjKbU6MMLXMp
31780	payment	2134	2134	1874	1	1	3148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcvQ66f4nKzGsHn3pimPwETonCc96FdjnSP27aTSmhK2CA6f4
31781	payment	2132	2132	1874	1	1	962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuKTkQWgTSt8YZ7ic3exoP1kvbTRgBPBP6egfVJCFzAzAbc3H
31788	payment	1397	1397	1678	1	1	12659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVSiWnXzS81mP7PQbWeszpS72M5LaR5dDx7uhd8wjF5jytHtP
31789	payment	2134	2134	1874	1	1	3150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsV3gaGpy9jVhaTRfCYvdnSXRNgRg4bzp1tUx1Cn3xG5mHCYS
31790	payment	2132	2132	1874	1	1	963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymZMYKYHTniF5YYkx8vebg3hzjc2zJSRjWQW4UPz1s3PkB7MZ
31791	payment	2133	2133	1874	1	1	3065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14G6AVKutdDcAp7jAuWqg4krxwXmYZhHExkcXvU22Q2BtaVmP
31798	payment	1397	1397	1678	1	1	12662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsdXDMBaLtmgpKvGb6owJc9xAtgwereLBFK8jkJXs5YBGnfv4
31799	payment	1397	1397	1678	1	1	12663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WtFWSEz8iCWJoYGTk7KLeKLEwYRvFfgBcymLeCd1uir5WAuY
31800	payment	1397	1397	1678	1	1	12664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6rbpt5jWkXPAiXx65unCVdSvFBGUP9QNkKpaqrnWWRk3pkGF
31801	payment	2134	2134	1874	1	1	3153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSS6Ps9Cok9Nexahr7e4d3EuVSYQXtN5J4e4wZSroEEvdaBYU
31627	payment	2132	2132	1874	1	1	948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLT63rRxjZ31gVW1iJww8fM6mJRZBNTDriXumANLwd1q3dpr2w
31638	payment	1397	1397	1678	1	1	12616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5v3Nh4UpWTAnA9SnMPFpD4g46FgcSEBv5FhKG2i4MEm1aUrg
31639	payment	2134	2134	1874	1	1	3107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGhPPBtoqA4U6HsyULN1sr6u31HNSmAhN43kfkL6Fd6BGN8Nj
31640	payment	1514	1514	2287	1	1	1	700000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQwao3kqNW4btxRwNKN8EMKvMo2qW9YkTHFaJ6Xgmu5ePtdNx
31641	payment	2133	2133	1874	1	1	3024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVxMZLEAaAnWE8Daa8QZwAGYt5ERVcWkr6P4LjoaWauLCL11j
31698	payment	1397	1397	1678	1	1	12634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVVX8c1kevHsP4RX4riztw1jjGTJcrMZmA7jFcoi3Af3eAbNr
31699	payment	2134	2134	1874	1	1	3125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgze29fgQ9fRrJ6oT4RSF5GEYLsHTSf47D9cRQuc1EX5sDm24
31700	payment	2133	2133	1874	1	1	3041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGA8EsLbTPRDAfKg9S6iYnACoQM5vVGj4bhHTPoU5o5mwAhB9
31701	delegation	2287	2287	1514	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpi6Aa7LN6fxCZiewvWkzfEBxkyJsKtisMhkmk8SATTzTHpgo5
31735	payment	1547	1547	683	1	1	6	1000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa1WXUfHhXpX5aokMxqDH4DhtSBu6gAinkRizBjnUVcPusz6MCv
31736	payment	1397	1397	1678	1	1	12645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkvzS7125a2qrfnScmi2AM7bJSmiYEGXVrHHchWhDteEa2cor
31737	payment	1397	1397	1678	1	1	12646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN442JWMkzj1Pd7VZZXFEQ3qJXsW7HScgBwoV5NQ7Nc2gRpXf
31738	payment	1397	1397	1678	1	1	12647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmtCKKfLtEmDQ5j9Jh3uPTuDdijqhZuJAQvjk8zLa3c98g6tz
31739	payment	2134	2134	1874	1	1	3136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctHtBvYMJByzDXQXtzfAp1r4ujgEJCKvR2RWeDhBpdigBAfeB
31740	payment	2134	2134	1874	1	1	3137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD26qgTzqpBwD7tNkRtNBhmsw5XtxfPifMKtQuXfWbgoHoQ4V7
31741	payment	2134	2134	1874	1	1	3138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfqbuGvaQCKbEHB9vJeojMWrbUj1PoT4NfKVLv1F81RVbBDiv
31742	payment	2133	2133	1874	1	1	3051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQSofAQdyhJxS7kNt1PhhkUvVXC72p8FuCVnNfwcKkPbqxm1t
31743	payment	2133	2133	1874	1	1	3052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSejxRf8kYFohBMwsvepvVVbNT13BKyy6nexnyhrbga8CyRvPA
31744	payment	2132	2132	1874	1	1	959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpjBo2UXrcfpYjLnmQ1hs6NJaAk8bmE7FX9LHKEeBobesitJH
31745	payment	2133	2133	1874	1	1	3053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNMbmiVVJfYSiV67Boii1osJdx2ejhuDmbTETvCJWXPbSFuu8
31757	payment	1547	1547	1012	1	1	8	2189000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZPbqb6iMT4vqQPya225yXMCHkPjebnCHGCoUnU4drKCPMnFh1M
31758	payment	1547	1547	1252	1	1	9	2647000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZckufkuMnkbQTxPJCGt19VDCUDTJoqQZratLEqmBonS6YqCu3c
31759	payment	1397	1397	1678	1	1	12651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCYoaqkYjsDWSrVEEKWBRsqzgDzLFqtgv9jggCj7ZBv6fBdPF
31760	payment	2133	2133	1874	1	1	3057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiJ4uD9nHQjC7AcPspLkNr6jausc8JCaadWs5NZBn9CsKwP6q
31761	payment	2134	2134	1874	1	1	3142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSxFRNsAzZxB1msbYPsx4tAoysa3oxsY4j5J4vcz8Ce2VF8Pp
31765	payment	1547	1547	1132	1	1	10	3922000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYqKbBqduq23kuefgfzrZtCDpr7xAm3QTCXoUEUEYeMQipNbUUk
31766	payment	1547	1547	1378	1	1	11	7373000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYqUDGo2Nb1Md6wuBoMz8GXRjPmAYgCX7uWRwLVAy4fiVTse5Ls
31767	payment	1397	1397	1678	1	1	12653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixazzxjWr5jYuSFve6kcgMTwvf5yRHnJhr3WAkJooUx79ooac
31768	payment	1397	1397	1678	1	1	12654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrWMJuapANKYj1NCxDV6QH9xYne6H3rKLXhMBGaoiT4tHKbBo
31769	payment	2134	2134	1874	1	1	3144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAkSimhkHugvBGYdTs4S5iZG2wdoJ9cR223gJcKD2gJz3Pyqr
31770	payment	2133	2133	1874	1	1	3059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRxtL9FJvcmpkoAFgECgKjVQibHXEeKVyDiwgnsBcomqM64kP
31771	payment	2132	2132	1874	1	1	961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GnrDHq9T4oFeGRmCNCekaap9pTuyvWirA5enaheh6ndwYeET
31772	payment	2134	2134	1874	1	1	3145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wDmbRDqjwDUGMkpZBtJsRhF7RXfbTgbqk55X54f9mN8owL4U
31773	payment	2134	2134	1874	1	1	3146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3B5Yuz66BF67zXUPnFw2KdQ6o9AQKQECFaAhny5Ajab8Gq4D5
31774	payment	2133	2133	1874	1	1	3060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7BVMc2NrCpRSLGXbiVAZAetyNojer4H4unBwiqQMxgokSwkD
31775	payment	2133	2133	1874	1	1	3061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYew2sbk55G8YpzaMnwSh6ZV758EAvhMdKNsiNU3578HyKh7Fsk
31792	payment	1397	1397	1678	1	1	12660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vHqE3apWvRpKsnnBDzKGhi4tNEgzJuzVY766QdWmruwkzj1Q
31793	payment	1397	1397	1678	1	1	12661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKWXenkFoLtDYGMRD37oMfycNGVSYLYj9dPcAVjLhK8qkdEHu
31689	payment	1397	1397	1678	1	1	12632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjszdQc62vYPzy82FGtWi2i69zThi5kyFUMdMQBXPQvYGhx4hM
31690	payment	2134	2134	1874	1	1	3122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEiheUa1R8U6be4FpCHH3qRkG1oJ6tNmFJ71b9S8EtWAodSZc
31691	payment	2134	2134	1874	1	1	3123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV8D8EYozPhxwijVaqANpSmDHyJyXWNMJXoepNHWwijpvd49a
31692	payment	2133	2133	1874	1	1	3038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh5vusPbbtTq8Q39ShpiQ8UQYwwmAWMhGawG7EnZzAiYZAQEY
31693	payment	2133	2133	1874	1	1	3039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCoYDBE1jvQPzc4TxuhGMBN2t2Q36isvzVtCqnnyzuRWb25mn
31694	payment	1397	1397	1678	1	1	12633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQ8BbmLdWVapSwMTP74kL8rYdo9SZ95C4weN9nw7nAZttWVQt
31695	payment	2134	2134	1874	1	1	3124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEYp3FmHj7QqdJveRrYxGgdq6zGgvYkw2DCxha9GNp4c9gT5L
31696	payment	2133	2133	1874	1	1	3040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HGtVYTC68NdtyGjrm2ddnC85D7MDX4RESFuZF1DEyiJNfG9E
31697	payment	2132	2132	1874	1	1	955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RNc6BV4k1CHEF6N4ixA3M5sRvxrjAWdZEvFqUnrp1WqNdhf6
31708	payment	1397	1397	1678	1	1	12637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpj18yDFky2VPkrRDBGXkmvFoZuCBqkb1gLasRP2mL61fn5Rsd
31709	payment	1397	1397	1678	1	1	12638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsFkgv3x8wLNdLWXfQwYgjAJ1Bi8FuxC3QCD81RBGUHwgWaw1
31710	payment	2134	2134	1874	1	1	3128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqCx1UYbjf5Jwa3eDModpGFkGCFZdhtQvATjhquoPTKKWDriX
31711	payment	2134	2134	1874	1	1	3129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWfbLTedpZjGwhWtKemdACHhqSrT4Chpk4CXV2gi5b7Txdrw3
31712	payment	2132	2132	1874	1	1	956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHePr6Q8xG7XY8QjvThXgMLNXo8Ln4BJog8mEUzEfhEPxcPze
31713	payment	2133	2133	1874	1	1	3044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7rhSFRDfCcU6gz7HUHb4g5BiCEPC5hqipj8BhLCLy76x9Gar
31714	payment	2133	2133	1874	1	1	3045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSGUe46aakUFJZxFcvyQiPtNyngYZh2ruPvHNVCsoRRjqb48z
31715	payment	1397	1397	1678	1	1	12639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DNPAugwbYdmGxxEbDsnDGVkhAA934ekHJCUiA8z26pJAwaWD
31716	payment	2133	2133	1874	1	1	3046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzi6e4wVbBwjJrdZ94w1Ebvq8mnYKe9Lpe9MSuqz6PVt8yzYo
31717	payment	2134	2134	1874	1	1	3130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTQLXQpFSKApiWBZ443NYtBRY5Ld1Ebgg7K7V8xNZAywC6yVV
31725	payment	1397	1397	1678	1	1	12642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfHNVwGbAMP7RM1YGxYgD2goGNWRwBFH425naXczLT4GcTZGj
31726	payment	2133	2133	1874	1	1	3048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxcrK5qMnc25bYtmPfRk51un7ihV2gFYNq7anFS9ubBevKsZA
31727	payment	2134	2134	1874	1	1	3133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAagxbiQiscXYS5PCJGRJ4oWT6QGnkaejWQNwsx7m4mPEvXdRH
31728	payment	1397	1397	1678	1	1	12643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5nQcUZBjyuySLeAbbEeMWukcgGvZichU4ZR7UYhue6g5xBto
31729	payment	2134	2134	1874	1	1	3134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT8a9tuqofsTFKz8tN9kbhsTKmnL9eQbxfmMnvDNtaFdKnBpX
31730	payment	2133	2133	1874	1	1	3049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDaXp5VWorHVEZbHshbEQDa71zLCeZhLyNdPURBFWa4BVN3Ws
31731	payment	2132	2132	1874	1	1	958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQBA2o1EP4Y8EgE7ZYn4LvZPJ1zUbB13Q4cv5PFaLA7nXshUL
31753	payment	1397	1397	1678	1	1	12650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7u8oEPPoR52duKu5Cv7meUjDdGQqmCLF9s1eZqhHwV5MhaQcs
31754	payment	2134	2134	1874	1	1	3141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuePPAQpe22Gr3paBs1YtQPHuSTUXeTz7ATb1FqMVqwyFGgL5
31755	payment	2133	2133	1874	1	1	3056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLaiCox2u52bmApN5AA6Y5GhnGrXoNeKxwanUjt8C8MZEvdV7
31756	payment	2132	2132	1874	1	1	960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpgm4pNzyfpLznaPHNu4H4K4UnEjGfrG3MQzkULKBTMKbEYTG
31776	payment	1397	1397	1678	1	1	12655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX6D7U6La37fCksqhj8oVfjaC9KUKNxvUWBfLVfPAwKqax29s
31782	payment	1397	1397	1678	1	1	12657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5u5znhdkcTx8PcYHG19Wjn1tGhqegcRZ7a1FbCE7zdCNqVLSS
31783	payment	2133	2133	1874	1	1	3063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZd1a9KuCsjfWApTehbKaMLrikWoQPHs5eLKVbzqoPtUzAdJoz
31784	payment	694	694	2288	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1M9B95c5QSJvDJHCHRzXafb77x715efkXxMfQsp7NNkCZebZ
31785	payment	1397	1397	1678	1	1	12658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8w2u8yUDAfh6VxXrNhzPsyn6msKAam37UefJSV1UXuVXRjyzB
31786	payment	2134	2134	1874	1	1	3149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddu61fyBAV2JBoWeZTetcsFTiP3GRkVvVApJHxtXjNgMAHzub
31787	payment	2133	2133	1874	1	1	3064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjs4qzZzcXFgu8vGBRvcisqMUuqXCDEX6kSkuCW3rEeZTUWjau
31811	payment	1397	1397	1678	1	1	12666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Xw43UPhtToarcbhYpgWjHoLsUybSnSgBRZcGiUjwa7Cwg3m
31751	payment	2134	2134	1874	1	1	3139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KmLj7pVmiM3mN8XnbvMRufdk191XXWxKoGFwDmNiuRMBV9F9
31752	payment	2134	2134	1874	1	1	3140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumGJAD6rWhBrKztLP88TVXtzthYYEa6SbG21zPb9exxnH8P44
31762	payment	1397	1397	1678	1	1	12652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bvJ8mWrGCTdrjR3TymnRjWVpvb5ge9L62BXpxMozq7cGXJwV
31763	payment	2133	2133	1874	1	1	3058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzx6JtcTwmybqNjrk4MLrYPvn9VEtqFRqx5oSqp1BiAuMLLcew
31764	payment	2134	2134	1874	1	1	3143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvw9QqgmorX1Yxna6XiEPvz2HUUSEWwnjm1TuPu3prxZBncy6
31777	payment	2133	2133	1874	1	1	3062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TwHR1W2zScMXh5wZaF12pSF4sNGiynHdxKoqWphPq3TmJbSV
31778	payment	2134	2134	1874	1	1	3147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjXLas3jHDWDS3FnAQBG3zUwDA3AscyiKD5LvL43xzSyqtAja
31814	payment	1397	1397	1678	1	1	12667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFr5Wc4EQKTUthrWQ9ruMtYqh2UpbSnDemARydN7SfEVLmbiS
31815	payment	1397	1397	1678	1	1	12668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5BSjebKLxu8LUpDHkwVPPV8gwvifcwByKYphZ47HvvfMzvp5
31816	payment	2133	2133	1874	1	1	3072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU64zMoqRqfjdk5wQuqS2Hu35BVjMsfZc3S52xQXf8te2LxtLt
31817	payment	2134	2134	1874	1	1	3158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAQcvdvo8THXnxHkpnKqs3vX18ini8X38WuGxSxByRaEMb892
31818	payment	2134	2134	1874	1	1	3159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnr4bzzAGJULcCb2qADU4BKhfzv6JwLzsrrEGM3xfqa3nrZnw
31819	payment	2133	2133	1874	1	1	3073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRqQqLnrDbRJgwW24snkFPbqNUM7ZPzCpGVSfe4YS2Wi4AKwW
31831	payment	1686	1686	1771	1	1	9	293260680683	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaGb2kbY3YTuqts4ewXpZgs7Hc3XVWqWdiB1XXqkjqdMvnMrwGT
31832	payment	1686	1686	195	1	1	10	289185790016	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYw9xdsJjSy6Q6TwALF4SxoEmk6HLmHBpZGTm35i4urWVDrPKRR
31833	payment	2132	2132	1874	1	1	967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnydkxAQpFHEvDiA4DRJnabqSEYuedcpXBiRio5P8wB8h9RDYr
31834	payment	2133	2133	1874	1	1	3077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNuDYYgtH9HYURpa5REU6DAB8iEjaZ6dpwjsfufvx7Hpnxtcf
31835	payment	694	694	2288	1	1	3	510000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AEBpWThAK6jE8U3aJzJHxzgHC3VUpJnT5vYyNAYXp3XQAB1P
31856	payment	1397	1397	1678	1	1	12677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp1f5pr7aHku6voT6hj5uogEirGzpm44HdCHsxJ9QSUhFx75z
31857	payment	2134	2134	1874	1	1	3168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1km3VeotdnLnW72RfZGELuGoHxQmexykZsn3N4LsYYsFyfXdy
31858	payment	2133	2133	1874	1	1	3082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1qm8kvh27fVECfaQJ3aiwDkNoqa4Bm424oUi85vwfhwimrzx
31866	delegation	1686	1686	1579	1	1	16	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpe6B47uLz78iSuTECnHwtRMLGv7WWta1krKV7tgDyvETK91R
31867	payment	1397	1397	1678	1	1	12680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8NTWjCgMwsjcdTB5oLWuesk6y77meazComudUxq4zTvVSGDJ
31868	payment	2134	2134	1874	1	1	3171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAwcm6fYyq2v6UqDcw1qveJsFLwcM23Cpq3BhZxjtgsteNrLf
31869	payment	2133	2133	1874	1	1	3085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fAaeGHZLSJS7yGNHR8feMF6FDD8EdCBBgLFsx38o4Pmzmx8P
31887	payment	1397	1397	1678	1	1	12686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbGN7dU7gByuM79TtsSVR9kQWHg5T8WkDVawGjLcUnnS8fHc8
31888	payment	1397	1397	1678	1	1	12687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPgy6aoW5XkFNuXisknYMHtoqk74cNTzxdWPTvSSuwqCRFDch
31889	payment	2133	2133	1874	1	1	3091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzYUmVWF31s4GA3EWCAZTxGsjbyqEsjKgiYmmG3RdZ4VHb2q4
31890	payment	2134	2134	1874	1	1	3177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboPUSMu6hzVTGYjZ8Yt4Eis99QzVyNWcbPj4QnEh6cmPjQvgq
31891	payment	2133	2133	1874	1	1	3092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUxvCGqA4pnnK9R9UtWcEoNQEbyQYF3wxYgaW6Tv8cM1HGZKY
31892	payment	2132	2132	1874	1	1	971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMM7EdTMsUGhstwLcrMkLqjJLxK3qzznJzAdtovXkLaeoNrjtX
31893	payment	2134	2134	1874	1	1	3178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBv7aTkuB8XoZkDCN7jkpwhcoKfysYULJvgKeVDzAdDdZCnUD
31917	payment	1397	1397	1678	1	1	12695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjQZ1WXzuj7QrPK2982V75QwE6gTz6LMTo3MVy1mUNhNJZaNr
31918	payment	2134	2134	1874	1	1	3186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfZJq8SfGHRy9bgu3hx9hoohL52xn9hKX8TMpajX8umon5E5H
31919	payment	2133	2133	1874	1	1	3100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBHfp24nCqDAzHj7VYSaKH8KW1MA4gT7964JbobzuNHwCNh5X
31934	payment	1397	1397	1678	1	1	12700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBHC2mBmwiQZ453VaXtFckReK8EpmTPR8QSTtzHKUtYL6keEE
31935	payment	2134	2134	1874	1	1	3191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsiYynaPNnn38cVCtxArRsWoYvFLs9EYcWNT98tzte5ejtg9s
31946	payment	1397	1397	1678	1	1	12704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViPg9LUHppXBiNqpcscwFSSDVmdUvUxERk8fqGEczXQPK6RfH
31794	payment	2133	2133	1874	1	1	3066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2u6RVbSbqHDdvQwA4kAv4drDs53gt7ayUKBU8MQo1qLcUJ5EK
31795	payment	2133	2133	1874	1	1	3067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXBaYC67SW5o5KFyGhFF5S3cGtFEsFSfc47ydrccWfUh4e5Bo
31796	payment	2134	2134	1874	1	1	3151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vtyf8gxfVcHLZVBCnnGp9oXKocb1sGQkkZMJ7SgoV2mVYzjF
31797	payment	2134	2134	1874	1	1	3152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigsW8EvRvd2JGr95MwtDmvCxHGb5MH3qMLCsbBCyyAUhy4VZe
31808	payment	1397	1397	1678	1	1	12665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk4z5JjRrsY3YYPCrQ6KMa8RMApQt2rvVSqmfneCHeEcV4fyD
31809	payment	2133	2133	1874	1	1	3071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdaTJoA8EKEUBgb65o7QXBDERFHCH3EazqYHHWHGHs4nYNZuRR
31810	payment	2134	2134	1874	1	1	3156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJnKKnFSN99KJXceDwxJp7znAtEeuG3xgguzW4rVxTa4Hfnpu
31836	payment	1397	1397	1678	1	1	12672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3MBxWggR3TjSFfH5DWUGLCwtwvLt3sg7mc5bp7ZZZNec8sSa
31837	payment	1397	1397	1678	1	1	12673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeovzsWzuiDp5m7bcqnDf6YK8qvX3bV77HoeDuTznvUFx9MEej
31838	payment	1686	1686	291	1	1	11	289185790016	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	Ckpa3P9PEPxyPKNM4uAjaUiVvGrdTdqv4M7xc9Qxk5PyrWbjHRjCx
31839	payment	2134	2134	1874	1	1	3163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPQNzajXVT8rbVnwxicASKqqKpLwoR7k8nw6crzaMquh63nZ7
31840	payment	2134	2134	1874	1	1	3164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ecwgHYDV41bG9WU7ppdZwJTWU2LufPGfXSEWvpsEAo83Pe4R
31841	payment	2133	2133	1874	1	1	3078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5cWVtwdbBey2oVud2r2h45ZUu8C4QMiS4utnmnHeRVY1DHyE
31881	payment	1397	1397	1678	1	1	12684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkCqc7Aj3XYsm28gZZ6NUQdfJzzESs5Jke3PRJe5Z5GgWyGxx
31882	payment	2133	2133	1874	1	1	3089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCRAtsoRV56nmECkPenfSEhQKB4g3WKp1mffsMtk5AVk2BY1P
31883	payment	2134	2134	1874	1	1	3175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJb6iZyRchTjTNwD5m6DzhkrVuBzjWd51ZYFpGKgF4JpsNZpU
31894	payment	1397	1397	1678	1	1	12688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RMjUPWPcjcHYGC5R8Xp4WFZLrQZ4fBPLG1xfKdqSKHuGbLUv
31895	payment	1397	1397	1678	1	1	12689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcw99s2UUT1PwBsLb5Yq8tmUAZuufQufCvtL8WuXo6wS4hJ3uF
31896	payment	2133	2133	1874	1	1	3093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNrqUMoytVeNynCykwgnMSBTMEUCRwXnJBh4RyM8iMWjtvhq7
31897	payment	2133	2133	1874	1	1	3094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX9Jx1p6bcfFyiRnVEHUnRY9ct28Yez3J2qx6Ng3yyTRwBEyM
31898	payment	2132	2132	1874	1	1	972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvrbqPpbmwhmjGS3rfQSTamu4x1UQc7kiGLmSTMN2JED37Ts1
31899	payment	2134	2134	1874	1	1	3179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zR95KbDJJThhKQbWS3NR4DbZgyw6ifbTjJgc9Lf32LAiiJ5o
31900	payment	2134	2134	1874	1	1	3180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6srxMgWVq11stEznqkrRE5TQZ3s83TWkUz298btqXyXsQhAA
31907	payment	1397	1397	1678	1	1	12692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vFM2c5D2oejqEXVBKbkg7UCoF8rRcMP5Y6azrCXs8QxCKGnD
31908	payment	1397	1397	1678	1	1	12693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVhvUu1E8MXiRT8dfgtRT3yL5kWcUQcRBzKmQCKZusn9T2ZQq
31909	payment	1397	1397	1678	1	1	12694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdC4ks8bpnsGgyTBW4LfWRBPiSKgnW2NYnXW2DAvjbpvBfKwGb
31910	payment	2133	2133	1874	1	1	3097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6dEfMPJVFFBq3BBpTYAc5gx9k5RXvjj5k9paogcoUQBPAgp4
31911	payment	2132	2132	1874	1	1	973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseVU615v6tWR9XJJ6raSLXFPxZNHNPHi22nUaQMRdWyP5NpTq
31912	payment	2133	2133	1874	1	1	3098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJ75pWraCvF2WpqRwTcHuzTd7Nz8sxrbQvnTf3KgCDjaZ3pVN
31913	payment	2134	2134	1874	1	1	3183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4LKBcnmYejGzQtghFB3JXpHJpPLHA7PzLgrAyCKKGAsmAKzF
31914	payment	2134	2134	1874	1	1	3184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1faVruotZsZRg2pzbdsgYydW1g1nDRam3RioPGnJQjjx1H3N
31915	payment	2134	2134	1874	1	1	3185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQp1AC8NG5oJMzhoZnwfUhTwA5oTHzgQqzWV87fj2JUUqiktj
31916	payment	2133	2133	1874	1	1	3099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeqXwEUHkrYD8E8SVjE4vYwpanYUhrv8uyd6DCRVh1i2Qfvm2
31920	payment	1397	1397	1678	1	1	12696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmsBE7F83SPQ4Mqb7QAyXiNXXTiUsRjz65HH1Dv5mKzssnDhG
31921	payment	1397	1397	1678	1	1	12697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9gku993UpBirZZ7aiLhQZm2FbQuuAdEFtEk4ruGMA1p7Mp2c
31922	payment	1397	1397	1678	1	1	12698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZPLDQXqbfBPSYm1HZeMYfuz2zYgtAxL8Tqi6sEebN39RW8LV
31923	payment	2133	2133	1874	1	1	3101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63tKonjxoK9MTnJcnbwFzgAP7LZKEcjybQfuUwAody4MJ3ki3
31924	payment	2133	2133	1874	1	1	3102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjkNpNQSKwg1PtGz59fviBvTBAffxPGYH3WG4mQ6sh5SoC7Sq
31802	payment	2133	2133	1874	1	1	3068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXmySaPEPxhYZ29S1fmcUF78AeRMf4h8AxnM76rQAo6zEXmZM
31803	payment	2134	2134	1874	1	1	3154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgFXqAizVzD2ZhzXL1yM4PkCmGKae86hutfFRW5r1FLurV1cx
31804	payment	2134	2134	1874	1	1	3155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUeSLDxV3GE3sz4PTemGwG9r8pAnZFaunK5dz9RHYwH7NF9tR
31805	payment	2132	2132	1874	1	1	964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3DPfWhMSkghTR2PSSDqUeWkttCX8X89jViZShus6boLkBQWA
31806	payment	2133	2133	1874	1	1	3069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc3Y5jDKWpLZFC4DjYDueS4xczBgKJPQN6uNym5mse8kD6eXm
31807	payment	2133	2133	1874	1	1	3070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1ihxTGRC46ZV2AsxeiN8HY2PQH1xUK2ihN5kPVTVZMzxsTkU
31827	payment	1397	1397	1678	1	1	12671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwHiUVaZxrfGLJ66qXBk39ddzgiSEY7ohvMAtx8CdJ6u224SR
31828	payment	2134	2134	1874	1	1	3162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaE7q3wxzbHyRJCwe1WQNTQ3e8wN8JehqZFhokWddLE4socQx8
31829	payment	2133	2133	1874	1	1	3076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhinxBkpWNDf6TLVAwuujk4wN5mdQE5tTXSxuhV3aJbQpH2Yd
31830	payment	694	694	2288	1	1	2	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvEVYQZKd5U7Q62vDGw5cbxs2C81YVHKtXyxo3HN9EGKxi7EL
31842	payment	1686	1686	1023	1	1	12	2201908885700	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZg5j6K3tcHs1gLSoAqXsGhUCgv5LcBPV47DgyCBkSPQUU8QaWM
31843	payment	1686	1686	1143	1	1	13	3945801857225	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZLRDy1fXV2wZqSshwpPUhZGr7yKZ2T75GwNXSMgVyQfTNUXMKu
31844	payment	1397	1397	1678	1	1	12674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiie1eGLm9aGsKHzaVcfQzsSULUHyBHyGTXfM2ezacx9Ym74G
31845	payment	1397	1397	1678	1	1	12675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5LvQQmYZoyajGEVWd3GTwz9zcZMEyn9qNzx1RwPK6Uhap1ms
31846	payment	2134	2134	1874	1	1	3165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkaGixfN4XPR2gzAAJzyyAQH7sNhoa64haakjXBmyKS3Kzb7a
31847	payment	2134	2134	1874	1	1	3166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaRJUMXU4KCsXx4tPgL9v6Bu9SBcdNwaXKBzmhxi2Ww18B42q
31848	payment	2133	2133	1874	1	1	3079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVEfGGGHZfoMEdm6hzptbGDrr78AtCJmDnxKCKETXrVRXrrkv
31849	payment	2133	2133	1874	1	1	3080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpiRmkoA5cVvCv7p885iJDfE72ft1WYMDTKCemjwN2Qjtrmuo
31870	payment	1397	1397	1678	1	1	12681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzZuy3kCbjncn6be5haVbGf6Kh5RkmEBapQk3rADzMhp9ZSms
31871	delegation	1771	1771	1579	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DEFsE3kXv56ggGk6Lmbaxb4FyiKFpQxWuf3ytEfPveuzKZrR
31872	payment	2134	2134	1874	1	1	3172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfj6MKw7FGwPczqJgDbrJ11xqn4AE4GJpi7qtL2uhT81RvyFo
31873	payment	2133	2133	1874	1	1	3086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZLrLaDJm9YLTZBiwne8waJEXYnnRxF5gWsFDShnxM5qCUjcK
31874	payment	1397	1397	1678	1	1	12682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14U4gtqXcd5mkU7Auj3qi8UJmHXjxDzrNNVhzwEzRCpCiDq5r
31875	payment	2134	2134	1874	1	1	3173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaagTcPVY8GktPn9k6Ggq3ieYZ2wPx5fnVvAtPzDC8zp1ZRqsZ
31876	payment	2132	2132	1874	1	1	970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrcddV4KseKWQs1e4Cf4hFg2UydPHj4rDz25yzjHdzYua5yYU
31877	payment	2133	2133	1874	1	1	3087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXYpWJTCCGDt8aS4M3MfbroxeWFx5LxkYyb8SrxGNtRZ2RYZb
31884	payment	1397	1397	1678	1	1	12685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSLnKUbqw5R7HWvRSCfdnHnzkSij9GY4ncmimEfGvDwGsy4Si
31885	payment	2133	2133	1874	1	1	3090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLRyWxap15cNLXFedg1rqSzcEBrmBCv5uz7ynDrwDL78JvDSU
31886	payment	2134	2134	1874	1	1	3176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdSVAor6Zst2DsTyrjfGHUATjiLFqTT5Q8MznLLgmnLuTwP6S
31904	payment	1397	1397	1678	1	1	12691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEAUyZjwmoxJDQEMbWywF4or3wgMBQ4WDdkaeeLXtRWeYtehe
31905	payment	2133	2133	1874	1	1	3096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFyG2Ps8o5Jk724x6pSy6eHYdCyaUbzsT89mj8DMFFB51ZUL5
31906	payment	2134	2134	1874	1	1	3182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuVFHK7Ptan8sePLNzq2GLQoq5K6MVygGaRRppTBZbJJKrQN6
31930	payment	1397	1397	1678	1	1	12699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2txiH5GRTatPjrWU4weunQbnvjUnJCdDJPatcwRpTje29h7gj
31931	payment	2134	2134	1874	1	1	3190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMdw3mgzWkmows7bs5knhicKposPu6ZQKf4pxMTJKLm3Q8NxV
31932	payment	2132	2132	1874	1	1	975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvVHw9TnRKc982RWBLp5F7Wn6C1vc6jghGC56B8WfQtYKMSYX
31933	payment	2133	2133	1874	1	1	3104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSh4o5p7LuM13jeNKnkaicWMgdYXJaWgmpqL9z5pxoqXRYix2
31943	payment	1397	1397	1678	1	1	12703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyiHVditgVG88kKzUVigF8TGRbpL1dmvMj9YUSxCP6hoMjmMzy
31944	payment	2133	2133	1874	1	1	3107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCmnQaw45VXyUJywcsujSqpaBJX4KEW9qNJTyDPGauRHATfYW
31812	payment	2132	2132	1874	1	1	965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFgpgV8KQSBpVkQheFMZRvBvc6cJ2FXmFBnNjuJ6q2iQG7wTP
31813	payment	2134	2134	1874	1	1	3157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQsnuPwkQ1CwYwN46u7ZNDpjeEPh3HpEBc4mvHZyqvon7VtzR
31820	payment	1397	1397	1678	1	1	12669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ozcjVeNPY1EkJP8JSKpJtEmf5i6cgyVUiLZW2DRCKjGnPRei
31821	payment	1397	1397	1678	1	1	12670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxmjVUUmHX6aNp8UXHtrosBV54TBUgmYTWsEe9oDddrLcF7gR
31822	payment	2134	2134	1874	1	1	3160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUTVBttZtvWLWf5dBt5drCCoNCe65vo7CD731cikXnUpUFStB
31823	payment	2134	2134	1874	1	1	3161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GTUL8uJNgAUCYruK5AC7UQLrVWc1gSw6NBe84GmY49SWrd6v
31824	payment	2133	2133	1874	1	1	3074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVqFnDt4CnCkQ5i9DDvzr17J197NJ2RYzW1xHDZMTCLmimJGK
31825	payment	2132	2132	1874	1	1	966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUbeHhyWuL95HWp9uyeXdkneSvfYHMMee29LqzDKFY6k2n8WL
31826	payment	2133	2133	1874	1	1	3075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gTnvNYMc3fsGFmcZ3o8JC2kZJGE64bTK3QKmjEAdFtPB22wy
31850	payment	1397	1397	1678	1	1	12676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRyztY9mz12fYuD11mUAUuzkvRQSPwrCnR36u2eWYN7a4hE4D
31851	payment	1686	1686	1263	1	1	14	2662311138725	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZiPRUQQfnbm373hieTJX73ygbVGufjf8nqouK6WwYfhU7Lwik5
31852	payment	1686	1686	1389	1	1	15	7418766707575	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYafaQ5bKudF1CeXR5HDGPBMbEzBP8zB8jWK247UtR2QqZLXFVG
31853	payment	2134	2134	1874	1	1	3167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9vSHm5qVjVrWcET9FKjVNuJkzSb46EG8Ajd716Y1QoUdeEv2
31854	payment	2133	2133	1874	1	1	3081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7hgE9xBaR4HnnCiRFQHJbvdNLG43Qrg4UQKoZfd2CFCysUbB
31855	payment	2132	2132	1874	1	1	968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ojcGU3gM6hkwyC9Jf2TftoiGx1N8DQEzeEHTkeiNV2pPUVTg
31859	payment	1397	1397	1678	1	1	12678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TZXz2KgbCyQvV6qeYoE6gyBeHVetJuRWUYtbYajaiTNgHnnA
31860	payment	1397	1397	1678	1	1	12679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4XupxggivBn8ehp9KcJQVEXHmzv4dLx66tXJUQ39hFZE4ZeG
31861	payment	2134	2134	1874	1	1	3169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbMKoNrMkHzXHoJ31jyqfeMGn3Hc6U4cBJ1FfwxhgqPPm7onh
31862	payment	2133	2133	1874	1	1	3083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54yh7CZNn2cSkiKiRdVjTVTX1Vus3Ngu8nUANhnbKXsQeRZff
31863	payment	2132	2132	1874	1	1	969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F6B4ddhWMmyXMqvEo9tJoAnVugjDY9BL36ZuG7XFSyykZqTK
31864	payment	2134	2134	1874	1	1	3170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSooAGoixrCLb9XU4WJKUDkSaVg8VdZuozJannn2fzjo9SFE7
31865	payment	2133	2133	1874	1	1	3084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvF6TXmUZvPWPwBopqgaKmehus3avtRXjjrT5PBHnKc9MGY3u
31878	payment	1397	1397	1678	1	1	12683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj2UrCbhaNqCMJMf4P8ffLts6XJeapvd3XkHRBzvdXnYeykUv
31879	payment	2134	2134	1874	1	1	3174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5jUw8YtU7fKSCAGYBVfnmF4zr94cxjTeJn7eedtC3YRLVoPG
31880	payment	2133	2133	1874	1	1	3088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUxme8n63q7HGqwcgzbDCsbnNB9iuZ75e4hxmzZsSFsG3Z7jV
31901	payment	1397	1397	1678	1	1	12690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbCAah33ViBeeb4K3YxRncBeNXjJjCJGbPVeugmXj1qta57PR
31902	payment	2133	2133	1874	1	1	3095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoBFLyUGyLEn6kBiJTMRn97TEACaQFRM4rqN29xyBWMESrwxi
31903	payment	2134	2134	1874	1	1	3181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4ZTKpzvrnmbvwFSVgHUbztuA86yhZVBGZ7MfGF6B8rL8ybDT
31949	payment	1397	1397	1678	1	1	12705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZGfD9KvermFqcvHU3yncuvyjzEHwaGtrod5bmutkDeRe3DK6
31950	delegation	885	885	1483	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XMU3D6JvVAJNYyosD2f3CD5xHQT2m2L9pGeVpn8buQNarLja
31951	payment	2134	2134	1874	1	1	3196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyamWYxKDYqJcP4nRxZCBAUsbKfqMhqLPoHUddaEckqRSHp93
31952	payment	2133	2133	1874	1	1	3109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBtDevF6F3jXVxa14VvySqzj7pdSTAiis3r1tiDkYGY9zETut
31956	payment	2134	2134	1874	1	1	3198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxhDbqecRQFz429Bcy2EsYH2Dnqz5D217iMquQSwMi2igVEvk
31959	payment	1397	1397	1678	1	1	12709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvvFQtEYvsK8yt8H22DUTxxtqsAWBuefQATdUJ2iVMkEmYgdt
31960	delegation	886	886	1483	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq11SVNv9fvPrFCSXyyDiy3G4JeFaE79CUBdvGGF7J39f2Wg2
31961	payment	1397	1397	1678	1	1	12710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCznjVfXy1SLrXcwD5zv2Hs1MBCWZ48yhZL4FZvLHKKjssEC9
31962	payment	2134	2134	1874	1	1	3200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpfeHpH2U7EAcmyUW8xpQso6g9fna1WCgonVzYVxH3nVw1zpZ
31963	payment	2134	2134	1874	1	1	3201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnKgLeSoZBJPkA8xcva5RRttLXDkbjgiyzS1GFsk577nC3ui7
31925	payment	2134	2134	1874	1	1	3187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXZRYNaqYMnATzdYHbUmGA5xWKHQSvySzUZAHJBaaRPdN1diq
31926	payment	2134	2134	1874	1	1	3188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHZ4Ny3HLfBS7zZD6F6AZ4ndgYLevbJjZ9tgT1nEKZGGmDMqg
31927	payment	2134	2134	1874	1	1	3189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXHhnN1RTChS8TpzVNs1DzcBhcPMe1pFvk9BPfB8hQiwf3LjF
31928	payment	2132	2132	1874	1	1	974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoE9w8Tax8U3pFZycbmv9ZCpjvBSqLWivm726TVm1QTQrDa37
31929	payment	2133	2133	1874	1	1	3103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UReacGVaSQ1aMoSsDYAwFvCETFWK4JoXZXNprbKWeWPvHxTN
31936	payment	1397	1397	1678	1	1	12701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3TxVX1LZ2iL6HHFzBEz1Qs28ksAa4h5RAwexAkiXGsmEEGC2
31937	payment	1397	1397	1678	1	1	12702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAnrGBjLsBqU4TxCPE2qMeCLZRpQejTPRncst9mWkgkVXdgvH
31938	payment	2134	2134	1874	1	1	3192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iFQZ94S79KJSZspfzrdhvFDnNBkBd6gAVnqvRNv1gzXT8vh8
31939	payment	2133	2133	1874	1	1	3105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCivshnkaMA2e8i8yJA2gPYASJX1RVhPBS2CgCuQfeopvoSBz1
31940	payment	2132	2132	1874	1	1	976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXyD1CddPyvTXZoJLcMGuLbGFoeTq8hsRncwshp8WaGURnFKA
31941	payment	2134	2134	1874	1	1	3193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9Hc42PsxZQ1RcJQf5uUYTZDrAsymNxDwdQZZzhcAbkseq3MV
31942	payment	2133	2133	1874	1	1	3106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dgxNRDSn91Y3d2GwMC1Fe4DgRaTG9TeSDPQWBbNTY6ZJoYTE
31953	payment	1397	1397	1678	1	1	12706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPrz7QZR8bNvQNKjK7gkgQgq8ZxDr9cHgPKKsxZfio5aTZrW2
31954	payment	2134	2134	1874	1	1	3197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2e3kZ4f9BH72eePusL8e6nbCkuasZuGzgFKzHMNhY3SwxHmB
31968	payment	1397	1397	1678	1	1	12713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBeBiNKC9gxUoA1vZCJTZeLsi7jdnnDbK8sezwzQQC3mgLtZep
31969	payment	2134	2134	1874	1	1	3204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxRvwBmRWD2d63EeQvDK4Vpzpzn4NS3exbcvV5ASeX1GLEPkz
31996	payment	1397	1397	1678	1	1	12724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUaKPNp8aFenDHaLkUz52Vtx4M4i3mxtx88ZLWPePrcg1Sh7w
31997	payment	1397	1397	1678	1	1	12725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyCGv2x4vC5rFYDDVvvtYXXQ9Z8neFmm2eitmYchfzDKq8MUC
31998	payment	2133	2133	1874	1	1	3114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgi5W6rKyitJcwbfuBN4GWLV1dr2vKmA1ETCWBqsF75WqEbd8
31999	payment	2134	2134	1874	1	1	3215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MSqW5RLDXFUYq8YyKBvqjAdQejye3uGgtx5Jusq98SCprsP4
32000	payment	2133	2133	1874	1	1	3115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirziuSPzngDMuju4myH7g9Mjf8wBGjM4LJikJUxi7E3LwDvtZ
32001	payment	2134	2134	1874	1	1	3216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwnZDMgckDFPKQKCSedzMmaHATSCYATP2VNPFZQvo22xdwDsg
32012	payment	1397	1397	1678	1	1	12729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VFieJv4AS52jbpuyEKAtxzxhBvggapnDRr3NTCx99FNtNKQj
32013	payment	2133	2133	1874	1	1	3119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4mMjyr8MW5ke7RWpAjtaG32HzbseBvnQzDJ3BGKPNeGvck18
32014	payment	2134	2134	1874	1	1	3220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6KGDPpmtfTTnR12pYytXdjpRUpjiB3YTAhhVc6QkNgtCUpQx
32019	payment	1397	1397	1678	1	1	12731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqBJyCrxqrtCLogmyeHhSnCFunfkn8pzffJ8FrEkacuddsRqw
32020	payment	2133	2133	1874	1	1	3121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwsiWR7JPQ4EupzpCWR2vQbagaL8y2LAunBQTGVsZDkFpcJND
32021	payment	2134	2134	1874	1	1	3222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2gntHSG2FxsWrmitp5McGeapVUByjXMtCoQcNA3bpXjsEiWn
32022	payment	1397	1397	1678	1	1	12732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDRzjipa9Fn4EnrxLk8DFpAxy1NRNbgJ8ZmR9dabeJ3VCioRE
32023	payment	2134	2134	1874	1	1	3223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ637dP63FvzDAVJCbDY3WdpKXymRsQmCwrC22QS5NH8xaGZv9R
32024	payment	2133	2133	1874	1	1	3122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtxcat63FGR8mhbwmu4xzFfwpuowpaHVGN7MTyegKFVWNEMVe
32031	payment	1397	1397	1678	1	1	12735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xKSZ76doeGqiQTC6Gy7otTt6jaVgH4dQjj7PoiG1A72wNyRB
32032	payment	2134	2134	1874	1	1	3226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNJKunAyUXoAuCzNFNeGDDKt1cpAw3f1kJPEQAQXTHrY9RQPk
32034	payment	1397	1397	1678	1	1	12736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q2V9vTTuUQFznWaXQ6V4jH1gpmW66BNvQoktJC1prGmU52nS
32035	payment	2134	2134	1874	1	1	3227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ475DfmyNd9EWVMV7KtGnjGHrTXyGwoGJHPsoKZKhT19ZyFa7w
32036	payment	2133	2133	1874	1	1	3126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMygV8Kiki7guExvEVapFncM7dqgapHemheYSsw4zSYKzSeHq
32074	payment	1397	1397	1678	1	1	12747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmYUysN11Vrf8pkU9AFawuhw2ro62K2yh4zAUoddu1Npwq8i1
32075	payment	2133	2133	1874	1	1	3141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wq1Rae8q5t2f1EV1i9fqZZZWyjqBNHWHwqkSWyHT3a9BuaBH
31945	payment	2134	2134	1874	1	1	3194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqFzQF2ZRJd8S1bqD5yBUAhJR9tvJvgyRixjqEAkacYZ7a2N9
31955	payment	1397	1397	1678	1	1	12707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAW5vWkV7sSkycRBPsimJJySeXHxJFdjWGAUB3QQpL7xYbZVe
31957	payment	1397	1397	1678	1	1	12708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTMFZ8Z8wqBiW5AQDn1ppsr6fpv5ceBYk2s6QUWJcta1tDmrM
31958	payment	2134	2134	1874	1	1	3199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUKFXy7EocWA3d82RNeL5YawF19kNA4jDSUGfkX65Fm9Ty38i
31964	payment	1397	1397	1678	1	1	12711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8svZ5oSEWsHaMiUsiHNRSxSaud6eLTJLTjcq4HMy1XEomy92T
31965	payment	2134	2134	1874	1	1	3202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsLzAymBWhkrUYV2REhpjbEbdPBgVD3md6mtpWz9bSEqQMJZv
31970	payment	1397	1397	1678	1	1	12714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5VjUzwTdesBzcn7tn1fYVtx54zwMhFwf3HnnJwhtru1zY8Y6
31971	payment	1397	1397	1678	1	1	12715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbbnbZgjiAinsa636mYQ2YKmaY6EhjVK5bea2SxmDG2ZVjYaR
31972	payment	2134	2134	1874	1	1	3205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRcnLPXoqVhG2143MNPrbG2jQMe3pLRVDttB8PF1zHge83z1p
31973	payment	2134	2134	1874	1	1	3206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanboKjePNekiPPY5SxYsadXCUGhv6z4yrLiY6heBfMTnVhdrx
32006	payment	1397	1397	1678	1	1	12727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJrginc2raoxco8TxRvEwBWhjoUCwfMWaPa9HC3KiVvJEuQGj
32007	payment	2134	2134	1874	1	1	3218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxZGcQG93cR199dkx1NQ3d3tVYgzwC4KHvZEmkrCUvF6vhHVJ
32008	payment	2133	2133	1874	1	1	3117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6u27WL27i8hKcsxMciEJgdXFrtNFzwCgp4BCFBWhngLkvkReE
32037	payment	1397	1397	1678	1	1	12737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvftb7L3X5GVcb2zACYUuFWrTnYbqPXkAJ9GiDERtdFt1o6sk
32038	payment	2134	2134	1874	1	1	3228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKg1w2axWvtFhRjAnPTe75Po4cKH1wdPJtL6LJQxhrf4Nyix1c
32039	payment	2133	2133	1874	1	1	3127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyiPTFpZpow1XbLcUzagSTNojEDhkPp15ZADJpzaFTUZWWY5x
32052	payment	2133	2133	1874	1	1	3132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQDL4kgMYDpksef6P1j18qQJyAnfrJQJk4BBWmsLRc3kDddjd
32053	payment	2134	2134	1874	1	1	3233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYA3cASiQHQznzJi1vm3wFpqMvRKNCPsHymmcjiYQa41GFuqz
32059	payment	1397	1397	1678	1	1	12742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDVmTtEmtzHUsWoGUoWxDLxsFuxhcHrxZCweTF16dwceggjaN
32060	payment	2134	2134	1874	1	1	3236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQRjEs8mcNfYz6ApqXLxVazzbs9feaanvTzYMgX17jatCKg2b
32061	payment	2133	2133	1874	1	1	3136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUn159cDY5Az6f449tW9KfexMU7ZM5RrhW7MA56rMbC2S3Npg
32068	payment	1397	1397	1678	1	1	12745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwVD914W5L3QPxS237BPEQRxLs9QqNLxKKojb8vp9VG4KTcA6
32069	payment	2133	2133	1874	1	1	3139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gQ1BbG2R4Hzhmg8VNcZZH3Rc76vM3VrDaDUunkXpVtWxEmfR
32070	payment	2134	2134	1874	1	1	3239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHimQHJvN3o2AnM7setk1JAjRAu23pmJxy7jf5kP73FPUmp3uP
32083	payment	1397	1397	1678	1	1	12750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5Fw8Qz4FhaoLDobiY7GRqrb4nD85BKgv9KU36T9gC7VH3r69
32084	payment	2133	2133	1874	1	1	3144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxNkz8EezuR6yvRTKdUrjS6NfiZLVD93KWK7t4StqkzfwjvJa
32085	payment	2134	2134	1874	1	1	3244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7Mb3NcyxpAvjn9Uc21Q4P6eaYFynqpfCwhWi6Nkv1r911T4u
32108	payment	1397	1397	1678	1	1	12758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvWihS4ZZihXZshRiuvQfA27nRXntBL2bCRx3tZNbZ4gicT71
32109	payment	2133	2133	1874	1	1	3152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeGkmSjSCZQw6xXeFieddc5F8JYHebgdGEdidC9eNMbRNvCnZ
32110	payment	2134	2134	1874	1	1	3252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YesEXdMHjku6AUSXTWy6fVzUJQq2W89NUwnsyApsfVuogCWW
32139	payment	1397	1397	1678	1	1	12768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszQ1dvjeMgALkkiRGn1nERX8xczEKVSvzPHmiHBGmdrw8gjiM
32140	payment	2134	2134	1874	1	1	3262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRc7YEACf4kNoXP8UUm5pJvDJk7V4jkt82biX8fB6FRdc5KqD
32141	payment	2133	2133	1874	1	1	3162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQ9MqT4P15UQaRh6oFvMxcWSYbfdzpUK6TSTFwGr7MVfhwt5x
32157	payment	1397	1397	1678	1	1	12774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BfuF8cBiYGTHr4NgBgnJFYMugodoTmyAVgfNjX8yztzaRH6g
32158	payment	1397	1397	1678	1	1	12775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi22tshtEP3eZVQbz8XTeRYo5zT9RkRDgXHNk7MVscb7aEr6Ha
32159	payment	2133	2133	1874	1	1	3168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AbTud3BwE9LKXyKEjFUYgZN5mQa3XgoRnoxpNYAK2oFa2Wch
32160	payment	2133	2133	2289	1	1	3169	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBzegNfYe6c5kBpNiMGVkyoHJunh5FpRf35djaVf5RA3CKCrx
32161	payment	2133	2133	1874	1	1	3170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUF6wcdtwf8H7CR3g7qJAymXNs2bWNFipnhAVthT6mM4gKsme
31947	payment	2133	2133	1874	1	1	3108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZycwyudb8HMiJ6TKoPsXavPCxYCbcN4Tisi9G37M96fvNdJK
31948	payment	2134	2134	1874	1	1	3195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcCX4YpZTJBKDFLqq9ynisiw95v8nS5A6FWubKSQVrZutWPKn
31966	payment	1397	1397	1678	1	1	12712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uN5SF4LrV75eKTre1ZSaxHMFkSFVGopsNagbyJWJyHSqH8t7
31967	payment	2134	2134	1874	1	1	3203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6MvGGDKAmeUtsmqprAitg94cLhaW85jWiMYiw7iCsKvnzTc1
31974	payment	1397	1397	1678	1	1	12716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvYMQV9opMKNVUUt3oA1WBo9soB5zAeRE5gjHJQrjDHWX56zx
31975	payment	2134	2134	1874	1	1	3207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigkUUzy8SdQxCftES4vit4pEYnzF8k4y5oN5GKcwvHFn8udW6
31976	payment	1397	1397	1678	1	1	12717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kx7haNqWTxBs8wtVanh8Coh9Daq99owF8CegLo2M3Vs8PoQD
31977	payment	1397	1397	1678	1	1	12718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PcAstiRF4t3gEXAz831prVJZ4KddUdRnoPXryyP1ZonJStfn
31978	payment	1397	1397	1678	1	1	12719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShwLDRQejMEqpBxN91DZnsYW28bW9QFrZpWHMVSijGJFRmwgg
31979	payment	2134	2134	1874	1	1	3208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB98QCWtX1veDoDVxFwrntgLML2G9TY986M2yNhM6HKXzAzipE
31980	payment	2134	2134	1874	1	1	3209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6mmatY84xtT4By6K8JQ3E7LxxMPnCRUqbGxRk5jGNwuZKJFD
31981	payment	2134	2134	1874	1	1	3210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEci6hQjkpXgLsw9DxGKgS5chSVVvBuKmtBfVE7pP3qaD2wpgv
31982	payment	1397	1397	1678	1	1	12720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5mRPwmT8nFvoLh97tQkUySjP2DbCRZayp4QZJLRRiNaGcDsA
31983	payment	2133	2133	1874	1	1	3110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWBS34jrbt4b8ww6x1RhGGnbKTwdZkmFc6YZtcMdUcMVEDKB8
31984	payment	2134	2134	1874	1	1	3211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS4GPu2ksW3ED5vK55Ys7c3UL2GZQdp8P1BDQHH7oDH45ZzuU
31985	payment	2132	2132	1874	1	1	977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9otU8MnfQtveZxSTSNT5Ya3Va4x3noacsCBkLMt9o8fSsyknB
31989	payment	1397	1397	1678	1	1	12722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpurPAJ7siTDLZUea5cvMTa3z4g8kMAFnkuikr967YSCnZvqn
31990	payment	1397	1397	1678	1	1	12723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3sjaKAHjTgWukuLXR63BhbwnL3kfjKX6NVoNK4DAFinRhoNt
31991	payment	2134	2134	1874	1	1	3213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5ioarehNtoU9MUcT9EztFSdbuygfyC9RGV1gZTTTitWn3avy
31992	payment	2133	2133	1874	1	1	3112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDdtCy1Seuc5XYiBa3WXL6TVU6yLQfg47qhmdUDRtNTf8C7SS
31993	payment	2133	2133	1874	1	1	3113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPM7oMtNLCHmj45KtGzshuAJhSKEw2FB14fyftvgGvvuZNZEoY
31994	payment	2132	2132	1874	1	1	978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9AhQntWW8CcFmYikCkGQ8Rz8GMypsRM1148AtMet9waq3uJR
31995	payment	2134	2134	1874	1	1	3214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLdXGyzJPhFthidRtXZ4ZbfBG9oZZMbcdpfd1gajX8WkKaHSw
32009	payment	1397	1397	1678	1	1	12728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwv1BrjCfC6o4oTzmvDPFck83y9iimmDKTNE2zFaRFU9iN2Wy
32010	payment	2133	2133	1874	1	1	3118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdXmkQm3cC2CgcATD6rSY69BxvJv9iebzUjkqQ8fgWEfdwMSD
32011	payment	2134	2134	1874	1	1	3219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCUubKRTTBGqYfmfB46BwZhmMgFDt5EpcS4mZKZXc1gJ8twVz
32015	payment	1397	1397	1678	1	1	12730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1bSHwGJCLE813ReQP6aL25xvRrhK1gaY7PHMUB2sZMRD6KCE
32016	payment	2133	2133	1874	1	1	3120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaH8695N1Maq7185cFba8scp4hNNEKqfhGPP64Rn2vYXqDMSvD
32017	payment	2134	2134	1874	1	1	3221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfmojmFx7vnrEtwLichUa4J75mhjyh35Jp2nG6K2B6if589S5
32018	payment	2132	2132	1874	1	1	980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmzsotJvAybEr8Y9B1mbEfc4FqWphTrSn7ubWn3prKNtkajHC
32025	payment	1397	1397	1678	1	1	12733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijF79EGiz4njFg7cus7iv81UXRSg4aZf8xYebHagWFSgqzDwV
32026	payment	1397	1397	1678	1	1	12734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuT6aZ7K45bCM5RoGWgat2zdDNWuezm9FbzHRRJq5PUTeQBy9Y
32027	payment	2134	2134	1874	1	1	3224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHBm8F5K3s5SAGYMBMWMCdYV7nEYzADQhSrDyXX9WntQogiVd
32028	payment	2134	2134	1874	1	1	3225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpgkx3PasxNzAxvjDdixGrwXC1VQGGPNXbq1CcFXYR4xvgc1o
32029	payment	2133	2133	1874	1	1	3123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgQ1gGEoLZPpXy1QStqxzb7SA37wVR5Ye8qVBWB2v1UteR61j
32030	payment	2133	2133	1874	1	1	3124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjgptfZDyZkZqpiRzLvUnv9WbxQEHb3aZMRegjQrcNxfSk2Cq
32049	payment	1397	1397	1678	1	1	12741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzmVrcKfwxZwpGGxu7tHyLaheGTNX87mbr7URrcbB3fqjKiup
32050	payment	2134	2134	1874	1	1	3232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehTtrVidPQCexfwsRKn7FjPUye2EeEBues46anorz8DqFFHet
31986	payment	1397	1397	1678	1	1	12721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbZq1BAtKFDiwEqGEhK9nAhCGzdFdDE2eoPNSNfUTkt6PsdKR
31987	payment	2133	2133	1874	1	1	3111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieeqW6crUrjhrWN3wqvTCY4uGmHHKoNidyaexhefxTA9VE9xK
31988	payment	2134	2134	1874	1	1	3212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwYWTiNyD54EdgaB2MN8YwJae5fbR4WF2fzwfNDipxH5aEhgv
32002	payment	1397	1397	1678	1	1	12726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcV3eqRykMgLwNcVDQzDSK7mD4ykWW1tqP54e6V4pQ8J8Ysdr
32003	payment	2133	2133	1874	1	1	3116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnY6omAtWzMq5uTnN6TY77W35dEPoHpgxHxkEqd47DxVY4v4Y
32004	payment	2134	2134	1874	1	1	3217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdgPf8T5YWmZ3CY7bkTMwh4RHyzP7Kj822jBPYwds6fHuPr3A
32005	payment	2132	2132	1874	1	1	979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wWMkkeg3mV8BWGtEqvxRaovFEszuScvutFcaF6f47BXnKeYh
32033	payment	2133	2133	1874	1	1	3125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXL2piUrrwTwY77pquEvYp8zgZYzWDdk5fB1vGs22GnpGszBLF
32040	payment	1397	1397	1678	1	1	12738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKG36vmffZ3nwkVN2g2qxvZc43Di1u4ZbpaNwzNhugDT6fu6uJ
32041	payment	1397	1397	1678	1	1	12739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiweHrQU1Lfp4mLRes8qaxnqGWNQUjdm8KyedghdKbWhDWdXKW
32042	payment	1397	1397	1678	1	1	12740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8Uv3RVxotfXJpAZ3ULPyGkNb5FQvip5RrXaVR6L3pXayoLoS
32043	payment	2133	2133	1874	1	1	3128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZHysAbJpcy3SdeDf6encw1xgLabkdjhV2CkJRmndjUgFoUzu
32044	payment	2133	2133	1874	1	1	3129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckokUVVsmBcgKDPVtar2KMeq2T1oBmtSwcWu6Ww61GiJigie7
32045	payment	2133	2133	1874	1	1	3130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdYS4yNzg1VPQfR3mihoJcTktHwzBKh3M8bomP2Cib9pwPCP6
32046	payment	2134	2134	1874	1	1	3229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfkg91oNTfRAhh6sPyhzwY2q5pmte99HCTV6dHCwyP3sYgQ8s
32047	payment	2134	2134	1874	1	1	3230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHziPhEcfiiwcCFt568i3QrrxutfK3gMFDzPGbjCp4Jq5L87C
32048	payment	2134	2134	1874	1	1	3231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnD36B1xcEN1kt6sTbhNLyh4zhFSvfmSvSyjLnCa2ftYDdtLg
32054	payment	2133	2133	1874	1	1	3133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoB1WUuNFgto7bJ7j1o7bGZJszdegENCzTYJYEivfjVv8hnCD
32055	payment	2133	2133	1874	1	1	3134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNBqvpqwTvWHzFALiEmrHB88X68bGQyERQHfqUvR8Z7GNv7Ts
32056	payment	2134	2134	1874	1	1	3234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5eXWGf8RMthXTLMF8tnijcsJpFZWRtUpJNo4NHrNP7v4zP1N
32062	payment	1397	1397	1678	1	1	12743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxMVbHR2FwdabjYNW471k1xrP731jj7FznyN2CMoPCqDiJrKc
32063	payment	2134	2134	1874	1	1	3237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9aHftfHcxtjitKhU9B885XPPHxLsCLUyoZEpDzi6iLiePbvq
32064	payment	2133	2133	1874	1	1	3137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr9ukgbC4EyAkFZqN5tiXm6eakQGj7S8XidvxcJ6L6JJt4gkB
32065	payment	1397	1397	1678	1	1	12744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9osnckTee9aQECE8Wms5MqNMxuW7n2kkTXvJgqmWEnKNdMZGt
32066	payment	2133	2133	1874	1	1	3138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLP4fwesQ6fVsnyr7Ecxj9V5TkoRBEE1Q1jDKPTbgGMiW7DVX
32067	payment	2134	2134	1874	1	1	3238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHopCMfYUePzKkQatoVXpAvfj8Mqyp1UDRVvLnbNEFs9X42mrX
32077	payment	1397	1397	1678	1	1	12748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonxw8xB7Y2DLtb83FJAuZKqbY7gjKyL36jNJ5oodtPutcZJCN
32078	payment	2134	2134	1874	1	1	3242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsjbe2JV6WxcMXn3uwAJWPa7fKmFaY2W3UkhJZSugwgpjDvud
32089	payment	1397	1397	1678	1	1	12752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUf5a3hQm7shNrMgKXup5eJd1ZgUn7wfqz14RSFN4xMMdJUcJm
32111	payment	1397	1397	1678	1	1	12759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLU9RBx7o9Bq2q8P148yJhQ6oub7LjU6YyPeP34d21nAnbAYj
32112	payment	1397	1397	1678	1	1	12760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhix6CayRtkDYyUo2aPVggmKrjjz9YLqdcYM6v3A1Agh8Zy2fH
32113	payment	2134	2134	1874	1	1	3253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMjGQHUh5qEZxEyU2T18eRxuZY2u92Gwn4jojEsMb99Y1EYCU
32114	payment	2134	2134	1874	1	1	3254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYbmtNTYuZiAs4AqLAjpsr1Tf1x9wUPnixfsVtPv2PaMcCiKw
32115	payment	2133	2133	1874	1	1	3153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8EPRwLDndge2f2c4C8nNm3yXeVhZ2L966WGwTpTuJWL3n7Pi
32116	payment	2133	2133	1874	1	1	3154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPB4NKFheP7LyrZZ8oyufRXe3vrq2xGzSNBW3ycAHdUjJqE1f
32117	delegation	2284	2284	1483	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoxaNU7kpemr5WMKu4PJJce1za7VnzbJhN64kvkFugw91qZGg
32130	payment	1397	1397	1678	1	1	12765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhK3YfhuEM2weM3qx6PFbAcjJRxdyYzvxdxGUm2xbtrjyaU9aJ
32131	payment	2133	2133	1874	1	1	3159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TJ4HoQZjHZJBonUAvYFpBt2sWuA3sWwtD5eg1aTxMM2whscc
32051	payment	2133	2133	1874	1	1	3131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMT7eYjooS9HaYyDJSgchooA7QJaGAVbbcvN3K7693f9448Lg
32057	payment	2133	2133	1874	1	1	3135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAAH23DZzAuKFkQ58XateTtJjXYvWFSS2bo5732Binkaoj7ED
32058	payment	2134	2134	1874	1	1	3235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWDiEyBdQSML9v55u5ZUSBjnL9vFoNtpcZAsAc9ETGnw7fy1k
32071	payment	1397	1397	1678	1	1	12746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRp1rox2GPycgCmNfh7zkW4CEouBtaF6yNdCvQYwRVXW8Vaef
32072	payment	2134	2134	1874	1	1	3240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLfroXJQKnL8W1kW6MLhqR9DMA8NroS6XHXaZZ2yceczJz1Y6
32073	payment	2133	2133	1874	1	1	3140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83GzzMzXnQBGL2eLGZoNorFxZ61s75ygDriPdigGHxNeoa6j8
32080	payment	1397	1397	1678	1	1	12749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFZKVh691fFJiZdmmpFGu5QxHUYVRrLurQk469eNaGS77j8Wj
32081	payment	2134	2134	1874	1	1	3243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2goV1DNb4wLSmNWWXbpQAiio7AZyvP5ddTr6Apq6gSyoHYiz
32082	payment	2133	2133	1874	1	1	3143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkiWjrV7kjaNB6HRvkhkyY49iyybDWo4KjxtXPavvSiyirEqez
32090	payment	2134	2134	1874	1	1	3246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphcj5xWPfBsHpHKdqDfCaY5uPo7vnkqVHeWm17sUzFjP5wWeJ
32091	payment	2133	2133	1874	1	1	3146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4TE6JNqWSZCg1HPwhVdiHhfkF5frumUmxHHM86xvCxCuWF3k
32092	payment	1397	1397	1678	1	1	12753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVYv4PwUYQ8wtGdicVmkvQbJpMTmsY2pAQdfZpUipdY25Lanp
32105	payment	1397	1397	1678	1	1	12757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiHhDozv6F9bSXm89hZzRgCTSNgZmc2wd9agSK4JSLo8EqGdr
32106	payment	2133	2133	1874	1	1	3151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8envg2DmUwWqMLkfYaK8eJtB6EjuL2iAKwh6B7G5JK5nb2Wx
32107	payment	2134	2134	1874	1	1	3251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1TXPuwkDb7oeULzwWdPabY8X82ZEWth6L491XvtFnkMDH9dR
32124	payment	1397	1397	1678	1	1	12763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34Rd1KMnHCvKYKvTMZVe6kgJV4Mm8UkokYA3FkhvLuBgtm1hY
32125	payment	2133	2133	1874	1	1	3157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A3WnzRVag1MghECnS5tM8dkRMEqbemArN4CKAwSuPkVSBvss
32126	payment	2134	2134	1874	1	1	3257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmCde1a35qTAfBFqXF9KBN2UKJ8V9RmG2PTqFuFFXLErgn5wT
32127	payment	1397	1397	1678	1	1	12764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWt8nJodPvdc4GGyjMp4jB12sbhhqhcbPUVB3nscBxpfFNzhKF
32128	payment	2134	2134	1874	1	1	3258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9YBKUJaFHzjE7AwxQdDRzbMwv5bwR5QcnvtRDMTtcL8UQm5H
32129	payment	2133	2133	1874	1	1	3158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJh6MscNBZUdy5k21jGcGn5f2HSCsudVxmKBFXhgjxuTs1puR
32132	payment	2134	2134	1874	1	1	3259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7LYRyoSDyY1WUZ5mMxE6knmWrLTvUGjTJX74fzHPnEYJ3tUp
32136	payment	1397	1397	1678	1	1	12767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HuQ5Zzvn3Tuzc4xnUoFWUeyWvhkCYzG8R4JmhuN5tmvp8snc
32137	payment	2133	2133	1874	1	1	3161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaoTjJjAQowgdWypo4tvqRibw4VAFWhpqR5jHv6Ampp3JWhjz
32138	payment	2134	2134	1874	1	1	3261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQggn8UjPcBeU31nNH1wMe3wURVSVZkJunCQrbEbEKpnuh1mG
32148	payment	1397	1397	1678	1	1	12771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8SqUFQfRM7gyLD9DDZkwT4Hp4Z6iaJ5Wj3rkGMqWYgwqE7fE
32149	payment	1397	1397	1678	1	1	12772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG6qssYJTsoSqszFbpvUkCSANGbFrCJYU1YrJkj2sVqYrCTzs
32150	payment	2133	2133	1874	1	1	3165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD7LPMicX3JN3ShgwecLnKzUbnFP3PxxvUtQbxYiNihV4KNwA
32151	payment	2133	2133	1874	1	1	3166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLSV3EYiduPwCUM4LRicBSyZk4sroX8d3SARxEN5fTJMh9tP5
32164	payment	1397	1397	1678	1	1	12776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbbgrW339AReyqSvAyJtAkekw7P7fAyhutQ8y9LygB7QhW3Eo
32165	payment	2134	2134	1874	1	1	3270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzgZ3ZjSSfbwWc1wTeskqFe3zWm4kqY3k6G8AXXKXAfL76dti
32166	payment	2133	2133	1874	1	1	3171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW9rFCWhPbL9y8a4oeciJbugaqtLwmEHMG46Te94JsyzonySf
32170	payment	2134	2134	1874	1	1	3271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkYMdbGZauEojJFfB3uGJrapaDJpQQpSaSJUdHgwPvhLZqri1
32205	payment	1397	1397	1678	1	1	12787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUengzybvoscq6QCwwtUFiySQEC7K17JyiEnvfYyENKjTvRPm
32206	payment	1397	1397	1678	1	1	12788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8de6Ngrhwwxqz8ysSKeRXiAVfAME7JYKPCphBzUCmyTMjjVNz
32207	payment	1397	1397	1678	1	1	12789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTeghtmTaTpGZZ3EW7gud7D6XmFcv47Eksb1sv3Gsc8TWpKAX
32208	payment	2133	2133	1874	1	1	3183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjJsocnUGH5FLUDYuxBxw5UU2sfcknY6cRzHybJrUj4Tah7FQ
32209	payment	2133	2133	1874	1	1	3184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB3VGKRMrxQd6fLaoeW9Xv6jdnZBoP4i69oNa4Yipdn3E6zPz
32076	payment	2134	2134	1874	1	1	3241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrm5TyqRKxunHmGbMP2i5AxLnwHgLbV5KbSW3cmkXTsqR9o6c
32079	payment	2133	2133	1874	1	1	3142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtA9p4dvyXnMs47qpqpfhXgrsEt8jbeqbw7otBALcshaEaG5A
32086	payment	1397	1397	1678	1	1	12751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuapGsaiYH1PwScEWWMvs3ZizM7WbZ2MY1S13KJTuP9kdsfJBV
32087	payment	2134	2134	1874	1	1	3245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpKUjrRdWgi4QjdjVNwKcDECyufuegB5r3yzdeqfriWWL244H
32088	payment	2133	2133	1874	1	1	3145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfE5vYZ7dmp6kxZm8Naa4PbdrRH9233itR2L8Rrw4tzFD9nT3
32093	payment	1397	1397	1678	1	1	12754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nsBKtgSt1WMZCDt9dUSshArwYExz5w11zjGWshSMzFckET8k
32094	payment	1397	1397	1678	1	1	12755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg65AVQVS2xeEfdeYfRtqhFt7HzS5AJQGVGF3J1Ww6zvFLc1S2
32095	delegation	2284	2284	1406	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSXbUvQXAB6BUguPEXhNRQABLa8S9dtoSirt6ouMJsPtvYu4f
32096	payment	2134	2134	1874	1	1	3247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JfQveLkEkz9yw9PXJP6MFUnA9dQxEJzy61Y9dGaY9R43hgsx
32097	payment	2134	2134	1874	1	1	3248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoX2iuYBFiob7yBuA8KLV3BCqWZi9HydSs222cGS61pi8n7Chf
32098	payment	2134	2134	1874	1	1	3249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7WUqVBEbbSEWZezbVKKt9kGxZ5SoQ99JwtUEz46HDW7Yfk8X
32099	payment	2133	2133	1874	1	1	3147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTeDgGBNc3yeq4ntDbdSzTBnwgyCB1Ypq2qsVfjUTqi2LLsPS
32100	payment	2133	2133	1874	1	1	3148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphcP9A7ZGoYqUrrxc2PR7jdSbDPL98J8RrkZSXGKy78778Abq
32101	payment	2133	2133	1874	1	1	3149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfB3fikxLHgLRFAJyWjnYEhwZPsysCXQkeFQMJCGz2MZ2r1LeV
32102	payment	1397	1397	1678	1	1	12756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUSpU2Jpyvpmd4vRhDdjmAcewAp8XmTbtxep6Na6BV1GbSd1d
32103	payment	2133	2133	1874	1	1	3150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJJQKwxVYkB13qcAfTdQV8jSNLGjzJbT3AbtDkUv6vZCHRsoY
32104	payment	2134	2134	1874	1	1	3250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw82aTUX6FLa4hxsX5W3wXueFZz9L7bRx6UBCjDafmKaVzbv1d
32118	payment	1397	1397	1678	1	1	12761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS8yNHUkRg2rd5zT4ttU5FUAyG9Q8cvkpML36YP1EgsavWVbH
32119	payment	1397	1397	1678	1	1	12762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7KF6GV2pCqU35ctFv1GQdjPcVu8Xos4i9GFMQzAsyPXak4sf
32120	payment	2133	2133	1874	1	1	3155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMyQZPDoRLrDG1U82J5cfvoVJfKKkWwVMr92LMGfNUD11PRgP
32121	payment	2133	2133	1874	1	1	3156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtvcZBKGXMXnF6gzKC5Sbweu9k2pEhizBJTk28cYYSo9SU171
32122	payment	2134	2134	1874	1	1	3255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3BBcRCFuV1VivYcBhyYb8EKYdHQnobXpfbvWUiCq8DDhwnfF
32123	payment	2134	2134	1874	1	1	3256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJrovee1ACTGBuThs2MY8yYGpAUxpXX5PKoViX7RUXxj1wFPX
32133	payment	1397	1397	1678	1	1	12766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVx2KxMYebQvGNuCsUEFVy5j7XF1TAague6v28e28TxSQ9c2xt
32142	payment	1397	1397	1678	1	1	12769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbUDJorW5s9eUyeEHf9S3XpEgoAb4EMgMKGpgs869q1bWtbtd
32143	payment	2133	2133	1874	1	1	3163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcDD4ZS8goog7MsvXZfzojeaQapTHJwfvGG8Mv2Br4Kbv4Gdv
32144	payment	2134	2134	1874	1	1	3263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnjCCMuMEaYDWaWWVrmNrVnF4igYgwSZMf3E5XtvzRTSaswvX
32145	payment	1397	1397	1678	1	1	12770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpTfDJEZovKuZnWiifhxQHnC3Cz3udLTXhybFqvd1wh9WW4Yw
32146	payment	2134	2134	1874	1	1	3264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpbgjqSjeEsvp19f5VMPgnCTVwTJocToxtRT1FWXQ47PjMpxn
32147	payment	2133	2133	1874	1	1	3164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zkmBxGdEktUi9ABthxmUsLWpCNNFwxnnVZhUM7GT1WqJbCzn
32152	payment	2134	2134	1874	1	1	3265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFSrmhV99oSvoHCMoCGBNTxcoLWrQE6gfDBdPfLjjnhTYcj8R
32153	payment	2134	2134	1874	1	1	3266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFqJQQjxGHcAg5b8Q9MBiweQWqDtz4CJHtHiPsjmMDk5vytaH
32156	payment	2134	2134	1874	1	1	3267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2dpX7Wc3aQrqD5kn8M1T9Qg2GNahb4XuCqREG3odqrEqwLjX
32167	payment	1508	1508	1021	1	1	6	2552379382616	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZKYNeyMi6yyXgYQm8i8Uv3ykX3Grss883SZxXHrUyq7tr9NyHS
32168	payment	1397	1397	1678	1	1	12777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvfpkSNmHq99vhm42r4beSvYddSVXK1w1Jg2HLTUbCJ3TFjnS
32169	payment	2133	2133	1874	1	1	3172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98yav4TWPYQKDpiRHUQBPmmzLMyXwCdiU597VvM7t7zGPStit
32171	payment	1397	1397	1678	1	1	12778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bP16H3qeYtuTUfv7PKhH5aYBLt3PTdE4g37P9FNXcpb29pCP
32172	payment	1508	1508	1141	1	1	7	4573841984852	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpaB2Rj4B1jXgTKmpmtNFCfgiLxhYaTH9b9rACGQkWLzC4mEs8F3
32134	payment	2133	2133	1874	1	1	3160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAYfoj9RjHm9J54tj65M5wgwfNrPUuXS8HHaezQtCghRYxxJz
32135	payment	2134	2134	1874	1	1	3260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6moonKFNqQRADi744PxNHTLTt3fwW7ghuiVPCo3uoea8xaQR
32154	payment	1397	1397	1678	1	1	12773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEf6AUgsdtLZ5iwoWJJEdzUacx4iS3XnbJ4dKGbS6FhZ7AB4K
32155	payment	2133	2133	1874	1	1	3167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyo7n9ShrGrWoQGz9GjLEtiLVnmm1c6VbDc3YYCqeXkt7UyBza
32179	payment	2133	2133	1874	1	1	3174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQvKJ228iaYv6asjEafqKXEXbybhAfDRViEsAwTQ1Xrq8g2PF
32183	payment	1397	1397	1678	1	1	12781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH435ZJseyLbob3kqRiBDeHPvqevVXnJVAfkPfLnyAWgyNzUo
32184	payment	2133	2133	1874	1	1	3176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXC94X7J21E4Ug8M2q42t41GXNkVmwY14VCDdQTa2wWS8WsPMT
32185	payment	2134	2134	1874	1	1	3275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VCAiYTx3LU6HvREr7agJUoo5KKpziFzDsmED4LxBVjvpa1VZ
32189	payment	2134	2134	1874	1	1	3276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRMZq4XQ7La6oxRpJSQ2Zd5vWZBkoFcPnQbC4jvLfiveMC3F9
32190	payment	2134	2134	1874	1	1	3277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4f2oeg4pz5xJ7htrGTCZp6jwmTMk11Ghwxsxotaan1iUVY94S
32194	payment	1397	1397	1678	1	1	12784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXaKruiRDGt7GUrGp12NB4YoboKXEsgTYPReYQnJ7LND28drU
32195	payment	1397	1397	1678	1	1	12785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEtv5bWvAz7dBjyv1p5A6yDehDsQidA18VDcAwZYNnL6tdcbo
32196	payment	773	773	1508	1	1	0	3801812300	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZs6jwXaLrRHH8RiZUTah6kfGGys175BqMgVypkYFA7jCigbsPK
32197	payment	478	478	1508	1	1	0	251569611955	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZws4TJqtpCt1KVV3wb3ht1b9xBvgi8pJgRJWKpkUABt5eWxNz8
32198	payment	2133	2133	1874	1	1	3180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dNCsVpiFQM3TjQozNp3BS2iJrYrx5E2ajiiBjaW8pEVcUw2M
32199	payment	2133	2133	1874	1	1	3181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkN2ycd4JSKkY4afMLgnctMgSXhQJZurtV6EEaGy5DTRVBpGox
32200	payment	2134	2134	1874	1	1	3279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xzhcHpfG4MCBR7JyA38GJ3fij9iJbF4aR6iJV3aDMcsiA7jN
32201	payment	2134	2134	1874	1	1	3280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqwh1REGzes5FeVg2LQKviQMthuwj3fwLME2QAC1cspPAbpwr
32221	payment	886	886	1483	1	1	4	0	10000000	\N	E4ZRdmB7ixZTk2KWStWBZZSMhXh25Dg7fzatagZfFovwNhvBtfisG	CkpZRDxAud9TvWwX7PfCTmiYjFpcw4CogVwDpSJnMih9oiMJCKu34
32222	payment	1397	1397	1678	1	1	12792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WVzgywwdVpdjdAhYte4HGaiCXTjBCNycRqD5SJr5Zzp5c3mh
32223	payment	2133	2133	1874	1	1	3188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdt56CSgEWdziKzeENb13oMWnCLSnsqiCvTa2W8rQx1fGQsBbf
32224	payment	2134	2134	1874	1	1	3287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoY4iZuUkCME4pgS3tQ6zhNBt18xYpu6omfT9Z6TnJ8bHSsRs6
32230	payment	2134	2134	1874	1	1	3289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMV4La7W94wwj8NVCboKFLMgMU2AjheSCnZazDk9UtwLTeKkz
32238	delegation	2290	2290	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsdFkBPsBVA6SYaYgbdXuvzzEFqTEDCBdja9ZU7YqhPnoKtwi
32239	payment	1397	1397	1678	1	1	12797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvPKYbR18VNz9uERpB5GFvBAUspVxgNmeuUzMb7weumCQEaWz
32240	payment	2133	2133	1874	1	1	3193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhSvgWpGsujYsR9kJoyiCQe3fau5H6yWBDfuKEUGnUPSdoLkf
32251	payment	1397	1397	1678	1	1	12801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajvv9zkLqZznusMiQV9JDBCsntfVTiuuTZm9YD2NVXEMqfyoR
32252	payment	2133	2133	1874	1	1	3197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfusuMndAQ7b9tQuWN8ibgzRQMSdyxsRfV4V1dnX2E34Ee35c
32253	payment	2134	2134	1874	1	1	3296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaU4MehqZBayf4XHpn9kLj8oeW5Ez5toV5QSQZfgKHh8e5uaR
32261	payment	1397	1397	1678	1	1	12804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXQV9gFBN5n22PssE6Xv1vW2WvaTdmkdEpp2YxoTxsCfzZ1Zi
32262	payment	2134	2134	1874	1	1	3299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdzw3Zt3ZLmcSuJE2tufFwj3BcUfHyCLddaT6G2iptsySRBd53
32263	payment	2133	2133	1874	1	1	3200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57o88z2gRvPBJZ3aD3cW42YHMyR8bHkJrYaPvX9gpY3wQdcf9
32296	payment	1397	1397	1678	1	1	12814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45GUKYXvXxh9YxG2R1iuP2jbXwMXaAGc4iz1T14KpDrH15sUx
32297	payment	2133	2133	1874	1	1	3210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQogyuFRAjjQ8iTQHnQkMGcjxv2PeyS16X3ZnVQ3XnSLdCnmfD
32298	payment	2134	2134	1874	1	1	3309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ViHQpdqUrNLZ5rmipdMd28SDdnTyWAn76nBYMQhZJWVjpPsF
32335	payment	1397	1397	1678	1	1	12827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8jQQaqWLNKabR1p8tS5TzoZ8BrHt8qYn6kpK6fS8eAqQ8sXY
32336	payment	2133	2133	1874	1	1	3223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiQDARpbFwdisqwc4YXL5pRczuxXHg19eFv5wKjqFiG6atGKX
32337	payment	2134	2134	1874	1	1	3321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxZYQ3wJmKXwuipD6CbfX9gZf3yTu7bLQs19fFfZS2DVq6TVV
32162	payment	2134	2134	1874	1	1	3268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnoF9kvTDkKgAShRLeGGdBMTfcAF3wj3MC9AAf3CLsCSg5ytk
32163	payment	2134	2134	1874	1	1	3269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtBVNMfPp3XJZEH25dfukHX6mRr6AP51hdiuknNvgAnuqPdd5
32176	payment	2134	2134	1874	1	1	3272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZVDrtDGoNWGDNW3u4CnNHrenSFrfeT6fvKJqEKd5gK8snkvr
32177	payment	1397	1397	1678	1	1	12779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoGfAQU6PRorgwrfoHECzFw6ewwANaDo9MrucHZPjRCjjSM6v
32178	payment	2134	2134	1874	1	1	3273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBQA1jKZX38uGwci2HEGjHhdBhEq1kE99ifX5JvAHZvcjpsoA
32180	payment	1397	1397	1678	1	1	12780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7Skkhoa8uqvZriqSvZhecFEi3i1FoeoRALzsU7D4aULKMZaV
32181	payment	2134	2134	1874	1	1	3274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrcP4VXhz58Er4pF5XqKaqDsEdM39HHfNS3Cx3VNdVigVUPRM
32182	payment	2133	2133	1874	1	1	3175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKv5DpFizpvDdToroYnuDzi1wc5VZuE9Dkjr3s5NYV6jv1gNCF
32214	payment	1397	1397	1678	1	1	12790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYke5xUQgPe1NvgTBmGrHJGaZ6Da8uYgXfEffcqm5343bNBg7D6
32215	payment	2133	2133	1874	1	1	3186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjveM32FYJugN8WMvD8gTfDfJpue8czVUeQ8fWkQZNe1MSG94
32216	payment	2134	2134	1874	1	1	3285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzMipDFdKnzx4KLK4VyQwbRMP2Pj31fxvKu1VWwQgtBqDzsSi
32231	payment	1397	1397	1678	1	1	12795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCZ3taBzUZV3kpqRCMyzvcnuCV9fqNTGkQE62A5fsFqTdpJZ7
32232	payment	1693	1693	2290	1	1	979	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZu9sr1B5RJcdCN4dx2P9gZihQ94kmPgoKb4Ux6hkFVy7m712Ag
32233	payment	2133	2133	1874	1	1	3191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYGQb8yCdTviAcH6TTzuUHnAQNzKxBwwuNSdVjHGSs63WMzug
32234	payment	2134	2134	1874	1	1	3290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJCKu3erR8idffabYDZ6ZQZXotkt1NpsLbTgg7rP2wWHQoLqP
32241	payment	2134	2134	1874	1	1	3292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAuh3rDyLCNdLPG7t2QxeiYkJn3FXCrDEiGRMgEgvvxhGxGoU
32254	payment	1573	1573	1958	1	1	5	200000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPy2dSCnRYTYwsqugSoeAH7BigfJ5NevGXRnszJw2YpT2ddWhF
32255	payment	1397	1397	1678	1	1	12802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnGKwLtCb1jrZDDcFeB5qMETasmrdkEEmuKgARDz5nGta1ank
32256	payment	2133	2133	1874	1	1	3198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQjFVJCrXQ5WF2stsTPazTVof8y82Z8KGA4pBz3HbmVzkLFfr
32257	payment	2134	2134	1874	1	1	3297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQ5E9iXXiad8XTxbjxMrZU2z6mGTB819r4ujysPi2jghXwjdD
32274	payment	1546	1546	973	1	1	6	2188340000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaEnvytq1hebPbycJ2imkFj1QuDw2UrPfNZ3nfiM8oefXAGqUZC
32275	payment	1546	1546	1213	1	1	7	2645900000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaLCzZzpig55oNNmwkMjk6PPswoXDWKJA5dhDhkoMHp2g5CZc3d
32302	payment	1397	1397	1678	1	1	12816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTtGmsaNqramNBYzYWSQzdTT86P9WbZSQbhZiKvjtgMWknroy
32303	payment	2134	2134	1874	1	1	3311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzuNMpvHqQYCNgrgrxYyLHxryR6BLXW4NB7nYFD3Qyo9Aj5Rt
32304	payment	2133	2133	1874	1	1	3212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8fbtpouCbPYnQGMC1v2uWYN1gQyRB2qi3z3N7Sp2pgTQk6oe
32305	payment	1397	1397	1678	1	1	12817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2em425ibf89PVJ35s3KgrHtuGuvqCwZ2FqqAbU8CtXxbbwpZ
32306	payment	1397	1397	1678	1	1	12818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeydmtnisLtRferjAuE3kRAQeBg4kuVZuUoCrBtJQGPUUTwBZ
32307	payment	1397	1397	1678	1	1	12819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FscHyrWRg6DYFnuZ6BSGyaNcR2Hce4EMpojR1TBhaFJ5AGhU
32308	payment	1397	1397	1678	1	1	12820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwif6qooLoYGqYZ1GaybVTVNPy98312Qk69NWPsWbRZzzTNN1S
32309	payment	2133	2133	1874	1	1	3213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzUihAe95qMXjEV6AsWUisENrBdG3CHtgVwdDLGHJZWN254Qi
32310	payment	2133	2133	1874	1	1	3214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2VpkkbnungGU2w7g3j2tVm8mahPwTxyNTDN256GcTq1Z5vDxd
32311	payment	2133	2133	1874	1	1	3215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHGiFHY9qNK8oMV6ZnL9Bon9SJkFQtErc8pQfSsLawEJrkYwK
32312	payment	2133	2133	1874	1	1	3216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLHQMbr1Pzx33iW9iogo6YSbdovqiTxWQ9BkccWwCvkord48E
32313	payment	2134	2134	1874	1	1	3312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6uELK6zzKpXMwEp67VwkWDgWePC5e74KvByWG4mZDsvqgm2i
32314	payment	2134	2134	1874	1	1	3313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSFS4bBWaBhbHvoY6aagrpUmm5tLGnmxaSTw2VWphTRvUevvg
32315	payment	2134	2134	1874	1	1	3314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURbp7B81vXk1puUyH3SchMtvbfzcbGuZUjcpWcJ8dF3ugmWRc
32316	payment	2134	2134	1874	1	1	3315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXT6Z5PcNZow2CijpaiE7H7AKzpepQHXs7AM3e8MjoFQhYp2q
32319	payment	2133	2133	1874	1	1	3217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGd5VrWWwhrLDKqDoH1LY7HES4Fv7Tag8nomnzm93B4i3Yrxy
32173	payment	1508	1508	1261	1	1	8	3086062327432	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	Ckpa73GcbUEThbHBbNcMJusVhs4PDAvoQE1nvjRLpUQHcsNybvcs8
32174	payment	1508	1508	1387	1	1	9	8599587072748	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpYmJre6BxKpiXegJ6Go45bZiK5ADdcQkQz8s1NTSyA33SvBHX7V
32175	payment	2133	2133	1874	1	1	3173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxM2EZj1j98i8Zzvjhb5XXoQfe1vZyZ2wfADAbNCJNDmkgYHf
32186	payment	1397	1397	1678	1	1	12782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GnuNmukVHHiBfonHKU3Sj7xw24ec72AhsyxX6AKYBn6P34HC
32187	payment	2133	2133	1874	1	1	3177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cYpn9obuN2pGfMF6TvWvP5P7oDHmNbyLVWGE5uSEkGAkWtaw
32188	payment	2133	2133	1874	1	1	3178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoPmMsgn5eWeMBa5Cs1XGzwTCEhYFKSu9Hkh3Bi4m39K6yKQm
32191	payment	1397	1397	1678	1	1	12783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamY92buXh3n6V5xDSZanGyWKfw5pKq48RScLBZo1r1o6vkQy4
32192	payment	2133	2133	1874	1	1	3179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAAqyyC8gXZa6hg3Kw9hioSuHjpJcDNCu6wfdDmWRr8DxNNK5
32193	payment	2134	2134	1874	1	1	3278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C2QS4WUaZRDejiBTdECiT452LVuT6yvrHWNCQG18LtgBtdvq
32202	payment	1397	1397	1678	1	1	12786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pCeGy4YrMadfvrPnYSGzdMWRfLqmsqii9y4M4vGHhvcNbbKz
32203	payment	2134	2134	1874	1	1	3281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VvE3sJbygvtPfLxCBrfAStqoTEmjrnfkjiQ6pxZj4xFkFfzj
32204	payment	2133	2133	1874	1	1	3182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwnZYqfzqvsCv1xcZXgUkqKtJ1QpQL22ZrTRYWSpEyncGfT8Y
32217	payment	1397	1397	1678	1	1	12791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWz9mF9p6CgjzbcjKnCbbxjnkobgiYPDfzdvYdDQ4rCFDzBnW
32218	payment	885	885	1483	1	1	5	0	10000000	\N	E4ZRdmB7ixZTk2KWStWBZZSMhXh25Dg7fzatagZfFovwNhvBtfisG	CkpZoRDgvZhP2FBj9uPqBfePnxSPXT7CNQrsZ8FHtQBCbbvDe1Xrw
32219	payment	2133	2133	1874	1	1	3187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk69xtXaymJkLEbqt7Nd8Bk68eiubcULgyXt92sMEu7RQ58qvJ
32220	payment	2134	2134	1874	1	1	3286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkTiX5r5omieKXwJK9YbFkvDoa2gFfvowe4pdwJty6EwsiRfHF
32228	payment	1397	1397	1678	1	1	12794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5N5GrVM1oEEXyXpGfEi3eE7R2QgyhivLAxuMWHN3cdRzzi29
32229	payment	2133	2133	1874	1	1	3190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EUdyd5873sMdEZJiihVT7bsLnGBVa49D3CTnyBbuyeHNvzTy
32236	payment	2134	2134	1874	1	1	3291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6Z4SLLE2t9H1uSASstoPtFtFDtHyTAKVwyfxjQngtoxXt6P2
32237	payment	2133	2133	1874	1	1	3192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwD72FgCSjNrPGx1hZ4woBovL57aT9dfTkAtXscwfB1x3pYdW
32242	payment	1397	1397	1678	1	1	12798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEEALTJX1EExcNjQthJG3RFmj2UXh9kWo4pC2gvVJNmy6zQG2
32243	payment	1397	1397	1678	1	1	12799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4EA4VNPZaxoUcHPr29VEyAwwFGGcsLbYrjBGvZN61kvj12VN
32244	payment	2133	2133	1874	1	1	3194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwr9puiEP6BwVxqwUDR3ViJNnKAopixQ13Nc4QSx5FkLDDako
32245	payment	2133	2133	1874	1	1	3195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqUZTkzb2GYDDtBizd7YRpM9w5mLxT14MyUvurcgQFJkCZYYH
32246	payment	2134	2134	1874	1	1	3293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoc7kQmP4URQAjiTDNWFa2pMxW2gYU6jgnnXAbnbwhQAAk2g5
32247	payment	2134	2134	1874	1	1	3294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjXd9HLviSU2Tc8Ce3XfywreN2QCGC8S6suM7yZ82h5C61Ytb
32258	payment	1397	1397	1678	1	1	12803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Z4rxQzLJCwXSgznuhyRffcfhjKXtiTxo6TrxWDMw9PG5M1k
32259	payment	2133	2133	1874	1	1	3199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNDHzZNQbjAGW8zTFKZ6FufWv2T5YvQUjzP9acbd98oPFPZji
32260	payment	2134	2134	1874	1	1	3298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzugme2aHkfQvw3yM1j8m2VbFdUM33bPBuiRKLSoZjWyF7S1Xd
32265	payment	2133	2133	1874	1	1	3201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMZ1v5qzeThakkNpmLk4wzoqtyWErfHCcQN6Y8BRgkctJ49pz
32266	payment	2134	2134	1874	1	1	3300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8fJ2AKd3o9Sj4fToUwzWV6uerJZ5CcFdn2TPah326MAWwBrT
32267	payment	1564	1564	588	1	1	9	780000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eXrgYjcGYDBTDJp5KJGBDA581oqWJw7e8CuLPMA1ERfiReNh
32268	payment	1397	1397	1678	1	1	12806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogWAGEcTsuWi9rYkUhSCSrKTbh7wZk4ee2K7fgVkHVifE67LD
32269	payment	2133	2133	1874	1	1	3202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wYiyVaAjEBu9A7JGsqXVWSjuEyM5otYhTspaLSMWvxW7goAS
32270	payment	2134	2134	1874	1	1	3301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EVfZdDNDXnHg5FbgiQKgQF7wGy761BSksemdiARGKxp4jXiQ
32290	payment	1397	1397	1678	1	1	12812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoPGDHGWT9GuZVow2sCnQr4M7ko6b3MMTQjvj4vQWEskKkBaN
32291	payment	1397	1397	1678	1	1	12813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNWgUPqQ2heEnUwg4QTrurnjyHT1zT8gUfPJTU8LGbfJxnjcB
32292	payment	2134	2134	1874	1	1	3307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FBxFsgmPz68ELSqjfYf6HjUzDEwuiivW5DTZNgPBFGUfZTFD
32210	payment	2133	2133	1874	1	1	3185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyMFnDehiPzvFLtWu6UXUHHtthX3FR7QrJLfhgp3FubQ6jp2z
32211	payment	2134	2134	1874	1	1	3282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxamnuP2LPti9S6sQNteqHs7oXr5JfwPZbokQpDbwR7YTGr3D
32212	payment	2134	2134	1874	1	1	3283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G5DY5GC3SaswadD3vz8QkCGHEiNUMFmcyLghupDE99S6iVEJ
32213	payment	2134	2134	1874	1	1	3284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkp6EUc5b9BpohEWsmE9YJqTd6MRfpRasPSrVv3KazQjdDGakY
32225	payment	1397	1397	1678	1	1	12793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesQSFRZJjj5MCBEXvfEPSrWcNLApS7Cg5zCbFJpRJhB9kh1it
32226	payment	2134	2134	1874	1	1	3288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6E1QUT3KUHgzqR9u3SsR3yNDrHV2YsLQspdpufJeEYmtnGJP
32227	payment	2133	2133	1874	1	1	3189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDj7ZC1BFp2RtFFSDBtSXipM2h2H6RSCLMF6513Z6ceLdc1tN
32235	payment	1397	1397	1678	1	1	12796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecsShKT4BeM8b2Pwr3oiQRRS9ZAgd9pjJe2LM4opgcZUjhe4W
32248	payment	1397	1397	1678	1	1	12800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFy1ztd5V2Td3Ssi3ixgA1Zprj1LeWj92B4mm56gWDTHV4y3e
32249	payment	2134	2134	1874	1	1	3295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1DF61ihQuwu8rZDke6jKdAsAmDmwVEz2wY3eQmehSX8Yd3kq
32250	payment	2133	2133	1874	1	1	3196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qR6eYjWmAeTaBLuFCqTBYvNitT3Xz7JWZXuyzKuKp2v8PV3J
32264	payment	1397	1397	1678	1	1	12805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuQ3ziYYipM6tCEDjiMCpA3BbCEnX62VtLw8aYqWqpQ6ZwEic
32271	payment	1397	1397	1678	1	1	12807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqLVyisXUtZ8iTFEbe6P5Jd28JJfHKjjFTPV6egELVm7o2KKj
32272	payment	2133	2133	1874	1	1	3203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmC2b1whWkStRM9CBCp7CyJDMZQ47gCBxoevaqefqiKsfFerQ
32273	payment	2134	2134	1874	1	1	3302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEhxjbgcf3LXbMhQE8tV96CKJ51pMMMnWZDeVEzHFJe7fmfg3
32276	payment	1546	1546	1093	1	1	8	3921480000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	Ckpa719EziyTxFNV7pJA6ZR2abvMhBTKrUo943ofY52AqVwBiFgGu
32277	payment	1546	1546	1339	1	1	9	7373030000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	Ckpa2k59uiTqCJPinV9VQ75P7vCo8pDCK5spLGFav5ksZxYdRGkuH
32278	payment	1397	1397	1678	1	1	12808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLVd76zMVwmBvVSV51eNbY2pt3wYsFAV7xuMG8M33Esp1B2wb
32279	payment	1397	1397	1678	1	1	12809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7QJXMZ4HmqmdL3BfMHkCQeb8dqahpHqUHxCJmCJ23JLKdjtb
32280	payment	1397	1397	1678	1	1	12810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwiP9bkJoNwUeq1kYUizKRQbwA98gL8eBX5RdbNX3E6qfTFTW2
32281	payment	2133	2133	1874	1	1	3204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrthLLBFvZbQBViNhbbybG4d9w7xzkyRJZuRC79kueL4tMt8TW
32282	payment	2133	2133	1874	1	1	3205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEPg84xiqfF1YbNKDqw71cEHcP9WtW5qZNqKvFNNnikLtNcbJ
32283	payment	2133	2133	1874	1	1	3206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacuFc2KmnTqVnykPTWX5ocfGYGXAnMceuArd1SdigL8giuFXz
32284	payment	2134	2134	1874	1	1	3303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQK2Nod9FJ4QAhM4e3gR3JyiFaFgtHLadQoVZmh98mi19cuhU
32285	payment	2134	2134	1874	1	1	3304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HrvxcFVys8JgANFGatpthdTkVWAXUBKkG1ygtFJWRWSCYFK8
32286	payment	2134	2134	1874	1	1	3305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDbZmrxkAmLFg3x7ksybBnyzNPJHYYvui67Bj9wYTRwQG11TE
32287	payment	1397	1397	1678	1	1	12811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKutsGNhZzLn5TC1MpXtmSDp58jeptXwmi9Bc5oP5LBeftaeVu
32288	payment	2133	2133	1874	1	1	3207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayrc6aCrSFJvnqfYHN98K5gXT7PyhUpk4k6YgiBWs5rC1DsiN
32289	payment	2134	2134	1874	1	1	3306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9LEeHPoGfaVj4eHVZWYtKrrGNHaPdcQyoz6TTT6CqgQ4aHrw
32299	payment	1397	1397	1678	1	1	12815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2jC6DQB1TWw7Fw8sW4gAuaRsjau4oTV1HcM2eD5DZjGvqk71
32300	payment	2134	2134	1874	1	1	3310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgmnvMWfmPk3hvMFFLFHNfMKwrPBsCG4TKReehcNQ3T3EzYFW
32301	payment	2133	2133	1874	1	1	3211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzhEANFFqyJdZjnuScTt3j81HmfoYfydipbppWQC9PKqSmSUR
32320	payment	2186	2186	2291	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCyHvHYcfDCfNBfRsSQzf6FM7gCW9uRbttY2ZXJwrv4SpJyor
32321	payment	1397	1397	1678	1	1	12822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZwrtGLeUGwpNuJFCKYvJoTV6FqRwH4cSuwfSwhEY3C5xg7xq
32322	payment	1397	1397	1678	1	1	12823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xSHvLvkc49K8QKvpJ9hWAtmJjJJXjY92cngwpUe6wEVcMDDo
32323	payment	2134	2134	1874	1	1	3317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUpR59ZAJLtSicP1YS8bBvX88DRvHzVs5qbC1tjULACxhFGcx
32324	payment	2134	2134	1874	1	1	3318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KnqVbX4cW9JX8aV37Jh5iAxj4YqECziWYrsGVxTNCGxzF2PA
32330	payment	1397	1397	1678	1	1	12825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuPyF3aLS9y4wWPw5BMGLvyUv9zqPqwyreD7cH6QcrhpyKe7V
32293	payment	2134	2134	1874	1	1	3308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgH1NBx8LvALzDVwz5zaHFxmbWet3F4K14bYLLXENEHjo9Gf78
32294	payment	2133	2133	1874	1	1	3208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3CqEAvfAfhZ5aeTBP3aK4JxGozCk6imTET76B7LUfNqfsAKZ
32295	payment	2133	2133	1874	1	1	3209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFP7pmBfX2VkWXoR9vWDiHakcX6G4J67LZ4SZQgJqtGTSXKLq
32317	payment	1397	1397	1678	1	1	12821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BrWkFUhqQ9vehCxQLDdi1wgjgBaZJhjFok53NfSo7Ax2xWyr
32318	payment	2134	2134	1874	1	1	3316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3Sv6usqxspNuSmeJvXa9uj8jBBXNVReZvX7VJz4R5U5SapaZ
32325	payment	2133	2133	1874	1	1	3218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLGLuDwnsgwvWJ23RrNVd2qHAucGKbyS2ymrJXQue3FEDPFMc
32326	payment	2133	2133	1874	1	1	3219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4RRUqEEWvK8cH5w2LaBzaCueDKYg2RwNdcJJq86QHJADknUr
32338	payment	1397	1397	1678	1	1	12828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeBMQqvi9nYKk35We4LbE4jtWTFNeMWMXEUChHgCUjkanu6nq
32339	payment	1397	1397	1678	1	1	12829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcXsiLC4MQEvoXuyXnQvZojpYQTEA2pYVy6CaqWqsepwZ6KFJ
32340	payment	2133	2133	1874	1	1	3224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXpo9PzhX2YuYzKYaJy2Zgeps1xt7pn2RBXxk4MeM1YRJNcNT
32341	payment	2134	2134	1874	1	1	3322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PeENpzQy3X12Ecu8A2nDpQFkWpUrd7ScqQa6ZaCQ8GEZmZ7P
32342	payment	2134	2134	1874	1	1	3323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyPXxyA5zrzVZc5CsES4wBirAPxpQGkbVYTpHH7cL9uu7iyR
32343	payment	2133	2133	1874	1	1	3225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPTE4kqL7fddNP7P9DhKhJbYaRYwmkDhLa9Z9JZPgvfL7TKaB
32344	payment	1397	1397	1678	1	1	12830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKNbSPBC2mCfSgxvEocbG8yrWyCrT9NoEfBqnHyM1iZ15Q53c
32345	payment	1397	1397	1678	1	1	12831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW34BEPMunM2EyJuQWMRWifdUQvU9MW7QFmPmVgcJJ7b1hh7E
32346	payment	1397	1397	1678	1	1	12832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqrTjqpmFbGPBZg2j768HcHwzHv39Mf1VfNUKrJ6F8WiqSu7v
32347	payment	1397	1397	1678	1	1	12833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHpbhKuLJJEvBSBB37GLakH6x9nWz4n5pYLm4ywb142rhAmeW
32348	payment	2133	2133	1874	1	1	3226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTSXwjVKbyXrPQ6JahVwcUKTJ2znWaUZ3bNpiB4N7erscQ9Vo
32349	payment	2134	2134	1874	1	1	3324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXoSGBCcw7URMf6ivxZ6YKXNmcYXunkgpx3kXr5fLsfDJUzPjR
32350	payment	2134	2134	1874	1	1	3325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6hCL5vFjsJPxY7RzQsiezYd8duybhdhU9Ka4zpPWUVnf13dj
32351	payment	2134	2134	1874	1	1	3326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5tPkbS6Ah3VfZUcMBXYKuxryjk5mgTViX6Yq5gKf3XEUHmr7
32352	payment	2133	2133	1874	1	1	3227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShb3BRHoQrXvH9YwYVjzMNGoX1wCzMAudAg9zHDWFt7hTS2cm
32353	payment	2133	2133	1874	1	1	3228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaULNQg1EJ9YmG6R5CaUQjasoVkgdacC4nn6DDDyntsoir3yte
32354	payment	2134	2134	1874	1	1	3327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwynrZr2Uwmqc1eLnt68wcdAdVmkS9Pbv1QSEeXosrUfWQife5
32355	payment	2133	2133	1874	1	1	3229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHF54q5dPT2jnSEMAhSszqiLZwJrgEcYPbPLEbWv9nejid9CK
32362	payment	1397	1397	1678	1	1	12836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFGrroYtewfJZe6M27uvshZTRfFy45Nnyd42k8n5qoDDaKF7p
32363	payment	2134	2134	1874	1	1	3330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpCTtETVXuqMasaZLJQvXiU4gZTyPH1T9isDsV8fGfu7FpzAz
32364	payment	2133	2133	1874	1	1	3232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuaA3aBKrg3qKzYBxJJp1UTsa85x91Q8kPVuLqSbLB6S3jDPud
32365	payment	1397	1397	1678	1	1	12837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75eNDmLirP9Pp8iPgH4bWZdNZSNRvXuZu5cF6bikPZxf7ERSM
32366	payment	2133	2133	1874	1	1	3233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNWmE2jkoxgq9xWZRib6nyDTD2fqjnDMz9JHmBamYiwye7MpP
32367	payment	2134	2134	1874	1	1	3331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBFttU6GWwM8kHHYuRciDQGD13zv1ZAudN1YYcUZrjedqpR2c
32372	payment	2134	2134	1874	1	1	3334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKYEe9oBjLFXF7mPWzBvfxsB5tXyY6LvcX1FdFvkwWCWE4eMY
32373	delegation	1877	1877	1442	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7w8utGP7MxgTtoqV67nQpvhKrhDPeSjAEnXbgZszEvfAwJTw
32374	payment	2134	2134	1874	1	1	3335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvpj5BkMFwEhwxQaPtcSFMNRHvb9Hq8aZaAqx8npUQLf66M8a
32375	payment	2134	2134	1874	1	1	3336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrfFB3rXUEW5R6HL8aXgxvQMb4rhNdYDB4wHedxVdPkno44q4
32376	payment	2134	2134	1874	1	1	3337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKHUQuoit6FiqaCujaphYk2RcPEg5N91hVD5u3kBkL6jxAk4a
32377	payment	2133	2133	1874	1	1	3236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcRCD77uGiJjGPKiMvTdaJZkcndWSW5bu3a2HDbHjSMgbzZ74
32378	payment	2133	2133	1874	1	1	3237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtzYU4Y5U68PdUAgmaPZGizZdZ8qd8niM66g15haS6iLtX6Nf
32327	payment	1397	1397	1678	1	1	12824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFc42PU9BS5QQBHmFdXCmewkNskVaqXbJLPzLoh2DwxMsDJTYB
32328	payment	2133	2133	1874	1	1	3220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmgKXMX2u7Qd9VFBzZTMNTab5e8uoTprDgsuW64KsgFjSPt5e
32329	payment	2134	2134	1874	1	1	3319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbniiJdnqssqpDXDzt8RWU3WssTNRPuMV53zjYveeanWxgPHc9
32414	payment	1397	1397	1678	1	1	12849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWzH8pRcfeVPhFe4qQ3XM5nY4M8wHQTSsJREvoxMYVDoeVMFf
32415	payment	2134	2134	1874	1	1	3349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9LnfBYMXbGsyzcsLutJQvDxvhEVezub38GcZKtUSn38nGaKM
32416	payment	2133	2133	1874	1	1	3251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFE6bf1afwSRYB71ybvraN1s5omTvabKnM62okdZuzKnubqiwA
32426	payment	1397	1397	1678	1	1	12853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJDB8T5M2yRocjpex9mTLqFEyEwDenPKVFWvy6EGp8kuTNvkn
32427	payment	2134	2134	1874	1	1	3353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYir3MuuBMf94iZpCEVKZDA4ZpUemZAYQXPaV36zaTFGpPh8QMY
32428	payment	2133	2133	1874	1	1	3255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHdeddUe1kavw6HeYzsMaUTvTJUjB66gtVwhaxReLpVz9XdWc
32482	payment	1397	1397	1678	1	1	12870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTe6VbYr5yC63fvUE98GPvF3m1GDbvQByCoz26Jm1twDPEL23
32491	payment	1397	1397	1678	1	1	12873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvBTT3t1gTPgcvrV3rWKRJPHo3MpuqyPqSTA95ixzRReYpNdT
32492	payment	1397	1397	1678	1	1	12874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZUrJJnRUK2yewTuntTp1XU2Gc6Zc5GtwGhvT7M6DvWrjB4Y8
32493	payment	2133	2133	1874	1	1	3276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqSoC3MXPGNdMcVnnWgqULMVh9rhmYySLroNMJG2PF5eUs2zK
32494	payment	2133	2133	1874	1	1	3277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGyuJiNuE5Y9B2eKgCQKkMYHj9s4cUQ7vAn2tgXCffK93eRwi
32495	payment	2134	2134	1874	1	1	3373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgyh1na76reg8KRADXr5mKfgB2nd15DGNJ3tJagqxEkg9LrzX
32496	payment	2134	2134	1874	1	1	3374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXTv19f5q5pvvhKnEP35xxa2HV61tm7iwaTEVtdrHbH6FxuHi
32509	payment	1397	1397	1678	1	1	12879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdzXdDD8tgFJntcqHUgYBLgUYCbXQz9LpCuBZWapJjv4SJMMbU
32510	payment	1397	1397	1678	1	1	12880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnMRD2UqYYrwQPge86muq2cPC3yAPRDbs49uMp9dxRDEwe1a9
32511	payment	2133	2133	1874	1	1	3282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPio1wTy2hNmQAYrwNKTKYhKr2C3ubm3g3tzbHyPtiMHcbKiT
32512	payment	2133	2133	1874	1	1	3283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdVUdqVZxAQvUVxK7d3egtRoKqDTHE34pPjqn2Y2Di7bLdVFv
32513	payment	2134	2134	1874	1	1	3379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyngGoEvSCLwGvsM7iSUugPbiyxx3qznNtyFrEQ7d1s7uLvjuR
32514	payment	2134	2134	1874	1	1	3380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELL77ENTYSZds7qByspcshen3QoK4uuRcHcB5zLXCYiPHBPsN
32521	payment	1397	1397	1678	1	1	12883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75eo51abN4ZGurwGmTfPZFuuFNzQA9S3yL4TniWza6wegEppn
32522	payment	1397	1397	1678	1	1	12884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdFDAty7sbwA2rCQ1eHCEE2eVLMgPYQZfvYjqixqEi3UjzPGE
32523	payment	2134	2134	1874	1	1	3383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48DYwVRLmUcok2GbScaeyTSxN8Dz4XKcgRfkzNPUMExzqfwrd
32524	payment	2133	2133	1874	1	1	3286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mp24qVbcPGTcdAjDXMphbMp5ZMtCAE5DcASmNuuXRXPqHtPC
32525	payment	2133	2133	1874	1	1	3287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbknUz9KGAiYCVm88TUUos6AdJPCMfHegNeRt45witFuJwQ21m
32526	payment	2134	2134	1874	1	1	3384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqNsxMG5s1657i47RJLvXA4P57yvxNbAFh6qio6MKPAAyDz4G
32545	payment	1397	1397	1678	1	1	12891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMH77DJf3WjeCgxGvcQE5579Fp7KWcN345GsN8srsMtM6HkR9
32546	payment	1397	1397	1678	1	1	12892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZHSD6senLkGLUUuuaZX2Peu8w9q6LxdsK9vHabh9ETGbhsYq
32547	payment	2133	2133	1874	1	1	3294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcNgwDXW9Ripq9eUMWpb7RYLxkBYqk4UwCMZMFVoEeuofMsBA
32548	payment	2133	2133	1874	1	1	3295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzJe3HCzfUTeocrH3d4nmxbuVy9kLAitqJCWGTGowtStodnGj
32549	payment	2134	2134	1874	1	1	3391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vcp5HPtH9UNknaoM3Sjum3DT42eBZmVy2eDfGfv6kbAsjk1g
32550	payment	2134	2134	1874	1	1	3392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQd1sCNH89VGpNL21ZiKUejFFE8iSsFtLSuuKMy6U9H5gfb3bs
32572	payment	1397	1397	1678	1	1	12900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9h2PB2c2PWtuPQsqYv7AsTE7QKM2KMKekEn42bfcGLpSr394
32573	payment	2133	2133	1874	1	1	3303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUC4eky7KpENY21YfsS8X6PaWboA4MNhzcs8cTAS3kn3G5UtH
32581	payment	2134	2134	1874	1	1	3402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTq9fNJBzdURu4FHXgU8bAPb3LnsNwhk7G6KWL8ZzgXeDkPHkL
32582	payment	2133	2133	1874	1	1	3306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXkZSkEbPLcuc8RDZNQ9u21szC1WqxwMN4wbo26sZe7gptWN9
32331	payment	1397	1397	1678	1	1	12826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa274sjx9gQCp3FvDmD3hSiGnkybrVWe9PV7HYcvsgkrbeo8v8d
32332	payment	2133	2133	1874	1	1	3221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQHEwSPcyCT1Bg3qHpqPAbZk6U7GvRRF6iyohBr8VsxhPXWRW
32333	payment	2133	2133	1874	1	1	3222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQ8oetWXMZKEXQC9DURVmZ6iXqfTcuDnt6ZDStja9M2b2Uyxh
32334	payment	2134	2134	1874	1	1	3320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhj9W2GqhvqmReDKr1RU8mxwtmgHHWtZNKi2HJ7esRhkRdPho
32359	payment	1397	1397	1678	1	1	12835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHWdnky9BuYe8Wa2GZczAuCTuhnULu9iVvUdoka6UzJVwpgF2
32360	payment	2133	2133	1874	1	1	3231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvV9ziscp7H5FJVMQMhKhbhVMJsk7E9ppV4TvVbzmpfqgsKwY
32361	payment	2134	2134	1874	1	1	3329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrzSxs76mQpue9iRWBhTjYeuiMuXqDkRFbgTsz7CXbrx3JVbv
32370	payment	2134	2134	1874	1	1	3333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSuhhTSzwuEDqMxgqikSNZW9biWWFtQQdwaWhFYsPjgC2KzQH
32371	payment	2133	2133	1874	1	1	3235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazPbQuXa83hW1FQWG1nKaMSUzQAAUt7fGmfG4hpbHi7gMQCqG
32387	payment	1397	1397	1678	1	1	12840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqzycak1vn9hWGxCJRqM6WuwQjBGGHyHDSpW5SjfiE7sHJsCF
32388	payment	2134	2134	1874	1	1	3340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoJVyHCxVX3r7E1Lv55keNGLL7SdLZGwhx2gLD2tgoHZQxvny
32389	payment	2133	2133	1874	1	1	3242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDqwNSGCXfWNBL1WzfqD9mgGXN7oytqdWL3srnzGoeedcgdkC
32390	payment	1397	1397	1678	1	1	12841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTn61WF8ijrKpD78yBM4egQxXhwRdggTqzNHokgRoFHNz6yi8
32391	payment	2134	2134	1874	1	1	3341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt3xorUYpSY9A2h689pqZ48W9z2Qha4XVrpuy7UWreEH1HehC
32392	payment	2133	2133	1874	1	1	3243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJbo57HgGtSwoqdVQk6eN6FUsfTMV9V1ocHrNeru4GHqpVfAZ
32399	payment	1397	1397	1678	1	1	12844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGUyrDKigZBewVg75CvJrWXLVXcfotLqLeA5idshGsNhWjayu
32400	payment	2134	2134	1874	1	1	3344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iBVjV97aDxFnenzwuApFLUDWU3oMEGG33teXX85gXHqkR7Ct
32401	payment	2133	2133	1874	1	1	3246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUdYiwGhTG3Mjm6aUnqNToorvo4qp51bzBSYiaGvSor8JRAQn
32405	payment	1397	1397	1678	1	1	12846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkZZquRZJqBrG2b1uuYvZLMByhLKYX2497cHj1GgedJJQV88E
32406	payment	2133	2133	1874	1	1	3248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfcPbyUYEREhHm7N8J9StzxVW6aETXM4zGTn4k1cY14RStyQp
32407	payment	2134	2134	1874	1	1	3346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HyHesBXnS7NKWBra5RYA4BoAhBCMf4oXit3Y4fVpH2ymz5Zt
32444	payment	1397	1397	1678	1	1	12859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZadTNzkqu14GAS5EuTnrn7XXPxMTHa5r6nDgySZkPyqjtZPj
32445	payment	2134	2134	1874	1	1	3359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8gqk18otfDUos1cSvfAFBNNPBgRTqqLWqe68N6VNfhE9tRds
32453	payment	1397	1397	1678	1	1	12862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x5V9DnQwTFBYmzm8HmxRhZA1WsZacJhyWd2v8Q8K3tybwDni
32454	payment	2133	2133	1874	1	1	3264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpq4MBBENFQjLMccuN38Ye1GtKSNMGwMbANr4VxzTHG5j9ME1T
32455	payment	2134	2134	1874	1	1	3362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyahfmC8ihvUJndqGCjMLaTvgsTRK9q6LHuX4uk9EAHrMT7t8q
32456	payment	1397	1397	1678	1	1	12863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcc4qjnpJ6BKh6bTvVhVgJXZMRoC6C6LBoW2MyvdiH96kcYzWH
32457	payment	2133	2133	1874	1	1	3265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZY8u4SpVFwq7ykKK6umS7EMSjezeDdazN5HSnUgWdmdhdYic
32461	payment	1397	1397	1678	1	1	12865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsMqm5JVB2sG1zw8WGL9RDURZvG1iPEE9KwyedR25ZNQ7d53H
32462	payment	1397	1397	1678	1	1	12866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3tjqyNpZbrtpHNoa6XRPXm1EH5Swk6aBLNz7gH6Vh3Xqn7vf
32463	payment	2134	2134	1874	1	1	3364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuR14RexgwK6eUAToWLCfNuu5gGm5EDDrpH1rHFNuQ2rxzZYi
32464	payment	2133	2133	1874	1	1	3267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnfr4HjELVzkQWvzBQCuHzy3ku7WT7bDkvn5xoRHZQcRLRiXb
32465	payment	2133	2133	1874	1	1	3268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpos1w9RnvJEoptbm2qHd9UWGiH81oFxquDRvGtTXAboi4pUxs
32466	payment	2133	2133	1874	1	1	3269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5JzRFNwME343GRzzovBobgEEHjZQ1QKyB7HuHxdk3UQyhkrn
32467	payment	2134	2134	1874	1	1	3365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBZ7e4mNJbKGfJVKDFUZXEB44cV4GBhrE8iPeQv1mHn37eHQQ
32468	payment	2134	2134	1874	1	1	3366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZDY2aAWU1FzSYpRAg7Porvi9C3Sr74JdjRUHhsq4jxepVgyc
32476	payment	1397	1397	1678	1	1	12868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVXsjn9iF2J7SSjp9U7bbLWycj1AJc5xoqB6JjQY52oVLpB3X
32477	payment	1397	1397	1678	1	1	12869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdo5p113wNWjyX41uLi5B8Xt5SBi53aUBDgXDmSVDipwFxSGjD
32356	payment	1397	1397	1678	1	1	12834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pfK8F77vSA39BMsJiLHAsGuPEodoQs96WivZiJY2KzPRYtvY
32357	payment	2134	2134	1874	1	1	3328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ly73HA7EkBeW5kPzcPmV8xq3vhd8gECkRGk4uWE7jyXsCcAE
32358	payment	2133	2133	1874	1	1	3230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeQkr1T94TuKNWdh7e5dhA1ZLHnq3sEDJ3zYaU5D5hiXW19iS
32368	payment	2134	2134	1874	1	1	3332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmjaXHiSTWwJqXHE4uY5x3oiRye4nVgcVT1jLxxsjkoRzExuL
32369	payment	2133	2133	1874	1	1	3234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrekUC7LU6RiN8DKqGziTNCeMgNRk7SefZVKduxTbMf2znRY9
32408	payment	1397	1397	1678	1	1	12847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTLeu5muWfQNE1qzzFQo9FvqYqmjStrsanKu7D4xwggXJqwhA
32409	payment	2134	2134	1874	1	1	3347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoypN28WvmzgK4FqT1fhJJnXHbH1YVXooQd588MEmz2X5bXjBj
32410	payment	2133	2133	1874	1	1	3249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtA33Zux5h4bBePgkHqg3r23uNBcGYziffPFvJKcaJ3NkhUSF1
32413	payment	2133	2133	1874	1	1	3250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnpYRojEr1hWiefZJFeLbeKDwSUV42VWooHnKr7oCEeb8631p
32417	payment	1397	1397	1678	1	1	12850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvma2KidQNeLi1xhcwpq77rrm2LohDW6ruwE9pRDci8CvDf3C
32418	payment	2134	2134	1874	1	1	3350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPatvCaWZGBunFncPL3VDt9omxPJWz4RpKQTEZdnGY5vfntF5
32419	payment	2133	2133	1874	1	1	3252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASwsMMN5uAu72VMnoBZBj816uMeFazstpF2fLHrwxt6JubagE
32429	payment	1397	1397	1678	1	1	12854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGb5DTs2wfp3Jw5gj9prXXUdbdLPVK9LdwCN6dJ8My6aoi2Ue
32430	payment	2134	2134	1874	1	1	3354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpwGwBRgtD7qKB6szzTY1nbhHN7vgdWvQ7odALZtLCiSRnB5H
32431	payment	2133	2133	1874	1	1	3256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiEJkypZVwifw4nh2xxeSFTUdGWk5866bfF3toAKGQpfHeRCr
32432	payment	1397	1397	1678	1	1	12855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVjirdhZfV6h3WzZag6vyhvPZtALDndEyrX98WrXC2um4WuZN
32433	payment	2134	2134	1874	1	1	3355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8vkU16o1B1uWAvMF5XGmFpgkMk59APsVEG9YSsGkWmCCxgMy
32434	payment	2133	2133	1874	1	1	3257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBAtepGsgpQGvVVM4GcvGSoBWCVumSQtZkPMssdC6NeG49jeH
32435	payment	1397	1397	1678	1	1	12856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7FncvNHjDb37NQEujibBswp9z8mrHDWVt87cnG2FeeHpmYa4
32436	payment	1397	1397	1678	1	1	12857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSv9TRcPT4bR4WV39inh33Tjd1vtLkBGq3hNJQpqw4DHdbTaLw
32437	payment	1397	1397	1678	1	1	12858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc4rCGmnuqSKXHKHryKsaTAvKAWPPPbYnWXmD3GXRYWc8s8yp
32438	payment	2133	2133	1874	1	1	3258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFsBffBeKR1KhGLFwhuNeajfixurzVqXZ4x2cDn8gCV7pDNeS
32439	payment	2133	2133	1874	1	1	3259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVbjGQ6f4vBfh2RtrT3XVa2X41yUNcDRCHQHYqyGdmmTpQoa5
32440	payment	2133	2133	1874	1	1	3260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYik4YRUBLwiak6nr9WefneJyzq262rhMLooJVNvRwtqj6nPt99
32441	payment	2134	2134	1874	1	1	3356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFx6FvxVfzoq55wy3ywXLfC1ToH54WiJQn5NWSiHGGwbZE8Ukb
32442	payment	2134	2134	1874	1	1	3357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSg6gSdjwGRFkpfNViuU7bX5zWdZGM6EUkxifMC29hLsYAB2R
32443	payment	2134	2134	1874	1	1	3358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9ZDJjLHewiN9YQj5ZJfoXyz68FP847se7dAUULbyDWct6uFe
32458	payment	1397	1397	1678	1	1	12864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxF9MeeHcP9569XG6NZNQAxtRS4RpUf34XvcF2Kw73S9E6sGd
32459	payment	2133	2133	1874	1	1	3266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNt1Ww4mQvvmbAy7xCbPbEdgtpKSkorPTsiMfSYHQtUrNwAb8
32460	payment	2134	2134	1874	1	1	3363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgSfr9HXoZ6AXgChVFTGYPmUJ92cwZGcJCHYqXD199CUVycAZ
32485	payment	1397	1397	1678	1	1	12871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9g2Vxw41jFojpAzx1sFz5tKM3gkzBEKK1bdGAehEvivpoNEM
32486	payment	2134	2134	1874	1	1	3371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfXwkBuVWpoSv4ut8o13kJyEo43uqEzFpW7gebMo9QfeVobf1
32487	payment	2133	2133	1874	1	1	3274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKo6RC5fxH3hsHsMLdZRTP83gi3JW76qCQSggrx8YYHMuvYunM
32488	payment	1397	1397	1678	1	1	12872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGqqUUZJPUp7dBYKrVKeJKL3cgyZPZ3MRFXhDtQLmsAs8qagy
32489	payment	2133	2133	1874	1	1	3275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY5cUpiowp46evuLzPgJT71CKRaUeAkZ9szzpc4fitzhjUonm
32490	payment	2134	2134	1874	1	1	3372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6sKVzPELSW3ETE7UQqvgn5L6cTVcPi39ZPpQFEePqd6WVjDB
32506	payment	1397	1397	1678	1	1	12878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG2XEs1gfvHCoH3W2FWqi6uDkHix5YS5yEaJ5UQAcef1g7sGx
32507	payment	2134	2134	1874	1	1	3378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrNCQYsH5JaqNcJwh2CKoqrpMY23iwNLrwzLmoRcu3L2aU14D
32379	payment	2133	2133	1874	1	1	3238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWizLNfZKgNPGBqksUZxXvg6tBGUKBTK3i3RMNFTDSWzS6TcnG
32380	payment	2133	2133	1874	1	1	3239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxqnX5W1xf1ktWte3wmJGiDAGTo3rQbbFdMetkd3CFD2QHk5K
32381	payment	1397	1397	1678	1	1	12838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRS1c9jnzexyLCgzUdDAdyD97YaJ31QV476vaLtnG6eXfZSWNN
32382	payment	1397	1397	1678	1	1	12839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFxhK94973BAsobqPHzmS9mFivdxKb6MszJsTYkvyzbpFK2bC
32383	payment	2134	2134	1874	1	1	3338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjARpJ9NdhB9ksweW4EJi5EB7h7AwGcWJVhz7kC82TkXSVcSY
32384	payment	2134	2134	1874	1	1	3339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u7vbF1JJ4t8cmCJoeDA2kU2sAVCYYUZB1idpDjWDhDQPtUKd
32385	payment	2133	2133	1874	1	1	3240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3rVzrjw9DSLRsJ94XGAaPzycsSSHSsSAbPmCDyjsm8UKoPnx
32386	payment	2133	2133	1874	1	1	3241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwa3wf35GLsYctwpEQzYN5YCH5HU5Gc1oCFNU7DqPdAMVdZrAa
32393	payment	1397	1397	1678	1	1	12842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtjr1EsQrPdqVMcqa4jMJCQXHs2SjiYyLhJa1V4584C8grt4F
32394	payment	2134	2134	1874	1	1	3342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpipq2e8SKmsAkU9SNYmRudKZLg4S9VSPz5WPF5yq6a2ZVcrY
32395	payment	2133	2133	1874	1	1	3244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNit5VVhiPbLsAUbzGkEtz223VFJrSxrKuh5tNMkif2mhEXEC
32396	payment	1397	1397	1678	1	1	12843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpiLoGMs3AvrkPrQu9yhLztiFX3WYboZvZEmV3ynSpb7bjpGQ
32397	payment	2133	2133	1874	1	1	3245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkixjJtq7f3mVq5W5effdKcbQQNNk63aC4psymXyKX5PqbRMuZ
32398	payment	2134	2134	1874	1	1	3343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiStH1arhLsWv4zXzTaeF6qiadSCsWKekHzU1cCyvrwf9Lbowq
32402	payment	1397	1397	1678	1	1	12845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7xqUDZc1yekMouBZkAJFZ5f5jHMRoyf5XQeaYj17zrHbSzZ6
32403	payment	2133	2133	1874	1	1	3247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9jeneKrWzz2Qdvp1kJ1EHYF1s6TmWG4GpU1DD1xXgJmRjhtv
32404	payment	2134	2134	1874	1	1	3345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBeFD4MARCRTxTNUreFhaQZozAPuitpMZxypAxJASM6mYW1M5
32411	payment	1397	1397	1678	1	1	12848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4AsbTBt5T8N2vHuKgUnDwVDC7fQczt1YUoJ8PEvfYyvkojN6
32412	payment	2134	2134	1874	1	1	3348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwheMos6ZWfU3m1efJogugVmdb9xP175UL9ecAAvxAPhd9yq7
32420	payment	1397	1397	1678	1	1	12851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxijojjmqWSNUJsLcgb8AcBy9En6Sgea58RJ9NB9LU3krvg2i7
32421	payment	1397	1397	1678	1	1	12852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgeGvmrLXzdiaY3ej2uww1pLT5DyE9UkDEGkVo43DYo3f4Kvd
32422	payment	2134	2134	1874	1	1	3351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJgXTvyaFaSbRAPQsAuupeQ1wdDgUE4E5HBcioSBRpATWsyuZ
32423	payment	2133	2133	1874	1	1	3253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZ1tauW5ThaeFgGv7JQnZfaccfHUie89T5p9VE7x2foaKzRrv
32424	payment	2133	2133	1874	1	1	3254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWKY8kpdfR6XMS32PPHKzxYtbGuYY98KutcD4CuxQtVzGGmNg
32425	payment	2134	2134	1874	1	1	3352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3ar64JcZrq5hdyrZ4qgx3vdQHN2aXchY7vMLpBjibNmTzEtv
32446	payment	1397	1397	1678	1	1	12860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7oMJ3XecVSTGakgpiQqcX2mrn9qr98R9GN7XuzK6RCdVsxrz5
32447	payment	2134	2134	1874	1	1	3360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hNyRE4g1WDYV4tyxEbAdRaiJFsPsdQxd1r8KGZXKtEvmanS2
32448	payment	2133	2133	1874	1	1	3261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArjTyrdDdcj1LWftsfuYZk3QV6kxvcmUPrJs3cW7hmk6Prpq2
32449	payment	2133	2133	1874	1	1	3262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2YARwKtvbo6cdjvmn765BvvRXWACRKv2ptrewnv5RBQTJKQc
32450	payment	1397	1397	1678	1	1	12861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXfWxvjrhcRziA2XszqV8fhJ9vufR8tmkSRheSre9jqQvB5w1
32451	payment	2134	2134	1874	1	1	3361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYAC5q7bQ6HLCTx6Whpk76EA25769Rfyh9iejmqaw7V9WE3Sp
32452	payment	2133	2133	1874	1	1	3263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34UjpnBHur8XrqQdtahzTuhwyd6NsMnQz5QVz5meT3kdxQxSk
32469	payment	1397	1397	1678	1	1	12867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXq5VvMx7k1CJHYF3f85ZWSdWiSTPLzPD917HKeo4gXDSf75tV
32470	payment	1573	1573	1318	1	1	6	6217000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUHyJFYHWxTTvwXKTqvMnjt6X3Y484MoA9jpVJmH4s2tHna6W
32471	payment	1573	1573	1072	1	1	7	3307000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVKeGaRxEtyusCm74y5FHewF35gY4qKiS2LXYPuxXXeCn98q3
32472	payment	1573	1573	1192	1	1	8	2231000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgV8iZidpAade5sg1w4CSoRFuhqzaTph5kunqV9YSuwZCy7Bmi
32473	payment	2133	2133	1874	1	1	3270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUu7ZKKnBHH9JN4VLNHp12Pd4pknocfxCRupyhQ1eeYkABQyb
32474	payment	1573	1573	952	1	1	9	1845000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGJE63XeYyhehUzsFDgCiTF1vg8xoRikpPyu183NaPsMRPKzF
32475	payment	2134	2134	1874	1	1	3367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSf6Ab1uR2CHCoLCg4S61BLwNSWEkig2oN73h7jPVWEJNMdjh
32503	payment	1397	1397	1678	1	1	12877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV16Zj93pvZREJpq7SH95FxSeP73UPyojsAZ6UcgzfSsu2VNc
32504	payment	2133	2133	1874	1	1	3280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyNC1CYNtBurbUguKP26ckVFkGZaQfnLeV2zD9H4hGBEZ7YyU
32505	payment	2134	2134	1874	1	1	3377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XNVu7b9ZiKfvueXVjB2BJFpKyh92w6xksF9724ai6KhHyvAb
32515	payment	1397	1397	1678	1	1	12881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2soTg8PYv9i4zyMckFAYG6XjE6YTPeRDEs44kwVSnzaKhrcc
32516	payment	1397	1397	1678	1	1	12882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gsaHvY7tp3TrN7tAarA7JiWbxWZ8bkSLUNKtyj89dcGTmiy9
32517	payment	2134	2134	1874	1	1	3381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6phinbRfZNMsN51opjbm3DAxEKNL4Qnx81SoWxn52JABNuVw
32518	payment	2134	2134	1874	1	1	3382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ742gRfySifEqWQemKRcixM1a8BrbNHqMjPNGM1E8fhDEmumdN
32519	payment	2133	2133	1874	1	1	3284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQY3DbkQUjMpTKnktamNY7rFnRKiVEAe2qZDLqvUD88fnxtVSp
32520	payment	2133	2133	1874	1	1	3285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYmgUQwPQtrAhp4hgWLZyMYfSWUTP4wj3GVvrndsLa4DHnrmM
32527	payment	1397	1397	1678	1	1	12885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivctbWHEStHcoaZesJe1TA3Ay9msBSro3oB15qN6G2jzXYmvf
32528	payment	1397	1397	1678	1	1	12886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbQGvwDVxrEoyicJpq5dQvqMDVNs2FMcx4YnBMACwUY5DmoLJ
32529	payment	2133	2133	1874	1	1	3288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHyz7HPauF3VBWkrDUZPwaVUJidhc9wEre2jGiByFw5EDK6do
32530	payment	2133	2133	1874	1	1	3289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYmCdBYTFeyoGcvrGC8jScG6ZQiE7r1U1pe78yBgypSW9oA3S
32531	payment	2134	2134	1874	1	1	3385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwfEnnaXYntpmzBX4SeD441nhqSkqLsYutuQokS5uUBiV6AcJ
32532	payment	2134	2134	1874	1	1	3386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyQYNhqEaDPQeom3bpSNeNAQdcibYfi4zZ63ZgxMhPxd5EJHr
32533	payment	1397	1397	1678	1	1	12887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5uWYgfNiEuA3WCNRjZGkcbxaYxrdqqrCJcTZ1Zq8WMkoubp9
32534	payment	1397	1397	1678	1	1	12888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndgYQp7kPFbxGUsR78VVpciKJKCQAFTXFqZNEWbERQxv7csCG
32535	payment	1397	1397	1678	1	1	12889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zkztqCnDYPwEao8H6aqZn9hc79BxHnYpvxLyjUDmG7N6Azbs
32536	payment	1397	1397	1678	1	1	12890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4X1CazM5qmYo8NpPEHnYmSeXF7hoeTZw5ssqWvwGzQK9PVoHJ
32537	payment	2133	2133	1874	1	1	3290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jj6kUzZ5QSorijPtz7dzeAsZMLVeyVP3jPTRYyjo2yjLntNS
32538	payment	2133	2133	1874	1	1	3291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDYoVMhtefE81Nzk6xuKWcwoysyniKFvupNsZsGa8oB56Nio1
32539	payment	2133	2133	1874	1	1	3292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6wvMKNbSQ468Fkb6PPLdEb4irruXYEJyQrm91BAsCVywgnRg
32540	payment	2133	2133	1874	1	1	3293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPLbN3YjKGsh3LQfLh9P6AEF8hASr8VxgU8jAiS3phseA3CPc
32541	payment	2134	2134	1874	1	1	3387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7hXE1QZAu2QA9QTZK2PC8tUPVSbKqYxMypm2gMQL9fhZnBNd
32542	payment	2134	2134	1874	1	1	3388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNtvmKK2PrndhK7zdYWUFtV9q3hX5AzSyG3ELVWz9smL5CbdT
32543	payment	2134	2134	1874	1	1	3389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGjNGJCCvxSVTt6HvDBm1rxtMHtbTezS7gzL94TcxfiwSspku
32544	payment	2134	2134	1874	1	1	3390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWL3hEjyMhVmski2teddagvWG5XNFUySicBmoWu7CSjX9sq8D
32551	payment	1397	1397	1678	1	1	12893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKSnzHiBgEm6CxGL4nV5bBF92g21Ck1k3VAMRh9QFPn4ckMef
32552	payment	1397	1397	1678	1	1	12894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktahb78hNM3E2fsVi8THGwD2FuTTCm6EQyoWvAisbThDKYv9p
32553	payment	2134	2134	1874	1	1	3393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRRkyjfkS78ESwcJ2rd7Hg2rSiWzyWPbbeTKmQUN3CAuormHs
32554	payment	2134	2134	1874	1	1	3394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaK9XcEwB516SCRk39EVNrqoEDKQqENikKeG18Y54fKGXnZPs
32555	payment	2133	2133	1874	1	1	3296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGjquA3oG16xHCuLvUPwcBHwznmPk7EgoUMYDcxojk6igXMEf
32556	payment	2133	2133	1874	1	1	3297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyekTghqkes3nUqJ9kdNzzounUuAJbmyzqDXkc6bbcir4Zftg
32574	payment	1397	1397	1678	1	1	12901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEARCL5kEbjmtRgf6cVke7MJSE6mSKkXGxL69ighG7uygFsd6r
32575	payment	1397	1397	1678	1	1	12902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGRzaQjXvCskHPr2jeSS7kcn6K7BwXsr1T29UjE72aeNHndr2
32576	payment	2133	2133	1874	1	1	3304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSRApqNUthwCY6dy3npQ7bqZnEXCPbqg9HELmqJJsgyXif7gA
32577	payment	2133	2133	1874	1	1	3305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDwwbRhCKtgdHHjQTUhVYUqFZSGDKeoj9P9JRzCUP7w9aEz4n
32478	payment	2133	2133	1874	1	1	3271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bHYMsxh5ivtQUnnNGC4fKoxRUSynfnTi8mkdqjYZ4uAo7NVd
32479	payment	2133	2133	1874	1	1	3272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJxj68tHjtfVrWcENrYm35tmqocHWgwF7QbDFZKE54X2jPARG
32480	payment	2134	2134	1874	1	1	3368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ1bf2dVuoVWvrqZ3ia9XXgzVyb4zXjKKVwcVB9sN9WhRAdg6
32481	payment	2134	2134	1874	1	1	3369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBB72Pfcn4Eu4e6uyjXuCztn7mhFCS12CaWKtBXFVmN2DofZo
32483	payment	2134	2134	1874	1	1	3370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZwxR7xd8uB58cUorrKC2VprkmxqDaK77KhcyTsivsnpyxxug
32484	payment	2133	2133	1874	1	1	3273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipbQViqtXBoBzpLj3cgWwhVvxxfHyhT1uGvKtrBUaJFnQPkyb
32497	payment	1397	1397	1678	1	1	12875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fnKeqXhXa56CSUpuXq4ojXp7pNfywowzgo8PnnRPVkfDtdc5
32498	payment	1397	1397	1678	1	1	12876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjPCuFijFHJt2JcEoJaRmnTb1azVBHpRs6XWK766NEzDLNjzq
32499	payment	2134	2134	1874	1	1	3375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmuBkAQ1UQFsdu2bdhfWhv5cKAvxTTgNqe97sZX5pDVLutTMi
32500	payment	2133	2133	1874	1	1	3278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDRTLr2jLy4joFDU3LuxdLgEGDCNMP8ec8tbpAxABRKuPU4Uf
32501	payment	2133	2133	1874	1	1	3279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmgRajMmE1zjbgudRSo4egL17ZSinFZtL5R7RzR9Xv4J8EJ7c
32502	payment	2134	2134	1874	1	1	3376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAhvzaLKq72QvdQzoHz4wXZQqU1XAcK9hGu8ZWxrXq3CbYxWZ
32557	payment	2134	2134	1874	1	1	3395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZech9s6yzWMfbSVfrqsbKqZHwJPE4RPkkM2L65fVDGXC5gQFkm
32558	payment	2134	2134	1874	1	1	3396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJwJoRuomP7sovjwX8KngbV1DqmqGGjniEtD83dsVMyQBX8qS
32563	payment	1397	1397	1678	1	1	12897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYz1SZDfPJzBhiW5FsNM86FLNpqXTDsPEuifPeH8iiDqaLZkw
32564	payment	1397	1397	1678	1	1	12898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYHaMxLZk32KWCG6Ja6iGB9EtJMofUEBX3fkZ3B3dJ2FquW4K
32565	payment	1397	1397	1678	1	1	12899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9GGpkkLNxew7B3hnwyDAcbpK7e1SYM3WD3w3eTrsFCjCVYc6
32566	payment	2133	2133	1874	1	1	3300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYds3GYa8JGQ4ATSpoDXRX637U346CNthXqf8dYTyNT6Wik9JLi
32567	payment	2133	2133	1874	1	1	3301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ymro1u1sf5FaPBPhEchHpXXWYPYfc3g2z6G4mvRjyo1h4bLg
32568	payment	2133	2133	1874	1	1	3302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Lk4nJ9Kb6iQk55xxo43zx6aQf88Q9w4p8N2Xw2zSCYK11pVa
32569	payment	2134	2134	1874	1	1	3397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWqS6eMPPjUZLXwpiYfeciT27HtSknuQbkShKApFeWu1QmAYH
32570	payment	2134	2134	1874	1	1	3398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvXTNsSD3o2sYjHtzKPhZyKMAz8wUdmAj1gaxXAjevWQsWPet
32571	payment	2134	2134	1874	1	1	3399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCESnPm3GQ6w7whfc73yi515hTZrnKrQwTBsawzpZK22yfCjZs
32580	payment	1397	1397	1678	1	1	12903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HVG6xQMJVhoSUWqdeQJVSMjZ3HRwTRPHwuginQdtodqphvCF
32583	payment	1397	1397	1678	1	1	12904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3acFarWXoN6vPctDiXx1nCAQZHSS2h6KAmttfWQYcZ2iHrTk
32584	payment	2133	2133	1874	1	1	3307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPrypTYYiandgFMWNuhe81odQhHhYkgs3VHUUBQFECrwScU5u
32585	payment	2134	2134	1874	1	1	3403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp69X2yeFmnzWv2m6kGTs6fCgUnMJxucCXdHHf6Xh9wKoucHEV
32610	payment	1397	1397	1678	1	1	12913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoty6rEVeit3nhJ4jFoPNx6FyniCwWAWWffEoiS26E25JekaTE
32611	payment	2133	2133	1874	1	1	3316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwpEt8rRsF4iEpYi9eDWudVU4Nm43ippRFfisxXqC5sUBpuAn
32612	payment	2134	2134	1874	1	1	3412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCgSZsRv7cxWnY1FmTXvVs92RwM4XE4bS38TBKk8hh7qNqjYb
32622	payment	1397	1397	1678	1	1	12917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWj4HeAQcdqkRQ27aFwgA6uSQd4RM2aKSPPKyyDLFZ2Eu1ww9
32623	payment	2133	2133	1874	1	1	3320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWgtYmzbeGXSSPqn78hu4bprGHp8a2qav4fZFaickrcrHEtRk
32624	payment	2134	2134	1874	1	1	3416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgmuXXUepKmJ3XnFYWYngg5gThw1rm49kFyxvUZ5RXicWgCj5
32637	payment	1397	1397	1678	1	1	12922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HppaQeKy8rwJbcXgafjVNL6bbmc46f6LbdUDcSmejZBsQU6x
32638	payment	2134	2134	1874	1	1	3421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3YGJs4c95oBDrT3rxt6w6Mw1edDwmT87afia2kDxSsmkizbG
32639	payment	2133	2133	1874	1	1	3325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbm8ii6S8oGyqXU2JvN3gp36eYzQeEG3LZE4aSn6hwUFGK2UDf
32652	payment	1397	1397	1678	1	1	12927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9BQEqpkiYrr3ieVA9cBQpCWntmPPXi7gtv8fZccRNsEPkZm7
32653	payment	1397	1397	1678	1	1	12928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdchW2Ee3PVRRSgA3koyywQFY5mZ2LxdMuX88dK7fUmL8QpXAA
32508	payment	2133	2133	1874	1	1	3281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXnE5BmUjvPtimCsnk1Fd78tHb34EWH3umJvoHsYjDz7av4q7
32559	payment	1397	1397	1678	1	1	12895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABAYA7EPm4MnAnQrADop9k5QRPyNraExnF4avUvUueSSAkGVQ
32560	payment	1397	1397	1678	1	1	12896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDdWWqkxTQapS7cH3cy9WqU7RAwpyXLbU3JQXfHDwYGWJ46e6
32561	payment	2133	2133	1874	1	1	3298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpsTdprDPXTHnnemY9k13GBC39bGUNjrK8qgJpPyvRdzRH24T
32562	payment	2133	2133	1874	1	1	3299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFyBC762m4HFEJgyyTDPV8aL4628fy8UxnLZjCdj9XThHCYkS
32586	payment	1397	1397	1678	1	1	12905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqtALNme2GCpMXziAXAwwuhGbCbun3hhbMm4a1b3GoiGeJru2
32587	payment	2134	2134	1874	1	1	3404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQp6pAvKEs7tjaqPiRdkDF5nQfcSpKBpnjUyhvuX4D9kyZvzr
32588	payment	2133	2133	1874	1	1	3308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDF8asrxwAU8S7TRUGu2e6FtVaZnMrSHycn58N2dQujnJe6bp6
32589	payment	1397	1397	1678	1	1	12906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHKaYNsjEUqg8oBHmMnNLQaS71G4NA82vYcSjDhn9adxZoaoc
32590	payment	2133	2133	1874	1	1	3309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoXpkMercRWrjohdTjeMyMkAD46Qfy9us8U1ycmGnyEbi2rmT
32591	payment	2134	2134	1874	1	1	3405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61nPoSKijHQVEmywtdybTVukkvUmHsvMTwizMc14S7CZZxpuT
32607	payment	1397	1397	1678	1	1	12912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5abeJkrfbGdmk47D1UCGNTGaLrKv7MPhAczZCx1MJwFrPYgfE
32608	payment	2133	2133	1874	1	1	3315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrvvANmaNQnYrEUds7nSVT2G4bqcsbEoVBcEo6P1RKmmzFZic
32609	payment	2134	2134	1874	1	1	3411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqptXksWsY1hiwh5B5WqPWhpMocHbXj2rXSYRwgSNWx6BKd3ci
32613	payment	1397	1397	1678	1	1	12914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEN6SnuRoYfR63bvidYrVusqrFzrUENo3oLr2qBfspCCU8Lif
32614	payment	1397	1397	1678	1	1	12915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekXoWDBR9XCac19YthpEoniGgXEsHFzxKddxRjSDKTeZPxFVr
32615	payment	1397	1397	1678	1	1	12916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvPX2LmFrpytgWUFLfASztkACSshtjSq6p6V3HfCfdUsLY6BL
32616	payment	2133	2133	1874	1	1	3317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtcs2Puo5GaqKDWZusmWKDfaTgd6gjzPVAijt2qWP8Vb2uSfQ
32617	payment	2134	2134	1874	1	1	3413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWHKWeSe4cU15dKwQ6oAEXoCUNHif6ZvVYPm8CwDiNZfzbnZR
32618	payment	2133	2133	1874	1	1	3318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5z7BQMUD4X8N317hZqkGpVLAnHNMrKczWvEfmqGG1mpQFXEfM
32619	payment	2133	2133	1874	1	1	3319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXbPcaupJ32hEUtoVfLH2U8yLorrCWpiBeHY696UDNizyt2zz
32620	payment	2134	2134	1874	1	1	3414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNwPeS6wjm4JStYuC1xqinBoTMnN3CqLMNHHykSZH2CuGhr6N
32621	payment	2134	2134	1874	1	1	3415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkknfPQULJt7JQxytUxqY7UN7HBrVesjd85ehtkFPqr2Zhgg24
32631	payment	1397	1397	1678	1	1	12920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSzzsg4f4jCBqvMdcbYDtDGEpoPB6fpXJ57WijTvLxeD8Aj3y
32632	payment	2134	2134	1874	1	1	3419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuuiJK2ujQPETgJPqDLRoGWf9ge49z3dP27A3H3gdsBCc7Gp2
32633	payment	2133	2133	1874	1	1	3323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HCL7fVPxzeZZp8vLCSXnrGWFsCcucGznQ7uk2MLiCuFMDfsL
32658	payment	1397	1397	1678	1	1	12929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfK8kqD9EZFVLEBxakU3oYfKFFBepsRmiaWPBtL3jLjs6yjKx
32659	payment	1397	1397	1678	1	1	12930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCbi2Rk2C3HJp8nAvDcd2PvFP1XSkqZq2ppwh9X4fLj7MLtxH
32660	payment	2133	2133	1874	1	1	3332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78Qn9RahGHBAKUWJ9iQrqD1LSPhxeh9VukJhjY7SMrNR5tpgL
32661	payment	2133	2133	1874	1	1	3333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDZE6Bju86FjD1W15KoFsBzyUxCoUFjYSeXBBv7ZncovjjiQP
32662	payment	2134	2134	1874	1	1	3428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJzT7sveLASjgreP6Qb9kdKuSfERCirBMS3WGvsxqJY2Uizyv
32663	payment	2134	2134	1874	1	1	3429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHu3u8KCfwQxFiJ5T4NNvpYjeZKroLuAawSoMdjcaoiaWhy2Z
32673	payment	1397	1397	1678	1	1	12934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawznHagLkYX5BZNor8AfMgxXrZY4fC4SAQpp4bQXW1iLisxLG
32674	payment	2134	2134	1874	1	1	3433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvV78vPE5fQ3E1e4zwW9amZmPSmRALqMfLKaqhUA3fF6k88Zp
32675	payment	2133	2133	1874	1	1	3337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBw4oQNXnNJU3fRXfKRwQL6Wh7huuzm8bjEos2DuoFtR3d5Qt
32681	payment	1397	1397	1678	1	1	12936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgsLXpcAoEyEtbDy9a4Mnv1AzQdsyRyLBtQa6wruQYW15SYw8
32685	payment	1397	1397	1678	1	1	12938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfrZS7tMC32hHW6RRt4tjLBuJTQy92bJYLQPbT7eBv8Z6ygzr
32686	payment	2133	2133	1874	1	1	3341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EuBrZTxu3zCzSq3zYwN5ZsCdYFY4y6Pr6irPP2M79uveU2gh
32578	payment	2134	2134	1874	1	1	3400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHnvhEUsx4Ji9GH2x2YiFjntKt495QFrozs7kNm6GojqtGNzB
32579	payment	2134	2134	1874	1	1	3401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4B1KiFRc3eRiyJzvieAEJvYx5zrFqvFhX13uVMHpEqkTSe8d
32598	payment	1397	1397	1678	1	1	12909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYgBo9qZfSxtL4BQWgHVA8bPGVVZyyjZpKZarPQUWQxs2E24c
32599	payment	1397	1397	1678	1	1	12910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDyRvgFshy8wC9HAxCfsJnUyAbWNvGUzYoiRqpJS6r1sjwo9K
32600	payment	1397	1397	1678	1	1	12911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15sdqCSm7RFTz9Kg8wHxR6jLXGx8xuG1UvUMzzQkJKDC6LDhN
32601	payment	2133	2133	1874	1	1	3312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJeRcZun4ico5y4eBethZSS3aGgyhS6SBByKka1frnQ2tqvFUw
32602	payment	2133	2133	1874	1	1	3313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiU1AeJNwgQZfc8HtzStRP6pPM6acBirSQXWruWLYeRLZAXH5w
32603	payment	2134	2134	1874	1	1	3408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzeHmXZQqXydWBwNtrPy4tuY51D7aRMoAHaguPm6MepTTePVo7
32604	payment	2134	2134	1874	1	1	3409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKSQE2CiZLXgWtQeLNWWuvWFi2eULMbC11AmLYWmgVuEM4yDa
32605	payment	2134	2134	1874	1	1	3410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJRiqT4VEWvXe2EcKWTqSoR3gHfD8T3WJWdNeV5rUTfms5668
32606	payment	2133	2133	1874	1	1	3314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hEaeH2hv8oPuqbgySaEkETYDzowUyp39VJcQoxusLfuoGNBC
32628	payment	1397	1397	1678	1	1	12919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDLSJ9GnjYQvAfsGzTJtQ8a69C4YWHKrm18toj1h9oXVu8bAa
32629	payment	2134	2134	1874	1	1	3418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8tm5CdhabAPpDcUc3pmEaycramdqtqBMmMXJhGtbTbJzPfpt
32630	payment	2133	2133	1874	1	1	3322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6dGVbEv58ffAxqHbpvSm9m3EGpKGa18CTjXHHb8q7RW2hwoK
32646	payment	1397	1397	1678	1	1	12925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFRnGEYaRmMbU8a8t7B7DJm7yVf7bWGSNATchExX6CVKhgTtk7
32647	payment	2133	2133	1874	1	1	3328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHceptWHzQrAMC3aeDpzCxDz74Qc6qAqY2MRjkfHbYj2P9Hs1
32648	payment	2134	2134	1874	1	1	3424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZE1Fu6zjNBA4uxCmWZt8tjaRCQMSWWUDTp3QoE7AV3F3vbv3
32649	payment	1397	1397	1678	1	1	12926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi38iYnpdHHCmh9f89oGCmajC1HmxAuRczyps1zNQhJh57t6u
32650	payment	2134	2134	1874	1	1	3425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5nFa3tfdohZ6CFRkSyHCrMmPyczQZCUKmBhUEeEPQ2RQqnh1
32651	payment	2133	2133	1874	1	1	3329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7m9SyXHJBxSLot7wW2gFFoFyVHUikVy2hQGmYdYv3pbqnu1W
32670	payment	1397	1397	1678	1	1	12933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23dMFrTZCKoZoyb1AQYGiPrxnvvusSenhbztxg54FpzQru9ve
32671	payment	2133	2133	1874	1	1	3336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtr943W5vJV7Ej7ZseA7hj4Af2EC4kLwdsLDTTkWUwfqk9LdWu
32672	payment	2134	2134	1874	1	1	3432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PMTKtL7VUm7QUJT342nTH6djB6r97wKRmsNZ9joY5QUCnsDG
32682	payment	1397	1397	1678	1	1	12937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH77bVJ5CYozqEV6atfcFMb6597vj2KzYfNVwimN5Y3jTEtf3B
32683	payment	2133	2133	1874	1	1	3340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7X8GYru3qLTDmRBJQjELN31VU4C8SpT9Ged5dSNjm4rbS35GM
32684	payment	2134	2134	1874	1	1	3436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9e6xtWSz1vhapcSz1TpuY8Vf6Kh45YGmigU1ppbScd7dFwQu
32694	payment	1397	1397	1678	1	1	12941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kmAWaGJPFWVwk1hiRdqz4c6wtfSPZ2mQ8wJzaEnKd6m881rD
32695	payment	2134	2134	1874	1	1	3440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2j68yqXKFwympTca34bqaFDLCrewYeSHwaYvcbnVHD6HVS4A8
32696	payment	2133	2133	1874	1	1	3344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gsNBDqrjQSe6WpFAhWRUKCycsa2QsDnsfDDoMRua8S9nZ21i
32703	payment	1397	1397	1678	1	1	12944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJf2cLS9PEghiKUTCMpx58YtoduaegDnzZDaQpCQjhAB8qpgXY
32704	payment	1397	1397	1678	1	1	12945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1DpYe84WL45TmVybvWa4FviV4QeLTTqQw76PffzDHgm7jRhZ
32705	payment	2133	2133	1874	1	1	3347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM2PB6cPy2fGRfLRotAyAZz5k36XPNV3JWTAj75V59FdKH6HK
32706	payment	2133	2133	1874	1	1	3348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fSiZ9SwKMsB3Hqa8ReYGcoRCFg8MVRZ6of1H92UxdKGDgQAD
32707	payment	2134	2134	1874	1	1	3443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUpRQAHPtJJ2qT1TxgQVx8gbo8Qo4gTgq1cosA5BoQdSPGxPA
32708	payment	2134	2134	1874	1	1	3444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddvnUgaEy1heBE3vq3vKRNT57jx7HMHFxMpWshKPfcKMajurf
32718	payment	2133	2133	1874	1	1	3352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWNqNacdWs3SKU7ZTCb147bEtHuRrSFHevsb5HzDhL7q3wGUd
32731	payment	1397	1397	1678	1	1	12953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAHpcxGMTRfXY6cySCX8u1YmtsKnoHUx3vTrhxFhqxXQobHX3
32732	payment	1397	1397	1678	1	1	12954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnA2aGvC2EjBZ4DVHQvMggPJ8uhyKCzLZ3r3CkjU6phFjmddxd
32592	payment	1397	1397	1678	1	1	12907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbg2czQAL7goJRuzDLfMQPie4K1MfjJagbMwzHTFqHABdoY67R
32593	payment	1397	1397	1678	1	1	12908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVnsEVq96HY54hZCXViGBAYerCLKHC1U4cgXcFy1c1PLYYTRo
32594	payment	2134	2134	1874	1	1	3406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2wsiYFAvJG11GCPojpbWLjpBCLTj4PqYSTEK8AwNhtThw7og
32595	payment	2133	2133	1874	1	1	3310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJQLBZ6UrcjvAywZf8SKPjWcEsbNjBgvEQ3s7L7DdHE2rr2Hz
32596	payment	2134	2134	1874	1	1	3407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjeToVsYL1nHNCcrYruBEZt2RkPtsH42oy57jJf6cucXHoqnPz
32597	payment	2133	2133	1874	1	1	3311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQqec6Xs1JfHW5QdWoAJCwjUqmp16sBzus7SyA8NfMPvDeXtg
32625	payment	1397	1397	1678	1	1	12918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyUcBAnxJUSUbFUrztiLnYtRZhJDerCVvSUdCzJMNueD5mdAV
32626	payment	2133	2133	1874	1	1	3321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dzxGrKHegmTJFZgqe5GThUhpiFw1FB7aY4n3LwtiTcB5Prko
32627	payment	2134	2134	1874	1	1	3417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuscMQce412hk7WV5KhrwVyw1QjFd3dDL7yXZ5VSMeiH2fcQZ3
32634	payment	1397	1397	1678	1	1	12921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShCywZVmxoY2VN1ugco6bXdH8VYngiXWpXsivJRuLp842Kvui
32635	payment	2133	2133	1874	1	1	3324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8HdYDNgs64BN8JmNMLVMg6CnqtdPrGJ7WP2fwmCrTez4mrtD
32636	payment	2134	2134	1874	1	1	3420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4c7jrBNubb6CA6XMb54t92Xu7qMXUXMGrHpfb6cFsLH9EqGYw
32640	payment	1397	1397	1678	1	1	12923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HUCiLBA3C2FiWu9Nx3iryTrCVXXc5YXJC2eipmLdBcyr2oW6
32641	payment	1397	1397	1678	1	1	12924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQMZCDyB3ASZ1qTgEkMdTh4sZJR3SpSUiqB5Q7JSn1dssorZ9
32642	payment	2134	2134	1874	1	1	3422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZML2ktL1WWse751Vk4L6FPMx3KBm6W6vrhWwWwNmLhqfASZNpY
32643	payment	2134	2134	1874	1	1	3423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCoqg4cb2tU27mR1DZaRF6hL21uvkrVZtXKk4LhNYK8kTULFd
32644	payment	2133	2133	1874	1	1	3326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLspJLUhv2Fma5NjYB6RqA6D6YA762DU98gywNMeXqiFXGwLJ
32645	payment	2133	2133	1874	1	1	3327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhHUqvDjrix3pkoWgRVKGHsP55SpxYfSgQpzyACthCZSt17Kb
32664	payment	1397	1397	1678	1	1	12931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBZaRZvhxy3YyxTcuXNMeuW8mD8rnzLqcdChjvspgKXzb5LVx
32665	payment	2133	2133	1874	1	1	3334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXXstPbw8C4cyFyXAk6dXKg65cWYxmmTQ9PAGXRM1fgg6vjzb
32666	payment	2134	2134	1874	1	1	3430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBj2tYGoh2Curabti69QjUC3sbMMKUdUd8dkAnBJ8yt3mCkP45
32667	payment	1397	1397	1678	1	1	12932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaETBruF5rHVncKiGvKzCXYTdTH3L5k7aax64utn9VKaq5cxpKb
32668	payment	2134	2134	1874	1	1	3431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVyfprbag6g6QhyCqFoWPNTv7eATG81UbB3Q3uwwDTbgfMbSD
32669	payment	2133	2133	1874	1	1	3335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzp4SyRRdFvNTbGr1MJc8BpUJ9qKSBj2QyT7DynhKGCQGibBrm
32676	payment	1397	1397	1678	1	1	12935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruhmAcHZDDrc1L1cdQhSU4KEJ7wzAyg9MaLCEiUZXY9FkiD91
32677	payment	2134	2134	1874	1	1	3434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7gmD6smLtiqsjdFq7Mndd4Rg38pgWcr8HL86xkapv9WkuV5m
32678	payment	2133	2133	1874	1	1	3338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rXxrrdXyqJ1SJQUueCMMhm8E7cpSitrkuj27SsGrL6g29SEQ
32700	payment	1397	1397	1678	1	1	12943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnB3En4mr4tRKb7sHRjXSngsvaf9BsKgrzkYYB9RV2Vyjvhhc
32701	payment	2134	2134	1874	1	1	3442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcEuYinKDrDYy2dGok5qB6EtYS3ztSWXdRkeyRQmpGXSXDtum
32702	payment	2133	2133	1874	1	1	3346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBnop9mYrMLjDNPFy9h8RtE3RySVV5mmaVEw3pashf3NAvR8d
32712	payment	1397	1397	1678	1	1	12947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGCPjn5bvopFA6wBJEF5kzfDh9dN4RN9oGgjdEQevnRAnS7fP
32713	payment	2133	2133	1874	1	1	3350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu5jFudDi7mXnkadd3JVv9oy3Z2Ni8hRWhYQdP3Wwod1skCrs
32714	payment	2134	2134	1874	1	1	3446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsbot8c4ynPH7KGj3bWCboSMQ65z7dRQqvAZ3G9i2Z1t1XbHk
32715	payment	1397	1397	1678	1	1	12948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1WqThfXx2dzmW4JKoi3BvXLNLvXHuK6J9a6tgxyDZDjbuEPa
32716	payment	2134	2134	1874	1	1	3447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtd44qZYXosZE14DtZZDTnQgjxJ2WsWSngDoF1thkyq4mg6SR
32717	payment	2133	2133	1874	1	1	3351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaJBHFVQ3Gky6PfFnuqRoeCrQyXR9mvYnwbF5nQZzs16y5qjv
32725	payment	1397	1397	1678	1	1	12951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYBcsc7175iU4kAJ46VohK9B7JwcPjrHYTX8VC5DWMzW6T6Cp
32726	payment	1397	1397	1678	1	1	12952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZx57Ptd6b9XyN6omc9UM1zKQqHmVXww9ZVxQTfQiyTfV6z8ck
32654	payment	2134	2134	1874	1	1	3426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoooK1cPV5E9AyxQJDqPEPtp1xpwFweQkdqE61UbQbYfXAo3Yo
32655	payment	2134	2134	1874	1	1	3427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sL36nrxbirg4tZNM8W5jov3Ab4jdrpUAK11ghsNW5LGsN2AK
32656	payment	2133	2133	1874	1	1	3330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN2tE9LCkeVUaNBuVdvCoctdgfRxxd6TC6cbGYPZiMTFiB6Bs
32657	payment	2133	2133	1874	1	1	3331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPvGw1FkA4obh8pJXxf2jVp19AQxtoPVg3eFEhSB8Uqcjz3iu
32679	payment	2133	2133	1874	1	1	3339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFt22Wux2FLF8SjPxGM5Bpmu4UZAbDXM5k3FTy3PMbgPjjcX89
32680	payment	2134	2134	1874	1	1	3435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNCWkBfTFUNmATKSEBaKwmjrSR71E5bQk8Pt3WEUexJKRCDGB
32688	payment	1397	1397	1678	1	1	12939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY71on8WjwEpR4eACtNskGNKttmdzHzMD45KFrTfMNoFVtRcPS
32689	payment	1397	1397	1678	1	1	12940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZxJ5vYGGnpBgUBHU4SgfDzZ3adyGCX6nu1Nojcg5YXutrAjK
32690	payment	2133	2133	1874	1	1	3342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxrm1McdzhNazTGtpnt64rqGAhikGywM4NdV14NDJCJaHK8Rw
32691	payment	2134	2134	1874	1	1	3438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNoHyENZhjiTTty2Awm93ceJiA2SvT6gap3bRxUd18Qidf3F
32692	payment	2134	2134	1874	1	1	3439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuodmWnUGR7CyE9awSvw4b17LpMtokx2GwEMxy6CVbze2b64p
32693	payment	2133	2133	1874	1	1	3343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKa4UE5BR96aAeANSMKPvpXg1qvhWuTuHchi5So9kqd25Bjr5
32774	payment	1397	1397	1678	1	1	12968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjByWSLkeaGcbDCJJDa2d3WPvxT8uuxxjGgQP9HEaC71qW3YNE
32775	payment	2134	2134	1874	1	1	3466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwHM8TmUexTwL2Tjt1hCrDptKAtDQypontWtLLu3dXgy7hoLx
32776	payment	2133	2133	1874	1	1	3370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvsCqWV9CACKMoEwPBXc1S65MqrENkjd2ugnB8kYcv2tgdTtL
32784	payment	1397	1397	1678	1	1	12971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvfrX7S91eKU4nTTV4JF2zcyPFztSpvYFnyk3oiG269FkU5SA
32785	payment	2134	2134	1874	1	1	3469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ46tGTyPuuZPBuGBJdesnfsp7z2Dye4eTH7BNUir7KyDwxgWZ
32786	payment	2133	2133	1874	1	1	3373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcovFUTTZXrPm8uTLkZdfHt3co94oPaxWC4yosZMkkFtcmym1Y
32829	payment	1397	1397	1678	1	1	12986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwGxbJapqeccQGaAM1DtJYAT3UtHPKRgUCMuuhbuEJGvRX2QJ
32830	payment	1397	1397	1678	1	1	12987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoARSgW5FD9o33aV46t8CtjGww9hg1m8abXVqAep24tCfGTT5B
32831	payment	2133	2133	1874	1	1	3388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyrGPc8p8Pssht6VQqoieSv9gkjPgYkPe4iiZ1oivxGG2MHRB
32832	payment	2133	2133	1874	1	1	3389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmkjiyVvYduS11yFNqBVtGn4gAgRiEdcXfBKcMVyx4yPoJ2zK
32833	payment	2134	2134	1874	1	1	3484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4vMqFuECgUouV8wJvQB6mVtcX9iBVoPRUEeqyjt2yUTeJ2Qr
32834	payment	2134	2134	1874	1	1	3485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xPSLpwjbUZ3Cc2dw9Nn5p41JRK7vkFbVckw7hqjRnbvM6T1Q
32847	payment	1397	1397	1678	1	1	12992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiwqBN5r4e5Wi1AdMqjy71ZacRfwSh33QmHoUJkKYj7vKouva
32848	payment	2134	2134	1874	1	1	3490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9thw4ViMGCvjV1XNj9BFTmFHZsTkCPHRvZMkuALcuRGztVWqG
32849	payment	2133	2133	1874	1	1	3394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCe7RQ9Lkvm3q4ZoDV9QpaNydx2gzBoDTVPLYZ5EyZUey7zAjW
32870	payment	1397	1397	1678	1	1	13000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzarfDbVJCvsaxb1wcDQamjQxxNvoz5mQyQG5sggaSrdeK8gW
32871	payment	2134	2134	1874	1	1	3497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BS6kUDUQSMhoyvQqNLcxcq1koo9M11STdrxa3gqiDWz84p24
32872	payment	2133	2133	1874	1	1	3402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9tpmbGqUehWGzgJjZagML6WH3HV5e4Cpf8qA1qgprmfwBq5R
32879	payment	1397	1397	1678	1	1	13003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNwAJtkuGJKNsVRMnjfm6Pfk5iMN4Wh67vAD36kXUnrumvfmH
32880	payment	2134	2134	1874	1	1	3500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAujybHGfTCWKNELACBSVhPnF99FxiM8wEimJ21t7kFfGFoy9r
32881	payment	2133	2133	1874	1	1	3405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dXPMVywLdXyRD1Tt794Tnt4KxPbeBDDjripaQKQc4NspeoGK
32888	payment	1397	1397	1678	1	1	13006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1HmpBkiHcgVgEhnpVgcp43gAJgZRVYvWoGYFmP5oeBppWfat
32889	payment	1397	1397	1678	1	1	13007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC74cnSYuGwNdAwRWXXJaPEPAy5mUYwF2Vh9pNTc2i2eMC4TX
32890	payment	2133	2133	1874	1	1	3408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxDALdPs31TqQW3XtWU2xdB9SJETop7i57a5VQCzJMko3Nmu9
32891	payment	2133	2133	1874	1	1	3409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgpwmY9F7FY3avXdLZZawPb9qTjvWZ32TK2twHSQMy8v4JQmJ
32892	payment	2134	2134	1874	1	1	3503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJD2FxbNBbAdSpNs385t7Lk5tceaabpSQs87NnRL2dwYqTNSj
32687	payment	2134	2134	1874	1	1	3437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9eXvdPEoN69gkFYtj8ziCfHa88EsLufU3Hc11y7YN8Rbo14c
32697	payment	1397	1397	1678	1	1	12942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhoGSZ3SK4QXoKLw6RJKEqz5tx9EhG7kJaN8ERFDeya77NuEQ
32698	payment	2133	2133	1874	1	1	3345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqrPz7UqsbDYxdVMWoaUNyKBaneNSZkWkA1CV9uWmDjvXEYsT
32699	payment	2134	2134	1874	1	1	3441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCj8HM6DmcZrEsa1AydBdhHgsPyUWWAazvXc9RYq2k7t7H4AP
32709	payment	1397	1397	1678	1	1	12946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupGPxXA934aNQLBfCyF9UrYXkQAEUZqixH4qf2fXeB6CJDBRJ
32710	payment	2134	2134	1874	1	1	3445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMTbHws2ndFaxs2paT8dSYtzH9K3zF8i6srUbDTL8wEi5RBxS
32711	payment	2133	2133	1874	1	1	3349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubxNBedTum4a74GToJVydYh1bqhdoJBMNm5Ps8ioNo2qLrKhw
32719	payment	1397	1397	1678	1	1	12949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaETvv3CyssgGpube3KvFSSVmwVinmK4agnAXTCwigpLzcF5V
32720	payment	1397	1397	1678	1	1	12950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ReA2tFSXya63AcmNRsjL6mK1TZJjzLSA35qZtRtpTvVo4ES
32721	payment	1932	1932	602	1	1	8	10000000000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68hNNLGmamdRA8QRirXgZVV1KzEdgdLrc197S6awGes2yM1FU
32722	payment	2133	2133	1874	1	1	3353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXLZNP9XyXH29MARJHKVcYFW3t7NYDpNWfDC5Rt9jgMp4Dy9H
32723	payment	2134	2134	1874	1	1	3448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVniE56kPEhdte5XEwo9zAYqVkZ1egRxYj8HzkYxhNatSZS3c
32724	payment	2134	2134	1874	1	1	3449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFUr1S6RP2XAt47uMA887nvzgvqJxJGBF5rPQwjmzCGkEFFVe
32758	payment	1397	1397	1678	1	1	12962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgUKp7eBJRZRYGqF9TFwGGajQr36h3zXuBdA5dRuvogzveco8
32759	payment	2134	2134	1874	1	1	3461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG15UEi8Pna7docq12G8Y5Z9m3ACsAYyGH8mpixbhq7rG6UsQq
32760	payment	2133	2133	1874	1	1	3365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziY6iksSARgSvyDTLvuZjagHyvdqc5s6MrULWes4V427bivxy
32764	payment	1397	1397	1678	1	1	12964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjAR6FpLLkWspvUSJkh65joaSrUWm6oAnc2RsexL8zNLbjFpG
32765	payment	1397	1397	1678	1	1	12965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vDhkLxCYTyBWxWufJ3Wm3pMTGjQyzsrPBGaVkYHK5Mc6Pqp5
32766	payment	2133	2133	1874	1	1	3367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgQVCcqZhxzdKZsxiNwrWTzL7gwnGK9Awkoi675VLZM59ZvFF
32767	payment	2134	2134	1874	1	1	3463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUE1DV1QUmzCaLWeGUECgkWKxzE6rgeQRCwDN3YwwjPHC2fi8
32768	payment	2134	2134	1874	1	1	3464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGdwmP78Na4ztbVGb7D1btsrp6yTdpQtH77qRN2cYt9BQuvPA
32771	payment	1397	1397	1678	1	1	12967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZBR6UEKM7hrgRNVKDvQrM7zftbv2iC23mywkGeopz2DiY3KV
32772	payment	2133	2133	1874	1	1	3369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTK3HVurZUFPgfqFAfvPgruY5K6vX9RPW9b1y8D5Ecf1pDcGAi
32773	payment	2134	2134	1874	1	1	3465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAobVFvqQoNStaSYCmTZva13VCM2APeT5JYsQ4m7j3qLkZaBV
32790	payment	1397	1397	1678	1	1	12973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QepYgrxBAcxNvsTmznc4BQc9bGLR8RfPDci3ofwNvyq7auN5
32791	payment	2134	2134	1874	1	1	3471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfiWzDpTzagfhxyS7Lpd1TQH1jfSiTLzf9QdnfkcY8swMB9oDA
32792	payment	2133	2133	1874	1	1	3375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKQQqEYbfTk3XHydpHkBvaR4uRmBw4fRRP7us5qkavejd5nLz
32814	payment	1397	1397	1678	1	1	12981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvrixxH6Gjwi87oPDz7M96L4EwLaeXXCcEYW6BsBCJALRZHsJ
32815	payment	1397	1397	1678	1	1	12982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjpaYmDPrpBXkrK2wUCWfVUE5qhoEKGWMxEUVBY2ygtsEYnrb
32816	payment	1397	1397	1678	1	1	12983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKT5bexQDBMZ7P8ophTzQesfeGghh3RZ2bgrcYDNxGE8H35gbb
32817	payment	2133	2133	1874	1	1	3383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSWzrzY82MUUoZiSR1L5jwKkeXxqELZxMhBYi4rsM165b5PDA
32818	payment	2133	2133	1874	1	1	3384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisTiCDUb3AmijpZSMZp4EDGBNsNSqczWwiUNf1XwX9pBsXQTn
32819	payment	2133	2133	1874	1	1	3385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2enJCux4s1LyG56CUgA3WFnWErjd75gUkf6NYrGaEqycZx5dm
32820	payment	2134	2134	1874	1	1	3479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrooRx5s6CiBitBttX7gZ5mXQpnyAqy3uT25Cok7HNGqxD1ZXx
32821	payment	2134	2134	1874	1	1	3480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevGVRHebXBaSGiz8d2dXARFyaXsAraR9smZYzZc31zL9Tx1be
32822	payment	2134	2134	1874	1	1	3481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmZFbcz6xuMMU7baGYDQZXGExTkbDgzHCx8YMbcVaLTqygJKZ
32826	payment	1397	1397	1678	1	1	12985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgsbEmnCZjCrSY9VpGqfEGRiZkjMNB621PhLryxe8RcnhYFu9
32827	payment	2134	2134	1874	1	1	3483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEm1fsQLxLbd3Psv6WLRPkEjPSAJc1BHYzH46pJfvAnCkUvwy
32727	payment	2133	2133	1874	1	1	3354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbFM53TeF4KQdKkgLsiPrYGTxwjVapAxzztddBHeasEKiCr6W
32728	payment	2133	2133	1874	1	1	3355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4rDPCdL2z8MqRNHi51FupBzHRDQ9Ne1ynT43D1FVcUCXg1QN
32729	payment	2134	2134	1874	1	1	3450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJj3Uub37X5ZSg685oARsk4C9yBsyzotnUVvPNjt7Lyizx517A
32730	payment	2134	2134	1874	1	1	3451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfnPQ5X3cggf9ZfesGeacANsQfbpDNw4SeVBGL7h5KZbThzQC
32761	payment	1397	1397	1678	1	1	12963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjesDiVqi7a69aBZL5eXob4z2NGwLm9aLZBDApwKqNFnwBcnaS
32762	payment	2134	2134	1874	1	1	3462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GPUEP5E2gVEjsQ87snwsS8YagBKFztCEuaLB8ZmutzYDkrd2
32763	payment	2133	2133	1874	1	1	3366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLqoL82TL8dmg13EgPLxaH5scywXCzg8qm3PqUvpwsS1rkqfB
32787	payment	1397	1397	1678	1	1	12972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoN6bVbXvv5VupdCSrbxQvtzoa3oyWpbmrumPdYudKk7i3aWwh
32788	payment	2134	2134	1874	1	1	3470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7hwTSziqsPpnc89kqrpYnk5w2mMekuvLyWFgNma2xFTmb7yV
32789	payment	2133	2133	1874	1	1	3374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXMoYW1j11KH8yf87qkVSCnfBrdvXuiLnfxX9rMiB3k45rBQp
32793	payment	1397	1397	1678	1	1	12974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxbEeHgFtSPnsvfmHJjNmPEyM5CzS4XmQdoYzYwDaS4Ekm2AH
32794	payment	1397	1397	1678	1	1	12975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwx6zFicuLSDmzQNbzcaX3hiGS8h3rFge55yF6Ph4a2LVuorA
32795	payment	1397	1397	1678	1	1	12976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBanMnwXuie9ntNQE9gfE5UEBWKwNRRsoqicFsDWPsU6gnpfZ
32796	payment	2133	2133	1874	1	1	3376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N3Uec6UjcmFo669N4ye3UFYNACnwQZAEo4SErAgsXA48u4Tx
32797	payment	2133	2133	1874	1	1	3377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERUWj33oB2j9iCG5cs7Pp1yYVUowwLUHQpotY5J7mJVxNhHzT
32798	payment	2133	2133	1874	1	1	3378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvgjieyfeYKFvVuCbk8amUkQ9FR1SMyz3oGKUHaiy3u3t5o5N
32799	payment	2134	2134	1874	1	1	3472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2xijsLFpPyGSkMXojyutTWcxXoN8cKjx2r3z153Tc88Npruz
32800	payment	2134	2134	1874	1	1	3473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg57GmA4dFTXmTNhNgL6PEB3KPTNc2kfkAcbNY7qAgjjZEgMUi
32801	payment	2134	2134	1874	1	1	3474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHH7g43KYn7e6mXXJVuNDjGopkjPv2i1kCLc4ZvouH6vBCbMc
32808	payment	1397	1397	1678	1	1	12979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqM6y4FjA3wHgMThCfTow1k7FP1ZQ5ZbCNYpr8UxF2LW3Rtwn
32809	payment	1397	1397	1678	1	1	12980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdwNHuzu1eb4r5tpGSc9MtbXY8V3QRiBo5Gd3jBo8R9MH27LS
32810	payment	2133	2133	1874	1	1	3381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmjioqUZYJa5isvgnk9EhaeFBCwkvFBiU9YZ2kHEgwHiDwcWM
32811	payment	2134	2134	1874	1	1	3477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2Qz7mWhRoLcEfprRD5wdFfUi3jkVCVKXgyRSBHF1Yth2rJb6
32812	payment	2133	2133	1874	1	1	3382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHt2YVZSrQn2sDVUfU2uU96oxayNV3cnnLyrnFKZ1CuYYA3k2
32813	payment	2134	2134	1874	1	1	3478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCekNMybW5vRyZAXXLr6PSL8fEwrQCFrzyHNbW7bG335o8RYA
32850	payment	1397	1397	1678	1	1	12993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFafGzA6qTfV1ArFCzbhNCYjnKPQmR8ALY8HT5jZvH7GMSQok
32851	payment	2134	2134	1874	1	1	3491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikxycNTa9FpzbJzhVLWukwgmX7FUJXVUafsn8bcgiRRNaS3K9
32852	payment	2133	2133	1874	1	1	3395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiGiz4kmEEBWcnJuX2pt894SJMKVAc9WXUr9kF8pq1WnkexZE
32861	payment	1397	1397	1678	1	1	12997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SB7q46ZVMTbVxiDPqBxjAbEstTg3RXAG8qTKQw5WCnk44rM3
32862	payment	2133	2133	1874	1	1	3399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDqyxDUGgRAhA1GEJ3Ev4FsymRzkTQ8A3Rft7hcDNJCy2Q3H37
32863	payment	2134	2134	1874	1	1	3494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoECRuVKRBPzy7JRGVd8WkzEGF11T7SZdQfzKk7cWKEX34uSVN
32876	payment	1397	1397	1678	1	1	13002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaTUgxMJkuiF6djwZwquDeCWmR6Jt92Y7puBV2vqTJawi4f5n
32877	payment	2134	2134	1874	1	1	3499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ475z5e9Z22FULVN72RkxbGbcyX2KXt1sCbjE3zHx8tsWw8KiZ
32878	payment	2133	2133	1874	1	1	3404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKrWRwQa2D1CMDmkKvwQ7kEPivRnkB2yJqu1p5rNGJGSAUGhd
32885	payment	1397	1397	1678	1	1	13005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGrKXh7QjLarnMyJ1ZNeXzvENftdAshMo2Pybp7VcJUW4os4T
32886	payment	2134	2134	1874	1	1	3502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyajUjBGoVqFEMrtsmdhKizaUi7FNABRaPUBwTrVVQwnTx5qMo
32887	payment	2133	2133	1874	1	1	3407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6mg2rfCUnpkhtqQymahcYHj6qWT4AxNGs4ZRmqpM5zhHUQmQ
32897	payment	1397	1397	1678	1	1	13009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YJaqkN5iKd9nRttKvNXMAcuwfMaD21L8jvVaMjuqzoCDuapL
32733	payment	2134	2134	1874	1	1	3452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHQP7LWs6fnb5pPUkmiUxW3htrCUQRHdtRXamskrnKWa56r6Q
32734	payment	2134	2134	1874	1	1	3453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3VzLsDgmvowdTmMzDbHiukG9DSy2kkeh4AMutzozRGUdptQo
32735	payment	2133	2133	1874	1	1	3356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98dvn9caTGPfM6T4BHK9EUKDPUK7nkiKe2sXBJjALwqTgcAFA
32736	payment	2133	2133	1874	1	1	3357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx76NTFjTC6AacYAW8iK5F3WYALfZfw4yTMgKHKyuSvLmdPPmG
32737	payment	1397	1397	1678	1	1	12955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrcgBEWhfnxMx5qwh76ggdSvncAbHpaMffHHqVPRuW555p2NU
32738	payment	1397	1397	1678	1	1	12956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82ojrJutrWdLxtNpxL2pYXVB1pi88fyp8vbRyC4hj6exn9QqE
32739	payment	1397	1397	1678	1	1	12957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWf6Do1AufwW7wS4sKvAHFTPTLJFbJhqjBis3tJDBm2aWj2Fq
32740	payment	1397	1397	1678	1	1	12958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH17amEbasavDRC8JemjWXziopXHCpEjjd68hpLsCmJAVrUk1
32741	payment	1397	1397	1678	1	1	12959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmGtxNDxK9TwuNoPraSqACMqVUBtRX8L35bd8bpcGebfgYJU1
32742	payment	1397	1397	1678	1	1	12960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmi43mZcvAmFNuxgTwRyuT3BpRwoEnCjipU7eg1TtwTHfD9P5
32743	payment	1397	1397	1678	1	1	12961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmfRysK7hvruivGTATNQNE86AZZo6RYSXYzGxKXuT2C8kVSBu
32744	payment	2134	2134	1874	1	1	3454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaszqZHc9eSfKv2gDepT57pEvtLeeo4W6FZTNc1p2CNmjjRDDh
32745	payment	2134	2134	1874	1	1	3455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXY6qsa8D9USxgarPU19uoLUVhuSQdAyuFoKPbCpt6VG7kC7K
32746	payment	2134	2134	1874	1	1	3456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvgHQHhxGgDtoszJaPyFEiBh8sFFzLE61v4BrokGHk7wi5QDh
32747	payment	2134	2134	1874	1	1	3457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9XpzDVz92ZvxcAte7K8NA6yB3WrN6rrJRY3eKJF756ZKB2EV
32748	payment	2134	2134	1874	1	1	3458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCbFC97wuDsgxEZDVuTXiu94vjPNFV2LNFTmV3j3KcM5FuKQu
32749	payment	2134	2134	1874	1	1	3459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVWxi4rDeJWecpNKLYFd9bSPWsL7oCzHFWKctUEvnSD8GSnBW
32750	payment	2134	2134	1874	1	1	3460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiZHjL3BuasMVWt9bi3TUwtAqLEbkNLDta5NGsiGeJvstC8F4
32751	payment	2133	2133	1874	1	1	3358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAJTGeb7FgibCQCfqhm1oBq8XTD86nN32ipmkAveb9nH6QFFU
32752	payment	2133	2133	1874	1	1	3359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfesFW2n6D4sC5f23KEnrpPB7foRHnSpVfLFuKMM6osXVuTh7Z
32753	payment	2133	2133	1874	1	1	3360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAGvNtjPofF5LvumjAS22fRCJZbJwoQXsmQQuLoRaNCkD9Gb7
32754	payment	2133	2133	1874	1	1	3361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyPJrHT4c6VWfnpamedo9P3z5NtxFhTAb5B1Bds22S6fZEkhA
32755	payment	2133	2133	1874	1	1	3362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4MWt2aVzhD32ciSHRmnhKN9ktTs3X7M6RYz5FWmfEZ8H9NGo
32756	payment	2133	2133	1874	1	1	3363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrTSL6bUT7MjgNtgsF4LuC5B9KqnByjtkyih2tm2EfuBuKfgp
32757	payment	2133	2133	1874	1	1	3364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSu4XLTzmhhZJkSggLygKhg355ZSxfJWVACHgvnVDV2kC4n57
32769	payment	1397	1397	1678	1	1	12966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpX3wMfLx85RvghTbNxXPjKo2bi9m8NxKiLS1RxZmVf4LQxigT
32770	payment	2133	2133	1874	1	1	3368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDcuTymqVMwtoWsaxiXjB3VK6q14uyFHfgDB8w1y9yMmzzVb4
32777	payment	1397	1397	1678	1	1	12969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmJ3zyf1oxh7U1QSJFCU2YKFQwQx2HGoAiyNKuFoNYL3QA1hy
32778	payment	1397	1397	1678	1	1	12970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aWacQXoi9gfoSka2e9cCK2yR3WqFdann9PfV4mFKdWgiviAG
32779	delegation	1932	1932	1932	1	1	9	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2jut279t3U7BJRxipwc2tZ25FoHx1WScU6Hhc7QVEJWaWe8e
32780	payment	2133	2133	1874	1	1	3371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpuccCdxiDd8yxstJF9frVZsiCL74Ne4x8PhNvMdZFhAp7p3F
32781	payment	2133	2133	1874	1	1	3372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsEEtCPHYarPoRiZEH5nurhJ6N46UvdiuNZDpufEQqXkBSh7F
32782	payment	2134	2134	1874	1	1	3467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UeojDGLGWKEy1QstFzY96ZVi2L2jDN175dMqiL1nH1Z4vFaE
32783	payment	2134	2134	1874	1	1	3468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3y6S2GijzciraRZEG3sJ1PCB11G3mMaLZFFJWUGokteZkrxK
32802	payment	1397	1397	1678	1	1	12977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZDxY1ePeTLEb1vDvQSHrZojt2LWkxJxp5noR9xg9qkAKwBfW
32803	payment	1397	1397	1678	1	1	12978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2itE5LyuM5e7PHYrvm8FwisR6gN7aHR5hjJA4nXgNP6HbAf13
32804	payment	2134	2134	1874	1	1	3475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9etrdbUZ59KCmimP1gNzecLB25D3mBvxN7c1XUioPDbZ8FHF
32805	payment	2134	2134	1874	1	1	3476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74b9YiW4TgALrYYavEkHzEyKr1bEkxNmr9QW8bmZZe1ng1fDn
32806	payment	2133	2133	1874	1	1	3379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcSXKCEqb9zx8JFGVoVcZopG9Lc2QSnNaUzzBrPaj57CLnrFh
32807	payment	2133	2133	1874	1	1	3380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7AYsq6KRnvHrexMDSiT6MKSJ5Uwk5KBZ5CySse98LcPmmPuo
32823	payment	1397	1397	1678	1	1	12984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhbRJy9EW323gpFz5nuxaq6TzrDM1Dd8f6coB3jHXfF11Rwuw
32824	payment	2133	2133	1874	1	1	3386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUMgyRkSSvDUVN6SaZnvBtoNs2USKzpcGZJg8Kcr1ffy2Hr15
32825	payment	2134	2134	1874	1	1	3482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdZEPgcmLkFZdDDP1kzcbpgr1mzqikAfM2P8WH2vShBVxnKKE
32835	payment	1397	1397	1678	1	1	12988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7Yn1nXPdNfnBHAHdK5znWQ8Bxotr4r1XXAipuQJqYmJb2BZZ
32836	payment	2134	2134	1874	1	1	3486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHCFMtCGkzVHuDnBh28CwnyQV1XaSBWYkcGbRi6Aq4TXypS6P
32837	payment	2133	2133	1874	1	1	3390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqacN8wMqnxDNH7FKweXocG4Gu7GSdAZ3sW9TMiDqWFUu5Bib
32844	payment	1397	1397	1678	1	1	12991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhGbE1fwygCT86tsjPNC8CnwMrd3wcnBk9KrDFgQ8Lpyiy7fZ
32845	payment	2133	2133	1874	1	1	3393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqtuMbdBQxSBqxtp8ey5Hx58xZqVV4zRUHuNkwiCxm7CXTGWM
32846	payment	2134	2134	1874	1	1	3489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56BKSNobfMZ66hHpYNpzW6A4BZV2hrpEteGcXv1GV1i8YtHCC
32855	payment	1397	1397	1678	1	1	12995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuCgeHVDu1ussY6oKGv1wBKAvLs7RKHWuZNu6wxRPfnMXrPmY
32856	payment	1397	1397	1678	1	1	12996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKgFtBWiDDiZvWi3hc4EDNd6v1nnAG9j1Kof2Y7gyhTrVQVge
32857	payment	2133	2133	1874	1	1	3397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibiF4KaNDdbGyULEnFNvpW97BpmNLDrBrUrnhWtYoFtE4EX5t
32858	payment	2134	2134	1874	1	1	3492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP9X4pNxge6ppeyU2swTk79GVfELMrRjovP2T7GLDZMYLtBL5
32859	payment	2133	2133	1874	1	1	3398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo4uL6ndZL5CFq5SJYzZJeXkrUQLvnsCnQU7fXcFrd5N8zCb6
32860	payment	2134	2134	1874	1	1	3493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLCA3EAoGEhBLNdt98kqgJ6dZD3RTWPNMovvXJpkE4MTZUV7E
32864	payment	1397	1397	1678	1	1	12998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMkz4J3UJiiKYDnXmYMdx79q5n9EYBtK7mTSquhYMKSWYtfDC
32865	payment	1397	1397	1678	1	1	12999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghgDw6BE5jECdDrQPbbHpgvVVjAUmXMGA58hLLVFSsdft5vts
32866	payment	2134	2134	1874	1	1	3495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdid2HG4dURABn5TSQsyYerLsXg9nUic3Yx1kAuzcQ1KkyXV3H
32867	payment	2134	2134	1874	1	1	3496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqSX1iv7yeoeT56fLVMJV3zL9N9TLgJN4rjfAQ4kRmSiSiqBD
32868	payment	2133	2133	1874	1	1	3400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2S9pmD9kUBpREkjaRUgr1T7TCRqfkuMMcV48JEB9XN1vVfBWN
32869	payment	2133	2133	1874	1	1	3401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpszydPpN4AR8NrwAKhNXnkXapNjrE6HWQ9B1yJkkho32XaRzs
32882	payment	1397	1397	1678	1	1	13004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjprtu25EZbu2QV3uEHvK3FjCncHgPP5by9DxfFeEvTfRgeS7V
32883	payment	2133	2133	1874	1	1	3406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfyibRHQhoE3aDMz29ZdBSWDVBDEAJjRwzfNBSGeTJNhQm9vD
32884	payment	2134	2134	1874	1	1	3501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjUj2enP6kLVDcM7641bY6VASkHYdi8wjuQUwc9UQD4q98hkM
32894	payment	1397	1397	1678	1	1	13008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa22pNCSx9dQuCMzCC6zKaybUd4yukU2oCBEsbTmNSwEP6GKoa
32895	payment	2134	2134	1874	1	1	3505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM6aKCAqwTiQMGGqXn3Qa4VhtW9SXTEAUMTeFMVzRc64MGPJs
32896	payment	2133	2133	1874	1	1	3410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtq6sqTMjiqMTP3fCv7Yj8weZid4cYFpRnJjVz9APZGTTsVYK
32915	payment	1397	1397	1678	1	1	13015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDFadxx6qa33CnA7Vsw5vjnmU3mDQSC61roCWKKEoz9LvfdEE
32916	payment	2133	2133	1874	1	1	3417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuXNdGLAHBmCjzBZmxRRSiEA5PdRiP86FHBHBn58qbJ86XdD4
32917	payment	2134	2134	1874	1	1	3512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHRaXvKLJR711wtNGNz1SULNsptQbPrnG57dB4aZbyWZFaejV
32953	payment	1397	1397	1678	1	1	13026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvtoZJH42QHVHW3ALTt8vMgoANadcoEXWzcWg9PF3wQbZtAGn
32954	payment	2133	2133	1874	1	1	3428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhpmZWnoJT5zEQrqH5BkXRgv62DjWUpxWaN7YmT48kuGcmopb
32955	payment	2134	2134	1874	1	1	3522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHmCZoahCFvniUxbmuKgzct9AM1xyWXSa9mbZ5JrggbJL9Qse
32956	payment	2132	2132	1874	1	1	983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuaY98KkW7xkGjTZNFdAKt5jNpYrXEMYtDYwtLzqzxbXqCoEZ
32963	payment	1397	1397	1678	1	1	13029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHw7cTYCN4Ab6jjHCZjzC2LHekNNVaKSdQZbfDc4DWpW7RHpt
32964	payment	2132	2132	1874	1	1	984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGR9X7n2aGtQKAggw1rTvGNAbR1gZU4haUDYe3WkkXahrMZJsA
32828	payment	2133	2133	1874	1	1	3387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxSccpAg5DfntFyXwxW3dStcxHeuU2oRFVpftHJoXDJrfpAKZ
32838	payment	1397	1397	1678	1	1	12989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbd2juDw42WFNRvVeGXggSiM5g7nsyexApbVXxphbKmfqc6rGw
32839	payment	1397	1397	1678	1	1	12990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ48Eu9PdZNEE9dhTaikkqnXebNNbshNRsywu8GyHnG7b5Xepw
32840	payment	2133	2133	1874	1	1	3391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxDAQxeMQuh2cZRwvdY25XfZS8FZ1ZTS2LhXP1C3i12AuPYtU
32841	payment	2133	2133	1874	1	1	3392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSHJzva6TMjR8qnFpRuJ2wWYnpoRf7KWCPTHHUVs5nMYMQ6SX
32842	payment	2134	2134	1874	1	1	3487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YMEiJMpv4y9KzC5yMwYwaLLPx3FVDY7ZigVkAYEFvviR7RQb
32843	payment	2134	2134	1874	1	1	3488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRkgCgo7jvzC6DGXBzEhNyTuZMuxPyED1z2S6T62yfSm6K4a3
32853	payment	1397	1397	1678	1	1	12994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36mhR6CYcVHwKAuiPtpXji9V3eiD2pY5DGNgYG2kDUktWEkz6
32854	payment	2133	2133	1874	1	1	3396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kmqW5sRQkZm6LoJCrsZ8Dt7Fv1VRKKEvGGgF5U6xF7LgwSo2
32873	payment	1397	1397	1678	1	1	13001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvx7hLGp4u97dQMGfiMtcpbCzwoX7Gzo8iT6Mq8Nbts6qLyR3
32874	payment	2133	2133	1874	1	1	3403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSGVEjTaJfqNjmPF74MWLg1Z872KZFq1UcMbyTN6UpwD4M4Sm
32875	payment	2134	2134	1874	1	1	3498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnBMCk2C5Vu69VTBZxZD1LVeZ5JPAtUCeFV4wiJSXC15x4Bpa
32900	payment	1397	1397	1678	1	1	13010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnb92q5LMKwoPNRwyvA5iY9Ma1cx1KP3vJsHLNN8A98kb5QeS1
32901	payment	2134	2134	1874	1	1	3507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPXP5dVUF2sB8bjwQtPT7cv2M7MCLg8zE8TkfBrTNjLb8sCUe
32902	payment	2133	2133	1874	1	1	3412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXH6nrj4KmindnqQ13yFEvMyfLUKnqdRiqN8eSqZrdXnKquLut
32905	payment	2133	2133	1874	1	1	3413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPDksgWR7DBf5sbXcDf55A3kHyzdGQmhMKfwwxMZ4NCTErNnR
32930	payment	1397	1397	1678	1	1	13018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKY6wEvgzebsK6drNYt8LVyFLA2DxGhk8HebWa1mawg1Wzy9U
32931	payment	1397	1397	1678	1	1	13019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBqXoJtUKJsrGb8aj8KVoTBswmyNx8Hzbak1DGan3S7oHKptF
32932	payment	1397	1397	1678	1	1	13020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5pHg5xe6Mm7BDQYZvszFteZhv8xruJrHuw94Y88G1LXpe41d
32933	payment	2133	2133	1874	1	1	3419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3G2WLQqRz4az5YkpA6x7uKxj1xRQT75wdeV4rR2f8tGk45CP8
32934	payment	2133	2133	1874	1	1	3420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nzwQaFjxvdnZR7VxT2uTGxBBJbHBb5vnzPoLuigPGMRzJk8D
32935	payment	2133	2133	1874	1	1	3421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F3BrJqdjqDNSTd9zbsabuZkNTmZiyxMzWohuF5jmH3k2MApS
32936	payment	2133	2133	1874	1	1	3422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCgZnw8jB2SwBGRapFQCbtCHeRnwkN5JsdNXw3VX4doaUdEMV
32939	payment	2133	2133	1874	1	1	3423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRMpRDRk2UjPxC1hoNAXzPXPpq8eW9FDqBoVu6WgwwNrzFffM
32940	payment	1397	1397	1678	1	1	13022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWZnFBYJGTrJAzVFYKJZ11aerE2aM7Qbg7UKYn8ZoSAeCsQgB
32941	payment	2132	2132	1874	1	1	982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTQELBUzSA1cPMbY8NCqGCU15uxmf1Zf1n5rqXqcFRLj61myJ
32942	payment	2134	2134	1874	1	1	3518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JmYZUeYrA4EgkxJmUYBbKrE4rkHSV7AjAg83ATFBEkdP37cr
32943	payment	2133	2133	1874	1	1	3424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ohhbb3dbWDwtECiQWHupMSZ8rSVxvCecZQiHyAptZqnPPeC
32959	payment	1397	1397	1678	1	1	13028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJxt7xK9cHe6YrAm8yucf2CLUTWqcftaFyihMDgJCmKEqeLPt
32960	payment	2133	2133	1874	1	1	3429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCrFj6yUS6y6ULg92jNR36E7ySCxyz7LVEkbkUY3ptqpDLa9A
32961	payment	2133	2133	1874	1	1	3430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvP1b1wPYB3ANTsakhXbsFGN1uZPXgNwcAbUB3A2cCXZY9hYmt
32962	payment	2134	2134	1874	1	1	3524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPvHCn3DvjSMVHXrrZAbnV3H1dvAgyNtGNZPKgc2tivxNW9eN
32983	payment	1397	1397	1678	1	1	13035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCryYp6SG4fzwcHGico4XfUzU6n3uLW7HccFRb664ARPAYToDH
32984	payment	2133	2133	1874	1	1	3437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRxm1RD1BV9DXrWgSYZWVp4CtWRPTh9we7wSMN8xDx1guS1Ez
32985	payment	2134	2134	1874	1	1	3531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bGMiwWfZn4yjy8cps6MPUfnkPDrub2UY6JBeyttnDDh1eLBA
32996	payment	1397	1397	1678	1	1	13039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKsPrqcMnmnBbjCqCHSJesneLApwWRkqSbfQ7jWwurXxhyjZa
32997	payment	2133	2133	1874	1	1	3441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD11CVwWdSBj6xB5Eq9gJu3KJJF76GNFHfKMWf31t1Y65q2Hya
32998	payment	2132	2132	1874	1	1	987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDY4G9g4jVbF39AmtrzWwwaSCYUgeYqZ6hhmTp86qkvHaa3LoN
32893	payment	2134	2134	1874	1	1	3504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHqE4eQiZLaMt7jkbfbnXo3oVv42oJG1yoLFwrMYfkupdoBna
32903	payment	1397	1397	1678	1	1	13011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9tR8WNtJUvhM24zFoNuPLaYAwz6RfthCSQz3YJzaoUZhhz2w
32904	payment	2134	2134	1874	1	1	3508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBra4GvqmiptKv4DFemzoZabycMct2Q5sEfzj3gCvAw3xSHKq
32906	payment	1397	1397	1678	1	1	13012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysF2uuzYqB6Cb9aNhjnJaJo5Hs5tzkGXBe8srfkYipLcu68ko
32907	payment	2134	2134	1874	1	1	3509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcLaguAKQy2PcRqWCYwTAL8C7hBpruGNGzSYdTUcs9HN64FKC
32908	payment	2133	2133	1874	1	1	3414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Q2pwThMtN2VEsUe8cycHQCvwFEdnDiEte4vQxkBZUr9VE7tU
32918	payment	1397	1397	1678	1	1	13016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmymadoU7jcGVuVUHpTrDQdheeB8imrZoXwWcuYxpb6wukfN24
32919	payment	2134	2134	1874	1	1	3513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyQoSN8FfL5MCAvtcAr9yjLYLDRoqWncVsz1bZ9MsttZYx7FN
32920	payment	2133	2133	1874	1	1	3418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc3vot6c1BuHptntRzv8AWv5H8fJusErF8JQ7KrauVBT3jDYp
32923	payment	1724	1724	1303	1	1	9	7681000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZW93qBKpbSpKJxAotM1efdKgGGtCb2qyfRqTS3e2wagrB2Ze9M
32924	payment	1724	1724	1057	1	1	10	4085000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZA4LPiuNyrn1T6yaEgspDF4Vm7W1F3sBBdfpjcimA8euEBqgWF
32925	payment	1724	1724	1177	1	1	11	2757000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZ5aSsowMCucEhkuTcxnWTEg1KvckD17Y5qa3M771o6Vt5Hnf7e
32926	payment	1724	1724	937	1	1	12	2280000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpaJH9CCSes5tZzXszfDmeum9Dhcn5NsfkLRcPdnAB9rpDLEbVpn
32927	payment	2132	2132	1874	1	1	981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThmuHACWBtj1cAfDfqCd3p73nKk7LwTxSGrJYSpEkmSGmrrs8
32928	payment	2134	2134	1874	1	1	3515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqera38ZGw1YL1Ac8K7jYq618yvpvJZip6UsC1cssxUWwmvcG2
32929	payment	2134	2134	1874	1	1	3516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1d3Cy7SSYKjuXZwKpDJAYsoHN3pNgM3zxDiZxgqCzbT594VU
32944	payment	1397	1397	1678	1	1	13023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfybmZffFoTT8yc37opY1etSxkwsamC7EhAGNeJRSKuCSZhmsd
32945	payment	1397	1397	1678	1	1	13024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWW2qnXLPj6WCPbbFqVhuosKVjXxHQW1bsHpSZTp5J1aG6Jknr
32946	payment	1397	1397	1678	1	1	13025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5YfAWBrCH1rPcoueaPrnvHgcz6wBLqvESJfqzpwGphW6epdC
32947	payment	2133	2133	1874	1	1	3425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMnjbcUkEaQKcFD5LodWrGMybsc8eunk6MK5YSDZ9TNanyred
32948	payment	2134	2134	1874	1	1	3519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQadvq5BtznYCk1w5zCNQftzyDfeCDd82Mn9HuSUDYaLRH4Er5
32949	payment	2133	2133	1874	1	1	3426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZK3ymiyrUVomsgc5Wb1iXfNGpBJFJXsZLp2xYHFKQb3x5Dma
32950	payment	2133	2133	1874	1	1	3427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikAPSAfbDZhXz3VMqHmYUVxP2MCGuDczP5oqjWLqvfw8vmYFE
32951	payment	2134	2134	1874	1	1	3520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH1BN8efasECBGnzWfWiU5pETpK1RVbvoRmGQL6fh9my4BcVu
32952	payment	2134	2134	1874	1	1	3521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgvLSLeK4Y8m1aY71eCbYNHjHQ5mKirFQ3xKRXPdWBH6Jp8Bn
32993	payment	1397	1397	1678	1	1	13038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmszLGt7fZyZr4A72cqynKiJ1ccrgC8c65CLo7f394DibxFU3
32994	payment	2133	2133	1874	1	1	3440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr5XPyuKxBauqNY2fvuX9VXbatiqxaquPdf4k3w8jZe6orBZj
32995	payment	2134	2134	1874	1	1	3534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSumhMKhv58jC5UKZyughCe3pkaMEzCRK41AvZiRnK8vAW82K
33019	payment	1397	1397	1678	1	1	13046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDRiBVNuJHvQdqzAZa5UHdxUgwtPfkmK2P6zKfvGS5RZHPeum
33020	payment	2134	2134	1874	1	1	3542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt48LEdkn3HBXeJVyTJ18qvLVcz7iMtknkx9WGhgVuXQSu7Eta
33021	payment	2133	2133	1874	1	1	3448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KxnsDGStVsHvFjRXk5H1SDeETA4ytVNoQFpv5XNPhqfjtYnS
33022	payment	2132	2132	1874	1	1	989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQ9HR9gAF3s8uEN72Ea5jwdFWJkikmb4FNMXRoSRNhH9xFWhZ
33045	payment	1397	1397	1678	1	1	13053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUefNrCnWb49PiYePyZCR6p1ZHdpEuNHNwebbJHAQDcYAzX3bM
33046	payment	2133	2133	1874	1	1	3455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZtQNPtbNjCaDWPsydE4gnubTU9viTFtWv4eLws76LaA2AvaF
33047	payment	2134	2134	1874	1	1	3548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2SR6etD1GTLkHu1gwL85ZiGVJjRELG8pqhvsXqYQoAptSkr8
33048	payment	1397	1397	1678	1	1	13054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfqam9tDT6N1xRsHZMoPoJ5Wn768d62a3GZBC4Yrqa8JsEVAS
33049	payment	2133	2133	1874	1	1	3456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAxTq23Zr575YT25g9d2mEVKKiFzWpna9Uv2MxTTmVv65hh5h
33050	payment	2134	2134	1874	1	1	3549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy3Ndhr15q1Vv3FJbh3jenRasZZU8vDmqJRemVwGKFgLocWhb
32898	payment	2133	2133	1874	1	1	3411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevPVqw73gcGJjJHi8dcupUmUquENxCzYVYEAdJbotkja3jkwy
32899	payment	2134	2134	1874	1	1	3506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPWJ7r2VRBQAB5NARsUrjqCWRqAT83E1BsiyNi7rj4RE8d44e
32909	payment	1397	1397	1678	1	1	13013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpNjNzZnJ4cMya6wtb8MAbpoAUfWNh3ZfUjz9r1AV8NCZUyMT
32910	payment	2134	2134	1874	1	1	3510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1sjbEyfhfrTDTUTLb4dU9BvLznCkpsbT5iaVrEFQ2dgaHvrQ
32911	payment	2133	2133	1874	1	1	3415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKd1HA9jDDXoMzLk9CnYHCGr5hxVmqhmustENKRhM7Y1iCw91
32912	payment	1397	1397	1678	1	1	13014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdgBcSjEtoxRCirK6wwK6JtfLMtbWHPRP6aJNavQQnuad9ERz
32913	payment	2134	2134	1874	1	1	3511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezvejf1vpF3Ej4QVe75txyjtMrwCr8C8dnWXBypvaAMGevrhZ
32914	payment	2133	2133	1874	1	1	3416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnefN49DAuDWm4qYiPFFSMy3qQr7bcTMuJE7arhVDwae1ygMR3
32921	payment	1397	1397	1678	1	1	13017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEmaWiLdK4hNwhegStyqLvKcA8ZWKAi2cnKotnzXMsUSPea9v
32922	payment	2134	2134	1874	1	1	3514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhMc4gNeCBgc2PQerXJ531a39cLQ12Wdi8R8TbdsrCjAhyS52
32937	payment	1397	1397	1678	1	1	13021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZrtAWFZKjASv9RjUDUChzLHV5qhJVwRLQWFmnyaTtAhbPpDn
32938	payment	2134	2134	1874	1	1	3517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxTV4w95g8kwydjvR8JUV6PrppofGFD4Pzt6GPgS4VwnUfozQ
32957	payment	1397	1397	1678	1	1	13027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1LDaQSxZbA53yfYE1dH4zjhvueQQGPJ1GhST4m7w1xyYdrg5
32958	payment	2134	2134	1874	1	1	3523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSCE4LT2sm3SaUg2HfpMD36WpBQXj91XJAYgLPw6ad5P9eXWb
32986	payment	1397	1397	1678	1	1	13036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYRuKFBAmKw5ajMWm3ZWqUsgFJEBwi91yqovFTokmPGsUZVS1
32987	payment	2132	2132	1874	1	1	986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqyMDA9WsSyUWTD6gD9YRK7Da3LAhnbdM6458j1HzrRVUw5mr
32988	payment	2133	2133	1874	1	1	3438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSiZA2AfRWq8xd9aqrpC2gNrLuX5ZAro357YHdoBegbaao7yw
32989	payment	2134	2134	1874	1	1	3532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEyN7JpBkME3dAeQNa1QbLJRtQiXHhGJqG1fVMW1jsCCkdK15
33000	payment	1397	1397	1678	1	1	13040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiY3TUkVfEMzea4nRxm4g81zXyhiJBBzChD6NGZKtU1mHNJ3Q
33001	payment	2133	2133	1874	1	1	3442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJXj4me4nvFz9TABxkoa2hoEVfGLHtUbJ26sGHuPNkWR3j2ZW
33002	payment	2134	2134	1874	1	1	3536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMjnZ5amCoSvor14keBo6Re73X34aYuEdSRmPGuRpXCVMmDZm
33003	payment	1397	1397	1678	1	1	13041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5ksVeu338wiH9sxCirjyQrGPQVPEhv9W88Pra2s4bS6Ti9s4
33004	payment	1397	1397	1678	1	1	13042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNA4cQ1NHozixeBfG3k45qBvvtdphgZr1MAHrAJRVmvDJ6JqC
33005	payment	1397	1397	1678	1	1	13043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLY2b3qhVpFNf6WXFLTFHhn1pztvdFN7r1RZdSh4myX7bqDyaL
33006	payment	2132	2132	1874	1	1	988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa17c4owTmGVdqwYzXrVU922wB9pZ3Wh2ooZCbQ2xqN7vuRgKd
33007	payment	2133	2133	1874	1	1	3443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuu7BuwXMSonEqBjCMDhKokVHncHwGDq6kttmaLFkGigF924V7
33008	payment	2133	2133	1874	1	1	3444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYte4USMi8XjDvqCPh7j5jnAHEbofTy7aj49mqYkFDqK8aQhb4A
33009	payment	2133	2133	1874	1	1	3445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NZJZhr6bH5MFHczhcYv9EXLcLEEyTPuKMen6CwfQWG3NYsXy
33010	payment	2134	2134	1874	1	1	3537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHbUSU4Yz7tZ8dHXeqbqsLLQc9Qx6Xae8JfGYxTCrhUGmQYnj
33011	payment	2134	2134	1874	1	1	3538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvBSmTCczNYXY1QNLNLwMVrxhETaMYJHbR83o9UZfaA6azrbV
33012	payment	2134	2134	1874	1	1	3539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JytrfzmPYNmRD5aF2VdeQ1Ayz8dDMV6hsc41NRZp2inPd6xi
33023	payment	1397	1397	1678	1	1	13047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRXsp3sPetGD2G2NdHLwViVDXFDhfkmDGX9c93jrTAyP7teSd
33024	payment	1397	1397	1678	1	1	13048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dhtSAqgNfA9h3JAqdc9nV3drFRHVHaswCMS6rinoTnHMDb1z
33025	payment	2134	2134	1874	1	1	3543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT55P6xmFsdN8SjrSC3nQcM8oSsnP8oAXMsrw2vdiJyd43PCy
33026	payment	2134	2134	1874	1	1	3544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKGAq8ZFz8z9uBCjyv4CC8ZWdRBiuS4uFU8i8G9Dqs4soX7F8
33027	payment	2133	2133	1874	1	1	3449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSZBxRK8X7uDHiFynpf9ZSc5wYYhjiuhs9C3Mmriqg4fq1ytf
33028	payment	2133	2133	1874	1	1	3450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThdzKv57ZWA7vCkSd948EZaysRYDjNuF8y3aXwWvP69MNG1pQ
33039	payment	1397	1397	1678	1	1	13051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeYHMhkQ9ymRz1HZ8yPkHaK3BqqBzAxmFYcHoMEeecqQoHppX
32965	payment	2134	2134	1874	1	1	3525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddNCiCjUMb9cC4vGFwEnngDQpMaskEysnhhDvsUUDQbkVVJaE
32966	payment	2133	2133	1874	1	1	3431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzTq9KmVMNEqoWQseSDc5jsSW7W854zzthJ8QE9b8aM3WDzr1
32967	payment	1397	1397	1678	1	1	13030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdjtEcZGSFvx8awTpvhhHXfba1k3DUp3BVAKqESKwWQ7ziC3L
32968	payment	2134	2134	1874	1	1	3526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkEEpMP7qn64A2JWznDBcuL5faopa48kQ7fiTfTNpo3Kdr4VU
32969	payment	1397	1397	1678	1	1	13031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfh5wP9JgWHsjg7YaVV7C1eUxneX8jDqWvYgVJXamQainpVYs
32970	payment	1397	1397	1678	1	1	13032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bKd5t9RUTDgrRjiXKNjNAi3qq6FfZfyiPYjTdujBALaHxD96
32971	payment	1397	1397	1678	1	1	13033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvXG13bivXgLgHBKsPERRiYtHkPdBfUswqzmwHQyATywFuDZQ
32972	payment	1397	1397	1678	1	1	13034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NGwzFCJ9BLPw7KvLjyd8cEyJHbYg7hLaGsu6No8JvGDWubk5
32973	payment	2133	2133	1874	1	1	3432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2Z3fXoHgKBHCh2pN1ErnMqWdhqFy7ekYhDg7q3FkHKj3qA7N
32974	payment	2132	2132	1874	1	1	985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEbmiVp4jwL7VX2YNab3DgLKChXotQVmEKH9WEcnRmmf8oGgv
32975	payment	2133	2133	1874	1	1	3433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZneiH1oVPEAKuEUqHfPSYEPcPWHnPoNER8TfkcSUH629M4mFSc
32976	payment	2134	2134	1874	1	1	3527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqanVrbrFEfRjnK5Ef1yxGn7EQcpcRr2TPGm3fHnXJdZMZikDY
32977	payment	2134	2134	1874	1	1	3528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNxYVyNLfGrfzUuATQQVKTgrwhVynoJHYHShPE3YPmqXK5V83
32978	payment	2134	2134	1874	1	1	3529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxqYy63N2FAui6BddsF4fPNGKbxy8HC6jDYcB6E9XUkznWCrT
32979	payment	2134	2134	1874	1	1	3530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZzxgmZiAfjb46v1MZbE9j7R4DQrVzrPRpRLsvBfjxK6iZWBo
32980	payment	2133	2133	1874	1	1	3434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6z2Fx9CwjvSju87j537M5wtqp6kBk33xjy3tT5q49sDramPFP
32981	payment	2133	2133	1874	1	1	3435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqzk3vWfjy8Fx6iNDB7hQBjWdqdW1HQhsWphkgxkkPbAjoNpF
32982	payment	2133	2133	1874	1	1	3436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ngV14GXjvbGQF5mpqtqY7hoo4M98QT5Jce9QrbgPm7s3LbE8
32990	payment	1397	1397	1678	1	1	13037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8XQNgcrjbBXTvsRTpc4SD7gN1hLUfpMVHnooV7Ua6Rz8sehc
32991	payment	2133	2133	1874	1	1	3439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX47gYpyonTvEn1HiUfWQvt36kKQbEzSsAJfSfTPCz41VkDBaL
32992	payment	2134	2134	1874	1	1	3533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2jg74n71JoMaD9T8QYWmVa4MWWfumYjD7krMqesK9XgBrjtp2
33016	payment	1397	1397	1678	1	1	13045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQScYvhMN12Rk48BHTexvLvbxeZBNRkrVAD7riYjDViaRZdNfL
33017	payment	2133	2133	1874	1	1	3447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLgK8iw88PLDDzMCrcd9CSEMp71fokPxfGfv81zG5g8r7USfF
33018	payment	2134	2134	1874	1	1	3541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcp8CeXbsib6wY7zUayYucL4UhnMRJBC2Xq3ixUxXqW8ywgmeu
33029	payment	1397	1397	1678	1	1	13049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrzhmusN4eafc461kyKcNZdk7o6PpgGNHQHmZvXJYM12epFZom
33030	payment	2133	2133	1874	1	1	3451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRZRgSeucwBjpEjjhgfQ7gN6bjYS6E7yULGBGqnUeEXXNivS2
33031	payment	2134	2134	1874	1	1	3545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBPiESLg1eNsonv88ZkcFdDusX6njJvfEnphTaCExitWuTuEo
33032	payment	2132	2132	1874	1	1	990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoixuFwryRviNU2iTuYFcDNosuZATFgxSyUE14od76chiF7PYv
33033	payment	1654	1654	1340	1	1	7	8295000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZ6GAtvB5UvfbYtbXWTnS1V7Zsz6BoF96hz3nv2uD2QLrC1gvmd
33034	payment	1397	1397	1678	1	1	13050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP81FeRPfirtrw4BLPmMQtJJENRXmyT4HpQ3Y7siW7vknNqD3U
33035	payment	1654	1654	1094	1	1	8	4413000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpaEZLwocahcsUJ9ETLN36M1ynjPs9HKPenJ91aX3N8ictrqsgUB
33036	payment	1654	1654	1214	1	1	9	2978000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZcAgJwVPoC29qgp2334QYfGBiYm84EAVqrqj8Bx4YoU3vmYAds
33037	payment	2134	2134	1874	1	1	3546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1so7x4Gm1Ht8TKeKosTTpDhizNw3ojjG1ppL5Bxa1s3PJ8nJL
33038	payment	2133	2133	1874	1	1	3452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa493tmbYNGm9WejMX2pVkZiB2BFz6BvX49dyyP7awWzeBnckSh
33061	payment	2133	2133	1874	1	1	3459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJF6roGzbySQAg5gNr4GFHBjjTL3KAEwKpepva3sYy8XG9TMAu
33062	payment	1397	1397	1678	1	1	13058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpyRZTr73rZYwSNSQojgpb7cWqfSKotjsGTkXKMQo3rRQDfqH
33063	payment	2133	2133	1874	1	1	3460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjP1EQwCnhYdzmbpu9eyMj82BVS2jW4zQYfS7mdTKgRZJxd6G
33064	payment	2134	2134	1874	1	1	3553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qt3qneerMiDHe6PCGv8r1apLc97Kqs97mJPnAFLV234Fc7zc
32999	payment	2134	2134	1874	1	1	3535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsd81w4rH6GnqfKuYb3byC9JAooShqMnJqj26pNQFqxJZKFg8
33013	payment	1397	1397	1678	1	1	13044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeHTZiTYYB5tA61BcjeetdHkyNd4tecmPjaKAAdghUUkmd9EL
33014	payment	2134	2134	1874	1	1	3540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaUPbeK3T3FCXzy8zmqwVcr1qVDwsX3N31y66uQyPyfAmvNxV
33015	payment	2133	2133	1874	1	1	3446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HCGew8AU3Nthu4jaxbFXAMZbh7deZ4Q8Qhd9MwxiT7RNuXWk
33051	payment	1397	1397	1678	1	1	13055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFzzLcFTsShMaRUakVtKUV455vaDN4pwJJknx6fDEPK9Xa7nn
33052	payment	2133	2133	1874	1	1	3457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3iceucGymuiwh3zHJ3Ht8wcC85pqdSU3zaa3if6EtFQvJ6Qy
33053	payment	2134	2134	1874	1	1	3550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLrjpEGh4vYLk2uJ24RzKRnFU6ZJEUnFmEhujstdCA8M9yWU4
33065	payment	1397	1397	1678	1	1	13059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvujpvArU8udWSyoaX2X2g5uvK2zBPgDT98Ta8w7CjK5TetTC
33066	payment	2132	2132	1874	1	1	993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9a6PedWYDAyvCrnHkysuc6acwwM7rbxHRQVZXe1j7Avt4KBZd
33081	payment	1397	1397	1678	1	1	13063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXAmpfTmBcUghwZGgEKd6MAzKHsaqTv9CNxwAMYe3CHGXCmU1
33082	payment	2133	2133	1874	1	1	3466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Kt5hrKKYWV9G4WBXp7U36dhwHE5ofuFvUDJS9KFup41ys3Th
33083	payment	2134	2134	1874	1	1	3559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqpmL3ZPWfnkknQqXPUcdZp3ckfzf7QvmSdkHUEnbM6e7GeBP
33117	payment	1397	1397	1678	1	1	13074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEV3SYYJvydHrZqY16NFAFQrAPCKz8eRhs4S9Ln1yGcEc6wnnd
33118	payment	1397	1397	1678	1	1	13075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjFPDBbJMHeDRbeyZgMmrNa9cVQmTDR2AYxGenDYYnpfRuxoB
33119	payment	2133	2133	1874	1	1	3477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbwdLxRYKGx4PHaynZBbrzx6yEatXfTEq2t5HqJEF8CmtX3i4
33120	payment	2133	2133	1874	1	1	3478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdrxKYmWSoPgSKcfY3ATCB3GdWR6vZuXkHLHRHKRBjHPvSGzb
33121	payment	2132	2132	1874	1	1	998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovhSChfXVwz4ebTZ3RZqjD273pAZUwbgzjTiS8iBZs7gG7p2U
33122	payment	2134	2134	1874	1	1	3570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CKtUjRPdE7k1d1JPKWmyXtdgxj3mQne5x4AMfYu1GvxjCqcQ
33123	payment	2134	2134	1874	1	1	3571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZetJEsUscCWPhibnt4WAuTBijR2fAUy6BkVf8xqZwwwTmzWj
33128	payment	1397	1397	1678	1	1	13077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbbk2mXe5DoHtqXfECq9FsW7DLcrSyFkQzAvfUnizcXZjas17
33129	payment	1723	1723	1120	1	1	7	4487000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZcXjFC88nFXSjNJ8HMY1owkMuBJYNtkWzbZS52jsgfpubD86Qe
33130	payment	1397	1397	1678	1	1	13078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JhTNf7GChacapf9QuvWFRKAkCXfHLjsgcB9gzvN46iurhGyL
33131	payment	2133	2133	1874	1	1	3480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsvDPNKj6u5hFrqhm2BCsGriySxE6SUpJrqsVzNXa3YMbQF1i
33132	payment	2133	2133	1874	1	1	3481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdovThwAA2gmKP41bupA3toqCTqz8jLT3FHTy1Pt7eukmALnoB
33133	payment	2134	2134	1874	1	1	3573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyGxAcQALfhDYtXUTqir8ZYgrwaoNcZtxDhYKmb93VDB83qLR
33134	payment	2134	2134	1874	1	1	3574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQNexA4hycDd7E9BK826HDKrRzDLUb4j3XT419ro8ydfwbZWX
33135	payment	2132	2132	1874	1	1	999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gm8CwCoZ7cHqNj8UqzxPjnZjMYaXHt2Enx2fi5DoBjfDpHz8
33148	payment	1723	1723	1000	1	1	9	2504000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYzMSX8bnD9qmEnWWcJovWHuVrBtwL72X9e3tppidv2MbTeHMGT
33149	payment	1397	1397	1678	1	1	13082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7iatvapdoRknfGGDJYih6oHdJHXfy9poogjDv3W1x2aQV8SC
33150	payment	2134	2134	1874	1	1	3578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Xg6m3UjcUG4WrKXLB8vMVU56saQ14mHoGRbR8zdRnn4mcPnk
33151	payment	2133	2133	1874	1	1	3485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSYBDTTP4RYVFJXQ3M8GBfqdXrkcmJU9hjAehWp33Fn7WdGxK
33180	payment	1397	1397	1678	1	1	13091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPuBrKJNZyEhuYUvKSG3ivbTxfF5ccJyxbz717c2V8tbvKkaX
33181	payment	2133	2133	1874	1	1	3494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfna6dLww3uYHk1oRu9L6ka2VxMjzGEbDTYvmiNyUNJ6ju7zhx
33182	payment	2132	2132	1874	1	1	1003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoYjNEgfjV9MM715aBctxhqs6a6cj2N68mBiubDhUj9TTraaK
33183	payment	2134	2134	1874	1	1	3587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrFhJV9zEGf5eyfGrkRTLt3u77KZKhVfLv7xW1fqwM4Yqnr5s
33190	payment	1397	1397	1678	1	1	13094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQ8TKqW6bZTMdW65wyHVYsgoCf7ay2qMhoEoUoFC1NvqrBUAj
33191	payment	1397	1397	1678	1	1	13095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuJeCem2WytJEx7NX4py44CmvbEBv7m3KcfkZxjDbAN5HHH6c
33192	payment	2132	2132	1874	1	1	1004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdAhNA7gegqqHuRrag9wXHMRSkYSVjr3D6HAcnF9fVEtnHm8f
33040	payment	1397	1397	1678	1	1	13052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgXjbd6g1h2NC4QMw2F55Q6mdkjpRv8eBj7kFGz9KfXKUgYtF
33041	payment	2134	2134	1874	1	1	3547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwcPvxxCpTAVp9oFLsGyXfgBrdrHp7xiQf9AQn2CGKRVMRyyU
33042	payment	2132	2132	1874	1	1	991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV3bbZG7Ujn8fGP3EKM8BPmeJyyhbMJPVrU4nKaH2HMHKMjE5
33043	payment	2133	2133	1874	1	1	3453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnbKnSDweDFQHRd41NDp75RQRpsLmmZgV6AT3McpFevQDbXZC
33044	payment	2133	2133	1874	1	1	3454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADKqgdeXq8Go6yc3PJ6eFK9CeZCqp9ym8AFgFHYzxR6e4K6Wx
33054	payment	1654	1654	974	1	1	10	2462000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZgsWmkokR5TZ3AZf4xFnEWmkgXJirLLDpBwGEgAJjVA9xyoiis
33055	payment	1397	1397	1678	1	1	13056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiANVivCDqMMS3mPvXpyY5eXVn2ScHuLmMvx45wTZdhc7XHFAZ
33056	payment	2132	2132	1874	1	1	992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7huytpQB18DymS3uGJgYyewABi4Dk1BMJq6gKBgnE3rPKvJEK
33057	payment	2133	2133	1874	1	1	3458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPXm2gs1JbSY44Dwk4Xc78hPMrjBvgZXLFF6rZ9MnxKxSkfLi
33058	payment	2134	2134	1874	1	1	3551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePWJcC5fUW1JiRsUx2j7NWKM15ep7XGJXNcLi1vgGZgceSPAh
33067	payment	2133	2133	1874	1	1	3461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxf4E1xeiEioGReEDmkM8TdkvAGzNFnQEGn3K7hu9PfVKWBn4
33068	payment	2134	2134	1874	1	1	3554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFWq2UmhsuEPMxc1KPBk9bH2qsbyAN1kWkoy2LpzioywYW723
33069	payment	1397	1397	1678	1	1	13060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPx6beJn4nm2RJQZk68waxbgTXciebSZVSsGjLYhLiFo8wB4s2
33070	payment	1397	1397	1678	1	1	13061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2i9pXE7bBSftvdt8F4R6QDcr5eDGoUUiZ3vULov5BVMBeADhW
33071	payment	1397	1397	1678	1	1	13062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBiz5WRjh7f6EgRbY3UYaDXPxbfqFUxNKce9vkT88WG4NALex
33072	payment	2134	2134	1874	1	1	3555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxxrGmkFpfqe78Ma4i3sxb28VeC8LUkv2wFFuwpctu9firKWC
33073	payment	2134	2134	1874	1	1	3556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwGWxHSCKWxJjZqDpsaaG8dxsrpmjJMz51VDnKgnPoUN3ZZWN
33074	payment	2134	2134	1874	1	1	3557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mjX1NZGv2Wx4aEPWhwMwVw48mTB5Xe7AgkvZt8Gejww8CUih
33075	payment	2134	2134	1874	1	1	3558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxZzF7UV21c76ySNy9GAywQMnRC4dJkTVS6R23Zh8iZNkjJ1B
33076	payment	2133	2133	1874	1	1	3462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47dVjuWeWcLcqiJfdBvYWyMhu6tQkt94eegJngvDQqaPNgXD2
33077	payment	2133	2133	1874	1	1	3463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhneRGiNRMQppiKmpdDRctcp48w7ncSqSPa35ma9ZZPc6uNdEw
33078	payment	2133	2133	1874	1	1	3464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmu7mFik5eMC8AuaVketruuarrksPSnbFd9Yh4mx8nv1E9ZYn1
33079	payment	2133	2133	1874	1	1	3465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rSSwyqK3mQp8VZEX4TSVVhPnkxxmWD3rwzLzrWdwV2vgyeRA
33080	payment	2132	2132	1874	1	1	994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVvqpfzC85pNTAg9krh2K35jWXgbkynrbTLb8z3oKbgf37ssR
33091	payment	1397	1397	1678	1	1	13066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPvhtoJPWqN5yH1a8bStfqZHbnb3Yyo3dxPKjL1BPZBiCCWfa
33092	payment	2134	2134	1874	1	1	3562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxjjDQEQ5JMYHSmRrX2y8ehttDFh9UvR4EJNzDJWuwftpHZh4
33093	payment	2133	2133	1874	1	1	3469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSNPdbSL4mX2jdsSN7JMb3aaYbd6GhNDLSNRTfRMJwDoruVn2
33104	payment	1397	1397	1678	1	1	13070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj36QiCRPkh2ZtxHF9YqcykwTvwsnDGZDCeZgiUqfXd3ymhSNH
33105	payment	2133	2133	1874	1	1	3473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSZVqJeANad5WNZJw2NPR3AsEVq3gL7diEF3BKpZ8FzecbiYS
33106	payment	2134	2134	1874	1	1	3566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZze3mSoEZ5ie6FBLpAq87tnVv59r3ukobaVm1m8ewwccTs5b8J
33136	payment	1397	1397	1678	1	1	13079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc38h1K7Xko94xzv3Q45EaQViFhzPAfFrkpgT2y95RwNdfHvon
33137	payment	2133	2133	1874	1	1	3482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUc4giuoqKVa7ArDHHzzyW9d4YjpY2RnhJZB6Y96VMPaZUT2y
33138	payment	2134	2134	1874	1	1	3575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFKCNJ3ZyAB9WuAwheaLzcPAmkFATMZKsqNyk2tzThXVJJvnr
33162	payment	1397	1397	1678	1	1	13086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4iyaerTSqP6BcLWgpNmfTnAt4P11qfqfKQ8RkdgrDyYLQVhN
33163	payment	1723	1723	723	1	1	10	15000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	Ckpa4T4sjftFJQ6ppY8cv1s68fSfmZhk61o5kqHFvY3BZpSJnJBEr
33164	payment	1397	1397	1678	1	1	13087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4zks34nR8ktJQLzdFFYgYSjaim6KeiBNd7hDDfJ1fdNBSFoZ
33165	payment	2133	2133	1874	1	1	3489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4gLVFwAjXXrj2KSRLn3GnXddvXxrQyMP7ipd4zLwfikPjym1
33166	payment	2134	2134	1874	1	1	3582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBY2jyWNf11iYAJcjLg4B4eh89V1jTLfVuEf3XM1cD8uwSoxYy
33059	payment	1397	1397	1678	1	1	13057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwD8g4kVS4xzW2Rw5pTBfr3LdzN2KV5yzEwnQQskGXCYiLVmZP
33060	payment	2134	2134	1874	1	1	3552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUQrJd5Jnur5uJ5wBicZVddJpV5Au9qtWg1bJfLqQg3bG9zzG
33084	payment	1397	1397	1678	1	1	13064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSN2c65MDksEc7oByuGnmYxnSgRN8QiFup9VFHLS1W2FWjPi8
33085	payment	2133	2133	1874	1	1	3467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYt839DQxnS5WmVcE6Y2qAZZt5jJByERiDE9vLwG8XiBGAVPh5
33086	payment	2134	2134	1874	1	1	3560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUgoWN3DR187cRzZJxKof29aNca7nfhLVkFCHxSaQJrN9kjyr
33094	payment	1397	1397	1678	1	1	13067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJU4hL67WZ4H2GXxhsFU8qTw9zryjNiYSgMk6xsiiuZdJmGaoZ
33095	payment	1397	1397	1678	1	1	13068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHpwzC97o3TJqj1EwX4hRujWXsrLAMhAqQ15KpqXmCJ1JMc83
33096	payment	2134	2134	1874	1	1	3563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9CskJasQY8Mt6M53vNQ4PSUUJYfKbicrFAg4MRpGkEaBkxQX
33097	payment	2132	2132	1874	1	1	996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDK1CnGFZ1rd23ziRFY5HLoBATc1roeN988Ek4w9ZSjp1m8xaM
33098	payment	2134	2134	1874	1	1	3564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5afZP7V2A8afTK7dtpGsAPrXfqVM6Ke61Xatbin7wNhXbT4v
33099	payment	2133	2133	1874	1	1	3470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36T9M4uoto18JDWsU3aYJzNNwQ3vhCozPSm6bx19fsyU1wrYz
33100	payment	2133	2133	1874	1	1	3471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHtgxdxDD5d2hFhFG5PHg3B4ML3TiCbhuM7sqmQ3WL7arLPjF
33107	payment	1397	1397	1678	1	1	13071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQ47eWbKuXEc9eTQ757gTXxT9HfGreURpjazBRNigWR8eQFc9
33108	payment	1397	1397	1678	1	1	13072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFMuNCj2iUjT2MNZVYrHEgksM4WtpKobLdexhZHSipSPBfSfL
33109	payment	1397	1397	1678	1	1	13073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhSMyqnd149cYQTvewxgdC16GkQpZ4MQy1eSuXyE8Un8oPgUe
33110	payment	2134	2134	1874	1	1	3567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYnwGq95B7QTZPEiQzbiEEx4YDRdTNnYa6azozPLpVngGf78b
33111	payment	2132	2132	1874	1	1	997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95X8dUfRRbSQqHnEjKxpAHptFd68jyUJdeDDuVPYY63TMDD7o
33112	payment	2134	2134	1874	1	1	3568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAT48Xu3p9WCK3F2yi7PmwnoFFSnTvyPRDv8aWwwiwkA3cWCWH
33113	payment	2134	2134	1874	1	1	3569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD6v3Vw8oKgwj9EaoYiwLK5FtPmAVQbuMxJE94xVbPuVCeii3
33114	payment	2133	2133	1874	1	1	3474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwufdpXyyMTSiJtom7dLExAB1dUEdkWnpKWH5ztne4Uz7H1Qr
33115	payment	2133	2133	1874	1	1	3475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkpK2D9wy955dBQEHSZX6NSSbCTMdiM82xE19xoYVE79DyPMt
33116	payment	2133	2133	1874	1	1	3476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwciD582rM6KLrqWfu1PXJzWebdxfB7MAePtCpphVak4TYC5tD
33139	payment	604	604	604	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapCPCpV6CN94TTKH5mF8JkfrneePW2pKKjmuJ5rYdH5ji4KkB
33140	payment	1723	1723	1240	1	1	8	3028000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYYtt4bn7t41ofXvkd8jQ5NTYFxozw5xTBeBqUxREWiAwEVqE9q
33141	payment	1397	1397	1678	1	1	13080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9hdTomZ5wixjRZvtdDTMaqWGQ4CT7qwR7AiA7vVRQJJ1mwhY
33142	payment	2134	2134	1874	1	1	3576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNaQpbsCg5THxfcX35o4WB91eoykUALEKxa2KNNi2FmqYbTig
33143	payment	2133	2133	1874	1	1	3483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nPLd19KckQiTX16b13hGhrcWHMHS3gsD1XJfcFzmCWAuDjsS
33144	payment	2133	2133	1874	1	1	3484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyqCwG4AfBPaedSF6mEbhaNaY8VNFAr8n8Br7NN3Zz8dSdgg8
33145	payment	2134	2134	1874	1	1	3577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBxriuzrtUg2ku89iT8JrgaSUAu47i7GZauxnCKtDXAFzyPNt
33146	payment	2132	2132	1874	1	1	1000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKcnXNv8Q5mLG66mW6bAy2QPuFPdxeMr1wwJnxezHYBoLVTWc
33169	payment	1397	1397	1678	1	1	13088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcf8gmNQgnqwByLmiBnAJQTkgLFPnrv9pSCaxRUyfpsM3gffR
33170	payment	1723	1723	2293	1	1	11	2048000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZaHkYpnZBRcZy7acHAe29LPCpj2wuuTAFC2nSW1eZubrTjAofT
33171	payment	2134	2134	1874	1	1	3584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgjKba2WYyUp5TXNGfTB4cHNKybFnGFRsjwCncg5to5GVuCtp
33172	payment	2133	2133	1874	1	1	3491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRTgqwtgShJ1rCZ8xv7FQnNrPXdJtng2cj2gKveBifeUeEKPv6
33173	payment	2132	2132	1874	1	1	1002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJW4TWDnM2x3vUh3seT9uECudis9iaSyvJVQj3sCPiYRYyns6H
33187	payment	1397	1397	1678	1	1	13093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjBfffA6C1xBnE5xqYgf69CVmZDKSbF42wGsyjQ69LdyRRFHf
33188	payment	257	257	1546	1	1	0	1244990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8z7gAkx4Lga5zrTVJzSAyYPHZEPfD4RRmYET22g5Hv5at86L
33189	payment	2133	2133	1874	1	1	3496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWA4Tywr6yYZc7mytdbAUX18xkdsdCfYr4TjAk2rXxzysEWpiY
33087	payment	1397	1397	1678	1	1	13065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2ZZeVN2uJ5VLAA1WH5GXCH4qXFjxt6sZ88FeV7NhFqgWgdMX
33088	payment	2133	2133	1874	1	1	3468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXHiNbVvjGcVwUyFmGAdC8GPyp5c4sp57yDMmyEaQ1GAgMsAL
33089	payment	2134	2134	1874	1	1	3561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3oTAdRmd4jUk8MoMe9hav5Em98e8NeqSSUaUkk6jpY38kbd6
33090	payment	2132	2132	1874	1	1	995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFE7Rb8YMbjCYKcyoaQD8hTpqaVeSDcSVCaqojnvf5VtKTPiwT
33101	payment	1397	1397	1678	1	1	13069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gTbXVUj79UHxjt2WHcvHmgYeVDpa4fKJqyUJsZVojkzAvErx
33102	payment	2133	2133	1874	1	1	3472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3SqinMjjnFELW3yghLxwDueXxVWZPcML8fyL7T1oMsFFmKHV
33103	payment	2134	2134	1874	1	1	3565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM61XAwFBKLoughdgVQXfriXgxupxMTFcii2XnqDLGbfh26Fr
33124	payment	1397	1397	1678	1	1	13076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubkWmaQUr3fvkqJDqXD12auszSFsA5nyFq3qp92vrA6XpjyKv
33125	payment	1723	1723	1366	1	1	6	8436000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZzDb2cik6KGZZeo5EdNvPvy3VEzKvwzdjWB3FRxCreSF85RcPD
33126	payment	2134	2134	1874	1	1	3572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFqFX5bknTQu8Fs2pRRGDT9RxAnzXaJXxMvauEysLbf7HuEcg
33127	payment	2133	2133	1874	1	1	3479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxFcJqDGbdxBeoj175yuPYbkiUzs3WMWrr8L3yqfPx8RLLbVe
33147	payment	1397	1397	1678	1	1	13081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4aRaF8u7giUriUQNYo6tGoyZ7wAopbGm1CRoY8H17bszBhnQ
33152	payment	1397	1397	1678	1	1	13083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kiJcF4v4Au6uTZbcSnqJTW4hZQHnVV7jxL2dnRi9CfwWS4kr
33153	payment	1397	1397	1678	1	1	13084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytzmenmDPfDc4A1w4M49yTSSgrZJoWWo7jhQY2aJxW6Q1mPrt
33154	payment	1397	1397	1678	1	1	13085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaNb9A31TsVhTByqM7SmeaupUguVVYtXyJCFnSdNYExzyxU9g
33155	payment	2132	2132	1874	1	1	1001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkrcuFn9drizJDKQLHQL7JGKchqJgSL74CJxZ6H94HWMmdAJn
33156	payment	2134	2134	1874	1	1	3579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqaPtB8TTkx8sWZrxiqb9fABHw7rtPafJmytfxySAvVbJzCtv
33157	payment	2133	2133	1874	1	1	3486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtyMyKZeB7YSzfFH1mQapNswohK4eoWj9A4oNyzG1t36uDCue
33158	payment	2133	2133	1874	1	1	3487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DDRZLmNDPccgq6mAT11j98PYDHqzSuC8bELvGy6wA3AEaRxJ
33159	payment	2133	2133	1874	1	1	3488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaE9azcTuGAxaFHEoXHVQA9ccpRrafrgAEuhd4XqY5kRHZSSL6
33160	payment	2134	2134	1874	1	1	3580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn91DLTY2o1Css2cjXPMc9PZw61AFPfAiQVEeQ2K7EyVLXzr48
33161	payment	2134	2134	1874	1	1	3581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPGG6iAgqr5kTzuhA4615csaqKiS6CyrMbBsUFue3BHwtpPXY
33174	payment	1397	1397	1678	1	1	13089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACsW9hpxx9osZmPL6Wn6f9YxSjdA8AtTi32XaV8ThMyGB9TJr
33175	payment	2133	2133	1874	1	1	3492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9Wctz8qRMzDNPwLpoBD7DYaMzETHk1QLTcTWxWmCzSVtcrR8
33176	payment	2134	2134	1874	1	1	3585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVr4dMtQ3A8eUo8r9drJrMzWHCa8UuiAamDGum6yymDqiL1HW
33184	payment	1397	1397	1678	1	1	13092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJApZUn5mtDBQ1f92zqj2ZHdHE6PbrUG5uEKQKh9YDArJ2J32s
33185	payment	2134	2134	1874	1	1	3588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeKf585memYu9jxsNLUtdUJDmbpvE51Pj4LYY9495SiE3kXcz
33186	payment	2133	2133	1874	1	1	3495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk91Vsje2YcXFMLUVE3nJkTAxpopL6MK2rTEQzLVDhLtEYpZoS
33197	payment	1397	1397	1678	1	1	13096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcGG9nTRHjeyz2wqzR8LMHpkjf3EWsvn2xQRD82JUKrF6HUtG
33198	payment	1397	1397	1678	1	1	13097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULvcB4TKxnGU14qyTC9znMMZRPevWifimkCiVzujwmKYv9Jfm
33199	payment	2134	2134	1874	1	1	3591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvSt3AjuxRitHMsKNm6HLNcLd1kbouCcBgL4QgHnW8k4Fj2hz
33200	payment	2134	2134	1874	1	1	3592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQimS3m5GHyg39A41EoEYCPP49wsvkDzemQVcaBGXMBK1Aeygy
33201	payment	2133	2133	1874	1	1	3499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDX9LyStGHpFpmBsYfShypxuvjodyooe9mAfjEvibNpT3XMsLT
33202	payment	2133	2133	1874	1	1	3500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1CgCSv2zVph34Ek3gCuy1JTQGkCxGniPxe44etowMoMHJ65q
33217	payment	1397	1397	1678	1	1	13102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1ejDRFFbACYoPT2sEVucooBJkPvYmy5EqcjFidMkMxBANtRu
33218	payment	1397	1397	1678	1	1	13103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Cwy83MkrPYja3mMn4qPwJsCU58Fd5ECsgFerco77yWc18sbT
33219	payment	2134	2134	1874	1	1	3597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxSSAGAqq781fG2aXCksKvbkxsZ3efqRDB3gvMwzriAJiUBN1
33220	payment	2133	2133	1874	1	1	3505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1f5Sda3U859k3RwTRJghQE8ZMEbvSmNhAaEEr66Gu63MEssD6
33167	payment	2134	2134	1874	1	1	3583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPTQNjAYEsygWSZyVEsWrzJwSNC2C5kHGkpMk7R23gK3uKWUD
33168	payment	2133	2133	1874	1	1	3490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdtrrzdmejR4hMC1jUQu6ydVZF4QXkincUW2XxUS8v3gADLTs
33177	payment	1397	1397	1678	1	1	13090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts5DAcmEeSaYMTYtDzvHkjeHa21jrL5sTNAhr3dzTTLH8Vr68
33178	payment	2134	2134	1874	1	1	3586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd8Kqggp5BPcrwr4wRaHWewjLTMoCDZQSBrBv8P22D9WSwa3tJ
33179	payment	2133	2133	1874	1	1	3493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCoAXJHuytzCTR54YwC5rtMhiUZXsz3o7mNSQkTc4mWnHgEc8
33223	payment	1397	1397	1678	1	1	13104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ153CzJKkRt5DqWnrMyqA69q99qHQc9L2vWZe1eQYXRHt5rwsm
33224	payment	2133	2133	1874	1	1	3507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdaMycEqxy94BCxUf4sqH9XUaC264Dtv4Z1Tx3zATybJkfoGg
33225	payment	2134	2134	1874	1	1	3599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HtAozt7XPF4GQzAFdy2KzhuYFgQxJXMJ7Dx5ZMA1sQFDj6J7
33237	payment	1397	1397	1678	1	1	13108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvdk1t8FjSf3TBA23Bw4vgRu3xN7e8ptQjanyUuxnVK3dfZRd
33238	payment	2133	2133	1874	1	1	3511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9sZyi1MRqtc6aFhUdxGXH1UqM7fqMVaVVcEJ4fjRQVyLn9mf
33239	payment	2132	2132	1874	1	1	1008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnF6nrQeswqRSQCak73LugjYfKnYGJeQEU1mZhmD4kJPHXHKdx
33240	payment	2134	2134	1874	1	1	3603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn9katesUdz2b2weoq3Pcn8TwMebzg4TVUhVnio5VB6etTMsd
33251	payment	1397	1397	1678	1	1	13112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFTtZdxTWA52b2rJAxCzqVmRVEwtKrt1ahuuG9R7kfXaHEP8t
33252	payment	2134	2134	1874	1	1	3607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUShbN7ToXzf1FgGThS75cNs1uSmQ1FceiXRtaKrKYmaEFiXH
33253	payment	2133	2133	1874	1	1	3515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p3ZCiaYT9fEHJRGTBzrSZGMieMmQTJy2pSWGL8iQwe8hSBLa
33257	payment	1397	1397	1678	1	1	13114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZfRUsrt5FqUtTCnt1vd1B1GYBtvpeV9Uah9STCtCCwgYCsTY
33258	payment	1397	1397	1678	1	1	13115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMr3BysNjQsF3pZAuTTFxD5UakBvJUdCGmn9K3DfVYPm6ntiP
33259	payment	1397	1397	1678	1	1	13116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJnyRorQ8bej9EZtdc3tpNGQNm4wJFfVzsbhoKLjw46Eh2UcY
33260	payment	2134	2134	1874	1	1	3609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPTmQGCgTnwbff5bVLDww92AQ3PmQCn5Y9MTEVHoXER4vgsGr
33261	payment	2132	2132	1874	1	1	1010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeHtQzRiKuvJ7BGhgin7wHM3J4fbCmhBjucTJDZX1edozkqBN
33262	payment	2133	2133	1874	1	1	3517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dzSx2LxMLA6J5hPneHcvH5bRYVWFpWTxF1FGZaCrGQxn4qed
33263	payment	2133	2133	1874	1	1	3518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1rwYZXWHoRramYSMAGNeEMVQMidzNQt8JrSJKBHbMEqicasK
33264	payment	2133	2133	1874	1	1	3519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSN1gaRwaizoLXLkBMntTXSpFve6Hv4QDeEJsfkUxHP5VRBDQY
33265	payment	2134	2134	1874	1	1	3610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgp2aKeKyHDJ7W5oABhGCS2s3GZveBq2qHojXb7kgfLZTgeiwG
33266	payment	2134	2134	1874	1	1	3611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkB7ocfYmYDNFPqw66BE541p9PYdACYmvHPcQbgD28ogJDFLi
33267	payment	1397	1397	1678	1	1	13117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyoVsjUTXDoXi5seWJgECmQo9so9XBVyjE2pBK45YJMumzCiy
33268	payment	2133	2133	1874	1	1	3520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAtmGGVjsaJ3CkATh8Qm1EtAjjz2fWvb7xztiddLPkxuuTZVk
33277	payment	1397	1397	1678	1	1	13120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktfepXMx7vF5xTMqXgPmdvVF4sdjiv6TPM8E63NDbNkLpSfg2
33278	payment	2133	2133	1874	1	1	3523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4pwZpEE5bC1taCqr5k3Sg5TE7a6vgiLRxvM2GFSMhP5pgwQe
33279	payment	2134	2134	1874	1	1	3614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wAxFNXgrJeqhwuM7zdeuQzojQWtPmvPRn1HeDHfmf6F1TFsk
33302	payment	1397	1397	1678	1	1	13125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdp9V4spimZwmS5b9KiwAwrQtm4V3hk2aap59MbkhbAh9cQgzg
33303	payment	2133	2133	1874	1	1	3527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbjqJGjwSjSmwE8Ww95r9Hr3kSduDWzY3EcG9JRG9CR7SxiuT
33304	payment	2134	2134	1874	1	1	3619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXGYCUrABogwM8dS4XiTCY4cwvLe1pyawtccv2r6FtuUy1jjV
33305	payment	2132	2132	1874	1	1	1013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRnWEYLiST2c12npGkWKWaWKr8PxuzvqSrRzLDepsdRbF7Gn8
33326	payment	1397	1397	1678	1	1	13132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28kN3CSLURzcU8UvgamthrgaMajboyGuvh8m34RUn96b47Hac
33327	payment	1397	1397	1678	1	1	13133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVz3KrVDRjwDUaAcNb3sRwkDZJaD2G1nth7rRYUMvNvgTuAhZ
33328	payment	2133	2133	1874	1	1	3534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr47g3ZFKxVPdd6ypHWegrDK138yR87hR3zgZXRm6J1PVujSrw
33329	payment	2133	2133	1874	1	1	3535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtamquLsDgfiiC2JHqBUxprc7vnbXY7nnD4peRgadmBdbsEwyA
33193	payment	2134	2134	1874	1	1	3589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqy7RtqwBdekxwSqgtg5UrdJEbQGxVveYxr5UrCvTdhG8KD117
33194	payment	2134	2134	1874	1	1	3590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KtNwBTDD5aUAD5rcx3nk3dBhiao1BhC5up9q7toArNuyN3zn
33195	payment	2133	2133	1874	1	1	3497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7f9CZW2vyzidhmHv4TNrw4FT9uoaCNrRa4CkYaVweD425CxNT
33196	payment	2133	2133	1874	1	1	3498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAjKJ1D2ymXKrQuYLKFkdRNm9ENEnDQgMa87mCDBv6KGEaPk2
33207	payment	1397	1397	1678	1	1	13099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qg9xxWYZRPnAdQ8dHNRb8r1Y9sCasmo1TodYyfWGKXPPnGvH
33208	payment	1397	1397	1678	1	1	13100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBSpHRjCnD7nfD8RQgwi9bXsrDak1mEnZFpadAXoXtLuwUsWZ
33209	payment	1397	1397	1678	1	1	13101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeVEGnjwKeBHa52XSuhYyniFkEpsRxVGZWgvBBkpx1Z2sFdpi
33210	payment	2132	2132	1874	1	1	1006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFyRY9BYKQkmirE3tJQvqtd1vWWEyJaZdnW3Z2nmgEgKSkCTS
33211	payment	2134	2134	1874	1	1	3594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZj8nkAxRgXBFXE7JqT8UJ7XRxcGs2xf1ucKW9Rh2E3RYJSSb
33212	payment	2134	2134	1874	1	1	3595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRnUYSVfTqUeXifmEtxxUZqUDwUodiMm13KoyEDhkwvFxK4nX
33213	payment	2134	2134	1874	1	1	3596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSDiJJtvxK1swwCdSrUwrFGQmREDmR5g7FEskhoxbG9thouAg
33214	payment	2133	2133	1874	1	1	3502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7imwE6oekvcxmDLZFPqhRd7nG8GvXJ4N7GJo4TFQ4K6o67vf
33215	payment	2133	2133	1874	1	1	3503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVB86frmjCVZEvMf26R3SbywHBSEKRJUtFxuC4cCSK4Xz2AGp
33216	payment	2133	2133	1874	1	1	3504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbVyvvBawtyUsZe2uBfiJvmATJTyLvWHdEEWMWNkpbhUyD75z
33241	payment	1397	1397	1678	1	1	13109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ceVPdwW4Gzv61D1jxV26fv7GBYmQA57NgDYKQXFoB25bj7Ki
33242	payment	2134	2134	1874	1	1	3604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jvdLQoyAY1Ykax4BNGj6UX768sAqxDLXoexKwzLywowbFUyV
33243	payment	2133	2133	1874	1	1	3512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYjT4DuXWqvB7YAZc6NmK6z4m45JE1gVXWSQg5PKor5JiBMzA
33254	payment	1397	1397	1678	1	1	13113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSF2JqbGBa78URhDZdEgfvmCiuxr9oYWnMdGwZgS3ugqBJVS7U
33255	payment	2134	2134	1874	1	1	3608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDCsKYzPWc3CSTzPk56rRCdy5fXxoNU2eNngeRReJoFLQacUh
33256	payment	2133	2133	1874	1	1	3516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGyUNmoGoWYxGXwffThh6Bndy5sE1fa7u182zHxgbAXv6EPjn
33280	payment	1696	1696	938	1	1	5	2254080030000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gNVeWb4wn8j2BfAvpxGHLkvE5w22Y98pwTLVZXPNay1xGa6s
33281	payment	1397	1397	1678	1	1	13121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCygrHXmrRca8McmDi1TtKgY8vVdr4ML7fBCAJQ7Jfs7pAt15a
33282	payment	2134	2134	1874	1	1	3615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hgdGndSaiyHjKjHQqrGg7kvG1paGfpVQ8jCRjWCaHrWAW8Jn
33283	payment	2133	2133	1874	1	1	3524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMj1KBokXZwMnCLhDkgWc6f9qgCbtA4iP6DG2NGa3wSdE9uWC
33284	payment	2132	2132	1874	1	1	1012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqoJeUk76ubQV41rr5boHPZ128GJWeQ9EUFvuBA4BcreJQsu2
33299	payment	1397	1397	1678	1	1	13124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRow9NgHEF3D2qXF7r6FCkk9EX53TctM5SdN5RrXrZmacHn7y
33300	payment	2133	2133	1874	1	1	3526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwMVb862P9mavcVdgnXEkqpgfGHKFDy5mt54L3KQK4Auvrkn7
33301	payment	2134	2134	1874	1	1	3618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Jv4EfGDx5cmMxW8isWegxCRWMgCUPga5NzwUMA8vLvckpYm1
33309	payment	1397	1397	1678	1	1	13127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKZecbzpddC7J1a1jmY8fMpom8muMgCHUtxpQT2Lb2oCB4EzB
33310	payment	1397	1397	1678	1	1	13128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTUgt6DaUuDu1AhVFiDMniynthmp2xqjh5QfRF4eLac8952Mw
33311	payment	2134	2134	1874	1	1	3621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yojDXwAsu2rXu75fYkZTWaiGHwz6JhEmX6WWJnqAm5HwEZ4Q
33312	payment	2134	2134	1874	1	1	3622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLirHFxx52fERXdqo6hm1bfiY6PSeSBkXvVxKqdjjtz3xRBDDz
33313	payment	2132	2132	1874	1	1	1014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcjNEaWAEknyXfwYT439u9Hnkifrbc3DxHHa1gAswfQQsyBA2
33314	payment	2133	2133	1874	1	1	3529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF96hSbWfD7EsxQAHEtWC6xzqCdn2VojJmKEw6jy7r1Lgptafa
33315	payment	2133	2133	1874	1	1	3530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJrCWBbzHE9UmkNk9Yi3pbtekDuRa9EQSzt2dia5zC5reEC9c
33316	payment	1397	1397	1678	1	1	13129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7S8WCSweRePhGLukdryEN4yqziXYSwfHadA39mMdhT8fgdmyT
33317	payment	2134	2134	1874	1	1	3623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsLUwhemDJ8dZGuabDcaxGtda7GVxoKN6xXBgF5MnKRGym5Ab
33318	payment	2133	2133	1874	1	1	3531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9KxPbFTUCGYarzF4qZLxwTkUfgiuHZPXj1FMHhy8Du94JXMb
33203	payment	1397	1397	1678	1	1	13098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqBGeQJA14L7QdHP1N3xbDR67LcfsfqhjQr6WuDdxmNxPmkZq
33204	payment	2133	2133	1874	1	1	3501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCSePvAoWLTmgQeJ46oQnr5FwZNT3eejQ35DpePGRsXh8FEg5
33205	payment	2134	2134	1874	1	1	3593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqDiexfU3uizPe1vyr7XxLBuBwkTZELDUY6WC31LsSB8mCGcJ
33206	payment	2132	2132	1874	1	1	1005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6R2QzyngpD67pPsMWJmUqdL1ahfwdMPux5xZguNqgFYjiPvj
33226	payment	1397	1397	1678	1	1	13105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVWVFpfje1p5eFALZzjQNzhQ8AZnjscLwsf19m7CRpZDD6DgD
33227	payment	1397	1397	1678	1	1	13106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFS3eYzJV1JvomjFyxBzTDHDQCGveQ9JaGFvsA75cRohPKnP2L
33228	payment	1397	1397	1678	1	1	13107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv79qxxqfDQKB87Hv6Vz5hwZj5sYmoZHeYvg55nWeRE7jhJmhN
33229	payment	2132	2132	1874	1	1	1007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWnCH8FJoxVHi226zFXyC8TYGkiok2iRCqGA5UgFR2Jm2BUiZy
33230	delegation	1885	1885	1885	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdjXUANmtJcP3Y33ZqAa7mt1jhhxZD3NEE3CoFCFFz2X6GheM
33231	payment	2133	2133	1874	1	1	3508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbVvqT99xreeF86vFc8LuV2uotJUV44YsjoR4XCCFmJZPk7T9
33232	payment	2133	2133	1874	1	1	3509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAcuHYumumoLuCkv1YqmLyK44PE829oXmNQY2Gke6SXBwxAHh
33233	payment	2133	2133	1874	1	1	3510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMoy258JMoWjCqe3nUhqgghYLWgDVR85qRiAQPv6H2VhaMj5A
33234	payment	2134	2134	1874	1	1	3600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoRpzKGs1Ge2cEg5CRGcGAtBBfsEo4JDQqzDz3wxBmdTttHw7
33235	payment	2134	2134	1874	1	1	3601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KtBaDm9cyqHUWZvgddw8M81aGpK39m1giDRukGuwyieZ73Za
33236	payment	2134	2134	1874	1	1	3602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuc7TFYKqCxnyDVUJVECqPpwbvieNxBp8JnhzcjJvBoRyrGUwn
33269	payment	1397	1397	1678	1	1	13118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtSQHftqFLyJectrnfFisY6rkBzRLKDVEPpBvyZ145z9ajgED
33270	payment	2134	2134	1874	1	1	3612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1kBdqHmjew4dzpzwdZ6PBME2pgA1Soo3pyG6HYaStvoCAmx8
33271	payment	2132	2132	1874	1	1	1011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgWeDz7RLDkhLwGLGFUZfkNFGo8vTpTCL9T452wyCG5LPALKa
33272	payment	2133	2133	1874	1	1	3521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTf6EDwCnU87vtA9c9ZCcyUoFqDJJSa31aDNtuRrWdiAmEYi
33273	payment	1635	1635	2294	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzysxcyUr4RZpCfN9THjrVobiPX7KjnxwVvrcvRLAZBFpGZycz
33274	payment	1397	1397	1678	1	1	13119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBQmQoEjQzvfZULVCAVDDXwE9W7JDnYFK7cVo5nz7P6nRECpm
33275	payment	2133	2133	1874	1	1	3522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNfdSTZ8Zr95BmspEmkcwM57b9WJwtq1m6bNTAkheC1NTkU5y
33276	payment	2134	2134	1874	1	1	3613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EMK2dtXcguLQGFEYqpTzsvDnTetLR3qtUzRtDcqhQchg67ZM
33291	payment	1696	1696	1304	1	1	8	7594543990000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVJGqWZxPc83ddVvqFLUV7LQT8BR1hDnGu9PLt5EUHGDVZQYx
33292	payment	1509	1509	954	1	1	5	2188333810752	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuJeXHi19fdTgGNa4gg3Mc5b5R7KLa9q7MbfmxFo3TF7ft5yX
33293	payment	1509	1509	1074	1	1	6	3921475439232	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKw9p1JYNeYnXMmoFRu9BU8gXkdDqTL9QZueMpPA5GYVjcC9ox
33294	payment	1509	1509	1194	1	1	7	2645897619768	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQRzzkrWB2Zgixn6waRZNNqNrkSdfwXUrJQnMC5eo5qed2Cz6
33295	payment	1509	1509	1320	1	1	8	7373028977568	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6BDwr6LEmKajbmwRpkEBssyf1iAc1pqiu5arPVHJM62EVxdN
33296	payment	1397	1397	1678	1	1	13123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTZh9c5NgRQcFFkPjqngs476BxU33RFsxwpVL5Nnk4YRksoqo
33297	delegation	2294	2294	1635	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRc4qZHNoZsRwhS1LyR2zrquX4Sfd7xDUxhmNuGLKk8eoEpxK
33298	payment	2134	2134	1874	1	1	3617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYLmP3zgwTo8nAaxZ74R51qiZGXZTJEytafxtK6781XWvSewK
33306	payment	1397	1397	1678	1	1	13126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2BK69VyZMPEcumzJ9jFtUfM7jTSdEwKkqt38FGKtfjojC86F
33307	payment	2133	2133	1874	1	1	3528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhSQ71okQFx1ZF1wUH7cjJBB7tCQk3NpCGGU8d9PjZcxerpSK
33308	payment	2134	2134	1874	1	1	3620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mheQZXjgdm3cERKLiqTfZJhzqAs6fftxkj6cQmXUVFBPad7W
33335	payment	1397	1397	1678	1	1	13135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUDgz1ddbj4QvWpnWhRRVB7yrUbUSV4ZkQmxyAjFCKvNzKzR2
33336	payment	2133	2133	1874	1	1	3537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUhEuSTJrMQhNfD4YYwRyN9vBJfyMREFcmSrgDUevGbki9fjn
33337	payment	2134	2134	1874	1	1	3629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nyhJyGqk5KbYmQiGVhzrk7UJS3CbVedJhb5qexoG4e7SBTsj
33338	payment	2132	2132	1874	1	1	1016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mtS4i5QbzxX6uC3aPzoC3iZFDnTtERvMarUudCQBaHmFj65Z
33221	payment	2133	2133	1874	1	1	3506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LVLWCGuDmviWjQMonKW9LiCX2bswUERJWrLGDNednbeJ6RP1
33222	payment	2134	2134	1874	1	1	3598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnNBS9tumBrip4YcYZLsxbMT5pP2dgHVMYDdaraS7uyQCnY65
33244	payment	1397	1397	1678	1	1	13110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDHJuzvvXRCKbNt4Hfvz1xSYBUbPEuargVohCBVPQTcTF4oXg
33245	payment	1397	1397	1678	1	1	13111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxyoRCcjWhE994XCpL4zK5cSsc4DL7Tfh4BaM947ojYntugJv
33246	payment	2132	2132	1874	1	1	1009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkUneL99ERFYvh1NzzdUHbFTmN2dp53VMAr6rncjdA8iYC342
33247	payment	2134	2134	1874	1	1	3605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKC4TCwkiexwAnAMqhHhfXUUv7wTfpmzVASXY6b9bpZ6pxPmZ
33248	payment	2134	2134	1874	1	1	3606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t7dXaVhQwVB9ccCayimC2geU2Qk11hfySv71tx7ZN9aMuaS4
33249	payment	2133	2133	1874	1	1	3513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRAL4gohsPGqeurVLGewY3RsSLwZXoQfphGSkM2iJFF4pNFc9
33250	payment	2133	2133	1874	1	1	3514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTri5k6UkfPvK1RGMcJxeSayBrVaofqRznshRTmT1vEjQL5UWD
33285	payment	1696	1696	1058	1	1	6	4039292110000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4zNzsNTPhFKNEBLN1JgDay8kanFeZjziCwSAG2dWrGAeaPkr
33286	payment	1696	1696	1178	1	1	7	2725390870000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzQeNfFGKzHzuPDGG9MGs2ZCkNKc5GjePg5i5H3qfPXyem7p7
33287	payment	1397	1397	1678	1	1	13122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxipsNi1xP7KaqpKbQXTd8TKgQZ1LvycreEfaPKuTF2tPbdm6W
33288	delegation	2294	2294	1635	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxdCDYCQCcAyLAVF71TAcuiDWkA4T8JbFPgyUiTs6pw1N6r29
33289	payment	2134	2134	1874	1	1	3616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sYEf8b9NwryrEV7eZiEc6cQCS8Mgu2fdDsxNy2HGjHCmiNhb
33290	payment	2133	2133	1874	1	1	3525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhvABkn8AZEz458vSDDC5ZQV7tMknad6TjT6ZhNQwEfach3dx
33319	payment	1397	1397	1678	1	1	13130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyH4jMFc9WxkkcWtfrc5Teq1iEWjESXpcspcTfjgZBZPscWtYt
33320	payment	1397	1397	1678	1	1	13131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf5LRQwqdbajazj1LVQCpkt35aEVPSJdLvdtmY43uJrqv1k8T
33321	payment	2134	2134	1874	1	1	3624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sBn2KLgY3UcciKirTrc7g2ZpADcejtdDRRgDDr6RuL4HZP7C
33322	payment	2133	2133	1874	1	1	3532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1ymt9ZRhwBvie7xNni1x1Nkz4etavYTnC4GUL93vjLnm83kc
33323	payment	2134	2134	1874	1	1	3625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXwPJvArVaMWfJ9ZXvUS1ggdw7MWALxVC6vM1gotFFU7A2QtW
33324	payment	2132	2132	1874	1	1	1015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7koJAGeVpvitc2VBdxMuYDAsUEiM8DWXcWAJ9H6sErzMfn1P5
33325	payment	2133	2133	1874	1	1	3533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsCtrFuTjjY77uzkCcZbyqj7nSznwkMwxa9YHWWP6KnLGnLLR
33332	payment	1397	1397	1678	1	1	13134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9gk4UnPmUCmi6gg3aTHDVxHcNxtXcoD7ZU7DFhbvQnM6eeqA
33333	payment	2134	2134	1874	1	1	3628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkaaB5hCzzGNDQqzXrRvqiU9PjTuWZbMJw6VJHDA6cDbrvLwo
33334	payment	2133	2133	1874	1	1	3536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4ZzdEq9tAFcyMqoCPpCbXURsdPCoFxHqPWSjMUozpXfPz1Vn
33345	payment	1397	1397	1678	1	1	13138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUk8pJcNK8Korv74fVbxQ7oCnK3TiBHos5ftzVrToubrGtk6J9
33346	payment	1397	1397	1678	1	1	13139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrT6WWuyoAb9fN3xCVP3kVYEt3MVh1J7YTjN7SyR9YpGCcW9QL
33347	payment	2132	2132	1874	1	1	1017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptM7vXUgzoG47CWRtMYdBCRVFs6gSKmdik6MuEtinH3StrYsP
33348	payment	2134	2134	1874	1	1	3632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEQUqGnPByoQ9AYHQ4xZ5Ghdca1hC2sACsHQYkPSRirggHJK2
33349	payment	2134	2134	1874	1	1	3633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLq4YCop6U8U6B1u8SP9bpYCU8ebFAmXQdc5YnZYAqEurA5fQ
33350	payment	2133	2133	1874	1	1	3540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDUskQbnihs5BTdFTDiKf6jd6ohEjHfX7GcEbazfZshEian11
33351	payment	2133	2133	1874	1	1	3541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVZ1JG87LkxyiVLvNpWouKD9BNn6EAWbCWRQ8DbR9ACHVD2GB
33360	payment	1397	1397	1678	1	1	13142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqxon5Nzh6QDqLqEskw6yUviEQEZdYru1urxmuFt6Nu4H6oCM
33361	payment	2134	2134	1874	1	1	3636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXt3JqRmdmNhDw1QrpZE1ddkAWC4FAVfZvL73dzLeMxfhfGuYt
33362	payment	2133	2133	1874	1	1	3544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktfMzyousgvKQNN7hHbsfhKGhsSbwXQAyU7sPdmJVH2zV8php
33373	payment	1397	1397	1678	1	1	13146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfLgpVJd6ZpZXFZAtZtPvVHifYcaypZSshkYGGrrcjQAhJDE5
33374	payment	1397	1397	1678	1	1	13147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvaVhzWiwC4oJv2LvA3fKgF4A4idPBgqMptBJqXa767GK6DaB
33375	payment	2133	2133	1874	1	1	3548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgfxnBdwgeE3ESvPAc3NamkXtG3CPfnioszQfj366wVyg3VrT
33330	payment	2134	2134	1874	1	1	3626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUU1MXr8hgky3Zp3RjA7BBdN5PJiA8zH3ZccWnwtygXYZbn7Q
33331	payment	2134	2134	1874	1	1	3627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6SdzA4HkcG43qYShVHqCKc4k1Vhh4s5RGBCK57FSVTGLJ4UL
33352	payment	1397	1397	1678	1	1	13140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAwyrdgV3BweX9KCtUpg3tRBRVhjbA9BRbexcjxvsMVVGfE1n
33353	payment	2133	2133	1874	1	1	3542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaUsHmfCP24uNsDmfQbjUWp5QiVujo3L2iVduJ3g7krWaYigP
33354	payment	2134	2134	1874	1	1	3634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWnHBzCoFHK6hpg6g1zRQtXF97zYjxaGtvcZMRq8cXpJkfGx8
33369	payment	1397	1397	1678	1	1	13145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn5qk6pxQtts5UwyAyGXPcJ5a8SBqqLCP76NbSiSVo2y56CAj
33370	payment	2134	2134	1874	1	1	3639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2keC2597KZkhfYr2qDeWCkobTVNfVK2taZ8rrJzbDCGkX36W
33371	payment	2133	2133	1874	1	1	3547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbGJ3B4BA43iCG1oAtmXSAhKTxdUL8Gj4eMDMcKmMjhoGH3WW
33372	payment	2132	2132	1874	1	1	1019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmTZS8PfJgb6XqqA79RVMgsSYByTHmfQKEnyPQEM4xd5t6do2
33380	payment	1397	1397	1678	1	1	13148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fNY7ozdhVtPjzK8BPAKbUQCYBwtxk36jPZoX3WsPwP4Wz748
33381	payment	2133	2133	1874	1	1	3550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyiGNr6JRnem54nuGJvC3zkZzfnS9gT4wWf9F9XUgixMMHgDV
33382	payment	2134	2134	1874	1	1	3642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhVm2SxNWMkhKBS3vxBr586UyjJvymvV8Vs1vfKRrnR6daqbA
33383	payment	2132	2132	1874	1	1	1020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSaU9WYGZXERTRdERuuPjv42JcR2JEEsVrdeqhz5iMpJGoYb9
33397	payment	1397	1397	1678	1	1	13151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqQtJws65iriXtrZdKohEyKK5qYCNX8gRdX3VNP5557hYnkHM
33414	payment	1397	1397	1678	1	1	13156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqLpW5V5VppXuXQDpMRVrirxUekTNvqvRGj69wnMmCK963gT2
33415	payment	2133	2133	1874	1	1	3559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHH2PRHb74egkGU4qFpFB1VCtEfq2P3wM29hrSowsJGixyfAL
33416	payment	2134	2134	1874	1	1	3651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsih4mppidomCj4mBPuJbsCgq3nzeUUroM6JuexKA8yYM1CuXV
33421	payment	1397	1397	1678	1	1	13158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfuQyrsXP81CZxeueKEYxqmBF5u9Dwn3ETRNjAcRVTq1Sdwct
33422	payment	1397	1397	1678	1	1	13159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAGUm7MpQfXpHj76nvVuniPKUyxamENMbNgLUFhuiGYWe7RvC
33423	payment	1397	1397	1678	1	1	13160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzCzssuC8KcBo2x6SvvPHUjbamfZBjttrVUuQmqaes44JhHU6
33424	payment	2134	2134	1874	1	1	3653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzBeF8cWGcxSPk9JipLha4nkMDoFYtKVfwMUix24oJZuhcWZN
33425	payment	2133	2133	1874	1	1	3561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEexQQUfwMvKtMoaAk5bN4B8YPBG9Ngr9d7MJwwX8a8rEy1HE
33426	payment	2133	2133	1874	1	1	3562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmu5Ba7tMqwnbVg4Bxk1BT4pAQGQCD5sDTENxydP877k7LpW1
33427	payment	2132	2132	1874	1	1	1024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r3T8w52ZN9GDse2jWZZmEuRKhtaP5GkpgReueSPBX6BrKn95
33428	payment	2134	2134	1874	1	1	3654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4zoQLUXL9SrfGL9JxauE1s6ewXtSwwVkzXH7qhwARwfdmb1rN
33429	payment	2134	2134	1874	1	1	3655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wfwpjtSQK4UZU7srzkoTE7oWrqcNhxFGdbPmj68LzYmp2bTo
33430	payment	2133	2133	1874	1	1	3563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wEN7DfYuVGFpJi3vmt6WjfEqHWvicozscDJZs5g5DhxonFaf
33446	payment	1397	1397	1678	1	1	13166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1FvNLE4TFkYb9urFz53BrJnzuvjoxbSw5QuSBuE8DAmNbvxR
33447	payment	2134	2134	1874	1	1	3660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStZh11UCRhY25epeEdhAbpknFyrxryYHPbmQEsu9eL4aw2zMu
33448	payment	2133	2133	1874	1	1	3569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZfhkr9Mx2L43ThGoArvsCGNBfGVc4NCgXvtyKwbD1j5fSVVb
33466	payment	1397	1397	1678	1	1	13169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR2KjhB41FQjVCMDZkV2ibtoYpJjDTSPYti7RuL13vQ3qjXUV
33467	payment	2134	2134	1874	1	1	3667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKq8oQ4oDU4gbYBT4Y7AJosYBuC2Y8gmyLCAtYvEQNWQfTB6SE
33479	payment	1397	1397	1678	1	1	13173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgj9V2aZuWFhVZhumN7kKtqwGy7VeUgEGv1bGBNMjYngyJP1C
33480	payment	1397	1397	1678	1	1	13174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVd9FtFKku1bt58gvTt5WZSRe6DCga54TrL5e1zgL7HNz6zQ1
33481	payment	2132	2132	1874	1	1	1029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftdQc1EvcUBLrMYrRc3UHgwjtfdiLyyhrh5J8tGSXa3E7n1RR
33482	payment	2134	2134	1874	1	1	3671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdR9T2DsYY34qTeem4mvHDhvr2HUSC79KryEjcTHBJEbFRyM91
33483	payment	2134	2134	1874	1	1	3672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5YhEMTDPk1ntCj9crxB8skZZhWbd7ubtdAfqhv5H1rCU3sRv
33484	delegation	1865	1865	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoBN3iv65ba61n6vpw8DaZqmAfanvCdb491AfkSPgrhfVemBm
33339	payment	1397	1397	1678	1	1	13136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtufKRQMKGnRETrQBofBN8Uo1YMx9yq5UM1tFwVBsicMVk8eg7
33340	payment	1397	1397	1678	1	1	13137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsArm1BVDQQjSC9PqMQjK19kd4dxzsU1CUtSA2yEj7dwHPx7Ha
33341	payment	2134	2134	1874	1	1	3630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYj2iCVXNTsCkvp5hDQGUjDjBCxUpxoFn2n3bkKXqmyShRxws1
33342	payment	2133	2133	1874	1	1	3538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2Eacy35YtXRF3rC9gJwiuRRweWBtqsvmrfd9M1R8ymNVJPbu
33343	payment	2134	2134	1874	1	1	3631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGtvi7zDioh9kiaGwRzPnDqzR9ssTNCiyPpfCqTh3JkJzFJGs
33344	payment	2133	2133	1874	1	1	3539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMraZQEqrhyBdsqwmfkGyfvDUEQpoAUkk7BBUbS19F8C6XYSX
33355	payment	1397	1397	1678	1	1	13141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZQkdeJaZCq9fC5Dt59eMx6vAB2HR8pGd7yaRtZv3q4ZppNs2
33356	payment	733	733	640	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisWQMZKjFNEr4do4hPQK4p6crGa9aLyHFqV2XHY5XVQdH5rpR
33357	payment	2132	2132	1874	1	1	1018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNYEhNRaTshyDn14CfWA7WdMy1ur8oJS271RUanv5LGhfRfGc
33358	payment	2134	2134	1874	1	1	3635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNVSqQNQxvuM5LHwoGQ3qKyyDvJXYWQJCcjBRVtMqwuZKvoZb
33359	payment	2133	2133	1874	1	1	3543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8w45nKEU9U9fzLNvo219iTEew1cXMG1hDMaGE6Tj1Uhyx2z9z
33366	payment	1397	1397	1678	1	1	13144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EauNpsJPqAXUHPskH6xA498rZ7GSMNAVL3JphUg59A1CGHx9
33367	payment	2134	2134	1874	1	1	3638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzp4mr3R8hWrc8Rd9JoBb6KeGwQF1p3eXmox8MGDzrZNS49QzZ
33368	payment	2133	2133	1874	1	1	3546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Tb3m6yUnWJKZRipzYDSWVTBYnm5QH9pzXx2rU48qDXyPybry
33398	payment	1397	1397	1678	1	1	13152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH7PVMWsAEnuwqzKyZKsdE9tRUPrVwZGhqCTPWTLDy9ZBXNrv
33399	payment	2134	2134	1874	1	1	3646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruKSjezRVt7tjkBYD9YfiYbsRVhMgTopSvZveCckHLXrR4i44
33400	payment	2133	2133	1874	1	1	3554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5adTWhumC6VgYhHmbW6FS1AQvBmLhYrnz4wJbzYChZ9gHYXeY
33401	payment	2134	2134	1874	1	1	3647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfQs4EVwRCgH57iejuZvMBp7M9utEBQzMUJ5k1EGdtWwuiJk9
33402	payment	2133	2133	1874	1	1	3555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvz9RWpE1GqaCaJX6XtBoBW4RZacHd1gp2etAgQfyNVjDrREhJ
33410	payment	1397	1397	1678	1	1	13155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty3vkuW84YmdhQh1dMZE62nrSFNQwqTDEngYTwtx5BdThi1Wc
33411	payment	2134	2134	1874	1	1	3650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWp6yCxKYjf9Ad2juzhYKJXsYAFYH3bokdfMoGs9PPCAyP85LB
33412	payment	2133	2133	1874	1	1	3558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXMxX3eqrpDcawbqqFgNPUo7dHzg692xFsEU1enumpWvupXyz
33413	payment	733	733	2295	1	1	3	1999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdPNZ1dLav52HY3PJNtFGEsjc7wg1ZnFBbekmwk7Lpj4Tt6da
33449	payment	1397	1397	1678	1	1	13167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqeX34CduvDR91qug98pAAFfDseazoNKZSHhzyfRnkukZj2R9
33450	payment	2134	2134	1874	1	1	3661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZgE8H5sq29buL67EvFk2S47xPpegvcNajNWSqD2wSUc1p93gC
33451	payment	2132	2132	1874	1	1	1026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdLp1PBj1iiUkSWCVL4pW7Srbcdm2xHxSxcuJebLWtRY9VkKh
33452	payment	2134	2134	1874	1	1	3662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkCdwCxyHC3jwWNhXyUTA3FQpfp4ApYVpR8pZ3WjCGjb2uSi9
33453	payment	2133	2133	1874	1	1	3570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZox1swPzW3UmDcz29VE2Rq9XVoodyzS1569JnThK8dmctb9Ct4
33454	payment	2134	2134	1874	1	1	3663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hPF7ka83ZcVfd3wjeSsQuFftpZkdinaSZexnNWch47cNeZZZ
33455	payment	2133	2133	1874	1	1	3571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8j5oRXrnAkUJAHAJ81xvbN3hHqVctDXj2iUFtQKFWR28X7jGP
33456	payment	2133	2133	1874	1	1	3572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpw3VTHCdpTQU4pkUwYcbXL9arzsqtgaPBE258XuAkXae9enrU
33469	payment	1397	1397	1678	1	1	13170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3YxXNYtyzV2V5mtBU1BDs9byuUTnFofP1AzD6FpUiDN2HxzG
33470	payment	2132	2132	1874	1	1	1028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dp9iM1xxZXCNKoe2TRrXC12oda75CuFWK89van9ciH3cvMhj
33471	payment	2133	2133	1874	1	1	3577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQcYMAysxTAJQn4xerYDsHA9fMrbSiGd4sxsWZ4eV2ctGRKBd
33472	payment	2134	2134	1874	1	1	3668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SjUyJy1coLqLuJLyUb2ZrCyMqBZ8os7pWhjdUbKYkRk9kHx5
33531	payment	1397	1397	1678	1	1	13185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCKHz5xfULegKWVEBFHhXGb57W5usgCLBiDb8z1ao2cWNQYxs
33532	payment	2134	2134	1874	1	1	3682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZu9omoJwY7WxE4gDk6iqM8KAjNt4ZnwnSoGFejsroagLvbML
33533	payment	2133	2133	1874	1	1	3592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCB25QgmKmUmAYm4c7rByMXk6tLzCV6Hpx1fQVQzM9Qjwpfky1
33363	payment	1397	1397	1678	1	1	13143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpWz5ZyuCxuBrwUg7rVT95FayR7HXFFNkUAL6J5CBhptyJUC7
33364	payment	2134	2134	1874	1	1	3637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCUuUjLNKseA6KiKmZejhop65ZXAb7KEvpNFswzJtXucNCtEy
33365	payment	2133	2133	1874	1	1	3545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErTbqz1P8uaEAD4RbCmKhm1K6nMBDYzZqyn71bm5TpULGtmHB
33403	payment	1397	1397	1678	1	1	13153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupr5GeK9Ry7Kc13KdrMs1WjAhhGRVdbDCaRMuMMDrXVuTAHL2
33404	payment	2133	2133	1874	1	1	3556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwayrHp62fKLkUcp8i9DpTwPxGkHF2UoSPA4DMp27zh6TpcRo
33405	payment	2134	2134	1874	1	1	3648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmSvBX4NFWm78HtQXssj4p5fLt4e9jJzq6rVqnsLFAapeNd7H
33417	payment	1397	1397	1678	1	1	13157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1tPZvNYEb79CQv78H4x5UfWDRBrcNne5EVHfX7eTapFCkKxM
33418	payment	2133	2133	1874	1	1	3560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bvWqYXVgi7pJzMhZHDrjJPDQpDJ7i2goYphX4jmxPUztsf5o
33419	payment	2134	2134	1874	1	1	3652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbpAWNKRvXXBCC2qJWcrA8p8AUL5ixUHKkShcJcNTpUgWF1gX
33420	payment	2132	2132	1874	1	1	1023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNFAV3aBbmrkvc8rMvTtoMvWevCgMF4YxmeXFbGq5jTBQiKMi
33457	payment	2134	2134	1874	1	1	3664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLeTKG8g65vECYPLL3nyJQQKo1GsDAjucWo2aLD3ZgJEWX9v9
33458	payment	2132	2132	1874	1	1	1027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQS89dvQU8heZTP9VURvDRjk9JQEnKynr4s1JQjrr15USP3zh
33459	payment	2133	2133	1874	1	1	3573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLamv91KmfgmhJdfr7i9frS1Q1kUWFERm2WbYcQnpL2Z2YhCZ
33460	payment	2133	2133	1874	1	1	3574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxdmCbop84PenjoJEPJs88pPMWsKiFAXyh9RJKexAQjjfa8sw
33461	payment	2134	2134	1874	1	1	3665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtmrPn7oZFc8msvyqXSTbxuVPMHGckmyKX7E1WUtEWUhXP3xA
33468	payment	2133	2133	1874	1	1	3576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28ZH7KjM7DpLw3dMofGHF5ofGTXmf4TXUm4eFBFNFUYQQ6RYK
33485	payment	1708	1708	1139	1	1	4	4822844614039	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadckLzoVfDggCx3U7bKSUeR6ErE3BgK43DYrGC9e7Z7sX5gBn
33486	payment	1397	1397	1678	1	1	13175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHKSnRy879UXfs8f1GJoVuFDBVHTX1F3GbsfbhmpC6DpYkSJn
33487	payment	1708	1708	1019	1	1	5	2691332407011	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWmF1ATdKrPZb2r5PAXwAf2CZ4ZFmovCn3rtmgyHCN3AkEV5M
33488	payment	1708	1708	1259	1	1	6	3254069363049	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpAiC8TEJokJmy7d1QgKWmKv2r2pWaHPxgypkBxw7G7toU37sh
33489	payment	2133	2133	1874	1	1	3580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwu5HTCxvmnU9ewzFV55WnAWNM7JFLNWtFpGBrB6TyyFZgjZki
33490	payment	2134	2134	1874	1	1	3673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioZAk5spB7KR6XD11NZ8EdWLDJ2a2Hy69wVyjtyF22YqNLuwT
33491	payment	2133	2133	1874	1	1	3581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV8CxHnfUS7N97UKZm9KLJCBgb18VQMbuvzRehMqmTHFGzZ4J
33492	payment	2133	2133	1874	1	1	3582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9c4Snrp18VBndsn2GY9QMemc5aTgVfjvTTfB7DcUJnAnwrkP
33506	payment	1691	1691	192	1	1	5	395486009902	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYjS4sdjQFBsNm2uQferSpPHktpYnVFvddbdNTsgZmzoRzcAiDT
33507	payment	1691	1691	918	1	1	6	3008958989784	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYfSenn2zqsUUsUCDaxgjLXiyrunfV9oz93Yri26ZeMZYracQAQ
33508	payment	1691	1691	1038	1	1	7	5392028728944	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpZCmaZrQP7ojxmRNw1Rze4msYpMNDs1gD53b7zfMH7XJ3rFx8a1
33509	payment	1397	1397	1678	1	1	13179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN92kU3ZJE34iTqHqjpsnJnstkp1xtJXmeNFHemQuZ8Q6ybhah
33510	payment	1691	1691	1284	1	1	8	10137914844156	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	Ckpa2uHzDkp57WmraK617W8QkYv1u7CCgcaQsP4UcE1ZpjE4eFjN6
33511	payment	1691	1691	1158	1	1	9	3638109227181	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYhsfwAMKQquRbRWuMXKfSwt1NvyAJP7y4qDF6Tf136MaZEuw7P
33512	payment	2133	2133	1874	1	1	3586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPWCygxpnjs6ywnWbmG2wFS6pBvdxzEV8taxbQBCxmZq2YF8j
33513	payment	2134	2134	1874	1	1	3676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZhbSdA9CXBQLDcqUxeCSBPv4ysaFCxXB38H7KAKrzJk1438y
33541	payment	1397	1397	1678	1	1	13188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LXULgrL8Ms47tjyddxDvFkeRNzy4B3LY2MGBnW9GdkgjMbCc
33542	payment	2134	2134	1874	1	1	3685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrBxzY1wM3ADq59Z5Lkm9ZFWtwVSEUvS7HcpXwxTkdpWyYJ2k
33543	payment	2133	2133	1874	1	1	3595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCydGU3PvsHeK5RGAfx9E4BCWGj9Us72iLYiRV78KufBJwvVj3
33566	payment	1397	1397	1678	1	1	13195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SoxgdcMqkL6h4UeZjsn8Q4U6C39oAdgfjnShkqyt5LXWrKTz
33567	payment	2133	2133	1874	1	1	3602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvfafUoYxkhmwqphieU54GE4h9fvDfKZN8QoEhCZTVwZziR1p
33568	payment	2134	2134	1874	1	1	3692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvNJwuQLo5D2Y3Gh5yTCnBg1E7KoHtWBUy9a5DGDbMewA1gj
33376	payment	2133	2133	1874	1	1	3549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFvRVA8dhHoiqhYYJiQs6BUZ1HxsZ8Dn2Tg1KjJYfhtv2tdnR
33377	payment	733	733	640	1	1	1	718998000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm99obvLR66pj5Q6XKCnbVL9okCCddY2aWxjeZqQ2W3EeQjvyc
33378	payment	2134	2134	1874	1	1	3640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EQyZksAC28TWetHwToUjzXi4WyBsycKWSxZq4JvNo9Zn3Bzk
33379	payment	2134	2134	1874	1	1	3641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLHNvZY7YJJvB1wUVPghwPBMLry3N2oLGazoPVnWsTnvx7Qxz
33384	delegation	733	733	733	1	1	2	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKw2HSj1T2iN5RQ6WC4JHuSfwtZ6pvnu8BEQbRN7Tw19R1Zdz
33385	payment	1397	1397	1678	1	1	13149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCjpdumiZJANTLgEf51cKn3AZhU79R2wLMHc6yHxMmXXMXAyc
33386	payment	1397	1397	1678	1	1	13150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G4A93XKaJt3nN5azR9HSNEYZ3618tTYv5qsK6KAVxcNmFDaG
33387	delegation	1899	1899	563	1	1	2	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS7Fsqcj1kyTEBRmvH81MvoUPv2bGmGHNRpWeBjZ5ueimzMQF
33388	delegation	1740	1740	563	1	1	13	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvrsLS7e5VRUGrt3ZmoEfqo2bAX2VaXSo6dqhTAjzMdMAsTPw
33389	delegation	563	563	563	1	1	15	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaxuRzLXDRYs86Wg9TsnZk51G9m8w1XZK5Zha2S7PCcZpZsru
33390	payment	2134	2134	1874	1	1	3643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmV1J2JmGkwzggY313nnYuXpQN31RCU9wkvUK8CvMiHpJiQ9C7
33391	payment	2133	2133	1874	1	1	3551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR55LCN2WE6zBuptgBZvJr5J21UE8jgB8FS4Yh9Tuh43NhzJ7
33392	payment	2133	2133	1874	1	1	3552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvXCR83o53immPKTqS5Mf9knvQEuBgKuJTuDPTs8jobNaaY4Z
33393	payment	2134	2134	1874	1	1	3644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGub3DHJHczLFa6nxrc2XE5RLvZyRDwAMS55vAQFHgRNuLtfW
33394	payment	2134	2134	1874	1	1	3645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMF5eTHhkVuHrRGaUB8zBAy9Y8ZDaoSkcAAm6rwxame52AQhy
33395	payment	2132	2132	1874	1	1	1021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUH7iSH5fGYncspSA3tvXyaYVud8iJ5SCDFCNANP98iAeuqwa
33396	payment	2133	2133	1874	1	1	3553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABTWezVZyfWdexpmbHcah6NCWWfaVZSsxoe6NtsCrGo3Si84f
33406	payment	1397	1397	1678	1	1	13154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA86ybQ8YfBEUFMsk6RdTMf7tW7QBFHVSbPCzzG1CgubwaR7wh
33407	payment	2133	2133	1874	1	1	3557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu8MhHzMs64gbFVBafSiavGXfynZt3nYvD7bGPP44YRDNQhuK
33408	payment	2134	2134	1874	1	1	3649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPLsiGKwg8gZRnfPT9GLFaiT277Z7pcnr4QJ9VudMq8w4Qjs6
33409	payment	2132	2132	1874	1	1	1022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7CBFtSS6dg5qGcn25ZxypFrGVF8LyzSTbSLe7cj2nVSHxXEB
33431	payment	1397	1397	1678	1	1	13161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6wjT4pLCfqe1uYDRQAsgymg6b633XAvV2vixUeWjPkfwecMR
33432	payment	1397	1397	1678	1	1	13162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgQ122LvhHpLCMVABVjzE4jaGuQuJD2Xkw6CCbQJahkypXKy2
33433	payment	2134	2134	1874	1	1	3656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQQfP86iWwAep1dp3dmrzhKhkiQRxhp6ytYQ8VBaBWXQ47ZEW
33434	payment	2134	2134	1874	1	1	3657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqd3HzuCwkREAzLhUkrbJXajCqS5ngcaAS7qzcdq41JstJvQXm
33435	payment	2133	2133	1874	1	1	3564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FMxxU1Xt6uUMQjae7TDAr9mXMNU6AgWqXEKS2kr6QpZ65RFz
33436	payment	2133	2133	1874	1	1	3565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzt9fs8trYfnCPfid6JBUB1RJwABpsvYXNfT5bvSoGZ3BTruki
33437	payment	1397	1397	1678	1	1	13163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvCTyMU67GZcHPR16z4mQtPfzEN6X4HgQFSoTkCgpxnCv9pPZ
33438	payment	1397	1397	1678	1	1	13164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA5hqYfBzW1RMfqYiZg9eHEULzkFbCM6pBmqDrSynUokTAaVB
33439	payment	1397	1397	1678	1	1	13165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpq4U2gHVhckauVx1skEPHsrH55aWaFteH1YzUHmEpMPXDXDXK
33440	payment	2134	2134	1874	1	1	3658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMqytpUsAuhBDWASJt6REsKVSq6qYytRndjGh3HeD3ThEdZTR
33441	payment	2134	2134	1874	1	1	3659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAubxCyBAcNjPTXXwrHafFuL75r8HACZjTCxcax23TtitcNrw
33442	payment	2133	2133	1874	1	1	3566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vfngqf7SQugrpSuuDNbVdBBJEvtfkgvgnNfuER4Zb59pQoaC
33443	payment	2133	2133	1874	1	1	3567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW69VnaPnuXwRUiB8Ez3bNScAW9qoJaah3SfQ1xo2VuXGAFkKX
33444	payment	2133	2133	1874	1	1	3568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JWtzkSkaYu6Dm4YatzT7UjAmYpt5W9Cfi8mz4Y8nfeZrWSWN
33445	payment	2132	2132	1874	1	1	1025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FGG5Svv3dEZn4PZ9uArPRW9Xq4B8GTrMjS2PXsLUXXn2dima
33462	payment	1654	1654	974	1	1	10	2462000000000	100000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZZaRzbjvRd9xetsziTH4CN19biqh55XQkJfmgZLU8yqvJsoDfz
33463	payment	1397	1397	1678	1	1	13168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1nvit1JsWyPsZDGZTorJzfFoah79WxCUqUatKFGw9rL81iy6
33464	payment	2133	2133	1874	1	1	3575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpsfFg3B1fK23p6myyzAqr6WNjzwsxGeAtTd2MbxWbxE1nmKQ
33465	payment	2134	2134	1874	1	1	3666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGG4cuxToE16NUHJSjzatHVVvak7Eqd2GBHpSrM7pRbcffbWu
33473	payment	1397	1397	1678	1	1	13171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipgKr3XvqQWbw1XQBzC4doBXc7kZxCBjJBKJ97E9RzWMmwbDh
33474	payment	1397	1397	1678	1	1	13172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JY29qwSPZQZa2YFWbdVnXszgMZC5VXQEepryqLELvUdQHqog
33475	payment	2134	2134	1874	1	1	3669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKQ5qEiW3YEsstsFVwKbEvqKupxssMQGMQ7s1TEdxTUpoPigQ
33476	payment	2133	2133	1874	1	1	3578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC9BeHwwFTBbHXmmVqEs8ZTytbE5wTGpDV6o48SQ1waNbPrae
33477	payment	2133	2133	1874	1	1	3579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZThXY9difDuHuok17iGn3RXowuP2CAs5z4n8aaYsBfTNxLnW
33478	payment	2134	2134	1874	1	1	3670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvi9Ya9UQzWXpUTd1ZgehfsBSgi7PhyzjW5ubcpCni9rRnf4v
33493	payment	1397	1397	1678	1	1	13176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPxuboZj1jAbiekzvATDZFXqaX1oh8i6NU524gVRvJGL4kdrR
33494	payment	2133	2133	1874	1	1	3583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMvHZoMrAPKnQBP9XXrRBrjjgazA3k4u4MZScF3irrFPysXY6
33495	payment	2132	2132	1874	1	1	1030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wTFn6kcUg9stx4Nfj8xTxWVrps4RKJDZY49EarPyAjcQw5z9
33514	payment	1397	1397	1678	1	1	13180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGMNE7bT7vjwoYRMyHR4tVVzmq5kpPfVozsfovis4ci4GMFiv
33515	payment	2134	2134	1874	1	1	3677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ3yiRJU9ephzsg5T56UnkZE2gQG5AyvFbHqFdh9kftLCordj
33516	payment	2133	2133	1874	1	1	3587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKXd6Xxb11ybpKHYGFnD3SNuTghyUVsMZwi6L43yeXkU27pv2
33517	payment	2132	2132	1874	1	1	1031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TpfGYGZzD3ZGNVatbmUrkwHcH93efYWifpR398WRcsDwfoU3
33524	payment	1397	1397	1678	1	1	13183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5436aNJqWyaXsgrVE59Fu7HedfWwSeg9WmHcMzDgQ3DXnb94
33525	payment	1397	1397	1678	1	1	13184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYeUNKB6PHARiTUM2gUuoQmgtU2mhtVRpycNGF9hEwqJ2DJM5
33526	payment	2134	2134	1874	1	1	3680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4LiutP93aEcsHvuxWYSHqeF22Cx9p59urNjPEvUSrxcHvrTX
33527	payment	2132	2132	1874	1	1	1032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SVBarBCp41BDAE5epaGmJBcSwNn9V1jS4U45Ea6Ux4jZ5F9T
33528	payment	2133	2133	1874	1	1	3590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9je83UeKfFNGwZrMSdeYmNk5dpexLFjrbJvUmi2ybVuRtqkUY
33529	payment	2133	2133	1874	1	1	3591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCTmTAqG4d3Q56qNM6LZexUQM97CWWoGooStjrhiSxCW2DKRG
33530	payment	2134	2134	1874	1	1	3681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSJL1YN6eYhzX4nKxeG2Dusc6Y9XW55msk9C9h64RNm1D7Dgc
33537	payment	1397	1397	1678	1	1	13187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3VfWu41kyekMthtrj5wKDnKWqsUfudRWhDpH5soAHbmCEDUY
33538	payment	2134	2134	1874	1	1	3684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPujAFuYvTm6PrpSYR3zXeqQyHNPYBkSmaPPmGm8bwsu5icp3
33539	payment	2133	2133	1874	1	1	3594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPimUjmTbdAsM8oCmxw81zqFk6W9bpy3qKSrrJpXSeXw8ZDXjT
33540	payment	2132	2132	1874	1	1	1033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjniiyzh8GhmUfH45eBFvsksd1see39HAZK1fkiYEotp9FXwu
33580	payment	1397	1397	1678	1	1	13199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3c5Hj8tKtdQKbPzAEN7Hv4VZ3LC2TFGdJRTv6sL4KPKDkRER
33581	payment	1397	1397	1678	1	1	13200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjV3tkAAVAMeHKS15yrW682LpSnwGXyGz7USupLd6rmyzpUYgx
33582	payment	2133	2133	1874	1	1	3606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUbztdndVU4ZmKnXMHPhiUKWW7yNeWokUXWNLZupF9VJHyGhk
33583	payment	2133	2133	1874	1	1	3607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJkaKaLtXA7s5DNtvTYMUGLBXDwsijxHofAPFHgMmXvT97Mu9
33584	payment	2134	2134	1874	1	1	3696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYXcjrwAopMdw69EMu71jCj1MuC8vrHPhd5vC64kNgjXRQRTE
33585	payment	2134	2134	1874	1	1	3697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcgrHmMG6Pq5m8XCYJ1U5FVxaJC2huwYQjUYAso139qqsow1B
33586	payment	1559	1559	1353	1	1	7	6755040000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrLeHawiV5DKtWJzWYF9AZQpGBwap5fQ6qsEXUTM3ijMeZrHG
33587	payment	2132	2132	1874	1	1	1037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPs7gyJw8FfZaUp3tAAnt98nXpGUspbeQKRqwk4yocTSarCbu
33591	payment	1397	1397	1678	1	1	13202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1b3uPvnYmforkheea4wHg2X44TpcorGk2kPMZ9NZbPJczRUc
33592	payment	1397	1397	1678	1	1	13203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikJyVK7yBoMPtap2W31F9QuMYqUwWdTAsPeDL6zSeA9tPD4sr
33593	payment	2134	2134	1874	1	1	3699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkaUsoDjZx8kjw4pFSV61MSzx9YQaznqwa4gfdi6aQDBNTVhd
33594	payment	2132	2132	1874	1	1	1038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcedvYowJhJfsWAAK9niWVpxi5AAqsmngr8vvX9YwXQiuojJYX
33496	payment	1717	1717	920	1	1	4	2969746104288	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpYUCuQjJpf75DnU1CBbvMejHv2TRYWfZZsdvQo4v7UgmCrF5as4
33497	payment	1397	1397	1678	1	1	13177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztqCGNKuxo8mTFA34oPDKsQNpt5TL8UnS9fhgMHXALNYnm44N
33498	payment	1717	1717	1040	1	1	5	5321759574112	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpZi6iYVeQ9tqJr8ydg2M4tfvddVqtotRvovEg3ePUHJiLnnfjnB
33499	payment	1717	1717	1160	1	1	6	3590697228192	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	Ckpa49agSbpULbnKThJzmzux5bNjqNbeo8Nk3WkSwLN6kLXpqd58d
33500	payment	1717	1717	1286	1	1	7	10005797093376	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpZJeUTPom9DKSMT9XNvFRKPhcEE8RSMxo1Hs7K9ixWm3HPoTJfC
33501	payment	2134	2134	1874	1	1	3674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVZqSrfiqJEdmxMbaJFqgxTrxoNsVa5VpMcP8SdHnBRzGGUat
33502	payment	2133	2133	1874	1	1	3584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzi6FmonpMgLfwPcxefxdSCfPiB9CZWX6Po4cCqkFagmRWN9n2
33503	payment	1397	1397	1678	1	1	13178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEb3wYpHAYyG3MU9k5N8MxCiNrgfVYCFvmAzAxDktQmd5ockS
33504	payment	2133	2133	1874	1	1	3585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB633vkepHb8Mb2zo8Wa3NvexdP8XGkmc9jBYrAVrY7SaXA2bP
33505	payment	2134	2134	1874	1	1	3675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHA1Ugz7hpkzoHY7pAkT5uLUuBSqgr2NJyPUfjzAk5PSSpB1H
33518	payment	1397	1397	1678	1	1	13181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKDkauryieGHkxFnRngQqE1Ph9sEoz5WPKfsZuSjAA412fWfd
33519	payment	1397	1397	1678	1	1	13182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenKx4NyiV3t8TuxhHQMZ7FWhFFELSLPSyjnoT34mhPSBy3DQR
33520	payment	2133	2133	1874	1	1	3588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKNFXhzXgrauCM7rdahqCdYpWNcevRAF3uQ9kYDzG6uzLCUeA
33521	payment	2134	2134	1874	1	1	3678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMR1i4ZX2sqDmbReXqWZisi6UcKcxkCbj48iKkhNnKM3BHNBc
33522	payment	2133	2133	1874	1	1	3589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUunmJC3CMa7uMfgcADimdBBseQ9KZFvcS2fodnFMJtjTvL38
33523	payment	2134	2134	1874	1	1	3679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qMeimNcxaJLNUH1UNRpbNQyEXyLJQkGfWJuehZqqvC6ZDnPE
33534	payment	1397	1397	1678	1	1	13186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGfJxpEQicot1oZSmkgPY6JuCFhveZPyGxWiv5HDfr2Bd9PgB
33535	payment	2133	2133	1874	1	1	3593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7LsBwP8Zr2azAyCGSGhsbj3kNQiNicbUdacizxNS34u2NLER
33536	payment	2134	2134	1874	1	1	3683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv9EtJL62iMZnhhu1AfuVvow2xraPN2kQzJ4WGvNRBuu7zVsb
33544	payment	1397	1397	1678	1	1	13189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD74d27YkiYBd8A4yewPwUX4e2kPfkUBdzqJpumTmx3kNS8BZs
33545	payment	2134	2134	1874	1	1	3686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyRXWNXtERKXiec3zVox7VdcrPkkadm2RdswojbhL9MBiLd6V
33546	payment	2133	2133	1874	1	1	3596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCeFnwehJ3jDHApQX7CDEwAcKdMCumxSEmyew3eDL8f5ZHA774
33547	payment	1397	1397	1678	1	1	13190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdcmAMYmYycT6ptjqL2GnffRTyGZSS5g21Rj2kMm9cMRXJSba
33548	payment	2132	2132	1874	1	1	1034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvvuSXfHRaq6tKN6HScH7Ar2rFNsV7fG7bWLpjWhmB4MZSBFb
33549	payment	2134	2134	1874	1	1	3687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Bi5f6jwyqqE3Rai5gtkxVHVAiE8Rt4wwj18EE2SsiWvny2ck
33550	payment	2133	2133	1874	1	1	3597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hZWUBaaUB4iXKFgCkdX7ADKDfr5UdXWeZqSTw2fE8QiijfHQ
33551	payment	1559	1559	987	1	1	4	2004930000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP5fQesWxE8HRAer4sbTiQipFnaJfufYE9ULzrNmNt32Mj6XE
33552	payment	1397	1397	1678	1	1	13191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNUFFy4UCrkb84RgQT7U8fStKULiZ6curgNvRGbJqmWmzDsHq
33553	payment	1397	1397	1678	1	1	13192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAgRqf3dLfqdUriRW3G94HMKftd6E3NS9jWQigqanZ5V2fwqp
33554	payment	1397	1397	1678	1	1	13193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7cnbJb6RT197JcNsRQxD5EKZQ7hhujkQViiuAuZL3n3v33gm
33555	payment	2133	2133	1874	1	1	3598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPwBU7b8KQ6CbgNURA3tdoSmMhk2pJbEfrAVaoW7nNCpDUwZV
33556	payment	2132	2132	1874	1	1	1035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4dZ2p5NWxe1yFQHQBtCnLWa8Qkz7csjMtfSW3HgSHEGXfPzd
33557	payment	1559	1559	1227	1	1	5	2424130000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCUAZ4YkifjwUFxhtiHBDzix3kjCRiPTuNrCUpJLVAggLGU9G
33558	payment	2133	2133	1874	1	1	3599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa817eDpc9M6CoyMV5nQcCHnT9tG9ZMwfSY8q2cSvDHzhN3mxS1
33559	payment	2133	2133	1874	1	1	3600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27a4ncuTK5Tf5S862vSoKyPM77YQ8R8XpUwjBmayMw9F3AtCo
33560	payment	2134	2134	1874	1	1	3688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9N2yji6EnehTX9QAfFagFZdnpNtzuBxdzKfNcYu7dgtPjfnd
33561	payment	2134	2134	1874	1	1	3689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGh8NV615SdSaKjbvdCR8GofmdbXVrY9F1dHQX48rMXSc5kuH
33562	payment	2134	2134	1874	1	1	3690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXbH3gTMG1CtrAcSXXSyVofh5iQW8VVWSQWCRhfnpPPNZC5WL
33563	payment	1397	1397	1678	1	1	13194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk1qvdfa1HKda1EyLkzDD834xwDmMqR31vW37M3Fhn6jds4rh
33564	payment	2133	2133	1874	1	1	3601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGS1RPuF2T3cX6DdJgU7SAbumveWpmFc26XiCUc4dnp1L1K94T
33565	payment	2134	2134	1874	1	1	3691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmniPpmvHpZcHvz4X5cUzrSewNL7LY9QEip7Ed1b1EV8UN86wr
33569	payment	1397	1397	1678	1	1	13196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVTn3uJ2ALZSsgjHAD7iASqcXtSeC8FET8Q4ioxrFvpMAdgmN
33570	payment	1397	1397	1678	1	1	13197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VKxZ6nZuCKp9xiok3XFXVsoDra1VC2WXYzigXsdDBTaecT9w
33571	payment	2134	2134	1874	1	1	3693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQ5FZRKVRLUVy17i6pLs6GqhJxp44rtWazd2DAk5shvb5A8ES
33572	payment	2134	2134	1874	1	1	3694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2MAA8aHwe2wcKf3SkwZsyKT5aELew8KcDoUhzihHPGTPoWWk
33573	payment	2133	2133	1874	1	1	3603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKnEL6SgcseJMcvCytikXKdptqcAmCLHKzgXGqHB4PGACRBmJ
33574	payment	2133	2133	1874	1	1	3604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMuymQzn7PUzMKN4movqjbESfk38fqA5vfoUuF4tHECquifR4r
33575	payment	1559	1559	1107	1	1	6	3592790000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjD8fwcXfdiTGb52U9YDL6EzBNvu54MWJkPrzeCRhF9cdxW7c5
33576	payment	2132	2132	1874	1	1	1036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrZNrL4Ua7r6sJsM4h8EbvGdcm8bw5gaiKhqp58WLMWu6zwG2
33588	payment	1397	1397	1678	1	1	13201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdbyFUUfARSnM5A6C1NVj8bXGjf8ssVGVkjJcAff9X6Sv2M8Z
33589	payment	2134	2134	1874	1	1	3698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnh8ZjRT7W2zetB4LB7gDPEP4txPvYWsBz3E5wYPY3JN2zxxZ
33590	payment	2133	2133	1874	1	1	3608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTFbuzZyWBiK6isdLiTL4phQvHVsn6hPw8goPtxpytBBD1ExT
33600	payment	1397	1397	1678	1	1	13205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkg8maqZ3uQbSusuBLZkzjcz7SzpJgXaGwRhR94sqxXe7wq4p
33601	payment	2133	2133	1874	1	1	3612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPjNCrJh7ucA3iuua4koXRgrMLEd6iVhXZ9eKs6FW64TBms5s
33602	payment	2134	2134	1874	1	1	3701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihGsn9yojyciZN39fCSv1Py331xY4vqrZpGibQBK4T6Fu9D7p
33603	payment	2133	2133	1874	1	1	3613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxTns6Uk3JaZssE79ohPGURyjf9NnYGeFWAg9umKg5CsgQxwL
33604	payment	2134	2134	1874	1	1	3702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqpEeGSRpKkmRJFPTstQhhey5BxF3HwrjdVLoyrnhPawEXu9B
33653	payment	1397	1397	1678	1	1	13220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEC4Eh9ztZC1bVjdDnXfnnVWdD84GU4FS9d5UksLnwNzcdpEEN
33654	payment	2133	2133	1874	1	1	3628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ21xL4SXHV3dZPyDELv7FnHgeJFnX4ibhjimhhXm7iU7LgKdF
33655	payment	2134	2134	1874	1	1	3717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK28wuY1noywWmZ5LULdGHs3uttrbJcrwLUe9HoVf7PKnRd2d
33577	payment	1397	1397	1678	1	1	13198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHdpKAjYds99CoxzsWxYaTxyatKscVTetUFWdbjbsAeNTrw4t
33578	payment	2133	2133	1874	1	1	3605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdvyuChrHLiQtnSe15Gm2mc7V2DxAJu5ah81Z2vxDDLLEqGXf
33579	payment	2134	2134	1874	1	1	3695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJqhBLaNaz2urntsVt8WJ26TjNjv3gi5W71siKywpaxMS7dA1
33613	payment	1397	1397	1678	1	1	13208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY59xhBFMqDJdK2xRuQx4HN2T94mdwKNqBygV6NfhUNieUEaq2
33614	payment	2134	2134	1874	1	1	3705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhthQMwY1SKbWWeTkguPYpHhJGdX4N7BHKptn4iXPsxUVwtHCk
33615	payment	2133	2133	1874	1	1	3616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzmiTWxC1A5wnEgnnGg6Nnph4tDocevKQxM2QecWU5umJcgFF
33623	payment	1397	1397	1678	1	1	13211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhBKP6ZoRNNbzBc17Z3adszrW9meEFCbyxx8rFGnykif85EtH
33624	payment	1397	1397	1678	1	1	13212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNmtoAjruuvm7iprj2XbJ2ULM2RP7QGPwdLQenM6j3EeT8czZ
33625	payment	2134	2134	1874	1	1	3708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVLi6Y7ef7WKZ3f1D54S5doJoHVSCzRNiRg6EGq8owMYbdpSR
33626	payment	2134	2134	1874	1	1	3709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYvahY23QRgfxiCxBYMrJaaNSVVbyrGbiRD4mHQZRz6Lh16hF
33627	payment	2133	2133	1874	1	1	3619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTXpM5f5yuZKxKtEGprYrTpHrrxktkenHwvFWRHNPmjzCkVFE
33628	payment	2133	2133	1874	1	1	3620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPs8MYVmWdkQukQvykwiT12RzrHtqvoCTv5xLeaVBx4t7krZf
33629	payment	2132	2132	1874	1	1	1041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Ayy2vqoSMVZ1GfX3PFehEeWgvj3FtRxvMYKHmgx1kQg8gU9
33595	payment	2133	2133	1874	1	1	3609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rYdzqaEvuq347A3iCbr3MS6RF1xy4tsZxdLtRe95j1q8G4ur
33596	payment	2133	2133	1874	1	1	3610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDMirR8CejxCRXfNUoxGKA3Q1by89tj5Wq9WpgQo4JCoJYuL4
33605	payment	1397	1397	1678	1	1	13206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6zT491CZixiniNVniEFhJ8VkXQugb9ANRPGxuLUq8H588TU7
33606	payment	2132	2132	1874	1	1	1039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMWBEqyieLTSSLcTcrV9eJn5kA8wMK6hFDKDadoCdFNyRtiw
33607	payment	2133	2133	1874	1	1	3614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hQJ2TgfudL5VBy32A4oFm6FA7mNRZZPjgWCWoCiWYzcDxbyL
33608	payment	2134	2134	1874	1	1	3703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCqVkfT4DJpbQbHBLEVFjbK9N6HAgQdRgTzC5y4iVPU1BDMyQ
33609	payment	1708	1708	1385	1	1	7	9067753615872	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmai15BJju1di7mZuzbHzy163mMtdURxJAaNgLyBz1SAi9uiX
33616	payment	1397	1397	1678	1	1	13209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhM2VHMw3bdpJc1bfo2gypSkcDmmspVcrT295jQV5aFiEnqdU6
33617	payment	1397	1397	1678	1	1	13210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRxLeZTGbNkLdg5bxfmXn2rGdD5rNkGidWvJqCThtbkEdtqxR
33618	payment	2133	2133	1874	1	1	3617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2Qiq2FUg7Uy5m9R3MHXLCzx671BZnE6nE3H4n4SEzre2Pf4H
33619	payment	2133	2133	1874	1	1	3618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEW8u8vpwcRZgpnY5zrXx9v6kYPhCYaQu3KpAGxd8PM8phHmB
33620	payment	2134	2134	1874	1	1	3706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JNifmxtNcxzCavAPfX9VeLgwoPsUnUFP5DjQp4k5D9UXDptB
33621	payment	2132	2132	1874	1	1	1040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrF9oKvUh4JDoDHJvyZsVrwjRXYJzv1D7vWEVxUyF7fTmy2VRt
33622	payment	2134	2134	1874	1	1	3707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiBPiYmcBxm2Rr4VA8vuVcs4RyYThu8cK7RXctU8Y1zVK5J5i
33630	payment	1397	1397	1678	1	1	13213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYconrkQR42jVxP6eDvhjDu5HacNSuTitNerKUcFBmpN89hzWAk
33631	payment	1397	1397	1678	1	1	13214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aWD8AHFQMwT5BQSp1LopoG5XNH9Uxpuw7CkdP4rw3igav6CZ
33632	payment	2133	2133	1874	1	1	3621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZim7AX9mmK2RgPkLWz7BLYYLgpAKbYG6aHjGJGtASGLrRy3aVz
33633	payment	2133	2133	1874	1	1	3622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2m9HXsf4JgQi15R1F8CyP7JSZLC4UjfdJwXH5cb58qvLfne7z
33634	payment	2134	2134	1874	1	1	3710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QgwjWJhU1B3Zw2j99sJeBV2YzdBdp2N55x8hGxZaH5nZdFTx
33635	payment	2134	2134	1874	1	1	3711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC6Qpnh39pZmFddFyArExA4vGNNpTwkbXbR4t6g8iy3yXdton
33639	payment	1397	1397	1678	1	1	13216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbeJngngJyCwLUPvAbeQ5EtzHiFKBPX5Woj44tFzkNxgCbpVx
33640	payment	1397	1397	1678	1	1	13217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLKatfWVSzsj8JLg9U8tQvBJvvQtiixcmW9vy71pjBXjLoBcH
33641	payment	1397	1397	1678	1	1	13218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56QigHv2URk82uwJTnntLXMx5RmdP5TZSXrhWYPQqFG5Q1ocZ
33642	payment	1397	1397	1678	1	1	13219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaxVkViZTVck6zifiDJXX6NDg6ti5p7mYiiHmfNWJaARvxqVx
33643	payment	2132	2132	1874	1	1	1042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwV7pDCnijEGCzyGq1F9iCQgNmebRnq1qMYfmDbCEaqvBwhe82
33644	payment	2132	2132	1874	1	1	1043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmzLdjjhxQfeM1mTHmKMVLdTH27MHGyKNxuc6fVZ4foDwZ4oT
33645	payment	2133	2133	1874	1	1	3624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAHroRTuZn9e35XJ5ppZb2QhKnAFrw956VF5zuvMFr1nfJQxR
33646	payment	2133	2133	1874	1	1	3625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzVxJHvgCwCd25ciYH17vp4vVDQuaGZS1WfJ1t39EmrXESgSX
33647	payment	2133	2133	1874	1	1	3626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBom2bXkU1dSn7dEr1m7NKYWqpjYzrgE189GcuFJbUfMofYFAd
33648	payment	2133	2133	1874	1	1	3627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9B1fEmNKfaVKkzYcoJzTAY81sm8n2YjQRvwvLxyp1z2jqbum
33649	payment	2134	2134	1874	1	1	3713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqu3QwHB3rmqk2WE5ULaUS37LbAMM8otawkKxTmPwzSrHYosf
33650	payment	2134	2134	1874	1	1	3714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5YJd1Y6ePQG5pEQtpkHMZaGdvWVCsn7aM8ikYp9SgdmTLMkj
33651	payment	2134	2134	1874	1	1	3715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACmFVXQymKNgb9d2BARk89qMaNRdGAC8MSZGXJFUVnBjr3KFX
33652	payment	2134	2134	1874	1	1	3716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaVTqFHJ6SG7F3h8whniZ4Hgsi1yBZ69U3D2SKeKZoy4vrA2A
33597	payment	1397	1397	1678	1	1	13204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfq9CLxPr25xa9ioYCyRESiG4gUvSzXetjK4ax4JKWGeaPVM9d
33598	payment	2134	2134	1874	1	1	3700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjR67bR5cf2AukGSMtnKdEoxficwpD9RJYduRPVnbqvPJJEaj
33599	payment	2133	2133	1874	1	1	3611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJbzfVAtZtuW5Tg4icnU7i1you66E6k3JEZJah4y6KvZcLe4h
33610	payment	1397	1397	1678	1	1	13207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfNEHmk1Q9LsA8ym6axBcREUEo6GT8o9djPsXx9jE9wP9tGxe
33611	payment	2134	2134	1874	1	1	3704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirqDTDtHVXPZdM3GeZM2tGZDpNrTxctomF3Y65nxhmXoewmH5
33612	payment	2133	2133	1874	1	1	3615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEM4utTUrZehfUtWFi8vuqVYseEUusx9qHGEsPRkHwMqRN6ZG
33636	payment	1397	1397	1678	1	1	13215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSy9sUC7FEyx798a9KxbJseCf7UAeoQxPSx3kRq9aTeBkfiDfW
33637	payment	2133	2133	1874	1	1	3623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgM1MQoTM5Gep9ipJawdLSbFBapfYGgSFgRbhzvoDCrNcHBdD
33638	payment	2134	2134	1874	1	1	3712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyD6eQMTuhaoVaPzKTZ6NDAPtEqSE54MWae7yedfjUJjx8apdK
33656	payment	1397	1397	1678	1	1	13221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ3qo3LbS8w9UHc32mBEVD4Y82o6jsgDLoFA7x7VhgSwVZ4UM
33657	payment	2133	2133	1874	1	1	3629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHFL8LSYigMAREmM9yAJbGCdDpZiNuKi2DGAip4THifUBUCmo
33658	payment	2134	2134	1874	1	1	3718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRxUQ6gNzRpt6JVZDoiCpv5E8f2rhTbky4TjzQWeVVk2Hm1NV
33659	payment	1397	1397	1678	1	1	13222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeCsmmp1dD4pXeactdHxShrhRLPAcGmmBq7wXfqMGeY17Sa9c
33660	payment	1397	1397	1678	1	1	13223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfz2zC6Jd54zD8W9xFPkMYwufm4pmQ9jFsu9y2sXimuiUfADiz
33661	payment	1397	1397	1678	1	1	13224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6EnMKk6XrR5KCnPRMBSpfjBqTPPEVDj1rXmYu2XumWPsp74J
33662	payment	1555	1555	981	1	1	4	1458502504352	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZSQQwp1iwA1ZfypoDANX9ZSRvqQtRYmEtMhY7jJynwV558iNoF
33663	payment	2134	2134	1874	1	1	3719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKRsDEqAYJH2yri6NKqs6iCN7HVDue9KYuXmVCz7Pe4fhjGrw
33664	payment	2133	2133	1874	1	1	3630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19kFGoSUphYHKHg6zJeo838RuFwuuRNzYLuschR3GcJJmPK9R
33665	payment	2134	2134	1874	1	1	3720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzGUANr4Gc8rtXTvNc86aUiuHUgCzhAkje5u8XQsuwLFMdwKV
33666	payment	2134	2134	1874	1	1	3721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1WgMdvrHQz8wYgPkWYhS7WmViUsKtvQkMSdQzdEW1exknKtc
33667	payment	2132	2132	1874	1	1	1044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3whqNWin2d8XwmWzVE1ktStt9AeDVZw3fvaPL97PB8jKqhzo
33668	payment	2133	2133	1874	1	1	3631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBF8bbMonNBvGBSsULEWdR8LMYiEn4YkuY6iWzuC6jLDnQfdt
33669	payment	2133	2133	1874	1	1	3632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4faLqXcbBmqdHg26ut8w55onP8sqLFzzp9qdWYbyn3SFzxMKG
33670	payment	1397	1397	1678	1	1	13225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynyofqHfQ82vCiCyULjmuSJZH3TEhbtLT6EcSReWtDTh9aS6F
33671	payment	2133	2133	1874	1	1	3633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwKSDXqCBqxZACXjH54zwzHk1Jsw7J52BZgD3ioLVPR687kj
33672	payment	2134	2134	1874	1	1	3722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKJx949FYd6pH1LaqiUAFZFxcdsK6KsMJTKpPpJhZPUKbm6Vr
33673	payment	1397	1397	1678	1	1	13226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtbgmmPKPyxN24HXLmM5n46DMcXJTr718DC3st9ashCQVuXmy
33674	payment	2132	2132	1874	1	1	1045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4roxmdWFMTHRuCZuLPsGUvKw3VGTLHECusG5WaSVatVFJcYq
33675	payment	2134	2134	1874	1	1	3723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2bxqMe83qdWr6ewiJ1p9EWH9dynXDRYsJGYz7qVC9fXJCWvQ
33676	payment	2133	2133	1874	1	1	3634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNLKubHn7RiYk9K7X3yz6HApuJNbRAEEPCx18oPXTkiaHLav4
33677	payment	1397	1397	1678	1	1	13227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvup8JVemt4cbhWPXnFfP1XzWFZ8Xk3C8aoKMn6SHbfH41qJN8
33678	payment	2133	2133	1874	1	1	3635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSG8X81EgJYBBRi9kE83PHDN23tuFkNCjLXa7VUA67Pa68VqS
33679	payment	2134	2134	1874	1	1	3724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPjsBTKMojiiUPXBZBzQztsdfzyWBKeu29ZM1RcmJKGAxjfyV
33680	payment	1397	1397	1678	1	1	13228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZf7H7ARMjEqm1kMCRtLcx2gq2jXtHcffzaoeseHoaM9jh6NCY
33681	payment	2133	2133	1874	1	1	3636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBVT3SoA9hLWEK3DnExBjNzHbMXcN8foNGgpV9rj5GJRfWhKC
33682	payment	2134	2134	1874	1	1	3725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5XzgZGMXxyyiVwBNGyuWiTU3vAWBLvgRVhPWE3J2ZJ5Z89Pm
33683	payment	1397	1397	1678	1	1	13229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZTTZLnvtUzQXkEPKqCi3h52mob7Kd2JcvJHRWqr3nLvzfKAR
33684	payment	2133	2133	1874	1	1	3637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP68yK73oU4F8psyGSPWSuDwkdZKEW973wMQEXacwUNTfpBRPS
33685	payment	2134	2134	1874	1	1	3726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2gd7J7esc8Fyn61Gc1jBmfqhjJpC7UNS5m1495rhetSkpV9o
33686	payment	2132	2132	1874	1	1	1046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdREbPEM7CzP91z9PCJZEA1yYmjiyHeZNhFbpfZyjPsLdEgTr
33695	payment	1397	1397	1678	1	1	13232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEULUrY9GnKicBcTQa59whg8wvxLwphbFEhLLAqN1UNaqBupo
33696	payment	1397	1397	1678	1	1	13233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MVD8UJXZjCRMeUAWNA22p6n2RRwN4V8AN4UFwVgp8RNibGok
33697	payment	1555	1555	1221	1	1	6	1763464187104	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpaJ7mW9KP7y9XjCpj2ddVACRaRaNaWGUUWrdeyAQaPKdwGY4W7Z
33698	payment	1555	1555	1347	1	1	7	4914049755856	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZyiNxoNKK2Qj3JcADA3TaRPa7ZeKURoLnTETcPkqFu97f2sbWX
33699	payment	2133	2133	1874	1	1	3640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSjM9d7bkgxpvRPALkvSUsoELHz1KhnNbAeTWW1RoR2W4Stoh
33700	payment	2132	2132	1874	1	1	1047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRGPwkrmr3YqyFTYrDqskT9dSRLz6ZwpeQDnvFszndYxHr6cJ
33701	payment	733	733	2295	1	1	4	717700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VqvZNDhi2v4wjhqXz6ySXuFhhDGssUCFq7VcD6GTAtzohtga
33702	payment	2134	2134	1874	1	1	3729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqN1wQhZyW2SpqwQFuyW6jhVQqduoqvEL4jTewSapZSWhwv6t
33703	payment	1657	1657	1098	1	1	7	3578560000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhKwAwnZRPSFrNQfE7f6Frf6eJ6hG2kZ3fGuCCujpJcvjqBXz
33704	payment	1657	1657	1218	1	1	8	2414530000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLJuLS2LBEgQMU5pQTihdqR22ghqCJhMUSusbhLwnPd2VKPzr
33705	payment	2134	2134	1874	1	1	3730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUhbmfRZjfzYVmACcKGYjP96Tv3zbNsioAuWpVWQW8sRzUc2R
33706	payment	2133	2133	1874	1	1	3641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86hu2kRM7jfy4ry8ejGuf5Makso7KRVJGo6HY1i3BANwdree2
33707	payment	1397	1397	1678	1	1	13234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUUCxJcASysjwGUBPaGVPoAABDXerjdMFNAYMEUWhmdEuRGKN
33708	payment	1397	1397	1678	1	1	13235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFEXqijMMZQJWpSHxawHFoiXAm93KT5Pm1Po1tbzNcobDKYJW
33709	payment	1397	1397	1678	1	1	13236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSL3LDhSNQk74myhzGtgV8Cec3voM9eCT2GKumWKfK76XQao1
33710	payment	2134	2134	1874	1	1	3731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs7FJu3Qnds8GburrMT8oAb4cCMRuGQpbAMX95CWWVR9GpxeS6
33711	payment	2134	2134	1874	1	1	3732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDxQKpgmMUWd5Tx9rAZSZw1EwkW8EkNErB19zCswmnrrtnaHU
33712	payment	1657	1657	1344	1	1	9	6728290000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEX94u97NKVYymtQn5gkgzQeZwh799HCEsLKvu5Ppu66aTBZ6d
33713	payment	2134	2134	1874	1	1	3733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5bVn2CQRdgvt4xkhSqSu9teWBNVxew2xrfT1vpLyCMUkpBCA
33714	payment	2132	2132	1874	1	1	1048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBGnPvfjmoGcpTQEoiKtK2bHAfhGGefjrtqnhPFrzctaoNy4g
33715	payment	2133	2133	1874	1	1	3642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7CmxEJgS4onKdLhjHbrECRLm6XjZA7scJB4va8M5WdUy9MP9
33716	payment	2133	2133	1874	1	1	3643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd5xuWmZabnWvcAyyDP55kMkSKc9E1BVZ9rCzsrNe8Bss3fVg
33717	payment	2133	2133	1874	1	1	3644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvAXvVybQ2UZXznr1uERNiGmjrPdnEmJCUGg6MQtabCYfpSHY
33728	payment	2134	2134	1874	1	1	3736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWSZE9vCCM5ukpyX9dfv9oFrLNPHKDZRyJKUYexJjUj9pk8NQ
33755	payment	1397	1397	1678	1	1	13248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoL84W7mjzgspNhNfG6tDBCwHTxurMdp4KQt8Muuj5iYa51Tff
33756	payment	2134	2134	1874	1	1	3745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiC4aTMxMQdJiadVDU6AyojCtExN5sS9yAdVTio85TEJXGonmS
33757	payment	2133	2133	1874	1	1	3656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKKLs6fYVLjMkyfSf716afQTWczArTngMtJDNPcRG89scMjzC
33776	payment	2134	2134	1874	1	1	3750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U7cNHz3qoHmEuNTTeEJ9aTus7zbJoaXQjzvjVpKJBQgSo5wG
33777	payment	2134	2134	1874	1	1	3751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7PQZ7vgZDLC4QRWegkSmT6PFpvqJWA5yUMVgB7x944aFvwKB
33781	payment	1397	1397	1678	1	1	13256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPzkzWRYxiBy1HZCYKyNNsDYyFCwNzjRpXEUcXrXXJm4F7g2J
33782	payment	2133	2133	1874	1	1	3664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuGizxGECFFhjyF8TCkinei5utc8g4WZvB6ED5v2u154idREa
33783	payment	2132	2132	1874	1	1	1054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xzxf3SW5XHxg4gBjDfJ5fW51p384b9SL9ucAKSS5UWsxXAew
33784	payment	2134	2134	1874	1	1	3753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXocxQhL79i9FwHFh3opDRqHtQzVD8LtQagWmMXhEMB5A6t2k
33794	payment	1397	1397	1678	1	1	13260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9MSafk3cJQ1dnHjqy9nE3TDzNQodSZYDmn5oL9pX6J39rhTr
33795	payment	2134	2134	1874	1	1	3756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwHxuECqpk6zgZE3H9XuK3R4bBzyoVBMqhnBzUhzEeizxpiw5
33796	payment	2133	2133	1874	1	1	3668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QF2GF6r1fB17hMcFgK1vAQAL1CRsndMjEvRqpea2oakGD9o3
33687	payment	1397	1397	1678	1	1	13230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKSEmt593Y633qjuMzNyL49uXgfRAFNUMojDSzzrTLZDLTnUV
33688	payment	1397	1397	1678	1	1	13231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtJxLDDebtximLMMwo4odzGJoUyZsY3w8voViN4nPPzPhhehS
33689	payment	1555	1555	1101	1	1	5	2613623991344	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZnkfD2edrGAYpxCB3YknCCG1Na9JsprP4J7HA2f3U6ijx7iHTr
33690	payment	1657	1657	978	1	1	6	1996980000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5qT9cEtAvDzXV8SzrYK51wY9pPY5WomwRhxVf4SaHezNpgYt
33691	payment	2134	2134	1874	1	1	3727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeyXwYYLyJsDxXDQmJriTR9GscjBJxDZbSaTQYgG6p1ym8pch
33692	payment	2134	2134	1874	1	1	3728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMvZKCBiHwnAmAYwQKfnrNw5ShDiTkDQTHmbLPgx1KgZMERga
33693	payment	2133	2133	1874	1	1	3638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaxjUmKa5nN6bQc7ud6zG5NYqUrCxoNcEjj4oGPS3yaRfxhyy
33694	payment	2133	2133	1874	1	1	3639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnt3buyv9655ckheNUy2b2UoPAC1Ue6HEUeQQqnnvHb9w9dM2
33718	payment	1397	1397	1678	1	1	13237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ561guEvmN5Zd5s3PbS6SH88p3NeSaHy5UgABgc5JmTuzDb6WW
33719	payment	1397	1397	1678	1	1	13238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCMJZAnvaY9ajCFVFv4HWMfikHq1KFRvoSysPTeZeAi2FcvA1
33720	payment	2133	2133	1874	1	1	3645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULLuVeYwvrcyVFyyrNbak1C9RtRpj1FfV4mDuVJfzfu8QP9sM
33721	payment	2133	2133	1874	1	1	3646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBm6RkfgAgBYLp4hKb3u7QMABAdSuuKEDzDn7GTgpVvdBgap4n
33722	payment	2134	2134	1874	1	1	3734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeWGLLsxbSqneyD5TRQv5LHu8xasDXStUxhHxCnPW1CoHvqFM
33723	payment	2134	2134	1874	1	1	3735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkR1z6b9RtdFGW19nPi9S89Riq3kUNMWDU9deFQrA2AdAErwja
33724	payment	1657	1657	2074	1	1	10	1122000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Tu6HL3W4f8ybXsALGJL38rkUvH593NYSRCARN95sPHLv1fYY
33725	payment	1397	1397	1678	1	1	13239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNZHHxP3xE665254CBABQN87yJ73cENUtGunX2Px2WWYGghzr
33726	payment	2133	2133	1874	1	1	3647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwxoSQgD2C9bc1GunfNBABKT1WaoR944NCabm52NYXDFyJ1Kf
33727	payment	2132	2132	1874	1	1	1049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UefTxcSbR8dhwnWcUnSsp72fdpuWFtvfnomVB4CjhV7GTVTK
33736	payment	2134	2134	1874	1	1	3737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VYLSs3ytYufttwD8fqvbbXCK2WXBiQKYbAo8yh67rBeBvE2v
33737	payment	2134	2134	1874	1	1	3738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6nXBh2276j44Er2UBGvUMkJ7qqZSXcG67g443ZAceL31qHX1
33738	payment	2134	2134	1874	1	1	3739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVKFyEUfW6L7eLAK8Jo5wZgVG5EM1HadGXXihBPbsufo2P1j7
33752	payment	1397	1397	1678	1	1	13247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq6UQVkEntcUXYRnV93MKM6MzMmpS3n5VQ6SF1RFVHeriqTaiL
33753	payment	2133	2133	1874	1	1	3655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoTezwHcCCsPcYrG5AMdtBvfSSE5QUuGKijkbNiCMbmgfn8mj
33754	payment	2134	2134	1874	1	1	3744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJDn7Jf2Sp5WeqtVCWc8U8H46vhPeHMh7NjVzHFnGS8PqxcvE
33787	payment	1397	1397	1678	1	1	13258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRecWCDz3fh1Ymd3aRqbYxhJV8qew9PTPh6EymXWW7pDBgvbFt
33788	payment	2133	2133	1874	1	1	3666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xoUBdk6wRk3GYkuH1yfx4qbvRS1X5d5yD5SnSfBV2zLBTgGy
33789	payment	2134	2134	1874	1	1	3754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqGFhHsSzkMaeSCgdqdmvxoKcdY1ev5Wb6Ud4e3R3SpjnEbsf
33790	payment	1397	1397	1678	1	1	13259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbzo7auojibd6FCdxxP5ubwsQA4B5qNjHrtRHUi1vDJZsNVjS
33791	payment	2134	2134	1874	1	1	3755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJJz9vBgxGkUY1HyRBpjtkXQ7Jy2CudGWGBCx3Q8f5xCLTs8G
33792	payment	2132	2132	1874	1	1	1055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZGLJzv9RATxvJCszjPvWEst7D1S2UTQc2tPFS868rk3GXTat
33793	payment	2133	2133	1874	1	1	3667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vsQtr9c6h7TxDnCjEF9DoNsRGzCsMyximoe4zdHpvG85akbe
33800	payment	1397	1397	1678	1	1	13262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPNEye7XGAKbjoBEf5CH9vL4EX173xH42QnUfuiDttykFFwMi
33801	payment	2134	2134	1874	1	1	3758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqM5VY4AcTH4U7RxCttFoRSyfzURrCHMXzzV8vcedwyrQJhvc
33802	payment	2132	2132	1874	1	1	1056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7GMsbS5eZMzz9kfUUaS21Prw4nidURsfrfN7ox8Rsi5EdsTy
33803	payment	2133	2133	1874	1	1	3670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9QfwB9EhozYfEnhTHHG7TGwDzWDQBgKbhYkz33g3v6PtEGWx
33828	payment	1397	1397	1678	1	1	13271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1Xs5hStkXNLCchfq4Jcibsd8Nn5DPbUmkxrqg2DLrzQfhEmz
33829	payment	2133	2133	1874	1	1	3678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcd8VXKW9q8G8Pz9v4MX4hB5VHPnNYmSbPEEdPKNc2pEtzF6GA
33830	payment	2134	2134	1874	1	1	3766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuf42jB2C4Acf3L1y49y1e12RejjbBBwCXqekqtNHZ5W6WZob
33729	payment	1397	1397	1678	1	1	13240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgxKG8QPb8vRpigJuKBXABJhe8pTCFcuzQbX573ATitxopFbh
33730	payment	1397	1397	1678	1	1	13241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPHwrTbECFvRuqt6wrTsxVayekKG26kVyjAuGQ83YJ6QzePBv
33731	payment	1397	1397	1678	1	1	13242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ94wKV3HEDxh7UUxLyjgMri11DH6vv79eJiaw2Z9fFM5R4H1q
33732	payment	2133	2133	1874	1	1	3648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHnynW8jiC7XTd1ZWhEdwY1nrCRgX8aVCNycRtLuPRuC6NNDJ
33733	payment	2132	2132	1874	1	1	1050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CUcswnzeKfjbw9VeY9AHfPGAccn1wBsguDfwaHDMAT6QiZpy
33734	payment	2133	2133	1874	1	1	3649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKb5Pq6256Jyno5QBxxmm6c1EjeKRpQdr2vf8GeZFTbSFXv94
33735	payment	2133	2133	1874	1	1	3650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPQEc7Cj6eb4YbyAvU7e27xnebAuvA6tgXEUqg5TCRqmz78xU
33745	payment	1397	1397	1678	1	1	13245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5bnZ8Sd936So687cs93rfKhuAxuzMsXF3ru5zF7dQHnGivVQ
33746	payment	1397	1397	1678	1	1	13246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNbTKLNW3Ph98Ywn9UVb2sFC83fNiJwp3ThHHic2gN1DjUw71
33747	payment	2134	2134	1874	1	1	3742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNdhAoJzvGYZG3Rj61nkZYwvMuNRziqQw5uzMdSpo1vN5oznJ
33748	payment	2134	2134	1874	1	1	3743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumi1bV8YHRPpUMxP7dDNc5Dk6xCPFAHHteLnwbGS2LgrHanW4
33749	payment	2132	2132	1874	1	1	1051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqf4SjDWCgF9TnNijSme7i9kvq7zniN4LRv7Y3eknTzhZjoabA
33750	payment	2133	2133	1874	1	1	3653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveSP9bCx8eY61n5v2VUWr7niwWynXqtJf1BuCDmZkrRxdcWcq
33751	payment	2133	2133	1874	1	1	3654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFj25aFKMKStE5wCUdYBeNNwzyTVxJMW8rqYfaQFvnYWLC4nr6
33772	payment	1397	1397	1678	1	1	13253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXCtJ8mshbXT4LhmjtHAZLq5a2f4ShipX7F7WA52BYHPLFk3z
33773	payment	1397	1397	1678	1	1	13254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHkZoQNKomwKF5w7Cmn4Crutp2WueasL1y84qFBMcahEsugLB
33774	payment	2133	2133	1874	1	1	3661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaMLs5ZfkNEsmsn8AtWhDUpTYeaYZ8vYjurc5vagQWSJBrXru
33775	payment	2133	2133	1874	1	1	3662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtveBDqwvjB6FPWjBbTtgsKGtMnfRfz3San7n3nz2k7cPUkZr
33778	payment	1397	1397	1678	1	1	13255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdpCXvhNnyGEdevaN2gd2DHFMmQHAMqV4nhNYT2oKdLQS75ke
33779	payment	2133	2133	1874	1	1	3663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1nJptrNdJMX4dib6f2FUvn2VPCaJiMQ1qR9v6w3FYWfeLSor
33780	payment	2134	2134	1874	1	1	3752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa977ms76o88V1Ls5v5CWN7BgHadRFXfsxMk4L6iWj9W1aCFhf1
33813	payment	1397	1397	1678	1	1	13266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbehWL3JSr5gqxe83HZg3WqpWVCKndZW7iniyQUQmMBhziY5R
33814	payment	2133	2133	1874	1	1	3674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QBUwpmXHFBW4S5oKtc2uzYKDSvNanVs1jB5vG41UUCHc5Pgk
33815	payment	2134	2134	1874	1	1	3762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhksqJgRose2T7CrK8EyoJntfG5HxdScs3tU74NroiYuKQ6H1
33816	payment	2132	2132	1874	1	1	1057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUc5DCgYRmvBpwAo8Zbcx33943HVm8o8xbAjRgU3NYaM2hdkJN
33817	payment	1397	1397	1678	1	1	13267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjuVgRWGbxBnqYmVAN5sNrEfQkQc5jr8XnWPVrsHWKq5LVZaz
33818	payment	2133	2133	1874	1	1	3675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VoS22mrodVVBCyQ3RVFBWxqYVfuweCu4b5437wwiCKpLfEJk
33819	payment	2134	2134	1874	1	1	3763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNPGix1yxzME2zMackWZAf9op1u179sQCEJnAQ2skHH8kVajh
33827	payment	1397	1397	1678	1	1	13270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDFGoLhjda5wEfdZXbfWdSNXmeARLtWZ92LAGaHaifV39HHxL
33838	payment	1397	1397	1678	1	1	13274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuqa4vfTpGda58J7EnapNu8CbtiZhENnBR51kn3PNBsvdp7pL
33839	payment	2133	2133	1874	1	1	3681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VP2eCGhdX7ncYE1Ptx4o3HJBHUygArQoyaMA2gnknsu6WN3J
33840	payment	2134	2134	1874	1	1	3769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mgko5PRAaPkBr3x1G778hqZjuzW6kaNwBi8FJxKhUjUFyRER
33848	payment	1397	1397	1678	1	1	13277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBSXfxX1LFb5QiFBAyeLfVXwfhf7bRP5utPCQpuhp2ey7U9fY
33849	payment	1397	1397	1678	1	1	13278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nVmgU5taigU1FYDXtzg42sufjGENx9gk2RgY1C4PxkzuwkKJ
33850	payment	2134	2134	1874	1	1	3772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcHqGL5UZSUvFprdxqcc3yVm2iKPXzHT4zcRUyhEYSV2czcqC
33851	payment	2133	2133	1874	1	1	3684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYZGeTu4YbXDiWCbEQTFRm3tzj88bZz2yrheob264zZ1r5DjL
33852	payment	2133	2133	1874	1	1	3685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNdqEgM4oQuC62KSJenQ3YeZiWDUR1tQWLR6ChY7Ro46LxZC9
33853	payment	2134	2134	1874	1	1	3773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpaAiymM4ZYAoM8ynrdwrWX9YNxtrJ2FdBxfx6CwoZsi5pTfP
33739	payment	1397	1397	1678	1	1	13243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4bXkRTA7u5x7QTm5PiTwfcrhMCfThDrtihB3myC5mbPvFyqU
33740	payment	1397	1397	1678	1	1	13244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6erEofnFX56usFTvkoArrCqssZGR1Ac4qWHzZtZxLDZH4iYDK
33741	payment	2133	2133	1874	1	1	3651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaG9qFZsGoWETZnP92S9eiGHiFpUYeXcF3seDLkRkey2PekHQU
33742	payment	2133	2133	1874	1	1	3652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSzZu65eEBLuCjQsJKhzCjnFyd5maSuFxiALs1bkLN8p4izkR
33743	payment	2134	2134	1874	1	1	3740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZknzyi1ej8xREBvnqoHc87WL5sA3pe913q3bWPeMWmAtW3mWPu
33744	payment	2134	2134	1874	1	1	3741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iY9nGnnHEAM7AU7BkVXGcN8RtkjZtWQiX98MPygiNxCwZz1k
33758	payment	1397	1397	1678	1	1	13249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQELnEjw5caHaLuUK3FoCtV9ocD2mneqS7UUrfjUWFq3CoSznL
33759	payment	2134	2134	1874	1	1	3746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5oCpGiahFE5KvAPRtPWaHRzazaduCNp6SEzKBSvDyx7zfNpx
33760	payment	2132	2132	1874	1	1	1052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2YgoTxBjK7QijLwqJe4ZfixiycLtYRyy54DjBmMXFtgmxtaH
33761	payment	2133	2133	1874	1	1	3657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBjKxtAMSdBAaA3T6B2MTviGiSNskEXib6Z9gPK6AjCPjNUiv
33762	payment	1397	1397	1678	1	1	13250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tfgK8ix6z8NcMyQPc1d16RUz4QWVnpbX5WN2CzZXXNcyJCHv
33763	payment	1397	1397	1678	1	1	13251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiHvEnc54wp6Mo1CrYh1mx9BG2vKFcB6xuRThaCVmXtUeBHcH
33764	payment	1397	1397	1678	1	1	13252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PE7foJwQ7ue9xiTn6esot9sBgxA9HAZ5DB7NM58qfExzDGmP
33765	payment	2133	2133	1874	1	1	3658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPALAToQ9zwFz6t1JBdJwqyZ9oGt4tZPG9q2oaZ9ymRfFUbLi7
33766	payment	2132	2132	1874	1	1	1053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRMY6s9bHJvxC36ZQMCLSzcTa2YDRRvyD4CeE6u2a3x2XKBxm
33767	payment	2133	2133	1874	1	1	3659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvGXULbgAxCRSuaKUS4JporkEPVtX6wi7RyJXSQZajp3ZE14q
33768	payment	2133	2133	1874	1	1	3660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYVBVrjSFPsxFPSVUH37zgqtbuWyWS4hiAy97ujkf3HbUFbPT
33769	payment	2134	2134	1874	1	1	3747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4kjAQyDnDB5WScrnKk5CEvXzLhzUmqGjMdVokiv9LvaELgwR
33770	payment	2134	2134	1874	1	1	3748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdMtB9RRog6bjLjvCXQiLf7NMFyEjFt6SE3tVvpvCqCmq8W6a
33771	payment	2134	2134	1874	1	1	3749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTvd3DCCRLRPwtDNefvbhs6CAH53rbRsHgFkHk4JMiYmnjGuf
33785	payment	1397	1397	1678	1	1	13257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16JNor8kpcH1txQUfCrwhqE9UtkpbFw6mKwAPEs6jP4ECA8xJ
33786	payment	2133	2133	1874	1	1	3665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7A6wGyKWdHQJkhBN1RSLEAz3JZ9YWA7PBCh2YCTE3UrLcgQGM
33804	payment	1397	1397	1678	1	1	13263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmb86oFKsG8F2ZnDenLLy7ecXB8UDG2XkV3qVTHrheXKRM3LBu
33805	payment	1397	1397	1678	1	1	13264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVey24nn6SWQjMDecVYRWcvf8LqmRGrC2YuzGUWNn6Mg4eh6u
33806	payment	1397	1397	1678	1	1	13265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgiSYfG92b4GPygkizAj19UtZHidDw5z2XNxomJVtG6Y87gmd
33807	payment	2134	2134	1874	1	1	3759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89iJp4tFHbtBz66N2ry6TmdmBJf5pZNDzCK7teVD5LhajQJA1
33808	payment	2134	2134	1874	1	1	3760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDoV4iNSpXhv4EcD7icn154kY3QzhuMFyXbfe4mwmzHSix1Tv
33809	payment	2134	2134	1874	1	1	3761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRsLNtvopRsHWS9EPBYirVPXKcusKoZqc1JHyayBeGj8QQfufJ
33810	payment	2133	2133	1874	1	1	3671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdippo2pLeH6tAm1nXw7R6oizYxN6NP88LcWmF3ZKN27ejFHbh
33811	payment	2133	2133	1874	1	1	3672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKfwYgX44t68ESUYmTN4p9AMGRBdbis4VufFuQk5bPYUXrPj3
33812	payment	2133	2133	1874	1	1	3673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoei4SoStAnVQDx9U8xn8uPPtCRYiZWtbe1FNDe8rJn5A781h
33831	payment	1397	1397	1678	1	1	13272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVauRAd4xJnhb4vNCfbMXuKKmdp89DLFBmZ1zcMyPLADt13qC
33832	payment	1397	1397	1678	1	1	13273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvDFPMixPTdN87UAH2UfLJpdWP3jBaskFDfmLC9jpcihPB7io
33833	payment	2133	2133	1874	1	1	3679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDBh3Y21owpNiAEmEa9QzB46PMtWkxbzJdTQxp5gKTpV5RwXs
33834	payment	2132	2132	1874	1	1	1059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxzbxeD7jv52NNHtLcvqWdMi7tKRzVp1Qdv5iVGWiS4PiKrAz
33835	payment	2134	2134	1874	1	1	3767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa331BDc7FhohMWJHqA2bg53653qFhrDEaybDVKnZco3h7ZfK9V
33836	payment	2134	2134	1874	1	1	3768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2srVimVJNvffPKTwyt6Xy48aVnvsXT94hcoMWYsbGYzmPtqh6
33837	payment	2133	2133	1874	1	1	3680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANY8BVKVQSJSHbELCFzF9FG4Y9mEVty3gZ9rYVqrAxGYTs9V
33797	payment	1397	1397	1678	1	1	13261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYa15kfQjEnbDuLEEFk8YpiaEMneVVy5PFXuQHoCM3jdPnZ9V
33798	payment	2134	2134	1874	1	1	3757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yKCGRnPdr2zYahFoX1KTF3jnjADMGBo3gUnY8fq9zGXCcwuq
33799	payment	2133	2133	1874	1	1	3669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6abh9FG87ot5Lvh7zR5LftzANyZmysbSjUG8251nAqBfAPmx5
33820	payment	1397	1397	1678	1	1	13268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8H3YNJCNGaK9AnJS9aTVkt3q6koPCnojBrPVB8pLK8EWyYq3
33821	payment	1397	1397	1678	1	1	13269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7qKKXpXrgVQkBa1th3gS311EwNExvpqrBEHaAu3iNqWtHasg
33822	payment	2134	2134	1874	1	1	3764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6ZW273zeaKJUY9cwNvorPmfKkM7bYMftZQQRu9JXGAYF2ig4
33823	payment	2132	2132	1874	1	1	1058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYkeLQAVKnESDGRKXJpXAGr4ihhLiiqSo87sGSx7UMDrDhH6f
33824	payment	2134	2134	1874	1	1	3765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw368SaJRjheDpDtYvoNBrSiBpnDmjGN4Wd16doXtHX6E4vwoa
33825	payment	2133	2133	1874	1	1	3676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmkJjfFHnj8fDqFMuBhgXqYkiJrXvnNg1yx8TE1Zcf4XcyfAT
33826	payment	2133	2133	1874	1	1	3677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEY4XvarUvwKMPF39EQNS2oZztQY8xKhZe7aP4W8Q9NF2fmD6
33841	payment	1397	1397	1678	1	1	13275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTymF5njZC3eQ3WyyuCHUhUap31k27jc8dJRZyEo9SXG6Ezsc9
33842	payment	1397	1397	1678	1	1	13276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mAtKSWyUz1jNUjpFahRTUEmMiFnEkh77FWpMi82DnATnzszZ
33843	payment	2134	2134	1874	1	1	3770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLuhMxWgarBDGyfmzYB8i2APK2WvPCKpyE5WHaTHU5xFAYBa2
33844	payment	2132	2132	1874	1	1	1060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQcbvruQWd2CUtA6BkaEfxJdX2QN5pn1mn4rae88x1E7tgKie
33845	payment	2134	2134	1874	1	1	3771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeAdk29KoH4E4g8hE2bDGTJErhG9AZ4pcR95oUov2dfYikY92
33846	payment	2133	2133	1874	1	1	3682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoDgfYXJZp2w2wtyDwEZjWZYp5JQT3Pa1m4ZSkEqcTpgnDUjE
33847	payment	2133	2133	1874	1	1	3683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7UMiL1BbkVNSijWhThEfTNWmiZwEyBtohoib6G8m6GXkxuk3
33872	payment	1397	1397	1678	1	1	13284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9e2GM7hvF9Up1VqbbWXRhLMi29nWudYqVNUcxj6TSBkJFQ7b
33873	payment	2134	2134	1874	1	1	3779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt599Uy2MSnXhJE5DFyucxyo5zPqr8BXPyz2n2KY96CHB1f9v9
33874	payment	2133	2133	1874	1	1	3691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTpjsB2dggEGqkVK2MfaXJafCtX3FtWmqxhjwMFr4KB4kGZ1L
33875	payment	1397	1397	1678	1	1	13285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttiLZif5qX2qXEW8YMi68MPsGkRsSgambfcSU8PEJqQ11cf8c
33876	payment	2134	2134	1874	1	1	3780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP9mEGHPrD6KYES3AwmTJ8Dm9Hy4HwEToTiSXN2rT9D9i2yTW
33877	payment	2133	2133	1874	1	1	3692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1t4qEPdm7WJUeUf5Vm6sHyZfjEyESXogrPE6m6jo2wLYhqCz
33888	payment	1397	1397	1678	1	1	13289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M5C6GDshpZBifRfJ5CGV3jfSY83mieWpvYt1HZ1DBSfr9355
33889	payment	2134	2134	1874	1	1	3784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqr137WepmBsLEic83qar5TFyWMrQdj2AHH5kypBtyVZjWaZEg
33890	payment	2133	2133	1874	1	1	3696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgyaJUGqzbZrJKXBD7XgzmA9XDsMo4xnPTrakQToZYnVHzVq8
33891	payment	2132	2132	1874	1	1	1064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yDyhdvQ22ahiK2Lqc1GgW5JFPijzv9Mjt4r38xZ4tQKDtZ84
33909	payment	2133	2133	1874	1	1	3702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqneUJvLXfkAWsd7oyrwjJS3PdoHdtqscv8s4xqT7R5fJgp4V
33927	payment	1397	1397	1678	1	1	13301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcz2WRh84L5hzTmJz5E9RXFdYBCDKWdpRiUyg5DmjD4uFNhLR
33928	payment	2134	2134	1874	1	1	3795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKiMT2i2uKYTbtU3FYYariXw9jDkFNa8TciK6Z9EABnMFtNqr
33952	payment	1397	1397	1678	1	1	13309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUuPmvqLbPm1fKd6iYP5Bq6FHJkZzeEoEr5t7jwMVzY6ELrvt
33953	payment	2134	2134	1874	1	1	3802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKHgn4EWmrNDw5Ked1B7wuT8iaCpB3B9DP949pXjQiquMoT8a
33954	payment	2132	2132	1874	1	1	1070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kqTJcMKoK76LRCpWc3ak3kBkTSo1w7u4LiJesBoSnMegjBrz
33955	payment	2133	2133	1874	1	1	3716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqZnfNETMatq62SEE2WATU7PRhmjS5b7oY4NWK3v4p4kM2pb1
33963	payment	1397	1397	1678	1	1	13312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMzPE29RRXEn7Bkp9ZAPFio8bzPtux4azDvQXnAwh87yh2tpi
33964	payment	1397	1397	1678	1	1	13313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2m1NSwCrf3AAXZvNbxzyJAGkGnfCFkj4LTyH9zd1prMNYCMbG
33965	payment	1673	1673	100	1	1	11	432510000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZ2vJHESNKMi3i6S7gh3fWh7FVMfMP6v4tG2dZ6McK1ohVemMPP
33966	payment	2132	2132	1874	1	1	1071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAab41bFUReEstWqcL6AqJSkbjUyL7MRWmS1hGDTNQEKn3gyP
33854	payment	1397	1397	1678	1	1	13279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4URUoXkFZgRm2eUwNBP7yZD7xLSj9oMzuRSjPt8Kfg7TEBuV
33855	payment	2132	2132	1874	1	1	1061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1GBw7rHDUsAro3gxJeMPy3ijREwcUHNSRDuL7dVMXe74NMMW
33856	payment	2134	2134	1874	1	1	3774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sFfbpyJbeftfugM6AYQEoQNKyb7MjCtSUGzw6jGTedSmrX7H
33857	payment	2133	2133	1874	1	1	3686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTJD1gd298a1G5UVckF59peREeybUpqQQ528Y38T92iscd2oC
33865	payment	1397	1397	1678	1	1	13282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3p8GMHQCkrkCtBvmQ74URux5sbkpHq25SBBDaqV6LwQRRR1Na
33866	payment	2132	2132	1874	1	1	1062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8AGRWexmrX2MWh3NX4uQBUL2vv1SeEUpsXq7gNmq9G1fvYes
33867	payment	2133	2133	1874	1	1	3689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkRSBMkHD699SH1L8bRUJFa9JotD95Wuxf55MEQXTcCN2coSV
33868	payment	2134	2134	1874	1	1	3777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSUS3DpAK5CQfvu8HGnnhq4Fkd8Ct7CRUVsEhtpUFCLrTM9GF
33878	payment	1397	1397	1678	1	1	13286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXY3RwiRAvzn8VZjDPZ8Wjui5ia8iPm8VW5Lvq7diRkk5eEnx
33879	payment	2132	2132	1874	1	1	1063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZM79LyYyLCJqJrgeyuLiqxYDnSiW2jv3E34fmLyD7mXrQe3tB
33880	payment	2134	2134	1874	1	1	3781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjQwE7wEYjjrTV3XGd4mtHXwxw6zkK9fncmXwQABsvGczSnZh
33881	payment	2133	2133	1874	1	1	3693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKCf9UANuG8J8q2RhKDdnTHtaGv8PXiaCmT1SHr1xfgbguwc9
33882	payment	1397	1397	1678	1	1	13287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQVmAvWQD1pqfDLfgnAhpH5TDn75jwJkY2rrPaiPMijvGeKqS
33883	payment	2133	2133	1874	1	1	3694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKn1gzKRoXpfDFaFHxATBj7eXkdtexvckVxTtTQLK7eXZ8FMP
33884	payment	2134	2134	1874	1	1	3782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4jjpgdi6e1arBCYCCaL9h2pgJA9E9z5BgbndMRQfJ7RtNRHN
33892	payment	1397	1397	1678	1	1	13290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQXszocNUioeAyMEvpGenoDjTLPcapKYSSTWA3bMvPHUiQh4E8
33893	payment	1397	1397	1678	1	1	13291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RqYuMVNVsvMhKHhQzMtUQR7zApeBD4a4Uns6QUwz5he4M7Cs
33894	payment	2133	2133	1874	1	1	3697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRnuf5hvYymb5ukiJWAweS7MBeuvwFNq1kq3V8AaGSwh56sEF
33895	payment	2133	2133	1874	1	1	3698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmznSSCPs4jfJpSrrSQVgr5fdVE7q9ibMGFLoRy7PgnQYr411i
33896	payment	2134	2134	1874	1	1	3785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHndLjXsUK696u3u1vGKy7xdXqnWNxRopeakaGyFDH7PS8X5i
33897	payment	2134	2134	1874	1	1	3786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKi2JBUzGAaoU5L5i3SNCis2aHjSqiuE5yUrCn7WsM2LzMx3gY
33910	payment	1397	1397	1678	1	1	13296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpoPe2zV6NhQ2csw72eUyGSAxUNXRmot9dq7NX956VYVTpkwd
33911	payment	1397	1397	1678	1	1	13297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBkjDmeXD2Wd9JW1hGDWTkR39qb1GE64skuG3ntCS98zpcbQa
33912	payment	1397	1397	1678	1	1	13298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG74RygXdZ7XPJ6XkmVvFW6oSqQrN886AqUUYcvdmCKnmS7Km
33913	payment	2132	2132	1874	1	1	1066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenWmt1W9xcaqxBWiaShjdfKAXjfqnR2SaJ6JgfCffu2pbNCWC
33914	payment	2133	2133	1874	1	1	3703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3e7N9cPTN8LtNYtr52ZftqUEMh26QhjLhFKMvfCYLey8zLGvM
33915	payment	2133	2133	1874	1	1	3704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2ySJpLvoYrrU5XGPXjFRjN3mKB6hrUFKvhKHiVxpcric85nJ
33916	payment	2133	2133	1874	1	1	3705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozBe5vnDeqPfz6kpTpVjMLPHu4SPnvCo6PumndGZT9seGgrUL
33917	payment	2134	2134	1874	1	1	3790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTeUz3Bw5BRXhVZkMSay4bgHHtywQTxAKJXemPQqNm6jc1SQr
33918	payment	2134	2134	1874	1	1	3791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfECgygZCnUrHhQinaYpYsU4fW9BdKPEs62Ttz8vTPR1WtwaJs
33919	payment	2134	2134	1874	1	1	3792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DU5RmVDFdAZW6UJKcZBY9HJ6ttG5QGPemnjQ2Z12vPVmmNet
33920	payment	1397	1397	1678	1	1	13299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYay4CYRiY3Ju8sacUB8onVxGkjRev2NxotTv8hhf5Ggb2r1w2X
33921	payment	2133	2133	1874	1	1	3706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7moTc68E5YX8pPQ8JjC3MpTtKu9dE7FshTEBY3DjPyqpvPteQ
33922	payment	2134	2134	1874	1	1	3793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMNTUBX1FJcW8RhUygQapPK94hETMXftAchdokDxNv7F2244X
33923	payment	2132	2132	1874	1	1	1067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rhngm9CMnuz4S5qmthvtHcL42M8JXaFGV1WXAVXwcwFQKrdh
33929	payment	2133	2133	1874	1	1	3708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpxUSVLsP8UrTcjuQ2bcqR18QYTRfMYtS3orK9FdM4ijf6XgX
33956	payment	1397	1397	1678	1	1	13310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRXif7N1kY5xA562tv6TYsXewWQLr7CcV8DkBGVmKxmbEYzBu
33957	payment	2133	2133	1874	1	1	3717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrn9jUXJs4SexoSnaJRvwhxaeir13vc6a4CDcwCT3YN7D5CAkX
33858	payment	1397	1397	1678	1	1	13280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaYAT8sJqEdpW18UCdHyi2EWw9vA1cDDpTWUjWXkQD5N5dGXC
33859	payment	2133	2133	1874	1	1	3687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDSoqhv83XnFSzmNdAc8aqgnti2yBCznoaSbDbk7KVGLBdTvQ
33860	payment	2134	2134	1874	1	1	3775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosrf4JvpZGx9ucrh4GdbShCJKc5Fycj4dHY3KTCTSgP7Bbeec
33861	payment	1397	1397	1678	1	1	13281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaBWEHUBDeFjg4RRaBD8i3vf4afnDWZASPNZ1Tv89fEkVryj
33862	payment	1560	1560	2199	1	1	29	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbTPTUfSmokHjfd5eX6nyUfsgsv87SaDy9hzRhC62dpzdkjgR
33863	payment	2133	2133	1874	1	1	3688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi6SAqgwHoS7gSWjaG87PSPnpBNpYb5ScpReaW29WD4Tmwoni
33864	payment	2134	2134	1874	1	1	3776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUAB9Gy28sT1WJKk5zjWdaDfTQWsVqjhxTG3GRGbE9xpta5LY
33885	payment	1397	1397	1678	1	1	13288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtH7FLxHAXjVi3cwr2NzySfY5EuESCzwUgAzNCaKHMpsKvQEKQ
33886	payment	2133	2133	1874	1	1	3695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmrotGEGaP2E9q7XK55uRLALdPuUgypUx1KKAmvWkBc5ZcArY
33887	payment	2134	2134	1874	1	1	3783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nfiHwSFkerHNseCiWgdNf8ABAza12EGLCgmFKHneyggwXVMZ
33898	payment	1397	1397	1678	1	1	13292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLVjCnAvHupXiBr1bZdCUcg1LC8d2bxisQeeReLxfHFyggcHA
33899	payment	1397	1397	1678	1	1	13293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHCXN56yJBLjTLHR6or2F9cguacLxqFner2fhVtcFkbQ4QWSV
33900	payment	2133	2133	1874	1	1	3699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGKk2Cvvgk4cqCPMtQcKPfs7kd33Y74osfr6xPmVA1Qtr7eCL
33901	payment	2132	2132	1874	1	1	1065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsGpMDdAE2VCyFR6qFj5akj9PbGpkXQoWJqkcLMWS9qQFkZo8
33902	payment	2134	2134	1874	1	1	3787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3i4QXU3qd7m8Cmf2t7cVtRyueK1iQRoQDEwV1VhScTBN5k2n
33903	payment	2134	2134	1874	1	1	3788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPAmNcVGZsYjVP7sfxGd6oi8wzLiuCdZtVnNWsoy9oBsD5sKG
33904	payment	2133	2133	1874	1	1	3700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzkQB9wL7vXHqCfFVtkZcNGZu3sUvAhV9RN1kkG82DrbwxrSs
33924	payment	1397	1397	1678	1	1	13300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnZqsVDQ9qtEnA5RbdsYW8vNYBrS51wMv7Tve9DjEM84hFHkC
33925	payment	2134	2134	1874	1	1	3794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNcH9oFHtdH4kxuN3GY8GkcQHtZb7Zkm9cptf7p1xaEEeotnD
33926	payment	2133	2133	1874	1	1	3707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBJ5wBihNrRNuKpT7nyWtXQrwY1vzajM4K65W4SmHPuaeRShr
33932	payment	1397	1397	1678	1	1	13303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh3ps6Jph3UKXRrLFvSCwWcrPXZApi3YhdPBZBHt2fDfLDbiH
33933	payment	1397	1397	1678	1	1	13304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaznCt37ZnKoqYKgH5o1rNjKtziHFgTKznJXnbaAhFaTJcRgE
33934	payment	2134	2134	1874	1	1	3796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdetSsJEoXoXcpMaGhi1DTGLfWHGSbbRc3CJs3NG8FKgTGfBhK
33935	payment	2132	2132	1874	1	1	1068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEMHnk7vsde6gBJ6hnTCuc4pyhNBD3ZpvgjUWuxSpAeatFdgb
33936	payment	2134	2134	1874	1	1	3797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPjUv61v7dnxB4ND5ufPnUgNQRDnPP66sqfoFpRi75q7SBzon
33937	payment	2133	2133	1874	1	1	3710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs9MCatgrsM9HTqR4Xq9Rc9vfYUG3g5nynVUmAy8ko73wKU6v
33938	payment	2133	2133	1874	1	1	3711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XSLQ7XnFVaXbwhVHxUMkVBghRFSuFQJAJNKCRjTogyv8XDva
33946	payment	1397	1397	1678	1	1	13307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKZhjabbD5LCkKD87BNXN3Ef7QvPngR6XSmHxfKkZCUdtU28J
33947	payment	2134	2134	1874	1	1	3800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHrUGHnzjXEnshx7ujxBsXhB9axA3YtM8sukZ6vWkW2zE4jb5
33948	payment	2133	2133	1874	1	1	3714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKUCHCxgyGGYTPT88kmgFQCLzavg5GMwVDiHBW5Mewfh3RkKk
33949	payment	1397	1397	1678	1	1	13308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmAuvN3T3nprsacXqPW52eqEaETsPdqYAfRTAqy22EfQzBrAxw
33950	payment	2134	2134	1874	1	1	3801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfJWtXCgW4C1wunTFm42YHA2NQcwVhfDoGtQ1buMheVP1s6hH
33951	payment	2133	2133	1874	1	1	3715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrPptuqTPDe9qDgoEuhCqEtYGbNQfdnToSQVZZX7MDTRy4W1F
33977	payment	1397	1397	1678	1	1	13316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmo67DfNFn4apxNnoKrsoiizC6r5Y4yDnRzmqSFojkTE7ikNx
33978	payment	2134	2134	1874	1	1	3809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLDKFxikAV2rpR4fmtRR2iNDdCTRbfrVkVmmWhiGvSe76Jbg3
33979	payment	2132	2132	1874	1	1	1072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWsLu5wqw5Dhpc3Ct9VLkjbQpPBnRctbNgUWg34nYaThkRMot
33980	payment	2133	2133	1874	1	1	3723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoYv9kA3o5KCZ21FPfE16mh252U2NDLCibh748Xuur9wmW5MS
33981	payment	1397	1397	1678	1	1	13317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAW2ZnSNzhWGkEuqRK4exLaAU8BH49WdGJ8k9DtkFnW5onrou
33869	payment	1397	1397	1678	1	1	13283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQgfACLNnozJYTZs2FMo96bL7FerTDynbtVDdHhTUYpCLFQEH
33870	payment	2133	2133	1874	1	1	3690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrwL6M9hGoWg9HipNAmqGHzqHfzz1AytJ5YRWhq5b7MUX89Zf
33871	payment	2134	2134	1874	1	1	3778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5ujqLMKDLGcaq5ipNTHDTYnnw88iuqqrfMfpiZkY5M3FUhCE
33905	payment	1397	1397	1678	1	1	13294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoU6AkbS9e9XBKAoptzfsg5tA64Docnbfe9Kho91inejvdKuqm
33906	payment	2133	2133	1874	1	1	3701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRkyjD6AYGMxS1nEcBh9oasWE9tvbEWhqFfju2iJ1eYrig5TF
33907	payment	1397	1397	1678	1	1	13295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbn92ZMcaCKDJY5hgGfw82RhndfNdo9XXFfomPBbCwfwuapLot
33908	payment	2134	2134	1874	1	1	3789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5VgiRhh6oxCgSN4jeH8zQgdHnbURucvgJr7ujWNwb7QX5edi
33930	payment	1397	1397	1678	1	1	13302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWg6eu3fF8oX861DhCV5uj8t7EWqVGZasNWqZsZodkXUjWFUn
33931	payment	2133	2133	1874	1	1	3709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaupke4JHqDVpNe5arNL3EShTFrnejNvwP7gTSfw55uZSGDWu
33939	payment	1397	1397	1678	1	1	13305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3yt1GX1mQf5FJD7w8J6i7mTqcgky8c13uChRUw7jMryBj7Lg
33940	payment	1397	1397	1678	1	1	13306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGy7vPSAg6ZvWt4xB1nTjqrmst9couopR9zjs6TUZ8mX6WbC5w
33941	payment	2132	2132	1874	1	1	1069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RLto7XHVny3awnrS57axHG2uvKwPLENrpPLSHkn9Hgdzfpb3
33942	payment	2133	2133	1874	1	1	3712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmi2V3aS2cs3QmmhDCoGaadQ4tbmfAdNMzJWBPGYPGnGgBA8h
33943	payment	2133	2133	1874	1	1	3713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5Sc2AJSZUcS3j8RRZPy4WaqSneHSofusc8SySzR4kazNUr5u
33944	payment	2134	2134	1874	1	1	3798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9C3otBaLhGQQ2MUFEJhvk3HPAvvNgvoR1bGjcPbRwsu6rHvvk
33945	payment	2134	2134	1874	1	1	3799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5G5p7CEX1h5HjMebXMvV8BHXfXiWtYtR92WoVmo2oGs2pYFZb
33973	payment	2133	2133	1874	1	1	3721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhdJdeWegu8XXyVHQ4ZLGzs6ZonNLvEvXUVsrXJbyJ4zgi4Tv
33974	payment	1397	1397	1678	1	1	13315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaR9GrxKwwupoRa3Kfgz9PGv35LDupf3Gn4bLrVRcYusRjaEDg
33975	payment	2134	2134	1874	1	1	3808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hbDwrr9gCCPqpmm2791TvdQccdsvou8eXK3AUgouTPURd2iq
33976	payment	2133	2133	1874	1	1	3722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDambnxpFeKNq94RSFAaLNMvFgGap68te1CsXEA5PvJVGNVSp2
33984	payment	1397	1397	1678	1	1	13318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5Daj8FYKxn3kUF49GTT1s8FGkmUk2iAeD3QwZhoTiJZ79swy
33985	payment	1397	1397	1678	1	1	13319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv2n9AoAGqEw3W7cybehXYY7oriPG5qNLMkq6HrSyEoJBfAzP
33986	payment	2134	2134	1874	1	1	3811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvxCNxnDBWfiF26UkMdNeCCDbKm5rsMvoxPhJQ5e449gjb7R5
33987	payment	2133	2133	1874	1	1	3725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAsYEzWdMH5CgdQgjhX6P68rVnDKD9hafRDurM8Q3EvWuXfu9
33988	payment	2133	2133	1874	1	1	3726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF86x87wt8aXZTxkubd12YrzZQ4ArPqPait9iQPCmjm6XQiNSe
33989	payment	2132	2132	1874	1	1	1073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegt876EUvQ7UsFZ6WBocdWVSZXyhkcZX6v2uSK7Y6esPSu8iY
33996	payment	1397	1397	1678	1	1	13322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHZnFFE2JpbSngC4NWr9dscmmxPMZMrdiR6mi99rbmbUuQSfv
33997	payment	2133	2133	1874	1	1	3729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKb27Hz9josgsVwqxwRgmHMbGNXbuvMjowMTvEs4XbxBgpERh
33998	payment	2134	2134	1874	1	1	3814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYbmeJyX7UMhZCkEcRZmEsXn8S4sEj6R3iTTFZVCacKXmyEiq
33999	payment	1397	1397	1678	1	1	13323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgywLWjBJ6ggK6x1GPf6cfTUgkPRdmudLJ6pEcvohWTZV8j7b
34000	payment	2134	2134	1874	1	1	3815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBJ5cKQq89Zf9sZ74bvnae1he8A1EdqUN7PxFektLB3s4bzEE
34001	payment	2132	2132	1874	1	1	1074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUT6PBDgv5Mv6sHsiWt8RGEzFYFX4ydv7YxJfB6pUSjzPqM95
34009	payment	1397	1397	1678	1	1	13326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBA6joWVeffSHgF1SXUywTHwjcaZ3RssPAEKm4a6MWw39mTC6
34010	payment	2133	2133	1874	1	1	3733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3h5PDXpFoyXmcziqtCvzv9o53RGuaRe4sEjckSz9ATLCRrbs
34011	payment	2132	2132	1874	1	1	1075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQe2HA2jzhTGQGeD9eL3gmw6aTns3U3HC8jfV1CqX3d9x6TXX
34012	payment	2134	2134	1874	1	1	3818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcubsS3dN4cjPxUaQxjWHtbDwxrsUP2VfS2hSS5eSwKN8NgCj
34015	payment	2133	2133	1874	1	1	3734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad4Ghm77BWaEHMWqMm6NTNqwZEbRiWnChXyWDq1S9EqZcdYBn
34036	payment	1397	1397	1678	1	1	13334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sn3n46hvmycngQCx2swPfzYToRtbYn6a42vh7jww2DVzv9p2
33958	payment	1673	1673	144	1	1	10	432510000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpaEqpnCud3b9qgUDXXDuGY8gTd6SWxUbVeKd9mQB494bkuVFcJ3
33959	payment	2134	2134	1874	1	1	3803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMmr4kvmttwtiM7dW9mpqB16ubwPESj6J61Lhag8xzYuBUek7
33960	payment	1397	1397	1678	1	1	13311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31oktBkxXxbkiA2M651y9Ldb2msZnpYYE6FxvYD5JBBmGYYR9
33961	payment	2134	2134	1874	1	1	3804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnJXDy1HnNvmrvMNBMraWZ6w8XpE9hgyKY4doRQH7C6cu8Bbr
33962	payment	2133	2133	1874	1	1	3718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk8phPn7oPb66UTVCbvkakWAxKxRKQJXBvWeyjyCtxiNaqTQC
33971	payment	1397	1397	1678	1	1	13314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnT5HBjucSGb61QQyhGC16riyeQeDBsN1dCHmprjT4ToT8tYg
33972	payment	2134	2134	1874	1	1	3807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B3VQHRZ69xDRwGsumTwZ1sT3MDNqx6ewKm6XEv3dsSckgZuU
34002	payment	2133	2133	1874	1	1	3730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbkV3YT9ZzsismpQUMKxjiiJKkgfoEbodjnT8tGGPNvRYCFT2
34013	payment	1397	1397	1678	1	1	13327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1kHpWLFZvqbpnzTrXx2uSZ7vgbCXn52PYHddkwpFYqUPZp4h
34014	payment	2134	2134	1874	1	1	3819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnAyZ6r2Vaf4YkZct2omRZwckXX1hJgZo5oakoqhPxRWL3SXe
34086	payment	2133	2133	1874	1	1	3746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs25AdFaB6zMnYqVMZeSWiQ4BFU6jSKBt9EyDFzSkjGPd2KZLD
34105	payment	1397	1397	1678	1	1	13342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvbtJEYjSqMv2MfzKBT9DRDFs4RUTCGyeaXityrwJogizRocJ
34106	payment	1693	1693	453	1	1	1024	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaH4ZEe8ib841Lj55JoNFAQSzCPptGywq8EtvB7qmsWeNwzGUp1
34107	payment	1693	1693	283	1	1	1025	46739092394	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaJVQQYypQ4R5igCRP99Kkfm8qr4ZJgV3uBYC5WxsMLLkiYWmQH
34108	payment	1693	1693	308	1	1	1026	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZBtjXGrJFyH5z9Rp1BKzPfBsdtT39U1HzxbyEB3wo2WejBeMWw
34109	payment	1693	1693	201	1	1	1027	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhaUUEbkUrsXExZ7617wuQbo6f7vTuvpXqaMd65QRdpXvLP8fz
34110	payment	1693	1693	748	1	1	1028	1418018119	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZEipPu7kxQP13dHahPE5vvwE7UBLUmw2aaJp3g8sobaWKNiUyq
34111	payment	1693	1693	35	1	1	1029	14861574594	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhdq9bXHw5koMESAJWtTjDDCzfGZcYY4KoSk5F4oa9E3Ruyeun
34112	payment	2134	2134	1874	1	1	3833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJMrr5pdinJRVS2G2VnuauRvk3vfAB6GXTnd9goSjmsq6K2V9
34113	payment	2133	2133	1874	1	1	3749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFBP2CJ2vD3yd7PKXJoXAGKySz9wmc2edNLpif94CsbjRinh1
34162	payment	1397	1397	1678	1	1	13350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwF4bHjQ5zAKnKeoCmFd8EktpssEWkRBaQzVL3WBvVpZvHa1Y
34163	payment	1397	1397	1678	1	1	13351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRL3vG9ruan5XtSW5j4PqFwDecnjwkiwT7LbxqiY12Ao2X1HQg
34164	payment	1693	1693	587	1	1	1056	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZUCWkvu23K2JCmF6KPP7jBXk9BPtiBTQKbhHRLMpDRZBFmmC3S
34165	payment	1693	1693	238	1	1	1057	46738858702	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaLKoKjzCxCAsS6f3Ax5yuVr5mk3SmwD9iDUA5QHgyXXKR36wWE
34166	payment	1693	1693	392	1	1	1058	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhRzVYkJuZ1vuMqBbMwXXb4MRVUew48dtDK26wpWyKDxUySxWv
34167	payment	1693	1693	578	1	1	1059	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvy2FibZcig7wwf9hUuWhyvgJZryyHDbtBAXwTSkkhCYTdy8oQ
34168	payment	1693	1693	408	1	1	1060	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa7ejgHAddDank5McAcsuH84WenB6XgdzoCckrhYzLyXwD9tGgS
34169	payment	1693	1693	504	1	1	1061	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa4W6PTk95DGPGeDgwoBn4scR5UQEQVroHELDXABf4cB5Ut2hXJ
34170	payment	1693	1693	611	1	1	1062	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa28qK52iHeBfi8b3ooAtrFDwSsZuSrgLgpegLFXv4rR4tnHehY
34171	payment	1693	1693	500	1	1	1063	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZCRrPmgD9UpECpZUx97JrrqXxE7Ak6ehCuzsNvmAMRgkKimwv7
34172	payment	1693	1693	353	1	1	1064	4148160270	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwqWbY1jEnii6A9suEoTbqWQ8Nrn2cxmUhD5jtuBTkf6Ad3tv4
34173	payment	1693	1693	301	1	1	1065	46739092394	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLpKMsRirikECnVzTPcg9HeEt77LAotFjWmrEpfrdizfrx6Sfb
34174	payment	1693	1693	601	1	1	1066	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYYtYsuGcRGSV8VxbpYzAhDdhQec6sq3n9pqLnhGY1iSbwsxogX
34175	payment	1693	1693	1276	1	1	1067	1311619300034	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZN6FqyswqoZuGor6W87mkE57EqvXnafmPmueeMSayakQJCqAMe
34176	payment	2132	2132	1874	1	1	1082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZQ42PcxzhBCmqCfziNMnMByBNHp94MviMNnYwkQ7jZsQgQLv
34177	payment	2134	2134	1874	1	1	3840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBRRZRkDPyKoDt2iVusyFFBqKipexDXQVuZNZiDtMyPVzmHjF
34178	payment	2134	2134	1874	1	1	3841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cTiP4Pq2M3dz61xL1YX3ySCxk98Kvo1URecZNAqYswKqGsPK
34235	payment	1397	1397	1678	1	1	13360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUCnqWCBVv4wJqnnWr3T2AU73HYQW6XtzdrGWB7ixxTjMpKeH
33967	payment	2133	2133	1874	1	1	3719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfY8jBwjaJELdzN5GcoW4gF9WgtUbkz734JioVeivwuppVyUQo
33968	payment	2133	2133	1874	1	1	3720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQFLryt9yWBfvrUzhm4t3zCgtPqMDQ2LM4uPFTNdJ9VCriFpH
33969	payment	2134	2134	1874	1	1	3805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZDfEkDYKSMYsjauQxWXsduENFgJoJ3ddD6LRXixQYXpoZfVr
33970	payment	2134	2134	1874	1	1	3806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqU6dHs4RL5jzPLGZburtDJ2J7xnjXtbFAeJBABpyJJ5HHeyd
33990	payment	1397	1397	1678	1	1	13320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAhfPVLAG3yMbZjC8ruHt77S2Fx6arHYUTL3g8132bkJzQTBu
33991	payment	2133	2133	1874	1	1	3727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbf1gtW67xy1vt2YhuYxvK5BwM2NVpqWKjcF1e2YFCyvrTW4a
33992	payment	2134	2134	1874	1	1	3812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8n78xSW6Zcn41EsXrvmUZwxgTGPfRhG1tw47eHjE1zvPJCGYt
34006	payment	1397	1397	1678	1	1	13325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16bvpADCt5gKt5RgbDypyBcSdtQL8y8CB3GEWc9ykibzQm2Pi
34007	payment	2134	2134	1874	1	1	3817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFNQmBWxPsFv76BcYwnY1k53rLjQuYkZjsVoupEGuTVuoSodj
34008	payment	2133	2133	1874	1	1	3732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4fSdK6WcxcrndfpWTvN5wickEgAnedQbB588uXHj6UyBsCEi
34050	payment	2133	2133	1874	1	1	3742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurbTQsJhX4e6AG9kcHUXwPfcguEx5pGrBSafdtNjDCa5nuMX5
34051	payment	1397	1397	1678	1	1	13336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WuEjXtnby168p2eJDR9N69wNgQ5oGtDA42SoULeTDmpBxCBq
34052	payment	1693	1693	653	1	1	989	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ8JRE3Yf7QSLMbQYzxdpAbJNAxV4JtdbcF2MuzZmmCvfN2iTwg
34053	payment	1693	1693	373	1	1	990	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZXa8uzewu1tWpsN3bXA8XBNw8b2G8upu9Tfh6dwDPZWC4S8s9U
34054	payment	1693	1693	92	1	1	991	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYfetP7mGwR9nuBc4RU91LmjzdyGWccbanomjoTaa9CnihkpJTF
34055	payment	1693	1693	710	1	1	992	3870201712	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaAJ68vQn9QxbRRABA7uDBxD4iBFn7fem8s9gRWv2v387DbGs2a
34056	payment	1693	1693	1961	1	1	993	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaBMShPUWaD96SDJZZMsMABNGPHnHJoAnSFuraaJDhbj8DQVF3t
34057	payment	2133	2133	1874	1	1	3743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyQYvuPQBbf8sFMFKfwuxWgiQKwp3vXGTZcXyKmjTUa7Jm6xv
34058	payment	2132	2132	1874	1	1	1078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtK6XyRgJHhJncgNzXxeTQMvBxEwGbinjQXDTrMewm1UwebsDA
34126	payment	1693	1693	225	1	1	1032	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsowkYgTertu3HFVLvmh4wNzCeobUc53EKuceyvLsvHNUUe7tx
34127	payment	1397	1397	1678	1	1	13346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn29mt7tJ8svsTcrEae9ZzQSJX2VnQ2M7ZyxBkYkZgB76YjWYc
34128	payment	1397	1397	1678	1	1	13347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEXzr7wyBTdxKGFz9AFPreTqtZmA9p48yjCwCCe9o3bT9d3y9
34129	payment	1397	1397	1678	1	1	13348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzZE9sEujAuCLFirasLwRUftDJFQHpmsVw9jemDVhrNEV1mwF
34130	payment	1693	1693	2164	1	1	1033	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa388s3DnoQw5A5CfBeLfv7cvZp3r6u3JzMiJ7UhGh4aYPT5hyc
34131	payment	1693	1693	99	1	1	1034	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYTxBzaJmgG7kFAuwLoXBwjzVUhByU9hqZFNmtFQzoFTJpjuvJr
34132	payment	1693	1693	206	1	1	1035	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZnDgRFPdfK5yM8TH7aRBm9hkA5vJEtDr5PWjwjfEXcYwSdx94Y
34133	payment	1693	1693	122	1	1	1036	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ8ggUS4jApDJHCVKKcwUnH8srhdw9vv1pfxxRmZt2CHfWKy6U6
34134	payment	1693	1693	443	1	1	1037	46739020166	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYwNpPb9P81zvTWRhFzPPCMVYZj7PoWAKymW2iHxAj4xWrK72z3
34135	payment	1693	1693	691	1	1	1038	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZYrkE1Geo8omRyhbfu1kBhk4cRhtch3aNrvp74JvVj8YFzSmMF
34136	payment	1693	1693	377	1	1	1039	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYzhQiaLoJ3ssqrPryCxDVHLpr8DwwYcst54H64gTBbWLa22CXR
34137	payment	1693	1693	49	1	1	1040	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZToRUmxmhqFbrNpFtFebTvXprdfS6XaSE3rw6bcMREySWCzXLB
34138	payment	1693	1693	530	1	1	1041	46738815506	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZR4oa8pTMQMQUR9yonyJMuUdDnKqEkqoGuozx1ZtiwFhMCfifL
34139	payment	1693	1693	893	1	1	1042	237493315876	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ1PCbrupVCgL4wBX9gYBtk23cfD8gfVYfAQEvqDX6jjSexi3Vs
34140	payment	1693	1693	54	1	1	1043	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvxBDhHu1sPr5gEG7jAcnjg2eQBkkSrro8JBuyp2gUvn3nVCET
34141	payment	1693	1693	217	1	1	1044	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaEsKeCXqr31SBriESLqBxHtWDDvZ8Bmkp1bG227FBRAPBaK9Qh
34142	payment	1693	1693	603	1	1	1045	47249337864	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYw4uDjdy5NupUgTAvQhb8U7c88BNHoN11jNYtW5bVupgSUHTYy
34143	payment	1693	1693	165	1	1	1046	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYe8qq9fDgE8ocixvpEF3SD8pN7xVicXFWKL5rE3yT3V3vhXkPu
34144	payment	1693	1693	194	1	1	1047	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsM9s5Pnm7pv1uzdAnugrLnEqY8xbMFjjkqS5hkjREtHn445c5
33982	payment	2134	2134	1874	1	1	3810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshUGhiATQVem4u1TYWLpKUm4bQxr1sQzTjsATipo2gTnE6oJk
33983	payment	2133	2133	1874	1	1	3724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwek5k2zcdRZBxnLv6ZCTvsBeRsZEQ7y8k6FAxRPTwbwwHjECv
33993	payment	1397	1397	1678	1	1	13321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vdc3CPi6yRT1tvTFSKefz4Dd33XZp7VAVf6NkewYBffM4NYV
33994	payment	2133	2133	1874	1	1	3728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVBhfeWbqmv8BGbGHfTfsQ4QD27wRB9xoBoJbNupzNHMWqCBq
33995	payment	2134	2134	1874	1	1	3813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5A5F7gejH2Zq6RuLBgJBJKxUyYAeiqKoPnuEPAkxQqZhV7Ymu
34003	payment	1397	1397	1678	1	1	13324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor9dofNpqKY9NUoKeG9tP6mHbq5oMbhC2XQdAVAK1ZRKM6PK6
34004	payment	2133	2133	1874	1	1	3731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTibYvuChx8n5Ykoaf4Qrt91x4fSp2MJZNnMvZoJtFS3xfxd8n
34005	payment	2134	2134	1874	1	1	3816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtPF6QHLdT4aq6ZNFCfg4w7gpV8ffHdfMnp6EiNQYMPRW6g4L
34016	payment	1397	1397	1678	1	1	13328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3srGKFoFpArHZN7KEkDXRDK7J94HTZotbmcz9fsy2fJFSquY3
34017	payment	1397	1397	1678	1	1	13329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoUSqMpiL8ekm4kHMzw8SdXhdeHg7Ma8vFYrNCkuxRSZ1NDgP
34018	payment	2132	2132	1874	1	1	1076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHmFJia1Haao32jhsK3sVNVWnVVDksJUYsdsWxVWMh53WjkKV
34019	payment	2133	2133	1874	1	1	3735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yQdi96N9a7Y2vkSvfQCDMN5HxPqzpEUojwTQNNBEaepGYnRD
34020	payment	2133	2133	1874	1	1	3736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY3rcN7BLN7pALzVJoqhBGNbc5ziUQsnsJAAjD6aLu2LcEvGy
34021	payment	2134	2134	1874	1	1	3820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMHRgQrjq8hkiH191dd4aRRfcD6a7Zu9xChGDEidE5RNY6E3s
34022	payment	2134	2134	1874	1	1	3821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzhcnm3FgZbTZqYP6jXvhXKxh2GYvo6XdJLkfm4dQtbfLMULQ
34023	payment	1397	1397	1678	1	1	13330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJte2gwcfvwgWeLqbDWxAL4eMkdcn55C1gjidTHCXc4XEsd3UC
34024	payment	1397	1397	1678	1	1	13331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1eyrTyYFCtby3GPnVfdrXPuLMTDxxDX2iLnXzctjAdhdmAuh
34025	payment	1397	1397	1678	1	1	13332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttmb9Fhx82B3C6boVWBhNbXng7WJcgGciWovy4L95T41aHHdv
34026	payment	1397	1397	1678	1	1	13333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKdbmnPgQhRfrshqdufjrfoaxXVVTDbCPpstLxgd7hsU3k65J
34027	payment	2134	2134	1874	1	1	3822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTksoL2a7E4PTHeroLfvbfmUQTgQ6f5iZ62s1gGmhxuDQQN1Ur
34028	payment	2132	2132	1874	1	1	1077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4kRGsWg5FhMnEUVR2AJ2taBTJHMSzqqTKfFZiQ31ejs4RtpZ
34029	payment	2133	2133	1874	1	1	3737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Mfq2uxvQau6QiehgMVqjtUdGBRCdhPNPfkLfDwyJUJnmgH2Z
34030	payment	2134	2134	1874	1	1	3823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8H2ZYh1KTALeh7q86gG4Hc7gmmf26hhpwmNw8ddXLzfHaNfqn
34031	payment	2134	2134	1874	1	1	3824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxd52fv9tzftFSbZnUkKH1ZhGLjKB8PbBdkYMmL8TjoiHowri
34032	payment	2134	2134	1874	1	1	3825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwg4rnPUrs9pYFyExQsMw8esgdYPzntw49teQNHWcv1dNpmKcz
34033	payment	2133	2133	1874	1	1	3738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZy4yjKFwYw9H4RaWjKXeuwsjGzPQfwbsQCws74uvJ8UZbHMF
34034	payment	2133	2133	1874	1	1	3739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RBLysNtQt7KWGZirXknmdygeVQnorte4RqPZixkcqWxb9rBV
34035	payment	2133	2133	1874	1	1	3740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdcNquEGiXCoDwy3qbbxQqGHsCaD7itUjbLhPDmuNVS6Ug253
34087	payment	1397	1397	1678	1	1	13340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXkfeaFdfb8KgBnpjvJmHTs9vs7JXavt2D5Yc2RYHRFa4uvn1
34088	payment	1693	1693	1962	1	1	1012	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ6qUT3ex3j98FfvVa8GJvbeJMwRQg6qU6a5Xum4TYnG1ACRFuh
34089	payment	1693	1693	63	1	1	1013	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZNue3dkJRWFt3WoJEFn2bKun4eQnPawdRf6fs1f4bU887aVTuY
34090	payment	1693	1693	1150	1	1	1014	470689915171	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ5C9t3tnqWzkFKoJUXKEUBSWfJeXN4YFs3oTLGBSy7b6tJAtvY
34091	payment	1693	1693	163	1	1	1015	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYdpDXksBQTexL6ZjK2WTtqEcQAubGsv8zEhJ43ydUB4hyyDH17
34092	payment	1397	1397	1678	1	1	13341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrKKYhqpngS5zTPCJR91YDegZmAAgZkxdj2KT36Bivzfa2Fq3
34093	payment	1693	1693	78	1	1	1016	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZjbpYc42WCosHBS5dGJFxGtF9X2W8tkjZyJNANLinFp2NcDPHt
34094	payment	1693	1693	678	1	1	1017	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwUg1wVDrnw49G7odqZa7jUyqCnL9dE47Dr324AuSAvK7qy45D
34095	payment	1693	1693	108	1	1	1018	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYe1vyjLW6BAQmmjjfkHt4D9RGtpYjFjE7qhcgyBysTpPDunodr
34096	payment	1693	1693	745	1	1	1019	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYga5XwWzHvzQ3KG26NTUjWSTHynTrgWakWC8Lcto9REZbFSwaR
34037	payment	1693	1693	2181	1	1	980	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa8V65AV9bNK4m2LqVCPgDutF1GyDeh1bdiSDrAnYjYpgdJoFLd
34038	payment	1693	1693	438	1	1	981	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaA7XubvNizJLpvDmADnkQ2XT53yDcd9Evout2X9Dh4uw3tw9hp
34039	payment	1693	1693	262	1	1	982	46738815506	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYjkqo21zJBn3D6HLeMrCPMHqHanoULqoenJxyeDMDVeW35mvUR
34040	payment	2134	2134	1874	1	1	3826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESGwmaY6msrrimBz9v7phdNVKKnepvUTWaaminptQCjLbQyEh
34041	payment	2133	2133	1874	1	1	3741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6WWCzQH1tkitXUZUaEffF953aY8hHe6ic3eSStwA4KAHXQox
34042	payment	1397	1397	1678	1	1	13335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDddinFzM4c1rDZxDc6UL7Pp5bGEqbmeprAcXYJQKJC2ZPpEr
34043	payment	1693	1693	240	1	1	983	46739524375	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwSKPbpcktzfDDottAhe6Ut9dD5bMNHoArNrD6oQGMfK5r32uw
34044	payment	1693	1693	304	1	1	984	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYftWY9x8h8LJetGFMYj1qJ6rMaStqYQ1gNNJQNRmegERWySMKc
34045	payment	1693	1693	562	1	1	985	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZSFAYdLdLzsd3gmgM4swzp9NKcvNQQetKoy2wZnpxGKtsBi5GZ
34046	payment	1693	1693	560	1	1	986	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZHdVXr3ZqbS7MCrn31bQLqSHHjTpTt3cpcfVc5r4HV3DdqbMNW
34047	payment	1693	1693	441	1	1	987	46738752480	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZqJaXUbJpjVrx59a7cGjsoMaxs13Lvjvi4ZXR7zCVvTUzQyjcR
34048	payment	1693	1693	1772	1	1	988	366855802461	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYVf2KSAikR5o6ByPSgsuizoNenR4pCYVjQUFh1g3aPNGaKwpmi
34049	payment	2134	2134	1874	1	1	3827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86j2ypGRHc12vRGaxWCicQ8LEKq3mEP2C3xfvTzn2yyBADqjK
34059	payment	1693	1693	660	1	1	994	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYaWMVWkR5hQEhVx7umY1CWB5jRfV5cKa2YGaqNgwnr39hLKZQm
34060	payment	1693	1693	395	1	1	995	51084516961	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLbTNnHBq9KCNypFW6keSQ3mRyXaoqPFQCUL9JD2S7a7cJc12n
34061	payment	1693	1693	394	1	1	996	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYzsYH7sNuj4jq3QW5owRWM6mVoxWDS2ufFtswYsedWYqXxForf
34062	payment	1397	1397	1678	1	1	13337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vAD1vBjvRmJpderxjjDS3PqnLYuDBDpewnSxVNSYPt5yeBiC
34063	payment	1693	1693	29	1	1	997	5418282399	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa8vU5uUa78A8zqFpNHRJYTeJMLKtz6EPJUFBWqEfAK34T3eunQ
34064	payment	1693	1693	251	1	1	998	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYigDyaCRcDV1gQ3NoiTpgk8Rh6SzM7cFYUC3vb3c1fcpyx8vJr
34065	payment	1693	1693	91	1	1	999	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvt7Zdme4arzGBwFn28YwHPrae4x1T3gPsKf5c8w9rt3ejJf8h
34066	payment	1693	1693	89	1	1	1000	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZN8VUMcC7RcqWZnSkox1ogwNYz4JKJsPbX3Aywi2BGigCJdXuT
34067	payment	1693	1693	1811	1	1	1001	140322344508	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZK8D8p9CLbRgLHyzW6oanwJPYVw8mrYr8QL5hQhAfUJ1iYnraj
34068	payment	1693	1693	84	1	1	1002	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYVvYGP8VcdGwnX8ZkpHz9DTshbTXSnc2KWN71iXCWZ2XnqrGbt
34069	payment	1693	1693	390	1	1	1003	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZnndhJbffUgxwwbuJc4tHDhbTYdW1o4nTtFiJL3xorcbaUqrud
34070	payment	1693	1693	910	1	1	1004	389291954470	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZMe6MUmKyY2BME52kmjbv3Bmy6CRd6GuPgB2hyeCyNx6bS24U6
34071	payment	1693	1693	658	1	1	1005	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYtagNU71hvFgiUwcr8b46aisUzzFQL3c5SG5i44vaPeKnCdmBY
34072	payment	1397	1397	1678	1	1	13338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zSWmzR6iH7jTQz3MF6X3igQzYPtoy5WuoLuyddy2N2f1jqVy
34073	payment	2133	2133	1874	1	1	3744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJdqM3ZQKMvqeqsSJAzzZFz8GGf8J3nBePfphhPus8hZBo5yS
34074	payment	2133	2133	1874	1	1	3745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiThSJALbjHKdpShp2rfqt185foXZLKgijJS6fbHiKqx74HDRB
34075	payment	2134	2134	1874	1	1	3828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrb6yugkUWbo1WgCDCf96BiPNySCvvGuBss1bncfmeAXBzXnUJ
34076	payment	2134	2134	1874	1	1	3829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkzGbmesiQHzMPyWsGQpshpMxHHumRL5HRa3NTRNum5JFe9Ly
34077	payment	1397	1397	1678	1	1	13339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUnt7s1VeygVVthzFqWjYPmegRVEJwbowvzfHNbgK8KKcgk2o
34078	payment	1693	1693	150	1	1	1006	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZxwjvxyoNgdcYzHbpyJZwZEDaTjvX8SHaaP88YD6SVxkNkHX2S
34079	payment	1693	1693	154	1	1	1007	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZJWY83oPknwMfG1UZxSaDpAguc2pCt1T7degvNkdDoLiBFrGWw
34080	payment	1693	1693	593	1	1	1008	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa82XcY1fLgPuHUgX6Q5nWQ7qwgikWKUiwE837BMt95f1n3Kgzc
34081	payment	1693	1693	180	1	1	1009	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZUurj9bZS9AHroQyvjvgCtcmheDu6ffpb48dSqeMTzxshhorT2
34082	payment	1693	1693	711	1	1	1010	2126180928	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZxTSfcGzm3G2nByAqswdq9YH8Rb5hZtiVfBHNaGa9zZr551FCz
34083	payment	1693	1693	245	1	1	1011	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYjyB2MHyFm3jNetKMrmkakijvp2tDCL9P1EkFRHooV7VCE85mc
34084	payment	2134	2134	1874	1	1	3830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTbhvRLVyAQte1JTi7qwNige6w1UeG73LCsysWLYAoUiF9KC4
34085	payment	2132	2132	1874	1	1	1079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fBzyWtRtam4qLnHS7jDMRDkVJH4RUnPaf1mBLcmrtWAsFciM
34200	payment	1397	1397	1678	1	1	13354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspENrn3T5b4PPTYnkQvy9826k7KwQK7YeMBojuaC34dSLYbK6
34201	payment	1693	1693	352	1	1	1080	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZFg7FKMzQGgVqrGPSWmUzfFUugNN8i2t5zWQ7mvDV2p8CerPTg
34202	payment	2134	2134	1874	1	1	3844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYv6iB7qWbB1RxNBVd1urVQUxgbcXYBXx8ataU95BZWGnbzfC
34203	payment	2133	2133	1874	1	1	3761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegjLoBq58ePKEKNG7YhrQKLTEorcJCsy9VYunJ239XDY77tVJ
34204	payment	1397	1397	1678	1	1	13355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A1YdXxADxsPQDCMNYRdbx6n66yBggjLdBgbpdizV24cc2sT5
34205	payment	2134	2134	1874	1	1	3845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGR6A7RksQQreayRjt8oN9kbGGQ7sv9YaBx8nQK7teage5idp5
34206	payment	2133	2133	1874	1	1	3762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLGJckHvk2Q55X8ssDAtUcf11DBxzyfbcWCd9TWb5DF9s7xDxi
34211	payment	1397	1397	1678	1	1	13357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG5uVn6VGSEgGp6JwRpYoTFYbi2zTwz55UVJdUhJ8dCnCQnmg
34212	payment	1693	1693	663	1	1	1081	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZomiYNJvPoUvwtvFBQ5YgHweyU4WAcysrVmmMBrMsYjTUDEA2v
34213	payment	1693	1693	266	1	1	1082	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZiLVHDmEsVFPa6axPLMH8ReSwxDh5LovQQgw9QY4WM7e2Bb4aa
34214	payment	1693	1693	191	1	1	1083	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZsZKEajWF3doeQ1ibijgivaFBX29f2ywDdPhYSmn46AinHZ4wS
34215	payment	1693	1693	379	1	1	1084	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYcAoSJRLgvPMgu5mY61NWBqVNUo97ftH6zEcUmtrDpe6FxUBwM
34216	payment	2133	2133	1874	1	1	3764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9atyjHC95gC21VymyCKyDdmjqJ6JMmfoaoCies8novYc1HcK
34264	payment	1397	1397	1678	1	1	13364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVo3SQPA66LiWMjSbscWrdeiQ7cazj1vJSgn5uN63qrEyUJca
34265	payment	1397	1397	1678	1	1	13365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeaCLH9oXkYvzXkCaPD2qE8ifcH5WmYAUc5iZA7cRXDNaeTSe
34266	payment	2133	2133	1874	1	1	3771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z4FUgQDDHjvKG2gVNXqzH2zrNq75jU51rD3qJ5BBeDzgc8st
34267	payment	2134	2134	1874	1	1	3853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZCaiKmEgpanWXa42mgDuR9vEMHaddJe4n7id6fPm4GyKLQ1B
34268	payment	2133	2133	1874	1	1	3772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdDHn3Hd52w9vniLkF5Rw8fJRnT6deimBH7p47navtLMEL17a
34269	payment	2134	2134	1874	1	1	3854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDb12SaKTTB67Radh19T8wvnGAi1ab78SQqoPjcUrZBFGAN6D
34277	payment	1397	1397	1678	1	1	13368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjK368UnbrnUnLvhP1va4GwYsCaveYmtEC2ftohgUvgxec6Mqj
34278	payment	1397	1397	1678	1	1	13369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2AQvBeYJDskinqYKbwNje6Lzsq391qcaC6cs9PWNdWczYB7F
34279	payment	2133	2133	1874	1	1	3775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3V8BWcafKR7QJMCUrLwFyVZiMXc4CsEq11zJkroYrxKv9gyS9
34280	payment	2133	2133	1874	1	1	3776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSg2pC3NQ6RwLVNsMxcFEc9bAvG7385MPp8NTzKN399NjehpJ
34281	payment	2134	2134	1874	1	1	3857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dYGZNsoSjfKujbMLpSQVDXoBKqBgKTcbvYsxjuWKQHLBy8iP
34282	payment	2134	2134	1874	1	1	3858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPRVmPNeKd8mmuSGCqCuHpVHJLtQdh41QvN7QokRninM5NmBC
34325	payment	1397	1397	1678	1	1	13380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLpNqcPipneVtgHAKhCkZ9MuWH2FacRzndpKqo1yQRiuyDaVc
34326	payment	2132	2132	1874	1	1	1091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiq36cMTDimjW7tcmdRnacYfBi9AovqDukkg11J51crTaJmdB
34327	payment	2134	2134	1874	1	1	3869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLE2fjv36txNVqUWa8hSTEHSmekuUoLtsMPCqyM9PK1ZWZJzp
34328	payment	2133	2133	1874	1	1	3787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqei9ERa3XoqZSZz8itmC4kKwF5jBDGdw7p9FENYHXPC4rE8z
34349	payment	1397	1397	1678	1	1	13387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7bdDUNRWvKYjVovzZhw4doGRwsuPXfk7w59RijcZpiPWfabc
34350	payment	1397	1397	1678	1	1	13388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAndnUigoZgqvztS68EytMPZDPA49TykQYnohdRmKE17FZKywv
34351	payment	2134	2134	1874	1	1	3876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHh5oASqnwvGCVSJ8PcsMaD4CCVjoXobSC7hSd7AJcMArKSBo
34352	payment	2134	2134	1874	1	1	3877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxDaDUypMP445CFSsFWU2q51PoVJLvm3hNLysnmaM13tE7cRw
34353	payment	2133	2133	1874	1	1	3794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29aEqbCMMdBLFYYq1mc9fB4RGPAmwfqeyHUSLSAPgBnDuESq7
34354	payment	2133	2133	1874	1	1	3795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmFTGjhXhNHXS8ZR7UwxZqcehD5oeQtyyxPJLp44ChMmniYVs
34394	payment	1397	1397	1678	1	1	13400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpruH3fboj58d8G5K5DLKyQc64a5149NYQNo6CBkbhahb6PpEa
34097	payment	1693	1693	600	1	1	1020	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZEBFUJsiXLnvkgtndNfSGpoVoMuunR5dtSPcwijHjFjuSKMhkp
34098	payment	1693	1693	112	1	1	1021	50979715941	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYiuWLvPRrrtLJnvc9afrTBgciMfrpm27ssZZFEdR1KuyWxtkz2
34099	payment	1693	1693	103	1	1	1022	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaEH9pRSkfjnsHvojyzmLMeMaGc4rkxx9P1LTTcLtBHRVNsxgEC
34100	payment	1693	1693	383	1	1	1023	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZacFfHDLTZgptXA3r7AtzctdJhV5xrHb89myvphgbjcrof5RKH
34101	payment	2134	2134	1874	1	1	3831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8dNGoonwrPoRQfvMXrHwTCVnowfg3SvuMLeSR931CCnb8sgK
34102	payment	2134	2134	1874	1	1	3832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbtqruL78BcxePMQWFDQ8VEQPequjLNM31drjzDGyQ5jwJvEf
34103	payment	2133	2133	1874	1	1	3747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsYXW1iYXEGeRpB5jDWUEUdy3uyzDm9GyRHx9p7hMPx8GdZDb
34104	payment	2133	2133	1874	1	1	3748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQ4HAsnpTYRq2nn2hYbdRV8uN8Sf7ZQkgQ8csg8rs48nVJJc4
34114	payment	1397	1397	1678	1	1	13343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU8DJRVriF4NEuVijndrGu8GQkSVdBivk4dLh4bNM38EAk9ZQ
34115	payment	1397	1397	1678	1	1	13344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttYpEwV3Jg9E5r9fCWoxVcr64th4VXbEUgFU37zf3YgBEUQHL
34116	payment	1693	1693	2073	1	1	1030	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaG3mJYM365rb2MLk621A8CNGcMxvAhnStrk1cRALSjkwtCqV6q
34117	payment	2133	2133	1874	1	1	3750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfbo9cZ22JygkoWm79h3nGqYP76XwstuRf6UU9NegdmiLzADb
34118	payment	2132	2132	1874	1	1	1080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFG9F5Z9oGXPML7k5VoYGx5gf7J1JvD5DhKMkMvFvnPMgqkiL
34119	payment	2133	2133	1874	1	1	3751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkUnVw9w8hF3vTJBbwbbiU8eNTLmB4YSG21zvGnrna8EWxFUW
34120	payment	2134	2134	1874	1	1	3834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsexLYhW92CBwFZWvKAWY4i6rtn8DVzY46Qry3dJ92xByPQAy
34121	payment	2134	2134	1874	1	1	3835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ589ade4c1z2K4jVBpKWaghvMo18AocAMZm355BqiboRevwi3X
34122	payment	1397	1397	1678	1	1	13345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ahFZVMnLpStz6yGGm2MNsrAhTcAvgftrcvYM82H9FnKKmPXt
34123	payment	1693	1693	237	1	1	1031	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaE4jAHEsGasjY2VP8F84iVRzBHu5TEo1YSUENXaaM8DtJg27Ns
34124	payment	2133	2133	1874	1	1	3752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6UMLMCRFQKGK4UMPDdwS9tsegdDegLokJCgsES1VfxRgxv51
34125	payment	2134	2134	1874	1	1	3836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YPpvacCq3D7kSHBtP7yoXYDUjq2Kb4wCtoSka71vNx7doT5h
34179	payment	2133	2133	1874	1	1	3757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EYRhAcv9NCeFFdoQgchJXpKzixnJo1oVwoS74K5xtdtocMAt
34180	payment	2133	2133	1874	1	1	3758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCwZcQjqwi2VqUcJyURCHzFTZabjC9RYyBjf8XHACrqfQ8WiN
34182	payment	1397	1397	1678	1	1	13352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9fYjZWSVTBmUuCLodqhbfRp1VJPhkNky1efwRZa7kpbiNAiN
34183	payment	1693	1693	10	1	1	1069	23057065816	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaFMfUGcXzSxuBT1Ezf71nmwYoXWAxpAp7MGV7QwPQZgiBhUEUQ
34184	payment	1693	1693	421	1	1	1070	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYQwJFPvUa4JBTBBVBH2T3hghg3eXGcy6sGuCEpFu6ZvW6YdJeB
34185	payment	1693	1693	620	1	1	1071	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZgCnNJQWNGFNd6uVFJ7t9dvLDdMPTW7WSuAFrKPb5jEu2938bx
34186	payment	1693	1693	594	1	1	1072	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ7kEKUxWNj3oToDt57MxVKGeBGyLti5e61aE6dyzsXrxvxbwT5
34187	payment	1693	1693	622	1	1	1073	4148160270	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwR9G1rc5EWBNvZhWfKegD5btotXp5AxYSDZ3iTvxosx9QyBrZ
34188	payment	2134	2134	1874	1	1	3842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUWQEdVPXySrE8PrHSxseozpRABK8A1r67fukPXB7wqaD2DM8
34189	payment	2133	2133	1874	1	1	3759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsaFq11GwF7LoKendyonbhHRx6CvPWqsLpybbBmve6U5TvGdZ
34207	payment	1397	1397	1678	1	1	13356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqgubPVqyCT8Y7PrW8wbRaeTEYeHZKQUmjYBwDjYNWuYrPEts
34208	payment	2132	2132	1874	1	1	1084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyoB4jRttJ9fCZJNQgHm4WzJWsU7NzWDY4ENCNMQMAdibtTsX
34209	payment	2133	2133	1874	1	1	3763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u753wAEjGuDPL873bWZgswBFwGrCyigk9GEmcjewNV81cu7P
34210	payment	2134	2134	1874	1	1	3846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwr7zpMnArG4nj9YbLeuaphn7WkQQwieq2xUChQCscWPyJkWP
34226	payment	1397	1397	1678	1	1	13359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4b7p7Tj5NDKHg1CJqjShG6ZhzEQ5rmR9PzEwMcpj6f6YGuxs
34227	payment	1693	1693	499	1	1	1091	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa7Qy33d4d3LosgV6dUTCZMsFidYc6PZ4zgDuNG8RjqmEmu1PmQ
34228	payment	1693	1693	391	1	1	1092	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaHdJWf9CnuaxFvTaR7Ysg99gQLBriiboM227qB3S8E5KF2nzKV
34229	payment	1693	1693	186	1	1	1093	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYrTz48dBnW5TNksRkdBSEt3jQPkEq3R3zANdkCLzgiPkm4Nodc
34145	payment	1693	1693	339	1	1	1048	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYXeqmyYhTsFF1AobjsqiJFwfUVa1BpT3sjGcAWBV6f8keXw2Lb
34146	payment	1693	1693	105	1	1	1049	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZpiyJXutgmv8ozeFhPHXvMjacgYn9mBBuBwQU1KKVcRoigyVhe
34147	payment	2134	2134	1874	1	1	3837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmRAHvqqTyWgbsuEjQ1fLhB6ge9bMVsaojy7hkAVujUEpUJs1
34148	payment	2134	2134	1874	1	1	3838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGnr3hexVi5S1xNKShaeH4NiGudC8ZZcBnLU8xAiK25kXGyoS
34149	payment	2133	2133	1874	1	1	3753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRJ6hyaNQkN4iCDJwLbCNXJ1CtNCoxdNy86q62ZiZXGNGi5hm
34150	payment	2133	2133	1874	1	1	3754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h1RQ1nBdbt5pCNGpCJoJ3Cb4wzQMXV5SNLV7A49XV2McFUXv
34151	payment	2133	2133	1874	1	1	3755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK426JB2cTwtDjzpxZfaM6d2RKei1YaeJkiesi3Yuz6cHZ4xQM
34152	payment	2132	2132	1874	1	1	1081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ88wSqHUP1k13YPXdQ6nQThquNHqdtFBrbDCUNR4XjSBFb2po
34153	payment	1397	1397	1678	1	1	13349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdZT1xx5E93AmiRhpKYdu1ZrEdUBe2aY8i9JYNvpxNU5R6Sgf
34154	payment	1693	1693	322	1	1	1050	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZzLbeBzyMyYYbSDuS3R8d5L1WhhjRSoj8CtQr8u8Tx3E5upnKc
34155	payment	1693	1693	252	1	1	1051	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZTXBrFs2mSLwhXUphK4koLNDMhcaCpupm8SQK5getEaxACUusC
34156	payment	1693	1693	636	1	1	1052	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa2hecq7Ki9M1HXjnrCHG74q1qQsxTj7mgqgHiEAPW85619YjfN
34157	payment	1693	1693	1778	1	1	1053	1416401776	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZgzmZFRgLTmEBp5pnMG63sPnqKcNVHcQE9MJse7cHghRfuaPsU
34158	payment	1693	1693	146	1	1	1054	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYk8JXyukaFjeRM2X37JqnNqYwsFusC2gqwM5fGcjvLik2vvvdZ
34159	payment	1693	1693	114	1	1	1055	46740685762	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZDfhMxtLqWtPeGbfFPxn4NCK4UAMxtJDVMtnBRo6vRT5dghsHT
34160	payment	2133	2133	1874	1	1	3756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNtQU7LWzBxmffKQhgWHgyGg4Jk9dpDcbMXLaDn8gq84SFn3y
34161	payment	2134	2134	1874	1	1	3839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf23CNLw6trVvwpQ2KgVvHAW55G3mtzg1Vc9UxCxxmo7UvXHFV
34181	payment	1693	1693	450	1	1	1068	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZexwQVLV3t9hfzNfmfnddMZ2GVjXCEQVZCaRwRUt2Y7gjpU12K
34190	payment	1397	1397	1678	1	1	13353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPu5LPhMLdzgMfJtNikuW8Xd22QyE2Ktyi45E1webnnHxZwYo
34191	payment	1693	1693	2017	1	1	1074	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa5R2z8uMWvNqtfoBrurbuSTK1C9yyHjhVUnGfxgwNVYouuppyi
34192	payment	1693	1693	520	1	1	1075	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa3vWuy2ScLSwDhm1crxoWgkj8ZDZwndJjuFZSYLt1CrwuNDFo4
34193	payment	1693	1693	452	1	1	1076	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaDfJWsg5nGAqxcmmzVK446r8fkAQ1GdVeYKFGhK5NAMFsJkUtD
34194	payment	1693	1693	652	1	1	1077	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYxm6xgbY4a33jMJgrQeLbUGpo49VBdo1Mgo4zaDWEjDqqoxrms
34195	payment	1693	1693	354	1	1	1078	46740437906	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLzNayUoB3qD2mfbxXhe99No9L2p5hek9xCw9yJet3E3Z2HYyG
34196	payment	1693	1693	569	1	1	1079	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ5XNtCkDb2uNhKQ8Xfm3Kmdei9uZr1NLM5PoZwy2WLM9rotwa7
34197	payment	2134	2134	1874	1	1	3843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84UxohGibTZyhC4q1SBSsBwjRybHB5s3JCbzFf9kUio85rUvP
34198	payment	2132	2132	1874	1	1	1083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsErpki9QaLzXTnoBqNrRRwRRqB8JgJW6HoP97rWzmzCD1iYnm
34199	payment	2133	2133	1874	1	1	3760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcmwMkHcKDJNZ9dRo67Y1NHiTMwnw1uiXQYzU3DbsxESzhzvq
34217	payment	1397	1397	1678	1	1	13358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiU856TpS3TBUz7w7dk3gg6SwQEti32djgvwiPTg7DFHB7hUd
34218	payment	1693	1693	551	1	1	1085	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZHXvQn9csJyRLa7rxBUxj6dfMUtqzJDvTGcrARhFV65sgnM1Mf
34219	payment	1693	1693	366	1	1	1086	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZw2AgbJWND6uFtjS9zyMPYszDJUVYntdtBWeCgEYhYWikFLgxo
34220	payment	1693	1693	82	1	1	1087	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZGMLmVnHom3Wowb7ttLz3cow686pYMTLjFYhoKzicnhYAtrwvb
34221	payment	1693	1693	680	1	1	1088	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZL3VaqDmVbGvQhixSEgZgsn5faSW17QnSVuBbj7UiKzKYdxJcN
34222	payment	1693	1693	342	1	1	1089	46739524375	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYXesco6UxTZEYrwrRajUxQXB1G3DxfDLWWkTpj834bCcNa4Jau
34223	payment	1693	1693	361	1	1	1090	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZpCwVPNYWW7xvEg98HTRUQZuD8S12k5YzKfdFpvd4QroyggSgU
34224	payment	2134	2134	1874	1	1	3847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzm1JnvHdsveyTe7Qm4dZ7wVKb9jbYZN2RzbCJsLhVUmKX2hoz
34225	payment	2133	2133	1874	1	1	3765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jdcH8qQ5T2GWQy3kpqPbZC1GLv9S2SR69nHRtCQrkAAPqSTC
34260	payment	1397	1397	1678	1	1	13363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzxnzf2wMkpxv2ZyAJKNXyqdFs9Ng2WptggfyRNkdKQGkbuPN
34230	payment	1693	1693	458	1	1	1094	46740437906	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZtZ644LngYFKH8qciH8tYM81k4MgxLGUGkf3hiTZ3fh5FwZNVz
34231	payment	1693	1693	327	1	1	1095	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYoKucq647egU4oWD5ZJRX8o7bL3PuzY71LikhWQ8xwkz3baJXv
34232	payment	1693	1693	894	1	1	1096	237493315876	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYpRasdCtva5a4s1TjQhpWGeRwGSHYbfkSgCvNZmb5HA4kBDM1W
34233	payment	2133	2133	1874	1	1	3766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6rTaxU1YHnZmNDx2h2BRzmhEVqkeg9WYPug833ADct21JHaU
34234	payment	2134	2134	1874	1	1	3848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfX2PPNfMLmeCtFMXsyBteMCvLMKmfzmn5eCQaxRCfo3tyWQL
34257	payment	1397	1397	1678	1	1	13362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVCruMjkcSiDHqcgrrgcuu9UU4gpe6fRJvoR25f4NsSBBqhcw
34258	payment	2134	2134	1874	1	1	3851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgqPjojYdQ31ijhvrm1si7UCqcEhrEP4PBMSo83SoUrmLnFGv
34259	payment	2133	2133	1874	1	1	3769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgfpyTnRAG3Es1xHYAcrQgTuuyd5h3gPQLEFA8aUtNL2WRYxU
34270	payment	1397	1397	1678	1	1	13366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWZNxKEMmqTHLaZDKAoRwUD2jmiFzJmUrjBgNyCT9ENzG1J9W
34271	payment	1397	1397	1678	1	1	13367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKmkNC1LMxbiUcxePXCdzrneE8bJKDUr96xRzH2wvuBfH6mCG
34272	payment	2132	2132	1874	1	1	1087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhzvCN3zKSGFChdaxvJAqDE8ZU4G4SRCyok1M5khMAcs8URKD
34273	payment	2134	2134	1874	1	1	3855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eV6UKmXYWPKoTg8aGJt2Lwp6JTQuT92v8pnvPKF6EjPEFeUo
34274	payment	2134	2134	1874	1	1	3856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfs7iWCRJ5NhXxC8NsJjtqXnGoyHYwM7YjjhsVsuf3QiNYZmY
34275	payment	2133	2133	1874	1	1	3773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGkEkzmPeSbDBehaQLX5Cxyee1JKiN9SvPh7rwNjPzuDJ7oMf
34276	payment	2133	2133	1874	1	1	3774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTk8L3YFkuM6SyeqmVzrAP9sFmdefjuF14EorUnTw7UecowPbZ
34304	payment	1397	1397	1678	1	1	13374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8PTjT6xSRB3mdybzSQQpjMGu1TaQvppLtbYqBXJNNVK1jnKN
34305	payment	2133	2133	1874	1	1	3781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUivZ6A3RGxknN26idmuF348cALoyw1J6V4pQpHDofTFXT8t6g
34306	payment	2134	2134	1874	1	1	3863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SYLmZu28HrXWgxuKogBSyNqU9tuH6c4RP9CEyD9XusEvb6aP
34323	payment	2134	2134	1874	1	1	3868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWE687pxq1erzkA2DbtEUgVx3C6C1FqeSc91YK83hwG9wQENy
34324	payment	2133	2133	1874	1	1	3786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCurJ33iJNcK2cF6iEYnNZLxstYZruehdBTdmvMk2G3nmYqzB
34345	payment	1397	1397	1678	1	1	13386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBxNY9ZHyZKb52M1Kbe4CV5i8i9wZw65MTuM2mtR9MTbseacw
34346	payment	2132	2132	1874	1	1	1093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGhstTLYmhaMvQXFU8CycBj6Zwn1igDd4LE4aHT2aScVSBSA7
34347	payment	2133	2133	1874	1	1	3793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw7Zvp7sPwHwtWbCH7vSZVXZ2y24LstXwRfJX1Fff9A5PUEHT
34348	payment	2134	2134	1874	1	1	3875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGxAzSbbj5zBENpife6jeKehHKH3JWTEj5Joc2Cga8sxT5Cq9
34358	payment	1397	1397	1678	1	1	13390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXC7i5BkNpKjyCk7HdLa2bwKqYPZtp4jYPDdVkve8KcoTtxqSV
34359	payment	2133	2133	1874	1	1	3797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3royFBjffTWbzcL91vz22SLgkuwmbC9tN6qnJzmAxve5NMfS
34360	payment	2134	2134	1874	1	1	3879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbay3QFiqZwXWHUn33K6YVEQcEQP4Gq47HcFMatEYWUzv5h5zx
34361	payment	2132	2132	1874	1	1	1094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArEV19toRea9gCEbdyys7eWrjMwAnwmeDn1whBbhgXQwQGqzw
34362	payment	1397	1397	1678	1	1	13391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Fn6RJbFmaBsGK3HQkU4SYBQEWYyfS7GhuDDerR7yQVZx1Cdm
34363	payment	2133	2133	1874	1	1	3798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHUyrSgKZeC7QRo42fykX6e78DACSxkZFjyDD3C8Ya6Zt6ok1
34364	payment	2134	2134	1874	1	1	3880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWkxyapd5sJFeoSg8W25qJWTRfvkqfi4fAbXTNa2raf77aKMT
34373	payment	1397	1397	1678	1	1	13394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvn3gfmmqGkzeEvn4yATwQDp6vnibTtvAEF9nGc5sfnBqbTb7
34374	payment	2134	2134	1874	1	1	3883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jPGd5bLeLwdQLXFvdo9arbb7RzxL9cnCGVhMZLc3vdK7MALk
34375	payment	2133	2133	1874	1	1	3801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4Q9jc1nxg12vzoMXpkNXm5ixNEkaxsdXiCpWQy9RkyBCPyeW
34376	payment	1397	1397	1678	1	1	13395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszXU8u7FQ7qFwc6fxMkrcu3TfFBLQWTqF45wJXpffNsHpKztG
34377	payment	2134	2134	1874	1	1	3884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTbfy9uC6C6CtZh64LyUY1zpXXk1SdyxTiXANrTLQ2zS3of4R
34378	payment	2133	2133	1874	1	1	3802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvce3GiNb2rFUKT5Wges5gscymi9UARwECzzPhTGgNStHJRtm
34379	payment	1397	1397	1678	1	1	13396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz64bbwwQfTjhrFh21cZ1D4UnuGYxbHDyEMCMyzr5NMgWBrmp
34236	payment	1599	1599	921	1	1	4	2643535789138	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQoiytELGFNNhtzWpakM8fthQdkDo1adVYn26qqjn6VmukpiF
34237	payment	1599	1599	1041	1	1	5	4737193484311	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG7nk43arLZQ9n4sszgtTfNdx3unLzsw7N7BNCcaccXdowDix
34238	payment	1599	1599	1161	1	1	6	3196278839126	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFmLhyz3eQMEn7k661wZvZkSJZDM4EmYiofwyBZrjKQn3rjNJ
34239	payment	1599	1599	1287	1	1	7	8906715182489	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14QQvcnchxs7oKPkAuDmVVhLjCuvz7USzxyArN8uBS5rByQkZ
34240	payment	1693	1693	570	1	1	1097	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa5Z1HunynAybswfcrVrsV1s2b1v41RCiN4fWmgDCjPfeybdadJ
34241	payment	1693	1693	399	1	1	1098	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsbErxVZ6TAPYJsWUbqMg5SzdKj4P3M98RXj7J6u413Ti9Kuqj
34242	payment	1693	1693	721	1	1	1099	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ3r3L1t7hnZ359jCF6Uewj3kHi6DNHCZ4kGdPRfJHYXSWDASfq
34243	payment	1693	1693	534	1	1	1100	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYniRHe26EgwbTYB3NfRWf7g5rv839hMZr3dnkMDyEEA6TN1JXE
34244	payment	1693	1693	731	1	1	1101	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZjeFxTH2KoJVUULejtybkLsyVwBuzd2veNYmQAWHhH9AbN17Lp
34245	payment	2132	2132	1874	1	1	1085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25Vs89gs6qYy9h1kTRGeB8ZJLrqa4Gk17CFGapsD59aLBSbte
34246	payment	2134	2134	1874	1	1	3849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSzHVRnh3sYbiLYSsECVL9GwrMQ7LTo8jtdQtJ7zZhHrTjJ3z
34247	payment	2133	2133	1874	1	1	3767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP9S2ZUAW1XKP6LyAmD1bVtqzjZA94ZbWjwMt1v9ZVnHGCwJP
34248	payment	1397	1397	1678	1	1	13361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUADHLw47i6jim8qGkXe5GGxCzPCJXpfTznYYtrz9iZW79js4S
34249	payment	1693	1693	138	1	1	1102	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaBdur9i3YrR4RkoRUPDb9qWgrZaFkqHUiEADEjVVQ28p3vqyjs
34250	payment	1693	1693	402	1	1	1103	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZKzgpDhiUsuUH41L5UyCe5FKWZEKPwiKLSCo6gAFJoAwY1tKgw
34251	payment	1693	1693	275	1	1	1104	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaHfDEqfen7Du5wJ6tymFCeWd6V7Dfzmf1SJk3gGwFw6FS3t5rx
34252	payment	1693	1693	1030	1	1	1105	697607846969	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYWU8S11HBMRGn5bsny46xcTpX65ScgGRG3U7Ve9afZcfC9ADCg
34253	payment	1693	1693	309	1	1	1106	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZGC3Y9nawuXN22xcKG5ktwLgJMkQggj6ELynmbXG5V7otGf1pG
34254	payment	1693	1693	690	1	1	1107	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYj6M7SR9NLzseoDMDCMgywKmujMgB4t1iSPfsh5jNWsPnLrdVW
34255	payment	2134	2134	1874	1	1	3850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8WFzHDHaMP2uY43UnUSouoJwPUztRfNXVM8Ck5WbLEpJCs9dR
34256	payment	2133	2133	1874	1	1	3768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3gY4cV4z9dffKDn7ngfA1sJh4nYNSGGeJc4MyZzkyhDk35PA
34296	payment	1693	1693	320	1	1	1114	50887527308	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYcQQoQtYe92EaJYUom2da3rXwqWp3PVkxqtHKi8aKVYhZvg1Bd
34297	payment	1397	1397	1678	1	1	13372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHQpymDZYedMuECMKF6X42D27EATHN5XGVWiqdeE3XrVC5baL
34298	payment	1397	1397	1678	1	1	13373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhv3wjoMYmMNZu3b4mMKVZyCrMDHwnD9kMZa6qwSH6g2AcgzY
34299	payment	2133	2133	1874	1	1	3779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVcR1eQDdFuiY14Jk3xhKz4fs69X25NtvC9KsGaMcFuQLPAS5
34300	payment	2132	2132	1874	1	1	1089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFaHVmNTDKw7ejnGqHuSVmAz4WwTcwqRXBTgaGJY6vvSkeY7p
34301	payment	2133	2133	1874	1	1	3780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGU5uNcHRB4Ln3erD3q5hZb3nBBFEZym5YCJbs6eLufAFFGe1r
34302	payment	2134	2134	1874	1	1	3861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvTi6PyJJujCsaJbTT6wEJSz37xmT7Rdm83DgLvxYdwwWGi3P
34303	payment	2134	2134	1874	1	1	3862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kGtWZJaL2L3byDPHQopb3GFPQQqaef9cDfZTPVuZTFEwqheN
34307	payment	1693	1693	1811	1	1	1115	1087616978	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYZkM3Zv3eGEGGBxSBChEg7gScdaVJiPTVE3sBqqS1bPjAD6W58
34308	payment	1397	1397	1678	1	1	13375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNwjrWg7yKhYbmzKft8pbFyErab4pvfvZ9Fv8pJ6eBHGbXcWC
34309	payment	1397	1397	1678	1	1	13376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPNSySEWg9HLA5F1WSo4tjYbQu63jgPLjx9KDBbkFD96MvrdB
34310	payment	1397	1397	1678	1	1	13377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZVJ2ibutCL4yr2FwuXYN87sTYF9z9c8Wqiru3zvDV5dYj3LX
34311	payment	1693	1693	1772	1	1	1116	2855319911	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZZhv9tZKjr7TUayR6c2TcRApLFKVbazpu3uR1jHocQ1rbLAkRz
34312	payment	2134	2134	1874	1	1	3864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EhU1JPLor5uM6NzdaieaoHkRJyX9nTMMB4SE5dMJjcmE3zyu
34313	payment	2134	2134	1874	1	1	3865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2EBHLm6taTD4AVAdcpJhrY2uSkzbSZeqzGyVfr3HuBJBg5Hs
34314	payment	2134	2134	1874	1	1	3866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQQfpy6QXr1FCpJ3nJZi8AuQDQC8znr7XyCB53JQ847FFKiqN
34315	payment	2132	2132	1874	1	1	1090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxD7SPUi8Fif1X3QmKoaZQi1RgXFmRaEusPH3jDgZPdJwmSLdd
34261	payment	2132	2132	1874	1	1	1086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrc9h2YjikfrUCf97Qcq8vTbJdz5d8YNNScm37W4j3ZHhcomz
34262	payment	2134	2134	1874	1	1	3852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBJgCk32FH5jRb9Xc7ffAVLyNisQBBxBfGjgLGmeCJ6wuC16c
34263	payment	2133	2133	1874	1	1	3770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVYNC64wwhLyaJiFgMkSquQoP86h2Hgcxba6HbVWHrm5KDmy4
34283	payment	1693	1693	312	1	1	1108	46738745395	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYWakLDM6e3T8axpb6DL198uVaR3ngBRUh1S6nvtbsPrcoGJgqw
34284	payment	1693	1693	1772	1	1	1109	2855319911	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYwaRfiR3UfvKwcJRePvMXFYkfyT1KzdenD9W8EiVHYzsqMaQGF
34285	payment	1693	1693	1811	1	1	1110	1087616978	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZZzdukryWzN4EeJ962gfjWrh3fHwJK1FaMX4voR2GJ1dHpUE2X
34286	payment	1693	1693	649	1	1	1111	46738809135	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZQqasXpXypCzSoh5jVAqezdTWUr3T2Jw6ZwyD4n7brtLirUugF
34287	payment	1397	1397	1678	1	1	13370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7fyoUNwsr2P4GSXDcfWcvn45teaWrYwq5aXUwwcjccADrbNW
34288	payment	1397	1397	1678	1	1	13371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPSxTpKw3A7KyRdPMUFHBN5EHKTL97tHZbBdjNV7gi5CXQ5uM
34289	payment	1693	1693	205	1	1	1112	51086662692	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZyW4LeBM4EdXHNPnW1aia3kBTrLL9d5PcnEK4VQk2iZL2sVysD
34290	payment	1693	1693	120	1	1	1113	46739382744	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZcfRSg5GrX6SK11P7uPkQk4ZVRDf7CQ9mB8D7QGYV9wRXUbPNp
34291	payment	2132	2132	1874	1	1	1088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfJuNjytZBHoErRtzEj9x9SPQfVe8j5Muc9neS6FFbg7WRFDe
34292	payment	2134	2134	1874	1	1	3859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYATn5rsrYw6GD9vobmyAmTXAMAwTHDREfAGZtpokknCJTqxF
34293	payment	2134	2134	1874	1	1	3860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJupJhWWGoeoDbPn89RsXyzphgvUGdZscs3NmrPDecFoTCX3Ke
34294	payment	2133	2133	1874	1	1	3777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYYDoniR5NGSQeaPzonoNcHERuGTTUKZokpy918NZSsciUwdB
34295	payment	2133	2133	1874	1	1	3778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopLF9MRPZ5K2xSZyqp6ybPvuyvUXos1yy4RzbXMYo1vBapGNB
34319	payment	1397	1397	1678	1	1	13378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKMr1NghyCiCBKZ1PKvptFET2Rq8zTgy41s1ZytYG6rhPsKJC
34320	payment	2134	2134	1874	1	1	3867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCkgLCRjdLFE9KoMbUYCJuMjmpFuaMxurxBG19Fd57VS6zVWz
34321	payment	2133	2133	1874	1	1	3785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TGqEmcF389f27bi8Jnzjf6HAW3bYbvZHgLSH8d7si6Xtt8tU
34322	payment	1397	1397	1678	1	1	13379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzTjFMAYNbWHzhGMSzG3uqW38nCgdsoongsSQDnjaTdLKaL8u
34407	payment	1397	1397	1678	1	1	13402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTBL788TUGtcc3xhBThkC2158CE1uDHSRbXXYVAMadCwdA8oU
34408	payment	2133	2133	1874	1	1	3808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiijAUrPDhZ8yVfpNkBsDPCcsuktBa5u6Z1PwK6nrnnoXJDnZ
34409	payment	2134	2134	1874	1	1	3890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhR4LQ5RBFtNRD1vvfSdxkxnUGkvzeGbhnmQPw5doLmW74LSY
34426	payment	1687	1687	1866	1	1	6	14175294119770	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHVM13DkHxwSatUCg9CpVruEY9aUCihKXevotP5WfYH8qukru
34427	payment	1397	1397	1678	1	1	13407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDi9ZySpSpWtFdsKCJqbTn6BuhQjLDDZTd6WXPSPjQ2gce4At9
34428	payment	2134	2134	1874	1	1	3895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwjiBoUAsiNp9GfPd3qM6r6qRevDc9xRYvVBkj8XuwsfELJNX
34429	payment	2133	2133	1874	1	1	3813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmw3gSPJrmgVcXjB4iVCTWppcBJ6F5xxsRTLUv2HKZU9uiRjDz
34472	payment	1397	1397	1678	1	1	13417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeW5Ptbsd6FRi68TJpxx38uZjgqwqHNthJwPxFeFKUqhsqtp6
34473	payment	2134	2134	1874	1	1	3906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wnou4FoZ6A7jxL3caLpFPe6ZnyhkoArEiBpdJuNQjFCF5Uq1
34474	payment	2133	2133	1874	1	1	3824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7puTUtx64CoE3mo4psCxUYWc8kbsooAhHrBzVDsvyinWYpeM
34478	payment	1397	1397	1678	1	1	13419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWbUwfA61RJ3tSEp3D5dns9J3j6gw5kpuXGLhS9JJMq2VyC3C
34479	payment	1397	1397	1678	1	1	13420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhzgZUMHLNWkMiUhcepUnfscwbBjysoDg1VpUGzUsC8q8CnGe
34480	payment	1397	1397	1678	1	1	13421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVjf4q9HQWiRWy95qdL5GW13JBuAvkaazNAkkntDb8nkeBWFK
34481	payment	1397	1397	1678	1	1	13422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkyTbCXqP7DrsyESQyJpuWKibHFQLVD89R8YNPDMhJ3vF6Ct3
34482	payment	2246	2246	2112	1	1	2	2686401101924	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBK3PB47r1RGqqRJ7Mw4qoL3ps7amE2ojCQFKSSXuTfqdNbgt
34483	payment	2132	2132	1874	1	1	1103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL5jcfzkqDezNvLSowLkK6FfAyjaVpAeRWmRR1A5NARmQS62X
34484	payment	2132	2132	1874	1	1	1104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoh5Wfot9vtHB3m4FeXsq1N7rRoFWJaqgvWwwUZ1Q3KQ9bHKX
34485	payment	2133	2133	1874	1	1	3826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWJm6X6apBst7QYxQW5W7M2NzVQvWAxpxziqmzxPCx3BUroNa
34316	payment	2133	2133	1874	1	1	3782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fisg6zMht7yt9EWhQZ5y99TEfBYm4WCmZi8m2t1oqzEJ282A
34317	payment	2133	2133	1874	1	1	3783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpY6y8gdMXMMc8s82v7epG8URwNwntwVc7UADKrrtd9pFGD54e
34318	payment	2133	2133	1874	1	1	3784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8dHX5tK2tUifR8h2YExTuMQshEhH2WRqZ3wDvmUQ3Ejw3nEa
34329	payment	1397	1397	1678	1	1	13381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8NseJJApdcwnp5QcGJ8a1ur2X9pVFxWeZoChkfqP92nMPVcg
34330	payment	1397	1397	1678	1	1	13382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPEwFZWU2QrQWoafUwCJh5pMs5QJNuqA1rSJsDydRFzYMFNfF
34331	payment	1397	1397	1678	1	1	13383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xApTLjPqooM2bjszyyZL4EyUkSQgTdQAzJtkE2eP2p1AciK8
34332	payment	1397	1397	1678	1	1	13384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFYRK7qhKxZqTqmeLZqxj6WQg521MqByoHLJXgiFaM7AA9owB
34333	payment	2134	2134	1874	1	1	3870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAMChAPQhwv8XaN8YQmifgLtojAx6Mrc4hdqPmoJqvjTMMXET
34334	payment	2134	2134	1874	1	1	3871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2VMGznec1AXE1pRFReMbicMSiz27ARcrJFtFHTFavyV7WoMAd
34335	payment	2133	2133	1874	1	1	3788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGr29jSrGqTCaSZ3F7YsmsF1ErkaR5vsPFnATvhKiXjvvuhAP7
34336	payment	2133	2133	1874	1	1	3789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mYcCqcorbo1vHmkdac6yLYG6nLQFBkTgUcT4B58ZMCJVPKC2
34337	payment	2133	2133	1874	1	1	3790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4stKzTGQhPQzPK7nSHRsEAZS9Fv1kVQmBcVaXpZFu5NHX3sLa
34338	payment	2133	2133	1874	1	1	3791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JED7e4ZixC5r2TKr1mKm287y3f4nNnLcw3WQyDLr3SwzvJBt
34339	payment	2132	2132	1874	1	1	1092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnuMwkPZuxekbLCNSXECN1gvvw19KTt3XzLQ9Q6CB2x2wJT1D
34340	payment	2134	2134	1874	1	1	3872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs9XN4t2hqJi85nrBz7bV1291Ceq2X1spPwJNu35fz4JhYDat
34341	payment	2134	2134	1874	1	1	3873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGVW3FhMNLc5U39wkHoyhFddiJesTNjY7fU2VPJXxzoJ8bw3o
34342	payment	1397	1397	1678	1	1	13385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK5i1qeLuqDuGxyx4NZKWhYJ35ZspYX6pFuKEP5duXLZcM7wV
34343	payment	2134	2134	1874	1	1	3874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxw5ReYDDegMz9ts2zLJGZJoS1GiMy6nXszivncjmf74hU5vn
34344	payment	2133	2133	1874	1	1	3792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbCe2Qmv5MgPznH4jqw2F1ZYM27xf5PxSUPRBqFKwhuEVXpki
34355	payment	1397	1397	1678	1	1	13389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgATUxwuJMMu71D7KD1qhxTacftqryDJZUs8ZrHe9PM1HK2myT
34356	payment	2134	2134	1874	1	1	3878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5FqUJDAkWohFwsKGe4XjorAAnR3rT8Xsg5sd9G7qTqKLm2qg
34357	payment	2133	2133	1874	1	1	3796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLbv7yX4GVANtUJXWL64CzNZHMZAJeidmFn5BArgGSLmDjFaq
34365	payment	1397	1397	1678	1	1	13392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCyr8GGKPMtXRnvKnvxYRnwy4EvgzsUchJEhxzhRkYTVXgEfZ
34366	payment	1397	1397	1678	1	1	13393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hvcT6Bx1zdmYFwXMK2VyM63GXyjTmmKWNyAyr4EegeStcdE2
34367	payment	2134	2134	1874	1	1	3881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcPctUAfDGG9Mkzup6Jf2CsuFR1XzUtHTEfbbYwwSwHPx9EbK
34368	payment	845	845	2297	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3ir6ybDYK4szaL9rL5xzAP7AhPTbhuvakvq2rXbAjp3kRz37
34369	payment	2134	2134	1874	1	1	3882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHxCUdZHZYMeysFtCh8NTJ76z1RPdMFMUtH3skEqE9KmbZTqA
34370	payment	2132	2132	1874	1	1	1095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QYUvF9fPtun6YGkJZftEWpBSk8HTFfRxnc4UpUCCPZsCpufQ
34371	payment	2133	2133	1874	1	1	3799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH5TtRxXVrG7iiKBg7keZLiQ2EkT9R96TojkoLaUPGDGkZB2D
34372	payment	2133	2133	1874	1	1	3800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcs7YwFr4rZZD3Y56LeV7ZjByadtYkYYmQg6y3XpEEKG7WVjr
34397	payment	1773	1773	2298	1	1	36	82793760832	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZk4Vkkeu1K6RfNtkVrEDAWVWU4VjfyVCEWCt9FRkqTaymicNbs
34398	payment	1397	1397	1678	1	1	13401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFkRL8Wmk89T4eQfSqetVwjpJQhk6GNVABGZ9czT4diCBTZ2f
34399	payment	1773	1773	2298	1	1	37	55195840554	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZxDrCsfhfvpPRmnmEqF7K1FkWFtCBTgzCnd1JBSBuUXwY1vhEA
34400	payment	1773	1773	927	1	1	38	629968031574	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ2vYefqT23JzQT9yLPUZnErcDD96TnNTgiNVWkMpBCbFG72Vuw
34401	payment	1773	1773	1047	1	1	39	1128897315014	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ8xo15TJExZvza92BfDcyUKQhFFhtmAGBvf745L9XiBLRRKtZ9
34402	payment	1773	1773	1167	1	1	40	760442349765	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	Ckpa8MUvLEMh9evWPhUZGzRVwRgzXJ8Zs5vAUYJwGNSviiSMhsZHG
34403	payment	1773	1773	1293	1	1	41	2122515554495	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZJDmaBZCk5xFDpd4Tr4HvRZVWbcC3TNdS81ttBosx8ysuLWyEj
34404	payment	2133	2133	1874	1	1	3807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFkinxgCyW6GnwMtn1i7bHqgHzzbbvkaGvBHobB9ViKKt2AQ1
34380	payment	1397	1397	1678	1	1	13397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmTLQbXHSzYmxYPmfUKPhHG3yQ4P6JiowndqryxgjpEmjHDUW
34381	payment	1397	1397	1678	1	1	13398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGUQhiH5rV7bMeREauSJyefXTf7csfDCJnCPaxYmtjdgYfEDo
34382	payment	2134	2134	1874	1	1	3885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA36EBMxeiEuQnT4r5s3hDFf2rgnFLzs9pFoGER2N6tEDAvri4
34383	payment	845	845	2297	1	1	1	3471784111139	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDQjWcmuWfgkRswHiT4HvWki851ng74pZWQFcWGUTu9AJtKpC
34384	payment	2132	2132	1874	1	1	1096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSWVHsadGjW9nGssLYDrTNP6hE4kZqb3dv5KUL2yU5bVAovUq
34385	payment	2133	2133	1874	1	1	3803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQT8VxEKFqjSSYEYk82XRfa2V8gmqu6pjJvXNEZaX3kQzmpPzz
34386	payment	2086	2086	1773	1	1	2	3775000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPekRZznRUP4X2q61CekEz5SbjSL6zc6BtDcWtQbdnGpFTyj9
34387	payment	2087	2087	1773	1	1	2	1004872852234	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdBB2qzez5UuD3wn4bDxMC5jhyza7AhR1JojerURQ33o6zPzZ
34388	payment	2133	2133	1874	1	1	3804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49DkcyoKk6fWyYz7xCxFTWCLaUe2JXkSmA2Pc45UTvorW6tca
34389	payment	2134	2134	1874	1	1	3886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NnUewFPkcDRyRT27gF3zdKuMrmevye2zsMZVWnDicmBUhjUq
34390	payment	2134	2134	1874	1	1	3887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ogXAaJaVQvbqWA5XAPiQfjtqp9dCgYjGJ2mMVsnRoiayLnX5
34391	payment	1397	1397	1678	1	1	13399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceeX6gWNvH4en9KKrY5JSux22tpzTRNYaSUezMYqwkw8mMXCk
34392	payment	2134	2134	1874	1	1	3888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6Mg7wv88fTphL2xraHW6QaepeeFcEPK4X7VmGEvis2hYYM55
34393	payment	2133	2133	1874	1	1	3805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRKRb42f3YiuTqUfps9fjPNJdAKFt6QyHHNyLUbM7uAhebzNS
34421	payment	1397	1397	1678	1	1	13406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5U5dsv8KyT2ScHewERC3rPiXotQHFK9q3JePi6UEJJ5ctaad
34422	payment	2132	2132	1874	1	1	1099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Vw2ot2q3sAzq78w4t1WRkjyqroKYkHThJY3JNKqDS4MUjPLg
34423	payment	2133	2133	1874	1	1	3812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdoMPBCsp51dUCCGTY7UJXQ8pnccFuC3RbBSj53PBfP7aaR8F
34424	delegation	2298	2298	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjwvj1uz5xZVRcr8XoEUp8xzJok6HLVnrCN6wwQpgCoDDoP3H
34425	payment	2134	2134	1874	1	1	3894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1d8fh31taGMbUgBL6djNVypaWdqcAYZCxccm7W1q9JLi8uNNS
34445	payment	1397	1397	1678	1	1	13410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF5fbi7DPbNRHVcKcYEzztTmVsLEbEY6qKw7eJnFtSDnXkgUu
34446	payment	2134	2134	1874	1	1	3898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnU6YAE83YJAdu3oemL72w9HB3GZQLhbDnf62DrgMmyjYRCjuA
34447	payment	2132	2132	1874	1	1	1100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoHdKSLDeN4Fi5kdoUiRfZAZN1suSrUUG2EUVg45XtScJy8nS
34448	payment	2133	2133	1874	1	1	3816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaqn6fLfbboFerADhhV1YvXdE2xhQviY6w7wHQw2T83rMs7n7
34449	payment	1397	1397	1678	1	1	13411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQud2ooXUq6MizhKfqpZDUnBVAbhdsqW4wqPtEurPA9yh4MtF
34450	payment	2134	2134	1874	1	1	3899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtRRcNP3qcvHKvRqqYoNnn7ezyEdcGmAJrN7V5XeJiZrBzT1R
34451	payment	2133	2133	1874	1	1	3817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnWEWkAo1vN8x3LBN3NgPcBGUNUq9wf2ykWdC8x3mqsNjXt7t
34452	payment	1397	1397	1678	1	1	13412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnGDBR5UXpu8hBpG496Q7nXxb89SfHXyDq21Cyqg65GsiYzxW
34453	payment	1397	1397	1678	1	1	13413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQs4AzvUARyq9entFLJ6SJcGfefJHuatPMUk1nhJVtcNkHBNC6
34454	payment	2132	2132	1874	1	1	1101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wR9XBVh7snCdkaTZ7iuUy5cjzaWjGkk3gWS4nWfL3REbjN9a
34471	delegation	2246	2246	2246	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqmFiChYKyYQNa9gi34SwphuJBAp5G8ngJhxorTpJ5W6U2cMr
34475	payment	1397	1397	1678	1	1	13418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFs5mpnmcfJ62x8YUDMsCL47yjgA3ywRe8sNq2Ss1qKB5eB7h
34476	payment	2134	2134	1874	1	1	3907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXr4v7N4cyrhQmdXWzx1w2tKxb3Mi1yHFkASiJ2rnJTSmCLJp
34477	payment	2133	2133	1874	1	1	3825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZADtaip2xxgGYFcis48UjZnntTW8YAWrx38wAbRtUT4DuW9h
34497	payment	1397	1397	1678	1	1	13425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDxi2ZUywf6U65PPofSU6N7MiPErADzgp5CBcFo6tzX6ExuyZ
34498	payment	2134	2134	1874	1	1	3914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xvhMtYMd2nWxpiWwcZQp4sPaAoDmx9JFmqa4ogivcdpU3t2N
34499	payment	2132	2132	1874	1	1	1105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoD4xP9AzxJcMTBJN9jnb53eFz3q7pGBmSUbYzg4Txgcrjz3Wy
34500	payment	2133	2133	1874	1	1	3830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kX3bbqY1ffXrYR1ffkbHcM6ZWdBh6NFtnQrGQgmpS4itzqnK
34501	payment	2133	2133	1874	1	1	3831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiASZo3x7TrTzPBN7r1gnxxburtPr6yhmohTK2JwiY5eUnW88F
34395	payment	2133	2133	1874	1	1	3806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rvzr6vbQ1r3Wv9iHx7a3XD74eQoqotXQdmsx8vMTsfi8n4qc
34396	payment	2132	2132	1874	1	1	1097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbib4GF4WC6eHfnKLS4NnteiuwcD7wuBGKbFegRxqTyecSqmnJ
34416	payment	1397	1397	1678	1	1	13405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pMcqvELxcr4ZmmuFPctmpztcyKgDhrGViPgGDnEuh7sSNBu6
34417	payment	2134	2134	1874	1	1	3893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SSgQD84t2wQm3ibQiGeZKJwDPUA4sYJSsdek196mLT7o3vUr
34418	payment	2133	2133	1874	1	1	3809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PZ72U6knviEMTwbArN3V8iMVDayaBu92zivN6baQcN55gRXY
34419	payment	2133	2133	1874	1	1	3810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGYXdvqm9gY9G9HX6mzHrxh1a8oeUSdmX1wFyLk79wYzm9tzx
34420	payment	2133	2133	1874	1	1	3811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJZoD1axMzCTeWA9AvbBqi8eUraT6uf5NdxGk7Pqs83LvHboP
34430	payment	1866	1866	481	1	1	24	139034079529	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZp8cnoqXkPr9oT8Ty3gfmrREUQt8rm8MPNKnQiCNDJ17ZSfPGg
34431	payment	1866	1866	734	1	1	25	4213153906	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZRyfFYK5gEijmV1zqZv1TQ2M38tqCEeh8CddMu6WxKNqhTGJRY
34432	payment	1866	1866	845	1	1	26	1207770791681	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZq23SZXYBksh1wSHyzWkAidfSkjvSW19GH3pv6Y5YckCMkv8SC
34433	payment	1397	1397	1678	1	1	13408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktzHiziuC2HTPGc6ktnYdX9GBgKHEdSWqCKPg3teLpLujxAP1
34434	payment	2133	2133	1874	1	1	3814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFdw5KGJzLfVEKCVoDxpSWa6YdunPwHPrt9jRavy92ebAFYST
34435	payment	2134	2134	1874	1	1	3896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2BySjyhQQi6x2pNCiEB75KqEPHbo2mTxKjTnVtHqJu94tDHN
34512	payment	2133	2133	1874	1	1	3834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAkVg5eaxTQvc4WpbVuihbLNi4HTybEZYR9WoLgG29mxk13Fw
34513	payment	2133	2133	1874	1	1	3835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZarhuNWCQ1RshrTgRbGeGNN4nhiGAdAj46oi33Y5Po1BnWzyc
34514	payment	2133	2133	1874	1	1	3836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLhq8TezPp88aw21k2i58cvRwt1HvE6gwCLEvXzivMYGPsu4D
34555	payment	1397	1397	1678	1	1	13442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk2EgWfRpB2yee84DZCWycjqeby6jf9natENHzoUDn4yJVeKC
34556	payment	2133	2133	1874	1	1	3849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnwDTgPhNg34BzZ1in417bGPbKEsX6JAjyFCHtt2Pb5JHGJps
34557	payment	2134	2134	1874	1	1	3930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3sAgKY9ibxEV3guvg8wfPrFE5bEqGy7rsbp4mmwe4mUfMERd
34558	payment	2132	2132	1874	1	1	1110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEV2hbzVbGG7iiabh64TBvsUUhZgLvRx1rJ139BBw27wyvdLNA
34562	payment	1397	1397	1678	1	1	13444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEFwEbkQuAghjfRAiy85WJm1EW6BpXxSUJNaUGphawZpfMtBx
34563	payment	2134	2134	1874	1	1	3932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aYBtGW2Qj4ZUceHcMstZwaJow3eT1rE5ZwQqpiGAuVjVUENX
34564	payment	2133	2133	1874	1	1	3851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9opeQKKu6hUVwYwwZoWkQinpZFsBq8GwkNFcLw7oaovYMeiP2
34565	payment	1397	1397	1678	1	1	13445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSinRBqmcFRVmzR3tY95kS2b8rJMfQyY3B1GRPbtpdDDR5ogh
34566	payment	1397	1397	1678	1	1	13446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdTSXxLZghh2EucnDBbteQmbuUpYbw93c2ZBYxignEtDf8frx
34567	payment	2133	2133	1874	1	1	3852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXCaCd3WU35AJbGmRyP9Thv8viwKn9naPiq4zWKg9A6h5JAj1
34568	payment	2133	2133	1874	1	1	3853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Gd87YmNXEQ9g2WN8KkvsWqVCzJjq6QDtaf65NTRqrsiX8h82
34569	payment	2134	2134	1874	1	1	3933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMACHDpNgk6kshwnmMEZZsd6KNTV21dvfbcvirCzPMXUywv28
34570	payment	2134	2134	1874	1	1	3934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxYpMfBkMCQwn6iiQh89GeyvzDfQhqHLmMQ4ZzgZiQNgi7FAf
34571	payment	2132	2132	1874	1	1	1111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5d6JkeicSDbZAeZqSu3wX1a1DfPXG6yPU9jgCXSsWNRN4e7Sf
34578	payment	1397	1397	1678	1	1	13449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqrKLvmLesc8fL3vegQgK6Y8ttsZhsraZPuJS3KUpQZv685X5
34579	payment	2133	2133	1874	1	1	3856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFLtmXYSt1juuZFxYdtATomFQDNtazhQL1CXifQcJmaQypgKw
34580	payment	1885	1885	1816	1	1	3	0	1000000	\N	E4Yj1dXBXdoJ27GYatUhiLhhFHo8WpTkFWQCKwStkSKBsLxy48hon	CkpZVMiwUeEt7ELHPfLvr1YvVDcSgcGCSQw7a2inL5NQU926RTbsk
34581	payment	2132	2132	1874	1	1	1112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbEX6Uwaovi6Zac4KrF3cXPdqmyhd2gK1VvWgj3fAK8mpAjS9
34602	payment	1397	1397	1678	1	1	13456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyTX7n6t1SnJRS3rg4v1iXMqNErj7Zr5Q45SwvzYFxTVi9Zfj
34603	payment	1397	1397	1678	1	1	13457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUaRnWcQpcJSoBtrjiFR3Ucp4U7FeVbBsnQP2L2rEzv2uwq8Q
34604	payment	1397	1397	1678	1	1	13458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DDgo89L1y1aqDewdyvLMQVoaVTs6PD3JpydEY5YQRtN3qZDv
34605	payment	2133	2133	1874	1	1	3863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX3vpP5p34pfhUXMDH5jEcYeiW472q9NWWDCJrJ28UQMF5tan
34405	payment	2134	2134	1874	1	1	3889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJxjUqP4NGTtswttgfgPj17iadErPFYa5ymqESPQv9wDfBCnJ
34406	payment	846	846	2297	1	1	0	3473785111139	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi46yE5FcyP2kBWfxXazokhp2YjJ1dcxL7TT5hfGX8twENKZ1m
34410	payment	1397	1397	1678	1	1	13403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB94aqaxPQ68926g6F218xXxLXHR4V1wygetTCYRWkrvuaPdQG
34411	payment	1397	1397	1678	1	1	13404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u9x1XsS8kcePb4GDWoatFi9RinsR7x8bcrHmt1bzRt8RGCd7
34412	payment	2134	2134	1874	1	1	3891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbNKAHorC7Bu4bX1jP7wAFwoWpiL8AVJ5RC8PiNxAMw2PG5eV
34413	payment	2134	2134	1874	1	1	3892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6c7GP7iJizvsnGwMZRTAevu2ND9GYajXbsWPvWfGw4vNVDghi
34414	payment	2132	2132	1874	1	1	1098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZVvG986ea4Sk8mtXYVwNTqkghrHLvrj4wUEbmnyhiPRXLYbR
34415	delegation	2297	2297	1647	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnHBTuTEoWBzYUQfDVpMWAN8M88i7MfBuy7hh37VMnTYfWgo2
34436	payment	1866	1866	846	1	1	27	1207770791681	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaBiupEPkFMZRp236BgTZLgouZ21hzwg2t5gkEp9XLscpHJ46qX
34437	payment	1866	1866	936	1	1	28	1117902708752	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZy9MXdGyQfypECUkYLgM8GpqJSVGHi2NwyfwHDAWnz8pxEsgUa
34438	payment	1866	1866	1056	1	1	29	2003272075893	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZ4MzGWue2aSZwoT1D11vwduSHna88mvF8nBEj352pbYUvp8qt5
34439	payment	1866	1866	1176	1	1	30	1351647587623	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYe3fwsHVA8uDojWvvbkJefAJj97PP8mLAjbFVJ2S7U3GksdwUD
34440	payment	1866	1866	1302	1	1	31	3766486184719	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZTCesgp9yWyNm5jBW87t1XYHfbSvwmLg6gcMbUzXZY48RyXd2z
34441	payment	1866	1866	1687	1	1	32	3835744910	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZhKU6ddp13THMYkR71E54xetPY7WtMcKCZgsF4uZixNySmedGx
34442	payment	1397	1397	1678	1	1	13409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4chHUSAWj1sRRLEKghr4YiURLLEkS9jg2GgkQM9fzJ4WMFb6
34443	payment	2134	2134	1874	1	1	3897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5Vj1eD4uTRb1fZsqTiHR26iijqTfuuTbDzpEmHNrdzDvKmVM
34444	payment	2133	2133	1874	1	1	3815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbYzuABUQT31cR2a6FBcVUoJ9pr7pWC3VCboXvQmkjuNXqPTX
34455	payment	1397	1397	1678	1	1	13414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cse7o3p2duqskeRYpnV2vUyBEi4DESniope9uaLVj3jQuvuU
34456	payment	1397	1397	1678	1	1	13415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZEj8h1Z7x4Xna6S53gXaU7SVoPpnfUzdqZ667JzRxwmKWMm8
34457	payment	1397	1397	1678	1	1	13416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNR7qMMTptdqngQPXJ3S7yWAfamhDNU1pV1d5nHg8GpMy2E2X
34458	payment	2133	2133	1874	1	1	3818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVBnp5x98oUmX4baYqTZg9qWgZEUt4fZhzCxKs1AKV42NLYqE
34459	payment	2132	2132	1874	1	1	1102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKai3C8bspi1eR8n6YB7e22BX5U9NfZNQarSZfE5iU1mahcqJc
34460	payment	2133	2133	1874	1	1	3819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmB6JBxPtNahsfie2wiiUGzpGsTVqy1tfRjowu87KCejGtacq
34461	payment	2133	2133	1874	1	1	3820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8egKKibCQCwKaGYCGbVBCk4MvBFUaPjRJxyMrxBHmuY3GttwE
34462	payment	2133	2133	1874	1	1	3821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyo6pWqEfZB8Xx4HTTpcF3eUaBGw2vYEyDS9tJx9hW2Qj7RxVR
34463	payment	2133	2133	1874	1	1	3822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcLJScWY5MhLyavW8cRtkcLooigZTWZNnqeKuity6DTbQrZxv
34464	payment	2133	2133	1874	1	1	3823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFmXHH2ne8P3L7iNFE6ZTos1oG7ffwUoXQuwJYz6kgRHsz6yz
34465	payment	2134	2134	1874	1	1	3900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEkjbsQQjmExLpL2geq5aRSSaVTwimU6Bkt6uUqS3DM8orHFv
34466	payment	2134	2134	1874	1	1	3901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixQ9TFjVhKcc1Vt2jxE6x45NgzgVUvtwmWrkng78iBrDguqir
34467	payment	2134	2134	1874	1	1	3902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBaSoCrgt64dSwZvqD2T3WjpP2HNgdtwt3BKVT3BWLHWFtpRJj
34468	payment	2134	2134	1874	1	1	3903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtmzgiggWo6MNukSgpzLMEy8vZQ4ydzQzpBmp11ZRmrhvuKBS
34469	payment	2134	2134	1874	1	1	3904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrgUoFhCT3x4iKXq779d7j5TW3PDyRkkHPS6yz5q3AtfgHLNc
34470	payment	2134	2134	1874	1	1	3905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotdG8AQ6imakyH6RvASZzmDsEwZ2basHJwC8Sea29bgZ9Akds
34493	payment	1397	1397	1678	1	1	13423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdKZUVVhdB1fzzDqK8KsibF2CYJEY4CZWxuGmt22s1xohZii2
34494	payment	1397	1397	1678	1	1	13424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvu5LHygreViVcTpZhvHxfyDmiSVTdeMuN22qr6saCriE3EPJ
34495	payment	2134	2134	1874	1	1	3912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRRFdQX2YmX1cv6A5rFTZzYVrERdY8LfSMMouTkrZHg9WHpQ3
34496	payment	2134	2134	1874	1	1	3913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAyYC8TfvS6xAjsjp6rdotPSga9aveWF6tdnYx6xdC6MmbqXP
34518	payment	1397	1397	1678	1	1	13431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2e7jmcCQjUXigKrvmWao1DfDmkuwMMHx7rQFhzMsgqKAiTbZV
34486	payment	2134	2134	1874	1	1	3908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M6PhsBPkgyxQC58uKbU2nARVTivzti7AWDkBxauGDNevLsmq
34487	payment	2134	2134	1874	1	1	3909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrscGsngqMd9WxwnCB8XMyqxDAL9VFnM6DLBascxaKr1zyYoSK
34488	payment	2134	2134	1874	1	1	3910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwaNY3piJZUJEvCW5prTHPBkuLAV4DiNMV6U1Px8esdxy2kpF
34489	payment	2134	2134	1874	1	1	3911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdrjpKgrFmhN5boYnqwy6HJo3Ujpnairvx7fQKPLieXbSzGC1
34490	payment	2133	2133	1874	1	1	3827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEQnoAQEXepJZq6Fhff8wecFkMezF7Jdp6EFJxscJ7kfRiy7H
34491	payment	2133	2133	1874	1	1	3828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTZeNJGDV2ZM9eLE7FNGfZwB4WtSJoL6DB1zwDRqDWAP6FcV2
34492	payment	2133	2133	1874	1	1	3829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfENjn2YotGCi57VsbGmXQgAX5aHBiSKr8pb9tujSGXHux7iA
34559	payment	1397	1397	1678	1	1	13443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtorpvqUBjPbzn5bzTsTnvQR84WBVYhGa6SkRVg22VYEvvf7t3
34560	payment	2134	2134	1874	1	1	3931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bHudjPr49fVcxBrgSAFfyAveNFgRPtbDHifrV5R3nCKAyuei
34561	payment	2133	2133	1874	1	1	3850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLahkRTro7nXMm6iKBFM2P2BjwbqY9PE2it3wWyYvRQhPd4cS8
34572	payment	1397	1397	1678	1	1	13447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFHT65GHVy41Dbvnguf5dDinnbN2gdBxSFtKTjQ8iTX4TJYU6
34573	payment	2133	2133	1874	1	1	3854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgC62veTC5j5TvZvvqLdYctNFiJ6AxHQ96aP1e1ypzXAtKQM1
34574	payment	2134	2134	1874	1	1	3935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUmh7mcmQYhsywdgBohEK38AEjUHdA9JnWJzQ9xeijmQfJKdo
34585	payment	1397	1397	1678	1	1	13451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYado3YPew1Vpo12xecvnRQNRJ6nVar1eXqGJQkbT4cPMmC2Dtz
34586	payment	1397	1397	1678	1	1	13452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sL4cAKfWLcoEvJYGzeadnEZPQnuDvZaRkffj7fFQRwReNmuf
34587	payment	2134	2134	1874	1	1	3938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpw97QBbiD2Zj9U1uFhCJ1Lejsg8SDHeivEdyJW64urpMgUg5
34588	payment	2133	2133	1874	1	1	3858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjMgLSBmSN9DanmxsGiFX8hcK7EAqBLn69huukrKkUTNw8y5g
34589	payment	2133	2133	1874	1	1	3859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXh5xiTfAunoHjW1djYtKjSypotxPeXK7eh2fQa7VcCSBNELcL
34590	payment	2134	2134	1874	1	1	3939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk88bofPLmRkQMvUbHqj8vusV9QqvyUDeNrie7uu9PWCNzWrXZ
34591	payment	2132	2132	1874	1	1	1113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbacqpi4D99FHvBvNGLKRXmdindRyQFvJ5Tzbu7WzLK8bb63u
34592	payment	1397	1397	1678	1	1	13453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kK8ZRJLfWg5eYkvt6NVRq1Q1BQrddbynNto1e9bAyrwvErxj
34593	payment	1397	1397	1678	1	1	13454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNgdikEhJ8FmChsfrzBBydhdG8RHFD7P23AvC7ryLhsidtzfp
34594	payment	1397	1397	1678	1	1	13455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbV9LP4i4XFPKkPjjDHE8m64sDTYXLcNqoiuUfnxFnqHbDQCk
34595	payment	2134	2134	1874	1	1	3940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSuxqRLbVCC8PGsdX78nSq12o8KvaXPGJLEQCpSCDjG8uLmsS
34596	payment	2134	2134	1874	1	1	3941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTgqgpKVsYVtT2NgW9F9BLcBZ4YuDTYHgUS4pws61pK3eG27d
34597	payment	2133	2133	1874	1	1	3860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehinVbo7mRXFuZ1QjLe8BQ2wY9n34egBY15fxCELBPS4sZfer
34598	payment	2134	2134	1874	1	1	3942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpueyaQSCTEErerKA4RsLfAtBiNnHFRn54JrvXm1tpjQb3SiU
34599	payment	2132	2132	1874	1	1	1114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgN4TKyRHHdC9yz8NgtNLhdeQhVKZf38RiZGjTC68f9GbTM9F
34600	payment	2133	2133	1874	1	1	3861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa31aTPQ1aKgwUSLJ2kDujTMEJZbu7zzQMArrhJp5Lx4ExySUKM
34601	payment	2133	2133	1874	1	1	3862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTuHxYcKRF58Wq23Yq5ii1d48uU11JFvKopbUnNfjLQbD3xD8
34638	payment	1397	1397	1678	1	1	13467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcYZSLwsdpLdNUbmySVJyu9L9VfTaZsJf2CqRX7hCvpHontnr
34639	payment	2133	2133	1874	1	1	3874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrStMLJXLKXZGUaYLqrPc7TnLU46HXZZ1VzKcEZ7tZsmpAFiG7
34640	payment	2134	2134	1874	1	1	3954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbM5Q3vxDbA1oqAqgQWpQsd2MC3Hoef1xPVMEeDd6qsQbWqXAh
34641	payment	1397	1397	1678	1	1	13468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYczgDiXKMTLRjVw3yeMTjDX84u2mdbXAkWP1bzXK7M8NQx2i
34642	payment	2134	2134	1874	1	1	3955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4egyCffqj8gZboGr3Q8ZvTZTPfeuzJjbkH6ytdgP1H48r8x6m
34643	payment	2133	2133	1874	1	1	3875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCh4tp1344d73CSwGG6RkF5KEHLLqqzZT2uRQRJkWGPUJhBofB
34660	payment	1633	1633	1264	1	1	9	2124134764356	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZ4wJJtnqcLWHXBzzPHo8pZNWLiusj2o1Rx9dvC3EVXxkbwddXs
34661	payment	1633	1633	1144	1	1	10	3148172569418	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZLoUzsaeGoUFTSmd6MH4cp1NFJ4TBP4ovRjS5pN2qGhnjJgoHw
34502	payment	2133	2133	1874	1	1	3832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW5mJy5pDyn3vrH3H5Z7V4cD1FaRTGv6P4e57EZeSBjyavN73
34503	payment	1397	1397	1678	1	1	13426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXJeonvvVGedKE4f8dfL6XJ53ePCjxanUmU4p5kLWvyHLJruF
34504	payment	2133	2133	1874	1	1	3833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBaoyJAW7arXGsHkkhFA5Ej57VBB8x1h8BUno5nVRxttbMEA1
34505	payment	1397	1397	1678	1	1	13427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNeh7pHoaVzo1n4qfEUvdcrL1sHPDTdTc3ZECnJtqUv7wcBGj
34506	payment	1397	1397	1678	1	1	13428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyfcD6Fx8pxzZbWxAbqUVeKMmH1YuXDJ87uyPXR4znMBJUhQZ
34507	payment	1397	1397	1678	1	1	13429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSexikx5xyqoHmGxkms1mWYNMYWKxoU9Zv5vXNCpZjJtu45qq
34508	payment	2132	2132	1874	1	1	1106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5PtMc3StUmYSuMBWVizPXkffmVsD245vxWE5RRWUeq4Wjatd
34509	payment	2134	2134	1874	1	1	3915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTg4rT1SkqYtqo34w3a994DVY5pLTsvDkcUVi6Vkwus63G2JF
34510	payment	2134	2134	1874	1	1	3916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YJUnZENLWN8YwetgcksEBoG49vfsX8UcrCxrBpCpunjopYdP
34511	payment	2134	2134	1874	1	1	3917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroKVn7aCZgbN7RhibspAxBHaKXiDcwtUiCQ777buuZKa7vn6m
34515	payment	1397	1397	1678	1	1	13430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPZKReR4u65do1NdxrXKN3cY9QDgiwep5PVVJCoY2C4dk5buF
34516	payment	2134	2134	1874	1	1	3918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsS25DZfxdStCbmQkyNAK81nxZq3DZQutjPHuZBmvNL8yURwa
34517	payment	2133	2133	1874	1	1	3837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPqAiCmdrNybG9BXHpbopuvFoMz6bn5TLtCPMgTBBrsCRiAbd
34532	payment	1397	1397	1678	1	1	13435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDUECyCTvyZkNWcgd5ZWvSjoyEcLBvWGE56R1R2XBKLPhtvMQ
34533	payment	2132	2132	1874	1	1	1108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5WSm9fjrKoaN9ho6xcYxhm8i2UVWagvbQL5NayjorLsQrms3
34534	payment	2133	2133	1874	1	1	3842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYijGh18ZscDDFykq5AsirDFtQ3rcph4hj3ZNcbbUhXGJjHG5o
34535	payment	2134	2134	1874	1	1	3923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9v4QqJVRMpzE4JF54A546x3yevndNACcdBKrNrD8ErZ8A3Da
34545	payment	1397	1397	1678	1	1	13439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWyhScohRMYZRPrDcfoAiDuiRTX4canv9AmJK7X4uiz2f4VNi
34546	payment	2134	2134	1874	1	1	3927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTqCDqkHPzS4jhhKivB8eXK9LTS1dzH6qP3xY2YmHvqkfx2vw
34547	payment	2133	2133	1874	1	1	3846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqU5HT5dvJe5n49jviiJsZeUuTYFbUh6t2M9JZSVCKVDMBkDk
34548	payment	2132	2132	1874	1	1	1109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCZxRDTFcY2JtQmMmQmSCt8DCNXLnT8TDYEcb7L4UYbmBuNqw
34575	payment	1397	1397	1678	1	1	13448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMLYmSaJjZE5kzwFpB3FeXCo8c9VFGSuYDAJV2PxXYHULMwN2
34576	payment	2134	2134	1874	1	1	3936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqt7ufq6pwpaECRgvu6NLBKHTrdChTq4abx6XLRoio4JV9r6kJ
34577	payment	2133	2133	1874	1	1	3855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZmMKqzohn5JZqNEAc1fM1nKz9J24t4ccYv4SfVkw2Ysj5S3N
34611	payment	1397	1397	1678	1	1	13459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU5BXUMxM6J1nrfSkgQg7bsMHzaPj1JSrRiAzDr8aq43JW8ba
34612	payment	2133	2133	1874	1	1	3866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDfsTZuNxZcFRCAmZTNSCG9TjG3YrNq9Qi9NfT3opJBxHXEhd
34613	payment	2132	2132	1874	1	1	1115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf84x7Xi19XSBuiyaRj9YSg8beW7PxRJTKbY8iW69jeXCo1KWR
34614	payment	2134	2134	1874	1	1	3946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTNjAoKbD2YikvyhzjM342X66byGdJiRPVZ2zqG352YKFJPCf
34615	payment	1397	1397	1678	1	1	13460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExmKF4ypneZCNodvdQyuijrpDbeqNtuhBbMR6LwrEiwMLVyja
34616	payment	2134	2134	1874	1	1	3947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFF6N2LvQdvXwGNE6GdpHvoXNN1Wc6xHVjRdXw4FZ2kLrqs4y
34617	payment	2133	2133	1874	1	1	3867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoR262pEaWRZEGSjM6nkSG7hQg3v3rU5oFokMuZh9QuZK6M5t
34625	payment	1397	1397	1678	1	1	13463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4AQ5bMmwRUR4UPakqopxbQzPaqNuSK2voooLLNLyXsJTWwVA
34626	payment	2133	2133	1874	1	1	3870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDygRoh678HVqfaM9jYjcUED1rh6HZsmnTzkdAyrpwLiVers5
34627	payment	2134	2134	1874	1	1	3950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykdwbjfwWJrncuhAJE5hZceTJ4wMvrJJt6tAdbSDEByEa7Px8
34628	payment	1397	1397	1678	1	1	13464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1szeeuxUfZ4ecVwJ8S9u3prfqvVsZw7gbyhLqG4Yq5bBX24Q
34629	payment	2134	2134	1874	1	1	3951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzN6TrfKGm8C384noEtWK9Mrk6gtcHo7Uj21wn2HhpngtdSc7W
34630	payment	2133	2133	1874	1	1	3871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRu3Tm1kDPNDWXUjjQEQm3VNxEbuWF1VhpRbgkrgRFW8e3Uz5S
34651	payment	1397	1397	1678	1	1	13471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83Pt8WNHnEH2tRhuEgMw13n8HGyizuJakhfXxXkx1HhvTUkcn
34519	payment	2134	2134	1874	1	1	3919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJpnL19GQ67CyiBNhFoE1fzVBvYZREUob9H8yorwTMpLCeRzS
34520	payment	2133	2133	1874	1	1	3838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnt7E5KRjLxnZuBR7Q3n6Z3iecf8ie3fCRfpAgPNshkpWvbKRQ
34521	payment	1397	1397	1678	1	1	13432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfbuoMoZ5Yk3Ba34oYyfg6PkpF8X6SjuhjtBN1nfwNtFXwnr2
34522	payment	2132	2132	1874	1	1	1107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSQeGQ83Xdmys2uZwFeEANCMVY3oexBnzeDDAsneyajoEZKy6
34523	payment	2133	2133	1874	1	1	3839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XYve7jFXBgDDhe6WB5f4qAyVjfxc63cZDTgJAub3SWYvSfNf
34524	payment	2134	2134	1874	1	1	3920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4psJXcUCw4UsStuGeLfsYDif5q1cBnqMommHFE8Y8mq9gPy7
34525	payment	1397	1397	1678	1	1	13433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkFz6UD7DyxX2am2X81W6DSPGk2p29vXNYJjisCDhstbcAvj1
34526	payment	2133	2133	1874	1	1	3840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjr81HHG5XKS7KvNcf8hsC7uoGcZ6b6f9j7kxMXvQTTGUBs4P7
34527	payment	2134	2134	1874	1	1	3921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrs8LUPkkDahZuEFUTArMiYV28oNZqjuVh7oMf4WYH9BnBHWfd
34528	payment	1397	1397	1678	1	1	13434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybB6xDMVoG4QLnqqY1kk7UoLzwz7XAajUaxY8Jw5Gz41VT8qd
34529	delegation	2112	2112	1607	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xoizmG5mu2qMm51J4BkCD3ZP4UU18x74QaXZHXfeQcg9zfMP
34530	payment	2133	2133	1874	1	1	3841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6h5S6FtYxDtkPgPsSmceLF4NJfiRs5regRK8Uq3iqvZhEE7Z
34531	payment	2134	2134	1874	1	1	3922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32sMnFuQi5Re7JHzHBKCEGAcvRyBTYG67aAHtsS2rFPh3XkDV
34536	payment	1397	1397	1678	1	1	13436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSErtmsSCn5ZWgoxHWrHDwCbTXuWLKvWSyNGcHCUuGsDX5N3oM
34537	payment	1397	1397	1678	1	1	13437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcs5Nn66gjYdHbPLk9J8G7JrcgkqiFGrdfPdpU9CMm9NbjWf3u
34538	payment	2133	2133	1874	1	1	3843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZxXh84w4ThyYTnqXwS7sxLJx1HRmXrrfbYYCBxeQDnTMRcLs
34539	payment	2134	2134	1874	1	1	3924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrycPR2waU1iJUSRpJPj8hhGPNizQhegJiUK9uunWfqbKRPsxk
34540	payment	2133	2133	1874	1	1	3844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4pUhUWV7Szoa5AnSmSAXqPkE4iQmSQ2GezVF5JXxvuaAeh4Kp
34541	payment	2134	2134	1874	1	1	3925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAwXecr8PpndLVHTdHqAZm7gCGK38i8vpXz9ERJmP74oT8sCJ
34542	payment	1397	1397	1678	1	1	13438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP1Nrcbo3ZrVPVwGYgkGbZaAnkzme4fGAxi8YsaRARbqScV64
34543	payment	2133	2133	1874	1	1	3845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSp2z32u13nB712sg27mkdrntzvXtfTW6iAb6Y5e68nUFsbruQ
34544	payment	2134	2134	1874	1	1	3926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAztCPJhuZYmwgqUz7mgMoXKmJbERqiA7xKzn9xDL9brRWoa9N
34549	payment	1397	1397	1678	1	1	13440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6idXoHL7aDpPvryz4t7kdy7Ye9CkAgUGDqCKKfAd6F3WjFGR
34550	payment	1397	1397	1678	1	1	13441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAqxxPeniPMFSphFm219cwC951VqRYJvoswiKtgc2ym36Rbvb
34551	payment	2134	2134	1874	1	1	3928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcoyuyLDLTbQtkrru4znq5jmHBqwUkGK3CbzKwdX6AdzrPhac4
34552	payment	2133	2133	1874	1	1	3847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeykwy3nvXWSMZVuy86ZXjSJFzpwcev1PpQxy6oGevBsefkvun
34553	payment	2133	2133	1874	1	1	3848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMUEZHSiG6wD2pJPKGYzksFiYAnnxghj93c3TNnrJL5fZAVaU7
34554	payment	2134	2134	1874	1	1	3929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7vB5GqtH2tAzoQSfsG2SRkrHaVB8ZPimSqtDb7z3vnhVGroL
34582	payment	1397	1397	1678	1	1	13450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYxMFRBz4T3HtedMnjVvPNEMYgYPQS46sXf3PVKcfK7ccjxtk
34583	payment	2134	2134	1874	1	1	3937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfpskM2giJMZDaoz56fBE3yjK8vyjmuGrKQz5a4tuf2BKVRwm
34584	payment	2133	2133	1874	1	1	3857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6uLy1CfATS8DJEBrnDByu7owsNkdvW9ypqP8FEN7wCfx8GQU
34618	payment	1397	1397	1678	1	1	13461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBfJCbzzPG5SDhsr3s2eJco7U4w1at5ujSfR3AjfzUb56WZhb
34619	payment	1397	1397	1678	1	1	13462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnG6n9bxnF1hLsQpiLDTe566SFY1MvMQe3jqhTNaTR47cQACR
34620	payment	2134	2134	1874	1	1	3948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrD5G1cTVG9dkSgZDy5ZyyJ9B4oTj8rHLhTHP7MJpRAwPTZj3o
34621	payment	2132	2132	1874	1	1	1116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xbyfYhoWTf7BuYk9EcVhpy8XxZEhcddYqoAMXXSFi2T2oji5
34622	payment	2134	2134	1874	1	1	3949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgzk3KYkYewwdookgq4LyTXaiuTW8MWSpkdquBve7dFYwBZS6
34623	payment	2133	2133	1874	1	1	3868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zeso5mBqim92uqMpLapUXUN9fJKMKjkv1Lp983VabpHLMRfo
34624	payment	2133	2133	1874	1	1	3869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDCwbFwkasQSUrbvobj6YUqUuhAYpU6eq5FpFHqRx3iUmdcC4
34606	payment	2134	2134	1874	1	1	3943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDa9RdRqmt3n1atz9EdvDwkbbUjmRoME3V1te9h9yKLqxAJey
34607	payment	2134	2134	1874	1	1	3944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUpSLM3Zd9vyeuneBWoW62Jtn2dKv4r8BUZpBverkg9DMVnMr
34608	payment	2134	2134	1874	1	1	3945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbzaseCgETmZkrj8f4v24udtk3Uqx6DEdu7QS6DgTEvX155iG
34609	payment	2133	2133	1874	1	1	3864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53946E2pn5sfxaC977KCZ4KDNSMUMW41cxPyJjhhcbXhznLgU
34610	payment	2133	2133	1874	1	1	3865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjunxMijGiZ49S4PtsUiLMfkpC8jM91TVzqU4tjYy6Jqwdb889
34631	payment	1397	1397	1678	1	1	13465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ELcfNV3CXQde7ByJChguPFyepTN49nvwexbv6U2zJkRhAN8k
34632	payment	2133	2133	1874	1	1	3872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNz7BUJru9ki3mxiQwzsY96Z2WHc49NKeUB2ii5GA33cpvxWa
34633	payment	2134	2134	1874	1	1	3952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtJ5cEEdxXuGvBYdZmpdnf49vMnTLj9GqUqjn4srfxVmV5zaj
34634	payment	2132	2132	1874	1	1	1117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuQq7XpAbAu5PHbdHfmKqaMraga1tebpUPwMFF1hDB8cNyPUS
34658	payment	1397	1397	1678	1	1	13473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9N1jjhCMu8YGaDibFhFh4D4NSaQF1Uh2atMsfDZkMN5kXXsy
34659	payment	2133	2133	1874	1	1	3880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcL8RSVsDcW17YmzcjF59DBA4AcxfbnNPJ1wA1acN5AK35rY9
34686	payment	1397	1397	1678	1	1	13482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3eAVizt2EWgfdWPCLuJ5PE1gR2V8vRQgKJkT6zGFTxaPzaaT
34687	payment	43	43	2028	1	1	2	80000000000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYoGqdZ8CaNmLwJketFWxcKK6djohB29H3CGAzzb7T2dYLiTUwd
34688	payment	2133	2133	1874	1	1	3889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYeLkAs5KgFWhJKXBezFf3BRDqHN9sbLTXnsEFnPCcx4GkSJF
34689	payment	2132	2132	1874	1	1	1122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vCURGs6Mwci6mXnhooBJAoKNQByNwvZfmRs11J7vaoQe3FZg
34696	payment	1397	1397	1678	1	1	13484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYGS9FkNAQzUuzLdrh2mRovBLXQg9hh8j8iaQKXQDy6Tft8px
34697	payment	1397	1397	1678	1	1	13485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRqUQWvqL23WpCkDSjLvE4zMcQN6ajPCDxfLH6JTJnMnv7dhu
34698	payment	1397	1397	1678	1	1	13486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQP8psGDHNRdRd3xrxC1f3aLGFXSR4PSRPhADkDx4uauSUPf2
34699	payment	2133	2133	1874	1	1	3891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25oQzkeeYtrRSVRNb8bqaKPPMV96BETm34mbd8cmxzWQcM7Qi
34700	payment	2133	2133	1874	1	1	3892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPZdJkV4irc7Af2gPNTiKzQjAGmu6whR9ctxEraiSpMcyCBm2
34701	payment	2133	2133	1874	1	1	3893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZxkmW5SPHMdJugbHDMSqgjehbxmWet2SyXXW1pTpsuyaLBvm
34702	payment	2132	2132	1874	1	1	1123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpaX7guvntNTN2yadyPkTYghLoSypF8hXGeyPRW33ctGLwb8Fd
34705	payment	1397	1397	1678	1	1	13488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sBadLjq8eAH2bq95AvuezUJbq7w4XpsS3QaWaHcRvCpe6xUP
34706	payment	1397	1397	1678	1	1	13489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGdgGSd4Hic29XvfH4aRKiMFW7Krj69VjiqbBfPKRLZ52axx7
34707	payment	2132	2132	1874	1	1	1124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkcjCEvqWFJYn54BUnhSZuxfsWdKYJJD8hKsm2pMW7KJ6kPfP
34708	payment	2133	2133	1874	1	1	3895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zjSRFW9ounWUotzuHpWYigbBUeNQRuW4xZR2vPoTFrDGR8Tj
34709	payment	2133	2133	1874	1	1	3896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHsrjPXHdEFPLYR5AE2jD9EasChWD6Mpd8vbuBtwKv71JGSgc
34716	payment	1397	1397	1678	1	1	13492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6v1TvgZ9XQYMs8b8Z1yTJaSeos4fTCxiTWVuUxtConaGN5BP
34717	payment	1397	1397	1678	1	1	13493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EwPWjknKhqwKvBQMKvssVx4sSi8Zoh55PVRKV9ob25p8Qoyf
34718	payment	2133	2133	1874	1	1	3900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBJksToSggSxq7WCbe9DzwdRjDVwmzbBjdCwSJyfDnP3Nz2T1
34719	payment	2133	2133	1874	1	1	3901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYqWM2dKJWynzFTXjGUfMQJUDksG461Jyp5RJF3zcocMARfkT
34727	payment	1397	1397	1678	1	1	13497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeYgMEtiEcSVD2BeM5yGWu9E7reXHfyeGuhwzxBGX8beYqfET
34728	payment	2133	2133	1874	1	1	3905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5eBsNej2pP9ygFjcoe6nkBU3dKVP23rj1PRbrAmtjLprUJS9
34747	payment	1397	1397	1678	1	1	13506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLyEtYERppu4U4WvgoM4rAbtick3URT9qyRV8fxiFYGTqaCcx
34748	payment	2133	2133	1874	1	1	3913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3j97AxzByj5ieUyFrtUgW66cSs55LyS4FjyrWBma3fjmpzkj
34749	payment	2134	2134	1874	1	1	3959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgzhDmYgodG6GoisPnLv9K59yCf6xho9JSnJjqrbQ58yxPgXH
34787	payment	1397	1397	1678	1	1	13518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vYxNBYdnw6bEB84LwoTtfLTWgPPv2fHiM67V5KzwjL8yTBwR
34788	payment	1397	1397	1678	1	1	13519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtALX9TTAwSCqBXBhjmwCm9r3B2TwNR8v6oL3QjkSGTHPSMJ7
34635	payment	1397	1397	1678	1	1	13466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP7Qfx2HzRmeDcpLau5vizMXB9coSkZSAxQQYaNLupPYoPKgw
34636	payment	2134	2134	1874	1	1	3953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW8SLcog8AqhK6Z9bn9faPA8JTC2LBY9Az5Pq1kAY1pZP5HQD
34637	payment	2133	2133	1874	1	1	3873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBgrEd1X3vk59QDDkyx6D3d4u9sAsdQVj9ch5t6tEc7mZZxcY
34644	payment	1397	1397	1678	1	1	13469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYAQzzgkU6rELvDVFcJqPaMkJyfDWqJrrS1YZYaBrrRSumSiB
34645	payment	1397	1397	1678	1	1	13470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZqmPBs9jZKzraztUD268FXy2ZJTpJQUCRP4rpWM2Bu7G4KHV
34646	payment	2134	2134	1874	1	1	3956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshyRhna8XHnP4K9Fy6d4js8KGFEHAPDhNuhbzRnnMQWrWY5Na
34647	payment	2134	2134	1874	1	1	3957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMCVtaehqPQZXjLaBzzCsHbn9X3M2jdaX6p7pQnEmUorpu5XU
34648	payment	2133	2133	1874	1	1	3876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUVWgYNUuEaZNJQ5ZokpqZYCF2Rrje131vi7AdBwquXDvscqT
34649	payment	2133	2133	1874	1	1	3877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNARKoU9ocUvSSLoJTpW71WE9rKdqMvr7MhHCGJntHQkaiVBBY
34650	payment	2132	2132	1874	1	1	1118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89pyyrekDzJgBZk9Q4eLqdSjryaJLjJzdpdt18FbZPzBtVfGV
34671	payment	1397	1397	1678	1	1	13477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNuwm1F86MuKXt2znmdetAtDgCvqToU6fSzjqf1VDbvnVLWKZ
34672	payment	2133	2133	1874	1	1	3884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCKfGCwdjjffTymU5EvBwL1YkSsB5Lm3sfNHcYg11PnkPerVq
34673	payment	2028	2028	1310	1	1	4	7338894580000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZ1tthRrwxZBT9MV76Uoj3UfWLoYUaSkQ5y2iqLPVKVFFhzD1SK
34674	payment	2028	2028	1184	1	1	5	2633648090000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZtCskPisvxFnSWuWiVaGUxAJ9h7YwyRYA1yJQYPSLKw4sXsWzP
34675	payment	2028	2028	1064	1	1	6	3903320460000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYZU4DuTDgYXqpweDNPzd1DvrpQETyWDENb9M8jreQaGmb5eiPU
34676	payment	2028	2028	944	1	1	7	2178202640000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYcCc7kfrQjuk54D5shRyifg58htHmxic1z6PHWzkhnsa5YLv9D
34677	payment	1397	1397	1678	1	1	13478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAcbi6LAHxwStkuEjbLaZSLmkuiTp9xCzTrehmMCCtydicQ5C
34678	payment	1397	1397	1678	1	1	13479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuuMh7V6KqtAsVm5aDM9snH4eBXgpvGPmr1yBwvKLJzjgjJtn
34679	payment	1397	1397	1678	1	1	13480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarpJ3pgERLipn8oh64LQVo2zEMXCyzBHgiLxpfgVimC9c6x8k
34680	payment	1397	1397	1678	1	1	13481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUztmJdCJY1YRYnaSJrL6UV1cC3JcuLzjfmH9K316W8cU6P9B
34681	payment	2132	2132	1874	1	1	1121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGYaMSydTuFo6D1KJM2xfekKFKV8XitEGT6npBooQ4vu6pqk3
34682	payment	2133	2133	1874	1	1	3885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2LqQ18zMXYRnecQYzv62k2nuwd3B9ieh8ZP1uT2CBYZMj1Vs
34683	payment	2133	2133	1874	1	1	3886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s9PwjvNYcxdFES3GconKD3fF31mV461CLTr3fQnmhn6VHSqo
34684	payment	2133	2133	1874	1	1	3887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYWMSvGaV9mi1Q6QtYQKBaPzBSHsqr3TC36u62YUfRRLLKAzG
34685	payment	2133	2133	1874	1	1	3888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgC14SKnwJZx4LnKHF8LtBGnscAunxJdF6JgRoSwqaoReec2C
34725	payment	1397	1397	1678	1	1	13496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEeBQ4ENFni6uZRssR6nJ8Xn1qr8tPaAgN8hULjyZEehtnE9p
34726	payment	2133	2133	1874	1	1	3904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxTD517peaypJXrdWx6yn5FmTEudjUb6KNnJHzDqWncanzvCQ
34734	payment	1397	1397	1678	1	1	13500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hNmRGA28NhiLEZMT8HsTNNoZPU1cTkfm9Pp9EQ7a84yQrWr6
34735	payment	1397	1397	1678	1	1	13501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbahaN3j7m8RtgGc74XJP8AUWDFELAZ2ZsQQfGuAYVqqfkisAn
34736	payment	2133	2133	1874	1	1	3908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfyQ5S2SxaGiSwgjXpzRM7hkpHHmdYacazHtqHNFqmNDtAPTF
34737	payment	2132	2132	1874	1	1	1128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZwWZdKjoJqhRhgExL1fXzDskDv8f9L2CsiweYLWp6HwKtYDh
34738	payment	1397	1397	1678	1	1	13502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZanYSEbSWtbJbzNreVepFcVDqYysLjspzWMLnoBrhwF8H4bGp
34739	payment	2133	2133	1874	1	1	3909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJsyG4e4Ng61da6TW4npd3nY19JDrWK5CWRQyY4pdvcfAh173
34750	payment	1397	1397	1678	1	1	13507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56xAzT3vQhhYZWUqtmkMz4MHMqKEoRujKRkgpk1UCDqDPxGmW
34751	payment	2134	2134	1874	1	1	3960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hriyT2sadkTbm2dP7uFNAqChLgV6EdBKNs9EDUCDw99ygnds
34752	payment	2133	2133	1874	1	1	3914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpPN1xdgTkZxLM3bfBnxhfbcNPaMq1442KyT34Wb5VA4DtwBC
34753	payment	1397	1397	1678	1	1	13508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1HQ12owPSL5HGz7UkuV4p5QmuZsY6nPXcDozW5ocB2odMN8a
34754	payment	1397	1397	1678	1	1	13509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjsEeScr5PUg1QZiKQjAdEaWxsrWxUJEFVYPYnCLUFhSvJuip
34652	payment	2133	2133	1874	1	1	3878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvEKK3fTDCUQAwEopKXmnbdWABJvvD8eDGFi2HWGqHTyVc6Bd
34653	payment	2134	2134	1874	1	1	3958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bN6asMByiymPjcbBAxhhbaALZX4VYSrfNrRMzyHU5a6woQVR
34654	payment	1633	1633	1024	1	1	8	1756801128175	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYyddoUoVJUUGYTLMEiXMv5HY1cSJxTqTgeKutJYWA3aokDRmNu
34655	payment	1397	1397	1678	1	1	13472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiLsQo6Xc2BkPa3e8PTNZEB1bKdkqbBQ5cAKkpjstdDzEWzSQ
34656	payment	2132	2132	1874	1	1	1119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqv6ZyA4UHEvzJE3cMtFcpmtsUGmb1kYz6EA16hFau22nj1ccT
34657	payment	2133	2133	1874	1	1	3879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuq54UkJFVM2cgdhczuuD8oNCiGcfKEmSptZWfk83GoN1NMD4T
34703	payment	1397	1397	1678	1	1	13487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkACv2JwuupyfVJNXwyWPvFiM5Zcg28to4ifhU73wF4x2tbRwY
34704	payment	2133	2133	1874	1	1	3894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJWBXLm6oaEByVHGu3SUyFWFtuh3DKrTnPJ3BAVnkWTb15fHr
34710	payment	1397	1397	1678	1	1	13490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LuQwL7tBUiAD4LTZNKCUmgKPpT8C1fk9xpgfTWPDzjZH35ns
34711	payment	1397	1397	1678	1	1	13491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz14Ek3kunpsAb5My9HMoFQdAepegbq43oxYpSyJcw4afTJUcd
34712	payment	2133	2133	1874	1	1	3897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXvoYJHeRj1Et5Fp8uNKkek4CfB5z1DubAUtmkVbs8z7t2bz7
34713	payment	2133	2133	1874	1	1	3898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbM5ej6UBUTsXkXjQm6MVj4ERz7hm2tCZrbjYPBg6SLjvqcEv
34714	payment	2133	2133	1874	1	1	3899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFnYLxxN4K4qbMvNzPd8wUrUSepdDdEmueHyuxjkrqS2zMW3q
34715	payment	2132	2132	1874	1	1	1125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5h8EzATJ8tC4Yc2d8qkNhLh8VWNzj54Tdh9ys5VZ52JjyPkEF
34722	payment	1397	1397	1678	1	1	13495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cAnRkgaprPGg9PspHvSVHL7Hkdy96f4XcyBmpj6Q9QHQ3Hz7
34723	payment	2133	2133	1874	1	1	3903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbQbEtKtiRqRak556JwPWwMNGanC3RfbQNtLUJ4dLsXGLCAeL
34724	payment	2132	2132	1874	1	1	1126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEGGqDSvRVtHhHTJVuX1rkhm5DzXsYf818QPyPcYXAvFVURQ1
34729	payment	1397	1397	1678	1	1	13498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEo7Gr7MQbgY1m1RY69hF8quRhiKN5vcXFb6JFcfLnw7251Wo
34730	payment	2132	2132	1874	1	1	1127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraf5B5YV2ymspgmYmBPeyYshEhQbMp1d88r57DUSazvjvfQax
34731	payment	2133	2133	1874	1	1	3906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvAAB2Ho5ELRXfbyuViUHqemHmWj7vhvLFvomFyxgW33h7MhP
34744	payment	1397	1397	1678	1	1	13505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pBKp5VuLhxHgfkeQ2hwRa3KWzQ3vfvZmY9daiZ2nx3x1hx1E
34745	payment	2133	2133	1874	1	1	3912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDW6yvtCyhkooa2tCKCMSmEf1Me9K94LBTyUb2uqYFuN3d4eM
34746	payment	2132	2132	1874	1	1	1129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBMG1jJNrfCw8tBGT3Lzj62fqtj3K7tqQ6rnvq9F6WpAUs62Y
34781	payment	1397	1397	1678	1	1	13516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB85FrpYb5SM4PomXUxpSdTNsHwtVeBixFMjtM46LuJ78bnqh9
34782	payment	1397	1397	1678	1	1	13517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcpsFUb42sUoX2WCbQgnDxPtwWqAB4NpJ1Mc5X5qbW4sLGYGA
34783	payment	2133	2133	1874	1	1	3923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDQmfUB5Rj9p8BXQLD2F2svfsFteZcDMmjF2PAnkUMujVnEho
34784	payment	2133	2133	1874	1	1	3924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPohP1WLf99tUMUPrYWgokJXzMSke64PSMK7cz4ogZcRMerSW
34785	payment	2134	2134	1874	1	1	3969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNyLrhwfFc38bFrbua4mZ1TPa1FJsg8FjxnZnQRoQssoEsUQ1
34786	payment	2134	2134	1874	1	1	3970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyvvPXaf1vrWvDoZbE1oB3yVE7fHV2nZA3ASP5sj3NuJbxUiH
34794	payment	1397	1397	1678	1	1	13520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bYZCtPeGzB8GfUxGYy5CX8w4hNbWKKc3tkj8SLHgWQjcTg7L
34795	payment	2134	2134	1874	1	1	3973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXgutjxmgfTEf67zbci6wZYxmJbrqGwsZqDxS8kwLyz9qEwNc
34796	payment	2133	2133	1874	1	1	3927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC3f9M4oqboTjCmM3QwxZSeSmKahuGdC7iJUKARsQAD8HSz1a
34820	payment	1397	1397	1678	1	1	13528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6t8wxq9RfyDCdXHgAR1GwC1C3tf1UJwgtpMX9sxwptBGb3r43
34821	payment	2133	2133	1874	1	1	3935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKtv8bXYcdMVNyWuB4NwsharxakQQNLrNeBvPUhTXXc69kAYV
34822	payment	2132	2132	1874	1	1	1136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEkDfeWSpkT3hu45N5zZvgVKP4gBHFxM94e5KVQkdCg1H84FT
34823	payment	2134	2134	1874	1	1	3981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gJ7pSk4ySYpMbygat6haHq85gA2WohiYqLRY1ToyFEaELPfj
34833	payment	1397	1397	1678	1	1	13532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3w2LXXGXihmEHhb5NroA8eYkg22xj1ydgDbaoERqXcW6WBot
34834	payment	2133	2133	1874	1	1	3939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdr4gFVfxJkSe7Z4f6qtpLbqvQs7Wf97jdAM3F3ebdirdkH8SR
34662	payment	1397	1397	1678	1	1	13474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFomaSCBD2Cxt8j3jxYVSbyECcE7hvjPWMkCqzywUSJLVMJsrJ
34663	payment	1397	1397	1678	1	1	13475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qMufBnsDdcEeabPrVWd872JoSdy33D5shQQTbvry571hyEe9
34664	payment	1633	1633	1390	1	1	11	5919090388412	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpaHUoMEyozjM7gk2RomABpCbApnMy9cKg68jMwyySe7KmCBwTbX
34665	payment	2133	2133	1874	1	1	3881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M9Q2K1cpbgyCTv3mtJLrfDJL9XVLSs1pBsVfnyKzK6AFz2Dc
34666	payment	2133	2133	1874	1	1	3882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKTLFXPvWgPrdWdNrLkJuTHoRBjuxVuY7jmTneNTpHo24ZZXF
34667	payment	43	43	2028	1	1	1	17201000000000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaJYZqMCzdcuvRGeRgoR2SrJpMqc3trLuSvhTeqB8M7yFr2r9r4
34668	payment	1397	1397	1678	1	1	13476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9akUgdHjiRzLkD9UBr6ifoEnEUK8hp4gfQdnQk5rHPK2qrDB
34669	payment	2132	2132	1874	1	1	1120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyUyDYsH62KYs2tsAsBfHaCqDzPtknY6JXScor2bkHq9wWiEf
34670	payment	2133	2133	1874	1	1	3883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JhRXpdJvF8f7T7EanCNDDQoszuMHWuybFT1cxpcgpxhVgnzC
34690	payment	1397	1397	1678	1	1	13483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgF2HzXNjRLvrYw9zcMviZJkZk4XJ4xbHGZYVDey8r7AE6JG5p
34691	payment	2133	2133	1874	1	1	3890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReXnKzN4juHGKqZYD8U1JJNdW71Dp4Tk331mdK4m2GKC5nFyc
34692	payment	2028	2028	1310	1	1	8	34134390000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYgxzrpJ4U6Vpp7HqJC98TPyJ6jq3ZHnmJq4Qy1kBzZK92pyti8
34693	payment	2028	2028	1184	1	1	9	12249530000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZEALV665YSK4CGAD8nkpAjJSdbqFPRWeixwLKn3Jq8L3s61AYA
34694	payment	2028	2028	1064	1	1	10	18154980000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZvYZd1Je6J1GZedwamDaA38URms8L3Y2QeRPWTheqx3bMxTstE
34695	payment	2028	2028	944	1	1	11	10131180000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYwQKb7yX1hRuiEX6FPyGbT3v89ctSU9nLHkVUZWmEVFj7yGSPE
34720	payment	1397	1397	1678	1	1	13494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9PPaNuDr2h1UZ6gwq3KpEGDfBBzKKUvhpUB9Rw9KMYk7uPSk
34721	payment	2133	2133	1874	1	1	3902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMQQwcxWu2PaZTnxtGyHhfJym54HTbRVDyBBditwFFzQaS6nS
34732	payment	1397	1397	1678	1	1	13499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouZcyjCUMLFvYVLwDMbVBrfx9qYd1sXsLYWi3Bte2jwPmWkLq
34733	payment	2133	2133	1874	1	1	3907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FWUx93mB9hsFJY5i57v2zZU8skKQaKjm96R8gYDFKd7yEt5R
34740	payment	1397	1397	1678	1	1	13503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dBgJYsycFciAdzGETh2C2ukv4x4nYnDowkCeEGrQzTuwA6XQ
34741	payment	1397	1397	1678	1	1	13504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcz9Ca9ePGDZy816yF62DHVhnVepM1V33FHU2oKQWGjXjjrZjj
34742	payment	2133	2133	1874	1	1	3910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgYjEzhNVEsw8cP5JTQfM3unmWx1Na2pLSAMYKaMpVpjmHzL8
34743	payment	2133	2133	1874	1	1	3911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR5HJwe5HnefH2MX64h4bMHqRsLh2oW1yHvuPU3rkwAyooGit
34767	payment	1397	1397	1678	1	1	13512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uQBzp1T1KDWhPGwgBmpPAisPSZU6CfUbLPqHqgL54ivn4FGc
34768	payment	1397	1397	1678	1	1	13513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdrkzZ6s8kJsYuX5YhT2Cc9YmJ8eHni5b8GPYeJCYoiXPjYFT
34769	payment	2134	2134	1874	1	1	3965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnzcHvrifizZTGMm8UUFvnJEcsudX9AmGSAJGJHhBE96BPSGx
34770	payment	2134	2134	1874	1	1	3966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ7GxL7Z14CzXm3nnXPwrK5qqrUaMkV6f2NsYWr9d4fzfWv5d
34771	payment	2133	2133	1874	1	1	3919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFdiBZNKeYfZQxvpDBDsWFYpygMMg2dFMD1Hy87o2vyYpyFzW
34772	payment	2133	2133	1874	1	1	3920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjUHL4XzcDpH7dkwvrozbSdhKH97Zd7nJUvfiFmFKmp2UkYtN
34792	payment	2133	2133	1874	1	1	3925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZhYXa5UrRJfRF8H7ZUmFDcB8ZANCTHjpKzRiBEEHA4BRGynN
34793	payment	2133	2133	1874	1	1	3926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpivEmi3JxfkEcnatouQqy3DEgi2NuJNRnxLoBCZz9mBXQ84L
34797	payment	1397	1397	1678	1	1	13521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7pJyQSdHeZmZLaUGtmfCwTVnNFBfZCT7T1D4gegRTZFNq1gW
34798	payment	2134	2134	1874	1	1	3974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDxiEpUPmH3LCKfWCxxPtWsukoJdYYWxtyipSrbDCPTdKNUo5
34799	payment	2133	2133	1874	1	1	3928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHp9iEi7BPZ4DyKctgqZ2pgQuQza37PjmH4q3Ed57t1nou4rD
34800	payment	2132	2132	1874	1	1	1134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmnYZ8ZJaVv9DWQL19zjPbc2ma7f5HrqCPLeZYjKQkw9Wnf6T
34804	payment	1397	1397	1678	1	1	13523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRSe29dMyb7CoSrpc68uWEzdCyeMaQUeGHc2NZsi1qqkx6FbL
34805	payment	1397	1397	1678	1	1	13524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs26gmA9ZLFPfDyABGYzT1MsHcw76YzWHnTC4rzXeeQ3679G8
34806	payment	1397	1397	1678	1	1	13525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2xkm7oDkYWWaBykTyk59f9VyfrTSzTpPDNFCNRU48UE43RMh
34755	payment	1397	1397	1678	1	1	13510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKVjkB8YTaUeJ5Lh62bUiJMmvrUHysU9UdXcXTg657WpnFrrA
34756	payment	1397	1397	1678	1	1	13511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PCuvF1AnnZ9LD4GA8n4ZQfiAhFYuZRbJSgjF4gUhnbPYL7xf
34757	payment	2133	2133	1874	1	1	3915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrkTMqySNNBsTyFtLG8c6Av72CBecL2o6ubUyh7SmrKQKCdEo
34758	payment	2133	2133	1874	1	1	3916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShEAFwBn6FhFLUN6RY6dAbTWiVmHBAayAoSDvY7urrWxMwn1M
34759	payment	2133	2133	1874	1	1	3917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwhkFVa8qLDYpBkVmnDP3jzANpRuWTvr4ZFsqJSaE33J7usrQ
34760	payment	2133	2133	1874	1	1	3918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98dzENDX4SuXC3TijoJL6pwsf6xypjcLZEXnpKT8UfemeEYe1
34761	payment	2132	2132	1874	1	1	1130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHw4jRnLPwWiRWXsBMC3LqYWDfuFYmskUsrUfYRL4Ubh5RSSQ
34762	payment	2132	2132	1874	1	1	1131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUnBrRgBp1pg7nAFHHC3d4pPgVkfyR3cjVbPUtJDnbb18EoJZ
34763	payment	2134	2134	1874	1	1	3961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FyMmuu2QMajNCKyA3odnN7XxF1S1oUd5PtgjSzk14EKZeehM
34764	payment	2134	2134	1874	1	1	3962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4WDKVmVto5fEz49B91SaWCpBRutyQ5AUaFiTyvekYUG8YBvnj
34765	payment	2134	2134	1874	1	1	3963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7n2CJNvjquvCgBxmBjLpsumthmNnMtwrhWJUCNLW7db2UFoy
34766	payment	2134	2134	1874	1	1	3964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkajaWkoyrAGGCYBMoxFkdiz6ZWs5DUmowAgdciphfXRBQDxL
34773	payment	1397	1397	1678	1	1	13514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf4GSfsqZguz7UqfhvVZEVHjU3qudzUn4EqkL4CNBSvhjcZqb
34774	payment	2134	2134	1874	1	1	3967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Wr7r8eLjXP8C9rpiVB48pcPYiTSNDDS1HU4EqFfkxdGBvjPa
34775	payment	2131	2131	2172	1	1	7	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	Ckpa6oUQ6NNM18iWLgW1TAc7ANeRToxpEvAkedVHJmTGxKtyTP2Po
34776	payment	2133	2133	1874	1	1	3921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4kNPCHVVPJPhZuKkgYVvSkbY8DtJFxKYWLigbdNYTLk4Eecg
34777	payment	1397	1397	1678	1	1	13515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfRELnRxDZ6yvSsYKGfYzeSnUBewC5akvvRaVZM9H52hj5FxW
34778	payment	2134	2134	1874	1	1	3968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfGYncXNtwRCT4FNbNkAeFjqQ1px3LmqgmTmijx5aCVPyGXLh
34779	payment	2133	2133	1874	1	1	3922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrLwkpTxBw7YfJ9tzB5fm4C2eoiQZZ1KB9dDZjLYcriLTyKJP
34780	payment	2132	2132	1874	1	1	1132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvphC3QGcC7jNZ4vr8edKUVFFh9HrAZADr6zcb4JcPx2bZjYh
34801	payment	1397	1397	1678	1	1	13522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7XgEirBKSGEV3QXYXkQEYobbU6oCEpny9Y4KB92uBu6N2Xb1
34802	payment	2134	2134	1874	1	1	3975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCn8GcqubpqA11BTBD3CxYm8Qj1i1nBP3TJoYyDwpB2kuhh3N
34803	payment	2133	2133	1874	1	1	3929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3xq7JAR1DJLwwTdEYMuYLRJHqbxfdUvSiNDP3UhKMjkDvYDv
34817	payment	1397	1397	1678	1	1	13527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5VRu9GNK4PkR9SrFjF7fYxcnVPat3hxACDpo3PVs6b3Xqwyo
34818	payment	2134	2134	1874	1	1	3980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugkqd19RQXeMdMYxi1sURrak6yLRarXncv1r5Nm99cmNw39wp
34819	payment	2133	2133	1874	1	1	3934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d399RsnFfikn8vGrSemmuoj6oCVT4MkX6VJ5jfuUGvz8WVYn
34830	payment	1397	1397	1678	1	1	13531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffL91cGCo4Q5dsfj52gS3bfyGeK1jHhvwaWodrZjjdJSzM1yQ
34831	payment	2132	2132	1874	1	1	1137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkr1H2mzHRTmHjjmHcNAG77bpbq7C3P2t8xEa7HfbeTJPyddqi
34832	payment	2133	2133	1874	1	1	3938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54jShVHu3nNkyuAW2XksmhugXdvzNB7UifrSqGJyefgF7Eguo
34838	payment	1397	1397	1678	1	1	13534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mh8QRKw2nHGUH5R5F6UFJX8dKHpormQSbuFFG4bDD93ryxHv
34839	payment	2133	2133	1874	1	1	3940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMBVoWcvXr4Ae73khz52j4EuU5syga322VWX3oGNpF1mhDxJv
34840	payment	2134	2134	1874	1	1	3986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AVpq6zq86PpWN8H3brUY1LZjfh23qFMQxLMuw5PwjBPz6Xvp
34841	payment	2133	2133	1874	1	1	3941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91N7JjPb2VsVjBNnVbfB6rzShzDKvWtdqMLDF7FbWbXJRntCh
34842	payment	1397	1397	1678	1	1	13535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsLh6Q76JTSCkEWVNuq1bECMJGBQS8T4ReCC78BeqeA92G7XR
34843	payment	2132	2132	1874	1	1	1138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2YMEYgw5BqH5NW54tmavtLBUs9FcUZSefA2qc5VoBYy3uewA
34844	payment	2134	2134	1874	1	1	3987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWypXtNnbMGmtHLYTVLgkvzrerz82nahv2yhVwho8B5TmaFvc
34845	payment	2133	2133	1874	1	1	3942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaT5KTKqe9bgE6snKyRLCoSuvLaLYZNGWiAaSqsEvDDhG1f4h
34852	payment	1397	1397	1678	1	1	13538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYja8UgicZxNVLvjpaqWeXWbZmcv4cPB6zb7GQEDhHuKwgynuR
34789	payment	2132	2132	1874	1	1	1133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyr5pRDxbdpE2JbDopdyKXn925v9NKR1JwDBdnqhmU4rkxdiu
34790	payment	2134	2134	1874	1	1	3971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBJS4h6Jz8PmrXKTxkahSdWhcssyk4mWjnRv3Ys4t1tRfe8AG
34791	payment	2134	2134	1874	1	1	3972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTrU1o6oXjx9RUwsGvKTQs5w36c7qJsQn332hLDVfoxZPm5PR
34814	payment	1397	1397	1678	1	1	13526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1HZphRTo4DkT267KaW2MdczptN4yhzHCYK6xdJEhehmKnoPN
34815	payment	2134	2134	1874	1	1	3979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKknnpiFeKQgQ2x76XKL4gQf31Vw2tw5baKitKtbES3AzriEa
34816	payment	2133	2133	1874	1	1	3933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu61sWpwE2N5rmGzLwnmPbi4p8bD6XNLWwkUyw2GhQsDx4h31L
34824	payment	1397	1397	1678	1	1	13529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5c3A4gYe1NhXbkcU5WcVRAKtpNNpuM6umAqwBasdSfD5X9gQh
34825	payment	1397	1397	1678	1	1	13530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU5qThKtaMRRcQfcxukdmQGXN75o1AzWSZbr21rvd9XA696yMh
34826	payment	2133	2133	1874	1	1	3936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5w9G88aj2ZhGS495B2twsAEJnm6xaWuNsWSLTQ8YJugfs8Fc
34827	payment	2133	2133	1874	1	1	3937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFZangC8Kamxp3PenRWesoqKYtKb3q6sjzjvCr94sgm196azX
34828	payment	2134	2134	1874	1	1	3982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGLK9vLGZfaU8zCFCpX3BBhqwiBESEbxQsPHUfXWrrsSX3E2p
34829	payment	2134	2134	1874	1	1	3983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrbaFxB83b61bLA8i5AEGLiGajcJHRt22rJRk7Z5aQrkjLA4o
34900	payment	1397	1397	1678	1	1	13552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9CgHURHhNppLAuHDkRYJ6eTjDoU74KurT4cueZZQ7QWgQ9Gd
34901	payment	2132	2132	1874	1	1	1143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr6DoELiVnAD7aTptDbLpdaZRGUCYrAE3EFxhjPSF5mgYXf33
34902	payment	2133	2133	1874	1	1	3959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkueFX8G415sq5jLzoHydFj44C3tYrncd94ps7coH18aJfuwJ
34903	payment	2134	2134	1874	1	1	4004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoknYzd2naDe3iqnNDfgiWB5ry1npfrQBZdYT4KrzVFToA9Jzw
34946	payment	1397	1397	1678	1	1	13564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpC5jeR6eJiw6FnB4JmtZo9yMmXhsntj92XAoBs7ufPE5yWHX6
34947	payment	2133	2133	1874	1	1	3971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcDjH7gUUs59KdgQ4BUNhJAK7Y8bvyq4G2QxHiSH3TKoMrNUU
34948	payment	2134	2134	1874	1	1	4016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87B2Pemn9qmnhgK3Mxz1xn8Na4N4Rtsdf3RqRNbtCNXJXyZUo
34949	payment	1397	1397	1678	1	1	13565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdx5PSaiXzW4uFZg5bD1zC5BXsNBjpRHcJF1Fnxus2SpyQkaf
34950	payment	2134	2134	1874	1	1	4017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdT2XHMhJwBbVLwWzgwQoJihShRxh6yfDa2sV2zrmHoFJxL9Aw
34951	payment	2133	2133	1874	1	1	3972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiD4fqwFkX9bfqhbp72c6jq9vyTBuRa6nru9rfP1H4GLKsX2M
34952	payment	2132	2132	1874	1	1	1147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtapSFBbTbE9yNrgXiBZUcJsGR8M3n2FYALKhiswGzJUb1tyi
34959	payment	1397	1397	1678	1	1	13568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEA7qRp2DuhZ2ZsWa7itd5maPQtexkU96Q432a43PsmWKxVAB
34960	payment	2134	2134	1874	1	1	4020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSaHB5JaVMz41no6gNAkTNYQZ2pgDqqoZVTjcSdieU2GJyoCD
34961	payment	2132	2132	1874	1	1	1148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQWYyZtwMmib98B2gdQt7QsXJkRTWGAeT8S16cG59DUCxJBnh
34970	payment	1397	1397	1678	1	1	13571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BdB2W7mPk43SP6DFh4Ptz3x2UoTFrCe9SVfvi2vNhiyT9h79
34971	payment	1397	1397	1678	1	1	13572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2iutmHB4U9S1cU2FeR6PeDYpCbR1ZeiSHL3PHRpd3Gmi6q16
34972	payment	2134	2134	1874	1	1	4024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwKKqHvF5Qt6i6hgBxuUz68fkEzZPZJWLB5ao16ZtXnQdvqaT
34973	payment	2134	2134	1874	1	1	4025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP1a2mp9SpPRdnFcwN9uTRQd3LAvg8CxWDKveX1bXCafCsBya
34974	payment	2133	2133	1874	1	1	3978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusyw8aZ4192TQpxUmWvxuHNSeWqLNx57hcQ2i8xqQ9LQuSqTr
34975	payment	2133	2133	1874	1	1	3979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTFP6oQrj2t14FZa1JYL7zMMmUYB8GHBSsnWY12Ri92iU5zde
34976	payment	2132	2132	1874	1	1	1149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AgDaiV1doPcrQJ4SR4WzCkXGzggcza67BZHyVRUDHGB4suG1
34984	payment	1397	1397	1678	1	1	13575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUtsfvr7oA2Q92c5zUa78wB2r37MdKiBjQ4BQGmECgLQrAvrx
34985	payment	2133	2133	1874	1	1	3982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYbvFovfqk1U14xwiD9RdjYjyg67qE3Kn7o1CTLAgkEtm921s
34986	payment	2134	2134	1874	1	1	4028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihH4Tr4GaTMkd26Jk7XZ5m6jGf6hWRtrSbEsMoJrNxhmhEFcf
34997	payment	1397	1397	1678	1	1	13579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamJMZpj6BahrPcq83A1d9qAhAuLxoBV88dBgZE1DMQ2K5HytG
34998	payment	2134	2134	1874	1	1	4032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMPGqCmBEpYvv3oSoiba6ycKQmHpRSL8Le71TNs2MwUARxCcN
34807	payment	2132	2132	1874	1	1	1135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEZwCmLdWb2dEyroBJWizEPkSHYWTRj8H19wqs6mzGYuHzWJj
34808	payment	2133	2133	1874	1	1	3930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFjXs1R1wgsCwk9u2BqguqjWrGbpyoV9JcB8hDCQX1KygfYkc
34809	payment	2133	2133	1874	1	1	3931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2CApyuivgY7NVQCdJgqyzaojdjLB7aAeUYcy7XELdBJsdneP
34810	payment	2134	2134	1874	1	1	3976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMqmqS4GNdqQT4w2B6ScCcZvhAGWAQgagZNDvChGjsVesdJd1
34811	payment	2134	2134	1874	1	1	3977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cU7ZRzZUrtGd39xh5iNXRoLbg9KtDB26bAsoFiiViNQ9nsFy
34812	payment	2134	2134	1874	1	1	3978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UtmxcmdHT9zQBzGiRrWriJjNmUMyJMaMEfM4xFZSqDjwMoVh
34813	payment	2133	2133	1874	1	1	3932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPb85o8EJYj2G27WBQ9Xn1hP6kaeNRi2aTfWcYmcWyAMbqT5x
34836	payment	1397	1397	1678	1	1	13533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6ckvQY4v9bRQcK4cs9WZFsXUsAWbRrDwR9xbhdb87eUFbkFm
34837	payment	2134	2134	1874	1	1	3985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJCfuHqeQyya8zaCEvpDzHgxz6QsRymSDR43V6tHFBy4t2TPH
34883	payment	1397	1397	1678	1	1	13547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaRT8zqt4aYiEyHgrCGiyA3LjJCqW613y9RovBknqCZ3GyCKB
34884	payment	2134	2134	1874	1	1	3999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmekB1E27vCFi8V3PxTVXM1yZunT92JWZuZac1eae7VNfpkX4H
34885	payment	2133	2133	1874	1	1	3954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBo8qyp2ibu3N16gCAbm3PVB1Wf8cmiZQqMXPFUdz8mUDeY57
34890	payment	2003	2003	1651	1	1	1	353000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafL4i5dpCyqupHQrAbPuNPwoqh5uw9FMp8cVWMTu9tBSNmntb
34891	payment	1397	1397	1678	1	1	13549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXPQVhZJT3pRnNUKKciNmRyAygoUyvtUkQpgT1bN4Jfj52ESf
34892	payment	1397	1397	1678	1	1	13550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFpSDuYxJUQmmgCPYm5vPKnLDsYSWCN5zohXZv4RCfQy3SgXn
34893	payment	2134	2134	1874	1	1	4001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmsM3DqHsHg2mvVFWEfJK1rbStZsZCVzbLNKtsPLYv5JFdjVn
34894	payment	2134	2134	1874	1	1	4002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqwJkvk9AzW45tqkb4Ly63FSSzDsKLywPyxM2ECs42cuCZsGi
34895	payment	2133	2133	1874	1	1	3956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55CMmq53mPAu9UFtVKVbQ9dxZtWqu97mtEjfX6xeoURaeFqVk
34896	payment	2133	2133	1874	1	1	3957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpo9wK32gb2vQ5L5gHuqtsoZJKDffZWsAjmHRryHUfTUFLNWP
34904	payment	1397	1397	1678	1	1	13553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfCQ5VJQVJQPQn5kLwf6HiXab6LEjD9UuVxrLimTqN6PSN3xA
34905	payment	1651	1651	754	1	1	12	5265064217	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZuWNKfPLWRGgWd3sg97BEbXYMVRM1eE5hXduC932GNzqtWfyEp
34906	payment	1651	1651	462	1	1	13	347494240603	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYTr5y4DWYj4cYuwdYpSUjC2zE37Rhf7gtWHBTKTK8Qk1w1KocF
34907	payment	1397	1397	1678	1	1	13554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CCrhHX2z1Es11DeaAWpuEC4P5NUQqAKA1UvPkYB9JaKtRsYg
34908	payment	2134	2134	1874	1	1	4005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjW36M1FQGWvWnTGkYttWExMRzYorY9kUNXecaFzbNCuXaADG9
34909	payment	2134	2134	1874	1	1	4006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC28QejV9igboBHocdC5ouS7ebBuX5C9zFZM4KvXYkaEnGa4gK
34910	payment	2133	2133	1874	1	1	3960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLaD5XfHdu59YzzYnHZQ53oiVRtwy1PA3hj2bTSq9HE4ibcpT
34911	payment	2133	2133	1874	1	1	3961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6u2VXSoUikJvuadwND95G33PNyxuyDxh91PdChEZjpSztGYb
34930	payment	1397	1397	1678	1	1	13559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hPy5hukRWopLHJEnEfAL3oHYHXfkMEfC8P1JEix8czn2SKNZ
34931	payment	2134	2134	1874	1	1	4011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1KDp7iQ6oLKP7sYt3XWAi3KhpMUcdFMideHowq5yqUEjJ81S
34932	payment	2133	2133	1874	1	1	3966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNqNiXzKDgHH1yqxrGjj6jQq8wrsFgeoqezW9bvrrMj1JoBTi
34939	payment	1397	1397	1678	1	1	13562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUSNH7iHBDwFtwF2EjuR6fguF4bobXXrGP6CNKFh3PFdNNZjQ
34940	payment	2134	2134	1874	1	1	4014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4ALJhAN1MeVPu3WdvUycqa9sRouGYW6CffYKNNwsPhPM3JkK
34941	payment	2132	2132	1874	1	1	1146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ192Tt62rfxwnQvFEbzSDoRw4S4EhXjZM6QbMuLRbiHSvtvMvS
34942	payment	2133	2133	1874	1	1	3969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kCXSxeccM8b58rAPat1FS5MxVfCrYKDhXZr1VJKhJhKWELHP
34953	payment	1397	1397	1678	1	1	13566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHQwk18EpY6U8C8mw1g4gB9MfCpsHSSbPmx984WYEhhwWXLji
34954	payment	2134	2134	1874	1	1	4018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGS7zUUKrvFquT4SogFPVLRt74hWJ7uDtnGNXvzzGXmHQmA2r
34955	payment	2133	2133	1874	1	1	3973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3h64Br2Ah9aJ3822PWMXj3qduitr2zgaWV3zxrCFGGgxuc7x
34965	payment	1397	1397	1678	1	1	13570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnA8z1wVnRkMNcmJnvjuMvu7SMnTeqKFqLoZpANeBvHcMVQsse
34835	payment	2134	2134	1874	1	1	3984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLifA65ydoqAGFQJtgdzWD3TkMfMbcJnRhcS1VZ57dxAYnRj7
34846	payment	1397	1397	1678	1	1	13536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BxALxh2rDcSnh23c9NjwcdfJqdrucUiD4P9cxYYKpdXLqFtb
34847	payment	1397	1397	1678	1	1	13537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEGwGM9TbVPMwstyhYB3XdFyG4ULbpHFpHEqYe725gXpktmbE
34848	payment	2133	2133	1874	1	1	3943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiztQ4BeGydWbth6Zq7SMexdWbUWgZMseBPAE4jERe3oVgRoyu
34849	payment	2134	2134	1874	1	1	3988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNJZ7USj92uSh4dUURAfbzAuE7o4FLNARtfh7YPnCXwHF81BV
34850	payment	2134	2134	1874	1	1	3989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWHCEEr3xr1Hxx6eiEvuof7A5EtnDDaXrzVatLdm7knzKyjo8
34851	payment	2133	2133	1874	1	1	3944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtC9Cq8SVjEDhxeoBX1bFMhKCMCEFBJmVetoGC3co2f61ysYzM
34873	payment	1397	1397	1678	1	1	13544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXWJesWyL19tV6wiBDUUP4Fy1zhFNAMURQooxf4wBZpKBeAoW
34874	payment	2133	2133	1874	1	1	3951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuo8QLUiiWgQ5uKG8t8ZoUonauMKFJ42TPPWbJDP14x7NCqonU
34875	payment	2134	2134	1874	1	1	3996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ193Mdd1yTdzaf5og46wQRHGRoaNX9WudidwLpG6uyjt7zi4Wx
34880	payment	1397	1397	1678	1	1	13546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQZKr5sRXBEP8HCzB54tNkDoBQdLyzFGPnLRrA6eYCSRiubqL
34881	payment	2134	2134	1874	1	1	3998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjaaS8jwM22kUg9ojws1koCAENxNNPVuDSegsjScc1rBdMPLa
34882	payment	2133	2133	1874	1	1	3953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4haKr6tfTVybGzHYVcPUaNpdViopY2arv7Z6cBrtyQNEUjmc
34897	payment	1397	1397	1678	1	1	13551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEV2SRHMe3LpriZ9LC9GaxLTTy7hKarr9vwfE1fanPECvFJjT
34898	payment	2133	2133	1874	1	1	3958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW94HZT69RC5vZZQeDLCuHShSvJw9jwJMWKxKkV7XJ5XTHtFJQ
34899	payment	2134	2134	1874	1	1	4003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Q5YPPczkiLb7X35uUixk1UNk3cvZ3Ef2HRpoFtBoas7xuREu
34919	payment	1397	1397	1678	1	1	13557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJeFsVdW6Tfx2frdtTC6io9H8eHuHEUY36QXCuYLdSgRhixG5
34920	payment	1397	1397	1678	1	1	13558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxFa2LZ6my4wRsKL9nQ613Qo5DKE6s3hKVCk66LmZoB1mj2VM
34921	payment	2134	2134	1874	1	1	4009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwVPLzFuNKNRm7gcjZ8YShRVVpRbwVYRbY4QXuVxCmmu86nQj
34922	payment	2133	2133	1874	1	1	3964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtZT9Jp8pgda5b3a8QS6oNXhCaGbiKX3wx4FW6hRmEENpMWww
34923	payment	2133	2133	1874	1	1	3965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHow9sovjBDKtZUeVsng3p484PW4gbaSGKyCH7Bio2WxhBkHA5
34924	payment	1549	1549	1362	1	1	6	9830706000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqTbodp7L4CJzddApcaU3gGR76kBpLUwHPvs8NE6gz8Tdxa23
34925	payment	2132	2132	1874	1	1	1145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FWKLApSXRvbBjsZZGeqCJvprRkQksWbsmTztWT1WGShdPrp
34926	payment	2134	2134	1874	1	1	4010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM17M4U8e1VedbunSPA8jSToBLwTqyewH9YnTB4DrYyMdNb95
34927	payment	1549	1549	1116	1	1	7	5228634000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBh7Rj5uWA3TX5YJDtogvK7EoAFCyHCmWsLDEYASKUZJJhGuM
34928	payment	1549	1549	1236	1	1	8	3527864000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19eFFtPfxeJdDq4mnkaAwcdccggBShLrPYnbGL1i5kkCijfR3
34929	payment	1549	1549	996	1	1	9	2917779000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcNEUzGyY1h9nYz8x8xFtNH4sFRePPwfqVpWGzb2WZJTHZ5u6
34943	payment	1397	1397	1678	1	1	13563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk78gpx4t29CZffvmhtUAE3hMupWy2DHsJh2UKwVauxM9Bjoi
34944	payment	2134	2134	1874	1	1	4015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8jHjnTic4mQUGkDgabmFKvRHfnYNpGwXG7E9Xv8czUPCWYqZ
34945	payment	2133	2133	1874	1	1	3970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQnsiehye5hcogJnpz61HpYkAPNYSjnhev1X59JccPcUCvUkt
34956	payment	1397	1397	1678	1	1	13567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosQDs3EywmfD2YS8FfY1qPMEB3J4RAjCqWdJjQzkXqof5e61V
34957	payment	2134	2134	1874	1	1	4019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgeSoUTC4gghkuhpd8JCqF3M28hyDZH8ombykUEBEU37BSkFs
34958	payment	2133	2133	1874	1	1	3974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87uXwrrNXw8wUsDH9QYeQ2RQDhthfZZV9P9fzwzfRYjwoSssq
34980	payment	1397	1397	1678	1	1	13574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgvErhgZuVf6q9NjigXvovoiBLLNuHM4bTAxpdjyPUSUkia22
34981	payment	2132	2132	1874	1	1	1150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9CmpR36ATMhEyFsLsoBALD1pZSNmuyrEVPBZmSWzQ3WizdmZ
34982	payment	2133	2133	1874	1	1	3981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfeteb2k4KWCyXxSVRUMC3JZxFA2oWkuy4XJbE7b3mAoVqfzL
34983	payment	2134	2134	1874	1	1	4027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4AUknLgEELKkn2xGuJcVBZMDsF3kbmrCFHfFPawFP4A41j6C
35004	payment	1397	1397	1678	1	1	13581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QdXV2TnvgKPPyxhnrmACq2AdS13XrMKewLEd7Y6LdENADjgX
34853	payment	1397	1397	1678	1	1	13539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdbC1JKStQGjy4xi5bbTbPFKGtaDi4FdpgRezf4NhceuY1oBU
34854	payment	1397	1397	1678	1	1	13540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwKYf18De3ML7G4Kr7nZ472NXnW7veqAb9zrbbSoroPFW3y9q
34855	payment	1397	1397	1678	1	1	13541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio9VSH6biPt99JACBnpVxWSvXq6EJo9udXDkLhpMZ21tHMFrj
34856	payment	1397	1397	1678	1	1	13542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2susrKQeSNXsoCsCiP5iFPduytp8iqSarvHWQUv83GMzAQihZ
34857	payment	1397	1397	1678	1	1	13543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAiZ8YWedxA9s7rs1LGQEdTHqXp7oeaZwTKrtjG8HHYdy6v6m
34858	payment	2132	2132	1874	1	1	1139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3ZpkeKCGaCt8vZPYn8G3U9EzqgVxo9tSTATJwBqRPJbjFDZj
34859	payment	2134	2134	1874	1	1	3990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7ZMg3HU15eS7TJEqdTh2TGtVU6EXtUiGAz6WZmAhm1Myd5VX
34860	payment	2134	2134	1874	1	1	3991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQA3xJKYbJrYs883cBh2rg6VJFYvn8zuRkx1dHeVe6yvsdwp7
34861	payment	2132	2132	1874	1	1	1140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5iDertuhmyiaEfbs2BTUjrjZNkruVWs9HQvsRvzSuq2oenYB
34862	payment	1549	1549	1549	1	1	5	1200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQE4G6R3K1yRaNsY4MZMwJsw5RXweyQTA4ERfbBJTsLKmxVRhH
34863	payment	2134	2134	1874	1	1	3992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdrBUpqCRtM2Cya6pTh6kx9r6dfQQdG8eaUuMNMkdffvbyAbq
34864	payment	2133	2133	1874	1	1	3945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtYPUUUFxfsQtv4iLG7RoDPcZEDoGmuvsE16eNkb7MQ9aaUDf
34865	payment	2133	2133	1874	1	1	3946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUHs5GGUnK9L6wxULeQJrzmN1kZRemVsWi7634DfxYfFMNoBf
34866	payment	2133	2133	1874	1	1	3947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsE2m6y6PZuDJ7HXyRSxsXA6Nbher28RHXtT4J2RJnho5oS5o
34867	payment	2133	2133	1874	1	1	3948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErKWDcBVbrYpLg3S5oHMF79YB3cdWmf1C5aeEckJwveZaE734
34868	payment	2133	2133	1874	1	1	3949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhovkCbjU4Hy7oAeo1bVreFuTBTmnWGpNm4kKpAAN3j9ucrRjw
34869	payment	2133	2133	1874	1	1	3950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hCvGcDCgTd9ww3q22ekTjJYtDZxFXbQ73u4kzhSjftgatswk
34870	payment	2134	2134	1874	1	1	3993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkN9Q69gZEoDLMxeTgpV1oPGsxaiBuhNftJseijS6xTQSrnVK
34871	payment	2134	2134	1874	1	1	3994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGqA4oAdHr8ZCzEL8ppcZTqzh78LbyaM2sWBRkRNtPMixsBCa
34872	payment	2134	2134	1874	1	1	3995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYENyF1YRxkjTPrV3o8zH4WgekKs3F7oJfxC5H9ufpkVGAkSRt
34876	payment	1397	1397	1678	1	1	13545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS3PzWrNicnSH7gvqktxS49MGaCcXvedqynHDjQnMxXKG7eHE
34877	payment	2134	2134	1874	1	1	3997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGyw5jbQTweNPeiyPYSwTBi9j4q456yqzgNzAdTytQ6WSpQ2S
34878	payment	2133	2133	1874	1	1	3952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uVMmmQbb7pCpNvB8xjC6R76xiptgLtMmKz12vQJXDABPRKZU
34879	payment	2132	2132	1874	1	1	1141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ic5nrZRVLswaB9UZgg8Nxt3Ghz248WCMidjyJkY2XCWjVdsh
34886	payment	1397	1397	1678	1	1	13548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEds2HA1tLVxVjRkM4X1LM4HX9wNSxZMdhdBEuZAzEmLMBE2M
34887	payment	2133	2133	1874	1	1	3955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZJq9BEdot3HSuMTA1GwK7PuJgT1oYcnVbKGWR4BdKMAdq2Pm
34888	payment	2132	2132	1874	1	1	1142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs482Lp2z7KjTgg6s5741YNSz9SVBgdL2ddptRTt1Aqd14eG4d
34889	payment	2134	2134	1874	1	1	4000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmPvLWHgeMgf3BvY5XaDj6gPuMVY3eDQFacYzrJZzTJBWxKHK
34912	payment	1397	1397	1678	1	1	13555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS5uwLxmAAELMcdLSkFn8bNpnjttq3MozL36Z45LgLv28CeHw
34913	payment	1397	1397	1678	1	1	13556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEoAXmNTp2FtmVh5iSKgdVLQ31EKxrNeeEbLtzRJysY6b1YAz
34914	payment	2133	2133	1874	1	1	3962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKyAg5dM77iGDQUh75D1JEjQKKj4tFsDLsCAUwNxg4d6dB9db
34915	payment	2132	2132	1874	1	1	1144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4Bt1Ay1vBvWMZTXTehmnTyumM5wEgJzjJqLHqABh594KqJfM
34916	payment	2133	2133	1874	1	1	3963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QgFH8WPC2oaQNwquwV9t351pXZcoHpqZ9ZKgLUhfj2b5FcJ8
34917	payment	2134	2134	1874	1	1	4007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEGQ9t3dN6ULGNvSYAXNBe3nWJo9g3AD6mfwpfxJVUxDzi2Hz
34918	payment	2134	2134	1874	1	1	4008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtLS5PiEE1KVqJWB71hfV2LhV6AH3wwjj6wmYkrG82mjABCyY
34933	payment	1397	1397	1678	1	1	13560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFKGMx4QYSXM4UEHhKjeKKRAV7bmEG1VY8aR4JoErgF71Yuh2
34934	payment	1397	1397	1678	1	1	13561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEjofbhGxmVHUsWGo4FyZRLxdFVLrTRf6Lbed1tTEstVrGNDW
34935	payment	2133	2133	1874	1	1	3967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFV9VJRV7mLu5t1osnhEAaQHhMSPqzJwTJt6Lupgq5oqGkpBj9
34936	payment	2134	2134	1874	1	1	4012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5VWE7daqsJerfJxFkbzCDUa3PaaHxz3JRcV2piftiBjNgsoa
34937	payment	2134	2134	1874	1	1	4013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPQKVAJzhgjbsKrnX7Yy2CWn5DycGHxngqGiEJVUmvMUXQVGp
34938	payment	2133	2133	1874	1	1	3968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCPPrkpAiyzdgW96XkBySZn6V81RyWMyfhyiV8jwGpdnWKNr3
34962	payment	1397	1397	1678	1	1	13569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4hJscbeZdRWxFKrTAsFg9gHcSsxdj2n9fooQ6gonCp4jXbbK
34963	payment	2134	2134	1874	1	1	4021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gHzz2RUE2pgAD6bfRLwu25wjZq8mmH5GKQH4cccsyfiJLeTF
34964	payment	2133	2133	1874	1	1	3975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HZBDcwrsVHvHhVfkxkXdnuqNLUmc7ogDip6Gansq4rHqKUbG
35013	payment	2133	2133	1874	1	1	3990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa593KtYTWv3LXVUb5mnYKp76bmCXekfD3KEeAkUa4LJuhR9rDi
35035	payment	1397	1397	1678	1	1	13590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqWcfu7Hjhe3S8vf6j2SAcKb82S7QBqwhBYTwG1vZeYZB8qQy
35036	payment	2134	2134	1874	1	1	4043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZER8Cd15oeGnS1n5MqXTcnHDvar8nhwBat9LyXMd5kNcYYcn8k
35037	payment	2133	2133	1874	1	1	3997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEe8ZsQzUeJmBCnMARoAAmGD6f7o395sUaBpN4pRAmNiovCdvQ
35047	payment	1397	1397	1678	1	1	13593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqE9PtkyZCFULJF9bU9mnoBWyGwBBxQ4XEsiSZUwTwUtg6ChvN
35048	payment	2133	2133	1874	1	1	4000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJusxgBjErsnpYw29XWSp4TGMvPks8Yb3RvtNf6DKGAgBRMBxs
35049	delegation	2119	2119	1672	1	1	6	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZKE2gUWn3b9D2gasjJD42xFHz2GWxnEiEK4UJ7kBf5AHAPB9fh
35050	payment	2134	2134	1874	1	1	4046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgVgmo2EpTp2UKoAEeE4UhGbtVpGaC5TqneUkyyM4kMy8NGfX
35063	payment	1397	1397	1678	1	1	13597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKe4XGMnkD2iPLdbVbJbaPgzLcMLur96BjFWKNCwxWjB9wb7Uu
35064	payment	2133	2133	1874	1	1	4004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd9SN1xGcZuoE8dmgfVETHJFgdGHxpLm7C7jQBuNGeyFiYRfw
35065	payment	2134	2134	1874	1	1	4050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYdGV84HgZ4jkfwVbfrgjDbbt4LsV7cVbkFYwUj9M27q76AxT
35083	payment	1397	1397	1678	1	1	13603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Sjmi6RL9rUvp1s6MQzC7z6dMVEiF5mwQFoUFBgXHVBe5pWAQ
35084	payment	2134	2134	1874	1	1	4056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc5ZEgfsGJZchgx921Jewswt4cVESy4nGEDLSYPC5oj2HqKhB
35085	payment	2133	2133	1874	1	1	4009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GWCmAA7X7L5WWduki8BpqRnmGSxNgZKbMhRT1uBDTqs3pZsK
35099	payment	1397	1397	1678	1	1	13608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLdbxaFRUbkePbjH4vYE6CcZbMnXypXx1Q9VM4nNUJ9i1jBq7
35100	payment	2132	2132	1874	1	1	1160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsRfMZjxWWDayGzXPwMDvEQEyrqYEzBwHsVzkVD48TgpSfVpy
35101	payment	2134	2134	1874	1	1	4061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNB3thViuKjrqRK7QyKqdYBb2kUTLMftkBD1YcriDyKhgdr8Lk
35102	payment	2133	2133	1874	1	1	4014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vTbB9wiMJ5nb6yQh3ahcBU3DNbfNX1f7kBQFSSWHiZo852cz
35106	payment	1397	1397	1678	1	1	13610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvX2wcAgWTHGxiuYm5dNCvZvhNQVuNXzT3YStwCY4CzePn7s44
35107	payment	2133	2133	1874	1	1	4016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkrCFAnSXzW6LzfsiPYjMgS6md4TfsULVJRZx7zA51YeBUNtZy
35108	payment	2134	2134	1874	1	1	4063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLemUkQSgJL9XdD2huaUQMqJyLQKSNFmVZy8LhAqJatfon9ka
35119	payment	2132	2132	1874	1	1	1162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkfq1aTXT1KTLJEw1qL5ZFUyRpPakYrCtJNmwyufKPo89pXLU
35120	payment	2134	2134	1874	1	1	4067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHQUaiSZtMJLSrUSGECJV7Vb4hqfXyJpFfdiM1EkayXYoh7SL
35177	payment	1397	1397	1678	1	1	13629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUcctexV4BZy5C9oMZx65uhtvhU4LEbt6G9dhmWXaTyXWHozR
35178	payment	2134	2134	1874	1	1	4082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCcrb1a7JVrHZEYTwmrjTiKZdNV4Jfe852ocvVBqsqB1QQ4KQ
35179	payment	2133	2133	1874	1	1	4035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARgK9iJyPXcVN5Vf6qyE4KWKB6BjhynV4tLToww7PaYg9sdzN
35180	payment	1397	1397	1678	1	1	13630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjpmiHgBrDAcfSiPFCtoGHbj7PPTwJjdCA3bKoLW9f5GckS3f
35181	payment	2134	2134	1874	1	1	4083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjL32mtdQqeQQjZpMz1ngkR9d3xFhkTCgEE6JZrr1zJioGtzFk
35182	payment	2133	2133	1874	1	1	4036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHMWPjbxFR1VmXbQyjCzL7wigczTMNjygcsUmyu2rQguztrLWs
35190	payment	1397	1397	1678	1	1	13633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSJpufn58CXwqbAVmRGPD24tEkHVaeo6mceuwxcb2MqvrgCR9
35191	payment	2134	2134	1874	1	1	4086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyhRWPzyKpZAWwFqz3iRJRhokxRXZYNeQ5KETnCYo76bydByS
35192	payment	2133	2133	1874	1	1	4039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoiaWmqU926khCbd5bmyPQhQXLmgU6VsyQauiTU8w9Zk7JGKm
34966	payment	2134	2134	1874	1	1	4022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNp1rvWn4kv5F3UGtsQt7mkpM4xUP8ppKtaHdZVhHibxYy4bb
34967	payment	2134	2134	1874	1	1	4023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX9wBmjt8Ws7tPXqttRMu4pVp69BGY5e3SBkKRqPPvNLdADV9
34968	payment	2133	2133	1874	1	1	3976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6coE5fv81Dfxb7J76MFTwYzqgK9BkWu1bCSBYc6Tm1TzzgG5A
34969	payment	2133	2133	1874	1	1	3977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTM6gkzp8rCAi8yshq4dR9VJtbxWdznkzzkiBF3KRmxUSu5K5e
34977	payment	1397	1397	1678	1	1	13573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L7rJGJfpYZxAVcMKNQiNjosXf7iVDFVkX5r57eSWaeTrbmHE
34978	payment	2133	2133	1874	1	1	3980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJVoM5vtznT89zDSuvQP22MMBX7jPY4FbAdujjwdE1FzoNLhH
34979	payment	2134	2134	1874	1	1	4026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2Z5U31z3WScNaP8x5rGAU1Ub8wxbBNkK3u8f4jnRdML8PuAr
34987	payment	1397	1397	1678	1	1	13576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4YtyWfwiu9sQBRUuZpx8dccJvkA8p5E2QnQKtvodZuwPc1ay
34988	payment	1397	1397	1678	1	1	13577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQd4GdtL2vWbmd8XZ6KcWXk9WcDeD22MqYgNN4N4BwiDPKbpx
34989	payment	1397	1397	1678	1	1	13578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErW9Dh8caV2GEQqXdMeVoRR8cQrwiYaDyJScz8k1sCWtHYUG8
34990	payment	2134	2134	1874	1	1	4029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hmgNSWorNXAHbvR6BrXY1tNTLXbTWcqqpuHAEjMqw1amCy1B
34991	payment	2133	2133	1874	1	1	3983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRkYoxCzioLXukVHJQZRC1fGHmP9GCg6Zh8BAx19U8hVeaJtc
34992	payment	2133	2133	1874	1	1	3984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuJwRBLTsLvMp6WqT5CYx9AS2LHA1ZsSfQUfrqkANyk6kkZTk
34993	payment	2133	2133	1874	1	1	3985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uKKn6YqdEd16s7kDsChpjebZBt7GGnZV3bzcATbHoD94pRVK
34994	payment	2134	2134	1874	1	1	4030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaioXgL2RW4UJX2aP5KL5bN2q6BfQo8xtAhQPzKfC5Vu6HyJEQ
34995	payment	2134	2134	1874	1	1	4031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfGbosG3ucvMvXXovp6vrUaAi66Wx7hHo6DT8WpxfAHY771P7
34996	payment	2132	2132	1874	1	1	1151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKH4u6EZ1KizUcaZXwLSYiTYPyCmJfwZYyEGL4TQCt4QgXEsZH
35021	payment	1397	1397	1678	1	1	13586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64qbn7AQ6brtuunDQfdfKbHTpE19Nbunp6tumRtqheSrWVuca
35022	payment	2133	2133	1874	1	1	3993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEA41k8deYaYd9S6zrVHtME9uhT5RH1ZQYLbnzMMdRht1y65f
35023	payment	2134	2134	1874	1	1	4039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwwZHFGEE7DYEcukXLH4Yet9oFM9TmisdABKHM2jEzJ2gzQq8
35027	payment	1580	1580	2300	1	1	0	60000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXk1MDYoyRELsEVvaXkQzuEPuqQmHRXNzt9nEYEp5wcQs3yfcm
35028	payment	1397	1397	1678	1	1	13588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVqXKuSNNQ7ZDuER7WUMd3TDGcgNaaFkcx99oSk2PzRi7bXkd
35029	payment	2132	2132	1874	1	1	1154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTKn8ZwrvpDMHNr8Ry4E4GoCnBKuAVyXr8RFC4yv8cJAr5kVu
35030	payment	2134	2134	1874	1	1	4041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnP8vXydvWEgdRAYfhFqoCSdRvqa2VJYJnWPMt1LHqXpZ4zNcm
35038	payment	1397	1397	1678	1	1	13591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQVwyNY9hbBxmRtncdoeuRkjJPNQ4pLZ2nfjJ93dQaUE5UWJX
35039	payment	1580	1580	2300	1	1	1	2100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JcXxGrZaeX1XKpiuisbkUUiDpgPYq1hxrFwGjXGrZCxRd6cu
35040	payment	2132	2132	1874	1	1	1155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJ5wc31hmx9RQkMqofnt7YLH26JQv2kVNvGZGak8LqEqjgTDG
35041	payment	2134	2134	1874	1	1	4044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzfyD45fY5dQxr9dm5Jhaq1kXdF1DchvWNDi1WW5Beb3FJSSX
35042	payment	2133	2133	1874	1	1	3998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfZ21UPEkjWtNjZ95mby39qhbRN7TYYHmk6avHsaPL3H9JDob
35060	payment	1397	1397	1678	1	1	13596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eiKYf4Scjb5oJqsuTuju2W7pZWx53nBF9oB4nDFG7Yd4VxvF
35061	payment	2134	2134	1874	1	1	4049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTjEZ48zyLc8y5NAZLhs4sG41xGCYa8xX9uwczPqSmTchA7fm
35062	payment	2133	2133	1874	1	1	4003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ebeG6j8s5BoXpxaPCecQq9Vcia4bEYtnAwbvWP3mMTf466cQ
35071	payment	1397	1397	1678	1	1	13599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2UvrWYQrVLWEVvyv6mUS3Vm9u88vh9aQ6miuktAWMvc82vNh
35072	payment	1397	1397	1678	1	1	13600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcisCqruSyx4TXNiSaRKdKFLowVSsY8p1Z2rS8mVj7BNs7PNvU
35073	payment	2134	2134	1874	1	1	4052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYijhCdM59jd35mBv1vu6ihEQfS51QbXCPbB4d2RafE1byGyWp
35074	payment	2133	2133	1874	1	1	4006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFm9qEFNrX7rYPUU8zhW44X1yaDa1QtYoaCpGEarwkamoUnG6
35075	payment	2134	2134	1874	1	1	4053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PETMHHgM2jeYdyFhcJc5WUedQReSBaEsfVKdvBurV6MXT5MD
35076	payment	2133	2133	1874	1	1	4007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqpmrJd5D7hAzQCGUgJvbh1siqneDRiS7vJT3if7MkZD6qBkK
34999	payment	2133	2133	1874	1	1	3986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAhmEUwSueiVNvSKaMdvv6PhVeGoKoA3DVRZ39idKMFrA3c4P
35000	payment	1397	1397	1678	1	1	13580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEwDKLsDnvnmgZRYVRT5hU3W7un8g7jgTs5aZXkeUy6koBZg5
35001	delegation	2119	2119	1672	1	1	5	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ7wTDXDrZQeNQKLTwfpjF9Wt2htwCEjmb41UtABH6dK4ep9XDJ
35002	payment	2134	2134	1874	1	1	4033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjfqU1g4YgJTAK1UERy8ziiTAKjx2g27digjjsHp14FyfTfSA
35003	payment	2133	2133	1874	1	1	3987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLQns6ZZutTuBirvwrCxNVgn8rj9i7tBFqchJCUDYwz1KaYCQ
35011	payment	1397	1397	1678	1	1	13583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLNkMjWwQF3PDm4uXZtfLdyXyQ1Q3NUfnSiKiTSt28KMvxCb8
35012	payment	2134	2134	1874	1	1	4036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2jrwTknFaWeoA8Uge3zSQGXeb1F2K9tyxD2FF55A1P6p96FK
35032	payment	1397	1397	1678	1	1	13589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREajR1ANZThav7P1AGcfHxdy8DqeSi4VGymWTYqahq9mLWqVB
35033	payment	2134	2134	1874	1	1	4042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWy4Zv8wuBndCJVy1aSQvigB3eMjx6e78gZU8FJUozn9hpmP5
35034	payment	2133	2133	1874	1	1	3996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybAJ5fDNocQ3JS1fRb86FVNaPRWKREfqNbcLsbuV8pqfEJbSP
35051	payment	1397	1397	1678	1	1	13594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RPuMLZMjUKJwgoeAnBpcs1UyrD8i7EsRKdxoMppULJHKthYw
35052	payment	2132	2132	1874	1	1	1156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbjQ4AU4FhzLnnfxY93w7TA5bNofAkjkHpUXMPP4dUW8oFmzV
35053	payment	2134	2134	1874	1	1	4047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJezzXCZZq2XKcmuciaaZFJTVUvZ2vv2AmQASBMrYpTPkAXDk
35054	payment	1603	1603	2302	1	1	0	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa845XEqMuG5FVsWWevS6ja2KNusBvwXyz9oFYQ9JTNm42gd5x8
35055	payment	2133	2133	1874	1	1	4001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqbV4nWMzK3MB5jSNipYggNaubb8zWwQJqQrqjCqvquKNdeJc
35066	payment	1397	1397	1678	1	1	13598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo58Fqdhz6BaGUreR6uekGF6FodwkJz1z98yza5RJGVv5LdTdG
35067	payment	1493	1493	2304	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAh8ZUKs8ndTVoWuaUyVcMMHpmzUbTdxCyqvRwwMt2zwhEHQ4
35068	payment	2134	2134	1874	1	1	4051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYu8qHpYQ1hRqCzh6d4TnKQEusEmrHZEkNHpZMYqc1ci1rfKwa
35069	payment	2133	2133	1874	1	1	4005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxfzJx8r7FmCVzxg9AcowUBTqGcEkuDBvBuVJkHsGev4dhiqr
35070	payment	2132	2132	1874	1	1	1157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8WUTkZPaQTERs2NAkPCGrXkdibCZNQdPkCkc8q4qgWYWeKJV
35077	payment	1397	1397	1678	1	1	13601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm5dGYxwcmfVpxaD52wYUMZZ8xeFgwDFZ1tz5iQpwL8EP8uCC
35078	payment	2132	2132	1874	1	1	1158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhn457f1nuDC49DRxatsAELD6yLdSpbNrJpWUp5sMFBArpi8f
35079	payment	2134	2134	1874	1	1	4054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8vMyE26HDMBbzigXheJ19sZUVxj8CGn2NCB175bTRHefzTaS
35080	payment	2133	2133	1874	1	1	4008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT12ubhDa6PuH9QLigeA7FVeK1DY7UrgtkVjHgeMGk3qxsp9k
35086	payment	1397	1397	1678	1	1	13604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSdtHACDd8gGfAafJpjTfEsvnTDsm8SRr8amBxYNqtx2LBsrk
35087	payment	2134	2134	1874	1	1	4057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGE6AxEuPQ5kWrswMcNEraBn9bviQvSsqyv4E8kaHgFZJ3QaS
35088	payment	2132	2132	1874	1	1	1159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLBu63Ah8SB7iVFQeMaX3FBGr2T9v5bzFY4FpoeG4RRfJmmJC
35089	payment	2133	2133	1874	1	1	4010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QJ7qXGb1D2SesaBRcMJPCe7upFXdXmivpWxzLWGCZFJvKHR5
35096	payment	1397	1397	1678	1	1	13607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyi9AoPtgBvxzEnPn9MD1ojtiQFWivhsLdu1crVuNeogwY7PK
35097	payment	2134	2134	1874	1	1	4060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8n7h2YEJ1r3C6Mr7vxVcMhNwy1BKGkwjXiyQPUzptGuMArmhG
35098	payment	2133	2133	1874	1	1	4013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCrP55hJVBBTyu1CyQwDxMcJuxVi9PzawAirxeBCnVHvKQFAu
35116	payment	1397	1397	1678	1	1	13613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZxaBXLgHxA2xR768fvinmHzeNDfnhq5B5zeeoiKMbVWZihLX
35117	payment	2134	2134	1874	1	1	4066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxqWHcAJnb6WdR6M3yEFXPczVdnv5JHB2o7LDTGB9SScaJEoc
35118	payment	2133	2133	1874	1	1	4019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGTUGrMkxwfWL8iStYZdj4jaj6x4pi4PQSRZzQtc184uVFUcW
35121	payment	1397	1397	1678	1	1	13614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKW8ANC41HdX6yQwxZ2ovnj2JMDYbWJsii7mvjShoqKvdNENjD
35122	payment	2133	2133	1874	1	1	4020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGka45UNwjjg2LoKW1X5iiJCCfkqXXcqNW7pagAWL4WrLh4Zn
35126	payment	1397	1397	1678	1	1	13616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6exet6oovjBVW9Qo1S4MJkonvNWrZUtP9mdbY3UDdgUp85EXv
35127	payment	1397	1397	1678	1	1	13617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDshTW4kmPkpjguVqDQo5EQauzkQtA9dKSztbPTiZw59d2UkZ
35005	payment	2133	2133	1874	1	1	3988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfxCvabQMvdDG67BGSA4rXq6RQTmU1ToMeMcEs8VBx7xp45WF
35006	payment	2132	2132	1874	1	1	1152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqunhmqEgGV9JhPX2DbNdeVBnfEcUkieEZRQ6C7kWYFoB3CTVj
35007	payment	2134	2134	1874	1	1	4034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3v8LgRpQfmRJJ8BdZYJ21CXRbvU2BoKiK54KveZhbNLqtLwEG
35008	payment	1397	1397	1678	1	1	13582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8k4esCWi9uZWSjtagskaPNUiHAyqU17EtjCr121LSB26AqiEp
35009	payment	2134	2134	1874	1	1	4035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgiUkDHM2pD5wSEjB6UL1izTvUzTbwhLjrfkWTRDaGPN6bTF1
35010	payment	2133	2133	1874	1	1	3989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTx2A3Gm5eawMHmFkksfXJCH9RJ324Sfz7TH72wzKAiqLEwyJD
35014	payment	1397	1397	1678	1	1	13584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBYuzqFx4aEDDXPd8NDVtDJN2oqx7swPEX8U4a4ouo4qRcUib
35015	payment	1397	1397	1678	1	1	13585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9y52kQhqrJ5hFJYiWEtTVpfKEvRSNu3oFabrUrtf4TGUa9s2
35016	payment	2133	2133	1874	1	1	3991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRxFmetghuCyXv4Snu4D78vLRjA3EPwbbwBTDyqcHGDnGeb4e
35017	payment	2133	2133	1874	1	1	3992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkdG7QJRFcbGP7iUtHKCBhr3VGvUjnPJJU2Z3APKy4UzXz38u
35018	payment	2134	2134	1874	1	1	4037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmS6mTMQZP3nwChTrkjmzkyjQSRH76YQGayqNWbtG5NaTKxu3
35019	payment	2134	2134	1874	1	1	4038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HWB5DuDBTP33X5ZP6TS77Amg1MpYWnzD1omLjd6ES8JeqrW5
35020	payment	2132	2132	1874	1	1	1153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDw83hzFKZZimAdsyR3jTq8m4cRCQi1qBoBocD1sVvXhQLbnW
35024	payment	1397	1397	1678	1	1	13587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaWwGKaXRGx2GqpJoPgDt6qDHaWaGR4C2ggi2CesMo3fN2L1x
35025	payment	2133	2133	1874	1	1	3994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFnryonMyxsZKnjCHZeKPFSehjRPnhp6x3BhbetR4gQBCQGHe
35026	payment	2134	2134	1874	1	1	4040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFPntnZnk8dEWMtMT3yJLonCjh4yko64g8MewJEFJXqZ4mpFz
35031	payment	2133	2133	1874	1	1	3995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXba5mGSKifEoLDGdkJNUmX1mVhqAj3mjtk5vbVKvf4rS1Zvqo
35043	payment	1550	1550	2301	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaqJKSs3R9rmwjW1fnkQxkTgcBNqrcw7QKReFuZmWYLpLApNo
35044	payment	1397	1397	1678	1	1	13592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytNkwcfnBeSZp2Um4bemvLBZkNm6KYWsjUw2g1DvtQLEGYhfT
35045	payment	2133	2133	1874	1	1	3999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbVjzgsJ4j1ryHxA6NyTBihDJY56YgfpAzNxaMtdDtdXJWfqs
35046	payment	2134	2134	1874	1	1	4045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegRprkDYp3PvyCKJqhBtJKrytppF4o7gvcewWBtjEFRNGtueb
35056	payment	1397	1397	1678	1	1	13595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC2GmgACKLyY5AU6SqXvN2tzxTGtSutnkQjX4EyoskyjupvWQ
35057	payment	2134	2134	1874	1	1	4048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQXNC4k8sUxx6JzTWzT87wPUQYHZHMxC8B8HVyg73up4Cg9aL
35058	payment	1531	1531	2303	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtJUya75hDooBAVnPFywKRNxNLDqhpupMtYvgEjGWYG1C1EKH
35059	payment	2133	2133	1874	1	1	4002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtB3BjbRKmD8obcao9MrFyZ4sGBUFpcvvKQ55oT6gtU4RbyHd
35141	payment	1397	1397	1678	1	1	13619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GVDPEnii1S7jvKXrh1N869F6x9LXpP7U5eYBVQfvMHapJMCu
35142	payment	2134	2134	1874	1	1	4072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAR6oreF15RFzA6qCpvdEGQKXj8XF9eFNtzGV2GWJaFsPbegL
35143	payment	2133	2133	1874	1	1	4025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7VdrKgozj6Tebo3netVNNQ4aKfuiB459PAfnq5utKVJB2jPR
35144	payment	1397	1397	1678	1	1	13620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr4nt368JmX6aYghNTRPnPCPdD9SMDezuhJ2cN2N7Ejb7eMHr
35145	payment	2134	2134	1874	1	1	4073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTb8D5eXwNdMGAnvAUJnbh19Xj7e8pwJTmUf6KzQ16786kXBU2
35146	payment	2133	2133	1874	1	1	4026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRghW4bVdawuqu367ATT2pxpz7fgn9VrKXUZVSFJSMsu6bQCe
35157	payment	1397	1397	1678	1	1	13624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhudLpjqG68bKioADHCppxmkr5LWaWDBMfFc1cvv7XCA6oyTXE
35158	payment	2132	2132	1874	1	1	1165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHBh67SJb1hMJjdtDSzoaxuhrGVsGk5Nw4YDWfmdGteXwyo63
35159	payment	2134	2134	1874	1	1	4077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMQiFfzM8Csga6LJ3m4hfr1jzjk3moSYEbywLtRjdHHkvodcd
35160	payment	2133	2133	1874	1	1	4030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXEjiGzJgknW7F22iwXMup8wCpf3268DEBYkkbfGbRh37msY1
35169	payment	1397	1397	1678	1	1	13627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqqFpb53SFrhek2sdQoymTNR8NkfnzuytjChisswMaLQrVpf7
35170	delegation	2297	2297	1647	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hofP6fCawC2aZqag4MpEvK15udQyne1wd51pChKJiaB6ggZg
35171	payment	2133	2133	1874	1	1	4033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ko8KztwpEU7eBygoUyEGJ3A8Kx8qsuiqEg948DutpyC9Sj7g
35081	payment	1397	1397	1678	1	1	13602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrD64GSu2tFdTtLdtVNtruZ4oYB5UXywp1MDyYDkUhgtZtvWJ
35082	payment	2134	2134	1874	1	1	4055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5AoPpKhhKJE9FNmGA4dSptw4mT9wBiDCDi9jjKebnHogYaot
35090	payment	1397	1397	1678	1	1	13605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSdMSrRF2BBXuKhPmh3Ziv6g2WzTJqpp5Ct7hNKFJxkVQM9sZ
35091	payment	1397	1397	1678	1	1	13606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskiKsU5f8PGJfinXdSYjPciuEUh57raydAu8bNqRqohyV7YwY
35092	payment	2133	2133	1874	1	1	4011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6fWK7EptJ4vx2EPTmG1sM5jBtChzv17G6rZTKdd64UaFtsz2
35093	payment	2133	2133	1874	1	1	4012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTowjg511TGEBeScsr55RKpcU7sK7dnS3ka8C2c83jeV4YFZVP
35094	payment	2134	2134	1874	1	1	4058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ezy45osJnbK8yU4tcr6eQjGHssv6hwmnQEXX8P8QSRPGYEt8
35095	payment	2134	2134	1874	1	1	4059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXjTbqkh4eJGLHRuQMJptcJZ1naiuEGFMP1xgXVEjeiY619Qm
35103	payment	1397	1397	1678	1	1	13609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5xnboswjk5S97spXLWsrUtomtdLJkbANoffNy35L4eCDc9bQ
35104	payment	2134	2134	1874	1	1	4062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbZmiT9QnzerNS894Ttrk395iWvZxgBsZHxK1AabQhi3B8TRU
35105	payment	2133	2133	1874	1	1	4015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3z1zW1LAUJy8oYRxvUMHr2sUpmCYYXpN3RZtW5aFNqbUxmZht
35109	payment	1397	1397	1678	1	1	13611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6trAVZmryLq5hVreJCjX4Sk8TdPW3eG1Y3J4U35qJTRLRVaD
35110	payment	2134	2134	1874	1	1	4064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iWVTh3mg38mi9JZKewgSi2N9R7x46uxPoBbmpd2CkoApMFET
35111	payment	2133	2133	1874	1	1	4017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnzhm3WEFQRQ8pYYniAVZ5Mu9a5Aj8RH25hxJdM7JkupMxN2s
35112	payment	2132	2132	1874	1	1	1161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKDzyw3xKuDgYp3Mmo6Aho3Vu8R3G7Kys9XYHhuhBZ3jmbDTL
35113	payment	1397	1397	1678	1	1	13612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmFAE9TmWjeTXPF9m5WqaTw4L7DNoQ6b9XUz7QTZBq72L8Um7
35114	payment	2134	2134	1874	1	1	4065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMLrvoSScakbVXybfcEpYkyqBNLY8ThHVGUh24Z1TLWUHC8ib
35115	payment	2133	2133	1874	1	1	4018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn5Pm2oK9SQuqdXN5xzobcxFRxouBNdWQENHJi7pubCz4V53i
35123	payment	1397	1397	1678	1	1	13615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiN3QgbuEXMtqtrpVmDYa7Ynpm3WNtrTuzcyMZhCynH5HTFy4
35124	payment	2133	2133	1874	1	1	4021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiCReRp5zriYZYjMYs8k221J9iTaAz9A3KvvPJwir38Bi6jQc
35125	payment	2134	2134	1874	1	1	4068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1yx3kM2qcFQ4RTud4dL3b65Qsmcg6YasneqsM5pxFLc7vUhn
35147	payment	1397	1397	1678	1	1	13621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGYQnaztfXdBsBuyckfsA4Q3r8Yi2FdQeC6hUQiH7rqpwNM8m
35148	payment	1397	1397	1678	1	1	13622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFA82CsJHSrB1cajBQQ5W3dbTRSqVMQztWgM5eGmJyNv2VF8p
35149	payment	1397	1397	1678	1	1	13623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpngyrSNfo3Wt2yfvZh5KgZDW4wobF3mfNxrL6YxKeub4bdpk1
35150	payment	2132	2132	1874	1	1	1164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdnYk2Zk5d8dQAAK6338uFFFfLd8AjjvMLavw8rvMbgFrRfcF
35151	payment	2134	2134	1874	1	1	4074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLS9kTwypoP2BuPHRDPCG18GpU3MYSwuZnzXZBLVEfz4tsf1j
35152	payment	2133	2133	1874	1	1	4027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWHWzJBptMbWyYR2TPLEJS2JVTMNPxWFbwdC1oda9a5oFZ9m2
35153	payment	2133	2133	1874	1	1	4028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkq8fZDsoqTMkdA1CavxdwDaY4pud6YAmyhwtpke1ANAb4ziiv
35154	payment	2133	2133	1874	1	1	4029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpKsdHWQPTo12xqTsCZVycaEvxY2Yfn6rsHXLCRjChEpmUc5u
35155	payment	2134	2134	1874	1	1	4075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SVeHUA4e3jbaTLNaPVZJzZgp3fZnHRk6FuCCG7JHDXsUZB5o
35156	payment	2134	2134	1874	1	1	4076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtp5M2UQvysD8oLcTuxuS23EX8CGoVcCf53kATp6YUwhw8hFJi
35165	payment	1397	1397	1678	1	1	13626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMn6sLcUhYmw1sZ1Ei8TrESpcdAqS9KbANWxyf9aXdypwWism
35166	payment	846	846	2297	1	1	1	1207769791681	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPR4t2eeXQEani3nLoH4FR34dbCihE8NhSMioEQwHiS9dZ1os
35167	payment	2133	2133	1874	1	1	4032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbK581m3Rf4CyHVPjHnbCdzBx3qYQjGMmX9xG3EL2kaSmxxro
35168	payment	2134	2134	1874	1	1	4079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dEoP435QDGmHHgL6UfpEKAQJ2rnC53RPcVyZwxtyJ1BaDygi
35173	payment	1397	1397	1678	1	1	13628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iZWJNLk3in36a4SpgQkhA743hitkeiD72qTmoNqpeDAJaAqH
35174	payment	2133	2133	1874	1	1	4034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDgDwJtCStxepdmCoJoKPXY1vfnyjaSGcv6zdjZmfW2v6X1v5
35175	payment	2134	2134	1874	1	1	4081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuE5UGWZrBq7xpzkQgX9iDGmDTLhVCNPzGFxcsCqDCymCQvgp
35128	payment	1397	1397	1678	1	1	13618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCdUtCKojGghM4tgKMfhHFHAUv3xT2N7b95WJ3jM8zuDWi7gh
35129	payment	1422	1422	715	1	1	7	7313670138	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpYpNvtMMUtR8tyFjMXzQUPxJTJWh4PQ1KnuVbpGXY3CX29vKPkg
35130	payment	2133	2133	1874	1	1	4022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMXybq8TrdBaTQDd6AVURNPc1uNv6YmnoHWQN2TQQUou8rQKY
35131	payment	2133	2133	1874	1	1	4023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvKQsjdDH2XTEPKZjfCDrRHcPNnUkZf3YcGsH3JpJVmNm5E3p
35132	payment	2133	2133	1874	1	1	4024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoPiQHDVvxVLMMjuPTpuTj86RetiM6ZU3u7DsQzi9DJhnWbGV
35133	payment	2132	2132	1874	1	1	1163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnv4QadShCcQHCzDebcRugiDzLzxP6RU4Fzi4YPZvkYc8QskC
35134	payment	2134	2134	1874	1	1	4069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4nK8ZfG33UkZeQvekrATiXxi6oJMjCqgDgTfRpomBcTfreqK
35135	payment	2134	2134	1874	1	1	4070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUJoL5YYSh9bmZoGDpbRTwsY4HyyDRRGAyTipHWWSTNXXiKk8
35136	payment	2134	2134	1874	1	1	4071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cqNgyoHcFJDQSHGrkBH2ZD6VQSzcq1HZXsv1SgVv9QWvNi3W
35137	payment	1447	1447	1345	1	1	6	6195160150000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	Ckpa96cxx5z83Fdk7RZef2ygc7i99gJHhCbFJ4GKWqxo5t8XKmF6D
35138	payment	1447	1447	1099	1	1	7	3295005140000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZNiBoWVocmZDfh4EpryPdh5FqP4XjHdUF9j6FYDy7PW9CSFoWz
35139	payment	1447	1447	1219	1	1	8	2223205630000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZxVEZQBYFgDrn8xiPBUeAcahKkLrLr8su8xqWgf3Veyy5MgpBY
35140	payment	1447	1447	979	1	1	9	1838739340000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZPB2n8gmbJt4y6uBDQNb9MRSuFJJen5kMARGYEJykQyKLxfsLy
35161	payment	1397	1397	1678	1	1	13625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa117ZKGZZqQE8YfHP8v9E3KZcEr7vhuwgD7Xt6YHE29mkDyAsu
35162	payment	2133	2133	1874	1	1	4031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKBuwwQv7cK91LeaDyw55AXhUbDWnQM6GGRXuY2bfzfKvcewm
35163	payment	845	845	2297	1	1	2	1207769791681	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73SS1b2srA5mCpwJPLLLxDGDsUkYPBiuMBFdG3LEBfLwH4rDm
35164	payment	2134	2134	1874	1	1	4078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dEk3wNZHEbmxE8B2cgXp2BLRvSmNYVDePa2DD1Sqze9JbJ1t
35201	payment	1397	1397	1678	1	1	13636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TJQ4ywvAdeGRGyesKqQzACvh28M4EKBNy9dGKtFuNvtfPr6W
35202	payment	1397	1397	1678	1	1	13637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQ2sdSgiHXx8dXJLFgbbtXDktg8SDysdiPUXg5QDbnSEZ8zgd
35203	payment	1397	1397	1678	1	1	13638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCsXJTJeKcB1HxfbpUwziJT7Utqff1xMQczHuJRQKjmC4D8Gy
35204	payment	2132	2132	1874	1	1	1169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyYyRDoQ1ViMuLftpX1KsMCSkaypbnmC8TCiFEYRZyT78dioZ
35205	payment	2133	2133	1874	1	1	4042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxvfbNMj1fkjstCgrFz7Whe48L6ixPCnHyZQ8fuUcnZ2snW7B
35206	payment	2133	2133	1874	1	1	4043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qeg8MWj41EDBRxMoCrwKKS2XfR64noYzeWp1vCKtxrAAsSu2
35207	payment	2133	2133	1874	1	1	4044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqZ7oL2MoVuqKmLjuPL2TnyoQeebXEiEqe83yWJN5m6GnoeS6
35208	payment	1457	1457	1391	1	1	4	9830557440000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpSaK7VQi1hVWN2m6Z1QeV9vAF6nw9k2nmdgDauPXpuetkvqj
35209	payment	1457	1457	1145	1	1	5	5228605440000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wGWvxTPW4a2SGqKJPw99PiPwSgRExbjSabcccv23UxbWT7Wx
35210	payment	2134	2134	1874	1	1	4089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgVnHtnWV6drgTeGHrW3wSf8WmWxk8hmgxaqhYsbtPhoDa2YK
35211	payment	2134	2134	1874	1	1	4090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtM8drQzcCy8DLydyHC8psGn99jxTJrdJiQF7GiceiJZNmsFg
35212	payment	2134	2134	1874	1	1	4091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcHbFbJj3oySKudAi5pX8jJExU7JPpcq4XHAzn5kgGyNPH2Yp
35213	payment	1457	1457	1265	1	1	6	3527688960000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQjqwv5wUe68fbbHY1FifJQTYWKe6irYTL3iGfU95Zj3XBYvr
35214	payment	1457	1457	1025	1	1	7	2917670400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8kNTfUpBSzEpeGwocRvkNVRR2N6tpNXQuoaCHS11hsUMgJPA
35218	payment	1397	1397	1678	1	1	13640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd425uqQZzPusuuTNZ3DFJYuimzXg3NqxQYWLxAAG6ch82SPXi
35219	payment	1397	1397	1678	1	1	13641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYn2zCNfUPFQprhQAmvpnpCVbLZejvhxaBLEN7urmWHozNRoB
35220	payment	2133	2133	1874	1	1	4046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX8EeR5gYSyyEeKrcF36PbihaYj2hv4A7gV3GF4WRy6fgKaP8
35221	payment	2133	2133	1874	1	1	4047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSakmby8ronHNm1DfAE2GqQWTKBZsDbARXeWAtCf2pKZFN7Zk
35222	payment	2132	2132	1874	1	1	1170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirPDYQ45ZQyDJhi9FLggihjbzbvJkrfQ967vToZupPtVQXxoN
35223	delegation	2119	2119	1672	1	1	7	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ61dxrgYs1CdaC2iuW9eLSi2ePVTXTBbQrE7tNbrcwrJj7qMrk
35224	payment	2134	2134	1874	1	1	4093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvTijSeKeytgoELo1drE9N23VQ97ciueZeFMMJdVm8TvYA97a
35172	payment	2134	2134	1874	1	1	4080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWbx4rz4SGidJNBEukAs2AjH6ae3XYEYSZrJPWBRrw3hB5ytc
35183	payment	1397	1397	1678	1	1	13631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRPaqcjDCFrL4xT6VrvYCfEpYaPw6kvFAnJmZM5vHQDBWk7BE
35184	payment	2134	2134	1874	1	1	4084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXFhty57duJ5bzYcsa5o3kJ4PrcbhDDisems3z7rQSRHNKwf9
35185	payment	2132	2132	1874	1	1	1167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6vfEC9i3eH2p5FVQzq8M7rw2zvSGemSFTrhiQ8f4fhwaUtF4
35186	payment	2133	2133	1874	1	1	4037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZJJWHk41kY1cXzEhuK6ipseeyUkM3RmEwCnAeZPkohPud3Mh
35187	payment	1397	1397	1678	1	1	13632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4qAPwLeaaeLUggV9sAE3R9tmEqd3kZpeE8pL8rdTgkQ1ehXx
35188	payment	2134	2134	1874	1	1	4085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9G139dBWoxRHbKc6Z8QGZ3nCjqRsQosNaquMiR7qnPwkxywq
35189	payment	2133	2133	1874	1	1	4038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaES4C9jsLQukZH8Vp9PkzcA1zM2zJDCdwDMK6j5REnA33Sz2a8
35215	payment	1397	1397	1678	1	1	13639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYUBqAaSzesdL9YAakEPGRot38TRwucPq8cbsEGxaLXXg5qWM
35216	payment	2134	2134	1874	1	1	4092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8m679uhSzNVFnXyt1MLjVk9w4BZYReaQcZw7kJqE9PsZAkU57
35217	payment	2133	2133	1874	1	1	4045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7VhHD3TSLadNYvxmcZdNCDZz9K81tSEwu6dZ9Qb4NgQhJKCD
35229	payment	1397	1397	1678	1	1	13643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JdhjhEMjLqCGcbPcwGRYRAUeyLnkmq1VDdpbJE38ZyXfBtkb
35230	payment	2133	2133	1874	1	1	4049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbYopEna5GyefADQm2cnAnwooMCmja8Ny6HLTBUJkRKMNkDZA
35231	payment	2134	2134	1874	1	1	4096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTZjFWpjDWVAoN1u1megnqrZG4QTE8EQ76yRFTJL8f2feE8xi
35262	payment	1397	1397	1678	1	1	13652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJFuf7YQUuqvXoqUtdjs6FupbWptbp5hY7gE7NrNpS4V4qzYX
35263	payment	1397	1397	1678	1	1	13653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfukFmMkBHJhGqbaZXNsC3wRdVs7XjaC3F8UKxm4VScD11umwn
35264	payment	2133	2133	1874	1	1	4058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSrjuc66XL3fcVYzzE4owWHPGBm6dBwhyShxNegEL2wUAtgK
35265	payment	2133	2133	1874	1	1	4059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBNKpJkBn62eavYBYxrbpVUEb66DDUC7xjaCWh3WyngeH5Xpi
35266	payment	2134	2134	1874	1	1	4105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ec954q61hF6wv9r9bekzKMaGi7Qrye8HynuiHDXN4LjNypdn
35267	payment	2134	2134	1874	1	1	4106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjjaHapZMNryQw6yFEjyFCde6S66yWALEKceRx2wcSMMp6bFL
35297	payment	1397	1397	1678	1	1	13665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BPVSsEXEj2rLq7mZDEAXz2UEmKhefZ3V2chTaGN8t4jQhPNC
35298	payment	1397	1397	1678	1	1	13666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54kZxdizCWVk37CLfcQuWUZfARYgyTxARutHx4CGmh6jF7CxN
35299	payment	2133	2133	1874	1	1	4070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1Evc6asUmjKg71AjAbLLCUp7jKxjWp1mxnu1hf5jpBStv3Uz
35300	payment	1422	1422	1337	1	1	11	6538636350539	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZsJs1jC7aBMGEXYQGk3sKJGiM9tjqZF4knqYfYCpKj4oLo21Ab
35301	payment	2133	2133	1874	1	1	4071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L3nqUSDh1K31Sh6fjVhL5mAjgu1TsNwBXWuhftL87FFbn2w4
35316	payment	1397	1397	1678	1	1	13672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnxetUCsKoAFATDkTHXZwo4AP1vUgw7gRvG1j1G3WaksRf1ki
35317	payment	1397	1397	1678	1	1	13673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxLxXPbdAFWGqCsTHhrMx8RhKR1M8QMv6ehtQDnjrgqo4Y2Sj
35318	payment	2134	2134	1874	1	1	4113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SektyMQrq6ai9bNUCkSm3SWuqPycqWEt8ahPYhCGnSLYiXmz
35319	payment	2134	2134	1874	1	1	4114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMUAgfXPAa7vdCtekLTj8xPES34bgwetD3L7koacJjJZvVnvu
35320	payment	2133	2133	1874	1	1	4077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbXif97wH8443rXgH46xma9VUgsPr21u3yb7W6Rs6zVU9SFPQ
35321	payment	2133	2133	1874	1	1	4078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQcoHoESDpnrCiscg6V7kr9ghUZEpSPSZvfKgnuRTYbrfL7GN
35322	payment	1397	1397	1678	1	1	13674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueocADUdEiwhxZxNDR77yVGc5Dw9gnyfn9VdnWXZStGCpkRcr
35323	payment	1397	1397	1678	1	1	13675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXTwBpfUHtnwHPQzWCgEri7YoMVFD8fWaCb4T4Haadmnj9Pwg
35324	payment	1397	1397	1678	1	1	13676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRCTMvCwxeViMta7o8pGhgrAiqR9gBKeUgxW6s8w1DsDDuw1B
35325	payment	1397	1397	1678	1	1	13677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk5rX7FhRQBgC7smyrYcHqyg2UouwfdSTWHHdtjGVLTyYhJkY
35326	payment	2134	2134	1874	1	1	4115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySRANpX8UVv9rFeWhUbCM1XVmryRf4pKZuE7tMpDfXJuR6qak
35327	payment	2134	2134	1874	1	1	4116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSne2A9QWN4aP9dtyJX2wGDAXDAP6CZAFEkLESQEagM7S5TSkb
35328	payment	2132	2132	1874	1	1	1179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBotEE86KMchvMetevLGmgnei5TrDkDp8hhNdU9xSkeQ8poDQF
35176	payment	2132	2132	1874	1	1	1166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4xfH92wE9uUdJkxNuXBHnAAxUyJQRymt9m9s8dG4UYJ32J87
35193	payment	1397	1397	1678	1	1	13634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLKny28TMipaxFPFXriA9NeoFRhWRVwaosDyYhtVFBQo23xTP
35194	payment	1397	1397	1678	1	1	13635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBjpfuqdNmm5JxcPLMVkjSznHMZAJ54FNozkTKujQba1FAJnx
35195	payment	2134	2134	1874	1	1	4087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRFzi5WGyNPiPpZfW2CgrGNMEELp8EPr2VDtAxmbDJFnQiHRX
35196	payment	2133	2133	1874	1	1	4040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQttUM9uAvRTajrKyF9HPeKrZHp2ZYxZQjtmcnjZtDP11xUQ7Y
35197	payment	2133	2133	1874	1	1	4041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggjtWr8VamuBF7YZLXWRTGB2t3gLnCvphgJtefeD8m1UxrjM3
35198	payment	1422	1422	971	1	1	8	1940683950333	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZWeHMbYUW1gSQPgnyRAYbvdgSq8t4rtM5HYC1RaDbD1LwY2mrG
35199	payment	2134	2134	1874	1	1	4088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamgnrzpJRYRMgBkCJBTrMdwSdSxQKCk2xgrk6cNjQCuzyw7Nc
35200	payment	2132	2132	1874	1	1	1168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmxwwFGoWiJdyNxYsqa7LCiVQRBeEqLNQtT7iGyd8SiXxL8Pf
35232	payment	1397	1397	1678	1	1	13644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9mPfVFrXuMr913VXojr1h13vcRjTLeNL7PiHKUBmtYFsKHxp
35233	payment	1397	1397	1678	1	1	13645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUH6VNh4CzvSc4aY9R4SnXsdx6tbxMDP56LvPUqS4GWmpSY9Yv
35234	payment	1474	1474	2305	1	1	26	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiHogT9cDDgD1rBj11vt7covF3Gbr3gz13z7vDc8moQ7wgLAV
35235	payment	1397	1397	1678	1	1	13646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2UprnA3DUUc6mhRoDj73EArBStjs1a97v4HHGoGMdRNYdfbb
35236	payment	1397	1397	1678	1	1	13647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCdbDv2Bo4tNWq4VfTi5Uda8weBTVLisBo3g7WdyfZFh8cv79
35237	payment	1397	1397	1678	1	1	13648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhbZSopitL94dvgBvT3JZ1ZnkATddVQiGV8W12o1iFfrhFRzy
35238	payment	1422	1422	1211	1	1	9	2346466073716	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZJ2QVXs5MAiMNP32rjSirpomV5Q36wQfWxyNJ9ChaaqPCtCa9V
35239	payment	2132	2132	1874	1	1	1171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1Yw3VeD3EaEoA6r5TmAToWnxqpyk54DXW9Qu4RZK2u5yTmWC
35240	payment	2132	2132	1874	1	1	1172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHY88PNnJ8ENVdTwXcuwukkBLetnPrqVzq7v838ydWhNcdd5k
35241	payment	2133	2133	1874	1	1	4050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwUKMhNvyQhAcJ39kBPkWAGoUqJpegqGeAyxB2xzu78P8Pz5X
35242	payment	2133	2133	1874	1	1	4051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGVgsRgtNZTJBGPSSQ5HiBrGApvyUR5atTTtEwkgR6UxFehYx
35243	payment	2133	2133	1874	1	1	4052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45nnXC898aj5EvDmEcwfFueM4mY9sXJmSvaYo5qXv72eCa77F
35244	payment	2133	2133	1874	1	1	4053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbybVxkaVNV7K7SGAnYLypwPFPPdxrGAx5AwzR9vKsv5U4JN2E
35245	payment	2133	2133	1874	1	1	4054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdRZoLL9F9okWjHexK6e1xkdELYUtVQ8LcXgKc53qfzgjKw6U
35246	payment	2134	2134	1874	1	1	4097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLf4rqaYVPMah6b21KD5gDPQe8kXQKTFftR3QyzFipvDgnNcg1
35247	payment	2134	2134	1874	1	1	4098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMg4bcZLUQow5w95qBaeXkCMRGkqdsdEniMQbmzh8H4EdFJr5
35248	payment	2134	2134	1874	1	1	4099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4y1dWJKrx4JrMCC2xgDsdCRfwJuuPAGHSGkqM5ML8hehyPYXe
35249	payment	2134	2134	1874	1	1	4100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnhoqdnrq2ZmsCdhDNATcYHF96kKDbg11589fmaf8s65UZSJz
35250	payment	2134	2134	1874	1	1	4101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9krNgf8QLQDRsxvzy62UzQf7WteDNtFN4R4wS4hjmRixXRUi2
35258	payment	1397	1397	1678	1	1	13651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjSnXE5eKABEGNBf8ahfcsybuB11UAMGz6Eiha1GCD7JBvVnN
35259	payment	2133	2133	1874	1	1	4057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1yRwaSdCqL6UGgKkeQ4CT9PK9RH7ooe8gfVBmPKMmxtwBXqA
35260	payment	2134	2134	1874	1	1	4104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2aRtYqDncjTQPHo6T88mQkxqtyp3Fq3aNewVQT4vN8oCWuxL
35261	payment	2132	2132	1874	1	1	1173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnR69QqD341kgVmvycadL2TE23FkXswr6R1uCWpzVWh8aqep6w
35270	payment	1397	1397	1678	1	1	13655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGL6f6G87MdLAUYJXzhTxBsKVrS1v5x1hsnPTVPRN4QiYp4jD
35271	payment	2133	2133	1874	1	1	4060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1BvsC8gHyMrwnkj9BKmxLV3vfBw3A3u4QfzgtSQ4BnoyxCqJ
35272	payment	2132	2132	1874	1	1	1174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJPSovKqgw9QQXXnyg8RgMeiLRenwFfVKaYGA8j3RxgtYZmce
35273	payment	2134	2134	1874	1	1	4108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ivgocZg8usg1cifv4NNGAUJsb6x4PvB4u2xmP6Ezz7r5LhYs
35274	payment	1397	1397	1678	1	1	13656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7BmEURTKgquDCHdbSEpunfzDqRmvVYH7uAcx9xypP8a2yZ5h
35275	payment	2134	2134	1874	1	1	4109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBByj6M4zT2uC3dQF77u3oYwxbHRwjW6SZ9f4h8kDcvE4Un8SJ
35225	payment	2134	2134	1874	1	1	4094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPvkqEN8NVcRRYRMwWtWscjAYzHSjSYWJ5iSJaGX5BKU6SzAG
35226	payment	1397	1397	1678	1	1	13642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iJ2DTmUpKRdrjibauZEFQzstt2DhHTmMHbs5MBC6ZmDX5SxM
35227	payment	2133	2133	1874	1	1	4048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUW8vDz6BKRbx31sZVfodRpeNkcnt3vKhKYSXp3as91EksjGV9
35228	payment	2134	2134	1874	1	1	4095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVcpHVeBBcemPiq4LXSaV6vfFRBo43H1AteUYh57zQmQYQ83Nj
35255	payment	1397	1397	1678	1	1	13650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqEmnHhYh7vqk8sivRafz1bHA46VEWPKa7GS1Fct9shuNk4M1
35256	payment	2133	2133	1874	1	1	4056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6JTQWJDsT9CHF3nE9Vjfhc8anBx4GujAGJhyazM27AVM1jM2
35257	payment	2134	2134	1874	1	1	4103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt31wfvEdKh7FnvCGdyCNrVKZLCdW34xwkkQSBgk2Zr6xxyrD3
35277	payment	1397	1397	1678	1	1	13657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJp8Ymdq7TYP6uwxkYvDmzUMkVa9g5fGiVi415f5hehmivaxr6
35278	payment	2133	2133	1874	1	1	4062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VhHSe5gSEXu3b5J55MEbjyfpEsyob1fzcUNJLrQHEmLeFdPp
35287	payment	1397	1397	1678	1	1	13661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81pfwWpitUFzM7Euh6DTSdbyEFFaMnd9Pu21MvmgJ8hRitaZU
35288	payment	1397	1397	1678	1	1	13662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRponXHWZSdS5Po4Ca5qCE4rT52P4UWvp4yYfnUkQo6f4NNN5z
35289	payment	1397	1397	1678	1	1	13663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgoEjnA4qvYHqbarp9Sgjr5Az5jQW53BVrCe9fqFW5YdwpLzx
35290	payment	1422	1422	1091	1	1	10	3477689011215	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpYmVwxARfrzLX9fyvwPwJWMfeepazEHHDj55uu8hpAA9LPNxRSZ
35291	payment	2133	2133	1874	1	1	4066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LfESJxWPRxEiYxc6NKUa3g16rtcoP2yU2hjvZMLtoE3mbXf5
35292	payment	2133	2133	1874	1	1	4067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsjAE7maeecg759rCSfWQvTaR9e18rz5QCVgaTuYpmmSp86tX
35293	payment	2133	2133	1874	1	1	4068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEVRtiG6nJRH5eJQGbV6nVYjyaH5XH7hkquQ4qgkXpL3oW5oV
35339	payment	1397	1397	1678	1	1	13679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJwFsQc4cyKwSAQ6QrSgmWrMRGFiVMmLVyzHVLQbrEo62682t
35340	payment	2134	2134	1874	1	1	4120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHxPs5vj1JMxA2Raw4uM56rA2ygr15REmLcV8ACRZiCrZJJQX
35341	payment	2133	2133	1874	1	1	4084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVXeGeM2Gasr7unbHqoDrtA64EeiBHg8r8vvJ1CvSzt1JbmAn
35342	payment	1397	1397	1678	1	1	13680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yqKXo8jgWhxqF46ehRUyWMEM5AgzbqxxoUpcTPNcbNigsBML
35343	payment	2134	2134	1874	1	1	4121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZao9JuvX9mT5mKjRWoPEaJiRcMaUD1wm3bgZ3FvEGbY4Spw3pn
35344	payment	2133	2133	1874	1	1	4085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhFSQQkWzidif6MMkD4mJoT6SQewjqZa3ZPrcRZmc5e9isQba
35375	payment	1397	1397	1678	1	1	13690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4ndnWsEzm8yPodpgdcATcir9mmLUSKZ6h6y4r9yrKunoAcEK
35381	payment	1397	1397	1678	1	1	13692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxpUSTCQ27y9itb39NUXx5x8pwzgnRxtSs7rUJckYhHhBGhZ9
35382	payment	1397	1397	1678	1	1	13693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKYvDvhchoF7FqYDAsgkahGS6c1Kbosy3ze517mLQBdsjNrt9
35383	payment	2134	2134	1874	1	1	4133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1JdcvouRVBqVbqC9XSaoRfYW3yGVgn2RWJoA6x9PPdtKHosX
35384	payment	2134	2134	1874	1	1	4134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV2AwQ7etn6T3GrqodGkXZ6goqpxzbCs7QE6VnjrndKiEGwFs
35385	payment	2133	2133	1874	1	1	4096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm1QmH3oyQgiMpnkEPWBdjpoUHUrB2fScu4cTSx2AYVxGfyjF
35386	payment	2133	2133	1874	1	1	4097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfKjbKcD2ZBTf2ueQVTmEqrXtCFeWw9vXGrXL97qgN9DG9yn8
35424	payment	1397	1397	1678	1	1	13705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXw9LmuwZkakWmJ5yXXXinikDwaK3p4Hd4WCmHskAx79VaRahY
35425	payment	2133	2133	1874	1	1	4109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayqLSwHZGbDNE836JV3NcffbVP3FCHp1GgWArH11JBkwB3vHS
35426	payment	2134	2134	1874	1	1	4146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxAqKWqYUdtddQinQXhC5kEg2iYqSNaRqPZfRhaappiskTrUj
35449	payment	1397	1397	1678	1	1	13712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2uxHw4FYKCGvCPM8pj7FY5ofB3ifZk6E5jVWqaHgWxfWbMqu
35450	payment	2133	2133	1874	1	1	4117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusZ1QvdP8Jete9c9hhRecj3DQ3prerphVzurrEpqjrT2bthXw
35451	payment	2134	2134	1874	1	1	4154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xKYfuAR91M3GSHZoCYz9MSexa5L4zzxys17Fhr64JjtJZhLF
35452	payment	1397	1397	1678	1	1	13713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3yWP6RHw8EdqC1kBCNLHLvqbFhSZ35oiYp5wqqwYKcaHnzzt
35453	payment	2134	2134	1874	1	1	4155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2NSVarzAjYtfLggPWAGhBxNU7ghueoW1qZnAD2itsUAkCCPz
35454	payment	2132	2132	1874	1	1	1191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgWC2FnourW1wKL3aFqyAMwNh5hkwxsaM9m6y8JxtvrBgrLYJ
35251	payment	1397	1397	1678	1	1	13649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxPQL4idxkN7hyq1RaMkT7ReeoYVXkqtnPyjQ4WbyHiMmX2WG
35252	payment	2134	2134	1874	1	1	4102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSB8EigW4dkm1fyCSwGr8XwuoowBsQCvgydBgAhSHCWsuPhiX
35253	payment	1569	1569	485	1	1	3	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXMH6qUaz3TDNqQfZsMKBRFdXZZTc7JixkBEYnuzaDhCMBDzX
35254	payment	2133	2133	1874	1	1	4055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TJRXZQthKLwUoUKzprt4do2qQyzcmf7yci1LNeqysNJgRSt5
35268	payment	1397	1397	1678	1	1	13654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcL7pxxLP71ejXikH4hjMwyfdrScK9Cn1cqFtBYsFV5TYonciA
35269	payment	2134	2134	1874	1	1	4107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4LdTmnytQaFtV13z3djRWUQop3FQwRy7MdwtadS64qLbAKA6
35279	payment	1397	1397	1678	1	1	13658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxJYWDRWFYD7JTv6cBwtSWF89UvY8k51TNvGhdW8wN8Fnst6k
35280	payment	1397	1397	1678	1	1	13659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjEP89w8SZoaevp4gGxJsyZ5hJRGrkTbZH9k1GxzhVd25DmqY
35281	payment	1397	1397	1678	1	1	13660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWiSN1y4Fnie39qgdUxyWCAXKWXo4ht5U2mKbCZ5qZuHVKnCh
35282	payment	2133	2133	1874	1	1	4063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnTxoVjkF6R8jRmkMBPNwxxdHQkAjDbZYLd7mEY9p3EF3dWZc
35283	payment	2133	2133	1874	1	1	4064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y3FnJZ2Q42CKtCdPoC2GAqfYMkR7F63CEJeDneBqatrdCxtg
35284	payment	2132	2132	1874	1	1	1175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGchjDeb19rH5hfsewdVxJiLG8FwU8WDvKMSkbH9SfXG9r8orc
35285	payment	2134	2134	1874	1	1	4110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzEqMpnaf1uyryHaxeWQCtoo23PeVTN1myXUMbTducMzgBtye
35286	payment	2133	2133	1874	1	1	4065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCbuYznrkqDkTjtCLKWRHANmLKSh4RZzaT4xoQ6xrrksWWBGZ
35294	payment	1397	1397	1678	1	1	13664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKiQRGaUM5gcQG15B1xv3Em39zrjVcR17uecrFwJQPE26uSdW
35295	payment	2132	2132	1874	1	1	1176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftaaMnhcGzEADQEY67Qj2LRsfY3eP9aWVzGsuD8Cw7E8FEUPW
35296	payment	2133	2133	1874	1	1	4069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswGruewEQwBzL3xy1wNq4Hs67kaaSgGp1EeiHTgu4zrciVpFz
35302	payment	1397	1397	1678	1	1	13667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrPCqjtV2dQXENuCuoBCmWfJAwUz67NhGBECmUThdqZqvKpJY
35303	payment	2132	2132	1874	1	1	1177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmUchytUmBGta2DRQfoESrkT5eQoRembLKsYt5eTZYCj3izAx
35304	payment	2133	2133	1874	1	1	4072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Gv5YvYDASPyX9aXkNCBdwyxVGfUJbrUkXrNmDmcRe6Sg7jtC
35312	payment	1397	1397	1678	1	1	13671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbP6BFLs6zba71aWjhsMKrh7CCqnxURbWFNFR6GahCoX7tfqzp
35313	payment	2133	2133	1874	1	1	4076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjNfZoHfUHHcHSX3cEY9Nq9enR7Sy2hjVijPrdbg5Juoq2Z4Z
35314	payment	2134	2134	1874	1	1	4112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsThTZAKt6pbffWi6y4rsihMpek73ZmttpBV79u2Dmkr5fB7Vk
35315	payment	2132	2132	1874	1	1	1178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3rhrBHJJEjNrKDED4hdyUdcNLCYiX5AN1obiTfLBzSdTxAL6
35362	payment	1397	1397	1678	1	1	13686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDCys8MQKsdzgnysHaoEVNjLhtLSvk1Li6WZAy3MRjw4XjgnR
35363	payment	1397	1397	1678	1	1	13687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSjXmQexiJYnaW6mf1jX7mBcYvxwcvzh1c64oV3dKk32Ca6fd
35364	payment	1397	1397	1678	1	1	13688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNtWGSCAEKQVgj5CjSeqpQ7Eh1XGoNjj3Bb6FCBYimS2JYc6g
35365	payment	1397	1397	1678	1	1	13689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjuBW8jgj1SpT3BrdvsyL4z28vGaRe6Ub6oY8NSS5F9MyrjLw
35366	payment	2134	2134	1874	1	1	4127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KBCs2BS95x3gTX62dwVYikUxuRNqP8ZAsnyUHHrgXMcGqNEV
35367	payment	2132	2132	1874	1	1	1183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUicZsiX4xVvg5z8Qr777fvpKpyopWr1F9SoPzYfbstJsdLNX
35368	payment	2134	2134	1874	1	1	4128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqu9F4QYsGCu5uwkH3hrBfoZHsNZGeGiu5BpBk7wxUNFSMc5P
35369	payment	2134	2134	1874	1	1	4129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5E2apzCsK4RPZrUZLxCTypf7apq2TfMJtWYfniWWkUmec1fwy
35370	payment	2134	2134	1874	1	1	4130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4pFmmpSEA1wrcJJkth16p8aDxrMbmPs2cioTP3NCBhto5Qj2
35371	payment	2133	2133	1874	1	1	4091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ucy1CNVqmQKRCvFWyW63JvSQUKep3x1cYUwFeyvSGu8KP2XS
35372	payment	2133	2133	1874	1	1	4092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCVxUSGMwyK5W8M26CBxRWPDQa4pzkpi8Jm5VVqpY4gEQutFm
35373	payment	2133	2133	1874	1	1	4093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYZVb8tGCZyVCscafMrAQLXQtjr4i6Aj97MVvsJ2VGGnwdpkk
35374	payment	2133	2133	1874	1	1	4094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQqDzGW3QjK3VBAjr6bU1f4RNBszAYUAtFq6cDeLsYUcGV1dL
35380	payment	2132	2132	1874	1	1	1184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQKZFT3fPWFNCEALJtXEDquLQatnJDBhf7KbuZnBYL3GBkDTF
35276	payment	2133	2133	1874	1	1	4061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8RYrdhws8YEzDyofyp3cEcoEywEU3rgdvDzrA9PWfE4yBAKN
35305	payment	1397	1397	1678	1	1	13668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HCRJs9pBBADstw38NN7yMwUxdud1HhVASWLcTBQV1haHPwTJ
35306	payment	1397	1397	1678	1	1	13669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjP1Srado6qEp5MYRwxWuLh5Wf2tXmsiB5J3pEbLTi2HksACWa
35307	payment	2133	2133	1874	1	1	4073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirq2cGbjMs2JMEHWQZoGU4Gba3bNvwgAJHZFeHUw89pLxUvZV
35308	payment	2133	2133	1874	1	1	4074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39odxJxHfNcFh74vuabTCE5chopv4iEsshEmqP5XszNRFKY5b
35309	payment	1397	1397	1678	1	1	13670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFLVyALwAVhHJW9T22r5WVJcCQsWFkEp78fcsvD2GhZ2ipVfE
35310	payment	2133	2133	1874	1	1	4075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15edjYcq5hccLs5ZDE2iN33tzMkYkvQ6FARQeaSukBbXhTcDe
35311	payment	2134	2134	1874	1	1	4111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhNH4mjqtgTvzyQCFU6vtLckfLnrmek7MS1ZKsBRQviGeywKM
35336	payment	1397	1397	1678	1	1	13678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFTdWEHAWc66sf6JyHckLQBdrdtS1FruvwH2dxUdGBg6FrQLK
35337	payment	2134	2134	1874	1	1	4119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmmNYaRPw3WyPekTXJPxZ14ZcM1MLdMxuhdS1pZHdZdCxymsD
35338	payment	2133	2133	1874	1	1	4083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEtPTAZiBBsLoEStoWJavtJtVsRYhu1Jo992UwjT7caMRasrb
35345	payment	1397	1397	1678	1	1	13681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGikWKTdVk2ar3kFM3wGSQvxt1sdto2w9sJcz1SMEVTHKvhMc
35346	payment	2132	2132	1874	1	1	1181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbdTWKgWpFxgmN1opQpp9Pyf7pnsH6yZszFYRszMLtVuk9E1X
35347	payment	2133	2133	1874	1	1	4086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dTmhmmomLREAJaNjfV1kFNG69JPFyBQny22RHJqye4zyJLKh
35348	payment	2134	2134	1874	1	1	4122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPLPJgx1AfNc41aZP2r6XnNosRkBaLJ5KYktZD7acxcqGjoN9
35352	payment	1397	1397	1678	1	1	13683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoAeJLvX5zMPXhsAUVCEfgFJ5aZVQ4K538SuHMZzVb8wojxjH
35353	payment	1397	1397	1678	1	1	13684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJsvMujVUNx9EyX9QNTye2JMSbGHe8hkkqtqVG3sSN4HDmzBx
35354	payment	2132	2132	1874	1	1	1182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8GvFgN2T3UmNnxYeLrVk4497t19eqKenSbKq7ZenXz89ed2Y
35355	payment	2133	2133	1874	1	1	4088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvSwP94qAYAu5CTx8B4mh3AREQrSSH9rqizSQC8N35JZp9S1
35356	payment	2133	2133	1874	1	1	4089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyn71Rf7Fih3phow6bJNznhHrew1wePbDWCFfyX2YMuQVSfJ8
35357	payment	2134	2134	1874	1	1	4124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa146KZf63i12XDvTS9uP5xkTh3rRhg2PE5wbEWAW9d4r8CNJ6n
35358	payment	2134	2134	1874	1	1	4125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUq4Ndr6wz8YML4qraLexbScicJdzKbu24NvnQc1JWKgXFnYT
35378	payment	1397	1397	1678	1	1	13691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf94GTBmnnpUWXHgRv9oQc6FAx5LVfeADWKXtTCEyEPqEYABK
35379	payment	2134	2134	1874	1	1	4132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxYTtAy1TXTpnQjAdjjeCjS6EpBdBe4Go1dtfuobmBj3NkVMH
35387	payment	1397	1397	1678	1	1	13694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vADosZgJSVauLgvU1BPMYVzi3EZWLSiPzUYm1V4eJBsJY9i9
35388	payment	1397	1397	1678	1	1	13695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6AMtAAC2BdZDSd6Mek5AUywmxDvoAb3TXykgmiRrSvxieVGg
35389	payment	1397	1397	1678	1	1	13696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn38pZfEbkUi93S6eVpG7Afwpk58yhZyvHCvBKvGsxySNKZVft
35390	payment	2133	2133	1874	1	1	4098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkY44FgozDD4v72otxojHUEDEHFtE2s3NivnTANpeWG8vaAwc
35391	payment	2133	2133	1874	1	1	4099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaL8JviPNwXyUX5HfzSKC4RcURabnKo7bH2gnCMwpa5gfFx61X
35392	payment	2132	2132	1874	1	1	1185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy2z6miG1Co3m1HqLu7w6V9ANZTdJy5jq2e957Mdh8SaLa96cy
35393	payment	2133	2133	1874	1	1	4100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iyhBfBCirVvPXafL32jBJLE2f85zQvrbaAnAYsx52uU2MTaB
35394	payment	2134	2134	1874	1	1	4135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGEUv4TjvDEPoo3tcuAbZTnxaFvM3JaRWgGd3sWLa5YrK9yQe
35395	payment	2134	2134	1874	1	1	4136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf7EMU5N6EX1u2yDRnbtqpu4jFFPKbAu4KHohMB4A7iG8DtLu
35396	payment	2134	2134	1874	1	1	4137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxG94ePHPAVgX1dtXD2kJ98JmGmEpicTcHQDu4VQ5HMaVyKJHs
35417	payment	1397	1397	1678	1	1	13703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvUqXA3Jgg45Ge5CWSLDn2cU9okmrzAMMxemPY2MjqBZ7uB1q
35418	payment	2133	2133	1874	1	1	4107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmHwMdDRWeHpDr2Ji7sKXXoKTukNd8FqY9Ck1oXzoptRFe5cm
35419	payment	2134	2134	1874	1	1	4144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEXKEGDEfk7hjcc9ZS3nspduAXUdqHQwwzEpbD3JRqPYEXPKT
35420	payment	1397	1397	1678	1	1	13704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvT4hm91oxmWVt1y8PULHD3EZJrW8YAVxJ6uqamsEmZDEsvduM
35329	payment	2132	2132	1874	1	1	1180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkA2j9KuMP5LEKG6EKCqkJvRGXHXWpQgQo5znNsZbKArzGypy
35330	payment	2133	2133	1874	1	1	4079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuY8jz5TzMn38fcs9xd1AcdDTwjyRiXytDjhPDyqv63MUARpL
35331	payment	2133	2133	1874	1	1	4080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa3kgXH9EaRTA4PhML3e77RavA2aNtqa35jzKFA6y8PR1EuTf
35332	payment	2133	2133	1874	1	1	4081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqMejzjqbMztYqDb89tJK6rSRTV95hWPWDJ7GgbqS7xQHJDxt
35333	payment	2133	2133	1874	1	1	4082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFDAbjWhFksDF1zHT6K2GyBfMoSQxsBSm9tgw2ueipdczt7XN
35334	payment	2134	2134	1874	1	1	4117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNbMezAthJ8aJQuNFfPnxV2i4T4rA53usSHXxYBeYvfSsTQPd
35335	payment	2134	2134	1874	1	1	4118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzrGEyApzCaGsPBycVyXAvkAe3cVnnYy11TaruaPyxM3miLDY
35349	payment	1397	1397	1678	1	1	13682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aTVcvSt86ULtjMsurMJ6Vfs4bomxbKD1ryBNDLJH9YQgxbQ7
35350	payment	2134	2134	1874	1	1	4123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8ga5vr1jWkVU3tVdWKFPWEAaoUuJM1S1rnDTzXsNqKTVXS7K
35351	payment	2133	2133	1874	1	1	4087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNCcyzJy33yr6LQJkmaTQLiG4H6DU5zvK8BQLkwogskzwquen
35359	payment	1397	1397	1678	1	1	13685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6EC74oGXmrDh761KaqbcSXha1BuWMX7cwP15pSc5v1gMZiKT
35360	payment	2133	2133	1874	1	1	4090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KvcNKrSstgPW5DQuKx2s9qZAq2XMMQLVwN3f28cXM1vfno3V
35361	payment	2134	2134	1874	1	1	4126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTL5D9LP4MAJrmAbTv8dEGCikkh9AudYsSfgt3qxKeRzs83Moq
35376	payment	2134	2134	1874	1	1	4131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADHqg6JpaRykYktP5ugV64WEd3KiNdZb4dM7T3pn2xG2YMuex
35377	payment	2133	2133	1874	1	1	4095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZJeQwHPQLEhy3M3856Sd5tbt3wKg9rsg8Rrsa35CH75czeqs
35397	payment	1397	1397	1678	1	1	13697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoUnhah6TdhxsmA79tMTq1s9nJxA7NqGysmzhjDuX1TzLAes8
35398	payment	1397	1397	1678	1	1	13698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEM8WRNkcqoRiyWn5rPyd1Wyacbosr223yaCBtWwqFFjyRG7yi
35399	payment	1397	1397	1678	1	1	13699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNKhn1FkHeTqxf2QyZW4me9HhXyBarPeBhqRKwn8siSuJBtEJ
35400	payment	2134	2134	1874	1	1	4138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbyqQ17W1qtSfMW2fxV4WdYw4SWLWGoZ4KcbxoQevrXc6iRY4
35401	payment	2134	2134	1874	1	1	4139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFvvV1SSyoQFiTQ6vbrLmU7E6Fi6teFCB6HDskwcy5Qrckih3
35402	payment	2134	2134	1874	1	1	4140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPDn113aVwqwvReovisWntHNzJ2ABb7bkby6m29H5kb5ohv4T
35403	payment	2133	2133	1874	1	1	4101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8579JBAZJd2DjWHHDYTuTdmRw8DaU2Lv5j41kpuNLUzK22AUi
35404	payment	2133	2133	1874	1	1	4102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTVEVk2yDBDu3dgNmrHTdMzzXeS77G5hK9Kqp8rgZx2pmHjK3
35405	payment	2133	2133	1874	1	1	4103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgagqFUygpDERgWXsvYFFtHbZCSkt3QrneB62BXqmhRymdC9xo
35406	payment	2132	2132	1874	1	1	1186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXGE7bCxis5wKxii9Aa75vP1cut82DxuaBSHydSjLmQC1REU4
35427	payment	1397	1397	1678	1	1	13706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbs23crtM5kEYjR5ArsgoPhJVw8fZUm67jWVHaq2WPm68ot688
35428	payment	1397	1397	1678	1	1	13707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1tA4X6KhjdsGXYWz5ceAFtBM17SakDxwVuJjaAtr6jiz9LRi
35429	payment	2134	2134	1874	1	1	4147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9gp5E3agGF3mnNzuCAczZtPNAGhZgcWtArMw1kZiNigS5h6f
35430	payment	2134	2134	1874	1	1	4148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNCo8wQaQGYiGCHXii8Ha1mDtMfuPpQLaAGhc7spaq1P5aXwD
35431	payment	2133	2133	1874	1	1	4110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiu2dgShyUHYfGJJ9dR8YWzXdi9UDcmHV5LV8SeZpPTnPjyFNs
35432	payment	2133	2133	1874	1	1	4111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN84moSNpj4qV54i2Nbv7FuE5fnDy3WcaaeqhtxpMF7ej7xEs3
35433	payment	2132	2132	1874	1	1	1189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrkXBFQJC22LDySZgQVudiFJ2oRYUdt9XtBvUHFTW3pyQgiaC
35434	payment	1397	1397	1678	1	1	13708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjYJCkFSjoN1S1cSRt8ub3trQDdnZyrbDALAwH5AXEwFSDpQ4
35435	payment	2133	2133	1874	1	1	4112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYac4EdMuLXRej5LMRBY4rAUNhDNCujJY3sRokcpiH87Q7LpPUx
35436	payment	2134	2134	1874	1	1	4149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsACUhiZkqAKp373tyUfvf2znB3BHPxwJRfeMDXMJzoMrkNcHw
35439	payment	1397	1397	1678	1	1	13709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9B62omEkuNMqQp7ab4p2paLcfyxoc7pcbQaeVvzg6mvwKo9K
35440	payment	1397	1397	1678	1	1	13710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3W7ExtWRHg6NLRFNgWsnyhVjcHtixSBt6eEmQsYMrHY8jt61
35441	payment	2133	2133	1874	1	1	4114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiZzcib3i2cPNWRpY6ufrAHFzn9FrAVainzTwwrpDYQjFKS3H
35407	payment	1397	1397	1678	1	1	13700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrYZtBTfUNivcevoyCGZWdpKCLQ5sH23cTnztUzkiKxm3NxMF
35408	payment	1397	1397	1678	1	1	13701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs62sJ31ti5E74wwNoGXdfHs8ydqUBfYEYuLhXJDxRXDHwLZ3V
35409	payment	2134	2134	1874	1	1	4141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTP6786JY2HR6ghkMUiexiFpw8civecmHDiD4MoGjSe1Jk8Wvn
35410	payment	2133	2133	1874	1	1	4104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkNdHUEh9MZ3GHAafmP5XSR24iUuF1VbeDrmYbP11TUMgw15M
35411	payment	2133	2133	1874	1	1	4105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1EB5b4i2C745H2srLEq3ExbCzXmi9z6PksqKTqXAZ3RurDPW
35412	payment	2134	2134	1874	1	1	4142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6G6fzFpnRC8adFDHP7Q5jT5uGN8hw5MShTTAWD3nUxnPBLPJV
35413	payment	2132	2132	1874	1	1	1187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XjebPftdeMZfLCSX2nVRvWbeCJrhoYwqjNicgPSUef3pPm8G
35414	payment	1397	1397	1678	1	1	13702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzjYLhdQBt1jGKrpbeDTw2zoJ113FzWPXww1wwbtv4gpYz4ba
35415	payment	2133	2133	1874	1	1	4106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyjkLeb1wBV5N2QyX1W8VWYU81m5LiWLEf8Cfcm8fSrKRbzmd
35416	payment	2134	2134	1874	1	1	4143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVkWPXdkfauedpkugkmscuXpnBBitbyWUyQXYQUoSnL7hxL1A
35437	payment	2133	2133	1874	1	1	4113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVqc3kMtshCjWqCKt8voyhCMwmc5YQQyBmkZrHbH9cXoTngxx
35438	payment	2134	2134	1874	1	1	4150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7stykdiQuE2vHAHtoUwdFHVRuLDihwVM7eQKPNEdY9B42v59
35462	payment	1397	1397	1678	1	1	13716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1gEB5kiyMYrJrZ8SKJfwDW7qdmA85H6hX24NJJx2mvtPhcyW
35463	payment	2134	2134	1874	1	1	4158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCeZkuXYA4D2FfX6BJbiX7VF84YWyrjkw9zYPczRPH3A9KBFJ
35464	payment	2132	2132	1874	1	1	1192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyo7T9hVbhEqktqXwwj8vCPzzvqHpBtvZkpo73DFVNNWkBTXX
35465	payment	2133	2133	1874	1	1	4121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiE7NCcCR4k8qQQY2qaFmYZb2jZEmTSnjz6FDv5tErnQr7qUp
35489	payment	1397	1397	1678	1	1	13724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvt2s1mNdxpB1zs7tALBrHQ36kWuEEMPMr2kfZoSQAGhQm7XzG
35490	payment	2133	2133	1874	1	1	4129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdt7wXLQVvQaE5zEJdooL7mvDCXKkEeiZxmKwX9f41xVqvsoiZ
35491	payment	2134	2134	1874	1	1	4166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG9EVaYiLz5a5qtFpRptspGXvhU8sTB4QbscCcmHos6nh53VX
35514	payment	2133	2133	1874	1	1	4136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRyEEtdpFzByJn5M1cj6cWHsmVd2XJYsygsvxGkUPdAr5Vco4
35532	payment	1397	1397	1678	1	1	13737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9Z9YkADDLV3n8NLsL1vtDELeZ887bX2mjcHTB8JM1zjBtgS5
35533	payment	2134	2134	1874	1	1	4179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXCAkqJK7Vvh6eP7djWGvDMPUXZc7EF5zpWNG4xCr4eTtJkot
35534	payment	2133	2133	1874	1	1	4142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMh41sNBvzF6pRoR2XynYHDUxX6U9qEMd3ccWzrnoyQojqczd
35545	payment	1397	1397	1678	1	1	13741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjrsACvKJsioCn5YL841Su9ykaDnFxBqBdWKvszstoHVipNkB
35546	payment	2133	2133	1874	1	1	4146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVedK8tR8eHmk8xmYKrqeYE5bZTMAisgmgZY5u7eEzYE9cqbS
35547	payment	2134	2134	1874	1	1	4183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hF2z8RY1pUWiqLHBZRU3hnhq9bhBY4PAdpVNygUASDdQCtoL
35554	payment	1397	1397	1678	1	1	13744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSez6h8HXzfb8h4ttt3bPMzCb5aZs588SbMyGmwSVYeqJABxgn
35555	payment	2133	2133	1874	1	1	4149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZhDs6HXruHHqgDgYdrjKK9i6ZVpEuRbt5yQ5yPLwLrPHXC2Y
35556	payment	2134	2134	1874	1	1	4185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwatjDewcoYapsXYeMX3th6R68GypqhR14tMyJ334Hx59pwWU
35558	payment	1397	1397	1678	1	1	13745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2BJhGJ7FK6capvXoVVETF9TsqccHuXq7J85btq8VeRDQjo1z
35559	payment	2133	2133	1874	1	1	4150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ957r1V8MJUNehfuPoztwcpAz1BCUtFmLpC1Sh29Ad45tmiqXR
35567	payment	1397	1397	1678	1	1	13748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPJaeNnx8PiAAi1L49o7aNQSBgMy8XV5rhnVuu7sgbBTrhtE5
35568	payment	2133	2133	1874	1	1	4153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqUFWb8JHwN2Rosuj8vX9SHgFXCp1LPirFZ1m6DHrMLqzx1YP
35569	payment	2134	2134	1874	1	1	4189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCE3sEVFHXoVPyH6e3perA2iU5GXN3ajTeL6wLi8vB1sYddUPL
35570	payment	1397	1397	1678	1	1	13749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ491v67Hpfh1ovz9xzysKVc7qfWtQrCf1uTnbetYD1aBq96RB
35571	payment	2134	2134	1874	1	1	4190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYZCj7GR44sbYXggKC5tawtmsqPTnVYnUKaoLR5FYRcWpcuBL
35572	payment	2133	2133	1874	1	1	4154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjudfcwVyuWd3jumfuUD3wJq6Tu9joHUnTPmckMj3jtf9D2AK
35583	payment	1397	1397	1678	1	1	13753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshBsVLg4twgeQqXZA7xR4igFPZsdRPgTzZBjc1CisGERU2a1N
35421	payment	2133	2133	1874	1	1	4108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZffPiZD83FZuiys98rLAzz6tFt5agQz3fuY5KYHiD21TKabnx
35422	payment	2132	2132	1874	1	1	1188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzKjUNctY5k6jajaSTSdDHtB61k434ejMWeoXwRznQimFdgcj
35423	payment	2134	2134	1874	1	1	4145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAxR33k2rYUZXvvx9sk5JSogPDTpYJ1CckT6eiuY55m1Z6dvb
35456	payment	1397	1397	1678	1	1	13714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAhMW1dTR3JGTNMv89jVmDRiwUQSgNL5LJFFsEfhqfG1wK1Jk
35457	payment	1397	1397	1678	1	1	13715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2k7DWtHq9WqT6Bve2ZwGNRJi97G7aoob9ghD8ekv7L6qkAaU7
35458	payment	2134	2134	1874	1	1	4156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgp6DuTW4KPnNq1V8ZPgNUJ5QpKRwk2cgd3XdwS7PNrcfVjfeN
35459	payment	2134	2134	1874	1	1	4157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPHVFZd5YkjPm72nysv3anHFbkAmTDAEUBZXj3HtGgssXrY1n
35460	payment	2133	2133	1874	1	1	4119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivmoZFyH26A8fH1AyNkCh34Ljw5H1aXrMTWyBQ5U1sYVy8xFn
35461	payment	2133	2133	1874	1	1	4120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbz8QgWQNETYqW2anf8gAsCD7sSjUkyAJ8BSB1N23gybAP9w4c
35472	payment	1397	1397	1678	1	1	13719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppFHiSdJ6WgZbz1oTepcyTSg8w2sCRmWTmzUUHd3rKsbVAAHC
35473	payment	2133	2133	1874	1	1	4124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh4YuCo763ZQdtHCirgF4VajD6UpQF8YVic2yWwy5tDjN6ZuM
35474	payment	2134	2134	1874	1	1	4161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcW4RT7ncR4SjbjLCQ4grSTqDSDez1xpw1UC2bFVGontmwXbZ2
35484	payment	1397	1397	1678	1	1	13723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvzCGiKsxwVcZRmS5XyFiLnZ3FrLxceXcv2RDD5c63X6dcuHm
35485	payment	2133	2133	1874	1	1	4128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcMw1t8yDsPKxKvL3GfyGPkyMLGqjLNw7GnTiHiWRuEJF4k9S
35486	payment	2132	2132	1874	1	1	1194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomNQEixzN9ui8JcaQ7JJSPmYCRiYNQhyhgdWmnFFkujpYpuBG
35487	payment	2134	2134	1874	1	1	4164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaamesMUm7ctbpVm4kr5FaiZakBSwSY8vDDkuFV3am323bsyf
35488	payment	2134	2134	1874	1	1	4165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6z2zrm8iV31nJg6ZCDQXQD1yYvTP9j2JCAYTSWykd1txaU7M2
35495	payment	1397	1397	1678	1	1	13726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZxUi2PdpnJoNz3Gfx3Txhk6RbMoJ7fiiQ4VzL9Rmt7xpNs6o
35496	payment	2133	2133	1874	1	1	4131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4tf75QZrRDrwmhwpSg9xjPQXERzGDKseMit97955q9oYHyAX
35497	payment	2134	2134	1874	1	1	4168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBrGzCgDq3dzjv7KPkcpiYhYDphRvBoRGcnLSoGLoNxAhscMV
35498	payment	2132	2132	1874	1	1	1195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jFDWDhYBP8wdrNGDuMRVEFmxyKLcLKCP27yXR2ju8orEjioF
35512	payment	1397	1397	1678	1	1	13731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ39Ne39WLo7bx1mpjEExjnZ37URXc7qEkjZMDaz94xrFvFgDP
35513	payment	2134	2134	1874	1	1	4173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFnbUccwHnjbRnLoiGnRvp5eqx5R2GtUm4xSvszEFeo9f9FSj
35548	payment	1397	1397	1678	1	1	13742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkeWMGaCMLkx9HJit1mUuZXbRNAQEAmconWA9Z6NoLpPdQo2f
35549	payment	1397	1397	1678	1	1	13743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5cthGFmbo1oJzTBJaMkm9uLo9XseFCBkidndMKjEbuqyVHYA
35550	payment	2132	2132	1874	1	1	1200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBbtqJjizGf3kSsZiaiqwZTtPrGpit9o3rQDQZEPQVm3x7HiX
35551	payment	2133	2133	1874	1	1	4147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZug2xEXdFS6wXhahabWutKQVJ9hzQoEnu9aJQ3RWPNkVms32mU
35552	payment	2133	2133	1874	1	1	4148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q2aGHB9BzBprtckVWkDJvED3jrBt8SjaqbBHRoZKCHFxmuS3
35553	payment	2134	2134	1874	1	1	4184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AtoXESWyNgqiXvT8s4x5exAa7rRUFH1zkV9C5YLac8VebQwk
35564	payment	1397	1397	1678	1	1	13747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuTAsYxRGkTHuT1FPtYjcVyT8nXCwqerUw2FsM2tuS9dGecpQY
35565	payment	2134	2134	1874	1	1	4188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhHL2Ts9rzCARoAnqz3kmyzDp3Q9c5FAm5L7uoA5MeHMkghmF
35566	payment	2133	2133	1874	1	1	4152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQoU2G4RxTw3Pho7ZzPDLQEPVFp2SZprLmwSnt3JCca9rZnSE
35577	payment	1397	1397	1678	1	1	13751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61E96Sy79UifZaZbLUQq3DpjZdCAS2xZAD35RdmestFBstcQS
35578	payment	2134	2134	1874	1	1	4192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrFHy15AHLUENEXBvR9bXMa2Vko5rKhx75bPvkeJcMoAuFEvM
35579	payment	2133	2133	1874	1	1	4156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8DZN7pVV7Ge76mQR5RZLpwLfdN3rkJQj4EwtWVph7rUuFG6uW
35621	payment	1397	1397	1678	1	1	13764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11gyAWrTSHrhvW2hy3fazrcPqgGFkTgKzb6wxtNey947RjL5Y
35622	payment	2134	2134	1874	1	1	4205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog4JSKeM9VSAyHUWpgHn4nCdSRF7BzeY1cysCdKi2wCzxnL2d
35634	payment	2134	2134	1874	1	1	4207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbr2UEh57gs67z1URVBNB2FAc8WhcUNWUFVGpxfJEommjPiYWs
35442	payment	2134	2134	1874	1	1	4151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWtnBmdNpC7Eso8KudcihXnp4fvUfQu6myb9jF7aYkuk31uar
35443	payment	2132	2132	1874	1	1	1190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUgDWhjdaLtKd8xLKeDryNSLbcUekTmBKmB5ngX5j1WTFxkib
35444	payment	2134	2134	1874	1	1	4152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2jLK3jFBaByvHdu6RnesQYaBivC8UcUq8S9v7UbfnBJw6Q7H
35445	payment	2133	2133	1874	1	1	4115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6w6pusrxgevpFeFKeGiiGmTVWXW71xBEAjjb7gEcgA1wYW3u
35446	payment	1397	1397	1678	1	1	13711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuK836MAd9afv7Ho79Xmz7yAp5HAXgcmj9JGjCbiPjaWd9MJeH
35447	payment	2134	2134	1874	1	1	4153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxdqsXSyLgdixBG39inyTtWrrnocPB3oBTWc2sP3tpRAcFS6g
35448	payment	2133	2133	1874	1	1	4116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTx7413YD9FcbaisZBXyRGW7gfES81tJv8znWLhipWY5zdyPG
35466	payment	1397	1397	1678	1	1	13717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ePiB1y6wYjxS3VkcGZPCAP7fEQhTQuZQtu7p5Y4Rt81edbhu
35467	payment	1397	1397	1678	1	1	13718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrkZbYUHiNpDRKj6PvfKARPeLCZ59GmpS3LYwqpDKRJUg7MZq
35468	payment	2133	2133	1874	1	1	4122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6W6V9azeTbJmy9ihqhib3K96adxTSzmDFP4bmt4CYo8nMjXzJ
35469	payment	2133	2133	1874	1	1	4123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dg1YtC4wDh49uC5248RCPS2mknhKFYiEk9irjCa4gtZSqFRz
35470	payment	2134	2134	1874	1	1	4159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgnUAcCk88bEkpuD783Ywk7xezCdCxBXinxTbyFGtvm13vpUp
35471	payment	2134	2134	1874	1	1	4160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYHnCkwNRospBVNswG237CMt5baUvWXrkdX3TUZWNacxB9esn
35482	payment	1397	1397	1678	1	1	13722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe58pTa7Mv1G7ForzTQpY8SdRF5BHPf2CsaecthyrusVpeUkHZ
35483	payment	2133	2133	1874	1	1	4127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi5bBPDVsTN9psXpXMnSbCwxXt54eLjEAYHvRuEqGmS2o1BiP
35499	payment	1397	1397	1678	1	1	13727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5jsUwYFJYyg89ATKGz7QANwvpied5muFPTRVfC19xP79QG1E
35500	payment	2134	2134	1874	1	1	4169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4iiadGHUBr3josEWpMfvn6xBXmaQVhb91fS2SoKDjScTXc6s
35501	payment	2133	2133	1874	1	1	4132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSbGrDixndfdmUkWNTwgFXFf7AVGHRQKPBLoyPpUdonfK5PXx
35502	payment	1397	1397	1678	1	1	13728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8Q4tJLDdJPriWSXNgEoXqeH5LsvrhQGGoeDH3jTYXTs5MZ8Y
35503	payment	1397	1397	1678	1	1	13729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3sBFNkjaLGhnE9d74fdpWQ4kENeZn5BCqF4pByEpcYXhrh96
35504	payment	1397	1397	1678	1	1	13730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xvGZEDwL1Jefm4RWoVzpLGwvHoAvUGppfsvQSMyzBdcgGbKc
35505	payment	2134	2134	1874	1	1	4170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9rJnQ3YTRXrUUyGRnz2GVmQPoHXjPBCFgG2Gs94qkUxi6UQB
35506	payment	2132	2132	1874	1	1	1196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEx8mX4zQQThUSmgzk9v1Rnjw4iTFWreUEFbPMmBeHiFpG76Li
35507	payment	2134	2134	1874	1	1	4171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNDHoacUUjE6D65SVZjLRmrrZu2WQjFovixPaV9C9LCMDvP55
35508	payment	2134	2134	1874	1	1	4172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ37T62UPhwi1QijUx6kau6gxTx9Bh3wH4XosdHu3TvaBbMhxr
35509	payment	2133	2133	1874	1	1	4133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kL1fHWLYnqPc5rdoE3p6fmJquAay3oDb9AMYVr8HogKp91FT
35510	payment	2133	2133	1874	1	1	4134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGN5rH6eJ6KjUce6kbuo5XCxSSC5FgRSGZxx7D4s1VfTT9XL5u
35511	payment	2133	2133	1874	1	1	4135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqxWMkYhSvvK3n917pYwL1u77gEdQUrp8c6ytMnrRZZRqCYyL
35515	payment	1397	1397	1678	1	1	13732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33csXwf4YYcogSnUPhYQY7nb68BvbfDjqzsiEHbWJJHRW9x9s
35516	payment	1397	1397	1678	1	1	13733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3et9rb4rSzRN2jDiMVqG8mMYpqP5QmAkXHq9DprkX2GJYBgn
35517	payment	1397	1397	1678	1	1	13734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK91QukCg65onXdpxKGBjX6npAfdizxSchV95iefndgYP7utFH
35518	payment	1397	1397	1678	1	1	13735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRp5xBomYTsZWPVNXuu2ruFqmQCgbXmMhy8221fs7e6DZTqx1
35519	payment	2134	2134	1874	1	1	4174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvWkcktte2xRSjxUoSozq1MSGDxNoePVHEKUqMwmfq6o9hDyL
35520	payment	2134	2134	1874	1	1	4175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYunoFGfX25vDzBeQKPsp7aN7yyM3ed99CxTi23cbSsoYM8Vy5j
35521	payment	2134	2134	1874	1	1	4176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPZyUnWFnUxRvZN4iHqGYz2x6Yg9R8hCGXExP7yyU9oQkiWsa
35522	payment	2134	2134	1874	1	1	4177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81fN4a9NN4GtT9ckToHDjRsPsvUg8nr8KLDEPS91EHFLDJv2b
35523	payment	2132	2132	1874	1	1	1197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ADVA8KnFsDQGscBqK6WurRV7Ae18pL7Kp8SPpHv6khrckpzW
35524	payment	2133	2133	1874	1	1	4137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8c3B61hMzQEyaQb1qj49mzVFJKCBL6UTnb4czMdSiwEpF5AS
35455	payment	2133	2133	1874	1	1	4118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7riwjWYWDwDFDwZZnBNoHu1antxdKPQ9oCm6pMRLe5wHEdt33
35475	payment	1397	1397	1678	1	1	13720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpg1kwRSyZn6Jvj5DwXABPgqm5jrq7P6Wa2gwNGNotzPJGr5Yd
35476	payment	2134	2134	1874	1	1	4162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhqatmN7SjbwzW6eZvAycZ2jVVLSiPK7cSvdDm9iYz4RXCtFf
35477	payment	2132	2132	1874	1	1	1193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YgyJrefVx95N6YT6aqkCc9x4G5tuG3XKQDxRGrzBf5JyaKjo
35478	payment	2133	2133	1874	1	1	4125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa787wZLMTm9PkuDpv1YUdhRK2QivhnZj2qbrPk264xgrWkKVQP
35479	payment	1397	1397	1678	1	1	13721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUjyhDgsTuUR9y42sSuS5gELy8VA4LBWa6Zz9WJknkj5tjaNc
35480	payment	2134	2134	1874	1	1	4163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBt9w5wNBkRboahzLAtmxa12sFcKfMgsm4vLqzwpdG5PGdRDD
35481	payment	2133	2133	1874	1	1	4126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNQM9JGGfuhBqUnSUEkPaS9jgjMB9L2han4FyXiaoW7x6MqJG
35492	payment	1397	1397	1678	1	1	13725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnqeCWyJrXqTH8JgZgXSrxCc5bbqvKcxc7HLmrve3tsb9r1eo
35493	payment	2134	2134	1874	1	1	4167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSg4i7HnUTcPfWenJQc1AUCGhmnXakgN4KPvtvWK3dBq4URhEr
35494	payment	2133	2133	1874	1	1	4130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnCee5b9TEnr4E7Mnyw7RuNKEhdisMp4t1EioVvX4a3qLmHU7
35528	payment	1397	1397	1678	1	1	13736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfwZQpC1biatM7HJZiduKKPns55anEjnYqwWQiqrxJugWcG6j
35529	payment	2132	2132	1874	1	1	1198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHoSgFyisqKL9aTsnmEXJzqWkKARXCDLtSpyTdRKddFbWHw63
35530	payment	2134	2134	1874	1	1	4178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxr1PHDEnbVWNwaCqp5uLnHgQkb2yKrcDUwvzm8rJxgMHAoYv
35531	payment	2133	2133	1874	1	1	4141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbqikWR1uRM58FYxBAnkmNybGNuVDjaG3fZETRr1EsFvWR9tA
35538	payment	1397	1397	1678	1	1	13739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4duUFxrMb5MV1AGcptDN2764qd9cG62SK4UCvwtSZgc5swLR
35539	payment	1397	1397	1678	1	1	13740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJNnffbzLUFyhM3unA2FHsbk7FM2JkPK8vKW3ZPcURPVqG8Ai
35540	payment	2132	2132	1874	1	1	1199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu44SVCcVygrxQztGr1XKMCF1GKYDjdSWbJ8vgiyBMdK79xFia
35541	payment	2133	2133	1874	1	1	4144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ7qL6sPX974eecQExgX4KaLMNaKNPwQ5GpJpacCQjJVrYrtw
35542	payment	2133	2133	1874	1	1	4145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMU74zKe9cH13i5dMudFyngQt16cB8GGYJHfsMyHwwj3gkgsCt
35543	payment	2134	2134	1874	1	1	4181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeu3mkeXA1Krm2xMKXmJ6nSYCrChNieRrK26dmroNyz2PbG8eb
35544	payment	2134	2134	1874	1	1	4182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmRywGEuKKvujsCNfUEfvTBTJw6VLRMV6da4Xp4TjjtHuU99V
35557	payment	2134	2134	1874	1	1	4186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifHN9HbEQmYt27KJkm3QJXu9vKY9sotkhwKxTF3pHzWJSLe9C
35580	payment	1397	1397	1678	1	1	13752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKMFHDK5gTHFDH9mqDfLV7kcr8oT8j7BEW7enirrqGora7QDH
35581	payment	2133	2133	1874	1	1	4157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzw4ZiSs73XkUMigwpXyDxNZMrsHdaXgfuPzDvD9T3un62JvHq
35582	payment	2134	2134	1874	1	1	4193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGSfig9Hgx49itSgNuaC9RnHm1QBqzij1XDJXTN72edV93ALK
35587	payment	1397	1397	1678	1	1	13754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVt7atSxPicA1RFNHP34hVUb75A43HYAhvsZRT6iPYKzdSeCj
35588	payment	1397	1397	1678	1	1	13755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYoRowa88rc6GsyGrhbvUTjHr5hHdoT32K5sqjoHzfEiQEfRV
35589	payment	1397	1397	1678	1	1	13756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWZeReZ5pJnTGvc8tKBNNirmw2FYPki8vcA3Nm27Unrf1bXGx
35590	payment	2134	2134	1874	1	1	4195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFCS8jRd4x6GAZ2e5othR98qaDSYkpnyZXCMniDzsiMCSVEN4
35591	payment	2133	2133	1874	1	1	4159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoyFweVHswf1LZktfUjQSgDReAmQSZ7LSvCckscU6zCz75b2X
35592	payment	2133	2133	1874	1	1	4160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBGRsisHNvoNBf95DiuYku8RJxdjzMuMZpcP3eBNiL5JnSx6X
35593	payment	2132	2132	1874	1	1	1204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnv6XUioBRAr2Gvyz6UxLB4tZiViAfxaLL7PXrE4w8QQ3Uz5r
35594	payment	2133	2133	1874	1	1	4161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziFG425LegS8rpYsUB5AWgiY5TobPNsWPjjgUvPSJGeyZSKVR
35595	payment	2134	2134	1874	1	1	4196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rSJWGLTinSA7VWSyseJdgz58Aqa1hvk3aFyi5FadHYd532ye
35596	payment	2134	2134	1874	1	1	4197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ukwpeWvyFvMbHCfGEucqwRDXyJ4XYFuyVtMjryHQy6MKxmkc
35610	payment	1397	1397	1678	1	1	13761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2CyYtKoX9chf2KpzyEW4PHroYAwzGhfXTNWfaPZQkYCkxue7
35611	payment	2133	2133	1874	1	1	4165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMonk3XdGUC9mfEubQJZSXvt2K32hk3PhkhNYM4pwqC7r8DBg
35525	payment	2133	2133	1874	1	1	4138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3VJjfHB4Q8YxxHzZLXFLECGjoJ3iQLdRySCx8opQrbfqQ8fF
35526	payment	2133	2133	1874	1	1	4139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzxsuj5HUBkMhBiNCZzrmYM6p2JdrJSajWcNXRKrHgDzM7VYg
35527	payment	2133	2133	1874	1	1	4140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBS32gByTXLQuupiFtLxCSHdXCqwK3cM3xUsS8o5KeFKMdNEw
35535	payment	1397	1397	1678	1	1	13738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4B7MPEYvAAX8uyBA1itdZe9XmRAQPnfdNJrnF8sAwTG9VpaE
35536	payment	2134	2134	1874	1	1	4180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1aMarW8oT1gRHPwb6oTFLiTMNpm6RskHGWMSwgtaW4WFxcEw
35537	payment	2133	2133	1874	1	1	4143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7QEJduDDGqHJpL3V5QbjqYqd3s4MztvPJt2CeAhA2aXLty7e
35560	payment	1397	1397	1678	1	1	13746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVoGf86SQNczmpxNkycuTNNJSgM5zyUimTRn4zWXsqUHUpa5F
35561	payment	2132	2132	1874	1	1	1201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYfjfQGsQtV7Ec66LXiUmw6mWbUoht3btfzCwT3Cv9ktpdYsj
35562	payment	2133	2133	1874	1	1	4151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3LtLD6gzic8DHApadzLELqTDcQhwtw8uteUBZgFNun8zviHn
35563	payment	2134	2134	1874	1	1	4187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFiGH7KXreooYdoxoDHAjFLAdrUDToPYGtsnsETTmFBtyETk8
35573	payment	1397	1397	1678	1	1	13750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuM79YSrHQbP4SZZ59F9mVPiSoZK6keCo2Vsi1s2f3KFPrDDAn
35574	payment	2134	2134	1874	1	1	4191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaartFZnNdkwbioJjbT3pTAjc1dDqdi94o6ru3RSYHMNQs7VG2
35575	payment	2132	2132	1874	1	1	1202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh92aYHix3QauMuHHJy5dnXZSRAebjcxaNiENSkh5cNaMK99pQ
35576	payment	2133	2133	1874	1	1	4155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhfh97mCcZuT1xLfjfoD5SnU1ijFcdABNLsfKGHq9JcysphUy
35601	payment	1397	1397	1678	1	1	13758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqrYjWpYyHrJ26LYRNZmNP4AWfaxVxotdsMaMjhDY7oY98EU2
35602	payment	1397	1397	1678	1	1	13759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDy6oZnYbGVXBYfVzRP2zHymxh6ZTCk8BxoNQhiT6XZxdQftK
35603	payment	2133	2133	1874	1	1	4163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzjuezYWYhKFGUrcHecGDWM8mSnkQBxSxU7j97VdCTJCvpGuW
35604	payment	2134	2134	1874	1	1	4199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGwGX59ydcJTMJxZaSXR7rLvCHRLdMFngX8uJtM1Hkp6UzHzV
35605	payment	2133	2133	1874	1	1	4164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGMDBC2khpZhTnVVo2ZF6HzzQ626zcYkjJeXXraNjeWt5Urs2
35606	payment	2134	2134	1874	1	1	4200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4pN7NmQX225pbD8Kw6AY1yWmsDGAq1YN6EVJFXpqM1Ah15Eu
35620	payment	2133	2133	1874	1	1	4168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNQNC6R59zAV8FmUGRk82eaS9BBD8KoN9yx3AysEmYxcM2StP
35623	payment	1397	1397	1678	1	1	13765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiZ9wziFFuqyz4JFHdp9z4wtZwcGAqGFEXhWmDnoR8KhShBht
35624	payment	2133	2133	1874	1	1	4169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQjYqRKuoxyvnsTwXAx3MLXjvUaTzqyKyafL8siL3YbfBFRM7
35625	payment	2134	2134	1874	1	1	4206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZAH6FaawtfrLwyxJiNudjyrCohD1ewmS5bnN1gvJBJMGHAGs
35626	payment	1593	1593	1346	1	1	4	9818000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvTK7qi6cXu3nKNPrQxA1FBNq1aHTZQMwQVWpDKKx3xYHLAJF
35627	payment	1593	1593	1100	1	1	5	5222000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJeBJ82RK3Lgssh7kSjV1v2H266aC18ncJc3TFnEnXwVESgZM
35687	payment	1397	1397	1678	1	1	13784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjqiLgGzDyqzjZbr1BebN6EjJmAGn5zZRz65ofxv2UAhKkpg3
35688	payment	2134	2134	1874	1	1	4225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohxoXh2fKbgYB1zLgboTDCkNDNya1Qr1xWBpkGmbW5Efwp9Fr
35698	payment	1397	1397	1678	1	1	13789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RWRDjeeCWidUnMhtCzxdHV7xLmiGowARnYLgnFguHUKiUiqf
35699	payment	2134	2134	1874	1	1	4230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRp3bSYVtgHbf8F3QorreaPi8rG5DDfAssAWZ2nwJSGWMipgKX
35708	payment	2134	2134	1874	1	1	4233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjbS3uddhUd9xaepgci3umkb6kM5tEPHwL9YfMNMmuCCiz6MZ
35709	payment	2134	2134	1874	1	1	4234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxynm2JET5st3xo6s87YQQ9WyVRTrhNbqYukwcNLQesTanKGYr
35710	payment	1397	1397	1678	1	1	13794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqaKuMYSBcN45Lnnv4GFeFPgav6kgbY9Z5QNvfpmgDAAo2j7e
35711	payment	2134	2134	1874	1	1	4235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmxvqvJhxRGKrtNDL1brVu5iUbJWwdYmQG7V1EbqtYYteYKM3
35717	payment	1397	1397	1678	1	1	13798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX2Zn8uPhh61EvKnxNbCGb1rzajsSAVsrcxk7WrLPRTM6ZgHa
35718	payment	1397	1397	1678	1	1	13799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3DadjikyAu7ng1KzFgbmxsk31Bp96nRdWQ8fdjFo1cmdTsn1
35719	payment	1397	1397	1678	1	1	13800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2D2GCrUVeEzu4odMXzQxtRSWKfwVjCErSNz8g2Rns3gMby5h
35720	payment	2132	2132	1874	1	1	1217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgQBVd5BuuiU3rHCeTS5Y8LyWmZEkmpZL48SHaLymZB36HYR4
35584	payment	2134	2134	1874	1	1	4194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpJSFvkbSYVogskP9Y6Fz6GuKHhf697u4VvxZVsh5945TSKbo
35585	payment	2132	2132	1874	1	1	1203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4wbgkQmJicj6WGis4LpSgMGNDwz8kVntqATiQH9HY7vz8EdN
35586	payment	2133	2133	1874	1	1	4158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQh5rcpnUFb4VBmiW2mtj1FFksvyq3wwmRmGszD7Btp4ztC7XR
35597	payment	1397	1397	1678	1	1	13757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXDpQsvkW2MJV2JN6cbLijaf7L4me1yXCszfWyexv21AHFEv4
35598	payment	647	647	2113	1	1	2	209325788612	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLNnKdydudQopwbuRYUWmXRUWQoT1pmrv3if4hG99zQ24xVNS
35599	payment	2133	2133	1874	1	1	4162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrv6a3Y6853TgEp9a7Pg5vKCen949rLUPRJk2h9pQSpsUVp8X
35600	payment	2134	2134	1874	1	1	4198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKo8xvwoSDwmJ2f2msqTsRvA4M9y7GRwhULEujtBuaW7Q5Xpo7
35607	payment	1397	1397	1678	1	1	13760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRPnnYWvVLQYY8xVSzmHqkroa2QS3ToRqgHxG1fqYmzPrjiqA
35608	payment	2134	2134	1874	1	1	4201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5pCZkm7e5cKVZANosMST2VwGSuNXYhT3479P1t2Ga9E5SWR5
35609	payment	2132	2132	1874	1	1	1205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7prBEx2zUPgJ5Zm2LcLWaX3nTxwkqDndMe2hMnjisFT5NVbFz
35613	payment	1397	1397	1678	1	1	13762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ndkenEpq8rvpe9CqD64KJW13bmh1fvgunBvS9AC5EWThpnHy
35614	payment	1397	1397	1678	1	1	13763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaErugwx8UCGnJg4PPdTkwJwjs8dqNKAUbeX2Nm9UQpYyx81hQ
35615	payment	2132	2132	1874	1	1	1206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYMKJMyp48YMznTasRNvuNNp8wizDvPoEcYnim94Yk2yVnsVm
35616	payment	2134	2134	1874	1	1	4203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX59PCGHT5PjXBu9nxi9CuojcnNcZtetNBqe7yo515gE4UHnWe
35617	payment	2133	2133	1874	1	1	4166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Xd66Dj5sFHDRTYw9YLCoptQP1ZGnx7pVBtyNXamXS4EMEP7U
35618	payment	2133	2133	1874	1	1	4167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8ni9o1XsqwrU26XMbMg5gPNFVm9iFe9F6SeRzGJ1j4twCkVN
35619	payment	2134	2134	1874	1	1	4204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHA8AEN7cYMzBBvecxazZngibzngyCRwu38P7Mtd1uksTKmvkV
35660	payment	1397	1397	1678	1	1	13775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JxHUmH7CJmeMwfRFDYgC9BfXHcXa4ahAzykfV5MWxRTT2jzm
35661	payment	2134	2134	1874	1	1	4216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKMbWAcsEQGQ7T9tRFbfyq3UTZn5nzAKwzErhtDFPk3tnzFF2
35662	payment	2133	2133	1874	1	1	4179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCXsJgGNbSmTcKd8uQMDhuynusNXWPL2L3YQUQbZncxS5RdmB
35673	payment	1397	1397	1678	1	1	13779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcioaRbLcWdmxKkGYYKn8UUkR1MseWnQL9mpnmCZoKWgA6guo3
35674	payment	2134	2134	1874	1	1	4220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxkATaWETZvzzWo1PAk1hjFPHEgXmgc2nkwDFAmRrUU6BCb7k
35675	payment	2133	2133	1874	1	1	4183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiNwHRyVEVcaH8Ka87VBTG6pjy2BQJcRHhoQmhFgxC6cDzKJf
35682	payment	1397	1397	1678	1	1	13782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59KA6G5rumu7uk2FW9rxni411fT3aQqPCjFtBPHTtPMWKWavu
35683	payment	1397	1397	1678	1	1	13783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sok3uXbCJxRCLpLzoiskkTSunvkEA5kHGxS5tDiDvCPJSf7Y
35684	payment	2132	2132	1874	1	1	1212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jzUJLtqHyxftMZ2cvXQ9k7qqACVmcxSaQrGer4HhqpAxeGdT
35685	payment	2134	2134	1874	1	1	4223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64EEHpdd4q7XxTtWT8MMX8EvHTavDKqsKYfz5YxdZM4RpPjCb
35686	payment	2134	2134	1874	1	1	4224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfQfqaXEkDW25D28EFUwgFguU2M9VihZpf8PzhzAUsc1FicYj
35705	payment	1397	1397	1678	1	1	13792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXuVo2QRZqHY2TQm6xtv5mCvwyzrKNB3o3Crah5ra9jR47d86
35706	payment	1397	1397	1678	1	1	13793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4UuQ1J5SpPvSSWbKMbg8myKDVo6MUGbuJ6HgoX1R3nwQJCMD
35707	payment	2132	2132	1874	1	1	1215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE35L47YnTgXVVnBTW1H5Z7Q4K92XQJ4pvSgqyKu9CodFQSkf1
35735	payment	1397	1397	1678	1	1	13805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfd9Y1zgYLbZ8FpkULKPpK8kRigpn8tbrqhf8Ey75vPPxL1KF
35736	payment	2134	2134	1874	1	1	4246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfMYuMHkGDJV65bRiQVbwGK5v2nXAWXLez1qhn5uERYCPt3yQ
35740	payment	1397	1397	1678	1	1	13807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1Zip83pAz7MgJrUSL5Htt6oKT7R2LLDfmgHRBWKDiFnmUHRr
35741	payment	2134	2134	1874	1	1	4248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkvxPsiHGozns4Nw2bbzDYAjK5qGRH7WjpyU4yZV9XDoYM4wb
35742	payment	1397	1397	1678	1	1	13808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJQ2n81guD1986sC8AcB6ZEFCFRM87ZJZZBTeXU1FCjWBZPta
35743	payment	2134	2134	1874	1	1	4249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYxpgNyehN4mnkDuUh4BqucZR9ffN2p9Act45TWn7pgvjmxnf
35767	payment	394	394	1483	1	1	2	0	100000000	\N	E4ZRcRStMSwDV96GvvD6UyJUY6U1iADGpcAGSfnVEDdaezvrNR5fX	CkpaF2m2Y8GbbyLfkT6LoExLBqUWLLwYbaEukK7uRwEGX3pHfcgih
35612	payment	2134	2134	1874	1	1	4202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDR9xB2LmszcVHyENRNbWh44ja2Mb24ryaBN2NykSXp5LhYsG
35628	payment	1397	1397	1678	1	1	13766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZet7jUmfraLiK237WJL1vXdvTu4caPkGYrddkrwxcL8Dr3dxFw
35629	payment	1397	1397	1678	1	1	13767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PZuWsJERTSAeTtBNVHuLFh9j8JmcqGK35m3L7vAVcBs25MtB
35630	payment	2132	2132	1874	1	1	1207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1oLGHJze6MYaVj6Jy6PK7ebrNCYP9PPizVNs3rWVgpC3dh8W
35631	payment	1593	1593	1220	1	1	6	3524000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFHBAMseLJinUBdrnXk4TpUdj5ypfJALtALgD4GhDePa8vVMX
35632	payment	1593	1593	980	1	1	7	2914000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3sCefT28Rv4E5CcRKAm5RxJS32dJvLzpf4piFMykFNF97sxV
35633	payment	2133	2133	1874	1	1	4170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEAoy7Ch8JxeDm2MYXPrrVTvgpM4PKzvVhdiCC1cXbdvWS4eb
35637	payment	1397	1397	1678	1	1	13768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5SM6A856c9BTteaJNKcGYiDDFReecXGmZwcSCK1MhN1A4zPD
35638	payment	1397	1397	1678	1	1	13769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3KqjQiUaNakj7rFhaATQwhersvbUKKYRV1mH5th5PdiW2Vsa
35639	payment	2133	2133	1874	1	1	4172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8PStmVpASXNAofbvrqMLTPrVWWkKqsCCNrcnoH3sNKSY9PzD
35640	payment	2133	2133	1874	1	1	4173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYfFiJ4wpndGa2TTE2UXyeU4nD3AaGXoCgy5gsRKqDEyrh3Gq
35641	payment	2134	2134	1874	1	1	4209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjspLJ5Xh7r24znhy7Fki6ZCuHexhQ1dR4KLPh4GLa3siMbwUU
35642	payment	2134	2134	1874	1	1	4210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjrUq5xzEy3oohaxGB2f5o3aBnWRsUo7ooy8eKJuD7fw4b772
35650	payment	1397	1397	1678	1	1	13772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZututdKmmdpK9YQvgL2iTvvffK1VfXdskgJrcnkbcHtPVD7ukE
35651	payment	2134	2134	1874	1	1	4213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iEwsqwuPaXWj4tqHEythZRABQ6jbuUnMqn9x9KBY5Jz6VEDF
35652	payment	2133	2133	1874	1	1	4176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NdGR26iNxFts1hpwzttiNBAX3SC53fjHuypfuKhkbxtbszFY
35680	payment	1397	1397	1678	1	1	13781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDvBc79NHxA23mciHAc5fMAgZmZEmJy4H8vNyC58DvWi8MM7Q
35681	payment	2134	2134	1874	1	1	4222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyRDL8H8LoP5XZhoob9dGeT36jYVXebnnRDtRQcttBj49HjKg
35689	payment	1397	1397	1678	1	1	13785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7Yq4n8MU3TpBQAyX7T469AVuwxKNhcPvpc92vYV1Zn5PkFGg
35690	payment	1397	1397	1678	1	1	13786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkh6Mcy5RZtCoKGUTcYzrskoJ5nFDpDEYHduhwE4bwycLwk5RC
35691	payment	2132	2132	1874	1	1	1213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoS2YZ3dEPW9qqrNqPH7AfZ8NVSxxLJZJxxUTuBPThvPRWmFBH
35692	payment	2134	2134	1874	1	1	4226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKRiyAbDSwQhEder7WKc6mxhH3iFvBzyMcySXDPMH8QeW4LjN
35693	payment	2134	2134	1874	1	1	4227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTJVEmh4sqSLAbJ1XroMLrCgGwFXdRcaLrL5E7fMf4UBA9J27
35712	payment	1397	1397	1678	1	1	13795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjpQ9AyDrdx1mvAxV44iQ6oHWPJmf45ER3pDbLwCZfic7iFtt
35713	payment	2134	2134	1874	1	1	4236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAxru26gTDuxQh7f9i42MYxx1MB57tA832qnebFbcDaw4D6ta
35714	payment	1397	1397	1678	1	1	13796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMaHMLEaGghVmMCWiuEiF6Sas42HMFMVPqyFp4p37Wug69H5B
35715	payment	1397	1397	1678	1	1	13797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZwREAuJ92kW6FmqAPP4emePPr9uUNkhANvgZdfQNsdYxtCFW
35716	payment	2132	2132	1874	1	1	1216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbSaoE34E23CTDVZaaPcZwTiF2jQZqjpyFARqcRXrxji9CDc4
35721	payment	2134	2134	1874	1	1	4237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD2Trz4ZsyZ2EWGujMonE6LcNVixXzt9zNxb6NRAFoE9X5ntK
35722	payment	2134	2134	1874	1	1	4238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAhV9x1XGeFwaJc1HWqpNFEgYHvV9dvS5YCR22pdBgA7nAqju
35723	payment	2134	2134	1874	1	1	4239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmU1oEgtraReA9iTos3AESezkNnP7C2RTFae9bZhRYUqoU8e1
35724	payment	2134	2134	1874	1	1	4240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngBBzjes9yHvHd4shxzXS5CiCy5oFpEFWpWaCtbhTVSq3hsZh
35725	payment	2134	2134	1874	1	1	4241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbk7cWFw7bGyWGDnByvDd9opCQPsifJgBpMaCtb8K2QKixTWgE
35726	payment	1397	1397	1678	1	1	13801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4T7fi93rkjNTinXsLbWatJw6kkGaG7LKHaZt9b7merdXEeFor
35727	payment	2134	2134	1874	1	1	4242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6QLjjDUBBgxSsUZpbkZkbzmCgWV9VtVNxGQ2T4SRRCcGJARf
35728	payment	1397	1397	1678	1	1	13802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLdJyTA5WqvFPbS54RpUFGWE4ug2fAPoYLsECXyUh7RDq8T9K
35729	payment	1397	1397	1678	1	1	13803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A1rUBtHqGe6DhYEamXf3KoLLiN8YTu6VeBHsshnUjSCNa4G5
35730	payment	2132	2132	1874	1	1	1218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdo4CvJWpWNCo2FHGj1Vj6qHfNxGbFzQ9qSvXQZ3oYQZpEVbay
35635	payment	2133	2133	1874	1	1	4171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMpTNPaB6W3YCu16iGpRr1zXjUfMAGGNVyHNAyVnmXwgB7nMb
35636	payment	2134	2134	1874	1	1	4208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVpV7T2LgCTRmtDHwnpuZDxrWJNi9YT7evM3y8PfmSmK1Q3LA
35643	payment	1397	1397	1678	1	1	13770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFpuH1i4dvt96ACDvfAbEDbh4cvSteW4PoHdLEo9P3EEufAnn
35644	payment	1397	1397	1678	1	1	13771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bGiRyaJiugRvrRccDWar3C2EtBe2LUULD2bV6dYhAuDJQAh5
35645	payment	2132	2132	1874	1	1	1208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM38Pdsd8h3iUBZoGD29R3MZLPdjvA4AcnXSxnM4jugX6oU4Co
35646	payment	2133	2133	1874	1	1	4174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdNtoeabWMiYF6VKzveMMgoezCiUbit16mukZP3CHQJ1MFYUW
35647	payment	2133	2133	1874	1	1	4175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnkwyrbeQri2pQ9SFcsFp4VShUB5QEkCbwPTPtKZHgXkbQhHr
35648	payment	2134	2134	1874	1	1	4211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnVX1FD7HEVVp6ZEEfXU8RTuVpqKAHeSh4XNMXT2zV1wzjUwM
35649	payment	2134	2134	1874	1	1	4212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvot3bz2kXLS5kMkL4qCzYm7c7vUxMmSisK5KH4PPQM9zn1tX9
35653	payment	1397	1397	1678	1	1	13773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfQBb9LRY1XvSjXDgrWmBD6z3L2uc5RG55AvQ7mMJavGKHRrW
35654	payment	2134	2134	1874	1	1	4214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkNhrmut7WjFCfqmPe724hKYR9dii1DL4qp9SSexBSnfADgU5
35655	payment	2133	2133	1874	1	1	4177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTRXpSkri8gCoAQhARoSo4TViFG9FuGadVHp2C2H38VXbtPXi
35656	payment	2132	2132	1874	1	1	1209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4s6FFrY8kEkFuhA2CD3mrmRKbEsWPyv9Xej822yWGjHajkuU
35657	payment	1397	1397	1678	1	1	13774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Bq1i9P5865u7zcpSVrBEkkGCzj1G9aLM6TEv6v7ymM1Bcsar
35658	payment	2133	2133	1874	1	1	4178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARvio7EJZimXZLN2oCH18m79oo8jmMa79d9Uxe8smHyPHg8fR
35659	payment	2134	2134	1874	1	1	4215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCSf9aCsbS6c15xJqb1SJiduSQmkbisZYuVUk3Bc6wGuzBgtsV
35663	payment	1397	1397	1678	1	1	13776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa156DWGQVu8FDGiVwUz8LwLvoX3crzDWAJZFydNYP42QpeTCyo
35664	payment	1397	1397	1678	1	1	13777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXXj7qhT8aR6mskFhhgVK144qhJC6RWLTid9nAvw4WwrPWiao
35665	payment	1397	1397	1678	1	1	13778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgDymiuZxHD79ZzyRn7Msou8D1JLEWyEzv3RvrgaYFJ8uutmS
35666	payment	2132	2132	1874	1	1	1210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe1s89U7DJcAo9j2ULEWomYk3vPATmLAqq3GHLSuzgwbdDAhM
35667	payment	2133	2133	1874	1	1	4180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccbT5S9RpGE2iBZwfXi8VMG4hGe2bZLaWFa6ZXPY8St4iGJex
35668	payment	2133	2133	1874	1	1	4181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBQHGWxZpT6UyYf4K3N1Z8s4N9sCjFQqw38M9WFMQ6MPu2HCs
35669	payment	2134	2134	1874	1	1	4217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiVxoeZx3GLpRU8nwdo4YCufCvQ34pArCWtQ72D4WzQs59DAD
35670	payment	2133	2133	1874	1	1	4182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksQn9tacfHxXr7qKJTF5FEKwtjVLNpNEPTyVK6Q8pHeKSwAhy
35671	payment	2134	2134	1874	1	1	4218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCob1pgEumQPHEq6mmPMzYrDY55XReDq2mSMHj5ackxDRn7Gmm
35672	payment	2134	2134	1874	1	1	4219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PKUrmTBSgz6FLpn95oU5kcLot66d6qQ7He6x7rs2pagnRiq1
35676	payment	1397	1397	1678	1	1	13780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhVNfTNX53QP3Y1ZqV5UyUkfdeGLNeL8Xci4EFsf2JjWuSr14
35677	payment	2133	2133	1874	1	1	4184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqZ67BVmKThjvzLQQHcXppeKRNBJDDBQqL4sYCe9nsdLiGL1T
35678	payment	2134	2134	1874	1	1	4221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWWkgRDNoykbCe8UxDjjoVBe9mfL6vwfP2j1W76WBUePfPaMr
35679	payment	2132	2132	1874	1	1	1211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr5w8kHfqzUfciWawhj1W7BLf52JTDBoxpeUaZMo7upKTDopB
35694	payment	1397	1397	1678	1	1	13787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvipX8AG6rEjYxCxV78DkDD9oyPobkAteHgwEjXHG8PesewzVv
35695	payment	1397	1397	1678	1	1	13788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Q4nakxWtsCec8m9G1emSQHVZZ1ow6yvw7p3objVuWCRsGAaC
35696	payment	2134	2134	1874	1	1	4228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1NSvQwFLrPdob1xvbsWnjRvzNN3SRWPboM9MAG8ZhfhLSa9s
35697	payment	2134	2134	1874	1	1	4229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvDrf7r1bPSxZZL3XT3UZYwjtxQ17zcD3HdU4tFyLAseRu2A2
35700	payment	1397	1397	1678	1	1	13790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdzs2Mb82bhN1zRyfmfBDkoFvBw9Zk5dEbQm9FxjDoQrqK9Fw
35701	payment	2134	2134	1874	1	1	4231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwEyGhayrHVtMwdVBmsVuHy25GcV8ozt6EyyCQFLccQAYj162
35702	payment	2132	2132	1874	1	1	1214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqQk7eEhaa2MpNT7QZN7tf6rPF9ABerMcJCzEmVAD6aceD3ev
35703	payment	1397	1397	1678	1	1	13791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzqmucCqNRD63Q4SQ2QS8Q21Zw3zjBUrvxDQ9tgxonSVwkotj
35704	payment	2134	2134	1874	1	1	4232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4uFDTEXQaYJPz9Gft2SwUxXaxY5KCKQvB8pj78EUr6oNiw33
35744	payment	1397	1397	1678	1	1	13809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1n1L5WgfU7TRCutT33cqWfSy2Kira7PV5ppAh1GJ2E2SFmAe
35745	payment	2134	2134	1874	1	1	4250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkQuhSDX2yHV8VmvEviBfYTGHHrSAc8n41kMTXWjsunMbdVLX
35746	payment	1397	1397	1678	1	1	13810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHYf8KFS1VfASzQP5XwPLJAJi5LwAcvXb99c7i8H35qNb11E5
35747	payment	2132	2132	1874	1	1	1220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUPphkS9L28DRiHZHqMRdgQDTE1TUaBByG29edCipP5Coedrg
35748	payment	2134	2134	1874	1	1	4251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZwR6YFt6iAx8CL1nwBjmdVZcdtDQYkUai4K2Mfkw9baryxnH
35749	payment	1397	1397	1678	1	1	13811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTfykF9Bk1aRFgGg8Xauqf7qPTch6vM5qJGcLf5P6nPmcdZNQ
35750	payment	1397	1397	1678	1	1	13812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49RSu5fWK8u32ZruW2rakZv8LjNADpLcKhSZmg68V5yzTgn1H
35751	payment	2134	2134	1874	1	1	4252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYE83TQjYyH5vvAvrqZdQU9udgwHfw5kKHKLxWKkBNQwWgCk5
35752	payment	2134	2134	1874	1	1	4253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUHRAsDXesSjadNNgf1tN35s1fLWMXxHKN1YkA7xVRHkNycmn
35753	payment	1397	1397	1678	1	1	13813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUAmyhkceF9imnNmuFa49ZMfP1GjoJTdWKxDb8dmWHF83qnpv
35754	payment	2134	2134	1874	1	1	4254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr5PTKmYnXeNWCTv82QGBZTVtKBZM5F1aP4DZVdoGSnzFD8e9
35757	payment	1397	1397	1678	1	1	13815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSfVCK6bPTJKBDKo1HXPWD8vHbmDZUPLokCffaKu6P7UArtrm
35758	payment	394	394	2308	1	1	1	45000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZod6RjzCo2yt3A5hssyfFzqgDak7sK9kg6gA9XaqKhpk4Nqcq7
35759	payment	2134	2134	1874	1	1	4256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61LsG6vGSi6eswNP8SGPSazg7QWWSsZRm93Vw8YvWGY2jz9mq
35762	payment	1397	1397	1678	1	1	13817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVU6DspV1WnWTFrEnYaGQVxcXPcoVRhoaH4NLzZwF9goYMHc7e
35763	payment	2134	2134	1874	1	1	4258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSxE4B24jhki43FaJAQheVwcroVysGPwKef82XknBEJugAgfa
35764	delegation	2308	2308	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpaj5YJ2h8jeV1mkcKm3f3KRXqNSq7uPjGp3fywuuv5MkQetd
35765	payment	1397	1397	1678	1	1	13818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W4wrAQ7uoqtATPYF3uZEtCAykZDJMLub6SBmxTkrPc3qZYCt
35766	payment	2134	2134	1874	1	1	4259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpexiXzXfKP7otLF4xPQRwsR1DdULTXZyVYsLuU352cvQPv3rK
35772	payment	1397	1397	1678	1	1	13821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHiFHBnMYHsnL8D6T647LwYcQe7sdrVhLsAckBJGEWHs7jbTk
35773	payment	2134	2134	1874	1	1	4262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2qwPXsuhUoCpEKcjYSUaMAHjdJnKAHYAkMeuEExmCu3CsYN3
35783	payment	1397	1397	1678	1	1	13826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNcfLJC5WFYY4wrz4KFApgmtxidhsuJEA4xDNjdvrFDNiiJZW
35784	payment	2134	2134	1874	1	1	4268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQXRGqeUv5TayMyGFyWV3GWRdRcGGjCZpU1FqYzuM5Mt1YGva
35795	payment	1397	1397	1678	1	1	13832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12EVd78HNp6z4dzAKQwx734w5Fd7u2A4ZbZjuxV95MvdPUygs
35796	payment	2134	2134	1874	1	1	4274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimokeXGMEfmGynWooS2qK6ge8fXAD2SG4tk7g9m9W3NnT6Xrv
35797	payment	1397	1397	1678	1	1	13833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M1YbpBdgLSy9tJ529Kzz6PwLFNHvExc5qe4YqFEmASCgQ8fK
35798	payment	2134	2134	1874	1	1	4275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaJCmPXHk1N1wPQ64dAHsLW6Y7ivs1555U6bDQPvXM5Ea4LB9
35803	payment	1397	1397	1678	1	1	13836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UXPLiqVatrbJNSiAFi9wj77WvVLDM7EdEUuDBYHAtdPWFxD9
35804	payment	2134	2134	1874	1	1	4278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiXL79mm1gfBUnotPek5amwMi6HzvUEJrbb7cd8xAdnVnLP5b
35805	payment	1397	1397	1678	1	1	13837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudp4Dcka4rYG2vhCjwXPpBY61Dk7DiWSEFpeV9puZTbbi7Now
35806	payment	112	112	1821	1	1	7	88300000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJcdXriMEFBrnrSiZADK4f8eeimbPxvLaG9p4ZunJzpkm4iun
35807	payment	2134	2134	1874	1	1	4279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZG4aLmHEgbvn9gLcZ1X6FFevyKGuaFd1ymYmj2taoiv5MgBwc
35818	payment	1397	1397	1678	1	1	13843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHjWzBNpYg8cGZnuG7Dd5ppA6bYu3cmCUaRYo7Fdv3LVik4kU
35819	payment	2134	2134	1874	1	1	4285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQNLzgY3dcKtr8HGvp9UwABwqancD84ofKsdyLSVodVFsAhGx
35837	payment	1397	1397	1678	1	1	13853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5eG68EpKgLHsN5kvEyX5Moa5BCVjjTuNTdiPvxD5KV58inxS
35838	payment	2134	2134	1874	1	1	4294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX6T5qW9bcaEwvYAyv8mSNLzPwS5GuSQ8vcbrjUmpGyTBatQo
35859	payment	1397	1397	1678	1	1	13864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo1YJHtYiVLNdKFQEBCba7dY2qU6e1NfXLh5m9AsvFjNdTXpa
35731	payment	2134	2134	1874	1	1	4243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mqb8gYgyFc5JbkBD6QFFuuTrbZJy9xXi6Ki5sp7TAv9uMUnq
35732	payment	2134	2134	1874	1	1	4244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD49DLUzkf1xKYSw8qC7rXGWNoSh7pVUGe5YNFRK6v24EU6TVZ
35733	payment	1397	1397	1678	1	1	13804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHp9tgH9CE71o3SGErEn9geFy1ekaURHYmKU96VeuMiF5fBKkj
35734	payment	2134	2134	1874	1	1	4245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBh3d4X4tmPi7KH7BcTZ7KSx3RUrXKLQf6wfRBVZeYpJrJGun
35737	payment	1397	1397	1678	1	1	13806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7845jWKaPpd6RCmMKC1CN4zJN9ojCqFrBsJfWat7BBGQsBXc
35738	payment	2132	2132	1874	1	1	1219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPw9HsKdbkHRCDa832zVtUhqqRxAVnW4WLb7mVMaW1QgfqJqv
35739	payment	2134	2134	1874	1	1	4247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuC19PoiCGEpZXMmfYiYXZuZuJJp4VBtYyGtEUqjiS8afa3nz
35755	payment	1397	1397	1678	1	1	13814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYup1ZNyBVUikPNL19mMq22MpH3X2Q6WpKJKs7YEWepdM9rfZ1A
35756	payment	2134	2134	1874	1	1	4255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDgFiNFuwKn9CzTMJm3ZUwm8z6pmcPmP87hi1kMvpW9SCnhQd
35760	payment	1397	1397	1678	1	1	13816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx9W11EUx74HH94ni9pWVzuUjd1QWHwaKPcpgSsiW6ZZyHAYU
35761	payment	2134	2134	1874	1	1	4257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHffrdADzRdpZYHftkULkPxB5j66Sn15oB48CS4sEPo5HhJ2n
35774	payment	1397	1397	1678	1	1	13822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTLPsrDovL98w38QGaawNmy9mpzTy6qpzMgzU2Epp15KqgMPi
35775	payment	2134	2134	1874	1	1	4263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPcT23gc326M4ZPG1v8EHVE4EuXSNenQMDazs5HFY25QF3UnY
35779	payment	1397	1397	1678	1	1	13824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMije2EtNTU5XiVtTuKQxdApD7ECQ99dninEEBqhSh5aUoa7r
35780	payment	2134	2134	1874	1	1	4266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1U1pzTeNhSUEj7eUs7vcDuKJoabxqEYJs4ZtKkRXcnmmAkwgV
35785	payment	1397	1397	1678	1	1	13827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE7d4kH9XNhJ79r4hyXXiY33uxnYmwJJDsKEzZnjd1ZZPksUS
35786	payment	2134	2134	1874	1	1	4269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAAmBakruoeR2Z4WmtvRUNqsckNaEBFCctvMS5aFjJ5SxJpS9
35791	payment	1397	1397	1678	1	1	13830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiNZjryqCj7JJZa13bFgtfjQXHJDJvX14SJGVBq5CQ4QaHYKa
35792	payment	2134	2134	1874	1	1	4272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpswVbV7Btfag1rytqkNv4uYSUYn5CyxAri1WtafYS9rSeLBt
35793	payment	1397	1397	1678	1	1	13831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggKbrjB7ihPro45nt8WnktoTg3HdRLjrDTKWJJxfpUV1tt3zh
35794	payment	2134	2134	1874	1	1	4273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAkRZjZpmJpk4398KPuMxYqmWLsTB1yvSRoZw1KudQodqz3Yz
35799	payment	1397	1397	1678	1	1	13834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KcUSsqVKd1EGp7vjXqscF24Rb9Eqpe99xaxLkZ9pZNa1rqRo
35800	payment	2134	2134	1874	1	1	4276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrKTd5MxiSgTdNM7qrBQSxWJ7g4DP8LhPAjZ42FtRYNTaLrtQ
35810	payment	1397	1397	1678	1	1	13839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hJtTQRCz8Qkp49yQaWAuPmbBhmYrPEaP4uT23kLL3t6D4ihP
35811	payment	2134	2134	1874	1	1	4281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpj8r6R9DqgiGnvgRqQYYy9B8BbLq4Ztm9bPgsCBfBJjVbLcH
35827	payment	1397	1397	1678	1	1	13848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qNwsuExuqjuCfo4BuQdTJrc7JzqmtMyoW3jr8Sw7ik7zcy7E
35828	payment	2134	2134	1874	1	1	4289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPj1HLHYcutoKP7RUHSfpBSjFtgxoiUEBurgB9tDpSJnT8qwQ
35839	payment	1397	1397	1678	1	1	13854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBCkhJQMN9KjVoGuRD4WErCDoHMu7qnWLkSAyDCtxzr4UfKDR
35840	payment	2134	2134	1874	1	1	4295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34uRuqsbFGoEqQZUpaBXzk2hAiLNf357SgQ4to8WZ4GwMqLc5
35865	payment	1397	1397	1678	1	1	13867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwtriNr1QpLdQPPXQAu6bYacij1ste2bx38dM6SpAtTQe9TWY
35866	payment	2134	2134	1874	1	1	4308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMvmc7CfCUdUVLNuCGHaAnhP9hh3zDf33ySnVo9U6H9Ds7xoR
35867	payment	1397	1397	1678	1	1	13868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3LE5T7w5PkiQMZjNFXy4xViYM4bBZc6fuXUSfXK2uMjfdCyf
35868	payment	1397	1397	1678	1	1	13869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zA1bgyp3MY3SiCRQSrWreHMya9ousMsfLx6B8U3Uyukbut9J
35869	payment	2134	2134	1874	1	1	4309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6tSAzBh6izvR6NNNx5ge37KAcQ5kRSSqQmWEZaErCCVBrjM5
35870	payment	2134	2134	1874	1	1	4310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwvRZ7CaUkUzQcDEdu8VRocPyVGiQChW7v3oiS1XDb1df5kzt
35879	payment	1397	1397	1678	1	1	13874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6JEXEzVkK9e4H3CwymfkDkCiQHZcxarBRP1HboGkHzvuhNot
35880	payment	1397	1397	1678	1	1	13875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGde7PEHwHZdXh1bAo7gSRaBBbhC1yxfWEy5ixeGaBx1PZ3vCw
35881	payment	2134	2134	1874	1	1	4315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGMiKLQk4LATtv8pgFgxQ1UVdK4M32nUazaxLvEEfJq3gArig
35768	payment	1397	1397	1678	1	1	13819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkcFZ4tChogWABuaG7973yiXRqTqUr3eEp5Z78KMznUJmrq6Y
35769	payment	1397	1397	1678	1	1	13820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMR7KruSmGWSPUQS3or4segzigZjE6R8x4DpSACPc19oLEjQE
35770	payment	2134	2134	1874	1	1	4260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZGY2bWQ78DapgLEgUe6NMt6frGTHuoneYEN1bnWeV8GrhAqv
35771	payment	2134	2134	1874	1	1	4261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6H7TxLdWpVogcXNnbs2nZEmd1kkaSLLX4S1ZjwAr9wXgW8TvL
35776	payment	2134	2134	1874	1	1	4264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY72pCNhnhLM8oyZtAt3fD4ZZfrEC31QC3WiTKt3sqjbcsnM1j
35777	payment	1397	1397	1678	1	1	13823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHM8cxtN6a1LvuJzAux5CK6b5i8dqdpLjJ9L4pSEPncNhVRRE
35778	payment	2134	2134	1874	1	1	4265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGPSNqQgBeofXhR9sZPbsJh56m7tDyhdvzTnqUkXdvve1boZv
35801	payment	1397	1397	1678	1	1	13835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1SsGuKjZNyzddYc1enS66RsPNAnY8V5nFhNQHURE3qfuXhvz
35802	payment	2134	2134	1874	1	1	4277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqnLpeCi1ikBZ6hZ1aYcJwvX7WdR6zLMh9DNrjQ6PL3qBt3oB
35812	payment	1397	1397	1678	1	1	13840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnniG5sjU2MyQXa8UjmyGtPMvBjjLR9vYuFSUgbAjvgiWworw
35813	payment	1397	1397	1678	1	1	13841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMhCs1w67zF94nMPv6cCP2i5rxB577MYT67yU6GoWMNUudBps
35814	payment	1397	1397	1678	1	1	13842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijpwY25mZ63y68EsgqU2i6ecbJEY88cgxTNmLCijjyVDSpvc3
35815	payment	2134	2134	1874	1	1	4282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQkSzvCq74sEJmQPCmeokoLjY2QzZx6XgABjw9VM4fCibxYiV
35816	payment	2134	2134	1874	1	1	4283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCavHcie5dSUoKoWcR5BHuj5fX7ceKj7wM32XxesvPBEWd8Bht
35817	payment	2134	2134	1874	1	1	4284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfM44bQiroWP3xxJZtNDaxxXX3TPTxqT2c58M5TaC3mLcdXe89
35824	payment	1397	1397	1678	1	1	13846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxSZg6rQ5qDqC3VfgB5ndn539d1BtKRNJNXjMbmKzD4WLCyw7
35825	payment	1397	1397	1678	1	1	13847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUuzMicftfB8KaqR6knMTgpnMoKpHvLSVBeRWvCawKvf9HM414
35826	payment	2134	2134	1874	1	1	4288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnY2FiNpjYc9Cfj7KgFDCQceEH2s4KFwEjTtSWQRtwi2fZv4rH
35831	payment	1397	1397	1678	1	1	13850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsr61hpCNFb1ymJ4cW9LkmmLjbthjyh7kTReJ3ds5qn4iEvuJ7
35832	payment	1397	1397	1678	1	1	13851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArkbvm2DwwqMJoemh2S1xHFFDTaJEvicmmzyBHhYSB5NKuSjw
35833	payment	1397	1397	1678	1	1	13852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXVKtFgHTedDMDaed6VQ2Ra1c6JFjpqyVfnPXHJ8i4kWifg4T
35834	payment	2134	2134	1874	1	1	4291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtqsKaVFGZ7k9afdspr3yWst3jfn4mFCUVUaJFLtwq5XZk9yN
35835	payment	2134	2134	1874	1	1	4292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVKjSH7XKXT96WpzokjeihB21FQQmJBMputWeFQQGCA5fPmZc
35836	payment	2134	2134	1874	1	1	4293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALWKs8aQk2MN4NXvy6YYsi7g2KisiN9saeyQuod53j5DjsNen
35841	payment	1397	1397	1678	1	1	13855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmn8XFfSKBwP7Rf8PBtDC7EDeRcF6Lg9RQS8zWW6Yq2umHD8wp
35842	payment	1397	1397	1678	1	1	13856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxCAskxLEFhwQKeBbkETjP3T9JH74XMZeKekZ5q3L1YEVH1wC
35843	payment	2134	2134	1874	1	1	4296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjwRp3qx95TsRYkTHNfqR6LFY8YYh5ZqFjEBUzx6uUNsVhrWT
35844	payment	2134	2134	1874	1	1	4297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8cbBJPvfbxJPhUzLRd8R1ZXqs6PzhPAufbeiCvXq111VsZzb
35845	payment	1397	1397	1678	1	1	13857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpUh5zLMRqEM9izh4jxd3b3PDX64MJXf565qQ3d6eCSfiWaw3
35846	payment	2134	2134	1874	1	1	4298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGvQTjWTLFAeCdjmPpTAEZc85h6mY9KELRFkpDutTj1Ew2T8w
35847	payment	1397	1397	1678	1	1	13858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rhij8r5hHFz5w8bQ4yppw8JHZBzDjibFpxm5Bn3dHnzgc2Jr
35848	payment	1397	1397	1678	1	1	13859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75qMUvWgR6p5d58oNnf3XmsBBSWJz5GPonCC51xCvJ9F3MXH1
35849	payment	2134	2134	1874	1	1	4299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XjHDKYWpUGzKLhXXW1q59MpRqfWtFtwXWCY14CqegFMZxfoi
35850	payment	2134	2134	1874	1	1	4300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHBDtoZKDRPtZzfSACXM2PW5kYPLjEVz3DrsKJv7LqWTp9BnC
35853	payment	1397	1397	1678	1	1	13861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6GTNNFhVJs1Hm8REEyRHXjMwRajjfDuruohPQvH2bD2sqThy
35854	payment	1397	1397	1678	1	1	13862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfDaL2Kht24NbM8j8yXxWnBa98gq7mRSEFK96FhPQLE5aL1e1
35855	payment	2134	2134	1874	1	1	4302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR5p58ukvbWRbzdpeAZz6kkby7EJGnoZjX2vkTXMv1t8R1R6u
35856	payment	2134	2134	1874	1	1	4303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHamxGF3cuw8XahFCazg6Kxz6CpXpHhV2raUTJUBGh77Lwmanm
35781	payment	1397	1397	1678	1	1	13825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiE66RV5NT92pheGnoZRSYzu7Xtt5ZiJdZWnbCRzVtDviPeh6L
35782	payment	2134	2134	1874	1	1	4267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncB8WGJmR39w9Jj6PbR6z32yfmRYp3jSgBEpkg8bMWK5wDE7a
35787	payment	1397	1397	1678	1	1	13828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAs4U5JzPf9c4fjTA1xjnWkQDvruDWsng6E8xkCw1cLH6bezco
35788	payment	1397	1397	1678	1	1	13829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94QQfum7S2tp9SAbKfpNtkMyYZ4LaevVbb1xjWLQhc8uRQ9FQ
35789	payment	2134	2134	1874	1	1	4270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7j5RqnFasATupHi628RNeVXhy5FvLx53RNpgswXDmM19h9ta5
35790	payment	2134	2134	1874	1	1	4271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kDhSF7KTgJK7VKExqL5sT9h1S7RmYRtfkafikZJMNEFzgzwo
35808	payment	1397	1397	1678	1	1	13838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVtm3okrbuLs6UFwimUisi8op8pJ3LcR47MGLnBFrfZUDrpdX
35809	payment	2134	2134	1874	1	1	4280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3inxdHPEw7fPN3JDxqga7r9kP4H58U5FpXAkEvcnF4dgsDf7t
35820	payment	1397	1397	1678	1	1	13844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBokHp5UVRe5zTiJgj6ASSJyWLt9nn7EHyo7DAquN6zsqw5U9
35821	payment	1397	1397	1678	1	1	13845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ5ebMamBK9TtsWAXU7om18DroWQRvYwDLK9sZB5w7TBonNb5
35822	payment	2134	2134	1874	1	1	4286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4BKCP2QwNWumwqhJMiTGbT753thbewtMwWUi5Hqjase33aNB
35823	payment	2134	2134	1874	1	1	4287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4YU7636P8KuGN57Yg1WyzuFgh3LEC6ZtSkpVEZRDts2bXsBN
35829	payment	1397	1397	1678	1	1	13849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdmi2AtvP84TgCDApzZt1xYApnkJJtEKpshWpUdiJz1uK5QT6
35830	payment	2134	2134	1874	1	1	4290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ggVY9CojWqvPdYaDCQgQrKhixQDQn7zkMEmqqG9qsWJiXCvN
35851	payment	1397	1397	1678	1	1	13860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxs7aCzPM7hHF221HcjoaTCkmrhFaxHowEtgY2NRE2C2cPVLb
35852	payment	2134	2134	1874	1	1	4301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSXNskDRka1S1ZScupYyZsyRL3TfwVF78y5zqN91oRUmesaYa
35863	payment	1397	1397	1678	1	1	13866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWw1bjHQBFfYPhmXCfbrzzcWx5N5jKgoNpdaFzd9wL4E76V8Q
35864	payment	2134	2134	1874	1	1	4307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCymca8DThLCzLLs6xkjS8HCjPKLu32sKXepxTUjaxpYsfL8R8
35871	payment	1397	1397	1678	1	1	13870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnw3VBv4gJBBk1fHHwuDPot53QbzgDc6FUetgizX8AfmNw6qo
35872	payment	2134	2134	1874	1	1	4311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCxQiVrnDLuKzEHmxYqwMu9BXBYLuSDMHuP4EtSMHv3P1TrmQ
35893	payment	1397	1397	1678	1	1	13881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi74SAyCBMphF4m4ri9JSFETjSAwqPZQh14xpp3zpdH9PkVj23
35894	payment	2134	2134	1874	1	1	4322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AieMoSzNpGgTXhnkc86N1xF1MHcrwb9VXuLrEhD2MxhjokXH
35929	payment	1397	1397	1678	1	1	13898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjHrHCYGtig2p1g9LmyrzUgC2LZotsKgBR5eRU1AiKFNRP2Pm
35930	payment	1397	1397	1678	1	1	13899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNoxRjNuiU84HARHES7NboGB5n2RTLykBr4wqoy75hxhPvpuop
35931	payment	2134	2134	1874	1	1	4340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQndmq9fc9iMg6zmfPZGmkyLzuihpbT25ZJQnhX1B4z7oh6gh
35932	payment	2134	2134	1874	1	1	4341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMRV1YUFGXKx2NXytHnJSKs86msPYvKAwG7PJ8CAostzvUSnP
35933	payment	1397	1397	1678	1	1	13900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5pBaRGjXkH5HGXCiZ7qLBwHzHTg4eAhmtDup5B8v8Nm2LuC5
35934	payment	2134	2134	1874	1	1	4342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sCDCHhf4j836VCtUUSq8wtuBcKCBdqPKRaXHuEX71ZssA7bQ
35939	payment	1397	1397	1678	1	1	13903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTaGcHoWxBjo9XXziGjRUUb2aAZtpMnAKVuZe9up3X6RivHb1
35940	payment	2134	2134	1874	1	1	4345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MzrbuWHa6Dksasu9eYQFxXqiegXtC1JVpJnrc5L1EDYfeCvJ
35941	payment	1397	1397	1678	1	1	13904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbRDrs2egyZoD9btp12WtuTDQSD3t22LhSvQjnsh3pwNZHUgL
35942	payment	2134	2134	1874	1	1	4346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcR64NyMWS6JTtaL5HQ9cE7dReDytQ2AjnbAKUQt3H5CNVjVu8
35965	payment	1397	1397	1678	1	1	13916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHKWj1M5xSEv76pvwLPve48X3C3668ia3EXYyQQ3aSLF1WsWN
35966	payment	2134	2134	1874	1	1	4358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fG4L6ELfwZaBCrXq7CPnSiKRKZNuaqd4cvRiSPzwCLztLXca
35973	payment	1397	1397	1678	1	1	13920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhNV2efKuFfczZVqu1t6t4bAg1cnDWa4neKJf3t1kqKcKAw78
35974	payment	1397	1397	1678	1	1	13921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3beusNimSN4h8ABvCxegyJhMNAVR6N74T9HFunW14pQp74AZ
35975	payment	1397	1397	1678	1	1	13922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8sHL2uyBFXavAPu3tf17AdPVeMXTr3rMe2m43Sb8fTKZniJU
35976	payment	1397	1397	1678	1	1	13923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzKGw2QP7xCtaQ1x2hDpaqwNbKKZ5oFJHMK4RKs12WcnGEtSx
35857	payment	1397	1397	1678	1	1	13863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR54gVeN6C3CiK1nSnww4hPR7MFYczZxJVpxsooSCydF2L889
35858	payment	2134	2134	1874	1	1	4304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1gJb65DhaxycarYxZ5LqbAp18TTNmiDETjkkpSCphmreVRvx
35873	payment	1397	1397	1678	1	1	13871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV9uk21goTMfyvr81nqZffPFnT3ZEwNh7qD8MsjvhapadPMth
35883	payment	1397	1397	1678	1	1	13876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenJxjwJHaUw56GhRN8p8VLoxF32rxh6ws8o68PsBrReTxhS7m
35884	payment	1397	1397	1678	1	1	13877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx2XBtruwaaCCWneBan7LjbT2a77ZVGbLhJArwngBVSQxyi37
35885	payment	2134	2134	1874	1	1	4317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpVk8CdjFQk7TcqrgYEfhLmRCK5MerZFgrJ4JFenwJNfRHwFZ
35886	payment	2134	2134	1874	1	1	4318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WxwdbXQsNYkvQQGjgLo9j2RoNF8aRHeYiKRWB4xd732BxFuE
35901	payment	1397	1397	1678	1	1	13885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGt8J7zwVQHHvE2789oTsRVU7SMFyNpFCoCK8rBsZ1eg2w8KS
35902	payment	2134	2134	1874	1	1	4326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhagUktsA3TBn1o6yGTM2S3kyY4rK58pEC4d6ezFdy9iije8xh
35907	payment	1397	1397	1678	1	1	13888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zC9qQvzHB3j1LvaFmPcxfx86aochfSzxFMjJUQNBc7g3Y9bt
35908	payment	2134	2134	1874	1	1	4329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvs1BJy5j2He1HoLfoWT2V7PGtddfZmemFxphUTkvBQvR3NTFi
35909	payment	1397	1397	1678	1	1	13889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYA4mmkkN2np2S19tYPsnyZ9iYKozK3Cz5EWaq3Kuk2Fesjnya
35910	payment	1397	1397	1678	1	1	13890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnpQiXKXa9Qjdh9tDirEhLfcBTfaG2PtPo73E2DrAEpRWx5zf
35911	payment	2134	2134	1874	1	1	4330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1KaP66ejQpNgLPEpfrqH2mtYMS8LHUXFmifH9h9bZdbghsFs
35912	payment	2134	2134	1874	1	1	4331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoXJH4n3TAAV362xw2SXRTtdH6VRBdpTg3ajcAWC6WvdirauX
35920	payment	2134	2134	1874	1	1	4335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwTqm6UQpfnKkbSdhjpZ3MNwtecNwPQ3NKeMGZiKujeR4RbaK
35935	payment	1397	1397	1678	1	1	13901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDHtFCTuhZTzH2z5uhZ6zQh2gxicY2js5GnKTseJ6TygueJG3
35943	payment	1397	1397	1678	1	1	13905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYiH5QpeRzgpye7dXgpwpNuaSt9LAX1U4tuneKdcZZBGCR6mdG
35944	payment	1397	1397	1678	1	1	13906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1xkKkKY77rYf2vdwYkP5FF5dXAcJnjGpZDkB4QhKziXJ3w7X
35945	payment	2134	2134	1874	1	1	4347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1kK53xrjz7LtmCEnygCyQf9fq3ppKkJP3ra3q2GuJ3Kk8aUg
35946	payment	2134	2134	1874	1	1	4348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUbirHi9oto7oF39KqLuwTGcxscqyK4A5NmcLmVEoxQiun6kx
35955	payment	1397	1397	1678	1	1	13911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiopSvpNSeUWDtXxooyDfjwfQdG1BvfZgfA7r3JwJG7Lgzmduk
35956	payment	2134	2134	1874	1	1	4353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3VQ1gAPYz1F1evry9qPNMHMFMhMzZUxhim6xowubth3dfVE5
35959	payment	1397	1397	1678	1	1	13913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqWNJ23iruiUmBDWQgGPVCLcBvokxatf5iiTPcgYBgTjwmh6e
35960	payment	1397	1397	1678	1	1	13914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkLW7Ff6iQpSF97tK6aSs7wXXoU5LadP7og3qU3Q5cm7ZMSAA
35961	payment	1397	1397	1678	1	1	13915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrGygGuY31aG4mfJnPgbMArV6fpmArp5p8czBd5AD6J1EeSrz
35962	payment	2134	2134	1874	1	1	4355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQh3WEpWhamB6Q6X3vYjdcmsovkVDuUBYiBwUTNgZo8HwNcnh
35963	payment	2134	2134	1874	1	1	4356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffDcwEnhGUe4ZP3ocn3DztYsvwZjdQC4MFprxaFafZgbE5PG7
36013	payment	1397	1397	1678	1	1	13940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDEJX1kmSrxofSX2kdWVr5rroDHmtaofUuVmKQzrSjmz9SBKt
36014	payment	2134	2134	1874	1	1	4382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XuW7rCZxCQhQghjxBu7toKJNzmFdH3niZcZ8LcDfXLGdyPfc
36021	payment	112	112	1483	1	1	8	1000000	10000000	\N	E4ZRecsFV5Pfqmn7wVUjXqhe2cDujJ6mzdpwMJfsZqh6GNot37QfS	CkpYdTWuUoeXFfi4sxd2boS3eP8UXyLuYpfzRR7EjKRHsYRNBqMdp
36022	payment	1397	1397	1678	1	1	13944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZLPpWmH2rtebVGQt9kJwyvEXFN3ETatebR4KE9333U2fRHAt
36023	payment	2134	2134	1874	1	1	4386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAsASyWEX8tSThfPTkFEwSCyNry5PZh7kDNsw2P3xRxduSYrN
36026	payment	1397	1397	1678	1	1	13946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N3YpWwac2o752uA7pLuGpXzJYNedQ4xwvnUZM2tRpzUeFRe9
36027	payment	1397	1397	1678	1	1	13947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ732ud9jERatx2pe1ErQTXBLfChjFhie7Y5dambLyGjPLME1RS
36028	payment	1397	1397	1678	1	1	13948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvoLLfaVw8CbefEAfY1ag7zvJ3xiQX38dDNVMaL6w4169RyVvg
36029	payment	2134	2134	1874	1	1	4388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2C276Kapz6Jqf1WYKyjHD7TyJza8KrkMbWwgLuUr2kpYWAMr
36030	payment	2134	2134	1874	1	1	4389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjE15w3BJZBrYLuucMamQy3j3sfYurefwc6kn2PUhMHhACJqbh
35860	payment	2134	2134	1874	1	1	4305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtW2bqR1ASsNurVhgnx2KonR33vahgZvNqc7FhC6zdZAbicwxL
35861	payment	1397	1397	1678	1	1	13865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjTdqugyNWdCzALTP5b8EnyNSJcXiz1ksDw6w299dRUpxyy1N
35862	payment	2134	2134	1874	1	1	4306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZxZdZFAJgomqykGDeRVCPfbPcqh5zGj19ejHQs38WxtLA2pZ
35874	payment	2134	2134	1874	1	1	4312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMEA8Xmq2vf7r5Ftcy9BMkEKGru4mzxUDDv7iuRRTQmr7hPah
35875	payment	1397	1397	1678	1	1	13872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnw2fvsMjaHKuJy2gcbJmCHreHPbE1VdHXrPZbfRitQ4ewUAWh
35876	payment	1397	1397	1678	1	1	13873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NABinSNpRkD6gjmFUzTYfbGMz8p4zB1J3wYQQvyia9iYt1EJ
35877	payment	2134	2134	1874	1	1	4313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAViS9Ldp5oGdnh5UuyndBcuts8WPD1qnFJEFjwpsQEPPreti
35878	payment	2134	2134	1874	1	1	4314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjEHK6vqMB8m4RRq8rBqeBX6GkaJDtHqpJEVvbxW7ZfRpw4W7
35887	payment	1397	1397	1678	1	1	13878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhumAHrBmVq4dsxYvx4o58ZgFAt1shLmfdCn1fDhDwGFJzszju
35888	payment	2134	2134	1874	1	1	4319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruyYbvL4Qbey4YvE3NZ5uXtjUGAzNawfcw68k8VXm3ACEJgBT
35889	payment	1397	1397	1678	1	1	13879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadBe1Tpdi3HRFFwKsDAMGwY6AjHsdRbM8KvCc4sowc8MSEEVn
35890	payment	2134	2134	1874	1	1	4320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyon25er7w3eZwZe966fouKVxCyVzqeAo246E6n5HUBwbQgxX
35895	payment	1397	1397	1678	1	1	13882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhc5FMdRrcMNjFjrQJ58j9K136oM11zkj66WxrMfhHRy8Zvnpk
35896	payment	1397	1397	1678	1	1	13883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbn2oR8BYg2fs6rnmL2punfUy1Kzhk87y92uA2eKcfyXRpXUe
35897	payment	2134	2134	1874	1	1	4323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGUwLudXwqwCcDDySUjUn9YuEsBV2iFUpk3oV67hY8pS1jqkT
35898	payment	2134	2134	1874	1	1	4324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnGhcu9Ykiupb1CRprr7qjGhm7KjiEWU7vtvrhHYZcW6y7TxY
35899	payment	1397	1397	1678	1	1	13884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVoU1ZZxZXh5PjDWtHBjQbSL4dCYi3gFqmQGoxoQrhoazba4x
35900	payment	2134	2134	1874	1	1	4325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7k4ZUcMdvPxSFGGq752M1SMPaBcmKnzPVqkS7M3MTetycdiqk
35903	payment	1397	1397	1678	1	1	13886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYRkfrBkBvkTpPkNDxp1hwSa1tjSFDjv9fWy8pYkg9VQ8UMJw
35904	payment	2134	2134	1874	1	1	4327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiYsVDBLHgD3k7ttrbn3uuARA5EJncoJNsMbxmBSvUsP42DRX
35921	payment	1397	1397	1678	1	1	13894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyP5m6C48uyvP1h8ZTufzXXmyePvGHHZiFaccpYjzXxUqEdMVG
35922	payment	2134	2134	1874	1	1	4336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgL8otGu2xHAsiYkbvXkuCXCQQdjdJr6nQmosiXHNrVR6PaevW
35923	payment	1397	1397	1678	1	1	13895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLHxJZY3uwTTxbo5ZyVHZtPDhNUrA2wpaGbYax1rsYMYJe9J2
35924	payment	1397	1397	1678	1	1	13896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSpfawTpm4qsD6xwkNyjXiTDSNR792buLCbFwsy4oCRaBnSrE
35925	payment	2134	2134	1874	1	1	4337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nY9EEfhBpjpYEqQ78KAJGYNMMfcaXucLJLhixc4vyYQzqjy3
35926	payment	2134	2134	1874	1	1	4338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsr8tHP8FqakGZ2b9FDQMDKtP7XSKpES7pqjzyzCa83UPhxgLV
35936	payment	2134	2134	1874	1	1	4343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwHATGZs37izsYkL4aS5indKRBrKhvvfUmiPirT12dHzofCF4
35947	payment	1397	1397	1678	1	1	13907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKa8m5sHD8t2nAKCg2W1tDnebsy8uyuUm2kr6253dJbUYqAtPL
35948	payment	1397	1397	1678	1	1	13908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2ZGUrKJiRrbimeHgQS1EjNUBEygWF5VaMTBkNSebQzQLSnbw
35949	payment	2134	2134	1874	1	1	4349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5qA9DsT3rv4izMbi4TDBR6Z9EmqeDgcP6WZyiHJRS3B2mke2
35950	payment	2134	2134	1874	1	1	4350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiiGCgqtfBjr6QVQdYaYyEyTpXEMJpGT3tGMgTAmXFY9MnisE
35951	payment	1397	1397	1678	1	1	13909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZj7qZs6VhBraxLsafJRTrM6NWMhXNdyXMqVzFsGAeyeJg7Tpw
35952	payment	1397	1397	1678	1	1	13910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNQ7c5pDHqQjMhh3jBZua5TfjKjB3oVjW6zkG54BJDmbZw3Wd
35953	payment	2134	2134	1874	1	1	4351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zzaMTt1qcfxCPZx4u2ei2P2351mQV96LjbKxmxBmg9AVqZ3h
35954	payment	2134	2134	1874	1	1	4352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xkmfhAByzuzxYaXRaLomyKyHcSVsvjFpMoCPqesvdQE6gQRh
35967	payment	1397	1397	1678	1	1	13917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8SmEz1MxksjW1Jm58yssAMZMKkW3GwqQHaKHitAzLwYt9Lya
35968	payment	1397	1397	1678	1	1	13918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5piNLcEKBFw5XJNgB4txKSxyxLicDVbcgMPMzFLgfo5hQd7Ct
35969	payment	2134	2134	1874	1	1	4359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMnwTc1vmt5t8tWTtFgaQgqpKdc6NRQssbsh42PmPZ4XGqdpB
35882	payment	2134	2134	1874	1	1	4316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAatLYs6oQ2qPKngw4TcWqMcQR1BX5dpubHMvLXj9vekgiL3Na
35891	payment	1397	1397	1678	1	1	13880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFhBQuZQdcFkfuKn5Uh55K8FQY5o1XCmLPhXCXs3CmovMjoJ9
35892	payment	2134	2134	1874	1	1	4321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zPz6xc92iYJcLnidRyyZx7zttvacMZcUoGPYhhaoDvevAZuT
35905	payment	1397	1397	1678	1	1	13887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6gqJwgZkHWDt38iqgiyoxcUC4Cjgz2Nc2GAz1ZY5CrXLzZaQ
35906	payment	2134	2134	1874	1	1	4328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLMLS2C7RLGZEnmPA1xrxQUaEqUw64JQE3hyukhjbsvK3WXrJ
35913	payment	1474	1474	2305	1	1	27	195000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZk7J9iUNYaJr7LDpWgVKhhKhuwTXkTqa55HsSHcrFDnrEu4yba
35914	payment	1397	1397	1678	1	1	13891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49ZxySZFXHAZk4HqioZFUmGvVhvXxfgqbFX3ML5dmWJELt85s
35915	payment	1397	1397	1678	1	1	13892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNvvaPiw2rBLNS9hsw5rji9vU4JxFCXKq73s6T8iHAkjQwQU7
35916	payment	2134	2134	1874	1	1	4332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvrFT3YnaEpZxDGJZtmkvCfV4AtSTve1tSySemTySfhWy2LJ6
35917	payment	2134	2134	1874	1	1	4333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkrEvMAMEbcCxFWt3MHsEaoGQcP17mTXxpGcvTdGDruDYKT2C
35918	payment	1397	1397	1678	1	1	13893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeorgy8SBLtfSCWNccDRoq6Cc11eFzJsB3SEkqPzpYjJePM4uu
35919	payment	2134	2134	1874	1	1	4334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxEjaY3qzsDaWpeaJwjUqk6ajfrtAhi5t9aXMtC2mAAjrgCWf
35927	payment	1397	1397	1678	1	1	13897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDuXsaMXWiQ97pBEFEwTE6xGgsMiZPeDuSRAxu641pq6HLvnB
35928	payment	2134	2134	1874	1	1	4339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJRvUqmpdx5ggXHh8ycpYpCYGPm4jZ77LxHyxvXRNdWGUEViA
35937	payment	1397	1397	1678	1	1	13902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutuKp6tfKSwi1t5Cjj7ZJJsiuLUXpoMPeNDKhWtEugPkQTn8q
35938	payment	2134	2134	1874	1	1	4344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88iervuZyX9wGVwaMo3J4rT7JuuPETXcHy8jPCgfbQhzZ5Lxr
35957	payment	1397	1397	1678	1	1	13912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1F78MqF6yqdUAPoeFERgkNeGutWkBVL7Pu6nR5xuTJfC8KbW
35958	payment	2134	2134	1874	1	1	4354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTuGwXAoxwKKN5GRUDKNsmfHiasJ8Sfdf99jAneVm79S3sZ5S
35964	payment	2134	2134	1874	1	1	4357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViVGMHLP9fpYSmo9pCJKfgapXPGcf4aF5kty8ge33yqA8v5Tg
35971	payment	1397	1397	1678	1	1	13919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi43thyvsY4L1PCRWq5nz45KCFozGmxnhd7B9fotryYaK9xwK7
35972	payment	2134	2134	1874	1	1	4361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7bnyPo8Bkg1zRVPBQ1pVSgnCp6sfM1EJ9VeC3Fx3LJ4HwJvk
35983	payment	1397	1397	1678	1	1	13925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPyNEwFMfCEtw3xhiYXRWQaHbA4HbsPJYHDMC7mZc1WJL8vkc
35984	payment	1397	1397	1678	1	1	13926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5s4TdVbkS265ifmh185RLDpuvftvGPr51fK9CVNvdMhAi4QLT
35985	payment	2134	2134	1874	1	1	4367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYyLjNX2gAPCcpEcFT75NVvrNJ9nsHNzBkVSUknZdZwSLsEXB
35986	payment	2134	2134	1874	1	1	4368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRt6HT4iHWCxjbNGkyvZZMk9Fk3QQPPLUJSSximUt6XgFc6Vs
35989	payment	1397	1397	1678	1	1	13928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyA3EXhbrSRBK7owUvbqZfQBQpYhgYkdYU8vS8f2Vf5UBzJCC
35990	payment	2134	2134	1874	1	1	4370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GCMu3HtLL7s1A4xviM1eMYyP1vSmNK1HcmzcE2EmmSJTQHjK
35991	payment	1397	1397	1678	1	1	13929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1UGNane5X4JvgvQ13VZqiFVWwicJokxKPyKwJV4zuaWpG9zQ
35992	payment	2134	2134	1874	1	1	4371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JbPdThnp8gxZnjXhLh8iWjEFcT5MSYuorB2fUS46cEsaKYE3
36005	payment	1397	1397	1678	1	1	13936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xuu6aE1qWR19wjBSTnbSUGdrrYiKkHy8qHtxFfc8igJwcS2Q
36006	payment	1397	1397	1678	1	1	13937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GvKSt8xRJmxWdppJ7WHx7PmUeyVjr1crNvzXADMZE4HeosB7
36007	payment	2134	2134	1874	1	1	4378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ738k3PMJf3tw9LDityfUDBJ4mL2ErVHZUZUCDfDjU3b6qjpm1
36008	payment	2134	2134	1874	1	1	4379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BxQRaomUgtsX6DJgfa5YZ2UKiHUK8Ndp63xkn59bf9sbqK9P
36024	payment	1397	1397	1678	1	1	13945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGtPpXWiHbEBHizWB1F2C4FxKqY5s66VnZJNFjHgdvHRY2FP7
36025	payment	2134	2134	1874	1	1	4387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCxjy69wNUPMuiQvUj1nLXrztYBaL8NGshGg6P9sJtMpF6v2X
36032	payment	1397	1397	1678	1	1	13949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAWMCawfrBfX93LJvba5KoL1kd1iSd3EHYrCia61KyLcJ45g3
36038	payment	1397	1397	1678	1	1	13952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFNGTEUpGFpxTHQNfK1mVFGHoCkLUQCtJaX5LaUvcwrTQzSUS
36039	payment	2134	2134	1874	1	1	4394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFW7JG3XigYZAUPcxDVvQWZ1bqfwnYK7cVWJLnjJuBJuGjh1B
35970	payment	2134	2134	1874	1	1	4360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRscbLdMYuDQAzn9GNHLTkJtGKFnB5RHFhebTxiE1X5kfc5xK
35987	payment	1397	1397	1678	1	1	13927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cQYyqte44Aoy2cnudKgp6F8csbWLCsTZgcBf6C8mEfP5HBQN
35988	payment	2134	2134	1874	1	1	4369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJx7ZHGHs6ADQiHNWTuSCtaSqmZaH2iYYDNskFTKLEqw2fKCfP
35995	payment	1397	1397	1678	1	1	13931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZKbUNZumtzAmcGdGfj8HN7mE7C83b5epTzanmdgfBM4jbbaE
35996	payment	2134	2134	1874	1	1	4373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxr4ijpwGcjvrTCduiQYir4Jgoc9oGZx8Lgh4GzsgGfVVDnnG
35997	payment	1397	1397	1678	1	1	13932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCbWFdX6PvZ5cfksrpQHttF6G2VAXDJQUyMvcWg15D3ATXiBW
35998	payment	1397	1397	1678	1	1	13933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEro8Mde5fQZQyFrhEhEpTD4c8YELCdAsR3vmjr1RzeDKEGx7k
35999	payment	1397	1397	1678	1	1	13934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkyfsnS9iP1DHiNcGsWMJaHpSPKB6w7rReWsqDBXFjayafooA
36000	payment	1397	1397	1678	1	1	13935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6EycfFHEHsc8Nmh3YpFwHn3UsGCaNPZEKyttD7xMZNoBJnv8
36001	payment	2134	2134	1874	1	1	4374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfVHLRQKkvfEpzZjdZdUT1b2wUEiHfUawcji1oqJhD4jGaiFN
36002	payment	2134	2134	1874	1	1	4375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8Xp5PizBFHP3iVZTPPGHRQnBfynCC9jYkGct2SfuuLK5Hrdq
36003	payment	2134	2134	1874	1	1	4376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3CTtujCyLrDSRWS4S51wvSkLJnqJoppmo79xspVV21sMaM6K
36004	payment	2134	2134	1874	1	1	4377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqYMtp2eW3gvbpoydWGfDhKg2qeYBbCmP6eHRuVMNJpfDNPmg
36015	payment	1397	1397	1678	1	1	13941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxFBzQ6Q1ygxrniou5Ncx2jz44NETYtkPv6moSLomKkwrmWSS
36016	payment	1397	1397	1678	1	1	13942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfWBQFBBQrasue4asj3S5VkSsjzu9JuELnRPL1VyPMRF4UXUj
36017	payment	2134	2134	1874	1	1	4383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZSEacfvE1aTkFD8e8EALb6BPVnTf7jKMCJuqTxTJKPiuajhE
36018	payment	2134	2134	1874	1	1	4384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxV4rGZeVLHjdSMuk8NHW7yYwKdxoa5mGW1BVQZx5WB58Dtpqs
36019	payment	1397	1397	1678	1	1	13943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmqiS9fbtvfcMYwULB5NQUtsx84FiujYbzk59959k7M8Raw3M
36020	payment	2134	2134	1874	1	1	4385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hiJ1P7Q8p2BvB6u8JCnqbDRMibcZeBjVVG23wR3CzkczRoZE
36034	payment	1397	1397	1678	1	1	13950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJzo7K6ctbNiiJdRknKV1YcGM7h1he9krwtEhTE7ihgL6ZHxc
36035	payment	2134	2134	1874	1	1	4392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyF2yRU4npRThpXQQZ5bXiMaRPZrfwhd8PUfPzFzXxwC4d5Qv
36050	payment	1397	1397	1678	1	1	13958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEki11y6G1Jt5gSSs9WSmnMJyBm1bxJc22hgbmtdUfR5672oT5
36051	payment	2133	2133	1874	1	1	4185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1w3Qws82AViz3r9N8eLZEKfLsDcS7Qk55KQF8wWJMGApsKGt
36052	payment	2134	2134	1874	1	1	4400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRHrFeZp7asXw7riTwBtfov5336jnaRwRmWqRbEAVKP4pHQ5d
36056	payment	1397	1397	1678	1	1	13960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSn75uQ8t2NrsEJ4zeg2uoQtDxzN4R5ao8eRWX5TsfCFq17wR
36057	payment	1397	1397	1678	1	1	13961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzdBaRSAdng1FvTGCvJSd18bsdRcQT2eLBNwLGyezVM8GTK61
36058	payment	1397	1397	1678	1	1	13962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUjxJYc36VK3wUuQbp6k5zEYYwb6dNbvGaCPkz4kPQj2gXx9L
36059	payment	2134	2134	1874	1	1	4402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMbRV4iBwFLxYGC8v5D8PbdBpUmaXE7DQQB1iXefdzjFPirez
36060	payment	2134	2134	1874	1	1	4403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRKAzTtJqreDGdRk7dF6sQbGNR5EwnXpirRhQeFtWBG7okUkm
36061	payment	2133	2133	1874	1	1	4187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoRz3tgvwvK1MnJJn5CGVN8bYbAspSsHqvnqrtFKtffBeLbtK
36062	payment	2133	2133	1874	1	1	4188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mf19SpcrsuN31dGEV2xVdanGBPDNJWXQgu6eJ6E4THTMaa2m
36063	payment	2134	2134	1874	1	1	4404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrrRGFfjtoAWP76YGDcQfBWSEEB1Lyg5K6Fh3SEs889ocNZwE
36064	payment	2133	2133	1874	1	1	4189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7w4iBjaSPrVrTyKHPT2nqnxyUXcEnoMEebXpwkeL2JMJYpXZw
36104	payment	1397	1397	1678	1	1	13975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKnRrjQJoTJAYUyAv2A9wVqzAuWuu9onG3CJs6mFB3MQCYDMJ
36105	payment	2132	2132	1874	1	1	1224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyJjSDnEWkJ8r7NaxbShBwzdcyXa8YVMVP5bMJihNMv66XdVp
36106	payment	2133	2133	1874	1	1	4202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9KJ7z2bJSUcsg5mBnnSYfhFAGJ58mNtCsrRtsaD5YxgepBFD
36117	payment	1397	1397	1678	1	1	13979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ULsniWACHE3pPwXFBAAE3ygGF4jj5VMhDhyme4yynHAditmc
36118	payment	2133	2133	1874	1	1	4206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk8GYU75QMLyx6w8iBrkLWpGB7DMeatv3GC6J4HauQ5Y8gdPJ
35977	payment	1397	1397	1678	1	1	13924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNQ7ox5ac2vbjbTqZwAFy4MJ1xvNziScivWDxWhXHaUVGsFwx
35978	payment	2134	2134	1874	1	1	4362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvUh7nLJhFeLCpfRnnsPeSyoKRRnSzr7PAtxP56e4hCLXW8af
35979	payment	2134	2134	1874	1	1	4363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ92LFAq6pVH8oQZ4bszuMGPHcQyDuvSp2cYV4Qf3XubVty6J
35980	payment	2134	2134	1874	1	1	4364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzY5C4QRskRg76vzbS4PSMSGqdgDDNnvT2SeBoKs1zAUM5KXZQ
35981	payment	2134	2134	1874	1	1	4365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa33yqQy9H6Dn3NJ5oXmzjXRREyf14cosX57xHRasYeYXZK2Zz
35982	payment	2134	2134	1874	1	1	4366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82cDoYN35ta5mgbWTNnvG41YsQfPswV3JPk1SrmKcxiz3xKDF
35993	payment	1397	1397	1678	1	1	13930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKt1dba6jpSPFJg5g3yFL6CS7xZaQLUcwxLzUfkx6cbvf27qFW
35994	payment	2134	2134	1874	1	1	4372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JHoBzFJ7wGdCpa9SWzd1FFpHvYouwMygeU7GjgayPYPQChuF
36009	payment	1397	1397	1678	1	1	13938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkrdfrokAzzcU8iANiHANb15P2dC1YtHKHQkPpXa4N58cRdwu
36010	payment	2134	2134	1874	1	1	4380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCP7zMsYMK5PajKvvz5Vu8mH6takC1auY5tf3R45N1XjiJupzz
36011	payment	1397	1397	1678	1	1	13939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaZvjExw98CHoaHHCACyE6UkTt9fcPL1FMyeqWhB4r5WJpvaB
36012	payment	2134	2134	1874	1	1	4381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVnf9oQA3odYUVwbUhn3i3RXjPKSR1Mdrg9NJCZp9KfBDAT3d
36033	payment	2134	2134	1874	1	1	4391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8ynStELAGZdmeDwKBeHYs4usrEwKHDbPH4BZZLeXXoJbjTHE
36036	payment	1397	1397	1678	1	1	13951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqgfeM17HBwRWDZ7v5V18JhxSnqGmJeivCS8LfXka1eTsKJv5
36037	payment	2134	2134	1874	1	1	4393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLoVTuAMxMY5Y8PJrBdAxD7fGaWaMwAkVCaNwgXrQEoJ7i1zQ
36042	payment	1397	1397	1678	1	1	13954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2yTFByrU8xmpfhXp2LVTanfMtHxsyQj34HYk8VqYq8oFnM7s
36043	payment	2134	2134	1874	1	1	4396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSudBKwhCDMomjn1uPFvBeTu9JGf4fW5bNwigvGhy8RBCSPgnF
36044	payment	1397	1397	1678	1	1	13955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4hkTriiX8GgAyMHep7kR7Vhfkkxc6GWJYu98scajDZMW8MCe
36045	payment	2134	2134	1874	1	1	4397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gTWGPXb6NbztjMC2owshp4RY4ocsRwPGQGH81At1oDQhyofy
36053	payment	1397	1397	1678	1	1	13959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw17kGgemT8jWmfFLZmBBX4Jpa7FeECTJujppoJ5938rb9J7y2
36054	payment	2133	2133	1874	1	1	4186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesKDvsZcFDX4KoksFXv1chjvQsM4vD2aRcxk54MZhf2wK8EJ9
36055	payment	2134	2134	1874	1	1	4401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4p3p2k5y94jnymvYxNqgkUsqo84WauCWhMpc7LbPahinC8w3
36075	payment	1397	1397	1678	1	1	13966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVCb4Cun9MQkbZZxZfoJbWVRuxcBLNXykVWPviLMqmTvTqRHh
36076	payment	2133	2133	1874	1	1	4193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W1X1D8rva7XnbJg31dbQjxrimSbbwijS2ZLDcLTf7g35H7tx
36077	payment	2134	2134	1874	1	1	4408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5t3puV7WY8DwVSULAot2DKMKA6vPii9YGEkQzSZkfLJPDk8L
36078	payment	1397	1397	1678	1	1	13967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERTMMgr1uNoevzTPXhXrUiQzFKTjp5zyouiAvW5nodKvcbzJx
36079	payment	2134	2134	1874	1	1	4409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPLWNBF9AofFFXfxwzYNtTvR1riqLqw3smYXL9rS3akmakzbL
36080	payment	2133	2133	1874	1	1	4194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttiCnPzTjFimhkWc8D5MfX3K4TeXB2PHcKXGEAbWVjePdW2sL
36088	payment	1397	1397	1678	1	1	13970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFNEY9BJ8NxVWiTPn9nEBfoSzB5tDuJ7jt1DV1L4JxsscBDpW
36089	payment	2133	2133	1874	1	1	4197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8neChHaaXfgxWWBpmR6SCaa2HewuURZGAMuN99LdGzgPD3oa
36090	payment	2134	2134	1874	1	1	4412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2mqGpCbbxLtDcmwCaV7yEbzgZGaHB8bqvmuPijWgBYdG9DDH
36101	payment	1397	1397	1678	1	1	13974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiQa3fz9uww9FLkPMK6BrCgAQFT5AMys31ozbiWMUfDTnRRBy
36102	payment	2133	2133	1874	1	1	4201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Wp4CmxqwbupX4GdeFqzUzCbCfQ9P1XxqKSQuohncHgvu7Pan
36103	payment	2134	2134	1874	1	1	4416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUFGPHE3JfNVeyW962Afmy4T5BySyo7iraznxxzjz5aGc7Gom
36113	payment	1397	1397	1678	1	1	13978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgj4s8fnckC35LaqD8XUCMTW79gf1KM753hf5ejau9jVX47fr
36114	payment	2133	2133	1874	1	1	4205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sFEEBdfkAzzmB7MQ5zC5nPTqn6ocNbRQi9ZAkjL7DVpT9m5k
36115	payment	2134	2134	1874	1	1	4419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8r3NbnsQAfe7j5ZKq63d8gbo3VPfEitjVpYN2CzurY6voxaf9
36116	payment	2132	2132	1874	1	1	1225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwESiny9CsagNWSNoAierrnuPZE3MDwrD4y7DC9fkXbfiZwmg
36031	payment	2134	2134	1874	1	1	4390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVxtM8y6Huidpc5M7q8ezyir1CUhADoqpWua6Dn7UPSG9KUN8
36040	payment	1397	1397	1678	1	1	13953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv25JBNGnhXmBRnK5WuTP8Dash4P9XY7Du9qpgrB9cy2JpLuaa
36041	payment	2134	2134	1874	1	1	4395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKnkR9u7xFGCjpTLgwbxnka8FXT48t1LxBEqHakqiniZt2uuL
36048	payment	1397	1397	1678	1	1	13957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBTxuxM3ZB26syh5ZbjoEoGJEQfLCd6cZtWQZ7Qku7Ff9KRCj
36049	payment	2134	2134	1874	1	1	4399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9JVfaCqnS2GhiUjpwBuGBXekdPVLMDsSGHyJsCjugJqUpxRY
36071	payment	1397	1397	1678	1	1	13965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmACwJvqjV3hVRf6FQPyEwrEFTHUNd469QLVXt7NuDL9QFuHZ
36072	payment	2132	2132	1874	1	1	1221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXE7FAkH989MvYjA5XJPrrQ6JVbzqvywwNaBA4Qrf4atbuTq9
36073	payment	2133	2133	1874	1	1	4192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GfSpM2o1yypuNrBKDYrdb1qfcE9LpDojetcgyDF2WYrt1cSh
36074	payment	2134	2134	1874	1	1	4407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVW7fXAN3nvgVvHSN7U4hYh6kddN5GHAEbX61Abs8oohgWwkH
36081	payment	1397	1397	1678	1	1	13968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVajyaSPH45KvnvsohzQghKpx1pgsfD1ToTFRfChz8PCaBrUZi
36082	payment	2134	2134	1874	1	1	4410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiF4eQwzy3zKdyVQ3iuHythLkVVFPDzfDeHVNugER6EKvejmA
36083	payment	2133	2133	1874	1	1	4195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarSp6tVoQirhUnRq83GK3pfS5fE3ZRdNFVeAoLrA9Y7C5kcYH
36084	payment	2132	2132	1874	1	1	1222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MgTSmXW91tSxnVoiMYtbgensMQFkBSTsGZxo6oGLq272Z2qT
36107	payment	1397	1397	1678	1	1	13976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AcNttCaEDpDTPR46MG6C9eN7gS6LyD7pxxSZDvmzDNb7nxi1
36108	payment	1397	1397	1678	1	1	13977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9PM6B1dvfh4T2pqDZW1K8QiKvcn7kvAUMs7FcCHcvWbPEevi
36109	payment	2133	2133	1874	1	1	4203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGrSrbqhBWTstJ2VcXzmvSDzTQ7L3yXktM8Ah959siKH9jf7a
36110	payment	2133	2133	1874	1	1	4204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9MCtbHAT5nQyKNB4HH6BzfrrTyakU18sL1AgUPjvP8cYfDf5
36111	payment	2134	2134	1874	1	1	4417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7o5huDWgbe5NvbVWrVq6ALyV2y58eVuijgfC6mWsK9P2MTTiJ
36112	payment	2134	2134	1874	1	1	4418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRpGy8uDdmN4pKW4qhHrk2J56XeoiV8EkQEwX8jZ6fS2xUtmd
36120	payment	1397	1397	1678	1	1	13980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQ1rG19tiWxTbFhHtDbRqStMTyptf6ZFt5PNpjb1aR4crH46c
36121	payment	1397	1397	1678	1	1	13981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUQQraVAeQE5u2RygJ3wsuJwPE6yRR8bA4FwNWNcZo1UPm1iv
36122	payment	2133	2133	1874	1	1	4207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeckoH6yt5MGn8t6pAgPB8D86xr2cAztApDR2VnLVuDFhq2Dpw
36123	payment	2134	2134	1874	1	1	4421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXPMKxDYJfMEoWScot4CgPUPjmX5q9t6UXTzZu2dF8A1bgpVE
36124	payment	2134	2134	1874	1	1	4422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrvrDdnfDkCx5nqMoVhokacR4aagJBrGqCUmPcx5CjRWD8VFY
36125	payment	2133	2133	1874	1	1	4208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oZhZRUhLfwcR1c6xRt9ojVWBUGtdWFed1BnFu1PzPYeLumpu
36130	payment	1397	1397	1678	1	1	13983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXfH6zvqqeZUdYrHaoyTpUyrx29w4JZCcrY7uc7tGC3zWhqwp
36131	payment	2133	2133	1874	1	1	4210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqR1Kntzkamn6VrD7UEAkZx8GPPhx58Xxy1c52ok4hCTcBRkD
36132	payment	2134	2134	1874	1	1	4424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2e62TCptzDN4jibWaDE1zpqimQE8hJqKZrk8mhmwSJJCpEQq
36140	payment	1397	1397	1678	1	1	13986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QMsjctG3GDHtByQfgCnugBZ8U2C5sg9Me8QAjaqS5EW3NEvd
36141	payment	2133	2133	1874	1	1	4213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgR82ybxbTLgc7sUhWBBQTYvTrsnj1mxrF1NRrPdGPwaxNZGM
36142	payment	2134	2134	1874	1	1	4427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u9JQARxwCVwKJxnEnk5Gnh6hiKEXmuvFUzC3FswEzkDgQnA6
36143	payment	1397	1397	1678	1	1	13987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDaDQzWP5fukgEr8fSrc8sn9y4d7DLNouoXqYF5BCWDKwM9VN
36144	payment	2133	2133	1874	1	1	4214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZidMjwb1ngUuDW1vF5JpocMjLDREHPUzgf9F6DQRjagv1e6y
36145	payment	2134	2134	1874	1	1	4428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzr7TncUiKhmexijJri92Wo9wAx893RRcjbTkgWxaSGr6qFEX
36155	payment	1397	1397	1678	1	1	13990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZY2NVhGoNwpAdC8snb5DcpKy3VA5Kb5MkaSZ2bfmGc9GiBzW
36156	payment	2134	2134	1874	1	1	4432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqorWo5ToN14ZTQJska286q3FhxE8d42tp9MVr8kDZeuUdey5
36157	payment	2133	2133	1874	1	1	4218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWGm2hibJ5UNNqHu9cDDzZvS9GcUMHsgrJBWzkwJge5PbYivx
36172	payment	1397	1397	1678	1	1	13995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmU98dNcfh2kBKXjrmPdvSVQ8Wdu3nHynYttpxHueBkM6r2nBq
36046	payment	1397	1397	1678	1	1	13956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV2TaYe8KNg7xg6jcDjn68nZevpoJg3pYjMStvWyuDZn9fpX2
36047	payment	2134	2134	1874	1	1	4398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7zQ6cRWWy1m8mHBBDNS57Wi69eTJvASb5x4yrBo6HCyftQZi
36065	payment	1397	1397	1678	1	1	13963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4J8YRMgiJryr7kszGnQRKUa9XC12dFusDesZhrdPNqbjLY8i
36066	payment	1397	1397	1678	1	1	13964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKMo8VnPSYqbJ1kbrUpT1RvuCkegUCVwqpR5diErfFGDMYtBm
36067	payment	2134	2134	1874	1	1	4405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bNCVZkD3apNFgBNYhnMauxVvhNeF5nJm5jux185zBtqJgKzh
36068	payment	2134	2134	1874	1	1	4406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVGxvEV92wdSBZGxwh7mBuDCBRx1EAusqWsR7nu4kpWiJgQQv
36069	payment	2133	2133	1874	1	1	4190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78moDQKWPRDqARk16yfhPXxDdFNUnD9Z17kjRBLpmrVdXM9gq
36070	payment	2133	2133	1874	1	1	4191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun68CLqcSYw4Bo6gVnx9weqD3NJhiyLEpfNg1cJ9AWFfxwPJM
36085	payment	1397	1397	1678	1	1	13969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFjmGSooPXkugHfGfBKt7dogabjVdWuZhnB5JGncRJhHnjNmp
36086	payment	2133	2133	1874	1	1	4196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUKfBJuKSX4yxVQHUTfZb29tr3xHXc4pKTdCFpajYAxe7Nfbp
36087	payment	2134	2134	1874	1	1	4411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9CqGWoPt6E6tkTEUQKJQMBWP7qEnnuDwCmm73iHm6Gie4E2t
36091	payment	1397	1397	1678	1	1	13971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YSQzid9Gka52bQBDyM8zHaMPfoMPA5mBLzaCTbMSYSSfT4WD
36092	payment	1397	1397	1678	1	1	13972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vyJYbezmM1iNwNrsbw75jHULFKEpZSmm2JgSS4xn5kGviSVt
36093	payment	1397	1397	1678	1	1	13973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJm1BzGPAp2UxK7UvLagXMbrUj6kmmRqnUpvib9J24hv9vaVc6
36094	payment	2134	2134	1874	1	1	4413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2XpJLQBtCq92wmEU7iR8CXQzZPoE8kANLKz21BdCiu76zTm9
36095	payment	2134	2134	1874	1	1	4414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXVHZsnaVR5vEBegdHPymy4QnXhZXJ9MFB8UUv3UJnyJzrk1c
36096	payment	2132	2132	1874	1	1	1223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5VpXAiHKCxVbGZkgKs8UgqLYYnmQNEZmNJHCfLJsd8h2sfEN
36097	payment	2133	2133	1874	1	1	4198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYug3XCVEaKaTAeZERapgjtA4CGKh4Ns93XRSEmdyMu8XTis6c
36098	payment	2133	2133	1874	1	1	4199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpPEq9rMLG7RghEY3ztbC772agfuMdbnABLkjWQ2KMUbdaq3j
36099	payment	2134	2134	1874	1	1	4415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfsxGQP7atQoQUZNqRFqC64UJHiaRBAkBjokVYtWpGJjmRQyb
36100	payment	2133	2133	1874	1	1	4200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6PpJSJJ9oujLdq9DPcVuvqNxTE37urnxhsMXWDEfS2gMuzSC
36151	payment	1397	1397	1678	1	1	13989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJEugHeG7WcqmYNq9ZbN3qEYnE6S7zpKtLsZ8T9oA7gFrKXSX
36152	payment	2134	2134	1874	1	1	4431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwdSReYFsDUDigdj4JJFvDepJGWGUi4z7FCPqyTEHfNMBba9F
36153	payment	2133	2133	1874	1	1	4216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkphdRbTFzYMzsfSbXsZpqnswM5v5LUAuZ9GChrfwfQx72tnE
36154	payment	2133	2133	1874	1	1	4217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6E4h4cZwo8SBS8QGVodhEaipfAoAooYdeHG9AnmVWeuDQoHH
36162	payment	1397	1397	1678	1	1	13992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurkfoazRjm5ayBYiCkg5JY4YUYcbNHWdKmm5cqUzA9mBygbbY
36163	payment	1397	1397	1678	1	1	13993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrqeFT4mTALWFqaWKovtjUQmUMwUvjqMhndcYWr3MZoDCvQi5
36164	payment	1397	1397	1678	1	1	13994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyXje3H6wmio8ooS5fGUTpBV7dHdgX9ni4fsnGUReJ4QSzJNC
36165	payment	2134	2134	1874	1	1	4434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoaErR42f8BQteiLC62hKFHFbTeyB8Eyrjv38DyZqtavbrk9U
36166	payment	2134	2134	1874	1	1	4435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHr2yYgVXnLh8gbEMrfXKkfeq6KuiX3eZbFYEzKBVSsNr8tfS
36167	payment	2134	2134	1874	1	1	4436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MWWhyi3RNVqtATwG2BNxcrXPwfNg55h4kmR5QzQVy17LdMmF
36168	payment	2133	2133	1874	1	1	4220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboi4hosvzaojacHv8WKXTa19LdecCGM1oFTdkRVRScyako6tc
36169	payment	2133	2133	1874	1	1	4221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7a8f9y1qz9KwpCAFau5Q1QBBZYh9phP2AcJLkmu8R4ZkUimD
36170	payment	2133	2133	1874	1	1	4222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiR3NEkKBLJ8pTycbMBHUgmF5fpDQFGyBkMVgcutbniCShsxm
36171	payment	2132	2132	1874	1	1	1230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9rptnQqqWei1vZC1b68vWyD3uoQMcufMz6hmytXsojt55YbT
36175	payment	1397	1397	1678	1	1	13996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRB3Rp7dMrYgH5GXYVrFWByoPKKZHX2cLt6ZytHMqYh8Dwfuz
36176	payment	2133	2133	1874	1	1	4224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QEG3HWeyfjjgHWGAHtCo6meEKC4qfDneErJkPgqgJ4ENqqG3
36177	payment	2134	2134	1874	1	1	4438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjBtmDXKc7kuoC8ka6Fsg6oTysJZ6jc6h6L7zUKpBCqgXeN4i
36119	payment	2134	2134	1874	1	1	4420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9X7y5Sf7eZiUWqN7csRNgbSeQmZYgMCEV8M2rRHQfTUerG6d
36126	payment	1397	1397	1678	1	1	13982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSySKf2GnwSdskmjSrubHVvrP4VRz6a5BEoaojMpHew9TLXg2Q
36127	payment	2133	2133	1874	1	1	4209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuX1kAqUfRQ7Vj3QQvPYEVufKVDXZnaS6qsyYEFL2SMRxM1i6
36128	payment	2134	2134	1874	1	1	4423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoGTkTZKCnLigjcG3f8UhSZJemXpyTmuxdVARZGknK4DGgoHk
36129	payment	2132	2132	1874	1	1	1226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAYVMHLgW8ofmFcc3XCTDk8Dc5vAM4mbMok2smuCf2dtuJqKx
36146	payment	1397	1397	1678	1	1	13988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDhzLGgrcxGnkmfw9dTKALPJgMmJnAj3iK5FXdRm3A53TmFad
36147	payment	2133	2133	1874	1	1	4215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbPB2953BJaNU6QMfGe3pS7TRBD1FvcZGr4XEYUc3HN92WLL4
36148	payment	2132	2132	1874	1	1	1228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnZpvBDp3CLKFmAXamJUNRMKRruHB91Kr2PdgwV7RuRt2YYYx
36149	payment	2134	2134	1874	1	1	4429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmLcsBtP2yWGqWAYPcWD6w9pxZJpg3HQo5DapyR3jgqmE7n92
36158	payment	1397	1397	1678	1	1	13991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVWSeng4V4Voqdmko7P3uRAT5DqXPAm1V1RNB3yiejyCkXpHs
36159	payment	2132	2132	1874	1	1	1229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz4d4jffLAupRZ1qLMbmDSEuSRz88PnQrh23AM4La4pD4iXXi
36160	payment	2133	2133	1874	1	1	4219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ub9pvAdcUWbmemF67vyAAjUizwHpSixA9y9CnsKufLtywx94
36161	payment	2134	2134	1874	1	1	4433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PxgbgX9RuU2YC3CNpBsZqP71hxk1me2NJWrEYrw4ak3yKBt6
36196	payment	1397	1397	1678	1	1	14001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EBgSoPc47XknGbsiLTjpX7mp2BZXrHj4kPujVd7oR1zz9c4t
36197	payment	2134	2134	1874	1	1	4443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiFkg4z96YypMBvN4miK6WKhsW4CL4nd8919hfLQ4ksTXDchu
36198	payment	2133	2133	1874	1	1	4229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9fAHW8rAdAgcq3faWTByi7kcn2hTu8XPAcHRHvZvLkez6gZw
36199	payment	2132	2132	1874	1	1	1232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRu4DU7JWT1NF5eWL6o7V1MXBoVVwZG6YYGd882yC69ViJ7ah6
36200	payment	1397	1397	1678	1	1	14002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGGEcCPkyxYW8hJrH1iEEf8BvH74CoAQjwQM1Zb98ui7D2DjJ7
36201	payment	2133	2133	1874	1	1	4230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBFwJd5GFQGMk41jJY8maw2XRVg7DLoKZeXZ856RNpM7pxNvG
36202	payment	2134	2134	1874	1	1	4444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPmwAAyk6RiPK4DcjFuoxJKZ2FAJKRfFx89Br8gMaf7XZ2fcR
36225	payment	1397	1397	1678	1	1	14009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8H3GZZLhwLSPs25P8uL2nCrunyUtKWci2gQTmJh9H6wF73LWi
36226	payment	2134	2134	1874	1	1	4451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7Zhm3WCivWcNu5JSQtxKFT69Dw4thvS5UXdxByabLMqMhbvv
36227	payment	2133	2133	1874	1	1	4237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jdMgKpM6Yhrja9ZcsxSZNR7aFhNvsFj4cxKsEz4He4Cs3Ch5
36263	payment	1397	1397	1678	1	1	14020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUebhDiYfsEDKB2VXiLKPBWsWVMDvYRBvDwX16FbYjRyXqX17
36264	payment	2132	2132	1874	1	1	1238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kXMC7iEYYMoDoWFm9qMUzX9NXFSS4m7EtPGtTvksriyv1y2p
36265	payment	2133	2133	1874	1	1	4249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1o7YuSGqHMokXR9wTH3xBBhhdg2kBJyBK8DuaZ9f1MP2UDv5
36266	payment	2134	2134	1874	1	1	4463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykvsY88AUGRzkqYiBofKbBd7hyz5x6vd6eDJbD4DgeryPni2S
36267	payment	2106	2106	1448	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqNRT2UwvxVeqdFASrcScuieMV1H49F34DTxtV4RyQWiQ958R
36268	payment	1397	1397	1678	1	1	14021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuB78ke2ncaKpVVjDMrfVbTTfkzdEhg1fhgYYyXSCuyhHQE7N
36269	payment	2133	2133	1874	1	1	4250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uBtY4MXYyCzK8dYVso35Fymh2i9jusrXWZgbqHHtuVvAREar
36270	payment	2134	2134	1874	1	1	4464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6jMiPG53XNuRECz86BYpr7FkjSLGzqeXamC5ktidnLW4CGHt
36291	payment	1448	1448	449	1	1	15	212000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgBir45SY9qXXLKn3Vb8rm2aEgpqgTsVsGY7mVihfm4EE2ZAX
36292	payment	1397	1397	1678	1	1	14028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyop8W7HF3tgc6AiBr4eHvNsJLoAmPDi9GjL3gP4jL2yCJieM
36293	payment	2133	2133	1874	1	1	4257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEiFDgny5EDvmod4S3gJPBMGpZ2FtwoXFjsLagLA1V4XonFnM
36294	payment	2134	2134	1874	1	1	4470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2H1Za9qZqQUJLuNpyBeAqSTVe55uRMoVxzKrbZ2xWPwpB1gs
36295	payment	1397	1397	1678	1	1	14029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBFGgaGbUsLWLK61svySBrw5vu7N4mjYcRV6mf8LAhgXBM4Xo
36296	payment	2133	2133	1874	1	1	4258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXq7RCiNnL5ZPbFFBZqWaF58KHVa4mY95yhG3hQfNgQXC7kmY
36297	payment	2134	2134	1874	1	1	4471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11KGanAu1DvgoeVUXCAYXSn3QUvArV4h1kCF19AqGCe2CFZnS
36133	payment	1397	1397	1678	1	1	13984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMEMd8x7q2XoxCw9z5wR4TW5agpry3apR8NdSe9pp1GHnwMSX
36134	payment	1397	1397	1678	1	1	13985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkHP93WKB8hwK3NQBNi9cf6p3BiyYmfWGQxx7ngKqd2mv6QCM
36135	payment	2132	2132	1874	1	1	1227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiVCHgvgG4r7ZUdcJ4xmWWcaKR4h3Zi7Aa8Rkwkkrq1hv7FY1
36136	payment	2134	2134	1874	1	1	4425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNGTtDVc2cSCUuGNRDdN7CDz7wXdCZak93n3tqd2SoyDCS2Zf
36137	payment	2133	2133	1874	1	1	4211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzKWpo2yCdi5sooT3akTZQVMqfMZ8T8xbUkgBBiLgd5MDaTaL
36138	payment	2133	2133	1874	1	1	4212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3UXrRkA69CpY9BKGqnNHFCVUNykrzrgZLduvPbxrTUxi1BrH
36139	payment	2134	2134	1874	1	1	4426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJLrU744NpgaLFsXQoHx7dDSZaR42VzYk5VNmsi4DA4xcgqw1
36150	payment	2134	2134	1874	1	1	4430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjquxTL3VLGwRep68qX476YNSUJF4SSVYgTnBkFB7WsvWn45Gh
36235	payment	1397	1397	1678	1	1	14012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWi3TecuHrPeJMDAYWADaFpiP2Pm7doXekQvv5doNAn85rtmU
36236	payment	2133	2133	1874	1	1	4240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbaxjdkcTMGe5D7G9DsqcVVsAndHw9m7HLGjXgcVKhN8KhbD9
36237	payment	2134	2134	1874	1	1	4454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywCENdnkC8yYJZ6eDo4E1QpNbjVXbtSrDWdCBM9nUtYo3Yyue
36245	payment	1397	1397	1678	1	1	14015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhC8jCRmDfFtMZz6PvmWZtpXziUeqfoiB4uK3tg2J7z6zzk39R
36246	payment	1397	1397	1678	1	1	14016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LuuzapWD2pVbZbX8MCP16fPARUy9zgiQHsQ1gh1GWxiS3Dvg
36247	payment	2134	2134	1874	1	1	4457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1a98XaHd1Fg48YEkiT4sLGNoWVHgTcATwStSW37RrXWy7uFnG
36248	payment	2133	2133	1874	1	1	4243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuECn45g7HMMbJ7sL5et49sicaMHtcjBDPaxFEWBYLfWK7vmG9
36249	payment	2133	2133	1874	1	1	4244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wLYnG3cPRj5exXfSmj62fwXnMzwikgeVcg19xaabVNq8E9za
36250	payment	2134	2134	1874	1	1	4458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wCXNCDJf9epz9Sd7qosAkiuqssDcu1KrBoFQTCn88y6ZrFeq
36257	payment	1397	1397	1678	1	1	14018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoDH6V8ZQkoJWnNSZ2RieiT5t5NmmJgVj2vbfDbaT8WoFh9mC
36258	payment	1397	1397	1678	1	1	14019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FJ8tgcgCdfsiQyqxYB1ww777WHrvVB9ZW3nMKSsGNDPFDe6D
36259	payment	2134	2134	1874	1	1	4461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhP7L4W54k2qaGXTCiTUDqipct7bpWUjvjBUqFDdbGyF1j1qkq
36260	payment	2133	2133	1874	1	1	4247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmGfeh57LVD7wGodvMqTePJTuTayqHKzZG9d86FiabHBKYaqk
36261	payment	2133	2133	1874	1	1	4248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaibZQ5fV8pH1iG6Y2xpdrqdmU1m5vEgGv11eA44G5ZbaATxv
36262	payment	2134	2134	1874	1	1	4462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqkRxMtBHeqJKaqAUP4VnFLnTGgQH47C1rSC9XvhPGiqf7fcC
36271	payment	1397	1397	1678	1	1	14022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDpC6z6ikvXWzCcPXtffYCJsGfKLSYnVqryiQF4MExtKLzHig
36272	payment	1397	1397	1678	1	1	14023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgU5LS6VHNLpM6zNofETQ5FdGShRZvfSXJBcp1tD5ZrKz1kZD
36273	payment	2133	2133	1874	1	1	4251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GeZuuXrgihj4WJXaaD4SULJrwZzhcNW3irmWtFHhY986CzBQ
36274	payment	2132	2132	1874	1	1	1239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqZdGVy4ctexMFaqEksEjvYHdbSWErpH7qiA4PkAoqWM4v7BH
36275	payment	2133	2133	1874	1	1	4252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgonJRd5WyW9HAh6ArvMMPayzsAaxV7YgBqb1PcUwBPgiaJ5co
36276	payment	2134	2134	1874	1	1	4465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTvLR8JHpTxutPFRLFwgNomz2T48NFhBTQuK43rsXred2BscE
36284	payment	1397	1397	1678	1	1	14026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhL98DPQ81Mxx7WgVBbgkbK12BfQHvCbSveBoxo1Y5TLQ1pHq
36285	payment	2134	2134	1874	1	1	4468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbxxBZaoXncDoYkzwhSw65XhhrezYU4iovwvJcNjfA4DZHD2L
36286	payment	2132	2132	1874	1	1	1240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1UGX6rnBokfvsbyBuR69GtpJzsVH9tGvQNgzfaMAH5TtkZxD
36287	payment	2133	2133	1874	1	1	4255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjH85fU5AMEamGyzkiHfZ6vTJjjxJZVtd2cXwYV3GWys3Xbrj
36288	payment	1397	1397	1678	1	1	14027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDhjqj5ngjpyoD89EP17NJCNXyfQbtxZzhu5yoMEVaZQB9Udy
36289	payment	2133	2133	1874	1	1	4256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvDFn4dRzqbaGrstiwCFQhkm9ypGnfqTYvYtaBM8mYd6PkNBD
36290	payment	2134	2134	1874	1	1	4469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvoVcmJUbCy5oiUE38zXiYHxrpirmZ15HZppNkw62tiAcRH1eM
36325	payment	1397	1397	1678	1	1	14038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQfyrFg7rv8yPanJejvmx9P4kdDR5MP7bHUi8VnBYb5d48nHR
36326	payment	2134	2134	1874	1	1	4480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfk12NxBwWSAzRUoYUCWqkxjBcJ9h1ha4nb1E8okuhp9qoJoGX
36173	payment	2133	2133	1874	1	1	4223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BqwFaAFB87QkaGuH4CiuP34JfoBcx4ZekAyCs4gHmNifD6p8
36174	payment	2134	2134	1874	1	1	4437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6TqCgSk9ur32r9t1wNv9f7a7RCPaHSWpLDQWnCZygCw1SoSu
36205	payment	1397	1397	1678	1	1	14003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqfWR4xmZ3EGwCec59ekvhWQmAoJ6D21oYbLfmthgHELoqeFo
36206	payment	1397	1397	1678	1	1	14004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cakEoqUtqosDMFRBnaDnuWBiKWMvqYQnt4EcDBhc97jxb1Vr
36207	payment	2132	2132	1874	1	1	1233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiBw23ZxEGQmcrCozuXYJtfiN2EQdXTaJZCzfNUcKTrnqtFFq
36208	payment	2133	2133	1874	1	1	4231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7UYLXUYaH4uMV29feu9p6otoMiLNjPTm5vaKnUKtZL5s8eJ7
36209	payment	2133	2133	1874	1	1	4232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHMmH12HXu8UhcmrXfgbW2jiWWrowM3FQDnuiAdWvGxzy1gAD
36210	payment	2134	2134	1874	1	1	4445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7hin7AnY8mq2Fmediw9LovmZYqukbHBLtz9mBw8rMJPVLDha
36211	payment	2134	2134	1874	1	1	4446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryfi1Fi2DGpEGcc5v3Jk1waRaWt1HBuK9nJFs2Xvb7dTZZd65
36212	payment	1397	1397	1678	1	1	14005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDx3PGPa9JaiyBJ8BtywhdQeNvQeB363b3ciFPVvGyy92ToAv
36213	payment	1397	1397	1678	1	1	14006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiBHVBZqAfdLhTiMJKHfDpTtcb9G2X4Ch1sg51GS4Cuw1gdhN
36214	payment	1397	1397	1678	1	1	14007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJwr6aBKEhKu5H7aDqLN5nQoCnmuxQRRofvpAMo4psb4pJVyK3
36215	payment	2132	2132	1874	1	1	1234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpXAeNsfRFAEgJbgBwHRG3wnJDBBaU68awQ7vLWUfeK33me71
36216	payment	2133	2133	1874	1	1	4233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaPX6mZ9R8CTnxxFbhGT5oRk8fcwzKFqadPnnjRFa1xZyPnjb
36217	payment	2133	2133	1874	1	1	4234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMyv4cHWEGZSbJKB8koPWwLrDRLRpgMQnSfvF6gRCo1k41Yir
36218	payment	2133	2133	1874	1	1	4235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7SVxWuwZGwtkKjiRv5cEZYXE34avRKR7SWAnuTaNgqibbSSX
36219	payment	2134	2134	1874	1	1	4447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHArDHi3Zatj2KREeWUJcN2R4dpdbXpYUhCASrh7xjfhtCcYyn
36220	payment	2134	2134	1874	1	1	4448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSN7UyxMhoZLZ2PJKxRVJ7XDwzH1k3Qpj6yekLQg2MbWT96qU
36221	payment	2134	2134	1874	1	1	4449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJEEh4RMbpxTNJEVhEwPhtxq65Hou1AhPiUCSpijWa7qLw4rk
36222	payment	1397	1397	1678	1	1	14008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2boosyQ9fvutUsdMbwSgBZ93QBbMPsYTfKfJMcSvBjmCSq7xN
36223	payment	2134	2134	1874	1	1	4450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWirMA9C3BsLRuCaHFZTEuYjmTRW27A4m543fkgKx9LEHHDzWh
36224	payment	2133	2133	1874	1	1	4236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bchU7EXGTShLqW7JJBAQJZdiesFAaUQeW64NpVE2RSDZJKYe
36228	payment	1397	1397	1678	1	1	14010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGc17aE86XdXrsR1u2yEnQFHbdLysqn7HGsja7No4wyf2mBbg
36229	payment	2134	2134	1874	1	1	4452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfv1Mmv198xJvi5EuYK6eKwjTHjfwokSdmsvQpXRZEbbhNE3P
36230	payment	2133	2133	1874	1	1	4238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLqdWy9ETvuQ2bzb7JZwzNAYE46BefV3dLgRsX7YzQ1YN88ff
36238	payment	1397	1397	1678	1	1	14013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6VYN4rAPcNdR7WScPy7tW5umxvWhq1Vn3xt4GxnSpRX7D1Cs
36239	payment	1397	1397	1678	1	1	14014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaaPaxkf7f5inrYPcTMpZF4b5UuPNouZzszTvVYqAtoFmHR5E
36240	payment	2132	2132	1874	1	1	1236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhnGsuDJAKfEKMyah9C2j8Urb3Wi43kUtfkJDNbHtMXdDs9y8
36241	payment	2133	2133	1874	1	1	4241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMA7Yrf63Ud4zjiZH5zhBtf2Asd5oMFpm5HxRL7HEQmFos7VwM
36242	payment	2133	2133	1874	1	1	4242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHq5jwdSKiZJr4SaDiB4vJnhC4YvXQSnyeiHXnRiGDTnPqrRL
36243	payment	2134	2134	1874	1	1	4455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PCjws5f4y57drwYzXydPXf23YaSnBEuhwj2fYcmkUDZp3T3W
36244	payment	2134	2134	1874	1	1	4456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7911J9Vy2RsSp7RdkPjuhZ5W85Y3bfzW3Qr8vN3PKUSCk1b3
36251	payment	1397	1397	1678	1	1	14017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG83y113xSCJsoAZYzUHg6SLxqqxCDPE9grzWuZCK8ZsdRGdDg
36252	payment	2134	2134	1874	1	1	4459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4Dc1VagBLjDQuQ8VDyi8YquVhjYhjJXjg6Jci7LK7fEJDi7t
36253	payment	2132	2132	1874	1	1	1237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTJR5sCHj7PTd74r8X6BBMu6pwUa8NSVbxufnyMuzQwD9Ynup
36254	payment	2134	2134	1874	1	1	4460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZippgUG8oDNiHmXdELBtihw6pn8JuRdV3XzbUaJ8Ra2eoZzTUc
36255	payment	2133	2133	1874	1	1	4245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn6MJc32mvymx1L8uLstB5VA7X3RzHCy6i7iGNXQkjtPpPsca
36256	payment	2133	2133	1874	1	1	4246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3MB8P6qrFZSHoTrpe8Zrf7LnNnf7o35K89iQJ56rviDNBoRa
36178	payment	1397	1397	1678	1	1	13997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hszU84GGZ3zXV19DZgEx2FMKJLAjPYLLnQcrRVS2C166MSH2
36179	payment	1397	1397	1678	1	1	13998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYet4PfVEew5LQniWdCi8yK3ZgHcsRRidroFctFe28mzMjjL562
36180	payment	1397	1397	1678	1	1	13999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxckURYq9y3ZEYZWAK9FJv3jXQZ1Nu6tPejdG61YUcxu97osf
36181	payment	1448	1448	945	1	1	8	1609000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MtzHDC5U9iyLmkkzEx5JEKaT9fYRNF1U2GGgUyCJdhTCJ8hj
36182	payment	1448	1448	1065	1	1	9	2884000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpqq9nM6J4E41w7JoWnDMwqf8vEyroEUjD3ewgJhXn32foWaK
36183	payment	1448	1448	1185	1	1	10	1946000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBkmmXWFxvZTMRgzWC66UQKQ7oentuxA2kHFvngSCjKTg3Ntf
36184	payment	1448	1448	1311	1	1	11	5421000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2RTiNTTU9qgfSa7sCerqVFpFdN6EXdfjQgpdtnrMEdg1TDvV
36185	payment	1448	1448	489	1	1	12	212000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nvnkqRKC35UmQuyjJwWJTNPrDitRz1TbxtaYifqRWcV2wFN9
36186	payment	2134	2134	1874	1	1	4439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFiV5ci5HP8VsBCDDBq32Zj5gA75FY826xpytFYDmkskuzNym
36187	payment	2133	2133	1874	1	1	4225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVzmwa8qLXEmYb9RnyB1UV2eFycc5WnkcuMUA7RXVVjBBjDnL
36188	payment	2133	2133	1874	1	1	4226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cWL1coi3tpyCtZnxJnMDkUA7sDBeVF6i7g7AjGJGxRr6f3M7
36189	payment	2133	2133	1874	1	1	4227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x8tZc5uHzQoGU6j1KGreoQEVazwjdF8vtE24yd6JJnRLNn69
36190	payment	2134	2134	1874	1	1	4440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWDkc9TzhXRdqFeh1AkPDYqoGntghTJZgGnXPKvacXZT4rMUd
36191	payment	2134	2134	1874	1	1	4441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSgPPa8fZYXLBPbB6bdixyttybLvae37RGaS2soX6RCf7ioae
36192	payment	2132	2132	1874	1	1	1231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzhPg8eZP4ZkGd3YuqoyimU5fv8FmPUeoa85u5xatxn1YWrzH
36193	payment	1397	1397	1678	1	1	14000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEzJgyg3o4KWhebyqcDq7Lf4aNgPmmrTDAVAb9XS5NDERfyJwY
36194	payment	2134	2134	1874	1	1	4442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQVsErQZkYPYJdY1Xj1mf8TZjNiUi1QK72r7x6njaNjArGuPF
36195	payment	2133	2133	1874	1	1	4228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqCCsN8TZrX6VoApE2Ry1F1uS3poJYRDqbaJ9xLGg4sgjPr3U
36203	payment	1448	1448	741	1	1	13	16000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHi3C9GGiuYcAYBduTWb2kBKaE6siLMQmqYeTxxDu3hkJSEag
36204	payment	1448	1448	730	1	1	14	16000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQSthuExPEVw7QHrLC1NYK1NSpDvTqWSzBK9hjYo3JVL34HFk
36231	payment	1397	1397	1678	1	1	14011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93gUMpnz5z4gSnUCRv79g1n37SLsZmttMioFbC5eww33YiTxb
36232	payment	2133	2133	1874	1	1	4239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzti3S1iYigVaMLJJajJR1EpcAnrRYdC9acBfA7x9RwJgoyDE
36233	payment	2134	2134	1874	1	1	4453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmV4qCq87X3qoX5UHvhtnys77AN7aYLijEHTk4KghNwpVhLJ8
36234	payment	2132	2132	1874	1	1	1235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ARusdiAAgzoGedFPLZvAiyd45Bg1Ay6gMsERKjiMR9vwaKwm
36298	payment	1397	1397	1678	1	1	14030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkACEmky5h2VeLHatCjtcDZmJJYJkqBfTKv5v2tDebaxxtwK6f
36299	payment	2132	2132	1874	1	1	1241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBAjqYQKVnodEA673AryFE5ekcU5yVs74HUPx93QWAp5CJoMe
36300	payment	2133	2133	1874	1	1	4259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNkMcgk2jwm12UV8oo5xBzYhCGKjYtCuxFhtL2AeG3u3jkcGk
36301	payment	2134	2134	1874	1	1	4472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMcbHDf4an9xVDHWTiXPk6yYv1mDDeF73Upq3bBJPEzcYfku1
36302	payment	1397	1397	1678	1	1	14031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHNUGWbrsV9r1SKjeZPrXC2kqckKJYggZgrKgUnH18PNzVZ93
36303	payment	2133	2133	1874	1	1	4260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPAJEAqdx6sgcayPgFBUKhKHMdbhjTtUTF2emKSyU3YkQca7q
36304	payment	2134	2134	1874	1	1	4473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTYRYed1XtdaSruERsLweiHvUpAB3vFtMQsJxeuGKMBunbNJ9
36312	payment	1397	1397	1678	1	1	14034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvHhKApUhGRkFhYMGYjF3r69qosDBSan1EC9Vzs4hu8FixdHa
36313	payment	1397	1397	1678	1	1	14035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73M52V8WejXDCLCTnrvGbduwmnjNDxg3ajbizrdypTSi3cHRJ
36314	payment	2134	2134	1874	1	1	4476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UVYfPbezuyxK6BdaNtrFXUUNHz3SCUdDHrXVma3M7cEErRWC
36315	payment	2133	2133	1874	1	1	4263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2YRyiB6cyVz2h1nvi27erweuQ3LjxSwSa4tt5qyNHXks7QU4
36316	payment	2133	2133	1874	1	1	4264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQJ36QwfZeFroWaNRfmuVd7dWVhCjXRkDcopZ1KJT4Y91YkDK
36317	payment	2134	2134	1874	1	1	4477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuhCoN6TF42AMgZRDavchGWt4hikLLsst8bQeQqFTRVxkoPra
36347	payment	1397	1397	1678	1	1	14043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3JpffhmSzukiFSnUxkhi6fEKo9bR3vXPDLv6ApuawtRLypxc
36277	payment	1397	1397	1678	1	1	14024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12xSjJzojrdDLUfw9ymtAtHvMeiGzTdW3TLd3cqwhoGY5fbAq
36278	payment	2106	2106	1448	1	1	1	5759000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcqRKo7DfTxSPAMSPj8BjqTeRpn9cgQ5Ee3bqowHyAfV66sdDV
36279	payment	2133	2133	1874	1	1	4253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsraZeAxgFEwmSGYVcLosZmjsrYJzWfHCet4kYbXVjDc3M8ghG
36280	payment	2134	2134	1874	1	1	4466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93SA1Zwn3fmmwpVw2h8KTyknSgf884zXrE1QXVgQV4AcLneYg
36281	payment	1397	1397	1678	1	1	14025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11TUD4WVnfrnUVaff9XAWvpvM6T32d2fxYHRgycQSfeABtBPi
36282	payment	2133	2133	1874	1	1	4254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDxVt6rjiB3FWFSTV8fprFwtwEAvbPJmyV39ek6xKzLZ2kFyn
36283	payment	2134	2134	1874	1	1	4467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYckvtscbSGBKyZ5XrYyeEStiBvVFKH19isFEJU2VH3j4mES3K
36308	payment	1397	1397	1678	1	1	14033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtnM25X8G4CcqcVxoDmdXLfDH9wLmouGy7yNbcgHbmWvPnxEK
36309	payment	2132	2132	1874	1	1	1242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSw6iiB2cFXQRPtVWmHgeX8MScW8Rw4TqQ58cithSpDLGokLX
36310	payment	2133	2133	1874	1	1	4262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uF97bjbNsMqsb4CF4RqCZjibcgpkLhDWeiVaSm35Bsfm2wRZ
36311	payment	2134	2134	1874	1	1	4475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpaJtoJFPkH9QYVNQfA24aoSwWWbMADrQzsh1EDPPehaYpoms
36318	payment	1397	1397	1678	1	1	14036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfBweQWrEMeaSK1Z4v6X5u1fHwzgVjdVi7wrrfumaytirZSXg
36319	payment	1397	1397	1678	1	1	14037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXD71MNRQ7A5eJhjspeyFaNYK68ShT2pd6JH3gQgzvzTqteu1
36320	payment	2132	2132	1874	1	1	1243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCx8Yta4EvaKkuW2T2BcwQ8dN4EQdwAEGfMQF9xeYQet3Denwf
36321	payment	2134	2134	1874	1	1	4478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsso42svjLKQJwwvmRcW8rMbsYk5BRDvWKxhooytUQxnBXL8ad
36322	payment	2134	2134	1874	1	1	4479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9QWhFoDv7um8AM1fMzDNGLNHDBhoazdP9irxCrxSmqoKEt6S
36323	payment	2133	2133	1874	1	1	4265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4GAXBtw7gAibNVeVp579bAPTZc3rrzAbZdaX6uRWv5kXLvAA7
36324	payment	2133	2133	1874	1	1	4266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUv8n8HDwahyFcTGZhvNBnVSbb6mNyWRHnmF94Hk6h4rwU6RZ8
36360	payment	1397	1397	1678	1	1	14047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jTpbMhH8pU6ubsh7VNovRoRPkR7H7yiPwGq42PCiAJihNiwE
36361	payment	1397	1397	1678	1	1	14048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMjzCi5gPTpgqdgL4URGmVWDLSFiuEhFEoYUGNZA2AadCXxYb
36362	payment	2134	2134	1874	1	1	4489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZjZMfsLErrBetYSyFCCnx1MGHiW13bMofDW1Y4EMNu3csGTa
36363	payment	2133	2133	1874	1	1	4275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFQVarpXXEEmR89yEjKCjB4MabfcQmUBbXBLzo3d9SRz3z3cs
36364	payment	2133	2133	1874	1	1	4276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxJmdcQVxG1KUkFffEkoGk98fwVmAEV8Gc8p2rWWCSQjKtemG
36365	payment	2134	2134	1874	1	1	4490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7wK3gV9dDmsrdZiU58GK16GgwAoEfPiB9YjnJ5YfCW92e2Ec
36373	payment	1397	1397	1678	1	1	14051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxRcdwr6kE8TbLUBaMR38uLNsWEn7pqgSzpyeXvoS8C9nJ4my
36374	payment	1397	1397	1678	1	1	14052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNwfHLQdCGgw2grjaGEJ1beiNmvyxkcXsJssfaHWeNd2rmBAc
36375	payment	1397	1397	1678	1	1	14053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeGmedrdF96bFyVynTrmgp2AM3Fgpv9kHet1md8srUQv1bkze
36376	payment	2058	2058	2059	1	1	7	720000	2000000	65535	E4YfNhcFGhzepDr2rpFtdHPupyPZxKT1KBCHGW67DSmN2Gwp3Pn9x	CkpaBUCkR45ndfg2rRQzvTTg9RAZyecQGP5W5KY4xGJHuUgPHfUT8
36377	payment	2132	2132	1874	1	1	1248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjfC7zuveZBaw6f9giNQZGLgDVK6eRtiUMJgS4YHRjCz6qqeH
36378	payment	2133	2133	1874	1	1	4279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUKqQzQa5dnGhgkvJM6ym8kTZf36uLgXu5zv3eL5rCPP9czXm
36379	payment	2133	2133	1874	1	1	4280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrLxN5xFis898hLMrbf4ykdMXgHbZjFYgvmQvFG1HW35KaYVB
36380	payment	2133	2133	1874	1	1	4281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo6J8WQNUkzhDjffsQdXxDHCsWyeNULbiH7eEx642w1eqCU8y
36390	payment	1397	1397	1678	1	1	14056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqUzrX1UFDGoexfokD3nNcRDSf853xvU7yBYtHXLeC9uGf7Ph
36391	payment	1397	1397	1678	1	1	14057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpP2Bw9AKHP8wm1aN9saeFoYnDww1Ud9Fz8C4vp2zVYVYXGcak
36392	payment	2133	2133	1874	1	1	4284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpgsdk8PGz8CQEijnikgdP4JFFwyojV9KPKtKLaqjjMHhbUR7C
36393	payment	2133	2133	1874	1	1	4285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVGbeJD1AA33resUeEJVYQvho7tU9PuBUNhWL8n5hjdkLMLDZ
36394	payment	2134	2134	1874	1	1	4498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnJG5Vt9PkkLvSAZZmgmbmuNvsG7cn3ojYW7dVGeTMfbEDWiF
36395	payment	2134	2134	1874	1	1	4499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrCFWyJEPfhVz6xpBowYwV7JZ1uKN2qbg2GEVQm3nnzrPBaLb
36305	payment	1397	1397	1678	1	1	14032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4UXP7zTyt811tJDnvAtCiXsmKzWWYKyMVN2tgiqYax3uuoNq
36306	payment	2133	2133	1874	1	1	4261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoAUAw5Cs3ncy5mBeMY2fbk3gqKAf8uNA4aUiHEt25eU5fFgC
36307	payment	2134	2134	1874	1	1	4474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCtSMGGen5FSeVis2n2Bxar3rBRKnrUCcq7X5BC4At68t1M59
36327	payment	1571	1571	38	1	1	41	60133319501	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZJ3jmWAB1awdToR7hbxqm6L36wTzEFdy2rdQ8Xmssr9vCpVf7c
36328	payment	1571	1571	969	1	1	42	454723066176	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZoLmxTdW6p3z3AwK4h9ALv1p2XFgYKDQhmB6uryzoCkbwf6YFX
36329	payment	1571	1571	1089	1	1	43	814859838524	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa2w3owJoAkBudDhWyDS8cwV3soMtxMtWS8Y6HK5hNoYpREW2bK
36330	payment	1571	1571	1209	1	1	44	549802170281	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYgti3jrw6nku8gt8zYfwYPK29utszmJgzkmqMiYcaCt2gTze35
36331	payment	1571	1571	1335	1	1	45	1532072633172	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZmM5SV54Vt95SqpyAh2snHjJhcGmu9qnegrRDyo6Jj7hoJxhDw
36332	payment	1571	1571	1571	1	1	46	8872572333	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa7VyFXo5rQmjKXxDWUpHN8LGrKAnWtCahzNGPfkutGAfECW4KP
36333	payment	1397	1397	1678	1	1	14039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGt19rjw4M1gDZt15HcGYT41xAhziwT7VDaKYnh6CXFP7XabK9
36334	payment	1397	1397	1678	1	1	14040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdffVLtX3J6gcTWq4XWnBWw89fkWQqkFx7ihFwzcSQpCm58R54
36335	payment	2133	2133	1874	1	1	4267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqcv8o2XcQcdgaC25mc4eESjVb1RDjzz8SFPTUK4AQfPW9dJx
36336	payment	2134	2134	1874	1	1	4481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdccae4sRMvbdJu8CgM1JqMhmYzRHzqnedo4BCBcUyVUB8sxP
36337	payment	2132	2132	1874	1	1	1244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUPU6AwWiqA3yAG2df75zYvT1pR6qaRqZ9Fsp6JJ1XWSHup5N
36338	payment	2133	2133	1874	1	1	4268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8a1yiyRPkFAD4SEbLaNdW4Sk9LPZ72UsLcCMrVCmVK7ejjTA
36339	payment	2133	2133	1874	1	1	4269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1q55tzk3wL9brEmSdURLpbeaRFuiKHAAU1uTJrTeoVn4sTrW
36340	payment	2134	2134	1874	1	1	4482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidahAENMaUatao6WKTuBKKPJK8sLPL1wxqnN7hZHKqAtaNWWk
36341	payment	1397	1397	1678	1	1	14041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyx5RJacy8QqvDZaL6FtiLRFvkwCRBuwQW5s3khr4ny7vTBH5
36342	payment	2134	2134	1874	1	1	4483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrCNVXEtDtH8dUi5gCLYekEq3r2sRBMFVzoVjnUxZ85oLugGR
36343	payment	2133	2133	1874	1	1	4270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNdCm2NySkVi7svhGHRN2fh5wbCW1RwufZRuHNXJmu31xhM5j
36346	payment	2134	2134	1874	1	1	4484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq34W7S3ricmuVmAzwoF6H1xi3Ssf3J24MoWMNiVGWQbBU491C
36366	payment	1397	1397	1678	1	1	14049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3i5AoRJRGpEp8CuSemfUR7CnAbPred9s4h9uuaP27VKppJWmo
36367	payment	2134	2134	1874	1	1	4491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2zGX3k3jcy19dsH2pBgUcBenCQ2prQmfjGykYDUz4cvCg5ZS
36368	payment	2133	2133	1874	1	1	4277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2LSQBvX46mEZuW3B4pV7u5LEgdwPWC2Ye7djGWVbGLR4esW2
36407	payment	1397	1397	1678	1	1	14061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyS6PEqugCd1MCKXQgj7yGGg6CFAHPpjfeRmM5YxB74uiAjBy
36408	payment	2133	2133	1874	1	1	4289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwg1ZiKKMovtajykJVx5BGBF61D3rNPPMLp8guxB59JZfcme9
36413	payment	1397	1397	1678	1	1	14063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzR8Jhg1gnCeMtrA4kRk9rLXgLsT2fZyikXWEMixHdUbWc1Q6Y
36414	payment	1397	1397	1678	1	1	14064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLRZBtERWX5kmNhwnUDzQvjWczEmsAiD9KuhyXLCrw7ETFgx4
36415	payment	2132	2132	1874	1	1	1251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevriEY5rMXuhSCx6NWdnSUJAu9skapjRERdwYDkUuxieMuwoy
36416	payment	2134	2134	1874	1	1	4505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmS9qKq4hpNXAAHeGNEhY6sqw2LDjg4LDcQmQwRRHQoDxLKFD1
36417	payment	2133	2133	1874	1	1	4291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvi3w78a15guyS6ptLKE1fj9dErrR7dmbVpnQk9r6iLpoM35R6
36418	payment	2134	2134	1874	1	1	4506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKXHyMdMYiKpUHnvHqa5CkhfCR3Ecs5fckp9rb2gQtY8Wu1zr
36419	payment	2133	2133	1874	1	1	4292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FoY5UXAeumdp12pRGxsHrpbrSYa4j7iXotE4FCaf79szB9Gr
36429	payment	1397	1397	1678	1	1	14067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnbtufbrXHtoUb9vsR5Lz8HTi7F6mErTSVSWjAG1BgWn1kQzB
36430	payment	2133	2133	1874	1	1	4296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazAHGRirueHKEo7PC4jjemRFGCuwLhYpkPY2G5WSK2eBT9BXT
36431	payment	2134	2134	1874	1	1	4510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgmPFdxiCNQjod1UWn45yXokEc41w9KApnoQC6L42Gg19mxnp
36445	payment	1397	1397	1678	1	1	14072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNrErFWPnTQfeJ1zhh7ZE999fkRyTCnLra5rhEkxCYqno2dzA
36446	payment	2132	2132	1874	1	1	1254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRcGYMybZgeVBf7NszRnS8tg1sp1y3wPMvvg2px8aNXdmg8qn
36344	payment	1397	1397	1678	1	1	14042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhDpHqwNUdLUmJe2vXokoQnx7Kyha4Go2Z7yDP1Lwqjr4NwuH
36345	payment	2133	2133	1874	1	1	4271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17Y3yorf9z2w2K3pozYxoPktCQTiBg8QAcjN6uwpsmxGky2KP
36369	payment	1397	1397	1678	1	1	14050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xfhEssGzEPGr8ZCgHcuWExWUZRHHCM8CVPwwWUXLnXv8nbWy
36370	payment	2132	2132	1874	1	1	1247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUpFVvg1N9ZNkPRoKo9LEuWoSsmXZReaFczydPFYsQnDRiPhr
36371	payment	2134	2134	1874	1	1	4492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZZoqJUr9SSRusaYXNVQZRzbCq5V3ZpSHooX9mLKzKiRgs1Gu
36372	payment	2133	2133	1874	1	1	4278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowBvE6ETAAMaRZToCvPH88YttMJqeCtMEkbskaKCvXmpUt8go
36381	payment	2134	2134	1874	1	1	4493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQD2ji7zGR7b95SnVCacQqf5UuDLz9z6c2D5FCA3mnVZ72fAW
36382	payment	2134	2134	1874	1	1	4494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcJEDJEcwYZcVuj99ZErc23auxyEmU9VPXY9y64H7hAPCqrVJ
36383	payment	2134	2134	1874	1	1	4495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfuD3RtaXE8kXnbeFjrvYyf2aaiYRvaojGpYbUxrtg3hDTpir
36384	payment	1397	1397	1678	1	1	14054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuFH7cVL2YNg2GqGJR5XrDq6tAoNuGTZxCP4T1qmKE8NTRDDfy
36385	payment	1397	1397	1678	1	1	14055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZBLvsDyaRPonqUUoaDe6zZLYnz4yXk99Tms9ows9LhVBVjjX
36386	payment	2134	2134	1874	1	1	4496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTWZhPbH15qWA4tv9vJtL5exSgthsHJQbp8Ty1tRSThbyqd7i
36387	payment	2134	2134	1874	1	1	4497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspuexEgTVuiCytPvhWS5rZfYLdWdigLNEgU5NyyfCG4kNVDgJ
36388	payment	2133	2133	1874	1	1	4282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNrxsEVYtySr4XdGmQQ4Yjtm2VpxYqt38AmWoSxvtVGi2UezP
36389	payment	2133	2133	1874	1	1	4283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgikhrd4G4w7CtCuyb1Z4L7pxMESJXS1Tj145XFTuajoZvmWA
36397	payment	1397	1397	1678	1	1	14058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJVZtu2exZhPLKGWU4SXAKJBi5En6MhFcFmgdKjYcKJhxCFMd
36398	payment	2134	2134	1874	1	1	4500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQ75FLtXVuDiWoQmcpmXfKMPWhvEaGCbBEB7tVPxtZyePjqmz
36399	payment	2133	2133	1874	1	1	4286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHietm7M5AQ269LLpKDg4tDssGYCmL23zxdJEDqfzzQVvMnb1
36420	payment	1397	1397	1678	1	1	14065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhVhkH9givDpXhH51YRsc5t3cf6A2ddZS6bKniz2BVyY6FcLZ
36421	payment	1397	1397	1678	1	1	14066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXmkb5LQEPaHZYAF7SQicUTnjerAoY29R2avCGT5YrNP1Lw9Q
36422	payment	2134	2134	1874	1	1	4507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfv7tSKxviB7xm12fUzoBurozNzBoNjdQgKkF1Y4xBKpAdWuH
36423	payment	2134	2134	1874	1	1	4508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEQYKWXyVmUEhxQJ54f6HAaAt3VVueZP6X4ob92AuswhqKMov
36424	payment	2133	2133	1874	1	1	4293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh259JEqt7m9JzeGYysV9eZDNY5awrfr6SBHKRm94sYBkTWVhL
36425	payment	2133	2133	1874	1	1	4294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92Ewq9nLoZ7fjqKdh7TJ1gVn6mQPL1dC52ocHkuKVNUrQhfkS
36426	payment	2133	2133	1874	1	1	4295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpekcdRUMDjhAVLPHJcstrd1aW4mP36UZqxZmfWBQbJiJ9LiV
36427	payment	2134	2134	1874	1	1	4509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjcYzeQU7U5CDkygM2EJEmNHu2vsoBcke64qD6wdGwaHGccqK
36428	payment	2132	2132	1874	1	1	1252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9xp4dvjMy7S9p45psCxN4yHguU4yNZNMP57Z4eu2Y8XucWi9
36432	payment	1397	1397	1678	1	1	14068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jY7fpBToLyYQdksPvPBoFbM1VZy9Qy3Wdfbrr5EX6T4T8mva
36433	payment	1397	1397	1678	1	1	14069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYoP6gC65zUv4jyisUZ5YcfQJdP2CD9YnrLyddpJyg6npBULMT
36434	payment	2132	2132	1874	1	1	1253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYxrVzL2MzYrnBYFseQApwMQC3Zc5b3P7FPVbdEokYCTVjVqc
36435	payment	2133	2133	1874	1	1	4297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9um96sGfkuY3xVJMPb7LmTETE71n1R3WVBqUWH98Tt5qJ5wr
36436	payment	2133	2133	1874	1	1	4298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvLTxBaYxJhQxMkdnrv2bU5WrYukDazNXDKgFc9T52p3pCetQ
36437	payment	2134	2134	1874	1	1	4511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEFwZqvevLDudnsNdq5imrvpmEzv9eV6Nkf2Smt6oa5Py7dyg
36438	payment	2134	2134	1874	1	1	4512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4W6LBPQwpHESsUokBsy41wRPTeD1V2ys6BEWVTbCp87pzDLT
36439	payment	1397	1397	1678	1	1	14070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5eXjiwewAU6zuUV6a76nwQnajxA6UoPncn7TA9NpdPQMysvp
36440	payment	2133	2133	1874	1	1	4299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8k87is1mNw6aDxHp5bGe4KdErbCQbhKNvBCDjMhANi9AqRQw
36441	payment	2134	2134	1874	1	1	4513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5wd9vDqiRUeFbk2wnehHHi3HJbDSoiGT3ni2WZh5JGJ36j4t
36449	payment	42	42	1361	1	1	8	4300581600000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYx8r9WKXoAEyf2Vz7tiZqNeKxtgz3MQjFUpz32EfVqS3xECGu
36348	payment	2134	2134	1874	1	1	4485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfxVVtgsrHnzEuikVbWUXcx8GogmZZJeCk6CSwfThXLtU3M5d
36349	payment	2132	2132	1874	1	1	1245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWr6L5zmG5BQdibXBww7wonfKo12zkvk8JPE9K8azp3xXFdMs
36350	payment	1397	1397	1678	1	1	14044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqWvuVUhiDna2WPvJroLaJ7Z8CrtNaeyqnJtJDuhXDp9ZQTVJ
36351	payment	1397	1397	1678	1	1	14045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXpBh6hUsUztqWV5q6M4oU3xe997nz3sGUVHHSF7H1F6UPAY2
36352	payment	1397	1397	1678	1	1	14046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBLRHpGQuYcv3zPCufzbNmB5oQVm3o3pNqjLm8cUgw6FjjbYB
36353	payment	2133	2133	1874	1	1	4272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZu9VjPAkcmhDhx5KbfMvyVmmKbK2Rb1cvxwnNq4bVo9B7xyY
36354	payment	2133	2133	1874	1	1	4273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64DAxnmVGb8Vr7Pmz9WFdEbCct1Fktd1Bd37PLWZJG8pjTezf
36355	payment	2133	2133	1874	1	1	4274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEC9JNCAEmR5fQjhreEZEmvKLdqr8Z2176ZEnPwgDmESjSfGN
36356	payment	2134	2134	1874	1	1	4486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2XcZeTp1iVhfBkYfzKASS6PSnaLgff3z8jpaq7opudBgkQ3j
36357	payment	2134	2134	1874	1	1	4487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pWNs7cNoCKA4MwsVR2NCGD8S8AiGnUyJVmDkH9sfi99cfFN1
36358	payment	2132	2132	1874	1	1	1246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJ4qx3jgZDiVYfjtUUPm5HoY8iaWRZNvjL7pim2ZySiqYZyGT
36359	payment	2134	2134	1874	1	1	4488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzT8KJ697t5HAEmnZz62d54yfc2vGiEYWBkNWBsxGti1Dqiw4L
36409	payment	2134	2134	1874	1	1	4503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5taoupFFUqtEvyaUAUrRvATpmcTzhcM3LegktWcgSpzR3jhHR
36410	payment	1397	1397	1678	1	1	14062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ovAUWfdirw6gNmN3g5Lpo95LJ477N3CJ39W6NeCvmcjMPt9k
36411	payment	2133	2133	1874	1	1	4290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun13bbksQg5dYEcVWnHqiJPWCL6Ha22hR7ftJLAAZF5CmTGYL
36412	payment	2134	2134	1874	1	1	4504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxaRQMJ4oRW6tXuPEZ51NvVz6TYeeHd79wbFrjZUGB5cZebyFG
36456	payment	1397	1397	1678	1	1	14074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkgsa7Cs8BWFn5VZzRUcfYvjW6TFPyEjKN2er8KxGuEuppUUE
36457	payment	2133	2133	1874	1	1	4303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RJsRAXzubsTMNuHcRwQj5mgVjGKZc3pC6k6fDx9ubiFttSi8
36458	payment	2134	2134	1874	1	1	4517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2quRYkReqg2aww9Zdy7Qou5ggppYcTWUqcZ3rUehiLX7yc6S
36459	payment	1397	1397	1678	1	1	14075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3StB25iaWzmqbDLbSxPpK7wqHP64V5v8ZCx3GFuaj4PxsytkW
36460	payment	1397	1397	1678	1	1	14076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLJYhvL1AHs2VwAL9PcL9kogiEby2qT8Lp3RWHBCRuoXwzd3y
36461	payment	1397	1397	1678	1	1	14077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtof4n6fXTCW7cQTyDS7ksrNuNNJ7zEj4zq6FkQ3zEaVpjEiHE
36462	payment	2132	2132	1874	1	1	1255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7cYRK1Ym4b23kkqpuVHA1AmAGgdFiLHzShCNo64S5BhtJCba
36463	payment	2134	2134	1874	1	1	4518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5WVK7nKU66KNSmsGc6LQFjgHHBtWNtwmJaFfDJ6KjnVtitQ6
36464	payment	2134	2134	1874	1	1	4519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1tgg5LXBWwtkxs9yA9Ndc74VhHxaSC7vVNaQTVudio5AzVEB
36465	payment	2133	2133	1874	1	1	4304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGHsWgEhdaHBNV47TsGBmMzQFEZbuea9b8LX29M5WUpxESAMFe
36466	payment	2133	2133	1874	1	1	4305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoD7pdHTPtBLE9ZczYktxAGE1E2yMwo7UGwAveNCVSCydMuTjN
36467	payment	2134	2134	1874	1	1	4520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQ9fGWCN7GAVguviFhZfxmKdEoJrt8GjaTRhH9YvAv8MttfFk
36468	payment	2133	2133	1874	1	1	4306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WPmndvFkjsxuv8x5v6gnVNeuUafxCHNCajAFtKSr1L8tX5kd
36469	payment	1397	1397	1678	1	1	14078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLksvqfGTsjAjzF6k2tn698BVn2p8DEEon6FE9MMdCh5o6qUb
36470	payment	2133	2133	1874	1	1	4307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJqywEkmWNfszCiaFfmZThVC1fBiyu2dHySJdri1bmkQH6W1F
36471	payment	2134	2134	1874	1	1	4521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTqg7nxQRUThoyg86VXDmZVG2xWb6nj89p5EUZzEMhio63dUo
36476	payment	1397	1397	1678	1	1	14080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAt4VeNKSq93JR6scTEGHKp5iiRgjpczMAXK6QeAqFEhuzv71c
36481	payment	1397	1397	1678	1	1	14082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdCjZHimpJSDabxuCfRpoVUQxxBNoxYJtYXhp1ytc1p2aSh2F
36482	payment	1397	1397	1678	1	1	14083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AQusXNpPPV88Qwxv7D9VJAK4fkCMBMTSAfwvNXaUWLgEyowE
36483	payment	2134	2134	1874	1	1	4524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYAju9hsmaehW77ZZcd8K3KeETNgR8ikG6Y9WGtcnpfMen3Eu
36484	payment	2134	2134	1874	1	1	4525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6sPpUiaYpe6xQLmkypxRkw4UkLxZKSjUUSmYy7gLjibecRx9
36485	payment	2132	2132	1874	1	1	1257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnTT5sYK8pyxfq8Da4ucXToc7Dttu8PnKmDLUn6UgAUMpgpJ2
36396	payment	2132	2132	1874	1	1	1249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gftf4vf5g2Va258R4GHy9sA1CgrSJFK1Eu2CEWQfG2Y9RDV2
36400	payment	1397	1397	1678	1	1	14059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRScY9uBkqrVzN7h4t51fJ3bMCMBLSQWk1LogoXNpXCxJyuJPo
36401	payment	1397	1397	1678	1	1	14060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHE6PUiLKW5H4rVDoeGHE4qu4c6yzCwFQmzswmHXqjQQqK44M
36402	payment	2134	2134	1874	1	1	4501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCetWWSsJBKtkigHexLCja8V8fkcn1K8YduqaK6SV599wCWsA
36403	payment	2133	2133	1874	1	1	4287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTyZxRzNTJLW8EvbpGwS5uQfN12Qh8LVsF5qeJN7e7TBLGhTD
36404	payment	2133	2133	1874	1	1	4288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oABuMiEDUJBFb4AUhse7K1JMBFhuZPmc1Div7MNFnShbavt2
36405	payment	2134	2134	1874	1	1	4502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNUc5ZPrkPpdaZCeF294wqfWcdSqVaxZNkpuJ4YmHh1FyPY6p
36406	payment	2132	2132	1874	1	1	1250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxP3RygxNRsxPz6ytG3V9EvK5huGs9uyKGZQp1WC5ejLvY6TtN
36442	payment	1397	1397	1678	1	1	14071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXfbhn4nCFKrwE5SCSKvx3sk3PsTAfaAJ4vFQji4zp6JNad2k
36443	payment	2133	2133	1874	1	1	4300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdbdjekPs3T2wyf74w7eAwD3ogugeZtZYKrm2dr1AYN5hKnhVk
36444	payment	2134	2134	1874	1	1	4514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7K54Yqb4HtVDNB5Taj41gCQGB2y9ZSz6fUN9ey3UWXr7iLcpk
36477	payment	2133	2133	1874	1	1	4309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCFxHKvoMkBwgzit7N2Tcc24gzTF2CPHadgNyubsbFYNiecD7
36515	payment	1397	1397	1678	1	1	14091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPbYKwNAWTSBfYRPxCjNe1NNDHvSphoTXNtSA2bMSaVevGR2U
36516	payment	2133	2133	1874	1	1	4320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDPXoDA29SGYsyQnxYsKWrpvik4s3EjgqQaGwHGYRNMTHMBRg
36517	payment	2134	2134	1874	1	1	4533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJq5jvVT2qBmRP3fF7vXD2Ak7ACPK6mF1rrLHSAE1MC43WMqz
36528	payment	1397	1397	1678	1	1	14095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqw3ioDhmPRXdJZSLXR6o92YugGLbyi8G55TX6U7sVkveMdbNp
36529	payment	2134	2134	1874	1	1	4537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7ZaCvupoGjG7wwFqnGVYPWYy6GZbS7BbWxbCxcc78DuGCETL
36530	payment	2132	2132	1874	1	1	1261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1ecqHp6d3RJgxwVtiji8T22LKGoF2PCjW8GfVKzLhYbSZuAU
36531	payment	2133	2133	1874	1	1	4324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i3GHKbYpe4cHH7xcFFmemNQtrtU1QJhBHAmt7M2MprpTZVCp
36556	payment	1397	1397	1678	1	1	14103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2n3axhwJeZAEcZMfwiM9hJZeYfLw752QRRVrGkgc8RvucRF98
36557	payment	1397	1397	1678	1	1	14104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarNfw4hS8N1CNmoUNPvBVscJXM66tQ4cAJAQ4bkzP8ZWaV5KV
36558	payment	2134	2134	1874	1	1	4545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1W5gYKfmRWB6BSjSkMhTeNd6UWcMWSAxPeXw5gqyxjB6PcFP
36559	payment	2134	2134	1874	1	1	4546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoGS9jNqcQTHDBndX86Br2u3NFMLzBmseDvuqGrPUYdXfC9Be
36560	payment	2133	2133	1874	1	1	4332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eLVjqRBASnXtFfmRhbq6Es5RGHT3oQ2HTHwshsjA4dBNrmZw
36561	payment	2133	2133	1874	1	1	4333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEkgFppEYaVqMWvXnb1KvND9wmHB5JMzNwh6aKWGbxinjMdeX
36562	payment	1746	1746	2309	1	1	6	2741644000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FBtbETFUDRro6QQDmMWRc8jP5WtzNzUtwJmGwL85NJkpVGDB
36569	payment	2133	2133	1874	1	1	4335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZafVk3buQYth52WvMgwjzU265MnKAfeG3YvtUUye3J1pHcTLMu
36570	payment	1397	1397	1678	1	1	14107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zEHF3RuBcUL2pfAXuajB43VCMJBPo6iDzaVNtnBnZqeJMPDx
36571	payment	2133	2133	1874	1	1	4336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYheY9rvkiYtfMjJpHit8z5MkDQWvQhnmBKMrvWPefJcoS7Pmnv
36572	payment	2134	2134	1874	1	1	4549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoV9iLYoZAUDzpWRuzAEGZfz1YDK1kPYxLfLL3ufBsfDa9aKGz
36580	payment	1397	1397	1678	1	1	14110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVTLd9oWarUatbmjVDY8kyTdVGXWV7PfKmvhtZpztQD4rNWNR
36581	payment	1397	1397	1678	1	1	14111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQhmE4N2nZkSyJzU7tmtB1FEpaJjKqSnciqAzSXmTJe9fjzi8
36582	payment	2134	2134	1874	1	1	4552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQA8zA9ch5Mw2Ej9xLhwcuEwiAge8ajAiPFChiKeAQFGq2vARB
36583	payment	2133	2133	1874	1	1	4339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQCfZDPLWCDh5xQGdoF1zsXxjw9SA4dwRbXXJweYYuoGHtKSN
36584	payment	2133	2133	1874	1	1	4340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6X9DGSDoWnYxiyvzCZw8E9eqWCTLH3cLKoznHhrTKe26Az2WZ
36585	payment	2134	2134	1874	1	1	4553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQLgdeQxHTWzWiZkg2Engnxq7Gz11Gc3uX4DmHgBx6sgXn8Cv
36609	payment	1397	1397	1678	1	1	14119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGCNaPtDy3DwQ3rotuVmoxTXh7spZAwdVE5VJ2XpJtacarkPb
36610	payment	1397	1397	1678	1	1	14120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNNws6aaWxTLFsQHiNmRUSsxq7qjnno5Af3Ht8gn3FjEUBXzH
36447	payment	2133	2133	1874	1	1	4301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqx3UQDarpSWxXu42tY6jupDkc9yYVDTkEn7MF8r8SnLcf9oz
36448	payment	2134	2134	1874	1	1	4515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxZKcxq2RuE2Xhom3iFyWZuKGUdhtUX2CFgs9dMEynYMEtzq1
36478	payment	1397	1397	1678	1	1	14081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ktEk6oyKMzqfCQXCF36ScbqNmcoPPqo6FUeayZDvZz4VE1FQ
36479	payment	2133	2133	1874	1	1	4310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZ1DNVqzFVK8umht6wmEv6qSKHtN1HKXrFpeWDbh9PbZ8A1tH
36480	payment	2134	2134	1874	1	1	4523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fBz1b3DcpjFWuM3qXkppyYzRPzAP1JSqFxkB8PtxAnDh2GrU
36491	payment	1397	1397	1678	1	1	14085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzHpxTDjCC1zxNGVqAwv7fkiJhsYptCikgRbLuo8zWqQEQ3Yw
36492	payment	2134	2134	1874	1	1	4527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyKr5RvC4uJnfMoaiBDHrCyxomHCVFxAsAP767NX1NceXaWe4
36493	payment	2132	2132	1874	1	1	1258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4osQSE1smnvm7tHuRswSVoy5aG6766xwhZv3XVV9FLo6XjDr
36494	payment	2133	2133	1874	1	1	4314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAE4tTQ4jqpXdaKzNKUqpL9NYgdqW8qcmU5RwnhpVnsuJdh4Li
36532	payment	1397	1397	1678	1	1	14096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgzPZZdPY1kzVtbYh6JLamZVMg8uFJRaKyrsfZ8tiYF7iiwt7
36533	payment	2134	2134	1874	1	1	4538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XGYL4g5Ub6FRFwo5AcQoMeiHMPMAAKbq2EUeGp2wSGkenWQ2
36534	payment	2133	2133	1874	1	1	4325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME73vTU9vkggvQkDWo4AC5oNAhHKZrUYTZPHVQdFLAj5bhjw6
36538	payment	1397	1397	1678	1	1	14098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxN6okdhg4QLpwdwwXctu8EfpgEdAAGP4KYCh8zZFneWFBbM1
36539	payment	1397	1397	1678	1	1	14099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LWpz7TZA1w3Vr4WuEVUe62eGB7E5XrUMRg1QBCwYyccD5rLi
36540	payment	2132	2132	1874	1	1	1262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieCqMNoAHqBHjXNYakUQ3QffcweM2kHmsdEZhNVK61LSYbX1z
36541	payment	2133	2133	1874	1	1	4327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXAD4LWTTNfDQ6tfdvwMqJMvCsKzbBUypdLK1JnomSHzZYmRf
36542	payment	2133	2133	1874	1	1	4328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ19BeLp8WauE8y9r1A55bj8EV1k9QAE8puL6Y3sFqMLDBS8n
36543	payment	2134	2134	1874	1	1	4540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4373nVUAHmpT9AvBEyy5ktzjGVV32aah5WduyDFSd8WdiMgA
36544	payment	2134	2134	1874	1	1	4541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkDPxVJgkcUWeiWmWgUTf1mTzJAaeXrXiBrvowhxdSSo6J5sUY
36573	payment	1397	1397	1678	1	1	14108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUe4EcBZZnZ5T51HXY7x8wuz9Y63Q135MtFExfCMrhbVqijMK8
36574	payment	2133	2133	1874	1	1	4337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkswknb4m9FJNBrHuVNRSnVUefMoS4q8VWGfG4jRU24LgKVEa6
36575	payment	2134	2134	1874	1	1	4550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYnXsxM2sxKZmsyUs6H1kytYyNP5n49L5a9WVFuQWmPAdH7co
36586	payment	1397	1397	1678	1	1	14112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUGpGFma8uB89kedr9aLPYwhYGXGfgEtYzdmMwNXk9B8Wsjbi
36587	payment	2132	2132	1874	1	1	1266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj85E1jPqbdem7jL2jVWv9vPtvZsZrZxXGPyvqNX4TyyGTrDRu
36588	payment	2134	2134	1874	1	1	4554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7K79jpmVk81dQGy2mxhWCLfx5FzsEoQNps82bPeUKA3Wjoge
36589	payment	2133	2133	1874	1	1	4341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL13oCj2XFmUe3mUQBtihFPPUQFgotHES9kPmLjoTYZDgfyW12
36593	payment	1397	1397	1678	1	1	14114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYCcUaXRPe5LYfXpcBNfs5XkcZ2GjLm9ihGx1ihgU5ff6iPFC
36594	payment	1397	1397	1678	1	1	14115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb71KqT9msJE2dKbQei1so4ggPiX6ETasr2Vdj279qxkoqoUX
36595	payment	2133	2133	1874	1	1	4343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopBReWKxUJ8jQyEfYEee8KbMxjQjMmyGWaodyhH43oPobps1J
36596	payment	2132	2132	1874	1	1	1267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABwY4B8b5YyTngJnrSrqQ34sWCo7CYEPCFXxu3BDnpjFuf9di
36597	payment	2133	2133	1874	1	1	4344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMZSpXeBwAQudqS47Wk8eS1sFatvHAN7qjbDb2hGfUjiturAG
36598	payment	2134	2134	1874	1	1	4556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKRU1eaTvqrmjsbQkpodegNuirgGa3RCTVcfJo97QTpHsgVVA
36599	payment	2134	2134	1874	1	1	4557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7iEk5KyhruD273MZwPEVZpxpA6Ad6LS8EBYNWhh3osSFiByb
36600	payment	1397	1397	1678	1	1	14116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8pUzHu9SjqpiieGNmNE7xo5iwMxyWTeQcbsvNj3EeDKa1eGM
36601	payment	2133	2133	1874	1	1	4345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNX41wWVaUEUMXytiA1QXK5qZP4PHjGr8uC3YJ9rQKH3otqvX
36602	payment	2134	2134	1874	1	1	4558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkpGidiZGxxQSRB1cTGG7u4PjATtNoaKopu6CRiGwTA2rL4dJ
36624	payment	1397	1397	1678	1	1	14123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61FAejcZDLy33JPbKNWsmrVdsP8TMPdQ8mN4AdxdX4sh5i7nD
36625	payment	2134	2134	1874	1	1	4565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwUseAxHryufAz7iBeGZGxGJkN73deuzCu7CeBrf8DWifNniX
36450	payment	42	42	1115	1	1	9	2287706400000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVgKk4uXJvMbYYcNuxvDhirQQ2F8VeWBkyV7NAHtBYXmNMshn
36451	payment	42	42	1235	1	1	10	1543651200000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQKbvoJ6UTHDADXLwdTNHjDTdSBpcUb7NqLZduhgSs8yntN82
36452	payment	42	42	995	1	1	11	1276480800000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabZi79xuTrEVjvvqA5wSVUG26SQ9aN1Nq2KPZozaBh9KfDapW
36453	payment	1397	1397	1678	1	1	14073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahNYamVJLUFE5acW4MRAQwbtH4MzFqZhK299LGZ5rZtL8QsEK
36454	payment	2134	2134	1874	1	1	4516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFNjCTfaybuHvUjRbMELWhFqkonCWHcRz4AJ51nDiAUDVJwWh
36455	payment	2133	2133	1874	1	1	4302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBAnUo8MZfZFUDGxpd1pDD4vHrRi5B86Y2BMHkxUDSt9e7ZLw
36472	payment	1397	1397	1678	1	1	14079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWLFbCppf6CyAXNjYXGnWuS8fbbym4bpWTxq3tnGUicF53XyZ
36473	payment	2132	2132	1874	1	1	1256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKnYhz41RV29WtgAL44A8E5TFwYu22uJpefQq95GrcaEBJTx6
36474	payment	2133	2133	1874	1	1	4308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xdBEAP7bhAXZuQJBfi7ywk6PRZLarib6w9Z6C4DbvfYRjqNZ
36475	payment	2134	2134	1874	1	1	4522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSXQis7J8Ne7ER1JYB3w3t727cpLp5kSFD68KqmBtjb89wxcn
36488	payment	1397	1397	1678	1	1	14084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioBbx4v9eucqoLDKaASdin7muvHbdiqkSJytP2uHWWnRoaGd1
36489	payment	2134	2134	1874	1	1	4526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk63GaETbjzDaRSS8pH7xdLUpytNuVP3dbcq9Vw6WyB5gexM84
36490	payment	2133	2133	1874	1	1	4313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6eZuRnXEa56SqdCgoFse4jqCidQ9S3YVdiM4siBge7XxbLJy
36503	payment	1397	1397	1678	1	1	14088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxjt5tvp2E7reXpuaYuNNP2N3HsAM8Puu5BdsL7sAqBj3X7GM
36504	payment	1397	1397	1678	1	1	14089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1z9aJFucfuahgECAGHFrzHi1Eq9z94YynPHpQDZKaGVRikfEV
36505	payment	1746	1746	1075	1	1	3	4569000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYX5eEurirm83uPYkhG1B7AUZDAyUXmdTSghU3xTquFLr4Buak2
36506	payment	2133	2133	1874	1	1	4317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oESksU9Pgv3eaj1hq7VSVPTuUKjbZUFPdBVkUZeKZg23bzGk
36507	payment	2133	2133	1874	1	1	4318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDADXdsbYpRxweNcFfiS2gzXTfDfYXv371RVhsLeWXbnnh7GU
36508	payment	1746	1746	1195	1	1	4	3083000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZqGfjUgpURziQ2joUhSWQ9h8qSaddSWfixtMu877d7Uv6vHxgF
36509	payment	2134	2134	1874	1	1	4530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4e5LWNFVQQFzjebZiyHuMYLBnwMaA3p9voqKQ7MuZQHgAvp5t
36510	payment	2134	2134	1874	1	1	4531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Q7KcpjEzkmpjPVzcorKH3EEtjni5fTHcjX4GSZeHkENP86cZ
36511	payment	2132	2132	1874	1	1	1259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjsrbwfowJhgGFDzKBDuhQdC3iq3QsZYbrMECfNaPtyXpDmCi
36518	payment	1397	1397	1678	1	1	14092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FS1E1NNMHrTkA1e2Y4NvK6Ejq5jmyBYsomL2M4euQDoMUFVM
36519	payment	1397	1397	1678	1	1	14093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Q5iQ65TXCrZpU8xDiwsBRNyLXd1WKfqVYyEdV7cgU5PdcXzW
36520	payment	2134	2134	1874	1	1	4534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8ighaazgxsS2cBbWtCbMnDGWAzhDSapR22mqL3aT1qdrsZP2
36521	payment	2134	2134	1874	1	1	4535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4uD2gD7xe15tG5ax9LWnAB7AcrqK2Y6PxmESdx6gEGB4MdEj
36522	payment	2133	2133	1874	1	1	4321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwTPMCXw5mc7U6yhWcEGZq4ux1sTbx6rdXPnFQYvZUFagzQMH
36523	payment	2133	2133	1874	1	1	4322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xmJcA2DCr7ZjVSm5WAJRZYyxKuYwzJFrsQ4MdeRKRzR7jbt3
36524	payment	2132	2132	1874	1	1	1260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpJPNJYogq3cyUGa5HScC4oGE2K9EegtprYYe7RsnuzfeJecD
36563	payment	1397	1397	1678	1	1	14105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACiwKA8WMTsQkbZtqCLTXUhXcY2J5pn7PSis3iQuyRLZTYm3H
36564	payment	2133	2133	1874	1	1	4334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp1vEsKg11ym1sSG9szKp7H9MrREL3xwrYjdgWVtQpErjmrwF
36565	payment	2134	2134	1874	1	1	4547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8N4zQhviszU359UDuHUJVKe3evKad4bkU9ibwMbYAizAo1K2b
36566	payment	2132	2132	1874	1	1	1264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PySBX8onF4BHUZev1NKPErTcrGGuX5D8FqJ9nitodJyyGxmY
36592	payment	2133	2133	1874	1	1	4342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEQUtAuQVmHF5iF3o56NHTsRPNaQEbiEA2Zfr9BGAqauddmTk
36617	payment	1397	1397	1678	1	1	14121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RyoUKmhL1rURnXXJFJ7w7rMsqtKXqrdn1TSwbddyHKMcehuG
36618	payment	1397	1397	1678	1	1	14122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZGPzJBN1u5R2LANjAnxHJ4oC2fwkUJP8KZxS1sYSDqDDVe67
36619	payment	2134	2134	1874	1	1	4563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKmW3vzn4apcbmDnZWur24trjyzXuGPGjRoktVEXBD7HBipgY
36620	payment	2134	2134	1874	1	1	4564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzj2ysM9m3XWunDoaBR3hGLSr36LQgCdsCqw5zQ6SMouo83Zf2
36486	payment	2133	2133	1874	1	1	4311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKHaLf1pCCw58JfbNrxi2LzirFbwRuejtvcWJu2F7XBELSkLp
36487	payment	2133	2133	1874	1	1	4312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHnzPZ4hQRiT34VDtEcQ1n1tvXFYdVBfAsQcpVHctX9X33Uuh
36495	payment	1397	1397	1678	1	1	14086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1i7LNW6BcMxi8kadG1eWmpkGPANbzAKkrywTqPHe5unnQwFa
36496	payment	1397	1397	1678	1	1	14087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWScG35qTURTPkTQTRuAD3FR5aH5XS9Uqg7v4BwGbzA5U3pmx
36497	payment	1747	1747	1321	1	1	5	8591000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYQRPikVpgfXdYEEcUhgmou6Km7PnsvT5TRnBB9WgS65seeADa5
36498	payment	1746	1746	955	1	1	2	2550000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZM8bJiuN4B9s7f6kyyxd6RfJNnR4bYFjkCjZ5U9yNWQLidvhKf
36499	payment	2134	2134	1874	1	1	4528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTNiP6h6PsAgKbaPX8KPtnLWuaBao3sJVrFqk2jnwB3ssjnRD
36500	payment	2134	2134	1874	1	1	4529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GFSRLYXZD29S9biLZnwKWitYcjWPJYWkgjEP1YFqiUqw7Hor
36501	payment	2133	2133	1874	1	1	4315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKo2PgKsrh9jvg4owqa1XJJwHdtGv5wHuXpnAwcVxPBhTYe2o
36502	payment	2133	2133	1874	1	1	4316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLgnoCdCYAgL1FpxxdZKJxErxkvoEbL44fc2LFtfAzJBqEmvt
36512	payment	1397	1397	1678	1	1	14090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBM4oRgyEFQXcqFuKXJ7zGZ1A7vJ2j1rR2RYxp3ARVEmUfLqA
36513	payment	2133	2133	1874	1	1	4319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjckGK7x3io8zpYrAVVsnZsMmy6gEVsJtFHv2dHXsH7L2MkTy
36514	payment	2134	2134	1874	1	1	4532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzAYB9GQHZuuWozXZYoegNH2MGohFp1GRAFUvd1YMx1y7vDeC
36525	payment	1397	1397	1678	1	1	14094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXF2qxHE15epgcgSwX4j4g3Lr483GrfUdHJ2svtbS7tEXPwEki
36526	payment	2133	2133	1874	1	1	4323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYGENdSfprk9RffVjmvNurLsxyJz4ysKfJwuZQy8okQBBN381
36527	payment	2134	2134	1874	1	1	4536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5mt6TY1GhX3b6iFo6dmAbJgPbxdwpJwL8yg1TpnfC2mDuLte
36535	payment	1397	1397	1678	1	1	14097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6b3K9hCTUBE6WfiZCqYG5pjTvwg45v5WRreceQrDcgpHFymH
36536	payment	2133	2133	1874	1	1	4326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnGeGd8BbyVHoqcGS7btbGWd7tcK7EKWcwaoNPDEvUWE422jx
36537	payment	2134	2134	1874	1	1	4539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83VGxqfQteUVz5YXz4Mutkadh9Gu1ZTy8qnkbAUGRKLFPb4i4
36545	payment	1397	1397	1678	1	1	14100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaQUa1Kfe9gTKhaSfSUC3bDKxZ1EjmunJtzVv6AZwZApCZMEL
36546	payment	1397	1397	1678	1	1	14101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3VGJXwZoFmQ5xZshetZ1tZB7R6eRVAvRt7k3xd85AS4mm4yy
36547	payment	1397	1397	1678	1	1	14102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGRCdBvXQiWBu5LG4xVhN1Y8i6nBwWPtBLqiimDjTmN3JJJEt
36548	payment	2133	2133	1874	1	1	4329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVyJGuiWVxvna5iqsVej1qjksEqP8LVGefNSUFpq7Atn5Ug3cw
36549	payment	2132	2132	1874	1	1	1263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFeuksMRG26VwmWEcuZLhPkv679Wos6uZhyFo1xdjKhrnhHXW
36550	payment	2134	2134	1874	1	1	4542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNN3vF5U66jf8PrkR8s75VJfBdJboYNkuh7pMWmHPd3T94bp4
36551	payment	2134	2134	1874	1	1	4543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTj2W9HqqXB5uE85uGwZqBxgPxpkUuUmFhMDJ8yKmJ9dJeJjnb
36552	payment	2134	2134	1874	1	1	4544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTaUgLF9vhyBjYjRR7P971WEFAJgtFRLjuia7wPDvSrwNZvZE
36553	payment	2133	2133	1874	1	1	4330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGCEMUHNAEsvciWr7hzNCbZRP8q64XYHpCV3pvGziYCjbUrbt
36554	payment	2133	2133	1874	1	1	4331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp48U8nEEjLdHrg7onNdguxZrwxtjfLvEdhSJUzyq94ycggwf
36555	payment	1746	1746	2309	1	1	5	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUh3w1DShagg4jRjUNnAscbNomURAM215bHSegHdZCHMRUqet
36567	payment	1397	1397	1678	1	1	14106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kJLDDsnPK314UQRAgBf7vWMx9T1KK8SttezsJPE9boAYjDPK
36568	payment	2134	2134	1874	1	1	4548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAS1LF6fyqJTw2MjwXDdPUevjy88C3vNehuoe5NnarM3wVoUW
36576	payment	1397	1397	1678	1	1	14109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiu8LJEMLN9YxLYC4h2JrUsf1qqcB2MR3qD6ypjaKscdpmi7S6
36577	payment	2132	2132	1874	1	1	1265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMzznewohqsD4hg5eamfphHF6QATrqvGr8zvRo4YxzG5cTCTq
36578	payment	2134	2134	1874	1	1	4551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuchHzuVKScXPmXoN7n3FFF6uP76QGRw3tJ3o4iRSXF67432af
36579	payment	2133	2133	1874	1	1	4338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoLduCKSd7Sdskzpz3Ky3bqTeBK3WRnJFnvSo6ZLnpxXgVGLH
36590	payment	1397	1397	1678	1	1	14113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYVxuTUnXa68hc9PMiXMGcUv5ePcz4Tv2uYRaTtA8tkfiNShC
36591	payment	2134	2134	1874	1	1	4555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnduJzKrzyrJBDEXtDQaHDcBdyXPZb5HmFGCMp1uHuY7ryPJt
36603	payment	1397	1397	1678	1	1	14117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDEwHKCugYnaV2nkzZSdTw8fX4VP5353XRj4xki2Se83sSPQ4
36604	payment	1397	1397	1678	1	1	14118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApVDL6ZEBk1D2GiYQrN4VQeTCYCtrQvPLnBuUCkfzYQXG7jkc
36605	payment	2133	2133	1874	1	1	4346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPY1DwwdGHuA4w9CTkyKNuiJzZxCTYujby2qx94sySwsNKsLr
36606	payment	2133	2133	1874	1	1	4347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECj3Q9qTkrFrSpq5TGAcPPMyGTocSoqvtV2vJbEerGz9C7fop
36607	payment	2134	2134	1874	1	1	4559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLRTL3MFnNo5ecVRYkeJRyiHSsNFibmXNJweTuMnUi6YJ8tuM
36608	payment	2134	2134	1874	1	1	4560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYSs9SLbvCPgqi7XJpEiNPdWWYVLMr38gP6xdAPKnC4fRXBNL
36627	payment	1397	1397	1678	1	1	14124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytcTamBaKTcdp7jyL86Ut3XkaFR8An3tsbZy4wuviAzvwz7g4
36628	payment	1397	1397	1678	1	1	14125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLZb96gufiDgQAWKAJw1SNifNffV6vn9eDw9XZVLEP3CC9v8w
36629	payment	2134	2134	1874	1	1	4566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRzPiaoDdGMrdQ2AsNzbYrAM7xTWRSnXShsHNj41PTcM9qwo7
36630	payment	2133	2133	1874	1	1	4353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZL1Vi4at4kiqD3VakdDJDBzrbPU3xYaWDzSHuGbYdn6g6akN
36631	payment	2133	2133	1874	1	1	4354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1xWnkV7xq6aHKKu49S8V6ZZT1tUUXXg5QkxUFeVBa7824bTe
36632	payment	2132	2132	1874	1	1	1270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q82kaTFAoUoyw4aV2PUuoUQd8nFDXwzS1NFkAdJSVTkKZRRj
36633	payment	2134	2134	1874	1	1	4567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFMamfHraStfurUsFiiUUXW6HD3oUW1bKwqS67W2u1cW3Wrmz
36658	payment	1397	1397	1678	1	1	14133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKVVCTKkvbzeedwuqm7isq8W9ZvTfnkAPBjRoVckvBZAtE1i9
36659	payment	2133	2133	1874	1	1	4362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjAt6kRULZY4GRYq5Eq5nEdPRSvNPGA8GYbLniCvjaZDjmars
36660	payment	2134	2134	1874	1	1	4575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGiDjkPHVeoDqGrtdZQC1zbfTSAD518yN9Yre8hu1hUmMk8eF
36661	payment	2134	2134	1874	1	1	4576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7udXHkz2x7VehX5j3MXaXbRGNdB4w9cDeeg6jfNQ1tyiWaV1
36662	payment	2133	2133	1874	1	1	4363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dBGcwQ7xo2BYPDhQGw9gAkqtoS8nq14fbbBDCWVfjeEWiUHH
36663	payment	1397	1397	1678	1	1	14134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEo6q7CNeZrPqQcqvYFtuz2rq6UjwPVvRnCorKQZHrRQSHDhN
36664	payment	2134	2134	1874	1	1	4577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSTRFzd5nCDq1ivFtkDEE89Xb38KqTGS2cVuZW2d2bJLmntRN
36665	payment	2132	2132	1874	1	1	1273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u3Q8kvnp7UrQBzD1P4wnWvSmhJiWzatxzgZfcbVyN77X1Puc
36666	payment	2133	2133	1874	1	1	4364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaLK3AGNTQJgZ5RqDCG4BkRuqDtwgrUQmmPnhzv3so2cEJhNU
36705	payment	1397	1397	1678	1	1	14147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKESsfG8HPJs66ACfGP7zn4N7QHno28p6FG7yamYEeKt6J65J
36706	payment	2134	2134	1874	1	1	4589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKsZwEPJDKQtif4hDzuY6886s2TdrWArUW9DoVquES5Mbim8K
36707	payment	2133	2133	1874	1	1	4377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoNKkmiitv5udbAWXWKhgjxKFf9GTao9iwfjg6jnH9P1AYYFM
36725	payment	1397	1397	1678	1	1	14153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6q9gPhzFKY4djNicvg7wyKxh8nngnPGTfLRDNdF5WFsV1xs2
36726	payment	2133	2133	1874	1	1	4383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKyDiPwp4bRGBoWD8QNemrY32RaR9FP83e6szie1CSFgAfNUD
36727	payment	2134	2134	1874	1	1	4595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Z6rVL6MuXhaGcTpjMA93PcRRRXnK8F6AXVcwv1jjsA4XYQoZ
36732	payment	1397	1397	1678	1	1	14155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgUnLVRzdRLDsedNRRApSHDavkUoxuVBU5sS7VQGUGYusmRUS
36733	payment	2133	2133	1874	1	1	4385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVV9JgV8ysNs4bhPPFcNqzaZ5469kTFaYGosRNRdCF7vQ3QYo
36734	payment	2134	2134	1874	1	1	4597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucFUDqZJkeHGAgi4VoTa77t4QET1ujjhqCmX5usL7JXTWm1Ad
36735	payment	1397	1397	1678	1	1	14156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGb5KdCTX3tZ3PqMNvosPZ8CQPj5tEKkjP5Z368bSiX2LMj89
36736	payment	2134	2134	1874	1	1	4598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vGGEeqGk8NUV9hPhiGx4KVmj8LXVdNhgkJVT2StdP28et35M
36737	payment	2133	2133	1874	1	1	4386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87dUB2fWce7B74zHcdhVDWQgXks9T5XmbBTr2jMMgMjawYTXz
36751	payment	1397	1397	1678	1	1	14161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yDSZyx9nHTetjSm9rn3WwYAftWAtgiqZAs1byRnxcUBnzbW7
36752	payment	2132	2132	1874	1	1	1281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnpZe6LFwoZ4doo58vBkwZRE4BnS3DgoazM7NfPhbuzKiVckP
36753	payment	2133	2133	1874	1	1	4391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8ugdHhT395dUdoHANpt1bQjR1N1YRN6suxQZzsiZSqCmhzWr
36754	payment	2134	2134	1874	1	1	4603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZVADZ4LpVg1PPVHRUJqm9Qxo97Yn1rFnXdAxZaLShpUdR82z
36611	payment	2132	2132	1874	1	1	1268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYYtCYcGbKEAmYphPZG4AUhPQ5FmarMb6w6BXMXKaVvbWSMMA
36612	payment	2133	2133	1874	1	1	4348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJL2aqCRobCKXRGdbjeeZ376po4DnMirNuHoV1vswSQ3hcrkr
36613	payment	2134	2134	1874	1	1	4561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabdsQER6bcCuSS7CUfE9wkWHTAzEutsF1NPS4d4tULQUohmpb
36614	delegation	2309	2309	1523	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbRPKTmoAwMf6xzQU6aPjMCaVmEUDBCnQcFR8yx1wjouYCpB8
36615	payment	2134	2134	1874	1	1	4562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMmnSPsam8XpfqYXBjh7QtumWHRbgJt8jCsr7GJnNyrXJPiy2
36616	payment	2133	2133	1874	1	1	4349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhcVXzGuURfAYQXTjVAis3Vp5bUoFxQstjB1rByKpwszkb2m6
36653	payment	2058	2058	2059	1	1	8	930000	11000000	65535	E4YXduXJHpgF6kDkDDhiVGB9nQBNMCnYv2chn7LPAYkFfSWSoEtdr	CkpYbjQ6GSDgy3kVVmhgYGzveH76ysTfWVvJMEL4AouaTLm1wsuvP
36654	payment	1397	1397	1678	1	1	14132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTFswfffSHqQVUfBHpqgJygHsWNxeQuFJurEyAtuD4SVFS6Cg
36655	payment	2132	2132	1874	1	1	1272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wK8MqKeGWFDTodw8UGwXeVKfpb6GDVtpF3itX8VwbT3rMxEF
36656	payment	2133	2133	1874	1	1	4361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwMJBNd3XzqitovX5c9UTpFmvSdiqdYb732LQ6uGVeqJWuCyG
36657	payment	2134	2134	1874	1	1	4574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFqixv8YiMj47AdkUfGtqsovj6qzm6FfhR1w6DGYXLYaGG9tSu
36669	payment	1397	1397	1678	1	1	14136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P2HD3T7Lnn5nqs9QbpD64dNFoUD96Ue5UXzNmQCsFq5jCUsf
36670	payment	2134	2134	1874	1	1	4578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4x5SoAQfWn23VMsw58LAcmLaU3g8KoFb17C25cyCp7XUceBka
36671	payment	2133	2133	1874	1	1	4366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJF6yGZWMaZzm49CbKd9cmEpqoGY1GppomtWs9tpaGCu7KKW9b
36712	payment	1397	1397	1678	1	1	14149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb36Fdj5pLwPFEn4mDnc6SF9zd7vVLvs2BmJgewSfWdh5SWod
36713	payment	1397	1397	1678	1	1	14150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpUYr4ExEo3RYzKUqurzDRjzXhRAqJ7i5ghin9HNTB8cB1Zu2
36714	payment	2134	2134	1874	1	1	4591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWdxxqTtP6UAZvriccbGw4oc14sdb28xQmMzNYbxvGJeRSwFXL
36715	payment	2134	2134	1874	1	1	4592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrdEY7KK3BkaMZ43s7ZqZSWNm86hoQVeiBk72tcnCN3eAUqSC
36716	payment	2133	2133	1874	1	1	4379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhbuDtcbAgqR4RbTfXfBgiiXbgbenzDuisKs4WthvsUJ4cneV
36717	payment	2133	2133	1874	1	1	4380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaQqao5Q97yVmh4ZwBBcLbZkCGAzEzBt8Z9HKsGt755f3RJmL
36728	payment	1397	1397	1678	1	1	14154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmcMTVA1cSPMpLajetiKhSLMJA2hB3eMfhd94i1kzSV4VCgCX
36729	payment	2133	2133	1874	1	1	4384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJzwNvN4kKjZPnmRuEJYzutsBaJV2biMgF8wn3mzJGHrjTE3H
36730	payment	2134	2134	1874	1	1	4596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBTGgyzSLjbTmRuqZoX7pj6oEAozBf3UUm132nC8ruYjRwX9T
36731	payment	2132	2132	1874	1	1	1279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z2zUktT7PJUBZRFpfpfd63JxrNpA3v9YafxvhETJ4uy4mRnS
36745	payment	1397	1397	1678	1	1	14159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvpJqjzeevqC2wGXyZDTHTziCng6pEzKj41t5qosb2KGVJ8BF
36746	payment	2134	2134	1874	1	1	4601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBkDbrZoZwgeFhpef3dALhjRPGETor3D6DvGfrMy8XyW4EmKZ
36747	payment	2133	2133	1874	1	1	4389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8TSEffjzk9LPQDx42AfELnsjJyoFqDnxgxiGCGmVMsyncwvn
36755	payment	2133	2133	1874	1	1	4392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdro9i8oN7kRMf6mbHjMoZk6rrUjEMGn3r1RrLKtSqEWKJ2CEJ
36756	payment	2133	2133	1874	1	1	4393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRe1emWGJs4ijf4fqnMdQbjRkjrXyiZcv6xLAWvfBvSj7jcwK
36771	payment	1397	1397	1678	1	1	14167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQzy5MJAHxPhw3cjKgdWYccmPVjzKCveyhVc13TSBueYSZwze
36772	payment	2133	2133	1874	1	1	4397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjGny7tuskCnfQtAvf8Pi4zjJkF5AVeJm8NMKqgUaoapXn1CP
36773	payment	2134	2134	1874	1	1	4609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LBFEQBYLNwY4Xv8enQ6wQEeHHsdNieVWU1s17TCqfTMeBi1Z
36781	payment	1397	1397	1678	1	1	14170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEjz9LZYHrHgdFucczMsHgSSEjHNRjxUagEet6akXuZK8wmgQ
36782	payment	2134	2134	1874	1	1	4612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfmpsh5MYe9sFYiaEvWNJ54vcGS6H5xWQnoSCvL1Msdc5kMt2
36783	payment	2133	2133	1874	1	1	4400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXEQwbWgi8qXBWNVaLHpk8kY4m3MAH8LPH9a31gWLTFKi3Up9
36784	payment	1397	1397	1678	1	1	14171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9anzdc1bxirPmaCsPTBzRKzqWEZUzue36hSM4ncrc8g3TUSwz
36785	payment	2134	2134	1874	1	1	4613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8xXiBdeHjXUzpbWc8Y5z8kZGmG2xSyoqPsDpYDTojX5gPgoV
36786	payment	2132	2132	1874	1	1	1284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirLw3CqsFpXUMt8y4vhTpgfsuQi3fSFpmrGkLDJ1cV21UDw1X
36621	payment	2132	2132	1874	1	1	1269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZpwbvjBnPT9oHqzAiA3vvnuc2x48VWVLmJtXgTAQ3o8CpbYE
36622	payment	2133	2133	1874	1	1	4350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgnfRUYbw1GcDbqbsPM4ntkxWDTBGZGDvSs77y1a8GpWA5mhK
36623	payment	2133	2133	1874	1	1	4351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNwENTeerLMPxHNce8zBtyzDyLJm83as5ra7tdCDHjsAEnbEr
36634	payment	1397	1397	1678	1	1	14126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHMqJf2g74ZgpkFC2f5vCQbozrkxCwfVdpvFof3sw3p5CYNJh
36635	payment	2133	2133	1874	1	1	4355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKaFLinBFmihck5qoxxEPvypiqAuE34C8XfpaCY9yGfRQkyYj
36636	payment	2134	2134	1874	1	1	4568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQifCikTSZJWXJXXjmSYVueiipdpjgF1YzHo5Ndv4HqW9ZM78
36637	payment	1397	1397	1678	1	1	14127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLmAPXfN7fZ9Rc5VJ7af5HR2jtfnFxE61wBCjfg3WigdB4hpx
36638	payment	1397	1397	1678	1	1	14128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEk7aQu1scxQy2yC37UFGXeSRXJSaJxQuRy8jUEHKZTtrHtaR
36639	payment	1397	1397	1678	1	1	14129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BmU7UzSHD4oCvcW4HvJK7a8neTqMuUaqD56zG9Tjr7Spj6KC
36640	payment	2133	2133	1874	1	1	4356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19t8mFAxifWRuBhmNzDEfdY7D62P5r5B47GLPAAJeAoABLcNy
36641	payment	2134	2134	1874	1	1	4569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GcHBLaMyxupZfMFkwrv2BGsHiDD8mAksqEkPyGmkrxBNSE2r
36642	payment	2134	2134	1874	1	1	4570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWA4Cen2y6pt4VXHre9UnwVtnkDZ9t9aPY1iZv66Mgu1VSrPpw
36643	payment	2134	2134	1874	1	1	4571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwYpont8UDVxp6gGDxZhrCon4Ttm8pBxAMqpPp7MXrTKqGtzb
36644	payment	2132	2132	1874	1	1	1271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJ5CAmB91Q9UH4aMhfxbxvK6Dr6dnnk7hXNN5anUzUfshZuXk
36645	payment	2133	2133	1874	1	1	4357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUabZjHH16gBPycjLrNRCCjUuf7jc8EqirpXi2xPZyV72L3Wa
36646	payment	2133	2133	1874	1	1	4358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaegm6cXJNsBb1erBe6RghUhqRU9MEmHqQn2Wz2vL4aKmucUB
36672	payment	1397	1397	1678	1	1	14137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZ2fJBxqJ1YHzUTNjHWWi4JZD8abPoQw79NPWogN4CJDGfigH
36673	payment	1397	1397	1678	1	1	14138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSwockrKDWj13JBuX48sHaqUWtDXtJFXMLXf25hTg4rf4Su17
36674	payment	1397	1397	1678	1	1	14139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfQC6jWwN7Ps3oe5h6HghejaNWatudCk3FLt8pJDp1Ybg2ejx
36675	payment	1397	1397	1678	1	1	14140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwZY8f4JfNVwmaVzds5uFp8RFUwEXNc2eT3tfy5s8qSnWGzU3
36676	payment	1397	1397	1678	1	1	14141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sXdRYenrSMpZYc8RbMaytqLHttKjBV7aR67Ei7JYRQh8GWfk
36677	payment	1397	1397	1678	1	1	14142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwFjTPnG2uchnEWhmnEWYqaNyqRBnYnUFxyy2jJr8vp3xmQL6
36678	payment	1397	1397	1678	1	1	14143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5MCrooXKBrhSk6rvjW81Nms8uV9GXHxBspJQFywgBukmQPZr
36679	payment	2133	2133	1874	1	1	4367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjnqjaCn7ULoEYkGbDJL1fSByWwc4UexBHpe1xJwoXutMijKj
36680	payment	2133	2133	1874	1	1	4368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPHQUrjj8ocxvyZjXLmkSwQXs9ybF5Qpm2umtb8bzpNL6xYgm
36681	payment	2132	2132	1874	1	1	1274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupLpWqu3tPPvJG1yfqHTyfmYbRuqPUV3TD2rvcT8w5Y5pEVdR
36682	payment	2134	2134	1874	1	1	4579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6dsxT9HdifubGXG8KP9nW8WcPaew8P3yZf8r81J11d8889XK
36683	payment	2134	2134	1874	1	1	4580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYZTj3hmpLUYhwYUvE8xVPQkjhMiZbKAQHGFE53rZHzjEyDDE
36684	payment	2134	2134	1874	1	1	4581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN26mV2dSv8ow2sngWw31p7yjnQSRA1M5P2qFNM8Dhayk68YQp
36685	payment	2134	2134	1874	1	1	4582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA53TxFrr67nQ6V2vbGbKJ3qQDyqxPiikNmfmM3FbDQq1Akmzk
36686	payment	2134	2134	1874	1	1	4583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieBRXTF8D9QpbtxHVjWX2tAAkdBzdJ241CpQJ5qDPRBHuyqBE
36687	payment	2132	2132	1874	1	1	1275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSJkrMuZ1R4kGTvU1z6e1MDdiBgkJJBxD7rtxTyPCgk8TDM3
36688	payment	2133	2133	1874	1	1	4369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsqyWqQVkyuxRsFpqqevDHDmQYb1DsqkxSPXEKB3mwxzpUaMG
36689	payment	2133	2133	1874	1	1	4370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqrjdSU4DsNkHsNmXkVH1CUkRLPTxjsPMEwgEb98RUSgxmGbr
36690	payment	2133	2133	1874	1	1	4371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnG2nrQF7F1tpeddTca95ziA1Gmf9HdoSdjnrH5CH2XDVAQCC
36691	payment	2133	2133	1874	1	1	4372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUTPGHVMfyzVH4NWdzCcb9JtqEMUR5cHfufjEDUAWqmKjG6GJ
36692	payment	2133	2133	1874	1	1	4373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7izoB28LuNcNY62LwchzBRuBvPHWUUMkWKXU8RNsrMubnQZyC
36693	payment	2134	2134	1874	1	1	4584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLwei7wBYTqCfC8gsYh7RJFTSuj8FgAAGuYNLWdrpGa1dRs99
36626	payment	2133	2133	1874	1	1	4352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNdmqVyKRF1GPjkeyLsqqCFcrhpR77PLNP5AZgsbwiNStaTCV
36647	payment	1397	1397	1678	1	1	14130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumAoTGGiRnMeGjCneo1TRMepi6VmEgoAPdVMSmWcUU4vQPUWN
36648	payment	1397	1397	1678	1	1	14131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqa9VjQhoMhAdtyqbTdvgYGSt6Vc9xks481v5NJwSKaiNssSgY
36649	payment	2134	2134	1874	1	1	4572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9ciju57CirAQiEstJSU3iesoezqr5fiiteotgYcWcTxvt1jA
36650	payment	2133	2133	1874	1	1	4359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChia9QU6ic8wMHGD4JYgSKNL7ntuoB4nrirbQt5p5YTjuj77y
36651	payment	2133	2133	1874	1	1	4360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMJysPnXRKynVde2p8XeAUx6ewMFRnJr5HLdCBL2jKRiff61q
36652	payment	2134	2134	1874	1	1	4573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiheUha2BkoAGsAnbd5hEx4V7EytzXXbW8ucnkP6Dc8GAACQxm
36667	payment	1397	1397	1678	1	1	14135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCdqkoYhDobH3zFxA7GgfezkLKSyBS55xHbx4FBboGBcjC5Yi
36668	payment	2133	2133	1874	1	1	4365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb8UJSSbsnQ3iWPX5bKd2FvjxeBjq3UHDNSNTmkNSccU9MWkM
36695	payment	1397	1397	1678	1	1	14144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbTpfpg9z4U9de1Y1jmkr2aqb1tSCUFe2taBEp1EwGJD9T1Pv
36696	payment	1397	1397	1678	1	1	14145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqnhS3zfQK7cfbU79kjDa6NTPTPasv3yJ7GbAh15GByNgkggM
36697	payment	2133	2133	1874	1	1	4374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFEBQwBRaNzu17zewayr4AYsKv393sUXt9sRbhMJcZxhLCJ7n
36698	payment	2134	2134	1874	1	1	4586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbGN31foHYTsQuekGkNRDFDXnCRxjjN6HqG9itkR4fs2RDdwX
36699	payment	2133	2133	1874	1	1	4375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGnwdM4S8HTxsFECpJVTT64Cr5REVub82poUh4zEZiX45NP7d
36700	payment	2132	2132	1874	1	1	1276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKQACWUkrUi8CbVehk4R1Pz2bdERKncevHjA2kWAHXYYGDmf2
36701	payment	2134	2134	1874	1	1	4587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhYZxYfWEA1mFznxrqm3EYzZFnLeB1VTcHbcfUDKwrA919vkp
36738	payment	1397	1397	1678	1	1	14157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sRV74U58kLN38n4MuQUMvb7pME8MbAv44CsdzTLzvsdvqEb9
36739	payment	1397	1397	1678	1	1	14158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQA2Ay8gmFK4yNCEAePU6bHY2zWiN1rQXT93uaTToRpehY5kj
36740	payment	2133	2133	1874	1	1	4387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrn9SjhEq8xLbfUVJpPFMWeNP9y6i4NdppJ3jFEREa5V4ZEor
36741	payment	2133	2133	1874	1	1	4388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoWEzgM55bM4xGAT2t3Tkev7oXeMYZRjUkFxXjvYECjZNtV4W
36742	payment	2134	2134	1874	1	1	4599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19tDVALx46gMtYsy1G69qWsh89QKWU7dVgz8CDtmw2dY4hT3D
36743	payment	2134	2134	1874	1	1	4600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4GiWvKWT7585UjVLQFXBRfzE5e6Ky6TZisgUMcSxGwMryjyCo
36744	payment	2132	2132	1874	1	1	1280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVp9Uf3FnzGmTDqYBWS4gqBbeU6Xz9QR5sXYvg4P4cqKxZuEK
36763	payment	1397	1397	1678	1	1	14164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4NhJkUANkjVXK1m7TVUhgXw3fEXMrnj9SCt8Tog6vCcaKi7R
36764	payment	2134	2134	1874	1	1	4606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRYRvUcHVGsGT5Wat8mbvMdtrf6knrpejEEXGXcdhUYNrZucB
36768	payment	1397	1397	1678	1	1	14166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzgL59Utfwx6WPpQZtAgFehWSMB5eEEA3tVqfx5Bs8e6rGUGV
36769	payment	2134	2134	1874	1	1	4608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTMZasv7CwDhYz8MV2AS4FTKFxUDwzwymeFUBuLJez8vswEXE
36770	payment	2133	2133	1874	1	1	4396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxpwho71gQcoQ6nw4WEuNz1etddLYj2vYz975FzGkDyY4H3QV
36794	payment	1419	1419	2310	1	1	6	1000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxra2fuSZGdjXX748FPtAZuAa41PA16A3ruFRzYhxyXjkUGQjV
36795	payment	1397	1397	1678	1	1	14174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE1sMNoyReVntTSPkkK7k2M5tv16PqwYpfM8szLwxiAnnZRD6
36796	payment	2134	2134	1874	1	1	4616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLzbdesY9hp2qztGRCAbow7oTpXvAHuvs8s8wDpv7tDMvQxCP
36797	payment	2133	2133	1874	1	1	4404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutyL96Z1kBVepHbF9KFtRyK2vbv1WicjgG5qxq8w6mX2cnPFf
36798	payment	2132	2132	1874	1	1	1285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaK8VJQfhHZHd395ATWtAUUKRkR8ZdFnsdq4eXerfr9wz7EFE
36799	payment	1397	1397	1678	1	1	14175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEv5KM5X8aEnWS2dzPxVGSSuAfaoSjYh6N5LLLBypuEKrh8fKY
36800	payment	2133	2133	1874	1	1	4405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bQ6xe6k2fz87iu4YuGjxomhgyo9PbqRPc4gHChQDzU45nU7V
36801	payment	2134	2134	1874	1	1	4617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu8FQrndFWDXiBHSPuPGhmMPyVJfbHCRBoD6YCrsRy95s8F7J
36808	payment	1397	1397	1678	1	1	14178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDq6dooLruMKgfQoPyJ2PT4Qs17zjYsYFpg3chjSxrJgApf1a
36809	payment	2133	2133	1874	1	1	4408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyg9JFoeVjAX22aDnCcuRr4nGCQiVm2ExQWVBAdaF7DQShwDY
36694	payment	2134	2134	1874	1	1	4585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Qt2vqUajdzouVLKjJie4fWPA5KHecLkwcz9ge9fWkkDM6Jsj
36702	payment	1397	1397	1678	1	1	14146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5R3HT5UEQcNZLCPKZVCs9TtHQqhNbrZEf2jCiU5Usjf1JnSsA
36703	payment	2133	2133	1874	1	1	4376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHaqqLrQgT93Cvkg4iaqqxY2tKZvPXi8BzWSgbRkc8kknVYhk
36704	payment	2134	2134	1874	1	1	4588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfydBkzU7TiSYuit1pBPBuDSFA7peu7YemHrWEgBKwegaqQPEX
36708	payment	1397	1397	1678	1	1	14148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZmeiF9aLMVyxFLNuYUx7dZUXzAKPRB8YrYGxXA2iKxLsG65U
36709	payment	2133	2133	1874	1	1	4378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoT3t4MMTYJP9kT3JsDy9CzBBJHpaQYn8oDMRhmZ2gfg1Jj9i
36710	payment	2132	2132	1874	1	1	1277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLzggBkyfnYWmNHgz1AWo2Lj7Um5r6xsTd4BrtCpTu61zdEME
36711	payment	2134	2134	1874	1	1	4590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzwu1m2cBfQmZ56gQZfDTtXV1n1LmJsBW6hWtgZyUnyQVwoD5
36718	payment	1397	1397	1678	1	1	14151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3hSNTuchxqomMH7qCoandgbWDnCR1jivXxyArHwfyHtHWJijX
36719	payment	1397	1397	1678	1	1	14152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdk5xisKBDyx2MrWRVbEcm4yw5gE44xqsnVKSNWCwU62m1G6NY
36720	payment	2133	2133	1874	1	1	4381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnWHfiRuTZSG2bBTqiFMSDKQkFCmEi1V1LqKPAmwxd1aDKJUA
36721	payment	2134	2134	1874	1	1	4593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbwrMQpVnHeMUaT8Sj5AiWWTbWyNKDDmagFcoiHhs6DAXqGZC
36722	payment	2133	2133	1874	1	1	4382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q2DERvqMRwL9UzSYCqWtPXeK2GHjLtuzdXU8ai6NPP1VziwP
36723	payment	2132	2132	1874	1	1	1278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzFM4YTZm9sqV1WyGggdQsgxkvUorGPDCUPWuwaYX9npRSgtd
36724	payment	2134	2134	1874	1	1	4594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUX8tw6xjVpjd7VSC2Vq1QdZWXbMjGxa8PQmnLMPqFoaV5vMY
36748	payment	1397	1397	1678	1	1	14160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUa2h7LeLMjJQCepU4AR7n2Yg8fEpjxihgAbyGSd9xz2YDHVe
36749	payment	2134	2134	1874	1	1	4602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvZuMT1xfYHMv5wn8CpKmnEjLFaQChPzNrjYKA9fTJywhH4wS
36750	payment	2133	2133	1874	1	1	4390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYukWu4zTmLSW5nVRpQQjo5MyHpRyUMXQQhoCfotTrTvfCQ9mL
36757	payment	1397	1397	1678	1	1	14162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgxors6THudbRsNysvM4Rh1cqATWQ7ZuwmbXHLbxPkjpEvuBo
36758	payment	1397	1397	1678	1	1	14163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F3SimiAzhj48p87LuX668XnBPBReTvfxjmeutnswPNeiosQC
36759	payment	2134	2134	1874	1	1	4604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1o5LZZsAVQLxvDYY8pFZ7pUqbXLfB4sgHXrNR8KCkaTuvTRkn
36760	payment	2134	2134	1874	1	1	4605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVSUporr6QHenJAYK9aYdCyaD7mwKDJWwsi5VYisGNd75o2gP
36761	payment	2132	2132	1874	1	1	1282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABP2JZwxRPbavL3WDLGabfF2LvCuSgT59x3nzHVwMiuLvZFcW
36762	payment	2133	2133	1874	1	1	4394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubBCxFCcTHT9ZHLzeuw8Bgw7mkJuwaSEX4x2CCEP9camyfUrE
36774	payment	1397	1397	1678	1	1	14168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH1uVbSdo1yZbFEi2cXikZDcAvMbDApK8ir5f2CDytdRnBTB7
36775	payment	1397	1397	1678	1	1	14169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMXg2rfdeZdJbMy14ageYdvnBu8VumxhZVV1M1S6aSYRWZvyf
36776	payment	2133	2133	1874	1	1	4398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRTYivZBhYH8LTjgCsWU9y3c7ahpfqXjRswSqHRedDoFMNwHk
36777	payment	2133	2133	1874	1	1	4399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYpXj2RB4tP7E9787C7nPNfpmj71TvUxsX4B3tgvrtBaf2ZM6
36778	payment	2132	2132	1874	1	1	1283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7evGsP4HNkWCTriKfWXmKLP26Fut4wKLTD2MW5Sw6Nn7FU7J
36779	payment	2134	2134	1874	1	1	4610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKPpzm9wJvAZTCicg8XxKHbvJHsYSACw9pMs35E4LgFPj88CZ
36780	payment	2134	2134	1874	1	1	4611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFG6MrbWqYWikQz7fmdWXstVg3K2RVpsxVeBzMNZAmpm8cCMhz
36788	payment	1397	1397	1678	1	1	14172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6KqjNzAHEdWnxM7aRncdHpZXBEo4cFbCvb6uJpNCQdkQ1Sbc
36789	payment	1397	1397	1678	1	1	14173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GjD2dw1mA6bF8F56zNwqKoKKb8LFhA7mEkY64uPUGDzYZ6yp
36790	payment	2134	2134	1874	1	1	4614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgZHTDWeGyyFx8kbJZHT2bmvAjZFp9WzgTGXGQHeEPctmgsRA
36791	payment	2134	2134	1874	1	1	4615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMtDV4DZENfCg7VAyKsWpK5GFjeaLDVJ949gu8JQyoptM7qCq
36792	payment	2133	2133	1874	1	1	4402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jpKZWRSjLgf8yBvop8vJJWntyehcXLPi5QyKGxsKvj1VU4zP
36793	payment	2133	2133	1874	1	1	4403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTjU8FjzMqRH4Xm94KZrh9he7uzxeTLmXvU3KjpTD7FxqHotXX
36805	payment	1397	1397	1678	1	1	14177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR7xm2PgkFPotnoEXeL9bvoqKjTZgmTXRphmQanoNFQHL2Dhc
36765	payment	1397	1397	1678	1	1	14165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqXWjs72vQuNWnzXnGEPjpXJhGu2imeBdkdbx1vo8aAAhYU4p
36766	payment	2133	2133	1874	1	1	4395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sibnDLrqJVKmim4ZfhiAqjj8ggx7tLSeopbjf5Ls1sWEcwWs
36767	payment	2134	2134	1874	1	1	4607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5fo7HDgUMVf6DRBKvnumKkTH4ab6KL72VXqN3iibgoFQ3usC
36802	payment	1397	1397	1678	1	1	14176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgsZJDER4gWnLkRzFMwQVRCmepV2VUxYGsdJp9KYBmsdpp1vF
36803	payment	2133	2133	1874	1	1	4406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDgdT8u6cFCMSU5wUNG3fXrrDYrRGhbz4yM9FMf99Dvebw1ct
36804	payment	2134	2134	1874	1	1	4618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKCQqTQrXtNDdGm4NciyG4XZY9TFNpDykwfiVdrEcSCCwb6Ch
36812	payment	1397	1397	1678	1	1	14179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Tdob1QaptZwksdmarQr659Aktz1aSsrkm39D8nMfAQA5WyDJ
36813	payment	1397	1397	1678	1	1	14180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGX6qSgxnWGN1UxCES7Yv6DzHYSpCm3wwcs8JRmGxV6n3abnQZ
36814	payment	2133	2133	1874	1	1	4409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6SuGM49kwhaVX9uYxb7bfbiCkmmPQtP3JcMBf628dG3gvpsB
36815	payment	2133	2133	1874	1	1	4410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7LC8jCynXKangeuao558Nj16BBcHuPss9iPZv1ECzUMGgcRc
36816	payment	2134	2134	1874	1	1	4621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb2gF18u8AoFAju8C3JrjKcRbtx1sUvERyuLqNnHYMZRtKpr9
36817	payment	2134	2134	1874	1	1	4622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrB1i4C2rKFEbGXANU7CmGaFnFqUokXSansfmYeZkKZFjVu48o
36827	payment	2134	2134	1874	1	1	4625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVxSEcVD1mAwMevwTpe99MDL5CSZtAu4wubKtbvyCjFqdXyyU
36838	payment	1397	1397	1678	1	1	14187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWocKYgSfnb1KkTcGyp9MwZqnW7xbdxrvt26QsZWuTAf9eAM1S
36839	payment	2134	2134	1874	1	1	4629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqt2j1jiNsDarzmiciKEpqH5HRJe92FduobwiPJH3szeuey8e
36840	payment	2133	2133	1874	1	1	4417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHW3tu62k2MEmUdrSUju1h2D9MEB8YFLtjVGqn3FKhxoUxGanV
36848	payment	1397	1397	1678	1	1	14190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUge2M1e3h6GQ1qopfw3vtifeb3xSg17QjiggBMYWu8kMJ2EUz
36849	payment	2133	2133	1874	1	1	4420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSppBZ5DTEMTBkAYC5DG9HC6sRUSaRc6YkbZcQeQECkJjekG3u
36850	payment	2133	2133	1874	1	1	4421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwqo5MP2RXSLm91igHRUkt6egMZJGxAonRtceF1yG1JYHHKL6
36851	payment	2132	2132	1874	1	1	1290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3Lu3ykXdmay92Tsnot9uLeMu7s5oWbv628A6JoEVJasHXU7f
36860	payment	1397	1397	1678	1	1	14193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvegLbYhT2tg75wEZXS3JQVMAZ8p7X5NvSBedoYiAfQczaKhVa
36861	payment	1397	1397	1678	1	1	14194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkbrc15CcnnQoHFtGDe4GMwii8W4AxGRtTDcWFBZCR8zJM1de
36862	payment	2134	2134	1874	1	1	4636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBh6hcyzgqxmSamcx9cSg2UboysC5ibpma6vDnQFgMXgKyazw
36863	payment	2133	2133	1874	1	1	4424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUKbBnv5ZsRFJjofRRnDtr2ntA8h6egArven5mRqoTWApRqoJ
36864	payment	2133	2133	1874	1	1	4425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUg2pzKYZSSX96EQGDE26v2vEUFRsE4updwN1aaAdF421jKLSw
36865	payment	2132	2132	1874	1	1	1291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcLt5LhBhSbeomTLcHnZ6X9LwQX3Mv8ajWe7X9tKDbQJrfKHz
36866	payment	2134	2134	1874	1	1	4637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudsyhvWWjAXftzU6Tc7QzGZtTS5GmrqReeiG2qdcT43w6HjvH
36877	payment	1397	1397	1678	1	1	14198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjQrgNixVXEfweRA3k7AmwwtDR7YF1BheBU2AU2P8DD4qA2UB
36878	payment	2134	2134	1874	1	1	4641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyTmW74hhEZfgofGNSjYq2gQoknMW8Tf7L6y8N58tKR2ZL53R
36879	payment	2133	2133	1874	1	1	4429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRz2wRCDxjxYM9A6wgcYG4TGRCNdRED4URuGYWJwnLn3zuNMQ
36890	payment	1397	1397	1678	1	1	14202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqjTtxy62E7uXCgBALW7wkZfYJBGjehZyRH1y3ChD37d3k3RL
36891	payment	2134	2134	1874	1	1	4645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMm27Dd9uWwc3cXzoB5DQdQLjbwnHCcF8kSMzbBq9VFbQtB4f
36892	payment	2133	2133	1874	1	1	4433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8N9vexiPVPRBufVn7FaojdfTYZdsX4UHU1dbpQ6AkMsmzpZ8o
36900	payment	1397	1397	1678	1	1	14205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJCq8FN7cZqgvUeV4HvE16FT6WNPrqGevV2tJkL5U3AKr7bQS
36901	payment	2133	2133	1874	1	1	4436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWSHEgSrw6ckeQZ5nMKSQbcJrVC9uJwUxj2X2BuhFeQA9Kskt
36902	payment	2134	2134	1874	1	1	4648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBiAeWXk66MsuhoBf8bzp32NhV7QP9Ts5LsLfsmEbERCENfap
36903	payment	1397	1397	1678	1	1	14206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyvpsgFc1jhP5Ue93rEdBbL4ph1kqaygvzRcLmxzDJg8eNrBB
36904	payment	1397	1397	1678	1	1	14207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPwGtif7JEqt8cR7SCqKyfGvUdfVBNn4aE6CjyzUMMpXPKHRK
36787	payment	2133	2133	1874	1	1	4401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oH96YbGdVAbme7AJorc5j5yqvE4vZMNJ9XnpriJVFJq4CkEa
36828	payment	1397	1397	1678	1	1	14184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp94D99LXmfZG9Ca3FGf7R6DW5wsJt8TuXdiWJ2rjEogopLoYE
36829	payment	1397	1397	1678	1	1	14185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHbQzw5iZKs6MUtN6mYiyocJjSfqGHUwqpAQJwRN7UDpVBuWu
36830	payment	2133	2133	1874	1	1	4414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcd2VYcHKm757tPk5zn5eixCGdsPCgD3Fgar4nW2w3MXAurqq5
36831	payment	2133	2133	1874	1	1	4415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUypFqdBBy3xJrCEFCsjzSVS3ukoeMVzN5Dcdz2VTFvTavyEe
36832	payment	2132	2132	1874	1	1	1288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AQU65cfHHxfcrSCNKv7EwQDEy7CALNwBQKcKC1yKTip6uvtQ
36852	payment	2134	2134	1874	1	1	4632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZ81uHQy9Samt5WSZXKDZGLxPeJGty3Kdnmdc7kDNhyfcN6qv
36853	payment	2134	2134	1874	1	1	4633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1X2v9GURtacJqZRMnSGZGg46RmWVk8tkQS5GfSk33uutKPYt7
36867	payment	1397	1397	1678	1	1	14195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiz7HRbG4R9a2kUPvXN36TGiYErY2YUevSuottMVyzNzF34fQV
36868	payment	2133	2133	1874	1	1	4426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zye9iEYfGPMmyyxTsn7zh4qhj3dY2RT4JKoRqQoodfcpVUkq
36869	payment	2134	2134	1874	1	1	4638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xd4U4LJGHZPLK9KHvjFZviar2zzYf13TxNNZCo4JipFzVNuT
36893	payment	1397	1397	1678	1	1	14203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7udQEdQwmixJQbHSUva6gCUE9HBXNShi2KD2Nizqcve8ypUv
36894	payment	2134	2134	1874	1	1	4646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDUgjKULCyKBsmzXdmvZb6AnW1RtEDgDtpDcfKhK84Jk87K5m
36895	payment	2133	2133	1874	1	1	4434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAuqm4ny137P5HZ13FWo1Rp7f1PFnv2hqAyCto3s2mnzFbbp8
36896	payment	2132	2132	1874	1	1	1294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCe8dCCvH2xv1Df9cGVzBjyi8CmyvEwkazwL8TdR6MEhZN7LE
36913	payment	1397	1397	1678	1	1	14209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbUSC695uQkiGT4wjiacXEabei5xR8ovMdxF5GegsJCp43nJA
36914	payment	1397	1397	1678	1	1	14210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFfXQ3pCTXqzsfn4g7WCBniFXGRa3Ce63x3psa1nXfbhJqQmu
36915	payment	2132	2132	1874	1	1	1296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCZZBUujT1BgFkHBRpPVWRDCenvujeAnVaktqMhaaBQS4oNH2
36916	payment	2134	2134	1874	1	1	4652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk6jRGdcJ9FLTZusfiAvhrXgpJ4ZgKVdzrdS34JSqjhBhXXpn
36917	payment	2134	2134	1874	1	1	4653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMX1ysGxm2uUYXU9P6h7KtYzEmW5s9WM6ZkwVWEvuDjjenvHC
36918	payment	2133	2133	1874	1	1	4440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsvEXxJj5RFt2UVtgcNnzSBBebUm7rPwwhM7g4HQNmtnSB4Bb
36919	payment	2133	2133	1874	1	1	4441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuq6tQtCS55H11o1SZGRppUo8LbKKgJBfJZrdARPRnbHzRWt2
36929	payment	1397	1397	1678	1	1	14214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjt4N46b2jMCHzdJxVhNwWiPMq643iDq1DHS4CbpqS3n2JWvi
36930	payment	2133	2133	1874	1	1	4445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkqXjbxfd5R75d51myhZg3pGDkoHx7oAuNPknf7mni1YGBSE
36931	payment	2134	2134	1874	1	1	4656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzmoJGgwA2v94dGRkYBTWobPLkpMi7t1U6EsTGv6KGXwLKUzV
36952	payment	1397	1397	1678	1	1	14221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptPeMCV1doRetvbWvG2AC1762xYXx98U9nXk23xNtJE3netai
36953	payment	2133	2133	1874	1	1	4452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44pqUfZjjxqxDhgpupRALQewjjNRJMKmiztxxNHTLKCRUfwhP
36954	payment	2134	2134	1874	1	1	4663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXxikG4VwCzyXGXH6DSxGUDcVdN3aSnsjBSacMhRrxXVUwgq6
36978	payment	1397	1397	1678	1	1	14229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZu3epDsY5rPjgAoYC9XRCPYMFyZsWZXGEc7tZvUusaZaqpDe
36979	payment	2134	2134	1874	1	1	4671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdUtoJ4enrXJrkY5NEzwkNTeWnXggGxJAxgnuvKRszJujZzNp
36980	payment	2133	2133	1874	1	1	4460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnVbZE7vzucwBe29JSPfsYcTrdDkBbrU6ZwYs4Y2msGxS2bWd
37002	payment	1397	1397	1678	1	1	14236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZzkcPXSPUPqMqiBbYkJ5C7f3jJa2VPNWND4HYAMYREqLEAZH
37003	payment	2133	2133	1874	1	1	4468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHYMqCF7QfSSet1wdQRofBgxEYLmc92J2SqwuiBg1tGffMU3z
37004	payment	2134	2134	1874	1	1	4678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tAnvGQRErPnM6SgS4Mknh8XVNkcxJd1DiiQ2UXREEaEZ84rK
37012	payment	1397	1397	1678	1	1	14239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ14BhELEzdeyC4J2DmtXbD8pDsFhUU4MUJmGMHbfqeUHCeyrx
37013	payment	2134	2134	1874	1	1	4681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GQX7r9i57pjXVCuY5ywGbHqnDY82V6h9mF6Nt7wFxriskN8M
37014	payment	2133	2133	1874	1	1	4471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo7F95qrcdYgx47aDJvhK7wPGpV2ciSofsAvW2Q8HdwhjG6BF
37020	payment	1397	1397	1678	1	1	14241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKNzVXfDpiYKGnh35zFNtd5wUYNUEjiRbYoVEiGEzVN9PAyqk
36806	payment	2133	2133	1874	1	1	4407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yWCoUmL9h8dFqYViHzwUizz8trULJdwirbE4yNCb8NGg2oWo
36807	payment	2134	2134	1874	1	1	4619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwYrewFCbT6QWbxsuPVPeTg67MQVzpmsb7Yi5mcG1bMzmXqeQ
36833	payment	2134	2134	1874	1	1	4626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQZ4Txr9q8Hc2UKsJ8ghYWVq95x66CCYX2pFpAEHhSUhHg13P
36834	payment	2134	2134	1874	1	1	4627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjPHCUHkHUii3GTBMEfgWNqJ7eHCc1oyLDehqyj1ZgfQSxAqr
36835	payment	1397	1397	1678	1	1	14186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT76DDq49859deor3Ta2jFeQqXGHKUw5QFNhsrVMRmiX1HWjLN
36836	payment	2134	2134	1874	1	1	4628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHNn1adoN7K8TX9Ww25kveMR8tzD827kkj47JNoRLPS8xr13F
36837	payment	2133	2133	1874	1	1	4416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxh7KAqPLUr6xmYkFjHFxTCsK3TfdJdR3t5WMTbqqED5J6n3X6
36870	payment	1397	1397	1678	1	1	14196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuHCRmLAnevTkosaxn2sgHemxqUZEqTvw8WFMdneghUv62i8Z
36871	payment	1397	1397	1678	1	1	14197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUW3Pi82yk5owZZLUUCzEJet4NVeetPBoeYuRRhxQqSkxgpq2c
36872	payment	2134	2134	1874	1	1	4639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMJFyAVjMWMg2b3E4ULXRJUKoHLC81nbqgxkvR2QUHjbHQqUa
36873	payment	2134	2134	1874	1	1	4640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwesQNhBgu6wsRp6NTirG9wf5vJucJqPndGW3gPRmnP71XkZvn
36874	payment	2133	2133	1874	1	1	4427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfuhhUkztbS4PJwdvTBzCU6Bw6PWQghMFqwS8599xyvFWMW9u
36875	payment	2133	2133	1874	1	1	4428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgD9VtWmS8A1CLNN3UJaq2QGwZbENpAmPBLxTHnY3ejTnaXVh
36876	payment	2132	2132	1874	1	1	1292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtgY12y85uADCGFaCkqWCErMsiHxDpdjYdF5mcLai5s2pRwTQ
36880	payment	1397	1397	1678	1	1	14199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4JmV6bjJXShCNKbBDTAnJPJMy3mo5KRh3MVaECqXaPXpzLoA
36881	payment	1397	1397	1678	1	1	14200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vBtjvEi2pSc4Mzg7hMrVSmH1yQFP4f3GgTd3yhu5X4PVpD9H
36882	payment	1397	1397	1678	1	1	14201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7m1j4QV8Qa1uurZskQkfwxwz8kE3DvtNTbphjaZ1qUrkFk5j
36883	payment	2132	2132	1874	1	1	1293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGwS7C1LA5agG27Cmd3VESTTYFUR9bHpKCFRUaqd2R3AsJrV5
36884	payment	2133	2133	1874	1	1	4430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKkfMchjhfMyT63GJySDks5RUDc9eJabN3Px1zcFGxxY4ESfE
36885	payment	2133	2133	1874	1	1	4431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnA5dZWXGjW39go7u3fAe5uyHfRAdMBzaEhL8E7uZwq3fAHuu1
36886	payment	2133	2133	1874	1	1	4432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4JJksBq6P6Sz11qG696516WrXgCeRGxmSp5EyMVmEqPGMxvs
36887	payment	2134	2134	1874	1	1	4642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kP6kQMQG1sM2jTvZGms7Fm46GwhxR7oxnFxXhB87zr7sQeAp
36888	payment	2134	2134	1874	1	1	4643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUHSKLZGFq6NLgXCXauR4DscZaEwoTs1ZhZGtgkgzbc2qA26c
36889	payment	2134	2134	1874	1	1	4644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURnfSKLHHVfDmUa39L2GrgyRvU4Qdr6CWPjMDaATQrDg9womA
36948	payment	1397	1397	1678	1	1	14220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehkCYGs6Seizj6YaTCo5NMQDRp4Ln2eBonV16tbJGhoRMairq
36949	payment	2132	2132	1874	1	1	1299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9w2atprrgPnTquEvq8mNESNbVVJd42yM5nWFoNkmS6mNTLvBL
36950	payment	2133	2133	1874	1	1	4451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovEctHtaDGnyKf5rchbNUbYfFhEpX89NnwnoXayvKSv1cUEvh
36951	payment	2134	2134	1874	1	1	4662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow9nvKWu78e1GHc6uqoYprPNGcC6AYJdW8KhwGwbSQZPKr3zX
36971	payment	1397	1397	1678	1	1	14227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eTLC2Rwvc3zV27NcuxodHw2E6AUZWEYPx6QxyKJREaEwYRXS
36972	payment	1397	1397	1678	1	1	14228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxx1iyyyaCPnbfR51vus9vPBoyarP2kKinMTfJ3AYPssD8Tbb
36973	payment	2133	2133	1874	1	1	4458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmP8eDfBmcQoRgbc8KkBygKoSeZ6qehmTad9j2FkSgGeYBQoQ
36974	payment	2133	2133	1874	1	1	4459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuudjDsJ24QN2wpsSLLqG5VG6M7CQiSBQedxf6tsB8qNLrfHX3
36975	payment	2134	2134	1874	1	1	4669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaH4LbvXuB3Fc1VvpwsuuGQTSFtuCA2K2aQNncxPh9wLDKQ5dm
36976	payment	2134	2134	1874	1	1	4670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbSWf992s1RDak1qj2c5epnmgN4WMAMB1c6EL2dKLJv198TVy
36977	payment	2132	2132	1874	1	1	1301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ff3ozy91bo8nEK46TsMFzDYN9FFpJe8U7zCDsLijPS5GNP3U
36981	payment	1397	1397	1678	1	1	14230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEDGCRjuJAWESuWtYZ4eHMLhm2LoVNZrSAsMaDw5zkdYNjLbY
36982	payment	1397	1397	1678	1	1	14231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yeEnp7964jEGzJqJu2b7t8EvXQBXXdbC8i2wsmmBqn2rN81U
36983	payment	2133	2133	1874	1	1	4461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7cGMWHurAmEkiBgHQNWjfDad58jo6Gdj2jf9TrJQb8osBpS8
36810	payment	2134	2134	1874	1	1	4620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZicfyCL7Wn1tezFZy9nbhj4VTx7CACv8B9byjJ9DWeDb6ooE
36811	payment	2132	2132	1874	1	1	1286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWaw8pNbqmu6dWqdceWt95ySexhsUKRdN4sCKu9A5pskdcMLK
36818	payment	1397	1397	1678	1	1	14181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cdTsXkPNWTZEeFcrsvopgSWTsxDBgAAjggC7GkwFFQ4rYTsb
36819	payment	1397	1397	1678	1	1	14182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHYCn2mimAaK97xFpMc7AMAvxL3JA1hVJ1CnQ5WZQP8QoMSw1
36820	payment	2132	2132	1874	1	1	1287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrbU4FT8au7jNgDPPoRyrnf7SjTMx4ff8kBmJ8nrcuL72prAb
36821	payment	2133	2133	1874	1	1	4411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3EYqhKeB3Pmq2pCsKFf3y1TSRML1w3uYW5JoaTcpxRzicPkh
36822	payment	2133	2133	1874	1	1	4412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLRcMDfNdkqy1sxFVCgN8cyowkjYnuAgu4jTRYGueow8E89p2
36823	payment	2134	2134	1874	1	1	4623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zgCsN1vhU6Ek5JmZHS55uxbH45jriVvuJaqiW1vN3omCAJEE
36824	payment	2134	2134	1874	1	1	4624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMCtXZRq1BwmD6bM577PBVpXhYX2g2bsGEydvd3X915LXYcxj
36825	payment	1397	1397	1678	1	1	14183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMpYbe7k7LejGPemNPpEP64WvPaXh7HrG9FcVPD6jv54pZAJBX
36826	payment	2133	2133	1874	1	1	4413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6BPtPc9r9qep56BVCbjJQYHbgmCSvq2fxb93KZvjxSXeDJoP
36841	payment	1397	1397	1678	1	1	14188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEfpTK1VijPFaHx1ocpZvP3B6MJKvpCkSGFwCYHnz7Tkg8Ng4
36842	payment	1397	1397	1678	1	1	14189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWwkZmUxpLw6jSuoFY2W2skf7ECmTWWDqLFWwezcJxEqxpdMx
36843	payment	2133	2133	1874	1	1	4418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREFsEWLs2VAfRzefw1tMiYqbsdu2i8Sp1Z6GTwaLC4pDZ8Eih
36844	payment	2133	2133	1874	1	1	4419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYut5jGmBV8oqeRxXhdkY2koaMnJqPp7gfN2XhBUMV3SNhjBbk8
36845	payment	2132	2132	1874	1	1	1289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowe22WvQuoBerMtXJmg8dHnGc4YcjR7CeBCqmNoUGxSePygfy
36846	payment	2134	2134	1874	1	1	4630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXXcHE39Mg8uNStjwXVr8n5jHkVcwES4ZQHGvkDkVr4x5S1BA
36847	payment	2134	2134	1874	1	1	4631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwvcwieDBWQWEgUnNZA9jyi3kwQzFSqDoemVYHJojPhty1pcs
36854	payment	1397	1397	1678	1	1	14191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfaS6WmHEj6j5MwFHnHwQgu4U2PRsGs5pcP1jXPfbju9G5kGg
36855	payment	2134	2134	1874	1	1	4634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5GfTVDQf9kAyN2TP9afu9ZsFvfVmMm56Z3iDkc7nFdr6gmHd
36856	payment	2133	2133	1874	1	1	4422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4a9bgq5TMgCepGMBBM6F9knyM6dmc1aGP6BGQZNAR841KTqnQ
36857	payment	1397	1397	1678	1	1	14192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVi4FCAU9AhYpsKCjfJz2KtcrnEV8rRcqqigoD2BP2VoJu4jF
36858	payment	2133	2133	1874	1	1	4423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8E4FRjcTJCxrGYDwHu3jCGeHAAY1dwaSyBHnJCXBbQx8Cd27
36859	payment	2134	2134	1874	1	1	4635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdBKKv7oUHvH4QRKnXoaG4VCKG8Hf4P9HuCWX3qZ1meXPxJsf
36897	payment	1397	1397	1678	1	1	14204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7n9hFiaGqRzGAaA3HVZ4N1Hdr6FC42681sZJVpqdrSY5eeJ7
36898	payment	2133	2133	1874	1	1	4435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdLJbWb6A6znySf47yuRGepr5aAZd1igyQBEc8vE9QChxuZfZ
36899	payment	2134	2134	1874	1	1	4647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBr4d1wm2ceYY2mbHsCxBBgDkKgjGmjMZHjcTy3LHpDFSX2vW3
36910	payment	1397	1397	1678	1	1	14208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtbQ7tBeyz2syLwftq9GvUcr7y5AqRouWrYG5iL7HQ75nHZe3
36911	payment	2133	2133	1874	1	1	4439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAagZYe2jFnfh3APW4zAdYx7hNvut9B7FZV3L6ZPNeKsUKwP6
36912	payment	2134	2134	1874	1	1	4651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92Gj7xjqjabxGPDTdrQyNdo4U9RUUm6pA8SwZEdDmk5qmccNP
36920	payment	1397	1397	1678	1	1	14211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qQYqRATND1FpJmVz72Y39L6WsxhfxkivLGunAiMitsfAxK3E
36921	payment	2133	2133	1874	1	1	4442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhagS5nUzX1Swm6srmy4vGWn3X1GBNEpNpBjSTR4Y2kaaFLiuL
36922	payment	2134	2134	1874	1	1	4654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8y5A2msYKm7uMgKNjvszM7iSuxf8wuULNHQ6Z5qYDA345u243
36932	payment	1397	1397	1678	1	1	14215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcDRcrRBSZCZS7TVkF4S6p3H5uM1yGbYb3BKV27Cx7CVhZn4P
36933	payment	1397	1397	1678	1	1	14216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uSkB7cY6JpjpHJD2kk9YjbY5Z1Rszpj9BLQ8xYbLPvWEKPQo
36934	payment	2133	2133	1874	1	1	4446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMASeC4hgtpkJ7jQrHkZyQRQUfL73v8hMY6tkoifuFh78bhuT
36935	payment	2134	2134	1874	1	1	4657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHXptxft8B1ANovgX74Jvfkc2rgy4kSYR5VxZtqZSsW6jdg7b
36936	payment	2134	2134	1874	1	1	4658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxXTXVkqEYRixiR6i1DhHD4LhJxCQDTJhZm3WddXc8N55knyD
36905	payment	2132	2132	1874	1	1	1295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVcyvUQ2gvMwedyQa739JiQXStyJwk6jv9wmN8DfviAdXxqXV
36906	payment	2134	2134	1874	1	1	4649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS7xBS7Mo9qb9W7LR4GaWpK5y87iSBDBoA1JLDFcsnofgmKmS
36907	payment	2133	2133	1874	1	1	4437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LihtvSGzdRoZaV2ig7VDV8SHFVYm6ru96ndj4L8npUiDhG7A
36908	payment	2133	2133	1874	1	1	4438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPturqThHRYeQ3YxDjsXkfH5MBkJ66cTuXD6MigjoLSq2xM72
36909	payment	2134	2134	1874	1	1	4650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBS2EJmtWfgVx4novvho8Pjjw5nNMTtz67NhvhMJe1RMXqEU31
36923	payment	1397	1397	1678	1	1	14212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV5oTRQiusSiiYVBg4fkD7kmcVWLxisQiSasYN5UhoVwxbJca
36924	payment	1397	1397	1678	1	1	14213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kUtQgmbNFXwFV48TmVRnmFtXyraGPXdJmyYx89627HhcfWPZ
36925	payment	2134	2134	1874	1	1	4655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cGBBndCvG5JQLrMNEsL8Y27GEsKkjd8rrtNUfc281ZFfbXE7
36926	payment	2132	2132	1874	1	1	1297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7KpPmFWRVRGVb3WgzkLD82TJdGJ7fbTZ6s5YqLbpDyE5ummt
36927	payment	2133	2133	1874	1	1	4443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7w2PQwCHDD8CHNnquuyoeEqGySv5kAve3ck1p2LfM5MFe2C2g
36928	payment	2133	2133	1874	1	1	4444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xDxhZVeD9Dzv2w5rpXuXZFdiA7S48nQeZjMqeqsuyizwqE1G
36962	payment	1397	1397	1678	1	1	14224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Qs1FeVpbQjc8cQ4krBe6N3Vu5vh5PBqTrjEJtqz1ZL7U7cKa
36963	payment	1397	1397	1678	1	1	14225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaKY9QzDNjg7sqXD82szwvoVJUGkW9DEVd9cSYK88bT2xRiBH
36964	payment	1397	1397	1678	1	1	14226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhaLmcviXw2Cw182xhkzZ2PnMVgbHBApQWkK8pFFjjqqAxgHv
36965	payment	2133	2133	1874	1	1	4455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVmgQbLKXkvf6rXG6dj6vKECACHQcY6otvCQzbLR2xMdHNsNy
36966	payment	2133	2133	1874	1	1	4456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc737Qvkm2LLh1KoEbvQU9dYeLT6NvWT3zMGsYCfGCjik1HS5u
36967	payment	2134	2134	1874	1	1	4666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VAinnbs1mhR3x1YC7mUEmjgBTaTrWy2K2vDRJST5aZQ1iPph
36968	payment	2134	2134	1874	1	1	4667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDftzbEzNDPJYWqm1M6u8LAGvi54MPHNaPhSUAw6E6FQNYuCYW
36969	payment	2134	2134	1874	1	1	4668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2wAiuQPA9GRw27ZFPHbuqZkvDqJ2cet9FUDfA8Ea69tgSqmA
36970	payment	2133	2133	1874	1	1	4457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzhNpUt2VFvgzL59EbN61MgFsqsTzBtQV2d4JCTKAmq3EZThj
36991	payment	1397	1397	1678	1	1	14233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDexxRpNdrnyWp6kKtZkn5Yrw3zELhdMtjMh9uqjyuSnZMZ5jJ
36992	payment	1397	1397	1678	1	1	14234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EFxumJuu5sk4LtpGFszdi3KhS2LCcTUr9dzC6xZFRFAktR9N
36993	payment	2132	2132	1874	1	1	1303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbVpwuWYQAjwq7xq59xFnPrXXDMqiYU3vkDnXb6jQZpVrUaEc
36994	payment	2133	2133	2311	1	1	4464	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFwZshcRmNPxiZocqgHFpMfTNv5LPYoXAm5Fcrm7LhV79wijF
36995	payment	2133	2133	1874	1	1	4465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqtCLJaWDYtz5gGKbnQqan95vkAGeX4vCE5yiA1bTSzis1J7D
36996	payment	2134	2134	1874	1	1	4675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuU6SpxRzyghrPk3mSiYnqkPYgoEXuco7Pb5Dq1Rdrebvcq4T3
36997	payment	2134	2134	1874	1	1	4676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3Mxhb1JTgqogAroLmkARq2ygxfaHnHku8VpTZU8e36CvNdtH
36998	payment	2133	2133	1874	1	1	4466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc4kPCwFvVX5hPGM4UMG5uAvKrhcfYBGUXVfR2AvLvprkY1n2
37015	payment	1397	1397	1678	1	1	14240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeghHDEg1duFsRSxJjyRgzhYFMj4oARd9LtmsBfZjBh2GnSNW8
37016	payment	2133	2133	1874	1	1	4472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAzQJr3TRZgb3mKwH3XdFhz9ccBsLuRQTEUs31zEeQuQkUhqR
37017	payment	2134	2134	1874	1	1	4682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQJcxwpMAdSraKYpiVoNcJ1xgJexGjPCZZ7mkPjZJixfL6NtN
37018	payment	2132	2132	1874	1	1	1305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuiqk8ksJu8AThQquAA1KMS7jGhf8qKEkhFhwMDTy4pE5t1Eg
37042	payment	1397	1397	1678	1	1	14248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeSE7Eg2rwpj3AFEmnuD6YgvLW6s7MgEPSyLP1XaF8pRR5Ttp
37043	payment	1397	1397	1678	1	1	14249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXY4DtE52ivkjnzbYtQwrfjSB9iaq9battBrhpqWWYf5Co3SQ
37044	payment	1397	1397	1678	1	1	14250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn8wZk8aXPM4bAEF7o73By7b7K4tkdstBN2SFS7YEJorYxN3j
37045	payment	2133	2133	1874	1	1	4480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGoEK98KTXPscykp1QQ35ZhL5jK1SMRHu45SBqAxGfMdhDwXz
37046	payment	2134	2134	1874	1	1	4690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhGkuxHqC9M4iRLaWN3QjW3kbseX2T85FP8aJK66hFPDEzqcR
37047	payment	2133	2133	1874	1	1	4481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUkM4Np7wJiwq3pKUv2PKYPtLrqoXjGgGg7zjJ77whV3rZzT1
36937	payment	2133	2133	1874	1	1	4447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyutkT8H7PP6CjGjLLwq83vnkgUhHCeKH6wW4m5U9XCExbdfFB
36938	payment	1397	1397	1678	1	1	14217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mp4WJcePRV7u2JCSZALTGvrD3bXV73n66w2ct22pgoGe31aG
36939	payment	1397	1397	1678	1	1	14218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5hLyfgBFXMNUYon7oo696YFdhkDna3HVuPGMwk5y8ymz9avz
36940	payment	1397	1397	1678	1	1	14219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8Bva7KkM8aNm1kp6KxiL6dWQtxjQRHxe8wo6AKg9YCiCLD4H
36941	payment	2133	2133	1874	1	1	4448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtg3ntf77dAozzvKskVXnmLdW13HsWuZ1o9LuZ4VBqo63Fvyj
36942	payment	2133	2133	1874	1	1	4449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJm12af9WP2A3dtCfgMtKgy7yViRRjzbqPfXsTwwB5vnvrYAx
36943	payment	2133	2133	1874	1	1	4450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuskV76ymi4afa9ZUXJBdp3Drj7aVECuXejfT4z43vUkzef6wA
36944	payment	2132	2132	1874	1	1	1298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLSPmZkZ6GnQBbyivFx4QnTdpLKVABpd2op2tSqoXdddjPXR7
36945	payment	2134	2134	1874	1	1	4659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HAVLe3em7anKPhkyQVEp4PZjsc5tMNX1eacxZdwn5vb4MGUQ
36946	payment	2134	2134	1874	1	1	4660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYrGzHrTHpNzKS43XbDjEH3uD8t1fN2NRZXusVKDDpajPVbT7
36947	payment	2134	2134	1874	1	1	4661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2CujdfDKuMjJry59Kho2B8gAwyK5SSCu4JkduzPEKsFRS58N
36955	payment	1397	1397	1678	1	1	14222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnWkQxitxA9ZnSLLxmmVf7K3VKSAv2fvDY6DgiFKEFQuKRt8Y
36956	payment	1397	1397	1678	1	1	14223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gTazeMSkuxsym2uvaMwf35L3CCvfHrhoguW5YxwvtXq7s6mV
36957	payment	2132	2132	1874	1	1	1300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wSZs3tpTRL7AfQ7ejUnn4LVkTM67zuSeziSRstr5CBke9zs3
36958	payment	2134	2134	1874	1	1	4664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLFX17ka3aaKoHZCWM3eaAL5LXKtWxCZDJNdUWwctkHUZTfRi
36959	payment	2134	2134	1874	1	1	4665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVybA19LqnavZHodrxWhCTWqETuDsAskXsUUs8CrczksJHAou
36960	payment	2133	2133	1874	1	1	4453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKA8AeV8sJzkD5chA9gt2QPX8Y1T2WMqpPZC1Eo62oUbzbJCw
36961	payment	2133	2133	1874	1	1	4454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxuktAwyUYidrBMfSTobjyTs19mLvaCuXtd8JnKGMsBPFDCPF
36988	payment	1397	1397	1678	1	1	14232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEYdnC9QvCEuXaQd1LiH7p6WiRxrTk3LR7UoFroHWxdMU6s5s
36989	payment	2133	2133	1874	1	1	4463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJGo8jQtoRWoMdZ7LpPQTemuPPcdn6a6dYkZqcii1j4JCwUv9
36990	payment	2134	2134	1874	1	1	4674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWULMrdiKAA7meEvVFW98ofngaa497UKDaZ94E9P4P2k5uf7N
37019	payment	2133	2133	1874	1	1	4473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMK8H1fzFmmch3hrZ4vtEc9z2gDuohw6ysG8LEzow6XWcjcp3
37060	payment	1397	1397	1678	1	1	14253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmuceUk59JoqDkUzYzy6g4MrT5RjbC2g75zUkffRC7cfPLo1L
37061	payment	2133	2133	1874	1	1	4485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZZRr3xyskzyu6Gv1r6fUbc9LRamyvAmiYw1K7Zt1Yq8AAjCd
37062	payment	2134	2134	1874	1	1	4695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgohBvBb4GgdiT9hdD6onRUEy4MbrEEGNBiw5329sbCQeNAED
37069	payment	1397	1397	1678	1	1	14256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP31VNxXXWFrAdmCfaVgjYoJjbPrypJueUFbvmDFJ2SSLRjba
37070	payment	2134	2134	1874	1	1	4698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxaeEYrowEtTZct5fJgTAc8X8SgRVQGpDxqRcW3koat8UWFce
37071	payment	2132	2132	1874	1	1	1310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh3UMsyndtRFxYzFrNMFjCRYaAXshmwfcarz3sqhiszv3QyWm
37072	payment	2133	2133	1874	1	1	4488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rd5kQBSjWLeanLDSGxVmGNfKhA4nYtLBGuSzpQ2xB9T8Avur
36984	payment	2133	2133	1874	1	1	4462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh94GQrbDBG8UtLnYWMLoUNCD8ohaDCXXpXayWLYwwecc94k3c
36985	payment	2134	2134	1874	1	1	4672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdor1T8gsQQUhQM53AYLhV3FxU8AV6Mi3pmtS7BunA9qUhx1Hf
36986	payment	2134	2134	1874	1	1	4673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1m7ft4e5gFddqAKVy6gJr5AP7wMtf182vUfDi1RQGaSJjpX9
36987	payment	2132	2132	1874	1	1	1302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VfAFDxqqeMDqVLotXgDbUeWDHR2ZENaomrJoPk7rKr4hKQLY
36999	payment	1397	1397	1678	1	1	14235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFR1AE2eW1QHKXJWkqxSUv3DKcuoQKEEVD3i1g88NRo1KLiL9G
37000	payment	2134	2134	1874	1	1	4677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbpEDrJXtAnjcMWrMgPiwAa42YDnenKAxvGoAMHpiQFJCLFXS
37001	payment	2133	2133	1874	1	1	4467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmdkXsSzwGtVJ61DTdwsJ26KcB1Ftt221UsYxKKh5J2ZBoiuU
37005	payment	1397	1397	1678	1	1	14237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xkGk6qcGYoiJQy56yrNkbiUhvYd2dpjAGp5rKdiryhZqeL8e
37006	payment	2133	2133	1874	1	1	4469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpn6p82bgtpHeDKCv5VafyA4K44F1yduYJR9y3aBqX4JxZJZKj
37007	payment	2132	2132	1874	1	1	1304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfTWGztpVbPQFevHma3r9JxAgycpAtcAEUaKhCsbKdf22apWE
37008	payment	2134	2134	1874	1	1	4679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfdkUUZg8mFYzq3hqdZN8ZQ2pxr6Mjxf2MjGG3MJ9r2FbX1J2
37009	payment	1397	1397	1678	1	1	14238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUgPLm4jELWP6o3LXCtjhRgqD6G5FbaJvh7DCCdah7MUt6JA9
37010	payment	2134	2134	1874	1	1	4680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHyAGePBYRP9nRTQdTmzzRrLBsH6TRCP5S3c96UBtALSLHhgV
37011	payment	2133	2133	1874	1	1	4470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAF7pVcGy35NvBoP5hPQboyM4b5xjm1FUEBZz1RG28f2uHA2CW
37056	payment	1397	1397	1678	1	1	14252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EVNyjz3EYRkNiD6Ep4gRckhCdH4fKF4MdDbBRcovDktwcv4d
37057	payment	2132	2132	1874	1	1	1309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGjTgRSQdWZ7o8HoympNrVkygzBjiEfKuqjbCRT2vxRa9XyrA
37058	payment	2134	2134	1874	1	1	4694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rB7WLf6UFc2kbkZKyiHLZKEsawWUjqK9NVjyq28aqrRSrGrX
37059	payment	2133	2133	1874	1	1	4484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANakKFu2mmdf9hxCCeBtDiVzhhfq64hZeyxKm1d2rw4vFPXmc
37021	payment	1397	1397	1678	1	1	14242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTvW2EFvN12pXATFuvFhjm3cLhd5MoECoWMkevCwxKUDv9MXv
37022	payment	2133	2133	1874	1	1	4474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbkEK3o9obmztJn9EEsChU35jkf218niJFuYUeUNpGeeVDc8k
37023	payment	2133	2133	1874	1	1	4475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2oZHtZETLEn9DjyFERwweSaYDKFxz22mtfPrNdtAjrdSXjV3
37024	payment	2132	2132	1874	1	1	1306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu341vT2LRVaTTU63iwUK44J2vCee4c8LVCKBqZ5RwAwy7ubhC
37025	payment	2134	2134	1874	1	1	4683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxJESq9Rm519A8EKpyYko4cbyTpJuqPNBiJ5N15G7C6V8bcGR
37026	payment	2134	2134	1874	1	1	4684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXHhR849TFnGbS8J6yr4cqENdKvPFqAQ3LKH7dczxZfix9Woqw
37027	payment	1397	1397	1678	1	1	14243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssTMr9hAxXFSoXf6jJ7C3igFteCbzTwLcgfWw2ktpizDcX6fp
37028	payment	2133	2133	1874	1	1	4476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMeR9WKtofT63fFnXtpDfhbQ15xv6wdpBEgxfFPTACbWXPYH4
37029	payment	2134	2134	1874	1	1	4685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMAKY1WVPzM6LdQZ2wZEJoHJAjcEJDiNLm5yi3aCkbCw1hSAc
37030	payment	1397	1397	1678	1	1	14244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB76WvfQZVJAaMXgr3XtYzvcwi5NaBY55sqo7ooWuyejMXTAP
37031	payment	1397	1397	1678	1	1	14245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi23XWXzTgwsGJxKKJodAreRpxQ51j5diRrArr5p8RuT6CrEtd
37032	payment	1397	1397	1678	1	1	14246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAARUjnFrovECgPe2fV37bV5WzqCaNm4V5qtgCZKVa24i2tWj
37033	payment	1397	1397	1678	1	1	14247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18V1fBgpbSbx5icXrZrbUU66PAUdMwtxH4QjzhpBrt428Ln2u
37034	payment	2134	2134	1874	1	1	4686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyQB84LdfdsKLeYL36EEN3WjjCJFU2qhX7LjkXWqPofZaroRN
37035	payment	2132	2132	1874	1	1	1307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cRrb6Y1e4Am7Jjfqc5oRHnWA1rBhQu4iFojosoFcRxrEDoea
37036	payment	2134	2134	1874	1	1	4687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAm3HDn183ggF8tseZEVJtM8tB55C9N1Ljxktdc32uinJgdUc
37037	payment	2134	2134	1874	1	1	4688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgqXwifamyp4nHVdMnCUS3LocyqjkR9FWi5nMmBCMVb4FvvLr
37038	payment	2134	2134	1874	1	1	4689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoyeQTfuuhdowgZGMvQzZHuiw7Sgge67FUd4GTTfuTSx9Z1Bv
37039	payment	2133	2133	1874	1	1	4477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJEGZvRzrJScnnTfrrFeqQEqgbMCHLPGX2qkJSis8C8kJ3apo
37040	payment	2133	2133	1874	1	1	4478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNTwMhs2vkrd2N6P5AQ8ufb7q8SXBC6iaEqzoBufRMaDytaeT
37041	payment	2133	2133	1874	1	1	4479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFayX23adAmrQB1U6Sox14j4FHG3n9v4o3vkh3WtWZZRKMdMt
37048	payment	2133	2133	1874	1	1	4482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KAFqvbr6WH29EAzYCh7xABzn9An3k5LHerxbuHj8CC5ZpKgH
37049	payment	2134	2134	1874	1	1	4691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRxgMDYgfZE4mKv6P8rLDzka5fqEVFuPs2XtNZYsLCUQHZT3F
37050	payment	2134	2134	1874	1	1	4692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5TSiZYJZa44Z3YPsfbJzWQot5eFnBdttAaXaWdaeddBCm3HC
37051	delegation	2119	2119	1403	1	1	8	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZxDugQN4rohjPg7RVngjQdgicpVvCienGh4jkmEk7ATsYJfELF
37052	payment	2132	2132	1874	1	1	1308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgLa82668j2o84C28m7ccR452qWDJfxsyBWhoU5DoXdHfYvfb
37053	payment	1397	1397	1678	1	1	14251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFXruWunA4qkaPVoJtuC3aUHKUdheYMxDhcedGs6TfJ5SZ3hH
37054	payment	2133	2133	1874	1	1	4483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazBS2G5X869dbN1Ss8NWzxnEcQUpYjn9kwVyhBTnx6f7Jyatc
37055	payment	2134	2134	1874	1	1	4693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmGy9WQYgfSg1HwhYyKAYHtdrAQeksuRjPFXhqgB8AJSSW1Bb
37063	payment	1397	1397	1678	1	1	14254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBxSJYU9ocF6TEFSj72g4x1yQJx7wmsptoryeXihWAPNyCvpZ
37064	payment	2134	2134	1874	1	1	4696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHdDfrFgweaHvVXxB9qmXwZJ3yjdDUNjrhM4BLbckvtDzD6FA
37065	payment	2133	2133	1874	1	1	4486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDMteDxt3eCAhGF4rGfLJe9T4V3fLrTpfccq4YsPZyveqQCm7
37066	payment	1397	1397	1678	1	1	14255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7xfwJS8J59Fn7oo5QDdDDyVtXT7VUHGSR3BtZp97q2ncuAVU
37067	payment	2134	2134	1874	1	1	4697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNW4peccbPVMWDrEK5F4NuPotJT5puHby4GzDUNkZsNmyagU2
37068	payment	2133	2133	1874	1	1	4487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZKXHQwAYWS2vwfyG3aTa34L1kgjQTo5bGSkzaLaqBGDgnk9E
37073	payment	1397	1397	1678	1	1	14257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh9TakjrqxE7msaQQqPzvpegADggNatrSSASRfGtXyZaAkURA
37074	payment	1397	1397	1678	1	1	14258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwTs2pm4ANqdYLhVMqhk8TnSJKzdp1yvKtYCaMVMXBsye7Q9N
37075	payment	1397	1397	1678	1	1	14259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpcJPbAX67HNvb5VvNUhsKNNnhBsNYP8n1Z8LPuwvpGE7Kmac
37076	payment	2132	2132	1874	1	1	1311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCDfmkk3Azv3SMz85aeWVxs2zjJLwDmiMygaZLevBUKUWGQ98
37077	payment	2133	2133	1874	1	1	4489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEiLhbKhhu8YRsNWsQ8vNU9RMgBQP78F2n4UD6BSpjNvMgmoQ
37078	payment	2133	2133	1874	1	1	4490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1RtiaQmiu8iSTEd3BwAdW5TNWaqNk2RN45dgq77oMiji3LnJw
37079	payment	2133	2133	1874	1	1	4491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FhVT34W5kMGewiMuwYPU3kMpJ6QemmgimXP4QkmKZYkp5Snt
37080	payment	2134	2134	1874	1	1	4699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzLtfgdpZRCK4ndrKTJkHzNeD2rtCvBByJ4srrMcsUQAM6c61
37081	payment	2134	2134	1874	1	1	4700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdB5sK6ctHtMDEApm8e9RWC5sa8K7hq8aKFxLSm1SfBxjhP8tM
37082	payment	2134	2134	1874	1	1	4701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeRwrEXKVdPFrvVr2Hj2HimyrMqTJVH682e8tqrXAYEEbniog
37083	payment	1397	1397	1678	1	1	14260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3cKAXzbpRtQSKhEpy2BZr2sgnBieHjTfD5s6Q6vCPsn5ppe3
37084	payment	2133	2133	1874	1	1	4492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKb6uFwgZMN5vgD9KjpvadZEqWQnsvJTkstv4hLMTUrvZY3wEG
37085	payment	2134	2134	1874	1	1	4702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqMZePDuobd2yWTbs4pZidoXpNHCsQUJ4XXfB3oNNVsdrQGd5
37086	payment	1397	1397	1678	1	1	14261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskbyL1QK8GtnDperAXpQ7uZdNFm7tDbNrk39urwRNv3D4cAMj
37087	payment	2134	2134	1874	1	1	4703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoQD7dz3AqgFuV5FsgQACNXWCsouaWs3vhNZGVKX5ay2yxGnd
37088	payment	2133	2133	1874	1	1	4493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirYsC6UveRyUKDXN9gh98fS8vjrVtPW96FNH1kwMGhVRNLw8M
37089	payment	1397	1397	1678	1	1	14262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1RHgYzZGZCKcPDknCAVWvQwFKNPJxvPfzaWYC848GhGUhDwt
37090	payment	2133	2133	1874	1	1	4494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1aXkuT6CMYnJXyCXutD2o3xQxWz4D2oBLatQGmpmhWYVyoEW
37091	payment	2132	2132	1874	1	1	1312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcok7rDr2tQh83njNrWi4fibf88FBRCkgzGN2YCNt98f3cw4t9
37092	payment	2134	2134	1874	1	1	4704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43Z9p4PmR5jV4ukqquAZZoA68u2n19evYTqjeHBKYFY1qpuPi
37093	payment	1397	1397	1678	1	1	14263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZAc3HzX1Fx38TuhCdbLcZqHodo7wgVq6xBrpDqyPx3p6LMWU
37094	payment	2133	2133	1874	1	1	4495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmeSgtMjNPahPDmrqeXYYKBn8d8vYPeHQCvDR2a99xGV3ad3S
37095	payment	2134	2134	1874	1	1	4705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3a4FkLvr5mMzQdpU234QiBmuz46vm9i86BtBM51C8u7CLwmqH
37096	payment	1397	1397	1678	1	1	14264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoe22kuEytva57Bbuvob4S8zUmy1vj4Gg1tP4o6MdRb4KKKcc
37097	payment	1397	1397	1678	1	1	14265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcsRpom39rfGUnW3EiQFaTq5sFMEXzb8ihPojacZY7U85H9Kg
37098	payment	2134	2134	1874	1	1	4706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2X2B71qJQXjYSJbsdsEewM3jkGjPezcsvf6qULgeZkmKETpu
37099	payment	2133	2133	1874	1	1	4496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcT3AgxkukiUfdyBUz1MhPZwAbem2Yy2kMzBBycQ9Q9JtPcg5q
37100	payment	2134	2134	1874	1	1	4707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgR4Y7puDxZ1pm7QTTk3VcYxtUKdM1VS6ieta9jCTWW8phJYBf
37101	payment	2133	2133	1874	1	1	4497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BXU3nqCPhTyHt5WRS2Bywy5cWxKrCsTT23qWjazX9Lvz5qvP
37120	payment	1397	1397	1678	1	1	14272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuL4br8PoxRNwi7orH7mLrJAagNCidw626LzmMfb2jJEizsiCN
37121	payment	2134	2134	1874	1	1	4714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQ2bNZv1khKc2BaATNtdQ7M7832PnW1FA9fSjUGPFrP3bqAnK
37122	payment	2133	2133	1874	1	1	4504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoVCZZZkkStEJUzicJmeF96jZKhAfQDmPtzTANKKw9yUT3F2M
37132	payment	1397	1397	1678	1	1	14276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQ4rkNBD789j93zdr9CGRERiXYJs5gYKXEEsgs7DkH1Be7KNq
37133	payment	1397	1397	1678	1	1	14277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnjzBBs7jddcfWfXSNPpFrnum9CJs6YJtM7tsazY3YTXPRYK5
37134	payment	1402	1402	34	1	1	33	285090975225	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZeGaM6myp77bQ15je8PHZtzgZnKNFLj7Nx4X8iAMvKbvz7Xavs
37135	payment	2134	2134	1874	1	1	4718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtU6ghVtREj2arQ8nN7bomxtUVmmvkwtnhQp26R5Gw4dcXzcDh
37136	payment	2134	2134	1874	1	1	4719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXL58xwspc1Bvgf2VPczx96pD6JD8iLdy7UeeLB8AYnPzLpGzq
37137	payment	2133	2133	1874	1	1	4508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBJxxDDgh1hGsrfNbufs9jVit6HFnq1NMJ6i8p7bxdWrehGy8
37138	payment	2133	2133	1874	1	1	4509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkHvd6r47U1CWDBAA3hJtWi6aZNe928RyWntDGZZ49XYAMvCL
37146	payment	2134	2134	1874	1	1	4722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgh7u6HaMtJ5tpDAWpFH7z4jAM1a5RMBsNN4coc27YfvsbbhC
37147	payment	2133	2133	1874	1	1	4512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uS8XRRoJEry1quo3oj8pehS8PLe2V7Q1twMj7uvbquY9829U
37179	payment	1397	1397	1678	1	1	14283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGjqsCmMUFHcxUpd7b1tDapyrFBEAoWM73YU13XfLxvB7iKhD
37180	payment	2133	2133	1874	1	1	4516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYHvbyxyKGjB6aihkUjLRxhhaX5sKnhqRE963u3twzQwS7TKY
37181	payment	2134	2134	1874	1	1	4726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfveaWDC2cG4iW1fAgRVGYBynwFEyHKxPnmt5aBSx8PP8YaYYC
37191	payment	1397	1397	1678	1	1	14287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RHXbaU3tV75xRmBRSwV5Xw4315rVZ3yLDs7WWEjTzNqjPrvY
37192	payment	2134	2134	1874	1	1	4730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnkdmYjijg317on3g1e9Qr7UueN8Syf1o57p7UqLMNVpd8Vv7
37193	payment	2133	2133	1874	1	1	4520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5M99aD1fQwuhwrTkMLxAQHBupUn4B9tiunzYE8uDAtuQvMp2Y
37199	payment	1397	1397	1678	1	1	14288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6MRL8Epy8X7hJ2fqsdiEFxD3fScoyjP5cAiprR1oBJuUnz9T
37200	payment	2133	2133	1874	1	1	4521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHuYPwKiwNenYr6JtyWdVRX95toJj64KSd62jp92aRDpfaSKr
37201	payment	2134	2134	1874	1	1	4731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb8bQ1A9PGt2xiy6Ua8uGmfNngBBUM8awpzbMCgT44wrTyxv8
37210	payment	1397	1397	1678	1	1	14292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRkpJst2GLVrQjPx8eBEQgz76iKfmtnivvTg9tEPiZRtGBcfo
37211	payment	2134	2134	1874	1	1	4734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTBd3JNS6AtVK2b5pr7RkSZR2Ym8EioxTwdyUUzjNhNMdks3C
37212	payment	2133	2133	1874	1	1	4525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7N4JAQCDQP5uyuRmh32VKBTH8a16Pt8r1ZdUJYggU85c2ou6
37231	payment	1397	1397	1678	1	1	14299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNd993Sa2wNKkT9hz6LTNbfnNvXATTAGAYebZFf6B66pdtNrN
37232	payment	2133	2133	1874	1	1	4532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5LxJNdvyf4DJzVMDS9MY57fA8XRtxaLRPwVnc4NwWSv4HBH4
37233	payment	2134	2134	1874	1	1	4741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSr9kazMCbxZ16NVPtsUsjDFTUYbMfMUC3pzXfZnxEw5wHxS1
37234	payment	1397	1397	1678	1	1	14300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCPgp5GYCqsj4kT1qyMAbj8VDbNS19MQVzFH957uxsvDzdoRJ
37235	payment	2133	2133	1874	1	1	4533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxEVGkjaQ6z2xmDSphDsU3wND5KEFzQgVAhECoFSvuxR1fn3R
37236	payment	2134	2134	1874	1	1	4742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNGyiZGbkTnfvrMWzkMQa4LAX2rmuQzGEBUZWYCuTTWHyYDYo
37237	payment	367	367	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNZ9RQqWayyhpXyx9kpyTPiLLh4t8eGkaQhWUCpStA3xyomL
37238	payment	446	446	1933	1	1	0	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpVkPmo4A3MbsLvUr5p7ea4Cjbd2sACYS9RF9F9UBhebPAUQH
37259	payment	1397	1397	1678	1	1	14308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPjS55aZpP9CPobTgyn4DA35PKc4rpe4PXTEgQ6BJ8vePrUFA
37102	payment	1397	1397	1678	1	1	14266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8PQxWh3U1hZfnAeCFwaGYuF4DKbaEvZ7GmArqyE7fK6m6Tey
37103	payment	2134	2134	1874	1	1	4708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sHtaRXozek2hrLFBf2bp6nvgf68FDVZeQUx87pTNDBGiPNYn
37104	payment	2133	2133	1874	1	1	4498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAww5bRUPzpz1Wi5KgGcfQ5SVn7LghbnnSx1zBhdkdRfv7Xu3
37126	payment	1397	1397	1678	1	1	14274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzK7EbAJFX5rVTDd83RotnbKStU1aF14mRFwaESQS2SXusfJG
37127	payment	1397	1397	1678	1	1	14275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycEmDeCrbbeAX2aHxww3kfvSqbkVCdh38uiAfRfapFxV4a9SG
37128	payment	2134	2134	1874	1	1	4716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sP9b1cxpGQGsQYgEWnmfbTCozr2JzZJbjYtCtsJR2Ky8iF5i
37129	payment	2134	2134	1874	1	1	4717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhNaCVozZ1VpPSkp14uFJ8on9D6P8ji1sKSNMT3AT2QpwSfHX
37130	payment	2133	2133	1874	1	1	4506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fMTnxPqMaheoP6r9VsRLYtvbvsx5aJXpNPi8sXwo2LeWYdd
37131	payment	2133	2133	1874	1	1	4507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfC59SicCtPw8gZw2ejXbrj268myNJoAMmZoX9MnbchehZacGf
37161	payment	2134	2134	1874	1	1	4723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKog5qkw3bJcH1MDTWf2o2rESQyv6LofWvcPdGzSh89JtNLY9
37188	payment	1397	1397	1678	1	1	14286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeFABr3zmYqf1o7zftniDRrnM1hqXVwBydk6JW8UVKBPiyuBC
37189	payment	2133	2133	1874	1	1	4519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64UsLNFovXFaukXzahL9s6depGRkqXHVVNiR3b7bsA1SBZudj
37190	payment	2134	2134	1874	1	1	4729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT3WPwNqjv7hVsfDz6FECGby6BaLqFPJPPMpuXTpdqHCWgw3j
37202	payment	1397	1397	1678	1	1	14289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMM9PzCQQFWybpAoTjfbakPYjjkA5Mn7G64dnrbG4g4sAveCa
37203	payment	2133	2133	1874	1	1	4522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhtzGk8G9HqeF8tC9LavYiDvDr4EsomcpWsYp3STwpnWUMRqf
37204	payment	2134	2134	1874	1	1	4732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjKj43JcmR1oJi2CtpzLFp8xvqcAp3DgYJMWDozdsr5ebTL5Y
37205	payment	1397	1397	1678	1	1	14290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrARATcbedPNTPde8XoBFg3Kg4rV8M7t1DrykiUTKnQFDX8sA
37206	payment	2134	2134	1874	1	1	4733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUfCg9a69FiSAFNkNxwUtRfNS6j8JsmoFh7RnbsqYAYo91ucX
37207	payment	2133	2133	1874	1	1	4523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmJU4rbzCQwdkzbctsTfmLRebcfJZGhgn5oEbRfv4boxxWWj9
37213	payment	1397	1397	1678	1	1	14293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PAZtqHPECEC92FHrwaM3Ck86dzeAStQnHoRRcrDXaLkiaRhS
37214	payment	2134	2134	1874	1	1	4735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJfAtv2qEinDeQQfVw6PSGmcyxxxjAK4cDTYowwHbbhJ2BAQz
37215	payment	2133	2133	1874	1	1	4526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwytqZYD9Ui1Ta2UBpEtoCpRGweqtXpPgGYHdfNDjGrbNBzXvt
37216	payment	1397	1397	1678	1	1	14294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoYmCHGkR1bVDP9LhRmFQQr3c7GEnPFMaQ1CQxTkZqyP7fJYW
37217	payment	2134	2134	1874	1	1	4736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8NKp11MbdZHZNheEhMKAD5QzQAYi2Z5Ea8fvJryMeCYhS17t
37218	payment	2133	2133	1874	1	1	4527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMyRBS8r1nNhxWvtMUKG7ToBkvdnGFT5UdtiLbK3LfTvtJnz2
37239	payment	1397	1397	1678	1	1	14301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNBXyb7vMzBrPuEYNeAQx2aYtuseAYsA9qNNsXjabcU14ZhaZ
37240	payment	2133	2133	1874	1	1	4534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7YF834hz72jbvYX4AgEcepxUUaMzpsZm6v12doqoKzafdBHE
37241	payment	2134	2134	1874	1	1	4743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA6hRYNu3rxzAFBKtUVZanZDGa4UDB1U3kjt4EKxiczmBuXLX
37266	payment	1397	1397	1678	1	1	14310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD8oWqvW1okHKohJ2SZ18DfhGkhnhJ5Zw7Qzd9a1XzRVr6Hcx
37267	payment	2133	2133	1874	1	1	4542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLgqCenu3grjdtRyzwmfWkPjkQfbqNGUpN6vgnWWhvsDkHauC
37268	payment	2134	2134	1874	1	1	4752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizkT6TL596eW8PD5rwL3vwSfXSv2ZWZhd4hXgf1j3b6Lg2W53
37281	payment	1402	1402	1268	1	1	64	4256613899	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZCV2N2Qo3HXHXZJWmiBMFFqCg2PF52972Uheu7ew9QERdY2V87
37282	payment	1402	1402	2081	1	1	65	897022998304	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZ1G2AKwf3F4syvPq3Uci1mXFUnPhftbouB4NoQBr6FcPVcLZin
37283	payment	1397	1397	1678	1	1	14313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvQyGMib85swexGvLoxqULTJXdgYGrG3rALrccFKhfXTm3Dgu
37284	payment	1397	1397	1678	1	1	14314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCebDRAmb8XwRUjgbxpE3baQ3fknGXrkvpSzicDqjzw6KGycp
37285	payment	1613	1613	1349	1	1	6	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKtwS3QcSvRkd1PpKRRQwgJUxAk2whrzExwjTjmNoJps11a59
37286	payment	1613	1613	1223	1	1	7	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3SCWoTy1S2bWedt1ddrXeoY5q1SoH27BrR9ZfHqHVsKoSRDH
37287	payment	1613	1613	1103	1	1	8	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6CxNBg6qHgHXL1wNixECvbTCQ3uJ73q8QXoXcC1h5NZPtWev
37105	payment	1397	1397	1678	1	1	14267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKGiCTva57baV89tfP3aM6uUpW54tdGMppaALyUz7eN4bxqWX
37106	payment	1397	1397	1678	1	1	14268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaK6N3yVZnUYaVMfFvpFtJUPYgCu5LU7BhN4ga6BcAyrvgxZ2w
37107	payment	2134	2134	1874	1	1	4709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG48o1o9uR1mhpjVRt2dGuqCDmUcEkvA5DbSsSad8PigrebdY
37108	payment	2134	2134	1874	1	1	4710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRR8FMVs6oFHEncn575x8BZEMgvMnNtvXvdLVZYe9KVnZhDeS
37109	payment	2133	2133	1874	1	1	4499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg37naSgdKroZFbVV257ByQEY1ZeLocqSzG3tcm1QQmoK2iVw1
37110	payment	2133	2133	1874	1	1	4500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pyPR8hQxdxKcGSsDhZtp2G3ECd6ijwcE8NdUn3b3qDrX1iar
37114	payment	1397	1397	1678	1	1	14270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcDs8ExbFseu7FhuSj3TQp5PjFk1rqycQEioEgFyDHPaDeXfk
37115	payment	2133	2133	1874	1	1	4502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkhQScrXbXCc2W3VtN8qGCLA6B4rhSwunNwsxGr5v6io2mSrK
37116	payment	2134	2134	1874	1	1	4712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyiH25aGTFkDGcYyQJUPiDs3Pon3oasVDaKUbFguHmQMKYPYuS
37117	payment	1397	1397	1678	1	1	14271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUB4QxbL6mnfp8DMvgfys367M9W75geapV6GSTH6ScYZ3fwTt
37118	payment	2133	2133	1874	1	1	4503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEF6UZ1pzWEYh238gynqcxjoCqZPmT4SiqbP6FwCTQ5gJLE2X
37119	payment	2134	2134	1874	1	1	4713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYPsxuHDS44tXMRCcbR8qqZs1kRTpxDkqD4douiF8PvGHJUoW
37139	payment	1397	1397	1678	1	1	14278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9bpCpo1yWT4Qb9qx9vFvkdm4wuXaDmSNUeot3fkT15pBcGVA
37140	payment	2133	2133	1874	1	1	4510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFkTTca4obtnjGsqRjZFdjxrrmVi3yRmbNe1RKV2rT8qGrzyv
37141	payment	2134	2134	1874	1	1	4720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVYgN2eBvgMhXbAWQWYaFthB7jZNovybwCDZcxXCSZVfHKeLB
37142	payment	1397	1397	1678	1	1	14279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQDV2WxQA2E9sBKG2svRQTD2KsGepCJ3X382rpGzs1vMfdoFW
37143	payment	1402	1402	795	1	1	34	236482970434	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZXcihZ1EpMSbGazNpJf9s4odtbX34esXujoXDD1WDDv8a1SEy5
37144	payment	2133	2133	1874	1	1	4511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjad8MrJStdLZVmvX66ZWTD1nkrbss5XhwzVK7Sbfeb4xo4Zt
37162	payment	1402	1402	858	1	1	46	1394170478013	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYuxRVK4EyJYzcxVYT5AjKYGGbESuggyi6e9sHvFDBsaFYwPsKf
37163	payment	1402	1402	862	1	1	47	1925674410275	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZFfJHvcwrdmXpyzxHXFj9BvVasMycNd3WAoDuJf3cACwL3KU8h
37164	payment	1402	1402	866	1	1	48	1690526049926	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYVje1Wd1r1CGAxkK6NJDg8DA7rSPHH9EshtmADBqvBCDtzrco9
37165	payment	1397	1397	1678	1	1	14281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV9CWyzhnFtvdERy31viYdWTqnySe5YKsUwoAah6N4isjxryA
37166	payment	1402	1402	868	1	1	49	10295684968407	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZm7eUoJHJM9c4VV5Aikzd9kUHyWkmZKjZuHpvRDJYoYaiUpeht
37167	payment	1402	1402	870	1	1	50	1101043429532	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYgNugGkN3LSCJZuqqWh5XYmqko4cnuczMjkAuryAEuSG1Vw8ux
37168	payment	1402	1402	874	1	1	51	10295684968407	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZkQ6oAdTj5BykHRePWvGw7feFopF7eH8wQmuU31wNJGM2mMpri
37169	payment	2133	2133	1874	1	1	4514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoV9STFRiadMH15N7FyDG9sSmLuaTezmBen1pXkQQN8Q4VDcM
37170	payment	2134	2134	1874	1	1	4724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WGujo4FCbhCJn1ugasAvvMUhK4tZg7veJohz4GKZmWbbgfWJ
37171	payment	1402	1402	876	1	1	52	902461274761	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZDvPRfrzhJfkFL6AAk83gihHeig9KnpjizhnLsRm2GJ843uEjX
37172	payment	1402	1402	880	1	1	53	571982498068	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9YVKRuUer4ayHTKMxZ5Y1XNzb1gCeLTrfRtmEWgG1hxnHp9T3
37173	payment	1402	1402	882	1	1	54	2478590825119	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZx2mgv5HpY9FeyeJo33XMR6CgiacMBEJKdUg119MFhjiXpMrcY
37174	payment	1402	1402	884	1	1	55	381321665377	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYk7oHuRf2n2jCdcs2cwFBPPWeHgCv2RzwYBWUwXJQU7ETZPsge
37175	payment	1402	1402	888	1	1	56	1138088829319	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZBPkuYtJJ67P3mtesZfRkotTqbUqKF9A7N9fjh9h6Ypik5NswN
37176	payment	1397	1397	1678	1	1	14282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yGgBa7e2rP66UgxmV2GFW3kDKfeRus1aGuGaBHGJRJu5PqE6
37177	payment	2134	2134	1874	1	1	4725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcN7XuGZJhZyAa1mmr66Z6GF2dKL8cKCN3YFx39GUGj8TojsRe
37178	payment	2133	2133	1874	1	1	4515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcEsH6DZDq77A66sM2z2bZhNvWQ1CZxSCmieQv9PXmApLXrtv
37185	payment	1397	1397	1678	1	1	14285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhG3kT8z1mCWNE4j6usDuyKSrTpu6K6KotcncfBxqDb8qf2YP
37186	payment	2133	2133	1874	1	1	4518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCdqYxeW6m2gVXmkaS5kZL8UXeax8PKhZYTJeJ8AnQGxdXdjd
37187	payment	2134	2134	1874	1	1	4728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8U9kr83CYkGSHZrJf9SkdbpMovmveThpVtTa7JjxBEAri1Xz
37111	payment	1397	1397	1678	1	1	14269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2xsgP6YcvAPDTQZKriQEFo6Fep4QQXwxHVfumLA6EzbejNjY
37112	payment	2134	2134	1874	1	1	4711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Zczb5H6av2LTfnZrocpMgLTVGCtbQgLvcUUv47rqR4hJXPgC
37113	payment	2133	2133	1874	1	1	4501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgdoYNt79UPbJWfoRQH47gf9DzbAjiufaNYWUL3wXtxanQqvu
37123	payment	1397	1397	1678	1	1	14273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSRHkp64mh1eB9y17GEgwbWiEYpyYtHrR3vhyS7jD2FD3QDrE
37124	payment	2133	2133	1874	1	1	4505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdXB774QgDRmHY5N9p3QKwjuLhoGAWLeFFQ4aqCXz16fUJZq4
37125	payment	2134	2134	1874	1	1	4715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6tMmuX7iq8QsbiWpfttLucKaaJNwz6Hbxe8cZmWxzzDpGQpg
37145	payment	2134	2134	1874	1	1	4721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67iU51aSHan7AbLgf3WJ2C4c41wphxKoknw8onkbqi1myM9Td
37148	payment	1402	1402	796	1	1	35	2601310404775	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhxMz1MjHEbtPjWKVt6cPVq37fTTG7Z7BNhg31m4S8MdaXxXnX
37149	payment	1397	1397	1678	1	1	14280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSWPxBvquxjrKzBoKSo1Kju2z9y8DKaDhEWSzwFHMfkjLC7Qi
37150	payment	1402	1402	807	1	1	36	112018249127	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaFgNScehxAmxyirZRU8rJGi2LHy7DxdnbqcS8DXvcoyQjPvS3b
37151	payment	1402	1402	808	1	1	37	1232199665392	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa11JNCNAYgcH3TvvYfMsXSxTFJtwyogejfNhYHvTP9g8jfVaxy
37152	payment	1402	1402	809	1	1	38	254214648680	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaE8rSCxiBe8BzWHRZbSzLSH4xF8WLJ8DVcLfZRfzcjtvVcrNNd
37153	payment	1402	1402	810	1	1	39	2796358695487	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaJJDWYpxGB4tWygsnNbw5fNbHutGTkCPWUzyJUEGM5ekp74NKe
37154	payment	1402	1402	842	1	1	40	354522378719	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYSuXMe7sgF6ZvrgxHATdEARtj2rYJJ7cGQLbJbr7WGsWkFbBm8
37155	payment	1402	1402	844	1	1	41	660957553337	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa8WFEYFhkNoBVn7LpbYESiMUqKgahsa6hdNfCqfDuwxf6gpUpr
37156	payment	1402	1402	850	1	1	42	4893607702216	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYRwYgCToUreDGpYneufkg8CifQF5aHaiuJq76FezEqoSqG8Cfe
37157	payment	1402	1402	852	1	1	43	9479656602039	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYbJohjRDLWfaCUQZaC8NyB2JPZn6DgB7wDoS99sqsF5anUmpd1
37158	payment	1402	1402	854	1	1	44	1045284668996	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYx2KXZEAGNg6Hm2UbuNEUFZVHD3PVKoYS1hDitNaEFxc4Bcqiq
37159	payment	1402	1402	856	1	1	45	552916414810	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaDdAprqGDKYbzkKhhBxh8JeBr8AR5p8KrULKDaD5K8CsHGeAw8
37160	payment	2133	2133	1874	1	1	4513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hB7QbuRWDzmbS9RHLb1eHcvhPcWnXMN2DWAMBaovCux1NPSa
37182	payment	1397	1397	1678	1	1	14284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4k4hNnMvxYbEY8NQ2cnEGeppS6zd7Xo5jGWcrmMqLiu93jEC
37183	payment	2133	2133	1874	1	1	4517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Zk4zwWE49VKh523wSr8zeeYAUEEANMcydryadJX56R6kBkP
37184	payment	2134	2134	1874	1	1	4727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXC4nM7k5U8BfAAoErhkhPjmUD5oEw159KP3oudRCvK8b7Gs8
37194	payment	1402	1402	890	1	1	57	955364571550	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYnf8ND6WHAjZ7TSSLpahLtF1WWN2NYbovw66wTrgNtU4KBKEJG
37195	payment	1402	1402	892	1	1	58	2097269159705	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYifE9ZGYRMDg1WPviF7VBdkCiRVLKUrcBypMsRcD4Bxw3cwcQo
37196	payment	1402	1402	898	1	1	59	276656494634	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZN7eX9AWuFpj8bdm8mPWn4PDKvF1DnFxBAFCHwkicxaiMBmYsZ
37197	payment	1402	1402	900	1	1	60	164913993808	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYg4KpFnfxv34ZDLEhJWeNxH7eD8UfzmWQgndAYsygchMtDn5RS
37198	payment	1402	1402	902	1	1	61	495718164984	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYXMEaCDXgrSjMiZrGFQoXTgp1zJ4fxTZiHavDMjzxHWFQt1vz3
37208	payment	1397	1397	1678	1	1	14291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVg2jXGToBTNvnYzQYxMD2EvkeqRxWH3zsvYWxvPRk8Cd3LDDK
37209	payment	2133	2133	1874	1	1	4524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe8ac12ZfUnoe7uHzJN8LMiqR1pgkvkJkRBj4V8VXCNfaZXAi
37219	payment	1397	1397	1678	1	1	14295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22yHUq8zyyyMVSCN5sutj6aDAGbpxQtXctFGpnQhaQA8kb2qo
37220	payment	2134	2134	1874	1	1	4737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcretTDyo7hSi5tV8YWCKC8yYNh3MzX8zNdF4nLBQFiBkMsu9
37221	payment	2133	2133	1874	1	1	4528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyTL7Lu3NFYjPWFJDqEbkDzjGC9jwVxRNF6bJpTyQ1LajGe8W
37244	payment	1397	1397	1678	1	1	14303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkyXyBQ1w84CGKRJzhhicqvsQ9dnyg8pGB8upt2ZQQpj5EDvR
37245	payment	1397	1397	1678	1	1	14304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tgQ9F59fPQ4yCM3yF5XTRJhwNWzyQe98hsBLEZyDZZ6y1Nb7
37246	payment	2134	2134	1874	1	1	4745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoxRNzFe6x2iChmjHTnT3SHRTtLpKDFy8Av7hmED92pXf6gzv
37247	payment	2134	2134	1874	1	1	4746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAtWzTQqsMCLH2ZdrJSXkgPCxCFHsWVM78K2Bdp5SSw5zJUGG
37248	payment	2133	2133	1874	1	1	4535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJieLEcGNLviVK88Sgrt7k2pKH5eZsTb3c2WQRuLV4dJow3dw
37222	payment	1397	1397	1678	1	1	14296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWBtqfW1EN2qcJeyQ7G7zK6YcfAnevEm9yN2vbKiqsgLoiwKw
37223	payment	1397	1397	1678	1	1	14297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwGa91fcbcb85ZsmEWmabVSgp9JxrWJPnipCmkhVJfV3cQTBE
37224	payment	1397	1397	1678	1	1	14298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoKcRsKqSSCNG2yKEUTj3sEZ1yfNjszn7kbGVe6xhVZFGhHcb
37225	payment	2134	2134	1874	1	1	4738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbBKBg97V2gy1cs83H9CxF44BqCNQn9wt4jBvWzePmjYMP2Sp
37226	payment	2134	2134	1874	1	1	4739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzsfkNYKWsPECjkB8LTwZtcxb1DpqGpUGLpAaSwe9etqjJmJQ
37227	payment	2134	2134	1874	1	1	4740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5F8ZaAdFtUvhVfPR2LdthnRok2Qdknk8jMWpp8ySS8nsZh9R
37228	payment	2133	2133	1874	1	1	4529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jFAT6fNtcJEkzbEh4mZRG9mUqYFGQ9aQ5e4jenp6ZjGtfgDK
37229	payment	2133	2133	1874	1	1	4530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfPpLdgAN8ciqVjhfh3TEHEUQ4chfBYZdFDHFtxUn2dZK9CFq
37230	payment	2133	2133	1874	1	1	4531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFexEePGC7VZzPT4oAqMbL37Q5XtzcYBopmuNwPJmmZHbs3UP
37242	payment	1397	1397	1678	1	1	14302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJ213rcxNkQC8hW6qftjVqGcyyJv68NqEPa96LgcJYFxAF6ib
37243	payment	2134	2134	1874	1	1	4744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoYFPUzB6XqzLkPrcS2w5yoAgK6BeVx8TrRhdwVqXPuawNRXk
37250	payment	1397	1397	1678	1	1	14305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnxSfierL4gD7AEiRucW2Zo5mxYtRVY5HGyKt3LGSo1JM9HKN
37251	payment	2134	2134	1874	1	1	4747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnb6LHhpJcMucpPf1hdmqoGRvcAvAbFHmRmi61mUrA8rR5BMN
37252	payment	2133	2133	1874	1	1	4537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLGv8sFJRS5yTW41ZB9Akmo6UZ7n4CQ62wJrRvqYDHR7FPbk1Y
37253	payment	1397	1397	1678	1	1	14306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeLFXcZcPwKsMQTEU7sdacSaqUZZxockKCMKtfm138A7cG5Hw
37254	payment	2134	2134	1874	1	1	4748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiWE2aaYUmyesXBdCF7Pri1dUThS2EUMjbfp7iytc1Wvq3yWf
37255	payment	2133	2133	1874	1	1	4538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZLzYFALbePPjtgp1vZGZQVbGQ7gdobsyUcSjb7UhGn8xrc6q
37262	payment	1402	1402	890	1	1	57	955364571550	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZLKpVw8E771MuRPMKg4oZFVZwc5rnSZqTGzPrumX5wTg4LVMTr
37263	payment	1397	1397	1678	1	1	14309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTYhNGNn8BEAEtLdpiUuEaAi9DgYjxatKLyb38ougTwbQCHmD
37264	payment	2133	2133	1874	1	1	4541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbVjTTvAtwnQEEbDhfqt2qdTy3iiWAXhKTfbffeFpigYv17jr
37265	payment	2134	2134	1874	1	1	4751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8BNc5XpuFxoNkUNNkwviWzJCyz4cEFAhJeqDU6vZukCyB7n9
37321	payment	1397	1397	1678	1	1	14324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrjpXPh7tLDgfLfE4p2R8Vg3TbHzhbDK9v2uDobPNT5GPgCBR
37322	payment	1397	1397	1678	1	1	14325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVZwjpRhi2faq8GuAQyYZUbS1gCAwqpfwCmoZeJDnyPA7fLMf
37323	payment	2133	2133	1874	1	1	4557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaENjo9ZmDQZKnXrA6vSVpeZkTjnbfpEkcmsAgJtokNkYwiWz3
37324	payment	2134	2134	1874	1	1	4766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5UBHG6g7SoxPqg9nDaMRsDifBzzb3AdRjKTWFJeeanWpMXtN
37325	payment	2134	2134	1874	1	1	4767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdc37tfEoLhx7x2TuciQQd423kGjwFYYbY5DY8vkuU57Kc9qJ
37326	payment	2133	2133	1874	1	1	4558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekqve4MGb9eFkoz75e88iaTtbmrZmDrdVhHHAF8fM9FucMZYc
37332	payment	1397	1397	1678	1	1	14328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEsNwiK7B7fACwoLhdihv1p1x8zdXJi7YekCiKB51GKF31AKP
37333	payment	1397	1397	1678	1	1	14329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSjx1dz525bkLGLomtBTueRRxKmss6iojV2Bwa48sYoQj6cMK
37334	payment	2134	2134	1874	1	1	4770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEe59HkMhxQ5AyNtwHJgXeLRLF2AVsesN3fdSKxHrbTxp4Y8k
37335	payment	2134	2134	1874	1	1	4771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJRsvNYBc6Xc1YFkeJV8fPtD5q9wYW35qaKGQR7S1txVctEEQ
37340	payment	1397	1397	1678	1	1	14332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWUBJnShqb2DcGztdLaatvkoQx5w4ZGvxUoX8hgDXmsHcGiVo
37341	payment	2134	2134	1874	1	1	4774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN7iCeBbqWhibtSKPSX7H74JnTuBMvtb4rsvNnEhA5jVL6CY1
37372	payment	1397	1397	1678	1	1	14348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUUz1uYBGKvq5AdFcDwz56mrxrUgx76bGKzzmE5fxbq3X8RuN
37373	payment	2134	2134	1874	1	1	4790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYUQrs4Vs6vQPv6MNVTgTQNTPbA6S6Ed3ALjTiDcG5R1e3n6n
37388	payment	1397	1397	1678	1	1	14356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqfqR92WncaZHDbNWx56AE6QWsHuhyJnzLCMKBPKJfjc4NqzH
37389	payment	1397	1397	1678	1	1	14357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG17FQK5W4QBa2AnxLvCSCnBpTpPczRiWohKsUrA3FzztsXzz
37390	payment	2134	2134	1874	1	1	4798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqHkWp3ajC7ofuKpxsXiMWJfqKQCjJ3pw1GYXmdk2w5YDfXgP
37249	payment	2133	2133	1874	1	1	4536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH94qqyXNcYTfieurMGieTgD6kwPUUsjcJwYaEdXvpABPXUBC
37256	payment	1397	1397	1678	1	1	14307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHA7aJCQtwPgqPjeGJpayTDwDc2wBaRMHDtA9GJ9r6v6h8QT2N
37257	payment	2134	2134	1874	1	1	4749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzUEzKRTL3HW9FnztpwV7e9vux3LULvCEQFsHnFnYUyAeoFvG
37258	payment	2133	2133	1874	1	1	4539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG7WgaJV2N7ZoiY7i3TqchzZGohsXHKBc3LfxogscuJ8ReAZH
37296	payment	1397	1397	1678	1	1	14316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvJvJiCT7pepgXVhhWDtfvQXgPpyKKwnpADc8ZpTkz6GRaGy7
37297	payment	2134	2134	1874	1	1	4758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqs9WdGuFy2CQqxZ8Z4VPMkw3JPueoFNahuuUdbyTpyLSnZMp
37298	payment	2133	2133	1874	1	1	4548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmXghzobmPLSEZsqKXQg1SdyJpRn1i1rs9JwftzvtsiWn5qc5
37327	payment	1397	1397	1678	1	1	14326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSsDAQZA8vEdm2UHNLsMB3eavzro5pAiJi2oY2zyZzWCYBPst
37328	payment	1397	1397	1678	1	1	14327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fC9bTAPkr2bbVhxQzAFNBvkRiHQT7rcZ61G3D5HEHvdMTJiL
37329	payment	2133	2133	1874	1	1	4559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSD7UbTKrz5dtoR3bWWu9LdDLjjck3Bq19A3MA6d5C63DhKsat
37330	payment	2134	2134	1874	1	1	4768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dEyWm2zHCci4VfWqUPCQrh4sSBTuJj6y2HoFfj6cQdQ4t3AY
37331	payment	2134	2134	1874	1	1	4769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mAfRCQ6A42Hw1DgQpsAbYPoTrfHUVNvGn97GyCHdm3gQ4brF
37336	payment	1397	1397	1678	1	1	14330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TtcpnQuKE8fm1xujkdbPTs92Bd5zDsyDQ9hJg4ViUtFSzBtx
37337	payment	2134	2134	1874	1	1	4772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKhqKxMhHsQeb2PVwEAtf1MJUyx6xWcrdjNXXvVBYypJCWFsc
37344	payment	1397	1397	1678	1	1	14334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgfitPhLWp2T7crzgjSHcstBtz3PkaczRq8FSJmWR6kJjP8Qw
37345	payment	2134	2134	1874	1	1	4776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajregqTDo4A7ALa9m9AdgNMUtPunKLB5btx4LaBbTq5thzH3
37354	payment	1397	1397	1678	1	1	14339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYps5xY7KEq8fRjdSoV6DAqjVHMejJBSd1qbP3HSHYkePQUjnQ1
37355	payment	1397	1397	1678	1	1	14340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nfw5w27PSVby2L7t8FjstFvTWJfpV6EjuemvruTZpsDVLsjL
37356	payment	1397	1397	1678	1	1	14341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJ9jnXAe95NLXN6S2o3H5ETqhbKhjKnu8nSydvqKynxes63Ks
37357	payment	1397	1397	1678	1	1	14342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7vUjpq6Q3pLLTV89VDMrjCG3647tnBXRyWgqx2bnVLRP9w8t
37358	payment	1397	1397	1678	1	1	14343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgDS5t6ucekdp1UbGpEANBMLrfT1qFz6xpXab2czkHyptHM4q
37359	payment	2134	2134	1874	1	1	4781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULPe8P3uQs6SJccsYSWHP6se2DS3fjW3vs4N6bneBnGs3GaXZ
37360	payment	2134	2134	1874	1	1	4782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNtxzfyEyqabHf58HBgX8oRSYgvQk1gDKmLUbgUcG3SwZJV5e
37361	payment	2134	2134	1874	1	1	4783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvLTPAxB9tNbuGS7FbQapv9gcxbkVTGGByVQXcrrhReWZ6Wh2
37362	payment	2134	2134	1874	1	1	4784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCb9vzpxbDKazU9Vtw8EKBW5FHerjNChyB3HsxAmDk47HUAmDM
37363	payment	2134	2134	1874	1	1	4785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGHf7oe1Vevp5vCD2iZD25zAQDzD6BVSB4R2dRkeeheNTkiyQ
37370	payment	1397	1397	1678	1	1	14347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB9FWiXrFGZH2SLcRRCQsLpJcAnRLnL9PXY5q8S4GCv3KSFfp
37371	payment	2134	2134	1874	1	1	4789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qvCcUo6MHXTyHhz1KAecHEfxjAG4zz5dNadwyNbFa35cd8Yf
37376	payment	1397	1397	1678	1	1	14350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLGNbsB84pWH5V2aRNJyPZAHNdvRheSKXe3oQpsC9g6KbWsj1
37377	payment	2134	2134	1874	1	1	4792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepKybRvpFG31rNxHeTxzLaB8HYEPwPYvNZ4RgpL2t7X4yKvhM
37392	payment	2134	2134	1874	1	1	4800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNshdrPfvTxHiM8ieX3Vn6YNj4utg9tMBVSMJad9ZkBgDcagPP
37416	payment	1397	1397	1678	1	1	14370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNtgRKSxjLqwv4mc5WLCocsyuRmbGA8DkNwra3cEAYZLWjjsq
37417	payment	2134	2134	1874	1	1	4812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyrSpUXJdc934LoZBdnT5T6ahdnVV7ZkkQfEsvUXypBjZ9fXi
37424	payment	2134	2134	1874	1	1	4817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGfKuwirWdJiBpKnd1Eg4uAYUeqnGBRA6Bi8fe2VhUoqYiCyG
37439	payment	1397	1397	1678	1	1	14378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5Pe4XcY75yuxNex2FRNyY8byiNdRFvo4QXbJHLBJDcSDFCco
37440	payment	1397	1397	1678	1	1	14379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSDxbsC1brewNvBQWpyAyxpYEKQYZjESMAEE3W5DLuamdNmkn
37441	payment	2134	2134	1874	1	1	4825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxQbCjYHouTWM8uACk87YdPYZQB7pakPGbLwmnP6LGPxpVU9n
37442	payment	2134	2134	1874	1	1	4826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUH3eTtzUKRffgQzYeJXyEq77TgKPnwqMgWJazY9dHAcpd5Hmq
37260	payment	2133	2133	1874	1	1	4540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhr6vDb17QG9DZAMYurj1FiPPDwE2s5fDqCykT7eihWBE1iaqY
37261	payment	2134	2134	1874	1	1	4750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWNfUYRD8o7PGK32F9CPS8AVALQG5ANG6NpLk67MZur3Lt1zQ
37269	payment	1397	1397	1678	1	1	14311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvmB62kvdf7SsojGo2jaPgCcVXBCtzroczWQxXL3Ceiuv5dvr
37270	payment	1402	1402	892	1	1	58	2097269159705	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpYpXL5TJeMXKkCk4MGygaRzc55oKvhfPavdLP4o87pPhw1YkYj3
37271	payment	1402	1402	898	1	1	59	276656494634	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZtkwE116H6iYypJ9JAoeEpwW2jdqdNsifTiTdwW9ZCQKb3fknE
37272	payment	1402	1402	900	1	1	60	164913993808	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZeKFkV44zgYKUEFNNvFJsfkJ1y7aUjAtEjCHGS4jFgYPk1qtn7
37273	payment	2133	2133	1874	1	1	4543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwwrGYmAnhXQJReiSF94hYXbvAXz1Q3zhz1UXRXkHeSnp1vfM
37274	payment	2134	2134	1874	1	1	4753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNq3QzbiQi69bAMGLLKFZfBM38D9q71TDn1s3zSmu4Wo8osJv
37275	payment	1402	1402	902	1	1	61	495718164984	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZdMSiYsN6fwBhxkX5yk9JMRmo9rKeZSXKZJg6qKvqy7EtrBB2U
37276	payment	1402	1402	906	1	1	62	1782678785752	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZtXvraeTXbzMmLR5pjEFmwqbiWbemCUbhMi2NPFU5bkFAUQeKP
37277	payment	1402	1402	1267	1	1	63	398419064786	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpaBaqQNwJim2s9mdfqJZ7un7XVA1pmkskLBM64GcnvZAj4sX7GG
37278	payment	1397	1397	1678	1	1	14312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNYMjsjLRCc89mcZ1F1FfsZtsGo38zFRhypqUpvjhVXyHfY1R
37279	payment	2134	2134	1874	1	1	4754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JKnP7DQbkEx3oHwpbv1BzHotwBKoD8UtTuqXysw5fs5FpKJM
37280	payment	2133	2133	1874	1	1	4544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZT3iwe325SeWkf1meoUXr7QEvtcv8pnaSY1Sb5UvMeFHYGHX
37293	payment	1397	1397	1678	1	1	14315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCECfxJATwHbrc8mDakY8gqrXpjRnDMMgFUYrpDmJRMQG9wXeT
37294	payment	2134	2134	1874	1	1	4757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYWnjzsA2tkq25X1fyovcGLd4kNGm7eryXC9HXmxuvDtbW7eA
37295	payment	2133	2133	1874	1	1	4547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKa6ax9BWYUDoTWxSupm286dnGZEFj4hKaaSNUK8sRW4zhzyMu
37305	payment	1397	1397	1678	1	1	14319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAR89zHDyEWZaKGueFfhsYKpZFYJYQxGKXDrQ2We1bBc8g5qiw
37306	payment	2134	2134	1874	1	1	4761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bo9w8GVCv3QmuvxZJHsYKxahdwewcN5hfvZRv75dC89y7h1i
37307	payment	2133	2133	1874	1	1	4551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M7UnLxbXBoKzd4WFcQvFLN1h6myLTJsFu5AEBhQyD1mZvrT4
37308	payment	1397	1397	1678	1	1	14320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohvjq1e9MWfRyyTgtNhnddhbYyvQyKoJeFw36wpsk85fgSg3X
37309	payment	2133	2133	1874	1	1	4552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCspaiwJSUrJe9Lsmfapy8E2o9nBW7VHUnEnB8BhoD5VSGEew
37312	payment	2133	2133	1874	1	1	4553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPKbDFX2hhdmFSYzgrWHUjKBph9ZffoJMNxgVdTxhL4WLcPLF
37316	payment	2134	2134	1874	1	1	4764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMP9pcdHGiaeKZpvMpNgXuMg53bbFQpV9jWfbfSwXQSeTkfQq
37317	payment	2133	2133	1874	1	1	4555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhUQrBAYJ8Q4CW5r2XfReddwffW7iSKV3mjUaj67653kVHxaR
37318	payment	1397	1397	1678	1	1	14323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2NsCX6PAYxyEJDyVq3AwuKRhtQgRFdYh4KfkQxBuzD7mSxyD
37319	payment	2133	2133	1874	1	1	4556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovmZaNiP45iN6hT9CdmWyB4PQzP2eD9EaAJp8eMkuzuFfzCU4
37320	payment	2134	2134	1874	1	1	4765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwyHnXWN8abMbsNXxkm4fj9itMHubynojqNN2LQoxUP6etw67
37338	payment	1397	1397	1678	1	1	14331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh3SJECjUpiiKcH5VHpmH52JxGQobemaYYd6jHAXyooKejJ9a
37339	payment	2134	2134	1874	1	1	4773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ998woEvm92MW4nP4x3oQVejFF6cduFNCzqoNFPTrdeVtw5fWm
37346	payment	1397	1397	1678	1	1	14335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u9kU4t3YqyLFqopM9CNm1968fcZHAxxqcd3ZRnQyrCKsUbBn
37347	payment	2134	2134	1874	1	1	4777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHm9TrR1kXbRg73xUqzgNGnifESwNyLiGpCtLcNHWJkrGmhPKc
37348	payment	1397	1397	1678	1	1	14336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiPTP9m1y3cGbBoPRqU1hu9WHGWHB2s4USCdok7gz8UGmYPpu
37349	payment	1397	1397	1678	1	1	14337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZduhviryFsSmgnhWqcVDs2UwfWAX4cTz4NhEAZNQUz5ti94jnK
37350	payment	1397	1397	1678	1	1	14338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Q3KT1vLGSb7SARPVcZvx6MLLjN1MvVbNjXrYrhoeK7NcYBzE
37351	payment	2134	2134	1874	1	1	4778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufSa29DJGn5gmwqpxM1TbLaarWZUYZsDrpyYoT1xViU7xLVSv
37352	payment	2134	2134	1874	1	1	4779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLNotLeEUEyZoRvdYxceDaQrrG1gPyeAwGGckZ5moe3jY7CCG
37353	payment	2134	2134	1874	1	1	4780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDMD4jXmFWtpk3y3REQfV7ujqx5PXPcEibT2LjqsqoYnSrtRr
37288	payment	1613	1613	983	1	1	9	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiBHs1MpVhoYaJJhxJ6o4ohjBCyGNozY9jTv3erh9p5rM7xrq
37289	payment	2133	2133	1874	1	1	4545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKMonf4KoXeKthxtvjRrcWbocRgV99ovUAi21a1WZ4qBwJLmz
37290	payment	2133	2133	1874	1	1	4546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2na1KRu3PL3SANSJMQjrFta8rbKXGSzNBJxGiFDGzRXpHW8Lm
37291	payment	2134	2134	1874	1	1	4755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP1KCnoH5KMRKQb3zaGT4573WCtSzmty5BXZ1jbMmYJxW1sr2
37292	payment	2134	2134	1874	1	1	4756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiUG1ZC9wRfHBnhEYKTMBRjs2wWPeZ7TJSnGLDG3Wk6am2A6P
37299	payment	1397	1397	1678	1	1	14317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn8Es2Y5U5VoeGme1tf9kAvH7XHWuftWd9t7gBRF4L4bRfTjy
37300	payment	1397	1397	1678	1	1	14318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdfR7bpdMqdxMHhucBTtQW2ZQ2tJ7BnZ9LBXkLaf62W3rS1bt
37301	payment	2133	2133	1874	1	1	4549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrjWETnRogKSCQXpKLohViDDGGvWsQinFWXM6N3wGnTKF8zss
37302	payment	2133	2133	1874	1	1	4550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWButgcTvybuyKNzcZMTV3KLy9RxG4jJpjV4hw2kbYQCGRoUc
37303	payment	2134	2134	1874	1	1	4759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YHJgaXii7oiYMtGi1VBkfrbmJmUFNPP8njWaf7EZTqtPAtfG
37304	payment	2134	2134	1874	1	1	4760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVRLasYmwRWmzyD3NUNejQZ2JgQDWG7cNyvRxA9T8WDVJ9Cyy
37310	payment	1397	1397	1678	1	1	14321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJNbVUUwfwPgKi94ksnRrWeuyLruTdZikMbeiEERCuS9a9G3N
37311	payment	2134	2134	1874	1	1	4762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGdVWPtYuq7dtJt6DqmpSiWSazRuPmzYpP9CDw9EiYr1n1xkX
37313	payment	1397	1397	1678	1	1	14322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPoWxxKa4Cc99ZwfUJrW1eKuwLEADe7uVvz5PgvGHvKdtixK2
37314	payment	2134	2134	1874	1	1	4763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGG8zaD7a2YzdtAZpe9kL93ydRmzTWsHWNDsinUDCJ9qUGGtP
37315	payment	2133	2133	1874	1	1	4554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHv5AKaoftF69NfWBMHjshkE7KKbXAU7Y6UjfUAmX2Z78FA1
37342	payment	1397	1397	1678	1	1	14333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6479kAp1HA1t73pr65L4CGTTZ9owh2ddRGwqqxkYCXbefSawL
37343	payment	2134	2134	1874	1	1	4775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPfaScSfNfcVHZhXMxc9cLFsjbhRe9o8nsLmHF6UY8jyVVjGp
37364	payment	1397	1397	1678	1	1	14344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGybXyTS9nhahmoiuRTYNJgWuG1HaSq4hHFK2TiPjGkwNtzNF
37365	payment	2134	2134	1874	1	1	4786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwKQ9VZSnZEb6r7aAtvfDvXktNsa918xBPtBBhWQzLMCvPt9B
37374	payment	1397	1397	1678	1	1	14349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpHxCWpipMbPKGE6ymxJRFD1G4ooNYbHZ7XygSMpqkvU9u7Ra
37375	payment	2134	2134	1874	1	1	4791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqajbPbKCnsmNZQ68tvR7qDxoCcaJju9tMTpgJqzGrHmfX7Uc
37393	payment	1397	1397	1678	1	1	14358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApVjAdTo1SzdJvWwu8voh1pPEZtjFXJKgebH21UsQVacyfgbv
37405	payment	1397	1397	1678	1	1	14364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdysAgP9uEcGfuqWs67kn4hCDm5JEn5aoFVz5ELQ18tEAcKToR
37406	payment	2134	2134	1874	1	1	4807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgucUvEic2N3hMustubQkS3S13g4t5E1gYaM3YrPdq9exX25ps
37413	payment	1397	1397	1678	1	1	14368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GxDqkxkDSMsrbNdFqJcoFHYmS6CYPfYwWhXcLHSDx6FVsh7j
37414	payment	2134	2134	1874	1	1	4811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxgwxq7kE7RksXsJN1w6tjVrytExXt5b7MfEPtrNpReGVtYbt
37418	payment	1397	1397	1678	1	1	14371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Hi4NgrJWRzg8Mw3YWU4mnrxuePeJBYc6MRspY7wNqJ7zMwqC
37419	payment	2134	2134	1874	1	1	4813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17gdnTdKukchm8XeS8VAbQGHKpS5t6iqaB2mxErWBehCwndVE
37451	payment	1397	1397	1678	1	1	14384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2QNZQjPNxRJ1teWmejUSTQKS3WnQRSpUBiXL2PMwcQY253xp
37452	payment	2134	2134	1874	1	1	4831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3i8AiD7XxMT2yHbLER11U5sJBifGQ2fLdq44YE8Gxg4UwrZWv
37469	payment	2134	2134	1874	1	1	4838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPrgjWMZVHtpVCMR2UMa1VfmZtZXtMxJcQJC92Jq9J9aeUEsY
37470	payment	2134	2134	1874	1	1	4839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNdehXzcGY9dWjcZEwtcWFMhyq5ibaCSpjyKPR7PXUEqduMtn
37473	payment	1397	1397	1678	1	1	14393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivRXdU7kaeZYPch3rk8xS8rVvHZERxJfjtyMpDujBnidG2ugh
37474	payment	2134	2134	1874	1	1	4840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtvcSAw1MEa1jXgUbXS8374pEEvuQTaarHeWEhgNeLYVt7Kc4
37475	payment	1397	1397	1678	1	1	14394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEchRDW3joSE4LbyJGaVPseKVVJ6yRQ56Gjx1HrU9RMKdJXGXj
37476	payment	1397	1397	1678	1	1	14395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBXW8UPJyMHJMNeyNqxEnDqPLYgF2GSjbT53cbHLVBoh5yQdx
37477	payment	1397	1397	1678	1	1	14396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3geMEVJfvUNV1Be3WRoW4yn7XjZwFp71dwpg9FszLYLLATd1s
37366	payment	1397	1397	1678	1	1	14345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxXP73ZUiFujEk6GW5YcdUxbvoeWGYT1fUY6qnHiBE7cpWoYK
37367	payment	1397	1397	1678	1	1	14346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUpgeXU7rqXLTu7BsiNe66HGB8bpUtoJxrfLCxm1DTAED3UQV
37368	payment	2134	2134	1874	1	1	4787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytvhY61beM74j6kQhQQqWEydsoRSzmDvcBqzerUguEeYbwUFA
37369	payment	2134	2134	1874	1	1	4788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvy9J7qbnzE4CR1hzswRLrDcxdujEFEwfLUEYTzxfjCFEz682
37378	payment	1397	1397	1678	1	1	14351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPJxKD685mQTKKcf3kA4e9Uj9nLYQ77WXpvGRZy3DwHqaRgvL
37379	payment	2134	2134	1874	1	1	4793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuw4x7vSXxF4CJ9nsPmWNkTu8HtUHRPMoGckgxZuENXeSaf2Bb
37380	payment	1397	1397	1678	1	1	14352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDFVxVbUWQECJjt2quBd1PiCfhtCat2dXmCDQYSSpr7XVUcub
37381	payment	1397	1397	1678	1	1	14353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzTkSXr6W3zYLMUQSeBGANupXSNPe1G5qCLnMFVrFX4KZXSxb
37382	payment	1397	1397	1678	1	1	14354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu87b6azsELfaT9euvRS87a7Vdt6WuSUH26M6pKp7t7F6gtk7f
37383	payment	2134	2134	1874	1	1	4794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKxyQtT6mgcqWracUsCpvqndQ6XuRgrg4sHJKcjFkuxFoJR4S
37384	payment	2134	2134	1874	1	1	4795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGTdky8j48G4sGSCm2bKudR1kuJLdLuhBcaMWmHwpdcDqQFiG
37385	payment	2134	2134	1874	1	1	4796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1E7SPWjfrbjafyW2da8aRDg5ijGWiTRTdfcDHYcf15SKT4Ue
37386	payment	1397	1397	1678	1	1	14355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAN7UPG3sYp8XCJmSbVCptsmzrEKNbfpekUdNyjs39CvVU8LxY
37387	payment	2134	2134	1874	1	1	4797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJCtWHNDr9SRnSKHAM8Tr3VEjXugHuSgPfrTq1rhwpj8PJgR
37394	payment	1397	1397	1678	1	1	14359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFKAss9aohZp5tZ4tTQnVRwViwf85hv6TnNbGkAantrkrVWp5
37395	payment	1397	1397	1678	1	1	14360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgDW4Z6H2heq2CMGPU9ajU7miSx6h3Q5i9RedkADQWTw3zX8vt
37396	payment	1397	1397	1678	1	1	14361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuccJ1bU2FpfQW9ubMfMcDBQWVqLXW8N9xtPPetMEvvgRfFBW
37397	payment	2134	2134	1874	1	1	4801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u2dgGMTyP4fAunbVUZ7gBYj9zQfgwKWxEkn3M3jeJzKRB16x
37398	payment	2134	2134	1874	1	1	4802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3X3Uio1iRyzUYvJ9cZrPFfgp52mxZrZy5bWgGwMcxJnEGtj2
37399	payment	2134	2134	1874	1	1	4803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8n6oLvC7orm97JeX89ay54axX6DQgjsyqec5NgUE8jGqwvdB
37400	payment	2134	2134	1874	1	1	4804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBYXNxrqNN9WwGQEYf4QmpxXt3LPf3RsbBHrFJcXtnPX4cxax
37401	payment	1397	1397	1678	1	1	14362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcc2Xz61coPT5Zh5Ptf1YQWdaNwM2G1y6tct12ngZGQ8ZNWEm
37402	payment	2134	2134	1874	1	1	4805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFQgvcD4E1CFHz9NFEQniq1kZp6i83Hs3GUZKSj9trbVnVFHd
37407	payment	1397	1397	1678	1	1	14365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sYieX7GoRecboWXE3FuG9DPfoAqMiVfyKH2gsTtwp5QcjvGs
37408	payment	1397	1397	1678	1	1	14366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45aKfhA1mdcnoV61t1LDCGrQsYAMqTxaSHfpPNxR2SbWjkDvR
37409	payment	2134	2134	1874	1	1	4808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmhah5xrPjjigAapErsx75H4rdYuwCfNPLdG8wRKB3fndSmNR
37410	payment	2134	2134	1874	1	1	4809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrv2WtC9LDwwb4AYy1HjSGhCcLprVDLNwgAoDxuVVhS9guiuzw
37415	payment	1397	1397	1678	1	1	14369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBodmMEmwmYGZNd4S6WXu8FCAcigBrTC3AaFAxxgzi56TV6Qb
37425	payment	2134	2134	1874	1	1	4818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLEY3bbj52SrWRkDooZwHvZbij9cMJcfS91LWcgwcQkzqu2gS
37449	payment	1397	1397	1678	1	1	14383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEicNvhSa7Qksx4S5AyospX7V3T3SQqsvQT8qwHLVHg3h5PPL
37450	payment	2134	2134	1874	1	1	4830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBetdTFqHH2A6hfKhiFhjVhrWbHmetBRHEkgKHMXw7NH1u7842
37471	payment	1397	1397	1678	1	1	14391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSB4iUpdZoU7HPLthdAgrhsnYZU9oWDutYHkMkhYg2mPtWyNN
37472	payment	1397	1397	1678	1	1	14392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9QC1d1shBz7AQm4jbsQn38q75G1dgZqrmz63qPpGo9LEVNMD
37481	payment	2134	2134	1874	1	1	4844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJH9jNSnJnjCp4HC1kxse187Gk9ZQJEbHajnjmx4u5snFp5Gi
37482	payment	2134	2134	1874	1	1	4845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiz6Mvpqu8Qd6Y9efSrdE3QPXrvCxqCAfiNmcYtZbjcP8fcFW
37485	payment	1397	1397	1678	1	1	14399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAxaDeyQ2jL2DtRkLLnUTtpVYqYGy95MDK1TnjqjkjLN96x2K
37486	payment	2134	2134	1874	1	1	4846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1TYUrQfQv5fHihno55Tt6drVjPSfehyQSik9UPT2Pbsp7hn4
37487	payment	1397	1397	1678	1	1	14400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuRrTPJwGBVKMQp9XAB5uzVxvLj9LxgaVMM6JjgFYcrwkYKng
37391	payment	2134	2134	1874	1	1	4799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngijDhgViwxWxdvDPnz1TxZSUgsgH4PoxMN6PfobCcM7FPufA
37403	payment	1397	1397	1678	1	1	14363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfMQ2AUke38cEEioWXYWCDzRWzpKBGLGiSUypiEJoD3H6wHD6
37404	payment	2134	2134	1874	1	1	4806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6i4RXsiyXLtYsSJeQAieWhDvV4yAvA2cUif3d3CrDADY39yb2
37411	payment	1397	1397	1678	1	1	14367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71gjdr2umSCMWLxawjA4aS2Bd6yju46XdvRgcWaYgTgrW9Fnp
37412	payment	2134	2134	1874	1	1	4810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPQES3GgbT9BqUuogLL45qarCSzxWESidkQznyBc3Pv8GThUr
37420	payment	1397	1397	1678	1	1	14372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALqYt15AbFawtL6xhaSNqQLqTrbrb6SrSN5eEDYQjYqMTGkBf
37421	payment	2134	2134	1874	1	1	4814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzK7rwTax6VR7cmDZSLkCQujFrza5jKLQmAJzYqExaNmK5Yvz
37422	payment	2134	2134	1874	1	1	4815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1aF7BarJ8S8g52yBxFstibu66AtCczrgWCEGkCurT2c5BHfP
37423	payment	2134	2134	1874	1	1	4816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJE2uUypf2icrHcdBVHJL6F2ikDpBmTj8J3Gd8eETt6XjHxNA
37426	payment	2134	2134	1874	1	1	4819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLc1FFLMr1vNMrwjmtLLEfmbJitXgaug9rksYrpvzwPHDn1MB
37427	payment	1397	1397	1678	1	1	14373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNMFujJvgKo1h7DxNgE1gpbvwpcKwHwoH7qjjerMH65Wpw7ws
37428	payment	1397	1397	1678	1	1	14374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsAaXXRw3WZuffhyHRJcGHNYvrFHe47k7Nhbg163yTTVGszk3
37429	payment	1397	1397	1678	1	1	14375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzGbVsiYKGWLR4Pjg8k2cgjyuhj3DGwrgW8EgohrBeLHMPry5
37430	payment	1397	1397	1678	1	1	14376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Do5MbJ25iQyezzdnj7XRT1Rfhp8kshD6CCUMiQAtCxdq3XGx
37431	payment	1489	1489	1014	1	1	4	94510000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgfJ3cELKn7ABtb9mYHfdpGwMS1ibD6GCZy5nWU7dRhK9rEJc
37432	payment	2134	2134	1874	1	1	4820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczQ2EmXCUTcNwPr2t2HRxKwGiSKbxmmLVvgMZS41CoUHKi3kp
37433	payment	2134	2134	1874	1	1	4821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGGHTGpNEg6qTZvCJ44CMJJN5kixNynWEJVEJtZ7eYVWCWR8WM
37434	payment	1489	1489	1380	1	1	5	703940000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNMVLfAVnKBmPrvbGkVLEtPCRde9iPXMefqbxFRPD7nCsQTvy
37435	payment	2134	2134	1874	1	1	4822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxG7b6dqWrwzjFqA9BvjfZH5yLmt7yZwjQ9XoVNS8EKxF7JZzn
37436	payment	2134	2134	1874	1	1	4823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7VwMtwn58xSREeHAv9rxsxsxYVnuCFcqqbguSz5e6U77t9Fp
37437	payment	1397	1397	1678	1	1	14377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJ619ydMz2ThEYcqoSnoi9MG6ya4WGVpQ1a3KPgJvhKvg8ev5
37438	payment	2134	2134	1874	1	1	4824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFBgBoMnj9NXxmhG3S148TfLCQvSc7ajdN7hpCy7aRNvg8Brn
37443	payment	1397	1397	1678	1	1	14380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5cwaererY6siDvEKnTantBuPxh1iVBXCXZupd3FWKDzULRni
37444	payment	2134	2134	1874	1	1	4827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSWq1PnNnrhN5zseZgpiNC4MSXvC6hUFLsG12pqNJWZB3Hauv
37461	payment	1397	1397	1678	1	1	14388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3JoPTCB8MksAnGG6HLC4h8XKyoqa6ePzWJCFZ6F365pCtnQ6
37462	payment	1397	1397	1678	1	1	14389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheSBy8RfWD4TFWntxpDXDGsrR9SG9qRsQx5xGjQ7aEC16eNjC
37463	payment	1489	1489	1134	1	1	8	4084870250000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehJP5MC32Aot2S5Rxw2ysjF8gZHxBffmsmdEo9J6hvSLZQgkn
37464	payment	1489	1489	1014	1	1	9	2279514390000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJU5Ag6EenQMz8ACKCr3hhU4KXJa6Wki4cLWHW3rME9JE3pCR
37465	payment	2134	2134	1874	1	1	4835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVk6GZ9oyw38WEqfYoJF4wThPDhbGfaDPpfAHraBLEiirfmJV
37466	payment	2134	2134	1874	1	1	4836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kMj78tVHM4ZjLaXXGhWw7tY5bBGVk3B571a8HZYjz1XXYmqH
37483	payment	1397	1397	1678	1	1	14397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8Pn5nvX8hjncyRMbC4Nhs4D52f4c1EKT2GDeenC266PMAL12
37484	payment	1397	1397	1678	1	1	14398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcszHRq1KQrZStDK1e53PPS7Kz42SmVdoVS6YEnfPjyXQb3PYs
37500	payment	1397	1397	1678	1	1	14406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hix2Wf9679XywDbRnyYZ6z1dTgQ3NEZtvNNQPSWoxHr4Pedj
37501	payment	2132	2132	1874	1	1	1315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWhaemdfFZXGjKaHs4fXQRpmpT3dyJDty8guBVX5o2GSFdn2B
37502	payment	2134	2134	1874	1	1	4852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZty5w1EdD4tZiAG4wK9HsE5Kn7QP3Dun9YahnTmWBjcCfsuWQQ
37505	payment	1397	1397	1678	1	1	14408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRYqJxH67FbJ4RCiQh598Btd1XsZAVEhjWE1YXGwouypAHU3A
37506	payment	1397	1397	1678	1	1	14409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwzTaK2st3ecQYY5zn7wzg5avpTwrRcUQzPa33WuLnAf7Zt4Z
37507	payment	1397	1397	1678	1	1	14410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTHjZUzTQEfZPLEWBr8novYspchA1S2qEAAVvZVoi61danQR8
37445	payment	1397	1397	1678	1	1	14381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLndMu42aUZbZp7re8Xeo83NhtGWJgdpykeZEH1uB7DNEynXCz
37446	payment	1397	1397	1678	1	1	14382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2JyMPGrx8g31B5BuWpA6Rds7Z5MHjvzDsvpHzQdZsn5m8ZFv
37447	payment	2134	2134	1874	1	1	4828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgv95KXM4wXqjSems1wQTfGmkkQjZJTk5nXi6o4vRc92irpJd
37448	payment	2134	2134	1874	1	1	4829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6YPnztohAJPinnL8ikcXXw55e6UkHFbzcrrRwfoqEo75MqAL
37453	payment	1397	1397	1678	1	1	14385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitGxcXqTDe4eW5619phG3SJy7mJ7QKwykBVtM6dFU2FUWRZo6
37454	payment	1397	1397	1678	1	1	14386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqLyxp9tG4gUsVUsEf4eFpekCeKiSXRHjCBbmHqSiB5wHH9SW
37455	payment	1397	1397	1678	1	1	14387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMWXYfydK2VrZiN9wve8jzbRX1ejgt4mNixYNscvqq1jJYffo
37456	payment	2134	2134	1874	1	1	4832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9ZvpDstVpEahM9oCZ83JHujNduCBbPH1pXTd526zVdWE98Mf
37457	payment	2134	2134	1874	1	1	4833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9oHqakgRPp6eVfEVmX8m28DVt7iPFDrVL14C2FaELccMVamk
37458	payment	1489	1489	1380	1	1	6	7680238520000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAnjxmY2FuwVedreEivtqiQ4zGKUtxDMaPz8R7WKt8DhNXEso
37459	payment	1489	1489	1254	1	1	7	2756143350000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNNGZtizQR3pzjEQrzpjFJDqkiS4ssY5oQ17YnodbmuXTvGoa
37460	payment	2134	2134	1874	1	1	4834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeanRRDE4KhAHeHAK78yGW6DNfGVNWt3tcsmPRPzCsDtNcooFX
37467	payment	1397	1397	1678	1	1	14390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXpn8yV4n2V7Ldo3hz2cLqZTXCGnRbPtyWa6AStfPpRzJXT7n
37468	payment	2134	2134	1874	1	1	4837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFTTh2nzda2JSDQKCpjdLaCmwffJNFPYVZKeVN6G1WfALruVy
37522	payment	1397	1397	1678	1	1	14415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFQaoE3yhpF3uEVCbkfUtpREMgd8k7PYXR7H3tKEcYxRAp4Do
37523	payment	1397	1397	1678	1	1	14416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwFtGgWUTFfqQouKEuVC4PKepoKyuY4oozYFhpZEtcFFqgApZ
37524	payment	2132	2132	1874	1	1	1318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrG1h5BtMnxdBCsU2EVincovyb2wZ8VPWXwjk55JkGAUBW5Z2
37525	payment	2134	2134	1874	1	1	4861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQXXjaQxt21R6x2BxaJ2udzMN2599BXeBdSC6PaBguAerFnYA
37526	payment	2134	2134	1874	1	1	4862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQy6ikmwiGMWaZXbfM3TgisjTVQ8vmUBJXWwfQa9Jcr3fuo3C
37535	payment	1397	1397	1678	1	1	14420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWFYWjgQoZbXM5uoxwSf2g23Pzz5PtSAxESns2ajutbas1e5T
37536	payment	2134	2134	1874	1	1	4866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwJPEmknWuXxsBVpDVXUSTe4bb8bCFywfbuaTH8Yn1VeMhRKR
37546	payment	1397	1397	1678	1	1	14425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2GXUwScYRLtfRZxWRqdy9VEpHaSJSJ6QkDQk9CnrSUyQNS39
37555	payment	1397	1397	1678	1	1	14429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ7rDS2GduZzGeJHwfRGk7jaky6933edUzst8sSnnTZKEF4aZ
37556	payment	2134	2134	1874	1	1	4875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefSmoYHkbdDEhHBZmQHexPNaT6JbCv5zdFXTTzRstxAWQ3e7T
37557	payment	2132	2132	1874	1	1	1322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypxCN8xEYkmeK7SGXgpaAu7pf6G5gPeeEQC1hj2TrtWQedQj4
37580	payment	1397	1397	1678	1	1	14437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4hYU8A82Pby5ojxB2dcKBZsMHpWLJuAHv9iMry6h9yQ59aJm
37581	payment	2134	2134	1874	1	1	4883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyCJUCztdmo4XQUWSap7uAZbD9FFcmCssSV851NFemtrUJLoa
37582	payment	2133	2133	1874	1	1	4566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzCdiYbNEhehQYraY5aDMd6SNYo5ydu6guiE4uEpHj5Js8BQz
37608	payment	1397	1397	1678	1	1	14446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwvTRB5fqzhSuJt11AJLEzNVZKCRNHXjEovzVsPyGfDiztjav
37609	payment	2132	2132	1874	1	1	1327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLJr1qGqytnzhFyGg9VBJtuYsLuc4VTshiXnPUiwjLyTRVuQE
37610	payment	2134	2134	1874	1	1	4891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SpgLRM8tA1sE39FUDYd9WnjePEBCH1KLxDLUdkwfLusHdsBW
37611	payment	2133	2133	1874	1	1	4575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgewsD4XqrcnKNeNbK99rEK1jvJQAwLRCwRm9mf5DPQcto1Use
37692	payment	1397	1397	1678	1	1	14470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENbuDaLrNhTpDUZJZh8CJaRamu1wBDoAxxLTp6Adi8g1AaNMn
37693	payment	2134	2134	1874	1	1	4914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXb9ZbUoMvrwJkwbBbpRkUpekzEiav6wLK1FgXRAoHXdN5otVS
37694	payment	2133	2133	1874	1	1	4599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHanGsig3iWkjzMuipGvQEsj5T4CX2Jd76uyfc5xnrzk1PQJYy
37695	payment	558	558	2312	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2BFeJ7DCpKEWz54fEzw1AUieemKiHLkwUhV4crvepSh7UDHo
37696	payment	1419	1419	2310	1	1	7	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufFypSHaRjxLmeDj68awMucCAYo93RmEyxMrsNT4rHzvgWWgL
37732	payment	1397	1397	1678	1	1	14481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6DtkGX6HrifRpjMJCbCqVeAojMfKW3acAemMXLTkuobz6gma
37478	payment	2134	2134	1874	1	1	4841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx5b7bMH7eHY4LS2RZuiubdqMmxuZvrKpBajAk2RKvQyPFAzH
37479	payment	2134	2134	1874	1	1	4842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EkBsZ5yGjLPrexzR3SjyJHX4DozC7y4WHCoYvZWzpQe9yR4b
37480	payment	2134	2134	1874	1	1	4843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8ncrYZNXDEuLUNBHLSQx1cRvjxduRUgJ4sVK6TPDUoE4obN7
37488	payment	1397	1397	1678	1	1	14401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVrahEZjerVCti3GGXEWHp2BqosA7JDHZvKhsbp6S84yKJkx7
37489	payment	1397	1397	1678	1	1	14402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaMUf2VBZuuvkqsWomyFVPQNPAdcoZdkRTUUwQ6ALvsfnBUHJ
37490	payment	2134	2134	1874	1	1	4847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmFj8A7R7k6XzFKhtFg1PomN1mJULRnHiwbcoeomrhfvPi6Xo
37491	payment	2134	2134	1874	1	1	4848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3URRpginbLCDL9e8LG6BwAvuEmfbeZE8yLWFReumjPpNY4nak
37492	payment	2132	2132	1874	1	1	1313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbnkJkR7TwDmAnwE1iPTvYDTzXuNX95gEpa1pADacvTiRGzcG
37493	payment	1397	1397	1678	1	1	14403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNzTjpKk4yYtT4AruwPqPVvupRFGaEGJggbUnfRpR5XTmg8CH
37494	payment	2134	2134	1874	1	1	4849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEBUTQKs5jzRNPoFqrWY1aTVq76iQh5mLRdviqiKDZUiY8q7X
37495	payment	2132	2132	1495	1	1	1314	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCu88jP5S4YAgTXRx3jt4EsqMXCt5fNdRevke5BwnZm1RWaKH
37503	payment	1397	1397	1678	1	1	14407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKWyucxHuYgmEwFinQ7T5dhkEoXKbEddV6X9Wv1276SAxvGmb
37504	payment	2134	2134	1874	1	1	4853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAqgAMpYPEDWAa8ucXjVk51PWvqQSstVkdNbLoHTJXxGn6gxb
37520	payment	1397	1397	1678	1	1	14414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecAAwwaeuEYjmFo7CQN7mU1FivcqkeABAaFdhSmr7r2uPuLFN
37521	payment	2134	2134	1874	1	1	4860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuX4qJrCriTy793kVkbLgcEtwJ4BnP73Hq7CQGxz6fMeaMRNf
37547	payment	2134	2134	1874	1	1	4871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUfVCVnHqxzaZhMVjxCQMCHWCAUGECKJ4SFU8sHMuYWywWr9a
37548	payment	1397	1397	1678	1	1	14426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCLLHRFtXhjDzmsrvXDB5zg9WTrtcmP6NCQhxCS8b7b3wEL2E
37549	payment	2134	2134	1874	1	1	4872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuPpDcDodp2x825tzBhbz7VqsH1RdKZBX7koFXqwHGcbaB8uM
37550	payment	2132	2132	1874	1	1	1321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnWspz8pJQakYXMP5gK1qAfpr3nnEWj1TUmAMRCKkHVT96z24
37551	payment	1397	1397	1678	1	1	14427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZ2Xa6zyGGZos2ZzkXydjVyVYhZVjnh4rKmps8hq8RYVZBNJP
37552	payment	2134	2134	1874	1	1	4873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTg8ozzwe8x6Qinr2Yv2HfdjfPryeEuUvPrnqwu7TRnjnTa2Fn
37573	payment	1397	1397	1678	1	1	14435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVB3Gcf4fgTDFvaYfuPdAipT9wVaaSKTVN7dGEYDr9W3pQ8S1
37574	payment	2133	2133	1874	1	1	4564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhw8MQ4HMrQstLtMpKvAHt39TZPAbR1bjvr2xBLLimQuaCVohF
37575	payment	2134	2134	1874	1	1	4881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aye1nWwNzburGbRsLZSSuGkgxNV3U5f5VKD5bRXLzaL3GEYn
37602	payment	1397	1397	1678	1	1	14444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrenTQFXb8ozAnvTdSDohjUJmwbYcKNM4kZWM9tKwNxuNbez7V
37603	payment	2133	2133	1874	1	1	4573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtN1gviAdhNmFagDJU9Q8sakiW8roJjVHKTer2VbcR1rBeKpA1
37604	payment	2134	2134	1874	1	1	4889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDH4fsKcdwY1eLJM3bcpHVoNtWJqjZhFotXMCRSEza8qfjXNcX
37605	payment	1397	1397	1678	1	1	14445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeu9LZsQcVWtH6yF4LPgvFMfbcu311tbt9Y5T9dx1bcWKaWMBV
37606	payment	2134	2134	1874	1	1	4890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeVmZxrdvs1Eky3HXFRSP64Lbi1CTWyAtC53gSYDoKcwSmDXC
37607	payment	2133	2133	1874	1	1	4574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhW3B2jt8bKa7L4ahHBjt7TQQ1TWPzSjQhLjAoGzRnJWSZ4To
37628	payment	1397	1397	1678	1	1	14452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAWpTgGgcAckgZucYdQBtiVJ6FGkvfEnLxhiGETyWJC85DMdq
37629	payment	2133	2133	1874	1	1	4581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfG7Ck7Bh6ZZb2HNRPQ7k94SjP2nf33FaTqXrCJJ8wYQvgJ68C
37630	payment	2132	2132	1874	1	1	1329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKcBpKTf5p3Y7rRk96Mtd5B9AMfnCGe6qMwT7aETRSzG6oLSN
37631	payment	2134	2134	1874	1	1	4897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Y878K9TaU5xRjQjW9HjW9VqjZHGK5zYJ61hpPrx3fW2NDGL6
37632	payment	1397	1397	1678	1	1	14453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqowV1aUqu9NMwmYApVps2QVniGDNbUaYwEMHkHYfEXq6ptNu5
37633	payment	2133	2133	1874	1	1	4582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczCKxFp1Vzrs6Dib1wotjMwm3obtKyxVhTYo8qFPk5pvuoVGK
37640	payment	1397	1397	1678	1	1	14456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoKniEXV62anVdLMySNdB9AUvrc1SvnKrdbn6NZQBSzo66hfM
37641	payment	2132	2132	1874	1	1	1330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGDuZ2NiKQaewGCaUYA4SudPpXsPGJ6cz1X54Td4uyKF8dGrR
37496	payment	1397	1397	1678	1	1	14404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3umYPFppMLydXXvB1TJKsLB8fNZPFfKRhM1wvTbEpXJf6kjo
37497	payment	1397	1397	1678	1	1	14405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpcCmBwGd5JR3Fudy4bUUHikM7YkQjcKmGYT4J6dwms9eX8xT
37498	payment	2134	2134	1874	1	1	4850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzQEMUKFJeFRFonWsXrtuyw6kg1skTPQ6xvT9tzT6VUVKvcN9
37499	payment	2134	2134	1874	1	1	4851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JAmoq6xFgBtG3JsS13zjMDr211Naz3zKKvZTBkfip8ng1d8f
37514	payment	1397	1397	1678	1	1	14412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvenKWXy2HiLzKeEWEZQpPBwvwBHFJUvuLeRtsqGXVML2ayYHF
37515	payment	1397	1397	1678	1	1	14413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6YYFUYzsMerAaKhyjP3CMte1ExbfXvDuwE5bzgh9EaiT74Px
37516	payment	2134	2134	1874	1	1	4858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLNf6ycjK1ijbB7ASahtbg4d4VxQeYQnVoD5hFSrMJnt91MwK
37517	payment	2132	2132	1874	1	1	1317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNmbomTfKjAgV6rTWQPBYmGTLgygZZbLpKh77giRhkBqeHKQH
37518	delegation	1925	1925	1401	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsK9Uc5TDkMgHnkTwd2CQD5jKnzdoLGTKi9cBTiGPCVH1odZu5
37519	payment	2134	2134	1874	1	1	4859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3JwPAhCeZBPCHTSX8oxvZyMS3wPktT833Q4me8vhFYwwy1Vh
37537	payment	1397	1397	1678	1	1	14421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbe3eWYXYRh8BScdbWLX7N48TVg6tUmpAHSaVbhbSBP9sarva
37538	payment	2134	2134	1874	1	1	4867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94YV7c8gipxMR555GUQaYZXzkGyaJTkyYcPb7fRZB3nwdfzaD
37539	payment	1397	1397	1678	1	1	14422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUG5TZyBTPRpuiqovLN2sXFPXsCd3t5vtYmKiwjUReZhiB9cgj
37540	payment	1397	1397	1678	1	1	14423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR2DoF7oxj9AotbhHX972yu6NZUHWvqefkMKB9CuCmeQtJoJj
37541	payment	1397	1397	1678	1	1	14424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JCWyNywT8Vp8TFWspsbBBvLi2UTRU5xLDUhnRPka5J4Vj3Ka
37542	payment	2132	2132	1874	1	1	1320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRvVGfE36d2RgV6TPwupqzyg8hc6HYNzBnNRBpx9t6BbBPd3d
37543	payment	2134	2134	1874	1	1	4868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24YC89jwoWxCZzy1CK5iai71wTh9Gwu2KpssnysBeFHUsyYmp
37544	payment	2134	2134	1874	1	1	4869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHoLvUZ5RGbhgksWAuC8EYC8yD83WQqofabqrEn9ahihtW9H9
37545	payment	2134	2134	1874	1	1	4870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCsx1iAt8ivYv5RTCtr2FeVfeq8wpKP1kZB1K1hMb6d1Gk93G
37553	payment	1397	1397	1678	1	1	14428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnpV8WYrSXQeus4MKEdUXZEDtiWxvQWHjTPcKyUKuX7P3q1RN
37554	payment	2134	2134	1874	1	1	4874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaCuYAuRrCZcn2KQT4tZsgrkVpmtmoQCpwXk99RV7Vkxxrzr5
37563	payment	1397	1397	1678	1	1	14432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYei6YRfKHTMohxfLEwna59ebCXWLLJXthtJk5vvqSFscokmbYZ
37564	payment	2133	2133	1874	1	1	4561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXsQt5jkehR1KhtYUe7om7ZfjhyTBYuDJU1z7ovRmw46thmhJ
37565	payment	2134	2134	1874	1	1	4878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmapp9puj1HmAcRDEfLPhjzKCkTxM66iMVBdNz7wYvhjwEm3pQ
37566	payment	2132	2132	1874	1	1	1323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhHgHCrhgAHZofHKL7oSjEvFEMohcBu2CZBda7P3pZHykPYdN
37576	payment	1397	1397	1678	1	1	14436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoqpB7yvRi6qfmfXpQD7ChCcH6foQDMkAUpwkZGY5dUYFLs5s
37577	payment	2132	2132	1874	1	1	1324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhuMPxCvtbE5cRZakgDckmXT7h7YbdeydCbUxHhsdUYcEphrd
37578	payment	2133	2133	1874	1	1	4565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnCx8TyV9KQv1Trq2dgseLca4XV6qfYWah4mP8rMpiUUjz56z
37579	payment	2134	2134	1874	1	1	4882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHQZkzwQSeRbxdBHrGxpAn2Nzjz6BhtRuYWUsyzq1XZYAjRHH
37589	payment	1397	1397	1678	1	1	14440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wJQSJGjSyEpSch4zHPYGGiiWn2U33hGa4vFBn1Kj5q93rVhH
37590	payment	2133	2133	1874	1	1	4569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5nQwHNnNGn6i1N7HHcqK979RKRu5VL6w8NR3XNLAmhuQGDYi
37591	payment	2134	2134	1874	1	1	4885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ372dBjTdCVfkghAV8EUQh2syaXEuq6AkDTAt6C3AmhGR133TH
37599	payment	1397	1397	1678	1	1	14443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKA5WfJynftwmHjebyAa6gxxqB3eA1SnAJP9h3HNt6e2JAaPc
37600	payment	2133	2133	1874	1	1	4572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYno6GeKR44KPxPu8vfGYwBaZXAS2FX9zrYdPsx4G1ieaaNR84p
37601	payment	2134	2134	1874	1	1	4888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDk7387jzA4oV4tvB7xTBgkhRMzkfNSJb1cY7tbapRdXkENMc
37612	payment	1397	1397	1678	1	1	14447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsBJ6dBXqgm3pamzwSzuHf9jcyHuWUVvquXLqrrX5mjLJnbET
37613	payment	2134	2134	1874	1	1	4892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2sZhz2WMFKzJgmTE765auHvkVZRLT7dotVckduRWW2MHi4Lu
37614	payment	2133	2133	1874	1	1	4576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnKC6i4qvM42nB8nYKLTcjX4pAcBq7Mm3fmzrdnRk7A7ii4gg
37508	payment	2134	2134	1874	1	1	4854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7fhLrXvt8Q3qjtqaf2NEWCSYUVgm9Gj951qfHQP7VTs2hWCP
37509	payment	2134	2134	1874	1	1	4855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhESrzMubekQZZfMuYRB3usjbxuHU3NJJpYiyhMpmHPePRDQJB
37510	payment	2134	2134	1874	1	1	4856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuKUTax46TUd4GnGFV46Y7Zkq2ZEK4db48z47nqyHjVieWwcS
37511	payment	2132	2132	1874	1	1	1316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD3bnZW2GSgesER7p4CRJdXtq3WA9pm3mVDghnP3hrVfJiF2b
37512	payment	1397	1397	1678	1	1	14411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYh9VFRQksjU37uxbMk5JeWWHVgqRTNqyiDHab8Ttn2oTiCf2F
37513	payment	2134	2134	1874	1	1	4857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcWFWV6t15qAuQWHhLfUzLKo1grxJphCJDCyMHASgWykCdtsY
37527	payment	1397	1397	1678	1	1	14417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8D5msCSoKhYc5uUmiu8gFBD8x7SmGs7t45ejEd2SQ2NsJbypp
37528	payment	1397	1397	1678	1	1	14418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVN8jevnmfwcJdAFYZuBN7Tig59FP3b974wR7GyZZTRgGhVDcM
37529	payment	1397	1397	1678	1	1	14419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXdZ4QcNw8ALsurfUhDtt4RmCgTDJ4JTyz5PQAN3mMMgqimBG
37530	delegation	1924	1924	1460	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDTco1fvsLEPwryYgCvXhdTAuNfF77FfSVLKQ1jMyUXgQ9Xdq
37531	payment	2134	2134	1874	1	1	4863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWhfGNLPhNMsCNdkZLAibSipK7VjENtEqaNEesmDV5aErd8m3
37532	payment	2134	2134	1874	1	1	4864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtipYaM3KMqdtdxAzn6DXJENSRjtYqzTzrnmqnARSnBfamop4Q
37533	payment	2134	2134	1874	1	1	4865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaDwXmbjPyzq73D9JTHZRw2g1NMQYnCoVJ48uvGx7Qr4MsTrx
37534	payment	2132	2132	1874	1	1	1319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6sRNXAQ1A2oszdbtWhYV4uq7n4aN8KgMn1bU8oy8ipc29qwRQ
37558	payment	1397	1397	1678	1	1	14430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDfzup1Zy7H2WrujWdBDswW323K6cZZ4rbyQi2ZWkTmkGotjY
37559	payment	2134	2134	1874	1	1	4876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCUDaWxzbhho5xqsoHHnPdtvDFpfLQ5YkAYGymLYa71PkpMF6
37560	payment	1397	1397	1678	1	1	14431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiHEmMySNz3TiGpusw7LKyWmSaPkxXgLJnHjzJdgCF48orQWA
37561	payment	2134	2134	1874	1	1	4877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosunnyeRrk1L6rbQpZTUJhT1tDMaby9nSTumR1W7Xt14G9Cej
37562	payment	2133	2133	1874	1	1	4560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKKsWQeKqh5ATCH5r3hE7aiAAznLPo7wXZsKQmnxHGDMGFQgH
37567	payment	1397	1397	1678	1	1	14433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vY64pQExahCDY2vWwbQ3TnxP3eBeogmpoic19ZS85SZsDf9L
37568	payment	1397	1397	1678	1	1	14434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtowxJC6xVS4nSGaqhoRznGK5qY2GxWjpvATp84M8czugcYGc9
37569	payment	2133	2133	1874	1	1	4562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAx6pAxrcKDu4jpNeci4d4yb8bbEDr2DQxJqaVfi8doJVSMqW2
37570	payment	2133	2133	1874	1	1	4563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5Jhp36edDLm7J2jauVyKEx6bqaKh7gV6RouBtpzuaZSdaTCV
37571	payment	2134	2134	1874	1	1	4879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCnpzcyCiZmaZw8gPG4WMcfqS9h2LFcFAesgoC8fX7MKPN8dN
37572	payment	2134	2134	1874	1	1	4880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVAdcNDuB5EXmd7yioavmMuPAPE1mGQvqyK16jNY9rhG9DKzn
37583	payment	1397	1397	1678	1	1	14438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUnGJQQjw9oq7iYRzZhkyYqzxT3j83FRxwHCMQj3h3dJyUdi8
37584	payment	1397	1397	1678	1	1	14439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGXNuMa8LxMd3USdWhEJMPQ7C1t7kFFkEDuxbXnLLDCoSduqo
37585	payment	2132	2132	1874	1	1	1325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhusnsGroYB5SfjmQViFMyHPGvoG4b8Xoqxa8VbnXUyBjEhozA
37586	payment	2133	2133	1874	1	1	4567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ko5eeoHZdTVp9nL3xJPNYE45ibQfwdZg3CB98ggh9JzYWuKh
37587	payment	2133	2133	1874	1	1	4568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyZWur51nW7F93d7WCq1jSsiC55aBt7Vo44WHKCsQf99Z58E8
37588	payment	2134	2134	1874	1	1	4884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXpFQ8wFBgvoRmGG6Q8FCCppw8ND4m5nVBmHfJ291vohbMuwr
37592	payment	1397	1397	1678	1	1	14441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZraQRZi1jTvsEb1kATo8N3Fc9yfvBrzTehSL9Ne6PoAwKM4AX
37593	payment	1397	1397	1678	1	1	14442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyBjvQbCMmhmZCu7YfRp6m6YeHouuXo5PwQTBMotj2roT8JCg
37594	payment	2133	2133	1874	1	1	4570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcc1fbba6iE6RWCP9MVRPVBtNdrNVe7mE498AaCT49ETD7QF8o
37595	payment	2132	2132	1874	1	1	1326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQ4dDsabRtLsPrGpJjUUfTRpS8dkH7uK5AKY7tYAzEBRWmPgV
37596	payment	2133	2133	1874	1	1	4571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xVp2rPYXhkAdrS1ehpSTo9YFd2fe3arGuk1G7bjZ7BpPHvXZ
37597	payment	2134	2134	1874	1	1	4886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXmqw28zxUk9EMCXUguLNuwV1YmyY9bdsp5jETSNQ4qEzVatY
37598	payment	2134	2134	1874	1	1	4887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57t5N5sWxDhqf2kb6RjSTnL7e9SCzjFtomJEQ1TBVhHE3P9sf
37615	payment	1397	1397	1678	1	1	14448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBdDKcYmhkPD1ggHP4aqVBsMZZMxE6pB7R51pxGWQJxt4a9Dq
37616	payment	2134	2134	1874	1	1	4893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jkEj4VyPrHiRaSTTFodif7uV22gkiJdWGLVQkzzAH9R2Qg7B
37617	payment	2133	2133	1874	1	1	4577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZCD5jkZq4MrWY7XYXfzwBHHsLxq9XPpY1YiHmB4ADEsJnCg1
37618	payment	1397	1397	1678	1	1	14449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdH1rYBm6otUrs1z2dVQCTxTizYCpK4fS9zZrTnWkLBq95Tvmi
37619	payment	2132	2132	1874	1	1	1328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf5zXXvfjFzVWZjZXR4VXTswmoRCcUJJsXvspsASGE8fvcSSp
37620	payment	2134	2134	1874	1	1	4894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Q4mvRnvdkyawBzn7ap6dbhKBVCKn8B5rcbhsy4zCdFc1NeQK
37621	payment	2133	2133	1874	1	1	4578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zdMmfuTk4Qgi2ikYtfcwGHmcsL9kA14GuBe13j2mG6VjqGXk
37647	payment	1397	1397	1678	1	1	14458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCNupTWSssvcHowQAHbCPssHXGHAsdhKKYFsLWwAnvYmuy528
37648	payment	1397	1397	1678	1	1	14459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nri2SACiDkhyLfC56uwzvJ5hRCSCzMGbyLTN5KwzC2a5E1mP
37649	payment	1397	1397	1678	1	1	14460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyrz5Ui3uPihewBpGCtb7qgDX7jUjS8imXYTZM65ogBQogFCb
37650	payment	1397	1397	1678	1	1	14461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMxjqsFhKCr4EU5YMjAP7jUWDrmZ3JoBRxNXGfPBrAJRpSUzt
37651	payment	2134	2134	1874	1	1	4902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ353Htz5nFXnLeN6UYdT4T9ggDnoTV4u9dqZw3spcv3wkzM2p5
37652	payment	2134	2134	1874	1	1	4903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThGcz8xGn2H6XNyDwmK3Zn3m2vbXoEYJ3R9hRf6wiQNiseV36
37653	payment	2133	2133	1874	1	1	4587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNicopNVLNFg4fqD7Uvde3j1P8fXpag45nSS9KzwZsE74dgu9
37654	payment	2132	2132	1874	1	1	1331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMshLbu2EF31tyy8JBkKfMahBk4CPRUYm2Ufv2ZHSCgXtMFWsT
37655	payment	2134	2134	1874	1	1	4904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JRiNZYxK3EA3H7r7LJYDWipKR8UWHBDLVFAi4qg1sF4JaZCd
37656	payment	2134	2134	1874	1	1	4905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC8cAekj1kLpvejKNZuRVdguWDvednHyhbugzmRWhWsptgrbX
37657	payment	2133	2133	1874	1	1	4588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzdr8PxbZZCcqxELsf7m9zGcoDS2cvUFrtkKEVWn7MeBcQaY6
37658	payment	2133	2133	1874	1	1	4589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwpzmMbXeC5ymXZ3Xug3f2Eqmk55sQctsuGj8AiKPYuTPgaG6
37659	payment	2133	2133	1874	1	1	4590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVoiNNPfVmLbZYfq7cLLwvJMNa8jU6RnfxYpWNq3WPver4pRD
37717	payment	1397	1397	1678	1	1	14477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAmB6tKzrG7UDYvVPD1ZdmvAYo2pAGUErsPrpYTgj6xAH4NR
37718	delegation	2310	2310	1419	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEn8GX1d97dnFC2V9ARXUr9B3oWcfwooMSVrquTr5Ukq8s41eN
37719	payment	2134	2134	1874	1	1	4921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfo8i6oU2JgGunF72meEe9bAHdzj7axMNNJeRPKaQmzziiERCW
37720	payment	2133	2133	1874	1	1	4606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZtPP9hgLNBnwnLjXz4ALxEDfTzX1U1XFZ6DcEThoGPkawpkj
37729	payment	1397	1397	1678	1	1	14480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGpmXgxpuWo5EWoGHaMVi1Scu7QhgmXDmNf5W4UZwRKZ5gwDA
37730	payment	2133	2133	1874	1	1	4609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RKshQEmqEfPTnmgd8nMDyC7br3mxBRgbWZQdVdNoekRpV6fS
37731	payment	2134	2134	1874	1	1	4924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGeJgF2Qie4iA189Wxx2tN1DSNPysquV4UjZkwbW97jsbDM4o
37758	payment	1397	1397	1678	1	1	14489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsEjecjfSF295LBQ66u1yBArWzhwEHNQb1FocDuFis1ATBGVX
37759	payment	2133	2133	1874	1	1	4618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgy8PbfMKwXcpMcaaKsyYCgDn9ad3bhYt5MKmRPaYadzYQuGj6
37760	payment	2134	2134	1874	1	1	4933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpgvZqWQSxHHY6uS5NX6WMsuaaCmuADiLGvnnbyuCyi7X2DFn
37761	payment	2132	2132	1874	1	1	1340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sjSaqdSBhawywqUg4F97tjnKeV4DP66kFHki7zKWMWDPtGvk
37765	payment	1397	1397	1678	1	1	14491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaw2q9FuJd4TVzd8EhVg8V2Z8ydaRuGUQmdUBAJawxNipzTMXk
37766	payment	1397	1397	1678	1	1	14492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6zL56MLVeNSAR4ebKmNcDmDz8vkFDs3fo12itFa9AMocFSJM
37767	payment	2134	2134	1874	1	1	4935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6uTjYnBrrUZrFA35dEWpHitq21pqKKszVKyfWTd8vT7QZzra
37768	payment	2134	2134	1874	1	1	4936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjq3hZ5ZgtmacosXfyk5BpS68pJFVGXx6YmdfF6Cww46RDyPE
37769	payment	2133	2133	1874	1	1	4620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CTjDcymG3AAbigJtxd62QdHPBMv5HcXTpeiwJ4fFNcbVSdNs
37770	payment	2132	2132	1874	1	1	1341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB76Huxho423cX9iwvN2rJzc6YNcfshXQYzqMtSLML7N3BxbjE
37771	payment	2133	2133	1874	1	1	4621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRQPndr5ZHGDmkj3hvPBEv4mnzvrJ4Wrga6ZUkN2ZEpSC3NJb
37622	payment	1397	1397	1678	1	1	14450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8efX2D2VXBQLEtgJXYKQm5fUfDfY6fTjjLho3uiEA39X29pX
37623	payment	2134	2134	1874	1	1	4895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoaNn2QeWXzePDbxSvxjjPxK6a9uqnRjQxbuGqo9H5BpYnfKs
37624	payment	2133	2133	1874	1	1	4579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2rHvzbjdCqm72rLu1ywMjiAnZrJYADNPDDSqjYf4jurDmiNL
37625	payment	1397	1397	1678	1	1	14451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiD31x2ZWdTiiMp26PMtismiD6efEtC2uPkZsaxSTN7KvFfJg
37626	payment	2134	2134	1874	1	1	4896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQB6XcNeV6ahmNoREH44xjiyRGfa47eBoFG5hXKAUZ7T9a7qTb
37627	payment	2133	2133	1874	1	1	4580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx51P9e7vBbp4fq9EBqw76BiTPdLDQYmg3v2GFoh59Uqpq6KTi
37634	payment	1397	1397	1678	1	1	14454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmP773hpofQ4bojTPbuvgQucV8FE8aUmiRNTPSEEYMJGvGZy8
37635	payment	2134	2134	1874	1	1	4898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpsLWD8111ffPSKL9Q2wdhfwPCME1PUYaxmyZTfCZaTNPRUsd
37636	payment	2133	2133	1874	1	1	4583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KD3My1HGVtA9FJkWk7XExeGGU44UEQ7SBRJvPJWnQRJyLnWg
37637	payment	1397	1397	1678	1	1	14455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob2RwpNJwjYnKAa6k1gMbMcVPpbZzYnHjCqzYuJa1VVXoeLHc
37638	payment	2134	2134	1874	1	1	4899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKD1wxfd1D2gPVEn322LrYSPGRo1fVcRAojwrg1u7M2pJKg4u
37639	payment	2133	2133	1874	1	1	4584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiEpUgYpsX6dmG5fgRMLEn63vGuKs8reozQ85B9NV7Z7c79n7
37660	payment	1397	1397	1678	1	1	14462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyoabyYKeaRuxLxx7F9Y3cLSpCjEFpKgVaZjTuyKj9jX6La74
37661	payment	1397	1397	1678	1	1	14463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyLfU9krwyBcr4xLyvy5DwFWFPvcBNoTkat3YCZsf73j5JSxx
37662	payment	2133	2133	1874	1	1	4591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEVsbCTqLZWzwfT8enE3mL9GwXenMUG3ZmFEFEVbpW7irm3aa
37663	payment	2133	2133	1874	1	1	4592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NmD5KPmtX962o3yJmpFdj9bmsbZGGCiiTnwrgogFSCqwrkQJ
37664	payment	2132	2132	1874	1	1	1332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T75vJu3tsVZKzxBZjmkbxMsAymoErrghNac5NNshGqXkZDZN
37665	payment	2134	2134	1874	1	1	4906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGo8Y9z2tZad5CpV4v58PhVo4nwMqJw2bJLZbw5QSb82Gzyk3Q
37666	payment	2134	2134	1874	1	1	4907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTs54YN8fEj8FZyVjdcnkYBogfPbCegfXpKy5NkM5CY3zBMv7z
37697	payment	1397	1397	1678	1	1	14471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZYbESSgNCcpGNHs84FB2KtdBVei5g1TViMQNrkk49qtLQzfq
37698	payment	1397	1397	1678	1	1	14472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8AA2q6TqJsYg2Q3H37SC4o6EMajQGPNJfwn1xrcfY6obyFWS
37699	payment	1397	1397	1678	1	1	14473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATC5vemYgcY5WrHrQPpv777P3oHu23rFLwcwCctkf4VdV7CHV
37700	payment	1397	1397	1678	1	1	14474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMm2NxnKzjLwPdTZVDgRdJWdCbKVYhPgYsNdbeJ3Fogt8TgUs
37701	payment	2133	2133	1874	1	1	4600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVixGtHrCzv66hQSifSd5ejAarNq5qwYCNgtsenw7VxRQ4KfK
37702	payment	2133	2133	1874	1	1	4601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZczaEYoXCfBWS8coSxxMCmeEBaNVw3Vi7QJgL1vH84Axg8XJK
37703	payment	2134	2134	1874	1	1	4915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwoC8mLpqwKbP2rcw2rDpFqTBmWFQokvXmd5nmigDZhVkdXuV
37704	payment	2134	2134	1874	1	1	4916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKdnEY2vZRoYkqGGs9vA3XLcGWs9GbBg31st9FVDEjgZp2TCu
37705	payment	2134	2134	1874	1	1	4917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdapZHTV13Dub1r9EJaxreyM5yEKsVUWuJ5oHJmQLjjw3NQoVH
37706	payment	2133	2133	1874	1	1	4602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocq4LF5cNP7YDiv4wnzhoZeSN9yaaYFeoGnN3i3TskazR8vsH
37707	payment	2133	2133	1874	1	1	4603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYems8HWbG9gTUMJu7rTqbrwsoBKtA4nQ2AmZNrUP9vH6uParnj
37708	payment	2132	2132	1874	1	1	1335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymvAbtdFWfWr49g8bzvJ4HbaAjGKvANppsPX4LjDj86fB6TKG
37709	payment	2134	2134	1874	1	1	4918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtDMCYGkwLBoH9EuH4EyM5r2YBaGz69RN8FViNUhrShmjjc3t
37710	payment	1397	1397	1678	1	1	14475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrzHe26BNusZ1Z9j2D7mYexgqr4K5o5Ej3BM5XA7yWrYd84Vu
37711	payment	2133	2133	1874	1	1	4604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3k8eeuq8kN8uPkTz5uGSnjWsEymBBPg7TK8NzJw4iaEwJFGU
37712	payment	2134	2134	1874	1	1	4919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jzeDfHpQs21RDXrPbmVmMs2E2nBy4qdxngwUG2M4DiXgFEAT
37721	payment	558	558	2312	1	1	4	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUf3SxXTzoHLTi8xYdTEuuwYT8eWPvoafFvZ3g3vPMwEvcTvGv
37722	payment	1397	1397	1678	1	1	14478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYvB5XJ8hKDLJGv3jyvQ5yZGo2KbLKTmoPNngcvzg6CXRM87y
37723	payment	2133	2133	1874	1	1	4607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcQRiBXvQu7erv2Er3K3FvYfW8nUtB1Kphj1TfcZLS1kkAr9M
37642	payment	2134	2134	1874	1	1	4900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuFWA7S1aLz5HYC3JoeAe7p3FLGnb2wESqMYKLJ3ksZ1hhDfk
37643	payment	2133	2133	1874	1	1	4585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3grKwEbvkU8BJNj6XEEHb9TzUd6HxYFYdwTwvYmufw32rWgZ
37644	payment	1397	1397	1678	1	1	14457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLyH3wtb2FLN7SZovY2zMWMpNB2n6TiAN5XEJDsoavr3VjhWe
37645	payment	2134	2134	1874	1	1	4901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFye1ysZovPRhhnAz9wVVktUkKwzcaajrtE7TAWWJycQMhYZW
37646	payment	2133	2133	1874	1	1	4586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDDqg3YtQB9b9Pj2wN5jWZqLJAz6TRkJvjxV541A6G41zhW2Z
37667	payment	1397	1397	1678	1	1	14464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKiAUN8nbSrpbL5hcEikAKbW5nDQC9gtXCGN6SeKG2THSpmx9
37668	payment	1622	1622	169	1	1	5	407542749587	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZtkkBsjTQ6QGueffxGMF2RczSaLUxSHjA1do7oJg6Yy6rCwT9U
37669	payment	1622	1622	990	1	1	6	3100139565232	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpYogXYyvR9uG1MQKgm8haSkGjJA4mAdFdGHCssdvvRzV1qeE4be
37670	payment	1622	1622	1110	1	1	7	5555423538912	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpYcjr2J1Y9kCNgfD5kdSzB9eevdr8hKJ2NoX71z3hzRFr52WB8M
37671	payment	1622	1622	1230	1	1	8	3748354961338	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZBWu1aw5Hw8FgfefLvn64Z7X6g7otidfnqUn5eZzZ69kpfZ62b
37672	payment	1622	1622	1356	1	1	9	10445124384888	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZWBjpTW2RYpazJKoFrGXoTgukLFrAG9PwtQ59aVSmzBRME1JPb
37673	payment	2134	2134	1874	1	1	4908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezHz6jSAaK3y6cFErNsszuoVSxNmVQEHkP78tNsCNWi18mx4u
37674	payment	2133	2133	1874	1	1	4593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqkBbzNvfYY5CkPzDSr7mKA5uaKGNXN57XmxC6UXdap4NSFmz
37675	payment	1397	1397	1678	1	1	14465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkFC81CHuWDW2zb6B3WrHMh5ZCv4drnDV4sRRe7AUK3ygt9nU
37676	payment	1397	1397	1678	1	1	14466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMTohJBxaVe8yJVEpes4Y2Kr767NkqPRrHsA5jx5eAUuev9yN
37677	payment	1397	1397	1678	1	1	14467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzqTRcS822Exdm3GqdhaiQc94f1hfUdsdMW8YjY3xXjAtMMyB
37678	payment	1397	1397	1678	1	1	14468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWevDcsCaagywyGSwhYTrZzu2gQvcXLjf9npGKKfamuTRRywj
37679	payment	2132	2132	1874	1	1	1333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVAMtiUoESJjA9NvjStUdLyVycYXLT3j1zyopcXcZbTR85VFD
37680	payment	2134	2134	1874	1	1	4909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnha53fXrn4Ymyyus5skTPkAVRx1u66RgU5NBzAqVu9fzScLY
37681	payment	2133	2133	1874	1	1	4594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8BzzsYZVgHm85Dkp7MSRXcmSwF46FhXGRnN9p84DfFvCgFFp
37682	payment	2133	2133	1874	1	1	4595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNKEu4zNq5hBjysBY8SBkuqo4GUHuzep3TNjWJHpNy3jdWFw9
37683	payment	2133	2133	1874	1	1	4596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1ixcTMRf82kREHLJ8t2BZc2BkTaHNCP6vi5Jwz9Dw4nTzDz1
37684	payment	2134	2134	1874	1	1	4910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAFeEmQ7rvbjZqUbhRoir9bfDzAqgg7c1762DUdyXYZEsKsDn
37685	payment	2134	2134	1874	1	1	4911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiweVJYZ3r23QcDcDz1FHbSSzDb6ucsg9FijcEZB9N2Zq9LXR
37686	payment	2134	2134	1874	1	1	4912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTknFcTy3L4w3hurVd8iCGiWep3Fj1w82Eh4cBjKNJjpS3dRx6
37687	payment	2133	2133	1874	1	1	4597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAcnWqJgAxhMEJQayJaNqNhPZB9QpMVarfFk9fXUD5DPrKuwi
37688	payment	1397	1397	1678	1	1	14469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAksSZvJ8JmCzWZJb4jPo7Yve5GpRj7H2jhzGez33PtYFnyxuq
37689	payment	2133	2133	1874	1	1	4598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5YYo3iCHR2vFp54msPSmyfUr1FVD65qEFCSj6sEAVBp8XUV3
37690	payment	2134	2134	1874	1	1	4913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad68AaFpCwS6tASXVTU6tjRjDis3zFf4VKxjmJQ8c5iJpfL5W
37691	payment	2132	2132	1874	1	1	1334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHRyM7TUQZSv2vWvgzjw2epYWWkhF1ssFecV2Mj4Bd1N8QoLS
37713	payment	1397	1397	1678	1	1	14476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KTS91xqzVGzpUNyabKyNcjyZ4EwLGcNCny83LDn9z83KSW3Z
37714	payment	2133	2133	1874	1	1	4605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu5rPk1Cm6EBNt9E7zfs1cTi5LHDVVwAzTTWnqtFFJwD5pp3Y
37715	payment	2132	2132	1874	1	1	1336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTqWtoU91utANi1QMQYq9cubk1r1Mk2oH9YLKhdraXYchCH3E
37716	payment	2134	2134	1874	1	1	4920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJn7WscqUYGpd1uFBwafkBLfsjGeiFDJtWxp43A95GxDKkAsE
37787	payment	1397	1397	1678	1	1	14498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJ1nnHFDKDi9427UuUJ2mLA8YyfX6Y2oPKXXEBkTUQApnEAtY
37788	payment	1397	1397	1678	1	1	14499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33gktkAAF6fP4XxQHzRFnKw5bHMRLbEvFJs5uWFJJYiiwXuav
37789	payment	2132	2132	1874	1	1	1343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKEzVA3kbuk7xPEm8pkoMdqRNg8jqULKXt2SAGXmeJyDu4kCG
37790	payment	2134	2134	1874	1	1	4941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYZSzD86kh89y7ou9xP2bQWepjPxecwjQoy15qSEkNFdM6iAa
37724	payment	2134	2134	1874	1	1	4922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkMtDEFLbrJMVdf3hxZu1exdqWoTzgGuFudeaLQHx1tiia1Y3
37725	payment	1397	1397	1678	1	1	14479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeL7GdwpkW4G5SA7B2UW3u94C7L3gqiPWYMoHoKcRxJZPawZW
37726	payment	2134	2134	1874	1	1	4923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBiuvTHWyib1p2cL5H88rg6BpTq5EruxfGx151DkK67vbM4PL
37727	payment	2133	2133	1874	1	1	4608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw95DsWXJwP6TZy2qsVMApJkTu2Wg91ZwEJuXga55nd34rSxid
37728	payment	2132	2132	1874	1	1	1337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwT5hLrdbCYA3ePkhsEsfEL94d3aN9UZrsF12zxSHjCzuzFax
37739	payment	1397	1397	1678	1	1	14483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3ceRXnzhaLdULyEZSG2jj5q9ME5mXAC9cbfuzjCYBgjBd82R
37740	payment	2133	2133	1874	1	1	4612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnB7L5Rzd3jyFzTh9FPyKXQNrQ9uXxAMbasgBqsD8Lq7Kd3X57
37741	payment	2134	2134	1874	1	1	4927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQmPDhAJ1BsAgUNdbwkdxibwcZEh2tdTkF2uY22QteWghBCri
37752	payment	1397	1397	1678	1	1	14487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBF9xLDsxwuuefQLSmTaPyGznupRt4oeoUcHD9aiJCovdQbARp
37753	payment	1397	1397	1678	1	1	14488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPXemyLp2hJKVm7NZDNuwiQgDFF3c1LjnMJv9YdDfZFXbjf6H
37754	payment	2133	2133	1874	1	1	4616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQkx6xzTy8cBuHcbkiEVnNMbXfMjjDydkitGu3kdDoNHeaW65
37755	payment	2134	2134	1874	1	1	4931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwCwtQLckNF7KB5fxHWFe6j8L7tqpZm5cb2VFDNp1wtpXu3LW
37756	payment	2134	2134	1874	1	1	4932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28ryji1VytNmUNoAHykhKnJJymn4WKEKqDK9M2oLawcjwDoX
37757	payment	2133	2133	1874	1	1	4617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23XgHXwTmVi14ZnQXCKwsMczVCkG3xKnZE95AKsD6DYswZ8Ab
37772	payment	1397	1397	1678	1	1	14493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCW6fTrCfHVcPquEj1emBdLGdfRVNt3eSDnvnkPXLca5Qvh2gY
37773	payment	2134	2134	1874	1	1	4937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZQdBct31FeM36Kiq8sNQHEYFjE5yz6du3PYyZvRQ6gp1u5VT
37774	payment	2133	2133	1874	1	1	4622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKywdED6WtJDFS6FjLmYRazF2hZQ7ueHkP7SuBjcqzd8o6XqcU
37778	payment	1397	1397	1678	1	1	14495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKb1gWbdYTysgwuP6oxzginQgkxJ1oQ2QmbZrBUGuynJffrJq
37779	payment	1397	1397	1678	1	1	14496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywHuDPfQtwEeJmJV5PMTpFU8YwacSrQkpobmfswWsDYRtLZK3
37780	payment	1397	1397	1678	1	1	14497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Jp5tvjsXniWTtLeE3WoUbfxEKuK6qkcXDVbzKnZCcdMjzyAx
37781	payment	2134	2134	1874	1	1	4939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpErWWQjr2yAH2jb93QimNgKKqHcfKFu5nDiYNbAWDVXKnJ6P
37782	payment	2134	2134	1874	1	1	4940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE6aNC19A2ZkSkaPKDvr9LfVk4NvUZd9QFWAvf9YER6KSobKc
37783	payment	2133	2133	1874	1	1	4624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskz3XaZ5z38so24kzr26V5oRfaFwBbJqjULpGiAJChjv1f4rh
37784	payment	2133	2133	1874	1	1	4625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEP2xvU7qpjod9nGRUKrdLd9H39NXMHYDqEPhkCKdkWrbrheAL
37785	payment	2132	2132	1874	1	1	1342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzs4sCxezMtwepfuJ4CeyXerNSWeDgXXhRGBpGzB5JpnHQDcY
37786	payment	2133	2133	1874	1	1	4626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKx3CddsdwgCvxt8mNJAf8jM7h7Y1BAXTUA3DEUR58GhjHK98N
37804	payment	1397	1397	1678	1	1	14503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfToNGpwZJq9zxr5EsCGQ5NhHuy8crqTLBQy7MPLCdeBZdHvd
37805	payment	1397	1397	1678	1	1	14504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyY2H8jVXNK3Z9zhih8eacrXaAdGEjU3TNb8G5jaxCdAw5XqC
37806	payment	2133	2133	1874	1	1	4632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEa4Z2T1eEJCx9a5TsapEqr75QeRSMVbo8Rs46GJT3jxhMzm4
37807	payment	2134	2134	1874	1	1	4946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMPJv7mQEMhNKXVdnKeBgBbqKyiNNMQABs54LNG2K5hXBjakg
37808	payment	2134	2134	1874	1	1	4947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3UsR9pPFEk4CuBzmao8Tfeg8iGyLnzmQtWZFyNQJzmZMzjKMu
37809	payment	2133	2133	1874	1	1	4633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBizZxuLByPLjejB8Ld5A3zYXNUCqUws4rv6uJCSZBzNfEDKKM
37810	payment	1397	1397	1678	1	1	14505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGrtQEEoRSz4KyffUKkAVs47x74JTqUd1KRgfpQWj8oSz6eu7
37811	payment	1397	1397	1678	1	1	14506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQihyHrgFiS3kZ1jeoocaaXpkYRUw3CJPAQ8ApPXzvunNMaGDK
37812	payment	1397	1397	1678	1	1	14507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUn3aa7H3CZH6UePWgiu3R9EkDAEgBtNsXF32C2ENQkJE8VRx2
37813	payment	1397	1397	1678	1	1	14508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1c8dwPJgq4kBpJ2fcH6EhCW9TQz4Bss4ayJdkMeZFRzr1qzsW
37814	payment	2134	2134	1874	1	1	4948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbBbpCnMp2dBMFU381g6ByAvKvNKbVMSoMLBfDfxsNqo9iA7z
37815	payment	2134	2134	1874	1	1	4949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9PDzvpv6bfKMX6k4vuraKsJHS3LAQNYGFJjq7wqRmZkx782R
37733	payment	2134	2134	1874	1	1	4925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZEMTWu1g6aRjusL7RNikEg4q9hpJJj5xQUwwj8KApfEL1VW6
37734	payment	2133	2133	1874	1	1	4610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFn7cA9yXRhCq1Beb8ypqHVM2dHP5diazBvcrzXQfGsBweqPNp
37735	payment	1397	1397	1678	1	1	14482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSXKJij4TNqGUVLNG87zFxJzx9rAiupvPf6BsuLFGUwJ7uygb
37736	payment	2134	2134	1874	1	1	4926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5MBjKyXaa41xxmu82saMWg4UQspCSKc6cdvCVbRppMTACwQm
37737	payment	2132	2132	1874	1	1	1338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzMC4jguCNYQUagk2bGihE7dt1gZj9yZHUjvLqD5uttLJiwY2
37738	payment	2133	2133	1874	1	1	4611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tznMW3c1sffPCoBmDF3KwZY3YXfwarh86L9Et9dXtPSm8QV6
37742	payment	1397	1397	1678	1	1	14484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH9kEpwmjDcG5gb5WE8n3PNyvUiSorqTo15oW9nSgUVbh1wcZ
37743	payment	1397	1397	1678	1	1	14485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfpigRvEFyUG16DT71jurmRGCFk5yEaLLQjoyQv1xu6h1eFK8
37744	payment	1397	1397	1678	1	1	14486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VFXd9sSu7cW5oCmwnXeTj8vymCRsenpsHack3Dc3Mjk59VZM
37745	payment	2132	2132	1874	1	1	1339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdXYrqQsmEHYPaNPYpu4EwvNVjnMuobwikrYsPuLLYc5qYbXU
37746	payment	2134	2134	1874	1	1	4928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtePcdVwVEeiqBHa5jmW5QnZHLcLdVQab7imh2EkyKLaFxahj
37747	payment	2134	2134	1874	1	1	4929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW451kRUB7Jw2vEhDxR2QnYfPsmQyf7UgEommaMrtyYKD2qgDV
37748	payment	2133	2133	1874	1	1	4613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mFruDoYE5H1BGSULpdgU835VLMUT1DzSrkduCgFU2dXxpkm7
37749	payment	2133	2133	1874	1	1	4614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK534sbHYXL41EvyYDGkSToYsmL8agXH3AM8vNBfWMbWszABxD
37750	payment	2133	2133	1874	1	1	4615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgfHdXgJqgc7htU17sEWZAbgZ7dc4SDBSLPpgTSAYbHwNQMBt
37751	payment	2134	2134	1874	1	1	4930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn15RsBXMjAvpnaMsFqKcBFc5jJxVcG2Am5PLKk2LNPmx7qXg
37762	payment	1397	1397	1678	1	1	14490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywVeNc4Sn9Cb36Vhq6MCiUfKx5kHvoswKvHEjzPUNFSr4dn4z
37763	payment	2133	2133	1874	1	1	4619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfvyLXCGZSe9Y9eaHjSfjVmvV8Kca33DV6iAzG65GUsqTKZXn
37764	payment	2134	2134	1874	1	1	4934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsJWVwpTAqoinpyqoztt4xhUFsPjcFHCGYaBNLG6JpJTqTgrs
37794	payment	1397	1397	1678	1	1	14500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LrPSuid5zjr5cvcYtepiEvK8PynGU9hEw4vr8H7vTjRjMJFn
37795	payment	2134	2134	1874	1	1	4943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gvcPhaXu92W4q1CRkTSvUtftjHyBrB6AzYXenofirW7D5KtS
37796	payment	2133	2133	1874	1	1	4629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRyH9JzXuf7S59EstRdmuKxMqGGXPKmJLYvraPwR6hJSNwoKg
37841	payment	1397	1397	1678	1	1	14512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBi2std8DFX7H8MNSpnktMijVLXDB1ejvkrLsNU5WpSR2DqeY
37842	payment	2134	2134	1874	1	1	4958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUL5TwNXR8gxAYdMBSFFT6N3BviScnVnT7eJoiK58DyP8dTwA
37843	payment	2133	2133	1874	1	1	4644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aGK57ppsqQaq5aoR6138HaiZzr3kyXvYZ4kpcr9CDTF7f5tm
37848	payment	1506	1506	1007	1	1	22	1732600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ25SmhWQ6ETDzXWZ4txm3xTogY2geTSiGDsD2yxd6qe4VSCJs
37849	payment	1397	1397	1678	1	1	14514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH4reyAWm3nA4N2kjoRMw7VpMrDhzP74SWWy8wqa8STzuGy77
37850	payment	1397	1397	1678	1	1	14515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzWypBsGGYnvDoufb1xcEX23MLxjJa4kjzacxVfBpzsY97NsV
37851	payment	1397	1397	1678	1	1	14516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NuEWNJYF9ZT2z3uNicxsYBDEjjLTXK1ZFcPVaKpH8ZDcUZHh
37852	payment	2134	2134	1874	1	1	4960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9FWHkqu5uFho6qsJuKsZwPaeN8uTshhS8RGgUhm1CVdSWMEA
37853	payment	2134	2134	1874	1	1	4961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hFPash1a44zkm7FHWVmcDHZ9ZVwJH24vBDarq27HmWpvLmJL
37854	payment	2132	2132	1874	1	1	1349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq54e6prFRyByrmpcwEVewkh5RdcCkXK5rjTa4EvhcgiUWqdj
37855	payment	2133	2133	1874	1	1	4646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFcv7ZduLcvPPqaYymLnPfAsumQ155JEv1QGofH89mAegrMJY
37856	payment	2133	2133	1874	1	1	4647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj7QiLa4BKL52Eh6MUutWTe2q6dJxfh1V6cEbsZGryjYrDeYq
37857	payment	2133	2133	1874	1	1	4648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvsjgkirZYhpzKpsytEJSmy8XyWBN5Xo2RN6gwNYUWUTaDgFn
37858	payment	2134	2134	1874	1	1	4962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLD6KZjfjmt1GTZ13SZJAfXYmpWt2vfbsRMizHzFMhE3K7GQ5
37865	payment	1397	1397	1678	1	1	14519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsiGqD9MH7CYnBGX7T4gYW1mfmQkd6b9pyzezYRB1aHNt8tJv
37866	payment	2134	2134	1874	1	1	4965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzimFvZjTGNze8zpnePcEaVv2ARDaQsBRCiP6kKb6baDE9pijJ
37775	payment	1397	1397	1678	1	1	14494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrpDdqJQvhJh7PuUgD4pXsv9v6HDxFhDPEZFucACRe5VUq1p7
37776	payment	2133	2133	1874	1	1	4623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nLVzce8yo1QHKnhdwRuwFrLivuDsKEQ5ws45DDxsefk7yohJ
37777	payment	2134	2134	1874	1	1	4938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbAB4TtD3yaANHXapBNHELUq8SzmtzkrYNcCG42pASrXShjWk
37827	payment	1397	1397	1678	1	1	14510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzA7YdcUwUhpKJi3ixTSF5v1HMMDiFbcsEBsywpRGcjiUdJJ5b
37828	payment	1397	1397	1678	1	1	14511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCcFNEcL36kKoQuowVWTbrirjPNwCAsBD18caZ2WR9jVVNRNk
37829	payment	2058	2058	2059	1	1	9	610000	2000000	65535	E4Ys2i2Sv3a28ooHGo6ybLhtGZSW1xwKayuDCkdacvJvNigvkAVkv	CkpZk9L8xxgS7HQg939PvZeA1NJBonhrE7QPhd4G56NoWUEhZBLTy
37830	payment	2133	2133	1874	1	1	4639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Bv5PZkVLzKUMxcQgk576b3dCXSLgErUFrg84AP9jyfQyFVN3
37831	payment	2133	2133	1874	1	1	4640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNy6idDvx1qcuev5Y3Dptp63cLpQUAVdRTTnC5ZXaNzULz6Mr
37832	payment	2134	2134	1874	1	1	4953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtJgCfYLJxrREQ68uf4EdSKo8KeKXGpfkbcbvntA45cfhwRiY
37833	payment	2134	2134	1874	1	1	4954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn27FAY1a64QsBdNMixLLAcoAqs82mpR48GxV4F53YDjAsquh
37834	payment	2134	2134	1874	1	1	4955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdg9rBAXX7LEf1fTt8et2qq93QbzoBCZNct9FJbUKnFgYyNib8
37835	payment	2134	2134	1874	1	1	4956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzA8xqkFb57G6zZCAq9eYhr1KsN5trVbCHRfszx7ZxupsCt9o
37836	payment	2134	2134	1874	1	1	4957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLSHoc7n5wAFTMuRfdkajCQXhbJQXMHB1kf9iq6qvp9fvoVHz
37837	payment	2132	2132	1874	1	1	1347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzvhPdNsUQz17Jj7Riup1UpVifi3zc5tMWwohyAtrYBKAYK5A
37838	payment	2133	2133	1874	1	1	4641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5gyEZxBxsuw2JsCJvSApudSkE1D982ZmwMBWWASn2aMzLQ3m
37839	payment	2133	2133	1874	1	1	4642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU2zR4JFSQ6vbStK5GNY83AspTuk72Xqms9jAeqS2CbC3GbSc
37840	payment	2133	2133	1874	1	1	4643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoBYF3fnH7kwgTFXN1VeG6CpQmmqpRfCQsW7qEvddkHXBTuyn
37867	payment	1397	1397	1678	1	1	14520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkJQeiL3hn6B2TXHHKjK3XCMWkRpb6gthyrRghwSFJ7kFc1R6
37868	payment	2132	2132	1874	1	1	1350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgMvRJw3ZcpcdLU7Tx5n2Rb71U393hfJx9pgvJcNzJ6CdjzSw
37869	payment	2133	2133	1874	1	1	4651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPDNFL59uLfw9V67rLEfvw8dby6stnwZLdNNfXns5F4mpBs6c
37876	payment	1397	1397	1678	1	1	14523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpbBjk8Q6HR2WvRU1AGGqj7BkwPUmDqgwg8abnAZiwnXjxo1D
37877	payment	1397	1397	1678	1	1	14524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEpbZZQh7oKXcNKdKvUyCq6R3W31Yd8w1w26wJUy6t1Ze2phe
37878	payment	2133	2133	1874	1	1	4654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAhMTUgJmT6VbSKiPxPRe7LRgtY2oM916LPdBZEvKxrxvacg
37879	payment	2133	2133	1874	1	1	4655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw1V8196MpUUoihpbz4hKPpHLun7haWd5y729q5LafNMfBgB7
37880	payment	2134	2134	1874	1	1	4968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCD64HsVTAJdGBTsf1EosNF1SbW5ngnBdN3VtJc9FFRd3ZiQP
37881	payment	2132	2132	1874	1	1	1351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgvkqguNLiAD2dbNjNQGH6JiKWQtdyRfzs1uVbTyGqzU3RxNR
37882	payment	2134	2134	1874	1	1	4969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4Tzb38boLq8ddbLz45mjDqtCkewAo2r5and5r3ou4Vj9BUkd
37886	payment	1397	1397	1678	1	1	14526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaenYUQbbf5sykjoW4pC7fmxtV4B2vd3BHADHGvMaWfSiiWEH
37887	payment	1397	1397	1678	1	1	14527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkj1HFbPMFeT7ZvxytBxdznRoCoZWpW3iXL6d1wX1Q4EeJ318
37888	payment	2132	2132	1874	1	1	1352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSpcRtazZB2zUrjadCqQjiQjzSsBnRe9pnZXDdKLKAt6n4ubq
37889	payment	2134	2134	1874	1	1	4971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7d3pEEjVWJ6C7fdNBx2F2muN6NX7omXAuK6QU5aoAaUXXcDE
37890	payment	2133	2133	1874	1	1	4657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52o6SzMVqe6WR66icqEi13GEgVJFbfP55skhHKVNEDSKcs9nT
37891	payment	2134	2134	1874	1	1	4972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcaYhoVRjmGLhehKF9rVrgPZCLwTzfetfE89RFYTnU8sUqvZR
37892	payment	1397	1397	1678	1	1	14528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiSU9Vqyv4oiiPCWrKrFw54Egv74dUKNdm7gv6W4JVVEkLWhc
37893	payment	2134	2134	1874	1	1	4973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTsVjrdQvc3nt121SMD8T1gYd9FFU34xBBW3FQVh2WqfdZDRw
37899	payment	1397	1397	1678	1	1	14531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhwaaFz9Yvov4u47mud2vGQ6UD5PevWCkQ9tjQZfUACgf5GHS
37900	payment	2134	2134	1874	1	1	4976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabSpeWoq9iKnoPVCt379ibvA7NkgBvpG9tSase4TkJo7BEQ5S
37906	payment	1451	1451	1292	1	1	9	7986000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	Ckpa5Cd7JJCGWav5S26jJrPiqSA4o2pFyLM9t76NGPNJERqdy7SwR
37791	payment	2134	2134	1874	1	1	4942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkWZLxrqZG6od3RDu4AxA5ENriLg4kNqBEGjacWUwx7tPnQc4
37792	payment	2133	2133	1874	1	1	4627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5Bh5quHdp9SsjbnAVhTDUDpkF9SUeFPW3u3HpUVWMfLvQxJv
37793	payment	2133	2133	1874	1	1	4628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBvZqEgdoM2oKpE6UCweNfdBz67Le3rza9sVmLmDF9w7nWKza
37797	payment	1397	1397	1678	1	1	14501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVhGLpTfwxgZiZTxv4cKH8p5bqjvCUt5y8D9iCUbsQUztd2oM
37798	payment	1397	1397	1678	1	1	14502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnfNghRDf3YrT3DFsCrSrGXLvspUCTwN3ZCLTFtS1y5oJzrSj
37799	payment	2132	2132	1874	1	1	1344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSE4ZAuMskbuTTFVjdV6UdunN4Zwm7KiqKrX2AP8PtkjEfBY8
37800	payment	2134	2134	1874	1	1	4944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeVWiQMXsuWaKoC5bwy45nhkdWi8AUi7WgzS3vpXiJWMGxwfH
37801	payment	2134	2134	1874	1	1	4945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnaEEimJW2xHr3KK7wdeqAdPXjG3FbAu6dULBYEQTumg5qXTQ
37802	payment	2133	2133	1874	1	1	4630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZsdpM1FEEPJxXTW432FWiDt7Tpgs1CkRodH6q3cNtSaYKJeX
37803	payment	2133	2133	1874	1	1	4631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1QDB6DjWFmRqYQzitukw5PXbjSUB9wYVfyn38TdR1zTB7XrZ
37844	payment	1397	1397	1678	1	1	14513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39ro31HKr1GYnGJMDkvwMSjoAw7wG4VNpu59QAgciZtKaTNoW
37845	payment	2134	2134	1874	1	1	4959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZ1YMmzCkcndeSPEZT6Gqx3cL7GxRbt8234PtkW4n1S8hjz6m
37846	payment	2132	2132	1874	1	1	1348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4ye4PPbryokrheBZHEkdp3A2oxV8uP3J4kLj9AL5976yiDhk
37847	payment	2133	2133	1874	1	1	4645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt29BNx6pFpPWmpU56g9rAbmaZCEoK7XWB1rJa9KTXdwVuAUwf
37873	payment	1397	1397	1678	1	1	14522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABedwfrW9wU4PQEtuXj7tRjxUzxyAAAWQG8oDzuaUQ8P1Yu7e
37874	payment	2134	2134	1874	1	1	4967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFdVveorXR1qu2Sgpkd9tYoa5gogE3jow87C4U7dEkWDouUuU
37875	payment	2133	2133	1874	1	1	4653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMfk4mfU9i7sygWRoMUVWetkodpJk8bbutvvXPSaUenoXJZQm
37883	payment	1397	1397	1678	1	1	14525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVMv1wPuaT5sZAVDvmaXHtgXYYf2i6FMd153XfEdFHWeMPGHK
37884	payment	2134	2134	1874	1	1	4970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHmtkbmAHJcsnYozmE7fTVgx7BtNFMzmwJz4gPR8XA6ijJCho
37885	payment	2133	2133	1874	1	1	4656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNofKHpozik9gd2KTRMVPBWRwwgMBjFmhTtAebXVBx4Xs6c2t
37896	payment	1397	1397	1678	1	1	14530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKZhZYKU95TtP6wyefURCxRTjPc2GAct4x4p2NDHc9MAmmFfa
37897	payment	2132	2132	1874	1	1	1353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eANgA55SW5EpruaLKqfkgqakUNs3mxxFzpNgdhCKcqcvBDNU
37898	payment	2134	2134	1874	1	1	4975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYdhsMmauTWpuhuu2HeMRXaNQQ1vvAdnyW3utX2qhgGc3PZGp
37903	payment	1397	1397	1678	1	1	14533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nDgagfVVVkWhqvyJCPRVGwoyCPSMwd1Mmhf7ypAg75kUTeP2
37904	payment	2134	2134	1874	1	1	4978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRgBSERdB8FybYjpjmNLuEEficQoP2QYvYRZgVUsVtFMQimi5
37905	payment	2132	2132	1874	1	1	1354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMSxF59Rwiwjj39Y5eeGzVofug1fdjFbpz5TuE5XgTZ4mnxS8
37911	payment	1451	1451	1046	1	1	10	4248000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpaDk6Q1Qqm6zNAMx8thRGW7xJJgpj551Djn2ZXQGowU5aSGyWi6
37912	payment	1397	1397	1678	1	1	14536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDUya3TcXNHHoLxgwiNNTEfinTWRDpXQbbtCrQfnKus4B95Jw
37913	payment	1397	1397	1678	1	1	14537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgwAokm5DqvqJSQJrdDR6KSEX653p2UE454JgVVZeVkeamqkS
37914	payment	2134	2134	1874	1	1	4981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMyvhUwSgkH3EiYm8vKxvF63bgTnhFwKLMuuBUBs5dJrj3rLo
37915	payment	2134	2134	1874	1	1	4982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4Jw9umyk4ZX2FGTzKBbhwBcGfaeyrjLrStoZEfUZb93gNdfB
37916	payment	2132	2132	1874	1	1	1355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTvJS6JpRgaRPqYgErinFE33H4xz54vZdxDoSdC4yhtjpTBKQ
37919	payment	1451	1451	1166	1	1	11	2866000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZPjxUGn1N23U7R89WutAJKAncs3YhgqTTMxxh3ghahT1cTj4f9
37920	payment	1397	1397	1678	1	1	14539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5hFBwDfCXfpvNSAjwRcqv6vhcUWgYd8HqPNFCx38wiN1VX8S
37921	payment	1397	1397	1678	1	1	14540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuieubCYNgCW7oUUZjey43NCBTCSpYFg5wiWyw2rX33dmbX2sn
37922	payment	1397	1397	1678	1	1	14541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhjjHxG9phEwxmzQSiX69NRhf3WRnnPvnMnVgX3cqzsfgFEyn
37923	payment	2134	2134	1874	1	1	4984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6VZuww8dkJA4AaFPuFBeS9xeXYr61LSFDjdBUGC5dscHNEfX
37924	payment	2134	2134	1874	1	1	4985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8Zqoj4qnLNkKrCtrMLqkQe1ZRVhtf74pwSndvHp812ZkANNs
37816	payment	2133	2133	1874	1	1	4634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7kSrg4G8Ug1WtZBwAniJ6QSyNtC4Dy3aZWYQEgHTvFDYFW74
37817	payment	2134	2134	1874	1	1	4950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWWxWqTUcJ1RKiwpLqf8GQwEVHjXSLNMrdeSp9ajo1Ma8Mobg
37818	payment	2134	2134	1874	1	1	4951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPh7mcqs7Mo6Dh7fuhV2sgCDAVgJ3Hsr76bvmsBXmPVLyAPVH1
37819	payment	2132	2132	1874	1	1	1345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphShhykyCqXgkzgM56664a5GXJZM9oR5pKjJarT2faU2pFVHX
37820	payment	2133	2133	1874	1	1	4635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdLm4Eocvckj5h7NGVapPBaApmtEFKWSU22oFbiNKDH8HAxNx
37821	payment	2133	2133	1874	1	1	4636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpb5AwMa6Xd4PbBfMGMqyfovzttzdG7gcD9BZuUBtNCxfU4n7A
37822	payment	2133	2133	1874	1	1	4637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64VVPoPGeLk2AddgYBFyfy6fEVXdon1hTLQf4JpigjbitReW2
37823	payment	1397	1397	1678	1	1	14509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpCcLcq7wV4XEb1ZVFZd9sWWXi93K9zGAqc9f7WP8hv5Lnd4C
37824	payment	2132	2132	1874	1	1	1346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu59goQTwBZaUBHhpYZRtjvmfJ9iyb2FYd3ifVLpvQckLhbbX
37825	payment	2133	2133	1874	1	1	4638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2FC1TJ4L2bZca7CP2jrRcyHrfFRy9HSUrMqs3v3zFdjS8xYw
37826	payment	2134	2134	1874	1	1	4952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3Eziyw5SPYBtSdRv17G4apDQjmGnuwKiMZpF7BGEGSd4shXR
37859	payment	1397	1397	1678	1	1	14517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvhbzvSimi5ZAwmi1eLqiUfqha8v6wwvd3QXr3oCmS2SyhHfM
37860	payment	2133	2133	1874	1	1	4649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj5E2Pv5Py3gQV7pQRQKxMtbpRfsppw4Tp7EjpWDdGrb833tz
37861	payment	2134	2134	1874	1	1	4963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGtGwWudkFVQ4Le8SroXCyFaFJbhAwfYS5sNHqN6m6gCcn934
37862	payment	1397	1397	1678	1	1	14518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzuRxV9nFoPqy2syiPz2r1HYukKhGpnXp9sqFxPBhvLEcSioQ
37863	payment	2133	2133	1874	1	1	4650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTiGosHyYkEPfcW9B9pyWuJB6UEPcjoekgFk4nzNgfCUas61C
37864	payment	2134	2134	1874	1	1	4964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9nSNMJo9YJZnhCg3w61k7pJvUAuamHB2Dopujmdn4bmcJdFj
37870	payment	1397	1397	1678	1	1	14521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPQETJ8RA8HZuuWVZgxVshTuQ8dd9tviJPNt8yXUauEwM8eBW
37871	payment	2134	2134	1874	1	1	4966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhekUBY2eHvseG4qF8srvUmQ5Zmk92dcX49R5AUF4jGRBVhnu
37872	payment	2133	2133	1874	1	1	4652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DB9fca1a2CZcdtjvwAFnADqTong97mVXmo75tZ7PPNfmVg8L
37894	payment	1397	1397	1678	1	1	14529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEENbZiudBgC2PiB6L3rc69h2GXUkiPsn3NvvfPuCWu4WKVtV
37895	payment	2134	2134	1874	1	1	4974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ZakryUwf74B93qvg48oArRnWyGhbPBXVkTXRcBT8qGrqyyQ
37917	payment	1397	1397	1678	1	1	14538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1ZkzeJPV27quccd4uVsJkwdhe3dS42qzDjM3wggpm4vBsp4w
37918	payment	2134	2134	1874	1	1	4983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw21fqaHgMmufEYpawXTgRPfLPB4U21Y9z7a6b1yQ9H9MfEpVd
37939	payment	1397	1397	1678	1	1	14547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6pzDkX54PnGLAWzMxz8zecco34VCQUFwMLndGoBp4kzHfz4Y
37940	payment	1397	1397	1678	1	1	14548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbZ6L2WyatokQqZvUokcuqr5cn4x2tcr42ZCHveNgqJSQcCc1
37941	payment	2134	2134	1874	1	1	4991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQR2fLZubTe2W1NEYw37WeQS6EQBZNvVQHzhpg1yFDRvGEhHre
37942	payment	2134	2134	1874	1	1	4992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UaXSyn1gLQMMmRWLyjy7ubyUC15fY3GgiT4TtqaAkwzaw5y9
37950	payment	1397	1397	1678	1	1	14552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XYoQ7vGMqj4h5n4PvFfa1Ayuoy9FdCnGLjVHRHVxkGVaLggS
37951	payment	2134	2134	1874	1	1	4996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEn8tX2k2ZxJxkXKJm8beHb6rzbW1ikcDDEFdz6m8M6Hp2wP8
37967	payment	1397	1397	1678	1	1	14560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvddv6sJ3Z1N54hn7hjA9xaKv9RBYNrPigcFvmdnVHmiLP7ezf
37968	payment	2134	2134	1874	1	1	5003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHoMwjQfnU3mgBMvokD3UqZsrRihDuc7GFYruhQZJ9LVzkigF
37969	payment	2132	2132	1874	1	1	1362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkcWy5jfVRnVdN6PdgRKQPi4dr6U4bzuP9mfa7purrXuomH4b
37978	payment	1397	1397	1678	1	1	14563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc9kLkXy3meAigbmPa3rBR5wimUMTjccvKvxsQfF64BG4wfbv
37979	payment	2134	2134	1874	1	1	5006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X6KpuKrjQgawUDHir9APdgTC1m51Y6Rwzaej2DHyU8UyWYzS
37980	payment	2132	2132	1874	1	1	1363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLCNF2Y35LaMAiKRuqdG3Xipuq5AwSte37gZcap7L9NK1BewR
37988	payment	1397	1397	1678	1	1	14567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV78KJMFmnWvqktEJ88Woy1oYGU3Q8j3eEWzXgZyik32PPFFem
37989	payment	2134	2134	1874	1	1	5010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvZQNhxmnWkL47QyLbjrLZ8a5ZfiQeGUhEGDTUyoVDtLsfw2Y
37901	payment	1397	1397	1678	1	1	14532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1byvS1akWw4Uw4LWvNiXjeLr1hbK1n4nMbhdmwEpYT3csTJt
37902	payment	2134	2134	1874	1	1	4977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKYLLwZ5h8ZbtX5NpSXpUmChRtkJgGEYJU4aL1CN14ZisHpcf
37927	payment	1397	1397	1678	1	1	14542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzsrDg38Ys8yDEZwzHDJhhgJjBR9dca1uv4rcTFcGpuVFyTzn
37928	payment	2134	2134	1874	1	1	4987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRp57ZTYeM5wdjTBYjGJx8ahtMoh8UzpKKFCWPCto84k777fX
37929	payment	1397	1397	1678	1	1	14543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhHSkLXUcxiS3x4oH8kZGpo7XpNGkrHuHEhMFLBj55SpzAUDU
37930	payment	2134	2134	1874	1	1	4988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9yJQQ4pS5SisMK2az8uAiY5GDzScujuGdKRvCyxUTYgSvBWi
37931	payment	2132	2132	1874	1	1	1357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNR8kaFeh4Pqx4sCVufZxYQXr6EPM1oFArm2mKWNyhxDdqJL6
37935	payment	1397	1397	1678	1	1	14545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ825AZesVYz5BqJzNfdeaVceedmQsG6WP9CGby1F9De3REEeyD
37936	payment	1397	1397	1678	1	1	14546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSvxHwinQPhah71jZn6zavmXRHrPATDSegnkbVkrimSgQnDrE
37937	payment	2132	2132	1874	1	1	1358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFKXUNmTexc8igQTvnow1WDXVL5bWPyZqG3TNkXEWsrafgYqE
37938	payment	2134	2134	1874	1	1	4990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsovBPS1iRTmJjMbUkNwp6dFk78zXoKb1nmnp5bu3jR919vVK
37952	payment	1397	1397	1678	1	1	14553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YwUJGRDSAxQvxF2etSjXaDgjX297BLVHHZsstksdYxhf56iF
37953	payment	2134	2134	1874	1	1	4997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgD1WzPwyNzufjiAn78VCEwmyobP38YefcMuXFpLkJ3nzxvU5K
37954	payment	2132	2132	1874	1	1	1360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G9FzVUQdTuLf5g9UP8cgciCbtwCJMK7TkHEyo2K8rFtnRXwp
37970	payment	1397	1397	1678	1	1	14561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZht6yim2WcBKzqV6Zn9gBnxbC1UKhShprgzLFxwXNJVyZ3S8gZ
37971	payment	2134	2134	1874	1	1	5004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEJ4rgLsQh6VygDB2kQv4Eh2NNZyHtZXv6Dugv16kq5C86ewC
37972	payment	1397	1397	1678	1	1	14562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtYWhja8fBu3T8bxzrF7X7XRag1kgLNUT39rpo3qqFzcqRp41
37973	payment	2134	2134	1874	1	1	5005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFC9QTazxdBqmM6egttmzEDeKjDg9qnKrmK6qmw2zA7eboqVB
37974	payment	1611	1611	975	1	1	9	832171175084	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11qL3KMS7dWVBjRobRUmpcnNi2FZBc2WgkxRcRGwK7E6a54te
37975	payment	1611	1611	1095	1	1	10	1491243621950	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz99ChVfxJPWcGB3a8s2yfjAazeParwitsqSU4NHkAMiRfV972
37976	payment	1611	1611	1215	1	1	11	1006171799398	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYF8MBeiypFCvRN3J16r9DoQT6AADiZjbc3N2s5Ym73BHET7gz
37977	payment	1611	1611	1341	1	1	12	2803787161811	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWZ73GjhwzgTZZNg2jnPWqes2GKQv9oK72qWsrmpZ8qihEoG2
37982	payment	1397	1397	1678	1	1	14564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHHPt27nrFZxDqtPDHLfh2ajDm7h82GyfVxJBYXQ9ggVvQWsy
37985	payment	1397	1397	1678	1	1	14566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWDEDfyZ2Yikvxcf3st2ZZjcFYGjMAXmZQuJQWRg7z87fvv3X
37986	payment	2132	2132	1874	1	1	1364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWX4aHBQEBDtUkc4YZTYnF4LLRhNEbxuqBp6w275VzCbJpyHP
37987	payment	2134	2134	1874	1	1	5009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAe3mGKrCZpAoCh1BRGmrYW6GybHvS5kvtUQ4v4inQ5AoNSsrd
38001	payment	1397	1397	1678	1	1	14573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkM3r6JgYEM1TKtcwtCgD1tvEr8YTTmCWjSarddWKteSWXUJNM
38002	payment	2134	2134	1874	1	1	5016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rQNbp5vSevtw3pRbxfQL7Rv4j3K5RQGAehtXwrTkKsqpY3Z7
38003	payment	2132	2132	1874	1	1	1366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoguMRmgpfQPe7629T5RV2XDWJJhHtFrZqrNgTKajNvVMNfR5
38031	payment	114	114	2003	1	1	8	6000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyA7BZGpJ1LaHugTnzQU8TNxVBWgXUDsjA8BTTvEN6hMgH8uae
38032	payment	1397	1397	1678	1	1	14586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXrS1iriJLPQkML8dqWfFZ9ptQHPgRfXkLyYYpfKEnYHp2r9P
38033	payment	2134	2134	1874	1	1	5029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1HVrkE27m8YazY2W1hjmpX1onvLSnmNqeTMqMkPbdYWDbwi3
38034	payment	2132	2132	1874	1	1	1370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWzXw3uzP9QXnfumxg8tXSfJznLa3DDb2tRZDsHbMnUAWBoFw
38039	payment	1397	1397	1678	1	1	14589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHcWL923VVrU9R2PpsiPBUokef2TCdShXcHzbRMAUekgMKnMq
38040	payment	2134	2134	1874	1	1	5032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiY1UozptkX9tzD1Ec3bZx2uz8uT3SDU3WrUcxRSv6FsMEYfp
38048	payment	1397	1397	1678	1	1	14593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6AgxDqqoKYVjwVmXgKdJFhDyWzYbkem6k7bZ1bGVxXNPeMv1
38049	payment	2134	2134	1874	1	1	5036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAGrg4ctMDsYFZJucUwV3Ck9mpWTjrEyUuDmfx7Lim7KqYAah
38050	payment	2132	2132	1874	1	1	1372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyq7QDNxZdo2rrLd9cN8NKvP1aRQXVLcXHGPm7L6qqD3uW48sQ
37907	payment	1397	1397	1678	1	1	14534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jcuy53ny2pa3cJ3apC9odX49osAAMsqCi28a7o7WBhSzyaML
37908	payment	1397	1397	1678	1	1	14535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7JcR4WMvkvpEmEeussavBLxBjpZoAo24bY6JAG3YmmPBhrHM
37909	payment	2134	2134	1874	1	1	4979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxntnR4PJT4KudzceSHbo3hjhBSJ3A4Y4y5QRBjRMG7c2PUmV
37910	payment	2134	2134	1874	1	1	4980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxkt3i6CBkK37CYXZU9UGUnCW6pkgaYq1qCivu5PTPa1Hmh2qU
37932	payment	1451	1451	926	1	1	12	2371000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZ3pqN7tPR1NaC7cDWoFUSc1boF4SB8RiQUmzEizbF5FpAPy8ci
37933	payment	1397	1397	1678	1	1	14544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1igSB79BWyxS7cqZvaQY3yVCwxNDYppRhRR5uiqSwyBav3Pij
37934	payment	2134	2134	1874	1	1	4989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKDcHfzFfiddjstHhPR97X9WuuXnWKNLJvBa6chNYuJ89kkry
37943	payment	1397	1397	1678	1	1	14549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Bq9FXP7oiY6KJQgQpMnub6LNivst4xLBJc7mVM8cVBq7K3eK
37944	payment	1397	1397	1678	1	1	14550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAtMk5UQuEy1oahR1xa3vzSpCeHgAb6ySVNbtpwQEgfHPkGvB
37945	payment	1397	1397	1678	1	1	14551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfbzV9XcKxTtevCpu69UFtnbBuBF2W1ty1CkYtNeKozBdV9w3
37946	payment	2132	2132	1874	1	1	1359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdggYWoXkSgPiymgvVRA6vVb7LNKGzCgPGhbDewyxPv8kLZw53
37947	payment	2134	2134	1874	1	1	4993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAFrtwB7rgdRnaPX7FSCgm3jZh3tiYMAKp55q8FxaUuzfs9HM
37948	payment	2134	2134	1874	1	1	4994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQCMLSPA1UZ6b32oVG3A3Sq4KqK27Fw3QK7WJvXvBZx75dwNs
37949	payment	2134	2134	1874	1	1	4995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9KQpBiPwdDFya65hqyeFBYzyMq7pFPwgJSeFKRNPpDnrVncb
37955	payment	1397	1397	1678	1	1	14554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSBxZcoGJMv8mVbjNLUZhDPKqnQsgTPnoUFV3eXwmuhwsXHdu
37956	payment	2134	2134	1874	1	1	4998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXsw78Jkc4rfnaLpB6Dau94YDFEUDKQ1EMoA1mk3uV2ayWaZT
37962	payment	1397	1397	1678	1	1	14557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQNjYQt7wkKhm6BMKnmph17bMrmzDsw1eQNACjo2UoHZ1TBNZ
37963	payment	1397	1397	1678	1	1	14558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtz4YuZC9nXSiew7Ffy83bxWzH1Gp1EVSh3Jyp4bUGydbcss6m
37964	payment	2134	2134	1874	1	1	5001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxB8ZtwA3DkW4y2U75hQefjdL7k6MrSwUiDAHpTc957BMV22AY
37983	payment	1397	1397	1678	1	1	14565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEagR6xAf9pzANPk3Sxk81y9nrt7KtccgG9wnV5m2YBG99kfc
37984	payment	2134	2134	1874	1	1	5008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj3JaasRmfxqj1KF44wUYhh8ZuT6vbmgoQdtWZ5NnD912RRo2
38008	payment	1397	1397	1678	1	1	14576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirztc3gXBPFWEdQo8P6grYxnKJeMNxUFoaKZ3wSjpwGgzvxHV
38009	payment	1397	1397	1678	1	1	14577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqy9UCPT6u2z49sQtwQtaicGPaAAMoNjpJjhgnZBJy8bb7Nut
38010	payment	1397	1397	1678	1	1	14578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodVUdGG9teBRNMKFoKD7fmnHPTdJKfPndJRpSnhPpwRsX8im3
38011	payment	2132	2132	1874	1	1	1367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NovGUqqfy5hJzkWs7E1UmUyjfZMw4pW1YS9HyFiu2Fxe9zoU
38012	payment	2134	2134	1874	1	1	5019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49EUToh8GPbRZTXcP2sVVXpeXk2DzPmmWAi55RzxX2vG8zhxg
38013	payment	2134	2134	1874	1	1	5020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCMUG2UfpDiMWrALszBkxwwPSpHgxxQbXgJPPjysTaBHCnus2
38014	payment	2134	2134	1874	1	1	5021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwTwTNtKmHEXopRffjsNL91Qh2GEtQip16kD2euBd2pST4X1b
38020	payment	1397	1397	1678	1	1	14581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6ZDCcfFcFaUsjLzY1Rx2TsRhEgr84sCGYRCdJwpZguDJBs6
38021	payment	2134	2134	1874	1	1	5024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pTKcfiSZuvXHWqadiorVks8wtkakstqr4p7nHYxwzcQswsqN
38029	payment	1397	1397	1678	1	1	14585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHLhwRsS8MYUf3qZ8bXX6jwDvtXsNDzNkRknCEscL6ZfEUGLr
38030	payment	2134	2134	1874	1	1	5028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c3RrKS8hq6Q9QicCSzLtfSpMQuhqeV1LTMigLV6pveUftBd7
38041	payment	1397	1397	1678	1	1	14590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZLhGJh72Y5TkqpLbQ9KfGEmKeobp5BBdFy1pkTW7gTuG4AfB
38042	payment	2134	2134	1874	1	1	5033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxBUaJYE69tsrhCA5eoCT6G1n94JyVtfvUMJ6eEbG4B5C8Uys
38043	payment	2132	2132	1874	1	1	1371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfn1cjhXjjs6hyxy6ccN1DPgSNBouZSnjnzx8Q2kDH9tf5PYV
38081	payment	1397	1397	1678	1	1	14606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmchrj11WkVjhCSHi2ngeU8reFhW67MXt8tovQmNwge4CwQs2g
38082	payment	2132	2132	1874	1	1	1376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX7wfoUmN3ZSfaS7adLh7bPb5YxJWcm5YK1RR7VR6snbpqNK5
38083	payment	2134	2134	1874	1	1	5048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54rw6eh1xFDQAGdF1xh5bnLUCtRtcBifpumqCKSjMiCCorC2a
37925	payment	2134	2134	1874	1	1	4986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73QPN7qgmtp26iURVGmbSHDLmVHLPs66WMrBBecSnCnzkLiKU
37926	payment	2132	2132	1874	1	1	1356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ae9A6cG83hLtnGgzhDUnE2dLmDcb4WXAsKszPuwePqAg8nmc
37957	payment	1397	1397	1678	1	1	14555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiyJLZc3mi33HLDsKEuK3vX9bCpuAc1RV3m7ASmi55VCUgTPi
37958	payment	2134	2134	1874	1	1	4999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdPYqZcxdTEVJ2FX5bPZpjHz82gsANwBD9SggEcye3gM4eCbf
37959	payment	1397	1397	1678	1	1	14556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXchsg74N15ot7MSd6tyAUQKfVHjdaDNPt4FRPc8NunTqKtqZ
37960	payment	2134	2134	1874	1	1	5000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN34zmC4eVFZtJfgEmbg7HYKSdMPr9ogHTiKvBJbdJkER6LwmD
37961	payment	2132	2132	1874	1	1	1361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBnj1XgyxiKQ2g26BHRTxEJ9CJGQcFPUU4W1qfpHKbm1maUbQ
37965	payment	1397	1397	1678	1	1	14559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBviVTKQT5STJm9xk2vr3fbFCciPgRzoBTaq1KKJTmiTiubVPi
37966	payment	2134	2134	1874	1	1	5002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJiwSMxBhUs47qCmtuHBaN6ZkdixQbgbWDVmakcrpVHQEjTQA
37981	payment	2134	2134	1874	1	1	5007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XCm9X5piM5NYib5PxW47iLdZnnemTFHUCX4Um4LcfdSNWAE6
37990	payment	1397	1397	1678	1	1	14568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZ2E9ujpmKGwwjZq7v4pSPk6N46VVe2PWEJZpRxim7Trf88Cj
37991	payment	2134	2134	1874	1	1	5011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyAcieaeHt1T7ds5Aaj8AVqi9QxR4tyJzVCbWwjfPGAkhoq9f
37992	payment	1397	1397	1678	1	1	14569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhvZsbnsoQPiAPJvqKfoFcnoFVUFFz8sQEXVK4Yu4BR24T4T4
37993	payment	1397	1397	1678	1	1	14570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CoMkajCycYfmqc1L41fRnx3vL7N8KFjqDzpL3SkUvfjwc3Cz
37994	payment	1397	1397	1678	1	1	14571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdf7mHuPB9tNjEzPFohEAgBneyQCXn3CFZsJnip2rb2siehKWN
37995	payment	2132	2132	1874	1	1	1365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eWhM4x8QfEwJM71oZtpS9UCAJvm2Cd3LSeQXSWyMBhoBGYTR
37996	payment	2134	2134	1874	1	1	5012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLzj7a5ocas9fb5BVV2gEyyxgZmqcRDcouvAAmkeWSzx9Rufu
37997	payment	2134	2134	1874	1	1	5013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wRyztMP21kycqjG4n4hu5vH7Ca6hbN9LoEfwuRqTC8oXXeF1
37998	payment	2134	2134	1874	1	1	5014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqbMf3tUModv4Ria52S214xpt7Zate7uMT3RsQQQd64PzJDH4
38004	payment	1397	1397	1678	1	1	14574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AUQ498jX5YRXE5DRrrp3uXzhn7tfpPEVL8zKp5x6vV1T7Kd8
38005	payment	1397	1397	1678	1	1	14575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWrth1ns5CAzCatQJpSajo9Mkzt3Vidhj7UmJRkkZKFmfdw3v
38006	payment	2134	2134	1874	1	1	5017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZak4guevpwmhhNZxz3g2apSgWwFoBqysBoy7XzWiFBFcV8TwHm
38007	payment	2134	2134	1874	1	1	5018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxNTrpu6eATUmGJvCYu6G21mUMZ6Y9crAJSZpV9cbT2iVF4cw
38015	payment	1397	1397	1678	1	1	14579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSZPRQ8WA5R849JFXiUJ8sxthCge8U9yAaDgPSH7d46CdQAa5
38016	payment	2134	2134	1874	1	1	5022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoA3ip4R7ifQudB77nnax5UrNFxTiGPLitoNdbQ2azHivSS52u
38022	payment	1397	1397	1678	1	1	14582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LeAJbop2Cm1pXdzk2ShzuKh3eBdJppPG4URdQkoRHzUUBUEo
38023	payment	1397	1397	1678	1	1	14583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2tuxqbMG125hbGwYNtbPoLYcu5B9UgSNF97yv2iigFAGULX4
38024	payment	1397	1397	1678	1	1	14584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ssELRHLceaXd3FaQeMVTtYC9u8ykDhhzyKDXc6qVUS2CFGvD
38025	payment	2134	2134	1874	1	1	5025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcpDMcvPfEjTSvE8mYFfSmUs59svjwmgRUperFfEMFQ6rcfDE
38026	payment	2132	2132	1874	1	1	1369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9r8YVgzPQNwURWqDz3E42pYsh6bdWCjeN3vCpRJaPeoHGNYs
38027	payment	2134	2134	1874	1	1	5026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPswqkGZSQBKaa9USRPe23tv7sFAjq6RzeGU5RfCkVCnDzAqP
38028	payment	2134	2134	1874	1	1	5027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntbWfXYtyFK2Zby2K61oaQK8VXwb2YrLxmcnigRfaikNpJkwQ
38037	payment	1397	1397	1678	1	1	14588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4vz6ak8TyMEBuH5BsrBs5Kofah19SbbuAWTYUXaRzCDKEjDA
38038	payment	2134	2134	1874	1	1	5031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Bz9b5RgfwnJzcChpDXuFnEYsstVxbTkiQngakDfmF7cSpFmW
38044	payment	1397	1397	1678	1	1	14591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2U58tbU9pe4hLAH72AHUTyd7aqKopA2QsUwudZ1rDRQxxPnM
38045	payment	1397	1397	1678	1	1	14592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uhysQUTnz7ZKfduBLFRuc5uZeypzGDMV7rY8f3XLn9RbzDeh
38046	payment	2134	2134	1874	1	1	5034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZquEN97ZNpa8BHmu945raQdFFpMYYKxGWrP577CXkeWeP8V49p
38047	payment	2134	2134	1874	1	1	5035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3dNx4J3oHMubMzV5vaYWDQdbcDaFxN9chkVWunhBd8LfZG3A
37999	payment	1397	1397	1678	1	1	14572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjfjvYkFoFoSbSf8BCGVbQw3y17oEGw4qQLUbe36nQ4cmQ5cG
38000	payment	2134	2134	1874	1	1	5015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDKNriUQuAD4Mv5pog2ddR8DELz8yT29Un6ACGFG3KYgEiVHb
38017	payment	1397	1397	1678	1	1	14580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNT8RzzMgciof5oxDjhac9awT46CKM8P8MmaA4hZ9bc2Gc75u
38018	payment	2132	2132	1874	1	1	1368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbH4eSCqkVkzHbyNiB3tA13uoEDZDUuxinnjHdQsSUnx1jLRG
38019	payment	2134	2134	1874	1	1	5023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWR75Mi6rwpkKtmmpw1ep518aZHyvXe2FvMeC41huoKQeMtYnG
38035	payment	1397	1397	1678	1	1	14587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvcCoCEKh26KGebD3j4N22QQciAwXNy9Vbk7yihvy65XEcRRe
38036	payment	2134	2134	1874	1	1	5030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVD8aHVif9z8Hxef2a31S4PfsU5oHxXpWuWFiL1tZdbXk61xF
38054	payment	1397	1397	1678	1	1	14596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE3ebb5PFKwsR98A42c2d1JXF4AaT2t33qbwDVLz18sHutxtT
38055	payment	2132	2132	1874	1	1	1373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB37nmv5UkQbD74bpq4fxKtw7GPK24LgWBLECtv8qwqNKT9XQE
38056	payment	2134	2134	1874	1	1	5038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvv7W6acnnXwZq7hJpHvuZ4eu3yn3reGT23J2KCGdZBUQtyAH
38061	payment	1397	1397	1678	1	1	14599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjicCkPu3t7DfFKCh9htJNio6HBc3pLoZj8tWTz7wQLovG26mL
38062	payment	2134	2134	1874	1	1	5041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWHDoWqeKSJqVtJTdwX2mw1qFNVXo2nYeTDxRw4e1WRmLjguY
38084	payment	1397	1397	1678	1	1	14607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbxQWqPfWwtqL2yFtdr9TwXrMBPA3FFSpF5psFaNaKq65bGdv
38085	payment	2134	2134	1874	1	1	5049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFAshwvTuXgvUpBVnd43BZShmAq3fdsKWC7p6m2NRvjsKMzCA
38100	payment	1397	1397	1678	1	1	14614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemzvctmbTKHUyg9nUBQseKVhgwWrzRsy7iwgCzBfzcgLQAS6s
38101	payment	2134	2134	1874	1	1	5056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZET98uhJixpzfAhfpjHBUsRD64iV1T385E9zYvpuhPWL8ybqz8
38125	payment	1397	1397	1678	1	1	14625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARsdthJCFWxGGCzXcKXQA8rbpWjW5CBttLJfGkYX9UJDrvpLH
38134	payment	1397	1397	1678	1	1	14629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4zptSePBs9U7nmDvJJj3DayaAqzd27Q5Wt9ULTfEGsYS9UhP
38135	payment	2134	2134	1874	1	1	5071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymwLPSJ1Pd7ZKB44swaJKGB2UthH6xC6jHb1m5tLmoiaPGj9a
38143	payment	1397	1397	1678	1	1	14633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKe7E7AAeYYPY8QFFKL63rhUN32MNDuycSnrZZokhQPxQd45xq
38144	payment	1397	1397	1678	1	1	14634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkoMKFbKbkW7AHgMugdaAjbxYRXYB6uquJoT3Y59J27K515rY
38145	payment	2134	2134	1874	1	1	5075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9FssNQjpn17d8sTu3NKDPngcdHCY22FitjUf44cuJWBArtGD
38146	payment	2132	2132	1874	1	1	1384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzP9a22h9A999xMUPqYj49bA8mpFyAyMB6EjkCoYR7Go54vGor
38147	payment	2134	2134	1874	1	1	5076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7i4h9g1AFNyrC1rFxQR2N8zCwgEkVpW386QnXyrqW4AcYdJfR
38150	payment	1397	1397	1678	1	1	14636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMk6o6xbJBG1Vwusiawxd3s95vsQvFpvfD2gj7DgHJTU2Jd6p
38151	payment	1397	1397	1678	1	1	14637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfNFG1Zq3oA55AMGpp2J72F5fBPQUMdCNBz6qQyfJXyEL5wi7
38152	payment	2132	2132	1874	1	1	1385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7pTUwMCC883rpeZwS6ER8vCZ2gqhQrptzMhXkJzDUgujaVNc
38153	payment	2134	2134	1874	1	1	5078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYffs96axaLE6qLPUqyv93ZuYK6285Rv58VWFSQ1s8nVwD3QdE
38154	payment	2134	2134	1874	1	1	5079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6tuiuygHekBP5MYEThCz2pUXoJdKkydAo73bzPEuBtaVhaNL
38155	payment	1397	1397	1678	1	1	14638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NMt4ugEhF3zqseZTN5L1UdKWGCSHv4RLYTbTHfKbJ92rpYuv
38156	payment	1397	1397	1678	1	1	14639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAUQwCFPQKmGVA68vsoFBRxyxhMdTddk6ZsBKjmaTWCLGKAgZ
38157	payment	1397	1397	1678	1	1	14640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHR9ogbPJk4n7VY9QDVTDnjL2EQ4nqpWEh9WqYdErMrcb7BZg
38158	payment	2132	2132	1874	1	1	1386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqCxbs2zyok6ZdkekBS7hDRjUfPr1msd5DineUaNtVhNQfP1Eg
38159	payment	2134	2134	1874	1	1	5080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpePsDF7JpYHj6L7jn6yNv585DT1JacR5AzAK6j4gS56UWFSi
38160	payment	2134	2134	1874	1	1	5081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSYwoNBo1wZSgubngGVvd6U9dUqnbtYknPgbDCCYasoctwVri
38161	payment	2134	2134	1874	1	1	5082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1MpKFsJ7TFGEtsoWE8vveUQjahNsnLgDvnMjzk2cg6B4HEJY
38178	payment	1397	1397	1678	1	1	14648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zvL4zDMi7VtCWdrkQxtR9Cjvy95NBYB1EKoHNRixungVHFxd
38179	payment	1397	1397	1678	1	1	14649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTw6fyTQc1WD4cvFF1WNZYBiBCFFsxGPu61Yj7T3CS4VtUH5Pd
38051	payment	1397	1397	1678	1	1	14594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvVfG9xsSoawczUZu9rXe6D1TmSDtPvg42dkhkkopksuY9yjr
38052	payment	1397	1397	1678	1	1	14595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupGZ9TxP4JYEmSR9eg5B3JTAscYP4StTLYjkpFkGurYzop2tn
38053	payment	2134	2134	1874	1	1	5037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjEbucoe9HDn61WziXTxggus6sKXhnxuEugZWheaDSCGSvb8Z
38063	payment	1397	1397	1678	1	1	14600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54f9iavbgqJmyaAfgCDz3PvrKYiXVtzRyjwJmj76rxDMNfShg
38064	payment	2132	2132	1874	1	1	1374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfqso4hCBm1hVQpskPV95aoS1t8GoJemePQNxgfkiofKKL3qx
38065	payment	2134	2134	1874	1	1	5042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyXN93hgoeN8e6rZhxPcnRtn7w4VRC3EnKkiPwBje6XjHscS8
38066	payment	1397	1397	1678	1	1	14601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjkFak4C7ZYqu5jwqN79qUsJfUk6rEz9YZCzWMb1UL1Mo2KwR
38067	payment	1397	1397	1678	1	1	14602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vtD8mJ8G2RF5s6QhgnG9JCVKmmYfW4Z2kwFLsNJW1goPKYMu
38068	payment	1397	1397	1678	1	1	14603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFeg4zea4VQ7d3p5mu3udyyCyB5EdQsEuyu99pQXkJFyBfTyw
38069	payment	2134	2134	1874	1	1	5043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRNNZJ9qbRHWjm7vnb5cwhNz1nkTv2X6S5ET6Z4dDzZuZCFte
38070	payment	2134	2134	1874	1	1	5044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LcRQizpDcVMmSVF34B3sSGCNtJ7TfARFZ4gBAqURnWCHusPt
38071	payment	2134	2134	1874	1	1	5045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrgK53jUvF3fHmussQSk4j2xmRXK7vdbH8RfHtvkJNXKaxHdp
38072	payment	2132	2132	1874	1	1	1375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHWMifSWzpgitJFb9PRzkiEkeMZqexBott1QMJQj9m1sA66Wr
38093	payment	1397	1397	1678	1	1	14611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJSzz64o51o8Qzxv2TerTpY8mwtx2xJmPNBc83ePEECCqZvTD
38094	payment	2134	2134	1874	1	1	5053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjm89nckdeCXgmaucLifsdiFvEbJzSBrQzhRGe9j3DSPqqGGND
38104	payment	1397	1397	1678	1	1	14616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjb1EJEcBAYaAZ1G12ta1Dp7nFiidUv8eNH5XMakRe1QDshu9f
38105	payment	1397	1397	1678	1	1	14617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pgZDQATbSWj47zsywzApnmjJT1bHgwg9ww3cjf4RAin8viLC
38106	payment	2132	2132	1874	1	1	1379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYyh6ZUgAGDXH7qsY5vHJS4Q7TN4BqiNfDa6xx4d5SPLomK3W
38107	payment	2134	2134	1874	1	1	5058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdf9nwazUxpDmkbEZen17WK4A74Gm9mNtjuno68zrN2xJeSeE
38108	payment	2134	2134	1874	1	1	5059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYas5tnRTx7co8pbhZJ2CyGUNKpum4WmG7y1axpZpu1xVFN45ST
38116	payment	1397	1397	1678	1	1	14621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi86MPixcJywjahPqrha9AXeLFZV8174VfkGM1K1un4sbpzjt
38117	payment	1397	1397	1678	1	1	14622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVk4EA5myPyNTK1Q8QbrHQs56k6CtstfZhvjb8yjTsTckLpsg
38118	payment	2134	2134	1874	1	1	5063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenXJEkEpSzuDdP4rn8P4m4f2zS7C1PiifW1JxUcTdaRTTPZZo
38119	payment	2134	2134	1874	1	1	5064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvKit31R14ecRSr23TBWFQKqsD2EdGMfL76vSYJBqxghw7tYk
38122	payment	2134	2134	1874	1	1	5065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6ena5cT792T1A24wvdNT1gWpuNkoHeFdJGnqkaiRmcsDrUjm
38136	payment	1397	1397	1678	1	1	14630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5XW44LYq8T8VbTkzHGKw3yZWDfKYeqpaxWidvwkthHgEHwmS
38137	payment	2134	2134	1874	1	1	5072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddg5T1AcAzzxJiQcZmbQfaj171Gybu1p4Vq1LJg5J7hrELEWp
38138	payment	2132	2132	1874	1	1	1383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvEAveWdG1xTfmYYJ4uovkVogifgcv1fhG2DZX12KUJoB8ucw
38171	payment	1397	1397	1678	1	1	14645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88u1tqhRtep9BpxrVLhiqLqcK7urMx81JaXwyviapEuLhVQHU
38172	payment	2134	2134	1874	1	1	5087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdM7Aqtq3db1yq8QyZ8VH8C3zoNaU36yDSCEQCgN5LdRZFW9W
38182	payment	1397	1397	1678	1	1	14650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYks6498W9qfif7AGFiA2GPCAdmsGT1nG3MgsR9nXTyKUsNgtXe
38183	payment	1397	1397	1678	1	1	14651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZE5ov2QhXUawtAEV4GRY5c4wQjpx22VkCrM9Lxao8i4P87Ym
38184	payment	1397	1397	1678	1	1	14652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtniPHP9MfWA1ci45na6bdrtAK8foNJs1ijaky5BM8BxPVMbek
38185	payment	2132	2132	1874	1	1	1389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSuC6Nd2hLagKRsZQKKTYikCxzbZqpSDnRRASJnGN1ZHf8obQ
38186	payment	2134	2134	1874	1	1	5092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQxtk3iSXLeLR3EyYTmH4CPyPMh1nXXnvZqqaCLbMmkxGdzmU
38187	payment	2134	2134	1874	1	1	5093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZSRHPbcT7KXE1zBrDFRMb3A88ASpHGP7kCJvdmiDY6oJpgTM
38188	payment	1397	1397	1678	1	1	14653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LA5rX78iW4WyGWMCgrej2osxZvjwXR59sCV6bJ7UPkfQySxQ
38189	payment	2132	2132	1874	1	1	1390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9Fb1hcdexr18YhfWVLYnxsMVE47fJyRoecAG1un3tKNvaXdv
38057	payment	1397	1397	1678	1	1	14597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1onBceKLjMiAsHQkG56q2brRG3fG6ouQBnydFZDQuupAo51w
38058	payment	1397	1397	1678	1	1	14598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv7UePHCx6sZw8kSebDFXbcP6p9uggvfcCAmxUzjJvUaRH5Yo
38059	payment	2134	2134	1874	1	1	5039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhwy29JYsmmN5HNPz1HjczEYuNVrPbD5vk4nJhEm4WF9BTFCK
38060	payment	2134	2134	1874	1	1	5040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrNMfkZTBGdYfXovoK7rZyU6P7DcMjswYpknk2Ny3Q1kgvNSZ
38073	payment	1601	1601	1388	1	1	17	4053000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYdQXi7qDECAHQo98zXaBRKXtAu6u8SZUcFEJA2b4gmJmgn9dmY
38074	payment	1601	1601	1142	1	1	18	2156000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZQa3TGatwdA9QoDSMPs1UPsHz6ZcYeABruAzhawjR5Z2e2iDaj
38075	payment	1601	1601	1262	1	1	19	1455000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYhQ56do5TcWzwtJGQu1EzVPiDsuUVsjK1oi4mjF2jULkxJrFkG
38076	payment	1601	1601	1022	1	1	20	1204000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYwAxaKGA27rNuMBReMC4LcHBLcFEgvhxN3dokDkHC58GW6oWsZ
38077	payment	1397	1397	1678	1	1	14604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqeaYF2uwQBYW4t6sgRY2Bxp68unqyC7x4eKmXdbuLjhRrdcz
38078	payment	1397	1397	1678	1	1	14605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXwW5CKvfqJxRv2LCfNAMM4gwFTEMM5uMMMuf8RP3q4VjhE7A
38079	payment	2134	2134	1874	1	1	5046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf3wQtzC5AYzNJ39AQo33xcQmb95UoohdcLoPNkS7gPzUdWqt
38080	payment	2134	2134	1874	1	1	5047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnriXSstiXswd7kyQGxEto4TxhWwqsSzzMWZghoXdcFGDz9cMT
38086	payment	1397	1397	1678	1	1	14608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3x89PmKHCoFHQF2CKqjn99RXAXHgHENE9x755taBj18jh6uuB
38087	payment	1397	1397	1678	1	1	14609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtADxC7XvJdPGxErwqhQWqu4FLVoo9mQdGeCJe5c2wm9njtXcj
38088	payment	2134	2134	1874	1	1	5050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hrAsQX9MxcT1EMU13oHgwDND6niWi5QbLvz7HsAdYPg9wkt7
38089	payment	2134	2134	1874	1	1	5051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZA8w93JY1MY6tLycRANpBXcD4k3hhVcdZ4ZR8GhPjBoPfNNq
38095	payment	1397	1397	1678	1	1	14612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANJfWmJSgXY6RACyJaDGGPR2gBPDJSoRHLjNhESmXD4nWXpqb
38096	payment	1397	1397	1678	1	1	14613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFypmiXpEQL4vGo9gF9XCfhQZdPmyo8Nm82tjTwfkAZ7LN8txB
38097	payment	2132	2132	1874	1	1	1378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrHD6viYsg2okPeQ9MtyTWCLTQzDTtJzeNEGWUpc3dMSvFVCm
38098	payment	2134	2134	1874	1	1	5054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAUGnYMrgQSnxza4T5QV6Umq6NpBAqgL71iA8gzFJkN16zQ2b
38099	payment	2134	2134	1874	1	1	5055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnB1gn3arudKgbmapU5EwqmiDEkhBn9yGiucViLNKN1rPNj3g
38109	payment	1397	1397	1678	1	1	14618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsws8JWSvSd88mdX4WsxxZ3RMHh2HZmpzzR3ZeqCHZMGp2nFvf
38110	payment	1397	1397	1678	1	1	14619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GeMMyvxNndMxWotyYXLhdT5WD53uiUo5ocv8LvxiasrEFpy8
38111	payment	2134	2134	1874	1	1	5060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbEDhAPDwkS1tbgg6ZzsCp4BtKAQDBfLHzLgwigmeXmoCCsMu
38112	payment	2134	2134	1874	1	1	5061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2HAQyaML2gxio5LQAu5AUM2VosH2BTM22pU59Y2R8HXsrv7K
38127	payment	1397	1397	1678	1	1	14626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77V39UWWjyHwo8pGgCwpTHWXMR4ukMMUfAxRcJ9LLPLvTFfhT
38128	payment	1397	1397	1678	1	1	14627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKehv7cTgJTtRdBnCxtyELjJmKWxeYA5fTtLoAY1DzvUNAX94
38129	payment	2134	2134	1874	1	1	5068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCfXWWptWZbfjvbVNafoim7kY5exkQ6arDr5H2C8ttFC2663C
38130	payment	2134	2134	1874	1	1	5069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMcgaYFYpFs8mGJ5ysPpUqniSomwrm33hxp6K9RYmNPnbi6N6
38131	payment	2132	2132	1874	1	1	1382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zz3A1YUAtiWWnEEM3S1kuectpH1FHpQchiztuYNoCjoiwZeZ
38132	payment	1397	1397	1678	1	1	14628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyr5kNj11omLyCQFXwvv19C11crxuKdNMEtnQ3jJ4yvwxYwBq
38133	payment	2134	2134	1874	1	1	5070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kaYZ8AfkK7yw1FdkxQjsenx9PTidVHtZmLYsYiVQmgZLFAZL
38141	payment	1397	1397	1678	1	1	14632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPoTvLhEZUw2FeW1z3AenEbxL9tTT84cSwW7HnMZ8nF5p5wq5
38142	payment	2134	2134	1874	1	1	5074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCs8kC1h88SaocZ7CNF9yc4CdKhTVHPGKTGvosFXYt2jaLenU
38173	payment	1397	1397	1678	1	1	14646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSmt8wcxmo55dq7DabBSi7UDqLXX9CtGXjmBrHagqc4WmMXnv
38174	payment	1397	1397	1678	1	1	14647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrqDexwi4HiktEur1NeQydkEV9Tv3xEg9TA3yAb3eDQho3yS8
38175	payment	2134	2134	1874	1	1	5088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgBAyduV22wUa11L61LEGrUSrmkbXHWabCDM7b8YP2YVZdH4h
38176	payment	2132	2132	1874	1	1	1388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KTdGeqEyahL3fxaY19UTf5UzahAk8DvCSEmWzP5YrV5ZL3iy
38090	payment	1397	1397	1678	1	1	14610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjArcxuCUGmKKGLc9CYo4XQxX1skm8m1nv1mTpizz4ogwz3YTH
38091	payment	2134	2134	1874	1	1	5052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMcTGcQaHqGsva5HWjvAUhuA5UWW5xNpS6AGtMvXCBEDdKXag
38092	payment	2132	2132	1874	1	1	1377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RT3YKzHa9gcipSWUrNG3xjknbm2RPDCaQQieaYxBSEZZPSB1
38102	payment	1397	1397	1678	1	1	14615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpZmxujTQKxgmibZQPMmQ4Wdo7UTGPjyR3ZA8HUBDgoiXRj2A
38103	payment	2134	2134	1874	1	1	5057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKhYKbEjbZ68aBbJGakTWn5GLoSMeq1K34ifuB29c8bHn3M6a
38113	payment	1397	1397	1678	1	1	14620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VVrA5s9xqJfWGdHGNvpvP6RDLiDShHQ6B5NzaHMF9aZwqWYu
38114	payment	2132	2132	1874	1	1	1380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTWAnZCLmEExEopWWWcJNezRqCtqSG7c3QAFWLdimCBzp4aNu
38115	payment	2134	2134	1874	1	1	5062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4uXwV6VXHYUokmsgkywjwRCEzUYwNMk9vC1fythokJKmLRDY
38120	payment	1397	1397	1678	1	1	14623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qH6VCJGD8ajAQfMt7BtWfPURKYpKe2KM6eyhBfbrw2YihNxh
38121	payment	2132	2132	1874	1	1	1381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSgV4SmPxw1hYJdAUFc3WiKM2C7vwHN9hLqCzLgKnjTb1kw1m
38123	payment	1397	1397	1678	1	1	14624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCzvyZPN94LukKYap9JqHxpEPfWqmkjoLed3SZ6gmZ1kmjCmt
38124	payment	2134	2134	1874	1	1	5066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEr5QKymxKKCMaG5BZ8YTo3KNmrqbL4yVSG8kCVN2aDMfNCUr8
38126	payment	2134	2134	1874	1	1	5067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TEZUjf5Cq1T9Mo4rDqBcoyn2P2N9yyxDUZGttnv1T9UrbybZ
38139	payment	1397	1397	1678	1	1	14631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PrahsYDG8zhYRokfjQZiQGBW9R2oJpCrfxGBh2n9zdc2Eb9d
38140	payment	2134	2134	1874	1	1	5073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3X2r8pbyaCUDyShEs42h7JbwrNBp2NBbA4rgPoKdCqT56d5u
38148	payment	1397	1397	1678	1	1	14635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkTZUbmM1YyMbQreoi5dfQQjRZU4GtVJPvNcK44AMr28moyh9
38149	payment	2134	2134	1874	1	1	5077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfirMMR7vzLPqMjq4TvoAu7qgYPzcwoAFeptqymYipLte9V1ou
38162	payment	1397	1397	1678	1	1	14641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCgaq2LRgAGDQRrmEwa9nhLnNyBm6xuKoBLdEYmLwYDA4jbnm
38163	payment	2134	2134	1874	1	1	5083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgse7kGQMyzro34pTNHhxCAgBFP72kEfmHQyGW8BiL9kFjG9a
38164	payment	1397	1397	1678	1	1	14642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs74Fhe3SVFzNtt9L4Vb1HjgoRRLZo3MKvoeRqCDEnKAxdSces
38165	payment	1397	1397	1678	1	1	14643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5GdJcvwC8SZmf8HtVb3E9jFqEEADKbWWjMkPwFwE6sLivGXS
38166	payment	2132	2132	1874	1	1	1387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUAM7ww136L1QtopfNADXoi8eVrQdLzdoMg6TJzbQeQo5Lz4S
38167	payment	2134	2134	1874	1	1	5084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VEjDEMBnjFzVcHgRLDxoXwQHcbVNZeW7doirqjdRXQa4K1nd
38168	payment	2134	2134	1874	1	1	5085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9D61uaFDmDEkgigqLPvJLrmu6CnWMod76BBPQakfQnynUBnZ
38169	payment	1397	1397	1678	1	1	14644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMKz3PigXubPFRW2XqMvUkw9PF5ZESq7Qzh7DZcNPnhNoLmB5
38170	payment	2134	2134	1874	1	1	5086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerhqrfK1jsaciXqXDxLhGEruqxP24sdVxDvHWWVz9yCdMwUZy
38202	payment	1397	1397	1678	1	1	14659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYz6CoaCkQE1dbN2tvzkEqMoQNs8jhBdKvC3upP6TBF7PxAu1h
38203	payment	2134	2134	1874	1	1	5100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW3LnU6JB4hvMYgaLQUy1zzdxjnG9xxaDajU1FfwNw6VAnNpS
38214	payment	1397	1397	1678	1	1	14664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDVtgFMiioQkGhNY8XEZXChYEBc34m51TXC7Aeeirpc7BH5CE
38256	payment	1397	1397	1678	1	1	14682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuh7h49NEKNPysdde8sxYLnXPtRb7wiWWp29X6J7M1JGu1a8Hj
38257	payment	1397	1397	1678	1	1	14683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QoR9yraxRYQvNyZXirCobuZSP6L3QuNoZP6KgRQzCsRMce2r
38258	payment	2134	2134	1874	1	1	5123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMttM7Fin1oxgU8Fg7BURDyA4vZWe636HDhdbMBG47z1NUhxdN
38259	payment	2134	2134	1874	1	1	5124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoJFjJ3REhJHXhHHP7E7ZJRhQsVsxHDzbagHMHRmTGQq3FS7q
38260	payment	2132	2132	1874	1	1	1399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBhESF1KPh8rX3mCMPwjqKnorD6RrnjX2LcWSHjMC7Bh5MYnx
38276	payment	1397	1397	1678	1	1	14691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1QdMGECBYGTaZgxajJT3bmK4zM3j4pM2eBcTHejkGVrf2ReM
38277	payment	1397	1397	1678	1	1	14692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqtPXLYLBNTFqk3AfZPS7aE1vRfjx42SBKJKVP5gGccZue91w
38278	payment	1397	1397	1678	1	1	14693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFoq5YF3oNy9hcQwVzq2CAa5BHTucYe635Ygib1zk2X8axvU7
38279	payment	2134	2134	1874	1	1	5131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtLEKfcRDkub9fY5yKbucSyfiPvdmNXM4q4rjvz4GohAq6ozH
38177	payment	2134	2134	1874	1	1	5089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeDoxvta9RLKya9tDS4ESuNWboeTB6Prd3wFouW6g5x5Dgijf
38191	payment	1397	1397	1678	1	1	14654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk9VR11fuGPmrzE28saUoZBQ7E3M7TYRVM5os6okxWHrDLtFR
38192	payment	1397	1397	1678	1	1	14655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDYSgmuzpuRbVXMGvQohnW2YKRo69WLYEwfz4EkZRycNohMag
38193	payment	2134	2134	1874	1	1	5095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5jhhe1BrLX5zCto8G8aLzcziPzYkkByobjWF6GyGTRrNzRpA
38194	payment	2134	2134	1874	1	1	5096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YbuA3Zcyw4dUfBYYr2iCtnHsyA6CdUUPMeGPAuEdVs6jKXKT
38211	payment	1397	1397	1678	1	1	14663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCK7D28EaqUo6YmrvwzuMZvd6K29Lme5Dc8HNDuiC2gkohNcrW
38212	payment	2132	2132	1874	1	1	1393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVceAAUHzt52g2Z4tTi55xZEEZQw6WeKq2nLhuRvaooLn7S44U
38213	payment	2134	2134	1874	1	1	5104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsppnDs2JYzr89LDtaKh16HVpDEZrMZztarNCGDksD7fSy6QAi
38221	payment	1397	1397	1678	1	1	14667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJ794MGgpzsELv5F4QnpDCf9hEB1JFgZsDCb7VBSJt8WMjDue
38222	payment	2134	2134	1874	1	1	5108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQL8HkdCvHqR8SHzzE8P6sJpUxQTiWNiqwj7bBF3vGdheSgJQV
38239	payment	1397	1397	1678	1	1	14675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rhbcKCjkLMzv7GrrfiRfrLyBwvHb1BQJz5BX83zmWvTz4isT
38240	payment	2134	2134	1874	1	1	5116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM9LfyCGDXs4sF5KYdCq5ZCPs6uV3ayvyoP1uWQop3FosQ4Gh
38241	payment	1397	1397	1678	1	1	14676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyNKvH5HSBxUE4ienpgo45VNtAyp33gRTJr1NCCuae12b8Wk1
38242	payment	2132	2132	1874	1	1	1397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2YfHHsnDT2mFhkcYgWh3zKyX5nFutoMWEnwn59gi8HbFdEEx
38243	payment	2134	2134	1874	1	1	5117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzYFwAC4qbqZareUFGECpCNGAfdkkvXG8bRRhu6rBAcDgaa2U
38268	payment	1397	1397	1678	1	1	14687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4Uc2pMUPmQj22K5EMxsdMrr89nof3HiD3Abqzbz9X9T4tVS7
38269	payment	2134	2134	1874	1	1	5128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnxoNsJMK7WsbxhWjWrSbnBVCXy1Ui8yWXSCh2k8dcHqnCoH
38270	payment	1397	1397	1678	1	1	14688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtwG1REivAQkHr6eDxA93tu3KYpkuHwkexn6HoVvxCJrE3xZQ
38271	payment	1397	1397	1678	1	1	14689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tzbTkbYzhuo94Pwv38cJTRKPHGwiajTD21ezJegf5WtNBJPN
38272	payment	1397	1397	1678	1	1	14690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMeao3HgyzKtKwg4kEGDxFdMmNsiKWanQxHh8oFYTKUTVUbC9
38273	payment	2134	2134	1874	1	1	5129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdNq6G8GHgs8PPcrgvNToEuWMu73vFbSJc5ns78mkKDuVNoDr
38274	payment	2134	2134	1874	1	1	5130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbydUThWt7pR55NcsFX1AWVLaFQh9cZWctkExTeo31F4PrUsao
38275	payment	2132	2132	1874	1	1	1401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQrZRnfWx823Y5jzNN9CfGsCLpYnwfY38bmVzXWEEDSsnsXVd
38287	payment	1397	1397	1678	1	1	14696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYAgw3mNcSiNcbSMJF8QyDz64RXup6L5hfHcmVjkveeYrbtV2
38288	payment	2134	2134	1874	1	1	5136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYe2X7dcvMjAGtwqmpbLHxtQy3eW66yXRNEUtu9DGKPGPeXLn5
38289	payment	2132	2132	1874	1	1	1403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpFqCAXqXF1AUWRo9ofMJSQhWUGjSDD26ZUdXfCit8hLeLvLG
38331	payment	1397	1397	1678	1	1	14710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomJiiEWSySB69n3ggTt3cG7sXo8mSH8ri9a6xtzN7cUaYC5kr
38332	payment	2133	2133	1874	1	1	4669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGo8TzsA5E3fkpHcMisCwAK6zJMAh2tuJ8z2zp8Q2RbbSM39z
38333	payment	2134	2134	1874	1	1	5150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1A1K6B55XRBKECW3zb7jZraMTQGQcFzTHVbDGgfiVybKGr9S
38334	payment	2132	2132	1874	1	1	1407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqYHF1KHtZ8aDtiTRQQzrVevarKf91oJCNoMnbcn8VSGucvRE
38345	payment	1397	1397	1678	1	1	14713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbu5RshSYcgrtL7FvDpUCdxR63F7zRqAtCTmNLYd8W7iiFaKG9
38346	payment	2134	2134	1874	1	1	5154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPQ2eEj3Li3dW2YE2dShrfPegFAtu53DaLiFRM1eXEz9Nfi6F
38347	payment	2133	2133	1874	1	1	4673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKui3g9W4R2KDLLrk8P1C2R5FyyUyAFsQqErKWDLZ3XmtRUhs9
38354	payment	1397	1397	1678	1	1	14716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5B4V3WgZ88VNLwwahWiB3BKizzatnXadFr3NTLgWEc37rJMX6
38355	payment	2133	2133	1874	1	1	4676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyvZHEDvM3VYfTXX4TdaB9GxTpNbemTga4jorTkR8dJC2swB5
38356	payment	2132	2132	1874	1	1	1409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPGzrCd2qxLA92rs8HChwTHKj2DTmgcKYCr2Byn3Tv4pzFaJ2
38357	payment	2134	2134	1874	1	1	5156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5GheYk7CWq1c3h8EuTCWeDE772mMT3oUuyRvuLU4CiKAXvhK
38370	payment	1397	1397	1678	1	1	14719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rYyCr7yWBcJQYytrr1kuMggaJxSJvDR7r6YXYjcGZsdWj5Q9
38180	payment	2134	2134	1874	1	1	5090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKU14btLdoNajoeLHrGZkL4YaDwrsFUFZ5qMo6n4xAzgGeHhc
38181	payment	2134	2134	1874	1	1	5091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbA6aUECCf3wvUNgKVNJ3qGvWH8qUk9rBzcTUGBJsePWUBcFa
38200	payment	1397	1397	1678	1	1	14658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvE12A5p8mgLNk9S4Buvr8cpDrtKQpu7LxzNusLqBeT7sq9oD6
38201	payment	2134	2134	1874	1	1	5099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmC9khpPfKyrLYwdx87ybYJ7dz7yHYsbYha4y36VJLjZofBWeo
38204	payment	1397	1397	1678	1	1	14660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCgq6c62hVLVgmHjn6RqS7NcU51fe2ZYFQA8DpcuY3SnTCmCj
38205	payment	1397	1397	1678	1	1	14661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwMYjxo47G7oDik6ZNFfmTK7wmVmJibWki3dB5fiwK4476FQC
38206	payment	2134	2134	1874	1	1	5101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU72GNm9Q9rMYpHne4gtrAmxC6LJfZ3ePKezBZdLYWBEHjyNGS
38207	payment	2132	2132	1874	1	1	1392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SwtqaFtBPgYfkRwohHnLTTopTkhEK2mMLyYLsKG3caqnUuuv
38208	payment	2134	2134	1874	1	1	5102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraFCkbh2c1Y5YHyGhnGGezVthUNZEApzt44hrPheGKgeHkmY1
38216	payment	1397	1397	1678	1	1	14665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEXiSgy8ouLebzaS2vW1qXmU73SaE29XhB14GRHh15SpLmBe4
38217	payment	2134	2134	1874	1	1	5106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKMKxg7LDN7QxeFabM4YeQUScEjuGtZbXiZwWQb6xcGM7ngiH
38227	payment	1397	1397	1678	1	1	14670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkYBwU3hQChM3QdAbtR7oiQMnyteCr2iubnJ8MvKyx4PGwsWL
38228	payment	2132	2132	1874	1	1	1395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwZFx9faz1J4dG4M3qD2RRuW2qkKyPtg1ghPK9zJBPWtu9TF8
38229	payment	2134	2134	1874	1	1	5111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrsyiVc84R2TGhX63Qhar5jtNejvwTkUPVyu9MyWBVVwDtdXK
38230	payment	1397	1397	1678	1	1	14671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT61BLNSKAkLF96nDv7KWQ1fZuHatWdnBHtwTvLAfU4oQSe4Ns
38231	payment	1397	1397	1678	1	1	14672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBq2PAgYwC9nbReyzkFAfycWZRTCtcbQijUCCjDz8eV7Mqhzx
38232	payment	1397	1397	1678	1	1	14673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ku4YbTgHLBr7svkgLANGHe7R1p1bEWNRc4TBCSqLJpodHiZE
38233	payment	1397	1397	1678	1	1	14674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApDLcGNi7apsWk1toJQuVUg9iVzYWefhHWC2FpPa8QwiAxySF
38234	payment	2134	2134	1874	1	1	5112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrNdQka1YPBQF9nShBm9uePgvuypjWWPYk6UcFhtb6b4rvtAL
38235	payment	2134	2134	1874	1	1	5113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8krBPrgohSaviMHKgiaiahLwFEdfub5ywCrYwSz7BQphN1v3
38236	payment	2134	2134	1874	1	1	5114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXudt4YqGpN94nHmUciFpSx6EUEponDP3tZ6rMDB8cirQ28Mjc
38237	payment	2134	2134	1874	1	1	5115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnPCJUamynqdj4226QW16BzJx9tuY5YSDq5md5Q3jkVQVkEVt
38238	payment	2132	2132	1874	1	1	1396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXmLpmHKQKkwjZArWW5ZjaxYvKtEe9VKuUnhP3NS38pUJWFVo
38246	payment	1397	1397	1678	1	1	14678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xXFfQnGqvD7ommrNE76roT5TnxtXvmgNrvD7UfEQaDE74APV
38247	payment	2134	2134	1874	1	1	5119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZru3y4jiQiE7dYjimWkPfVKYAkJqPZWWZudV2ePXZpRxYjrLjk
38248	payment	1715	1715	2291	1	1	9	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUmPkVhMNrusiFoPYa551VArAocPJBq887DgGYU3ubw7t3XmR
38249	payment	1397	1397	1678	1	1	14679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgWSzXyLcGDSpoTDRztUC2CbFa8BWMX6YJjD7yhiVM3JgXEMk
38250	payment	1397	1397	1678	1	1	14680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXGfBEftagZTJMF6bBJ1oLyEimedxSoWh8x6v15zWu1VxbUhT
38251	payment	1397	1397	1678	1	1	14681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDccoz8odRkuUAALGxgX1BDVGLeofVzApRaVrCfVEJfwo1GYKk
38252	payment	2132	2132	1874	1	1	1398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBZiBeJeAeBNNWVRktUVRFQb5WV76UxMusy64j7vfHtaoSqCa
38253	payment	2134	2134	1874	1	1	5120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVfr5KMjKRubE2FfFq7JigPPyuHXHJAcugVxcGfyqhVM9mHhU
38254	payment	2134	2134	1874	1	1	5121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrJCMqo4idXofKGXDwxjqkCvwGgSYkcWVn885KTuJS3HPQ7Hc
38255	payment	2134	2134	1874	1	1	5122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ewdfwwSxYfSYemZcfCgCqJtwBy5efSvKyxjBb16Jm2AzQ72a
38431	payment	1397	1397	1678	1	1	14736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqGsv2YXUrYSf3hfuQw8Dtg8hATAsn4uri5kEGQrjsk5Bm1uo
38432	payment	2132	2132	1874	1	1	1415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYre8TurfJwwZKpm57TPiKn2SgauEAQAiwbssNGA9dfVa9xSoqr
38433	payment	1673	1673	1002	1	1	15	3286920000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZGWWpf1zSRsa3zdtHqouA3wZDWPJE21CeRZiMwLRtETkhGi8Q1
38434	payment	2134	2134	1874	1	1	5175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr9apfJSRiy9BWSFFXYJq4ZLogJQVXYcc3GbLxAkpUcyWaNXk
38435	payment	2133	2133	1874	1	1	4696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugDvwSQ7qavFd8RvEA43H3ADH5m9nrUSGQtTkaK6LBM1SYK4E
38190	payment	2134	2134	1874	1	1	5094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5XgyJPDwR5XuyCfoezXnawFprmp6sUPPFsmY63QnApTFXe2M
38195	payment	1397	1397	1678	1	1	14656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVjJyRZYmxwq4dZEZCqtny1BRE6jDpUTR1wSPfBftugDVYvv5
38196	payment	1397	1397	1678	1	1	14657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5FY5zfZRTie6P3g1k78FHriH4efdJQLAK236F2oDKB6Ww3Yp
38197	payment	2134	2134	1874	1	1	5097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFL9gbhxws32w38xjysdWNU1r5mBtUgVrJvgWe6wLH21xgo6tx
38198	payment	2134	2134	1874	1	1	5098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYJMnWUy9rffxetvTFEsYr6mWMesApjAbNLoWfuxKzdAgkbvv
38199	payment	2132	2132	1874	1	1	1391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDVFd1BsV76qfFkjZGiXPKbEyyaEu5ykHfU8C53Y1mw9F77FC
38209	payment	1397	1397	1678	1	1	14662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBqH7j6dt4EgHsyjqoDaQNMuztrcHDrxNbnHshoiemzfiN4Tp
38210	payment	2134	2134	1874	1	1	5103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C7c88WcMqKNHhGYFiaxqoxGaXgScvkLpuiCnH8eTJ22rtEKE
38215	payment	2134	2134	1874	1	1	5105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpdmssLeT4bjBRDy8dw9qa98vmKgXhjGm6p1ng1Eb4yEjUE28
38218	payment	1397	1397	1678	1	1	14666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXGJw9sfCABLa234kPEVjKfpfUMTHXM166QbaPBD2Jnny9ut2
38219	payment	2132	2132	1874	1	1	1394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXiTCCdrcZsmSfMuxgHUBt7GmEoW1XZFR8CPh8P6CiPdD8EXw
38220	payment	2134	2134	1874	1	1	5107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JhoGR1RF8QTS8oVGbwbpR4SPNyBbNBKeqiuQXkFjcWuZfGHm
38223	payment	1397	1397	1678	1	1	14668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9D7BkTw9gXq8BL89NpP4msKJK9XC9VkhDLG8HJEj4mSZUUASU
38224	payment	1397	1397	1678	1	1	14669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtidssVBsHztXuZ6cQzhHAxYq16JDLY5iLn5ztN8WMQGCrJnqX
38225	payment	2134	2134	1874	1	1	5109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeRiMNcCpmffDqSfwVNq5gc5q1PaQswx53GbXXmDFpN9Y8PUr
38226	payment	2134	2134	1874	1	1	5110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wcze9zMcV8SogAdbqDpVCCdjUVzSPfQ1qRAVJVoRF7m4Xwd8
38244	payment	1397	1397	1678	1	1	14677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZjo4Xxixkrv4SGho2AmjsWSuFwqWybDXgLd45k8PYWR3VJbw
38245	payment	2134	2134	1874	1	1	5118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3oioJrbC2zobEiq2J2qAruzEkdLJAH1BG34rFdY4evLwwshB
38261	payment	1397	1397	1678	1	1	14684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpsaN8nUrEdBEtNKQKptEvNJ95WYJEMcScGwvNp6vpuG7hC91
38262	payment	1397	1397	1678	1	1	14685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrayC7858A3rqRwFGE8H48anxawoZfPivwucTiE31rEbQ3XU3
38263	payment	1397	1397	1678	1	1	14686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzq2SjNSPc1LKVUoxVLretEwRmT56vTbe3sgstFu3v47BkgmD
38264	payment	2134	2134	1874	1	1	5125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvGR9b8Gf6FuJJj1N3dwSa6ppiUe5WZWULJ4RwtujAPfp1bPk
38265	payment	2132	2132	1874	1	1	1400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuCaMFwTpcFijUK2HBKJeDec3SzXXVVAMZaeJuYMkcRDMzNab
38266	payment	2134	2134	1874	1	1	5126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPL5DSfMD82afmyUn3EsH2TwygQd4ozVFEUbqSmR8aRdEg1HZ
38267	payment	2134	2134	1874	1	1	5127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERyX8bbG33sAoqgDYCidjAYsmuZ6ka77Vib5gp7PFhUzBmutz
38283	payment	1397	1397	1678	1	1	14694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBFzn73VZgMNAUQC2Fr1iZML6tcWR4FpuCaqrtvKdKsjY4wir
38284	payment	2134	2134	1874	1	1	5134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehL93ajdTa25ff9E5Tv55D1yE9Z6cddazzqRx4EdsnUkdbqC8
38285	payment	1397	1397	1678	1	1	14695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8v62GJoKHi1ZFaFhtfqqZzCAMEewtiE6VaT3ppNYpeoeSEjw
38286	payment	2134	2134	1874	1	1	5135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdzrcGrSThefNh24wPs18qa6UQdmpV6BZLuVSKwSYwfA8RaFq
38290	payment	1397	1397	1678	1	1	14697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdLG2x1xVfgucS2izHjb6KdjYq5VDi4b7gKqa2pVcNpGvtHYN
38291	payment	1588	1588	2068	1	1	6	934000000000	10000000	\N	E4YTEw9DPJsj5rGzuVMgYiqfxkCZif3yXuBN2Ey1bTHC34hmeEdX7	CkpZjFr4U4tQTCxZwBmthxsif2vYJjNLtEimYDFT9aD1tgAsFXtnd
38292	payment	2134	2134	1874	1	1	5137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyvJdfFTU2xX14yg1fsWg5Cik1dVuz1FxwuDRLsnxBYRSYN9M
38293	payment	1397	1397	1678	1	1	14698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXBhDotVasHmU4aQNPV2NtvcC4h7e3A9M376VySCsg4vLHLHJ
38294	payment	2134	2134	1874	1	1	5138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwsNnpbF6BXiMF647HqKA5pma2DZabBJ6ATvW2kCQW7cX3tvF
38302	payment	1397	1397	1678	1	1	14701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jhm2bsbRGcSjgs5KBhrMToXLxDmBJakkrrHBhDaKHNwaTxjF
38303	payment	2134	2134	1874	1	1	5141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXycFFyCBRpsExVEQUguFLvL5dp3EYbgoRxPrLv8HjjP5RmPLB
38304	payment	2133	2133	1874	1	1	4660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsJRSfnUWGyPZCMSFGe9ExQ3DSvmQTkBAALSQdehwgX61p15a
38305	payment	1397	1397	1678	1	1	14702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAS7jZLvyb1SH8tz7a3TVNX9SzRuPS6Gao6Zhc97i3ehUz9fnW
38280	payment	2132	2132	1874	1	1	1402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73d5VgD7ykKtqoqr3wCDL13h5VJFe1fp6xHX9byrSoKBJq1Yq
38281	payment	2134	2134	1874	1	1	5132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFw6V1ffRNLY8UvX7XqS3BPrM6ixkSqhY5gXgdNnyaQ8AnTWi
38282	payment	2134	2134	1874	1	1	5133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bP3c72a5XcShUmQRMhMj5TeZZaWgsoEVyqfcZLHX2g3cFppD
38295	payment	1397	1397	1678	1	1	14699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtdohv91NtoCKapDJzgYifQgbEwD66iAKWm8mwiwL4XaJVYi1
38296	payment	1397	1397	1678	1	1	14700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6xs9DaRALJGZ6pd7b9vpNGGdZHijpKZTrmYsQLxTDPT36Av2
38297	payment	2133	2133	1874	1	1	4658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VuUhYe7g7b3iZUdLdtDhjfqCe1pY4TBzAJKkopi4koRHkTwo
38298	payment	2132	2132	1874	1	1	1404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5EX8DDcqVmJd63Rr59zU9j7TPgqD3dw4oGdTWCPX2Qyefcx2
38299	payment	2134	2134	1874	1	1	5139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfz7pRsnWm1WuqwW9fmhCzjDSgQiJKT5vdpchh6RQZbRUwCYuM
38300	payment	2134	2134	1874	1	1	5140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAzMw4JfRrYhxs7eFZmK6uTNLr6uCtph3pydmeFv9uFKe4Ps5
38301	payment	2133	2133	1874	1	1	4659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRBfBpmZK8zr7kRfk4ibHiMwjf1EQ3VTYLxLJWugr77tjKBt7
38328	payment	1397	1397	1678	1	1	14709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwrsVVr59edzPDeDncxQYY3meAAAGJhhY16M3CeEweg9dUcf9
38329	payment	2133	2133	1874	1	1	4668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2LEt4J9RQkDVG374aBJg5k5qLiHBtuYSe4DJMPaY8TjTxzDg
38330	payment	2134	2134	1874	1	1	5149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zdUqo2Z9jqBw587bdzb79E1DF1AD9aJCsv7R33ZSZREoC3aH
38335	payment	1715	1715	2288	1	1	10	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjpgXpu4mfCGWDHi2ixsSinCGG1kZdzvNLkt6GKp7wGkoBxkG
38336	payment	1397	1397	1678	1	1	14711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckpwNdSb3zsMw3PjhjquyJQAqYUha53bKfQEcxL8vCrzbTArW
38337	payment	1397	1397	1678	1	1	14712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2mBoyPxNRxPCCvDzvNeU4NLussyWmNtyXZzPkSYmy2s2dRtZ
38338	payment	2134	2134	1874	1	1	5151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cqo5YRNjvx2h1paenhvbBqziEFj9rsQk774ngYxvhXeEzgrg
38339	payment	2133	2133	1874	1	1	4670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMQmHa6sZY2BMiwXfkhcE67N5ce8axGK6ndxwpisZTJ8vtWXD
38340	payment	2133	2133	1874	1	1	4671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD9AXdErZccnVWUjPUVix2eYS9ZaPWgSAzpbzv8QXteAqooB9
38341	payment	2133	2133	1874	1	1	4672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXuDPXhMLkqFyhiE67zFxBB3PD2tQMFSkXcVASvMLQUnBU6vf
38342	payment	2132	2132	1874	1	1	1408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7SFkZ5VG2vxKxsKwvpNbPxUcSD1b9g1VAEP3nvFCb6x81kwB
38343	payment	2134	2134	1874	1	1	5152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3PGykWKdY714cxftsX7uBJ858SC6MRpY3i69Lx1eRzr2WmDD
38344	payment	2134	2134	1874	1	1	5153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9ERz6UJvvArGPhSRASrHcmBfQcztSwDRJMjPJAjUuywJvmPz
38348	payment	1715	1715	50	1	1	11	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxRRmY3EZum3G6WogJUdTxFcBse6jxtoDTeVD6hWxQdcYdqWb
38349	payment	1397	1397	1678	1	1	14714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKVBRMTti5ME3H6F9E8V9Xvd6H6CxY3Fv6ZDXSqB9pnbteLnQ
38350	payment	1397	1397	1678	1	1	14715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtyRjSDQ9T6bqzDhFGUvcXDEKPuVeTFtJAxfKQhFgCJTvBk7v
38351	payment	2134	2134	1874	1	1	5155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnDB8P7hPmZhG1vZUgWMTVdVWkTAPA1ntS2JQ55v13AWoWSYB
38352	payment	2133	2133	1874	1	1	4674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GB97mW6q2DdHLU5HvxJno87H5yzoUETib7iDyS8hPURdvZXv
38353	payment	2133	2133	1874	1	1	4675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXP5o4FMDgm6bmsYMMGennxmcb3ajnMfAJMbYEbEKMvtVF9Hm
38358	payment	1467	1467	1010	1	1	4	2318317728055	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpYt4ACZCrPWwvmQkrveFY5W8TZVSzHavYurcEAooPR6RWPMdY52
38359	payment	1467	1467	1130	1	1	5	4154405505340	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpYqFyZSxpU3F3bY39KEv1mCMhbinMUs5j2mLxmcD4sy9ViMpi6o
38360	payment	1397	1397	1678	1	1	14717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQY276NSxKKYB4qW34WkV4iXBzwtG88rTx77MSBPZKGxKTDh3
38361	payment	1467	1467	1250	1	1	6	2803060176825	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	Ckpa1i2M4L86WHVNMJ9mNMsEXzmfDXveX9mZGNfgw1MwHbRboSXqp
38362	payment	1467	1467	1376	1	1	7	7810976416950	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	Ckpa3PjQUM2a18bMUCx1U9D8SRYUXBZKQAmMGDAx9HGUxXVDkft2C
38363	payment	1467	1467	1467	1	1	8	13370322795	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZrgM6U5r47zde3BvaaDaBifbvFE1ZMphKroo4pyBNz6jrXKEZj
38364	payment	2134	2134	1874	1	1	5157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBN5EGYBfph2ygxpxtVDuxPZ2V7sH57BAgf1YK17RmTnfu8Eik
38365	payment	2133	2133	1874	1	1	4677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25sJJP6HFMWrdb4qjpk1yL7NxtJxRQU6UbAo3qmEcjPh35Vxj
38378	payment	1715	1715	1246	1	1	14	2236874141124	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN9N5aAGtprBqkrN6aY8nYNk6dPqHXmxnJm4mosWGq14FTKWm
38306	payment	2133	2133	1874	1	1	4661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCQE5z63cZMRyo8njiRE14jsHa4QNk97YNSiccrcrKpYkrvre
38307	payment	2134	2134	1874	1	1	5142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznEAUC6dPqX6pETNE7HetPhumif12LRZCsdnu5hvegWH7Wtai
38308	payment	1397	1397	1678	1	1	14703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUENCtdUTdm755AJpJicDg6neZUprMkRXADf76VRb1PjFet2Kk
38309	payment	1397	1397	1678	1	1	14704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbE7dr7W4qJbfTNyexDf1xiZqRAjcpQEpYiyNWpHq3KAY8fWD
38310	payment	1397	1397	1678	1	1	14705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge3BU2Cf3irWZFGruveNEoqcKcW1YemnBeMPCJW3PSPejhEf4
38311	payment	1397	1397	1678	1	1	14706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsVTRczc3dx9YQCk4ZJSqWyq93aZi9ApRDFGRowNfSrhq2xGM
38312	payment	1397	1397	1678	1	1	14707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhDknmp98kQsx9vFV7NzYyWrs99K4yMAP73NzV7CNU9kiH8oY
38313	payment	2134	2134	1874	1	1	5143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQpbWm1o76esKk9KscsaffSdWivjzhEtD7AkG8jDdQekmK6Q5
38314	payment	2132	2132	1874	1	1	1405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22xXCwBWxXqGttLmL46ZSeyf195vy6xaVCVdQqmVxTxXg9p8B
38315	payment	2132	2132	1874	1	1	1406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmPVLodkyfPfKyEbicRMvnMT7aRDQ87CsM9qA79M1JMiXmd9q
38316	payment	2134	2134	1874	1	1	5144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2g9P45ecG4XP1ZVGuiKFhEkSiMYNGrwfSf5UoayQQrwDsSD71
38317	payment	2134	2134	1874	1	1	5145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyyoscZjNfWPeBZEPgBpU8dtrmpvj5XwEqGjXUbaP8vcQFLeC
38318	payment	2134	2134	1874	1	1	5146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCobBAoSAhf5Te86GPCGm5KUbiSHy5ukH8xyK453anqgNS79FG
38319	payment	2134	2134	1874	1	1	5147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEj1p9w4EEX4unoMXGb7a8yaSmQX6qfL9wnvK1tfTFHN13qzgH
38320	payment	2133	2133	1874	1	1	4662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVt9i2GF1sx6KkkHSZyL4fswrqzX3qyiy3pQJ3AqMcU6EfZ6N
38321	payment	2133	2133	1874	1	1	4663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazKG6uxb42BWvbMkNPhVrPDJbzHZ5wVUVrmeZAEswUccHfNyB
38322	payment	2133	2133	1874	1	1	4664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTpc6kWwobJNX6HVxXxibdkCJqCpEYp6HdzBRn5T6Czbq8rKt
38323	payment	2133	2133	1874	1	1	4665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgrVBY7WHVi9j3EguFsDRDLRDheTStYJRJoYhEmd5zBFh48XN
38324	payment	2133	2133	1874	1	1	4666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMksVmUi3rxXoTxdsVp19yTbtUePrw38TEYsWmuoJghsV44xd
38325	payment	1397	1397	1678	1	1	14708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVx45WURrcmFwjJ2et5RSWrEDP5y89NL7LfWDJ9ce5FLtATTJ
38326	payment	2134	2134	1874	1	1	5148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9HCTubNxrNLhMyvgE87aA1Ee9XUu7SPfVUoURMmXBRMAvvYm
38327	payment	2133	2133	1874	1	1	4667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFoRKKxWxd1gidW59qaiCjdVhMXQEBBSxJqdA1jAkiWz7h6zP
38366	payment	1715	1715	1006	1	1	12	1850044112385	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQM8oGSUxbM6qaEBNyvKdjVvZfTQJTpue9fwhCRdArYo7F9kE
38367	payment	1397	1397	1678	1	1	14718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJ55GVnDjyVQowUvgRg8gn7TCLH2ZnHTjCX4gWy8ukjUz4sZa
38368	payment	2133	2133	1874	1	1	4678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8V224Q5hReHqpLuJvxGTGeTfxvJLUuSDkUxtXELgznXCfadq
38369	payment	2134	2134	1874	1	1	5158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVqfuQeZM8zy1LBrMntQg7p2cinzfywaLpoE1fXiL6apBWtSy
38374	payment	1715	1715	1126	1	1	13	3315263198226	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TBCX4mzimDmX31UKpJn27hekXuKkEWgdb3xtZ2PAK7vybg46
38375	payment	1397	1397	1678	1	1	14720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEShx2bzLbRmhzfqy8fh1E5EcWHUW1obtH7AhBKyCrtSvHyjuK
38376	payment	2133	2133	1874	1	1	4680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5vqTqVoXvTRuZmQhPHwyajqxpEtQuPxAzxaCL9bXLkXvaaBQ
38377	payment	2134	2134	1874	1	1	5160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNR9RzFY3yWSrkSw3rxwAmF3c8E1SzduGjPKSSukTWHk8rJdv
38390	payment	1397	1397	1678	1	1	14724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3ghqgXLcLvky2uUSeqQSzYTdT2cqo5tCrJ2rxSMzWFowe2sF
38391	payment	2134	2134	1874	1	1	5164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuKhTXuuoQx1auy97HoBUJUQajQGg99aRNW1xLiz9PcaMcN3w
38392	payment	2133	2133	1874	1	1	4684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBSkUTsjiDC6Kfy8wp9PYqnzUeJ973wiAHZMc7EqSZCyntGC6
38393	payment	1397	1397	1678	1	1	14725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhaS1VsY7URNMP2LFYYeWwFsBF2qMKcbmkyF5SRyDrFj827K4
38394	payment	2133	2133	1874	1	1	4685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXvVtyEzX7in3X3QQhgY4M5f65qLiuKgLVByqg8TwHcAhfEHd
38395	payment	2134	2134	1874	1	1	5165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc9B7w6euFMKaNSceTKFvUmPpTa1TxNwAPUeNfmsVSdvvhCrK
38401	payment	1397	1397	1678	1	1	14727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQi2rXyrDWETViqSSgeK4P7GjxyPjJ1gz9QnDcvXQndU9kuoB
38402	payment	1397	1397	1678	1	1	14728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkesnC68LmarJrnCghqVp2NgBT2A9wA9jWP6RED5C6hR3UDXdM
38371	payment	2134	2134	1874	1	1	5159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBbgfKBiDRd4wqtEvkhvAaAdn25A1YLa33TuJiazcENB1qmTU
38372	payment	2132	2132	1874	1	1	1410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVom5HxgMAcjzddcmvNBnBhpXZ6zB1pd9zjxVRL5k7a6b6g9wQ
38373	payment	2133	2133	1874	1	1	4679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgWcEvaxcpTXWRwMjaFWSynUH7QDWzWFgbVVwAYHHVqvSuqMd
38387	payment	1397	1397	1678	1	1	14723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5PuomYPTxdt1NWCB7wEksmpaQ1XsSHW8SBYPBQg1U4N3HjbN
38388	payment	2133	2133	1874	1	1	4683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxNERV8pUAqh9bG7UUGQxh72tyLHkPyS5pBSZvsRPsmEK4pck
38389	payment	2134	2134	1874	1	1	5163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2Ru3j3Pujpa1gyN5RDVmWXLGQQNxG9Spgh54pkpWGfm8PeGd
38396	payment	1397	1397	1678	1	1	14726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkJ6k8GfpjLMS2edyEhk8mAmd1HjRD5VoP8RiGNYPXBYdxGRo
38397	payment	2134	2134	1874	1	1	5166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDKWaMtuPAfZ5bTWARxHvaNcdgr6EtP466K1WpPLAhrBLwWu1
38398	payment	2132	2132	1874	1	1	1412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbE3NtWK2MSD9mJa5TyAyshguyiDquyj673nCsJk8ya6jY9fU
38399	payment	2133	2133	1874	1	1	4686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHDXkjWwf63Hhn4cqFAXktCTt2gWBKVD5yo8YNPCw3NQ1pu9i
38424	payment	1397	1397	1678	1	1	14734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkmp92zuJKYZkwfszevMpVPfTpvBu896mH48R1tGnTu11Cq8n
38425	payment	2134	2134	1874	1	1	5173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnAvAqfDNFfGnb72RtWMoKK9WGPteQGnkNP7A31S6CLyXUZMf
38426	payment	2133	2133	1874	1	1	4694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbks7USixkKQA7hLs44zSzDdTzRF4NQUnPM692cmLDg6fXMNr8
38427	payment	1673	1673	1242	1	1	14	3974190000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpaFZM7Q4bExCZsw13U8nFVLLEH4kmmFrh6mGpVTokFYE2UCwEWd
38428	payment	1397	1397	1678	1	1	14735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhE6U5bw5976D128KA8ois6dQr1kPU98T4N9itcFgqQNLKLec
38429	payment	2133	2133	1874	1	1	4695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DzQdv7a4RyUCMrJBv2EfCwkFJFk1jRfZ2H59vZQAhvfCuoC8
38430	payment	2134	2134	1874	1	1	5174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aPZWACqWEPcGSww2MgEsbPq1BzYMN9S6H3183bt31237jdfx
38463	payment	1397	1397	1678	1	1	14745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkpfDJ34CcX7a2xgE4PBEpQEypEM6ndV9EpoY5k8WYMhUu8n7
38464	payment	2134	2134	1874	1	1	5184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVF1SGzYbA97T6HuohdqhHUFmq6SeYNXQX9dLN3cSXtdLimcZ
38465	payment	2133	2133	1874	1	1	4705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUktiEgf6kbhKyia5fWQqSTkkHHZk5ihSFTK5tbLWXyqdW17d
38466	payment	1673	1673	756	1	1	17	6540000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	Ckpa1W61kvGYT8ykyZrpP2dv8P9RCRKCXTevV9i4uXExjwgHXphe6
38490	payment	1397	1397	1678	1	1	14751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk26BKqd2eCn7WT8nRmAJTtvcs9poTvntfqRLcbj5zZ3VsF2w
38491	payment	1693	1693	301	1	1	1124	75500642221	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa3m6BQh7uVWhPKJ6rUTvXgjvs6GqvKV5tVMXo72ipYri5JKxSu
38492	payment	1693	1693	339	1	1	1125	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZJ4r6cuz6VcHRXs48PyCC9bGoph7saKV32Y6pPdrY72q3rSrtS
38493	payment	1693	1693	601	1	1	1126	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZpozUBxJKvzYECUCZqc5vzQfoPTdx36v6scjxwTpEkSEsPe44V
38494	payment	1693	1693	1821	1	1	1127	76205579462	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ5QZdAFqi2Kcc6GfwGxzM8PVG9rG89GvsF7EBppCiSdSysq8tG
38495	payment	2134	2134	1874	1	1	5189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWnXZCiaFLTA6MbEdZwhRxjfWAZDm5CD82qXmaovgCdn3dmRZ
38496	payment	2133	2133	1874	1	1	4711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFCCkzo9HHo85M52MdBmEGPd6ZF7N9QYKH4Q1T5hL8qrL2XcZ
38497	payment	1693	1693	408	1	1	1128	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYdb1QaDy5zxeNKqbz7RcacxkGULBN911UNZQGkrdpRX5uvYib4
38498	payment	1397	1397	1678	1	1	14752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNEa8bKtqYitMf9B7E8qMa9GvdjQt5Gj8xNPcpFmgbyzdh4Ln
38499	payment	1397	1397	1678	1	1	14753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPvx29h3NmnVeF7Ka3BEmPLaEJHr6PerQDPEdzNipCtzMDYtR
38500	payment	1397	1397	1678	1	1	14754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFtUFcKMjnPfUQ8899nj22v8o9xMLgvSBWigA8vUhtn2t6Q6S
38501	payment	1693	1693	322	1	1	1129	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGfVAH8sHRKKCFKAH5Hep3NdoPA4skEGKS6FsYwGvGXoA8AAT8
38502	payment	1693	1693	10	1	1	1130	37245551582	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZGhs9LBDih4sZ15ZdngDk4VUc4fF3jwPsiVFLFDQKNQZRZiRJ7
38503	payment	1693	1693	450	1	1	1131	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ67Ly6SyVMMrBfH2yU35tYzuKHaqZiEyAmJtZ99pr9J8w4Qjff
38504	payment	1693	1693	366	1	1	1132	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa8GoPcaHwryA7tvVJjPfikSxiz88LoHD3CoK2webUGzCMhMP9X
38505	payment	1693	1693	587	1	1	1133	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ3wxoZfZSHLBmCuWWfAH1T9WBiMaoZVt6TZtws4eXYUHfEgc57
38506	payment	1693	1693	500	1	1	1134	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqfrHrgQHH1MHfHwmuaPvkn4C5FFt1MqXnq2T7u7uUdHpTcP77
38379	payment	1715	1715	1372	1	1	15	6233248686021	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq676wnvjgsaYKQ5xPP4yNYpFkvXEJPQPcfWXiYXjonw3DpEpn
38380	payment	1397	1397	1678	1	1	14721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdr2Fbfg1BhhphqMbrP2tycuWVQE8EcG13VtvKtK59Bd7mG6BV
38381	payment	1397	1397	1678	1	1	14722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKZC8N3WUkves8CjjFgz9hkk2zNLrBr85mP7k31eixwm2b6ww
38382	payment	2133	2133	1874	1	1	4681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RhPedfPh7Xm7WZntL5ioyioh9k7ynXA7uvvDUT8Qirwd7Cy8
38383	payment	2133	2133	1874	1	1	4682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsRkzES6c3959Qo954pvCPBct1RFjSQZt1BakzeJ8UxSMPmf2
38384	payment	2134	2134	1874	1	1	5161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZES3FmhufAVcYAQ9oLaCAFhVTYYYqKhbGsbFn1J9RNs7rdjVYv
38385	payment	2134	2134	1874	1	1	5162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2X6sfdYsxVBZ6zHnU7pnJK1ev384xwTk4nPZNCcUiekvpQhfZ
38386	payment	2132	2132	1874	1	1	1411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRHjEUt8PnrDCeQFh4rxEeJgZsHUsZJLWy2fsc6ueZ3zzVNcP
38400	payment	2133	2133	1874	1	1	4687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhg6GoNQBybUrBZsFZZP8J6ZKFbkSV4Ry99AFXGwtaLs3NbDVx
38450	payment	1397	1397	1678	1	1	14741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm6sRskxvKXhXu5AEQVJ4aPGtk15bJkVSPEb4BmBW62ZkEPLC
38451	payment	2133	2133	1874	1	1	4701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9KMHSphpYGYjTQ8kKyCm9jda96s8ALcaonj1tMErDtpBK9T3
38452	payment	2134	2134	1874	1	1	5180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95Tt7GtzDuTC7UCfLH5ryxusnYARsQqJ2FH4wfCgUyw6VJMPi
38453	payment	1397	1397	1678	1	1	14742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoYqf1SnJJ2QJitm6HPW6vuhibeXoMLGfY8yFqXhbNF43XShE
38454	payment	1397	1397	1678	1	1	14743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3z8BRaUmox8krbLdYH4aWbQaG815RvD9rtaLBsDhLspUX6Fs
38455	payment	1397	1397	1678	1	1	14744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fphyHHqe6NR1nin5Q2zBEnFFpyb2fDhYPfEj184yJ5N6uhkQ
38456	payment	2132	2132	1874	1	1	1417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ca8QHDGbR3VLmrk5gjAvbQ86WqY1vHCBLFXgt9rpzK8hCXC9
38457	payment	2133	2133	1874	1	1	4702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXbUAv6jpBoTmUj7fBQSpuzLXo3MeDGVSQYNhCyTtwio1nzr1
38458	payment	2133	2133	1874	1	1	4703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZuwbZhnSCGjK1Mby5FUnXZybRKpQfvBr7PKYDqkBNDZvdoYk
38459	payment	2133	2133	1874	1	1	4704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRRscoiewrgEeznXG8du8zipGLkuyfhEGtUX3hyjajynemKNu
38460	payment	2134	2134	1874	1	1	5181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPchjRPtK7RvJfVyJRtj2LB2Xv51cfDKaMWVn5tnWxu3bNh7q
38461	payment	2134	2134	1874	1	1	5182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUJQtUxdmkNdtGB6T76aD6aqp5rAMx5Wb9pV1bNGfB4CS6tqF
38462	payment	2134	2134	1874	1	1	5183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc9FWGrnHadhqhxnHnCRaji6wG6iHg1TmLwGNYUBiuAGx4gok
38467	payment	1397	1397	1678	1	1	14746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkc1Jq4A3zSFMaCL3bow9ePMh9zQAwRBRAMgKKUh6Y57ZB4yPa
38468	payment	2133	2133	1874	1	1	4706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKbXmygQnawtiRw85uBRD4DTXMgW7c8jCg4MREsSv2wy6gRJa
38469	payment	2132	2132	1874	1	1	1418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9LULRyCB9rDoDPTou98jf9FSomZuyb5UoT1LDc2WzjCf1BHJ
38470	payment	2134	2134	1874	1	1	5185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5LtbJgsrvnkrNGkdbAYWgtCxaKaE1SRSZqFiskvVdE21p6Nb
38482	payment	1397	1397	1678	1	1	14750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbjKxwsKNANSvDiniU6HU8koqM2bkcrgUtRKg5ZPQMk2TbxjY
38483	payment	1693	1693	1811	1	1	1119	208337588999	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZnHV8Fo4tNNLMaLwV2QDpkdHAFsNBwxJ775yKFgaZ2XiEHWfxz
38484	payment	1693	1693	283	1	1	1120	75500642221	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYUpyTz5Ln5ygnL3fjB5dhn9bqNAzex32vgMyfq18NtCnSV6REV
38485	payment	1693	1693	308	1	1	1121	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYYiMMrfRq5ATHC5NM6SkrvfWN8zMZjUmSbumXNYW7xBQP31C2H
38486	payment	1693	1693	186	1	1	1122	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYpCGU2uhwz9UQrMCenWTCAtcXAr3w6hJFnBQnfGwWwXtxMtXbd
38487	payment	1693	1693	392	1	1	1123	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ2ADiaeRFpFCSVHUWWb1qngdnFa2ituGcNh8nQEmZs2XN1simC
38488	payment	2133	2133	1874	1	1	4710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPAqePtAQ2VrXEitUfvSJiRT3zSBJReuoJXanT1snfVXm5Zra
38489	payment	2134	2134	1874	1	1	5188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtHji1unaXyBdKzHEavV96bZAXkRp9b47LHHTD6SvJRHPpZCL
38643	payment	1693	1693	1961	1	1	1210	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYex8rgt6bspkFWoxrmCa7stG67oubHmPzWvjmiKsFNiYgwza8W
38644	payment	1397	1397	1678	1	1	14772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZitEtjCYsmfpAaMaSwd8gtXKWWkhLUGi8beVUoCTQ3EVJzJgM
38645	payment	1693	1693	658	1	1	1211	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaDLkKTifi2kjsFPanNnNn1Yk2HpHejHFPoz34BdCBrtFv1sMHm
38646	payment	1693	1693	240	1	1	1212	75501340026	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZBnroWBzY8BJ3CoAhyrUbatfzTo8fVPBB4to3MSNyaBBH58Lqt
38403	payment	2134	2134	1874	1	1	5167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckJvemfv9g2YvkohXBzZvF7iNo2A73LR5Bgrn4sWDrRQuNo3o
38404	payment	2133	2133	1874	1	1	4688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZwFfaGzebm4KSx7NfjFzemphSY7FZqAksTKqByYzugH7FFmB
38405	payment	1397	1397	1678	1	1	14729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ABRUq9KuXxCWRbfacsN5ya6iir9ULm9r8JRZkktYmbtQPdKv
38406	payment	2132	2132	1874	1	1	1413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRmxVsRsuTzU7p5uLmigosBG15GLjGb6W8FEVMDFCe2Gwcw97
38407	payment	2134	2134	1874	1	1	5168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJ3zAVG53AadrGUUN36m7zrLBxFqq8AbL7GtMA72o3seh8tiN
38408	payment	2133	2133	1874	1	1	4689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7385tcTNLhsYG3zia5XN8JNPUVJ2K6xduVUSJLqTu3fBhRdLy
38409	payment	1397	1397	1678	1	1	14730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuTcKXWVpu1K5GCcnW77iaFkHF6TaPn3fERFvfLtk8vzP8JJ1
38410	payment	1397	1397	1678	1	1	14731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CbY3cVTMS24Hsyd4bQdSk8NJ4ACFuw8kidDXpEB9KcZ8Sd2T
38411	payment	1397	1397	1678	1	1	14732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPZotqfaiwzbPzTkCV78PCroHQmqiVPVDhb9sBi1fPqL8HmBY
38412	payment	1673	1673	1368	1	1	12	11074430000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpYanzzL3u29vFTXnFkTLrhsCEWkUDhy3NFKtPgKQB2Psy7e17tN
38413	payment	2132	2132	1874	1	1	1414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXwcC8sxB9Wq9QxsvM7trfURmgBnHzBjXuTxRKBDmhs3xfHFm
38414	payment	1673	1673	1122	1	1	13	5890130000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZ3gRoz8nX8L213gvMih6MXgQUsdxpEy9GtNNtxn9fYw6ynDXc6
38415	payment	2134	2134	1874	1	1	5169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVbrzux5n5kgRNXDQRp7KH5YFAsP7pu6oJ1AxyXEvjmxkh8ie
38416	payment	2134	2134	1874	1	1	5170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPASQE2NNvnTpFt6v5axCRngbiU6doApcWxUiHbfSdPSYAyWs
38417	payment	2134	2134	1874	1	1	5171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezvvTkbd8MkQc8xpY6woG4LYWvgQEMdnSBzbbSCd6icEaR2kN
38418	payment	2133	2133	1874	1	1	4690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQT3bRSXGvZbSawJTiaYB63LNSjNP8cWNhPP1HvFytDzMpGT2z
38419	payment	2133	2133	1874	1	1	4691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7kpbLB5djnfZRpFMAXhGEHjWQwKMHfVvcADZsTEued1GzDnW
38420	payment	2133	2133	1874	1	1	4692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANrkNJtAWXZYuZi7WpqyB6wN7uc4mPWdsM4ADvrUEQBZBQ6Jm
38421	payment	1397	1397	1678	1	1	14733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9PenFngr6aUYaaNXBVHFutGtT3kSX1qCRw3zBxWE5aitnYMtK
38422	payment	2134	2134	1874	1	1	5172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmptB2UnbXobxD4G88NeXusvqo8TuYiSDeq6bJ4zNmYNpMoD9
38423	payment	2133	2133	1874	1	1	4693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnaRE3U2ReMC7QCYkMgU6uXTqAo7Dgw6k5JMcrVnQoZ4xibov
38436	payment	1397	1397	1678	1	1	14737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFt8VCudYQGEstV1WBBFqdTGcpsuSiWQPjpqJ8F4D7MGjQecp
38437	payment	2134	2134	1874	1	1	5176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XVikWP3XvyGfEVgutLyJKuRgEzAmRjHUHM22HgFjXymueKfm
38438	payment	2133	2133	1874	1	1	4697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VFq55snQ7ew8uyUAFJ392aKMy6qWAFYiKB7JnB7gqE8GxUZk
38439	payment	1397	1397	1678	1	1	14738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4Wz6G8uynnXEW9DYxKXk5FPcVaiydVDaUK4dhrYH5jUjbJJs
38440	payment	1397	1397	1678	1	1	14739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdE2gLvkFCKLrkz5F77GxvancqrBf6KDVQJdgTMLx35czpK8s
38441	payment	1397	1397	1678	1	1	14740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVscLFx7mWAwijA9GAz5vzfha5ikFUsbXpG9BKitryxdiKXv4
38442	payment	2132	2132	1874	1	1	1416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPd1GSVy64m8uhGbB2UXSSJZhP8ZvLN4V7ZWzWtxrb7zqyjXF
38443	payment	1673	1673	23	1	1	16	213080000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpYkBvath6ELPRmqr3NkPyi9e7Ror6gLM6SKU7UEUPjB9tNgTjYZ
38444	payment	2134	2134	1874	1	1	5177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdBsFqBBCtCuD49qnUGVMzsKbFkDxk8EDX3xLQjVERSL11Fr9
38445	payment	2134	2134	1874	1	1	5178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BGLyMQbP6ErVMewRCyNLXQG2p25dVwthXb8VCmvEfeo5j6ZG
38446	payment	2134	2134	1874	1	1	5179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55QGcykwcAiPF12ZV3WXvLusDGCR42rg1gVkBDVjVUxTaeLuB
38447	payment	2133	2133	1874	1	1	4698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9V3N2SiRRXUAbAVm11MBmvwSgm3UyMvcmfdndPLwjRcATwqj
38448	payment	2133	2133	1874	1	1	4699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfhP4VZMurx19Umc7wfJd26R3waWT6vUdpBoxdX7XEJWbd7zo
38449	payment	2133	2133	1874	1	1	4700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpTWv7Sdbb7kRMVn7mdi3XDLZLViFm2ssZinMRCUuDzhcMCJA
38471	payment	1397	1397	1678	1	1	14747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i63eGqN71oKDAL1BXh5BCbD2dCfCAL37W3PUnn2LPGYyKiYW
38472	payment	1397	1397	1678	1	1	14748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEzuqFJ6CQ1tCgVkfXN1f93z7yBVni795JyRBwvda32ixiifF
38473	payment	2133	2133	1874	1	1	4707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9jQUG5bjs2W92pg7atz5QbcqbRVmSh1SyL7htWmeE622xKwr
38474	payment	2133	2133	1874	1	1	4708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5cec9ZvQWyLpbmDqnLYJiyLCvP2JdQV73r7PWbYaoqhBRGjc
38475	payment	2134	2134	1874	1	1	5186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz13WUwgC7hNteqP23GXAqZGkHxk3KeyxcspT244gZjz9KH6yb
38476	payment	2134	2134	1874	1	1	5187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZVoMAVxM7iqVsvQEhiM6b21k77dD4xJ7xcrtEupKjp52r6Yp
38477	payment	1693	1693	245	1	1	1117	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYZ7cYrejAbVGqxWf7nHc7bDuCKZgY6MgzrxSiE5vF3jy8ac7NQ
38478	payment	1397	1397	1678	1	1	14749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFcYCxQP39XvwT4tSCZQfugQqgXK2ekJMk8saEZy3K279mr4pM
38479	payment	1693	1693	2017	1	1	1118	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaHtAjrvsFmHXap6x6ufs5SJWdYVtbbXTRLRKZahC9GvNfPPHJy
38480	payment	2132	2132	1874	1	1	1419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcVXJtEcipdeyExpMLa8PSgFHN3jfEori4bvYctUVgDdkqnnp
38481	payment	2133	2133	1874	1	1	4709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NuAXF1waynrvT9pQHCL882FRbhootiqVD6fZbxt5n11PpgQg
38541	payment	1693	1693	120	1	1	1155	75501111237	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeZKEKAKQLrAvQb1rvmPCt8De3iY61TSiVQKDSmJrbJyGmMM25
38542	payment	1693	1693	320	1	1	1156	75501085869	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZTKCkXzE2MypKDjSF1nhxE3iF7CV6B1ytiWVLYb4i9PST9krw5
38543	payment	1693	1693	251	1	1	1157	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2HQaL3ALfBaQqam89nnM16gFt8rftduY47RsvUdVEWoaGrzgJ
38544	payment	1397	1397	1678	1	1	14757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jAQdzpNhyzz4oxC5u1KXtqmZAg27sR5jWZUq1MhXuJPLVAEg
38545	payment	1693	1693	312	1	1	1158	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGt9wjMHSafuT7z5UVeFAxmvdRMCLZqbbedW2iYZupKJcYCJjB
38546	payment	1693	1693	663	1	1	1159	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZqPkgigK7sASnK2Kh6GH8syXnD1yr9GB2pnHbzV66Zkk9DQnbH
38547	payment	2134	2134	1874	1	1	5195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMc7DNdi13VHmK2UHqqhUgvrGaE1ocRTjR6VMSCAtRwPFX4tc
38548	payment	2133	2133	1874	1	1	4717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qfWos5zTY9VYFAPLYU4YACnhSR3AgtyChGHybDgAdgmynVkt
38563	payment	1397	1397	1678	1	1	14760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQerNtnBq6BhahgrTboYpiYSuepnp7v6VV9V1AAsD7Y7gfTrhM
38564	payment	2134	2134	1874	1	1	5197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUAi7THGynmKn7x4ng96a2MTb1xRRYRwSZKcRBypwnULstUZz
38565	payment	2133	2133	1874	1	1	4720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUp7dXLFgRCD8YrvYbkZasmiusPgq9h2TgFJUS37r7guK6BHuL
38566	payment	1397	1397	1678	1	1	14761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xn92Qadirp7qWr7zAvPeJrcEnumth6R24oLF4T3P4stiqXXg
38567	payment	1397	1397	1678	1	1	14762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW96zzAX19nLsqqdnFZzAXXi9xAcfr6AVkcDo6NyRPhWchwra
38568	payment	1693	1693	309	1	1	1168	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZoJANTkgGXDwMxFScUZsuVUJT52UWJSW672VDrSoj6DtZdmPsD
38569	payment	2132	2132	1874	1	1	1423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLeXfdAYi9xuPQuLJ9CJ9MwMYbESUnCVC44JYvR7e9ND83kES
38570	payment	2133	2133	1874	1	1	4721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6owWptTSQsSQ65Nae2trYs7rAJQBvatLRK3jRuW4Xr2XNUkeG
38571	payment	2134	2134	1874	1	1	5198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYS1a5TZo83gbGrB85SDmtHSVtmDfgft5t5sdMTFXcTwht9wb
38572	payment	2134	2134	1874	1	1	5199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvHHcd9U4bQD3eALMdFrDjZNEYvwWLKehd9gJUUQKUDNGqKbN
38581	payment	1397	1397	1678	1	1	14764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHH5ZPofG1KWv5qgqM6pkdoM1k7AHsyogDaftqAPJAVnPEApJ
38582	payment	1397	1397	1678	1	1	14765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw4ddixKSWfgNsfMc8c9VVEvqZ7TzzARtgzuqVDj3SG7XhPRu
38583	payment	1397	1397	1678	1	1	14766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNLYHL1UQxkHaWDWCSvbg43yjdZi5iHXXrt74RNCNHogHS245
38584	payment	1397	1397	1678	1	1	14767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS2ySqxYig2ZVUycyR47b8y81j6hP9xnkXh1sQt56LHNcTXm6
38585	payment	1693	1693	458	1	1	1174	75502815709	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaJsbkLmddGyHDX944aHswaKKg7xj69CuxCcPirS4VJtQvKNWdD
38586	payment	1693	1693	391	1	1	1175	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZkpakaYFm2z3gbmLTrYmjL34pQq6G8UMRwzBBiM6hN5GaAWkFa
38587	payment	1693	1693	680	1	1	1176	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYopuXrodxK5wBE4eENBTeBRi9MkRQarG1xFfTum2giUsmBw8C3
38588	payment	1693	1693	690	1	1	1177	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtbRYzAuqTEv6fkrfHx4cnMUE7shPnsA1fzjW7KpXNBVL3kKo3
38589	payment	1693	1693	2181	1	1	1178	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZKM5rBJwxrS82kyhYYB1U5RGyEigSPnZSidNw6wFqc8D7KWkvY
38590	payment	1693	1693	327	1	1	1179	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYpS5mgMSKwcCbP4pjjokLSbUm76e5HXbzdYCF3CB6cMApWLKrF
38591	payment	1693	1693	652	1	1	1180	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZZg1RC8MVN6acNvEwpapfU52vjunkSwdH2yWFVv6HNuN3o1YtV
38592	payment	1693	1693	266	1	1	1181	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaAZH68qDtAp5jZCBNbJYBkjKbpcYC1896Wa6vy6nhubwbnzQDN
38507	payment	1693	1693	611	1	1	1135	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6y82jFjqMSWh1cGo5H7MeZBgFHuRp7hMDiJhPKJi9P4uZyB4d
38508	payment	1693	1693	146	1	1	1136	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLXAmGQLT9VA1rBX6fs1Y4eJiAss7aVP9641GpUTigeTaVGHZn
38509	payment	1693	1693	114	1	1	1137	75503216089	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZogL3gE8LNK8rx65AqdyHnbdS9Zj2aiEnN2qrHQofyfSS9kfcH
38510	payment	1693	1693	443	1	1	1138	75500525541	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa794KwfGDDWqvJcJe5Khff7rabNwpu2mMJYDAvZRdLT5WrCbax
38511	payment	1693	1693	138	1	1	1139	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYrehCPxGd7aya3byq1UPNHVV1qEoxwSVp5wxr6eY9N1cqzQfZW
38512	payment	1693	1693	205	1	1	1140	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZU3gRJzqF6BXzSVj3e3S7vd22WRVegdDrUANRXB4UveKA9AEFz
38513	payment	1693	1693	578	1	1	1141	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWxxAgZUyo4ENHJqHZAxDgvSEnsEkdU6sK7mt8TVPHPYz8rUsH
38514	payment	1693	1693	649	1	1	1142	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYQ1g5XFhSGzXq6LfwtcBWkr9RNGTpwpdr5uGevn1LcqRka1HCK
38515	payment	1693	1693	504	1	1	1143	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZTrehEX3YkhnL5P2cVkNPWwAujbBsmER93BYdAd36gkvRkGz44
38516	payment	1693	1693	1276	1	1	1144	1946786843988	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYwD72rVx5Th4uD1iC4F3a6NYCjr31yPAg4FuXW7shCqv5FWDzS
38517	payment	2132	2132	1874	1	1	1420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8K6yrBRMaJCsgeqEvfM4vaLNKySBQxXqJKrgPAY1CpfTFL4DY
38518	payment	2133	2133	1874	1	1	4712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNEhgHcarCV39epTKGQj3Xeyj8KcgJeqCgLdXtjmUo5P13NLm
38519	payment	2133	2133	1874	1	1	4713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkdAMrAopzJd5mNjpTcG1pDenZ5ukJK1ivK71yaXWToUyM7ZT
38520	payment	2133	2133	1874	1	1	4714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SWx6PcZfLmXRd7ZoH9dEEyDtXpT3oyfiR8FXeUXW63MpfuQj
38521	payment	2134	2134	1874	1	1	5190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMeVAL7XNdCCwugdyVucSYkUprHz4hmRXpMvd1pFYM8BzPfY8
38522	payment	2134	2134	1874	1	1	5191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeHJ31RrhchNpQGdKKU11uZnaheYsmz7sPkCA3XEPG4oZ1UMB
38523	payment	2134	2134	1874	1	1	5192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiXwbmDB8wcF6u9N3tA7XcjLr6yyZc9gMLPsDx3ppSX2ETGPr
38524	payment	1693	1693	194	1	1	1145	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZEoo1wej7tskNauMDevVdShd3NS9vKCeNkjgY2YRYxbXNqJQxg
38525	payment	1693	1693	399	1	1	1146	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYwqRkVn3SLcHYPdgYaqyUaxedDVWkf2RpBXAo51R4ojrtEvcTY
38526	payment	1397	1397	1678	1	1	14755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ5NZpiAtCfYHqPif72121gzH6WaWrYf1zymFvsbzXRZWDafc
38527	payment	1693	1693	636	1	1	1147	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa4Sur6Ebbav6rGYmaTHL9JE3coYKcamfjeMYJEjTt9RVrMdG2b
38528	payment	1693	1693	721	1	1	1148	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeRfCKAR2VEVqbx2kZoSezTVQScirB8L7VcohSFrzBh2dR3nez
38529	payment	2133	2133	1874	1	1	4715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnKD2Asx8CD1pb5b3hynuuPoSAADn9xWExE45y8dbMgRpsGJh
38530	payment	2134	2134	1874	1	1	5193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQiFL4g9RDkFbiz4YsQbBvz3ZToXEDrAjXk2R6jXmdrtQJ6Sy
38549	payment	1693	1693	1772	1	1	1160	544674052897	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYy6oKvCRAxqzKbgu2134f8Q3Y4PUuEzn5CVkwTzHcxRbGbvDRY
38550	payment	1693	1693	354	1	1	1161	75502815709	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqmr2NTezoHFfXM9Xw9GVjXUrFSznX1JSAsd2dpDzzr1PTx8Yk
38551	payment	1397	1397	1678	1	1	14758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3X8wTwnpY1J2hsoKZPNs6SDUL5hM4v8rpL2fN8zFi6FTLQsb
38552	payment	1693	1693	570	1	1	1162	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2zGDF39nVVvHD3zmx7maKxqUAcaLJKyugDBqTmtgM73NQMkKb
38553	payment	1693	1693	894	1	1	1163	352487287519	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaHu5x6eFncHXkndNTq7y1DTMpwtCR5LRWGgbX5hB5UTYQKb7Zf
38554	payment	2134	2134	1874	1	1	5196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbPwgwa2qxi4hU7oR488E75zPs17X29QV5A8WZUvi2hTyUenF
38555	payment	2133	2133	1874	1	1	4718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p5u6PgQVtBFwpmhmNggc7bM2vHaBHuoEpBnpgHFrSQjeMMt2
38556	payment	1693	1693	569	1	1	1164	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYVU15rd9tfy6ekjDok4RVcoWL9SvNsnLYqsxgk8WwnS3BfVU8H
38557	payment	1397	1397	1678	1	1	14759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyYnwif9X23rRLmSfPeeUkEZNk8oQKGrYHdfYsn1x4jouE8Uz
38558	payment	1693	1693	390	1	1	1165	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa97rhQsPo7nK2CCsSM3RAuKDjD6y25xeXE71Ca5XSrGNCBP3AH
38559	payment	1693	1693	342	1	1	1166	75501340026	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYQ2qrDqXBdiSNLy6p4kDA8ECeGUfybNYjTrtqaYRriUc5fdu1o
38560	payment	1693	1693	731	1	1	1167	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLU69Ptzy8bLhrKas81Dv4chAdaaQjPzCgur5cp8YmkY8s57PH
38561	payment	2132	2132	1874	1	1	1422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCheF9azL6KobXTHb8KCKRCwSRRdp2MZR8mS7W9TSzWUvVk2dL
38562	payment	2133	2133	1874	1	1	4719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPRgvFZngkWhPbiSKUZ6sR1JSPd4m278t222omG2nqLqYoZfMh
38531	payment	1397	1397	1678	1	1	14756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9Yfs5Be1op4oJyzvJoiFFjJN4taBmeJSKUrpMdBoXRCgzjZq
38532	payment	1693	1693	105	1	1	1149	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa35u9C4cqahjuT2V6wsU6B3ksBD2ripWw3hgasDQs5DHA2h8bY
38533	payment	1693	1693	206	1	1	1150	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaG1P6GpuNdQHZkzgrdYK31DSzoxFZnsu5zXmWfLK9wLGcJJ5z5
38534	payment	1693	1693	710	1	1	1151	5744148628	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZa36JRRQnDVjQQ3GaVchxJe3VL2akySG2b5FGR7LycUQbs8dDt
38535	payment	1693	1693	499	1	1	1152	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZoThuJZV6p8WcoRZ929Em3XAKnhh99gB6KGpMMnM7DmEPXVjn1
38536	payment	1693	1693	1030	1	1	1153	1035432902448	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ7uWarfeG1ywhwFg41rDX5iof7GYxvrTuzeQj7yjcwFfjtdnoU
38537	payment	1693	1693	238	1	1	1154	75500264719	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYdisdDdmxEZVd6BLYfZpyEYTina8j2R1RS9uNUpguq5zhmnXBd
38538	payment	2133	2133	1874	1	1	4716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwpDnAcr5i5D6p6EsPKwXMqrtBSEBVN61KuWZNLbuyxQVKsnd
38539	payment	2134	2134	1874	1	1	5194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyxJXF2FUwGPajQ62Jp3x9wzuqfKtaTuZcb2wxp64J2RLwYy6
38540	payment	2132	2132	1874	1	1	1421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgUD2wcaWq5PzFkjPdrNUJPJUiSwfkDnNQ4EBmzUwQiB5k6Ee
38573	payment	1397	1397	1678	1	1	14763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcS4Eism9eRWr8MAbsRLSAk5P9Mg3npszGJtv5Ywa7j6Nh2ew
38574	payment	1693	1693	82	1	1	1169	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2QHEdMiBP5bRZagNtJut3LMZMMyB2MNbCzjh9vfweodY1YTnf
38575	payment	1693	1693	361	1	1	1170	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZJ1uHSnp6MRxaBqvpFG1H3pRTVBFC7wbuqHoqbvhUysN58VwJy
38576	payment	1693	1693	402	1	1	1171	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYgPqCkCBYx2QDJEcq6ofMX6rok27mJjhHGFgSqjx4xb2FZqdz7
38577	payment	1693	1693	275	1	1	1172	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZwpP2QwaciBzhKTewnyzqZULyoLmGv86mMiUKVaUZV1ZjYJpQf
38578	payment	1693	1693	452	1	1	1173	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZg7mt2NCp3Q625j3DQADvRnv9UeeLiDrstnojR2dE2ZU2UVTGR
38579	payment	2133	2133	1874	1	1	4722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDrCWbRyhrZFh64hH6m5f7MB62rofMDjQzYmKHhoKDBJx4cBN
38580	payment	2134	2134	1874	1	1	5200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdGFLCMysPNbhbkZk3JxPPTxXQLuWjwf3b1QUiJKtTVbdL8Xh
38634	payment	1397	1397	1678	1	1	14770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMEK3AW4zDtWESvQLXbihuxamfB7u8ZmwP8GjLvhQ7WXhoumF
38635	payment	1693	1693	29	1	1	1207	8041808080	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaACtFoJSHhZMRPHAoWAmpQQAyGHKsdakbZ559LapwLwuQyJftj
38636	payment	1693	1693	593	1	1	1208	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZFDWWLGKSpMgjJRuMW1zizqzJTX6HLXdzz2VDYveW1zz9zybec
38637	payment	1693	1693	154	1	1	1209	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqAPTmTCAupXekm4rw7YhKnzJ9eNJdfPKvzQDEVK4kZt1SY9Rz
38638	payment	2133	2133	1874	1	1	4729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ14gYwee75AHYasQ8GFw6f9KM6pLXNvb4A36sSz3o9cXDfaB7
38639	payment	2134	2134	1874	1	1	5207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTMT3LKCFENDXcDr4CzQaJk3SNA1fVwvTA3m3gG8RD1ntQJiT
38650	payment	1693	1693	262	1	1	1213	75500194937	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYsThQKSBhC4wbXfqKy6bbDCRpXbLtQhvVrR9AadU4ma2sMonjW
38651	payment	1693	1693	660	1	1	1214	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYrUAej9pVbQ1j2aZpAH5MtKZAikc899BY9vfsyEgVUkDJv37Nr
38652	payment	1397	1397	1678	1	1	14773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoFdrFTvN4QdzUari9tQZUTHLgcAePBwg6iw8opbbNGpCzEhn
38653	payment	1693	1693	304	1	1	1215	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZx25qY6WZf5CWFew3xLf9jEdNZuwZp7RtZYtyYJF6fVyGvJHCr
38654	payment	1693	1693	441	1	1	1216	75500093132	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZHCKBoeFzR5YEL1tHrTsAmPu5iRnDw9UJmUEXnVkCgYfv9LS9y
38655	payment	1693	1693	122	1	1	1217	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWGe58xRiLpaQZqdLUJBgpF2h1z1aTn1wgBgCotd3eSN5pqPdB
38656	payment	2133	2133	1874	1	1	4732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcnpwwjTVvwFDjb2d61Q3xLeN71vRkZBdF1CNp2ReTno1DVU3
38657	payment	2134	2134	1874	1	1	5210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJE6MKRRctCutHEtQCXKcfa3NsJbELSp2mc3FZKdQTvmAVC5rf
38698	payment	1397	1397	1678	1	1	14779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MkBw3Jh9uLDs17GjCBH24ZD5rwLCKhSe9PjAj5efKPPxcNnt
38699	payment	1693	1693	237	1	1	1242	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ6vLbRxrkH5991ienhufMPo2G6RhmHeUJTSFEWMKXyywUxnCxp
38700	payment	1693	1693	2164	1	1	1243	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYtMgpXoNBjXHt31wHiNa2xJrpjTVGtCufSXxAgQicDrC41qCHf
38701	payment	1693	1693	165	1	1	1244	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZZs8obhBPfwZnBXY8KUS1rxwf5pB25w72FLVh8jpSVwrCMhKRK
38702	payment	1693	1693	600	1	1	1245	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtbZowqy3e8iZxZrcMe4dgTNbqVJfhWvwvtHuZ67rnSdKcFbzu
38703	payment	2134	2134	1874	1	1	5216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1SWKUZiPy5XuHMCXxX3cuKHKpDrsP2SUEPjNTmAvuSPSVYed
38593	payment	1693	1693	352	1	1	1182	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZPxKP6rJ2JVsFj88a2qyFdD3awgP8kURKYritut6Ce9FXPNHfT
38594	payment	1693	1693	534	1	1	1183	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYb2cJSGBYNrteTaztcJVKW5zuWKvSQ8rBtX6RyDCJdjHzso28B
38595	payment	1693	1693	520	1	1	1184	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCQHuiU6eru3XQ35ZZJuncgp4QDuXXR2H45ZJir7m5MnHTJ4Di
38596	payment	1693	1693	551	1	1	1185	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZFzwq57bJ9HepH4HHYVng6QPd9E7PSPnrHmCoU1cFXxpSUGWfh
38597	payment	1693	1693	191	1	1	1186	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ3Fb5ZC4C36hjmvoZSosuxwhPRZ6sPjTd5zwNKziewhoMpSw4c
38598	payment	1693	1693	421	1	1	1187	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYxLN3BXeqGJ6fcmGxPP2Z9PPXyTVVesy8Vd5KdrsvviTyeS6fY
38599	payment	1693	1693	1150	1	1	1188	698627211744	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCHsxgfqcydEuAjpm6CBBPcwJ5qR94R9o65J3Uf779oFpHyM8c
38600	payment	1693	1693	84	1	1	1189	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZhMPRpzaCuidEusoSoTKAqzYwaiwfxaStzVW1wk3mSpnu93oN2
38601	payment	1693	1693	379	1	1	1190	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYY4YkW4JqByJQsdhPvqnNBWpjRMm1ypxoAakFVPrZme4nHYZbi
38602	payment	1693	1693	678	1	1	1191	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa86s372ZiE74iucGdSM8tGBorEyZHkxcKzUqoWqudXDDdSXbu2
38603	payment	1693	1693	89	1	1	1192	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYidFg9JJ8mT1tLRGQ3NnCv2aRhL1tup9iGMu1pZMaPdSSqdukn
38604	payment	1693	1693	383	1	1	1193	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa9cxAvQkrXCY6undo5T485AggkBeUTiof9pnByQBzjeoKLet7T
38605	payment	1693	1693	91	1	1	1194	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYSncqq6WU1EeYdgXDnHMNyZNu4HtmtGgr9KbBwhuMTJaE7AGWS
38606	payment	1693	1693	438	1	1	1195	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaFjHnv8wJ2oJcp6w2UohbHsbapoxjQebxRBZWXwfkdUoJ6JCep
38607	payment	1693	1693	745	1	1	1196	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYZ5t52RKwnunRTx5LqRb3mKxvmDu9VDYktee1xpPhJbZijeezN
38608	payment	2132	2132	1874	1	1	1424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSiwKhpW2cz32CP2xKjd2wgnCoxrU1GsSHvMZR3qgFS4saETC
38609	payment	2133	2133	1874	1	1	4723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSrbLjZsTt1c3CVKpBFSZiMePWR6AyJh6EQFZCoMfX2RFAUFd
38610	payment	2133	2133	1874	1	1	4724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RqtMEUxK3LahmEH6AuY4HkTBLhi9U7QsfAtktPcWJL9A9kGL
38611	payment	2134	2134	1874	1	1	5201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45je86PHJmT4Zf98Q8ZgfJ5ZqwWai7oQ9rAG8iypmVut5FUu5
38612	payment	2133	2133	1874	1	1	4725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtPoxkQpoZ6anYzwQSzvZNwNP8fnLaPoGE6WMdjRfN42cD6qt
38613	payment	2133	2133	1874	1	1	4726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfvJaV1s5SoKB2QmJUgWKP3MCHFki6Sm22txC2CcuBaMddrFV
38614	payment	2134	2134	1874	1	1	5202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhuXXXrvtMUNg9bDMj7ffNikaBwQpS9E5WtCWQZdTRL4MUzGx
38615	payment	2134	2134	1874	1	1	5203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7BZtkkpSEKidxLJj9kgdj7eq1ByRjtEpuPz5KXFhGTRwDijc
38616	payment	2134	2134	1874	1	1	5204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNQvq6g66qDUGoPXA1D9pgasqipYEj6a3Eo3sVf1iW6e3zvSB
38640	payment	1397	1397	1678	1	1	14771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjF5eQwnqaiScMcUY9q414cQsKo3nDNneyMg62h5EEUdwNAK1
38641	payment	2134	2134	1874	1	1	5208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaE7rCgAqJMiKuMK2qCGBpju1DezxW5981WcVWx12qPp4MH9s
38642	payment	2133	2133	1874	1	1	4730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhHGTXnk8WvifeMJjVkb1nFzBSnK3uRQg68fTLoxx9o78zkqM
38672	payment	1693	1693	35	1	1	1226	22057530746	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZBS1eFiSSKGhC636eQ1ASviXFTpjWkEJLC2YQiszKCnNyLBepP
38673	payment	1693	1693	49	1	1	1227	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCbBNBSnMe5ydy3ev87awY8m6cBsC9GB5ezcuPQL71zMJP4yfs
38674	payment	1397	1397	1678	1	1	14776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pFM7gRZJYgBt1baHc9ssf1xRcab4eAKkyqL6PsWs8agjyGr6
38675	payment	1397	1397	1678	1	1	14777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3DzneyVHfcyQU9f72Vg8uNA2xzfBzGbB6KnazJxRmkZ8CqAy
38676	payment	1693	1693	1778	1	1	1228	2288014596	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6EJDGPMcqKSN8JiN3jSQksWZZcpobyYz4bJDfWBzVbvFoCtnp
38677	payment	1693	1693	99	1	1	1229	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaL1T4UpEPFdbJ8GgRrTi5CoFNycWiKMmD97xR4Thq9zXiXryqD
38678	payment	1693	1693	108	1	1	1230	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYb6xxGrvFwTJGzZfWuDNFzVg9cBNgzkiVU9Q1sSbZ1tyBnUDcg
38679	payment	1693	1693	252	1	1	1231	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZHvwaf1td21RaBP6ZXheUvLC9DRkfccgzXpSnLHdfqmXiiYRKA
38680	payment	1693	1693	225	1	1	1232	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYznTfpPyJuSrqLXVKvmuiRs8bmRGNWLZuG4mFAZfHj9AQpWB4b
38681	payment	1693	1693	377	1	1	1233	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeUz44S4HrDhifDBjdTQgNoJ3W6Un16k7zegZtWmyTXAdCbzr1
38682	payment	1693	1693	560	1	1	1234	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZRxtyjaiRp17ZX3YknytxLHovRwWfykdkYPjUEya3nqX51ZU2K
38617	payment	1693	1693	453	1	1	1197	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeViZczhbRHGypFoMWwK1woKPHdfo7i29fHJ1q7NRN8sZ7496i
38618	payment	1693	1693	373	1	1	1198	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa4AqCi44GREtgbCCUw6zMsBZvYZ3i6LF56SE52sRvteeqoLWvs
38619	payment	1693	1693	63	1	1	1199	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa1yYAAFtm75FiRU25rG58TL5SSXYWDo5cDnF2pUf2pkUD8jJbd
38620	payment	1693	1693	150	1	1	1200	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYWZgeH2SggTRyUF6pGKpdsyXq84WmGNJQXf7nWdYwPxdSf14wH
38621	payment	1693	1693	92	1	1	1201	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLBTTNHmsy1rG4JTEd8467UZh4VqdTk9yE34wfUFkk8fN9DeqE
38622	payment	1693	1693	562	1	1	1202	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWUmeYXEAeAkt7iNKEFXMGofsEJUcsf5vXWAFnjez3CbawyzZz
38623	payment	1693	1693	910	1	1	1203	577811301963	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ1zqz7ELwBKiDLc4Q2CfcGfxC2737NxjmXu4TCCqUfoXTsi5Mo
38624	payment	1693	1693	711	1	1	1204	3434555899	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZQAjwA2trqVuPeub4zpiowsY7JsqQruZKVqhHPFmnyeCf8wmvj
38625	payment	1693	1693	395	1	1	1205	75819295835	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZNtXgnxVFpbf4dJ9VGUk9QUFxQrotzxxGQxMehgqPWGvZ4un6s
38626	payment	1693	1693	78	1	1	1206	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYnMUmYGkBV9wSgkH7MtV95VEa528duncoZpBkex4rkT4CZp9e8
38627	payment	1397	1397	1678	1	1	14768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRohasYmAWACbCBPhNeBQZKCynxZuLnxNtgi2wijGAbfcmeZq
38628	payment	1397	1397	1678	1	1	14769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxNkf7SJdPcigMbnbwq4o4efd6DGcwcSLET2zihbVtMgZDWSQ
38629	payment	2132	2132	1874	1	1	1425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoe2xa7cwh7rUz6NkyDFre5xnbGQkzurtVrHMCbktWsdjg88SH
38630	payment	2133	2133	1874	1	1	4727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1hgah9hMbuWASEA5W2uh4rK8iLAugoM7SevyaGoLuFxBi1ia
38631	payment	2133	2133	1874	1	1	4728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZepG4B1jhg3LzPTSDaGRhdmEzCcqkXWiJvvtEP1HzWcRF8GC
38632	payment	2134	2134	1874	1	1	5205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2LCqKxe3NqYn2rXWERc4byrV493d2xj5VoJzPUMrLBGzZqSJ
38633	payment	2134	2134	1874	1	1	5206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwMnqSb4Hbhdro3UBpRTuG5tmHwRWmFNRCt3aJa7TSwMinUGt
38690	payment	1693	1693	163	1	1	1237	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZuh5u5eyE91XoKRsyLaSuyDDBhT9r2WCc2BPJ1bSFT3tcKhvbE
38691	payment	1693	1693	1962	1	1	1238	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYzjmcJPRgUt2mUmt4HnnkbpxWxQP5PjbazCyCY8aSTQXwgv67n
38692	payment	1693	1693	748	1	1	1239	2290615270	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGYdEpGk5eTrxEW5MTLqAk8vrUArDGbBqkRQNEvHE3VfGUxdgW
38693	payment	1693	1693	2073	1	1	1240	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYUjritkoge9iDqZKuiqEZTBYfe75EyCRUTeSzFW7xp6QQa9jbz
38694	payment	1693	1693	180	1	1	1241	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYj7bdepMZGDwJeaFHJAqV5JCZ37vHBy5e64dRCVf2mrdpQz7Zi
38695	payment	1397	1397	1678	1	1	14778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcWj8cR3i9FEL51ugKx8zzjPifLLLcUJ2sBnvkCsveY8HuhzK
38696	payment	2134	2134	1874	1	1	5215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxq2kTEXfLxtZC8STjb9QW27mVcumS9Cja5iEBX5br5xqUTXk
38697	payment	2133	2133	1874	1	1	4737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YMskeWskdskFKZWmxd6ciShAaHcBZ8Q2U6BxxxvSfgvrodvx
38706	payment	1397	1397	1678	1	1	14780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qcTKMBrdZRk96fi7iLp8R4f6MbVWPJB11a6iLWZVMWCarywC
38707	payment	1397	1397	1678	1	1	14781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9mNZnhFFaRyFhL5at5NnrCc9JcAzWA2Efzu8krKf9gGZ2guY
38708	payment	2134	2134	1874	1	1	5217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWHTQRLoXA9XaZXjZUkCN5V3YJ5TURWrPZHDu4BayiMoDChqg
38709	payment	2134	2134	1874	1	1	5218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5wfcpQpbmLkzbx2s19iAAHdUiWdyiVPhdMrGvKM7qswoNWBU
38718	payment	1397	1397	1678	1	1	14783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLGmuqwtW5jgSmne1RdxSPFJeC3MAYMjxjdGsujNRwftBck1u
38719	payment	1397	1397	1678	1	1	14784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6V9betucYGwuTytKYZDA3LFAMnYdDkFcJPrWCZPVrpWZjagTS
38720	payment	1397	1397	1678	1	1	14785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5scpYtNidmBgRCJEq8tN8S6HYvjmrB6eBcpAh5J53zrJaF4Uh
38721	payment	2134	2134	1874	1	1	5220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KpgfCJbhKfErtAVf9afPHVqXo7gRCVapUdDinxcBDDXEDEoz
38722	payment	2134	2134	1874	1	1	5221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GWUTnvfNzzqf4Pr9nGFLewKM4cPECmdUmu3WodYXR1r36PRZ
38723	payment	2133	2133	1874	1	1	4742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsAvk7mt9PB7TZsFEPhc3gjXL4ZSb9MW9257BTuGJfmRNz76n
38724	payment	2133	2133	1874	1	1	4743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbik3cVBRaCFCgGcheYJUcsy3nkBfiRXFhR7MYL4Cb4av8DwZP
38725	payment	2133	2133	1874	1	1	4744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oMG5JH5wS8PL7SuxQrmwVg28x6AU1ySSn7ypaAqk3LTnqJY5
38757	payment	1397	1397	1678	1	1	14793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB329xtzeGhrT37R3fB5KJs8AjXhZjQKNdGcai3yfjPt2WNApo
38647	payment	2133	2133	1874	1	1	4731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLbH6V9wmRUNLhaugX2Hrjt8TguMjENFwPQQwT5qWMTo54YQm
38648	payment	2134	2134	1874	1	1	5209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzh5fX5XF5gThPaRdVEE2E4J9zhbXcTiBuzpJVpCHcMVFLviva
38649	payment	2132	2132	1874	1	1	1426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvLWC8FebYy8LrUSfJ8kHT1EcTX31fTLJK379WUFGZJR37ZC5
38658	payment	1693	1693	2308	1	1	1218	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZE1aDWxzknr6JA7wcc7qL7Bxge6WGPDn9yuFKpnF2JRWQFWcbr
38659	payment	1397	1397	1678	1	1	14774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKAZFkV31ycfbgTEMmfS2NmanVhqRhvbfjuo2wZWdrVWSNizr
38660	payment	1693	1693	653	1	1	1219	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaH3Qy4CjQf9ybx5s73Y4ZrzcL5oasmHtuVytZKHTQoTL5Jbyt7
38661	payment	1693	1693	217	1	1	1220	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtnYP6yEp8iKWTWSDxRzrUgeKzD7fEXs8UYM8JcPLKBqNEDxsr
38662	payment	1693	1693	103	1	1	1221	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGUjSwPVkNi9qJDjr94UT7Uf6mnMVM3uPu7Y6dhCqsuvAAuWjo
38663	payment	2134	2134	1874	1	1	5211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdb15jXMLxNGG1vNZDKD9y8zyTt5xK537ndW8FpoWd3BUPavbP
38664	payment	2133	2133	1874	1	1	4733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrrJCYg16BVv6f7Ek4eNXqJQCnsAWbZEiEax3BtC3XSncNdCr
38665	payment	1397	1397	1678	1	1	14775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfBv3wuDJCcDoke2vADGK8Vg9ZMTY4HnttLvgTRnGPCxxiYdP
38666	payment	1693	1693	893	1	1	1222	352487287519	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZaW3Ja9Q8y96XiCquFCrweEc6h289tgMhf39mmR8iyeRxQxXi5
38667	payment	1693	1693	54	1	1	1223	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZR1TiTW6H4smEa6nrjdZA8hSYmCtV3WCp3Syqk2TvmMnu4fYkK
38668	payment	1693	1693	530	1	1	1224	75500194937	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6g1pEtTcjrFA4Yqvzma6i6rgmNzLYRrgqDCVkK6RfwfwVFaV8
38669	payment	1693	1693	603	1	1	1225	76324874328	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZaGL5aeDDfA1j6FFyeQfNLqs7FaNnFRC4rzN76C1dhJ9oe6YP4
38670	payment	2133	2133	1874	1	1	4734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSt5z2qy4Jxu8VAjeDRtXrdvQNsPrYmUKABCr4qQrtYb9Qd1ad
38671	payment	2134	2134	1874	1	1	5212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EMJoDM94unUDtqoH4vqqiQU7pTDHNpYTzByfHjCb8cd8xPs4
38733	payment	1397	1397	1678	1	1	14788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqxLg1G6yPZkjSV3DbHpLwSP5gs7TSx9fkrQJugbqQCqU1sv6
38734	payment	1397	1397	1678	1	1	14789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe5XxPgriQLJ3P77yfDH1W1nSk25VPyuf238BF28GDiSyWsjL
38735	payment	2132	2132	1874	1	1	1431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBsjNFrRWGHoRyHmfAQhuJ5GmWA36jRdnuLUfSVu6Xqc7VpuY
38736	payment	2133	2133	1874	1	1	4747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WmaixrkdNpdmVTp837BmG88aSnZkwftT98evEbjB33nBMdVb
38737	payment	2133	2133	1874	1	1	4748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnSV12HwQ4GGPhNqPshjFKDcM32TdY2cSUbGEUrnYPBtYYtJK
38738	payment	2134	2134	1874	1	1	5224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspZ54hVf9icWQ7RwzS8RyjEFwhjsNofjbJ8EiQfMPA8UQsnZq
38739	payment	2134	2134	1874	1	1	5225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vQqbQtSETvKAc7MaS3HbG3ZHuCxvbzjbDtZLNRgpXJTNd5be
38760	payment	1397	1397	1678	1	1	14794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLb7bsp2ErA4wvVc8PnMCqC7AKvi5HskLk48TfepDGrrFG5DEG
38761	payment	2133	2133	1874	1	1	4754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGGqMcvk62gCWkQj7pieu7RrNEtU8SNQPjtzigxF8XMU54kyN
38762	payment	2134	2134	1874	1	1	5231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPrdTwnXEe38EBhgkh9Y2T4c39ue4LFCZSjN9ZJ2xfQsCJnRK
38782	payment	1397	1397	1678	1	1	14801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJy27wHm3HZkbQr7XY2jDKKytbNukKJe6UTQgK89kwUnfbKsj
38783	payment	2133	2133	1874	1	1	4761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrq4BKmgeGsBFekgFYJfNTkv6BezDSZnKFd35qe4q4AqXBmnL
38784	payment	2134	2134	1874	1	1	5237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND3t8yBRXuKBosnxhZsFP5HxRcXywDuK9APwrum955K7CjPQk
38785	payment	2132	2132	1874	1	1	1435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstbzosqHsu8uhuFB9gBwdkXjDrRYCy6EPteoBL9mfxJVY23mL
38806	payment	1397	1397	1678	1	1	14808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg76soNVJm43T6nTJ4RH2fspH8TKAv78guzCdNqqDewDo4ZERc
38807	payment	2133	2133	1874	1	1	4768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pgmyfLnzYq9MXNzcZ6ZegJpSCGNb8hVceprSq7moegJsmus2
38808	payment	2132	2132	1874	1	1	1437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrcBc4gVJZcBQF2Kxw4b3mDEVnFhNQbStET6u6qRD2NtyxuWWk
38809	payment	2134	2134	1874	1	1	5244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88EvbGWV35Cpn5ms4sfYWX1kJQCpRQqXtAFEFS2ev2zCjr4td
38830	payment	1397	1397	1678	1	1	14815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd3igizDy1Zzd4eQyLvbAc89bySx2mken6Wj1ffjqvVTCPzGu
38831	payment	1397	1397	1678	1	1	14816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KNscdSrQYxBQiarRaguWrvvkP6tXDbv2kCdDvoMYTaxG9Qqu
38832	payment	2132	2132	1874	1	1	1439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgp7CJqf39BoeYgXWo9FybUkW9kFHEd7K4vXXbfQufvBiV7WY
38683	payment	1693	1693	594	1	1	1235	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZjPrDySa9XxDSGnaEPxv1nzeH4jdvR7EzdxLidDP3n2b3KZaad
38684	payment	1693	1693	201	1	1	1236	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYaFU8bLcJ8yuxKGr1AMzqVgEDQmNXMgQVRrRpmwAs1gymYfijT
38685	payment	2134	2134	1874	1	1	5213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjaEwtbFTQwiTT4jx85PwzTEznAD8mv4SNkxUV734kdnXtkrZ
38686	payment	2133	2133	1874	1	1	4735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsSSvbmTJjWq9JWBFAwoWMgYABrhrZ6suXXemakX74SmXAkJX
38687	payment	2133	2133	1874	1	1	4736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVbgfZSQfgzVapLU8KfCbPh5vRNJSMaxhgTpyXbQt5AKkJdQy
38688	payment	2132	2132	1874	1	1	1427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStz99VUpWXkcGwG33Efem9PKJT6b1yH9FmxuS6nMLk2C3X4U6
38689	payment	2134	2134	1874	1	1	5214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHGTkH9J4xG9e7BEKGiZ6sJD9xxYfMJkW1nJ7jtVbKfAiRCwj
38740	payment	1588	1588	1392	1	1	7	8758476000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYgWM59dyjYVxZCbMzF1JvmaKbStr9LG5kq4jr7L3jGnkKgs1Dx
38741	payment	1397	1397	1678	1	1	14790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQdghczDNE4iNdFhBo5DgnqpE1r9NkeN7tLzHVWzXXcukfMGs
38742	payment	1397	1397	1678	1	1	14791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodc6WYKMsvqUE7f1genCwuRoogwGUL7yzKRK2KcP6C3cRc16B
38743	payment	1588	1588	1146	1	1	8	4658350000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpaH2xrtYjQjjfhxs4RnhWbo1gsfcufGrYDm1u2C4CwTesrmd6Rg
38744	payment	1588	1588	1266	1	1	9	3135636000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZTmkd7j6Qk5oEmQkvPXBEfQGnKxZ2gzXVnv6uU2DjYxozM2eRt
38745	payment	1588	1588	1026	1	1	10	2599538000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpaJ3G8fZBXkBtxMpjTD9fdEjx8Zv9cs6q4aTdykXruqiJujbXDK
38746	payment	2133	2133	1874	1	1	4749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYr4aVkE4w46JAxrKira9iUFYtByPQFgPEYf4ou92838gtaCWr
38747	payment	2134	2134	1874	1	1	5226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqT7U2QAaWQRJGGtWV1f4FLht7d3KkjqPXpYKSazbAVYL6dfL
38748	payment	2134	2134	1874	1	1	5227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxcr7kr1VTHYZhG7BdBMtze6jB9NH6YYZKyQ47VCLtwQCoyws
38749	payment	2133	2133	1874	1	1	4750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzF7MdbDRRKnJB72AxQt15c45y8tmYcSDVhEqcYedxFae2EaeH
38763	payment	1397	1397	1678	1	1	14795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPBkWGobgF8BkPqyi4BQH4jbMoWJBckxqh61BUkKRv8eJxFFh
38764	payment	2134	2134	1874	1	1	5232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxEErQW2M1gfZTy5yQU1CQuJRd8R16b25S2kPXPS8dBSxXpMN
38765	payment	2133	2133	1874	1	1	4755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fDtW7zRHqXXdsMqF3jP6oJwaexBvEEer7WRWmv9rPTeigdJL
38766	payment	2132	2132	1874	1	1	1433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mZweMoqy8JsSYqXeNGVWsAUspBy3J5DAJASFCZHiCJDJEPu5
38767	payment	1397	1397	1678	1	1	14796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXWeQjchqUws8u8Vo1qbScaE4dsdhXJeTgsGDqQbQVizGdbxa
38768	payment	2134	2134	1874	1	1	5233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdn4i3f1x7ViAAiyY9ttWaNsNE76BkeADJYPtmfezktquRGD1
38769	payment	2133	2133	1874	1	1	4756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZf9vtpShuGCF5J8XnF5czw4L7kGYinyFJwHhEx8uxawzZzzF
38776	payment	1397	1397	1678	1	1	14799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp36xFXnQzznKtpXVTQSsmNAobDQMbSaZJPYddfXQa2wGMeCrz
38777	payment	1397	1397	1678	1	1	14800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeyksUXfEABbGf9JMuSLLXemQu6tcBV2oQ3qPCmJWNbn4zLJBw
38778	payment	2134	2134	1874	1	1	5235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi6R3wgiPUM3vEKW2gPg8V3pw4wBwapWEDx88SZjQgSQJyykS
38779	payment	2134	2134	1874	1	1	5236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NPu5wnY8nMdjfPmKpRHCTQxzeoBAKhnnkVpdfWRaaHy8FHR3
38780	payment	2133	2133	1874	1	1	4759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7bUUfxca3ZL4RumLWg69MFQqiW1CA79NHGk21G3KxNBKNBMM
38781	payment	2133	2133	1874	1	1	4760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedxMWYytyo4K8euT9cVkjSKdwy6X4KzdugWQxzWtZFi2UBMwj
38786	payment	1397	1397	1678	1	1	14802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBc4wEnpo4fm1rme8ZxtxvkBFNS3Yb8c1tW4FbLc6g9xpuvs8E
38787	payment	2134	2134	1874	1	1	5238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqrP9e8QZHSrgti69AMmNjjN76peWdPwce6MW7e5UGjapisxE
38788	payment	2133	2133	1874	1	1	4762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39iAF1rJ767ci6PEsTfmjH9PNarf6hrHZQFV2AWuBchGFKi9h
38810	payment	1397	1397	1678	1	1	14809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEX7HDcAYR1dFcpp6wxBFxEHfMSmksEBA2VoDMCyZt64GGns3t
38811	payment	1397	1397	1678	1	1	14810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJSDNJxLSGxHCoYFFzAoYSrSoNWNve7b5Bi1A5xXvn8CPtW5F
38812	payment	2133	2133	1874	1	1	4769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGme7sY6YnRviDtRfr7F9wHe2cCNH5kf5NcuiFQW1oJFnwrNZW
38813	payment	2134	2134	1874	1	1	5245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMvBa4RE2Tmf9pA1JrMNurtkaBe3ssdzbVkEWDaaay1uNW1di
38814	payment	2134	2134	1874	1	1	5246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQW8siqJPaWHauBiSLU1gjLxUtcgnC29y2jnz3mic8nrgx9xgQ
38704	payment	2132	2132	1874	1	1	1428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehE4BKtrMHAkHR3ttfkkBVH7s5F8DWiqqfc6tiFAMTt1DZfsz
38705	payment	2133	2133	1874	1	1	4738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYuRBpcgFJTboxRhjRMqS7K7vhFTpAVwxYqmqj98MtR3NXDGW
38710	payment	1397	1397	1678	1	1	14782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDNHQDHg1dhgVGJc8gFkqftxdk4pvceybBK3R8y8YA3j7Qwyy
38711	payment	1693	1693	691	1	1	1246	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZbimugdWNeeXDWGL1F8itDtWcLcDNQLXGGmzymnkamPMzRrxM2
38712	payment	1693	1693	620	1	1	1247	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYXXPWGcpAd33Uo9beRDbbZgSjXbEKJZUMuibbFzkTWUynyfme8
38713	payment	2133	2133	1874	1	1	4739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtPMitH9mXqjA1V9c97JLdCimX8cGjrg8gxpQvx7HVhq7vDof
38714	payment	2133	2133	1874	1	1	4740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrb4QMXtbmvNtFLEBQ1tJfFeYpASyHS7Y8oYvbZZAVD5yHK3dX
38715	payment	2133	2133	1874	1	1	4741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbwwBauCJkFg9B6qGPAjkpiNBuzZBmPxWcgzjtFfBNtJvnAg6
38716	payment	2134	2134	1874	1	1	5219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjDGZHYRrcWFhDr8xZTgmLB52KgEu66qY7xsisUEGAmkRDLR9
38717	payment	2132	2132	1874	1	1	1429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MdE3GmRx82MhhefkhFPy8NpAgnkToUDQd9ZUXsYz3poTvJfd
38726	payment	1397	1397	1678	1	1	14786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEK8Bf9Rvez84KsQaPUEi85g9QDGkHHQ4HiKcfsjQfG7ioECK
38727	payment	2133	2133	1874	1	1	4745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GBGC889MEjUYxsEfymunn326KhHMNWo9vv9NK9SAVSkZSjyy
38728	payment	2132	2132	1874	1	1	1430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa156R5fQZXiTkK1EsZ1VMMeR6SUbebVc3qf2xWadwrzx1Wg89m
38729	payment	2134	2134	1874	1	1	5222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxbmnfUnH9aMsEQZDiDxZR5SfPE9qKb9WXe169CNeK5aNXWik
38730	payment	1397	1397	1678	1	1	14787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tY9pBbhMTJDUvPGcCQp6uz73UHfVt61fSYTpPNEG6cN3YqcK
38731	payment	2134	2134	1874	1	1	5223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa9m8FTTkQD6WL2KMYic3Jcc4VxbHRTnrDHHADCUYMi7zsVUN
38732	payment	2133	2133	1874	1	1	4746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3RWJv8VXSBDDGyCCeCHJmaTShJm3uoXBicS4pk6t3b2rNWN2
38750	payment	1588	1588	2068	1	1	11	1008000000000	10000000	\N	E4YTFNBSyRTHCEHUAomtPkh3z4eBATkV57MctCcuHuEWepGushD5s	CkpZdZMpCoK23eTHEbaprhSWY5Cm3KHs3fZzXKoVosg3awy7MQa6r
38751	payment	1397	1397	1678	1	1	14792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBCG32Mk67uNF3QShHVixWy9eY8Lf7LDjRydS6zbAP15Hg5Ag
38752	payment	2133	2133	1874	1	1	4751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBUTr6pQ21xVSPLixsY9PnyqW5VvdYZND2h92SgxUgQGfFcBB
38753	payment	2133	2133	1874	1	1	4752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfDrhRRQmbYxdXHbH8Gux2CPLTRYc926Xz1hMskt7eTSU546B
38754	payment	2132	2132	1874	1	1	1432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktJsD45tMwXRPJeALC2RAEqugM3ffmzCXDuukcfrYKVfXAPrh
38755	payment	2134	2134	1874	1	1	5228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVhX1GuLGuZxG1AwCNrdXXiiAjDWVJDb1siyTXswie1K2FNLk
38756	payment	2134	2134	1874	1	1	5229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eDMQcee5t9wM41D4dP2ipto9viQNDKmrzZ7AdnsH6UMAW4aa
38770	payment	1397	1397	1678	1	1	14797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JN9jJZQiwCKHwp2Trd6PkPgFKLJ5ReEEjjt5Qdy8hiPEsw95
38771	payment	2133	2133	1874	1	1	4757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC7Nah9S6J2fKkhTDipC6qicSeREfU1WQyGKAoi6qTxc6M1gd
38820	payment	1397	1397	1678	1	1	14812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqM4RF1ZgsxRF8Vp77ypcHqqctXXaYWNfWNGmBeXf4Va5BJgZi
38821	payment	1397	1397	1678	1	1	14813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGL93padfkG4PBqqGXdVfaT1qZvzz4ZgV4vhscRsqrJ8vdCcGE
38822	payment	1397	1397	1678	1	1	14814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHE3NXJ3JVbpDBgtUuRcCk6a5RMPrqwKj2gCMRcqu7JGre5CE
38823	payment	2134	2134	1874	1	1	5248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6BzJeZS2XJV7mjxU7bU8TFaaF4SGsqnyPAcsPoQDQMECbzue
38824	payment	2133	2133	1874	1	1	4772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJtv7Fj6UGe7PffJ7dcgcormbFNHG2j6RVa76VEVKbkCLTyHY
38825	payment	2133	2133	1874	1	1	4773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GahkUo3q6YbsaaMATDJt3g28Rrad8NaWJcSZVaaSamsU85Gj
38826	payment	2133	2133	1874	1	1	4774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4BTJzdfcqpdqgGrBE64Z4k58bbU2GeU2bsk5d5zKk2tx76M4
38827	payment	2134	2134	1874	1	1	5249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEP6zrr33uS588u27YV2UmawKtGrbazC6ZcwqEB8c1bUnhQcQ
38828	payment	2134	2134	1874	1	1	5250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTP8Z2KqyWoLHNUvXWQSND6w4NAmJBC46rdtL1wFMS46enrUfr
38829	delegation	1926	1926	1403	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7n8b8PALf8wQdTUq6UiY5LSFZPg1wSwgaUdNRcDAchSqte5R
38840	payment	1397	1397	1678	1	1	14818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9CJwbyqg8ss9rm2R6MmnuQmAbgJ1NGd9qbCknYKRHKyh4MMH
38841	payment	2133	2133	1874	1	1	4778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW3Aku3Dsx5TkwrdKK9p2FqBKbcdqrsTsC4aB1T3qcTkPR3b7
38758	payment	2134	2134	1874	1	1	5230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hbogpYpjpbv4mpEJxQ2pJdjMZRa446qxNpfKZ31aC2wGmuVa
38759	payment	2133	2133	1874	1	1	4753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqzHxjYxxiv6U9XPRZ4nrtfEp5SmHb34VEag15mNDVmwuqR9T
38772	payment	1397	1397	1678	1	1	14798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1wKboVyJy7BAvKXt4CRcRYGNrGeRhcWmJvfTADft1thDJ811
38773	payment	2134	2134	1874	1	1	5234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgehJkYFXKCH5PERGra3RS31Qp3tCTvBrN9T9HkbyxEwASUgD
38774	payment	2132	2132	1874	1	1	1434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytzh4NHDEEUSUDQ3aGhEDvXTwxU2ctfNAr8ENj5yefkCnkWLf
38775	payment	2133	2133	1874	1	1	4758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hh6Db91oMQhoacgikcZ2r2s9HgSkCEqAV5KKHLHpTx5J1amr
38789	payment	1397	1397	1678	1	1	14803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYaHChEuHRGmuK15ZcAQoGCXFH3ZTQq8CVBgcZuevS8cPN2Rd
38790	payment	1397	1397	1678	1	1	14804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL8nmUfbCKSb74dEC4D5E2GEBP2UsrJJS9djxaygHsHGB7rME
38791	payment	1397	1397	1678	1	1	14805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpJwGYGsyCCND4fxhjx1nTA4SfToxbLYBxhtyigaDhwQNaLbQ
38792	payment	1397	1397	1678	1	1	14806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiay3HZdEa2zXL3by51TPppYeA7EPfSvTgVpLi2SEJdhepY5d8
38793	payment	1397	1397	1678	1	1	14807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSgM3No3MwJbQXrEP2fdwy2Jq2q6cAhwfUqonzupbh9YKaDzX
38794	payment	2133	2133	1874	1	1	4763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7mZARuftj2c3Fd7o9boRNM182v8YmtVPxEDDaPeq3uhYEwCA
38795	payment	2133	2133	1874	1	1	4764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdBiL8fuU68ic1WifX6aKnXD5fq41TUPepgLZzunajqPuZR4y
38796	delegation	1926	1926	1406	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m2CGR3ztHPBb4fqYPXiYn1JARdRM3ruPMYdgmacYe3qK9UVw
38797	payment	2133	2133	1874	1	1	4765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBBYi2fJQzkLyvkYQJKndp3amihasueBtUwyRqNW8Su7J8MSM
38798	payment	2134	2134	1874	1	1	5239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6CTuNdfafB6TTZcLMEQ5V8A6WUkSNTyKy62yT722o3U9pH7b
38799	payment	2134	2134	1874	1	1	5240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocWBoqBWNxaFw5MFzXRCr8K1F96mJ4tLWfDvYo6tQcrxmSusa
38800	payment	2134	2134	1874	1	1	5241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkTDpoSoATAVfxGaBqxuLTazw9ubZFkzm95hKHHmC7JGY7SVc
38801	payment	2134	2134	1874	1	1	5242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwRcetWmps3UGWGkSQAb5F1crHC9kq4bJx2dSedw6GF5RqaieN
38802	payment	2134	2134	1874	1	1	5243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRyZFmkSB2MaM8wzsPxq59QDAe7R99G8rzQVkiRCnta4kwP2F
38803	payment	2132	2132	1874	1	1	1436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FqsbzGb5yo4icCRgHPFVz8Yo9Ai3tgwmN3L3sHnEJkMXQkKE
38804	payment	2133	2133	1874	1	1	4766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyQLv3frmk5uWTxw1H7gGMzyjD5Dghwpm9DHw5JQ3gmcZBFtw
38805	payment	2133	2133	1874	1	1	4767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7LRWY4vgHmcGnrMU1ctcqV5ZJ4BrN4BfaAKfxkbB2p9JaVSe
38816	payment	1397	1397	1678	1	1	14811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJfUrLXvFyQSFJbTAYHBipsHjrB4ngkHgbXSrhmh1C4ws8orL
38817	payment	2132	2132	1874	1	1	1438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVorxiK4rWhdbCFQMhnZtAo66uuni6vTYKahBqzGYtRCNSFRc5
38818	payment	2134	2134	1874	1	1	5247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGPo1g8bgF1N1sa8UVYTXAvqeE422Hh6NYtSa4bYMNVHpN6un
38819	payment	2133	2133	1874	1	1	4771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cZwwLDphJzVPAzDTwUhBhDw7AZBBhqav5F28VLbfm7JsC7g2
38844	payment	1397	1397	1678	1	1	14819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPavuHF1X2RHrGeCBW66gsv5bCziq8UMf52MFifqHw9mz6NjZ
38845	payment	2133	2133	1874	1	1	4779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPJKGQMD8rYE34mHffxYfKieGexZSpXhmUj7dNMXLfmq9JcXn
38846	payment	2134	2134	1874	1	1	5255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NBkRRqz8bKzV11Qv9wNYM95ds93CKBdFcL7m92BEdbvHbaHX
38914	payment	1397	1397	1678	1	1	14837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qDrofb3h8NtnkRY1D6UbwfSzFmU1JhpsVGoGbA33SFJjQvuX
38915	payment	2134	2134	1874	1	1	5273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnd8XTGhCZmnceRRo4PBvXqSgQCJYTTZpM7wNciy4EuHSLS66
38916	payment	2133	2133	1874	1	1	4797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPB6uKUJR8VDLMqz2ipUvPKwCB2xEpWfmqJ8HYiGVrXWttnf3
38937	payment	1397	1397	1678	1	1	14844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQyhPxVh68YCfzFjtFN5oHTq1U8MFDkbKVC3Zj5jFm5mUYSSi
38938	payment	1397	1397	1678	1	1	14845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBokeD68sSmaeY2FbFiEaTqvqxh44uN98dyKnLYTbBPatQDtXY
38939	payment	2133	2133	1874	1	1	4804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Yv7ghmt4TsEQmEwzgqWjG45w4gGW41m4Dj3ovu8sUjmqavcg
38940	payment	2132	2132	1874	1	1	1448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYTqWffg1BN7ErGsX9cyw5PuhkLJQdNfCj6V4yDmrjZYxNA2s
38941	payment	2134	2134	1874	1	1	5280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoYjPSMWrJn5R5vTFtVt7zcEYUajJuafAbPLCRcxPtyDXBR3s
38815	payment	2133	2133	1874	1	1	4770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVYoY4Tx2zkcHa8VB29Qut6BDQyvabBEyLZtTZsT9seL8zkPR
38837	payment	1397	1397	1678	1	1	14817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLxbHKW8uiwSfkN75iB16am4NTxBK4FfFbfYqdCMDBXd3cBWU
38838	payment	2134	2134	1874	1	1	5253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY2VjZXJQWKf8WiiFxCVdLpbsciUJbScGiJ39zrPEmfx2YjHU
38839	payment	2133	2133	1874	1	1	4777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJeGyMAkmeEFFs1HDUWsuxs23ZnE1ruF9Ju9tUB4XWDr8DHER
38851	payment	114	114	2314	1	1	10	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBh8TRw792EjQHX4iLZB4u6A7sFq8HAscmTkwD86UBHtXzhyX7
38852	payment	1397	1397	1678	1	1	14821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTxaSgRznLPfrp2DPa61vzbe4ffNcLzgGSMbEWUgBG7SNppfV
38853	payment	2134	2134	1874	1	1	5257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfxPQGKdTszWBckmja36qp4keGKe7tHdiQCNYukREQ4cz6sdk
38854	payment	2132	2132	1874	1	1	1441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAFkK9BuMAxjVcPxBZX7ks591xc1C6ie3y8sVAPRtWEwRsMTN
38855	payment	2133	2133	1874	1	1	4781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UzjdRaJ4gYT8FTxJ1A9dRBDSMxEbdJCynwSko7WB6p3R9b5c
38869	payment	1397	1397	1678	1	1	14825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZWP28zRGXP7aL4HwSawygE9N5PFTaWBqBF77g78Az77Zk7ND
38870	payment	2134	2134	1874	1	1	5261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNfJW7SGJ9BcezYyAbvC8KQXUGqL3QXhSoX2SdHNJ3EPYX4vF
38871	payment	2133	2133	1874	1	1	4785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSTFYrfz7AHCCWsbDeCixH9WbWwqismsDa5AiWnWiACPhJkSn
38872	payment	2132	2132	1874	1	1	1442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVM4kWrPxREYfYFzuNggTTWsQhvq1m5G6BQ15UUKBBNUQhUeu
38879	payment	1692	1692	1860	1	1	5	67001000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4tjYregdSCRX4esnxPkK4Bh2pd2UWs4nZqQiNMi1Gnix5Vax
38880	payment	1397	1397	1678	1	1	14828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFijbWF5PMBhkzXCx1HtDhSrhnUck1MkBDULwtVjU4VUpPPvC
38881	payment	2132	2132	1874	1	1	1443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3it3SaQg1k8CTC9VQbvRGkQcT7vhT9dVK6zUKqdBfxeEt3gKX
38882	payment	2134	2134	1874	1	1	5264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4M5La1Pt32ajDb2YTRCZUjY1d68GFeJLz4ZSCPb6yZVe4M5n
38883	payment	2133	2133	1874	1	1	4788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqCBbPFWVQaeTZGdyohka3GpBfPmBne765w9TYzJNpFp8hDbo
38887	payment	1397	1397	1678	1	1	14830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfjhUSR6idSL4J7RSvQtr5vJuV8hnET2Wezo6vkqY2BCDnDWP
38888	payment	1397	1397	1678	1	1	14831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjXGD89LLkgDRyqcVysRBjbjimzzHTwxqkymcQdQ1Tmawd9FJ
38889	payment	1397	1397	1678	1	1	14832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgkNkymX3ZLjRzEkKeeTVEtqvuX4YeuMSeuU1ChHW1eTCvuF6
38890	payment	2058	2058	2059	1	1	10	90000	2000000	65535	E4YZSJm6ocX1bjCpvP61P3HzTEaepBNYhnSeq4C8cPHiv43qUDfFB	CkpZ2Lzfie7tPc6tQV8K7u7X3ncX8VB8nZZYem2bf5rRKGaNcSJpe
38891	payment	2314	2314	114	1	1	0	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbb1LegGnvQnKDrDGzt2QYzQKsWJ8tL3avhtwprxX4JipX9pxw
38892	payment	2314	2314	1950	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7cJrWbpPsZymag3QzzUKcAQaP4edwCs1HrTw5iWeEuQzDYTW
38893	payment	2134	2134	1874	1	1	5266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFeLjHp7Mf6dNm8eWxBrgjQkvq6mxUjgFRdz3CVRpJFwM2UN7
38894	payment	2133	2133	1874	1	1	4790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2p9oRdDfMfnnLbpH54E4YXquWy5qrn4RcfHLS6uAWMXsXvCn
38895	payment	2133	2133	1874	1	1	4791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyBqMGhSaucJFGJyTdthbhjBFnJ85XSnCRmaBmejdFCxrFYVf
38896	payment	2133	2133	1874	1	1	4792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjfknzPr7pVWk3T5fqZjVX8sSjBU6J8JLjaSwQ71SZV9RnEmi
38897	payment	2134	2134	1874	1	1	5267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu6YLncD6jcrRdu5AvSfW75dr9DyjTwLtCJeevKgiwyRxzjR8
38898	payment	2132	2132	1874	1	1	1444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsmWfjUhssR4EYTJtR89cqf5LaYY2TxmVvKMBye9phz8zue8X
38899	payment	2134	2134	1874	1	1	5268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKWTcrJNPiEY6mb6VaFWFVVvjAXiC59Qke6gpir6tToBV1SG4z
38903	payment	1397	1397	1678	1	1	14834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCvAx5DNkWCh8fGB2F7BKgyHNu5XjEraD2enbSsLNC6B9nizU
38904	payment	1397	1397	1678	1	1	14835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmws85FNJPwHRfzdc52fgkW5D6ym2T6tJrxzYTZz5khqT2J3dc
38905	payment	2314	2314	1950	1	1	2	426500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAqLnnWsU3V8tio3CojcFWqiwJHG8Pn9YiKDhS9P9ifAQsASe
38906	payment	2134	2134	1874	1	1	5270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPCua2kyXHybBq59pGwLuHVNa71aNi7YfjJFk5pusBtjxbvEU
38907	payment	2132	2132	1874	1	1	1445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkAXqmxZJsHkH71ZxsxG2HS3qjaukHu6QtSj1Zv2gikCxiqpU
38908	payment	2134	2134	1874	1	1	5271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLHMUVDuHXQQa9NUsSqVxuof3NjwxhCB1u6P4NkRgrUKRoQTt
38909	payment	2133	2133	1874	1	1	4794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j2DTn7GbRSVSUDUcPrHPprgQkVqUrEMLbA8h9R5GZuUoYyKh
38833	payment	2134	2134	1874	1	1	5251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qHeqTKUs487ap3gck5vYumuBiyWSXLFVZgM7iyYYqffZ5MJS
38834	payment	2134	2134	1874	1	1	5252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiiJ53ZkJtbHtFkapL4wUneCuEJeubcSf6Vz4d2ehjRQnaivZ
38835	payment	2133	2133	1874	1	1	4775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2ri3DE39iLrdr1ULDzMbcN3dnYDxDCrGfwCmZ13W1ta76nDk
38836	payment	2133	2133	1874	1	1	4776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjKUYvmxWrQfcnjMj2KzGewbxWSGYMZqaoBEyXELa7vMiQzTD
38847	payment	114	114	2314	1	1	9	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSzLwZrK5Xyxm8Jysfhwb257J5KDmktFKWvNkfTYUdgMUdWfd
38848	payment	1397	1397	1678	1	1	14820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYto9Yt1RW4tCmYMtVEDMTsJFRQ4aEaX14kPwjQsCex8p5rJKy9
38849	payment	2133	2133	1874	1	1	4780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GWmBio9QS9m3B7d5WRshgJhGipkagsyfEEN5d8d4GiTerDBp
38850	payment	2134	2134	1874	1	1	5256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB36twEbGAU6sNz7dcxmUTe6Hyr2YMK3VrRZd2jZSMJEQRyjaj
38859	payment	1397	1397	1678	1	1	14823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenEmqN8gY4QRRqPqKtBg9LvpbVUYTYnb7F3GLdTzPVCPsPSqB
38860	payment	283	283	2314	1	1	1	121000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGwWRydipzLk4MxXx9X6zH3Fe5Q1dBhydi6AosBjUDiDRB4rP
38861	payment	114	114	2314	1	1	11	116000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLv4xz9xWPWMqTKGF4yLv1xaCcKUZQ4iBmps2GPNkSYmUkYcy
38862	payment	10	10	2314	1	1	1	61000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3rtSE8rj6yqiWxjt3SHJ8iHC83Wavfu7ezCTRhsL2mchn9Rz
38863	payment	2134	2134	1874	1	1	5259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7mVieN4wEag47DrMk7GMEMqsAezMzvDYDnbAaodLhaX7HNSg
38864	payment	2133	2133	1874	1	1	4783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEHtpfJiNGV2C7kT9onYy2rbewHfjQgi57LzbBcxHFUQ9DzEH
38865	payment	1397	1397	1678	1	1	14824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B1ijkVk3p84WFGLp8bsLt3ziYN7BsHysu964xk3EN644L68Q
38866	payment	301	301	2314	1	1	2	130000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdBGVjBKFDyKrR3KBssmmkDFTgtuwRUunVgp3WUYxRvd4MfJJ
38867	payment	2134	2134	1874	1	1	5260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshXE19mZ3s8aC4PPCsdnUtbr4xXtffsh43h2tBv9SmC3y2svu
38868	payment	2133	2133	1874	1	1	4784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJNjBCJm6brxKtLb3eq4oLRJTToegYY3JJJeASC86F98PttbY
38884	payment	1397	1397	1678	1	1	14829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iht1y7tp9bsBuxtK43P3Bzq4id2Y4ypGQ2umHbwKaWpmQdL1
38885	payment	2133	2133	1874	1	1	4789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1zmcSaQN2jT2WLWoNfpmP51oLkBBSpCyqJfKRRvhutZuGU6Z
38886	payment	2134	2134	1874	1	1	5265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGHxpj9oDCKinPXFT6xh17nyECvoVfj74E9yENGKZXJUEYknM
38900	payment	1397	1397	1678	1	1	14833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRW5K49tHRtjPRs2k5gJeJn6uNNSFkhRcmrEECDXr7NhiAZRg
38901	payment	2134	2134	1874	1	1	5269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQXtheyzEHuqBX8aVGiGEmNhjsHvjuEQGGY2ZKdHJ8cpY9eWs
38902	payment	2133	2133	1874	1	1	4793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGJYWNGryqnMWFgKDiP78ef5jURkEE9EGi2Ni1pEF4aFheAXg
38944	payment	1397	1397	1678	1	1	14846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7RNcfsNPFK2GF992Mvqm73XEfmDzRtKRYGwnv5ziEagW8Wdi
38945	payment	2133	2133	1874	1	1	4806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcBwLGiNoTNZv9SWuZWH77nh3qYFa12DLAYE99DBBJeAYjUSh
38946	payment	2134	2134	1874	1	1	5282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSL3u5mWzBG5DGvjqea919EHBUYYtFQ4oXKbsQFVBRUf9kEGD
38995	payment	1397	1397	1678	1	1	14861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJiuSCpthsYTJ91Vj8rsP6GWeLufoiPJL13fQwYrkJzLHkE4L
38996	payment	1397	1397	1678	1	1	14862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnm7gA8GgSWQisrz4KpsE5W8UHvvWgHifAotgQWeraXvah88z2
38997	payment	2134	2134	1874	1	1	5297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVsBMCMMqsNXxz4ux2TNdhoW9c3NkY1tCRnoH5B6dKSxdiuBp
38998	payment	2133	2133	1874	1	1	4821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmjsT5DhasWmJyKoV63zfvBYZFpX1LnQT4oANaHcuBbv7pNiJ
38999	payment	2133	2133	1874	1	1	4822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHARLy6KG32MwhZkmfowQW4m4Uv8ff5HLW5x2Q34PFK6mSoYK
39000	payment	2132	2132	1874	1	1	1453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRNqqbTsdKyYVW3b1VmUE53RJs5E5UNeWXWTS9nmX1S1UU8B7
39001	payment	1769	1769	1769	1	1	54	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycEjm2JVMmjDxU7sBmcNV9VR5EneFebddRW8j9SJhDSE9atrR
39002	payment	2134	2134	1874	1	1	5298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZoZCAHChQTrsQBaNoCPchuCm5svs1Dmjkt3Ypi3jA5AioyDU
39003	payment	1397	1397	1678	1	1	14863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa26s5f1vqSYoiwB8McmMB6GXiZtn65LEzEVqurjP4MFMwqQxU
39004	payment	1397	1397	1678	1	1	14864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfNFv3tbGoPGqBWExcB7rA8PkSoT9dE6HetnzwrbCM5NvomCx
39005	payment	2133	2133	1874	1	1	4823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJTdq438sn8xJV9BXhXPg1foJABY7PTKkSUoGgRPaDH93CcJx
38842	payment	2132	2132	1874	1	1	1440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshvbDx8vWKMztYcUvoXR92PeE2M4RLXfAZ6etbANTkLCAgUi7
38843	payment	2134	2134	1874	1	1	5254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRWrTnNyzNNxQXBGzsx5cMNczxqbA4y8oXvtprE5WqbYcdDMa
38856	payment	1397	1397	1678	1	1	14822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCKoCWZPZ83DhE7got6jdK2fsHPfKpgPWUamWsVNnj7dvMxc3
38857	payment	2133	2133	1874	1	1	4782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccFGYuPpDtefYnCEGHnRwNDSvUcCix1JKUTRL69syVpbx3zR6
38858	payment	2134	2134	1874	1	1	5258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsx996guVdATbEPTG4CF3EfAeiZYzRtSW8ByF6ptEwX58gNC6A
38873	payment	1397	1397	1678	1	1	14826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83nuKtncSi4CsZwzbVL5fYUHAoCC1bD3seVB3ET5M7R9AgrwT
38874	payment	2134	2134	1874	1	1	5262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMhoXskdVtq4mYz3MbUxgHxaT2Vh7xwV47fdfZCbGJnLu4Bzf
38875	payment	2133	2133	1874	1	1	4786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHujuAsjEbeZhgU1hi4zpZPvt3b97233CJAJdFRRzUrjzEou3
38876	payment	1397	1397	1678	1	1	14827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7DwJDvWxJtYMjKqVHBszm6WrmGa7EkSEvuGt6LSDmofmEn6V
38877	payment	2134	2134	1874	1	1	5263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2b2GSktHU2Je4Venirh3Dnh5Q7enaTawUchEGqhSdRXaAVAN
38878	payment	2133	2133	1874	1	1	4787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGt1qSVjxFNX12Wj5Av8kQsbbXJ6ibxuzJiHrPT2nhLwau6WW
38911	payment	1397	1397	1678	1	1	14836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBU8RXMqVyDcmrY3D8hnuwStYRpy54E2KGRv6gNQ31VPubVwK
38912	payment	2133	2133	1874	1	1	4796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAjcTPAYmMNafeMLppnCZ5pn9CqVw5h4qk1TjHFR3A8u3xzJm
38913	payment	2134	2134	1874	1	1	5272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjL76rR5spm8a1ynyMYRWYaoikrRx4VTEN4cguK1D2Rv2bvk24
38924	payment	1397	1397	1678	1	1	14840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRHGt8C3PBfwD62ZTviG17VQjUBAzdqKoP3WjTQiqrKe5Tb3u
38925	payment	2133	2133	1874	1	1	4800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwhqCZ9B8i1Q8gDdKBgzrmEjiS5nJhmTTdE9pLRUYEYTZsWYxS
38926	payment	2134	2134	1874	1	1	5276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCL35hzK1kNyzeF1WeW5U2XHraDe6bBW8wb1ujuuHgKSBUSCmq
38927	payment	1397	1397	1678	1	1	14841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapceHNp9DwHcCQTiPbGDBgTpYAnWdpQDy77Zwq21vDmHCZi7u
38928	payment	1397	1397	1678	1	1	14842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytGWtXXjSf3xJkAQeF3vn1LXbS6L4AiYupw56Kg4j1v7kDZGM
38929	payment	1397	1397	1678	1	1	14843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYy98nYjM8yzEarDXoHmMPmRiVj38ZMSB7qrR3ffooERdVS1W
38930	payment	2132	2132	1874	1	1	1447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUcdSfDrY5UpLu4VaA4dyC6BqJjREMEdbXoh6HVPVDmmWKiiJ
38931	payment	2133	2133	1874	1	1	4801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFiEUHBPdfV7oYvzcmGZh5fzQgX5SHxgLGPZACyCRFqGMj5hd
38932	payment	2133	2133	1874	1	1	4802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZvKFNjpSBqcPEziy2uEP1GQWg7YGevo7WV67PgVdGKwe8nhq
38933	payment	2133	2133	1874	1	1	4803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWU7E6QoUzHVN7LkMZxgnTVuGVyJzC1BGhLuBsqU6RoTLMxnQf
38934	payment	2134	2134	1874	1	1	5277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2Mbhi26ub2vXC71i9jdHeztRkRJehC2N2pmJubjaJpgTKbVN
38935	payment	2134	2134	1874	1	1	5278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2j8HC388qqfLGDfdQzKVWE3pYbbzkrAb3R9gzCqEF6hzHPaTM
38936	payment	2134	2134	1874	1	1	5279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouFBdWyDPefAGkQK7JpcNUEqNQEhnoH27VJNGfMpL4mDmKcZK
38971	payment	1397	1397	1678	1	1	14854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTo9An5KAmu8Bwf5j6kDQWgB1WycykVPUkVS4NszJJc5ic9D4
38972	payment	1397	1397	1678	1	1	14855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvstEuEKjzqSjdeeabUbTfH8HZKESqv55nA67G4vSbZDAnN1Ua
38973	payment	2132	2132	1874	1	1	1451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyU7utEAxed4fxMwj9Skk3D1ZoJSoLidhRmtgPT2n7NjUD7Aa
38974	payment	2133	2133	1874	1	1	4814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZRBgzSy6pTUKQxVee5S2xJSW7Qy8Kv92a4j879dEM98Ws2mz
38975	payment	2134	2134	1874	1	1	5290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3q3Gghkix1B62YqUhdP8hzB9N7ZLm7DpkTx8MG5qMenPcYj7z
38976	payment	2134	2134	1874	1	1	5291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SViHAVRKbmxrfUvN4DzjL6udEy5GtdQW5tVvrYki33UWWe2K
38977	payment	2133	2133	1874	1	1	4815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xUN2mDbZeqq7TjGXYzZMwYxL4dDseNzw4oSNk8qYuVLr7G33
38992	payment	1397	1397	1678	1	1	14860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdub1AWTCCxSku1mbv9o5M2nQvuHmvY5tnsReS5tcpajWGzK7
38993	payment	2133	2133	1874	1	1	4820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKNHrCoAeDUh2ALd1ihrWiPfE47vMu1Eq63Cfh8Zw9rq3df2o
38994	payment	2134	2134	1874	1	1	5296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5SrBW4685KFkr65GA6i8tSHYMDtybLzXpsXE5GscD7WHhszZ
39015	payment	1397	1397	1678	1	1	14866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesiupAen6dyyZJ1Ntz8WCPTE1gHcMsF9ak154hMAmDRWGMBde
38910	payment	2133	2133	1874	1	1	4795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPKQLf7YqZ68p1e5UfqyRUXBStGA3x92ZcWVxUcsPxB29tfrE
38917	payment	1397	1397	1678	1	1	14838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJugtCpYrQcDYFCWBywPFH1jWWcWCBbyGPc6wBzXYvc58DyJ6Y
38918	payment	1397	1397	1678	1	1	14839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkMsMZKha8sbnJkHwQkYGhd4K7sH794d7fD7m8R6aSrC8g1BE
38919	payment	2134	2134	1874	1	1	5274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUvZ9BzfCDPFNAoz9MNcERL5HXNTWzNdJdo3cJmVSNS8vN4Wf
38920	payment	2134	2134	1874	1	1	5275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfXauRcVEJH8m8fHXeYTicEX1yqDU9cJsD79Pi6qkyErvTDQR
38921	payment	2132	2132	1874	1	1	1446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzagmyMrps72DkDa5MZFBLrFhkkg2fShWGztnYWBzzWYUmycp7
38922	payment	2133	2133	1874	1	1	4798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNPh5CDXszzV8umq76az3n24j5FvjRgMKfCk3B6xkGbtTETUz
38923	payment	2133	2133	1874	1	1	4799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwy14sMqCNq2sd33dt7qTRjBpBuTBJfy3SA8nU3WWcBKvLrEzx
38947	payment	1397	1397	1678	1	1	14847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuk1paiTDuJLemuG8cEs5fvbwfDSdewv9nUqQMuG1Ur1gkJHb
38948	payment	2133	2133	1874	1	1	4807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydmLtDWJneh61D75xRYabHfada8M8NCJKZr3vz9R7BzvyArZn
38949	payment	2134	2134	1874	1	1	5283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpjzNvSTHeqDQ3KZKhz5sGSCCqFkjHSZYi6zVbbpy4TuFVrfn
38954	payment	1397	1397	1678	1	1	14849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAef8cSXC6tWBKkRoDxSdBcbvRsMqiLhK8mEx5Jf2D8LdhBRU
38955	payment	1397	1397	1678	1	1	14850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqmEF3ipuaNMUNrSdzpjX1n2aqkD9jFD4wTD1VqtQEwq7pTLr
38956	payment	1397	1397	1678	1	1	14851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHU6ChVCSvt6xaPo7NBRutk7JBFwfbKuzNRBmZoZJrjqMyBww
38957	payment	1860	1860	2152	1	1	4	67000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufzYaxMv9w8wtTcXzNL2HzTzXZXK3u4VD387BQbrb8QP6KJ8F
38958	payment	2133	2133	1874	1	1	4809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3ySaQno2yZSj4KMYnHNDgy3fVErGxf1TcExj6yisKSS7GVBQ
38959	payment	2133	2133	1874	1	1	4810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsnKbgFa1XpemGgYHeoToyTjyZx4574KipXggV5ajrFNWN3Ng
38960	payment	2133	2133	1874	1	1	4811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBSTb7rrtaxf8N3WZuLvnXZwAbva3A5cdrvLpf6NeUj5UrbcY
38961	payment	2134	2134	1874	1	1	5285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFvQiNMKtrm1YJ92TfqTUYen7JXtVg1xaRu12CCPsNPM6TwT8
38962	payment	2134	2134	1874	1	1	5286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeqPeL78A3r3T6pgJ9yMUDwrzE5BfzTjWKvRh1h8kDHEgsfRV
38963	payment	2134	2134	1874	1	1	5287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhYMunL3hWvzeCjoUTyjTYTMyUZc4n2m2Xhs6ntGZW4YYd1wg
38978	payment	441	441	2314	1	1	1	122000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ6JiUWqTCHAJq4KQNb9UvpfdtrxpU1PB8VJLSXNwFNh7XMPL
38979	payment	1397	1397	1678	1	1	14856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTPNcZWJu9K3pAXCJumcmHpviszFq4tkchwocPx4GfUK1BzgW
38980	payment	2134	2134	1874	1	1	5292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeE8KWG4GVa8pRuqTg4x1K9ovgToRnHBR1AueFtLo83qU6yVn7
38981	payment	2133	2133	1874	1	1	4816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87gTVdenAKhgDpcmDDmRDwqMEM6WYBHjdAS2yFXnkpA3jw1Td
38985	payment	1397	1397	1678	1	1	14858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrHwqyFJoFJU8igdo7K7JA3z3PeDtj4QrMEReijZb4zkhUk5s
38986	payment	1397	1397	1678	1	1	14859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGyTMkmqLT9KkjuqSppZVuDLNi6z78TYfuQCXqx56ZkDe5Yf5
38987	payment	2134	2134	1874	1	1	5294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSczjG7BkQYSjnsQgVS3ku3sCmTUgocH6X2wn1M4mMdcjnFpfx
38988	payment	2134	2134	1874	1	1	5295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKGQ6M9VuX2KFXZgdobcfYDjRKJZXDa68tYZswkkgxoDr4qiQ
38989	payment	2132	2132	1874	1	1	1452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rfBQxd1mmCohTWqZtJ12MGJSAyHCyMgm571PBZcoF3GNbNoG
38990	payment	2133	2133	1874	1	1	4818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPho6twyPFz3LY749NtTsTSTKJj7jYyZgLcqZhXrpxJ6okx4u
38991	payment	2133	2133	1874	1	1	4819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE69499C9oZJzqJKtdAs6DLUhH996MRArgsob7Sv7ahgtbdftR
39010	payment	1397	1397	1678	1	1	14865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsYcKrb4ESDuoxLEo3mAnUdbJzM2GSzA68gUdaGf8FPXasTm8
39011	payment	2134	2134	1874	1	1	5301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7ywA5AbhepdJ1ePVV4QXCJAD7KskFiruw2GtA9v2D2JVuVQF
39012	payment	1769	1769	1769	1	1	56	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWa7TV32nWvyZFQBfgKLvNMckEXrCxjFDjF3zyjV4HyJrQiRkV
39013	payment	2132	2132	1874	1	1	1454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82h8US2g9JcdFXrvRr7fvCwAJwmQZHa2AQCdPYgunqsVGu3tW
39014	payment	2133	2133	1874	1	1	4825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENQt9Pgwd5f6dg2xET5YwbVFp5Xr3n5ttZ4MTLp1YX52wecKZ
39018	payment	1397	1397	1678	1	1	14867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRusxmt1Ep4Mrduhpmpo4zGQgcRgcALS1AjupHwKiqfJ7qtBAn
38942	payment	2134	2134	1874	1	1	5281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoShA6uCuTNX62nyiaxc73BGqf6yBNWZL7E1CCHpufTwDcWJX
38943	payment	2133	2133	1874	1	1	4805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh16T9Et4SdmAH8MsvYYhjmLiGZPLoiWT37nuUo5JftmEWG5T
38950	payment	1397	1397	1678	1	1	14848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7db8R3wHcPdeNob6UZc8vEiVzPQ1zEbGJE1pJaFF9EbzKQ3y
38951	payment	2134	2134	1874	1	1	5284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGLNupCSnRAUkJ5QaEG33xFzxqARbTuuXxoPhGNtDZ5KsWA22
38952	payment	2132	2132	1874	1	1	1449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43hkb6W8NY9z6XBn5iEL1uwWJoQvPpepCMfHGQvcdLbgDNfZm
38953	payment	2133	2133	1874	1	1	4808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZB4QXQSvvLLgrPA6Cs2hRibxuaFEgRbAttQ9MJXjsdpDLiex
38964	payment	1397	1397	1678	1	1	14852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLNQ2mxmXnoX3ncAdsNFZrArpHvovwF1uG1526rmkiVDEtRET
38965	payment	1397	1397	1678	1	1	14853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcgosZuHnBeThD8CTgMJWj8KdT7cUGNyDo5wF55KDqFBfgcuP
38966	payment	2132	2132	1874	1	1	1450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c8oY67kVaymZ9nJKvqbYaM8NMuXRYVzs5HQWtnnxsvxsSYno
38967	payment	2134	2134	1874	1	1	5288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jkYdy7h3FB6mbQp791csrn6zmQNbke9bQgz1JnXWe4eBgQwK
38968	payment	2133	2133	1874	1	1	4812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbY1NsBu7fmJrXaDhKSgWoWMMGCBXUiJ6VXGy7sxqjetiay3P
38969	payment	2133	2133	1874	1	1	4813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWhfJSRXzbGM4c4LeBhy2CnwUdYLB9jJkGPiSa4geQEo94zef
38970	payment	2134	2134	1874	1	1	5289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fDFmBjhnCmSd9cvaym4k2k7ceV7kc9DJ6ub2yCWB8Yzj9ho2
38982	payment	1397	1397	1678	1	1	14857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiiWKZ36d3BsLSEp5S1qxLKY4ULccX9t3XqNzSsat21r3U61V
38983	payment	2134	2134	1874	1	1	5293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAbFo3hR1WakAPsUU4Ke4ZpR85sKX2ffBZnVzxYqHZ4VCkPHr
38984	payment	2133	2133	1874	1	1	4817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiBd6W2qVrp7VNYcZXwuh1d812ZUd2azYZQ5JNHg65nkv6K1u
39032	payment	1397	1397	1678	1	1	14870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxx7jkHknQGxJWmPPpLZHdhucNCqZWRCTad1nTjvKWz47r8Ag8
39033	payment	2134	2134	1874	1	1	5307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYmhkGK9RAo5pjmK1SAkZpqYhcaMQ7XJaKY7yQS1GYZvGixGz
39034	payment	2133	2133	1874	1	1	4831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwm9bew8hbsXWDRbuKWB75eGeY73jjovLENd51emAzmxXb95Ti
39061	payment	1397	1397	1678	1	1	14879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Dqp7pySRGndtxGXsa4xTDir32zehWYNQUuGsCdoPVGnPN8BF
39062	payment	2133	2133	1874	1	1	4839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvgmsfcYMShh2CfRUPfJbcFMvaFkg4tX852iJFyJwLGLsmF2J
39063	payment	2134	2134	1874	1	1	5315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q1uKWaFNCdkJpUzxs7SgLngfY7bvjhU6fvpibmFd5fZdoD67
39105	payment	1397	1397	1678	1	1	14892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqfSmfRZBWzrBQCRFKENPgmzctet4Dy8X18dn2sDoLYNoisez
39106	payment	2133	2133	1874	1	1	4852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXKgLKVMcRGGQya8bmXGBFJG8fVsBQLZsf59ZX1SnvcSR75Tk
39107	payment	2134	2134	1874	1	1	5328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqbgktvkdKrRx51yAYSJUX4SNo3JRU8aouni1C5DeyW4n6Wzg
39138	payment	1397	1397	1678	1	1	14902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcq4jxCQbhHd3LEySaRnHHuQxjgpUevY94At5rgBDVdrJHXkL8
39139	payment	2133	2133	1874	1	1	4862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD2hcbghLwcaTUZqtRxDN8ZXXeNkuSALLydtb1WwveRGmtR31
39140	payment	2134	2134	1874	1	1	5338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLQwLdbBF9dUAMBK7NywRMAVr1HdV3JUDopp4FLbVUWQ1Y2GW
39141	payment	1397	1397	1678	1	1	14903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXqjWjTk2PZBprE8t2r24fQTVcsDmpxYDDwqEPAtUoVqtKN6v
39142	payment	2134	2134	1874	1	1	5339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMaK2u7PNnFYymk2tU1WnxPFYZPCL8ofK5HZvnHxNqt4FpgMY
39143	payment	2133	2133	1874	1	1	4863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrLNY5RUFZa9Uqmm9vF9FRQoURsomfa52sJwBZ5GbcVyNnwye
39148	payment	1397	1397	1678	1	1	14905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcXnkYin3KX48cCeL6su6xdRrS8rMhrwGbULD33TSaTM1xexr
39149	payment	1397	1397	1678	1	1	14906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGC98H5UmRh7NXc63jMWuPUVBdtBqrzyfizG2TbN7zDPdGiEZ
39150	payment	2134	2134	1874	1	1	5341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1CqVTCQgVG84tyRnVCncrMX4baiMAXqTDVz8ivuQm1AsEgEE
39151	payment	2134	2134	1874	1	1	5342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSA8MTcYzZKoiqLP22gFaRUKk3rT7mZpkbW1kokAi2z3TPFdP
39152	payment	2133	2133	1874	1	1	4865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPqchSjFxoHzaG7hf7r9YrJWAR2qXNe1UvgzZYqX5fydJzCLu
39153	payment	2133	2133	1874	1	1	4866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSawytbxnnaobTH6XKo4sBJLBmRXcpkbZXJuZY4kdMeCBFkik
39174	payment	1397	1397	1678	1	1	14913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL9tw1u8WpxxRgZJjPVMEkEmx3UkaTartJg9qjDsxQuMVpyy8
39006	payment	2133	2133	1874	1	1	4824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLCFFEWCFuKSC81aXLBcjkRTxAfcDCpmV8d4VMAZta6HcbiiS
39007	payment	1769	1769	44	1	1	55	1200000	1000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpZoggFwpjR4CNxhpDkgtUugY1km8n4HYV7qMPZT5u2maiPhuHh9
39008	payment	2134	2134	1874	1	1	5299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWAVm11Ky3moqV5Sz6n4NLTqJqywKAT9XYQLDBU5LWAcedeY5
39009	payment	2134	2134	1874	1	1	5300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBSnafsBrrRFqhRsR45NbUhQJ49BSHqPmXVCZaie2RZzTfaHV
39035	payment	1397	1397	1678	1	1	14871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g2vMgPZVjmpksgbTGKtQqRBg9TfrFz4vxZkP3fBhMqv8CXb6
39036	payment	2134	2134	1874	1	1	5308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3rNod7w9Qrqrk96WJvg3tJLiABHfzKfX5h1CyGRidWkKeKZ2
39037	payment	2133	2133	1874	1	1	4832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJroyWKyEaULdu9v6GhFZETWE3CEdDrbsejX21bN6hjYJvWBTk
39038	payment	2132	2132	1874	1	1	1456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbv7yzXvR6K9ABnZmQZniJfNH68SUtRzNARz9fbpBo4Vb4jsuV
39045	payment	238	238	2315	1	1	5	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAe5N8by9gemENkZ3Ea4kVsbKuLkGCriZSwtbajQejABfzCRm
39046	payment	1397	1397	1678	1	1	14874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9sE2fhTjzbszfXjy5BiDdKXMt36a4253csc1vPGKTfc4SkAd
39047	payment	2132	2132	1874	1	1	1457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkbJiSDSxyy1VEpZxQestj8pavoqrqMzz6trybSqjXbWHbyfY
39048	payment	2133	2133	1874	1	1	4835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5C749EvrfKzxSqUfSb1gVuhswAdLWfpnZX4hkg7zWPjUBvEd
39049	payment	1397	1397	1678	1	1	14875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknGWarohK3bXKYX7W1CqdUwn6gBswcQNRChMWXM1JmWD5tnCZ
39050	payment	2133	2133	1874	1	1	4836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6gzUnPrvVHztUqDX87wWDUkZ44pRL4jqGU4UWyN6TwpHmjPw
39051	payment	2134	2134	1874	1	1	5311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiy5iiBCrnjepCdo9oHfZx1yKhhk5avV2WHkeg6sWM7FXyF7md
39058	payment	1397	1397	1678	1	1	14878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznxfc2S3ifimFjgyAcoRVWyQJPhnsN6hyCXysd18EY2uuCJLj
39059	payment	2133	2133	1874	1	1	4838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFwb1U194K9ZYsX93K1qWa3NGk6ipakvBKo8dJfbQd4Kpdu31
39060	payment	2134	2134	1874	1	1	5314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4rB5AzEZ5r55FRDmcjsiLfDppz27RaxZeqLwSAKArJJxwdKa
39072	payment	1397	1397	1678	1	1	14882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfWuyRvbRTsFDis5HuBgQS3jLQtYGf312gowUx5JniR74zVbv
39073	payment	2134	2134	1874	1	1	5318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiuxH2cKGhqFZGrs5vG2XkWgLMvLXJZNhGpwnuqr1tfToUrSW
39074	payment	2133	2133	1874	1	1	4842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncy7zfsQMeLWAbCW6QbxjU61csrjoNvZ8NiY9GAnVNn8My3fi
39078	payment	1397	1397	1678	1	1	14884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnBExoxP9hsiAiscyfCbcpWnjD1ZmsR6ebJdt2ioEh1wu1GQf
39079	payment	2134	2134	1874	1	1	5320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2pvdzNPp1sihBeaX7H6L2x4tySmECDyYQHCEUbrpq2xUSba3
39080	payment	2133	2133	1874	1	1	4844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumPKdyx2f6BzpeT8bWLxk54kAh3PebtP7Khq4txyq6f5kWzLg
39081	payment	2132	2132	1874	1	1	1460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPkuiFfp63pSES4Des56V2L7qGVTLQwK5h3yx7Dh9JeA3ZKcm
39092	payment	1397	1397	1678	1	1	14888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7zUwb9LW3ioJReJ1GpCUi2V8zQjW8FTbTv2BRKeYcd2SpTeK
39093	payment	1397	1397	1678	1	1	14889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxC84kJtTMQE4Wu3kb9gSwj9RvtacimzQ4K4yx3m5qYTDFWir
39094	payment	2134	2134	1874	1	1	5324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZZSNk7SXeUcn29Fcu7ieSVTZMzVNbKaKw4jTyzxTiQ3cpdNh
39095	payment	2134	2134	1874	1	1	5325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKVmGarhgZcUacjX9ePdRYyorqasQNFqUSvPb57tg7AhQQCSq
39096	payment	2133	2133	1874	1	1	4848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdmW6oCJSH3BHUJ1iRZTg9MxMUHJKNt66Rs81oGAtujtzL8D6
39097	payment	2133	2133	1874	1	1	4849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqh4JWqiU8uEmjWH1gDpEvyqmkxRBNLZckpJXkRFpSftapKew6
39108	payment	1397	1397	1678	1	1	14893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCvaMrtRYmjkFbDDeFGSQxHcA5Wq1KZJvpnSCradXpMj2eDYB
39109	payment	2134	2134	1874	1	1	5329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRBs3o1hbvK47s8LMsv4KDBQwqndCY5CNgXNgowjz4w8dgVab
39110	payment	2133	2133	1874	1	1	4853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6qtG2prx31wvUX9kMgXuKhcNH2cmjm153vpVWwgEDaCJJ1C7
39118	payment	1397	1397	1678	1	1	14896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Fr7qxrSiKNW1nS8gQcrUqx5Qxnu1wScR9WC43Lc7vaZxhjU2
39119	payment	2134	2134	1874	1	1	5332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6s4CxmnsZm8s4JSC2CasW8vTbNtcNMGfHfKVAajiH6CUZAVJ
39120	payment	2133	2133	1874	1	1	4856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWnfgqAe6PfWgrTgq9RgooFqmKUX41wTY5YazCMLqXZN2AXRb
39125	payment	1397	1397	1678	1	1	14898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3beuiBo457JHTJj3fsC2hvTVLsY97fxKwANR5WRw3UyKscTHP
39016	payment	2134	2134	1874	1	1	5302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdsXKJAcHgugdZVRQPzfGV9jsJJwXT5EyTtqiyW2tUoBx1Lfi
39017	payment	2133	2133	1874	1	1	4826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcvemkP94pcVtUAmJvQZzkNsTP8JdrF2yaoPATQCdYiBNAgYP
39039	payment	1397	1397	1678	1	1	14872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLShaKaEP3hCAzWn8Q75Agae3UUJVrtooXateJdgqebjJWmssj
39040	payment	2133	2133	1874	1	1	4833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfTnqWWrZpNYAbLLNZ4toUHLRg8CWGcmuZKCRTn4DzZ6d7cZd
39041	payment	2134	2134	1874	1	1	5309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3PsRJg5Qibd5V3CNP8ngQYMYjap9TxBQjD9Y8oyX1fNLuSuo
39042	payment	1397	1397	1678	1	1	14873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79mpMsWAM9HdDYRv44y59ZBd2m2wqYz6kjqdR1dkJQwXAfWmC
39043	payment	2133	2133	1874	1	1	4834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLk5oDmXfXqBavBHKooDWQB4aDnpu53vQ16G4xfezkMmAJWJw
39044	payment	2134	2134	1874	1	1	5310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLw7rwfiZDeCkwWyDmPkGppoVqJxsfnkxaZeM8ztS7p7V93z1
39052	payment	1397	1397	1678	1	1	14876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrCYdJzpkZvSZHCujgv7JDJFYw2vEZai1wmp9bVGNNf45JLVv
39053	payment	2133	2133	1874	1	1	4837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiphnkUv6HHguCWP7UtJsd7YEPVabkZo9ScmNau92EH1YrbwUq
39054	payment	2134	2134	1874	1	1	5312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfVGJbE81Ty6EBvsndnQjAQZKb3STUt8txjd6qkr5Z9Rxcstq
39055	payment	1397	1397	1678	1	1	14877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXBYWsQhtkjD5KcazCeuxqVhwPAUxybhXcSboA6z5haHu7h3D
39056	payment	2132	2132	1874	1	1	1458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZJLH48VzpdQGbt96stk5mhB1ceeMRpHjcvpWCZZ4RWFxfSCp
39057	payment	2134	2134	1874	1	1	5313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCmkoztNvHrwp6yrXNVHbAoxz7EgHZDArfiSNLyemUru9pe4v
39075	payment	1397	1397	1678	1	1	14883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrL6uTT99G4zfajJeHqanJePVNM5SDYgA1SopvdoeZCAwuNB7
39076	payment	2134	2134	1874	1	1	5319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguUvNNuRVDwicH4HDSxRaZ9oj7JbNbcBmJrxfSFDaPpNwqpDq
39077	payment	2133	2133	1874	1	1	4843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiWKSytWHQQWSVMs4kbcgvgP9k1isvbgbEFoRhdXi8XjPz7Xy
39088	payment	1397	1397	1678	1	1	14887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizivFAYmSAaocWzGFfbsGqUaabbfstyF8qmoPjSxm5ib5Huux
39089	payment	2134	2134	1874	1	1	5323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULwaff5uMjxZqJT79aL9wihKXCw3mCzjyaDQtGWe9YodkDBcb
39090	payment	2132	2132	1874	1	1	1461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CgrkLsRDPntZAYoSxi43xArnbviUVAW8M4SKvfhMhULjtSDE
39091	payment	2133	2133	1874	1	1	4847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3sRCpcYAvUBqXc4AttLYNhdBJ4gKeoc1PjD1Mj1k324khrS6
39098	payment	1397	1397	1678	1	1	14890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFQd9gXd5yGJDbG132nQ22CqAMfKdnjaP1AnaGNnq3Tdee4Xh
39099	payment	2133	2133	1874	1	1	4850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9MagoemDDtS9a6VhHT99u19bAXjPhgNTu68GtXYFASxUuw3h
39100	payment	2134	2134	1874	1	1	5326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVEzL2sALxwxzTjy8YdP2hoNAptjcayXZmRfnLGrDSsti2P8L
39101	payment	1397	1397	1678	1	1	14891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCnbBeG34hg3yDxTHuFUoPHzm8itAK2ZP2NR2pxkZQNBwBb5i
39102	payment	2134	2134	1874	1	1	5327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4HEjEzx6HL3cegdpjMtNfRNhsZwZuQh3bp7Jsecgmg85eC8E
39103	payment	2133	2133	1874	1	1	4851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JNd7QpAq34ztswfQ29tXKmPtLrzRDaiCjPjRJcSRd3h26vbE
39104	payment	2132	2132	1874	1	1	1462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRhrS9dG1FVhk8TgCYeyVsyZrKZg7w4DXMZ7QEW53qLoSQQ2J
39128	payment	1397	1397	1678	1	1	14899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJz6kmN95gxWZcCaujoeFjHnvj5rVayACeQsiEpDUdwjSovk
39129	payment	1397	1397	1678	1	1	14900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYsepZ1whr4hBrYw9sZZMTejEWPDMJhzERH1rSMXxXKVxWq8i
39130	payment	2134	2134	1874	1	1	5335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdvzcUaY5EbpHFMhAMAMFJnBNGMs2do3CfgiviLWfrYk3FsH2
39131	payment	2134	2134	1874	1	1	5336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3qatcsT14GbMYdbNmjdcW2EQKXSBji6JPbRTT6YXr4ptRzHp
39132	payment	2133	2133	1874	1	1	4859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WCJBmCuF9XhFUHB96AeHuNG7UsUaGCSzyk18TSTCu53Mk6XV
39133	payment	2133	2133	1874	1	1	4860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEUiebLKVcUUcajib8apJQBPvtEunxWroSeJR7vGuUzJsPZ88
39144	payment	1397	1397	1678	1	1	14904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJntWH2MV35KntKnD7K5HnAELRL1R9iqygn3W8fDjHUxvBuyH
39145	payment	2134	2134	1874	1	1	5340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoS1rDW6B5FEq21SCdXz2vnNpg29hKs1Wx1eC8dS17fcHN1Fu
39146	payment	2133	2133	1874	1	1	4864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceeYm6sopX97j34Nx7o6yuEvNj3765Rs2rY5XnLJcucEmC9xo
39147	payment	2132	2132	1874	1	1	1466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLwArU61teCW5XQGCP9BrEfoPLBLA4d6rwmpbJiQNa95REJHU
39019	payment	238	238	2315	1	1	4	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFEPzmgCrgMu3xC61HxmjSydAktrMT2zAPvazbS3xm5twRWdb
39020	payment	1397	1397	1678	1	1	14868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmVetoViJbzXoVXPjJ8vMuaJw5Kuic3gRLHdbB4dbHhnFUN5o
39021	payment	1397	1397	1678	1	1	14869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5gjhE6q523g2jibbgbfFjTFT2YMN1CnqHbvkqnfAyxG3HNsg
39022	payment	2134	2134	1874	1	1	5303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAiv9TjD3XPwNKiGZeHY5yhCP4TUoQjdPq2PaTYbQA2QkqS8N
39023	delegation	1769	1769	1406	1	1	57	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63U4dZUQFAA6KLbCzLY1WcDVHwv2EcyGuh3sD9HxASjaDwvmH
39024	payment	2132	2132	1874	1	1	1455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CGWqaMiNoi7t2YKo4ME3v9qAkqF8u5uCksBn3mbxYaD6b7QU
39025	payment	2133	2133	1874	1	1	4827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HuBd79qPjKV5CussApmTSUDV77JxZyaawaPmLiQSB6PWS1iH
39026	payment	2133	2133	1874	1	1	4828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswYXnAqACoLFKFkUGmVcxLTpuvCEVC7qQydMEwoLahK5Wbda8
39027	payment	2133	2133	1874	1	1	4829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnE2UJPMgCDUtWN9gYkrjUwjsFQRCAT8nzzUGyHAmgRd8xy5xj
39028	payment	2133	2133	1874	1	1	4830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPMDC6PP6GVYSfNsWfEKdHzpRd66Bn52rabn83Vdgt9ugST44
39029	payment	2134	2134	1874	1	1	5304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCvNqRvDPESA7wBdL1P2EQYB65pF45cxThQ8dL2cx4PgA1sss
39030	payment	2134	2134	1874	1	1	5305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhe2xFxj6niguSEtFxCpw9ih9QSUKmaVHQhJVHKCdBVHXS2DiP
39031	payment	2134	2134	1874	1	1	5306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnVQUdiMNdVPiHZJXsgWhCAUDFTxmuyp8JERD3853sA77FHRC
39064	payment	1397	1397	1678	1	1	14880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YxzSeArYDKCUhLEkSjPGXmbnRcNW3ucipBy1PMCt71qWnpR8
39065	payment	1397	1397	1678	1	1	14881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGY4TS1eNNnVRz87y4gaRkTfsD4epKSydwt9SQXKaRGfD3Cvw
39066	payment	2133	2133	1874	1	1	4840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJMiywiYHUE81Ndy3LbgMfAdyS5Nc48hPSYoPgN73yqj2aMPL
39067	payment	2132	2132	1874	1	1	1459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7jT5adyFkSLe5yA5QiJrXF1osikXGrXD7G5YLBByHSESXjHf
39068	payment	2133	2133	1874	1	1	4841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGgkqsLQUu9KZYtsxkxHg6ZhGeL9aXFLES8BLX5c2Vdht5ws2
39069	payment	1769	1769	1769	1	1	58	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ9pQgM4TRCieNPjUagpAN2NkvygNjMEJCRfTvWXfCZZJyCxV
39070	payment	2134	2134	1874	1	1	5316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSC3iemrZeGGh8DqAbaN3ssBsLdUoQzPBsv978oU8KshXPQUc
39071	payment	2134	2134	1874	1	1	5317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DB9LndpRtoe74TQwkFbT2SUccdp2QbBB14hzCVWnj6GwUm4V
39082	payment	1397	1397	1678	1	1	14885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyvwnagKB1HAMcnYVwy2ztjGVoynpkXwMu3qWKzSTPdoPDg8Q
39083	payment	1397	1397	1678	1	1	14886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDhbZUuP49sSHzfMZWqYeHZ1uACEweMPkVBYTbKks2ZvnNsb1
39084	payment	2133	2133	1874	1	1	4845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSmsptUHrHJ8rdRBnuPc7U4giUGaoBD86xcBR6oWk1iwRDsz9
39085	payment	2133	2133	1874	1	1	4846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbohNA1zRu2hRE6UXC2ihsLkqmxWrBZqs8tJRMqCQwJW3BAQJs
39086	payment	2134	2134	1874	1	1	5321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8Nu1tiHaLq2uvKSBQj5Fi3TJdpPPfTZTaWCRciYniySpFSyq
39087	payment	2134	2134	1874	1	1	5322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgrZJGHgPWmHuoB3iyD5g2hhE76x7Tf6jvhi16FJh7z3FRBmp
39111	payment	1397	1397	1678	1	1	14894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBQRc1iTeNX6Bz2kcbWnJKCjLhfLCYpzpB459KmLpwaXN3suy
39112	payment	2133	2133	1874	1	1	4854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrU7sPrAb1eepGprejPCiNVNnGzgmng2LRFoVzqyUP8oVyYK1
39113	payment	2132	2132	1874	1	1	1463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct2SLfaobUZNLfS8xBKFHRNBfXnfJ1avtrhST7AK1BwZXDstM
39114	payment	2134	2134	1874	1	1	5330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikQyvTBYhVvbTopaybHbrRxtW9QAxydLRRMUbGBqimPwxfv3G
39115	payment	1397	1397	1678	1	1	14895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtcMgBqXJ8WfjtaQdGFjmoFeREzDWhT92i1WpSNRKBPzzi14K
39116	payment	2133	2133	1874	1	1	4855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjYWCzYirxm4da2rypd4i3PAzQDR6CB1soK3TwWFV8x7o9dAx
39117	payment	2134	2134	1874	1	1	5331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpUjV2u1s6jGrzTSNTgezKvZXY4o5HMKcJvha5qpNgwQiRr1J
39121	payment	1397	1397	1678	1	1	14897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdN2RhAC5LcQpKLj13VEQkWAsommXPb7Mu4hPYh2G1CvKuWjd
39122	payment	2133	2133	1874	1	1	4857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFQmatMfCBTSPbSb2JCzQt5yAcW7g1GTdwZ5FSKdKGDJjchPu
39123	payment	2134	2134	1874	1	1	5333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJjZgPA8hvdair6gYyLbUFkv5AfV24Lt4f1yfhiKHdMLY2Lgs
39124	payment	2132	2132	1874	1	1	1464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD1GiAionweXJ4iU8U5HxrPXwipRViJDcxPUpcYa7ZHcEhDXw
39126	payment	2134	2134	1874	1	1	5334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWnePwu7tcLjgGknUn3hAX1RxG67auWUUbfzutfDxR4M76NA8
39127	payment	2133	2133	1874	1	1	4858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpFJ4TnsQ9LTC6LgAu6zGXaQfR8RU1oQ96skXnEqjYkf1ALzT
39154	payment	1397	1397	1678	1	1	14907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykvb1Qbd7Zn8qvmX7HL7BuL3gFWrJFsLoGMmMGEkJtGKxKz85
39155	payment	2133	2133	1874	1	1	4867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjwvBXL55n124ooxT4TedEzSJ4vzB7QfLvtTBpjiHBzmcKz4C
39156	payment	2134	2134	1874	1	1	5343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rbqLUaFdym1zCckPfaUGkf1UDTERrViUgDCu5wJsea4VfGyb
39164	payment	1397	1397	1678	1	1	14910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6YhNX8vTMFTwzKryRQfVJttBuGdruxEeFtbZ3BGXGXxGTssy
39165	payment	2133	2133	1874	1	1	4870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSH8kZ5oGFC7CHm8kTTSkEWLGaffvE4gnxom5zuXdxFR1jdnoi
39166	payment	2134	2134	1874	1	1	5346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2T6FDrZtRAYSrJqJfhnGK7h11SYVbQ7xLcfLpXidKojkhz9N
39167	payment	1397	1397	1678	1	1	14911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZB2nRSHvmx2z3WfAmZwiaYw3t5yv8ACBhDKM5S34F6ojce2h
39168	payment	2134	2134	1874	1	1	5347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUEjN5AX9HsJPDy5JSXWu5NR6okAFhgvyQMMpgCXdnZWFJSaJ
39169	payment	2132	2132	1874	1	1	1468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeq4suDgJJDUt54xzUgCkcTtEtyP98QGZDQfMztdUjagLsD9Yi
39170	payment	2133	2133	1874	1	1	4871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeQ5bJYhakEdUkXw6pV8bHEfQUHAM9WUzS5Y8FwQiWgE513zJ
39188	payment	1397	1397	1678	1	1	14917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6o8qj8RPGVfApSDevKHYy4qVFg3VY4Ra5qyPSK5bgeeGVsTt
39189	payment	1397	1397	1678	1	1	14918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j3ZHTrYxisNHy9TEsv79ikQDD1qUvYqc7i31AVHxYHxkztCJ
39190	payment	1397	1397	1678	1	1	14919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGs3jjB5XRWY7y57MbpKf8mWM27gTNd9zx6NwEw76MqGwkYtWn
39191	payment	2133	2133	1874	1	1	4877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5jvTfe6jvCMJPaGFZXETTMsboApQbJbCw8MGCEZp63qoLM8P
39192	payment	2132	2132	1874	1	1	1470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuFMebgvQoL2garwAQAW9J5FcDd6QxW7kLfSTEdAsHXNzg8E2h
39193	payment	2133	2133	1874	1	1	4878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUhoAe3FfrcNgxiyr7VkQaYeFLkjBdnLQpt4zaAvskdxNkZV7
39194	payment	2133	2133	1874	1	1	4879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSZjraKuLHMAgYpBnzhNw6gZME4Cr3YRAXGcCykP5CyTU52Xa
39195	payment	2134	2134	1874	1	1	5353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jhfKCQ5ZBkGVxUhj9bvqyRt5a2DzKcGjpceAYGzkLxK1L7CM
39196	payment	2134	2134	1874	1	1	5354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZWVWBMT4TqkeMNEa74FUNwRLuoyfnuMrE4HZ6yTrSZjNVZht
39197	payment	2134	2134	1874	1	1	5355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQc22djk2g8mM8ZypX7NvRkGVxrhfiqj48Eth5pjNztjpPwVA7
39218	payment	1397	1397	1678	1	1	14926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQicC3U7LaYsc2xBPbrKZESN4xnMTbJRU75RQcbJh56XzXNyf
39219	payment	2134	2134	1874	1	1	5362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekziotsgGb6YvkWS2nYffpC23bPZsB8b25ZTDHwDepFx7fGoC
39220	payment	2133	2133	1874	1	1	4886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDAjsUUZzGFDkpht6LJDFhsaVEHUBGUacKZmDa8j9R6oiRQbr
39239	payment	1397	1397	1678	1	1	14932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fUoGZLxSREz9LNiw7enUsWoSAyi8Bt42oRagCEnJA4HdpQJ
39240	payment	1397	1397	1678	1	1	14933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ybUKRpm4eCmMEwfPLUWKb7aMTUGJj3nc9dXrMpNi6xFPmsPx
39241	payment	1397	1397	1678	1	1	14934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfVCKnsGpDvU9JqC5T4sAmJGNe7dzyc8g8aXVvmHnQrdEmKVx
39242	payment	2132	2132	1874	1	1	1475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFmS93kKjajNJWuj7PJb2x3Xq4SqSGSxyQuaAvSdTFq2B6E41
39243	payment	2133	2133	1874	1	1	4892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9EqGp1159wYu1G7Sf3P1hyW2Hv6kh5K3izPQYrjgZtPngwfa
39244	payment	2133	2133	1874	1	1	4893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5L7YKnqaXUt1p9fJc2WAs82d2pVQWiwK17kfNQ9dmBaLmVqLv
39245	payment	2133	2133	1874	1	1	4894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgEWMtxYF2cN2oGewXRe65Fc1dfYx3sprYXddhqdDrY8J36ru
39246	payment	2134	2134	1874	1	1	5368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjWXuf7i9tQvHPZkFRL1hyrjrfXuMZnHResiBuNe5M9Qxrz1C
39247	payment	2134	2134	1874	1	1	5369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo66YWZjrjDM37TYZ66uPjEcmrAT3czPAfeps6XHp2L1HtuNPQ
39248	payment	2134	2134	1874	1	1	5370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HZkzXqCtj8jPwvmJfJLSeZv2eUBH9287ADhnv2J9fBE1RXYJ
39249	payment	1397	1397	1678	1	1	14935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LuJtVZVjAqDJ8RUK5vXdwyRtF7ViT2VVSwiStWsc1y3FYR1J
39250	payment	2133	2133	1874	1	1	4895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9by58hs8uVFWef7AbRCcfGELAgrXwAare8wYg5WPCRvcoww6
39251	payment	2134	2134	1874	1	1	5371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqz8QH2NSyVdsNtWeHRp3jehjgsPpWDSZx4aTnw5NtTdcC4jAV
39134	payment	1397	1397	1678	1	1	14901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYwzWd1w2JbnLeDTtzDX7rpP49xJW3YASrs9gw4iBEcvLssXH
39135	payment	2134	2134	1874	1	1	5337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojeyBABPppWz2zZ7Pki4e5c3ffXfqPAsGG5JyDfrqH9SBZPqq
39136	payment	2133	2133	1874	1	1	4861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7Jpwtr1fp1CSLSTiEvKeBdxo7UEVrowzEvZMDqUxCE3qdo4h
39137	payment	2132	2132	1874	1	1	1465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEmu45TFxv3PLYyRujw6DLqBNfgTKH21MtbEe13Tn3XcWN4n2n
39161	payment	1397	1397	1678	1	1	14909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cJ2Zrin2t5zjcny5rbyJTQAjyMPQavCTkusWnB22BEjuLZJx
39162	payment	2134	2134	1874	1	1	5345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6CQ9insg5HaRix1F5BtYSy9hpLZE1N5hhC5TVRCKoHddSvaA
39163	payment	2133	2133	1874	1	1	4869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XawJ4M1RVmuX8q1rTZK5tN3MLu3iKjY7v7pwwLYno7MhDdYA
39198	payment	1397	1397	1678	1	1	14920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGzuQ2ppPp5CQW3cGMUPeV8U21rS1hKWuVf3nx2HzX12VCt7K
39199	payment	2133	2133	1874	1	1	4880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV69XJpzX2pZ32wJBc5KbJvEvgM7NRkXnGFGD5uXcLtb4fVMCy
39200	payment	2134	2134	1874	1	1	5356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jxZJDNLuCcvJzFoR4BkoZF5puwDR8oozgzFcBXdeG7GrJGV2
39201	payment	1397	1397	1678	1	1	14921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7gAs5np9B7Zc3fftsvsDCmm7Xqc8b8eCq35LA4Zvh6We1t4G
39202	payment	2133	2133	1874	1	1	4881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWZ7xw2GePbKB3kaS3uk3SggfNz2ddBfw5r21FSxBxc5BZ3rj
39203	payment	2132	2132	1874	1	1	1471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7ixCSzvmDeN2q31FkK3SMi6Z7qgtERhhTHTje1W55BHUuXKF
39204	payment	2134	2134	1874	1	1	5357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE2ndCUTDF5V12awYQyViPdAznJo2d4Cr6Vv4rfsccCjUWVcK
39215	payment	1397	1397	1678	1	1	14925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyh1tmH4dtKx4AxshqZUVyhaZD3nac1zzNuaVKvQGYJLttEbYs
39216	payment	2134	2134	1874	1	1	5361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXfaPSMCk8eVHAsck7xE9AAXTwpbfLEXdc2BQ8UA6t1Auz5Vj
39217	payment	2133	2133	1874	1	1	4885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rDm5h8oYcvKABY4K8AGwaSbtmkzJdg51rFoZt29fTjvSjxHT
39252	payment	2134	2134	1874	1	1	5372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9REwGtM4gTcaLMNH3earbwBasFWxH5T9zwYB8ZvkmWmiYgGx
39284	payment	1397	1397	1678	1	1	14947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutm83vDbntBjNimbUmt2KvvHygv5h1K3zn2chW43pheBGVJjf
39285	payment	2133	2133	1874	1	1	4907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSCkpvTCaUXhnFoi7XF9qkyyRhz158BaC1Qxy7JiHKW6D7bZC
39286	payment	1397	1397	1678	1	1	14948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurFd1KWUA9o8tHZTMtP2v61NBwLEvPoJn6s68r5yH9H6oeMdf
39287	payment	2133	2133	1874	1	1	4908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQuXu8UJpMcCGm2Pnqq86fN9F1Bbr7rJ7tibduzTDtDADMzzm
39288	payment	2132	2132	1874	1	1	1479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTYrt1LrXPG6RmDsNFGapiYser9UjkcP73d76XHqiH1rq139m
39293	payment	1397	1397	1678	1	1	14951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE6AdKkEPhDynE4GqhdEhw5HbXrHPc9nBZ8xe5cbsngVmMchE
39294	payment	1397	1397	1678	1	1	14952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i9LD1w8Eq4rs5kDnH8KmT6eK7PJpcWQcGkWtaSzP5yonGkdJ
39295	payment	1397	1397	1678	1	1	14953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhKQVumztZ9UQxc4bgj3FtoKa1pFGyLtPwvgeRZFm1Q9kkaPD
39296	payment	2132	2132	1874	1	1	1480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUseQibGvbR2cDbPDn5ros3uteq8uyLk8GvRPkYBxW1FS6wX9j
39297	payment	2133	2133	1874	1	1	4911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDuUmWQnS5sYZH7gqNJZX9PjiWr7E4h7EfqynxNMYjCGMKXjx
39298	payment	2133	2133	1874	1	1	4912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47eSXbkotLNieLU9WcqnBJbMU4vtQRzptjndCLGDSMGwuYyhR
39299	payment	2133	2133	1874	1	1	4913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JgX1ejmx7PNfJLy2hXMfbCPrXZeAoScFyvFT7mn6SMnV3x4k
39300	delegation	2317	2317	1600	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DqUaSyHus9UpYcZqtjgTbKizeHQYrmUumMzGqfuRTpC5tPgf
39301	payment	1397	1397	1678	1	1	14954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHCp8pqkXRHACrL6aY1ztKReoUmVZ41TRcQE62yXJdjt87Gjc
39302	payment	2133	2133	1874	1	1	4914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEha2deCxdSRTud6ot7YzUzUpFkHriV94evM55Nuv4M6d9Cfn
39303	payment	2132	2132	1874	1	1	1481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbTg2rjYRnka6zpdFokauhVabDYJ6ZpY8pDFaVfXtXz57XTED
39304	payment	1397	1397	1678	1	1	14955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNSnaoH4Pn2jXFBiazCAAdfET1VPGgQzwnXCAnZGWvU4mqBug
39314	payment	1397	1397	1678	1	1	14960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcc43JAEQdehXjfhjdZZyVD2Q5StcUhT7UsJJ1Wfr3W81dMzq
39315	payment	2133	2133	1874	1	1	4919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRKnr2pH1vJS132vbFASvRbZGXcQ9cJmiPDgPEhdgmNQ8nn3C
39321	payment	1397	1397	1678	1	1	14963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8fN4TtTV4STs9EaZUxURDrN9k4bE1LJXwNhU41shfUhHajYp
39157	payment	1397	1397	1678	1	1	14908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUM9PenGoprQJFgbtet6kpdShYbStHcZCmhzytkGinEVYU5M2
39158	payment	2132	2132	1874	1	1	1467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQs6f2HAN4SKDf28nVNm18iVBGKUttSJMcKhkwpBqEf42ohMCi
39159	payment	2134	2134	1874	1	1	5344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJumdZ3YyM1r99LG4toJvP47zwd6Eaoa6XEDJgWA3NLt95eZn
39160	payment	2133	2133	1874	1	1	4868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvWeVpF8WJ4NQTLMzhjQwherMjfQwTdFEDXtDKsdgMHo5ynXX
39171	payment	1397	1397	1678	1	1	14912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ63rcYdEbT4DeLtwe5jAHEVfQSRGdRyFJ5vDhkx6HYNKz1DVT
39172	payment	2133	2133	1874	1	1	4872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR873FyGQUNDpppD2mqbvCTLLFnJnJWRYejz2DrA3SUjPLkGmm
39173	payment	2134	2134	1874	1	1	5348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBxuUtndxtUbpcHxDCdV6qtKnyKEMzKGkvqThN8SrK79ErhqU
39185	payment	1397	1397	1678	1	1	14916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqKUnnJzrsNy8J2J12zh3kZZArMHCphvYdGjDQUKusLCEATBL
39186	payment	2134	2134	1874	1	1	5352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZSwY2VKw6N8ot5JHY2bj8yuKuw4HK6LV9dbUwTHWKApd81aD
39187	payment	2133	2133	1874	1	1	4876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnoE1Jbt15nxKRrm7BosyBJhHLiS6VgrqbgGN6gMBrEfrrjWT
39207	payment	2134	2134	1874	1	1	5358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMYy1VHGkX6ky9GZbwqjVpVepQt1tw6RaYWCjNrKLrSSN35fR
39208	payment	1397	1397	1678	1	1	14923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurwfGaRUZDsLNStUTvQWKjCGoEuA94g2zf1vpcQkiWPS8xW5H
39209	payment	1397	1397	1678	1	1	14924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY7Cc44kTKGdZyCCWcTmqAF5J4twx8q14ayy9MQb6qG62daFC
39210	payment	2134	2134	1874	1	1	5359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcwjtNCsMHdUfpxukrCHteJpf48EbyNjYcuXQrCNS3ii8xFar
39211	payment	2134	2134	1874	1	1	5360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TvBoL2MPKrRsJbYvWDUrw6eazc6uxyoBBbDrhyFjZEew8XJR
39212	payment	2133	2133	1874	1	1	4883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhxRwh9CqUMn38K63eLCfFJ3KgaE9JArLr87oPMbDLxB4vtqR
39213	payment	2133	2133	1874	1	1	4884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmu9HvMCLYrqmbjH34FrT47PUTZxW3xEzrbp1SjRS1UJuChbs3
39214	payment	2132	2132	1874	1	1	1472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYHtVhrRbbuUZWjwh4vc4CDGRouSdLgYKB5kpUh8FP3Wzgu94
39224	payment	1397	1397	1678	1	1	14928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpWWHYLig3KLTwRpP3wMS482vBo8ykETRp54CQVAk9vz6CbHW
39225	payment	2133	2133	1874	1	1	4888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3C91uiD9B5qBgkbQCSU2gAwokEQFnsFkRZZGT7z5199YyvviC
39226	payment	2132	2132	1874	1	1	1473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVxz6dJiTN7fxdkFGttHfVg2awVzZkK7HHUnGSZdfG4gfEnQi
39227	payment	2134	2134	1874	1	1	5364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPPXoUfiJCmytBuDvSrUhHbsqtF4wkrtwGdvm5YtFRcRw5D2t
39258	payment	2134	2134	1874	1	1	5373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUL9ceewqffXaPGS3j7NHCWz1qhnt91gzUbS2FfSZeN8Nky2P
39267	payment	1397	1397	1678	1	1	14941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW71n4xCL5zQZZsNd1PVBqDBMuGcdRU94VpUgYvWgXSnnGuQf
39268	payment	2132	2132	1874	1	1	1477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkyR3rrL9tThvSr73y7HoHp4HxjrMU4iDnPYo1sp8MykTf6uu
39269	payment	2133	2133	1874	1	1	4901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcy8FF24XdCTE4UEHACvqigayEGKT7cFA32UKvD4MbRUvAXZU9
39277	payment	1397	1397	1678	1	1	14944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQ6UC3ZSpbeLb9aPW26BRT8t6asW3GcVvwRbH14QkH78riB4X
39278	payment	2132	2132	1874	1	1	1478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWLh9pyats1C3VMFYHT3vbcR6sLfY49UcDwSXwQQajLboNbPM
39279	payment	2133	2133	1874	1	1	4904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddjj1isV9iQhe3YHk7udpstKzQC5Z2pr4dxoLfg64FFo87fyn
39280	payment	1397	1397	1678	1	1	14945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaYNRWbV4UL2mgWA6ifRmLShbRhLeVMPFqUZ4kwdRb1aYLf3J
39281	payment	2133	2133	1874	1	1	4905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgvANgwdVrvHj9QwA8XidufQ7CmoJ3rBakz4uaSxDTyHLcfmj
39289	payment	1397	1397	1678	1	1	14949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXp27DEb7inkSCoLEWkqQ3RbSucJ1k21YEAnRvLTbNMX6rjWUf
39290	payment	2133	2133	1874	1	1	4909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9ynsK5eE5Aec4bug1LeT3VYhCuxo5ise4NNgTAcFoWu5R9Qw
39305	payment	1397	1397	1678	1	1	14956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3yAzZ2Le8QekXz4xRFhNQpBpGpR21y7fwwJ2uoZBkrm7EfCU
39306	payment	2133	2133	1874	1	1	4915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqSBUD5TKbYEwVvu9fjVn2mbBXNtYSu1gu8xqDapGCAdKQTZe
39345	payment	2133	2133	1874	1	1	4931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6SndczVXUoGGTxsButYWaY4VxonKHw53BPequFkSQAZ71Hc29
39348	payment	1397	1397	1678	1	1	14974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFNCYfEx9cAWRiZY49VpUKMMPfgheq3mVe9Ad3aNoYtQozKYG
39349	payment	2133	2133	1874	1	1	4933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUYdjvXHbJvXiLQnLusrNxcHnLyyqRpBYfTgBErqVwVbZ1MgB
39175	payment	1397	1397	1678	1	1	14914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqSQ1W28dZeQ9uJ97pPPqG52MpgYdxjjcbbRqy9x6XpMHiysZ
39176	payment	2314	2314	1950	1	1	3	122000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2CjjCsNiEPPHuqbYsHTkW1c6o9hcScfzMaJBQhQabkP2qizq
39177	payment	2134	2134	1874	1	1	5349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qgH3gV3Ufcx9cCupebEyfJVE293Pyh1GXesB9LXogVN9p8GN
39178	payment	2134	2134	1874	1	1	5350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9HS4gyqNUziPVA3z14J3qUZKESqP78ZU7AHtXBwzKqkzd5Ws
39179	payment	2132	2132	1874	1	1	1469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Acd4Tqi7npWE3B1NFioGhgpRNmd8UoFtbWJbTeoWZEGhDdwh
39180	payment	2133	2133	1874	1	1	4873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJth96uhofVxi2QZxg6qy6yDF1ajnHUhkHmy1t242t7H6ttea
39181	payment	2133	2133	1874	1	1	4874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahYvQnJMfm2HJtnF8nrvkB6a7HSmDLY3DaboUQXAbXsr6ngys
39182	payment	1397	1397	1678	1	1	14915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP94cotKypQth8WJqC9X3xq6bAyuND4pbDCqD1BQhtEf36suQW
39183	payment	2133	2133	1874	1	1	4875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVEUHB41PiC9f8qqci6zYSgQ1sCjVHx7xGYY8KMaatniKCHGA
39184	payment	2134	2134	1874	1	1	5351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3GmYpNZxxye88Ckm9gjcCE3S3wDkM5428rdj8C2zjqgEu9H4
39205	payment	1397	1397	1678	1	1	14922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjVF7r8xuWeXGXDysRuSRCDSGJtMKQs5Y8b49VPHN1UcyEy7u
39206	payment	2133	2133	1874	1	1	4882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuKnMb7cTRq36EsQfbTqdb6F4bbRKYPQP4Zn9HftPiG7XzWS8
39221	payment	1397	1397	1678	1	1	14927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMb11CLxA1UD4Sbq3Aah2o3x7kPpFjRgkjX5SbS9j2Cundt3L
39222	payment	2133	2133	1874	1	1	4887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6k4cckBdXEPf5JAsNrNzjH37LFn7cgX9X8Dj7g53UDdXPvh5
39223	payment	2134	2134	1874	1	1	5363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76APzzQduZUHJkoDpHJLDuC9G5NtKrTACouQkW8HQu1XnQvr5
39228	payment	1397	1397	1678	1	1	14929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83AhZRgwVcsVwpNXgNf6TGNkySGgKS7iKPhc7bviLUEgobwTi
39229	payment	1397	1397	1678	1	1	14930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpMMTngD4RuoihuFafJGATm2vqBB1kSCi354y9JkEdDwVW5om
39230	payment	1474	1474	2316	1	1	28	800000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaTFQKvEM8yooqWAr6euAxoaPABoQvV1njXfnAReBDxus1BvT
39231	payment	1397	1397	1678	1	1	14931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eDya9CHuwZ68pWjhSTwSPTTtauBMD2qFHPhZ84zuV2jvTJV5
39232	payment	2133	2133	1874	1	1	4889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtxHdE7pTHsrTsdzowb6Bmdyf8gXqXMfYU2igBXrVdEcsPj8R
39233	payment	2133	2133	1874	1	1	4890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkQc34Pf9uEUvqXW2FHhdzdrHYFS3kiDiHELXBkd89dAvq53m
39234	payment	2132	2132	1874	1	1	1474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyGDVZpRTCGGoEvvVaHesda2dCkVjkZZcLcsWnsHZsJmZMebD
39235	payment	2133	2133	1874	1	1	4891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dxpWer7iaCW9DdjWeDTTaRXSFJUdb3ZqfUtCrhuC4NNrHqNL
39236	payment	2134	2134	1874	1	1	5365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1qBoCdkKLgodaaEUWGc6jqYFmY1ywaddxxBtvdYKN3V1W7nJ
39237	payment	2134	2134	1874	1	1	5366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jKTtnCaTU1FJD1cSF6GBCot2naJikoB3TiMGufGw9DWJLTpm
39238	payment	2134	2134	1874	1	1	5367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDRkC5eTLTpwpspyLXno3PnhsASTvddMShV1UDK8aAEuLEDtb
39253	payment	1397	1397	1678	1	1	14936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmvM4WGuZrDvmZEkmtNDepsU2VLm2R3GKiDG7uGko4933DvoT
39254	payment	1397	1397	1678	1	1	14937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2SUbNcs5BAfFy18w4fDKuzFiq9ZUdbQJdso3iMZfgBswfrW4
39255	payment	2058	2058	2059	1	1	11	363000	2000000	65535	E4Yu1DNec4Wsdr7F8UbpezefvoWzBuEkJhARCvsX8REgbUGkdXef3	CkpYRUrT6NGNZbt6heAYknZWkM6zSe2NAmo886hzGt8RvFXpcG7fk
39256	payment	2133	2133	1874	1	1	4896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXBHoKVS9oRfF23Vvd93KPK3xxPcjCFFynMUmNUqGzs8mQasE
39257	payment	2133	2133	1874	1	1	4897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuwTKvWiHkH8ZY52coL5XHw93VDUYByomsrzPp9ax5GpVmgkf
39259	payment	1397	1397	1678	1	1	14938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eSPERBBU6beEb4r2R2WphEF8jELZm9iQF6mPuZxGsViNj7xG
39260	payment	1397	1397	1678	1	1	14939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSujaomNMbnFzXVo482Jtg7W9sfs93M2Q69NErKyec6cXE8Ww
39261	payment	1397	1397	1678	1	1	14940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9fvLYND8He9SfzKaUuHtk6XJt38doxM6B9Ui7shFf1PBJuMA
39262	payment	2133	2133	1874	1	1	4898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjJvNPVhjqg4YqCmymGKGsp3sbw53LG8gB8WSuS6TSeax3yBs
39263	payment	2133	2133	1874	1	1	4899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVop8dbKBdVzyJt6eDjYeqTWCsKy4YF3kUFv5EKi8fi3epFBEx
39264	payment	2133	2133	1874	1	1	4900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVK6HgfgUnhMDkpinhawAuWzeEpCcbCj9pxNpcmDudmSAuYpa5
39265	payment	2132	2132	1874	1	1	1476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzMpDB4FE6dsiQNYTCUkwmnSqRURwGyrB1QRKLBBVbWK1HrEJ
39266	payment	2134	2134	1874	1	1	5374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XXSnGGc5vcoaQFs2ZDSPBoYu4J1M8cDfD9wstnEY19KTocvz
39291	payment	1397	1397	1678	1	1	14950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBFyZFDKPifDJ2PAPq3NsiTQ19ku13Sgw6vL4BsapzPaWZcDU
39292	payment	2133	2133	1874	1	1	4910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4MHAK79chbRBRnoBx383GXy4Pvq82vHNig3yV3KtrKrzg1Nr
39307	payment	1397	1397	1678	1	1	14957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12W9pVx2NGy5MFpNNgSin2rTe82PEmJnc7KU4hiYsMWyj2Xd4
39308	payment	2133	2133	1874	1	1	4916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWamiFLC84FUv8zw1xDsGYeBeb7eB2CNcq3AvcKsRTairpcp7
39309	payment	1397	1397	1678	1	1	14958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSRQiH3iQJDXzCmrCqEA7pxWCkjA2RzHH4HRyyjrGryKUsbEb
39310	payment	1397	1397	1678	1	1	14959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nsmKZHCqx5KE52MgzRHv3kzkapD5icq2FjWRDnDCpH8YEer6
39311	payment	2133	2133	1874	1	1	4917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZut2dLGwpjJZsuNKFMrrPfAymVSeGwJdLrT7qLXomDuymHDh7r
39312	payment	2133	2133	1874	1	1	4918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhsa7V7M9hJGMQ8pdAyX26qdEG2m2heV7KJ4BwsjQGc8bquup
39313	payment	2132	2132	1874	1	1	1482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YbfEjUEUNZQrr2jHcJZELsgB38hixKGMP2z3ayiBVxiwLGWK
39329	payment	1397	1397	1678	1	1	14966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4MJRYJhSZLGja1vdcFBF7wWiwsduGjYeWR5MKFBrahc6xK4a
39330	payment	1397	1397	1678	1	1	14967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrjxEfiUmPtk7xRVJ4UGxXRhYSmo6q5EAEjrM1KxG3t3BQZQH
39331	payment	2316	2316	2319	1	1	0	300000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqk3N41sppkCifus9jLspoG32YNuKcE2q68SoDgX9AMqop57t
39332	payment	2133	2133	1874	1	1	4925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCpqnqXw4zoCHHoELfXUEZ4tc6yY3PLn84t8DLNQ5LPDL6Mmq
39333	payment	2133	2133	1874	1	1	4926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSGdkfyrQeVxkgHKkT4zJ8ejENmJ46m7tgcVHC4qG7UNsJ6Th
39339	payment	1397	1397	1678	1	1	14970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqWbd6SHN35F9gXwktcjrhg568odaahuKkdSyz4gmPshFqpJi
39341	payment	1397	1397	1678	1	1	14971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV6rQjCxwMF8U6kLo7g43svDA7B2fYBjfxRPJdq7Gr3u3ExYW
39342	payment	2132	2132	1874	1	1	1486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFrZM1Tr3rgBVBP4tUtihgL3RNYXBiKjRVTFWk812Kyg87YuX
39343	payment	2133	2133	1874	1	1	4930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkSh9HaeEpH6y4zacQDnYbqsPPRVNmtXwzYj6B4ck62ELKX2L
39354	payment	1397	1397	1678	1	1	14976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg26a8iD98uK4hTqtemgc4mKTCXQpmHj4iXHFNp7tvNJCNLS3R
39355	payment	1397	1397	1678	1	1	14977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJc8jBeWbKYEAwpkbqwCXnrtzg7VjqBnZ7msX5meHqijexKgJ
39356	payment	1397	1397	1678	1	1	14978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv13mfXe5vczzon3EkMhTXjszc5rYmSTz9cytuXfLeHaT3o7qi
39357	payment	2132	2132	1874	1	1	1488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mVNnBhxDMYm1CkddjKNf867iPKiDjr8YTpSKbx4EkLAytm4r
39358	payment	2134	2134	1874	1	1	5375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFvafCcxRDemsZDhHva36iPeMnjERWKriXsEiQCnVGHoNK3UT
39359	payment	2133	2133	1874	1	1	4936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oSH3Kt9BJrScWCnKVKcTrbyWPbVXgvBuC8QBC1AvhCTwRXQm
39360	payment	2133	2133	1874	1	1	4937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeS1rF7fVvAWraEW81MvW5PNuWoPxBpJ4UMoMNeLrLZKGNAqEB
39361	payment	2133	2133	1874	1	1	4938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQ1VPpf9WGyGDDWGdeQukg1icfRMyTiwHHcRyqUQMuNMKc3xm
39382	payment	1397	1397	1678	1	1	14985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqwtY1bxZXws55Mj3Lc8kCjSkUBoNxJDLg5oWTxzi64Zvhhxh
39383	payment	2134	2134	1874	1	1	5382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi5MmNeUBsAMwkVE48xMyuht35jV8nABwkXtVnsFLsnn2YtZZ
39384	payment	2133	2133	1874	1	1	4945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedJx9GhtvJs6NtBaHawDfPrHfGyBMjEEffzoEgBoh6xGwVuUv
39395	payment	1397	1397	1678	1	1	14989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitVNJRHZVxGGGtd7kEdphCnpRydvEyXr6bGU5S3TQXRhJk613
39396	payment	2133	2133	1874	1	1	4949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXqvJppFbnmtbAKUfBLKxLTHkoCY3r1dcAoC1AKyNyB15vY3w
39397	payment	2134	2134	1874	1	1	5386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QYxeCsp1iY8iMkjoS5qWJWh11JFRmcFveaZX6y1Qen21bviB
39408	payment	1397	1397	1678	1	1	14993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGQ3tvjADDvyzQpKwPiSWHfZAJo2ZZgCybj1r6hGTgCgANKod
39409	payment	2134	2134	1874	1	1	5390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjSfbGLiXP2fNzp497DtFyDPrrDfQjZrQ4F5GEujdMqPBw77B
39410	payment	2133	2133	1874	1	1	4953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1WbFh5G8LS4wRmhXWZMBwopvqhUVRq78dLbGh53xHrN5jSBw
39411	payment	1397	1397	1678	1	1	14994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC4Lzc71fMZaaT664yZBG4wWzp4BRB3VoUUqrPRpS6sdHKcjS
39412	payment	2134	2134	1874	1	1	5391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsFgjs7P8AsLmc5D1Z5Q8tBMETNbMkkSHBUXF1mptKQzN6VL7
39270	payment	1397	1397	1678	1	1	14942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7VsuLSExuHETK1ZEbYZy6xkmZjnPZby95xZKwwV4hxqR4QiH
39271	payment	1397	1397	1678	1	1	14943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqv23hXnqHRaiHjN6MaHMcbyycPojKfi4KzgVPCYLpKQL3WTK
39272	payment	2058	2058	2059	1	1	12	717000	2000000	65535	E4YTjY5nNsRcKfU7CDHjDQftrpWChzPWQQE9kR9cYKBjuDFosM87c	CkpZ5R1LVTugWiuVf9MEPcuUQaw2AgiadjAKqT3KoatUc9FRR6dKK
39273	payment	2291	2291	2317	1	1	0	255755211465	2000000	65535	E4Yo4NHtB17XoGsJdkQqtZGN2hYKQW6KyjTYCxdBjckWFqPbNbqA3	CkpZhw2QTGz3dBCoYimyqJTW1EVPRcepzFCbeg9uTQ7js7oa2Zb6U
39274	payment	2133	2133	1874	1	1	4902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KmFgMtrC8zBZUtFYn76bRbTL5ahK1kUDdTFnGwfRjBwsZGoG
39275	payment	2152	2152	2318	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGgQFCS2cKutRHriyqsKTRMZwxYf1xA4obSRy46mWovk7pMfT
39276	payment	2133	2133	1874	1	1	4903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKRqSmCkj1nHDjaKPKwcRsEUJiXEj7RVccukGu63fFfpXU2jj
39282	payment	1397	1397	1678	1	1	14946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbWqmKer4GjKoW9jtv6pmNkG1pMac2bwELUcaV74A7CmDb3ew
39283	payment	2133	2133	1874	1	1	4906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5HLvk2t8wq28VmJ7v7VYGdtgxYa1nRBCDsx1uLpWQnjazd6u
39316	payment	2132	2132	1874	1	1	1483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX8CeerXW6DFRyzSW6hTbFftMLommYFDFR5u32yu1r4GnVAXV
39317	payment	2133	2133	1874	1	1	4920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrZaGCFWYTF6xYgcDroUhLmaszaADZTLHanjqhqkmshDSPGvg
39318	payment	1397	1397	1678	1	1	14961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwawe5VyPp6191WNSjDKzAEHMCp6iFsqBHnHcEV8iMZ728ECV
39319	payment	1397	1397	1678	1	1	14962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxvfRiHjEYkwT7JEV4cmSGaE2hfhgdvQxnSainVxGx6rPmN4h
39320	payment	2133	2133	1874	1	1	4921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4aTUiv1mP34mc2C6CoumgEuEsWsUM5YaUStwUmoaMsj77LP68
39323	payment	1397	1397	1678	1	1	14964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC6nUpkUnmTuThHXfVRmxBF8XPWDHT47rAkFLUUmKC5cp6bQe
39324	payment	1397	1397	1678	1	1	14965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBDengBpH735AbEU9AKFunag7g16neuY8cyNYo3n9tRzULZMN
39325	payment	2133	2133	1874	1	1	4923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMLh2vRigiysY2JMZgigJ2LA26PWznQePXmTvYDEymZizMadV
39326	payment	2132	2132	1874	1	1	1484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5MXbeZu2TPgmEJa4gZsD878LdrmZRUE3Q6dxaMJgb6pwEZN9
39327	payment	2133	2133	1874	1	1	4924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXwKqhoG5oUtKUuxzGDLTVsMN9P6Uyeb9qmpJg1yuQ3YobPiZ
39328	payment	2152	2152	2318	1	1	4	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUfqU5oP7dGibYUBmEWC3qFoYhRzzo4WXSYgeoJBDF1RPPD3o
39337	payment	1397	1397	1678	1	1	14969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCsfWz8HeRRYFjFywXSbNtoeb2rwMCKT2W6L8njyagp8PQMr6
39338	payment	2133	2133	1874	1	1	4928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFqZSMaGyrfq8y2tVxrx7SroB9hoY8chGsCHFFJzCSuDaQLpH
39350	payment	1397	1397	1678	1	1	14975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGt8AsKdDjXKYEh9fED9nstxcJRZUZQKFeYtM19vZY2DTy1gu
39351	payment	2132	2132	1874	1	1	1487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vBf19bajwhrPL4EjaFwEm82x6vLhyzKazbVfA4xahXXRTyuT
39352	payment	2133	2133	1874	1	1	4934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GeckAuWyW7Ye6BqHaGB1hRLsu2gnfquhqHVtk6NgCNovc2mS
39353	payment	2133	2133	1874	1	1	4935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUhThfhJHdAn7JwvM7Ne2A5rfMReTBHM4JQHiNwRZuBqsj6a1
39365	payment	1397	1397	1678	1	1	14980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzFFZqMYqg3QtH4ANDhPnhUvJdn2PJtDwQ9TsMhbWP4HNKC3H
39366	payment	2134	2134	1874	1	1	5377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaKt2UZend8MZ4K7DPkTNm9HfQ99Hp2ocjW3q9sYNhavU9KpS
39367	payment	2133	2133	1874	1	1	4940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb7Jg1jtmf3jBpGayKj7EHNPRrE6t34UWy9SZnNyATvvxqnmY
39368	payment	2132	2132	1874	1	1	1489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZN2Xvgax2ixPydcE9iq9DoEzTgDnHV9riuLLVWyEgLEecf7p
39378	payment	1397	1397	1678	1	1	14984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTGuCKpqBdUGsgmQg4tnmGRbiwF1m483Ye3BQCNEZb8Sq2YdX
39379	payment	2132	2132	1874	1	1	1490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7ERe9hXzJ3iEB35dyGLLwWkU3HZzv69mGdaviJY63ZMj3GB2
39380	payment	2134	2134	1874	1	1	5381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfE4KPTB83rMoomsaohKnpQbBCJdCuDaTHwBuS8UYJZfgzFn33
39381	payment	2133	2133	1874	1	1	4944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2Mqg1zdbUcVFxizTkgh3vZQh8LPuxPqXwHFnbu8edQfNDahs
39388	payment	1397	1397	1678	1	1	14987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLDZrjgPsFfhXTyRhNJ32XT4mXYyPUuciE7sMcho84PTCyBca
39389	payment	1397	1397	1678	1	1	14988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcX3domBLqPnFy2GbqJFgmCKp7bq4mmCtr4DjzY3xTLmJjKz7C
39390	payment	2132	2132	1874	1	1	1491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefDnz3aDoWHN6Ei8WVaRp1PrJs8NEySivY62wWTfdcnYoiC26
39391	payment	2133	2133	1874	1	1	4947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgR9mvommRjRxHdgsTx8sZ93rm1yo6b19UygDGRM8v5e7Myig
39322	payment	2133	2133	1874	1	1	4922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nEZR8ywRRxRZFnjBVuhU1ugVe6oDCbep861KENsBsD13cPkE
39334	payment	1397	1397	1678	1	1	14968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUB8hfmejjr1WBstSPJMh4cXGX5QvoY7SgUXbnATWTEc86VRAz
39335	payment	2132	2132	1874	1	1	1485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfRTV9F9oAbRdLiLngFu1qiJFey31NrdrdQKZCz96PogN8364
39336	payment	2133	2133	1874	1	1	4927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYig7erqgD2BH3hrR8TBaVvKDorPGa9YHJA4PJeT5uNy2JvLbb
39340	payment	2133	2133	1874	1	1	4929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdwg5TzKktSQWqP5PcjiEgR9FudXVGd5UqdZWEPsNEqaZG7wc
39344	payment	1397	1397	1678	1	1	14972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4EYqSMWZzhQYDqcDJPH6VMkEXzbPkwY8vrf4Kg5thoXv5WTsH
39346	payment	1397	1397	1678	1	1	14973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSLKaNwnCqzorY2dmxAjHG6MfkuAYkyXuckrdvjGLRmstcYSr
39347	payment	2133	2133	1874	1	1	4932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8biyt3x2AepeSBcbCS7ZCFibg6K3bMj9iFCWRwumnA78W7pJD
39375	payment	1397	1397	1678	1	1	14983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifehiYucTMKSngFSFkHvr7wap6PQhw5zfo58dsJB5owTsPWKb
39376	payment	2134	2134	1874	1	1	5380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphiCtJdgTBgbHPB3eTooH6UtNyo2dpuPNPzyz3nLtwKHBEpZT
39377	payment	2133	2133	1874	1	1	4943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk8hxEHRGhozkM1sMafBQ3oy7h2tsTqUqgSnL8SVHzNR7i8Yg
39405	payment	1397	1397	1678	1	1	14992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGybcfcYUNLzDPhXmtP4buYV3rdxk1aAjqfiiWZa5HNsCbb8Fi
39406	payment	2133	2133	1874	1	1	4952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhZEWZfyhv235Fb8KPPAjhYENEuVBQ7BjaMKzTHDmennAMDgY
39407	payment	2134	2134	1874	1	1	5389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLYHutzgSWvbWGCLjwz7hEGyCmAFH2irQFNRmYT8gGRs9MN1d
39418	payment	1397	1397	1678	1	1	14996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2YBxVtfDcSRLfmUkqYkd7PY1c5uXnsTXzsKy4KqnsEyUJZnN
39419	payment	1397	1397	1678	1	1	14997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xD86k5uKraXGkyWueqfQm7Lyi4NW54rp23ZNHhW5STABUS6x
39420	payment	2133	2133	1874	1	1	4956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXP11iv9eNd6hyUXcpcEwyLiR6QpBZvxrKLnN6VYDGhKSHLw8d
39421	payment	2133	2133	1874	1	1	4957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4VYP7NTpQKSGXiSSEuNfCYA8pqvrN4GAV3KKLX169tqa1WQ3
39422	payment	2132	2132	1874	1	1	1494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCtye5wUzoHBFnza9R3Ep83GKzaCFgzZdzxALZDJNF2Bqnrx
39423	payment	2134	2134	1874	1	1	5393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFDcnRD9ndbA1xRo3RcBkvDuGWFVYH7TTWhi9dn3VJRe37Bfk
39424	payment	2134	2134	1874	1	1	5394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiCa4dsM2nxTWWvirqX86BTWiFZjU1FumQMxfV7HJoeVUPRZj
39431	payment	1397	1397	1678	1	1	15000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKYT6EnZyUVfa1HC3FcpQaL2s9Lnn4bAQ81KcaFjUb25y4VXa
39432	payment	1397	1397	1678	1	1	15001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7adeVT2cVc8P8QDKcaL85RPtuFV6FagHs8RiuuP4ZnRxMketx
39433	payment	1397	1397	1678	1	1	15002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBLMYioj8913RpT1ZYRKD9mtRoHNmHivzop4ZUeATNT2yN6DX
39434	payment	1397	1397	1678	1	1	15003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUvP5EHbygg9oxvD7C41wnECazE7MG8AwS924tA8ZzUwhGLih
39435	payment	2134	2134	1874	1	1	5397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLhZHfho91Fizi8rbAmD6RJs96Y1FVgXrA3mLVVmUggdBh1Nv
39436	payment	2134	2134	1874	1	1	5398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMy37JHo79Ckp1MfL9gtMJx6xH8nFZHybvy8sCDvYnEg6WxCGd
39437	payment	2134	2134	1874	1	1	5399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg7SFJykmZQn6ogRyfBHZEwaqGSbatT5niRrvc3W5r9kKkP2q
39438	payment	2134	2134	1874	1	1	5400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfPdBDVGDSQDur8GZQVVM9nkbi2K2kGw15QDz1wS2zVKdmYDV
39439	payment	2132	2132	1874	1	1	1495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKv9cEKzGMr6YiEfDiRtR5qcxPSHAhQNrwpcsSUPqURxdnttV
39440	payment	2133	2133	1874	1	1	4960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzsAZDKXH1vCz4fnf1BCbo3Tn3WzWsDtCXSmH2r2Rg5VEksWB
39441	payment	2133	2133	1874	1	1	4961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuq3W1UXzmx5Jyqm1paJDvov3WGMaixjjgFQC2UNwSnmq5ybE
39442	payment	2133	2133	1874	1	1	4962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeggBcty9C2CegTAwgugJNj2PV2CZY8N7C2qBTvbDxePuQXpUv
39443	payment	2133	2133	1874	1	1	4963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Sv3uWLw1uLDbsbXmhL22pdi2ZnkCdbNqZHjbmcSWJF3DETyY
39448	payment	1397	1397	1678	1	1	15005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMg7E5ebHeyy8W4cVUuJ9UoPmMxnHSzfd7e6dmzCjnRxDnkYc
39449	payment	1397	1397	1678	1	1	15006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxc5QNs5UjykEc9PgyjsY2aFX5UmKdoTScSbbrkgr6NuTvWqrL
39450	payment	2133	2133	1874	1	1	4965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLb9Bn8vx66aVz6z1vBP8fjcwrmHN2xUmtLeJXd5hMEznPqiw
39451	payment	2134	2134	1874	1	1	5402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTgrbrXuTEAxuWA2sQq59HpnHwKVNGzvN2NPgPKnd539EuuQg
39362	payment	1397	1397	1678	1	1	14979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGSbiz4AkjaFKM5Zmpd1QpdpMhLgSTkmVmZ7m7HLMTywoh6dj
39363	payment	2134	2134	1874	1	1	5376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXACzhSoqknC3if4a46RQ1r94tvxfBG7aTqygTzGhuiEgbZhj
39364	payment	2133	2133	1874	1	1	4939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9q9qLjVxHYfSggyrMquba5CSDgV8zB1xMMqihAtfELfTV5nr
39369	payment	1397	1397	1678	1	1	14981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PAMzzhALwi3T4eXPBiSuQYGgdFUUz9ii3oiRurh5Q5FQxTWX
39370	payment	2133	2133	1874	1	1	4941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9pRga8XKKf2bbD5XQ1aHAWvM3eAb2gEs5UUZ6gJDXhWi2BV2
39371	payment	2134	2134	1874	1	1	5378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZAtUFYojHYSBYYwys98vHGdFxZgsjxA53orKDiYg6V8ivEEG
39372	payment	1397	1397	1678	1	1	14982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfbfeRCoQFhHg897FjhgGrc5saBJbjNqLuuN5QizQr8zy5j9v
39373	payment	2134	2134	1874	1	1	5379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfSYF8vr3miRJyHrYwWLaMKemeRcoEjjQmyP3nu2HYTSZNSeT
39374	payment	2133	2133	1874	1	1	4942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFPJAxUBwYjaRRxdMi9nGdnUmfr2THEwpfn9uxjtPaDphkszg
39385	payment	1397	1397	1678	1	1	14986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA6Aptg4yELFH4VVwhVTLH8gYCUgEjakU91SixWGnSenNBE5k
39386	payment	2133	2133	1874	1	1	4946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4WsqwcFbcaPxZw62BJRDRJf4zNTBaAf394XrGp5qnZe8aX4Q
39387	payment	2134	2134	1874	1	1	5383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9y5JJRcGU1GNnHhdY5HcVpWkRYwL6TLgCZw7aseHp3tvPrCj
39398	payment	1397	1397	1678	1	1	14990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQcrTsLokE2ybrnrezz9L69SGbTznBzkV8vNvW53mz65X1kdk
39399	payment	1397	1397	1678	1	1	14991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipMkWkd8hFXgGmUQiA9AbWRsUWbAi6xiGbrTdrqJR65FeyHmj
39400	payment	2133	2133	1874	1	1	4950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtV8FmCwhNb2kHShkaip5VRooQ2xieztTbyhEyhswurPq3wQi
39401	payment	2133	2133	1874	1	1	4951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEN7EFrkdEFYpNEvPrPGQkUbBvdk4dZAJEeFLzQM78dNebWqA
39402	payment	2132	2132	1874	1	1	1492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXWWvK4tT9Lt4XoEndcUy5YKDeC1Aw8r2oUBtj4UKSR5v9AXT
39403	payment	2134	2134	1874	1	1	5387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1XPFEcYPUnXfxLFpyH7RCxoY6zzpD4nJW3zkiExadYsgdMJv
39404	payment	2134	2134	1874	1	1	5388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX4yDodz3kTUhufL5dUnFPNw834ggQaRXnZH9McCr7RdVHF8C
39458	payment	1397	1397	1678	1	1	15008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzifTiVuKuMLR82v4Se2uoaMDUF6FiFmgTeiTQRi1qPD1R8PA
39459	payment	2133	2133	1874	1	1	4968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfuUukKMZDar6KMpXZ3ppvubmmbhPkavKA1GsZzDawA2Zbrd8
39460	payment	2134	2134	1874	1	1	5405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgZroNAMwniwSTLaAkUmnqDgUQymEanN6aV8raR4oQRK6awoB
39465	payment	1397	1397	1678	1	1	15010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNmtfZG9HoUEqDixAhzo9zXkepoUwuZD74t7cuZ2FFYGRCCgC
39466	payment	1397	1397	1678	1	1	15011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DW3HA9DxjGLiCaiaUeEAKFDZPQG8uiweWHWCcGcQtpW6NzvD
39467	payment	1397	1397	1678	1	1	15012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BA53fmPzUS5Rj2aLwXbxGTHeKTq49ACWeUbHTt3qurBTkNua
39468	payment	2132	2132	1874	1	1	1498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGfqk51B5UU8RHyJdhmUKBYgSPziuq5SnfNq18CCvoMCi4eJ3
39469	payment	2134	2134	1874	1	1	5407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErLYFRchXdg2wLqsHb6NaeBNS2uuDmFfDiNwwWtyCTHzpXEGM
39470	payment	2134	2134	1874	1	1	5408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd6wjj7mhawUhjtH5pAzksHdYhJ9xxePoKoedbZnP6AxdmH8n
39471	payment	2133	2133	1874	1	1	4971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLJxLygPP9iQf2nAYsXcSq4cUdgkLtF7v8XxJsD5u3jTNAB9e
39472	payment	2133	2133	1874	1	1	4972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRCakm1TnV8Ajo9As52ZoApWgpNYHSfnMPX1eDnGtLEYC6Rkf
39473	payment	2134	2134	1874	1	1	5409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBGd5vNnmWhUXvhGXsdqQ2zBzFP4xAPX8Bn7VVkmzCuwa7LAM
39481	payment	1397	1397	1678	1	1	15015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gA5zXxLxKydDgfV5ApXH9XJfuXB15619LDPFjS8UF1fjdStw
39482	payment	2133	2133	1874	1	1	4975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksgrzyZH2jyyx2jxZh4bzfa47ZeoJ69AMUu6ZwkhAzBcqehZc
39483	payment	2134	2134	1874	1	1	5412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSZwTaAiJpTPq8PjjMREmwrjS2vG5Zao6QDVrbyKqiMWs1C7R
39506	payment	1397	1397	1678	1	1	15022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQgKFphin26Ea4RKMtEvfU1y1xLKTUGfTjVQgQw3Zkt2fLP2Q
39507	payment	2133	2133	1874	1	1	4983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLinRCun8xbRpm387wD4dXJ9eU6pJiudKfZDy3hmZtJDNsLLY
39508	payment	2134	2134	1874	1	1	5420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdA2qF4mqUPwBY38Ct1iAV4JfH94em4dMqEjWr53cHqheEu36D
39523	payment	1397	1397	1678	1	1	15027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvWh9MzFV2QiwRedj27fNaeNEx9bx9BtNqaZfwpXPWDfrEm7Z
39392	payment	2133	2133	1874	1	1	4948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmg1JXnVD75ESPiygofd7NVpL4sqCrDegSGqzeGoQmDnW2Yrew
39393	payment	2134	2134	1874	1	1	5384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv54j1yEYcR7gZ1zHMPmg732GnsdgQYfU3WVoNhRdRxEisYi3K
39394	payment	2134	2134	1874	1	1	5385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeeEGsLZj8TvCdrjTkSNCzGjEbcQmkytPE6f1nfJhwLxx6ph8
39415	payment	1397	1397	1678	1	1	14995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnamcsquKM7BJ6QVP6sc6RNQVb12y3H5nvom76i1FbqLEBpgvQ
39416	payment	2133	2133	1874	1	1	4955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXnwjbxHmNgSdZThg9VwB9RXK4Qdj4wUw927dmrSHk1WKsXcd
39454	payment	1397	1397	1678	1	1	15007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrzrjR2fikLTYTKsYdyrWW5h6nWj5mmHxyh2Rov6dSuLp75t9
39455	payment	2133	2133	1874	1	1	4967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsacmazAYWVmgcDVMSPid1xRsEUdAfZ3hXvmi8Eh8XiQYQiSG7
39456	payment	2132	2132	1874	1	1	1497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqBU2wtaSiMUMLnhWW12Vmc6CNf45bn65p72xd47RHPxVZsAi
39474	payment	1397	1397	1678	1	1	15013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CpTs6y6nUCGBKpXtLmj1ycEZfCuVHWu215ub3bt3QbDb9xoc
39475	payment	2133	2133	1874	1	1	4973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj4zD8TpjiVeHp1W9sQuASi1M7T5UvCXHnCWvxV7EuuyYBkXf
39476	payment	2134	2134	1874	1	1	5410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKP5SiLEkNLGM3N3iwbpqDSYXnZtDVaP1amaExzkCVxWpr96YH
39487	payment	2134	2134	1874	1	1	5414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfUpKRYPA6BAfFzTjBtyv2Uk68DJdFQwHj6cPTYNdXnJe9msk
39488	payment	2132	2132	1874	1	1	1500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYai7Ts7YRY2QRsxJFtK1VzHZ9GMRf7G8GuaFBS6DVKdauQPpkr
39489	payment	2133	2133	1874	1	1	4977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t8bKFZxLtgx2Rri5vJziXZrPXrTgWhvVeibm9HPnwKMPjC86
39556	payment	2288	2288	2320	1	1	2	774743211465	11000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTcF5LTHifdVZ4eVUm3ZrtsbUB7VDoZvi82N5ajmgWupkuC2Q
39557	payment	1397	1397	1678	1	1	15036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvgZ6zqwvbcPyvrR2fggUcFzckxNyFtDsDqDoYQnLFmB9mfFx
39558	payment	2134	2134	1874	1	1	5434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuCeY5YZP685QMwKEPLQvRa79ib65doosQiH7pKjeKLiSpoLV
39559	payment	2132	2132	1874	1	1	1506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvu62kx3eqsZ3MQVw1mayQifvGFFFLpDkWbMo6hBXUG5znRLTE
39560	payment	2133	2133	1874	1	1	4997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVj5y68qARSonVCxxh587CWBtwjmyciLmzegtHJ5p8vpRcRVd8
39561	delegation	2026	2026	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJefr2AbaGT1bXpdTNtSaMCmLVr4AAhiirTNYpT93m3Fzn5b7
39562	payment	1397	1397	1678	1	1	15037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzoViFj7ACejR4bDWXVrbQ1ettzCTHpB4YUN31Goh7xZ9jY92
39563	payment	2134	2134	1874	1	1	5435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpV8EFDr2W9UmZD1sDD3kxJMoUR4oTEaYGcHDeMRBAqohXtp5
39564	payment	2133	2133	1874	1	1	4998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ngCzfn2d6tSS88YDpF8vVwhYHhw8695yUX4DmvYQeR76s4PX
39565	payment	1397	1397	1678	1	1	15038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhTQW5juQbPcbeRCY7gtsLkpybvpSzqFWmF8XdnW5he7CBEWF
39566	delegation	2320	2320	1600	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbDycsyk1XtjcvnwCLHhtZvQ8WwvwWA6zLETe6ZL1Xtnh9NUx
39567	payment	2134	2134	1874	1	1	5436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHh9MLFjdDrAsWtHTvMu5aMr2VbfwhKysxg7j1eDXw7pqyxHPE
39568	payment	2133	2133	1874	1	1	4999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u2TDVG8gw1FfgxKYT1otiCSh3QMpTmgqiDqpSEE2jcEDt7ny
39589	payment	1397	1397	1678	1	1	15045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQqRFRMbqCVP9qRfVS6hLouChfqLwiCAYrgng9VfizrWkfuef
39590	payment	2134	2134	1874	1	1	5443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAazh2jSWrFhsnrcS9XrXQ1vCUVc163FDPWepDcTAdW94R5fVV
39591	payment	2133	2133	1874	1	1	5006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTWqXS8Li42sRuKrvFo1hJC586XbYT8W1sGXrn9yXBVkB8iwV
39599	payment	1397	1397	1678	1	1	15048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTbyvLcVJUrWT4Z6Tc2C5WmuRTHdVXBp8chU8Bs6U71bNwpbA
39600	payment	2133	2133	1874	1	1	5009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4eGtZvdisZep5e6b9o6froZkEPFBjeHtH7FNqy9XCvAvMFE2
39601	payment	2134	2134	1874	1	1	5446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiu3DVtNZ63i6uuiLZpEAtC2s4F4H6bE4soK8VMhJYLyEoo4F
39605	payment	1397	1397	1678	1	1	15050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98NgzdfqHjtxP3KRs5HNmf1iASDoSXv93ZtVZjD7d7HUmKeKh
39606	payment	1397	1397	1678	1	1	15051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUadu5oCHRRu2v7e9ua99hWFe6Yo4tHpJY9kbVVRWmWXQL1Fh
39607	payment	1397	1397	1678	1	1	15052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S5Hg1QxjiUebnB22uDHohnQzaA96Z3vANF79nTFy1w27QJt8
39608	payment	1759	1759	949	1	1	7	2412918710000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZdGXxQJucv2WXUxZk61iV2nEsKeMoRYPw4nTcV2f6Y452xdLyL
39609	payment	2134	2134	1874	1	1	5448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWAYeq8qxRkASvJS78RfAZmpARpeZA96gDrxG5YpZ1fAmWAMV
39413	payment	2133	2133	1874	1	1	4954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jVJxsrqhAmarPBDCqcvKj21uRKaSKznqsoLyMZs1rkPGUyBL
39414	payment	2132	2132	1874	1	1	1493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeZn6UjrkNF8AF4xniVM3dshL3HZAUKzPwQhu2JBFECkvnaqk
39417	payment	2134	2134	1874	1	1	5392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnhyDXEmc3PEYdtYmQhhPcUevKE2n5PFgbCQdwqAvFXo5k7CZ
39425	payment	1397	1397	1678	1	1	14998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPeXwUXBSy4egpg5Ss86CpD7HKHcPM6TkMmbewQZjXJdi38fv
39426	payment	2133	2133	1874	1	1	4958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjHYdSyyAGCDZ7g8KZ8nMaYKG18Nw6CrzzbNRX1cZwknrXHiT
39427	payment	2134	2134	1874	1	1	5395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84Y5sz2tgiFskbHUxZMY7PkVK7XLaB49nwvomVdMVCvgZivDR
39428	payment	1397	1397	1678	1	1	14999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG59oXS34S2hR5o3GoY1Bumo8AhpXLnM6dwYwbs7dJLRzCT9Nr
39429	payment	2133	2133	1874	1	1	4959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDG4duq9sPHthD2WQc7hJtrjZ47jGdMfSL98t2hma7t3jtSrt
39430	payment	2134	2134	1874	1	1	5396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKjEMvAMFpiC1XLxEnaj2THneMYWrMaiyEkGHm77bCj69rPoN
39444	payment	1397	1397	1678	1	1	15004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfZXEsZGtfKNsAsx4aCdhxekrSBR11DXN8A94KN1QHKVZXvLq
39445	payment	2133	2133	1874	1	1	4964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4urSsiUAx4QPLbCenPuNmcfKrMv8Gsj2eQ79HiYYkdGgWpwAc
39446	payment	2132	2132	1874	1	1	1496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceymsnS61VqjhwTg2Kv8aZHh1ttXBjgBZiZ4cT3cNajcRQSxj
39447	payment	2134	2134	1874	1	1	5401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32pTPLf4kPqHEZEFZyxTKfuf8Jjy3aVT2egKxaJrbANCHrJhx
39457	payment	2134	2134	1874	1	1	5404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqLRutJSWn9BsSLYZnL2MBmK6eC5MQFgn9P8DhxzBsFiyHJfk
39484	payment	1397	1397	1678	1	1	15016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsao2cRFTxZAuUFjpKt4PcSD9gPFkUkb7iLMfrGRZwiqDB93a9
39485	payment	2134	2134	1874	1	1	5413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsgD25nABjNnxWvfs7WraQ5k9iU3FsUkqwnJKwHP1VBdJJNcH
39486	payment	2133	2133	1874	1	1	4976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A24S4QvGSmiAk5NH21m992KpM9ThsQu4bmGiAWz7QMcj9HzW
39490	payment	1397	1397	1678	1	1	15017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc46M2WtY1JrVjmkPmxCS2LGXDMLzG2ysaAzjJ3rmKSJycdEr2
39491	payment	1397	1397	1678	1	1	15018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuMfe2J6p5iM4EPDaovYGq4KDtwhVsn3UkFxCPJKG7MGYua7y
39492	payment	2133	2133	1874	1	1	4978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanyAzUCQwktSgzac33qHJ1RCRiUG8AViHmS8PjajgCJ5VmjAW
39493	payment	2134	2134	1874	1	1	5415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmL9GEb3w3EJqKoTf4NFZ3P1uhAB8c76p1zfEFRqa7VSj8Jhpb
39494	payment	2134	2134	1874	1	1	5416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGG9GqNamR6sRHmugAyxeEGZCmzKufqALHNvXgq5eg21CFJP7
39495	payment	2133	2133	1874	1	1	4979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj8bmiE6faAke4dzPUGKuhi5uSurFFa7YSG1dBbEr3xqiBRx6
39496	payment	1397	1397	1678	1	1	15019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcRYfzfcqdXGS1eyfuckQFQVkefEVjJfrSW5B65i8rY9H6YHm
39497	payment	2134	2134	1874	1	1	5417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoNqrUDgVDrRo6dfxDKG24nx2L3LsnahozTcrzhZULtWepDKs
39498	payment	2133	2133	1874	1	1	4980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJY5c4a2rD7bqme4JBT7CHkZfBpvu2gUWNVRGQp3T9Mq6XBpjv
39509	payment	1397	1397	1678	1	1	15023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUwdJrfSMYTDLqZkGyybRKd3Tq9jgDtMFGsxuK9oE44KNkLNg
39510	payment	2133	2133	1874	1	1	4984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihpPTr7VP6UYprx8u5pQ9LesDstXEECvbFzbfM18fBevNHNNT
39511	payment	2134	2134	1874	1	1	5421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgPgAFjoSE92WQfJvNEgS1eXxD1UpDewoTsPaLLyq3GqzunhY
39512	payment	2132	2132	1874	1	1	1502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH353fPyTTFr8VnDKa2YiQZMjyEon64PUJXMp1SwGSCs7PrYAw
39526	payment	1397	1397	1678	1	1	15028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFm1w1BLbkGBDyhoipps5DuMjc9cXYzwY4pSArQWRyZAhJFfdy
39527	payment	2133	2133	1874	1	1	4989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvgHhHAEa2HzzvPW3nDyfB8Z4mGXziXFHP54fwKA6DfuDYB88
39528	payment	2134	2134	1874	1	1	5426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2WCQyWu4G854vnjH81zEWzwzcNrcDMbdRVyxYLz9tR7wfswC
39532	payment	1397	1397	1678	1	1	15030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fw8yhUsYJZ3D9Ljb3fgw3MHJuB4Mji1Bbq5QcwLuHBVs6jy4
39533	payment	2133	2133	1874	1	1	4991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEqBCexHJ5Z8t6VKkCa7eu8UjSQsdB7avAwAYTSfPmPUMhjf6
39534	payment	2288	2288	2320	1	1	0	1000000000	1000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4LpsrHyTn1AVbBcuf5hqW8JFqT19D36BqrVXLaJ59qKAWd6D
39535	payment	2132	2132	1874	1	1	1504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXNs9s8PnJdoKmQsUZ2Fd3nySzm1mXEGrtGtyoTEMepKJbhCP
39536	payment	2134	2134	1874	1	1	5428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncceJjxjQ7n96X2bHz1w79BjmyMu6npUAWnfXvdqPwP4QYTUq
39452	payment	2134	2134	1874	1	1	5403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8o7d3fwUACTG99cPLUXodrqLSPjB8tsruGEugbR3uGQEpLSzh
39453	payment	2133	2133	1874	1	1	4966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjzpF8MRHuTDwXwwJpxJ7HKZD8Y1ikdBPa2HAtDC5kxPRz8HF
39461	payment	1397	1397	1678	1	1	15009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DVfEo4cqr54VkgxJ9GUVNYqmPFHJ1LceaTL4tvMvRjrRUVDU
39462	payment	2134	2134	1874	1	1	5406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzr3XBGxFSwBQCFr7bvuBvt9dYzpjALtpVqkpdvULiCZsEAqk
39463	payment	2133	2133	1874	1	1	4969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2AuAXYm51nhq3ZNSpmXJnVZKvasdTgjbsVafmwG3Z4qbr2Hv
39464	payment	2133	2133	1874	1	1	4970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRsyCTBwXNGK4isnGqVikXQbTmotsXfu7oYuReuVDYAcJef4Z
39477	payment	1397	1397	1678	1	1	15014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToPdFgdwuCv2z6cgLHP6amJ2MJvRxCXmaMxsbsNgKkUbtHP8C
39478	payment	2134	2134	1874	1	1	5411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFo6Letb53JWRkGnNLUG1XiN2rjCZGyJt171Kcy8Zbchu6nZJ
39479	payment	2133	2133	1874	1	1	4974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwtM2MNZLXfgGTZnqyGF7qhsjaotUuD3gytL9S3aEs7VKxqqa
39480	payment	2132	2132	1874	1	1	1499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3pLyRr72EwKdwCRYcbd7SvxBMw8yyDaUUorqa3T1BYCpqK62
39499	payment	1397	1397	1678	1	1	15020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxLbDesBcacpJuTah6jFF3WDzHC2Ay1NEJFw6FK6N7N6hq5kL
39500	payment	2132	2132	1874	1	1	1501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUTYnxS26syhdmSkYMsDdo1gkYgxwQtw4uD7YeWmdBVkuHuwP
39501	payment	2133	2133	1874	1	1	4981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEU33rui3NXyx4PZqGoUaaSF2bWhKaAwga9Gfj6r9dUv2qBd1
39502	payment	2134	2134	1874	1	1	5418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGXtUjUjrrKKa8zu6i3hqRY3GKJSMU6CMsJsUyKWvjkwZZHFm
39503	payment	1397	1397	1678	1	1	15021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC72hg614Kr211D71wCRbDUNYq3CQU22xUSt4G7FS2M12bBJE4
39504	payment	2133	2133	1874	1	1	4982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFyDyZJfZ3N3FEKgW9YT59NzcdpthwWJyEetSUbArLzZGF6LK
39505	payment	2134	2134	1874	1	1	5419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAi9NiFgUjFNmoh35KEHF4QxLTNodjasSGmubdYRLhFchh7G4m
39513	payment	1397	1397	1678	1	1	15024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsjz6oC9sJCWa8yDsBug3H8bWYoDiPcmpqUiJjUxrGUJZHK8N
39514	payment	2134	2134	1874	1	1	5422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61dYqyNXeJ1nSCDKZeWAnm5WtUDFFVKCS6VYLV5sK9888sSob
39515	payment	2133	2133	1874	1	1	4985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6a1t36yujfnAoMAtXUNbds4HbdVVNdvNHuBycar5DymPYex6
39516	payment	1397	1397	1678	1	1	15025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSztAJcbnDfadQaLU12hY2nHt4csW8Zkdmn6BzkWrM5mQkR4d
39517	payment	1397	1397	1678	1	1	15026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mej4D5kzxcVSsY4HBdexXR9MyZfNiKChw8VEjNdf83Z81uXk
39518	payment	2134	2134	1874	1	1	5423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjv1B4Qqg2g1SdPP4pQETGRpk19UxqSeyHPtRFMAFPYGe46Pv7
39519	payment	2132	2132	1874	1	1	1503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLVEvLUnZePTPeDeCr3VCYLSEL5Rc6GyxnTEmT6GTWVAsV34J
39520	payment	2134	2134	1874	1	1	5424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6JsPMNVF33HdssBZhPSYR1zRAYrc9VPrae2Ty7HLRV4i97Ai
39521	payment	2133	2133	1874	1	1	4986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRHzFnktX2ngLoJqzHDFK4zYBMa4JPa7iB2xT5rZNMyYdjHch
39522	payment	2133	2133	1874	1	1	4987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHe93LGYpu4jjpX22ewSMhgKUNvnLXAP5Wf8vt6x2TJP3jggW4
39529	payment	1397	1397	1678	1	1	15029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXUctp4e2ed48T2CA51kyGcS5EMzuPh4VXc5K6FGiarmohUR9
39530	payment	2134	2134	1874	1	1	5427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMyrtZx4NcSZfFeYM6VinpJadqE94oJjKo6gZUNHegkQ7HDiL
39531	payment	2133	2133	1874	1	1	4990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9rSh6iLerMavs3b9ZB212hGw8GYwcE56Y8oL6ZzX4Et86WJy
39543	payment	1397	1397	1678	1	1	15033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUKx6kUoY8BfnCRCZjeEnybDatpcJihdjNaDVetJMLUt1BD2X
39544	payment	2133	2133	1874	1	1	4994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAAUWiUKDVBRn3H11KZEQ4SXDNAAzan6PzwAAVvNKQEgwLCwA
39545	payment	2132	2132	1874	1	1	1505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwAw696U3ee9MfEzuFnxuzHmKkrDzJBp4GXt15JrYBcaefJGU
39546	delegation	2119	2119	1403	1	1	9	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpaFmYDrT2xFwJRSNKSQoKLshK5342dKtvC5vX1FahjcACmAQyTw
39547	payment	2134	2134	1874	1	1	5431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7zKpm3i8gsVfwXpSJVKiqmHUUDskjufU4aWUJWkpPzpeeHdD
39548	payment	2288	2288	2320	1	1	1	1000000000	2000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikkqvsZudpLrP9qH7LrWfonYabKteuxwqKWpYAFQhfeT6zGDF
39549	payment	2134	2134	1874	1	1	5432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzza5YcJiv89emaiWoWB4VbcNaGqqZvSzuCqJcPmcVvTrFZnNx
39550	payment	2133	2133	1874	1	1	4995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8n9NyTvVgekCFggeUGoWkp1TmrVPyKC5yz4ZQmVqVAPs5GCn
39524	payment	2134	2134	1874	1	1	5425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5Zn9viqSnZ4yzYkUpAiTr9xwJHPkLvVKTnsaUbtD2rY391uA
39525	payment	2133	2133	1874	1	1	4988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69UJhGe2d4FrNCwGjSaa3U7RJnZMNFNk7bfwTppFAa2LY9v2F
39537	payment	1397	1397	1678	1	1	15031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCnT9KJooMUGbRpFmj5kqsKwgPMsf4aSAxwc9hVzmVRSPsvLf
39538	payment	2133	2133	1874	1	1	4992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTUp5mQTstGsH9LZWLAco2WGniZwYiZEKNhRYrt3TdKpsEZSi
39539	payment	2134	2134	1874	1	1	5429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoToVSxjZgmr5VGDUvQHUoaA6qFjBYHBiKjWgiH1jpXj5U7tpt
39551	payment	1397	1397	1678	1	1	15034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjadX7oPDxU8XUH9aa1oZaJoCRyVduWyjY459JQTp6HMi3zQK
39552	payment	1397	1397	1678	1	1	15035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDQQ5Kmp3BzEGLp2wTCHDovLM2uTic4a3aXXqUqn5rFmbcqGX
39553	delegation	2320	2320	1600	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW99ysDL5Q4gTxh7BV5AHfKzKzBgX4c6gUjhgnBdQW2sxwXTC
39554	payment	2133	2133	1874	1	1	4996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFoPwPhs6zZhuQJtQUsmmWFDMPfdk6DoKATL78G5ZRuiKRjff
39555	payment	2134	2134	1874	1	1	5433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CZC1eM5eY8uMEgYXE96RCnLszNKQphfhMakAiJnTQFJwBcHC
39569	payment	1397	1397	1678	1	1	15039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApoufyyet5URNVaPQpG4x4XpJjmjUny93gBkpWHeybbepqnCZ
39570	payment	2133	2133	1874	1	1	5000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uBRmSNiPAbFgnYPNFyBKURa3mvPCFE1WKLukhJxEaYN2jBCq
39571	payment	2134	2134	1874	1	1	5437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLMbZ1MnzJvpNQ3RoraJBBxJYatDykw8uzWdka2nFM1ncx4AL
39579	payment	1397	1397	1678	1	1	15042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhwMgFJfDJF8MCEHn8WcsV1sv9ePUFELsABUcJzRTgotNEUJ5
39580	payment	2134	2134	1874	1	1	5440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZVZvpoyVzGqMTG8UC2ZRvqH15ZYr62TQ3qtdPPweWzFoMEno
39581	payment	2133	2133	1874	1	1	5003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYt1bcBjcdy3eryFvqRf9fGXnZdxXC1wmUixTzxyrgeDxEWco
39596	payment	1397	1397	1678	1	1	15047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEKMM1LM6YHor62uqzVvxG1nRf1nx42RVUge3KVV7xEmianiz
39597	payment	2133	2133	1874	1	1	5008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzQbsmBFuqpjSoTizr8GVo71ThCMPzAfMfN8LGRcpTKRy3H4Z
39598	payment	2134	2134	1874	1	1	5445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4A6ob4zf6DpChJdUAxECUdnapQgZceiVgkAKta5Xu5iUCMdC
39622	payment	1397	1397	1678	1	1	15054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZti2iEBQXSxB2tvPEEunQo48346WE7b5k4KVYnprLHoXE1nP8s
39623	payment	1759	1759	1315	1	1	10	8129710000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpYXdkEEHfagZJSLy2jFJKKdbJVR32wmwv4JKrowkRLzKAYRc76f
39624	payment	2134	2134	1874	1	1	5452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAFHjbES3pwEVRiKpqgqZBsUAXRWmTrsxCMN7KqqP4zLgfZNY
39625	payment	2133	2133	1874	1	1	5015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNCs7sNJeKHigCKwErKKFqa5RSropve64YR31nhiLawqv9FJF
39638	payment	1397	1397	1678	1	1	15058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJ8QKaqFzkmkjY8AZbk6HA3B1PT77QpY8vKsckQBdi9YbZqme
39639	payment	2134	2134	1874	1	1	5456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrnwHsRaayUCyVyMg76q6VNkZi3bEVwtPDy77hWaJpJpcYpmA
39640	payment	2133	2133	1874	1	1	5019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2h6nw4jafPjhKHhm4mMV7MVEdPqWJuTUg1XhmabxQV9oFbRX
39651	payment	1397	1397	1678	1	1	15062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYARWQi22Te1DdqFhrSe7z2YWXvkcVpQ9qeEQJRxFLLXjTGhdf
39652	payment	1397	1397	1678	1	1	15063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2chguKPu1gSuXATcZ8mCaYwiEDyWjFNgXrZ5eRRoC6axpWugu
39653	payment	2134	2134	1874	1	1	5460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebE21CLpNj1fZHcBhD8ZgQC9RdyaBGAAT2cMwEZ7L74KrsetE
39654	payment	2134	2134	1874	1	1	5461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSp17ZKWxP7iUD89jCCYeNKZyPmCE31Q62wBdyBLWAeRPVzRwg
39655	payment	2132	2132	1874	1	1	1514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh9vx5MGHZHYuEDRRH5quSVQ1FCbQ9LKvziLSQtPXMx61HhyYC
39656	payment	2133	2133	1874	1	1	5023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtNgtNwYkHNcqNxM16dxGJA8Ny2oXSu9bcNS1hSq9V4TrG7YJ
39657	payment	2133	2133	1874	1	1	5024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkimQvucjJG1KYZkBXxvJDVffjkQ18YvbTS4Sr1rs28gTpn1Yv
39668	payment	1397	1397	1678	1	1	15067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACAME8M2oBFcCmB7uWbTkLYUrhq9sPaQwC81tRnqegLP4TAiL
39669	payment	2132	2132	1874	1	1	1515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdH3nqaJSTbvSh8TqpzC65UDhLa4B78ikUEGZqLfEzAD8N9J5
39670	payment	2134	2134	1874	1	1	5465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6poBqLpeRsH4oGArUw6KX2JoVE5xfxWvLP7XuVimAUHnQE2G
39671	payment	2133	2133	1874	1	1	5028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXn6HYeFigDbEP5MtAEGabcuQ7rAx7TkCij6jgHkPZt7ADfea8
39678	payment	1397	1397	1678	1	1	15070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcWGRrwQY9zQTwDKdFY6vAvMTBmGLmppA4GmQJuPFyN9QAXbh
39540	payment	1397	1397	1678	1	1	15032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMNZNwHGeEPhDXGQHhsmCSRQBmz5P3cdvwBzNRijiWsXgdC8R
39541	payment	2133	2133	1874	1	1	4993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ946gRxufMprGUx54uQsr44mZcVY7MfFbFW7kR4s5PDN1HMatf
39542	payment	2134	2134	1874	1	1	5430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDa2ohD56mMwxeYMuxN5UdLr9Ez9dxVwEys4Hx4ds7PWG8MNfy
39582	payment	1397	1397	1678	1	1	15043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqzZeAGBhT2byZDHK4znPsbCRxaY1rg1rffvybgYEemxYK2ME
39583	payment	2133	2133	1874	1	1	5004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfby52DcYeiUMnt2FoCgDL76Vau1qSLBq7yELHCEF61RoRLdM
39584	payment	2134	2134	1874	1	1	5441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarg4bbdhHiwRZAYpaC4uP4YT798d4xTXBCZF1UsX7XFzskzKG
39585	payment	2132	2132	1874	1	1	1508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdESsJtZg5DGDCi2DZp5ifZPge5v2CP8PjWtQaXDeYencxFGoC
39592	payment	1397	1397	1678	1	1	15046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxaK9TRhMikgCYQjfrTusDErQU9GN3aERUMTXi6BsB6YPCLGr
39593	payment	2134	2134	1874	1	1	5444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3beUrEtKNkwU5Xs2FkUnZ35nFjgBMiDHqBs7DwZVwbiwGJ42
39594	payment	2132	2132	1874	1	1	1509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngDn2jsBhTSWKVSQKGHMqJQ1JCFE5DWxn5esfpqrsNKLKiT33
39595	payment	2133	2133	1874	1	1	5007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6wo389Q4F1qLnWM1scVssdUWdhRqpdgNBsVUgrPVwTkMfwaU
39626	payment	2186	2186	2317	1	1	1	522850000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGzXWphTNPfsZwEHWUsgBkKUNyZY7BVYnqCR9BrexRVSRuYrs
39627	payment	1397	1397	1678	1	1	15055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunW3tuayaMLZDiZ9eRjLYobKzBWbhCtXnbFMckWcZ2weQFTG9
39628	payment	2134	2134	1874	1	1	5453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFascjWZJkt3BUJkMf8JfoGvHaYX1dEnyuYQkpwo2MdVkHUdJg
39629	payment	2133	2133	1874	1	1	5016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHQCth4oLumEU4ty6QumB582jVnwB7aipJ2RSGFXjPJts3fXB
39665	payment	1397	1397	1678	1	1	15066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EEhfrXP8zoG15vxh5ZEcZsKdnDK4Rmx3zeRobbXvnhXfFBPc
39666	payment	2133	2133	1874	1	1	5027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehrB6F9gZ1T5aYaYndA6WhpG6Q8Ua9RPurKWUBVno5PsAgMEo
39667	payment	2134	2134	1874	1	1	5464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dDJ4CAyHj2fVxz8qzkyoe4DztSTr8jpSwnaK9fLExchJ4eAh
39672	payment	1397	1397	1678	1	1	15068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmCKjW3uwgPPgCHc8c38nF3xUbZGJtqaDT5gCBJtnbiJ7zVH2
39673	payment	2133	2133	1874	1	1	5029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewBPDFnuqkLRPA2XfppBVJQuwZUAv1d4tD8vnu7WtnaXRxcPg
39674	payment	2134	2134	1874	1	1	5466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GkDzxnJTjN3PR2GZNSmCHbayq2ENRvVbT8dSgHgb75J6rjCq
39684	payment	1397	1397	1678	1	1	15071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Du1NCM2FzoFaazGM58Wv8ib2yWREtayWWFpUnPPgHf8fDJMi
39685	payment	2133	2133	1874	1	1	5032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJN2eaDG3ZcxpRen3u2orcGunEhGoTYwSyt5rGewa7Rzh6mPev
39686	payment	2134	2134	1874	1	1	5469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRz9fvgWLkGMaUvUwdt731j8cjzSa8fB5yryJfG43Kahod8QDH
39687	payment	1764	1764	1208	1	1	11	2468000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZogdtptdiMLiDn8eKkreokhWvFTajYZXiTKVbnmjJA6HUMRwJ6
39698	payment	1397	1397	1678	1	1	15075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxSrmpNojz2UXgvN7u7bqtYXHTZ394iGQ1sMTJwk9HqYPuVXn
39699	payment	2133	2133	1874	1	1	5036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQks3cND5osTxmzqiULxZ58xXG3enyYSt7Y4okaL6grRCnGN6z
39700	payment	2134	2134	1874	1	1	5473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuH82NS6PAvcTCNBYzjmgf4CCE1eZKUiBtkke2fbwTZDm9iVAQ
39711	payment	1397	1397	1678	1	1	15078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rs5tyuJdHfR17WB5CU6FndCsXHm3iy3JKfJfBzB7E29Mxeiy
39712	payment	1397	1397	1678	1	1	15079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFG1yXqZgjv77EVtq5dHBkLJVKeoVbuNAd8Wc4qKGK1nLTtx5
39713	payment	2133	2133	1874	1	1	5039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRnD24ZnVJBZwkhdYvL4PJbPAKe6dgNrZBzy8UJ7spFDWRufx
39714	payment	2133	2133	1874	1	1	5040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyBjbafdSmtXjG6HZnJPYZAQtJQHCKbK7fJ5tG68R49qbNYVy
39715	payment	2134	2134	1874	1	1	5476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibd1zHX15qJa7dBYSNfb1VqmkuvVpsaYqvWNh4LPJ8dU9nYTZ
39716	payment	2134	2134	1874	1	1	5477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EX3wdQVswHyayxsdckyX2bgs2HPvNVGFBgw5BCEXgc9K5noY
39717	payment	1749	1749	1081	1	1	21	4490000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpZr65d9Jrio9oJDQuYyWFMSTPPaUCxUMtTDJw7Q5Vzz51V5t5Cz
39718	payment	1749	1749	1327	1	1	22	8442000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpZVUUgyPAdupjShpVXjo8R6NBXhZj1dQYQUsSUEmVVczyVCZBKV
39727	payment	1397	1397	1678	1	1	15083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmax3VcFn346bKHxQgJ55u5H1hhDi8WCSxJoBg1wmLHsF6W8E
39728	payment	2132	2132	1874	1	1	1520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt19XfPMrL1TR2yukaM3NdRoLM5iPC2jghgJfXEticE5iAU1Tb
39572	payment	1397	1397	1678	1	1	15040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATgddePU8PkqZY2oWQXHKFAT6pGDxLRSidRLn4PgyyotS4vdN
39573	payment	2134	2134	1874	1	1	5438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNihuCwDYHaVuj9KtP7Ff8CC8brnjBdceSMAQC6sX9HTgJCgU
39574	payment	2132	2132	1874	1	1	1507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtFcbjYnki1WaxE6PjZMsRD7o85iCKuyoaPKfwwb1K3Gy7fWp
39575	payment	2133	2133	1874	1	1	5001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHEgHHLySxq38xDybK4h19Zg5hmoB8TMUUNY5KDT84P1uMBe
39576	payment	1397	1397	1678	1	1	15041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXu15AforxoV8fBgCAFuc9eoTCowAPrbB3aqRarmJ1xeu1dvg2
39577	payment	2133	2133	1874	1	1	5002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsj1UXeK2G4cQkLTrcqF1PYhX8Rtq58LenNPnzdC2TzYTMobEG
39578	payment	2134	2134	1874	1	1	5439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVFLWUfyfJmFHppYugVEWYnaZ5Ta7DYWBD15QhK1oNdJTw2Y1
39586	payment	1397	1397	1678	1	1	15044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWaWmpgVcZUz4XGKfGFDhUrzYkCwK2F4YKjYRLWFKuuub555E
39587	payment	2134	2134	1874	1	1	5442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQQpMtcGkK5DLYrk4zn7oZxJaPoNiPuXuD9cd59WEGnTvvSGs
39588	payment	2133	2133	1874	1	1	5005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWBzBjXr87cTGohXU9AXyDFztjGdrXRsmUBscnEygWsk6xinn
39602	payment	1397	1397	1678	1	1	15049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmACcbaNf1TB2yQnixxg2bvSJYGeQS7jZ8ViHcHRcwZ7QaGt9R
39603	payment	2134	2134	1874	1	1	5447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfHEeFJGXcC6hBiiQhiWbn5TCNWVp4aAXMTYo5Ntgq94YEnuc
39604	payment	2133	2133	1874	1	1	5010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqyyfqCWxied4tEm5hAMe4wVfrK7aKb6txUU7gCRmfr81BJ4n
39648	payment	1397	1397	1678	1	1	15061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt39bLoE7fhMz8V41uogZRD5ZkuiZiRJKDt4E6ZUh8ANexJrn
39649	payment	2133	2133	1874	1	1	5022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydByXr4cZRYgwcPR4RZ3tvFbjnSsWsNT3jg2uA65hfUcVhVFo
39650	payment	2134	2134	1874	1	1	5459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6Qe2qMwGLgfoDxTQzD1CmG9VJYGm4aq339SFG2e2JAUe5cue
39658	payment	1397	1397	1678	1	1	15064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXEmBgVVZFzVgGNVYwtDd4irknbTKzoDNjmrubt2hyEszmYr6
39659	payment	1397	1397	1678	1	1	15065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW43MEPQX8Wz19H5F6rVVpozs2CvXZoWrR7sinT2viwHKoCV8
39660	payment	2133	2133	1874	1	1	5025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBjKXK7BDDMMwvg1rouPnRHFoxUeCzuDyoUx8HdgNwcKUob9A
39661	payment	1769	1769	1769	1	1	59	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhD9Cr9XhrWAA6rabkHxdHUw2iK77SEz3DKLmdPygNZNZJaoP
39662	payment	2134	2134	1874	1	1	5462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcR8F95cQRzdSW9SE2bJPDXcT4F9ad7i86dF3GukCbzQYRZCX
39663	payment	2134	2134	1874	1	1	5463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEs8mkL96x5V31qTRy5CEwsgdxk5zQruLniA6umPnpsH5r4K2
39664	payment	2133	2133	1874	1	1	5026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTJwXZfgbQdJjUV9DU7PQr7TNR5ZB7zNRpAgbmzSJff3mHhY2
39688	payment	1397	1397	1678	1	1	15072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KYhpyqRmuTN1Zh72UpyvYiCazNG5bjLn3o5VWYoVACcnzTAa
39689	payment	2133	2133	1874	1	1	5033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7ospajTZxZhMmYkstw1HuM5nmqZGgTggHikpr821sH27EqNg
39690	payment	2134	2134	1874	1	1	5470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuo91deFt68PPVHS4npUGgQzwL65cQ9k4z3ESN6GRhDUuBeJF7
39691	payment	1397	1397	1678	1	1	15073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyr2YZ1tpGHD8B1148W3cnUATRJm4zNBiKeKfRAsJkLA2FMhCQ
39692	payment	2132	2132	1874	1	1	1517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYt7Lwhdfe7Kf8muSxnDNXiYoeYRLD1cQur5589Mn54YRTgiqg
39693	payment	2133	2133	1874	1	1	5034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxe4sjwqsUQ5ZJr26JkUMmkk8fwmey9xtYRCxm7JMEPoJte8a
39694	payment	2134	2134	1874	1	1	5471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSXCcdyDawq1L896WT79JS1z2FcEpNEhsQEKXRKeDa2ADUrH4
39701	payment	1397	1397	1678	1	1	15076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tis3JJ5GTASi4cAwx7WcHq3fshGa3wFTa6JxZjzE9UKWW8JX
39702	payment	1933	1933	1749	1	1	2	1903000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpJG1pMsmP9YYsixkLiygmhSE1V43xFuqdWCFcxzNX8VVVAka
39703	payment	2134	2134	1874	1	1	5474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GZ6qpdVTadNFPNPdZQSJ5jweXQBH39kcMe7YCvoZn4nVk3Uc
39704	payment	2133	2133	1874	1	1	5037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZ4oCb7MJ5jvPAYKUDL8d2PmvowHMAc3Xx17LqqqVHyKUFv24
39705	payment	1749	1749	961	1	1	19	2505000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	Ckpa7myZr92hW5PZ3sCajhQRe2CsWvhrCS3NDaJYSV2M2bp1TUnc2
39719	payment	1397	1397	1678	1	1	15080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnja4K7B3Ku43wbNbiKwFEgj4bVzfvCYf5bgSHrZ5vREYdniZi
39720	payment	2134	2134	1874	1	1	5478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxPin9qW9p2YWoCS5B4YkG223mfgAsC9vzPC1iXuHfh26rW72
39721	payment	2132	2132	1874	1	1	1519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHtNcEn3StNz5YKxe273dFN9kL6h8pjQQarQc4iyRkum5YkbY
39610	payment	2134	2134	1874	1	1	5449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzNeqhCZaAqAx1mXUNo4VaSgAJA3uQF5yYPabc8k9tRAZ8sgS
39611	payment	2134	2134	1874	1	1	5450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC2F769h1XJecore7F4yjZ4Q3MfKzrd5bq9eKxF1URkUMXFC8
39612	payment	2132	2132	1874	1	1	1510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5jBR6Ucnk5ZXAg1FjYSBYqMjz8UyqLrVtKTyctfZFAxwvj5Q
39613	payment	2133	2133	1874	1	1	5011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATJJVYiAyNUPc4jpCrhYfiU57FaJD8KApeqYxw774nx2xLSRo
39614	payment	2133	2133	1874	1	1	5012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp42JJRy1Mdd4VbqxBwyHBHTqaQCuafLV6137J4zKBwbj2cbQm
39615	payment	2133	2133	1874	1	1	5013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNzvtaWCWdPrTUVCh8WJbG899z35Y7x1YkMtqp3ZUfvG1WQtU
39616	payment	1397	1397	1678	1	1	15053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wUPVBNe16hDdmnzZwqDyzURBHhSTHNrfJPVjYk24UmZW7nLz
39617	payment	2133	2133	1874	1	1	5014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8kKcGDnvvZvPA3M848fGiYWxXcoJFcpg5qrNTdLQUptDaThJ
39618	payment	2132	2132	1874	1	1	1511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikN6k6LqYiKnbUBmfP5aGQLpnTH3FEUenLUAFVt6QPi77krBK
39619	payment	1759	1759	1189	1	1	8	2917441500000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZjnAHgUPybfWoLFaBdiG7n8BdmtKieVR69vhUaincbJNKDaAUw
39620	payment	1759	1759	1069	1	1	9	4323929650000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZ67RPGVgp6JAGjUTxA4Hsh3bJuJMqjxQGtVfGyd2oqhV25F6eb
39621	payment	2134	2134	1874	1	1	5451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnj9dzecrqW2HruvR7JD8R7DmbCWZTetDDpZqT1GPbfWR5sD3
39630	payment	1397	1397	1678	1	1	15056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhuBt9UCbQ9MiXRo9Y7x8Gq6EV7ZocikjGwJ29A2dMkns88HR
39631	payment	1397	1397	1678	1	1	15057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpVDTHdX2QPpQeEcgLj8zmbaiUxDUAxXf9nkUc1GxJmHJhbC7
39632	payment	2133	2133	1874	1	1	5017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcKf8eWP1ZQPcpwDS6eRCRqmj5oy8be827W1y2FWPkb4zs6iU
39633	payment	2134	2134	1874	1	1	5454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVW4aYshFk7YNU5vGBHxfx7c87RUDMJMyzry4yYrNVNZLU2jT
39634	payment	2134	2134	1874	1	1	5455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgd1obAGWZgJVxwwm3t1kxXejNfg3XwmJniGYQbq2is9zFPYj
39635	payment	2133	2133	1874	1	1	5018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnzkUdRjmwnqZgDT9brGaGvHsYArYTGhW8FixpV14xuG5cNEn
39636	payment	1764	1764	968	1	1	8	2041000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZyiz6K5zqD87Y29RWSHr6wK8Pa5HcQarDyCJs3dD2cgXjTYfLf
39637	payment	2132	2132	1874	1	1	1512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDuDRZZVsWiALDJCRDahJWV6AGQSFH7vEay2AQbC6yzotTbtg7
39641	payment	1397	1397	1678	1	1	15059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGWMy59CvCttPBS7D6WEsddNWfLCSb67QVJ55LbHgGCgGB7wr
39642	payment	1397	1397	1678	1	1	15060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEK8ax7JxqbJkh1KpxKvPP4xw2yEzffv7AALZ95m1UGMYgMgUZ
39643	payment	2133	2133	1874	1	1	5020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZnwHMq4faHK9RDYjMsYmQkmLznea2iA8qXquA2gMCzd5KYQb
39644	payment	2132	2132	1874	1	1	1513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAHKbjro1KpLMThfJZGZR2cBtBLgrKCRdkgN1vziPPi9338Mr
39645	payment	2134	2134	1874	1	1	5457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSJsnNWh8J69gLio83c6F3objaPSLY53nyxoWopftKRNzP1sq
39646	payment	2133	2133	1874	1	1	5021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkLMLWwCgiF2itXfXi6S6LqENS7PQc2ZseaPmQJ44LGk9Xwhi
39647	payment	2134	2134	1874	1	1	5458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbquyK2sSXviZ6K5H4W8dUobMWzTm3Beaivn5JjEhF6YnNXBU
39675	payment	1397	1397	1678	1	1	15069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQ2a5T1p7LuBLjLBmLRKNvZwRE8RneumzuUJYaucCDRV5hpYe
39676	payment	2134	2134	1874	1	1	5467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eAuwMeYompbB4GjNXcNqmmJVpF9X3fDPHBuKKeE4renuXrRZ
39677	payment	2133	2133	1874	1	1	5030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGF6DoYEhgbMhjcTussFD5DgVb9kGYURe2S2JSJEXTFfMjSMr7
39706	payment	1397	1397	1678	1	1	15077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM2hGFTnLihjrfsbsc8ay6kkWnXvfWC9PH6XTThsNJF4n2i6rt
39707	payment	2133	2133	1874	1	1	5038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgS7LLVtWkykv4NBc1mUGm87T3NRX9xyFgFcoe9kcdqvqAk6Bk
39708	payment	2132	2132	1874	1	1	1518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35EX3u6saFyjxUWPYrCTVZEZHTPQEFEcYoMBExpsnwPAU8A7G
39709	payment	2134	2134	1874	1	1	5475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHdkPoYaYZGuUnxNmfShbfi5Z9q2LdUNNDPWQKHEZmn8u7KMQ
39710	payment	1749	1749	1201	1	1	20	3029000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpaHg2WEnbFQ8upBsL7gWqFp9fPLwBxF1EN4dGvjm3RHL1xjkWDS
39723	payment	1397	1397	1678	1	1	15081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WG4NXyGq5i4erDJ7WQR3VR87LDTQWFEjzz6xbvyFySTMqDNw
39724	payment	2134	2134	1874	1	1	5479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xYHvsdmWB4TLkgkvcnNJfHH6Sd3h51cMv3er82Cb6SzZD6G8
39725	payment	2133	2133	1874	1	1	5042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY38yC1HzV53H9dKRLtHWtT4JJyot6rbPgpYihcmsPJNuHCrV9
39679	payment	2134	2134	1874	1	1	5468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAiipddnnAEpc59x9YpVB2TWngeEPYeTt1vTaCb2E5ecEeAXP
39680	payment	2132	2132	1874	1	1	1516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzufdRpBeNtt2HE3uYXwZ3CJx54Yc4Q92YsnSphMTJzwtncgX
39681	payment	2133	2133	1874	1	1	5031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6X6v4fAhvKTNH4vZhg8BKD6dmVrzKahTw4Rh8NsKTo8TbkHe
39682	payment	1764	1764	1088	1	1	9	3658000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZi9kezX6NaVabkDo1ddtDzFPQscbeVHV5LkCeyoB3X2p6URHPJ
39683	payment	1764	1764	1334	1	1	10	6878000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpaEkAH9f1QjGW7aQ2oeasAEaMAY1qWMDBRsRksfh5PyFBKs2xi5
39695	payment	1397	1397	1678	1	1	15074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUrBruD7MDPM7WFMoxq1YD7p39gEo3afrVTsARkXkcr2yNnZz
39696	payment	2134	2134	1874	1	1	5472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQas7T8b9omSqhBLVUmK8c5f4pCuxnqrZ1RPwV7s4ZLGBwRWoA
39697	payment	2133	2133	1874	1	1	5035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHS28UvnJAkTxwBN4HnKfigmMozAPaeQcYyj2FTiueuvEt839
39726	payment	1397	1397	1678	1	1	15082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hH7XURDnFSmbNgZJSqQn5vfJ5QWD9F1JRkETVidD9JzZ8Fzb
39817	payment	1397	1397	1678	1	1	15110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhacV5op4d7zYNYtdowa1DMegWoU6gYEbd1bUMFop2pkseY7LP
39818	payment	2133	2133	1874	1	1	5070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsrNkkSw6FTFA9UobntLPTtBJJpvwEUu6CMPKWesK1KZCAHzz
39819	payment	2134	2134	1874	1	1	5508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXSEuAd9LHMrbMnWZ3a5TXjKAm55iujj2TdXXFoLWLUNF5amQ
39820	payment	2132	2132	1874	1	1	1528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxgoDL7U6JQXJH4UqEYKe31LJPcCqymx4F2HR9BKNMJNhKSJg
39834	payment	1397	1397	1678	1	1	15115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5bFCHhCkcX5ViwP2XQ25tV9rpVcqC6VSfoJhW4m8MeNUWWJt
39835	payment	1397	1397	1678	1	1	15116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnjQMpY84TUp3ENHJKAf9zW8koVxRV1tKzpwhVNBQFXbrymhv
39836	payment	2134	2134	1874	1	1	5513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLf7J9i8Y3hZe7Kgv6AtKP8qy5w5RNBFCSSr479m5MpjLEZdb
39837	payment	2133	2133	1874	1	1	5075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YwJaJCrQ3G7rCEDwxhJbRrmeTEmVtCwa5GTEqzETP6nEyK6v
39838	payment	2133	2133	1874	1	1	5076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9PCfV6HExTQ5JF2Q7zVgr7JWxjUR2DWmJanmeQsjMutW625R
39839	payment	2134	2134	1874	1	1	5514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNqv6sftqY75AN3rQuHTmvBShhDoqtdzzJmK1YEaNVKhVDs2b
39859	payment	1397	1397	1678	1	1	15122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQxwYuhQASDmLXBJfqFUWjCur1StDbwQ3S2575Mjm4MTBows1
39860	payment	2133	2133	1874	1	1	5083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dc7bboYpoisEkeaH5CuHczXmsBQ4royS6sZsRzGEVDzGFmLD
39861	payment	2132	2132	1874	1	1	1532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Zm7YEGZJobRD6LoqmBiEQLyPEhUnu3xPetgAAnjheePAU2RN
39862	payment	2134	2134	1874	1	1	5521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJyePvPoybWMyXAU5QJDguNGL16zVefKPT6ZypwZNXdXha3SR
39876	payment	1397	1397	1678	1	1	15127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpMehm9mtFD4ymunEneJaHRbzWMZSvYbCUo7u4Q8wTcJKubYQ
39877	payment	2134	2134	1874	1	1	5526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesagoA4bFMMagsXqHmHRxzAWNnhjPYkxQLC5akBc4MXTrseZZ
39878	payment	2133	2133	1874	1	1	5088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZxowtjF5Qc7kDEJ1k8RBdQqgFKz7gvgFRoibG7zEUoBa91e3
39882	payment	2132	2132	1874	1	1	1534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiax9SexK8zRaCrok3mK6aSdZ8gcwzCApBJduWqRvHd4bPYuQB
39883	payment	2134	2134	1874	1	1	5528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbQSGKUKwzP1kxuuHpcCDr43oaKJocZEGg4r6xS2Kt6sPTN6d
39889	payment	1397	1397	1678	1	1	15131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UqZcNo51sSSUJvF2WMrj6xveNLmDfWWVvXm2FPGSfbWzmyKB
39890	payment	2134	2134	1874	1	1	5530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzJuBR5LeYZa1GGTs9RyA33BKyX28vxEnKiLxfpj5h1qEYnAL
39891	payment	2133	2133	1874	1	1	5092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTw9kYoHa5bFWnaYoUMZLhDMCqHJbcxpCGPJZor48EQtecb25
39892	payment	1397	1397	1678	1	1	15132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRordwt1Mc7pizXE8CE9vtpo3YK44qotHVp1KEvjUzykyBCg7x
39893	payment	2134	2134	1874	1	1	5531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCJU47nYfmH1hHuAZM3ik83zSz1GfDFFnrQnG6PoBRdLcPS48
39894	payment	2133	2133	1874	1	1	5093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxihnoN5ZvR2PGVZtNkzRBCNYhWYiYiLPZKXtLv7SGej2Liu9L
39895	payment	2132	2132	1874	1	1	1535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMu66UVrJ8kBqtrkSuLNMXvcgVPxcp81FZWJv2xHjWNRYgRMBH
39918	payment	222	222	2321	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VD7xa7iURE2Be1ejEUkcN894v87UStXSJprCVdgARetyeAF5
39919	payment	1397	1397	1678	1	1	15140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFthJNVCWTEh5VtcjG9UvvtMyDFEUEVhi9NVQtgACPKhUt74vu
39920	payment	2134	2134	1874	1	1	5538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5jgNRokVbe4X1j5jrbehGJRRJqwwhcfMiwoAiSQpxnMi5zvET
39722	payment	2133	2133	1874	1	1	5041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSVmnxYLMkfCMor8hc5wAf5dduYYfq9CaQmZsdczaEbb3tq3C
39733	payment	1397	1397	1678	1	1	15084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpdioc2cxZTmiEmEgZuo8hEgcvtRkHCiGJvRmrbQrJEJ38Knc
39734	payment	2133	2133	1874	1	1	5045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKaT4bjq52GsJkAmEAsfi9AhSgmRV1ttpipbswfHmszry6RCa
39735	payment	2134	2134	1874	1	1	5482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGA1dYs8LjEcNdj4E64v3HDng8ZYjJRyCp4GHRzTB4Rt2Bie6
39749	payment	1397	1397	1678	1	1	15089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrchoavbiqnXxjTZPxiCmapjfpNvUNfcbSxZZHijZXKcmLNdM
39750	payment	2133	2133	1874	1	1	5050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9rUFcR2uiJWa8cKHWtkBCFTXViyjYisGKrE4ftqVcwT1ynb5
39751	payment	2134	2134	1874	1	1	5487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3fX5mhAPBj7KEJMmTh3xxpGBotZGw5Ue6qoQU2ccK4jnrhfC
39752	payment	1397	1397	1678	1	1	15090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugTXmbFcZr6b51GChomFu9L7YcKSuxkq7zBtEKKn4hmufxheh
39753	payment	1397	1397	1678	1	1	15091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYcKQgtWnW8tG9NeCZ5uxUbm5s5i41RijPVNrVgfmCfq4bdcA
39754	payment	1397	1397	1678	1	1	15092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKagfY2Y1HkodW48Maery17ugXsKuwyj3y3ghjEjkGcUEMpEc
39755	payment	2132	2132	1874	1	1	1522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvHrTedwosYzSWw5sxw6FUdSPRGS6fnskQJ1Hh66eob2DjUA1
39756	payment	2134	2134	1874	1	1	5488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqRRZ4ob26YoxeWfSYRyZDWcDYJw1uSn86r1UNXCjvhKEttn2
39757	payment	2134	2134	1874	1	1	5489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCXcDF1ePRWhnjVcubBbHWx6ANAP4XnPdZtFMhmBqjocNJCau
39758	payment	2134	2134	1874	1	1	5490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtJLf7rGS7Dk374dAKe7M3WCSfFaUjtwDohNuuP1nedMuCPjC
39759	payment	2133	2133	1874	1	1	5051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuyVvMvRMeHvub9zU8Zvjg7WGz3iPvqvdokM4hCTc2qh6CDPD
39760	payment	2133	2133	1874	1	1	5052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8haQjVY4K3fZP9P69foFNMMtw3fFDYxgiFdJj8ZYrzX8ZPiR
39761	payment	2133	2133	1874	1	1	5053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeBEazsqJegJD5Pp6aHfSZdhCGTEvX66PnXbkQRZazm9UyXP1
39762	payment	1397	1397	1678	1	1	15093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRhfFrMHVH2RQYTbwJR3Xk1jfam1Fv4ekKki8wyHhUqLaCdY8
39763	payment	2132	2132	1874	1	1	1523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7k8b7NBbQ62AoM4tMh1eqmBjzobSh5bZiP3aTTF87MGJeACo
39764	payment	2133	2133	1874	1	1	5054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV3op9VJAugQRC7uD56CEz3g6fdPaDCkYjGu6VLE3RYj8rBqp
39765	payment	2134	2134	1874	1	1	5491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiDDKa9pCLgApJr5wJ3GfDoRj6wEta2PU4sFmjNHYa9kvfA5T
39766	payment	1397	1397	1678	1	1	15094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6QLpvY1KNBN2uCHkzFZbMrsoZi9VfnpNzfBoz6LUwkmzPkGT
39767	payment	2134	2134	1874	1	1	5492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3rtnhqMJYgFGsz2hAxgB5bZA2c398B8sGhGBJTKhMGMWTS8y
39768	payment	2133	2133	1874	1	1	5055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5bpKRRJ7jR5Abnps3rvUqpxkA3jYcLRFNx669aePqE5q3oEz
39775	payment	1397	1397	1678	1	1	15097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsddEBVJ2Tk1VF64p2F4fJv4PSP73JBZ49KAuyg2oHozFXszPX
39776	payment	2133	2133	1874	1	1	5058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaP9NP7vWVnjaCckwE6zLF3QqeGMW6QtpDCbrR4Cnky22Mqif
39777	payment	2134	2134	1874	1	1	5495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkU6vwkwoT92U7SKbyLTWcWYaXXsWGhjYo6tQLiVwzToumzGV
39778	payment	2132	2132	1874	1	1	1524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7ZmZZshLNyCC8uMCuVtyvmYpg6KtuAxc48PJACzkeDLDUETs
39798	payment	1397	1397	1678	1	1	15104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts2pgEtohyW3Kb8Q1RcwtrTXUtwCtY4QiDQoaK6WBS16ytN74
39799	payment	1397	1397	1678	1	1	15105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXoVgwq4epESsSufVayPfsLjHhLQtbMh9xExPHD19cyCKPURfu
39800	payment	2134	2134	1874	1	1	5502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1KK2rg1LHgMqeva7pLrEyFTER4LT2MbaB4mFJmE8H7XuinEk
39801	payment	2133	2133	1874	1	1	5064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuR7UwnS5d1z3pjLZytw3Fm4xuxR8XeJPsMYZq5Zm37umnBEnk
39802	payment	2134	2134	1874	1	1	5503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2bmQ4MZfNQj6sPHG6S6Kvd3Bz1AQm1Q9iV31B1xEA9qAjzyM
39803	payment	2133	2133	1874	1	1	5065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPfmwN49ygq36AzraV8LhndKjKHi8dyGTZ9PDEe4wAMyv187q
39811	payment	1397	1397	1678	1	1	15108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZPbrKxisTmxqi7bjssAZVSqcXrA8jc8avEUxXje163coTckQ
39812	payment	2134	2134	1874	1	1	5506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR7pET7E3cQcLJhj4MFfkCCp25oHU2WyukdopHBWJDiuqepUC
39813	payment	2133	2133	1874	1	1	5068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsWBVMNBPfhtuvV72isYMyA8tgfNuxZzV9CGWQezfzgpzXGpg
39821	payment	1397	1397	1678	1	1	15111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qrhG8Jr5fFJgo43VaWJuq1yfgrmfXQvXLtQb8p1NBj4hsR32
39729	payment	2134	2134	1874	1	1	5480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzUEPhEMNtRZWwGvj8K6r8zZNQeMqZSRnAM4BWanGg82e5rYi
39730	payment	2134	2134	1874	1	1	5481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeJ7db4mg79awzNCUmd93Btff4wUGYQD1WuSFbnaevt1fh17F
39731	payment	2133	2133	1874	1	1	5043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKr7114UssY5BpuVKDKfLb4Roj65js6EYKouzbLU2KSH8ARhP
39732	payment	2133	2133	1874	1	1	5044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBFKNH9vVNXVEpMoSUejBJ1ev1sXsxM64dBmuKyh9HL38hFjL
39736	payment	1397	1397	1678	1	1	15085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AtoYiNn99gBgKGPpVVhHEvRaui5XFfMu2UdFvyikyNhbCBgy
39737	payment	1397	1397	1678	1	1	15086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T8PWzbSeS5ua2ptujJduFMTxJsCdFkP2DanBsNkZiAxkWJ3N
39738	payment	2134	2134	1874	1	1	5483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusisR6qDo7bT5vy9GLxreSrB6HfnbJXEug14VCzAtmMYVVhK4
39739	payment	2133	2133	1874	1	1	5046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG5oC7rTQEVWbGVAh35VmarHSSjfRaBqzchKsZP4FcrknhLqD
39740	payment	2133	2133	1874	1	1	5047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUgKRy46Lunj84EG5hSJgMJji4YKKEr9Te7A2677zjAnCxazU
39741	payment	2134	2134	1874	1	1	5484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVq8MsXczVBJiXBQM5ZRn67SUtQnaSnV8J3o2GyxYKTmjAbfYW
39769	payment	1397	1397	1678	1	1	15095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLJV2veT1pdq4rchPGdTqbJR45yNPeLpG8LPGB1ykWouan4vc
39770	payment	2133	2133	1874	1	1	5056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6cAfHowC7pVQ7aFSgmybnHBphC8qSx9Q6viMx2oL3jMdAtpD
39771	payment	2134	2134	1874	1	1	5493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm7DvAcjtT4y2duLRgKgKHa197Bc4YK1djZCCvjFi1kepyaDB
39779	payment	1397	1397	1678	1	1	15098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5FArGwuUiXURfa4MjoodarQQKUPEkVP6qCoe6i51hnrLpFgR
39780	payment	2134	2134	1874	1	1	5496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CQAcXsYQjVgLKF9SbJ67yvLcZ5gJNdqPKUgXooi74csELQPa
39781	payment	1397	1397	1678	1	1	15099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLWGCvx55ZKm8PBmRgGGNA3rvmsea83VWs5GUDNEaHVypHHX2
39782	payment	1397	1397	1678	1	1	15100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes1cx6SMv1vDrL3L7bFnRte2no6Hy1RBL3upyi2qSDtiYC9gn
39783	payment	1397	1397	1678	1	1	15101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N7YoNJD4VVHs7aRPkxEmDLotGVZ3Dvk6LRim5aG9jdnnX8zb
39784	payment	1397	1397	1678	1	1	15102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4gDwBNiWjdd4xE4WqnXea3eqxBmP5Uwszded8NstvVX2RMeP
39785	payment	1397	1397	1678	1	1	15103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTqb9Ay9RBZyaXk56fUQuTaU6AbT2e6JJf3Cr519nRBaU7UaR
39786	payment	2132	2132	1874	1	1	1525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBUi5sRKjoDFVzUfhamiiH8h3W5NepnEJM97zNcY2R4w8jtfL
39787	payment	2133	2133	1874	1	1	5059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuX7zAZXt8dD4oErybhCu56CXBMjDZALxJbUyZUwHFDWSYzdzt
39788	payment	2132	2132	1874	1	1	1526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbgTZhVn4qgYeixrWYBDPxt1getHu8cJczUTK96pXtfd5TPrF
39789	payment	2133	2133	1874	1	1	5060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfEU36hSPhK6GDcpkibM5nnezvdhzfn8MmeeoHEvkzofC7Goh
39790	payment	2133	2133	1874	1	1	5061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3YHaQC2gtB27wrjzebZr9JbCEhzKpLP7aPYe6uVvpiGsKcKJ
39791	payment	2133	2133	1874	1	1	5062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY89eJPSd3K6DQvt9L5BRAfkQYvWWGakPTXyAYLC7Y4TNGQGy
39792	payment	2134	2134	1874	1	1	5497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwezu61qfjBHffe7z4MYGkyjrKhGMtpTNBeJ2XG9oDKqJekvv
39793	payment	2134	2134	1874	1	1	5498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWyfKrSAm7yMkmkjRUZuC9MBhGt9uQqyRKv24CUwtDPGE4a8r
39794	payment	2134	2134	1874	1	1	5499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aepVC4MvcnEPvT3Nfm2ZCMkfAt9hcHojiqyXjUpTCTkjPKS8
39795	payment	2134	2134	1874	1	1	5500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBB73A8e5TBJ4Fq6ttwG5NHVo488iR7jA4XxLrgQS29uhJvHt
39796	payment	2134	2134	1874	1	1	5501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3pWgmNGtUZpCakTpWpVLf6jqVfpaTXQeUkqxKXeHwNkvniwZ
39797	payment	2133	2133	1874	1	1	5063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwApv2Drkv2EFNkixLH4tCaiSupEaixr33sAxyD7n2fzq6Knx
39804	payment	1397	1397	1678	1	1	15106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozr5ojNu2uF2kxQdHFCAVaGoqu99QuFmtWa9to363E78iFdke
39805	payment	1397	1397	1678	1	1	15107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmKNbtFz63vAzrWAnFES5gR7RFZKVbYq8sE9g6WGimZV64Nd5
39806	payment	2132	2132	1874	1	1	1527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDv5icx1hXm46tjoUXNqmxV4UeCaCqvqiUUZnwCEi8LABRyCC
39807	payment	2134	2134	1874	1	1	5504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpcJiYXVs5KjjLtG5rooB4Q6imobiqUz8JVFYKXrHxauKptnp
39808	payment	2133	2133	1874	1	1	5066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcwEpkPSDDMiUjpznXgfYxX2d67HfGpeZiqfr3giF9uyKvNnK
39809	payment	2134	2134	1874	1	1	5505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nth7N4WW9XgRUaFgpPRDfaTDCEw9TREftHL1ijoe1N9jwuA6
39742	payment	1397	1397	1678	1	1	15087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzC3NzuiwTSqSMyty9auhu8sxJJ9cjARRLHY89WtCobvN8Ly9
39743	payment	1397	1397	1678	1	1	15088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGj1YzxSvspeojQjdBVfABawvMe1ay4bWcexX3X2Yf1VUKxuS
39744	payment	2134	2134	1874	1	1	5485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6E1UA13uqAMbH7ChALx8aahjfQLMhYzXPSBGNDKgv6Bc86DS
39745	payment	2134	2134	1874	1	1	5486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8h5TDxmxnrUNJVe2yGSr8M9Cf9iU81hQ6tc5qG6qdLEHN5i2
39746	payment	2132	2132	1874	1	1	1521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLgZzw6wFPsxgon66bguitHMUTbquRAr4DYxUtjKMdAW9mL3u
39747	payment	2133	2133	1874	1	1	5048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryKLmCwjYPxow68YyqTveNJhKsnT5iAHo6jFvutruRgAMrgze
39748	payment	2133	2133	1874	1	1	5049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9agfptMTMy7a2Qt85vxp6RZ51Li4hVGQfKuQcgfgmPcq83RMw
39772	payment	1397	1397	1678	1	1	15096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2oFHemqc57ZQViM3LzYuPzvXPqhErnDPMEjjF3N3n4ickJRe
39773	payment	2133	2133	1874	1	1	5057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbB3SEr8dhjSUDCqY4LXVq1sJJQsEskjQhxE2VwzkXdct8WF4
39774	payment	2134	2134	1874	1	1	5494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtb8wCFHzk6c5YhGr9pU5Fb421g16xjZLbVr9opqnRQGAhRmL
39814	payment	1397	1397	1678	1	1	15109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmLrnpfneWX49Zg1jeFTsKxK5v9GkaYGUmAU2dgNP5S3iWZyW
39815	payment	2134	2134	1874	1	1	5507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwTVua4jLcANoGwJCpU8WXqLN5RPqeaorRUXhgcm1a4HE3kdn
39816	payment	2133	2133	1874	1	1	5069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ794wgrCJY5VnpNsyzPQwAVTEZmvBzebv4GUfTWPeEPykBMC2M
39827	payment	1397	1397	1678	1	1	15113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSfeQx1cMy15U7WdTSLKmFejgMJET7Xd2bSq3QyU6oQanjfeo
39828	payment	2133	2133	1874	1	1	5073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBBHziZPdBMFz8nd64ZFecm8Sj3UaqZdYM9rTUtcPY61yyjxa
39829	payment	2134	2134	1874	1	1	5511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNttQzX1Z74VBQEF6rDmvHvhcHdygftdjXLeYMhVf6N92WP9J
39830	payment	2132	2132	1874	1	1	1529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgRm9NoUofcHx8JSNNY3JivTRe5gPsZz4gTyEGFN7PcNRkRDR
39849	payment	1397	1397	1678	1	1	15119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzNbyfMv9ggYxxobDphUG6j8P6rktWHCaP9oWs9x1wUGxraJ4
39850	payment	2133	2133	1874	1	1	5080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAC4sKpcubYJztTCJzgTZaHYLsj9qrvosjwLugJFw127R5Gux8
39851	payment	2134	2134	1874	1	1	5518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY1GLYUPfzLkEUWgNKnUC8NSPTpuxfwCSrGLVwzCTyDZQopiG
39852	payment	2132	2132	1874	1	1	1531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5JcwcVbdTPvvMtvXWRoPHzA1Ajgmh71KsfNfRN8YQYsAmrbh
39863	payment	1397	1397	1678	1	1	15123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZ7Hsyu8XyUj5PLRGZLZqCyZFDKhnzcbavequc7noNpdLsGeq
39864	payment	2134	2134	1874	1	1	5522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhdpDG5zQ81UU9n9BMDYfnBBh1wGPEwsoSGBa4rRSdvAovTm5
39922	payment	1397	1397	1678	1	1	15141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEA2bmimvHM2a5n2oAmAmob7v7JwHTHMsYEdsVb9mm1ssBFzSQ
39923	payment	2134	2134	1874	1	1	5539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQGi4gNKxKeFwhaKpXSFox5GhRtFFZN8UE14vKtm7mKJpHcdi
39924	payment	2133	2133	1874	1	1	5102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83Uh1yBDs7ZkjLj1XmoRT1oJYKc2g9t6QPXkxfcyrFNE8xtmR
39944	payment	2134	2134	1874	1	1	5545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsdaqMNubdFgP68y74SrEbNrneneV2fKtZUeRgssSRS2sxMAZC
39955	payment	222	222	2321	1	1	4	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWeGmdm6Dwvgkq4ENpFL26B2iTPsa4uqsZW32icy2KNaigKVL
39956	payment	1397	1397	1678	1	1	15150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRZAPgUK7ozpC6TJW1ibJRjtxfpZQAGARefs3qwumJL7prBNL
39957	payment	2133	2133	1874	1	1	5111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfW8c9JKDG4iDn5kqgHk5P7WjouBAwsUfT3TsDQgCQSpb24cCB
39958	payment	2134	2134	1874	1	1	5548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuotteKgkRfHsQagkJ2bj5j4foJuVKzX9emKzsxp3nGokkJHBB
40011	payment	1397	1397	1678	1	1	15166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZDC8buaQHSPpj7W7HV2chyzx5BpLcSC6Z1kmdsvqhA7vv4GZ
40012	payment	2132	2132	1874	1	1	1545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G7XHCcZG25LVLgyEY49aGWE5vgDbPvJPFefQ6ig9MXUvpzZ1
40013	payment	2133	2133	1874	1	1	5127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEv4jdzQWDDrHVd2cZiSn9ZLBvcaG98wRWWbjSTeRzicL5oXm
40014	payment	2134	2134	1874	1	1	5564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqeFeXT3iongzdV5vBaxMapvtSRvDagUQsXmV5dAoB5qjuj8q
40025	payment	1397	1397	1678	1	1	15170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iHqLkYBRNKzErcyKksMLN2fuWQSSZcC1bz4nzMLzBmmSH9Ts
40026	payment	2133	2133	1874	1	1	5131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxdgJXq7M1SzjewDu1EjsfPwHdMoKn3ZCSzuvtijqPBEptsGx
40027	payment	2134	2134	1874	1	1	5568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGZBpx1ndFQ2WUbjrzK21sKyQ2PdenzznJXx8snGNLp4reXgB
39810	payment	2133	2133	1874	1	1	5067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y3SJSkDcoRj36kxmzsxdMje63rQeiGzRE7Z6jQhRaufKjFZq
39825	payment	2133	2133	1874	1	1	5071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs92obPVJ6n8vqjrKddQKYyvrmuTPeiJxyBaoZNpjLsBciLvr6
39826	payment	2133	2133	1874	1	1	5072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11rahcCCdG97aEmeXez9EqrNVd1LMkwTxVVGYb88g4wnZwHeZ
39831	payment	1397	1397	1678	1	1	15114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZ3NLEEX8CVFQkfFutVdbiDadiRXB1bmY8oLeGBMT7rmZm5JH
39832	payment	2133	2133	1874	1	1	5074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbsHPhmz9w3tEJ23SyhupSxPAoMMPH8sLUAuJD8SyukmtbJfU
39833	payment	2134	2134	1874	1	1	5512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGBndxeZXcxdg9RZY83W29cDuhqKHTNHK33tdfT3NBdJbv2HC
39844	payment	1397	1397	1678	1	1	15118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbG2oF75CQbVj2uTceuKgFbAjiB91s1RE3fkBvZdaZKBE3HvQ
39845	payment	2133	2133	1874	1	1	5078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQMrinQx28n7oLgisbNHYW5HGqXYZLJ9GPyyQTJhEcqhcPp9X
39846	payment	2134	2134	1874	1	1	5516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1N241uTXMDEDsE6FMca4buXGnDqcyfLsGTshTz3JvDvLYetDo
39847	payment	2133	2133	1874	1	1	5079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMcMGLwKejPeq2AVLvskGGiJXapDG5BcyrZJ1So9NFvmkQ55n
39848	payment	2134	2134	1874	1	1	5517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvno3XB2eL5cJ4pFiocqKQmqK8LXWJhytb5APbLrKEnWQoP64M
39856	payment	1397	1397	1678	1	1	15121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4paPW1kG4ULr86obys6ZP61d5mMtFBBVB3VWs6jYSp9BSdAYT
39857	payment	2133	2133	1874	1	1	5082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4VQK5buEcjUQ7UeoSxnPRjVSHaCwNKacCWHEu5QZoaUY6vCAD
39858	payment	2134	2134	1874	1	1	5520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebqLyhTWV64tWqAMs2GfubkYMN7vfHxCw8opppD5Rk267kLMr
39869	payment	1397	1397	1678	1	1	15125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXjkUqD9orWsSFCJH31bzMhEgmxp2xUHq3rWpjRoTu7oSamcb
39870	payment	2134	2134	1874	1	1	5524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3rAhVr98Yr88r7WAmu9jfM52q7vBCdCbPpBcNanYPBCU6bs6
39871	payment	2133	2133	1874	1	1	5086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFv6vEAuRXPk5My22SErjGsiamRXDV3PPCsg3FJJFiV71Ytmz4
39872	payment	1397	1397	1678	1	1	15126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgFKzck1FaMeE7SkPa2Dhc7B68BxaEKmSnrbDhdtAmaqam1Dv
39873	payment	2133	2133	1874	1	1	5087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin9kZv7TDTSms31SvhkA6WwH1caBjHga2JvzLia2iCw8SRpqy
39874	payment	2132	2132	1874	1	1	1533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktwNzsL6koQAuQaJbFCZnEWsgScWvn6K4mW4inGaCmRYSm4dg
39875	payment	2134	2134	1874	1	1	5525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mafwRTddwmEkatV92gMGJLZWAFnx6BxF9SsWebUpmXPXiXcv
39884	payment	1397	1397	1678	1	1	15129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NnuTjUrt8dEKHvu8FYZ6J2MbfzSd1wwxm5dCJZGMjJNZZCo4
39885	payment	1397	1397	1678	1	1	15130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEjbm2gkcGYp5bX9K38kp5XNY8eGH8JVrS2c4JHkZLdszXity
39886	payment	2134	2134	1874	1	1	5529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HuTyYwR6yGotYyViboezornxKuEsvCoMytHy81afYU3HFeEc
39887	payment	2133	2133	1874	1	1	5090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEFeHajQ9ms36dYLek6FNraSfYYkM3tCnZJZurBrAytw5vQS7
39888	payment	2133	2133	1874	1	1	5091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBSHoWiCsmzwrBky8MsXmMqPxjdgvKNWqae5NduwYFz1GFSve
39905	payment	1397	1397	1678	1	1	15136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYighPQdXUZQXuQ93RdEUJTnXoLuLQrJftmfmAg22igaUZ7SEQK
39906	payment	1397	1397	1678	1	1	15137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PFLJ4hTr28hvqp9hB9U67fA9VUb7v9nxS9bTUHcsAEvQ18rR
39907	payment	1397	1397	1678	1	1	15138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7id7SkG6uGwmznahF16wS85Exq4qQxaMpnNZF9RgetW5Wx4k
39908	payment	2134	2134	1874	1	1	5535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqttmUqWjCFQq2mAJWCTJTbnJ3rv6hPBDRU4idtmUMEB4dSAQy
39909	payment	2134	2134	1874	1	1	5536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwdAriuMwJaYYfwyDWCdztziQhX6SfRT9g18emiR6nUU1LoPR
39910	payment	2134	2134	1874	1	1	5537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWu8vfXpfpWgq9ip7eGgPhhdmetzFLqQZDsAcCNhzMnN667vL
39911	payment	2133	2133	1874	1	1	5097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj7XQyhr6gXVhvXEkkFCUxPbWsyP9QEGHSuoEo7ZSxTtNp76j
39912	payment	2133	2133	1874	1	1	5098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBr3mF1uELmzfe25PGAZ7wsibFRgjAtZK4kY3X7ykBTnd4RVA
39913	payment	2133	2133	1874	1	1	5099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2Rqg399MJDBVFSYLkDKP65oBLRtmw9B9MkC8PopKrAe2xUmF
39914	payment	2132	2132	1874	1	1	1536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZQt2XSRJ1BLuenJZMKTvyUciPWTmZ7iZkU79XCBt4gC6hQYH
39925	payment	222	222	2321	1	1	1	10500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv38PJmAgSwgu1Sxm1Fwhv6mKYB7DRrPrAJgawyYZ4i2ay2Zhu
39926	payment	2134	2134	1874	1	1	5540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxmGjq2v76G7hqtM7uJShPWmv98gKjBSY6FMQog4Sw1o79r76
39822	payment	1397	1397	1678	1	1	15112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwo7ntwGcq4v6M79iZn6CpkqhbC8D6p1MYyiB4L8GF7BuaRuN8
39823	payment	2134	2134	1874	1	1	5509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirs9dKRxvRggq7YrDoVoJcMsRH5R7rTHSSED5uQDuBWSz7BHJ
39824	payment	2134	2134	1874	1	1	5510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGvf4Www6CMdacE6SAPBzLXedGqtsJBP19rfuZgarFNzxwXT5
39840	payment	1397	1397	1678	1	1	15117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7LV6eNevfJ2VzLMugfvxdFesmgJtFA7xvDRB5XkSbW3Ess2N
39841	payment	2132	2132	1874	1	1	1530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzvbqPiXmJtm9iuddUGRmpimi5hvkJLjK4tXCWk8MAygHcbgH
39842	payment	2133	2133	1874	1	1	5077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQnh4ak9CRV9kgKh8C9aNZq33AVgWKzBtRr3RjuzJqAD6Wgze
39843	payment	2134	2134	1874	1	1	5515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArBCWrmc8WuQhhYx3RwRA1gmKZPUubXxtebkEYNQbFsAckSn7
39853	payment	1397	1397	1678	1	1	15120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnqWDsc9cdvWtqm9yn9yRhvJj7AxQZ1nxo6KK433HuFw87gbs
39854	payment	2134	2134	1874	1	1	5519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfQPr3AVYvrTTVK9NWM59CuvSwFA2M8oscrjehv3vhErhhNax
39855	payment	2133	2133	1874	1	1	5081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUJLc3yw2FbHVypMmN5F4WnZHQVYz71LmQQ2ewk8ozubFmgVL
39865	payment	2133	2133	1874	1	1	5084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NnHon7VkTVammiUUDkLECMssmcdFs9yMRznq1s9u4w1Wpv4i
39866	payment	1397	1397	1678	1	1	15124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJiQPXfr2oEa9gT3P2dGQFwR7HH4eQ1DfV28fDhes7qyVznbu
39867	payment	2134	2134	1874	1	1	5523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnwSWKDWJRtUPqvhNpJTcioA4H87tYSRs6atF84LYjhJ4joPt
39868	payment	2133	2133	1874	1	1	5085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbXXhoTiGPLSu6fPavj79yEn8vWCj6gZCibEiCTWuGHxccFhB
39879	payment	1397	1397	1678	1	1	15128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGE53RNNvtKssHa8n11QjvJwPgeFd1ZRDMuN9ZVPB9T8c8N14
39880	payment	2133	2133	1874	1	1	5089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQBkqgxvk1a5H91JpXJuwfmnFrnczTy65AUZ6ggQ6rpKxp22H
39881	payment	2134	2134	1874	1	1	5527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRrSyVa31DXJXu6a673WsBxyxx3WNSD9N3KDyhsV8omevakRY
39896	payment	1397	1397	1678	1	1	15133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLL4jaEXrZUpAhNNhj5g85M1VJfTotbmth1VtMnyrq76dtgx3
39897	payment	1397	1397	1678	1	1	15134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsvwoiBDHn8v9Mecd8ERR1eXTg8FkBrwmDm5et5PyFDSePgqG
39898	payment	1397	1397	1678	1	1	15135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvf3zsfNQJKFvEKPXZbGdW9a9G8PRiEdDDeKMpjrKa2D2Z6F7
39899	payment	2133	2133	1874	1	1	5094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWQ1Nvp8ABqtSYbc7wiUc7LMFBjeW195FQBFWYHbzsD57rtEM
39900	payment	2133	2133	1874	1	1	5095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgFHFLbGM1da7G2rMiuEuiEw6sEg549bhniLugLuhtU6yNfUt
39901	payment	2133	2133	1874	1	1	5096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVeYcAbwvS8uavRWxEhvwwuaUYbmAHPofie5kWMXPqhMLsRqV
39902	payment	2134	2134	1874	1	1	5532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQpeJ9BB35xbtoWX99cW2tiRfes1CJHMuv6jWwXXmqnQ4JGxY
39903	payment	2134	2134	1874	1	1	5533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjUXigT9N9s5WHHEe3XhBqz4fbcoTo8Jt2JeQA7vnwTH5q1y7
39904	payment	2134	2134	1874	1	1	5534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjpre3W9TuFSmfFF8tMFKFRnM8HDVxe7GNxKtGJmDuVnykGJh
39915	payment	1397	1397	1678	1	1	15139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAtbkZnj25Zs6UwBMhhnQNmL6NdUj62aRTB2AJ2g41tn5eUvy
39916	payment	2133	2133	1874	1	1	5100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpHW8iJKc2VvPeJTgUM3P9FX7CwQjWWsNHfZMaqtLHgdkxPGk
39917	payment	2132	2132	1874	1	1	1537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ywmZUExeuZ1JGGsxr9C8aKpqiYpxPmEqABVhRtM4mzZesFHt
39931	payment	2133	2133	1874	1	1	5103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nQ64EXBGE74c7QyE6gLeTMoJZJZdV45D7zGwEENrsbXx9mpQ
39932	payment	2133	2133	1874	1	1	5104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcREBHKWhgUV89j7EudqSZaaVkJ19XRLK5g6JME71JHBeM4NgD
39933	payment	1397	1397	1678	1	1	15144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuF8A2j857M8qVa1agEyU7mK68cr94SdpKN8jpxiCSJ6282Rz
39934	payment	2134	2134	1874	1	1	5542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSc1kEcm59rs9Tc7zrdDogRmwDGjTTddFp9EKNXAxA37P42Tn
39935	payment	2133	2133	1874	1	1	5105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHBkPuP9uaMWw1MGHnuaheN8VNE9BPYTeBCenjciV1LD8RKdE
39945	payment	1397	1397	1678	1	1	15147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXyzedsHYfrcKi6rcEoaKWgPVcqQGk6znoXczHH7sPiPEiWL4
39946	payment	2133	2133	1874	1	1	5108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtudsRcv2x6yx1GTeyC6DxPDojXLfS57Bt6tSWm1Zsr3AdE5v1
39959	payment	1397	1397	1678	1	1	15151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6Pc156dz6a8egKiLgrbob8Zv459PCxeLC4op4f7nsPaDnTmB
39960	payment	2133	2133	1874	1	1	5112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQa4BcdxEUL14ngcRtHxcVBacVsyeaye2SauZ4jktypg5evM8
39921	payment	2133	2133	1874	1	1	5101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMRx9Ve6HDaezTxBm75giDZ9gqQkJba1PCLoW4vK5jHrRRuoz
39929	payment	1397	1397	1678	1	1	15142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJYhjxpQa75vfkSwwq1aeSCcfTDrUc2wp32zjBiBDAjBsTC5S
39930	payment	1397	1397	1678	1	1	15143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtkutP2BMWLEeQyk4oKFEzkfxk6e4YC3JvCikHL9THXqQCTdT
39947	payment	222	222	2321	1	1	3	20500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVscJPdYKdabYjuDnzm6F2P6W6hesCR9fg2WHcqdNTGgu6djF
39948	payment	1397	1397	1678	1	1	15148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5DeLz2iHJNP8LAA7gq3muZvvk6PYMnLECkERQ4GVE91mv7z8
39949	payment	2133	2133	1874	1	1	5109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPqgwVAMnnPuJTFGrYcBkWg2nWhWsaB2dj34oL9yXkyuz93qf
39950	payment	2134	2134	1874	1	1	5546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bRiitxqzncUPviPHLWFmr9gqGoF1aRubqv6Y3uFCVZZSaxD3
39976	payment	1397	1397	1678	1	1	15156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KWnCz8KY84D2Whr8UWHtSu2F2ghcsBtvFd6tof6jcoqJzUYc
39977	payment	2132	2132	1874	1	1	1542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ24xmmbvwjvKc84VWXV6QBLDVRQY4Sr7EC9xXwQpso3NWjmAP
39978	payment	2134	2134	1874	1	1	5554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc34GQoEedQ7ZZ1pnF8pddDQZZyq7B6wQAdrE2uD3C936RrhP
39979	payment	2133	2133	1874	1	1	5117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeTDgAEnqHCLt5QQRZLqZyUm3yFfRfPy2K4k5MKELk5o57k4m
40028	payment	1397	1397	1678	1	1	15171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHCSYrXvcdhpNEue7Z5u1HJAcmJ6HNChXsy7HTqVgkFoG1otK
40029	payment	1397	1397	1678	1	1	15172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBbKxWoY7sEsfJe4eQUSbShBa8CF7SjUKzKkWEuAnHTR446HM
40030	payment	2134	2134	1874	1	1	5569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqX1tcSFPFFfR7Yvjw3QgiamNKS4B9CAbG9RFK2SQk5zo1WQHD
40031	payment	1791	1791	2322	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLgPRizQKdDzqawmsJXm8Vrquf1bLiJ3JDrE8U2gzLzwHeqZ8
40032	payment	1791	1791	2323	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvRaceSpcGSUSUNNoipgyQBYBhhay8RBSMMMxY5a7REHK6744
40033	payment	2134	2134	1874	1	1	5570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHotXXYNaFGSYYbCDx2vLjSuG8DfqAqtLmjMHEE4mk5YvrfLLq
40041	payment	222	222	2321	1	1	9	55500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1MmAYuAYSzUbXRcf8LBPq1HtkPDieNT9X5uqaHBGCcFnLgeY
40042	payment	1397	1397	1678	1	1	15174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWrdawVQuoX2urW48LoocjSbdTYjRABzfSHH1wRctmG78jhue
40043	payment	1397	1397	1678	1	1	15175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2akFEnqkcF3Y1i349y8EJ3aG551FPmwFGLpWKTJWc9nr3iGT
40044	payment	1397	1397	1678	1	1	15176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8SVWACWkiZdSMoVvAB2EDnp4rg6DXa2k4S2whVGAjSqBRTUH
40045	payment	2134	2134	1874	1	1	5572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJjiYH49KMrUDodEQxprSmoVR9KfPNpWfmi7hzHN39CwdmiPo
40046	payment	2132	2132	1874	1	1	1548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEn7Asvn6K9YXbovKk4ubdufNkvfAmavKXEE6L7DdeboAr1iC
40047	payment	2133	2133	1874	1	1	5135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Pw2J93H9N4QBjwrRQArEjdKACZcSus8duAFZSMWFZjaQ8Nh
40048	payment	2133	2133	1874	1	1	5136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9iK6USRehXxAmgB1pqWBESQHa2UV2psxgu5oyGRHamur7z1i
40049	payment	2133	2133	1874	1	1	5137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbG4xFPw6R9KHvwhxeUBRX3FQd8N1qY6SubzjHkydJiDhHXHBR
40050	payment	2134	2134	1874	1	1	5573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvj4YJ12kBPXRpATqnw8EUksbDHWMHStksELACvLYf6eJH4c9
40051	payment	2134	2134	1874	1	1	5574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwMhhvqEN8QSNvbrAKyMCMA96hkprEfxgqNKGeoXma81ipMea
40058	payment	1397	1397	1678	1	1	15179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPJaHGTL29ZNgPpTfHM1KjmKq4S4RPkY7duZDWPZt6T2LyWRs
40059	payment	2133	2133	1874	1	1	5140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAciVLwEHmdUT9VFbxXFPD9dVJCTf6obNVHWXEQMqeoah4FwQ
40060	payment	2134	2134	1874	1	1	5577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzE6JhckKH5yv8CTDu18mBFK9e7PLjFh6C21gdfYsSLANkSPQ8
40061	payment	2132	2132	1874	1	1	1549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUGfLp6HDNMYhtHAEnG7NokRkQU6fevhhhj1F3g5AbX96eauX
40062	payment	2134	2134	1874	1	1	5578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7YtLdjztxzriZkVwM7N8s7L2jd5yzotcazd3gD9NWEorWvRf
40071	payment	1397	1397	1678	1	1	15183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfHNtZ26rSZGXf2VonFBToSXv1SCi61CVmYgC1ExZm99pMsSn
40072	payment	2134	2134	1874	1	1	5581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3Sm8NkfMA8zGqkBkw4uA6zw4vzCCKfJzpnbmz4H9eF6T1fit
40073	payment	2133	2133	1874	1	1	5144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdC94JiP17brRqkCzKpLLp7fz2iKB5kZsVXnCJEunv4a7YJij
40074	payment	2132	2132	1874	1	1	1550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2H7sprsdRKWku2KaiVLFSTMabESHm3SE1bvZRY1bVvHjmy8a
40077	payment	2133	2133	1874	1	1	5145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZSAopakidQBq7V6h87ogHP6d5hre7XUNMa4BRYZhLi2xURu6
39927	payment	2132	2132	1874	1	1	1538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2WkEvJTJVdpMKcnEM282fmjZVSM8cMo6cJWa9LAVtnv2hGmG
39928	payment	2134	2134	1874	1	1	5541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dauzz4egWyn4DbEuLBbCQZiDYnBUNYPTT8o5fQvpUTWW7PPb
39936	payment	222	222	2321	1	1	2	20500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFArFaXjrPVwQuUGwSMix94ptFWxWqzKAwzXBNqzxzxmSMbdsk
39937	payment	1397	1397	1678	1	1	15145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeU6vXy7YwQ32x81TDuTZZgV6MRtazE9oZ8QR4wadZhc8QL5QW
39938	payment	1397	1397	1678	1	1	15146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqF2nwvHxkdcrcPxsZ2ZttUdAPGkmavzXmnBCrgLD2msqFigZx
39939	payment	2132	2132	1874	1	1	1539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjiEWj9jtkbovpsrXb8Fr2F8c4vr8zJUAEWQzkGq1nP4VsRkR
39940	payment	2134	2134	1874	1	1	5543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiRZ5Py45vGn1n26WW9vA91dsfM791cnykifXVfHiHHLykeyV
39941	payment	2134	2134	1874	1	1	5544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXqrh4sBLvwU6YTK7yxjvFoc1fUaBfjp3xPzWmppJCsrXpKwE
39942	payment	2133	2133	1874	1	1	5106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDp9cpCFDvHV7vsaySzRyVrf3uUvnEv9XQCKdJJzWTEuHqRqC1
39943	payment	2133	2133	1874	1	1	5107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nkrE9YQwgEqMmB3c41JjbMwu3qfU4gNGx2mLJMiZrQaQd8cU
39951	payment	1397	1397	1678	1	1	15149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrRfXFupmEZAf8pjnyaCPiNLMhuUsGQVFfi1udvjmE8FUGR1W
39952	payment	2133	2133	1874	1	1	5110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhCUuoyMH8AhnEUq4s29ouZ8JaWp5XDCgHsXd1SzRtDzQJYk6
39953	payment	2132	2132	1874	1	1	1540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEoGgFJPxAwCvi71b8vdCrmGNQkJ5eKcQyY85DgimEJDwMCrh
39954	payment	2134	2134	1874	1	1	5547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLC87crVueFbcrNYGqVn5ZwycjaLHgaLmf9jF6hZqMDvKrHDCp
39980	payment	1397	1397	1678	1	1	15157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhAEFdEmEZiSFVsQ2hAPg1KhvFvoV2QgZ6eknUrecWanyD2Xj
39981	payment	1397	1397	1678	1	1	15158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNskCHaqCtKdFJH7vJnwTDFY83s2znw2QyKSQUMZxh1QX4nLTh
39982	payment	2133	2133	1874	1	1	5118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwosawGANpMdNH1GkDYy84J4EpJxofDbUfBgUrDHQRaDBCzbSh
39983	payment	2133	2133	1874	1	1	5119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkCSoeZqEttp9bi7YDzGTAX8y1uhymfAf677zPo1R7DNfe8zH
39984	payment	2134	2134	1874	1	1	5555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKV3v5kHC2iTF8F3vt3unL59YiT5y6qKSoy8J2NQsYAReXogt
39985	payment	2134	2134	1874	1	1	5556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZ5xriEcRf7afeKrj1CMQqd4ekg2eAYY6ewA2yLnayzkK4ua7
39986	payment	2132	2132	1874	1	1	1543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE3hrg5qctcYB2RgCfV6PmZskLkuWjSa6tH99y6DHvu2RTpSs
39987	payment	2134	2134	1874	1	1	5557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuGrbRs1boaJCyJojAsw9TGHHr9f7MvpedQX9cbMZavvAx4RX
39988	payment	1397	1397	1678	1	1	15159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMaz43UhY6gC4ST7Xgi7shmMEdvWtfuSfrRV32kmaU8vPhUQF
39989	payment	2133	2133	1874	1	1	5120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjpV95ceZU94XFyNHAhHn3QKQ3w22j6nJkApiZJd6McmGE9Gf
39994	payment	1397	1397	1678	1	1	15161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1A1g8kpXuY4nAXPMqG32hKcTCD65SYnk9zuLsBMDpWx4Db3va
39995	payment	2133	2133	1874	1	1	5122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzr4Pdj7FUE4m9w2Hq5RiuSWYvukXz32euYqiLxW7biB5yzqn
39996	payment	2134	2134	1874	1	1	5559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLH2vu74xAytkxEcYJ6228QL484vhseFPM47fH2BmjmiUHHooR
39997	payment	1397	1397	1678	1	1	15162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsFmhnesidSmKo78dTsC6iWQvijE8K53HWEbk5ud7pTQFsG1S
39998	payment	2133	2133	1874	1	1	5123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQYtUDh8YTadgQ1Ea6GVciH9hNnvJU5Ugao5hFzarguZpMURP
39999	payment	2134	2134	1874	1	1	5560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HeMhugHBvpZ2Tempuesn3TBUkPrfirzB1YyZi2Q7SAjXqiuB
40008	payment	1397	1397	1678	1	1	15165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgyxtjkzaU99B7ZtWFyjrtEJ2cNCg2UTG1tk7xq8joMj8DeQS
40009	payment	2133	2133	1874	1	1	5126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRme4PXDuAkWH83q5mhCdfji9cr4c6XbkEVCYUBJPYsABaykqf
40010	payment	2134	2134	1874	1	1	5563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQUJRT57jkmV7Az7QvsgHLAV4wSecsBaWDk9LAd3WTDaYsSLR
40015	payment	1397	1397	1678	1	1	15167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMU9SnSW1KvGE1Zpwv3sLb66y7hxRP22XNikmEytPVitt1R9R
40016	payment	2134	2134	1874	1	1	5565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtJKDTUDYmHthEcyjNbJoqsTkK3naUb3MbzkCyJCmmq5YThv6
40017	payment	2133	2133	1874	1	1	5128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeeKSUYVJ2xnrour98UgwQk4QEJ8J7ND3XYNgkEKyTai3eHKy
40021	payment	1397	1397	1678	1	1	15168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXEzrvbmvxwwaGYSQnjHp1SmfB3THY6pwZZGoqbNUCvnyZsnk
40022	payment	1397	1397	1678	1	1	15169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQgbQrsjjMRj66wvWsSaX2qfceEyP5oLwMhRtkWDz2NrSS3aJ
39961	payment	2134	2134	1874	1	1	5549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqmaKKHjR4fupbxeLNYGMjgp8jMwR2eguDGpf9eizHvB7JdFU
39962	payment	222	222	2321	1	1	5	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Qgs8CDQ7EfjzeR3zavBLgfX8c9EtydoJMfPjXeGrLEV2vXBX
39963	payment	1397	1397	1678	1	1	15152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86hYyoKfurvkJNRBtUxPp2bMj41c5dbVDQuZbeHsQJCDdbW3n
39964	payment	2134	2134	1874	1	1	5550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQET1esPgaZ3H99BQU2hDNaZYq5A6QX7wiXs6XAqzwZ7VTDE5
39965	payment	2133	2133	1874	1	1	5113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1XuUb9H9uMr2YDf7qxkDoXJYDAhc1F5XHEF13bnjfh2gWEH8
39966	payment	1397	1397	1678	1	1	15153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLmcoB9CocKGJz3SASZrD3Tdjei9v5bkmynoLuXMihVwiAxtG
39967	payment	1397	1397	1678	1	1	15154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8455PZSHjmU2NYF42C538yYw4REFZKKJ2priFZfhE9FXsh3B
39968	payment	1397	1397	1678	1	1	15155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcULYPiTXgTmu5HXa8RJ518fA1aYQzssk8EJb9Qp4DsY8XsVo
39969	payment	2133	2133	1874	1	1	5114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXngjdkXJEgSCbVFCjmH2b1AQ3K6GpK8eM6HJJYxKUthDuoqC
39970	payment	2132	2132	1874	1	1	1541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJJXzpuRmb98sij9UoazazHVRmgSYpYVVvEqAT2S749yMc9xt
39971	payment	2134	2134	1874	1	1	5551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXERQMF9J8q29BkUeAsZmiduSSutaeF8SmskT1UJXQy9ro1Xg
39972	payment	2134	2134	1874	1	1	5552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNJTVfHomu5ecPcCB8duyofhgQH99cW2JHPNBU4CfkpugpZrX
39973	payment	2134	2134	1874	1	1	5553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Q4DhgHubzFqPQRYvYEpS4ogTUUNoZW1rDnrjXozgi95QK2ow
39974	payment	2133	2133	1874	1	1	5115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGq7FmcXwyTSeT1tT87SDGikTYZfcLGTGLoZg5Bsa5VYo1Q51P
39975	payment	2133	2133	1874	1	1	5116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWt3YaeWvEHkiANUtL7oQfHoS1PoVdTw6w1QPKntUdSWjCqMs
39990	payment	222	222	2321	1	1	6	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uwh7WBWMmX9G4A1YJqYeECa9fGKw4Amt6ZGPdmUZQwsoMQNJ
39991	payment	1397	1397	1678	1	1	15160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSthK9nQ4q47zKVjg8PWYgRPUAd1tywuBGTuJvZ8TfyyWCdA55
39992	payment	2134	2134	1874	1	1	5558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTiMm6yMXtKJssYgdD6LZrTev9Vmq5RUknisWffFffQqi8sY4
39993	payment	2133	2133	1874	1	1	5121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtMrrUnZwJnAKS7QZDeVKUtqqamVzmrVon1YZ4vR831AKwz9A
40000	payment	222	222	2321	1	1	7	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Wasb3MTfbtVqpTHkWFnzc9qnttHX7Reoq4E2j6Tsd3QnSb9M
40001	payment	1397	1397	1678	1	1	15163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKASpwBoypAMEUQ7NF2jMYgkWWTzSvFwtVLZGMoNXom6eyNoYk
40002	payment	2133	2133	1874	1	1	5124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ydAarAdtgm35txaiziJo3Ee1GWUvjeGF9mmkhYaju4yPnNLQ
40003	payment	2134	2134	1874	1	1	5561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS2uimGnYjSkJ3pZidLLaLBimitX5sTVpPAQTkBGexEazHTQGZ
40004	payment	2132	2132	1874	1	1	1544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkD1twa4vUzqFdusPicBQLoanooMiAUvZwxERLGbPxQ6oDL3G
40005	payment	1397	1397	1678	1	1	15164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHRpVBVhYp3iAYDVbJQvrCEdjtgB6U5yfSDetNsN3MPMvZj6Z
40006	payment	2133	2133	1874	1	1	5125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiSnWP3qSXb4AbRqrEfQAQTyvAMyHvkGyVv7VS7LDPULXYa85
40007	payment	2134	2134	1874	1	1	5562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9GfVWuNMmwkCxvkdEvdRfWiiwDfA2NMWMVuLJcZ5ZXTXsJrP
40018	payment	2132	2132	1874	1	1	1546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGP4D36uw9FpQU24Zr4pHWKySeHJLRxditnqMsXMbS8sMQnXk
40019	payment	2134	2134	1874	1	1	5566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv87PWLdwXrhHnGMVCu7NPFGop7JQrbKomEeJCiwt3uP6WiPrd
40020	payment	2134	2134	1874	1	1	5567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iSse7NRQ6axuRuACwJKDN9HCni9WRzwaERA6BqSLqQMvbUn5
40034	payment	2133	2133	1874	1	1	5132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmX4w8WCJ5ruhBLKoYhjvXzt6Rrf4mHMKAXxYjLLQXQwznUB91
40035	payment	2133	2133	1874	1	1	5133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmfEWn671zmnHt6rx8kwaExJLz6t1zkDM86oMvidiFzApu8jy
40075	payment	1397	1397	1678	1	1	15184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFwhhUkpkMuN4B7o1WhvwbgrgxBs121px5rRmyuY1ps7Re63J
40076	payment	2134	2134	1874	1	1	5582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoFjBx8eYNev2c4g4wvqSmNmLJekNMxDRRkbvm7jexy5CkLpz
40088	payment	1397	1397	1678	1	1	15188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNJ6fcSsXSv6k3d6bVhyLxYDSrHGbVQGKcyq5TaZ5otH1V1o
40089	payment	2134	2134	1874	1	1	5586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy5HiKVuXLrJqWwqbiZCJgZVoTaSqCVxMbnYHoLuvC5Gnyxdy
40090	payment	2133	2133	1874	1	1	5149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRKMKf53QjDhpfKt3uw3r46dQ2C8tD4rvDky3NPjYgxB9pQMy
40101	payment	1397	1397	1678	1	1	15192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTGe3f12zZgynL3oZnAvJ7GiBoqqYBrQAwGh3vgGtQfXvvJRX
40023	payment	2133	2133	1874	1	1	5129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpouEyy37TN13egJXyEfZ4AdU1qTiwJKom2FXHour55Gyf4Jf
40024	payment	2133	2133	1874	1	1	5130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXa2qpPCzwRkPtCHjtZFrKXfJTPGmAeTcYL4gmET4P1cqRPVq
40055	payment	1397	1397	1678	1	1	15178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vxijSM2zu9trBG2CmAQkqMEDxvP5WEPWhFJVbAkKE4pJPRnT
40056	payment	2134	2134	1874	1	1	5576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjN3cQkUVPEhH29AhPaXsr99UTM9mHRqT7omfKVVuTc7Y7YxKV
40057	payment	2133	2133	1874	1	1	5139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbhkbdFRjWJ2mVquek8CmwiZMS2hggWzH5F3fkM9E7xE5hLfc
40067	payment	2133	2133	1874	1	1	5142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqjcXiEfbh2Bx4Y9hrpW2BQYiU5NMc11gYje68UVUqiBLFf3u
40081	payment	1397	1397	1678	1	1	15186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ovrubdygznFB7UMrDmuJa6TrDrCAUziLhurGSRM1da46GHyM
40082	payment	1397	1397	1678	1	1	15187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsbX3Sy3ijpXgDvHCXiwg6SwDYAu6UxJSmt2mWVP1MprQLfBS
40083	payment	2133	2133	1874	1	1	5147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSGWmXxDELzBygtDLEJLa82tmpajpfB4AFjekzNN2fQiBPwCJ
40084	payment	2133	2133	1874	1	1	5148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHaWYv5wMYq5oHMXJ6HWtFVNDwi2bxGcU2aYPwNphd39QLrWH
40085	payment	2134	2134	1874	1	1	5584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCesReZJUxJfUABuptbHQLSoq3wJMBTMAMCwEF7oV13cCxcEyP
40086	payment	2134	2134	1874	1	1	5585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfj9wwqT6BEGMHr7GM573ej91sEwBkC9xwnKdteqD8XnXWNQB4
40087	payment	2132	2132	1874	1	1	1551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHtXSrLFSCfL6MpK6qmo9kBQ3wVfB1hRqQxpY7PzwkkT1AEUH
40091	payment	1397	1397	1678	1	1	15189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VSCHKt1B7dkgvdKJS4byKuXFRn9tyy8WKYP3HRfZjtt1F9Ks
40092	payment	2133	2133	1874	1	1	5150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSi2WS8XfsRYLsXsQdMvN1XFEtRfhS1FETPeTgcCqwY6gt9Ki
40093	payment	2134	2134	1874	1	1	5587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39YTvpmLfvfburknghQrLPJcwupyqS5kCZC3ZSvBc3LTQ9gra
40094	payment	2132	2132	1874	1	1	1552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94wHHcT4jzTbHVB3yd1QyrGDhPwV83TcwRvSNCZwfJdYF54qJ
40104	payment	1397	1397	1678	1	1	15193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN56UyWYfiLMY82t6aFtSGRbiV41oUFaUFhPjBXfDEzUR2DYX
40105	payment	2132	2132	1874	1	1	1553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx114PwL5opnS4UC5CLdP6SZXLdye4XUpFKZ1GPyXSRBb7jFBr
40106	payment	2134	2134	1874	1	1	5591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLezQdnBRQTfSMgtdfwwZEebcMLRzKYWAxFxFUXUwyZXc4Jzh4
40107	payment	2133	2133	1874	1	1	5154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9nU4ih6BKvZS3TRARbv8xDsJ79ot8FL4c6hktrsJ5DUPueon
40122	delegation	2321	2321	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3aotTng3j1TYtSaX6S9xXZaFppzv6RUJubT6WisdkM2XEQCCp
40123	payment	1397	1397	1678	1	1	15198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQM3Px9Ht3oeiXLnHSmfRkZwfkcNKWrPFKnNKWs7SY2n5LPoQT
40124	payment	2133	2133	1874	1	1	5159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7jzqMhq4atxjs2Te1eLR6cRYcZ2wXSgpoY85X1p3F9P8EewY
40125	payment	2134	2134	1874	1	1	5596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHZ7fmW2vyujrsPj19XBkGHv8p6tGA1Fd5H1Mq5ba4L9kGTrV
40136	payment	1397	1397	1678	1	1	15202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKPDiVzSy4ptrQFArrWKkQVvSzNCkX16VzrtVim3ech3NHE5K
40137	payment	2134	2134	1874	1	1	5600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPypnEky8K9MumwS93h4SddSiscxWuFx7Lpep7nGt2NL3SAYdi
40138	payment	2133	2133	1874	1	1	5163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPie4LFeoUsx7Cr53a3YY8x9yVRwortfN4expyvFFvSk8ufLA
40149	payment	1397	1397	1678	1	1	15206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypXHf9HYzXARXgg8ex61UwZnz1DprG7WovTQPVSseseyV953L
40150	payment	2133	2133	1874	1	1	5167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYPSDfFJ3Ytx6X46VTa3ah9nd1P9sT83VZLXLzxWiiogzRBzj
40151	payment	2068	2068	2152	1	1	0	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfgsWVivXkjaPiRjz36TejVqknkbNLMPFiTkZeyuvqGaWARFG
40152	payment	2134	2134	1874	1	1	5604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzAdPdvAHsjUP34MRjEwnhE3e2cdTTkckniQVtM3j7bKFvTLX
40162	payment	1397	1397	1678	1	1	15210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28vAMvvETX4xmZdS3KwDN3CZ2wAjofH6QEi2vvbcikaetzzsT
40163	payment	2134	2134	1874	1	1	5608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3zEdyEEs5DwdgLTxPceT4GA4c3u4YAq6ojwKP5nJZSDsSbpi
40164	payment	2133	2133	1874	1	1	5171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYxMksY13fVQ9sAnB12FciPUfv5X2hjZb55L94SbHJb5p8UXs
40183	payment	1397	1397	1678	1	1	15217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjLPnLjXDb8yv5HKSJt3eo8Bktb5eYNkfjNq9yDcs1M8RDCLx
40184	payment	2134	2134	1874	1	1	5615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr47VpXiuzminahwR4TVNZ1vrDCsrdhJ2qQG7NaAftkdmov97u
40185	payment	2133	2133	1874	1	1	5178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwEW1A9EtZhRvwK13nK1VEKSkMVajotxQXeLZ7PJJRMFBCaHD
40036	payment	222	222	2321	1	1	8	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQgLutQmwn1GgYKpZc4uWY35xrLjkEkoCRhqGkTZrUdtXCxwd
40037	payment	1397	1397	1678	1	1	15173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2X8iMQUsNqUFgWszKexyBbChcopwdePegyARsXUgNdEYmuK63
40038	payment	2134	2134	1874	1	1	5571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5qbQbjSUWZ1dQpfw78i39bEQhx5ZMm97dKd9A7eJZtzCUu3m3
40039	payment	2132	2132	1874	1	1	1547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGP87xm6zmuF9jh2P4Khbz1Hus97U8jryLYRAffetB5UA4P1UR
40040	payment	2133	2133	1874	1	1	5134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNKaaXRpiZsBRXudS3gfzKtKKiHXgoefkEy4eN9duGmHq93TY
40052	payment	1397	1397	1678	1	1	15177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL56NYf1QFe2SMp923qPj8F7s4jnzQpoM3ZQBPkz9HHaYxMafk
40053	payment	2133	2133	1874	1	1	5138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNrS5sD3omTxGBViT8xcmU4sYtS9rsHWqShfwJh3zzZAkxxxv
40054	payment	2134	2134	1874	1	1	5575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3WGQUrEaKpAuYoXN2Vfe9L573Z4V69yXrbN51d4XDVPBNVZc
40063	payment	1397	1397	1678	1	1	15180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5J9fGD63NcXijJjRswNPwvPRyUsPJjoNdiEMriwC8mSGu5ZCu
40064	payment	2133	2133	1874	1	1	5141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QSg5FWJ5utNxyf5JVikB2FfgFTedETUJuwDG3xDxBnT7wkh3
40065	payment	1397	1397	1678	1	1	15181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtKTj6YHhN2JPHsMQ3kTV9agS69wBARChRHYGeMg8ow336qcY
40066	payment	2134	2134	1874	1	1	5579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFVj3VBFJzgojN6fZpUvrBm4YNAD8G2oMiSCs6TCFivV5Swy7
40068	payment	1397	1397	1678	1	1	15182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuV2u9Sx3sdDcTWXtcvo6sFUKSxqHEKxeTkUwFSHh4D2ktmQL
40069	payment	2134	2134	1874	1	1	5580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZiMvxssWEk5W2gpuhvfxWTAPNhyFjjWbubgFDnVFNU3FieDN
40070	payment	2133	2133	1874	1	1	5143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qrwF83d3i4x69f8iRS5WwhHRVfyb3aKAnwvUx6ye2tYasc73
40078	payment	1397	1397	1678	1	1	15185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBotLKjw4tnecvkC6xKJb8xd6CVQxXyKEmPYRGR6j3jab6C6zm
40079	payment	2133	2133	1874	1	1	5146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpN7evMwSZ9dZkdQmRGXbBN6vQw5ti68FKrU6zmqLVA7ZMW5r
40080	payment	2134	2134	1874	1	1	5583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEhWvHwjywM8HdkDLepSH96zDaoFLoW57iTN48egLytd8WfMy
40095	payment	1397	1397	1678	1	1	15190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPugoVQ22EKwVRKgox5BmQcDvBPp2YtADDZHZp4B69NQ7RciB
40096	payment	2134	2134	1874	1	1	5588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaGbUJsLfVAwvtycPMhSmB5PoPjdM2THn9agQoAJg6sKMCtED
40097	payment	2133	2133	1874	1	1	5151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbHzqTDpqVwAkG9rE6MzCVvmuCoKvLKHpd44U3YEScvK7uB7R
40108	payment	1397	1397	1678	1	1	15194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZbbU4j9pWuacwYhtzGDEt7WxA8vRqmQKGuTwfgVdJNtQJJfy
40109	payment	1397	1397	1678	1	1	15195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvKh6JXRaqVoRmRRMFV7caBbX7FxtGgPhcuYLVNW7aW9sU59j
40110	payment	2133	2133	1874	1	1	5155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcbdd44Vi7GqmNEB7qkEDBbqiXcm8iXdFXMTrXCmQnnD38CsE
40111	payment	2134	2134	1874	1	1	5592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN96KNHmryQU3qPXSVzrNwstvR1q11k9FhVbjr16b6b8qxdVrg
40112	delegation	2321	2321	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR9WuQkqDEWyWdcMLq5c7m2PbaEKXjfnYKbPz243DfY45Hf1R
40113	payment	2134	2134	1874	1	1	5593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKsmwQVf9RcgbJRyaV8wcMCoeahecG35g6muT8Jzp9BJy24F3
40114	payment	2133	2133	1874	1	1	5156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A43xurxUHGcKQAEx7MTWM1EtP14Fe81YVbh1BenA3cqqEy6f
40119	payment	1397	1397	1678	1	1	15197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNjC3Naw1qT5L8ZAKDfSSFaaK73wM7wQzTd159B5RGtq3dHfY
40120	payment	2133	2133	1874	1	1	5158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKeRYbdiGseJJ9tmVEiAMkEo3hzwyXQN91Gr1n9h4KpHcPQGn
40121	payment	2134	2134	1874	1	1	5595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqoEynMrVGkBR4MBb1ZK78W4RzfF5GLAgzVv6FShhsRhSt1Kc
40130	payment	1397	1397	1678	1	1	15200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiM5jv4v6c2yYsmvpnNSbCTDdehNvruBz4qv83GirLCZFw3UcF
40131	payment	1397	1397	1678	1	1	15201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjyEXoXJqnNUCdTwcZ7AB6e35752yJMTzADDVajJ7CoEyUmuC
40132	payment	2133	2133	1874	1	1	5161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPQEtkt8qdaDPruCefK3NSguQ5Y7vQKK8gi6fiCVEY4N3fhKi
40133	payment	2133	2133	1874	1	1	5162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBCJpYJ1vkWMbpCcVUnWSaToZYU7MX11v5jpck8LzLono5Cnm
40134	payment	2134	2134	1874	1	1	5598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aQjTWQ8o7riAHjovTNtv19rW3fZZL315s9j1ycdxZwJ6USzh
40135	payment	2134	2134	1874	1	1	5599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsS62Hbi4ge4GTQMMXjB41J7sNBEKpxbCBzMkuo1V6SQcQLYwU
40146	payment	1397	1397	1678	1	1	15205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5sM9uQhqRVb6CfPjTzqCvEC9EmRAQYQNk63UiSXHBLu3Csg7
40098	payment	1397	1397	1678	1	1	15191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1JS9gbW5nBNxJqozqf4R5APNo5sfPUQjmjJBLDPUXJ4nnM92
40099	payment	2133	2133	1874	1	1	5152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6D4a5qVWYQaULVBgKTsqx2KqCNjJfjcvSeEJA1C3haVeR3DS
40100	payment	2134	2134	1874	1	1	5589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt3VeZLzLbA3p94yCCcgH5VqVRjE1kXvVuY8qGt4UgXPoJGjm
40118	payment	2133	2133	1874	1	1	5157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbqjbU3o6GCdbH5VvnTqdG5KZTMTWbe6cYaGxGUyspH6j8pHf
40143	payment	1397	1397	1678	1	1	15204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XcuZTruVRJULTkA5c89vH5GinymKfVGwHtYwMCRNah3CgsXp
40144	payment	2134	2134	1874	1	1	5602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdZhYzBRZ4yZDq7TH6ZSrjAJDFyidE5sXL1hvRGAPpho4ErNR
40145	payment	2133	2133	1874	1	1	5165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzLeBDoUe4imngnXZgNFR7tMhaUKUvBXiM2pnd5mKhMmEmGDv
40153	payment	1397	1397	1678	1	1	15207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde19gjz6L4hXeKbdrp9h2Wizjn1H4atLWG5PZLQrQ1XiYAMmR
40154	payment	2134	2134	1874	1	1	5605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqSx4GQ2WzJ8P5ytowzW3KYFyRqUgezQZ3tjTp2fU5pfMQFVj
40155	payment	2133	2133	1874	1	1	5168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiRnYrziVFwwWdu9R4TipHEksqvwZrz6qFekyDThzZTpdiRMC
40165	payment	1397	1397	1678	1	1	15211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsRSL913xoTriGRbEmv1Aa74awFSAWmjo4EhZU4vZaDgskZFB
40166	payment	2134	2134	1874	1	1	5609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5mnJVMoAtgjZok9wpNXwHotmfcJC9eFaeHHJPpoMTjE4kiyC
40167	payment	2133	2133	1874	1	1	5172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYL7QiRvBHnMi497A3s4qGSqJvWmesBodsmESMZ2Wk4QoQc9i
40168	payment	1397	1397	1678	1	1	15212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDwVJWXnzU9rDb5A5PL3fGTZp9b2hSuwDNAQbAbwnL7KiCKjS
40169	payment	2134	2134	1874	1	1	5610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14QrPaLNgQnY6rnwJPDAw6N2EqNhQLdR7MVx8Y4U8CX3bBnKd
40170	payment	2133	2133	1874	1	1	5173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUeNkFaX1AN55ovFksoQYruZcn6k8PQKhHkwiqCwwggeaMJQa
40174	payment	1397	1397	1678	1	1	15214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcncHfXLgBoZrpRkASgFba7xaN6xKEKxdCZXZudfrb6uoKtPd
40175	payment	1397	1397	1678	1	1	15215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuEJ4KDLJPZCzp4KuSocEUpdGhZY4S7ZUeZ2tn2eXFCV8Ci8v
40176	payment	2133	2133	1874	1	1	5175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDxgnP8F5Rp8UvQ8tB8ro4tFLUj5WR3tafqxTrgEPPt3B9o6E
40177	payment	2134	2134	1874	1	1	5612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadnVGafwHC4RNKff2TBRT1yq2inXfCfXZAyjTUWZDU1m7uiBS
40178	payment	2134	2134	1874	1	1	5613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GvsL5eohjCeTMuzTh75h7gue2udCQK5MmAGkLip52nm1Tt2D
40179	payment	2133	2133	1874	1	1	5176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkFgu6vJYrZ8rj9hXdiAvRhBJaEZbTRod1wcUPYgoq2pQFsXP
40192	payment	1397	1397	1678	1	1	15220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BbjEDwQ6DrvfUtCE2FCFErTQmWF8PGT1Le14XTXPm4vccb5n
40193	payment	2133	2133	1874	1	1	5181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3FvBrfZt3j3ZyVHheXcYHcZGF7SaGF18ETWxEnZVh3iGU9BP
40194	payment	2134	2134	1874	1	1	5618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqgVg8XEi62ZJTspJ2KvWbToKnr7p6SACRmMhfNA9TP6VKTWe
40195	payment	1397	1397	1678	1	1	15221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpLrNr4Md3MrGsmLSK3vXJCrWWm29H1HKqsJCaW7GxybKSiUm
40196	payment	2133	2133	1874	1	1	5182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGqcqtgd4bk23go3doDvMJ2AG3kjyTkJT4rKC8takkLPHr577
40197	payment	2134	2134	1874	1	1	5619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwSQ2DTUPn2wJEuL4dSpsn62biJU3HQWinEQYJdMEzUqoDmQL
40210	payment	1397	1397	1678	1	1	15226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqhNPHXWQAqKE2xBW343tgzjUzXwUMuX5g8DsBiDojwjMDK6y
40211	payment	1397	1397	1678	1	1	15227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTJt5c5o7p2gc9vw5XqpY7GxnAyRCwpjvwyiKzgFXDKyKjgis
40212	payment	2133	2133	1874	1	1	5187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba5syZ5fJ1G24Hab47viz3vBRdz1dzGGokps3CqzCm9w9pKvH
40213	payment	2134	2134	1874	1	1	5624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLFJhyXpL2pbduwwgzu6e8gKWpfkK1HhXtx2xpHXcsos6WdB4
40214	payment	2133	2133	1874	1	1	5188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSjNhQSs99WU5AmZPQ5mZmevhpByiaAoefV3XPXzMxuSkAWKU
40236	payment	1397	1397	1678	1	1	15235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaBcwN2JPref3E6gMAgVmA2gZANT9wauHQZjeQ5U3JhCndgUA
40237	payment	2133	2133	1874	1	1	5196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMZA8pZphTo2ur8AxAyNtcXXjDNV2AnQp6R8W2jfGSSh7ZFd3
40238	payment	2134	2134	1874	1	1	5632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiPwXUBsfZVkvvkZLedMVh9StKg96GuUBamn4jKaycpqJSFeE
40258	payment	1397	1397	1678	1	1	15242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWbfcRnswYv25F4HWb6jAkAVb2viRkfpScafq9q1Uab3FPRXp
40259	payment	2134	2134	1874	1	1	5640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsPJvxvtM2qoDkVzwtamAMR8kAYvuoLMnqfB2iN7hPKNGRy2D
40102	payment	2134	2134	1874	1	1	5590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1N24DJCGFGtwW5WCuS37G5KZsjrTzf91WLwZn8CtuqoH9gxX
40103	payment	2133	2133	1874	1	1	5153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzwYLsac71dpPvCQXg2usMLGgCpouSKMwLaZMsy4M5ruAVq6Y
40115	payment	1397	1397	1678	1	1	15196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyRU5wHi7ZGp4aDa3KEptnLZFsmu8gMPTSRywDbUXK9aw93ky
40116	payment	2132	2132	1874	1	1	1554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8ufhmn9RnrAMf8r7G8SEEdYsHubZDwfm4yeShVfX8s9KxXqW
40117	payment	2134	2134	1874	1	1	5594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DyFtmBdbqePhQLNtjvAgZLRea2jgDHgEKbctCWwKsxRQPwu9
40126	payment	1397	1397	1678	1	1	15199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4DDSweShtR4RDHjWymBKK2qE1WACkxGmEBdpLw7vnFVTnBcn
40127	payment	2132	2132	1874	1	1	1555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36EXZQnHTFXDVeiF22Z7aN1Jm1VimcsKDbAuC8K1FYdjDoQCz
40128	payment	2134	2134	1874	1	1	5597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WtH3LmVQ3BMH1jWo5ZmFFcGyzVmcwDSH6BWjuR1jnz87BopF
40129	payment	2133	2133	1874	1	1	5160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwgcYqs2Y9AdgzFM87wjREoQPAeHtzCDuTRqfZhczm9xyaqux
40139	payment	1397	1397	1678	1	1	15203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6fqFW8nD3x4r27SxQ3GeBsG2xgnCGgZf7cUbRyZta61LMhxh
40140	payment	2133	2133	1874	1	1	5164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEchUgmwcYVer4rxzjc7fhxPQdUK8FvJyVmchTTvRvCtHSCGZ
40141	payment	2134	2134	1874	1	1	5601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCP5CYEmqycU34gD3UM7fX7pXtA5amn3Cv5MxLHe4DKNzE99h9
40142	payment	2132	2132	1874	1	1	1556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANNxrqBXXA8dFoWtfHn7ENXMCHw8QDs6yUu9dAtZd7R3mzc3
40156	payment	1397	1397	1678	1	1	15208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhw6vNVWqC8jqxcvtwUxnMT7yv6ZDj8Yj9tUtkgJBiwBdcqP7
40157	payment	2134	2134	1874	1	1	5606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzqQjqsAtoiS1mmT25Xozg9oMyBJuT3PFLDr3X1fXNvJJnDrn
40158	payment	2133	2133	1874	1	1	5169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6YX4cw5ZfzxMgCziSZTvG3rP32s4gxHa9mhggCacDvgjGai9
40159	payment	1397	1397	1678	1	1	15209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1Fh1Pu2Ac3HyZUcTcQ8Ad14spuiddb7fxfMtefHw634EcLhV
40160	payment	2133	2133	1874	1	1	5170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn26NGQCKRSno4VjXbREwee1wDd1WuXpxruwX9YMC7MXmbXsXQ
40161	payment	2134	2134	1874	1	1	5607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMkjkdJgZCzA8pSEjRuCrqXZhurKNJcqnVP8hpzayrJPoXu3D
40180	payment	1397	1397	1678	1	1	15216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQJQz5ZeDr7VL9GbtUhS51kKhDzp1yjC99KfGvTnieq4vKKbA
40181	payment	2134	2134	1874	1	1	5614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCbingPbiDc2jEZjSibJofnUNuG17PUg3qdWjAr9BJZjufZvK
40182	payment	2133	2133	1874	1	1	5177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmebAAszVoPmCYR6GtLvmVbq5uk3UDS4tS4e5d9r4D17Kz3F5
40189	payment	1397	1397	1678	1	1	15219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWxZFeD3KheqVoCT5TR2yfei3AfCJytjjuPZw2xNQMT1J8Wqz
40190	payment	2134	2134	1874	1	1	5617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKJ4qPZxBuGw4hb2xiM8T9EeUoJZgqRETcpg5RcRhnvVuDYiN
40191	payment	2133	2133	1874	1	1	5180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz17jV23PEcJzyTVtytsNaC6bBf5h2oVPAQqdHG1zrPasNQw9Z
40204	payment	1397	1397	1678	1	1	15224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcREiYhbKPXVoDDHQYenSUMHaXAC3k7Pgt2hh1xvN5jM55PfJg
40205	payment	2134	2134	1874	1	1	5622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyzp8MsWJnbCzVoes81W4pFi9PVjoYK2f7qSK6D6quiVu94gwM
40206	payment	2133	2133	1874	1	1	5185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa637XwagxeVLQq14GYCbkPBVmNN37He4NRXZPpwZb9ksz6s3XB
40215	payment	1397	1397	1678	1	1	15228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ete1bNd5ThjbhtoVpy85poLDnJ3wSZSY8WSoms9YYGZK4NB8
40216	payment	2134	2134	1874	1	1	5625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9tzZMQcGFSg3xNuZ1kFY2NKrYh7SbTAe1YbiQMb5P4Jd1Y7L
40217	payment	2133	2133	1874	1	1	5189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtowtT4BhkthmLa4bwue4jnk11nMgHYCuoUaGy4QjA9RnemVL
40218	payment	1397	1397	1678	1	1	15229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMBcKnawVsvexN4VEUKCKzxs736NPNzhLNwMoZsR1YuxWycA7
40219	payment	1397	1397	1678	1	1	15230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGNEU7p1tHTwhnKZAnYV88uBXzy2ZzQrJo9RPKtLm34yrMWgd
40220	payment	1397	1397	1678	1	1	15231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcmvQtpaAjc2eVmRkbtwr3nQTNunHJ2HSzH6fYh9bxfFviuNv
40221	payment	2134	2134	1874	1	1	5626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EHEuwPwap2zeUhzhk2NPf7fWZZ1YFVrGCRAM7uRwpuY8ivpg
40222	payment	2134	2134	1874	1	1	5627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNsZF3UUkMbSh8Y4sFt4BLq9dq8V7ZSEkLUtSF1JFYzPnggAS
40223	payment	2134	2134	1874	1	1	5628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6jon533Cft3qhHzyoCqmnmze6iCW817PZnRWECtFaJ5KtZtQ
40224	payment	2133	2133	1874	1	1	5190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjSp5JDiAUGkNHpJ5RE4FMkZnZCPextHyb1X45Kvz7jV69aZ8
40147	payment	2134	2134	1874	1	1	5603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUoaFbSNLNRGnoLszq5eV8WiN7ZeCfDr8URQhWSbrcuifFNLx
40148	payment	2133	2133	1874	1	1	5166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunRCdxg6kagiaJnkdXK7Jou3GreUFJjXVmFEZDCGn9u5kN3fc
40171	payment	1397	1397	1678	1	1	15213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzNrZaSejXDMvDkzvVHpHSsbcKe7ySFbH3djS3EXcPH58BU8V
40172	payment	2134	2134	1874	1	1	5611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYj1AtLVEfN2T4PtmCGakNSVARQLHXWzhuZ5W8G9US4BZ1xAqA
40173	payment	2133	2133	1874	1	1	5174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrsNtzxfiy6caXR1kaE6a9mpzzittcCaVg55guAArt1wyWo45
40186	payment	1397	1397	1678	1	1	15218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dtXv7CVetptgx2S4DGqnKyp5sKJww3xUnck7aV7c2ALRLfjG
40187	payment	2133	2133	1874	1	1	5179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzhCcRQQLwU8PaxEcKEVdzTQLK8TUeFx9bXRgr6iS1GopMRaR
40188	payment	2134	2134	1874	1	1	5616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWutRYr91wT5Lk3GC39JN4Yy47RSAUBtSybCVvcQ5KM4GoDR2u
40198	payment	1397	1397	1678	1	1	15222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnsa4C3D14ZUMAcfdVCk2PppqdwA83QNDHjoAAU9FbPSxkm6u
40199	payment	2134	2134	1874	1	1	5620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1QrP7sVGdHTQT1Lq3m9KB2s8HxRTWgRyLHomB4zMc7PPK8nu
40200	payment	2133	2133	1874	1	1	5183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HUBnhpkagPpSftMedAUVkUhTu6sgWA2MsMMv7UkrndRpJXGb
40201	payment	1397	1397	1678	1	1	15223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2SsuCmKXTpqD8sGVZvpanSknRQLtxYGWujkjJD8nAWhfuKTf
40202	payment	2133	2133	1874	1	1	5184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxB4DQejbfRUh4hG1va3FKouWfTmS9kDbk4d79WZhhiujmYSuH
40203	payment	2134	2134	1874	1	1	5621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8C8GhBbqkW9oxUKAspJKNkNafL5QWtEpWr68pTN43tUu4t1Gb
40207	payment	1397	1397	1678	1	1	15225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFbJcpjkuC6SQKCXHPfxZgRAoonhniZUeKhftn4EdhZkjBzeH
40208	payment	2134	2134	1874	1	1	5623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsVUVbuB9HizUxgQv7iPWT3YXNpu5pJcDnEb3rh815RGFR3Hs
40209	payment	2133	2133	1874	1	1	5186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3SJWTzZuW7psGnQeCavpLox8XctMreJ8U6oKaEAZ1SgZPx1D
40245	payment	1397	1397	1678	1	1	15238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNDAt4PDsjcLx4yHhXnjuPh3dhVQiASanMtMXzKRsKHNuKEa5
40246	payment	2134	2134	1874	1	1	5635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeKeQQbqyNwkq9HoCHS8abUx1YVroJkKzdhRY9dXboQhvREwA
40264	payment	1397	1397	1678	1	1	15244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21khJTahTWFwGiFncew3DjDGjWjdVVJRiiGqtHAkdkrCX1ztF
40265	payment	1397	1397	1678	1	1	15245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5AefUz4eGqVv1QonXNKk27iYjm6UsaSTWN7nrCqBjLyQew6P
40266	payment	1397	1397	1678	1	1	15246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfo6CobNN4jAcX4xhz8s8XKLZk3k1NUNU7q65E9DgrLxMwK7g
40267	payment	2134	2134	1874	1	1	5642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS1DWH57B7eR9pevXG6q1MJFvQnAML9ePogQvRPe774wCLXSb
40268	payment	2134	2134	1874	1	1	5643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokWiNvn922tPtHC7NDj5J12KALryeV3b6NKhQZCL93P7XfJhJ
40269	payment	2133	2133	1874	1	1	5205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGLXCggPiDvCEZyPu6Cu3jC5DYZuYanY2SQcFdbfuUDFzLtULZ
40270	payment	2133	2133	1874	1	1	5206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyKwwGRWyYDG5tA5Te1hPKrbLqJ64E5eX4jAa9B9VxbGr9BYB
40271	payment	2133	2133	1874	1	1	5207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa3SRSNXAoQaFGWzJvnfLaPbJywuzAnzQE9tKGvmpTANdWxk4
40288	payment	1397	1397	1678	1	1	15252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4r1Kq185y2Kh3WdtRy6EEMXofHQHFDtEr6Bc5urD3ECTXNxRp
40289	payment	1397	1397	1678	1	1	15253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrmdqQmxhSBP3skgHryWrozeDEViPKfUUqu9XBhsAD4A3z8r6
40290	payment	2134	2134	1874	1	1	5650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnHkg4PuLsmM1Wo4LAXeq1jFUA1PTvMvH917dJqcaHuoq82dD
40291	payment	2134	2134	1874	1	1	5651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLM4Lru3h3LQMSg4LffnzcCtUMNE43zAZebyB71JK3copDev7g
40292	payment	2133	2133	1874	1	1	5213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6USXwBd7XzWp9QXVWtRZpA7DvNSTNHNYB6AqyhLjDuFCSqu6P
40293	payment	2133	2133	1874	1	1	5214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNhGNVpXjoCg8PwWcBqhvFNSTbWoUjriYkPxRoRzaQPmsvgJE
40297	payment	1397	1397	1678	1	1	15255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9w4D1Y4LyJuMaySZjbefT7SHXWX3fxA6KfhBT2TGCubBUbsbr
40298	payment	1397	1397	1678	1	1	15256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjECqmkvwhDCmpEpWTkTYSWKaZuvmhn5nWzRui1gbP1UCsaLh4
40299	payment	1397	1397	1678	1	1	15257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFtqu3EPw43dMD6SNNKnJDXmPbntThigDQQUFHPbDSj8zC8f8V
40300	payment	2133	2133	1874	1	1	5216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6NRqKamoE3opQ1Etm9tXMNNQpuMr4xpnNTqdKfZuBiGeqScG
40301	payment	2133	2133	1874	1	1	5217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhHDdtk9uz6atsDBwtZVKaVV68XkrzB7EhtnMJ6AyFtW9MkHU
40225	payment	2133	2133	1874	1	1	5191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCACM521BbPsakEAt8cxMj1nwgpp4yMhTdSte9JSckg2Aa1Kp
40226	payment	2133	2133	1874	1	1	5192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQj9qKG9T4uXRfo1MCBMpyPfyyHyiGJZi76Rbnv6UjWyFV3vV
40227	payment	1397	1397	1678	1	1	15232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLuDXwZ4sdyX5q5cd7UaGfWNoWLwEHMFtNRqpCwiRvFNWEKEck
40228	payment	2134	2134	1874	1	1	5629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB1i5fgLYVjWJtiFhmjaufTwNT87wE4aU8v7NGfCRBr9GwrJf
40229	payment	2133	2133	1874	1	1	5193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgty4cCdQPpV7JVuQYq7bHfS7cQNkoGpJHyqAtrCRm3eGT9VC2
40247	payment	1397	1397	1678	1	1	15239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yf15smS2iaGAqJC72ShcSwnkMrVjSsBQfcDmpehAZyK3qqB8
40248	payment	2133	2133	1874	1	1	5199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5VJVHSizk2ECuWvoXSGp9R63q3joYyhFvYULrWcFCfyhBsVk
40249	payment	2133	2133	1874	1	1	5200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTaMhDaPGw81G1otPy7vWiTUaKatGhheXrmN6yjiGXBc8tYd7
40250	payment	2134	2134	1874	1	1	5636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDkj3Vg8SRJV3f4cjWQUe6sogu8NzhZCdiukp1xHVueQVoXVm
40251	payment	2134	2134	1874	1	1	5637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduZVGXZijzFWkw1AyNd5pJbFJdJJVcz6r9dtoAZNheyZFPPRh
40261	payment	1397	1397	1678	1	1	15243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZhTP5FMP4RR34kd6DDQBUfz6UnWFWdNL7L7Z3oYNy1yVWNTv
40262	payment	2134	2134	1874	1	1	5641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXawsVEqRya7yBZFnKfWHPygyHqLeE3YtHdY1a5Zb1Z1RoRQS
40263	payment	2133	2133	1874	1	1	5204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzLJC9WBRSBtNwGGGNxvXxgpYdBXH9eHMDeSYaEQFbPMFiUvx
40272	payment	2134	2134	1874	1	1	5644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoerb3s6rQewisTsra759ugWgUbRt2GBSL7XrMfcDMeHucaxj
40279	payment	1397	1397	1678	1	1	15249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd44oCkRE6Qv8BMy6EUs9zk1the8Fq2jQjYy43DNWcDzUXWnYQ
40280	payment	1397	1397	1678	1	1	15250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYum5jts56NpJRcehwEnrZ3C3v4Dm8WixEkZn1M3XdAZKwdH3
40281	payment	2133	2133	1874	1	1	5210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafbawhYyiMkYERYGw2vBNQBKb755utEUPXUEPQKTfNP5Y2J7b
40282	payment	2134	2134	1874	1	1	5647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaUqCypkUrnZq7KXariimrtMofF7vhdgRbQ1qhhNMzB8nrj2B
40283	payment	2134	2134	1874	1	1	5648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptS1qD24QfSxUyhz35ZyThNMKcmZGowguaM4dvihiwVV3NWHB
40284	payment	2133	2133	1874	1	1	5211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aCPTjXtC4Lg9nWi5MnbRcvBpDDyntQFEK8EK29WDa24sqE5h
40306	payment	1397	1397	1678	1	1	15258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6bJWrsR8vzDFRk9b2KFmSNMhRbpXucn8fjEWsHASMDYP6avz
40307	payment	1397	1397	1678	1	1	15259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdZ9Gwxj5dCd7d9qHioigGLpo2bi9Uhaxyb7C5YWBbvipYxjW
40308	payment	2134	2134	1874	1	1	5656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzofdhk9iVm8ewq7ogLbHTxt7fr6FwKGstoTyt6yfwxzRNVjos
40309	payment	2134	2134	1874	1	1	5657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5qW5WbDeJmLST6y4PGjiWgrBLF6uapXBHyfnh9z6fGRL119Y
40310	payment	2133	2133	1874	1	1	5219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2TvArD5am6yRWU81Bj289MC3FCNa6W6KeQw4WrPZCGoGvbpw
40311	payment	2133	2133	1874	1	1	5220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtijGGfDdbjr2KWNjTAbv7JMNzPeBiBHx6TznPNTxDVAQibh8
40324	payment	1397	1397	1678	1	1	15264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpiuHe1rDzQ8sThzT5NBMnwCBpXLeTyCHS3iP5ePvMF5YxfUZ
40325	payment	1397	1397	1678	1	1	15265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6aPAJ2CbYaJ3SToWnc54JHfmSqA8dgt1aCR8jcWjeZRY1zrm1
40326	payment	1397	1397	1678	1	1	15266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRuaM4XeqNkSPBGGM6ccqMGrKLkMMvgvHgc65GiEFMoE45L4F
40327	payment	2133	2133	1874	1	1	5225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHeFLyoM3PSnK4GkJfJGd1S2q6KjkwNo11ij6kuzB7ajvD9ir
40328	payment	2133	2133	1874	1	1	5226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXP5KZDDc2ECJjqEpMjYb4fFbzr3JyNyeAPriVMVmz7pCqXPE
40329	payment	2133	2133	1874	1	1	5227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLGjAes4EGwRxDMqHcWpd8wQgnNRJnpno1ePCS8yK8PJSVmFD
40330	payment	2134	2134	1874	1	1	5662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJvoA5nhLnnko9pqC8CYRt2nwkRvAZdQAc53poWsTbsD4MHn4
40331	payment	2134	2134	1874	1	1	5663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ENw9mPeiJYHCdkocmoCaG1in4MZX8oekioSVroHejtPMaaVr
40332	payment	2134	2134	1874	1	1	5664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVwa79CyAfpQqxzaBH8jP6DwPeMMJmE9WbyWWZ26hsX5MVEeH
40356	payment	1397	1397	1678	1	1	15275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGiLDKhiwhBsCbkXWwegbHKFd7hcp9aTCAdy7KcihVxS9YDVP
40357	payment	2133	2133	1874	1	1	5235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYep9tuBeRVojM8vKsMAspQVQaXgA6t5nFcrMNcbFTJ7Vd8CcvR
40358	payment	2134	2134	1874	1	1	5673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpajEtbLpPMDVHyZsn8JhBo8dMbHV1VXXMeCtF4J9x4C2f82BX
40230	payment	1397	1397	1678	1	1	15233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBENpKA9xN7PyLjrDiXhpsvF6iU7xKXZvuZKAkgct5fBuwei6f
40231	payment	2133	2133	1874	1	1	5194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgbBHudpDVkqWXaCHStTywUSrmTRJxrhRLdDh78ySCuVdYHq1
40232	payment	2134	2134	1874	1	1	5630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7oE9pLfvGfmXXR3ZANjKwNUoE6rG4hV9Zea2KqXCN64juwc9
40233	payment	1397	1397	1678	1	1	15234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81yF97W2UpLbC3Ee5cVH71wzck6HCAo4X1yCctTTpSxj3WoaA
40234	payment	2134	2134	1874	1	1	5631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSztBb5Z1ijx38QGiH7eShwgoWtYR23iDaBgkLiaJo1yVgThiK
40235	payment	2133	2133	1874	1	1	5195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJLM4rUKE1uRGLzVJYkL1BMq4xwU9CeE3UPNSjaHnQTR1jNkL
40239	payment	1397	1397	1678	1	1	15236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhtxzvEZVjDZBm8nJvEB7bHpdtv7KP8vY9f4X2EGwRfpv1QdY
40240	payment	1397	1397	1678	1	1	15237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5Xxbp9mC3b3Ym78DgWiEjN9gGTRLCifX5p5nCzBAFea8HoU5
40241	payment	2133	2133	1874	1	1	5197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCYCBLBJqmhphNoUzbu5Amyw6doNbUyUWL9UYYV5Hnah5RDFw
40242	payment	2134	2134	1874	1	1	5633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi2TYwZ3h9WrBWf33JbmWpUhKHEMbrb6y5rQBJwQcEt3P7zY2
40243	payment	2134	2134	1874	1	1	5634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaCejw5N6aW2xWQZ7dzTT6rTK4GZQd5Xao8knZzEsTBWe9eiq
40244	payment	2133	2133	1874	1	1	5198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1JdmZ7wEDxRR8YkULCkTASAcyH3CGxjLjNneV29tNAmMx9V6
40252	payment	1397	1397	1678	1	1	15240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3h8jeTmo3T5dTPBrfgmaXJnRKpNJPf9FPFp9W1pS3UwTJQuy4
40253	payment	1397	1397	1678	1	1	15241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkN8QQb5qhbRkqX4guaPpPY4Tp3VjSM2ckwW6rvwZf3DMe5jmm
40254	payment	2133	2133	1874	1	1	5201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftGAg2jeNMTLxCrA9pAkwW8aXYCp3jt5Rr4AN3SZQ3ctsJo33
40255	payment	2133	2133	1874	1	1	5202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBYiJh9qH3NZAPjRSfC7ccNWw1WnK9EN9XAgcUPjMwZs2YkH6
40256	payment	2134	2134	1874	1	1	5638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZympHaTFNzdw6bX4QjdFxbZK7n1ZapCULwEjjj1uYp2WXriDYy
40257	payment	2134	2134	1874	1	1	5639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWAcvWZBz9PMT4ma2KDEKVoSwrqxF7ydrngy1eA4LX2NpoV3N
40276	payment	1397	1397	1678	1	1	15248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdRdEipRHe3ePVqEy9JUmYkddG31Kc9udPr62RxBFe9pGSiv2
40277	payment	2134	2134	1874	1	1	5646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAFdnD1p56vUTK1XxnwQxLf98CFhxnwuuCaCnm7DyXyucZX6a
40278	payment	2133	2133	1874	1	1	5209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhm2g7s8YPNZ3t6HJ9uGBAGgPgXNgZc8wVJQs8tiR8qFjMDCRz
40312	payment	1397	1397	1678	1	1	15260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrrstL9o9AoSbXmxs5Svej7Pqv9NJvwt2AxdZY6ym5ytaXvMo
40313	payment	2134	2134	1874	1	1	5658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRaWodo7wZXZovV3BHNechwYrhYxSEL1iV1KRoSjF2uBh7QXG
40314	payment	2133	2133	1874	1	1	5221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB52v97CJmZouL9HWHcEmXszuwspnVY8kRcvaRAHZJgcUYsaMr
40318	payment	2134	2134	1874	1	1	5659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ174mMEAaN7FJmRwz6JRkxTw8a1ybCC2LvfK34Xk4LtYo1LkAw
40319	payment	2134	2134	1874	1	1	5660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqtouVdAvzuK7udgGHcQW9DFjtdPZsY2E1pdTTd8Qi6PjY4Tn
40320	payment	2133	2133	1874	1	1	5222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyyxN4ERPh4PhuMM4Ne1fQD4FRV8GyuS7SyGLKif71oJ44t56
40321	payment	2133	2133	1874	1	1	5223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjUauNQ2XPohMbQdh47TBbq3kRFsZ1NmhbqvC4d4HAW2XjuuA
40322	payment	2134	2134	1874	1	1	5661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwwbABtn2wjpMKWRJLNTGqKXDiS2sm3TzfDF77bgTMtHysUTs
40323	payment	2133	2133	1874	1	1	5224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59qsM5ooHPrZoR8TvvwAWjt4UcW2mngBcEMJYkPAcBWtHpEGw
40336	payment	1397	1397	1678	1	1	15268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnt1dYmLwwaC5bPzups7sHCt7QGP8EoG6BsT7wFV58mLGq6w1M
40337	payment	2134	2134	1874	1	1	5666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtp6CM7HiitX2wfYpTPVFE1Sa8cgF7E25yxGnuCEcF1yy8Jr2
40338	payment	2133	2133	1874	1	1	5229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWGWBEVtQdk53QuWnw53ZPzvAmSt5nHfneTiSFHX4MbeugKfJ
40360	payment	1397	1397	1678	1	1	15276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPAEPk8Qv2chqmN6WTpjaCAsLfGVkP6gpEHYG8pX6NpDkoHHk
40361	payment	2134	2134	1874	1	1	5674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97AvyBk2YZaQaC8XPMkPgAhaGX8hkSXqpRx4tF6dt7eBSv3dA
40372	payment	1397	1397	1678	1	1	15280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7RgzzR9gGW3d7nsespN14YXp6kwYrRYNPHfmrPNPJMM6sNoy
40373	payment	1397	1397	1678	1	1	15281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYkjdcRpzNQEPpSjuUoiT4XHRoMtJmup9rk6LMXQ25YmCiwSt
40374	payment	2133	2133	1874	1	1	5241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVz2GBWrxtodAjRYutMHKtBg6pmkpGw5sj6nYPQtWauRtg7L3
40260	payment	2133	2133	1874	1	1	5203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ak9WUpozBpuVNZhzyZrUo2mFE4WzoY9L9zw2ZzjQD6ujebx
40273	payment	1397	1397	1678	1	1	15247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBSXQMbFB5bzHx4x4BCVAYUwaNdcwLaaGjvnHiPaL6rxM3fv9
40274	payment	2133	2133	1874	1	1	5208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtERBRbfDaamWVNe939ECoynZ2mQh4w4gkTm5zgDsjJsVzUbB
40275	payment	2134	2134	1874	1	1	5645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11Lk9hDjpS7FG3FWLx1gwfhxnVMaDBf7hzgVnktXYgWTMba5B
40285	payment	1397	1397	1678	1	1	15251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjk41kgzasEEacRBc6yh4sw48xh6f5bF4vEnByvMfbAaAXcgyo
40286	payment	2134	2134	1874	1	1	5649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnW18ba2E9afXjTyXWQHwcY5NVTDe99ELrosbVHPbbUz3NiAR1
40287	payment	2133	2133	1874	1	1	5212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jMPTggphBwXipzQHuxXLsEPEGDdvCYrRckkrZuhsidiCXiaG
40294	payment	1397	1397	1678	1	1	15254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Hzx26w2fqaBJHX3yngVnAemwcw5RjfKL5fgBB4XQMr4FWBa
40295	payment	2133	2133	1874	1	1	5215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcsWgey8u1tUfWQfsVzRQ9hCRJZAqgkULcN4CXBzfKU1mdEjD
40296	payment	2134	2134	1874	1	1	5652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvhwnNKvba3E2AKafZbg3d7cU6K5FZ11cxpcU4APXXjVAxgYq
40315	payment	1397	1397	1678	1	1	15261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDRDgQxKW2VCTw6Ki1sHuyLULvfnp36kCjasENXWqz4mJrM3a
40316	payment	1397	1397	1678	1	1	15262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvBBy1hpkvVN56e6kBV4kYTphHQqTZf51ei5KHt15oEkEMTKb
40317	payment	1397	1397	1678	1	1	15263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1pymZWKeDsWMhMEJFTHan7tRqaR13VtooxHgas9rfqfTH9Mfu
40333	payment	1397	1397	1678	1	1	15267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i7bHU6HBmC7gjUzeSbGTBWB78bRW9AXCMigq5smgNMtL1168
40334	payment	2133	2133	1874	1	1	5228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAPPoWMBFNK96iBZ1cwFtkgUxi58ZDBqAv2tHuPg6MFq5Xta6
40335	payment	2134	2134	1874	1	1	5665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNaDJc6tCSTW5PvhtoHKXRLZ5gVnfxoyVNvEcdTiR5yWc7REX
40354	payment	1397	1397	1678	1	1	15274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLtGR1YNWidUiiXgtb4PmdGbZCxxsc5SieZEMWccYvYRCFckX
40355	payment	2134	2134	1874	1	1	5672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmvNfTETK8X8qTsZxPQ75nQtMTedJv8YM5n6Qtcz2Uqoqwg28
40366	payment	1397	1397	1678	1	1	15278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQ7jNHzTeK7yKtfFBM4RaZ24pjSmQ6dqmajwTDMpFq9sLknaC
40367	payment	1397	1397	1678	1	1	15279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqA5P2T7FmJK6DN9V4KFZrT63Wt9vJQYdiRWQCCf4GcmxhykEZ
40368	payment	2134	2134	1874	1	1	5676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbra3iUCvnbFeyJ37XsLymHDorv5XeqVeVMT4ebXCLt3D3Uacb
40369	payment	2133	2133	1874	1	1	5239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjFtzNdiACFTkWh76grQwvxzRrjxu81Sdm5afHRE7si26XiUs
40370	payment	2133	2133	1874	1	1	5240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjwBbnqJVQapnUiEiL3WSBX1GMk1aU25F8U8Ksz6veA5cSoJD
40371	payment	2134	2134	1874	1	1	5677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4yxDrgPHKKrYeEiaiebGaUNKeQCdv6a9NKAsPudGJC5eQVpx
40378	payment	1397	1397	1678	1	1	15282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqBPEoQ85YzZLCxYBkJCLHNjHSxifpLnPGSsfZecE5Ss79WFb
40379	payment	1397	1397	1678	1	1	15283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExSkV4EpMD7ryzTroT1Uo1xun1Qiqz5XHGGNjw7YdPCZizB3y
40380	payment	2134	2134	1874	1	1	5680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4f1PA4s5BMAbpCDEA56Pw9uBU7zTf3u8ngBhhSxRsEYyigVVU
40381	payment	2134	2134	1874	1	1	5681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1LgJrmJQ4RxpQDakBLwS7mpDUnQP7rnmNoSfGZunYMuNpU7Z8
40382	payment	2133	2133	1874	1	1	5243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcGd4PtqDW4NZjXhFsUyLxGByJ9AZ8qHzus3UKW7GAVQAaxX8
40383	payment	2133	2133	1874	1	1	5244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zF8WfGp39kKx5wPzJbPgvRVD6AwBsttF8qHU1cKxHdXGx8Rn
40387	payment	1397	1397	1678	1	1	15285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcEmrorry2qj9wE8y8gg3Nym1GqXn35QxGMgUhRarp3rMzyfS
40388	payment	1397	1397	1678	1	1	15286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ERaowFHNWAbSH9Uhjn3YSdPkGfH21cxUS51Ug868nWtcSyHe
40389	payment	2134	2134	1874	1	1	5683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sWjeLemtPFZFTNcmEQ38kmeUYfj9DBoMzpMHC5AeSPZJ3Qb4
40390	payment	2134	2134	1874	1	1	5684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC12BHN8vXa1R8t5yofpHhbNybxgG2Fwph5jHU3qGPSEEQAsj
40393	payment	1397	1397	1678	1	1	15287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQinf1rQPjoVU15h9nmd5ocsnbnyZdBRUkqWksNTHaN7c9GgMX
40394	payment	2134	2134	1874	1	1	5685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeM6JATmSgr7EuZPiEWjDAWC9BsFFnn6vo4ZjLD3c18Ei2UAR8
40395	payment	2133	2133	1874	1	1	5248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGLn6SoeZgE1KHgTACqiosL59jBirgeYLZPt62WSiqtVbVr3D
40396	payment	1397	1397	1678	1	1	15288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiavM46bRbrGJNbkZSUJZnn6dKfs8A8PWB434gizFmyz4sw17
40302	payment	2133	2133	1874	1	1	5218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpj571iDy3tio6eKaTfCyFsfo8zu5MU2uieGs8sWBJfcSEEAmE
40303	payment	2134	2134	1874	1	1	5653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTX7NSx6L8k2v6vx6JCJzP1oNFZ5pUz7qVfVv8BkGWPbrf4SyD
40304	payment	2134	2134	1874	1	1	5654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39pE3gzGJjcBCGPKv2oViaWH9igmKMgf18jnL8hi46kefHLkN
40305	payment	2134	2134	1874	1	1	5655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgfWmEBY3iwgaDbESyLLXZoUPyqGj8HpJTggFye71vdBhexok
40339	payment	1397	1397	1678	1	1	15269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkgcYg13e3JV9UmdcLvHEt6cphRCuW49aa492C1AKKKshjUwB
40340	payment	1397	1397	1678	1	1	15270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRxjLsfsgmfVUo53firtZzH13YEeZNKzkKiLsqRJSctwNv14b
40341	payment	1397	1397	1678	1	1	15271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuPgb7NYDaSBi3jSkDvCT33UwF9rDim14PQqbDYWWeFuAPJBm
40342	payment	1397	1397	1678	1	1	15272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPL7keiRCTCtCp2Upkpxky5Dt3M4ezKy3d1zc4yeokZdX6HUg
40343	payment	2134	2134	1874	1	1	5667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWEVNYF3YhPW47iW6fPXbDpf6HxaBby5wbw2M1S7acSzWEkhiU
40344	payment	2134	2134	1874	1	1	5668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurz3JpwLayZQifKaWnDFd5wwcnw5VXPykjepczMiZuR9u5kxK
40345	payment	2133	2133	1874	1	1	5230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexEYeQEMKKvw1EdaSemTBG69VS1xuGF2MWmURLpgr7xFte4Bn
40346	payment	2134	2134	1874	1	1	5669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjao7BJS8NyDe9FAFCD4bmGmiNGp1F8QeoaJE53319uEod6XTK
40347	payment	2134	2134	1874	1	1	5670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJyywwb1dJprJmMsECguf1SqmC21vQcZ2w3ixoaKHsqArkm47
40348	payment	2133	2133	1874	1	1	5231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5bq3VuBmx7Bx6v7D5qAwtSW8y3kFTHAsu6PRqTdG39m1Zh7J
40349	payment	2133	2133	1874	1	1	5232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkhdtbbXTsSv797nZ6MwR9S93CNXynP9w67gu5u4ToN9vx7TS
40350	payment	2133	2133	1874	1	1	5233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u4njHDHygFurrW35Z6uKcpANvVXpzCdWXGYF3Gg4xHtjbiM6
40351	payment	1397	1397	1678	1	1	15273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU51mAS7UR7ds3D9f1Y55YL3ixeygcyrAvZtKDEN5gxmNih2GK
40352	payment	2133	2133	1874	1	1	5234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchYuMykC9abGKVaKE4QXqCZpuDR4AY4RCwKv9HJVrUYbigd2e
40353	payment	2134	2134	1874	1	1	5671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hgpBKtjYgVx7g6GbUMwbQsBFUxr73B5zumrsijj1bRgXDF1z
40362	payment	2133	2133	1874	1	1	5237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzknnXAC5i37hZ1KEg3CdbpyCUSRdfT2Yy92Z52SVeQuqmuut4
40363	payment	1397	1397	1678	1	1	15277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MnmX54NBTxD3LgVH7AS7c3X1phG9jvoR5WbmhD9fdry473yY
40364	payment	2134	2134	1874	1	1	5675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRJs3Z3p6XmSnMTb6ZikYFZjAfEiXEnUcxrBmnZzdcE69Vqps
40384	payment	1397	1397	1678	1	1	15284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTkLZ1FM7XxPv5XXJ42Ubn7Y6Tf4eYsh4UQcL5RyWAzY4CEx7
40385	payment	2134	2134	1874	1	1	5682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsP1fxxMnVikXdyNPS91TTioYbSiX4YyC9y8gqpGei6dSa6imh
40386	payment	2133	2133	1874	1	1	5245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSjqZcirQT2c5jbLXchXkmDo9RWcyKeab4FJZiueYiHWyRRQ6
40391	payment	2133	2133	1874	1	1	5246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoaffXvXU7iTaf9YJmoCGqHKSfezVNoEA45JoGDYPQmyuYfeA
40392	payment	2133	2133	1874	1	1	5247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbEvYqRfR6QMSFA1vNPuxccBWiLP4ZnBBK5CDr9KSbvfm4hbN
40399	payment	1397	1397	1678	1	1	15289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GwoTaHXLdG2AQZrEcv4EY9LmtUobT1X8zZ1AM6M8ixCZuNpj
40400	payment	2134	2134	1874	1	1	5687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68ysG1oysUjtrsKAupELU1dncbuVoXKYktgQDpVwYFti3xVPV
40401	payment	2133	2133	1874	1	1	5250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKHBEzRAFGxyhS3mFfZaKR9gEAELubGJjgihS4bRjgXdE8VFR
40441	payment	1397	1397	1678	1	1	15303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWAZvrCob3z7eHMcW9MSwGa6uhEww9kKWhtQbsATkUJ8Dmw6o
40442	payment	1397	1397	1678	1	1	15304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufZrR85oDZHnJYK1ZZvzpL41k5aRMyBCbZHHhqwG3u44Ermk3
40443	payment	2134	2134	1874	1	1	5700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5jfbxCxiAWrzwR46YEhAuLSoy6rFnbESYxPGKzY2sX8mRj7b
40444	payment	2133	2133	1874	1	1	5264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ6BZo7Gq1qmrECqg3BCb8nQkzz53q7G9epAaxCRvrst63pWWG
40445	payment	2133	2133	1874	1	1	5265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWNN2mP5jeECVh7zznX7iCTKbJ9G9r2MCqdVP5RDUeXJEMbC5
40446	payment	2134	2134	1874	1	1	5701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2zd6NfqGSQ22j3BMNM2cfos7UHAXQ2Esjyr7otx7Y8YLntuc
40468	payment	1397	1397	1678	1	1	15312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKiobJMRNJC4Cpu4GtdPA13yLL7i3w7QQyGgeGMdtMxQGy97t
40469	payment	2134	2134	1874	1	1	5709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNGHcByeB3QNsLE11fAAoLtFwXjBJUaDLajss9iK3F9NvBffv
40359	payment	2133	2133	1874	1	1	5236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C6aXyEeeV3mwNtUp2PFhLRSEpi53FBsgTp2A7Tcp5Zj9XWZm
40365	payment	2133	2133	1874	1	1	5238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dnGN7UbFPGya8qq5oF6BBbdK5t51QMgwC9aYgfvjeW76bZoq
40417	payment	1397	1397	1678	1	1	15294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81g9mpYU6bGwVWDCSAxPX2WqdeQYoBNSG9PnqmHuq3LTXqy1F
40418	payment	1397	1397	1678	1	1	15295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKXMSiiWqwvzfhNBTozq5FbG76bNekdnTLAYPS4p3AXPA4LgE
40419	payment	2133	2133	1874	1	1	5255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3q74erZNvjz2cnH59mnncBUohsd8nVxhuCdX1eysmfPXySrV
40420	payment	2133	2133	1874	1	1	5256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEymTm1CM8NQuZu4Acbyk6CBQZKxaEBFdgNXB9VR6MPYGfEFWq
40427	payment	1397	1397	1678	1	1	15298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHHD4X6GegEye2V9Lk9jhs9FgVbab71sWa4iAtqT8fdRXNvSV
40428	payment	1397	1397	1678	1	1	15299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUCMYvLXtj3c3Cjb4P457Xx4GhqfAuuvx7dqZwKVF16fmMRJi
40429	payment	2134	2134	1874	1	1	5696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vbWxpi5WLaUUCPkiwTaCLcrjYXWXS32GQ1gjbgppxMGzz9Su
40430	payment	2134	2134	1874	1	1	5697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dApjeQhaLThCFP3MqzvKpj7TpES74LazhsYxQwRwpt9rJrpX
40431	payment	2133	2133	1874	1	1	5259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLe4gC3x4YSYMy8FAscnLvUDwW5dYKZATKwQhyBAYPEPx6hVhA
40432	payment	2133	2133	1874	1	1	5260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYubGDWTtYSNSSC3rgc7Rf2FtngNDjD1wGUJ9JrFH9V15VJuX
40474	payment	1397	1397	1678	1	1	15314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSitb9qBhQ7YHtUYxfBYADRG7oZrkmJLPa2ZGG4aNq8BNEU3U
40475	payment	1397	1397	1678	1	1	15315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg7r4UvycAxLY2z7ZJ4dmtTi6cwNFjgp81T4sQ5wg3exn7iPp
40476	payment	2133	2133	1874	1	1	5275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLioJAQn5PWACkiAoPffWwyuzMBHn1GF4fykvuHx7zG1Xy563
40477	payment	2134	2134	1874	1	1	5711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfExLf3Vtce2Q35MF6D9oU8RJxENsWKvzEwkuNE9f66boQqg7
40478	payment	2134	2134	1874	1	1	5712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReJAuJwD1ZcJbeR291c8wExZXMZ5zaH6Gn454adXskfdeCXwm
40479	payment	2133	2133	1874	1	1	5276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBD6k74paSGm5HLHVpPG2Fyw91H71krwJ5JFzGkdo2xasEXsK
40486	payment	1397	1397	1678	1	1	15318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhbxmTLNTZtjpbkgztVrJdUysLDURvzZsTKrPKbN5enH2d2eR
40487	payment	2134	2134	1874	1	1	5715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQtmBL4iMA7f9SJoNhGfJMF4Y91gGvAzbDaspW4ADdMPJevbN
40488	payment	2133	2133	1874	1	1	5279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXmgo7ntezuygwRc1ewtsokpzDWtipw3ophEKrbsYxVfQ4ovr
40498	payment	1397	1397	1678	1	1	15321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DxnfWkzg2Ho2bzwTVL1nmVbPhQmjgLrrGcnT7qbHeytBCgCQ
40499	payment	1397	1397	1678	1	1	15322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPhN4eLVtVnuiKHNbnoosxSDSpomyeL6Z3EojNSFVD9GFdKwE
40500	payment	2134	2134	1874	1	1	5719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScSPDZ1chEPLcupX4XCpCEckC3ksTP9ScXRiiabb2itHZgohZ
40501	payment	2133	2133	1874	1	1	5283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt5pZp8Ziqa7yJMcXin96dmwC9DgJWLrwezT9dzFJmCSFa2Qs
40502	payment	2133	2133	1874	1	1	5284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8sLr2VawT8HX46EfJrMA8mNEKfKwR5q1x8C4ZY1pMduhQ4nj
40503	payment	2134	2134	1874	1	1	5720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnup8bhkpKnhKdMyJCj2A2JWERL5k3TQjDCG3awoQgFSTq61T
40535	payment	1397	1397	1678	1	1	15333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoYAReysEWwYViMJb325MKX15tVUMf2XnquZMWpZTy9yFufNp
40536	payment	2134	2134	1874	1	1	5731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaX6vE8rSTjrEDnU944TjbkQTUvarhc1yz7wLYA4uhNtKyUUkg
40537	payment	2133	2133	1874	1	1	5295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyeHxSJntseGNzdYLSaLG9G3kHvohisTsHHqpPXJjR3tHTQiK
40553	payment	2133	2133	1874	1	1	5299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8z6njS7BoiVPjkcCHrN3ptWtheyAB8FPj7jUgNTm7ZbCSe3rq
40554	payment	2133	2133	1874	1	1	5300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4KooW7RKmHRwu8Sgvuxg3VWfeLYKbNGYNsyrDtEJgP5XhnbQ
40555	payment	2133	2133	1874	1	1	5301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFzALpLaLQ7Cupw771PateVWmYkusWYCxEL8Nk1bg25ZJaNiT
40559	payment	1397	1397	1678	1	1	15341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9LGsbnTMV8p9irgPp5ShhzYK6JKko1QhoMsAn7gbA18DdGBg
40560	payment	1397	1397	1678	1	1	15342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjH2tawoGEdvV11sRnaPcpZE8bXwynk5U1q7oniost78D6Z6k
40561	payment	2134	2134	1874	1	1	5739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLtVCeGhxzMiZ741H2jBBuqi7Wan9e3Q8tJBPek3AQAU6SoEh
40562	payment	2133	2133	1874	1	1	5303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43YzJDhAmpExwR2PohVZQLLHp7S8nVibJk3C9Yx2GduPBjYhN
40563	payment	2134	2134	1874	1	1	5740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cJVWzua69BFy4epnbcZZ4Yje3HVYDAUu5adLMRg3KWAf8A1S
40375	payment	2134	2134	1874	1	1	5678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4tetWoUCh3jcBy7niWTQv4NqMCpS8kmdDasS8sT7J2asMdX3
40376	payment	2134	2134	1874	1	1	5679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwssB8hDUsdqwyHFnJXJswjxBt4dsA9UvA8rhVVXwrCWPomShF
40377	payment	2133	2133	1874	1	1	5242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAeNQfR7SaVNsi4tbPJnVbgeJtYg65aF3MTj3Cx7ZEXWdWMyn
40409	payment	1397	1397	1678	1	1	15292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViZDaEnepvspetNHfTCTKCHwV4spy8N7wFoAFtkv5WHZ5aXxE
40410	payment	1397	1397	1678	1	1	15293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9jYcv42C4T9UgWnA4qwyYTsVvtbtsZ11v6kVgHenNfnkczDg
40411	payment	2133	2133	1874	1	1	5253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTjcw15ai6PMfjiqiQRi94Uv68pfQEkLExxbnE7RsvpAQesj4
40412	payment	2133	2133	1874	1	1	5254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfbN2kGkcQL1K9L6HNQCpLVLGQ8suG4jCmLuZYnmxkeF1QxUM
40413	payment	2134	2134	1874	1	1	5690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspTCacXXR4p1zn1jq89tiaHFjpsAjZLbMrTQM5eGduNJk9jdT
40414	payment	2134	2134	1874	1	1	5691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwx5x3C2FVo2jbYRDPUSpBpqHgxGHvmFHj2RC6M4N7TNyumKJ
40421	payment	1397	1397	1678	1	1	15296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtVTGKMoPf9MJf2swrhH347LEkfUbsF8pVW5RyM75W7AjiTPd
40422	payment	1397	1397	1678	1	1	15297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8NncQRbmZh6AuVtJNZmzaynDMxkg5JoJVAaxaNnLLxq11G1p
40423	payment	2134	2134	1874	1	1	5694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypRHAAfs2cfNdiTNbDzbWcBoPNhE9kXjdbasJsgS3pMeHRHB8
40424	payment	2134	2134	1874	1	1	5695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTVpwtmGcT5986FjdYXJq3XSgtyQbWAn2PQbQncPZGR59EUrR
40425	payment	2133	2133	1874	1	1	5257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UdTaeMH4tcfgN9a1EPZBRgmkVZATpQUhYbzPKzvgk3z2RCJB
40426	payment	2133	2133	1874	1	1	5258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVUT7BqEoVQybbS9GDZTHtzS25YHm4K4MWwyf3X2ugpvohwrZ
40433	payment	1397	1397	1678	1	1	15300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHsHFEskKvTihBmmDNSK3WaG5Tv7psEDcfyvEEQMZUTPDJF85
40434	payment	1397	1397	1678	1	1	15301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHHX3FxjFBDqdrVFspYHi4RuTdYdwjzgXJaZnSxjmg5rbvyui
40435	payment	2133	2133	1874	1	1	5261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPUNLYxrASHMu7SewWvuhGeoPXRYLdQwXfq1ihB9jrPuy3bRi
40436	payment	2134	2134	1874	1	1	5698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGzAN3FPXcvE1J5irwadgaeTVVHheY1zSeXqSAhqpv1meCCKk
40437	payment	2133	2133	1874	1	1	5262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmvmTqpZuMAMhFEoCKzaKNeYkkpW6s4uNcdiMcZ4EqLsjbB2T
40471	payment	1397	1397	1678	1	1	15313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAK2hnKuGUiWJYZNsuVfzrm8hEinNxzya6fRHSwZ8uTvKHpxPf
40472	payment	2134	2134	1874	1	1	5710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHmUQi9Buxgoc6qcWSKQyX5eUUtw7HniDhHbHGj9ZunAz1MgS
40473	payment	2133	2133	1874	1	1	5274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4YnSDxq9rjffd5gxhRs9pToptcsN4cedSFsgxMaayZJ5pmgp
40494	payment	2133	2133	1874	1	1	5281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPPgkSRzjmSZiEzZUegkAsQv5Sss5wvcqCWUMrAHn3ygq1uyW
40504	payment	1397	1397	1678	1	1	15323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCxT5VGRBjhfQaTv1uYarwQurcS3kxwKpE9JpfpzfxNPwkw1B
40505	payment	1397	1397	1678	1	1	15324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1DG2Fs8mjg2C9j7jZp9KbTUL6t9yHBf3qWFz5aERrUjiJvPp
40506	payment	2133	2133	1874	1	1	5285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41mpBbZuJHKMM5iuqz7aaa8QveDav4SVLgzACvrmn87sj7ni6
40507	payment	2324	2324	2232	1	1	0	7980000000	1000000	\N	E4Yd1e1vqgZzrcUmS5XMqvrsRutuiaxZppt75fqnUuvxEY6JGDur9	CkpZ7jgTUWsgQRc92usE7jMjxT9T23F4oizi3Kmpw422vqu7iNrv8
40508	payment	2134	2134	1874	1	1	5721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNos9mU8FbPL4kzy47iV83DxjmvnaaKWh2eZHtxwXd2WvU5Cr
40509	payment	2134	2134	1874	1	1	5722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVSBu8Ur2Xj2hNHYgxXLbJJyfhRbugXYhRf7ueTenGR5f9ZeU
40510	payment	2133	2133	1874	1	1	5286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUCnJaQRc2WDu46df6rjazhaopwyeCQT64wDzBBCarUYMtvdt
40511	payment	1397	1397	1678	1	1	15325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuq52eh98h2v3fLjRfrNFp5gRjGJrrs1jVnGrhHjhW7vYHz4MC
40512	payment	1397	1397	1678	1	1	15326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbpeacdT3CL33jVZDBmPKErT7PAjBS3K6gJmG8tkqREEgYGsU
40513	payment	1397	1397	1678	1	1	15327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7htaDX9mzmf9RUfzrKi6XWWKjMwM36c3y1Xj9EhirA3keqF2
40514	payment	1397	1397	1678	1	1	15328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P51Mki1eUSb7rrrdpw2LDyahpDSPLsitEE6BKtXfXELmkKKj
40515	payment	2134	2134	1874	1	1	5723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9XgAigRAp1pLnsyr1Szqab3xAaChCpqqCy95ppsuVttjwe1i
40516	payment	2134	2134	1874	1	1	5724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyx2tJfqokiRCr2hQjD3Zf4WEYSWMnKmWdUJn1m3YWjbCVSc2o
40517	payment	2134	2134	1874	1	1	5725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9gPF1TD7nX46DXxfg3EQuninDf3R4RHnY9uWBDYBdSE4BP2j
40397	payment	2133	2133	1874	1	1	5249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnkwQkEvUFAdaLu1v6KS5TDvT5jypZC4r7vo4zfmayENxMpZB
40398	payment	2134	2134	1874	1	1	5686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzu33WQ3RVLg5nZtDjVPTNj6wyZyJ7FMBHHDTNrMNp5HmecwG
40402	payment	1397	1397	1678	1	1	15290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVKJygA8WNuzVBFqyjQvUykaRrH2Gayb6tkV17dVF67cv3pDS
40403	payment	1397	1397	1678	1	1	15291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2PTpVuyQeMUqomZHCmrbVTvHy33Y5cN1BV5PFmN3EYBCggAT
40404	payment	1159	1159	2232	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4yd2yMTowBtEfK5HMhYvPwJ7v3ExGs9QuMhjof2fT8WmcD5x
40405	payment	2134	2134	1874	1	1	5688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pBzVqtYYVZQ3JSrZMjhwqYe5kd2nqNFRjrahEkjNb1Q5uVch
40406	payment	2134	2134	1874	1	1	5689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurNRoGe5gr881yz5PPodUDmYyAZWRNHwuahn7tcyDvQBNcbbn
40407	payment	2133	2133	1874	1	1	5251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TvnhMYD5BADAwXYAutg62nSUUZJAmD5Dt45brJKfScTRNYsV
40408	payment	2133	2133	1874	1	1	5252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eZQnhJd3D4WzSVQi1rTvLwwMQUKtNgq46Y7CLSbG7Kxgi4WJ
40415	payment	2134	2134	1874	1	1	5692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRw2JSmn5Zj1jjpat81DDA3Yazzf5ogeT7cZgYHfbQNFzDh9K9
40416	payment	2134	2134	1874	1	1	5693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPr1sD74oSh6q8h62QZmAkwzvHYTu3RrYCLN2Uj7Ry4sqdww8
40438	payment	1397	1397	1678	1	1	15302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjspEYNSm842ziGFy3QTYpGkawZKZ7DMGBKP9TQNcT4ExfXois
40439	payment	2133	2133	1874	1	1	5263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd8qDDpfC5ZUB8ikU69ABaZRst72bA4keauw4saMiP2ZD4QZxp
40440	payment	2134	2134	1874	1	1	5699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbctgy3SbmiDdYderrhE4ig7p24m5PE9WEsySPcy9tUmHbGgM
40447	payment	1397	1397	1678	1	1	15305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5WiE6XmdyNUBpvp7PAYzLrDHMcQw3iFk3upiLxjYD2VGgAux
40448	payment	1397	1397	1678	1	1	15306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sojqxkkJTD8WxHtgjhwwyMCWgjNFEe6Kvo6mfJeemuZ735PF
40449	payment	2134	2134	1874	1	1	5702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuMmUpq12o2a3xdSijLLUt9KjQoj2YULzkh6FUagwwMSFWhjP
40450	payment	2134	2134	1874	1	1	5703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjyjjxxSujwXvne7bCxdDVaHCHJcZAdYmqWCeEZmdtc2EXdEE
40451	payment	2133	2133	1874	1	1	5266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu1pq9ca2PNKVR71VqWNFPNxD1b6Vq8HNh82of1PAPHCQUa2c
40452	payment	2133	2133	1874	1	1	5267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Mn14jEgfG9BD7eGXKKLoY1TVsRwkQVrf4KouY5JwjaXf6F8d
40453	payment	1397	1397	1678	1	1	15307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUW4csiTN6awN7qNXnBAuJzh3JZugfbVpYNryuM7zZZctJRCt
40454	payment	1397	1397	1678	1	1	15308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fuwE8MaisZHN8MXK7izMsH2ANdEyVrFEsFHPpQF3aC6PfaN
40455	payment	1397	1397	1678	1	1	15309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1sCkQ1MJprTeB9nSD9rb8XRWoss3G5UFtpXSTAfr6WyBtRqg
40456	payment	1397	1397	1678	1	1	15310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghd8pyEguFHvfg1KyyRkbbRF5na9vH9hebNU57bnqhhXFPm3A
40457	payment	2133	2133	1874	1	1	5268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjvc1c6rdtonwfeTZXp5o4JrGGxKYm5TaWv8J1WKRi6vtjdpt
40458	payment	2134	2134	1874	1	1	5704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqF598BPUuh9ngxemSJ2FgU1EYgoEkKEYxCy53UjBNdp5AjE9Y
40459	payment	2133	2133	1874	1	1	5269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkGtDob2tNTjxUvftg4nYuYzJbLdorzitqtSs7rGzYVnxdSNV
40460	payment	2134	2134	1874	1	1	5705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXznPxATjRkqkRuWy8QUYoC81xM5pSagbPrvnfpscRwwKAJ3Gf
40461	payment	2134	2134	1874	1	1	5706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrj9g8qyPMYJTf7zcY4g8Fhke8MZFQfnDySbWGiYzA98vvWNr
40462	payment	2133	2133	1874	1	1	5270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGG5NBDngM3BeJnbvmxRVpjMd1BjqdS3GKrPw21qJwjzbnnJn
40463	payment	2133	2133	1874	1	1	5271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hk1mxJJVdvG8PbRVANoqFm2oWJSvu31nVYGVPo6fgXAuijwJ
40464	payment	2134	2134	1874	1	1	5707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE34YQmpo7UyvRSqGsw1yJb9hZmeGgue4w97ncS3RcLoCSMRft
40465	payment	1397	1397	1678	1	1	15311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWREgTQM6sxyBzx5e9zTFKvghMumi6rWTnKzVMoSK6AcsiztQ1
40466	payment	2134	2134	1874	1	1	5708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDYgFNqeQsvhm4Qi9mDR4PfFiwtJcwX26xWEJTBJjDMPZVWao
40467	payment	2133	2133	1874	1	1	5272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWdSS1BGLrukSaMRaeN3JiwprVNXQSdK9xPwivBh4Ur9ZM8Dz
40489	payment	1397	1397	1678	1	1	15319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYESp6yA2Zo1cfT4yXRiKap7sGRNEyiVYpu9QGW8cVZ9v5xMwN
40490	payment	2133	2133	1874	1	1	5280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCz28MUSvDBW4RfSKy1yK6GTWzq8SyqTfy4UxEHnU86qu1VcDR
40491	payment	2232	2232	2324	1	1	0	9000000000	1000000	\N	E4Ycxz4E4dR5cxtnk1Qj7tkYy116G3xif23dhXPbQHhsuLv514mMv	Ckpa1GhthVXi8xNYFUyQAkSbhx5b1wUb1KvvP6VbPuqLzY7HFGyc1
40470	payment	2133	2133	1874	1	1	5273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsfNWZT8yXmUQt33WPPPmgmYV5XNxm1rZVToJiXyZ4KNot2ej
40480	payment	1397	1397	1678	1	1	15316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjZ2MKabCG7TksqBzazZivKnzsBxqPfpHZn4kFYLie7V3S9y5
40481	payment	1397	1397	1678	1	1	15317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYSn2SpoXj763csZ8FeCgRXS5m8FA6en5bBsnvuuDaoLdNf3Z
40482	payment	2134	2134	1874	1	1	5713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEdHhbZcNn6goycUSwLmCxaYdpkrzchzViskdPwqbkXfXuc2
40483	payment	2134	2134	1874	1	1	5714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvame7EspN791x1iSahX2X74eC9Px5Lh8GYy8F2ZwqmMbzxe1U
40484	payment	2133	2133	1874	1	1	5277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSP3DybbphE9vJsutJNq6exhUGe6cs9xzaXRW6Np3jSHcfuV1d
40485	payment	2133	2133	1874	1	1	5278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqpmcCwuArVxPBtPwE84TGz9b19o71Hi22sfZt2t3yp7nHy1E
40493	payment	2134	2134	1874	1	1	5717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXdePfQ1sW6UmzmHGQFnE9iiejt33ShHEtyRNHs7QKheVJmNh
40495	payment	1397	1397	1678	1	1	15320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTjGK3jb7pH2rV9fqX3YEWC6NMzcBcNDUGjw3RKNMpMgMXiXx
40496	payment	2134	2134	1874	1	1	5718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR7d6YgvhNo3D448hPJrzYZYyYf2SgY7g2nhUWPqtTsrpiUWS
40497	payment	2133	2133	1874	1	1	5282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoW5ExNBhs3vCs9kwn4pwvS4PdQrVD7CWEQ1zHsqYd8wJn2H9
40529	payment	1397	1397	1678	1	1	15331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcBnXhAAmfd67UqvQWJNjVHuVScJxicqK7rgNEwwyDy8nGHCf
40530	payment	2134	2134	1874	1	1	5729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd6gcUJrY82sWvzEwRU4vL9JxkTUPtYnXHNZpWXRizTPATkge3
40531	payment	2133	2133	1874	1	1	5293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCHB7yKGdu6qQx1ACyguVgbUwJg1icvi5joMmuFS7oErgKmck
40534	payment	2133	2133	1874	1	1	5294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgGWnr3iTPcoUfi8UjqV6y9ckwEGLwMdG9EHJzWpGkYmS6mjc
40541	payment	1397	1397	1678	1	1	15335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tYY1SgLM6GUuKkhukBfwrnDra7qDJgqepsxVxFaxgoj1dPEf
40542	payment	2134	2134	1874	1	1	5733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLdL1gpnJwcCXLLwbv71kCfBwRc9y1GMPG5mSLDb4DcFiigan
40543	payment	2133	2133	1874	1	1	5297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTmyhZGXSqyjsvep4eazDLt5LYG5UDzasU4hsw4Ai6YKyehB6
40556	payment	1397	1397	1678	1	1	15340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjScf39szeYdGzA3RurjmbK6RnseZBajWwzTGJirXjzPVaCdP
40557	payment	2133	2133	1874	1	1	5302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkN9EgshZxMGSAM9MhDZR6F6XLzFfaGEfSUsDMxENahVeuYgC
40558	payment	2134	2134	1874	1	1	5738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJR8bR4jHUKeBEZqTr1ozrAKsDZ86onoLhkjq8ckpXXS7UWmra
40567	payment	1397	1397	1678	1	1	15344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4empdQpoMfA2N7M7EM5sDUrveG4yJboCB3yqdu5aJEbWVURfN
40568	payment	2134	2134	1874	1	1	5741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtbBkX3QmwSFG7Yt8iPzXXJxwvNmw9jiDcwKtEZU2rDMvqKCp
40569	payment	2133	2133	1874	1	1	5306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGC3sFGhjfnwLrTUJbo1ksVmAUBLzJ3N3SzRrjSFd2xMc78sBL
40589	payment	1397	1397	1678	1	1	15351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRPMtXps8874udGDins8k6mQ1AwB69BUocmRdxEjbHa9a75mx
40590	payment	2133	2133	1874	1	1	5313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoArawhiSxy7f9MEVvirRxowoeapCDVGy9xE1zv3US5Rc7MhV6
40591	payment	2134	2134	1874	1	1	5748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLH564CdE54jUzdvXJRL2XtWzzipZatTk69W1dZMn25acAuwPY
40592	payment	1397	1397	1678	1	1	15352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxz5xZurnykaUWNQjqntGMCfo2LSm3rMG9qdgZwf36GVKsLy5
40593	payment	2133	2133	1874	1	1	5314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLTPMVXJEcE2jVffBjRzzPFWTc34dTGcUtdKcffmjjFLd3nPa
40594	payment	2134	2134	1874	1	1	5749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGamEZCHTm9eki1EswgR6C28qHfQ3u3qEyS6VEsRwGtiqX4cff
40614	payment	2134	2134	1874	1	1	5755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX6DE85k2sJECNZKjUvLfHpFhavpL3UXzSFo8qeC3AMJn4Yka
40615	payment	2134	2134	1874	1	1	5756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3VfvxxVdSkRfNuoMdk2cedpC9T6736iPmYXMfnkqLCjgUZj4
40616	payment	2134	2134	1874	1	1	5757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUJDvhZfJ9ZHZRwJRjrF4S21L7rpDjLC7eNBzzKRz2J1EmH5S
40623	payment	1397	1397	1678	1	1	15362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t4Gyru9U659TK5WGKQRSkURaCoM8Jw3ZUZuhFwAiDUGdPteM
40624	payment	2133	2133	1874	1	1	5324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWm9rDCUzUmMZtkMMjQ3KWvEzLct6CU9yJHJdPfWY7vGpkW9Zo
40625	payment	2134	2134	1874	1	1	5760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BzfmxPsHhMaYwZbWsNhqHhMwCLdj6nYr4oCVBXWAvjS1e4Xf
40638	payment	1397	1397	1678	1	1	15367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7byt1ZLakQKYCExhAbZzUadzb9pWt1W7bB8TExke2iQ24BCc
40639	payment	2134	2134	1874	1	1	5765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbNoFGW7D9vrJNqgJp5nJ7dUFurdqDgr5aZtsgSEeSxQ89dGa
40492	payment	2134	2134	1874	1	1	5716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mgziCTq5Toy6Hvde6xZTHG3XRpz87HtZh4NZnzKdRZDT39Kr
40523	payment	1397	1397	1678	1	1	15329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4m79dH4ZbUHkm8iTBfpgox4JoUK2jrpXU6hRZ2YuBmchkQ8W
40524	payment	1397	1397	1678	1	1	15330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3HED6pwq4GNTa5pLPzCrEThWvBnoreQNjfrZrxz5kA4UAMuD
40525	payment	2133	2133	1874	1	1	5291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6qWfksvhgskoDgBYpLfXvBdhmETCpjWN6T4wUmrhrSiihAyg
40526	payment	2134	2134	1874	1	1	5727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CmKora747hTyBH3gHQdBRf4eVioVKEddECxkBw99iCSMQWe5
40527	payment	2134	2134	1874	1	1	5728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJV8W71WctMH5fNgrnjEqocwWnX5xWxGQE5WWaDjArmWrmpoa
40528	payment	2133	2133	1874	1	1	5292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmT4pzHPhCWtBeVw2CXuSDKWHUWoZHmEGAnBEio9HMEX3qfmrm
40538	payment	1397	1397	1678	1	1	15334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQcduebb41ocpkA228uqZfAMtzpQjvGHeYUjN4XEHXgU6ZD28
40539	payment	2134	2134	1874	1	1	5732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXcSSdAJv1qbpuSPnfLRMG113dCW4vheBocMvA35QZpWqbEBB
40540	payment	2133	2133	1874	1	1	5296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkseQeonBQDWHtQ9ov78qGaKva1mrvkwv7hc33CwWtsKR1Hg5y
40570	payment	1397	1397	1678	1	1	15345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vSjPpevXQT1fcjhMLKhog8BAg1zoabLuTNbmMwvpVWEsGEsc
40571	payment	1397	1397	1678	1	1	15346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52tSy7tRotp3nGoHMwyQ1XX4m21poV1SuF4oAo37MzQnmCQDj
40572	payment	2134	2134	1874	1	1	5742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLJaSpvKA3QFXi9NdJFaomfEiEK6rAyA8nx9MAU46u2zJcxKL
40573	payment	2133	2133	1874	1	1	5307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiByvM1VfpFkTB9bZJPE9tCeQYva9dUxGAD759biwzqn2ztbi8
40574	payment	2133	2133	1874	1	1	5308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYToAZ9mxYfPLQhXF1igZY65moNN2AYf7YY1E1yHkc14ftmgdLu
40575	payment	2134	2134	1874	1	1	5743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y5NL8wrgW5zmEG5WMJshMLZ3TbNjs1vBAP4XDeQnkMACdEuo
40576	payment	1397	1397	1678	1	1	15347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpBjSHTfZaPvKkbDwkugHifPUMZtQMByUTqbyXD1QJ2FnTKVP
40577	payment	1397	1397	1678	1	1	15348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdG4qbfMJyN4CaS5Cz9LRHvEyyMWiCmqcfLgdAwbxBT9ptzCh
40578	payment	1397	1397	1678	1	1	15349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6Jf4UmcAkpnDy5t2FDgFfqoqycS8DZDkNxUcqRqWWirLVV8L
40579	payment	2134	2134	1874	1	1	5744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9i1ubYDyTvC9JATaiWqtpkjF7MGFXMX13bQyP19pY6YrxFMR
40580	payment	2133	2133	1874	1	1	5309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJaT1uRV3HgeJ5LRTv1t51h9KL1Txdqdmr7rBd41unTHfZQemE
40581	payment	2133	2133	1874	1	1	5310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuFm5NWJVKAThGgHiAWZgnEUCsTKULdAPM22uyjhrLyuVQzUH
40582	payment	2133	2133	1874	1	1	5311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRejgorFuQPUGXf77MaTh5S5rogjEHbDc23waP7wGNVtMAy6N
40583	payment	1624	1624	1764	1	1	1	721000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtNcBW4Zn7HM4DYqpWgcBAn6Wx2im5rrNqsMGr7gddtdn6r22
40584	payment	2134	2134	1874	1	1	5745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9gLfBZoLoGDkd1qVjJrwv7f4Z2pwzerLSRmfgkRcgyo7wQqi
40585	payment	2134	2134	1874	1	1	5746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9D5qz9pYrpYgeUKadndTNi6CCDwCrTqGa3xHi2TSGEj7fmjPf
40598	payment	1397	1397	1678	1	1	15354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2teXQmSjMSyKtFNh2gGYKrrdwtJcBiUJrzP26aDo2c8sAWrF
40599	payment	2134	2134	1874	1	1	5751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzebBz298LBd2MctBR2kfZPVfJQ6DSj3UNVL9Vrg7TqrZUGMY
40600	payment	2133	2133	1874	1	1	5316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSo9wjKeCCmEwmnQ2RyoBnB5TVrEeKzmqfaVmB32Yyb7oMuGvE
40629	payment	1397	1397	1678	1	1	15364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMF3LxYyaG8ECw59yUT9YKfHnC7QFFYwWdAs7u5Ax97qhVzPw
40630	payment	1397	1397	1678	1	1	15365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jJQr7xHN9r8SomrY22LoFxSur5PuFGWoNpbEvYyieGz6Gekv
40631	payment	2134	2134	1874	1	1	5762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9J9RjdFYhzqTTy33wdFq9WFPzyeceMX42HAsEJRCur57Q9nJN
40632	payment	2134	2134	1874	1	1	5763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dgwqTPec2PSdjZ5xB3z9d9Rfr5ni9RPwHEoJzCzh96cFefD6
40633	payment	2133	2133	1874	1	1	5326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC96Hp1ea4yiAKmSCbh5hmP4ehwFVm3Jd3nBgjP6PvfLFTpxe
40634	payment	2133	2133	1874	1	1	5327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLtTSN6BhDDvt1Qvpo9fGpM33gx3s8PwtNppjc17NKH2YAjiv
40677	payment	1397	1397	1678	1	1	15379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kEfWGirrgqPKoriqpRV7bf8EDJnNdVVjDNbbVR5V3MRg66ki
40678	payment	2133	2133	1874	1	1	5341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPhvYYRvWuYVfH7TocaKxZUXFxvtKGHPv7PvSKyKXe1EjddM1
40691	payment	1397	1397	1678	1	1	15384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpdYe9sQzRoQKujZsMJGw2sQGYEee8yUnf39Nzo8P6hyrbX4M
40518	payment	2133	2133	1874	1	1	5287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfLT8cN4ypEZC77HoaaQ8FiU3x4Q7HJck65pRP86tTgcWzVGQ
40519	payment	2133	2133	1874	1	1	5288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxxmNuYy9Z4naGkPBt42RELWfDzDKY1xqU8ERaaEtQEmsGZ8n
40520	payment	2134	2134	1874	1	1	5726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMuGoh5UbnuqPMuJvAhTUS9fWq2PgJ3qFmqiyp29Udjuhujaw
40521	payment	2133	2133	1874	1	1	5289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8McSzzLc3v8Q8xEepxrjqNmJ6P6fmktz6xyppnKiTik9XzqWs
40522	payment	2133	2133	1874	1	1	5290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQC8acsVg6iZHUKjtqnCuX2sEYpSrnkZCWESaUNgsZcGWMYef1
40532	payment	1397	1397	1678	1	1	15332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfYpj1JqJimEUY8knNKjNSpaeWKMwpgtPQiBcwkoq6LhpCBy2
40533	payment	2134	2134	1874	1	1	5730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa132i59w7Q6vru7W4HLCHvD7XiHR5RX3HJn7VjG4efNsN76jDE
40544	payment	1397	1397	1678	1	1	15336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rXJCyk7ZHpETAZvimREdPfJHQKgQPcTZC657Hn2FKxfJV1C9
40545	payment	2134	2134	1874	1	1	5734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyXLERiWjpCYGZ9s1qubGQYNNmJ284gPZhzdPjJsoxjmyuuUW
40546	payment	2133	2133	1874	1	1	5298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnL9YLhBhr7TXfDuVTTpzgaLTc2HDyAsUP5E5KTYfJCZdhGzh
40547	payment	1397	1397	1678	1	1	15337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8PV77XWJ2qNytoxN2sZ1afMT25PdXpC9aE42ryfXS3fGDxra
40548	payment	1397	1397	1678	1	1	15338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Aa2f4zZYwHZscAZqp41VmQsfZYLWS97TML3W1gtV2gHXNRpD
40549	payment	1397	1397	1678	1	1	15339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDD7UQ914ovrSADYW4ErLsrHAkAD3coNhNNEZMbVM9ERYLG2WE
40550	payment	2134	2134	1874	1	1	5735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDae5vLNx7KTN76F2CbygyzQzEDwRMkst646gciuRRRr4FRTK
40551	payment	2134	2134	1874	1	1	5736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pKqovZAg8F9cAHtrkmvLiBz81vwHMaVc7huidp9ox59iLc3L
40552	payment	2134	2134	1874	1	1	5737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJijKqGdJVKEgTT8a1cg5sXiWLdUc81K7tELR4J3JMP7esrRYj
40565	payment	1397	1397	1678	1	1	15343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPZuQgP6pHKyjy6hq9J8AAsS7xe4HFKYEqc2CRW5UWrfRgtF6
40566	payment	2133	2133	1874	1	1	5305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqGRSvYQfxSe4hpSdYNkfxxvhvhRK5dibAw4hdSUND4L18Ffb
40608	payment	1397	1397	1678	1	1	15357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9EJ5h9DVhBW21nL8MGKjNnEUdgQuNwDgmgSg6BsZ9k6JSTUb
40609	payment	1397	1397	1678	1	1	15358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tjP6BT7WdSozmobXFYiwMxDr9kH63gpyWRXAwX7FYTWdFmz2
40610	payment	1397	1397	1678	1	1	15359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5JJ1v8sTwat95np3iary3r9v1dTnar1wLQAu8uXWWc4G3tJ1
40611	payment	2133	2133	1874	1	1	5319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRz2zBY2rJwrWj4FX6Kma8KTtvSCafBbGWMpQzkJxEXRLsctD
40612	payment	2133	2133	1874	1	1	5320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wJ91nZtVYH1xCWgV1x2ASYCUc1jKsCTVWCGVqeWYFE2byQw7
40613	payment	2133	2133	1874	1	1	5321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnpo2958BMYSLtiLWUErxEti1eZhzhr9jmRruoEjdt457renR
40626	payment	1397	1397	1678	1	1	15363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbK8j5zbyoGH19Gpzhgh6Pybw2c1RTbr97rvbvQr5pNowMRvY
40627	payment	2133	2133	1874	1	1	5325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLxtjhU59hfzefC47EtnEyMiCaHwASxPPStNo6uYmybkmL4gM
40628	payment	2134	2134	1874	1	1	5761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1AmeiC42nkVMNPPUAHcrUhAdYuetxSVtRLuUotHVKJ3Rwzyc
40635	payment	1397	1397	1678	1	1	15366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ABnzciSJjH3Eyx2fui6iNHxwBVojLuGPqE5JUXAjCUyere8p
40636	payment	2133	2133	1874	1	1	5328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeVgGrL2s5RttvDa8EBsMpr1NmhavD1fY5BrdTzyS4X91m3GH
40637	payment	2134	2134	1874	1	1	5764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABKna1CQVvQnLeRjHD7m5pK4m1JWhBLW3enJgjb9eX2XybvdM
40647	payment	1397	1397	1678	1	1	15370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQ32virebomyjNADSSpZyHiq2cDBJHAWwBivkSLGK5iUD8kVo
40648	payment	2133	2133	1874	1	1	5332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzkdnLAbUgD6zv6tcykpRcEmvPUNUbhH1fs7vWgZikshdB6by
40649	payment	2134	2134	1874	1	1	5768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHxcVNNzmezX3mWUN3RCXYxpDKnGVWxbkSN64vWMcCuVvPCfi
40659	payment	1397	1397	1678	1	1	15374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGygTQa5MZnBMR1AuxC3JKTLqCnjuBvdCMvPzmDFdx3F9hxKUW
40660	payment	2134	2134	1874	1	1	5772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2vVBtzDq4qkpQGhezouxXBDcKzv3VdALBdcAjRUAYeUmgWfz
40661	payment	2133	2133	1874	1	1	5336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh3opM4gKUVH5Hr1WFXxPeLfEN8Lm6Nc4PwP1TDa2ePTkM6wZ
40671	payment	1397	1397	1678	1	1	15378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9A4XNXC9PRBzcoKmRPJfpN4EHGNhHcFuMHNyD65CKLWtQ3pc
40672	payment	2134	2134	1874	1	1	5776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdg5tBYn8j8vRj3JDNdK2wHSn8qLs8NQ1W4xJse8z6xfkZxoW5
40564	payment	2133	2133	1874	1	1	5304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCDJZpYeo1QjzJu3NsTtMd3mK9zTPVYotaXusS6xinb15xHBT
40586	payment	1397	1397	1678	1	1	15350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRtkznEsqyUm8Lp3f4CrVLzsFEsAue7psUTSWw7iAyqGLPLXn
40587	payment	2134	2134	1874	1	1	5747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggasKZdZpGMYDu1p3JeUYCfP4vYAGtSNHmWjQo8de3yxE1zBY
40588	payment	2133	2133	1874	1	1	5312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqjUR76sk9agBEWhBuENbdE5Fy7sUosjvELNiB9aYWLHYgnxs
40595	payment	1397	1397	1678	1	1	15353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiSRaHsCekPGVvsBFQtgfw5CePSavZQdeMyh3Vx1KV64vTHQ5
40596	payment	2133	2133	1874	1	1	5315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXMGbeHnBYds7b8hiJXyS67DFLUdBxnynRiBH3w3FSbpeXNMc
40597	payment	2134	2134	1874	1	1	5750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGLWoDGCuzCC5LnJtJExHQmPLgLTrwEmDoK6VPKQwkXXSX9CHd
40601	payment	1397	1397	1678	1	1	15355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJeujMikBV5QquXYpyzypPsA8GwuLPVakZTYdHN6zz2rwnEGm
40602	payment	1397	1397	1678	1	1	15356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYWNZrLxQRYb21gpY3nZqhpZTzEZ5xZp3yG9yFv2GdzNpqUGH
40603	payment	2134	2134	1874	1	1	5752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJZ8dApMY7ydyVuUzXAWTFUCxvf69PNwheF1JSuP758wkrrfe
40604	payment	2133	2133	1874	1	1	5317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwVDEjvbXrfm929igRa8CNNWmxtBX2Yx2kBAamM4sjvP8CQK1
40605	payment	2133	2133	1874	1	1	5318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXW96BDiF7s6MFoRGZFNR9Yo2AHtyKvPG7tADaF5TWX7EAtqp2
40606	payment	2134	2134	1874	1	1	5753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFURUopdDE1Xt4E4JQq5S7NBNcGGpBJtTHiEBAuAUHBVwqdZdy
40607	payment	2134	2134	1874	1	1	5754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrQPikGvZGNXAXUg4gc6tsKEtwsv1kwW6EEuxYh6DpMYNQyCP
40617	payment	1397	1397	1678	1	1	15360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhYkFoMT55kFhtcU9zuPhuD62UD5zwvARiTihWA2FQE7xRCor
40618	payment	2134	2134	1874	1	1	5758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxUAAGknCSeaawYG6equW8tLwaABxBk66aDJpJnaD8pngRY9b
40619	payment	2133	2133	1874	1	1	5322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4Mu3QDnPydP4MFL64hVokwd8rsuYDycsEf7V4WzyqXQN7EUd
40620	payment	1397	1397	1678	1	1	15361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdXjs8ApxdVC3aDV2Qap4epMqQ5x6pHadtustrito8sE3oZSN
40621	payment	2134	2134	1874	1	1	5759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatLAwW3VSskdEpXPJE1mPhMGCt3BNwPae5uHBUpGcAA9S7Ysn
40622	payment	2133	2133	1874	1	1	5323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5gg1KWwBntiRJqDnPAUWtrX3eEqw7QPxt8y7kAKN2ZEbZiAv
40641	payment	1397	1397	1678	1	1	15368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaEcxCSPLMmNWxDPgCHQTK1QPjQQzV4rFDGbavcMDPsXF5C49
40642	payment	1397	1397	1678	1	1	15369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uBRWK8EzisT3K4p37hxWPLTbLkN2pYwV2bkJkVXJjewcfDkR
40643	payment	2133	2133	1874	1	1	5330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxRdyPtMdGMsXGPQ9higXTE9Ah123hDgNS2qCMMYYKJaBnduF
40644	payment	2133	2133	1874	1	1	5331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4cYc218AmvqNy3FKu7oqrymeg7G3r6dY4GFT4tkoPNkx4H23
40645	payment	2134	2134	1874	1	1	5766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXUqT4BPg2xtmJp6Yhc5vddM5PoHSHF2Nd1oaeApbPZqjeE24
40646	payment	2134	2134	1874	1	1	5767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFbv3Ap2LuVJCbit4uFYfeL74ZKsNaoyKCunSpAXkEwx4vUod
40650	payment	1397	1397	1678	1	1	15371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNBkXTzcfjbcCSMchGFNeyeBSVTZadnTsN86mA1Y5wfyagkZ5
40651	payment	1397	1397	1678	1	1	15372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkTm4bHpinQedPcToKtW5EfEkxYnPVkBk8H3iBxS3i6i8Vx9M
40652	payment	1397	1397	1678	1	1	15373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc18DE3j37oswiMLTpbbN2hkx2qSnosT4BgvVU58jK1G99QEP2
40653	payment	2133	2133	1874	1	1	5333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHZi28WC2Xr2NuKx3vFeJwEwLx8UxoRGJVXDmTQ45dYmXT3st
40654	payment	2133	2133	1874	1	1	5334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4rwy9GkWAFeaafNezZbMUpJSxebRzPsaRuCKELwcTGQoJj34
40655	payment	2134	2134	1874	1	1	5769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY1KqoP4cqrzJpQ5jeZWtZTAVehu5iQoo6bGvANoChSshoFsm
40656	payment	2134	2134	1874	1	1	5770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpATTMW317BBMnwMour85ZUQxkyBSWKFfAo1crYtuwDs1i9ThY
40657	payment	2134	2134	1874	1	1	5771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNcnt7EmnxB3gmzzJTgLBmKBL8cKVxRntGvVb8n2re9e8Spw4
40658	payment	2133	2133	1874	1	1	5335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqiQLZsrhcdXF2CFV4Vy2yJoTdrmNzp9UbWJEhqgo8naDWzynz
40665	payment	1397	1397	1678	1	1	15376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRWoQ3E7gxUYvXua2CjBqadAySi6Lca1vMsdJczsxGiZH99hf
40666	payment	1397	1397	1678	1	1	15377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bgJLoEAbVqU9nFgi7mFem5AWF4fV43pVTNhfHjqD1A54k6kx
40667	payment	2133	2133	1874	1	1	5338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhTvT3UVZXtSttf8kS99SiJUwEn7GEeth8o6H78intE5nUB1p
40640	payment	2133	2133	1874	1	1	5329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRipKuzcwvF97RF6HB1GsQ8dEXUTcs9dWj5RXgDo4jnDx75YuB
40662	payment	1397	1397	1678	1	1	15375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yN164SbAprfDxJNc72UJST4vpdqf3c5DLjkAw8dCbXQhTZ3Y
40663	payment	2134	2134	1874	1	1	5773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwmnfj3h4vN6L7HR9VxQf1TX5Z9bXEhMCR3ZwXPhN3iQd6eEB
40664	payment	2133	2133	1874	1	1	5337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aHvLdq3baDFVh9J2SzfhZkMpAg7eDHqryPjcsVFLAiqhfTk5
40700	payment	1397	1397	1678	1	1	15387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVEHc8ZRwxfyttNegGwHjp5pr6LSi91w6FEGFnMKsCnSAGFN9
40701	payment	2133	2133	1874	1	1	5349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvKBh7cregn9UCGXH7Y5UCbKBnzQyPwmHG324DYrfRRGHA6nC
40702	payment	2134	2134	1874	1	1	5784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiHQdXusetYmjDawn1cem2Ujp7WeXzZdY9e77GkVziLNwgyhJ
40721	payment	1397	1397	1678	1	1	15394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupgZ7YiwX4LR2QWgRrraZPcLzB8epj1cwtRZ6rGBrigqdKyYs
40722	payment	2134	2134	1874	1	1	5791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDEeHaUEr7rjyZRBGNXguVAhm3Mu3j1iXY7HWA59YGpKYCEjd
40723	payment	2133	2133	1874	1	1	5356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZLj4MMW3UysULgz6tnGwYGk2m7JyNAb7imNeZpVdfrGH9B91
40724	payment	1397	1397	1678	1	1	15395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfWogvZyhVo9ioZscwyL59u1UCyaexvmQ2HxyfveHHimxTUig
40725	payment	2134	2134	1874	1	1	5792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcED8zzZ95Moo7A2M6oAvqnyJ1KYkanqpwCgWLpH2PRUyWRtNq
40726	payment	2133	2133	1874	1	1	5357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zyETMGxddzTAKGmFxuW4KmEKTwJisebMjayML3n3DKLM1YRA
40771	payment	1397	1397	1678	1	1	15410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5wcTj7A2CZs1PnXbJNZYgeCiUZRdcJTwV5DgGLRNM3R9t8xh
40772	payment	2133	2133	1874	1	1	5372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BcFMDNYdbSC4nu7EuwzxM9rYsJj7DNocydfX5r4qEPkLL5Qq
40773	payment	2134	2134	1874	1	1	5806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7yQZq47uHNa8nK2yQJFavAhsLmvQ4p5t3Au2wkkKG4z9Z6Dp
40774	payment	1397	1397	1678	1	1	15411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqqY5LeX3aq6WAmBozJ5eeXHbVGh3auduUyVEcwFFNUttcLL7
40775	payment	1397	1397	1678	1	1	15412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBY1391SYsXaZY6v9DHHkQUTGAKX3T24nTPVL9bYHuVYGK5Vfu
40776	payment	2133	2133	1874	1	1	5373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbSf3aHLuXTGgP1qZSzaycJaRi1GC5Va8Uo2yavf34mXvK112
40777	payment	2134	2134	1874	1	1	5807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHhuyHcGNiPrrRLn5jaAqv6694Ve5CUemLPRrBpfVR2HimNYp
40778	payment	2134	2134	1874	1	1	5808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQpiViiMNy3weAio9s1FbqdmdP4gBDZgfuGkUVkuhbcpmkQSN
40779	payment	2133	2133	1874	1	1	5374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE76X8p4zJw73cLWHn98bSVg43R35bYKUTRrKfxjT8DM5VcPHB
40807	payment	1397	1397	1678	1	1	15422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhsZ15NSDcSrRrnrMAmxRooxZYt8JRNKtdf8yRpDMKqC6rGJU
40808	payment	1397	1397	1678	1	1	15423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7hQPBG7cuGcoDpvoe4ZET4gaNYFuk9zHEm62i2FyQxZkd6o9
40809	payment	2133	2133	1874	1	1	5384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Wq8bq2A7a9fNSkCRPQ4q4jwSBx1aTCxABohYxpMQV4ZYbgjM
40810	payment	2133	2133	1874	1	1	5385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRETyHxui77P6K3KJw9tW1gzLX9jogXMTcRg4AUC5ecaKmeHe
40811	payment	2134	2134	1874	1	1	5817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQKTKVSjo88WRBUbKt6EJk4WsBMgbCQ4h1b6yg1zHgkY9APuy
40812	payment	2134	2134	1874	1	1	5818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYLFSMPonP6cRk8t6rw8K8vMRUPkhdwH1mzm3VHPURFL4L11Q
40813	payment	2134	2134	1874	1	1	5819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxtaLUqCNFfy8ixhwCfvNaWaiEXqgano8qBBoERHtPj72ztwT5
40668	payment	2133	2133	1874	1	1	5339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfxxxVKRQiBYD7mLz4Ne8Zk516T1Mw6B9pePisJDthsaUEXec
40669	payment	2134	2134	1874	1	1	5774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLe4dYTmvhw6gVzXdthNpRnXy81YwAATKt2ue5yBpdYsLAmj3e
40670	payment	2134	2134	1874	1	1	5775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1g8sZRXQPk8edh3CGvNFUgn9PRmPLqXQcAyFEm1PADKV8Y5tP
40679	payment	1397	1397	1678	1	1	15380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBK1njvz9EpHaFUPhMQvz5CtcrK1xERpAJqmwmPV3JoDSMqBPi
40680	payment	2133	2133	1874	1	1	5342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3te38qD9WA9iDm3iq7YQuW6aB7hFyXhC9yti5D8EEuGw9PXT
40681	payment	2134	2134	1874	1	1	5778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahL6v9aWKJWhdLYsRuAUwuws5oXYDdBV4koF26ciAVvWdn9oW
40682	payment	1397	1397	1678	1	1	15381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GKzwDkH8QWdf2d7t9pf34uQN5jctVpirTFFoYWq8GoSgZaUq
40683	payment	2133	2133	1874	1	1	5343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9im1ciuxymf3MrTWmimqNqCK9tV3WgQDpopAjvGJyRXK5dar
40694	payment	1397	1397	1678	1	1	15385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1E2Df735bCVD2iZ2CdcTFnuSzNhAUhiBX8sKt5uCBiiRrpaD
40695	payment	2133	2133	1874	1	1	5347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmaaS2PYVS8buSmW6ahBq39y5VSCuLVdEMBpVEwRsCdtKcSix
40696	payment	2134	2134	1874	1	1	5782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUXmWBLcCxg4nUMsqsqNs9noNVnK7zgXQhty9GjrtnobzhV8K
40727	payment	1397	1397	1678	1	1	15396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oSx8tgwdneZa1qK8en4QfxBLbbmk6vUQEDrVndqMWvLs8S6r
40728	payment	1397	1397	1678	1	1	15397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoR5FH3nA9qLadPTALcsaC1FGCCFgHPhYpfPEJu9pVL1W3ZXo
40729	payment	2134	2134	1874	1	1	5793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuam8mf66ot4QcUzsHbrCAwu6M3xQFauKU45YKe5BF6GCjm84o
40730	payment	2133	2133	1874	1	1	5358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybvwB1HRfU8CjURoUnfy1TQHYDqpAbaxHbU7AQ668K5vbZpic
40731	payment	2133	2133	1874	1	1	5359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYtZpDXLDwkiH1S2kuGtVan9LorRdWmsTNb8UuWWQ1d8E7Lgx
40732	payment	2134	2134	1874	1	1	5794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqcv7a2C8XP3TP64KZ6VsujGCwWqzKp9nQUvEUhXPeYbwgega
40739	payment	1397	1397	1678	1	1	15400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdF7RHyyQca1CYy8STUBfeKWDWPnAQ4rM1P2F17Zs1Z7bEqpz
40740	payment	2134	2134	1874	1	1	5797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMCmsd2vHpXaFUWcxMS5FGk9uif9TbK63EcP3M6wWc2cdD6HU
40741	payment	2133	2133	1874	1	1	5362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJ3QpUCNBRcdDjx2DoZZJTWJxTwd51XUGb48WGAxSmE7PXzSi
40742	payment	1397	1397	1678	1	1	15401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PaS7MrnufmXbzLvUwrRuT5RH6dz2nbKGgqVx8qY1WfCmW5qx
40743	payment	2134	2134	1874	1	1	5798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64FwbSzuFzDb4fF3ShDbgx8M1G3ZcXz1otjhJFQWL4fyW6ohC
40744	payment	610	610	2325	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ57hDRGne2RPLd7e7CqwDiU2ijANSDKwj3YkpWwFtfuHzfd5y
40766	payment	1397	1397	1678	1	1	15408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoUgdjJNwvfiDnxjqeAfTveesLjYz69fmChqatd5bxp4fQ2KN
40767	payment	2133	2133	1874	1	1	5370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzwF6ohvuaSq7MYHJd5D7DG9vMeyQ8C3BHp9Q2FkNtSBDYArC
40826	payment	1397	1397	1678	1	1	15428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAEcZYQQTM96PJkP6WJkwgTCeBDZeUqdYvjAVYocYpkvJGf5g
40827	payment	2134	2134	1874	1	1	5824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6aFUuJ2ZGdsrB4BUjtURcvgc359bg1YT8QHb8hKhgDXh6GXX
40828	payment	2133	2133	1874	1	1	5390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXQVgKnyWuFub7yF95rff88YqFAae1iwars6whDtKD4pcudvb
40673	payment	2133	2133	1874	1	1	5340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrARjj5BQPP8ffVVZRkAEzfMo7LVu6HCHwjuUWihixHCjCMgBW
40674	delegation	1769	1769	1407	1	1	60	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1x7pNjRxzCpCsLA8YsyADQFRxWJqk6cSpBBoLhAX8Sw62MFy
40675	payment	1769	1769	1769	1	1	61	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p7PcTdLMome2oNiZHxN9y7ceQ586wxU71TosrkLRmC4f3Aqz
40676	payment	2134	2134	1874	1	1	5777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaq4pkhgzmQ2reFakDjfYy6FXERmKQ8JKqVu1yiMuwrJhg6iz
40684	payment	1397	1397	1678	1	1	15382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZNLacAypotmW5K8ZmsJ7LjCpPQzjqSm29AfJR1DNScQrCS6L
40685	payment	2134	2134	1874	1	1	5779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHrqVo4WsWuaHJuR2R1eqCMqQzvQonLHk13MUFoB7ziJHYmVX
40686	delegation	1769	1769	44	1	1	62	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsaxCx9SZFWywsxSPFUcsvgcRxiMZK7mWHuLGd6A1WQqr8ng5s
40687	payment	2133	2133	1874	1	1	5344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9REGXqiFKGNDuTcvisaBJFJvmPu8f95NJdsuVWYwLyPQh1qt
40688	payment	1397	1397	1678	1	1	15383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbHP9YaMAWaRUqcNHdVuPz18AP4wfAmgFDPVVotY7wtf8678G
40689	payment	2133	2133	1874	1	1	5345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW2VQW7nBGHh3pEA6Vv9QugCtdTcbmiFqGvrUy9svcgq7FR7L
40690	payment	2134	2134	1874	1	1	5780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vUCKt3EnYgf9Kqy4n317RpaB31iZsVrEZLvEeWcn2HJGGPCy
40697	payment	1397	1397	1678	1	1	15386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcarWN9Abwu1G3DznqrCsFuAnbU7cjCbwqXz6mqpFTUbq6dkK
40698	payment	2134	2134	1874	1	1	5783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZf3gyDqkxnTRREz9vP1GG5RggFgNRDdxFcWH8yhNx9iRS53DE
40699	payment	2133	2133	1874	1	1	5348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GLgWmaXX7tmCXYe68vDQXxMsvqFE1UT7GRcvNr67cBbLVdk2
40709	payment	1397	1397	1678	1	1	15390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SDUDedJ8yxJTutHRJvtkcQjXzWKYuQgcYcgBCAUNzuDbZ3YZ
40710	payment	2133	2133	1874	1	1	5352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEoe6bjK4XQjrtquAZG9pcs77Uuv4udjwxyfPsGnxqRNLvfQu
40711	payment	2134	2134	1874	1	1	5787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPY91y7cJiMMPngVH9GsMjW4VLXmzAn654nJYrwPceG8gNeRC
40712	payment	1397	1397	1678	1	1	15391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9egxMzcVdCqBZdPHTU8tWyeDEjKQq5NpBsTXZH7LArqGRbuP
40713	payment	2134	2134	1874	1	1	5788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHZRQKjcXFdJ6GqqQi7Mf3WJLVJYd9ESGNkT48WWYBsLmgdmE
40714	payment	2133	2133	1874	1	1	5353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oBVLpQQezv9XMv9nf1u9j6w5Miip6RoYKSz4GKD7ShiweA5a
40733	payment	1397	1397	1678	1	1	15398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGdgBgbvDVsSafzTan8tsrmSt43gbJTt7q7Bb9Twfh7oWoTjX
40734	payment	1397	1397	1678	1	1	15399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtfdsvpgDYwAYnPS8VKcZ8dL6n8by263WLRNxrqRNBP8ArCUf
40735	payment	2134	2134	1874	1	1	5795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC49q3tJKq1QoRsfhqmppXZnxC9mNPucTgMmtEe6h8KL6rJPkH
40736	payment	2134	2134	1874	1	1	5796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUb9B28mcDLGzqxNcg5uYHzvbq8teruqosy8MKfNmuEGdSkfJ
40737	payment	2133	2133	1874	1	1	5360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Fqdw97KwPxKZ6ngcN543jpqk2bp2ZLh8mwwcxPtmYFQVu8NT
40738	payment	2133	2133	1874	1	1	5361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRaCjD45K2G2Y2RXmpKZFT9ZKH9NfMyS8seW1K5Vpa8xMwjDJ
40745	payment	2133	2133	1874	1	1	5363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJd6WmhwU9j8QzAXe127hbN1JzebzzcMB2sMqWTiTrZ2DVYgDU
40746	payment	1397	1397	1678	1	1	15402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjTuELaPamkXKUgrSL8JUWCYrh4GEZyTYGNn67XNwi15GDUem
40747	payment	2134	2134	1874	1	1	5799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFffPoHvK1VGw5M6R38UXXSrwRR46vjxjyCaNJAkGA4Buy1xaW
40748	payment	2133	2133	1874	1	1	5364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYVuPAAQ5Z2KrjiXbD9MJVg4MUpsf8ZqzWUvZvcwNAiWGnW7W
40749	payment	1397	1397	1678	1	1	15403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtxhj125kiP3wVBRjJit6C1Qvi8pUuxvMbUsjCwxURoCdYnvu
40750	payment	1397	1397	1678	1	1	15404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnkEMxWcEYpsfydE7rhBzJRb4KnnLharS7PwkGFu7zdHfnA3Q
40751	payment	1397	1397	1678	1	1	15405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WFuQwx8vz1DAHwAZNBcw1yiGkobhe5ezCAV5fbUS63W1EjN9
40752	payment	1397	1397	1678	1	1	15406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGoU6P2HtDJKXVBeNE5Gkw3pTEbYx39jQSLS5HSrLyfH8EbFW
40753	payment	1397	1397	1678	1	1	15407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FodLkMGDpPz2BfnjMYpxZKF9exW6uxCiV6vp61EjYwoxSRcL
40754	payment	2134	2134	1874	1	1	5800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpXAvhH9yDWjJnf8CtPVaFZimckjJ4RGy6pYwEraNwLTD5Q9t
40755	payment	610	610	1718	1	1	1	1438000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfmhohzcEh9dhqtobct4dGP1nwPdQz69Gq3w8HrU6eT1jYqSF
40756	payment	2134	2134	1874	1	1	5801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnyyKZ8afmCZyBrSLCvU3cH2nAnGhCtBrettmu6kFbjP5VR4a
40692	payment	2134	2134	1874	1	1	5781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKG4cQSkFhySrRpYEbYp3cQQH1rxBb7t5ahpD7Q5eTh3sgQNr6
40693	payment	2133	2133	1874	1	1	5346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJVx1zGBrfsTNBUxLTnAqwpvNGNEuWeBzWa7GDaS34qZkCFhb
40703	payment	1397	1397	1678	1	1	15388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbbK8NSGLs5bz2QMLPqprF1JpwNRMuABfZ6CjSYPqiB2V2h1C
40704	payment	2134	2134	1874	1	1	5785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE5iFNfjutTW2BNb42kgk7gvKjAdCFByHVXLvehda6MCujhHc
40705	payment	2133	2133	1874	1	1	5350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwZov6YV351WsXWhkYG8v5sNz8BjHPfsHF5nQjV7JfVBKv2Z4
40706	payment	1397	1397	1678	1	1	15389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzncu53KbpvWwfXb1LjuLLoPF8xNBdgc9YwHTZirPUNvCyHcjG
40707	payment	2133	2133	1874	1	1	5351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFoqxYZQsKxu9CGNdkDa3jQRrWHW5FoNPbV9mUzjkx287AQkJK
40708	payment	2134	2134	1874	1	1	5786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqq8GNR8sTHKZaUSgFTbL7iC8h2SA5ZSCTmjM4pvFJi8VQ41d
40715	payment	1397	1397	1678	1	1	15392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkcdZAx6c583cyTY7WTNPmK7Hfdz7aqPBkh3tdmzZL8ETSyky
40716	payment	1397	1397	1678	1	1	15393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ziy7XjHXEAgJDVUSrq9S2uiFWFvSL9n9z9XEmKHdPmAmycsw
40717	payment	2134	2134	1874	1	1	5789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVoEovEQBBu8Hgb33E1h7paMMupmR5xYvWLqGbjwDzLKHX73N
40718	payment	2134	2134	1874	1	1	5790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDkntSq948zyuKupqfqe3sg9Auexdsgp57EYkDf5C4HPNQ7FU
40719	payment	2133	2133	1874	1	1	5354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZW6NjZ4fubPhW4QKdTkMvJ7VU2qd849NADqcGk9gYac1T6JF
40720	payment	2133	2133	1874	1	1	5355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDi8LBs4GV3BVnEXAupxdfJSahHk3nor2o5JbN3SHP4XdHtKu8
40768	payment	1397	1397	1678	1	1	15409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAdT2F28DynEi2GVyqp5pUHgUx4L6i9LSqTijm9z8SGuXiexZ
40769	payment	2134	2134	1874	1	1	5805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gdjRr8MbnzVNrba7Mn3CerL4pZGGTWxCZd58nvLizv2Pa9rH
40770	payment	2133	2133	1874	1	1	5371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvsCyjzbPaUbF8769xH4jByHoUgw6LZKpXPbZhd2o31BQi4yF
40780	payment	1397	1397	1678	1	1	15413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibP91KsjN77mzW5KeXqAEzdJ4D9B46fz1UUCQrcBpHpKrtfo7
40781	payment	685	685	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxZcdPkhk3xyE7bS5e3jUqopBptokD4QNnNTV3MfRqZA1vr5v
40782	payment	2134	2134	1874	1	1	5809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpUGSrnyFGJ7xC6gZipwx1X7TrS9oCf4GF9YU1hBbzPCF28tZ
40783	payment	2133	2133	1874	1	1	5375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWzy5LTKhk5jPbrNQjMJwUAZhZgQzTaMFu6L4bLpbwgkPVzG9
40799	payment	1397	1397	1678	1	1	15419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbec2XVnqRbwSJpCiSaxfkfoemAz2muSnHcmZLZLhRTbpKce4
40800	payment	1397	1397	1678	1	1	15420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFhdU4oCh8um1KT5KrJfPMCt7dhYyvamstLzEaUNSRfQ6Ro2y
40801	payment	2134	2134	1874	1	1	5815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZYggRNme6EYX913gCwitVbZDbvi2XovXJpw5Xi9gwtbLtznm
40802	payment	2134	2134	1874	1	1	5816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozQszShk5KHqkxHe4Q48aJhjair8Y2qa6czotR5rCjKCnzG6F
40803	payment	2133	2133	1874	1	1	5381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnNyxf946XcdJ2wvcdDnktHz8XhMqxpKATuB8CvfFjSxY28TG
40804	payment	2133	2133	1874	1	1	5382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh4k75kDYroXLsYibPC3Ssirjvjt6YRdSFjKSh6XNeFWkkcDh
40805	payment	1397	1397	1678	1	1	15421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhnHei8jAMCawqMdLB49gWDd9xzP6j4apFUqXFZDTSwe4KfS6
40806	payment	2133	2133	1874	1	1	5383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzXAUvJ9PUFJdwHzpkSVbrPqYDaDLqjWwty1XQJjWh7V5XMpX
40757	payment	2134	2134	1874	1	1	5802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUG8FAfWhdCGrNsx5ZccZNnaRvfJ9gbWSC2dWa2MZx3wKT49g
40758	payment	2134	2134	1874	1	1	5803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpK1AkPwuGHd1VCrxoZR3Mmon1WzscsHEi9ScS5o2XVNghnpn
40759	payment	2134	2134	1874	1	1	5804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ73KBgaWwuPYK1LLMaHKdwuXRy3QN5RLpoRG3tpemPYJ3NAaR
40760	payment	2133	2133	1874	1	1	5365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCmVkJTWBUCS7KySpZFNg6oRKBiAi9ozf1VTYepZdd3XugAdj
40761	payment	2133	2133	1874	1	1	5366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1yc8EHmwCpz3VkSN69FeNn3kGDPNAJKfJBLaCUc6njt8P7rw
40762	payment	2133	2133	1874	1	1	5367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6wFUmJjuEXZRLEPwoHBkMaETLryDLZ61nZdT9ZZwj18UjTP7
40763	delegation	610	610	2325	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSqYQ6CdJbqjpYaoR9ukaEbvxx2CGskDYtkydYCKRzGrats2Z
40764	payment	2133	2133	1874	1	1	5368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkpqVFbcyGy6hQuFm7EhFRFRG8fPtQrscyeiAuar4FFrxDv1B
40765	payment	2133	2133	1874	1	1	5369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkG943zHWb3SqW5KPKDQwHrn5kFDJMfLjr5ein6S5gfDAUgb7w
40784	payment	1397	1397	1678	1	1	15414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTnPUAty4PrYiJAiisQYbkobhuNJ4z5LSqfmWrVLcS5CLNe55
40785	payment	2134	2134	1874	1	1	5810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfe3jxoKDZ7KXkEsxKqK6ZrwpCansEXKqAwvpdvmCskJT7iVpt
40786	payment	2133	2133	1874	1	1	5376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEGTwD3aVXswmE6WuiViYjKySonfoxuwQGkhmBnXud5PtCNgE
40787	payment	1397	1397	1678	1	1	15415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxzAFcYRNaadgNsbMKY5PUxMdJRhwPNDR6AkRHXkcD2Sdc2UW
40788	payment	2134	2134	1874	1	1	5811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPNK514qPP2sehttJ22ZivaN7Y9UfXqXm8s5x5zkGC3R45UWN
40789	payment	2133	2133	1874	1	1	5377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXUctj7hHAfnzLkbibqPqBQXDwB1iiKacfZkz2RoPQLoFoLWY
40790	payment	1397	1397	1678	1	1	15416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyuJYPXgf9GLtMEayar6wrnKme4wBpMb9rBEKyYXcgjuMM64Y
40791	payment	2133	2133	1874	1	1	5378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF95yxskVj3vAyNdin7Js6YstbQh6kF9ZbVNqwDc9eZHxsFzwn
40792	payment	2134	2134	1874	1	1	5812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbo5h7YfXPDV7KR4wk2gnKFoqwUudx8ytddKWo1hijdK14Hra
40793	payment	1397	1397	1678	1	1	15417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRCJeKj8Uxhx59ZEdp7c5YCrye6g9eKa8iSSsQehnyRg624yQ
40794	payment	1397	1397	1678	1	1	15418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d9CLPKB5DEm5ukekW4mnetL3JnGkK1HdLQSzbKzKL1oJSFCj
40795	payment	2134	2134	1874	1	1	5813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo9ovuepDsjh6DQ7hMMYVdbjjuY34zWfKquqNEuUwN26gkBnf
40796	payment	2134	2134	1874	1	1	5814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkW4Kigm8UPzsyrkEyA1YuKS8mqKx2qiNBGhCY9oUZuv64MJsR
40797	payment	2133	2133	1874	1	1	5379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDAwBC2YGNMhoNR2EL2qmXqL9UQTshqtbBfyVsjLtyxVrQQ9i
40798	payment	2133	2133	1874	1	1	5380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nCnJXE7Exrfgsfyw9yEEe9qMUy6xaxmBvQWSwiHHM6Le9ueL
40814	payment	1397	1397	1678	1	1	15424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBe35TxnN8C2T9n3w4Ktyd7ExGqZ2F34U3z1yWG8KNoAaez7EB
40815	payment	1397	1397	1678	1	1	15425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRBFncgQwRco2WxHrWqQFQ4ja4xFrvbn8U6WfoabHfaom8QwB
40816	payment	1397	1397	1678	1	1	15426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbdEG7yVp8Fdv6GPXVawxkZx8V5tCjdLNFKNrUXb4tDgSTeJo
40817	payment	2134	2134	1874	1	1	5820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDRMkhHt1mhLrwerqxrmUzhqkzxksN4vBxTsRZ2qxx2WR25JG
40818	payment	2134	2134	1874	1	1	5821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCqPLbv4JepZiPD8CTFHJej3PuY6MrKC1SmqZ9HRRQtZypPqA
40819	payment	2133	2133	1874	1	1	5386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtw5UAs7ewfYzjWRGKqF9LxBXC2zNKLPwpaptL5zVwqo8zSrsP
40820	payment	2133	2133	1874	1	1	5387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgxNxMjaXVxRzgG2kkcVWgrbi8gJS1nrzPXx2TemB2PqUZpDq
40821	payment	2133	2133	1874	1	1	5388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhWVTKwEak6AEF1RCdTQfkwxH1a4UwyZxJz43Ry372XY4Nb4i
40822	payment	2134	2134	1874	1	1	5822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoSLSUpuwM7YNUfqFZ1dMtFXdW7RotQM17VF2y7Y8RapDqtKs
40823	payment	1397	1397	1678	1	1	15427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQannPih48x97f8qgLdSFXaNpKbrvGtJJss1yavBQ6C4MzkCR
40824	payment	2133	2133	1874	1	1	5389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtnwohUqwv3pLDPdGsHnvq6pSwmWAcbDgymrSSnwWioUSCzUo
40825	payment	2134	2134	1874	1	1	5823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxLgSmMRUpawoTV6ttWL1roRjb8Akb9nWSNJeEsQiLUbaAoZo
40829	payment	1397	1397	1678	1	1	15429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg2gbcQeNuLZFRZhxEbABXmJXFYtPfhhhY2z3vq2eo2cUpBd9
40830	payment	1397	1397	1678	1	1	15430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfZrqnMbMeWbqJJBzxj3f1Xn9h6DV8d3X1XiuiR89SmQREHt4
40831	payment	547	547	2326	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU18Yw6VqcKu4E7ia5UehWP6JgsSzZ85WyHhCT1oWEkctBoWkR
40832	payment	2133	2133	1874	1	1	5391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEvvQeCAot2CuPv8kPhMGRHLoqkiuXoqkbeBe5poUQUho58NW
40833	payment	2133	2133	1874	1	1	5392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLJz7ejGuSKP4NAA1oCYngEJk5UmRgVcytRTA5HoLykgP7rf6
40834	payment	2134	2134	1874	1	1	5825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhnf8pyzPawfHB2yoWsCBSWeJBTWhwBU38Sahwcz6XFZzwC4m
40835	payment	2134	2134	1874	1	1	5826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYA4BRKg2XoSQHHCEv7MhjfUGNFzFFy3Vw9NXKf1yVaV5dNPM
40836	payment	1397	1397	1678	1	1	15431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdfTEU1vUbrbrxwQtWyzTW2vb8joHZTtScRovxqhEtzrGh6VM
40837	payment	2133	2133	1874	1	1	5393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHbkxHXGh3NCeaTu2TJsBURTLaQxEUwUyBFx6cvPeBWeVJjyf
40838	payment	2134	2134	1874	1	1	5827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuR36fegTJwkhnk8G6tjffbUcrrP5gtEsQqt3kZm1UMVRg5wMY
40839	payment	1397	1397	1678	1	1	15432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2frquWbbzp6znoGmnsFiJKDvZhsDyj77bZ46inSRtRYdvmSU
40840	payment	2134	2134	1874	1	1	5828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQUGBPerjCEhUpbiQB1LVBTNABiuuT2iYoUupXhbaX4d58aa8
40841	payment	2133	2133	1874	1	1	5394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZD7S2eZjTkcZhVrxQt1asFVVvDAd8gye1cJAtWUAWREkQjofe
40842	payment	547	547	2326	1	1	1	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcC93kqVX93Ej7n2sFfMfFvZUGaGcSqGnNmrbiSnAc76ejmM3G
40843	payment	1397	1397	1678	1	1	15433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Jqwg8kgxqE2xbJT5F1cz4wUL1byTKtVkJQua7QDr6RGPu7se
40844	payment	2133	2133	1874	1	1	5395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUUdbjD4Bd9wSS4rK6rej3bKatvLNfNzJ7ZifwDjjk6fWo8Qc
40845	payment	2134	2134	1874	1	1	5829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy59M8W3ijDzNDGi15RbiHNP4Py4uR1n5MnBJLreuQBS3HqC1T
40846	payment	1397	1397	1678	1	1	15434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdjmB7GB9cawwrNiYToagasLq4Y1feLfPBr6oQA5NgupxKKtY
40847	payment	547	547	2326	1	1	2	4000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBbCyoVeeHxw2b35vS2qy6w6SLzJn36Qams7Zjf1C4twEbGyu
40848	payment	2133	2133	1874	1	1	5396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjyZxURw1m6W4tKoFm1tRUagK8xAMw1jHyqn6kPNCAVpEs57g
40849	payment	2134	2134	1874	1	1	5830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBPkioDcNTb6PQeWZTTANYLnrd8tvaYon5j1BNxYrwEEJwepG
40850	payment	1397	1397	1678	1	1	15435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpuTtzZ9Qx6HZQ3wwMQwnAoZAnxMo9jivSjoizaAs73qSBx9s
40851	delegation	2326	2326	547	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bh7dXuVRN9fQLqZvsWhkpBWQSmJK5sN6xvUKKtvA5hkbNk1K
40852	payment	2134	2134	1874	1	1	5831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmnuGpYF88xoLWpURXcZ3aHoTh2MLh2Q6KR2q1ENLUkkMYZCK
40853	payment	2133	2133	1874	1	1	5397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tyE5xSUJyZqiYiEDusKGsnyZyEQU2rXd68CchZ82wNywCibq
40854	payment	1397	1397	1678	1	1	15436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1f8BQmJGuqzRe6hs15YSz1KA5Wd9qVzUB6dYhFLQc448hj9c
40855	payment	2133	2133	1874	1	1	5398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFQS83qMfqUiCRCxgUGBbuBb5uZeHEDADVm224b2efxSpJUmr
40856	payment	1397	1397	1678	1	1	15437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTG8M95oTof8t2nH2az9nDam3CByj4RjNCVLDMLX5CNzuSfTtT
40857	payment	1397	1397	1678	1	1	15438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk73e9hZqig5yGJqvn7M1p7ryZxE62ssaLN2HkvC33wucT6ML1
40858	payment	2134	2134	1874	1	1	5832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa52NwZfPafZy8M3Dhr58PZPaqZTy9AainvCMFtKzi1vGBrYRP
40859	payment	2134	2134	1874	1	1	5833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYNJkmsdAm1DLNtwVU16SRL5qvvAJ6fDwvrYNDZH6JNkBnJQu
40860	payment	2133	2133	1874	1	1	5399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nLSysoaRgaGoVSvE3vT9FhyTxc6GpnBWBSMbh2iiLgvkVwPn
40861	payment	2133	2133	1874	1	1	5400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aDcRR3Xj3nbzYTv71Dcb31y8HpzeEa2iJ6xhz1Gn4YMaQyXE
40862	payment	1397	1397	1678	1	1	15439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv9ydgytD3TrjHo9EChTp9gS2LKPnxJFfCdK5RCLS3ZnW4h9K
40863	payment	1397	1397	1678	1	1	15440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26yq8wBh56Sja7eMiB2TCg4RpiZw3yLVTt93kjK22Aq5qiHTk
40864	payment	1397	1397	1678	1	1	15441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEngH32Sm51JXCgj9tS2N2bKmxPGrQAAA9eP83R8LzXMGdBSt
40865	payment	2134	2134	1874	1	1	5834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB2KbBHy7BLywztiiAa1Sj35j7ALTzZq5bqXAniPvVCBbbaFA
40866	payment	2134	2134	1874	1	1	5835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUunhS5mukm25xRev6vnjeHcpZF3qiBtsvsMc9kaRCFvg8DM6
40867	delegation	2030	2030	2030	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kPYZUC8ysaHcNXCyJpdihvkFBbzthjsgphLZTzZNuomQTzEk
40868	payment	2133	2133	1874	1	1	5401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE867xzcMcikfJx8dc81wGL77gAjEv75JTTPTwKEDCcXrmavJ9
40869	payment	2133	2133	1874	1	1	5402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFF37Vp7MG3Nm9g8vs9XjApBr2zKrnsNGs99Yv285YanZynSa
40870	payment	2133	2133	1874	1	1	5403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HCmP672nWosuXDyJann3bYuHpEd1ESV3D9LJQ69qfqQ6FwT5
40871	payment	2134	2134	1874	1	1	5836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5MsFhbg2r2vKSYDh4zRMJRUog5PpvYPymkoJtJekm5vjhw1r
40887	payment	1397	1397	1678	1	1	15447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpMf3q2VKUg2CZtdrn3xPXEmSZx8S8Y92r3oi2SVHw1Kym8bW
40888	payment	1397	1397	1678	1	1	15448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hTvyo3QYVKuQ4HyggVKHnxFEqQPd9sKjju3mhyXzfxLRegDT
40889	payment	2133	2133	1874	1	1	5409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpBaujzX9rgGk9YAn2DemDivJRESGd51hxZsaJrMPmvbo31ZW
40890	payment	2133	2133	1874	1	1	5410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GCbJP4z4zc3hm4Jb7GFD9gzARgtRbE8gAiqnS54RquGbRVKT
40891	payment	2134	2134	1874	1	1	5842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjqw5EnbPXSuR7o61uHP36cSJbrjvg5gZA85ytuupcnLqRaCP
40892	payment	2134	2134	1874	1	1	5843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTfPw9ivRwUVbN5CHNzht73GQdtWL8v4EE7RScSgBLF9GWdXS
40893	payment	1397	1397	1678	1	1	15449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKwb584dHt3vrff3LTSX5fZoxDbxQKPzo2646iHZtoQL5o3Xk
40894	payment	2134	2134	1874	1	1	5844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDeJMBWDHuPxzoXsnWopYYztxPzLF8CChRubyjcq15Uxzg5ucP
40895	payment	2133	2133	1874	1	1	5411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXYCZyAZAUr8CN9LhRGc7kHg99m3j9q7ifK6XT6MW9PmYSeR9
40902	payment	1397	1397	1678	1	1	15452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMWqpsUaYJV1CYotVC6FGAr8vCjbLKuiuRv894KtvpjqHBzNA
40903	payment	2134	2134	1874	1	1	5847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgddphX1rQqYuWXzrY8kqP1Mr7JY1seDbC3G2pHr762dYMVcy
40904	payment	2133	2133	1874	1	1	5414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoonZA81nzmcsbpNHcXhmxwBLEe7macdJfCkfsFGSQoBjLFBf
40911	payment	1397	1397	1678	1	1	15455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY3F4RNAVxZvGVRAhPjUfeNiztKBLRTubgho7CRAsD8aD88WB
40912	payment	1397	1397	1678	1	1	15456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhML4iZtpvscEavdTyNh7d2wnt8vGYBr57xgTaesR1WJM7Liem
40913	payment	1397	1397	1678	1	1	15457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRFZcWiuFnXtp8P6XzuKTpAv5eQLUrSBTL5vvP5Lx5vqXFGqu
40914	payment	2133	2133	1874	1	1	5417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtgfwVVbQauWDEPXFYUtmnHf73UeMsgT38URzvrr2rr56NkMN
40915	payment	2133	2133	1874	1	1	5418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12cAmsb9umhYhTEf7p5Dxn61Pd4rFq5p8p38FvG4JkXF8C3Bx
40916	payment	2133	2133	1874	1	1	5419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBEw6yWsqktMu4nHVp4XxoBCX5sxAzbDcG84MNs3CG1g7e1ic
40929	payment	1397	1397	1678	1	1	15464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mqDL4vfW7yhMcrA61UFbDiYWg4GKhCQcpqtxSmGRRq8p7YEx
40930	payment	2133	2133	1874	1	1	5426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdUSyRoG2oFvnbPL9urigTt96yKugFJxNPc3TaSafeUWz6NY8
40931	payment	1397	1397	1678	1	1	15465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpYG9NNLqgCw26zNSxLDbigq1suNem6NE3PkEATvnDJU8zW4w
40932	payment	2133	2133	1874	1	1	5427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYNJFRbNqmGngi8W5UP1ME3F4kg1hH3Nk4ZUXt3STmeUaKPsx
40964	payment	1397	1397	1678	1	1	15480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQD5er6RT3FBfzCUiENKedeCLR4PyzfHRGnLV5CUFzC9ARD85
40965	payment	2133	2133	1874	1	1	5443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33QpsMBnBr7GKgwBFPhwXpjrtcWZQn49Mm89AGAjys8NCg122
40970	payment	1397	1397	1678	1	1	15483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn4Y5HJ8BCdSYkMPeefcuoBL8VD5T46GnhTkJsKDLoHbDK2ec
40971	payment	2133	2133	1874	1	1	5446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLF15C2Kkggex6rhfswfJVLE2yLxV7pCcjKRAMHz7jUHv2CpR
40988	payment	1397	1397	1678	1	1	15492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMLseBLzCxYrXjRcERHZtkfXCsA7fJ3FZAWTE9EZ6oDBNnkmu
40989	payment	2133	2133	1874	1	1	5455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3h8hot4bEk8XHmmRv6ii25u2wsFjfpBkNWH3sCXHL8GTr4SL
40995	payment	1397	1397	1678	1	1	15495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxB5Ki9kFPMgB2BujVW3sp6BMEcK8BTDyLhe8nsZdyBpvPW9o5
40996	payment	1397	1397	1678	1	1	15496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzBkUg1TFjVj64UAeddfJnh7sfFTzTQv8Q4vm8Sm57YLGyfaQ
40997	payment	2133	2133	1874	1	1	5458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5bAkhFKDz9QoqYX4oisniXrHUHmxQGfqDYeD4zQurXFCK2UdC
40998	payment	2133	2133	1874	1	1	5459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjESDgLtjdVMKPMUixbiwvZrXLwjRjY4vDrB8GYvnWVrRGPW8
41017	payment	2133	2133	1874	1	1	5468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxn4bzwZ9XJoqMLWH79Ty66yr62H38oRAps1fBHpjdwCDvGss
41018	payment	2133	2133	1874	1	1	5469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHR8aBNbtMEkBVnhx3tPZd1W4MtqGU6rY8Ern9n16FZUeD2Jr
41019	payment	1397	1397	1678	1	1	15507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPjiXS3akpptWJV7MoGC8Sj3UZxruvmFXT1LUUKRjFahvWQnm
40872	payment	1397	1397	1678	1	1	15442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RwKZv4HGVsSXD7otZ8L1AD1Ha9SYg7YQVvBxAGgvpLxVbBDh
40873	payment	1397	1397	1678	1	1	15443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DmHdN8EkrdBKYM3xR6d2BqUJZxGuGPPXpdcEKVU4a6PjRmso
40874	payment	2133	2133	1874	1	1	5404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX43et8eXLBcoZRi35zchuAvKjjVbKtkg2QtqAWsGdes7qFGCj
40875	payment	2133	2133	1874	1	1	5405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8i63qe2T5GyLCaPZuvUjuD5jcTK2jzGV33tbKBiEFgXSvPUJ
40876	payment	2134	2134	1874	1	1	5837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDVXW87NvmwPaaMMYAb4CMruR1kFjLokhRqY816Xoh6Y1bqMo
40877	payment	2134	2134	1874	1	1	5838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubmLSW5E9SMuTU8tUtXrvy4rEFijdso5kvoGBUq5aEdWKhgH4
40878	payment	1397	1397	1678	1	1	15444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gepX1T97KYqYwoMqcPfhvPSZWgtnRAZGcKA4QDoi7H8unpiZ
40879	payment	2133	2133	1874	1	1	5406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTawhcfkCpx7efR3Wga71qxB855mqdsV1YNSYUB8p5zVLdMYE
40880	payment	2134	2134	1874	1	1	5839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CFgZx7T7LPCVhcRfozMzovNBigmaZEAvpAsy9Y46DpjAzf7M
40881	payment	1397	1397	1678	1	1	15445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGHpM8GBpFjDbsdBgTe4ax5UfGvtYz9pbBoRwPXt52YykybGc
40882	payment	2133	2133	1874	1	1	5407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizwWsmgjzB7nXNWLSNi8TnbsrmJsuzoQ6yxDgLwvgJ3iYcRQB
40883	payment	2134	2134	1874	1	1	5840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyBGYdUgzR4wTHgdsNdx4Szp3xX9odbcu5LpSuYUMkNngmbPo
40884	payment	1397	1397	1678	1	1	15446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQs78MB8FMRkyNYeCN8MpBeNkL6CbYeAPm8SS4QPeGA43xBQWu
40885	payment	2133	2133	1874	1	1	5408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbJoTUrjyt2PHLaKMBx9y4wYabAfYPPAwkZbZjXToi8tzNNVU
40886	payment	2134	2134	1874	1	1	5841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PrwLaHLQHbDcfgD5hnTt7xZ3RdD4JwqAJCsqAJY2uawSmK7q
40896	payment	1397	1397	1678	1	1	15450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNmFZQL9MUCuEC3c1T7MMj2GrQwMYYrRsbHvZXLM3q2G86cSS
40897	payment	1397	1397	1678	1	1	15451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHDS9E8sBahTSPeJuHUyT2B97bfT13c7nwjrn7B6p7ZZReoXs
40921	payment	1397	1397	1678	1	1	15460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWC1zNE9Uct5STsSvJZd3HbHY4WUvepDHTbiNHvkSLqAmgHbA
40922	payment	2133	2133	1874	1	1	5422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG48ztnp63sDnPkDJKi1eWUKCrdPR9NmLtZrVZdDsNnD18NHWt
40923	payment	1397	1397	1678	1	1	15461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EWmMFjFpr51SBnGeSvV1dSMH7bk3TJsTvMDjViG5L6HGW94J
40924	payment	2133	2133	1874	1	1	5423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1VoB3ywubBTWG7NGFuSTxeKfC2jXCDKRyWagxhXPmxMXyizj
40935	payment	1397	1397	1678	1	1	15467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RYydSZWd4UXUtShwXQjzEAAJSNpNEMK1ydGpvZqgtr5Rf8St
40936	payment	1397	1397	1678	1	1	15468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8MWCysMW6Ka62XhBbmxSVkwwyfkYS2j2mheWFzFe8RnEUf3q
40937	payment	1397	1397	1678	1	1	15469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDbNBBUGYRwKXKt5KdVhYShmYzjEnw5uJhBdMUatxAsDd5e7o
40938	payment	1397	1397	1678	1	1	15470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLxdrAkXHXRQYdjHrar7N9qeBXv4kTEWJhSsQEs2ZBgRy8if7
40939	payment	1397	1397	1678	1	1	15471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5ULAuNcYuM2cZmN5wupXAndmZdPufsJtuq4nnPJmLcMoVXmT
40940	payment	2133	2133	1874	1	1	5429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB9aAFsixQnwDvs8GAtrL4JLHrAkvyy3x5UiLtikwrheqtdHx
40941	payment	2133	2133	1874	1	1	5430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBPVfRaMdWQPTAFwVBZJXGCxCqZjyuSehNdnZi7AnS1dtZjTH
40942	payment	2133	2133	1874	1	1	5431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtoik7YQrSggywuE1J666vcXrMFvL7uhWWMLBMrM4YrazddWH
40943	payment	2133	2133	1874	1	1	5432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVzsybXte8nxPdHrZRtnojok3jepTV6aBCByY14UMYhs9Yozg
40944	payment	2133	2133	1874	1	1	5433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YPfKdLoNKHkH5oEXRXCPuNSQ9gvip6x5Aeskzr5rhVxPCf7g
40945	payment	2133	2133	1874	1	1	5434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5K5itx7iyfrYFWvDYpLNsqr7t5aD8wD46TJSahzY1brqFaNxS
40946	payment	1397	1397	1678	1	1	15472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuJsWGrXYLNGVxwv8NdidJpkepz3zWYcw3rpQZwRdM4GRrWXH
40947	payment	2133	2133	1874	1	1	5435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2FqJxNSuvBDtCMv38DZUD2n5p63BW1nuHQEohrcAYt5DCYKP
40951	payment	1397	1397	1678	1	1	15474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmWZDSU6d52UwktiesDWd4HUSdvtUeobXSXq1veWRwYFucjda
40952	payment	2133	2133	1874	1	1	5437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHxTm2aXUENSq5NVTk1rPa8ahNBkuBf7CMLm8gpZT42wYkxLY
40953	payment	1397	1397	1678	1	1	15475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJt3MNza1g5iumXfkCL889m4wkpQmFjvTimmPmRFQ8AJZ2bZU
40954	payment	2133	2133	1874	1	1	5438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeisWrjffxQRw9dUFa7oC9TmScuMAmMAwUg15gzXf4Lk8dzoVu
40898	payment	2134	2134	1874	1	1	5845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynQ7iXUqGkjPGmBc1M1jbP2hCMCnkvQztuxhWUueayKtrP6df
40899	payment	2134	2134	1874	1	1	5846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtY4zxtBkWXkWB57xLwwYhsWbsReHajGiahn84XHiAcfhUfBYz
40900	payment	2133	2133	1874	1	1	5412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Zk6ygnk5ZnVw5dYgnu5WvM7QnrZwbJEGr3VUTt6MdhqpPWfk
40901	payment	2133	2133	1874	1	1	5413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YawwLv5GAqFvAzmaK4WrvAAVwWZBihSmcSGymtChwJ6ckfWp
40905	payment	1397	1397	1678	1	1	15453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgWBJJuAGvgbRkAt7JcomR7YPR3bxUr1qA3xozyFUjVTQreuh
40906	payment	1397	1397	1678	1	1	15454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEN3rZAsDTeWDW5ssTQWRJ8nEErauD68XQqNgBa8EitE8opUZ
40907	payment	2134	2134	1874	1	1	5848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsbz4iNynjpLePmPh4cU2Ro9wD5xtNAhWU7UFuWWvTfJ8SXJX
40908	payment	2134	2134	1874	1	1	5849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVpBiYbuthuJJpvhaAErgAso8STEMoVpWmQXDtGPuBaQXwGEA
40909	payment	2133	2133	1874	1	1	5415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxzfRwKYWMmJN6emEWwGfeMPpQbQ8ePWgoPQxXXvQGgWhqSHZ
40910	payment	2133	2133	1874	1	1	5416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVL7ubqLXQhkL3YU9LQkbsufG3vVLS6b61rNXZX3YM4nuTMLP
40917	payment	1397	1397	1678	1	1	15458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZviEZhbQTQDt9mxCpKUg2DKjvzBcVsnzt91NVcfCKHaQJLZ1eg
40918	payment	2133	2133	1874	1	1	5420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLYMmKD2twKAwYgJGcpo7tiZNaJpozPF4EPsGJ1N9KftUWvxE
40919	payment	1397	1397	1678	1	1	15459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JQGt6nFuzu4szQkrroEVL6tJds9YSE1xnSP9zjMU6yXpwmfU
40920	payment	2133	2133	1874	1	1	5421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YK8eyCsfDD2Gfep5rUk9Bn6vCMvNpmtqy7M9jhZxPytmr3Fp
40925	payment	1397	1397	1678	1	1	15462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVE2cQhovHQ2kGP2eRudZ1afUrbHYWM5iiDQkhTyvaSh4fRLn
40926	payment	1397	1397	1678	1	1	15463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfhLP4uJQYRVGakxJfzYtJqmqAq5Yw9ApJ25urpnMvNZQe6kS
40927	payment	2133	2133	1874	1	1	5424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtPYqNRg7LJRtc5pCe8F4Pg6ZcEGQtbpXHsSAtsfKduRCkyUe
40928	payment	2133	2133	1874	1	1	5425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iHcdpowMTDFLjFLKmeteqQzXqDqjrZ5fbY5UDQk3M3Un8Hs3
40933	payment	1397	1397	1678	1	1	15466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfde4aYpJL1nHtjKaTgoZ2rkHL4x3RTW7VpHdrCbS3gWGNWpa
40934	payment	2133	2133	1874	1	1	5428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfNQCXrRZ2dz8EdnRd6Dx1ngyWtPbroM4EgUQ4waLs9rrPebR
40948	payment	470	470	2327	1	1	11	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibKd9mfoF958ejP1tJ24FHHNFMbaa6npseRoFGg36MdSNSajR
40949	payment	1397	1397	1678	1	1	15473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjxyDuemmTbN4XAM4mjKaQ34kCwDEMUjL3cwsFm7fRNszkr27
40950	payment	2133	2133	1874	1	1	5436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PB5cYvv88Nf26g7XPZXyVpHM2Mh7cHttS3nPwmsjHrZcFv7b
40982	payment	1397	1397	1678	1	1	15489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaXMfD4wFjDAZPdhEvTzwb3pYFezEUYk4RxQK6jzAmtFiiYQz
40983	payment	2133	2133	1874	1	1	5452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LxVtjiUNAbLEdRvLHi9WZnKRhYEa5R8jerdCiTAqeF7fu1af
40990	payment	1397	1397	1678	1	1	15493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoBJbjKm7DxmZq22biwQr6YuBmLsxwKoVDYEoTJKCJQaVyKiv
40991	payment	1397	1397	1678	1	1	15494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyWy7yuGaxQiEdxqJWapCd7wsYhGfiNuv7KSSPRVSKsBGSp6R
40992	delegation	1678	1678	1397	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uC4J83jZqsxWPZf4zxS5kXAZybkZ8ehu6HmZoeox6hsRiryr
40993	payment	2133	2133	1874	1	1	5456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeoe9orfEwx5iaxuriy7JeNq7kbg6j8RYre8JfBtzPFcp4JKX
40994	payment	2133	2133	1874	1	1	5457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHB7oo51BY8keNi2jAayG65gg2VnTC9Ztybfy2qHkbZGTQnWw
40999	payment	1397	1397	1678	1	1	15497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbcDoKVWTxLNH1dPNpePz2deQTZi9CqnrPGKHbN8Kzg1jmVy7
41000	payment	2133	2133	1874	1	1	5460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeWtAR5LqnLhw2tRTTtbGSAXY9634wZYcE11kvTCbP3E889mL
41009	payment	1397	1397	1678	1	1	15502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyR5pwExQdUQEvE2HpDoNK5TgKKMZ2yxUMbufgyi6SG1mGqVMn
41010	payment	1397	1397	1678	1	1	15503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtdgQN1g14ZHMCkNz1w5JopjB8KSvE6kcqxAzbitoipnoXDzh
41011	payment	1397	1397	1678	1	1	15504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhnRfpkr3tRRzXU7KWHq3W9wT3uBLm2GP4MgX3FkmRYAPA1Lg
41012	payment	1397	1397	1678	1	1	15505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsAAYEmEz6bvfzHFuM6v7YD66FzB6orUcBQY4GPc6kRd9ZaL2
41013	payment	1397	1397	1678	1	1	15506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXRmny7QF9JAQE67Tn5LnGVnM3Q1K6oVm3dbMyby5Z94AFo98
41014	payment	2133	2133	1874	1	1	5465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSg5XVj9t1nqUzyoJGCqMPRLAGdUfp2JyhcK155msQZ3pmi76p
40955	payment	1397	1397	1678	1	1	15476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGND5sLTEiF9Qj5xrcMVzQ7niYPC9RKXftUXo7jBs8PKk1KQh
40956	payment	1397	1397	1678	1	1	15477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetqHdmNB8tbfJpoUYcLdQoTa7ADmtVhNWvEMfpPTaoAWRJaXK
40957	payment	1397	1397	1678	1	1	15478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcuuiavSXiw48WTAjPSEiVo9XVTpeS3stXoiATbT3nCdKv4wd
40958	payment	2133	2133	1874	1	1	5439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN3Bucmuf8nWWipwsAtdJ8uMC7qCn5SUmxo1DnouFFa8Tw7aK
40959	payment	2133	2133	1874	1	1	5440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCFBuQg2Qi1nEvgDTmYERcH9jTyz4WS2xEEvr2Z9nBof3UuLT
40960	payment	2133	2133	1874	1	1	5441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aRJ2aiCXngx2jWFdRMCD8rivfmkiS3bdKSHSJciBKW147Pfm
40961	payment	2073	2073	106	1	1	1	188910070	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1wucBAyNwG7iNLZjuxuDkDjZVC7CWcpomVhrMsJDrVtbCiBs
40966	payment	1397	1397	1678	1	1	15481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg3tUACrjfiK663evQ6h7bs6yPXFRRN8tV4Y4V2dpHZqPc378
40967	payment	1397	1397	1678	1	1	15482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbNeiSnxUQXyLAyKvCCthX9dAPzEhg6k7qa9TL1D93ntVoACw
40968	payment	2133	2133	1874	1	1	5444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLfDx5J2atdNKP4fKjMJfxTatEqcJPYsx83DjjwTfQQGhfV7J
40969	payment	2133	2133	1874	1	1	5445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgvSkaWU3WYivrGeqaat7VuRsmj3U3p4kS4pR6oyheL2khYTH
40974	payment	1397	1397	1678	1	1	15485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeTtN4oFCidrzr7Y3fgRTejYyoDDrbbqPXZuvTqxtmF7v1xkT
40975	payment	2133	2133	1874	1	1	5448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhqsDpjNfnyVaF5PH35oDJXyi2inqMQ7YNsKgchg4w8m1CXhN
41001	payment	1397	1397	1678	1	1	15498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4s83vRuCkDxjP1AaXAWAYSXvsRLJUbthHiHpnXZGc3KShje8J
41002	payment	2133	2133	1874	1	1	5461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUqCK2CdmhyUdamfZDYHj4o2LHKQTp6F4hNodCo7o5C2EenBe
41003	payment	1397	1397	1678	1	1	15499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZngk5DL3sm7VSrrSW1BMDUjP9emkVHbUycY353NBpRir3fAB8
41004	payment	1397	1397	1678	1	1	15500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfVEEoFXLXx6VuJ7h45jsCxzB3FBoaxLktDyfwRX9Z57KbQgZ
41005	payment	1397	1397	1678	1	1	15501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguMvdhMhSC8HPi4f8yk8Pntny3QDxdFm2vA8ksvvCrosHGHAW
41006	payment	2133	2133	1874	1	1	5462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxU3aX449MYnbtqaiEfGFwzwritiTZp4gwE9tgnrLsiFRqn7r
41007	payment	2133	2133	1874	1	1	5463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2veEodLdxyuDkQktRcyqYB2wQ59XPVrtVUqofD4sU3TpwRMXk
41008	payment	2133	2133	1874	1	1	5464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqrJ8qL7fqCKkc1sQ98nZn5Gr4RBNdzbc1gnbaDhVe6e3GTEw
41031	payment	1397	1397	1678	1	1	15513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLT5uem1KjpJ6HpE2n5CDj83fUjAPxXkTFt9owpDK7F2YgUj2u
41032	payment	2133	2133	1874	1	1	5475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekhPDLDCxyQXi5StgvabBjQUTeUovNLLmf8Tf45rAmWeTtqKe
41039	payment	1397	1397	1678	1	1	15517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuMYPD3aed1xMj4hipo1ycM4fwgdSEALPsUbwKtqjrQgB1MHs
41040	payment	1397	1397	1678	1	1	15518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2h1JrvY5UwjpN1nEbkh4ZHxVsbaksmiTanPpar15TYEJmgMEo
41041	payment	2133	2133	1874	1	1	5479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3EVyNuMC1wCRUWjT4bM51QTgWJxrWt9oEdNex1p456yZov2i
41042	payment	568	568	2328	1	1	0	720004000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoiuBE6JCKovoiwe1b6fzsmWYQNZgzkkneqQ9o8wwBcnUJqCu
41043	payment	2133	2133	1874	1	1	5480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUWwvNzbW3m9d8A7Es2zYyKitE4bxmdcT3pudg3MxtqoNYggi
41056	payment	1397	1397	1678	1	1	15524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54MBm7HmuyZtuKLmKdJ6rsFwHTP1G6wU1oy3Vd796DWVJ3nTs
41057	payment	2133	2133	1874	1	1	5487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXcZ9kGaWjhusvBxWJkuJS6x1GasPAqWsZRRgFVkffEvQXNsW
41066	payment	1397	1397	1678	1	1	15529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKaY8gUVFivBegg9X6UqGxvBaHbrn6VYP5uzH2GUCPv3cyuwb
41067	payment	2133	2133	1874	1	1	5492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yHojd3TYbLPUjwnePeHAAtFg8BU3fzhA4ecwY5iwnzQhoey8
41080	payment	1397	1397	1678	1	1	15536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qHNdfUK1HuL4aTCvd8Xg5r1YDg3Brdd2XWwnvqEZrMmLhDmL
41081	payment	2133	2133	1874	1	1	5499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDEJdMtW5z1aNH7EneYRESmzdP35efj1LsGYFVpC2zK4UysCx
41082	payment	1397	1397	1678	1	1	15537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLqaS2aNkQXjW4CVFuEqUrryCYekRmScZLDwF3Er2zugbZpgZ
41083	payment	2133	2133	1874	1	1	5500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPfz9WXwhDdhihjkjKt3bckY3AwYgVVGqXtQKz2iASnGLhH1M
41086	payment	1397	1397	1678	1	1	15539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfMLh77AjFgPtCc2G54fE29dXkKtJiW3qeSRjd5VDT8gPAWjs
41087	payment	1397	1397	1678	1	1	15540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrKXSdnHaPbXVnuwdc1HqJdstqeH51bMcztNawSfyUkuUVDdv
40962	payment	1397	1397	1678	1	1	15479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cdCqCs6zhqZ4EihECWwYKTYq8bUQPUhknPWjdTHAxJKXdXG9
40963	payment	2133	2133	1874	1	1	5442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uy74wb86ZPzDGesv15oVcQyoSzGZJkLtLGoE1UwXmsrUhusU
40972	payment	1397	1397	1678	1	1	15484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XbKvCcxyifdTouZVfuaamefz3Ssyb7K8kANPbYNUii4hPqYP
40973	payment	2133	2133	1874	1	1	5447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh8iya7z3aiSRMan7p1Fo8CV3tC81cZ6HaFJUsZGZ1BtcAGNb
40976	payment	1397	1397	1678	1	1	15486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRB5285Y3A5v2c5qtkj179FLCfbXeVCtgro3GP4gTDgqq7q8p
40977	payment	1397	1397	1678	1	1	15487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErt1yzMVxiMC9H6eaJP3UTGiWZDbmjoykSJekYzxhfEWG59LC
40978	payment	1397	1397	1678	1	1	15488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtNn4iQFXatD6L3H4cmKQsh9P323tFzXgeJHo4TMfnhFAEzJb
40979	payment	2133	2133	1874	1	1	5449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv62nNWxcFBoyemEKUWN3rXNrJ7M72dUT47eYco1LDs8dAwcUh
40980	payment	2133	2133	1874	1	1	5450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ146eoNr8yN8EnE3nVoDLbym4f2U5qnLsHVUaSzd8HxcghhZEX
40981	payment	2133	2133	1874	1	1	5451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWhjBSyaDYg3PevhRftFKtzZ6STai2cXpBGzuPhXcZ3HLhjbD
40984	payment	1397	1397	1678	1	1	15490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXGHnxzNci1TvSzA786fHHpgRXgCuZdmT5yYiLeGN13fgkygk
40985	payment	1397	1397	1678	1	1	15491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDT4z86AJi9Kk4p4JL8BwJmW1ocVubAjux2iY4enMBEg82jKz9
40986	payment	2133	2133	1874	1	1	5453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbAYYSsiKnPrpbo7ahcLPszEk8RxDeeuwRL9tXFRs9rSnkwV2
40987	payment	2133	2133	1874	1	1	5454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87tZNPEh6Ja28UkXkWS9beqyuyaFsnoy98wBdfPpEJT8mbePz
41020	payment	1397	1397	1678	1	1	15508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMdoKco5KVXn5r4wzoc7tHG9daQm5r7TK24P4xZuBbTnmXcBz
41021	payment	1397	1397	1678	1	1	15509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2Vq8DARpFx3pLMnmqJJNBVYsFysmP5X9d4c29BdzprNwcPww
41022	payment	2133	2133	1874	1	1	5470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9Exz3sK62KPwEwh8LRkZskvCqH387SSiCTzpj8Do1Qwe4DK6
41023	payment	2133	2133	1874	1	1	5471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5umHk3oo5W5z2hrdFAwNjxGk815LvapC6CwUsg2z5qyzUq6my
41024	payment	1397	1397	1678	1	1	15510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3H5NnNjBwMZfHQM6HQZgJVK8oNq75ouQH6WZ8s3aBsFeJTY7
41025	payment	1397	1397	1678	1	1	15511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLicfak5pGNaTDaP5ADYHHJocFYgvmByH3bDHGyuYCfQRhCrR
41026	payment	2133	2133	1874	1	1	5472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdpGXudiRAPh9sEWGnPsf3XQa2hCwT6M58UHW2rqYJETZg8os
41027	payment	2133	2133	1874	1	1	5473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvUzzp3AweNM2RLuyXS2bM7B5FK29ciGqRuwYLhHiRMvtMbQ8
41028	payment	1397	1397	1678	1	1	15512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGgEUH4eGkEw99RRoS3QXCxHfkfvbuKot1NbfWDWN1SJ3EpaL
41029	payment	2133	2133	1874	1	1	5474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTtFs29wuBwfYf3gtsAN4kVBZPuRs3hbj3XxFw9cpAyuotC5R
41037	payment	1397	1397	1678	1	1	15516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2TqNsc4VVLne1TaKcTZGd7NVeUarwcv3fRYAsj4QoiXhxXbp
41038	payment	2133	2133	1874	1	1	5478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq26AXbYupsL9bCmS9P2isTNrzPd27SKxkp1iFf2RJshRa4o85
41044	payment	1397	1397	1678	1	1	15519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBoDVGC6M1sWCg9dY68wNGF9ghzmKVdKtC3bTKQ1kq2jtQbE4
41045	payment	2133	2133	1874	1	1	5481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJF6yVoT7ycaBFq93eEJLM4q4gU4M9nQSuhEYvriFturMQ5Z9
41046	payment	2133	2133	1874	1	1	5482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5apLHoQGrLiC93QWWtKEg9U9YABPNzhQvApcdRNVA587C4RU4
41047	delegation	2328	2328	568	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ46KDLy8NuukC8RNWTB2YwDn5DrhzWxoAEKBA7zqnc89TJxRZ
41054	payment	1397	1397	1678	1	1	15523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnddcG8K5LXGTaH9FW1RaRajd1UjKwcTH5xFHGrXaD5rtc9RK
41055	payment	2133	2133	1874	1	1	5486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Hun1y3cBtXeV55vczt6tPukZTkmM2Un9KtqgAZv5PPxAgpFw
41062	payment	1397	1397	1678	1	1	15527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbX4RnQV3iXa9DPBEgxmbYzM5tzMjfWXfCh1SavqfsXdMLCix
41063	payment	2133	2133	1874	1	1	5490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WSNxbEdhEXbyA9STaHHtvmsEPX6o9FNqx7ZnZAtx5oDtQt5i
41068	payment	1397	1397	1678	1	1	15530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9JLfmfwGj5Lne78xfjYcPhctLyshDdDScdE6xYL8dwkAei1B
41069	payment	2133	2133	1874	1	1	5493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX8wc2cqbure45CfNz4kXFekhT9ppBmyTHALQ2MRaUpwWx9LA
41078	payment	1397	1397	1678	1	1	15535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56kqAWZFpEbMG8LUJV2yH7QsDEoWdbybZSy8G42gXq8Mu5mad
41079	payment	2133	2133	1874	1	1	5498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTge9KuGe4MY7DQghf4rAbN7qmfMHJCpySWiN9fhFsyBuvXihz
41015	payment	2133	2133	1874	1	1	5466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzi4jVMUWFVR2CtHM2ZWh8TVyQm6MLAFckkLxdYQJxJBJYMju
41016	payment	2133	2133	1874	1	1	5467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQjBeWTNjgPBUg7KuPkWuDHnMhSTjzwXx79cAfz6DtQfysQ1f
41048	payment	1397	1397	1678	1	1	15520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xgQEqcpqJotkz41SBNcM7HvLLeJB4o7jExsA3GNB2LAQZCZ7
41049	payment	2133	2133	1874	1	1	5483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jYBmntxfGjCrucYTRhQXyDnzXseTkYdYsPW2rxEuQQYSxQfS
41050	payment	1397	1397	1678	1	1	15521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ftnjuc2wRs11aFpf6KPTr7e1hDo59uAKN5XMKmvr7rH4RuyM
41051	payment	2133	2133	1874	1	1	5484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxpes5JiCq7C4ADFZ26ydQsSE1KTE7XE3mRuX237SYAA8Uyn5
41064	payment	1397	1397	1678	1	1	15528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD5GpFcfGmXrupUdHxm8M5HkNLVacPnzPZBV1ooku97kVhY3e
41065	payment	2133	2133	1874	1	1	5491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG2o28yR1RW9p39CWTSzvsrm6QLfbajBvrAZBiCvUsCNHKmZ4
41070	payment	1397	1397	1678	1	1	15531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbgh3PHYhGVeZsTHyWksEmk2moYnys9A7Dr14LB2Qhmp29eVa
41071	payment	1397	1397	1678	1	1	15532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmbyniYorPNZaogdojgnz3PodEXgtE3EdS8xMNMGVgTYyrNYr
41072	payment	1397	1397	1678	1	1	15533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1a8qe1fVyeXA56ewQj3dzXyALYWeyvjbVhiZiMP5KjqMM9FM
41073	payment	2133	2133	1874	1	1	5494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBmDZTdnqeNUrY1LJzqRcytMfU2MYzFUGg9XW1GxVm3hEcoCU
41074	payment	2133	2133	1874	1	1	5495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbZFGkmzAaUdKh6oyzzkkqLRXph3TaevCk95pTZLW14wLEtM6
41075	payment	2133	2133	1874	1	1	5496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoBTMMmYMqo62aZMTUNRK9cVmE1koR5MD94kK4JnwHnGUTXiu
41097	payment	1397	1397	1678	1	1	15544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqRd5ZyJD1d73KLKQUUSBVfZQGgCJPS2GJZBd8otEn8uiY5bJ
41120	payment	1397	1397	1678	1	1	15552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiXVaaTPTnFwNPGc8hWvyjhL194KTUb72Jtm3hTmuzpcmNG9a
41121	payment	1159	1159	1726	1	1	1	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgXabYKB2PbGGdDToQAu94eWgdzrHiWXcEpUxetPht54Cyi1d
41122	payment	2134	2134	1874	1	1	5857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7z9S7x5iXEC9a4dhVCZPaXULmMvY3Ghra9MN1Rz2eyGq6V38
41123	payment	2133	2133	1874	1	1	5515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUmtjDdNFtjS2bSHmj6KimAh4D7P4epZqEWdAUDUapUkKp4dP
41130	payment	1397	1397	1678	1	1	15555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtJboyijgEX4NG9ZQ5EA1LwrABzAZLrVPgeycp46icDwhcGrs
41131	payment	2134	2134	1874	1	1	5860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfnNPny2w3agWR8m2FRHP2XM9yZxeEKwqMSskKdR3siRCycD8
41138	payment	1397	1397	1678	1	1	15559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGnccdh2yXbMq4u2nKmvBbieVRhRHiey8Uar44GA2Yspxec87
41139	payment	2134	2134	1874	1	1	5864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tVea3P8BPHgC9PwSWyr9ibmFFfkisZzmkJbtEpwdHMcTC7YF
41140	payment	1397	1397	1678	1	1	15560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQVAuTHNP4SZUF1JWDWW4mSWn1HVZKE4xTuqQyyrMQGLt2JVD
41141	payment	2134	2134	1874	1	1	5865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPzjr3yAMoYEGKncAKNoUpBgXhz8GeambQiioejucNx1Jktvn
41148	payment	1397	1397	1678	1	1	15564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGSx3PXjGSvWiu6nYQdZRD7QdqsphtoUzHykYZ6bzDtq5hDC9
41149	payment	2134	2134	1874	1	1	5869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjqJrCPiAFnEqtja6utZ6MCUu67KtEbaLkv29NZCvbTPTCk3S
41150	payment	1397	1397	1678	1	1	15565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8KTV4AnT7UsFqmMakyFPStjC32rMoFWwfvL9qq9EvQCUYJUM
41151	payment	2134	2134	1874	1	1	5870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzy2rjYgaRifzL4L1SA1iq99dHHwY4VTCJRVRwP5sVmr4febWi
41158	payment	1688	1688	31	1	1	57	2515428052000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZSwWQsRmbj434PQvdV4rFAHXpSamnGcKF4JyJS2r6x6Jbbui6K
41159	payment	1397	1397	1678	1	1	15570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfc9SAuNu9WQadUemTTwxQFrfLWUNYUjrPwwYmNrHUr2Z2ihox
41160	payment	1397	1397	1678	1	1	15571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQkW5CzMLWi6hxh1PHtvdNnSUuHDDcJSqYw46jAkouSc4rWWb
41161	payment	1688	1688	32	1	1	58	140454056000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZhi7LH3qLZQa67vCr2sWaKxF2Y4bN8D7cYymEyWULJtrp6uZx3
41162	payment	1688	1688	40	1	1	59	125904461000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYpZJpk3TkMSd6ptyAQoVR2VFFtzF1e589zCN3VbMhBvpuUXM3t
41163	payment	1688	1688	779	1	1	60	52990929000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZMHUHL6MNT2C3w9cYi2ak6anKL1RKTUgM8xvQdzCv5paKgzzm7
41164	payment	2134	2134	1874	1	1	5873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMQRDzpM1aS49bzL56aaXC7PZFxF7YdzwzWpnkxdgFwYEnZ8N
41165	payment	2134	2134	1874	1	1	5874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1hnGjFbnKdrje263GsqNbn1fewZNqquyw3pJS41d4KmDMzMe
41166	payment	2134	2134	1874	1	1	5875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa29BFboJR4v5DFmz8rbGv6J1LrhYDbNBCpwdx9T3XE8yAA4A
41030	payment	470	470	2327	1	1	12	124000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JH18MSyjnSAVhNtutpXwg1aejbKQ9jdx1UR2mrH6mpBzqJPy
41033	payment	1397	1397	1678	1	1	15514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyRkRiQbLXccBQG3bBsPkgvJDf5euTFEUaAWvNDyCAkffwzzy
41034	payment	1397	1397	1678	1	1	15515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeiQNujymReesJGD12Lkq9URXmnQM9QLmKxDhKHcn8C8qZhEU
41035	payment	2133	2133	1874	1	1	5476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWyYYZVvJqbCc5nBShyD5NZG5tuQyRgMKr92xwszVg5YoUZ3g
41036	payment	2133	2133	1874	1	1	5477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcBKCjBpkHogawYXmoHSF1cDv8CCKAtE6m4Frb77mCpUjuxmS
41052	payment	1397	1397	1678	1	1	15522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BRLd7hWj26yfbhM7biQdMzJFUt7HjY8c6jZRiMhb3kPfwax7
41053	payment	2133	2133	1874	1	1	5485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwHKsvzgtUANAskxQuiGvS9m8RYU1CC9t3EckZ8CMbHhyNEKk
41058	payment	1397	1397	1678	1	1	15525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVFjXYxnM4LNkka1YSF8ich1QrXpdpLKTHvkg7b1TFsWAN9zv
41059	payment	1397	1397	1678	1	1	15526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbricCY4vAQ5toNJ3LfPkPq5KbeUvbB86qhHJrpSFzmyLvdex
41060	payment	2133	2133	1874	1	1	5488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMoTPLgp39Cmm5LdTy4xDRYUA7FUJdzX1nACuoBiY6a5TBQ6w
41061	payment	2133	2133	1874	1	1	5489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWEwJPSWVQ1Usntf2Tyvt9Lj2De7eKqJFw6Zf8w81sHgaXBzW
41076	payment	1397	1397	1678	1	1	15534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb97ef53AHt6X7HyhCJFvgk7WZDa5uLyWZvij2UXfCJPhkSCWc
41077	payment	2133	2133	1874	1	1	5497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoJ5VQev21BFavoKU8MKNNBQUZfgahfD3HSMwamUqA1LtoY4y
41095	payment	1397	1397	1678	1	1	15543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJ1pMU1q44c3WrGVGkPgzWWnKcW6RsAH5kBt5mdL6H2Z3w1cz
41096	payment	2133	2133	1874	1	1	5506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VYBFaRNRnEUBBkLf5dQ8R1zi9gi1vDRq45Sx1L6RfpitVUmW
41098	payment	2133	2133	1874	1	1	5507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDe6qJGUwnyL9eRAedd4H2Lg9aQU7JRdQTRtsfLfD5TgHNU9QY
41105	payment	1397	1397	1678	1	1	15547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyx3UrkQJEHGaBo4JW6SjLXd5FRvCoGZG4zBVxM9RCHZa463BC
41106	payment	2133	2133	1874	1	1	5510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAZpY5c7EYkf2wu7Jn5C53KA1P2Ykri6fqGNuUX8ndef8KMSW
41107	payment	2134	2134	1874	1	1	5852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAMchYTuFqo57JgEwZuR26d7EWMMiZQniJFJR8kjirLDTjGAk
41117	payment	1397	1397	1678	1	1	15551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCmXPnfdS2kgsCjKd2jotQ2rVMCWVB639PKeuyWWuXU5Fuf5h
41118	payment	2133	2133	1874	1	1	5514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LkJKTmmRGXP8D7Vc9KQGhUDvCpCUW3JdZJ2Wpe9BtzW7eGN4
41119	payment	2134	2134	1874	1	1	5856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LtWmM4tonErZnaZ5w7XzXHES6LoPKNSRWQyTKkkbttDHytGG
41136	payment	1397	1397	1678	1	1	15558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxLdm1HYW53J2kSmRvUR1SNuCsaQCdKKJXvgTAMDFQajHP2Qr
41137	payment	2134	2134	1874	1	1	5863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wdo4GqmsSGmsBZXqTw88CANFnu1GKUZVLMYKWgkNG5crWbCN
41142	payment	1397	1397	1678	1	1	15561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7PKyqoVPSmozk8m7Wkptizgh8ZrcrfXUS2pxY4DUiBfgwuNQ
41143	payment	1397	1397	1678	1	1	15562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdCbUc4HtUDXCuiB4MLo7B5hFe7ttUaYuVkKssKqHt9Lh7RpE
41144	payment	2134	2134	1874	1	1	5866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoUXAEbe8NUiCFgb5aHwjLFLDVKn5oDWYDyZqNBJX1VqUFZwq
41145	payment	2134	2134	1874	1	1	5867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJDimB7UHXESKrj9UCcEaiVTurJpWH8cw2w5PKfjkTPRYRztD
41152	payment	1397	1397	1678	1	1	15566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPXt6k3Z7SjeYMcfuxwHQQ3sX8kPtigXrDjQurY5LPg1mBELL
41153	payment	1397	1397	1678	1	1	15567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX4utf5G24Lz6QNoVwU3zh1BCQY3v7dVpMmAkgANkH4YrkBor
41154	payment	2134	2134	1874	1	1	5871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDatopzdgGiLC79a3Ajndet9oUddbYmUYRsySsKvA2Avz9GkdC
41155	payment	2134	2134	1874	1	1	5872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsgb8NVHDzsfZyWC9Y8vkzgFZU4AkxfviqmymsXmsCNuoZmuk
41195	payment	1679	1679	1	1	1	75	843431070000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEKZnGwkt7Y4zH2d82GEMu3FHPw9BCZba8159RZW3tnehskkoW
41196	payment	1679	1679	841	1	1	76	188789348000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZuv8HN782YfWpxrpUm4BrLAWGA7s8Ad5wSkUjWRMBufkVZdMHX
41197	payment	1679	1679	843	1	1	77	351971422000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ7qcAoLZr3AaRto17RJKGaFBDbCYHkHBph5jWsezAb3befqRng
41198	payment	1679	1679	849	1	1	78	2605931429000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5iZ8u4VqPXjDAiNAfCWitvsD8WzBN5qkWPXsV3gbepWrBQkBu
41199	payment	1397	1397	1678	1	1	15577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TZ1tXHJXBQbiyxV71pc2faApVjRWyZ1kRtAMV1ptccUEJpsB
41200	payment	2134	2134	1874	1	1	5883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUDrSZj43umcyy9Hr92aRMixfZhhFPawucctJb2z9VEDJjNnn
41084	payment	1397	1397	1678	1	1	15538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXTn9vkBzWApTeEcYHiwj9U6w6rzWcFz2e17UuUZtsyZm8Lz9
41085	payment	2133	2133	1874	1	1	5501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiYHKMyoiYRNpzgYQAFuy5ayxb5V5GnwxGMfW1K2WYagxytWw
41090	payment	1397	1397	1678	1	1	15541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8oN6wE41wznDDnYJof2fPBdmPCx7hj8q456yyA12cKcim5Jm
41091	payment	1397	1397	1678	1	1	15542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRfhSobTEnhgAcM3cZ3yL4qTD9h3ajvD61PW2hVFggQMZAY5p
41092	payment	2133	2133	1874	1	1	5504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg7fLDQmo5Bn4bhnTPYHSsMyLGLvTtRwz7DA8NM87ESk1M4ue
41093	payment	2133	2133	1874	1	1	5505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrdSsr1SCSV7VM98wBAuEbNeXSjCDj2ryGpA7C9jc8kCj7aQz
41094	delegation	2327	2327	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XhCo4qtcG2HTKaSq2KohF7QeYQPcuhjFgXvHu5TB38LU8SVv
41099	payment	1397	1397	1678	1	1	15545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdonA7jHjTh98y6xJgAh7S6SdgsTpJKWmXCVPbPWySqUDjN7D
41100	payment	1397	1397	1678	1	1	15546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgovhAy2mkK7bf67TunA6mhjJe7cQjtxTVKPUoJhxmFTzxFfji
41101	payment	2134	2134	1874	1	1	5850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6aC141uq8WqDEi2PNBya8WP25hPYQfyPMhwAm6iycYjxzAT4
41102	payment	2134	2134	1874	1	1	5851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfFw4betxmKkYS716VFXDzbcMvuUwq7pUMSNXQjp7LTg9F7Uc
41103	payment	2133	2133	1874	1	1	5508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCCKxMMBUCD981fLSAb3kKQM1JWa11PuuuGS1PxWkMP1YzTzc
41104	payment	2133	2133	1874	1	1	5509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM5PFdjwdg8MsqhFnbnWqLvVAzvTU6xAv7kWvizv8ieFCNoxU
41114	payment	1397	1397	1678	1	1	15550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdpTbyP5UTZtQcLxQZRSQmRy8uZqXpHVebiJzveooEtrW7Zx4
41115	payment	2133	2133	1874	1	1	5513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5inWnMzBnSM75uXLKGNrFiXUULj4RVRCqrjbDoiiAR87uSCme
41116	payment	2134	2134	1874	1	1	5855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnWqMznei164wJbTUTWacmCKvCfoosSRgaarkrnnuUNf463jU
41127	payment	1397	1397	1678	1	1	15554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3TMjBYS95B9f4e4nwHpBUQNxwuUJo32S4Tc1bzJHvt6JA6sW
41128	payment	2134	2134	1874	1	1	5859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJMuYirycFAJw5QnrV6CCsjnvsHidYf2JghYmV1bPrTLUmyFD
41129	payment	2133	2133	1874	1	1	5517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFBvhEjyHD7VMp21VezftugQRHoodBkzGzbHLXVz6tCfyPBGYm
41146	payment	1397	1397	1678	1	1	15563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpDniNeuSodvS97WnkEaoWztJSwAQVmSBN2jeENMbqMbgVHaG
41147	payment	2134	2134	1874	1	1	5868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpRtkiKQVJ7sNTzaTvsswFtkEhURdTboVXGwi4K6NRxgZyShP
41179	payment	1688	1688	801	1	1	69	26497992000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdR9YQrkjgkuK6kRbh1U7XHuwxu2ZgqzmGiWwjAKGf1HVz3D1w
41180	payment	1688	1688	802	1	1	70	291477660000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYstbiyeJjh3BUXRRzH91cDCcgXaqgUSvPa2HACinUumRuvgFBm
41181	payment	1688	1688	811	1	1	71	205071825000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5Wm46sG685jpmvpHtnFz18wVkjgDwYbq6Q2KHMbmZgJHXe3E3
41182	payment	1688	1688	812	1	1	72	2255788106000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZnv3hzLaFoMWfpzuGM5ASocan7GTcsk94mj2KLU7PLLMjwapxA
41183	payment	1688	1688	823	1	1	73	3290688327000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYt7aPkXZ4hXDfHW7DtjZSP8DqKp3AfHcGJew4m375VJVKfuduZ
41184	payment	1688	1688	824	1	1	74	36197540012000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYtkrhsJfDWTGAwMyBDMhatGWa3AU4LVvspozL9q4L3cH6o4oge
41185	payment	1688	1688	1900	1	1	75	126000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYz1QjpYKQF6upBsb8McCqLEZmsbKRKVUpfJkZcS4wjtsAqr3bA
41186	payment	1688	1688	2177	1	1	76	6264057581000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbP4UmV72VRtMFh9NE4yxoawVVpA46B7uvsWshnTU6jiHJmKdJ
41187	payment	1397	1397	1678	1	1	15573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiQA8vqz91jwjKg81rPDEFjurTB832RohJHHhYdMQHaiUsh8Z
41188	payment	2134	2134	1874	1	1	5879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVv6qRPY9AVaqw87YpKwf4AScLrJd6WqyeiF6JSTxYcbZLSJ4
41189	payment	1397	1397	1678	1	1	15574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25VWKNtSPriZ4EjCrRq7AmSvKdpAxpEHsNumN7JRwpP4MMamr
41190	payment	2134	2134	1874	1	1	5880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVyoM2wKpAzYnkDdFN91vrsj4CqknQDW1BhvX6HsX6Zk3RyYP
41191	payment	1397	1397	1678	1	1	15575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g9bmUKRuujAKoLm15Ho21WjnwcLD8xyWz9MfguGQybwyC3xY
41192	payment	2134	2134	1874	1	1	5881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvhXAM4dCN4aCJk122qwpJtGdxwsFKiiSGP2bogekdBeauppc
41240	payment	1397	1397	1678	1	1	15588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrUBGYMwmavMdYPet5vYYXUAQCRjVRDn8B6kjC5jdCtSyCiDN
41241	payment	1679	1679	879	1	1	98	304590654000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZMiShYPphTNKw13mN9DkkjCQbutjF5wA23vXEftkcKTaMHd1Jz
41242	payment	1397	1397	1678	1	1	15589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa775NrprDwStzpEvHYwK7KrywpjPz9SoD4iAgY6FXGeyWas7S6
41088	payment	2133	2133	1874	1	1	5502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7kcf2UrGT3axwYHqYzy6GfJ2TUFXH8WUP7PWoCxX39ppA8vp
41089	payment	2133	2133	1874	1	1	5503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDvz1YxYXUB43mGDwzhzwksBvN5PENbN2u9xx6nKwzTwY7Wb5
41108	payment	1397	1397	1678	1	1	15548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwksqubeWvb39MSCuKLGpgisENdEyzpaFKy8gzCKpGLr9yJs8C
41109	payment	1397	1397	1678	1	1	15549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7tTzfyPrvLTUJ3vRLrhrxwpsUNPxoPRTo2yxw8XdPVPrf6Vg
41110	payment	2134	2134	1874	1	1	5853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fvpPQxenK3JUiRVNnuLa4Zk6ywJxLL8rjBo2BktWcFU8ibLf
41111	payment	2133	2133	1874	1	1	5511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC5egXYQxGtLDp3ckJc8xq4KpZW9XyAHfHRifRpx2r9nTzYTz
41112	payment	2133	2133	1874	1	1	5512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmCsrBXG9ZxFP7GA7AvTKMuArMCyv1v3P67faKLPKK1riu4zz
41113	payment	2134	2134	1874	1	1	5854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBR7VQBV5jbyLjnmgm61xhJ7dEBQqWQJd4ewuC6eHVbpTZEkPp
41124	payment	1397	1397	1678	1	1	15553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWDmMddvhdiu15bTUVHWwGyhXyUVzabM7x4L1qFDveMeTHZ1j
41125	payment	2133	2133	1874	1	1	5516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSaLaUUUgTqCVUiXThhPU8jGDmkZmneY1RffLR7ReGtSQekgE
41126	payment	2134	2134	1874	1	1	5858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjc7K2BiZpqMsBsC2NJ3uziP22a2rctGvDPeesWxSdtt7UJirD
41132	payment	1397	1397	1678	1	1	15556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfxnZb4sL7ik4ktKS9a3Zd7rfxywBhnFio9udhjSmv5z9zG9d
41133	payment	2134	2134	1874	1	1	5861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSmmBRsfHAuwKpaX8C5xvWe1rtWBBdjGPtWFr1LWJUBegHfSQ
41134	payment	1397	1397	1678	1	1	15557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPkL1M918osTDdK3o8LGBcKF8bPSPGDDSmW2b9dB1y8zyqZU4
41135	payment	2134	2134	1874	1	1	5862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4fUNs8RoJi5KZsmDFqhp9zf2ufVA5xQhCGhuHGfyqbAR1mhc
41156	payment	1397	1397	1678	1	1	15568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujA9exn8LKbwYt71GU2G3vE9nVePM4y1aqSVAMKb9ggWKHuMy
41157	payment	1397	1397	1678	1	1	15569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCtYn7rgmWHhohoby2KDSe5owD9N6hx9pBCUQVqd3khM8H3VT
41169	payment	1688	1688	780	1	1	61	582899713000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZPKoR9ZmoeQsfuLhp1XxoxAhLSKhKghCofh3NghkAAATtWcsb
41170	payment	1397	1397	1678	1	1	15572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuDUowGhrtSU38SAVgxCW5x1B5fJ45PZgiLTxC5hhAMyzeXeN
41171	payment	1688	1688	782	1	1	62	4663103394000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZNhxesCkADubNGJmhwJFRAjDxPaouX8LNjf1fs2XRdMkZqE3yg
41172	payment	1688	1688	785	1	1	63	423918860000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa6aG2e2JE7RPMCueqFoXWdx74PVKX1YanAH4ebzahRttzLcYwF
41173	payment	1688	1688	786	1	1	64	4663103394000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYWGBPpVTFgyZJ9gRrufRatGhufy4L4jpaCSh4kgVeoLYuHDpsa
41174	payment	1688	1688	791	1	1	65	105981858000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZH3g9DhbYG45LEpMWfP1cSJVkVnbmZuVWdqb3TEEvzPGV5NejY
41175	payment	1688	1688	792	1	1	66	1165799427000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYU2CYyGh9cFWnJZREkofWpcS9cb9rZiEYL8ZBfxXuZhUmhP9hR
41176	payment	1688	1688	799	1	1	67	26493091000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZoe2Ut6eG1FUH5Gt6JKoDiYUsWBHoYz1KJMzTLwEVXDV3EDhQF
41177	payment	1688	1688	800	1	1	68	291423743000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdr7g5Ld7VuqYwvFXgpTW3eSeSxq5bVgNr3AEwE2AMSzi5fHwq
41178	payment	2134	2134	1874	1	1	5878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnweohqU5YRckDQQVzgmEN4bdM8QfGBruoi8Ctqg3psKkT65mZ
41212	payment	1397	1397	1678	1	1	15579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3DudpBETzXLSCaz437mwchYunQ5WDoS2E9YLz5bNrjtEtkbJ
41213	payment	1397	1397	1678	1	1	15580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmZvYnuDnU7MBhZpmnufa6mwseeEsVY6GNVhc3NRGSXDxTpQW
41214	payment	2134	2134	1874	1	1	5885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRqXgQTXaToNKBHHAPf1VJkE5PdpZBRSDXQS9UPz7kRRfQzwV
41215	payment	2134	2134	1874	1	1	5886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmarBvcP2e1NzspUEhw4bNtpggczRsisvmNCLdksLGErCF6D9
41266	payment	1397	1397	1678	1	1	15600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eENnYi9Nt5DDHVcFBoNa4sYGh4HaL6wsaTTx1gzar6Z5tZrm
41267	payment	1397	1397	1678	1	1	15601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Ywa8wd2WXgDEa6dAmmniWpeUa4FxAgK5iDPzTjkKqxbkW63C
41268	payment	1397	1397	1678	1	1	15602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYev27TEHAXvUwDLM6ZmnismwHGytUAuuNjhxL1GDjBfyknmgFf
41269	payment	1397	1397	1678	1	1	15603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUDpZz9VpCjaqS6aVG4NsuEhheXzoM8v3ciiUdCKRek9Liu8K
41270	payment	2134	2134	1874	1	1	5906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFkSTMBHtXJUMoBSDxgCiGWErxDVAHggwm56A4iVnuiRJa8z3
41271	payment	2134	2134	1874	1	1	5907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25a9PmnGkw8P4MGpAQP9omNhaELRxoowG2Np4wQQnonjQT1PU
41272	payment	2134	2134	1874	1	1	5908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLPqza79u2CGWo5HuTJpd83RgyuwAcnjq4VtWZhM3x8HTAJNu
41167	payment	2134	2134	1874	1	1	5876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrepYnqmYDyUrFJGYozTvQXKSsCwNEiNgdrixU1U3wQjcUwUU
41168	payment	2134	2134	1874	1	1	5877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UBom7WCJqxxnWedj8u6VPieW84eDUmZtra3HSwZ3JRYGTMmU
41193	payment	1397	1397	1678	1	1	15576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFeKLYgWSeeZufUTGRgSKBsjEvXnS9iZ3WRqBxYsRk8kWTDTK
41194	payment	2134	2134	1874	1	1	5882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyh8VW7f7MTfMyitgFB8Hzn7wsGtEEHerffSohSgHTCD7KrKh
41216	payment	1679	1679	883	1	1	88	203060436000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa7sMsXAPA6EaPKeM5myUyinZzkup9AVVR3PWEtz2R1pYpycBKS
41217	payment	1679	1679	887	1	1	89	606052146000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZcKyktKnh38xyhtxHZv5GY6VBpHJfcNWaC1F19WVniTU6ZsfxB
41218	payment	1679	1679	889	1	1	90	508748293000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZQRCoAGhaBQsbMedew6hAnYfwBQYGLKt8pup6QyeCAHYj9Xbeo
41219	payment	1679	1679	891	1	1	91	1116832396000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZyKAnhfkquM8V1P7fmc9PNem1MjSg4vPcbReQNfS94qSHNjxSZ
41220	payment	1679	1679	897	1	1	92	147324407000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ9ykXGPAEAC3La4CintMrC8QsmnDJ5UudzDt2dzvQFgd8eN6Zy
41221	payment	1679	1679	899	1	1	93	87819577000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbb3hBEuw8aLQxwmb5kRffvSu8xxSJACfU8in9bwyJEQKRLdeY
41222	payment	1679	1679	901	1	1	94	263978566000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjFiVyMKiJ8jKsjw2nsTeYRAaQ87MJqEeSRweiQRTYTTaCWUMV
41223	payment	1679	1679	905	1	1	95	949307537000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYVAmv1DmYLqoMf5sFANDmum7PccfPWQWDbAQYrziLy2aaEpup4
41224	payment	1679	1679	2177	1	1	96	1584060900000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa7TmmEYR1CZ2YD3aA18EnrB1GPrRw8iWZQD1xvwYSR1PBCG7Du
41225	payment	1397	1397	1678	1	1	15581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGc8iQCPoPjjz5fqUSaCuAwaAusM6H1AxrsG4GWGSkcsdDhZ5P
41226	payment	1397	1397	1678	1	1	15582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtEzzN2gMvcfNLnt3cbAe54FpqhGZE9Lpe4kw7xqGqUQQtxr3
41227	payment	1397	1397	1678	1	1	15583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9eRbcEVZhtbE1vYCJYdvD6aJoGfujAEeyJfaQevMotMjdagm
41228	payment	2134	2134	1874	1	1	5887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk7DTQr33QkspikQqFtqk6MDzp6swyuW6xXFNDgx5L7iKKSvW
41229	payment	2134	2134	1874	1	1	5888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr21t3Tt7iweCZTcXKn9mc4CE2ud7x9taSMACJMbHYLXYtLNsf
41230	payment	2134	2134	1874	1	1	5889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy99NQ2ayQchHJNgsEjP2W9pj86kPuAxvcFszUHUACKZeEUM3f
41231	payment	1397	1397	1678	1	1	15584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3MUHJizHXPwf2bupcq3PcaggSchHt7Vo86eyxGpNWWAYeWNn
41232	payment	1397	1397	1678	1	1	15585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNvEXKB9WBYPSv9kcqtBLaXREzwwCLpAgk57qrs7CBRR5U837
41233	payment	1679	1679	875	1	1	97	480576364000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDAKSc7zGiqJ8CxzGCwbFK9X1XQNTKuhNW2HtQ3NKtLgCQVcZh
41234	payment	1397	1397	1678	1	1	15586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2NkTdymfAgvUyh12Nhk51typbtjEp7VWv8aBn21bHTyZHsgj
41235	payment	1397	1397	1678	1	1	15587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCTFQC5mRudNtRWpUHdjGyHQ11zBzVsQoYewBwgj73S7uC9kP
41236	payment	2134	2134	1874	1	1	5890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyhnkNKFV1CWBn8qQFV1eeofsQ3kC5MUdcbu38sDnvvzC1NxW
41237	payment	2134	2134	1874	1	1	5891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUYpEVGc3sYgCsZvHdRXSEE4KDMATTbPzU8LkXkMceZVKTymj
41238	payment	2134	2134	1874	1	1	5892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mXMR3N6tVGiCzrVBXuu8dAMrUZVPJ3PfuU9CxJpA9D3J8rYD
41239	payment	2134	2134	1874	1	1	5893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkQyazWVnQkLdcwWXVTLqtp3RS4Cg6pEtzv754uh8Hqo4ucsm
41254	payment	1397	1397	1678	1	1	15594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcHh6qkPAHcKJofYQkSAZXmd4PxiMihh2qoyQcLRQCxccKZdM
41255	payment	1397	1397	1678	1	1	15595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCkmegpQn2JoWpfsTUvgAMi6YBdzeb455MrDUD23TqDFWQmyQ
41256	payment	2134	2134	1874	1	1	5900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FfbD9dX3JngE6cvEqg1uPKiYCTjqeYeB6kZRN31bveemDmgh
41257	payment	2134	2134	1874	1	1	5901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvFkVG3nQbM4BQ4mJXMXnN86DF2yv89yTx9HiW8R64hN4cFeX
41258	payment	1397	1397	1678	1	1	15596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTW18efUJJwXfiZ8oVQoKjVtV2iPGEZZDq99WHjED3gmgHBzGh
41259	payment	2134	2134	1874	1	1	5902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNkU6WRoAqSHr2UC77KYgTFkwC9rjYHHwVRqQijk9gz1GVXgA
41264	payment	1397	1397	1678	1	1	15599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagfMfLQT7zRmibzipDUgfbDy7hEyatdVMpM75wvnit17ZBAEh
41265	payment	2134	2134	1874	1	1	5905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNRjXDHvrP6zQ5UDq6C11MtVzxG8qkCjKecw4t4MYExSV2xP4
41274	payment	1397	1397	1678	1	1	15604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHzGVimyv1R8XqkrRPG2W8uegqR2vfxWu9dchikdbQNKmozSJ
41275	payment	2134	2134	1874	1	1	5910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcmZBVWQSyn6L6DCW18s9WhzKApNsmzw5YZLrRQma7LfampKS
41201	payment	1679	1679	851	1	1	79	5048082432000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYafV7JKX3jLnfEKiK5b7r3D2Z5XSMd1gbNMj86rvs7i11cNWKN
41202	payment	1397	1397	1678	1	1	15578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAd4T2amJ8g3AJpWBP3sbqEed7meRe6Cjx9HnnBjG66g6T7Hs
41203	payment	1679	1679	853	1	1	80	556632312000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsSGA3DZzZvbQVzEFnnWBwfQ7qfuGq12ESvrL5nrWtVJYhmsYd
41204	payment	1679	1679	855	1	1	81	294437632000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4Mj7tvHEKLvTsFGYJUYM8v1K28tzEpEWMbb4eF6ZSEnsqNDk1
41205	payment	1679	1679	857	1	1	82	742420089000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4UhSGMXu6DbGG2M71UXf2nxepRvfuDKL8UW7fmcXxsf9cyAoN
41206	payment	1679	1679	861	1	1	83	1025455200000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZCgnfxbNbkzhxiDL1X27vkRSnHiAEWgajZM3C25DLWnBNbL2B1
41207	payment	1679	1679	865	1	1	84	900234598000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZpa7x4FYTTjiTndDr46oyv5c4Ya2bdRSbTXrDnQUiQJfMruVQ4
41208	payment	1679	1679	867	1	1	85	5482631766000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZWBfP3BtELtHnyxKas3iGDQZNEz3WNA8t3avvgAnx66nTS6CzP
41209	payment	1679	1679	869	1	1	86	586324824000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo2CfjTxnwZk5ASMZkBqN1Fx8pKM9JTCmBuQQJMp7egJKrXQ3j
41210	payment	1679	1679	873	1	1	87	5482631766000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjAwpjw81Fv7rNW3CpCvtTFR9sP2czVjuKHonBUaoKyfyuPLPj
41211	payment	2134	2134	1874	1	1	5884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtwZwdnZS3tge8YpjNDicEpkK22aq83ir5ePCusg4f3reosZk
41246	payment	1397	1397	1678	1	1	15590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRr8tvBYujgwExSLergGvJ7yCBfnYyxLmx2HJoLbRgfEHYidm
41247	payment	1397	1397	1678	1	1	15591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENcguujp2heLpMVnfckhnfm74d8zkwMngG9pwejrHKv5DEn67
41248	payment	1397	1397	1678	1	1	15592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawXmXuHgjX13N6KVW8UVpdGHX6sEBX34Fahausg7Sxxq49fML
41249	payment	1397	1397	1678	1	1	15593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryG8tcvrrpDEuWiwq6VFTtWh1f61VkXoFmA8v6cimemFgU8ed
41250	payment	2134	2134	1874	1	1	5896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRF1atVR3nNNdRbd6fRUvwHG47W7YiVdDAeb8Eb9SvaigkAnr
41251	payment	2134	2134	1874	1	1	5897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLsXLFPjPYYZdbt3kA3hyMLYZaJHBwrq7PPZZ4wwaq19qx9JE
41252	payment	2134	2134	1874	1	1	5898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xRTztbQbgaBnBZD8Ln1Z5E3FHtk4MGxHFXcobBTdzyzn2fjx
41253	payment	2134	2134	1874	1	1	5899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYwdYJd5d4sivJgvtK1BT1zMfmXtarE8tpmjBy8EcvjxA4G6t
41262	payment	1397	1397	1678	1	1	15598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzhci7eBeu8ZZdwQ8LxodKcWvRfeTz3zAkmZRCPJkzfWpWrAb
41263	payment	2134	2134	1874	1	1	5904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77NuR1s83xD3mEewiqnKgkt7BppBm6gdqGVDZPt8aLbEy3k46
41276	payment	1397	1397	1678	1	1	15605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5qt9JzNQjazcjdvXrw466km1anEKXqV3Vk8HGpytx1mxyFgy
41277	payment	2134	2134	1874	1	1	5911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEwVsciSF8xUAs6remkXNNirraMvPbGDZg7ehxi7NdU68QAVB
41278	payment	1397	1397	1678	1	1	15606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwi34o6wRsqQMYQrVz93DMqw3AJstRm6kMjNtKZjRNhSNabsG
41279	payment	2134	2134	1874	1	1	5912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZokX3Wi1ZbLTHCQo8Hfjwg7A8XSw1H6FvpFEByVVXXwTSufM
41286	payment	1397	1397	1678	1	1	15610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQQRxZFzZQu4BrPrrEKAmUeuFej9aPonWU3b33nN99G9gsknZ
41287	payment	2134	2134	1874	1	1	5916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDxNrAHcRpuHypFemkDB5f6LYcLADXQomewDxzjEPVWAJGo6h
41296	payment	1397	1397	1678	1	1	15613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJJFBa4Ny4iggCdQECiWENhM9XnYrZ7qGdw9XRtEpuGbJ4px
41297	payment	2134	2134	1874	1	1	5919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbkvs51UT7iXJ6VBUJ4jZy7nB2qcsoabDENcVJroBTJqm7ehf
41312	payment	1397	1397	1678	1	1	15621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk8MGPVhLQk695bWApvVS2VqXNPNQNhtC4wEeCTe9wJiPVhmH
41313	payment	2134	2134	1874	1	1	5927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofcVmwYyspphWN1ejh4C2PZamfD8D6vqKMjZFpb6rqvuETzgN
41318	payment	1397	1397	1678	1	1	15624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYajVjqffvVnLVTJ9CM2w6Cy63Ve1JL2xvwLKALTAFP4uNUqf3
41319	payment	1397	1397	1678	1	1	15625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CvVJUnweFc6Vohb1actAZSFmKyPEqqFMpe5re4txTjmFkRq8
41320	payment	2134	2134	1874	1	1	5930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GMo8vSZrCewfSDanQX23ssQULbCsi73pWBb8wYB37XoW9b9Q
41321	payment	2134	2134	1874	1	1	5931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHPnvgSCxevZZxDChrZhenzfq2nttSGNqxJw3tagPeGvM3NdN
41330	payment	1397	1397	1678	1	1	15630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUd5ycM2kwGJH3p8vwbS7Nb3AopnT3yA97epGQrV1RrKj2WDQ
41331	payment	2134	2134	1874	1	1	5936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhcBDPhssvcaXBK18B4x3kpATqPLfrjBY277fw2ei7nLwHneZ
41336	payment	1397	1397	1678	1	1	15633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpR6ZSjUauAyJR5iuZnmEo6Nkpsh8DEJ8yAyTdaoC2Le6wrTEn
41243	payment	1679	1679	881	1	1	99	1319892832000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaBDKGRnfU4HNSgdmqkmSRqej2spEE91BPjuAT3U6YXSDAd2Kgm
41244	payment	2134	2134	1874	1	1	5894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4iGABALz1yCaaVGb8B63o9mUt8sUZKemWkiW5QW3DvF1tVkv
41245	payment	2134	2134	1874	1	1	5895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkGNJ4h8WNXFpmi5dzED56SNuDyXaDjG9qaWAAwBXQ5BnaA6W
41260	payment	1397	1397	1678	1	1	15597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzWex3LfeJoGEebfbU2FByfmp6zDRJR6SjMCkY7F1rnokmBZe
41261	payment	2134	2134	1874	1	1	5903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCU8gQXTudmGHvXh5odzntcooL6LzM9VBaHDsxZc7V8tFUVenC
41284	payment	1397	1397	1678	1	1	15609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoLXGjMmPdeQsJrnwzghNdMaDJDWWAy2zMUYYYJCpmj8V2768
41285	payment	2134	2134	1874	1	1	5915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pCBf5aFjFiND69G4ZY7DLbDkJZtY6vwMDvnV1EwPt265KExq
41288	payment	1679	1679	875	1	1	88	480576364000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZjmbZWt35bkqTTFmtGa1dvi3HAFAYJjeU3xf7VtKyHrzm7YVhF
41289	payment	1679	1679	879	1	1	89	304590654000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYtDjAUk354xaNX1LCVnpeFC2zNf9AzvpZaowdsTRE3NQoBV3KU
41290	payment	1679	1679	881	1	1	90	1319892832000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDSseU7ygEPMHFECErjPFBQHise9roxLshV8oV8Q7b2RJ7XZgR
41304	payment	1397	1397	1678	1	1	15617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZw9yELUK4Nen6Rhw2ptLMpjGQ8zDPDzzmgkumd948BDRvjUS
41305	payment	1397	1397	1678	1	1	15618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdy4udhLR4iDc5MXaVkXRwp29Ze5xAH46Eegrbtr8VHyp4jpCn
41306	payment	2134	2134	1874	1	1	5923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqsdi7VmsxqrZQvfpV8Hr1DeGgymTwujtGFX6wfSRvi1NRkWo
41307	payment	2134	2134	1874	1	1	5924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2Fy2rRjdGsmkzajDtqQ6nPqMmjNTQ6u3MmD7bEAUA3MzrHhQ
41314	payment	1397	1397	1678	1	1	15622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtPdbF2UmS7A2dVgsaa5QcUZ7X88MykaTaneszJKby4prHLTK
41315	payment	2134	2134	1874	1	1	5928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBYxtNncAZA6v1gKcwnPvvgZnjzNEb8JeA8BbUFUaHpJkzfqt
41326	payment	1397	1397	1678	1	1	15628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3N9QBT7yxA8KZzFypuwGzV7LdhcET1JM78XSSPzNdYDy4R5G1
41327	payment	1397	1397	1678	1	1	15629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbCfPKLLYtWHcD3sq8HeS23rrh2qiUDtwUuskpmch4qhdzyhU
41328	payment	2134	2134	1874	1	1	5934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC6rtT66ofBbUKofy2HvnchhzD741i1g1kLNn8jHAfurgSG6T
41329	payment	2134	2134	1874	1	1	5935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGiCVAStmW5pEosCP8srttvGW5hb5TPWGC1SYrPDtH5nTPS5h
41346	payment	1397	1397	1678	1	1	15638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFT5JU4Ry3dg1G7xw4wLDq1QLvQqhWPFzFqWno7q77Ls8EmtP
41347	payment	2134	2134	1874	1	1	5944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQacqEaJAyomv1ARaHPMT8pjKSwEcMqgL2D2viC1gt5NDRwcx
41352	payment	1397	1397	1678	1	1	15641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RVxnaU2ux8FFpm2Z7DVDG2h8UtkL2i8mDwZcqGFAE3HX7pwm
41353	payment	2134	2134	1874	1	1	5947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8E4U5HmoQTFpVPofyaRSyxbbWjvnFExuotoGcoBvmHKK3Hsm
41372	payment	1397	1397	1678	1	1	15649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2MDZbgTjRKm86AhpGrSWht6kXGSFyWDBdc2vCT3NePgWUJhR
41373	payment	1397	1397	1678	1	1	15650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL814z6TwA4mELVAjVmGx1qJAWjW4NQcEN57y2JT8kvuGWYWSE
41374	payment	2134	2134	1874	1	1	5955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoQgrtoqbBEQfDHc8ZTFAJwwjZCJ32VfCG8aBmNWriWnqQVhd
41375	payment	2134	2134	1874	1	1	5956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoWfgH1AdaqFAf18xtN1ox8D1taRUJFt7VMepAn6MbEo6u9Hg
41376	payment	2133	2133	1874	1	1	5522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigS7aYCWLahqmj1sCrPiHXPz9VG8UUs2EAZCki69M3twTtNzs
41377	payment	2133	2133	1874	1	1	5523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6sf47pzKziFxGBmLnfobo9Uv6Ds33oWaqbLwNb5LuNmxzcGm
41383	payment	1397	1397	1678	1	1	15652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsU1JELA9Qxk54qMVZfENkscuyEXGf4meUKJCBYcsG23t48BJ
41384	payment	1397	1397	1678	1	1	15653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WbXwsQryqbvhYrn7f99LmnHe5sxkZHVJvxkhtzUqxpFa8Qx5
41385	payment	2133	2133	1874	1	1	5525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeMC4MAVdSSPmZMCNCerXcGxRon4o7YwXXekkD8UKLmsQAiNC
41386	payment	2134	2134	1874	1	1	5958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGX5WnR6KkbC1ESLpXd2JohnYUhyZ4nPSAtcf4Pb2yG4VShCR
41387	payment	1726	1726	2332	1	1	8289	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwArxgwCGcF9ecz7B1xhazXQLcpTqSZV7Tyiqj5PREuu4Co8HC
41388	payment	1726	1726	2333	1	1	8290	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNEjjn4zriXZczfQMKsRCNkdYC4G7qnsAwwz7zmr31hryfaXPJ
41389	payment	2133	2133	1874	1	1	5526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyey5HK8pX4385cHrngYfwd4WkNBVSKgkoQKAYTptkm8EYbAKk
41390	payment	2134	2134	1874	1	1	5959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YFbLMjCjhdx6qQk3dPYq8y1EcunmVHpkk3QiPnQPRLXxHAaU
41273	payment	2134	2134	1874	1	1	5909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBsmLVg9PDkPGfq2EXaN6HJqo3RU2dmusQb9ctMPPwL66gA77
41282	payment	1397	1397	1678	1	1	15608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkZhWA9JY4atjTBsZnBphLLvVhtwdcpTCxrhBG8AJHH8DSCe7
41283	payment	2134	2134	1874	1	1	5914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVHWGfC4pGzbhcX64UKcnxSLT1TBXgbg2g92yZRfMmz8ZWYjV
41298	payment	1397	1397	1678	1	1	15614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcbyhQhz4DHDnxMs5qJyCiPQedaeUS6qpvZ9eV4MX8DCA692n
41299	payment	1397	1397	1678	1	1	15615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nwpnH6SmzAZtDcw17Y4gs7jG7q9y8aVa2PhpuLpxUfiYGLGY
41300	payment	2134	2134	1874	1	1	5920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jz6HwqcNHxkkHsvFnn1k7dL85FBCP6U6xaxHf5v2dTDgM5dn
41301	payment	2134	2134	1874	1	1	5921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtCFXzL7zkqmp8JDyQobUZxL49Dq9xSPkzR49da3Y1H5GuN2o
41308	payment	1397	1397	1678	1	1	15619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFdSTKEgUkJAtKC6V8DgQTSbUuPNZRZWB3xZtNsnAivR1sYR6
41309	payment	2134	2134	1874	1	1	5925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2Pn55raJzksWA8ugZCiwUETdLfHLH4KbQEBUP6B6Wo66Lmm8
41322	payment	1397	1397	1678	1	1	15626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdZZSzUjWNNAF6EqWwGYTpDDZMJuaaK9kz5CMMVVGFtonKJjC
41323	payment	1397	1397	1678	1	1	15627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDvgTxX4SCuRBThG33UyFnQ9aaEQ5Nmt1debemXE2e7P2fVyY
41324	payment	2134	2134	1874	1	1	5932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJkDfQwxPaqLFzAUHZtwfXqSWd9tJSgAVrGLi12mBC6AC79bf
41325	payment	2134	2134	1874	1	1	5933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrQnGPk7KprAL6hExzaMNmZd6FXSUBjV8smoYo4G5X3PodAu7
41340	payment	1397	1397	1678	1	1	15635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iuStPSLu7t4mYkxD7Um1TwnLpguH24XavLHLWgHSbSQPXwk6
41341	payment	2134	2134	1874	1	1	5941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpFEHr7WKg7521VSSQtAZ3PLsGpQshmoKnfQ1ciEaeYzCe65p
41348	payment	1397	1397	1678	1	1	15639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVf9bUiFvYMZ6zKuLp3YM9xCDHD6jTfXnAw9z9UaX9iDVYgYY
41349	payment	1397	1397	1678	1	1	15640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78RPYda8EUAnWzEb2zrbq2aZtRoo5c88a7wSy4Xb3u8CeB5w3
41350	payment	2134	2134	1874	1	1	5945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkZByk2U5trEYBvGSwiKtK113NuWWnSpPFjHNarnwv3Dz2DgP
41351	payment	2134	2134	1874	1	1	5946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRHFNobd3FSSMwFYxViig1fvF47HJvQUfJoLghfwHsBHErzw8
41356	payment	1397	1397	1678	1	1	15643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39Ki8R5nfMffYh2VzfwFvkMgP3Lz2rDwW2DECthxoNo4Cg3W8
41357	payment	2134	2134	1874	1	1	5949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjipjoYGRxjtzEgdxeAY7RSK8n5z4c4Td7ukt6DxaQakstiUgD
41363	payment	1397	1397	1678	1	1	15646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjDkEtHyrK8uovJnruH7WBb199WtNwk4sWkXUoFz64bYCVjxe
41364	payment	1397	1397	1678	1	1	15647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6nFsi1gNXisHJCp8JULnfHh82qQbgyabaWGkjAkb1WZYQkCr
41365	payment	2133	2133	1874	1	1	5519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWJuwmqy1T4CqUBe2e5UHZyRM8mb94frr9781bdmcJcAPk9hV
41366	payment	2133	2133	1874	1	1	5520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRs39DLE6Z4nemeJmaHE7zd8cZcQQ9iQNhrsRZ3cGUES6L2sX
41367	payment	2134	2134	1874	1	1	5952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCia8mpd46ubUicRrbKDfS75mbQgV4jNw8pE1DWmJ88Uf68PY
41368	payment	2134	2134	1874	1	1	5953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpTHQ4RVfExGobUtpG8J2n37EZYKHdBN5MBZhDHg7meMGGxPH
41437	payment	1397	1397	1678	1	1	15666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYez2JHCzivDSVNm5cX9f8mfRzxzMA1pNZ5G94HfARSjjPJu9za
41438	payment	1397	1397	1678	1	1	15667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzwyG1JnaB2bEvHeYF2DmKUMUuFY35rw3c2nUZSwSA7GWj3WP
41439	payment	2132	2132	1874	1	1	1559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEZnGANQNeP5nug9FUvEFLcDdGdazmC1pQ5fYiejDqggRcVtw
41440	payment	2133	2133	1874	1	1	5540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdhYR7pjk348AF3ix2G3GZYSWUNonyeetf5cF6y1xEGKmhGfd
41441	payment	2134	2134	1874	1	1	5973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd18U5CfYr72EMDC6RhgCfHMBQPYdxRjujSK6ND7QTKe1KWQAe
41442	payment	2134	2134	1874	1	1	5974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYACy9zgViQVTfvRJc9uMi6FAMfkde3uE8ky4SfWXkDDiBNgj
41443	payment	2133	2133	1874	1	1	5541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBV4c9RfsxUoY1po4aMhQDjwK9MrfXw6XBwGqKKDW2ehjgCvT8
41451	payment	1397	1397	1678	1	1	15670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WXLZ1upBUwxwNV8cKa6s94BeXDa9Ra7bAZC3Z9fTPevxXxzK
41452	payment	2134	2134	1874	1	1	5977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjq8ngip3hh7gFTtHPRUWGduQUhWkgJyHkkPjRBKRhEPzoqt5
41453	payment	2133	2133	1874	1	1	5544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXK83cwBeTTXnTJZFndMXHi1ni27Pftt6vfhruVjtwBFzTuNkB
41478	payment	1397	1397	1678	1	1	15677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBogFgMrqkJSXDfUbr4sNvyLyUbo2rC3GcU47tKYX4grfGFSbi
41280	payment	1397	1397	1678	1	1	15607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWMTb4RwnFc4VMajLR1UYU1dk3qihi3bXVdmnZFH3hSav3ukX
41281	payment	2134	2134	1874	1	1	5913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqX6Wame59nDVzq1wNv7vqWiuRkRFwZPct7hMKP9nXrSykxaeq
41291	payment	1397	1397	1678	1	1	15611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4p2TfKr4VxvciR1j9KdTqVQt2g2TMvgjvKJPSZS286Cecnext
41292	payment	2134	2134	1874	1	1	5917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjxjir6AAjLu3kvCWr71z71nZKD113Y9NwEiTeLSRFpkGSWLX
41293	payment	1397	1397	1678	1	1	15612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8pNWP9EgKopYnC2WCJ5GzXaAa9HiwcTPQvuDxZm1tv8kcFeW
41294	delegation	2320	2320	1600	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqc4UHy8xCUqNBXknVZUaPzauPEsbe43iQM35n9uUqBTRYYUAv
41295	payment	2134	2134	1874	1	1	5918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHbvWuPUCBM3UqdfaWwT5U7uwh9Wz5gqwfTJF3dYPWAKUbiNw
41302	payment	1397	1397	1678	1	1	15616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoZd82HojE6cuNcMf5LCuZhhbkiMkDFxMw6XRooFiSKF81AP4
41303	payment	2134	2134	1874	1	1	5922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8hBYdMKPFvCQ158KM5tDxjTHgpkB8aURLjnhWLbkRHa5MzAP
41310	payment	1397	1397	1678	1	1	15620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzYw655coCE1BuQWbdDJF9jfnUn1MWSUDnh6gg4TbkscvpQHa
41311	payment	2134	2134	1874	1	1	5926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGrfwAV2FT49jhfFuweLRE8AYQ5yWjhVyDBbYrABfDDZ4Fb7y
41316	payment	1397	1397	1678	1	1	15623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivyxrR7bVZmRwX7QD6PSVEHaX2sqaWN2AatiWJa1EYA6qeNiD
41317	payment	2134	2134	1874	1	1	5929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48B3fWCkdLZFaMeZKRyUR2BdkxqjY1QianphJ81oh4ZpqfPks
41332	payment	1397	1397	1678	1	1	15631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnEJ1kAnoQ5o6AEDpKMp3P2PrdBgHytNpBK17bGEeUvhy1HUd
41333	payment	1397	1397	1678	1	1	15632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu35mCzJcifB1pLdGE54ThFvsZPCeBSWSSwqNJjcsrP1VZTKcf
41334	payment	2134	2134	1874	1	1	5937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyd2GoYGvfDEcPpqMetBoKBwDKpePqBRNSycMVsb6pNY7BMPDh
41335	payment	2134	2134	1874	1	1	5938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6brDTQTsfzxbVLsbVnnKE2QybmU4XFtsM6Lp79pjrvsVLMW9
41342	payment	1397	1397	1678	1	1	15636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAczZvVDZ6nQwr2uaYpCMA2FzKfafpYb4q5s9sB66Nt4qSBTUJ
41343	payment	2134	2134	1874	1	1	5942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT1jL6kUJ876XhJMDZTYGLpoZVsPxFyRfNc22XUBejVNz7yg5
41358	payment	1397	1397	1678	1	1	15644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWM9nGZyH1zeHo32X1PPxDo6PMe5zDrD8YgJ1yq4rH4VYCWa1
41359	payment	2134	2134	1874	1	1	5950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPXDW69v6UKSNCciQ36N9dqVLC8gdbJuMDB4nKEhFcsV5thbJ
41369	payment	1397	1397	1678	1	1	15648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqifeYY4d7oytTP2wQnQSmHtu3fP1mmcSbULUn8L7hKaHf1vgU
41370	payment	2133	2133	1874	1	1	5521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1pfBXE6k7m2c4GwfWvrztf8j7d8VQam8cGNaS5r8SKise5UR
41371	payment	2134	2134	1874	1	1	5954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSWpBzwGFaELfdzSic49YikgWXD6z2ajrbKLBNvVTwHKP9f1o
41378	payment	1397	1397	1678	1	1	15651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1SL4J7XfQ2ZA4z3YuKpFmaezAUg7qNc1Lp19ZpQZ1dnU3qCH
41379	payment	2133	2133	1874	1	1	5524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZR8XPJ1kjVRa3joE7fTvb7fcS4dxw1dd94wvH3DSgiH1Wok3A
41380	payment	1726	1726	2330	1	1	8287	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxZKu47QtbCKF6X3zgMeoGgzRcujD3iAPFoDSqGoN4gm8r2KjP
41381	payment	2134	2134	1874	1	1	5957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokZoBSRd9b4vZYWP3LggvzGtobceDhhScsJfHNRBSmDyLfYAV
41382	payment	1726	1726	2331	1	1	8288	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa8JUrxApKmNeQijoJpDL54wWeBsgUejBnLGCBtsDqPw1JXXXR9
41397	payment	1397	1397	1678	1	1	15655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWc8TzJ9o7ukm96dMnNt2a4NkzxmDZuYqQLTnE1bMarp9AeSY
41398	payment	2133	2133	1874	1	1	5528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSf8ozj9KoLX7DRnXFEiK9ZGBdhvyTTF7WjfzsthR4FhGrL1ji
41399	payment	2134	2134	1874	1	1	5961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCcum6PzUnGJgWPKCNxfffvEe14ajwsHzSTQf6uKZ3a7YhgGL
41409	payment	1397	1397	1678	1	1	15659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjs8kMptkCDR4nAVTcfdY9e2j5FBP1N86ZYwrrsgZ7kq2tvX4e
41410	payment	1397	1397	1678	1	1	15660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZe7aqHeWw8WvfosBL8wDSAWRs984eS5SzS7bWiBXgFgPW5id
41411	payment	2133	2133	1874	1	1	5532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9k2eu8PSow79YCHR21nTXUJ8vSCmMEd7NvLjKSF44QbtfCjs
41412	payment	2133	2133	1874	1	1	5533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrFE5EMYyjAYERbYET46WZBHsGJe6DBndu6nBYwvLS2uYGU86
41413	payment	2134	2134	1874	1	1	5965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMufzuYKCBtiTkYxcFs7RPY1nrEgmw44ibkpXa7QNqDTafBDk
41414	payment	2134	2134	1874	1	1	5966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRektL7VALeCZkEUBXZCDKatpXTk7MypssBwQjakxEKgMKba5y
41337	payment	2134	2134	1874	1	1	5939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiitUXzp4rAiNHjfFV2NQ2ZZ6FzNuv8Lo6wwVDVtmENzjwchDc
41338	payment	1397	1397	1678	1	1	15634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7ZUtvb8jKY4qQCzrqPu1oy5hXutqPuhr4zpcSyQmydtfUf6J
41339	payment	2134	2134	1874	1	1	5940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9FwsgPADyJ9cKWQj9Fs1J92GHVSwGwYpekv8NTuBGxU3vj8A
41344	payment	1397	1397	1678	1	1	15637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p8krfcC4NAAQeGkFYyRdZsfdDmi1fpbz4RFfzKSA6N1N5ZeJ
41345	payment	2134	2134	1874	1	1	5943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6fc6Zua2UV9BihGpPe6DyGeiq2NhMMPkWiJrv2hYabtC55aX
41354	payment	1397	1397	1678	1	1	15642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3cFFdyxoWKB28ZjFai1AruhxvUHNbC1DyJUpX2115VhKUiqa
41355	payment	2134	2134	1874	1	1	5948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUWi854zmpTKbjoN7zbLqrPx2bw49E9EvSjtGsqCJmsqtN7oZ
41360	payment	1397	1397	1678	1	1	15645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBpxS53pt1BNNiyWoTX7QQZ7wJZ5VkNLGVXwURgYmcqkHggyA
41361	payment	2133	2133	1874	1	1	5518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDUgf5ZEyGfnZ8gVAtmazi3V9E97AFMmY7tsTW5pwA7aftgFf
41362	payment	2134	2134	1874	1	1	5951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrc6XrhZUngMNo7YwAsJZZj1XLedMjTjL69VaeCYz9xzMwgBC
41406	payment	1397	1397	1678	1	1	15658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4j8ZnrvPS3bef3qcvbo2uu2bJ72SSUxGxujZM3mXxKRDkPGQy
41407	payment	2134	2134	1874	1	1	5964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeorSmQnqafeHQFi551UAt5Tmdt6TSXZoEgGEimM4i71gxuQAw
41408	payment	2133	2133	1874	1	1	5531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNRzvv8cFKoKz5wNbyL5Tpufa9owm5jLrCpZLtJh8qamGUPPK
41417	payment	1397	1397	1678	1	1	15661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk3A7KyreADzrg9VAdcWVC1PvuNdw1hfsk3yhHENsHYDLk5xk
41418	payment	2134	2134	1874	1	1	5967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRubvgSZtXe95hfXaw1Mqv5DdQQ4wE6EYSjkzyJubPfRrtepkF
41419	payment	2133	2133	1874	1	1	5534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rv5PzdzqhAPNDBAgue6GRNMnvJhZbVeFBM9kw9ayDjGyHNpD
41446	payment	1397	1397	1678	1	1	15669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBcQ5WvDLXLTyP7n8wBpc3cYaRCWw81smSX3dtpL5tdYFC5JJ
41447	payment	2133	2133	1874	1	1	5543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYDaYFYmNZoggo4T8ZUr6PFn83URt6LBvuLiosCxaJApMpAtf
41448	payment	2134	2134	1874	1	1	5975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mKXdvn97CvKeyvcc3KcVevnrm8SyU3n2hbLZpAvtVK5FgCAd
41449	payment	2134	2134	1874	1	1	5976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvT2NadP8QczPgBJHBqB3EUgGJh2XucDediASsYK1zEVrFn5a
41450	payment	2132	2132	1874	1	1	1560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykLPUZ7G7VQZUGx4JTaa48ZJ3iZSaBj8asnPSYPvav5e9GA59
41473	payment	1397	1397	1678	1	1	15676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSPjWjWa69Ypqr2kFaV8rHhqHvkrfvfm6Dh1qmu4a8pfYj79S
41474	payment	2132	2132	1874	1	1	1562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgD8gBUR35UepAWz95WVnHJDZnQawSY4beBWzmgtZuLthAgYb1
41475	payment	2134	2134	1874	1	1	5983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7AGeG7DL6aBRvfreVZBh3j7HiMfwQG6hGLfJoVK15aRgysh2
41476	payment	2133	2133	1874	1	1	5550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySkhHtTPg7s6529NyEeMFfUq2yDQzj91VNakb7kfsjMQhmyMG
41477	payment	1726	1726	2340	1	1	8298	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6ejGt4wvQMFHv9wVE6jm1RMwNbGnJ3k3eKMMBtqi1L9QdrQaz
41495	payment	2134	2134	1874	1	1	5989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkFxkDGVXcZDSf7S1nTP9USrdYnvaBWos4Lyo8wQFsVbqWnJH
41496	payment	2133	2133	1874	1	1	5556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eWTH9dK5vUZkx7RXsi8imc1VYXxzaWr74sp6KjAfLUiJMy3g
41514	payment	1397	1397	1678	1	1	15687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5N23Y4uYJYFxjBs6fT1eKk3gAKsKE18qsXiEGScgosGjssHnT
41515	payment	2133	2133	1874	1	1	5562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiUMat51yf7s6Sve6rdCQsALN9nVtdnBLxkC36V8Hw26vE7we
41516	payment	2134	2134	1874	1	1	5995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWFGgZDveSJ5YbauWVPVBS7e1jBPxrmA3gfcrvPuKaaXgT6Hh
41521	payment	1397	1397	1678	1	1	15689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Rk2raktDJc9jG4K1SvExfYgBEox8QpR4eQFwcMZuqhrfnnP
41522	payment	2133	2133	1874	1	1	5564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqBzaJPtxawy9XVwZDe8jdi85oWtjJHFurLcjEQ1r4rueJ7qW
41523	payment	2134	2134	1874	1	1	5997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DeuJwLxzzBcSLfALoMJqPvQP5AZy5he3Q1AWmF74uDgFsJmQ
41527	payment	1397	1397	1678	1	1	15691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpMPS2dgLsMvVuR2g3t8Y3Re9W11qasTRckiEbuhw8NVWbVj8
41528	payment	2133	2133	1874	1	1	5566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAt9bq9EDBkBdsF7oVtNNyXsZFawJVN3HNivCVUv6MmiHBELC
41529	payment	2134	2134	1874	1	1	5999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZav5CBc2dDPBeVV54z8K5yJgN3cAkhurpaYfbRq7xoitVvb6ae
41534	payment	1397	1397	1678	1	1	15693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SNHqxMPRSeSSQMA7KDpt3pZjV9u7MLiErkLr5LLsWfLsqbNF
41391	payment	1397	1397	1678	1	1	15654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgWSBXBzVQAfEE9zsPdwJa4QTesQk5GMjPUFiGXFLqqPsnryz
41392	payment	2133	2133	1874	1	1	5527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFhSDYkC1V8jiVfMnWFRFzqTBZUT78LNaPWUqcZDdnKvxqL9w
41393	payment	1726	1726	2296	1	1	8291	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSb6BLGiacMMbeSg6pBumpEEYUBRUpfD3DKmENSCogVzjK72hY
41394	payment	1726	1726	2334	1	1	8292	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiev8CBzyqHonFM6QC1nuhK3ebcCGiKs89AiexUEX4279UM3Rj
41395	payment	1726	1726	2335	1	1	8293	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUgtYjkEqDDkbko6RtY3PxXySkSacW549skXAhkt1GGfMhhpxW
41396	payment	2134	2134	1874	1	1	5960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGH4sZPAbMCWvUNDMGPFJCMYTCnQqm52FmmjTtiUQe1Ntkh8f
41400	payment	1397	1397	1678	1	1	15656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvCnDv1k4jnCXvqC9R54RwT6zZhyf7EPuUZqeZUJZQ9SvdGtc
41401	payment	1397	1397	1678	1	1	15657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwjmRv1hF8rhZ3EMmME4WoAP2pY1TmMgHfJZ75LtFT913GSS6
41402	payment	2134	2134	1874	1	1	5962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYv3iJgnMRZyRSrWMXmCrz1QWB69WeumdtwGhwKAhVvEEtUdr6
41403	payment	2134	2134	1874	1	1	5963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZJfLH3fqcEwVkuW1Sc4GTwQGARwdbE2dGN1q2TMrpvoWiAv3
41404	payment	2133	2133	1874	1	1	5529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2J6DmPKQeGwcVzF7aK3TghuQPYqm3eAwoia2MqNyvsHrXcgsb
41405	payment	2133	2133	1874	1	1	5530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe8jTE9rt4CJDHoYX9evhY2djGQkNNZARX8f7Wtxr5WXdcFXQ
41420	payment	1726	1726	2338	1	1	8296	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYY1isagbBY7VnxgmL1ZrsCo9hLVoHQnxScztN2VCsa3wWpZExD
41421	payment	2133	2133	1874	1	1	5535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsPGa3Z8oRmDsV9TVFXMih2TVmsHfEhQCZkixKMwmKJUkCuG5
41422	payment	2134	2134	1874	1	1	5968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62wTHmFQTt6ZG4XQvzYLC26648RJHhineCx7d2479u1wBEpmK
41423	payment	1397	1397	1678	1	1	15662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjeFJKht6rr6Xa31QmWDcRyPimdNxwEbD31eFeNJb85SE5EH2
41424	payment	1397	1397	1678	1	1	15663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqvdCGaRF7331nT7kRyqJauoVHWdmFRb6WvMnDBvqUUKQgzrh
41425	payment	1397	1397	1678	1	1	15664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RbMMFv15ZUwqkamA1nPXwX6eFK7QVwmMJyHG7Exu1stBj4Hd
41426	payment	1397	1397	1678	1	1	15665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAPwpQDUN8dQsZDBgLsXaJeufKvgsBXh51snRSGToFAfpFTyU
41427	payment	2134	2134	1874	1	1	5969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeJA7kJX9kh4RjXX5r4gMH7r5wNLsrguqBDChYJRAnezXpT9w
41428	payment	2133	2133	1874	1	1	5536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYLHYsknRb6aC277s2swesUk9HhEeWQx13bw78BVeGbcncCjU
41429	payment	2132	2132	1874	1	1	1557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppyBnqmKVGNvHh2nRYLi6YmtHa9FVrZ15Py6SpArow6xKtTTu
41430	payment	2132	2132	1874	1	1	1558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZgyJ8QnkLgd8coMNLKdnS2DGgA7dWATX9SXyPMGYN83RW5nm
41431	payment	2133	2133	1874	1	1	5537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9repmCUfgf6Sa4Sy1fZuC93LeLtDvtDydHzJNcA27PV2RBTaH
41432	payment	2133	2133	1874	1	1	5538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6HoHtyFDhQWvU211un4wEcqf9NBxU6kqFiQfkZFmEKTJgoEU
41433	payment	2133	2133	1874	1	1	5539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBJwrDhbSF3Gnj97CSFH46yTp2qNzM83dST1o1P8a4T64rrC4
41434	payment	2134	2134	1874	1	1	5970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuuDUGqFDydpbKpxonroMD1AXsemwTsz8drAa6CKhzPaWUUMm
41435	payment	2134	2134	1874	1	1	5971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrT2YuyAyhQs6N77We6nfkhj8XKXtLZNvY57sdSaahWVAV52ok
41436	payment	2134	2134	1874	1	1	5972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWW2eaNLBqKMKeZREmghg7MbfjFLHWNM9hrwbS4jiHqtHVK5aB
41444	payment	1397	1397	1678	1	1	15668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1N8VqFav3AG8wVGyGNAod7QkNDknCBXnhBQpcqy2jFWJdg4fx
41445	payment	2133	2133	1874	1	1	5542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsbTVrHJyVHR8CgpcFtpa39NCLYn8S7dzRecfqGqeaobLQz21
41458	payment	1397	1397	1678	1	1	15672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbLL6W6jg5Hzcj7ySARSr4mQcGRjJpqkjWhtw46sQtwQsZ3SW
41459	payment	1637	1637	2329	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgEoK64iVFCXjyF8pCrF7CtMnfurb3hWWkDbWhuerkP5CAtvy
41460	payment	2133	2133	1874	1	1	5546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs59vTpqxhcvWdhB8YaPYF5zqq25QQuwSNPSgCj2GyMfCSZM4X
41461	payment	2134	2134	1874	1	1	5979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrSJA6LNT8tZqwKtYJh8gAKUqotXUNj53GVP6tBWYAWkZ977F
41501	payment	1397	1397	1678	1	1	15683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjKjNkHrEyoNuCe6KXodNQ3W1soUeXcwwDjG13fc7xrenahnk
41502	payment	1397	1397	1678	1	1	15684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXDVdVrpPEiiUn5BEb6xfqCfRjS66f2NdUVMcFq6B4ShWWcEc
41503	payment	1397	1397	1678	1	1	15685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHDJpH3Jr2e4vPnN49XBPYz9mok2Nou9tGHkRs3ENH875Tqom
41415	payment	1726	1726	2336	1	1	8294	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLevaVLNU9CDQW882aQ2pHksUB29yzU2GoE1iBxNT9y7wWQZ7P
41416	payment	1726	1726	2337	1	1	8295	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJLX4YYtpAG8aakne7FTLCVr3Ak8KZqNSeCvo61RdMr54JDyvQ
41454	payment	1397	1397	1678	1	1	15671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptQ9vbeGtvyzNS31r29EDFfnW27Qsy7SnikBo3hVutdVeP5qE
41455	payment	2133	2133	1874	1	1	5545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4NurGHYXrVBhdGaWfYjoSGEJkqpNv4FdDQZi3N9XThJmKZZH
41456	payment	2134	2134	1874	1	1	5978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Ww8mdu523wctHLMFFi1M72UNFeYd7d9PBfFEpJxNu9TmDBXY
41457	payment	1726	1726	2339	1	1	8297	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZaqe28PfoHtXvDWtRkSKcnkAqqzZxnYb8E5LFLfUmrJjbdGXmu
41462	payment	1397	1397	1678	1	1	15673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11fN1vqYRA9ThB2f3Xk82aQQ7LQrpXEstHJ6Xo1ANpo4Y8yXG
41463	payment	1397	1397	1678	1	1	15674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMZjxZEYbdpHQzyucQPmh7jNVoraXxYfeAFSD359yLFTAx4mv
41464	payment	1397	1397	1678	1	1	15675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdyvseKoADMyTpCnkQaH3gxgwRrDkCRWxfVwcgXukXfbgvApG
41465	payment	2134	2134	1874	1	1	5980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZAwQfB9hEWRGAwQd9rcMvWbx6hhrwg83UFW8o2KwfxwrsKXQ
41466	payment	2134	2134	1874	1	1	5981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6751dceP7dZtcnHxZvUgQH8ZsB8Mk2buAnNBUZs991iJuH6i
41467	payment	2133	2133	1874	1	1	5547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGFiRcMxRVEA8w9dc52CisD1d19cF9zgjuEqED2ENvYh6AWhQ
41468	payment	2133	2133	1874	1	1	5548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwvFWUDky1kgTksqZgjyC9mnQCPh3ASgi6b2sBTMYxpLwNSM3
41469	payment	2133	2133	1874	1	1	5549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh17435dsm7dJ8GGnGWB7iQapWkhRuxJJ5jF59uZHjTJcEHwU3
41470	payment	2134	2134	1874	1	1	5982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeEc9hYStY4DgZmjS6y3PoYz5xCcGaNR578PVYVKpraXvtqQC
41471	payment	1637	1637	2329	1	1	1	301686177819988	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiQZimRzYvrwM4suGorXycdB5DzNyP1LqEEWrXZBhnjGnPbkW
41472	payment	2132	2132	1874	1	1	1561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3Qz3cqD9t4hyUxjS4nkqfxJ7U8ZTpgh1peXp2qftK2mePTVF
41484	payment	1397	1397	1678	1	1	15679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgu3mjc8FUtYyJ5xiAsCmErNgAh9FY3uVHGyxs4KKsaHojM9z
41485	payment	1726	1726	2341	1	1	8299	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQ96NTD5ny32HMSySU4C65y9tRuR6rA1wrbRKsUJZeQrZerYUE
41486	payment	2132	2132	1874	1	1	1563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2dRRXmZY9pSn19LeNyBwr1GtJJn4tvzkcngGz3XAmDR64k8V
41487	payment	2134	2134	1874	1	1	5986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXswDGy5u9sMcfNPWsDt9qMzTJ2L5jMQQkqjyZazzgYDBG6enD
41488	payment	2133	2133	1874	1	1	5553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9zcnFzu3qW2RZw2rfAepAYvB1CoHBSipkK4zFVhfyR9qg2N6
41492	payment	1397	1397	1678	1	1	15681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQB2fs3NQiTSAmtxDAmNJq1c2ceQEAuUqvwjzdzvEzqNCXEeBq
41493	payment	2134	2134	1874	1	1	5988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oMyt2Gmhtv2ne5iMqDVhMv9a4RXQMQm4zv9hzsxKLH7wgyNx
41494	payment	2133	2133	1874	1	1	5555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYBSLNNomLsHzft9aDGwNCPwmmUEy2nzESxRkxbCX1TLKfcJr
41497	payment	1397	1397	1678	1	1	15682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuq5Jqg9pA5qfVz1is7ocKR5jeKFJhjK59iYT9SCe8d7YxijPX
41498	payment	2134	2134	1874	1	1	5990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWft7MBWgik9jnnuXUyPAe8WZHFPJmrKZJ1RwTBZVoH3ARbvT
41499	payment	2132	2132	1874	1	1	1564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu42mHbJ5zEi1TENCD3hp7kBsWRAmGX4nQXKufH2EBB7jPxPCG
41500	payment	2133	2133	1874	1	1	5557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHFKp1P5hUMedKMM334hrjcd9Cajqpu4bcbnoJh5Kpj3qWo4Y
41584	payment	1397	1397	1678	1	1	15708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1RB7yBiitkVvpJ7U98PMqY67D9wq98T7yGqaRbYS8TTMqoF6
41585	payment	1397	1397	1678	1	1	15709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUty2WAaWSMQ2KF2y8fMzFGoqPNFKxEynDVoE3hc4d4hZjFiFt
41586	payment	2134	2134	1874	1	1	6016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6t2rT4RNWw5R78FfxvruVJksFqXwKks9TCfyms1emzEUTJCh
41587	payment	2133	2133	1874	1	1	5583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vM1y7Ah3GAPoapudCwYbVh2mrQrizJfL46ruBumEXYBMRtzA
41588	payment	2133	2133	1874	1	1	5584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXgJuaq894anb489TSPZr2xHi9ta8sgSo9zrLRzmsmt1kRPwb
41589	payment	2134	2134	1874	1	1	6017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQq4zeSWMMek8BGbXQZq34PM6jcJwfL4PZ84JiS3ASsBdQCHET
41590	payment	2132	2132	1874	1	1	1572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZNecWe9EjBdF8XnathV1BuRJLA5trztTxMpp55r2Pev4TkK2
41594	payment	1397	1397	1678	1	1	15711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejCAzKBspcm8RShQ2L1amQKsSzG57Rwe62y9sLvXaccW6A1Pr
41595	payment	1397	1397	1678	1	1	15712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4xnsitAZZF1rzy4CRvrQNyeNCzXKyR2ZhqNWUp7X4cH1fYcgF
41479	payment	1397	1397	1678	1	1	15678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpv686RHwxkbvJ2i34ftKtSRtHonDFqiippbb4pmFvpGpCChK
41480	payment	2134	2134	1874	1	1	5984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMPvr79HRQmnHYfQFfwpWa529p1EdCD5pmJFAdA2CGarotoSn
41481	payment	2134	2134	1874	1	1	5985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFCdzaURLGG49UKaZ9Cg7LifMrQqw1sw3QaaZPLKb7pPEAEDe
41482	payment	2133	2133	1874	1	1	5551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CfA5cp7UbjM8h3kE6qGmJ6JJSTxxhbpB1gXhsohtMcN7E5m2
41483	payment	2133	2133	1874	1	1	5552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15CsnJazWaw8zgdYdahvzV8PNJV6VRGjqckJcz85sY34JWmzL
41489	payment	1397	1397	1678	1	1	15680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1n99b8EC4m7jDAXDCNT4CdegxoPGqQb1Spdh5uu64Posr3Rtd
41490	payment	2134	2134	1874	1	1	5987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrdrQbbGYj3MzrLUW5LWdviCwvTngtcoL7i5aZKwaPgMAKZ9h
41491	payment	2133	2133	1874	1	1	5554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkytYoy4z5c9X8ZyzQnsEewNtFx61NCQk47G622Ezvw6AbXVXh
41517	payment	1397	1397	1678	1	1	15688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN3H9SPxY9WG69RAJBDHcg2cSdRRzhkwJahSEtFy5NAkF45EK
41518	payment	2133	2133	1874	1	1	5563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc153NQda1mY98vKdb6i7mm6zyKkKTw25hS9nmPXefhjgZ4F6q
41519	payment	2132	2132	1874	1	1	1566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzCyFHcGCdHJsZiWYyBV66F43cLbuhogsGKWbsVkMkcgt2nctc
41520	payment	2134	2134	1874	1	1	5996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rvpto1AtJS7VeJxURS9yvZCxkV9UT3SzGHkogVhkCyNKdcR9
41530	payment	1397	1397	1678	1	1	15692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1nhZYGnR3F78Hv46pmCm5sMj3VMdX37KY17AxqpZxoasGcr2
41531	payment	2132	2132	1874	1	1	1567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnf14nuuvAn7c1xsuHWPRewAbpKEMkbHVJ6nCd48QRQ1ZdaoE
41532	payment	2133	2133	1874	1	1	5567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fucqXYKr1yvNeafAdgajBRcj6upZubYHG8wBUVYjHmEtePdJ
41533	payment	2134	2134	1874	1	1	6000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGSrhozdA47ouXMP5fmWAZBkpsDc8dTPJXsjvoBUnivQiNCxN
41540	payment	1397	1397	1678	1	1	15695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiwub76DvLkoBJBPDJd4f2zyXeSp27u1Yx53kKnUqn1MbvfPb
41541	payment	2133	2133	1874	1	1	5570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbxGJ694BaLTM2ie6sJr8XJ3hpDrKfXhYUCzXsnFamciXyz22
41542	payment	2134	2134	1874	1	1	6003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMVo587Kj8vwwT842NdDMW4HPhXm9vJ3e2hfdETTevhwpzNKR
41543	payment	2132	2132	1874	1	1	1568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqW9SijcX2TP2oN1r9M5XJn8mTLhmHy5D7n2MVxYMQTpPdZyv5
41544	payment	1397	1397	1678	1	1	15696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZNWoVQNVrLpbFfNa1fxyvDyjELZcMX9zawKG3cu8m95inE24
41545	payment	2134	2134	1874	1	1	6004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQb1R8nSu8aczxekDEscvKpNxv2DAZfujV9mVrgA8sSaxGZZ8F
41546	payment	2133	2133	1874	1	1	5571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGwucGard7npWaHsBSE3nudtEsyf4Wa98VxtDQbutdTpCXB1H
41581	payment	1397	1397	1678	1	1	15707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziioz5JqSkrL3oRzhqEbJWzrhrsc2AkgKbvHvtsuqiFqzhxXM
41582	payment	2134	2134	1874	1	1	6015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqd3Z2jBgevcPx2teTp7HK2ppkaCtuJMyoReeKr6HFn1uSfRXb
41583	payment	2133	2133	1874	1	1	5582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdfzFMGNuMNyXQTdbwA2wJ9LRRYVKKdfxhq3jxokVmUvXBEGs
41601	payment	1397	1397	1678	1	1	15713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSxCwUcBEj58vrrdRfm9dvopr7Vq8KzFpXNrHZMVdCo2tgNg2
41602	payment	2134	2134	1874	1	1	6021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgn4tuvtJBuEPM4FV6tSUa2mXukBb674nraL4xaLV68JiYShJz
41603	payment	2133	2133	1874	1	1	5588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Pp7KJQSnDxYkwvzRt3apNgxjRgfkJfZAH6v9J4d97B7UZwAa
41624	payment	1397	1397	1678	1	1	15719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fCtkMCorJ2kfQeUrnH1j1iM9G983S2BHLJQ9tCEEWrHCQ6in
41625	payment	2134	2134	1874	1	1	6027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3bDWris9tRUyJaujdWhxcAsAYtranHPZHxdJo5REhVY9BS9b
41626	payment	2133	2133	1874	1	1	5594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpExR2bBqKmT348KxmqCy2tgFvwfthJUpLLMtc4erDH7LiYyW
41627	payment	1397	1397	1678	1	1	15720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHgNrJcHs8XZXsaoFGXTH9osKHg1dFehh46R2cyE71rR2p464
41628	payment	2134	2134	1874	1	1	6028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDi6uJo93qxQhvHu5pfsFNuzze8jV9dm6K5yFMBZRdAo2CsSS
41629	payment	2133	2133	1874	1	1	5595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxb2dw3qqjJA3afXsZ8wsP5jne4TgGKNRYHwptXyUwdH52GuzQ
41650	payment	1397	1397	1678	1	1	15727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiufjPZKKPgeXQSn5bzfPyhRAWgtRt9TtZa3nuMyfEKVxPRqd
41651	payment	2134	2134	1874	1	1	6035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVy6W9GyoLGGcqLscRGUcjgp6ScnBW7SZuE32U62CSnGqax7o
41652	payment	2133	2133	1874	1	1	5602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSutBtsydb93yLyVRGZnXERqEMFDr1TbxpbMESJ1ri8sK5wYH
41504	payment	1397	1397	1678	1	1	15686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcexFWnBu3eKZ1y3VN6DgV1aFDVx9US1NEBvd9GN7TYMEyrxh3
41505	payment	2133	2133	1874	1	1	5558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseppCBS7h33sceLpKnYMtJykFSGamhcgJi5rUKEGvyfeeea1o
41506	payment	2134	2134	1874	1	1	5991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbRcawzgiMPYQJ5NUtwLP1yB8c8WFihz5QPfewCA8nTqr8i1Z
41507	payment	2134	2134	1874	1	1	5992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgZHaFhzceFSjfiGX2HCmpKGN14NZVTzPKsfSvguinLPZ5m2d
41508	payment	2134	2134	1874	1	1	5993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYDxBUeNE7NRUfMoYCTMm2347PCMuieoMavT9yeqKUw7AMcoq
41509	payment	2134	2134	1874	1	1	5994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpVMm8tj7D7MmEpJ2PGUHfz22iGnaQLspSQomEqWuxpZrb13q
41510	payment	2132	2132	1874	1	1	1565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyagCg6EG3ciqW7n1DUbVsFs2ZxqNoAdnFigwmqPo6BTMkgaWn
41511	payment	2133	2133	1874	1	1	5559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9886kT5EaYWPWttFCW4vbUWHV8rXWdhVXhzedsSyvRm1TUkS
41512	payment	2133	2133	1874	1	1	5560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBpHwwkRGn3FtZrXvSWChcL38Hjd8eBQ7jkQpXwGxnfgs5FRD
41513	payment	2133	2133	1874	1	1	5561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHdDX3EG4w6GFhMiMzydYSKFRE1KAi4vemtkAzF1os2AWXarp
41524	payment	1397	1397	1678	1	1	15690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhzFRqtxfKtwnq8KumbiGZmoYCs7txXTZJPjtFQiPAKCVXXdS
41525	payment	2133	2133	1874	1	1	5565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3sac9zFMFL3B9k1cpN4UpZRdHbfweFTij4kBjTopn6BSX5T6
41526	payment	2134	2134	1874	1	1	5998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkX3cL3FiJx2HwRUkAshGWknmBBNpKWN2qKoyp3GaPnSUdYae
41554	payment	1397	1397	1678	1	1	15699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYEP87n9NjFnRJRRH41y1ruQa5sT2BVmLGQM7RdpMs4yomcR2
41555	payment	1397	1397	1678	1	1	15700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dNw24JY7x1qVkLnckT8XuUn2gZbsEaenabNpkSrt1AWyYH8L
41556	payment	1397	1397	1678	1	1	15701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhZoVGG3n3txbVmsMxPdahiEe6AGdNn1NZY3JTV4ynDY6rKcY
41591	payment	1397	1397	1678	1	1	15710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThNzNqvSRSRCDoM8AoG8QXvaYMaYkcNQMck4XcW9Tj7k6UFgb
41592	payment	2133	2133	1874	1	1	5585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9syRpQhfcorzGJFwD1cQK68Bn7v346K5wg6Q4ExCNpDETvVQ
41593	payment	2134	2134	1874	1	1	6018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDY2nJdZTsa512pZcMzCUxunQrpZhzktyBsSJesJY1BFkA8F3M
41660	payment	1397	1397	1678	1	1	15730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc44jxovcukTFegdJCUxcab9PaYVHi1pcL6B9je7fdvg47AmR
41661	payment	2133	2133	1874	1	1	5605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSd3MC4Rgsvpgqz8P3eJJ5s3ek9U6hJ2yTuigUHs69iK1UwKHG
41662	payment	2134	2134	1874	1	1	6038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ6SwWXutmkBDBireqHVa3eHWrZP786hoLCg8T1DZ51xv6uKp
41682	payment	1397	1397	1678	1	1	15736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3vkQocJTyV9UqXwwVD8dBUmfKuuBqTwGBdq5Hvr5Ae5CNrw3
41683	payment	1397	1397	1678	1	1	15737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwY1eou7ha5A7UmQxuRSpN8NxQtvhhVpH5pdtFFvC5wGzSbq1
41684	payment	2134	2134	1874	1	1	6045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2CmVesFtTCgVvuwHJMkE972Zi7aq5baYMPyNKwMrdJxuJV6J
41685	payment	2132	2132	1874	1	1	1581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRcyY3s6agp2rQqAv7vsVK3Z2fbGQwr1KgLNzxYVE1icEinUb
41686	payment	2133	2133	1874	1	1	5612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXGT6Z4Kc8WcBBGyPPcobrWi3NaBpvLqK4o49fBEEx78s8aY9
41687	payment	2134	2134	1874	1	1	6046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TU4dsw2c7SzKL5rkkg8BUk1bfP9Vp36apW5gABYr3PZSvzBG
41688	payment	2133	2133	1874	1	1	5613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAYLd4fFTkyZgbqVwW61FAsTvpfqoyTLQ2ShgpBeqdoBc7b9T
41731	payment	1397	1397	1678	1	1	15752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGULGHkZUdhUAZ7Upfkquhe1gNicpu1Arpw6jtEcVkcDSPo7A
41732	payment	2134	2134	1874	1	1	6060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS7fzeaFTT2FosZZHFs812KfES4RGdStZbPJzCNamS2VRZs7h
41733	payment	1397	1397	1678	1	1	15753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqz3XrX8DtnSjGCSi5XY1YhetUnMZ2vMBAs5prhYZg8gUegsu
41734	payment	2134	2134	1874	1	1	6061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDesHMovUDeAoMabiYRqnH8qn1M7Z2VSnJzsek6YZD2MSmT3Y
41735	payment	1397	1397	1678	1	1	15754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgi8xVooyD9GJs3au4RxFimzrKtsDv2TbgZdvgTAKJBtUeo1xo
41736	payment	1397	1397	1678	1	1	15755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46eW237BBwEgNvbk1uiWdZstqKfiH32Jx4J2wbkjxiNwFcQdq
41737	payment	1397	1397	1678	1	1	15756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFFNzDq6Z9LoLwc7ohSnJfnCsGE1oyFv2GQX5GwJ1dRrAiu8G
41738	payment	2132	2132	1874	1	1	1586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQkeLUq7u8CaZwAG4jfnnh4L5bXFTFFgkT8deuQK81njSTuFV
41739	payment	2134	2134	1874	1	1	6062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gbSETdHPKm3UbTTDVBrn95wEMArhwUW3E25wtRia4Gim6Bwt
41535	payment	1397	1397	1678	1	1	15694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGM6fTasCJERrqicx3LErok14bFRBrx77qWknFuAFVFSU1oZm
41536	payment	2134	2134	1874	1	1	6001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKN32Lww27C3XcaCZfiwdBNbWqHm61Gdm5Y8tweK99qXTxR8R
41537	payment	2133	2133	1874	1	1	5568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofqJNzYrKSWaLciUMSAGwBAXbT5a8shfvn563ncVajjF22Avs
41538	payment	2134	2134	1874	1	1	6002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cuz71anSDNFz3BGJpVsMSHp1mf6aq46f7TiNRCH154YvJcnW
41539	payment	2133	2133	1874	1	1	5569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YqopVRwWvfTjFbmGD6L5Cuhh1KVpoesKVzJqJCocrqFbV9MM
41547	payment	1397	1397	1678	1	1	15697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93KyU2ozYxc4hqA2ieA43CQhSJaiP1YW8HZpErCSyA9TK7Wzk
41548	payment	1397	1397	1678	1	1	15698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4C5BjnSUEjEUjxZjE2AbTK6imsr3X5qsSCSPb2ThRVaX4KYQ
41549	payment	2132	2132	1874	1	1	1569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPY5KpvJPrhKm5FhAyCRQ7AKVignUCc6oRFSUzmSsA6YETrND
41550	payment	2133	2133	1874	1	1	5572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZuZAyQppMPpsD6Y9ksiS6xJUHCuFsiw8U6AfnVZHcAKHrHFF
41551	payment	2133	2133	1874	1	1	5573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVs3HXyLt8eNzB9Qbrv7U2N9ZMmn4DeXGeSYErTKfqoHy8GDoV
41552	payment	2134	2134	1874	1	1	6005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5f2QUHttQQ3qEeJ9BtkJjVByzER3AtPGqC6GHzBxF4k8t1XY6
41553	payment	2134	2134	1874	1	1	6006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WKPv9DtFFBZdHr2b9kxCWedME8hBzCzkXA68vePFC1R4cZwD
41557	payment	1397	1397	1678	1	1	15702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFN5mGF6wcUjvLhMRQtXsWL5EmCVdu9apmS9BzYPpftEQpHQD
41558	payment	1397	1397	1678	1	1	15703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtUXdEE7TGw7Pyk4RnuxwKsdWj8iArFEwcBW4hSHJrTXk1qL9
41559	payment	1397	1397	1678	1	1	15704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8yepLZCRAsD9WZJ1qiBiQB9vXnfuV4rtGd6uq32GWqYCrsRK
41560	payment	1397	1397	1678	1	1	15705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVcBezDQtBaFyswUuL38KWRzu4uY1VxZchcQ7DXdFXWsW1WvU
41561	payment	1726	1726	2342	1	1	8300	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ4JY8e7SuVdH7iro7z7JNpEX75ohNe4U4t63gbXo3JzAGsJSs9
41562	payment	2134	2134	1874	1	1	6007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwn1t1kjAdCDQq1KpPLyeWbrDW7unrsdn8QmaZaLASNppdjay
41563	payment	2133	2133	1874	1	1	5574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3AfNmJdfLmDN7GQjHqJRkJPLZ2rkYtP7AcPhWgALAHiwBMJc
41564	payment	2133	2133	1874	1	1	5575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqpV8W9cqMC2Szay4HnQTgyeDkgRxCQNbMDhRpc4qWxGDRVnN
41565	payment	2133	2133	1874	1	1	5576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoocpJquzFbE4cQsrBvLJJy3PMfHf5Go9xipTagEzkS74rFk3
41566	payment	2133	2133	1874	1	1	5577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpcfX9NQhwQ8DssxWtvu8TcAtxAhJ4LFSyuDpikrqVVs1NfFm
41567	payment	2133	2133	1874	1	1	5578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsR6RShbqnNXrpAzPgLVVicAPMNuCW3vYJdLxK4KjYZEsJDoKJ
41568	payment	2133	2133	1874	1	1	5579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rd43XxDast9iYBGJxJHBh3zLGiSg5mwPEeMFDoBgsGJkS7C1
41569	payment	2133	2133	1874	1	1	5580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRa6AAnyTuwiZXpm9HMazJVHNWC8vuLZ6x4eoWp3LLwy3yvZJ
41570	payment	2132	2132	1874	1	1	1570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmu4wKk6SFYbKyJo5faTei9Pt1azupoDNezHGgHPM8tpLNDyLN
41571	payment	2132	2132	1874	1	1	1571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CkoqvknHzfwd7V6HDPupb6UP3oJRg3R9aVU17g23CRGKpPrc
41572	payment	2134	2134	1874	1	1	6008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshqEPc4vEwqFAMKsVLyFTyMFpKA6Mjtw7jfgyGS2kB7BDoc6s
41573	payment	2134	2134	1874	1	1	6009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnubAkcSnVJxjQfA1GBc9UjPQPF6ZBWTSE1wQpX8wij79mzt3
41574	payment	2134	2134	1874	1	1	6010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWHnoQN6hp8HaCWby5dUmoyjbsGxEAeoTYW83ojDa8DzyFGHh
41575	payment	2134	2134	1874	1	1	6011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKdMG52ApBhZ4y9pcWtBAJzNQADTLYCpWtgAL1A8YLG9Y7XhQ
41576	payment	2134	2134	1874	1	1	6012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgJfp2UFXnZzop2cqxuubpFc3Uf8iGi862wiEUJvXYToJA58o
41577	payment	2134	2134	1874	1	1	6013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHVUSE62yHV9QvsVZ2x8eAxrTWuzGzzBN4Cd9rHQwR9GHd3os
41578	payment	1397	1397	1678	1	1	15706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdsUzc7mt3gLodEdk3RREGZwwVC2MJTdvtk69jSk4rSxhWzxT
41579	payment	2134	2134	1874	1	1	6014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncjosiFp4bJRg8adhKyWsSMbKtgMfSYMqbqd7jmZoLJ1Cim3a
41580	payment	2133	2133	1874	1	1	5581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5m5mTwPQSjzmD5mEjgjU8rVRPzxAx2KvGV1cmKyV5Y7kZhVWG
41604	payment	1397	1397	1678	1	1	15714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHshrAfeCZXPUoiToNqrgQ7aZkxR6iz2uEmXE94Nhj3Ge94qf
41605	payment	2134	2134	1874	1	1	6022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSccKmjEK6r271pKXTPc7qo15WKyWBDF6qDKXjjNtpE7f4kCqM
41596	payment	2133	2133	1874	1	1	5586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaBSyvhkzFKuznbuNZQg4LDtiGZCNtGB8vT9rqBRqwbK9kq2D
41597	payment	2133	2133	1874	1	1	5587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEoXfBUoG351hHcaub9RaJ7ZmcURzfYnUfj1tbZRh6QJzPAYi
41598	payment	2134	2134	1874	1	1	6019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZiRAFxSiGH2qkWFN6zXA6CbYdS7tGffumETMqvwFYFyS8qUY
41599	payment	2134	2134	1874	1	1	6020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRcVyG6Famk95TUrGFpXPwMQEHeHhJp49xaN6duDSazXAy44n
41600	payment	2132	2132	1874	1	1	1573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZruAdMcN9jBoTvRewkks7PbYQcMcNtXzmVjJAAh85P2nRHJmg
41630	payment	1397	1397	1678	1	1	15721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNyWXwfxRkyaQsSF8nReCRte8M9VBAZhMWJSwXFukvKSB8CDP
41631	payment	2134	2134	1874	1	1	6029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoKhdh53tDbda8d39Fqeg9EaNf3ZxixhoV74Ax9U5kkQ1SaRW
41632	payment	2133	2133	1874	1	1	5596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJVLbyEHNMTjgpY7dra5etmkqVsWWEJuwKGU4SgA6qRu2Geit
41653	payment	1397	1397	1678	1	1	15728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDHyTFiFzfHs4YgKHukN98jJX5ehSkFWndWEpP2pcyw9ZBRt9
41654	payment	2134	2134	1874	1	1	6036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJPhcY7hzY2Gb5YNF5pTZjPpv6B4XNyi7hFpWuqX7RJX62pUa
41655	payment	2133	2133	1874	1	1	5603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoC4fecx3t5AVwhVx852Pgm6TngatXRstK6jfggDtbxg3y84re
41656	payment	2132	2132	1874	1	1	1578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SUoHPtwi4veTQUhmhPQVZSRR1vwmKPBT24U42t4HdeypbLDU
41689	payment	1397	1397	1678	1	1	15738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmNKvzAcNFLS8gkxyqCW1UAe5Jzp6oFrTH8sZ2aHGmHn1QRxo
41690	payment	2133	2133	1874	1	1	5614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkN3f4mFgiGScZHo877UJd32TFVV6BU8imKeJR8G1dDNaNn8XS
41691	payment	2134	2134	1874	1	1	6047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NcmMyMb3nMy1HSVwYpVbqwb9qpi45XbBgsWBLEkGkNZcko7s
41704	payment	1397	1397	1678	1	1	15743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubNVDKDjMbXKvZZubdWgKKed62eE7nVWSSCunbCaXnaPm7KAw
41705	payment	2133	2133	1874	1	1	5619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwK3PqdowAirtRipwUQati5u49i5PJniUgpXvAiWJkrtLnfh4G
41706	payment	2134	2134	1874	1	1	6051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NGd3KnjeHQN9DdVYgX8GEqMFGhGdaZzpNZ8w3pmdSFzdPzuD
41717	payment	1397	1397	1678	1	1	15747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS25gQrt5Y4wXWbY4A4BRiWGXsJhrccn5ump399qGhA3kn5qDJ
41718	payment	2133	2133	1874	1	1	5623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZizp2wpQ1B6w5UhbLU1QHV6TVrSzbamFtauaEB4RNn1zdM1AF
41719	payment	2134	2134	1874	1	1	6055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuTUpZNJzTohPu3QDDLqz85FS9VGDako3uuP7UF2GJmc4VvrW
41720	payment	2132	2132	1874	1	1	1584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDT9qYmzpcpx2i6RJK85SA6NHBfrXkhFmxoHzR2HFxLgASwxh
41724	payment	1397	1397	1678	1	1	15749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYioMnNySqJzDCEuXNKwrPHuqcvpeLE3uyVTjf6mpJXXH3NepzF
41725	payment	1397	1397	1678	1	1	15750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr75P9Y2KLZ4TPz2dQ2ntVsTTK7DJkXhsUCb1yAUxtXHbKaQdv
41726	payment	1397	1397	1678	1	1	15751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8dz1muFTkyrLgLnhWib3qt1dihFNaKEmoCTbW1ukKKvj443S
41727	payment	2134	2134	1874	1	1	6057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9szXSR9KLp8xDVggxPAdZZRp5rRFeiJX8fBcUCfxHKxiC36e
41728	payment	2134	2134	1874	1	1	6058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7X2HCUhpXAwi8Dph21cU6Qw3umaEPSqgMpJTt7rgepQxTCUN
41729	payment	2134	2134	1874	1	1	6059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbZwNAcWxQMHVZmeXtWetY7pxb473Grx8LbYVzysfd1FwLe4F
41730	payment	2132	2132	1874	1	1	1585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDQq63gXnCnooj2mgPEt2W7Vh7opGHVdFoccDbPjNiphqvWou
41747	payment	1397	1397	1678	1	1	15759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKWknGbbpFPLyYxkTBFJE2FDLzvv4EVtCawSHMYgjYe69fGc4
41748	payment	2134	2134	1874	1	1	6067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmMRLCXNHwUosjN51C2Ws8PkWptNMmxnBgF5n1PE92d7a7uvX
41764	payment	1397	1397	1678	1	1	15766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqMnFY4c9dseo3k76orMydG6ejMe2KD9HazwEDQLaTRrDbr5b
41765	payment	1397	1397	1678	1	1	15767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcV8GXfW52sg9H5Sc2GC1YJCWUucoFKKmysMievZcHYYb56Coc
41766	payment	2134	2134	1874	1	1	6074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSHJFMZp4gwCsEoXaAai2HbxoqEf2S1m8TZ9Rq6hiY7yidy3B
41767	payment	2134	2134	1874	1	1	6075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRR3Rw9TCL7HKSC3SNaKY36xwv4jUYLy7sYc8MhzJeRe2oRKQ
41768	payment	2132	2132	1874	1	1	1590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7wMEm6VhXX2wabT7wFHdfExgvy9KZ3JhKk1hugHAmZEZzvu5
41769	payment	1397	1397	1678	1	1	15768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zMJw84VntPbaHYKQER9cx3doLFJrhEHEEgdz4HRcNvj5SxYw
41770	payment	1397	1397	1678	1	1	15769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdC9MZuTbL51EbpunvWXzZr4orCwmyxPu4ben5C2WNPTasgmtS
41606	payment	2133	2133	1874	1	1	5589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7Hvv8cmEh5fqQ9nEmFp4doGmpNwfbut2vJe6NohbQzeD91Sn
41607	payment	1397	1397	1678	1	1	15715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYmuvVNDAAQ53ha8dgQEdZ5CFgotSzSE2vkruD5QyZQ95mkSM
41608	payment	1397	1397	1678	1	1	15716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEqkXabVL688HhhYVFr6onX8nbEk1SrDBfnM474eu359bAh8N
41609	payment	1397	1397	1678	1	1	15717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uvgmwu282RBmZb2wKvYoKzGaFqY3YzBWeN8rvcCzNq7rxU37
41610	payment	1397	1397	1678	1	1	15718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLiMDNoPpyxgSpKgMddTMkvDhBJSWbG6C9sDPRgDqnRbGh9iV
41611	payment	2132	2132	1874	1	1	1574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fwqn2geQPaecVE8iSnEPszicdkRQHrckJ8NEQB4qA9WvWgu2
41612	payment	1726	1726	2343	1	1	8301	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCdRBPzv8uwmCJ7KcdP6KvSrCWajHQiqdPjbhJTmoRrQXhWJVN
41613	payment	2133	2133	1874	1	1	5590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwK8CzHV66TiNodYkXi1bhwpo1CYmr6TDdnZ5JkTtyyi3C9gK
41614	payment	2134	2134	1874	1	1	6023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUApuwQ1s1VgrL3N4XaKyir3Fhg27p8VP5Uh7ybHhdLzhTUiY
41615	payment	2134	2134	1874	1	1	6024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWPrf7TkvURMwTZo1vGyFtkWGigzCTokAcwVLDwz2j5wpfFYm
41616	payment	2134	2134	1874	1	1	6025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXw5Rc5XJZHeoFqWT8myMAnaps6fdZDVYjH6FdBftXjHaFBKgS
41617	payment	2134	2134	1874	1	1	6026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXARUxQ6HLnLuEsn2joeNTYp127TvW17pjjxrsmZznmeKg8QV
41618	payment	1726	1726	2344	1	1	8302	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm4vmnEXw5zLHxm7igpnRQXCzCLtfXMu166kAot1b1FU8KMgYE
41619	payment	2133	2133	1874	1	1	5591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsztN41d6gMFbG3xPceRKks8fGkH7f5Fw9YuSjvSrewcBJH7A2
41620	payment	1726	1726	2345	1	1	8303	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtFNfE29FCPqdMsqsQtPNpWMAHx3nN7SFz9pcQiyh1qQKf9Ehu
41621	payment	2132	2132	1874	1	1	1575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94B5RDsbiESo7t7vaoCB8b22NbFHN6hh9QuKGTrSfq2EBamFK
41622	payment	2133	2133	1874	1	1	5592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTDPEfdqZKvJz6zrx3FXUELLQKom2d8mrbU6rgx759irJar4M
41623	payment	2133	2133	1874	1	1	5593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPxkdce3Xfs2C9BzQxyRxSDam6mE2ZGUcwyQfvJqJF7UaSJSz
41633	payment	1397	1397	1678	1	1	15722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgModNLf6GNXTNR8HfxFMcQik9JuJDc8XomnLy7oYmBZvMyiX9
41634	payment	2134	2134	1874	1	1	6030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhc6nMoAtA3hXwfWGxxPJW41rgDYERfANf6irV2fpEU9pGmkBD
41635	payment	2133	2133	1874	1	1	5597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjZdmVtjrMDTmo5TCU3tQtwcyterpgLR9235NbxRWJ55UyvKo
41636	payment	2132	2132	1874	1	1	1576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uB2zwho9qNuvLkaJUeM2fUcv5kx7i9YHC1Fh89MdYaAxwReA
41637	payment	1397	1397	1678	1	1	15723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf88CBi478uvYWojxkVkTAoEwo953CKbRfou6Np5HBGZxNob3H
41638	payment	1397	1397	1678	1	1	15724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQaJyCfRcFcgtkQwUpf7PpS6EEzjhGao6hxK6niaHvpNJX4PV
41639	payment	1397	1397	1678	1	1	15725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1JnSW8wBA6RU2crQWpXcZsMPVpTaWsVr9dmNGvthvK7BKQxq
41640	payment	1397	1397	1678	1	1	15726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkmpuxbzCqvCvPoHAmXNzjfdV7uoLNEm2ktHwyh8GUECPKkGj
41641	payment	2133	2133	1874	1	1	5598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVRbiQQVpUr9ceDoVVciPrnxvWkHrVJ3YdrCoqb6xbtSyAZof
41642	payment	2133	2133	1874	1	1	5599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxcTR6Hw59j3WDGn7GqttthiwPEHZc1FMk5BdqAgMvZxr2y64
41643	payment	2132	2132	1874	1	1	1577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1MQXbVgmqyVqCXTD4rCqCFrJANTeLraLo6qYkR9ngxqT3zy1
41644	payment	2134	2134	1874	1	1	6031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtAP5JjaDjjTHuUEHDbNYwUHGqbFedTgWAfgnr2QEjMNhVSUk
41645	payment	2134	2134	1874	1	1	6032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSc676eXwraQ2ydYREmpiTxeNDAhH9wfp7TCWSn8jSv7dfNWKW
41646	payment	2134	2134	1874	1	1	6033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRYoF3jHiFgnGQS1qmzvbNz4p35NyCbGK94p3SWZFTR9FGcwn
41647	payment	2134	2134	1874	1	1	6034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv3v6B5oLGy3FgSNBHksNhaSVf4uJEY1QVq2q7Mn5sUA95zCWm
41648	payment	2133	2133	1874	1	1	5600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuQj8JSihZYDmik9P5r9vFbPsRgVhqUEFNfHKsb8SdMoncz5E
41649	payment	2133	2133	1874	1	1	5601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ie8B9GduvVnx9QuYrT4HT67LNyVRUdBQu7DWDYnJhXMZoAv5
41657	payment	1397	1397	1678	1	1	15729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcC1qa8DM85LASLPWgfd8yudvwqbQd3DfxCBRj6JCTXvAkJ1Wt
41658	payment	2134	2134	1874	1	1	6037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbu1jLHwmVrEFfT8Zp5ou6UkHBvsXNxF5aEYpJCYnjEeRRq9gb
41659	payment	2133	2133	1874	1	1	5604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmx3uWHLh7CDyd76LFPpHuAYi4qcsHhEokNNXCAsiqNN9pFkQm
41663	payment	1397	1397	1678	1	1	15731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsfMrTq95MXQ2VBhgZpfKot5C64qzB5PA33A2PnSnQqwYBHXY
41664	payment	2134	2134	1874	1	1	6039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPU9M8akEGqKYbujF6nfk3exGpR7F7ABLfhGioJmjkCguZZMg2
41665	payment	2133	2133	1874	1	1	5606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwuSpfN22sytYdnuUGJBcvwwY23TdGDngFdDtM4BeeK1dt3qy
41672	payment	1397	1397	1678	1	1	15733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KqVFJS1NLs4G8XggmZSUKuVdQQ8tbDQesvFBgkdCBkPhFnUj
41673	payment	1397	1397	1678	1	1	15734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvACeBAJTLGGsw935da9JNinSugxSHDtchqExukVGThHNHTkN
41674	payment	2133	2133	1874	1	1	5609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaekN8JomLCsrEKowsjMfik9SDnRgaQ5AkVeKJi4pwmZCfZPUe
41675	payment	2133	2133	1874	1	1	5610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dKvuw6Ryoo6zXNE6ZUwHJKZ6cGKMPSk4C5mbvjftNyieQEnG
41676	payment	2132	2132	1874	1	1	1580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUQfXm3SG7X1zuD1VDHz7QwdXBwpuoJfxBpBtex7DP5T9H2Je
41677	payment	2134	2134	1874	1	1	6042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqpDCwhw6tzCe8QBTdKM6WJSRqCF1RsHY5uVgqofKKDPoLEH9
41678	payment	2134	2134	1874	1	1	6043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBxz6rgRFUyQdpDHkSUiRYQJagxcJZ4dZj4qj8GonpbZzDkZK
41679	payment	1397	1397	1678	1	1	15735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRTurM1zgwz7aBRvKejk2X23KqHAAni378182i4cieJwBwkuH
41680	payment	2133	2133	1874	1	1	5611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNB9LagrTLxhRgPAXnciWARB1BaVHWkqmsNhu3E1mJxDazfbrm
41681	payment	2134	2134	1874	1	1	6044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHqbdwb4U3EYBPAMzqAMSkfZp2Au9gWuR5HgBSaWfVShApBpM
41692	payment	1397	1397	1678	1	1	15739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3ZaHvZAb7gqyTRxACXBWxKCuzaXXMWbjgYkSXUJmatPmgpAK
41693	payment	2134	2134	1874	1	1	6048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZeHum9PrYu67wzgufScfVPxt3qTVAPMtrbHFZ3HugP1MCtTX
41694	payment	2133	2133	1874	1	1	5615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SAkMQ8cFidCrtvXZKXzntQyantA4uXFjCGvfH1hhfVD7Xutw
41702	payment	1397	1397	1678	1	1	15742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagE7qpc1wKMB9RiJXzTAuUEyTjFwqD8bAcic8tzgtW2Xbpoqw
41703	payment	2133	2133	1874	1	1	5618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRVw5Xi3HP9MXyqNL3M1iuuCuTfiEvtwrsqMz3GNFdYkzLk5Z
41711	payment	1397	1397	1678	1	1	15745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MiTmDL8YocWMDJCpqhnuajQGBR8aSfLsFqVJZZVHhMfpqvqS
41712	payment	1397	1397	1678	1	1	15746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjvpJzFn3EEGKZK3gaCyGUZ8fDwuw6VvoVkwHPXsqsdv23mB3
41713	payment	2134	2134	1874	1	1	6053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5nFUJu6zkuVGfYkrBmfBVNe1fh5GLB35b62tNYwWyycFeKjR
41714	payment	2134	2134	1874	1	1	6054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxxsrNkzijjtsfi9seYGFDfcuXEyxPN9cws7YiEBL12asLmUd
41715	payment	2133	2133	1874	1	1	5621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hp9zoBY89tU8W4hSKwvpLBgkTCcv1HWmEPCSUYuxoQQXVHZS
41716	payment	2133	2133	1874	1	1	5622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9DqLpzVr1xoV5kpe35sXBGmZcGHLKbYwAxmszVLYqJfoqYVS
41745	payment	1397	1397	1678	1	1	15758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUX9CPZ2xPWTVPz9FGZnfLofyLtAZH18yHJu2MeEy8NS9Luu4
41746	payment	2134	2134	1874	1	1	6066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuzCkx8ctcgap1sSeWUPpKQDzB57iZKSB2vt5fsiUpdw3HsJR
41789	payment	1397	1397	1678	1	1	15777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV3NuYfTSvdzwaMK5BfncrT5QSXrafaj2dGPXiJrjtbQADmJb
41790	payment	2134	2134	1874	1	1	6085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLxg5XZ6nrNrRm99mhMwh9JkKXbiz7iczni5abShQfA5EcvvA
41791	payment	2132	2132	1874	1	1	1593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiQtrwBk16RSZad48AUCsH3spPNQpRovxQ4p3EsBEEJBE7hn4
41801	payment	1397	1397	1678	1	1	15782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNtXHpiRknfjBq1jSRyRwUYLahH7iA48hDxcU2HMK2s5t3Ftb
41802	payment	2134	2134	1874	1	1	6090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnvpgYeKM4u66RxmV7vMKvSbwq11Arfk5EcK92UMx9oEvFdjoC
41808	payment	2134	2134	1874	1	1	6092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEB51VgMBTo1DkVDWqjECGM2hdo68qbLvPmLVKYoxwNebdUru
41809	payment	2134	2134	1874	1	1	6093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPThTuAS423j7Pj975xEfN6TwJ6XgqGvo6Ne3yuBMdtzDLsAn
41826	payment	1397	1397	1678	1	1	15793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoL4CXXLGw8Rc6Gkt3GPkw5ux9PcsqhMwXbW4F6ado31Z9mSAs
41827	payment	2134	2134	1874	1	1	6101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntqUA3Bwn9CFWAyQCgpY2qCssPoTe1Xw2HqNXsoZPUPvYJ81X
41850	payment	1397	1397	1678	1	1	15803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoz3pRgu167pNUWNvkjoCNVUkBBrAjnwNRZHnSRbWh56qx4Bcz
41851	payment	2134	2134	1874	1	1	6112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTST4y5AUck32xHWk1BF391jtRc5xEptzYGzWEtLa8HwctHjB
41852	payment	2132	2132	1874	1	1	1601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoC6U8mEvqZ5hmDkqF3FFgxBQ3pDhps7hN6zyPa4Gre4vzw6L
41666	payment	1397	1397	1678	1	1	15732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5i3BBxtXDjKAtC56QRH95tnemYKX1yckKjyJKmBFDmU3AX4J
41667	payment	2133	2133	1874	1	1	5607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrKrLqZwoCt8JzRKYfzoA8WsvMMpL4koM41a2S31Tiw9zBNTf
41668	payment	2133	2133	1874	1	1	5608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4CuNdzD6hJgUGZh6Bfr8QQK2vaAbP2tLa7nq8UTwks5UM7xD
41669	payment	2134	2134	1874	1	1	6040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS88CZhpE8AkvXaBEGzhbJphF3tzJmjyFymjwgqdoTpydRVf4
41670	payment	2134	2134	1874	1	1	6041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aBeWtt1LNrof6kyiuKcYv4EcDqU8cdzaWM186KHQqgpkZEAH
41671	payment	2132	2132	1874	1	1	1579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXWQoK7mFikWmRE4NvhWQQmncxCMwWPKcYyUHWP7fynnA4SVw
41695	payment	1397	1397	1678	1	1	15740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqfyHZQVHQzYRPdzUJbpzpHRYSTjSq8VGG7x7W3jSEn1TG3E6
41696	payment	2134	2134	1874	1	1	6049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4HY8noB8nytrjS39e84ePbPkwX7DyGMiGtZb6WX4fjCmdus2
41697	payment	2133	2133	1874	1	1	5616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhVd6GxWcpSArPoMhywF7d9t3Ct1hFUMVc98q6A99Jc6nq3yA
41698	payment	1397	1397	1678	1	1	15741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC52xGEfxY8DthYCAXem283eLWqbtqFi1WqWH5UJybbSD6fpFb
41699	payment	2132	2132	1874	1	1	1582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtRi69cnDqbsjmvqPFZFZMu83Af1ui2LvsaTViLjgMUvBGpyM
41700	payment	2134	2134	1874	1	1	6050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCxRpqzQMd6Utxe3AJKayiVyTg4RZe3dMn5jcS1vL6vVb7cjK
41701	payment	2133	2133	1874	1	1	5617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFDLRfoJGoGDh2CWG6YmBiTXTj66SxykQTQVvfjmXcp3ijNp7
41707	payment	1397	1397	1678	1	1	15744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaPq4jnQHZqd2t9bZj8VDvYWL8zvqHgRUffQcLi7Ykm7guH45
41708	payment	2132	2132	1874	1	1	1583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg3pj62Cdk6dpcj1gyCFJsyDzRCbeFsd6JkCnshe2xfwYrZ3W
41709	payment	2133	2133	1874	1	1	5620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CvJVyBwibUP6zAN9dqFa5f2DnNUA57FhLYP5XYYsxx3ViTwt
41710	payment	2134	2134	1874	1	1	6052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jXHGj9m7vvRBUhvQYxbPGYPqNuq3NZjj7nxuL5JWS5K7mZqz
41721	payment	1397	1397	1678	1	1	15748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6gKbTVstkjfng5SaZ3kdRphG6H3bPB8BqSU3VVbjU8okfSAP
41722	payment	2133	2133	1874	1	1	5624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsfmN9KBfxozHAXxvPyXAM6Dnnc2kktbgGMHea96W4JkErZSx
41723	payment	2134	2134	1874	1	1	6056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNdfZ4aEGJPMTGHiBiHoCYo3ApxtzWzbu8a7AX5NCjMSHur58
41742	payment	1397	1397	1678	1	1	15757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhPkFUfzE84LSHcVvresABKkbgqa6ebPYW1SqAJvjXLxvLGoR
41743	payment	2134	2134	1874	1	1	6065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWtoE2Dc23SFf6NhKzf9yEMNRZ2GHT5Mcec5hkpbZiz9TkDTJ
41744	payment	2132	2132	1874	1	1	1587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoEkQ3WKnFk81Gi2XBQThv6rzTBowrRTB8ruxA8DQxWTXuVxe
41762	payment	1397	1397	1678	1	1	15765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Rb8QU9hHDhbmZbsesDpjCnPhtvWq9znuFfe3KsLWtesGmGGS
41763	payment	2134	2134	1874	1	1	6073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8e8yVsEJoZpbnLN8C458YWDv1G4FBzViUty5qftNc69HfFKr
41775	payment	1397	1397	1678	1	1	15771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99h1afo1j6WKu4syewwBQS7avtqn3YCUXXShTtNdZfvXe2mgF
41776	payment	1397	1397	1678	1	1	15772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8h1LJaAemTp8WQeaHEN1iPxMA4G87WBCZzJGXLCgHki5Mwdf
41777	payment	2132	2132	1874	1	1	1591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3WnWWxHPFuf8kKzBsrjUGy3mgCHPtdJbWCzhG2YwXSVBa8N9
41778	payment	2134	2134	1874	1	1	6079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQ8LCwzakwcrmPC5cMossNCEWZD6ik6HcgUUxv4jRJp7RMYik
41779	payment	2134	2134	1874	1	1	6080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZStsh7AXfg9rUzc4wSu2n8pjwDdy74jKDhuRN3A3uXaZ5XmGt
41810	payment	1397	1397	1678	1	1	15786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzuPwZvifCQ4TyDPZwHRK3SNKBqHH1x1SuoBQCNZbNTUBKGzQ
41811	payment	2134	2134	1874	1	1	6094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNkkykQVMSSFj7oDSNczrhrf6xmFFqJmELaN6b4VptMD7BwHK
41819	payment	1397	1397	1678	1	1	15790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWEmRv9g3ywMcGjsKJYSGwCEk5Bgvhd1K1psnyxVboa3n4h9f9
41820	payment	2134	2134	1874	1	1	6098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcegcCzjS3KNDPeZHsNMDgXvtop9PZNnbC3k3kwV51gKT9shRH
41821	payment	1397	1397	1678	1	1	15791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmo8hZVpcs8P6PaibZUtzujVCV4rVJLtSrcgrt1NQH2KFwvDN
41822	payment	1397	1397	1678	1	1	15792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZvJJJsiDSHjLsXacgWpU1kpfGBUsZt4monRKc1mPH6pc46NL
41823	payment	2134	2134	1874	1	1	6099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUckWQs7RdsRfcYpsJBxcoqoe2TxQ2Y4TmUCYnDsst3pULcsRv
41824	payment	2132	2132	1874	1	1	1597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPoVLxTTBbDUbynuwxjQgJo7E3A3d32M8nbBS54FXtAB9gTYG
41740	payment	2134	2134	1874	1	1	6063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JBmAEfSsCtKTmwj3XGgQRJ9pi62FXNdejJKMQTWVHgoH86A1
41741	payment	2134	2134	1874	1	1	6064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjrFVTx8zgdsDjqwnXAZ5MwsSfXnwc7s6LCeHVz1sE39Jvqdz
41749	payment	1397	1397	1678	1	1	15760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs14vrrL7SKV3CZhp3gW24aWDDiwxjD9pzafDRtSvCCMDkuTej
41750	payment	2134	2134	1874	1	1	6068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5TjuiiETvdoiUtBDM3DYFiZYhGwBdMUwyXdXV2ZX4PpGZ3XQ
41751	payment	1397	1397	1678	1	1	15761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2MikxEbeqNLuj6idXThj7xnfnhyHiL3hyR7Jjkj9vp3Bvcye
41752	payment	1397	1397	1678	1	1	15762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6T1XM2uPK4CrLpmeXfANVV71H3BzPcMsLUDwdsM1GSBT5Y24j
41753	payment	1397	1397	1678	1	1	15763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJMEjE5HR39a4MwvXStRm1AhzHiR7ckZfp6RKmCz67WgFnrR4
41754	payment	1397	1397	1678	1	1	15764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9j8VppAdEBDvWdvUiwLHoTJp7TNJRJBprMFjjAVoqosVVyVb
41755	payment	2132	2132	1874	1	1	1588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbTqqq1JzBjWdtWmBtC7LxBZNEmqQnKhQa1b7PEPuABzWak7TN
41756	payment	2132	2132	1874	1	1	1589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeU9oesmHgkXRs7AATVMKEUSLgKGcdkTJdFE1rbkDPesHvhUCq
41757	payment	2134	2134	1874	1	1	6069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh97JEURT6V4f2cb33W6VZ29hTnuThqiA27kXnxqYnTuh3yo2T
41758	payment	2134	2134	1874	1	1	6070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyNSYLr7myvGHJhyYJVPd8bQHSpj1cbfBbqKtowyB7UPkLn3R
41759	payment	2134	2134	1874	1	1	6071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPh5uQXxUL3tU65hybCxJNPdxsimP2rijmFeeoR2RoHiRVQVzd
41760	payment	2134	2134	1874	1	1	6072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1agMPDUMF5B1vNwx7w3s8xQZg1wNwoWbU63BUHw2X4RAdzJdR
41761	payment	531	531	1681	1	1	0	683260448682	1000000	\N	E4YeQrG6kS6kyMvXAqguD1aZaKYBMWSMeqMZs2nVu5aGFWqfJTA7d	CkpaDa6u461wTAjcgUAstuc1Us2Mjue4RbYdVj835fWZD8VTzDAJh
41780	payment	1397	1397	1678	1	1	15773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoPpim37tLDEHbD1QyvXLmGiEyk1dh1grSNNuShvZA2ess7y4
41781	payment	2134	2134	1874	1	1	6081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzdJrKv6yYjfhjnpqRgom93zNbQc4yS6dnwxg3E6H2HTYgJgK
41792	payment	1397	1397	1678	1	1	15778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3f6nz47pdo7wNKxjY82dGdQva1iFeubKCpd7DB8oSr9KMqXEz
41793	payment	1397	1397	1678	1	1	15779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkEyrcoEWQPxfLoUdPRotXzyYKro5jFji7vtsdJmPaX5t3EoC
41794	payment	2134	2134	1874	1	1	6086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ysyvVRzhMvsnPAQtmzjepXPrvNQYxMYotQb8TqyteD9F94aY
41795	payment	2134	2134	1874	1	1	6087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKDLACUQsPSxpewTutBJiRiA7SKMvoGMRQ76ycbvFJPhXCnfp
41803	payment	1397	1397	1678	1	1	15783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX11K26onbmD6NNv6GSkrL8xrwMryjfqD9Hrbhqzj2T3avBKqW
41804	payment	2134	2134	1874	1	1	6091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueJ8pk7KPVhWrwiyewBPVxnsj8fpTnfiWhbAkN4jkD4exBGLf
41812	payment	1397	1397	1678	1	1	15787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKj4GuFpJYqfXET1H6BTTyEuGRseT9FcTT1ZTjR9fPFLn5Botj
41813	payment	2134	2134	1874	1	1	6095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBJphcM2DzjBF5t7btxaTMKaEGix2T26kwDFgRUBBv2xHinep
41814	payment	2132	2132	1874	1	1	1596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhXq8Bx9NrF9HE65f3CTvduuZJEFzcWs4bM1n7k2TGRdJSddV
41831	payment	2134	2134	1874	1	1	6103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZS25sijbz2e69YLJdictAQvt9F4h3kd34NA19MT6Xuy538kH
41857	payment	1397	1397	1678	1	1	15806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkCDZeB72tkNzMgHo3nTTmkZ3MpwoKwsWH6iWNZXvSUr5SkWc
41858	payment	2132	2132	1874	1	1	1602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmH93C2AVwaM1gE15tf4DQX4zoeRLbQJsxtoiWk98TB36dvDS
41859	payment	2134	2134	1874	1	1	6115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC77n7GcW4n8WmiivKZb2XLSSH5uYmBBe3hk7T1VYPRNMF6N5n
41873	payment	1397	1397	1678	1	1	15813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa42TuKxY763ezLX2eDFWaPR2Qx3g6tojordmu4MGgAEJEbUWL
41874	payment	1397	1397	1678	1	1	15814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgvkxwYW4fzkamn17dD9QGrFcURrPhy1VYjgFkknAenS8vbqM
41875	payment	2132	2132	1874	1	1	1604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPLthAJmkASUH1PVqzMbVQz1BFLWokBfGyfEnsa1LAooSzi3Y
41915	payment	1397	1397	1678	1	1	15825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsPjehj7UNrrgRA24qSqxn5mS61T7kHBWabTaDTXPcs6o5vJk
41916	payment	2133	2133	1874	1	1	5635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWUoCbHCr9vg2LNPuARaThiESK7MTTyTVtqPXLySwxPUVp2D1
41917	payment	2134	2134	1874	1	1	6134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rx4Zcju8zECvu3RcghuXt5eUrP4uvoyT8dSqRhfD75Jb7HDP
41961	payment	1397	1397	1678	1	1	15839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX2MDKeMS5TgWYwWocnXYXLTjXZaNT7GebPNHv26qUbwpy1NR
41962	payment	2134	2134	1874	1	1	6148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkK2bkA9fAy7Tuod5UPXBGkuUw4qWR2w4N9KTRk39iJ9P9bEV
41771	payment	1397	1397	1678	1	1	15770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf13wZMRAjCdo4jyWCDejoMkVVGm5hsSPFf5cXBpeR7gT4onpZ
41772	payment	2134	2134	1874	1	1	6076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzNbjC24PGcQD2NYg7nLRtVWZUrwMeHKpfB2NMKCPmWy2KSmP
41773	payment	2134	2134	1874	1	1	6077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnM8M46SoR6eGRqN1426yoDRwkxBvCadUNa3irCrTrEAYCXsY
41774	payment	2134	2134	1874	1	1	6078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTmeoyCD4FkfCVx4QF9yTHp4iPxze11h49mkm25iY9gGHom2r
41782	payment	1397	1397	1678	1	1	15774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjjeiyyhAsc7S9HSo4t39LrYMyXCDpfNiiQfKC8MWCEzY6XaW
41783	payment	2132	2132	1874	1	1	1592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4wsZweBZJravfTesox1GgTjA3tCiFtNGrwWTbQ4yVJQBPxcW
41784	payment	2134	2134	1874	1	1	6082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTrveQjaZoq4sDat17NRZqoiwcrcJT37NA6pjyCcCnmzjyvwv
41785	payment	1397	1397	1678	1	1	15775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmM3UpPju9jBWdWsbyA3d1bfUYtMbuZ29ujyqPfL1KYqeKiZe
41786	payment	1397	1397	1678	1	1	15776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5LWFe9JjbayeRf1tNTVRQwEumnhDySrdyzRsfjgeofEgNFLR
41787	payment	2134	2134	1874	1	1	6083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8B44et5rkzM7WBFXNKzrc3XTKb5aFRq8nxqMh2MQGQP9rAjjR
41788	payment	2134	2134	1874	1	1	6084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGV3VGiaSiyP9MMRC2Db5WdfJAT92kQf8Qes8KBjhtm45vzTVT
41796	payment	1397	1397	1678	1	1	15780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgUafkUSRv1ByfoV9TGABpD7LGA8bEJLrH5KF4n2pcRSC45Yg
41797	payment	1397	1397	1678	1	1	15781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVGAjizkLkGZr4wAkjaEzKpsPSyA2bDBJDF8Eoxy5whVhjYa4
41798	payment	2134	2134	1874	1	1	6088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqTsambshjws2ub9YVNdJSwxpPP8gfLDz1TdpFnt74XjA5cfc
41799	payment	2134	2134	1874	1	1	6089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdywCJRBh6Dy5CHNrJGqR9GQqpkcneazRKf5mB2eTmsMwH3HKq
41800	payment	2132	2132	1874	1	1	1594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uw7ksvwsSBGg2Hfd7US7skucHg5LJZuU4Qn39pfhjxLe3Pws
41805	payment	1397	1397	1678	1	1	15784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKDZVKc48HkH4nD99E7euJLaTVPL7rTxW19Z5x3KzdsJZxY9N
41806	payment	1397	1397	1678	1	1	15785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYezy7jeYbVXbPtKyCW81TwKEzjxCLgH8hRpuvdA2TpHPDJ119
41807	payment	2132	2132	1874	1	1	1595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEK2KnGFcFY8HfpFcHZC6ym3SVRc7hgdT5q5drUydnyHSX58o
41815	payment	1397	1397	1678	1	1	15788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE2XpeaLZCMiqX6kqq2pYXdL6f85dXnreY655QAuQekENpPER
41816	payment	1397	1397	1678	1	1	15789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJmETvs9peRiDEG5gbE3RhkMu4RbDfm2zDfncXDYi8jVpqSCw
41817	payment	2134	2134	1874	1	1	6096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBTScJCsjcsKL8mo1jvMhir2Jk4jBfNXjVnFHQzEja93EMc34
41818	payment	2134	2134	1874	1	1	6097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9m2duu3jNzrpZTrXqjEjshmWzLohXV57tqNoS3mA7PGBHWAY
41841	payment	1397	1397	1678	1	1	15799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQryYHhVbYUQhfv9ZtpdZDTgL1ZQty9eVdqnHcGD7MZy7gp6N
41842	payment	2134	2134	1874	1	1	6108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPtcJPA6Qps1mGJCqe67kT7WfXkFtP9AMLNLvqszkrTgE97Jh
41853	payment	1397	1397	1678	1	1	15804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3Vke9DBuoeCirw4nNMcqoDTHVucuAVnb1gf31MCosSPHB29e
41854	payment	2134	2134	1874	1	1	6113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cKTQnqYwqsu3KCcMKAjdiYs8AMpKn1ZhCYPZdoFJ456RzZqG
41876	payment	2134	2134	1874	1	1	6122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDDYHLtUiUMthh9J9k4vfhKc98bgTTH9xixxiyndx9GjdCT7k
41877	payment	2134	2134	1874	1	1	6123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgUZPLUgcjFUV7QoXj1vGqKyAywDicZXEeMHfGynn9serqwVt
41882	payment	1397	1397	1678	1	1	15816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxw4mkUm4LWWeGPGmSsrRgcZeAHbE9hCWNLaUCkZtXhRoiMRK
41883	payment	2134	2134	1874	1	1	6125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsVsg3aYp2N7Jtu5KtgTBR5jVaqTXovFp949frtN7WRfBpRz6
41884	payment	1726	1726	2347	1	1	8305	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZP9YrTouqAF64xwZSMka8hTwihL7JXDiKV2fRMkxGLWioVYDvC
41885	payment	2338	2338	2346	1	1	0	90000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5wgQk23GwcErbiYJ3XMgHvrbdEy9K7TJLPXhAwwsemRzNioe
41886	payment	2132	2132	1874	1	1	1605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysbXFdhi4Xj7qTioCbFB5h4KusXhpffUhWWtYb3UDCnNn8dX6
41887	payment	2133	2133	1874	1	1	5626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWrQVxb7f167SCttd9dD7npT3VucJnzihzHY72ergfaEddbaS
41908	payment	1397	1397	1678	1	1	15823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZf6f7JHSDW72xqCJmFKRhiXd6WjrGmQ3unxMLkRtvREvWu4r
41909	payment	2132	2132	1874	1	1	1607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4tEH8vJGGF16UfHZu3RwZXp4V8CHcXYpcfiqL3kP5AJ8aUhy
41910	payment	2133	2133	1874	1	1	5633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ft3q2gms2mcyj4k3iazw5bbFpCotut1NyNdBrHj2AMY1KY3d
41825	payment	2134	2134	1874	1	1	6100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zt1SLyfmtcRGC4SDWTm6yqQPg66q7aeocCqYtXJrXwzkCsfu
41828	payment	1397	1397	1678	1	1	15794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpYZgH5RVBkwU9P1xAGfcLMpWzJBNbkU7nMjpcj9dRcGzwXW2
41829	payment	2132	2132	1874	1	1	1598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TaHB8JUTfcdyFnNpqTBpz5SiKFrGVrsiNCpLsR919KBTHKdr
41830	payment	2134	2134	1874	1	1	6102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAMAsp7dpVLtvAuTF95Z7hpu4ztam9MtrJenWFceifV82X2KT
41832	payment	1397	1397	1678	1	1	15795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnMVekkKVRQgjPE37YzhVwGA9nWdLVyWdj5Z8WrAzuCjpHF2F
41833	payment	1397	1397	1678	1	1	15796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaTu61A7TaC9SH5Bd8ED7D7WK4pXq6wdTk8hoKj6THGJTw9gz
41834	payment	1397	1397	1678	1	1	15797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimHSr2iseJF5ua6mExX1WnSpec1z1LBsqS5wT3cCsrSd93yAy
41835	payment	2134	2134	1874	1	1	6104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmp3AJcKo8qeCxmNxwzrRFUR6yoqy3EruAJnEk3xZ7bU43kqE
41836	payment	2132	2132	1874	1	1	1599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYasxJv7UUXFQRYPDb1YxXU78eQunwDpvNmEEmS6pbRy1oK3WYz
41837	payment	2134	2134	1874	1	1	6105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TsRcAgHKS8fFBPwrLHtoGmUNGib9Tqgqesxwrq15gRyNPk8J
41838	payment	2134	2134	1874	1	1	6106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGs6BxwYCRgAj2bRUwtxBvkHzWF2usqDFiTBWaryq9k2e6nocF
41839	payment	1397	1397	1678	1	1	15798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrmxcv478DsUmy9Nhx9Ne7h1Qvfempsz6zLWCutttVUfEUGb4
41840	payment	2134	2134	1874	1	1	6107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEq8UrhsGQzP7QmhwhGmHFikjcYor6L3W9fR7Dkn94EEB7api
41843	payment	1397	1397	1678	1	1	15800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvb6e9fPUJYVxTtVMhEUmCNkECEbjZEebyXoMZhtH8Uh7c17r
41844	payment	1397	1397	1678	1	1	15801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUaujkoN8Nowv2Chy7MgSZc5kHMuP9paRSzovUuQzwXvcG9od
41845	payment	1397	1397	1678	1	1	15802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBvTxgSwjA7KLEsMqZ8Qc54RHPJoHsd58rXs8SVUuqXrso4aa
41846	payment	2134	2134	1874	1	1	6109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMjMvjaCFwQfjujkk7meF7KViWFGugkFhQktpnFhgB8qFmVt4
41847	payment	2132	2132	1874	1	1	1600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9TL48ASE5bSdJxhVwX1XMGWJMAg7yNKiegdfXFvtt68fHJLn
41848	payment	2134	2134	1874	1	1	6110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9c4VvyvpL7Mm9Vue8nJ4jdyahRcMjsFThSqzF423SNRnmEejM
41849	payment	2134	2134	1874	1	1	6111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFDGr5JvuLHVsJ9Ec64pT4RXEymL3ZLme8r2zxVn23a6Gh8ou
41855	payment	1397	1397	1678	1	1	15805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgyHwztsQMAN94ee2JBCehkjpCGZDesyBC42wC9et6f165RTqU
41856	payment	2134	2134	1874	1	1	6114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQKbKTeqhCNLaGhJGcGGhPz9NvKTUj4iLfV2hpDCdpHqBAqZj
41862	payment	1397	1397	1678	1	1	15808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9ZhBpV5MVy3u7EgGAuG8ZPgrPeiXFMc3Y8zePtNfGsmysWqM
41863	payment	1397	1397	1678	1	1	15809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVAU8fUxPJdJXzTHSMjtC4YTc7f2zCuzPphtE8Pg4bNYgo9Yy
41864	payment	1397	1397	1678	1	1	15810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QXuSkCzDEznYAQgRHRZ7EUtJELDhZ2J1EDtTjTmwH9N2FFSQ
41865	payment	2134	2134	1874	1	1	6117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGCaERyXBbTbjxXdmEadzWGxmVmWa1Wdi8iFR58GLe2DNA8U5
41866	payment	2134	2134	1874	1	1	6118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uSve9K9KKhd72VAoWjTPCz5hMpsMKYyMdQtbp4QyLnnXEiCi
41867	payment	2134	2134	1874	1	1	6119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmGfcGwgUanhmwRN51pcPjo6tKcfdvyuwvdNy6VmRkCSTb6xX
41868	payment	2132	2132	1874	1	1	1603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4bjKf2X1QKu9S25DZSTfVGLKqvLFY3iHetxrJnxgBVZMbzJG
41888	payment	1397	1397	1678	1	1	15817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzepheTksAqbzaL2ACiW3m8kGLbNG7UqotHzLpJV3TKNXppmSe
41889	payment	1397	1397	1678	1	1	15818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBayZXcGCPZvHv9Lvi6RfNtAT4htDn2EAUdRVcqKCBvraRKRyY
41890	payment	2134	2134	1874	1	1	6126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXZbfdQNYg2uz81TFvPCB4DgNifSP16f26RAZtDqq6Stna4jW
41891	payment	2133	2133	1874	1	1	5627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvQVpq3WMD9DcmqeCW61wFs6BkCHCSLAnHT98XTGdjYrBAhno
41892	payment	2134	2134	1874	1	1	6127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sgxHJJs7RuiFAJxwQq8HeLnf517dNvoSfovyYDLg43dTQmTa
41893	payment	2133	2133	1874	1	1	5628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5w4RtbKuUhznPJ2e2NM8bkqDejnYHCc5DCmzqdCxfxmAPNDct
41902	payment	1397	1397	1678	1	1	15821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmxmXL3e23rnvFypFUmGZVSzRx4JQHAGS2MgYkUuEtnWiztif
41903	payment	2134	2134	1874	1	1	6130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcV1Ubfs7sYBgJvRjfc17pKT15sCGHGB3TLUCwjMVCj44MXVa
41904	payment	2133	2133	1874	1	1	5631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcGBMDeNFqpHkTyFmzNWGgvfm3uqATC6wXsXLXBwxvhD7XDeo
41860	payment	1397	1397	1678	1	1	15807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLC3u5W8jWnUkghoUBCpWdDkTa4vZhQF8rqdFqFdKNRkHCWLLV
41861	payment	2134	2134	1874	1	1	6116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4x1U1JYfepcymX2vNLRV6CerDKWfV2QJJKfhp2qEvbbCkh4Lt
41869	payment	1397	1397	1678	1	1	15811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEg2qFuuMEWhhvVTpeWrh2v2aPKu9ewvG5Phojba6dpSMFsdid
41870	payment	1397	1397	1678	1	1	15812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsNb5scR6F6DGL9yNybwmyFZ35TNsgQDRpkYuJ5b9zXbafKG4
41871	payment	2134	2134	1874	1	1	6120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn85Xdo4R4fSxK9umMZ8JhBgjBpXesZNeUULHAijUBysZdQrTE
41872	payment	2134	2134	1874	1	1	6121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tH2743tAMBV64fci83ZQbLKVhWZzv6xZEFzC5dzovw9yaotp
41878	payment	1397	1397	1678	1	1	15815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJN31vivcxnR6ifdYns3D2rz2qDeDAMLqh8YiK5AnH5vt9XjS
41879	payment	2133	2133	1874	1	1	5625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5AisSsC1yAcJ8vuqnqBXwXHbv2hx2ANg24fi4fcB8dg7xXke
41880	payment	2134	2134	1874	1	1	6124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ25fGMS4FNYoW3V5UBnpUTqiTUHF82biVumkBjzbGWSrw1Ynz
41881	payment	1726	1726	2346	1	1	8304	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa5cRa3RRVLK89weSgVVofcJGiXztSuvK4MSVjnqvk8p1bwXU7Z
41894	payment	1397	1397	1678	1	1	15819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoTS37Vt9VixU2X7yqfW7GZ4xR4pB65zm18L49XjwZHUVZJ13N
41895	payment	1397	1397	1678	1	1	15820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFEzthLWMu9Lgr1JEb42uPBNMUH7vovsTHL3Qb4gHAvq8fWmr
41896	payment	1726	1726	2348	1	1	8306	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeLjdYrseqCQ6bDzDaATFQsrvyLZdspJ4x6khjqVeueLMvt1Fj
41897	payment	2132	2132	1874	1	1	1606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonbaKbLu1HKvwp8TsytRKKB4KsAyvT7UQkfF6U2PKga3aL45A
41898	payment	2134	2134	1874	1	1	6128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VHF6HDN6WbpUVpMjtQRATevz38CzxF61aN7tfH4hka5pV6x1
41899	payment	2133	2133	1874	1	1	5629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9igjyMbQ8LkBkc7VDQWbbwtYX7oajdfNgXURQWp8tvhYgKWz8
41900	payment	2133	2133	1874	1	1	5630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHQpY5Y293rBNJ4JMAymXfoTg25dMJBPe6sVv7rT4QB1jdo9M
41901	payment	2134	2134	1874	1	1	6129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTMa2jTyid5zxJAGuYvJS1QakCApFZk8Seh1nCYenrN5QpU1d
41912	payment	1397	1397	1678	1	1	15824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRjVVVWsZ58N6e7Qa8VujJt6AjdHP6cEYUoyPVqgTJBgbAUHJ
41913	payment	2134	2134	1874	1	1	6133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wdNd2BrMKijV3MQPFGYv4dTEkJcEjj1vhhwBjXUZkrCi9Lws
41914	payment	2133	2133	1874	1	1	5634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8g4MfaMVNSweeqDJ7T2h6bQVZ35C5tw6Sex7g2bZ8XJ1To2K8
41931	payment	1397	1397	1678	1	1	15830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbuGrwCv4XnmxT4J1244UTHu6gnLt5WbJLw5D8aStcQzMBuq7
41932	payment	1397	1397	1678	1	1	15831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZ9dKUAmi8pg698NZ1rAGeNbNZVmRrh6fzLC31wy88yzbcnyv
41933	payment	2133	2133	1874	1	1	5640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPyaCNHKowAc8aRpYgqu9WeT2avRrFib4aWkKtA4n5S8v5JXk
41934	payment	2133	2133	1874	1	1	5641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwp25Yi3KGzBPw6vi1cJniqwnJXbeN8j9DpGMCM1CjdjvMtNTB
41935	payment	2132	2132	1874	1	1	1609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qc4xHmXmQVVm44c7qX7C77BiGppCYdP6ypV3eL3DQQWvhYHJ
41936	payment	2134	2134	1874	1	1	6139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrSCrw8Kdms5UaDpCZH2Qh5zSKEHA7ovR9SQN3EmgnBqoGKoa
41937	payment	2134	2134	1874	1	1	6140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtwfdEdrLi7QfbSB5g8A3BMPGTeUYKn4n1GnNCLxZMXt7F4MA
41938	payment	1397	1397	1678	1	1	15832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkivHhxmQPnK2iPHkHgaQjPBbAUMdovsrqKVAJRUWNQMYpdK76
41939	payment	1397	1397	1678	1	1	15833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsvhLwEX9zTVjJvNW4Xn94e8qTpRgEnr6D4fDcyZVMYbEWy2m
41940	payment	2132	2132	1874	1	1	1610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYKhaDV6ScWeX7CU4oY6fU9nveudN3fcu3WL2oeVcCx41JZ2s
41941	payment	2133	2133	1874	1	1	5642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2f788WFffmzMxATNLcdQ7jq6hXEz2TjPHSyAMthGpGYTw55G
41942	payment	2133	2133	1874	1	1	5643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN54vUpGZQ1moYy8zm5UHSXMZutANB9Rm3CpmPD1q8YnhbcFr
41943	payment	2134	2134	1874	1	1	6141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PTGsxKnwUhkrd5vFSi7ubHJZJBZw6gb5YEFYXNg7ZjJ25LTY
41944	payment	2134	2134	1874	1	1	6142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSxvkcBU8VqZsKX8saxygtX2v4nn58zB4fkQetAMhvucemEgz
41952	payment	1397	1397	1678	1	1	15836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6ysEkSNUFFHxH5Q59DA6rZ3WTFGSCMqRKrm7NXbzqmFxwbnW
41953	payment	1397	1397	1678	1	1	15837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTkKnQcueB89GSNgALYgsFiWeLGotAvTYaVYny9EcjwLkdFxS
41954	payment	2133	2133	1874	1	1	5646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuzm8DQZhvRVrFgbBoaD6GgGnEkUjVJf93med9YqivEgG4WCV
41905	payment	1397	1397	1678	1	1	15822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrab3hFNKrwQVVCLvGxR6if3WycLAjMz1goyqy4rVkwaVCPXyk
41906	payment	2133	2133	1874	1	1	5632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fpfnn6t9MJxEgcsyJ8rW2Gk2cwPdHQsR6ZJsWTAAET3UFezX
41907	payment	2134	2134	1874	1	1	6131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCejQiuqiobGNSX1wvrw6Ukr2rqF8QugdyMPXs5AXv3B3BT7J
41925	payment	1397	1397	1678	1	1	15828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpArKHXismBGyxcC18j3KCaFUFhvsGLbwUUb6tqb7bQHKz7o7
41926	payment	1397	1397	1678	1	1	15829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGVGrW34EkTcZ7Truhg1XX4Wvoag5CZPGm1We1C7NSY5q5HFH
41927	payment	2134	2134	1874	1	1	6137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6pmFtp7bY6bJ5xXQ2maBVCmyug4Vv7qFiWWv36LHZFyDVuxj
41928	payment	2133	2133	1874	1	1	5638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9hwRUAXxt98GE9VExyuG8yo4kjkGzichMWictzdrRq76FNni
41929	payment	2133	2133	1874	1	1	5639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYfpkC81f51gTjpJvXUuM5hUKLD48aCFuuk4wXwNQSGiQvL53y
41930	payment	2134	2134	1874	1	1	6138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aUFUManPZ8zfJcUymcaXquvEQwhcBHEkpYsc6cDXVZJgXzg6
41948	payment	1397	1397	1678	1	1	15835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij1ehAVVxBftERCfJ5EcQXQUom1oK1B33DYR7mmLwk1tJ7ihg
41949	payment	2134	2134	1874	1	1	6144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm78j3UvcRMbuda9fViEbxdDw35HHSu4SjLEGTzKTHANdeZ9dm
41950	delegation	1741	1741	1561	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5h8bXp9F9ZVx9AAf8kG5q2tve1kDjqq33Q8hEQPp5L6x1aA8
41951	payment	2133	2133	1874	1	1	5645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPCZmnHe6td1m7RXziv9xhDSHgYZ77t8eVft5FVaFAyAXgyvB
41965	payment	1397	1397	1678	1	1	15840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTmdKsVUknhSSWo57fuxWrQaexr2JrD3KGPk8VTrPZWMgCj5z
41966	payment	2133	2133	1874	1	1	5650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxi8KSoZxFkvyqMu9HC7d3Qa66Bx86E7LDxgMLusdG1BQsmfDc
41967	payment	2134	2134	1874	1	1	6149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaruZZ3Fr4Qbgauusm31XDqc5AxQ4gEXt8eE6sYN8SaxGCSSon
41968	payment	2132	2132	1874	1	1	1612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2KPY5xpQapsCMDcc1cK8qmokYHXeHuRWyLT2YUWWF5RXY1o3
41989	payment	1397	1397	1678	1	1	15847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ426ycyx47uG6JtQcBFKmxso775Qi3HvLtAuqTZGk7eiQMRRLV
41990	payment	2133	2133	1874	1	1	5657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw3n51wKodSDDeTzEvFXJKn1GXhy9S5sXEs5GPJ9zJGBmkCcJ
41991	payment	2134	2134	1874	1	1	6156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBXTD8tgASGho2xbZHT47ns7wPXuzDfCSYpuHEiMDb61G3H8T
42033	payment	1397	1397	1678	1	1	15860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHm31aTTTgnuJ9ge9B9zUGLp2ZWdAUfpeDGWPFDKdtQsu9f7zM
42034	payment	2133	2133	1874	1	1	5670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNGmMUQEpEnU5EqrAos8pCeHy1HihiTptG4zmkL8QNvqaqaqx
42035	payment	2132	2132	1874	1	1	1618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwjGuYJ3BRzbqSdBvu9M3WL1CKap5MgvnZgqLhb6RSArLs6AE
42036	payment	2134	2134	1874	1	1	6168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF4ALfnjZGAGFotBcHTNr5j9BBKnPgHDW4krzhEDQwBB6G28x
42040	payment	1397	1397	1678	1	1	15862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhmPjLNgw9t8sjtG2d983zhGn6GmUgDyyfjQw9BL11szv87hb
42041	payment	1397	1397	1678	1	1	15863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmMUYEXH55CEoHeUxCtcsEVtifuguRzjmerNVzU8zuhoLcnab
42042	payment	2134	2134	1874	1	1	6170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExfL2MUDKmAMNbfCC94FJdrKVpYFaZuFKHTAEbU6q9GmWmQsB
42043	payment	2134	2134	1874	1	1	6171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbB4gURoCUYP4z2fHbqhS3yrXHoM2UtjMMVgkU1m6vKdYek3N
42044	payment	2133	2133	1874	1	1	5672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMz76Rv5eCYE9qN1gW41eYTEzDrEUQh3bu2SQWMFWkX31ywEM
42045	payment	2132	2132	1874	1	1	1619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXRNqeCV2nmczgLE7ij51fD5YN6EbXW4SZcRg7ZMHLYHGTUXy
42046	payment	2133	2133	1874	1	1	5673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCR8p1FCvN2ANXbQjGMvRfXvSTeSufBs8DaSVf3x2V7mssx96
42047	payment	1397	1397	1678	1	1	15864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwix6b83Az6KBgts27A89yDJJEcUKLu9qYnKS7GtrCQSqs4wcD
42048	payment	1397	1397	1678	1	1	15865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAzr3aNWdYuPHudWTjtVGjFA8R2fLUjhKWMY2vK5wRkrrU88h
42049	payment	2133	2133	1874	1	1	5674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3jrfjbuixxHVoG9XAej2aRLKScUoBBuypXU4QaEUwtczwFLC
42050	payment	2133	2133	1874	1	1	5675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiyQm9U7qrMjnnd7bkV5fXkAfB82r9hxhycqoygd7GC3TSaoN
42051	payment	2134	2134	1874	1	1	6172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemMEfu14y9h3SwKUPzDmTsLMm7t6yRGZ2oPThcAujcYqiD8yL
42052	payment	2134	2134	1874	1	1	6173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWJkrrwekreTRc3JEUXfmKs4QzgBYS5zQ3NepVyrzEMwhX8jE
42070	payment	1397	1397	1678	1	1	15871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMhveCgy44wCyRcP9gSVdJDmEnHPMLn77J2FzpUa61U4crXF5
41911	payment	2134	2134	1874	1	1	6132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3efDBH27iPmkWa9aR56aCT69HPPyaAgD9ShbVxtFeVkXkjUqb
41918	payment	1397	1397	1678	1	1	15826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NQrdhB4N7DjensX6pzpBgt6tSd7yg6MSWfTPWfGsaJtTUgCp
41919	payment	1397	1397	1678	1	1	15827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41HhoVBgNZ6iHPbi5WKi4wkRUVCvvw4o8mMp13mWCjEF3DJ7Y
41920	payment	2133	2133	1874	1	1	5636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5ZW6KhAZc2iRUdkeiWZd14yr12tgYkvvYYYEZKM9uw3SZBSo
41921	payment	2133	2133	1874	1	1	5637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiVXchxFMrUifBSkKPFjB5pUyStaUqXTzBtFC5vpnkj7U7JwZ
41922	payment	2132	2132	1874	1	1	1608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ATmuQFBeHVxUdR1BR2hpfpiNjYp5r2hcZokLakDRF6GcTDNv
41923	payment	2134	2134	1874	1	1	6135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr25mm2eCaqcM4g6PQFKgVmXHyWeMEwN4BCHdc5dtjVeeHN8E
41924	payment	2134	2134	1874	1	1	6136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGjPB6giy6vVKGnPP624KHBDKNx8V4SGpskeGwmvRQZ27oiUE
41945	payment	1397	1397	1678	1	1	15834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEQET8xPtVpa7So8Ap9PQ3tr95L6pwyGQcHgEriQnNkKFkMvN
41946	payment	2134	2134	1874	1	1	6143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7UVzg3d89eoAz8geY8VjPwPmgAiyERtWjT8Ze9x8DXmTVB2a
41947	payment	2133	2133	1874	1	1	5644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fxCE5or6A7TdRQ2qaP5S7rUFbWreraYYP26bZiyrASq613uQ
41972	payment	1397	1397	1678	1	1	15842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb88ENfNF978yHcHLz1EQ516rhb4Hj8SjBLFqhWTkbJrCLN3R8
41973	payment	2133	2133	1874	1	1	5652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz16fDfkKncJbbRd3ovHWxZnEfSMNcwY734ZNWcYMYm66CYpV
41974	payment	2134	2134	1874	1	1	6151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgy5uSP2aq85VQBF71JQy2pa7r3e2imYFXAQqz2iXK9h33nFi
41980	payment	1397	1397	1678	1	1	15845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GsjZPYVkmnB8A4NSQMq7URUq1nXZnwnR2tut4sNYFPBrtCbW
41981	payment	2134	2134	1874	1	1	6153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPToJE57S5W1reas6JRxw4dicsxcAFyz7ijAvxFddzRK3g8AzM
41982	payment	2134	2134	1874	1	1	6154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUYAg5XWEQkyJ7tQgvPcrLY2KBdNbUXfqg2fHMq4i8vAEPbxaR
41983	payment	2133	2133	1874	1	1	5654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQD6xfLysxf9ZrgcQpU12GE41FVFv8FZyAnjEQkaBGsDevwiH
41984	payment	2133	2133	1874	1	1	5655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgEDRjebxVZcx8MZToMDLDD8EetEcmoSMgtv9CLHGQAdEw3gr
42024	payment	1397	1397	1678	1	1	15857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt9pEatqS9yUcmi3SWyasdzKoPeL3WiK5wc7zKjkigFDqPBeR
42025	payment	2133	2133	1874	1	1	5667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn62bSLmsXSB1zAsmS1bEvoDvodEmKmfSVaUW1KcLwvFKWQWy
42026	payment	2134	2134	1874	1	1	6165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLNbpZoNoYgTTRqWB2a1E2F95AM4ca84Ahk7y8hPcSzAmwL85
42037	payment	1397	1397	1678	1	1	15861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyaA2mQqAo1Jv1Mn6RS6t6d3WEYQVY1VamyF8omJ3osKE3ZqB
42038	payment	2133	2133	1874	1	1	5671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMQ3gA6ttCsevcWjCHxVdcy9wMXHxG7CSuBKDEsZoN9gyjNc5
42039	payment	2134	2134	1874	1	1	6169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFi6zFhvsndK9RiF6QBzUi3uau7kgpsPz2YHKensRtfvyfJWik
42053	payment	1397	1397	1678	1	1	15866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dcoYa53f2mcaH89eXjDJzcAnzysQ3gDcdQ9LTGruLFq9WmYK
42054	payment	2134	2134	1874	1	1	6174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDxx9nUJB7WZ2j5Q4tZLSwXteTEbqBsUXBxHgEUs3jxBG96ad
42055	payment	2132	2132	1874	1	1	1620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzScox59iefjmQ3dkXLpXvXbXezuzVk9SQnG1scn869TQHS92
42056	payment	2133	2133	1874	1	1	5676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98XLm63U73yEDk8VDx5Z7zUd9PiG7dXpwUwsJ2pi8X7Kzp2bn
42075	payment	1397	1397	1678	1	1	15873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrdwN7CreKKdZmSuFvXCAeB9FNDh7TgZurEiWguMucEvkKmS9
42076	payment	2134	2134	1874	1	1	6181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MUsaCfxysqBs64SPCd5xgkGMGfhLN218V7Ez1iDCuxARoU7q
42077	payment	2132	2132	1874	1	1	1622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DRxn6Gr32HiEKVfRWD1BGo8BPXWyQNRd13XwtLNRWWoUmrZu
42078	payment	2133	2133	1874	1	1	5682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Gh9mxxKbAzpZw9Rheus3mdiCv5gdWYGGVqw1pPwCB5g1CFkX
42115	payment	1397	1397	1678	1	1	15884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBivTSSJYL5kEP4bQvrfxX5kX2DmtHvmZdsNEpztUXiH6G6EN5
42116	payment	1397	1397	1678	1	1	15885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEcNQHNbjY1D7MPdjrNnMDKBKpXcf9NxLDk3Uf2GiEsncAyFV
42117	payment	2133	2133	1874	1	1	5694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsabKEcZ6vkmtZAZmQj7LsM3yxBmbmHCGsEXt5D9vSZRaQTpXs
42118	payment	2134	2134	1874	1	1	6193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETJ6jb1gBFYqss2QgoE6na6wPzBedvSGRbPS2Nav6XjPHBLw9
42119	payment	2133	2133	1874	1	1	5695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFhC95RhrpwNjXcDdDNp9jUcuKvHzG5AdRC4ieX33Ncdu5G9W
41955	payment	2133	2133	1874	1	1	5647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEoY3e3fj6uwGnMRfj4TXvGY1TZcjjhMgxXFgU1zwZTneuLth
41956	payment	2134	2134	1874	1	1	6145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8C5envELXUJSupaifJ3TMWB5NS3i6BhPtXTuDwiDtsB1fsnm
41957	payment	2134	2134	1874	1	1	6146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMNhf6x9PoTrmNJwGW6u8dS6HdNPnv3MKWvhcrZLKeiWzbJsX
41958	payment	2132	2132	1874	1	1	1611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeadUCQk6BMztRYA7UpyNY9vGXBs5uQhVxGzzpm8QHnnLq4H6
41959	payment	1397	1397	1678	1	1	15838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkn2sb7FviT9LpXisPGJQhr4NvKa9z1dtMNBT76y7gSvwiWNN2
41960	payment	2134	2134	1874	1	1	6147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsT4vsinFGdmxi5pSaLrcNpcEu4dA5aVjsXfcyQwe6iz4gpB3h
41969	payment	1397	1397	1678	1	1	15841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvdwUKAJ8M1gQadTzspoM49mivK4h6cZc8txDbZng7r1KR41z
41970	payment	2134	2134	1874	1	1	6150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaPep8nfoH3ZxFqDsNaBpjiyMTfzLx5GFUSwkQoN9PUPZ1aUz
41971	payment	2133	2133	1874	1	1	5651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgidDAmihC4Lsy3d6Gwy55cbvLyeRwhMB8fbRH1ZZuR7dvM2p
41985	payment	1397	1397	1678	1	1	15846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6ugVuqHTmzC8oxfifRB4qLH51KBpJMn8NMZ67BUSEBF5G315
41986	payment	2132	2132	1874	1	1	1614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV4Hd776w3ZQBKfqiwdWR7DtPyNmLuT9UWvXuA8BPDzuP3Edb
41987	payment	2133	2133	1874	1	1	5656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzXwxU24LtJeQX1jSq6RwpVHnKp4BvQkCnco7HWnjXSu4waWK
41988	payment	2134	2134	1874	1	1	6155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQziS1JvNMzkcTiiSQry7an6tyXtQuV5EvrBRHSbZn6ShxUnq
42010	payment	1397	1397	1678	1	1	15853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoVefLANquSBjzaRyCAEfJkih7SiXExf6DiB5UWdDMnnv4tPv
42011	payment	2133	2133	1874	1	1	5663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfy7MNhyNYNYrg9n4BBUHRwkCk6VVMFsUk2EsY3cuHgu8u8RVT
42012	payment	2134	2134	1874	1	1	6162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1TsAaxc1AJL9Rjt8vFg6P89Ef56oJQ4Wtc7kxgAMfz1m8aeu
42013	payment	2132	2132	1874	1	1	1616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZTjss7EPdDmySJPMVeaQcEAqU3JmripLCSf8FvfrijhH6umG
42014	payment	1397	1397	1678	1	1	15854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHQZoBFtRnAV7LSRBBSCckkS8qA2W7UPqnk4cQhTMa33Dcxwz
42015	payment	1741	1741	3	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtB6DeHM5KtTD7iXMACJmEaNvnFCfsFRFQ7nPjPb8GVZPnqXFA
42016	payment	2133	2133	1874	1	1	5664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEAYBeMiVX5iJHyKUJPz9CcUtieD6rXT4Gnw69qikfcUVQsqa
42027	payment	1397	1397	1678	1	1	15858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYts2MHHQeMs9mBxoD74GD1NtXza217QShsR4c1txr9Gxm2jJb5
42028	payment	2134	2134	1874	1	1	6166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxwQqiuJX5K3FmL7mqrGdogSQjuRkUKA1Utp7Ra64nfTtqqG2D
42029	payment	2133	2133	1874	1	1	5668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyURs1PZK85Hf5eczPac2iWqqrNsBeyaHJyC841cjBst3yqUE
42060	payment	1397	1397	1678	1	1	15868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn85Gafr8sJzyKHz88tdo94e3oBpg98nsKYyShmCky4qRrdfq8
42061	payment	1397	1397	1678	1	1	15869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkx4E1WepR9oTiWQyNXs18EBWHZbEiASaXEEGvQpq4mjPDNqzq
42062	payment	2133	2133	1874	1	1	5678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ksDELoqH8Boe9VeBkwiYTVfn7vyQcPzw8QxUS7yjkTHb5NQu
42063	payment	2133	2133	1874	1	1	5679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQUk9StA2amePvZQRLhPjwipCAp4Y398GeFBMHQJyEzVkYMZH
42064	payment	2134	2134	1874	1	1	6176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZsnTLiTzd8m7WUrVnFLLSwDWizuNYdZMvHtrCgKCeW8CY5RP
42065	payment	2134	2134	1874	1	1	6177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YxGvHkztkHmT5JozaTuCmogdUJv1DF6PojnkpYTSivdSvKzP
42066	payment	1397	1397	1678	1	1	15870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMJinja9bXSmyrNwVxVephC8xtXpfiM1WKitGY57tFUbUCgHx
42067	payment	2133	2133	1874	1	1	5680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqWKx6eaBHH1mszdoeKJojrsg1uUag8MQT22jHKQ2SDU9RcSK
42068	payment	2132	2132	1874	1	1	1621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBQzH1gSSe8QRi3wkaBoHgfVGnJpZpRefu9EmYVuq5YG63X6o
42069	payment	2134	2134	1874	1	1	6178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa175fqsekxec5ztqnkN969Ucz5AK2XmEWuWQVApsBGkFN8aEL9
42079	payment	1397	1397	1678	1	1	15874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fYuUQdmC3mJJ3JJcRj3oznAH1mRZLcKTHa6H1bbcWLRsWTmv
42080	payment	2133	2133	1874	1	1	5683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdG75PF7Ds7QLQqo4VNw6EttgsHNrrCoL8hmAYx3brwsFrxdL
42081	payment	2134	2134	1874	1	1	6182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAwm2N5X5Sz7uS6ZcE1xvqxFC7NGXk27v2kjAjwvDipMyhEDf
42089	payment	1397	1397	1678	1	1	15877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLu2N13YCEHfnLXyz1sfbSWbMskWg2uMipJuxfo5wWzjCxHcW
42090	payment	2133	2133	1874	1	1	5686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpcq6KNNmeXgmzCSybuHYg6fZZ2b1N5zoFGrmbQNBCpHsuie7
41963	payment	2133	2133	1874	1	1	5648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSchVC2ff7tBteto31AtyS7Q8yvyqCu95WG2Kt4AdKFFpfUk6v
41964	payment	2133	2133	1874	1	1	5649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRdYHKBQE344V8HPEQEmhNiFy1mpDdUnsoRYopum6CTqaAtdD
41975	payment	1397	1397	1678	1	1	15843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmfY1vjU8aoa48YejPwqJWZeqF8wLAFA1R68vyPHheMv4Pdki
41976	payment	2134	2134	1874	1	1	6152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG22VzbFmKM7qwPb9CeWNBfgTuQBPN3VTWqoHQFeqtZj2cC8J6
41977	payment	2132	2132	1874	1	1	1613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWispCdSsCduf1Z2euEvfrg2BJv2F2crLCNrUM68NP1qDUnhQ
41978	payment	2133	2133	1874	1	1	5653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8R6gAecS2dDpGxWGRwaHPzknFioH2T3iNhGhutdjFuKjRsba4
41979	payment	1397	1397	1678	1	1	15844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwppSxozRj2AZmhVmbhRQbpzyz2FvLB5gYXUEmMwLL9UyMAHaP
41992	payment	1397	1397	1678	1	1	15848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyLdVFCqa26c54VUZKV5LMGyeCN5WcFZB44MJspbjBtj7yzq4
41993	payment	1397	1397	1678	1	1	15849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGQXz8Bn97J4XyTKwPXBjR9sg17wyEGqkhMHuzy53Ku3JHDH8
41994	payment	1397	1397	1678	1	1	15850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbJi7gyENpqMRQwmmsZwvQSB6z1rVFTZ59oPdKom6dV7ZWA2i
41995	payment	1397	1397	1678	1	1	15851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZba7ch7hG5hBDvbexoU5bviKgLKxxWydnoAXy2QaWmsxNrcXtv
41996	payment	1397	1397	1678	1	1	15852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudwfrnbELErWQ3SX1tnet8paV1T2f5cC9wWNZxHG68u8gSu5b
41997	payment	2132	2132	1874	1	1	1615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqUaE4hAfYnPU4JBzmiPzoSpbZwL5B7JbCBfecdpkK2mmWtvm
41998	payment	2134	2134	1874	1	1	6157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrJHxRFAFxn3GPi6KtzZprcMztcbzfTxtdK2fPZzPxoahsaT9
41999	payment	1726	1726	2349	1	1	8307	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWtNNe6Sowb3paLyV3sTQ97mvP5gxK76apKWiP6uNeVTHTJUcz
42000	payment	1726	1726	2350	1	1	8308	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfVGX2zLtec9fp4zo61VzftMbajXE4C4CZhudiVDYWzQ8bcQYu
42001	payment	2134	2134	1874	1	1	6158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnVDqaMZthXyYTPcrVekjtf6tEEZF56tbPhcT8N1ohmHzVdQQ
42002	payment	2134	2134	1874	1	1	6159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBAnSnsx5hG28s7zW2Ac4M8Vu51WYHreMyGqWvJ5nPVSnwLYM
42003	payment	2134	2134	1874	1	1	6160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3CeUJ4FbBJzaP4QrzGbhQWbnqy9YRKRwvfjBiaKKqeXBu3vU
42004	payment	2134	2134	1874	1	1	6161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfcz3Ant3HEHRquLhXCtSn3teGH8SeB2yz81WNWbZXP4T5fnU
42005	payment	2133	2133	1874	1	1	5658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFiUC9XdoyJQKQ5nSkbdTsxvbCvT2VUY4bedVj7CDhfHDG8h3
42006	payment	2133	2133	1874	1	1	5659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhbtHJYBw8EQrA3DWXeneD3GWodEGKLtjJtNnTBTb19yfoc6N
42007	payment	2133	2133	1874	1	1	5660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPeRAQPACsPvrAMqYuS1qwNBz7zUYxRNJaGa4W3zgP55sa7DC
42008	payment	2133	2133	1874	1	1	5661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uC4u16JWK6atwbRkdZnmEgaddncsECyk3jvzYevfDvC59yd6
42009	payment	2133	2133	1874	1	1	5662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPgDjm9XpAH9uYANsuLU1y3e8k8WVjb2WrQC7msARKjVkexkh
42017	payment	1397	1397	1678	1	1	15855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJu5zKFSnFAVRFqPFGPQxiGFSkwyyEzbc8FMFBQyNF3G3W1x8H
42018	payment	1397	1397	1678	1	1	15856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6JK2cYPoxWRyJUJhciFvqX6nnGEk3jXXR8yUYrQLPdS8otCh
42019	payment	2133	2133	1874	1	1	5665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvrEFM9LufZb9JKQk6aq1cUc4PfuRBpUbsyDxZ56DoWamhDX4
42020	payment	2133	2133	1874	1	1	5666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXsqvXZm8mP9BUXKghegDZHWGb887f6Rr8q5U4FW4fineRpap
42021	payment	2132	2132	1874	1	1	1617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2meiofJtcVniemDgB2fXbdWJNr9fpj82V2h9JgCrNhCKFxbZ
42022	payment	2134	2134	1874	1	1	6163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkGoGNP7j1kjS8NNiaahgnMQSmws9aft4bdBnVKUKmHc1HMm6
42023	payment	2134	2134	1874	1	1	6164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvN5w7Vfhew8FfWsFcxrVHz5A5wpmg2p7pn5T4RrEWUav37rDZ
42030	payment	1397	1397	1678	1	1	15859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQiVnj1bqbNBsFRe12xQbnDPaLfVFkrKgnmBqzF8tDGXb4mPL
42031	payment	2133	2133	1874	1	1	5669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RtLKFUodhvmoWqhtZm8XxUrU4q3iyw7pgBGnKQnYP4hfAc2j
42032	payment	2134	2134	1874	1	1	6167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq2Woem7jNDD6vaTnZ5sk4j8f232hdJZpbxqbt8bbWRpjpsRC
42057	payment	1397	1397	1678	1	1	15867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiJzy3xrN9kFQPDJcT3rowdqYJCSwUsZYrikMjj4e8NAZWc96
42058	payment	2133	2133	1874	1	1	5677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEneueT2RgSFtjwsTdPgeVP1MJkZQb8b41qwVRvaKqSiHdtmRy
42059	payment	2134	2134	1874	1	1	6175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitCARSQaR9VksqCgmCTqDrHN8ErGV2ER9HtbjwBQiNg7kmqbJ
42071	payment	2133	2133	1874	1	1	5681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgRQqnFFrZpd2wvFtzS6xc4dPK8mHGm6VkExHNgyVSvQ1wLhF
42072	payment	2134	2134	1874	1	1	6179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1RahYb7iM9hpM8XkBTZ3NLDGvmxfye6rbn6LHE3xwSwmqdgV
42092	payment	1397	1397	1678	1	1	15878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaetgW27ndJUC4NBep8q2KhRp5vBGusihUKZtnTHH7sMWL4N2
42093	payment	1397	1397	1678	1	1	15879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3uG8D8zmVkjYSmRfJnA7zbeV6HwLT1gUrP4g6qT31D92d53n
42094	payment	2134	2134	1874	1	1	6186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepXq1mpo2TyFDfqGkCpGyT3nsmQzZKmvVkFx6FhH9ExmSZXzG
42095	payment	2134	2134	1874	1	1	6187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeG2U1F6mExkRJqVMKBSDuH5xU8j1XsnGiaSogaBesgJKm8ax
42096	payment	2133	2133	1874	1	1	5687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKPbAwKq6yS87KmMADiv5EJcsZocatyixnyRdUehiRMVuTHWy
42097	payment	2133	2133	1874	1	1	5688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCH29WFVqm1hKGEb9FeAqnhceRZdDqfgK2vSzPbqxJ3B56rqM
42098	payment	2134	2134	1874	1	1	6188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsoBRcRH1HMQs9RVV8Jjvu4e8FdzPJUULjaK3jy4SfTxQFwEFG
42099	payment	2132	2132	1874	1	1	1624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42MMkXRygpudbj2UmJXgJuYbdiR2SsWKhvX6F1FW2QSNbC8VX
42100	payment	2133	2133	1874	1	1	5689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7CTQfXhQCPNzYKv4EknGKwq2PsFpwnWLTSwvFFa7v1Y1yn4h
42104	payment	1397	1397	1678	1	1	15881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaXi6SLStL62M1tn63KXC2gTv5cKiETv3MtMpDDKEGAAGLMP1
42105	payment	1397	1397	1678	1	1	15882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDe8eKYyeTwBmDoKnPi9NnhUvULC2ffyvUSppy7zGnRYdcHmB
42106	payment	2133	2133	1874	1	1	5691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZbNU7CdNwb7uTTADew1Qvq16JoU7KWRNcfr8hLJPPEGAo3BK
42107	payment	418	418	1950	1	1	0	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3VZuEZKvsxvBTBZCgd8AJWbQifxG5mS2RcCGMzkxX62bm2a4
42108	payment	2132	2132	1874	1	1	1625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTbWkxGBVxPLYVJQG6b21oBBNZZHYvu2YSXGyv6wJD7JjGvM6
42109	payment	2133	2133	1874	1	1	5692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZympDpV9RFe8ypPLmm79zXtVp8ohehM7mbo32BYi9oxMwS1ed7
42110	payment	2134	2134	1874	1	1	6190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VEDXwLQSdSHEjFxp1FmUhwRY8vpKGcyWRBD6HgdByMDitnQH
42111	payment	2134	2134	1874	1	1	6191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLXGN4khkMpuFBxmRehqKJVqcaLBt6g94P6tRuiktKj1JgXRY
42112	payment	1397	1397	1678	1	1	15883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEe66pyLx55j1NmHVjW4R91xvnmMsk26z7Q44KYUfMxGS9rNF
42113	payment	2134	2134	1874	1	1	6192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK41d3ZSQchV39TkhyXMtWUSLuhQcyZqRFtEUDixG2Gvpq46rh
42114	payment	2133	2133	1874	1	1	5693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XhiXBhKyj7FDUwpr59yrX7JSa6ZEVugxg5EtVXyDCSXYwwUD
42190	payment	1397	1397	1678	1	1	15905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANE2Jw7hTVVvjA4KrP3WrXrqEMr7HGwUar5YV27juhMdmPZbp
42191	payment	1397	1397	1678	1	1	15906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AoaMUZsa5iFiGmNt1BAqdmvMu4qMwTkc4bExDch7cWv8zxtX
42192	payment	2132	2132	1874	1	1	1632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLmadpByG7UHk4fGdp8R3PdJdZetUsPbWzRu4WiPpGYyxYPhf
42193	payment	2134	2134	1874	1	1	6214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmR1wHjDsBWtSiVymyi3u8FMsG3qhZJR9pj6vbkP11ZtYdHAG
42194	payment	2134	2134	1874	1	1	6215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtnqfrzLEXstLfbRdjK9B72xSPvZRmNuJebhn2ywWzPhrosqP
42195	payment	2133	2133	1874	1	1	5715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1sUA237sQDXZivTZyavWG7LiwCWMgpfj23Jmc8ipasEbDST6
42196	payment	2133	2133	1874	1	1	5716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaULqS8X74npZxNf4pLL6McEAvp22WpC1urn3MfDYqQVYkGWzk
42197	payment	1397	1397	1678	1	1	15907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHwDQ3GPbuDUB2k3Di2zrwHC4J661g5bFHpWUNQBS9LVJuqs8
42198	payment	2134	2134	1874	1	1	6216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBvt3TgCSTJMm7pwJaL5BJTW2BLK4QrnkiP354nm1bx87apga
42199	payment	2133	2133	1874	1	1	5717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4fwuN6N7pBJBNYNQjuyQALGQMhUYNqNsZ2mMcVM7ydVzjLxKz
42210	payment	1397	1397	1678	1	1	15911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9jj4TeyigSutzTtvjD8JRAi1guRURaMCDybg9KknR2qLgmUf
42211	payment	2133	2133	1874	1	1	5721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KprCQY2hTVEThk8EDe2BDEf8HDUTsy48XD3XHFhvXFMN6SnG
42212	payment	2134	2134	1874	1	1	6220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqfw9NMa9j1cgjtpnZ49ZcrLincKgQbAQr7kpN3j3kho2Ueib
42227	payment	1397	1397	1678	1	1	15916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzeDy3L8qM875xFbUMZFko2oay12UVqYwrVb8teUvTqLpwGAf
42228	payment	2133	2133	1874	1	1	5726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwd6GmuiwdNCdMj2i6uETLbAC3vwkNxPdsnQV86QtJgrCTcJxB
42229	payment	2134	2134	1874	1	1	6225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqwrm41Fw7wvnayu3tMHZTBUKzpuAKq1Tafs9kf8MiQPKAick
42073	payment	1397	1397	1678	1	1	15872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJu7EVmA6wQtNemcZe6eRU76naYhcb1UC62VByG2DBMs7NPg6m
42074	payment	2134	2134	1874	1	1	6180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmUpDMcRTxrAtoeuS9XDyDE8M4VGKQWRxek9BGHtGKmjANvR6
42082	payment	1397	1397	1678	1	1	15875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fBZeNonuJRNkcFM2gHGGRgPuHVkuoa2c6hmWjc1JnrHiuEwV
42083	payment	1397	1397	1678	1	1	15876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4od41EomEbuRhGDvjDax2hVsfH9DGHRtAx9yEaTP4eVe1xxs
42084	payment	2133	2133	1874	1	1	5684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYco8x9aGYdnmK5D3BwHjQSgwyoZArPxNqmBstFaWWNxhb9TZfS
42085	payment	2133	2133	1874	1	1	5685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzT2a2q1txKcTCGrF7J14qYVcxsiMwbv1dpFMa1dTPsAMUaVu
42086	payment	2134	2134	1874	1	1	6183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoEMb3WM4i6DmNodDRr4TWUTrxaYmwtvTexPRMrGtQqK5qc7M
42087	payment	2132	2132	1874	1	1	1623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYr6Su3Ym4yRGC4NWvqx6m2gt12iwyaJ96gUWuCjfmfqvB79H
42088	payment	2134	2134	1874	1	1	6184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbBHWnNNvZcLX52SBBU9MPVPeCirHM3eHCg2wWS7gx6z3jegF
42128	payment	1397	1397	1678	1	1	15887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHttZ9dNFowwwoMU1tjK7ZJSWtNTHCC48q9coec7dWz2ky17fy
42129	payment	2134	2134	1874	1	1	6196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuPbrHMUqDZUwActzU4fXWLjFU2eu9WrTVA8DwXPHbTsQePfG
42130	payment	1726	1726	2353	1	1	8311	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfkmZ3U322EsFEZ7qYe2dJpGM4jRUJhEtPzQz7GJyxAyw4Kuvr
42131	payment	2133	2133	1874	1	1	5697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwPSXYxgpa65oqQzhG3KPWypv6CfiMxjooQ6GMmWvLUJzXTDZ
42144	payment	1397	1397	1678	1	1	15891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GqGfcxkp2NKm9dzxMHpzQU3fBtwB56c6q3sxTooJQUqeWmgb
42145	payment	2134	2134	1874	1	1	6200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCGWEgT9Hy6YbcH1zTgPXMS1pNcPyvMHanWvT64qL9axRm84f
42146	payment	2133	2133	1874	1	1	5701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirfth8mQpw2XMfALTridN4J8TALELBhFRZzyMFCmimntHtfVb
42154	payment	1397	1397	1678	1	1	15894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztJ9HzT3VN66dxeddrUtnXg9jqhBuGVzNg71yeqEvw4s3H8zu
42155	payment	1397	1397	1678	1	1	15895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUWzhozRYo1FVH3x3FxJsD3c7hu7UciQjrp7uv6LKJxksTHxS
42156	payment	2132	2132	1874	1	1	1629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6S6jYZnkEQERpKVctKz1ekpe25nczvfBTPiSHrdRP29v7Zab
42157	payment	2134	2134	1874	1	1	6203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQeJkMztNpJaGoshZHJLj6KZv94fA5Guz4dFESX41LL5owuMe
42158	payment	2134	2134	1874	1	1	6204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeKfC6ouw8Ewbv4j4AnLhhzVKymBGMrHqTzpgXCRMDEyNyW47
42159	payment	2133	2133	1874	1	1	5704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6G5gFWymbBcSwAwaowffyDTHcm2c933utyNbkohdcfAeFHGNp
42160	payment	2133	2133	1874	1	1	5705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyHD6BfvYPYDzCjnHNrWmaP6oHHGxEuf7FeF63a6Y3AX4Ub7T
42167	payment	1397	1397	1678	1	1	15898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDZDiUa3ukMoubDQZhSkv6giZXKA6DWmt5maqg78QaKJAUvAW
42168	payment	1397	1397	1678	1	1	15899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMNEoPnpTvVD49iDxEkf8c6oPAu12nw3uN4C6wpBqT1UaJYEn
42169	payment	2132	2132	1874	1	1	1630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiijxoWi33X2odvcKuoQ8oNwfwH7mRBt9yLTSXCK3dHLVzBQxF
42180	payment	1397	1397	1678	1	1	15902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeRJKnpWjCwjZnEkbAEBVzhCbzxnaB9uv2ksuKJYy1mF3Vzu2
42181	payment	1397	1397	1678	1	1	15903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3H9MWagzokbZ5za4uc9g9hVm4eDPmkRJLcmt95MCAgwK12CX
42182	payment	2134	2134	1874	1	1	6211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvwYTcriMMK9ETiigbyNweRgT2m9fwgDA72DsuKiJsDjTrsPi
42183	payment	2134	2134	1874	1	1	6212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMp1sNdfNnpeD6C2zJGeH3xEPBy8uCGQu7Faq783PQbSFvJM3
42184	payment	2133	2133	1874	1	1	5712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNWndQWG25XrCQsrcwhtGL32fn6SLz7pBAkCrVbd8wkJ66dFG
42185	payment	2133	2133	1874	1	1	5713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSDeahVoPsDgpmufRUUAtSjrJegGWZwLfXGp9e7ny4cwTpJgY
42186	payment	2132	2132	1874	1	1	1631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANBUkuP8yLky8WM7eTQTvaQXHgDRFSDrtFR9FoWtb4V4wjbqw
42207	payment	1397	1397	1678	1	1	15910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrj3hVdXZnGtno8prtcfsak7FTg4rdB7mKxApNd8wfaQKkYrCb
42208	payment	2133	2133	1874	1	1	5720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpCE8ewvCJEMk5MpMeyioFQQvT32aPsvVDtytfSGvbJiRNZwk
42209	payment	2134	2134	1874	1	1	6219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcVSd6mRJ54HuqwffnycAXo4zEKR4W6PZervBd3tDbSTNyhPC
42213	payment	1397	1397	1678	1	1	15912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGyVTtKSWkDhJ6UydsCPhqweUbjhymTT7Wv2919Cn8WUj2dUA
42214	payment	1397	1397	1678	1	1	15913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhsN5sbarxx199X12QtLr5f8FNDYSuqti6FrE4euqM6AGkR6S
42091	payment	2134	2134	1874	1	1	6185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPrdknzcRmPGBpAT2KB56wjhVhas1k9y5GRBS3n4YiDpyZ5PQ
42101	payment	1397	1397	1678	1	1	15880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2BhkjVRzPrGNF872iqezWRUHYLunM5kosBrHrekKtirRncEW
42102	payment	2134	2134	1874	1	1	6189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7aKJHpw24ut7VSo7WrYz3ZYmnVDKdjA4TKGEmhE2zwV2DTXz
42103	payment	2133	2133	1874	1	1	5690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19NmmhgsqHHczg7UsFS1YXAfvpTq1BctFhAjMMNDNcDNGAVmq
42122	payment	1397	1397	1678	1	1	15886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntWf1KCoxAzLYmAMiekVoJsmAXhLJhE9y6FaLS1y2r7pAbrUL
42123	payment	1726	1726	2351	1	1	8309	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhPYJwfNbByFogLbmVtDD49K3SRDxx7Q46aXtmfxGuuvxA2Jja
42124	payment	418	418	1950	1	1	1	310000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrL39pVqY1jACdBSLD72LaMXzBWxWxgw4LfcY6PEBMEt1p3P5Y
42125	payment	2134	2134	1874	1	1	6195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aP8ZpHoVedspDi5S2Bdmk4Vrp1DmBbFoyzgbEmH29w49y6rN
42126	payment	1726	1726	2352	1	1	8310	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZEcmLXmSPDZ98m83CbvmynJNz56M6dR8CJjCmhqCeWyJNvVQub
42127	payment	2133	2133	1874	1	1	5696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTusecSeA4EwWP7LuHf9dQi3UDt46FY4RgjQRTynPXCyDNLdM
42151	payment	1397	1397	1678	1	1	15893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDRf9HNRK2Zawd2NN3EetmW7N9JMuVoTXwVECDWPUwfHBqoYG
42152	payment	2133	2133	1874	1	1	5703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTp6H8uHx2y7zNnvR2X9dnZMNZoHrvACfuqCLDKAaXHWGWcycA
42153	payment	2134	2134	1874	1	1	6202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CGucRU6AVQAYHpMMBvTDoRSwnoq6BWPGXDBwt1mxPH7YC4k3
42161	payment	1397	1397	1678	1	1	15896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ87BHSNeQu5VodNp4uzgMsamL174wZfvuUnFW39FJJAVSWE1w
42162	payment	2133	2133	1874	1	1	5706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpD2ZWnjXWDK31Sh8vFkxLBxpzLooiLy9dgQggfCXQ8QCyJ82D
42163	payment	2134	2134	1874	1	1	6205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8efnSvazTLoRAmKPy4vDZVQuoRuiaQWMqaLbkosFncXtxq3D
42177	payment	1397	1397	1678	1	1	15901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscBHEzc5wvaesYfzLXkjM6jHUb73fCEkbgz7b2hLUHxbfrnPa
42178	payment	2133	2133	1874	1	1	5711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQwDq7StaCq5vhHHUYWoWaDXeGNLGh9gDPA2XtFmWfPLPdvRk
42179	payment	2134	2134	1874	1	1	6210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWeqWjndiUzpXBAxtVxqnhNg5oJMW1ywVMa4RHN1QV4wQ8zN1
42200	payment	1397	1397	1678	1	1	15908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5oV31NKSsRKZRM1CTuxd6H5CkNHivLQQht2f6XYc42E6ALvu
42201	payment	2133	2133	1874	1	1	5718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDfroarToTgcXkDxgTWLGbbkvWHwT2E3U2oUL5Fxyvx5ifk4P
42202	payment	2134	2134	1874	1	1	6217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxXfwapcVQCiY4jnujWYUu5113dt1hqfmb8QdZ3oNctwGSUtdu
42203	payment	1397	1397	1678	1	1	15909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfzJLsQMZDf2h77bXDT9Y9vVAtLubeN76WDVmnUt1wcbFP9Ez
42204	payment	2132	2132	1874	1	1	1633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1tFiMgSofWw7Vsy7HHj66wuK3j6RSQHTZ99WEktWvhA9vhXt
42205	payment	2133	2133	1874	1	1	5719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqNqgCs2xm9yBdo7yhDgnLhvrn2dQnNaWWPDSufWLrZ13HxFa
42206	payment	2134	2134	1874	1	1	6218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4QvQkVctGnNQYaD1Bei43mgpSXzpw1vz35euFvdmXR8y3Ac3
42230	payment	1397	1397	1678	1	1	15917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDpKxUKJfkE5Us5bFfy6ydAaEeg7Dg2x12Krjuw4yf79xi8Wj
42231	payment	2134	2134	1874	1	1	6226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpzvy6jE4msNruqN1hZfYhB4B6LyyrS6gA85CxWbUHcAZDr5Z
42232	payment	2133	2133	1874	1	1	5727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmj15YKQYAqB7SxPbY1romwMSc3TZ3JoWDpPnxo8sJNG5KcLW
42253	payment	1397	1397	1678	1	1	15924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9BTDN94y2L9ZqtJqcHAjgmH6gJvfRFrVYxucHprEaabnXSAw
42254	payment	2133	2133	1874	1	1	5734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMSpWhd5dPPRFkjuNvw8vmqhBHdDPn7t7e25crm7DbfpobCdA
42255	payment	2134	2134	1874	1	1	6233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZtwqqb8UvsgPqkUNHQ3Q9zk3RiUZ7GVhe1PXqw1GAqifw74R
42260	payment	1397	1397	1678	1	1	15926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8CZ4XHGgwAs75yztccR9MyDPSXTsYD5Xy43oHDapmYSdZtAe
42261	payment	1397	1397	1678	1	1	15927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1DC2DKnmqhdYEtLdDpWQ7vWQL5ji4BqoehjSmWc1FXhn8446
42262	payment	1397	1397	1678	1	1	15928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYgyYmXirGB4SyBHF4sntJdB2cKfXzxcuccjoG3hY7Wwp3TnN
42263	payment	2134	2134	1874	1	1	6235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrAR8jQccuBUTx8ZGCMyWSsuqGuPUGfwSbgrvVA3xBr3t27BW
42264	payment	2134	2134	1874	1	1	6236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEorXUncmqfD3y5ML1QBQ5mo467D3DUJe52PsDhTJfj4oWrmZ
42265	payment	2134	2134	1874	1	1	6237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2etWWdtBAEMttL9qnPuv9hBySSmVXZwgJbbLkNAFyK4ge2FDi
42120	payment	2134	2134	1874	1	1	6194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqfUMhjNKyA7qDPKYavCoovVf4EdrbiU79A6VASQiMAyJbw7m
42121	payment	2132	2132	1874	1	1	1626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkftVrwuuJ5WwzfYrYVuk2tG14nooBANNnFRjrqzYZG3NmPoy
42132	payment	1397	1397	1678	1	1	15888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bAiuCN3ScJxyeZhkeq3aMR2T7tnuXwLV5HF8swEhghF2WxdM
42133	payment	2134	2134	1874	1	1	6197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrPRHTiVu9e5JkMigdA1romjazQGrzKtGapwKa1K4zPDbJ3pm
42134	delegation	2352	2352	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSfzaiBxWzXb6pR86iuVpRnB4NYEcUEezZAgwQwiSvhANQspS
42135	payment	2133	2133	1874	1	1	5698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXwkSumPj6RkTDJNpib2YxkYWpksj2sT8nZf3wyqPSiCz8ueS
42136	payment	1397	1397	1678	1	1	15889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaeKWnpG844nbAmjRFinRXCCcuRqE1ZzhR7HJXajpXqUYrjdo
42137	payment	2132	2132	1874	1	1	1627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8viByCNtd28R69nD5cWGDi62SrhdeM1UWmCkL7mCUb1CUx4Y
42138	payment	418	418	1950	1	1	2	310000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeSdwSPunPxoByWScMf22PycMiqccqLrV7RBFLXqja1tTjjsZ
42139	payment	2134	2134	1874	1	1	6198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikL9qALvcRd4dLPXsY1RZ1QHB21QxXxGnfAjL9fx5cgJeWG9d
42140	payment	2133	2133	1874	1	1	5699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywJ2SxprxCQitd7b6fMV3v4niP56MbcoMxWxsvdps6oY2D5KN
42141	payment	1397	1397	1678	1	1	15890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkAZrYAGzTevApyzA8TgxUPpCVw9qKNz53imF5oabaVHruYZf
42142	payment	2133	2133	1874	1	1	5700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8yYWJCCWSdZ9P6DjDEvoxc7TWsuEjdDrproKnTwiHVqcLAdV
42143	payment	2134	2134	1874	1	1	6199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVar1JHrLsNv8R9Zosi1FQdQxUxtgGcPZHsvvuDdN8PaQSDzjV
42147	payment	1397	1397	1678	1	1	15892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEs7ZLZyfVTJQenV4moukknUxALv5o44UWcSbZsR8BhXHQn33
42148	payment	2133	2133	1874	1	1	5702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKuNysGxUdATxg6dih2idP5JxryvHP8q6Qzo9mJhyLhgiaPG1
42149	payment	2132	2132	1874	1	1	1628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkffN859ec8eqnWt6RHS4WE7mvGdBvcoyzYQ1qczx6gU1xL23
42150	payment	2134	2134	1874	1	1	6201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfN5VhCMEHuBrTos2idUKHFGwApEDAxTqgGENwzipG2nqAUcW
42164	payment	1397	1397	1678	1	1	15897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZqVYqKrFDRxFFysdYYGzWxShZ3SLeBN1jBrFJZHR9Qk93AVg
42165	payment	2134	2134	1874	1	1	6206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdquQAGZJ99yZDNRSBJXoeH3GZuDdcYhTENNEEy8poxbcVrbxw
42166	payment	2133	2133	1874	1	1	5707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5P6GWt5WrRJq24jL4KZusZDMr4KMtB4E4YqJTVNuP2yPbQb8B
42170	payment	1397	1397	1678	1	1	15900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56UfFFdjU58wJMRbzKrRJ1UZahwacJVj1qnpPrM6uu4PpL8uf
42171	payment	2134	2134	1874	1	1	6207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKNXTYEQfT1RZ6dAxFoGiRzwBzUfkKeXvxQo5Z2U8bweA7EQ6
42172	payment	2134	2134	1874	1	1	6208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWg2Nf5LKXkwHkyutdxzNXpGZ3o64Ne8CDn3w21vkQyj9P92G
42173	payment	2134	2134	1874	1	1	6209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJqyXUKnpj2AbMGDKyetHtmW3zHDFu8hQwFpueyaT5X1rSuc2
42174	payment	2133	2133	1874	1	1	5708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3QsREsuo9WWNL6iGHruWJ6k5Bk5Fnsbaq5PDn4abJqURbNBC
42175	payment	2133	2133	1874	1	1	5709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77zxFtYW4UngZTmVhFYeFVQKTLjESe7Yksv7oPVxoSBvadSaF
42176	payment	2133	2133	1874	1	1	5710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAaKXgLvQpHqFMsyJ7mFpHwHa9yt7Fq1J5zupKHzsdECkLFEEX
42187	payment	1397	1397	1678	1	1	15904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9fwddngvBR8woTsTQg4YSXVFn2XS4Ercihh7A1GnKYYnNUo6
42188	payment	2134	2134	1874	1	1	6213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49G8cKxhYgoyTX23uD5L1LCa9NKS1JiwD4qCydTytysNncf5r
42189	payment	2133	2133	1874	1	1	5714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAG7nJtVv8qjFvnk2Zo6Gk1iS9VQ3kfKQKdK9AmvhnpgPVP7pj
42240	payment	1397	1397	1678	1	1	15920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUUBRu1HMgCscnwaCP5V2Zcj7EocpjBwCjVC6X2dj52sJmLRE
42241	payment	2134	2134	1874	1	1	6229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFf5zqrNrDU7YSzEdBLpPRVMpyrs4HXYE4EvZRHrhWY6dD8ttZ
42242	payment	2133	2133	1874	1	1	5730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorH76uTuBSCdYP3YyMdbByLYP6vZp4j7U6p2r5uyVkePDBxQe
42243	payment	1397	1397	1678	1	1	15921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4Ha8XR9SwJBRMXHWxDoEgGmU5VynJJGUJseC5DKeUNbYiz8B
42244	payment	2134	2134	1874	1	1	6230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6XjWN4nwbUyDNdFtQjJ1EpPL9QqJaxLTdE1N9qECntHZjav4
42245	payment	2133	2133	1874	1	1	5731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvF7bFTktiwEiyjBkg7uiPguGACh6qEFxMMQ94kH4DTPZ1UL1
42256	payment	1397	1397	1678	1	1	15925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYRCciFUrB8NvrUacYijBwEbeXc6e8JzKX8uX4ieK8cKan7c9
42215	payment	1397	1397	1678	1	1	15914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFb6N7j7Tzj7K6b68XFErieH1RctsPG8SKfaYRobCm9CUZxdNF
42216	payment	2134	2134	1874	1	1	6221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUxJbsvgzidFVXge1A1Ke7VYdwqPMFsKDs6nX9tbNYcne7Q73
42217	payment	2133	2133	1874	1	1	5722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriXr6tpLMSiPPXcqc4MbK4LLZb8WSXnXyPcKzxhmw3v6oKMmn
42218	payment	2133	2133	1874	1	1	5723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7w2WpK9qeoRicUyvTANjuESHXhvwNsRspdrvb8ztnY1FYB1in
42219	payment	2132	2132	1874	1	1	1634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmt136Mizn98e2v3WxgnFz9yzswDGMz2BsM5anCxFZNUTvidY5
42220	payment	2134	2134	1874	1	1	6222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RKoKctczfQZFErt9ArWheewq8xBJ8xS2CQiEctrVvzbyfFe7
42221	payment	2134	2134	1874	1	1	6223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWd35aWbKM1iVKA9yJeAFqJ2qPNRgwApEE4aWWRsiANivWHf1
42222	payment	2133	2133	1874	1	1	5724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHs5XZMfNv1ZuTS8taor67frJAA5wtV2zD8eTjVrWzrLDUtE8i
42223	payment	1397	1397	1678	1	1	15915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqnLos7yb6BnEWzwDAaop25Kdgk3UooaefZBBgx7FBQWmR23V
42224	payment	2133	2133	1874	1	1	5725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVF2au3DcfBDH1Cy858Qr1qjnsnQoi7M8LQ3LNgco75GChd3qR
42225	payment	2132	2132	1874	1	1	1635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAehhWxCtpqMYSYrBiEMSDK6cXJjb6oFN5cC8bxtudkK5rTDT
42226	payment	2134	2134	1874	1	1	6224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYSkiT5mh4gL3L1nQCm7uF5ALd8dzNWhBEwT4735UbAF4fWBj
42236	payment	1397	1397	1678	1	1	15919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPg5iwSxA4uwWphNpCcNv9iwb3kxy74yd6xPNHCAbZCMspWCQx
42237	payment	2133	2133	1874	1	1	5729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEtNA1KAhUbyj2WKS59vQfqwcdRSiu5mU2Kn8mYoaLE3TFz9L
42238	payment	2132	2132	1874	1	1	1636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUXotyw3uzuDTk3GuT9oUnoW6CQocUyBGuqSGXAVmzgZiy4kE
42239	payment	2134	2134	1874	1	1	6228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJsCMLYBZeS6bGM8rpKJT8Qr5AjsTw4hPD154HxkspmbPUT2m
42250	payment	1397	1397	1678	1	1	15923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz8tVRxjEhKB81qov1ANVahs433txY7VGid7UwMCeKLWeF551
42251	payment	2134	2134	1874	1	1	6232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrudGC4B9CxDjmF98VDqCLWYhiZ2QhN7PQpmAnjJXjum7oNaft
42252	payment	2133	2133	1874	1	1	5733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPDqJAAHfNwK8EeMPpzSDSDmaF4QMB3MaLPWthV2ET7D4GteL
42289	payment	1397	1397	1678	1	1	15934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMB4w1UkNFoHrzo5Z1VUyxMXdsAgLxQS71kgu1RqGuCp6tHR52
42290	payment	1397	1397	1678	1	1	15935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGyJ1nEnaZFpc7gtpntZkHA8oTmhPA1421BJx9yQdRw8cLEWk
42291	payment	2133	2133	1874	1	1	5744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2YaWk5APSaCmegfoGCMrdkhwZ544i2d3p6zEWP7N92Abhej3
42292	payment	2134	2134	1874	1	1	6243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhzYUreT3aaPvd4xBBrGZicBNEqm9zbBp4s4LmqtEPWdH8z2k
42293	payment	2133	2133	1874	1	1	5745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3oVLn5akbyMaY7cvackDWovW5Z1nwPmmPULrWGbPJBLyFfR3
42294	payment	2134	2134	1874	1	1	6244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuaPQ8dmjfmL1hw4Joazid9qfSsEKmBciL4w5fUwGndshZbqTx
42295	payment	2132	2132	1874	1	1	1641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFHy3a8QkaS8bJ7huTGQLWzVEiA1gxfshE7rmkdCYNxH93Bvi
42298	payment	1397	1397	1678	1	1	15936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6HsBXyGMvYn5TSPXejLMmAjWodeZpD7wmXm86KnmNYDMsfAa
42299	payment	1397	1397	1678	1	1	15937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XqXBDYZMiVsCCYFmCQXemDvTxWnpMhNNWUJ86QoaLkyodTXt
42300	payment	1397	1397	1678	1	1	15938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaCnwNBpFEw28apBxKPGJUxHHyBMom3eLRqiY62D6rZGJJH5h
42301	payment	2133	2133	1874	1	1	5747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSbrpQFsQeHMBvGPephKiyG3fZrrdyyRtP3hPKx4NqbZqfChj
42302	payment	2132	2132	1874	1	1	1642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqood1VewSvAMvtSLTtmNxcBNAtU5UKhM1HbQ51zzgaczgp5a
42303	payment	2134	2134	1874	1	1	6246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79mMfBaFr5njy94PKtGVBnZqzitxsLdDqpqqigKQ5SuGqkVqH
42304	payment	2134	2134	1874	1	1	6247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsxxsRVfix67CjYfjA16DxfwoDov6d1SrrWdGuEtfyqBxqQZq
42305	payment	2134	2134	1874	1	1	6248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzX5RkZL9CxAQs1XNkewPFfq44oyMWQDHKcHjRb1RtnKyyghc
42306	payment	2133	2133	1874	1	1	5748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfrrMEMEEb3PuKJhA5GJfwL2StzyfBPvU6K2urWZqA4EHJtJz
42307	payment	2133	2133	1874	1	1	5749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWqD6S7ErUC2ZinhRaC2vKdehVxz35M4pYZRakphHMmWGzLZN
42317	payment	1397	1397	1678	1	1	15942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPYDvQeB5kKW8acdsZa7eLDs56ZBzT5uQz7kZFYpJw7Ub88sF
42318	payment	2134	2134	1874	1	1	6251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeh19yqTY6jC8Gqvmj9HjJow3x7gLWwSMhDcUaMWUqKzzfzzbi
42233	payment	1397	1397	1678	1	1	15918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FxBnzkP2qAVmCPdY7NUW4npEaY1BijwHvgNT7hGqmA1qMnbj
42234	payment	2134	2134	1874	1	1	6227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6DZZ21DgjDauNG18x76zCVFEfMEigzKFHrhX6yM5vJzaj1HA
42235	payment	2133	2133	1874	1	1	5728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbVcByGjXgSvKuNQQbGu7ZuRxq7Km36LpsKTqLALQZ1Smqxxy
42246	payment	1397	1397	1678	1	1	15922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9tEHTsY5BFe93qAKUR5koSpbKJRzQ3gCqVD1HFBejMCYeg6t
42247	payment	2132	2132	1874	1	1	1637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4SfAzehzA7y49TYm99gJmSWgZduin5JjZQfmUuY7fXdCNiXt
42248	payment	2133	2133	1874	1	1	5732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWm7PGfv91ZEhpFbuJ6BW7bFGL2fCGJd5hfJ6Tstncs7j9vTX
42249	payment	2134	2134	1874	1	1	6231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiNdRrFJeiEDXqJDRZgn1UgJf7ArwB3pj61a3HUn7PSjtiEAP
42269	payment	1397	1397	1678	1	1	15929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqV2b59ZiDpZzXsrnfsunrJeTRV9XfytzhAbf4csMJJj4QpBw
42270	payment	1397	1397	1678	1	1	15930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9NqwPrPXKnatsWqo2dFb6fckGJ8T8szExGEzZ6dtzKraSy4g
42271	payment	2132	2132	1874	1	1	1639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqFcdyMS3DPAheGpubUN5cUGJ4oMqu6u2B25rPkUktBf5nAFG
42272	payment	2134	2134	1874	1	1	6238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Kn2HH1tJ549QSnHVkhEofCXqjWkvobjB3fZGwM6FVx9nZZBL
42273	payment	2134	2134	1874	1	1	6239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h8DBAG5QQrGhj7Ebifwew2vANCqH3Bvn4QJdzcGrGYisLyvk
42276	payment	1397	1397	1678	1	1	15931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgiqefVafm6EDkpHJrzXS8EBb7EKsQp5BVVjKTjP4SFgiTuMS
42277	payment	2133	2133	1874	1	1	5741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94BAWsKBDvUG3JSJqJjZNDS21jRtQ3RJVc9ZjyYbsYaFL4Dj9
42278	payment	2134	2134	1874	1	1	6240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiajD2KCVmmgeS4zhArtWVMxmLSVNb3nQZnx3QEtyY2i7yEqvR
42279	payment	2351	2351	2354	1	1	0	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W8PjXm7E4u2JrAiiETLa61oZvNJZdXHZ65q3L2Ymc2qjpC2T
42313	payment	1397	1397	1678	1	1	15941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMEfAD4CTAJV2Y2xgbFRrHF9SNPuVfm6iXsvrQyzd69QgjCsN
42314	payment	2132	2132	1874	1	1	1643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiasSCjwMxs15GyxiGiHqM85zXnW8Lyh7bWdfnQ4iX1kmMWfUC
42315	payment	2134	2134	1874	1	1	6250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq9NXe1rvhrRi86YSux8DyLbHbTVxc4LsR6sJj8cFJfVMPcge
42316	payment	2133	2133	1874	1	1	5752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeXBvAuHxju9Y1esNxVbvycps57QabyptgwTSiX4gxMe3BcpQ
42343	payment	1397	1397	1678	1	1	15950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ5LMkv4UBknvxuLH87pTREKfcQ1pqdoU1MibKBWMVorJsB3T
42344	payment	2134	2134	1874	1	1	6259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSfHEuFC2aJu2EuY33okeJpkfbeLiqbwmrJraQzwbc8HoMQoL
42345	payment	2133	2133	1874	1	1	5761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGxDRQnnyq3txCaTxvd9rm1Yypv5La2CEWbrPphPruWLwJcoG
42409	payment	1397	1397	1678	1	1	15969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpZbnznuQ4ZiGjNk7AoY4U7ezXLaMNyejNWVVzHb3YcDTeL5V
42410	payment	1397	1397	1678	1	1	15970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftnDfDaNceFtZK5ajL45DtY5oQu17yMtwkBEgb1Gw2CrmGpUe
42411	payment	2133	2133	1874	1	1	5780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHTwMfjp7ANJgGeSZrKit3LNZhfVaxKhCvyGeWswcThFZXZvt
42412	payment	2133	2133	1874	1	1	5781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cjNFMtaMUpq5FTFtSepWL63buhre9y8GkfgPyE9YH4SctrL8
42413	payment	2134	2134	1874	1	1	6278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3939rVLFd4ZQK9hKy2U8ggjSMjcMs4koxqiiUG6BK6h3dZXaD
42414	payment	2134	2134	1874	1	1	6279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rutQDeCxWNYpEsS6YyBJodBGuF1a4xx7FYtdgrSr6kobEczK
42434	payment	1397	1397	1678	1	1	15976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDgZL3DEcX8Lgi2PC2FBaqa3BDQ72z1BPFMTLnUaCS6sMShJs
42435	payment	2134	2134	1874	1	1	6286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6ufxNEFZNquTGE8zRzxo9XgaecTqn8CB3o9wxh2vWbnmJmeE
42436	payment	2133	2133	1874	1	1	5788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sDfU1LEV2BtTPqkLxJVsCizX8ACUJZmVUt8B1skHTVHyGp4w
42462	payment	2133	2133	1874	1	1	5797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmEB7mjtzUh4AMVSwdFkXApEpaT8z55b1MHGQTPU4RTpD34fy
42463	payment	2134	2134	1874	1	1	6294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSU6a33uvXnDdMbuSM36pAf6YCmYqdCmdGGEz5PVnEw6NvThZ
42464	payment	1397	1397	1678	1	1	15984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8mdyroEQKkX8VCR5R1oDYSrLKvE7EmndhHT8UzFkXgc5tGKd
42465	payment	2132	2132	1874	1	1	1657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYB7fdFFB1auT8S8PBtw5jRJxjYJF1yQv59hgpnEgMetWgXx6
42466	payment	2133	2133	1874	1	1	5798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXsAxNQsPYffTSyUnposvVWQgqfXnAfjuKvULF9pME5ucmB7c
42467	payment	2133	2133	1874	1	1	5799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiQcf5Tv7pR7DkBp3r1wjG3bW355VJZQdiUKHqKhvtZGV6XMP
42257	payment	2133	2133	1874	1	1	5735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyLqKnBViiPKxMdLB27r6b2oy6f6S9MwefF31Cinwa6Q4VT4G
42258	payment	2134	2134	1874	1	1	6234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12Xx2nwZZ2qMZryJijwgfbQmR52gVXwmDNLdKoeexZCCLrA3i
42259	payment	2132	2132	1874	1	1	1638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tabXsj44joYzmVY6tVeju7dTV8wEDsjEpJfHUsU97mEV2oYQ
42308	payment	1397	1397	1678	1	1	15939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzQfRrRWzQBtnVrU2urQ71nKyVBu9xkoJPjvzS76LiQt8GGcE
42309	payment	2134	2134	1874	1	1	6249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCn2ASR4VNZZnxn3p1jsQR3ALxFgVBBYnytjtrGEeYEFKwEHDm
42310	payment	2133	2133	1874	1	1	5750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8gUoLEnoHG5gvXg6UKs1znZBoJ4dccgV3Rypa9PTzJxRpzqF
42311	payment	1397	1397	1678	1	1	15940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1g65CMi65vAHH3N5cNGpxk9528oEto1a3vT8ruNj7biFyNhij
42312	payment	2133	2133	1874	1	1	5751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXo8FneRELRYxHoC7bb3JyXsFCNE1v1aLbyxU4iabFyH1uMdk
42333	payment	1397	1397	1678	1	1	15947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoNYx2JK9Bdc6EXaqmwDJi3Cja3LeTUJ4fKdkDczw3ZFi5Vi3
42334	payment	2133	2133	1874	1	1	5758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW1PYMdRVXNRYKuZxb4vxVcCyC83zy3T1mEeMFmmhHLFxed64
42335	payment	2134	2134	1874	1	1	6256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pKV135LYYgrE7PaC4o2CXbFLafqYMHjpoh43j9mZB1ArKrhF
42349	payment	1397	1397	1678	1	1	15952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnmMwQoXzpDM4DFPD3BZVYYRjTFn5iDfpbC7xas7PTu4qMZ3F
42350	payment	2134	2134	1874	1	1	6260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaAkp8axZuUwJFTYa4BfALgtFtgUR4apvdQBDqU3NbkrudfPF
42351	payment	2133	2133	1874	1	1	5763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yaco8TWBUXkCNzCMRwTWBTC8hSumoPioHxKmepqp6YadDma4
42352	payment	2134	2134	1874	1	1	6261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9S36BfyPvxLiAC8yWTFN6d1LCWy9faGPAzoXQn3fbRAdtbLxZ
42370	payment	1397	1397	1678	1	1	15958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWhsH5LyUSoprM4FM9QHX9ymsusveRuCeiK93VYbR7cT6FDP3
42371	payment	1397	1397	1678	1	1	15959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzTR7RM6G9DBf1iGxkcrZgLbmKXPQxc8sj3wmzL5iT85fADn8
42372	payment	1397	1397	1678	1	1	15960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MEV8jZR1FG5WdarBJZfwsf7dUA7D8asE5Cqa6rduJQGXekFQ
42373	payment	2335	2335	2346	1	1	0	99000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMSK7vVryZzpcWcJRUigkJV8cFYKvaQWYjiuT5kcDvmZQZyCX
42374	payment	2337	2337	2346	1	1	0	99000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6xKjtpFA7RRdNJxymkq5dJ1QbVyTK6E6aWu6A3jr8RiFRxZ9
42375	payment	2134	2134	1874	1	1	6267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzL8f4Gv8j452hnaQ2z57uTzCtd4xNd8oYCYcAnG7h1EjA5iso
42376	payment	2134	2134	1874	1	1	6268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRviAfKk1hjdXQiBA8tqKjSke8w8KkW3Dz7udPcFNHxMqLMWJq
42377	payment	2134	2134	1874	1	1	6269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9jaG9AMKQxZGgbycoKfPtNcUEsJMCcTGvJkKuSCe6HFn1KUB
42378	payment	2132	2132	1874	1	1	1648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eKCcjkTHR351dKWiYLcCVsC7LjYxUoBUj4PhCANUWwThMVys
42379	payment	2133	2133	1874	1	1	5769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDS72U1NwwJ4jfzE3ytEWVj6TRxcj6MHbzBuxamthzeq1kjJUF
42380	payment	2133	2133	1874	1	1	5770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGrGd6WN6LNxL9TmYYzeKJQdwT1ma2krvNZAxgaKGCYeSdR214
42381	payment	2133	2133	1874	1	1	5771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUobJDoUzPk7hMirqX5t64wvmjLeGV2VBT7MQH6W9nraPHmnJQ
42386	payment	1397	1397	1678	1	1	15962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcg3mQGdWewcMBP9qQ6sbdKZbgSfBtGfAwgQ7tuX3nMsW7NYS
42387	payment	1397	1397	1678	1	1	15963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrySuTYhzrHVjndWySJh71SXBCb5y3KqBJ1WRGNFpJFzZuZ3L
42388	payment	2134	2134	1874	1	1	6271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXLsafycMrPWmzSyhbjHqHBikFnyZqsAr2hR13yuLKEmXByAs
42389	payment	2134	2134	1874	1	1	6272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptGcU2UfdaTwhd7SHZzXsFxGbXouY3YJBbf1Y9m3NJQ1QHvs2
42390	payment	2133	2133	1874	1	1	5773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJ2jQ1uLZN8vu39oCFQSnDRf29T8ZdvKqx845c3a6G9AjpZC1
42391	payment	2133	2133	1874	1	1	5774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUzK3BNAGMRmNQxnn3K7nC3QbsSsTqYjYS95gtMiwju97NMsx
42405	payment	1397	1397	1678	1	1	15968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJTVFDfJ1LkhSMaPm1GcsUU58pLA6eLQa1UqimGECEmbv6MQF
42406	payment	2133	2133	1874	1	1	5779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84mq24938k1VQ4PpDAZ5En1hnoh8J7grdVASa4EZ7d3qb3jDg
42407	payment	2132	2132	1874	1	1	1651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5Qarq3TpW1nENgSeM5yMZn1K7NtAqCsxokCLgu6PmnFS5SPG
42408	payment	2134	2134	1874	1	1	6277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DqHY3iy2sFWCEbdYX1WFbCdKviFRiCgiKXRd1U9Md1hQGPvM
42423	payment	2133	2133	1874	1	1	5783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCQVfxLJUf5MiFxfMCaijx9Kz6iqwNaHgfPmgBjTtX8SfSoXu
42266	payment	2133	2133	1874	1	1	5736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Fb5euiy4At3AuGYXoVzJ9kfdp7q9CkJPSJvAVGEdM4mYd4Uc
42267	payment	2133	2133	1874	1	1	5737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gViMTimFBUG6To8ZNnwDmAiynFcWmW8W7r1Sj6hAkamUXtuV
42268	payment	2133	2133	1874	1	1	5738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSpFqivpPsoNREh6ShSzQX6L7kCDiH9Hzc2if937s8pTy2qtd
42274	payment	2133	2133	1874	1	1	5739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRR4E6zBvQbGhZP1GusE8qvUFyaxV3jjRNaTYEPFPUqPJvbUFU
42275	payment	2133	2133	1874	1	1	5740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevm4EJaAB24LrG6aSNh7eR6aamnVWZjHm52JhYmc8EZSzzRkn
42280	payment	1397	1397	1678	1	1	15932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1X59Wu6kBZzjiZTVbB3wjmWJHhWrZbFGH869ydSoQFdXMUE9
42281	payment	1397	1397	1678	1	1	15933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYwN6xciRohFe6WjJbg6H7wRsTKwcG429XsEXN2RWQtcF2yx9
42282	payment	2134	2134	1874	1	1	6241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8bzWxM4o15RHqrR4wEDngZBXkTix7yvG9jLJvKZ9rKLRqJ7w
42283	payment	2134	2134	1874	1	1	6242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYyhEeC6hWe23xZY8rb5i77wP4fHgJkjVyyiM8B5SeadyWTmN
42284	payment	2351	2351	2355	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaWNRjbgvPYGeMcWrbSpX1Gk546Eyn6bnknTXHCqtSxRco4wD
42285	payment	2133	2133	1874	1	1	5742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkpTrRr8grWkiYZqjxpQ39qRL8nXMsP2AGJPnwD5Hz7QBPqXc
42286	payment	2133	2133	1874	1	1	5743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUj7hzjMurrqRKSx24Pu6Pxagj37GNG7brgrU3s9nRbHnrVYJ
42287	payment	2351	2351	2356	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsyq8XStqRewqDG2X9hD4KQLN1N2YB2Qn6NE1Ziae8UYu3qdd
42288	payment	2132	2132	1874	1	1	1640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW9Nk6wZSXJ4hkjJPTojYPtWZ11jkEPnavPe6U8sqmYWtJFsv
42296	payment	2134	2134	1874	1	1	6245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoiBCwtJyCLjSisXzCFpY61M89ErbGPRU1FLsL64EHkT2rgAD
42297	payment	2133	2133	1874	1	1	5746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bi7a1mfKbv5kLrQTyeZVKQz8K9Gof93SBTdj9qMydKf1yfVb
42320	payment	1397	1397	1678	1	1	15943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkrKZte4BCGEoCBmpPrvFeYkQcVn8wTVTETNxNAZv9GHvFXvy
42321	payment	1397	1397	1678	1	1	15944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWJosm2dE2Mrz7X8XbW3uRgcixodgNByNvCXtcEB27EawG3LH
42322	payment	2133	2133	1874	1	1	5754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvDiSK93BKWVEnN2Cpy89PkckAajoqYcE5Aiy3AGZ7FkpogXb
42323	payment	2134	2134	1874	1	1	6252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuP12ZEnAysiNTDVDnmfHNb6EXxQ5cV5KFzzkbcjVboUtxAVJZ
42324	payment	2134	2134	1874	1	1	6253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b1JKifCtbsr8upZfueoKYnCkkShMMZfTuBW42Pefxu2Jf7dq
42325	payment	2133	2133	1874	1	1	5755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wUDPcvyMLJxgnDzeiLcvLtM1LN48PxiGjmBhej4iCA4Tw1Jd
42326	payment	2132	2132	1874	1	1	1644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98jdckXEtqCK43CGGLJjQB2Ds55gJKvqA9xtXVkFSVP8q2hym
42336	payment	1397	1397	1678	1	1	15948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd8HPKX5LdZpEqfP6jjY3S8pH61fGZx8jt8VS2AyzYU7nMrCa
42337	payment	2132	2132	1874	1	1	1645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRGvjYXYKYCnFruCxsfsowPQLZjHVgQx45Mhbqqd3LCVid4C8
42338	payment	2134	2134	1874	1	1	6257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4YTf1MYcyKDyb5m2L1Cir22SBrByHWauNUTuK8utqRTgk6Rj
42339	payment	2133	2133	1874	1	1	5759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42oiayYmZxdt6fKRLGJrdXESke968k19NxCT61r5an5a1fiQY
42353	payment	1397	1397	1678	1	1	15953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdRYGC3GmcXoGTYrZVaLbFgdu1DUAfa6rooVzDP917bHYLAVd
42354	payment	2134	2134	1874	1	1	6262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfumC7v3XSntrryioyQGxhwbKnQfeR7Rhi5XhbNetiCe4Zafa
42355	payment	2133	2133	1874	1	1	5764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8CciZ95gqvueVV6BHKHrocyUS4nQNPDoYiaJWqXw4m4r5vMT
42356	payment	1397	1397	1678	1	1	15954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCkcBVvL1VVHKNRHo4WstsVMR3sZTivkpCQ8kxUqqNWbRCoVV
42357	payment	1397	1397	1678	1	1	15955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSPLQcdzawpK1HthRarqr3yiV5K2if9a9tZs2bjbHCkQtAVs5
42358	payment	2132	2132	1874	1	1	1647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLZMxu17hvSwzmDLCVSeqE2zHQHsVxxCmwYzfGHHN3G2be77h
42359	payment	2134	2134	1874	1	1	6263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBn41uBKJWtPigZeZA5yEbww9d3qsb5YrZEv4vKVjKtkVhsyz
42360	payment	2133	2133	1874	1	1	5765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jFGw6QbFzt6goAMR4n7UqaV2VrY1a7CVnD3GeZoDqouYh7k8
42361	payment	2133	2133	1874	1	1	5766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Cg7FdTYWZ3f6NATw2kPMxSyZyhxgR7KKHuqt8sN7Js1MRxvT
42362	payment	2134	2134	1874	1	1	6264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUfJsPsgidhUrWq8ZRVSsYnS5hUXTaPmBd8m1tmZpfnibSBUU
42363	payment	1397	1397	1678	1	1	15956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrfLbf34zZ82QD6jdqN8FTf94BkTAAYh32UMs7hfTnFLQPsP1
42319	payment	2133	2133	1874	1	1	5753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5x7hu7KMPGncBjww8fB4XWF6cntRHwmyFvKCV1jDrLpjYmvqx
42327	payment	1397	1397	1678	1	1	15945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVf8GnvDPiNeJZqv8sZ1iEgnfgCQaCPS5MWVr6rwgnwNE16zm
42328	payment	1397	1397	1678	1	1	15946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfePyfJ9tppNurQywc7HXkod3N6LosHhY7zQmDZC7xdB22hiF2
42329	payment	2134	2134	1874	1	1	6254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpwxj8MQx3wPecGjJX12G1HAAJrGK6rtbV6z6EizyTijntW8z
42330	payment	2134	2134	1874	1	1	6255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFaPxVUFeAoULMhQoVnkmTMoS76Up3a24mi7kpsDkGCcENvcR
42331	payment	2133	2133	1874	1	1	5756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkeVhSguFDaMSzR5mBKih6BgvZ2RbzK5XiJow76wVhDN97tUE
42332	payment	2133	2133	1874	1	1	5757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCne1RzemgSbKjdYMnjcEmWp4FpraGw64f2e3PCV3e6qJ1Sh6
42340	payment	1397	1397	1678	1	1	15949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHMc3A74RGYrQSBafCTQMQnc9Wr4PgWhv4zPzFT6hEZPcpJzt
42341	payment	2134	2134	1874	1	1	6258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZnxpazDPEjSbExXGa4FauDSgpohTx8RZBaCrVkBffFn78SWZ
42342	payment	2133	2133	1874	1	1	5760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxbpo452CdC6YDhAzGwC1L7uEpUh49W6WBd9txusxepc3jua6
42346	payment	1397	1397	1678	1	1	15951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3JkqJtvPseMSfSfvKbGfef3VwXY6D226i3L9x9vPE8UzC5Wm
42347	payment	2133	2133	1874	1	1	5762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtC3mj5CJfz1z8vLAK7HMJL8HxuEy1A7aAu54V4bX3zcUBtsm1
42348	payment	2132	2132	1874	1	1	1646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxHpB98rXTRi4qDECtHS19hk2bCbw1XtwZnAfMdCG5RTTb3nk
42382	payment	1397	1397	1678	1	1	15961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCtdgxfq9Pccc2nmvJChTqRuD7aMaEFfasGRhj9YLDU5SqU5P
42383	payment	2132	2132	1874	1	1	1649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5YanBZoyKY5Jqe1dVPZQhzG8wNmDdrXHQHj3E7qThYRUs3W2
42384	payment	2133	2133	1874	1	1	5772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjz7DMwRPn1yCdM9HfqGy3WW6gm11hvL4tfo7Gc3AtoLRVGBM
42385	payment	2134	2134	1874	1	1	6270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4sxENQERz1xYZwmy3dgTYYJPLwEssCZYpiyoMgbkDJcSwkXr
42392	payment	1397	1397	1678	1	1	15964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpidaAoTXuKhaGXiRpeA4iZvFoQmPvczknPwFija4hj2d4NQ83
42393	payment	1397	1397	1678	1	1	15965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByGBySFQsQkPNpv8PJAXR8DDCvoXgBeVS9vFcTje32i34PDeN
42394	payment	2134	2134	1874	1	1	6273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj71WRrKjBAEvQUVsoa76b7DPBUqTgJGs9UvEop6ht3Qfkp9i8
42395	payment	2132	2132	1874	1	1	1650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7v9Cxdo38knf36Du7pfgF2jygLtKdwEwQAeGgMBaSFTJDyVv
42396	payment	2134	2134	1874	1	1	6274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4s23VnF51tnSwSY9DaRkbqv6ikUsvnNgCsMWLQB4we2GGhw2X
42397	payment	2133	2133	1874	1	1	5775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NGaYw74ZLDFXYZZFHF4EbaQiQoXTEEYjgrF3Tr8iRL7fpDgd
42398	payment	2133	2133	1874	1	1	5776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5mUdQdhHUVTymcsok241W8b6uQoHF2ASh6UMKwJtsfLty95K
42419	payment	1397	1397	1678	1	1	15972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rjGLWpTahQr1BrTp54wig71Hdy8Fvjesy8EQDtzGqFSELfuX
42420	payment	1397	1397	1678	1	1	15973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H6hRUJjxhRcsiDFb5N2KhW2XtifTbQeHRTnUqLaFwED5qQmY
42421	payment	2134	2134	1874	1	1	6281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5TsjYfTUK1RmL1Tvc3ZQ7g6KraLffBmr42URpSgrNdqcq1Rg
42422	payment	2134	2134	1874	1	1	6282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXBZGMSQRsBHfRPW18g11FRQfJ51oSW3pwgJpGU7ujHCav8vg
42425	payment	1397	1397	1678	1	1	15974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAeG4n6ikF8keZCpK3kJVXcQg6WRqffq1JvXEtBhJz1R9VEfp
42426	payment	2134	2134	1874	1	1	6283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTeP4tjkgCwvnbeR8XFqwZNBMrFY9UB28eNCPyCPTxXJj34RS7
42427	payment	2132	2132	1874	1	1	1653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmtkdUASGhb5HxXtTq68yA57b9tee4vkuMMxbLsGmnoGZLLGw
42428	payment	2133	2133	1874	1	1	5785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8r5Ui3UZHk2L47JZmWVkoizE4dGHruugNKtKRyUTkuGP5f5L
42447	payment	1397	1397	1678	1	1	15980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQMxxswMaxLbEe2nw8wGTjSJXkb6nbdD9FmEM4RBtV53KTvNK
42448	payment	2133	2133	1874	1	1	5792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYo4RBs2o1LeKfQD3iH6fBud2TNBpuqiRewoNZRCGgx1chwoK6
42449	payment	2132	2132	1874	1	1	1655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtywyq1a55YQnQUjDPfj2eCtz6JrHqiePvRJsvAv4exb3JEs8
42450	payment	2134	2134	1874	1	1	6290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9vK13PQDWkheCMac8j971tz4Djyw1VPLYvgvwc7pYFPcrEKL
42451	payment	1397	1397	1678	1	1	15981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9f4oP9dUPLigVEPZm5UVehSMB2R2qfR2siNFNrAacMxdGjrsQ
42452	payment	2133	2133	1874	1	1	5793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4g4b9LVK85GzY2L9WZTV5iBHtLeG2Fyuk2QmA6CagUBEgijs
42364	delegation	2338	2338	2346	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6mxMtkAaYsqun6gvvApgpLXThcUFM4k22vXoySJmBN4Zq4xH
42365	payment	2133	2133	1874	1	1	5767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQzfPFHSDfXDvQmCUCgymdxLFU4eDqTbycFDntSq3xn8XRqDt
42366	payment	2134	2134	1874	1	1	6265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSEhbkogchLEkKxGhzVPtTrQXgqSTBvXSEqXFyHDvhsvUQAyr
42367	payment	1397	1397	1678	1	1	15957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXt3p2euYf9VkoUMGALZP1WeC3yERVA1NmGyj2Pu4C2Zs8nmb
42368	payment	2134	2134	1874	1	1	6266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFho7sd7FQdyZqUngvbvLx4VBmjHeX6XZUZPVwNRVhgeRq3mn
42369	payment	2133	2133	1874	1	1	5768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJ3ztnhReFCXpeZ6uAgah1Hi4eTK75kHkKRF3QNqkpcfjJwou
42399	payment	1397	1397	1678	1	1	15966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmc7AxayocdgGsyh2YQUwbYQ1mSGco3GtdoW5fjChCkqDNsEa
42400	payment	1397	1397	1678	1	1	15967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfycKS8dYDKgmiwyL8fu5au2uFPWGz1Lqi4LKZLyGBvfjpFYLt
42401	payment	2133	2133	1874	1	1	5777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3rwsFrjvUrxkdQDnhLenb6ghCw69FU72Ei2WUyJPqwK25DgV
42402	payment	2133	2133	1874	1	1	5778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PsFy3U3cKFoBGD8hDK4FtYoUkDYvNvPfFcw8fBof7oBc3k9R
42403	payment	2134	2134	1874	1	1	6275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzXdgNRxn3jTThutQvU3yuGoLzR1MqgSBe2TGEV7orKdgwZys
42404	payment	2134	2134	1874	1	1	6276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXgfMQ2RFEdi6jKvEPeBQwhtwhYWAZZA6a7DiE5D69iv8cDGB
42415	payment	1397	1397	1678	1	1	15971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssH2M9J3N2R6EU41uz142AZK7Ercd9To9n5N3gRpgvMygAbyD
42416	payment	2134	2134	1874	1	1	6280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEHcmxLSA6pHCrs4YAX7aXhMzD7tvv5xNd4N8MsH88Re8Rvus
42417	payment	2132	2132	1874	1	1	1652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEQrr79BSfE8TAmLAVpxCUh54K6KuhmjRM36u4cs8zpNPJt21
42418	payment	2133	2133	1874	1	1	5782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42uJLG7eNnrShBYncMm2ndBkEwSaqm1GHNffFUTd5jPUbSGo4
42429	payment	1397	1397	1678	1	1	15975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqJqdZcwo6kDjW9aaK4JNg9vh9FcLAmZxSVdKkqbSsVHEfpCs
42430	payment	2133	2133	1874	1	1	5786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XbStt6zBAstU1dCCBNSNe15ayqLPDcoWxT17UsEksdwLNMDt
42431	payment	2133	2133	1874	1	1	5787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqkVpFYzkX8ePeCRSgbXurQoyjerwoQiDqEV2Hw8EFDdtJhkC
42432	payment	2134	2134	1874	1	1	6284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKWLwbvF7ma1zK6LTo17UW1gKZhqP1uiktoDKLT2bBNco2Ckv
42433	payment	2134	2134	1874	1	1	6285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrb6Zuv9vuVHwRQRNSYBGLYYLMLX4DxWwuvwdovxkGg48jteCm
42437	payment	1397	1397	1678	1	1	15977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1Vw3ZB6sbsZnZCHvPUiNpEsnWruKCAp9Pz6sSHUkViR9B8Ri
42438	payment	1397	1397	1678	1	1	15978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa937TmyEyEmEAfWYcjExk7uTNvv6Kc5zD5ZwgWyWBPUBZLweSX
42439	payment	1397	1397	1678	1	1	15979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUswvEXqtwDhPp4MG6z4qXkKadgCjccyHQW2btbFS41zVkrPC9
42440	payment	2134	2134	1874	1	1	6287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PrvuGzuTCQ2avJokHgCNKs8BAvCNsdzXwHxMMPW7X7DodaWD
42441	payment	2134	2134	1874	1	1	6288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpJ3epkm7j7rytKbf5EnGh7ZwgtZL4LuQGLdqUbvdB7LebM73
42442	payment	2132	2132	1874	1	1	1654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWXCiFW7dZteEfGxrn1KtAzy1DS8hKNdKjALxD3UN8LkHQMm6
42443	payment	2134	2134	1874	1	1	6289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5jBNgC5JD58n5G44WrKFAFQT9daZXGQdC2hz26gg3yBLrDNB
42444	payment	2133	2133	1874	1	1	5789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLLBXgkQpJ8cPAHKAff3xxn9nFrPe4t9HJUAfsYng3U9wyhrT
42445	payment	2133	2133	1874	1	1	5790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeAyzfKBD5JdrNN9Hie7ft2jk137kRPgNuxmam4dHVysVj7Xf
42446	payment	2133	2133	1874	1	1	5791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fnd5H4V1ykD62QPrMYZSTbpP14A6HR8LEcvV6YaCiPEd18Ea
42503	payment	1397	1397	1678	1	1	15993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7Qqx14kTxnKgSvuKTZmMLoKJ2Z99T2FZ5mo9e6ogyRgi2Ut5
42504	payment	1397	1397	1678	1	1	15994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWPdJ5Kr9tDgXcAPYspBvye5sJhcdWb9smEpgWPiMmbqsVvSG
42505	payment	2134	2134	1874	1	1	6306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjasTDffk4D8ggKsqfzWDkaUgBSFqXBi1RmkavNvLo7m2cKPe
42506	payment	2134	2134	1874	1	1	6307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEULXmRTzorrbq9PzPCLX58nD7D18eCWTn3jLFyx8b3tTjM3k
42507	payment	2133	2133	1874	1	1	5809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDk2aqVwmL5o2Pg1J1mBgCBzoyRvxxuQB9RFC1FghSFMZ6QAga
42508	payment	2133	2133	1874	1	1	5810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42K1tSm3YPue4yj19YmaACAip1qpXpH5KT3VH5nvbqAADtH6h
42509	payment	2132	2132	1874	1	1	1660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEw3gnuapEmN35SsNgjstXWCAF57wZtqauVjeYsc5nGCd3P7Md
42424	payment	2133	2133	1874	1	1	5784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wcCnfHCPEUtCYXwR3pTfrn6gtMUSts3RkeUpeqwPJt9UKDoE
42453	payment	1397	1397	1678	1	1	15982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScY1gEniEYrCgi9yaSBRU3gF7PU2qxCw3P1buPtGJ8joHdj7u
42454	payment	2134	2134	1874	1	1	6291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNxzJhbd4qrw7nHk3N9ioZbuQ4CyRNu4jrqQ767hNGQRs6r2j
42455	payment	2133	2133	1874	1	1	5794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZse6pJQBYpQ8Peiq3HQrtGjyUjZS4W6EDyXaXhbRR3RjzfQKp7
42494	payment	1397	1397	1678	1	1	15990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZax5JyGGGqTvLqStuoZjd9z922nuovuuoBdFoEwrY6sJXnyx7H
42495	payment	2133	2133	1874	1	1	5806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgJ8RH2UBFbLMeVbVFkZYh1iLfEprW6HUbDfKCccT2V8VbJVK
42496	payment	2134	2134	1874	1	1	6303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZjT8xUqzXiz7cWNNDzBEWvoHYFyheE92KzJnM9ceQx8oFR3S
42497	payment	1397	1397	1678	1	1	15991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfeX9AXrfC9pi7kNNYkk5rqd15CuGCLET87egWGw8obQuddpt
42498	payment	2134	2134	1874	1	1	6304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduGfZdfHxtGMLfbz8UE1nsJus7MvfuqPSrTLPzJPrcZUGagKf
42499	payment	2133	2133	1874	1	1	5807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bmqSGAjmqLKxegQwAm53VyVjbeu7G841tKytttErtMnooast
42510	payment	1397	1397	1678	1	1	15995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjynH9Y7ydAwJJmm3p3fVUyUTt8zpxKvZq72vN6HNGvRTtSfq4
42511	payment	1724	1724	2362	1	1	13	1000000000	6000000	\N	E4YRfJDjVKqwGS7P419UqpceVMLr1zRrjbeDz5ZtJPU9gHQ3nDgg6	CkpYgPNxodk57epELbQJMCQTSxSBEeSW5LDDQ9UJ72qSUQUyoWF74
42512	payment	2134	2134	1874	1	1	6308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7KXT1HKR97Xv18XocksNSBA6qfCKBGH2JjP6cVYVApsf5xyM
42513	payment	2133	2133	1874	1	1	5811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB8xmqgEPHmAAo8Q2qEp5SPJY9PnfF7qHFpUswXEhKamRdy7P
42523	payment	1397	1397	1678	1	1	15998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpZR6EnDq2R6a5ZQpVQaDuGQyzyuQMDaby3WisgABerP43Cos
42524	payment	2134	2134	1874	1	1	6312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7LmVsXjXiXfG71vQ99y5kdsMpZHujDukzJNtWakuFFr4vrWi
42525	payment	2133	2133	1874	1	1	5815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2grj4Mt9yTqiuYRxCcFhMrJd3CQ53qp3F5anePwFASjSVdrc
42526	payment	2132	2132	1874	1	1	1662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nSEJGkPed5wKG6myH2JpzgpKrktVC9mdvm2sCvPLY1ABx1Xk
42546	payment	1397	1397	1678	1	1	16005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYr8pJdW6u194Kzc1689qmZTiiYRaYwc7my9P2n6UWHdnXjJec
42547	payment	2132	2132	1874	1	1	1664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc5xerTCBVMM9jAbJt66RM45hCUcww9DW1VupJC3qJ1heyH1v
42548	payment	2134	2134	1874	1	1	6318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtckdN5t7cqXg13p3tSNwVyQRdyuFNetLH5K8EtMMRMcryZQU
42549	payment	2133	2133	1874	1	1	5822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sRyh2cMYxTwyHhg7MsMbTyd1UEU88ga7qxVgk7cGAPq7ATQj
42563	payment	1397	1397	1678	1	1	16010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCh4iV1tDrsi6rsPSTdreB1YFFqGGZ6FE8v5LqzVYce8LG7em1
42564	payment	2134	2134	1874	1	1	6323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4WNw7s343SP6A1QutATrVv1MUcw5nZFuHHWdLdwMKpVDLs8z
42565	payment	2133	2133	1874	1	1	5827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNnGmbWu3x9SFi7C5zdKtrNcfSvmHTbNDgNnHZV6zqLPRAKnp
42573	payment	1397	1397	1678	1	1	16013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrkeq31p1KeLSyrp2m6aPXACBiFwNPf2WT8443sokQSA9Cueg
42574	payment	2133	2133	1874	1	1	5830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEnY9sBD66Wb8c5fPmuaRfXBn41yagMTZ97qWMySAgERKq272
42575	payment	2134	2134	1874	1	1	6326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rivFyE1UXGtwjwQ3aQpZf6Y49ADCabwM5WhXsTcMxUhuYj5a
42586	payment	1397	1397	1678	1	1	16017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8ctecRdKuyHXYuVHVfXfttxD54UprgiPFqhyk5gvqh6EbrBe
42587	payment	2134	2134	1874	1	1	6330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXzKzfodiQWPh6eAFqC7Epu6CHbN3jwqZGNfBxULAfFxq8gWK
42588	payment	2133	2133	1874	1	1	5834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszWAGK4tD4n91SsRxDFC6U5rDBezitPm59kusNArNh5f6sxez
42609	payment	1397	1397	1678	1	1	16024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EQGS79uTs1xAVEpEPNAbFtkvDEsuDYCNT8bcwDfESXnwuUri
42610	payment	1397	1397	1678	1	1	16025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SkWwmmWuxQcqFiCmWM5C4wfpmpWL7PqWgt8dG1AkJLQGTBo6
42611	payment	1397	1397	1678	1	1	16026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmc6D8TgGfL3Gy53VADJYAgMvnmFAyAsb3UhTzc8DBgRRcwjN
42612	payment	2133	2133	1874	1	1	5841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf5wSKYZrAFUjQPDXsWqh77fn7Ld8JWFA9hCQLQrAP3gvUhCp
42613	payment	2132	2132	1874	1	1	1670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYem2WocAr5L7Do3tQ1EdjtqBNTZD6JpppWnBpChw6CyQorEBmd
42614	payment	2133	2133	1874	1	1	5842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaDQiMDVNfWSDQz5SzRcy4d68bXeFcT3Pt7gUZnFyqj7iX7Jq
42615	payment	2134	2134	1874	1	1	6337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwGycrgvC5Mz6UyVwUCbe6D99QcnwPz9nk6dHcxnQs54PQsLv
42456	payment	1397	1397	1678	1	1	15983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGRM7pfRYycvSJA2ht2SXGmoUMJjcyeusZbyJ7ktsTSyLcduw
42457	payment	2132	2132	1874	1	1	1656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGemxKawX4fVYMWsNx3JiLtZsCWEh4emnZ1H13unDRvCZk8c2V
42458	payment	2134	2134	1874	1	1	6292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH94fNATLWW9JAQ5jwLnnwvmpg2VGQAgTAkjCVspvsU3gDbdN
42459	payment	2134	2134	1874	1	1	6293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPc59uztoKfWg1sqHZmrtnmNr1Lb8bfLm5tV7RuXPxXJZnTKF
42460	payment	2133	2133	1874	1	1	5795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikbfuFj2X4iSA1fSnzFJifMQQiZdFjdkEy3PyJhSMj5M896nc
42461	payment	2133	2133	1874	1	1	5796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFyGBnf1JVJkmq7nyVsfpfJe49oAancyetvBkAuCQbRtJm5MH
42472	payment	1397	1397	1678	1	1	15985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvGzs3WCEAw9TyUL1k1NWkqtnh9SaUa9Mo1uAG3wzMRpq9nv7
42473	payment	1397	1397	1678	1	1	15986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v5hREUbaU24aarCL68FezTeD8eCjiq6njSFG76mHTpAPCC8Z
42474	payment	1397	1397	1678	1	1	15987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBzMuW81tekdRm96NLXNYbGTk8aA7uvmBVK42DvyYMuPUyJ3v
42475	payment	1397	1397	1678	1	1	15988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFcM6omVQro25XujWY5tF4xzre7kn2J7qmy9xrMr47smu2T19
42476	payment	1397	1397	1678	1	1	15989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtFKBtYFxzbimqpobhUV7dvMgVBHi2aDW5piDyvc46yaYraY7
42477	payment	2132	2132	1874	1	1	1658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUgvwqCNK57pzuZbL3vqJRABdzP37Zjnxs8z5GdczPoSa8yeX6
42478	payment	1726	1726	2357	1	1	8312	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvk4kVkymw6SguAHZNRfc6YqHdSxi6Q9HMgoTELwapnGS7mAEJ
42479	payment	2132	2132	1874	1	1	1659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SqtWpZSXRgV6p2ERpHtU1rcnKn5Ydm3wWY12cmY3csH59Eyg
42480	payment	2134	2134	1874	1	1	6298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2QT7yZHyKCsrHzHMVeHXCDQgSWXvqkBe6SKY2yKfMHiCw7pA
42481	payment	2134	2134	1874	1	1	6299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT777EPLDojBYfbrerVv4Aa7YdWfE3QMRgJpHp781aNG9NV1rG
42482	payment	2134	2134	1874	1	1	6300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtxnxdrXVpRgn7TkhhnCFuTpCZ1W24Y694KApyFtMMMozhgJU
42483	payment	2134	2134	1874	1	1	6301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq1LJQgVnRoQ446pfZ9sSTcvQvmDHz8QbmntuJsXoZpcj7Shg
42484	payment	1726	1726	2358	1	1	8313	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZphB1H6tfSmVUroYqrxTn3Qk6dMe7ZWNhrLxqXxdirGR8Fpxp
42485	payment	1726	1726	2359	1	1	8314	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT8WMX2MXiR2Dsn7PHAu1eNw4JYwZLmEzcRRyoWFERH5BNJ9cU
42486	payment	1726	1726	2360	1	1	8315	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiLNL7m69BngXuW2a2WHHHYWfeW7jtdeccZT7ArRqjKmpY7HMY
42487	payment	1726	1726	2361	1	1	8316	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdtGvQqaLSggwsUcKUnurr7wjv9RnN89mAwkfxWnuyCD9qJiTE
42488	payment	2134	2134	1874	1	1	6302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnJK1YRC1kinxAm1V26hYZVdjb9f8ci8cUJL4VqbxWR4HZrui
42489	payment	2133	2133	1874	1	1	5801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8acpZNC7PWhaUuE3UGttpDnWxcojkeefiq7E2HrYRgLQLNpx4
42490	payment	2133	2133	1874	1	1	5802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYah59UjAtZaD86iSXTz3P7i7oyR2AmPeZjVUP5yepUKkmNToE9
42491	payment	2133	2133	1874	1	1	5803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhjRjb6L4o723Yr49Yq7W5BFgztRov4U1fGzmDbhiEFfi1EcP
42492	payment	2133	2133	1874	1	1	5804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2c1B1hRBzLUSYcNXkLwHaZSrLCnBo6haSLCY1kfnyQP3bRW6S
42493	payment	2133	2133	1874	1	1	5805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDv5tku8vT8zDKNPVg82yFSGNcMGCLhPKbdvJDYRtizRoM4FH3
42540	payment	1397	1397	1678	1	1	16003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAGkqRcU5VhCeF2wN7pRZfwFA2m4HbvmWjsY4CimEArYwWjgo
42541	payment	1397	1397	1678	1	1	16004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnuZb8rfsN8KgqVptn4exHWRQeXrJt7kwcnwwoV7ssyPnaRih
42542	payment	2133	2133	1874	1	1	5820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2swfsXGsDARE5kUmDzuydKYg6H4xfgAtw89W8TaiuwLZChEmQ
42543	payment	2133	2133	1874	1	1	5821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AXBhnEmeENg1sgF22wvBDjkBkpxAtP84JWrVtV3SAGNeHsBB
42544	payment	2134	2134	1874	1	1	6316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9P8Qc6R26GtgmtcrTX6zadsk1D9bKk34orvHodGtDALDEycwy
42545	payment	2134	2134	1874	1	1	6317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZS5TtH5uGchqhPTWa5jXzj3fttWJib9nsxbcCPjtSWcRtE7r
42556	payment	1397	1397	1678	1	1	16008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWLrHGv8E5qRwXSw7VCDJG6CmaUsFs3JmtrkJii3GYn7C62g2
42557	payment	2133	2133	1874	1	1	5825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfv5hcvqdBfQ6dAMVFguH1EeTbzy9JT38vhJ5tDzg4SsLZsfGt
42558	payment	2132	2132	1874	1	1	1665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmSMB3GNEjvzHoEL2A2cQUHLPmj6ecFf6Eg1hJB2iw9X8DBws
42559	payment	2134	2134	1874	1	1	6321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhr6QtbSz61CHctWPQwWKSH8YgMSpLZWNwKoTsuYp621t313B
42468	payment	2133	2133	1874	1	1	5800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwZmGMEXmeP5PRBZxDy1xYBnp6kTBLLhk7nNT6YjFL7BqFX9D
42469	payment	2134	2134	1874	1	1	6295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB622qsgXwMvVUU6GrJmwzKhTMx9E3N9wNxc8TjBz1T2xXvURv
42470	payment	2134	2134	1874	1	1	6296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSHJz1vhmE9ntCewEjWtDUo7nSPKZzyRWAP6efxjbKK2Uvh8j
42471	payment	2134	2134	1874	1	1	6297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjoaSXWrS7WumD1DRkMK1Vpv4EFy24VvVUBQqMji8gF1gdy5z
42500	payment	1397	1397	1678	1	1	15992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMhekPdTCpbnuKDnJwGQh6VHBTQXQAvYhCeCd1GBr9U3wSvbq
42501	payment	2134	2134	1874	1	1	6305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYc4BUUqiARscTFXszKqyeype1xPsr876ukBptao9HcCnWArei
42502	payment	2133	2133	1874	1	1	5808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuCx4kUsCxa3aryDQWN99L3CZPLddMZaGrVUosiDWghB4fJ5Z
42514	payment	1397	1397	1678	1	1	15996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PXdGsTMjNV8Www3E6QVT7B5mzGrT418geWen3Q4uzcz6Wy3G
42515	payment	2134	2134	1874	1	1	6309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9wXLRJ9yxWt2R7MWrtxRfwxU99bvmLw9FSHBpVT9ihKsV4zL
42516	payment	2132	2132	1874	1	1	1661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtR7aRvAr5Mxw9u3uqZK9bt9cmnAirBDc27SLUQfsJstP7Hvq
42517	payment	2133	2133	1874	1	1	5812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5M9hqEjWQnQzvszKYMSxSnhq4vS7hGwMCBfxyzdPiHp9Am9rq
42518	payment	1397	1397	1678	1	1	15997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzKP3cygHovnq3DccdvL31pRs7LKzzoagLjcDXRybctNhV1cv
42519	payment	2134	2134	1874	1	1	6310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4guuL1mDrcWb9UP8CiBW7agsJhjiEVNPu1LS9aQMhEWpCaYP4
42520	payment	2133	2133	1874	1	1	5813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxVEfGzDYRsvFRRD2FQ3J9NkZ4mcRZkurdCvRaYjjrcLZiDgr
42553	payment	1397	1397	1678	1	1	16007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvNfMH7c721oEx2EzcdMGBqrTTpuNnnHgUEs2rSmgewg99TQD
42554	payment	2134	2134	1874	1	1	6320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1i7BD4bZKXLriJuFi95ZKLTAUxqYAQxwvSjEknXSvHojFwdC
42555	payment	2133	2133	1874	1	1	5824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2fLX3iwA38fYjKqtU4Uesa43jixkgK4Zfhrd1GEscmifDksK
42596	payment	1397	1397	1678	1	1	16020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24dnrQUgyh561U1uZXKcFSpVgBJjsscZje96BbWHbCBHLCuVb
42597	payment	2134	2134	1874	1	1	6333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNDfyWFyu2R7gKJfzyXetyzCAFrsVvYC3RgvAUMmXm33QCHaC
42598	payment	2133	2133	1874	1	1	5837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCBSwb1mUdMzeHLoFU44SerSwucxnZyWTajUPrGSpfJsJ8t2r
42602	payment	1397	1397	1678	1	1	16022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1cw5CJ6ybJ6KU76BfX6NNFCsVeBFVnu3vHCicyPhn3QdVTFR
42603	payment	1397	1397	1678	1	1	16023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ah1ZzPL8aXWE2HJ4f5QvUXtvgotEfVS7hMw4LoFpe1ceg9Kz
42604	payment	2132	2132	1874	1	1	1669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrMQt5Na3h5jZH1QEu5sX7ey2zmeJwnm1SBUR9yj5XE1acxcd
42605	payment	2134	2134	1874	1	1	6335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg69itqNAyCK7rJwPGs1vymHMJ65mDoC83SmTae1iGbfztJGDA
42606	payment	2133	2133	1874	1	1	5839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9avvSjvPPTUMocP1KwAkmH7j4CKNpXXTk4QmGpTv1r1ojhuR
42607	payment	2134	2134	1874	1	1	6336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1SSbe8WVGjLpTwWSSJZV67FLw39bQMmgpkt7LVjyBfhV1Qia
42608	payment	2133	2133	1874	1	1	5840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDiBQ4FFLWDJ7fuXnvRPfWFycjczE71Cs7gNroN6BVhiQTYkF
42618	payment	1397	1397	1678	1	1	16027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MLi3Qg5Xhnsr6VEMojBrUstRmEZk2ZazyBby51iJQSfjXMCk
42619	payment	1397	1397	1678	1	1	16028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeFTySfftRGaA9wL9x561kBYUA3Di7iktUytPYK7NmgMxy9Ho
42620	payment	2133	2133	1874	1	1	5843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnk9s35T7eRutwLPZwsXBRvFPowG69jBGHVCqtCBi86Y2CqSb
42621	payment	2133	2133	1874	1	1	5844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4xMVNNiASqMMjeuNsa46sfxH1yoHwAByLSMLceKrNFopeyRZ
42622	payment	2132	2132	1874	1	1	1671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmRuv19tg39dB3JcHLFdddgZYhGohpL8MDH2zQNHZxtiJTAwc
42623	payment	1726	1726	2363	1	1	8317	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhatWxqEYnJiAg9FRAP7Qxg1iX1bVJMMTtA15SYXaPmw5jP8p9
42624	payment	2134	2134	1874	1	1	6340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZQp4WQF6UfJSxsZWq5AgrkMsDHtg14Qq2tbvtYp755rLSu36
42625	payment	2134	2134	1874	1	1	6341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AAMJYji7Nd1mSQcR3Ho1DbjRMDuG87QK9noqhsainNqrX8bn
42629	payment	1397	1397	1678	1	1	16030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6b6zGEwPkivVcmygkuhie61rs34giQZTbXhiPEPThW8YPyvRv
42630	payment	1397	1397	1678	1	1	16031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCV4HZ9KTKE9WNmd4TbPwC7sXudN1Uoubq4gokPnMQzsLZyRb
42631	payment	1397	1397	1678	1	1	16032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6FCmSEQ35JNFsEtka1X37mradVfsgdxjFY5FbcvCq3JAS7oJ
42521	payment	2134	2134	1874	1	1	6311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXDsWGRvrufgvfnKf1GJm8b4GEHoFQJQj7wpCgRFZpprX92po
42522	payment	2133	2133	1874	1	1	5814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorQK6xx2eF9fH62Q6mdEZ8LfBkMLfx7QQi8UEgJhzLpdLRuS5
42527	payment	1397	1397	1678	1	1	15999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaazeaffWwWo5gJQGUN4wCG49LYUnUx9VM5Fh6CkDCs1KYqcj
42528	payment	1397	1397	1678	1	1	16000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUJCMxVXh93e5Uf4CReP8xPeBG7ztR1qL6emaTeUM2bw1AYer
42529	payment	1397	1397	1678	1	1	16001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7SEycf4Ai9VmW52X651MmxdM2hkxuFC46iPwp239GP9bG7SN
42530	payment	2133	2133	1874	1	1	5816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUL3h6VXXg88DtTHt6QAj515Efcuk2n2biMYvKajCsEgc27U4w
42531	payment	2133	2133	1874	1	1	5817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4RRgT4ht61uTSDwA9nZQvzgVQ5vhDVm7dT1PrL4amfDdxdQb
42532	payment	2133	2133	1874	1	1	5818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEFjtbMwKj2gnoPSD1W2H63HKsD45QuErHxxrpUdK6zP8p3es
42533	payment	2134	2134	1874	1	1	6313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXc8jucTmTp3pDo62b1YtiN8QTD5nzVm8wDL4X876FxMh3UP9J
42534	payment	2134	2134	1874	1	1	6314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkjWDU1LmNEKLxEfTCVCcPjoqJmTMj8VRcBZ3LhVkcrhBBABZ
42535	payment	2134	2134	1874	1	1	6315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfhBT8KuZPkyM3G1mtLqSKqsTQobCCwX7wTKzJ2w5cnpNvCXL
42536	payment	1397	1397	1678	1	1	16002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVKCWgZfY8A6fF4oAQHQK3YUgFs93RLmnqqvMU31cqozswQbt
42537	payment	1724	1724	2362	1	1	14	1000000000	6000000	\N	E4YRfJDjVKqwGS7P419UqpceVMLr1zRrjbeDz5ZtJPU9gHQ3nDgg6	CkpZFVy98ppDQH145k5wRV5NGQgv6Sx1B9xsGA1yC8ZXwKazzqTxj
42538	payment	2132	2132	1874	1	1	1663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWuBkeC1XHBmQSEzTansw3Nv3vMLdQaNHGum3iZZc7wQAxHGm
42539	payment	2133	2133	1874	1	1	5819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvouapJnCvTwayqwqLYUgUctAM6a7m1x5GQa4UZPAcbwMxs5f
42550	payment	1397	1397	1678	1	1	16006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2c3EFdyfL63iswTgE65Yge5pSAaFuKPkydseVXQnjxefqw7o4
42551	payment	2133	2133	1874	1	1	5823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgo1P73vARM5x7BPwdKt2MXt22Hba3QMoa4mRR3buB1XJ85Eq
42552	payment	2134	2134	1874	1	1	6319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77gBBmnvVLyuddvAqY6AJWYabd4BUoaQkho1RGxKmkfMybbL2
42560	payment	1397	1397	1678	1	1	16009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS14dyefiu423BV7WcvKHvseyZbzebZydvvG2aCSEZmi2h4kHv
42561	payment	2133	2133	1874	1	1	5826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopR6KTf7frzqy4juoengz3jpkKBhZ3adPVBu3EbYfjmQLmd5V
42562	payment	2134	2134	1874	1	1	6322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztKGNL87iQNaqaG3zLDfH4EDnAps2apgWm4jnrUeMQ7mZ84UT
42583	payment	1397	1397	1678	1	1	16016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8qTVDSYjotzHnccZTQkcqT8FcgEdKgg7JghmMNRN3Epikjqn
42584	payment	2133	2133	1874	1	1	5833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5K2KXnf9y3AVTQmPPrxSG9fjfwJkLXEu4H3Ri4g2J6ffeKkjk
42585	payment	2134	2134	1874	1	1	6329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD4qWbeYLTPEoJJu4ioCkA6epF938gyvCyQXpUb98SXG412fV
42589	payment	1397	1397	1678	1	1	16018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxunNogLR8xA6ss9mzJBhQ243DHWr86xmAYwaJhUXMpRbgDPS
42590	payment	2134	2134	1874	1	1	6331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVndZ6q2Ds8DHRRfopceTZtv1DSFYv69uVguDNMYvFcHH8VT3F
42591	payment	2132	2132	1874	1	1	1668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6P3jd3UQgdKzw5YMXuc5ZtQhBNR2TCpmsmNhEJdT5MQtKSRv
42592	payment	2133	2133	1874	1	1	5835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZyZMtbHYvRHT5FuUqEq68qEUtYy9cDeqaStVZ911M9kGYWVC
42599	payment	1397	1397	1678	1	1	16021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2gexkRjcwRt2rK5bQo1zsuprk2dTMMtpPxBgmjkEfxKNqKLK
42600	payment	2134	2134	1874	1	1	6334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6BxBbYkf4KwAzYvWp934Bz7Mv7xJpFcWuUUbeBg4kAgKnZHx
42601	payment	2133	2133	1874	1	1	5838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwW8eu9PJGvvFMoCRKLZsHrG1kCMKJPxZZPhkkqiGwnvHzrUdg
42626	payment	1397	1397	1678	1	1	16029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LFkUC2cEGUcpcrMazk5nPWhV1EUCC3Zy7NXnxP11WZ8ePRDV
42627	payment	2134	2134	1874	1	1	6342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRV2bHjivLaLQxrFbYEhbwhHZLEaaq1R9gREmMwrsRjt34jzC
42628	payment	2133	2133	1874	1	1	5845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gyvtKRhK1sTcVH9JzxmgEcBRWPtYoKBVVYngLTJfHH6WQdfR
42643	payment	1397	1397	1678	1	1	16034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKBHMFWX5AV1EncTxUSwdSGHawt8jcVdB1NCMSpw2BXnrcHvK
42644	payment	2134	2134	1874	1	1	6347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBDp9vuRK1UCXXUrsCJi2CW9QSQEkRaAxfNr5rdq664Kynn1E
42645	payment	2133	2133	1874	1	1	5850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseA3ShYruaXCPFLUazBdJLDb1Vg2KzyeqJVJfg2ktUmEUttAy
42653	payment	1397	1397	1678	1	1	16037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMJdeekLpGScMtTkq2uPfdrEpdCZNqHQ5aq39wMSmfdAtWN4d
42566	payment	1397	1397	1678	1	1	16011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCKcM7XxiT8c1yqs2QpVTeCVojdjfMaD1JkFuGRZrQsSzPKVK
42567	payment	1397	1397	1678	1	1	16012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSpqYGajYgsT4HsawtjECchDNqMAmWN4cmxbWgCRz7UoZfvx1
42568	payment	2134	2134	1874	1	1	6324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3q7J95mhnotAgPbEuZnxoXLoeXubEA9VxMVmY8nfRpRhHMJVu
42569	payment	2134	2134	1874	1	1	6325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbR7e7ePa7PJfwMaC2vXwc6HtCXE99YXhVbSwZpzDmmBMeyMq
42570	payment	2133	2133	1874	1	1	5828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGkFm2zEifmzKpCdxZzEXqMiRyNVh76tzPLpybh76DQE6RH8P
42571	payment	2133	2133	1874	1	1	5829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1CZfKMRv76kPkPgziDMKwJ4yeGJV1VdBFgSxSGByhuivqatb
42572	payment	2132	2132	1874	1	1	1666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQspaPuWLjogiNCxKYo2tBuYev2zeCFqQ8i5QLXfKsgZCWi65
42576	payment	1397	1397	1678	1	1	16014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNh6WsnCB5CHoBrZHWAcAPTYzpGTkioeTfoqYT1EQmPvMFffeQ
42577	payment	1397	1397	1678	1	1	16015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7a15xdn5RJbTYLtbNWJLqdPDes4YZCksSjFEPwg135tyeSLov
42578	payment	2133	2133	1874	1	1	5831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wq4onT4tnADyXxcb9eFv3ryHW54hvohmGJHhdPheVS5uWdco
42579	payment	2133	2133	1874	1	1	5832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJNAgg9ZaPKb34syydv3Nyb8yDaU3WkVPhDU4hTGvo7Y2Ccxw
42580	payment	2134	2134	1874	1	1	6327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHGJRPWDmM6ZmgojTF1W4Rdc9JP79DoaZai426NHRtPMc2ZW8
42581	payment	2134	2134	1874	1	1	6328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGLUxd8mESrjz1ZaFsyqRXKTukwmceJCjWiZYygGkPcTDgg2y
42582	payment	2132	2132	1874	1	1	1667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1bZxmSanqk5rAXL9XuRer4CFCLVCFZs36DGQRdYvXRMEYoYE
42593	payment	1397	1397	1678	1	1	16019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdG8ZgCwjpDYm8yGYSx6nPN9dnaYvGzn4nxcgT6hUjfKgSffN
42594	payment	2134	2134	1874	1	1	6332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BSMyzMuRRbHTe38do1t4mQuoqdKT5ih9qfBBF36fXBgevVTy
42595	payment	2133	2133	1874	1	1	5836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFk34AxFm5TMyFjh1dDUrgcayD18W7Gm34bTMADfuRzEsdjRTH
42646	payment	1397	1397	1678	1	1	16035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Dz2E4E4ShMb3fGbPv5YiaVqRCxkZhg9i5RGA5zCHHvP8mCSH
42647	payment	2133	2133	1874	1	1	5851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZdzJqE89XP86J7Q4R9XSaiv8b728JmbxnZAxZgYKz6UJN6hY
42648	payment	2132	2132	1874	1	1	1673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjg3hFRnjdyWJ6mV9VGHwHiQRDNwzZkr3KmnYFhxtsGGtZn2Wx
42649	payment	2134	2134	1874	1	1	6348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirAuS6zkuqbGvywDqxdsGsm9vbge21q5EzGgnXugNk6wEHai
42650	payment	1397	1397	1678	1	1	16036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKS2xKdBvRYB1dtSgiCuyigMvapaMMUVu4d3RrCreytvw2WFp
42651	payment	2134	2134	1874	1	1	6349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKR51wc3fozu4aWzzHSr8p3JfA2hBxp8YexRzxow7ChUBrQ7S
42652	payment	2133	2133	1874	1	1	5852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN3pkRDJgyJu3t1uZ5i3eY2buGSgLdFSZR2LX1Lo1JKVzRCvC
42656	payment	1397	1397	1678	1	1	16038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBgREzyvjtkXdCdvWKgFw6JXhQW3qB3cgpjgJLbKc8yi4ajcP
42657	payment	1397	1397	1678	1	1	16039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbAYfEQNCReegv1cPzKamKDnHd8coeF94YxXgqhKf4FjzEWJR
42658	payment	2133	2133	1874	1	1	5854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3CdeZTbK4Wh7phhT9rKDzUmwQpVJcFjTvdsePLjJNH51QoxF
42659	payment	2134	2134	1874	1	1	6351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2eT1xQ6KnH5qZFCCZqUt7w1fXZgJKPkQccSSMGxweoyXUNLQ
42660	payment	2134	2134	1874	1	1	6352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAMG4FMHrx2Ys5kLeBAJSGV8NwgGnyJr6CqPCCutRqt2C8JEJ
42661	payment	2132	2132	1874	1	1	1674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeADuXNfcxhHgSPNme7ADUN3KrM67HWELto1cQRMMvPguNRFS
42662	payment	2133	2133	1874	1	1	5855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Wxg47acFSZg5c2PHdUqToDvRJaVyszwS1BC7jkpG1uZtfPs7
42757	payment	1397	1397	1678	1	1	16068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdECg5nzF8A9yiXsmoEBMEjNkrqwVTtLuaaitd5ecuMQfenssp
42758	payment	2134	2134	1874	1	1	6380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVKFEDZC9WP5K68LhGn9Zgg93MVdBzCjg376GyMNAwUJchBiV
42759	payment	2133	2133	1874	1	1	5884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjXokXoXNouRuoZ4SnEGtUpvdeYXYq6tked2kvRybbJBFrbwQ
42767	payment	1397	1397	1678	1	1	16071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6qrgRuU1s3epkDo2S1eX6F41drviTuL9N3N2RGWabx7zRmBb
42768	payment	1397	1397	1678	1	1	16072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmYdiyEVqjhedoUvbugxKF2DzeXxChee8WNhA425zRGCuPUJS
42769	payment	2133	2133	1874	1	1	5887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTKhceteT3ukzYLLY3GncAZGe9cxbMKz6eg9NRy8NUzPQ5vRn
42770	payment	2132	2132	1874	1	1	1684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmse67h7ipnV8XRdB7d4ffmGEw8Qfg3RDoRs6u65m35wMe5D8
42616	payment	2134	2134	1874	1	1	6338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSjabjpsQy3GEHemaXU2gWWCww5qHQYJTyGivDbHykRmpzYUM
42617	payment	2134	2134	1874	1	1	6339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEGXGiXrMXwZSUoo1uVpesDAd36mnMvk1ju5HudoQEJF8LPdP
42639	payment	1397	1397	1678	1	1	16033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRtw9kxj6GhRBdqJPfWipqHtSQworCfojV5xaGc8WJr6NVjmu
42640	payment	2134	2134	1874	1	1	6346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTrVPQHAGNxrhPvHdBbk6bwSWCwqfcwDptaqufEivRZgz8Yci
42641	payment	2133	2133	1874	1	1	5849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX56tdcv9AhDNTSphtRDEVcfrAQTz8nr2V99GVz7c8oAqG3PNi
42642	payment	1726	1726	2364	1	1	8318	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyDVMs4TeAowdi9ERxLPD1sWYsB8URfPJuu9rdHybUyC5hNXre
42663	payment	1397	1397	1678	1	1	16040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAb5fEnWgwqoSXCgVwt53i6UjLgD7QtpbHLJ3hLsmUCj3AKZ4
42664	payment	1397	1397	1678	1	1	16041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Xho94aS4c4w1CbDsSMfsybdpzicAfpyBRxeYT73d8RG7Hifc
42665	payment	2134	2134	1874	1	1	6353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWDYGA9FAB9pSsSXXXf6ZeEkWNjDaVkefrAVtJrc5eKr8De3q
42666	payment	2134	2134	1874	1	1	6354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMttSPa8f8sUbjf6gXN6p8qHJQQuTNY4Mrx4J2cTFUyZTdVYh
42667	payment	2133	2133	1874	1	1	5856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXf37vFUfe4m19dzLcQR72HgiNja6E5wibsGQ1BZu2YHLXK4J
42668	payment	2133	2133	1874	1	1	5857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QmVpYbWNWuDgTdqkqarYg97E57ct9kCVU8WazVVq6vYZbKfj
42690	payment	1397	1397	1678	1	1	16048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTE2CvuvSJQwmGjqnxohJeZS4udB6RpTeFbfbiTf5kqz4Pqo1Q
42691	payment	1397	1397	1678	1	1	16049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmLej97gxTN9Aanh2zqiQsXwfrJUVU5KYHbJMLehQXKj7pQvR
42692	payment	2134	2134	1874	1	1	6361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGrMMnr2vjX63Sfh2t5w1Ron5b6cV3ZoEdc25N5CTb1qNWreW
42693	payment	2134	2134	1874	1	1	6362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQNVCuZSt78ckKNbsAZK4jbzksRgiyb5RRLKf46ho4rgAypsK
42694	payment	2133	2133	1874	1	1	5864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSWvRFqEA4UUPV5WQNazhvJf4dWMW2o9a3KkdYkE1T1NDVFHt
42695	payment	2133	2133	1874	1	1	5865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvWGbLpSNPkHbxLsiG647BM4NhZFd1gjC6WZNq4NMkEzV6xS1
42696	payment	2132	2132	1874	1	1	1677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GS1yAS4HBGVvF8UVWcC2LhYGZDHPjCPy15RSNeZ9zG64iZ6w
42707	payment	1397	1397	1678	1	1	16053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EGQKXJREmysKypT9fVAmQgcczQrBuMYgRpfMANTPu7tw2EXM
42708	payment	2133	2133	1874	1	1	5869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHbCXTDMCPu69YmTFUDYVpcb59Ee28EwLHm5U74MQg4FzagTj
42709	payment	2134	2134	1874	1	1	6366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebz2cAJoetecwzt7qX3nbgb4LdKAF2MR9Xsb3FZ2xYdVMbUUQ
42710	payment	1397	1397	1678	1	1	16054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbvsMXV7DCDzcUc4MiGurtUEv2Y2zKTazJv48yqEWBXdwGWR4
42711	payment	2134	2134	1874	1	1	6367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkmUWsYcZwA5TLAxim91dx6BHe2YivG7B6CWLeSod5wxiWRLW
42712	payment	2133	2133	1874	1	1	5870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGSUZXbixrYmAZZKU4s7CE6XVxjvrNg77mATMYXzQdrexL3CF
42717	payment	1397	1397	1678	1	1	16056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BtzD4sUha7RgoNd3Xa9TGQ3EPNrgP8pw7ygtqr8KGUYhqwTN
42718	payment	1397	1397	1678	1	1	16057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa518JEeKqCavWY9rdk5xRUw7zXwbQerJJpcoKmtmcSXjdqbM9u
42719	payment	1397	1397	1678	1	1	16058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQj5U9ft1AvmHFabKD7uNZAeFw2pRcS6TJVEsccLosmVy4KUCc
42720	payment	2133	2133	1874	1	1	5872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2QYVaXHixeNhRTzEVa73TiyTBmDtkrfWxmL3vWERW3mcnDyj
42721	payment	2133	2133	1874	1	1	5873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7du5FvNMJNKJcSeBoKysqSiYX5WgGQqt8eDtouFKTwKouJWKD
42722	payment	2133	2133	1874	1	1	5874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dXoU7wYdaB21vdpTuyfmtB91hs8yCQn9HZWdB1gCQQ1Cgf6R
42723	payment	2134	2134	1874	1	1	6369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PkRqk2ouWaivtmhbiNVBirfp6zD8A5XKTRt5wJLJ1ZJP3nTe
42724	payment	2134	2134	1874	1	1	6370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRjnQnUwLLgm9sfjFNaeZnwwizhEBKTYv48AfxKKnkPdezd2z
42732	payment	1397	1397	1678	1	1	16061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksyK5tMc5RNTDUyDkjEasg24638e8o6uSXmrCUZ7SLWyLRka6
42733	payment	1397	1397	1678	1	1	16062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnxKz1nTuVk4C1uB1RBfpbqYxuXFwYYNLoBoAC6VtRFGqNBfJ
42734	payment	2134	2134	1874	1	1	6373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyJ6ma4UK8fJwDUCTbVrTpaF7VcibJ5y9p8piomrnPGkCLKUM
42735	payment	2132	2132	1874	1	1	1681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62ffwxydbY3KP6pLkPMPr9v3VTqjJTtQk6JcAPcAQ7by1GBvB
42736	payment	2133	2133	1874	1	1	5877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZti3zT6LBP13UeJ2CFnVFSWmLRLvDccoddjFFce6sAhHrXeFwq
42632	payment	2133	2133	1874	1	1	5846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7SKMHy1wQNtHpmxvyQobjNUk2n3mN8efRWDQFLq729dxrgNk
42633	payment	2134	2134	1874	1	1	6343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsey4wW1CskRkAPAo1PrTUT3KaCduE7awyvsFmZWK62y6bgVu6
42634	payment	2134	2134	1874	1	1	6344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPVmKmr14Fh5QpR2YewgewVNGtfQNSc1hBkqugAmg9rAJ2x9a
42635	payment	2134	2134	1874	1	1	6345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHNK11RoTtoaye1zFzZvJny32AukCEN3hYtm3GGLQuzqvmDMw
42636	payment	2133	2133	1874	1	1	5847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8giiXWaBhz2qpkaQTN3eUEzaf5HYySnEUNfTFnwuaMgN9y3H
42637	payment	2133	2133	1874	1	1	5848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PMwiLDpxRBpDpdojh88gxvcZ4zw2MTZUh1TNqGBeqg6Nsd9Y
42638	payment	2132	2132	1874	1	1	1672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzb4YQ7xjmYJ3i7MAhh7EPGshwaKB63WsWEjGW3igWLfX5TDev
42669	payment	1397	1397	1678	1	1	16042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFWA9HEDS9g99YmeaVZ8arCdED6G9XAdmmRhaGR8UzG3qeqD1
42670	payment	1397	1397	1678	1	1	16043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSy4g3Dhqq79ZrxHaSLYkdt25xvdSPvgscSxfQi5BycsnM2Hh
42671	payment	1397	1397	1678	1	1	16044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRo7kzmYNGKgZ7qRUPpAKUbuuXTfw7FNAPEJrDDa9oeageP2L
42672	delegation	2283	2283	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrRUnhZbCho8cB6czBbhnVw5hWFuJe9H7adD91CqMPSVoeXhB
42673	payment	2133	2133	1874	1	1	5858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqHoKLZR4f1vuAmRGKuPEajmxdMgrTA6XPV24wtdD7t159C3V
42674	payment	2133	2133	1874	1	1	5859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpAcdAsVHBMNMZsAqTZJzX7CracNaGX6gvtooZ29EeRXqaVtL
42675	payment	2134	2134	1874	1	1	6355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQt4mLn4GUyWM8wWMR9vw8BdRs7Hz5JsEm3GmMSkMf3YRhHYb
42676	payment	2134	2134	1874	1	1	6356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQRtRa6CVmyXpyGmVCYujNviXztdB4hPb56e2LRwa3XBhTRYQ
42677	payment	2134	2134	1874	1	1	6357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xbLXbZTcgSkKnYnXuHEYfGLUXfq6Vy9RMt8DbL7KFtc3PA69
42678	payment	2133	2133	1874	1	1	5860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JdK19jnqYrFudRSsnWzfHJtwdS2fLtBqAVBPujbBDRz6Uqef
42679	payment	2132	2132	1874	1	1	1675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZNdk7AEbehfQCRuLijZTVUfyJNAwc66EkPYMYwcGQn7uUVpw
42687	payment	1397	1397	1678	1	1	16047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZav1iVu2UG2ZK2UxiGMN2NAh1Npv2KiKrthazX5yq8CMeVcYz2
42688	payment	2134	2134	1874	1	1	6360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVERdbGoaQqDq9pUzzycjxZbizxKEzBsZxarKLwoLZAz8iftM
42689	payment	2133	2133	1874	1	1	5863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLHxTqEX4gTqwBezQXzyJfWUdi4NnwqD1ekPy9q51B48HHje3
42697	payment	1397	1397	1678	1	1	16050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXDYT2M47v8UhZQJnJU845w9tic4BjgSiXzTe5b8suUTtobMe
42698	payment	1397	1397	1678	1	1	16051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZc2x1r8u9iagEKWAE9mVMqq3BvwNwfDg7gcCDJ6L7PfRHvD4
42699	payment	2134	2134	1874	1	1	6363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKrm5ePuz5ugLEBr9eKtyRdGp28isGMPhFQYHw8iRi4c5kL1L
42700	payment	2133	2133	1874	1	1	5866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaBoucDhNefVg47XUkMUK7Ch9BCPKVBZkno11SzNCgyXwFk7N
42701	payment	2134	2134	1874	1	1	6364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9Sygivk5o2LbPWq7REPUguPyhR3EKfzjnmtV1LQHHuGML3Wf
42702	payment	2133	2133	1874	1	1	5867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBLdoQ15NrddBQgaBkxZVifd2kAwM4uHdiRJVrXw4jn98hYWG
42703	payment	1397	1397	1678	1	1	16052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6JtFEpQiNmuERnpi7hbZADSXPqMksobrR1pa91m7Ej6Ghcmf
42704	payment	2133	2133	1874	1	1	5868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hsVi9EBkKdtpoJViKrvoFY8fkemmfvySEQpxwu9KBytr4MQ1
42705	payment	2132	2132	1874	1	1	1678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcic76J2dKKzMnxUkJUrpu6VdbpjKsdEWWVV1WnDx8BtFBqYiP
42706	payment	2134	2134	1874	1	1	6365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJhASaAcZtSaxrPhPzydNGS7ZedvT7W7wysvC47YEMQ8YJLQ9
42713	payment	1397	1397	1678	1	1	16055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrXWqcsdk32p8Mva6uz1VbQPSJQUPytNFnfBVbPVLzQVmucAS
42714	payment	2132	2132	1874	1	1	1679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc5p9hkczy285aYhWsGRPAQYzyhkx46EscFEjbVMjpU1nPkry
42715	payment	2133	2133	1874	1	1	5871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UH2dAzCTBB2TNcxRawB5vVNchqdrFyG9sYZF48NzPmG7Z4Wm
42716	payment	2134	2134	1874	1	1	6368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQas2PuqYtNeriweK9GFDQHVwLFwVHjNAaz7jQUrNQWQy1gHB
42725	payment	1397	1397	1678	1	1	16059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDP8So7KdXJkDyjEkZyPCtKguPumxAN69xfbZyvzZKDYn5pJg
42726	payment	2134	2134	1874	1	1	6371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJ9wvtF45CZ2Vk21hXNqJe4mnCB9F2N1PnDEW9uBvbnEMGZD4
42727	payment	2133	2133	1874	1	1	5875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvumH8aE7XqJkz2ZPsrRiW5Q4odsLq3WsATkQSpveMWHS8WYdp
42654	payment	2133	2133	1874	1	1	5853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdEUeUNGv6iYVin5HMEzERXnc1QfvaeKWdEfPh84yo3yhndBb
42655	payment	2134	2134	1874	1	1	6350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BMYHbbiK8iURi9bCFvHLWXbxCNwu93pbRBVgHnUhyqvQCa9x
42680	payment	1397	1397	1678	1	1	16045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWQwrtGve1LVUvEwtRx3466b1xbzQhuBjxuCefLrsd4ms175k
42681	payment	1397	1397	1678	1	1	16046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTd3ErzRkprsRf7PJXxX1PYdSbzem1AfxeytzyMETAyin6W1b
42682	payment	2133	2133	1874	1	1	5861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZ8at8f8Co5TT3QaVsnzdy5hboEYyw8QDLZ8DjsdVHJ7rChjB
42683	payment	2132	2132	1874	1	1	1676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYox733TiDszZF9ueQGf5Q6nF8AgjDNnGWCPoZ9JHSmCyzhYtbW
42684	payment	2134	2134	1874	1	1	6358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5xsWRgDisCnhQKVVC1arSLhNtKeL1QkYXbBsf2nczFq1CUXK
42685	payment	2134	2134	1874	1	1	6359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyPuTyaor3dVWvs5P65AFBJ7GCdV1HuUFDX4VLQ69SWpAhofJ
42686	payment	2133	2133	1874	1	1	5862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbdUGe9wk6pVtWHXfN7inKHbAYTsULAji7TCvQpCv1FRFhig5
42729	payment	1397	1397	1678	1	1	16060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGADgAqRbkYEWzN5vr1WTDKpDPjwDkXnvV6Nqdx6QNC8qgix5w
42730	payment	2134	2134	1874	1	1	6372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7WTPyrsKSaV6GfrR5t7VYMWWZNaV1B7XY5Qfq4zTWkNJu8Vq
42731	payment	2133	2133	1874	1	1	5876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gxRQhf2Hg7wt4LjqaYCJRFetgrbHxcE1oi77DNu2cCgTupEP
42739	payment	1397	1397	1678	1	1	16063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6d8XEkJ93ULt4EZrH2qbArRipTBHeBa3RChbi4mHDXkSK9DxD
42740	payment	2134	2134	1874	1	1	6375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqeJXYnKyzSCfjDxUwvuhJeVJmphFfwAhPfYp1vHKT1maKadF
42741	payment	2133	2133	1874	1	1	5879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBr5sSL3XiLPoJMYH8rF2kA4uzXMWAZGDJ2ncCWTcL79VL7xn
42747	payment	1397	1397	1678	1	1	16065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzq8SWmnMem4Uddn2mjHLY2w1mMjbkmVy1Hs3AE852Mwpuojko
42748	payment	2133	2133	1874	1	1	5881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyyXjpHQkBipaFvSbeZKPeDYLYMqSwbJG8rCjbRh51nfJDFoz
42749	payment	2132	2132	1874	1	1	1682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6HaQvSDZpWG6C9smctCeXrjiE3zyy7Kg5dVr4pSLQatKyYfr
42750	payment	2134	2134	1874	1	1	6377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoouYyFzearcNpKorMUFT91qAiREfC7kpwj26SPzmsDHc3VPLc
42784	payment	1397	1397	1678	1	1	16076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJfrML4Wy32Qr51jRMAdMW7m7WM19AiY93AVXGFg3DAAvhwcB
42785	payment	1397	1397	1678	1	1	16077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgt3uixY7fYfjpgbowDwBVaZGC43rxnUpY5yq8oCBioCteG1Ya
42786	payment	2134	2134	1874	1	1	6388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjJjKTEH2qQTZB9yP1wgXp2rvv5J4itNThTfqSTXmuwNTTUAz
42787	payment	2133	2133	1874	1	1	5892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xcS7yK32tUHqdWnrzp7gWCb9D2Lxi4tkKHzUtQdTbp2veMKQ
42788	payment	2133	2133	1874	1	1	5893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn3SayQADh1cjNBcVUrC8hGbAfY5irAjJtyZxAqwHQGvyayyS
42789	payment	2134	2134	1874	1	1	6389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnLVE2NCxsMgLLm1MxrUChaxLmWRpU8ayiqYYunf9w5VKw6kG
42790	payment	1397	1397	1678	1	1	16078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL99HnPDEBmMNT5f5SJKbDjavLbrFA8pqgBuxPQDDeZPNCbBaN
42791	payment	2134	2134	1874	1	1	6390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTMqna9V8Zxv5ZWERZwJczt3gD6BdyNEMbTs5vy7RshGRvWvN
42792	payment	2133	2133	1874	1	1	5894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6JU85pTModXoiCUbb6ndzuJTbe2PnKSTc3L1vzCtGTDjX4bk
42839	payment	1397	1397	1678	1	1	16093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvytRKzaGQbrPPnbN94sDKKnG776KDjqcVHWfrXWVdKJeRPBeX
42840	payment	1397	1397	1678	1	1	16094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwz2oHZi5WbAmptC8bS4aHwgcQQznhkumbPDXhzoow9ZfmVye
42841	payment	2133	2133	1874	1	1	5909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzUU7w4REAMkqmaZfgwhB1mHDnUErCor4uQ5iQzNFeHGCmtYC
42842	payment	2133	2133	1874	1	1	5910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3LU9szKMWhHkr9Lgj65LLLw5SNUzew2M53AzTgpqGsuYshKg
42843	payment	2134	2134	1874	1	1	6404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PruvjjRc91nCcP9PUWd4GyVjDUaaBRfwpy6bDnTB3hQtZKNd
42844	payment	2134	2134	1874	1	1	6405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4miSt9kyCoHj2bbuUPdEwix9jrc9ZDrkHhKGxaQkNfcFQN3iB
42849	payment	1397	1397	1678	1	1	16096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhL4nnxXbXQA2C1UnH1BVFyhgJUgFvpsA1vXHUotMf7E2AKWZ
42850	payment	2134	2134	1874	1	1	6407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYavurh7aiqHiNebzB1fqt1QrZbwNDjRpxVAwfFYwnngT5Eog
42851	payment	2133	2133	1874	1	1	5912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9HrUTuSncAkvQE2yJQHg7NFeNeiHCzu975r2CcHpm7bHvkvx
42852	payment	1397	1397	1678	1	1	16097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFj9B87UfJSNv1zUzqey3EKe3e5TWK28AP1dhqM7ehpohP4hxv
42728	payment	2132	2132	1874	1	1	1680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAotnBhYyLBzrZPYpnvVmT7Vd9eyHeszYodmpeUofU8sUcWpGU
42751	payment	1397	1397	1678	1	1	16066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgX1iQxg5GymNdSvZSK9rMxiuqyZ6ekpHQtvr1NVpjRmtqLher
42752	payment	1397	1397	1678	1	1	16067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4gB5V4kxX1LaCunggQbeuy1eikTqYd2TtZbZ43xkee1QDaEq
42753	payment	2134	2134	1874	1	1	6378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ988AQhu9SAtGi8nF8GVsLQ8j89QAQBxM2Q1i9AfXfdfwhamNo
42754	payment	2133	2133	1874	1	1	5882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJT9KkkLkgq7KUXVyEhs5f6SqF5ZFndW2XDFF1RHZ8K95C6Aw
42755	payment	2133	2133	1874	1	1	5883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHjWpqkDb3X2kQsyEQ1FVPfzjHRSnniiLjavsDQGA7Cv8yCmF
42756	payment	2134	2134	1874	1	1	6379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEEKLq8TUXTQjdx23syKoe1C16zEobVeQ32jNceCW56QFcQQW
42760	payment	1397	1397	1678	1	1	16069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi5WfQpAkH8euuGeUCD2BppTNDZ4TXZTXbmNndtd6RUciRV4Q
42761	payment	2133	2133	1874	1	1	5885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BoVgVEKrcBkjbgvwKk6WVBhLPKoHhs2LKKmqfTKZCZ8a1mKo
42762	payment	2134	2134	1874	1	1	6381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HXYkwWodmSxBDEYhsSaZkBdg8JJMqCzCb99dKwRNzta5AkCr
42763	payment	2132	2132	1874	1	1	1683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWKacPJUv4ztmBm9gfFRg518eMNA3RfmNLeVJgNTCYPfmCVZ8
42877	payment	1397	1397	1678	1	1	16104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRXavH7ZtJKWZdsfEke8KCZjn9Y473NUKsUjpo87FjMkTvgkz
42878	payment	1397	1397	1678	1	1	16105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSYBxT8Ugbm67FPE6eidU2xTyuiiqTQwUi8mkXvvjpjuLMYyL
42879	payment	1397	1397	1678	1	1	16106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtngposThNtx3L8HajHMCMXXoWb61XVbXwWMixM9anCyFBL3t6
42880	payment	2132	2132	1874	1	1	1694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQ2pk21VygQnRTacKHWKbrxJXKovZ59Fdafck78ZPfRqAeEvJ
42881	payment	2133	2133	1874	1	1	5920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ywM8NpUACE5Gf2BYDDpjZjHwoGKUvT7BokuxmZDa1NxKWqoc
42882	payment	2133	2133	1874	1	1	5921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9gq5kFo7M22LyRXa4fmX1GCNBZkHWKDaqHvDHPLrEeFStsh5
42883	payment	2133	2133	1874	1	1	5922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFwSmg8g9m4usu858LVLLiLyKESUHsE2QoeV7yShYtCpXg3pb
42884	payment	2134	2134	1874	1	1	6415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoT86JSwjvL1eELBkfQ1RD3fFwVvEb2Vzs3mDZKPDCZM1e6FJ
42885	payment	2134	2134	1874	1	1	6416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEy6FKgCG4tGqTsCpLN8tdrYwBtvRLJJ3pKk5rb4c3em36Kde4
42886	payment	2134	2134	1874	1	1	6417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxt5wNdZkKp59pHVMdvkqAPaDiKVxRyNoWZpiQkpzXnnypwnpR
42892	payment	1397	1397	1678	1	1	16109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcME5CKTNAemHJGq8uo3QkcQMMo9L7gAvWUg3A9E1q7798oTp9
42893	payment	2132	2132	1874	1	1	1695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqP7oBX1tjZC6sxdQafLxDSfrE3mrMhsPp8myoTpcoWnT4nBRs
42894	payment	2134	2134	1874	1	1	6419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzir1pQP4W1MNuQ9cXgexNB6DSfDxuZEDYbVjpb3untiUK4ue
42895	payment	2133	2133	1874	1	1	5925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nCtB5qZkoYCmAZEGUTzgaW78zUCWhb68asBZyxBTCzWymEAP
42920	payment	1397	1397	1678	1	1	16117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMK4ZdtpDKoifmMCLpCccLwRdFEsDoaMgJV4vzUh9LkSc9kfN
42921	payment	2134	2134	1874	1	1	6427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UxofCrVP6SkF65622XYFvHQizb4XpxDPeTNpreo3kZ39T2xi
42922	payment	2133	2133	1874	1	1	5933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyZ4HxPJXi63AkjMZS9MR12E9of2fiGkQq5npEKrx4ouT1Vsj
42946	payment	1397	1397	1678	1	1	16125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9uXQWEBkxeRtjjM1gGLeX1o4xsKZi5gnwYbqwrx6LNZyzY9W
42947	payment	2134	2134	1874	1	1	6435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5i51gfVAfzr9kma83YCC2WWtujzx5abJdU7oyPaaUgQxYRpDr
42948	payment	2132	2132	1874	1	1	1700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX1H4DjXhqxNzgb5Dz5d8LCbY39WXvRHaz6D4gB73nsed2yJ1
42949	payment	2133	2133	1874	1	1	5941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFc5bqVTPUPctkqZKvU6rdbRDyPmRFAmeMoLZSWHLQaCQiEAzQ
42950	delegation	134	134	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8jgtcELbcAevDoDaFE4fhHK8c5P52uAdroA91mmdS4aDoXVQ
42951	payment	2134	2134	1874	1	1	6436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8bGt2C9mqC4yd8XcwZAr9Ptn9t7PJLRG7V2iHXgGhDxEmm1o
42952	payment	2133	2133	1874	1	1	5942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVtTGJzSbVu4M5Mx4z2CwhAPvn2i7bbep14c2ijD69FuCcBLB
42954	payment	1397	1397	1678	1	1	16127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWqbCTqT1Dj4SvKhFKTNrxLZWN929QsfhD2wAAorQw8QmvUVb
42955	payment	2134	2134	1874	1	1	6437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2hcnCdLShZEhwRF85sRQiBqienaRkmiPtyY8JWZ2wficuAJB
42956	payment	2133	2133	1874	1	1	5943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoEyj9menZMAGbD5dexFAW8dnBKKY5q4B3sPgyVKrPUVhCvn7
42737	payment	2133	2133	1874	1	1	5878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjwvRXbM2pmJEFS9SGxhfoijYPrDCdqoQ7t2Bs33fDuMtJv8X
42738	payment	2134	2134	1874	1	1	6374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5WTvVe51ars4cFeWg6eTgd9LrfBLgAgeFb7EjPnpKsyppNuz
42742	payment	1397	1397	1678	1	1	16064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXx36vyPk88UW9DaV1sLV1vXA21PxHuKgPzy8t757dRVgPnMy
42743	payment	1726	1726	2365	1	1	8319	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYi3pmUcNBX5VytuJkLhV4GmZvm5fXjAx45u3GbDKRwVQonrJFa
42744	payment	2133	2133	1874	1	1	5880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36aRcj6pBUdGKMuqLW4d7mRu9zyKg53op3D5z9YsKgn3DnPDV
42745	payment	1726	1726	2366	1	1	8320	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKXj7ejcp2gHvaHSAXYMGEiHb1TPoJxZepu3PazwDwFPLuk8kg
42746	payment	2134	2134	1874	1	1	6376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9xmLTuQwWorjCp1pJcKgyUXEDZwT798iNEx22MrcHw6do1ww
42764	payment	1397	1397	1678	1	1	16070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGg2qH82Kzu2Zc5snZ7YdhJGZyxjJz2Mqczgctxxz4QG7Z3bNb
42765	payment	2134	2134	1874	1	1	6382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxUrLU43opoNMBZ8EaT6hYnt7LAkREKvRi62xcKxwJWSfjFSD
42766	payment	2133	2133	1874	1	1	5886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsM6pxKpJxAURvrHyxdYZCpswRPLvR6ENoMuJKmZuR1jm54cd
42797	payment	1397	1397	1678	1	1	16080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJapD8kXc7HK9MjLTgooLr75xS3wiWBqdCYvmEuxERQUYCXox
42798	payment	1397	1397	1678	1	1	16081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBaZiFC9v9JJ8S2PzD72VMYrznJjE93YFzao3Kqo478rUoKN4
42799	payment	1397	1397	1678	1	1	16082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSDViNtNdG95cXCmjrC4PwZb7x7m1YpdKEHMGA8FVVfboj4ga
42800	payment	2134	2134	1874	1	1	6392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWFyWxZZ3vaaJAZ99T6HJ55AXswoQaoXZDyFt7CKcUfab4Ass
42801	payment	2133	2133	1874	1	1	5896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFjcikruMoc83Z7qduGpqgRbfCM7PDzFEuBpUn5P8x16NF7zB
42802	payment	2133	2133	1874	1	1	5897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6KXLgrfY6Rigpdzs1wAKq9ESivx7ZBWqNKeu1ArUDDBX8qhe
42803	payment	2133	2133	1874	1	1	5898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzjSZc5dBDR1vk8uwZJL6BwqjuX7fUh19UCnGUiGJjsYfzYB3
42804	payment	2134	2134	1874	1	1	6393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY82kpSh2shjCkuSP6K4iZmcAfukMg2QGNPCsoyZ9MPjqm6r8
42805	payment	2134	2134	1874	1	1	6394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmviRdSvuTmLpfyCj3D5Do11JBqmYNMyBAgddKbpNop1QVh7L
42806	payment	2132	2132	1874	1	1	1687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAp7jr1peRBwJTfQtDTe76Q8AMgiuH3gQAr9ce5M9zvh66kHyJ
42813	payment	1397	1397	1678	1	1	16085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBynHJRYm36xwRphjzYojBnu9Ayht42eXLi6oP9RAjkmYD44E
42814	payment	1397	1397	1678	1	1	16086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyArk3X8Ha7QoWk4qvXtMHcfnN6Y8u4LF77DpjuK7xkkPvCQA
42815	payment	2132	2132	1874	1	1	1688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAxc43BA4XXBvdnZtrG5Sdo3MsQoBgiRny2ntTr2uYSvYJWPL
42816	payment	2133	2133	1874	1	1	5901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8iD3nPZ1jK2WvFLwxYU5HUuXBZKGymi648J2nYLrexDSyvJU
42817	payment	2133	2133	1874	1	1	5902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DRnoJYN4PBzEGorppKFgQfSz6vo8X6Mfzdh9sZZJyWrvoSmB
42818	payment	2134	2134	1874	1	1	6397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Qj8DdzjRwxxNNnMAeEtr2cqQ5orDj9QWtMqkxfiiQfRLpc4S
42845	payment	1397	1397	1678	1	1	16095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZCvomJX6thwiqGJyEyzS9ksMHLz9hAnSHXHX52Ghx82K8aRT
42846	payment	2134	2134	1874	1	1	6406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiuzemZ8QCkM8K4jL4zxsCVErSmVMVZGpHrw8S2Jxv43ktfaQ
42847	payment	2132	2132	1874	1	1	1691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLweC31jyua1KQLt9PZQgm6XroZkwp7yGXUPts2bGScwWtp67
42848	payment	2133	2133	1874	1	1	5911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTGcbv8rHJt5hLEBLbopMdwk36frWoSjURjiy2XwUuLT1kEBj
42874	payment	1397	1397	1678	1	1	16103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkv9Jay2vq7u2TcybrcJRDkZCZnaD4NLXWChmQPEyy4cs4qNE
42875	payment	2133	2133	1874	1	1	5919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYH8Vhh29k9ffkanPWszywbb4z7mfbSXjkzpzMLWxdatR6eFBQ
42876	payment	2134	2134	1874	1	1	6414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Bq8HCdabKyeNAHEjw9AWRbqqxS2UYhftfguQP8NbMyK3LoD8
42910	payment	1397	1397	1678	1	1	16114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUuxkdjWnNjhydBK1aSKA18DPq2egTRf6eoQduM1skf6t1KKny
42911	payment	1397	1397	1678	1	1	16115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyhnYiQn33iqrzvruAgf4VTwAycoF2t42MiibuLBf1toKYuYa
42912	payment	1397	1397	1678	1	1	16116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YGGYYVtezbLzjKTT2bdJ1eVkHhFG6nADToWrapGJWFr9waU2
42913	payment	2132	2132	1874	1	1	1697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbr2Tb2rgpn1PRSVsKho5NrqpEaUU3JEbm6yHSUxAtZAPekDh
42914	payment	2133	2133	1874	1	1	5930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PjaMULvHtJeYLiRcDXCqARLRgAFAEyuNNtEVViQFUR1svXwJ
42771	payment	2134	2134	1874	1	1	6383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhZ5utxp374f83sWLhKj9ChcX1k4XfTNyzHP4SXtZtwmjN9Lb
42772	payment	2134	2134	1874	1	1	6384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2TzYVLwmuSomhyPVDQdSgKdcGKQ1Hh9EuuQnSdaBFB1nxk3E
42773	payment	2133	2133	1874	1	1	5888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZb3uANyyDKTCtwCXXPxy9X3cDmjWMazmNhnK3mia5BpdWPRv
42774	payment	1397	1397	1678	1	1	16073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv82P5jV56Yq848UCVUR9EP9zV8ZQMUi9SW75aoyVtDfR8jW8X
42775	payment	2133	2133	1874	1	1	5889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgpTqcbEt6jAyGZwE9dcbV7fgJCdzq9wjQrqJmYohLEY2scV1
42776	payment	2134	2134	1874	1	1	6385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqwAZ2gCb9aMUqHSMb6DvmQ26mYqPXPLsAo6XDuvwH12L9WAA
42777	payment	1397	1397	1678	1	1	16074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fWSHCFArUy5QRNbGJtPUFn6nFbPSL4PVryv7ko5j8wrSzFoW
42778	payment	2133	2133	1874	1	1	5890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z4LUxfGzWABZMBYNzmmgBEBjHb3SGJDFgjH6RFs6m1s26tkg
42779	payment	2134	2134	1874	1	1	6386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmbQCcQZNtvgbPT5PJF4BmBjE8VTGvVyNEtqxomJwYPkfxujL
42780	payment	1397	1397	1678	1	1	16075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQUxXbp6WxUV77XiEeHB4Yw3iqzVbhxstVFsjyAXPaEyxXqZp
42781	payment	2132	2132	1874	1	1	1685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabGZrKyogwNpCvY6dvmMdNzJgc9TqriCFsUKuZGd6fTvU5Bzq
42782	payment	2133	2133	1874	1	1	5891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaZTnL9hP933NyZRNoQGhDt6bt4FTXYrivCvNpNWmQ3RoQf7z
42783	payment	2134	2134	1874	1	1	6387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQGEbb4ALX88mQjDztx6vazCxK4Kn9TWXZKWBu2FniGEi9iaV
42793	payment	1397	1397	1678	1	1	16079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzueLzV8Mv4c8LoiCbFupvSCRaddLpbYBMhZqQvhUcTHRYsVSG
42794	payment	2133	2133	1874	1	1	5895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsnTMXqJUMhFgeZMw6xdfxScnV5KRoaXjwNuu81ygkkEx5zQ7
42795	payment	2134	2134	1874	1	1	6391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT9XcjirQCdWoP8DgUPiU5dVaaHk6X6r6WRBFAxNkM2noAZzH
42796	payment	2132	2132	1874	1	1	1686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXhYZXZ787dcG59SgFE6DAur1HMsqjemzMP64kakNjznv6b7n
42807	payment	1397	1397	1678	1	1	16083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmpwFgVYx4N7FX9Bj5KTRPnQ6VVsfg5rKRhnzLS6Ad2FUtvHZ
42808	payment	1397	1397	1678	1	1	16084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr21oLBMPyo6qLQ18AgVjQuBtsrcWr8PqVhmCCrarMsW7VP82z
42809	payment	2134	2134	1874	1	1	6395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQJYtTecUpdXNa2fChKgZGvTUPJ6CUhCSnN5k3YJQSDR38ntg
42810	payment	2133	2133	1874	1	1	5899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhhV7ZNgJdWrsEJDZ32gWWjT2BxmGjg4sVHB7Dyh7zW421AFa
42811	payment	2133	2133	1874	1	1	5900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGehMDb9t9VUUHfWVnrZhS7toDxt7hwxTCZvn4SNHradqAo4W
42812	payment	2134	2134	1874	1	1	6396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP1fgXEcJqa2wssKtxrECZM8u3GL17jfbZLTD57CFCfa5t22Q
42819	payment	1397	1397	1678	1	1	16087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4JE3njrxt9AxnvmNELqgrDANm7jNPjB5SMRH8Lmox1BxKbUK
42820	payment	1397	1397	1678	1	1	16088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p5kM1vNnsULrUz7RyTgqeyRuXejTFK8QZZNf1A4mgAVs4Y6d
42821	payment	1397	1397	1678	1	1	16089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpvuAmUB2paobdEz35NS1pdfLU8dwWorwiSsNV1HHmQ7h4MYU
42822	payment	1397	1397	1678	1	1	16090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsp3CU2b2mLXTSBSPbpAkWDik53t7ejYrdUzX8nq1QG2cTAgj
42823	payment	1397	1397	1678	1	1	16091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18FAnhU5yoiwEz71wxwf3CQRSVYJnYQ7fvMNDXGxUt5fp33FT
42824	payment	1397	1397	1678	1	1	16092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmQGi3B8gYCZP1wkcBtnrTLZuJxtL1HSYqz4jKhAJe4n61Qbc
42825	payment	2133	2133	1874	1	1	5903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwunJdFdPmRbJXZ8ZVt9oAakLMzwVtfimcK8HQA6DzSL3rScH9
42826	payment	2132	2132	1874	1	1	1689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fkFtYd87tkQvWgt3NT6zJm4s9ouKLw82HmLDvVgWdEHMvEGE
42827	payment	2132	2132	1874	1	1	1690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KP5ow62hcat2jE8qBSKWUSfhzioDfTHjCHcikg2ihxgXBnG5
42828	payment	2133	2133	1874	1	1	5904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCiSQQUhtxWSo293pqdqk5o2k9CC21EqLtApzWw98jusf56Fv
42829	payment	2133	2133	1874	1	1	5905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ERFBULeCHNsxXpWSokNqA8H3areicX2D9nxGfu8b5mAfxtK8
42830	payment	2133	2133	1874	1	1	5906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3Qi8SvFoVuDYDJJfpH5mfNmEtRLn957TCxKAyKm8KD54GTFb
42831	payment	2133	2133	1874	1	1	5907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BXBmXmCK1Yzs5eMrP8bpuFMTwZq3wjMwbNoCGikCQ8AZAwAi
42832	payment	2133	2133	1874	1	1	5908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6CzxWDZ1XfpL8HFTnbBvJyj7PcEcbMJ6BFQz237viuJt8SkK
42833	payment	2134	2134	1874	1	1	6398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JCXUgqsjqs5qgrFk8D4BXU5iS2DhqXTdSssfPQ5uiv2PSyZw
42834	payment	2134	2134	1874	1	1	6399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SeBpKTFu9CYz5KUmXThv42cJoN64miwCC2J7MhYioNXDhcoV
42835	payment	2134	2134	1874	1	1	6400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgP7qf2Gra7wFwJh7H25KwTsQEtSFWh3UHU42VDUN6x3DaucW
42836	payment	2134	2134	1874	1	1	6401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcL4LvfAHwmfXFAphddM574CqD3jtkpdspgKysrvcZbEKL8Zm6
42837	payment	2134	2134	1874	1	1	6402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Z352D2u5wM6jExL58tQrgreC8764aK3T5jQiECwXq55Un5p
42838	payment	2134	2134	1874	1	1	6403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq8Qjtm5fZoTZjgfqCFs8zSXckSYpfVRvWXUc3jau77LL9ZjA
42870	payment	1397	1397	1678	1	1	16102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYsoKwk83t7VfKmu5ThuznQzUyzqgzAjj3HFpFUtYgoUgyBB8
42871	payment	2133	2133	1874	1	1	5918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPCtNf45kp9eKFxkcgF21J6oTbRqh5LWChNxnx5cibxFU7Myg
42872	payment	2132	2132	1874	1	1	1693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVfT83z1upcrPStGFJ2EHpq6zbLRtTBPBYUEH3PzWn1HHtpf1
42873	payment	2134	2134	1874	1	1	6413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoioLGNEZV5utbTwsT65wuBVwi8nWVL3TCyvA7geBQWQfqcDF
42887	payment	1397	1397	1678	1	1	16107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXYR3m3vdVvhS5AXmo6LUjRw45eAAAoX8vMR4wd12NCUgH3nh
42888	payment	2134	2134	1874	1	1	6418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmygBadR43VdBE6f2o5Hn7BgLWw1oVXroZyNxPkujdT7t7BSA
42889	payment	2133	2133	1874	1	1	5923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58i4TWZyk13UJQNJyRpeXj46aQVB9TTGuL3JTX4K5hcYK3FWf
42896	payment	1397	1397	1678	1	1	16110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEBJkbgBaVbXx9uqWGMEm1rdvQyfbAKpPJtakbAQxKyaa51Zx
42897	payment	2133	2133	1874	1	1	5926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWhGh9GAtUFYzT1SXj2EdVN2HR21hDmQYkY9Vno3nmAT1CKdw
42898	payment	2134	2134	1874	1	1	6420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9aATUv4WP41eokn5ArdVuBDeYEeB9MN52GMkSijYWk62JEZCz
42899	payment	1397	1397	1678	1	1	16111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYN2nPBhLuZcNifVDkxZ8nMn2aKsmxBJuAfzmADxWxLt2aNrN
42900	payment	2133	2133	1874	1	1	5927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ2U3xcKykhut3ANmCpJstJd3cccRfYM6buReDejEkYHxUNim
42901	payment	2134	2134	1874	1	1	6421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHJRj5KW27DzAQWo8Lw8yKnxje4sF4r1kP12CewPsjCE5UhyE
42906	payment	1693	1693	134	1	1	1248	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZDLSydovJCnsN27jcaQYiaWQJPytbosxfwhWJn8qpL8pFrX89T
42907	payment	1397	1397	1678	1	1	16113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsod3pEWLB9nj9us9dVHfL7sFeqBrfvMuFnKk1hpxfxZuoy63
42908	payment	2133	2133	1874	1	1	5929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWh2pKdeawSzU2F8pRkKek5ufPRcefN6kts3ZSfo9NEA9B377
42909	payment	2134	2134	1874	1	1	6423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowXnqNcu66SC5hsCdLdxS35BfdvVvoYi3xkaQVpSRtUmvCT4A
42923	payment	1397	1397	1678	1	1	16118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxUMt7k3vmboacRqtGd4YwBVFoEjRf6wQMzE4RTbzVkG9jrM
42924	payment	2133	2133	1874	1	1	5934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmaJDJbKwYNoKM9bhwjQwtwxSSkJMUeYC3CRYndJFhMD4ubJD
42925	payment	2134	2134	1874	1	1	6428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNGPDEDeLwzzEc7HxfisjoLR3qS72aheGJtVqCjRb5yZwTcMV
42966	payment	1397	1397	1678	1	1	16131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9cafPNEZfppvvFYKP8dYCPLaCsTxLEQkEAFsgAgSqCSqj4jF
42967	payment	2133	2133	1874	1	1	5947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1rTx6uTDS839FakDoLDfR8KHJ4HjtBU27Kk9zjSFaH7BzHW6
42968	payment	2134	2134	1874	1	1	6440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4v6CjMfuPLRoPuZKX49YTR94cjD3gSo31uvAcaZvYuoyWvSU8
42973	payment	1397	1397	1678	1	1	16133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUsHZWMgNWqbtiLgS1W2W4VRjYMJRYZHhuuAgrHNLKX8rFuU2
42974	payment	2134	2134	1874	1	1	6442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfcZGkS7AFSYQW6umGKrBYCsrwcS3B72MHdmQMufSeThrugxa
42975	payment	2133	2133	1874	1	1	5949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsHNmtGtipEFPpn2m97tcmz2fjGzPfCUePx87LUpvL3tfJxrw
42989	payment	1397	1397	1678	1	1	16138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWm1jfsb843G1LZGUEJotwVwVZvudV2zq2TXzCNuqgNgDv58cT
42990	payment	2133	2133	1874	1	1	5954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3d931T9L3kcCnLYrfUbPqmP31jsrN9qYRuLPkrs3ezrKtdGqh
42991	payment	2134	2134	1874	1	1	6447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEn3tT1jGYGd157ZheCNN1qptbJJaEA8iJJSuYFGGCujiEfKbs
42992	payment	1397	1397	1678	1	1	16139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aShMWo97oxiH2JeVEwQ5sfa6n4d8No2jPoJ3Vg2EcuYWQ2LN
42993	payment	2134	2134	1874	1	1	6448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXnJSgUBGceyJywPxrf9MpoYUNUgPoasatvCoWLXq2P19ebFi
42994	payment	2132	2132	1874	1	1	1704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT65sNP5AYhHF63qrV12gwuzk2UGFzoQ9HY8by3r28L5cCWWT
42995	payment	2133	2133	1874	1	1	5955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj14a9yM3wdQomTNUrTnbL4UwhuJA9zFGrkzfpMHGdsCQMzS5s
42853	payment	1397	1397	1678	1	1	16098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDcnNyfgZewxaKaw5ijKKD8ByYPBHUNRXsmtyijxw2DfemEE
42854	payment	1397	1397	1678	1	1	16099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ifF3RwXTA3yo7Rs8e8QXg9goc5HbtNBeJt8qzrePFZ8VAS5d
42855	payment	2133	2133	1874	1	1	5913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQT6XTfxmuU3HHgTA5qJR7CzsbKaFBcMGu3sFpNv4fx6bVJE3
42856	payment	2134	2134	1874	1	1	6408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee8vo7kBf7Pr4w8327FbvtNck3SHF3zWPqTveegHqp13VcPoZ
42857	payment	1726	1726	2367	1	1	8321	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuUhzfzwXMQ16eHSYdEA7HwDq3zGa19HMr1D8ddVc7ZPEZBCkE
42858	payment	1726	1726	2368	1	1	8322	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoSkDBFnNT5cs4VQ28T5j8Nnc1noLSSvjJurmYPow1h2nyGtxP
42859	payment	2133	2133	1874	1	1	5914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7psZ8fSB7Y2DpwP5CVnNkweXuJTkNDNTiuAon8PYWBaByUSC
42860	payment	2133	2133	1874	1	1	5915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLqGXxyxfMMte5sxXScbAY7pANvfpGXWmNZM7xXvSwMYakwPR
42861	payment	2134	2134	1874	1	1	6409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88gTXMnL5KSAhYAkwk43cu2yQ5gXoMFh32BCeEgPRZR38FXkm
42862	payment	2134	2134	1874	1	1	6410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89ZZbM1DKuqyFPm3dZ6g4BmeSJtuvDTUZLb9i6REtXxt1eivT
42863	payment	2132	2132	1874	1	1	1692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRmP69VHwJPQe9LcwaJKJSkrmVjB5LW67cEyrQWS3FHLoZMdb
42864	payment	1397	1397	1678	1	1	16100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7nXw8TrGq7Djac33rr3wEpcHEBPSbWnFbFeodmJDsR96P92C
42865	payment	2133	2133	1874	1	1	5916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAV2oQ95H2g7PjfXykVja3gXSq8d9j2AhD2bpLoGGpAwrvzJD
42866	payment	2134	2134	1874	1	1	6411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7m3noTnALrdnffSPvX2x55eyfX1usvnVFt84mhCMihKHvFLst
42867	payment	1397	1397	1678	1	1	16101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDXjKnr67xR7VNsecKKJMBDMAjG9Aw6EkTF734MZp8HMV6hcS
42868	payment	2133	2133	1874	1	1	5917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCcQFimkvEwV6U1L42XsUhporKKp2BZfBFT2UqGEcAbG42vTp
42869	payment	2134	2134	1874	1	1	6412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaXULikDnkKXqHNfi8NkcTEJ93nsmnMSvkqQmkay2DxGqg88P
42890	payment	1397	1397	1678	1	1	16108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazfTYx5DgeBrRjF2kfy4XkDzh1zJMUEA9uoDUehDughxUk8VL
42891	payment	2133	2133	1874	1	1	5924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpYkfs6uBRsD6P1EFCY8Zv7GztJqw89bdb9Xn6JSkeQB1wDps
42902	payment	1397	1397	1678	1	1	16112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiJAv3jd1eVsHPpEzkWtzG18t6ERnKxDojZUN67bsm2HnJHwe
42903	payment	2134	2134	1874	1	1	6422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmsC3kLEhp9mmJnEFki57ekPxNkosANnT8GZzwidjFZZrCFi6
42904	payment	2133	2133	1874	1	1	5928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdd6ncoAWpiFEgZfDk4AmKh5zV2VTL63d3m4r55TBGKcovF73s
42905	payment	2132	2132	1874	1	1	1696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqxi9onv4iXNSzhsQyw4PkaCzpp82UCMzc4GqEAjyvNLk6jbs
42926	payment	1397	1397	1678	1	1	16119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbB3sRKzN2WRN23cvYmFqunGcqsxg6LKxE1kpb6gVJEVkBuKN
42927	payment	1397	1397	1678	1	1	16120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyPkmsPGxpkieXkf38QpkVkAs25ASuLmPi4c9JdM6DAuTXbdh
42928	payment	2132	2132	1874	1	1	1698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4iGh91GCYeogMp9GrFzqUprg6wEUDbnCLeeGAzAoUjbnWMAQ
42929	payment	2133	2133	1874	1	1	5935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeKW4d7XnnjUZvhBMnj6Ep2ZYRoWRwjdgxhKmm38tr8Nc87ru
42930	payment	2133	2133	1874	1	1	5936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTm4ftqLEKKN71B6bYr2KkgBci69UajSjjwcK7by1PFPgW4xa
42931	payment	2134	2134	1874	1	1	6429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bGE13w1CSWyLPd9amuuVDqXjYMgjGy3YhnhRq59r2NVY2NJs
42932	payment	2134	2134	1874	1	1	6430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnitAVet6AcbiYwfHCjx8eoKhLXwhVG4EEq6qHDV1TdL21FVW
42953	payment	1397	1397	1678	1	1	16126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDRHyMXDfWhQmptzAzevGm54N8Rr5ywTQbjgX6mdU68QA23r8
42957	payment	1397	1397	1678	1	1	16128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeiU6s5LL9Hc5aaXdCyccer1jbkPNK99TCvJRL3eAe5GuD39Y
42958	payment	2133	2133	1874	1	1	5944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSxXExp9hoP55PSpfE1okkEZx5ZGx7BHD8ZZrBuLhpNhfF2c7
42959	payment	2134	2134	1874	1	1	6438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEMCJyHBvhmczUUH2xW1VWS2Ug85xW83aVcgaZhpJWTrXTBmB
42960	payment	1397	1397	1678	1	1	16129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XQ3iT19njqQMyjk1BeRMyKCvRvW5F8uE9vtht9Z1n5wGXJLT
42961	payment	2132	2132	1874	1	1	1701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VW5YGRvrSsYoiya7PpXm1NKz23ZFwZ3FMYeR92WXNEu9g7di
42962	payment	2134	2134	1874	1	1	6439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdkRupEZUqr52GiFHURdxh57rEZTTUndTsDfixH9MSXgMzJfy
42963	payment	2133	2133	1874	1	1	5945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Rxi5r4KPCg1XDm9oYXbyVHyqcgmCbt1pUGYZWDYRwKTDgPD
42915	payment	2133	2133	1874	1	1	5931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmz8pGVTzMNvt6cR1c4z4vSUKunbDUMn81znBX5gHaYBc7wcR
42916	payment	2134	2134	1874	1	1	6424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCz61LUU3aGVwao2rcxCUoXGadDtWjVBvEVuMjXPHhHjHqMpGq
42917	payment	2134	2134	1874	1	1	6425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV2MjmnoNrLEawa6yefkT9sN3HmWMETRsaWSaLRwv5geRTR6S
42918	payment	2134	2134	1874	1	1	6426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6nxMqsN9N79GAab3oyumJBAC66hoShRtHm4RV6J2BeGNG5YP
42919	payment	2133	2133	1874	1	1	5932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoRBPG7HyXRcdikCf8tTv4wY6FVNVHSiFUPr7ymdPNcckjoSD
42933	payment	1397	1397	1678	1	1	16121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5ncEvHKDvuozRNem9ENYFqH8rtXAycDSWjMc5PGqXBVyc8rL
42934	payment	1397	1397	1678	1	1	16122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEouPfkK2hAKoSy6qoB6wWPFXq6e6Qw3pmrHNw8SNM8X5W2WC
42935	payment	1397	1397	1678	1	1	16123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjEiW8ef6igfcuHvDuFPG7oPA1nkW6f6tkCDN2fJm9wjx5Xuz
42936	payment	1397	1397	1678	1	1	16124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6fCDXHFwxKaoefefz15y4M7R9X6Khy1dm2n1DkRfADa7cGDE
42937	payment	2132	2132	1874	1	1	1699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyVAve46ssmeNDc2zu95xa2itNxw3WrViddpmppao6u1KtLzR
42938	payment	2134	2134	1874	1	1	6431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitGuZnRkDVAAoSPAo9nh34EYYzAs6VhtvcTGEYuuhH9imk5wy
42939	payment	2134	2134	1874	1	1	6432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9e968emjFs1nnCRbEooLmLuN5JHvqYDMWtWM2PyATofvdJkVs
42940	payment	2134	2134	1874	1	1	6433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrY5VRSjiLWkLwSDEFLdKMqFt9m9FruENzmJsRuSpXrvCbJg7
42941	payment	2134	2134	1874	1	1	6434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbT9F7agdcidAmwrjUdqczP3wM5LqdWMgHT1fQz9pR7hv8heR
42942	payment	2133	2133	1874	1	1	5937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQYrx1MUE8dbcD2qfvqm4KJLWNik4nxn33Mn81nANaKwH24RM
42943	payment	2133	2133	1874	1	1	5938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9L3jwqSwUhXP4fVHzr5guRCDzLADDt2DTrCcJ1GqUrwu8Cgc
42944	payment	2133	2133	1874	1	1	5939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vRa6q6qwYaH5MvFE2Mn8eqPDXnhkjQ8mVtWbaYNLxYMMPuL8
42945	payment	2133	2133	1874	1	1	5940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVUdbhTUZ3rhgifRkyT7ZUkahzTvK4svvp4iY6h4uSRMqYiWS
42969	payment	1397	1397	1678	1	1	16132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5EqAd7neZaHZHh6Aow4q7ZGhkiccjq9awcvXwQKQ7fFvnR7T
42970	payment	2132	2132	1874	1	1	1702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tDZsuxurSsPhPX5B7rVzj2bnAW7dfcaQeyJFtRnfGACaHuja
42971	payment	2133	2133	1874	1	1	5948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKCBfXjnYTvsyZ13RuLZCWDHAgFwy2kWq6jjbTRaJBxjgnFQy
42972	payment	2134	2134	1874	1	1	6441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnznBx8kZVgCi9WWpfj4ex1QXHnvQtmAmq3t24N2dMCLVAXqhN
42976	payment	1397	1397	1678	1	1	16134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ABFvVcLuSzfFie5omDjWRZDvhBW9KVBBLJMfNEi2wRQPRJ4
42977	payment	1397	1397	1678	1	1	16135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFq2mDMuryTNbNZ652krTJCx3m29FgfofG1hY6dpKfkg5Qpyr
42978	payment	1397	1397	1678	1	1	16136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9x5mssy3ezcQjMA3BCQRxiF2ayLCD27kiCkoR3sbGU7Uvc5V
42979	payment	2133	2133	1874	1	1	5950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjZ5ZmDMypqDJCU5LHxiSMeENeNrRg6Rm7ncQ78WD1V1DSrB2
42980	payment	2134	2134	1874	1	1	6443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNzPSnb2vWKqQw5g8crPM9AbEuV91tTAoc4doTg2HBqPbwHSq
42981	payment	2134	2134	1874	1	1	6444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7w2hd6H1AwE7M5UJ6tQbFWsqxDUZHBKMXQmbntm9HZGWHQtP
42982	payment	2134	2134	1874	1	1	6445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUzareJiaW3krYnCzaiHhmckFZww1RXaRgGGqqH5o3pJMxTs2
42983	payment	2132	2132	1874	1	1	1703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHa1cc1EoenkmFYdmLYsfogwgeFLHQ1r4UcJcEmm8uHsvkG4j
42984	payment	2133	2133	1874	1	1	5951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpvvwhgbiPPVKuURLGRLVKzb5iZzzbvyFc1rj9uk1CkWTxtvL
42985	payment	2133	2133	1874	1	1	5952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsF9c8jrHGtaZgz8M5LcqrVicHDFPzNEiMi8FF5MgT5ouJcmM4
42999	payment	1397	1397	1678	1	1	16141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECQDZBaHoWt4DEggdBbTeRRNMvQZP6YPTzqoXqLGM1SKiGrAb
43000	payment	2134	2134	1874	1	1	6450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgXKw6nSFQXCMD8QhgdjR3c5zBernV6efAyLq5JpuVS3zYmrA
43001	payment	2133	2133	1874	1	1	5957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTGpNpap4V8B1KZYLgdQUM4g658xBoX6aoesMKkTQunyz7Rg3
43019	payment	1397	1397	1678	1	1	16147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooGPabYxN7zWf29gKBrzzgCmV5TnoMMkGa69qLRLNJUnxWf4L
43020	payment	2133	2133	1874	1	1	5963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9WLuKhmczSCZMJBzfWXDjC4sgirFWnsrYXLBzDAnRDG2WJKW
43034	payment	1397	1397	1678	1	1	16152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUTsqQW3VqiABKBRRuRNaqXVtBBzYKuZYTcNBeUhFwMcsFq8q
42964	payment	1397	1397	1678	1	1	16130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gDbZqqYG7uFPLMVHdg9tuLyn4665ng9EE14GdE7BB4S7W7or
42965	payment	2133	2133	1874	1	1	5946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLD34z6SLeh5SD3KiWYowuTVbbTipZUfvUTxARzi6NpFtHAsai
42986	payment	1397	1397	1678	1	1	16137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoboMNmX6Ao2eWUzDhgBoL8v6rLjBwVoftUhz3RvrDuCkn8oE
42987	payment	2133	2133	1874	1	1	5953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEyrdmjotqszVRMtXuRJzNPQaYrak4zC9iNGD74EZCHdsSseR
42988	payment	2134	2134	1874	1	1	6446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsq1jaHQSLc31EXEQj2jk3LVa7mYfksUyxQ3JBZsFbzTD26oJ
43021	payment	1397	1397	1678	1	1	16148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZafia3ophyfqX3AuXi5fZ6GfeQA3mcDJCRBxkLpRx1Tf6g8Fg
43022	payment	1397	1397	1678	1	1	16149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyENe3npp9762kv2KQFZ8j8UPCet96GjqGXa5ATyEhuqQobePB
43023	payment	2134	2134	1874	1	1	6456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7UBt1N6kfS9kZAiqM9ri42qrYqm9uCn752w5me7cy2g98usK
43024	payment	2133	2133	1874	1	1	5964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkorLEjYzaU5ojJ4sLZfDXsGGXB14xjjn2yQjmaFooiaJXaXz
43025	payment	2134	2134	1874	1	1	6457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nkRjWKY6HVNWaQiiA2McwEN6WB6J7g1hSHoPnrHwEzChChis
43026	payment	2133	2133	1874	1	1	5965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucL6wrGsyqFgA7smvifwLzkM93M8A31a5LjHDTR6BGBAEWMpR
43027	payment	2132	2132	1874	1	1	1707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4A9UQw6Kue9cnoAHAA9PXDed4VYx6mTHUtuvbgmzohFDuCZT
43054	payment	1397	1397	1678	1	1	16158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqi3CDJANVYFMdUwZ7CjQvDc2P7SJL5BEMHvB2PRu4wtn1TR2J
43055	payment	2133	2133	1874	1	1	5974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCLGgrQB7kTRQaFAEPiupfavaHQ4mBQFemtsV8PgUeymnvdM7
43056	payment	2134	2134	1874	1	1	6466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPeW1npuU8V4A7NXrbURvMNEvAssARogUKa88JCnCAHx6SYT7
43067	payment	1397	1397	1678	1	1	16162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdu9DJo5kZmpmo7RCoKm3crVSWCptLes8yZz5KM4Ey2W3eZLdg
43068	payment	2133	2133	1874	1	1	5978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpi812xEGLYXn5SvaknBPFmb5inYiK1okCTJxrVfS4NkQDZGC6
43069	payment	2134	2134	1874	1	1	6470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2ogCZepmUsGeoiR9py832F5uKFYk5PrHewLXuHiDsrgqgx6o
43070	payment	2132	2132	1874	1	1	1711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8UE2RyXedcgX54PPVQx3ku72qzwTKYfyyzqVtX1F1PQRtys4
43077	payment	1397	1397	1678	1	1	16165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnuRpWRyzVoyBoaa2eFSZrud3UNeaZtn4xsg3UAcEka9cPcvd
43078	payment	2133	2133	1874	1	1	5981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxB541jZ67GpjxgU6qAFFu4XG98EaC5jhnjT5HzJxX8mmEE1Cg
43079	payment	2134	2134	1874	1	1	6473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVEVts7tSNHP1hSUq94jiPst6T3oqsSttKXo8SCf8GXVgg2b2
43080	payment	1639	1639	1841	1	1	3	720012000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86mHE9MNL42t7smEeH1Su5qNMCSyun9CTq2o2VjYi8o4BBgsA
43081	payment	2132	2132	1874	1	1	1712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoB6ck27Ume5rbAojVwyUEgt9gfKvb3peMbGFFZhCQkCKrbmLL
43088	payment	1397	1397	1678	1	1	16168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSH1fnwtNRFB9Pr8ebvf4Kct8SbYHCL4qDTnh9zp7BbshY9ieF
43089	payment	1397	1397	1678	1	1	16169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND3tEmsnirA3D4SkJzmhDwjJf8RbQnwHeCWUXnrGqUAhstipw
43090	payment	1397	1397	1678	1	1	16170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXd3PQRVpSxuzCLrnKNp1r8LcpFC1KKyMhnwqBhpkCVAPFPgYP
43091	payment	2133	2133	1874	1	1	5984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSHS1NiGqHboo5UmkVNses4Z3nbZgFfG4gmphmzBK7F5c5mMz
43092	payment	2133	2133	1874	1	1	5985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcajAQGvgaTK236BEKnJ78NZcmnabuQM3esNJeFuUrAAWV4Ne1
43093	payment	2132	2132	1874	1	1	1713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8tVSVGtfAGDFEzurjrvhHZvTSacrMUrzrUNYodFH5sydbyVD
43094	payment	2134	2134	1874	1	1	6476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9dPQFQ1WkkDJYBjeTej5uADtCSzvDZTN3qFSmtzEXPwSsZAp
43095	payment	2134	2134	1874	1	1	6477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxL7suKNeKJPmaHSe5p33aFVhUyb9rYNXyWWEMUKMX29LRQpfw
43096	payment	2134	2134	1874	1	1	6478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJvVzeXch76Dmt64Pps9vgDsy9jkkG1jLMCTpYE9GNGxAFVbU
43097	payment	2133	2133	1874	1	1	5986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdg2NyVSR3xNfxoEJvrgXv6guww5uHsqr1D991TWAGFcFK4oT
43115	payment	1397	1397	1678	1	1	16176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowDG23uV82Z3ZtYEuBJXougwRnKQwQGnj3S4X2iB1smRMSFns
43116	payment	2133	2133	1874	1	1	5992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorp5Rjond1N8oXTg5UzUVBFcQUtHdNCXdgcG8G6XrqtriXfTT
43117	payment	2134	2134	1874	1	1	6484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabadB3bn1euxw6xyLn55j8Zgsw2ejD32sn7nyzvxjqc27UgKT
43124	payment	1397	1397	1678	1	1	16179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8oZ55Qf8Ro8gPZQYec88cqNFuGGHjreA2z3TFXgW7dty5xur
42996	payment	1397	1397	1678	1	1	16140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbqexswUq7QC5ZQwRvDxjgy1K3sKzqr7eNLzwh6m87TiHQdrK
42997	payment	2133	2133	1874	1	1	5956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX45EDBck7tJpxTbsJC3LeQQsu9nAuaJz6PyWhgRmva8WbKCPX
42998	payment	2134	2134	1874	1	1	6449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbZ3pYUeKjKtyrTcKSVtQFHGPPgPvytHHP13tLNBDrXbyhFEK
43031	payment	1397	1397	1678	1	1	16151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22enrFpRNaVrmKxLRRJtrFjQ8hTuwAJ2hnGXrEBkjzHC1vL9o
43032	payment	2134	2134	1874	1	1	6459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh9HGfb3KsPFfsCUf9MMA6Exx3ktw6kZTtUrCDYewV43jv3KX
43033	payment	2133	2133	1874	1	1	5967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyaQ8AuGr7UWsNMwAYr1W6szZ6Hzchyf6AdbyYpHVYvzGs2Ej
43105	payment	1397	1397	1678	1	1	16173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZknjA2ZNYPYjHqkzFwSfCCY6pTNATwSj4j1ushcSMLo6jr5JP
43106	payment	2134	2134	1874	1	1	6481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZiVyaz6cgWMUFw2E6E2sojK934X38Ehx5Tbd1h6QoepQnJJt
43107	payment	2133	2133	1874	1	1	5989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTaSW49BEgk5sdtPZMvkf3seiYKx6uCb57coKd3DQ4vH6A9wFZ
43157	payment	1397	1397	1678	1	1	16190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bPuQYQYUdHV3WtnDZybFRuh6Nkt7NpG71to7GGgVmq1watp7
43158	payment	1397	1397	1678	1	1	16191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsVQFNwAXTxRb9fJkWQqAiQMJowfg7hQFYLXWCZUKgc6Aq6yf
43159	payment	2133	2133	1874	1	1	6005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWmoMj91ZPB7bBoDLbmJhWBkxYp393aS5AMo2f4zo5oJYYwy2
43160	payment	2134	2134	1874	1	1	6498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqmQrumYNQfGGJK5s4T2NWjyR8KL6XSaXsuVncB9u11wD3H7p
43161	payment	2134	2134	1874	1	1	6499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwALpMsFWPGNHXJFnsjAcpeBrWsbq5eiS1HTDxahAz827Sdm2
43162	payment	2133	2133	1874	1	1	6006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpRcZ2BrMkwD1gCXA1UxyRjSPRK5FiLYsDRMRErEa3JSPTwGN
43174	payment	1397	1397	1678	1	1	16196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSg9cXpmUFy6YahMdEVV4ajtQpUN7v2frELQtQCZNgvpa9mFF
43175	payment	2133	2133	1874	1	1	6011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCwc1zMPXJADqCwqgLmaSGUghWZUZiyS4tZW8rhxSZfGChqGp
43176	payment	2134	2134	1874	1	1	6503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitnBVrJsfGGLZfcveNG2X5P2EvNKmwV1ezQuH3QKn5PaquA9M
43183	payment	1397	1397	1678	1	1	16199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27vT5kcruE8NVviLVVA5p2Ksao4R1Q6f3Luz1dpMaXsWar99o
43184	payment	1397	1397	1678	1	1	16200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpq6QpPLg2JyjpDqfuYpqJWgq79Gxke2D8drcjXiudUyoijgM
43185	payment	2133	2133	1874	1	1	6014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo942ttUdwcvztDbcfGzzn1UfgGf2eChUQmiTjHt7R2ENNPNhE
43186	payment	2134	2134	1874	1	1	6506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv39H1DKrCC9Pwg8Uq9sjjjVvsjQ9EPwMjsBgaUoo3KSnNrG7v
43187	payment	2134	2134	1874	1	1	6507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSGyP3TZSn6cZya2PDXvrM4YEcaqQKTnB5WJoW9oLvxkJ5YXL
43188	payment	2133	2133	1874	1	1	6015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKofD87CEDw6PKzGC5vJv1EPQCnfUfpZQ7BaqLz7WYc8NsXL44
43189	payment	1397	1397	1678	1	1	16201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzC5mR8D9NHXDZw1qUTWB26jWHftzu4v29u6ghcPsxgtsDaPx
43190	payment	2134	2134	1874	1	1	6508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqPNiNZF4sPzjq98BzScbtDQUfpu4cFmJyfmPc8GDGbd44Dbj
43191	payment	2133	2133	1874	1	1	6016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpGs727NGZnfhwGaCKkNCMDvM2tbBXiAHHZnyqnzoqfZ7rDnq
43198	payment	1397	1397	1678	1	1	16204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55ATUkwFuD4N2UMzweiMH6afyzuPY9bfYp7R96Q6aUNbCuKCa
43199	payment	2134	2134	1874	1	1	6511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZers2qG9aLfVDQ2R8C4tGaDCfRhgCwSR45tXvgnHJV61ERYf2Q
43200	payment	2133	2133	1874	1	1	6019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRCmtTeB6JXy7yoVTsDyEtGWWUhov4V3Djdp8dP5E9RzsUTD3
43201	payment	1397	1397	1678	1	1	16205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdB8v6YY6FRWb9poD7efB789CG4sESiq1Qu4FjDAJUaccDfPh
43202	payment	2134	2134	1874	1	1	6512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzyeVkuve2NFJdwkTLeuus4HuMp854DR9AQ9tnu1Kkm7JdRwa
43203	payment	2133	2133	1874	1	1	6020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eScjS2ygd2v8vc87sug3H1K4BvqSKFLcTAPVuEr3AjwLRqDV
43204	payment	1397	1397	1678	1	1	16206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6RKGhH9eSfdn2N9goPkB5idD7HrddQ1SyJmFTQkw1qK2q67j
43205	payment	1397	1397	1678	1	1	16207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9hPT1rXLZ4C3AkJ5WNgjCqXLRR73RhJDqHbBhH6BFa6uw9By
43206	payment	1397	1397	1678	1	1	16208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygGkxt6HSQVRyV2YE6ZdV3e85p453E51PKsjoUZ5CUohgpjiw
43207	payment	2133	2133	1874	1	1	6021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDiJUMfX96gJKCmDdFg1fonERrjuvi22C7E9jpGULMhqX5KGM
43208	payment	2133	2133	1874	1	1	6022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqDfDgBB7VqJcbbxhCwzv9oFQbCWVvgocNvMHDXV95PZncUSv
43002	payment	1397	1397	1678	1	1	16142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzpNipVtQheh3MSkT6b59e4Tqrk7Xni4is2yN489bmW6biN7u
43003	payment	2133	2133	1874	1	1	5958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YHa5AtuYwjJjVUiARuS1M4XckhVtDJ9K7EGWvhKqP8ZfDyPV
43004	payment	2134	2134	1874	1	1	6451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZXznyu3hjti4GGVD26DNzMV5oAQRmJnXhL9Ghnm4UKroSiXE
43005	payment	2132	2132	1874	1	1	1705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9foB8Yo33o6KSef8wXE2XN14nQ8nYwnyyYpvQZkk4TaMXUpS
43006	payment	1397	1397	1678	1	1	16143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpto4UwwDet6gaNFZ7nZnAGotdSi9aT2Ydc5K47UGnukN63tQ
43007	payment	1397	1397	1678	1	1	16144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrahC2TFEk886zkdtxjjcUYweWht8TbL2mYhdPdRZNUR61icVk
43008	payment	1397	1397	1678	1	1	16145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KbEQt34XnmEutaGwfehKNheKoX2BTLNUJiatiJxeCoEcDQrj
43009	payment	1397	1397	1678	1	1	16146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTErWhdBtYjQEceGaX7Vn11Mzi2BrbGh4L52FUvwURQWLqJJpk
43010	payment	2133	2133	1874	1	1	5959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28tYuobSpVzuLhkVpRgmvKwjdAS2sBF1gsBJCCwdqJ1NAScdM
43011	payment	2134	2134	1874	1	1	6452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbqgiSjNpBD8REUphwtCMFbj12wQw29V6XLTBcyu42jRsEHxk
43012	payment	2133	2133	1874	1	1	5960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRBVU5hMhBKxYGR68LS7VZuCKGt1SZDhFJUJR7Mz8EpRb5Gpn
43013	payment	2133	2133	1874	1	1	5961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCRiqRZ7YXbJgkoFs8agmRxr9a1zSJnUUmR6h6Xty1LYkppKm
43014	payment	2133	2133	1874	1	1	5962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc6YMVr2FqXx65jMN2WFpn42MgLNPnpG95TxUvJxxuRNNQwdi
43015	payment	2132	2132	1874	1	1	1706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALiRpvF92KZWcKnjZiru44u97QN3pWmEgQyKBe4UVLKDTdnFk
43016	payment	2134	2134	1874	1	1	6453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2ZNAMZGxs1HoyAGJrWFJMUztXzXerSQ7zSFoZ9Y8GGJsRSaF
43017	payment	2134	2134	1874	1	1	6454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1194S7sbeBakZthnAnnAZqfcxCNzZD3zKXpvNg9rHtn3zzBp
43018	payment	2134	2134	1874	1	1	6455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4gy3PAcasq9UdbTLqC6pbTFVZDwJJUSZecRnhHRohhkogNmc
43028	payment	1397	1397	1678	1	1	16150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLsLh58mN1bjihq4ciXEYQAXcMe63UnDFGYP3X5QXnvkFtTHe
43029	payment	2133	2133	1874	1	1	5966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXj4mdNLZYQoaAjiRenbHM91QhyZq2RxshRFiEmuRqvWaCJfv
43030	payment	2134	2134	1874	1	1	6458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZ8T1NMYUPH6W5kNPMMBxjRxdJ4EaJ3kwggB8cdyPhpdVFzkS
43041	payment	1397	1397	1678	1	1	16154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEp7yoPXiaPb22DH21wTdrPmrZeptMJvS8jDVxd8nQfEPfwvx
43042	payment	2134	2134	1874	1	1	6462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsozXR7nz8Ze66oFBwcetQHVNmAnaUf8LtC1M2Wnncdt2Meoqg
43043	payment	2133	2133	1874	1	1	5970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8b8hjcTbRRHa8rpQQid1U3ddsyumw3F98Vs41WJ3WGPqMEVY
43044	payment	1397	1397	1678	1	1	16155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcvhuQtXtabL8V4c4i1UmGHfYBb86YUA8ZGNR38sUrQKNFgob
43045	payment	1397	1397	1678	1	1	16156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5LLnAxaohedQc8LPSpx9iNcDDEb15Qn8CBdY6JAHiPMoCF14
43046	payment	1397	1397	1678	1	1	16157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5MPiamkyqdcDpmxnoXsEdiZf4BML3d31g7KE7AKGxWJzcHoi
43047	payment	2132	2132	1874	1	1	1709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjDsHxAVBTuwmDXEFJMLyuZakR2P25eto7eYEfJkJPBT3PCqX
43048	payment	2134	2134	1874	1	1	6463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk1aEuwzbYuGnfFvx885zqgpQ7VMVJruq2gW8hVkzhU12sG9H
43049	payment	2134	2134	1874	1	1	6464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrPy1PS5e1YxHzzcHpe6RtrFdFUZx3uR62vZXcuKbRw56UA71
43050	payment	2134	2134	1874	1	1	6465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2q1M2cLsB8kfFD9g3GMCf3wYy4QpFSZ4WnM2Wynkz6uSbo25
43051	payment	2133	2133	1874	1	1	5971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P24gzKx22NHfoqn76We99zTtjZZndVPFgQzCihSLixW6V3XQ
43052	payment	2133	2133	1874	1	1	5972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohnDzGQ9Go2Ryxkz2Q96v2ZnE6khFZdWbsmS66vxQNgCbNJEQ
43053	payment	2133	2133	1874	1	1	5973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXEBwU4SmxZdnv4Wm7XuksjexcPfSbQrXeq9cnLyBngrBNKU6
43064	payment	1397	1397	1678	1	1	16161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6taABHyzjfdo6DsFFfivqpCVembeav286tBu8DJf8YdWAbgG
43065	payment	2134	2134	1874	1	1	6469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSW8K3qNgAKUyZ74TSYNPYgSAj8RJHpKaFSTMLcnuoJvCRwPS
43066	payment	2133	2133	1874	1	1	5977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPLuh7QnHTsYzzvh6Rh6cUoa7rTh32SCVRk3osLGRK7AGLUrV
43071	payment	1397	1397	1678	1	1	16163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoocUU6mwvDnMDuM82pq7ppAYdEBvnc78cs5pD62fFtZCTYAtN
43072	payment	2134	2134	1874	1	1	6471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYiJ8EsQCfgH9G8NT73CD9d6MmLPGaGaCCiXQyWX6ZHuykJ5e
43035	payment	1397	1397	1678	1	1	16153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVNvvKY9Pv5RuL3Lph2TrojSBbnGZcG55EXhqbjDUzAq5Vf45
43036	payment	2133	2133	1874	1	1	5968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCaWLoq4wammJVzzXC4TiXMWmGct71434gUaXBjqMSAzeAJdf
43037	payment	2134	2134	1874	1	1	6460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4SGVKjnnZmtvHPymvopWsr82ZU2NrrGHSP7WMJUbHP1K9NTY
43038	payment	2133	2133	1874	1	1	5969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTaXLF1sZ7fwgGG1CvTNotfszkn5KnA7rMJZrMLk3xmpmwWSo
43039	payment	2132	2132	1874	1	1	1708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeH5MNfTdzuiSZa2bK1BFxux36GQrcLpWjSzJ1jncTHKSMqq4c
43040	payment	2134	2134	1874	1	1	6461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtF21PPqhjCzZXzBed2ywk9o6vMrfffaUESzKQ1nDWr8tbFXkS
43057	payment	1397	1397	1678	1	1	16159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYXjTEcYXidNrxMNxGUV5sm8rQv1dsrY4NjF9QuWeevvX8zhp
43058	payment	1397	1397	1678	1	1	16160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8GDJNXPBRySeFYouWwWwiq5f1fPmMtW8H4icJc2hseVvCM2R
43059	payment	2134	2134	1874	1	1	6467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qWc9yZZ2oofZRwGkBxqmyg6n2WscF8H5G1bjP7Ptf9D6rPnP
43060	payment	2133	2133	1874	1	1	5975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsr6SmaCRbgs17yiV86HqLr6G4shAnErh6HV5RwbvNpagSVYS
43061	payment	2133	2133	1874	1	1	5976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHshX1QcBwEG3nN3P1WugTdUzUYPAFGi6CoWqawtWin3x7Qr5B
43062	payment	2134	2134	1874	1	1	6468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzedNsRSUY741bMS15EBGgRHUr8AyG4x2SG5emxKdY1f9vXbE
43063	payment	2132	2132	1874	1	1	1710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9sgZUta1TcTcfKtYMG4eHKMhuq1c3S1aETkEEdnwXs7rkTyg
43074	payment	1397	1397	1678	1	1	16164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgSgaXKyhbCYnfmtkcciJHVyh7TnKMSg6cHXoe5HaehNxuynU
43075	payment	2133	2133	1874	1	1	5980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhsgYBvUN9fJ5EetpWEoYxEXwnQAxkD672gdh3s1yJKjDnhVx
43076	payment	2134	2134	1874	1	1	6472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoa7x58WB4HWjuDdJCepdEaeoiYgJu8VRG7iGWP48TSd4d8x5
43101	payment	1397	1397	1678	1	1	16172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkjHDZS9FmZ3Rw4DQKu8n7hnLsQPd9EjEgdvTZ1rHBN9Z72oG
43102	payment	2133	2133	1874	1	1	5988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kdCPKKeaBdEm9r8rjs5dcjRHUJLpfig3LgknwFHscDJiKFxv
43103	payment	2132	2132	1874	1	1	1714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkmfUJZpGMd3QXZ2iaphGc8iudjQMx83qXbmmVKx8sWkgVB7R
43104	payment	2134	2134	1874	1	1	6480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5Z4ug2vGPPPg7NNxeu6DBwHmPpPC2p5rTxrFTRMqqFvQv2uX
43108	payment	1397	1397	1678	1	1	16174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQ6H4CDSEyc4KLho3X63w81TuZv4g1gaeaNXx6RkkJfMBZsSA
43109	payment	2134	2134	1874	1	1	6482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5cSNQuXBF6QpK2avBqpCkbjW2Wu5cdTsUzeMrECR4kNLsuwP
43110	payment	2133	2133	1874	1	1	5990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R2hL1zNshR6Q8naBNGqmCtccNEKLsBxgPN658svWtKN4KZq9
43163	payment	1397	1397	1678	1	1	16192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgdMTXxcHh2uPXSJ3wQ7H66zgr3RKkg2t98t8u9WjqYW34ZvLM
43164	payment	2133	2133	1874	1	1	6007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhG6YGJrcpDdv15wzaX1wahD6LcgCX1NG4NZRUrUPvyvg5WDu
43165	payment	2134	2134	1874	1	1	6500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8KvUcnNA8rHAgTamQDjZxhBEwMiCJXbG8qzfAdcMVcmZPviN
43166	payment	1397	1397	1678	1	1	16193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tSfP4ZSmp35MZmamRQ2cMho21eXjN4eBKDpwsdr6ZfikFoqj
43167	payment	2133	2133	1874	1	1	6008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSKJFi15wdS9NzgeSPZCcwri7guh4whwjPtBZdnx9k21DPApn
43168	payment	2134	2134	1874	1	1	6501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngFkAWPoLCbeumf13Gn1WNVspcM5wm5ykEVzvCQfCLjZCvZvk
43219	payment	1397	1397	1678	1	1	16211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjC7nEFUdj8ASerMnHub5hSajHe6m1i94ntHj7ajfjhDmL8Mf
43220	payment	2134	2134	1874	1	1	6518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrtc9TfSZBuNgmfrYEQj8ixPFeZ63d8yLqPZkQgY1Ccmcoxrx
43221	payment	2133	2133	1874	1	1	6026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVxDnaAMCTikXx5vbmkgenejnE7mCasnVXQPYQrfVVrmR6tXy
43259	payment	1397	1397	1678	1	1	16224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDuJRFdJhXPzBhj3RGj4QJfrhZZVefZCdvuWe9Tgfcx8FY3UR
43260	payment	2134	2134	1874	1	1	6531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51VsmzwWNXQC3n9vAGnpxHSX7QUA2JKPZXGZqBMvxzfwLi2oP
43261	payment	2133	2133	1874	1	1	6039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCR1FMTfztqcYRT21GEXaYUZxLjrhWPRei6uZVUQoimVhHV2p
43262	payment	1397	1397	1678	1	1	16225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCWyYWT2FqPX9cF8JSBjcSuuu5nZBcwFVn8cVpTejYfSLAYHK
43263	payment	2133	2133	1874	1	1	6040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba2L4bL2yMkwTvWkBSfkmpNN1Nx5eDTUWhYDmNWXQbGqNHHvC
43264	payment	2134	2134	1874	1	1	6532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4bA9ZwtkHbSkBR3wDrQTWBYRLR6hTCkA5EpvPjBzm4aYvMn3
43073	payment	2133	2133	1874	1	1	5979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSu3u7e9ZpobiUoG2VSPK4iHj8MzG9W91wS3H3Lb8RAfdk5Dc
43082	payment	1397	1397	1678	1	1	16166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPSyjgSExmb55rAVarEZGaBFAV9rUrsG7yqgEY9gSc1eiizKf
43083	payment	2134	2134	1874	1	1	6474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxzysrCfYcvjXmhzZtoKDNQqqPRKJr9NnTem7XB3Edco7fTPw
43084	payment	2133	2133	1874	1	1	5982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFxpxgNTGnnrdt3hMJUgvaTnt6mgEsqD1cxm3EKfHwKtLK9uS
43085	payment	1397	1397	1678	1	1	16167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk1TJut4Z78wD8yq8DwV46UMzxFQTRurft1uKFLXPU2WzbzFU
43086	payment	2134	2134	1874	1	1	6475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbt5v6RZWTNcoG6Sx6mKaZt784tebaFGmuPFCVjNZA4XpdDXP
43087	payment	2133	2133	1874	1	1	5983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfk6ZReVo7T7noVPhMGagyNDebea4JWy1xNLiHZJ4urE7cgLv
43098	payment	1397	1397	1678	1	1	16171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wvmt6MDmdDz1v58QweuQ3F3YSGw6BZ8Ky8DJoj9MDdzXA8FS
43099	payment	2133	2133	1874	1	1	5987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBC1N2tCoEcjB4v6tvKwh5SsQtL8KbpptXxPnR3uDco5G37pZs
43100	payment	2134	2134	1874	1	1	6479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkdmnFKe47RWEZSBUFL3BHdmD3BMQzaibGQy5AhwMwXh1Nzro
43111	payment	1397	1397	1678	1	1	16175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHTb4svpJX7DPA9jBRWJoUNRUb3PQeSY7NiWiN2bW4AcRS1N2
43112	payment	2132	2132	1874	1	1	1715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ3aqR6QggdHnWxxjvJUKfW8tvVnfuvcRmu8FkEtvHGPE9hY2
43113	payment	2134	2134	1874	1	1	6483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAPhr7qocw48PJVCmoyuQNVcxXdzQwMeueXp1DgBDfC9K9LQ2
43114	payment	2133	2133	1874	1	1	5991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYL8UFk1Fjw6urVEbffRqGv9E6ijzt6x7YoDmEFsennhBL2mNY
43118	payment	1397	1397	1678	1	1	16177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhSgbu3mHRB7ocdJDnXbrvV1UMs4UpcSJS8VUs2dK9UvLzR9p
43119	payment	1397	1397	1678	1	1	16178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR25jitUFj7wDH99JY1pT38TGUsPjZhtbjWG4hq8ctPoitLKu2
43120	payment	2134	2134	1874	1	1	6485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNiWv8GEsrK5MzuaYTSthKKCFjx6cHfcM7CRqJvDj8cAwBcga
43121	payment	2134	2134	1874	1	1	6486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTarxHSvjqdPLY93TWghjUDtrB5bgdG49qfi8PbZNqqptyJsR
43122	payment	2133	2133	1874	1	1	5993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPUfxtJ1R8CYo7E8YM8RPmV51vquov8Q1DkzE51BzRX8UGxDF
43123	payment	2133	2133	1874	1	1	5994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXYWAG79f5b2pMKKxhqCoyYmwhqK2bL59FxZS82vWNRp4rGV7
43131	payment	1397	1397	1678	1	1	16181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY8JCn5uBxo2r9TC82dHqELZHbBnAgwzfzNLt2QTpSzrQoJWE
43132	payment	1397	1397	1678	1	1	16182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HhU36MniXnFijzWq6Gc4FJDDD3rBB6ci38uZE5EnVS65rqCC
43133	payment	1397	1397	1678	1	1	16183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g1dV5nPDuG9TL8SD7XWXPDMmD9keXnXojqyc1aLo9HAPvZxs
43134	payment	1397	1397	1678	1	1	16184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6aBDx4Pbkn3unCGwzb85CUsiCrnzgRDUDZ2TAAzv2Q6WoyhU
43135	payment	2134	2134	1874	1	1	6489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgPetGCA3HjuHTG7pzSYWZEfrSW9ywzhZxNnRoS84Y9njxshc
43136	payment	2133	2133	1874	1	1	5997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqkqcCFmefXAEqD9RXm3cKb9uw6uPpDQzYuRJYwfBCxBwfsPu
43137	payment	2133	2133	1874	1	1	5998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmoFXMoosN9EwnbmdAoRfKQzcdfrUr4fYYTJhq1C7sR1gectDS
43138	payment	2134	2134	1874	1	1	6490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RHqjjmLog99DSHSTkwB9GrE8Agt2fRc8jFm4LQeVxUAGmF9B
43139	payment	2133	2133	1874	1	1	5999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLkR1Y6sC2jNMyr926JfQsWWWkLamWPzuqDa9c8aKXnmdpG2k
43140	payment	2134	2134	1874	1	1	6491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3rwSsZjL7BM39kiwLeo6LwoE8JVQL9h3PJ6EcVq5r7Uj8MNG
43141	payment	2134	2134	1874	1	1	6492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXxeCxnRBDXrdHADGvoSxVe9rKACQz9HwF949YzdM8dzYvzZ1
43151	payment	1397	1397	1678	1	1	16188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAHWHGfZ6gwR1BANfBzehUAbFygsReWFHD3mTz4ZE7ikoH8xi
43152	payment	2133	2133	1874	1	1	6003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyvf6A9KG88JAWogdAFEXwDeZPnQ8nsrHL6mp7k99YRozbrzV
43153	payment	2134	2134	1874	1	1	6496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz8kiAYPJcA5Qg3uS3EcUvMCp3dwLCuQ3pu6SsGy6bxeHTwpA
43154	payment	1397	1397	1678	1	1	16189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PNCaGyJi41k9nBgisRrsCSVHsaYS63SbSJysRmQdz6ko8Yqv
43155	payment	2134	2134	1874	1	1	6497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxtV5myDRy7SFKJA38zN3Br7GcjKvhSao84YKuLPGPSpCoDER
43156	payment	2133	2133	1874	1	1	6004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FPs2F9aNWCHnD8kjsMUAkXf7XGdAm1rNW84EVDo8x7KVh5uX
43169	payment	1397	1397	1678	1	1	16194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ugBedPsos12eygjteUuwKVEnrSf2BEsf77z7GNFZGdDX58hz
43125	payment	1397	1397	1678	1	1	16180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfpvMdmhpgt3JPyWqomeo9qmi6LonqdYMsnjyacSXCHV1W4fu
43126	payment	2133	2133	1874	1	1	5995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCBs9x1zwJkLZA2KwXTrksvvjAa2WNRKZaiJj1QKfrc5DrTAC
43127	payment	2133	2133	1874	1	1	5996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWhrtNJtoK1BfDa6txEpKJ5fu7zvyPwriEgWDET1NTN132rdS
43128	payment	2134	2134	1874	1	1	6487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi3siCLRhFU1uJv4j51NDbKF7Ggym2CEMH7KTbiUSgxtsD1XY
43129	payment	2132	2132	1874	1	1	1716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedy7Gb5fcBMxSk8MMVrzBPUv6yjye7yBw9joJT8kXUHSb8eqd
43130	payment	2134	2134	1874	1	1	6488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xc32R4BnBDB6gEa5h8PrT1DL6msDHvBXxUZuzwQwQtUmaHsp
43142	payment	1397	1397	1678	1	1	16185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZSHcGgrRN5kkGFnB7WFwTBp22WiC5VJ7NNhwGWZjCS3fHrNU
43143	payment	1397	1397	1678	1	1	16186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKvTxk5PBtXK8SbgXQpKW7jvrv9XyTtYwkZcwvDUqD3pw5Aej
43144	payment	2133	2133	1874	1	1	6000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzFrVgzwLNvJu5YEYuBrVjBTCUrtUoCtTfiXZ7dK3ettdZ6hw
43145	payment	2133	2133	1874	1	1	6001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURo7dEtuQoXYYfxfcBQsFWdXRztfhSCnMnda5VtCGPW9JirZ3
43146	payment	2134	2134	1874	1	1	6493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcAXg9Pbe5ZXAt9cg8pk5eH43qy4atmBBDykBdZnPUSkmqf1S
43147	payment	2134	2134	1874	1	1	6494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZY1pH64hCBUpi6TQydD5Yf1Zsmm2TtUN2B8ncH6jF8XvBjkn
43148	payment	1397	1397	1678	1	1	16187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SXGdP8G5guKkViM7rEuAbkqLyqyH4PUwjScQVuNzBw9hBYJV
43149	payment	2134	2134	1874	1	1	6495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWBiRV6KwEeaJ2Wmj9zwBkSng6jTsPz8EPdpqjHmNctvwBhmy
43150	payment	2133	2133	1874	1	1	6002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezwQ14Qky4cd5hWTGQjRBK9DtUV5HSqmbXizuNBeaB592feSp
43195	payment	1397	1397	1678	1	1	16203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLmEWwR3p2NXB9PFi5L9YC8mA6gDV3Zyk3ngRfyhasxxPFyRJ
43196	payment	2134	2134	1874	1	1	6510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKx876pFyefk8F99Zp52SaRCCSnXgZ4DTbRjs47yLRhi4b9ot
43197	payment	2133	2133	1874	1	1	6018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJ4ucDEXJngNEnHJE6iH2HyPtxe8ZCTvnyeKAVmC9AevkKs9v
43225	payment	1397	1397	1678	1	1	16213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUSj5q8JJeXU3yPe8wLYpjXf1ssxAGLQvaGT1AeCff9szirT8
43226	payment	2133	2133	1874	1	1	6028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFTzG1edgBrVwHFoDTAj75zcDhdosch4GtSsQBi8X46BTR9vU
43227	payment	2134	2134	1874	1	1	6520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbCTCnXFbnFevvG3TM4Qm2NQVG6B6Vg48fBxJb5otYTB72d6M
43228	payment	1397	1397	1678	1	1	16214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygTQDjW8DeGcX6c695tuFX3tpbZzANqdTsnvJ1yNsHZNHwdSk
43229	payment	2133	2133	1874	1	1	6029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBEpwTCczwpsG1VoMN666CGpBByzPgJ2iRj72wNxZhJJEKxqY
43230	payment	2134	2134	1874	1	1	6521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQKcmzRwNXwhWzdyhubEcjELaC3gomwGThChMQmzc2ovdCrXD
43240	payment	1397	1397	1678	1	1	16218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TpKWzpCutcQJu7uzz5ayHr4w6N8hzP3UNmQs9CnrJQkf5J4m
43241	payment	1397	1397	1678	1	1	16219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ1ssc5DvxUDHNtrsCpVtdCzugufywfXvnY8kWTJNW6db7nxL
43242	payment	1397	1397	1678	1	1	16220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfqWY7fTmiVGKW8JThDp1syrvjgtK6an34rWQ3jdYVfzeTdVX
43243	payment	1397	1397	1678	1	1	16221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumTNTRVQ5KF91KNUALkbXv7dm6kRW3JuZfe9oVauMLDX2qY14
43244	payment	2047	2047	2369	1	1	0	20000000	1000000	65535	E4YhMeNTJaRuqHVQHAqXMFeXRuHJDzPvGRYmunHRnJ4vFTpyQ9APC	CkpYpQtM3F5DoivgSiLukPhG4tibkxQtuew5RSVfeoQD3WgdJ7VYZ
43245	payment	2134	2134	1874	1	1	6525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuiAkzDrpM9dxT8LWx7ite3Giyb81WQfsVpuGw2p8MytfRdYG
43246	payment	2133	2133	1874	1	1	6033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7dqHPzJ7UbzrGMus4NiJK4J5RXUAZMtZDEqYnHjUWGZcZvM3
43247	payment	2133	2133	1874	1	1	6034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymJsB6T1AWT8B7PVxkPj7iDvQfNjuv3xdSC6gxYSuiEo7HtdB
43248	payment	2133	2133	1874	1	1	6035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWrKsLm5VRQvjgWgTSye2dw9nztDwTaZFRLeaPrvX7G952rgN
43249	payment	2133	2133	1874	1	1	6036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBAh6Nv5AcVLuNT2TtHTRvwYTeLMpabKExsJYwXUEuxxFhrm4
43250	payment	2134	2134	1874	1	1	6526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEa5xyX1hErSgUeub4qcLrt1knxDHfox332yhwDmpP6gAmLUV
43251	payment	2134	2134	1874	1	1	6527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95axm3GS9uMiNhfrvSViXmVLQDp1mPb312M3ZSbAtPJwJawjA
43252	payment	2134	2134	1874	1	1	6528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqfqsVqjymapG8S4CguA4FugW5fhaNyxMcNGmfxH3cbJtaR1y
43256	payment	1397	1397	1678	1	1	16223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65oRR7yPkjrwqn8HGvmZon5d7XVBMoXrJ4nbbsMf5Rw2LSfRc
43170	payment	2134	2134	1874	1	1	6502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPA6XivWi8G44boLT2ct2LU4hveWUSeeLsxwL6xbQSNcqSdFT
43171	payment	2133	2133	1874	1	1	6009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPndtUq6tvZeAcfyBJoN91u69YySXgF6fpm23sAq4sFztESDh
43172	payment	1397	1397	1678	1	1	16195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZYVDdSEevTrPhnC3SnQ3KPsnVsqShxnkGXBZUngRN8R9D46P
43173	payment	2133	2133	1874	1	1	6010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXn9E59PZXELQ8UMAe8MNk3PAi6UtgZR3GnTwh8t743m33pNu
43177	payment	1397	1397	1678	1	1	16197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQW7Z9HDB9ToKbH3BbKKW3dwqj8ySznzWS7SpFb3x6LbxFygr
43178	payment	1397	1397	1678	1	1	16198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjbeQu4kyWScMHp2SZnc35zvhciiWK9oBfKNLGKu5627Y4uyM
43179	payment	2133	2133	1874	1	1	6012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsfVscnaLZsRj5Aoe5Ku59XEp5UDr3zWgBphNVffWv2kTJcsJ
43180	payment	2133	2133	1874	1	1	6013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXReUox9eLfen1RMMnrvSv96L6GbGAtaJhrGGzFyoSmKbymaJY
43181	payment	2134	2134	1874	1	1	6504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHAJFLRpzeYmSv7s338rXk5n6GN9htt7KbqQvDHmbHRMFFTur
43182	payment	2134	2134	1874	1	1	6505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpA9N78uGcwvBftSS8oHrrdunGQuqvqiNCtq6kWGkjmYqa5jC
43192	payment	1397	1397	1678	1	1	16202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8xe5ZPJQzcuxWwZeV5YjTCXJ2ESdvZqwpGGQUfJhDaB4mqk4
43193	payment	2134	2134	1874	1	1	6509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8tTGsVE3oHiUDmeJLD4dSv3wSFEVbL1WpYRCBM1n21V39MwEH
43194	payment	2133	2133	1874	1	1	6017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiE3quSbHMjSz2NgxoxxKEbPWTASR6FK2VqKk7dVotjFNndiW
43213	payment	1397	1397	1678	1	1	16209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMdaJocdRhhapye1QRqagp8ULFPTSBAmZpy1tTnMd6JjXRard
43214	payment	1397	1397	1678	1	1	16210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMsoYoCR23si8ygB28RqHf8gUuVqLp7skGoeP8Z74zJu8Wuth
43215	payment	2133	2133	1874	1	1	6024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18q2yxv1cVbJdCXw8v9GBuEPxiVk3fPcYKNEzHGfsN8m9cudX
43216	payment	2134	2134	1874	1	1	6516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1etYayw5AYaZFAxR38XCpzRiwQNiha958dgY7hFvf3xwCVwE
43217	payment	2133	2133	1874	1	1	6025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhK2RAQSJqn2UsdBKwmNVufCCj8VdfucVLwYxSrJhuzMxsWkHH
43218	payment	2134	2134	1874	1	1	6517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ejX8f6sxGqH372YJCnKMYMxr9yvYYTyu2Feydr4RnmLmsU4M
43253	payment	1397	1397	1678	1	1	16222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnGe6Hp5yFYT6MkUtU4jb1G6jbbHVVN19vr9QqQcb4SghEWGY
43254	payment	2133	2133	1874	1	1	6037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccwRjGGHrq4SgeXmZizRm7k2J9FR3XM2awzC4ZZzmRqyZkLn8
43255	payment	2134	2134	1874	1	1	6529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6ysn7Po1QLP5hSGHhiPvrtNJT5CW2kWkBy9Su8cvKHi2CuZJ
43265	payment	1397	1397	1678	1	1	16226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEVdawEp7MFriu6CpRPFp99RWcez6imnEgY5E8jpraWFHu93W
43266	payment	1775	1775	2047	1	1	17	11000000	1000000	65535	E4YZaffXFa7o9C7vDsdhHxNVeV5BQ1AEqonnxirpbBXHWCxxLZCHP	CkpZ7Ekx98eAafB9TZijwjMK9zpRL6f7oq4k61EBCzGBfb8DT43kb
43267	payment	2134	2134	1874	1	1	6533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1STjRDKJ3h6Uhc6vpKugrukVo13dfQs5hSASvSpHcWv7L3yJQ
43268	payment	2133	2133	1874	1	1	6041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ28ymVvGZEcPT3R1MUVffPsjXRE2NiB19W1BwxXZgREEhade
43279	payment	1397	1397	1678	1	1	16230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfnkyfjE7fZyAXCNejbqTz4ugFYh7t3dNtZ8b7toLHgW29dSc
43280	payment	1397	1397	1678	1	1	16231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwoJ8Zt9ozTXQkCMRLULemgqxSAPb3Nws7WuxuatawB31pzgn
43281	payment	2133	2133	1874	1	1	6045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbQQsxcG5VAKSbVRTEMFThxQ4r8RASfMXRKyjhfvs9ZSqWyTq
43282	payment	2134	2134	1874	1	1	6537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtG9H2mHT2oG9qhn8mC4nA98afhPX2XU5yEQ2UcaewsPy63E7q
43283	payment	2133	2133	1874	1	1	6046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc4x7oiWLn4RHiDPMok87HT87RSQp3MbSh1UN4KJ8HGk8AnM9
43287	payment	1397	1397	1678	1	1	16233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLJGFewRohS3SioBoXZFZjFN1ynHzt1QQna8FTda6qasaBoKb
43288	payment	2134	2134	1874	1	1	6539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU69dnBQN313W2trEdPLs9WhmmaFvKDmfEb9btgKmfFEr8Bd5t
43289	payment	2133	2133	1874	1	1	6048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF8Vx2gfhkXCSzNYS2Kb1sSfm8JxRKnZ7BWrAeEnrquwC2YYb
43317	payment	1397	1397	1678	1	1	16243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLUu2sJtNE7t4xWGxw5fiCMRnzathzEXiHtLeiJYWJ5Jc2fnH
43318	payment	1397	1397	1678	1	1	16244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWx2St6QZgkqGUBBw7NFRptKqCDkApZHewXc92iky1Fb3NtvJV
43319	payment	2133	2133	1874	1	1	6058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuSHYueS2baKM8crFhGwFgMDuaP2N5MoB1UVhGEiKeVUm7E6h
43320	payment	2133	2133	1874	1	1	6059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFBDg4rQmkUFbqdEPn3QWmxLfQJksxiNkvM73bMf59Rrhmi7B
43209	payment	2133	2133	1874	1	1	6023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2f13ZHcoWQaDWPLFLw1VGzaSyFSZ2PWRyn1sFwagK7LAKgkL
43210	payment	2134	2134	1874	1	1	6513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSVGi7kNy2pEmBipu3bgFni5kaJ2QwLHn57RauSxmxUXgFjYz
43211	payment	2134	2134	1874	1	1	6514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9mknub7jCQXzpdmmwnFjrxnj3tA51AkPaJbBfLjSYHPDn4YV
43212	payment	2134	2134	1874	1	1	6515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zFQGek3HSj8wbaYszQVnjRKnt7QefYyh7mzV8pULGCxLrQtj
43222	payment	1397	1397	1678	1	1	16212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriWSmicUgyDZ3GL6VpC9L6fQDR1x9ZGPptTmfBHqrk4T5Z96G
43223	payment	2133	2133	1874	1	1	6027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGiPQosqhhgH7zB1wsixjLEmppche9v8M4ycBLUouPYjvzf1m
43224	payment	2134	2134	1874	1	1	6519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrcmBLe6aqRVM6XicmdU7SSCyVMvHZwT7XBt6cZNuE3CLhbeUm
43231	payment	1397	1397	1678	1	1	16215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1GfMN5iGTSTWJsXgSjpMNByeFVpLeSQrB3BTYCQz1YMLm9rq
43232	payment	1397	1397	1678	1	1	16216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNvBTZWvwENETXXthyy8Ebj8gvUCXQDqAr3n7rd3Km5tmkYAx
43233	payment	1397	1397	1678	1	1	16217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93ZG2ZpujiRhGMmVptfMTdA6U76RvsCCsYBtFMuRbKe2Lz7Mx
43234	payment	2134	2134	1874	1	1	6522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYDZfeWGwUqBnabZmYopMAeWmAQokvCSuY5NLYbced2SdUFpg
43235	payment	2134	2134	1874	1	1	6523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBnD6N9wR8VBNzwhvh4wXdPwGwpBjDpP1irn3c3iX4hqs33Hc
43236	payment	2134	2134	1874	1	1	6524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFNjh4zHJgkXGPAniuopRnJMZWu9b1kbCysYszMh7mFegfU5s
43237	payment	2133	2133	1874	1	1	6030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHabDDY3u5psunMAusn6Ugf6cBxZKXuz3q2MPu5jHTDMMeuUY
43238	payment	2133	2133	1874	1	1	6031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjgnNnYFnVgFizdEJpb6UU7BJNa99sMY5bFYcLcMS6wrXeSY9
43239	payment	2133	2133	1874	1	1	6032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkZ54NfqXkqEsdjf4eKiDg8SvkgKSdk6uuqRb49KaXsJMMV1y
43272	payment	1397	1397	1678	1	1	16228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyzVj3WTvmeocCUxhGEdeDGQuy6DevHetNFjpYGmPCTR2Kiyp
43273	payment	1397	1397	1678	1	1	16229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1FDiUqd76Zix2Urbi7UErSqs2XgkcuMUD6XXEYWCw67Xkx5G
43274	payment	2058	2058	2059	1	1	13	200000000	2000000	65535	E4YhMeNTHQ3tCww7VpyVzN9x3y142UDNKZvBFpQurfMjuFWETyzUr	CkpYf5zQc4u5cPwnY5mpwZwqNCJNGBvyZZrRxwDFYhhQFBBTyxVgL
43275	payment	2134	2134	1874	1	1	6535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kuYzsc2UeMu7C9RY33mqvEuEqkHYMzpjyiw3Fd6rtV8q63s5
43276	payment	2133	2133	1874	1	1	6043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9t8MhLhswMGmLN1c88ZgYg7vPn6RDy2tk3bQ2VApBtnbcgvDz
43277	payment	2134	2134	1874	1	1	6536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1eWVvMH7dE6FU8aV6iDk34K6tzWXwqUg4J5drFD22g6pNFn2
43278	payment	2133	2133	1874	1	1	6044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNp6DsB566FTZo1XjynXaFA3H3J31wtTjRpRS4H5hvNULm2kw
43293	payment	1397	1397	1678	1	1	16235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3h5X3cwF9N1QX5suKAZFSApA1H3UFqaH4DhD8inxdPBprh3tg
43294	payment	2133	2133	1874	1	1	6050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4VHyYwWvWxhFCkdQafWYJfUzjZfYcJTjFD3hBtdAhKZyXhVA
43295	payment	2134	2134	1874	1	1	6541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1P9Y3VYopgdRKnTrhTaFkmJxAihCXanbxjWdZYyxR3JZwijY
43299	payment	2133	2133	1874	1	1	6052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG6nMJ3ZvnfKsD1ZCHaXgXHJ3Aegr2vz41QTndL77sqAipt41
43300	payment	2134	2134	1874	1	1	6543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2UsHQ6bYQawvJANwyWb29naLvaMrpSiLfst12ecyUxRvyLUm
43326	payment	1397	1397	1678	1	1	16246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EEKXTZPMfRis8ZU3mEnN5dmGVpBeR4Ho3ENWfmtijtTUZYBw
43327	payment	2133	2133	1874	1	1	6061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG9NQu7zKvNQx88bigfJnHHgJ7JrfzWuuSjCeTnmR5PtqfVFn
43328	payment	2134	2134	1874	1	1	6552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLfpmBr9Cr3rq6XmXGSgxr34q2oxNA9j8bdh5k9HFftxqw7Bu
43334	payment	1397	1397	1678	1	1	16248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxdB7xQ1ETM84i1qoxBNN8zNbTzoFGnsh6376erBjg1c9TyLx
43335	payment	1397	1397	1678	1	1	16249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFsRzB1wWqeVgYBgVLXzTNF2hbeCWXCxPanbrjiykWtBEmWAVo
43336	payment	2134	2134	1874	1	1	6555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUURwpBntWLmf9fyqRRPZfGpBxcrFC4PMkVqGVLXwyNk7BvhX4
43337	payment	2134	2134	1874	1	1	6556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapnksu3Hya3PEpjuUcB4eZ3TnWtRJQgjKDc9ojUuE5q98CBhw
43338	payment	2133	2133	1874	1	1	6064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAmmomZSCzw799FtCQZ7PyGBVzyDMXBPhofHtDME7tUjrNHXn
43339	payment	2133	2133	1874	1	1	6065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHd5j9wk62fqZ4FUpxXfwTop3i9W7xZmiSoQXJxcJEEUKFiX6
43384	payment	1397	1397	1678	1	1	16265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv5VkNL4fxPAHqu1E4SFCZGsFgQgUoubtm7Ez9xNzVF7ipDuG
43257	payment	2133	2133	1874	1	1	6038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYms1gXoMSLmBumGy28mWoGw6uQdG9B3XWrHxFGYtQ2QP9scKBj
43258	payment	2134	2134	1874	1	1	6530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpw4jjxQLTV1UJ1qc3XwRLHAXK7wjeWvVXLkbKcLzjjgug7KtL
43269	payment	1397	1397	1678	1	1	16227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYZGd9cwfsU4uAxinXZerLwMvweku1YjYcPzRRkMCoCk6jJWN
43270	payment	2134	2134	1874	1	1	6534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPZv9KPWpm1zhHDAAvDmYU9ARTmW4RmjS7ZTJW4KDF89i4kvf
43271	payment	2133	2133	1874	1	1	6042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZve2CVWhKpLCVhKxGJ37wLqAmFd17SCdJsKmi2786Fc8UETnEC
43290	payment	1397	1397	1678	1	1	16234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKPVL6veXuBcxfsVHDCfWLEFSER8DLZEfvAMTpjtjwntrNyJW
43291	payment	2134	2134	1874	1	1	6540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4chdPvZ4ituuqphiPUbdFi6vxYpfoP2291HEC3KeKTqR4x9Gt
43292	payment	2133	2133	1874	1	1	6049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMbdzKRviPcvpEebaTxn41g2D6xRX5afn9MQ4C5Ey9H1Foo4c
43296	payment	1397	1397	1678	1	1	16236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzc9epubJrzW2NZR8GfVWPQRFa7kCynzoAzCWffELRxKr9CnD
43297	payment	2133	2133	1874	1	1	6051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE42qV6SoZL96UzXTtuc9ygbnEVQ5Ksm7FkqvgX7MLUpYho3PW
43298	payment	2134	2134	1874	1	1	6542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa62vM7V1CgrVNcEnWxWJRqyAb4im7pEuBGAY2Duy6CnxYbNtXr
43301	payment	1397	1397	1678	1	1	16237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNf88qxEeNUUj6M2Ss1f6tYEX41a2ErbqeaGWo5YEfMk3tirD
43302	payment	1397	1397	1678	1	1	16238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MHAY81kRCUbaWzmT2awD77eW2LtFRooDNTHukgMkzTuVWiCg
43303	payment	1397	1397	1678	1	1	16239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cX5ihD9GNrFFXhQ7W9pqHu8AqA4ZTqqc3RKqv18bq9paPEXe
43304	payment	2134	2134	1874	1	1	6544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdedRARKB2ooizyqxoAfcSNzN5d6f2qNcyncq7jk8Q7tg8Ebd
43305	payment	2134	2134	1874	1	1	6545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7s2gYLyxzmm9tK4S2mwYYuy4qDxKbyxJse6w8CNmHXRHN4k9
43306	payment	2133	2133	1874	1	1	6053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyNRBBtB7DfMHoRxueiE7Q64e1zaUMMhJeKmy1xrBRsXejxwb
43307	payment	2133	2133	1874	1	1	6054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwEQiayNksEacuVPumnUBa1sbAnkQHU9PfhxTwNFWjrjzAvpm
43323	payment	1397	1397	1678	1	1	16245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWULUPQKmUZ2bzmqB4emN2zjaph4ibhgE2jbo8qDcQqbKEJ2f9
43324	payment	2134	2134	1874	1	1	6551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGoYgoVKaX67vV1T63iBuhsovMdmw8th1H24G4PzaCSuXthia
43325	payment	2133	2133	1874	1	1	6060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiSHKuPTvmtu4sHpagGHzR8a2BgBCMTgMyQuYQMMCkUeMVMaH
43389	payment	1397	1397	1678	1	1	16267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYiGi59qJcRN7Q3VeAjAhumbR6pgh7hzQgoNnNJgkUi4q6Pfz
43390	payment	2133	2133	1874	1	1	6082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbR2tTmfBnsBBqy3ePs94nApMhyS84ndRAZn67Z2KVL1LVifcj
43391	payment	2134	2134	1874	1	1	6573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97BoGrLEDVfKkQYiiTxefkyoKVhtPEJLhRFDjjAHZoiPmUWmT
43398	payment	1397	1397	1678	1	1	16270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcY11ZPmo9eAjVjuJtChZs1hJds6RGH11XHwFJHyd8Fhn94mQq
43399	payment	2134	2134	1874	1	1	6576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJ28pxJqtyyoWPtxKD54p9pcTAbe7H1HeCuKAra5JYF6qcpEv
43400	payment	2133	2133	1874	1	1	6085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjafe2AkQfCAzLfs791UVbMtxQYz4mGtLPiMLmgQoJiGAASVw
43406	payment	2134	2134	1874	1	1	6578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGHcnNrjoD9itV7PJwDEGLrjyLYvBSEHPBf8SxAp2kXGgooH9
43407	payment	1397	1397	1678	1	1	16273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWvFpvnBwS2yFT8jdhry6LK8gb4au4N8afXBpaP711RKBDD5j
43408	payment	2134	2134	1874	1	1	6579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcWp8B7ofhEXcUxc9QunjCp1qXW1ztU27E5WwbPuBbH19xmYh
43409	payment	2133	2133	1874	1	1	6088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLWPsy7o2wGvjg46zT4vCuU1hEMDsufGiPcnoiVhSzRWHNcxw
43410	payment	1726	1726	2370	1	1	8323	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEbUz2kZz7tNYzchqCpVsse5mktGZHWTs1C86PogPxwziiGNcC
43416	payment	1397	1397	1678	1	1	16275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLc2GWAAUh1u2k1UgfWM4duDEzrifDQnTkzdt69nX2abwEEK1
43417	payment	2133	2133	1874	1	1	6090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UH5FPdMa6E1X53kLE2fF4DAYXxE7T35avTyeW5wHkcfar3KL
43418	payment	2134	2134	1874	1	1	6580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUxXv4fkAqyXDTeKGzzza69n5E978kHQmuetLbcfRhDhbSDoU
43425	payment	1397	1397	1678	1	1	16278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTb7yhELxkZW4vLQZjV8aF9qnKQGydp8a55tkGGLn2LbvoaBp8
43426	payment	1397	1397	1678	1	1	16279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLri5hxkVazcXwn2AguhkA5XGKxBu7fADAbMSrTNRF5eRq4nJ
43427	payment	2134	2134	1874	1	1	6583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuGFbntX1C1XzY6nBRuNXUgs4hkKchkweH4A6Wg2gbV7bnrHw
43284	payment	1397	1397	1678	1	1	16232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbiQBQHdTWbKSScghB3QS4rdcquFmeuzsp8YTxYFFr9op1qUQq
43285	payment	2134	2134	1874	1	1	6538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWth7Nx3W5Aphpz5EBsv5wLst81mqhy8kSjoxNzQLh4eB6SEkc
43286	payment	2133	2133	1874	1	1	6047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNmgB2moDsA1Pg8oUJVufdFfNkMvDgA6nDwZ7rpaJ3cA7WkRt
43308	payment	1397	1397	1678	1	1	16240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KHjAHAwAmaKxDLNEDLfmBLzgYVn1bCUDuzVX1CddaKrMdfnd
43309	payment	1397	1397	1678	1	1	16241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDkeTzoZ91po89ppithCSvgCKLJpi5ovJwkNV9VRQE1NmvEb7
43310	payment	1397	1397	1678	1	1	16242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQiLAHEVe5Dv94vmgbPT6pVUEFDjLmoXTW6Vx9kC7KBwD5W22
43311	payment	2133	2133	1874	1	1	6055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaCYtdn2zn5JJwh7oQbqL4Zux3eGqExLjRMPAnLC9MC4BLrsG
43312	payment	2133	2133	1874	1	1	6056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarG7aQqQHnkpv8a7xgZNceA1hzEkbRRiHXwdgUFa1EzQNA8H5
43313	payment	2133	2133	1874	1	1	6057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvDBfXHJTn2Vkvj1QAuqVkQRpWiXZiwBKhwrYjdshwQzC1dLh
43314	payment	2134	2134	1874	1	1	6546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wWU4iQsfubkQbVMTwbiNy1fn4GKHbQsUCgh9b5FgniGYa49L
43315	payment	2134	2134	1874	1	1	6547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvKKcikfJXGiXSgVPyLSQpu69qxMCWbo43qcVtg6rwnSE7uCx
43316	payment	2134	2134	1874	1	1	6548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCSKz76RVYNfZRp7FDfMYNoDSW5eiWFxVy7jWpGLrHihF4Ar4
43329	payment	2133	2133	1874	1	1	6062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvZGqHRGrFe1iAXmWVXa1dnMetw2PfH5gdpzFCkZwKTqbSsqG
43330	payment	2134	2134	1874	1	1	6553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QyfSxTz593CSdY8kKNpHdw32oYzguLaH3SB13o91xfY2TyNv
43340	payment	1397	1397	1678	1	1	16250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm664132L2UNextmNCHXMk5NSRWV2QhccBEDEjRomkdA2Cukw4
43341	payment	2133	2133	1874	1	1	6066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW2EYnak4LSab3kjnHmKvbh2woHqvWxPWATP3nzwkWkDneP3P
43342	payment	2134	2134	1874	1	1	6557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmfpxJdY35pJcqHfX5mFF6AR4qiES6vxT5tL1u1Gc9sH1rYqz
43360	payment	1397	1397	1678	1	1	16257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChTLcp6RZdcAb9opRVahuNRb9dd25F39SkPQmZzEoQrjC2V6F
43361	payment	2134	2134	1874	1	1	6563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMapa2RgwLd61yqgjMx3UhGrZYNGqXM8V5zpeMNMfskZEcNzz
43362	payment	1397	1397	1678	1	1	16258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DfvDnCXRD78ZSVcweX275D2MCuQXpFqSPmbGLnFgVW2NJAV5
43363	payment	2133	2133	1874	1	1	6073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWu28CvTjYVS9UT3uzpMv8CdpseGJKSjnwJiDuQpSBbtSou4m
43364	payment	2133	2133	1874	1	1	6074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWorBBcLX47CMVGqr8vGmDkeb5yWna3PDB9huHHr3BHJMZioUz
43365	payment	2134	2134	1874	1	1	6564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMScWyQWpcs5BB943uQThYc2KThWtUfm5DCH8ZhoDSa5HXgum
43369	payment	1397	1397	1678	1	1	16260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr88PPEeoBHivS25E75FjSCSPJjZLqjRY26BLowU9NQwVHdEqU
43370	payment	1397	1397	1678	1	1	16261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9f7qMG4578hbYdVU3TivNgsb2pUNCLcK2QoPQgAAderSnVud
43371	payment	2133	2133	1874	1	1	6076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JTg78pwzZ4DF487YLy2JwSbsBnm4UAG5AqeyrvTNLYtD5F8G
43372	payment	2133	2133	1874	1	1	6077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDCpHsHiLuRabwnqzQFj3tMpQT12q7pVw74TkSNBvrGszoFdF
43373	payment	2134	2134	1874	1	1	6566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YF5q3N9bSckhrSdeE6XSPAYMnc3m52vngwmPrj8LPuTALSTR
43374	payment	2134	2134	1874	1	1	6567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3BUj3R5vhSNahZwcuFRqXJjPg7BW7Y2j4tmXeHKdMBaWwobo
43375	payment	1397	1397	1678	1	1	16262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoBriCz67MhmJ3wSKSV9jrhhP3sTnxTXabqnDHnKhJwwUtcWF
43376	payment	2134	2134	1874	1	1	6568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJWtBmYxv1T5iYhZziCgFefM29PJqXizcL3QXuKtRi44aG2aG
43377	payment	2133	2133	1874	1	1	6078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoWFzxKMnGgtzuMXzThFeD8ABgYjU1WWwkFnbBJhCd55Bwdc4
43395	payment	1397	1397	1678	1	1	16269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcetAKc2QPCG7amYwMLs2UH1jGNsxjGy7U9czhT5Mrfr8XDWPx
43396	payment	2134	2134	1874	1	1	6575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzDhoHLnfR5y3cZmffjyjk9zDv19wpdiuRdnsLKX1rKJRthcG
43397	payment	2133	2133	1874	1	1	6084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXsWHcCdCkxKbGLV2ArSP8MWL8q85uKEe3nG28QGxGLZJ89hg
43419	payment	1397	1397	1678	1	1	16276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDCZ98AQF5UqQR954mz7UowCwDkx9ZN6GUwcFnXZcCVJNQcxZ
43420	payment	1397	1397	1678	1	1	16277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAJA8dJ65rzvRsm6VD53RtX1Dz2m7bKQ7LYarzPVzbkAHcM4d
43421	payment	2133	2133	1874	1	1	6091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhANCHRMCBhcGhAZJi3f8FPJJM5RqEygCTbiYCLaekvLpne72L
43321	payment	2134	2134	1874	1	1	6549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oQStPEbL4zLqk8dx5exjEfd1vkZQ9RdR73SAtZVVrCndBRBW
43322	payment	2134	2134	1874	1	1	6550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjuE9EGJeSEYaTfDLRyiaKct1UtgUBErigftaQmBQGft1j1K8
43331	payment	1397	1397	1678	1	1	16247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZWi4hciNRwvZkiKrthBkC4cdrkHvnxymPP98cpGDeP466t3C
43332	payment	2133	2133	1874	1	1	6063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b12qGk6Dm4noHu7eBqw5nHNQx3Ak4sawzX7dUdqjD8orVDZW
43333	payment	2134	2134	1874	1	1	6554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMU1tBPLGXkR5yVkUJ9sz9QnPTQAPjocwC75BdazhLu9f8BuJ
43343	payment	1397	1397	1678	1	1	16251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVac3kvwthuGb8uBNKyNDSKEDDrwzZukHs1izk6iuTnPBzz1Z
43344	payment	2134	2134	1874	1	1	6558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48FexZwAFYxe86HVTkYZttuQP4MSgVdYj9oALNnD8HSZDwSZQ
43345	payment	2133	2133	1874	1	1	6067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHooCAiCnudvHViqjeYDETzKcfDksnx8Qkq6Jr3MSM3KzSP7H
43346	payment	1397	1397	1678	1	1	16252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KNPL1sg79y34gr2X2yhNEqkFHkovHknUMWhahLDZj2WnLr1y
43347	payment	2133	2133	1874	1	1	6068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgq7pmo1NbhN424YBLyPFAfQW6CAzSxskxyfRrjHPFDiAY4J4W
43348	payment	2134	2134	1874	1	1	6559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZknaN5C4yS1YwESsbUcC6311AuDauKBUH7vujbu1G2UuxZRxNw
43349	payment	1397	1397	1678	1	1	16253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBruamuYNTVwVPsxUCfmUhm92rsuAqYqkoH4Eaf4CyanK4CPbz
43350	payment	1397	1397	1678	1	1	16254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtNa18tLcJ8gHPq1HLdC339pWhe1tcrwjyk1CY8VsbSTQgS8d
43351	payment	1397	1397	1678	1	1	16255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6taF8gxVPqFw5okxuR3WoPVvgmaAtdcadWuivHoaePKx92rnM
43352	payment	2134	2134	1874	1	1	6560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjzuhpkiD8wGp81p5QgLK513MFs8zRyXi5b3mB1cSiMwgGAZB
43353	payment	2134	2134	1874	1	1	6561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc45qBArPufSryJRWQJXJrUMshLwM9UYEgkDrax8bYqcEsREMD
43354	payment	2133	2133	1874	1	1	6069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZoCM4n95AXpH7sZniiVQUXsgR53Q11CgJdyhwDLTQWREiJFZ
43355	payment	2133	2133	1874	1	1	6070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDviVn7CnY8eRPvbFPvJWvB2cD2PqMnfpEf9HXp2nZVrXXw9ye
43356	payment	2133	2133	1874	1	1	6071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8w3rR1ehSixJjGVwryBY3gKSzveAwKQF7sy3q9o7A4VLuTKd
43357	payment	1397	1397	1678	1	1	16256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPtunkKkL1H2WFMMWdky9Zn2DA8pXGJTMJzNuLtVPqQzmgnYq
43358	payment	2134	2134	1874	1	1	6562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXa5m4WsdLdFE7PWtBbJV1JmVFtUW9tYsN8yDFD5zJTA7XhaHF
43359	payment	2133	2133	1874	1	1	6072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cQkU9t5ByqnD2of6uaDyA2KBSnkBsX2FiRKT96z4mGGHFq5m
43366	payment	1397	1397	1678	1	1	16259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDhQyY88XTY7a3H3Y88yfusEiZ6VVvnSmLmNfrZ6rrTziZYEY
43367	payment	2134	2134	1874	1	1	6565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUouq15uYSNy467ioyhdoApKNN1gVETXzUnJ2ppA2fyAyfdUBd
43368	payment	2133	2133	1874	1	1	6075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSC53esVQcp4UpRbyQBDKqVWUbe2BNPkG44R6Vi5AdskxNtmj
43378	payment	1397	1397	1678	1	1	16263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckDdheMrLyAWsBBY3ovRj5rbpkGHbyfcSoDvmAf7ctmb4bity
43379	payment	1397	1397	1678	1	1	16264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXLVJya1WSMkRpMRUzbTgBJrHNsBSMfcD9mLbKrEAvkeGUqDg
43380	payment	2133	2133	1874	1	1	6079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNq9uvHNuhh9bBG8knd2RhKwY9JPXn3LAoDWh165K74z58ZteN
43381	payment	2133	2133	1874	1	1	6080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJDeCAoNaHz6ReKYGvHaACEBpzULsptzmCDQCiNqU1gSS4wg1
43382	payment	2134	2134	1874	1	1	6569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8jjSbkjYySEVVpGJFMvoFn9EiAhnPYC7U2DxArVcA2SKcWWV
43383	payment	2134	2134	1874	1	1	6570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW4PTVpV38qHeWWBvcAmT5DNDpCZThN7J1bRne4HuAAH25f2V
43387	payment	1397	1397	1678	1	1	16266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRM3srxywc1bjBKPYdFGeGkwse2SWSQuvevGZ6MXuvZq1RwUd
43388	payment	2134	2134	1874	1	1	6572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQPWmx9e9ccpinxonsDm3sabwbWLzMHdKf1waaWTaZUDCzbax
43401	payment	1397	1397	1678	1	1	16271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7goksprkvTP2HwXFsSGmWdjfHcWsR9ZKvDyzaEeXr6d8VEfux
43402	payment	2134	2134	1874	1	1	6577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJJNsNB2xF6gDzqvopeqhZNdvCUUMoe8H4nFA4HoAFjvYNjRF
43403	payment	2133	2133	1874	1	1	6086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFe5sqGc9qxwmzryk4Df9hgPUbKtSm9gyAdPR7QEjtq2f8CJyT
43404	payment	1397	1397	1678	1	1	16272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSRDjvELv9VU1LQhSXC3H9mZB2vQCZa5TbCZbu4WVhBB5Dfx1
43405	payment	2133	2133	1874	1	1	6087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTjT17u4gwv78RYyqaPL9DqvCE1aVy3whyGW8KHjzbZkfdzyH
43385	payment	2133	2133	1874	1	1	6081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtLKbWpu8bHEPNJHMg3C7M1d4rKNg2gACrot6qYsRR7VXy8Yo
43386	payment	2134	2134	1874	1	1	6571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4FZBcv3ooVoXrpkdRvGzcSqqBFaVvsPRKm7WckYtNjhcMou4
43392	payment	1397	1397	1678	1	1	16268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArAUFSrxiVBx35UmQWsKCVYQsBgctCE2Gj3agc6gyLjVXS1ZT
43393	payment	2134	2134	1874	1	1	6574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRpiwGKEJEd6bsLG9T6PMteikFw3Y2JpfyvPz7aCsK93dChaY
43394	payment	2133	2133	1874	1	1	6083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJzMYiia5czga14AoKrkBXHefhESSzjMiznJfAG1RFv9Jyj4P
43434	payment	1397	1397	1678	1	1	16281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZvwBq5XUw61DguwTapYGTnbAF3xu62mMi8RVkP94sB1yYdiR
43435	payment	1397	1397	1678	1	1	16282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1XfkHP5cuK3yPZ5hBbZmmLvoc8vWJzai9yQSKFpZng8xUXAP
43436	payment	2134	2134	1874	1	1	6586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PDVDw5wBxXTULyALs7ZB4ws57V3FC9KRhsRFRxeJEZgnjLwo
43437	payment	2134	2134	1874	1	1	6587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqYbm5tungcFuCjjYYUN625aTHSj2qycEMpHn57oU3AEFmLuM
43438	payment	2133	2133	1874	1	1	6096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDUR5ZZFrcxxkZaJiLs5sSEb9EgVV6qusZ4e6AUweMdK7ygHr
43439	payment	2133	2133	1874	1	1	6097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSwpnPzbPaEtd8SJvZNPzET9zQTgKfLWMBybJiPSn3ZbWd6LJ
43458	payment	1397	1397	1678	1	1	16289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9paHVhQDK7RG1Nh5crp6YoebMw9hJRfp8uivERW6TwYVPppAP
43459	payment	2133	2133	1874	1	1	6104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbKiWK69SMpPD5eQzMvbwdPmutU87aMempbhAv4iW55fthN3
43460	payment	1611	1611	975	1	1	13	554780787792	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZjSEAX4p4htMYQhWG7o7W9Ha6hPFgdYUw8W1Uaj3r5gVcbN2Nw
43461	payment	1611	1611	1095	1	1	14	994162418364	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpYaWsoRXqYriM7hYpqkhAkAiKrjZje1nDHkqGiWcLJ6AzvM9hv8
43462	payment	1611	1611	1215	1	1	15	670781193756	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZnT9LQEE3hSjxFUGgU1HwfgVAFZ3d2K2JndPVH42oAPBu41iG5
43463	payment	1611	1611	1341	1	1	16	1869191438946	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	Ckpa3HtE1YAVSuRybYpQLogi2Z7oSmuTe7RzgZGTDk1eFSGW2cF3p
43464	payment	1611	1611	1611	1	1	17	15158261124	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZ6WJTUhqUdXbAhYZQxEDy158Ttq6Cm8AHFqbcwsQHWEGWiwo4K
43465	payment	2134	2134	1874	1	1	6594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKe4Rex1wjfoEagMjwqDFXhGYcpHvHdmqtcHVMpWNiQL8pAQVN
43484	payment	1397	1397	1678	1	1	16296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6exFon28v12VYKr98qLCjobqvnvVi9oJnHMyt9gZmxGTqph2n
43485	payment	2133	2133	1874	1	1	6111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdyCj5VM6p34oXtcLceMZbZraE15SUmkiazHNk2yQB9u76gLkN
43486	payment	2134	2134	1874	1	1	6601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ixTCrJwJgN32u529njkSiEgLfuTWG9JQTYVj1h4zrKPnMPaT
43487	payment	1397	1397	1678	1	1	16297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWZuwpNPRDyRsDrpnBUXHvXk2rAC1jxEyssuWDqBBs1cAENtW
43488	payment	1397	1397	1678	1	1	16298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hgJPSRxF6m7uLjgQaEnAxTCMqzMbSvxAShkfVYHSQfv53xwr
43489	payment	2134	2134	1874	1	1	6602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfsMfEvtZdPZCpdpY5tfacaEkjBiPPHgrMSikEMDZ5Pte5d2n
43490	payment	2133	2133	1874	1	1	6112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokdgLMqm4qCEH881pu4uoJBmbqRbdKeYquugAgYgmhbpr2kLZ
43491	payment	2133	2133	1874	1	1	6113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsTyb3xCTxxd624iR4A98rc96TSSHimt3poBJdd6HLkJjSPMF
43495	payment	1397	1397	1678	1	1	16300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4NYNkgf2WgS23uBgmrJzELutjx2vPyZykhtv7ULVG8sBhDzE
43496	payment	2134	2134	1874	1	1	6604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJ1LyHVtSCbtjZ8MYpaxH9qYv1dfm5E4xHs8EmnWLVtrG3tZC
43497	payment	2133	2133	1874	1	1	6115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7sSPisfYM7jjJwHqgvWHaYvxKH3Mm2W2CcFo2L5PaJRQvXQT
43498	payment	1397	1397	1678	1	1	16301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo2jv6ybWxSL4tMXHAbTbpqtqiKGxbKjMSGhH6aoxybtsa1gu
43499	payment	2134	2134	1874	1	1	6605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWEmYuvPDNZUtnmGTexBifZkB5ohvJUahXoXn9WeYxpycTWsx
43500	payment	2133	2133	1874	1	1	6116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZQkoqdyPahJLcMTiJ6u7JXBDE78wC4SyNctc84AVABQZ8Srd
43523	payment	1397	1397	1678	1	1	16309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdS44kVsM8GXDWGeyF7qk25NrvsTFAgaJTE35nVJf8HAzpXh9
43524	payment	2133	2133	1874	1	1	6124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbciAjMEuYkCPm8hPHugRL3meFWtJ6dihemQneGzFazRD891D
43525	payment	2134	2134	1874	1	1	6613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DkLf5Atv9capsipNpBefpQcTvoRUB2JTcUxsAmkQzNkqczU5
43535	payment	1397	1397	1678	1	1	16313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFRa5ZgkAqK785SYLpcV4dHeUmw7CeCvoN6pmRfXMCBbUjviH
43536	payment	2133	2133	1874	1	1	6128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mWU5NxAtBvF99VQvWZL3aUajMn1jQziDa3Twzyr7uH4kpnZ7
43411	payment	1397	1397	1678	1	1	16274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCNNcz85igKf9SGUFLm9263jWAvSwkg3iTtxtq6m8UYTvR7Px
43412	payment	2133	2133	1874	1	1	6089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a9v1t6AKawBguNvvQQpxH6VozKcYiVZDec12guD29GRc3PZ4
43413	payment	1726	1726	2371	1	1	8324	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCwZR4kTBDcceejpbX7uyHrMn2DjW1PdGViRa8j8cyzitHqHnz
43414	payment	1726	1726	2372	1	1	8325	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYsMu3P1DtzfwejxvDqYCMwTkSJCu8iCTwLT1Ev9wUnT2cURgEp
43415	payment	1726	1726	2373	1	1	8326	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRuNasUdySMPkNmgPF5996JEEMSjRu9AUycNhHCoUDpibQMNyD
43440	payment	1397	1397	1678	1	1	16283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUxeoZiYxXz9vhRD4VdYxvKR87yn3TnB9UNmFvQkZUGs6tGhS
43441	payment	1397	1397	1678	1	1	16284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrX6okC3ZZqi3NBZfCF4NHVsk7rY9jT87bmhsbNkMGPcnd7fMx
43442	payment	2133	2133	1874	1	1	6098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamXLQ1EbY5zFH6vids74BioPvgprL5HfNWbhq6HeH8NzGwVTd
43443	payment	2134	2134	1874	1	1	6588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes1fWN1qeWedFmvLGNZoFwhcRHiHMczAWwzTaZ63uJyeVuTN1
43444	payment	2133	2133	1874	1	1	6099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsQ86qwiPwCWBoF5vHuQRGJWjpFNZjoBTwf5gF8BT2Bniw5Ku
43445	payment	2134	2134	1874	1	1	6589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEV3p5knKJD24yeVhJopKWrMfwCm85M85vKbiKZUVHctfFWQ7
43514	payment	1397	1397	1678	1	1	16306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFY7NAGBv2S9T91Ksuieesw4amN2N91aaZXsDjikJFMZ5z8Yi
43515	payment	1397	1397	1678	1	1	16307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxvCeaM3iMrEfb6z1dbzpLW5MQuiRSnexyWwCqgGtjmd5r3fW
43516	payment	2134	2134	1874	1	1	6610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqN1RGSLumXWvvzhL5MyvSZbWPEab8BgW2s8f6J2H2RRUmzTb
43517	payment	2133	2133	1874	1	1	6121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH5cMLek3yddyAMRq5prHyxFfrpmK8G4BYG7Bpg5dkibMewRk
43518	payment	2134	2134	1874	1	1	6611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgb4zEmwG3bu7u34yVgm7yX5ovfrmGdpT96WGDbuiHb6doT18U
43519	payment	2133	2133	1874	1	1	6122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA47c5569XtNWdm6wgdPTGdyNCjEUn8hdQYAgNBgd7BozDnkce
43538	payment	1397	1397	1678	1	1	16314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeiJG3Judm4NRDDaSERx4ogqiTj9mRHEM7nYkDPbDBDrWRMTN
43539	payment	1397	1397	1678	1	1	16315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQbe5RyhD5DgrY8TfWZ6UV1z62ro8Y88FnFCuBLzAEnEskAB1
43540	payment	2134	2134	1874	1	1	6618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcX4iLaLHz7AGJnw9ukVF8LN6pGPMfDfUR5iZtqDKnB2bfZkr
43541	payment	2134	2134	1874	1	1	6619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1U3vCJoUbwHjzz3aWBP9uW9kn8iomEha3ajHk2b9Rbt8DMSK
43542	payment	2133	2133	1874	1	1	6129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBA7ynBun8aV2La8jh9AidsHAUCTgCDvs8cCGy9qBcCxsjhuj4
43543	payment	2133	2133	1874	1	1	6130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTefT5c2GGX3kdhxXQWR9tTeKUZDK2WrVGYG3X5vC8vuFCU3bA
43550	payment	1397	1397	1678	1	1	16318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtsAE6P1SLMD3gt4rttw8sLFVaMzFog984Kq5GqNsWMioH4n5
43551	payment	1397	1397	1678	1	1	16319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2SjM2drieGvVpQnbcGQJGbqUoGnSzNFXyxNW4NBtsdoRapS8
43552	payment	2133	2133	1874	1	1	6133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1Ao8bR3xzGAAgq8UCANcq6zSFHs5UDfJZzkEhEZ5Uk84Q8Pf
43553	payment	2134	2134	1874	1	1	6622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnouMJDUrz5JS1z2qjjR28Q1kCF3Ph6vVyxi8XPPp36VTtfqqK
43554	payment	2133	2133	1874	1	1	6134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxAopB7AC5d2FBH4LKvbk1sSNXs1GyRQDp6Z51AnwbNbQChdk
43555	payment	2134	2134	1874	1	1	6623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJwW81pxQPZPLemRPjidEbF2DaoXEbS1KodkuV3eAi6QgfTd9
43573	payment	1397	1397	1678	1	1	16326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oMz43Zfnrp3YAnsPtcKsuespXTxGSNJXLFbmhLwCs1PC3Gmy
43574	payment	2133	2133	1874	1	1	6141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi837fiVAm45t8e2u4ixURSUreks3ECYFpZpDVmhSgyxkAHuRS
43575	payment	2134	2134	1874	1	1	6629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqW4nJReiEsA5rnvayWNwjSDG4psPDjrqfipci24cK9UdBe1NP
43579	payment	1397	1397	1678	1	1	16328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryJW4L5CYLCYvx9DrRkiK72yYHhznX4MC8rdWbqrZPJ4yYyDo
43580	payment	2134	2134	1874	1	1	6631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy9FTVQbAL1TJfAbfdTrjqtE2mzbEWLRQD2ioEeoKgWGEVcos
43581	payment	2133	2133	1874	1	1	6143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGM7Pr5TVjd6UpPn682GrXz72hfa2b6QmdLwPFjyjn5qZ4paC6
43588	payment	1397	1397	1678	1	1	16331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTAkx8gdjBmv3EbWZGBbztMqWSLTAwAykg48MkuQkLKQpuKDS
43589	payment	2133	2133	1874	1	1	6146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3BjoQqmtH8PqEXJsuuzaYeQfqiiHLYrQZp1wFs4wiyWuPVVw
43590	payment	2134	2134	1874	1	1	6634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9aSzqxtigMqYXQr9t36hma3JHk3Vg8UbN4RNVXdjHmvcTMRD
43422	payment	2134	2134	1874	1	1	6581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyoC9Up6KnvtUtFpLmT5856aVxX45yCoNrBpkvviETrL9fg4mW
43423	payment	2134	2134	1874	1	1	6582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYewpxG732MZrUD5m7qUjHLHYnfbwWE2MuBsALb6jw4PUbkQDiF
43424	payment	2133	2133	1874	1	1	6092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3Nu8EG2eKybh3z1aB8inuiti8Z6mzz6zKjkquC5C6ni3hfik
43446	payment	1397	1397	1678	1	1	16285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYvF3CNktV9tV6aRiqeLhwsBvpLNAjypkNdJQwH3QpbBpstyA
43447	payment	2133	2133	1874	1	1	6100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZ7bvJVFxjSB5E3cGfZVCmFNsJDYEuXQNRq56YRogdYA3ZBRa
43448	payment	2134	2134	1874	1	1	6590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibzd7h8NmFcdKZKFstASAUBE9QUTwGTDnMiSrP1j1apy7uGGY
43452	payment	1397	1397	1678	1	1	16287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMjPmgqUtbwTFtYebXTwdgR8VwBwQewz24C7T46q3wBiXJ8fD
43453	payment	1397	1397	1678	1	1	16288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpsdGZQKbcrMZMTPMpQ14a1JPffYv7ELyhTtULRrfWTp8wiKP
43454	payment	2133	2133	1874	1	1	6102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhejCTWNvxabHxuaRytRp1FzBbeefk6FxAJFk7V39a6CppfHy6
43455	payment	2133	2133	1874	1	1	6103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDkbyyGRDTFs6TWtTJhDV8AuKojxSpvno6RKpH1fe8YJ6EGS1
43456	payment	2134	2134	1874	1	1	6592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp78jxa1hy9tJ1pfrsVQQNaCi7uj9StV9shYDzzc3zBZ61cZXr
43457	payment	2134	2134	1874	1	1	6593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeitdmocC3dFBzHEqKry8aCY1ioUmkNCv4Ke1wQbw7v4tZyxx
43466	payment	1397	1397	1678	1	1	16290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAU7sdUCPF8NN4qYGMD1spuuSRRACRUiCMB1Lksgxr4qXYSze
43467	payment	2133	2133	1874	1	1	6105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbwaPBfCs8KGDBpoprzWFMfsGCY5JxKN9YsLNFY8hbHVGqewr
43468	payment	2134	2134	1874	1	1	6595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJzixwGLkhbswLWc9r5gMqpk6zuXtmWewmfcWtYMKM2yU5yUB
43483	payment	2133	2133	1874	1	1	6110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFuSM5zTtP1WQ6uA9Sb4Ebu2A8XA5eAjvneMw2BzSHbmDQKT1
43501	payment	1397	1397	1678	1	1	16302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNNhKH5eUShfqAjbAMVStn1c6dSc8JY7j6DZUGf3oKiqJ77ea
43502	payment	2134	2134	1874	1	1	6606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjKzNDCur8FSCMvqyijHeHU3TDvgqP1vciEujENccCG27MkGy
43503	payment	2133	2133	1874	1	1	6117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXP4yChGhPhGncCdF41hdwPcFrkYTwudRBJa9vovFU1gmYqHBh
43504	payment	1397	1397	1678	1	1	16303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5tzMZpZZTKSLZ9h4iwMbWFPpZ47aPZoWjR1SEXL29nMFwhJn
43505	payment	1397	1397	1678	1	1	16304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrkXv4zMEJZq8P1VCPdgPX3HjUEwvAnsEzG1NQ2EPHwNo1JdR
43506	payment	1397	1397	1678	1	1	16305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeV6fdYZLKMTLAtFF2HjV9n4w1B4Fp85SPRp3JeLKSRLmqHxCe
43507	payment	2134	2134	1874	1	1	6607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHTijiLqY7wRGqGeLdZ6aStAKcuWqP8hqPyZRpTeXLPo6CyBa
43508	payment	2134	2134	1874	1	1	6608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmyNzeLoZEu41NW55czgzdhnr8EzXDL2sM8CqYSCKMQowaNoX7
43509	payment	2134	2134	1874	1	1	6609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGSofBor9x6ymqg6WnEqvxSSvASmr7DpSae62xJfiyLhsHcKC
43510	payment	364	364	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZa685E4qTXcwUdB54Sbyf59de8r1QvngevRWHQHqNfMnggbd6
43511	payment	2133	2133	1874	1	1	6118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vj3DM5qwnEQzpg7rWkfQ5QfSujvTTFtEAzu734b1kgk1G3EA
43512	payment	2133	2133	1874	1	1	6119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPdkpF1zKt5QTDSbUWoQtXfcsuZn3jZ4JmdxdmSAHEH7P1XkE
43513	payment	2133	2133	1874	1	1	6120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYk7V2YorQdFkYBvyUZePVBsnAXLznTozWNQcK1YTUHSoKD8iP
43526	payment	1397	1397	1678	1	1	16310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KS8bwAjnDjyzZejYwajFKCzohqEVgRGsrNxJf5X4WtjkkL2o
43527	payment	2133	2133	1874	1	1	6125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsSHdJtc69rxCHB4VWmVunLXwyEcj4J5jbFsRc3uuQJ3kwvp8
43528	payment	2134	2134	1874	1	1	6614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1H29GXLZ74PQhKxQ54dWucb2f3TFfueKCqoNa2TofBT2zpTq
43529	payment	1397	1397	1678	1	1	16311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5k7WiEBB6vv5Atb6vNA8hFzcV1jx45yC1twsbZGBqsec8LUY
43530	payment	1397	1397	1678	1	1	16312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZws6ZGLyL7QSAUb8QMVLdZ7h1iuSTqo1JkLvsS5Z8Fk54E8Hu2
43531	payment	2134	2134	1874	1	1	6615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx3rx68JksXNNYicTokJT1ueVurKuk5dDt4ebP96tE2jivrmi
43532	payment	2133	2133	1874	1	1	6126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtA1ccAkxkYQ6MjMtvigo6c2YrDa6AivzpHPxpeoToouMW3P2u
43533	payment	2133	2133	1874	1	1	6127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdzEj4SFsb7fCZHg7sJ55NxkFKaQ4LDAzzZpfM2JrCjFpxjyt
43534	payment	2134	2134	1874	1	1	6616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtMFNbYi1zcgqHt8hSsMNrrcomGrAdiafTPBYumEhPze1D5LY
43428	payment	2134	2134	1874	1	1	6584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVko5ojuR1Q1YjzXEXzr9GHEjCsFe6jZKAsWRgqJyDNrs1jxG
43429	payment	2133	2133	1874	1	1	6093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWnsKVMwZ8xARE31R6iexZeDEptYe7MW6oCdGLuUGrHG5ZVKi
43430	payment	2133	2133	1874	1	1	6094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJJHWpoCPDrj6Lam9RwDM8gehTrx8bNTH89tiYPcmaGbB2F26
43431	payment	1397	1397	1678	1	1	16280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJvs8hnHkmoaRUDGvrDjFWkMhtwCss8rezA3iSrcebBUzXi1b
43432	payment	2134	2134	1874	1	1	6585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MiPU25xFNJY71jcHQfw4eLsMKwXUgDMULvWYffxE2iDmXrPc
43433	payment	2133	2133	1874	1	1	6095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMhuX5sDGckcMM5VPhnzd9HtL6VxoNQwMjF8x42oUAeGZd8ue
43449	payment	1397	1397	1678	1	1	16286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPy64HYHPfgUShDp8jnGDetMM5X5Md1KTatjk5VAyB4zTudRq
43450	payment	2134	2134	1874	1	1	6591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CQv9qTE896PCixTzVVAmQdo9euzWUKJ8P1DUSEyDQAViXLqK
43451	payment	2133	2133	1874	1	1	6101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3BopWPevgVTTkguzHGLXWNNj1JDgnBYBh8e6PDpMt7tgceiT
43469	payment	1397	1397	1678	1	1	16291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b7btmFZQk9NAD3adffrng47s7NabVjyH1q5v6GWWL5GhWojq
43470	payment	1397	1397	1678	1	1	16292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQzqgLMFQZJ6PqH3NBAJfR7BisfhC4jVRCqsCVXFQABkDrt2N
43471	payment	2133	2133	1874	1	1	6106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkJrDqnNQ9Eoqc89eRGiUjLkuXNinmJP794f3w8LT3BCM64Pw
43472	payment	2133	2133	1874	1	1	6107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFNGQiuv3scY21K9RdiTdt1wAu1qKbmp2z3JfS16ZTsm5hatx
43473	payment	2134	2134	1874	1	1	6596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDHCVC9JyqJa9TRDrfbfCpcWhfWvD6fFRgcPHuBhxPq19kWRQ
43474	payment	2134	2134	1874	1	1	6597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThB4HPqftAc9edyArMJqcQjprLcjTRkfYuBynXyus2recwv1r
43475	payment	1397	1397	1678	1	1	16293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvaSgVh2gtmm3SEWf11KXLCNJV5nusKsej8XnpZDXecdxmi31
43476	payment	1397	1397	1678	1	1	16294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5x6CpPjCmv9qvyYq1zf354acHpe9bxMu39QeZ7batcx42tbZ
43477	payment	2133	2133	1874	1	1	6108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyAApfLqJDwXeBwMb7fiMgfTibXyFk9xxZgTX74imE6JL5QFt
43478	payment	2134	2134	1874	1	1	6598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHT9KmR4GpyRWf6D2vjv9arpM3vGYmX3iQbCs9acsKJe84dUnJ
43479	payment	2134	2134	1874	1	1	6599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkGFHL6PyHc6Kz4hMwxay1CLGeBL1vVFXdAyQW8KMJsbvz5vJ
43480	payment	2133	2133	1874	1	1	6109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwyz5UGtZc9Q5eQkZhDSSw5PGtdwd3yTQ4xAQVDMFGrrxpxDW
43481	payment	1397	1397	1678	1	1	16295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVww5X6jPGn7oyLdgMhjgg47nsUBrGizgmSoYMDxdUXZSaGSm
43482	payment	2134	2134	1874	1	1	6600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgA8pbMELAQUdkHnfC2CkTKmmVE6uqWCzZJVrPjW3uVnXH6cV
43492	payment	1397	1397	1678	1	1	16299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYtDUUVKavemgjPmG45Q9UENbVJbop2s5u6HoGT3wmNtiSru6
43493	payment	2133	2133	1874	1	1	6114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPp7mRdWFNbmvvZRmt7uQycprTJ6PbwwBfU9NPtp8g9YC1Xtmm
43494	payment	2134	2134	1874	1	1	6603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiWWpSvKDsL66YRZaHQtfghbsvZQ5TUa2DWpRaJTmScwkbLfK
43520	payment	1397	1397	1678	1	1	16308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGXrpnBQpLDFPMxkFxAZox5vMCwRQTi5eSwK8JyLXjoYuXv3r
43521	payment	2134	2134	1874	1	1	6612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENZNu6oNAx8fiB26gFSChLvsngbDX8K3TT8QZw5fffHbhiAJ2
43522	payment	2133	2133	1874	1	1	6123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bQFbiSBizG7YG8P3nNfDg5nWQKCo9jGFtnmmXyKJ1rBvQH8A
43565	payment	1397	1397	1678	1	1	16323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6QupwTuhHmkkDpKyHGECeHPi1Cm1e1PsZVKtg2cZJvyeJTfp
43566	payment	2133	2133	1874	1	1	6138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBaU2vnQsvTJoJg1sCNBp7DzKzJ5veh39bjfCKEpT8VBEFNVbJ
43567	payment	1397	1397	1678	1	1	16324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7D5sJFVXTUT2E9sKQUEYBsfseuneAfzq1gXWdg4MeKJQjEx5
43568	payment	2134	2134	1874	1	1	6627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcFCjBes6fvGaXjZEmgz9ZGtyC7rwM74xXi4dr23HMxGj9FFa
43569	payment	2133	2133	1874	1	1	6139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1XH483hfGj1cBqtXraWFrvoakR13w2umpKqbQuHubPfVmN6X
43576	payment	1397	1397	1678	1	1	16327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxuATYU5q8hdkwT6pJXrzJCKpki7vbX1nrUhvXn2gFu3CGb1s
43577	payment	2134	2134	1874	1	1	6630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDMhQBPtv8ic8HSedBNaW2uBBUxsFvSy2qiETVgkgWvaZB1xS
43578	payment	2133	2133	1874	1	1	6142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUpZB712ivw2FjCGLr9pZq6fve5Zuk5zpxnoHDX6WoMuGjZXy
43599	payment	1397	1397	1678	1	1	16334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddAbdaXRuUz995Fz5H1PhtfnL8WQLSSn31XwR6uLViFb2yUqG
43537	payment	2134	2134	1874	1	1	6617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7okLF4u8mstyLg6ZZgeuag9rbwvNAydkqCrZsNjsWrAaKf9fC
43544	payment	1397	1397	1678	1	1	16316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NPnmLTkcp31jwazAonD6ub3j4yTFJXP6nomc1mrgQ6xJNayK
43545	payment	1397	1397	1678	1	1	16317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAEnay2D169t1c7YWbHk1WEsrd11jwqsTKwYYKsSYzmYstGTA
43546	payment	2134	2134	1874	1	1	6620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDLSi8F9zcSMoviNmC8vXKs1PFr61osuzrHt4ZzaqHdUHzE23
43547	payment	2133	2133	1874	1	1	6131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDnEDdw5GBLN2Qk6UTM7xSH7m5NK2bZNH6RzV9srZJpxiWVMP
43548	payment	2134	2134	1874	1	1	6621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrh6HquBcMWHE2k4PmkgaCd6UqwH8VSbJXvBwDTEMnU6nVC2E
43549	payment	2133	2133	1874	1	1	6132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdYTbyb6AwWJSGJncoiqjCF4LphNqtLD6SeQMj941KkAJ6cWU
43556	payment	1397	1397	1678	1	1	16320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFAmLofxupCYEWkTZJEkYVYpuipWZoVBmJd8MwyBUUQBpYvFH
43557	payment	2133	2133	1874	1	1	6135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmC7fp8Az64rMhpgqVR5Wk2yvCCQSAf4bfqfX49eGVMkJ47EC
43558	payment	2134	2134	1874	1	1	6624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBq7H1RvZtcdEti8UgGsNL7JprDxpJuKmkHettgo5orwWnoDsH
43559	payment	1397	1397	1678	1	1	16321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYjCx1aLnRhcp65PRm9XYfHvyohBoZXP6HMbni6gksEvqXWVZ
43560	payment	2134	2134	1874	1	1	6625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQVy3tjnCvcfvNCDR2G8oZnhYme4m3UiXsAxAHvYJ7JEuneF2
43561	payment	2133	2133	1874	1	1	6136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD261Ja3kEGSpk1gGvUTeA2xBVM6ztC5naCPzmFAZd3XXrxA4
43570	payment	1397	1397	1678	1	1	16325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EwFL9WM2riNtPygZ9265o2ShKe5caDqgC9HkEGb8foTkE6dw
43571	payment	2133	2133	1874	1	1	6140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTGw7LfoNxAj8j8m1FzDa4DaeWPNB9V1Kd1xQzHnmmHALioKn
43572	payment	2134	2134	1874	1	1	6628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtrM6sVUAXTiBEF4a9TPNSoxrCbBgj175yfA4vQLabUVo6cHx
43605	payment	1397	1397	1678	1	1	16336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyUrim6umhPeQqj2HPWP7Xtuaesutrpav2tSrWUD2FNaLUQSj
43606	payment	2134	2134	1874	1	1	6640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbd5zw3Y2cUtxK9YdnweMgkzsvPig6Ao8pBkNn36QH3zhMHQQh
43607	payment	2133	2133	1874	1	1	6152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNRPHNv9KSPwuw2t2ogz6N9V2TJBGijTy1PB48B4aMWU8qHNa
43646	payment	1397	1397	1678	1	1	16348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGy7ZfEJRqEmgc8CtD1ayHNXGZ1iSX7XAMZ3fmXshz1KifV8E
43647	payment	1397	1397	1678	1	1	16349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9sLUMPAM3NGPDrryvoejmGvvvf8FTTDUMT1ZHQtAS49u2uWY
43648	payment	1397	1397	1678	1	1	16350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8HhFyv4dAA17V65MwuSEFLJYujQXimZ5RJbrkbc6d5TSUf4u
43649	payment	1397	1397	1678	1	1	16351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRDnWKvkFG7t6hiffWatLsj2t8seKdCUyczEQgcBrpVf5sS7Y
43650	payment	2134	2134	1874	1	1	6654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qd2f3dZuokmXzbBQ3KHz2tbRc9ybjFy7che1wHRVkpuWyrrH
43651	payment	2133	2133	1874	1	1	6167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtppcsQWvYjLfrdqUQDtvFQnem2GbhtzzQC7zLkAUqypQ4KbcA
43661	payment	1397	1397	1678	1	1	16355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy813Jc6nUxoBbg9ZzFmka4p9nSs8y1b2mJP1dQ8qSV4CGPgun
43662	payment	2134	2134	1874	1	1	6658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQi5FGxp8GVvfprRpVH5gySzHnoKWjsNiHskdzi2iaajRUBqiC
43663	payment	2133	2133	1874	1	1	6171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGYW4oRL5yM8MUL1cLueEtJ1AGcrYgWs4JahJr7R5Ptcacphv
43685	payment	1397	1397	1678	1	1	16363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMDgJRywy71b5JyACzXsLWGkSo9XUfjkZn9Qkx9GbefzSUdmz
43686	payment	1397	1397	1678	1	1	16364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxh1HSHhUWz8uEuarB9ifQWojWeYQdvMbgwBCZdmW5jK969wjt
43687	payment	2134	2134	1874	1	1	6666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMaj7XhDqBhzsXqV7w5DT76cDqSs9SJ7UxvNcnqk27qY7EHmn
43688	payment	2133	2133	1874	1	1	6179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwihLwyZY4eG2sSU5SCyBj36oeKQNYDeoGP7Q1Zpt2CbiMwSZ
43689	payment	2133	2133	1874	1	1	6180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dyQX22D3mxEVkRp5uGDY1sJefUfQQhLXoZy4B3yiZR5bh15k
43690	payment	1397	1397	1678	1	1	16365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiALKBxAnzp2v6BuXvHfvb4rF1nobAMQNyhRaAq9yq8kN7rpsw
43691	payment	2134	2134	1874	1	1	6667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwgHH3ZtGK6ZR4vuXPJ1QSb1MmrneKSK4QBaQEYruhc8i14cU
43692	payment	2133	2133	1874	1	1	6181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4QUMWzBTjWuU7CLWoEXnvHLrDPoQUerQ3irTg6Zb1SX5iKXew
43699	payment	1397	1397	1678	1	1	16368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhvphyZKnxmC3HV5eGPkrQgUoGyrZYoSSsVwARKwGeEhWmpXf
43700	payment	2133	2133	1874	1	1	6184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhCBFuDk44AJSAMUC7XQau4sbKxgKGJKq52GnMp85yZY5bJMz
43562	payment	1397	1397	1678	1	1	16322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sL2WTaN5otWuCrM9xaL6tXeqyKMVbNSUjY6Ymx88uzWPEs1d
43563	payment	2133	2133	1874	1	1	6137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYue62QVzapfTJB4L735dnRwHxDrfCZmRpFXR7cDGGF3zYnAHCA
43564	payment	2134	2134	1874	1	1	6626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZVtYa1HCxvKtLZkoiJFe9vYpcmaxVUH99THB2hMVPhVdoTzC
43582	payment	1397	1397	1678	1	1	16329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TC1mdBwH42sv5bBQsH8sXwDybTb1nGkJv7gkJ6qmLYmax2qF
43583	payment	1397	1397	1678	1	1	16330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwwVGyE23sm14ma5A9m713UJbSCuCTsuhDby77FfP32RiCdar
43584	payment	2133	2133	1874	1	1	6144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUudTb5y4bmtUy4P9e1ZMZuV5v5b51E5VgudJNvxrxuLbEJr3F
43585	payment	2134	2134	1874	1	1	6632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTFcD26YxQ8D9ffaoyNZfdqGqwW3RQbbjPqUnD2x2i1Go3jKX
43586	payment	2133	2133	1874	1	1	6145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn6zHJXCnv9WXoyA3nYQaNyuLJKLMdxCvPSBfc2QY6cXMJvue
43587	payment	2134	2134	1874	1	1	6633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HR71VVKvgETBEEiks3dyqwmcERHLdjvBXBuSAcj8NxixLqdM
43593	payment	1397	1397	1678	1	1	16332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb91krnKodJ3HgXKniETypNyogZRJAbiAMdFuJrpytrbwAkJwj
43594	payment	2133	2133	1874	1	1	6148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpQBGKoWVXzUQwhbsoBTSLusC4w2c9xo4nj2WsaXvtBorhLzX
43595	payment	2134	2134	1874	1	1	6636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV66pU3WKFyQPMRYz1hsqF5A7etNfyZnSniJ2hBfgVA8qyV9y
43617	payment	1397	1397	1678	1	1	16340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3hQcgitf7QYxJCEgqrWAAw1fPFZogK28akcuSipA9EwyjzmP
43618	payment	2133	2133	1874	1	1	6156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCgekpuomD1RcC1z88HdxZcb1gna4LQyvpszVMCjDgicrPL7d
43619	payment	2134	2134	1874	1	1	6644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8gvHBxmKp5HfnburotwE4VEKWhKsCohgkx89XrLqiKsvJ4Z2
43626	payment	1397	1397	1678	1	1	16343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUrEB8smVq1KFsgGZcATZ92PV4WuDqKYtFCqsWRuAMi7YUqmA
43627	payment	2133	2133	1874	1	1	6159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRp3zbVFtf71HBmJQhVaHmATQxMqzv5gJtoJSHrrKSV4DYvHKn
43628	payment	2134	2134	1874	1	1	6647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtP9RPvuVxXY55JkiGEZLUiHcFvVniPW7Q5WWmm7k2Q9V7LuXr
43644	payment	2133	2133	1874	1	1	6166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn9yDwXEfjC3GgXCoCHCuMNxTtbsWWfU13qJKbhCNQZ4uJHpr
43645	payment	2134	2134	1874	1	1	6653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhPKBDNSYL66ocQmtqhwNMGB2RCuNdqg5WTaNsk9CDui8qQeQ
43652	payment	1397	1397	1678	1	1	16352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzktUpDJK1a6ARFsYUDR1Yjtz6CdKhEvQ2cgKpuNo7AavtRmT
43653	payment	2134	2134	1874	1	1	6655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8HGh9tJWYb4E6HuVUxokBf213ymratHTn3QAUDkZan5d6vD8
43654	payment	2133	2133	1874	1	1	6168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VpFNti9K6Z9J7Kpos4uiWgPy66f7Q99nPbPrCtWmowkyE5v1
43676	payment	1397	1397	1678	1	1	16360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxXNgZGbXzs76ACSAp1dtwtrk7TU5N4csGji7xVwszv5LMh5A
43677	payment	2133	2133	1874	1	1	6176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cCEFpweodPcP9hNtBWNotAnMHR2G6UTA3JJg7R8tA9V7UdWF
43678	payment	2134	2134	1874	1	1	6663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6UqDdNjmX1KZP67Fbivx5GhWfqZrrYcHxYcGQXtkUw5avBE7
43696	payment	1397	1397	1678	1	1	16367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbDWWnAoUwGhaKCE87vQqoZ2iNTSbofKtqazf4N9SVEzbKoDV
43697	payment	2133	2133	1874	1	1	6183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzcvaFAv3brobCin5RR4BwvViYzLrZpGmpsG9XuwthyPTHAkU
43698	payment	2134	2134	1874	1	1	6669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6owwo3Wx5k53zm647qwaYLo8MScpfDWzeJKJc7kUGj5Au2BWw
43720	payment	1397	1397	1678	1	1	16375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjqaN7brMuoSKHdCdaTnVHZJmk3zaENidSbBg6RGg5wgCSvfz
43721	payment	2133	2133	1874	1	1	6191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsvfJXmpWTRQsDhMkxwrN5n5oEiSgkYXp9pE4PZ1q2WUNk5GP
43722	payment	2134	2134	1874	1	1	6677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjogwrRCDMSzwR9PVZ1rzKDr75DupgGstkJHmacxqRhFWtgPYY
43746	payment	1397	1397	1678	1	1	16384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqavupkiJqchVHxHHdN4HRyVmE5afqrWB9fw5cakn34dgfs4JJ
43747	payment	2134	2134	1874	1	1	6686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQRDu7BFCCYeTJJdbPjMWAraN6YaNPZ8gZUbJkoMPWqFg39Tg
43778	payment	1397	1397	1678	1	1	16394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDBCZfmfewFU64CRLQHSac5qzvX1GZuE9y1gx6JVwZm9oPSEg
43779	payment	2133	2133	1874	1	1	6209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdtcrDmUiTdMZ5iXL7KBpUVHTuERhurEMXcmmFMEZjXis5j6v
43780	payment	2134	2134	1874	1	1	6695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYB9xN7BfM5NCdBDi7BsXMWpUtggRrAmL6bnUWM5vFEbj5a15
43789	payment	1397	1397	1678	1	1	16401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3W8CHigqwoSv6FuBSLH6G4WpKXLNrLPjp52iZTDCefws2GKr
43591	payment	2134	2134	1874	1	1	6635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvvJ3CsDuQT4dhNnEX7etBCMYWQGLQPPr25ankEwHY41DWTNqC
43592	payment	2133	2133	1874	1	1	6147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHu3PNR8jGqo5B9DYNxtQumTXoWJHYeSBy9SMrJnBapNpqBcLv
43596	payment	1397	1397	1678	1	1	16333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNtg8Gva5e5rMoU2Pqv9ULb1pE8Qwgu41es8GZBCaQBjGcKEe
43597	payment	2133	2133	1874	1	1	6149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHv7FV497UpL9x3LMTM9AicXtZDHJAfrTDKxTwZFu7p1JQKPLs
43598	payment	2134	2134	1874	1	1	6637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8UbELn96ZYRBZtkgbGQ8h1Nb2THcz5DftCrKRgs2L13tWgM4
43602	payment	1397	1397	1678	1	1	16335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxPRcWxDACtXeJeseG71wTEy5SQve9yQBA4iThZq8bVthFp9c
43603	payment	2134	2134	1874	1	1	6639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYjUCC2z94hLLXDoZCVsncgANFv1Sp6f5c4cLkrWcnv46TNDA
43604	payment	2133	2133	1874	1	1	6151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMfgMeV7arazcRddF3T9PhXjmyiGUXDroyWVrzp48DLv3xjCE
43608	payment	1397	1397	1678	1	1	16337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxA9rp6hk4Fipq5jkRCrbenUpUVYdP3fKoQZP2iMHTZWuLnw2
43609	payment	1397	1397	1678	1	1	16338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW6KAXpLSzLBaVdNBpa6uNgFfKukCuL9c86YBY9afJVfdrgZd
43610	payment	1397	1397	1678	1	1	16339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbUtXnehqfCmV3q4w2EUenEQhkErmpHRSC27w7ayPva4pNSZe
43611	payment	2133	2133	1874	1	1	6153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67pus5HRPcfadW9basa4hgQSEJDYExGfCFJvprcRrn6qgnUgC
43612	payment	2134	2134	1874	1	1	6641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dr5vkYcmjkMd16QdbK7GPYwCe4oKpjbmYNAxjkeuJGDegZjP
43613	payment	2134	2134	1874	1	1	6642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsJhoFrsTCYL3qAgcMyy2sGZy1Ht1AsmSccAoijFovX2DJxdg
43614	payment	2134	2134	1874	1	1	6643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEDaJNUpKrHck1EnJVvLRDZ33WQtLBSDv6aGXeGQUmhPFj5Jw
43615	payment	2133	2133	1874	1	1	6154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEquFzdW8cSKsPeQN7or2ktFxTBcTCpKDtk9zP79MfrN4p4Rsh
43616	payment	2133	2133	1874	1	1	6155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgrnZE8B6mGYUrUn2vVWDB5a2MvoCczgngtG7L46enx7Xwmbk
43623	payment	1397	1397	1678	1	1	16342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkEZx6ZCpvN9XaxtqXiTgwGaQdG8xxTWb2Wv9yqbs65Rtqev6
43624	payment	2134	2134	1874	1	1	6646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMajvxUPWeHoQZM2u4jmKkznas3StYjptWDCXc8rvibh82aME
43625	payment	2133	2133	1874	1	1	6158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob8oJTdCTzgAYsdBnx8RMybf4N7bZj7QabopSg6E3Yy5Qa4nX
43629	payment	1397	1397	1678	1	1	16344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZratG7fe2zAkXKatfAg4JeyqwJZSA6YRE8pWLDXcAqEdt398YK
43630	payment	1397	1397	1678	1	1	16345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfriWRWqcSdkHxgDb9G68MPhGNNcjgKhEunNkzdT3tVjGB2t5U
43631	payment	1397	1397	1678	1	1	16346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAesc4is1jpTXwN5PecSVbkQgtxMSnbwdfZByvsAvDxuAZraSs
43632	payment	2133	2133	1874	1	1	6160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGY7J9u3yZNKwuXsRfUeBdCsDKNHme7KrZ9gb7vJbKgx6XcXx
43633	payment	2133	2133	1874	1	1	6161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKkJZFh2aVwzjkSWANUdrFu1Uj5GAjQLxvPK91CZk7BHXg1tF
43634	payment	2134	2134	1874	1	1	6648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ848cJpGNEUng2rV1siyXTdCDFTypJTV8sfmzWJqKa69wJLXWk
43635	payment	2134	2134	1874	1	1	6649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR44VmBAiy7mEWLsxSc8TrkRKQfa3EbTMb8KjV4dK5oFbqVuSD
43636	payment	2133	2133	1874	1	1	6162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2UrNuGyNwDA78Dkd8gf463D8B4PEoNDL14rQzaNSALJk6fTe
43637	payment	1397	1397	1678	1	1	16347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ufuRR8R82N3FL2wMq1SMnoUHCB96vm1pR3JXeG7b8dH7DNPX
43638	payment	2134	2134	1874	1	1	6650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLVz4jWYodG4q6jPhE1QASnTwwJj9UqxxexuPeyCQGhtEdSbh
43639	payment	2133	2133	1874	1	1	6163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWPMfTqkzeRdzXNHDd21SZnY9xpNQQjs1phLZKqHUdA24taRc
43640	payment	2134	2134	1874	1	1	6651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbhrocZMRrmPYJAyPhLn3aukyVvvMrSmNiCdn3MydodrHjSNb
43641	payment	2134	2134	1874	1	1	6652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GGUzpZToz2Q349rAiGpDoXLmHRR7zrGrQefqSzWeJU2BNXqG
43642	payment	2133	2133	1874	1	1	6164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWGpTea3sjeaE5BnictLBWW6nHEqNtYXPYwR4ALSnri3L3AGC
43643	payment	2133	2133	1874	1	1	6165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS56WXdc89isWbjAbQAiZ9Svw7eANuB6XGhBzpTBJ8yEAaWR8o
43673	payment	1397	1397	1678	1	1	16359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CuiSYRHSHkAD8kLYERz83m63KwtqZp1nRGffX77AqumZkP85
43674	payment	2134	2134	1874	1	1	6662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKnZx9zxpEbDszL8VvtJyhyGAmEUZNCCKStyhwo2VyJxnQrdv
43675	payment	2133	2133	1874	1	1	6175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxqaktP8xjzoW1idq1Jy53uYuKBHSnKL9hXmJFhfiMJE4Z9Bw
43600	payment	2134	2134	1874	1	1	6638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hoSVMZDHrJtJvJLe2GtWXZvCLrUj4oKhevFSbu4ZZX7nJptq
43601	payment	2133	2133	1874	1	1	6150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtjo4hYhGdi7HzWaKCusadPhVumuuFyj1E1xtNC8xA1cR4HFG
43620	payment	1397	1397	1678	1	1	16341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjqrhFHfjXMYGrhiiVMz47aVxL3f8wcGCV5AeEeHbpFmghjqh
43621	payment	2134	2134	1874	1	1	6645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWvFpjyNxVPhuGk6f6iMKJ3THy6Mn19UpYCbscEcBLrzx3ihb
43622	payment	2133	2133	1874	1	1	6157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtu5U2zpzRsyAhRGBs7rqPcv6XYo8AH2ZbVG1JFL8zEqJsexZJ
43655	payment	1397	1397	1678	1	1	16353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFZCvfrXGE93raZiqk9WZnCH1CmK9qjimsh5ngkq4nDmAZPWy
43656	payment	1397	1397	1678	1	1	16354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhVBMD7nXpZtHdHeZdLrrTTtbjbcF8syvxaBMUxAR4TsJTr42
43657	payment	2133	2133	1874	1	1	6169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPgpfXAH7MPTCVgCjrX4vy4c1S33m7VT8SCczKyh93Ha2a4ks
43658	payment	2133	2133	1874	1	1	6170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGu9y97AnqSUrfkKvgFdt7y44TqvVcQ6YAuueWPmUtF2SKp1D
43659	payment	2134	2134	1874	1	1	6656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YbwYU4Q2iPsFoZjxwK1jXcvowQFBQhHX9adtcxwpzPFvenr9
43660	payment	2134	2134	1874	1	1	6657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43byXXgWCaJ2r3vpVvgihz52EALRmabLt7k4WvR2u99CAZzGD
43664	payment	1397	1397	1678	1	1	16356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHWu7hZdnc9wTVBsPhiJN4SF9tfeYiK1KVQBnQkGSdJq1KjXg
43665	payment	1397	1397	1678	1	1	16357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGimxd5cYq4BKec9fLXMRTaHcWRCC6WrtjQJRXBdSujFapoCvD
43666	payment	1397	1397	1678	1	1	16358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHu4TYFs3bGdguRM1iKYakkQ3Q1HpwZoTrhGHhAi93zcNc6uJ
43667	payment	2133	2133	1874	1	1	6172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhmw6HxrGTMDAsWcpw36pD1azqhyY2faWsyAF3JTPRkCxpRgP
43668	payment	2133	2133	1874	1	1	6173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCGgmFsTySE2h9gaaTyhNLSxXQjE5mazC68TF9HNsN3g5JqgQ
43669	payment	2134	2134	1874	1	1	6659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXwA5ZpVUsbhEDzGSkMphAK74EeKMMQiosfYLxTfUwndAfQK8
43670	payment	2134	2134	1874	1	1	6660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDPTFzmTqTwU8tYxssZmCjWi4FGMqMdd2PjTzEQhvTgA6CMZN
43671	payment	2134	2134	1874	1	1	6661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxXDxF3Cb6zb9NTNCYjzifmb9ZjYDQaprDuT95CDy813nuV26U
43672	payment	2133	2133	1874	1	1	6174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzKMMXDnkvmiznj8Jagp8bPHCk44dG6D9d3D2ypnsXMoEp5tm
43679	payment	1397	1397	1678	1	1	16361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC2oLvY4iZqr5FGU8mW51UmZLHvwTk1s3CmqZVU488Sc5eRyf
43680	payment	2134	2134	1874	1	1	6664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3ALHrdQfX7dEZ32KY2zfN2vWcq2nEKTG7yz5wbRbm5JnqVEf
43681	payment	2133	2133	1874	1	1	6177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JnWihL74qYpLvDLNTwzEHpF8EHh83RJdzi3qNdG2fMfSjK5M
43693	payment	1397	1397	1678	1	1	16366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPkZgupueRs99Sd4CEd37J2A6Uza9fLHyLsqeyAFFrpN2JETC
43694	payment	2134	2134	1874	1	1	6668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRwEWMSkDcajrdyHRJzJLhHEKa1GPeAQE1V4Y4u6vbWqck8vt
43695	payment	2133	2133	1874	1	1	6182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaSz9GPfpAEmFyqGuLNsHUgperiQrsc96zfzAgur376qynspo
43702	payment	1397	1397	1678	1	1	16369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rxm7FkoBjhMu5TvkWLqS3bHbeRyiyQCxBBZq2YQX2gHdCPpR
43703	payment	2134	2134	1874	1	1	6671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpnAkR3615Y8HSHQSJCNiYEXPdnkH9koLqsAevpCgb2yiSLkA
43704	payment	2133	2133	1874	1	1	6185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt399fQY4tTqJP3LtkUJxDvpeav8xdc8teB261crLqwtQ5LQVk
43714	payment	1397	1397	1678	1	1	16373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mTNz92L4bJZFjVy5MvdxMTm7czXeAftDDc1ox7fbQht7AKbt
43715	payment	1397	1397	1678	1	1	16374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZJoia9U9hym6iMtmAg8oHd3Y57fWb4ZDfeNppGKmUbh6W9F6
43716	payment	2134	2134	1874	1	1	6675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnPbQBywkT5JLhYNE1x17hUVdhGqGvKrt1RbwQR1jyAEhskYP
43717	payment	2133	2133	1874	1	1	6189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPm6mBrwjCW3zyesNd79DyJJ9cgZSP9zAadrLMeAGTpmn8a9S
43718	payment	2133	2133	1874	1	1	6190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EkQtpXaPrYwaqa8nS1doGPeuwDy5kcMacU1FPinR9dBuHMka
43719	payment	2134	2134	1874	1	1	6676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TVVFPUMduS7guXztqwfnQBbqoXTVagxzXTXHntMi1Vc2oGnH
43729	payment	1397	1397	1678	1	1	16378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRwgZML835UUsXXN241xmXWYx1a2QRT8L7ixLU8nFkrYqE72n
43730	payment	2134	2134	1874	1	1	6680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokAQaePingUpLPmt434YbN9MCQTD76QSAVxaWeLTqAUpPwvQN
43731	payment	2133	2133	1874	1	1	6194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZATr9mJphpG9vjFWCDoXPuyXKBSbVMCauzqHpNzcGmX5cSzP
43682	payment	1397	1397	1678	1	1	16362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuUDcM9rNsnuzx3cuTDeeBBdQFEPYDnqnSwYdL5zSkWnf2iKk
43683	payment	2133	2133	1874	1	1	6178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9TZMdGst84dnFoGmgaB5XuyTxEQqiuGTL1yGXRfxE771KdYZ
43684	payment	2134	2134	1874	1	1	6665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKqR8HqZgRL6nDx6ftuk8DBr5JbP5ZGHFqsum4HYNodaquWqJ
43705	payment	1397	1397	1678	1	1	16370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6SEw4p5msi1crsATgPbL4i3AVy1AMYmWrtdHqfALYFUTMWs9
43706	payment	2133	2133	1874	1	1	6186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHX91tVjvy9ff16tuwmc8BfeRRz74soD8x6PW2Z1dafDwJd9N
43707	payment	2134	2134	1874	1	1	6672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63TiHeb4wyk6hD9HRVEXFMpzG8ATqj6CQDWDwGcKfk8fCEKC8
43723	payment	1397	1397	1678	1	1	16376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdgLKPKubdhArLa2Rvy35jK1EsFwQ2yeEg3e1SYuiuj6XBNgp
43724	payment	1397	1397	1678	1	1	16377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB84SmbybzQ3fynBxWRQESRAF7CWLe3Z98AfCAm4RHRWnnLZEE
43725	payment	2133	2133	1874	1	1	6192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFJL3ZALGt3cokWH1sR751VBGhWAcUfVaYmoaV91WdECtPSz5
43726	payment	2134	2134	1874	1	1	6678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbfAZdk5b1oMbjawK1fhNaSUbFzHW4SLoeLYnY2vXfwHH1MaR
43727	payment	2134	2134	1874	1	1	6679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6iNSTe5c52cpnodShUhC1PCot9ogGhSCwc4dtxYRMFR8y8ms
43728	payment	2133	2133	1874	1	1	6193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKR2Gfw1WJGbW49YZ62aTHZNRLoMrMnUgpJ5T6vESczAQtHRsA
43732	payment	1397	1397	1678	1	1	16379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcG9jLYG2nN9zXPJUzDSfgZwTW3jLJV2X7Qqsn6xEG96Heur2o
43733	payment	2133	2133	1874	1	1	6195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4spsiEvhsu9sAfYMxUJ7Cc35gfQ11ajZdQrqDWTFv3aSZfWf
43744	payment	1397	1397	1678	1	1	16383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm5T8fB1cmAzDwsaD2fwvuT8A3sfPDC76WqGJNfiwF1NZUhhM
43745	payment	2134	2134	1874	1	1	6685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmjCGisF1ScbqzeZN5NhJo5CLk8bGWM6UpbhKgNHbPNyrdbrc
43755	payment	1397	1397	1678	1	1	16387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDEWqBQ67Poews5aSo29uoubgoYwv37UuCFP8h9iB38E8qSS3
43756	payment	2134	2134	1874	1	1	6689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2tsuZ6Y4yY3g4mBPztTRSYR3iv5DLg85ncedu1Yh7RNY7cTk
43757	payment	1726	1726	2374	1	1	8327	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgWgmsJiBYMT2B9W8EShY9gu8i6RV6K3SB5MDLreMvauNzT7zF
43758	payment	2133	2133	1874	1	1	6202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWFNdcR9eAgFNRDvWu4ybtd3iKXzys2VcEDKnjmNKVUGGapjK
43759	payment	1726	1726	2375	1	1	8328	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKqiXeWmrBN6J5RpDZ7jopNzs9uveK4Wx54kdZkjo81QrGHZND
43760	payment	1397	1397	1678	1	1	16388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm42NfoFqssy8WtxZD7NaQ64fciNiVmXap2tEAfcVDsQuDRjY2
43761	payment	2133	2133	1874	1	1	6203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhj3FnApbHA2W93tvexrNrT7KPT7XKbAk4zHUxoXn1FM1Mx8b
43762	payment	2134	2134	1874	1	1	6690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnwbvzHsQGFP86oEh2QRyCheU8tdsQu9pEANiAL2DrpQUCyYN
43770	payment	1397	1397	1678	1	1	16391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNptNVJWtLq9UNV9MjrtTnPpbfmPPEXyg3YjmbkVqbAEfHhUyT
43771	payment	2133	2133	1874	1	1	6206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16jG3vtk6KLagVbrD9XpH6kkqPkoT1xRPACgJfBXSfanXehEm
43772	payment	2134	2134	1874	1	1	6693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ442krtG1qjBpa1sKWGiBD8zBkMMLq2yEGJyAEbDu2bxtFjmnY
43773	payment	1397	1397	1678	1	1	16392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKs3C3uC3Xbzm54JhVEtseJPKRUHfUov4ccLowDsC9VY1Y3px4
43774	payment	1397	1397	1678	1	1	16393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAZqbpQwbiPK91qPfRcTmgG7W99wf5XRYHqKUWQcV3MAiYG5j
43775	payment	2134	2134	1874	1	1	6694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrw6Dv7fTxXw6Kic6itX5m3SUqzFrfmrszNFQPM9DBoPLHuUdz
43776	payment	2133	2133	1874	1	1	6207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUY7Sn2RWtKbKoTQcNrJwEgBEKxKebSFExTAPZSnF5cxLY6b5T
43777	payment	2133	2133	1874	1	1	6208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLEjKV3j1iuz1eder2iLALKgGi49a9jzuLZX9chMBGFP5AkuK
43784	payment	1397	1397	1678	1	1	16396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6LnKFn6ZrJFbt28uJqxPnZkmDYLGfR6Jh99eq1mfBA55UeKG
43785	payment	1397	1397	1678	1	1	16397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRp7P1KWe3X7pfJPxrYKpuNE9tdAxxpQChonaFL4my8sLUzyoc
43786	payment	1397	1397	1678	1	1	16398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoppQPcf7Xo5T6EUh89JTAhg2UT2C1gtqAMGeYhyBrYwzj16BG
43787	payment	1397	1397	1678	1	1	16399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzY4xE7KRKdup43sYwHXtLZ1WLkZnmVVktWEmetqNEFtXZ7mfB
43788	payment	1397	1397	1678	1	1	16400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sjdKWgmwqqHhv3Jk9PkH2mZGureQi1qhvcyhYeToBvhfhGot
43811	payment	1397	1397	1678	1	1	16405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGzqq3JFMRJTuLuDqmrn43tcTPYT5L5mVQ1rK7CZsBbvNbz5T
43701	payment	2134	2134	1874	1	1	6670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rYHWvESNNET2qnTQB1eCDMfS9p79Bv75o8eibSkQ58hB95n6
43708	payment	1397	1397	1678	1	1	16371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCsMYuCrcGvtHnzFtm6LWPV3UDsMkttLuNKd4zoZD33RFRdsi
43709	payment	1397	1397	1678	1	1	16372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYop4P1DoirnG5LYX5K3X3VbKsajssJ1i1HwjbJHMiYNqJSc1fi
43710	payment	2134	2134	1874	1	1	6673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHtdY4iGMD8nyTwmonEKyXckygz4g7Hb6AfnzQhWNkptnVMyo
43711	payment	2134	2134	1874	1	1	6674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SRRr8aJ3ZSYKMGfFbcrvpnEZ8mH25gGFR4ax21uy3MgrHd6u
43712	payment	2133	2133	1874	1	1	6187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qc6N493XShfYcovroRWGapmt1tkCV1CPijGQjUFtpbeCEjHu
43713	payment	2133	2133	1874	1	1	6188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeKKVDBhaXPZgB4H3J9Q5qrZb6pEncrKnMwwfbwNwoeBpTfph
43734	payment	2134	2134	1874	1	1	6681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPLRKWdZZ9ejPdqxBpLDM7PoxncBRxiDTp5MoDKTPkAnHr3Rs
43735	payment	1397	1397	1678	1	1	16380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhYDD1HCw1JS7J81y2DrgYtJ884Nu3TBUta5yJtJLxGscmy6r
43736	payment	2134	2134	1874	1	1	6682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnX4c4CvTS3Ubn2mk9qcrHisXuKe1YVijWHhW812cASu5A6yT
43737	payment	2133	2133	1874	1	1	6196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUTrZTTRDQ8Nj57W3gJnPZXbLftXJiRWpYvnCWYEpnN9gJCvA
43763	payment	1397	1397	1678	1	1	16389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtgPV7azBySKj5TUDUUDXLJaPhrQaAkYvgncz2NXgvVZjZf2u
43764	payment	1397	1397	1678	1	1	16390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEeY7DP75EtTPufRbdDPcDcg2JyGmzRYXte4R9E5UEqH78vjk
43765	payment	2134	2134	1874	1	1	6691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGLtvrpy1Dde8sRWYePWRDJrwwq5uEnmMHN2quNgCvrT2C94X
43766	payment	1726	1726	2376	1	1	8329	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZa27ozs7oAVs6Twdpjd8Y26F7H6E1KHLbFT2XemssEyYgEKSmK
43767	payment	2133	2133	1874	1	1	6204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2udGZrw1p8HdUwKsptgX7dJima1QsTeqnzfiDQ4yT7JTfFSDd
43768	payment	2133	2133	1874	1	1	6205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyCMoTf9JBZXV44y61wQ3rLJBR3qDgtanzwR6GGBCK4Z7LyTs
43769	payment	2134	2134	1874	1	1	6692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bAS1L2eJkAg6ThzZpaKRm696jVRrncXE5UdrSuuhdqLs5G1r
43781	payment	1397	1397	1678	1	1	16395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxyV9sRYjigCYCS1PyeB7owZ6wtxJu8phJvfdZBqvDSLCp5Xp
43782	payment	2134	2134	1874	1	1	6696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1AmSjMAfrJVJmxUQfmeYRtY7kqLXmcp8eoBZDiTZ3LsLCXLL
43783	payment	2133	2133	1874	1	1	6210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbG1L1cYBcNeVh7J2VRAZJt3rpQpAWtGjhcDMaxf4N7A1BR1n
43814	payment	1397	1397	1678	1	1	16406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwseKtA5LVQG7MRmi1bN44VtY6rjvNJoitHGQ5tjxDXfKVmfp8
43815	payment	2134	2134	1874	1	1	6707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdEPn6vMMB68WCkRZbKpy4Hjovim1UkYtAAZyS1bMLLWJmKK5
43816	payment	2133	2133	1874	1	1	6221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDY6f8cjj9LoGSy1wWHqAjzNwCPotzFy8CAs5BZnUjdmpVsTyD
43829	payment	1397	1397	1678	1	1	16411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65zNz6AjzJgoBHTtffW5wmXCBWR7FaocGcFUJPKozV2ePkxuF
43830	payment	2133	2133	1874	1	1	6226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFS11kxn7tgXCXSuHvS8Rvh4hN5nXgQ2hdtmJEmFSrbdUXxvy
43831	payment	2134	2134	1874	1	1	6712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa1cDr5CPGQ4dNJ2FanY8apFp6gui8uec8idPn9cWSrLvcn6Ce
43844	payment	1397	1397	1678	1	1	16416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzn8YRoxcsEpzkYbuLng6LseBnp3G6pAYdzjSRpG3p6Zn6XRu
43845	payment	2133	2133	1874	1	1	6231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCadPVnQBgc4EBRvny1qxTxZ2rvz44g7xVmrKxiCMDXA6GewN
43852	payment	1397	1397	1678	1	1	16419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1obXuVgVvnMnnYTTxPojuBQntntAJCpaH2Uofgxw6gqJ7oCW
43853	payment	2134	2134	1874	1	1	6716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbboYuQc5WDsokikiJ34R6id48vyWgwVoE538m6WQEUHqjwbXs
43854	payment	2133	2133	1874	1	1	6234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfJL8y3iWEv5AyuqtwgZUC24c2UkX7us6ZJHH8VqDj8x2xD3R
43855	payment	1397	1397	1678	1	1	16420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMW22PgfEvKZY571wgw6c1V1XgRao2w2j5YSVNUEddbCpfNes
43856	payment	2134	2134	1874	1	1	6717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe346f5i83YZSzSHd2NKprnGthEjLD9FzHaQBFmdR4B5LcCemP
43857	payment	2133	2133	1874	1	1	6235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfvHCgbhJy9avzUR2KuWpXwEDsqVEEDK1sq2t4vDcGhvzHjrE
43882	payment	1397	1397	1678	1	1	16429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivbBnZbHZvUg9wC8by8iozYCxE6TXgaCz6J7DAhqVQHQYGZvS
43883	payment	2133	2133	1874	1	1	6244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hmXwNcRb6Z1M91F1mLvhASTeNE87BgEWv2uogsr5jgCU7Hfe
43884	payment	2134	2134	1874	1	1	6726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSbU3vp2DXNr673mjrx23UcP2t3odN1RnW19xumBSkoBqrExW
43738	payment	1397	1397	1678	1	1	16381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXaNfnD1KUpH59UkHUqz7qQHzkBzkwKzS9Bqu5BR5Dn9Mw2Zr
43739	payment	1397	1397	1678	1	1	16382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGcqQbqMdJ7KjwkuMumNhitXYJUcoaiPLDXDzfqGFARuNXu64
43740	payment	2133	2133	1874	1	1	6197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDzkjDry7NP4yA457aNaJn2f2L7R9pTxsLMtFTj2YFna4Pypm
43741	payment	2133	2133	1874	1	1	6198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUXBoRsg9hMqMJNrZJ8Nn3MsPC3uUYtzkREkF5SVPy7XL4YMV
43742	payment	2134	2134	1874	1	1	6683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jR2nexYjDP4ZtG1m6RoJeWxvzFCs7zRCCKSXyS856DJcEmBs
43743	payment	2134	2134	1874	1	1	6684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKm9KuVZBvCtt2EFGvLvdrP8bbety2FyerhKaXVemuRMgZbwbc
43748	payment	1397	1397	1678	1	1	16385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnF7PCsDR4mhi8vV7Jd4fvYVCSPbhvMUi98phMUBJsDNFbVK2
43749	payment	2133	2133	1874	1	1	6199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuU7fkwVz4hEfhdgfyjkGUYEYH9ScBYyEmVAjzyE4fFythYvh
43750	payment	2133	2133	1874	1	1	6200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjYWptUqmRSJw9w38Cd64p8CPtj3yt8RmJC7R4oYnhZ7CGMnE
43751	payment	2134	2134	1874	1	1	6687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mBWWNhmKGAWknSD6bNLehfhkTAagoU8hMsF5rGMZWSjAinfK
43752	payment	1397	1397	1678	1	1	16386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21JRw3BQpG9DpcVfvgqqGR3TQitAR22bnN5C8Vx5yPUoFdJHH
43753	payment	2133	2133	1874	1	1	6201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVLMjafBoAKZmRZqTeHKRqVveQsvncvkCVVhGufRPpWMWsfoN
43754	payment	2134	2134	1874	1	1	6688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAuPkizoGLP1XbVNMQPixZyeTtqmopkuesS9xTQwW6rgWVpAt
43805	payment	1397	1397	1678	1	1	16403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vmvMP9E8VAg4jrN1sYGBPTJfuBGau3HSdrCFr4GxjS3p8cs3
43806	payment	1397	1397	1678	1	1	16404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsh5DYyBxTN33MmH8cWBkTjtErm3UUh5JaK9cdj3VTWy4xkb4H
43807	payment	2134	2134	1874	1	1	6704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyDATq2FzCMneM6q3puCAJnpLZyQXavionkpmATJkb7Mb7tWM
43808	payment	2134	2134	1874	1	1	6705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJstC2xtGLn3mF7KgsvpQ7ZXnruoJNbZLAXsnFF2UyhHvVRnx2
43809	payment	2133	2133	1874	1	1	6218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyzDEn8cxwHKHBm5rCeVh98bYvoxeqCXXEQ3nJDtNKLhhmYPm
43810	payment	2133	2133	1874	1	1	6219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPcMry9eHWmTd9pkaowxqJ6v1bdy6wJcQjx42L4t7PPSBf9V6
43832	payment	1397	1397	1678	1	1	16412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WVjZGaXy5fcRVcUuuvmhfwB8mqGvvevVD24nJ35XKzV3bVHq
43833	payment	2133	2133	1874	1	1	6227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJgUbCvZ2ED66UKDVuAaJPaW8iEEJ7ZdmDA2S7ZhwSpsndyYv
43834	payment	2134	2134	1874	1	1	6713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzEyVDZzGcN5zRHnhMpa9HUpviasxbqGesQTAHWJooHX5DsEg
43846	payment	1397	1397	1678	1	1	16417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnptJbSF1HpXhXBA9HtRNuxUQAvAXhCDCAPiCmXM3axDCw1iL
43847	payment	2133	2133	1874	1	1	6232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySLDPPVe96u8B4otCPUxxjiq5YuiaT8cTwmgw4639mWpesBRS
43858	payment	1397	1397	1678	1	1	16421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfr3p3hx1neL6zsNCrTx9HuFCjgf1f6SfBWKszVttuCPARAuS
43859	payment	2134	2134	1874	1	1	6718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAFNmyJJVRWF7Xka7hBjS6Q8s5sbh3nGYQLhcmBgLXaCTby23
43860	payment	2133	2133	1874	1	1	6236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQkxygshRaqE6ksGktyJTRtsPzVYbLt8QByaY3uCy7ngUUeL2
43861	payment	1397	1397	1678	1	1	16422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT6dmSsDEMGY9NovCLeJWHdHdknxW2Ec79qBBtc2d8S2AzXSP
43862	payment	2134	2134	1874	1	1	6719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBUTz1kE8pGTyrfNErjnEDhhvLPGgyXEeCccorpDU5HFtymPK
43863	payment	2133	2133	1874	1	1	6237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTXjzAg8NGJJYwQywQAywSFWBqWQWSNybyHJcPCiUGqAvByxB
43867	payment	1397	1397	1678	1	1	16424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8VANNbxce7uEeivGfQRvH7FLqADvTdpdKpHQQoue3TLJEmWtR
43868	payment	2133	2133	1874	1	1	6239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5DzsK3o99KtS5cjvvGLK5VZgTU3bMXFUTkK1eJGG3PRUgKBp
43869	payment	2134	2134	1874	1	1	6721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDa3KnnKHFdFrTS2qmZzHe7XU7tByRpRyAFW8oyVrkEgtpnQ33
43888	payment	1397	1397	1678	1	1	16431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYmcBLs18C1Uv4sYRUMgP7wbBy1Bb6q4XbV3CFhTVLZMfoZXy
43889	payment	2134	2134	1874	1	1	6728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5yKu4PMjWEEDjGgaBwnH2ELTpff9m7q5fcjbCcy7ngZJbvds
43890	payment	2133	2133	1874	1	1	6246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHR69Hbvmj8czyaAfWkzHsaHMgwUpTG3eSjwc2z7cPak8TBiyV
43900	payment	2133	2133	1874	1	1	6250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhFieo11A4qfsJ8KyL4YW1H1fPDFDUp4TQxrUR8WMjNYVaqC5
43901	payment	2134	2134	1874	1	1	6732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XTbJ1zCuL7JEzvkQUsf9mPBUYo1nzgLZGnm2bieMHxFGjt83
43790	payment	1397	1397	1678	1	1	16402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGZ39iW9CkVJnw3yCgWjgdzAFwekhoWe2o1rGcJRBuSWiShee
43791	payment	2133	2133	1874	1	1	6211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbNiUeEzH62AWBsZWEB8sbyK1RnUHHqDRUvPjTHpZ9v6fVp3y
43792	payment	2134	2134	1874	1	1	6697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cWntSwaDXUv3ZaoFniaBdTftu6gRwKwf4Le8QuKxzATdspf3
43793	payment	2134	2134	1874	1	1	6698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45ZbBf8LLvWkgM7rA4boXwP1Vku1wN6Jt4KhzwDwrFq4bA366
43794	payment	2134	2134	1874	1	1	6699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1ns9cTvBhQ97KS4Vx3x4m8MmkWAA8CzRkcsB4ykrmJDh8BuH
43795	payment	2134	2134	1874	1	1	6700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvmfehPtFwF3E3iSkdmzPpKJhaL2UU1Vw8MAePW8ZeniNJ7Tn
43796	payment	2134	2134	1874	1	1	6701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6QP8DpVZLZjPjXeHvauSsepefDmkmGGyBn8AQm2WNcvLZH9j
43797	payment	2134	2134	1874	1	1	6702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKsGWuwnxheLZ1JnqdfVTzwrnqVaanAVLrgDHhBBxd1GNYvwd
43798	payment	2134	2134	1874	1	1	6703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnAxwGi8kmYoTtkjSogdpBLdDShP67X7VuNDTuUHXyLZTNyhn
43799	payment	2133	2133	1874	1	1	6212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgxbAd2LmJEBVZ88AZfeYsRuAjRc9ZMaXhAkLuvyT9e992kjo
43800	payment	2133	2133	1874	1	1	6213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYWkfCFENbEHaB3RCBZWXGj5vUULCbVm3M95ioJ1rj8mz22xQ
43801	payment	2133	2133	1874	1	1	6214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbZCvBZ88bUcHVFKdmKK7XPMsYUsTU3QRRJ8auKroa7bQoqFE
43802	payment	2133	2133	1874	1	1	6215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhezMTwjTXGA5aQnRYW3Wm8RMi9oGzAVGLriefksWC93CvuAXN
43803	payment	2133	2133	1874	1	1	6216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJDfijjWqqaoQihzAfxmnHPtaeXDt8mjshhEzyYXvKHZLVNnm
43804	payment	2133	2133	1874	1	1	6217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVn2Yh5orA1g7cxfr53EVic3UAaE3gtzu8DcZDmwbm7yKVmapD
43817	payment	1397	1397	1678	1	1	16407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYK3Nzep6qsv7ML5wzaUot3HMskAspu52TProxuxzAnEyU5bg
43818	payment	2134	2134	1874	1	1	6708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFSq11mD32yuTYaPpcRM8udGC68P9o5fyzY6KH8ym5N4bsmxF
43819	payment	2133	2133	1874	1	1	6222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3ftrfvzS5Nrs7eSWUbaUoAHVBJy5P75zUehT7Y4R3Quf8bMg
43826	payment	1397	1397	1678	1	1	16410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrSzzsPZPBtmHv1kofLEtAJ1dQUCSYfBDSZbRE49iVEWs3eQo
43827	payment	2134	2134	1874	1	1	6711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj2Njj1mvyo1diWarsvHY1BDVPhzqJFbn9DyWnZwaH1tDRmw2
43828	payment	2133	2133	1874	1	1	6225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrDubpXYavqKTyJTKWtUCgv9KNyg1bYBes4W7P3t9jtQznjMk
43864	payment	1397	1397	1678	1	1	16423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSu2P3D9ocixvLompw9BfLW3nFsmGZiRdQRx2EMvzyhNEbKdN1
43865	payment	2133	2133	1874	1	1	6238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ULXEhrfbRwcqD3QKtJ24zwJT67ERo9bhh7YRycQBfwM5h7zW
43866	payment	2134	2134	1874	1	1	6720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzFuTUmVvWFFcWdbd3L3vNWfyKy7H8138WpRMmyU9HgwMhjwE
43870	payment	1397	1397	1678	1	1	16425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBwoovDvtXkY8QZDH16MA5pMXFumDSFLhvK7ZwKki85UADKbK
43871	payment	2134	2134	1874	1	1	6722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JgDUVGWt6NhafRi1fDTdJxG7SWAFursvL7fvfAJ9fah2B51M
43873	payment	1397	1397	1678	1	1	16426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35hvimpMkTnPEpz52Pk5bhFAoSw2GNAAcMgpZn7tUnjp4MMUK
43874	payment	2133	2133	1874	1	1	6241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMBGiUqubzHmkYgcdvCx7WrDLHGra4QBdT9dw7NxwoAuYzZhc
43875	payment	2134	2134	1874	1	1	6723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu4Gn7AePdfsbdPPK5seNQMLSPTGQZTrMnEfCqSgJvmg45nNK3
43876	payment	1397	1397	1678	1	1	16427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNhYvAjb7E8R2SNkLsYpCZgedYaAE4mMwYf1mJabRYoHzgVrH
43877	payment	1397	1397	1678	1	1	16428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5x384fHSLAtkRdchbUtTfShVYDzkkreve2cqhDYcMPgyWA3W
43878	payment	2133	2133	1874	1	1	6242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgVjZkP1JKpnTgGcDhxPxubn6Wz9PCAJgTcZqFt8T29tB2sDB
43879	payment	2133	2133	1874	1	1	6243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZAZ1kUGNWSTuB5r3CwZozL38oRmqHLkrh2YyikeKT1mvwe3J
43880	payment	2134	2134	1874	1	1	6724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB8ATkNE7NJVArYDj23EuvYDqE2jZSn8f7NfxLAWdssjK6exw
43881	payment	2134	2134	1874	1	1	6725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vetPrWp8AKXBRddGJU8T2BWEk9TmDkq28VftHybhzcf6bKxq
43907	payment	1397	1397	1678	1	1	16437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bYJMwy8L3bUHpG7v5ifXboZUBYf2EvzBxiPMPi31uXPCpHBQ
43908	payment	2134	2134	1874	1	1	6735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt2nHyNW3wynT7ZuRx3orpqB9rz7RA2ELNaZXnTAGUtQUVrdy
43909	payment	1397	1397	1678	1	1	16438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGn5x6A16JTNPqGpujbNXeQKuKH3GuMiXRGw1xWonUMRW8W1f
43812	payment	2134	2134	1874	1	1	6706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2C8k8gZhr3bKAqWYXYphbCHDBfDBwBrdXjc3FEFgvRBf9wUX
43813	payment	2133	2133	1874	1	1	6220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYP9kRH5Qv4oHZFAPUfMVWZWhxYUQX4Pn561gp6Pjo2HxrUHuT
43820	payment	1397	1397	1678	1	1	16408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwv2DbaCzKoLfoZ6pGeNpjuSLWNQ62pCuSgSvpnJTTWNdeQq9
43821	payment	1397	1397	1678	1	1	16409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkS1mM6k6hfKRyfFBQVaYnHB5CycDqJsUYFYzDF6Q1r5ERjZFE
43822	payment	2133	2133	1874	1	1	6223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzz7wTniJ9NFb8YVsLPwYRoJphhG5eAeemFwMJxnB1omHd6Mg
43823	payment	2133	2133	1874	1	1	6224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKBC87yjy6FqY2xuTkyoomA5ZUERGi1U15YDDwrH8RNaPRWer
43824	payment	2134	2134	1874	1	1	6709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxQ2imbBEP5tt6Tu2DoZMtrbVgjHtriRWS1Z5tE8pa6maCapW
43825	payment	2134	2134	1874	1	1	6710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQiHJxewTBqQJjFCqRhxygTu3MD7L9TvZzv7Lo2qSLjwqvNgd
43835	payment	1397	1397	1678	1	1	16413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnXwzgaWQKjoV4J6KMuaZ5T8j3i5MeQi4Q1kvssgLTy4yvsmE
43836	payment	1397	1397	1678	1	1	16414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmcUFRDTyEJzX95fYSB4ZjNH84nVntmiPpKvt8NGQVtSD5wsx
43837	payment	1397	1397	1678	1	1	16415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNq56Fvo3VB2qYdAb4dR2ebp7LASuX3EPq3CMcfb6FeCzBY4rs
43838	payment	2134	2134	1874	1	1	6714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrsYKNKY49hokP7JWhgJMRYVvr7AoxoPHT7SXdgHzQcHaQsfe
43839	payment	1726	1726	2377	1	1	8330	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkKYPt2wh5BmgtFL7pPhcp8Qwun3vMmsewmVQamsVLnHmQYW4k
43840	payment	1726	1726	2378	1	1	8331	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYcRuDUsfCVaCEhuHU8YWBaf5A4e2cQ3rZtB5NBoviPkXa7w17K
43841	payment	2133	2133	1874	1	1	6228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruaP5y9HXttqdPjUJiSrK61cyekwjEvV2KPgoDvyqcVgMW8vw
43842	payment	2133	2133	1874	1	1	6229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCSTKRP3McFTsYnfSC8cQ7omYjpqDdm7kx3QrsMpzytFuduqE
43843	payment	2133	2133	1874	1	1	6230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkwLjwuK5DNbYGHLSPMdzeMHcbEPiEh9FpKVXez5siaAhAvzy
43848	payment	1397	1397	1678	1	1	16418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosqjVTFLu37ypfkp59axtZyZL3CkCt82ZBigxZgzrXRa5kN3N
43849	payment	2133	2133	1874	1	1	6233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24CbEqMBJ3m26Luy622psHVNASyw4GkLQHR599pubsLxqbYsx
43850	payment	2134	2134	1874	1	1	6715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxe4WiBPQwKMuXyxuBXmUdnzSxvcsss3Zz31c6opmbsup4Xhd
43851	payment	1726	1726	2379	1	1	8332	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzZojVohq8EpidxWD9fdbzs1YZofHedve2wv2G8HDA1UsVRuhp
43872	payment	2133	2133	1874	1	1	6240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkLG8RPDzrG3mGAvpuHheL38rgqGb6gjD11EnfPyzP4HcYwhz
43891	payment	1397	1397	1678	1	1	16432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBJQ7sJ7tADmXGrKdyFsSZ5Vp1877sci4Jm9pie1N3q9nS5nC
43892	payment	1397	1397	1678	1	1	16433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XzA47msmG811Xtykv6mDPRUDaxr6UrMNVZWn2HQ4563JdCrg
43893	payment	1397	1397	1678	1	1	16434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShJxwGdn6kdAT4eFDiTG4ucJLCCxhnkcwxGxejtde1X9Cimnn
43894	payment	2134	2134	1874	1	1	6729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXHvj1tjnwfgkJBwUiLXf4YEcjU6SAFtSFHnhVPVtk1uNyBmV
43895	payment	2134	2134	1874	1	1	6730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoE4AZdXMDbLruU1G6hnwfL6DYetmmAQ6yyJ7reizTbC7opGX
43896	payment	2133	2133	1874	1	1	6247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Zt95saAiez2sV5RnfqdWgh8r3ePgTZTCP7jvyzzjaXzNKp3p
43897	payment	2134	2134	1874	1	1	6731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCET2mS5R8M9gjdk9s1Qk1Hj3rW3ZNnENHAXDsQybZQFjJzfo
43898	payment	2133	2133	1874	1	1	6248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7XVunnDP68iD9Mm8TTqTD4QYrkbKypJAzpp6JaYitAMPUb4s
43899	payment	2133	2133	1874	1	1	6249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzKEWckfDUbBrecdkWpT1a4QHLxPAB7JgmHAnnuQkCS16H6wj
43902	payment	1397	1397	1678	1	1	16435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeuxg5WExaKUx73gQ3Wv9CSHemUynxiVzzsbh1tU4gnUzLmAE
43918	payment	1397	1397	1678	1	1	16442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRTMw2uE9CYJLYiJ8FpyRGbfhxZFMcbD4mSnAaDzTEKA7rNZy
43919	payment	2134	2134	1874	1	1	6740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeXNFT9MX9bseVog4zHgsv68JogcvgTAwpfagErPYQBxggAit
43944	payment	1397	1397	1678	1	1	16451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasJjhXg1KGYYVQAAfbNfR5Ae1tPq8NCQnZb9kM6QCMdz3WEmK
43945	payment	2134	2134	1874	1	1	6749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8aim5W3sxb69GhLcnd5zjSgq16Mhu7cMyGZqQZdWQtEzzVyh
43946	payment	2133	2133	1874	1	1	6261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnZByx81NoKLkNJFSHroLjXdySqHKNjnGZdLPSPNkGEF5yTeK
43968	payment	1397	1397	1678	1	1	16459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCfM3KdXPFBAiri3d4WHKiBqhJ8vSAD76wvybknCLwcamRgCQ
43885	payment	1397	1397	1678	1	1	16430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRzEh1W7wUzXJFLaZNJgN7939aBrByVH2JMXrFSYGP55H2VK9
43886	payment	2133	2133	1874	1	1	6245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEFbW7xAR6zmkyYdBgLDNdfTsU2xZLn5EmUGwtuHMVeXUoFX
43887	payment	2134	2134	1874	1	1	6727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vEypYsXPVGAFw7DmDtUvfs6jPxioogJdVEHGD7WMiAqUnJta
43911	payment	1397	1397	1678	1	1	16439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKx7FaPp6NB3qpZfe5PVwjcr247RhuJEftvdiN2WRKyJF7SC8
43912	payment	2134	2134	1874	1	1	6737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4j1FGDdnxnxD1cztzkjk7pGhn1hzpB193sZW3GNpv29svVqi
43917	payment	2133	2133	1874	1	1	6252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DWeS8cUnovkKsBFXgtzxwndbVAZayg7pWUFoJpdvbQ26QiYz
43920	payment	1397	1397	1678	1	1	16443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ69EZ2eHQc2GWgUQX3djZ9kHR72tsr5mAdCKTeKf9XECN3VmB
43921	payment	1397	1397	1678	1	1	16444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VtTvdJ2LecgDa44he5MBmMmVAbLCWAnphKLF5RGshrtKnH2M
43922	payment	2133	2133	1874	1	1	6253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrfUS4RzGYSnohkXh45DESTmJyBAMRcXbag5zjuYZNNqjHXEb
43923	payment	2134	2134	1874	1	1	6741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAj5ziD3YVHvUp1REeFVuG6K2xdrzciTJjBeUGw8XGje8jeLbd
43924	payment	2133	2133	1874	1	1	6254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3khgPKBbesJViwXuMYHZ5HeMUj1uyz5c9BnwFUGDYtWovf6x
43925	payment	2134	2134	1874	1	1	6742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRrvG5npzzK6WJ5xDoX7Ws162jKkoC84VjiXarpthGmq3cVdH
43956	payment	1397	1397	1678	1	1	16455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWS4z2Fwmd27yKpEPd8G37zx9W1tT8Uy6Auaq8KbK2wYPihZK
43957	payment	1397	1397	1678	1	1	16456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXzKu2dpRfrSyfAr7i8UgCepjjU4QjJgGcCtRNJVdEY9wWvQQ
43958	payment	2134	2134	1874	1	1	6753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowKq7CHMCQgvTsrfQwSXB6SbRYHfdxcuubFdNFi6bftMN2oNN
43959	payment	2134	2134	1874	1	1	6754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1Q2Mt5aVWVscLWvKnaa32kvLci13CiqRNfTMUxeXRdEiKrfH
43960	payment	2133	2133	1874	1	1	6265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVCnwDZW9fPd6vxgnhw9k2kw4V9xiguVSLCFQwjT6JsqWJTAx
43961	payment	2133	2133	1874	1	1	6266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDiQBDge2f5tU2Sk3iMSSpLn83bXqWqCVDgN3sGcBKaKrXo4a
43992	payment	1397	1397	1678	1	1	16467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY3iieyjWUYPLHd1KLfiXPa8UqYCeBYmzxrV7zqYzkZEHxP7F
43993	delegation	1751	1751	1454	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV35dWN4Tjp7H8Ei2ztVuDktrT3g5oc9jBbA179sLp9KbDJsvK
43994	payment	2133	2133	1874	1	1	6277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j6mD8puKUGXMRG23aDMg12ba3xx8TCxBYYgKb1ssUmWs6rNd
43995	payment	2134	2134	1874	1	1	6765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3CeBAQ6wG8TQrC5eRegDupcy2bHxrLXYQJqG2vLEosamFsxT
43999	payment	1397	1397	1678	1	1	16469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNY2nh9enQrPByqfqD5w2QKpDrgrmom7Ph7w4eW5vTA8uV7YG
44000	payment	1397	1397	1678	1	1	16470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomppR8YCnMLpT8JLE3ZzA7BpDFSuHESr1344ReKDCzQMHTx94
44001	payment	1397	1397	1678	1	1	16471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJmtX2f8Ba4Psgr4XL9u3dakRFphppZnbQvJvYSXuj7azhTJ2
44002	payment	2134	2134	1874	1	1	6767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ85jw12wvCxLM81LziHfDMfbpAtojY6iw4Up5eoy7jgBEQNfE
44003	payment	2133	2133	1874	1	1	6279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApYn96Uf5G2J7PNN8AMkTCqVWK2izrbUwD4aG3KEpP2xZ8HwV
44004	payment	2133	2133	1874	1	1	6280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoB8ajLt7yjDeAdC3bSa2tZq6h6t7QAG3ptMtgtuFjrkix3GqT
44005	payment	2133	2133	1874	1	1	6281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPL5pLMYCGuVij3SxHCZzkMZPPZJwtrYyoSu82ASeGY9TNJvy
44006	payment	2134	2134	1874	1	1	6768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmwiJxLdV4a7utx1g86cDEzcHc36hVmLwFEhQsETc9pjEew6P
44007	payment	2134	2134	1874	1	1	6769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sz13UEJf6dD6z91tCstcL7gRrQv2QtCepNoXyyH8eMEEUBQA
44032	payment	1397	1397	1678	1	1	16480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4gdZu1AQyWqudsMF3E2BXKUzaC8R8AKpU13r1P11yA44WYEp
44033	payment	2134	2134	1874	1	1	6778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4p1YCKyFG69XUTkM4ZGSiZdS4TtKQgJbe1UDXoj9PiyvyHiZ
44034	payment	2133	2133	1874	1	1	6290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9L7XcsNWQ1cpZUVaPEgoJnPd9qBNjs8Z5ynf7ZN6QNtLXpz5C
44093	payment	1397	1397	1678	1	1	16499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36DPSRY4H5KesLXWU74JohLNLopv4CUZ8np6u2UbwqUpcUTsN
44094	payment	2134	2134	1874	1	1	6797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrXKoaAwCep6KEY8hk53mmXNKJB2XHCJqh48cY21mCEUZs6qX
44095	payment	2133	2133	1874	1	1	6309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2q697a31mVCYPPyN2aVYJC2UpWCsAq7SpuRnp1SgkqcQx423L
44123	payment	1397	1397	1678	1	1	16509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspg94hZMuuNhQ7DGgHHG1YdWNYF3eb22kME7TCdnjQLRd5HLt
43903	payment	1397	1397	1678	1	1	16436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKotXkHtWtvXBWkd1p2qsSbThiLwDEYF24zqrfW8bAiLAEs6F
43904	payment	2134	2134	1874	1	1	6733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU1drBzjHsdCMGEcZCQKPubHVVNcFWFPDbztiYXebBWgPBCFM
43905	payment	2134	2134	1874	1	1	6734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDYAJeADz6nmgEhkMfm5AKdMFnJvAhnWA9GWMr2ybCEk5arHi
43906	payment	2133	2133	1874	1	1	6251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4xNB2Q9sNHCAPZuzytWxbbQ1e6eRDKYKs28eDWnVFTYDw7Yt
43913	payment	1397	1397	1678	1	1	16440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDc9apvdxHXxDkBsMbnKvTLgYkWaE4bRJPJp6NXXV3WnsVcsk
43914	payment	1397	1397	1678	1	1	16441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWYGrhunkRCKNG54fzfyHWvqGLkfdWiRFCMoiEXVXrVanJdTF
43915	payment	2134	2134	1874	1	1	6738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2DFp2RUQn5k1vTcodWxJckdwPgoFvBVDzAx7gRL7GPgC1C9G
43916	payment	2134	2134	1874	1	1	6739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPtCxX6RG42uWNiijZeuagYXR7Amy1xkJkn1zqaThS36mKV5t
43926	payment	1397	1397	1678	1	1	16445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawvvU8NVkyHDE9ZLweBm5ayCyLE5MHgVnuofW8R8apjjxWpNv
43927	payment	2134	2134	1874	1	1	6743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQhbXt1htqTrGbAvCMvK9Hz1uRMTGXYHGB9eNrkCdFbLkznjV
43928	payment	2133	2133	1874	1	1	6255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BNNZjuMeJ4BnR8sUZFubLbfimpiyzRAVQi7utBj5T549JgQS
43932	payment	1397	1397	1678	1	1	16447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaeQriXQus5p5Ruw5CX9bFqaVa9fSkRi2m49e6EnK2kUGvU5wh
43933	payment	1397	1397	1678	1	1	16448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3xWPMQRaMz3vX6dEWBu8aPEyH2M5PpX3gvRXfbAU6m7ZVY2u
43934	payment	2134	2134	1874	1	1	6745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUBix48FtuN5uzjVFvDa1yr1F2eh5x6K39qpwbggauCQiVh5V
43935	payment	2133	2133	1874	1	1	6257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SEEiXrDRaHekemCnaiK1pZbBsgbroyp2zeCrq6iSufePdQWr
43936	payment	2133	2133	1874	1	1	6258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTWUrUppRT7HWWo8sVshJziYU3eknXDx5iRyYb4gYhjjdtiD2
43937	payment	2134	2134	1874	1	1	6746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yu3BNPThHKraUEK234TFm2NrfwvHDsvncY2SGaHw1MnRLU7c
43941	payment	1397	1397	1678	1	1	16450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXatwVgk9rfMHxbLSUmuni1YSLUhia56G2jX9tAZcnikUYWffF
43942	payment	2134	2134	1874	1	1	6748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHZHqfcuAbHDVLTtukVH2VShBbhnhph8ri3gdBkh4EfuE9X7d
43943	payment	2133	2133	1874	1	1	6260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hgsfQfGg4cgYtLEwN5bH4zkujWUtZQPasLz3Mn44iao8Nw1t
43950	payment	1397	1397	1678	1	1	16453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz2qr2UTRvc16NBHBpFFWNrYanyKRgEg3XiZFqFRFYJcpFwMS
43951	payment	2133	2133	1874	1	1	6263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGJSsLKW4nwUNeVS3xSv5EruchBFo8QmmoaXKqwDeqKLARoxs
43952	payment	2134	2134	1874	1	1	6751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JFCNQaS6ykVmGog8vzX8cCf5JBGY7VwwyiQxrsWGy1Tv21WC
43965	payment	1397	1397	1678	1	1	16458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxSNHzzZtWL6JjHxCvMiopHnap24c5H28iMLfPSg49cHSSgZy
43966	payment	2134	2134	1874	1	1	6756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAjL7ngJ1bi2kwKW4mMYePRRFXoEpdEyvCfLkmapUWVTparhd
43967	payment	2133	2133	1874	1	1	6268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVWYS6UYUe22jMpeYEvyECnXuLK5AUYjeS2pkFVH3zxEM7PpN
43986	payment	1397	1397	1678	1	1	16465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMci7rgy3pHWa8Z95o49jtn3TQFc5gbUpGY75WvxWXk1webvJ
43987	payment	2133	2133	1874	1	1	6275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzLqEdmBQgmiyEHPgdF3t5NiahPnTkKZ6bsj4KXTyvFndmS4D
43988	payment	2134	2134	1874	1	1	6763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypS22QHEdvqMUKLnHW4s8HuVoVK1SpSkRDFRsGEpergkTBaEX
44011	payment	1397	1397	1678	1	1	16473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJibYZREWqz1ne4LPCDVGow51EuspTacannabHYSfMfXaMFYGz
44012	payment	2133	2133	1874	1	1	6283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnw3ps7EjR52kdXE3JUhx6cmNX9bLUKucEy1Bdkk4YgG9pPaP
44013	payment	2134	2134	1874	1	1	6771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7xxeFsTjEbhPuZ4qhdSNWCCmkMBb4LU4N6gviRnHGnEF9QeL
44023	payment	1397	1397	1678	1	1	16477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZ5sv76LdGdjE2JuQRJ4SseVGw5T4MfZkVn8amf4FQpEWSK5j
44024	payment	2133	2133	1874	1	1	6287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeu5683nqRNQPfVUaZxJVqJGJATX4WKbcAfHSc7M5Ybipz8rV
44025	payment	2134	2134	1874	1	1	6775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ia5UbCcJHPZg1bK2xBhCsDnrrdfBArHredJC8TAyXSFjzqLN
44047	payment	1397	1397	1678	1	1	16485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZjx7mY2MjFQiL1XxFvyUTccqUNBPKzgecZTk4wAM87mS3JnB
44048	payment	1397	1397	1678	1	1	16486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkk2YZ6Gt5wimXSmFb4tbqMPQD9Q5goKg29haFS1y4uae8Qpb
44049	payment	2133	2133	1874	1	1	6295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCp4MP7ipH7wC5cZzZKW2dwe6mjMUto8N6Pfeiz4gDwY2HXGu
43910	payment	2134	2134	1874	1	1	6736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxKXT7kDHGVRnZ1J2yYdKHjZUJS4dFdWpjWmpBLAA2d1JCDBH
43929	payment	1397	1397	1678	1	1	16446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqx7K4SMoCfUGj4HFJRwB5a5Q7fft5r9fcGa2QcvBS9mXQEFsV
43930	payment	2134	2134	1874	1	1	6744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkqbGFne92yLcf23ERwhcRbPn3J9GiwZPN8ekRUSdL4uY9zM4
43931	payment	2133	2133	1874	1	1	6256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhidtiKfcw82MQicXqeFSadvgJUY8KNpdrodeeEqEb9caYQz12
43938	payment	1397	1397	1678	1	1	16449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1n19iH558ADiHbwvxfrpwYvCsnbbSJDLnmgkaqEtoTkKTi9t4
43939	payment	2134	2134	1874	1	1	6747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7kgyUGcFZqk36Ub36XoKMQMBU9ocRLXivzE6vQixrDWGzj93
43940	payment	2133	2133	1874	1	1	6259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhLePKDheUdXW7MxNC1zJgNjqgozuWUT6gZPhhWsBsGFCN212
43947	payment	1397	1397	1678	1	1	16452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzitng1ShJuSCfkB43vuVCrvHr97Cp5f6io9VfDFKFjFxmh5xB
43948	payment	2134	2134	1874	1	1	6750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99m298wump3WL619py5MZmmzP5dG9eQQyePfGwXZ5cgxUoTbW
43949	payment	2133	2133	1874	1	1	6262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3urKykL9wBn3fPdQsJDt2GQ3DWxFiKwwHFJLaEhNBKWWJZ6X
43953	payment	1397	1397	1678	1	1	16454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfGxr79WaC5BFhZEatdtxgTXHR6TCPxPwvY6XAT15e6Lrisvs
43954	payment	2134	2134	1874	1	1	6752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjN5kHzRRWDh1MkZL63UMgYx3Dzxoq6cpWP7ucWcQdEVAEmRm
43955	payment	2133	2133	1874	1	1	6264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhe64Ltap6Fr1AAfqKSFrPgjr936E2Lsz74T4FBTDCiNoeuxAr
43962	payment	1397	1397	1678	1	1	16457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRR5zb3FP2Q5N8E955ghPMDefU4rgAktfBcdofoWi1TCqrgYsH
43963	payment	2134	2134	1874	1	1	6755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzGk6sHL3gqzLNQWznkkMULVEUopfkmVQARWzDSabGzqQTBkT
43964	payment	2133	2133	1874	1	1	6267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nXY9AcDc9rr4pBVq4vCCLmok1RWpdUS29JuUrcWeRyk5jJ6e
43974	payment	1397	1397	1678	1	1	16461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1QCbSMnh62gtKLaAqgsLiDeFsYcSw9aXxW5LKZQ3wa9pm2Fr
43975	payment	2134	2134	1874	1	1	6759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbi5zNZrVTpixDameBdxKLRAJdWkBqsB2GTsMf13M6rohdtXCL
43976	payment	2133	2133	1874	1	1	6271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttvAetmWsqin8iSA9Rzef7uu7vyN3LBXu719MFLxHBv13de55
43996	payment	1397	1397	1678	1	1	16468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgWcp4vLz2Pc35o7CGShRVf6Cerdm4ScYS163evC3S8JLR6M1
43997	payment	2134	2134	1874	1	1	6766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVFpaEWbpJ9qgCJK3j77FzQoH26h5SNS5f9cXxof7HXzxZDrr
43998	payment	2133	2133	1874	1	1	6278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmnnVh1Ei4r7bXxhjq6qhH3hg76mLTWY9kM1MGhNapXAzZAUm
44014	payment	1397	1397	1678	1	1	16474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDbKNeiw3Sav7pTAgeu37zbupNidcBThUZi8pd1QRA8NZ32TR
44015	payment	2133	2133	1874	1	1	6284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHcNUZ45AA2KPVkmGJSwANmJi7NSoRK5Zg7zfanezaCF6zfF6
44016	payment	2134	2134	1874	1	1	6772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtU1FPA9AE11NzuBfhkQCdPjRC3s5yi5c2B1qNttGHmQGvSAPa
44017	payment	1397	1397	1678	1	1	16475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YCnKF9oPyVEzoK7igvK5zHd9u2foNeMiATsQAEArE7G436fy
44018	payment	1397	1397	1678	1	1	16476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWS1LShqaj2RjFbKw1veAtWazzeg3BX5HXhA57A12yM8RG1HU
44019	payment	2133	2133	1874	1	1	6285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkW9GPgg2GZ117MPBewvWqM1zJUMDtdEATEVj5bUD2biUXvQM5
44020	payment	2134	2134	1874	1	1	6773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSE3DJnmZZDUNQReBe9obphtZLKXae73ygT6Ewdw1Ks71GmgvV
44021	payment	2134	2134	1874	1	1	6774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJa5ph4yp5NGBBqQmtKXPBdf7h7Y1pT9hjr86MxPsDbRPahkQ
44022	payment	2133	2133	1874	1	1	6286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnEBf1zp1bsGKHLJfezYyxAwyGSgY1XvvHKtPHhcvAZkTdB19
44026	payment	1397	1397	1678	1	1	16478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPERAscUQvu7LJzvwxiQAD7YGt6YSasPTCQpsXqQ3XPD2oec7e
44027	payment	2134	2134	1874	1	1	6776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN59JopGDSf4Hs24fVXUHCrNhWeH7veqHd2LeEDDUG6nHeGVrF
44028	payment	2133	2133	1874	1	1	6288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACzecGgvdJerpgSwKopmia7nJ6fM4kNZs4Ly6Ubeypw6KvALU
44035	payment	1397	1397	1678	1	1	16481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAicH9u4zJsxBsoUeC9CBdLBSKop9VSHdxzzLJ1oPygUFHwrJd
44036	payment	2134	2134	1874	1	1	6779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDVf2cpWQSPmLJK2BTwKnBEqNwxSk7WKrUS3bpHCgHEWEey82
44037	payment	2133	2133	1874	1	1	6291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXsZSqGyLaZtNasv45sY4JxV6NWEUBjKkMsfsUmv6TFrstRfy
44053	payment	1397	1397	1678	1	1	16487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaxQtT1aabP2a5MEYFVkUWUNeP7qETUwtSf4S5mfwnkVLXgqC
43969	payment	1397	1397	1678	1	1	16460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiEckMPbHuCkiDgYZBbjMUuiu97Jf8gZoriy3AGH9KJP3FjMk
43970	payment	2133	2133	1874	1	1	6269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JUmgU3tVUv2oLhcPbsCyYJ6h1pdKUtUcToUvFfewKL2GYbEg
43971	payment	2133	2133	1874	1	1	6270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcEkRwy4pccda5Fh3t5dbPUccih4dL1sqR1XLYNZBCvhuqFex
43972	payment	2134	2134	1874	1	1	6757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVUTgCbwTE5CXm3wncHU5FNowZfJAs9x1aYFSSgfqZqigYFTg
43973	payment	2134	2134	1874	1	1	6758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2brSAqFZSLKi1enTm24TGZ6XciUmWSt358W3crChnhHu9FNxg
43977	payment	1397	1397	1678	1	1	16462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1ULjEWAwvj2qTk7rX1odC4KcBLcWYo6C4FBwJEMU8d5MjhfX
43978	payment	1397	1397	1678	1	1	16463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsHpBBM2UbTRGfQgFAtdLYrCXQtWSrgSPKF7XnB8TUYiccJok
43979	payment	2133	2133	1874	1	1	6272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDuToES6tebBi4UhmGuSYKGNaxnMgiuwtiUgvbTTTc6qiD3PF
43980	payment	2133	2133	1874	1	1	6273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigqpSihey9kZUGs29fD43qGsA8YD6VxDto3n85f7tiBvUBUrJ
43981	payment	2134	2134	1874	1	1	6760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBLJcYb6uv2cE7Dwgx3GSKjddGzbtC2FQgae7zDH4xkkxmctG
43982	payment	2134	2134	1874	1	1	6761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsTQfVrcM2VFpx8aNLMTg3eAa6Hi3AhmEvB4hfqEWpuzHMV42
43983	payment	1397	1397	1678	1	1	16464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsphagDn4tvnv9JrfwTCDfBGaR93XiwzXFcUSuY8SSeDZCY81
43984	payment	2133	2133	1874	1	1	6274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGVCQRRWFrPmSdeWMg2uLYNYNVfpauwFARewQGoGqLK6T11v8
43985	payment	2134	2134	1874	1	1	6762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1PKN7NVaNvKJsxkDHdKLjTrvCYamDM1Jytd4TvK9C1ojp2iU
43989	payment	1397	1397	1678	1	1	16466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgc3DVcPFsbyHSiZn1ufiG2YLXbnKhn9TKVvEvFnqeEJsJbJo
43990	payment	2134	2134	1874	1	1	6764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJaCWDrEj3nm5Lddh4hTP3pNAscL7oHSxecAqTkY3AVaP3yCK
43991	payment	2133	2133	1874	1	1	6276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8CWDjS3jHbJAYbLNirbHN1Hv1ocZbXn1b3gS3Sm63cgxKC8v
44008	payment	1397	1397	1678	1	1	16472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpz1LFhM3xhZYVzya37w3fG4Dq38ZfF8vfFqb857s6qCNSzGtH
44009	payment	2134	2134	1874	1	1	6770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdVvfUyhEBerBrbRa6jgeP2n1oYNGTRG3hJGVLzexBCWr5Nvi
44010	payment	2133	2133	1874	1	1	6282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAZjSAuHzcmtCxFgmxnJvEidJSWpZnZTAsirCwdhMgVcrCtid
44029	payment	1397	1397	1678	1	1	16479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj55pAxHx5BKY2cAGCnSTjkM9bT9c94QFJ454FvcLvea5fpXx
44030	payment	2134	2134	1874	1	1	6777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHaKqi7QpVP5BoBe56wooXKo6wVMqr1ENNMz5cQFgS3vYSpoM
44031	payment	2133	2133	1874	1	1	6289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HgsZCbf5uBR9LSrfJBXRQn9XoadmACRtLAKGbVsRfLzWRGGC
44038	payment	1397	1397	1678	1	1	16482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMe193qaT3BAdsoB4AevJ5JHHxMkxNfWfcgxQHrXS3rR76HZr
44039	payment	1397	1397	1678	1	1	16483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdmM4gK2KiGMBWRHJAPL9ohjfbawF9tjYMH87FmtiXmymE8Za
44040	payment	1397	1397	1678	1	1	16484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QvtMneMAD424drkfFiz2mE9x5c7QshkMYoSv7idrCcqiFwNP
44041	payment	2133	2133	1874	1	1	6292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRshq7fWQYwe8GGxFaEp5PKmU79qer32oL7uHSLq6DnhGCNc71
44042	payment	2133	2133	1874	1	1	6293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJXX7wLpv1q3TVw1zupDfHsXhGnhD8US8EVitorGPJZAondJq
44043	payment	2134	2134	1874	1	1	6780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmXvaXRL3uknEjUXPdz6wbtkjdGAoqn8gf3ccLfqRjMfHhGKE
44044	payment	2134	2134	1874	1	1	6781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnDMrzq4ikjnZRhjR1VdfDGRCV8hEizZKD3E3WDevAqspUt7a
44045	payment	2134	2134	1874	1	1	6782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxafZLj7FkV8fxntMPVw7Ft5LiFFGYdapaKpDC4tAh83RHxyYF
44046	payment	2133	2133	1874	1	1	6294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHMShkpaMCadEk8yqe7Zv9wUYQwdLCbLDZnJjY89iQvSe8oJP
44074	payment	1397	1397	1678	1	1	16493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMwi9CnBjACHDVbPGNErBSySsMNTmTjYfz3vJQWRpja1p3Zhw
44075	payment	1397	1397	1678	1	1	16494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgYsVCgqwm7jHLJvQzRNggMYrkxBig84HuSfsQDYq7cxVMCgG
44076	payment	1397	1397	1678	1	1	16495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwUBQBdv3obvhXFBRVD7eAKNahrofFj12VctZ3X6B9gTZkdDA
44077	payment	2133	2133	1874	1	1	6303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZj6hiUjWsiFeNQR58KvYJkmoGJoCUVUTXbGvf1oPDzhGkgdr
44078	payment	2133	2133	1874	1	1	6304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHt4AuqfJ4qTM4AoMtxb8uuuudScWdtBKUz8mnBtB4XpcfQ8qK
44079	payment	2133	2133	1874	1	1	6305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUnkmvvAo1mNaqyeYhhj3LwTNngMbdd5yaWevThT965jGCXBe
44050	payment	2133	2133	1874	1	1	6296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajWcwKMaDn6by86h84wTCgMwMjBGjPgwTGGsm1NtBQS3L72jR
44051	payment	2134	2134	1874	1	1	6783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrP7eb1qjiZYxMgDeu6w28vtBwNDquPYzEBemuHJ7mSpSnvqvc
44052	payment	2134	2134	1874	1	1	6784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWSx3LQstMnSwWBL9srZXBP8dL3hyTpKR9ysdHSbeh9Wqta7k
44062	payment	1397	1397	1678	1	1	16490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjLdq8X7ZGAxBKTgAqVmNF7ruyuQE4DXYThWtSCpL3tT5Joqp
44063	payment	1397	1397	1678	1	1	16491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQDcFZjiupytxHMkNHpd4djnAPm5f3p4Aa2UyZMa71THn59Xd
44064	payment	1397	1397	1678	1	1	16492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY15e2JyZKt94BV2phSGhGAdCARQCsG5bXu2FByuBzuZyRGXq
44065	payment	2133	2133	1874	1	1	6300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxCcWSKPuZYCYg6QGGxirSRhKGL8raGX86XdAqrZEvubiX94u
44066	payment	2133	2133	1874	1	1	6301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTahYzE4BH2bJtbWBLzkWQFMV4aGKGQjrQKNcCwMY3GUzfwwC
44067	payment	2133	2133	1874	1	1	6302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr9DQ1CVhbDCwFdRMmsYTMKBeUF791Xpnc4UYVoSdjMq9MvYa
44068	payment	2134	2134	1874	1	1	6788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifGxJZ1QqjT1thyeSgRAmvFHUbgDFm56MF5ybpXHvdLeqPToT
44069	payment	2134	2134	1874	1	1	6789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSs5SeWkbrf3UiHMPGdmQeNuRGXsmTLr8oSEpvpvi2guZmT4k
44070	payment	2134	2134	1874	1	1	6790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmuUPKru42z2NGTERcVixKBCaZSS9pi9BYX8MexU34AvRRdbx
44071	payment	497	497	657	1	1	2	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DneypZpmXYHuJpkRgisWbpmZ3BHcpL1onUQQCJUdpncMTrZc
44072	payment	497	497	590	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpfb9S17nmPfJj1EJQzUhg3RmsmoeMGzW1P2X6c7czdUkPZWd
44073	payment	497	497	553	1	1	4	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jz3uwwnfHaR1TALMEMZxhT6wfnGcPhd8FZXEyZQaQV3vCWYy
44083	payment	1397	1397	1678	1	1	16496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPDKhKfKKKMQBTuNsnWSndjniVNfbqYLcGsKCdRz3YQ2MZdDpA
44084	payment	2134	2134	1874	1	1	6794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83msMrKwxWf54UdVW6Xp67zVZ2Ga47rb3PtWMUBynUh95gjYz
44085	payment	2133	2133	1874	1	1	6306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSWcPhV737iD3bQbchC7LZSLKx9AxbuTbwMpaEWHhiz6Ph9CZ4
44089	payment	1397	1397	1678	1	1	16498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAnzvnuet8cD3PCbozWRZdw7eanpWC45B157fEgSRXmCqtq9H
44090	payment	2134	2134	1874	1	1	6796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhGjgyQHFYEngyJioCK8krAA4sgBY6aCQUf77edVBLKReNjSc
44091	payment	2133	2133	1874	1	1	6308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJ6qfRz4yT7fpXyHs8pScRDC3ySrJyur2hoTookaiPTe5Gh4o
44092	payment	1726	1726	2380	1	1	8333	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKa28v2u517LRpEstkWC4knRLP5GmHKEfGoc52xL9obUPR58HN
44099	payment	1397	1397	1678	1	1	16501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnyYgmcr1hQ4QeVfMWWoHorCcysFW9KbakFAicicFTA4U6NCF
44100	payment	2133	2133	1874	1	1	6311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFacJtu1DhK8FB9QhC3o4cpGFAswKKeu8oyhs5gnytaz5NawW
44101	payment	2134	2134	1874	1	1	6799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LDWWdaqob8b63xpMQvmAhT7tzuTnvfn3LyCdqrkbkX8VenfJ
44147	payment	1397	1397	1678	1	1	16517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkJCXPLGRUtBirzFxqC9kfxqNainVeJsH4FkrW65sLakCJX8i
44148	payment	1397	1397	1678	1	1	16518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq2TWa6RiPE8oEurHESXNuN57tHQoVM9Co6eGjx8EXB6FrsVe
44149	payment	2133	2133	1874	1	1	6327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxRXcYEUXRK2MaiS41qNnHSMjFh2h7dGVogRAwPyup9TjCzY5
44150	payment	2133	2133	1874	1	1	6328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TBqjAT749wKwFmBNjB4PaEmA3KrYu2ajJLxSSdMU9zRjk2Gj
44151	payment	2134	2134	1874	1	1	6815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZveJFJshDEJ3Ph82sXAoGSp5hSGAQehy7yks9SjWGcaUX5ni
44152	payment	2134	2134	1874	1	1	6816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxU2MZ6RhKVHNPsoaai9UczzECNqxQNVnnBbfkPzFDWGDzopHS
44177	payment	1397	1397	1678	1	1	16527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymFQpR19vWD5vXQCxwR4zZwomt87YUoPU1AngvWQZv73gXr1Q
44178	payment	1397	1397	1678	1	1	16528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTpFiP1ucRPsq9wQEjx7TD46V23EGktWir2eQrx6ca6mMQqPs
44179	payment	2134	2134	1874	1	1	6825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgCP3fwTjK1cbJLce7iPGmRS336PjpcKyG741vaDjE8ijbzCx
44180	payment	2133	2133	1874	1	1	6337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoV1MH93T6h4BfC69rELkxYK4ECcYAJ2BwSv7iyRPCbVCfe7Gu
44181	payment	2134	2134	1874	1	1	6826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8bJRKbr6YTmb8Qn1JUtAqfWGJisV9u9ZSJuUcvP5RN8xCD4y
44182	payment	2133	2133	1874	1	1	6338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuRAkeWnNkbh124Uh3i51x8AjzzaULPqRmS9oJbcHztdE2ia7
44186	payment	1397	1397	1678	1	1	16530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHkYBg6LbcghGq6gKzno4TxMLqfPWZdmMA2ifZQ5BKMgS11WN
44054	payment	1397	1397	1678	1	1	16488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHuEmtCMA1PVwN1UsopputCtpi8RAuKuefwXqSoLbPKkdQgLp
44055	payment	1397	1397	1678	1	1	16489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1mnL63KztZpPrvL1D8xvR15mBo1NKbSHaTQUraV883iqUTVp
44056	payment	2134	2134	1874	1	1	6785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8g2pyEE9faDWFhb1ih3Uw3bMRj9WDDHYeVVkyamBb7iPbUnf
44057	payment	2134	2134	1874	1	1	6786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfW5Bpa1WtkZnzZVxDyfojLz78TtKCHgVENrjaypsaoh2pvsG8
44058	payment	2134	2134	1874	1	1	6787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2wK4e2B1EHBYpJoAR4gEASypTHeNJjJhhuvB815AyydfXHXM
44059	payment	2133	2133	1874	1	1	6297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVKqF8vscBXQdv3VkUJvQUQugx45P9sod6yWi6CBq8RvVk5Hn
44060	payment	2133	2133	1874	1	1	6298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1f6r5FfYnnMDFnFaYwjsDD6L7W1M73ioLCXomR5sKgjbL4FC
44061	payment	2133	2133	1874	1	1	6299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLoJZMQur33bvYzFLFdt2jDN7yHM8jdHUkobPYo7sEQekdgEM
44086	payment	1397	1397	1678	1	1	16497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbprhU3hMnAoAVRQfgqBVvZ5k2anqRjTk1YjLo5FaP8DBwuXX
44087	payment	2133	2133	1874	1	1	6307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNejQvZpYHBc1YB7n45rJUaRU6SASMbM9UszLtB5fCkra92E5
44088	payment	2134	2134	1874	1	1	6795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwbqyc8XBhaTDqShXSz31kQmc2Zee29GUfVMcbUaqFToxCXEr
44159	payment	1397	1397	1678	1	1	16521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgaxCujzPyX5YqtqFkSWxYES63xsnfUSLd8QBaiXHgKxSi9rH
44160	payment	2134	2134	1874	1	1	6819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9Sy4bLUDajroFgzK5hcitYCon9x4zcMAZFTf2nRDxssZsGD3
44161	payment	2133	2133	1874	1	1	6331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCkZypqefK1Q3LdFhocctWZoQXFg9ngksbuCjmpJbeVtex1TQ
44183	payment	1397	1397	1678	1	1	16529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5U3sjnQawwJ58i2Ki7HqRLJo23zv7pHTLT5t32doyYdKj8i1
44184	payment	2134	2134	1874	1	1	6827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAinVcX6JijJYAanF2S8uNrfQHUa9ToUdBLekW9384Lt7GG7p
44185	payment	2133	2133	1874	1	1	6339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qbgcqFQ6nqgCjwSEFX4vUKHHEQNjhcocKWZx1N55rjedyMcH
44192	payment	1397	1397	1678	1	1	16532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKLC7oRqj6RUctEe3ktaUuC5kZn1vv26XP55E9q7YAm7jy961
44193	payment	2133	2133	1874	1	1	6342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoie9qRhBRrZiLsX65zzruQSZVofiodCAdviHGkeXFjTS27Au
44194	payment	2134	2134	1874	1	1	6830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vtHY6rjHhABs1zpPsMXWRxhv9nqpAynRmsosiKJbx21bzFVE
44198	payment	1397	1397	1678	1	1	16534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhufnVktc3LGciiKksnKendkSFYYubm4k8Ry4wA5PqEGxcpzU
44199	payment	2134	2134	1874	1	1	6832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc2UtGWjXR7Hh6RPC26s5C9Dszmj6SmcKNWZPR8TqYriWV8uY
44200	payment	2133	2133	1874	1	1	6344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeY1zf46vRje8dcE1e8kYYwdDJmMm1bwUGfEnrLiQCquttGKQ
44201	payment	1397	1397	1678	1	1	16535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQB5JVMyBNpKxfgb8mmYnoaSMXGhaWpGVeBN9PjCz7SfRe8fH
44202	payment	2134	2134	1874	1	1	6833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrG7rphHiVL29dwfWXJuqYhydKgFRYn513fthdXJciCPE4Vrx
44203	payment	2133	2133	1874	1	1	6345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQTUbQBS5vZzWruiNy97RiJDiHWc4VgW8cbh9Uuw4QpWXjnE3
44210	payment	1397	1397	1678	1	1	16538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3epdxU9s2nmwEjrTPgYKYSGseHNsemCSmMxefuz7uAd5VB5cX
44211	payment	1397	1397	1678	1	1	16539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5xeTGrdgGeLtMJuxAwAogGcwn4QrX5RFMzv4C5Rzs5eXzpST
44212	payment	1397	1397	1678	1	1	16540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5eowVq3cNYANrBKr2WpR6G2FYbaaGwiJQvTe7DJpTvvvn24V
44213	payment	2134	2134	1874	1	1	6836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WQQMAjwZqcvq43uxnk1ThpbK7GXbo2cMSETJtyTzTog1EzJZ
44214	payment	2133	2133	1874	1	1	6348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BpAXTKe2zjSajEDwh8WtHxgXRZe27BMwzxhr9xprLcsdmvey
44215	payment	2133	2133	1874	1	1	6349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgSKGuUM2fZwxTYvDB6syuCYmeVZWZJFK2smbvUiohQx7fif9
44216	payment	2134	2134	1874	1	1	6837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBMitsbqS9iJoXvknRzDXgAz3uXnJms29UZdi6b6fvGAa28sU
44217	payment	2134	2134	1874	1	1	6838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfe3khYwRUZj81SZi8jfPuQZwh3ay2VJrPcLFno9bVsSJdge9
44218	payment	2133	2133	1874	1	1	6350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJq4MegXDNHJXpoaCjkPDyanMeoTg8xR4Ug55s81egVwBWPqg
44244	payment	1397	1397	1678	1	1	16549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJwxV9e2Q4bCY9Sa4PJASv9PUapWMk2ZoqJK49AvfiED1mq19
44245	payment	1397	1397	1678	1	1	16550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCu2R64aeVukuTJLF5vXYhde8ugtjj2NHMJTBgtt3u9ajqceP
44246	payment	2133	2133	1874	1	1	6359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgvZ6dBebjiwrnnSsNWbUmSxYrUz9iHooXL8Q3hK2r8xrnRjU
44080	payment	2134	2134	1874	1	1	6791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKgzqe8uHc6f5AD8qp1Xa33ahiNMXX54cx2LdgG1Nct6cYvuL
44081	payment	2134	2134	1874	1	1	6792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6U2g7vegtVgqDXAMnVDZpy7aW9v6R8qPssuVmVy6iU1ps6hu
44082	payment	2134	2134	1874	1	1	6793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFh5TdmrBktfUczEogtADGrNkpkH1L5VAB6nAq3W9ZwdXGU9U
44096	payment	1397	1397	1678	1	1	16500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3LWHc3gC2vBYWPoXXTrnpYKAvSn9SKwx9F8dxZCeV8JbNk6k
44097	payment	2134	2134	1874	1	1	6798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvPMNimgiLZgmcmhmWFH3ug7yT217B1aJefYvfp13W7z6YVqT
44098	payment	2133	2133	1874	1	1	6310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRf2cWcj75poppdgkgBp1yFyVN7TkSDEuRGZeXypaYH5F7Nx7
44102	payment	1397	1397	1678	1	1	16502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdBst3DnD1djTmqm9hTGRePq1wrQJXekPBnosgCKiSBvbM9y7
44103	payment	2134	2134	1874	1	1	6800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5TDvYhcrNvgHKRdqqB4mZqgtdt82bndty6Z96BQPWsmZ27Gw
44104	payment	2133	2133	1874	1	1	6312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNPcs3LKKZ3UWEFgsdYiBWCGuGeJ5pDsWrvhrNN9eBhzitLMv
44105	payment	1397	1397	1678	1	1	16503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ai8wrYsRcfH8Q7PpDG2sAwj3q3PjUoBT5vgNKPtCgB6wAFps
44106	payment	2134	2134	1874	1	1	6801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydkkL7Snhhgiv5UmhoL3VcjiiaKuY8Jm9qU5X66HQ4LqpjXTj
44107	payment	2133	2133	1874	1	1	6313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNYBApeSixbNY1u4WjgRfdcdytFzUKgMRwSn8nzaVsRJRzJX6
44108	payment	1397	1397	1678	1	1	16504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mf7aCFRJ2AcLkYMfWBhNeytQ3wM6BVWyAafhHq2abccGFqis
44109	payment	1397	1397	1678	1	1	16505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Pqu8bMutc3Dw25XU3rbuyaMHXS5x7HYXZBXRSFnjkr1MqToj
44110	payment	1397	1397	1678	1	1	16506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefu2duhTk4kCTA4a1bP36re3ZQcgUaCJPan4pEaDmSb8wQQPb
44111	payment	1397	1397	1678	1	1	16507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv5H54nmvq4mmP7V4UeEjigxsSHx4jmXBUBPQAqDVsuv48dqB
44112	payment	1397	1397	1678	1	1	16508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8iptGQBYeAaSufLAQPZQQdMo4HPVDYgkqN9ZdzRbH8btxaU9
44113	payment	2133	2133	1874	1	1	6314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG6CsHni947yQPUAPBCQk24Yrphnj3AvQVTjKYSnoTuTnH1s5
44114	payment	2133	2133	1874	1	1	6315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXXDNK4byui7CeKSKSEDsMPz27PJKjjfP7NRfb7zScooLQ92C
44115	payment	2134	2134	1874	1	1	6802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnwpdqCpjD7FKSU1oz7vjsvATp996Cw7VdNiTFYGEz3EhiW8q
44116	payment	2134	2134	1874	1	1	6803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2SkvYQmmYwNHV8DCRcxCuGJ6Mi6mB4oFavZFhNsaySqEi2HD
44117	payment	2134	2134	1874	1	1	6804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgn1dXy53UyxDLXTq5dh6WoXEMyhGJedAKvTt1Fg1GDdaoi4jT
44118	payment	2134	2134	1874	1	1	6805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMYzSETVBDrpERzpELoxiq7dvXVwfVMtU8p8vvMPoLhRj8o63
44119	payment	2134	2134	1874	1	1	6806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ137YGVg4ziy4B3gbbcFkko6AStSKU1xD4Qdm8TzqF9fSybNDZ
44120	payment	2133	2133	1874	1	1	6316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsbhegcbXVv64iQBMFdJXyjKbQgUecUDGTLVjH3BDTigyaEhD
44121	payment	2133	2133	1874	1	1	6317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeBix4tV8BjfpSYyyqaWo4u2U1NbCxNP7gasFPn14VsTNDrWc
44122	payment	2133	2133	1874	1	1	6318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTtPzQn5vemtAHTF8RH9WMZ22eqhYEAnwZtoNJUM2711DsDNh
44132	payment	1397	1397	1678	1	1	16512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T2Y8QbrANciG1EtsjyqmKf8UqbAxgT7VrrqSzczPiLJ5Mkxr
44133	payment	2133	2133	1874	1	1	6322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zCekPce4sobhTtp7tM2NpmZyQZRt19ScMY741abUdJNaa43L
44134	payment	2134	2134	1874	1	1	6810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCZpZmzAGe6WmqwyNxRAYZJntrSg5PeD5YVYFf6FjvHnhYWub
44162	payment	1397	1397	1678	1	1	16522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa674h7cWr5owZ5nav3uCivYG76xQj3jXDqjVoxcgcuCPh2J41s
44163	payment	1397	1397	1678	1	1	16523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMRxjxzD6YARqWNf94tAL91VQCcZGn9P2m46j5HQSpujGM6dt
44164	payment	1397	1397	1678	1	1	16524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkhjwNnaM14HnMyRA6hX3pLEZn9fX9ZGYLYZHu3W9JhmjikEQ
44165	payment	1397	1397	1678	1	1	16525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FkCRKMA6GGkf15wUAAmRgT2iUXxJzXVEhCk1LFnWHWsdHJPN
44166	payment	1397	1397	1678	1	1	16526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5rGdyjbjmCBUAZ2FSvWimrTXbMUdL3zywtLMGiTFXzyLj1Bw
44167	payment	2134	2134	1874	1	1	6820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaMEVX8ZrsqMGsLXZPxZSeTAZXr2hAg7GqgDG6tgJURoqb2Yj
44168	payment	2134	2134	1874	1	1	6821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8uXN1ktvDwX67zHaNafkSidwnp9BexEKoGykDUW2gSFmEZgn
44169	payment	2134	2134	1874	1	1	6822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnKuTAawzeWSeF87WXNai5mh17kUbebJjbePFMAt3JecviL1Q
44124	payment	1397	1397	1678	1	1	16510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGq9quG6NE41eDTJmGpCB6n4nYUkJY8MFgAkQxDcugG26Ph5aP
44125	payment	2134	2134	1874	1	1	6807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6ccfsJRQwD7esT9R8Y57SbTtmsEhb85S3JbvBeYNiLByUNk5
44126	payment	2133	2133	1874	1	1	6319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNuvXo3MZX64LnZRGWzrPMiefwYEEkabPPzf9h1xGSmzpghWF
44127	payment	2133	2133	1874	1	1	6320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5s2rJYQ14ZKj6xuQceLh53A4r51SuDdmH3aZ5xj8PRuWdxDV9
44128	payment	2134	2134	1874	1	1	6808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sSuiuf8WAbJJKEroXhuLYbW9m7DkZ9RAsALiJu2zgnghz5Uy
44129	payment	1397	1397	1678	1	1	16511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zuC5aeyQDBtEFbBcgwvJym5x8wzcqHYxEdavo8fsZCipbyp2
44130	payment	2134	2134	1874	1	1	6809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsT5ChcrxXG2qXKkZR2zGN8ydpEi4bUAKgvFCg9frRZTKLtLkW
44131	payment	2133	2133	1874	1	1	6321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBYxUstzdkLpS765DE4rQBr66f1A21JGCiXDzVczV6uYf16GH
44135	payment	1397	1397	1678	1	1	16513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtXCBVRn6FiMK3HiD4TbuuNBzhWycbahiN97e9hLf99EEWwMG
44136	payment	1397	1397	1678	1	1	16514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtFeRnAcs4MtDGwaci4iVsYQbyQiDA4qm1mRsfhj9aUyYSwCY
44137	payment	1397	1397	1678	1	1	16515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaeTNJSqQRmtQ5kWU2vsdK6mjZYD7sew99TfD1cjhCC6dKAtm
44138	payment	2134	2134	1874	1	1	6811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDRFGBaS3q5bMjbs2WjxtyZzTCdqDCo8AZyC23V7UgHpVvfpa
44139	payment	2133	2133	1874	1	1	6323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUq1yW8GK2rkV6i1ezE7BG7qNMo3Kc2PXbtEuXSxfmnx8mG6q
44140	payment	2134	2134	1874	1	1	6812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Pg45hKEZr7Bf1CAUJs43jkFNw6MZVgb3uYdHqKYfAe7Hi5gr
44141	payment	2134	2134	1874	1	1	6813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEuUJed1HnQPMLVpZPQy8CMBdUydb688NZseZEG9Zbu27Tu1t
44142	payment	2133	2133	1874	1	1	6324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bMRHKX9vAPSgUw5pby9Rk9CigSpT6x4th93yjXWFDsRpfcRn
44143	payment	2133	2133	1874	1	1	6325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VtqjHhs4DKjm64BZwbxhdmVrBAvBDksxpaVsgrb5McsFdeP5
44144	payment	1397	1397	1678	1	1	16516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbUDWC3e87RbGG3vyUkrFYLtskvhebWbDMJgM3hTZ39HNJnfo
44145	payment	2133	2133	1874	1	1	6326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64bSCTpH9ZcSv1HBqrbvdsoyjwnQgyVG7U7gW4sLTTH1Gaqz6
44146	payment	2134	2134	1874	1	1	6814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN5gtpM5mSMXJGKAHmeUecWGLkRNfPXosZPbAz5bX9mBsRxEL
44153	payment	1397	1397	1678	1	1	16519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqh6kUkTrLsherygNpRYCrQLYDEv6Pc7oPdwJz9JgeJAqgPAL9
44154	payment	1397	1397	1678	1	1	16520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcMoa96QzbAhU2n6nrRkv814kyEFEFwbVMfj9hjXbs8zgfv7j
44155	payment	2134	2134	1874	1	1	6817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VmGWMEDbRhJBTRgdEokuFb3MKCakGwD9VzVxAAR2M2uUtA46
44156	payment	2133	2133	1874	1	1	6329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJewENWzDc8qWxftB9gGjeN8EknsXM7if4QFM6r2ZRANd164r
44157	payment	2134	2134	1874	1	1	6818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSquhdyREBFZVfhX8VR3mmRhD7cq7GKrR9WAZqn38e6kjQt9Dr
44158	payment	2133	2133	1874	1	1	6330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTq4yet64PV7ouQi6uKC8gtd33GWkJbM76wGjNotx2f5DhRVFi
44189	payment	1397	1397	1678	1	1	16531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXL1EYNztChWLXhR2tEZEhUnCLk2PgQHH5Yi3Yvj5WkEZKuLZ
44190	payment	2134	2134	1874	1	1	6829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAGXvhw2Gm5CNRjmVcfxHpAcJxrJ671v6vWqWfaXufVmjS6r7
44191	payment	2133	2133	1874	1	1	6341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnr9qFUoek9U3GDPG4RUkNwUwJMapGKCHeto67Hap6FAjnM2xa
44195	payment	1397	1397	1678	1	1	16533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjFXAWQfSymqs9ZKQZCTcEVfYfEKCZQwV4junmzR7cSxopx2c
44196	payment	2134	2134	1874	1	1	6831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcU8FcKR8rZSZg3mST98PqzZpUKDtsum8cFsgUDMiWrKRNrBfx
44197	payment	2133	2133	1874	1	1	6343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6bVvbQf59XySJXob7AUYhhJZgw9NQNReL1qLFaanzjeHy3hD
44207	payment	1397	1397	1678	1	1	16537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZK2uyrTkH4XxuP4zCpSTuhsVK9icNDKqtD1fCRcTv3d9hktm
44208	payment	2134	2134	1874	1	1	6835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbqXEEfNJBU9Qvh5bknuonNeSxpy2eG9PzVX385RjwbsaNxj3
44209	payment	2133	2133	1874	1	1	6347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYempBzixA9EmSHzeuD1iSonwv3eUMZpQuX8YDUA3bzADmMPfEt
44243	payment	1515	1515	315	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sqYdZ8seCvRgBBHrHKcpFPDA6BtqzGZnqmuprDVB6Jrr4Xrm
44268	payment	1397	1397	1678	1	1	16557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9To2J2W93XnzK1f2YjsVGXDzQQp2PfFh15Rn441YfWswMW52b
44269	payment	2133	2133	1874	1	1	6367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wyzxPHerFz6bG6KFyevuTiFAKEmWq75RTijQWTh2a3FwJyc4
44170	payment	2134	2134	1874	1	1	6823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqeGNbJBqFbJviMs7A43ktDJ8dVfa7TrycNEB4YzutbETvU2r
44171	payment	2134	2134	1874	1	1	6824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCRfHk7griAKQBGE81As7WRDRuMNhaKitB3etUGopmYQ9zZtK
44172	payment	2133	2133	1874	1	1	6332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AHr6K75iE4YpYyNdvavwfMzFtRTGvzYRGgzvWMCGPNeaWN6k
44173	payment	2133	2133	1874	1	1	6333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbZctXspfgm8TCMh5AXDtMU2GL2JxfvCPutJUYxKZUmjLYk47
44174	payment	2133	2133	1874	1	1	6334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5JKKvPcaGZBcWqVu63cxGxJjYMsQhA4fnZ8yN2xV9uNnQD92
44175	payment	2133	2133	1874	1	1	6335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhRxLhtrRKywpAMoQcZcNa63NpTSADTGL81j5gB5jtaRUYsvR
44176	payment	2133	2133	1874	1	1	6336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjn5yH2mFADmCc47woYb9z662f3fedUvZ8H1zYAT5nGjRUi5T
44231	payment	1397	1397	1678	1	1	16545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1PENS9JCgrYQqu9JEoayCyPauj6gFwZCtn9txbK6zwMd2PFMc
44232	payment	2134	2134	1874	1	1	6843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUz1ozazoPi8pxobcH96KRQTLt5UAy6BznBqCXRnjK7Df7AKBH
44233	payment	2133	2133	1874	1	1	6355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbbQ2nLc1r2bn63LDDWToLTp4nWWtpRHpx1fL2mapPR9Af3Ri
44234	payment	1397	1397	1678	1	1	16546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa6XQdYegpkMJ6o7DGytWJfo1HAKNjG2rypbzdzccpfsarmQB
44235	payment	2133	2133	1874	1	1	6356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQwpLa8GymNTLzjBTQ3FkxTv1Wkm6zZU9Fv7Wt7CyyYkaZLoB
44236	payment	2134	2134	1874	1	1	6844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLtuUWeLFssud3CcxcUbq8XkoiCrWdfcY3bETGruZ3PgJBh7H
44240	payment	1397	1397	1678	1	1	16548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeq1DuWtFdikLqDbgQ8qojAHcQ3bvZMGvKw4azWgjSdSjxz6K
44241	payment	2134	2134	1874	1	1	6846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG6zxVKYFpxLcRmqZYAMeq2px4aNQ6nqvsuVfrXCMm75fEaU7
44242	payment	2133	2133	1874	1	1	6358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbWwtn2eNQ5o7X6aceA2wahgtrrUJM663gGLfEAUpKqnjTELB
44253	payment	1397	1397	1678	1	1	16552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjjB8o9wYiobMbqBCsRukX9dQpH17naqm2uzgXm7fECW3NBLA
44254	payment	1397	1397	1678	1	1	16553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemgVPhUhBmXpmvBUqhQrdnxeCF499QhvFkZC4BGXBoTyNrwwK
44255	payment	2134	2134	1874	1	1	6850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFkPc5kNFew3gywo9gtgmX2fem7nSRyNSSJz6MAtoakPXeBHV
44256	payment	2133	2133	1874	1	1	6362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwA5b9pS5j1T9L6XfudtkyWuX4Wbpy8wBeceWArNssTQKEG7v
44257	payment	2134	2134	1874	1	1	6851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkovUq1RmEbVHX437RCMAHmeMWPqqV4CNGLHSEAQHdxUR9X9Hr
44258	payment	2133	2133	1874	1	1	6363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpNHVJVp9uK1JFGRzRSMhGsEEWMXEWrWDaudKWvauDXZG1P9c
44294	payment	1397	1397	1678	1	1	16561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5h9e46tLpHnW1PVioFrw8wWg5TKaKVswz1xv9Xs8KMkFfN66
44295	payment	2134	2134	1874	1	1	6859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs7QVuNKqskNAQReaKf31H4bhmEpAYKuxrbgZQ833eSHduZdjb
44296	payment	2133	2133	1874	1	1	6371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3qWjFq9eFoPKswgdaFr9Fj3MNuu5P4JhkeyY9SpT65tqvaHk
44297	payment	1693	1693	452	1	1	1263	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa4fB24WKnPTTm4PgZz5zFATwifbc4BM7E3nuKPs9q79cKnGJLU
44298	payment	1693	1693	275	1	1	1264	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYa92zBXziPJu3v5DuzKbYK1tPJKKcp79DCf4euzDjoSYSuJSxK
44299	payment	1693	1693	402	1	1	1265	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZEps4ENwDtk7cz2EGqEK1bzRUw5rJhUhiqKRmBGoGVT2gmn56A
44300	payment	1693	1693	2181	1	1	1266	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7FZDnoE8MqLis8Y4mKz1hGWxRynXq121DeqZchrKD281MPf3h
44301	payment	1693	1693	458	1	1	1267	68310385306	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZAXfEZ8PWcMWFSdr8a8dV2ubYbhMYXZry24SwTZSVYrJTEc86N
44302	payment	1693	1693	690	1	1	1268	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZSRj1hBaexDLNAtQQiB6xxpCSpvrDqjduaDj8ASuaoE5U1tbno
44311	payment	1397	1397	1678	1	1	16563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojujU94XKX2NkuB8gvjVnNcGhNkisvDgJZCbfpN9fXDUwJUd5
44312	payment	1397	1397	1678	1	1	16564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS89wDBztEtf8nGQ6tnqFSXeWcJm8PTZeN6y3mFJk4oRTyc9XV
44313	payment	1397	1397	1678	1	1	16565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU4EvdDJt7dGkBqYV5S83Xg5VydAHn5kRwxnKGjvUVi38xjcf
44314	payment	1693	1693	894	1	1	1274	318909198285	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYnnmPgLGyBKPcZxXA52PUJYFKzDRtriazqqtH2jdhUbhYYMMPK
44315	payment	1693	1693	342	1	1	1275	68309050196	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYh5qNMUpcvNZzhuEz9KBxDrEeAysoNnn6rtQHZLF9MsuWJS4na
44316	payment	1693	1693	1811	1	1	1276	188491275292	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsSWa95JCci6aSDYizfN85ufasRKG6ptvWfNiLadGyjxY4uF13
44317	payment	1693	1693	499	1	1	1277	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZUR3aHZDKUCvXi4ijsEcT4SiQXGHPfJafTZR6S7We7U13QQcnQ
44187	payment	2134	2134	1874	1	1	6828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqNWNNs9bHGqyyu3pDnQEsidZLsouJcPh382QdRez5Czgjn8W
44188	payment	2133	2133	1874	1	1	6340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLruFWC9g7ERxkHJz2QmcmTqbkN3nD8fpDnmQ8uj5JHShuyWq
44204	payment	1397	1397	1678	1	1	16536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YnNkgq39jZ4CduWd8iWRAoBgT5nv7yQNgeF4aUTTmaJkiMfE
44205	payment	2134	2134	1874	1	1	6834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27snyWyvqQgryZwmML39iaDedp9K6PdWJYkciEnEujcSG3Y7T
44206	payment	2133	2133	1874	1	1	6346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazR6Jw9VWpmM7LR78nfLccZK13EEyUT5PHQWpiQHmoJqDWzq5
44219	payment	1397	1397	1678	1	1	16541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfXuLFeshNySkgvZPzYjXWHijMKcxcDaTqDQwrW3kJUpNin4P
44220	payment	1397	1397	1678	1	1	16542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvFEFRYgcxDpCAnQcVuWvB4aJPqeJmLZxHFPt8qjAFvgBChVq
44221	payment	1397	1397	1678	1	1	16543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJun62Xfvkfh6NLGo8xoFQVHvpk9yngPvR6pU7EQtTaWbKRmh
44222	payment	2133	2133	1874	1	1	6351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zX7v645LS9N3QKi4o4KrVA26vSGXc4M9Cc7ym4qMxgpTvZkA
44223	payment	2133	2133	1874	1	1	6352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSucxjkfgFneVF5UzsoW7EQShCUr2G474fjdcyJUtMLeERbbu
44224	payment	2133	2133	1874	1	1	6353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXC7tyYjX1ENvsdcdzUYdYf7qWdMU9K8d6Te8eFXmh2Zr4gVQm
44225	payment	2134	2134	1874	1	1	6839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnahzQ9aojCeiz8P5WuWpedUy9NLxSir6fFGMsUx8EQehbZK4
44226	payment	2134	2134	1874	1	1	6840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPd5DqHeMqWz1gvpwYf4tbNLCbTQxKabnXjx7BVgVFJnk2q5U
44227	payment	2134	2134	1874	1	1	6841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSdPwuTNmmAH8WwsAREpZMaGbdPaRDrw3LinQqmoKeGFjo2EQ
44228	payment	1397	1397	1678	1	1	16544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEooA7RaipGxneeuCeD1v6h3GXpgw5XeeV2svMuzJPX2NTn9xK
44229	payment	2133	2133	1874	1	1	6354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDUqih1tBjgRTfVPb1aJNdFsM5Mc7c53zGUCfu6HgYyjjz1WY
44230	payment	2134	2134	1874	1	1	6842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3kDt76X4V55ZHFTzP5qVr7jxtcmw9CDX3UB5XWrfTb6qNgkE
44237	payment	1397	1397	1678	1	1	16547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqhhWkavaVKfPYr9sbaH8svWMtuUxXFrixWrn3y3RsF5eMZB8
44238	payment	2134	2134	1874	1	1	6845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6nHwef7Fhw6No9HnCovv519pbMJyLr4FruvMKRvxtYm8Rd8G
44239	payment	2133	2133	1874	1	1	6357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuTJQ4CBi9Vqin7xwKr5WuE8TQDxbPy7YC94eLz2PBPHX5mP7
44259	payment	1397	1397	1678	1	1	16554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZAE3GzuE5Jhf3BznReuxSZyzgmy58pDsmYn97cig2AQAoTbW
44260	payment	2134	2134	1874	1	1	6852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ996t25PYLiYL5L8YFJxnwsRpzgTviHobpF4CbSPiL99GjtUmY
44261	payment	2133	2133	1874	1	1	6364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KgBTkMLN6DEmQGScFdJBvjfSehYWqtipjaNGYdveTa1XoJ19
44262	payment	1397	1397	1678	1	1	16555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpVH6Luq7S1L5afYbe5S2wckg89B7qZsaAr1MYFtUzHuc4HRg
44263	payment	2134	2134	1874	1	1	6853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSdMSadVXw4SiQpPrwC6A65Lkv5TsE56aiF4VQL91hnAoXZ39
44264	payment	2133	2133	1874	1	1	6365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHFFyUM72Rnv5wq2Tw64p17XatkKCA8ZNLRQMgosscysCRC7r
44271	payment	1397	1397	1678	1	1	16558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNXDF4pqfsv82qjSoEgNUs3Bi2PLvqBH7v5JRGNqBBXP1dFWy
44272	payment	1397	1397	1678	1	1	16559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzN1dCwHuWVzPnzJ7jyzBFkz8MzWWifo1fx3vMd1YbCGUSsJ69
44273	payment	1693	1693	383	1	1	1249	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYVJAtY52p773VSefEbgDuBwfz9daCPpGoMLqa7U6rJuSd8BsLr
44274	payment	1693	1693	327	1	1	1250	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHdNxkqbdn14aNGzKdhEhLrq9dpF3vLntzPEnx5JJsdZ2J2Apk
44275	payment	1693	1693	652	1	1	1251	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZPMRyJupN9GhSso2bjxRE1bG2kW8j4p65TaqmSbZDEgyCAjgFs
44276	payment	1693	1693	266	1	1	1252	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZqBsyKcQ21ZPeahWSdAVq1AwomKVpLj6M8bk9mhqCqythgN8ce
44277	payment	1693	1693	352	1	1	1253	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYzH3pZRT1y2J6YnwgM8f5rQXDjZeWyxA2fq3pNS6GcQyYf1PWK
44278	payment	1693	1693	191	1	1	1254	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8knUiM2TGyVz4HeyqryL7M1JcEyw7F6n5yajrRqoB6rgTqwGz
44279	payment	1693	1693	520	1	1	1255	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZQDnEA94Rxra558rBs8ST4T3FK4wCxhM2ydgzy4WqLN93zvV7u
44280	payment	1693	1693	421	1	1	1256	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGXkJGoQtEnT1TbZyPjsXxukHWBqwqvpJSYd1rJBSk12n55r4u
44281	payment	2133	2133	1874	1	1	6368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DKDD7CjWwbpoR71uYnAUMBoeBcyYkPaSwGJ17qSpTtdYGvkd
44282	payment	2133	2133	1874	1	1	6369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahYti2LCwpp1PkeaXkV6fV1zZX9Tda5ktiDbHefiNvwuc3FFy
44247	payment	2133	2133	1874	1	1	6360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsR6qgE2fzrELyx2PX9k4j53XMuS77n3pbuQqYBAR8wSDqQqk
44248	payment	2134	2134	1874	1	1	6847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf27Mk1nsvYJ3vjjAvLGcfurFn438cXt8sngJki4f8zFAL2gtQ
44249	payment	2134	2134	1874	1	1	6848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVwFxtqtTNtjmiz2V6vqxF3GJpox31JSxqSY9gLbHFqrk8QQW
44250	payment	1397	1397	1678	1	1	16551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7U98zsNsqMXLiPnNjx45y3Fgsc87yXMbgfkDay1hPVYAkM43
44251	payment	2134	2134	1874	1	1	6849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyCmhEmCuqsuLGtFt8VpEKEdvFL6UVAR4yh8AwatYLEwwcp5M
44252	payment	2133	2133	1874	1	1	6361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyusFGBVjes1V52pGZ7XdZnXr313g136r2yCVEmEkKNPJLAum7
44265	payment	1397	1397	1678	1	1	16556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1aCYotHJsyXXFqcGJzXmdrF7DAUeYyCY3mpMAZw695MDVUAv
44266	payment	2133	2133	1874	1	1	6366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXQe1VKfZtDYZZwFiRkSzmzifX8EMZ7csCwh5Qj6zubZJQipy
44267	payment	2134	2134	1874	1	1	6854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnFtkJf7sBaGKntRyh6xnS6BW2H1DL42bVQBC754rK3Nje6gc
44350	payment	1397	1397	1678	1	1	16568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobYdfLmeqLN5hMYTiomrTJHCD82o7p5aBNiGJco8fNFb3Rohu
44351	payment	1397	1397	1678	1	1	16569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3J7k9Fqfqn9qJ3MHkwqhGVFGM1gvQFNmRiJZatuXnR7XjMLq
44352	payment	1397	1397	1678	1	1	16570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKL6BVtRkmTy1hyBZWxQdMMFcVRQyqwrQgwRVtzTkUpapCCdiu
44353	payment	2133	2133	1874	1	1	6379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhWV8WvqTTXpCn3FoLxV983kdPcxR1Dw85nqDK6yTNR7PF7mH
44354	payment	2133	2133	1874	1	1	6380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXsCt9to2HTg2792xmXTxqMdxkZuvDaTqEn1UVs6H7nw6k7QX
44355	payment	2133	2133	1874	1	1	6381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr14uBgCSVsEkifrU4RWbDtgMwwY3MrtYMDdwgJJ99hU58Lec
44356	payment	1693	1693	500	1	1	1296	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa6QSuh3YQsBf7MpgLuWRhDonUoE7GSdChXZJT9GCYpu6Wdejc2
44357	payment	2134	2134	1874	1	1	6867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YpWkvt9Ns2GYucBEe9LGXDp7K23HM7EPedr7hC3SJFtQEx55
44358	payment	1693	1693	587	1	1	1297	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBv5iDvZi2xvtxbxspsUJwzXKepJUgjwBYu3xGyJwSiohyoWMg
44359	payment	1693	1693	138	1	1	1298	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3oBLWZyFgjiZUzH2aR196r5V1KZPhEFZRtC9cnm5ea6oycpWb
44360	payment	1693	1693	114	1	1	1299	68310747543	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBvwwMBWL5MRHJWawQheL3UZEhohjtrgqrvF4mjdMxnnoUC7Er
44361	payment	1693	1693	443	1	1	1300	68308313303	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZTZeShJxPp8z3aZLpovBsXUonjCaAnws6i78JKHjhEHVQ6FJRt
44362	payment	1693	1693	649	1	1	1301	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa1C5xL2WGeCLe1bHvsEKmCGy1pTqadDMJedtEUEX4gpRMJzZfQ
44363	payment	1693	1693	578	1	1	1302	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYWmMDSF3mcRBBTuZ9r1WdkF5kSvhWSJ4vPEJbnHnPZ43nouegH
44364	payment	1693	1693	205	1	1	1303	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7hxijceDNkyK2HsoVn7xu1rcwjXCHT9yEdnPV3TXafqvoZ9Zd
44365	payment	1693	1693	504	1	1	1304	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZH679r6KnxzKXFA53PHPeXzrg5ZcLY7GaDHimce8Yd1b4KxQ7o
44366	payment	1693	1693	339	1	1	1305	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsp1yDJtjinFD3T187SNCArsybEbBTeYaDDrYfXNL91giqmsZ5
44367	payment	1693	1693	301	1	1	1306	68308418862	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ97Ld8RfEH8uPeXntYREQxDZ7KRQtu7Cm2aSWhcm9McHzC4U6i
44368	payment	1693	1693	408	1	1	1307	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYhxcAbJFD9wyPr6ib6CXJbgRnADxDb4JrDbYBP7gzTScqehx8c
44369	payment	1693	1693	601	1	1	1308	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHuz8BimUMaLyBNpCQakh7HKCZL1d78gZJyKK7DqWSXDyc2Lj5
44370	payment	1693	1693	1821	1	1	1309	68754015081	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZYiSzuGxVC7zuSBVqCBUdS82iR1yEGEwz9dK5nn713vtu3Gdav
44371	payment	1693	1693	450	1	1	1310	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGaJSY7DUsgpfeRp4jRmiFjwGPTWDMtWenyv4qSNhXD7wpyFvH
44372	payment	1693	1693	10	1	1	1311	33697524468	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZqiA3eZPyHkWAs1Nf25LMsVY4z4Lb7XrFz95WXi6sJr887VxVx
44373	payment	1693	1693	322	1	1	1312	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZhvS32283tYEiTDxHLZPpPQuEEL3vkx6PK318Mi7ja8NVpSVg2
44374	payment	2134	2134	1874	1	1	6868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcHZ2i2T36MXRjpsJRhzs3FCDGcw9gUrFafmAhjSKCKqeoU4t
44375	payment	2134	2134	1874	1	1	6869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUwWLPfTcsRnXQ4dcRngXmNN7zimT4pk1SFRfFp1X9YzMNBKH
44376	payment	1397	1397	1678	1	1	16571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHjPYTjMbG5BWePywsK4E1yPfEg6LNBQyw8e5wt8WPNSEPGgs
44377	payment	1693	1693	366	1	1	1313	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa9bspQk27mp69yZNtgrfFZC2gqUJqzTJEm1f6caDBwzCWrsfKN
44378	payment	1693	1693	2017	1	1	1314	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYQEPjBnVQF1t1pESjjGZQUkw5QHq9o61CNvzXmtAoxfJhi6ZJh
44270	payment	2134	2134	1874	1	1	6855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NMQwxFcTaiPafpcQm5zbYgNZjj9cnRP1m12kTZHQar9P2sJN
44285	payment	1397	1397	1678	1	1	16560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEh2m3zHmjQVysjWNszzzY2FRKM9LQeAAgEmW7VQAMHzXo2d6c
44286	payment	1693	1693	534	1	1	1257	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYSFxwFcJbpuQHvRSKE6UgAAXhXjnabT7773Qka9TXvPmDMPPDx
44287	payment	1693	1693	680	1	1	1258	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYehZxGkQcGVD3bWTE8TwKFoQxLML3kqaBw6bm5aGGoenCs98M5
44288	payment	2134	2134	1874	1	1	6858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD3xu5253nHjXQdWS8L1eXP9Q7jz4tj7HTq8PtqPgVfrakTt2
44289	payment	2133	2133	1874	1	1	6370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmddgeCAqD7J8zi3BZLJou5Quf2N34wcip8rkdYtXC9qo91M1S
44290	payment	1693	1693	82	1	1	1259	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYo78fCU76AS8NqFLCbknUbx4vTFFYomUns4UHMHitDAqg8rfkY
44291	payment	1693	1693	309	1	1	1260	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZcrvwSy8WyjCfUqctY7Db1yupSKGrgJzXeRviNRou4pRE2NsrM
44292	payment	1693	1693	361	1	1	1261	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZmfqThGqjTZEmUFor8kJmUz8cKR9eDSJKupyx8MYbaQvDwaYqo
44293	payment	1693	1693	731	1	1	1262	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTGWLdV2QegMnugJVihxQ5hkuNNSUdnLgpLfyM9wmUfvze4try
44303	payment	1397	1397	1678	1	1	16562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPZh52nD8BGpDwtBNpmXzQyoM5KLTKkH3wS77kuQ9miP6yvyh
44304	payment	1693	1693	391	1	1	1269	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYU9YtAyTis4F7MKYchFHcWEbHzUEGuJhnPbGPeigCyq2EsvKR3
44305	payment	1693	1693	1772	1	1	1270	492788206733	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3PRk37etABEGsJRAMnZcsLRw3P5ZpAqUXoHuA6iWsBsYZSdrX
44306	payment	1693	1693	570	1	1	1271	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZQ6MQXpyWViTSkHrfpRYNbpW2Bn1w61gjcZi5GfHoSPADnnGzT
44307	payment	1693	1693	390	1	1	1272	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ1Vsw3KUahLn1Hkx8QvAoTPJaRngNdCjRrtjZ8bE6wgLmXZuN9
44308	payment	1693	1693	569	1	1	1273	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYwGyngPzmwBNCSW9WDLHXmeowgpbiek1pgKGmLGhyitsU3gNjg
44309	payment	2133	2133	1874	1	1	6372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVn5N13RJqo42ZmrcZcCALKZ6xSf8mEuYFpuAznzpdtH5mjcwH
44310	payment	2134	2134	1874	1	1	6860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEkx3g5mTy9Wh7yuVSz1n3cc6VNjd5Vgp1wyhMrbvsWjjbDGj
44335	payment	1397	1397	1678	1	1	16566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Eeacnm71JvcUtWdF4eYQZ3BLfwqU8fr6Qj89YP7nUzTq5gFL
44336	payment	1397	1397	1678	1	1	16567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXsPuusECGAxAS7vK7V5bLxkGbR9amZ4WPGc3uetgj72vRSg1
44337	payment	2133	2133	1874	1	1	6376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYagqUKFXgxEfRC91cC8XwHDgmdQtkhbRaJXADNrTNPf4VXQTv
44338	payment	1693	1693	206	1	1	1289	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYpyaK2GRexDdKMuCod2Z4bmJCaSjb5Se4XbpiEiiAmXeAa52A8
44339	payment	1693	1693	636	1	1	1290	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYb6Jscgv7fgYYzfLmPyEqmekzQ8gdqBsDbqTeejfuJdGKCfbNh
44340	payment	2134	2134	1874	1	1	6864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLuSaAkxwWtBeeLW9sEb9QnhZgvEJGBFrVjTQcBKvcVAB2hP4
44341	payment	2134	2134	1874	1	1	6865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99ec73zNQuUSFr15HpS5kMz7iXN9TxV2Cdu6PpG1KidFj8EBU
44342	payment	2133	2133	1874	1	1	6377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavX1oe1M8FL28VhBCo8Rewy3U3rHHdbXkmF7u7B8h7T5W9kkD
44343	payment	2134	2134	1874	1	1	6866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAWr1LtcPWZcVJhPPHGFMJiNRcTRr9rru3tE3eaYUkzUVHs4E
44344	payment	1693	1693	399	1	1	1291	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZDHfsnfHxmqsCcKyejA73MgBC162pqYpVvDiuv3Dw9my5GKggP
44345	payment	2133	2133	1874	1	1	6378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qeJytSM5S9jbHRXe6C9rEJzzvdE4ZNMrW9ixfw7qk1ivAvEs
44346	payment	1693	1693	721	1	1	1292	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa8Nd776xH1wK63uS12FXacAsb1fmwiPe7DcchYRK5hsDL77y6i
44347	payment	1693	1693	105	1	1	1293	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5asgNiKw7ThMBVQnxJfU8CKr8Q19Kz7zk7J7e4NA2RaFUMXKT
44348	payment	1693	1693	146	1	1	1294	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYpA9BNA3ubhf4jPy3nZHSVuXAAz3JCusdDE5B8WasZg36FPJm4
44349	payment	1693	1693	611	1	1	1295	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZiSCZP9YweTPVrkhTrGoEjMncrQFpn65VUGiokf5RFrVrQp57a
44417	payment	1397	1397	1678	1	1	16576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x5nXzhfjbNEski19oWdBAYvdK6JnA1m5ZuRkkaxZVXtsTSsL
44418	payment	1397	1397	1678	1	1	16577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSCz5WSPKtWEgrdFeRsqAnBFb8q4TsBJkE77uDbeggT8uvnWH
44419	payment	1397	1397	1678	1	1	16578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9Vy34Ke2fSiUK9RE7qZyYg99NbrZ4V4dpMetk9UQysoMYoa9
44420	payment	2134	2134	1874	1	1	6875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojUNiXSdsrDAbeuC7y6tgaSY6cknXGGkqDeTVPAKFBKWtXRWr
44421	payment	1693	1693	560	1	1	1339	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ6585k4n8x4oZY3k9RYWRxS91SaphBiYGamq5MoEMYPVPseUQJ
44283	payment	2134	2134	1874	1	1	6856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeWDa88GGm97birxk55DpPJ2cUK8yX975PQJzSDcrkCsJ3XgU
44284	payment	2134	2134	1874	1	1	6857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxrHni1A2Hu6sgFcfDWa3qjK3obq1cFi39SF7DXh3yiRtBiFw
44384	payment	1397	1397	1678	1	1	16572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7qXxS1wNgRjNVNpmzw1o72oHUth7xuFpLAZv7n9qnsFgrjBK
44385	payment	1397	1397	1678	1	1	16573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZnzDT8vpyAEkapcYBpAwE6HnKnvbKkgwETm6of9FYekU282Y
44386	payment	1693	1693	180	1	1	1319	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsfPCDzz47Qn5Uy2mgE14pER76LoA6e1WGmq6UED9MCWWK4mYu
44387	payment	686	686	2358	1	1	0	50000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfn6APjzUdBzBQrH5B94bFsQmi7ctRwxpApmfhDxkm3zC43Sv
44388	payment	2134	2134	1874	1	1	6871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ66C1YoyaV1U3v1Frmichcab99y2ZdaEJNXAxf9ZNEbFnAAyLi
44389	payment	1693	1693	165	1	1	1320	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZMrZXGnssSsRdkSBkJQjGmpfDfQ46PkANUWQ6kD3LKVDTGHX8q
44390	payment	1693	1693	237	1	1	1321	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTXX8fKHEYE4pfNVur3mPDC76MavGHbBHqgxpzUS2BDyzcmsiQ
44391	payment	1693	1693	2164	1	1	1322	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYycga5NyeutmmAPT9XTf3Q4kxsjKLGJ9Yw45UbKHSiJz2Zkyc9
44392	payment	2134	2134	1874	1	1	6872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgTkeNvQAEudfi26FMC4KmrtxgPgdSinP9k8qd3MLX2WsddcJ
44393	payment	2133	2133	1874	1	1	6382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAL81wQtkDs3Ue9L6NNECxk2sxKLhSpKYt66KYLgM3ajviNRg
44394	payment	2133	2133	1874	1	1	6383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifzwDd6GpiZfD5pWP6k7T2GyDboXpPnbS5qJwVUj9hFtpta41
44395	payment	1693	1693	691	1	1	1323	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZeuq5ShwNGARvpJdvUqDXDAevuiXMgA1eMA2NpCPAbfpD2okdF
44396	payment	1693	1693	600	1	1	1324	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaGRKZejPyjEcKAJHZsP1KE5gGb58qXtvJNhjN4Rxv5S5YZaWsN
44397	payment	1693	1693	245	1	1	1325	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYyacuTvdzQjGBhyRLq3CBH1NLwR2ibcTmnotR8fSA2kS7TbgNE
44398	payment	1693	1693	620	1	1	1326	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHaoFWbQc18DpQAfEpJHFiZRdwTurUTY6x5SH2PMDmobqF9p2v
44399	payment	1693	1693	594	1	1	1327	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZCzAqADGPyE8dSWKcKLEe3CKtgFAbB6LqUNKvstD5Fkovqj6dU
44400	payment	1693	1693	201	1	1	1328	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYV9RTh9hEa2TLkpRCTuisaA4fvG6rRjbJSiUFFNB8kVJU6Fm8X
44401	payment	1693	1693	163	1	1	1329	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZkXeodntjqzzqU216DZkhP2y2rxHzwhPg7yswJpgsyxUVMfYSq
44411	payment	1397	1397	1678	1	1	16575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RBP5KybLAc6aVnBorwArWbJnbQroAJTP6bmEMQhBnX8fhwnD
44412	payment	1693	1693	252	1	1	1336	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYmEqe3DHk6mitodXHWUSBk3UPej3t4Pg879jUcDNQECyUBUhAp
44413	payment	2133	2133	1874	1	1	6385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRn2XhNqew8kWdBq1a5wGeUX5Wbdd61CPorqWVjtByyau1GJSd
44414	payment	1693	1693	377	1	1	1337	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZe1y3xbY8VD9bC59e39Ngsp4LtVwAMvCLrSX5ih9SDFY8Uvqsy
44415	payment	1693	1693	225	1	1	1338	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsumPbz5YwPvtkQzP3FDS6UonpLgLYC8dyBwA8UQirRCV72TpE
44416	payment	2134	2134	1874	1	1	6874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVMJKGu4WJ5MT4b7EVMRKxWfhv98m2QSPANiAXMvtXCvBHcVX
44486	payment	1397	1397	1678	1	1	16585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYie6cr9A2bdRZr1jknPcgLUQeQQj55pRsYaNaydptLJEDZbW7V
44487	payment	2134	2134	1874	1	1	6884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBGh7UpC1XWvYcRNfsWPtHhL1vnG91vgwBgp6J2i23UhwhCTR
44488	payment	2133	2133	1874	1	1	6395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwy4xvtG3ztVtHuoPcvGsqUiD5zgFdwT9jRywuuxr63zBZs92
44493	payment	1397	1397	1678	1	1	16587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYht6fCgZuvtbZBoHaA65rre1jXaDeCoJwMSJeszNjTgthUuFM3
44494	payment	1397	1397	1678	1	1	16588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7gvPEtT5iEG1c8PAa88UMDfKYa3xaBERTaohqHZddnebj6RQ
44495	payment	2133	2133	1874	1	1	6397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi48hV5AT8RarkJUHPmxEweNuqQxugNZrHzHCHiKQ9T2UbcpDc
44496	payment	2133	2133	1874	1	1	6398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUDZvT22ykqdJwrAR7FiyFJnjM2iFLWfo7v2AXBhLmFGcmsG9
44497	payment	2134	2134	1874	1	1	6886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfQrg8ZRybLVUULXeoTEBp4gucqPt7st7qPvuPUoSCaAVzRtg
44498	payment	2134	2134	1874	1	1	6887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsb9JcTtnBAwGS3awPqQvFjmn4ZpwacXgJDzDBLFg1wnR1ydT5
44518	payment	1397	1397	1678	1	1	16595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjBoreYFzbCL7EKGW2kt2x2SVGR594K2dStEjRFMqrwjqDC8E
44519	payment	2134	2134	1874	1	1	6894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nFkxP4pCc5JUpeK5MN6Lc6EgP3iz1Uf9ERB9kLA9kGFcHM5H
44520	payment	2133	2133	1874	1	1	6405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmcUTHUhkCBhDBstsmDFd92iw6Ep56WohaseaytKxmseHQJSK
44318	payment	1693	1693	710	1	1	1278	5196958580	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTbNWQ2AfRHuvfRZZT7V7ujvyxjaZ54Z1xPw5s3MmhjiCfiuN3
44319	payment	1693	1693	120	1	1	1279	68308843202	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYnmvj2Y8bLCcdLtMvnj7p71FU4Zb936C3iZafD6mKM49H2GFLP
44320	payment	1693	1693	663	1	1	1280	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ41HsfzwEu6yPBpEA549WHy1hdos3VBFHJovToZvGTTE3D5osH
44321	payment	1693	1693	1030	1	1	1281	936820245072	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZTx6cL9mCmiyoeHvT2vXbpVXa7nGMLT5yBPMxvzbCLpvC51uJ9
44322	payment	1693	1693	238	1	1	1282	68308077325	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYp5LTjUphiNtj7TSqyxeD6PXhQegyHcsSBJX3mWmk8RvHYqFv4
44323	payment	2134	2134	1874	1	1	6861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcF3CKoSuJBnAdntgTQTprP4xYSfZmCAS1J1LudeR5ehEfyRvX
44324	payment	2134	2134	1874	1	1	6862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUu4hp3LDnvZcvr8221JgKo6EHf5nvJ88evKQgYPWewXKPqS5K
44325	payment	2134	2134	1874	1	1	6863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm43mHHvXVUaWWD3MDb7rtBRwmTHwCH1iRrzobrmcC6FWR1KJm
44326	payment	1693	1693	312	1	1	1283	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa2v78JaEs9qSi9vw1DsaBnAhZbaLv5kSSVAtCLgSKPRtUSwYM3
44327	payment	1693	1693	251	1	1	1284	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYjnftfGHG6PuP6dfUn84qm1cLN89WVnsEUEfT7NFHK2ZLbNM12
44328	payment	1693	1693	320	1	1	1285	68308820251	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYqg4rPTUMFQynAzQwz6EdBf2krFJRZtaLzCGoT99bZhuKA7MkB
44329	payment	1693	1693	354	1	1	1286	68310385306	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZZKcopGK3XwzcKUieBKFA7gNa9HYiCivNBmbvfya3UeHpRfuvN
44330	payment	1693	1693	1276	1	1	1287	1761378573132	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZR17LxcefnPfWde2Tty1mrw1RPAXoRBUY8HHqioY4EZCaZ3Rp4
44331	payment	1693	1693	194	1	1	1288	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa6yNXx8KFFUYzP77Su3QtRMs2Ff2hpnppBwN7pEXLyVrn4VKKF
44332	payment	2133	2133	1874	1	1	6373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4By7As8BFhJHdnYeazsUioL7C2c35jHVH6vYDsqEVZzBgyKN
44333	payment	2133	2133	1874	1	1	6374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFumBcdQuLsf3RTKdttNpzMX9eBwKfddek9SQg45BVb2iJRSz
44334	payment	2133	2133	1874	1	1	6375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEt6SfhzQVqo7dY87YTJAG7gVXm6GhckU2ebxpsSaFNsjWxA
44441	payment	1397	1397	1678	1	1	16579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Qa3dtJmHe44aT3thWNAkruYWpUQ6sTznvAxKzspqx4o4GK17
44442	payment	1693	1693	2308	1	1	1353	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZRANefAHhaZS9u6iYr2irw2EUTMWiGWWvN9RgJoYLizKX85gj8
44443	payment	1693	1693	122	1	1	1354	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYWv1LT4vAKPZsoi7Mk66Sa4SDRfRYk3pQNobGfW8wvbv5wJUDp
44444	payment	1693	1693	910	1	1	1355	522781654157	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ9LtNJCR6H7PNRm82gKUHJ2ZtPY72Hm6KWFTXMLueqGXsaL8xM
44445	payment	2133	2133	1874	1	1	6389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT8quoAdGRss56C4XBp7c6jNG45i7qxYdWyo498kRvKVuhVwg
44446	payment	1693	1693	29	1	1	1356	7275742011	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaB6vjiXoDZx2xj7pwfN2hZbYUwg6NVBZLWBPGQPhMMwoXKsZ4T
44447	payment	1693	1693	78	1	1	1357	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa7oFjkQvKJPxqwVcDNPPV8bwWdB3jaeJzv2EKPgtuPCZoraaeq
44448	payment	2134	2134	1874	1	1	6878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNVrNctnutUJjqy2wnb56gcfk3Wt2WQzLUErshH6kum4EVnWv
44476	payment	1397	1397	1678	1	1	16583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZduFhJ2PCkuACN3fJzNZQBr8wB2HP1watgJhTtAeD5Th9asVp
44477	payment	1397	1397	1678	1	1	16584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpGQDzv1GTmwq2mTJkyTnpkEJ1ZzgVRKoWfTgRjPyZbEqot6R
44478	payment	2134	2134	1874	1	1	6882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCFVqRDT5bTzBuQWSyge7XhnTjxKU2Fku6k4fTy47tcjKL3fz
44479	payment	1693	1693	84	1	1	1376	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZEnW4qULa9b1ZGHzLnwbfg5BM94jpJjr17tKsfToudwFDD3STy
44480	payment	1693	1693	1150	1	1	1377	632091286816	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZFcVhhd4Mdr2cEeEucLjcgMoNxCQWyTUzqmuGWtKHCuhG8fmuT
44481	payment	1693	1693	678	1	1	1378	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZRx8sux8KS6Pc4P6kKevSijUEaTspAsGDxrufHpFwYuzXdx7fX
44482	payment	2134	2134	1874	1	1	6883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLJxqcqWGDCwKCRcemZbemCTqZPXPZFgXThhCZkarDbz531RB
44483	payment	1693	1693	89	1	1	1379	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa4y3zfL21jU1r8Fs6d8UXcpc5mVKRMgyk3N6kNuwY7vB7VeK2t
44484	payment	2133	2133	1874	1	1	6393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJW4Gp6nR6tGjmbSG9xpxTKAKYM2QgzkP9LBX8xYgvBk6fRppj
44485	payment	2133	2133	1874	1	1	6394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4z5oPRMixGbETjffrc3woLBQB6hqxYT3H9GzbFDmU8ssBDrfZ
44509	payment	1397	1397	1678	1	1	16592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuY19mxnFzeRWj1qf5gY6zH1UMoCZ3yZDRsNU1oXyLpnMrUVC
44510	payment	2133	2133	1874	1	1	6402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAqUKBN4pnBun3YYfdH9e2cupxarrQm78zvuVXCwpxT7a7Ggp
44511	payment	2134	2134	1874	1	1	6891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nAVC9NDWN8JtZAuR32pMv633wb8YGRgaE9y8FDCxd8rweLMc
44379	payment	1693	1693	283	1	1	1315	68308418862	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYhk1QAYPVef8sK8Cy78M1h4KXQzbAgnsgHSVyBbRsh3HcG372V
44380	payment	1693	1693	308	1	1	1316	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYakcvYnn88vUBW8wr5ZykNUcrRMhd78g2MVtUtwYWoFiCYs7Gk
44381	payment	1693	1693	392	1	1	1317	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa11h2mBFLcS4xHYif7K1VQ5Xwq4VaeKQyCePB3DyQxoQJGmMHa
44382	payment	1693	1693	186	1	1	1318	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZy4T4PVeN7ZnWYj74FNaoHQQ9xgm2Lp6d2R736fhAYXGRLsWUp
44383	payment	2134	2134	1874	1	1	6870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFzFjwkyV6McgNeVwhgdRLwxVbexTriR3UZPTkbEZd8A8wFkZ
44402	payment	1397	1397	1678	1	1	16574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpMmXD7GmzPQUqAtuNMENkvR4QM6jk5esCT2sFX9VYFjd11yH
44403	payment	2134	2134	1874	1	1	6873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC89rU9PARjHhVmBPqDoFKHLNzhTtzsSuZUZXaR2djdvriusjW
44404	payment	2133	2133	1874	1	1	6384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aEHardEHe6xW4mVvjBJPHqX8kV6rwcGmzekZS71dBJB1qUX2
44405	payment	1693	1693	1962	1	1	1330	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBzXEg3hnAaAUv6oCFX6XF88vKFJEWRAJmbDasp7GnnjsGrxZ6
44406	payment	1693	1693	748	1	1	1331	2072410282	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZJcMypU8PjPFF8HXbqZZ3xm7uEL9bDyVzswkv8LY8oLzFxbY8x
44407	payment	1693	1693	2073	1	1	1332	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa1NkcBNSoeBXArPtVJ7HcaydyV751bj2ezrQaxSyYbQ34ccmuc
44408	payment	1693	1693	99	1	1	1333	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZyLsCK98RtzTrSFqY4JiRErtdTApPFyfGqDRAHbV11Fq34taeq
44409	payment	1693	1693	1778	1	1	1334	2070075331	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHu73dxrHzuMcYBkztnGZQ1HfT59waYhNFHNUbt8PzhUTrBCba
44410	payment	1693	1693	108	1	1	1335	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGAhpcUTvh7gym7rjSgkmjsURazjnynpqKXi4HfEmpwm6kaNU7
44449	payment	1397	1397	1678	1	1	16580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3Vxv87QXLbaZpqC7vR2XFMU1tD2MNivpLktN3MkLRozw9EfT
44450	payment	1397	1397	1678	1	1	16581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszbo5cdidXKDtbijy3W1CfLkrvbnykc953f2CX6tdCRgPkTdB
44451	payment	1397	1397	1678	1	1	16582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpy8sjQSAUXMRwxfU6v2jCoKTmGfK7oeSaDzEwipmeKd81jSa
44452	payment	2133	2133	1874	1	1	6390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSCGaya9gMACB3jKysHGVWFwXBUCdhv4rvrYVqtPFy95Gc4pE
44453	payment	2133	2133	1874	1	1	6391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ANZqsywqgTtRy1zXL3yRAF4WVp8mQXVv7BxnWdE8FLsyVtiE
44454	payment	2133	2133	1874	1	1	6392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQmnhZ8VW7TWQqBrtdNYF38LVoKKkYT7rDE6LY9GDkcX6HxXT
44455	payment	1693	1693	395	1	1	1358	68596717405	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa7B8anSkugsTeEg7zmZiixRnqK37Ae1GJmoNcTbPpHbS5rRxww
44456	payment	1693	1693	593	1	1	1359	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3h5tEGFCdJJz9hWqy3v8gvbFQZjHeoqkbriF9fNL9qRAbX3gN
44457	payment	1693	1693	1961	1	1	1360	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZFoewUtR42LVrzi3dRTReQcsyNtMiZYUhyCkLdRaYpzMn6Na2q
44458	payment	1693	1693	154	1	1	1361	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaACWQie848VGRaB3qTkdeJSfG9LZLaRdQKBXH431S1A2n5Bwv2
44459	payment	1693	1693	658	1	1	1362	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7P2oC986MfKJf1wsUNC49Uih1sDjrXEZZcz6yV5jqpWyEhpLF
44460	payment	1693	1693	660	1	1	1363	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZXyrWGDMYV36XQDxUPCAwenN2HH5uLBjTzb7eWNDpux3S84XPn
44461	payment	1693	1693	745	1	1	1364	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTgE4Wmq41H1hL62Vq86jxWzNJxfBMUSCExxNf4pRbjMKrQKYt
44462	payment	2134	2134	1874	1	1	6879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAt9NJazcyqu1LJXtztmQE6BpBho1cddCRtDaLa5w4vwDwbfcU
44463	payment	2134	2134	1874	1	1	6880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXeeqeUhTTEcawWDasFqJMs2C5hiRfCqEDibyKRMvGyJW9igm
44464	payment	2134	2134	1874	1	1	6881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58ktfNtizDbqWLq2u1WBL8SQLTY4xuZ8T6jjrXnJixWa27DLY
44465	payment	1693	1693	91	1	1	1365	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaHvkWxzHgaeQtRLvBQ5eFGx5Jt9k4p4kuwtTA2BqcRVxnnN3DP
44466	payment	1693	1693	438	1	1	1366	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5ikUff7A9bzv4ih1cNfNRzZmy3w7FS9cu9RsKiLcXLD6Y3V31
44467	payment	1693	1693	373	1	1	1367	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaG6txXAFK1z7msKkn1Hk4LKDHgeW7t75MPsrRvbznrUbNPyj5C
44468	payment	1693	1693	453	1	1	1368	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYmaUeWGRD1MaaZuHEXV36UhqbWLxFRC75NV3SGg7fwgAWb53oP
44469	payment	1693	1693	92	1	1	1369	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYqAs8x9bxfKj2QBHxpQFi8rE6XYvEB7N2EpGXFHtQU7VkPBf2f
44470	payment	1693	1693	150	1	1	1370	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa9mDB9WH9j77jHkrd9kpj1DqYnJai1J86PmDJYq3KjgD8aGZTq
44471	payment	1693	1693	63	1	1	1371	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZCisTSB4nbAQoiGEdXW249XroPSotgvLaMFPkmDc8Hi7rBQ8Gc
44472	payment	1693	1693	562	1	1	1372	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5VgJuGirHJD9bMro75fqmoCPq1gWpFEN9pSz7Sgrk1Kd6nVAU
44422	payment	1693	1693	893	1	1	1340	318909198285	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsrB9kDL6dHQNgf1x6dBSKtMaTsvkgm27Sr1hobegvPdMo7jdG
44423	payment	1693	1693	103	1	1	1341	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZNCh9UVWUpxH92yBDVN1UzBS78n2bJXoSJ4a8NjXSN7G9JTafX
44424	payment	2134	2134	1874	1	1	6876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9dm5cagyW63qQhcqm3YRVUMHM9Vq6n3ZNM5zHhgf6zMLZPxj
44425	payment	2134	2134	1874	1	1	6877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm1Z8mxoQd6kP3SCzVMDEznPDaRcyBAbxHXNZ7wALKqrLbQoK
44426	payment	2133	2133	1874	1	1	6386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMQZd8AnqhJ3BKoNCFVC8rCEA6SZVBggJiTwwRYLVYmUv2M3Z
44427	payment	2133	2133	1874	1	1	6387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBayZUr36LLtBgjhHoYfoVFCCr862YjrqDVHSVSWNEh7W3HrT
44428	payment	2133	2133	1874	1	1	6388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rTYNJHmaFDh9B2gcmdytANxgeX1wzZChj9wJffBphG92wJQN
44429	delegation	315	315	1515	1	1	0	\N	1000000	\N	E4YhNESmm7Y4rDWMNS3xvunSd1oguQWiqJn1pHQQM72kJ8Wbp8Hw5	CkpZphqbHj7yhykqCNVLtsqmRBDQupDAcfWh5uWnvQqi8Ry45DiMh
44430	payment	1693	1693	217	1	1	1342	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaKhgrerNWpAeGfWBjmcjdEv7YWWg9jN4fq2RT6Cp8jms1zGV9x
44431	payment	1693	1693	530	1	1	1343	68308014195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZNJfKuxroGc7E4S7uq3xbEknZe324kq9FsAsC4ogEzXrMY92Lr
44432	payment	1693	1693	54	1	1	1344	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGUM7MKLBa71B7Lg6YQrruqbGgXWx35MQv9qvuQpWAHjgQjcHb
44433	payment	1693	1693	603	1	1	1345	69054134271	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZDHMUMighom4oKHymDsVpFMQZYh69U3i51qjjkazZEVj8JTHtY
44434	payment	1693	1693	35	1	1	1346	19956320964	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZdWUYEhdAcBuCCkp4nFGQFgYsnxShSdCDMBR7fHtcFXuQspePy
44435	payment	1693	1693	49	1	1	1347	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa3L7byUBapzoKfCWZCgnSUUtHrAka1yp1qFtenosigHGT3rtNB
44436	payment	1693	1693	240	1	1	1348	68309050196	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8q4RVrYikbhiJXC9g32twv38mTREzyUyLeiBZBcE7EQ8VzH1w
44437	payment	1693	1693	262	1	1	1349	68308014195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZSA82kwRwhg5X6HAFNqjt3QHzoDFvdx6cFephq3WtKshuTP4iq
44438	payment	1693	1693	441	1	1	1350	68307922083	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaA72iKsxTYh5Mggv68tMkoMQmXjdAqfCE8FF9ZVdvVMRJTjKGW
44439	payment	1693	1693	304	1	1	1351	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8sNKvnimXdh5jDNj76P63Z5iUp74vg6S8jgSwa9EsnFRLKreG
44440	payment	1693	1693	653	1	1	1352	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaGvTmJkX9T7BmQmipzNK3sbaQvEhcp5tTA2Jatr8qMuWQU85dg
44489	payment	1693	1693	1778	1	1	1380	68599853356	2000000000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpYhsJuLePGTHimk8KbWC3ATnEGebvNLdwBvR4HyHyKGNuQ1XXTS
44490	payment	1397	1397	1678	1	1	16586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDAhdghuzKka1gtoz2z1Dgj3UL9EeQMwBHSTpk5Z8FMtXPYny
44491	payment	2134	2134	1874	1	1	6885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsEXGCDqo1WsAhBJ55Fe76BLemtEjB6gNW7VAHCKpo4FQ14HV
44492	payment	2133	2133	1874	1	1	6396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TLQRYegW3XRPEPTXyKRhbeFWewNSjRforjK4E8au7AkqkP3E
44499	payment	1397	1397	1678	1	1	16589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwC8hzBEJaZ3tHPRepCErHpTdyvYUzKo7eRE1Y8Rb8X1mwQJge
44500	payment	2134	2134	1874	1	1	6888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicvF2EcgVu7g8jm38CW6q2vUjW9uxQBwg4kQ9V77FQYrG2jka
44501	payment	2133	2133	1874	1	1	6399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL65okA9h4WriFPU6GjRWDVtvG4qVjrPoXLG4Q7fTChxGMecv1
44527	payment	1397	1397	1678	1	1	16598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8cYesVSt33HLkA3YtRE3XSba3gar2C7N7J9HRtkRqHhptZe6
44528	payment	2133	2133	1874	1	1	6408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS98yLrTKe3uiyUEABEHHFhojHCvxbFAiyBwhvCuHD8th77JCi
44529	payment	2134	2134	1874	1	1	6897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDGjiDsPRNsKdp7agimq4NerwF14ptL3SLRfS4Wn9VJxB3FDn
44554	payment	1397	1397	1678	1	1	16607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRhARx9p2C4QHhZ5tzeqamND2RrMjNLhjF4r2Pz3oqHzo78mW
44555	payment	2133	2133	1874	1	1	6417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ar92RWBH8W77JGZ6U2sJSP1HbhjuwJXyy8FPneLHYL2hiKgz
44556	payment	2134	2134	1874	1	1	6906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrudLTVCksXS5zztgd7snqKGET9fDzKce1jzyzunKyq4Wtfzs
44559	payment	2133	2133	1874	1	1	6418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtKGTpMGzMLVRvMyRzsZ5en8Z4NTkrzp2UPmjc1n4Lvq94Fzd
44586	payment	1397	1397	1678	1	1	16615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyk8Ke3WXVyAFUDjm2wqB7XT7f9G2XvT6dGmquKHTwiBRL1u9
44587	payment	2134	2134	1874	1	1	6914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9Bkg9SAPftx1mmHxAfpQQCbu9wcoVkNJ2Ca1YjESUinMtNid
44588	payment	2133	2133	1874	1	1	6425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4ATbV1wjspbHAfEnj2UjedsiDyAYVzH513bviqfqeXHivdSh
44599	payment	1397	1397	1678	1	1	16619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmLZLT7m9vKMiy6fVXkPudxzjDqo1SzeqEBkoSKo37wB2M3VR
44600	payment	1397	1397	1678	1	1	16620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9VQ8jM1SrMTg2hTcmBA3owXVgSAjxszoxkK3hFRjcfU1wQVY
44473	payment	1693	1693	711	1	1	1373	3107378639	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZMkwgWE88THQwM1pNLcJunvey16wieu1AURDcdRCF5j1rGXV3S
44474	payment	1693	1693	551	1	1	1374	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZq6TubDSqqTj4wN7UVR7MGgWnrF9umE1UX4XmYXufFZsNmfWg9
44475	payment	1693	1693	379	1	1	1375	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZezoob6Y9qykj5bECDPDMBLAizcMCRC9PHm2wTG7C3e3rP2iAz
44502	payment	1397	1397	1678	1	1	16590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUKuQ7jfi7NN3RGgR2DzowFFHHD6FTWQHjRfh2Lo2bfyhQBoY
44503	payment	2133	2133	1874	1	1	6400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiczSQcGpCtbXkq1sDXKPXCYtphiCR2MJ1Dsu38FW2DLxvPXK
44504	payment	2134	2134	1874	1	1	6889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbSravrZXMD47cPZs6ccHQYVwziWPeE2on1VX9TCxPLVsfHtU
44505	payment	1397	1397	1678	1	1	16591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRW5Q8n17F4jeCvhSTuCLwQNYpdwEWUUVSCTi38Qcp9qDiEWc1
44506	delegation	2338	2338	2346	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtLgSx9EE9GdRWzCLBdVdyuqtVfqsfvye2MCRhWVEYhP7GC81
44507	payment	2133	2133	1874	1	1	6401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Qzc9v42YZNLVTEdwLqoqmyS8S32RQYoUEJCJGfiBV14afeZq
44508	payment	2134	2134	1874	1	1	6890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzhg7FGQZu2bSSiMtSf97fGMHQ1onhfUfbosQ4aft27wsDT5W
44512	payment	1397	1397	1678	1	1	16593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmS7rNqNkZysZXbghigqFxkDhj1T3uCc6aPb9TfNfyCe1dw2ro
44513	payment	1397	1397	1678	1	1	16594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fdgauQQbueitZidzxbcQdBT2Kvp3hqtB1FwUeCxtqxBPsRi8
44514	payment	2134	2134	1874	1	1	6892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Dd9atASQxrKrbwD5peabZhJ5KpxpHwfYrnpt6CnikZdLMur
44515	payment	2134	2134	1874	1	1	6893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWCoaw1HefxZfNeJxHNnnaEAHwryPGgPjY1nDSqcdNng4hEZn
44516	payment	2133	2133	1874	1	1	6403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1QW5RRPkCAp1n5QYoC8n2x2EtgD7nTkrd77wYJf93qL5bFr2e
44517	payment	2133	2133	1874	1	1	6404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG5cgUkn86CKp8z4zw12KkkeGth68FsjbT9aP4EJtxgMKhSVc
44557	payment	1397	1397	1678	1	1	16608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZennahHCaGKJCEdpJAg9XuuvLVQffFGoxFvFoSBi9oZcvJ64hH
44558	payment	2134	2134	1874	1	1	6907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtRaL6RS1CfeLZ7pCWH9D7YV6i7gX28QwEiGYYKUaLMqDHb9Z
44560	payment	1397	1397	1678	1	1	16609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaCz8RaQQ8fDu5P7iQ5Bzp5LueX6SgR3qH9MpzsF7tiCb5AWA
44561	payment	2133	2133	1874	1	1	6419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCxFjobXLFW6LfaUjsQodBroU8AXor9juNg5mwbAhz58MPX9f
44562	payment	2134	2134	1874	1	1	6908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hFFW4CQnTY1RfN5VnoYJ1xEZr2fTfdsoN2AimQHhinMBGYew
44568	payment	1397	1397	1678	1	1	16611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwgRuyqsG1esbHSAM1jPPcYcVVBMS7KSKvDfdUzmeW9bucPCa
44569	payment	1397	1397	1678	1	1	16612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFW5Zx8AxXnZMvqif6FLr3SpLBxTXfET7ircL8SQhoevqrDm98
44570	payment	1397	1397	1678	1	1	16613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qK1BhULmGgqq7gBgJvmZb6mydnFNPtMYCcYv6msvg5NCqSEd
44571	payment	2132	2132	1874	1	1	1718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUo9PFCq1L3gdoQq9SswsdApGfQVpMfatQf99KFZ1qXnHJ7r39
44572	payment	2134	2134	1874	1	1	6910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKXwGvM8gnyCM7k2pCXR9coHYqEUXdmfV9vW6PWNy3H1N81da
44573	payment	2133	2133	1874	1	1	6421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4DYtLq3gxHBkb7Sp7EEtQ146WiM89D8dbaQ9ag5z4KeZfY6d9
44574	payment	2133	2133	1874	1	1	6422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatwGghnymHFzANwvvNCBGCwYj9NKrvvGyLkJGLQHBcG3NUFGn
44575	payment	1726	1726	2381	1	1	8334	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMrKmJdqFuGrnHaxNcgbY7AsjWPZieUdah493zq9k6WudxFFuU
44576	payment	2134	2134	1874	1	1	6911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvTVQ25k2zSM3UNoANY9sQSffvW8kCcxEbixP5wcD5HDYGNms
44577	payment	2133	2133	1874	1	1	6423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1iiDe8v3QmDSoEqcCuknbNFBLBBt9UzRfvDQedKS8uw7iDAn
44578	payment	1726	1726	2382	1	1	8335	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeRSZvRuWY24rWoqKnnZ2KDjz2wfrJNWHXo55jGxPTc2jdAQUH
44579	payment	1726	1726	2381	1	1	8336	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCd39FvT8pDs9s3sPdgpL1EGtZRBk6h2tBNBZfPCqZMZAfXEUc
44580	payment	1726	1726	2383	1	1	8337	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3K86SX6brh9zVPzBTsE1jexs9izMpMGEoyKuenhwCR2sbQ2fU
44581	payment	2134	2134	1874	1	1	6912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcdCXgfDBRxMz66jd6S9pDkiWUyhVWe21LGQrvHbxQqSXjjsy
44589	payment	1397	1397	1678	1	1	16616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTnsrrzjjKdMX2gP6cxLa7WSgcBh9ZrNXWqEkBFZb68SGsrsG
44590	payment	1397	1397	1678	1	1	16617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8FGNb5fMstTZaKBXkLGLW8JUmFZQW9gZsHcLWcDXjTNzZVji
44591	payment	2134	2134	1874	1	1	6915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRG1o6SqLJ4guon2TGEr17atTTxHmxaYuLoo95Yo3JQS6AtmZz
44521	payment	1397	1397	1678	1	1	16596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFrCc925V9FLttmjxN5kjkdLPAwPMBjgK22rAmKBFqZ2hmxca
44522	payment	1397	1397	1678	1	1	16597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwRUTgrNMXMyofknSCAVLrRn1M55znQQKqMd3sY8m5CbUWGu9
44523	payment	2134	2134	1874	1	1	6895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC7ta43JVEVw6K9idWdTbwGmhnorANT6C1M1Z3oCsktF74S8C
44524	payment	2133	2133	1874	1	1	6406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRJfgJ3Winx1svYD81PPK3rhzqLimU4Yix8sth649tZQdZ9hA
44525	payment	2134	2134	1874	1	1	6896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKBHFETyA86ugBTxXgNzqVqKXokLoY6aCCwhxE6VSaYTgt3hr
44526	payment	2133	2133	1874	1	1	6407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33R4mPjLogjHKv2ibnJa7G7dXcQ84gLx7BvWkBghGZxMDtc9H
44530	payment	1397	1397	1678	1	1	16599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUoJ3gc3FgqVkzSVrZpXWBPA4ZujtAkyPPCnGJNuE1zrPku8s8
44531	payment	1397	1397	1678	1	1	16600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS9CuovVhv3m2gxNAa4Fi9pzhdL7ovU8qMkPsxMp6eyty2qWM
44532	payment	1397	1397	1678	1	1	16601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc53aiGE9NSZetjDid6ZmLVDHn7YXCYvRLaQTmoMCT6wLhigyZ
44533	payment	1397	1397	1678	1	1	16602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSTKDdrNJJRyXyPaxjTizCHij2TMRJyQYWCLcsHfM1oL6JEWU
44534	payment	1397	1397	1678	1	1	16603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7od6s9mmpEmQACvVdJgz52Ux2c6wifHuXtZKAS43WVMPZkDM
44535	payment	2134	2134	1874	1	1	6898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXmE8RhRVcKrfB4u6AX369paKsifn9FUdvJ8EZUAgxbAE9dGw
44536	payment	2133	2133	1874	1	1	6409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxAoPfktdot9G5UMe2iypp8uSK8hhk2p3vXaGqu8WCihTMZHu
44537	payment	2133	2133	1874	1	1	6410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgc7v9bwqZKieCxMHixyfmbjBquo2DMfXusXFTJ5vLZkuZaFA
44538	payment	2134	2134	1874	1	1	6899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijZQrZHZjQpSDMwqt4bxQcHenerMDugBbhmRPJ68QdX9GxN2B
44539	payment	2134	2134	1874	1	1	6900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVYVvq6qb965xh1crUcUp2WsyXAMb2LnL6hjBACLK61X2Z7zA
44540	payment	2134	2134	1874	1	1	6901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm494vpELAtABcL1EfjP4DDEaH8YCnGefW8ckq7vccyqjeqNZ4
44541	payment	2134	2134	1874	1	1	6902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGd2ovBoEDpe1Xw5pUaaREbYFJ7aP7nyVmjpfMfQPn5tJhG2gL
44542	payment	2133	2133	1874	1	1	6411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pL5ruBuFhfhfj2JQTRYAwND33mh1J7PGHSsau9iEN5cs2Ai
44543	payment	2133	2133	1874	1	1	6412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQG1JchPJHtGy6VQdUEGRGUn8ZLV5rFCdTV8Xc4p3HnG2Dpqh
44544	payment	2133	2133	1874	1	1	6413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmLAajDWMRmsvY8PSLc2xvMM6XSP4XFSSHHQGSfGHoZaAnVDb
44563	payment	1444	1444	1693	1	1	12	2000000000000	10000000	\N	E4YmEgWXS5JzW1tKAN2mYnqYKmXsQ3jHPwnBsW2FSQtK1MzHpN8XU	CkpZCejUMmhRxfvs1ycrg6oDT4wQmFuCtyeLZ38ETvefQeMHLMyK6
44564	payment	1397	1397	1678	1	1	16610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zsFwQCp9oz6gB2a1WjCUWAtabNqpUpDB9tyHCNFkikLEJ6Vs
44565	payment	2132	2132	1874	1	1	1717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeAcCi3wzv14bCN9v56aZWf47C3gLRn7SDfMQw9FLgX4ixW9Q
44566	payment	2133	2133	1874	1	1	6420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cCu5HG4zYWYgdH9c6coiRoKZoxm5LPs42EfSsw62s8MSp89B
44567	payment	2134	2134	1874	1	1	6909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmWqjxAv1sridn2zCrsDM7VRWJN5Red9FgVYQBqy4rB61PfZq
44607	payment	1397	1397	1678	1	1	16622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6nhFoE9kaeL3rJBd8MtyioufqQR7cKNXBygfCYQExwrW4R27
44608	payment	2133	2133	1874	1	1	6432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndqgDLaomAdDhdWtGBcbmxdqtusS1PF5TRqJ6MXoJXPdiZmfZ
44609	payment	2134	2134	1874	1	1	6920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRseUy58wndM4WeoWhGJ9QrsEeVMRkWC17CEDkjFjPmk78oUxJ
44617	payment	1397	1397	1678	1	1	16625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqKKEWm5QU2ow42U6YQh4wT1CQLndA23aFdS8x7Kh2ZZr8DqP
44618	payment	2133	2133	1874	1	1	6435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyGfLxkWLEpBgQ7LxTDgiAmZHc6xDd1i5C1yWzkHQCdsoYrCS
44619	payment	2134	2134	1874	1	1	6923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsP2QUCjwD5n8RVX1mr13EXixehKveQG158Ge4cXBLeuLHJFc
44651	payment	2134	2134	1874	1	1	6934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1Zi8hCddKFVCJdViCPcvE4Tb3TnjGjZCderujjfiMjp97VDh
44652	payment	2133	2133	1874	1	1	6446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99XUeehPhP45D6zrsTi33se3Zh6of2kavbCqEEzsqpfZeW4Co
44653	payment	1397	1397	1678	1	1	16636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquGR2gsPmdPM8qZ3VS9MX5fqZ4Gdy2f6snr5Jj79sdgnu6uRn
44654	payment	2134	2134	1874	1	1	6935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkSgyWDqoYkaSpqA1FnxoD12DvLNd3EFbzx2qSBwDV7S6gXw2
44655	delegation	2382	2382	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h6U7UdDPN5PjYygYftZgy6pdb4UuJfvJvrRNKZg5rQrwhqar
44656	payment	2133	2133	1874	1	1	6447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pY3jMMpcq8YYns13bD3GGK6SYgvQCAyzBfZvMtWij8T9gin3
44545	payment	1397	1397	1678	1	1	16604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfjuk1zNK13k16h9ikUmVVeSboGVjs6YoYJo9mPDmeowRUKCm
44546	payment	1397	1397	1678	1	1	16605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH2bQ3jqTgZhcoxQwjCJDgqcqt6Je6G99Wd6TxjDQ25mxhdsD
44547	payment	1397	1397	1678	1	1	16606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8SgiwTdzGzcM5szbhbFim4SgtjfGX1CFZUK1jYVc45inoLNX
44548	payment	2134	2134	1874	1	1	6903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBDy5NY4j8xiX3RCtsR6gSa3TbFtCrSG2nsvbLawEJLLa1zgL
44549	payment	2134	2134	1874	1	1	6904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWXk8seeXf6S5oR5mbWkov7arwtN1BWNRmDdM6AyowwvFuFBU
44550	payment	2134	2134	1874	1	1	6905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfinmvaP8ADri4Ger4S7rMEH9K2iVHAJ4kjqc45mV1jUHN7sMR
44551	payment	2133	2133	1874	1	1	6414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AvKUp66Wy5XYzvfD8HiD2DJe1mFxr6dHZWnLKodVrNK3auPd
44552	payment	2133	2133	1874	1	1	6415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTFPdunMnuGJgk4LXb1o5epANSFyLpyK3wF3FVBhAgeoqwLLY
44553	payment	2133	2133	1874	1	1	6416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEjnJFrpzmNZ11FhdN7sQbdtjhb2fmyeWoimsZpEFp6poYnSE
44582	payment	1397	1397	1678	1	1	16614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXgsqTZ12qfm27YpeWHW8PfXKsQUP1hjUqyJynpv2obf4nxdJh
44583	payment	2132	2132	1874	1	1	1719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdn5dfmH43qDugaQMGYBs4re7JMhShe43kQrk5gJSLNiEPJZ6
44584	payment	2134	2134	1874	1	1	6913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd76rBfCdSyytBGBLhPaEjEnVX1VJkcR3rhiHz67ebz41oBetc
44585	payment	2133	2133	1874	1	1	6424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyqQiJH9HiASLzBiQB42sfrhig76gKNmDXpS8cfJhra8MBuhJ
44596	payment	1397	1397	1678	1	1	16618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQUC4gEWjGeb83Zg2yfpo4ra8Y5x5o7hbCJBm49VvvUhD7jGK
44597	payment	2133	2133	1874	1	1	6428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qbqQdhXUac6oTHbBRajxSQDgmfv4h2xgHazGSbw86RUkWqEe
44598	payment	2134	2134	1874	1	1	6917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyEamMwY2AyMz9xZCpgLcWacNuDPQY88NoHHtFGq8JqkEUhih
44605	payment	1397	1397	1678	1	1	16621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaykhjKp7r7EgQhH3L8AFehjN3LDDSTWuynFY5FmBxHV4pYkH
44606	payment	2133	2133	1874	1	1	6431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fLUsyH7hx5iUZ6jbRFJNJZZoKxo84BnCd34bpoqzsroZYX2z
44610	payment	1693	1693	1444	1	1	1381	100000000000	10000000	\N	E4Yh7YJPCbnRF3VwWkmz8QiL1eQ3x7u1qY7zjFsozgFdoxrP3fWpt	Ckpa6h8urjW8aoZNr7BGzX1xGwJBiP6atXqL7d8kqJAK23q42wMbw
44611	payment	1397	1397	1678	1	1	16623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEXdfLodBLpCq2E4iRjNAmrz7P4Q4Qu6hcSkhhVSmfcQVMekq
44612	payment	1397	1397	1678	1	1	16624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHw8LE8mbFLCghhkZUM9ivbtEdDm9tpzmtPVBWpVP3rdG89cDR
44613	payment	2134	2134	1874	1	1	6921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFukZLMXAnVwVRsXViEUEyjKz5baGg9Bn4oAtqHQwcVh22qgY
44614	payment	2133	2133	1874	1	1	6433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmQ3j2a5AUF5Dw52Gc8y5N2Z6WGyAQoVST2w2LCpAZo8yzEeF
44615	payment	2133	2133	1874	1	1	6434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAaSzC7t48DUJrqZMh2qbED2BdLqUMcSDqtSqotzd68TbAEFL
44616	payment	2134	2134	1874	1	1	6922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXiGbRgW2RmjiRNbfj3e2mRJuGzDJThuwzfBjzw1jzXoAa1vR
44623	payment	2133	2133	1874	1	1	6436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXUWpb8tm12Ed9xd54udnHY6fmg2j98fTemF8tzyzJbZqiVhi
44639	payment	1397	1397	1678	1	1	16632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdReRgdo9gzFPwLdPdWZphfxeBtPSatdQKqQbDusmztzt2ipv7
44640	payment	2133	2133	1874	1	1	6442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8djHu5X1ocq7UMdhbTRpPVgmYHcHqZyx3qJ2je6bnDLQS7FA3
44641	payment	2134	2134	1874	1	1	6930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FSewM84wumzui4qSDi8EnTAsiBsT5QEXFzafNu6yVnqv9Mdg
44642	payment	1397	1397	1678	1	1	16633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN11vs7KmYCVyDGuoW5T5JeUomXi8sAxL1vLuMyxznJPragqs
44643	payment	2134	2134	1874	1	1	6931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFMPPeopYekiYqAdtQ9FGGBmieKbemickHR69qy6zFrfiPePa
44672	payment	1397	1397	1678	1	1	16642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXupQFyCc4X5AzX2yZzad9GykwsQQ8nZTBEvgtR2m7c44btKs
44673	payment	1397	1397	1678	1	1	16643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm76AdevQDPQsW1gWZGaLLzS4kh1XGL3Neskoja1Dq6Nh9Cf1u
44674	payment	2134	2134	1874	1	1	6941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHYQq7iNA66swKpkdqRAkpJDyLLyFetAj2wSAGPAoTWJDeLLN
44675	payment	2133	2133	1874	1	1	6453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmifJS2GeCJVBcMjhQUNaPZxBLuqJrbKNje9xS2t5d2QA1D8iX
44676	payment	2133	2133	1874	1	1	6454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCvzexKTWqE29jU9Luu5VKGZjgAPzDHigXREHPT4Au9z74XHw
44677	payment	2134	2134	1874	1	1	6942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZoeZgL94eSeGHijjMNtZJ2MYqcjgGjYrrY4XCwam1HZhnsid
44681	payment	1397	1397	1678	1	1	16645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEmWqb9KSkuJEVMjKWqiAHaNSVovXr2xvx6BzssY5tFce8LV3
44592	payment	2133	2133	1874	1	1	6426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaB4BXruHv6VBZcNiy27uw26U4Ynyz5iRmY6NgSVyjELKKHns
44593	payment	2133	2133	1874	1	1	6427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmNBKffpKBTvKbRsbC6bcfib2FngxMffAPgu4zSVbh6ChKhU
44594	payment	2134	2134	1874	1	1	6916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQbcj8TzNdVvoBGBuk8Sc7f5FirbA1EAMcBvPVFDQcmVp8bVX
44595	payment	2132	2132	1874	1	1	1720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59j2YjRGjc7CAP3mW2Ubj19gRmdzqvhSaSafyA5dwWdRUWTJH
44620	payment	1397	1397	1678	1	1	16626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCjm7GCBq6StCF6Scmkw9res7yCLtvvEqSsiJTBF6N6BA5g8L
44621	payment	1693	1693	1778	1	1	1382	1900000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZ5kGua62oGgg25GQSgLxhAQMm1dEq6kCioVCskUkgbPfdzBdV1
44622	payment	2134	2134	1874	1	1	6924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj9XpH5nE4FpVU5XtGZzsLBqVXLTkxbzc2H9vVmttdjdq9RUy
44633	payment	1397	1397	1678	1	1	16630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUAuptZN7fakRcdPLNNiGTPPiDJmRHLyuoWZB3APAjco9jPpv
44634	payment	1397	1397	1678	1	1	16631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6mVdLjW8rAnRqGXQWbNRWfGXVcmVdAJAUVuunay8XfaMz52s
44635	payment	2134	2134	1874	1	1	6928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw73o2pzdFMNvamPrW3RJP46q866Q85c7e9KoHjVWozbDzneda
44636	payment	2134	2134	1874	1	1	6929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1aum5nNjvQXPFJqKHU2orwr2Catn2rQcnbUtmLS4wRXcNhd1m
44637	payment	2133	2133	1874	1	1	6440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EXwjpPuyAzUnWLETetdU3cE5nCFPAjFR96Fbm7qFaHzkhREN
44638	payment	2133	2133	1874	1	1	6441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5rynt5DkwNGNLohpzk5cEiKC6niCT1PXHeAyuK1zMuhL6mva
44660	payment	1397	1397	1678	1	1	16638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULp88nVsabhrKjhLvcHrcqZu9Y7bTGmAap2CjXQNjPKiudk9w
44661	payment	2134	2134	1874	1	1	6937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJRtiWzja5ZJeDpwZYk6YLA5gGLnCVGacsPZjqgpr6zYvLwyF
44662	payment	2133	2133	1874	1	1	6449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgEGg6ka1yhxGs33zRmLvxkrUPwEngPUt414tPgApbPW76wBZ
44669	payment	1397	1397	1678	1	1	16641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrC7vDLDC4pUwP68Bzb76JpDf1mW69qRspeNZu5a3uj3rZFEK
44670	payment	2134	2134	1874	1	1	6940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUkpMZ1cm78ekmNBG5q4axBF1g1CA1dLgLyqp2w5xpmekgRh7
44671	payment	2133	2133	1874	1	1	6452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jEdbexeZkX4uUQpNRe2ZeNCqodHmrcttnu7r6SQtBet9nAVS
44678	payment	1397	1397	1678	1	1	16644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYQ7nJhdmiSTVDkThMdtnNhghoSnexciLVNFBxtKicmFaf6Re
44679	payment	2134	2134	1874	1	1	6943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMx4jKa1Gzr6JNL9G2qDwpYFyazvmrXJo2RfVPRzWGhrqDPmM
44680	payment	2133	2133	1874	1	1	6455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkjk1s4Fx5HKT7i7VmNKasw66tFgz3fqKrvvjbmArKibxaCqp
44706	payment	1397	1397	1678	1	1	16653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk2P5MRTEemS8o9hK49XWCag9645iPsDNiHRx1KQeA9Dp5sDh
44707	payment	1397	1397	1678	1	1	16654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAboE8Hq7DmX4CcPjZtNXqmZFPQ97xZp1wRiFhaW29Nypp5dz
44708	payment	2134	2134	1874	1	1	6952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Xa4NHGtsukPALegn3Ef2b9AoR1A3TAav99kTWFyeyyNgK9r
44709	payment	2134	2134	1874	1	1	6953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETK9qtKvFs3Pp6VYv9atHFwit8popYiUh7BRKCnZ7HMSrVRxA
44730	payment	1397	1397	1678	1	1	16659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbsT3dKFgUTyoRFCrcShaP4Mj66VsVUHoWN4Ajcu5SvZFGPvU
44731	payment	1397	1397	1678	1	1	16660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tTEaEJfHybcKdi3ZYHfKJJHmttTMmbEzmPpqRvDRxXb86QoQ
44732	payment	2068	2068	2152	1	1	1	2000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4Vg2wLnpmQwToiyLWhHRQmfYwzDTcvEu54tJSsWqnELmmgM9
44733	payment	2133	2133	1874	1	1	6470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZpPePiQW3wiJt8x2cep3Gg6oVVtroqNgfWyqdcZLyuvX9uH5
44734	payment	2134	2134	1874	1	1	6958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNViKq24Ed4J9NyKxbnJQR3EhKrdytzGSsVFcwGjtoVVFrGFc
44735	payment	2134	2134	1874	1	1	6959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5MXHsR4YhnWHqg6K62AN6p7HHgFD7aKUET63Qt9Dv4Abd1ep
44736	payment	2133	2133	1874	1	1	6471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnCkNJsysah16i943YzEtKybfX48v8RMmFmbDQEAHAbBN6byn
44737	payment	1397	1397	1678	1	1	16661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX2sdDk6Ta9PxNU1DLX3oi7SEX68PrazoS2K3k5WR6hG5xNoA
44738	payment	1397	1397	1678	1	1	16662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpStpRP6PrcQpZd2TPmzrXnNuVQ8v4sWAChqenUN7mX2rFa2P
44739	payment	2133	2133	1874	1	1	6472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqAcrNoP9nNZJRwDYEF4B7tXAR5Hik8Xar3SnioYFH2y92KwW
44740	payment	2133	2133	1874	1	1	6473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJY1WZ4nDqZtRKRfbR8w562nnwiC6ZMFCJvhBtVnJEHcqu1gFj
44741	payment	2134	2134	1874	1	1	6960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJK4zvcRFwz2a7M8JGZ82263qnRnpzym8fXenzsL1UB5C9191
44601	payment	2134	2134	1874	1	1	6918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ6CMcRZNL3UGTJZU8LhwCqBib4wURrC7Xcj1ioTUbF1qybgJ
44602	payment	2133	2133	1874	1	1	6429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaRG51FzG5cFjVwqRjHgq5MehFmupvrEGM2ToTHXZvAcukGjE
44603	payment	2133	2133	1874	1	1	6430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVpJsgYKJoBFm9Wo8YWtpg3cpdFR8AAAn4hWsuW887wUoxVXJ
44604	payment	2134	2134	1874	1	1	6919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WY1iwVt8CUikapCYA1hTNRyTWyQPhiBhgwqTuZesDrpdYs2U
44624	payment	1397	1397	1678	1	1	16627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2Y3QvcwHse3gQBq6QE83Jxidn6xpgWAuxZXSZmji9cU4kt2e
44625	payment	1397	1397	1678	1	1	16628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEBagzZr32VMG1LEr9U3qHau1SWUPLDqcLEBbxRNMiexpDm9a
44626	payment	1397	1397	1678	1	1	16629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFgEWfxeMXGyveeuw768JK7XRejVPwzoqfs1LsCJWVv73qAFE
44627	payment	2134	2134	1874	1	1	6925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugU6FQHhJg2bBZo6tcwJWjV67ws5YRuVyH2ruw7Dv85GmD1Zu
44628	payment	2133	2133	1874	1	1	6437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQzVCrePtrN7BaDdgDkTsdVGeP3eawCvZypswocNWnT2WFeK1
44629	payment	2133	2133	1874	1	1	6438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sha2TDYdqG4RiFMqMszCubWupcbKUVYr8Us7y3sjLCobDXZb
44630	payment	2133	2133	1874	1	1	6439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6frgVTsE8pAeZFYWbaCcyJPcRJEDwZ33H7HRCYo1xJqWVh5j
44631	payment	2134	2134	1874	1	1	6926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkSRwwJL9ke4267Bu93cNCxZPE1HiW4Moh7cg8WTLrsm1Q56X
44632	payment	2134	2134	1874	1	1	6927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3d6i8SwbJkhmyxixzbWoBHoH2YwE5vUVZfLUv9VGCdumazZu
44644	payment	1397	1397	1678	1	1	16634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojBARNjedBaogA4VN5TeEAhCHGUFJVCP784DQTbnGpMvKi4zD
44645	payment	2133	2133	1874	1	1	6443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCkcgZh1hR8JCXELAXo6b13KWx9Roh2aP7JcNMD2sTgtYPPJL
44646	payment	2134	2134	1874	1	1	6932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWaf4XN1k3snFJr1KUQ13ZiG5aC2H5CFvntBPXNdfSvSvpMcM
44647	payment	2133	2133	1874	1	1	6444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoKHnydQr5gNfhida5fRsUiViLumVqemrKQA12kC8dcYk64Ez
44648	payment	1397	1397	1678	1	1	16635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcZQWLoqAjTnPJt4UZCcqRUNqJvi9iKZFDPkvH4FnDmLwxNXa
44649	payment	2133	2133	1874	1	1	6445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesRB4v6fyBYWEEPtt8AKu5cKAZVs2xyUEDNgwf8WCvrhHZAGL
44650	payment	2134	2134	1874	1	1	6933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kbPYVQNRvfC6b8ptBz4y5L3waJ4FxNZBym7dPmCheKfCUKWt
44657	payment	1397	1397	1678	1	1	16637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTPtx3Qttk3mmCgc4Aa3XV5xp6tn7PZdoU6wHRSarixdrGr45
44658	payment	2133	2133	1874	1	1	6448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJScnZHXGVCJGHV4ACJAv71nJdMZFTAHKVAKoEyUdapCRYBkA
44659	payment	2134	2134	1874	1	1	6936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCz31Vs1HXkawMszBiXEGVHpDC8FQsUZ6numUn5YsZZwyjgZf
44703	payment	1397	1397	1678	1	1	16652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXASuEHu1cDJg77jos4CSrM5uRAKTbSWQTh1gGrE4mvpFn1p23
44704	payment	2133	2133	1874	1	1	6463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2cinYpFo9dPgn2ihZp5GTucpMosdSYwa57sX4oYQ947V1Ps7
44705	payment	2134	2134	1874	1	1	6951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwr6X6HQCEFEt3MpbgXDMZt2cN4oJpDq4Py5RSymozMpvaCo
44710	payment	2133	2133	1874	1	1	6464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcC8WnMK9KQaVN5gzszqC1K88Htz3jwRgSRxPyjEE4G1dK2kf
44711	payment	2133	2133	1874	1	1	6465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQjgCcMWR5JfWXtESY6YbWZt9ohE83pLMRAczmkfnwZuch3Gc
44718	payment	1397	1397	1678	1	1	16657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwy78Z3zqHXjTaR4QxUnhL2D7JnVs3mvuhqdesS7Zijy9hSqk
44719	payment	2134	2134	1874	1	1	6956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHFLj5W2P8r36HMwCmRiDWh2jisESaeL8mt8dsPzaWgv76aE2
44720	payment	2133	2133	1874	1	1	6468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZas9RNmRSd3ZiRz4JLqzwhKB9bm6mkP4evzyZi1kao2qWLTatk
44721	payment	1571	1571	38	1	1	47	95557229712	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYxoNesTwLacc93jHTgfih9RZwg1Fr9yz4379znn7S3kCxU4qLJ
44722	payment	1571	1571	969	1	1	48	727084981456	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZALpjkJQ1B5VkGE9AVrCcXZrWjT5r33vCDWUm4BwpcU75TR4h7
44723	payment	1571	1571	1089	1	1	49	1302930057112	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaEJ5AHuPzPjvvRogTNycLwnsBT6qtzo9AGMVRyjTBYtsU3DgwH
44724	payment	1571	1571	1209	1	1	50	879112872248	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZDH1E3UcP6vQx1jhrNGBokP7ZsZn9yDdaUSkAMGFzL6ca4gPcb
44725	payment	1571	1571	1335	1	1	51	2449726184880	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZVYSXV5q5h9XLjf2STnXcgCYFJt8MR8o65GTXc7K6ahbUaVhZg
44726	payment	1571	1571	1571	1	1	52	17742574568	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZXFUguNycga64BwMZc3gT4wXpTqyGNRoQgpmpsAJKzkJEqjKfA
44727	payment	1397	1397	1678	1	1	16658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEsT52mnHFhX7cGz3c8YqWXEqdJ4ZDFpKQ4CnRTgQwD3wCo8m
44663	payment	1397	1397	1678	1	1	16639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVywpBdV2tev9AeJwWyXf487DyNmDykzXtUEsRRRrJEUmqVDJ
44664	payment	1397	1397	1678	1	1	16640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfEaYaH3bA3LKZVZyXXU98ZYGVVeDTtmoMezMXqgs2E4WcAKh
44665	payment	2133	2133	1874	1	1	6450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGJege11jpS7GxRksfG7dKB4oVzE8tdAwwdx573susGGAyVJT
44666	payment	2133	2133	1874	1	1	6451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2eWtx81EhARK1tpLTjfQ44XNCcGVdh5NvthA3fwe3oZJryQN
44667	payment	2134	2134	1874	1	1	6938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMhC2hghrYnqnqXhZmT3TyVygoiYwTzuKSQuAtZWVDR9yTG5c
44668	payment	2134	2134	1874	1	1	6939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS66RXoyvr628EMK7f6GS82rjwHk5nw2CA4icG4cSFQ9EDmoKH
44693	payment	1397	1397	1678	1	1	16649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUYFzkSvagbpvMJrKuo3QoiQiMEbikoUw6s2QFVmf5LqXqdYt
44694	payment	1397	1397	1678	1	1	16650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bhX9Yp2iWmZWFfkeLKsAijP67eD38J7KLtTxsseq9nPiRmhH
44695	payment	2133	2133	1874	1	1	6460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYDK6G4TfFwGrmMgxyPqZSHmrnD9PfPJ7ksJw1qzXvsGUhLEW
44696	payment	2134	2134	1874	1	1	6948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBb9QhpegDK42BpQfxmEswyrRrN5HkiGY2HFJq5vzyDHAuGEB
44697	payment	2133	2133	1874	1	1	6461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqdmG2M2tStfg9pZBEfmi6dzS2YNbvERioAT6UAk8JTgkjLET
44698	payment	2134	2134	1874	1	1	6949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtxJQi8wotmFVXJ5UWCNfyf8krb1VJ8y7hZxjGDsyyW1d5Y7t
44712	payment	1397	1397	1678	1	1	16655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcipdp1zjE8H5pdxeUo3fgJKQtyLitQkazkrGUtaiAFGt2rXyp
44713	payment	2134	2134	1874	1	1	6954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VLYNMAFDQ9b5tPWgShbiue2XBY9hvSR8g71kPpTECQDM1BPM
44715	payment	1397	1397	1678	1	1	16656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qzGqBfCYWd4fuN1yitWdz3X6gmqTB2RHL4JtHWD2U1VzKtyz
44716	payment	2134	2134	1874	1	1	6955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTc97UyCRHSSKbwfgsdunYRMfY1VxxWNz7noaWoSNvRp9dZ6fL
44717	payment	2133	2133	1874	1	1	6467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrQgdeLxLjzbtQjFjNUvcE8x4HCqKFpzFZvZNkHQxR3oWcy2e
44743	payment	1397	1397	1678	1	1	16663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJdyMesuePQuEKmYtz3x9RkqpxgJKoAmjPWQfQnhtxeQjmAyz
44744	payment	1571	1571	38	1	1	53	35825125689	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZrMmw1UujJACpfrS8e46YZw28HUnwk5AQnFGeZzMNLwAT7F8BA
44745	payment	1571	1571	969	1	1	54	272656868046	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZW9YMfH44snnJtNYZYZMLdgTB61piQHAUsyTGXRT3QziU6Bojt
44746	payment	1571	1571	1089	1	1	55	488598771417	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZgvB1LfcBR4bgMyfAtahbksuB7kgbEf9VxhRzuwjqPcUMRKPS3
44747	payment	1571	1571	1209	1	1	56	329667327093	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZi7xR6tuUxpqgRhL3o3dVWxJhAwcnP1D9XkC8FEHWrcRg8pksN
44748	payment	1571	1571	1335	1	1	57	918647319330	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYoEUJ1CFidHC778qDZvbMpZYC4s1nWzAWftnaQrS3tWcjpALS4
44749	payment	1571	1571	1571	1	1	58	6650188416	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaE2kgvYEVkW2o8DAnPBSWXgbwmfkEYYrEAubm5NMwVSJARqKrK
44750	payment	2134	2134	1874	1	1	6962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa96QFn6RPn8RNs4DteUf47itfTAjCaDsZVxNvZvaMfVVf7r3z
44751	payment	2133	2133	1874	1	1	6474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3neRGbDmur4AgEgntxSwb7tQYwDNyrYKEFNrzVjXP1cGDpg1
44752	payment	1397	1397	1678	1	1	16664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVh1dB7fRfDF3LARR8SfnYg5QGEVtVTJKeJEWfsWah6BsBTEP
44753	payment	2134	2134	1874	1	1	6963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uG3PTJQHiA8gLJaXyDS66JH2mPYiz4NNmSC7BtfvqD2cdLp2
44754	payment	2133	2133	1874	1	1	6475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJEWrMh6rw6aTn4ykqNCo8KngWCv6ntNrQW227mWerowMbjH4
44755	payment	1397	1397	1678	1	1	16665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMdfCK3kojeDYS4mdTThJR3Etis8XnPdpBhLW4XpgU6hzn7ea
44756	payment	1397	1397	1678	1	1	16666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHradYfbWaQUHwTZvEm8yjH6Sm6PwHPCR3UsvtmytoPj4XtAob
44757	payment	1397	1397	1678	1	1	16667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QGkyjPSKr4gRps1aYqJSeyfDf1q3oJKh2xotaYy46tTRjvtp
44758	payment	1397	1397	1678	1	1	16668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedazf8f7hAtH6FaAL7RR8DRzZ9XXAJjGtXwgsmUXbaZd7Y11A
44759	payment	2133	2133	1874	1	1	6476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpic29bEoMbkRN1aCP1hURAFYLSJruL64FX5tXmh6zehtMvfAY
44760	payment	2133	2133	1874	1	1	6477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLvvmnAnEfc4AHQv4wQF8yr2itHnjQW3dw1CNSuhMD58HEAT7
44761	payment	2134	2134	1874	1	1	6964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgX1Q58SthvhJcWMZRSmJjd7yRSZBMfxNJ5BjKtbs9PSedbNX
44762	payment	2134	2134	1874	1	1	6965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3ZxaSd6G6eqA8L35823QRKSoqH2rUXtb5wnhEoYLLrhXDcKH
44763	payment	2133	2133	1874	1	1	6478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEip8rstHgdsZj8MvgRHdSz6ngaopqkd3qCV24BW8YKw64Ab6
44682	payment	1397	1397	1678	1	1	16646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu4PxPgeRt7xKrvJ8LeqBHjJN3SR38VscoRuyKit5J9NUD9kc
44683	payment	2134	2134	1874	1	1	6944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKy5SCQnarKQzJXWByjcFkAV62ZC9fksPc7XkHum7c4q44kyMU
44684	payment	2133	2133	1874	1	1	6456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQEmmnQZMii6y2AzwDY7ihkmbqKJpqUoVqXvBGVSRc5oPCpuD
44685	payment	2133	2133	1874	1	1	6457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBg1fCgWCvsxbrGki2nDtcXQ6hUfb6XQDxsUqPYs19gUpxjX9m
44686	payment	2134	2134	1874	1	1	6945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACuVNkEDYgLY43LzfQBCzYhKaKuUN6pWDnSZ6vdC7J2691Rbo
44687	payment	1397	1397	1678	1	1	16647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr76QRG26RY8M944PW1zjXUigR1jjdfULiUnxnSh2xMQHYRr4u
44688	payment	1397	1397	1678	1	1	16648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbi3yadKyVNzu9eBBzd8d64hFsADPsA4AbnPKXbGENJUCvpz6
44689	payment	2134	2134	1874	1	1	6946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVszaFSyZFRV81UrwgZermkSXvcf46E5ABYb4EouRfKJuGBH1
44690	payment	2134	2134	1874	1	1	6947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhpifd2Ydsy8Ty9iw52bWJQQ8wUHxGKnncPBJr6acpTFy9HE1
44691	payment	2133	2133	1874	1	1	6458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3bTPnTy4hkjrFnUWCPuV6AkDM4afocg99FbFFTq3pHb4yE5C
44692	payment	2133	2133	1874	1	1	6459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMDu4bvXYSB3foDXpVNuMcgxmUZzQeNWxBZDoZ4HNigm4QTc2
44699	payment	1588	1588	2068	1	1	12	1057100000000	10000000	\N	E4YTFoiyqbRtQcmNEnoT9czG4jLFwuy6MAGp8VQiuQD9jMBAgW8vf	CkpZWHkqfS5BTWWy9bTZBVieXd38abwHAmLa81L1b1y8mj9hKxMAk
44700	payment	1397	1397	1678	1	1	16651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAPWgiGUtMdk6kcgZhvdHybKDjA5SS7WC7xLzv5rAQEmkZwAE
44701	payment	2133	2133	1874	1	1	6462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pi9eX86TQ5Ykx2DeYDU5HgeCKc8aS5fpttQ6LRqpWXWVSwMD
44702	payment	2134	2134	1874	1	1	6950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCM2PWV2VSp5T8Awy9Xrzbeuy9Ak59Bwf4cwbd4NauDboY4K3
44714	payment	2133	2133	1874	1	1	6466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1SQ6m1whDA7pY8AqoebLaPJf2c5MmcHFBn7SagezjPWWC7yf
44767	payment	1397	1397	1678	1	1	16669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqSRPBwb4gzF84A28oiXwxKPZ3tQG9bwooFVXJsG1xwKE4YLNu
44768	payment	2133	2133	1874	1	1	6480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9VBGwE3gMxqzxxEkykgxeBT8W5H7psA2j2MkNLi62HmFMask
44769	payment	2134	2134	1874	1	1	6968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYuYUhJBUBEtJTffgnwXvQk8ZiLPJaHkMCaTw1eFdyrfm4qvf
44770	payment	1397	1397	1678	1	1	16670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkkTeBhiim64D2Wq9ExB3rhhKDReDV2EEVPPjGhpZRidhHk2H
44771	payment	2133	2133	1874	1	1	6481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8CH9dpWQg8nYnC6AYemfu9t2ih2g6HVrwyGL6TpwwiAmdcwW
44772	payment	2134	2134	1874	1	1	6969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbz8L332T92qVdz2xtoL3qKMkj6uVcdNEnFDf6bLiFz7mcoTA
44773	payment	1397	1397	1678	1	1	16671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJ3XVzGfhHNK3ZZKEsWgoUorASifQnMmekHH6kwbyjGexgFr2
44774	payment	1397	1397	1678	1	1	16672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLZYddHuZKkQsQbhLC4VG3VZznmZoRTueva3nJW3zsaS7EuuY
44775	payment	1397	1397	1678	1	1	16673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuwQnjASkGQFjiBSQaakSRJGFBwcgPkaN38uAvr5mjDED4ygJ
44776	payment	1397	1397	1678	1	1	16674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMWD8HBzyzqKWQzAMwp7br156wMAPppLmGhog9nPwbVZ4xgC2
44794	payment	1397	1397	1678	1	1	16678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7grzjjxobqfommzfmruEY5c2gfySQg37yqVTw2e4j2G66EYE1
44795	payment	2134	2134	1874	1	1	6977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMa27ry7XBovatUc1Xf12oSMC4FCys8qGf1H8tLd95igXFFR8q
44796	payment	2133	2133	1874	1	1	6489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4idvS8m1LZF5ds3EoSdmdLbtxUtpZczxCGQD8TFG9miB4Tcx
44878	payment	1397	1397	1678	1	1	16704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmHkkP7ZsV7H8WQFfNcLkZcmMhcZc7BtScCy7WbS8UsKgsJXM
44879	payment	2133	2133	1874	1	1	6515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc9tfpeNAQ3pHfFGRbwhwA1hQPF1ouGLsho7Tp8xjhqYg4riF
44880	payment	2134	2134	1874	1	1	7003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoDu1Qh6WTpxgSm5HVKxyiCZcVzyCkszC385hWwZjdwzg9WwP
44895	payment	1397	1397	1678	1	1	16709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNpv78nhWP3GRxfm1kvDdjRyZGoPDdGYE6UDqUP33T8HSmskp
44896	payment	2134	2134	1874	1	1	7008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkSobk5EL1EA3f1vjDAtmPkzUXvKHQzCCdUKWyYd9GoVHceJE
44897	payment	2133	2133	1874	1	1	6520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpMBrCRJoedqeiSFoHTdRgpWJMz1wb3hK6LwTQ76iZ6p7XDUVK
44915	payment	526	526	1474	1	1	2	9360000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuq7hSGM6C9SbSAc6DCX1bgvj9CyHxeSneQkMwkGWhqj74G3Y
44916	payment	1397	1397	1678	1	1	16716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPXM6bwLB8VBGP222zmDfoJmM42LWWiQfUuNjnNXr79k1AbRV
44917	payment	1397	1397	1678	1	1	16717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgWhzBrw3uKs2ivZPJn4g3UciuYYaMYnnWq6fJQUs6YPAw1Ai
44728	payment	2133	2133	1874	1	1	6469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSweCtjZt74Aa3NLwD9fPgJMBU2wKy2mPwwv3LUaM3XfC3edx
44729	payment	2134	2134	1874	1	1	6957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgtRykg7MnBLSVXwJydK8SytxeSc2wcCBL9yMJEdGCd7x9MBr
44777	payment	2134	2134	1874	1	1	6970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPjRKTP4cjbc2RDgoiy8WoKifNdR7Q9EcsdqJriWU4EiebuLs
44778	payment	2133	2133	1874	1	1	6482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGAVdAYh7A4u2LkdzFniNb6YhL68WEtHLjZYN9LLLaYjRFGdN
44779	payment	2133	2133	1874	1	1	6483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoHbh3mrYHhsRAT9UKf6J4QcYK6X32HgzunBh4rK3qAoMVNma
44780	payment	2133	2133	1874	1	1	6484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnnHkU5WCT3yTjQsQ4t1T5vYkgLKEuxx9SwbJRTXBCKdsoVmf
44781	payment	2133	2133	1874	1	1	6485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmhsRaqEDnKoeCG69DWMpQ2A7iWUSk4JqkTC8HqPAXMX44voK
44782	payment	2134	2134	1874	1	1	6971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1CE9No6Mp1GXfmyJK99yZ9BhCvWSNV4RwABjgMzLMprJNQgL
44783	payment	2134	2134	1874	1	1	6972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxr8EioiCoV1Y4vzREDJEAVDhR6N6YRXCb2c13UWe3szspxWez
44784	payment	2134	2134	1874	1	1	6973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSB5HG7KpcFjjSV6NTzsZEPA3sT8P5CMhTv6zUqDUk3pfQUJR
44785	payment	1397	1397	1678	1	1	16675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyCipafF4wRC4pEx8ACGTbmBccFYsUNwVqwVDUwSihZiANuta
44786	payment	1397	1397	1678	1	1	16676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeDM4F1odsDft6rngCpqFjqKzaCcUyTWyaRhoxj9GxgCPxAQN
44787	payment	1397	1397	1678	1	1	16677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZE5vKDtDWXuuQXDCZNbw1NQpvpfQTAaxgAG4a5Gfy5DKbcfvS
44788	payment	2133	2133	1874	1	1	6486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhacBydQuiWM7ebh6sWyp2h61bZiY4Hy1gAxjFfwib3b57ivx
44789	payment	2133	2133	1874	1	1	6487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG23b2nsza1AgEmYk8Qs4nW3F7Rx7ySgrMBnVWoUeudiiCYc2n
44790	payment	2133	2133	1874	1	1	6488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLZZpx8uPg1K35HbpohX2NmVNZhwq1NhQedA71Q7CPo4451rH
44791	payment	2134	2134	1874	1	1	6974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojzXjGadYz4Qn2rYA7XqwQSPBngz4PcwZ8nZcGSWzm76UK6zs
44792	payment	2134	2134	1874	1	1	6975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQi39v47AYCEWrwBxah59LfncCH4yxG5qssK7qHUwK3VMSLQL
44793	payment	2134	2134	1874	1	1	6976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h8jX1EUVqEn85BbWjGWLiLk6GodMAHuGneKgaza4A7KCrWdt
44803	payment	1397	1397	1678	1	1	16681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HNGYymLSuyfTkegD18yJKorpi94MLogUPGKPbdQUFBFGUFmY
44804	payment	1397	1397	1678	1	1	16682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6Jg3A3E525zFHmfE6VqyiNdGTKrPaLKAx59hwnJDTXA8Eka2
44805	payment	2133	2133	1874	1	1	6492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFY4LuFFqby98oi2dS4ncxToQ18wE93mDrNq8ewSKhw5DXDJt
44806	payment	2133	2133	1874	1	1	6493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJgKCuVmnGEWFsmF63Pom3dV6EFvaPLsQvzuNB911PW3m5uQN
44807	payment	2134	2134	1874	1	1	6980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpi1RvYbpYudiDCTHMvud6XWvJEWukYwx6ZodYPihmZNq5hRw
44808	payment	2134	2134	1874	1	1	6981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEirJn9rnDLpSLBhb4RknoQtyiAroexDSkDoeMLBUmLMgpPXyY
44813	payment	1397	1397	1678	1	1	16684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzfCf17711iZj7C8x8PHRcKX5YtFNcHoZoq1Upoex4qGSyjrW
44814	payment	1397	1397	1678	1	1	16685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAH4r3WffceYJA57xYhWY6NyCuiV2sv9mBnNs2dcdYsbRuzT2
44815	payment	2134	2134	1874	1	1	6983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJYRPmwFEgGNs6bkPrL9GATjgZf5dVhjb4k2jfHWZaRVNp8nG
44816	payment	2134	2134	1874	1	1	6984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirF61yVtpNwgN4wN9t6UbgzDjf21kauXgDhgLEWaNuDhVup7Q
44817	payment	2133	2133	1874	1	1	6495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR9SfHtXr54CYypaw7sde19swFnS4rtuaVHfC1afqtbSnJeMK
44818	payment	2133	2133	1874	1	1	6496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HMSrm5Dx4YgZzWTJNtcbqRXpcT2eJo654ADRxAC5KuYMZEft
44840	payment	1397	1397	1678	1	1	16693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6spP9JzcPWmzmy8HeBLhmDttoVoywDafGRYuDPkMATNY7WcGQ
44841	delegation	553	553	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4mXEgAdrSgDD8ioC6fnGQ8SjufSbEPnvtbwXDEKfAFzUUVo2
44842	payment	2134	2134	1874	1	1	6992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxMUVLvVR4fuZrBaitLF1o2QXHTvgzuFq9Z5SCYF5m51KPwRx
44843	payment	2133	2133	1874	1	1	6504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVqUM9dt4KVXkxyARufGvYU6oydaEEfjZgh6L4hKW3jQNqe1a
44850	payment	1397	1397	1678	1	1	16696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKSJT9u1pTSmsEbpxoLmUBGF46LNWn61e27QTftPUZGeKTpCJ
44851	payment	1397	1397	1678	1	1	16697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBH8iQ4Vqs1kEZjDqXkZpBBTUbY59JXQP2NVm8Xb2iKBNXL73
44852	payment	2133	2133	1874	1	1	6507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxqHuNKr8yWFKZiBmpbqcHSGFc4be8vDE3xpbRgt5QyrKEXLp
44742	payment	2134	2134	1874	1	1	6961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKtPHvLToU29Kgxk4aGWH7dLVnkjdqJwA1YRqLMtZZStLZ9P3
44809	payment	1397	1397	1678	1	1	16683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtJVLR3tc7EYbJoWjxTUaXirXSsttgYFED5ZqCnfHu9CCHhEF
44810	payment	2134	2134	1874	1	1	6982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpHjPvQ8fa5cmd2Sg6pvZACjM9qdhSLSnutrYy92x9zS84QXn
44811	delegation	321	321	1635	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjsNU3LvuL6fxuzDUTm8McGkDgHpYTFdq4rDwmDoUfA5SkxL6
44812	payment	2133	2133	1874	1	1	6494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMNZHsmonVJMzAc4m8TknX9NHiPpmgAGJK4Ax7EbqdN2Bc8Pb
44819	payment	1397	1397	1678	1	1	16686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctP83aiz6aob4YqqZcswjusjQURTqAHJ5GESYVVLZ4V5k1vBk
44820	payment	2133	2133	1874	1	1	6497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEcBfdqucPLo162ZZZg7fZxfGij9fRW84jKDLMxcxhri8uUPP
44821	payment	2134	2134	1874	1	1	6985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzMkMwmiQAbenL5HTyupNA4wEr2iDx8LUTbmfV5e5zmnagqb6
44856	delegation	497	497	1474	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYH3HaQEgRJpXjEg9DbDSpPkrD7kzrgJ9zrk7YejQGknrvhmm
44857	delegation	657	657	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWN8u4k7S9JvWu1EiUtqBLvEsKf92chah4RgYkeR3Ab2ABcuVm
44858	payment	1397	1397	1678	1	1	16698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwo43TWXPDWAr8suhVVheM1NfimrEuG2Ri1V7kGGp26AWPyTR
44859	payment	1397	1397	1678	1	1	16699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkMCibRbLvd1JHeHKKVHqWZuPnNkRp6xQBAw3xihGcqaTeMSU
44860	payment	238	238	2314	1	1	6	179000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MssJi5SG1A7AsTG9ZRBEnoToAoGMbh1DvX18r7qq5XKmFkwV
44861	delegation	590	590	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6GGP4DGxH8WZv9cr92S3LcK5ZpppKBPrnL3KoWJXCaXd2m8X
44862	payment	2133	2133	1874	1	1	6509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V6sbQZun5bWHsN5V5s5DY7JQEogENUsF52dynAoQ3ngb7DUS
44863	payment	2133	2133	1874	1	1	6510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYAaD3Sbnd4WC4gaXZBdvBHLJ5AzBcNfyLpV7Wbyg9GVPgDTR
44864	payment	2134	2134	1874	1	1	6997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHPNrbzByGTJ93DjpywaCu8svDyY4dXUu2R2Q2ve1smcPC2QP
44865	payment	2134	2134	1874	1	1	6998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoQjwzpfZSYyR4KQ3pj8KXHxxVg9VcAuksTRgMYwboSUuWhMx
44884	payment	1397	1397	1678	1	1	16706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Hd5G8xQWYud7tC97DccUun62SXLQseGzwSEZGzG5Ub8KB7rH
44885	payment	1397	1397	1678	1	1	16707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtKNstzSLEPqL3VGaY2RtsH81tUm3XngoQzBSagVUyTfsWuPR
44886	delegation	2305	2305	1460	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ85WKNzmZu7r8QabU2YqhKxYxjox8EtRfpjaELqrAW9h38bmmU
44887	payment	2133	2133	1874	1	1	6517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3iBSCb4126vr8wb74McTDsi7zDG5e8tMJvE9DHBTia1z4doW
44888	payment	2133	2133	1874	1	1	6518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRp2JmgM4YmWJ2UfJT6YfSEsUx94rUhmASZEbuGYoAB5yYdJbt
44889	payment	2131	2131	2172	1	1	8	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	Ckpa1Timhtpv9UoMDFkVzEg5bTmQ8Zw2LQZoAqsrfhE5wUZysGebw
44890	payment	2134	2134	1874	1	1	7005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLgip5wJsHzskr7PBDCbYNcv5CUaCVRUdj43numgUFXbQ4JSP
44891	payment	2134	2134	1874	1	1	7006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxWfgZLLtpojQv7rDTRsyPEPJHcNhchbTfMVzcxg5QxFaJUvP
44892	payment	1397	1397	1678	1	1	16708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidQHXXy33SndBGbjnbEoJQQ4aoF4SSEr9euapkC3ZsVS1D1V6
44893	payment	2134	2134	1874	1	1	7007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknKebudYmsEtFfH96HHt2cptTuEYnQGhPW44NUREX75eLyLJT
44894	payment	2133	2133	1874	1	1	6519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeGjZNGhY68YpzxTgUNaCVr1wwercJ4YVmGW7PVgtZfESqwkc
44901	payment	1397	1397	1678	1	1	16711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzAikrnbkaLrERjPipQ2PDmBWyVCQHVF4XEVCvZaycyrdS5Bv
44902	payment	2134	2134	1874	1	1	7010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vmpekiW8cJyjLKWjT6ayKCvaANW49NHE9QXAeKz6RfAoB1BQ
44903	payment	2133	2133	1874	1	1	6522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGr2yMdAQsD4tJg1pK2qjryEvdQS3cHHoTuXqyRykw5p1UBf6m
44912	payment	1397	1397	1678	1	1	16715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqEUKCtCLBwCJWotkFsWFoCUV3nij51UW1kdBMnYqopbyuLEz
44913	payment	2133	2133	1874	1	1	6526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLb8ipS1EeLrxfj8Ce8RZKCqximNgxN7jKZiggB9d3uVq3NPW
44914	payment	2134	2134	1874	1	1	7013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwsX9ZKq8j3bQ8Rkb2GoHStT4DCjwHhCvPm2gvbEha1UYgGt1
44922	payment	1397	1397	1678	1	1	16718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnJyXjhqbtuezX1aCM4i2NENZTWPRwWU5kwLuLwjYtRwM8TtE
44923	payment	1397	1397	1678	1	1	16719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2MviEwiaaMtJdPhDeohVSbZux5ayvy3HjFbRDMRJ1g5YEDh5
44924	payment	2134	2134	1874	1	1	7016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ef7LqVjEpKDxY86rknT8wmx3CRnAGdfeuEmiu4dzR3ddituF
44764	payment	2133	2133	1874	1	1	6479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WR4uj7GjHsuJCRYgaRVtZBoiJRwP8wB2UYAyAXcyQhFHZvkd
44765	payment	2134	2134	1874	1	1	6966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGT6k6Sb8mRdj5Qx5RafLTsCQPa2UWWEoozpc3bq8TpH3YM5mj
44766	payment	2134	2134	1874	1	1	6967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhhVJMFEmXfEkpc6SEDtFRD5nvNqaQuwVpHXvu7m3V51beJbL
44797	payment	1397	1397	1678	1	1	16679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhm9evZ4LMaFjTXweodwp4JLQ3v4rkemdJJa1rMdtKm6rGP5d9
44798	payment	2134	2134	1874	1	1	6978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkUJf6iKzjQFWASNgBenUCL3mKbzFNHxwdnPiBZfZrkhfsrXS
44799	payment	2133	2133	1874	1	1	6490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxao5zshM5x8DsqF2L9nrPDEkWL3AnGUT4dd35nNXPMrwmCYwR
44800	payment	1397	1397	1678	1	1	16680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNYoQWusQXkV7u1z6cars5GULg9awHF2NjziXoVvJCG3redoA
44801	payment	2133	2133	1874	1	1	6491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFrGsg8tfp7vFCzJ2GbLSYeTY9TexpZjb1zUgYbMVVjKLeDuY
44802	payment	2134	2134	1874	1	1	6979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfjFTKF9eK9eJCPEMVtCcWDgpqDj3cRKeLvtCpfAxWKitwVnp
44822	payment	1397	1397	1678	1	1	16687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6hvVc5N7x1uSUEiCfVobhdyRWQTrMgZgqecfaYJQH8FDP1As
44823	payment	2134	2134	1874	1	1	6986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1rro2LNDRHEMDqKNzao4J3fdJ6CuBdnBD61PUgX6XCCQr63V
44824	payment	2133	2133	1874	1	1	6498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNNDuk9AJgCQq1etuAZ1aGknhxYVpsd3gHnFbkrPN2h9SP4Qy
44825	payment	1397	1397	1678	1	1	16688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwj8iFfNQ3e7oAUgmFs2XQMqLkEhyib14PXjvfsWUuvWJk1F9
44826	payment	2134	2134	1874	1	1	6987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMzwAXMnts4tDFyn2X6CfdQwbyqGgSbccvCyhCHBiPxHmnkJi
44827	payment	2133	2133	1874	1	1	6499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8curN6LWbYVLh5vacVFYCa2i6jx1Hn6AGDCGmyBuxQTgTQmZy
44828	payment	1397	1397	1678	1	1	16689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh1YKEyDfLznCnzo2R54X5keTEHNyP29A4syfhyPFg7gPuBuY
44829	payment	1397	1397	1678	1	1	16690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRbQ4rqfDg7SRRZxMD5195xcUgBXyifZuNrupPmuLmdY6DGk6
44830	payment	1397	1397	1678	1	1	16691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVkY9rVU7h1NMNwjRvZLgWBPZRR2h5YzaWAKVx8B7fJUy9Rxw
44831	payment	1397	1397	1678	1	1	16692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6MTjn5BL8NjAkaedh29gSsWqFdTbbTkob8LFGuQp7ioVWmkD
44832	payment	2133	2133	1874	1	1	6500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4VoYVgibDTZgaZv5iFpXdwFsHf6gXWL1YEiietcDqtgzWuZpt
44833	payment	2134	2134	1874	1	1	6988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcY7TvAX7ops4VrDjRcGgjjx1bo5ieUPjV42hdvA9Ng1VCmDB
44834	payment	2134	2134	1874	1	1	6989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCEtwvwZmY1Bzs4tp2aLK65jZrbXWMMK3H6vJKd9Dz4d8ZwAG
44835	payment	2134	2134	1874	1	1	6990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMSFLf46DM12jwdvi3QVAZMFYmKn3MvF12r3gAkfgDZkoKoCP
44836	payment	2134	2134	1874	1	1	6991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkK8xzoB7qxk39SYK2FsDdD8CupGcqS4NAZy4zFmGLGwhapYf
44837	payment	2133	2133	1874	1	1	6501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRpACgynLVeePLqmB4PxVFPvF1jKDLWWvxjXoaKADCFEDjx1M
44838	payment	2133	2133	1874	1	1	6502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCa7Y3KyngAKq9zJUbj7bMY585SdFtpz5fSdYznaHo36wzYkk8
44839	payment	2133	2133	1874	1	1	6503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFVVhNWfo96qnZ5ZtXrF4E32pBA2J3djrqyay9rNM49zKfdPR
44844	payment	1397	1397	1678	1	1	16694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyzQmMirEmHThfJYtb5HpSft2YNf5pbxgVfAtqHnGZyxCE5Ze
44845	payment	1397	1397	1678	1	1	16695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmVhNe6By8aMSri2a1CSpwY5MiZxogG8Wxp7PVHF7TyqHkFVn
44846	payment	2133	2133	1874	1	1	6505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq2kyZLmezbmhM8gSy18gDRJZ5FmHW4PrLubWqghQtsMAxB3Q
44847	payment	2133	2133	1874	1	1	6506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtzsP86YJEHfxb5vthKDiKHNjxK29LHdXQRoTT14oqLGHuT5W
44848	payment	2134	2134	1874	1	1	6993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERGtQiH1R3Fdk2T3MiD4dr1QaGpAUBpmdXTth7B6CegvxWNPT
44849	payment	2134	2134	1874	1	1	6994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjM83euPLLPSgzd2ipnTS8uMPvWfYkrAm1sALBxb9EYVbVrVwA
44866	payment	1397	1397	1678	1	1	16700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpihpUZPzXLdGbbCHq6b8SJ9a5AuHFPQ7wW4RUoiLYoaz7qwTj
44867	payment	2133	2133	1874	1	1	6511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67MAo24Gu5c6CjqnwscLfc4Ce34rHZ1cE6r2Q5FZ9FdwnUEVh
44868	payment	2134	2134	1874	1	1	6999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XgcBuii7Ejq8bXiyB7M9uabab2n5W3nsoLx9AKboDkVVugNi
44875	payment	1397	1397	1678	1	1	16703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCUGZvzxFvMunF7oMYeWSFYuGc1Db9tPX9FRguqWCjjZXtNng
44876	payment	2133	2133	1874	1	1	6514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVDqpvh1XAH3MbuucTK2u8mPfD6NJpewHA8NW2McsZrpbSpS9
44853	payment	2133	2133	1874	1	1	6508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKQkzVuPKR9KgfBk9byb6S13jzdsSsY8DuugDn6edmuQH2C95
44854	payment	2134	2134	1874	1	1	6995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtY7PiSehhz6YXFG3EcumGNo7JigXacotoKa2vk3tqmndxBvr
44855	payment	2134	2134	1874	1	1	6996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbzFBDBFXQrWYwq8QsKmiVSWbUmJQXxNJU365LKUtX11WK5EA
44869	payment	1397	1397	1678	1	1	16701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxmUGZ7PUqiEKuQcX7qKGDiHW3zAxoZGTse7YEZ3da9RjWTBU
44870	payment	2133	2133	1874	1	1	6512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKoAFDa1Kn6Y929rYyTpEhNQq2y8GRs1RWBe89R3S7cj9MokH
44871	payment	2134	2134	1874	1	1	7000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vhqTEwzmRtuY9cTQugcCyCpth75U2tDGMPJxNMXTnmBrh63E
44872	payment	1397	1397	1678	1	1	16702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcDLJRACaeWtz1RGXfD4Qwg6BbF3wkFhHKAuoiNSzw1G3QbQq
44873	payment	2134	2134	1874	1	1	7001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCVar7yxMJxDqKm25HYAqvitW7k6TFN1zNEEGkNFFBK92SLE8
44874	payment	2133	2133	1874	1	1	6513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAZPqjhnQYwL8CBqkfoCuvjzbBuEeo6pdsPr767E7U64enZQu
44881	payment	1397	1397	1678	1	1	16705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7bVM8ZoZYz9c16HXh3go3PSuHMfP628SvvHFTkjoG2LE7BFY
44882	payment	2133	2133	1874	1	1	6516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9vs6tr9kgJLqu5J2m4wyLJsTdrerZ7Wytbqwi2rG37PtBn8W
44883	payment	2134	2134	1874	1	1	7004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Q24rwYdNQZWNDAv9vJ6s5sDCE87NJiFoVBqimQ6XCZkobVko
44898	payment	1397	1397	1678	1	1	16710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtToDWFReaEySCJybw4D4Ut8bfStZXRiPqoj8pgqkZYTwWbJsP
44899	payment	2134	2134	1874	1	1	7009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ229hiHgxDDfn3znnZYnGLukYBSsExH4edP6eQTgQBdHq85Fjc
44900	payment	2133	2133	1874	1	1	6521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRU3w6gyzAYYmQaTGSQvjEBeZLLwj43kGPmsUNRW8jNTdUekg
44907	payment	1397	1397	1678	1	1	16713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGGBMjhKa3YzQJyScBacCHCpwWR2iYxnnFH8KqRWFHVbY6mPu
44908	payment	2133	2133	1874	1	1	6524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAg8za2gsQF7Vd83MyyHmWPePLqpjRxe39T6uBWcUZ2UScGh4k
44909	payment	1397	1397	1678	1	1	16714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8ViUe3bkxWrYaCFnk6jpoB5FxqQA9wWqZu35uZu5wYBbXcPp
44910	payment	2133	2133	1874	1	1	6525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBnTTWLin1AwPhS82sLAnAc9X3YekPtJ5nYptKVzXHWR7T9aV
44911	payment	2134	2134	1874	1	1	7012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX5M3DxGesHKMjvNQUsCCbiKuaX1qCgzbBM4NVbLgamSdC2gn
44931	payment	1397	1397	1678	1	1	16721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAK1qguUUNAcag1dFHrmHRJHC7T91n86hytq6eqkNhy4zBKiF
44932	payment	2133	2133	1874	1	1	6532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpRBDiJBKfSXRet8LLK8tnfD4W3dQ5w1N9EYtMpJBsRx2Rn88
44933	payment	2134	2134	1874	1	1	7019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNjY5b2BdE4WnmRDcivHpuihy7jdpHf4r3FTBPA3YZZUBwJ2m
44944	payment	1397	1397	1678	1	1	16727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXhEmm4VMsb2tbj2TXYAYkpdF94GwSSYnVc2aQopLJN3i2FPJ
44945	payment	1397	1397	1678	1	1	16728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnQn9EHHepwm9GE4P5UFDp4rVjQLLZLADB2R2ynwxGW7SPcWx
44946	payment	1397	1397	1678	1	1	16729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNHFED5DPYgUjFMinHKwyNazytXQMBFZnNF8HRTAexDj9W5tP
44947	payment	1397	1397	1678	1	1	16730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq21aJHDchzcD6Kv8KEr9bJcXMkX9Mc8qLksYq8FaNiADeKz8
44948	payment	2133	2133	1874	1	1	6538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNgEwwgjnAWBtkrR9NeeffSYRUEVFzb4de2eJ59qzSfTtt9Bi
44949	payment	2133	2133	1874	1	1	6539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qg5b7nkSotWeufAy13Ztoa93cqnF9oxpcFxw2ha4Trp5uK78
44950	payment	2133	2133	1874	1	1	6540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHuqEnTjSeCiQXGg6cSj8JBbLJeLwQ5HcHqJwBS1rWh2epwx8
44951	payment	2133	2133	1874	1	1	6541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaBte3n84P5XWLAFbeEtHJedTzzDAxjSVeCVA3NQ8iPc2Zvw4
44952	payment	1397	1397	1678	1	1	16731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgPMKhfBwnadkproRRcj2EcRoFVAjt5QaeN6z3ZCdjc4uMeNE
44953	payment	1397	1397	1678	1	1	16732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgto15JNvPxfVZ1xgMzCEBUxYrEoj5vYZtx89qGuMMdXc1dk4
44954	payment	114	114	2314	1	1	12	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyp4v586yBrdAhUWKNED4tPKHieh53FMzzCZQoEmDiU4aC2ez
44955	payment	301	301	2314	1	1	3	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMY7uvpCnSPLdiWpxaiM29fGaFRFugZoxQXjAddtzB3NoXH419
44956	payment	1397	1397	1678	1	1	16733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX61f7v5ieSBU58fBMuVKyQVPUsMkuftiXsMppDAsvw4kdEr7R
44957	payment	283	283	2314	1	1	2	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMxMxk6QkjEmKkJdyz2cZiq9Ay1BTXdzXMTZg4aN2EFJhmXij
44958	payment	10	10	2314	1	1	2	32000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qug19TD1EdvGed4MWsXvQJrSTvCRV7tjYrqjYPyQRfsZZeRV
44877	payment	2134	2134	1874	1	1	7002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7kMqSisFohAjoCBeFcbek61sixtoBA2sbwTRg3YCwM77VQ8V
44904	payment	1397	1397	1678	1	1	16712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCE9MBmjeQD9acoqsuWNSoJGuLytt9BaVcKDoyrW4DNvrxCPq
44905	payment	2133	2133	1874	1	1	6523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC35WBYZgKHyKvgA2khzNREH6TuFzc8fxHqPzV4M5jrQBtkJ5b
44906	payment	2134	2134	1874	1	1	7011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurYrz2peB6jQpwYzRP8QcT8Cgswtwg1MjdP5MNQ6e2DBzRWca
44918	payment	2133	2133	1874	1	1	6527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkJjSjprK36AN5z5Con7QjktiW2N2modgFbG17ZusdchD58e4
44919	payment	2133	2133	1874	1	1	6528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFrYdTr9dtPsuUmJy5j3Jjjzzp7GHw3wbiiBXbXxkDUEhNecy
44920	payment	2134	2134	1874	1	1	7014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ufnUxS4BychwHrCWKCFCZ928aPKWFKUFXUV6mTnxiRvi7veH
44921	payment	2134	2134	1874	1	1	7015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtjUDGNB7RdTV6NppqsSEwafB4UfgXmQk1Mqqqz7QemfCADp9
44934	payment	1397	1397	1678	1	1	16722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNBacX1kUEdwkVbZqGAdcPQb24W5cBCxhm8GSKUVf7ygQSMmT
44935	payment	2133	2133	1874	1	1	6533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPZw5qxx6SaQYoDPR3rcDZy7VkBkxFKmLDjfX3C19d9i9nRZN
44938	payment	1397	1397	1678	1	1	16724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTS6w7CSA94X62g4jiUy3ruJWDWAfPaSfa8EAYDSABYvnKvf6
44939	payment	1397	1397	1678	1	1	16725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiDiAPCFqG3CfWEXJH99igZNj55ZPjEyuBjjpBBNgPhQdQ6Jc
44940	payment	1397	1397	1678	1	1	16726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3APZffV3ZGZiUP1HC7SBosC7c7rn351KM2CyGzqTW2jvGGuK
44941	payment	2133	2133	1874	1	1	6535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmxRuYqaAB1MRFGtNTFozDjWHXcJEibD5B2rMPAmtiqmj8vGS
44942	payment	2133	2133	1874	1	1	6536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9co9Gi9Qpz2aEgTAG2TxxU42GkF9HCi2dow5z6kpxJdXq97y
44943	payment	2133	2133	1874	1	1	6537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCScsbsbiZbxgBE768ndiCyBXqd7vRrE6nDciV8AFWZt9XiQ93
44966	payment	1397	1397	1678	1	1	16736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXKiTDvxxGPYipryoyyjkACgdKoEZ4zB8iQuCgpJ2bF7Rg7N1
44967	payment	1397	1397	1678	1	1	16737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgW6M8jpPCaC4cLfor2imUtzXc7eL3arh1KSRvK579Dx3xhMv
44968	payment	1397	1397	1678	1	1	16738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKguhvZS7VL9hyekTy8oh8X9BbY35K7qpupCos1TCPpFdEmKS
44969	payment	2133	2133	1874	1	1	6547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTscP2dp4kBtN7Z9ngvADB7dJZ6WvfspNGymnRw4rGQNn7tQU
44970	payment	2133	2133	1874	1	1	6548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqihz6RkWXHEcM2LbedRgPorvCxE1w5DrjYbaiMazz9EVwsw5
44971	payment	2133	2133	1874	1	1	6549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RCWyzezC3iGKE9qrduJ2DMcLKtqnBu37Zub2yiyrRcqcbvFe
44925	payment	2133	2133	1874	1	1	6529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dkish9zLSpuBz8CwEgDoibYt2SnJAU96iTPicwpTQTDnUGNT
44926	payment	2133	2133	1874	1	1	6530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7XisWmuiEbeC7xvpEfTRnDdHLQNU74JYCF87WYh2Ys4Djtk5
44927	payment	2134	2134	1874	1	1	7017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MCTmEF7iVrWiZey4qBiqorsCmDoDGq3YVhBzAYWLHgUTzLHi
44928	payment	1397	1397	1678	1	1	16720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuvoDeSqY324Lk6HWJXMjBEm25SHixwrKCzuFWGG5k6NbFZwF
44929	payment	2134	2134	1874	1	1	7018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXG1hBZVQ28pi9wJ14b9jzJFxPy8VLMmjfJUoTbC4itPCs1aPX
44930	payment	2133	2133	1874	1	1	6531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYro7s8SHjXSui3Zfrh1Kx6SCy8dZ4zhUoKKGToLiiF47AxYf58
44936	payment	1397	1397	1678	1	1	16723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApEZhCV3thmShu8BJM8TNMYZ6PsrNaPd8KZk4atyW8UZEqDNU
44937	payment	2133	2133	1874	1	1	6534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbvaQozR6911WFtFpottHcMFZS2sVN4TXViY68o1T3r5aYixu
44962	payment	1397	1397	1678	1	1	16734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JKamtbzg9vrHNCPU8puH3ePF7amrKF7Es9LLitw5CVa3NaQX
44963	payment	1397	1397	1678	1	1	16735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFQFMTkQHBryf85Vtm7Xc4gsE7SBy9ZcES321Danw1YmBi3oX
44964	payment	2133	2133	1874	1	1	6545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxyV755xjnetFJeBCuN523qgLvSRALUfHMtHuWoCQyDJVn3xKq
44965	payment	2133	2133	1874	1	1	6546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13ww6EX4X1GLz3Fy15cLFFv4WW8krV9577PHwV8GRePtJZNQ8
44959	payment	2133	2133	1874	1	1	6542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdMzHz5vr6cxLnzcv1MjBpGnsfjGMjZeSucvag3bK8ac6psvN
44960	payment	2133	2133	1874	1	1	6543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUc86Rc11DbEByDUgV5YPxuJHXLk1w2tbRbCWH28jt1SvUb3o
44961	payment	2133	2133	1874	1	1	6544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJivaQs7YVdXx4UZH5DtihteVgrnKVUgUgGyukdNDiFkBr6Sp
44972	payment	1397	1397	1678	1	1	16739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JeGnAon5tdaDwc9kgKUHjgPpyDpYGfBKTwqrxnjcMThNVE2f
44973	payment	2133	2133	1874	1	1	6550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4tZLYsmQXnHniLXdJMbi82foxFy3muyuhpTDHfvRqsGUTYrJ
44974	payment	1397	1397	1678	1	1	16740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPApBZ85ruvf1bWSoGHF3eXAefRU6NJV6ws51bc7NvBZ978eu
44975	payment	1397	1397	1678	1	1	16741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYbTL6PfF1Efo1n8wUapfrueTidJC5hjqb3E73qzVZEonYwTL
44976	payment	2133	2133	1874	1	1	6551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY555BYiM5R2mtoh28UpdWVYv6NSGiHw1DwXgtK3TUE91h1Y2p
44977	payment	2133	2133	1874	1	1	6552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7eUFtpCdirnSZ458jSRuuo7LgLgQ7d7iHc3Tt9Z7ayFRK1Pg
44978	payment	1397	1397	1678	1	1	16742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uYEktvfEWMfYDVjMz6j8KaH8RyknkjPyak8fAXfu5MpcVwqm
44979	payment	2133	2133	1874	1	1	6553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGojjWRRCRgYmThUtXU2DzyVLQ7x3kYT2QE9XkBcXrgmHsjz2
44980	payment	1397	1397	1678	1	1	16743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UEa16ny5pxpwQ1VsetysV4th3JdDUzKDoC1X1pxccjGCTvKX
44981	payment	2133	2133	1874	1	1	6554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2se9VhGy3gRKG7obDLdWi8Bgk8nykNTsDPJEpLNwm9D52eWFS
44982	payment	1397	1397	1678	1	1	16744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAuTqKSfaAmfjA1bX3VaktU4tb2gEtWVZq5dENxE45jqdYX8P
44983	payment	2133	2133	1874	1	1	6555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38Bt9ay9GpFLAraaBneHz3jdVoEJjGJXxHbefnZSaruMVRdgy
44984	payment	1397	1397	1678	1	1	16745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY9TgavCu4oxK8NygF5MXHWHve2pYuUqrZu5qddUQddDgn58H
44985	payment	2314	2314	1950	1	1	4	418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmL4N6Yd2kFFyRZt9nfWspyb3NnJgyPBMgUFLsEp4oQrhEqXi
44986	payment	2133	2133	1874	1	1	6556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFViP9YJmNZczjDvaV6ARMYQRWmoyTMoRmemqFzKoSTnhyW9m
44987	payment	1397	1397	1678	1	1	16746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbopVa7hPUoBwYs5YUJ4svA9TpnCc2ekEZ4utsDAvdKu3jkyNN
44988	payment	1397	1397	1678	1	1	16747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4Gox248ZKbyWtK96YiCiQsDmiL2qQkghVkBiHPK527PT1RWN
44989	payment	2133	2133	1874	1	1	6557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLYVvmNafPM8tWJmuyFgTB5KWo8cBPy3F4tMzNj15dJLvxWgz
44990	payment	2133	2133	1874	1	1	6558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSDPu9FuN4mnaUh2fMUTq5YdupdEQWhenmdMPVzB8kEGSm9t3
44991	payment	1397	1397	1678	1	1	16748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjMsYDV8SpZySHaZYWpwLBuWeZBy2Cc9qTxT8Rfpo3zcX6L7z
44992	payment	2133	2133	1874	1	1	6559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MBYK2Krk3s42ocRNg5B4XBnuuwi9xr83CKV8M4YY3xcisLG7
44993	payment	1397	1397	1678	1	1	16749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79mo1CWeV5jbcviEohakcKY5A2b2bfDp72TJHZroRaq2uhXG1
44994	payment	2133	2133	1874	1	1	6560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJRxMVkyZ1QyBvvwV9RDrgCy5puvvfQZ2z2gmvTScyobvLtDm
44995	payment	1397	1397	1678	1	1	16750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBxeGLB9Ebxzi5MnvSY2TTd3JdiQ7ZsDPefn4ZWV6U3uq6CwY
44996	payment	1397	1397	1678	1	1	16751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQexmdrjuLo1WbzpcbiUvrYhmxFXRFymjEWooi8FmJ9KnSqQEG
44997	payment	1397	1397	1678	1	1	16752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoomdgdvwzYCs1inhoydwQv7pRj9uMVsEggq4bj8xMzXAKZMjv
44998	payment	2133	2133	1874	1	1	6561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rXZqkAYCvQzN2EQZCBBBEJke7MEFufKdtciTYiWhZRVonApT
44999	payment	2133	2133	1874	1	1	6562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWiRQSG2W2LfDfEhsX3NZMZid7o1iaJEnPAuNxFRGma7yTLDE
45000	payment	2133	2133	1874	1	1	6563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fz5dwef7hnpyLSHk54xRSMfYdVbaxZfvR2PyR6MrzFVAnmJt
45001	payment	1397	1397	1678	1	1	16753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSaYnsT4qg67x7uW3kmpE9toWjrLcnXH3oRh3YAeSjmXVGGNH
45002	payment	2133	2133	1874	1	1	6564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATZsVStedmjcsM9a3MmMoqfHQNt2mGBGFFVfSqr2aEYZurxbc
45003	payment	1397	1397	1678	1	1	16754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccQAgjnbRCRYpgpxp7QuvU1C9LNNgV3Zf963bGLsnhisVXRRc
45004	payment	2133	2133	1874	1	1	6565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSdPRyMtDM6LDxHQhtzpuYp8wTFw3DkXKsvyFZEe3Nwohy9yb
45005	payment	1397	1397	1678	1	1	16755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgG6TByqLj9cWrj2W7SdY5MD7f2juJdejzS2g4mbsNgLDfEJq7
45006	payment	2133	2133	1874	1	1	6566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLCNvBHRS5McJFrAkceQKXWsLpCcyzWh2AiKRDwx5zEAWR2K9
45007	payment	1397	1397	1678	1	1	16756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtS9xDDbVvSD9KPHBzjTbfrRfaJWwoMUg9NR8X7oC1TS8ykjB
45008	payment	1397	1397	1678	1	1	16757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrwE5ooL9aGYeEDzuNnVT5YEWDAtm3v2KqG5DRccyeeaZnxDB
45009	payment	1397	1397	1678	1	1	16758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1FyPLYkwPMzX66DNn3fzt2fPrW4nm5a4qEvdq9sWtTYZLFhj
45010	payment	1397	1397	1678	1	1	16759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FvVizefPWL9a1YB6W9Yiwf2e9wvYFRbKx2FG2B9Y1n9Lgmp
45011	payment	1397	1397	1678	1	1	16760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDB8UPgu1W3FfiErs7gNuJtt4TV7eDpksde6RzifwnTdGuVEWp
45012	payment	1397	1397	1678	1	1	16761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR62eoBk1AW5Z9JScwfsoKQCCGLiRrQeogSYQ5knvEADFpNQ4A
45013	payment	1397	1397	1678	1	1	16762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGWzmwfx9VSAfA1ySE2EqmsWpkoCdK8vRSgxX9GggnwF44ZGN
45014	payment	2133	2133	1874	1	1	6567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGxYcWt8FBYvoWYByNiRnyUem2FbXTAuVVWiPy7GFuA3Xyd5M
45015	payment	2133	2133	1874	1	1	6568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEfJKcGLTJ38ddQeiXk6w5y4cU75sPKpDA2DuPFoK4X2VxkMb
45016	payment	2133	2133	1874	1	1	6569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaWakmNwVaLSAFuDdwDYeMY3oHpAdjTApJBcNXBvY1fzWbF4t
45017	payment	2133	2133	1874	1	1	6570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGXLUQZuNYU9UYrV4o63yKPsEMqf52ywD2YNnGcrcxgYUUyvo
45018	payment	2133	2133	1874	1	1	6571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3tjDc75B53ghEwufQfR72dGQ76WbJ4ps243qTPqFJSZTHuyJ
45019	payment	2133	2133	1874	1	1	6572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEggA7k5cmv97ZGGcjdrvV5hY1SmwUjkgz1XvE5QfpHCG8aRS
45020	payment	2133	2133	1874	1	1	6573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEy3TqwzWgYnDEFMnSmM8JMTaQa9KvPG36qGQTrkK8zeHgj1Ee
45023	payment	1397	1397	1678	1	1	16764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxefN62FXcqjLNVuC36mKYZd1gjEHYUNRuVvsRJ6oJuN7LFwyP
45024	payment	1397	1397	1678	1	1	16765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4yJr8fawijpJj3qbEELJW5eVUrW2SLhA2dFRRbQsECwmjDCL
45025	payment	2133	2133	1874	1	1	6575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvdrvqj9gkSStaUFdT1KoH4TxhaHuq2EaEbGREz2GjCieLhcQ
45026	payment	2133	2133	1874	1	1	6576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hcSMVFMbBNjGhaFuTebAXKeRz6221RHQR3XcNmPehmHpJ3iB
45027	payment	1397	1397	1678	1	1	16766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnD8JpAKuMZMDbkZnoTB7Cm77DikJyDHDZkgG8G6pDiCVXyHk
45028	payment	2133	2133	1874	1	1	6577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiY7vuXv5QT2ee9kLXxEtXBkTX9Vsrw87zErwnNSfUz9zkx7bP
45035	payment	1397	1397	1678	1	1	16770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBu8nRp3CndnFZ9ryvk1H7X3sFBnrqAur8G173UyneQDzhYoLo
45036	payment	2133	2133	1874	1	1	6581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMpo9NkVcNMvpd4FSopPGUFNsYRNTdrAbiciWp7CdCJmQdr1q
45021	payment	1397	1397	1678	1	1	16763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJohp9aDdtanws4mmkWmakPFP8Zj6ybWjMVxj5K4szP8RLLas
45022	payment	2133	2133	1874	1	1	6574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmuffYCJch8fYXrz94ZFWtWrFUwJ2W9n2XnXA1TGLmr4ovTis
45029	payment	1397	1397	1678	1	1	16767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFiHqWMR5NxqjsjnJpwKRRBE7ZHjDTgvsESsssXZ7seyAfpGA
45030	payment	2133	2133	1874	1	1	6578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTsYps1Lft5VEY5NDGNQqa4yeTka8SULVZ3YqEWoFKnWJzaXV
45031	payment	1397	1397	1678	1	1	16768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamDb1PmmkVLbCzq2Re8vNi7t5huZVUvfWGvWtxhyYDt6yoib2
45032	payment	2133	2133	1874	1	1	6579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYUnW64Ps4w5c7FXfPMs451WqU9EKVGn4muSLD9WxbH3ckXB3
45033	payment	1397	1397	1678	1	1	16769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tNqAmdA56T6QxNAeSWtp3jGkW5gCXe8RSy3P6gmeiWgiemLP
45034	payment	2133	2133	1874	1	1	6580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxYYmv4ZH45KrBX3FBKcvQs2fkn2pfrJshWjDMt7PE9uPjdce
45037	payment	1397	1397	1678	1	1	16771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxSMYkfaMCfgAQKsKG6fGetG5y7fzpQEqmDdwoq68nwFY5FbF
45038	payment	1397	1397	1678	1	1	16772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE96q3XmQKFxVgwUZTgcd28L3J2k19Q6YT4fF8TRGbEH1oEWd2
45039	payment	1397	1397	1678	1	1	16773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVUZdoBpRkNtBeCAbkdEGPurWUJZVWTmEDDQECxqvDs5tYnT3
45040	payment	1397	1397	1678	1	1	16774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mRmnrzEGjSJRiwtbjsahjZurGtqTDQ4twvHUcgf3dKnASXzL
45041	payment	1397	1397	1678	1	1	16775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiEaWEfJbqgq4F6FjU5W9mNswBjmBkyPiiM8kms4qMKqaGcD5
45042	payment	2133	2133	1874	1	1	6582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1khfpYETsDP7JvaDeqtVo6xqkkpa8jVi8umDb3kXqnDXnoDJ1
45043	payment	2133	2133	1874	1	1	6583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR94bLDU2y1BXrnoR33npj4rvXH8tfUFrCAh4xnSVqKhipZS3
45044	payment	2133	2133	1874	1	1	6584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdavHZxyXFJDFQQakgrNmVoKNh4mtvqMWs6bDHsF4UitEicwX
45045	payment	2133	2133	1874	1	1	6585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXhNJRdoQDt3YXG2C41bCVK4tnLWRAnYwREJ846BAJbGmCKNg
45046	payment	2133	2133	1874	1	1	6586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGGtkkzrCP14Gd2hdczt28C4LCu5XYZmwNo5KvAfFQwbH8yE7
45047	payment	1397	1397	1678	1	1	16776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtp6Wty9dERf8yyJivf3RSdPkoKgKYb3MWPeyz9gmfh7WjwCv
45048	payment	2133	2133	1874	1	1	6587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYvpJiVLq7V2cwa9xL7eEJHevhcA2sSNuWGr1Lgd2NmR67Re6
45049	payment	1397	1397	1678	1	1	16777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGeKwnFdFgJqAkuK1FxBGDNeitnohwtCAMWDQd55o3wifBQbM
45050	payment	2133	2133	1874	1	1	6588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSa7B4b3gamNuxVAnVLagP4tBqanfrdvWd4rbNX8QVoHG6NMJ
45051	payment	1397	1397	1678	1	1	16778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVBmFWb4CeTQUuLLGFbm1898kKgo7bbMyjrumkeuC7hftHDBX
45052	payment	2133	2133	1874	1	1	6589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu53ytepnjrCgS82mho7fZFfVPF5UbG8NjTq73MLbsqScZV1CM
45053	payment	1397	1397	1678	1	1	16779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAm9Q5nLK9bhXMTRFGKcxjxWXhNtqoJh3ruKGk4gLBuT2jH6V
45054	payment	2133	2133	1874	1	1	6590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yECTVFfPcJ4uD7DakmxUGeY3J2ahDEZRqVecXebh3kgPYqpX
45055	payment	1397	1397	1678	1	1	16780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nfpXfWKeNu4WZD1XtYoj6JrThQUEXbzqHmg6XjjabyPkGR6A
45056	payment	2133	2133	1874	1	1	6591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq88muETZEzqwqMJDeCG6tLUxK4g3ChGAgyDqCp4H7Zjh2nB3
45057	payment	1397	1397	1678	1	1	16781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeW8QpWQSXUvqZqBKgPvDchp7zmMBQQLYBURarXkLrm88ypXBL
45058	payment	2133	2133	1874	1	1	6592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiTPMDkNkom8tFsHvAt6v5cLAVLrFrz8hrVWQYtAFUvDt5SDk
45059	payment	1397	1397	1678	1	1	16782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcoJKzqM51W9ziun17uhnxTRaVPiUoSg8Zoi29URnuaV8eTsJ
45060	payment	1397	1397	1678	1	1	16783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKCcknMcdYBwPd8j2iVXUL4qgdiFb1iRC2TUTFxVZq4i8oLPi
45061	payment	2133	2133	1874	1	1	6593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbKZShSuJnAr5citg3f5uxkhXW2mbderxTzAdpL4ZZFtmP4FV
45062	payment	2133	2133	1874	1	1	6594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4ddC5mjxy7LFx7ad1LAEt9dFj7HSCZNxo3yhPj4HEZ5cY8qj
45063	payment	1397	1397	1678	1	1	16784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycnA1TyETTwQqS2SqXyFncv3C8Frn2Y7AWY5svwFTPj24T4d2
45064	payment	1397	1397	1678	1	1	16785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNw4FqSi6npAiKdWZG6B62WvbvV8BEhw2eGsnirfhYYRjeucB
45065	payment	1397	1397	1678	1	1	16786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SdpkAQA3RUqD3PPgAk5hYAdbZeyit9G7Eba7Vo488Mjn47zW
45066	payment	2133	2133	1874	1	1	6595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCne9uEbVTTFxEdDckHgAAUnCXg1FiVumsGtk4dnzxTkZr4Zc
45067	payment	2133	2133	1874	1	1	6596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXkYs9T4oRsf9PndsNM1zucdRpcKLtHtiKwDT7JfGQ4XgGZio
45068	payment	2133	2133	1874	1	1	6597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUX86dtKbPZGP62Jcbpc7RctC7jXbzL9a8mrqcb3qNJTxsC6hJ
45069	payment	2318	2318	2152	1	1	0	9990000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9EyXDwbn8bk95YAyTznv9L9HRqZj3p3Yiz1xzNjdaRJTKwVF
45070	payment	1397	1397	1678	1	1	16787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezTK4pE43hrj61JF5nbBGo59Xz4fLqRVCXBTAkbuFhKeNiK6y
45071	payment	2133	2133	1874	1	1	6598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1HDS4eTiunvYEBiR2qGeYwkTdoKqGbYFMx2yEWJ8Piq6Hkk6
45072	payment	1397	1397	1678	1	1	16788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsW4NdXZFgPHN4x5G2VVJfUq8Qwwt2Jc7XTkKb6tBnPGu1u8D
45073	payment	1397	1397	1678	1	1	16789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPFrLRMwnDz4LwFWP8mZmCEUd48ymHUJMFCfqtwfBDpuF82za
45074	payment	2133	2133	1874	1	1	6599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyi5UmMEjxwju2HBiyLdCBvV5iup7B5ozXAQX7ueXWZ9sVkD6W
45075	payment	2133	2133	1874	1	1	6600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYPdPMieB1incLwrkHKs93RJrDJkQidG6b6EpBP2AzqyxdxM9
45093	payment	1397	1397	1678	1	1	16798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxz6dLRdyfvsn1kcqhPGtWuzqVBq7ayLCC86HMMDpr6KzGHEDX
45094	payment	1397	1397	1678	1	1	16799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpBnoB62jMosobChYdJPr6ZKCykpUd9hN9fZxKJseUBHaF6kJ
45095	payment	2133	2133	1874	1	1	6609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS44EmDqumRDYy5h72vY5dRVWE97PBc9txY7vNcxNoyAowdKoH
45096	payment	2133	2133	1874	1	1	6610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMB6HPkTvtDmXGtyb1xm1GTdKQALVEx4UDzTyhsDMTkU9PaERq
45112	payment	1397	1397	1678	1	1	16806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwTbpRTffExKHXBv5DWbkHU7aPpiKHqXp8veniyx4EPceyoSr
45113	payment	1397	1397	1678	1	1	16807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1X3oXsXsSzk4kB47286UGB14VovTLk52SJuW3tgGynxt1Lww
45114	payment	2134	2134	1874	1	1	7021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG861EdVDFwKnjToBP4GRfwn1Ncff8TgCUSBgaQzNoSCt8AikR
45115	payment	2134	2134	1874	1	1	7022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGgL8o8oiWtWAk3yajHxLQynmcDeJT66ruDGguyQ58wDQKwnA
45116	payment	2133	2133	1874	1	1	6617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Fc6hpgw1qUaCA37ACs1wEb4gaJrvtsnfk79FHiY3MCfSkBhs
45117	payment	2133	2133	1874	1	1	6618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjE3XPcg1fPtKzrNwqbFvzD343Brc6VGvNjNb7x5375NyJZ1dR
45134	payment	1397	1397	1678	1	1	16813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qDa9BFwPSVaFKRNp4PsQpDBES5oTz4ia3TERMZmHn9Km9yy4
45135	payment	1397	1397	1678	1	1	16814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGBX5AmTJeAsoSLUUjhg6Cey1oHtN4hkS3e2harG9D7dHTJFxC
45136	payment	2133	2133	1874	1	1	6624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKoeqnoJg9buaQqc2rbzBCh7fvbzqduAyiFndMUJ4GQWoha3u
45137	payment	2134	2134	1874	1	1	7028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZqNm8ZCQXSt3EU6A8aLq1KGFFrEm4tixEv8jZxyKcFbniP1r
45138	payment	2134	2134	1874	1	1	7029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxq3eYsSDDQKmSH5stuitxzLoEoMZjDJdvvEk9ABBT35Ht5uC
45139	payment	2133	2133	1874	1	1	6625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfVKLn5HojhYpn1K4qY5o9TDGNdhYSYy7x6FgqQ5zxeYs4tC1
45149	payment	1397	1397	1678	1	1	16818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4adi9usCM6V8bDWM325Th3Y4RVSExWPogUdNuCKAh6FVoumRg
45150	payment	1397	1397	1678	1	1	16819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG19AcGf1GU7hGHgs8d6irBF2u7DMYdvNXpZEFLbsWN8croypY
45151	payment	2134	2134	1874	1	1	7033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfAqMSszi47zHdfBj87BWoWAhkPfdkxLe4pBWgc4yaNnW9uTR
45152	payment	2134	2134	1874	1	1	7034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcoz2Aa9bcPk6DJCgF18VstbjpLLqHRR4MmFg4TPzFQZdacft
45153	payment	2133	2133	1874	1	1	6629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nwWJuPJjZ2XKA3GSMjfKvoRa2Tj4LQBnbjArP8eFuqpvwZjR
45154	payment	2133	2133	1874	1	1	6630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArrx4RDUE6ee3dQKPZy7cX3BvbvjmgvEiozbyxdvby6M2ZEU4
45170	payment	1397	1397	1678	1	1	16825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWQW2751d6Tn9Huf7oDMp1WgjnpUCa73svDeq6GxEDSHxZeoc
45171	payment	2134	2134	1874	1	1	7040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpU2gwCz5aqCdkZ3qxX4Eo6nrbmEBM1x6PbHiVMPReW5CVNCeG
45172	payment	2133	2133	1874	1	1	6636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HFy17bHU8UD1rctpVBUxe6wBen93YMLsYcTEa4axX9K47TLX
45176	payment	1397	1397	1678	1	1	16827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3b2mjgjSGNUPLnH63t5F9dkx9fV9GnVUhJaRA4sWf5LFqaLt9
45177	payment	2133	2133	1874	1	1	6638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV5YfXGFqKBd2h7BVCyW4mfdDgAwyUWfQUGEnaHFDDqcTK8Ed
45178	payment	2134	2134	1874	1	1	7042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAGL8NCGsi9WLiyjwtLwWUHbUs71R7kMxTHNSBdfWmdFCsrrw
45185	payment	1397	1397	1678	1	1	16830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUybLxAHN13nQjEwdDy74wE8frvbfxm6NexrkndBYVEbAUj8yz
45186	payment	2133	2133	1874	1	1	6641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYN3W9AmRVC7J7zj3AXWdA7F2MhB2f9C6NYNnv8oKuZMH8yYFP
45187	payment	2134	2134	1874	1	1	7045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wpxdCM5L3vhMEXWtv4Rg1eBPPvok3ati2uLNwfkEF4LUzwDU
45209	payment	1397	1397	1678	1	1	16838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttmiFVJEjmqwqQttAFXsQqU8JfUXxfMeSxtzLK1NapbsNM2kJ
45210	payment	2134	2134	1874	1	1	7053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZrNwjopXSsTWmNT6JSxECZGbqKeNtnb1L8exFK8gSCmuhPdZ
45211	payment	2133	2133	1874	1	1	6649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLinPT1YF4SL57sfipXdq3npSZAatr3QnB2NzBpbsfK4Ji7kq
45221	payment	1397	1397	1678	1	1	16842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJoonyCtMvfpnNMixBSmej1TJ4A9qnYMkenkri5w1RS1YSeY6
45076	payment	1397	1397	1678	1	1	16790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLzyQRCTaNe3ResAC3dGXpMs3qqiNGX87gCqDBqWqGgzM45QJ
45077	payment	2133	2133	1874	1	1	6601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToZJmiqkE15Zssok8P638K64kvhj7vvQzmeANaSmFEXUviLUj
45078	payment	1397	1397	1678	1	1	16791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ665rHDWyR7zdhfBFVQR7B76EiuavSY6Ak99YTca8XoxHS9mJ
45079	payment	1397	1397	1678	1	1	16792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEuqq37Yq8vMGJdFswvk15uKENyj3xCF1nXBZUiPD7V8H14hN
45080	payment	2133	2133	1874	1	1	6602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDy9KtpNBQebS7as4521fg7Ugxj68SAFpJJC7xpTSQhtTqJdM1
45081	payment	2133	2133	1874	1	1	6603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yruunnb4yrqt7s7YUqm8q32EfaMJvP64z3exGzAwohhAyX41
45082	delegation	2317	2317	1600	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZRzeE3pfDCG4kcbwsQ346PZo8pbZnmXEmAP8HzxqFCStVnBh
45083	payment	1397	1397	1678	1	1	16793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkndChzTv4x2vbdEzKXsK6YDb3FDEjeBp8DuDffkjgw84pYXo
45084	payment	1397	1397	1678	1	1	16794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPs4QxCiZCbrw9PkrtJVFaeZxcHqQUviHXwFtxJqh24ThUPcU
45085	payment	1397	1397	1678	1	1	16795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVreUVaKYSakE8qAnsJa2cde9e9Vhog7qNAsrV7Ubd5WqTBwN
45086	payment	2133	2133	1874	1	1	6604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsCH1KdwRP1czXJPZko5kkzELSKzQqnnaX63yZ2ZrL6iY5Wta
45087	payment	2133	2133	1874	1	1	6605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMamLfz99PkdJLNd7NKo63srwPz3rLiQpV3KMGkvLNc1RXmUd
45088	payment	2133	2133	1874	1	1	6606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfH63FQitYLyqeK2VzzCXNzsuUNBHuumPxuWSmTYTCH8vkgr6
45097	payment	1397	1397	1678	1	1	16800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xmxYvhv71NUwpqmZWZC96Q7rwTaBYuxzyYEqZrn5iVJMTcPW
45098	payment	2133	2133	1874	1	1	6611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4JRt178psudL7FK9kCpEVCuEj4kbvYzENApqHVPjMYPjCQ8B
45104	payment	1397	1397	1678	1	1	16803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQjvjQnyBhRcaxHC4BWdkC65qYDX8xnffggLKaScYXsZdAV56
45105	payment	2133	2133	1874	1	1	6614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9DEv3LZLa5eTzYg7APXkTQfezAh4Ma5Ktgvm6roJsL8tuYuW
45118	payment	1397	1397	1678	1	1	16808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8uXb8hqkyhZ6JqBF3sov3kxwZFpAdyuZQBeEmLenzfTm9hiY
45119	payment	2133	2133	1874	1	1	6619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCTtCnFAW2ybGUo4AYEb42UcofV7eH23EnMBKA7B3DQbmvdH1
45120	payment	2134	2134	1874	1	1	7023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLzzXbQmN7ww3h5VqZ9yGrYYxFzCwPdZbYjVar6umc5pLZxgx
45121	payment	1397	1397	1678	1	1	16809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hDtez8AVZ9g1xExTj56gCaRCZQTPd5YkwiNgkF7NZUJGEgEK
45122	payment	121	121	1816	1	1	0	0	1000000	\N	E4YrncE7KmCzc13wLELNtP13WuZbmfVpopmebkPd4TMFfeUfmfdRz	CkpZDxauv3k7whnXNQa3NFMa2xfRHCqUYkUYBcQjUiR5vrZsWNHQv
45123	payment	2134	2134	1874	1	1	7024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsx7ohmv4CKg79ffFmS1oMSRi7wKhji7FpMa4GggmHUAzz9pDL
45124	payment	2133	2133	1874	1	1	6620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGB6sELhHYwLXp4TJNZMGYFgAuofS9RTTaQ7MRDRVsKqGnb2gi
45128	payment	1397	1397	1678	1	1	16811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXAcKMjzAwJzrTairebNCBAddx2h2DXFFe5KyaiAhp9N4VnWe
45129	payment	1397	1397	1678	1	1	16812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDe8VuxXiNj7vFARKV5AeNAFFk5g7JPw49eNwGHAwJR1JYEt6
45130	payment	2133	2133	1874	1	1	6622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWuyL5eg3gyzqsecz92x6TDKKKrSu1oHAX6zMSzKCpWhh1piJ
45131	payment	2134	2134	1874	1	1	7026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaoGyV3a3BVtpQkRNXdrBMFinZ2e5dxNrmn5Hc4iZRxCtGHkd
45132	payment	2134	2134	1874	1	1	7027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaM6afCHiqn5Y4CYnhxRMFXAy9ZrpZfx3UtDfPsZ9Tg6MaxNBj
45133	payment	2133	2133	1874	1	1	6623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA93jdCJzfbAkh74ZYsvgQa6UbZw16KHUUpoR2S87f6FQAsSib
45140	payment	1397	1397	1678	1	1	16815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWfmft3a5dQjaNcB3tFmxUSnr4HkJQ3vf8NWbFGFgaKZY3rYz
45141	payment	1397	1397	1678	1	1	16816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUn4MgHo1trnbSc3YdzwN82zgMMw1pLNAtSkJuEoi4fq6mVN2Z
45142	payment	2134	2134	1874	1	1	7030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepbnixpTJm4Xz2FMujMGZ64TmtPiTMFnSTcTTgF3Sn5FbjeLi
45143	payment	2134	2134	1874	1	1	7031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL3nobFTPss5MueUaL7tSLD6yR82oD67baoM78L7UWeWZXMCP
45144	payment	2133	2133	1874	1	1	6626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVpNtEWpA9FLv3LsenaAKvmj1p2LMNW2L4QNTmER3qLYVaSbw
45145	payment	2133	2133	1874	1	1	6627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrd9k7CEdCiG2faoMB9qpio8qrntwu5J2h1ZzK1dmn1Fb2nu4
45155	payment	1397	1397	1678	1	1	16820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5WSGPt3KCCbDivpLwFW8nszGBFeVnTCuihbGpYTZfecZ3TNg
45156	payment	2134	2134	1874	1	1	7035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdvJJqz4NMQEAVYobwDMeniR2W5viabTG2agkhMdCoyAbREt8
45089	payment	1397	1397	1678	1	1	16796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCwnPh8JEvzRNSrXLFg5S1tj6vEGtiqr48qdKTqDrNDJvdmp4
45090	payment	1397	1397	1678	1	1	16797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1oZmzFxRbkHWLTLQrNpxd5vvGjAoC9qA749r1n9pPodcHCav
45091	payment	2133	2133	1874	1	1	6607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZ2BSC7cpnVRCbqgQTcRau7dWBcY7yhqnpYdz6rVPEAVC74ty
45092	payment	2133	2133	1874	1	1	6608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoy1rxRuEafQrFsb6vKLkWx8J4w3FfbYmhe3xQfXumbNoS6k4j
45099	payment	1397	1397	1678	1	1	16801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG83tc3v3ns8Q9D4FtTXNgtTK7pc628cQsGg9di7dcS6GAm1va
45100	payment	1397	1397	1678	1	1	16802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwEnd2P7GQEd4n1nzRSgbC56F79Shw4iCC6U5gHw3Qco7qutu
45101	payment	2133	2133	1874	1	1	6612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsesenNwjHq2DkgtrK8muQ8jxTnTmRuLDBAX3umbmBUFkrZJEs
45102	payment	2133	2133	1874	1	1	6613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhKobVyHoJjwkfHpuqiQjovLmNK9mUpQpmcQtKziAHi9Tjxrt
45103	payment	329	329	2385	1	1	5	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSukuko1rTZme291wKPJ7gxePX3iy8bJz9hAkrXciztNJiTWV
45106	payment	1397	1397	1678	1	1	16804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNjqtWK7mbJYVVT8CzXXnvdYayzsWkZ7Ez6T8rGLnEL8hVpq5
45107	payment	2385	2385	121	1	1	0	100000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQ8HFbpaxAJi2gpfaXRAvtPMnSKFKcFpm1dW1e2QBNy4vQYXt
45108	payment	2133	2133	1874	1	1	6615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDFzewKXabxZ9rTMmMg9GQoH7uxgtGdioAqC57o7xXAXay6SK
45109	payment	1397	1397	1678	1	1	16805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXikb2xNq3znTYri6qztmTszL4ywtVJVww6cKpy3BBKK1n1kYx
45110	payment	2134	2134	1874	1	1	7020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXPheFQYoYHrqu2Pgfx3NBrWFVK83Aqm71nBjGvNGuBMf99ef
45111	payment	2133	2133	1874	1	1	6616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKoaNS92tkkXbZD9KePTYz2xYBDmQve7Sn8VbiyGD9sx8R4XN
45125	payment	1397	1397	1678	1	1	16810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVawnvYReqQFPc5P4eYfZBRqEpEJXKD4uyuBCc5GHcbFSpQSrN
45126	payment	2133	2133	1874	1	1	6621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVf1xjTousrzkPYmsttNaFgVXPCxjytCX7VgDgrqDAXXTmaz1K
45127	payment	2134	2134	1874	1	1	7025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5e4vWnjRFxZNuUm6V85s63Y95Ro7zFrWW5VdVdKuWsxvdZ6P
45146	payment	1397	1397	1678	1	1	16817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYda5w7BweqjsxJNgavjmCeWsiwnmHAWE23vKFNLeFoxKzWG3N7
45147	payment	2134	2134	1874	1	1	7032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6otrrhbCqEFemnfNHDHv73PYL6aZCsgEPZfWgmyoiW3WH84f
45148	payment	2133	2133	1874	1	1	6628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DrwDDYLhcEnGwJ5tPTBodS2DHJYtQejdW9oLqzvdY3CbYmfb
45158	payment	1397	1397	1678	1	1	16821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMgF6eMep5LvSUSqEpTq7MSswJZXHkechvkEmy4f9iKJxAEGR
45159	payment	1397	1397	1678	1	1	16822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJrTrNBrFwm3wecTvMYfYHvXS2oMh9TgM1yyHUTEZEkNKTr4j
45160	payment	2133	2133	1874	1	1	6632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZKL46C9FK3LohJsDH1hJoENyHxHtPR9QEQd9g7siUWabPtig
45161	payment	2134	2134	1874	1	1	7036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugrwgKsgd6Ky7FGVdapwqWoF2f1wiWs9RxBcptqFXJWFnwdpc
45162	payment	2134	2134	1874	1	1	7037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCRBB5wAAh7iCK7JWFAP9pBCbu9cyWZ78dV6GrRJGBP6XtRHo
45163	payment	2133	2133	1874	1	1	6633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6rgrgq4CzZM5YGrp18r3qHWFTtz1qBhrUGhYLeo7VxqL4n5D
45167	payment	1397	1397	1678	1	1	16824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJs3k3NWv4MA9Zo6CEP7r8ARQjVxkVYozLoiTMY9arq8iXVVs
45168	payment	2134	2134	1874	1	1	7039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGyQA2FLAFUjH4hp5rJ95Wd41oW1vAQztVTqrZW8AM4BxsYxF
45169	payment	2133	2133	1874	1	1	6635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zpqZvtjFSMM83faax83mAy2o8GMgg6v8jSMgVZtyb4pSuVaR
45173	payment	1397	1397	1678	1	1	16826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrnN9Jdxp7Qwz5ZHVFPWtad6desq6cdqdsfC9ZN9rMBeLHVjk
45174	payment	2134	2134	1874	1	1	7041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUP2cgS6CxT9Dgv2L2yhyrLmKJiUZCY4pmAj6Bqs7mEDB6ViM
45175	payment	2133	2133	1874	1	1	6637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnrMaLxf7sc14JM9yv62L4Uke1Djq4UjYXnoos8bGPhMib8gRT
45179	payment	1397	1397	1678	1	1	16828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1v28FF6eCM1LaFrjZzXpbHdtosBu6auRNnFBkbvohAR2mZEDk
45180	payment	2133	2133	1874	1	1	6639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepzxUqSrxnzT38VAJnh7qHnQoKj9dnGzAqE95Ffz26tEL3wC4
45181	payment	2134	2134	1874	1	1	7043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMJY1vs1xmjAJhobd5aLNB7WWRG14Hiq6TPhEMZnFvrGdjxdJ
45191	payment	1397	1397	1678	1	1	16832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxgMGjZW1MeA5vhRnUpRAZTTHGFiDU9mnoFYHKi9o99K7oXdy
45192	payment	1397	1397	1678	1	1	16833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fPxp8AvUCm1oHAwPTVjn8v3QMN5FW1wKCUnZHfn39eKJUanj
45157	payment	2133	2133	1874	1	1	6631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4MAGrUbNzpZBzQWZR5unLbXBpN4dcoP2Kd7eLRJru1dZB9Gu
45164	payment	1397	1397	1678	1	1	16823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUk6ESXaJRDjrcdWrprPbtt3ENrAXuiPUgr7AzFQW7Y6cCyr9
45165	payment	2133	2133	1874	1	1	6634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSaNz2TxrMf77PhouYqPP9GW21rKwQVRBKCf5Eb6sSMfcTKmk
45166	payment	2134	2134	1874	1	1	7038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QP1KhpCkyDpsaekZS6uvpGJE9j5F6mkfc52DJikH53NqVcNX
45182	payment	1397	1397	1678	1	1	16829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3giQRBByLcT98wby5QjGKytYo1TZmhtorAZRxYJhBXgP26gvs
45183	payment	2134	2134	1874	1	1	7044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNxwN2tN4BzkxJYz8h4ZBaoYQ8eUkoWHJMrDRzL2cQ633jRUL
45184	payment	2133	2133	1874	1	1	6640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9JQqFLHet8z7DDE7NbzJgBRpCetK8P8yWyHbUitVKFkMsQHF
45188	payment	1397	1397	1678	1	1	16831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZr5hMo99vhSfAu386DbGV7HMQWKq47pfdbr49dZoj7sGSTEm
45189	payment	2134	2134	1874	1	1	7046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWd2HbyTAdC8LK9keyHMjV2iGzDBnn9tuDU2a1XtLXmpjDLoJW
45190	payment	2133	2133	1874	1	1	6642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcW8G2gS4NvWxcgF6UPxnKdSvv6gufB9kdg4AYkTqumHJt7erT
45212	payment	1397	1397	1678	1	1	16839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpNXq8yKnQRfvHei369YmfpS4AzcsVBp1NuhC6Nv8sgDm3BDM
45213	payment	2134	2134	1874	1	1	7054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhZGnf7QnCgMenkn9cdP4YMBWeZQzXwsx9dKJ4zaMMPex8rJC
45214	payment	2133	2133	1874	1	1	6650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcCRhHGPN4oEnn4V7d8hzecxHK6WbwXGwjuW5wbKhjg2TCWxL
45242	payment	1397	1397	1678	1	1	16849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeuy9Uf83MKYiCDuwNBCWJdkU9muzQ4Cn52azUzbCTta5pvdp
45243	payment	2133	2133	1874	1	1	6660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwpXJgji1yJnGNH1crpGpC9SyJWN5W9eZatgZQYzzgjAwp6q
45244	payment	2134	2134	1874	1	1	7064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd8iA7555PWUvRc9yiT3VNJqgdMQXf3Rz3huF8zR81LQH8YSG
45245	payment	1397	1397	1678	1	1	16850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qbBX5QoZijBrJwJ2m2MceJKsJ7MeCya23ki64yChrbf8oCGc
45246	payment	2133	2133	1874	1	1	6661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AEeSFzscyoMCN59bb51dB5vEGxz9KuSe9RfnWrH7mAhfG891
45247	payment	2134	2134	1874	1	1	7065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBCDrNSUUvKufGYxJMhw1Xr3wZiMEw3UkVptCDzrEw7Qr8immq
45248	payment	1397	1397	1678	1	1	16851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAZndvyxEN9mPowyxuXXhpazZ5qaQsuqrAknaSFKPCeh36pLh
45249	payment	2133	2133	1874	1	1	6662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cRXpv7qTyrLT4a1JLgqa2tAVkWAHMjt5fLJaGRUjqmUcenCf
45250	payment	2134	2134	1874	1	1	7066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCJD3LyqXTaxammfnNfz3eTCBLxtzNAMsm3q7tJ42FnFzgjAV
45254	payment	1397	1397	1678	1	1	16853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGdeShpd9yyMJ6FM9JbiAgvdskDQwnqHRZWp5ia18WA1YroRA
45255	payment	1397	1397	1678	1	1	16854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAeBV6BtsEkP18HMVFQkppMJ3N9s6546gtKdQfSTLgES3S1j6
45256	payment	2134	2134	1874	1	1	7068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXN9fi3S5mUmVvDwMJ13rJQQro3ePJnVSPwkXusRV1WjaR1gQ
45257	payment	2134	2134	1874	1	1	7069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq5vDiuwjJ8HzYhqGdKEbm7AEvPddoZNzX9abJND2n5hwEytm
45258	payment	2133	2133	1874	1	1	6664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKd1U52PVJr9PKRB3Q6L13tbJYLw4xN8P1GfiSVohWCmnHcJ15
45259	payment	2133	2133	1874	1	1	6665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhzwWLdRT2JUhH2RQK63FopfhA6zZKMjyTDAwJL83nvbbbWCk
45272	payment	1397	1397	1678	1	1	16859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wQxEQBUhc48ue5FCNH7Y3V7kQ8A5pGzw1YZyxZ3TwGYGfy7r
45273	payment	2134	2134	1874	1	1	7074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6Wpaox8nzZHA7MkJdnHXthmTWZVRJEqCKkE91Sh65g7pxdVt
45274	payment	2133	2133	1874	1	1	6670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBNQPeXftAp8zPSYYUEyv2ciUs5T4rNcziBrV6mMMDGGuRfUJ
45278	payment	1397	1397	1678	1	1	16861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLq4nuVR8mLpn3tdR8Y3WfYqf1YYsBhyikLP4mEPFBrkpNqSR
45279	payment	2134	2134	1874	1	1	7076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoXcZ4MVwBd5kZSvBWh3SB4VYUrKZBqCZ1Rkw4aNEZhMdqaHd
45280	payment	2133	2133	1874	1	1	6672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76qfvkKdiQHnn1zZ823kKrKWACKxhTeXFQPhBovoNXoBnLTed
45292	payment	1397	1397	1678	1	1	16865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPc2hJ62LKMgdZaeoud2AHZT9XTB2ovcxQToLYr9z6EZUGTTg
45293	payment	2134	2134	1874	1	1	7080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCYTixWXL2zGvk4XrjXYjBQuC58eMSJ7pBemu38Bh7ATF7xFJ
45294	payment	2133	2133	1874	1	1	6676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvueYtT6xUtxPo7YgCWLuUqvMJjT9jbTXsYKjsbwNr1XhSD5v
45304	payment	1397	1397	1678	1	1	16869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCfzQrJUWzyVQTnD2Rzpus9uBqEpMVGeNctZLW76BNGxEM3MG
45193	payment	1397	1397	1678	1	1	16834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUJ479a46wPPfJqYkjEm7MX6UJo3tmFi6pUYGVs7Yiagjd8ew
45194	payment	1397	1397	1678	1	1	16835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmeh4PAcurN6iVEQiaQKy5f3hhHHn1sZrZQwKmotFvr6cDcuGh
45195	payment	2134	2134	1874	1	1	7047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNnsGnvxAwMWS9gjz9pRx3oPtSgvz5WdwusN1gpQcieGNTiXB
45196	payment	2133	2133	1874	1	1	6643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eSMrmBefKjLmrD5czJMa5s93DbcgZXpMWmH1fa4C5eNVqDcu
45197	payment	2133	2133	1874	1	1	6644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMf1ds2sfhEYbFVzJsFoXYohcVeQiJMZSeLHayRK1hnBqnxpd
45198	payment	2133	2133	1874	1	1	6645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHywQuWAX8wu4HygXBSKmJCssb8E7v1BWenxb59Pe2k9jLB8P
45199	payment	2133	2133	1874	1	1	6646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZAsTvQzCyJvbpXwwfxdD2vs2vUvyXTu5SugF6BamXvg7p3ad
45200	payment	2134	2134	1874	1	1	7048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcFQVAMDYuDVr9Y6bRjLDSSAosjEV2GqKaWKdaGBdg2PdE4Qu
45201	payment	2134	2134	1874	1	1	7049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtEsTbGuiz2mSqNnkCsfLoPEnmSDfiNNAGrFsZhRRTNQ6jaUB
45202	payment	2134	2134	1874	1	1	7050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZvjKQ4qaryYy8cMJAJsLmEQChS6v2MFHkNG2aiuyNwYp4o1Q
45203	payment	1397	1397	1678	1	1	16836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBWWTMiV2RxMAV85ycFqehjGq61JVRrefEhE7EmW4DxP2ZW7D
45204	payment	2134	2134	1874	1	1	7051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwPxHyX3xtZx8xWcfEpgC9rs2j1jfJdEaNUHpWTZhu1Hgzpki
45205	payment	2133	2133	1874	1	1	6647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTbzJqor7WyRKxwKGuA8yKzoPYzF2KfNnYLzto5RJ8qu1Lnwn
45206	payment	1397	1397	1678	1	1	16837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqg6SvGAA6poy7nWaKxLiCHAgCJNT7EwCvt1pxms54DM6n9poP
45207	payment	2133	2133	1874	1	1	6648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9RnfB5L21mUb4YVmzfd7CzLdoRmk92JM2LFyDtZzLmvxB3L8
45208	payment	2134	2134	1874	1	1	7052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjD25e4F44xWqtaWAfofzBgBcTG1KjSEVBWmtyqYuEyEctQDfe
45215	payment	1397	1397	1678	1	1	16840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5LPWvju9BcNdvdSGMNZr9UzXEmX9T7wJhdSaC3ncpn3NEchU
45216	payment	1397	1397	1678	1	1	16841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsW4uLt75pjmAPb8CteBKUkmH5AfeMbbPmy2vKty8AXn1sgy6i
45217	payment	2134	2134	1874	1	1	7055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQ2phgBZefgvHvM2oPcgmqiqNjSZCTgjwUz1VAGj11MTXFdV9
45218	payment	2133	2133	1874	1	1	6651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWHbBfk9BwawsuQZY99o61zinn3UW6Z1fxFL32bRMvsS2tatb
45219	payment	2133	2133	1874	1	1	6652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iDmebgSYK2YeStWd6JoFyEzSRrVN7EFfj9FoWTHVAq6giE66
45220	payment	2134	2134	1874	1	1	7056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXEoC4hZ25eyGgtjQkSJpZ9PrgejdoAfkPABTKv6GeUpSJVSm
45233	payment	1397	1397	1678	1	1	16846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLm1HRivoFw1PN94ht4PnhRGiU7pzMWuf4Aqc16xiRyx7TP6Y
45234	payment	1397	1397	1678	1	1	16847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqrcf4mYEitPfLhDLkSZ2He6dd6AtxWbP76BXqj8NnwA3Vefc
45235	payment	2134	2134	1874	1	1	7061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfjaMmKHRNGgACrK1itvYwGUhXEo17kZXZv1Y5VLhWiYEKSto
45236	payment	2133	2133	1874	1	1	6657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbz2o4FuzDF1uEJ5aZBRM4AHJkvJRohpyAQ599W6iX4QMm7ndW
45237	payment	2133	2133	1874	1	1	6658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5V9wAJG3JvqxLt4Vp6ZT4TURxaTHbCdcTwe6rLmXwmwoFnMn
45238	payment	2134	2134	1874	1	1	7062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuab692MkvYzqX2tzWTLDEpxWaBngdabC9MV1NsuvYAcvsjES
45251	payment	1397	1397	1678	1	1	16852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnEX1zpManFdg2SxZmPogauNUUNTetw4jGc1wAYPj8BdvWMqh
45252	payment	2134	2134	1874	1	1	7067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZqRtAKWPsaKdafsvBGxqSFsxgmjd7tkcQoNfo9CSGvUxqjeE
45253	payment	2133	2133	1874	1	1	6663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kVtZwviT9Tz3YAvT5QHm6GDE2MkbVdwFT2cGU49TJEG9vHjK
45263	payment	1397	1397	1678	1	1	16856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Gt1HPZw3dmSJmTuwvmrntxL1v6eBZouXKSfYa9WW2MRcZCAb
45264	payment	1397	1397	1678	1	1	16857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7FhcqsSEq1ryYwR3Nbr2xCTMzzXsfPJAF3qjJKvCz2fRmM1W
45265	payment	2134	2134	1874	1	1	7071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfHVwXgkdDKKc4da197wAdxWSdw9q1ATX6Ku2a9GqnwrcAdSh
45266	payment	2133	2133	1874	1	1	6667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5c3kFBwqUwgREu7eewtkcQZcFik9LctBx5mAiPbKPKGcR96Y
45267	payment	2133	2133	1874	1	1	6668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HKXKspr3KNyAiJEe63L3VEn97QwE752rcxhgxemYG6G3kEQP
45268	payment	2134	2134	1874	1	1	7072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvuE94TgBDXcwDuW59Ji6ZmwaMHMJuaY1wWDR6yyH7m7hvmQhx
45281	payment	1397	1397	1678	1	1	16862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCchDwZCw8c5zbyS9tXrDUCbqpTRKJHcfXa9UhfmsodnZ3gwt
45222	payment	2134	2134	1874	1	1	7057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNuQNSMw1pJNxZHCYD8NCawin9nmvYifn1kTBC1um4m87imdWG
45223	payment	2133	2133	1874	1	1	6653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39SGCLpWyv2VAPPSQYGGPqsWqemSNraWEBwcXqfCR1X3obE2F
45224	payment	1397	1397	1678	1	1	16843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruYpbdRTG5E2ruueBAiUK8yjKSBuahF2B2Kz6WGnBA1Daa2dp
45225	payment	1397	1397	1678	1	1	16844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGcbemuMoSuxW55ZaN38QUN1jB8MSAAHF4uSP1Z9fh8MKK3GW
45226	payment	1397	1397	1678	1	1	16845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFkQUMbCddRmLcsSoF73VRBbYjE4GuSDEijFCxkepQbCZStLF
45227	payment	2133	2133	1874	1	1	6654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXjkYqMUP9nAskAfDP9UhNvba6g8xDi1VszDiqDx3ozvA2QVB
45228	payment	2134	2134	1874	1	1	7058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13kPq3asZTUEiEUW4Y32uwcmkXiPt57XLJQYeHJAdwCwHXRTP
45229	payment	2134	2134	1874	1	1	7059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsfNiVw19apeJhMu8AL1mNcYVaFVwX8wXsXdHnyPzEypKNaMB
45230	payment	2134	2134	1874	1	1	7060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vrtajWNGhQg8TzuzHNoXgULRWEF4a7rBGz1Qsprqy96FLqH9
45231	payment	2133	2133	1874	1	1	6655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PwzG2Zrj9ap5mbyWogVUcYhLEFpNmPPa6pJKqPtm1geWWRWk
45232	payment	2133	2133	1874	1	1	6656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qufwTULdsWcLwnkwiKUAQWY2SJhr9bqJd7ecSzkrDy5NMBbX
45239	payment	1397	1397	1678	1	1	16848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMSEJBytvF8p1WAF9gSLo1JfW1EMBguD6K6YH9Bbn6Ev9qByB
45240	payment	2133	2133	1874	1	1	6659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYow7pqcsWd7c75SdaUgwJng6h4BqnR59MfpgwPqryHzLQSPt
45241	payment	2134	2134	1874	1	1	7063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57Yw8Rk8K9TnECWy4Ls4pGgbb8r3N6rtqp3qJWwe14brvF5b4
45260	payment	1397	1397	1678	1	1	16855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwTJmmjRyoi2SAiKnGRWxYZNMkJmSVL4cRDPXe7dqjx6rgyLo
45261	payment	2133	2133	1874	1	1	6666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFyHHsuMR6dQRU8bxMwMExTXq6MxRmtctnqdbLgadZ8qAnWHV
45262	payment	2134	2134	1874	1	1	7070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPc8JqGHen7jFgeGyZSUU1dZB9oiTXkgFaXttsQNWP3Nz2M6r
45269	payment	1397	1397	1678	1	1	16858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfQHan6CFHJczciL4TATqwYVUdUuaR1xcFTZYvYke3pzYE1jW
45270	payment	2134	2134	1874	1	1	7073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqAAxpz2X68T6EsH5BUCPcrsR9C8eu63e7mLMFmKHDGh5eHH9
45271	payment	2133	2133	1874	1	1	6669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLqQKvR48tbSFxZCrFSdqodiKEMamExNGfWPKFbD1wRtMFjBC
45275	payment	1397	1397	1678	1	1	16860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqLiLG91r69j8yWULVThxfzQEuWRDRoQGd4NS9wU8bpScbDeC
45276	payment	2134	2134	1874	1	1	7075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTs5vBj9xoXCEM2ZNjW4N3ujHiocrnhU6BuNXaNq6SHMuTDD5n
45277	payment	2133	2133	1874	1	1	6671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMboHeTW2YFzqBVoswgNzdR89DTDku37pK2eRYV93ubHeRrYzY
45285	payment	1397	1397	1678	1	1	16863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdwqCLrSMDqjJNmGYZKYJEiNdZ5LXvScV6MoR5bvJxayq4xBW
45286	payment	1397	1397	1678	1	1	16864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G2DbsnnG5STiDWDv25bVV17tZmE6ok5wvtk1r16D8TnuHfjE
45287	payment	2351	2351	2355	1	1	3	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXQ1M9Q4bqWpygjvLcEQmykMDaQcRe9NXitg7LnNRYdohkvv2
45288	payment	2133	2133	1874	1	1	6674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeh6vhUNW8QK6kmCyzerviYBsGmEUYdzaDX5HhvhBwGvva5xF
45289	payment	2133	2133	1874	1	1	6675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxC7NbijF7x28UKQa722vXkFLHDaYARHasqqMjgawEpESXjBN
45290	payment	2134	2134	1874	1	1	7078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JLL4JEY9AyS2MdoqwevYe7ac6z2ojsyScsS1Y7iTe5NsGsCV
45291	payment	2134	2134	1874	1	1	7079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRNwKMVxU3mrJk1uRg4Aemhhm5oUvEb2H9QMVwLTrcjiEoQRY
45298	payment	1397	1397	1678	1	1	16867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAfsexJ3jxLz6kFRwUSHAWBTbUoDuUXbBuwFqANDViRQchdQd
45299	payment	2133	2133	1874	1	1	6678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xWESRSnoiLEHv6FTjCyBRyAfN32gT6PRtTKcnWRKUHsU6B26
45300	payment	2134	2134	1874	1	1	7082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKRPLvZzxR2rgyfvKySMRYgWDqoW8uxWcWrnvh1H6vUHaT1Es
45318	payment	1397	1397	1678	1	1	16873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw96yJAubWFy1FPRKWNAm5qDYKZgrY8GjHdrqFumMgZZkWcts
45319	payment	2134	2134	1874	1	1	7089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rb28qaSkAozEWjp7xHWPqxL83bbwMG47LygQuyFmW17mc2UN
45320	payment	2133	2133	1874	1	1	6685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfzRPVU9L1XaVHNhtbkbWnT4J39QK8mAgckhbac9MhK1fCWso
45330	payment	1397	1397	1678	1	1	16877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDkLgt1UzWiJnW2HdFtgbkEm7rz8J3vywAdopRbtdERRTZVVyt
45331	payment	2134	2134	1874	1	1	7093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcn1XmKyv5dNEWU4Fb8zoJ4mJ8iVFDafLZxjNUd55JMC3wiBNG
45282	payment	2134	2134	1874	1	1	7077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDgW9S5rujEq5tDC8R3bJg4tRnZ7rDS8aPLtzx18ddi93aFfA
45283	payment	1726	1726	2386	1	1	8338	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZagk5LgLze5v31j2rzacDSfWUx4B9xN1P35JbzkUTpkV5GrjuC
45284	payment	2133	2133	1874	1	1	6673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjNL2j5SfvK9JmgQzKti5Uk9eqkSoHQBeQ8pj91YGD4t41jC1
45295	payment	1397	1397	1678	1	1	16866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7tBLrYgHdBftL5LUeNaFSMFKDC9Pwqcxt6FyD4QQCtPB5N8k
45296	payment	2134	2134	1874	1	1	7081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmtNjiNEN93oCP17ki2k7teJja489iLUWqdv6Vvr32wpM4zGS
45297	payment	2133	2133	1874	1	1	6677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51GrpM8EWeQUM91F9QCkW49ctQYUnfHbQgwQZdWSmsELnVTRL
45301	payment	1397	1397	1678	1	1	16868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpWeJR79myvcyo3mFqrGBhTC825sBnrcKMyDbAcd7nmu3fEjf
45302	payment	2133	2133	1874	1	1	6679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDETpWbbJQymxhCY6eWiAs6jYCTZE7y3uaQ3abLBQXdN4WASV
45303	payment	2134	2134	1874	1	1	7083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzm8u3fKZpKkQWwq7e8WoJ3VWqK1czsXySpo1YDhfCFRw2Z1m
45307	payment	1397	1397	1678	1	1	16870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9Cc9xeCdkmbGsvWwp1nd1JSRoediGpHDNfTC9omYfjiiCZnW
45308	payment	2134	2134	1874	1	1	7085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6M1KC7QqDnm3tRvXMvypJCjVGaVTUGQthaJcrfj7aNNd4eSxM
45309	payment	2133	2133	1874	1	1	6681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzohn2LYH6QPfYzzxfJTaLrMgJtX6bh2B4tjbnhDb26pfnuJHv
45310	payment	1397	1397	1678	1	1	16871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5kwgxfqSwwmdPyVaRjmWBYeQ5iBC6oDEpmQ25Kf2vagFoYit
45311	payment	1397	1397	1678	1	1	16872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutRkBapoRGZe63vCshEMp7K1an1vdLzYK1j3CSzoDTshAd5b2
45312	payment	2133	2133	1874	1	1	6682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLMyJDmdhWZweodS5PbSHMAKcXnK6NVS1cdEDw3kWvP7h5Bbu
45313	payment	2134	2134	1874	1	1	7086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoXYMY3UioNPNY6YayNX2ppXacgoqhivmQR5JAJfdYmmf8xcQ
45314	payment	2134	2134	1874	1	1	7087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxMJctx3ciai4zyFhdWLiFcBXj13sByp1gzpvN6d1U4DB9xhF
45315	payment	2134	2134	1874	1	1	7088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrE8MPZXVDVVhZTv4i9PV26MpcoWPG6ihSUBtG2GBN2dhXxyyE
45316	payment	2133	2133	1874	1	1	6683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58EWEwnsWJopWfS3JPnS29rEXK6tAWkKf82Ra1yoVZDtba67p
45317	payment	2133	2133	1874	1	1	6684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGodfNjkPq2NHKrxYJhijbLBdeJW97rFLQ6Xgp5B8CbUkWkuPY
45321	payment	1397	1397	1678	1	1	16874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZesYbo3QHbt5vR3D4V8wic86v5VG8x3PB4bCsvjtg88teySg
45322	payment	1397	1397	1678	1	1	16875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pxgqBpJeDcRUCHckYKkDm2iSLfZnsS8HSwYSQvbbKWLSHxNZ
45323	payment	1397	1397	1678	1	1	16876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMpbcVnSTDvBMYkBdUZz5YcX7YChtGFX4YLaD9jAWNGCEWcjy
45324	payment	2134	2134	1874	1	1	7090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgwo6BTJ91wM4vGjnU6jXcAXa9MRnZMHhgh9hrzYnbZuhyDe7
45325	payment	2133	2133	1874	1	1	6686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpze2umsUBFhRqZknLUKAEpn3sUi1uTpit7AGYkAA4Do4exYwJ
45326	payment	2133	2133	1874	1	1	6687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9TrQueaHdpXwd7pSFj4oZA1YFyJV6KavG6w8ctVQ7P8LgWZN
45327	payment	2133	2133	1874	1	1	6688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUaoeHLzkjYSqXUt5w2a3ftWLfJ6k8Yk3XDBZKHeCabzXNZNq
45328	payment	2134	2134	1874	1	1	7091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCwsmcSf27SFvhsHtYxZ4dnsuqWDQtwX2Dn5MSU1Uzuovq54B
45329	payment	2134	2134	1874	1	1	7092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6fRJxR4S3WYDT6uHbvES3eSF62qg2Du1A9awdhCqxFPA2HdA
45342	payment	1397	1397	1678	1	1	16881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2odEvmrnE3WcTqkZqm5iXH2vxr3mwJ9druGhXiBrHEVWHLuy
45343	payment	2134	2134	1874	1	1	7097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR8r8TkAAC7TutC1Zfb15JEqFJpZHWvenawkQAD4SZKq5xQ7v
45344	payment	2133	2133	1874	1	1	6693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV9m8nPvpSUyJT9e74oV81uQBEgwgtPGSoTdNC36g4Hafi2Ck
45345	payment	1397	1397	1678	1	1	16882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRy98k3cW3wWvWUCAhvmXDpufPz2iRAGPDV5K2HR7969CeJU4
45346	payment	2133	2133	1874	1	1	6694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHES6k2Vii4PPooGsSc31bQBdaM7htFdbAKWa2mRbujzP4uda
45347	payment	2134	2134	1874	1	1	7098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRLN5wncU9KAMLkkNRJLxh9koeWiA5xN84NjCBCCqQPnRoBR3
45373	payment	1397	1397	1678	1	1	16891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmFgAe5WmY2w1Ahr6kP7cknvtUJYiLrg2tu3AmemQWRfWNhsj
45374	payment	2133	2133	1874	1	1	6703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5vRFanfC6qSnvHcXs5XyJVjf8quHcyHNTCfp7dyNPeTwRhJP
45375	payment	2134	2134	1874	1	1	7107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpq81agnUNBeL4GWhujd4n17xEmeKvFQWcMdfGSgAGcDT2K9s
45305	payment	2134	2134	1874	1	1	7084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsys5pXCB3VKc2WC62Me1Qiaxv68mqv5LvQZmN2dgnfcvzTjX
45306	payment	2133	2133	1874	1	1	6680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfyG2tFyw8vDLRL9ih48Wgeq7i7EQDEzTkPTzAdC1fUQSV6SD
45333	payment	1397	1397	1678	1	1	16878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPPKzsKhMbSssC2mMxscC3RtAQsU6rXLgwC5Vfpvq9DA75BxQ
45334	payment	1397	1397	1678	1	1	16879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59K1zzu74GnbP9gCE39i19gpiibEo4KU9eJSSxRpe5AgGJ3F1
45335	payment	1397	1397	1678	1	1	16880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVghAWNMh1o9tJjEJYqRbhXnXsWkB5kz8PxNsk5p3QftBFbAVx
45336	payment	2134	2134	1874	1	1	7094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLM2sMK5iAGrA8xPttcknfKEmmkbEZf53TLbVhqxag56ge4Y7
45337	payment	2134	2134	1874	1	1	7095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4zWPHY9i612zfdG9U5euAJt4UXrjpuficWAz9HCZfBYRheNz
45338	payment	2134	2134	1874	1	1	7096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFnFbXYfDxrTfwnXVQS7g2mimetfQiS21GhS27oEdcvYVrZcr
45339	payment	2133	2133	1874	1	1	6690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDXCe3EkwJY4GUiGWt2imuWfC1nYxEMEDkS9UYpDpVUUsR5tG
45340	payment	2133	2133	1874	1	1	6691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCCMqNPbWyDwWxaMVegnZ9Q57rxwzXWhGSP93uNqdbwSSquLP
45341	payment	2133	2133	1874	1	1	6692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXajsLf35HJYfRdMgbPG1Gv1s7QT1XVJ5zyhbiDrHfpbKTg6cW
45351	payment	1397	1397	1678	1	1	16884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzoMasLWap3SuwhPFMp8j8n14cwLp1AKfJVaJq4hmGC4GrbFr
45352	payment	2134	2134	1874	1	1	7100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBgBrjXVxTE9wyZ374ZHSrrPL2n7aHHzcziNUCdvu9EreyfTS
45353	payment	2133	2133	1874	1	1	6696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMFMrWbXJ8XhPa6PrkeUNczH5vchy8f1PosjYhhB8rFzQkaF4
45354	payment	1397	1397	1678	1	1	16885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33DqLGP9FvTbr6BsthLjPYm4t4ZrL4XVeVAtWfcvqx6HHKyD7
45355	payment	1397	1397	1678	1	1	16886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCquRQDPEsUuoxLCT9ERmXQDoAqFZHtAx4Qk3C7WAZ1QZEqCF
45356	payment	1521	1521	1931	1	1	7	2880000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiSsw2e7nHYiMUsjuXLaJcV3QT6DXwbpsitkhWXn4dSvqD339
45357	payment	2133	2133	1874	1	1	6697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB99b1ee1wgGiyD8HqhrchZTP4u4ocnAbGTnBZ3vo6dBeKGWqm
45358	payment	2133	2133	1874	1	1	6698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3afg48V2dHy9NB8j7cG8fXfw4wEjVWM5X9ZyJ2MR8CddQsvVt
45359	payment	2134	2134	1874	1	1	7101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTzWtCsTyTuGxbvja4jx82DtsigiNgf72wd5G4wgpBv8vi4iG
45360	payment	2134	2134	1874	1	1	7102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdVGvZvgLHCHVbMTf2cTxqDnhxA15bfEY43nKZT7usb5pNzAJ
45361	payment	1397	1397	1678	1	1	16887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeeQgxB1BcH8S7BA7abhdwGqbtWDZ5thPQc4PCobnSSZnXb4q3
45362	payment	2133	2133	1874	1	1	6699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZEKzfYQfd2VQvh3AyJWXcVJVNVx2r7M54QMMdTA8MQdvSbe6
45363	payment	2134	2134	1874	1	1	7103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANjpusmhciMms5jsxTGxFabUotxHBzsvmot64kG8ZuuV4bxgz
45367	payment	1397	1397	1678	1	1	16889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5N3psnR5mhj3kgaTP6vyyxGQdH74XVvCqWDbTvBGYR5H9FPbX
45368	payment	1397	1397	1678	1	1	16890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoJYbjwBw5NV92dGoE3cMsnPTex2pE7bM55w583oAwekXCG3C
45369	payment	2134	2134	1874	1	1	7105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV32mQGqvkmytn4SrWfLp7Ha4grKN8wY6BRdQMLx3UEFR2oNet
45370	payment	2134	2134	1874	1	1	7106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38FQG2bUeobMqpyUENG5ABoCp93nnuSzNeax9yrFfEJJSJn9D
45371	payment	2133	2133	1874	1	1	6701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGKYB7VmwaJ2S98StBktH2Lf5ss2ZRBRgFUg8VQVwcNjcaLJd
45372	payment	2133	2133	1874	1	1	6702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rN98tN9socpd97MWzTCwDutydMkcrTRuPUAu96wwrG5JAH2C
45379	payment	1397	1397	1678	1	1	16893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55J7sqWN8bSR1XZQBBNKZ3pRAx4g1xWVKLaeBczw5rVuQDpNP
45380	payment	2134	2134	1874	1	1	7109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3hNBBbGXq4m2Pdd9eTM5Wyn7N4H72cdFS7kiTUU7dDrUYgJ8
45381	payment	2133	2133	1874	1	1	6705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJJxwFAfNzDvjMTH2rkGt2oJFNy4MEpc5K338TG75x5Ncffa8
45404	payment	1397	1397	1678	1	1	16900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHXgmpUG6dgbkEqiogxKru6Hs7CLaZbeYMNseRykZgXiUH2pT
45405	payment	1397	1397	1678	1	1	16901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1pAPC5jAJAQeKzKDLDt6kzCGT4k1LcLM4nTHjdV6BFRj3ay5
45406	payment	2133	2133	1874	1	1	6712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgX8bbFMBA89Fvqn6huXEXSPV6imSHKDSm3iB14YtVNnN8ooN
45407	payment	2134	2134	1874	1	1	7116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi36nmLXDqD2LxJUb9uBwC8YADuk7ZN166AuohAdZ1u6Z3GqTR
45408	payment	2134	2134	1874	1	1	7117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDpqHZJog1tEcANRtechgnLEsTtuwo14qUZXpiup5cn5WZxDg
45332	payment	2133	2133	1874	1	1	6689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbM7zHkXVNpC687pjPdLhc9QgAvvpt2VLSW1rabB2YWd3eU6oq
45348	payment	1397	1397	1678	1	1	16883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYJJzjr9KWFQuetfYhhfoAwvD8C1TS7iCJiAUMcoUq35pKAmx
45349	payment	2133	2133	1874	1	1	6695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UK8u7Nbu3Rt2CFCWaGFo8n3wx6PUxsqJnFbsYspL4WRL7Uzt
45350	payment	2134	2134	1874	1	1	7099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUNrQJhghM5rqWncG2c5FitnAdk3mcuN7JexAiwbKBVL3rFge
45364	payment	1397	1397	1678	1	1	16888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkU8BdRcwKLjbAuctUTiAMYpohUDBbFZFeiHM1GdGSwYJY8uX
45365	payment	2134	2134	1874	1	1	7104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcEzcGr2Ka9GVWCFbaRAN8FQhGWxS6hWU7vVaqn8fDP3qaAwR
45366	payment	2133	2133	1874	1	1	6700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45mWUtoASv6uNDgHrvYkQezF3mJBVEZ2Bk3DMLLU2ALKuUkoT
45376	payment	1397	1397	1678	1	1	16892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvJ4BqWBZn7zbxugY5Xuizva1KnJYw5541XziH2E9k28B11ZL
45377	payment	2133	2133	1874	1	1	6704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG68bYSbcLbYLmsXARAeyVBAZjL6NgQ6hXnt6cL8TPmvxdS5sk
45378	payment	2134	2134	1874	1	1	7108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6uCzw9g62mjRTb8eoBHWVkSAAERFUn96r7aZUvc5BK6Awb8Z
45401	payment	1397	1397	1678	1	1	16899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZaPyc8Xv4NWU2p5jaQoXtK52vn7DGeWBcekwMu4yJG2gKRBt
45402	payment	2134	2134	1874	1	1	7115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz4oYqaqHLCjK7youGkruEa6xQJbgwPhqiBdBhdTMC8tVz8zv
45403	payment	2133	2133	1874	1	1	6711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZJQQXHjCrxX58L8RHAKVCPcz3VYqFMWvLqRFSKsXCyHHvPv4
45425	payment	1397	1397	1678	1	1	16907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudt2d7cwifSiNyrCQDuFdHFQLhBjpMZ11eawY6kiCgVFGjzGX
45426	payment	1397	1397	1678	1	1	16908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRYy432WY4wsXELBFUbBjpsvaEeVzQivhsDVx2t1dzGUbc4eS
45427	payment	2134	2134	1874	1	1	7122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnaYFJqa3H9hh8kUfDRAmDLdcrXPM4a6udi7k9kY43gqtDVUq
45428	payment	2134	2134	1874	1	1	7123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfuAhwzZ6AGH89fqvbRTDyLKqdciPVRm5oCYkwmfsufb45H3w
45429	payment	2133	2133	1874	1	1	6719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSw2RsHjas3wjwh1VJyW3XyDkKTXhWb7YXxnGfw4EJbv33FMY
45430	payment	2133	2133	1874	1	1	6720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyEQTkkyALA1C7ahPJuudwoyHsSNrJ4E1cRoP6Bnr8BT7NERe
45437	payment	1397	1397	1678	1	1	16911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFsH9YwrJyAAZrPc253a9VpHJQhcYx16cN5YhwR3QQsy2dGNx
45438	payment	2134	2134	1874	1	1	7126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnz2SHK1JLF2WYRuAixXoF2kvq2CWWguQEgZUDACh9EPQXXmFU
45439	payment	2133	2133	1874	1	1	6723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUiHBZx3jvVVnuK5jmRiFMX4vBeiy9JPVjuYubJRgZh282wbc
45443	payment	1397	1397	1678	1	1	16913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vg21FdUQs7Fcf6Ef93zpNuHS2vJLqNnGa6TUauhGmwFJX5U9
45444	payment	2134	2134	1874	1	1	7128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2BdBrATFv2CUBYJZ1mhn4Dq1dfTcnz82pnvUwobVo3ep8LBt
45445	payment	2133	2133	1874	1	1	6725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGL3CUHMubrDuXKHT35QtVW6TgMTTit7W11KcWGompophaUWMk
45450	payment	1397	1397	1678	1	1	16915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXegu1Lfgv6nM77xknyycfut4USo8f9wWRfMQgGZsjoBfHruY4
45451	payment	2133	2133	1874	1	1	6727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXr5sSbLyTR8FBsUM856zvxVJ2bA6QE7U7ReVvaCYL4e4RW2Q
45452	payment	2134	2134	1874	1	1	7130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMuctBSJu2ZhHPbo9rkTEDvWj1wYaGGcwCSjyoyrq3iN8Mabp
45475	payment	1397	1397	1678	1	1	16923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLWNwfbpPT58et6hq7dcpFLRw2a3gVKhRTJuenfK5JeX9Hf9i
45476	payment	1397	1397	1678	1	1	16924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaruM3dEW2yGACQXobgkdBRCF7SFNqu52NVwwC6rKJyvysnrz
45477	payment	2133	2133	1874	1	1	6734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnP3NXWJnGSKk3Aug2jx1oQvz8aeopJebxyxKeC8cY6znqLrK
45478	payment	2133	2133	1874	1	1	6735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkhGRn2hE6Gx5PhQ2t7F1SEjV7Wj374aeJXrQohQCruwnxB1G
45479	payment	2134	2134	1874	1	1	7138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2VGXaXNBqmdYDPdWJozn925RdrT5nvWaanrVNfQUjiZNFx4yW
45480	payment	2134	2134	1874	1	1	7139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYK4GT9Xau2iJ3wa5sMN3qE1f1whUZaZ1eBJ89LBxoAiCWSDx
45491	payment	1397	1397	1678	1	1	16928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eeGCw7ZYS1dzhb2R4knmAvmTsTJkjcUTTT1AMixbwYpHLucZ
45492	payment	1397	1397	1678	1	1	16929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbZfNkMa6z6yCtNcjiy22MTPP6tCXrCETPCFxvr3Wwc44bUaN
45493	payment	2134	2134	1874	1	1	7143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCdpcfkxHYqMwVHxja1eXxZvLCmTQcWs3Z2Kra28HUsQy36FW
45494	payment	2133	2133	1874	1	1	6739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh87Xyvs4GNg6His9uDgzxYSsKmKCiYYzLzkhB46AuD9wgfm2e
45382	payment	1397	1397	1678	1	1	16894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkxQMdodk8mJH3jcLKw9g9jw9jd3qG5YqBCTQikTiFvGcw3my
45383	payment	1397	1397	1678	1	1	16895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEGBpT6HmosZ6EQUDhHjuQ3jkBRFv5FWtD9eh6ZLxwxwkPMJL
45384	payment	1397	1397	1678	1	1	16896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvmxnuuWvv7hqXrGdVvvYd1Fbaudj4WDSmZXTd3jzZ1mw84X4
45385	payment	1397	1397	1678	1	1	16897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujTCubv1nnTJn8fxo2hedJrDqyU6TmMXjg9ecJj2F1kE3CxVk
45386	payment	1397	1397	1678	1	1	16898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbHEENvZLQoghSLR7xH1iPQa83GSY4asdJ9EoA9GrEhzpAnSL
45387	payment	2133	2133	1874	1	1	6706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq79D85p4ZFLxvy5hdQ6MRSeHb26hV8RtEiRakGycBqTCoQEYp
45388	payment	1726	1726	1865	1	1	8339	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrzyH93JK1FWqCAXSLqtiQshMRsm2FLAaQXVGGA89p6xPhprkQ
45389	payment	2133	2133	1874	1	1	6707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ACQHGHMQb87VTyGBAFBzDA3wHu4Vva3AiuZoiAmMgMQRUAa1
45390	payment	2133	2133	1874	1	1	6708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3w1fGJXFCzMJLfLL4MNSDyfMcfSsSiEmziX36h8axMatxwnkn
45391	payment	1726	1726	2387	1	1	8340	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ5YsDoLMZXpbZLcnEmwAbqXGshCWSVnRn8NuK7HoRb9kNPXQeN
45392	payment	1726	1726	2388	1	1	8341	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRubX99rPLA1Rz54Aqt5DdauLkpCVR96KEPRjxsgvpi7rC7Toc
45393	payment	1726	1726	2389	1	1	8342	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYx3eW25JE8NKZ7FWwxdJFF8qX7ZwoBzw9J2zjguQqY6dhKuH7p
45394	payment	2134	2134	1874	1	1	7110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hd4Fj8pU1RdjeN9ksGnDK8F6tpXsoEpbustKMTw3Knp8SB9N
45395	payment	2134	2134	1874	1	1	7111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uQ26ny8JV4WZy7adMRKrPrkSdvCUSzEjVqB9Q9Yk7W9P3TNy
45396	payment	2134	2134	1874	1	1	7112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgN4JzLH1XfjT3Q8SuEUJA2Gn68gz5tQtW3FVEBgUeK29L6j1
45397	payment	2134	2134	1874	1	1	7113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFC8ZiEbCaPohHCs1DvU7QsJKvRTk3MSKq6MCKzAQXfGAqJJM
45398	payment	2134	2134	1874	1	1	7114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ijwbnWFsJ3YmXb9hqTqgJ5b9AZvsdQLyDZXrUN3D5LyPE7is
45399	payment	2133	2133	1874	1	1	6709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRWSBAuwitq1VNw89ym8kDpVvQYCmUvDbvVRVkqLhSv8icSsT
45400	payment	2133	2133	1874	1	1	6710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpZ6CPcPUx89Dyyp3nq2B25gghxCXHA3ajXAdYgBgFnjQB2sz
45410	payment	1397	1397	1678	1	1	16902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EsTWhjWP4J1VPwoifi83tDWjZcXJe3tPVYsHEsS3aGAmDQ91
45411	payment	2133	2133	1874	1	1	6714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7XDwUFLvb9cSoXimxN1ughKPRpQHSLQffhUfhBtv4ZPxReZd
45412	payment	2134	2134	1874	1	1	7118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD4aJRTVPBgUf9twdAbqGdbXvzt31zbetsXpWcBxqHA7y7jEA
45413	payment	1397	1397	1678	1	1	16903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQX8BQRXzs2rvCTzv66Zdb4c1s1jTcg1c3PXRT1hjU9dK36vd
45414	payment	1397	1397	1678	1	1	16904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57JaTeTCxd76y5FKWFSJRj1QLkFVfWYe5qd2Cf91Kq64RxP9F
45415	payment	2133	2133	1874	1	1	6715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfn7BTnbeSCLEYPC5PwTU9ZG4ju8UccRNh9pNuZgDg9SvG2XPm
45416	payment	2133	2133	1874	1	1	6716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnK7aA7qACisAhSyDwHpKQGh3wM4RdQBWTzq1gxc17od1o93SZ
45417	payment	2134	2134	1874	1	1	7119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqd1TwVVYkntVynCAwR1Y97zAV1fTptaXZtC18Dj84DFXhNGoB
45418	payment	2134	2134	1874	1	1	7120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZQLRC2J5ZnZBuxy8JEczi1mJ11stWEihQg2SByJPyN6LGssB
45422	payment	1397	1397	1678	1	1	16906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxe2hhwAxrUUHYMFALAGLJ2H3cKAb6kfxnHya6tSHNtuj6nWXB
45423	payment	1474	1474	2192	1	1	29	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ547jGPZUKyUAtjH8eCzMuq7zaETsKceuLfUcRmvfBbgtnbLRf
45424	payment	2133	2133	1874	1	1	6718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAg6TXZRtdA7SppzunujTVwDLANx8X5VPAWDGcfNp6vgRDFghn
45465	payment	1397	1397	1678	1	1	16920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoD781UnnQMFe5rVhxvpyZnNsQZy9Gcj5mMPwF9ueZ8LCXkwi
45466	payment	2133	2133	1874	1	1	6731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjMZZTMqrmeQPJQ2vb3hpi3Espwvef1JXT6f6qYRLCTe6mtu2
45467	payment	2134	2134	1874	1	1	7135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbV3SqsELKjKvaVt9cMC6DG1NJs8K7jBzAauFxcxB4a8jWAeg
45487	payment	1397	1397	1678	1	1	16927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyJAhKRPBC6bWnH4kyxLRbZWXG2nogXWtBGYBMSZ2Mz5Uegtm
45488	payment	2134	2134	1874	1	1	7142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuCizEVTeniDdx4rbSArWhv6BvjbYU3xz7QRde922v3f99Wzk
45489	payment	2133	2133	1874	1	1	6738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdTphzeXKtQHvKTQyLYduSX859uyjNiqszCuXkK5Lx8o2SvQ9
45490	payment	1726	1726	2391	1	1	8343	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpVtTfxAcnqBWJbR3GMGWTS8mm5cqevh89mpeT3sEvd6jA5CnC
45409	payment	2133	2133	1874	1	1	6713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDYC1ArkG8zPguXomwXry7ELg7RHC8GCHfC3LNZ8hzonC8Ahe
45419	payment	1397	1397	1678	1	1	16905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEKxLnbCY2Y74r53FnifAXfHBdSqtRtEKzWSixyZMF5RnS49k
45420	payment	2134	2134	1874	1	1	7121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobtztJ8Z1wzehszTUoYKfZD7NkPc1puxTzitfKBMdFs6DWi4d
45421	payment	2133	2133	1874	1	1	6717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6S2ZQaS2HLoUvTFpSPR6fXYfbHvAxaQ3qKNVPd5BWjiojvDav
45431	payment	1397	1397	1678	1	1	16909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVtsyCAjGaptDqxRbhZvft15x4sMkSnpDfehyF2dQte1tDvHM
45432	payment	2133	2133	1874	1	1	6721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJjTTYKXK43sMJnuF1sCFQX6eFXGEwmU584bz2ve8YKt36sXc
45433	payment	2134	2134	1874	1	1	7124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfd3xbXd996brYeDajCnrLgSqmxMtJPaTbrS4Y56Xsf18LaBo
45434	payment	1397	1397	1678	1	1	16910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46vJboKGYmTBFkn44h8Q8QegKuKG4G7dBfU4YDLL4NJZKfJeb
45435	payment	2133	2133	1874	1	1	6722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5a2qDBvg3UuUrCkjsvTVNdteGJTFBzGAYciUXbf2BGo4dh9U
45436	payment	2134	2134	1874	1	1	7125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSujd1qQ5iqRiq2VX5WXQNFzp711GdsLU6u3XNTqds8pk8TMj
45440	payment	1397	1397	1678	1	1	16912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZBQBMWhVEpuZfuZCgiSyETWjLN4qWULALPFqPoLEQw6w7mZv
45441	payment	2134	2134	1874	1	1	7127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXuTZ21MmkzoL83DJaGzT5FGipQfwAm2RWkZhKAs6W1y3AAi7
45442	payment	2133	2133	1874	1	1	6724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9FUxLHo67hwxnYi7fiZ4BoSoPBs8fgBzd8Xx1TB3Q6N42Ztc
45446	payment	1397	1397	1678	1	1	16914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBci2sMFxUAM3c2Wqoy2gUVVKhNMaD5H2M1ksovu3dWyvk9SMQ
45447	delegation	2199	2199	289	1	1	0	\N	10000000	\N	E4YhEahnSRexdoJXcr6exArn6qvcafbWdvicynXNWHzD2j5k8yCWo	CkpZVuPnv6r9tLQT6HAzpxi8MjGJkH6FVmRDkrH1hUE1hKdWKfQ8B
45448	payment	2134	2134	1874	1	1	7129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtdBQHtxrMoTCgmJU4HrgCPwLDWAWXDgj8wiKviDSMaNQq7g4
45449	payment	2133	2133	1874	1	1	6726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDcYmnnediDCGxpP3qxt5f8Hxhj7wwgeqQWANWjkkdUdrQkfW
45453	payment	1397	1397	1678	1	1	16916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyd4UbC4JdmDc2dhAdPeY5RxcMeySiuysjWPDiAK9ES4wtNNJk
45454	payment	2134	2134	1874	1	1	7131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPdbX84cV8m18YuJ3qCSFFWAQf4HfEhq82Wa1Fbh1Ps89YP2A
45455	payment	2133	2133	1874	1	1	6728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmjqD9hLek4pL8ZEGS1iw46eh7s1mueNfKQDqPyujF6tUcU8x
45456	payment	1397	1397	1678	1	1	16917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7b4WJskJ7tiAnCtbZcBiYXSneo4gKPXKdxaMKsFMSHnpDtVr
45457	payment	1397	1397	1678	1	1	16918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUaDv4BnQapnJhwxEMHURpjXYyQzDXXsozzmyqNAauzUibjN7
45458	payment	1397	1397	1678	1	1	16919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzy2h4Kd1fVjNt8ejYPbzfUwdnnSFuy77NXq5CA4CrBr3MJPGv
45459	payment	2192	2192	2390	1	1	0	100000000000	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiuoxnmPUcKBVJ9E4QwCgxS4FcDQrnuBMuye9SJMQEJXy3wp2
45460	payment	2133	2133	1874	1	1	6729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKbYc91QaDB7zLmsHLJYZFia5qXAJ1dHQnv9uC812ngo7RYB9
45461	payment	2133	2133	1874	1	1	6730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sBs8Ek2xr2TwHS4V43zSA1fR1PfcrrmeRiEPQd2fnHHpRKHj
45462	payment	2134	2134	1874	1	1	7132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAj7zA4NrS3JvDMEct2EbA4r4VT14snt7YSn4G2aDARA4iiQD
45463	payment	2134	2134	1874	1	1	7133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrKPvAiq99LS7RxvwTR5tyF1zG8hTUNJEPL6knRofhKra7Mkk
45464	payment	2134	2134	1874	1	1	7134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsg9XqWvmxBYCFWbFNSUzSQJ69j3wnXSRWTQM6x1e3Z52Woer
45468	payment	1397	1397	1678	1	1	16921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVrptjVSLZZskfgKjagMzDq3FKqgYWXdpr22hc52c475kQzb5
45469	payment	1397	1397	1678	1	1	16922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmPVJoRS7eswskHr61gtrCxWb4aXG8MX3NkAJxMxSEPJ12N28
45470	payment	2133	2133	1874	1	1	6732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xT6oMcUWxCAm2uyybwcMfrXbLh3PgaJfU2YwQtaeLrxnUaF6
45471	payment	2133	2133	1874	1	1	6733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtokwrMLKqZKkZV2g52smyAQ1vQ8pgDrvjd6rHSYS5mJfgvBK
45472	payment	395	395	1760	1	1	2	299000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ815ZTPxmtfk6AmVnbY7Rz1VAj9BAR2Ffow5Eta4eVPpmcvsss
45473	payment	2134	2134	1874	1	1	7136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3YePsH13Fa4gv6yUQnmoSqsM9EzSby36fhGoCWtpgKxeCFvM
45474	payment	2134	2134	1874	1	1	7137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cNvyRHzDebX558wn9YZJsWcQNanJUPQPGgdQdWGo9VuXMdJw
45481	payment	1397	1397	1678	1	1	16925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtb6fo4wbeVG7FkwVPtyxvpPYEbdGKzjxPAmsvATABiAc5BWG
45482	payment	2133	2133	1874	1	1	6736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1sbb4rALst3cXr5nTuMG1fEmxpFyMsxhR6bofWTQNRBi3f4t
45483	payment	2134	2134	1874	1	1	7140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwWNbinDRzeHBo8fPoufujKuV7wNkq9sTFk3uqLDrPy18Z8qG
45484	payment	1397	1397	1678	1	1	16926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBT9d3sSLGTbbt3pQWDAgRCgsa7x5xdqyHUPA6xuyATZ4ZUuJ
45485	payment	2134	2134	1874	1	1	7141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgmVrAgonZgxiMHQh2TAZF5dCSTbxmDJp1ycLGgkbACxHkapf
45486	payment	2133	2133	1874	1	1	6737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqBiXV9Ga9K2Egrnk7AEpA1hjy48QvY7hmR9GAqjL8MzFuHjA
45506	payment	1397	1397	1678	1	1	16933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXPU4tVXBR1BHkPEkwgNS8M7AsKguaa5mThJsJYawgGL9pT7M
45507	payment	2133	2133	1874	1	1	6744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMRA7Fja1nrZTbmbjjzCJEfxZ8dauHPdTZJaaKtzewLPXci9T
45508	payment	2134	2134	1874	1	1	7148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkiDwFAabgnCZofCHMrtV7Etk5vsA8EdmQ3kkwDe7AhnU68umb
45509	payment	1397	1397	1678	1	1	16934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QGQoXrMxUb4sfjk5fHuJDQAyqDmHN4u7czRAL1n9MLzUiejA
45510	payment	1397	1397	1678	1	1	16935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8pC5h32tN6bHtMhWWF14t8hwAAyUMaHe8w2pfGmR32icjRLk
45511	payment	2134	2134	1874	1	1	7149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5ix36ug65CrFmvZYqBsSwhjRD29ubvkWhdS5t4aWfUmbuUyf
45512	payment	2134	2134	1874	1	1	7150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KHuUW2mutU61JTMX94XPyCvr7jumtpXWkkyG55tDFPA8i9Fe
45513	payment	2133	2133	1874	1	1	6745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmCyad8wqMYd97kJUxaVJpNYE7SH8Audxtw5kSM1psRiUrML1
45514	payment	2133	2133	1874	1	1	6746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRSrw65Qpn931H5yeq9VmJup58KiXDyTCYSyc3QQanCPmUpR6
45521	payment	1397	1397	1678	1	1	16938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQwPoctffdAAKs8uFwszv49NRkPfN7ZcH1G1rbxNPx74KGkj8
45522	payment	1397	1397	1678	1	1	16939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBVM8Mxwmj3fBP5qQuX4ssYK1Vvba5Uey4eVic93AGeU3iit9
45523	payment	2134	2134	1874	1	1	7153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeowDF547Bshd2wcMQSirM2PSdPx5z8RUoxLvKKmMJugQtiVqP
45524	payment	2133	2133	1874	1	1	6749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1urcgsyvse8tgwF1NtL8Du62kA8QorSDLToVXtg6FAL8NRx5N
45525	payment	2134	2134	1874	1	1	7154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ToB1bUe7bQUXqruhL2bBJ4gFme7k14xZ36aTsxek7QVnqCBm
45526	payment	2133	2133	1874	1	1	6750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoRV73EJ1rZ1YsHcQaNfrKNLett7ZVd5cmuL9SgZfQ3ivCMpQ
45536	payment	1397	1397	1678	1	1	16943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWKYycXDkUVJG7MS8ojwZpqti4MXUTghiv9WP9epBX8vR9dPT
45537	payment	1397	1397	1678	1	1	16944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnR5zWz5QzTGw2haWYvx5rpaP2PkWeAPUCGsV1GxYXt2k1Rkzs
45538	payment	2134	2134	1874	1	1	7158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxjYWYg3SrY2c13VE8y3VSh5GyEoBNioubhbsenJghzxbT4w1
45539	payment	2134	2134	1874	1	1	7159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRvM12MVb1KwsudLXgndPnBRzmASqYbnyooEqtQUETyPCHZqM
45542	payment	1397	1397	1678	1	1	16945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkjfpqfd2cz5H6Bzki835vEr23RGRHxtk7jWcJs4DVsx6ULQ4
45543	payment	1397	1397	1678	1	1	16946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJzvv4YkoZKCrMVLM5LrQwpaG7p1Vyky9pxFfMgCqn6goVyAZ
45544	payment	1397	1397	1678	1	1	16947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQAiH76WT6CzPizMg1J2FH99Q46RQkFdNjXhCKE2RWc4h7EHX
45545	payment	2134	2134	1874	1	1	7160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNt19FvHVAupnNV7h61SKGnrAdyjeuF58y2hcrAxAbhQEdssE
45546	payment	2133	2133	1874	1	1	6756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLUB54DRhMGBUkwqAi3y9ApGBGp7TfYLe1HhNFxwSBrxmpUGJ
45547	payment	2133	2133	1874	1	1	6757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3Fqj15ec8beuSEmFyrMXqvSA5v6aRPNJdaCBGkLNvXaZ34vH
45548	payment	2133	2133	1874	1	1	6758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavxowJZwTDiaSgYUEzAbff2LEaWjPN7zy53PoxdPz5SycwcmP
45549	payment	2134	2134	1874	1	1	7161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW2LKLL1Ny99ozNwLJFpSuEj4Fd8pCTHWHBtEBisY6jjtAB8k
45550	payment	2134	2134	1874	1	1	7162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmrtpB3M4PZknqfAmm3aQ5xZLvihM3UHSwpBkLHfh2KuBAXQX
45566	payment	1397	1397	1678	1	1	16953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4sgZTUjANs54bFkZaFBhQjNbipMJXCwtJWGHRZzZjuK7tknL
45567	payment	2133	2133	1874	1	1	6764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwjv1GeonLxUssVpeMcPajzqBbnTARKPrSm9PN2crWC6JN9iC
45568	payment	2134	2134	1874	1	1	7168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1SkQ6DvtmPh5dfyUoQvcgPehjwPBGJtBrcpvaT6nVmYCKffT
45583	payment	1397	1397	1678	1	1	16958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTjqzRPW5d5J4YpNK5NoFZ6oE4uTCfWcL5hYcHn33bo6bv9Rzp
45584	payment	2133	2133	1874	1	1	6770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7Kei4dfix5aFXAUamt1RYJ5pSRqrCCKHZPBBZFXhBjgnPQFo
45585	payment	2134	2134	1874	1	1	7174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVvymrbAApgRww8EbqQ5WFmC4K1Q5xub7MbwxpcgRm4TzM4hi
45495	payment	2133	2133	1874	1	1	6740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYqTuTNspfHeCunbUJMaGppm5kMvw9BkzfMLnC5HccSq4ibTV
45496	payment	2134	2134	1874	1	1	7144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79ioKsyAWxCCVM1KGbxNhjRCVxHi12RVjQGFPs9q5Eoc5xp4E
45515	payment	1397	1397	1678	1	1	16936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8aEK6kbQk9g1VpW6A7me8NPS4svgNXG9KFecuMmMc9LYcZ7b
45516	payment	1397	1397	1678	1	1	16937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJU3sJdssax1GBv1LEAqrvRT9i5hMPbgZkSXeVLsgbFu8TukC
45517	payment	2133	2133	1874	1	1	6747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUw47myNWSX2y6aJYMCTctUesU1pHysgQm8wyw7nuGNPRtxD7u
45518	payment	2133	2133	1874	1	1	6748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAr2FDVuWgJ1ftosKPCYa8egTcznNwpDvotoRFN1mWDAhutoG
45519	payment	2134	2134	1874	1	1	7151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9emdbAqeNDGpjRMwfC18DPJAg1axsxfwu3LQ5txg6kFBXC1tw
45520	payment	2134	2134	1874	1	1	7152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37qC8wEJqx866RVtP4YbTTxxPfysLDMEWDwUfeuBijesNztGf
45533	payment	1397	1397	1678	1	1	16942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuBaHMCUbdSxU5J3xmVouA38ajwG7F6Tm4BSwdqK48DGrDYcS
45534	payment	2134	2134	1874	1	1	7157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWaonBja1NYjyUrxHFfGX1FibWSSqu1LuDQeeUC3qhomLRhuP
45535	payment	2133	2133	1874	1	1	6753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcv6dLXLmPGaAwqZNFAp7MUsD8xXGCspWL4699VX55pK3V9RT5
45551	payment	1397	1397	1678	1	1	16948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1wCJAgKry3SjJvLtJb7PfZYNJdK6MN9JGYZkbZiyS3qQhbLU
45552	payment	1397	1397	1678	1	1	16949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVzTsYvd6Y8wd9KxPRZ295M7avnBuFuGJBdaGPVVxgKd1TZJj
45553	payment	2134	2134	1874	1	1	7163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfPpJD4UKG5wwAJmAwHrNo9YGJZPcjKNc4NHKfYbEAVr62s8w
45554	payment	2134	2134	1874	1	1	7164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrF1T8FRfRv325ZvhVoXCusuZr4wTPXBCisztRVrJQXxqZvt1
45569	payment	1397	1397	1678	1	1	16954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBm76nvc8aMDtUN9kcAA6Tt317DLtfXFH2vGAix8PQhwgrNeU
45570	payment	2133	2133	1874	1	1	6765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1thqqpQdhMw66uierqCsKv6ydFZLeJYajjjA3ZrnxAnmBW7wX
45571	payment	2134	2134	1874	1	1	7169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLPTtJzgZ8okKrv5feuuCCYW5ikdR74nc76GQp5rwPCXP6oaa
45572	payment	1397	1397	1678	1	1	16955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotwgi5tj4SXPrRBViwqtksCWfgWmrvYmHdombgPEzRMJ3DBSH
45573	payment	1397	1397	1678	1	1	16956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuYjdHJh3sb4hAEEJNcYFUCeWnRWUVmERyiYEyHH992UHNMTx
45574	payment	2133	2133	1874	1	1	6766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MkVSLcckBQLPuKtqZpniyM5TzicmTDoKgVDWXdcVDVbRQdKV
45575	payment	2133	2133	1874	1	1	6767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAHYuZqTw3zMmi1C1B8TWMHEpT4WgdEPnuDL4dbXHBjiEffzM
45576	payment	2133	2133	1874	1	1	6768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV2riTHuuBt8sNpocBbNsG6hHdtA8exhmho2B5dXXHuMJdU2S
45577	payment	2134	2134	1874	1	1	7170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3Lrzxhcc6FPWDVJ6qVp71yKUq4BLRcgRkAc7U3tGL7W1JSSd
45578	payment	2134	2134	1874	1	1	7171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4EwoY9uQ7MXw8e99EvSej6bFCdJW24a6SQ8Nfb2zCUMLNfF8
45579	payment	2134	2134	1874	1	1	7172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCZ2BDwB4NQeTEtGm66Hv6XiUPKgMSs1bEcPtcdDpp5kckJVQ
45601	payment	1397	1397	1678	1	1	16964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbW7SiuEkSLpuYEvbz7hE9PP7H6A1WUprquxhDSPvJFE2dZGqC
45602	payment	1397	1397	1678	1	1	16965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47FWPcVUD3QqAeuoZU1p35TS96WnNcYa91sbtr7Q7tkuD2zxM
45603	payment	1397	1397	1678	1	1	16966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDNwjSDcGi9Axsn4uwt49MpQT44NaKnnXUjdie2CR6BaXunbV
45604	payment	2134	2134	1874	1	1	7180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQTJfZE3R1x3YEGUjr6gwajUALGabmvSCneheR95FYL2Q6uKW
45605	payment	2134	2134	1874	1	1	7181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4vY58fizjmSuxMCaRZWdRJ6RcaiSRobetJcRPYD1Wbpxmmkf
45606	payment	2134	2134	1874	1	1	7182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMBgiH5VzhUFysFJvV1CSk2yWA55YYYYDK8YrWd7wvW86QRr4
45607	payment	2133	2133	1874	1	1	6776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKC5LnrDkbDTSMWVAxVmhs9Dj1QceARDmwsGoNZHt1TQLkg2t2
45608	payment	2133	2133	1874	1	1	6777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHsShuUKZVKdpp2b8vFJqsZyCdrQXo2ggem8J4kKrEHPpaPds
45609	payment	2133	2133	1874	1	1	6778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeLSiUd1KU7uVNn85GMzb7ArxVapYS47w4rvG5mbvcf2SuhUS
45619	payment	1397	1397	1678	1	1	16970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKdMMZNZppJ3jukCtYqAGmum6E5C6YcbPK8nHXQcqSFo7PNpH
45620	payment	2134	2134	1874	1	1	7186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVbTqkKc5e8mgsoxVw3rgbGpd2Ziynuazyy3GazdByEriT617
45621	payment	2133	2133	1874	1	1	6782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVq47TJWpDegqs2ZHres8RoWG371T3y9R4VRpVCxLNoriJ7SW
45497	payment	1397	1397	1678	1	1	16930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCXNY7J3xP5F1t8JswTzRrC93Ap66GsckZSbvHVn4rr4PPUVY
45498	payment	1397	1397	1678	1	1	16931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe215oerq4CtXkYLLzzpoKBxm188B45dxAZTXzf5AyDZtex3Xc
45499	payment	1397	1397	1678	1	1	16932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqdrBBwP5AsQtjzx9Bs3jxTU8oipqm61biJQruM1aHfstzTnu
45500	payment	2133	2133	1874	1	1	6741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zffTYhF2jwNaKyuSo9trNfpEEznrgRS538PgVrwpXAhB8dtF
45501	payment	2133	2133	1874	1	1	6742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUM3mi7w4q3bPbKKS98X2mPYwfUPU4QZX6BSCMav4yCNrQxZE
45502	payment	2133	2133	1874	1	1	6743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQNqbBpY8J5sf8FPXjQkvXTx5brUwFS6zSDTeRfrEzDgi6dRS
45503	payment	2134	2134	1874	1	1	7145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyCJiN2APjDJaskqgqDofd8MmvkrPu4nUGupnv35uzBZ7c5Zh
45504	payment	2134	2134	1874	1	1	7146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwuagveYmGtGPWrBni219tom7TQKjE88hz2EXE9kay2xyfWKo
45505	payment	2134	2134	1874	1	1	7147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJwCAYtyarb9qMY3UFeEmfgCfyyx4p99nofmzMfnGd2PY16Rw
45527	payment	1397	1397	1678	1	1	16940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vnN2NEqCgT9sXTmgeH3ZB1a9oo6xwJpyRVaTxxYgRYpBVvYi
45528	payment	1397	1397	1678	1	1	16941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JkHvoYD1hTddYKnzwYfvCsT8nH1W9qLVhmNiDj2gWuoS3uph
45529	payment	2134	2134	1874	1	1	7155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRwfwzj641Ci9nkhkTYTk2R5TM6zovi5qV86YTmBjhg6xoDQw
45530	payment	2134	2134	1874	1	1	7156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTGBrSeGxafXLYXPB4aTTZQnyq366pTLAJeJtnafEMhMUH7AL
45531	payment	2133	2133	1874	1	1	6751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWcFNPEaMiJzDUmGFdrTZsTvig5cEGvgpKSVCuPq86y9d3RA7
45532	payment	2133	2133	1874	1	1	6752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mMQu7v7qZqvKcLKVf9hNMEaaN6P5FVu99YpCfvk1sSLUMRC3
45540	payment	2133	2133	1874	1	1	6754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTFK7f3YPQPv1AuUEFrKEz7JUadLgbv44EMjKizvNYsDF7zdk
45541	payment	2133	2133	1874	1	1	6755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgirZqX5nvercYYsH1gCahkK1VgHdbFt5n2zpkFRM6azK8w9SG
45555	payment	1397	1397	1678	1	1	16950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWkyfWasyuPsPz2eLhkLjUw7F1fJAngQy4Gv26cGtXvdSfcYT
45556	payment	1397	1397	1678	1	1	16951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2LhFdFxmrQFw3cZbBsJtYZFShzgn2Yy8sqw26JUrXXtsmnY3
45557	payment	1397	1397	1678	1	1	16952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSEGG5bySRmJhUeBN7WvU9Nhe2Vj76g8uGHox7Q1GTpx3u3RX
45558	payment	2134	2134	1874	1	1	7165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgQU5yziez6ZZ8AQSqXFya9fGCgAfMWRvwnVWhAe3nGE4Csos
45559	payment	2133	2133	1874	1	1	6759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeP269XGHzFpFoNQ5AoCB3KixTmbRkBzcpFbunqVSv9twB2BE
45560	payment	2133	2133	1874	1	1	6760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31urknxY1NSHuHYPm84aqrC2qPfw3VV6CKDNRwVGQBG2jS6Ef
45561	payment	2134	2134	1874	1	1	7166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYJAD2vACXBYvb33oe9P9E8hC2iuapY49fYttxZgPmdvPdoe4
45562	payment	2134	2134	1874	1	1	7167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHs5rbt2xoj7KYHfkN1TGYctMokcJmpotAH6stYztinLQhe42
45563	payment	2133	2133	1874	1	1	6761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1T8kFcCgxhP8Wv9WfbStGqYUBLjjTNsYjAYqeRvoFyijnyDTB
45564	payment	2133	2133	1874	1	1	6762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqESTjPVGbVEa4Rw4qgeTrjzsk5YwwfRPTcFtJwA4hHZdRpRLa
45565	payment	2133	2133	1874	1	1	6763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9adNx2UugRrPBQfxsSAY6ZhzheK5wWfwA5eKeyB3RhuCZkayq
45580	payment	1397	1397	1678	1	1	16957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqBAmHNvASzUGqsQMHeZCdN4nR4vH85GkYiBbZW2fzthHN9XM
45581	payment	2133	2133	1874	1	1	6769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QfeeZVGHKFm5kkg93b5WBfearuV6R3TCkT3pfUH5uqq996KW
45582	payment	2134	2134	1874	1	1	7173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRejVh1t18py7cWpFjADLF5cyT5CvSE8h35X2zrWhEukt8GMU
45592	payment	1397	1397	1678	1	1	16961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWkC4GNEnLqRmeod8fAFzgd69HHnSKSY1okbUCgDXYNzJeLy6
45593	payment	2133	2133	1874	1	1	6773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSZFy6W6m4jSwyyLenbXnovdPps3Ji3TonfvdgEPUAiF86tQo
45594	payment	2134	2134	1874	1	1	7177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfyF9sT4fDRPqoS65MnGFmdbrSUt3cobPNizAtKPrjyX3f6Az
45610	payment	1397	1397	1678	1	1	16967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDrRR6afGCDU9ZXrhXofaN4NohsH5DcrhMuqPnv8Q5bNXWqG8
45611	payment	2134	2134	1874	1	1	7183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQWZxvkLK3y1VDh6jrQtEBJhmrTv3MEf2YSUsj6hqZFB8oMDN
45612	payment	2133	2133	1874	1	1	6779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfiELcZRgMLKqAcEry2FAnnTdqtnQjJtKH9tPo67RngrtwjQZ
45622	payment	1397	1397	1678	1	1	16971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZs5pGSP9LH1hnYpZ1xTBgzgCGttEfd9t5QiPvC7hNKqCZVRP
45586	payment	1397	1397	1678	1	1	16959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnAUxDR1SU6NVF3739PXfwXY7MLU7D5YnZ47kfsR7kbn9YjSW
45587	payment	1397	1397	1678	1	1	16960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5pQxTNFVCeoqtqRXXRzPAuXtzsHuEjVYD7ZYdzyW3HXYY4U8
45588	payment	2133	2133	1874	1	1	6771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RjoFipGZjh5QfgYZQ2G7qJt4zNozUwDtiaCJeHxeaB2YC15X
45589	payment	2133	2133	1874	1	1	6772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFXGTVw64Sqbu6nRz869MatnLyiduJe9KfUcx3utKJKLfxB3a
45590	payment	2134	2134	1874	1	1	7175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZ2x7xZARdSLmFocjG7Twu6hjvP95sk53bYEozFiMkXjtdsEx
45591	payment	2134	2134	1874	1	1	7176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxAq1e6UogC8NvQhpDo2oUZxqHUZyTyGbas6uUDuxHHy7s9Kc
45595	payment	1397	1397	1678	1	1	16962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88QtfXXdsjXGKZi9K2sGzPwtZnVtyGadbKZ6zm57Mwzkt8gCB
45596	payment	1397	1397	1678	1	1	16963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88jJMCaRkPT4QvDUbVWX31F4P1vYpeVxZg7AjtEqtbj2Mf2yo
45597	payment	2134	2134	1874	1	1	7178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA5DP3X2jeptF3mTcbPSZ6er8CyhTkj8TUqTANzqKQumdzcCW
45598	payment	2133	2133	1874	1	1	6774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7JBDKMKRuzNZx7g58X1cfR3rufXoFf4tSE5AcDYCHF1ydyaS
45599	payment	2133	2133	1874	1	1	6775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVqySw3wpf6hYa3UmhapGagUyg53QxmJCfswBSYhDhUSg6xbv
45600	payment	2134	2134	1874	1	1	7179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJeBgfbkufcabbYuu1SJn2fu6BT3rPJnNGcweLSTu651PKDza
45613	payment	1397	1397	1678	1	1	16968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX53cDTBNjo8cuz6J42ZHvLECvhm8srEip4SiBkjgXTGwFEvDm
45614	payment	2134	2134	1874	1	1	7184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSRWKgRouu2J6AcGcUtf4npFeBSurToBhGWBLMULraCjTKHtM
45615	payment	2133	2133	1874	1	1	6780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbVTvT1u57gqBZUo2kmBNGKhuRfb6c59xMbPMmukoihNwYYWf
45616	payment	1397	1397	1678	1	1	16969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAxt2z9Zn7wkQTsSHYma4axKoKijVyYKPNVByXCGgZrKQX1DC
45617	payment	2133	2133	1874	1	1	6781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCb9hwafhr8BjHda6KgSpsnQU6bHcdCezsKG22Fmh2vjcEzSx
45618	payment	2134	2134	1874	1	1	7185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQe6ZDb7oc3u4NT6RZVhkp8HjtWkfGkbDpuFtYgKWarMM4B3H
45623	payment	1397	1397	1678	1	1	16972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpZ49whS6ngs48C3SYvZPzZqgfqsh2JZMM6661hkChp99ZCXy
45624	payment	2134	2134	1874	1	1	7187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbomu4MfkPHSxVXftkm8jWByrfg1PAFHJmbgJRivdZbRgsy4m
45625	payment	2134	2134	1874	1	1	7188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCCE2Cbsg7VuAHocrnex5AVe9vwNjMhPdMVjEr12FteR6cpVP
45626	payment	2133	2133	1874	1	1	6783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWHuAkjk8JmxyGrTfYMWUBE8AEx32KnKKViApykZaeFbLe9T9
45627	payment	2133	2133	1874	1	1	6784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMASGhXidFGJj62caYrVFqb9RoFFaenhTGAmYip8ri62ohuuQ6
45628	payment	1397	1397	1678	1	1	16973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutBFxhumxLMdvTsWcKPDQDTMeTHmjdAVD1iUMdVmVyBjeccm6
45629	payment	2134	2134	1874	1	1	7189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaxLr96CVH4QUHjrtuxr9ktpRpZefEEuiMkReg8K7mVoDnzan
45630	payment	2133	2133	1874	1	1	6785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mxSVwHtpKfLE46fb743fQuUF2TJFnMFXKSxfdPSNTqn2BSJn
45636	payment	1397	1397	1678	1	1	16976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphYeALmgzPvWLwurDVojJ7srmxAsG6d9mqntDUPghhevrZks4
45637	payment	1397	1397	1678	1	1	16977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe71Hx55dJYSBT9xRYQptHBTvSzieDU6co22d2oa13R3kFQtd
45638	payment	2133	2133	1874	1	1	6787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6Wmw5zP3J3REsCuvCb4xTo81WzvtyZC6Kyipcf5xnRBCiyVt
45639	payment	2134	2134	1874	1	1	7192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TDU4jyKURFEnjxP1m9764LjLQ1m45zdMFv1RfN58cGLHn8WE
45640	payment	2133	2133	1874	1	1	6788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjswX1UvHYPU3yzskCEBtp8dahEkb4uZstcsH8r8HJAkJJSbyH
45641	payment	2134	2134	1874	1	1	7193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1EtXm3vgN2JY3pV3n8dAPYwigrgsosfEdc8zQEcnZPCfLQUg
45645	payment	1397	1397	1678	1	1	16979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasjuVfjqajUdbAcDB4LKv9jfxFGq89suxGXjkXpqZKautHxYz
45646	payment	2133	2133	1874	1	1	6790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwn7UNeCy3X3BWMrYyePfC3upf8qRJwKW78hFQDHsMNbphPSJU
45647	payment	2134	2134	1874	1	1	7195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25EKUGKXDcGDKhH97G5WwGwCtYZMaWmxP2dhjjDHbaC5WfpEj
45660	payment	1397	1397	1678	1	1	16984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgycA2ELR5ss94GxwrBEh54mpxDxFCfVrohdeRgfnSDmgfdG5
45662	payment	1397	1397	1678	1	1	16985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKe5Na9FwoopFs5McQHcrXWoENcp7Yzn61bymgRvBqS4Qi79T
45663	payment	2134	2134	1874	1	1	7200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVaoxtKzNxkFNXGQTrY6cAaSeHa5CqAmWPWnhxLwWqmZMFVgZ
45631	payment	1397	1397	1678	1	1	16974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDVQQm8pw3dnEf7kRivQRVcjtofN3X3kGU1Wm5UTC1ftKyeN2
45632	payment	2134	2134	1874	1	1	7190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYDCfW4MbF2YPwD6cXy9qi9VitfkGftGnKVQHE28BHh16wS7s
45642	payment	1397	1397	1678	1	1	16978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpeSjQzdDNhuvFEdHPrxH9qj3EoLpw5mJD5P8nxiXGQX7VWGY
45643	payment	2134	2134	1874	1	1	7194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY8aRTQfowAPz9nbenPyf8B59LpSgaW842LPrtqASPnQA1cdw
45644	payment	2133	2133	1874	1	1	6789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87SebD3H1AhxKx7aSuWDHS9eSv4XWjW6vUQgdoPwBDo9VTinM
45648	payment	1397	1397	1678	1	1	16980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkThyGwFusNEoYrjuz5Lpe8SuruV6vwzgc1TCrAxFZPXAFSVfD
45649	payment	2134	2134	1874	1	1	7196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkmGDWEwUQtQ9Ymg53P1oZmJdsxHoMb2W4Rrcjg4Dkax8edPi
45650	payment	2133	2133	1874	1	1	6791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDyEa9sRHvbYdhhea64HLBZPz7nRPzej99PF1zpDy7UQdXPC5
45661	payment	2133	2133	1874	1	1	6795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTWuv652v2FkgXrbJEC3H4gSU2EX25x2Yb229YbrvaxBeWKH
45674	payment	1397	1397	1678	1	1	16989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9LQoSc15pPR8mT7bgk8YLUJc7fBERVF1f5r9dRJkvoxauz98
45675	payment	2133	2133	1874	1	1	6800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJYwxDK786ckdHbiVy8R6ojTW9v1nEw35qgTfgvuCDTGN4AhX
45676	payment	2134	2134	1874	1	1	7204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrAawbXeP4YxAoQH19ucQSC4jC728QX1RcfpYcFweN9drYn3D
45677	delegation	2388	2388	1560	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecj711YdWZN4zHXK96icTqGzuVUvfr848M5BHpzmhrNPCTHG4
45693	payment	1397	1397	1678	1	1	16995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCczJXjWNwCa7ESweCw9xsHKq2qcaW7QLjrYSHpNsbcMMx26Dw
45694	payment	2133	2133	1874	1	1	6806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVi7TcvRwnRA6FSh16xWvVJ3vS2Q7TArrU2ympughfCQDLYhB
45695	payment	2134	2134	1874	1	1	7210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcYnot7kYqcMwsWfGkRMBLx9gAufQQV8eqZR1njyM5BLrZbN7
45702	payment	1397	1397	1678	1	1	16998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eu1F98AgPWqhkJS79KSYhZXedN432ytcAFW7YpCM3arcx8x4
45703	payment	2134	2134	1874	1	1	7213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzVxbGZuYKxAQ3vnSpxMSFeZdzfmGn7hwkBvDHyYsE7xTnQbB
45704	payment	2133	2133	1874	1	1	6809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wzPBdyKUPGT6Vx8uNvogSTxN35jcWqUJwXCkEfnq2rPo6gV2
45707	payment	1397	1397	1678	1	1	16999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKUF714vW8r85mhz2MC2M3GgnQ21sE4bbSMYWpAxdusauv57B
45708	payment	1397	1397	1678	1	1	17000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEw9z2wjiF9eArfzyuwuUxsjNXtzFdgtnzhbUTdsjuDt89Rqg
45709	payment	2134	2134	1874	1	1	7215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqMGpeFC1Sa1BtgyN66eEx3Ypp6rC6c9oiVQnFbUchxtLLV9w
45710	payment	2134	2134	1874	1	1	7216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3p5T4H3RK3E3PSa9Y5RFU8pNoWkUKTQMnrYoUJHSJz3B6VAgm
45711	payment	2133	2133	1874	1	1	6811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8tNNs4e17gzrufwxd5UVZpN16LXu9aZuNHAnzDSkTRPvTy3z
45712	payment	2133	2133	1874	1	1	6812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdYguNezL2TY8pNvSrL69KgbjrygvdAgkgknuKQ9gUPD5ePgt
45713	payment	1397	1397	1678	1	1	17001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBUnLniQqA1eGdSeuQLcEiom3QKqF1bhgPtkjV3wbMkZErDZb
45714	payment	2134	2134	1874	1	1	7217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaN2qF24iKBqWYMG6baGcXb9oE4M18wmd8NCxzcgKa1RFu4ak
45715	payment	2133	2133	1874	1	1	6813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjaR9Qb9pnSKuYJy8nLgrBmycSxj1fcj5bpN3CGt2Ppp1XX8c
45719	payment	1397	1397	1678	1	1	17003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgJrgU3s3i2nFTcvvJNst6UMFbm957TiBg9uT7opCeavhNe6T
45720	payment	2133	2133	1874	1	1	6815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmuv7DwrutYTdjpdRwaUoyBGWnpmYbNL6ufbkuZai4mADRNcmT
45721	payment	2134	2134	1874	1	1	7219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmmMCLirv2CDrJbtdPekqAWnhKiwa9q4x2LPqJJSFyyxLu7qt
45728	payment	1397	1397	1678	1	1	17006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokA6KXEuVY24G98xZbQa5Pf8rciFTfkVLsteU7ptsyNxASfuE
45729	payment	2133	2133	1874	1	1	6818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1a7HdBACYi1J2dAmGV4AKvPYfXmjiKwLNFom1JrKmLsZErkZ
45730	payment	2134	2134	1874	1	1	7222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt1zaAZpVsYxTitR2wUQoWKoY77H2sgzA5LVbvdk3maFr8ph6
45731	payment	1397	1397	1678	1	1	17007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aTjhPwLWcUppMDe5mm2dB9aqTYXntPHnMWUXfA34XYeaFyUm
45732	payment	1397	1397	1678	1	1	17008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BaNKjnrG8fX6fkAXMkY55pqBfSVrxKYKrLyFeiAvXpEMAtrm
45733	payment	1397	1397	1678	1	1	17009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfnZw83WaFSmoHHbceqU9jURSKX87kePFn2Uy5r5d2L2sguLo
45734	payment	2133	2133	1874	1	1	6819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRbQUF4h4ALdycTTtcEujECPacZtXTZBMdrEEfk4VVDqe1CUw
45633	payment	1397	1397	1678	1	1	16975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EMsZ9zVguqpPW4BvtMkkz1bmTCG3ZQaD6pTmaujA7JhuRq5w
45634	payment	2133	2133	1874	1	1	6786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSCrAjoetuiGoZ8w9A1M8WBTcEtkNcWhPUQLGu8VvMM8g6CQz
45635	payment	2134	2134	1874	1	1	7191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt64D5H2ysetFGueiyYzbMBWvUjuq3BL3kPQjkChszMrccUZZH
45651	payment	1397	1397	1678	1	1	16981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBKf3DfTY1pgefXuuXjB9iX429ChQSf9N2A6hyJM94A51zVVvv
45652	payment	1397	1397	1678	1	1	16982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YzfyMCXa527qdLu1ikpbV7YoiXUk9f5awr2ovueTS9Qa848a
45653	payment	1397	1397	1678	1	1	16983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZny3esuYqbHCdVGzKyF1JrWwJgKUtbQ4ECFQQqqRrXg1Bo7AUu
45654	payment	2133	2133	1874	1	1	6792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYya2LfqprgZV8nZ1eVDyT1CnVK5iqoxMELVhyoWr8BHjVFhq21
45655	payment	2133	2133	1874	1	1	6793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVEw9b2CKqKBtyXZtgtQ1E6uN8feDtZJmLqwaqLWud4hSA3FH
45656	payment	2133	2133	1874	1	1	6794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwzZnujtjt8XUgfrUijRiEj4kzWA6SGTFepEQFoZnXqcyrQ6k
45657	payment	2134	2134	1874	1	1	7197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzUiHSUYWHjYj6AWDi38PVYgj5ANKrFfppPVSVvLoYVtRxVJh
45658	payment	2134	2134	1874	1	1	7198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf9UTued5gffEumJVpdfXSkagQnRnPEirjSzJr2prJSdpPUpP
45659	payment	2134	2134	1874	1	1	7199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3hZzzsGuJp6M823Badn5cyf14mM7muCr83GHt6NKCDA5xZfBh
45665	payment	1397	1397	1678	1	1	16986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3xFEfv2JGRUofCu1vwt5bWJC3DyWpwJdxcedbph2USLrWgPp
45666	payment	1397	1397	1678	1	1	16987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGh85CF9qURQEWomzEpFdD3mZtuAM9gZVqs1AyuJcC1CbkNTFT
45667	payment	2133	2133	1874	1	1	6797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2rvPYcaJcHZF5oX3bazqxapu7mASvE9Sf4DpFqUR27t4k3Eq
45668	payment	2134	2134	1874	1	1	7201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHL7roRWQZyJivKNevL1d6j3g6xCbqPdF29JGXWGFmDuSJPtZW
45669	payment	2134	2134	1874	1	1	7202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpjJftM3phokuy9oSLsUN1T6p8JYw9MH2rM3EqharpTnPo3U
45670	payment	2133	2133	1874	1	1	6798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtZpJo6QzC7FCpxmA7SVQ598yLDguiF5kjrEjhL3FZ9mR1nMf
45671	payment	1397	1397	1678	1	1	16988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRXaPhVaoobBAwqbjUaMjimQvxhzLXp4t5rAKwcqK46eqfPn1
45672	payment	2133	2133	1874	1	1	6799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYannnvHrEa9JXspjC3cW9qVeiW1Ausvdvq39FexDWMvRbeJJvH
45673	payment	2134	2134	1874	1	1	7203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZeCTLxq1fvSbQ5xLBDr8vcPGuRHeTEFNJFvAQvkRZbSxs3nk
45678	payment	1397	1397	1678	1	1	16990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAoD6Cq3vKnEFH4J9tFLSnSKimtxPYuHEWUVKjwruQWrWW6ye
45679	payment	1397	1397	1678	1	1	16991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1MhvvYMWEUVf6tjuiBRUovmW1jMCr1tGW3YmTysLZDXkJWsK
45680	payment	1397	1397	1678	1	1	16992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKPDP8kpHhHkf42amDxLjCd7kEsuwPZYAmHLJeewcYCq6DjJW
45681	payment	1397	1397	1678	1	1	16993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFEjzFi3N7CVK66Y7LzmxRYZB7LrumSMdEdYQ3B9C5EyKdHjV
45682	payment	1397	1397	1678	1	1	16994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgkicJvS1Cm2BHQa19ELoHbcvAtsLVfeWopg9aJ4wZQu5Yq2X
45683	payment	2134	2134	1874	1	1	7205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcW3CpynaWdSZWebTrQ9wXQtpCXEoA62tDixDmn7pBXzZCZcw
45684	payment	2134	2134	1874	1	1	7206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHXu4fizUkyTt81YQuKwcFzQtq5AVQNimfGViVRZ7vWJkJJPh
45685	payment	2134	2134	1874	1	1	7207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuCqR33kgQCXaikf9omNfKDt7FcWYdzusdUKKgJNJvx5ZxMC9
45686	payment	2134	2134	1874	1	1	7208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmLdKVULa68ejgnpmiub3AAVXV4Dunid8FnY5PkmSy9LtSuhN
45687	payment	2133	2133	1874	1	1	6801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDkik8GY2MR42JA2z4WNUH9iVVYn4nF6uhTvoyEoMec8vstBo
45688	payment	2133	2133	1874	1	1	6802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Jc48Affk925iFuhARQrHutwfNzZNgABz1bHo9K4T3uUZMQJi
45689	payment	2133	2133	1874	1	1	6803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZVbzjdQzY79xpBXrAm5aQ1MWVHXpwbg7XDhqywL4trp3YRde
45690	payment	2133	2133	1874	1	1	6804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7AUZCFhBxWMfenTUBuGKmNmhPeKGmkkey7LCoEMdQAY5M7zb
45691	payment	2133	2133	1874	1	1	6805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzEcG6Nf6B8AnGstXevTWvPRJ7B4utFqqFnxzeMpu6nNnni1f
45692	payment	2134	2134	1874	1	1	7209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBu9wDdnXLHNaDgdi7XBynDmbb3daVXLePjY6aGv2rr1yb44x
45699	payment	1397	1397	1678	1	1	16997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQ7Mqic9njsUdDNYuU1dyQq7Gabp8HtxEeJxT9uq2apZJhxCs
45700	payment	2134	2134	1874	1	1	7212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXzmi9SBSJdfqTFzMBrXgEwHbdBg3mNUDJDxkDGMdSdA73hR2
45664	payment	2133	2133	1874	1	1	6796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovzUhDHyVoxdUNjCWytLYARXWYU9Eqge39y8WSFHxfUgoMNod
45696	payment	1397	1397	1678	1	1	16996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mEGk2ejZcVZTS5bXxtDcjXBm7YYdLTNMd3A36Goqn7z66y7a
45697	payment	2133	2133	1874	1	1	6807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW2o6h3zPzqe5SEpe1XXEBwLqG3kG7psadVz9V6arYHt5jmzt
45698	payment	2134	2134	1874	1	1	7211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJjov3JmjFjshts5XmoVW9G2Q3LYyLDHRpDvNcPqFNXUyP1zT
45701	payment	2133	2133	1874	1	1	6808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY5iqC3JgDDUKvoABWnQMFX2CZFS2zW2Esifm1GiurXMgfBa9
45705	payment	2133	2133	1874	1	1	6810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTScn1Bc5d1wV8btobM3WzuPsmUse2zTypSmShQFhn3wFtYwj6
45706	payment	2134	2134	1874	1	1	7214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqT2H5rUDKxxcDqwWekmFzvCDgFw9enJfC21qxG54uUsaVYQY
45717	payment	2134	2134	1874	1	1	7218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXL1b4CryFQQJ6EsD9Hfy5EhUsACwkgu1scZAow3DNqcAnw7e
45718	payment	2133	2133	1874	1	1	6814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMKZwL8rxmGfPPQVMCsRs3X5c7X2TeGokdB9tBQzmTxpxYPgu
45725	payment	1397	1397	1678	1	1	17005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4hno7L1N9XLzBVC8cbEkoF24xkZjDJLzFH4zJrAhfMaLvgak
45726	payment	2134	2134	1874	1	1	7221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwha2gwd77Rnh5zHtDVXuGvefu5qyRcigAoFz95M73XuTzM2X
45727	payment	2133	2133	1874	1	1	6817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeyLKkw2db2sJYpMsj3dfswHk1sHNMurK4EkXwhP4Lnv5Ak9x
45750	payment	1397	1397	1678	1	1	17013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcs9EuHB9wAS3csejgFAUfTBiuskx9MEq7PukNbhbEV9vDHic
45751	payment	1397	1397	1678	1	1	17014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5CHPaAZe6Nkq98ZW5ne9GE5btb5hFgKjqLadSPd7twygqGkC
45752	payment	2133	2133	1874	1	1	6825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbujorM3adqLfNoXGa32sQHvEkxZtzWsSh4Nbsam6WUY8Jpq6
45753	payment	2133	2133	1874	1	1	6826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnqHXDRV2bbUULELXkZhNuv6yKp1sA9nhRbViFvMMc93Y9F6N
45771	payment	1397	1397	1678	1	1	17020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3fT1fp1pAxzyubiqWKCYRc7RpqD8ZyFRh4McS26HFhrHPrgc
45772	payment	1397	1397	1678	1	1	17021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUsGbHZqgT3DtoQNnoYsydu9isHjxPHHHLnXRreFnUGfiRivL
45773	payment	1397	1397	1678	1	1	17022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ih5g5mxQikoMDPMy2VaRw3QwuuMT7pJTnTKHcrmBAv9KyR1z
45774	payment	2133	2133	1874	1	1	6832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnUsFh5SqACDHDWjW4WYfLvFsJt7wNUjf5vhvLEi9VvFbNrTK
45775	payment	2133	2133	1874	1	1	6833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uHafWRGj2FVfT4fiXioGqDX4erqGhuAribvtjkcwjsxbvksh
45776	payment	2133	2133	1874	1	1	6834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FRozK8rfXjTMrjH8xs4F9DA1gaXDagMTsZqC2M5cPTBMnjek
45777	payment	2134	2134	1874	1	1	7236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZwmJ1ohAWKPAn2ey5GZQ8sfKB3J7saLNX5336nTy1KQZjQFX
45778	payment	2134	2134	1874	1	1	7237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJ5dGgRMiRdiiikBgihHW5wcM9g4aShiCYtdA4WeHdongW7YU
45779	payment	2134	2134	1874	1	1	7238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZ5oiqjZaUSu8GCEteuXfZsdhfciKBVf1MLAtXo8xnM66YX9B
45780	payment	1397	1397	1678	1	1	17023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ99rsYjAf8FRhomKk9SptR4Du3AfgALA7p9YhEzfGUcZno9Tr
45781	payment	2134	2134	1874	1	1	7239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbs44RBtoLqwrBWEuW6WVTz2cv9T1WVTf168N4FUC5PnknQz8a
45782	payment	2133	2133	1874	1	1	6835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwLkW2dcTd3tfT155J24hK1sd2M6cBNPALTY8UmP7wv2WoF3V
45799	payment	1397	1397	1678	1	1	17029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwGbUQgZAtBL8PLRPB8Qg5u9Dhn7cNdZPSyFNLYBMN6wNqEEA
45800	payment	2134	2134	1874	1	1	7245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGpY7jq59yJe6U8ipnDj8Dg3Vi44a18mJvGmqczgP88u68JZg
45801	payment	2132	2132	1874	1	1	1722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvozoQ8hapcoSXKXvqq16V556GY2ckfQVTfPfUNa37zk49KV77
45802	payment	2133	2133	1874	1	1	6841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESNqfoEfnxgfFFxzpCtPxYLBrmkPz9gi4shrziVZoqpRW2GFM
45803	payment	1397	1397	1678	1	1	17030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9EnSsyoTu54uGymYDLxdF6BdX2sk7Cnk3urKDhtwyeodscEn
45804	payment	2134	2134	1874	1	1	7246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJeWpnHdabduG9AmvF8916PUCeX5HQ7f8rPbyCpFWFXr8d1B9S
45805	payment	2133	2133	1874	1	1	6842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBhWmyWbJDKzS1bBXtuZSaBpJkww2xVpbwpd79oQuP18ryX69
45826	payment	1397	1397	1678	1	1	17037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh1jmGaqDBHVimz2QMo6ad8nSE29gqbDRbi3JSUHNt83UJ4CQ
45827	payment	2134	2134	1874	1	1	7253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJZ4ijcTEHdjDxm4bYXujKGuxc8dTD8KFjciokF8e2DBj7SkC
45828	payment	2133	2133	1874	1	1	6849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpGYCYad1YZ79TqMQucnVyppDfrcqo1d5fPintc2pP7GfzDZt
45716	payment	1397	1397	1678	1	1	17002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAeDiLs2D1gYFk4zuZ8QJHsNyddqJTjCGntBWujeKz8fYcrFqQ
45722	payment	1397	1397	1678	1	1	17004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceQmBnEa2xJHhcJiFCDnviCYyRLwBXZWEWRhvxTMcnyvjKfrp
45723	payment	2133	2133	1874	1	1	6816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5FMCKTCC3KfNsBsUbtUqF4mmMXvAPi8jTdGeqMzc6xXAHCt
45724	payment	2134	2134	1874	1	1	7220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQpWeeEhM3c1np6rbWnNTrDy41Z1cbHNBgWYg9ZjxgYS94xc
45740	payment	1397	1397	1678	1	1	17010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2WedcV3myGNNahMM72QSQTadymMtDW5VPEaH7M9rrCLozSGM
45741	payment	1397	1397	1678	1	1	17011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45VpH6dbEkw95hjKcRKGsVR9LaJ2goWW6Jrzvk3JhS1MhbyLT
45742	payment	2133	2133	1874	1	1	6822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaZMXfgFAL1TbeKH5zWnV1eyqUxtg85L5PACQ28jfnUifr7kU
45743	payment	2133	2133	1874	1	1	6823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYE6xJpzgxmUZSkThht43x6XjBVqzF1YBqwPLm8xRgtX6a7zf
45744	payment	2134	2134	1874	1	1	7226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycFacBT9biwhx2cW2Qbx6LrRBPbBuWCig4Zxpisfp4YsLXWgg
45745	payment	2134	2134	1874	1	1	7227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiUgq7z7WQMzzFgYYQd26HiYX9dzzh4T7fJotGYn9cgGhrEsm
45793	payment	1397	1397	1678	1	1	17027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG2JE3nsEoBvEW3AupPhY9So2HARZ29WxVKDR7Jn5Rw8f6idh
45794	payment	1397	1397	1678	1	1	17028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD77WLNF6abYo4LPha3qTfzLm9gdrVxUPz1cBNuJk3nGu3s6xa
45795	payment	2133	2133	1874	1	1	6839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnfyjuwSsRN6zrQtfkDi5q56svkT7b9k1UrSuVx8VxfYSiGPh
45796	payment	2133	2133	1874	1	1	6840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrVw6oyfbAvGxY3g7gZRD4PBo1CGJojBHaCeJg3bf4htVtQ8k
45797	payment	2134	2134	1874	1	1	7243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrCwoMkYc196Q5Zt8RbmaivoaZsvhJ9kYYtpeHPcN754j5d3b
45798	payment	2134	2134	1874	1	1	7244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFwjtpJkk9kGxjNGCih2cFLmFECrfryXcEyKanjJQekvzy6e1
45806	payment	1397	1397	1678	1	1	17031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KZqAt13wjASy57hFyDm2JghdhFa9Km5fF7kMYQ8SrgroEKeB
45807	payment	2133	2133	1874	1	1	6843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRWkMP8HzHtcXUdsGSASGNeH2boQ5nUCUGFxLXSD8SQMCVpkn
45808	payment	2134	2134	1874	1	1	7247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMfU75UATNxmJpyuJLTp9ta725BBhRNqwLWiBSyagZjk7XYys
45813	payment	1397	1397	1678	1	1	17033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXmRXBDnrhimjteDntKR9MZ728b8GEPY7Rh9ADgav6ax6Cfhj
45814	payment	1397	1397	1678	1	1	17034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqoSgJJGa2rSSvanemKXTtb2eHDSTEpKbhJvJY4GuizWT7fSd
45815	payment	1397	1397	1678	1	1	17035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfbdMmTtu4CHC9gwZ5bPiaKywk1owCaXCAQPL8WU5GBN5h4Uu
45816	payment	2134	2134	1874	1	1	7249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJi5756jevTyL3HfNKvwEvJhVNuints6BL5ipLST38SJDBwCu
45817	payment	2133	2133	1874	1	1	6845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWrUDfdjrwehDF4L8Vhm3PbA15eKjkYHezNcE3BoDJssuXH3g
45818	payment	2132	2132	1874	1	1	1724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTHTH12xktq38NLsW1srNryugMY39QNqx3ibtjzWs9xY8XPam
45819	payment	2133	2133	1874	1	1	6846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YKrotEzSfq7voK9RPjd4vbt3xvVTHFafjg3r9j3GYE6FUiXb
45820	payment	2133	2133	1874	1	1	6847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9A4g38KQL2GUoj6hvCpiwy4LCKzHGVVyC9r4JgxjN9CbCN1M
45821	payment	2134	2134	1874	1	1	7250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4xNkWkQC2N2JPZoVDf1rC5RCw1xeGgGcQxNCYzNHzwns5pLt
45822	payment	2134	2134	1874	1	1	7251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTDMBHUW1n6eZ9mpDdCYzD1xuLcHLZwFp48vbJhJNR8Mrhppv
45823	payment	1397	1397	1678	1	1	17036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEcZQFDGCHmYenJMrM21Ym5C4Mw2sGh9kWYETkzh3rkjZJqqn
45824	payment	2134	2134	1874	1	1	7252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SxKuTp1gVTCJAnjRauoYYjL8BUJhu9Tepy5r3Ntt78MjfEgc
45825	payment	2133	2133	1874	1	1	6848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaPmk5KzaNtarHwDgtzMCVn9UujieV4jNcRYiP8K8HVCXaQLh
45836	payment	1397	1397	1678	1	1	17040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27SSMt2B3eyYMPhcM6txbZNjx3Uph7DVdVCk1TSazqNrYLqCb
45837	payment	2133	2133	1874	1	1	6852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzoW6hm32b242qMEY3GycoPfYa5GBGmS2niAMz6hbXUmR3aJW
45838	payment	2134	2134	1874	1	1	7256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Yv2g4hLwtVnGmMTn7Xngm2gtZ1yMF82i78FeoEEsKqmC33pn
45839	payment	1397	1397	1678	1	1	17041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMdwyxXAPMTVKSqJ5pqpjpwkoAvcyoXxNkPQvy2gxzQhQrKsC
45840	payment	1397	1397	1678	1	1	17042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67PSS5npueePcJECM6865ThEhiAqi9xvxwX6t12yizRPrjz2v
45841	payment	2134	2134	1874	1	1	7257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1os7rHJwpxz4Ht2rBsJjZW5jmXhGc4RzLeCK8m3PwoisDB4v
45735	payment	2133	2133	1874	1	1	6820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XNc1ULkuhtG5AYoAkFeV7MmjgfZpfKZx5PhD3nFJUmgRuFWY
45736	payment	2133	2133	1874	1	1	6821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNPdaHRWtY71xZZifkeDcaNbhTobdf7Ggc7TG8Lo7zdDeMZTBg
45737	payment	2134	2134	1874	1	1	7223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U6UbTm3gNq69651GCEGxvS2JsYB6f3V9HWCvdKwf5iGaEFUN
45738	payment	2134	2134	1874	1	1	7224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ6wvDiagjytNDjH9wHEgocAyRMLVDkV8R3ALods2tjRisf9w
45739	payment	2134	2134	1874	1	1	7225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptPuiGr3wMZ4z8dZeHPdAQhzkkB4xGJukFw1NQbJ29i6A1Ep6
45746	payment	1397	1397	1678	1	1	17012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ehixduE23PjCFjerDzSStYmpF8y9Rp6bED4FW6QrtDw9L9V2
45747	payment	2133	2133	1874	1	1	6824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQShLqY9pnrtQ46zyYG2Qt58z9bNZEELPo5QxyHu5eXA62C3S7
45748	payment	2134	2134	1874	1	1	7228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAzEfB37R4tVKjdRp8U6fNw8nTdetrkC8UKcYDjVjudG7g4U1
45749	payment	1726	1726	2392	1	1	8344	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiyvNxuTnTY1CHA3Fduyq2Ws3xhXK7BDcbSHrbciKDFKjUzNDJ
45754	payment	2134	2134	1874	1	1	7229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQ8wiLtqiGHyTvQiV5e9PSLErxSKrwW1WswxP2HCj2NHwCmQ4
45755	payment	2134	2134	1874	1	1	7230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeS9mx6QRb2TZjxGxvs4nrXerFscVSNA8Aotu6Jkz6ApntP7zM
45756	payment	1397	1397	1678	1	1	17015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fBECvDi1rton4CVyLKBS4QJsy4rS5E1w8jbtm9m5MFeHRu8y
45757	payment	1397	1397	1678	1	1	17016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGgGCWZpLZx4Qo4z4uzVdZcyrkDJuZsErqH2txEPR1Fsp87Jj
45758	payment	1397	1397	1678	1	1	17017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ztjMDQhFNWbbTWdo7j5AHqo61MLus3L7kUn296YDtoBGsXE7
45759	payment	1397	1397	1678	1	1	17018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd61ka1iU1qkPm2pWLjdqhdBE5FJosVF32VFXgCQ97dea1ez6y
45760	payment	1397	1397	1678	1	1	17019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLtcBYZ27LgCdx5NiEpD8HdhsxgCARjR4vFjpTez5dF7r3o1x
45761	payment	2133	2133	1874	1	1	6827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BcqTdCcYQ2kSkZrvuh9qzyASSCQmekLrMUCHXisMwfPfqYjL
45762	payment	2133	2133	1874	1	1	6828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaN8CEzm4tdnCCaGnU2hsvSHo7YWJzfJeH4CnHr9pUwMFfR23
45763	payment	2133	2133	1874	1	1	6829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmS62YEEMmj4nr9MHEe36TuNSRM3p2fz8v495suMVa9dYcoNM
45764	payment	2133	2133	1874	1	1	6830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrUVRCvyUk8nTWuVFGCU3n28YqwP6fR4TwKz8TjNKK544AVNw
45765	payment	2133	2133	1874	1	1	6831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUDu1DzhWRJNxKFygo8tqULPVnXvUL2fdxSSAQCyanmJaEWsF
45766	payment	2134	2134	1874	1	1	7231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoYoUXVqmwV5ifPERDfsR6iaW7dMYyDAQg87miFDe3gJe7bqh
45767	payment	2134	2134	1874	1	1	7232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1eBXDpwZhYpyeVcKASt4EB9cum3oRSpek7psKjqzzdaToNkk
45768	payment	2134	2134	1874	1	1	7233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcafLHYXbWR1gkoKZrYjM7qGkujeeqzU2f4bjMR76QowWycmTB
45769	payment	2134	2134	1874	1	1	7234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyduBTiwSnykPprzace1TPccaMT77zfv1bwHSd8nSX1VfKPY3C
45770	payment	2134	2134	1874	1	1	7235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskXXfi6ptowZhS7byuopqxiXvFWedkduW3c52EPCtKjAUfy5t
45783	payment	1397	1397	1678	1	1	17024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsB5NqrQ7ZGALMWG3mrn35jvBoG5qR1CFFFREPvZ3ARYuRCqxR
45784	payment	1397	1397	1678	1	1	17025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonKgLgzEYmdJ5odCeB3HtmJcw58MbVzWtJJaN4s96bmjN3Emd
45785	payment	1397	1397	1678	1	1	17026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfu1AxKuLz4j9R6VsZxDFuP1L5CxddSP6zqUJ37QPuXeVo5YF
45786	payment	2133	2133	1874	1	1	6836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFxQ2yuKaSmdzV5FLQ7KZKMzy8Sqimvd3QuoKSuqu2rp4bFp6
45787	payment	2134	2134	1874	1	1	7240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6sDR835SW5XZrZ75aE9PGUkJSLXnCb1ox1tyoChaoeosgdPN
45788	payment	2133	2133	1874	1	1	6837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQQMiWRBNja1bCoLRNMfbbC5gbSjVsQCcfBqT6N9PLidsaMjJ
45789	payment	2133	2133	1874	1	1	6838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7zuEWg5KgPCdMWhupkUe1d9cFdHb1jYnQvmBBk5q7K2hGABA
45790	payment	2132	2132	1874	1	1	1721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyYxuFq2L5asjEkmCUPaN7GA8xNDovSJBFmb1YSFk8FJFyKHJx
45791	payment	2134	2134	1874	1	1	7241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkFANFWF3TmNcXnkw1gkUTf2Ld986LwpNb3SLa6UiebKJwF81
45792	payment	2134	2134	1874	1	1	7242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qQT4Jsn5rLaFZkyTH6nF4orKs8BSCfTbzCAT8SfM57vwJe1C
45809	payment	1397	1397	1678	1	1	17032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWtbCYTxdakyjCZiZGLRfZX2poPX2ZxHBP4J4h9Mgcfy7FETz
45810	payment	2134	2134	1874	1	1	7248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9gUjWnNzhknbvKRNSKuib6w2C3R8CnDSLEYMFNdorjx2oTKF
45811	payment	2132	2132	1874	1	1	1723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpPqwV66DPFBPsnKEQGqXagHQEtXStxLUibrUpMbVBTzbrroZ
45812	payment	2133	2133	1874	1	1	6844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLyfvNPFWmjGCfuTsvuthYMsVS7qbSfNahUx5qGRVJgjbEFwc
45829	payment	1397	1397	1678	1	1	17038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3t5dWjVzcK9kGZwtFD9Ap7QGSg2u5DEAKwT7na8zYAwDgrHZ
45830	payment	1397	1397	1678	1	1	17039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7BHSzzvBdpLQxG2VFfTHtfqzDoW4D8BkR9tXMGV3iz1zDsKy
45831	payment	2134	2134	1874	1	1	7254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFNqkHjc3q3UEXTneGitE879AzBumDE7dNsPaB8pMZomR7wLx
45832	payment	2132	2132	1874	1	1	1725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTC11D6JpuBLVzCZ8Sp43N7Aj3YVUVvKk9Johjrkq7ZyE5Jpk
45833	payment	2133	2133	1874	1	1	6850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkHE4pezaQzEcgsrnZ6re8xkg8dWTZUVSGjquz66yBQuGK1oG
45834	payment	2133	2133	1874	1	1	6851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2uBMK45nz7xRffHxVYBDyuQNAh22JZ5nwTNFbE7a36NUga8U
45835	payment	2134	2134	1874	1	1	7255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNrvLDb9mjCiH4yfnBBYgoJGJMbcmBXGMtkgAFM1rfDCu8UmJ
45873	payment	1397	1397	1678	1	1	17051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdQn4y4h6xKtte1tA1MrdSgWsEFZf4YNfXy9gSTVQxg3KFmnE
45874	payment	1397	1397	1678	1	1	17052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBs2Eg4LFdDwP34UYuFd19zLsfeYP6jGZqTtFGa1mCrXKVvvve
45875	payment	2132	2132	1874	1	1	1729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEsR5MSgeB51ixAzdd6U82KY6EoxoNLqRGxebdtLEf4Btjfjo
45876	payment	2134	2134	1874	1	1	7267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLwyQrmrYGeNFQ84Y4J5E8xWYx2B7VGxQ5MbD2PpqwdzFqk5d
45877	payment	2134	2134	1874	1	1	7268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR8r4aRiGziboJEkEMj3W65JeUm92XdUEiXTq8jTb5RjtZwsw
45883	payment	1397	1397	1678	1	1	17055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6ULhCRJyBY3G5PZFBxYKDhCS47MkouvLhPsUswJ6LeKygMGn
45893	payment	1397	1397	1678	1	1	17059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPu1f3L4DzwbayddtLaMwS1jmnv1UagNrp9SDHYDf69FrZ9oj5
45894	payment	2134	2134	1874	1	1	7274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhiYTFoejya3XtQ3Qdyq7pBi9CY1tJVgKuqhYthRGiNvK2aTS
45895	payment	2132	2132	1874	1	1	1731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5HGoh1XQijPayh1azXZ9nK6jAq6UUazoGpCMT4PpTDQ7fgPm
45906	payment	1397	1397	1678	1	1	17064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofCqn78kWacZSRXCvB5EppuLt9M76o3SdLFv7KYKwDzwRmZTw
45907	payment	2134	2134	1874	1	1	7279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nsU45uTgod62QuWSkQDoTYz7vsCQYUeM2FGHtwhm7EjTpJFN
45915	payment	1397	1397	1678	1	1	17068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZJfKBzVLFefz1eBECQP4YwpfrakKUWSPD1cLgsJnVx2tgyCw
45916	payment	2134	2134	1874	1	1	7283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQDxb2qtsWzdZD6m4QzSAR6w5ht3WKvLGtdJTUSgPCGc6URPh
45924	payment	1397	1397	1678	1	1	17072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GM7ZGBHgmnrseMi7HUtTJ8ANzo6t64TaDffVGwdhaaEvnnFo
45925	payment	1397	1397	1678	1	1	17073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUcu74TfNPr9DwWqz7AsPcZVgBTqfSbPcFD8PuCsY4L15Lcqw
45926	payment	2134	2134	1874	1	1	7287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNRV9srZjJbaTJdJzBvkEScCWtbKd7275WzTSpBgbhsNWWryB
45927	payment	2132	2132	1874	1	1	1735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6nix9GWux2tHsXPjDBWLg9vcoyGau5CQvvz8zMC2Tgkg6LXG
45928	payment	2134	2134	1874	1	1	7288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRXp4rCCxiKWWyY4ExkYBr3w8Phn2YddyQbBDJs4XdzwE962i
45932	payment	1397	1397	1678	1	1	17075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXyqskPTfyru7pZ1m4Uv9PX47mfkayYo9ay1AHLd8BhT4nKDr
45933	payment	2134	2134	1874	1	1	7290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmENPd4uVBzPj6Nqen7wnJ31A8YFpMFj7d4qjrqrdMnqSmyUwQ
45948	payment	1397	1397	1678	1	1	17082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYabXCZSXwn7uDPgjokXBUSkExbrpLa13HbgC6oszVJ2ScDFP
45949	payment	1397	1397	1678	1	1	17083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevRnjznkw2GjtBeySpxvXwQ398WHdc6DUPg8b9p3tr51RhPJu
45950	payment	1397	1397	1678	1	1	17084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULZqc1ySKjShjX9csmYusb4wouAYwSBK6z8z8qKsR7TMoWr99
45951	payment	2134	2134	1874	1	1	7297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HCsuGrYGUfuSG2ZoQaNcqGnWD2Tjpmo5Wt2Lw7Wc93by8WQ5
45952	payment	2134	2134	1874	1	1	7298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzakm8R9RS9uG7UqEkaiv9F4tLbS4x3YsSgA85pU2nUCBSMhL
45953	payment	2134	2134	1874	1	1	7299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy4ycW9CcL3TyqTPUAgafZTyQeyDNbjJ3p9FqUpJAnr7LT6FW
45954	payment	2132	2132	1874	1	1	1738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpnFGoSZrcUG7dTD4B4GjdEMjsQKLzTyERrEUzUq14a9D3wRJ
45955	payment	1397	1397	1678	1	1	17085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVheakfZqm5RbfgY6euGthj4PWiLEhYbAd2T1y1uBmJ6deRTKE
45956	payment	2134	2134	1874	1	1	7300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1Vuq3AzZqczkvZqUH7xXERVzANmXLoxohL7ZMQeoE8oUtHBy
45842	payment	2134	2134	1874	1	1	7258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy2aHuT6oXvPTrnGqGsjfPGesBmjZoQzVVPrCzR6ozBeonLJj
45843	payment	2133	2133	1874	1	1	6853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevgzjUpxbhytUybny4KYcYi3tU2JRLQtGCYbGZWrq3VkL3XZ4
45844	payment	2132	2132	1874	1	1	1726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2JGZEJWYDGeCYbEZmbBhC2m3EHseTHkxxsRQVp7fviZaLc2p
45845	payment	2133	2133	1874	1	1	6854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykELA9iPu7UYvKHa4AYwyF6YDRXv1Mm9CLt6CVuZ2tqJtg131
45850	payment	1397	1397	1678	1	1	17044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSEuKaBxtWLv219YTodXMMVJRmBpfvbn9kZadHCBBmwJ9J7C8
45851	payment	1397	1397	1678	1	1	17045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9qgiD41NhyWogkRVafd71AybJTPu2ge4hhdXWLDmyZgnofJt
45852	payment	2133	2133	1874	1	1	6856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLHPwmHmVxjEHXuEb1fWdGMqJU43kyuqS3i6PJahJNYas1tpZ
45853	payment	2132	2132	1874	1	1	1727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGi5368xRAAbzqZ1ccJkivMhFkzsjfVrYzkaVMyCzJJZWsyKT2
45854	payment	2133	2133	1874	1	1	6857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfumsxUgq73QYyzMBPNiUaFEtAiPrdFMb2N39GsPbiMzaMPgaa
45855	payment	2134	2134	1874	1	1	7260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhnU5eP43RG6uD4NfGY3zbdNVcgWE8snSwAxus6ebhy7rmSh5
45856	payment	2134	2134	1874	1	1	7261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuyk2bvhMDn2gcq9SygkNLu7a1SH4LLryGRnUCnNCt4uyn6eZ
45863	payment	1397	1397	1678	1	1	17048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2gXvbRt33tpXnBsht7ghGwtcVSMPDV4wMssYvKT5oLCW9XqA
45864	payment	2133	2133	1874	1	1	6860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFczwSanjGNRbK2L5aPtyU4r6TwinN2Afr8VDU6UwUTYu1ChL
45865	payment	2134	2134	1874	1	1	7264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvn5469Fi8rFkyfdSM9gH9Z9mhqBXkdvyjetHZb1Q2TsMoeFJ
45870	payment	1397	1397	1678	1	1	17050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1go5ceRJ98kZZNGoSQTU44ApHYX29NczxEY7YXbD9XznY4o7
45871	payment	1464	1464	2393	1	1	1	2158000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZHV7ffMzLRrzr3wnyEeLiXbf93T1foa2sGVGagSJSk6jNu3D
45872	payment	2134	2134	1874	1	1	7266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZpApARxpor8sQ9ndWwAHgk3mmeF1rZJb341jSXjjsG7yMEPA
45882	payment	2132	2132	1874	1	1	1730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWkhD7ZaPBSo6g6Nwqo4WPRxi8wxw9cN65kJuWZykjNmb967P
45891	payment	1397	1397	1678	1	1	17058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YUrXCxDhDpiRtR6cbshUHjLXEer91PWp7rngGCsNz4a8xdJn
45892	payment	2134	2134	1874	1	1	7273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZC4cWnuYrFQyu8Fkwdji2YW8ZvsMVzGkix487dAXzN4wzB4U
45898	payment	1397	1397	1678	1	1	17061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2JMaMB7eoYfiRBswtKvbSDH4SALzwCVay41BbjxLSvMYLhWK
45899	payment	2134	2134	1874	1	1	7276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYus1DLB1qBX2FHqiANQEwMQzmuxtTQVfrktxqXbFGQAaN1dEWc
45900	payment	1397	1397	1678	1	1	17062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXr11jrq5r55BNGjoXYmmhgM6c2KHpFNcDpq6x6qDvxshHycyV
45901	payment	1397	1397	1678	1	1	17063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCCqNja4j9gJkk2ZMsTq8eWgKZdsWxT7DJ4H1ynuTZEmg4A1V
45902	delegation	2394	2394	1483	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjoCGdeLruPBCmHCfu8ESUneef1sPy2W184fQHtJpGftXdp6f
45903	payment	2132	2132	1874	1	1	1732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqifhwq44Yp2WSZJdtKjRQL83Sz5QYiCbfisRw43v2jhs72Rxr
45904	payment	2134	2134	1874	1	1	7277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBeFR2kXo7XhuMWpqvW6M31xQijVAfCbeum4fECGPTHpk12HPQ
45905	payment	2134	2134	1874	1	1	7278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Ujtbrhs3sEx9JyK6KNEdSErLnEbgpgbZTG1K24aBYzHJMhT3
45913	payment	1397	1397	1678	1	1	17067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwWC6RuL8JBLcCs5zPbJxV8rWy1bvuTeHC1ucb1NgqDasSHJu
45914	payment	2134	2134	1874	1	1	7282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdqd4acad8o7qZMyg5DiiNDx4VZcvF2HsycBk2Moae2o1A26x
45922	payment	1397	1397	1678	1	1	17071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcsqN6hRqXoDVQoWDbz8F381mE3Cu1smnosz2LCkuGr9cpqPi
45923	payment	2134	2134	1874	1	1	7286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENVNhG5amCvUTYotxeFoa3Kg76Z7dgEAkjtMnespwwuXBEX8S
45931	payment	2132	2132	1874	1	1	1736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75uN3p2twVh5B3yQ2nuxPgUvDyAmVjQVP5BSbFBX8f5q1WYej
45944	payment	1397	1397	1678	1	1	17080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfbNxB79aB5GaAgs1XAXZmcSQbmbSdTDi6usVBR1b6KULHWgpb
45945	payment	1397	1397	1678	1	1	17081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJvMFunMeSVdoHsATPJujFxcTvnVQf33uTF87Ysjt9uSVLkKf
45946	payment	2134	2134	1874	1	1	7295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJL6Di75XCdqysxsTUga2EVGPYsSbQNGZZeMGCkfgcWEPGuED
45947	payment	2134	2134	1874	1	1	7296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBZwpN68j3MH4eXTkWfaao9aZ7FRH3QKULah3WqrVekrB2FZX
45977	payment	1397	1397	1678	1	1	17094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4JefMqCeLRH9mMaiv57FDB13bsTc71z8zrzZLB28S1mmqdTJ
45846	payment	1397	1397	1678	1	1	17043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6J4SDxZzQJcEMmPCct626EXc62QfCatbWCr5zUemkffAWuDpj
45847	payment	1464	1464	2393	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7fJ7nYq9rPMitxD8bZqPFRVe7mdK4XjRWC2kQH99UJvNMgci
45848	payment	2133	2133	1874	1	1	6855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvu8C5JjkLfjrZsrBFGz7Y6dvs1vkTnzyoj5m1HNVX7mRNnNM
45849	payment	2134	2134	1874	1	1	7259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JQ4ByDUoXmg9ero3P6mbqEvrbQzrw1VSpfouDB7ajWbW2HTh
45857	payment	1397	1397	1678	1	1	17046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQXzXgGXM1BLLhAYnvn2vgjLtQPtxKEJvZbpeF9HCTaLRyukN
45858	payment	1397	1397	1678	1	1	17047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmW8ro5dNj1JpVPArd9wDj1Y6QZKGj695JvJxwAxSKfkmDGfM
45859	payment	2133	2133	1874	1	1	6858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5QYN4V6K2nsyehr138zyFSDmynD6crfdAPKnX1pcDQuz8XbD
45860	payment	2134	2134	1874	1	1	7262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHsd4296HUdT74EFPiasMtKidYyQsR9yueXufW7BWs7HXYsM8
45861	payment	2134	2134	1874	1	1	7263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAox2Z6dv6kWPy4B3gewZ5jvEvAWrmPp4cmGzT79EobT18X4L
45862	payment	2133	2133	1874	1	1	6859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6LEkmcXKAp3F3a9m1puQWXU75LjsxAGZLSgtjaaVb9X8EaAa
45866	payment	1397	1397	1678	1	1	17049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRedr8a49dGyJn2GRSDeZ8TTvj5uKB5NF1qDsGa5kcNzv1WYU
45867	payment	2134	2134	1874	1	1	7265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ChRU1q1jydyL2TCsEEAMHbwEcX9mMVDjAXF23zTwrLVKDDwD
45868	payment	2132	2132	1874	1	1	1728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YBhMBkm5rmgv87HWQCiaqHTRTvxhX63zfZgY6rZFnpkQ7qgJ
45869	payment	2133	2133	1874	1	1	6861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ys3bLHCQMViXXdY4eDqGLXenRh4GWzLasrJeNfmQmLH2kWk2
45878	payment	1397	1397	1678	1	1	17053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RJY47pvhTkcuQiuwYkfiC9RKfxQXWr8X6zT7ZPM5J8S7egw5
45879	payment	2134	2134	1874	1	1	7269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hEk56nGY7hNqVunutne4UEbkhZiHWcexFxYc11EcKRXUZzbo
45880	payment	1397	1397	1678	1	1	17054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqNE5viYTKrdpfGNWfSSJZCK2NWmKA6YD8S4dVvji1xCjY8VU
45881	payment	2134	2134	1874	1	1	7270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX7VQ1oeh7eiTBpY8WpQXSEyiuoJzA66Jccj1dNjejDahyr6f
45884	payment	1397	1397	1678	1	1	17056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXBz5AGLqNb4mQoKfcDvb8KwTrKsvPWGuGcG4xo8pVRrYZzYj
45885	payment	96	96	2394	1	1	0	1440000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rBL3qmo1wwh3xYqWBVyw3zauuNi1hzCL3LCcJDZ9dspN5v98
45886	payment	2134	2134	1874	1	1	7271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaP2jmpCeAs1uXoqQhTkGwBc6S4R6eKBEyZ6gUA9p7dez7n6T
45887	payment	1397	1397	1678	1	1	17057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8B67NTAyd3DZ4vwbeZyGoGNFyC5HJH3h6dxcRSrKs5rqbHwc
45888	payment	2134	2134	1874	1	1	7272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAtaQdYs1USAfesRVLaUJ4XHLgN5Hvkk8rcH2ZVY61xRTuwXB
45889	payment	1726	1726	2395	1	1	8345	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdSekhfVMvjxPS2fcHv6H5cuZE9m1bWeUk5iKpf9fbD787Simp
45890	payment	1726	1726	2396	1	1	8346	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoQJNWPW1Bgxg4M5MSMXJmabeMoFnW2UMquuKaE828Z32G9ohC
45896	payment	1397	1397	1678	1	1	17060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuQ2662z9koC6X6b8o5GTwnyEF8ZxSu9eenQFjEpJA3PzHASv
45897	payment	2134	2134	1874	1	1	7275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yYdoiRZU48qr2C3N5qv3cAndmqrtK1ZRk33JLXxdGZGPnUPs
45908	payment	1397	1397	1678	1	1	17065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoinB7qtWzANKVcFjaSWy5NAK6htYxgX9KogaLGZFZbUEHLxv
45909	payment	2132	2132	1874	1	1	1733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBh55LfrK24GpFiezDeaAbfiPjXCbYPGHcakYduDE5pFnBZem
45910	payment	2134	2134	1874	1	1	7280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zpPj1QoPibE6vDSFgBTVDJYQYKu8mpnK7YXV52g3227pBq9L
45911	payment	1397	1397	1678	1	1	17066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPXfZuNua5qNG7v5RW5YSS2fEHMG1eDhWLtLcSoBKaFy7sXvm
45912	payment	2134	2134	1874	1	1	7281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhC4nBDHXW4QiSeQae7Lv64PRKHNTCq58KvybeK85UegCc3RSk
45917	payment	1397	1397	1678	1	1	17069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVU7ZPcNinskRxTYgNazdFMCghLj9fRwVaV17P4YxXGk7ApeM
45918	payment	1397	1397	1678	1	1	17070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrUd4faUSLb2QHmyAdKyeaoHobG1P4F1R4a1Yogkdi6y2Yw2s
45919	payment	2132	2132	1874	1	1	1734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBLHqCztPhjg1YCdHFxK5MTBrgAv7krJ7y7ASLtLMqZfsJjjy
45920	payment	2134	2134	1874	1	1	7284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKePFbDq2mpxJURqSeFXwrH9CpubDW9UMNsMxzTvqsYXViBjCw
45921	payment	2134	2134	1874	1	1	7285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLEUjZxxmfmAevrm6pnFUjiutb1v9m7GbyLeLFEDEyYfUmYaK
45929	payment	1397	1397	1678	1	1	17074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaaJZxRe1VMPQ6AwkkrKKyZanqsz71DS1z6JY4aqHHU4TJpQm
45930	payment	2134	2134	1874	1	1	7289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nHPfuVaSJfraAEwakMKaouQiZaBjfkSzjCekwZka1YYNqNGb
45934	payment	1397	1397	1678	1	1	17076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBHyrG8n2ZofxQaymWL1WWVXkV6RhrG37nJ8W5GZGFbBZHnFf
45935	payment	1397	1397	1678	1	1	17077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqy7TXwF8cTeSkhFErtJNUFZy1vKQMpupBkiFjpjU3dM384CtC
45936	payment	1397	1397	1678	1	1	17078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvhxDhh1ruEQDzuU1R3iAAMHLNmbXv6xe38bqAX2AN3DiT4en
45937	payment	1397	1397	1678	1	1	17079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTP3GqATv75nuugfQP6XS4gWNsJTD38YLx42DriXJVoSUEACg
45938	payment	2132	2132	1874	1	1	1737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANG3pQq4Bo7fiMCEJc9y2L53pK1PQzVHcK9UGcznDpT68ZHiz
45939	payment	2134	2134	1874	1	1	7291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7o2eAuYosTDnhSRrkzjREo3zsCzPxrjvxqzCmXZqCo7WPhFZ
45940	payment	2134	2134	1874	1	1	7292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgdgvKmNV6XPgkSpqP7w7Kvboy1rg1SFXerMGmpubn3T1288B
45941	payment	2358	2358	1816	1	1	0	0	1000000	\N	E4Ynu7seRhW9GYFf4Tig6NDymTQc5chEQXhXHdYFr7Caw9DfbVYLP	CkpZjTbC32BTZu9mXaHemibZcjyAQbvTwioB1B5m4GMmNoRKdrXfs
45942	payment	2134	2134	1874	1	1	7293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Dg6QojKouSnxTp2RnvA4EGKBZDmxjz6wZWZg5ys26PaRR5mh
45943	payment	2134	2134	1874	1	1	7294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5SaQhLjSop3vdxn6BBLKbx1TxWANHRk9Digq3MV1jrnRUf5x
45958	payment	1397	1397	1678	1	1	17086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVHhvJLUbqish2cKU7x8wUpApX3Xh8oD2bWJ5e3FZZ3i2e1R5
45959	payment	2134	2134	1874	1	1	7301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuChaxGmCD89dwrUa8v8NiZ3zonDFbu8c6tVXFwmkyxmZVnB2
45980	payment	1397	1397	1678	1	1	17095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswLnbFEbQbPoudHPHhvZFx7wwd6QeTpGNsLy643SKb8YpDcvo
45981	payment	2134	2134	1874	1	1	7311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgAxyrBCgj1KcwonQZq65jQBmCDXkhurY9HEMQdiDNLmYp3ic
45989	payment	1397	1397	1678	1	1	17099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmquSaYSzRr8KrPVvF5SvKmpMk7bUbhuPGM5AB2Mibzmkcv2Zf
45990	payment	2134	2134	1874	1	1	7315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ6N2p5FR3YF8d3pfsRR7dTfA39r34CZp2fRMcoUf7aSGkMZf7
45998	payment	1397	1397	1678	1	1	17103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9HU5yKMWrNUGZgefF7gc2SmU6kqK487zCt9owhLgDdEGAwgQ
45999	payment	2134	2134	1874	1	1	7319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hi6tHA2xiCQBQJw2R8Xeirf6N8ZL3HruDpWLyqWxSuXWW629
46016	payment	1397	1397	1678	1	1	17111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVs4SA9TmRsAnTQHr8CZBFNDdiCzPVV3Uop1AyZcxAVUCV515U
46017	payment	2132	2132	1874	1	1	1747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRreqdgy8tLPKporieUf5MgNQqXkJ28ZtsDF1USSFsmutMKdcA
46018	payment	2134	2134	1874	1	1	7327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9aYbjuQWf93C43QsyZayhLRhBmVmzQ4dgKgryTPCx2wVgSiX
46023	payment	1397	1397	1678	1	1	17114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqqpuQVuYNedMY7yCCEWWddaCojideDAe2AccAKoLKP56Uwbk
46024	payment	2132	2132	1874	1	1	1748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwJMPFjbPYXH6ZsLJ8XumYoG1yS4WifprLYd3Z64irQhczM8w
46025	payment	2134	2134	1874	1	1	7330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1GzEnfexyfEq1X3oLYVYxX3wA7RYgx8N5m3LHM752SQ8L5RV
46059	payment	1397	1397	1678	1	1	17128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfFJ9mEFtv7QY43R7i7p8fZYnAL8gGuX8TTJDzijqweUJxjiJ
46060	payment	2134	2134	1874	1	1	7344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4rXvhyKLpsxD9N2cEisp9xP7dX7Aoo8ksgc4PstemwHDtPkx
46061	payment	2132	2132	1874	1	1	1752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRa173xZtTWX7tXyWToVDUfCTMPf3MvUhJAC2syZwAG5L4vR6u
46069	payment	1397	1397	1678	1	1	17132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMpwi8GakXoeLd7b59wgxQMgbET3Y8ZuPex4uGGJ5ze6uvSzh
46070	payment	2358	2358	2358	1	1	1	0	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZeibqe22edsjnXD4UYvRXaw3WvPWNVxBKqtKF9kNnnc6Whss2v
46071	payment	2134	2134	1874	1	1	7348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkS2d71BcuPb21a1NreAYWpKU6PqqKXqXt1YzUZQvZPDjySm5
46080	payment	1397	1397	1678	1	1	17136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBwjoGBVtPCzYfnBoLtcGTQF6hMSpAeiTfw1VL7gUBHUGx4jx
46081	payment	2134	2134	1874	1	1	7352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR2jMFNKzekZCRpz46gUwVq6aA3N1T4dhoiGPF8wNtDd84xiU
46082	payment	1397	1397	1678	1	1	17137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFtEg49BpujFns3GTBL2utYjDA4iGr4Lmf9yV4oBYanmUUWEx
46083	payment	2134	2134	1874	1	1	7353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSP3QU3JhbmUUWRFvGraN6coBoBTSK5FSqFRhMix2NatLagTV
46091	payment	1397	1397	1678	1	1	17141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31GfUQmS4DV2qv9y8V6H2ETPZK4f9Jt2CRzsQws3T6YDMhJvr
46092	payment	2134	2134	1874	1	1	7357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNWS4ZVFcs6CXVsX87GXwEqsuxNbs3tQ1z2wAnUSoivb7UjCx
46093	payment	2132	2132	1874	1	1	1756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZMonJaeFsZZTdq8NazDgMc5KC4K6h9KZ5CnxWiizUTqmNxLv
45957	payment	2132	2132	1874	1	1	1739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFSZAKXcEysxoUw3jDi7FoSJN42bZEPxzx9dZf6Prvtp5sBqf
45960	payment	1397	1397	1678	1	1	17087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRd4nPvqk6yiFcpz4fCeSRt5M5n8QirJodPFLo25qbAShrGHN
45961	payment	1397	1397	1678	1	1	17088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQcTX9co3x5aGntgW35jVdW9wRfHEusPGixVPcDZ9kM5D7DXk
45962	payment	1397	1397	1678	1	1	17089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF53GM3DKwYnXjzzup57gY9rYb3EcgNZjZMvKyitoit4xQ8J79
45963	payment	2134	2134	1874	1	1	7302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3Xfe2rqCDyVP7LkycRQvxwYD5NoR3CgNW4kPLkXBjhsZWkms
45964	payment	2134	2134	1874	1	1	7303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjszxrJ3NWnehYD7DpNn6V21iydgBgE97g1nRtiDsx2tpLSHm
45965	payment	2134	2134	1874	1	1	7304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1AsPmghxxxBwGZ5tcCqpenadStp2n6K45aUGryjq3f3J4252
45966	payment	2132	2132	1874	1	1	1740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCgNJTiD32ygHpjsfRhUFpuK9R69KNgvdzht8h4Y3xBgGMXyr
45967	payment	1397	1397	1678	1	1	17090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiTunPK66eyHEN9RNu8aJ4A93cAnmnmPrxwvj4Z7sorm1eNT8
45968	payment	2134	2134	1874	1	1	7305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7noE8g2ZJJKwYgtww2Au6gAtPyUGsHa4t8neFXNdzyenjpU2a
45969	payment	1397	1397	1678	1	1	17091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xMn8zDhBqsrW9mmhVRYqNwnn6Xzq9LBZDCCeB6WFT3gKSwZH
45970	payment	1397	1397	1678	1	1	17092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMowH4H2MAYekHwypydFUXPpaZvdkpXNncm8WW2Q3oL5BfYuB
45971	payment	2132	2132	1874	1	1	1741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXMgn9cc3P81jZrzJmEsSMJ5CG5FXiHLr19JSM7FokrSVpCSC
45972	payment	2134	2134	1874	1	1	7306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTEfUvQv2TKkEFUsS3673PkAUpvDfxntCopECqtLAQH5ufRJc
45973	payment	2134	2134	1874	1	1	7307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJDgNA3ApxwYvqmYUxCgP7BN5DpqWqB2Z646ueBWjKHurvevp
45974	payment	2134	2134	1874	1	1	7308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ2cMrjdfc6EGx8rBxVFDtopENpJpg8e6Z8T1bPMarU3h4Ynq
45975	payment	1397	1397	1678	1	1	17093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZCQxJLpvqGbxRLKj23m3tj2FHHgDBjn8FdzJhPZ7wSNVTfcF
45976	payment	2134	2134	1874	1	1	7309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLFsXUP4QN9WeGNNcLi4V74pqSp9bTY9xHa2VhDLwFXKmAVFh
45982	payment	1397	1397	1678	1	1	17096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGgmrjtjwjtgdpN8MtZZxe7jUxaz5kuXpNRQWNk45hRuLHhHy
45983	payment	2134	2134	1874	1	1	7312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwaH5TSd3PkvZ78xdF29u4T8g6uSgyhdTi77hG8zYsr3igVtz
45991	payment	1397	1397	1678	1	1	17100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGJ2pep6mRcG2NWvRfCyCnyUVEhYM8cYnCTrf6cJpYcy7fXTA
45992	payment	2134	2134	1874	1	1	7316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHfgqHm4QK6oGLBQCFaHNfLrc7wVbWZwET3etCBjefjEaWr7o
45993	payment	1397	1397	1678	1	1	17101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ88zSYaU9EeWyM7csyS3Vy3Rr77P9PNWUWikQauHDuP7EVgTU
45994	payment	2132	2132	1874	1	1	1744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sL9n26RbpgZZL18szBvEfkGMm2TA894fXFp2CeRMTS2t4LFV
45995	payment	2134	2134	1874	1	1	7317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yTYJc3LCV2bnaLcLHBME3sBRWkf2Csc7kPPRatsbB6KgTZuQ
46000	payment	1397	1397	1678	1	1	17104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtawTaH4grimcecWxt8hhB5ruLBgJ3ECTZXsRNYeMoTUJbdRiu
46001	payment	2132	2132	1874	1	1	1745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntHY1NNn1Fo2PN6Pic7XvgyURrLY9x6eUdxiMSXx1exRH1zc2
46002	payment	2134	2134	1874	1	1	7320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZdEa8Mza2m92RW45SAfn8UcpemR5au11xNk2PvTmVCpVAZFZ
46003	payment	1397	1397	1678	1	1	17105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWknzVcgm4PvXRz4WfvE1u2sTkUR7bmVoVCw6D17CurL4wrKFC
46004	payment	1397	1397	1678	1	1	17106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4kUtehP4d2js63nU2e4PUu8dgh4tNWQ39a2D2zxVtGX72NAb
46005	payment	2134	2134	1874	1	1	7321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8d4saL6c3bj2TGazvLEdVf9gjcwhvQYj3KAZf88JnvjDDAYF8
46007	payment	1397	1397	1678	1	1	17107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7rHtWpXGHQhqurGVf2CYvxhYJQ59GBvFb2EXwSsqsWG2TZqn
46008	payment	1397	1397	1678	1	1	17108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmTbjTbtZK8xmoHiW3CypVTXyRZH2T7UUYnGNcAGEQN61RkrS
46009	payment	2134	2134	1874	1	1	7323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVeGVjvbudVqzFyvatXM9A6zMgnDa7XtEQPgdwdUJePVQAGDJ
46010	payment	2134	2134	1874	1	1	7324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVxDrscw76dshUfCeaNcbMfT1WJUhACgmNCU6UtuRfc9nyubU
46011	payment	2132	2132	1874	1	1	1746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRq69TsHettF5NjcyqmPyh5KHAA23fui3XsXpXWYapXQLoFcp
46012	payment	1397	1397	1678	1	1	17109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYTdr5EdhsLwtE9jsd5UmH8BPAZqhkkEfs85Fg3d57a2ewQpc
46013	payment	2134	2134	1874	1	1	7325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14gK37jyJZHnh51EL3TyTFSrwT5JCVA5G3AaQAQb53PoPiGr9
45978	payment	2132	2132	1874	1	1	1742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwiJNGH3jaa5pdynJpSk93MLi5va7xa5gr3uyjWD9EcXJpD6J
45979	payment	2134	2134	1874	1	1	7310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYpwpZngCnKcVhUbhpjCdoJw8ZDzcPMMMEn9Hboy1nrSLNPrN
45984	payment	1397	1397	1678	1	1	17097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMLVTZfwJzN4ieMP71sk6DAJYqXk4yZj7xFAtFjc3r1k5ReNF
45985	payment	1397	1397	1678	1	1	17098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnvGrzREcWzP1hx8Bjev8oE1q6bYNH4ncoYJGF7azecnDofAK
45986	payment	2134	2134	1874	1	1	7313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsX3bnC2PAmzvSbr9RA8KcfLw2jEw5LVCB9yi39G7zPZKET3og
45987	payment	2134	2134	1874	1	1	7314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoX4GPLhm2Bdvx3kj8PvUywokogpdUvZLswN9YsUPTqVb3YJ8
45988	payment	2132	2132	1874	1	1	1743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBVnXd1tPB3afUuiSoebpPMULxeZKxtDHi3j5TgcogpevEuZr
45996	payment	1397	1397	1678	1	1	17102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKQT9ii45M23ew9pUbqpToHNgFQoGtBoerm9nWiCtKMBnETrb
45997	payment	2134	2134	1874	1	1	7318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEsgaCivNDaQg1LJy8ZCs1ht1xt81nEWCrRSz7gyKTFkvr5hA
46006	payment	2134	2134	1874	1	1	7322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFkKdrHcc9EYb2WF12YtaeFqsd5YrTGf5MzizvJv54A9FGxrE
46014	payment	1397	1397	1678	1	1	17110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzJ7ZA6wyv2jMvFCR4MAApKtHxNCXz1Dqb1GKBGPnjE1DQv6E
46015	payment	2134	2134	1874	1	1	7326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwic3dszSG9PAP3jrZUn3VLeUqoBg8HW1RC73BX4b93fFhiDwT
46026	delegation	2394	2394	96	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhsHi132Qzf98qvoU7w8EJg2K9D7nGDpwjvtywL7ufkhyKT3H
46027	payment	1397	1397	1678	1	1	17115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vsgdS3euKHL922BZTE5gYPetxsTyocZ4w1JfGdj9a81PCjVQ
46028	payment	2134	2134	1874	1	1	7331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrEeZgAyUpvgf7gcPQC7fB6XXNfcQ75RfNQdAxAqJCp4mymaf
46034	payment	1397	1397	1678	1	1	17118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2Jj44t4CFAdvcDoWtPjMyTKFafLnYWzWcvuV5QRUzmKpb12S
46035	payment	2134	2134	1874	1	1	7334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLLjgttqXK9gieGuYw7SM5fAAPjoaLX1bfckeE5bdtpMMkCF1
46036	payment	2132	2132	1874	1	1	1749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKU2mcwkBHCYWWutq412pcREmbhS1RqjoGFELxPzHqDYMNNCZ
46039	payment	1397	1397	1678	1	1	17120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnYDePNxPN8ocrCcVQbJUfwK4YJZeHJL3uy7ZN7WvYS6XV4Xp
46040	payment	2134	2134	1874	1	1	7336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLhBBfb6aaJ1bA4BKCeuh4rHM8cnbBrhqmWTrgF3sVFKvWEpZ
46041	payment	1397	1397	1678	1	1	17121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtpb65caZHSjQNk6Tz3bUCzqjbF1kPxYdNanQgCkpEYLupKyC
46042	payment	2134	2134	1874	1	1	7337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDCqFJYR988EnGK7zinepyXMH76LZ3SCkdVCqYfkpgzQFhzk8
46043	payment	2132	2132	1874	1	1	1750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqK57gcaEPfQqXsUXtFLZunW5rJmzhG1qXBrNfr6hZT7zyowDw
46050	payment	1397	1397	1678	1	1	17124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihVzZXKQjKHhW2gXDAjaFmHhNL58T2jFvyAFa7GHZvUMp4Bdi
46051	payment	2132	2132	1874	1	1	1751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbssxuaRDFm4YC6EVnUfbSQ68WempUYAGnFbfyLsKqif79LWt
46052	payment	2134	2134	1874	1	1	7340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhhbf14HwCAwmuzWMPyn6r41fCKmzhxEZAdHFNrfWAW2NQmJJ
46062	payment	1397	1397	1678	1	1	17129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuLpENof9s4YXkZ3iFzktqToJgeTQbiSuqnS2Z1xKHRfCQnTS
46063	payment	2134	2134	1874	1	1	7345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEf8S4zPTyFRoFrEMNtr3sF6h5a9Ss3Nqi6ofEzpLtSLZjbkG
46087	payment	1397	1397	1678	1	1	17139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtJYAHtzm2ntESCesyVnH1GFJ1NHUKdaWHi3gvzDzG1rhAT5Z
46088	payment	2134	2134	1874	1	1	7355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMb59seKBkKZjsgPB2feDdRD4oKBSP3EFjCwEBZDziv9zFhSY
46096	payment	1397	1397	1678	1	1	17143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaGS5vj9i5fJF5BqaY5gE7tDLDicrBGtMVpkUkFxagmPoGr4Q
46097	payment	2134	2134	1874	1	1	7359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVCg17vMnbhGZmfKivdgF7xKx8rWst4rSTMFNXpqJRDiSnLMS
46105	payment	1397	1397	1678	1	1	17147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmV65chGusvrQqFfE5AUQiPjmQKFFbnG71qo8Rz7mkYLd5isg
46106	payment	2358	2358	2358	1	1	2	100	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYaNPQ4syiTqh4QtosUYZsz7p4RD3gYzFkcz2bg5xWqCSiXzQgK
46107	payment	2134	2134	1874	1	1	7363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96nnCW47AdXfcoCVNHFSpyxjMf69P8cFai745JM524phTUdjv
46115	payment	1397	1397	1678	1	1	17151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibrYv8n28kkzf5afKbb56phQP4AJ9HdcQ4QrEcXFoFvvWvJy2
46116	payment	2132	2132	1874	1	1	1759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxJ6M5FtNtmhd4fPm9GhkY6uuSS4bPnfdeZezawXLhgGWpqRX
46117	payment	2134	2134	1874	1	1	7367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzW1hzsMHki83pJi5cJycSo5sjyR7obLLqKsME1meAqYZBbo2A
46019	payment	1397	1397	1678	1	1	17112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFZe5huFngpKYdAbm1PdieCuGdXT6rTfkB9bFc6tWjEfHRMVo
46020	payment	2134	2134	1874	1	1	7328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDaKwDCyu2JoJXPgtZEck5f1iNa8AGMngdjtJvdVV7H67U6xJ
46029	payment	1397	1397	1678	1	1	17116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEyNwo2J1w4A1cna7d6jzTN8NNTEeSYxtXroZUhyRzE3KukH5
46030	delegation	2394	2394	96	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZXYBBk84gtwLTDbWLAbhiivAJe4a7odwDfZ8E4aSwbPvRB5C
46031	payment	2134	2134	1874	1	1	7332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC2fX6fZtcDG5dr4nvBkiGQENZfLoofgrHeTxaL6EWgQA7fak
46044	payment	1397	1397	1678	1	1	17122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcZvXQ9r6uTFwTS1YExYQptxX9jZKV8XhCCxvyRvnkXEyeBkK
46045	payment	1397	1397	1678	1	1	17123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YNpJeWumLouBCk7dUvU79WAym92an5tZhh7GaFDmFrCSP4oP
46046	payment	2134	2134	1874	1	1	7338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi79P4tktDEv7yENFea2eL6d68jv8iNKiS3fxEjGGbYbr9YgVS
46047	payment	1769	1769	2397	1	1	63	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jjcokZ7q5FxCE4vYBT6xGUaZF1DXGd8bPZiuwHnuyoALJdgt
46048	payment	2134	2134	1874	1	1	7339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9qie4ter1NCBMWXL8UUu4gdxspdhRpHgcR3wFELkiUEey4FBp
46049	payment	1769	1769	2397	1	1	64	50000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ajwgAn7zTZBXwoWRvBZJLLtrX8pKXZi1hH55wKZgagrXnVK3
46053	payment	1397	1397	1678	1	1	17125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zqhQK38LgGWphpzhxzQg18MFumG9vX9JcT2XC9PQ9xi3ChFs
46054	payment	2134	2134	1874	1	1	7341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5iVqNCvgP1ZLEGdoGpUMe5YwF9Susqet99AdPDc4dxPVU9bY
46066	payment	1397	1397	1678	1	1	17131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ9GYe2Wmm3JbdeXDsAM8zvsijQKroG18qinQSyiA21kYrTZt
46067	payment	2132	2132	1874	1	1	1753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq17Rg8gbf3zp7zCcy5aaecTGbSHdDaUyRpmGG1GqZ6TFs6Z4
46068	payment	2134	2134	1874	1	1	7347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zvhnckQwa82DLmEJSjnzsNMSq1dKCUzFnDvJZyGhRhUzfYGu
46072	payment	1397	1397	1678	1	1	17133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1spqsgHDzZjyTvFz28CRbGa2S6ak2dWHctZRVpZDhA6NgYtV9
46073	payment	1397	1397	1678	1	1	17134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuPSxn3wEy2bykAF6RwVcNiPj435NfzpyS3sbNuWGfjYbfPYP
46074	payment	2134	2134	1874	1	1	7349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NcEwKVUmfHs9hn7YvAQB6tqUZ7RGvXiu5HNmiALMJfZDKAZM
46075	payment	2134	2134	1874	1	1	7350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpr1cWnTKGgWJmwmAgJH7h4T2rCH3ynt1pLt3ZGevRx8csGxZZ
46076	payment	1253	1253	2398	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNHeS5Hea1ZnPgB51LXsHQgZfwAwVuq7aYsqUgatwmPytVHMr
46077	payment	2132	2132	1874	1	1	1754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56V5x4JCUegsbvEbzP4n1oeCTjqSNK8vNht95yhsLVovtV2PD
46078	payment	1397	1397	1678	1	1	17135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL6PwzfpgmKJYWUURJejjLxkkC9kHCS7nQxv6oA2ru6Sg98DeW
46079	payment	2134	2134	1874	1	1	7351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxasbXvYNNzW42QcefjE6UjVAEjRLrg3uPa9SsyvBmxcmWuyZQ
46089	payment	1397	1397	1678	1	1	17140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqc7UdX36HefVBoRiCPctZJ7sTrBu4mxowQFocj8QjzjqhRXsM
46090	payment	2134	2134	1874	1	1	7356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NEmqazvnHpopDBShBAemw9zevaTZ6dYP7aJzWdpiuDHiy3mm
46094	payment	1397	1397	1678	1	1	17142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7a1LqaLLnxMZfRh3ThUESjBXeoRnGnXCx58qLjLynFmDCYFYh
46095	payment	2134	2134	1874	1	1	7358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDnaMRoUFKxZwW4sXR8RDAzFo3ozHzut3DBFVCvzhVQeXvtFn
46101	payment	1397	1397	1678	1	1	17145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3rRZxtmkThvDmAyZBKHD5EdHggcrxALxyv1TsqPmtZXEE57b
46102	payment	2134	2134	1874	1	1	7361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4bvXBMKmSzWtsiJdLyERxVLMBzRL6mHQuj5sLe8fzZqrvVAC
46108	payment	1397	1397	1678	1	1	17148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWqBwVdFwxGd5mtiSdSX8GCWFgVvEHxcPD5yy4CeuURYiSYdV
46109	payment	2132	2132	1874	1	1	1758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWojrNF8WLSMCZo9dJAT9QpQFRnD6bmX6LcqSkn3ntYoSeoU8r
46110	payment	2134	2134	1874	1	1	7364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkomUMej328yuWPyYPaxTfMiekxSg8NSEp7zok3LuZ4v4ZLkBx
46111	payment	1397	1397	1678	1	1	17149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxYFTokJgZUdKVzs8E9zuG9fobhmpVtADyyXvdY8iCWY8qxCA
46112	payment	2134	2134	1874	1	1	7365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfp3VwETQgdBqgb4MNGevBMuo4fTe5WfyESmrJqFFuVgUtoVEw
46125	payment	1397	1397	1678	1	1	17155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21UcF9BF1umH2zpasCKknebnfPHx9FMvEGM6fVGgAq6gwhXrS
46126	payment	1397	1397	1678	1	1	17156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfDdhgEWTPNm9UWSxDZLz6YHpAdyUQ2rYhHB5u4LYz3RA2m5i
46127	payment	2358	2358	2358	1	1	3	0	1000000	\N	E4YWdsZTt7Ytd6GuudRH1w4YmxCi3uBFmALVwdhJ5bUqnXtX4CeU8	CkpZsiHbLN6VB51dUtsM6LpnnKAFJDifHgKoDQ6LahpL1HkYUU65M
46021	payment	1397	1397	1678	1	1	17113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAPbuJYLxhwLNa9LvCGj1xNNttCBYtTTVHB2kXvr9sq3EpAPo
46022	payment	2134	2134	1874	1	1	7329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtALw6w5gCBbRsYReXnVB5B8hs6v2nEiqR9gTX9ERrsE8jm3Ww
46032	payment	1397	1397	1678	1	1	17117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNcswyyLG245UXWdfcpuv3XEf5g1ohkwd93YbrbmbxvQ7Lo8S
46033	payment	2134	2134	1874	1	1	7333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpiZDkYLL1MuS9xJtRT95dka4uqNJWVLTWumLztqGqeTbTYk3
46037	payment	1397	1397	1678	1	1	17119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFV115EvnTHwcFVrdMQDRet5mBtac2AapACGNYyJJ3b1Tihfz
46038	payment	2134	2134	1874	1	1	7335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tdh6KZqmCsWnbWym4U6KcANyhUS5LAVxUxki5QJ6ygy6t4Zi
46055	payment	1397	1397	1678	1	1	17126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ9MyRw9jMeZC7cPCJnKEd1CoCmdVD4kWCsfTj6FDj9Tpv5NB
46056	payment	2134	2134	1874	1	1	7342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHS7UXDaZfayWvFQdYwhL2FYQpNL8CSa4brEgm1XbQ2YRVarH6
46057	payment	1397	1397	1678	1	1	17127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MtVZy8R7dvXu3ENBdkv43eD6syeNSFnJfReLb8bHA1xYD5iy
46058	payment	2134	2134	1874	1	1	7343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYK4RGQQ4JLpToDLaY8VvGgVxGH3UgLwibCjr9ZNPbLJuqwwR
46064	payment	1397	1397	1678	1	1	17130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbawpUZ9CqUmEqK2einKz8V6HqkKDLJHTqDmB4BghKLvCTwwgs
46065	payment	2134	2134	1874	1	1	7346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDiyChjiKrhTGrvAdGRJLMeGj1jmS9XrFpR4VUajsVvWQPtrB
46084	payment	1397	1397	1678	1	1	17138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRh69CMiuJ1ExV2TsMAfCbUkYM2Vm6GJv6HwKjaDpSRWhN6Z5J
46085	payment	2134	2134	1874	1	1	7354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVirYth8sHXfPUfyUwHRGNjCbrNQ6yALkQ8KT3d72SkXs18n8V
46086	payment	2132	2132	1874	1	1	1755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY7uiY6oR7kDyq5YTsK6UxzrwkHnbGhjyxYQjjYAiMvNGZdXM
46103	payment	1397	1397	1678	1	1	17146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gJ25z1MwLGVJZxsaaTKmbn4WWXMNk7k9KdXozTs3xnspQhnR
46104	payment	2134	2134	1874	1	1	7362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXacsPkY2V7vtVKabha7eYvWGLciWbeiJRhwLNyfR17mQFaDaT
46113	payment	1397	1397	1678	1	1	17150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVpTHYMvv9ZP9fXTvkkQsKQmKhD5Jg2oNqjYVfyL8v1yfU7nu
46114	payment	2134	2134	1874	1	1	7366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gnuogc9YFopirHbNpymYXMYKzFV6PxTkdZYNNxSmur7FQwsp
46120	payment	1397	1397	1678	1	1	17153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ix2GBhxq7qzYMveGSaE6sUFGCUvmjJGENUSKmpg5PRRjoQo
46121	payment	1397	1397	1678	1	1	17154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfi5Tga7BWs3PcAHiD7ByjRrrYHjNFr2YLu1UvpRNxietxHQhs
46122	payment	2134	2134	1874	1	1	7369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1i94hcu6CCzr7wg9cT3EGNbLueEWZnXafBjtxRFhZU4N7JE6
46123	payment	2132	2132	1874	1	1	1760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiEn6XcgwXG729ehNcdR4yvh4mXnsemjZv9tcBHD4Q2HWrHCw
46124	payment	2134	2134	1874	1	1	7370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4QLqT7zVJK9wpn9h6MgWnz9Ucxq327pmar6Sb4zpepkwFEaN
46132	payment	1397	1397	1678	1	1	17158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkxPhXPvzeLY3DhxUEh7gK2emS5dgqWVRuXjp1gKSCizgHeX4
46133	payment	1397	1397	1678	1	1	17159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcdGi2LESwRVBAGBGbu8VACLHTqunyVBGjTYGqj8ZgReK6k3g
46134	payment	2134	2134	1874	1	1	7374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjNyjqdnVv6ABcMPF2vcNyQSN6hdedgikxCNxZR1KnFo8RbGF
46135	payment	2132	2132	1874	1	1	1761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxtDYR75n4Te6Br6npfHvzYJX4jXixoiwTGRvbvvieFFyrmDu
46136	delegation	2280	2280	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmJ6Y67qBn7g3z7pnX9mSN4WVjuozALwywN6PCwrqj7CsFDbt
46137	payment	2134	2134	1874	1	1	7375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pqt2pVTRRQBwh9BxrfLZr7QyhcAvTpwwUTMWYCisrk6ntw2u
46160	payment	1397	1397	1678	1	1	17170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNSqiFt2TMHGJhrchMefCMvaTDAtekNRRoXNssbCyqPVfFZDJ
46161	payment	1397	1397	1678	1	1	17171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunGvWyKHi2htQaiBGhYSt2uq5DiFULsNT8hY4tb1WysydXQgo
46162	payment	2132	2132	1874	1	1	1765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNV5o7D3yHbo3cD56ECJTzUzLzoveXPw8XZDhdmi3ofSjd3ti8
46163	payment	2134	2134	1874	1	1	7385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6vfZqHmqaTkmuVxrSzdYmdRzuEbPb7xEi3r55jvigHNwNRTv
46164	payment	2134	2134	1874	1	1	7386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TxSVD2oQByMNY1nSoD9SrTguVktvzPvRBNEkSyCeEGv9pugG
46191	payment	1397	1397	1678	1	1	17184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzj5dcoj2fnxzxFjkJyjDmsFEShDH28YKUunJAmZ3VjrAMSmm
46192	payment	1397	1397	1678	1	1	17185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMxV32buPwRGVWaNdNuiu6ThH8EgjvXKTwVsMCMY5PPjZSAnH
46193	payment	1397	1397	1678	1	1	17186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3FYvVTeSr15RUntvyK8fQ6TgBuKttbG6Znj82TUyLsx36tnn
46098	payment	1397	1397	1678	1	1	17144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWhALHBMcHDjtmeEQDVFhM5xDJSXYErNHDbychWirBdQJcLiG
46099	payment	2134	2134	1874	1	1	7360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs9wLFjHtHMNxXWufnkrNk6QV6gE9Kikd8PWJzYU6QrTa3UPa
46100	payment	2132	2132	1874	1	1	1757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1edxBuZsHwuiw9cd8YgohZwkNDMjm5phLA29NyDtTygCsMAvd
46118	payment	1397	1397	1678	1	1	17152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5ZzUJqfCXUuhj7Y2jCmcnvGwEuymyBgRZGBeX86NPws4MMxX
46119	payment	2134	2134	1874	1	1	7368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6i6zixM9f7B7WQpw5NVaxG3szPCPQCUnpkLuzKBSCt9KssMkp
46130	payment	1397	1397	1678	1	1	17157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GJLgN8hnUgx8kUvtjjK8UQQ7biSs3bHYs1DNHyuKDWXSis21
46131	payment	2134	2134	1874	1	1	7373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYdGZoqAYYBhW8tT1XgWnwthCiDFCYSkDBJW7h5LhgAxf3N1A
46140	payment	1397	1397	1678	1	1	17161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwsb6d8QXLFvmhNzVRTfhHSQfpJzY1Dsgm63gPZUsD2mhktCL
46141	payment	2132	2132	1874	1	1	1762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qAuny52RvWqvd7CW6SDdvBoWzWWQVucHgepFShsS3fyTVVPm
46142	payment	2134	2134	1874	1	1	7377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86ABQcEXnWXrDmueGQzkWwDwjPDqsDHaLESS4i19PuUQgFops
46143	payment	1397	1397	1678	1	1	17162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Y6XHDrg1nfdbvfLN5aCvy9wU3xaErFCkPnxHXuM2Zt7majN
46144	payment	1397	1397	1678	1	1	17163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ufQFi7A8ik8tb5RzaAYYJMDjfCXYwEn7GEZiuvTY1Kn2oBLc
46145	payment	2134	2134	1874	1	1	7378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqvgFFbvZ8USytBuQN4vJrzEjpoXPWSQmDheRcQaKnZVULBrV
46146	payment	2134	2134	1874	1	1	7379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPgMmMZW7kJMkX5EPqYVGTn4z6EQtphS58ipSLS6caCHMM28i
46147	payment	1397	1397	1678	1	1	17164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbAbTPyctbpEt3SSzgQnkRSbrVcYDmknUBfeyQ2HXWg3N4UB
46148	payment	2132	2132	1874	1	1	1763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyDeU9WJFZBgLw4Ygsjk5jx9DVtQfP7QTjYxxVHiQuSsqv4Mh
46149	payment	2134	2134	1874	1	1	7380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJg5ERFeRnwmaFDEq57CegWSeFSwYmDwaYMZ8uvLE3P1fZNKvJ
46165	payment	1397	1397	1678	1	1	17172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwpUtp8ewj8BoHiB7h7J6ntxSLh6mcNHH1XnXAc8Gb2Ry2JpQ
46166	payment	2134	2134	1874	1	1	7387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QxVCxjbnXXFEDMCpx58yW34BphoUk9ZSYrkR32y1Eedgr4DF
46167	payment	1397	1397	1678	1	1	17173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybnKwSJBmTvR1rhmArfnVeTcCyyyfpthmawfH3GCfxy3pfJ7c
46168	payment	2134	2134	1874	1	1	7388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkx3FdeUZka3Yh8oFy3mikNAj6hQnT5GJbRs3EGnS7pL7wnBJ
46174	payment	1397	1397	1678	1	1	17176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfKMbivWtmHqKc7bF9uMKDrvGHpJktr6Eprq4d18cFXVefkDb
46175	payment	2134	2134	1874	1	1	7391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BajvXeDWdP2TRWqKNouVreMPrzX6QWNrZrDu8LMai237GXAn
46180	payment	1397	1397	1678	1	1	17179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeoLgVGuDaoMHYTbTu3VSsRRjb39zmYK2MLxn2jCz77N2hJuR
46181	payment	1397	1397	1678	1	1	17180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddMMFeeqC7R8GUGbwtJtnTndC1cRAkrPR3SUDamzaYiZtMbjA
46182	payment	1397	1397	1678	1	1	17181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuurzNhZS56fE4JZYdSJyJXLLjZyucebG769ZWQskXd3TK14m
46183	payment	2398	2398	1253	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1mfmgRyVzt6LSpeARfx7sxZPywSpLG16h6PSEevY1ydyxwfG
46184	payment	2134	2134	1874	1	1	7394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx778tMSYcuyKfkYEfXdNDj8MTeGumnsuugGWUiMeScmWo2fNN
46185	payment	2134	2134	1874	1	1	7395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxRrt3BYEp5Q1vUi8BLMvVRLAcz8tuLte7p7Rzk22qBDQGch3
46186	payment	2134	2134	1874	1	1	7396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38HGTZVa7ENnWodrGp1sXPAyBYZLq1TZ28Y7FHzdEc6vWxLxd
46207	payment	1397	1397	1678	1	1	17192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGWwP9ECoB568pL9ixWhKNGSYk8iaD9rdkr28pcQYFhzzfhYs
46208	payment	2134	2134	1874	1	1	7407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2Y52gBZUUw9rXpSdj393uLAKGEwdtLhKKG6oBerhRuETYh5c
46209	payment	1397	1397	1678	1	1	17193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzL6pamPpVuLy4D2RdGmQmRorc58r7fMNz65DS5A121DCeRzPn
46210	payment	2134	2134	1874	1	1	7408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9gXYqKrjdwH4HYKToFfvxx1gf5dbcxJvYzVRkVVxfoe738p1
46211	payment	1397	1397	1678	1	1	17194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9SVAhndmMpThxQ1d6Xu973MSrJERv2is2SE8NyAsN65ZBaJi
46212	payment	1397	1397	1678	1	1	17195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7FC4Mb8DqZAqFbjjfu9QnA1aqrNMTRPKMVChGoR52tzfRMN4
46213	payment	1397	1397	1678	1	1	17196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNZL5V5eVj9F7izDY45rfqCdZD55LhSAB1d4hmbMLo6VECN9Z
46214	payment	1397	1397	1678	1	1	17197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw57Tx27Dkru4dmF51FoNQeUw3ZGUodzKPLZ21KWe5VPGuau7X
46128	payment	2134	2134	1874	1	1	7371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqAWv4LxBEFoUJ4WVDSd1EjjJArxYKDFrEmHfQtoskyZrtSLH
46129	payment	2134	2134	1874	1	1	7372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjqs48KQCEM4LuJMcn1wz3PwjSUdvpEZSYenw3SPYJLRm6dgS
46138	payment	1397	1397	1678	1	1	17160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtn5QauJnbyhQbijM5g51YoQdXt2cZ5DkPSSx79y3BQdUEfdpR
46139	payment	2134	2134	1874	1	1	7376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUhGraa4bQwbDd2sh5buWovWfomYiY1cKkA2s4ZB9TnfPymyR
46150	payment	1397	1397	1678	1	1	17165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9Jr2gpphHNS6SsSPKNKV9L3HnF7rqdzR1Hup9qoTVsvGr9tz
46151	payment	1397	1397	1678	1	1	17166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ29MbDS5PyLeTJQZBoHFRpbtqJrd19RZ1TXX1ggLzuAm5u4dx
46152	payment	1397	1397	1678	1	1	17167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPWPCXpUYzxgfbB6FbmHMXgPpivgfuwgWUuUwCT3cx4oxXJbT
46153	payment	1397	1397	1678	1	1	17168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pauZhMsmhJMsHe4YW5onxuJDZ8RLLEG41bS64vwbC2MbQP6f
46154	payment	1397	1397	1678	1	1	17169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Xqw68YBWGae8arpG4w1cNg52UriuaW9ncRLpyfjTUvfxRG9
46155	payment	2132	2132	1874	1	1	1764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdovpVPXw5bWo4bfr3sgwywhgdhiamo52gFQXKxEZLTEwm4cyc
46156	payment	2134	2134	1874	1	1	7381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xvDueFmo1fzMD3d2hpMaoXXUQKZM3sZoba8c5if4tKTKu8A7
46157	payment	2134	2134	1874	1	1	7382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMFtB4BAY9H9HGTGYyAyCyH4nyrsNjVphMr8xaSnnVw2ufL8U
46158	payment	2134	2134	1874	1	1	7383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJKvFA5oF3Ewyqkc9dA6XY669yoCXYEmjDcoBEft27Md6YyBi
46159	payment	2134	2134	1874	1	1	7384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XRMN5NYgaF9RBw697WW7samKpPuz6MErSNYR23udgpyYvQLm
46176	payment	1397	1397	1678	1	1	17177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxErC6WmUmP5FAoNwrtfWEdp35HPTSFEA6SQxCGdh2MS64GCx8
46177	payment	2134	2134	1874	1	1	7392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgXgHZapypZYapCXygD1YUCEnPUuchyUb5kLbLz1Hh3QV9V9n
46233	payment	1397	1397	1678	1	1	17203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLJfifUQLMVnCEznRhajqzboeLQaCtx7nwHyGqxKtKYNURGYB
46234	payment	2134	2134	1874	1	1	7419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMri1p6rT98pb82phNU3wggKJKXaUdf1uSe668biXbcknW6DW
46235	payment	1397	1397	1678	1	1	17204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusZfCKSYnL1kfsEAj1MVBtmnBqGX6aRMxggQ6qJwaSWeZojBt
46236	payment	2134	2134	1874	1	1	7420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJjWxtDKujXsHSYdXvgYN6sKNpYK84gurw67wNGDWu63AJm8U
46244	payment	1397	1397	1678	1	1	17208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPcmRhCMqC3mpaXu9vgszQKaMbEXmHbUaEb1frkevBfzdzVFp
46245	payment	2134	2134	1874	1	1	7424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMHnhmbswd2tkRC5VRnuzy61kuTBAjAPEJR6GuorZzKguu5Xi
46273	payment	1397	1397	1678	1	1	17222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNboRtNmn9sqKLYRP97uLuJthsBdynF6ZTZda9NxGHLTBEycqF
46274	payment	2134	2134	1874	1	1	7438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UqnHmHckYiJGj5dbfMCbhvPvSb3ZwofkCzKwvmrNW9tnxvKQ
46280	payment	1397	1397	1678	1	1	17225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojZ8XVyXrEYn6c8oRNAeZiFoSNexq8ucPJ25gVRkWv78BRH6g
46281	payment	2134	2134	1874	1	1	7441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwLNkvgCDFxq4wUCFrbL62sjmLBYc41KFZT5ArxRPMCMrnesR
46298	payment	1397	1397	1678	1	1	17233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpui89u6k8AhCngHzA5NDgs2NQATSYhSN4JQVKHGnv2nW7RmGp
46299	payment	1397	1397	1678	1	1	17234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzoHoSya6ttfUZ2kJJLcd4dtpXTBhLqaf2nrkQrFawNmkoaAd
46300	payment	2134	2134	1874	1	1	7449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqR8ZqgVbuKxJx92rHQqp78mxhpJYq3kEMCKC6FPFgQLFusAM
46301	payment	2134	2134	1874	1	1	7450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW56AvRTjs3qjKuGhkMLiWqrP5hN8sNnAAbRh75mbXnRWo4MN
46306	payment	1397	1397	1678	1	1	17237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbdu46q57D2WumbescNeZoCoCeNfaewXuoZDVDmgSXrEDF1Pn
46307	payment	1397	1397	1678	1	1	17238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM885XCebqPyk15ovsZygZnLW9BHQyCPASLAntfcsvbqkeM6ah
46308	delegation	2402	2402	1507	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLj5gcwFFFZiDou1q26dqYkBdsRXuvB9Dk1RrqFV3ZfekGcQx
46309	payment	2134	2134	1874	1	1	7453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQ3dCF7GDayc2dKvsByYVjt81mBhL12LSdJXbJmxVmZQRXAND
46310	payment	2134	2134	1874	1	1	7454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FqA96gvvUta7eXfhAKkkcSNw5n1ZTv7UTK1DuxijDzPvtTDW
46315	payment	1397	1397	1678	1	1	17241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRYiVGu31qgMHJNf6hnXoJmWSqgQFEXreqCVoptmVLWTHUVjQ
46316	payment	2134	2134	1874	1	1	7457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHj3g5t8Lwk3DAv2ya7pkoMN7xjovYTZPjjQ9YGExiFs1m1C8
46331	payment	1397	1397	1678	1	1	17249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FP7Z32pnsqX7i4FJonBKjSLrDwGMrJsjs9oisA4V7DoWgGGS
46169	payment	1397	1397	1678	1	1	17174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cN16X6eTKsG3YnnEWTBBvhcUrLhzfAkYBwPbjdSDRdUB5Y4E
46170	payment	1397	1397	1678	1	1	17175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWtqdgKCE8TcE8Pha75nN6uPFBmo3Lphtj2okYZSJySKiYA2st
46171	payment	2132	2132	1874	1	1	1766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCmTCVQJSzYCPNPwCp99jZAyJHJp5qwsMSgJ5y15FswriCqzy
46172	payment	2134	2134	1874	1	1	7389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhiFp6mxtJkvocSg2zhqPZMmkxzzHazofoppiPmh7UA72UKX6
46173	payment	2134	2134	1874	1	1	7390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuiS81RD9rjbZQ6NHD6NYwfNs89CwAWedTjLfb4ACtJU6wW7XN
46178	payment	1397	1397	1678	1	1	17178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCZXQHm9oP9UwaD1p7yWtXoqmN36pdp17a2LLxorEXZ5yFrAh
46179	payment	2134	2134	1874	1	1	7393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcen6V9vjBken71kfCCWdd3vxBJgM47thn4o5cFUAkaEZF41X
46187	payment	1397	1397	1678	1	1	17182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1UN7zF6qSgiHa8kPQ59PXv2wxJ8gst1oPoqoPoDLARUubUmh
46188	payment	2134	2134	1874	1	1	7397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqCW9bPwyYnN6BGUgqdPu7gKgLX9LQHqbKhKLSsFNaKnotkfk
46189	payment	1397	1397	1678	1	1	17183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWii4Ta1cSoCG4F7xhm4B56GG6dzxpJcrY1TiSUpk46K11TMo4
46190	payment	2134	2134	1874	1	1	7398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPAu4ca7xzXz9rwDZy2nk7XHFRVnhH4ZrZCcRKCXtm6JELcbG
46197	payment	1397	1397	1678	1	1	17187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QnZFTRHeoiBedp4JUXwpW6cs8gADDib3dQPtQ1ScwQL2PjuY
46198	payment	2134	2134	1874	1	1	7402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRDToXuCyqNv6hLMMzkpBLjcyu3tKEybc6mzSkDYN3rV4Ah9d
46199	payment	1397	1397	1678	1	1	17188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75bmAYuNgwZCoE3HyERVGKtoJeCpX5MbYFtEVGt3dcZnfZMPY
46200	payment	1397	1397	1678	1	1	17189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8evAVvNwjBZY3Z8bYSbRJuAW2zkJtFSaZ5byh1NkkQbafZzR
46201	payment	1397	1397	1678	1	1	17190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYff7rSDHdqknFngqWmvNc7U9vr6fE2nEPvtrujZpPpbP99i12c
46202	payment	1397	1397	1678	1	1	17191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDgfZ6Pgf7Qk3YLBtyout9d1QCsndm6PBznqM3vdPphxwVQ1e
46203	payment	2134	2134	1874	1	1	7403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41NdMaFSbznh1QBXDUqdWh8acjGyRfLJawc2o9psPb8c3pdrU
46204	payment	2134	2134	1874	1	1	7404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6dH6gw6NDY5vFKEnXxkm5CNY9Xi5sqCCDkk4BMyqoGyj3A6U
46205	payment	2134	2134	1874	1	1	7405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PBtTVSEHruuq4SAoM2WMdzabXnPrqdnmjYLswAdX5tnnz57r
46206	payment	2134	2134	1874	1	1	7406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eV1VjbYnMdqGAq9ZqMbKZVcm5MfhCpXTQoY3aJHrpiMPCTfa
46219	payment	1397	1397	1678	1	1	17198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEAj3psomMGRHcwkzLh2aMFajhEdTgKDAcDuccmZ5UPft9NWT
46220	payment	2134	2134	1874	1	1	7413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp7qPm7FTwNvCRqFZA58CKiEEXZhPh1jnwbsEuRw3xk5znjrD
46256	payment	1397	1397	1678	1	1	17214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VzqzsR1KkgsD6NT9jv6ABiPkswTcj3GUQVwHhuzdXiKHUXE4
46257	payment	2134	2134	1874	1	1	7430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzA8BrS3DwJPLKHfTpw8SfkJjYku6TmfEGbLTKHPv4fk3NPk82
46275	payment	1789	1789	2401	1	1	2	2880000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcakE86wbKUA9tfAcF2T1k8qRQHViNBmZVpUDPnxDQiUZVmo3
46276	payment	1397	1397	1678	1	1	17223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5NVLXYcmfs51TTwLfYkTZ4YecG4Tx2TU1rafgZKnPLRDSyd6
46277	payment	2134	2134	1874	1	1	7439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMXUwUHSnrCeZrQu7rWdCB1wsEqPD4vxLpn9NHQsSELAsYuSP
46278	payment	1397	1397	1678	1	1	17224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjnEbm24ZCnsjKP9GFE7Q8hs7vLkYcX8MxLciiqvdkEYGnLbr
46279	payment	2134	2134	1874	1	1	7440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPcVVB6Cx18ka89L9n7mAsXgiWWvGr4QdtnZzyYDGeA6fCAS9
46284	payment	1397	1397	1678	1	1	17227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjjEKdCdkYKNDSMiGYwt3oxfuV7KRLwCstvdn1sE4ovaxgRU3
46285	payment	2400	2400	1379	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjBWDzYG2titx6mPU5wyqXaJCfwnehZaoDCyogQYgYJdGp2Wj
46286	payment	2134	2134	1874	1	1	7443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktPRfnxMJdFmAURMHKBe6A9XUuZHL929hePUq77egbRgvxySH
46293	payment	1397	1397	1678	1	1	17231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxJSRkrQfPoDK6cvRQaD67SYM6PxVmV63jyEsAcJLJAoAPRbS
46294	payment	1507	1507	2402	1	1	0	50000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQW8FFmmZPcWQjupPDTaShZdMJv1F3fAyFzjuMk19XWuis13m
46295	payment	2134	2134	1874	1	1	7447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TjZqCKqga4UcGdJGg6sg37j2ag64GNV8v3Eow5ag42Nq9HVv
46296	payment	1397	1397	1678	1	1	17232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqJyMjTQE7Wu2kLLzmY5C44yThJ7kNGYnzYfE8zJZ1pKGC5SL
46297	payment	2134	2134	1874	1	1	7448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUf1vm98K1Yf1KQ4wR376cXGgEPMk6vcxi1tM7iaNjMJFNofa4
46194	payment	2134	2134	1874	1	1	7399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiefRs4xyn34Gh4XbYRTZHwMktHeDt2ujNjWW3g7LGBpN2May2
46195	payment	2134	2134	1874	1	1	7400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1DQEoGrnYZZbf8kyUHVwCSvE5Pa8SnyuWnaMPPJwd2BcCC45
46196	payment	2134	2134	1874	1	1	7401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJrMuzmW2NQqnVzR1EiaSrEvmG4HeEtvhuiV32RznUpN38y1k
46237	payment	329	329	2401	1	1	7	1367000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pJvzNYbcsyn3r8ZGDPyEmcsfAMRWb4W3tPf46PtWyngdFDGB
46238	payment	1397	1397	1678	1	1	17205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKfVFAbg1kAfCNgegy9TyLSy2gcXvD3YrKXBpysheazieq4av
46239	payment	1397	1397	1678	1	1	17206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsPsUDSMAxE27YAaNnhg53CCfEzCYgnDoVByRJxtfNyxNoEcb
46240	payment	2134	2134	1874	1	1	7421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJLGRywV4Pa2VwGK5AbUArVkFBW4S3FHCiYJ4hNWp5VKrmQjD
46241	payment	2134	2134	1874	1	1	7422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7bKP3fe4kU9yr2gcHnosHMzxUQdBbLLTr5xCaehNQ5eohLM5
46246	payment	1397	1397	1678	1	1	17209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixzBu86sQDR4bmBUEpKR13vYXgc6A4kyMU4oEZzihU4rYgnX3
46247	payment	2134	2134	1874	1	1	7425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBBja7yCEWh4VKwS8vcxZ3vpkzRpfbN8Ro3k2pheiRwFAWxKT
46248	payment	1397	1397	1678	1	1	17210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmLmLte15NuX5dtLCSdqgEfhet3fpS5tJhkBrMX49HcfQGqxV
46249	payment	2134	2134	1874	1	1	7426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbY6AP7Xm9FedGDzES6iWKfxg23BWvLFRC9NA6HBAvbLcRZwC
46254	payment	1397	1397	1678	1	1	17213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEQXas5SNZBwGzKWi9qUyPuekBRgyLhZ84YKMj48FkLsDdA4j
46255	payment	2134	2134	1874	1	1	7429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodhRPKmYa27o9DpknrMyn5S5fU8WCpvK6WzUSq8iCHqv3xpBY
46262	payment	1397	1397	1678	1	1	17217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEohhAiCRbZLagTGkBKxuApP8fLXEhUZhLT62jprrLM1fiLsAB
46263	payment	2134	2134	1874	1	1	7433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoWZeRWMU5cLpuvdjGAMWKwPpRqRDCQMWUH294AjxhTvS58sY
46264	payment	1397	1397	1678	1	1	17218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZtU17FuecwNSF3yyrLThK7qdxLWy9VqJSFhg9dTciHb4CCBG
46265	payment	2134	2134	1874	1	1	7434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jWKTGtbsnc53DRGdPm9ntnddfMd6n42URNLMDq3sUQWzhrdo
46266	payment	1397	1397	1678	1	1	17219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gKkVTApak9SGYfcoTQC1ZxSjfmbopnd88uT1TP4p3JezkbwN
46267	payment	2134	2134	1874	1	1	7435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwoCqCYTDSsoH69kCXwN6Z1P9hSHXsuVbPt9eZ37sGWNrgcLC
46268	payment	1397	1397	1678	1	1	17220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZa2M6bjHXJ98ALnP3gZzjE9WKZmwoR12U4RbeNYgi7UUnGJu
46269	payment	2134	2134	1874	1	1	7436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDd9LshhCiCYSbh45MuS3r774bVPDXkKpszqjAQSDTz2BRjTv
46302	payment	1397	1397	1678	1	1	17235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv3UWNMoCKAZKyzdVCAggH5djhPvyoU8Taf9heneeXTu5o84D
46303	payment	2134	2134	1874	1	1	7451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfh5xop4j9GvipSsey4Z3UiC38HqbNhs6S1UVQuXGkGNaXhdn
46311	payment	1397	1397	1678	1	1	17239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwS7yLTcP1JBVQutfWon11cnDDXVu4mKZTHY3c2bqyTTiYsxBL
46312	payment	1397	1397	1678	1	1	17240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCeQEBv18aCSacJyGjoY1MCLQu5u3LvkFaqDoCWXN9PDDuCGA
46313	payment	2134	2134	1874	1	1	7455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEV4wwHP7hMQS6qXoH8AXM1Zjt1nCDL2YaDScP6n2zVXpgTkZN
46314	payment	2134	2134	1874	1	1	7456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFaUZTGJT4Z7D3FCeQGRPsreDdRkfz3FSLnzMg82yjCvtT2iiz
46337	payment	1397	1397	1678	1	1	17252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Qnk3BH2FJWxn1aePdDVEXmWbVy7xW5T8kmLUcRgjrKjinLkC
46338	payment	2134	2134	1874	1	1	7468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbb43o4egZwAjrcyf3oFubET5ZakGXejWn2Z1GgDoaibzDzZnB
46355	payment	1397	1397	1678	1	1	17260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqsWRvnZtZ4JpfcjVt3HeR5x4bYDnca7zZ9vBKzUz1SALKjQw
46356	payment	2134	2134	1874	1	1	7476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFu7L3SY8HbmwZdficqFPVohsgfiuPWiThqzTDBG9RdD3vkDX
46394	payment	1397	1397	1678	1	1	17279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGrhrqWXdJfeyVi2BPnxKeWgSPUuJydhsmsBZNzxEv22LSqDWC
46395	payment	2134	2134	1874	1	1	7495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrT3MNE8EWBcNvYoAcqrDXukBa5BN7X2ffY4a9rLnde1ozm9uv
46411	payment	1397	1397	1678	1	1	17287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vXZu3vAmThXeVaAy8XxVKj2uiYJZXvk7h5mxhR73H213vuFo
46412	delegation	2385	2385	121	1	1	1	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9xNjmchMrNHWW2PRAxn63ssghNa6TT9pjEZSg3EnxA2ymTwT
46413	payment	2134	2134	1874	1	1	7503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwuYGpMDoRA5SnMAsbaCVf8xWkxuRW28ij6RBy5RKXRj8k8YQ5
46423	payment	1397	1397	1678	1	1	17292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5o8zN9fTs5f5jyhtrD6j95ciezFwPCmnNoYiiLbvy1zSpDCD
46215	payment	2134	2134	1874	1	1	7409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5kxxdoxKirsNyWchw7Te3FB43wpXRwwRD4BvkmeNy9t9PKt3
46216	payment	2134	2134	1874	1	1	7410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrp5qLCjTTMZS9tkkSsR9Tc8etztJaQyKm52SD2GP96CXpBTg
46217	payment	2134	2134	1874	1	1	7411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1ALYWG5ufR9h8jLcFWVqMGohSsdWemmg6SEef12fXsjfzBm5
46218	payment	2134	2134	1874	1	1	7412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZpyCevdvNZn1vGrnVxp9hVDejEFWZDn5LVdm4hY3WSBq3X7v
46221	payment	1397	1397	1678	1	1	17199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDU5axkoKPPrtDKkfW7v9txNttKhkrqwvzmBwPR5DbWM9J1FJ8
46222	payment	1397	1397	1678	1	1	17200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxUhbzuDUXqY1sqnarBg8U2cCSRQeKpfjzoTH9aHwAmcXCdnB
46223	payment	329	329	2399	1	1	6	75000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSBbVh69uRLihqxm3svMNPPCC61gKy3kVaGD9hw4RUJuonrab
46224	payment	1379	1379	2400	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGirJbNNyeeGR7893uZwjSsxin9TqqAWy5M2FeDktWqQdJKYNG
46225	payment	2134	2134	1874	1	1	7414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQEysJthPotBmCF29ESHMAWiAtC7d1MT8DXRuNWpSWt1z8ShW
46226	payment	2134	2134	1874	1	1	7415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBGSqrZeHEwKMKKDZUC3ogroyVvWoEYNxP4GKLbJhez6f4xzU
46227	payment	2134	2134	1874	1	1	7416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafvzj6aYdjAtwG9j7brn72oTSzgCtMCt5Se81fw7MDiutQFfJ
46228	payment	1253	1253	2398	1	1	1	607902747000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxZkF9Qc9i4ud4kjEZ9dZjH1R4v8PE6mp5kWtH8u4EwQzersq
46229	payment	1397	1397	1678	1	1	17201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsAsX8TzFcnuQDdEZ6dg4d58aqFsRo54ejAAm14gs9EsuLn4C
46230	payment	1397	1397	1678	1	1	17202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1dcRZHr5auZ9bfowqKn8cse94fWkN5D21E5RLrP6PT5ZJC4H
46231	payment	2134	2134	1874	1	1	7417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZrKfhopYMBeJFKhT13WqT7BD9mKFo6JVq1ra8uDxJcT2ScAv
46232	payment	2134	2134	1874	1	1	7418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEmgZPz3RAfGwxSs9V95ZoQPi3SLWKkX4WXR9ovx58A6gxy4g
46242	payment	1397	1397	1678	1	1	17207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBqALjQkQpk3gcWP42M1eqzkV4zayAB4jNy84G9dM6i9TwT2g
46243	payment	2134	2134	1874	1	1	7423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzsGkJMiG2izhdBrejNXiJuURPsqBViXPA8trhJcjdcEjejK5
46250	payment	1397	1397	1678	1	1	17211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5JmUHV2dbDmmCpWxvdMnzv7CNWufJEQUeze1zDmX8YG6R3zf
46251	payment	1397	1397	1678	1	1	17212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrNwSJ6qBgxtYRbtkWSipFbGV8NUMiL3Ez8BjEGy7RD9ZJbJr
46252	payment	2134	2134	1874	1	1	7427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DLBkS7XenEgT6XPWKsTw3s96L8rSimt2EB3aJrCRrrviTpzR
46253	payment	2134	2134	1874	1	1	7428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CJEBohnd86116xiVk8JDYz3czbEuVyxgJLEJxPmpFXVQVEvg
46258	payment	1397	1397	1678	1	1	17215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn3pmdnAiRNHgE9XFazrv7uH51rjGip9CgmbgdpdYmAyS43ft
46259	payment	2134	2134	1874	1	1	7431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9YTkMnrrXfNSp6NZB838rhYCoB2xU9QuW7WUWoymTr3NgPTZ
46260	payment	1397	1397	1678	1	1	17216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5YAZtFnjo9YjRp89tPT9hv8fQTsT1RVGfZeA275hWbApKwhx
46261	payment	2134	2134	1874	1	1	7432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iwVL5aBa3VyizgUqrSvHCzJFyEbSv7jZPkGX4RrEYHsMSxPd
46270	payment	1789	1789	2401	1	1	1	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyoJy7Zi5iEh2KJRfMMcrX6oSFp637LzSkntA38TspGMXqaD1J
46271	payment	1397	1397	1678	1	1	17221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Ew31JCm4kEboyVz6gT9AosNRW7Pt5UF4ovBKvfnfKQxn6zN8
46272	payment	2134	2134	1874	1	1	7437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Cw7VELbmDYW5GNXdYCrHdbUanSGyz6BzGU5F7cDDnJ8Q79Hq
46282	payment	1397	1397	1678	1	1	17226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7Mt7Ev5f2rhKWHdPjfsGMCLbJphRPabD2AHa2fVemxqm4bwP
46283	payment	2134	2134	1874	1	1	7442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtTaWBMxd1AmMiunYUDJTgtTJebk9ZYqSvuR5cvCcnyS8DWXv
46287	payment	1397	1397	1678	1	1	17228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabhz17Q4GPeReeZqJq57KcgWTvC3PwNHUBb6QoVjVRCQCW2Jq
46288	payment	1397	1397	1678	1	1	17229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZii8u2CpYKThNzEwKmVP9DkJMGmmEbmQrYAfKHRiQshDhPXpVW
46289	payment	2134	2134	1874	1	1	7444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzFBoPBT2Xz3736JfKCLaqJ6ufKrnyMu3fgHLYN7oRetw9vcZ
46290	payment	2134	2134	1874	1	1	7445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKP8Db7qq2uHk1QJd7Ja7aU5Z1zcVngaZPMiohdJp8giufPvS
46291	payment	1397	1397	1678	1	1	17230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGurjyz4qeDmgvMKFQQCD4DDAzFTmQdfJcadHub1TYDgxLFf2
46292	payment	2134	2134	1874	1	1	7446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxsndBc4tzAf6KXwJbQm2jnMm2m7hGbcw5DTCCb2obFJ8h3gj
46350	payment	1397	1397	1678	1	1	17258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQsgbHaPpZxHdt6CHSWwt13ZXES5CkyPcNWJUnFRvRYQ4pJ4gw
46304	payment	1397	1397	1678	1	1	17236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHnbDdvH3zuFic4LGkAv3mVh6pE9NWKjCwvNuHSWpEBFnqp57
46305	payment	2134	2134	1874	1	1	7452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHq73xc46HYV1bejj3KJxsfEciTWoYhAWvo1tbcUiDDJu9guN
46317	payment	1397	1397	1678	1	1	17242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSENhdyCUPFx9Pqd33WcmBUvtFoaHaiZjkZJkMw8jszpMLZQp
46318	payment	1397	1397	1678	1	1	17243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzMYmiiDxxzsEaU1f3TBeNjpwjiiJ7qXUdKdiiiXHA5yemMgP
46319	payment	1397	1397	1678	1	1	17244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpGdKGQBCjkdbJhEN3ASK9ZxEt87xEMMEHqi4qfmnpxMnL9M1
46320	payment	1397	1397	1678	1	1	17245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpAAHGtwRNuwxxgDsPqd1rjjZcySBBykXbFkEsJEy33QGTaC8
46321	payment	1397	1397	1678	1	1	17246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAGvysCiAJ2BDUwqUbR42LpL6o7PwspNavf97i8whXG7cFoVe
46322	payment	1397	1397	1678	1	1	17247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSPZtsXSvZ2j7WfGq1z9o1MkUEEQKc6ST8XPeEeRoP4Q8jTPw
46323	payment	1397	1397	1678	1	1	17248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7JsZhAz2wJ8LDE49m794FdaK2DdeJ5rgeM3RQ36EbvNaaoNd
46324	payment	2134	2134	1874	1	1	7458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsYwrGNPgYtTjjEjAa3JPPSCsZv59rfLcASHsDXBuu3z1XeYh
46325	payment	2134	2134	1874	1	1	7459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ZEZvPAVP8S8wfKr6adhjFHVppNbgG5FJYCYVpJfEhG9mm3o
46326	payment	2134	2134	1874	1	1	7460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW38ZThAo7mQYjtDRAgwce8yCtXyUDbYFEfFw5kC8RM2PnGYmz
46327	payment	2134	2134	1874	1	1	7461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgPmunUkxUEj6VM95o7gg9jdS3vxcPcU18Ly2JgwDjY5NFuFe
46328	payment	2134	2134	1874	1	1	7462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkkAMmHBMETboHWYFD3894rjimN5yZ6w2buxrxfnjWmN5kM8x
46329	payment	2134	2134	1874	1	1	7463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7xic91EUKV5QKapbsqC63pbPRnujQ5f4USGYqnpWqyw3uK2Q
46330	payment	2134	2134	1874	1	1	7464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9c1Fvwz1H3jUtE1DPixukCAhd9EVwoNegbZw2vqgzpgWkki6C
46333	payment	1397	1397	1678	1	1	17250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6T9G59fG5B4ociTHRdxaeG1D6gjAqWKSjRRTLgNjt836L5at
46334	payment	1397	1397	1678	1	1	17251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Xq3GN5BYPXXH5EHU8coXAty2Gwjdofwrm69SAcsxSKcfcQbj
46335	payment	2134	2134	1874	1	1	7466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqgoyAz6qGZYFXigwDNjN3VgZax2LqExmEivQFqgUiPuwsmSG
46336	payment	2134	2134	1874	1	1	7467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTefUfepiWHAs5w1zVt252qPbg8WGiLPMAsvzX7oGdZtFZtCd3
46341	payment	1397	1397	1678	1	1	17254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE41mp2mBeZhTaHPnARDHpBJjMZyBzrkekycHEHgENtUqBM4v
46342	payment	1397	1397	1678	1	1	17255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhctTPM1xvTR4So7oVtLEAUbGHbVPzANBeVMoPmRW7D4uNxkp
46343	payment	1397	1397	1678	1	1	17256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppPnpacWo14BLmFwUL35nunduZPVaJC9wUymqoeZU7ccaVUsw
46344	payment	338	338	2403	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8WiDtSj6E6i24RNFVb9cKSh5DQAjrhHyQr1CfbNdV3agFBXm
46345	payment	2134	2134	1874	1	1	7470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGiWAkQcxzK8Hvn1eZ3aksKSSywnPHffX7kEjtjK9Xd3MZdxT
46346	payment	2134	2134	1874	1	1	7471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsVKkp2UwgfgBqxqEazuwgkgJSqbM8GtXHe6NvqPztbmMDUwW
46347	payment	2134	2134	1874	1	1	7472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZM7dcQz7hVvQwBSXT6LiLUTe222xdscLVdVyo1HWohThXB3v
46352	payment	1397	1397	1678	1	1	17259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMrZ3G1PN5YbdeyqQGXa5HjDFysaiywjZ2tL6hkasbcUT3ypq
46353	payment	2134	2134	1874	1	1	7475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXF2JaUj4iQWUtrrXTFkGxedAMmswkXPBUUPye3KgnvhLdMBdt
46354	payment	338	338	2403	1	1	2	438000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZzZuoE8eeYdCLufnqkjWtoYRPSe62rKytnKBf2ideBgwKw1t
46362	payment	1397	1397	1678	1	1	17263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXz9ERWFrJEncMkAU6FTvp921DKyUTnE4oV2X14Uor3UpRjQD
46363	payment	1397	1397	1678	1	1	17264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkHomMp6tUfCq3rTpQgkbs43SsSBjCZiABWKVrR8iFmitZt1b
46364	payment	2134	2134	1874	1	1	7479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp15gWNA1dCCDbsfcanUbzUBDVTQSGhr1e2ZxqDTZRjkdh75GW
46365	payment	2134	2134	1874	1	1	7480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUEN72VRSEvBjzSidrnxH8THozEdY88HhYuj3hd7Hau91z3me
46368	payment	1397	1397	1678	1	1	17266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZmja6R9tiVhZNshzRugtZtjnwDgcK2efm5FFAJz5mcmSvt3m
46369	payment	1397	1397	1678	1	1	17267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPoPNQopxxMZJgSzUrLabCguRFAXS4wchDu7BX218tDEp1YkT
46370	payment	1397	1397	1678	1	1	17268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaywARCn5VRVr8r6zkhx4mahYyVnw9fwQm8VcjzKvU66Xjkqfn
46371	payment	2134	2134	1874	1	1	7482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuN7mwcCCUGRcetdDKinC4ZroA35b7pBKxAoF5FrJGKGUPazA8
46332	payment	2134	2134	1874	1	1	7465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqkaB6BhkcbUL7BVWwtFoTu6NJnLWDaKwkoMcrZqwyYP2ByXx
46339	payment	1397	1397	1678	1	1	17253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyHGzXtT3diM56F2pYjmC5eiRsiyti2pjHJGF9DqibWLLW8hm
46340	payment	2134	2134	1874	1	1	7469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifeqcbZokUN1e7TqMErKneJBJyLHRSJyLGeySudp4jrBSamC5
46348	payment	1397	1397	1678	1	1	17257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAUUf7PAZ4jbUoSxamNs9MvEEg33seZnX5kmCS73KodBK7EzB
46349	payment	2134	2134	1874	1	1	7473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLBiy98MweUJRTBYMcCJqxQoAuDiDEh1QSFnU5gxhntMtMMHh
46357	payment	1397	1397	1678	1	1	17261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGf3bY6mmQUzZ5vyuc2B8gXWm9QJmYZwRWdHeH7id4PioQyegn
46358	payment	1397	1397	1678	1	1	17262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKPrSFJgK3MMwxBkqfNNACy29neKteo9iDHKSfA5LV191dgf8
46359	delegation	2403	2403	338	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcK8aE68mBhrkCwCvfqryxQoN86uqZTqNY1gSorCNK4uBqFUP
46360	payment	2134	2134	1874	1	1	7477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDx2LQupS2WrD8xBv5regVQWaSrDzyRSViab2zEHkSG6vAD8Z
46361	payment	2134	2134	1874	1	1	7478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VNs46KWDP55Pn75bqbJkvFvMVzU8hsopGE8iQXbck1GRgwbx
46378	payment	1397	1397	1678	1	1	17271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UR7opnJ4QseSoMhfP4qcMHwHNDFL2eqeK5Vc56nvffq23E1R
46379	payment	2134	2134	1874	1	1	7487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t86WaCJa25J24NpDfpwiEYbrq9btwLhNdfeWLJXXNPSb9TkM
46380	payment	1397	1397	1678	1	1	17272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpyh77tdSFkJzWJjfrs5oqoPrZGEnT5PRvC9QmWuNwnUNiQFj
46381	payment	2134	2134	1874	1	1	7488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnfKHQT9NB6PfRerr7a86K81Lgx8bUcj6oHSnYuea5px6TLt4
46384	payment	1397	1397	1678	1	1	17274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShtD8TfS9Q5ijRLwUCNQZxAjgMb8PjxtZwgf2sPhPj6QBYs5J
46385	payment	2134	2134	1874	1	1	7490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWJP8uqp1fSCcPVNfkDh1NN39XhR1NJ5EipZkgLQyQQqvbw9m
46386	payment	1397	1397	1678	1	1	17275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcLqJ9YBAGBBt3Pifcq6t2R1E64btqpPU7fYm39YGRFjyNKez
46387	payment	1397	1397	1678	1	1	17276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcRHXiCv6LwqMdD7BLacA5VyvXRHJYcW5vm3QddtMejyU25yu
46388	payment	2134	2134	1874	1	1	7491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqfsxnKaWgZukteXGS6tAeizzRvy3tjKgFK7bU8mCUx9CTEub
46389	payment	2134	2134	1874	1	1	7492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZoRfWNB4aVjwSphQuNmD2mDtg79YePR6PfRF5pY1Preu35DE
46390	payment	1397	1397	1678	1	1	17277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqi1XUDPwtfcifS59r6VLcgUt72bBEefe6RXh9sbyRDmVkPN4
46391	payment	1397	1397	1678	1	1	17278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCotAh33fhen8MdwTjceFcnKGRfTVF6KSyCrJB7i39QvkJW7nU
46392	payment	2134	2134	1874	1	1	7493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpk1o3TFNvNN9Kk2w5u9qtSRdp2LHqJGCFtHqtZxgGvCfJSMk
46393	payment	2134	2134	1874	1	1	7494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsdisam2TfoutEvvvYefpAvWp8k6HMgEJtgAYVZtgRwcu5Xuw
46399	payment	1397	1397	1678	1	1	17281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TtmPvEKboQRgkUTbghU4S5FkuokjjxEQkC2q1T7jMgdYmtac
46400	payment	2134	2134	1874	1	1	7497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FbWXCAUUMNxz2nG9xg4xUiaV5pg8ukFo3ghBvM7HZdt4YWrf
46407	payment	1397	1397	1678	1	1	17285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzZQEBBMU9MjHAebhhkEX4jhpAKtAcjW2k71MRVbspXJtZi23
46408	payment	2134	2134	1874	1	1	7501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1467ZkL4UJxvwp5RVua1eYp1CegBvkJH7iKr6KWyxcTMVC9fA
46409	payment	1397	1397	1678	1	1	17286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaEZ2eKnzHGkZSmj3EdJ1KsnuKx6bnVbxKh1ZDwyHeUq5qywP
46410	payment	2134	2134	1874	1	1	7502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5xy4sofkaKH5JR1aPjHpCCMorHHCX73XzAPhfjHPoBCiKrEK
46425	payment	1397	1397	1678	1	1	17293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacQEBnuNscPKJoNWGb7f9X5KjE1cGtikjqbeuYFiJMEi7WFcL
46426	payment	2134	2134	1874	1	1	7509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TZZu7sDzWwGz6A5927sMKzyqJe15m7rF7VmZbaj7Wj5VqPBc
46436	payment	1397	1397	1678	1	1	17298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkMSS9L92GZbEmr2H6UA2mnuf9QyUK6YKMSJCSNMN4V3qvwU5
46437	payment	2134	2134	1874	1	1	7514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpAZ7Cx9n4k3dtR4x84FiLRx7k9admQUs3ickWrfhFivXeLv8
46438	payment	2133	2133	1874	1	1	6863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnP61NSD2XCzGZtRMyQqb42SoMaPxi8hH8yE4U8iMuKA3JnKF
46452	payment	1397	1397	1678	1	1	17303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPRGQ54yLSG8GKMi2x3aKBmL2EchmVqpEMA6EtEwKAGzTqMpr
46453	payment	2134	2134	1874	1	1	7518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkA17k2ndvLoNtsFX7Ba6x9LpWj1LbmdhEC7gGTfPEfsbus1fk
46454	payment	2132	2132	1874	1	1	1767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QWTZ4aU7m6sfFBtvLcCXQVubY6e7QXKPsRo5HkeaVMuJuxDa
46351	payment	2134	2134	1874	1	1	7474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLKPxFwpnCuneTwixLTMfTRcQtzF5YAmkWTcAZb5djbkGBiVZ
46366	payment	1397	1397	1678	1	1	17265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjtYbwSBKNHWPQUZL2KFwTVXPC5Yt7oK6cm1c7vwDxTQGCB4Y
46367	payment	2134	2134	1874	1	1	7481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQdrBvfgPpLv1UVjsMcXpYVoTUdzvntGHr4ZrjNeJvMBFJFoYe
46382	payment	1397	1397	1678	1	1	17273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYS1abFs6f6e9RGaW86HmT2GvyhEXCJ7j4kts8GjYo1bYpsF5j
46383	payment	2134	2134	1874	1	1	7489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTBh1BexsbmaDgeHP99oVgteVnCi7NGViyya8SavSFoGSFUoq
46401	payment	1397	1397	1678	1	1	17282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrifRnUZisNQzoHUuEd6bhV5fVNFTS1ZqpKZcKyLZ9CdU88uU
46402	payment	2134	2134	1874	1	1	7498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzKJ9FUuRXoXq9TE7XCh8qKTQoiEwxJnhQYrBJArsNzoF8ebq
46434	payment	1397	1397	1678	1	1	17297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTksAdQSuLt4peXRxb4GxkiHKBN5vcWgp9Xuz2n8NNkhDUExsU
46435	payment	2134	2134	1874	1	1	7513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF46W9hx92YH8BvyLpMKgyqFqujjvZLj6dHdj9pcbmzHHAbf2e
46473	payment	1397	1397	1678	1	1	17308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wmh24BCz7J9wpycsBmigd2UnChvJKqVhwvVdKqgZwrViLXai
46474	payment	2133	2133	1874	1	1	6874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1DLqhj2QFyPHbkmcvHEoAh4bjHLq5Ph57nox5axXCupkiUrF
46475	payment	2132	2132	2386	1	1	1769	140000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuETW8zxgWbJaUvzv6rkK1ZyeuQzWBtTk9CjPh4X4M7jpj52m
46476	payment	2134	2134	1874	1	1	7523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8JioYc9twMfkWtSGzDd5fzXXVRi2E41fXJer2i98TdzRPiVD
46488	payment	1397	1397	1678	1	1	17312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKue32K7MhLFB6sHRvYcV4xVxrQSzr7HRe2tddyBdvUyXUopL
46489	payment	2133	2133	1874	1	1	6878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSAcM6ubh8zkqz1gGjd3AyeokcwYFT7BnCYKzKxP53hzmfRDW
46496	payment	1397	1397	1678	1	1	17315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRw8KSd285Adtiqy8rWG4LMqr2iQ5BcbzhaeGwQ7sh6eZmi3AP
46497	payment	2133	2133	1874	1	1	6881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBemQeMZRyjYP3pTKzqY8dNBg9UHDk2t5h8GToYLos9qoaoZD
46522	payment	1397	1397	1678	1	1	17323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7Bf5ujoSvYoxr4zfiLNFu7adz3EGrvMoNrC4hgezrcF71zGx
46523	payment	2134	2134	1874	1	1	7533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC4TLfoZDDwtWCYsjwtvXyC1EfNMM5Tfifiuhwr1nT6whR5oj
46524	payment	2133	2133	1874	1	1	6890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1TsjT3isHhLKDsQ74frYahgBiRmgxNfk841kcJ84GU3MZzER
46544	payment	1397	1397	1678	1	1	17330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtFNuxivu8v7t5Z4mPWQgMhYaGCsneKGCpNpNQvp9zkttQMYK
46545	payment	1397	1397	1678	1	1	17331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KDiQnqGtWPKxVH9tiiaq7oRh7DxaZWvYjEpp9oJh8DkKBKFC
46546	payment	1397	1397	1678	1	1	17332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8mRNDjGSm7ex3DZT54wo1h5RQwtRhnEPQVrAW7XTgffGKpWZ
46547	payment	2134	2134	1874	1	1	7539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2D7NsEg2ncv1hWx6N7ftgb44d2QhwXZu65czLMznh1wypy8i9
46548	payment	2134	2134	1874	1	1	7540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4gS8tCSM1SijqxeUPcXFgBE7CNFspUKNMJNB4osf6hvQUbCy
46549	payment	2132	2132	1874	1	1	1777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yP8fhVJ2muYUTw6xKwWGtoPobb2wKyTX3yf6GNBaPgGR3tY9
46550	payment	2133	2133	1874	1	1	6897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxQeqcGZsUBv8yayDrPsQ2nrFqZGE3diKRWyEYydBzDr5iHDh
46551	payment	2133	2133	1874	1	1	6898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8CDo4QFQ2dTBocM2XUVq4Uj2oya4RmpUejy5MZTdU7TzPiFxn
46552	payment	2133	2133	1874	1	1	6899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb78zEWozMjmg5L7uiTvysUCW6i41REUJKfDsS1qS6iJksP5wc
46572	payment	1397	1397	1678	1	1	17339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1C817USkH4uCQe6sZFMWi1FkPzm8VnAGmUiz4pzLmEqXeMeg
46573	payment	2133	2133	1874	1	1	6906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxoXc74E93EYp3shpjnA4hKpLrPmzX88p3Cd4EzEuJc4DkBFb
46574	payment	2132	2132	1874	1	1	1779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFi6NxUnofjBjAcrQrYVL7yqThL1DqDrp7M4KNi8PBgRFyMq3c
46575	payment	2134	2134	1874	1	1	7545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqEdcJbfkYF2srJhkkSDFND4dA87YoW9ZHVdX5KkhM8Z3Z8ES
46585	payment	1397	1397	1678	1	1	17343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2EQPVEoJAmTWqHNnApBza5Ee64PBgrW8Ep7jz2L3pa4nD5Cs
46586	payment	2133	2133	1874	1	1	6910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bJCqFsB7iV98Pqix14M61SPAEFzm6ou8ZmnMfBes92aXfKjv
46587	payment	2134	2134	1874	1	1	7548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5SQ4ZUNkwowkuGWh9NFCgJgYxs8jLChVArbtWegute1SDK8t
46588	payment	1397	1397	1678	1	1	17344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMq7Pku3WoZr9um7REpKwWnPTVYJ513fQKDAineSsTwUsNHpP
46589	payment	2133	2133	1874	1	1	6911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcVsaRCJqFAX4TfrNRPcik3RkmNV8EewqADhZLfQMz9fCA4Up
46372	payment	2134	2134	1874	1	1	7483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMUnFiNfrN6FLjm7QEpVbsQis4pyBifaSNQdx1nq3EsVEG19K
46373	payment	2134	2134	1874	1	1	7484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpt3n3NYdtxe17QnQLzYbPv2qB4DXXwo5KYnWc1kmE4Bx7rm4F
46374	payment	1397	1397	1678	1	1	17269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmVQami1eC8zhUm5RhjopEHGQdVx9DHbuxHXB6B8SHPYPZYFL
46375	payment	2134	2134	1874	1	1	7485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvULLL51JXxsB9LdfwrKn8WHitEoza2tKuTXkrnQUTugbH6L1B
46376	payment	1397	1397	1678	1	1	17270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8g9EqJMknm8TU3cdCkqhJsvjzzNLYp8x12rjhuaPMfHHSoJr
46377	payment	2134	2134	1874	1	1	7486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpYTcE2egG7ZBKybWmFKfkNQn4DzpKBpHBcsbpJp5rZ42us3H
46396	payment	1397	1397	1678	1	1	17280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vWFGAfGucEvEtMDgMmxwL2ViS2hj7FZxAUKRPQcZCAtL2eqM
46397	delegation	2401	2401	329	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFE5LniLz7KSzMRxcttn64gnyrpy6KCeMcLFJ1CbsnJnPaepKV
46398	payment	2134	2134	1874	1	1	7496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYki9dEXTyAL4tJ5YLkWjbNdALWvc5CD8NED32zMq7ZwcBmxYC7
46403	payment	1397	1397	1678	1	1	17283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRH4W4PxChkz5Sx1DMkRwhYH9Ke7diGkLnMjLFrd6ZLv18A39
46404	payment	2134	2134	1874	1	1	7499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitRDBfaLnLyz2Bb2BavoggCZCvaU9ok1rNdvvBJn4HjTzHdrm
46405	payment	1397	1397	1678	1	1	17284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpgK6svSbYNwqnMo2nRw6k77jymfqGtLBAAadwttaaWFjtkG6
46406	payment	2134	2134	1874	1	1	7500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfefRycazo9oznaD4p551fbxW1skfgatGucj6MzSXEV2gRxSb
46414	payment	1397	1397	1678	1	1	17288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Hf4yP4btcXXdDzgGP6Yom3Gm5VKg3vnh4ETwMNTNyRKriXia
46415	payment	2134	2134	1874	1	1	7504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWCRTtp2Jrd8oWETFWBv18cutK3ZUb8hF5ZU51c7HsGoF1gF9
46416	payment	1397	1397	1678	1	1	17289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GEFzDY2Q2WBNAjxvgcXD1ZoYXxbFpzNxKyjCFEYSccPc8xyv
46417	payment	1397	1397	1678	1	1	17290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Nca8KkEydFpicwm61hGdVZWQVE9x6eV7YWViy3pxva8emgc5
46418	payment	1397	1397	1678	1	1	17291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ221E486H4rB1G3bcuJQR7Ada9pUaoo7Bk8ywJzTSk6Pr7PpwJ
46419	payment	2385	2385	835	1	1	2	100000000	3666670	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhafKmfPvVhDtW2NNkny9Bw8r6kGaydQh1u8CVuLjzhFZNgrj
46420	payment	2134	2134	1874	1	1	7505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovrb5WuwcypFV2svHPzDjVnrK6BsrBFbG8CrZYmMiZoD4LkxT
46421	payment	2134	2134	1874	1	1	7506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUS2FiVoRMpDthtnfWKsYwQaiZ8GFwD9mk847Qa7xrdxGiNfM
46422	payment	2134	2134	1874	1	1	7507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg31Uj7UvFn2omAgNFFDm4h7g3nFst6kiG2L9UeJ3BCGi9Xmh2
46447	payment	1397	1397	1678	1	1	17302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHisqF5hkxfpDPfPoaxJew8XbPa3e1Wd5ks5YMABJZCPPzYa1k
46448	payment	2134	2134	1874	1	1	7517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVD5ZLtvv8mMbJrj8A9TwovPGxPT4uBYcQyqYVU4gaojt2eoh
46449	payment	1726	1726	2404	1	1	8347	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKE94b6ap3qEtFVfVUM8fe98n18hnf14WJjRBqTwTJmw7GZYUU
46450	payment	1726	1726	2404	1	1	8348	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYeFshb6BRugZGXKpL2D4ZBtp6G73Z5ZZQtEGuMiK1A8bkDyT3B
46451	payment	2133	2133	1874	1	1	6867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqu2ojevKUHw9Buig5g4Vat5L2CrGLxoBkVXE3Tb4nf1JBRtm
46462	payment	2133	2133	2386	1	1	6871	80000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHXUgc2iBnVqqvzrqQ7LKohyQuRL5q1vPi1s3gCpUr4LFxj7J
46463	payment	1397	1397	1678	1	1	17306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Hi8YjPwWrX5DByQgViogu87Au4DaLVLmCMRWgcg6SDT4ZiSR
46464	payment	2134	2134	1874	1	1	7521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5NiMBojA6Bwec9Us1WRX3SwkcMEqKBKjwiy924xKGXRYC3v9
46465	payment	1725	1725	2386	1	1	1	98000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4G9ebmhjeK3TWGGNboUfEk9b42vrwFTsAQJXECJig3TnjUMqt
46466	payment	2133	2133	1874	1	1	6872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8mPRVr61nutSWzhMEfbrkmpiZWZYm9gLrW5cthVd7eBzK9zV
46477	payment	1397	1397	1678	1	1	17309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEttsxJ6PKrq5x78ozaDUk5jptx8A6uH3TSfRcpN1uJZDvewuR
46478	payment	2133	2133	1874	1	1	6875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgurVvCanKRKbikf2oR4M1CD6dj6sPaTKL4EeEnJ4GPiy9Geq
46479	payment	2134	2134	1874	1	1	7524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTQLwgRGA4sR9CXXteBcLU5fdqyiZ17xaP9ivv2NndKCwWuFq
46494	payment	1397	1397	1678	1	1	17314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuvhi8TGG9drrkL4hZTJ4Zhuj3MrRYZKm9iT6N9sfL1Nms5fT
46495	payment	2133	2133	1874	1	1	6880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uBHbXCo1Ap6FErYgqidbRaxdWfd6usdpav2vW5FoH1RpiyWu
46498	payment	2132	2132	1874	1	1	1772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam1EJXS2FcgigNnU1rNiA2Dz2Jnh2igbZejV5JNPYxNzMUgdY
46424	payment	2134	2134	1874	1	1	7508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DXYbXNuxomesfoMq8Tdktn9Wb2vG4fe33drfP9KEJLK8oHSc
46427	payment	1397	1397	1678	1	1	17294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigVtHr3QnTi6q8sU8a3yk6S9JVYoUS4kBMWAtQhSiqvZzisbR
46428	payment	1397	1397	1678	1	1	17295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3j8RktTEyXzDpYtUe6pFjw8bykS56VGNCF8oHudCXyLj5L8x
46429	payment	1397	1397	1678	1	1	17296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTe4sUhAvy11ny6jeSiY3nhzNjmZY3VzfUbb2sQyRdUM4sYJf
46430	payment	2134	2134	1874	1	1	7510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1dfYTcGC8ZoSqRhgzSBdqWLTqCTg7w1EZgyTA2P6KrtxnSPZ
46431	payment	2133	2133	1874	1	1	6862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhz7NZHRPYSNzBfuQY6dp4neBrh8dr3y6NhopZQUDZdrVGHeRN
46432	payment	2134	2134	1874	1	1	7511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniN61cc3jmeDCZK3yLsqVJCy6PSbDoHM8pkPWxiTjGp42pQjc
46433	payment	2134	2134	1874	1	1	7512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomQ2EW88usNiYZD2Qahg536TdSLf4Xj7teY439qYZAcJmSUhG
46439	payment	1397	1397	1678	1	1	17299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9tJuoAX3VwzAEFj3i7k2LMR6tSWfSgSPbKxCnkJnD1b8zzqm
46440	payment	2134	2134	1874	1	1	7515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNUtw7zkmRCjEXxxTNneCF52HufkmXgx6ye7h9dX8sR8ob8rf
46441	payment	2133	2133	1874	1	1	6864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiuwvmNhyzjmBN6MaXfPCv7GvFUYWtuPzvF4RF69772orqZy2
46442	payment	1397	1397	1678	1	1	17300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpegeaASUmiLAdrKzti3CMpd8DoB46cGcvUkfkfmJhVrQvk4X
46443	payment	2133	2133	1874	1	1	6865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXQuKSj24h61kKxc2PamSWYHzaGsGJReJw8YWZEU7ngX6CNQd
46444	payment	1397	1397	1678	1	1	17301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXmiFZSccJetLXkkAZfj7B73kuxL8tRmTH6zww9HWofBLy9y8
46445	payment	2133	2133	1874	1	1	6866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSLUW7Jw8AhqPMKTbJHQBp2mVrMejDoNJWWkZqjwD1UPJM8Lv
46446	payment	2134	2134	1874	1	1	7516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Tf8uKPYjNqoZRVqp6KCkvyDe8LabTiGSJMr3dZAgLte4rfR
46459	payment	1397	1397	1678	1	1	17305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFk3MeKw9vNtsW2aRKR257RGcDk4a8di1WdJ86PADjRiUsCYxm
46460	payment	2134	2134	1874	1	1	7520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9gdLScoQX82iNUp6R1CTPgfmURDfZWRuDpD2ayxGWcsKLpxh
46461	payment	2133	2133	1874	1	1	6870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEo9CWDj1saZXoBKAJbvGT1id9khmpjzZeXy2aAJSJ9aDm2J5P
46490	payment	1397	1397	1678	1	1	17313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3NbEdvkw6JqHQeiXNgaFmQHpya1J8zdbA5KxWuNEYuRArmqf
46491	payment	1726	1726	2405	1	1	8350	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUCTPh4koAvazGbT1J44euGhhso9nLihkBEZma6qt1bvgNDMSg
46492	payment	2132	2132	1874	1	1	1771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4U5VZkLxKipaXnddFZHLjChaUYaUtExA6VHVwdvT1tNcL8c1
46493	payment	2133	2133	1874	1	1	6879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpJ2myw8RbZwXUsL1DhsXm3DrbT2hsjbc9P4bN9BNjn4imGWk
46499	payment	1397	1397	1678	1	1	17316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrfbS3tZgWkuKWczPGEshAssBW5SZgprJPgKuX7Wf6XZvHARW
46500	payment	2133	2133	1874	1	1	6882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHLaBL4ShP2qmvRt7z3tkWBJ9ELAU2frAzYJNpcvZ94RtJr8q
46501	payment	2134	2134	1874	1	1	7528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KZKv7UcTsqsvyZih1opGmTVTC2gct2rG9MzzQuEnLHf7A1Yw
46502	payment	2133	2133	1874	1	1	6883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRU6yHihgaYkhztzuRMN6rgDNttFHUYoMko5Q4zunW8ZTS1LRw
46537	payment	1397	1397	1678	1	1	17328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNEPWM5KuTdQDaw6mdhBqDqPuQVaTnQAh1riVccUQEQEZrKJT
46538	payment	1397	1397	1678	1	1	17329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3o1yNTjeZTVAT77LKt1CYmwNrPtcPupcKqWiNFqot2ZVFawT7
46539	payment	2134	2134	1874	1	1	7537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVmqyuNydJHrCqiq7C3TLqBFjJ6X1uVaLdEp3mhdizanR3ZNN
46540	payment	2132	2132	1874	1	1	1776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBSqAxtjMfBxknQpFQ8DYd5A6Eh2Est9ESTfmTALwNf6AUzPM
46541	payment	2133	2133	1874	1	1	6895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAXF7nZHPHymtH6wjLkuhexTgeKbLAx8bJvhAHP1mMXiGTXnz
46542	payment	2133	2133	1874	1	1	6896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQycUcGCDjWuCQnnfcFHX64PAi4wBdqkXJ7M6zz9YzhdTarmsV
46543	payment	2134	2134	1874	1	1	7538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdvddSSzU4mMJNKPFf2WVRdShAygTYNacrFbtBRwgoHKSCkJT
46560	payment	1397	1397	1678	1	1	17335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6Y3tWhGKKPd1T3UFnBsj4S9wL6Zfb38EZG2GmNhWFQTbxszd
46561	payment	1397	1397	1678	1	1	17336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9be3iPbSTUPVZPrWUSacmwA8JJKKhNVdYZt3vV21ZWNWpQmUJ
46562	payment	2133	2133	1874	1	1	6902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvyGeNHZ2U2P9FMJxt1Ks3tmtvA24rnAujeacLPxk5Fg9nxbX
46563	payment	2133	2133	1874	1	1	6903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbYFoQ7FSU36Dxe7w9v69Vxf3joMnUu8cEkbfk5u3sXeNs2zP
46455	payment	2133	2133	1874	1	1	6868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TcDGisFbTAGKAKLkwevqvnv9STWAb7FJMrUCG6KDtivg3TPH
46456	payment	1397	1397	1678	1	1	17304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH3oxwzSkb7JUWTkgRRfZYNdZCb1s7U2NraLyjeAMaW8HLYSf
46457	payment	2133	2133	1874	1	1	6869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS6bhaozmW7ToCfqZfWau1LD59qu3QoMtLBB3ySYyV4zF8f2h
46458	payment	2134	2134	1874	1	1	7519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtRaboXndmaAtJ8R7QhjHY7MR3BRZmVNdYYWQM55QvCMr4nQQ
46467	payment	1397	1397	1678	1	1	17307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPdxvGF1GmzvMDhrhZwYH1m536yyNnvcaX8GRfu49Q3PrkTLo
46468	payment	1874	1874	2386	1	1	2	30000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQaBpPVsMHdFxf5H9itb3KjpX9HoiayTF4jDiMd4BuM8sJyvm
46469	payment	2133	2133	1874	1	1	6873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECUra74hB3FBMCSu9YhyAaxboHwv3WPtRhECkMKs3CQ7V9mm5
46470	payment	2134	2134	1874	1	1	7522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EePb3sQuN2UGnV6YhpyKBteYjjJurdgVJQBPoM4QnAUZSjAp
46471	payment	2132	2132	1874	1	1	1768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nrBoj1UDE3cW2DSQR2tUa8RaevdMaJMkEdXoLnPDG4ityTC4
46472	payment	1726	1726	2386	1	1	8349	800000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vagDNmJvs7cy3bGi3w2p4JaM5XkSAWJk3nBb1dWD34X8i8sF
46480	payment	1397	1397	1678	1	1	17310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesAJCzDmFZKxDyuVLcZ2QS7iR6G4o4annrHf2QX2ByZ6pLWyC
46481	payment	1397	1397	1678	1	1	17311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2KVVBomK8EJ85EV6cEYAzFmb9XosW3aXsxiUhwNGiCP5TvQh
46482	payment	2133	2133	1874	1	1	6876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeBvTS3WVoSUjKVPx3AKAjCeAUL2iYAUBxXHuPBjKFZnH2pcf
46483	payment	2133	2133	1874	1	1	6877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkn1aQLZqMfeJyihzTgQfeNV6dEJdNJsybEfAgePSwHqQhxpQ
46484	payment	2134	2134	1874	1	1	7525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGj4ivb7wb1PnMyChzrU3B6QxtKCdZS1BdTidf3LS3WWetHYt
46485	payment	2134	2134	2386	1	1	7526	70000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBkBacHG3Yr8b26oV5aQsCFxKW3MKW8MVRZwVcZ8HPKzmLfgE
46486	payment	2134	2134	1874	1	1	7527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRm4F8bncFMxmF8Litym5YmSpC8oUtwbmyzqRUNo66y53VVNSV
46487	payment	2132	2132	1874	1	1	1770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWvKmf5Mu7Qy3BwTSkDHEnawvGPZ4igxzpNVyUbt6M7EZ7QRV
46506	payment	1397	1397	1678	1	1	17318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdC4wdb9Df1VeFC9mCHacBjdyWtfhXJR3mYhX9WqNJeJdrtGX6
46507	payment	2133	2133	1874	1	1	6885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fQ7vxNfvC7agc4N8uh4w4K8Ls8LPz5RYGqn1KSCTMYLLxe6m
46508	payment	1397	1397	1678	1	1	17319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYGq6BQ92muGwF5m8G8WuQZqQsgZHRpLCPaZA5jUrQLcv2PsB
46509	payment	2132	2132	1874	1	1	1773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSzB7x5k9EczAMPrxk2kdw7RoSJVoQEzYcHvZExb8P7vaTpR8
46510	payment	2133	2133	1874	1	1	6886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4XCJgADTiRHpDUys1DmrEW8BYhHVRBhEiKxfZmcqA4Wn5YXk
46511	payment	2134	2134	1874	1	1	7530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9ofSDZbPjguZaB2HWf79ihTeTS3hBiZArYoGAsqVS8WMRJaL
46515	payment	1397	1397	1678	1	1	17321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpmkd46fxwvDLKyffTdYbpxEqXTDsFx3mY1FKVga4LF9tuMb6
46516	payment	1397	1397	1678	1	1	17322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdsysNpCUEB7VTVYRUMJBP5WTNh84VkGrDGehgikTo41g8Ap1
46517	payment	1726	1726	2406	1	1	8351	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpEzzXWYhWJkbJBBYq6qubriA69NMHq1BvzcvRZZUrGtYhQwdz
46518	payment	2134	2134	1874	1	1	7532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVb2PFhNbJYozVJepayBkUBP1Bb76GxUj4wufARCohDjf5yNSy
46519	payment	2133	2133	1874	1	1	6888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZca6eJ69kXaZStUysjFFdGaBExrT3RArbghWM45RD62PFPcrk9
46520	payment	2133	2133	1874	1	1	6889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqagr4EW8CXXhG7Dc2GGEjQ9cX9mHanNcXAe5M6Ckmn6NYYgkV
46521	payment	2132	2132	1874	1	1	1774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEc8NkKzwbT462GjwXYeLJELqv617wiJUMqX8RRmKyAyTQGMB
46525	payment	1397	1397	1678	1	1	17324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy21F1EURykJYthcGBRFftG6LaWP7g7mBB6ZnnJmQG9BLFGVvB
46526	payment	1397	1397	1678	1	1	17325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy22HvTzPb2t2wGAz4yh9bpsL8X3QQ8xCQrzpgYDaid1xGDEpG
46527	payment	1397	1397	1678	1	1	17326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2h8HGrnXG5igQpfNTD3KjFqmVF3GBTRWj7rfG64wDEpk9Dsz
46528	payment	2134	2134	1874	1	1	7534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6VwSQcfiAE7pmnybq2G6oR5B61i4SRtGGdyxpetXR74SYvmP
46529	payment	2134	2134	1874	1	1	7535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFPRNTX8Zgf5G25578zCn3KhK9ErgYrYrTCJ9vvtR5c1pcget
46530	payment	2133	2133	1874	1	1	6891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDKuuX7DjXVJthaNE3u7EnH6PboeRv4eXduUigNvqK7iqBtNA
46531	payment	2133	2133	1874	1	1	6892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs43dVKEFFGcFqBRuGeH3uS1FSsF5oUqNjJ14oU4bEF2JxrAWE
46503	payment	1397	1397	1678	1	1	17317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFAdeMZYc9sYjruohPgoaxNoz4kGDE8cqt2tf8B3JJgvjm76P
46504	payment	2133	2133	1874	1	1	6884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tVfFJ75rhu326wiAXnwPpK6vtjNTeRroBZcNx1Dv49QbUCjL
46505	payment	2134	2134	1874	1	1	7529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTp5fiyvj6vtJ43j29TFvyW6tCPnJMNKd5zch9gfuhx9N3mC7v
46512	payment	1397	1397	1678	1	1	17320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T7r4vtUL6bo84kFwvSqVSgs5s5hzJ5aQPWcKhLwYPkeXXiZ2
46513	payment	2134	2134	1874	1	1	7531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AhbXzvjdUB3X7aAeoueMS5nwU5dfK7CKXHC8qVp4ydweygCf
46514	payment	2133	2133	1874	1	1	6887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHLcEJAwa66wDNkZp4yC76FBYhurjLaEFjBgRu76nW6DR4xsq
46610	payment	1397	1397	1678	1	1	17349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzkMvhzL1u6DVHxev4LzsyZ3Z8x1eiC6pvcULGV5vwvbDxWHY
46611	payment	2133	2133	1874	1	1	6917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGJiNiWDmVNuxhnWwXhkXKABMGbMMdaPsU3C3jHbsyRLmQxJF
46612	payment	2134	2134	1874	1	1	7553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1NHxhQPUD715mVYbdwMRvz1HJP1JNQuVgCZnAXt9SSNHRHPm
46637	payment	1397	1397	1678	1	1	17358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw9hapsiQDR4SMUw45cH4mUUXYcFT78ZNTiX8GQaRZDN63y5Y
46638	payment	2132	2132	1874	1	1	1785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBepaxV8sFZqxHSL4ff6WVe1ZKs4s4gHznZcdbJid9oahAZtU
46639	payment	2133	2133	1874	1	1	6926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T6uJ6Pz91PEcGegHuHCveEZSYeLyREjzf3zTBoZh4GXvsJwQ
46640	payment	2134	2134	1874	1	1	7560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpNpSe3ofyK87LhX5EzscRaRQsiDg3zvsYkazFrft5yea5pLx
46645	payment	1397	1397	1678	1	1	17361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbofSGYGeet6iew2w7p3mUqtisFG2HqJzvbWXYacGKc8vfENf
46646	payment	2133	2133	1874	1	1	6928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztQRN1rsEXB2yRH7Ygczzk4ERpeDAuVN21SCCBpt3tBmp1Nr5
46647	payment	2134	2134	1874	1	1	7562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZga9BmXwrqKjhDwVjkuxU6kmEMjtkMwfszgYNrnAhnMBUo7kdF
46648	payment	2132	2132	1874	1	1	1786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSRZzWHGPvQFRktkEvSjTVaHrhZ36Dv7vJecm8TGz2vgw5FrP
46682	payment	1397	1397	1678	1	1	17374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPtDWMYKdHxj2ZaTMcppTZisaqxiyNHkom6LZQk7Tw3P2A6xh
46708	payment	1397	1397	1678	1	1	17387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUNrimSRko2M8zFyoKdpDebdcAe8divaYacB6kRQmvczbjTo8
46709	payment	1397	1397	1678	1	1	17388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzajhEFcFCjzUAyqAw24GqmRgNhHCgh3TL8DzUcZAcxLwEVeb
46710	payment	2132	2132	1874	1	1	1794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53vmGg69E5mQMPwkMiBupqPh8bTNja1rZ5vYQHxexJZLG4ieo
46711	payment	2134	2134	1874	1	1	7582	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZja4Jy7Dpwgtr6pSzjXQKy2XdtAv7cYGsxAVdyQP38UQBZNaNd
46735	payment	1397	1397	1678	1	1	17399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobXq9HD9rbrw8ghprvwKTjDX2ieyRQEN6VzFdBQ8qQw4t5rb8
46736	payment	2133	2133	1874	1	1	6937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8ai7kg2TmoPPkTxpkBrKGi82KBsgPdHwWRFzcEEEhpTqJyYP
46737	payment	1397	1397	1678	1	1	17400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8yh7rHg9N49QF1kLbnH6cRep9j93xTzdbmqouBKdHTX8p7qP
46738	payment	2134	2134	1874	1	1	7591	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yTq9LrHjsgvPpbwHxnzRLShDt5WsSpeTFcKGKmuS17PYtKn9
46739	payment	2133	2133	1874	1	1	6938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZan6q8AHKMfobzB88BfqnPR8eTTCDNQvZodRv7svofypLHn4Sp
46749	payment	1397	1397	1678	1	1	17404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMH37FP3Mx7byy1bRXqk88uJHUUxJirHg3MrdY8NtxRb48Vwm
46750	payment	2133	2133	1874	1	1	6942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFLg2FX9HLGC82fXAxDwSvghuVo3Q2SmbjeiNk7s21JByBTR3
46751	payment	2132	2132	1874	1	1	1799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBsvej97XvV4zUqmknmMekvpWwcDHVnyAHe1jW9YWcU3tvXX8
46752	payment	2134	2134	1874	1	1	7594	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGWQiwSXZx5WRRgqcj6FrS2BDgXq911Y76sDw9Bt121nBiVCL
46761	payment	1397	1397	1678	1	1	17408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rsK538TEu9L7TMRzuEjBcPHXUQEcQjB6aGE7L2xDezUrwf7j
46762	payment	2132	2132	1874	1	1	1800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevLVAv66SKdf8PCDUd19CANAub3BjF2FZuCamB8AgVr6o3u8y
46763	payment	2134	2134	1874	1	1	7597	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeSfx7j9CsMNXVjqwfRgdgrngt6dMYgEo24XDqgLjZyp8Zx9g
46764	payment	2133	2133	1874	1	1	6946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGP1w14WkU8Hk5DkWWRbKDvp3QC5k5S1pXoFVsJGdnV1DoV2RH
46774	payment	1397	1397	1678	1	1	17412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgWSavMzw7hzYrRG4EkCHZYb4cNm9FW89QYt6kwTy1QPwoh7V
46775	payment	2133	2133	1874	1	1	6950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1PuSa7LBkVMdUuHu1wcUBqCJFEqoAAcxSKjdt4JMXLp4f4HD
46776	payment	2134	2134	1874	1	1	7600	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdVd1MjaU6Hk4B3iWZP8jLj3NBBQB2Rokj9oovczan9PUPC5V
46532	payment	2133	2133	1874	1	1	6893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUv7i7PM9BrJVb1YZhbyoaHwHSnBvSA7VwifY5xzHCF1DFPtr
46533	payment	2132	2132	1874	1	1	1775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgqRcmby3kHE3CskXrNJjeb99KrvXjWdT9TSy967GNngj5bzd
46534	payment	1397	1397	1678	1	1	17327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBy6BXH8gsYLyGoctidtw6Bsd6JuTdawwULwa96CwciMfZqsd
46535	payment	2134	2134	1874	1	1	7536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBhzM4GacJDwzrSKLngNhRY4ESA21MaWUQS6gr4DRQa1a6JeH
46536	payment	2133	2133	1874	1	1	6894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRoEo2h8Nc5AzMzBEBTF9J59QVTi9NVeG3PtQF5HnbVVcXpRE
46553	payment	1397	1397	1678	1	1	17333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v1ZxpNXExhSqQZSDi6UBKmkJnCbJDkDyZh71Bv3Nk16YiM8m
46554	payment	1397	1397	1678	1	1	17334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNF86Dk4HX6fV9z3B5V1BCT8hJdsxRHrdgCxNt73AieMF7e6g
46555	payment	2134	2134	1874	1	1	7541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeZCQek6vosyiP9G2kgwPwMqqoquJjpPjPpHGghrVXSzPcR6A
46556	delegation	2386	2386	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvoHrA2Zguec7ktAEbbSaMX9VRP5EvwijLeCNBrutNDXU4HWG
46557	payment	2133	2133	1874	1	1	6900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x7UuSRzJPKCeVXeJtFrs1DaqZoZ2VtgJ7j2cLEn63MR14XKY
46558	payment	2133	2133	1874	1	1	6901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9fUfJH9MjHdAkkBpEuM3nnsjs7m7vqLrAxThAgwYxe2cJocQ
46559	payment	2134	2134	1874	1	1	7528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPMA7C2yPomjoK4ifqxnGfBmmaLdd7tZX1kxs9F8xwHyS3owg
46567	payment	1397	1397	1678	1	1	17337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNWJugPdae9uxapdM7cmDamy7Pz1VntnQep6LYUC6twz5Uuhw
46568	payment	1397	1397	1678	1	1	17338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGuvTq2LM6YryugfeFBUq9ghGK7AmrgBRQnaG36WjnX4YPwNh
46569	payment	2134	2134	1874	1	1	7544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QYSeCHkBKjpksNbt4fc2C7KuoxVuPEYi6ECUGChazTLj9iZp
46570	payment	2133	2133	1874	1	1	6904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsdGDHoitCUSBbXqC7RacW6ZzKDV56d6ccTQbK9FF3QUj8nrv
46571	payment	2133	2133	1874	1	1	6905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPmhQn8rwXaxPDQQXwmXMfMfUZ1KdzxJYpvKN3mjvFsHYFJiP
46576	payment	1397	1397	1678	1	1	17340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZd8PaZ5Rp1mUwgRe7co69LVbUDLZAXDpDsaXtpnikKzbygr4
46577	payment	1397	1397	1678	1	1	17341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEzvfSKaF8kFBxMwBmaA6RvakGpRMyXsyCuDfNPpRyLN1dCEP
46578	payment	1397	1397	1678	1	1	17342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3UXDtYxE932dsbKX4VodpA9giYWDo2NUkMiaB7wxxGugoU5Cu
46579	payment	2133	2133	1874	1	1	6907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2r6HfGemtSb2Uyngab1aPK3Pbo6jVbUoJB3Fr44iLXpQMd7rx
46580	payment	2132	2132	1874	1	1	1780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMj7VGgBkr74QcUrMyQjuWU9vHsRPsdYq1LZqbAWgfph2RggC
46581	payment	2133	2133	1874	1	1	6908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaELszGeBHwLfPeLcKdLCykNezok9fh85bbkoGgHYVXsBhARPG
46582	payment	2133	2133	1874	1	1	6909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYD5ZbuJy4MggVL14hNqJtXmV26AHYXj8ZE9rG1e1d3MnxVuZD
46583	payment	2134	2134	1874	1	1	7546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetaEDqtu3kqbq5HfPXW4JQ7VS36AUgGdE23qA9xuxf5XUanhg
46584	payment	2134	2134	1874	1	1	7547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwMVSpsCMvkz5GHnE2JBNPG5Vkey7HmgiHpfTNv6myPx3pvAk
46616	payment	1397	1397	1678	1	1	17351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs449oCb7HqyDi6sxna3YS1MBeKNAi6oEXSJxLjVaJVWwjJMyR
46617	payment	2133	2133	1874	1	1	6919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehmFsC5xBeDXBiiiLZMyZqZtsmWqKsBqjedSrC6FV6PL5sF5x
46618	payment	2134	2134	1874	1	1	7555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeLBX297zjuDquVxxzXCeYkYPRiESh8CeGeX9SHcRwcG4QjGq
46619	payment	2132	2132	1874	1	1	1783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf2JaAn3f1TTUzvw3i4NDpbaSLAsKJcW6NdmP3msJ12DdYJuQ
46625	payment	1397	1397	1678	1	1	17354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYDoeXNkYpgiZMEFUx89jyhJNwHGuWRifE7mcBAnq2M8ksoyy
46626	payment	1397	1397	1678	1	1	17355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCSLQkEjWkvLpyEW439BL72aVgqZgS4CztRGnzWsgwUvnyvUD
46627	payment	2134	2134	1874	1	1	7557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGSWDyJVNAizCzGY8A5sMC2G9BdwY1dgpyMaKPGGqS9iZRM9W
46628	payment	2134	2134	1874	1	1	7558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRj4F7yczCsNkskZQGRg4t29uh2cFuXmDj2GNAqdUQ5WAFbc4M
46629	payment	2133	2133	1874	1	1	6922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nYEfnkTfhNRAA37edMnrwqut1t2BPhxFTaZtxECanMca8yMV
46630	payment	2133	2133	1874	1	1	6923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfQiL5jMEgDxiGHNuPsURenzvZ54c8bqH9eJ6ME4kjjxWsrWJ
46631	payment	2132	2132	1874	1	1	1784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkvoKZEvFRMLotTgU74ARrVqLXnKwadqx9vQ48EntvUnnfgDf
46664	payment	1397	1397	1678	1	1	17367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsE2jzNvonAYCzDhAgfiSfUgm27XVp5QUaDMZvy6nwZuGDtCgz
46564	payment	2134	2134	1874	1	1	7542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJ8m7pX4KaVix62sA1x7x8u2jW19vBTSdv2172XoTwVTCoqQX
46565	payment	2132	2132	1874	1	1	1778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtLinFA9vSnX74AA5syGPDtsLSgAKhP2TGv2g4bFnc1GX48fT
46566	payment	2134	2134	1874	1	1	7543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wmfdJ8fQ4SWWFdRe5kSVZohf7anYdwJMiDCcFCZmeBYGuS91
46591	payment	1397	1397	1678	1	1	17345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR6z8RMx3ughWkJLhHHk4vsVGeJGQhLSmgBgNg36gd1FWfnR3
46592	payment	2133	2133	1874	1	1	6912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQUFMiooobMdi5zJX4cP1jVt1WrU8qABBBbRfbxYvgFb6r957
46593	payment	1726	1726	2407	1	1	8352	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXABtoQARQ94R2iXfD416MgAaRAgRzzCezXGsmYx2ngv3gHuQM
46594	payment	2132	2132	1874	1	1	1781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppfCScJdbMXyK1PW7rjgibze3J5BVVYHLHRbWaCZd7QSRKE6r
46613	payment	1397	1397	1678	1	1	17350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbEUG4VVmKfcUXTHxVn9on2yqE8zTzqZ2dgj6VgSH3FmwJwc3
46614	payment	2134	2134	1874	1	1	7554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLHxKSSFQ8wdmvvJR5rxnGR4KP1ko6XEjK7zbHXFMeG7YbHuw
46615	payment	2133	2133	1874	1	1	6918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1iqeAejnYPyx4u3etXuECQRpzX7g4i7AwUAmNj6NA9nsM8G4
46620	payment	1397	1397	1678	1	1	17352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWhDvPb6dbpn5MutgK7kGa9so2ogS87hqDGjqu9YKfsz3vYJt
46621	payment	2133	2133	1874	1	1	6920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLzgo5YTF3FDzLNzshx8LPLn7jMxhMwdPKWx6gkh33Qnj9XLW
46634	payment	1397	1397	1678	1	1	17357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnuHmo5hXTPDStUj57G37CmVCBWHctmNaPuWptLtSjJw2g6Yf
46635	payment	2133	2133	1874	1	1	6925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYiX1gsbfwtGBd48LQ3Y1nFRSgakinrU2jhZHhWVySwrfJfs9
46636	payment	2134	2134	1874	1	1	7559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoYEontPzfb3rAhtMMaPvYrxkWb564kBKubitFr7N9L8XK5rP
46649	payment	1397	1397	1678	1	1	17362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju1LV4gFxHg1NMcdE6KHfkA5kDBPsXXU7RuZBnTAvxNFhFhct
46650	payment	2134	2134	1874	1	1	7563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPon6DZ8P3FJs9yXGNxf2M8ZoQgUh4nrYhmPSA2jRy8hXVYM9
46651	payment	2133	2133	1874	1	1	6929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbypQY1xgB8o1Fz4ZNFLubhzYTfNR7BXfJ8FVGbDK4ahFvzWiV
46652	payment	1397	1397	1678	1	1	17363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcha8ubi88pcY7aLvUg9YNXJMuu5MQkb1p51oA7psCoTx6ZRb
46653	payment	1397	1397	1678	1	1	17364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaSL7jQu9TYw5D7QaEpwfjGRXy3JWgvi4GxnNiYwfDQP4hxta
46654	payment	1397	1397	1678	1	1	17365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpU9omqajEvYgTntw8ScmNvCPNhSj64VWXeyt2ZZzRVgEKjmY
46655	payment	1397	1397	1678	1	1	17366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEjCjFbCfG6KUMfnstopGBYKz7JXAgApHeomQhG79a1poZ6yC
46656	payment	2133	2133	1874	1	1	6930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB7anCfAoBChGzn1wnNqxSaMP81sXmxG5hD66subEmf61sqz1
46657	payment	2134	2134	1874	1	1	7564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKowxoitAqpy8dVwpwaXvmn6eFZttRkvrbSN5R5zHvr14YSec
46658	payment	2132	2132	1874	1	1	1787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiQnpe6RmmHau95wqWTWSXT252u2NyFX4dAS8NVKEwrETbRWQ
46659	payment	2134	2134	1874	1	1	7565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXhDtNFq6jF9HHfhJbabVfJ3NirvjRUjiEYaxhXgj53RXREa2
46660	payment	2134	2134	1874	1	1	7566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFhWR6opLDd2FrZ3RMWdeopqyN6Guifx9h66V3n3DDQWGfqbb
46661	payment	2133	2133	1874	1	1	6931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTwcBnyaQKqimGowJDHCfhDH59Cjr1GsCskdSHaqp6ogtvwTg
46662	payment	2133	2133	1874	1	1	6932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S1fu6xB31rpYZRYFXN9f7cUoLamJGL3HQt9A1LhFsNckh3vx
46663	payment	2133	2133	1874	1	1	6933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjckdZoU22vaHhnF9hnb8M7ZoGbagV3CZoeuQrjFhLNZazrCJ
46666	payment	1397	1397	1678	1	1	17368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFcyzUJ3cjBi5J4qNE7veEF878be7a3ZnvCbcMk6wEeiTLMSM
46667	payment	1397	1397	1678	1	1	17369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sKHJE8ManivmHsNJ9oaQgy8iUFqeJ8nCaPt9MCDLMCh9dyb6
46668	payment	2132	2132	1874	1	1	1788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWR1iPk4q7vzdJ59YiLiVJ1Ra9rPJPgnFDSM5dC9sCYC5SXBTp
46669	payment	2133	2133	1874	1	1	6935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZUNkjZiixLVNetqEPwpDTZvktdyB7AAmz9Jysw2nowpqbAwX
46670	payment	2134	2134	1874	1	1	7567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiBfZAfgCbDoMBkJ1CTkNvxte98GeaAVp9A2vmyPCw5NWSDiG
46671	payment	2134	2134	1874	1	1	7568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GBRfQLzmRXA9hubWTSHToXJ9qkB14DVdKCWcVVRqwcWuzPHr
46672	payment	1397	1397	1678	1	1	17370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGYojBVtQ7LuPiXAph9vFyatjrDxjdx72bE4ZN7xmBnwMxoMW
46673	payment	2134	2134	1874	1	1	7569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcewYDXiPnSnKuV6K63iyXdw8doJDjsfTPaWDnWrnnfAdwLzm
46590	payment	2134	2134	1874	1	1	7549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTQtAcUFYmGSonfiAm5JAtw3vjeLecaAJnQx85fENNo68g6ub
46595	payment	1588	1588	1392	1	1	13	312803000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYtfApVyf1KxLos9ApygpNGVdyL6FGkY3x1KoKN11CTqmzVyVhP
46596	payment	1397	1397	1678	1	1	17346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwTKV36WPeMZJcEebzVqcG4DXxqjqH7VyRPX5Ud8vDx8HJ7fb
46597	payment	1588	1588	1146	1	1	14	166370000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	Ckpa8AzUcavn583KAxiNRTLnrj5U3Cu6QXErNvMi47booadAh2Nrb
46598	payment	1588	1588	1266	1	1	15	111987000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYsmHtxVqxgZ1Tkq2ZVznaWSeWqsfZ6AhMPd9SeNbdrrQpDtb61
46599	payment	1588	1588	1026	1	1	16	92841000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYQnVT1HiLkDGiEM232xhCsBThucNNzJNw7gE1TtkNPEv3uApr6
46600	payment	2134	2134	1874	1	1	7550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uLqSdV9NhKBqwjERxUYT4nRnDXoV2Piu33HAMLFj3D2qE64S
46601	payment	2134	2134	1874	1	1	7551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE58tcBH6cYu9yYkUxtQKGA5iVLCQnyAYrmLPonF1bQW77oB8i
46602	payment	2133	2133	1874	1	1	6913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWwitfPWeYf75cpMWbvkNpJ4jxwmEZCebyqWhDpHiXb2bPmAA
46603	payment	2133	2133	1874	1	1	6914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Pkn23oQ2tCxQn2Trsgky6MYj24FiVPTr2eb5kKbNmfdAbFgf
46604	payment	1397	1397	1678	1	1	17347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALPcTcUc4iYyh4gH9cTpqnG52eFcqon5gfThG4HumsDGrTcJy
46605	payment	2134	2134	1874	1	1	7552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDnS7Qfv3bGu9NY4vH8RNmwrHBkFyfeXRNpd1hFECSjHkCdaL
46606	payment	2133	2133	1874	1	1	6915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmDSFfk1dNsWdw2BfCF68BrvMF6sQ8VG3JcsL84Wygp7cpW4S
46607	payment	1397	1397	1678	1	1	17348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE1FUv18xXirn391GbT2S11ySX3qFxWEKSncVzQGAUTq3sqyv
46608	payment	2133	2133	1874	1	1	6916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazGnNy1Pu86VKFpRsmegL3WH6TrAkNMdwmqh1v5VFZfayBHyi
46609	payment	2132	2132	1874	1	1	1782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuD5uEYTBgqW7aUc5t1UhMzdvq98UVPGXQD8h5KEebqQSFkp2
46622	payment	1397	1397	1678	1	1	17353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuxUf7xCy4RJ2Q2aoBHtb9GuDyTZW1AEABXU7zF9Kz3cipyLd
46623	payment	2133	2133	1874	1	1	6921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRdoduca1tcVaTwjV4Y1rarPxNQzNEC8g9DheaBtd7aNUvYre
46624	payment	2134	2134	1874	1	1	7556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdQGtV3jiRZuSaVjazybm1hAkVviaWmjCa4w65jKYcS6LibDY
46632	payment	1397	1397	1678	1	1	17356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ALtQ3uHGVen6tStR1D1dANMGLCP1mx9YywPAM5wLRps3gq2e
46633	payment	2133	2133	1874	1	1	6924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2QgxEH6VChLMhuE2Tb2h8zZAfdrfv2segf872mQ3Xqm21xje
46641	payment	1397	1397	1678	1	1	17359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeojZStddSsTqJoX1kwX6gUhsw1G5t9uZdLcEkD5gjALgzxeWC
46642	payment	2133	2133	1874	1	1	6927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNwNawrNdtvYYrDTt89NUskMs6g372mHXyFk2ooYaCN2fKcgg
46643	payment	2134	2134	1874	1	1	7561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpA5X6WWSLQkGc2SSMkgEi1joctrbhoip5dVvRQoHXjdhv6oSh
46644	payment	1397	1397	1678	1	1	17360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3WaKJ7kvuRxSe8RXo87fS7ZR7WDSPk5KevU6Dgkd6E5sFTXp
46676	payment	1397	1397	1678	1	1	17372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6L62fPvpnzkecisNaV81LYKv8i8xPYJoEb1naVgpNMZSE2eD
46677	payment	1397	1397	1678	1	1	17373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAXrWq2ePt44rGmehWNFt1ruwA2V3aRfZtXR66PZ3CNe8g6PE
46678	payment	2134	2134	1874	1	1	7570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzXanGbVSGcbLyTZYgMgcaC33jPrG3hib4Yb2znKzyaHW25sB
46679	payment	2134	2134	1874	1	1	7571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3w7FXWKBTM538cVzSVTxDCZyUf7tYUfZiMP3vfK6u88onxD6a
46684	payment	1397	1397	1678	1	1	17376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQcfE3cWtbxR2HTmqZd4CG2ZFg8F9GvpxdtjJAKSWBy6jDu7z
46685	payment	1397	1397	1678	1	1	17377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMd7V4wbXKWav51X1jymmLs9UjfkFFDtGmfhzLjgk1gqe2GyRv
46686	payment	2134	2134	1874	1	1	7573	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAYy9dekMTNJXKPhP8kBAJqTqCTsL57fiDofaurT6jUiPp12X
46687	payment	2134	2134	1874	1	1	7574	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUPMGDs126Mez4RiXs4LAih1aoqRFoq1QFN5SyydhsqJvrkjB
46706	payment	1397	1397	1678	1	1	17386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TqgN3jfKQ7DQk3eWTEWhcCF5SQpeWtaLXRgbFhnbBMX4GTgM
46707	payment	2134	2134	1874	1	1	7581	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8DCarFS9cZjGMGHU5LDgNAWCfe7VUwMXdmYRHQNXBgHNdYaE
46712	payment	1397	1397	1678	1	1	17389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8GwVHDU1PpswbSxdM87Wu8NKQDz779uH7SALpQJorhNcwz8w
46713	payment	2134	2134	1874	1	1	7583	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFShb8BFXGYTkuz3oX2ZMYWvjyrAxYqna6XUe18tAcQLxxVBF
46731	payment	1397	1397	1678	1	1	17398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8F2KSvgn4YbUVeVVF81desFjzsiqeGb44fcPTsAkJ7qWBx6t
46665	payment	2133	2133	1874	1	1	6934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7n7AfXvwL1i2aTNBaw4v9zZwJvcXGQMTprBLvMsK2ySujSKwe
46674	payment	1397	1397	1678	1	1	17371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqJv8WWcgcpX2mCcoGzNMdPag7Jmaw3nXrxY1o7sZA7Cnmxur
46675	payment	2132	2132	1874	1	1	1789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYQLYryHp5JvtkScHfqJmhCUXg7BsYsrkH2eLgDqK2LaxyWnC
46683	payment	1397	1397	1678	1	1	17375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxemd72VBAkJSxGr3CC9kKFxDEceQCFZtkKGLNiRFWuYL9CYBE
46688	payment	1397	1397	1678	1	1	17378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy2gYkcWMRSmQx7Pd7s88vdUhNGXEDD7tW2d4SRdJ85r3VqdS
46689	payment	1397	1397	1678	1	1	17379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TxaW7aQcsRDQvFyq7CnSw8m2b5pX9K4oAJ7YTPgr9mTZFbLL
46690	payment	1754	1754	1779	1	1	4	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8zVTLaZBbjdKJqy1ueMJJN2hBstFad6TdyvmPDC4zauahLPT
46691	payment	2132	2132	1874	1	1	1791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4PCWS9a6pMTWFg6Nw6CHQB6amDbUdCm6GaSCSgZj31vkH8GM
46692	payment	2134	2134	1874	1	1	7575	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7vFkZs6cPhdZ6sgh62ifQeLjDXjKw1usRqYQy8tW8zo7ttwz
46716	payment	1397	1397	1678	1	1	17391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASnDnm5bbHcQNGQ88a1yGpQJ3aevanpfY6FwjhKsAd8x5QKC9
46717	payment	1397	1397	1678	1	1	17392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJGJxjETQzKjVvx4qnNqesShDnBHrQihkmq63k3oi9NorUf6e
46718	payment	2132	2132	1874	1	1	1795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaszJEFNfGtci8tPYuv9x7s7Se51GokpDrHRfw71U9GmsAZoiH
46719	payment	2134	2134	1874	1	1	7585	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHK33XYRj1xhBSksVPLgARc1GafQGp6UePQxTUYe9SrBfTVUTU
46723	payment	1397	1397	1678	1	1	17394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGSXRb6CS2s7UVSwHTWAM76jjpKX83ZtSFfMmERrV5iLQ17Ee
46724	payment	1397	1397	1678	1	1	17395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTbjyp5VaPihj228uvnLAsfFJUJoxxfkeEUopHoCh4HG9hZ1L
46725	payment	2132	2132	1874	1	1	1796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjwakVyFPxw83P2tUaBTpPkyauFfMeUx9sFCqutB3Q23BSkV5
46726	payment	2134	2134	1874	1	1	7587	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoJbe9XjxZc2G4YHp5DMTxqg8Lxx7F52yKVfsmb1RgZQdVwre
46727	payment	1397	1397	1678	1	1	17396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19ZZT42Ky1CMwbKNySHfUf9dEPK9W4MPDxsX66U52qEuiTQJx
46728	payment	1397	1397	1678	1	1	17397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSywMjG4tQdZj5BrNkGUHroCcuqCrVNVm58NLdnukjQ1k4x8Vk
46729	payment	2134	2134	1874	1	1	7588	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3D7dZ6DqFP9pQMMBC91UQXP38yHd778nZyeAqRT4Bnnbr3wfp
46730	payment	2134	2134	1874	1	1	7589	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRoPDw36EGFHb2x2URARRWWjz5RVMufpjc6CS4p82wwFf5XMC
46747	payment	1397	1397	1678	1	1	17403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqG8TxGVJ3xNmHcmpA4f89BHjuWb8xsSY9SAVvdhEqFruneD2
46748	payment	2133	2133	1874	1	1	6941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKqZpkcQXPdFtqZXz5ymLAh9AUd8Hpd7MpFmw3kxSjyzAB7sZ
46758	payment	1397	1397	1678	1	1	17407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHpoWmpfSULGhaEtdKnduL6yGSSpoNkmzhEXUjRPs7KBCWUsq
46759	payment	2133	2133	1874	1	1	6945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8as9ifrKRFWN3LpFsJnG7fcphn6NMk52TCQufq5KQYb17z5QZ
46760	payment	2134	2134	1874	1	1	7596	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNiajNU66UncT2v8oiUzvF7tZBD9Yh1BZreFMEkJT8qRByw1V
46770	payment	1397	1397	1678	1	1	17411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT1SrrcsGGiBVe7YC9jfUQNRbRKvQpYXmVm6xZj9Qsd4G5FtS
46771	payment	2134	2134	1874	1	1	7599	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAhv8spt5FqFH9e6ovB1UBeZCf3ZiTVaBJGQH1jBYLF3VdDTa
46772	payment	2133	2133	1874	1	1	6949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZt9ntn3ecwYq1LXdnXZs3E1ZEqXbGQaRCcgUJQawaANNFDWL
46773	payment	2132	2132	1874	1	1	1801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpCqSLWijGWisMj7L13DcnhAtRn4A2GhY61uD92ChSML6UEpn
46781	payment	2133	2133	1874	1	1	6952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHya2vMgn2xn6b43ZbcBvuScodH3UXJ9y2woybaCBXAnzHBeNL
46782	payment	1397	1397	1678	1	1	17414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKUkBkP7jNqrXSVNQ1TgfU6EShGc1YfRbFuW2119Y8A8LKEVJ
46783	payment	1397	1397	1678	1	1	17415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM7AKmNabxqFuXd25uptRsWSFTfA6pyvavyBybjtdqkt7EnP8
46784	payment	2134	2134	1874	1	1	7602	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynyGvLMJ9z3kVxJgY1AFQh6cXfUvo285U3G6sH3iAo7k4nExh
46785	payment	2134	2134	1874	1	1	7603	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcFSLPsPTKfqjwcLbjvXotqXQ8GEB9pTU7bZ54jMjXwC3SEge
46786	payment	2133	2133	1874	1	1	6953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMgstcfUzmht9m4jtGojSmQ3o5pcSUTkrbSq9bZrzT4s7gtBa
46787	payment	2133	2133	1874	1	1	6954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmeUnLyuYQwXGY2PGqvog2YPbbgyKHvtQQmxNUABkqzqh8zmt
46799	payment	2134	2134	1874	1	1	7606	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQuRqCFCEtiDLztKn1WCAUbJWBkap6M5PdqPWabdUVufCdc7n
46680	payment	2134	2134	1874	1	1	7572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5zSZYTgGjam28cjWmEpkr1EMtN58T9HZApFVPNRJwjEkjNhM
46681	payment	2132	2132	1874	1	1	1790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZLcDdo42dN9LX8Vvtk9EkFw2PSjzzJ7axan22kkyuKkCT6j6
46693	payment	1397	1397	1678	1	1	17380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfUv412fhkwmirbxSJwCJvDjYKANcgt7KZXg54rr3G2yp2dKc
46694	payment	1397	1397	1678	1	1	17381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPx25buh36kPbtaswPbewbBMTeg9GJsZSbxLEBkhzfr4Y2RSz
46695	payment	1397	1397	1678	1	1	17382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwkRGK3TH3LH7LY88Hit915p5tYfFeaAf19NKQhRt5DqXzFub
46696	payment	2132	2132	1874	1	1	1792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfu3scv6h63zM7aC6ovzBpvkZ7SzKVVKrmS9J2tKaAFeKgLot
46697	payment	2134	2134	1874	1	1	7576	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HH4P4wceJeqobfh4WQAJ2e2Ym9khPDXyYPphHCbRPhjP71Cx
46698	payment	2134	2134	1874	1	1	7577	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7rSjkWnNMFmy8U6KbQjcVcLXByHqN94FnZV7qj3VQw8TNcgn
46699	payment	2134	2134	1874	1	1	7578	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPtB1ygM8gpV2gjrnN4rFRBGhP4Jp2RENDEWBzhQeUHxV8N8K
46700	payment	1397	1397	1678	1	1	17383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKhjNXk9tSGpsj4ZnpFPBMbAd5KfNENxJhNGntwsps74KwU4k
46701	payment	1397	1397	1678	1	1	17384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQj49rciaGS6Xcpn8P4ue8wLMGoqNFsKoiUkXxd8c2ANSwKZy
46702	payment	1397	1397	1678	1	1	17385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rZmtEUHp7vX6q5X8ijdFzHkw8uSvYp4FiVP2Aajs9yUSi2oS
46703	payment	2134	2134	1874	1	1	7579	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM5tvdLKkzWsAeAPyUqwFnMneZ2wYvPKyCmpRpnhyYfiwLP6j
46704	payment	2134	2134	1874	1	1	7580	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnxZs49Mos1zgnRh9QPhiFrwM62qWubY7Sy5rQSrfCCisHL5o
46705	payment	2132	2132	1874	1	1	1793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCBCvHqFM4ViL7LG4arEx7ZSSP27x12bTpRuhKH9jMJLXLSjx
46714	payment	1397	1397	1678	1	1	17390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mXwqxRWLt4gKavHWtFX8TCVmfe885f85GKE1hmuPZ6suZFh1
46715	payment	2134	2134	1874	1	1	7584	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXCdwg3zXSJsXwcajSzHkCYGWLQFUPRsPCiUc2yzAKu6fG4JN
46720	payment	1397	1397	1678	1	1	17393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnUrRN4knnXZQdDHckQicy5mT6UYAATg6bW2LgFZ73a659Tmc
46721	payment	1379	1379	2400	1	1	1	1693977634750000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMm2VZBaheYF2ySdXmu3eJMyJ4enSL2SawBf8bFR77q7V9oJ2
46722	payment	2134	2134	1874	1	1	7586	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YSoBZ6ECnMeyTsTsufQ7Foqd11iuGmr5Y58cXNAZsrgmG4Qn
46740	payment	1397	1397	1678	1	1	17401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXNHSQxYPdKcpJeSTXx9kkMTfprZNcMm3AXkfBVDxCeWHQnhS
46741	payment	2133	2133	1874	1	1	6939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjLRkEjgY85rNoor2GFTjuiqenrBYhUkk8Yeo71tQa8c4FfYR
46742	payment	2132	2132	1874	1	1	1798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYLDVAEckTYmUUPXicLcZ2HtytyUEr9k6JcxBaxmkbSjFZRgT
46743	payment	2134	2134	1874	1	1	7592	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYy7nn2v3SjJ5KzLqtCbUc3b34mfzGWh6YAoDXC4PnXbb3K7v
46756	payment	1397	1397	1678	1	1	17406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8VS88QG89uGUN1GnVW5PJ8j23yLxWEPnkVfbTTzKcdE2nALn
46757	payment	2133	2133	1874	1	1	6944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GddcgRXZzRf87cqixLxaHCaAxqFK3wLasVKKcMQgSEtXSPVj
46788	payment	1397	1397	1678	1	1	17416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE41HFx9E245t71G6fpcM7BVhzLHtKo41LDJtZCDb4MrbqM6ta
46789	payment	2133	2133	1874	1	1	6955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJvAaBucsbKvmohgP52zin1v3fthLNP1W7DFuZjnDtjNzTHkS
46801	payment	1397	1397	1678	1	1	17420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmERrUebee2LA9nm5pnhgKt2xNKkmxHwzapXQYsLPMYxmEu7NA
46802	payment	2132	2132	1874	1	1	1804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKXn26atDA7LTpf42fnuknpP3nMzt8yAQR3znoMbVyrr2hPEd
46803	payment	1397	1397	1678	1	1	17421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpLhiAgUtQ6VPENUzjPDdsnfsAGozta2D5QDXYyuWVfKAeSCW
46804	payment	2134	2134	1874	1	1	7607	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLpm5LpHSsZwTKLz6DwBEizX5gabvjapFDvticaba6YvxAVZ1
46810	payment	1397	1397	1678	1	1	17424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AYBppvRbUpdYXbGcLZm39S42K5rcMtcYkmNti8hwBHKL8hTx
46811	payment	2134	2134	1874	1	1	7610	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXsyckjNFEUK3X11KU9dvDTKwoJRb7aQzNXmSmWkatUhXQ5jP
46843	delegation	2408	2408	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYornr8bXA56Daeu6ZyPqQBeoeggC45eGukCXtrFh4bwiRZ97Q8
46844	payment	1397	1397	1678	1	1	17434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziMgqvBhY5icVTy2LUfdQEWGuCv11tdunDcuAzkCn1ECUusj3
46845	payment	2133	2133	1874	1	1	6968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3LL8j4fEHgNa8stBas8i2StHH5MRiXrundSGhKZ83k7Feyiy
46846	payment	1397	1397	1678	1	1	17435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcn2bAbriTMFh1RoXFAVeVh7xBPcxyHaFp8TGLBoSn6DWWLDA
46732	payment	2134	2134	1874	1	1	7590	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmyYChiBBLuHnxh7AAQPwPgrH3ySqv3sYBTJNmLAVnP9PmYPZ
46733	payment	2132	2132	1874	1	1	1797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTQyziKQLsZdu3co6pLqX4cdrgtp27W5NxqCGyowTWzH6dw9f
46734	payment	2133	2133	1874	1	1	6936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVGBCQbQnydXmAQtq2Ld3mXfvfeXa6i2Rvmqk6MizdnVRZouK
46744	payment	1397	1397	1678	1	1	17402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkgGdwbEMFVLLrcUnsdfvuRgp92zuAB34nc844sNDJgFTsMog
46745	payment	2133	2133	1874	1	1	6940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8m87YKQcHsE89JLcvvu99rGdCH2us8VsX3rGAbxYUvNtR685
46746	payment	2134	2134	1874	1	1	7593	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEgjjU4QZhsDBt7Gp4ZHSPyvv7rGT2RY2hio2HQFfcpWzcNzp
46753	payment	1397	1397	1678	1	1	17405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2w6RoMbbHdSW44pUjUXXnb1ZT3WjAKTUfJcGpan8y51X6QJe
46754	payment	2134	2134	1874	1	1	7595	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEouqJKZ8sBo125hNDD8r9j1hbjpFKbfFS6jfJqAy46a48mb3
46755	payment	2133	2133	1874	1	1	6943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MSUk5WQ71ZRadnmHKS1MBBgHDHdn7TuKiuk7i1MyHWZjLwPR
46765	payment	1397	1397	1678	1	1	17409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CTk3jZUkYogjrJsTMF1bCCkbVcDnbBA4bEFNWR9KQNTujitF
46766	payment	2133	2133	1874	1	1	6947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUwrtZortCFnLDziqoHqgXqwU4mgQ93NBNEMJ424bgMsTJ3Du
46767	payment	2134	2134	1874	1	1	7598	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZaYmF6jzeh9VYe98T1D5TM3Wt7DXPDJBrkp8iTKjFyHWLQst
46768	payment	1397	1397	1678	1	1	17410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUhCevKriLfmuTTKQJbvGbaiiDHeVqpEhYSDFG8k3yUBwMdjC
46769	payment	2133	2133	1874	1	1	6948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAv4irNusAX4E4oVCjRd3EzPzMLEPQrJE3YfHQsg1JQksmRhtt
46777	payment	2133	2133	1874	1	1	6951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P5U3PSo2iwGyHao5VnZ2PVvjK2eSSvduhMS9HcGiAV1SVSFu
46778	payment	1397	1397	1678	1	1	17413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtT8b6iuKaqtfmunqg4va7zspBWcwfZLQQExbv8dx4NQDFi55
46779	payment	2134	2134	1874	1	1	7601	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSePpiD1PVDU1GAzgP6g1BoURjGU8971PxhRdiMSKjGshPQSsG
46780	payment	2132	2132	1874	1	1	1802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhvbncgvgwwuubkhsCcw1zrRpaxnkmrhU3cmCJYA7wBAxZVUS
46790	payment	1397	1397	1678	1	1	17417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapNcoA3A5VgihLKW8uWQJbcAQWu1FBeGSy4pjJKQiimrJSnEt
46791	payment	2132	2132	1874	1	1	1803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAxqyZMPqh6gCc8jqU1ASzJsesdXbtWHNRd4J9gVutbg9Peqs
46792	payment	2134	2134	1874	1	1	7604	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSgVB2ZHLb78Zs5ruuTRsZbw6RribtDgomKcrgRGRmfzxoSFh
46793	payment	2133	2133	1874	1	1	6956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UTTzfUKbiGv2FhavpVbA7fB7YWygN13X4LZAoUd7t6KHb1jw
46807	payment	1397	1397	1678	1	1	17423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvToqLbDcZ2rBhGJbQx7B5PMXkaLKyrnLo9g36o9h6S6eekazz
46808	payment	2132	2132	1874	1	1	1805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYAxRHj6vnzu4SbMe529sZKVYJjFFGf6NSGBsEJYDvmWMn9bZ
46809	payment	2134	2134	1874	1	1	7609	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWW5H3SNDnDx4odp4RrtUiiLRzzfe264Gis4eRvtP5yvzPmBh
46818	payment	1397	1397	1678	1	1	17427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8W1aKFgMBr7hb4SrKEVb4Z7HgLn17wUALWmyoKtGWmRo5fEfr
46819	payment	2133	2133	1874	1	1	6960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf1Lqe5yxBSnXdxCDQrexbVWMpSFG4C5SMKU5ykxwKm5nbkwU
46828	payment	1397	1397	1678	1	1	17430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMjfH6dW1BDN6zpJXLC1j5Gjb9YAakgeLZ95yzmEwsPVqEtnw
46829	payment	1397	1397	1678	1	1	17431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeayPvdruRJfXuU6yV4obj7t81CkKDUtmLxLNtWcUxJcE5f6B
46830	payment	2133	2133	1874	1	1	6963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYfa4sezGRgr4gUshaFhQKTGzXZFEm1h6LXrRx7pNDhYJzHVL
46831	payment	2133	2133	1874	1	1	6964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNJsJBzQjA8AB4YuSFMqUGKzJko7YHMEGwhcPxjRQAWVGsZxJ
46832	payment	2133	2133	1874	1	1	6965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYPkQCMWNoUqByHsr3pCUzmLLE7rao7oWZyEMqus4Rxym5Uvz
46833	payment	2132	2132	1874	1	1	1808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEu4kY5XdjEHGF426tYh5B81o6JFvM98R1N8Fb5xWERh5ncXM5
46834	payment	2134	2134	1874	1	1	7615	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQU64bH9WDwVF1Q4M57a6JFXycD9D35yxewFTZkYkf1Fftxqp
46835	payment	2134	2134	1874	1	1	7616	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSXADSn23gZzMuD8dpHiYU1n56U5Qj4MCex7jpxqfHckTr5sK
46881	payment	1397	1397	1678	1	1	17446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkmvgAyLQwdrVVumE2SFvc8QvR9gS3Ukp8N8eZNEoVZAYxwbN
46882	payment	2133	2133	1874	1	1	6980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4pJ7KQodHJAodjwZcweKY36h5Rys8f8hemBXV9Fvcxdr7Do7
46895	payment	1397	1397	1678	1	1	17451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoZXm5X8ULEzZTxNMPzDNw84qGEXjgAQ5LtkfC4oG3RJ5cP47
46794	payment	1397	1397	1678	1	1	17418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTU8CvRrWeDRgkNgtZmoyKvXwtamTBq3YMoCMBpEnydoEDq1g9
46795	payment	2133	2133	1874	1	1	6957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXqQXiGwyUmdYSpTpGEGb31rW9nBWPjdrAAuwDG8Lz9M75vRj
46796	payment	2134	2134	1874	1	1	7605	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyiRJdb8kkEteddfA4CjP6CUVQ1weAySy6yMRaN7sxwq2N2jr
46797	payment	2393	2393	1464	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeivn6RCvYYJA6Xi8uo2ZEf6BUncqsWVe5c9rVavsiLwAGEHF
46798	payment	1397	1397	1678	1	1	17419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkZCsJsqxKoJ6zRfcLwK2YionSQcD6UdDpr3TeEnSjdmWYWgT
46824	payment	1397	1397	1678	1	1	17429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzSvAFEKZrxX1nGsas8PCXg8Q3Dma4nVpzkyo6BFSv6HEJQYE
46825	payment	2132	2132	1874	1	1	1807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUobRpZtNW352L3DiAWJF8PgoFBt2aHd2baoMdwhYAmQMvejEw
46850	payment	2134	2134	1874	1	1	7620	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1ER4gwAJFs7x7BeQhticY7oSmoBiJuNDhfqSE3ZdYhDaykJL
46874	payment	1397	1397	1678	1	1	17444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gVK6NfdudDhBmf5vnJULBetM1zXqJnA86ivLj1stxrAbpVbt
46875	payment	2133	2133	1874	1	1	6978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6NBurvHqEooQjo2qeBPx2KrfaABD9X7GsaBJP12vWfnfTM5b
46876	payment	2134	2134	1874	1	1	7626	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZpVwswbmaApNxgpu14xtWm9swJ2Govz4uRS9RvDaHk9DEaQo
46910	payment	1397	1397	1678	1	1	17455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPhy8W7xDe6GBXVMLJuLXro2TuA1FrLPAUJ3r7nmUsV1bxdwP
46911	payment	2134	2134	1874	1	1	7635	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwmHV8gQtAaov77KxVmLzVqNEctNCMRecSvbnihkr3YtHKo9N
46912	payment	2133	2133	1874	1	1	6990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajSo39nvFyVYdFPNyQj7ndcN4J7Ep9Ux2Dna6cY7zQR8zd93E
46922	payment	1397	1397	1678	1	1	17459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5PGMo2r5w4LACaspMCXJEdkBJMHwEabGFT2zpGxzwYjxnXZy
46923	payment	2133	2133	1874	1	1	6994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEWbmaKPEDEYsJhrwMuzAtn71M5CA16E1yn2Zga61Ms3RpQmi
46924	payment	2134	2134	1874	1	1	7638	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAxDsasqtDpU5KLosN2sgaMxzfB3ePiTZbvyGdZHeBiMW16PJ
46925	payment	1397	1397	1678	1	1	17460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYLs9SWTXBbiqhtWzGcgYrA5TCjdyzRSfJsuQPUW67obMWDyf
46926	payment	2132	2132	1874	1	1	1817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuzXAvadexuRYFe3SjwJBZ3dsCyveof5uhTZQHwPcm1JcJqjc
46927	payment	2133	2133	1874	1	1	6995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGouioS4YvXdgNonGXUGzzobGBe9auUiRNbZwuJyFsFMmKDDB
46934	payment	1397	1397	1678	1	1	17463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJsjwq4nABiaYh5cC8N7JkbLQz1iTnH5pEyP1USVWHmwyoXvE
46935	payment	2133	2133	1874	1	1	6998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2wNwn7c9QrR9ReahJ3ti8dHXktMMnDqdmD9by6VJmQiCeKCf
46966	payment	1397	1397	1678	1	1	17473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9szVU6mGZAyxAmpvnxKniQfEKMPN182buDTRTcQmYgBjz9bf
46967	payment	1397	1397	1678	1	1	17474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPpFBVczY44JrdQGBt78gKewaYkX1tqEmKGeazKSmXU7KeKvQ
46968	payment	2133	2133	1874	1	1	7009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJRN2zRXq2XPx9GgJQGu4u65hERow9b7hrj2zDTTDymYsYbp1
46969	payment	2134	2134	1874	1	1	7649	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvKp97EhKzBVJyphpAfynHcMapkJajumT2hKhCRxH6VSaDjEQ
46970	payment	2133	2133	1874	1	1	7010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYNxhy5pKPkYyzMU4vLPxfXUgZmGWSx2etVQPTXGVpooRq4Af
46971	payment	2132	2132	1874	1	1	1821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8LZ17rFcL4m6BQGo2HnwWvmf11oo6NFcKcbC16tMBk6PE1q3
46994	payment	1397	1397	1678	1	1	17482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM24o8eL7zMwzjaqpJsdZYdS6qvMMiHcJkYdPPR9n3Bb2hSdUS
46995	payment	1397	1397	1678	1	1	17483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuDqhv7mbUwvQxwQ3ibEqJuEge9LBc2LSVCYLKyi8y7muDVcT
46996	payment	2132	2132	1874	1	1	1824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbP4G4gSX5o8ooCCM9xSyJUcjE9r5Fg7D61LvmcQZJGKnVhfpu
46997	payment	2134	2134	1874	1	1	7656	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75qQVkwcQKxhyk2Es1CjfHMnca1LARy4Bv685xZV6hMMbervq
46998	payment	2133	2133	1874	1	1	7018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXutphUrzLndAX4xQdxUZF6DfL5785vA97YFRMCwpakWbrjCf
46999	payment	2133	2133	1874	1	1	7019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kY2hxspSPoK1DwMkmnB3ztuktPSSZP7F5UdgAc6FkVweqTt6
47009	payment	1397	1397	1678	1	1	17487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Gu1J341UAV78u16gUmKxiQgxd9dtHiKxHzSCEBZegpdZmwDb
47010	payment	1397	1397	1678	1	1	17488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZd5KH47HMFy8nYRd7627NNn74MuXHJGBYLBwdLhhxZHonXwVf
47011	payment	1397	1397	1678	1	1	17489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDKNedPsGwiHkuZ58cE2YCH95eCgGWGLGdUhBA2z54gQz1ZVdE
47012	payment	2133	2133	1874	1	1	7023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFso9PiGxGHdjHo28HsGuwspoLNhsEn9HDdZDraecrU4UhnDD
46800	payment	2133	2133	1874	1	1	6958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDzZM3K2Zu61gx7LtJvcvotnP2QypKS2EmHVPH6nLujxESF7w
46805	payment	1397	1397	1678	1	1	17422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXNYwHYMYcYr67v8815idbESHcjqtzZrjuqjqTHgfi4BDNjR6
46806	payment	2134	2134	1874	1	1	7608	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCco3ZxbGMEbE3eAmGFXFq1JVJ82RxCvJ3ibHDzA6eZjxxizK6
46812	payment	1397	1397	1678	1	1	17425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37HjQpZPgSgnvrczRnGsE9DY1784ijDXpgVKybVqxiUurASo5
46813	payment	2134	2134	1874	1	1	7611	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQAZ6HdHsDB68YYzmwpPynkjipqWxzEgGZzhqPQSTUVtuKKaV
46814	payment	1397	1397	1678	1	1	17426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVnWqNWox5yRPisSfMFAJtkfyBtgqxX1L2Pe8zQydX5zCXuPD
46815	payment	2133	2133	1874	1	1	6959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTs5w7qi6hPPf74pmA3NcVYFfov12RimtBSxrchMu7ytYHQLPC
46816	payment	2132	2132	1874	1	1	1806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbMghvidzAHE2pFSfYEPVNfiNmUGuDDa4b286Toc8ee1XGjGJ
46817	payment	2134	2134	1874	1	1	7612	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcRa2jLgV2gXf78CwQnBvZJ1wX2uLYifw2AJ6odznLmqxd2DW
46820	payment	421	421	2408	1	1	0	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHdzZMqBjRv6f3LKoZc3ZQeUx2q4d89SPrhZZfw1NW3pFwafu
46821	payment	1397	1397	1678	1	1	17428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VJrJREdgSAZjhuqp3MAC7j97gi2L2L6BVaKTniYHvnUBwjx5
46822	payment	2134	2134	1874	1	1	7613	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6ZKXdMksVaBq8o5ErPXToFCsRvfWuYWQe4tfkJVXi8Tv7YJL
46823	payment	2133	2133	1874	1	1	6961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSeLqW6DiQv5dEv7pa1ZhRYNTLFxmdgBuccEWhgGZu4HvaYkr
46826	payment	2133	2133	1874	1	1	6962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7Hun8C18GWBBLxs26jNRzMMt2GHWVrLHmBycqWwmdvoUYJYi
46827	payment	2134	2134	1874	1	1	7614	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4oUAFbxqJJyvvfpkKNKoEvFzbvu4CL2apC7hoZqESktiiyKP
46836	payment	1397	1397	1678	1	1	17432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iRKX7jXL6RHFy76XX4655D8CKnyB1BCUdkq1JW14u2KoH7jH
46837	payment	1397	1397	1678	1	1	17433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7sRWiRh1y4RCfzaaEsZivTbALoL1pGsfVESkjAKtJbf9a43Sc
46838	payment	2134	2134	1874	1	1	7617	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAee6UMDB5RTsox16viNBciR4yotaAV4XcBNWUoErd39pw5Vd
46839	payment	2134	2134	1874	1	1	7618	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZei6GJ77D5WhXu7cVrE6tmF8kGb73MxExwbvep56uCMx6QMKUa
46840	payment	2133	2133	1874	1	1	6966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfioEQPC4gePX1aBWsiSVuFWMys9qz7HYT56xWZQSqb6SPPJn9
46841	payment	1726	1726	2409	1	1	8353	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgY9TPQW3KncDe3HSFJkK5M6ibmsEAMAbtd3uU1gHwRoS2coFG
46842	payment	2133	2133	1874	1	1	6967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFVukBXhFZ8Jh84agzmFuZZoA3TzyeXYXEphdWEmJnudrJrHe
46851	payment	1397	1397	1678	1	1	17436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJLkPAczm6Wxm3caX4grrGyVQfMghvJWs4VnH5LSE9pbbrzfN
46852	payment	2133	2133	1874	1	1	6970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKTihCRm9yr3uxgAyiAZuMPNdLaRh7Sf8VqkHRDNXCisyore6
46859	payment	1397	1397	1678	1	1	17439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvy5AdSyjDXrzbi6mYwbMeB4NResVE9damKiBNmM9KCTE63vY
46860	payment	1397	1397	1678	1	1	17440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWVGcJ2nxQvSzbzgyeFs9saSZK8x3QUc5GEwqsMrvBTMZrgiq
46861	payment	2133	2133	1874	1	1	6973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbSBBibT2DXL6yyngMd2ktSfwtRYsrKH8iwAv1SBf8GZpcCaWF
46862	payment	2134	2134	1874	1	1	7622	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAK5tNCjyqZGN7y6sb9bbLmahXHT5Uz9rg5XRbVdqDpfBNvnNH
46863	payment	2134	2134	1874	1	1	7623	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacDwdTuBiV7wMhn7NLitqtVgVaVfvgCGTkwXLrmbXK5uwFrQd
46864	payment	2133	2133	1874	1	1	6974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFm7bwp4eFeJ692nXUh7HgZNnHrkmMRCqaTTodKj5HjbkREVj
46865	payment	1397	1397	1678	1	1	17441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHkhmdzsTDrUA4fs1DjpdCZU5fce9xZCpWz5M8e9vpS5mrek8
46866	payment	2132	2132	1874	1	1	1811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST4u3J8szRdiKTL82dsbGh8AG6LGVhopNLWYAGspj7q3cNRLP
46867	payment	2134	2134	1874	1	1	7624	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWGQ3uqNoqfeXdJ7Vg65SCX8X7zxx5HRCAARYTckKg79WzeQ6
46868	payment	2133	2133	1874	1	1	6975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNXunxN9dCVV5rTTViNUwP4QuuyTiHEzaaWB1o3uNUgJmhKTt
46883	payment	1397	1397	1678	1	1	17447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QukrgpvuAo2M6MpiokCfjSsmS4hPVQb4BPtGEdPUYueKWf3B
46884	payment	1397	1397	1678	1	1	17448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3YHPwnxXDCvE5NBNRVmfg1LTz9qFxQUpG5uiGex95TQqWuwp
46885	payment	1397	1397	1678	1	1	17449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9D21i5rwDYrfukkUKxPUJ9G4jTgLJCVVrfgxSTtvLZCUURPJ
46886	payment	2132	2132	1874	1	1	1813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxHwUmB6NF2Q8ECthgVmgFj2zTrystmJsNXHZHgfbSTkBGvvj
46847	payment	2132	2132	1874	1	1	1809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtfERyxgeLJCqTkSdMxJvbNd1XKBAhZqwfvA7NNhox7CVCFMs
46848	payment	2134	2134	1874	1	1	7619	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuexoAkcsvFkviPz9Dy9Sxw4oqiMpb9fdmSLMVhi84NRLa8zm4
46849	payment	2133	2133	1874	1	1	6969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZin1C9zs63ttAN8T37cXhYNRV3kUhBKpjkyx7fx7LQv44Vdw16
46853	payment	1397	1397	1678	1	1	17437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEugXsJKqYSurSXCzRahaQj6c41PJ4HViJ1P8UzcMvaXAKySCN
46854	payment	1397	1397	1678	1	1	17438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUXKE5SmESbP6ewwwM25y2532w5WYhjduYbEwhXXWdL6xjEb6
46855	payment	2133	2133	1874	1	1	6971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaX5msLpg37P7MjkD5aPeNTK5WFs7qC89CVTHpDw8diV4LCvo
46856	payment	2132	2132	1874	1	1	1810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KTYvMD4qvBQsfhYQ6sYuWQRrkhzthpP8pcp1vWSKZAL9unFn
46857	payment	2133	2133	1874	1	1	6972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGvsNSGQ7bx3D3cqapF6V37QsS89cRceNzGuirbUuJ75BtvBBg
46858	payment	2134	2134	1874	1	1	7621	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3i76jra9cJ1uihW3ohoUdEvAVo2iTP4Fnwcy6FuDgYYi9wMJ8
46869	payment	1397	1397	1678	1	1	17442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyUTDuQcdUfVJou4zVi2m8uayfsXw3yHEW8zsQELvqCr9aogn
46870	payment	1397	1397	1678	1	1	17443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddVGHgRtGtTjC1rEKAid6L6RXzz2NHRP1C5rrePAKuuFYuqDz
46871	payment	2134	2134	1874	1	1	7625	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhCMt41Pewy7vLwSdYpdwbWxFXv5hDdheVVdPHKmLCgrWrn8R
46872	payment	2133	2133	1874	1	1	6976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEeWWX9p6ijg2egX8KZy8Sg6rqm52H1nqvDabuHof2s2PbuX8
46873	payment	2133	2133	1874	1	1	6977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cJyGcHa9SufPeGjcGNCZMRmYrK2bcgByCBxhYD5SAe6Y6bcp
46877	payment	1397	1397	1678	1	1	17445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuUsMwCRvS2kycGRVAzCraJTP1b3xFvy1C4zdd9ENc4hLtT4E
46878	payment	2132	2132	1874	1	1	1812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjCnczaC58Mo5yj6wS9iviU5QaCpcn2vQr9Gm8zuideVjNGyf
46879	payment	2133	2133	1874	1	1	6979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrN9bRf9E1x67dLGQ4SxxG2LwsFi4oRoBvNsUUSn7P6iVY6gvc
46880	payment	2134	2134	1874	1	1	7627	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGefb7KBxsWWx96BAcBRf6WZCv873aY3gtNgzqb6fy12kgL5n
46893	payment	1397	1397	1678	1	1	17450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1yt5MbUxqG9dCBGotzqz7WFWbKduRiv4A4d9YyipHrpcZsUU
46894	payment	2133	2133	1874	1	1	6984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLpUTLQgSXqJWRkpC2ZWVppprRXhvBoAUeBh28imgmrHQBced
46904	payment	1397	1397	1678	1	1	17454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeYqJJeHVYZpvUgSLotuuvmQ5jdZ7nH4CmeT8NvhLECrnnT3i
46905	payment	2133	2133	1874	1	1	6988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpTZQdCjLot9yTRwRuGCeby7N4vtJSXrdXBLeHHrQKGT227qg
46906	payment	2134	2134	1874	1	1	7633	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaVwbZhTvxPhVPsVngeaHWUn5fE35Qir14T6ouJJcpczdU54g
46928	payment	1397	1397	1678	1	1	17461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCh8csPpMWSNEcGJv76E5UGDsEedhppHJp6S92Znc1oePy33nn
46929	payment	2134	2134	1874	1	1	7639	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4YgVFW4e7TrUnyrE7K4qQijQyu1orHBonmDgV742bNUs9Edx
46930	payment	2133	2133	1874	1	1	6996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXveDJzJHvrFhPHatNyheCeQRENYf7QB4oiuAfjnFRGn15uuPq
46939	payment	1397	1397	1678	1	1	17465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFB5aiNNwaLPfKxdarQyw5HdUnGXtmwKpiYfbkGhjgAtVaS3S
46940	payment	2134	2134	1874	1	1	7642	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBTJKfgTEHswhJp8E2k2nEoMi1bExTfRNoipHewVtw5DybE8y
46949	payment	1397	1397	1678	1	1	17468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKMg5QnrMZHph7wHcWVc6ii2hko8jaAqi1Mpqk31rxMLNdytt
46950	payment	2133	2133	1874	1	1	7003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeT8i3Ud87ZonmPUcF5uAafWo2zYk1CvZwaTP7wi6v5ofCoYV
46951	payment	2134	2134	1874	1	1	7644	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzcPqxWivgywKp9QAPCwAj6PaFau5iZb7KNMtydD8jnqehVQq
46960	payment	1397	1397	1678	1	1	17471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTKU31uUhrDaaBDCG1cpRShiQhWMJ3DZGHc5Wk4zoxZwELAnv
46961	payment	1397	1397	1678	1	1	17472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88yAMVqQSNrmkRaZBYhPeG6hKGR3XeGwC2nzLWjfbpQ6MA45k
46962	payment	2134	2134	1874	1	1	7647	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgyf9DHbLWatNk5F5QHsSLz78hrWReZJS7nQq15N6pgNiZH36
46963	payment	2133	2133	1874	1	1	7007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHHRinZhJFV9RN5mYd8SP3bsJ8fUJtjVkvm2TMs3n75GSErLN
46964	payment	2133	2133	1874	1	1	7008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXT3brcVRiVg8cvFWwyKjXSGcd6vvkgLFTQMdRXkrWn44CYLP
46965	payment	2134	2134	1874	1	1	7648	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69DurHu4AD6cEziwQRabBdeejc99FQcaPH7HvjxfJCuyYZGub
46988	payment	1397	1397	1678	1	1	17480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuyeHbpz9UKjpJkmXrQ91ccW1z1QQACPgUPL6td4WyEzLUe9L
46887	payment	2134	2134	1874	1	1	7628	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwpFVS4u7M7sgDWdQmNFMsajmfSPtAqaAADLsYg5XZDWSRZTk
46888	payment	2133	2133	1874	1	1	6981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN58N1Wzo4XmoRieXfQQczt9DdV46BXNUtzaPBJ4PBD2UUhbU
46889	payment	2133	2133	1874	1	1	6982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3Kfr9VJSCcMNFumTaoj4GdbpTSdvVgUfPKnGXBQjW7HiSopV
46890	payment	2133	2133	1874	1	1	6983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzGuNKc2WFPcu1w6mtmeLCt34xvai6e8dXzM5iK6BZ7Q2Mfag
46891	payment	2134	2134	1874	1	1	7629	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzf4GcAJbTY958R4k2nbNpiuZfwQLzRujHktXwKHNVc28cnfK
46892	payment	2134	2134	1874	1	1	7630	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAhrdVjQBEVevhRfSnsLDjARX2sSzF1y9tbABGxNKtvz1acPa
46899	payment	1397	1397	1678	1	1	17452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2urhHjs71WrjkH5CN5AMFdgAwuB5QkEcK3zxQFLGw326A19Zm
46900	payment	1397	1397	1678	1	1	17453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDgdydgh7PxyrXBjZQpF1b5gjKxLN1yt3qX6V6gmoNjZRMuXF
46901	payment	2134	2134	1874	1	1	7632	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd4JJt23bE6GCG4moW9DNJtMThUMsuzon6ENuJ9F8KVvhumro
46902	payment	2133	2133	1874	1	1	6986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i2CcFQW9dC3WQbsfFN7GkYvnCy8DNKvsgx5CdBRT3Eshm78i
46903	payment	2133	2133	1874	1	1	6987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vtuM5yNmKQas4tU8hA1uosvuVuk3UhFvJnQSpnfHE8BavUaP
46936	payment	1397	1397	1678	1	1	17464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwzougkBVz1CWdAzvMor6Upqhi1PgRvPK793Y2Mu9p3mem9F2
46937	payment	2134	2134	1874	1	1	7641	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn7qJ6G5DQnVLZrsjZ3VQKMyH9sUY6zSc7cRQypN3JggkC9qNW
46938	payment	2132	2132	1874	1	1	1818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4oqvB2poBmEKrL19yCBJe7BgSab48ka1WsjVqj8dRd7ifrgF
46941	payment	1397	1397	1678	1	1	17466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7DNoq63ESABeWTJVZxXjCZP5tpc8oNKfZEPs648tZTh3LD5g
46942	payment	1397	1397	1678	1	1	17467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXjmYs8zoQ8q124PTUL4XRevNmJfmX4kZk4FyqDpKdAZuvQH7
46943	payment	2133	2133	1874	1	1	6999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93T2JTBBS32S8Dq8GF3DwxXvgVydLj9og7jhas6onofSeottV
46944	payment	2132	2132	1874	1	1	1819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAnk5hbWvDrtY7G3JxRGFfuuorjEKusCJYAaoowWZGAEPWHTT
46945	payment	2134	2134	1874	1	1	7643	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSdwAwSfEnA93mL19hyTsU3C6qLqT6jtZMHGxLW8L2jujkV4T
46946	payment	2133	2133	1874	1	1	7000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5ajPNV3bGjuSHuToPyTXeiRsofhw5onRNDBr7sdtVAeLZABj
46947	payment	2133	2133	1874	1	1	7001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4yrpeiaCXSTnCMQCLujz4XHgXe3iRC8niiqPCsSthCwzUMir
46948	payment	2133	2133	1874	1	1	7002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmmfLgDvqL69hBMH8xsgiG3po4R41k2GkwP3dhTUN1RaYSgNg
46959	payment	2133	2133	1874	1	1	7006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZWKrSjJkugRaxb5rMm6UTfFwzqJ32Mot2z6VXacr83zK19k5
46972	payment	1397	1397	1678	1	1	17475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51c4upCt8q77MvNRcABxPRt7Q2LbhVdYXtoxpMup3Pa7RGYSC
46973	payment	2134	2134	1874	1	1	7650	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3KRsb1RNrdUkA3uabJiy3RqDhHQXB9QNMD419xDtu6i45p3g
46974	payment	2133	2133	1874	1	1	7011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JtebGTJ9zJPQkoVL5v3UkscW4X5asizgFBqdsgWhnZ8mAALp
46982	payment	1397	1397	1678	1	1	17478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWddnYVLNSReZk2WB4ZPYtkUQBR2BBUhBbgUFRDTkLiDTiwVSf
46983	payment	2133	2133	1874	1	1	7014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXoCt3eihHJoqXCz2PSQSZtB1kvgo1HWqaah27rN8cvGKX1dV
46984	payment	1397	1397	1678	1	1	17479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38AxsoPvhpsJD3kFWPLP1Mxo2p1X82zeqd5KvkH2JZgYdvLrL
46985	payment	2132	2132	1874	1	1	1823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yTJVTt9HqvqmrAVFRQ5t45si2JPtK4SRiNycFtLPVUAheHov
46986	payment	2133	2133	1874	1	1	7015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomGvdxydQWgf4zsug5RUD2WU1igh9YH6uAxLijH4BgQVESMpZ
46987	payment	2134	2134	1874	1	1	7653	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFUSF4tGvvnJ8tizJf7mbK3JE4XAJPvtrakiYSBMoVvxVKMub
47039	payment	1397	1397	1678	1	1	17496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZc7APjfKcC78NfTF1wSsjfWz4mA92kdVzTJRJD45V2CrfVnuC
47040	payment	2133	2133	1874	1	1	7032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbyp5Po3VGqFfEFTiQ4dZDV97eo7G3oEBCfQkvVPSgrieZMcz
47041	payment	2132	2132	1874	1	1	1828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVFB3TDnEfM9WbkLmEy3U3m91TXZzENyWu7SQQWnko3hbxJWK
47042	payment	2134	2134	1874	1	1	7666	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH3rrwtGwZhEYqDxfNJM5Ursq7sTLTG5NsVgwppyAeGLEiTbj
47054	payment	1397	1397	1678	1	1	17500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhjhYQVXh7gDNNTgqKDUmox69iAuxCL3Nmq9PM3z8xL5eE99J
47055	payment	2133	2133	1874	1	1	7036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCwqK2jTX1VdE57LQVAqn5CNsTMU1BfVPcX9KaqxrKG6KXPVS
46896	payment	2134	2134	1874	1	1	7631	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpf1QFiFR3Le2eG8zKTj7MqFM5bT6UQhKT9XVZyNpEt5RZksuz
46897	payment	2132	2132	1874	1	1	1814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PYL7PPTbrvfhy2nY5kgxPUup88HAQJ2rUUkswVdQyvLe4zdv
46898	payment	2133	2133	1874	1	1	6985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SMo9J31u5YAfPskvJr6S9y8YLSCX5apPGpYn92wenYRgnj5y
46907	payment	2132	2132	1874	1	1	1815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqK5vdZfrWKkdRr7ofLd7YswBZDkPGBorJR2e8cDd3Y8is8aW
46908	payment	2134	2134	1874	1	1	7634	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfyRHH9cFq3twXTTnKciL88VfDPTQHv9NchmgRaX7SCMnJDCh9
46909	payment	2133	2133	1874	1	1	6989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJwYGmNJLsZFaYVyM9XYpNn8ZrjC34PRUPeBuGAwZZZd1peMH
46913	payment	1397	1397	1678	1	1	17456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG7eyZUt7sG73MkLh27VqrfgMzBKrsq23bD6tFLqCuAHLjkhn
46914	payment	1397	1397	1678	1	1	17457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4C3dKicijeEhM44UzDVrJpFZ7mtsPcreq2avkYzhQk4unqUb
46915	payment	2134	2134	1874	1	1	7636	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36wWsaRXrmWtu77Ys6eCf2bqo3Re6j6zS1F9L93FZuBGrNf4d
46916	payment	2132	2132	1874	1	1	1816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCfpEnBHckd6QZXb44kmi1Rbn16T2osZ3n7dBV6i5WVX2DAr1
46917	payment	2133	2133	1874	1	1	6991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYacNh6hoJKNLmwv6uPxNaWBDrsE9o9QEQKR5YwzcsKTtYe8J
46918	payment	2133	2133	1874	1	1	6992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PikUwyTr8MsekPL3YxX683ck11cnQGVRwg1Ds4EFE8xeUJeX
46919	payment	1397	1397	1678	1	1	17458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfLWQ2tgoQbyu1ftQLczX7kbDdFGofuKCGD7A4N5CVWCHCt1tf
46920	payment	2134	2134	1874	1	1	7637	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQC2YjLUSTpcHYCPdo8csbQFcaBuVECYkgzfQcfyxFNh7YLFi
46921	payment	2133	2133	1874	1	1	6993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhJUvhVFvjMwptVumEnvF8LPFXumMVgKnXoie2G6XDG2CYkXa
46931	payment	1397	1397	1678	1	1	17462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A8CaEBg1faeewmCq6GDBo6sPX2E5oVvRqiZho1RwkkizQfX7
46932	payment	2134	2134	1874	1	1	7640	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5kns6NXt6cAPeqVitGCVk33Pt65SXLkXHYSh7jJs5HyDN2n7
46933	payment	2133	2133	1874	1	1	6997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyu9tSJtXdpeuhSWhvZCKk6PmNDHqNRMv7vbijbWQzf2TJduwU
46952	payment	1397	1397	1678	1	1	17469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqTJJMEoEriHFGJJDCPzz85y3h8xHV6mBWNzF9wPtjyNdzW5k
46953	payment	1397	1397	1678	1	1	17470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4fTr5a18vVitZt3ZRTSSASzZp44WBHSrhfnPXEDYYffBnmbP
46954	payment	2132	2132	1874	1	1	1820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERdRdb4Cniv9c2UQqX9vMTJCAt3P7EWp67RJ5pqVMFHEFr4oZ
46955	payment	2133	2133	1874	1	1	7004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4NihudyebajHFFkt498ow2cVrLfedRs7q1XdLvydp4WLCYQs
46956	payment	2133	2133	1874	1	1	7005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugJV17JnNDNT7bMTpFtcRCj1NHJPw5YBHWEK2EgcCmDzDncMR
46957	payment	2134	2134	1874	1	1	7645	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1V8tpJMk5CdAgT1WFR4EyJjEDUuLMe1QMzBPH4m7uHcfZ53Qi
46958	payment	2134	2134	1874	1	1	7646	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MiVTketREwWySTMzWQ4wuzzBFcmHJDnXGsaKbA9J2su3kggk
46975	payment	1397	1397	1678	1	1	17476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8SmjVGvXtBBxtkw3m8babghorCpCY4BRKprD2CRPsh5SWYW6
46976	payment	1397	1397	1678	1	1	17477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNAKqXCSZeK1D13MdX9AkS8kfX63apsZ5oGoJ7qzGCd5p3NxB
46977	payment	2132	2132	1874	1	1	1822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxUGNZA2wxWqNdeZ7nkdEqCKne1VdzbkLCjNQSKTJsDZfpUma
46978	payment	2133	2133	1874	1	1	7012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtpmnGUR2qFJtfx3GnBMnZi5CPqBVacmiEcMTaogsufJBkGz7V
46979	payment	2134	2134	1874	1	1	7651	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYsKxw5VEsv84yL9ZXMrJPiLd116orUG7tttzou5F8PDS14DZ
46980	payment	2133	2133	1874	1	1	7013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwASz5LYt8m2ox4e648Qk7b8kJ5Df499a4nUU92vraEbtLqm8
46981	payment	2134	2134	1874	1	1	7652	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9n1Ad13SZaEa7HRC2HuvyPsc63cKRcm983N1eK37b8rnwb9u
47000	payment	1397	1397	1678	1	1	17484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYagBzMZmrMNDC2tefAnQQxnviN2JX4s2SezioZQyfrb4hh5Xe
47001	payment	2134	2134	1874	1	1	7657	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCywxNcLwmX3S3ri8gvDh47vxbGFUWwWC9pYb3T1kuvSLyrCif
47002	payment	2133	2133	1874	1	1	7020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuJ3EcDhtfEGkDXsU8rtRbp2TczpvuwrcWXKuooCdqWsQ4dpa
47043	payment	656	656	2411	1	1	0	30000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78HKYCdcBqhgfdrPDw6XNmg5HYjxYmjzMxreBh3GeiTYRyqsm
47044	payment	1397	1397	1678	1	1	17497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvSvjPk6Z1WZg8bX88FEyzWwmszXYJoWTVYBDgeRdKDwemzXL
47045	payment	2133	2133	1874	1	1	7033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjXi6b5M4KWrpXR8972epCuvcSWmjs4c7Xx8EXm6ahdZM5rgk
46989	payment	1397	1397	1678	1	1	17481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmTNVhfVNPi2a7HUk6tVVWdroBoz7nDghxskZUhH4NeGcW33S
46990	payment	2133	2133	1874	1	1	7016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFLhhjtKhbAfEj5R3neuPMyDZAHg1JSN3BFvHdxoQpLnrfPzx
46991	payment	2133	2133	1874	1	1	7017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmo7TqXXVbteYzcER1gWqzq4AhhKp8Jr4Hy7gSXJKaXwHY3LyB
46992	payment	2134	2134	1874	1	1	7654	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bre9s3Dz3nhtjuZrKUyAn6hgNEtGGdCF172RMLgExyALeq4u
46993	payment	2134	2134	1874	1	1	7655	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEooqN2Ctu9MRvFqEGpHniR5heU1Pv9EniRKTmphR7THefUHAi
47003	payment	1397	1397	1678	1	1	17485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSY9GrfKNoUnnx3ppUoxSQGVuhoFCL1H1xMqyc5vsSzqnXJCY
47004	payment	1397	1397	1678	1	1	17486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWEBmq2ZQt127c21phkzVnGRcTaKrvmAufZ6NaR2cnTS5QYff
47005	payment	2132	2132	1874	1	1	1825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfdp3nwhVPDJ3Eib5ygZYgYG7P8MRq3VWPNK7Ruip3wUxwQjW
47006	payment	2133	2133	1874	1	1	7021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCNVAzCMQJgjvVSYLhpGcfHjqNxaRJ9EFarBDZS9R3J792a27
47007	payment	2133	2133	1874	1	1	7022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrM4B5NdHjRZFJjBm4sKAXi6qB22VVZWdHvzjPHuYVxRWfXmM
47008	payment	2134	2134	1874	1	1	7658	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxBdLXKiJqfsEVXSHz3e2K2fjphMJxGEHDmqSmEAaKUbUCMHG
47019	payment	1397	1397	1678	1	1	17490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe7KYJqY8iDchUDgDbLknp7mob2UhmWA9HYsCE7Cr3EFcJJnd
47020	payment	1397	1397	1678	1	1	17491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5dcJtgb4dYRvFGUMJeLYHBNoqxpbThJKZP3eyg8mQRCvZNcg
47021	payment	1397	1397	1678	1	1	17492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6Utc9z8vkWe9yzKpVb3TLfF6YMqLAWJ6enDbLnBNDnG93MVp
47022	payment	1397	1397	1678	1	1	17493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGFCUZ8KcNaCZYGfwoJYnhxyy3yNFfRCqhA9ZYpE86G8tvXML
47023	payment	1397	1397	1678	1	1	17494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CwLk1WkyhfBZxxjfUer9MnqjMS6VRXziZSW83H91Ykr9d5sn
47024	delegation	2405	2405	1406	1	1	0	\N	3769230	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5EoehAABoroT3yjHpDJ2m2U4g1hpwtaw7zXAfkn5XFUra8JU
47025	delegation	2405	2405	1406	1	1	1	\N	3769230	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywfZSbCTCbiizWBqv8RQxNPVFqhzkaZVQ9n4XFuGt9mYX2FZw
47026	payment	2133	2133	1874	1	1	7026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qJDvwRZpXkinU3juyz2BE6pRApR2tSv5PU6ywGSsDGDypqvp
47027	payment	2133	2133	1874	1	1	7027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHhYMc2dX6gpqnd3ha3QNMG2eQB9koLzDFYr3aeewdPKbNJdG
47028	payment	2133	2133	1874	1	1	7028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy6xEm9xztbWtwEg5yfVwrLUW9UHvgm8v2ugaADwobDTSwWVB
47029	payment	2133	2133	1874	1	1	7029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovGTPY1gbEUrkBUdmJCkGbvwSsZPG2s1BNSXETHaT42XruK3T
47030	payment	2133	2133	1874	1	1	7030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD8kNLuLZSGj57CftvyV8MwMFfSG3cN8yU61KMkoFyGPvxvM9
47031	payment	2134	2134	1874	1	1	7661	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwS8MLZFgWrnPgVYuYsny9DFc5CPdoNKYkUQFGiRbrfSJyrafi
47032	payment	2134	2134	1874	1	1	7662	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEgkfvrxjhjKdsFwTjfmzzvSzHSYiThxnUjFakVzuiJgqzHAu
47033	payment	2134	2134	1874	1	1	7663	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zWUnQTRgqoWFgD5KiWWpgH3uJ4s8YBieosgzYCn14jTDomBc
47034	payment	2134	2134	1874	1	1	7664	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWmcijcjo34Cuf9CiC3xWP3jnerxZiQAFZgJHX9nxUBsUR9Bd
47035	payment	2132	2132	1874	1	1	1827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94RgpWfDyN1PfWuqVHeCCDq7pftuhwQnkUrFJNsbHSqxERPtH
47049	payment	1397	1397	1678	1	1	17499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnde9baUTrb46PSW3vGB6nkUzT9xaNg9xFMsfYVXCJpzV8YAyP
47050	payment	656	656	2411	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncChwcLKL1x8JSB8Bj7cvfuQE7rQdj8QRNLimJAG1EkTtqHuu
47051	payment	2134	2134	1874	1	1	7668	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4EWKJZq6bXJgCPiDXFoPoEVqGvTGzNDUCCFwnWch3a19d78p
47052	payment	2133	2133	1874	1	1	7035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxS7Miu8nuYenT7pcUr1VPshqX1t4KtiB6238EpMpzpvitiQK
47053	payment	2132	2132	1874	1	1	1829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49zbcnZWX5MJxa4Wd8Q8qT4BG4jn4LzgEHdJk1YFxk6nBRAcK
47069	payment	1397	1397	1678	1	1	17504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pYkM9eiKDGankp4zKigUyQTKmQegGDpzodgWqdYR8HKeQTNN
47070	payment	2134	2134	1874	1	1	7672	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWBLYbqHyL1HcT3ZhyiR97AtjoTUfNByNaVDzjxTCGSACy7pf
47071	payment	2133	2133	1874	1	1	7041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkPHtkVEV38tH2QpwCKDpJjEtnDxPVwbiyF2GrXPjAYT7Na8k
47080	payment	1397	1397	1678	1	1	17507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrixgufoJ6a9mDi583ABhvBMarvcegHsiv1tk1EhhJGV53LdH
47081	payment	1013	1013	2412	1	1	0	502775774000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NPnrz9Jdo6Hsf7tGcGQGa8vozm3JWcZxXbjg9ztENuPHLRes
47013	payment	2133	2133	1874	1	1	7024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexi6CvDim6s9p51eaGPgoyjSjrNwCLopDXxvY67jfR753j4cE
47014	payment	2134	2134	1874	1	1	7659	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5TtvmkdZzNQL1Mbj9LhNz1wh5Q6aY7Vmsg9yfGTR9hT4ohpp
47015	payment	2133	2133	1874	1	1	7025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFDKs7MSD6kqAm3mHUSdc6bfWJ4gKHWp6jNwiXNPkrFDN7kJw
47016	payment	2132	2132	1874	1	1	1826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCwuMH7LAQcHbm3iYfXPfSbwdWXEgiq6rRbMncprnRmqYUVdF
47017	payment	2134	2134	1874	1	1	7660	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxR7jg5kW6PCFu4CgEy4aBKrxbcQzgBWBYyxLiNPQFvDk3arMS
47018	payment	1726	1726	2410	1	1	8354	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa72h7kyvUMSdDrLt48pkobmhY4BbZmFhHFKvHPwuk4Wxey1iYk
47036	payment	1397	1397	1678	1	1	17495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEvKZJZzJD3iAkzu8N8gcCwVsYdecNbqjsfpgpE2MHhRi7qTNC
47037	payment	2133	2133	1874	1	1	7031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZS5m89JaMn1nNnT5Shni5nQpSivZxvd5WL3zZdtDPpBrSPVf
47038	payment	2134	2134	1874	1	1	7665	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJje5RGeNmS9wKuUtiwu2U8db4ezwZPqzQAeQmNGPT5AgZHepk
47046	payment	1397	1397	1678	1	1	17498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaM3ATumwa4QWXGeo7Afu13pekgs7ePCEu9FKdfiy9D94TBiC
47047	payment	2133	2133	1874	1	1	7034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVviFrdGrwhMfpENQq7UHnLfQY2cXhJoafR3FosS9k8iehzUwX
47048	payment	2134	2134	1874	1	1	7667	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbgrsqDhSQwSWLKgotv2rQrLVsKKwBATLEsAmZMDEpYEeu4sv
47059	payment	1397	1397	1678	1	1	17502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoVx5DqGMyYZruFu2oQ97R5m9sYVT5o1tz5xWVmvfR2GmYQ6N
47060	payment	656	656	2411	1	1	2	30000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFVKVdc6Ld63cqRMX7y3MLzVZTmQaYsFmXoXypw3n3cAvoPnD
47061	payment	2133	2133	1874	1	1	7038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoABqSAMztPtLCLNVQA3KFjU5hvtQUmzvtp3LvsAo2FZRrbkSN
47062	payment	2134	2134	1874	1	1	7670	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv92dLLpcv5UQhMGhXqmheQuGpUpmifX4o7dTEZZhutjt7VFJY
47072	payment	656	656	2411	1	1	3	543000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotfwweL84DNCpFK7FCgMf9GdZbMurcJAPK3wqMZHjPQTEhcjP
47073	payment	1397	1397	1678	1	1	17505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9nnV72bNTCz8R9wZixSnCzuPh3zyRNjVPeiyWKZECrpAuRSY
47074	payment	2134	2134	1874	1	1	7673	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMfuegRkAx6fw6Ws7bBLAt4KhkxgFjPXufxfbe41YWSJ3j7Pt
47075	payment	2132	2132	1874	1	1	1831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrBX1K9nEGWjgxcWDxYCnRobePSjcjcEci1CL8D9tCY3vtNYk
47076	payment	2133	2133	1874	1	1	7042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpaCDJLgeYoZK47c22UGFqU6SofS1MB1MpcfdX7LD9apphExH1
47077	payment	1397	1397	1678	1	1	17506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSS8kGuK3TPjwFZwHSaDfGk1FkemjxD3cTzqckaoBebVY8v2V
47078	payment	2134	2134	1874	1	1	7674	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAKMgJYjotMgGbV7E2zKRhThB87LUhKhqvKX4WpprGKdVYke7
47079	payment	2133	2133	1874	1	1	7043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE98ARtbaGAkYV34AEjfMCNV9GUFpvmectqXs9514cWdykx4sJ
47097	payment	1397	1397	1678	1	1	17512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHwyRm1wRuwxMpafY98VPTL1pLkn61XujPfsoyARZhakB62vt
47098	payment	2132	2132	1874	1	1	1833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1SPAjbLV7rXzdbVeKzC5qFMxeoT8bVmEemTT8zd3TSJWGvi8
47099	payment	2133	2133	1874	1	1	7049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHMdEpEW3Uo2Dp5q2gepGB2aQfC5jKw71EHspAtoA7BznbEVT
47100	payment	2134	2134	1874	1	1	7678	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qz3UNbcRXWHeM4vr3kHDtcqXYRbMQrLWXL86HtjCmGCWhBRb
47101	payment	1397	1397	1678	1	1	17513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkcA7wjXuGuzAb2tdTKmtHtCnN1UJgaFQvuGiiEhNPEMwGevZ
47102	payment	1397	1397	1678	1	1	17514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsqqcZs97BCwEoZbboTakyuDco1LbAo451pjvdZnsGaCXSfet
47103	payment	2134	2134	1874	1	1	7679	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7r4TUswuGY52uXHmdQ4rgeTh182GZfqG1CZ5VgUF53pJZcqh
47104	payment	1726	1726	2414	1	1	8355	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZu7Vb72shmQYWexjmNi34taB1FUfjSSEKdZuNc9txiLukF4Pvt
47105	payment	2133	2133	1874	1	1	7050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UGpxbeU2iWW33ijJSS1mv6ZCrunNWro4aMPTgmSgHvnH4Tnp
47106	payment	2133	2133	1874	1	1	7051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGD1P7D6CGQEL3tM1PEGYZdV336Z6attETAF8ijAR5MgH3AmX
47114	payment	1397	1397	1678	1	1	17517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84MPrVC29aVrpdDRJeo83p3pEZph46VoUwKVb7z5MtmzVP1n7
47115	payment	2134	2134	1874	1	1	7682	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTJx7FbhvtzchQTgoPKx77Rz1nWnL71QT4qiMjBmr1SwYnEgc
47116	payment	2133	2133	1874	1	1	7054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmnRmgQrPke4nGGtwZFvDXo99q15eRsDYSuE8pQwCJvfVsYcv
47141	payment	2133	2133	1874	1	1	7064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDo8Xx4RxMKQDLsG3FSybrVRths2fLw85dGHHFDGfamDAsTby
47056	payment	1397	1397	1678	1	1	17501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWgtAAryB68XNvNzyBKuTUu1wMeAKNvN1ApA77mzSMsicbBeK
47057	payment	2133	2133	1874	1	1	7037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8ndc4oAHxet3MtVNbLXodFQY4aDp2YDZ7pBvxUy1XkcX694S
47058	payment	2134	2134	1874	1	1	7669	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiXZAuDjb2WTeqAr1zCxXB8NSiVZXRatLf7erw1g6G9gLAmry
47083	delegation	2411	2411	1546	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQJwamRo8gBGpP2bobuMF1zUDpf1t8xeosLwVqAHXkXwWcdfw
47084	payment	1397	1397	1678	1	1	17508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqud2LxZhauHsiBH2AF8nRrfLWoTxCRn9EUey4gqKpLpWRgHv
47085	payment	2133	2133	1874	1	1	7045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvL7rSF2vmcovKKC5dPPX811Y6oqxcd94fVWaaskmu4bCtMHHp
47086	payment	2134	2134	1874	1	1	7675	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmzxNwZEjr7d8CWQ8yAKF7AUEqQ61mmGbnQMsSMU9Uo6GE9ax
47087	payment	2132	2132	1874	1	1	1832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XA72tWdk17CWZDBpqZ3DHH2FrvmFRf3r9FtCH4muhAEdxasA
47088	payment	1397	1397	1678	1	1	17509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUj8j2U4uVCW5YcqcPFbAzC9XipwoEqXbUD2ChVVFX2oF8tYP
47089	payment	1397	1397	1678	1	1	17510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLz2KmzpEafw9ffrKfDB5sSniXd94DBdtX66UpbNAujo6TJ8Le
47090	payment	2133	2133	1874	1	1	7046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNftfyrMCgqpenBmAW4NSLErJo6GuWGycb9UZ75XsgGUprhRe
47091	payment	2134	2134	1874	1	1	7676	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwVNPdBPFjgDRdK3z5CL7dWpzR5PWa3KVxjSn7yFGHwxTfv19
47092	payment	2134	2134	1874	1	1	7677	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2phtZ4sVyiLka7FvEbYSywpuM1fb7qQnC9iBitx3VVymmw3D
47093	payment	2133	2133	1874	1	1	7047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZps4ZjiPxjkbNriVbGBjUfZjKRWzgchynC3XM3spihprtLELSQ
47094	payment	1133	1133	2413	1	1	0	900972464000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjDFH5C5rjRHr7v7FNHA3QzZ3K2PvwicPt51ZtbC58KnhGLSB
47095	payment	1397	1397	1678	1	1	17511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguy94Ki6oHuL8kw99VqyoHsQzMf3aa9VdSDTAyyTT3Vx4K1b6
47096	payment	2133	2133	1874	1	1	7048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnUrDWDoM86ciMY4hUEenVgWuNL6GcDXzJM47x5S645ZSnZqW
47123	payment	1397	1397	1678	1	1	17520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt48Fnum8Y4W5RATav2XQbRsXNZWRRP6qYc3gSRFW2q8Q8v96M
47124	payment	2134	2134	1874	1	1	7684	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZfnUHsYhyTyUe7ZqrWTHkw2ncNfzjJZtHVwJjQAoq7KQewtX
47125	payment	2133	2133	1874	1	1	7057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsD1S4tYefZyUQRQod7ibKbLNvjQAAFXqXQTicDYf3HSiAw5iX
47126	payment	2134	2134	1874	1	1	7685	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzEw3noe2mU5aZ3BmJTotgzzJsV95rkKeWmpRDxsfoUNy7r5S
47127	payment	1726	1726	2415	1	1	8356	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNwdJ5mQpW4t9cAfHtXZe6D7Xe53HW2XCp4HVmN92BUQTihQqm
47128	payment	2133	2133	1874	1	1	7058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiy1YkU6BSJK1EKroJhP3kALJ17NbBo28i3gKFUBLgb41BtYp
47135	payment	2133	2133	1874	1	1	7061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysP34G8AXc9XEnVwtgHRo1sYVcN79bXHHrR5bRnujRpzpLost
47136	payment	2133	2133	1874	1	1	7062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVjYFANtJ2XRogN9GQ9Du4h3mSJ7hkc2UXLMigrS4h1ppwnSD
47137	payment	2132	2132	1874	1	1	1837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19DPu56JjEKMTeAKvF58ZWgKZLqmf6sLA4hKEhE7vj32GYPYY
47138	payment	2134	2134	1874	1	1	7687	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYGyNtTV6fVkea6XasmzwsWHQ1GYJad7MkWUjpPryNnRWo9uHU
47139	payment	2134	2134	1874	1	1	7688	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHSXTe91uik3BRNxtYZFettcDAJyLw7h5EzLFxLJ4ZasaANaY
47143	payment	2133	2133	1874	1	1	7065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZv39w9JDvyYn3kE5FsvQFp3ByzqWiUo54BBubaxR8yvH29jJA
47144	payment	2132	2132	1874	1	1	1838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmH6zMfJsmq8d2aTSfeXmq6iGkJoTe2HiAaTK7xb9HJBNcRBNi
47145	payment	2134	2134	1874	1	1	7690	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq85qrnGRhUmXMFtByoyYFTG6YNxcQ99g9LYtv8oDrS6egYojL
47158	payment	1397	1397	1678	1	1	17527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCcHx9EmpCBoSm8jWCemBwuiKUFj7rW6Yccue8xsoqBoXuMf6
47159	payment	1726	1726	2416	1	1	8357	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjnNFkVjzBuo8M3XCo7zPSVwEc718U7f1Y3oJ1NVZBXxdFHFsn
47160	payment	2133	2133	1874	1	1	7070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEMuSJq4bPpb8PgM2vDRuTTcWgN8HZmknXYQRXjE575jAAXRZ
47161	payment	2134	2134	1874	1	1	7694	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDUXmsW6CfbxbHSDbHAzPnNTfguuAUwc7KyAc7tUaj8cUAkTQ
47162	payment	1397	1397	1678	1	1	17528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6Wv1xegWCNGQhsNW2Uvs39fCsmTSoEgfFonqopktcPnne3Nn
47163	payment	2133	2133	1874	1	1	7071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LUmsP9VUcL4HnJvkxwZYqva1wFHc5cwFtraV6eiVmrnhwDRZ
47174	payment	1397	1397	1678	1	1	17532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQpFuE5aZniybCvnzB7CugwnNyxTNooQEH7sZFcfvJ1xKP2K9
47063	payment	2411	2411	656	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfF4ogJVHt7eMxpdGKY71pWTMdjgTq7AwkxDZWWknZvk8J2uJa
47064	payment	1397	1397	1678	1	1	17503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Knk6jBr2TZs7Xtt22VsPUvcik3RUpJjq8DZTBQKT6VwED8tQ
47065	payment	2134	2134	1874	1	1	7671	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRHm41CnYxwyMw11mvwc8uFXz8ypBPJHNNaJdsS57AtYQauRq
47066	payment	2133	2133	1874	1	1	7039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNt39TUdhv7QtgbjUnFG2UKdbfrnCQgGRq35mRj6bpCkHqQfe
47067	payment	2132	2132	1874	1	1	1830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGxxXWVyrWLHjXCBfFBq7vf1HYBABxuUbtHhaGH9PVHmQMkFX
47068	payment	2133	2133	1874	1	1	7040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsddQq8Us4YGhwPDQkJXhrLiw44vtmgJr2wkdXtiaDazaiGQ77
47107	payment	1397	1397	1678	1	1	17515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKPZujrfrPUS1aXzPPWtVd6H9JxquJFDE7hhFxVQgPPPTzmKe
47108	payment	2133	2133	1874	1	1	7052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRtmSDoc1EK9ApHYGKGdhuzWkantzesZ341G9cdn2HUn2u43C
47109	payment	2134	2134	1874	1	1	7680	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5iY8PX51Mty1y5sL3pfTeKxBnBexZFaN4XprWAPGRsBNMzk4
47110	payment	2132	2132	1874	1	1	1834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEQdwynRMMPGZxMwmoMG678L5LDy1WZkD3TMqDcU3BxLRqRCX
47111	payment	1397	1397	1678	1	1	17516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5azWLnVywQ8n2XUWNi11dXLc7WWSZzfcydeVSwsdcKFD5Eun
47112	payment	2133	2133	1874	1	1	7053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTboYTCnZUQ8c1o3A8CKWMwXTaWnwFJxTtEFPfbZf8bSfMWRy
47113	payment	2134	2134	1874	1	1	7681	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1tPAiYYyyjSdkz43ZwNh46eU3RnMLdiqPMnA6xtUNx6RjujD
47129	payment	1397	1397	1678	1	1	17521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoU3cneL7h6pborzZcxeftDZQxTYJA7YqdrnaqzL4qJKRd3g5G
47130	payment	2133	2133	1874	1	1	7059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAjktPUHEH1QCTaoCNPYqTNAJFckw1BV5wHkeE89JZAanizrG
47131	payment	2132	2132	1874	1	1	1836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uByNx8C2weJJ9t3eL2eTrDvVTidfnEm1DRTsCc71PEJ2ogsW
47151	payment	1397	1397	1678	1	1	17525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oiduSEoA1p1JWu5nXLG8zksyUg1CDvbEdn2WHrvr2VKNZ5Ra
47152	payment	1397	1397	1678	1	1	17526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qsB5jJnVnyDvwwiHivytCZgtKdLHcxjxu3LKU8VRg3co6HTb
47153	payment	2133	2133	1874	1	1	7068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76C5X2G4bB58udVFukVB1vukoSXtbyxbs8orxsc7D219kr2FP
47154	payment	2133	2133	1874	1	1	7069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoT4myNGrgxkqi3jMAYUkayasG8xozQ4VFVMnukpDbX9bF5vk
47155	payment	2134	2134	1874	1	1	7692	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4LekLHmtRWY987Ri1LcFS5HMJKNNdPdsVLx9XoEJS7oEteGs
47156	payment	2134	2134	1874	1	1	7693	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzV52AuENYcoUpZX4dV9fqqbneV2s7eHeX5ZpEzXcRQdiEWAZv
47157	payment	2132	2132	1874	1	1	1839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFeECczDL2fAn2jUrEEwnM8JKRcQacASdC5RryNm2y4Kh5LkC7
47177	payment	1397	1397	1678	1	1	17533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4sw7P58VMDmoCcy7h7aKNeJWT9mmn29UgMUm2jXboMsBjzMK
47178	payment	2133	2133	1874	1	1	7076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWS4GALAyfiEHypbsx5tRYXRMjmFcuUFua3djsjLM2eZA1mgd7
47179	payment	2134	2134	1874	1	1	7698	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B29deRbuXPpCfur1JXm2LDgLSRimCmwXKX3K2qf1nYiafuMQ
47189	payment	1397	1397	1678	1	1	17537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbsYWLVrC3pPUgu9LCYYEzLY9yYdsqPWKujufnBYFVSYmwY5X
47190	payment	1397	1397	1678	1	1	17538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQe5GtVRwDXYr6MqDLdjRu3Zvhrwkysk3scxDDMV9sBHQXezx
47191	payment	1397	1397	1678	1	1	17539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H7JgoC32zmwKZKYi6Gb4T89zMJMo83UcumBbpL57SQSmcqig
47192	payment	2132	2132	1874	1	1	1843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWvkbMFHgEpbBxv4J4h9DsKie9iWfi8PfTQFnFDFzSYwugtus
47193	payment	2133	2133	1874	1	1	7080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uNRxvZuUnPfsJqwRrJyZdLUbvkKkMuzmqQ3CF38LvwozeJ14
47194	payment	2133	2133	1874	1	1	7081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Sa2mrpKJqDUdGztZh5EXEycysJjAogjV1RxwXp3H8JyjXnYn
47195	payment	2133	2133	1874	1	1	7082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UFU6XXE99QwW1jB9sMiyqzp5kCe6zZTcAjYERtrBoLXztT6K
47196	payment	2134	2134	1874	1	1	7701	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JDxk4GvKG3yBPmfzV261zJge1ZfuAX7hrSEjqBMSVYKynRgo
47197	payment	2134	2134	1874	1	1	7702	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ysdK4GzWfaGxvGT4psR2qofxww4gB8gz3DbXEToxtheWZS7m
47198	payment	2134	2134	1874	1	1	7703	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeDKizCbkxFUA79pfy49e7gzeRhTD8n2VukiBVF8idbJXGgGy
47214	payment	1397	1397	1678	1	1	17545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoTYFnwhp4daTHfVKy3rzDDsBSB6VittnSbc7pWBakUs7Gq6h
47215	payment	2133	2133	1874	1	1	7088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNPEhWpQjKVbUpNpwPp7Zr5wspd3F2ZUPhXJoYb6a6hDpZirn
47082	payment	2133	2133	1874	1	1	7044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9vzPjs27iYXiiZ6Ehz8Kp3Z6KBUyhaKg472vTWnc1VtDPPWt
47117	payment	1397	1397	1678	1	1	17518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydZYf97ii49wfE3r58FfF86KeQZTVzHseyGaBT6P8RqkkDoQk
47118	payment	1397	1397	1678	1	1	17519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3rp9BRLNd8kghxavgbS6QQDtfE8EjWxKPYifVhsZq5y2oB85
47119	payment	2134	2134	1874	1	1	7683	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcahKfgNYhn2rkoHvd7RbMK6ANLu1YSpf2F9FbLrd3A5LPpkk
47120	payment	2132	2132	1874	1	1	1835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn3eqUMXqYEDCbj3AkVQ8cYnE5onraqXRtqwgZiSHZtouRvnw
47121	payment	2133	2133	1874	1	1	7055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP5NU3Fd8vnssYgzMfCLmTCY8WA7ZTiJneqwm9JzsMx2ZHfHX
47122	payment	2133	2133	1874	1	1	7056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2JrUaPdF1LcAhzepyA4vwXgJtwyXgtwUpfz5r9cWuaHV1phu
47132	payment	1397	1397	1678	1	1	17522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRx6VYibv42ZyG7ZoPYeJHaY8L8DwsACwgEhgdqDuY3su53Eq
47133	payment	2133	2133	1874	1	1	7060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYis1JKiBwtLDXZdf7zkkxu3siS44zzzj5DBdaTaJkotFwCVUs7
47134	payment	2134	2134	1874	1	1	7686	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q51STgXqnL9Szso5xQqxqrA3KPVxnLsrKMBHCq8pU2cQHkiv
47140	payment	2133	2133	1874	1	1	7063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsxqkZZdgi8fcUhLysJ7dME5w9qGfnYRv6qbo2hxw6XijUfWU
47146	payment	1397	1397	1678	1	1	17523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yz16yS5v586jVoCkbvc3t96ohrei251FHFnq3DWo9Q5znxFU
47147	payment	1397	1397	1678	1	1	17524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQQzWAe6hwxiK5XrGfteMM1uqCPYDHUZA1SsXwxQUo2Zb2tRX
47148	payment	2134	2134	1874	1	1	7691	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDzMExyZm3Yw89EwWoC4VVwgu4veEK1uGK7Vjs9GrC8HDoQA3
47149	payment	2133	2133	1874	1	1	7066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCjYEwiUZk8yo38viz5KULVEPqWNDc7K8xtvgQghmZYUoXfP8
47150	payment	2133	2133	1874	1	1	7067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mtAJZDxgZkUcHr9vPc3rVwjWsFLFgwF9HKT3hXQse6FAMZnx
47171	payment	1397	1397	1678	1	1	17531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gC2VmYLJ6Hi2GqPXEJt47etTW3cmFtAa4KQD8TBf73zcjzrZ
47172	payment	2134	2134	1874	1	1	7697	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHWW9aceoacgc4223E9dTiXpE7RTnqYWMNFfRfAuNNb8EZyMn
47173	payment	2133	2133	1874	1	1	7074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfz7ds37nAM59pN9UCB1n8dnC1aVWvxJusx2w9UtDZChNgCrw
47205	payment	1397	1397	1678	1	1	17542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MFeDJVLgGj6Pv4Dc26NubW3bhNmioVA13t3jVGDe9enn4EQF
47206	payment	2134	2134	1874	1	1	7705	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnbUkvPHkHBB7jgPQojUDGYMEMFWzeGJ5GwFLSa7jswJpETZh
47207	payment	2133	2133	1874	1	1	7085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoHFEGHKmjL9jgrn7XvD5bXPwUdTStdfh2VZ63F1icUA6r7E4
47208	payment	2132	2132	1874	1	1	1844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFygwHT7hFRpPvzWmswZFdkBYXhnwe7bkKbWMo7g41wEzdXyeW
47217	payment	1397	1397	1678	1	1	17546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWsKZzSe7UTkUQQHyybYsGCyyogQchqjhQkwZ5XTnxUkkKMPx
47218	payment	1397	1397	1678	1	1	17547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhXhXnHKGfiPpo9NQ9b5XU37nHbgJ6TNprKCFgu2vWZimpsyc
47219	payment	2134	2134	1874	1	1	7708	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaZiZrL4Gb2Lw9qrBaAA6GX5LKXX3xDNbsErWBmmordfwgTNB
47220	payment	2132	2132	1874	1	1	1845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Z7LDuKGnWzrEAZbp9sNobHgLPCE7fT57YvsoYE5oekAmokD
47221	payment	2133	2133	1874	1	1	7089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4BjyXEnXehNxLSCSoquuxZXBTmR88ELkKvecEr2YEgxG1cyX
47222	payment	2133	2133	1874	1	1	7090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjnRgyhLJ1zXQvFTBT7CMLvMqd92tPvhfeZncrcqRRQSR3umn
47223	payment	1726	1726	2417	1	1	8358	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHofw5a29w4DGshEEQVA3f7PQ5e5QzX1MsNHwN1YP9VMw1FQof
47231	payment	2134	2134	1874	1	1	7711	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo56qK9916uZVQE4Tnirs3TCHySGmDxaoGr4gzUvPB8YkSFiQ
47239	payment	2132	2132	1874	1	1	1847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwetcZDJME4iMvXHK6QAqsKixFSj2TyQs93BPzLWUvpmC1bun
47246	payment	1397	1397	1678	1	1	17555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyTNcsDWNwv7LGYG5mpY8E3RYznznE8Lnu1pEQzZL1ffwdeVC
47247	payment	1397	1397	1678	1	1	17556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZairNbC6W1Y9e4D6TUfjdpzkK54qcZrBV2GUipk2mFnZXpKr9
47248	payment	2133	2133	1874	1	1	7098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wCDiiT45wNJ42ZH2MFeCp7ytNBgZXX4Rdtnjj5noCpMJwFhC
47249	payment	2133	2133	1874	1	1	7099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZuPF2SzKgSY4fsYGfQfCZfyUZ948T5smwWB7QA6UXKPTV6uE
47250	payment	2132	2132	1874	1	1	1848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJXCKMyxgUp8u45cgv4g57b5ogzmboiEBi9PgfsFemR6tuKqh
47251	payment	2134	2134	1874	1	1	7715	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDShFt3az5qy2pGGDSzWUCfawAuATLNjeraY8tRACR53XVkzdc
47142	payment	2134	2134	1874	1	1	7689	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwHK91zLD7LNbbEUANrhPJ9EMRHdGaGodud8L4GvFgbbKqKLq
47164	payment	1397	1397	1678	1	1	17529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yGFXDbRfn3PwEjh3CuGRQc8guz9SMQHBHCnXAWj3bJzRK2jK
47165	payment	1397	1397	1678	1	1	17530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXVHXbhhssBCnm5SJemchEQ1dEbqEyKK7dvpDNFyx1gJXqZv6
47166	payment	2132	2132	1874	1	1	1840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrXZuodsFoLWoLu1nrjXkNBvHLhofEsaLCZng1rKNxuEmHc3K
47167	payment	2134	2134	1874	1	1	7695	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bwDKS2Jwhfy45DjakJTZya1smfd9fdivBAQQ1Bg6rBSrYRBU
47168	payment	2134	2134	1874	1	1	7696	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc4FRqSw4tauKPJBHFzyr62C6j6cifw27RrXqEyrGNKCgQCvH
47169	payment	2133	2133	1874	1	1	7072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLMoRNvs7j54XqFRHC8MPkTqu6eiUyZAqNYk9ABGCXDPnYX8y
47170	payment	2133	2133	1874	1	1	7073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwXoRUTDK4qLbgay7C65CBEjxYfWKaEYu1ukP6n6ySfDZUWaP
47183	payment	1397	1397	1678	1	1	17535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAo5sKCjsWL3KWtYqjuSBeBRFaBc3GaevMGVHR8uyXwnwbNTL
47184	payment	2133	2133	1874	1	1	7078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj5BTuw2J9aEEiV5KDmcEJRbGmCHLcamAXybKBKTjRcWDy4fM
47185	payment	2134	2134	1874	1	1	7700	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ878EQyX8hG3LocKTqGjTyYwg4jhVKA88ATRz3JDBApM3vtgjb
47186	payment	1397	1397	1678	1	1	17536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxqSwuokeoxv3b59WQFq4wtMJxMZPgEzLVGp74MeDc62bMVD7
47187	payment	2133	2133	1874	1	1	7079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRkX18jDbcvQYuYAybYwZ5ZMsDtA9ZLT9GwepcWRrMsKbxTnH
47188	payment	2132	2132	1874	1	1	1842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NTJgZUeRW7NxgerqGm8Ux3cYWDaGXQRuzGWEp5DTT5QNSzsN
47211	payment	1397	1397	1678	1	1	17544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEydWmtFta7MfCUanNiWTtvnx293YuxBAJv3hQX8X51xRUuoWX
47212	payment	2133	2133	1874	1	1	7087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNS8FMu86FPChMALKNp1Ty4jgEsGHqzfYkWv8BQwtqxa83xQy8
47213	payment	2134	2134	1874	1	1	7706	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKrVwQebavqKwUtc23UdPX5knnKbT4J2RhB2STDVprJQeLtMX
47224	payment	1397	1397	1678	1	1	17548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMbutw3ikE1v4P5Vz99RLYWYHisaapW8ogxWBW529XRmaRevz
47225	payment	2134	2134	1874	1	1	7709	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVkTstQHbju5ckS4VkTochsjwGuDcKGGxn89WmETNKL5QR2xu
47226	payment	2133	2133	1874	1	1	7091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXRT1QsBD5ZYiNDDetBbkcDY3MNhN8hf28esbsZr1mWZuzABx
47232	payment	1397	1397	1678	1	1	17550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkizYDzBSrrT4LidPXBxHQGBocew4De5iiMZUrMfDx51zt4cQG
47233	payment	1397	1397	1678	1	1	17551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkPQZKWgKUt7VyRHrqWpr7TNMx2HTJDN83Ux8o9g57XmBQvfK
47234	payment	2133	2133	1874	1	1	7093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqv8P1LnZVqMgLtDSwUSwAQHotG48gfoF2N4nwSL5is5NtgkA
47235	payment	2133	2133	1874	1	1	7094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfPsM5yD13yTQDsqpM7J4AnUtRmZptgfQmvUmkZYRtVBU4eMu
47255	payment	1397	1397	1678	1	1	17558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSV1WNpegMbtsBoncn7uzUcCC3YZaagjw1KJhsHjGr5YSAvQA
47256	payment	2133	2133	1874	1	1	7101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9htcog5TtgUcNsS4EHh4Xj1FriBudV7sDttH47yeNYAbhvJB
47257	payment	2134	2134	1874	1	1	7717	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNU7o7HTzR7SkttbhPqdWSqcL272ycnN5TosdjWNSDyt5yS8K
47267	payment	2134	2134	1874	1	1	7719	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK45ufmfDBPNhgWFuwig83HqRNRPbUghNBHVoLZXoXcp2fLy24
47268	payment	2133	2133	1874	1	1	7104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFgaxxGXf5X6p2YJ9txVVNqoNXng89ztVc9axiCUwa2E9DBQE
47269	payment	1397	1397	1678	1	1	17562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVRjqwa4cijKZjRFeu7H3sxYeDZb97EHLGFSah3bff1xfNL1R
47270	payment	2133	2133	1874	1	1	7105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTRPTW5KxQfmAaoCE3MXySxHoc2aqxkjr8bSyT9afoQzdJHo5
47271	payment	2132	2132	1874	1	1	1850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYCyoqVZZ5oFHUuGYwzyVBMrVcuEpSerKD1ppBzuhAYDi3zpK
47278	payment	1397	1397	1678	1	1	17565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvFDekbpqBBsTZSezXHir9KtWzDMq1ueUsj4FceArhZZJs6bu
47279	payment	2133	2133	1874	1	1	7108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPd69DBCwvfXpo5Wbm6YCbmVArCeKRokEhFLtZGa7Cqjf4GAV
47280	payment	2134	2134	1874	1	1	7722	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk6ossDhnLGA7ynbW5BFhKiMaPHWp4wp1rDmzTyoBfGntoZw9
47303	payment	1397	1397	1678	1	1	17573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGHPfXqtfVqhawaG8AqQxTs7FtyQjwJsM3JuHQfLN2cw5LEZ8
47304	payment	2133	2133	1874	1	1	7116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzofj2QtehEt4Km5fFi1KwAYTqPGnTw7vHo6aAbRyZ56hhB9eo
47305	payment	2134	2134	1874	1	1	7728	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZnPSN3XCj3kf4xwvMY9jmuqGpnorMi6zjc8mf9PcEJsb51j3
47175	payment	2133	2133	1874	1	1	7075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCkWF1Z6vC8qQTgGFe5aV6zXTmaZi6HVQ76hJCYmca5uLAfro
47176	payment	2132	2132	1874	1	1	1841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKRzaLH3hdeGjS73hgbDtzkcJew3aKQ4mfeoW8MeC1jgqx5XH
47180	payment	1397	1397	1678	1	1	17534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoYmDAfVCgtwPQfJznKV9QKkpwxcxHMSfNqFsyLyibL9dsTDH
47181	payment	2134	2134	1874	1	1	7699	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4opDmodEiFT9WWrHP97jWZUGeVnmHrdB7asbsygYGeXtrMsg
47182	payment	2133	2133	1874	1	1	7077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFVgTK7J9EK5ybQJWAQMHsMJKuefpHDp8u4Z429HcJU7QMNSx
47199	payment	1397	1397	1678	1	1	17540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7zow9nNfbSsRLfSPhZX8ct4sZ3y9yNGioXbDqpPEkrH2FKEY
47200	payment	2133	2133	1874	1	1	7083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwHX5sod3dXXtWQMfzya28mmSFoSmSetH8NoPoG8gfo5pPAvc
47201	payment	1397	1397	1678	1	1	17541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7nd1deCUm9fPvtLXR4uWGZ4nt3msecm4fsHGtopJk71ii51E
47202	delegation	2416	2416	1600	1	1	0	\N	4857140	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjgDcT71pBjXprhfHzg198aUmpSBPQd7WFYRzPHjAkMaAYNbH
47203	payment	2134	2134	1874	1	1	7704	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjnxB9Cf3FLxx3dxZUszprkXj26HsDba8EAajdtfYxpwRrq5N
47204	payment	2133	2133	1874	1	1	7084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9tRxL33R1CMLdw6gbjb7VRHRBTiJKVQYAYrSRFBjGfo9HTS6
47209	payment	1397	1397	1678	1	1	17543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KdZ4ufWBX1y49xaakLybVXq7BSrk2wM8mayZnJdGnnfonzp7
47210	payment	2133	2133	1874	1	1	7086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1P81RzNeB4U96QciFS4oKd3ktYCMRSNuecpEnHTq2TDZNJmbB
47227	payment	1397	1397	1678	1	1	17549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDQGj9yYTtMnkSzxKWLaTrE8hU7XsbkxncKNn5hVYPZAqfGLe
47228	payment	2134	2134	1874	1	1	7710	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9pk3DhFPSZrraoiuaqMPRQekqdYQqc9h54ELn6xuQHeiL96E
47229	payment	2132	2132	1874	1	1	1846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALWyzL8wSxGVh2xBRHJDJYWvKHkzDgp58eNJwJaWnbsBKKKvs
47230	payment	2133	2133	1874	1	1	7092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxTK6529YDeS56e4a1b3yS6GHT3gYqBpV3JzdSHP7YY7iCWWG
47272	payment	1397	1397	1678	1	1	17563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddsEbWPUpduxKhX7gXM6aJkkhhff1n62Lx1aMW8YhB67qYnRS
47273	payment	2133	2133	1874	1	1	7106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfDaKWQhtMGUHk39Q5gnguasknQfz5qfpVQi7GFncBS4UXUbw
47274	payment	2134	2134	1874	1	1	7720	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtcoq7grrznGieWoJam9dmzpNM6RNqYahBFgtiQp436yqAYUg
47275	payment	1397	1397	1678	1	1	17564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnb6ZuWRVFp9vTsBUGYjrHyJ8sgMJH9GKbNasgYcqP4Fnt1qR
47276	payment	2134	2134	1874	1	1	7721	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUZfwQN7k3keeE3Pnb5WJFLZbxrUSvRxajoiCvZ4pFTRqq5wL
47277	payment	2133	2133	1874	1	1	7107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWZcLu9UNegXPcPpdybT7kPqZr2GvG1WJjHq1hmB9cN9PVi16
47281	payment	1397	1397	1678	1	1	17566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9asYyT6A1SXDu4PjasSWQzYWYC4GYkZthEFaeTLFb99sbXmL
47282	payment	2132	2132	1874	1	1	1851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrggbH1DcyDvSsV2yes5Ky91YXXWdTjof57aZ7GDNHPtJE6iTG
47283	payment	2133	2133	1874	1	1	7109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJEU2CDiZxcPsS4gGBAT8do3c6Pge2rpgvVQfm4A64z3FyADf
47284	payment	1397	1397	1678	1	1	17567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvSmxMMk5qyPvy7jbhkGY7YkUi7fy7XPibuR1nMGXCiQjzwh5
47285	payment	1397	1397	1678	1	1	17568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5bfqjUNJpSag5f4Y4NqB5HGBTAbnfYSjTsYRHVCsuFXZ4AZB
47286	payment	2133	2133	1874	1	1	7110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgiu4f3evzgxkXvVPkJstPuzgUPB1S8NS9jyEoxnsVQMs5DMR
47287	payment	2134	2134	1874	1	1	7723	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5Tusukhb3hB6m9ENGbG3SWFyyvyaV5VnCyM2cj6zsHCsWcwL
47288	payment	2133	2133	1874	1	1	7111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqx5Es1ojiFmpA5kc5bvpR5Notr82rt27SEun6HUv44GRC6tEL
47289	payment	2134	2134	1874	1	1	7724	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEmxWThvZtQJoD4TgpAiTPNfQZuKa39LjWoZG7n27Nnygm6U3
47294	payment	1397	1397	1678	1	1	17570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBY9se2kHHwnsXsMxXKWJosMJLxuAGKunFHXPvBdQTa7dhJg2P
47295	payment	2133	2133	1874	1	1	7113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGVdQKSsmQ5vrPZvxYSdye8fk2cbQtY7VrCPDtUJMBt1j3dcW
47315	payment	1397	1397	1678	1	1	17577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLmCfcu2cuUDcTjaDp7QCcd5DgmVzSKgLABDywJHgW8TMHZkQ
47316	payment	2134	2134	1874	1	1	7731	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4u85yoYLWAEvbTNf9LzTcnWfDvn49BCQR7kxYJrkEqJUM7gt
47317	payment	2133	2133	1874	1	1	7120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvfCSbqiRFtvUFnmJfU1U4FCRuLMjiviUuLeS1gx6PGLASec9
47327	delegation	296	296	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vhtKTFhLKXEdamFdv1NmNNo4bWMim2tDHH74zQNMQvHUyw65
47216	payment	2134	2134	1874	1	1	7707	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq91GFwBHstvNfziNPC4yLYwEqadBa4cKhdCCW3nEyWQS3pUmw
47236	payment	1397	1397	1678	1	1	17552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkHrMiZGzkPqFuppLjKkGJGLLZPxd6FQ9GPA6eCyFD6eMMPMP
47237	payment	2133	2133	1874	1	1	7095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6TJVDX73cBChygbxusrwjkxpRXS1LZSr42GmML48Y9Q8dtTi
47238	payment	2134	2134	1874	1	1	7712	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2QTmtoKnbkVRTQa1JS6XNGn8y45UE3NntvFGukvDq7Vnt7NE
47240	payment	1397	1397	1678	1	1	17553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKso4QV6C9rw5dW3UbpVJPksMfDa4emnWG1TBwQDDCLDR6YFm9
47241	payment	2133	2133	1874	1	1	7096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbyZ2Q4m57gHQZWg3H8qBbQLvjCkgyr7KxkeKfaRGrG1FXUCm
47242	payment	2134	2134	1874	1	1	7713	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLbnvNhskBBNadqXWPgWnHDZdvG7Pq8WZqcYS3M7USHTrxMiu
47243	payment	1397	1397	1678	1	1	17554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgWyX35jXhv1e33DQrV8H8GqUzit7Lrq4hZUjJxNbieFd5EVu
47244	payment	2134	2134	1874	1	1	7714	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQ4S5XuXzpppYU1j6Dqv2knRCNcTA9aNbVdqBLdb3k46gG433
47245	payment	2133	2133	1874	1	1	7097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprEhw62CLTKLbvDPHKiNqpTVKoJu6Unh5Scrojx95XZE9NSZz
47252	payment	1397	1397	1678	1	1	17557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9ZBazVueXfw2NsWjz1rvzedWQFoDGbT2QLBZyELi7M93yw5W
47253	payment	2134	2134	1874	1	1	7716	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxzSWWoJQ2HDWNwqcQAfGLYDfk9SMuhdnyfKjf3hYfYY2W8hZ
47254	payment	2133	2133	1874	1	1	7100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1wB5Prh6Ls66KCSSzh7QvhZbxQYpvTr7wWGaoE9rMWcFeZLz
47290	payment	1397	1397	1678	1	1	17569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTiU4kbeKhfXVRRGdGTKqFPiaxkoQ1omoZtUhWFiYRfgtatyA
47291	payment	2134	2134	1874	1	1	7725	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguUN2owTpUDbKC5qkJfUXdTmssj5uTp9xSDX1XbJ5mJTqwSxJ
47292	payment	2132	2132	1874	1	1	1852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGviWqxwTGScVri1jSj3XU6vfVp9iTy9pJTt1L1GFbJHxipjK4
47293	payment	2133	2133	1874	1	1	7112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJz9TRJPfLxoxnav8oeUnuWSLSUMEzVpsBN8yfVXPNCaHDCHo4
47318	payment	1397	1397	1678	1	1	17578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1a2bhSzrUHnPuK89N1nHVHRuje2CPwWdj8eRgHwuimivwE2nv
47319	payment	1397	1397	1678	1	1	17579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8dDbTwYdUtiZZEfhgTfNkohBgFeccUnSRjLKMPanGqi2KEqi
47320	payment	2132	2132	1874	1	1	1855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJS4uzmoJ7ZYJuXXZndDigC48REv45XGG6jm3Tpq5u6zKqoA1
47321	payment	2134	2134	1874	1	1	7732	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifxNuNczQhXmV1vbzh68haqJ5obCZB3aY9sbxnF17LxRKyATu
47322	payment	2133	2133	1874	1	1	7121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDfaejhjz2BjANwpaVEPb9WeXwyWWNWidXA7drL2V1MDv3tXr
47323	payment	2133	2133	1874	1	1	7122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEK167D26J71VqBfnE9T4TTiaZkANtn2AMg5xskzv6xFiB7wc
47324	payment	1397	1397	1678	1	1	17580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxWjaW93dUxBog3PDiGu7haDqM1ALch2JURQ5dPYNag3ox8th
47325	payment	2134	2134	1874	1	1	7733	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibJE49sMx7oaUqJxG4x9CAybsg4VS3KUdyH5ehpbku8p613Mf
47326	payment	2133	2133	1874	1	1	7123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ijAY1jJ3TcF1tRqVkPjKMHBf924M39UMYcR5FAhUrQq8wHHq
47340	payment	1397	1397	1678	1	1	17585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXRqGPB9YuSAe3UizvcEjTjCJiYM2FoCGTLTw2azkgortLWKy
47341	payment	2133	2133	1874	1	1	7128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VBWFU9e71xNAf7vGtXzytKRbvSpnbgxqaV3tXf6PxJnzXqxa
47342	payment	1397	1397	1678	1	1	17586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bmg55nRVkn8NgCQpXKQRLe2npfXq814sByAenhUguegMdX6G
47343	payment	2133	2133	1874	1	1	7129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWUw93t4WLqVgvByyqxXNRQVvRL7fhsh5UjsEP6sKxAy6ArQc
47344	payment	2134	2134	1874	1	1	7737	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAN6U75iAcwxxJz86yQTEE5GqwoHDEXcNpA4VSZVuLazCN2gS
47345	payment	2132	2132	1874	1	1	1857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx34vFHEZFHyRffsGtco5Hhhdi27ktpSeFbReUF7QUvZvozLfs
47358	payment	1397	1397	1678	1	1	17591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLzP8XhmEVg4Pv6B1iwEr6uEuBiYjM3JJJrKcbkGN3jskymgs
47359	payment	1397	1397	1678	1	1	17592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dRtZLjfYAoyKVjTNANaNeSiYXR7dYqNWfZ6REt5QxdkMDPyp
47360	payment	2133	2133	1874	1	1	7133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpruzqJhN8ELbDu4sg2Sb82yrMHD6aD7ewLimhvYRJL2auGXZ
47361	payment	2134	2134	1874	1	1	7741	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEPN34MPhZCnFsvVhwMyUHkvUvwhZmow27SpC8YVd3YkdYT8H
47362	payment	2132	2132	1874	1	1	1859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwpo4bAEPcDkxkSeNkCL1Mo1y4HBqTVuDSPGuj5TiXzU4x4q7
47363	payment	2133	2133	1874	1	1	7134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTXbm38DVLUaedFo3YFZYgmh6b5JM4vYsHu2J7QP1aE216qSp
47258	delegation	2381	2381	2381	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL5J48SK3AWq8X5HS62G3FagLMLqq9GMQgHeDVjHJj31ZeCyV
47259	payment	1397	1397	1678	1	1	17559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cZ3JbBAmgExMapLjf3Ja6Eg6NHPDQUbsM1WWSN822n4UZqA9
47260	payment	1397	1397	1678	1	1	17560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ygiNWULLMBHjz9gzq4xM6ZWy27mgkzGmpaWUEdo2oQF34t2m
47261	payment	1963	1963	296	1	1	1	2000000000	4000000	\N	E4Yu1eXC1XmF5hDf5d66pyq6YKeTzCkSL3Zam8ZXwnkio2CwLP8rS	CkpYkABco5Fm6EJu4qcAFgNSkXPJ3QkhPYGaPuBAqeKqvNUPmU5ag
47262	payment	2132	2132	1874	1	1	1849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZwyichTggPn3SoU6gGXzdBHsCWi86ZJNwJLZqg4a57hhPzFX
47263	payment	2133	2133	1874	1	1	7102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSg9FzmrVZzLUTwPsFoicYNVo7UhDRc8J6AowteKtch8Fogsr
47264	payment	2133	2133	1874	1	1	7103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx22nhXrhXfxNLU99aQNntjJSEevAeJBM7rjRTC4Lfnb2a5Uef
47265	payment	2134	2134	1874	1	1	7718	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygXx9zX9Xp8rqJecw5JgMyUZKdUfh9S7g2oPQPEfACHiZHE6Y
47266	payment	1397	1397	1678	1	1	17561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEPHjRsQD9eiiCtKtjMFD3FPG5sxcAzb2acQoJXhUYCtb9PxJ
47296	payment	1397	1397	1678	1	1	17571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWxHMyWf7YwJUc5JZuU7zCsaXWazxDx6aubBYiikPQ56rg6f2
47297	payment	1397	1397	1678	1	1	17572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF2UVYsbpFjBVPfetGurt9ruLTDPvnXtxvfwWzYRH7BphxqnX
47298	payment	2133	2133	1874	1	1	7114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfbTexz7HFTmCSRECVxyJhg4rRJ2ER83o9gBHehmi1ZzC2Jff
47299	payment	2134	2134	1874	1	1	7726	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeZHDkfQMX1B1CVQsMKWqzZ9iKwHJ2q9webQhLQNBFVxwxQow
47300	payment	2133	2133	1874	1	1	7115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT9cqgzHjgDftXRk79p8WVSSkpbuuga8AkUL7QbygQJwNd1jQ
47301	payment	2134	2134	1874	1	1	7727	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2jzXDpFEX39R6P6Y1MttuXrpoe85M9RCMrRJrPdYSdidzBhr
47302	payment	2132	2132	1874	1	1	1853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WtZMW2esmMHmZkXfwk6g4HbJTJXQY8bN4BMWGNT5s5cWTWJP
47306	payment	1397	1397	1678	1	1	17574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrhDcPSo2VXk9uDB4Q4zYG5UyiFR4qyLfjoFN48279skxzYTb
47307	payment	1397	1397	1678	1	1	17575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLb5s1Nkcg4SYu7uYLhEXmMcDhLEAx1s1BffRvesLK3CxrdNfz
47308	payment	2134	2134	1874	1	1	7729	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWmTGyVmTXcyGbk2LJeZuCtm5qsqPkWTTUzMdxtU3jetDYyWP
47309	payment	2133	2133	1874	1	1	7117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqy2dmZZHyaGLEfDCyvQ8VR383YXKBiqxgdsNAaSm541P4ZMi
47310	payment	2133	2133	1874	1	1	7118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxskV8FcxstbYpdRFqWMLsU8xdigMNLRBxLHLzJ4RAgBDfEE6L
47311	payment	1397	1397	1678	1	1	17576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhyEH2mV7mZiYb1nc4YFhVNv5seB83U8Jx8SDYkrw8677ckYp
47312	payment	2132	2132	1874	1	1	1854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LH4Rd6WT6WRfGRgKvsENYc9x6EuzUxsSbrXr5eup64h8VCa1
47313	payment	2133	2133	1874	1	1	7119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dp54ugE64rH67kC5dytMWx5Ez2Li6J8SACMSZcBTrHFdjpU7
47314	payment	2134	2134	1874	1	1	7730	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1H7q9cTzon9hQcfU9yCs36grNuiLUwuDNkkmmkKztz7fV2Ns
47334	payment	1397	1397	1678	1	1	17583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYig4WEzmV8XEhFPDruuFvHK2uqnRrK72Wruko4XXCMhaFHkoSZ
47335	payment	2133	2133	1874	1	1	7126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhybUirrTA7uw6ZFetFF15cWNwzumWMz7apcEH4W2yacnvCeAm
47336	payment	2134	2134	1874	1	1	7735	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusPM4DEncmoS2kWEFBKQhda27uy62dV8Yx7F7sn1d2BHWKtmi
47351	delegation	693	693	1726	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgo8YbmBVPRokhZVQE2gaDMA21c5QA2x25JRyUUseLmTx6YsM
47352	payment	1397	1397	1678	1	1	17589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJVpuTcHwTji7CsUAPvFRmZAKwpnxUW2KaXae9Dv4Gd58qfMB
47353	payment	1397	1397	1678	1	1	17590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wfi5ja5G2cq7o487rZYKQCZA2SHdthrcWVqBBfgFhCmuqZW4
47354	payment	2134	2134	1874	1	1	7739	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDjQb2prWvhXJwvprVwcraWcTDiEWofNGswybDhvY1krDzLSo
47355	payment	2134	2134	1874	1	1	7740	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqhL22U3kWNqWEwMS9pHof4HhGCLF2YQmyhjenzcsTBvmn8jX
47356	payment	2133	2133	1874	1	1	7132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZD9VrMtoxkJCtekVeBW9RNFRXunU8kjXn2SoaWDEd3Qv8uSZw
47357	payment	2132	2132	1874	1	1	1858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFDTWSW2giGTdi7xvMkQFbm21bjDtan1vtcY8qoZC46s5aeSFF
47364	payment	1397	1397	1678	1	1	17593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEZfHjTRkbGNMLYonkHeuCKWt8uTKWjAbstNfL8ChWbCqKiex
47365	payment	2134	2134	1874	1	1	7742	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWKoMa47PxyFyMMXqXQmGjGrCv5vyXNjsHRvcFTEzDZTNMUi3
47366	payment	2133	2133	1874	1	1	7135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBuAgNc623xEyYtN9oaNht9dMY88fcNXeoZS5gm1LCvEhdGUF
47328	payment	1397	1397	1678	1	1	17581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pm6ZczETiCtjELBmNLir9paaxfHwQSRvSR5WieH9oHyPUT5k
47329	payment	1397	1397	1678	1	1	17582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b5FnbJJ7jz3q43gchqqj3BwiYmdgzic95HL3kUxyva3r8gBR
47330	payment	2133	2133	1874	1	1	7124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiw9Yj5o71LDKEBcWcumq9jqjzTLhcH9zEqFbdCHqEGr4gL8rz
47331	payment	2132	2132	1874	1	1	1856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78p4EA6ruFJAhTtinNeGKSSamCtt6BDC55k3fb1KfGjGa1X33
47332	payment	2133	2133	1874	1	1	7125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqeaoHYELofNnLc2vfiCrnRATP8TiS1ir8KU6ubmC5Zam9sb2
47333	payment	2134	2134	1874	1	1	7734	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3C3p6shEQCC8rcMLBiBgFK7bECGA84sKQruFcQgcCE4YsVodY
47337	payment	1397	1397	1678	1	1	17584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTn6jnKULvXR9DbKRvcxY4HBvRDVHnZ4wDxobCCepyoyi3MaM5
47338	payment	2133	2133	1874	1	1	7127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNXRLM4qKX2R5ztLTB9V7fVLMFNaHXYMCKqEfD9sfEbUFH5KB
47339	payment	2134	2134	1874	1	1	7736	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3wZ1TZXDTs4YE1zUSnzdbN4kucUeDNgm5hGkdyJ4JFJiz1RE
47383	payment	1397	1397	1678	1	1	17599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshzoUwpkekFuNoHYGzZrGqSUci5U1EqBHrTFj8XfY4tAzwD6V
47384	payment	1397	1397	1678	1	1	17600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTB5WA83NiBme7JRmRKj8t8gKJGS3jLxJa9kiCHbZ7Nr5Tqvmd
47385	payment	2133	2133	1874	1	1	7141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NSNChMau6BmvsQZXdRzjX8smKFBVMgYg4o48k3gXBaNACsM4
47386	payment	2133	2133	1874	1	1	7142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHRtNnUcTffMmgvNpQrYnKW6eke9M2kGVvSqPi5NvnFnDW7Bd
47387	payment	2134	2134	1874	1	1	7747	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FaUBAX4QgNcGNgii6Fr8b88euAsW53UEa3Pd8jmPygGfygNT
47388	payment	2132	2132	1874	1	1	1861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1j64stL48b4qxfS7CxjWiNRTet4TGqgzpWaAUsuA8TibbnWga
47413	payment	1397	1397	1678	1	1	17609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbps3aQ9NDhbFWYUy3nR5ujoGeTSjRTG7iNSwGmup7UEEfPhpa
47414	payment	1397	1397	1678	1	1	17610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTGhZ3xLGyK6f5ENhsXqxRxK3YvQBBxsHNuU3SfW8KHdzswe6
47415	payment	1397	1397	1678	1	1	17611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8Z5pRGLXdvxtrpH5KFSLdxWZgQiLKPQYet4xPtyB5AaTU4YN
47416	payment	2132	2132	1874	1	1	1864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6Zg5Qs9M6mjhJW1YrguZvfTdwCxJbfqWr3Ho2vEUD6g8BszF
47417	payment	2134	2134	1874	1	1	7754	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvsJZVKSaxvDh7huJBQE9usKvBkK31Z14JLRUpAhNunhJpoyr
47418	payment	2133	2133	1874	1	1	7151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywdeUXt82o5g6SPeyEqc3Bi6mvY2p777DAX8b24q9nD1HUnQY
47419	payment	2133	2133	1874	1	1	7152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8knotrwSjVtWJC3jN1aSiDag5CUj7kvHWn7ARVev2sQjj3hG
47420	payment	2133	2133	1874	1	1	7153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWw5p8UY1xDoU5T459oAXprqvFpCM5HK9L99UnXQJEdrtpYjF
47421	payment	2134	2134	1874	1	1	7755	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2e1JNJHPAYhfQCzjeeeVyNSBfHAcZL66xaJPbTczVEYVgoPid
47422	payment	1397	1397	1678	1	1	17612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45HdFh46hRTqYmTaULaw7NTzv4NDeeGg5s35BHwKe5K3waXnN
47423	payment	2134	2134	1874	1	1	7756	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdYr5kGnb9sXNmBmoo7VVchw38ZZpREfFSjzBZ9cCdij3mnw1
47424	payment	2132	2132	1874	1	1	1865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6JfjyUi22Bv4EoVixbHdtK6VAAJ9uNZ51pSyyNQAGKWXNyro
47425	payment	2133	2133	1874	1	1	7154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5TUtPsGoBAGs3a3odPEwP471w6tAcbWkRNWN6mUAfcdazBPp
47440	payment	1397	1397	1678	1	1	17618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZZLbHQzf37ZZEZcGWMusEXTBoRqQ9TsvdV5QKnmhumNSkYK4
47441	payment	2133	2133	1874	1	1	7160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnLKo8DbCqJFn24iudYqwoEhMQNzQ4eMuqLewNgUt7UdcuhrjB
47442	payment	2134	2134	1874	1	1	7760	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5w49GLPq7wDYovx42WoQ2SmcC2KpUP1r6DGrs9cWHsDjq7gFS
47452	payment	1397	1397	1678	1	1	17622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQ4LygYhLtywMz8uMHJPmqqHsirziYx1ojmZgRBydmcWLcQLf
47453	payment	2133	2133	1874	1	1	7164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGewk3okQHFPzJaKJdxPiJ6NGmjvt8M2c19vTFuo6k5f2qZap
47454	payment	2132	2132	1874	1	1	1868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gsE1EedvEHPUzwkvreANUcjbMG8MLFfQMsqZAccrd9Bo2won
47455	payment	2134	2134	1874	1	1	7763	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArR4BRP8dCjbN54z2JvqePmEPMdvbGo63j9AGxnVDyNxHcNmc
47487	payment	1397	1397	1678	1	1	17633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLkBPxs9kfc5tsrsSrcLjLQDFNqQd7SWjrHn284urwwdfJjdU
47488	payment	2133	2133	1874	1	1	7175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa22cDxJCeDzyPViMXuu1V6ZPLwThZSiwGYKh9w8dWYxiABM21
47489	payment	2134	2134	1874	1	1	7771	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2i5pB3tQGJsaiCGr6ZQyZU59UnLHt4F3TVj2T1HsF8t4QVu1Q
47346	payment	1397	1397	1678	1	1	17587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6ehoSdntiMiLujDABrkmxMchJ6raSWpA1hJGRRkBeNgfogFm
47347	payment	1397	1397	1678	1	1	17588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYiCWq6LLKBFyHY3n7XiDGC5DYU9rXzENEfJuDXSSUYaFCK1o
47348	payment	2133	2133	1874	1	1	7130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXKozkGcf8taht21zSdC7cAC24k551RWo6wAqibQ2mmWnCta1
47349	payment	2134	2134	1874	1	1	7738	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Ba1WirZzPf6rpu1vVgEACpsReMbS9b5bZSMt9TknMaLxgpV
47350	payment	2133	2133	1874	1	1	7131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4fk6L8gc4Hop8eGHxg3p5ESGNWHvthJwWf5DcSGZ9DVRBWVD
47373	payment	1397	1397	1678	1	1	17596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhG9rC4GFtX5m3U9hja7kCvLLxeFEdEipjJfdxfmahTVG7izBa
47374	payment	2134	2134	1874	1	1	7744	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqTgrvp1JXm3hAjMjZ5x1kXQzCKDSuywEDzT1LC6zJ8fqPt5y
47375	payment	2132	2132	1874	1	1	1860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCCkqnNS5ZHUYo377LyjoHxMbT3ycmbZswLb1aToV8bMXVDpP
47376	payment	2133	2133	1874	1	1	7138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QZKCM3yHUnaKNdmsV3qk5hwPxbfNDWy4w4u4R2JxzZFx3ApW
47389	payment	1397	1397	1678	1	1	17601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo3fA6FaqpccpD16TPkCdcFPo69FNXNtpYjErnzm72nkQ6HQD
47390	payment	2133	2133	1874	1	1	7143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS2gnB2xdGWKgMap6n5347hyq7qVXPEfDGWJ2PXANiMdtJJud
47391	payment	2134	2134	1874	1	1	7748	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cZ7NDcBcTyaZP2Rbf3pM6APL8ETd9xJknTSXNyAtARx1e1kK
47401	payment	1397	1397	1678	1	1	17605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyU8Vf8KbBcDPMMN91jm5qkGwkNjaCmM5t7XLUBnjyQe1JP6JW
47402	payment	2133	2133	1874	1	1	7147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1S1BNf4wAj6AWw5YjBJpqSjAoasT1eigbAqnVykJSWGgtjKYx
47403	payment	2134	2134	1874	1	1	7751	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1qHgpFZrHgobYkmH5VvPNALM3Yk8U1E7YFRogqExQDHLQSsC
47428	payment	1397	1397	1678	1	1	17614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnoN8maYHB7imsecnpuh91gNe1JF2MCPjDWFeaF1EfzSXVhni
47429	payment	2134	2134	1874	1	1	7757	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK5oxL2SmHhonj8CzYA4vrvCQfawmbG3hdU5s4JWiGg6uubLL
47430	payment	2133	2133	1874	1	1	7156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1ymZkgZcpM4yYVQV1r62zt6i6DFLWYM8E1ZeqgMP4MqQGyQm
47443	payment	1397	1397	1678	1	1	17619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2rasfbF4VTKbQzpRb2sPApAyD1Dm8xFvYLFjZifSkvCmKiD8
47444	payment	2132	2132	1874	1	1	1867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5ieWFyQdNz9vK4BJ272pkYGhUqy9uWNda2xAHMNAZGhFUBto
47445	payment	2133	2133	1874	1	1	7161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LzJuSrkBBsimZTiGXPjA5ELi9G8oesZcvYSFLnzdgHMQuFRv
47446	payment	2134	2134	1874	1	1	7761	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoVazCsdEXWWTQULZFyAXEaYAuVYkdZhFroW1LaH8i71Sgh5L
47447	payment	1397	1397	1678	1	1	17620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujAxiwqJUSc1eJ6Mrw6HPdfzb7nW7iM3QMvcXAqTm1PcmDUTY
47448	payment	2133	2133	1874	1	1	7162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbjqF2qeX5bntThwJS3z8UHCTNkX4ykuPCWbeMQcwkTKtSp4Z
47469	payment	1397	1397	1678	1	1	17627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJQXHNmTt6FugEwxZmuoY5xfF6CVmgvoJ6NdhGpi2DU55MGXU
47470	payment	2133	2133	1874	1	1	7169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2xwBT8e4JVAEjuRYETig5J2VpNTH5RuPMjPLeyJ1ZRproeSF
47483	payment	1397	1397	1678	1	1	17632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQ8FgQ5EfeQ4KWqVteLWkPFWKvmmC5hRUziCcrULDHMTmPNcX
47484	payment	2133	2133	1874	1	1	7174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSxT8DJVZr2tzFWBYPBE8bt8hNSxoFPxy8SVv7hhHch5MsjSx
47485	payment	2132	2132	1874	1	1	1871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodctr8darjdnpFoKyCGToSDZVbwb5YSdffeiGiLzuVBhRcg5K
47486	payment	2134	2134	1874	1	1	7770	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf1NGUXf4t6hoQntuMbLB3uqLNdhYFv5xHme8y5xnLA57b9xg
47495	payment	1397	1397	1678	1	1	17636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZicLPtGx34XeeH9RwuRpVfh3LEdKp3FRds2Smpz7cWvyjKXw
47496	payment	2134	2134	1874	1	1	7773	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjZmXUYbrRwK1CTHJ3hgR9BdqKkAfyc6QPtkM6T3dh6AXotjm
47497	payment	2133	2133	1874	1	1	7178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrahYqA5PcEpzx41KVmY53EKo4rz24Hvqs245mBnG3X7nghkv
47498	payment	2132	2132	1874	1	1	1872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89qxDd39s8gUxw7RbLyLTFv4uLmgoVPUAS1bh5Hh1nsdbY9cP
47508	payment	1397	1397	1678	1	1	17640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVffudbNN3rviXHKhcuMW94d9NPgNx1HBSPaPDfEjgZEgnLyFU
47509	payment	1397	1397	1678	1	1	17641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnosGpgB5ipztnkMmT3atUS7oFvcRPDSHnnz75GcA6ispWPjaj
47510	payment	1397	1397	1678	1	1	17642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjBLDKpSYj2Q4SSujJqLyxTpjT5ZNSeXQWn2AXbF2g869kEHP
47511	payment	2134	2134	1874	1	1	7776	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgFx4e1w2ahxg8fYXMK8iSpD2hgpjDdtxpjNBnD2DYsqZ4pUs
47367	delegation	2414	2414	2414	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYW324vit2rchQot7UwLHfxZd8LBPwkCNM2rEU9VUgeTdfd29C
47368	payment	1397	1397	1678	1	1	17594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEhtaHaSNMUYwGuW4M8TXKUFqJG7HT3nXioMGydXziXr4yv1S
47369	payment	2133	2133	1874	1	1	7136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqomNUEKaMEvApNasrAjqq4Bd6meLf3EadsCkNQrwdNvZzNFwC
47370	payment	2134	2134	1874	1	1	7743	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkofKppzqGNo6GftUysLp61UMSwZ54QHeBiGQ4EFECSTLP4Zr
47371	payment	1397	1397	1678	1	1	17595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ftQxaNajRUQBMH8k9heQZnKp4rMoK72Li2hyyguiHpuenS55
47372	payment	2133	2133	1874	1	1	7137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdJSHzatf1mgGXz2qBxgZs9s1QTj23BpQQwvY3Fnay1n9jQan
47380	payment	1397	1397	1678	1	1	17598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgqzfuydA1HHqVkrYyD5pRbAAugbNqSvj63ngyXWjkNfvBAPs
47381	payment	2134	2134	1874	1	1	7746	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSGadK1dMzK5TXd9f2F8FFSC9rJiT94EgQi3Ym5b7KZQMc8uP
47382	payment	2133	2133	1874	1	1	7140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVWygLKNbf1nuoudY9zxFQTKfnvCf2HmYK4voeWxGYpSSNJtH
47398	payment	1397	1397	1678	1	1	17604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnaz1wHXwxfDVR4CU3nc5ma2EKmwAfdCaZ15dinQPvRSxY3hT
47399	payment	2133	2133	1874	1	1	7146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuhAWQ9T1tn3cG2Y6S38PtoK8uSeDQvAQgkV99cA5cfpaMsPzM
47400	payment	2134	2134	1874	1	1	7750	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uDPinXN4Gqevfy6RD7719CekdM34LQSbuGaVpudVjrtqUEQF
47426	payment	1397	1397	1678	1	1	17613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGPmvUenocVXAD8qLTtnqA3iJqqSyW7sqGrQbV6aXhy1uUyFS
47427	payment	2133	2133	1874	1	1	7155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUFrkeg1RKXrYqq3kK8u7x4d7k7v5xH7js2D1wtAZzScnKheh
47432	payment	2134	2134	1874	1	1	7758	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWVX2rcqXNr2uo6dx2QEcaWHzDHD32DVhx5UfnMbbYLo3CSbg
47433	payment	2133	2133	1874	1	1	7157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoERgRUSEAyNyBP8wD962TqhSbyQQgcuoH5TCHdkXmXX8G8ia
47434	payment	1397	1397	1678	1	1	17616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFen669HH8twKHvbU9QGpjbtiTzAAJZZgf1K6yEV7KE55DL2en
47435	payment	2132	2132	1874	1	1	1866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDEhh1rWnWQ1rK8iLQwwh1pGXjqze4svh6qdRFuupKdscMiFR
47436	payment	2133	2133	1874	1	1	7158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxGDMqv7EQkFu2k7QYFi16KaYHwvmUKe2bR3bAP7JqENSPLom
47437	payment	2134	2134	1874	1	1	7759	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkfCDSkQ1GxqYZV4ba7ioyP7dXmoyMUczT2prPFhuY4NiAfrU
47438	payment	1397	1397	1678	1	1	17617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8ZPMQo4dpAdVHEXvPwrXAvLYiJvx4iKsXLEoZkB3fTTFytcv
47439	payment	2133	2133	1874	1	1	7159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZip1XehQqChskzj85RfKGfVvMy124AEmAYSMFLMZR7hPqC9DpS
47449	payment	1397	1397	1678	1	1	17621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFWcNHyFGqaxfg5jugG4dhdyyybdpByyyD795gT1NU6xjRaDv
47450	payment	2133	2133	1874	1	1	7163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWUbJTx9MUm2uDZmwsSP2fmiZ2TfZ688hcu3zV8WNiVHy8Mod
47451	payment	2134	2134	1874	1	1	7762	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh57LdTLtorrjVUrsMtm9nT7yCUFWJ7zMeD5R9wtG9sv7aFVn4
47456	payment	1397	1397	1678	1	1	17623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAFU7ARy9gyxUZ2TpegMD3amB4pfwnE4doyrXJhTiRmR54X9V
47457	delegation	835	835	121	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz5jvymY9R3d4a23CMAT7LMUVE3tUqTxSY6nGk4MTZ5ysAxTK
47458	payment	1397	1397	1678	1	1	17624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi4s4rU8NmSFJymsQ2tTY4GAD3oAPZC6VphToLdzCRzmFX7kt
47459	payment	2133	2133	1874	1	1	7165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm2r9ncXjAfHUUNtvC2KEPdHoijPJRgtM4d97o4PRWLAnBdF7
47460	payment	2133	2133	1874	1	1	7166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVf9jS8px9x1wVQH3a6cD2x6JB4Mjwo6givK5sQTytzMKd9aEy
47461	payment	2134	2134	1874	1	1	7764	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJb8rXRg9JS5KD2Q9uGJ7Xu3aiKUdB1SEXxTpRYBovfsuHbcK
47462	payment	1397	1397	1678	1	1	17625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaowek1J9vrqa1pLXFvR5bwnLJoyyhSanZEG7NqdemMfNVxA8
47463	payment	2134	2134	1874	1	1	7765	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHEGr333vt4JKNhCZ4ybCKJpbsNANRXUzxpyuAAczZBdvrCVe
47464	payment	2133	2133	1874	1	1	7167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmvqa64726H7v82EXRR1NC423nU8jSa6jRbThvivjETk7qHvS
47465	payment	1397	1397	1678	1	1	17626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1LqDFkWV1KBezLcSPpBWPNNpVtHTVscq9djUJaKQsrAcfH2G5
47466	payment	2134	2134	1874	1	1	7766	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTns6e5dAbzMgTm8nTaemqqYhpuD94GhjksayNbQL9LringTf
47467	payment	2132	2132	1874	1	1	1869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8gMjyW8fMzyqQQiuei6dBGepvJ3sT2BfzxJk7vKuB45u5CCS
47468	payment	2133	2133	1874	1	1	7168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tmogmDtew8jaAuc2m5Kv2BiCNwe9KqUg9HZuRJgXj8iNaH5o
47377	payment	1397	1397	1678	1	1	17597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa9LjVzwpiQbJGncDZM2oSSTjip6n5NQaBzWpLdhnBFwkjgAq
47378	payment	2133	2133	1874	1	1	7139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3gc3jVLvwTTN35Xh31Qv41HA9NhqyLifDEECWnVx5XvYVZmd
47379	payment	2134	2134	1874	1	1	7745	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38MQ1AeHfRs14vaNpxB3FC8vZiwFkf954rei9g4si3BiCSfJw
47392	payment	1397	1397	1678	1	1	17602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijf95SfZYXRaixyroGsjFZNZa2NsaJADEcYMQ1USUUyvJz4Ub
47393	payment	1397	1397	1678	1	1	17603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnLbxXFvAFEUZZMBR7YdjnEkiF6LJuSvwAVcQRbp8DySAgmS7
47394	payment	2134	2134	1874	1	1	7749	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p49hbNsmUKPfitGn8S7AKMWJeYxwLSFF1VH1GmEEvSJrjKsg
47395	payment	2132	2132	1874	1	1	1862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPELTgYobTamGjFTAwxoCoCxkAnCtvvAtnWw4iQMVfJT2MMfcA
47396	payment	2133	2133	1874	1	1	7144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxccCrLN9s2MaS5iBKZoHjSSV2YArVMQyxZ5wrh5wRvTZr4Xfh
47397	payment	2133	2133	1874	1	1	7145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8xjAbEp7ZYVQS7bysKJL9pxrcuaD9kqMgYt8CnBBGkFY8VMg
47404	payment	1397	1397	1678	1	1	17606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRM9ERGEnHypvF41gvqfrGVzrT7YuWMoCkYs8eGtUM88pZv9WB
47405	payment	1397	1397	1678	1	1	17607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSC7cxNLLtV4bKKNMcQoJQNMKz7ur2Pb27NF2Qgec3AgNpZiG3
47406	payment	2133	2133	1874	1	1	7148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjNTTjdihYFY9dvH3QAtpiekrQborU22EVkrHHCtAfb9CwroE
47407	payment	2133	2133	1874	1	1	7149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4URKqVYxzLAhsTYogMqMVAWvURaRTmH6f9zGzFUSLd9RYqiM
47408	payment	2134	2134	1874	1	1	7752	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfrDLhxGF7RW39s6g9zhzdrkTvdEuYWV9zWcEFiVpYkFbcbiw
47409	payment	2132	2132	1874	1	1	1863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkxfxWPZTMFSrn8Hfw7PiJsPQGugJoWcKMTqCiqgdLtwTsugV
47410	payment	1397	1397	1678	1	1	17608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGbfVfXGBVH86bYSxcPaTZPecN269QkkCJfnLaWmjSxEKn8mf
47411	payment	2134	2134	1874	1	1	7753	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVK39bma3bLhVL7m6WdyCus23rwQWGkvP17s7D5VTcYaGhnni
47412	payment	2133	2133	1874	1	1	7150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74mPq4AuTriZ8An6JgpT13Lbe3y5TmpvyjWyQsTa5QXrq5GAT
47431	payment	1397	1397	1678	1	1	17615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUukdFdj3eU1jBcg7NyuuUZRwj1baBiU5UUd49ni1vjoQRXRt
47490	payment	1397	1397	1678	1	1	17634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYToykTUX386En1oXFjanhoutDUTTKsFYYwdKuPZwHvrCUEqC
47491	payment	1397	1397	1678	1	1	17635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUs4RRtJEqChikDdjzEE5ohTeBwT4EYd65mFEUN2WFZiGjuXL
47492	payment	2134	2134	1874	1	1	7772	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyMuZ5fzwZqRTyT4bmc8sFFoJ1BG8jUusvRzHgxac6QhB6agM
47493	payment	2133	2133	1874	1	1	7176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDw4spFLFpAScRvYgnVyz3GtLHG63ogmtjkkdxxU2YzJUXnLvE
47494	payment	2133	2133	1874	1	1	7177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWyJqreJPMvRTUs7EicD2SjqfrvEDEk5HZo2sXvnJCxvTrToS
47554	payment	1397	1397	1678	1	1	17656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Jr5a8XemzMCebYZKmbEHdrp6vBK6aaNWYLGCU8TDHG1CjUyh
47555	payment	1397	1397	1678	1	1	17657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbphTbm12dEhntbuoHvovWqBt9Qe1xy9jnyG8ku3DB6maeo3x4
47556	payment	2134	2134	1874	1	1	7786	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFhQjryjMNmjZh8HrkXwdtXksypRmERyK7xoWMNEChW2HMf7S
47557	payment	2134	2134	1874	1	1	7787	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvUNxXoWUwgvMiqC8oHnPEtktXZjceWxdmrDMWE5kxJ4Yr6dx
47558	payment	2134	2134	1874	1	1	7788	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRm4ByiVqs5CJYEyZvZX8ciUT39w9LD6zvzPzuUoHFBWrheJ7F
47559	payment	2132	2132	1874	1	1	1878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuKfkeWAj1sXuCXKrbvvKcqcbGRaWzbbjzKvRxBr9D6DLEBUb
47560	payment	2133	2133	1874	1	1	7198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWMPhvDhVLrbs75yhKgRypRzwNwhd79phjxMzdHPsEMBkg8Qn
47561	payment	2133	2133	1874	1	1	7199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMFJr3HAEMqFC8z8gVj6SyJgV3V87KtE3WYAWUQY4RW4EFtpx
47572	payment	1397	1397	1678	1	1	17661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUbAgUpC4W7WTtLGk8PXzxs8vWVr1KcxJdqPnQcsEnJjhx2WX
47573	payment	2133	2133	1874	1	1	7203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5wPQGgxz8F748j2Nd7iYaz8BumDGG7Nw1CEC6bYAnngDbqch
47589	payment	1397	1397	1678	1	1	17667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLw7MHcgDpvkrpG4Ji2bDqYzjFkEUmid3bHZwCoc2vCgkQA3Zx
47590	payment	2133	2133	1874	1	1	7208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxYSjNxiCoZey47RUSXjeudT5Z9DBwE9g8EfQAAjFPQjgZ2zA
47591	payment	2134	2134	1874	1	1	7796	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmstxiQyXz3XtxPi1K6W6K294h49HR9pqmPRFo7sngz6KKcnZ
47610	payment	1397	1397	1678	1	1	17674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6wKnPk9pYJUXTwDsv3B8GW7PaeGPGuoZQ1r5FzZndrQqd4ps
47471	payment	1397	1397	1678	1	1	17628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7dQfHYgm3n7tjTunNiijpWuQ1gcVGTx57grrp59sk78cAL3x
47472	payment	1397	1397	1678	1	1	17629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAaSkD1YiikHqDeJ34mqhkFKSMqDjwA9iPYVrZgp7auAijo4T
47473	payment	1397	1397	1678	1	1	17630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5rZghFPNR3YC9ZL3iSNZUDg63RwnppthTm8ucPiKte7Ybh75
47474	payment	2133	2133	1874	1	1	7170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZHTkCv9pCCH1d2H8HxgGeGo3WPep7fkFALuapHuckAwhPSwV
47475	payment	2133	2133	1874	1	1	7171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn9E1TxeJxb9HkB28xyhXit1jdHeaBmoBQq5aN2dSUsP4i75D
47476	payment	2133	2133	1874	1	1	7172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdGY6C5CLbWqALHDxMvNYYDJB4N552X7FNB9cgkhx4cJ9vYkh
47477	payment	2134	2134	1874	1	1	7767	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAzbJ34b4gsmmz3DHvj7zfBJyVHSi4Dqv9XXkGk1J65jUwj6A
47478	payment	2134	2134	1874	1	1	7768	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1N6P7B9z2KjPgQt4P5Rr51sXDbW61BdXdxHSakPdZa9fQxg9
47479	payment	2134	2134	1874	1	1	7769	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8oWj3pSAuC8iHNWRV9gzoU2Zxw5SnxP5WCJtyvth4p62SwMk
47480	payment	2132	2132	1874	1	1	1870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYGcUxajFY3CwPpPLfAqgrMku9Mwprc2GQcZV9yUcgswR2KcV
47481	payment	1397	1397	1678	1	1	17631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZN4BKcwSzopAMgvRmhT8yznnT9b87BGAfSshP3mVtceBdAr5G
47482	payment	2133	2133	1874	1	1	7173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWH4MjvRjzSBm1VKT9KKsW1uFGeu5RahhkgZtWTzBTMX4f1q7B
47502	payment	1397	1397	1678	1	1	17638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUy5P3sWVvtLcmZXYeWBmEdiSqUyHRShgPFYb8G6mEZPJ4VP4
47503	payment	1397	1397	1678	1	1	17639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5B9PS5uY85kb8Nu3AgqYqQdXNyeA9S1tUJT52kvWEceEB4aF
47504	payment	2132	2132	1874	1	1	1873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6WhLkgWRfu2FQWktxCs2s8EYUFFUUBTBHA1tdwLo2jdUuptp
47505	payment	2133	2133	1874	1	1	7180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYe6Xn8DWjGmjRfT5Qc4YExWiUMSu8DnvKC48Czpzo1T9Xdxm
47506	payment	2133	2133	1874	1	1	7181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjc78KYwaaqpbftJUTJDiZNAg59rngBxeZ1tCHLiL2eoznXdP
47507	payment	2134	2134	1874	1	1	7775	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa596uuxxs9rhvVTg1Gzs17TJhxYCKEKYNnWHJUs3qyiiVEZkjG
47529	payment	1397	1397	1678	1	1	17647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGYcysWkjvvDwzgq3zuqFcYkSahnMb87TtfEAbrusoeN5c5yU
47530	payment	2133	2133	1874	1	1	7189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWjNWLMcVkwfKMqepDFM8gpeMpQCjUntE6WkjSSVYB9zhkQc5
47531	payment	2134	2134	1874	1	1	7781	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJr4kptDSR6N3TD2HaVr6vpjJQ7G7sXt9kpNY1txKgpas2CDN2
47550	payment	1397	1397	1678	1	1	17654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgD5nWR5C62JzBECp3KHfRjcpqHKTkc44psf9WzBPsy5vJLBm1
47551	payment	1397	1397	1678	1	1	17655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZfWqipFZDfoyuzXgkLV7jY3hi651h9RLkP8UMsxP4L1qGKZX
47552	payment	2133	2133	1874	1	1	7196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrX8Q5M3ZSdE7YsHE7M3AdkZaeuiBaTYGPPrKqsiPwYpdvvAt
47553	payment	2133	2133	1874	1	1	7197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpV9bXJ52JtLRY8ePn5PBmfMEGzeRQreV6Ai9yJQR9ztnoGLP
47583	payment	1397	1397	1678	1	1	17665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGftKHEDTuLrGC2asf5VdkFNoFskgFjzos6BJKwqfjxB9FiMNR
47584	payment	1397	1397	1678	1	1	17666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFk5EY2JAxraRYCkQbb2b3PrjREqNrMjr8Y4kgxAeZK6NAaau
47585	payment	2133	2133	1874	1	1	7207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAgbeNbr2cVAnfeKduVZBbJAPoeJnENYvdB6MgEdtW9ET97Z2
47586	payment	2132	2132	1874	1	1	1881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfW2uuEn4jZw7Tp5mxhkRZR7uPtKuPEHPg6reWwgDGnPyg9xP3
47587	payment	2134	2134	1874	1	1	7794	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BPD1pT2fLfMr2oZJ3GTKV7JHdw1nGhaeUEDaMxEfsnGt47dV
47588	payment	2134	2134	1874	1	1	7795	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5hmycoGPVmkGHqXc1PajazmMa2bu8fiRZQi7r3g4wdJuCJNT
47592	payment	1397	1397	1678	1	1	17668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPGdLqsgYMZqop5Nf3wNq523XrsxknbNEEqAwEcT6zBvRALmc
47593	payment	1397	1397	1678	1	1	17669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSbnLav5rnHRoWJ6MPURL59xUzsktCzCUrjkYAvpLdhTDBpKk
47594	payment	1397	1397	1678	1	1	17670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjUDfZBbAcW6HdTk7hvNihdPCDTCegJSbp5Dphm4dhgpmCJyw
47595	payment	2133	2133	1874	1	1	7209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwfzfzdxXCcG8oxPrxiNBjFYS9skUD24QTqBWcidJ5nK877rk
47596	payment	2133	2133	1874	1	1	7210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfQTCXrEN6gW2f7ZHaUL2ifKvYMDHZx73LvmyaFG2MZamKRjb
47597	payment	2132	2132	1874	1	1	1882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc96fVV54HcX3RsLcBT2KYPig8VGH9VshcsYvABc3sWR5rXB6
47598	payment	2134	2134	1874	1	1	7797	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpYfQXyDb3hKv6LrBNv7TBt5exusXQaBprAtsRLVq3qBjYdML
47499	payment	1397	1397	1678	1	1	17637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRPfD1rqmQDZpJXdhpbpvZHL87XugP2oZMBkDLu5RiFfLXMvK
47500	payment	2133	2133	1874	1	1	7179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEY1SjG4APW3jL31y3Qe9Gr83dtiRMn4JJz7rH76AFheN34mH6
47501	payment	2134	2134	1874	1	1	7774	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTtATc8eFfC2cawr5KcG1fZPJskeHAx2kbctqjygCdtAWjHhc
47525	payment	1397	1397	1678	1	1	17646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY3fQ3URG83evLhTLJvJ7mK5NEvnZRv2uNCw836CBYKS6NfXn
47526	payment	2132	2132	1874	1	1	1875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLuNJXcKNPZEJ1Tzs6n9ccdApMz8416cNNaroU2dY5Rn7cJ7T
47527	payment	2134	2134	1874	1	1	7780	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNoVmVVqwHzjn9CMrwUkKyJPj8WityWUgdXbuSLL98BStvLjF
47528	payment	2133	2133	1874	1	1	7188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQcHPhz9hVMfUibtWkgVfNyT7ySL3rXmvUoNa2NgJq8yCwmh4
47532	payment	1397	1397	1678	1	1	17648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYMnFMmgXsQBxh6FcaCmJp3HrRHqCgD5NueEZgKKUrtvkrp7b
47533	payment	1397	1397	1678	1	1	17649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3s48wLTQe7eNVFXZMFcpmGzudjM8KdgT5BVXiLptJT46a11Uk
47534	payment	2134	2134	1874	1	1	7782	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA1B42C38GMUWXqLbSuqdCzJw7Lj39F3dEMVsD65Q4rFWsmHf
47535	payment	2132	2132	1874	1	1	1876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3XNdRLGB6uvQx78jrZPz8zH6mVruMucqSs3vjWFr4EbnHPKX
47536	payment	2133	2133	1874	1	1	7190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVvmHwhZYeJG3CsVyPE3UZj4s7WSVrjhbRLVrtutjUKEmvmN7
47537	payment	2133	2133	1874	1	1	7191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXom4bVbmxeXyFnnW9URVJg17uuXAh8sAUUt9V2cakNFB5z9WW
47581	payment	1397	1397	1678	1	1	17664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT5kTuFGmd2xzYrwYbeeMSxR8EXK2SYdiA8bP4x8XqKHV9Seb
47582	payment	2133	2133	1874	1	1	7206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuwsHUERJ7kqk3uiy8SuozqpRvuhTVzg83V3YY8iUbwnhjcft
47606	payment	1397	1397	1678	1	1	17673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVj7cQQ4Xce5fdVQ8Bbwx3F8EimU3sBVBVwPQc1TC4RijDj2i
47607	payment	2132	2132	1874	1	1	1883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeGtKk19ezhh6amK57Tcdk1kYtWq8cxawtYNQJBSMH4f7qg19
47608	payment	2134	2134	1874	1	1	7800	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7HogdQJ1ycvg8rzQdWmcEn47NTQBjBpAnYmbUNkMvtdc9ZHvE
47609	payment	2133	2133	1874	1	1	7214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy1oqKATA9VQVe1ycRUKNKpgf8SGdFrQU12n88bm4Xmf5few4
47616	payment	1397	1397	1678	1	1	17676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgJJk5t5F28ZbGLtxwQuxiFdv8wrjtrd4fxz4GpmniS6ZXwRX
47617	payment	1397	1397	1678	1	1	17677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tiN6qV3dWPxXfGkPXg7Sq72JCvwqNshd42EbKTRyZCittJr3
47618	payment	2133	2133	1874	1	1	7217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVWxAas6kCVpKt7SgxnzARUAKHP9eJzL38syTB5fEbj3TocPQ
47619	payment	2133	2133	1874	1	1	7218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRb9o7foLkhP6Drb7FasGE5zQwr4jz2U7qb6RzNjMS2MGHrxB
47620	payment	2134	2134	1874	1	1	7803	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3B2x65jjFbv5QEfc1eVso3WazBm3BeG5eSd9K6Mv4J1PUjf9
47627	payment	1397	1397	1678	1	1	17680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgSRKWoxsXGEQb2YTrz2ChBtjeL8gJtY6nzvC5tDpX6fiYvZq
47628	payment	1397	1397	1678	1	1	17681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRgfyzDtdQ4wXcQA9pjXgMnfsSbJywjyHBfCiZgc7Y4fY3wv7
47629	payment	1397	1397	1678	1	1	17682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAtZSKJkYQe1RdofkUqUDDb7QHVH1AzstKkWWRmRPSZLKTGkJ
47630	payment	2134	2134	1874	1	1	7806	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiraVozCCzcmhEjFF8k78YfgVFhcFs3y9mTiKXumptLQpbNcP
47631	payment	2133	2133	1874	1	1	7221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgnCEX98G55uiL7rMdmR6cgjYAZUwQtNxYhVZyM7AikbksHzD
47632	payment	2134	2134	1874	1	1	7807	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQfm11FQFJwNgVxUezJkGSiwosUZU4b8JBKoUXp3uzvnpQnGV
47633	payment	2133	2133	1874	1	1	7222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkpYvxqpBUvgS1wZ2r1p8f4YzQEBirCHFRMTBCMmAvrXhEzsF
47634	payment	2133	2133	1874	1	1	7223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoFh87et7RULwc7xZqusTnj6ygePf9iTyaAzRPk35t4jw98n3
47637	payment	2133	2133	1874	1	1	7225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UocH9VSkG45NfvVoKfqM8rSYqq7zLPR1tpfz1yPWDbXdjdcT
47638	payment	2134	2134	1874	1	1	7808	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV7JZt5cAWa2FaBSaTgo5R7xho6DDe4B3dsTFJHGozj52V32Q
47641	payment	1397	1397	1678	1	1	17684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZLr6UKw6kxBfuXxMxbnTHSRGbbV8nK5bCNJudSAefeFCJC8q
47642	payment	1397	1397	1678	1	1	17685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzLSeET8R47P4nMswDpg398za6f96Mjf4UUpdGw9kmSvDYSAg
47643	payment	1397	1397	1678	1	1	17686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVCxGhxpmCszq5hY4xHEx1XKkfs5GSGk5VYN6jiDp8RBYsDEj
47644	payment	2134	2134	1874	1	1	7810	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHFBX4LJinJCHUQ4VkR8QNgJAikRhowMrk9fb1T1ww99UAE4Z
47512	payment	2133	2133	1874	1	1	7182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1s1GYeya8RudEk3EpNdiu685GDdpy7Z8Afc7cP2vRENrNZpA
47513	payment	2133	2133	1874	1	1	7183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXknWuF3DN2dABoUAWQTfhhTDRSh38E3vGd2C1PYTLsBGSSrg
47514	payment	2133	2133	1874	1	1	7184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHyRS3oz5zjdsMRCB8aXFVfDrt4Mf4VfGy9zhQZepRvLA7F5x
47515	payment	2134	2134	1874	1	1	7777	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpU7bEXUktCf71ErCoeefgycnpHPzpnhpTRTApRUEjXTVpLQoS
47516	payment	1397	1397	1678	1	1	17643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi92N2nR5XqqtMEgtLuryDEddussgFPwHvpfwXmmGtPwoi6UG4
47517	payment	2134	2134	1874	1	1	7778	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXGkFzhQqMxP9Rd5pvmQCTXkiC5oWYkh2gj68t4tU64pax3mm
47518	payment	2133	2133	1874	1	1	7185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj1GUnrUvd2wDw5Pjr4PKBgdoeCHF4YMfMYGq8mLiu6z361m4
47519	payment	2132	2132	1874	1	1	1874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjnjUmRyyz9SjKXj1HAtjsqVJ1aHJDj8tV5U5Yj6jVsqQyEyZ
47520	payment	1397	1397	1678	1	1	17644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4guJso7inN4ay4oLW7ZhYAPTEhnyb3rqmCqvKP4QAXtib9wN
47521	payment	1397	1397	1678	1	1	17645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DTrCWC2R8syRrbF2zpJ6YNL9aU2tqygtEJtbgdzq7CCWW2GM
47522	payment	2133	2133	1874	1	1	7186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipSC8qXtR2vQSZBL9VyPYsFU6UAP5NeeTVNLhgUDfzJQmpE8C
47523	payment	2133	2133	1874	1	1	7187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqPXBzd7Ebnt3idwSBUcr9W8ZARwRcqxXj8s4VdNA6VddthQ2
47524	payment	2134	2134	1874	1	1	7779	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9paLamJ4r4VAk5rD6UJM65YFHjikJi3squedgZuePdiJsSu6y
47538	payment	1397	1397	1678	1	1	17650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxivt4TP21919qWU4kwTMq4YufbpkWm8VwUUtf1K2XX4TUjufC
47539	payment	1397	1397	1678	1	1	17651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXQQanTiPgboem6TZFaJGkkcZyfkjXp3FJocshGzrUZNvtGT5
47540	payment	1397	1397	1678	1	1	17652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqPcV4y6yyFW97azx3SxMY89jWz7GdtmFBge3NMDKAw76hmx2
47541	payment	1397	1397	1678	1	1	17653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUC4GFiLuUW6Bd2LAqiYAHqvVEg23KKyr6hiy6JAJXAhXtobQD
47542	payment	2133	2133	1874	1	1	7192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA9e9zm1rCfJRvwZw9pnrzPAdJgax9VuSVV5tdsE3jmT9yXF4
47543	payment	2133	2133	1874	1	1	7193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZu1Ue4KN6j4tTW5PAy5Hef9iGTBzfjEWTWbxhhktxnNakfbyi
47544	payment	2133	2133	1874	1	1	7194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3DmyvVX3evG2JxGdAw9wuAiSz5y5s37kBkCNRV9MhNchYQe7
47545	payment	2132	2132	1874	1	1	1877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTL4oWCis5Ruw9EsBZdxjhMRFXMjSPwWPH5BApwVTKsYJMWBW
47546	payment	2133	2133	1874	1	1	7195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxanyuffkuJ84adUxsJLGU7oWaNeUr1PKPK8R353YCGd4q3VQQ
47547	payment	2134	2134	1874	1	1	7783	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5K7PZQtw5VY2kp4RLaJsjmv4w6Vue7fwvKoe7UXGxZbD9uA6
47548	payment	2134	2134	1874	1	1	7784	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8wdDN8oeijt9n7r9fBPhbG8g2wQiTVaqHbQAnVSByHF17Qhu
47549	payment	2134	2134	1874	1	1	7785	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKsgEmfBZRdZVEus3nZNRrui7qn11jYxRGmhewXrUb3fwMcpK
47562	payment	1397	1397	1678	1	1	17658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQD2hja9avP6C2YdMV4xvRRfCtUHvTR5cQ88n9trMKacZB4h49
47563	payment	1397	1397	1678	1	1	17659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLSRFpLaJeRr3uDsdiw3eG2pLoCKBNzE1evzcm6vvrgh1wH95
47564	payment	1397	1397	1678	1	1	17660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAPARE7ch8wMbfL6WDmyTZjUDrPuudzt7Z6SkXPj5pQJcZjqp
47565	payment	2133	2133	1874	1	1	7200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYFQwQEog9kG56E2A2ASLdgG52BWxBpDYL488SGdtrF4CdiTs
47566	payment	2132	2132	1874	1	1	1879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbkqhvnWVMSd3baasEoCTBHjQpKzoAbekMtbhwmgChHWEFNmw
47567	payment	2133	2133	1874	1	1	7201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbJm8wKjX9xPn9xFsGaSMJSmJMpXmLfUHPUV6QvKcMBRGAMdN
47568	payment	2133	2133	1874	1	1	7202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dAdnisqQiTLs74oPUVgkYE7R94myaVMg63iS1dZypRuQprWi
47569	payment	2134	2134	1874	1	1	7789	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DRzs9TbRAoVxJJYcHrCUuzxXeSBV47jWDxZAgtgc3HjLDK1N
47570	payment	2134	2134	1874	1	1	7790	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhW1FkSy8tmfgB76PDNy9wSRAiQXMoJypyXEitcuaELW4uwNR
47571	payment	2134	2134	1874	1	1	7791	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3biXLhRM4w3svotq5ENx9sbwf4EMdcMePu5RpMoZV6RaQQVP
47574	payment	1397	1397	1678	1	1	17662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ471LZwmQYW8WWx54APw5Y6TH9CnFggznbbJY1icBJRt6MVfyi
47575	payment	1397	1397	1678	1	1	17663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAythc5JkVc9ncFfFhmzaDQYwziPcvt74sTzhC88U7mpUCv2za
47576	payment	2132	2132	1874	1	1	1880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwPAJM9UUEQKmCtEQVFqYaH3deXBRJommXiAG3HdtxBAugKva
47577	payment	2133	2133	1874	1	1	7204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGTh3heDm27nd4J7GiGf6hVBXBHJSVr3HcHeJQamX5PFQnjM6
47578	payment	2133	2133	1874	1	1	7205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU92EqvjXMieG3ZVkDahbN4b7F5ZvgVne5hakBnpowL1TBQ7A
47579	payment	2134	2134	1874	1	1	7792	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpz8Mre51DBYdEaJKqkVgochD7srxokm2SiN3DrCyMwkgZKE6
47580	payment	2134	2134	1874	1	1	7793	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQYe6hieUa1mfdrvqAHEZbK9LFvHNmTYvaHv14GSbH5gbNWzZ
47601	payment	1397	1397	1678	1	1	17671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QTBfPqff1TsX4XuGqgk9av7DDKtkh4ogZhfzVkwNDUfvD319
47602	payment	2133	2133	1874	1	1	7212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRUorgN9jPMeZuxmDFgUFN23pAEw1DLuNaXbonN7DiPqTiWDq
47603	payment	2134	2134	1874	1	1	7799	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hExLXCXgGu4mkEmqPz7wwE6cmAPkJVk9mvUswNDKVLaz4iqR
47639	payment	2134	2134	1874	1	1	7809	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxE4z4qNWUaQL5WE7H98JbkKKAWJ3UUxnTxNFpNjmkCx8qoNK
47640	payment	2133	2133	1874	1	1	7226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXdBGdZBLejN2D7BnjG9Um3HnLjfa4KtBiTmkSAK8R2eu4efg
47657	payment	1397	1397	1678	1	1	17690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTKW79iNgU7xWexD8hyHp1fc1avc26GuUdwxekAb1nAHS3zv7
47658	payment	2134	2134	1874	1	1	7814	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPTJCjU1KQuEU1FtTZFnL8WvLWpuSxwrd4KQa2FQwr3uM7QGT
47659	payment	2133	2133	1874	1	1	7233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGMxLWDV6HKbY9V2XerXGn9HTWiVdsuZ6hnXrmwbcowq8VhQV
47689	payment	1397	1397	1678	1	1	17701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSwNPijN8iHSX1LBiwhKj9CbgLr2EnN1K5Rp8vAENMWtxxQ9p
47690	payment	1397	1397	1678	1	1	17702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwUp3r2kinp4sMhZXEdKDhAZACTxcWuC45vWjWk3JrtymB1ii
47691	payment	1397	1397	1678	1	1	17703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfH9JPHYgw2rNH5j6diqi8ChJ9JWmDzLxr7uMWPZZeVuvqi6K
47692	payment	2133	2133	1874	1	1	7244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhu6BcQpxJu93v1FN22d4MjHbZ7fiK3McyzuQwkSnANuS8HMeY
47693	payment	2133	2133	1874	1	1	7245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfLAw598jX9f2qpzfNXmEW1x344CTrXaF9KGL4hTAmvcY3zJB
47694	payment	2133	2133	1874	1	1	7246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SosqxE3vj76uR7ZYFVMkmXqJJQdtGvSXf2T8Ti35b4WEWMpk
47695	payment	2134	2134	1874	1	1	7822	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VRCuTgt2uqvGKjRhB1e83KdVywTgiEfnGpHnNv3QNGydjaro
47696	payment	2134	2134	1874	1	1	7823	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJEQdzj4eKXf7Er3iNfMQWKoSxhHBqYzDxvm7dvUuMHdZaBta
47715	payment	2133	2133	1874	1	1	7252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8N6hCgScSXjfUeF4ZyP4W3XNb9GhYLzQftWJpK23nf5AAZRb
47716	payment	1397	1397	1678	1	1	17710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQe7jMgxmFmVNY6xBUMuvh7JzXvN3bm2jMH9HTZcu2RAn13v4T
47717	payment	2132	2132	1874	1	1	1888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUixSCtgD7Acsk9oUGu88dXGWUJ9zBM4qSpsw5M75ygR2ZUdS
47734	payment	1397	1397	1678	1	1	17716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6pR5G4LgKLERXmkMXT7tWaZQ7QRsrdxcJbxGWG4MNzVW1MVt
47735	payment	1397	1397	1678	1	1	17717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1e3ADTifPYjSNEYXRNqmfZnSN3xo5q8264sWNPDkSdmmVkHi
47736	payment	2132	2132	1874	1	1	1890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLEWj6RLvFF4NXZg2jx7UcUuk7rKiLtHqu7G57yPhE8daQH4U
47737	payment	2133	2133	1874	1	1	7259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbCzXf6ogB5GVQt3AZcao5wvW26bf9TLMQQmTar2cfM5NeLu2
47738	payment	2134	2134	1874	1	1	7833	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuSNGU8tVCAqDkq2y9s2B4opPF7ji8LKYP7zwL5sg5JgdPuAT
47739	payment	2133	2133	1874	1	1	7260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRYzL492gMuqKDEHeVLyCq8eTsFe5RK2mtN2VNqx5CH11g3F7
47747	payment	1397	1397	1678	1	1	17720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhGy2YFS3RmpCdENai7rAgYbZzWryptD4aVrZfE8UNMkETWcJ
47748	payment	2132	2132	1874	1	1	1891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwqM2F81G47EYzTwKWUd2aWMWXzELVqbNeVTWNYM4ri7bki41
47749	payment	2133	2133	1874	1	1	7263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgw8Czx46qeT4ib8NaPCCyN2Tj6LqM44wJBVqaKkNWs8iczKG3
47750	payment	2134	2134	1874	1	1	7836	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxFecnXZn3BM7Z2dvCtLo7MctfWBeW1QfAZLYmqfCVLKASCTK
47756	payment	1397	1397	1678	1	1	17723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXYpqW79dEqg6ik4xWMFQKVxeAUkkWjGRzA2WBAYAMNEPyEvo
47757	payment	2133	2133	1874	1	1	7266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G8c1XuCn59AXYnTZ1ohGp2AWs1w6mF21TnhM9nYLKHTbjBfx
47758	payment	2134	2134	1874	1	1	7838	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mvppaySBWUJa5LCB1GbHZyhwLKEJbvqkeA8K3AFmEazdcQa8
47774	payment	1397	1397	1678	1	1	17729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHr9zjFDh5ZWvdGEVBS6h6FQ6FSiB6KhhCHd7n3SqrrKty3w8
47775	payment	2133	2133	1874	1	1	7272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7pewSwPfZm2TjyZ8z4mTuSUePs71LBcFusF1tM7yKc6UUqCP
47599	payment	2134	2134	1874	1	1	7798	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbJeed7UcAJkiT9SKey5FhEBoGsZiwq25HwtXzYeK7uXQnwes
47600	payment	2133	2133	1874	1	1	7211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDdjZSoGJ9U9bMMCcmHLwwSMCRro9NdQqBHDJCxw78GjtjZFT
47604	payment	1397	1397	1678	1	1	17672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Ezeg4Mmsb29We11pNdERLsva8QvZE95kie31NmoiUYLwjJtj
47605	payment	2133	2133	1874	1	1	7213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PLv8PsRzUvtqZy38EgzanybCPJMTdQmwwU28ibTZmjYx6gH4
47624	payment	1397	1397	1678	1	1	17679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDmHMjyFqduVbAzaLqM7AbUtxrDEKnKjTxXofSrLmB83S6F8R
47625	payment	2134	2134	1874	1	1	7805	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsr1pJsq8f1kpAfJENXrdMPfx36vngJ6gJMjkmNjuyNQmwsjdz
47626	payment	2133	2133	1874	1	1	7220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwm1DjUx7Nh232wZpVihmjY4XzXHsMh8JtpGx6Ax5yjNow3YA
47646	payment	2133	2133	1874	1	1	7227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgYE2FqmAqipr6kZWSiwvLMep5QYa4dCKSqfnhMfkfD9J2u7b
47647	payment	2133	2133	1874	1	1	7228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KjGyGefJxtaJoUX4GzLRgJwSLn1g68ZDPEwqNYopnS2ustFz
47648	payment	2133	2133	1874	1	1	7229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJG2YXFtmYagkjgG6WCts84SJcmGep43HG9Yg4sYsVsghx9EyQ
47652	payment	1397	1397	1678	1	1	17688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVnEJiBAhzdX2hi3K9V7Ht8kopYjiGmqL6HsNC1Dph3BMYcKY
47653	payment	2134	2134	1874	1	1	7813	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtAyC8jGUrcHk5E8EpraFkbaqoBzcYroWxx4wfoMsf8oduxrK
47654	payment	2133	2133	1874	1	1	7231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb4x3Yfeth3eGkC9aPjtcmve9XkRjjP5NvjnETsQhxzX6kuER
47660	payment	1397	1397	1678	1	1	17691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjgppUT52xy9Dv1SUNUXnPnEQ4dWcXuWe2ntPR1uXcSuwZj5A
47661	payment	2133	2133	1874	1	1	7234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4Fm9Zw2h3XrcNHE52b5WCiqWX1MzegADZX6myz149br5X22E
47662	payment	2134	2134	1874	1	1	7815	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ka1WT8CYSZDGbsfjMGjrGM3bWKYJ5ctRzU7UQLBjRaGe6ZSB
47674	payment	1397	1397	1678	1	1	17696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAg7T8WwhxxXMzWwsqbiyGGVdCF52ocb7N1qyttX8kw49UtujP
47675	payment	2133	2133	1874	1	1	7239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dtvW8nFPAwMA38LLBt3jduoue5eZhHPZViKmsA8o6v7P5NbY
47680	payment	1397	1397	1678	1	1	17698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8FDMumkfggaRJkExfsu4EJLwN6EUkU9TQkXUrAjFGiqks7Dw
47681	payment	1397	1397	1678	1	1	17699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK9cj7Ga8cZ8dw9qrhA2i5UZ1d5pCYwcK3Rk2yECy68gkH7Up
47682	payment	2133	2133	1874	1	1	7241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAZrgtNvU6G9bS9UBTYeFwADPZf3DnCAJi4wtvfHgZvAKRixA
47683	payment	2133	2133	1874	1	1	7242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoXu1harTitYEdHr9YeeEmxHg6KGZkgj34ZLan3iUhEUUCPYv
47684	payment	2134	2134	1874	1	1	7820	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3N3LibiiAPHvu9eNT3iT4Mgn2rmCdkwGkSobRWgMAas83UHWi
47718	payment	2133	2133	1874	1	1	7253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JvmNSHQ17WVRrRDiKjXrsUUtMy48SVh4bomGyWAY5kDBjoXP
47719	payment	1397	1397	1678	1	1	17711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEjf4vYYUM5rdxHHUZ51XCsphswvjya8ySrCRSqk4bZs91fYM
47720	payment	2134	2134	1874	1	1	7829	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYs7M6RsiisHmzz7oABATDio18vyBPbJoRC4tWhF6mqEmVcQf4
47721	payment	2133	2133	1874	1	1	7254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsn8T74WjerPo76dj95ELtGRLggPCKSWxZskuCdxh3BjbfEZZ
47731	payment	1397	1397	1678	1	1	17715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaJTsW3fEppZKye5HJiG94REZKhCoykGrA3nhAgC3qmWMp7zy
47732	payment	2134	2134	1874	1	1	7832	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWV2PLjEm2jczp1YnUQZ1YVGdyGn1tr4ymMv6QngwkKNCVggaX
47733	payment	2133	2133	1874	1	1	7258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYNDpPPydGB8ww6CXGecpZ9Ep5BW2MgsckMenG2ykgAsQ7pjd
47768	payment	1397	1397	1678	1	1	17727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFjHsoSZt22M2nNeM9HZb18fdC3SKYZF6omjZbL7cU6cayVPq
47769	payment	2133	2133	1874	1	1	7270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb5AoE9fdGCemnTCxmVXwLQePBCatrKVu1d7zN2yaxWtgGFbq
47770	payment	2132	2132	1874	1	1	1893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5Crmp72f35wbkYmoWY9uVGttHBmrDbAGVXUM72XV2T1JX6j9
47771	payment	2134	2134	1874	1	1	7841	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpgt21XvFq1cicQTxMSQV98wzTVCpx4zNxkWyxbih2EGsbR2R6
47781	payment	1397	1397	1678	1	1	17731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzz7eLmSz7usPxnKMANiiwcF2pfgB5BXqpApweHTtruCRZn8g2
47782	payment	2133	2133	1874	1	1	7274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbicqfsEL9NT6o4aZEM1pX2xnTPPSLKVfgioD2a1MpVfFAKXet
47783	payment	2134	2134	1874	1	1	7844	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvK8uHamz57D7hUY24gWuqowbkNsbaR7eqiaziZcLMC5T24jH
47784	payment	1397	1397	1678	1	1	17732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLQc2PVKPeVUiifptbasU1Z8egRz451JFfQTshqQmizxC2QJq
47611	payment	1397	1397	1678	1	1	17675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDHTKHyPBMUAB9G61qy5k5CQWxEqfuEgYpnZu6X8WavBwQgXo
47612	payment	2134	2134	1874	1	1	7801	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMhZeeQCL6pwJVA4irAWnDgfouVsvcaxkaQsYDpYczMRSokgQ
47613	payment	2134	2134	1874	1	1	7802	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrt6CrFpA1mfHLiMrLpXUzNZ7aKV23fUP1KTaddHRJaELjS6P
47614	payment	2133	2133	1874	1	1	7215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqWaWfhcPDYess7x5d19mm766EXW1HvmgfdfJpo4FUZ4H8Cvs
47615	payment	2133	2133	1874	1	1	7216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwT6JPHo1g1am6uytDTWrzkQ4Hi63dsB5vGkMX5QmXH3G6HKLs
47621	payment	1397	1397	1678	1	1	17678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCqH9KWUxKo2xxG7v6rp65vDtBdymEknis9XpsN7q1RWzPNJu
47622	payment	2133	2133	1874	1	1	7219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRrpNbtFJM2hMFJsNdVJwt5aWcZh61P3WCFvbiZpFVYSVMuDM
47623	payment	2134	2134	1874	1	1	7804	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiquGcRrwRwSUpoW8ovTpteNnCm2gWyjL8pjYMRQL9saW5BoDA
47635	payment	1397	1397	1678	1	1	17683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNzrYcfXPX9yNDURtjbPxXAJPTsgtuUrjVxH2ssZ1WPL6VxxY
47636	payment	2133	2133	1874	1	1	7224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrBjLT7oeQLDWsoGnLwakxnJuL1sxfroF5SQXT94Xtakezai5
47649	payment	1397	1397	1678	1	1	17687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2AXTspSj5aVwgFGZDgreZZfaYBktpbRtepn7FZPMyo3TfRPk
47650	payment	2133	2133	1874	1	1	7230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK61Q9baHsuU4Upbg38NtBdhPoYBpJNP5uQttrUKNddHXoVoQq
47651	payment	2134	2134	1874	1	1	7812	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFd3WL8967hQFpop1ozbSewGa2v4tamtcaNChEMvXf7EPjXfgs
47655	payment	1397	1397	1678	1	1	17689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAGovgWtfphqyubJSYxCZyDh8KS7HqXAsYvJE5vaRtuUQ3H9x
47656	payment	2133	2133	1874	1	1	7232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUeJPaN1peY2kzCi72BqDbw3UA6jCYKSpmqDVeU4N9XpRJ5kb
47671	payment	1397	1397	1678	1	1	17695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwSHDftE6uQYcRBUwMjN6ZQxKUa5oBDyLqf4ytohZVF6ucRSP
47672	payment	2133	2133	1874	1	1	7238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWYnKSspvmksQ7mDdwGrTRXyiGbGD86xqBVr7gTuPoYTgZRbV
47673	payment	2134	2134	1874	1	1	7818	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw93ZBrR49m4K8YDxXRWMV5W2Ys3V1hv7sGU6V8BYhjGbuxdCh
47685	payment	1397	1397	1678	1	1	17700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqt9YgADQyPqLb3JMXsH2BkoM4MGo21ryeTz8fWFJxZWu2x8N
47686	payment	2133	2133	1874	1	1	7243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfv4E5bZSTmDpTzcC8dbLqth2HLYydLtsn8HgYSH6RXsfU3ue
47687	payment	2132	2132	1874	1	1	1885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9254q6F2QxDSFP3Q1Sw4tvYzQu6Ssdm5ywzJcjQSd2moaEqMt
47688	payment	2134	2134	1874	1	1	7821	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P7K5cgzyGs5y3MCWR33Qx6c1cPJhrWF7kME5xzLMTJMt7zWS
47697	payment	1397	1397	1678	1	1	17704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwEBT92GjZfV6dLHDrDCvwgywBfA2QvdQ4UDEgYckbQ1M27h2
47698	payment	2133	2133	1874	1	1	7247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUV5MWArnLwBKgy1Zd7LPHfe2PhReA2wBHatv6fWhQvNTBRkj
47699	payment	2132	2132	1874	1	1	1886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWQwhGxntqaigsGpHrWKBvNqmEeYTfznThgF1bZYaxh4KULhi
47700	payment	2134	2134	1874	1	1	7824	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtctNJpCbtC14MgXuwvGQGyA6guUgEopGxtHE6mWSkzNxYPRT
47704	payment	1397	1397	1678	1	1	17706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixE464B7vbiuUHrqmnwrpVJWJb1hYah9i15BmbhezBfBur9RA
47705	payment	2134	2134	1874	1	1	7826	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdEvQpVFtffkhjFsJgn4d2mWpJY1dCJVHEBPv5pAa8L9SdGSR
47706	payment	2133	2133	1874	1	1	7249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PW6NaCsrZztney5B7inypsBe9vggDeDgsZJakDWg5bauv7tk
47707	payment	1397	1397	1678	1	1	17707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf73q48kn5yTmTp2kWtaYp92ky9m7HiLsV6nACNU2zTxfp7Fx
47708	payment	2133	2133	1874	1	1	7250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXa3R9rwz7XnZdchfAG1xbc2x9NcS1f1JY76qfVUxhyjLjDKjh
47709	payment	2132	2132	1874	1	1	1887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU74wSQxjeiALKvrnvbQwzdByikEBLn2gUWVWLQXVdvppFTuKP
47710	payment	1397	1397	1678	1	1	17708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNAdMcwHswY3crnwKDxte989954EPQPMduptHbiYDZJjiExkj
47711	payment	2134	2134	1874	1	1	7827	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSu2H1Jmo3WzNX9bG5MyGdB7WtLYCunSEtAk2qMXjBDs3MxBTP
47712	payment	2133	2133	1874	1	1	7251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgR85cJiX8sf4jiQaoxRfdb19rxSyR2axzpr9wPvQTnTed726
47713	payment	1397	1397	1678	1	1	17709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWkGdYwQvhrDQv6CKkCMUHFC6u6Y4sAoZBAVsr1iW2qV451iU
47714	payment	2134	2134	1874	1	1	7828	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFC7HnhGKuSMouUzzwoRAxAVmfup5QWyHMKJ8aRmdsds5mA21b
47722	payment	1397	1397	1678	1	1	17712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXvRp1QfdBqeRJP24MFTZbA7sL5stKe6ozCMLZGLiwtNu1tzg
47645	payment	2134	2134	1874	1	1	7811	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXne6EiJ4FCAx8iMBNbzWDQJzC4vo2fr2MYyZB8JHcL4dFsY6
47663	payment	1397	1397	1678	1	1	17692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuQZyZw2RZoiNPWtjuhYjbmE5WFs9koFp17ourb4TjKAPtntu
47664	payment	2133	2133	1874	1	1	7235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrUxqa2hBCqGEgHoB1xNgZFFwLjoYh8Te3htcVuc46azUYtDS
47665	payment	1397	1397	1678	1	1	17693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPaHp3oSYpoJqNu3z5icWnnRxXZirube53XTReJ9Y5xgqksEw
47666	payment	1397	1397	1678	1	1	17694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYappV9CAZRuMLYR3aexPmE72rAq55rvf8oaE45X5NJbZunJmH9
47667	payment	2134	2134	1874	1	1	7816	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYay3535fdo4tupnLuHnthqcTuJTd59dcTW6LgAUux1fYkc6U4B
47668	payment	2134	2134	1874	1	1	7817	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRLJiRSbUNnnYhPF8thMCb6wrt2aeortqvp25Td8sqRJEWWxB
47669	payment	2133	2133	1874	1	1	7236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxm5amTqdD7ZqeJbDyN4yRSbS7ZHueDHqKGo5cKt2Ya1b4a78
47670	payment	2133	2133	1874	1	1	7237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SNwfdsgZQjSTkF2JPfmP8raeQY1PP1KdtqSHoxg636DbeWR3
47676	payment	1397	1397	1678	1	1	17697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayRT5yEuo7M2MBPazSpsjzwGX8dWN4oKJ9hLmKzBDVQfABZzG
47677	payment	2133	2133	1874	1	1	7240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYco28LEMEHnW9iNckRHN9mpsttBQGo51WMi5Wq4VpZbNyVaR9K
47678	payment	2132	2132	1874	1	1	1884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk66wXJ16qUY3H1R5qLfibMug6zN92WnK6EirbLtvaKBcTpdH
47679	payment	2134	2134	1874	1	1	7819	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcvaUSMdYXr44gM5ohBqqgLvWSY9jHAfr1M7bW47V9jrKXFcA
47701	payment	1397	1397	1678	1	1	17705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3t5XxaJA4QGHkR2aQF6tz8Wc4KVXhHFc3L5HhTep1q9TkrjS
47702	payment	2134	2134	1874	1	1	7825	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyGDFmoxijmdRuNbNRtujCSm762jTWkhsd1ATNCQHLBQ4rtVi
47703	payment	2133	2133	1874	1	1	7248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUezsuftFEGPwDSPEHotqCbUNeZtjwt4N7VnWeZoKXAbje3Vt4
47751	payment	1397	1397	1678	1	1	17721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v3wE7bnjx6ZimERMKVherPW9woNf6seaSWkwHcKZKBQrZLyr
47752	payment	2133	2133	1874	1	1	7264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjjhgYg1gZLUPXGA9jxYEVEDvLc21p6n99dd7HxE9U6NzbuXM
47759	payment	1397	1397	1678	1	1	17724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSUAAhRmry2jY21JEE4AKsEusmuM6LGz9Xicq1MKXxDx5UBkg
47760	payment	2133	2133	1874	1	1	7267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnopwogSuotZGUkyicFmFC31pKXXjrMw79yh8gr3fwVKBZAFd6
47761	payment	2132	2132	1874	1	1	1892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJkWWW8G5ZfoWzswF71bZcAt9YfEj3uPLD2wfTNLqcfGx7rvH
47830	payment	1397	1397	1678	1	1	17747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLtTUvC2zZ3DZd2BHFMVjfi9sXnkwb3KeHyfaMMPbjy4QSz6x
47831	payment	1397	1397	1678	1	1	17748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55GTKiEhjJxKpQxZR3Aveff84ciZCFdQV4yQBykKNYj2JQfua
47832	payment	2133	2133	1874	1	1	7290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTidJB8n9A5rN87CdgcgJT6keZuh2TzikoKefCNdczazogPaK
47833	payment	2132	2132	1874	1	1	1899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaKRCTkYmaiRb86jeyELPtV33yBQbfQtKTi6kAMTDVQCwUiqy
47834	payment	2134	2134	1874	1	1	7856	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRY7MThwu3de6dZAL3nnvzY9BBPqEZMrPcF32FC1aqMv1Z6xW
47835	payment	2133	2133	1874	1	1	7291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyrCqnr2vwb2xe8ssHkKoViQ3sBvJq2Ja78kxDskBqc13PTHD
47855	payment	1397	1397	1678	1	1	17755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSRTppmqUdS5n3GiuNemHCMv5aKjoUSVzTcJkWvmpct9dWqMB
47856	payment	2133	2133	1874	1	1	7298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHvA7oh6n5vqU1wSLbUhVrFrNDMbHBb84duDjJEmzMZ4aiegZ
47857	payment	2134	2134	1874	1	1	7861	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeRZoQxNV9VXCNH6eiTthtq6tgGQzGqDdnSYwg61QvG3adf8f
47865	payment	1397	1397	1678	1	1	17758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4biZ8pZxGuEEpM4osWjWfDjvBdWN5a9xmMk5pzhUJPLachyS8
47866	payment	2133	2133	1874	1	1	7301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuWWS71bWcL32TGMYp7bLgdY9j4ZjHGNHMi4kqrK3CtsPykex
47867	payment	1397	1397	1678	1	1	17759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDe95KJtdYQ81Gb6LFoLydxZCoERQXFChfuLHuCA5Mikw7Dq8e
47868	payment	2133	2133	1874	1	1	7302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkLLrAuyXDLjziSgXPYV3Wvb8em8jT4z5zAENbtUSG9jB4r8n
47869	payment	2134	2134	1874	1	1	7864	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92TjCQ8oFFyqeBw9AotGS2u5dVVTUZXTRgtbf85UdhrvdbKeJ
47870	payment	1397	1397	1678	1	1	17760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdxJUeUe91HLCsEmTirqyqTyg1EvT56VobpzXA6GgETPE3h6A
47871	payment	2132	2132	1874	1	1	1903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPn3gbhd9R7nxA5sGPfYgZgLVXjQtUG944WQBpHfX5rfnTwfY
47872	payment	2133	2133	1874	1	1	7303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhnkhCGQAPzVnNjGurYqoyuUKzbf4g1TC8aAN2TmVXduDUvJ69
47723	payment	1397	1397	1678	1	1	17713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6X4g2oUCxaau7PrSaUrHMq13KSkXZAkn7xdHKT6mByGRggmGP
47724	payment	2134	2134	1874	1	1	7830	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxi7einrRudZXVrY4zwRQWrwgYDMph5HxMCPfqZD7XA21FsXob
47725	payment	2133	2133	1874	1	1	7255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaV3Nz57yGipcZGg3V7QdoJxp9B9Ls7ewh5Zzcfnrv4AXCd5m
47726	payment	2133	2133	1874	1	1	7256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFVzPp6J9WWznJvcv9mrfgNtvK3oByqzKUhx3PbRav7oLPtnR
47727	payment	1397	1397	1678	1	1	17714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZRdyLDaKwriry33uLqL4sXopGwFn3JcBTqCUF3t6M7Wwki3g
47728	payment	2133	2133	1874	1	1	7257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDMbfYUvcERZtqe7Vj4k6GJgxTcso8y2D95sTf6c1eg1dzFu4
47729	payment	2134	2134	1874	1	1	7831	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUPwKx3S2hBybiuVPjoQCPq3KkoR6z5ffVpQCA1DYup1fkyBd
47730	payment	2132	2132	1874	1	1	1889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznGaWvo44HQwmsBUnbzp6UcrBLiW4Gc7QwR9oiWXNFbVPBRSP
47740	payment	1397	1397	1678	1	1	17718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBU2yH6tYBkk5B3uifbmsR2M3C732pNhRLAR1Rf7YAjCKsvXT
47741	payment	1397	1397	1678	1	1	17719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbDB3fsiWnTbe8h8yiPuEryzT6rpnMCBPuqdTKubvfY5tPj6J
47742	payment	338	338	2403	1	1	3	990000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZogW1utJqJbaufCcEmSqC1W8LU1pfNa8viUt27jeeeTz2HtD
47743	payment	2133	2133	1874	1	1	7261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyUrSjTSvNo1A74e5gzAAXwpSRFE4p4rWkkerbj6gCYKFukq5
47744	payment	2133	2133	1874	1	1	7262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqq2SrejnA8bN5j4PMkK5cTZC61gUQNcCLofzQEdRyuqGTKeS
47745	payment	2134	2134	1874	1	1	7834	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysTH1AtgTnavK2tjzX1fSC3xiazdetoX1wef6vJPJALFYJBLX
47746	payment	2134	2134	1874	1	1	7835	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SSnhU73uVzmq91d9ZBrsSo8tRaNRc61v8sUGuDF8VAwW9n8h
47753	payment	1397	1397	1678	1	1	17722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPtdZ1TAkvwg8hRCx9u4cQ2oAK1wyaSvEymM4HQBnVYJCFvb9
47754	payment	2133	2133	1874	1	1	7265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKDHAGksRrMjtPkraNC5mKf9sytrE9E4y7vEhMLbSpFGy9AzX
47755	payment	2134	2134	1874	1	1	7837	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggEm76X7MxmbrwksS9f9ZdgfYgF8rqUWU7GUNNetFvbKhHbj3
47762	payment	1397	1397	1678	1	1	17725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCZzivWrL2hHsn4qXF2DY7Yiu9e5RDtEYbi3nsSY2kKNwdWme
47763	payment	1397	1397	1678	1	1	17726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTMtU7bDszKYqrbDhudT7my7XCJgtcs2quUD3xNMXkFnBG93E
47764	payment	2134	2134	1874	1	1	7839	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp14GuV5YpooeZzajijisH2HdjW4zmsdStFELmYS79xKEHdGnQ
47765	payment	2134	2134	1874	1	1	7840	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqoaCApHpwKbo7P5Mr3G7XqRnP5BSspSYgmpZC4Nrh9x3akP3H
47766	payment	2133	2133	1874	1	1	7268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzpAoZ1BHG8LtZAgieZtsrdGgmj8ksedyyRPxwUp1pVBzKFJW
47767	payment	2133	2133	1874	1	1	7269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoxs5zHDidVLeQet7o8VBstBbDjWAa5TJRnxECD3HNgnZ1cce
47772	payment	1397	1397	1678	1	1	17728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tmRqGKaqe5xGFZaK43hKEN5gFm2LS28wRxdLKajmUbymCF8u
47773	payment	2133	2133	1874	1	1	7271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdqBUCc55fn1HWrQyw36EFXHFnFcRb14m3QbViswraQuR9ZwE
47777	payment	1397	1397	1678	1	1	17730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHg587axkcATP4HGJsds4SPo5Fx6wEGBPc3pZb8m8y3KXL4iUG
47778	payment	2134	2134	1874	1	1	7843	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuhhaq2jSJrwSrb8BXhtdd6VuFpHENH44BSzdVVnUCDUd6em6
47779	payment	2133	2133	1874	1	1	7273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MaRgEEsFQzk93hhiYLLuKwoCdewM8ijwffCU5yT9Sh6NYnxX
47780	payment	2132	2132	1874	1	1	1894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63sXb6oaSba3sf7VXLgnvv2dcBNYd6ffbXsc5AyU5PNbAQLs7
47789	payment	2134	2134	1874	1	1	7846	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwmsQKAsY1mfYoNDwpWQ8u63RWm9BuR1EStGADVfTUJK3DBx4
47790	payment	2133	2133	1874	1	1	7277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcx6fZtvj8T6AKT9hAGL67Yb9EBMQs7LH1PxhQeLtQHP6mKSgQ
47791	payment	2132	2132	1874	1	1	1895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNczT4LJCRJS74D359PPLSBJJnXe7nTe8gZaB2B6Ka5WY9TS1
47839	payment	1397	1397	1678	1	1	17750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCno5PDFVqbRR1BFgNCJDRSSgod79188AfowXhWqxNypgHswm
47840	payment	1397	1397	1678	1	1	17751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYir5w7BxeXhM9BFnY7TeVFb9qbBekj4nmTLVyFSa7HDsAgf3Mn
47841	payment	2133	2133	1874	1	1	7293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqthaETJDf2CDiC3QrkgyKAmuCkjRyRXvrC21aTtw7APmhuX7w
47842	payment	2132	2132	1874	1	1	1900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmTTWoqYsVymyiVxAg7TiAh9Y84hSSjsQD2vAuSD2gyuRRo2G
47843	payment	2133	2133	1874	1	1	7294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLma2rQvYSWzfEcbW8gUd9tt8wYVYqFpY5Mw48jrxK2UTFHeQk
47776	payment	2134	2134	1874	1	1	7842	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRQVmwVWf4JjoPAR2P5Yx37akYhNsgCFWFv7gUiymBS4hi8Vu
47792	payment	1397	1397	1678	1	1	17734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGnaZbWPABJMq2rGyiRV1uZBNvtCRKoeLAUwbE36rmBrQxDqs
47793	payment	1992	1992	596	1	1	5	15840000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStEUNGykoX7nZcH9khTGeHkLEa9N3hPExAxUkKjV6DRoyzDaf
47794	payment	1397	1397	1678	1	1	17735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSswPbbpUwSTj9SjmsVKF5FxgKhoUpoP23xrHkYGRacaT3Qbf
47795	payment	2133	2133	1874	1	1	7278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ3gaAToj4hWhAck6vNj31jBPmw1ZQdqzbsKikexKjFudXeQk
47808	payment	1397	1397	1678	1	1	17740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwUTVSA5q293tpHuwLkFkg4BqEpfBrU2oXiWsrRYAagpvs8Az
47809	payment	2132	2132	1874	1	1	1897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZer5iVTubXB1aiPWDfqiVbaFcQwuMrRDn2Azo1n7KsRn5mxBK8
47810	payment	2134	2134	1874	1	1	7850	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFsjV37mSu2Af5d15MxU91V48pLTcUkWXXyYDjKN9bnDtZVrE
47811	payment	2133	2133	1874	1	1	7283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL53yg5Mu7Uk26dtT97s8ohWp7Npb3oj3QnXLybSzFMmhh71Mf
47812	payment	1397	1397	1678	1	1	17741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycNGZ3v7CaRrAxFFFxtSPUjZspMAiBR5ucHAZ3CGVZbPHkokB
47813	payment	1397	1397	1678	1	1	17742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54SSGaLe6Vcu8VfYik3qfn1d58bXAc99WBw1qCt2Zaw7HnzAu
47814	payment	2134	2134	1874	1	1	7851	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSeD6Zgw1mdAp7QaqERaxrxH298n3ztsS7qp5EA8Z9Y8Yvd6H
47815	payment	2134	2134	1874	1	1	7852	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1LEVU31hvQLorsoCmNZZZ1nQfBaLS7cv39ssk1xFv8gWg8FY
47816	payment	2133	2133	1874	1	1	7284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqR4gX9VRGqJBKw5tj3QAskBULtnRxHUjVYKKdGCrYAx7yoHA
47817	payment	2133	2133	1874	1	1	7285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqahL6WcYzS1vfUrSx7bqWG7w2LRSyesoGf4pUzEGdvu8C19FE
47818	payment	1397	1397	1678	1	1	17743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKGRC9coTpKjZJBK6SvyBYabEGs6LQsUeTfAGSdvGoFTWi3NV
47819	payment	1397	1397	1678	1	1	17744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbXk58NFrCMwhrnAksNQxGQaUZuWF7maMj2R84bFjE9JBnXde
47820	payment	1397	1397	1678	1	1	17745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDVoBnPubYPAYdJC1krrfWJsZQuBo5tc9S3o1h25CXf6tQAuN
47821	payment	1397	1397	1678	1	1	17746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXrhUaxv4P7ifqKocJwSHPSMKiAr47iH2MDeGfdaZe4kYaFom
47822	payment	2133	2133	1874	1	1	7286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAr1Nxo4wZ4DazYQ75weceHig6qcjHjFxByTDzizcW6iYFSia
47823	payment	2132	2132	1874	1	1	1898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmmymXdizG6j5n3A7L83JoFXkCt9etKBFtF8yEpV19JJ2Xkii
47824	payment	2133	2133	1874	1	1	7287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa241w9xEEmg7VmiKzTWuNJ7BocuHKMKoJ3uoztxSB69tNcJHX9
47825	payment	2133	2133	1874	1	1	7288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErnbXfbpc3WFj7DhHj14vuqUrpiD9nL2mYrfJ821Hk619P2MJ
47826	payment	2133	2133	1874	1	1	7289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuB2TAigJScsfMrtrPwTsamMEj7ne87C9tGt7gukFRvoFqTHt
47827	payment	2134	2134	1874	1	1	7853	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFeZiJZ3f9aYnbmkf9XqfMtPuZVMVC4RRfR6eFfUNtd3mn729T
47828	payment	2134	2134	1874	1	1	7854	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xHWGdXz4tA5Vud2PoYUB6WmzEJxer9WWUJBhudcGwRj9WUdR
47829	payment	2134	2134	1874	1	1	7855	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdqLAbfvMFbnSbfXS7wDVnVpnA1a2JCMJoJUHKF6kBd9soxaS
47877	payment	1397	1397	1678	1	1	17762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv7kWF3KCF6hJPa85SALpsJdG9yEja8AiiYqkMsK2yjSfa5ba
47878	payment	1397	1397	1678	1	1	17763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXFHazYMyiGkfqhMNcDBmjsfFCCk9ykzsUkv9f4MxBbHRi1qM
47879	payment	2133	2133	1874	1	1	7305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXxUwy7craRHUZBAeCjoE81kup5Vrap7FJdRWFZZ4inxinVg4
47880	payment	2134	2134	1874	1	1	7867	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSanspQJwMcExbXFb4okE1y4n9Nyk71AELK4iq6SuKSuziwtNX
47881	payment	2133	2133	1874	1	1	7306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoy7F1e7H7CV24mMKvDL2dGq9Gw2dpvcLTyGm1ijY1TnM9nXeP
47906	payment	1397	1397	1678	1	1	17772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9YXgHD9MBd8QNqeF7azH5zzYjXBEmcQBCUP8od8vtm8RkKxX
47907	payment	2133	2133	1874	1	1	7314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8p7XYqQ2mZMKqRovuKuq1YnwtF9umc1Pa73AKfGtWHCYAErq
47917	payment	2134	2134	1874	1	1	7876	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Nojjfj4jABztxYqFYVnR6kCQHdY1KPYtDkUk8gpTf46GCajn
47941	payment	1397	1397	1678	1	1	17783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcn7uQRJfcfMEMgxZxbGWfbYxQrEcXjDbVD4kPF6zwyic2agG
47942	payment	1576	1576	605	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ejUCrTzWZv9A6uUniCRdRwTdXjk2ZZK8xYMhMrpxA5PzhYKg
47943	payment	2133	2133	1874	1	1	7325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvWrHGSGEz6K2tbN3VxNJFTfvVqbw4ip4ZwX5y9sg6J1uELJb
47785	payment	2133	2133	1874	1	1	7275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu23RQDiMUYAGj2LQtVTQQehyGWXnSxDhwKMP5jXynCRWRx8j5
47786	payment	1397	1397	1678	1	1	17733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwjeScpYrUtZ1r4xvXEoR5158rQn252fjfKmWDEqsMndVchaL
47787	payment	2133	2133	1874	1	1	7276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGEpTB6QHNpvtASL3LceEBahSW6Nw9o4kMCRPdZ5xKtoytaeE
47788	payment	2134	2134	1874	1	1	7845	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSw1ry2Z66AGQqngBAkE8p4p7dct1gCmE9CxsYhP9ztTDypbc
47796	payment	1397	1397	1678	1	1	17736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjWMigdoVdutSovbmzn6CkpFf7LfDtyiFA4rkYuQfD8NUThX3
47797	payment	1397	1397	1678	1	1	17737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4DT83WFx4cbfPq2s719WXxc4G3zgxj15rPe6TgbEo9rZ6eeQu
47798	payment	1397	1397	1678	1	1	17738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BQ7S1PVnePWb5goBBwGnFUcHot5bWzqN3XSURV8ruo1FWrja
47799	payment	1397	1397	1678	1	1	17739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ9QvMP69USrDTf898jYeEbJH7Z2onadDs4uTdX2i2FL6aFr2
47800	payment	2134	2134	1874	1	1	7847	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdud1oJnC3AzSoaueSATkY9Sjnw5ssFyvzv8mhmaixYVnsvZz8
47801	payment	2134	2134	1874	1	1	7848	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajeHf4vXyKrbxCNcGWqkLfnPiNtqKWheGPHqnLU3XkjZFYuLd
47802	payment	2134	2134	1874	1	1	7849	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAsztBMCEATYCtcnS6Smhi757h2emw1UE6N9sBMpPsrwd5YFb
47803	payment	2133	2133	1874	1	1	7279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXKPJBwLJHKaJ64xV6EL1KNPCo5i7oXxgYFuvxvVnvFjeQZ9t
47804	payment	2133	2133	1874	1	1	7280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGzUr1R1XZntLojQC4nCPxh6T2vW4ZYbrzMcF8QyxCnmPVc3Z
47805	payment	2133	2133	1874	1	1	7281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDccCsh7cFvnPb75nkSKaVSN9uTRpKUmNZeQ8NU1Yaqub5cde
47806	payment	2133	2133	1874	1	1	7282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKq7ZJKugZUZ7Kqz3CGJgcyGzmoJFPKsLy5QU3oHMjCaMFQH7
47807	payment	2132	2132	1874	1	1	1896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TqZ74y1ycF4hP7DW1hh3XjwqLtww115njvC48Vxut8Eza16k
47836	payment	1397	1397	1678	1	1	17749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXFiUwGv2ZAxu3WqZ8MiYyuRa5BdEjRHHJ1pHj3ysuBKE7kfc
47837	payment	2134	2134	1874	1	1	7857	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvH8uavKcuYhGwCVkHhbsdhPuxJm8EoS24HLLCaB3uH11jNorb
47838	payment	2133	2133	1874	1	1	7292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1LKiTP8PjQPqqG9fPGgoEFJsWWwGVkcoXeEJVf7Xou5WM5ju
47845	payment	1397	1397	1678	1	1	17752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMFQepjCGYSX3yyL2DN5EfPeHH7den3db42Nfy3iFGEPRiK5h
47846	payment	1397	1397	1678	1	1	17753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnPcosBfSB3RGFWTTRYdJvPdzKh6EYTaDt4N9rJ4HHAui8ZGg
47847	payment	1726	1726	2418	1	1	8359	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYY5KpGQRHn9kxPtBwB7KDGuZvowzccKpqMh47uEum2qkYF74gG
47848	payment	2133	2133	1874	1	1	7295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YoLsRhX1Fx3hgiAfrhcgTwBhMdr8vpkAvXAXg2rcXAw2icbQ
47849	payment	2134	2134	1874	1	1	7859	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBJfhH7c6vjsFkpY1Z1LBGwFEqCaTuDKzMmNRtebrn7hGZQvD
47850	payment	2134	2134	1874	1	1	7860	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fFBi1LoCpt34cTvCXgJdNVymuybYbHCaXEgariVUzD4PSPF5
47851	payment	2133	2133	1874	1	1	7296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAMRoohi6ZN63MKUBCQGiHYqR2CaPqpSVzkqDoEo71izg222n
47858	payment	1397	1397	1678	1	1	17756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg132mLsj2YqYW8DadmSDQ1ixRkJQgHKan99Ht4cKqwgdJh29c
47859	payment	1397	1397	1678	1	1	17757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLzBae8G1CPajqYYtThwmmeMHMXpExjvo9cDRmFr2NYfdxcAJ
47860	payment	2132	2132	1874	1	1	1902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSo6Wzo88NZCcKBpUAxGHrZSyztoY2LdnZLYzbA9HHVCtexMnQ
47861	payment	2134	2134	1874	1	1	7862	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiyxBtu6qcvAMiPig5P73YZpRvLKTbkVP2KwPXUnkrZGczDnT
47862	payment	2134	2134	1874	1	1	7863	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS4NMczXdLkwGW7A2vAG5xcdTqJnDAjPqaqAudCSkC16i4fkhj
47863	payment	2133	2133	1874	1	1	7299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNqiTvBXjzV6TV8nD5wu6xT7zvQHcaP2DqEVn54G3Z6thwkoS
47864	payment	2133	2133	1874	1	1	7300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQd9wqZTHuHQB1voxF8WF1kkGXjNquf3MoXWALPK9C2J8chqtT
47886	payment	1397	1397	1678	1	1	17765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxY1kHW9dVTngvpDEGbPiyQKhtfZrdn9vNKTewCEf1Pjnwxfk
47887	payment	1397	1397	1678	1	1	17766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHddggtEU3YFLChGbLmm7nFthx3VbPxzxTU1YyceqRW9HTwKm1
47888	payment	2133	2133	1874	1	1	7308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3bFy7x8f3YBxuqPqLxrD1R7ywR5vGSU4vS3wBBr6eVVVkk35
47889	payment	2133	2133	1874	1	1	7309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKv3W1q5joGobJDHVDJtKMrJpHXYvhXz866rLBhoGGUSY2e79T
47890	payment	2134	2134	1874	1	1	7869	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxQwJKG4L3t32emo7ByvMdFEWpWNS4NGpnaFnaX3AKP7aaoKp
47844	payment	2134	2134	1874	1	1	7858	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hdZhkR9NNCPD2G3v3JhoSgh1wVhh7UtCpaqhiHeBoqwQKWcX
47852	payment	1397	1397	1678	1	1	17754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMKiU8Ek1eS39m4hNnqCwJQoNFNYSxrTG8sgKw5oTtrRcR9VN
47853	payment	2132	2132	1874	1	1	1901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBgQZLD6Ww8UVHAX92Ug4L6rL93WbNLcxubq6bvTc8mQcZP1j
47854	payment	2133	2133	1874	1	1	7297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4gXE7fokYwsHhMmR28JAgSuhB5zFDXjayvoYgYzsbqBke7Ct
47874	payment	1397	1397	1678	1	1	17761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhASWfMFP6zWFM6EeCVj8ttVrX1bXAQcJLRAcqeNco3x9UuASu
47875	payment	2133	2133	1874	1	1	7304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdHxinuwX576M9YvN4ofsJFpcPj7WvABb7JrbE1GfLUkwtMQx
47876	payment	2134	2134	1874	1	1	7866	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebvkNiS6QkMtuv99MN3MqoE9d9grApbqkafHjVD5eFGD4kod7
47882	payment	1397	1397	1678	1	1	17764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoHzrMZyMnVBZVBKninzbnaWifwfNQWNWhz281rcga6wNqVLo
47883	payment	2133	2133	1874	1	1	7307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxhQqXG7RqsrPRDT4YKXcvDKaAiFd98bYP92jR8c3XskxjWYS
47884	payment	2134	2134	1874	1	1	7868	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfPexyJ6CDTmP5RbQfHWs9A8fp7ePdrPNaoxGasv2NBytAaQT
47885	payment	2132	2132	1874	1	1	1904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMafr8HvqXBF6dTMsCpnrDCXeV1ZYFnVHjX3RcVXThBJnX3qL
47911	payment	1397	1397	1678	1	1	17774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezcemyQhknEDnYnMioxYw2xPfKQycFmsUceB5AEW8PgWqNzqM
47912	payment	2134	2134	1874	1	1	7875	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMUAZJ9Cdg9hxEdQgoi1i8JuQfJ68eZHJNLvoBkhS5VFFSF5u
47913	payment	2133	2133	1874	1	1	7316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqF6JmHjuzFvK6uLcFfNecHPpKmdVKd3FBMu6PtDnHZ1LzZwFE
47914	payment	2132	2132	1874	1	1	1907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzfrXSnmaZqv9kQgp5mjXCKmZeqt6ALYbHmgYyQCCbjAg9pUa
47927	payment	1397	1397	1678	1	1	17779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8DvUmwRGGF9PAFmbTauakjaYNe6JZMYiLgLxeoasdFW8ovk4
47928	payment	2133	2133	1874	1	1	7321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcnJZm3oCCvouY59N4aDM7pQh7CUXQ3eaQNafBS9Hibz6Fkwd
47936	payment	1397	1397	1678	1	1	17782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTUWkhfkp3bUMtrGEbbJHx9516qvjXanquNSs6PePmX2RyQhq
47937	payment	2133	2133	1874	1	1	7324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUZeGfnrcXdD6jbCyBiFuhFFoJicMBgvzSRRga7BU5M9CCmfM
47938	payment	1419	1419	2419	1	1	8	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoujspcWXCz3w4HpqCZJ4oj5Hy45EZyNkSDiJ3W2HLcQkNayww
47939	payment	1419	1419	2420	1	1	9	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2vtg2BR1BPZzGndw8oXHJ9P25hcYxskbK8N6E4qkEXyFVPwD
47940	payment	2134	2134	1874	1	1	7881	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9ANMdA1AEj7z8QHRHgBY9xWW8NH9wxmV5ze5j9MCHkxxJ9md
47948	payment	1397	1397	1678	1	1	17785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6LKYTKLFYtNT9444aVE63rhndSmaHQyoa4EnEsEFUxbksAgE
47949	payment	1397	1397	1678	1	1	17786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ja8hNg6ULetCZzJUnwJVNDdrFa2GEEMcVNbDCMJYimE6Ehec
47950	payment	1659	1659	548	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGfNwhSKShbigztLP4VHbziudfMWe1Ai5iXmJ4nBDZ7MDjUkH
47951	payment	2133	2133	1874	1	1	7327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDdycNiDUZmvosc26VZmKoY5CFH7NjWrnwestk8gye1ASXtbx
47952	payment	2133	2133	1874	1	1	7328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8KEWsGE2u1HmjVwUys9Y8145QXqTpW7GnjJT6ziVfxXTcMjA
47953	payment	2134	2134	1874	1	1	7883	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jDkXFCqZXyXKjdfaQv5W19qBsMFxEgTKvR5drBFAksmDZG2X
47973	payment	1397	1397	1678	1	1	17793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqWKqMizrn8KU6xHkMisKdXz6LXM3bysYVqewn9no8GpZRRjq
47974	payment	2134	2134	1874	1	1	7889	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GsVwvkH72vGQFUwvLqHWvAAf9A2N5L56DDZwn8sGVbKFEftx
47975	payment	2133	2133	1874	1	1	7335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmxoUAbi4qRxCyRE1T5TPjH6aJMoewMo2ZTffb4oL1gcDynCD
47976	payment	1397	1397	1678	1	1	17794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyZFW2D1uXsna4eUymHaGffBvNHbYjVEsUYaNhABB54xiiKZw
47977	payment	2133	2133	1874	1	1	7336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfKCu9XrBRyFVUYg4VpKE7rJSS9LAMQJraCSNtPQ9xXB1jkXu
47978	payment	2132	2132	1874	1	1	1913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oFxpLiPYWC75MFyE9Ek24t3t69bmfRWjLLKe5hgxN5uzrTvh
48000	payment	1397	1397	1678	1	1	17802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2LWmyXNCTHNzG6BFcaJxskaNV3VtuDqfkwQyw97PmQjX2fyV
48001	payment	2133	2133	1874	1	1	7344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzfZ4eZj2FuEmgENZFARGn9huvn4A6FPS9r68CexnqSpbcZXz
48002	payment	2134	2134	1874	1	1	7895	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLpM6Kxc44wQfYMrg4CC82FUrtmUWs43FBb8uf8E4jbe1JBB2
48044	payment	1397	1397	1678	1	1	17817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG24EnirmUZknTxYsi3Z3q37SAqFXXJquCgKZi22UrTee3xZ56
47873	payment	2134	2134	1874	1	1	7865	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWKx7T7fTZsFpsKJSXdbKDt5iYCjAG16wgWfqJKzd2zNTkHUz
47891	payment	1397	1397	1678	1	1	17767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUm3cqRukUMon7z2nEHcpP9EAqJMNhAogQVZEm4NxpK4sZKFK
47892	payment	2133	2133	1874	1	1	7310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsG6rXBrvKVWy8ygJzLoLgjMqXPwuuu3FMT2zQrMMVCcEC6aD
47893	payment	2132	2132	1874	1	1	1905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZ5hBFULPQPDq5qvfJ1dMYi3TYG4wZ124Gnrgyz9PLYP9D8X7
47894	payment	2134	2134	1874	1	1	7870	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWTH5F2MX6tF4s7WMdtmveZhqmA1rBzVsizXs9GXQvuyrok3e
47895	payment	1397	1397	1678	1	1	17768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSV1XnE2VvkAKgAzzzZMPgtXCs2gik4k2XWbu9qhUnz7J2XgCc
47896	payment	1397	1397	1678	1	1	17769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpSQ3xdi6dk31gbpQPRuWPrJYuiD2FPtafno5ZsmRLUzojnRF
47897	payment	2134	2134	1874	1	1	7871	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBT71AxHcY8fQd14pYH5So1WcJreLAjzB5ibrsgrZCGDCRV8s
47898	payment	2133	2133	1874	1	1	7311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhd6SD72N8LBRK3yf5UK1As4m82uaHnb6ekDJ6QRSPNotxtY1K
47908	payment	1397	1397	1678	1	1	17773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhKKDYycbmBmFRK4zDcbnLFfFVF4R8u5hpzWFpYbYHKro3Yzf
47909	payment	2134	2134	1874	1	1	7874	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UyaMUnnY5fLjAX5z83fmL2Lzw4hZwTEq7jRMtwGNJhSPcgQW
47910	payment	2133	2133	1874	1	1	7315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2h3VDP5a2n7CmTFyANL79n7eTjJe8V9vz5xvkqSGDhbNhGCN
47920	payment	1397	1397	1678	1	1	17777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTtvRdoPdfok59WQBSJ33tXCK8k6P3ymrkBDT3oceqKb2hbF5
47921	payment	2132	2132	1874	1	1	1908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDW2G7YZj1mn2W2nRvWLK5FWqsd3Z2yHi5XgZWoxjdidtWBvpY
47922	payment	2133	2133	1874	1	1	7319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZojEAz4DkaJBt9Wv647ft5imH78M1FeTUuqNGfJqa6DBUafQD
47923	payment	2134	2134	1874	1	1	7877	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTht5mt59rDVEtADa36dW7kPfGwLLC4FntAiJiyF7nijReazB
47929	payment	1397	1397	1678	1	1	17780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74u4dQcxY2rfUc8JJD9WxarVxAiucNEai794eMKZSLfFz92mH
47930	payment	1397	1397	1678	1	1	17781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGCGNqpcZzWfy6unuawgjehw93RHj2mDQZm3UyQJwCiFnJcNT
47931	payment	2134	2134	1874	1	1	7879	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWDYcaKwTX5AvYv9UyAYjLnp82jXLTJ7w99RGjAzb9MwPuGta
47932	payment	2133	2133	1874	1	1	7322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiNwJTHYKQxFNNRVt6pgEvWvsj1K3PCfhqP1Rab9eGcvBAk6X
47933	payment	2133	2133	1874	1	1	7323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLZC3wrwh6Pmk2fgCdJ8a731qFGzgwVQ2iDNT58MDW5pZ7kjJ
47934	payment	2134	2134	1874	1	1	7880	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMkJWKgnLd37CkzLdSuMPWkMCgBhpL8jNjQFfHGdGDqSonpAV
47935	payment	2132	2132	1874	1	1	1909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuRyoXTrtRMWaSwMhJzPxJ8JKwXtq3YvHK3Z6aNYDHZ2JkFwC
47944	payment	1397	1397	1678	1	1	17784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTVRrJK5C5P9aKCuxbrJXVt1WyQmTQJXzT9PSEqWB8cXZuMTQ
47945	payment	2132	2132	1874	1	1	1910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbJP6JnS8eFHCX41ssaewU5rpyn6SNHSyfTrcqJ9NLBsLznLP
47946	payment	2134	2134	1874	1	1	7882	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCAxZXnuX9YqWhUR3juWFsYcA3hQ1JHDCZfPdCogSZRvYWpnT
47947	payment	2133	2133	1874	1	1	7326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHm521BPr5gqAri4jL4B42tFhGJhxkEKA7qsb4NzGX6XZjsV2A
47954	payment	1397	1397	1678	1	1	17787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Y1mVyY3rdGoxgxsUe8gq59i9KteTqBfy4AKvgqExnMYy3u95
47955	payment	2133	2133	1874	1	1	7329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcVPFSvtrcrmxVoCfbvn6kL4599M6ux4uhZhFSnGW9n1uwYPW
47956	payment	2134	2134	1874	1	1	7884	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuhG8ukfP3HDZ5MosFPW6eQfsDSRd9CkjPngZ1zQxtTcYh9tG
47957	payment	2132	2132	1874	1	1	1911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpKGBKNQo36F6u7TwScYn5wJHkT4m9WxCAVqiNMnWqFd87R1j
47958	payment	1397	1397	1678	1	1	17788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUcnGxymDw6HDbochBSKf6nfLK1HntPswiBZ4R2aEkuLdWywF
47959	payment	2133	2133	1874	1	1	7330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFTiuhsvUipPZiJ3bNNM5rqNFt4ttRBdM1cqz7X1MhGeXyaYo
47960	payment	2134	2134	1874	1	1	7885	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyrLen4HAFMw784M4uzrb39L5fhWFzHtisa4N76hwu4CYB5NY
47985	payment	1397	1397	1678	1	1	17797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe96LqvfQCYKXvHUzf9yvQsR2kgSmDVXkbN8Cy7LJkGAos1ivU
47986	payment	1397	1397	1678	1	1	17798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyewPwA97v36A1Jb96SmKyc3dt7g7kMZFycKoJrnooUAM3ZoFB
47987	payment	2132	2132	1874	1	1	1914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9TqwJt7grcKRPEXWxwKoGwaHs6VRFxz2zYPJ9TMKfgdkUXKv
47988	payment	2133	2133	1874	1	1	7339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphE3cwufc9PLm9GhTYZKBH5HByVMCZa3JemVor6qaerc2mPfk
47899	payment	1397	1397	1678	1	1	17770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcp71onpFetSyNUJP19JkX4Bnmc56Wh216XdQ3EzVEsiYxgiq
47900	payment	1397	1397	1678	1	1	17771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX59gXgR9XBLZan3kT7KGM4asrmwhzsWPpNrKVQ2TYj91qvSRF
47901	payment	2133	2133	1874	1	1	7312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkRR8H6wYSPEUwzwQpYcUWTCJPD93NZo2Syj3YXUFpTJt95vD
47902	payment	2132	2132	1874	1	1	1906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrkzFTPAFuau5D3r6Auc6HhkK1GnbsYWgC1SEZatky3Tw3b8v
47903	payment	2133	2133	1874	1	1	7313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36BT95jRyB3eEuiEugCAp8mj76UpaEYpuMyRhtYgNGL2N3UTq
47904	payment	2134	2134	1874	1	1	7872	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkQG7PRSMHe9cakGeBiLmeYC3L4KzhjD2Uc8A1YwL1Fajm9QR
47905	payment	2134	2134	1874	1	1	7873	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauL2RgFKRdvtdFdhZkBEiiroVzUiFGkpxsjtEgtCBsqNpnytC
47915	payment	1397	1397	1678	1	1	17775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYZdrPsgJYw49NYfVFWL8UpU1EtouDtceEKHtMRXZxgoAzuWt
47916	payment	2133	2133	1874	1	1	7317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDGeDDPLtRPFSL38dkR9nZsFy7LzfCLPXAQkqp9u8cCKpX2b5
47918	payment	1397	1397	1678	1	1	17776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhg5AgWQYU1WAWAyz7AuKCQbSF52absC3PpRUGEBvK9ieLuKq3
47919	payment	2133	2133	1874	1	1	7318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6kGNi8ZGTCiy94ZMwbFX2n6jBgcK1RVDE9TiBAdXti943M1Z
47924	payment	1397	1397	1678	1	1	17778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7pp6jF6ytMgQFd1X5x8jZE24FsaGQkuFVnAKPKSKgc4V3He8
47925	payment	2134	2134	1874	1	1	7878	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5GUJpuAy55XRcoCv1kiPfLfw7s2zgUDV7aAWgp6drFv4r5fD
47926	payment	2133	2133	1874	1	1	7320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2bF6ZmiigLihZYwTYoq1MzuY7bFAJaFRzEKBx3GwQ2n4o5Z3
47961	payment	1397	1397	1678	1	1	17789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RsHjzyDC9JTANMFEYugSGZbw8jbSospPgJLeFnRPFoRPCYmd
47962	payment	2134	2134	1874	1	1	7886	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxwTiLmuPpGEaubatksDhg6wGBgrhoGu698RZpiXJdEvaCWk6
47963	payment	2133	2133	1874	1	1	7331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAoqgsY1aAzwZBYZWv9Jjv39JbtFiU8saTmq74z55Tm4BdCGC
47970	payment	1397	1397	1678	1	1	17792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuZqLxJRccB1aqy57ifNs32jr1RBG3ifepYDWeXhH9WMiv47A
47971	payment	2133	2133	1874	1	1	7334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcPpZhrY1a2aaG5YgFnjfosRB3YQmp3P9b4upD92vp63W3jBp
47972	payment	2134	2134	1874	1	1	7888	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwCfetGvMGrs8B4goFiGfiPZvHxz9quc4tX5oDWhRE7vod1My
47991	payment	1397	1397	1678	1	1	17799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQrGjYLhHv6nHVQqYNY6ir72wbwfcV7ZJ4cG31SFkCgnh15rA
47992	payment	2133	2133	1874	1	1	7341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H5P7U64SLU7ov5pa6VJt9amZpasHAbaUwcF17Eopw7JrqcPn
47993	payment	2134	2134	1874	1	1	7893	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhGwoRse6CMVrCQ5sQevLk9HgGkVHigXwCM3f34BZryUAWmPX
47994	payment	1397	1397	1678	1	1	17800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe9Fzgw7gsAcpSYXQXtBVt3LPjcx5RPc7HCxjwuR3LvuYiXFT
47995	payment	2133	2133	1874	1	1	7342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n39LYTawfHtTsrtG8oc9chgfnYtg7Ecn3RayRnWRxXjPKs8b
47996	payment	2132	2132	1874	1	1	1915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvQRPqpCHzAZU7deacdnTpz31egq7tgtyVruadnyNSRKqWaYW
47997	payment	2134	2134	1874	1	1	7894	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo1yDgg3dJeRw1X8BnqncqvJFfVynGow2V2YihgAoFkTJ6fUM
47998	payment	1397	1397	1678	1	1	17801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGC4To39QmW3VuRVU81Vx5ctD1KxPZsD7am8Xkkoz5B8MCaK7
47999	payment	2133	2133	1874	1	1	7343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vA8vHKArjsi8ZG4LGk23HtNnqMzMjGtmhAoM722vWEX8estP
48006	payment	1397	1397	1678	1	1	17804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvK3fBifsdthe4LLPZ7Pin5Exhcr7LAF8oQosWphKmKrZ9SSo
48007	payment	2132	2132	1874	1	1	1916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38oQTcr4rsEAVvzE5cFjkUNr9zF8p4DVzBZ7y8H4vvxEd4M6o
48008	payment	2133	2133	1874	1	1	7346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9XKQmBEyAUb1kKyqKjJkspssyeiFY31HDdmdwjyzHGwoqyvA
48012	payment	1397	1397	1678	1	1	17806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5BGaQBLN2Zniux4VAFuPguTXpzb5UP2QdKVZtGzvoYzzm6eZ
48013	payment	2133	2133	1874	1	1	7348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1df7n8G9vVvK4u6YykKakqbUi8ZXvhxfDZXRj74PD3D1Cw1T
48014	payment	2134	2134	1874	1	1	7898	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1bCGo2LA7SuxsjxDFsbrLigHn2YomJvJTbkT3fF7Ax5HU5Cf
48041	payment	1397	1397	1678	1	1	17816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbvskXBuXy6ysU3CziccioTU4mwCkKNwT191tQQR7djE2gJm9
48042	payment	2134	2134	1874	1	1	7905	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCc17RjQ3TgNeySCHhbBSByATsApf9tsE6CGcNVt6XgvqeQWA
48043	payment	2133	2133	1874	1	1	7357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCowf7ZKLGWPiHGNxAo3doiJajuHQ9vRYq8YPiXKD41Y41dzP
47964	payment	1397	1397	1678	1	1	17790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfa2JU2LKk4BREZXisRTPNity3NgJCUB94TFGKueyXrrFFpwmT
47965	payment	1397	1397	1678	1	1	17791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51b3EgmEB6n5VNMjzRx2GqNbQDYP6AYNrF4wF5xLBqhKzC4Kb
47966	payment	2134	2134	1874	1	1	7887	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XnKhJHFyjo336GJ4Qw4FkcQ4uoL9GXPD2VNZwe7PvJJhxaKs
47967	payment	2133	2133	1874	1	1	7332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrZDuXMshYjNhJxmyecVcNeyXWdA5D67CNTcKUV5At52vNtHC
47968	payment	2133	2133	1874	1	1	7333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsYPRpbRhUMr8CW7xNQAvTKc2mWwtoEaDyd2WRLo6V7SGH34s
47969	payment	2132	2132	1874	1	1	1912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwZ7BbJx8isvfpSNvnTRAJesX5CD25GyF9p9KzZ8sGnQ7VTGi
47979	payment	1397	1397	1678	1	1	17795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6N8QExjuE7AUQzujrrfhxqsXCeGJtvBK6bb62CncwUB9jUTYW
47980	payment	1397	1397	1678	1	1	17796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAbGXoerHB2Hbu5rckUQ6M2sXKHwFeTyxnqGM78yCVe2AdpiC
47981	payment	2134	2134	1874	1	1	7890	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU83eQxmTtPcPPSU6QPeLhXx4co9rU5prfkt2TTrsm4nQK7PP
47982	payment	2134	2134	1874	1	1	7891	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRyfTuUeJ4csoxVXHEey9Kex7Weq1d4XMVvsBm2CjwhMox3xq
47983	payment	2133	2133	1874	1	1	7337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6ThHka57BcU7hSRWCEwDUePznKrX7XJUpaPdzuvcb5FyheqR
47984	payment	2133	2133	1874	1	1	7338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbqNdUvQLxHDiNtuZwR6ACN6Cw1A35QzhJNmevGkBGYiKtqCR
48009	payment	1397	1397	1678	1	1	17805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecu9h4msQ8dRnVtBveNunYKghh84642QUUFJjX4UwBCsSszwt
48010	payment	2133	2133	1874	1	1	7347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHos3ATTbpTREdC9ioJUHZjtnG87cdJpzGBRzEmbbR3QbgNN2u
48011	payment	2134	2134	1874	1	1	7897	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WjVkRceMi6rzWK1SpE2jJuqdrLEagmAQYc9CcNco8MysNG4c
48018	payment	1397	1397	1678	1	1	17808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWKMaGGH44U9K7FuZ7NWVCfUjeMwVYYojEcxcACZJu7hkS3or
48019	payment	2134	2134	1874	1	1	7899	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8YuTL9No2nGUXxtFHsPnC3RD8LVDQh8AzXo7QpTgohXUt99d
48020	payment	2133	2133	1874	1	1	7350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABqskZEjozEriZXyk82vf7jMUtUN5Anmb1KgZwkfrqZhhE5e1
48027	payment	1397	1397	1678	1	1	17811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTj3MVG9aZ6ges5KY5bVwqaDT4X6eknhzRosUrgexanPnMCe97
48028	payment	1397	1397	1678	1	1	17812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZnxWorvxEzG2LGEg2RZ3RBzaDxFAXFSVCvaPbvVKYdAK1C6d
48029	payment	2133	2133	1874	1	1	7352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS73rebHd4FMyPeLv6gp8GKzRhdqWDiZLPPyaXxcYscGvZRZet
48030	payment	2134	2134	1874	1	1	7902	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSwyXVp9G5h5dQnNhgaxUM3GrDHSJp8U8mKt4DLBSAyL7gSBX
48031	payment	2133	2133	1874	1	1	7353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQ4BjPkMFAwQdi7shP4hYZsMDicKVTHo6CmEwYTm6HeXCu9fe
48048	payment	1397	1397	1678	1	1	17818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDwUYzPhj4Tbe7Fi9VeZsDK4KvN82T4adE31TfJdoxcjjiw7L
48049	payment	2133	2133	1874	1	1	7359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAt9BuJ5Q5keMbaGPP2NQeVFgCpiz6jfVCdo4qjERdHXgtaar
48062	payment	1397	1397	1678	1	1	17823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgCZDPwPpAyQk8vmRMHU7xaKUXLZPMHGaxaxkf2uHRsdD73St
48063	payment	1397	1397	1678	1	1	17824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBN6v6SXfLSfRopBR6soQKdMLDcXMRi7eFHMFy6Zo225fkQ5bU
48064	payment	1397	1397	1678	1	1	17825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9iRdv1c1qEeXBUy4e7yStu4cuJ8enhNikZ5QuYQRkMTMezbx
48065	payment	2132	2132	1874	1	1	1922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqoLrBEPJFajNUcAKhiN9xuvVRAjxJrQzMYTFD4djXUdsQFzh
48066	payment	2134	2134	1874	1	1	7910	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZoVDza8LnJDjTKUe35qW2fKH1AZG73ov6a9LnMHDtWHicfAU
48067	payment	1680	1680	80	1	1	12	1000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZGJvkyP4RPz1fDHjrCJe9pPC58W45au2Ns3qUcaYu7sxVgPvDB
48068	payment	2133	2133	1874	1	1	7364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHC5XcSMETiNfdPpzUHiPeXqsLzk7XkvGssT8FFJTNF5wpo57
48069	payment	2133	2133	1874	1	1	7365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxbo3ebPN9eSXP3RxBh7HAEvnJ6F274JubQpqxDY7QTGtvFwg
48070	payment	2133	2133	1874	1	1	7366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhax7ioKjXziQH2Um5mJ5TmPsoVwxA4qeGVScFT27gSCWgPZZG
48071	payment	2133	2133	1874	1	1	7367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNqNbgHq6d6yewrgJDeiJ3Awa8LoubpinmG79FNCuTf1BPdXt
48072	payment	2134	2134	1874	1	1	7911	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJ8M2AEsjEaP53tAD9JV1Jx919tDFPNWGDbfKRsgRZv61Mcfb
48073	payment	2134	2134	1874	1	1	7912	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxNosbGp1gBwDpwYoZp1ufJVmCRXuDeE4d1iFraPyq1nL8SfY
48078	payment	1397	1397	1678	1	1	17827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKf9Cs33YwDqLWKBDNRfTmcSS4HuE78SaGHX6GLiRn9wbEJ1q
47989	payment	2133	2133	1874	1	1	7340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6mWA98TNhxbDFr9XtUYfvgJEoiqaUs3UpyvVwEwZaTF3abGye
47990	payment	2134	2134	1874	1	1	7892	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uZfF4NP6fynmNKCtBnZeesVFve8mpWRnkjDEJiGg3eFZL1qb
48003	payment	1397	1397	1678	1	1	17803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSs2YmWD3zHZPNCu3NtskeLtdrEKKHyYKpLFJTvtT5omY2oZy
48004	payment	2134	2134	1874	1	1	7896	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzkxsqcR7N6rvmkyvmw9mQMjDV5CFNdjP311q8ruaX3q9STME
48005	payment	2133	2133	1874	1	1	7345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3r1MuNxgwR1g1276ZEQbduTALuFzVGLPSvaZrDUbP9iWeT4F
48015	payment	1397	1397	1678	1	1	17807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC836FtGR16SNWXPHDG8BuSqAWMJ3Qvg41ai9XvFiYNTfAsQZ
48016	payment	2132	2132	1874	1	1	1917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpiM3WUtwPh1smF2ngwb9txdAVVZq4t3gH7zRy7SDhJLgFuw28
48017	payment	2133	2133	1874	1	1	7349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnF4kYmApCJimRXq8qkAdqej7fkey7jvdwsUE5oERY9C4iTWC
48021	payment	1397	1397	1678	1	1	17809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoYd4rkSP8FbYgGnRXs5sPFVUCoAJ8ybneGDnEaKD44c3Byxa
48022	payment	2134	2134	1874	1	1	7900	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMMVHsNv8JubUyHN2LjprtH3PbTNc5TRghTpAYsmcSkVhEFmk
48023	payment	2133	2133	1874	1	1	7351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUFGeUC6pGStzkmr6HbZbzpKtW6gzD8RB6cay1wtJBexBGY5h
48024	payment	1397	1397	1678	1	1	17810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7L1rTMdSWMq3S2qoY7YLmm5vHo43yzHXWxgL5BH1e14eCRPt4
48025	payment	2134	2134	1874	1	1	7901	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwa2WEcxg4o83sU6X1ARyohAbegU3n1JsfbJgJK9JgqPKDMHw
48026	payment	2132	2132	1874	1	1	1918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCj5ZQQ5hurE27WAgs6yMwbkY7kcFXduMxFiZj2ys66nAchdg
48032	payment	1397	1397	1678	1	1	17813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV9VVbRw4FFE1CCmXKgJiKVYJwTGCAfcW5jYbEKCfZkkhTZFE
48033	payment	1397	1397	1678	1	1	17814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSzJ7qNYG336PPYYgTMycDo19Zdisq5E8dzjsuVzfs5mgrHuL
48034	payment	1397	1397	1678	1	1	17815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyVLVKjyfTwkSub5FCznMce8hPonKzva9nBF235srMZCCx8KY
48035	payment	2133	2133	1874	1	1	7354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgd9WRj2L1UwZ2zKM5Smsf7mp6p5TDWqqauQLS1A662KwxMtA
48036	payment	2133	2133	1874	1	1	7355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVo7JmkUR5LJXvffRDVDAFr8z5k184rBNWGFLEh92qXowEEi9
48037	payment	2132	2132	1874	1	1	1919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCu3k3P4BT4FAQiRoFbK3t8o8ob8EY9BHAT1FKkZFCN5H2qhN
48038	payment	2133	2133	1874	1	1	7356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2FJeg72fVzpeHF8R2JaMvBw7krHDbqjSA8wkfT3nCpHYxZ1Z
48039	payment	2134	2134	1874	1	1	7903	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnVbpACBJtwNm5nckV1WpmrHjS6HoFqYEknAsS5zCdLAyU1dA
48040	payment	2134	2134	1874	1	1	7904	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFAGP2xe1RgwWBRhDnamTsiTBbcpM2pja3khQorkwauvFPEez
48053	payment	1397	1397	1678	1	1	17820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWs25JnWzXWkFogkU2DjKDmxBfxyajmRWCjojaEf76RDyd57Ui
48054	payment	1397	1397	1678	1	1	17821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTVUhNcGE4tRkfxvRoKxBz1cnmnqytB9baudqnCksw4VSpMvL
48055	payment	2132	2132	1874	1	1	1921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazeT7MzUhs37wDGVEEb63XHQQ4Gsk3S8GojfBe1HoqQnXp6Fu
48056	payment	2133	2133	1874	1	1	7361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihgacRgGnKcibbrq58if3UXVywni8FgGbtVnfTxop5yWu3kLq
48057	payment	2133	2133	1874	1	1	7362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhW9uM6PpwSt9HNJj7MkHxKNf82SgnPq43P86h4N2nQTyauTwv
48058	payment	2134	2134	1874	1	1	7908	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfcR7CtkasgwyEMvDfgmWAKYFnfc9sBWaGcTSCPJuEAttWiV5
48059	payment	2134	2134	1874	1	1	7909	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9rDpCufRRCEXJzCuwfd336vX9HPLK4L8EbWUJfB8F5RYbFb5
48092	payment	1397	1397	1678	1	1	17831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGwGkzoE72zkhryw9Dj24WJcjQdje55WnmcM4jx5LpzZSetjq
48093	payment	2134	2134	1874	1	1	7917	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiHjQsS5s1GsWVycj3fgpHHov7i23a4DkjvXmtXUetD9DVdLG
48094	payment	2133	2133	1874	1	1	7373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtuWrzc7Z1HL1Yda7BYTAYHrKP4biCfbo68c8ErArqAAoGiqg
48141	payment	1397	1397	1678	1	1	17846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3cztxvmPsMJ6NvVGP6tPuF5LX6mEjHFxVSHNMWhMN5qpcuzx
48142	payment	2132	2132	1874	1	1	1929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyToPRGNBn3oVMAYS5BfPqCMEfvyfsu1DDyrHEU6uXZ7nHStj
48198	payment	1397	1397	1678	1	1	17862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsqrp8QwgevsTEkHQvkJaEsyac9tqqDJZDCCRSLQFA2Jsv7V9
48199	payment	2133	2133	1874	1	1	7403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8tCMZuxzTHnNeQb6ZFCaMSKzU4cmLHxGVY4xEj2FVKuAkAAt
48209	payment	1397	1397	1678	1	1	17865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFwDVeLNkrif6hqwYyA1h1swnVS6DXcsF8nNSAUjLGwbdtpCU
48045	payment	2133	2133	1874	1	1	7358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQVrcrMfQit1NBTkxN3x7V1c1x8g5bUoChFw59jAHgs4CWutf
48046	payment	2134	2134	1874	1	1	7906	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxptc4C2NgpJKcFRtLf9ivuWot9WwufYBtvrfY1QcstpENL89
48047	payment	2132	2132	1874	1	1	1920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81bVyHFSPqSbxL6nRQ2MD5FmJBZMhEqypDrpEft6bSYZiwPNZ
48060	payment	1397	1397	1678	1	1	17822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFH3FoDtbukpHqbDtBvEvKxKPRKmTtHKfueqcfsKVBR8w7hCnM
48061	payment	2133	2133	1874	1	1	7363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7bJVC8YjJqw5C1hDxrvxQMiBVoJMNDguujKBEbLfRX7doBW9
48082	payment	1397	1397	1678	1	1	17828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq97SfgehJ3dnPVJSogSsC2wxRAjuCkRgKe4HwuatvR1cGkSga
48083	payment	2133	2133	1874	1	1	7370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv342WLERDx5zyuMSprVLG5C2nufLD3BhHAexFXU9ZSdw4kGcb
48084	payment	1397	1397	1678	1	1	17829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ABRQx4QizVR87mvUPjBspSreQVJAVDRKXiD56Cf9WJeSbhJ2
48085	payment	2132	2132	1874	1	1	1924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHjtNaNEUNX3PDCVSimWUqesPiD1weHT4bDeP8BXssqgubvK5
48086	payment	2133	2133	1874	1	1	7371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCvbVWQyXCNUmdbtoiXL16HGDKH6Y2ecQodFC4jwUCx8zV6DK
48087	payment	599	599	613	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZoNLQsywohCy8mHZGwpUwpMtM3FG3A9vNeDGLQbozgFwKUA1
48088	payment	2134	2134	1874	1	1	7915	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxULfD3F71GWEGCd7nFauKw8YG2NUsFPrrUa3GKwQiJLDNsgA
48111	payment	1397	1397	1678	1	1	17837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHpV6KPgxrGz6wQrG8ijoQaTW8eX8iJnA2UXGBECczzUXVZUM
48112	payment	2134	2134	1874	1	1	7921	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT4xc6kNerUFHPWFHb6R9NjAAizomgYEs2sGMrRGHKi37D3nj
48113	payment	2133	2133	1874	1	1	7379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTYi9gprdMRBbWmC6Vro9hPtE12VvUuWRLWE69HUW7CcopLmn
48118	payment	1397	1397	1678	1	1	17839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmedmLxYbdQ1FnRNw6Dd5Dm26XThfqfwweoYyAL8E4JYXokpr5
48119	payment	1397	1397	1678	1	1	17840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5UvHppqjKgfuUK42YQGxkJCHWmVWUDm9d5PXDCmJFcTwqh5B
48120	payment	1397	1397	1678	1	1	17841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzGs1BN3Vj9V3Dyz7JLU145C8EUBjBPGmJpTpRnUafYgz5SDK
48121	payment	2134	2134	1874	1	1	7923	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7jM1Mb6jpY5N3tdzXBQSJp2BjhQpM15xVgd6drcXwWoXxaZX
48122	payment	2132	2132	1874	1	1	1927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mFKHr4LBwAAhV2n49Skyi2C3kgqevDrcws5sF3NkPaqfHmKF
48123	payment	2134	2134	1874	1	1	7924	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8paWyQTu5nn9j4oYuNJpL5TP3rmGvtv2RfQuFY9mYupSXmYb
48124	payment	2133	2133	1874	1	1	7381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TevQWE6cAFZ7rJcLEiMa3PXBoHWaPNZ7VoTPGDMU1egQC3Wk
48125	payment	2133	2133	1874	1	1	7382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpze1cZ8RhkC48J6Ng7eLzGHStjQYfFuuwvEh2Bg1FDdkhGFVZ
48126	payment	2133	2133	1874	1	1	7383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWtBqcAVj4DqVFdNyTBwn9AW6Yz3CWPEhQF8knrjR8aHFpc6e
48128	payment	1397	1397	1678	1	1	17842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVjG83KM3sgAPCuSFZi9JfxQ5pVYb6QcwSqgPWjyCQUPgHHkx
48129	payment	1397	1397	1678	1	1	17843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8NmKx9SowA1vcbe93CAF4WvEeZPf9a1tAoHJXw2DE5wgG8EB
48130	payment	1397	1397	1678	1	1	17844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rGr8PPW24xJVHhdBAZgUfr3yJ12E2w4XYQ7xa433giN4btAP
48131	payment	2132	2132	1874	1	1	1928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1ucocLCjFX6755UC7rC59AToqB4X9VCY2KJe4fpdZfp8F1io
48132	payment	2134	2134	1874	1	1	7925	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggeFo6p8mz9TUZzJbAocQ5bZfy1qaSWc9vCtpP5qeUnYceiBC
48133	payment	2134	2134	1874	1	1	7926	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaZfo9TriyDqBwSSCJgxG9rmc8xPMtmujunEFYaSHBTYG2EXo
48134	payment	2133	2133	1874	1	1	7384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmRe2mgSxbkB56nt6P3yb2AHkuiGHBN366DWbqxQRjGukJA1N
48135	payment	2005	2005	2422	1	1	0	1399000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMcvaepWTCSMXXbxLxmChRYVcWsmiZWHuy8GLQ1DQVxmZWPBW
48136	payment	2133	2133	1874	1	1	7385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93gicJoJoxi4PKQ1ZV2QFtiR21ay4XGxy768MnW9Vsng2K5ET
48137	payment	2133	2133	1874	1	1	7386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kve7UChfGgzTiJVQ6vwwngeNTPEUa1Ydxx47gWrTLgdUxTEX
48138	payment	1397	1397	1678	1	1	17845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS1y5PG7chyisGRs7vxmqmY8mxJP2xcfMEpmEG9o1r7wYq5Cg
48139	payment	2134	2134	1874	1	1	7927	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpASxH3SHzFD3J4GoWdKaiHZwtJVtXi3KhtycWn2Ny6skib53
48140	payment	2133	2133	1874	1	1	7387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3fDiXSG6e249xSqPFvs2mCnDu9KERoy7WE8hGKKHSybHPPH3f
48155	payment	612	612	2423	1	1	3	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7GH4ZLrCViRcagMww527hsy97PLyaB3RwKAh6rDJb4hTUkEE
48050	payment	1397	1397	1678	1	1	17819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGo7WruqwSioMh5pxqNzgNgTNxj78MfPnFbGMaUmqTpX5g9xPU
48051	payment	2133	2133	1874	1	1	7360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzo8oYeEA8ChvYBRTjgtsqj33Ey6BkHXiqtyivD3Z17RhZhbHH
48052	payment	2134	2134	1874	1	1	7907	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk38GkQDxGS5a2Kd1VqcntBmvKRPyfqCjZrQV9bM1iaC4SEfp9
48074	payment	1397	1397	1678	1	1	17826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8j9nov9VfpeA8UcLfF6BSaEgszC5CQzUR2v12VV3UqZ2xXta
48075	payment	2132	2132	1874	1	1	1923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqDtbmLaPb71FFgskxqgnvyLA4jTEkWwXCxLgXqPG5F4yiJqN
48076	payment	2133	2133	1874	1	1	7368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVL1nneiu2k15rDfddzQgm92zHzkgfvmSiSR5ZLeBMyTm7UY1
48077	payment	2134	2134	1874	1	1	7913	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1qixFuVY6e5WSKLBFtTYgonXSq9yUgNEPXF3UjqvrPjvGdm1
48095	payment	1397	1397	1678	1	1	17832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFho4nktCay6GX7riPAZHQCH2yGFpJuFmANXDjc5LFnTg3Jg1
48096	payment	1397	1397	1678	1	1	17833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNiMH5ksrZWjQfAWesWjWVoNRhj2uVFCJCcsmrPBVgxGmamXb
48097	payment	2133	2133	1874	1	1	7374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5erWK2JqkSQNZntvKhBU9M5DxsHgZxaLbBdMgi7Y3ysgdCu9
48098	payment	2133	2133	1874	1	1	7375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRhTfVQYmS58Lwn51Zck484DYiNpDN8ZZBC2BK3EjGbvv5L1z
48099	payment	2134	2134	1874	1	1	7918	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiCJSmzBxo9MCidbpiFP5bVpzv4VTEqQSX5jQ68LfBiJir9Ke
48100	payment	2132	2132	1874	1	1	1925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHcxdy9komrCs9PjqMLptcSU4g7igH6s42jAZoy9PmS7BWjuu
48105	payment	1397	1397	1678	1	1	17835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZtLp51en3LzqSLYXuNpHDDMutjaVMSkcd4Qb2wBgHnyuTgEb
48106	payment	2133	2133	1874	1	1	7377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvDEBowYhaQGLegCP2fvnZKV1bSEnGmSmD9CPA1Mb8fYQBQFz
48107	payment	1397	1397	1678	1	1	17836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbr4PR4t2yKX8kSgmPA7Fhra34X21Sf9pbEAnHaqZ5e1t8DAN
48108	payment	2134	2134	1874	1	1	7920	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7YdVMQ2qtDfuxHnspFnudjZPScfMKcwuoRn7pH3uZGr5Zfru
48109	payment	2132	2132	1874	1	1	1926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sVd4x6wWrAWBYss7NRKsiKHcbEQpZftG9KzUoWZXHWR8fBN6
48110	payment	2133	2133	1874	1	1	7378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLCFW7nxwBeu4qvLEbKdwjDKMtkB6RHUhPApzj72rKiU7PE5h
48146	payment	612	612	2423	1	1	0	1500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwp2ma5ovd2r7vrB23kjz3m3gwDTAhPbLx85SMzXRALA7BWzS
48147	payment	1397	1397	1678	1	1	17848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbgJ9jxmUGgnNRTnkfp8NXxR6ktHiewuWWt6nV68fygvmjoGM
48148	payment	2134	2134	1874	1	1	7929	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzGh64oAUQcys9FfvNws72GtnDBtsQhwkbhauTX14LNvHykFE
48149	payment	2133	2133	1874	1	1	7389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvNLq9kF3tVt6sjdYK58zZzDScLYNu8oiHFxk43EBqxZZPqhA
48170	payment	1397	1397	1678	1	1	17854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCmGGxNJGBraxKN16X5CozsQ5ScEmNEyTSj61q3JfKor1xhze
48171	payment	126	126	1776	1	1	0	100000000	7750000	\N	E4YZZmcVKrYdUcsr3cNXsNmLwTo7ML1CR8t8534rm99wpe2Cck83R	CkpYpwtTTjRhUF5Ho1BrvjNm4njLJhpufgBZc54tD2G3vagQhEveh
48172	payment	2133	2133	1874	1	1	7395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gLoGrHmuj4RgtfB6qYuVVU2uBY2keqWhgRJ6tVWUssdvaYap
48173	payment	2134	2134	1874	1	1	7933	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfcfBfiCFEKcH7F8UdWiryn71E6sdrCk3sb2iV36JtjbC7WZw
48184	payment	1397	1397	1678	1	1	17858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXSb11PGWy9Mi6r8ghkfzr6TxrRc48bQ4nZWpBibxNCxzWTpb
48185	payment	1397	1397	1678	1	1	17859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWX1Cf6Pipvt6ZjJ3AqVBnQSr8qgtdaEk2zSX5FGUHhCoiZxv
48186	payment	1397	1397	1678	1	1	17860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBDAArDDYw7yNCWEA5hwfE3LwAgQYvFfGcpxGS8y3LqtFEBDV
48187	payment	1397	1397	1678	1	1	17861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJwHC3A3bCJ56KHefJQ3dAhdxEeFr1pVccJgUy3qQkxgNNoPv
48188	payment	2134	2134	1874	1	1	7936	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPsyPdCCV9UtC1MjrEWvBV44KfaEgfHDpkxsa855Da3mf8AX6
48189	payment	2134	2134	1874	1	1	7937	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3n3q9W5VaCBf8KaE3zyUncBSxBdUzSftqtdAQRMunfyWFwAgA
48190	payment	2134	2134	1874	1	1	7938	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5eiKmMhmv7JYJ1U1gCZjWRry9j27pi15abmMjTQgHDEd2rsv
48191	payment	1726	1726	2424	1	1	8360	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqJt337x6mtcrJvrU8Ex952dUS4aUGnZ9EfYH99BahvBTtyqry
48192	payment	1726	1726	2425	1	1	8361	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDqH9JaXvFyZmGCfGDm1DqF68j1Ert9dcjmzT1yuWe7E6rZKLH
48193	payment	2133	2133	1874	1	1	7399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxF63FayVJkpSv2jgEqmBtccqRC5GFbtzFRqEWuSdJ6H7ho93r
48194	payment	2133	2133	1874	1	1	7400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9d9hB4EZRPrK4j1bci65k7CM3wC8kBxPqzw9gKgUy96Fm9fR
48079	payment	80	80	1993	1	1	0	500000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZbkbi3ohPN5XC7k1mFRwEdmNZTLifq8sSyukxEZrbsDx5gdbks
48080	payment	2134	2134	1874	1	1	7914	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2W6Mzjxzwn5uqPzacYZEnAoXnxGK5tUhhuy6E6AXLHxJxkBz
48081	payment	2133	2133	1874	1	1	7369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRk7Tki7URuPcouf4YM9Drj8rBfQYWYtdeGgrAek3kgGkbNhD
48089	payment	1397	1397	1678	1	1	17830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfjJ57Db166NGABpKNsrocK1bosi41XCik2BF1SdwWMYTfXKZ
48090	payment	2134	2134	1874	1	1	7916	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1Pn8kJKQJsUZjwQUxjqSbeA6NtPwLt93WkjDBAnLxp64QAoh
48091	payment	2133	2133	1874	1	1	7372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7QZ9rtNR6fJHZv99PUK1oAkT9chRomtbBX24jwojrL3BjRqs
48101	payment	1397	1397	1678	1	1	17834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVDcXBMePBLccwSo4tvjJDgmMXHwrNXjSGSTi3eog5xdFAD68
48102	payment	2134	2134	1874	1	1	7919	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4xXHZDY2J6pZy932CUTD4Guc6nafB6V5Hwc2XeQAfanYV9VpJ
48103	payment	584	584	2421	1	1	0	335083938283	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XGBad6yQNvoAVuF7GJYTh7eBVRCSTYcuyWpJMqWADAeooMBr
48104	payment	2133	2133	1874	1	1	7376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceifLJ7jBWrKJDBkDet9RW9tTQMVpHx8ZiiAnQHPP3xtqdSo7
48114	payment	1397	1397	1678	1	1	17838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYY8Hq1LJfRTaddWBkQ7LmyXGUiNSivKZxvS1itfubNfaQrbZP
48115	payment	2133	2133	1874	1	1	7380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTybTieVZ7LnT43vUyp8NFnGgPVExZXtUmR2yh5wNGnENXzxk7
48116	payment	584	584	2421	1	1	1	209424788612	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHvGcwJ5yqQBaVLiU9u3SaiGmXavwBjGRUgUjSeopymC9VtwF
48117	payment	2134	2134	1874	1	1	7922	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUDqLkpAvh7L8gdEGSG22erWEJ5Xc8KebWMQ1DV2iq3rDgXtE
48127	payment	511	511	1684	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULcrmhEAZjURk5vJ2f6szoZ6KcuyZkNENA8yYzYkq1vTqmbDd
48143	payment	1397	1397	1678	1	1	17847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WwTWSkC59b6pvQZ8ixeR9LWJTbnS9fMpCn1TGCKzbTku3nsi
48144	payment	2134	2134	1874	1	1	7928	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmYz1aHbpcgCeR3QDgni5KqjM25WToLxWXpju4ygQY6AM9qF3
48145	payment	2133	2133	1874	1	1	7388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5H3oyvUcanKMyBgFpGANwLGh5S8i9oRmXk9ZUJBC49E6wyTBs
48150	payment	612	612	2423	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xUoziFJy3VpF65gq3RGbQ86KT53LxSGwUW44UHuX3rk2yG5N
48151	payment	1397	1397	1678	1	1	17849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHvxRWfroKATqRzTLqGB3M9FC2W4q13uS5p2fTbjCo6eoALw8
48152	payment	612	612	2423	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFtSNTWSXnW1cEH86wbzVLy6NEDN5KjTfeWDcQ6feBEy5XmVh
48153	payment	2132	2132	1874	1	1	1930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVsAFnfNApvkpcY6eUopcgiwLLKft5mLe9iszuNvFzVX68L8k
48154	payment	2133	2133	1874	1	1	7390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPE2zHoVYxLHDnWadGm6gaAhYnhibjey5yuGZRMewS1WpdR86t
48160	payment	1397	1397	1678	1	1	17851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AC6FqDNxkxrbdJ2X7ZHzgnruijGicvbiECK2YoHF8ntbb8gj
48161	payment	1776	1776	706	1	1	2	1000000000	7750000	\N	E4YXduXJHkJWbj2aj8MY5iDLTLP4L1Z74CyygDamEbNCwiqE9osDV	CkpYuNZtv4WWr8BGDeAyHjW2qusTa4YB9sz3mcRvExt9bTpAKF3Dm
48162	payment	2133	2133	1874	1	1	7392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWD9bGymBEyRp5Qjr2LyiNPfEXEXgnBB21StiGPHVFwaEuQxL
48163	payment	2134	2134	1874	1	1	7931	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VfpLK5CsZJzKTrW3ZyeR2RUCkgfCQKWjtoqstFwCFUe1uEED
48164	payment	1397	1397	1678	1	1	17852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQD3SmgpsZz6oyRDpQqXVMpgkzC7FP7zZBY5hcSQrWQx5teuQt
48165	payment	2133	2133	1874	1	1	7393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5Dy94FdJQ2Mo6HPufm6Xn5XJJ2P78KBGL3d2Cx4avJUokz3L
48166	payment	2134	2134	1874	1	1	7932	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJHj7fYWuuvd6qRcY9oYA3VWD1DXmAYjvdr6kQyYFEkECzb9y
48167	payment	1397	1397	1678	1	1	17853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaymjt8BBrtuSaJaTdvNvywGLg8AAXAuR5Ej4HAdVZxSMzoZf
48168	payment	2133	2133	1874	1	1	7394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77CHLRYefhXJty2WShQJWTzJiMHuEuoKrNDFw1HEcE5kxMgaH
48169	payment	2132	2132	1874	1	1	1931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtKCr3sUcnUpC7SupU1y63mYwTrYXhX7bPc5vBDwr3ujyQsM1
48174	payment	1397	1397	1678	1	1	17855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd87nKakBqjXpGxYUovHGWH3GnXUiaGPcKcgibL1nqdLdsp7bj
48175	payment	706	706	1776	1	1	0	100000000	4937500	\N	E4YbWWnimtQ4KfUMWm8a3cY6BghYRodMf5MV8y8qgxrgMzuVz5jyb	CkpZLFceWd7xBxMTAjmiYCogCA3KPKRtLSVMUmNvka4aJKcptWCvo
48176	payment	2134	2134	1874	1	1	7934	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVk48Y5DodGpeAaRwnnHWhsQtHmra3oee5PeMCihc6rCmTwurk
48177	payment	2133	2133	1874	1	1	7396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTwSaf31u3bEZwmaUn9XwMJfRWWKPdYJiiMSpfLf3DGBEr52L
48181	payment	1397	1397	1678	1	1	17857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPahtZuSFbMF724tM5tmwWKbFzvm8pjqCA2Ucw1aoaKa3K6tB
48156	payment	1397	1397	1678	1	1	17850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGEDABceXCBmHbTnxgxgP5kL4CC1wLRhssVmSbWpxF1uQgPuU
48157	payment	1776	1776	126	1	1	1	1000000000	7750000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ278Rfns7CyW33Qxf2ghgAHn4CSdbPHKDxpRxc2VWFn8DBNFMb
48158	payment	2134	2134	1874	1	1	7930	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVwPYyKGhriM2mXudBMx8bgL5rp6peWEYvFCNBGkAYoncLocY
48159	payment	2133	2133	1874	1	1	7391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVmj5AGjnkvdLnVHTg5op2Us2P4RjpBnSQyPY8jqWCyAvdDDx
48178	payment	1397	1397	1678	1	1	17856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1BWrGL9ynEaETjZq9Te7qmU5rgyJKg3o7fMURAeAyZU9Un8C
48179	payment	2132	2132	1874	1	1	1932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTZhr5nWSZypsvaFvyfG3YbEJLoBfLXQbFRTu67tuXPDDgVsc
48180	payment	2133	2133	1874	1	1	7397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7uJjD9DwpayUB1FacdtTAeGHqGKqZDrzKMbLCZDsgjm8XqFs
48206	payment	1397	1397	1678	1	1	17864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JnqPNTw3DjfBTUVVENk2JDXsZXXxMBemEpkxVSA8cFAw9uM5
48207	payment	2134	2134	1874	1	1	7940	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6FSStLbr7VmnqQorU8fCp2cw4NosuHfekNjNrSwPzJ4rRwCQ
48208	payment	2133	2133	1874	1	1	7405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2uDqBnQYgSstGSTuDNCUw2vCdoPMWFW1ankiaC4uifpBxp7p
48237	payment	1397	1397	1678	1	1	17874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnw7675SfNn1V5RWK2ojbsoTv7frq6AMZkwaFGBP2j6TKw87ed
48238	payment	2133	2133	1874	1	1	7415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh7iGdSYUMsgWHm4h5bXa99JnL8edyNAkKNDZgxCuEGAGYu4u
48239	payment	2134	2134	1874	1	1	7947	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTx5s4mKAx8gfNtcAjgvjTvrAPJ55FdSfSvYFhq5A6rqfKniMe
48253	payment	345	345	2402	1	1	0	50000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLQLLxkeSv2eDdh3zk29WH9mR1tS7Ah1xoHdwYiAQ3DPXESnH
48254	payment	1397	1397	1678	1	1	17879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq1MDqFh1sagv7aiWTtBprmQa95AVTZzjnMZm7ZMcZMbUqWUo
48255	payment	2039	2039	1445	1	1	6	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsKcUPFnjtNvJpyo6tbtTnb4FKGKGCSPwBZpNg8UvejvX4hyg
48256	payment	1397	1397	1678	1	1	17880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJ18F3Pj8dx56rmqJZ8tytpE9aMNVtKFzYfRSkJ46ccgjk3y2
48257	payment	2133	2133	1874	1	1	7420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSc2MvuSAYd6MWs46k1kwfAeHCvdaGn8rngfvXcLNggy86B9MP
48258	payment	2132	2132	1874	1	1	1939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMSyFVz31pZegyTBwUoCHz3CBbtrQELpeW7NkEKsdPR8eBGhr
48259	payment	2133	2133	1874	1	1	7421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5c8MY2929EvhPUT5DZt4qrgPRP7UNQX7TDx1zPRmX8CdWNN5
48260	payment	2134	2134	1874	1	1	7951	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTX1mTb6SktqLt1gMdorKXGC2EDXsdJsTXYNEbtbBAJabwa8z
48261	payment	1397	1397	1678	1	1	17881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzRMVtZeHFxokvNC7vBsnN3f644SoXykK8NC5WFWZ8nU79XLt
48262	payment	532	532	1724	1	1	1	1000000000	6000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	Ckpa5Q2bcXZ6SGnhbzAEUVWWxaTtNkskVKtqVDm6KPZroQFGQpkH7
48263	payment	2133	2133	1874	1	1	7422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Yjbeq2Qf2HN2KaRX7P4LKvtBb2rvdP5Rpm1KXMiEmpS1VHUA
48264	payment	2134	2134	1874	1	1	7952	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGvUemi3fTVdh8mS7hSC8qrn182r4LHNup49GYGan6vgWPyPi
48277	payment	1397	1397	1678	1	1	17885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvHWxq4QXHNYPCEp2a42bw9rYKyKR9hjz2KJTXPVj9ep418h8
48278	payment	2134	2134	1874	1	1	7955	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsqwG8tXUUVx154oDtaHdcaQNdHu7WW2w5fvQAGB9yQwEXG9d
48279	payment	2133	2133	1874	1	1	7426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthSs2JSZG25SRAkMoLXEfb4sSAnJsayWznR4SDbdaJsPPeK52
48284	payment	1397	1397	1678	1	1	17887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNoHmhSEvUjTDL39sQGiySiazfABkT3xYhPXATSck4saY6r1G
48285	delegation	2426	2426	1507	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRMczm9fhE7QRsoHvwVXrXPV9YH4YmAr15xnXgH3Joy7kAMSd
48286	payment	1397	1397	1678	1	1	17888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa796Q11UTN9FGH6gij6kooF3hd4KxeCYhLWux9xfir6oW6ow6T
48287	payment	2133	2133	1874	1	1	7428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQM6KVLBNYLkCKSXgArWdMXt7ibKTqBgCBPtQJcFYVVCMqH3F
48288	payment	2134	2134	1874	1	1	7957	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZdFQoUKf5aQ7zPr69wwsjWQAcKCTpFiTY27ytZfJRqZirzaj
48289	payment	2133	2133	1874	1	1	7429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ihrx8NcR4wm8Wq7K7RoTnTGgxmtWkngguWX8d8sZ6pVq3rZr
48290	payment	182	182	2298	1	1	0	770026864240	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KrJ4L3tHbk76RFVfikAgaVJ1D7crQp5uCxkXTkHBGdRj8KTA
48320	payment	1397	1397	1678	1	1	17898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9ftfZo7xi67jwxJLbgL62xMMMbw1PxkFBpcKZGX5U3NckP25
48321	payment	1397	1397	1678	1	1	17899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jPLxgy9FKBrTqgS4H8u5mqZSA8Hn9qn7jKyDgVbV2edPgURG
48322	payment	2132	2132	1874	1	1	1945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTjK5LteqTqy5AZ7aZyQuWH56ZC7DNXujcgBSsUrXzuBS2bXx
48182	payment	2134	2134	1874	1	1	7935	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Wk6u5iCAT56dkGX4XTsKeXfwYDei5kXYbnQ7y1YHd7YS9FRc
48183	payment	2133	2133	1874	1	1	7398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6s7Eznb6dB5bPybXwCX4kQGax4CNB1U5PLYRpgzzV8VtLe6Hh
48221	payment	1397	1397	1678	1	1	17869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPiYzQNg1TSWnS8kdZp1WxtKR676D9bVrewJg69uUvWbZbzwU
48222	payment	1397	1397	1678	1	1	17870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbevYxRC1N8NPVnvo6XdTSHM7N39WpxQChwW5zbcStEoU891Qr
48223	payment	2132	2132	1874	1	1	1936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmy7NpbeKgbsAeJm8t5iN3bqm4NHLpgwJoHeSyAwtG3rwP3m3
48224	payment	2134	2134	1874	1	1	7944	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Mmd8VspHY4uYA9pK469oxD7F1dehPm4y6Xrk2Sgg4pqqKyC
48225	payment	2133	2133	1874	1	1	7410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PL5o8HoYP6Edxcf4QjwaXRTCMSTdT6F1r35fPn5KgBYijSD8
48226	payment	2133	2133	1874	1	1	7411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4otPDKJLr55XQVyod7Yd576HTKQ5jxGewnGQ91WBHS2aZeh3
48233	payment	1397	1397	1678	1	1	17873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5xPEbAsKCkUnVA1s14LsEiP7ezEBdQwApMr1vAtkHMj8Dw9G
48234	payment	2133	2133	1874	1	1	7414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYqMJWX36zFzPZyuFECn3Rui34YvAHeMd8NzU43AdkFLPMxzh
48235	payment	2132	2132	1874	1	1	1937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9g13oNfZ2cAjezNLQ53wAaheGRDc3wvLPNz5fkjh1YsVx7Gd
48236	payment	2134	2134	1874	1	1	7946	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Z7nGrCacive6BVsAQzMNpa5v7gULbqXnuF1wQ7qFzGj483K
48291	payment	560	560	560	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAWBqkbh1szccnnhnALgrR1uvzKhvJQnsSFCaNum9GsYisPqj
48292	payment	1397	1397	1678	1	1	17889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXgmAJwvsoidiBjiWhzcGcVQ7CVM5Geiu5mNAKH4ZEg9MMUM5
48293	payment	1397	1397	1678	1	1	17890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Bp7tC1JCE1heGHhoSyBNg3s3WZjmP96odTwNUtGFyKvRnwFb
48294	payment	1397	1397	1678	1	1	17891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStTJ4s1emKGoQbVZQynw3p6p6TKg9STtchgSbLYpYHCM3ZRYx
48295	payment	2133	2133	1874	1	1	7430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde4NiYyWeqLAPM1B4iQUUwfeKfptVxigdNn9RxENToBoWMGwG
48296	payment	2132	2132	1874	1	1	1942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETn1NwSKodJgdBD4QSfuEYWzKt8UbvB8gah2SwdT4wpDuu9k6
48297	payment	2133	2133	1874	1	1	7431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZbaYKLc9SF6oAJLTXaveciURaAzYyqURSU2ejHCy9kxy1tSG
48298	payment	2133	2133	1874	1	1	7432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SjkHKBiXCEwBh31ZmbEfgK6JttL2YSRwLmNf57uyDJ57VP9g
48299	payment	2134	2134	1874	1	1	7958	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7kDcUeH9s4j9CNm4W5u2iSDZuBBkkLpPGA1SXbLu8fTDYUeA
48300	payment	702	702	2298	1	1	0	513350909000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAZvxyGTqni6FNTDfBNWkFLatn3qoMRG2GEs6XVoqrrnUDww6
48301	payment	2134	2134	1874	1	1	7959	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaUyM2PJCFCHt9U56ASFZWfDm28fQm2eqPWyEpNMve1rUXirw
48314	payment	1397	1397	1678	1	1	17896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyzevq5ZnxLZVJdV8psm42XnactGrPCmfNbRZbg5VXqxBKFxsj
48315	payment	1397	1397	1678	1	1	17897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSgX9ebdqJWbiRD2ih8C5ffm3mdc1dFr61pWP9aFMZeKjKv2D
48316	payment	2133	2133	1874	1	1	7437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQpL9wbxLuM8EXvpdzmMxqx29vvnoz6xuCKFCqhjqAxzmi5hj
48317	payment	2133	2133	1874	1	1	7438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMeSMTUrnxFvcDMM1fZQnpUSH1oFGjGMxvH299fVcGzLxy8cc
48318	payment	2132	2132	1874	1	1	1944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUPcfhHXYqwFGp44TfdQ6jGFgfRwXNsJJ7FEj2GcT7HdSVHEi
48319	payment	2134	2134	1874	1	1	7963	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMoHZYocJ1JehUJrt6Y1ot4uQcEHQ9X485fGT6EwBXC2sso5e
48350	payment	1397	1397	1678	1	1	17908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLipsTyhA6jp91rVQuG57ZRH72DGzyFZkEejvVLmGFEyDJbPXf
48351	payment	2134	2134	1874	1	1	7971	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVLxpE8FdT1NKagf9uXX9aNY7LHHZ1FohKXDuhQ7WWBPssA7D
48352	payment	1397	1397	1678	1	1	17909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVzHjveVgGtGmwfHxKJFXySB7wgvEEQ2X1asLJrtxbeumJoAn
48353	payment	2132	2132	1874	1	1	1948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCdkR3vSSkctJGEZRborjWz25dxTYXgSE3PjkqPvUqJBBxqPj
48354	payment	2133	2133	1874	1	1	7449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZJscH6DanJLAZkuDY4J7DCgR2GJLyFL5NvKZMbMR9TC2LmXp
48355	payment	2134	2134	1874	1	1	7972	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcYvms3AoGTgtxp3n7wyPA5puXSSPGt2whjfGrKBmHvte99Y8
48358	payment	1397	1397	1678	1	1	17911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeCbAbJZn7aNfEC9VRRnUyowA1aA3UosDoQ9YkeRmput2UZvP
48359	payment	2134	2134	1874	1	1	7973	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcnjij5HnrwBR49tAXtTzwJokvc9b7bGk3mHqfjFk5qLCViFZ
48360	payment	2133	2133	1874	1	1	7451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LEVxMaQdDiwrXhXGf1RrqEzTznUDcUMrZdeKbNFccQFosjLp
48195	payment	2133	2133	1874	1	1	7401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2z5pTr5ukk49D4rfR1CxuC5hLK4JHJigxy98MwooQ6xw2tDL
48196	payment	2133	2133	1874	1	1	7402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4BsDULmx1n8iUUhSQ1wekT6EugZ8MNeBsneHNXPDVLo42QFg
48197	payment	2132	2132	1874	1	1	1933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGYnT2WNm4wDDkotBkxDyDcaTmEiDkwqezLVbrTbAPuhhVcph
48200	payment	1539	1539	1539	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLStpP2T14QoxMED6dqmyEdepR3gRBaFNCCGPxWoq6h9kxktg
48201	payment	363	363	363	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJBhJYyB9ZybXnSZbv8ub17KumXvyBQXGFT2PCJF1nNsstDYJ
48202	payment	1397	1397	1678	1	1	17863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMSXVRrDJvaUvAMpHMYHyxsvWo5npBeyBGQEsWB8qA4PUV5Ui
48203	payment	2134	2134	1874	1	1	7939	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHzUtVmjF35F3LorQ1GqP3RD1GDAMTp75r8Vb1phNPRbPTkJg
48204	payment	2133	2133	1874	1	1	7404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVG9Kg92FTJtjVCsMyg4jiH2jnSkSjYASvbAucLLMcj43HtJsG
48205	payment	2132	2132	1874	1	1	1934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyY1ups1BFd6i4ePojKXPkPmsE59z9cj1a3xMZLV2hpgFqRUs
48218	payment	1397	1397	1678	1	1	17868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yo11x8RZ6CdHMKVZp8SDztm4TqmpmU7c5KakZvoTm2q11mY3
48219	payment	2134	2134	1874	1	1	7943	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJkJw4FRPLXQzCSQUNLEtN5kKAdyegGwX9n2w5DYDFqVfWVKC
48231	payment	1397	1397	1678	1	1	17872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoGxRAUizpgePWkbTsqB6HQBahRJjCeGifkF9UGRP8Krwk5To
48232	payment	2133	2133	1874	1	1	7413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSRFvBbT68XSPpzP4sWfbLopSgpD9aQ8NtysPp7gm9toXcMqr
48240	payment	1397	1397	1678	1	1	17875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhupZnvEkWtCHtMgwHQV5RjvgEgT87kPGzG7MpFTkutr4F69Sj
48241	payment	1397	1397	1678	1	1	17876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcx4KygrNiHjCWGCy1whYKNwtJGAxhf9rjqz1f15hQxGS8zfw
48242	payment	2402	2402	345	1	1	1	1000000000	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzePDeWMmHxefAJNYxweW5No4B9YKaVaJCySdnuD2sCnwK5EV
48243	payment	2134	2134	1874	1	1	7948	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQEHq8fYSmWHQwxR5EyWNTABrdBqrt3JR1J3CtapKNEqpAmKF
48244	payment	2132	2132	1874	1	1	1938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkYYskQXoVs81i2Qkm44DsxJ5YTVLtmV29MZcA3q2dZBEcUW7
48245	payment	2133	2133	1874	1	1	7416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxzwhWCRGe7aTcLDkx7aJvZSpx6xQcuFnTHBqTGagJ5N6Wfgm
48246	payment	2133	2133	1874	1	1	7417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZHjismxFNCcnWHmbaYAfg6dYGFHtLNcmDX48g7YhxGRWssMi
48247	payment	1397	1397	1678	1	1	17877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QJojQ97n1hZgjYLtFJZWTLVrEZZ8H2Bz5cmt62nUcLhHgYg8
48248	payment	2134	2134	1874	1	1	7949	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEakzK1rn2J14mVBzo3btZVbmZH2AHzQesgoduGNc2DayLNHZ
48249	payment	2133	2133	1874	1	1	7418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Mh8Cr3yodKbJakPbys5DR8cgmwymLACYSfLdk8fRSSNVygdq
48273	payment	2402	2402	2426	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJinuFXK2hGR52jrSfxxfraDhwS1y13pyDmjBjEXtCfsyHEnR
48274	payment	1397	1397	1678	1	1	17884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3P7n2n2a7bazwh4AQHc5mogYZee7fWfuacosioDbMGfV2agN
48275	payment	2133	2133	1874	1	1	7425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgruhqGvf7F3LmGi6oQb5cknCtThcDHxtNabpFBJrQWGtkag4C
48276	payment	2134	2134	1874	1	1	7954	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KxTxpdvcWNWqyxFfMBrByshbFk3RTJaLUEn3JMQ9GdRCfvE4
48327	payment	1397	1397	1678	1	1	17900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqncRS5XB6Yv3fQqhXBk1pv7E6CYodpATPK1c5dc3kpMqniqp
48328	payment	1397	1397	1678	1	1	17901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLPYqWcdbchQpnEWVRYithGuB3kRbbo9HTxK8UBJy37sEqEWJ
48329	payment	1397	1397	1678	1	1	17902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSofUeoCWwzG9mtsUUbfzHgjQq9fWEhncyfdtxXWRMcbXj4TGq
48330	payment	1397	1397	1678	1	1	17903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSkkYoG1yE9nSfPKH57jtL7LHDQ8z5jazaLyaXr1afm1mr8Ne
48331	payment	2132	2132	1874	1	1	1946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquhNJW5H9czAtCp5LPxo3Bf5wbre7m818wcEXZBhVJeE3Zsg8
48332	payment	2134	2134	1874	1	1	7966	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwwKTq4QtDtNXVXL343JKhLqFrQi6zyz4uztvfUyt9gJy8795
48333	payment	2134	2134	1874	1	1	7967	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPCzT73moFt8gmoTArtQX7kjXGa4PPtcbLTH6MrJ3bKdqKDVZ
48334	payment	2133	2133	1874	1	1	7441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpK1oqYiNULN53Ue59MBvheWDMkgkvSiL1jqWcax69vYbMEnn6
48335	payment	2133	2133	1874	1	1	7442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MdAXizWC5MAxX773ao5rYokYxApQ6Xsaoj5RnxXfwi6ry8oS
48336	payment	2133	2133	1874	1	1	7443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSt9AZHwxD8GBJ43tYkZQsekj7PkAM4LehzR7vxjSco3qs1RmH
48337	payment	2133	2133	1874	1	1	7444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8eCL1sAnswwTFK9SKhhtgcGLkpAyvUJKLzJm76RSWAAQXtKn
48210	payment	1397	1397	1678	1	1	17866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhjrkjGnCHC2WfgqBipCDNKMqjkAiC1VRBiqcMsnTit9N8Hh2
48211	payment	1397	1397	1678	1	1	17867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGiwy8xvWwN9PBUpauMe9ZM96suQAjh4mhNvLupUS6L4W6gnr
48212	payment	2134	2134	1874	1	1	7941	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQECZvVxwuV7Gbw3btGtSQnvugbp6koydwSjcLvRYGDipp2Mb
48213	payment	2132	2132	1874	1	1	1935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3PDTuVFKxa4G8Br8GFV297H3mk1qp9frik1m3Q984vLnGXaL
48214	payment	2133	2133	1874	1	1	7406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmudMtKbWw92gcVp9H7UAYZKVqM4kahS2JhV72RDCcPSSUyYy1
48215	payment	2133	2133	1874	1	1	7407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1d51e3ME9dSpt8gvs8g8psk3vTnt5MfGAX7XwE2v9kc2fx5qn
48216	payment	2133	2133	1874	1	1	7408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8PMPnM7o2R4AD8p1ZbLvWtkb13FMezkkAf8i3zKB3DiKdP87
48217	payment	2134	2134	1874	1	1	7942	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADj5kZ7XidGwgDzUjpxMKi8J3q3RjLJ8imsv4D6BGQWFDPZ5J
48220	payment	2133	2133	1874	1	1	7409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT9pd51xebXMwBe99QJgbGVXJd9aDeWA7XK78naqySBszcc29
48227	payment	186	186	180	1	1	0	1010000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5sKZuNU1BkeQ5A1d7viSXpTBPSV56DvCKfCqB1GCuM9uWeAK
48228	payment	1397	1397	1678	1	1	17871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QoghqmLjcuZw3of3TbC2XPwHaUKg4csgHrkfB2mc8uFRgedb
48229	payment	2134	2134	1874	1	1	7945	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxKQvWsv3QFrSdVeVAFDzPVC2AFUPJx3mDzPWQkmYL8moh8YB
48230	payment	2133	2133	1874	1	1	7412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNBpBmTyZExbb15nJBRDo48ebbN5WD9wN3nFxqGQwr8ckNgr3
48250	payment	1397	1397	1678	1	1	17878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGsBHdZRZs6sEoMGwKKCBe4e88HcE58XfzpaSFKgWHAobPsQY
48251	payment	2133	2133	1874	1	1	7419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnLjWp7sbxhwbinJuLMVJq2cZWPTyU6YbLvtYJiynE1jMV9Mj
48252	payment	2134	2134	1874	1	1	7950	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCin5L23MkheJNvH5Wd2NNxi3JyRarMKMLprorTVJA15wATZBD
48265	payment	2039	2039	1445	1	1	7	19153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbfm4nrYia9AoNRN4oNwL559Wrk65EFBDEHBHfZfx1zNPyGMj
48266	payment	1397	1397	1678	1	1	17882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bS6xmVVTpm351FxUaiaWwYm9ofgmdECerZZtSk6ZaLMmphN5
48267	payment	1397	1397	1678	1	1	17883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmimNDgSDt27qPNZXBuH4Tjws8iuPSU31vHTqyUYRpKwrfNLEy
48268	payment	2402	2402	2426	1	1	2	1000000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PFhizJBDK5KNSm68gfzEwjrKM6j2oxidotdBrqoVc8heJ7z6
48269	payment	2134	2134	1874	1	1	7953	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1f6zDgxCh1JLUAAe1Zp7c1a7sRCVwdSAFKcNoXrRzZVf6vxD
48270	payment	2132	2132	1874	1	1	1940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZji5o18hygG4piKaoFV5bKh2Z67ay5gCY64tg7gDu6AURfECu9
48271	payment	2133	2133	1874	1	1	7423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXVdfJbqbjBvQEp3LWRZVoEHGdFAm94gABkXGtmMAEmCqPCCP
48272	payment	2133	2133	1874	1	1	7424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9m5hvNe2Gwo9B6xDTwe8uBLtHEzrH2th6E9inmoXoHK7WuAi
48280	payment	1397	1397	1678	1	1	17886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDEoHgAcC5QmWgFeCoKEA2XP3g8vVhkzMQnnpWitrixCzkuF9
48281	payment	2133	2133	1874	1	1	7427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oXrSuAHboES3L3vZxYWrW3dv2LMaRcw9Qb8ZJdpWrdoGeq9U
48282	payment	2134	2134	1874	1	1	7956	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4Ls4rRPTJFx9HVefDgbbZuYCinehH2gTeQUPeRfZJQkkNsXd
48283	payment	2132	2132	1874	1	1	1941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStePfQX1bAao9AqtNr2drGbuA8mBQDWtmv9cyfGUZ1dMX8dQY
48302	payment	1397	1397	1678	1	1	17892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmaa1WYTwZr6uo9LirHpc5gavr6BovPaerLqYnVpktcbeCrEU
48303	payment	2133	2133	1874	1	1	7433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoN7aE41VWZWqJKg1TNS3QZVZLmFzbTHQgroGyii339Y3eRVmo
48304	payment	2134	2134	1874	1	1	7960	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtMaYmd1L52BUKpWxBkb8QhR1VBM6KWtyWfq1mLRnFvi87o6o
48305	payment	1397	1397	1678	1	1	17893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKE3izLkQLzg3C8vgU2YhBq7MNRUqdwe32pUEMhaZdJ6GXUT5
48306	payment	1397	1397	1678	1	1	17894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3hMvYCTxJM8QYSbU1ScXqHXs5t2PXHFj4YisPK8hhn7jLa3H
48307	payment	1397	1397	1678	1	1	17895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQN73NDAF27y2SzSRHMfcuvQt4gm16CpksMaBPP8xRGBNdNVok
48308	payment	2132	2132	1874	1	1	1943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRTtQdSRwNHurvHS4wTeUFEurn6o5tebhKigGRr39cKE7QfhF
48309	payment	2134	2134	1874	1	1	7961	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ykfbgLEypQNQP4H9Vt4kV4tE9zL7q3X3W3QMMB97Xz6WkCmi
48310	payment	2134	2134	1874	1	1	7962	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZys9yiauuorxnnp4GdKkdLtrxUJ7JEeUH8KC2XEx9TqZr6sxuB
48311	payment	2133	2133	1874	1	1	7434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcFTbaKfkP8VAB7MZcoAkzEfV2Pw3zqhXKmZZLQeqRjD9zjMk
48312	payment	2133	2133	1874	1	1	7435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83CNi5BMbJBpZ4nQMVayrnyWeQeqXufiUB9jHFGWo359WLiLd
48313	payment	2133	2133	1874	1	1	7436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtm4gNPQzVZ38H9kaG98QTSwpXb4hioSD12zVgrPhg9LSwmjaR
48339	payment	1397	1397	1678	1	1	17904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDaCk2kPFUzQ7MhkJagN24JskM9d2hoTubxi5XWw4QrvBRtDi
48340	payment	2133	2133	1874	1	1	7445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqZHoeQdpRHhT6Gq8J4kkhYnJUoGLrpem6XVsAhgUTzUmZ8Re
48341	payment	1397	1397	1678	1	1	17905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLA48x8udBwuZqtLbqXiL29z3o4kUnCkhADdScwd5i9F4mMoY
48342	payment	2133	2133	1874	1	1	7446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPvodakiGYa4HfG6qozLFm3JGYBALPyLzwAZqXTUusCBwXEAo
48343	payment	2134	2134	1874	1	1	7969	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbJFRk8JLpieDpJFLkgmw4MTHVzKLr71xfm5vf4Q9orST6HgG
48361	payment	1397	1397	1678	1	1	17912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KJME3XHaKuUcrbyWHgYXTbtYi5QCQ86ukTBXEufjyNCqW3PV
48362	payment	2133	2133	1874	1	1	7452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8sRLrfcj45PDwigw2uagMqsLk8pq9sjy7DpQALxBctA24ZzC
48363	payment	2134	2134	1874	1	1	7974	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVgaEXVmu75KqrMYfpGiav43nDBbohJv9J6EhzKBHdAnUJ7sp
48376	payment	1397	1397	1678	1	1	17916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Mr2XHJmyYsepSmSv6B3LHtpyB2WNQDE65jJYxcY6gm3muAL8
48377	payment	1397	1397	1678	1	1	17917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJDRTBQaMfTP6QLTG8BuL13dWtRjfweSz4rQXYUWGRWsamjJN
48378	payment	1769	1769	1769	1	1	65	20000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdgJ3FRinUFS4vJgdvMun6GhM2iDb4nR7ubvMM4E7gBj7wrhP
48379	payment	2132	2132	1874	1	1	1950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8bqTsCwxTZNp1RZqHRhdv9zzKofCFvfnHqrDotJkwPc8ZF4J
48380	payment	2134	2134	1874	1	1	7977	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzZjZRWmn8QciJZbxo2DGu4xWSM2pMxr7QWPikTTpBBcnKfbA
48381	payment	2133	2133	1874	1	1	7456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTHLjDZ94GnwRYu8N6Kox1Fu5WMTatUssfXetEFR5tA8CmJ9n
48382	payment	2133	2133	1874	1	1	7457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVH6KErKgxJTr94niZN45Ev4k9vDJ4EtgfuQRyMHuZtsoRmsV
48413	payment	1397	1397	1678	1	1	17926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmNEndznQLExCYnFU5y36ujRDPz7jkQ5DgNmRwnGXaSWh9XwU
48414	payment	1726	1726	693	1	1	8362	100000000	1000000	\N	E4Yh7V6ZEdJQ5nc9AB9yb2YXffS7YKSGDtb46aoVJJKJ3m9QPjsxi	CkpYrqw6Y985aWJkbyaTkG1C9v73eizFmdKCWsdMPQ413J2UcRhRL
48415	payment	2133	2133	1874	1	1	7467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj1rmgQjdzXfjJ6QCT1z4MKDDoqS3FA6EviCnRC8ZQPMS71tk
48416	payment	2134	2134	1874	1	1	7985	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCesK1DUULq85kS4EPL3ypu81MpHP6MpsgHznSjxovqd91ktpi
48417	payment	1397	1397	1678	1	1	17927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPGbNHzKM8xFR4FiURwVcttEsPpHdgw7JFZ6THUj395cFAk1n
48418	payment	2133	2133	1874	1	1	7468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZnge5YS3FDzMJzaKrjpZYSAFvVJ7hC5egZUAwZP4BQj3nD7v
48419	payment	1397	1397	1678	1	1	17928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KHvDaD7b752avXw6SimoW6jbrecqQTq6cxuxa5otFVgC86KT
48420	payment	2133	2133	1874	1	1	7469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEwuR3Hxf4iMZVdpBtoUe8EBq4cG7ovZbb95d76PFVT6rThV9
48421	payment	2132	2132	1874	1	1	1954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xAn93bzsV2X6hF9Y8ciNpXsFf41MzQ5m1dv3zpNACKpwieVc
48422	payment	2134	2134	1874	1	1	7986	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQNU7smggxb8SsxFVaivNgGJVbhWNE1R5QvBKhbXbj5eE9oeX
48423	payment	1397	1397	1678	1	1	17929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uxzDrBontYtixZfbyA4wXDRSNevUz8tr8muB9QKR1eNQTziE
48424	payment	2133	2133	1874	1	1	7470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8995M2TU7yAa7Pevro9LNRkyfRHyX6fkdFZpnYRd5HByrD4f
48425	payment	2134	2134	1874	1	1	7987	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZecoJxME7i7oLLMWHJxECLyY7ycg7PxC37GjDeR6FZw4qszGW
48449	payment	1397	1397	1678	1	1	17937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLncQoiMxmTd5ZHvP8obVDSK4RnMsMkDLnWHYpVLejxQimGhn
48450	payment	2133	2133	1874	1	1	7478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJiDUui7F6SPmQRR26aZyWe1napvqv8q3bjBkGBH1bpBvQpCQ
48462	payment	1397	1397	1678	1	1	17941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZp8wyDBQCYVu5tQgJQekJFoHadqkmn84Z1xQCQa6TmGPN3Hx
48463	payment	2134	2134	1874	1	1	7995	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7mxTSXLBX2CVmVwZgZm1wceNs7dZmGLkiN2ViGKJW7YkT7Tf
48464	payment	2133	2133	1874	1	1	7482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnprVfbu4xVA85kb3XPxeeGExia2DgfgmxAqdvsc4M2WsTfFF
48481	payment	1397	1397	1678	1	1	17947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGw338WBAuajFpPJn6KbsXdiXBQmyXsBgY3deyz2CoRVkBvdAs
48482	payment	2133	2133	1874	1	1	7488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgSxizjNbY7L1UkQrqxois1UvUzAPemVZExv2hh9gE1RUo5eC
48483	payment	1397	1397	1678	1	1	17948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSQrZC9M6vB1XdBQ2X6Zd4DBf1bHTgK7cgiwugKkr1AnnXHao
48323	payment	2134	2134	1874	1	1	7964	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXgVJcLNwwzgg6zro5YS4nmwG65eFKdCMuypo9QVckNF41uW3
48324	payment	2133	2133	1874	1	1	7439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJUKZzj1E1JzRcd17AqmE2J9SBuAx7qX7HDhQ2Prrkv6fgzfd
48325	payment	2134	2134	1874	1	1	7965	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKzpvn9EicsdwVtVNsaB8BRT5n12iXy6WFScDi53YmyzjcHaG
48326	payment	2133	2133	1874	1	1	7440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdRwqDYVD7FXGXNp7dGijZz2H1Cme3xYodpJJXTcW1rQyycTk
48348	payment	1397	1397	1678	1	1	17907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ByED2wmyj5BAJHBQEBm5tDtb1qimwfEJVCrApreX1WgJh998
48349	payment	2133	2133	1874	1	1	7448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFM5Mpd7AC8eUCDYa7uK7hTwbB7SJFgxhV7JudrQ4Mpjf83E5
48369	payment	1397	1397	1678	1	1	17914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZST9XHxa4YmCL15BZWx9pKwQXuaFi8KQYNQQNGqtpz9LpV2PLz
48370	payment	2133	2133	1874	1	1	7454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUv6cTZqqJbZcYt9w6S4ZVE98bVvZ3wXKiPseGWBoQw1LB8tY
48371	payment	1419	1419	2419	1	1	10	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazkLzoWc2yfx6RXDtLW5yzsZXTPHAeW9Sivq5dek3n2wvNFJy
48372	payment	1397	1397	1678	1	1	17915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBRNfdXvuaFPynM2e6E3PNqrE5r78ycDSyzAopeFEqzgzCQAW
48373	payment	1419	1419	1419	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTqQHB1bdujxTR8z5CzsZWZjho8AzmPPF6Y8soDRgoW2PLo9b
48374	payment	2133	2133	1874	1	1	7455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDzp57D5vhvH5Mw3V9r2KCZ3MjxRXqCS1ExWNPCZHyZVcseRs
48375	payment	2134	2134	1874	1	1	7976	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gG4o1Q349y6TRewWBsM9csZjCpjWx7a5DhuGB8BmNX1f956N
48387	payment	1397	1397	1678	1	1	17919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJF1vY9NX6JFBrCuSMvhcG8aQnUdoamfMioshs7dpChGEnEYF
48388	payment	1397	1397	1678	1	1	17920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59DwL6UipyzfrofBSV6D2ycWrP7sXx8KbWjPJt5RRurq7fu2D
48389	payment	2132	2132	1874	1	1	1951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN34YLzFBZ5vS8Nb2QoRGANSnvPmKp2d9YT8DHYX79xfeSxR2H
48390	payment	2134	2134	1874	1	1	7979	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1qqUhZJhPXFFvELrZAN3rVXDBkrDKNaEHgXBhbDpz3iL4UeQ
48391	payment	2134	2134	1874	1	1	7980	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVJwDmvurcPH28ioBWCTnzZHDwn2o6KtvFRHcEDJzBFG2zLeq
48392	payment	2133	2133	1874	1	1	7459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNSVdJ6Pk1jEmMn6Uw9hBr3Sxzta2cizRMXUATtcoGoo33vzN
48393	payment	2133	2133	1874	1	1	7460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgp8FLc8CGpuYBW4Qs3ZbNiz84CvB63jzcLmHekUgsz2W8oRj
48407	payment	1397	1397	1678	1	1	17924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8ZNY2DfvUeZoJf5H2gUEewyFW4pKL5MvFLgyNhxDZuDPGB2z
48408	payment	1397	1397	1678	1	1	17925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsPLEmm9Gw3vJu7rtrmpPR1Trog71rXQPmt33DXoJhBocxAJT
48409	payment	2133	2133	1874	1	1	7465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiFuD7C4GJaAk199RVnjGQcPeXgNfQn33SsUfrEqyojivdWrs
48410	payment	2132	2132	1874	1	1	1953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpnsUom7gJ9MTrw2hc761iydZLQsj8pK6z38P8oeoDgWa5uPB
48411	payment	2133	2133	1874	1	1	7466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKbRuvHkdd6YpgPDovwvpPG2yQZfuQ7k4WhR4kkvmPofoSBQ4
48412	payment	2134	2134	1874	1	1	7984	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8td3mwYTrybrukhYr1yJKws1Dger3V1JYZmFCQT1jY8u5JBk
48433	payment	1397	1397	1678	1	1	17932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs23NoS9aghcpkhvzDV1FTrnHYzjmwdhNdWypU8PEXusoRtKx
48434	payment	1397	1397	1678	1	1	17933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMMWmTXWvWScYQ98V2VE5CcZ8chTf3gBsDL6AtjqcBoZYEMJB
48435	payment	2134	2134	1874	1	1	7989	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdUmFoWip8YdrtmbbFm7QnK2zemJVVZGm3kjBrNRn8qaJNESU
48436	payment	2132	2132	1874	1	1	1955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnDRb9fJc4kkBVR4H4buYvAfKfSxLRDnrvbUvLjABYNyPegBi
48437	payment	2133	2133	1874	1	1	7473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrAxWRo3nfXqu2j1JWZkw91ZRZJjpPgEN6Bvmo7eUpyqWdwsR
48438	payment	2133	2133	1874	1	1	7474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRGdmWJKCHZ3MsB6MzikajhYweHmi9bG4y94n2cDQcGKPYdiu
48459	payment	1397	1397	1678	1	1	17940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNThw1FbFyCFHevbJXM4DLiCcrf4VRPheYCmu43nceVpS3UXV
48460	payment	388	388	1560	1	1	0	1000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCuHENWX7of1zhqxZscSRaEr5B6fToHfukuKvYgK66UkSpVCf
48461	payment	2133	2133	1874	1	1	7481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53kgXXgTFH5rcaxaiZmhg3owVj3MpvHmuGx3B6YoGZix4Tt6r
48469	payment	1397	1397	1678	1	1	17943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5bQFADPMk9Dg7qMaZPp8VFnNdpeZ3U4ekVcEdeL5QkFDK2uUt
48470	payment	2133	2133	1874	1	1	7484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RpJYnUyFBqniAdW7rfuxq2XZHeasWMo19DvfpXPdntwZSjks
48487	payment	1397	1397	1678	1	1	17949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRKuy1nbvQVpnsbHgSGp6m5Mu9caZrWxZRPtHbpibcSgSp8P6
48338	payment	2134	2134	1874	1	1	7968	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAxfmYAvA4b7Hg5LbGSsJWDZzagMSCrRdVwbSZaTV1gtjBGuC
48344	payment	1397	1397	1678	1	1	17906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaBfGwfo5BnTKdFzDsA3Unn3pNy2wsDAgxZNPHdoa5MtCBAqb
48345	payment	2132	2132	1874	1	1	1947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkSfS5EqE9XLhoNuQNtL9njbk8hjzuww3LLYwR7CeLXjaWrvy
48346	payment	2134	2134	1874	1	1	7970	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKeandm3Ydn81yRNQA3rSn35itM452pLEAsXRReSEBosWVfmx
48347	payment	2133	2133	1874	1	1	7447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1hG81p21LhNpk2GJqgyHkWpahWnYc32njSgxs9x1YvtqNvCd
48356	payment	1397	1397	1678	1	1	17910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8q7UbmDxF5Di6XVFJZsKr23Je71p68EgiD2NSwoBZt5tDFsDz
48357	payment	2133	2133	1874	1	1	7450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVvc9AsPUQrgxJDwo83SXben8NictkjY2THX6GEZFKnk7nHnr
48405	payment	2134	2134	1874	1	1	7983	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTbnK5VTvLxwM344XsQAifjJGD9C7qa8nP6J49MAtuMCQ1nFP
48406	payment	2133	2133	1874	1	1	7464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQS6k622tH9avSsezoFYqc7CTUAx5jVkV31ZA8bKpN6gGt82v
48442	payment	1397	1397	1678	1	1	17935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVDgxRLV5sA5xyLuetJ8jVT93X4XxQqjMSADmNiU53x3ardwq
48443	payment	1397	1397	1678	1	1	17936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJRqLdmCzzXkxvp9fsTA7NQtQ5X2fi8D84chrv8x1Tbb8xTgW
48444	payment	2134	2134	1874	1	1	7991	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1H8Ho9nS6o9RwG2ArtnZ9B4mCoEwoa7izCKBXiYyBraLdi4p
48445	payment	2133	2133	1874	1	1	7476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsFJpKdhKCLVbduj9yxTwTijYZjFpphHDqBKduUoswjpbTrpX
48446	payment	2133	2133	1874	1	1	7477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWre4Q4a5R7VkRwjQTZRaTUjrcFzptsJnpYJwDkcCdZFgeTTig
48447	payment	2132	2132	1874	1	1	1956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NDuaMGDJgnPSwawrwerc9hsUmwxqpPeivex9YPERZpU7Rh21
48448	payment	2134	2134	1874	1	1	7992	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T7wxtwTc5xifAAt8cB4aYQmR2ZYgBEiWiS4q6WQSqNRZJAE9
48451	payment	1397	1397	1678	1	1	17938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qQYzP3Ywdq2QSeFgbd8r2QLmW7P52qzdF9TNgDySrmTtte1o
48452	payment	1397	1397	1678	1	1	17939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPhB5y8XmK1JSpBxpiTCK81yNVjp5QmQJ28kannhFjgfDWr7S
48453	payment	2132	2132	1874	1	1	1957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxjUuVUqdNq4NYracyMfGKx5RAAjdT9AV5FX6uzdUj9mp6ccZ
48454	payment	2134	2134	1874	1	1	7993	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUkeqThxKgZXrqWXMYfezCm2wzyzJTG15brb9XS2BNaBabooU
48455	payment	2133	2133	1874	1	1	7479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZr7myK8aiUdKC9tc4EkQFc4jbjNMaKgYtBTzJVpjrcaTNKZP
48456	payment	113	113	1504	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgR9YFKGKoWtxur2rMoFqkCEHZKNJ8t7tyLBPiDvSuoMDkxrm
48457	payment	2133	2133	1874	1	1	7480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGCL9WjpmfCSetjvrbFVizWb6jSaCXYk7VaK3nBuD8CndxFV
48458	payment	2134	2134	1874	1	1	7994	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eMSkLEHDTUnQV5s7NnPfycFZnCaEuALRPUH5JK3JjWzzA5p3
48493	payment	1397	1397	1678	1	1	17951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyBZoCi1BDzbsmESofPhevuytgq1yYQ1rzqv6HVZTB1Kaysa5
48494	payment	1397	1397	1678	1	1	17952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghipYAMfZuBaL2KK2yr7BXQgS68yt9TA2VuwLd1vLvMTEiS2S
48495	payment	2133	2133	1874	1	1	7492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMDe8DWje8kMUdtJzqzZDpBtkqrQKfASXFHrA3t1Rkhg4hMQr
48496	payment	2132	2132	1874	1	1	1961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuepNPWpmP1D4DXUWHhbyERnSgrDagU24Hm1VTrJLzpo2UKtjf
48497	payment	2133	2133	1874	1	1	7493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykAKTgLer8F416ZqTat4MkZk9rwP2DBLFDE5gKmS1ddg6hVeg
48498	payment	2134	2134	1874	1	1	8003	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxUMN8pCxuZV8BjUpmVzXMXcvEnedyArgPRP8qyuvCSeVYras
48502	payment	1397	1397	1678	1	1	17954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XAxH5oPnup3d151dvjyJNYWZhkevznfNN5ZtZYCDdr8Y4mQW
48503	payment	2133	2133	1874	1	1	7495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKc2LqM2EEipKwGf4tD56GUmr4uFXTSPbm87Munp9ttzZKkqe
48508	payment	1420	1420	403	1	1	1	300000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsL7GyYNKDonMsrXvao3D8M18WeNyeRBotRFHN5Bd32Vq8zTf
48509	payment	1428	1428	472	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KiS2vVuXfcwQJNdjyEAGyVZVLxJVv1Dho1vt9vPYuxTE1N4S
48510	payment	1397	1397	1678	1	1	17956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnRMW5WXWfiqqGtJcdtfQ16zPPR68irpjBjaJQygXTmeJSL19
48511	payment	2134	2134	1874	1	1	8006	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRsSPTEGszTaSFyXdWAGHmcDW133BtB6dFxhqyKqMkuJEcaNb
48512	payment	2133	2133	1874	1	1	7497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TqNesRpHh8TkU8w2uxBboyxuNwCUippx3ujgyet6wdzfn6f2
48522	payment	1428	1428	472	1	1	1	600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLNnMZXKSVMQuCcZhXJ4vpjrB6NG21nv8xeMGGAvw2GmY2ztS
48364	payment	613	613	599	1	1	0	900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaxEJbz7Etqq6B5zGo55VHPgaZqMKZP3MsKYH4Nbr9iQjh9uG
48365	payment	1397	1397	1678	1	1	17913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAft9qwUPtpNxbB1jf8iARMm7uS6PK2CvkzBWUoDf4XRVqQnj
48366	payment	2133	2133	1874	1	1	7453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbP8FG64a56mCmzh9Hg8f87oiNrB12kD5mPjnNLCq9Qoxhzza
48367	payment	2132	2132	1874	1	1	1949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eathzdoVLyVk3w3apG8McZnMS6grnAvCLx4bZEw65zpX5PH6
48368	payment	2134	2134	1874	1	1	7975	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYjewNpDiNRweTiSkEo1UoNUWHAiCqSQQbUCH18SQfT1dCXt2
48383	payment	1397	1397	1678	1	1	17918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXamNMm6aLguRYAkyuHf7KFgk7kdFxfwXhFA9VLUsc1WhAL61
48384	payment	2133	2133	1874	1	1	7458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwH1JZhg7Uh3iQyw14t9uiD2W5zMMNBFW2sK2enCpkdxvZ193P
48385	payment	2134	2134	1874	1	1	7978	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMHnhDofHLvnMrtounp22pVEJxzbRqK7BUx29H7xyyPTYmrfG
48386	delegation	1769	1769	1406	1	1	66	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYauXFRD7QtHUwrxDY5Wdv8VETctBeZ6GDXbUH82X3KDPjpTW
48394	payment	1397	1397	1678	1	1	17921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUqEDq4gGRtTr5WT9kWybfRuW7dif8hEzswPjRCMYt7EbnSb9
48395	payment	1397	1397	1678	1	1	17922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmeJL7gqvYLbKAwqx5VzucB6BkhtVRswYKyZUnn6X5VPnLaWW
48396	payment	1397	1397	1678	1	1	17923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gpwSgzpEkW7Sg15fTnbNS8NW8vvxwECkByY9uvqecsnFvVRQ
48397	payment	2132	2132	1874	1	1	1952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsB15WCXKZPXgStjwJVdd6Je3dMeKsRYZpd9eJBwJTqr2FPiR
48398	payment	2133	2133	1874	1	1	7461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqFJY5pPzsrvJJatakP7Bxc4sFWEAZCK8fjCvDyzUsDyAJtpH
48399	payment	2133	2133	1874	1	1	7462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ61PLR63oFnpRkDD2t9KyCHvAouo9tZYyejBbpEuKNAmZLo7
48400	payment	2134	2134	1874	1	1	7981	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeen2cF3u4fQ6MkDK1hpt3ZdVSmvjCsMAndN9ktqc1sYXZuKj
48401	payment	2134	2134	1874	1	1	7982	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmBU3GQL1HYTm1ieJm3RssU9zJRPESu4ud64gdr9QEUXhWWMu
48402	payment	613	613	599	1	1	1	90000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4VVWgZJ4tVB2LsRySf2kvXcbjwGZNiFvmDwbptKMZanXqzk2
48403	payment	613	613	599	1	1	2	90000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtrTNYftBd1rWk3NHvmBLm85e4HEhWFtBAdhzsfKi1dVvxf5y
48404	payment	2133	2133	1874	1	1	7463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKXSQ4xURRKXS9Tve9HxKRp1WKGCxe3sFAhtj8Urf66gncHC2
48426	payment	1397	1397	1678	1	1	17930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzy4rgHaV7ayRkKhtwx5rG63BHYM9q6WzJM1fEcSNQ2iXgbiH
48427	payment	1397	1397	1678	1	1	17931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzydEVgoSHGrLoSZKuCLJtXeZeBV8g1C52NSdjppENYjKE1hTt
48428	payment	2133	2133	1874	1	1	7471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbgEMmAf4vD8QQ89njUs2WX14ZzoNahoNq7moqrkQamHfhegq
48429	payment	2134	2134	1874	1	1	7988	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8SGBTLv7NwQajREKWxRfH7cndn7yMUYvQ71ceRfnLM1D7m1t
48430	payment	693	693	693	1	1	1	1000000	1000000	\N	E4YXPnp379EAjxe6YZWiu8n2abZM4GuCpa2pZyxc7SeJfcu8BUjsL	CkpZiq9J6ojfgT2yn6YfB17GqKwakJMymiurg8vW1vfQG6ujLFvaV
48431	payment	1504	1504	113	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynEMEG8ykn7cATrbDEpVAaQuwq5VWoXAmPy3x8ruo24aG42Bq
48432	payment	2133	2133	1874	1	1	7472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7fKY6768Pvh7AcBW8Zc6JxX9xDBRW6osWq9dUJXf6rk2q5Fe
48439	payment	1397	1397	1678	1	1	17934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWYBiEeeAU2FJA5dXtbJ9sYjEfByZPiAwSCZDDBtB4DFCHGVt
48440	payment	2133	2133	1874	1	1	7475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYrEMSTroBkbJPEkMv8YnbucwW4tdeh3YLA5U5uu2q769DzQt
48441	payment	2134	2134	1874	1	1	7990	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJwWqSo3JqJy6Z6ZNyLziNuyrJbo85ZtCCXFi4hMi24bpnuafM
48465	payment	1397	1397	1678	1	1	17942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6zK2TRsenJwNDQiJ7dVhED94R9MrFbE6MPU46cAuGXH4XpgR
48466	payment	2133	2133	1874	1	1	7483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNKryDLeTewFsRfw94rpYKVxJDwmnygFyyvs33qR2PSnbpyWP
48467	payment	2134	2134	1874	1	1	7996	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLz7HpDRzu8xPTAUCAdUTwSAZQq7CG3d99PcVFrD6XsfuCuNS
48468	payment	2132	2132	1874	1	1	1958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiusxcgYEU9Eh2DxfeEzPh2ajdBRJFMhzxVkpWTSMvNiNyegWA
48471	payment	1397	1397	1678	1	1	17944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLkanELsE8keT7hbYxd7rxsYn77iarTrtKw92km9KGShdoxYA
48472	payment	1397	1397	1678	1	1	17945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytE7mKyusCoELFhGpWLnRjewqvybpisobCi6okVgUEbeXpfof
48473	payment	1397	1397	1678	1	1	17946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTega4WZ5paz9pHGf75F8kf7hYNSrspbro5xpZ3JH6ZKVm8JX
48474	payment	2133	2133	1874	1	1	7485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLhgzx5FHBM8ekwwLKK3cLcHtkKHFuSfvLsQXKg7GLp4VARck
48475	payment	2134	2134	1874	1	1	7997	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCW81KcrdsYjWvwhA3vEyjRghztAH84CtUYjgUqPgyxb21Yy6
48476	payment	2134	2134	1874	1	1	7998	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE95fxnU8przJRzRbzooHyAqPiY6t6scnEiSRYvohn3hoS6Bym
48477	payment	2134	2134	1874	1	1	7999	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6x29JjwxSF6pt4pWir9SntXysDtcRUNpSAjgDHCtRWwyBMxcs
48478	payment	2132	2132	1874	1	1	1959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB1TMm8LmrEq5Sn24cLf5equksW2bZaHAsXiQRzDFXEdKpmN7
48479	payment	2133	2133	1874	1	1	7486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iiKL3uQL5TnCA9Eh6LeGuA7AhfWzigvNiXYMgzNXfgxhfdyR
48480	payment	2133	2133	1874	1	1	7487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDXGeJAiaoVYemaZLAPzKYtNNGY8SKZjHZWmvQ8mQYre5aAzu
48499	payment	1397	1397	1678	1	1	17953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxSjoj52qx8SH1Ww2yLGX11FtR9VvqG3gsCYVjXvw2dNTAma3
48500	payment	2133	2133	1874	1	1	7494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnJqwuEGrhkakey4uMDzaowPXHye1Z6UAZyCvLvJerYu9jh1i
48501	payment	2134	2134	1874	1	1	8004	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1dXP7LYV8CZ1VD9aRpxzcipr8ZzckYvkUPvdGz8xTf7XwfiX
48519	payment	1397	1397	1678	1	1	17959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDENYQjzwcQzPsqSoB9AimeJnkw9icSStCWT7mqvZufNgwyXqe
48520	payment	2134	2134	1874	1	1	8008	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjMhBvwJYGtD2sh2hSbxcvaUByYoHdGcbMoTLRGpfprRio4Rc
48521	payment	2133	2133	1874	1	1	7500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92ZLAB3WW7kyWthGJ7xNNuVvLAFWvozuDipxnzi6Sqqvgq2uj
48533	payment	1397	1397	1678	1	1	17963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnkH4x3fjFPJKcgrLqvAcDvdPorTXN98UNkZEKroyNoSNKWPuZ
48534	payment	2134	2134	1874	1	1	8011	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMtLk3N6m7Y7mRvvVyJVfj2ytcvHXFV9Wn8YMrfr8aYkjWwTW
48535	payment	2133	2133	1874	1	1	7504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRvbRo2fXLbcyhhgs5gTMhfywJGq6iHSsgoGSzY4HR3TXZ4FC
48549	payment	1397	1397	1678	1	1	17968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkU5VQ2iSGvyDYeJvRh5eFhk7PG2miXZfXDFhmrS1TrMpGEzC
48550	payment	1397	1397	1678	1	1	17969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQBv9arSvMybRnYqTXeGHgUAskA5UTB9A2pNSiXH4NVksZ56R
48551	payment	2134	2134	1874	1	1	8015	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq89o8F9ioXaMtDS8932EHHXn6bJz8RKZQ9enuk2WT7fxh8uKZ
48552	payment	2133	2133	1874	1	1	7508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vHY8zxQy5LuWiBkSiJERZrpaZgmaN9UYYZpmsuZZhJW3BJ8k
48553	payment	2133	2133	1874	1	1	7509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iGP54g2hvYnyG4kCLjv2PhA8Sm8b7c9AUCLvp8hguTKniDuf
48554	payment	2132	2132	1874	1	1	1966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVPPwtNkaF8kSEA159etYefwcn2PZoVoLcPXFDE6K5yawQLne
48555	payment	1397	1397	1678	1	1	17970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToKTD3dCmEwWB4Zo98RgKC9GeHQaqYWxPmjjo7tztZQNU4kyD
48556	payment	2134	2134	1874	1	1	8016	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDEvzcrMc1hm96bRtDLBS88XJXVBNYhvrjjV6xCJQXQznbidd
48557	payment	2133	2133	1874	1	1	7510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTe3diFjS7mpmABEq6RuKY8iRQg4kjdH5EK4owgk72E9scMbm
48614	payment	1397	1397	1678	1	1	17989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLNSBoHi74Cm1x9RuEZFWTXxVucR4Pz5YyvoupGLFuf2chK2V
48615	payment	1397	1397	1678	1	1	17990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAikuzm8ymNfgq6dGjBEhGPtjL8UyDn2PShZHGK5Cjp1oFsy2S
48616	payment	2055	2055	718	1	1	0	2000000	1000000	\N	E4Yyk7ir4jPmppNr3sELP2QryGmG9sL2s2nS2rou7uFt1eb2tmcq1	CkpYponhxdYWjeF6BrUccJQXnVrYodsMfXSPpWm8PAeWCfPmbCou5
48617	payment	2133	2133	1874	1	1	7529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuN9WWpVuonhFJEiAA1NvZQmnQBeXkar1SPVvdZ68sqnuAj73i
48618	payment	2133	2133	1874	1	1	7530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZMCWu7Gz5S7J7pNKnPtzpA2e9js5FevXfH39132gWxsFhMoT
48619	payment	2134	2134	1874	1	1	8029	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3g1C3yPiMFv2xWvoHaoCTyVobxDUmTV22uTaj1WVxdAa3DkqC
48620	payment	2134	2134	1874	1	1	8030	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bYehqYQUhykuvA2FMD2tsPb9QamEcDncAVipASM7xST2P771
48634	payment	1397	1397	1678	1	1	17995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ArYnV7xaJ73CNbyYyFbFP1hw9JFmd2kQFvEK9HC4DeiPa2aG
48635	payment	1397	1397	1678	1	1	17996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajhoVZaXScQ2t1RTvdaqdrE9d38HTP39hZmNhWXRkJdDzNefD
48636	payment	2133	2133	1874	1	1	7535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5gRKvB3KUwupszf63BTAChXH4MGgoa1D2nndaWhXMK9TQgZg
48637	payment	2133	2133	1874	1	1	7536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaizh1PBoVkpSxkEkHwH1HP3U78kEXGzrZTB449z2EJM2Zk1dQ
48638	payment	2132	2132	1874	1	1	1974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXSVwPNA8n1Az9HEdC8hc7Xfa7LAj31M4qa76MorxE5fJ1N4u
48639	payment	2134	2134	1874	1	1	8034	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XJBafhFuo6DAV28sxxDdFd37auXvcPLBa4Rjsh6QhMJ7Qitw
48646	payment	1397	1397	1678	1	1	17999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6Sfdozz2tH2RUHs3SpBtTfcFKZjzdcBEtWmvSHKMUjr4ieBp
48484	payment	2132	2132	1874	1	1	1960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1whGjS5eYmv4cufaekgc9h5fFB6wgZKjWZ4YWDLyaSE3L9oc
48485	payment	2133	2133	1874	1	1	7489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14NyALhzRhyAcR7PGgMVHQovxy9JB4JSNiFGNqrkp6vZsxLLj
48486	payment	2134	2134	1874	1	1	8000	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVVDRFrJguNGVvYP56JptfmtZ11S83RXAG7USAeyCc6tWqUGX
48504	payment	1397	1397	1678	1	1	17955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf8nJ1jK76kwr4TysNB2vHypw2b7icgno87KSNASdy6eX5xoQ
48505	payment	2133	2133	1874	1	1	7496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu3g3u179oaPohvTLWLrErxQBkCatVZgGG6yZ7sdfho5nbYsb
48506	payment	2132	2132	1874	1	1	1962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZEXGXjshKhFLPKR3ASXkdo7jBf5e4WnhUJ1sTdGcLBPgUgwF
48507	payment	2134	2134	1874	1	1	8005	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zkcapP73GatNiBafCoACmPuWasXwFgVJoJXYeUtYQKZEwZPZ
48544	payment	1397	1397	1678	1	1	17966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycD8SR3XNzjDdwYNRuCyYDP6XnFaBrLU3cNXTwLwpX6Zfmk6W
48545	payment	1397	1397	1678	1	1	17967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvHVhXtdzzTNoxCZkbDBX4LkqupQAx6aXXfRCoZv1r4fqKz1C
48546	payment	2134	2134	1874	1	1	8013	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZWWCSqhQ8FhoZm5TSDmNPN8JmaVsvyAoKKcLnGC2Z2Tdam3G
48547	payment	2133	2133	1874	1	1	7507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WSNSYYGnr3yHeG1BLqpCtXwVHUnKK7iQxk4DJEsFD1UbEGzV
48548	payment	2134	2134	1874	1	1	8014	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPV5KhDeTfdcS4M3saQCWvR3hkDHwiwXnsRBpK4XYM4jdogGF
48576	payment	1397	1397	1678	1	1	17977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9BXWGaojsmuFPUHrDqaYbnsX65dNwT45CQ7VPsjsiWzQidoi
48577	payment	2133	2133	1874	1	1	7517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLjvnSPnra9Mq6udp2ZWuoQF5ALokCG8ZM7hVu6pSa1kq3aai
48595	payment	1397	1397	1678	1	1	17983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32XbJDCpc1e9ghdmG1bdgfzE5NyGJ8UPJseqEEbN1K5jnUFef
48596	payment	2134	2134	1874	1	1	8025	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDGiWqM4XbqMWP6bSUk2jh3VxsjAVuGrTyitycLcH6nPe6Qn8
48597	payment	2133	2133	1874	1	1	7523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTkMtcZ1wgBeg5hDixgjcDE5JYkhvBrV8cN78zPR3SFbZVTia
48621	payment	1397	1397	1678	1	1	17991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuV4QUMEruMVZbCZN4c8hGqfEiWA4m9hgBS8fPizLw21SjtFF
48622	payment	2133	2133	1874	1	1	7531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHQtGMzTtfUkWLwdoHDzHFzaLyRFcmCYxHXPWmuCyenvymWqo
48623	payment	2134	2134	1874	1	1	8031	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQNfTTCyFrtWXSpQEfD6S2AGb3Va3w5qA5uHgGbWY4deFjTQK
48640	payment	1397	1397	1678	1	1	17997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kBeZDqHV8a5GRJBfifp1TkvkKdnP6ZStxdRpvxmx2w3rT9Kv
48641	payment	1397	1397	1678	1	1	17998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuK3iP5176EUXp5TwZ88TA81BVLot5iyrGP8pAChQzz26SVUjn
48642	delegation	2427	2427	1600	1	1	0	\N	3250000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bT42632FP5rWaUT2UdrH7nh1hevVctc2eXxvcFUASPLPCndY
48643	payment	2133	2133	1874	1	1	7537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZckt8zB7xTTbgQiERsEPC47HXgs81AdfgU1h4mmd9vaHUW5E9
48644	payment	2133	2133	1874	1	1	7538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWQ7ocuaxveCpPzeVPjdetW1otP6VYiC8xpssodq7yXCfYYZ5
48645	payment	2134	2134	1874	1	1	8035	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgTJV8AB6xSCHPD1UP6BZgz1E4wgyz9Cz6i591gUUTSFo26Ck
48673	payment	1397	1397	1678	1	1	18007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MwdeszHztBHJiyY5uxfvKHoehhHLCZyTS4yBkyUr5G2nsi76
48674	payment	2134	2134	1874	1	1	8042	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJTASaZU2YDR7E8SFwpyK2vh2YYsUT6KU5qqb5WsibvvRTxmX
48675	payment	2133	2133	1874	1	1	7547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ611hx1mcBFAVvCuQ2CuQsJS7kk5xhUSbwcj2q6L6tkH6gGLQa
48679	payment	1397	1397	1678	1	1	18009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTETe5pF8ddSRAPzhrE1DLKweFHyfH5Jsazm2ruCVdvGhWXea
48680	payment	2132	2132	1874	1	1	1978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqp1wHVzj5mWvmvfm543ZLUDujPLCECBzGNzWoNoL64NLXSaY
48681	payment	2133	2133	1874	1	1	7549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcUJUubDpWTQAeTtApxhsEhDRG4n1kVi7rLXqYRjVHPCavVMx
48682	payment	2134	2134	1874	1	1	8043	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56bexzqqyQMPUeqfE5ahZwmSGLpUxJEsHgHrh249SWwtjQtjt
48683	delegation	718	718	1655	1	1	0	\N	1000000	\N	E4ZKwytHYi1tLKQVpehYwgCM9isAogrGvK4Zvhp7A56cv4UePf6RQ	CkpaCQ8skJafFaCByPHqia9Sv1xR4vyKfcep5jvRBiTX2o4nhfLMw
48690	payment	1397	1397	1678	1	1	18012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKhoNwKUokmKUPMJCa8Yk4kwzPLq9fmpYrqroH6Q4MhzD5nRj
48691	payment	2132	2132	1874	1	1	1979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wkESKVgBm24nUR7mYMKwLkBYbCr6uQWHyTztzDvD7f6CR63A
48692	payment	2133	2133	1874	1	1	7552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FE6mpbRpyo9VThsXmr21DuEcxrNweyM422WHTQoTeLBF8bY3
48704	payment	2133	2133	1874	1	1	7554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WHtsmVLxi1FB8RgZ6JQXh9xzPNVaMWVQX7WVgRMJBps89V4L
48488	payment	1397	1397	1678	1	1	17950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphL5FPLdxgciyBS1DVDJAxDdpURWWC3xQ6CBUCTbWUdQ8v9AA
48489	payment	2134	2134	1874	1	1	8001	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaoedY1zzRrsgCF3StxWymU6N9nLdrZAkGQPGEryGeNGYBpUY
48490	payment	2134	2134	1874	1	1	8002	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVsWB86C6ee2X8NNVCqSKdtmrZNA7SjQPnTQeQfGD2BsLxotF
48491	payment	2133	2133	1874	1	1	7490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWmM4h3DYFuYP3A1EAQ5rWp8Fb4AXGh3LXAkpuBTtBJRYCDoV
48492	payment	2133	2133	1874	1	1	7491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciUuaPahTW7fyUeDkw11viiQNbxAGsL7w7sriM1CeozWsYHcL
48513	payment	1397	1397	1678	1	1	17957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E9Kjd995S4k9DCc1gRiBcdXhYkUt9qWB3WpzfV5mFrNJEk72
48514	payment	2133	2133	1874	1	1	7498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9Nc244E4d21nYhNBnYPwLzxwSeAmbfM8G3PAtyozFLGgGik6
48515	payment	1397	1397	1678	1	1	17958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUjFGz2HRmKDiFdWkkvAGhvAVSk6GQrTGFRWw3YrwXHuBP87y
48516	payment	2132	2132	1874	1	1	1963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiFaBbi6vtodMpb7RoXyyvxQXAVRVeJL1GUtQx2L5S8JwBWuS
48517	payment	2133	2133	1874	1	1	7499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaG8C3oFrQdUGTNyJnkzsTn1VuWE12tshK6pthhnqXfsYdtjB
48518	payment	2134	2134	1874	1	1	8007	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5YXvLyoSwSuTgUWyAf84C9NQg7YMTUTx3WKtoEFH2DM4VnPa
48536	payment	1397	1397	1678	1	1	17964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3C36hhvhyWMjFgkm8fFCrrzAQLRfHaMtHQcnkrj7CiLoXdn1
48537	payment	1397	1397	1678	1	1	17965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vbGuJmWeEVnagUdMBsHh5UvLGAhmsCwj36Qt2Aykvicpr3mw
48538	payment	2134	2134	1874	1	1	8012	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqovxDmZW3qioQZSYpVU6bzk2Qc18yojzkHNTwP2i2pbSUzYb
48539	payment	2132	2132	1874	1	1	1965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD6rcV1cNPrtsH6gBNSNtiS8SsNtRD7if6nS9C9SYT1yHrUXr
48540	payment	281	281	1591	1	1	1	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sJDrgCSA3VBXXvWvZ8jhBrJnxzdk4Nnw92mchPhtAPfzbZHu
48541	payment	1726	1726	2427	1	1	8363	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKNx4jyfn6B9fz9piA2jbhTsdPsnJpteneXY3kZfXURRfxUCQT
48542	payment	2133	2133	1874	1	1	7505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgmMQ7FHTPzKVLCxQLcWTWRs4WZymViWVcfPReXA2v3E1vYzA
48543	payment	2133	2133	1874	1	1	7506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9VF6mmHJLyvbfZzzPYF2aoPiaZ4wKsWPrFskJaqHpCs6yjD5
48570	payment	1397	1397	1678	1	1	17975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD56rfw3vxjEMDyo4vgjg69fhqLhXRci8fqZAjebQZk52waQHn
48571	payment	1397	1397	1678	1	1	17976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqm6NpfhchcFEZUZeyNKP6MbZ2hL1NspPKMhaJyEWMKkJxuhhV
48572	payment	2133	2133	1874	1	1	7515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyYhTVx6asDJxSGJXNLuqKbTTgRRXhfS94aPF4CGd8vrEoGn5
48573	payment	2132	2132	1874	1	1	1968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsGY9m9Fw8Bespv2dishGkWJjuh6ArnX5i9gr9ceZSgvMdQ8A
48574	payment	2133	2133	1874	1	1	7516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24MgiMMZrvatJFiwgfSoLv9ycV1REFB7jRKKHkJVYMkWawWLo
48575	payment	2134	2134	1874	1	1	8020	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsxtVLv1JgmJoaveBPp6HCBHhSfBb44ydm5GwdMq2YCcMcCvr
48578	payment	1397	1397	1678	1	1	17978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykFt7AYArFdEXYGLdL5yTBEkT3hr9fam1mVGbYRPFeHu2BDgg
48579	payment	2132	2132	1874	1	1	1969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzk52NPBq51PBsuSJedjYYeiJPawz9Ti6Gk9U4jh9B89GRE3Dn
48580	payment	2134	2134	1874	1	1	8021	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2Y6zajQcemW8rg8KiquxBqGGbyBvVF4yWJ51tr3WTGZYfRqi
48581	payment	2133	2133	1874	1	1	7518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oV7koXLokvZ8hvg2TUV5stoAgLNg65HrecJMrrSqreqfcTjZ
48582	payment	1397	1397	1678	1	1	17979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkrDTNdugZsnTZXywGeYFNPkrxBKMytQSWsa7aqGR3fYcgqJsc
48583	payment	2134	2134	1874	1	1	8022	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagoDp7wiMzWQPaU57jamQKrSe5nDUgPuUj8w77FhVa3TUmNAL
48584	payment	1597	1597	2428	1	1	5	1200000000	1000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpZKzgyiSPQ1etb2N5mPRz9cCyUR3yc71qJpBP2NacfaQhH6wfcf
48585	payment	2133	2133	1874	1	1	7519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA75jybHq3vWpheGvGSyUciEBz5KV4v1vCYXzLm7FsP2xjV3hx
48589	payment	1397	1397	1678	1	1	17981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFuNdsawTCiqytArK6XKaFBDvkEVqKfEyt58sXuePgfevXV2G
48590	payment	2133	2133	1874	1	1	7521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXb5KmyYotGJAKJ8DGU37ffvJN8i8ZsDq4v36jFv6hTNcdyfa
48591	payment	1397	1397	1678	1	1	17982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa529yxtiM12Nnj36vZ46j7DTrbGaWGaswQWnKU9X23qp1TFPxe
48592	payment	2134	2134	1874	1	1	8024	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWYMxy7CpQV8Ap1yvYzDnuwkSTD1MktGxhtMJogj1tSmSdKXA
48593	payment	2132	2132	1874	1	1	1970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLixVNPdJpALjqXiALVBj1UZBHsQe3KE4C3tQan3PjcXduMY7H
48523	payment	1428	1428	735	1	1	2	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsp1DzxvtP59ySvRLt2CxeBSLo2KSAv8193K4BqL2cF7bRwZHz
48524	payment	1397	1397	1678	1	1	17960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYQyeVMEbyH8tPLRo9vVUP7HhMmPGnkFKr9qoTdFngfqoupyi
48525	payment	1397	1397	1678	1	1	17961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNz8u5CRmKGrLd4awe16afGHuuPc9SpwwgwE4QbdSx68myRXk
48526	payment	1397	1397	1678	1	1	17962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vRMnQwqY1yL38jqk5s11YuKwBBqEx7ySktftCdFvMuPhW6LT
48527	payment	2134	2134	1874	1	1	8009	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7iX2T9Rx6S78mKwwv5pVhPeYNa9T9STt3J3jvTW24wr2qDve
48528	payment	2134	2134	1874	1	1	8010	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcfxfr8Sebkq8ZqXh8eeoT1ZGLsEGU1hio2M6fuqWF9Pt2qMV
48529	payment	2133	2133	1874	1	1	7501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJKeuCoEMLP1T7Xf6o3bhdXRCxv5UYZDsCwNZk68H4Jx6a6P1
48530	payment	2133	2133	1874	1	1	7502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdFZwYgNWD8fdxvWr59PWoAbNNQj1fvRGWXnJ7ZsZXqjjPtYL
48531	payment	2133	2133	1874	1	1	7503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZ6TqLFjYm3kdj5EMLfLRXfURsu9CTA2r4HPaM85EhBVpeHXp
48532	payment	2132	2132	1874	1	1	1964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUdU4HUMyyhwppfDrPv8KWHitUhFF3yAFuAW9Hf5dfs5kCH8j
48558	payment	1397	1397	1678	1	1	17971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPD1DRqWynS7ARaKxC6J8NuWePmmpc2W78oU9gzcS4kZU6ajKo
48559	payment	1397	1397	1678	1	1	17972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdd5VbPvvqudkpgVWbSwT5u3dtDNmzypxNqjwRs8qXYeBBRZ6
48560	payment	1397	1397	1678	1	1	17973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa453xUnJR3vPVwHXPoz4UsbM1YugYQj9xuMBiBa4K235rTgM3q
48561	payment	1397	1397	1678	1	1	17974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3oBwM9G5HAwrvY9VBAE4Gp2bzFKeNeirN6oKUW9WR3658qv4b
48562	payment	2134	2134	1874	1	1	8017	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDzZ9ds7ML3ejBWSCURCQd1BnGViempZF8442UPB74vYtHH87
48563	payment	2134	2134	1874	1	1	8018	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGNjp3CoYzmRNKXjpUA26pyAxoLP3s9rcWBx4zbusxZQ4nSZQ
48564	payment	2133	2133	1874	1	1	7511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNdgLjFgZDK4oxPE6qPxpeHL1F4fuZ3VjDTjFj6PAnqJ88Uqu
48565	payment	2133	2133	1874	1	1	7512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4Hnnea733Hvab9DySuezF93cwrxNSoBo4TUb8rs3Va92eVyC
48566	payment	2134	2134	1874	1	1	8019	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnkbgFH7zmyXj3DrRTQngjP7eDifScRoUNFAcjxCtftmnXQLd
48567	payment	2133	2133	1874	1	1	7513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2iebSF88NVUTwuKHCfyZXLGTs9oecJZSrPzbFAqAezqVMpTDN
48568	payment	2133	2133	1874	1	1	7514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhQZ9QswpAwqQ4ipgLhCN9DdLozxZEg8W5A6hQcL5r9vxfeyV
48569	payment	2132	2132	1874	1	1	1967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96xov64xRzrYn4wS7ww4FGbfb1qcfh7moVJoH4K2WdCoRfzLn
48586	payment	1397	1397	1678	1	1	17980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsHKJtZwexWT2b3A5vGmXK5XSu3RgaMwuV99oPFjxjLQ8AKwh
48587	payment	2133	2133	1874	1	1	7520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVbSk2N9Aj1MTaEeGHTKvrwMwFDTHsreea7dKzrnzVvDi16WW
48588	payment	2134	2134	1874	1	1	8023	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2vo92A6ETQ5EKP3rPH8swQBzuPSShwgWE4DfvvHgVJJs1GjC
48676	payment	1397	1397	1678	1	1	18008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXcm5KPzn319Ey8YE3PwK4o6Kr5HnuZ57jAPxA2Vs8PYFk8h4
48677	payment	309	309	309	1	1	0	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbp2Mjq7Kham19TrGpUWRRcEf5pZQyYpM2sZaQVoS6EDUrxhv
48678	payment	2133	2133	1874	1	1	7548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iHaoB571zzZp3XwYMPRW5ZNztsosiUREFT5a5VQ3LfjZyFjJ
48687	payment	1397	1397	1678	1	1	18011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbhmLqneRFF5gPRCBWpShV6jQs2wBEcvtowHdGQkc8PCyWGs8
48688	payment	2134	2134	1874	1	1	8045	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2GyyGDfFGLAiCR75Yz9HLibWkhNeRVMbCRNMtHVkX9GXfcJg
48805	payment	2132	2132	1874	1	1	1997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGfyGbG4N5XTAhYRKwKM4HXB3sW2uDQHrxwuXMfhXgHGQeFaZ
48961	payment	651	651	677	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2sGQKf35Lr3NFjxbkKtxrgK3J2GMLpGHm2pWwYYMtpdkREAb
48962	payment	1397	1397	1678	1	1	18042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrvG1A6QuKZdxaBuRV1xQftLnu8bjUYVT9v5YmZjsCFwcnLDS
48963	payment	472	472	1428	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4UoxXBCtSmevc8fWRwGC9tmZDjjwChSTkriYAAY4U9F945L1
48964	payment	2133	2133	1874	1	1	7634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4muuhuh5j1ZFRZEExRYVBBfiH2HENruVXbMNGHP4SXWbhBuZ
48965	payment	2134	2134	1874	1	1	8147	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBPPNHhmnruftYkH5EkS6JHgCfqpL4sfUMRosDXqHwMUzXX3i
48966	payment	2134	2134	1874	1	1	8148	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uLWjFYc4sGnoWzjCujYUzw4KzjQyHqQ9gKoR91inaa6BWDkt
48967	payment	180	180	186	1	1	0	1000000000	1000000	\N	E4YXPnp379EAjxe6YZWiu8n2abZM4GuCpa2pZyxc7SeJfcu8BUjsL	CkpZS5Z8o89ANPj6qtXUs3511FtxC17Rxes1f6udaGLvQDJwcrDrA
48594	payment	2133	2133	1874	1	1	7522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaMsMcQ6Vt36fnie1eRj5bsjqCLU8491RhZg4tp3yrQFYjSRn
48598	payment	556	556	1578	1	1	0	23000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERuZViy83JNPhKWLbRnpSziTGUVCGtu3kGmjq27NHXYVUXmWU
48599	payment	1397	1397	1678	1	1	17984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYowhdUDSiadTKoASqTyAyPt9fXWrTaLKhbXyU53yyTNFEsP6nY
48600	payment	2133	2133	1874	1	1	7524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qnUzfgcvuCzTqoKbLfYy5Ct49vRbk12dEjZN298cgth6Xv2P
48601	payment	1397	1397	1678	1	1	17985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9tgSM4tbkh93xHmHXfgSvcjDHfA52ytLpsK1VqZ3QQDyyJF4
48602	payment	1397	1397	1678	1	1	17986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3Fe3K681GrDGfoCZ1KirmK2YeNG96s34SR32gCw8VGLCPVaJ
48603	payment	1397	1397	1678	1	1	17987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYok1MkE6i9aKpZyQpTafJxca2Y1VF3BZGhsX8wUqkrzLZah3BP
48604	payment	1397	1397	1678	1	1	17988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtDurHQxVFiKfzmuEeuKSWNHtwEeviSg2y2wEQgWkDPLMBsks
48605	payment	2134	2134	1874	1	1	8026	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ACy984CyYs8gJuKofzfG6YVG3iiQGQezQswvJLS6iLKKrSfD
48606	payment	2134	2134	1874	1	1	8027	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQsux3iqHqHBgqwoBAUFFsXqPHa3yN37izaC18LexY8AvibXf
48607	payment	2132	2132	1874	1	1	1971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtET8AETWJw8d98v9XkadMiQrzX9NXQRJsEpXU4PpoNKp5haS
48608	payment	2134	2134	1874	1	1	8028	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfM6zSgafwviGYPkp8XbiFZWS8y61t9hz3dFCqgU6ZDh78VQs
48609	payment	2133	2133	1874	1	1	7525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNLqb2FuxEpKg7cFVycQiMQg7aXQiFtT7WmzdDNvP3auVvGoL
48610	payment	2133	2133	1874	1	1	7526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bY7ayzcta14K73qpADox5ozKFf4CzAFJDhR2NmLMHoUCJsxB
48611	payment	2133	2133	1874	1	1	7527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQ1VcEZA752yK2rALbqhh6aa5f9APziugCR8xadPCLQCbG1Jh
48612	payment	2133	2133	1874	1	1	7528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLncjRGE72dFoXGmWn6VWnEwEUu9BJfkpCkreVNFBZ2BHAJ7En
48613	payment	2132	2132	1874	1	1	1972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAayAHEFLkxzFrY8ARuHz9XztGiD4tzgpMm2VDVFTAYMhoe7um
48624	payment	1397	1397	1678	1	1	17992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3tqE9XVND9LRkp4ncF96AKSPCS92MCeunAZBSrMA6RpnrXak
48625	payment	2133	2133	1874	1	1	7532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11xYgXUgK4dGWnepaodiSwfBxdnYG4iM8HtXD6Ddsi1pGfoE8
48626	payment	2132	2132	1874	1	1	1973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5iG3FCZvyJ3mGLwMWANZGD2L5gm4g3cH52mqbboZejEXM7Zy
48627	delegation	2425	2425	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKw735jxgMiF36SuL9Lz9k9bpVr5CV5Cq2ZeD1SzTZzo3Yuif
48628	payment	1397	1397	1678	1	1	17993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMKpqwtXGEehuRDjpEw9KQXaQmBnJLnmixFx4Rqp9dfiZMMQ1
48629	payment	1397	1397	1678	1	1	17994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYaSGR9qHpyKErmVAzZWGNbiSRx5zU2PUL2yLFvQAuM1Cdx1F
48630	payment	2134	2134	1874	1	1	8032	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxcTzpG1uEz8B4ecvmRyE6QXgp7pmrXDZvgbu7Nky8u86ss3T
48631	payment	2133	2133	1874	1	1	7533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTi8aVzmjDjiz3QxGN3JEHcmnD81RFzksVgXBZhNam1SVuf2a
48632	payment	2133	2133	1874	1	1	7534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxTTmFnocTaUmdw6RaYf8HkD13H5zz8iGnS3AhMz1mLghWW3S
48633	payment	2134	2134	1874	1	1	8033	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLQG5DDhxPuecrZCMYraYSc8aF3Kc82pX8atZE8yJvQTEUCWQ
48693	payment	1397	1397	1678	1	1	18013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Anr1zJcLDGKW5TfgfVN6tib2UPZE1dZFrew5X57ZbvFf49k2
48694	payment	2134	2134	1874	1	1	8046	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJ4ZiDmpQLCwjc92ZiTYeUq5qHt48UDrLBB9WEqYq9cGnuB22
48695	payment	2132	2132	1874	1	1	1980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKuCjGj3cS6iG81GbtyaTp7tWyL4GVYyqvPfUje47iUJLuvWV
48696	payment	2134	2134	1874	1	1	8047	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpk9hrmzYEeTq2fnDmy8GakuYB5r12y84g8ZgoLv5KX7mt8fRF
48697	payment	2133	2133	1874	1	1	7553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJg5J8n19h6GgL26BcXjeotbFXu41ADiR8eXuytVbUWgiEsthV
48698	payment	1397	1397	1678	1	1	18014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpUYwVenW41tbw5Vg6CpnXWfheraPXWKunNiRWhKobMit9iDG
48699	payment	2132	2132	1874	1	1	1981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkZfkB7ptuxEqBmWxXNYYLKTb7S5cuTcGpHsLaZrtDJ4ALcDE
48700	payment	2134	2134	1874	1	1	8048	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHwWH2T4jhWia934U2cVtx27ipDQayhABLqSZdM2VtscM1uN3
48701	payment	2134	2134	1874	1	1	8049	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcJWx9NBJXtXPNXPCSQZe4RaZf2et1bspxaG7E7UQgkE6UNjm
48702	payment	2134	2134	1874	1	1	8050	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJRvubMtkg4yj51Emk6dWX4zSWfGzf46vdSDUYq8CFce4DC9c
48703	payment	2134	2134	1874	1	1	8051	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RKvvuZjzPjZGwGQkbZMdXCmhnAUpRQ94DoJDm2sfMN1Xu2A7
48647	payment	1397	1397	1678	1	1	18000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQHqqk3XrTcZzs6HS2ydMcW4gM2D9XqvpcqS23kxGQHP9yxeC
48648	payment	1397	1397	1678	1	1	18001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiCcjGivMVt6mFJZ5MTTZcpY318LFnA6q9aM7p1BtUGEhjSRs
48649	payment	1397	1397	1678	1	1	18002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3DbHcNkvv1522xu15Ad58A3YtY9Sz91TxDHB5AgrzirkavKC
48650	payment	2134	2134	1874	1	1	8036	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVS8ttq8KDG6sZ46oE82mZLRZEeJJBo9V9TxBcuobWLwy7Qpin
48651	payment	2134	2134	1874	1	1	8037	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRKbxLis6eEfHMp6szBxKzWBgnm9rsfCyCDE6xXzoZMgVnmG7
48652	payment	2132	2132	1874	1	1	1975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mLLQBsu7V8fdetwB1Ca1bt435ZQk2P67qmSPHixtPT9K1Kir
48653	payment	2134	2134	1874	1	1	8038	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoqhwvuPxyWuc8Fta295wC72Tf8cUjy2czbFR1Ui6cUXBRWVu
48654	payment	2133	2133	1874	1	1	7539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8rhh2M5CpYsuTzekMFebCNf16NeAND1gJGa1KadWZRfHYkut
48655	payment	2133	2133	1874	1	1	7540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNpR8DJd46wdH8y5LmdfTHjedLvLz8K5mQWBNtGpAXYXg53JF
48656	payment	2133	2133	1874	1	1	7541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgbfkkUGLKEBFe3ZWtcTgd8qrdbF2aD96txSgPfUoyeiPiVjR
48657	payment	2133	2133	1874	1	1	7542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezipBoJa1p4784oqMeovs7ZuR6TgKV1RM38iVsRrPUVxSw1ir
48658	payment	2132	2132	1874	1	1	1976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdchQktPtcU2CVhZwZ3bTeDerVHdZn3YmKQ6KEpfkT2pN2b5r
48659	payment	1397	1397	1678	1	1	18003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdGF7N4W4g2VsccMcypTuVMZYPjUZfQwxYaQrHWhKKBXCUJFy
48660	payment	2134	2134	1874	1	1	8039	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffo5FWTEBBSw6k1kTE5GdLJgeH2v3FdiRJqL6LAzrqsfn1dP5
48661	payment	2133	2133	1874	1	1	7543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhi9gk5ybttxSfmh17ZQXcVMXcMRWAn2kS8KCQ9gcS2bwZEF2W
48662	payment	1397	1397	1678	1	1	18004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6MzpnSqanWSvyxfqTU9JNBdeq5a8aQyF2Ey8cStxs2fJCR9d
48663	payment	1397	1397	1678	1	1	18005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsNEtPJyVbLu5nRJoeZg58YYtcq1xH3z4Pqizy2sEXknLi35R
48664	payment	1397	1397	1678	1	1	18006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3W2CeyzLTwBsmjiFkNtn4oBJwgP8v92JH3oJ1inJp7ezJQQf
48665	payment	2428	2428	1597	1	1	0	10000000	1000000	\N	E4YZZmcAyBPgg8NMPE6pHENXffHaHo1tbSvhNByXwj3xJByZNR2qM	CkpYws6e3MtyaUJUeUC33mLvnUq8iuFtcMLnF4UDhq9MuyzQZoeqd
48666	payment	2132	2132	1874	1	1	1977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhjc18FMvSrRW3ikwtT5HXmUg36MT5qN2u54KBQ8Dg8ke9qYQ
48667	payment	1726	1726	2429	1	1	8364	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiWLPMZJCE7WPMJLbxkf6Ls6Q32KJ7FpRhrP2zqMXLB6gege2L
48668	payment	2134	2134	1874	1	1	8040	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnE36v83J4biTPQFuGNjYRiZzGNhuQAsVMSx2AnBWq5NnJFMJb
48669	payment	2134	2134	1874	1	1	8041	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQA2uYc1tsQihsfZ7vTPM2dfTbZ3ZPWaTSwSicXDYYzhcHshdX
48670	payment	2133	2133	1874	1	1	7544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpE1mnqpBNkCctoehTY1xumeDG7FYLzwNjJLPVECfh81TuTiEX
48671	payment	2133	2133	1874	1	1	7545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnknJqMi29Pqhq8RtKNP4HGjE4SZnC7k2W2yrNwWeeCH8enQL
48672	payment	2133	2133	1874	1	1	7546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYie8nC5aWe7QY7LRuqdT9Q4S92cC2RWJWHNzHtPHX4Mj1venDM
48684	payment	1397	1397	1678	1	1	18010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZKmUVpW5Kf27145MA8XdnPnb2yLTsURhTqMAAqfQ2tmnwNay
48685	payment	2133	2133	1874	1	1	7550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmKBjYa3wxy6afZ3bCd1FrYkjZzvja9h7i1zyTTwBfejfxGcs
48686	payment	2134	2134	1874	1	1	8044	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHxvSDRGHGY5YB4MqXDNUzG4Z9QKyUbrVtKLwQUCsp77supF4
48689	payment	2133	2133	1874	1	1	7551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBF56aNUJtNNgJfbce2kCwaKeHXuzVwN5SSNbN93v3M23kTBu7
48707	payment	451	451	1646	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiWyNt9AJCYRjxH9HnfBAync4a1oUEWzqKG4Gw3rdfGbob9e4
48708	payment	1397	1397	1678	1	1	18015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wxhgn9ZHgrDSrrBWa4G9Vsock5YsLQoGLywZy4W8N2qkZHh8
48709	payment	1397	1397	1678	1	1	18016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19zzeansE4ZqDSXWmxkVj3UBwuJRVZjtF5GXGAY15y2uzEVjY
48710	payment	2133	2133	1874	1	1	7557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrjmZ4hE9CNohpwRgDpFMuyCKxMNwF3j4HvGyNmrrUGfHT9n2
48711	payment	2133	2133	1874	1	1	7558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEcuniJY8TVR2A2Yb9mjNbM3Sp1RSHmtAAJritrg7FDGeXepE
48712	payment	2133	2133	1874	1	1	7559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XDprgY55C5bsbNKHy8szzsJCc5GvYutPH1GAcHwzJsGEBi4p
48713	payment	2134	2134	1874	1	1	8052	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsjbrKpYcL5jaE5RJ9PML9ckpbqsYr87SVNDV11Wmsriuffkr
48714	payment	2134	2134	1874	1	1	8053	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSgNMagDHsj7HqnWXzGkYccdWTjdsD7eCWLqtMroxDgdj7opA
48705	payment	2133	2133	1874	1	1	7555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAbvCJXKQZvQmxks8uDWwyGAGVigUoCycwKn546Ko26SuiK1r
48706	payment	2133	2133	1874	1	1	7556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu58zs4sFAutkpwkbj52gXhsJN8TyinVVRdyeEggwN4cjPf4cm
48733	payment	389	389	389	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqG8ofUo1nvk6iQH2d6M7kYn8vSKnMRSmmxMxAizasMiU59Zw
48734	payment	744	744	1646	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujyxGPRqDM12dF7HvGnDWXrmXNgQXUHT9RbAXAdoG3oteQLdi
48735	payment	1397	1397	1678	1	1	18018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtn9DRa1VvnxNd8xJRdDSjs96NjSWwS8kRATE2VK1fEQ9DFHq
48736	payment	1397	1397	1678	1	1	18019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYLzXbegwMQnJNRDPkRjYCb3kFi6ftRRbR1pQbLNC5Pp2XYtX
48737	payment	2133	2133	1874	1	1	7565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffWtcgSZh1yQz9a69EYkN7Cm7ARmUgprejXD4muyb5JBcGmyQ
48738	payment	2133	2133	1874	1	1	7566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBvbvc5D1PtxTKCWaGAC5BbvmmXFurEMfNPoz9XfZUetqcexD
48739	payment	2133	2133	1874	1	1	7567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiAZ7TARXBurSGBariH5T1Ds3Wps6dGpofR4UQx7NfkFSnjvd
48740	payment	2133	2133	1874	1	1	7568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJajTgQvdBWXUPpDFvDu7umKM6so3V2L6fSwJsrXmGubHak9W
48741	payment	2133	2133	1874	1	1	7569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gmsfnoSDD8LUhzmbxRJN8GuAKu1tFw9juDcNPQazrn9VPzuk
48742	payment	2133	2133	1874	1	1	7570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HZGkn8LdzgRiYLEAXJpnzktXH8uJCd1Lte7tBKfQnF9AqYLD
48743	payment	2134	2134	1874	1	1	8061	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q5LaXB4zZQsF9Jd68PwaqXVfgN2g8izgCK1NKduCbWDW4EXi
48744	payment	2134	2134	1874	1	1	8062	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT5Fv6JteBc8LN6LV4c5SzgAohM2rpYFXV27McxQQMkQPavu2
48745	payment	2134	2134	1874	1	1	8063	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjkVuSJw69Ls6jFcGMn7LDysaAvtcAEKvK23gPamMxDHQWouW
48746	payment	2134	2134	1874	1	1	8064	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiEHG3iaaXfGeZvtxbCJ3y7fk3QsvdcsYJg6dWyGU4Rq6DrJd
48747	payment	2134	2134	1874	1	1	8065	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAscgnTZVqt5MTcjzykkJ8DtehCpLurvWyjfSnNtzL6BZrqvoP
48748	payment	2134	2134	1874	1	1	8066	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUmgr9m22X9XBfERF2PwHxqyKPoeRY13rQdwhgN1Gx1QqmVNL
48749	payment	2134	2134	1874	1	1	8067	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSw9d3N97LV33mkoy6BkqFnM5cHP3hnZXvb2XkCCVJ8MpunR4
48750	payment	2132	2132	1874	1	1	1987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4JzsoMdYe2bcT5thoQfkJrrUhXFJktxY1XCvPLjth6mp8jwa
48751	payment	2132	2132	1874	1	1	1988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYK3ooJbeXHCvKFaS16RaR4cb4TnxEbCQJGxvXKkNVQZpA4rp
48752	payment	2132	2132	1874	1	1	1989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PeC733ADCb8Qiz2vpLguboHonBQqViQEeQvHWA8QBQjeNT2p
48783	payment	2134	2134	1874	1	1	8080	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfUAqNcPQyhYceUcpMjPqzLXwFxeH6Qdc7ZEWjWUzEDT2EZ2Z
48784	payment	2132	2132	1874	1	1	1994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFiQ14aAkS3J3FeLCQog2h3oRuSuWfLXU6a6PzfLoyTi2R6dN
48785	payment	2132	2132	1874	1	1	1995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbVrbeDER25QJivus3tF6d817d9qYaUFPmznZF3uuX5tpxZzs
48786	payment	2133	2133	1874	1	1	7580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAkqHc4cLK9nX5WyKm3MouNHV4eirjLCDYtBhLB5eoQzTReLD
48787	payment	2133	2133	1874	1	1	7581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCtkKQxPt5ksEfrENdNaC9Lt2pYTNxvTMWcBNrpkxx1Kowzvq
48788	payment	2134	2134	1874	1	1	8081	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBkU3bmj8KjAtkhNoYD8fAYbT5y1291UH9bPLhDyagim4gpEw
48789	payment	2134	2134	1874	1	1	8082	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Qxx5Lvqz5s2zSErYGPdzXkcVNi1tJt4SdJHA6sMz3xzDN7i
48790	payment	2134	2134	1874	1	1	8083	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUk14guquYMdU4msyn2Yh5KQEusNgdTkGUxYNCP8JLmCAv4NJ
48791	delegation	718	718	718	1	1	1	\N	1000000	\N	E4ZKwytHYi1tLKQVpehYwgCM9isAogrGvK4Zvhp7A56cv4UePf6RQ	Ckpa9enpkM9aZQ5P1yxyCDFmkq497AHcZ4Y9Yt8zs8wM3VfXbkX4M
48835	payment	2133	2133	1874	1	1	7593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNS1DND6LKWEqmQ25de5qGJZuKnGkEKaevQCsmd6SpPrF6gZD
48836	payment	2133	2133	1874	1	1	7594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKYdnXkt9Y5ZvbrskPJ4C67Zgcf3bQcofzKJt7SXYvJLf9Ggw
48837	payment	2133	2133	1874	1	1	7595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtU6W9zQfSPhW94SNc7on5LdpyYTsrtpjhTCe9XfnnSL2nxSZE
48838	payment	1397	1397	1678	1	1	18029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1wUrVnBMxfwVF6Mw6Ve4bZzE5RY14riD383mRmcjWejkdaRZ
48839	payment	2134	2134	1874	1	1	8101	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq91USe6ajJd8WHbry3PmCc7yrWCd8aQ6rbphkCeQq5kSZi8q
48840	payment	2134	2134	1874	1	1	8102	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnV8o2Ma4RLQcf2HnqfnzwNEHosQ469EWy6hzqhx1sCrTvjn47
48841	payment	2132	2132	1874	1	1	2003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfPVSYRmKfmVQ2Y6kk7Mz8vJiAnNADnZWS22XSLmTGE8F1bhP
48715	payment	2134	2134	1874	1	1	8054	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6VRE8WXVV1vnKSD6qS9t1hw8Ku8GiSM3sAFqBZTESn4FSFPP
48716	payment	2133	2133	1874	1	1	7560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDDQ3RhV2zijNYrjTzZ5iiMhQ2Yiq9gcnnxTXxhS2BMrhTrmM
48717	payment	2134	2134	1874	1	1	8055	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiq4pTohnXYGfYJYaEPLCVieja58gMFdP2L9yRTGdX8RbVKgN
48718	payment	2133	2133	1874	1	1	7561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpu4EtU1g4HC2E955KsAMFkcVtTbkDBzzjrsvT1KJ3UYzzybt
48719	payment	2132	2132	1874	1	1	1982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfUHTnH6bqjwp2UAJzt92tpac8h84FAPQAdMzrqH94ypn1oLz
48720	payment	2132	2132	1874	1	1	1983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QYzTxgsBAuhVZZFkG6DX6aJ4Sf7uugGYR7ZYNWxURpjMtHWV
48721	payment	2132	2132	1874	1	1	1984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Wwg4CDSxhVxpcCkodkK8tpnXgCHDvDHYUHW6aQaNMi9fsDWQ
48722	payment	2132	2132	1874	1	1	1985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMSwxKTccjpVu1HJkA851JGSgz1WLFUtTtEebnRu8TPTFBpEL
48723	payment	2133	2133	1874	1	1	7562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G7JmZpNtd39jjLFp8gjJ3LYtBk4kQEwh9Tfi5a6stznY88MD
48724	payment	2134	2134	1874	1	1	8056	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMtHh2BcAbrEGUhDpJbcseh3PJXRKympBFyYKZz1Ke4h17oPP
48725	payment	2134	2134	1874	1	1	8057	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NAFUAb1XZjbyMrSZQ7bhobWbDkhnG6hrSMZK5y4cXgjMdUg4
48753	payment	379	379	1483	1	1	1	0	100000000	\N	E4ZRf5ht4bxBXbLjaJWNRAB8bZChdS46ij3NhSGtGnJr5ndUd6r76	CkpaDp2C2mWSQFpGEii1T5tqr2zXZnWWbKRRb2jxrqfgeWN4cVNk3
48754	payment	379	379	2430	1	1	2	190526998000	10000000	\N	E4YxrX1XXDAwicB1jaM3487uDeJdzJ5HsExypxCfWfLFRPpWqyX3M	CkpZaBt8GqWeUcNR1sD19YVBupfceb3LtSuaHBa1HifetAdTucLN5
48755	payment	1397	1397	1678	1	1	18020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvG3dbceiPEfgevMQqX94vVrECrvsEBzWH3BnNa2Zf948CA1hC
48756	payment	1397	1397	1678	1	1	18021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NjXykUHp561oaAqWDVo6EMYoioGj34Ao9J8RntTdsQGYWpgC
48757	payment	1397	1397	1678	1	1	18022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjc5CLH1CyrMwL8v6c4mVWhH79d3rT1PvExRV1KPy3rnzY9WS
48758	payment	2134	2134	1874	1	1	8068	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbHChVF3nn11oMna14awSDQG3d5fjEicRwnT4NZzFZLnfgTbi
48759	payment	2134	2134	1874	1	1	8069	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjyTjeZg1hRHvdcfZRngypqBAsXxACwVfHcMPkX4m6FUHHJ6n
48760	payment	2132	2132	1874	1	1	1990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTT7owesp2dYgn56jeAkwrMQgD2dEUdwqLSmkZLZR9fcgvzXb
48761	payment	2133	2133	1874	1	1	7571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtgXEu58zE2gdMW72dGr7FxKUgC31wnd5LuiyDHLu5QqcAhQt
48762	payment	2133	2133	1874	1	1	7572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAGvGtce2NcotnFfFfVtstmM66mqoT6cJmAgqB2TMkFkRVqhX
48763	payment	2133	2133	1874	1	1	7573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8JaScVtb1UW2WuwvmwWuiHEL9EjBXFn1dNviFSUwcMiNzPzF
48764	payment	2132	2132	1874	1	1	1991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmArYUspbjaVCHVoxWycPsKY8S5sgLRjD1kecDA4dh2uoDk6Le
48765	payment	2132	2132	1874	1	1	1992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHLxWrgrmbGfVECu1iosxX2hJT9XG26x4sgvxLtHATUDKvcrn
48766	payment	2133	2133	1874	1	1	7574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRQriy7yriY45cWhZ27zvBDWFp3pcQxmN6efhR8Jq5r4X3zuF
48767	payment	2133	2133	1874	1	1	7575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryYfHGCgUnQBho636ruxhcvm4d6XX1TGqhZXN6D52jFa2F42x
48768	payment	2133	2133	1874	1	1	7576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtuJeKev25ZeEL1Uy2W5gruQPAgCQ1hzK8JCegAdxSfCpsV97F
48769	payment	2133	2133	1874	1	1	7577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHMPUND2WT38DX5w9ciEdUgWErh98BgxrgUDaGn7Zmvf5QCCL
48770	payment	2133	2133	1874	1	1	7578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeodjF6F4942wHtLPY5wteZ8vRSbGKDCqD3sYPT3L3mmsuoS1
48771	payment	2133	2133	1874	1	1	7579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64udueWXD6oBvGguCT9BY6GSJtXZQubc2juZsxjebiyjzw5SL
48772	payment	2132	2132	1874	1	1	1993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCkizz9338wLoxSo5vNnHE8gFC9qSeFgTCz5AMdhhehn7w2QU
48773	payment	2134	2134	1874	1	1	8070	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPbJiynJivtywxeawggoUKcrV5YBkJiLCpiJF76Q5pzbszhTQ
48774	payment	2134	2134	1874	1	1	8071	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqJeB6ab11cvuXkrHx7bnWCjBdF62PyR3LaVAviLe2aw9E8BY
48775	payment	2134	2134	1874	1	1	8072	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrvDG5fETW13WTqxyTmHNNiVs8Qf3e4jymQUUz8bGKtYrdSh2
48776	payment	2134	2134	1874	1	1	8073	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pVTyQhoJkvaMs6HDKiTi8wfRyouisrufFeWmnxMotPADVEr7
48777	payment	2134	2134	1874	1	1	8074	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNgvz9QRTTqyfq4oCdwewD4UjMvueZXzwyeFCWC4N62eq7mFeX
48778	payment	2134	2134	1874	1	1	8075	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEHdubCBMPqwj4CSvFFGuvZD4oiHm51QaVmtfLRRDb66Zmge4
48779	payment	2134	2134	1874	1	1	8076	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBqvdLdA61MW6xFvxVkGCFKzhYxa2cPXdQHRGEGwh7VbAK8Cr
48726	payment	1397	1397	1678	1	1	18017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkASKUNweuJdNfWThkXxwHKEtYgWsCL49EvjDzPaUwuXW2Qzn
48727	payment	2134	2134	1874	1	1	8058	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzpgZMbMpAeW5PiTNdCWZwEHxMGrhgrpxzgZM4UYWf2hdob5h
48728	payment	2133	2133	1874	1	1	7563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9W6U6h6iJAP7sAiwtvFjvYttBa8Egx7wVzVJd64fMGYdSywBB
48729	payment	2132	2132	1874	1	1	1986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWF7D4Y1XXDiGFPtXAHbXq2aJpwVTCACfmrXqML9Htv1uFNuzF
48730	payment	2134	2134	1874	1	1	8059	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasVhdh93yENmd9N5GhYYQy5K6raaTR5U95ugRDncjZJ92fb4S
48731	payment	2134	2134	1874	1	1	8060	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjwBaCanbWZ48Ggrjm8mrkmpz7KiG7gh9vqgHNvZzb2natfoj
48732	payment	2133	2133	1874	1	1	7564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB65j5LsMoLyUWqbsQJqMoDFqSohysR7uwk7MDgwCMwD8wNb99
48821	payment	1397	1397	1678	1	1	18027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPWw4utJZPUoppjhLfpX5WT1FoCuaFwoGR9cDWkeujLiNRdBf
48822	payment	2132	2132	1874	1	1	2000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHfS6JUaZepCa4h5WeqE2i5CXN2s3yFthQyf79GpHYHjSLQcH
48823	payment	2132	2132	1874	1	1	2001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CCSMEHrFJdbWMz98mGs4wwBP7DYEgTP6EGkPA91L6AfYhUUL
48824	payment	2134	2134	1874	1	1	8095	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4xBzThhk6wS3XuatFc8AhoT7uDRzDKv1viT29LD7TyN8dbYr
48825	payment	2134	2134	1874	1	1	8096	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuG3kVfowrH7P277UYSue9F6KVuiHjyewnbp18VuxMNyMwvvL9
48826	payment	2134	2134	1874	1	1	8097	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69cVmSdssFF1XbbRKone2X1knPipF8VC7b2aNe8ikEbJUJCft
48827	payment	2133	2133	1874	1	1	7591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ5uMiGratM5UiF72Avku4L7RbRxxMCEiEvuGeJhY7cFUPRi6
48828	payment	2133	2133	1874	1	1	7592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTz4HiSfAh2JdPQA9m6rAEsPwHrewEeqbpt95F6FUqfTZLBp9
48845	delegation	2430	2430	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdVJT8d1hNC5kr63NYgKxhxwAgcPec1miJ8AS8yB1gxcWtVVU
48846	payment	50	50	2431	1	1	0	770714905251	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncguppCuyCE7cAboqWMncHxiuUPy7xUXBKN2PqAjNTTcnqSGu
48847	payment	1397	1397	1678	1	1	18030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkdbYNuKFqTzW1Jjh7cKrpLHjGAwGptuGGuP2HJ5ubNtKhaKp
48848	payment	1397	1397	1678	1	1	18031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehbsf4XJ1r9DEXrNCkba89seCsyfSs3JEnzmD93QABY3PfaPH
48849	payment	1397	1397	1678	1	1	18032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQkhRqz8fsqk67uBR2TRQ64FMb1eGaP1hHDTMCQJocqWJXAPr
48850	payment	2134	2134	1874	1	1	8103	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbc1AbAbDcNp47pTTP8Zik2pFBwRkndnWDSmXiFTbKZTuFvD41
48851	payment	2134	2134	1874	1	1	8104	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9PJAAa3UXeu6nAkeh5HxPzK2KdnMMvWGXKaCSL974PvBvqbv
48852	payment	2132	2132	1874	1	1	2005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiME6HqxYjhvfrKWprVspf19YhNB3d8X3fv9C4QHZR4xN8HJL
48853	payment	2132	2132	1874	1	1	2006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPzfZVbpFCmAn4ushzatLSGKvckYwjm6WLVMbtBEhixzvqz2p
48854	payment	2132	2132	1874	1	1	2007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkK4thLZQxWVR5T6Kj94cBh7CjeWziMZ1CqxzxGf5nx779KLAU
48855	payment	2132	2132	1874	1	1	2008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhEzELbkVtLbRVaLRj4TVoxqTUx5rKwkpx419TYhh4KoLbZmr
48856	payment	2134	2134	1874	1	1	8105	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1utHKt96Ncng2wMq8C3bFwNHkEAjzxTVh55dhpTaLfxjLqr66
48857	payment	2133	2133	1874	1	1	7598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2otabTMoqWXR39s1eSnMNWiEone2tRLUtTswzmeZqoLaq1WsG
48858	payment	2133	2133	1874	1	1	7599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMg7o51jULUTP9CwAHREdUiFTM462XNE9YNpMJisVwQaU3RJS
48859	payment	2133	2133	1874	1	1	7600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrERgLmVy9GUy77CGkBcwyupn2NEh7Fa2fDUjjLavjdKfzyuCv
48860	payment	2133	2133	1874	1	1	7601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQ88mr5bPMRhgDnJ4DbPPXjBUmmUqGx6kkvmYK4N1wgpeFYcZ
48861	payment	2133	2133	1874	1	1	7602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwR5ssuWefk5Q2tEJtfvdwRBHHbfojfnK3mb1CGe5whU4Yjei
48862	payment	2133	2133	1874	1	1	7603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbVySJiYQ9oMS8fiY9odCfKaEiSTqwkFmZoTHBa5yN4o8zsXx
48863	payment	2133	2133	1874	1	1	7604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXh1wAsd6ML6zo34K14XSDkcYrigWojCRjPzJ3yWSyBjUSevC
48864	payment	2133	2133	1874	1	1	7605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNwguK5HjrxDoiTSRUKN72xZCTeEUpzRdPoCFbrar52EPLZLR
48865	payment	2133	2133	1874	1	1	7606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCENgL8upFeuxAMa6mMHYA62eSWn23X4KLLY9See9qtZjmGnAC
48866	payment	2134	2134	1874	1	1	8106	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9n3ESqsCaUAfmi6mpTiB6wtcmm4nUU4G33Jy7ALNaL4YmBWQU
48867	payment	2134	2134	1874	1	1	8107	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmV3AonUNBkF3f9X3kZeH1RQggjj7AfLQe73AMxxMKw8PjXY7
48780	payment	2134	2134	1874	1	1	8077	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KTqRANBoHccaS7e6W1QG9J6CejWDqPQ1cvCixcBJLYCNSHqn
48781	payment	2134	2134	1874	1	1	8078	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWfupcFvoWfgHxjHWuftdi6PXekSWSoFmYosPPWREbS7P2s5s
48782	payment	2134	2134	1874	1	1	8079	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnyWVKAdeKCjnf3teMiw9gHYFCSsipGLZF292fbKEzBgXG3vq
48792	payment	1397	1397	1678	1	1	18023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGC3pzCNF7kRS8yEPNYfqwVzXXj5wVsGPnCegSAf8zt1HAM23
48793	payment	1397	1397	1678	1	1	18024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VBirCvcKWMbQu52YXkhXHEj6vG8XHXA8JZF8Q8GSembavuXp
48794	payment	2132	2132	1874	1	1	1996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyNo7V73vf4mJMuW2J4rQWh7cm722s8g95LrvXBWVKNBUdPVe
48795	payment	2055	2055	718	1	1	1	1000000	1000000	\N	E4Yyk7ir4jPmppNr3sELP2QryGmG9sL2s2nS2rou7uFt1eb2tmcq1	CkpZwUoJnA6ZBNFmm3t5QD7Fr3Dtj5VTzcsuN2UZAUJeLiuvbhg68
48796	payment	2134	2134	1874	1	1	8084	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU46Am9NZXYoekLtoTBWY9H2aPjpKT7ordztsbWQLNRzU4qe5
48797	payment	2134	2134	1874	1	1	8085	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJT3XebX4LfqpRxJhSAFqN2FZdYxBignfq8Qq26CvB8rxU1tXQ
48798	payment	2134	2134	1874	1	1	8086	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWK6S8WumMzjHsqwNRMzZLq5PZsDqUP1GFuq2vGKF1rSXn8Wo
48799	payment	2134	2134	1874	1	1	8087	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwQY49jPy2mWsLTxepW1RvoBhKBw2a9oNf18VeyLt5CnKfVnM
48800	payment	2134	2134	1874	1	1	8088	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWochhwPpd7zJasRY9PoG4JEXTbGs7n8Y3b4btd3Jw1ZKwqsU
48801	payment	2133	2133	1874	1	1	7582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKV53gwR4AUzVjb88iAFCNUDsQdG72zFF9bo6ozM2krZcfKVAp
48802	payment	2133	2133	1874	1	1	7583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmMPh9R96hsX88hZnApEwWZsGCRNDfDWwpzAzE9WSQUK9nh6o
48803	payment	2133	2133	1874	1	1	7584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gT4tgnRKCSry6w1xfY2uceTcBkRXCA2zxb4yN66Lvy1ZpaQ2
48804	payment	2133	2133	1874	1	1	7585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjySa7SnvpFwCnrCxUYGwxGRXmM9vn15Zhh2Tf8v5hy7GADs1
48806	payment	1397	1397	1678	1	1	18025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5zVZiYBKR1uBDnQvv8VtXQX4beNCLvSFQsfLB9hLP4uNFYao
48807	payment	1397	1397	1678	1	1	18026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk5qeVLeuYUQiXg1qjscbbEhkA7JHYpCr9s7NMwydkCy6JQto
48808	payment	2132	2132	1874	1	1	1998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt94MJqFejaWX5qMRGvujqwdkrtk6YtT891E95E3SUgoqMoVFc
48809	payment	2134	2134	1874	1	1	8089	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nBFdSqjrf8JRJgQFtAyETbwvXNugRwvcmJkxddEaNRyMtZzf
48810	payment	2134	2134	1874	1	1	8090	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZyqwpUDUk16RHWixWxbQuU875a8s4KLVSrqR5U8YMvqCSEFK
48811	payment	2134	2134	1874	1	1	8091	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJu8nv5pD1GXE5iHbVrgEHamtohs96CKQKKvGPjPLzE8MB6mme
48812	payment	2134	2134	1874	1	1	8092	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKgMr3poRoDoPVaL9TPPZHFtRTMgQ5DiwjbXuwzYYFLqU17u8
48813	payment	2134	2134	1874	1	1	8093	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLZRtAxmPCeBFCibxP8EVjFtBAXkssKUTBYDWPvcMk5YHQJRV
48814	payment	2134	2134	1874	1	1	8094	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tUeUc7tedNfJyLhWKpi9N2d1mFEm62VuhDghGwrTBeY2c7Ge
48815	payment	2132	2132	1874	1	1	1999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LuVT2HVXD1QaUfPuP1U43k5YYC3kSUUFbtGy4VfHRDFVrx82
48816	payment	2133	2133	1874	1	1	7586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHUHEd7DTsZdLJY8t3yCZ5aLYYUk2LFXY39qWsuHh47SEGwLWC
48817	payment	2133	2133	1874	1	1	7587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AG5NvziGnjzKhTXChbmTWGY2poZnDXJw8eVy2rRwmkHGqyP9
48818	payment	2133	2133	1874	1	1	7588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnZbVbT2LRqfYopE77nQ5BxCsJR8uSv63MUfKmD9Vf4BMMXyw
48819	payment	2133	2133	1874	1	1	7589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghDzY3mGGXYAGLFSAxh1nKmLDvFMWpeWZ7w61VasxVg2kiEVG
48820	payment	2133	2133	1874	1	1	7590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDbcKntCACT2NRKUu2sSgSxXTsX2R8tnXq86kuaV73Xv3kuLw
48829	payment	1397	1397	1678	1	1	18028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFB8YQDSnzvScQdf3qjsFEnTCzvmQs6UQ835qtuPzSJYN2w3g
48830	payment	2134	2134	1874	1	1	8098	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtxpRbbegLYwhzbDq9fTLN6pQkU6E6JD14rV8Mg4mjjrwApNo
48831	payment	2134	2134	1874	1	1	8099	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rZtFywVCGFXEaUjiwJXsy89LY7jZFrPa5JApPZtfV5F4qz6t
48832	payment	2134	2134	1874	1	1	8100	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVyB8PjNZNgduhtYFkzt7HzrE5jUeRrCA8PxTgoZa6AJDFoPU
48833	payment	2132	2132	1874	1	1	2002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8gdL1SUtoww5gbZhjQBPgv2awZPf59CjfEBarq1SgmEgCcaW
48834	delegation	718	718	1655	1	1	2	\N	1000000	\N	E4Z2YZicix9BzkqqVjDVfjJVMw8TPDgDj45czaVqg7JhfP9bKQfdk	CkpaBk4UBXrBy6Tdev2R2qkmmCqfESnqQZCbH719LnKC55BmC7Pek
48874	payment	1397	1397	1678	1	1	18033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5psbBBkSxyfZVW5c1ZKHvAy9UtGV1gKv8k6mESLosC8uGSNz
48842	payment	2132	2132	1874	1	1	2004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3W9MzTHQTkwGg5q42B2Ry2uB5RjWbztf1nCEjR44Jo283226a
48843	payment	2133	2133	1874	1	1	7596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CqSqkEou67e1kPrWCfDQa9B97na1yu3uxVD8vJtp6eMntmVj
48844	payment	2133	2133	1874	1	1	7597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk6gNxKyvj3wNQdmQq7DsSSSFzLVMuRGfXWcUpf9bzdsr7VaZ
48919	payment	1397	1397	1678	1	1	18038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SGUqjRNkyibUbtB3cxnTXmHCt9FCSJhUt5hQfMUnggS1mQua
48920	payment	1397	1397	1678	1	1	18039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gmRnq9KR2etMq4CDiUz6kUcZbbMZxiShyFjUR9AM2F5QJ4ym
48921	payment	2134	2134	1874	1	1	8131	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppWm5UmKyXW5cspxPrfkdf2VzBeEfnQQn5gDsFiu7XfrEWcZP
48922	payment	2133	2133	1874	1	1	7620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCc8jZFuJcKRfqYCkBxxsJkPvUBXeyjjTvSo9LYPQAD5B4xUxK
48923	payment	2132	2132	1874	1	1	2017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpG78W8GFuoh4TWJecrm1shWKYXTEwXzYS7EJPznhSEmbf1ES
48924	payment	2132	2132	1874	1	1	2018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjzjLhGv1vWRWJvtXEUuW7ceyyY7sXxx145KqdwsnbEkUUkEX
48925	payment	2132	2132	1874	1	1	2019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZstMjwskRSHG1t2Q6CpWswLdFPSCgZRGqmXcVmxRJfU4667K
48926	payment	2134	2134	1874	1	1	8132	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyJ8JWsSJMDYydja4EHYH3HuX3D8NL3SuYPMrDL6AM9um3zKh
48927	payment	2133	2133	1874	1	1	7621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwpAG2Wt9TCjXR4LFcVjh8viDpZwuiXwGB1U86DVkt31NP8gF
48928	payment	2133	2133	1874	1	1	7622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLtpKfK5vMw43ziKHjXegrCyPgMWZ9wEmDnzE3QXfC82Uhius
48929	payment	2133	2133	1874	1	1	7623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nthazBBXWMeEMzaHY9C3DHnu5AfzC3nQHy3baGFGf24U7iB2
48930	payment	2133	2133	1874	1	1	7624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kbnyw47MGrYqS1HqQX34biMwPFnXULZHoBdDPiF7PbHWRBye
48931	payment	2134	2134	1874	1	1	8133	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7C1Z9Fbnj3yrWHrbXTk4GLydMnu6zjyCG9YVCN7Fzzwb8wYf7
48932	payment	2134	2134	1874	1	1	8134	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDwHrF6EyggbX5KRncPVMG42cVXob97z1mrdqTdBCpcMmcg1B
48933	payment	2134	2134	1874	1	1	8135	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrnNn1hBS98B7Rn8QsxTjczTx4jy5Puh9jZJQdaxdFWRG8B2a
48952	payment	1397	1397	1678	1	1	18041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewVZjFGLFSG26mVWoFd5Px9RF1uMciARrkQQN5FPYLjbpmaCu
48953	payment	2132	2132	1874	1	1	2023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tcXbiofJqB9Fa3BL4f4J7Eh6QZJWorVTyDk6SDD3CN3FBo8k
48954	payment	2133	2133	1874	1	1	7631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qZizCiDQhuoGofTeH5deDfHuFvh1qsShAKrKJhAs2USKAdHm
48955	payment	2133	2133	1874	1	1	7632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RzH58SybkPuDn7xp2PaiFXjrsHRSKviM9NNAmYQZcgvDrfps
48956	payment	2133	2133	1874	1	1	7633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLQYxci478XoYDLrjiokEszGbJ38y65GUd29wu8z6C4qPBod7
48957	payment	2134	2134	1874	1	1	8143	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBi2eoBAC643Txpbeu7yMrG5aPGx6HC7dEH3ha39WdXtNZmmfY
48958	payment	2134	2134	1874	1	1	8144	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mvnPXFgkrSFQqLVs2bMjatfHzwrPE9stNezkJprJZGdjhzR2
48959	payment	2134	2134	1874	1	1	8145	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQ5kjj2B1vdS3u3NeaF4SNgTT61XXsYaW5PnUpDmiJmDgMfPS
48960	payment	2134	2134	1874	1	1	8146	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AL33hBHm3vNeKJbVjQqi5kEWQT8u4sA4sYc4p5YBo7n5rCKU
48973	payment	735	735	1428	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVt57hMZAFnB1wJmKihhwrCr4CsW8NB8bantMuTLXBgu4fPxyR
48974	payment	1397	1397	1678	1	1	18043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMmjFBDhnBAAp4JjfWvPn5gWeoKq9xFra4ey9jBR7yG9VE7Vo
48975	payment	2133	2133	1874	1	1	7637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZs3F5hj9Q39MddBUw2XpQLFQLU3DZ1Q3X2i3j6kKh1nPFuh4Y
48976	payment	2134	2134	1874	1	1	8150	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj34qvGMUzCf9wZTqM7C77p9PTKmyjHGt5onD8SSovbXBzwhj4
48977	payment	2134	2134	1874	1	1	8151	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZpVyWEW9oGtVi5aMZZUReds8EPUtNj6UCk19NkxjTLMfGDKv
48978	payment	2134	2134	1874	1	1	8152	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgWkcCPDajFA5Y6YjwpnzoUShnie7mHpBzea3FWdNhPSk1tNg
48979	payment	2132	2132	1874	1	1	2026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNtTLMv4xZNJx9gUrdRHd5UidwucqDjFhGWRR4xKEF8rJi4FV
48980	payment	2133	2133	1874	1	1	7638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiMRwAagD3uttUhG7pvKwJqbth9x7SeKkB6pUsd7fMU3n7n6X
48981	payment	2133	2133	1874	1	1	7639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKrLLTWTTBY4ArCYggdXmKs95ZkhYxxNKBYsC9RrHKucwTuTA
49040	payment	1397	1397	1678	1	1	18051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yG2LhUxw57yqksLhU1JBbx7vFQWWkKy4P2KCEurNcL5K6i1e
49041	payment	2134	2134	1874	1	1	8173	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6JMijV6mn6W2NdzRcwT7ZarUttGNcTs6usWZGp5jiaWNB8mz
48868	payment	2134	2134	1874	1	1	8108	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibbipZiTgz8CyKRwSxjYA9GMXfTpwmiA3gRQhMcykzXv4Cx3m
48869	payment	2134	2134	1874	1	1	8109	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmaZWrWgj8wweetgsh9gFWc3EzK19SJw8K9RUiXgu8j4msjEGJ
48870	payment	2134	2134	1874	1	1	8110	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9Wyw1d8mLKz6yKfwFgcXDm7cPfRkLTkiu7JnxabPF25qMkAU
48871	payment	2134	2134	1874	1	1	8111	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYjtV3FBURY7u8pCAQDCV6hdkHhJq5iWmxdNMKnnwFJcrg9Uk
48872	payment	2134	2134	1874	1	1	8112	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1M6hwP8CXZ1nznKZ7whWiDJ36ihmgsc4qZsRz5bK4RwUypZ8
48873	payment	2134	2134	1874	1	1	8113	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagY9bJqDfbTrQMxjo11z54oETgVHKLQJoaoC7mY6MnuAJzEAE
48892	payment	1397	1397	1678	1	1	18035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosepJd1XDr5wPThJps4T1eemF2qryieXy91vT25MD9nQiNoa9
48893	payment	2133	2133	1874	1	1	7612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ61ezJjBmPm4n5utaSJhXQPTeqoexvQgSSbjDwLWfPMmbGxU3
48894	payment	2132	2132	1874	1	1	2012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLRBuZRCVFLN26MiVmxQr6DUk3TQgoEoJKqGPrK4zUwsQbPHa
48895	payment	2132	2132	1874	1	1	2013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1b8g63gXMM88JMTDrqKKdivJHmwkcwyrPBDHjAvLxKJPqGFop
48896	payment	2133	2133	1874	1	1	7613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z7UU8Wjo97vPNyRZJTEyNHY2YsKovt8Uz9Y1dSeqnPGeCnw4
48897	payment	2133	2133	1874	1	1	7614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGXkAByrpDZEJb56ekuXvN69EM8zyF2xQh3ckmbNbt1w6hNkk
48898	payment	2134	2134	1874	1	1	8122	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXb9y2Ly8BNRMtrMwoZnuTiiZsbcZsFPNRibqTMBusdcLsUdw
48899	payment	2134	2134	1874	1	1	8123	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo2Zid3mYCSWFeoarp1YqfxpVaYpQJygtick17S9qG7rGwWw8
48900	payment	2134	2134	1874	1	1	8124	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc5VZBJv7RK2CrkdU8GnG2EjVgYuwi8F1pazns4sD1KWgvkTg
48934	payment	1397	1397	1678	1	1	18040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TCJanQGs72UznHZwkfP1VsezniE9bine37JQwuJ56AwPRzLi
48935	payment	146	146	146	1	1	0	1	2125000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdBHRs9d5a6uFcdufWwJq2SfGjT2npFk4nyXWtVJPSxU8eE5o
48936	payment	2133	2133	1874	1	1	7625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhAXUmxyknokDCMbXUJwbP2rpA1f1JdoAvFsBMYtfUrGLuUw6
48937	payment	2132	2132	1874	1	1	2020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rN6xqfYFzo2CacKeLaCjRFm9uVJWMYnnchqtPUQnrbDV7yfJ
48938	payment	2133	2133	1874	1	1	7626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8apzYk2KuqVgRspgRRhoB3Q8oPGFXSkiu6RrU4i6jCpjW9JcW
48939	payment	2133	2133	1874	1	1	7627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteJ7nuFwNqrdKfjyke8S2BQoj6otBrmd5So83QavTvhLss3if
48940	payment	2133	2133	1874	1	1	7628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DtcXeZHdwhftebr7amV61k4i9KKaxfLC3E2EGFKXC7Vq6Zh7
48941	payment	2134	2134	1874	1	1	8136	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZ4y3tZPSfvqXgvtoQmuFeJABerYw4kaR89ZDAAGjKUnmn71z
48942	payment	2132	2132	1874	1	1	2021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAiVrtvdM2A7Qi7YGTrmqBnWqqvoPBZMHhK6gzdSb7L4AbS7P
48943	payment	2132	2132	1874	1	1	2022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgojbx5CeEPRkzzvE1AzuLCHtSZrV1wvMKvri5DGoLS87jvctt
48944	payment	2134	2134	1874	1	1	8137	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpFs7tGa2Ykt6eF1T4CswpnBCQoJaHRuL1ph6JmA4sT2T3M66
48945	payment	2134	2134	1874	1	1	8138	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCm5cHTLVQk6VQH9t4QxSEGRHrZgWB7MoFkyw8je8xDqhEJJX
48946	payment	2133	2133	1874	1	1	7629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4dTdm7sNJHaeQArgKPP45JB6mbvqTE2AXoT1HXACtchVpWut
48947	payment	2134	2134	1874	1	1	8139	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgFTkn9HYtLGCA4QreP7xBCrwtcm8sm9BZqnNoBHokm8jPBfq
48948	payment	2134	2134	1874	1	1	8140	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXE5bmmgWZtH7451bXFgEqQkzQR4arumx4a5ahmj9puXYDhfG
48949	payment	2134	2134	1874	1	1	8141	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XuA8TTDx9N9x66fXBmQDu6JTvYpi9StzsdrQEPZoErB3ZMWJ
48950	payment	2134	2134	1874	1	1	8142	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHbELTLo5cNATeupKv7s37sij5ujHr1PFdC47bot673iSXxs5
48951	payment	2133	2133	1874	1	1	7630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnwjoVP6YDJEcACFZfgAsPM1aWzirTvMkk3yGbNRhtzcE3nyX
48982	payment	1397	1397	1678	1	1	18044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjGUySG3Ahxa1agXfWDDLePt5DMq2DR8cjptSRtxyu8ZRSoz2
48983	payment	1397	1397	1678	1	1	18045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc5UsWYPAebwQgR3JNwKnFrmSYRk4FkgipekdekQkcpSeAE9qg
48984	payment	2132	2132	1874	1	1	2027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeBWtvX7NNm15i8hnS7GSYsMPrZ6B4DwAJ21MX9GE9ntJgW79
48985	payment	2132	2132	1874	1	1	2028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsGbcBK6wZcrczqzyUyLyzj6CK9L4aNdFpp6iESVWnwH2WuG3
48986	payment	2132	2132	1874	1	1	2029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcWVpmSEsAbMPh7ZCpyyX45zU5fNbQV5RJFChdwvxMkZYWFnN
48875	payment	1397	1397	1678	1	1	18034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99udxxZsXsGKdtZkXjdEJXcy8wW6jLBxSmhWN2Mhg1urHnmHd
48876	payment	2132	2132	1874	1	1	2009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4PWehwBXrZtr1kibokbj2g8DTNdueCh8cvMVTAYcnipZvAWC
48877	payment	2133	2133	1874	1	1	7607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRH5KKH8Hk1MKNLjRXPJDwHLDnvAM1QA6kqVGvv1rce8Ne2Di
48878	payment	2133	2133	1874	1	1	7608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNmPvY1mEtTdwRRkCfnu4wQWH1NxoXjA2Zm4RG2RwJL4dwjFt
48879	payment	2133	2133	1874	1	1	7609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3UjZKfh8ZHQUkQ4jGepU2s3SXGp2Y7JwYV8hstJu1FNxhgeG
48880	payment	2133	2133	1874	1	1	7610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrJLeR3FcUJ5mrtiqfhvZiw1UKCdqiYPwkwk3PDHhrVKKro9J
48881	payment	2133	2133	1874	1	1	7611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdGqirB4a4pWkBjxZTtne33S8mR3nG8Fy6y8sMJi7vrvfk6KC
48882	payment	2134	2134	1874	1	1	8114	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKWXaKTkMSoBepoNekrguxfGKApoRqud4htysDL9PXKGcXpAD
48883	payment	2134	2134	1874	1	1	8115	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEgQtBofgLwmWy7z6KLpmRdRvvB7UifB7pXHAEoKCLBzZSqxB
48884	payment	2134	2134	1874	1	1	8116	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpamQ3dqYKxwvT78SSDfV2zc139C9drntERm6r8EZHQ8EUyh8P
48885	payment	2134	2134	1874	1	1	8117	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGah7mzjidNb93uCtdBnTmamUKJXdnR1ACHzNEyMCWY9uAbdJ
48886	payment	2134	2134	1874	1	1	8118	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZha4ekfftkeFnBn1RudAH8BWjdwsg5tEmVJ94AKLkwnQzAP5gN
48887	payment	2134	2134	1874	1	1	8119	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpLe9DdwR87KdXFtgYcNDLLi5JEc6Yp9QY4DcrKfCLzwLWqiy
48888	payment	2134	2134	1874	1	1	8120	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrQbr7XiPv4x9K1PzEgPGgYAn6fWpe8oswSJvJL11R8kHs8QW
48889	payment	2134	2134	1874	1	1	8121	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZW2jQLbXbVNUPxmsjUkYvK4Htj7GPMTGcfxy25g6LzpsEzCG
48890	payment	2132	2132	1874	1	1	2010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKh6HRuyM2MkkrogfNnAzTotvWCkd5BK59sDAfRed5KidRjjkV
48891	payment	2132	2132	1874	1	1	2011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWCzwUmCHTZrdM3Eg6mnWdtffTzwWfcsvfvZfZbnwTwhgm5fR
48901	delegation	2431	2431	1600	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q22Vqkoy2nZ4cVKYMyBSnpmAR8aPMyQUvRKug95hEhyYjRrQ
48902	payment	1397	1397	1678	1	1	18036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiB6rL28J6hcfEBZfWAezq21JPELNQASr59iXwCyQCuxT4fbnN
48903	payment	1397	1397	1678	1	1	18037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrh1j3rBmDWB6GoG29AA4awZmbTStusqbD31Hd3eXC3kfY7izT
48904	payment	2133	2133	1874	1	1	7615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4mixK7fyFXjKaVzgXXc2w4kCoavb1DWFHo4JVxwTJ7oBvaZZ
48905	payment	453	453	712	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHfKeQ2gUDyyxWfwvLavWFeBsxRj5TH34CcW7BNfcTiAUAsyJ
48906	payment	2132	2132	1874	1	1	2014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQogRnsvE3uUyB215KVbRiMGFc62Pui7DpbNEnvrwgVciwMUG
48907	payment	2132	2132	1874	1	1	2015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVz6RfveFSuZUHfHrfDiA61HAb49bXc2QTq25tqCe3VgkgPQ6
48908	payment	2132	2132	1874	1	1	2016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUPJP9EYEgfKvE6JSnTLS6qsby73Rzn4Mw6AeVsBCYjXDq7NL
48909	payment	2133	2133	1874	1	1	7616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgFLKBhQi6u32gZ9nxzPqXVa6c3LHRV8bFNCUN4ZacxLi5oK3
48910	payment	2133	2133	1874	1	1	7617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVQkc2fb7pbMEDcVwVcN9ZgqfbPaNfqV2rk2RCFEBAU1zNFd3
48911	payment	2133	2133	1874	1	1	7618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqspxwGpggCzVAyLnUenE7oMGkc7A4HP7wYgK4Jxs2DSAHzUkH
48912	payment	2133	2133	1874	1	1	7619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsDBrwiUCrGz77A5NucjGYDzKsTqnkGuyZpgJCLmqvYPwRwbm
48913	payment	2134	2134	1874	1	1	8125	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdt7bC3gH5dpfC917NyxVHAXnwuckt5VCYBAiWPMVNfZ2siLf
48914	payment	2134	2134	1874	1	1	8126	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qxiJB9NNF8fg4yrYpsXrqrTtX59pWxEiiRnjgRACbvXvvynV
48915	payment	2134	2134	1874	1	1	8127	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ8PYGVJVnpMBkWRLi9GWKAQq8ygvEHaoA8xCAaCainMxPs8j
48916	payment	2134	2134	1874	1	1	8128	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrKTJXZ6LwZxvA4GZUMKimfXRffcikmt8V4iJUV4WGLaYV7Qz
48917	payment	2134	2134	1874	1	1	8129	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZZ8AeSWNrrE6qA3BV4VEwUJ897jkMTqumhpgN8zPt98ZwUmo
48918	payment	2134	2134	1874	1	1	8130	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZB98Lu8qBMuTb9HHipz7B1XNRSkVd6znP6MAYdSSfx7aR2Bq
49009	payment	1397	1397	1678	1	1	18047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFe4884HCihYNx1hX3UKoM5zaZQU7iBdKy5Rd2T2Fpaiy3eD96
49010	payment	2133	2133	1874	1	1	7648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLw9oaK3MdgbfeNZ8xvdraLSjdPUDbZMstbzpUuLyuC49HttPR
49011	payment	2133	2133	1874	1	1	7649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABuh2A12VdoMBJpbzx5ByLyBkCpGnB3BeUuQs6YK3FE4Xmp1r
48968	payment	2134	2134	1874	1	1	8149	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYozRGW4TyYW5y4LpTKcUM1W2JGEVSJ5Gi2Z7WnKXtnhw3et1c
48969	payment	2132	2132	1874	1	1	2024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4T6vyxsLrroV5gAivoyypZUzDKnEqzeCUDSiqTGEngjvMbpKA
48970	payment	2132	2132	1874	1	1	2025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSs76avtZAPkDJn3gZMEx66rqwddthf972LxtFSTt1hxLRjzG8
48971	payment	2133	2133	1874	1	1	7635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7NZwU9JAC88Pjit5i5nk3kQV7HJFzvnkeD8dWRyqp7Zuz2n4
48972	payment	2133	2133	1874	1	1	7636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cJaUjUxzA96RjHqobWut3LweMLWbhepVg7KPf3E6h9DrdZJj
49023	payment	1397	1397	1678	1	1	18049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4k7uWtVkNgaFKJb4znAJML62rKounJXb91QGdbSSLafp25Nj
49024	payment	2134	2134	1874	1	1	8167	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXX8bRf448wHj9bRFzQqmwg4J4hVaorzgs6ET4oJPQkEFro5ZV
49025	payment	2134	2134	1874	1	1	8168	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxdL9T6pk6jAn5YeWPSF68DPdpARt5yQoLF5KjerrkcFEGTvX
49026	payment	2132	2132	1874	1	1	2035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT4YqTgozoFqRfcmZtbyc5tpUXrRa3xEyEg6GJDAhKJdeGZf8
49027	payment	2134	2134	1874	1	1	8169	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qSxtm9Y1pygBcjhvYfgmaU6KQpVyoUSKPRuBdSrAtFW4LJz5
49028	payment	2133	2133	1874	1	1	7654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKjSE3GGgyegpC1dmBCaFXH4p4DBLeLxtN5g88cuiQ8mriEdux
49029	payment	2133	2133	1874	1	1	7655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncvCdATL5N32nTrLymFwBjugkRpfMtB9fnH1sQmF7tSnYzvR4
49092	payment	1397	1397	1678	1	1	18057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNk3UTkuSTZYG3sm8CFU8g6D4iqMkDasrzVznqryqrcj6s1mXE
49093	payment	1268	1268	1269	1	1	3	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanbFuLT6vwh5ihhtGjEKNj2Gw3qWKZJCfA3XPE1QjBrCwu6cs
49094	payment	1268	1268	1269	1	1	4	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuMtWSwF4fZPAg84CiJ37MU4KGc599bwgkkYnc6CfZaEWMz15
49095	payment	2134	2134	1874	1	1	8192	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3L2bJMWD9ZqVKEHtFkdrKw9vywb5S855cWh1tjf3mJmavw95
49096	payment	2134	2134	1874	1	1	8193	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMQW7HMBmAiQSho5KpqmsYxRw5Ayiu4Qpbqmz8bfJNaocZzu3
49097	payment	1268	1268	1269	1	1	5	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKUkTcj2ZS6t2UMGRMB3z8rokY8ASDDVMW7m4oruXHaHw6Xho
49098	payment	1268	1268	1269	1	1	6	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf8WRRoAYhurKrZgzNMopZRK6Kiaj2td5JNB2gf1L3wyDsbi4
49099	payment	2133	2133	1874	1	1	7675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvjAz7FT6vRQUQAKT6LRqVingu1kAA7YmFCYg6H5Hpo5MKXKw
49100	payment	2133	2133	1874	1	1	7676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBykGVYHEMr27y4y5W19GTuMH7cV6qfDNodnJpLKTkXC95Y1F
49101	payment	2133	2133	1874	1	1	7677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieixGF9Xv9DqycydJr4D6bQusBKe4V9deEvUd7TQ2LPZ6wvVh
49102	payment	2134	2134	1874	1	1	8194	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Hos1BHi6FW5euJDFCj6wb4NfUUNZTBnWpRFWAQjhjYLQEeE8
49103	payment	1268	1268	1269	1	1	7	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FeUeARpsFzjpRNj3mPERerxY17JvEwsvGxqyR52VimVT7QYP
49104	payment	1268	1268	1269	1	1	8	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hva1fwYNwaQRHXmDZ6hPGAKGqnCkZMWcw1qfLnoTAvdMP2Ja
49105	payment	1268	1268	1269	1	1	9	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DsT6tXMpLk6uuiE9sFX9zkk3raCeKJJ3M82BczMs9kV2V1E5
49106	payment	1268	1268	1269	1	1	10	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8pPF6jqwm3Sh6MPjQPvzYXhuJYh8nc53p1kfmWKhsphhdptz
49107	payment	1268	1268	1269	1	1	11	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWxeXJucF73GKpepfixqUY1iHimWkr4fkovpGKfCuYEmUDpoQ
49108	payment	1268	1268	1269	1	1	12	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkCgtackW8VumUGTYnB13hkfgCCYbvy3iSVkX64kqKrasg8pL
49109	payment	1268	1268	1269	1	1	13	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtfpB87ZK9Ze895qKMoQUuEkXDYPCjTB9qGFK9LeryjFjKHdC2
49110	payment	2132	2132	1874	1	1	2046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SJCWLNfMZ61npnxaLcz3BjEu14zLCBnHV4DhryusZvQpZ5TP
49111	payment	2132	2132	1874	1	1	2047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwUv28D2GmtFFk6Bhi1TkxqPcZjqtuYLpAWAx45ytRg3wUnbf
49112	payment	1397	1397	1678	1	1	18058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MmCyoCUw9pHdmdUher6MoS1g8qtRVPFxNSoWBbpu9yweY5LW
49113	payment	1268	1268	1269	1	1	14	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ557G1P98ZSvPDx5rXmwzZMwAZVi8HLJFpUuRQ8Ym9jRQnT7
49114	payment	2134	2134	1874	1	1	8195	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJz4c7hrLwYT46x3pLyv43ubHMSrgJkdbXauGsoYkRjke4dnb
49115	payment	2134	2134	1874	1	1	8196	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcT6NgzUKMfkxwdN3HZXf6ydrGyhkFogPhn4xkJBm2SAGiMLJ
49116	payment	2134	2134	1874	1	1	8197	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsARLEUZKpn52j88uvFJNrQyWNSeRQtyGEm3PkxPXwF6brm8LG
49117	payment	2132	2132	1874	1	1	2048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Ve6Q2gYo3m9HUSzfMurF1RSLLBSF745JBu4HZwpAuYBjSGW
48987	payment	2133	2133	1874	1	1	7640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkP17r4tcZK8Kezkvg47t7K6Q4qRvGSUzC77dXNUoEFdvLoFbf
48988	payment	2134	2134	1874	1	1	8153	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3A46vokps8ijusM1kcXrpn5JTDQgd5wDKM4Da57GVEJAdMbN
48989	payment	2134	2134	1874	1	1	8154	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTsucZZdFx4fDdCGh8tykShZ2TK2DPtWwJF14SxDQzg5NKN15
48990	payment	2134	2134	1874	1	1	8155	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjkvaiHFuK3pmruCDW8qB63Kj6dMQwd7XJj5KpGKxRffECXEd
48991	payment	2133	2133	1874	1	1	7641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUZr6H1x2hm4UX52drB2x21T9WG23b9JzA1ZjV9zJovhatuM5
48992	payment	2133	2133	1874	1	1	7642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEb661GWvuF6poHs5KMpv2PGxUMQPsMGZwwR1GZ3TZyjS1Xd3
48993	payment	2133	2133	1874	1	1	7643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZBFN2JgnzQwZFVkMEf1iY7xScRCpnL28X3iuYJjxqCDgQdhh
48994	payment	2133	2133	1874	1	1	7644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVHLfUiNqqQJBwfQh2MQTNBjeazMk3sjNWdzH4hYAKKsgXX7a
48995	payment	2134	2134	1874	1	1	8156	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJb9AaFYT9v5KQok2xwSC7Dfbsu1MSLeE3Zs5ZhRFUUfzzykYq
48996	payment	2134	2134	1874	1	1	8157	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktnsvmTHDtQ18A1TwzYWvQG26yK6i51nYnJvgnK95soHJavnA
48997	payment	2134	2134	1874	1	1	8158	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZxZryxixzXM8VFTBeDyGdbsBa8H6vXzjv5VzZSpQp5wNap2A
48998	payment	2134	2134	1874	1	1	8159	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKLH23FdfBLi3MvvcDiXEeST68PpGPAHTQ7jenXuDrXZfY5Yh
48999	payment	1397	1397	1678	1	1	18046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42REaFQzvEd3FsJtqJxggHcRVFqQKYFdNZrxeEEATqqMZ8c69
49000	payment	2133	2133	1874	1	1	7645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcErQLbeg5oKQL5ES1aLF57MM4eMUuZ7uUXKFeTPov3p8Vs1Ui
49001	payment	2132	2132	1874	1	1	2030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMLCupyNQvVhZxpmps1b2rtDXYtVLTqnQQkzWp1VxTi4HwqUK
49002	payment	2133	2133	1874	1	1	7646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihz4mg6A1yrPyXVng3eMDzVNW6iUA1KjcRh5y9pS3UHVW7PPJ
49003	payment	2132	2132	1874	1	1	2031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMFFerdeW2PAC5fEomWyUGJWHS5D2oZvMsvDLvtMBBkxBm3yE
49004	payment	2133	2133	1874	1	1	7647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7ZwgE3fAgnAWgCQow9282GN3N7KvuBeBQbHgK3YFrspFJbtZ
49005	payment	2134	2134	1874	1	1	8160	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx85yjQtMyWqM1VKdvznabRdzRUvJvmkuZAkzzYK1GpURchoZs
49006	payment	2134	2134	1874	1	1	8161	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LXCGhkiQ4VjpZYtVJQ252zEKrrA3VkWPbBChHPHjXDCBrmQy
49007	payment	2134	2134	1874	1	1	8162	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapfzvgwznfpcn7basjPJpqaV2rCyox4eeHEQhEWgjpPtAMZz1
49008	payment	2134	2134	1874	1	1	8163	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaccNDAtkHsBckvyujvjBE9inMvSAfwicxGVMyWuc2hfSK775
49015	payment	1397	1397	1678	1	1	18048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMPfWi3HaUk5hyG5s6MymFAzEnaM53QRPARfGmHR32XKY7A37
49016	payment	2134	2134	1874	1	1	8165	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQ9mbvusr9RjWPXwANn5uLYXEDmqmbndGUFca3UHnctHprQvT
49017	payment	2133	2133	1874	1	1	7651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmHy7qFepoavNWcKDz9DLSEQ3UQE3Jqetc6WQ5rgpcKbJDwCX
49018	payment	2132	2132	1874	1	1	2033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEpsK7UA86aUb8DyrUHH5hDoKxYZ2o4LmiQf4Unoes6u1yrFN
49019	payment	2132	2132	1874	1	1	2034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJfMCSfGo1ve1R9nvouNsodQfnhFVPwxkWeNy7jYyy6CGhMdS
49020	payment	2134	2134	1874	1	1	8166	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UbAjHtGhaMJpXBsWQvH4XHmqEd98hLtT2H2c6oDLq11rnhRU
49021	payment	2133	2133	1874	1	1	7652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDPabnYfGY75HCa5gF3awNaRxAMWhTc6YuBe4m8Vz8F7nvG98
49022	payment	2133	2133	1874	1	1	7653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34psM9Nf7emnfPapv7eRbA1GdAVfXitMtRhQGxQPZwFRqdPf1
49030	payment	1397	1397	1678	1	1	18050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnS3u73eom2DQVfT26AY4Ay9z95FRR5vJF12tnn8yr1J2fC1bB
49031	payment	2134	2134	1874	1	1	8170	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2jmfsY6FURZPxeDYt7ZqGGsqraH3BU5Q1jCZ2UDwHGbP6UhST
49032	payment	2134	2134	1874	1	1	8171	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXN3Jf8AQBZPST42zJyMiBCs5vz18Wpw88MZPhChq7ZSdjkT4p
49033	payment	2134	2134	1874	1	1	8172	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYridCvkWUJpZSbgcgdXmktcABTpHPLGgpd8N5XugBiqb4UuZFf
49034	payment	2133	2133	1874	1	1	7656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLainrdy52ey8zJDdibSUQHFA2QXurdcz9qA4zWcf12316WrHb
49035	payment	2132	2132	1874	1	1	2036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd95UkogXNnKUduKvpacNtVuFdm4vSAmPkbkkiJSZz1dbcD5vR
49036	payment	1726	1726	2432	1	1	8365	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpdWsMyxGnzcb4CQzvMMWL7QzYr2peZDuFMrJBCAsfetibnSMh
49037	payment	2132	2132	1874	1	1	2037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qHt6a8M18NgVzTQmjwkuFND97ZtwidSizEmR3pfR3DiVpgvf
49012	payment	2133	2133	1874	1	1	7650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pZsTnTP6aVMqtrB7EMrjbcao6hZtHx7Xv8o34ZegdK8HeoCN
49013	payment	2132	2132	1874	1	1	2032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuJfkozU85zQr71oWRkyVtMU11ySNsaYF5furQnai7So9DCL1
49014	payment	2134	2134	1874	1	1	8164	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqJTWrpDFGQjnGU4aKaQQiKWHbw6uv7YiMVLF3aHBW5wVvDco
49046	payment	1397	1397	1678	1	1	18052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJbgQadtCgy7sziaNCUDhQYeHbh8Xe1nLj5CVJHikQG9jTLK2
49047	payment	2134	2134	1874	1	1	8175	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYii7AHC9FLQoPFvR3oKkGSx51omtUXmqjmAtATFLU5h1FdytxD
49048	payment	2132	2132	1874	1	1	2039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATA74v1HQ7yx4Nqb2vhSC6CyGCRnAXYd3JF1s6JCRtGXiZewY
49049	payment	2134	2134	1874	1	1	8176	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJF5FTZXCKivXE7AkaBAZa7hLBgDA8h13thijg4cfoqhwjYZui
49050	payment	2134	2134	1874	1	1	8177	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNCg1QhSXTWc2NqfuaCnGRY2j5wGriPPAnJuesiPe7dn5dn6G
49051	payment	2132	2132	1874	1	1	2040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcB9vBdE5K9Dwd4roPkWTVjNqqP259bX5F3R8D2UVMV6ou84jG
49052	payment	2133	2133	1874	1	1	7661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fBwCeTfVAnyKyJ4eFQABkvPnP87vZaoVG64RLtFA1j8yJffU
49053	payment	2133	2133	1874	1	1	7662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrhb1Wb3c5W8cNgCxXLsWoSxtzHFA2XRXTDiMcVx9kinvwi8Z
49054	payment	2133	2133	1874	1	1	7663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznLhRjpCR72hnYmKhrTusfV7di1JDDuKXHdvJ827PrXhMMn47
49055	payment	1397	1397	1678	1	1	18053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZo2ARyg3scn7J5hN1i2sFkRswF36hK3eEFDNF4sGfCrkh5wbx
49056	payment	2134	2134	1874	1	1	8178	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqhDbL1Wdc6kzwM8KXaiR388iAFP1zuRRzDgzhiZigNsV5BJx
49057	payment	2133	2133	1874	1	1	7664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEj1X9idvgPRbDwVuFgBPn1CSfCmKv38q2rmrbxP7PtH4xyam
49058	payment	2133	2133	1874	1	1	7665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pjq8UwqN1yvvCZPWmGXfAS7BvwwnAMff9rUngi979TMsxhuc
49059	payment	2133	2133	1874	1	1	7666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtooWKjB2GaB83j9aZEstoUqNv5Gv7mpTnPtQTfXE3kSGZoGFn
49060	payment	2134	2134	1874	1	1	8179	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEN5sh5KAzy3UQp1UsFgTzdqMGN5SC2Y73tT4yTkRpTpLBqX8q
49061	payment	2132	2132	1874	1	1	2041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpz7pi7jL4DzsVVGRZ6STNEuamst2e15wBYprJqmpSn5LUZJd
49127	payment	1268	1268	1269	1	1	21	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXL3UeCE5ULpotfgL8aepQJV5uo4fBfUvp7TKoWn58bwcrSMSF
49128	payment	1268	1268	1269	1	1	22	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLL1Wm9MUE4FHJy5JKtELB9q5em7LaUgeYwx2bfpJfDznqL9i
49129	payment	1268	1268	1269	1	1	23	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaPA7i4hr8LvPYS6FR1pa1ChKW3bJMEwX6jgv8gqUEC6CgN98
49130	payment	1268	1268	1269	1	1	24	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFn3ezWamr7GKVEUN4ZEPXBeUjJdRFi2pegB95kpyL6VrqcUHP
49131	payment	1268	1268	1269	1	1	25	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpe2ZfUeJRXAsM2HGqM2xFEY7Cz7uz3vKHFQW88497W4WiAhFT
49132	payment	1268	1268	1269	1	1	26	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKSQUainAZskjy2FsF54xUr4xbqR92eA94DnqB9rnKAYVm9bs
49133	payment	1268	1268	1269	1	1	27	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqT4kTvH5PafuqKEPLQLuJLv9bnV3waEyuTtyzBJsrswGU7CiQ
49134	payment	1268	1268	1269	1	1	28	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBL9SCafA1y4KZa57q5PuuKQKKUTXUcgsbL55PgCsmp7EgyJZ
49135	payment	1268	1268	1269	1	1	29	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd5PtoM4MfrdSQWuViw2nntEnsbFoiQhtfiWveS2Tr3tfpvpo
49136	payment	1268	1268	1269	1	1	30	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtJtryDJUAWj9rXyJz9Cugvi9v3riE7QQjSFipx93qq8rNB8n
49137	payment	1268	1268	1269	1	1	31	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hpXgcyNrySuvphiDQ2B1rfgbq3YYnAHKQe4cKvePpkuTyHcu
49148	payment	498	498	724	1	1	3	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfH4uq5UiLd6YM8kzrYTrb1wD7EutdAUMh6issy9LswUknVBA
49149	payment	1397	1397	1678	1	1	18060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZraXgA1vDkxRy83C2EWs6ugok9w2YNdijaCagohgZkcbDC6R
49150	payment	2134	2134	1874	1	1	8202	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyibvJKnZitM1v5tsdtTrsG9ZrKARfcDxSa6cQhC8mv1qEKnd
49151	payment	2134	2134	1874	1	1	8203	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A4bQpA2oQyFHDGiVfNdZD13DrEiHfdoe2kFYHjxgzLo4SboS
49152	payment	2134	2134	1874	1	1	8204	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhQYwYdSRiPkZwGgWyH67efAMkf66r5Psok8LG8UUZDvzgddJ
49153	payment	2133	2133	1874	1	1	7683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCpxCG94GrcPrSs6FjZoygpBhMmW2Cmc2mpNcG6kU8S23pRLm
49154	payment	2132	2132	1874	1	1	2051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATmQo36seCFix9ipY5cHRBtE7NRuTm4HKr6Ln3DkNXvEsyw2x
49155	payment	2133	2133	1874	1	1	7684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV1Z7FKXSLEfPSU9qsN3meoPXnBwrN3wupS4hAyJqccZ4P3hQ
49038	payment	2133	2133	1874	1	1	7657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Fpqx814Lq8NPS6sY5y5UQGDskXhHG7S4HYcv2cp8PQshLv9S
49039	payment	2133	2133	1874	1	1	7658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQch7gyHgFo4sfPZRqFphuVXVTjgdVnhrF8zCjAkB1ALZ5jVM
49062	payment	1397	1397	1678	1	1	18054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjHr2oUXr54TF77FFng6QKAYR4MmdQCQapryxRNBSt1ZtHf2m
49063	payment	1397	1397	1678	1	1	18055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6cA5aWoXWPmexPSxaMUrYqNmU2cDni2WhSJNpMnYDzgx2w5F
49064	payment	1397	1397	1678	1	1	18056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRK1mC4Z1P9TnbS66yr6HRwr3fCoGAyEayurYNJobtHTsmxo8y
49065	payment	2132	2132	1874	1	1	2042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEev8wqNRbvvnx4LhfrPYWhK8ZYsLM6ZBqQ8Z8nkPC7gDmWpq
49066	payment	686	686	686	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCzYYep9aCrLQUCywy75ocrjGmGkfiCA3rWKyx52wdQDiKhvf
49067	payment	2132	2132	1874	1	1	2043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Xz9mjkeye5HvXPaQRVqJTGM3Zx2ApWzUzaT6bSWputDYcKS3
49068	payment	2132	2132	1874	1	1	2044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqFDyEkNG9U2THDgGsWfxFHHGSErxu4ypWxb7WMziZbY6Xv9D
49069	payment	2132	2132	1874	1	1	2045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rtGwD3AWM3jmUzSMZCMGigceM9SfnWUADm8vdFKQHATQNXpV
49070	payment	2134	2134	1874	1	1	8180	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoQo29Th9dYF1sc4ekMrewx3EJGrhxTZJ57LSQTgG9naApe81
49071	payment	2134	2134	1874	1	1	8181	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnYf5WuNLzML1QfCv6A2Bw7toZtbGFjnBZGexDiQszuGiGsRr
49072	payment	2133	2133	1874	1	1	7667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGwfgfjhNCdHKuDisER5J8XwZVHwSeT799Q2CRof1mtu97xtG
49073	payment	2133	2133	1874	1	1	7668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaEaxS6Er73mNrJGdx5Un8brMfWzJU2zWgN7XNLue37XHJ3UL
49074	payment	2133	2133	1874	1	1	7669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4d1jVYKVWorZ9D1ZRdqKKKw1oLjpb8zok6hop9dUGmSVaC6X
49075	payment	2133	2133	1874	1	1	7670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLwkQtdC1ZVVPFkTZn51szGqcELQMTH3qdFiKxbh3bz3t4JVa
49076	payment	2133	2133	1874	1	1	7671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgdTFrbxxUcSF4eQWiXLBSU8d3r8bQz2AKiQeMyJevm6ZmykR
49077	payment	2133	2133	1874	1	1	7672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDksQAeDVeKxw68qGKrMUHuvo1iL6V7wyKRX5gnxFkChUr1fU
49078	payment	2133	2133	1874	1	1	7673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6zhuZYLvVLkmdQuLaExaw2o7VPZUyquvvx4G8FWsZfw2UswE
49079	payment	2133	2133	1874	1	1	7674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmYkTvAyqyc8GjJKkhicwXjZqTnadMbWtJDyLcLM3QEqVFSiP
49080	payment	2432	2432	2432	1	1	0	100	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybeLpkj7LYLyYCnySQVZMddvszk8ZMWSs6CjZfms63yV1wRDY
49081	payment	487	487	1737	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL57PunZJMCKi3ujnzRJVXNZ5gsfQ1bZgi9zEUg4EkFpWeR12s
49082	payment	2134	2134	1874	1	1	8182	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTZgn576oxqn6ABKUMKef1KYTDpXMf1kU3D7WrDadZhhnDSSB
49083	payment	2134	2134	1874	1	1	8183	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAwjYbJiNhnk9pmQmX7t7A1igbJawXnsmmuZZynubDeBYy5H5
49084	payment	2134	2134	1874	1	1	8184	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1kCdJcPUucjom5sMYyJu2akP16yf8Fmzcgksz5KoysfnQcjWK
49085	payment	2134	2134	1874	1	1	8185	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYavnLHVL67k5tSTEVhXZhnCK8YZwmMhsHe7btQxp6e7Fad1S
49086	payment	2134	2134	1874	1	1	8186	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzp1izjbfvm3XSPeJAcdTc2qZFEhwiixESV8SnUAHK6gnG6XR
49087	payment	2134	2134	1874	1	1	8187	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9TQDv8jP7mmWjVdQsxsx1erMdkM4z7TsBp82UCAMaVo721FV
49088	payment	2134	2134	1874	1	1	8188	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYWoS5C7kRpTBEJrTw5PBXSzrp1GgzJC7e4Fbro76g8g35hmi
49089	payment	2134	2134	1874	1	1	8189	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MKVdLXgYKoaD3ZMMhs3924fBnnvB5TMGvarVXBM3s8dUgkm1
49090	payment	2134	2134	1874	1	1	8190	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4S7ERAqxeu6VE51fYccwe2pMJ2G2eNG26pmiSx2prxAXtcfyf
49091	payment	2134	2134	1874	1	1	8191	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkwZxQCae2AcqbqctUmozmtrftpfkYmJc3jkkDeWp64bPBVuf
49183	payment	1397	1397	1678	1	1	18064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQy2vTewBuG23CMpPeXqtME7szKmx2z4PEs6QmB8fEsWzuqap
49184	payment	2133	2133	1874	1	1	7695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8SQhGpgk3Um25B6ZgrmwekCP43DYZtwbzVbqf9uEVRVCVjeX
49185	payment	2133	2133	1874	1	1	7696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN49V2LWnFEHQyPe51ZWbf4wi6PcoXq33LqSdxxZWoLEijc1Gr
49186	payment	2132	2132	1874	1	1	2057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutkNpVZRxg2JKyVmWQGUhxZR2Ge2rAGZSNLNpmCAHQRCGVi64
49187	payment	2134	2134	1874	1	1	8213	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKuzvZpwu8KidNoGCRZtmDQuXGoJoyqVY2eEQWWjrXubpbcRY
49188	payment	2134	2134	1874	1	1	8214	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1NkZ6Z6Hw64A5GzTaZT7RHqkzA7PYhG65g2kQM3SBwi6Nt6E
49042	payment	2133	2133	1874	1	1	7659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hn4oJG3cn6MRK8of7fWN9vanzGsczDYx2YaKT2asJ546q7vj
49043	payment	2133	2133	1874	1	1	7660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDo5QCFoiCBMiTKWnLMFYtzrBAdPR3BAmNa32MZJU6hUcCcWa
49044	payment	2132	2132	1874	1	1	2038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmWLizV7BoebdxLjvSn3K3knV2ccL9XaLpGB8a25peKW8e92i
49045	payment	2134	2134	1874	1	1	8174	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8gTiDQV9maJzJ3dDL9fLpEUMaRTmvanmve5e9Jh1z5Pb4R5V
49174	payment	1397	1397	1678	1	1	18063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7dfKYJupqJMv87hEbPzXknZ8RAwxtKuDjFUv6LrsJGYwkL7d
49175	payment	2133	2133	1874	1	1	7692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cM6nvXaTF8yUp4FuJpfJUaWyCt9VDdaP2KnYauaMAgd19RmU
49176	payment	2132	2132	1874	1	1	2055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5SgirYC2wJemxx6CT9Pr3CJvwPrbnK3D56kcymV3gCRNvPE
49177	payment	2134	2134	1874	1	1	8210	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ezLegvEb2ceJn6fMQ1wsntg2YUjhtPbUHnVXEe3XgJp4JntF
49178	payment	2134	2134	1874	1	1	8211	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzr7DgvzSCPdgphqXsCNHQtmWdX5pe87dWQVvMNm129wHah3XT
49179	payment	2134	2134	1874	1	1	8212	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZRfk6r9cqybzSt2jP5BNrEJfzkxbGF5A3w161FcWRAWjNb9c
49180	payment	2133	2133	1874	1	1	7693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThgEJPznEnSmPfRq8rLMKDw66TPAqNp7Hm2uQhkRFoNDv61GS
49181	payment	2132	2132	1874	1	1	2056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhpWXL88pugUrrPDbLkpZXz3D3dvKfAPxTBefRzReguFyqnLY
49182	payment	2133	2133	1874	1	1	7694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWRrouiKvyoYigjkcxwsnBu5uN7nncbyQvqV8uHYLnS9JeAEQ
49243	payment	1397	1397	1678	1	1	18070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7nHgbWtAyF18VBKmzj9mivXzxquBNN4LLweMMsKPr8GgQm1e
49244	payment	1397	1397	1678	1	1	18071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZroTQUttkLzqVmj176hHGTMx49g44Asziw4SQcsGE8gYcFYuoe
49245	payment	2133	2133	1874	1	1	7711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNg8KcefvAzeyb5KNd2jpWXNkiMrYPWzTFMQoaEcrSSLr49PX
49246	payment	2133	2133	1874	1	1	7712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamisND696aitmqLdLctTBw9sNhYXLidSGpY3eU9aPbiuU5us9
49247	payment	2134	2134	1874	1	1	8231	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGGepnoprPK3fepu1RefLEtdsxAryZXgtGY6EowcD2P4fW5cm
49248	payment	2134	2134	1874	1	1	8232	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kAma5s7WrqNzns2B3dwsaCoSoGURivHR4fnMxtghoMfq6rjn
49249	payment	2134	2134	1874	1	1	8233	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHi1RFM9hdzXptC1vJmhqvN3qupmtPKxusM881TKEPYSL7JKRk
49250	payment	2134	2134	1874	1	1	8234	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4RF7Wa76qiR8mtncYnFY8Wih4PSZFMxcbtrTBKrpUUEoME51
49251	payment	2134	2134	1874	1	1	8235	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGzsJbaCEDKaeBrHMQKyX3T4nAwm7YEMkNNTFZaCuMAVJ1RmS
49252	payment	2134	2134	1874	1	1	8236	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDKHh9tjYG7jb8ey6SvxZh5d3z5FUXhr6iUVp7bg8aChYoWeo
49253	payment	2133	2133	1874	1	1	7713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuTZWo4eE9p31BCNC15zNTWWijSzCivEmejiLdvsVSKfa7Mbjx
49254	payment	2133	2133	1874	1	1	7714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mjdSc1WBMxoddHyY6UFG1UGMxyv2iNKBPy1G6WYdUj7DGbbW
49255	payment	2133	2133	1874	1	1	7715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbXwjP4QfAjGRsx3dY3NTwFMY3gKV6aa8TyhBRm1LvHrUuAEe
49256	payment	2132	2132	1874	1	1	2066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pvH14YFbLEQgKWr64ZtdA425VMrSPBCoPUnDfKm412w6rE3H
49257	payment	2132	2132	1874	1	1	2067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodZkmNo5FukCQbVjFmPQePAmorzh3Co4YLq74Ld6gaRzyc6Cd
49258	payment	2132	2132	1874	1	1	2068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkY18JgbwUUNy6P5d74gixd9N3cZXu2iT1aBpZvKix4Q7bxVom
49271	payment	2133	2133	1874	1	1	7716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4y8xB6rtTG7pwfEHNESrxx969oX1vo5rGQgCVZ7EhpMduEbCx
49272	payment	2133	2133	1874	1	1	7717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuf9aoMyBY1yLvvdrs4MqXz8ZhjhBLUSzmBNufUQsEhvDirT5X
49273	payment	2133	2133	1874	1	1	7718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfR37ZRSVxdwa1hE2FpihCNoEZv8xaAKUTXc5SicwFm3QQk8KG
49274	payment	2133	2133	1874	1	1	7719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjarhoawwjEATiYj3cqgyPseqhwGyfpzNVfWCfLLZKSmY2dKn
49275	payment	2133	2133	1874	1	1	7720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSp6VDgq7pXU5F2TSyr7ppPAZ39tj3VHtD5hRzLDCk9KMWWWAp
49276	payment	2133	2133	1874	1	1	7721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktz6fgRuuzxwmo5fLoHuZ9sCc55Gj2YMGajjuL76N5D5J1fwT
49293	payment	2133	2133	1874	1	1	7722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWw98Q44AhGkv7LE4fYBv4EzY43JU5teWNiqnic28Ck7J1UahM
49294	payment	2133	2133	1874	1	1	7723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjM1qmULtDVhja4UWDQ1gqA952TnD3JMz2S3GzjjvjUjMtDHz
49295	payment	2133	2133	1874	1	1	7724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjhacCjrJ5qHFzo7ddsLjX5JMFBqBFqpmgjUNbhjSQmc51X7v
49118	payment	1268	1268	1269	1	1	15	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZBbGQJsMZvEBmFpSWUWftcWcvxPWHZ7Nsb7nVZWEwL4fbjqn
49119	payment	1268	1268	1269	1	1	16	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonea3kZtocCreZm8YhA84vpgRbcViVHJwisDyzTyFmLEvKeDX
49120	payment	2133	2133	1874	1	1	7678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pF7xinnfZExWHRELYL3ZjszZMedGVKW4hRPuBjCKRpDAHoPp
49121	payment	2133	2133	1874	1	1	7679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp593t7hmNfL95piaZ4tDWRo2d4YtSSCRzxy1vY8urw1gxTbL6
49122	payment	2133	2133	1874	1	1	7680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYsjkSNz78VWpSR1WsfQ2PgouhGGdncHsQ5aGtNCrwnxVHwAj
49123	payment	1268	1268	1269	1	1	17	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiAS7Ki2uJKZNRp6PAaNdpBE2EYuhn5u1N1QRPttexXJCtckF
49124	payment	1268	1268	1269	1	1	18	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6s2xwrfhTZ1RsgtASCEtnNu4zpEZp5wqyT3tvcjajAPf9FHgx
49125	payment	1268	1268	1269	1	1	19	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7BirnGb2TMBp9jEUc1Dcha9J9qFhursRCenUo66SQ13Z5DYt
49126	payment	1268	1268	1269	1	1	20	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVcwT9k5TKdrTB9ipPKirBSe5CkJK2qXHphQAUxuzjVC7t5R9
49138	payment	472	472	1428	1	1	1	900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7X3mNYwcFjRRPogvvCq9EQLviQvYLTaWPgfNA7RSv8UiQ7Fm
49139	payment	1397	1397	1678	1	1	18059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsujFca4sHcA75rKns6dLpynSAgi4jbYJiXv1YPRBquoua9ZEN
49140	payment	2133	2133	1874	1	1	7681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfUDcaZrqNzZ1N8DF6K48niuwCzxnKnLPmZJFcBy8vxC3pDNe
49141	payment	2133	2133	1874	1	1	7682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpBEC5HCBphWTzvJP2HZh1SobFCvyfiVAz5JjL5aZdVT2SXZb
49142	payment	2132	2132	1874	1	1	2049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHi5fa3WvrSRy9Yq1Q5q1HiCPwJbmRmmbG1YnWtzN6BQJZVaP
49143	payment	2132	2132	1874	1	1	2050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMcw2jQskAgtipi2AKKNAAfWQasK8kBYEVj98hyuuP37BAxqG
49144	payment	2134	2134	1874	1	1	8198	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCFLxCuUJqfeMXySYsBhqEoj57T4VF478LmATwJD7XRMLdHNy
49145	payment	2134	2134	1874	1	1	8199	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1BfH8oXR87yski8M6rdySXHRoC53fKFabdp9ajF7YEx5aUaj
49146	payment	2134	2134	1874	1	1	8200	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxi7pDZUdRsUY4pDpuQtQ4qcBkAsfVY3vNYX1MBKpBNuMZ121
49147	payment	2134	2134	1874	1	1	8201	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5cvwRSbUN6MpnBD1iG24n5A7oZtHwGHQNzUYTwgJgit7bJ14
49190	payment	1397	1397	1678	1	1	18065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRJhJp1KkkURGfJbXYfgJXyZsSo3sbkeHmemk4oWZw2UhW1KH
49191	payment	2134	2134	1874	1	1	8216	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfwbzRS6Zre8wDVP3Re5GbfGFtAHr7ENkHrExS3X5ikUY4Zma
49192	payment	2132	2132	1874	1	1	2058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2ifoT5K2CGvcovnbE5qg444BspgRWu3i6eeLgibQosyKaunG
49193	payment	2132	2132	1874	1	1	2059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkERJ4LvfLp2hWxG7SWYp5MzHYCQ3ch9F4dnThEhyjQAByNKi
49194	payment	2134	2134	1874	1	1	8217	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2Hmqi2Q6WcJr5AgtBnajepg4GGmcNq6XdNHSFmsdNtkcyjnS
49195	payment	2133	2133	1874	1	1	7697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhShQp1YsbxN9dzJu3CmuFjParXBDLoCEa5EHTFjwWdaM2ABJ
49196	payment	2133	2133	1874	1	1	7698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsVWcDyWFgvXY3A9vtDuY5VDHoZPStmaW69Z9z7jkagSvK1Ja
49234	payment	1397	1397	1678	1	1	18069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGFMpCPG1zftUW5pVGhGeduP5wT5dhruXo1kRKhSjaWiwUmEN
49235	payment	2132	2132	1874	1	1	2064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNuhkUBSBHJ3XhH1x2c625LEuixidFZQrJjqYYAn5DqKuYido
49236	payment	2134	2134	1874	1	1	8228	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZeDR6RpV7aX7duoEvzNKWAUBBbQSmDNY7jF2j44CV9TjD7Jp
49237	payment	2132	2132	1874	1	1	2065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYL4kU113vE1H4zqdKQgmw8kC1bNXYBAtBwKC1HBFKbWGdbGL
49238	payment	2134	2134	1874	1	1	8229	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FLh14sg3z8ZY4GFGRboFJUpwQSv24nkhTacjsmyXKPzQfZnK
49239	payment	2134	2134	1874	1	1	8230	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBN6FSw4SLNknnhSxdkn5Bfj7SN26x7ACm89FcU5AWv4bmmRf
49240	payment	2133	2133	1874	1	1	7708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApH5nr3vNL67hooYgcjAKwoMRG8kjJnPaKaxWVJfVwxrBqFMe
49241	payment	2133	2133	1874	1	1	7709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy9rui3wvveH97kTGYSWez65PVyakaURR7JrCDsH946YtXwx1
49242	payment	2133	2133	1874	1	1	7710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPAKCEhxFfPB3EtBd9UtC2QWSJJHy6xY8ZiProzzu6shdaoKE
49277	payment	1397	1397	1678	1	1	18074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MYcC3xnApf6RfHUTiPXasa7T9S9L3urZqedqz2ydct9bonkc
49278	payment	1397	1397	1678	1	1	18075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgb9ja3awzo7KAacBWUCNF1hWQH4YTTckXFEdbeGzz3FWQdGV
49279	payment	1397	1397	1678	1	1	18076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5xA29aDAiVsCam39FsM3MjJcanMeS1S3Wczt5ayw9UZ6CxFy
49156	payment	2133	2133	1874	1	1	7685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxZZEsJSF6f46LQozYCLuyMmkQEnJZYV9UwtCEAzSYubg4VH2
49157	payment	724	724	1956	1	1	5	1000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD7uwo1CgiPcBHGBZ35zvLN9sJLDD4N4ojczobiKqx8kQhMon
49158	payment	1397	1397	1678	1	1	18061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgepnfg1ikKCiaA5rqUuerpBbq8bK33yVD7r7HrGUskrAqU7pW
49159	payment	1397	1397	1678	1	1	18062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwdR9YGevkUf2tvDjosnX5zH9S7XspsZEDcATyhWavQKXtttS
49160	payment	2134	2134	1874	1	1	8205	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpmVzL2akQLUHxW2ckLQ4YB2Q1U1vqdGnNMsdhznmegNgXe6T
49161	payment	2133	2133	1874	1	1	7686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZMiMvjCSYoj3VdWhoWXCnp3fBrJeDbCG6Dy5S7sCh4kE7QKN
49162	payment	2133	2133	1874	1	1	7687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjsejiGjDgeeEgazq1nTMXXBKXPeFUhjnHYRjxBfHnbKhdDEr
49163	payment	2134	2134	1874	1	1	8206	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7DeM2a8UzxbtGfkxSSmf4yWkJaXog1gfnfHcdgiZR4U1RvpN
49164	payment	2134	2134	1874	1	1	8207	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDPQtEU7PyBw4xB68PtHktdZgd53gMSykohMSexX27ynhVZje
49165	payment	2132	2132	1874	1	1	2052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRciJNVE5WjcE6FRTtTuGZE9rAp3Qg9DJPbwzMssyFDJ9f16T
49166	payment	2132	2132	1874	1	1	2053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLYJvp5fdrnx8pWzM6huTeZrK7RCdc8cHvcvA6DgGszh7A9CH
49167	payment	2132	2132	1874	1	1	2054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2txDi4a1ZqWMbsQpfYtr2JAkiu6s7kqb95RSC6Qpqe7mZvZ6Q
49168	payment	2133	2133	1874	1	1	7688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5b4Wra4AHPRJzq11Qhk7iPeSQWdLSmTv315GTfA2m5Kigfx2R
49169	payment	2133	2133	1874	1	1	7689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNKNJN5skoGsRuQyyJi9nkmJKM5WbuosiCZeQTUbHEeBDeqRP
49170	payment	2133	2133	1874	1	1	7690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyy8MKpdT74qFHDUBmwCghs4JKDbv6soMdSbu1e5R4JGgMv4bk
49171	payment	2133	2133	1874	1	1	7691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxNjnAj7ESmWoYE9yS2gwLNJ8DK4GMm4gaVJ1H3p5pwYdr29n
49172	payment	2134	2134	1874	1	1	8208	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHajqo6ShHgbiYjg3oeof4rs85KuF2kYtr19rGqwCkx4Uq4j1
49173	payment	2134	2134	1874	1	1	8209	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuaXqFpQa4EXAT8SY1CeyKNVE2TGyhD2Xph66gMLwe5TxV2ES
49259	payment	1397	1397	1678	1	1	18072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMzw4nnCmzjnsj6jhmCCstM6hVUTYQY8fph5avyzyVT63fnJs
49260	payment	1397	1397	1678	1	1	18073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiUBgvTip5GJxuW8PqeUjRfkunmrcDuS61gVnk6QvxcvE947Z
49261	payment	2132	2132	1874	1	1	2069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9JZ8dHFeJhErnaZw5VcR7gwiGBd9sHrPbmqrPYjmdUGvbRig
49262	payment	2134	2134	1874	1	1	8237	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZaEBJmztbCn8nwYTVcEzMZ3m3d9a3B2hujP2dKRT8oWQZyQq
49263	payment	2132	2132	1874	1	1	2070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxtCkhFr6LSkWUa94aXxYPSPDSEEvHHZHfu4H5v2UyGCm8uoa
49264	payment	2132	2132	1874	1	1	2071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQfRJ3NVEG9HUy7Xn6ZgEwTCK7Mn4b66s4JD7kvo1Zv1okD8G
49265	payment	2134	2134	1874	1	1	8238	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqb6Q5VcW1srAGYsTZu5wb2xKC9sKPyUm6A96gLLmAk5PyF5G
49266	payment	2134	2134	1874	1	1	8239	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1wDPRbjgwpaAkP8xy8Jn8QcezEBxgwEAex1Bq4zKijAk2NyE
49267	payment	2134	2134	1874	1	1	8240	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fyfJai8p2Cv4jgPjJaVqGVVRTd2iKhK7TQ21G7VW3bGK8xJU
49268	payment	2134	2134	1874	1	1	8241	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSNYTaReZ7FvPwbK5ZH8g4RfBDt86dyCzuc9H3ciaPMm2p3SE
49269	payment	2134	2134	1874	1	1	8242	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVP4E2mqHpy2ByqztibxC1o32LXWzd6UfvP9WfqkFisMSaxGb
49270	payment	2134	2134	1874	1	1	8243	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8toYMqpgJ1oCDvDXrPJxQNVotNcjeUS3mcmh1qk38rg6VGcFo
49317	payment	1397	1397	1678	1	1	18079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhMTcnheoPhPGiyaZrrXzXCLX6HaGpjUUcF79kQda876XGZfz
49318	payment	1397	1397	1678	1	1	18080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDa2AvMy84rsxqf8c13Vs6Mpgn7KBM86FdP5A5LDQdZiMtJ6t
49319	payment	1693	1693	342	1	1	1383	86281724001	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYscpYvobjqR6ZzaPrhksDKEQynUJz1LyGJJwYTBeVcHMnLAPkC
49320	payment	1693	1693	894	1	1	1384	402816835368	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZXbwnvfUC8Y3JvSNYXG4ThxGkfSMuhMDXWuxMw5kh9KhvtbAhi
49321	payment	1693	1693	569	1	1	1385	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZYbddF6nYnb7JiBHfDP3AGhoXVXgxuhrAr9xTar6qTiMA7UhNK
49322	payment	1693	1693	390	1	1	1386	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYc1mngr1eJ8QFU5AUfGFGNjxzJtjvWNow8WHXMszgQHj2RL7De
49323	payment	1693	1693	570	1	1	1387	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYmBu3JMRFc7aTVubh6aCYLNr7SJ8zHuZXEDzbPweHVt1Cdytbg
49324	payment	1693	1693	251	1	1	1388	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZRRNc3higtDXsFAEsCYvecQWY3oFxaaHSKkWuZid9sjLtAMqhS
49189	payment	2134	2134	1874	1	1	8215	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG8mwgunkUwhk97j2UZpKEnBG5zdbpwkScnAioXYFMFueHvno
49197	payment	1397	1397	1678	1	1	18066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyNhoSZgX39pHKbJ5ekgA9TfEJxW9y9XWjtVipFxJHbZgw2FG
49198	payment	1397	1397	1678	1	1	18067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuJ2EXERUoiWR9RaN878gFWS4AnhwCFFJXjGCsgDahZt4qnBH
49199	payment	1397	1397	1678	1	1	18068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpcFn6JFNexcDQiydLBjpnopFQAv6e2CtQxusvgNoL6XZDmAM
49200	payment	2133	2133	1874	1	1	7699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kDV9CFaMjCLRMCKKYNnXXmNE4gzw7uqQ6cHpDYcnrSaCKL4Z
49201	payment	2134	2134	1874	1	1	8218	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjCeMkKBx3LWQpJiA6v4YvwCJTZdZu4xCThZKsTPAEmyL1c4R
49202	payment	2133	2133	1874	1	1	7700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9K4dzsDiNAMEPDPYLVuv1HkGvhzKZV69xUrmZpyTpz7RuVx2
49203	payment	2133	2133	1874	1	1	7701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZXaVRK4tLirAe1NP2Pz1v3BxhViB715GoXPW9V51DwwBamqs
49204	payment	2133	2133	1874	1	1	7702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYt5XJrLe8XPjzKGG863bY8wQn2zwqytBxWHMbchf4EkQ1J3Y
49205	payment	2132	2132	1874	1	1	2060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jTCyTVtCp8x7ybZ7ZfSpLFcYRgGeL4tp7is7VmrfK9ncNP4E
49206	payment	2132	2132	1874	1	1	2061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBmx8YwkKHdbcPmQccxraP6TxR99YXx54dCCLFrT4BTeo6gCD
49207	payment	2132	2132	1874	1	1	2062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkVV8HG4vhFcRSfVJYXWDfb3CRLvNSTGaSKDxywZY8ySQ92Km
49208	payment	2132	2132	1874	1	1	2063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBj7t19FVwvevQfs6GbJYibVND28yP3Q7GcsdUoEL7XciybkB
49209	payment	1268	1268	1269	1	1	32	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55jaPD3DCDX4z5e4sM7ynMhoT5GZfswhREimXw3MSUnSWgV14
49210	payment	1268	1268	1269	1	1	33	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVsEgfaaf5ZgM1ha9Us9nYrNmz8fpaZEWtxdZLkLHz2jCfqbB
49211	payment	1268	1268	1269	1	1	34	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgzv5m2WdQBo9tonqFynKFrJneYUPiW2yxGNrNXrcQoUczUhP
49212	payment	1268	1268	1269	1	1	35	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4RcJY73j1bQkjRnUzri1KNJZuEjgr9nSSjKynmnVKhsYQwuG
49213	payment	2133	2133	1874	1	1	7703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YCXxxZ4kUoZ9BmHgAEkKQqgPqE6oiY6pHZ9gwb1Pekxtnqdk
49214	payment	2133	2133	1874	1	1	7704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYobo3YpcRi1q7StSEHfdj7ApFZHbN1k5BuA44PcQDeQbSQbS
49215	payment	2133	2133	1874	1	1	7705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWr5ap8B7YWFnA6MmfwRksSdg16iDQpLeQ9oQJHgi5bAJ3RyE
49216	payment	2134	2134	1874	1	1	8219	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HMUhU4hyyxz5HcTn6GqaDq7PsZjpyg77myBDSXpYonyKZAjg
49217	payment	2134	2134	1874	1	1	8220	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WmUAqAiDrczeWb3BT4bKRBmg6reLqNZ7w6F9VmeDV4TaYDpN
49218	payment	2134	2134	1874	1	1	8221	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGQnn4yYhDEnvqdnTR8qjSNEkN1JZJFzYEcJMxPuitVPpxtoK
49219	payment	2134	2134	1874	1	1	8222	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPhCdcK9JpHKgmpRS1GAhZLKr4Gaa67o8tzdnTy9JVTVvMcfA
49220	payment	2134	2134	1874	1	1	8223	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVcn2nYBL3vNGfo3fVJrGQzep24BJAyTpuwZsUyZhSnJsE9fn
49221	payment	2134	2134	1874	1	1	8224	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcxuZUKY9erb2UWSd8w3XMWSC7e4mc6ipcUE9msjV8f5mXxfp
49222	payment	2134	2134	1874	1	1	8225	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViP5oMdArD6oLvhTLKXDdaGUZK7ghprkL7xBSpUCet47R9dX7
49223	payment	2134	2134	1874	1	1	8226	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPMQaVLFxj89MJ8WrLFxEpxTDPJbNTyjVFsQa4qrdt3NvqUd4
49224	payment	2134	2134	1874	1	1	8227	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa868AuJViCeRbKdfSJdvqvMsJ8EZ8wx7ds8mWCNuM9cYLD88EP
49225	payment	1268	1268	1269	1	1	36	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YwhjpggKWNYRYeV1kf3iUbar8wtbmGxB4RymazU1XVuNyADE
49226	payment	1268	1268	1269	1	1	37	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQQQNrk85igyTb9jg2RLHTGoME3w2SM4HhDJvMzKedihFDE9w
49227	payment	1268	1268	1269	1	1	38	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzCGSxWNb4QuBcXsv9xjCNEMALp6yKeh12HJ7eoMSaCMgvH3iX
49228	payment	1268	1268	1269	1	1	39	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95DdQLZhV1KDKWE5jA5p8NkzWKX3wxFnzKF5Z31LX76CuQBQq
49229	payment	1268	1268	1269	1	1	40	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoPcwQPJRuBckeYzV4SGnews3sEHuAJUSxGsC85XQM69TLZDJ
49230	payment	1268	1268	1269	1	1	41	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMe7UJ6CzaD1FpTpX8gYSVvNzSpwLvbMu6TrD9KPjRCEUDsDTQ
49231	payment	1268	1268	1269	1	1	42	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uQ4GZHkfUvBdQzrKPfxKvKCTBTu2r7kbrqdsnwpb3SuBHvSj
49232	payment	2133	2133	1874	1	1	7706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkgcp9XMNgQuT7DmXovJium83xngt7gZaLs6Tsvpa5HfYhGex
49233	payment	2133	2133	1874	1	1	7707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUVxgcCj3XMKHzw6LWCgysJ6zu63sThtHDTt6ztPTtDEAY1zp
49280	payment	2132	2132	1874	1	1	2072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QvKWGXFyfJxCrPAwqS1yKRBUmDkJHN96i3ziu5a5negawLYw
49281	payment	2132	2132	1874	1	1	2073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicr8eaPBJAq4rA12qmS16A58rYevp9JfVBAkrKdWktTYR4it8
49282	payment	2132	2132	1874	1	1	2074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3uiP8BmcDaArCj57QLMQptMMLrEkD4yBWBKqsEMhGcNikfyM
49283	payment	2132	2132	1874	1	1	2075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHRECiU7n7QJ2hLsFniCEEfcWkXL7t3yg26mrWJqDvKds5PNZ
49284	payment	2134	2134	1874	1	1	8244	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3pMC5Uf3MpqNMyWP3TV9GE817jZvZ9qoHQAuc1tXBftkK8G3
49285	payment	2134	2134	1874	1	1	8245	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYP9qZvZBm2Sx9M7jF14ViQqwYcuSz8qsJQfYt1MG2Gq6hTjXu
49286	payment	2134	2134	1874	1	1	8246	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pPcLoRyMqdsygJ7iizYCrAnsPzVB3adKpuzzA23kpSg3JJTB
49287	payment	2134	2134	1874	1	1	8247	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkWX6maJnFMNJLm5hM171jwa9Vs9ecpjUwNo23VmzHhABLGty
49288	payment	2134	2134	1874	1	1	8248	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfhC5tE9zSVjSdXQzRBqcWohex91psEUtnzocj4SdPapTDVua
49289	payment	2134	2134	1874	1	1	8249	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBs6FoKRvB2pXnvAmjVhMpVWZqR7oFnayyPTqq1q8zYLiBLve3
49290	payment	2134	2134	1874	1	1	8250	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwX5xqYerNCS6zvAshE4GwS6nzgcErbfZQusVYBfnRbHMUhvnw
49291	payment	2134	2134	1874	1	1	8251	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLP7V3YvgZUUHvxsUPyp1DNn58PLTycbj86Q6CXzoUuJX9oFh
49292	payment	2134	2134	1874	1	1	8252	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wdkhGehJcEtTWmfrHdNAPYHiDumMNWe77e6N5JCoCi4gHw3E
49301	payment	1397	1397	1678	1	1	18077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtX3ZrTPxnwXArgU3xr4xYBp8Ypr3ZKQCCRogqq3t5acagWZA
49302	payment	2132	2132	1874	1	1	2076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8h75R6Wd4tEojCxbmPwhv56SqVR1eQbrto7MSie357Dwku8VV
49309	payment	1397	1397	1678	1	1	18078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM8X4PpLscMEbgSbFqSb4Sn9FYoefXCuZ6gJrs2H7k3Tku3Zd
49310	payment	2132	2132	1874	1	1	2077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMEcUpmkoEbEhU74Nq68Yc5Ndj5isM9AsiJuTu9P9Bfbfruqh
49311	payment	2132	2132	1874	1	1	2078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLD213TFpioAamMfuQXo64QuTKTpewiBpUjR7DucDyTeA9pHLN
49355	payment	1397	1397	1678	1	1	18082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJezKPNpkQBdydKur18MwrALiJiXtkkyDsmiGAuhFRLyBGYupu
49356	payment	2134	2134	1874	1	1	8265	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSpBjJjtX2hLXDfZZRsfu8tEQnSPLFPPTvfyfnHmPRpwhNZ5J
49357	payment	2134	2134	1874	1	1	8266	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmDnXmoCfN5Zz7mYfBiufyMgYGmvn8vgxjAXR4LQsVx3oJCGH
49358	payment	2132	2132	1874	1	1	2083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtkqdHDb2HxWgJTZkfMtgHNxmE8RUdKizvwYmJcwRhcEkxgQh
49359	payment	2132	2132	1874	1	1	2084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUVfKQJ8Q6r4ayCMhcoKp8mmu5nTrRKvdU9vXbspZAtQETka9
49360	payment	2133	2133	1874	1	1	7744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8K6MG3o37PCtBfVWjnjaoCHxDRcTHF7WKvhSAZ8UVDhHJqLSV
49361	payment	2133	2133	1874	1	1	7745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzCxTB2rHc8FtKukWLhYhzFs6yKfuFc171fexSVti8nofmaSU
49362	payment	2133	2133	1874	1	1	7746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EvGb5VLSzE6P6ZJwttm2uCD9aHoH7v5esYxMs8VRZwUsTDyx
49363	payment	1693	1693	1811	1	1	1399	238084910275	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaE2tzX7W46Cyw27YGw7tf1T6rh8Ue6JzefbMpj6xNYFzda8i5y
49364	payment	1693	1693	520	1	1	1400	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZtrFMA8UQuBMbKWYCxGSpBBrk4BYLrForCZHSDTWJEGbZj1qGk
49365	payment	1693	1693	191	1	1	1401	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrsGiM98vKDdVs7YQg8H9TSS2M7VHGnRKzeF9AQtuwcXej7fRt
49366	payment	1693	1693	421	1	1	1402	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa977JYAN2yW7U2VEhSfuicb3nHRghuthasZN8FkyT2fUbpF8aF
49367	payment	1693	1693	266	1	1	1403	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZAfCkyXf5qwSS3HsYLeXtApDB4dEepNYeAws9fpREf6NW6ViKX
49368	payment	1693	1693	352	1	1	1404	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZnzUvfgA4hptjeTJN1j89bShTEtGWsx4YDfZp2GibSrneT8sfb
49369	payment	2134	2134	1874	1	1	8267	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvwA6E7iKNY9xZWzyuS61p5e2CWLd8KhbyxHvPTN46phSfVRh
49370	payment	2134	2134	1874	1	1	8268	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZQipbBsMv1kn6VqubU46Yh9zfbNd2YSv6e5pDH8WbV6Q8Jh9
49371	payment	2134	2134	1874	1	1	8269	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YSC4GtS7PpxkmBd4xocB55AGm6VLRFxuMBveZEQLCMDBuQBi
49372	payment	2133	2133	1874	1	1	7747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBidJkbzeYh8aLGvvmucBLgT799FQrQJHgau4dYP7B49kZJTBx
49373	payment	2132	2132	1874	1	1	2085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD8yaQc73pbU347KoBzLUsPF7SBiyg645TagePiUnEENgjcc5
49374	payment	2133	2133	1874	1	1	7748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8KqZKCHiDcoeiFptLn8cgDHsE7kSmheze1dXvTnqZ9YikpVN
49296	payment	2133	2133	1874	1	1	7725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cSW6E2AdXx9ARw6xE3hk9Xs3wEi8tg6q1ogoJaorFmZozSQ4
49297	payment	2133	2133	1874	1	1	7726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8XfwyWJX5F7JX6gdW22a4jbZm2XXmeLoNmG9anQ9aaiifFWe
49298	payment	2133	2133	1874	1	1	7727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeQ2egj5CrgdWe41FzY9rP2eRGFNthVLFxSWLrLk9xP8t5Kii
49299	payment	2133	2133	1874	1	1	7728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3UNHVexRB2SMQjTWjWNpp6UzgZTuRd1s7ZQ2geSfxiNvn3H5
49300	payment	2133	2133	1874	1	1	7729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aa3X7HSB8u36LtkNJAWiSL4LwvAVFBMAptAxMM4cQErDKa8K
49380	payment	1397	1397	1678	1	1	18083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegDJgYh78ukfk7PDiSjBN1BPcP3XCpkgrM9SSMWZeQpHSu6GK
49381	payment	2132	2132	1874	1	1	2086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ek5pEgHQZEHWA5QLpFkCL1doPFxpyPudrB2tdtxN2uHa2UZ7
49382	payment	1693	1693	402	1	1	1410	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZPo4i9g1zgUnFnXCLATSPFqPVRpQ7PKBFdKPyGAhMwytK5iTGR
49383	payment	1693	1693	275	1	1	1411	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZKe4gz75pZJFc1CosmCvXiyuJwpZG1Rodw5BfA5bELmiFhGexB
49384	payment	2132	2132	1874	1	1	2087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsRz6m69nAaJWwpHVvqYGDYUtYhJp93yBbUk8JV2GKirYXXJ3
49385	payment	1693	1693	452	1	1	1412	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZtDdTG9vR6mAbK5oR1Tj9ufmdu9fDvJTY8W11A8qTqo4ne5zrD
49386	payment	1693	1693	458	1	1	1413	86283410386	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZcvUafJeYDVxQqiZYpWRmE11h6eNitsUeXB97LrGTenmqb2qtU
49387	payment	1693	1693	690	1	1	1414	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFCZS7Qrjuaz7FBg69tP8JKKrjespqufrtCM8eht3rzjRpXVp4
49388	payment	2134	2134	1874	1	1	8270	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKWzoHYGkpMVA4favDjNyFLvxNJqASBT4ax5YHAZiJHH9DWMW
49389	payment	2134	2134	1874	1	1	8271	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb55JrNak6xHzaMRN7DzwNMkiGWRJXpfrBfjXMVJXkySST2xJd
49390	payment	2133	2133	1874	1	1	7749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQoXERUJDD8CwzFsog8hS2me3nF8voD4Y7PsFxoY9tYj82dNE
49391	payment	2133	2133	1874	1	1	7750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EBo7uhPmQihPeYJx5gKUPD9EvbVwZrnK9GeVAJ22ApCyxGGB
49480	payment	1397	1397	1678	1	1	18091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCNUYLxCmSj3u7G3o4SfaHZWAeQzV87DaU7YTwwLYENVXMZuE
49481	payment	1397	1397	1678	1	1	18092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVj2NbLtWSabzw9BEuqdm2PZFsFimFUc2B3E3f8P7myKmH6XQj
49482	payment	2132	2132	1874	1	1	2098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCpfm5DesKgLSpHP2JqoVgWcfybFa7gWgfUiVGDQjACrEPEnu
49483	payment	2132	2132	1874	1	1	2099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNG6r2tZKcuvxLArzfcHc1dw63BTWNPkEwve7QGi2yxSUAme1
49484	payment	2132	2132	1874	1	1	2100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffzPUG1KMDRrmLjcNfxfgXh8zr7A9zRbMiYvpJqp1L3YoBMyD
49485	payment	2134	2134	1874	1	1	8295	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxfUsbDcXzbu8wcZzenNGY4ofkToPrwMbcHLRB8ivrTaSrB7N
49486	payment	2134	2134	1874	1	1	8296	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUz2YE4PCfBd51vxBeaQmgRmZCHFgegyjGXqHimbwL2Soad7Lj
49487	payment	2134	2134	1874	1	1	8297	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5EaCfna3yDb5pboEYchJk93sBJbesaPCXZ8spXH6WUx8tvZg
49488	payment	2134	2134	1874	1	1	8298	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFygGKa3Kfb75LvCndx9ZCLQ1fBd5pi858f4UFctSVoBUNa5t
49489	payment	2134	2134	1874	1	1	8299	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bQsQxV16RrRbYAkhHW6sSCZf6uq1GFYu89pWsTRafL5k7Vcz
49490	payment	2134	2134	1874	1	1	8300	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx8Mhck91qsPboodYvmjvTsRqSZ1f9KQSvEj28cEQGke7i2Mq
49491	payment	2134	2134	1874	1	1	8301	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtP4bt9JAq7jWa3uGMU9xGuyYNeKKZ6UA6ZEk95XznMQkhbLNk
49492	payment	1693	1693	578	1	1	1443	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa6BGRRsozAemQJAMULrNdY1H2TXDCApSfr9wyE3UVwRt9qqbin
49493	payment	2133	2133	1874	1	1	7771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC2Gqr32KyqkaiXkgfjhhmRFsDMU2e5yoG2MjHuRuDveQvpJU
49494	payment	2133	2133	1874	1	1	7772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuwbQ1VAUSu3tPkKsztGJf6P1pNHNa9u1zH1hNszo7foC5zmu
49495	payment	2133	2133	1874	1	1	7773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZud7LE2x29qn8pJ4UZ7uKiJoZpZS5bnzVMynfWmdZZd8SfMAnn
49496	payment	2133	2133	1874	1	1	7774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqQ14oJqAySDvUmkkKu37tuXU5ArKBxZmzjsbDnwP7fFSQDoX
49497	payment	2133	2133	1874	1	1	7775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rmtj7YW2VKWhX7V5rChBGKPa2eBnJ3p8XPREghgbone4o9rY
49498	payment	1693	1693	649	1	1	1444	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaEqh7UHokvjnSTGoyXaJ6gfLsMRfdXna4PwcDnqs7LcMGv4U5J
49499	payment	1693	1693	114	1	1	1445	86283867930	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkFLePqngDkNTGSbbxLkkBKti4Rxz48B9RqCB5mxmpJaRBs3gx
49500	payment	1693	1693	443	1	1	1446	86280793223	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa37dZuRnTVg5BPx6S1yX8j4JtTiJ32gXu7iyk6KeaBTsvw8s7q
49303	payment	2133	2133	1874	1	1	7730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWWzWGQvjnfEKNuotfpoNx6MviyYQiEh9P5PGXL6mfC8yjrUE
49304	payment	2133	2133	1874	1	1	7731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4kk9NTANnMPMpc48Upj3rB9ZDp3HSUWjEGVoRWP8juoSpE7X
49305	payment	2134	2134	1874	1	1	8253	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmMZLAetgndJwMEqJCjVAC1NhwJdfkz56sDNhU4FLq4yTCTP4
49306	payment	2134	2134	1874	1	1	8254	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB9UeceApyFMcKNNcXiDkoPyffoEsBe4gW1JgEgj9J4uW9Gga
49307	payment	2134	2134	1874	1	1	8255	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLS3n26eXiTJQZ4WNtyRdnMSaGnhD8Z9yekWhFsDqfj1z9coi
49308	payment	2133	2133	1874	1	1	7732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufWr7k6wah2h1ZKpizn27azrfWCNWHUaDGC2nCTTzmvqpS9FG
49312	payment	2133	2133	1874	1	1	7733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDo46Xpowza52EqewnBkWbwkrUo2FTbu9SYgaCy4y7HcaZUxF
49313	payment	2133	2133	1874	1	1	7734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjPKtVW1z9XtaTAS3dq5zXikxgF78Di8nJ4TvSEePyZoSciVf
49314	payment	2133	2133	1874	1	1	7735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrqKhnKBtcVC7e9VYkJ7oQFPU55FRv2HDsBr1svTBu7vmPbF6
49315	payment	2134	2134	1874	1	1	8256	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWNMqn9EEpNN9aKrBgNCE9QEKAfNQm4Th3opMVETjzV2nkBwo
49316	payment	2134	2134	1874	1	1	8257	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KRQgEFjVp9autsWvQLDcewXuFDCNfGiFy79DyD8WitHCooC3
49341	payment	1397	1397	1678	1	1	18081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnSt6ecDvjDG6jyRzj6BBtivFq8hkoxbgrDz2QQse641L5can
49342	payment	1693	1693	120	1	1	1393	86281462545	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYq5nUdC9hb4rBfpQ2Mp8ywxLKqnKdBACZu13wVoS1rCJ3X2cxH
49343	payment	1693	1693	320	1	1	1394	86281433556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYoTdHtyXBmHSNSMqgYGpNqknoKna2WuwhHmAVeayDJwb9GzQYu
49344	payment	1693	1693	354	1	1	1395	86283410386	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYZk9jYQsTAMmdeGStSxQx6UiUueexx7ZP52EwZQMaD8vsvY3YM
49345	payment	1693	1693	663	1	1	1396	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZCHixYAw2BxB8pPcsfrLHfopMtXU6EKBac3NPAYuZGvvufbUr7
49346	payment	1693	1693	710	1	1	1397	6564321195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYvmikcysDJnYLdx16zv6YszmzmVpHZeL5v4wWBoFzX8Ed8rmws
49347	payment	1693	1693	499	1	1	1398	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYwoG2pV9JiUQ13vYUX1ZcQWi2tx37Pim2HDPJD4jXjVFuor2Jc
49348	payment	2132	2132	1874	1	1	2082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWm2QwEW4etR4T74kc5c58CaGYr4T4weZGEy2BmVGJqvhFTGZ
49349	payment	2134	2134	1874	1	1	8262	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7cUyJG63AGnDZuWA2v5DvKZPB68d4C7schou4rGikeV5vke3
49350	payment	2133	2133	1874	1	1	7741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiejRHPcRPea93Nm68sk9UksxR9iAg1rXoZtdud8RKdAKsfpV
49351	payment	2133	2133	1874	1	1	7742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8D7nqDy9UVjXgQCx7tHnYEh7eAnQ4dtbsHQVzQMkNRpG8Kbo
49352	payment	2133	2133	1874	1	1	7743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFfJJBV4tvBiKAh3KS1nA7CLspW1Jacgpd4RMwtj2PEdPcdi3
49353	payment	2134	2134	1874	1	1	8263	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7siCWib9oTKP973CiwPwVvUh6RuF51zoH3tBVDajz6j7RtUQA
49354	payment	2134	2134	1874	1	1	8264	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75FWjxPJhCG8avmukYS4JWwDdfaHCkTDbZyimzeFNPPDMPnwy
49424	payment	1397	1397	1678	1	1	18087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnUUBTgyeAr5kN4t27Yz5YKvyEzXrkHpzF6ZrtukLGmTeCkXN
49425	payment	1397	1397	1678	1	1	18088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzA17Rt3sHgkms32tRuaK9mm7HmtMqrsbeFmcPuoywddNaLNg
49426	payment	2133	2133	1874	1	1	7759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMq6nbs7Ae3sEHAaWd9F5oJTxWM1DTDTeNAsrSeviTmUKWBUq
49427	payment	2134	2134	1874	1	1	8281	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumtEt1pDaToZVV9DeAG5brnFY8rdPbwJ9VpEtr2Pks37HiwuA
49428	payment	2134	2134	1874	1	1	8282	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnimp4yrofaXW628pGUBY5kXBX6veNj9dS6tY55qpp7FLcQtGF
49429	payment	2134	2134	1874	1	1	8283	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54DHAjyKoPEUJLQLshVnrekixPh1ez8WxTvJ4hXSakYLd1yiZ
49430	payment	2133	2133	1874	1	1	7760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LBoBaWEpoGk1cvyAfFhoc4qvRdy9Wp7DvqnRvPSe7ZKsxdzr
49431	payment	2133	2133	1874	1	1	7761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QtoQTFCrMhPuVhWaucns8s38tf1BpGPae3Zb7gnQ8ePRcZDs
49432	payment	2133	2133	1874	1	1	7762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBpvJ6ATs6aAniHdhjPRyQ6TkrYoTqQxouuFhBTx8cUBvcaa2
49433	payment	2133	2133	1874	1	1	7763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwNAM8vzU1eH6AUNuRsRfeoUf1AWF3U7MRxD3Qe19g9FhUTJZ
49434	payment	2133	2133	1874	1	1	7764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCiBd5nrk5Eib94bfMg93XcmVH1Pzrb6eofwLfqQJfy1JBacq
49435	payment	2132	2132	1874	1	1	2092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVV7w2kZVuVeuSj14NzNBbYs7Hnm8W8VZgT8DxfV2H6us36rY
49436	payment	2134	2134	1874	1	1	8284	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosCXgYewxetUEnj4AVtzs2yBsf1EX1KpbMMjtRsMawr96iWDn
49325	payment	1693	1693	312	1	1	1389	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDKEVNSDm1heZq2anZ9mgjPwP4UAN5bi2SPjd9BheixmS5Qsjm
49326	payment	1693	1693	1772	1	1	1390	622444916156	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDT5aVADriX412TgzPS2bQ4DXjC7AnGPB9BGcJx3MaTUNmufTk
49327	payment	1693	1693	1030	1	1	1391	1183351888512	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrEDjx5wsdXdAtJqQtcSg4oyHRRxs6zYLtkUs5dmq6hQSMhpUG
49328	payment	1693	1693	238	1	1	1392	86280495155	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYsA8dNDpH1gHqB77ydb42L7jqxoeDCDdpbwH34o8GLv6RNqceZ
49329	payment	2132	2132	1874	1	1	2079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNp7XB6ggXRMHmxcpFbM2kr2oVYaGGnR9pqbH5r3Jgt9ZN1vF
49330	payment	2132	2132	1874	1	1	2080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLCommPQGuqkSxbKMDjeaufM4JvTyVVuAphTnFWJR8TWLTe5J
49331	payment	2132	2132	1874	1	1	2081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuzSXoRDTmZ7vKduUg2owJe1dx8a15CjrjHF42xmrEEMzZvNa
49332	payment	2134	2134	1874	1	1	8258	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQH6XwYVYiPPK2VbtjfiGLbGZfAyUgVFdwGTKEtD2Ezxqfvwg
49333	payment	2134	2134	1874	1	1	8259	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiSS6Qhj7S2KeCv3fhpvoqLGwk8XUoqUoSzqrCabm31mu7sRv
49334	payment	2134	2134	1874	1	1	8260	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZdartyg6p6JUspNwHJD19eZDFxeZ4RgA6R7ShABZFByNNvtX
49335	payment	2134	2134	1874	1	1	8261	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi92kBmKMusz8AC5jx67dHdH4JthP5gguWRigXDkUhV2bxu63L
49336	payment	2133	2133	1874	1	1	7736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLaavWC9GvNrgZyo1ebg5TVGYnhHVZrX3bPSXK8t28MDsDMYq
49337	payment	2133	2133	1874	1	1	7737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPRhY6XSbKP81jhQF44yt3txUgr78oDhvAzZcVpcrCuumdcrV
49338	payment	2133	2133	1874	1	1	7738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNeBKCqUoDwNgbKB1EMHwhhzWKMWuqxzKTBABsxbL75YDC9hz
49339	payment	2133	2133	1874	1	1	7739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmb7MUckZ8w2wrnN7Ve1k5BYx7YtGeVqKmVSNthgXfyYyH6UR
49340	payment	2133	2133	1874	1	1	7740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mwLvzSTVRpsoLUxCdhNFwYvAXHttoL2ziJt5DKLTgoBPTEkb
49405	payment	1397	1397	1678	1	1	18085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNSBQuh48KsENfUowsg2ztLimPAHacuwGTqGzSsZZYkNdg3xG
49406	payment	1397	1397	1678	1	1	18086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGe8tUhCX3SxcFAwoKTAHz1UACQxeeDjtsXK6ynUXLP2Ze4cPu
49407	payment	2132	2132	1874	1	1	2089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYK5iuTQBhyXjGTDjwr9fwgJ5CYwBencctyQNerfLuNU37uUmH
49408	payment	2133	2133	1874	1	1	7754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL2Lu1bKmJt6mvmfNAKbys6iHDXXE1SDvjTSg539VEUoM3bzj
49409	payment	1693	1693	322	1	1	1421	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZBzqbaVwMJXWGzext2fr8dLH563pksidSzwGDMSLRSigDvthxw
49410	payment	1693	1693	10	1	1	1422	42563620739	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxkf4GY3Lkh3nDgmJK62mib8jkVid6Mrv4rvJMRJUbqFkf1NM1
49411	payment	2132	2132	1874	1	1	2090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgD7o7zjxPWmC6oMqX9uVj6tT8bJb37AcaNHVof1sywh2poKt
49412	payment	2134	2134	1874	1	1	8274	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4BQmSVzksQk1k2eb2F4iGcCadNcYBvccN8TFZNwVrvuKuVf7
49413	payment	2134	2134	1874	1	1	8275	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXnGUMvmb77Yt2hAHNyffzwaYxJR7ZKQWvVQvGRQuLATvYLgs
49414	payment	2133	2133	1874	1	1	7755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FTvAHAyqZ62H8rAtkCFDc1EjppxAXhpSqX4DumJX28QL3Mnq
49415	payment	2133	2133	1874	1	1	7756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcScfKPWHrt5kGuYPsxFXHVem5qZcYtGGGuLYZ5MM5FkU4s9wM
49416	payment	2132	2132	1874	1	1	2091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa815PWZ1MTfAcTnoBGuzbBgdq9dA14dyko9jEobP3anmbRdkZN
49417	payment	2134	2134	1874	1	1	8276	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvt1vLx1M93Liut6Ye5KQc52CskDvDJ4g7BdQQFGdW7LNSryK
49418	payment	2134	2134	1874	1	1	8277	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdtGp4gJXmnazSEwLV9GRDbDu5ndZebbQ87ty6Tssmn6EAbFx
49419	payment	2134	2134	1874	1	1	8278	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJymW6dnY56Z2e4mVfihc2njoAPnjzF9U9fF3zmfYWvRz3f1T
49420	payment	2134	2134	1874	1	1	8279	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9YzNDSrEV3mxBQjGLhFaJ1BFXTU7AETmy1mpvtekLfWYWh6F
49421	payment	2134	2134	1874	1	1	8280	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSf6oaYxUTUi1zE9SiY1yXNNP3qXnrUZXrFUct2xgy3MvHnKYS
49422	payment	2133	2133	1874	1	1	7757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZebNShN9QukFFStPJPWn1qfPFZEXvpMECESZfv1JVyrinTS1
49423	payment	2133	2133	1874	1	1	7758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ne4NdF1jFsT7LW3NeWGvWdtf5uKYLGck6MJ1n2HmmJJRjdLM
49522	payment	2132	2132	1874	1	1	2102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bqpPn5jVxTtVV9EsXtCRRMadybhpzjVvt1GhDHgR6JsL6r91
49375	payment	1693	1693	534	1	1	1405	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaAr9EM5fUEn75XUHvx8yAUNQY2xgaAwsy8YoSyWiRF6uhB3Whj
49376	payment	1693	1693	327	1	1	1406	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK51iYFo4MbSHMtX6z596ku75cGnFatuYf3hPegC7wXJT3EuUq
49377	payment	1693	1693	652	1	1	1407	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYsvT2r8yEe5pEwBRpbeCZ384eg9gkxCwNXYDF53zjiQie2mnjg
49378	payment	1693	1693	391	1	1	1408	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaGvRUj67iNZTm2UScTwmFJaXYpnhziUXZg9h4LPDr1FbBVFfyy
49379	payment	1693	1693	2181	1	1	1409	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK3kktAUTzwpofLDnVUX3u5gtDn9215n6pAEvCWTCFZV3vhP6G
49392	payment	1397	1397	1678	1	1	18084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEEUmBajP7kSzkLZ6BDcf21DytT9iymNZnag8eob6dJ5XRAbb
49393	payment	1693	1693	309	1	1	1415	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYT1Tdb3dRtYNEmJzj7mJzUq8FYwAWXwNgQka4Lfx5XP15NXY5y
49394	payment	2134	2134	1874	1	1	8272	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgTjMGwvpdHJcknKLpMW2zThpsfYtjMAVkFcT1F64nX6akZSK
49395	payment	2134	2134	1874	1	1	8273	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76RKu1LPJDbe5aMSKoQUax4saD9yq5WfitSS291PYSDJHcD2y
49396	payment	2132	2132	1874	1	1	2088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W3vYPkPLMuGoo3tA2brZXMfcPK6dpGRpC9h9jLY76fJzdoW8
49397	payment	2133	2133	1874	1	1	7751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7p9aU4XZRVpHhPpTzAduauHxzqyKeQP6Rp7PkFYzfVDSpX5Az
49398	payment	2133	2133	1874	1	1	7752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBo87PvdQtysKUf1MEfRmHrrCCnoFnhBjeA4TrukLuukUviQUS
49399	payment	2133	2133	1874	1	1	7753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57JvFjBstLLkueF1gnXfQp6c7kGX63sbBQop55Hw8ucGSuDX8
49400	payment	1693	1693	82	1	1	1416	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFH78a7NSrhaE5LDhaoznKyofNS5KfwJADEgi6EsynWotcrhLy
49401	payment	1693	1693	361	1	1	1417	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZgVr12MoKuXk7CXsmxz1Gs8pz3x5tqCVpRkZWSWq5BZ7fk7RNQ
49402	payment	1693	1693	680	1	1	1418	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaA2XnspuMU1BLM2gUuNQaDYGsyTdu6JKDfbYe2kC1HAMuBtFaU
49403	payment	1693	1693	731	1	1	1419	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZqhQZUrN94bbngU6th5cTqpeVu41ATvMKhr96Mrpj18mGfqt1B
49404	payment	1693	1693	366	1	1	1420	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYeyQ1Sn8p8Kq18zNZAyaGLdj2tJqHEJkyuykTTDgtFLwG1Z6tP
49508	payment	1397	1397	1678	1	1	18093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoUe77Hueh4ZNPpBiSwsu3qbMxeo56fe5vFVjfPMfWbgnpLqt
49509	payment	2133	2133	1874	1	1	7776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcEGTVET4UvWc7eynTM8LGrJpeJQNysVGF66GdxWg2dzdcGK2
49510	payment	2133	2133	1874	1	1	7777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDryxK54dwpDbfoNz2qewXLsXg49W6rUVES5pvun3TJXghtm4H
49511	payment	1693	1693	611	1	1	1454	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK5q29FsFDgkczUgMNaj8uonh89fPUcgHtDMXunTutrxfFg6iW
49512	payment	2134	2134	1874	1	1	8302	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLarL7W8HSXiXp9yf2162DSoPRfVPdhMhbEuuvHv6shm3E2gSi
49513	payment	2134	2134	1874	1	1	8303	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZiB7o1BJbgCeNfeTno7VzZqxJfqKzDN9y79vVNnyteuYWC6t
49514	payment	2134	2134	1874	1	1	8304	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqeu3Jdu1supM8t8i7pg5Eujuc5Sx7kjhgP4mKBdc5XUKbENm
49515	payment	2134	2134	1874	1	1	8305	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWgY2FpA6zdSAQwN3eYU3KtjT6FRwkGExgNVC8yFUsVRPaFjr
49516	payment	1693	1693	252	1	1	1455	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkwk6mZ5H5rmvzaF9GWZKJVTxVP17MbuFt3beebPSXXJjA1mvs
49517	payment	1693	1693	108	1	1	1456	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxrxZXtsMwdUsJiUCxmptomtHcvqTazkWJVBMgzVoiMmG15UcU
49518	payment	1693	1693	1778	1	1	1457	2614765358	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZSanEShkK8F8q8hjF9xd1Nrgg22yxTDG2mrMeh73dDhjazwvLv
49519	payment	1693	1693	99	1	1	1458	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZQVRzRm6uee7z9MWyV8dZKZsJLtBZBmW8xWuUz19BGZUYqyire
49520	payment	1693	1693	35	1	1	1459	25206993399	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkSNN63jZLXKS1xwFd4C3NBuNZ4EHo8GRZDjArnEzbZtkQCuy4
49521	payment	2132	2132	1874	1	1	2101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PJAkEoLiVUoUgWK26jNtcBRE5KkUFEDgNtgyZEP7UWA77xaw
49437	payment	2134	2134	1874	1	1	8285	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuP7BsBx2A6P5or5hTirj7DVcw53bRNiAHbe9mXWyU9rP6w4m
49438	payment	2134	2134	1874	1	1	8286	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8XQ4Yy3owYzrwEcsPKJXAVGd1kVdSbmrRNHK1YutpFTYe6A6
49439	payment	1693	1693	450	1	1	1423	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZqVm26YW9GkpWsiNET5nyCwCGUnEkiehZzn984fd9P6aFgrjFP
49440	payment	1693	1693	601	1	1	1424	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ8SffqVkZZXwwiCa7MnWQ5B85ansraSonFNn25ERdwZ46cVY7w
49441	payment	1693	1693	408	1	1	1425	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZFeUMzebWQmzjdkfneohs8fF867V5pvyJsDjh7xEWARvQS5Hp7
49442	payment	2132	2132	1874	1	1	2093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jimXVRY8R9dpbw8iVpEMtMWde12JUPa639648R9HuJgmLAHy
49443	payment	2132	2132	1874	1	1	2094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXadLBzv7hi6MAtxv6PWSFKZR2myfUe62wBBUeZFsdMrEXpnK
49444	payment	1693	1693	1821	1	1	1426	86843768235	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaCc79PtdRNfgYCPosGNVUfzBGhY6U5msBBW8sWFhmyshMC5dGd
49445	payment	1693	1693	301	1	1	1427	86280926556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZFhEMaKZxPsquwpoChsvswZ7g2iPyRL6wDsFsRoqQbxH3XZUc2
49446	payment	1693	1693	339	1	1	1428	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFWZ7d96vVvJnKcqQbJ9YXcNJncM967sqMoGuLNvj7ZViQE5Wi
49447	payment	1693	1693	186	1	1	1429	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZg5SSWVnHzv9p8hBTEcZZ1JVy3QKxvWPvnbkZCvTtKdC1UwqiK
49448	payment	1693	1693	392	1	1	1430	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYUfwPC6tY2z16nToZtZfF8C91BHxmJFobgLpXjE3YnGY1fqpDj
49449	payment	1397	1397	1678	1	1	18089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9yXJNGRsBHHj754d5259Z826JGS7D2diEKvc41sHgwfJGAoc
49450	payment	1397	1397	1678	1	1	18090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgu1uxSL58si8TPiy2Xup4pBrkaFrTrvaJhDcRwVc5yMFNvHR
49451	payment	2132	2132	1874	1	1	2095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdR5i1puS3NH1AekdpK4kPD5i61VNntPZ9bqQZCQ8FehqcW9VZ
49452	payment	2132	2132	1874	1	1	2096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYo8PUumpqa3ZEZnanEDFPA2hQiupFdssHMcaiyAGYcyyGQ7K
49453	payment	2134	2134	1874	1	1	8287	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQFkwVSeTjpR3dXEYMZDCuVsbzbj2e1FbFMsEK7obmMvGxL7k
49454	payment	2132	2132	1874	1	1	2097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUuoG6BCXhMEjA4NbJ5CpYu6EmYJK3JtKWWjLFXRdQjGCvPXx
49455	payment	2134	2134	1874	1	1	8288	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1iHsy6D3dkh8NxzEqwexknCnFEGcRmEfZx2GQpmsN5N1yDvA
49456	payment	2134	2134	1874	1	1	8289	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkX9PPsAaxpTPrSedHGbj4N49YM7vm4dY2oKDxYsVvyLHLJQFr
49457	payment	2134	2134	1874	1	1	8290	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjsD1rApCLxTr3pScbXhGEDivCkfiFXXT7deibkFbxDwTN65j
49458	payment	2134	2134	1874	1	1	8291	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM4rDmck6MkLtpYTPWaJ2VD9f37FQQkcWKhQ64Xz6vmHjeMCp
49459	payment	2133	2133	1874	1	1	7765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoRXeiLsgnG3fGVrwTYQZ2WRwvkTi1PuUCpyESfmgfmaMLh6w
49460	payment	2134	2134	1874	1	1	8292	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcTGcMjdYfh2knqfQp6wuFBh9A6BzyT8Lqzi21hqJqcz1Hh14
49461	payment	2134	2134	1874	1	1	8293	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV83HnMDNSNveubb8sT9fnv5iZxm1KZUtVpW5iJUzZw27FSQYf
49462	payment	2134	2134	1874	1	1	8294	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMZnZE1jbq3nkz3tHJJBoAMozUgKZwR453TaAqdGkkVNEwzmZ
49463	payment	1693	1693	283	1	1	1431	86280926556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa2JecXqn4o9New3sg7bJSkwbQFwoJJMzGGEtRDbWm4G5iTdQNP
49464	payment	1693	1693	308	1	1	1432	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZXjMoWbQTSKTQR43NhqpiE7vm9CSvS7mjTYH91HdPdSfbXTEpg
49465	payment	1693	1693	2017	1	1	1433	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYzpGb9zdcVoGZ4dB7QpMPZLVp2bbnphSoaW5wyqeL9M2JjNMkx
49466	payment	1693	1693	105	1	1	1434	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ26BnxpxKNvynYBsF61X2MGMkLiNHnoovBCfB21LEiTuKcygvK
49467	payment	1693	1693	399	1	1	1435	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ3ZJVdFfkU6BSLDytyfMPUL94nrKYcfdFwdAYeC6GXtdFs8yKd
49468	payment	1693	1693	636	1	1	1436	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYfVdjtL3JsdTLyZ7az6kwzkf15QTcpyrRUjzCvw2X6Zhf6d2F8
49469	payment	1693	1693	721	1	1	1437	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDcukTKSonRUhhS1GrCss9KCVf1ojyJ9Bn1hTvmiK5a9bq8DqP
49470	payment	2133	2133	1874	1	1	7766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kPJ7gRZi4Gy7ncfmmYMZx6UcdkQRZWoTQ5mn32FRzTZjLrZ9
49471	payment	2133	2133	1874	1	1	7767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYqKT3JtEdm9DZKs5S1YjSw1eQDa23umTPtoc6Xjttez6CHDx
49472	payment	2133	2133	1874	1	1	7768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pjw3uzWcbutKnKuc3JusWjoRBwVB4o9Qhpeg1TXiDahGvtPa
49473	payment	1693	1693	206	1	1	1438	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaBL6DtZAZp2vPFvAn2mLCq8qdM9qv5ZTj7o1Loez24NWVcrKKw
49474	payment	1693	1693	194	1	1	1439	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa6accG5DkRvLbLr9uBCgJsZWaom6rqnAFV2UJxkbj9XRbP6Erc
49475	payment	2133	2133	1874	1	1	7769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDH8a1QPmWuSTeY2YkNVnHb4VesYTcf3g1D32xdP6L4iY9HYcK
49476	payment	2133	2133	1874	1	1	7770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTRGeNRawLF1QToEHnnQqZNgsDVrGSP6TQGUHGbUWzjdBELNB
49477	payment	1693	1693	1276	1	1	1440	2224899250272	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaG9jpWoR75VqcRKz2298LyZ8Yik2dBJ2QynSnvtwfsSYFkoCbm
49478	payment	1693	1693	504	1	1	1441	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaB5RDV1FtumicHY3HZkQ74DvkLrNbpZMCZqcQsxYNRd2TmVZCS
49479	payment	1693	1693	205	1	1	1442	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaAjvDQtpfSnxHsVZu8c3UoY9NA9P3bpxcUehSBPK3jpTVVUAho
49501	payment	1693	1693	138	1	1	1447	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYT7ZQRNcR5jdPqpyBgmhg2gexbz78ub3wzFuMLVGcHbZhbcqxn
49502	payment	1693	1693	500	1	1	1448	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZJddhcoiTzbpLucQEsf7roWtv33FG6gJpHQV26Eg8giwLpQCgr
49503	payment	1693	1693	587	1	1	1449	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYa9n6BbvRCUP4zTCX5XRXGTvNq4NZG3b9g9qSJuxkRx66pcNjW
49504	payment	1693	1693	146	1	1	1450	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZCcJ13qKgjY7H6y7sjiYRFHwHAaM5NWpBN1qQGyg7wh3aGVHXy
49505	payment	1693	1693	225	1	1	1451	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZMwq1Y3hdspk5NXDD1j3Y7vUKpdn3EXxaxFSDWeEYXH3rGeRdE
49506	payment	1693	1693	377	1	1	1452	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa7TUNzKL52zo1XtUJGCmvqo95VvixQ1nRgyYuMdhkq3ngwniNr
49507	payment	1693	1693	560	1	1	1453	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkW9hnHqUtBTb1Cbv7b1e58nXeFwzL8uzz79tHn9R5q4sxJGgQ
49523	payment	1397	1397	1678	1	1	18094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiepGCnyCbAgEVmP9zrHgu69RL3JR9Dq5V5AwRSAoMRZmh5bs
49524	payment	1397	1397	1678	1	1	18095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorShMCneJ6XfExG1HTGBTXPfRHdvMzAcyWLVJ1vM1C68uwg3e
49525	payment	2133	2133	1874	1	1	7778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaJfCysCMsnShyu9VE2wfeUjEZPHp9Gnkb5DJEAK95bJpTW7Q
49526	payment	1693	1693	49	1	1	1460	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZKxCRxnnyppyYXJhMWz4VsZnr8DKuiFPqnac1RKSBK7y9gwne1
49527	payment	1693	1693	603	1	1	1461	87222845832	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYoxyTtvMUG4vtuVHfZXJDwH3u5f9ToGdFYqesRp5F3kmiHak9J
49528	payment	2132	2132	1874	1	1	2103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TFdbc1vsaJrvAas17ARn7ZAxEMGha7BWc6HjG5jn3GWw25vi
49529	payment	2132	2132	1874	1	1	2104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkzJ8Upfy3figKgEWpKgW4f2hkfrtqeYWsUJJd4BfXK6B8cFM
49530	payment	2132	2132	1874	1	1	2105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY8sEdXMrFMkjKniDamVgn3cMqDhKSzBrhafPHz4d8wxvbidn
49531	payment	2134	2134	1874	1	1	8306	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59ot662gwTrhxvvCTjqiDUQiw6eQRvS6EK6Ajj5CtfZmqsPAq
49532	payment	2134	2134	1874	1	1	8307	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVQcAP9N9BJfVVAhne6pskEUx1o8wKp9pvu2GQmH1qnFFhrpE
49533	payment	2134	2134	1874	1	1	8308	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEqygxUx1ZB2fV6aymDxwwqD381h6CzqPvC4VTKcSUZks8Hi8
49534	payment	2134	2134	1874	1	1	8309	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePBrEZVSxZoz7fC5Kf4HWrrqLU8nq1cDXkfY5M2k9u12KjcoC
49535	payment	2133	2133	1874	1	1	7779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa62oaRhBPRoLjKZ1uBaLz47f7z5uajfed8rydcpjjdBEtqnLFS
49536	payment	2133	2133	1874	1	1	7780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Bc3JVq7Hs37qFTTtAoH52H5faJnvxa89rqYm2GpNJoZY47r
49537	payment	1693	1693	54	1	1	1462	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaHDR6pikKZeWKK1Svu25s96n1c7vrwFviZUVZH7no6hXH1REAb
49538	payment	2133	2133	1874	1	1	7781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgVa9Yitw4fDp4iwppUqwc4teUbe6M9xw8HRHUqJdz7SaFDBk
49539	payment	2133	2133	1874	1	1	7782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABN4TRL2YLarnp2hV6DL96sAwEYfyE31XAGybV7L59WFykBJn
49540	payment	2133	2133	1874	1	1	7783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQu1RbdzsR2sYzeBrZ7WjeqsUBTPUHpiUabzMRTSdeETVBMR9X
49541	payment	1397	1397	1678	1	1	18096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdynLXeU1xXgoK9A73tDrdZjH67Wr7SqUzMzQBFaFeACeBXbZ
49542	payment	2132	2132	1874	1	1	2106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ455RKLEydXvN19hhFGmEqNdrbCrbmVCzUhGUPaYAFXX2TMSsk
49543	payment	1693	1693	530	1	1	1463	86280415414	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZQPRNPy9bZ3GBHdP13r4az3DkHqRfrDF7YVaT7AA7bYqe7tT97
49544	payment	1693	1693	217	1	1	1464	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZeG5aSuZiWzXBqoB2kDsfE84KwBYU4zryweCx5J92C6HGUgEKs
49545	payment	1693	1693	103	1	1	1465	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZE8trEPPfQViYvuRU2bcFY6pASKQrUqcsxacE4xxCmyXzv7FZ8
49546	payment	1693	1693	893	1	1	1466	402816835368	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ4SDE2U3ZFFhFX9KnUomhGTMXLa6zai4Dv7UimL2W5bVyWCGJn
49547	payment	1693	1693	620	1	1	1467	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZWJexAJtaNXHwYozsgscFsn38rPZnJ9rCbM2jLy1psZ2EYTKiA
49548	payment	2133	2133	1874	1	1	7784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT2EWSDXZVSPj1fGTQQzqsT2mJqMxxpHbCD7RNMNcBdtisCU3
49549	payment	2133	2133	1874	1	1	7785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HEfSHPTZmSGuH795y2vssNhosFyaNUfCCj3yK152GAUZTpFF
49550	payment	2134	2134	1874	1	1	8310	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoNvwUPouwyrUaUKJdrtrxL8MvAUawpb3LVCyW1Gu5vNYZLsc
49551	payment	2134	2134	1874	1	1	8311	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmtJ2V32uuJy96axPYLngbaa5662Tr3nsPTPjv9ExysvSgWx8
49552	payment	2134	2134	1874	1	1	8312	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4BPJ36mmfMPJ1Jn4doVWXW6YhoVESc9VqPrhM7Wm98jorp6F
49553	payment	1397	1397	1678	1	1	18097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jYmyMwwqkGPwqz3eHMC3qhGHXABzhJ2Luz4cj1rfzXy5dexX
49554	payment	1397	1397	1678	1	1	18098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL78bT1nmoeAKw3ktoSzDX4nk2yAWLiEafrS5vun8QQA66zyqL
49555	payment	2133	2133	1874	1	1	7786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9PYuMtfQxnrGCMNzkzuwfWNhksRgHqxdQ4LQKC5ZUbUJDXPK
49556	payment	2133	2133	1874	1	1	7787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiAhkphX992pX4JRYCzqDAm8Vi9TkUB1vtLyZxmdSU9DZJcvH
49557	payment	2132	2132	1874	1	1	2107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANP1eSVX8HiVd5UTurdrwFyLvocNg8MNvW5ceEBWBNUqoLTCX
49558	payment	2133	2133	1874	1	1	7788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeHNsTDoSq3Lc7p3f9HDBgndtHVFVwxxWTucFzVmCu3JZ7ZaL
49559	payment	2133	2133	1874	1	1	7789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbs7C8K9iWaFcY1ANeH5SAwnEfXT7BYFzxJwn2Yy1NSFhNFvmY
49560	payment	2133	2133	1874	1	1	7790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsyT6FJBrdYVqBXY1zmuzxxTzvgYo7UFmVpPCjaZ7hN8B2n87
49561	payment	2133	2133	1874	1	1	7791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPjZUX6Uq2bdxzA8ia1pi6xs9vKStDVEKzC8TBoQMyPumcpC8
49562	payment	1693	1693	245	1	1	1468	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa4PDmjyBTtbmv7FQaUxu7CrqvyegzGbqLqMuiFB3eTE2kb16Ay
49563	payment	1693	1693	600	1	1	1469	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa733gpaMJUWoKBNeW5mGN9h1Zh2NLgH3Rw4bmdT1zQzfgAPepd
49564	payment	1693	1693	691	1	1	1470	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYRdjqES3rxQ3wDYv3Qw46QvEqpJWVEgBhXMNG9vNLmQxMBawhx
49565	payment	1693	1693	2164	1	1	1471	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZv7ut6M5QmFe4MTdFdy9skzNG7zntV8CEHNMKuCCA5ZVuAfxiH
49566	payment	1693	1693	165	1	1	1472	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZnfurXfspHkgNwrZ3B4pG7uq69N9Ai9SnGtonkukP7b23qa68B
49567	payment	1693	1693	180	1	1	1473	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYzEPspzgQyRhysc1gpLuCfUqHgT3SvdzSaBEsuqETsZYs3GDw9
49568	payment	1693	1693	237	1	1	1474	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZvFBfhL5V8gHA48TkqhekcjLxVxfwMSBWQtouqrNN7yP43KPFV
49569	payment	1693	1693	2073	1	1	1475	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYZBsWuTmDyyaPnAnRTSX5NfhDSfa9HYJVRxvuCKJoi7DsMLXjw
49570	payment	2132	2132	1874	1	1	2108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SanDfkfpeE2CikZeiL626DAm1DrSanVz5kPVVrQgWVceRJPp
49571	payment	2132	2132	1874	1	1	2109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QCnv34fwxX2Y82nP8SxmcfLJokYr8f17nGx6hBGcWi5MScT1
49572	payment	1693	1693	748	1	1	1476	2617678499	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaEvUxAMeUQtfbJmHTTXWji3j9etP4TCfGSKjmfd4V2GtkhemPr
49573	payment	1693	1693	163	1	1	1477	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYg7rYgh9emEDgWgNQx3QrzLpyc8NqQnbNKHG2AR4WJHwrHdLMi
49574	payment	1693	1693	201	1	1	1478	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkG1WQifk9rsqJ6cE7pYXX7b3CMqchZzX1PW5GgRmYzFY9FsvM
49575	payment	1693	1693	1962	1	1	1479	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYQX6V2CnmFVvm6VuMpii68o8nW5G1oZZCukMGR6Xm3myC9tBDC
49576	payment	2134	2134	1874	1	1	8313	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJuwii74C1jNzg2eYEo73nJ5AjL2tRtG3KAUgz639Qfcn9eG9E
49577	payment	2134	2134	1874	1	1	8314	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdZ5Z8WzgBnwHned2XkGUpWrkpC5Yywk5YWH3HMe37GZyoqeQ
49578	payment	2134	2134	1874	1	1	8315	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnK81GKBa65stcyzyvVp7tjNuFVYK1YHVK2oEDRmad38KorSjA
49579	payment	2134	2134	1874	1	1	8316	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmTcmi37n5c3FxEXzKHGPe2m5Mv2J6k9ojquVNWDo2gPQFs29
49580	payment	2134	2134	1874	1	1	8317	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uF8FuaxCHCpvvxWmv2K3jZMANDZ4bPwk9qmM4S2cj6UG6XFV
49581	payment	2134	2134	1874	1	1	8318	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7UYAgVfarkXLXv3XaUfLBLEfJND7cA9WCQ6ipW2UsjBBHPLB
49582	payment	1397	1397	1678	1	1	18099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7d9BVai9Cg6EyAbaTcaUGqmVHM4DwNQG3icMnQdqXDidCYT7v
49583	payment	2133	2133	1874	1	1	7792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXAL95wZXxJsUioJA6iAJARYRBtcKsD3rXSQX4DwLSCJneKSh
49584	payment	1693	1693	594	1	1	1480	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZbodpQyXe8ahTpa8ZJCpLQiDDo2P2LjTWcpaqeXXa3TnCkQ3Et
49585	payment	2132	2132	1874	1	1	2110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgY49SAUmJDnzjPXR6soN4io1Wnv5aLmaNYb66Fk7ocaZoVH1
49586	payment	1693	1693	63	1	1	1481	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkucgp5peMzYGARASzjNzjiN77tyKkQ6rw2grW3QdQeYYm2hR5
49587	payment	1693	1693	150	1	1	1482	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZg8GTWMctucVGsMJa5jb3y64BDNNiuXSKchA58sGnncor8KdVh
49588	payment	1693	1693	562	1	1	1483	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYdGPc2y6D2mwv4Qoz6dbfC2BfCj96VrE3cpveEBxoDkE9QTwzF
49589	payment	1693	1693	92	1	1	1484	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYnMqgH3vBtxBS4uSTtHemXizfjkNF3HS5Z3Bo1TthpLhys1b5L
49590	payment	2134	2134	1874	1	1	8319	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZBvtLz3Hk82kwq8ZHGmvXGFQBbYzGz1wHeiP3VqXBWQsMeae
49591	payment	2134	2134	1874	1	1	8320	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAVuF3mqMaxSZLDLDbzb31ZfZKP961QjdW1fUrFeQNN7abQq5
49592	payment	2134	2134	1874	1	1	8321	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTojQKkki2YcGYZrGo9WX7m5wRCQQCv2K2vGsPgJc6aa4ri1P
49593	payment	2133	2133	1874	1	1	7793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZYPCebU3sDjBJq9D5GshMogtxwyxyoj2Q4hYNuHArPg4PfXX
49594	payment	2133	2133	1874	1	1	7794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzWWUYoNNb1YeypcsLy7MxoqE6iUPWZ2asAZVa4U3L73kW1r5
49667	payment	1397	1397	1678	1	1	18105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdaGP4QcDmbHJfmPGspDkUFbvjWh6i1JMSeZ5s7TCF2DFFH9R
49668	payment	2133	2133	1874	1	1	7807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXbnm8gFJKTBa9A2PkbMQ6wub1BUc5YErAftgB5ZD6hXaeNet
49669	payment	2132	2132	1874	1	1	2119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCMCLkLzjPb9nb7tE3otNoZX2oQoBysC4MGCrUzKDrVSckWLu
49670	payment	2134	2134	1874	1	1	8339	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQ7bDN5frkWJwGHgRcvax96s2emzgYW5D8nrPVyaVyyddRER7
49671	payment	2134	2134	1874	1	1	8340	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUejSMVGxCARWzAe2tNsEztDgdDn3NPB3camz9ybsRUqiiaSQ
49672	payment	2134	2134	1874	1	1	8341	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrR2oibuto4nNyWjRkFTxMTLhhpWLNN3Yy1ww1heoZpUMYT2SW
49673	payment	2134	2134	1874	1	1	8342	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtmqkEmExnqLdPt7AoiP2e66YfHd6nmgMzxL4STGcJeGhGwRX
49674	payment	2133	2133	1874	1	1	7808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEomYsNJPg9df4TkvM7dEySpvTP66Vq6FxJa3VzdSTvgkhbsd2
49675	payment	2133	2133	1874	1	1	7809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3cu4X8qqFFt38edH5HTysN9PW4GH84j4Z7xQds15x2aoxGWp
49720	payment	1397	1397	1678	1	1	18111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDgqRq9FhzuxvadzaEcvZozjN4Zw7XhBpNyGSg9yUX9LEdpPi
49721	payment	2133	2133	1874	1	1	7822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyUGDUdqUxV8RemgYJNSc3knSJV1Y9JQL1uytAySvVLpMCGqt
49722	payment	2133	2133	1874	1	1	7823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAjH1MU3JWnT9pZs8Gb4UUgXTAcDyzonerJBdsPA44Lejw7Hf
49723	payment	2132	2132	1874	1	1	2128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawwoN1ogxBx9GkWJ8so5VB7pjm12a3GNWHsXRo1suPa5GhP35
49724	payment	2133	2133	1874	1	1	7824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWVUGfL9y2bQJQSZG8mcf3j9GgtVdLJj2KtspELtrwWRVXs7y
49725	payment	1397	1397	1678	1	1	18112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8D37DractU5qgeAwgiCsFK4QDJQnCbWDaZkzqYDcY8FRWZjSA
49726	payment	1397	1397	1678	1	1	18113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu2ShDAFxSHJNCxzVHETfYsq5nzg731CdZdX9oD3H7shxV4tr
49727	payment	2132	2132	1874	1	1	2129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4y4tVAucy2fy6eQLFRh3rvyNbCJ7qoic1cy16mpNrZ6nRW2s
49728	payment	2133	2133	1874	1	1	7825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTu6zTbNiUddkaGzfu34jCc8Y5GPYwgiptpVDiDYrZEMWhFBE
49729	payment	2133	2133	1874	1	1	7826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtstNfQDa5DznbpWHsjpUHqm715ngdskEmrKgow7hWSBSvgS7L
49730	payment	2133	2133	1874	1	1	7827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqLrx87y9yWmQyk9R41cYuENZzcmNqvRyuxFQH7oKJR1qwDqr
49731	payment	2133	2133	1874	1	1	7828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31cCydjynmFuuQV2XWQNjAdUx6xt6m5uZaN3ns59mpTKBEMzc
49732	payment	2133	2133	1874	1	1	7829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CpSHYp3XfjV6wHLHRtsfzFGcjQdZSRJqYTQcUEpdb1suepgD
49733	payment	2133	2133	1874	1	1	7830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeE29F29GKxB2XwDYXsuz5bfRWqeVtgmXRy5h1wwqNAbg6b7Z
49734	payment	2132	2132	1874	1	1	2130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAvStrQWMGWVaB9DiHYfmZ3tPV2aegJH5TA7JJYpH4non5NeC
49735	payment	2132	2132	1874	1	1	2131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdXjPkiix6tCv3A5o8fBdJWR7LZ2eMRu4zHs1xJxRw52dLB8G
49787	payment	1397	1397	1678	1	1	18118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv32rDtwQZrvLkFqCyYGXXDguPpmcazauRDfzybsasq5vhVREh
49788	payment	2134	2134	1874	1	1	8388	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkze36EhJqKGEwEoiiadzPBnVJMjad1VLVGuGh216WjR6vRrW
49789	payment	2134	2134	1874	1	1	8389	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SNk9FVAdi5txrcqc9DjSZPe6pC6jmokhw8XE3DKWDmzR7kPF
49790	payment	2134	2134	1874	1	1	8390	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4WcJPYMCz3Ep4cKvFrGiwbLusr3WBPowhkBj9fD3MWiikZDK
49791	payment	2133	2133	1874	1	1	7845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHDjKGr1PBZXbq3Yes7XP7m4CBUQLgq2uLUgBafqzUBvL2URL
49792	payment	2134	2134	1874	1	1	8391	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvGQyqS7UmrZbJfBcWkgFWKWTj5eZ4mwPLCAG1YpFddidARr1
49793	payment	2134	2134	1874	1	1	8392	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgCvkQPgy4Hytreiu72BFmCS4Qx6HJ8cGM5UTyuCCjnvS1MqU
49794	payment	2132	2132	1874	1	1	2139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8QnaAErxjVR1Fudc4uayzNBjDHzPmyyGByB4kjQA6tCJ3gNt
49795	payment	2132	2132	1874	1	1	2140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsiu2H4ZonePCpJQxp8vtDTqndb76kKgnJoLXkqa1ckBw4otmF
49796	payment	2133	2133	1874	1	1	7846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaMPhE8fMSZY8QnDeRfxsNYgaxgXojniJTWwW9iZ89WMqSsSx
49595	payment	1397	1397	1678	1	1	18100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHqrvgyYsGbqWoXbWNopzAn8ADexQ9Mm5R5EobynsPhH1kqDb
49596	payment	1693	1693	373	1	1	1485	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYhv5jazp9Kg4gKZtWSocfCPXN5Wc8rt7AUvWbgKA1a9NtQdD7h
49597	payment	2132	2132	1874	1	1	2111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1M3EBvpyr69pvzYyr69nLKQwCuQVaaqqBMb9C62KHf7SQLLu
49598	payment	2132	2132	1874	1	1	2112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCin9H7xoZANY9q4LPgDFmbqM3cV6tS9c84LxU58F32i7Znxo
49599	payment	2133	2133	1874	1	1	7795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkg5DJB5p86qQeHsJaF6ygRfF2cXLNzYyRryA9mZyF9cYoJd6p
49600	payment	2134	2134	1874	1	1	8322	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprJ8GmFTz9oz6DQxBD9RUNj1Cc2dvxBmrBjpsQDBsPB8GZnG4
49601	payment	2134	2134	1874	1	1	8323	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgRx4R1HTdci6ptPBcERPYmJAUZt6jGYCoENdQQ3T39NAtoPm
49602	payment	1693	1693	453	1	1	1486	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa4QpyXruMzqM3c39g8G2jsMP8RVRZWkhghceLCDDZP6yD9Asdi
49603	payment	1693	1693	711	1	1	1487	3924955555	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ3YthZa4AmFev3soHduWYZzkhaPWG2XuMZzaotkyeochq2Hibs
49604	payment	1693	1693	91	1	1	1488	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYyrLTovBgNWi9QsDAaNAKhZsKARbfeNdvQxEzWV4uqAMqAcMUd
49605	payment	1693	1693	438	1	1	1489	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZc4vq7FJLcryxZT3T6zqsqSgiGA7Zdx3SAjAbrwJWpJfPWPZ35
49606	payment	1693	1693	745	1	1	1490	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkBGrjvgoYdPXiGvnfoGRjJfz3A1dCCqKN83WFN4FK3LsUMpo4
49607	payment	1643	1643	1299	1	1	25	1563405850000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77fkfned3Lwk6SenzPVCpV38hiwspazC9LerM6pgpzPAn93Ho
49608	payment	1397	1397	1678	1	1	18101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8tBW748TxpopDc3xaxU6nzoUhB6iUsF3vh3hCD2ARSxRPVyi
49609	payment	1397	1397	1678	1	1	18102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxXw1v6vkt1EESvbnfTQRzDnKSkVkhejNCW2SL4TxescrUmhA
49610	payment	1397	1397	1678	1	1	18103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanDdDNkSkecNV58dZjtdZdGDFdNXSTG2AnaASnCTairLBrrnr
49611	payment	1397	1397	1678	1	1	18104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndmLbZxQKQhNqjK2pGbpm78qdVkEMHGygEiuieneKaZdkQWU7
49612	payment	1693	1693	89	1	1	1491	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZWgmbv1qYQeUoYqbwkHFcWRawd1SXoYqrz26VfLD3tKbZ7VNGf
49613	payment	1693	1693	383	1	1	1492	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYjYzzCWMYyxFFahmCrJv5GxMTojX2KppbrMTho1b6M3jiFx4YZ
49614	payment	1693	1693	678	1	1	1493	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZX2Xp5LinjWLkKc1bW3hXaZdjANi4AoVQ6Wm45d21qFUBgvP57
49615	payment	2132	2132	1874	1	1	2113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPVHunpMV6tDBQkQPzX3TqMDWEkfn3Jd2EhbaRJzzxCv7yz7Y
49616	payment	2134	2134	1874	1	1	8324	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1v41yAXWLLdP1oKzbPatNyK9yZx59JBZS7h5QuX6z7EMojRV
49617	payment	2134	2134	1874	1	1	8325	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkLw59twDYwan5mcuPVfLptunvkzc6kLUR9r5Qe3w3AJi7yVE
49618	payment	2134	2134	1874	1	1	8326	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJJq2fYLpgvnScSRzQVf3VbpzRxwzyCQJdJejAodTf3d8LMPo
49619	payment	2134	2134	1874	1	1	8327	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuS9PMZBXKNjr36eVs5o6qbSuH1i37y5KTpyjMRvVbAp2nnwpD
49620	payment	2132	2132	1874	1	1	2114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpn6XqXBjm3jo5Zr6fRp7kPJ19fktgxMXJdWWDuv37jpc6T16k
49621	payment	2132	2132	1874	1	1	2115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xXMWTBXnbhD3ahh2uTBWRm5vmht2mNvUxqLekMj91oBuY8YT
49622	payment	2132	2132	1874	1	1	2116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg53rxSyK9W98cdHkkZhLDy4Kf9oesgFF3BR9f7WUm94NGQrZm
49623	payment	2132	2132	1874	1	1	2117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N8E4pg1ScucDdEtoTwfaHSYUU72iRQJv6jgcACvdfpMDQcQy
49624	payment	2132	2132	1874	1	1	2118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHDTzC51sinYLjbeWK7b3XuXZe7GoT5wSpgAofqQbq6uam1m7
49625	payment	2134	2134	1874	1	1	8328	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJr522AzPuVvuroCoYVPaLwgBSetzHLCh7j2YRQ8XbrwbD88c
49626	payment	2134	2134	1874	1	1	8329	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL4hDjRdN4BVFiBsBZ8GhgwFDhmGENebXLD9Je5SKiEdqGEKf
49627	payment	2134	2134	1874	1	1	8330	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotzoR9SNLDiUEgixdosK43bufXTYX9u3zEKMWfd8ftd3crd2K
49628	payment	2134	2134	1874	1	1	8331	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUenebPfozXWZPpGMWPQjfh8CobBj3z3eZEtmaGLWwbs1FHCJX
49629	payment	2134	2134	1874	1	1	8332	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UWxPy5thAqmNYGtdS845PtPe7RF6Y1w7k1txgCHTdHnexZxC
49630	payment	2134	2134	1874	1	1	8333	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUDLhTTyE6crXwQ3Bm7by2BP7pewM99ZECbAjL89qVi95g23C
49631	payment	2134	2134	1874	1	1	8334	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zDQgvYCWwxzcXogq7a7SncFJfSf9JF8gyxXPdR7feC33EQ1w
49632	payment	2134	2134	1874	1	1	8335	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccw4mG7z9ZHhsvBjU7ZhLBqKmD3jtVjZ5HxMJpuiqpXRKgyFZ
49633	payment	2134	2134	1874	1	1	8336	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsGnmp2o5djvgiZB7rXoGscynzJqJT1FvUaadWbZu27xX82Dj
49634	payment	2134	2134	1874	1	1	8337	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7Q62AJNeFGdUsQEbTQf8UEDW4fv53QbgMgzkp1h6CavdBnx9
49635	payment	2134	2134	1874	1	1	8338	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhcqD5P9jbjmJohmMbxJu6QKxdxfoLgJvxFAVUv7H7v3455R6
49636	payment	1693	1693	1150	1	1	1494	798431099136	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaL22Ahq4kfUcN2L9eKYn18E5WbjNa3ERWi1NZqXzgfhNLjE4Fk
49637	payment	1693	1693	84	1	1	1495	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaKwQtnyVVtpW6eJfHh9LiRtQucMnFGoJ88U82KNQhXo4kHaqyu
49638	payment	1693	1693	2430	1	1	1496	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZhgtkXoRaG6MVyQvQ5JwQTQcDLk8XBhvMirHPkGYeT7XBRpjFB
49639	payment	1693	1693	551	1	1	1497	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaDFeo494jWZ5m4tUiq62eJu32yT4sMKbx4ybdgu4P8Byh2hNMD
49640	payment	1693	1693	122	1	1	1498	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZcQipPFMUE5rsf2aLmT8xHis72s69ZGF9ng7pJzbgtpZNg2jwU
49641	payment	1693	1693	2308	1	1	1499	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZEna2iCQopi4tytixXK6DrqYdpyu2VvRtpdg2dm3oDhZ6ZreUJ
49642	payment	1693	1693	653	1	1	1500	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrktWaPV5eeW6aQi3RQDTTeEkuXEChiFcdyq6MwroZo2eNRrdL
49643	payment	1693	1693	304	1	1	1501	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZP5YMgnsVkUypMqFEcFLunziNdP2D56JYaqk8tzCXK8SySRkFL
49644	payment	1693	1693	441	1	1	1502	86280299069	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYYUnXuRFdmhPtg9Rb89o7kriEzTMyg1mcjrxskYkwRwJV341NP
49645	payment	1693	1693	240	1	1	1503	86281724001	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ91ngJ1cS2miXmK6ZUMKVJYM4k1waDsF5PBTDPE1PV8NB7uQiW
49646	payment	1693	1693	262	1	1	1504	86280415414	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxm2wCwdCwLgP3JsNi3X7cmTj4C7aXxZzHBhV7c7de3qDBgVYd
49647	payment	1693	1693	154	1	1	1505	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ53duteiMAXNKZWihZ624Ejvi9Y8dzVQpboKB7Eav4gxpejjW6
49648	payment	1693	1693	1961	1	1	1506	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZX4mH6SmQ4HvKiV78inR82MWad5yS71cfKXtG8aWqhBjiJKyvr
49649	payment	1693	1693	658	1	1	1507	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZA28ssbsyym4koFn1HfYKm4DYKQEaUPNvfbiPCWNyMmUscgA4T
49650	payment	1693	1693	660	1	1	1508	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ6qkysjZVE9BB6xV59sEsZofv51qjgys1bjpGReDimdHiddGu7
49651	payment	1693	1693	593	1	1	1509	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZbWxDKCogx9EzUQQ1Mm66vsoxoCAFA6YKzMzth4G4L4ud6Xjyu
49652	payment	1693	1693	395	1	1	1510	86645078818	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYQqSr5R1shxmaeHN7JjjopmzeREEGmcW3yByV63z9sT9tScCPy
49653	payment	1693	1693	78	1	1	1511	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZjDA3nJDbz6KEwKG7tvQzRmLHrseyPB4wtaqbEMEbZLp6AD1Wv
49654	payment	1693	1693	29	1	1	1512	9190049669	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaJcewo788D81L8zHD48AUXy3TgghRotptDb71oXKHbum2yZcCx
49655	payment	1693	1693	910	1	1	1513	660355773672	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYptAF2JMQkj9GRvoR96ytErCs4YUKsVrRhjoEHCHsQcsdwxFVd
49656	payment	2133	2133	1874	1	1	7796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLd5xr4TLFQkJxykEKmPDrw8b18iP9CVMKfk6ArP4RsVNMNF8u
49657	payment	2133	2133	1874	1	1	7797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWewr9QMoYj8rdcdWKg5M3Ds1Zw3y6KZakhuYh8mjPh6dgpifg
49658	payment	2133	2133	1874	1	1	7798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVvf1YBU6bhTW5j5ecNhDkyR73tAGUXuEUbsAobGABruoqa9K
49659	payment	2133	2133	1874	1	1	7799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1gR2wvYHtvfh9ETTF16UVzmxdf54DRPpw8DxJ2GDTB9G1p4D
49660	payment	2133	2133	1874	1	1	7800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT1RPDcLrC9dzWvRZ7QT8MpMFWcF6VRzkR1FuLVRuYVZwocru
49661	payment	2133	2133	1874	1	1	7801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrARoasY3HsrGsdigFQUJMFxF82tMSosHTNSaDGZ9Bb1SLiRHF
49662	payment	2133	2133	1874	1	1	7802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVa6ejQ1X7HYCdoGAKTiZSPXPsMjFgGh5oCgvtVTYLWPEgnZe
49663	payment	2133	2133	1874	1	1	7803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLen9khTK4XFT3PQdB5q9AT9x2SJZsegcPhC1p4a7sjxRY95ey
49664	payment	2133	2133	1874	1	1	7804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7KE1CXkY3j4qWzHNZHfPhdRX6wKTMFcnN3RzJkh4gik873Cg
49665	payment	2133	2133	1874	1	1	7805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFkVavAH4TXqrAcn1ANq5Nq3f1joxbMR5ZP6ePPLbzgrihutr
49666	payment	2133	2133	1874	1	1	7806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6GGDff4H1r47416yvA1WMfqisouGS5qdN7BHwxgbo1TNDEvN
49676	payment	1397	1397	1678	1	1	18106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApCKWUA4A7bdr9cj6PN9yDEXjNshanotGdF5CDeY49i3kgBaW
49677	payment	2133	2133	1874	1	1	7810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT92k8pxjxiqqGUjmUGhgwo986Evjc7uRGM8gXQ723xpvDFDK
49678	payment	2132	2132	1874	1	1	2120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA3QEhtZ4mymVVEaXNCaGfqjNWUvg9M365jE4QHyhJ8rQ9PWE
49679	payment	2132	2132	1874	1	1	2121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWH2TYZLXkHT159GkhWwCSdc1zioZAicRy9f3gmCfbG7W8ScM
49680	payment	2133	2133	1874	1	1	7811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA47w1QfchHDYkRjE5aRJ7jM8hHJBqyL5qb5r99s8KAeYyRfE
49681	payment	2134	2134	1874	1	1	8343	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9V6xUR78R7ui2e3frWZAW5yRPbqqvHbzgeEdT8guKDmQXGwK
49682	payment	2134	2134	1874	1	1	8344	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSgRu7qWk2vTXLPszmxC5wsSMe2mn1kBjVJCme1XXE3PNMCx4
49683	payment	2134	2134	1874	1	1	8345	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZory84HcGFZAqcLB3afY4HezV2FN1CoGzQxnQ9UeYvWoXsZrSV
49684	payment	2134	2134	1874	1	1	8346	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5v8NEWTrZ1atEePkBux6mQgiMQggytkQTXVS1s9x4JE57WxL
49685	payment	2134	2134	1874	1	1	8347	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzC8po7vPAbg5pCR7epYhpNPm2VTa5Rr3USXoFh8FsVe5oNkuy
49686	payment	1397	1397	1678	1	1	18107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFwqBqPhdmqpzsvK67BpHfCDk475fx4MQQaDiGzvpJV1QrGGt
49687	payment	1397	1397	1678	1	1	18108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkwT3w78EcPQrxtD2yMzNaXDsexTrfcYAK9xMxKFNR5zPZNwW
49688	payment	2132	2132	1874	1	1	2122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbe3F78936EZYYNtQ29AJnqv4ktPR1ocQYGn6n4TNMj4R44Djy
49689	payment	2134	2134	1874	1	1	8348	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7KnSxeztEE29FLxjHLmBeJiBUyuaWnrKrzDKkuC5cNrPGTrB
49690	payment	2134	2134	1874	1	1	8349	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNjCCcVSNYeVzupFucVHEtz22K8iXNh93SLH6NoHL2xqMpT4w
49691	payment	2132	2132	1874	1	1	2123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZypWzrU7sVbrM8WPBg8LxbWY29iVy85w8WKcaU5zd9ZeuoLz1u
49692	payment	2132	2132	1874	1	1	2124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyJUy6utUNRrwUvRm6rbtYCb9r4MGiCHXGLHtk3dZgoBxxAd5
49693	payment	2134	2134	1874	1	1	8350	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJwQgkqJ7LpNS17wTd8k6a1YzHNVZHhjz4WKrEEV5MERHh4xv
49694	payment	2134	2134	1874	1	1	8351	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMFHN9gqUq4pV7P46Yx9giUGyx3icqwi4n69MLfeXC7Up8gSq
49695	payment	2134	2134	1874	1	1	8352	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCZkrhMShuksSocoYyUWa7aBzEZWxkVPoKjyGDRKTBy7tQcNu
49696	payment	2133	2133	1874	1	1	7812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aQz6d4cVK83yperKvK6Mz3xwwiRZjiJBwUzavNKZWz7VY2uJ
49697	payment	2133	2133	1874	1	1	7813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9tC648Emg1r6UFp2ASXtykzTzk5zR4WvhLhvrcWrH9rGjj3Z
49698	payment	2133	2133	1874	1	1	7814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZRFswwBoP4bwDb61F5gVEmionnuiqHYqN4rnyZrcXmRuYRae
49699	payment	2133	2133	1874	1	1	7815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTsXYsnd8WmMyPJJm6p6EvfYTA324JUt3skDDjAJpDuwg7CXC
49700	payment	2133	2133	1874	1	1	7816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwc6Fy2tgBx2LrrQ92fsxJFcFBkTkHdqZd4hLvRLfyUVnwa83P
49701	payment	2134	2134	1874	1	1	8353	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDu773YT6HZ3hYRJ94teP8GsCWUUU7XNQTRa9DTPFxsAkCJv1D
49702	payment	2134	2134	1874	1	1	8354	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFScn82hQJGkJr3AUFWj5XEgJMCbq5g7pM3iUXCa82a4NjqDdM
49703	payment	2134	2134	1874	1	1	8355	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAfkhFs5eCpUtsFqVcF3n8vbkdcqF1tsjwnDHAmk8kkTU2Uaz
49704	payment	2134	2134	1874	1	1	8356	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsSA1qTLK8SRK6DnFuaxZvSCDygktRWe3gwcm5TLnVwbUEHpM
49705	payment	1397	1397	1678	1	1	18109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtrhctdfMgoGbGgf548AwBxK9GDYTJEjJfPmskYDM3q3ym3uR
49706	payment	2134	2134	1874	1	1	8357	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvgrMcKDHGn77bS5jUptkisbZi5dGdLbihoq79h1UiBNqvWUc
49707	payment	2134	2134	1874	1	1	8358	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFfEtijzuhYVssjMSMnXbhfa1ZTc81wATNX5EK3BmmtYUZmxN
49708	payment	2132	2132	1874	1	1	2125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuLMWJKVrg57FV4mtbXSfMGSMqTn6SbaK9dTdubhkTG1UTbcW
49709	payment	2134	2134	1874	1	1	8359	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iC6vEivrxRfo8LQwFAaZFeHne4597tnFHHUxBWYSekNTFQrY
49710	payment	2134	2134	1874	1	1	8360	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCf8kztTvBkNbDb42ZhpPf1cxRGHoHsujYQjur6tpUDreLeek
49711	payment	2133	2133	1874	1	1	7817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTKuSxekVzYawEKZrY6mno5PLonEnNKhuQAEQXmyubawiyT6U
49712	payment	2133	2133	1874	1	1	7818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRv8HeWtb7AjNZQp6MthVQhvJSBURXr19Co4r31FWV17MgX2ks
49713	payment	2133	2133	1874	1	1	7819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xfhDUd3shd8ABZvjid5aUWZn3JdaMCgizZVqBMywZzTpmmFN
49714	payment	1397	1397	1678	1	1	18110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK44gMX7tDb4xuNLAx6Cy5EEcRAw1HH8zTcVai9EtvSkE59qCu
49715	payment	2134	2134	1874	1	1	8361	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtC5rWJJT5cg1HnYkcg3vDVX5C9dGD6Ps2G1BheZAtLotTCLoB
49716	payment	2133	2133	1874	1	1	7820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91cbJ9TrkyEkXWXUDkfqmKit3PkndUZ38SgAZ4ehAA2cQsgM2
49717	payment	2132	2132	1874	1	1	2126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6tGkz9TLYHBZHqhMz3mrSTZKiK8tmT9ztcu9fzYXDQt7SGMs
49718	payment	2132	2132	1874	1	1	2127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLsxXbJVC3PAqfBs5xbDa98zrHgyuXnzqnxP2JwmWtaiYi7Z3
49719	payment	2133	2133	1874	1	1	7821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFECSfd9gYGAzawLrUQwnEfKxTeshsxAULytUAALiDvEaRf8JG
49736	payment	1397	1397	1678	1	1	18114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmNrJDkustHrzMm7cGsBjNxv7F81osBpXWC9QFEor5jo8e3BE
49737	payment	2134	2134	1874	1	1	8362	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p7BSURRAriQmdpHbARsTCRMpGLBfjcitogv7e82VcxmUig5g
49738	payment	2132	2132	1874	1	1	2132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDR6XLwuMhUY3gEWQ3iFiAmVhBUgKucpGy1EfDrgKrE8EJBtZ
49739	payment	2132	2132	1874	1	1	2133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9EgRiwbRupbWkWMfrHket6eHw1hJir1oRtp7w15JrCcHysb8
49740	payment	2134	2134	1874	1	1	8363	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa5PaUi6ygXShZYnHKwsQ8qKxkA4EN8gNiXbqUkSDkVG6Nw2t
49741	payment	2134	2134	1874	1	1	8364	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MeGw54fXShTVFuurX3FGCA34QZCnM4RhL6oXyPMUg8yE7BAQ
49742	payment	2133	2133	1874	1	1	7831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3yqFQHWQsm5Kqe5wY9Cr6ndzXRYDfJv1wDQUykWYvPCkXcPx
49743	payment	2134	2134	1874	1	1	8365	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JsEj5RsWMLYHjyGRrMp24jjmdfVZgmJApERzHFxGhfKxsqn2
49744	payment	2134	2134	1874	1	1	8366	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2h4yZPVxRcDrKbqdHqW4s5G55QdzphEn4X9ZKYjTXMKZFQai
49745	payment	2134	2134	1874	1	1	8367	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95AccnAtLcQCJdFXczwNgFWu9fur1kxNMyVrHxzrTzZLJGP5m
49746	payment	2134	2134	1874	1	1	8368	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMHkzGHhnoxWQrdBn8GfWdi7Fch4vDDscAR6e6tQc7M1586AF
49747	payment	2134	2134	1874	1	1	8369	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSTk4WaaQZBrmX2HkMmk3RTi7pcwdutKQ38PcPyT12hgCDk1N
49748	payment	2134	2134	1874	1	1	8370	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyryvojZa38LLhMbb5ujfbPhPJ9aadhRrAF4XypjkzsUZ7hsB7
49749	payment	2134	2134	1874	1	1	8371	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnwrxxPNSNWuz9enYNrQquf8qJtk3n4nQhDweU3Xja625PzLT
49750	payment	2134	2134	1874	1	1	8372	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45KqjkgtEZy9qohTzjBiVEyLLBNwK29qy4zfswB8C29uSQRxA
49751	payment	2134	2134	1874	1	1	8373	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdoooNF1DeJh3LQGGfhcFzwGj5rcNxE7mxQfRZ5F6WJDEVf51
49752	payment	2133	2133	1874	1	1	7832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKARUYwZPQUQgELwksb4k6pTcwBzQxtLTEEFTazXybbgCqXCbU
49753	payment	2133	2133	1874	1	1	7833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFRpEPJMGBU1SNW674eLfKCk7qvDpBxENmpPbn8pTj6SXpBme
49758	payment	1397	1397	1678	1	1	18116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpSmjMUXqsSfMProiNAPpJqbUm8F2QMdhY88y7QUoQu5BXLt2
49759	payment	2133	2133	1874	1	1	7836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjLYEbse9BEFJMg2zCzqys1VKfWHm2gomorkzZfVAgG9uckDp
49760	payment	2132	2132	1874	1	1	2135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22BNvUMCLyFzLzg2nBVfD2Ustf1mpDFtJ9ybX9kJtVMYsvyPJ
49761	payment	2134	2134	1874	1	1	8374	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73f7GiYCdWDLJEwA49tNxsB4wcuYqdQPJmzfxoSUw9u8UKg4e
49762	payment	2133	2133	1874	1	1	7837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbk5uVpDaGNoQURvoeNH46cPqzP8bTo2XqB2sR2GTwgikzvS7
49763	payment	2133	2133	1874	1	1	7838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkSrbUhNcDVqhh5vPcYn8LJ6kmxWKQoJ1uyktGJUyHoQ6aUZW
49764	payment	2134	2134	1874	1	1	8375	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUF7bqTb1ZMZqVjhEuppFoneFnCtLsvNhd1f4k5cr5k3AEhUa
49765	payment	2134	2134	1874	1	1	8376	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkXAzha77XiFpBPeaMfFVSa4DfKeHoGMFGa4VQ9FkQVpmSEbg
49766	payment	2134	2134	1874	1	1	8377	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmEktjAZ8p13ryxZDwaAFf6pLPhCfPr1hifzactD4vuxbNujk
49767	payment	2134	2134	1874	1	1	8378	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYHQoJfu2c3pNie7KAvaSXMgy4qYCEaPUURayYP7zHd4kew8H
49797	payment	1397	1397	1678	1	1	18119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLnxGAtySHcWeyMPBCp9qVYRqFw9paTXY1QXZSeGAwQaRDoHx
49798	payment	2133	2133	1874	1	1	7847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanwL3fod1fiMw2n42BR6ga3aTdEhVdx8fbgcaBMiiMQmgbM2Q
49799	payment	2133	2133	1874	1	1	7848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyXpBdz3eXHBuvADs5L3hGcwGbqr53sjGAr7hSxXDQxQzQc8S
49800	payment	2133	2133	1874	1	1	7849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZo6nJfhkewDXG5L49WmB6k2C5EGp3BUq3HQEnwhB4KGuNMPU
49801	payment	2132	2132	1874	1	1	2141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygsPtp5CbZma1TjvCLvEnDv55KnFgr45Z7Y3WH778DUi1mFL3
49802	payment	2134	2134	1874	1	1	8393	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxS8vWtSmknDFDkVGBbKiDHm7whofn4WXa1MCwx5ZuResek5D
49803	payment	2134	2134	1874	1	1	8394	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQDRXf2bjjoTKh6nb1nu7v9RcvvemcsVChNqUB6ombvu1AaaF
49804	payment	2134	2134	1874	1	1	8395	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAvFvQ1fSNoxn56o4ErTYVzbadETKDUgAtgthdR7R9fbdq4qq
49754	payment	1397	1397	1678	1	1	18115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1i7pUeewn9EDWqRtWvV3H4jXwuZRiY79H8eB7CyxLrtCcQaL
49755	payment	2132	2132	1874	1	1	2134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnGqAK4pMYyzSGDWefyZJcEoNLarrSoDcv5YbiFhM628psge6
49756	payment	2133	2133	1874	1	1	7834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpSjckBge9sXG9TQ83SSbGfnr9a1XMNUt6hXbatqfsWJeytLm
49757	payment	2133	2133	1874	1	1	7835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVy1WjA24YwKLXcaGeumHAiRmV7ez2p51k1crZHackiFA8or7F
49768	payment	1397	1397	1678	1	1	18117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMWW4eJ2hxsMUHQNqTGWmbidv9cvGCtkLZrNoGmMEasTjELxZ
49769	payment	2132	2132	1874	1	1	2136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZTX7zLJzAahHhinWaM65rEi7mzgxXtHRVnbssSjEsd7K7VF3
49770	payment	2132	2132	1874	1	1	2137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCewbANzhPG6MEkvM7p9ppJL5N1dn79ZYq1Pm3Dhb38FV8fxx
49771	payment	2132	2132	1874	1	1	2138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczPZeeDfgMLXEM2oumwYdL459njrb5Yq1EF8Eon4nfLCz673s
49772	payment	2134	2134	1874	1	1	8379	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB7jdeRQ2ZPYxiMv6aDA8xe9r1zceFGhca7F64QmuXShtJDhY
49773	payment	2134	2134	1874	1	1	8380	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxUy9xE2PhxQYd1NCA6HdT5BLgqFgqdKk1RwYmomf97Lv55WP
49774	payment	2134	2134	1874	1	1	8381	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifuUQgAXMrLZfgyymoYUarvkyL2k8PNVMp1MXPq61NXgiavxH
49775	payment	2134	2134	1874	1	1	8382	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjerfbYT2FwdMviGABcx75pyyZBDbpa4Ys5Zh7YtdvZ4eWXzm2
49776	payment	2134	2134	1874	1	1	8383	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CW778TFArRtmCo6d1U8ud1Cbuc9KSE3AAqJv2NG4E5Gjtim7
49777	payment	2134	2134	1874	1	1	8384	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBpCN2xFEv52ys5SUEaDvvHhiVVpC7MrGXLHCiYaawacySik7
49778	payment	2134	2134	1874	1	1	8385	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEBhVmSBSGssEAvwuFrsR4LTRx8PS74YvWJQoGWA86SFasb89
49779	payment	2134	2134	1874	1	1	8386	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrDpp1xNaB8HSDoKA2msLccnRSCshZV521KUostg6adKenohL
49780	payment	2134	2134	1874	1	1	8387	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc3bCYqgPbqrkQPqzQQb2f6vw7W3QpW8Cj5BSBNvbAkHXcwVL
49781	payment	2133	2133	1874	1	1	7839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpS7JGvDSS3FeSmz1aJKbwZCbCfCzVfbTB6qCj9g412bNa6HT
49782	payment	2133	2133	1874	1	1	7840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wXkcktgPdWKjuHWTreDsgXjMMohcDdhFfHFvLS6wAUen5NsE
49783	payment	2133	2133	1874	1	1	7841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWmshqLwzDMdB9ppPv2F2uhpFevnkWjibHnUGBnYfnPTfsKK2
49784	payment	2133	2133	1874	1	1	7842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BMdvSg9Ds5ZPKVxdoipVwpcAGvAYHtmpMr8Zu2d8Hc5btpp4
49785	payment	2133	2133	1874	1	1	7843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMuoCvA4cmVsVPnTXiDECXgF3A34LorXd52i3AHJMq29m55qB
49786	payment	2133	2133	1874	1	1	7844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbezEiQ2GXUy83Aezp6EpkbrwdZTo5W4AKjXbu5DcjNJgv6UrG
49806	payment	238	238	2314	1	1	7	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibPYp1oa1v9M1KXhKMdRsJs5YaLQjMw7CJzbssATugZhcSAg9
49807	payment	1397	1397	1678	1	1	18120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h4xBFr1BvLcHKTGSXKtozqFgqksP6Hmpz7cp3jWqzAkXg7Cg
49808	payment	2132	2132	1874	1	1	2142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbX7ms4GutV8BGErRDGhGE5sdnAkLjPcoL9Mxb5JXN7kn2nexU
49809	payment	2134	2134	1874	1	1	8397	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp2AS9nCVtNVVpJ7MSWfKeQRy7YTv7dfSvBSCng9Qio3rNruSB
49810	payment	2134	2134	1874	1	1	8398	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz67LyqpskxNS3yyXNG2bRQVL1yHJwyye57SPUn7C4N78RkUD
49811	payment	2134	2134	1874	1	1	8399	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3wrXL8Yeqp4tTCEWa3HKVjM1bVLv4Umw2PMwcoy5KRaf7WET
49812	payment	2134	2134	1874	1	1	8400	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7suEx3c1BoHmBS5SE2ayd1DoA5u1uSAV3Hdcx1jp5V8ceFoHh
49813	payment	2133	2133	1874	1	1	7850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXXvFZgJ4LytCWR5RYskozCgaUhpqnLWKW7x5zkF4jreyyNbT
49814	payment	2133	2133	1874	1	1	7851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQstQU8gBacxuB4mC8UsyEtQ8RYB1FeVeRxzGrwopkZS4hgXWW
49815	payment	2132	2132	1874	1	1	2143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcVL1bQCGvmJnpTCd1i9WzNuzpsa2zNa786Noycyb11j6ve39
49816	payment	2134	2134	1874	1	1	8401	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTh7Kn5uwkeY6irrRHZb6T3ZMuM18ub9RyQQfqZT6dGKk1tr2
49947	payment	1397	1397	1678	1	1	18131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPYZySRXkbeh2BA6c5qH72CrU8DdYhrZTh2tnkEAm1BgiAQJb
49948	payment	2133	2133	1874	1	1	7899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSXTCkyk1xCaqnjYEWczFK1Pk1hYXFB8maQnRk68kNkBtxWQ4
49949	payment	2132	2132	1874	1	1	2169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLdnip4xzR99pXNNo7HgELeqagUsb37EkVrhpaELt8YiER6su
49950	payment	2132	2132	1874	1	1	2170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwjbsNXaWvWmgtt4DXPd1NZBqj7zAq5UDdDbAD4bQ7osx6nLv
49805	payment	2134	2134	1874	1	1	8396	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvgj4xEH78KbsLkEmN5Qy29R6vcGD79GrqfnwkPng4xkguLbP
49826	payment	1397	1397	1678	1	1	18122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstQuyydVR7g1HCt6cTSzXygwz5NxUmekv6bA35zqCcX3VR8HJ
49827	payment	2132	2132	1874	1	1	2145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDQiGcTTsuAq5BqU6wKKUZ3Hnb5CLZq7ieZbWiexFZSo5kjma
49828	payment	2132	2132	1874	1	1	2146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7pv5pTkJAR22nPJ5yX2B7rN95C9rVaWaU7uxjQVJMTXE5kij
49829	payment	2133	2133	1874	1	1	7855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvohVLxYQoNF3AaQEcRcyozYsRpNw3gHH9jbegoTJKiyjYtPn
49830	payment	2134	2134	1874	1	1	8406	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj1sLacFzfC3KGdWrghBxakWHhpRdKoqo5W4iFc2UenEcjzaR
49831	payment	2133	2133	1874	1	1	7856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxspJjHTPsEBNUpWex11rzC3z9BPcSztdacZsAc829o3sgPAy
49843	payment	1397	1397	1678	1	1	18124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZnaPQJRt5EKVNvVMi1iTEaqz7KPUEY17L1Y1xXsnKXD5vwEp
49844	payment	2132	2132	1874	1	1	2148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcHJxGibJ56uWYJe9uH69ooFvCKmqRiJGtnaqE898DqZzVxHvE
49845	payment	2133	2133	1874	1	1	7860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYqmbkNjNuZhEc4XzQMGwVyBs96BQWTaLA5P7hrRzuxWjgeE6
49846	payment	2133	2133	1874	1	1	7861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmwfNDG6C8i7BBnWGNBu6Prn3W4GsN5AZaZgaeraSP54zwKH9
49847	payment	2133	2133	1874	1	1	7862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4i9tZ4qEeLWXxNnYge3D2V1hNdXKrrxZ6cwKvB34dcpwJDrv
49848	payment	2132	2132	1874	1	1	2149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8S8Xnjps4vLLGjMzKqmf7dF1mLZdptmNV8cKF63aZBh3LcuF
49917	payment	2134	2134	1874	1	1	8441	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhffMUr8dtie3HXKESRRPHygE8ZtRCryW1rBdxcdVB7eWP3nph
49918	payment	2134	2134	1874	1	1	8442	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeX35PVLqvhEYvRHniNaN3VFCe6TtvkNrKtZbab9jZvZBxrpWA
49919	payment	2132	2132	1874	1	1	2162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXabNCmVdsR2Xgw7FNAcTmqV4WHQqta4hyu2fAnwYBu96tNQ2
49920	payment	2133	2133	1874	1	1	7885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEH4YkXFcMtZfp7PSFqWuzJ1LUu7LHUkaLtaLG4SeTsBKJ1PB
49921	payment	2133	2133	1874	1	1	7886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLt8uNmwsRTaw8z25RRfurkqnmqK6VnDhn4eMfpwxzCxgNVut
49922	payment	2133	2133	1874	1	1	7887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPpSJjee9QDj8SyuXiXrDWbBYpUn8G1poHf1mXDQXXFfPvpwY
49923	payment	2134	2134	1874	1	1	8443	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcX1zENDJWVpsdKtLqYggLdPhnJZp5gWU3GsymW7qAs7vqQ6jZ
49924	payment	2134	2134	1874	1	1	8444	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45z7Wv8eEWVRa3EtroGeqMpCbMyNy3i6t7KwF64u2QUF8k38c
49925	payment	2134	2134	1874	1	1	8445	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzLSJPK9WqCMEw7HVNtTdhVsqZdP1zRm7ub379mTpfL61drBU
49958	payment	1397	1397	1678	1	1	18133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cq8k99VBWvD3MKfEids6y8fCGHFx2F76F1Du9ScJe1ub6KAd
49959	payment	1397	1397	1678	1	1	18134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PQtujimUYgNxEAAkv5VixmoB2N4kPVW8p7Lc5MiK9pnChu1U
49960	payment	2132	2132	1874	1	1	2172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdH28ipqt24ZFzjtFA2dd6oP8VWGqfwcRyU7jB8HkKXEaUKasx
49961	payment	2132	2132	1874	1	1	2173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFaucrPimLPihuHE2Ur2YbxxkQXap9xUS6FJSokdT9jHvLoZt
49962	payment	2132	2132	1874	1	1	2174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQki996Un7gpkSDRKTLA7Ymy5Z8WpBKriBrFx24EDSvRKx4pG
49963	payment	2133	2133	1874	1	1	7905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFEAcu2kiQUrtH4JMV7bo9NqQgwWZfz1CpJ4bi6tnCne89dRB
49964	payment	2133	2133	1874	1	1	7906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAog5wMMcbXf2Q93ztqe8GnopBPdhgNNVQ8xYmvcFAJqZhd44F
49965	payment	2133	2133	1874	1	1	7907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b7HCQZtFw2sRetJBwhbsoeYk3JHxz94ykVUXgyUPeUHWHAZT
49966	payment	2133	2133	1874	1	1	7908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTrjnAUCJQ6N3Y7UH42T7XDc8z4JbyD1tTn5u6wKfBLqTcu4X
49967	payment	2134	2134	1874	1	1	8450	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbQZWbEduLfQPYweaGrbWjDfhARFMRog1t2Fnj8aio8JfSNn7
49968	payment	2134	2134	1874	1	1	8451	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZN9TkywLYqudjytNGArgpYrHA8qoAxrKvbMhcHMgjh4YdA6bL
49969	payment	2134	2134	1874	1	1	8452	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPcczCxJfHz3UgWfGLTuf52JnMgzRTqp31NJJDtkbsMR7qjCv
49970	payment	2134	2134	1874	1	1	8453	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Uq7rLA1hbKnkki8D8vKtQqAa5fjotkvz1M2xj5FkNXKbhRaM
49971	payment	2134	2134	1874	1	1	8454	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NWBKbhmaYFAcQWmMFHtzzEmMFSfV7eEmPaXBtSpf4VKwLTbU
49972	payment	2134	2134	1874	1	1	8455	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNkWQ3zav98eFrcsMqfFFEpeqmGaf8jkiihXQidtiNEZQtcN5
49973	payment	2134	2134	1874	1	1	8456	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BszaefjppTLEVAerqq3yurZvNeT6XsY7fmf9gp7pkMLyZ1ZJ
49817	payment	1397	1397	1678	1	1	18121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQKEQovgDJZs76KjDSBPEvZ5FrtyPQRnTBjHAE18bLmjB3svh
49818	payment	2133	2133	1874	1	1	7852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWx48W3xRCQ8bVswX6h8USNnhxCyDk5TjbS7Dd48cMvBytZ7Hs
49819	payment	2133	2133	1874	1	1	7853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaESr2mr3xFiFYy2J6nELJhVa7CGrbmnZZXEBjHY96WC39s55j
49820	payment	2133	2133	1874	1	1	7854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDmVovEZ4Ee8Bp7XQQA8p7FYJq2SxR6eftuNpMQe1Vvodv1UY
49821	payment	2132	2132	1874	1	1	2144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcUrmT54nFzjm5upZ5afe4sagRAZd79pzGzcW9Mu1zi6jpcdA
49822	payment	2134	2134	1874	1	1	8402	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx4TVTWPD4NbFqQZAKjtP5gv9hqnHeyMsknB2yTneKuAy8bpg
49823	payment	2134	2134	1874	1	1	8403	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmY4nnNsuzHVw8b9ESaPdZz6qFjsm69M2NdVKPSTqqumjPKiW
49824	payment	2134	2134	1874	1	1	8404	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWnFUtDXLZUgPw8dzhGmNRJQsnLF6bQnyAEcN2mfRTx8vpDP2
49825	payment	2134	2134	1874	1	1	8405	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjG9XKxxEYpAXcgaPWomYuYMd5UqxFcQXpUnZmmbCNNbMnwYG
49832	payment	1397	1397	1678	1	1	18123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KubwnSv3T9GLwfEZtx2oN7akuDYU3XmHSTaM8mxRJt648Pru
49833	payment	2132	2132	1874	1	1	2147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHFMZC1i8GYjr4fBcKWj1FBtNAisCtJNK7hTQRAqCkci9ASTb
49834	payment	2134	2134	1874	1	1	8407	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2h8YWSunYUV8JD68ro2x4hnEkj3ngjN5JtDy8JbD1Qf6iJq9r
49835	payment	2134	2134	1874	1	1	8408	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFJYKLMwib2zn84MWF3e6mWW4a7UNBjXM4tK3FfXkK3rbvj7u
49836	payment	2134	2134	1874	1	1	8409	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiLAHXSwob1pkr5FkMKSbmwPGS5wftGqzWgUg9z5i46zP9Dd5
49837	payment	2134	2134	1874	1	1	8410	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBGwGaje9dqHj9NrYFX17ZZye8oGLo75waARg8PHRzT9DpYSk
49838	payment	2134	2134	1874	1	1	8411	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuo3du1PMyY2hbMX1VxKdcjeB135jC4Q3wG5ykSnoW38PqLsm
49839	payment	2134	2134	1874	1	1	8412	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JNiFX8JKFymdDnPH6U6XuU5PGtdG3V1BEWGUMSrAtM6m455H
49840	payment	2133	2133	1874	1	1	7857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveetdNoFUHYy3nxRNZEU7m1jSYHeTGa7q716AAq8N81LWp9ix
49841	payment	2133	2133	1874	1	1	7858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjFGBLxKGCUhAXugiLsqvhjALiG2zj2hsc7hrQBAeSoYLnWCa
49842	payment	2133	2133	1874	1	1	7859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT2hbnUUS6nKheyvR8d5PwbfggeBG5BWmr7p7PSqKWFYTcL5W
49849	payment	1397	1397	1678	1	1	18125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrs7uAPWWm4cdYPvrpTw3fkFsAexTU12yLAoX14jdgKbPcnxT
49850	payment	2133	2133	1874	1	1	7863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQLRX5aVwmJzwXX26zaB2ymb6VjyodL9AGSymawehqKLS9TSs
49851	payment	2132	2132	1874	1	1	2150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj84jA85maxVdrVHcUSXjq4wruGw8EBnx8kdBMfiwzvTg81hus
49852	payment	2133	2133	1874	1	1	7864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW5ncK3QVgrn6ftS49VVW2uVq78yoZFZ9dZu2m6pky1ZcRFKF
49853	payment	2133	2133	1874	1	1	7865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYXsF5c191VToQdj9xRSBy7xLyMd6iK81fd8QF3NxG8dNX9FQ
49854	payment	1397	1397	1678	1	1	18126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJe1e48gPPCtZa7HSXPcfZE2xaqyySn3J7adTrzvZnSbVxgxQ
49855	payment	2132	2132	1874	1	1	2151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7yDKtfnf7gE2aFeT9A7oXjoumva7hSEsWoPhktZsc2oi6GhW
49856	payment	2132	2132	1874	1	1	2152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiAhYGWpUr6HWLYSxRKqksGTrGtCjrUzifiviud7TJJmJYGxX
49857	payment	2133	2133	1874	1	1	7866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccdMnWckcBW9tUH8UGWNz1mArTYRhUnF7F4ZxDSSCxeqzyzPS
49858	payment	2133	2133	1874	1	1	7867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vhS4HaFCe5urJ6Do9a88hiYPGnDu8G4QUvFpZJQEXcknd4EF
49867	payment	1397	1397	1678	1	1	18128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAppBauSrvL9Qk7DLsTJER7qC5TGdiBdL7zpbdGkAkhh5i7gd
49868	payment	1397	1397	1678	1	1	18129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpCia7go6eGVsLCU4gHnZzTYyR9nsyEk9y66e2BwsVq3yi1PM
49869	payment	2132	2132	1874	1	1	2154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeJXdUbm1MQeB6oVsui9W8aHrbfrbQkgR899eTTFbS2YuZ79Z
49870	payment	2132	2132	1874	1	1	2155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69sDXS71qvazeVb3mXJLcknnSv3wpwXPQod1Ei5f24MR9mD9E
49871	payment	2132	2132	1874	1	1	2156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1pSZCXjMEXDVyEGX5SXuQcWkvxEBuGHRRB7bjhbNtpifU6ux
49872	payment	2134	2134	1874	1	1	8416	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJP78CMtWJaqd7zwhHePJeNVL8zUpxAjdceN5xmhcsEEQa2d3o
49873	payment	2134	2134	1874	1	1	8417	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahk2sLz6YusTKanmSBkUfduRg3Q2gUxhN1f1EbackcZxrEU6b
49874	payment	2134	2134	1874	1	1	8418	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw38NxYex6qnUEUiyMZ8XR7UPq3SNNbawGE1nnFepe8mLQ2BDL
49859	payment	1397	1397	1678	1	1	18127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSmzBqo7SSxKLLsK9M1t6CTuwxx3j6n68mk2W1gPmvnVEZTmx
49860	payment	2133	2133	1874	1	1	7868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSPF544yRdrVUR6MjVUUZ8yzuXmDNR5PXr5F8zHtxTdb1ieir
49861	payment	2134	2134	1874	1	1	8413	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNCPTecDMdYHeAC3VZhw7eh3jNTH3dKUuHqJjqDL8NFDMSsNu
49862	payment	2132	2132	1874	1	1	2153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2WoHq1uEaXdzeZDDwawa5BqW3feTQZefm7LzFYcTGzvA24Vz
49863	payment	2134	2134	1874	1	1	8414	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJBAqshEqkLMHwyKJjHHYR6AhdYFC86r5rRtRDs8fYpodD6t1
49864	payment	2133	2133	1874	1	1	7869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUJ6wSLFCjGU9AKVx187bYvggDhQooqNNc8jGHnfnoj6BRyVS
49865	payment	2133	2133	1874	1	1	7870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTnBAHK4xiA8v3m9zjVgnJqSvnc3CNsKfSoJX1u7RwRKhtD29G
49866	payment	2134	2134	1874	1	1	8415	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhbU5XvVuN5un4wPQppfMRQwBaebCmz2houYRUbsECgAYXc3h
49890	payment	1397	1397	1678	1	1	18130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqRzjZUhqWoaHoaqsXuBRSk8RpeHqM1YNcfJViixchfw6q7DA
49891	payment	2134	2134	1874	1	1	8428	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX585xKPVN8RdVsvQ1UsoCnNnLniQon7aKYEwfcrYeYQVa7HU
49892	payment	2132	2132	1874	1	1	2157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7so9wNSxXrddgNgPNSGLdzQuu5iuSFqvjyL1tDBPKrMoPm8w
49893	payment	2132	2132	1874	1	1	2158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rUV78EGiDcijbDXbwDLCu3Z5E9jTtRSYnsD8fDjSmiT6pz6A
49894	payment	2132	2132	1874	1	1	2159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy45s4NStL6rkLomD3ftRfZFAFn2MeJfGLvtdDTGPWthBb4oN
49895	payment	2132	2132	1874	1	1	2160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmngrqtL94pqEq3DZJS4K4miN6WwGSJGpPqb3uEK1Jz7xR6Gf9
49896	payment	2132	2132	1874	1	1	2161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3weXfFy3ercmj8aJmSDeBcDkVYzbcawJYTzzKwg93NuF1kaox
49897	payment	2134	2134	1874	1	1	8429	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VDsCaLX8AJnQnY4c7spzhe5Der9yBHBUx1yYrGhYinxDsidk
49898	payment	2134	2134	1874	1	1	8430	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBKPfkHkUXCBWQ3Xzprz2dsJSCzfKQN1P7Yvg87P8ZXZi5Vyw
49899	payment	2134	2134	1874	1	1	8431	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8cNKUrU1MrMB8AJwuxWA5fNoiqDfJ45wrisrhFMa1GQYjLed
49900	payment	2134	2134	1874	1	1	8432	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZAZQjSG8tZJmKfnn5t623gAACTiEYKUSuVxWkfHzNfmsJ5gz
49901	payment	2134	2134	1874	1	1	8433	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kTm6maBrTLyci58ZE7q998acNyt94hUCwtdrbV2B6jokycre
49902	payment	2134	2134	1874	1	1	8434	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwpaxw5pwVAvZ3GmsF65urYhfXCZJnAztTUEbFeNerqyq9vvb
49903	payment	2134	2134	1874	1	1	8435	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQKzjacfdzZ5HV1y4wxp5JcA17Md9caKRASKx2CSPHBZZDnE3
49904	payment	2134	2134	1874	1	1	8436	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LnLAzcqqbmbXF1noporndf3uitdGYghtdGq4gqiaY2teezrz
49905	payment	2134	2134	1874	1	1	8437	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLtgZXKgo3gEc6pfwmrunUTi8Xhaw2UrQL7zfm7fANgirNa1F
49906	payment	2134	2134	1874	1	1	8438	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYxUDXsCdCx4iyWRVPtfZn85DasoH7pqaYCBRQGgGrXwoZcZe
49907	payment	2134	2134	1874	1	1	8439	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYHcJSN4geVz8CDcwV9AL4Y7M1Fy71boHgwdp1mcK517nDdhj
49908	payment	2134	2134	1874	1	1	8440	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMiXEP23Z73SBF4FUBbDX2jYgoJZTvD4r2jWCPGrCSRZbPbYA
49909	payment	2133	2133	1874	1	1	7877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68f6wGAbFw6oJ4cVgXJEVhGeXYsXBCHGXpkfFifzZd7ph993F
49910	payment	2133	2133	1874	1	1	7878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPnZnTCKFhcFeM8XhogRVirnG4fSe7k5UZLopuxTPxiM9mZnH
49911	payment	2133	2133	1874	1	1	7879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFc3HtBCW33PErBApkzbP6KhLMoCwEq1BKiuPZjWkLbMKAtzV
49912	payment	2133	2133	1874	1	1	7880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNBsva7WQkM9zai2rjDviYvHKiRf94ZwY3uCW3ukmtshDgAoE
49913	payment	2133	2133	1874	1	1	7881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7VTeqEDbHeNkaWDwEGaVnoQkCkjvW884w4cEiEXe59WGPo57
49914	payment	2133	2133	1874	1	1	7882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9Ss9NyAWxzzbsxuxfhWFYabTxeNsRyBHYfjG4eddymgJZsSm
49915	payment	2133	2133	1874	1	1	7883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVXU3cyzAysBGbxLxzXfb3cFNisz6tSVzNwj8h1c39TmEyDTB
49916	payment	2133	2133	1874	1	1	7884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44cBbf16FSqkPb8CkiGP5YqN5MZbNL72HDRq9xmsiUXTrASU7
50023	payment	2134	2134	1874	1	1	8490	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3grPPejxJhetLHaTEgPFgTmK31WxVubYwExoN8S5eLM5CRoS
50070	payment	1397	1397	1678	1	1	18142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uTG1pQzVdeD6rbygiKLzd5mpdS4L2zVBmgrfr6naTXeNpwG9
50071	payment	2132	2132	1874	1	1	2185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1jxatfTagAr2rZWt84x6pUWUNUZ2XRk7x9GYyx9pqqaMiPir
49875	payment	2134	2134	1874	1	1	8419	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9AZNB6SPdXrBuPDouoRF8Eh6HhmGzTinhjEtg5cc9CvZvZXp
49876	payment	2133	2133	1874	1	1	7871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73bMtf3CHKFzNLJhkcPFL2g3ddWbG75Y9hsWHtthFRiMkdQ9p
49877	payment	2133	2133	1874	1	1	7872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzCe8vnfBdy8QvWEh1YmDzRXDuymEiR9D6F24CavHiidssZr6
49878	payment	2133	2133	1874	1	1	7873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7eVFyxjGKUHQKQknfsbTtYNxLmhiPtHny7iWA7rstfBuWEYa
49879	payment	2134	2134	1874	1	1	8420	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXjCSyehBvJUCN8CvwwvUybVMHv47cmmAsJPeEyiRdpwdZkzX
49880	payment	2134	2134	1874	1	1	8421	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ4Cmp841DfxsQQJEJPMiFNHGcY1chzcHAdgLGgiRCWiXTa65
49881	payment	2134	2134	1874	1	1	8422	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrGYYMSWG9gsukQxuoz27hqSYpJUwwxDjA5323itgrjLS9g19
49882	payment	2134	2134	1874	1	1	8423	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96aKzm8ghekXHcT78CE6wRGdnv3ovqBcMS7QukVJkjm9gUfSc
49883	payment	2133	2133	1874	1	1	7874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDKqZRiyUJFqiQjhYe6mwfmK2DTsiC5qqNWQVHHDXb1GPAj3H
49884	payment	2133	2133	1874	1	1	7875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1cYYVKmwC8u72iiEhiKuZLJTWjsJdHwfJT9XjsDfJrwyZba6
49885	payment	2133	2133	1874	1	1	7876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BWtChhikuFmVHDJzr4vVvT1UrxiiBMGYdLSsAVhRtHNRNWHr
49886	payment	2134	2134	1874	1	1	8424	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHStvtN6AotVu29KanJL2xpxTEkmtdF2j8FFhrXyHGjgbLHMe
49887	payment	2134	2134	1874	1	1	8425	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTExyabDXF6fM83aRvErwJ2LVGVYqK8UBX8dt89tVcdJ4GCgv5
49888	payment	2134	2134	1874	1	1	8426	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVz5MnZ3nEmNxJRhk4niTbirbFSgMPE4onUx2mT5k9ZQgVNRT
49889	payment	2134	2134	1874	1	1	8427	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHDTJm9Vq1H4ZTTqK2ZCLiK5UUzoZQ64wabGvA8UCuktxdeV1
49926	payment	2132	2132	1874	1	1	2163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Sb3x6akAJ95pfk19ekAf56r9a1JUvBrpr5dYUusPjB15WmK
49927	payment	2134	2134	1874	1	1	8446	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZr7HpS4fFrcJHahnqSHhsTFJRBhsgMPkkFfuM1JZNVzsdF1dM
49928	payment	2134	2134	1874	1	1	8447	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1u4QKwSX3uCpxsJbsqrGg8vGqvhqw3iA84wanhAYSdoJuNqnm
49929	payment	2134	2134	1874	1	1	8448	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuHUjEG3172hAPFW4JJLQqdWXGmgXqUJKhivQR8rx3Wy7By3F
49930	payment	2134	2134	1874	1	1	8449	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaeG1vBXwoGpY6w1uBD7zJYnfgpEKXPJFWijmStR6g8noENBY
49931	payment	2132	2132	1874	1	1	2164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGRuuTHexfYLNRPJyUru6LyokZiMSr1MtfPHHuUWKGi6CQC3U
49932	payment	2133	2133	1874	1	1	7888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVsigoksAoKGEPaBWEUXCZFfx5oz2HuF56cmnvrqNbwvNkiG7
49933	payment	2133	2133	1874	1	1	7889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeaE41hekFB7vRFRNTbbdLpKJS4SgidvgAu4gUbLZsM2TTpJ2
49934	payment	2133	2133	1874	1	1	7890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeq1fmuVSmnwSVu2A7G3s49XtoHPY29QGNvDnWFTgxrJdekCri
49935	payment	2132	2132	1874	1	1	2165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiGp6PhfUAkiukGoXdYDvTga9nx2tzVsxRtFeWgqrtNTzbjG7
49936	payment	2132	2132	1874	1	1	2166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKFZ3nAL3SFrHXvQ3Cttbdo9ZmRxbmuijTtN4vzxAMascHzr1
49937	payment	2132	2132	1874	1	1	2167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5pWGNA8FW4wmqB81Deqrs98npx2CgXkuPDZGK5fR22sRufrx
49938	payment	2132	2132	1874	1	1	2168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KURbmsnzXc6EwMuvAbB5aJ1dfVYQNesmN69efL5kgp15gYRH
49939	payment	2133	2133	1874	1	1	7891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSAhaTPo9iy9RVtVjeeKWV8kTmL1GFZjRQu9S59HkwR3TCVZS
49940	payment	2133	2133	1874	1	1	7892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6K9XhwWj3QvN8Co7XtMj8G6aUwG9RM9Re6gVn5H5CrGCTTEBU
49941	payment	2133	2133	1874	1	1	7893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFktMmLLrQN7nyHKQ2LfeWbzUqWF6wkJHmd1VRXqqtH47FMwVh
49942	payment	2133	2133	1874	1	1	7894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc2RgbpRgJ5EcAPoopxmEcb4KAQKsjhRM9AgwPD8D2xG35bNQ
49943	payment	2133	2133	1874	1	1	7895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXv52cZnPpub1SNURZHSa1dQg3NsEitEydQvQTbLUM14nAu57
49944	payment	2133	2133	1874	1	1	7896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwj4GRxSifzixyx6CrAQ11epQpXbcAva9k11SdF4TYinGYzSmn
49945	payment	2133	2133	1874	1	1	7897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPcHQWwFsrvsSRzr6tmSVBfGm4zV1d6pqeTNWCQEiefhQGTnJ
49946	payment	2133	2133	1874	1	1	7898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs44dvPa61scK9QLCexoDsqcUA8wv6pFEpvS4SGNkdqjwqPNJN
49953	payment	1397	1397	1678	1	1	18132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtzrdMiFWQ9E17tGqPPkowmpBt898mbZCmzKwrjtLFwSoZbWM
49954	payment	2133	2133	1874	1	1	7902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGVErxCXMTB8earzHRgt4c5cADD5deNfijLtcpaxYgnEkxEdy
49951	payment	2133	2133	1874	1	1	7900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg972GiAXYT1zAcsjNRL8Uu1jyFcnHq7UgfXdbDNpGb4xCisuR
49952	payment	2133	2133	1874	1	1	7901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrF4wh3egizUjjSSuK2ErHMi96cqLbXS7tGp7rtbhzmgffpnhZ
50042	payment	1397	1397	1678	1	1	18139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSV71TDGyY47xtYrGyv3xh1i5uVJ1xJCs99aVFzL5xC2y9Uz3q
50043	payment	2134	2134	1874	1	1	8499	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwq2MynSUnfa11KVHXWwRyGDsCoisPjfRrxFWUiKWMNddsuQa
50044	payment	2134	2134	1874	1	1	8500	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJa8m7mcjkBMPdPnpSkEP6bRRktgK2sH2o1KcC3PVT9Aa9ZUs
50045	payment	2134	2134	1874	1	1	8501	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAmEEwqSeXJMPFy4mX8QwKkwzKSjabmh5EKmmNymUXGFpuzeR
50046	payment	2134	2134	1874	1	1	8502	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgbggycHiWvWmN4hBRVdZ8LWshYp4s5L6CBMG6Z9Ut6NXp3j8
50047	payment	2134	2134	1874	1	1	8503	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcBHrMpoM7pyHMJ4uGfCKgUeezznSXj8uWxiCaqJxFqkUb8e5
50048	payment	2133	2133	1874	1	1	7921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68QcpPbpHAyvw6LXyVTbbjUEA7eh26EcsbpQR5XWokawJEcm9
50049	payment	2133	2133	1874	1	1	7922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZjNJKVt8htScJXiW9uMWFyJMTmhvFAEA7enLdPAVocB2YBPg
50050	payment	2132	2132	1874	1	1	2181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZBoFV39P1947rBRbPkaEPpWxbtJEVD7y5doxGNcrd56FuV3R
50090	payment	1397	1397	1678	1	1	18144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKAYYgNVTxd8EBVBhA2geBuxEBMGm92mQJQSUaFVJkPMECRr
50091	payment	1397	1397	1678	1	1	18145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDpsndrfyiaL6hq9j5UyphciTvf64CJmAhBfAg4t14AqHV4Kd
50092	payment	2133	2133	1874	1	1	7934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZn14pM4Dz3z4aJMV6ufpTMryBqSELWTHLF9otUsYrVLHDaiN
50093	payment	2134	2134	1874	1	1	8522	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm8KRvB2f1B7sPABddUgiWjvVMxqv1EcHCDpa8Qf5Bd2vsFU4
50094	payment	2134	2134	1874	1	1	8523	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqeJxv4ctCgUxXFnbFpoZEBvEBHeMgiiBQjhBVc3THZoxprWj
50095	payment	2132	2132	1874	1	1	2188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz25hBMss4b9p1WP1DbDfJDsSWdyixUHp1BZ86dJgPHbHxYi7z
50096	payment	2132	2132	1874	1	1	2189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDr5siqS2JZga4jvjz751scP3xYgDjYRbuPYJ3vgU8PoLbGtU
50097	payment	2132	2132	1874	1	1	2190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZD52CypgzqXjucWdwa1YEk7KgjUdwMg7SxZE9rCUFhxg9feq
50098	payment	2134	2134	1874	1	1	8524	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67GzizGSTB4hSNx7mJo3DBGvpuqqa9EMJNK4kxnv5pkcy7CBj
50099	payment	2134	2134	1874	1	1	8525	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNc839xSXYGqw7EetW5c9MZU7Vjp2sYyytVu1woRrc3iM7vYC
50100	payment	2134	2134	1874	1	1	8526	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtdDk41cPyPiqEBXqgHAZcE2ycEhT8TMRj4MJz6SJWp2Qa9jm
50101	payment	2134	2134	1874	1	1	8527	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjEv4ywTCCLHuG71oPLqr3fsf8NoLHUQ4Q5eE4MYKRaELpb8H
50102	payment	2134	2134	1874	1	1	8528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvVqjJCkL2YNYHMFPmH4uzKRaLwsiYq6KNUhd5bqEoFPBRMz7
50103	payment	2134	2134	1874	1	1	8529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaie78DwvSfDHKkMoi5NTCrTqTNeztyf1hgtoUBLe5kzFrL8GQ
50104	payment	2134	2134	1874	1	1	8530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwu5EMXEBfi6LbgvVSgREBUcxQbTTBAgjRoNwd8W8kgQZUSci
50105	payment	2133	2133	1874	1	1	7935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrfiTwBxRTRW4SXDgCbcpDHVtuQSAkfCkXvcRsFERq5sUabrb
50106	payment	2133	2133	1874	1	1	7936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJhWQpFLbkr6A1pTfRUHrtEAeHkUzdRNGAzonq5Rf5fbhzP9z
50107	payment	2133	2133	1874	1	1	7937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTE8fo4m78tu3wvxtAnMLxnGyZEEDg5nGt21RQMr4pBmSB3x
50108	payment	2133	2133	1874	1	1	7938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF38ctFD34qgtdVZSNiYA4akwFvFAFZpBDXg5KBiAxNQnaNY6B
50148	payment	1397	1397	1678	1	1	18150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hMxgSK8ZPAdvKe6aZvkNWrfJPh7tgr4oSrpGTRh8yQJp1Lm4
50149	payment	2132	2132	1874	1	1	2197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZquxgU1NnegmVjKsEGSERJpw6ymvFyKQwdiCSCuou5PF8vDEeg
50150	payment	2132	2132	1874	1	1	2198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4K5ufhYs4dCPMf4KZfNVwesxWzb54TvMk5VzftXCvxCmeDfK
50151	payment	2134	2134	1874	1	1	8549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEx7WAMpLo3bGPNZYhmy5rwXUPpp4KBd9hB3zsB7DgpYtVAMM
50152	payment	2134	2134	1874	1	1	8550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAMP2PosaZ48oKBztyK7LPkGMURJTSjoPnKG6rGrnn4MLYiu3
50153	payment	2134	2134	1874	1	1	8551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukPrV32VmoaxRGboSw9eWd1daiMumxVkdpXnz72JNbnBeawjJ
50154	payment	2134	2134	1874	1	1	8552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUsK3gYW9kFA9qjvXyA78wwxA4cSeCxkRYzvLPMrBY2Ypm8xT
50187	payment	1397	1397	1678	1	1	18154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAT2WruomSVHgGkeREbkgPQuN7R1GRYtmy2JwwvwZpRwcpjLg
49955	payment	2132	2132	1874	1	1	2171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzrho7gXpbSnqNMwX1ryBRmDBeAFKWV84Pyy3ubooDqDshPs1
49956	payment	2133	2133	1874	1	1	7903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiw7GpD6DjtXzYK8BCLKQjBGjdoPyWmkraWxD9oMTxkm6A16uq
49957	payment	2133	2133	1874	1	1	7904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvzHwxqxeWgDtimAMoLgibu248kbZSYEDQoRz9nBdDR5UErHPL
50080	payment	1397	1397	1678	1	1	18143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhLf92QJWdKtpbCTw8XkRoTDb1XB8jpwUGhFHYFRotzAhp7KB
50081	payment	2133	2133	1874	1	1	7931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW1Ye4DGpA8eswf4dxxjpecEY4vBpqrHk4D8iEaCPaJBBtQDe
50082	payment	2133	2133	1874	1	1	7932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWDh1CwnxfkeXrNMmeMKpTCFUjaua2C9YGrXWqXTqxqqRt378
50083	payment	2133	2133	1874	1	1	7933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYN8a6cpdWK6TaF5eq5beX4xbZMLNburdF415xY9af9bH7Qfw
50084	payment	2134	2134	1874	1	1	8517	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQZvqyHJAwK7reThCmm3Fd6ERNYefttSxQmQAHVogVxRd6xge
50085	payment	2134	2134	1874	1	1	8518	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvid7XydA2BUoHWoqhuTurJDCQcMuxjQNqbbtZ1GAWNrtEgkY
50086	payment	2134	2134	1874	1	1	8519	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYgXMiVe51mb2c6UU97BR6vgq1qB8yPEv6Uf7gdzSXQa9t1HA
50087	payment	2134	2134	1874	1	1	8520	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebDriEZTHkKGq7aqxSyFuvn1Ln4QoR2C2theny1aeU97NYFxT
50088	payment	2132	2132	1874	1	1	2187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQkM35A1UQaxHFPb3PVi1bD2ZNdgbLqFDNjFaygTuQ164z3kq
50089	payment	2134	2134	1874	1	1	8521	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrgeWizEZvGgaePR34y4LTqhe6ZDtksnPmSM5jojwcgKyALcR
50246	payment	1397	1397	1678	1	1	18160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUxhNRKiQPHhq9RUkfaZVyTDi3ZbxLCqVPMxr1qQLv5WAHPyg
50247	payment	2133	2133	1874	1	1	7977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJnSs38wL5BbZtXU968FcT8SGrsJfujKoyyZw2ehUVGAG5TMz
50248	payment	2133	2133	1874	1	1	7978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa1HMmhwGotATXd526NuLsVW1KzEgiKnLPNQxd8c2wAcTd1oV
50249	payment	2134	2134	1874	1	1	8593	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaT6auZUty4iTeeZajV5u4X43HuirEDJRgdreDte4SMXXugBs
50250	payment	2134	2134	1874	1	1	8594	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwkuQzThWxzv4HgjGadM8EdcHNJbCfhsnuHBNPwsPVrpKzLEe
50251	payment	2134	2134	1874	1	1	8595	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchPGEfDudxBtUikEFExdtqcj4mxdoGHE4zBbP3QY2ZfYKKchv
50252	payment	2134	2134	1874	1	1	8596	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKUVupXzghxEZ3FTxCzUZtcEdKWcAudazebk4KoPm4XDzFG53
50253	payment	2132	2132	1874	1	1	2212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcBkggdmMjkGJaZNoziKwcv92VVus3hcTiQD1JSsH1ne38ss2
50254	payment	2133	2133	1874	1	1	7979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLde1CrytZjZmwRQSVCjn7zBmtPgKsYBZu6jjMykT3H8T4tFff
50286	payment	1397	1397	1678	1	1	18164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpXULiXfVxKCYMuWvNEsf3mUXapVdQ9snk7xcSnKJN1KGQgmf
50287	payment	2134	2134	1874	1	1	8611	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkfdUeRZnogWbuGtwzurnxC3ZcqfpFrfZe6PMHdJuzHQta8MQ
50288	payment	2133	2133	1874	1	1	7986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepvbRuyH3B7RNWECbB5zft84k9CEhRcRFMg51jpEh83csSxCt
50289	payment	2134	2134	1874	1	1	8612	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvrUahg2mUsgdHFtHGZRMEY4DzbryX3N6zt8ZdcJa5p539bnn
50290	payment	2134	2134	1874	1	1	8613	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ85GSocHp6WHHYPduqQ5rAtUprW6XFTLY3P4Snn5HTrbTxxFgP
50291	payment	2134	2134	1874	1	1	8614	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvqLcvf5RDUbmReFfr6mnhPEzr8JmHkaWkmBnmdAJBJ3ti8dr
50292	payment	2132	2132	1874	1	1	2218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n6Aet3RhDY3ZQ1MzSsikYVTFccj4kUXLjtkSsXtnCiksjoCU
50293	payment	2133	2133	1874	1	1	7987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMxUjHBntwXcrqUsV4aJYizyefg5Bo92Umn5UrUWvoqCdDsbA
50294	payment	2133	2133	1874	1	1	7988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDCB6mHDHSVhhToXTu9iy2ZkEoPbz3CCWC5RWNuR1fp67PZeS
50295	payment	1397	1397	1678	1	1	18165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDLgCx3sNAg63uiHGZZAmscBuqWHVCqXdpqmAiH7B7bniTM43
50296	payment	2132	2132	1874	1	1	2219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU647ZCG3X8eTqNXzwYSC3fevEoFL2Wbuh5KpKs64tFco9EJMg
50297	payment	2133	2133	1874	1	1	7989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbfGB5ofvGsXRqYrVj9qQWEgit7gabLtVtdvSzZDsTC6PLd7s
50298	payment	2133	2133	1874	1	1	7990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLSk5VLaFQfRR6HEzRux1zLuAduPzxe7RxLm58nYQaUX1sxXf
50299	payment	2418	2418	2418	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogzrGnbvFsCs9TNMJv93hdrwJLk3dsp5HMYyiR3GLQmj2BXU5
50300	payment	2132	2132	1874	1	1	2220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHYW9juTisnCDJgmieSCrWEtBioeaEYwo41F98E5hmh6kcPJi
50301	payment	2134	2134	1874	1	1	8615	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xUNYKEmcGXR3LNDu5u3acCNbvXdccVjXeetc2fWfthb6v69d
49974	payment	2134	2134	1874	1	1	8457	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKRf1R3kCdfSHb12NLBXo6kkUUqDsqcQUfJDSxxQjHuWERgZL
49975	payment	2134	2134	1874	1	1	8458	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrr9QCDovwxnADP9bF7S5ySkxVbF4KpvtXLfUrAphayS2oQFE
49976	payment	2134	2134	1874	1	1	8459	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZhFWs5h8Pj8n1UcGuk65y85ZuvJPEBgXE99Txb1H5btVCgaV
49977	payment	2134	2134	1874	1	1	8460	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPiDHErymTF2865XXrZseM8LxWGYwHokobsRx6jdAG5zTrPug
49978	payment	2134	2134	1874	1	1	8461	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSj3JaLc9rtx1rrYVqG2ieNaFUfVoiD2U3aZ7m9sksvxwMnjJ
49979	payment	2134	2134	1874	1	1	8462	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9knWt4MBqBCxsxGccngCC2YYN13Cu5c9sJi6euWtPn12tj7Cv
49980	payment	2134	2134	1874	1	1	8463	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3badSCxKNqa15GbRckqrf1QuxKLFxQMEuvwCc8NiGXs7so6Ak
49981	payment	2134	2134	1874	1	1	8464	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVGhm7zFLwhFGZtwQqwi2Y58YyCKEF5PvNERXA2hMfqUngNbi
49982	payment	2134	2134	1874	1	1	8465	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmrno5Vkez6r5P1hJXtBVQmcGjtNn7qhpiz5YMrm4JDVYd4qs
49983	payment	2134	2134	1874	1	1	8466	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJdnL9bXXH5Gc8WoNj1RuH2cg5k6EkyrQtBrnwjqz2SbR25n6
49984	payment	2134	2134	1874	1	1	8467	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaeLZYfCRgoDqqo4UpieFTmGEehXkewXaLG3Fh4fzuHqbE81EJ
49985	payment	2134	2134	1874	1	1	8468	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLkMBq21L1w1KmnW28ytZPyGTT4pQaMmc9LH419MrtC8hBQ2U
49986	payment	2133	2133	1874	1	1	7909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaETnsmF5kUeDue6YojRKaLgizrnE7NzQLjv8idQZ8AMPytYGZW
49987	payment	2134	2134	1874	1	1	8469	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ91mrQ1osmCjPTjXvo26M3ou3fytsc8JpZgvKjWWLRcWCkLQ
49988	payment	2134	2134	1874	1	1	8470	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTJBEzgJNJNXrZ7LFG5twAso9Bz9HjBX2uJuaAD7bjWTMLDYq
49989	payment	2134	2134	1874	1	1	8471	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4S7u1dHhdz9uD4FzhP5366x3y38PEqQHbTbANGwXcZ7rjzmT
49990	payment	2134	2134	1874	1	1	8472	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt42xMemvaDn574NwTQK7YPxRz3YZZnebfZtDzukbgjuKohoqj
49991	payment	2134	2134	1874	1	1	8473	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8DAqzg8n65Zt3ERYYE1k4owuQdeLtyAZjVSo9P95awtCYcZ7
49992	payment	2134	2134	1874	1	1	8474	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSCpWTofxfrhMmpofpA3KHKsS59b9ZhSatWJYjaQatREk1HVh
49993	payment	2134	2134	1874	1	1	8475	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WLHEL22KShht15SCGpW7B9Nc2azno7eSpr1BhtNKyZCyShgc
49994	payment	2134	2134	1874	1	1	8476	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5ZsdfdKxL8PgFFi7haCUjtqVTFQrLW49pzM4vdi59iDS8rQH
49995	payment	2134	2134	1874	1	1	8477	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFjuCMmh9nSFjBCPmgR31tznoReHK1eUwv22MD7vFFNzdzpAK
49996	payment	2134	2134	1874	1	1	8478	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9MgXUXWQpEHoTgU5XAWayXaJGajFsoQd7b2j66kr1R1PPbNp
49997	payment	2134	2134	1874	1	1	8479	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRpR9YKmGx8pd7bT2M74ANdKVydCV1Q8JLjv9PvmE2Ai3swxa
49998	payment	2134	2134	1874	1	1	8480	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjzPGteWKjx8vah99376ZKXnZv8xbdom2eMDXn2uDs9cBMG6r
49999	payment	2134	2134	1874	1	1	8481	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNeajDJf4gvsVQQYWDWmWYcyYjKBFHFUUHtCEdF3gsG2qweet
50000	payment	1397	1397	1678	1	1	18135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa28DWH3XTF13HZZ2r6dBG5AkVi7N4dKUcjueQB3cecafCw4qy
50001	payment	2134	2134	1874	1	1	8482	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMPE7EnbCCAVmimPt5bB5jm6ouuiWU8WxbNJxzipto7v4sgaN
50002	payment	2134	2134	1874	1	1	8483	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Ed1eNqoqtyWPsrAtGTPThuCjMFtpS9mHgM6XxuRYHbgBzAz
50003	payment	2134	2134	1874	1	1	8484	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3rHMM5x1CVEtmeAHsMBTiXdw1h2wP381KzNDv6HGkjUQni7N
50004	payment	2134	2134	1874	1	1	8485	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGPtmbJgbJPS4qPYLicyMk4vYRW72q3N2GDTsxaQouk6ygPmq
50005	payment	2132	2132	1874	1	1	2175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUoXc3xVgJ2v6ns16vGguLBD592cynMkGz1J4HJvyDtpcSndF
50006	payment	2133	2133	1874	1	1	7910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3WZbBbneu9kXdf4Hzxb9cqTCE4jqYvBg7kcRUxzaChZtDVEE
50007	payment	2133	2133	1874	1	1	7911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgC6FjZRKf38KxjSQRMhQVb3d6JXGhBVSP7GfQzvCMnW3gsKG
50008	payment	2133	2133	1874	1	1	7912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZyy1shyNbyY3QQ71VH4F82VMBVKJJgPxGCqdPiAwFrefyN5J
50009	payment	10	10	2314	1	1	3	43000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddNJCxqBTgATRqrgRxqFbVX6r8hGpEqvxFtqi4wPNSUnR7jPZ
50010	payment	301	301	2314	1	1	4	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndQpc8tB7woFB2AiZT6Q2rV63gssFQWLRGHWbiGx8oXnzkGZ2
50011	payment	283	283	2314	1	1	3	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLTNaYUqRwppKM3Dt1NJvME9eKKMswK6yCNEgdz85NXtJma3v
50012	payment	1397	1397	1678	1	1	18136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHqQ7rW862jVB1APm8Gs4MSDx1AVz2vQ3TnTv7dMKT5wL6LZS
50013	payment	114	114	2314	1	1	13	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGm81qfREjXbM6qzdj6xka8vDBQvPA6ZNtbcaLvVazHSqHMacq
50014	payment	2134	2134	1874	1	1	8486	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGXikTFsQZE7cMTSx4ah6518yXNRZymci7sr7xcfrxDivUJBt
50015	payment	2134	2134	1874	1	1	8487	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxk4yYSJoagyDLHdHnfyraJez2deH7mkPHyChDADpeT2fY13m
50016	payment	2133	2133	1874	1	1	7913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYfEmvP1cyxcSRdUEgM58iWEpH3ZjBHTBcusuQYFLFUDdFb5z
50017	payment	2133	2133	1874	1	1	7914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2w6GB1fVij5mLFs4YhvggVp7JKNZxeiEbucJAnnyDNT3FkQuD
50018	payment	2133	2133	1874	1	1	7915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozJ6T2b1agkWvZ4utsCowyVqo2Xk3SM8NQ5hyN62Hwfex2ggB
50019	payment	2132	2132	1874	1	1	2176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nNjxaT4SGGcuJSySdrG1fKTakdvzgiL3YLCC3GHR9AFCjC98
50020	payment	2134	2134	1874	1	1	8488	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FVsN1FSisWvpQw4m2wXFzAvdc9x7Rpjoe3HXG9abY1jAYpXU
50021	payment	2134	2134	1874	1	1	8489	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8KdDvcan95JnDVoPh9kwoc2VEfiEHHYgdzcXap6KCEd5xG3V
50022	payment	2132	2132	1874	1	1	2177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7cEa92YViAUHsWX1F2eKZzCqA2SEB2ktZ52DMZk19sPg5ybN
50024	payment	1397	1397	1678	1	1	18137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbraTgcUhGwGA9qyWxenCYSmvGpZMvZgNL3iVwM1LwJoAnytVg
50025	payment	1397	1397	1678	1	1	18138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSSw8k26s8aNT6Kak3oAmJVWpehe5rdd3j9AuCDv4icLxfCbr
50026	payment	2132	2132	1874	1	1	2178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxn4bnC75QrvkB2NLi3aqCa2DYqZEYJYwLRNu8bRLKJVeCYnDy
50027	payment	2132	2132	1874	1	1	2179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU84WapNEZyF6dom1mXxF7snRwq9SFcShhsCMCbppxJb4mRGDU
50028	payment	2132	2132	1874	1	1	2180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxt3aspDEJdpvRMEb2monsJmPKbDqAZ7CZFsTb6Jkv3T29jyCZ
50029	payment	2134	2134	1874	1	1	8491	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcAwMZysYHK1CK8DsmRwHrHcpgfjMFWoYDDXxEKyeBHAPn4Sp
50030	payment	2134	2134	1874	1	1	8492	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPeNSibf7ioqEfNZZaEWzSf1dAEUH56fnbQobKCfQvBfsy9nP
50031	payment	2133	2133	1874	1	1	7916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPFBz9ov5QrL6JK5VXRgMeS2KDC9VwSP5ymkBpSb4vHvUYrqw
50032	payment	2133	2133	1874	1	1	7917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftCBdZL14d3a8UGx6smjwER7YmYJtzZwLyjbUzd96N5XDuGiY
50033	payment	2134	2134	1874	1	1	8493	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34RuCBpQohafppYJiBizekCHEvPbTcdjW43WgusjfZDrc2fgY
50034	payment	2134	2134	1874	1	1	8494	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7WzMcGMa2ft8ePJad2j5GMTFswksncTouGuHstGf1YXBUMvw
50035	payment	2134	2134	1874	1	1	8495	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyH4tPwsESzXApGjqbX2ssSChok2M1sr4KjQAjYAmzkH7v27N
50036	payment	2134	2134	1874	1	1	8496	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtEVq1Ufx1gR35t5epd3kVe2RHayzWAfadhfv4QHp2LGxcvNe
50037	payment	2134	2134	1874	1	1	8497	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQ6fCHajsEbMM6w3R21ggL1BiZKF42uNgfbCZB7upaiyK7Jh1
50038	payment	2134	2134	1874	1	1	8498	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AjnontKXRa5ExUTSr21t6v9679tyQnFjEbX82G1Znc6VcEmd
50039	payment	2133	2133	1874	1	1	7918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2PYynrXvgEzBHXFoY6V1MW2ytohRYqFUXi4rMxUF8AYBphTP
50040	payment	2133	2133	1874	1	1	7919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBhDRF9maYkqeTEtGTegYxB3dCGQvUVuhUDgcJiMpKVthDHpr
50041	payment	2133	2133	1874	1	1	7920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNxNMF5u8j1iNXknoCgGjQgqLPxpz176ZruYjxKaN8pwNpr3Z
50051	payment	1397	1397	1678	1	1	18140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjxQwkHMGHy6tnTuyva1L5GXH5gN9M8NWCgombqvsijft6f4F
50052	payment	2133	2133	1874	1	1	7923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrWwYgfZpdznZmGM8mMpbvSb5tu53pZxfUQVvccTmdoyVwNFP
50053	payment	2133	2133	1874	1	1	7924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSyd2FaRyZQmoojtU21oAeNAAnceiwj2b3YyfT7dzZ2jwiGYe
50054	payment	2133	2133	1874	1	1	7925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxHgzLAQSWtcrUp1boeKMkXPBDQw2h6iRjiWkHJ8zfR3GhWcc
50055	payment	2132	2132	1874	1	1	2182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9N9WZV5uk8Q5vVgHiahdyGMzkcfzcPnGDYus8HdMS5jGSegj
50056	payment	2132	2132	1874	1	1	2183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6D8kSEMxqnWRsSgmgiCMqwg2zuwMZRPNMYeY6g1JHra1ukYKP
50057	payment	2134	2134	1874	1	1	8504	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jypH5Ev5Bk8HKjmHDZvptGEP7YJFx7qf7HMPW3ZQyyC6sSur
50058	payment	2134	2134	1874	1	1	8505	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g2wM9N9uSh2Z7sUFL6nvCqc1BN6MLLtzjzCQ62hwrxfACFiV
50059	payment	2134	2134	1874	1	1	8506	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVH3YgNUnCtQ7oUPFgxqjXjPjmicjrQZ3bjjQrQN7fru7XVCK8
50060	payment	2134	2134	1874	1	1	8507	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb38VaJaCGKrFy2s2r1C9bbii5FyUeMR6Ptp5cw6mxahyAzkUt
50061	payment	1397	1397	1678	1	1	18141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnas4sz8yYKzBmpW1tRigAbcFScsJev357rqrwxKbHzz82KPE
50062	payment	2133	2133	1874	1	1	7926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqf1MFUq5oYK9kJNhramRqtdGNEbL1QRkTg6Zygz77omdzd4x
50063	payment	2134	2134	1874	1	1	8508	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ZWzJJmAjrvjfWxCrx81JJ1dd7vuiCtFU717QB9fSgnMtG4g
50064	payment	2133	2133	1874	1	1	7927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLrFc43RAo8wCs8ASGHDzkRLL9PsQgv4LvYVG1dCwby3qMBAt
50065	payment	2132	2132	1874	1	1	2184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEqF7Ruc39qsWo3NY9BeShcr3ie2np2hFvbEJqskNc9utGojy
50066	payment	2134	2134	1874	1	1	8509	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvdXj4hs3AJPgTWquuSXyxJk7XRAqfPmQ9twkPy26dub8kgrz
50067	payment	2134	2134	1874	1	1	8510	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVocHAX2mXqjy1p6QgDFvzBPoqd66LMD36H1UqSb3YA5oRDqqG
50068	payment	2134	2134	1874	1	1	8511	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yqLp1Zv9t5t5AcTvupHfFBn8QeEroz5qrYUu4nHpswHZBAfJ
50069	payment	2134	2134	1874	1	1	8512	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hxEkhwkduvvK9oVDAKfrrCH2PhyZFYXwWRTsmsiPTJfxENQf
50118	payment	2314	2314	1950	1	1	5	387000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1uQwAqvMvFih5gMqqr9ewHAw1j8cTeJz9Ax6KvXjhQoPPBU8
50119	payment	1397	1397	1678	1	1	18147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEjdeV521ZEtsEqzWVpAqNkTb5S1vPPML5X9UF7JkQ48y9rAa
50120	payment	2133	2133	1874	1	1	7941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj7MoGb3B685ZKNiPVFuLRmh1ZsHTC2k22UHQ7KS9Zc7UXP2r
50121	payment	2133	2133	1874	1	1	7942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3isyiFFnHCyE6cJUekEGKMVrKgcCqymD4CdL5jWw8fCqaqAdS
50122	payment	2132	2132	1874	1	1	2193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhGrYFT53jdUudJcef1A5qRByhkhxDUD3StgyBeY6AXeM2rU2
50123	payment	2134	2134	1874	1	1	8535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sZSHAt27ZtiDkdwU7F7yyKDeVibHeo8D6GGGhJyvwtZEpYNn
50124	payment	2134	2134	1874	1	1	8536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnB6ahmdG9ToLnEHnzvQbKVDqhWuoEVcRxRNHXGjUMkG8ZY1aK
50125	payment	2134	2134	1874	1	1	8537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWagec6wH7npYvUs54PXq3mD7tB8T875TUy2X4AGWsup8Bivo
50126	payment	2134	2134	1874	1	1	8538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCRppuoweAyFpjCbqEqrqb2PCdiWJ1J8LTgfBG27iJT88VYHY
50127	payment	2134	2134	1874	1	1	8539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWnU2i8tES3Nr4EMaNHHxuipWVTsNiDFCS29CSBhYivgmVQFz
50158	payment	689	689	1876	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWhwg6eGULSE9wSUPqNje6nxjzEh2hYggMDBdpADPevXYccSa
50159	payment	1397	1397	1678	1	1	18151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6YeLKcGdpjXzzJ4bWikh7xtWtQyMbWXtBHYsfRA2RtVxeNz5
50160	payment	1397	1397	1678	1	1	18152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQKEyYHYomRWkJUcPzuthgZeupMzsbMzdvaiboV372hELjXGC
50161	payment	2132	2132	1874	1	1	2199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcvtscUEttVnBqmJg2SutfeqrKFVMCcPMK7uMcoNHChYf4wrs
50162	payment	2134	2134	1874	1	1	8553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj7VKTjhL1X4SFoRze1vhtp8uWx89dtYvkfJQoq5Pi7KUzJFu
50163	payment	2134	2134	1874	1	1	8554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDT7NLpubnsbvRgR7BJN2CQLTx73CeYc47dGZsPqptpNVrvT6
50164	payment	2134	2134	1874	1	1	8555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuanswCD3kBJ2bcwZ1g8NW15QuSKHerSRq7GoQvrDyTJYucSZ
50165	payment	2134	2134	1874	1	1	8556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL23zg3r8rCMkh7wcpod2QiHMuqYPTecW35DjQ9VfaAZgnJ26R
50166	payment	2132	2132	1874	1	1	2200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rqScY8ZPwQ4WpcDndornHrJj5iPrY5tyM6PtbV4WHLr3Fv3H
50167	payment	2134	2134	1874	1	1	8557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfWHo936XvFJKrt9dmY5jTaQW99jPZVQxA81PWJxA8TT4koW7
50168	payment	2134	2134	1874	1	1	8558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEXZYgEMK1dL4i3i18erAbZequXHZqBRDYv7weNrAdMJXpdBE
50169	payment	2134	2134	1874	1	1	8559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWw8EZUdUzBgW5sQn4aJSBpoG7eAtGk2qV8KGaN6bLxjDSZ6Qn
50170	payment	2134	2134	1874	1	1	8560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU269HmLYxaCGYL9WAs8NjKe8MUU2qEyUajKDSjSLYL8cRybea
50171	payment	2134	2134	1874	1	1	8561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouyvRDZ7ZoJEc5rto4qfThcsRvQMeGLqTTFnuCwtNrUBKwRMo
50172	payment	2133	2133	1874	1	1	7952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsm9LHd4kvqoFnRWNEDQX9i3dUGp4n3Siy91SDM7ox1nHAAta
50173	payment	2133	2133	1874	1	1	7953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfAKiRWJ7CFeR8ZGFQ395A1AzYcgqboWT1eZaUHe5Nj7V7R6M
50174	payment	2133	2133	1874	1	1	7954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvbxf2a663QwVa1zMro69w5x26gWBkcxwak2LqyzKCVubEA27
50175	payment	2133	2133	1874	1	1	7955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PkkbwzvrgTTLnmHxTGLxWwzLJQAgQvZ7K9ufUn4eHh49PQd4
50072	payment	2134	2134	1874	1	1	8513	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEyNR2jSMo2GksEGowyp74p5PerFD6GLiGusMToXmnaNqeQNN
50073	payment	2133	2133	1874	1	1	7928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUewSn5LUrW9vhQJbEk9uzy4SzEveiyRikmTVXMRxefW2v3Hmp
50074	payment	2133	2133	1874	1	1	7929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaGmcjQfu9R4BwG5ceKmP83vhTAQyS2ucUaaF2KGyMb4n8RBZ
50075	payment	2133	2133	1874	1	1	7930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ325M9ysevcq4RGevoLr3cLzxmHiWZXY3JT3ses3ytgvcC2VR6
50076	payment	2132	2132	1874	1	1	2186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrqpNE2N8bCLU91NB4tcNJDR8T8c7WRfYybeFgE5auwAqkGJK
50077	payment	2134	2134	1874	1	1	8514	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1ptyGKzPrcc9Mqzt93R8H6VzezbKUW8aoohhRQUD6j5wEnWp
50078	payment	2134	2134	1874	1	1	8515	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCRoX4QhQ9j6G2bNS3MNMBfZ8eZAwi6D29XkXMYNrmwyMWRms
50079	payment	2134	2134	1874	1	1	8516	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqfYudJpL7omiNcPPJPSmsd98Bo2NhkXt9X3N9crwp2Ld5DPA
50109	payment	1397	1397	1678	1	1	18146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNReXhrdbvkYCGXLdSNFw4LMMM23FXDMMJVnD7BNzKA5K7aib
50110	payment	2134	2134	1874	1	1	8531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTqU4YsDPeuSp8edcLh9NPgvTeLCYVhGce52zzTjH3vmh6bfY
50111	payment	2134	2134	1874	1	1	8532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XgaKD17EEDfJadgqfMB1KnzW3sp3ukSzCMovUKcGqkY4x2rv
50112	payment	2132	2132	1874	1	1	2191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h1EoWiDbmwHLHLFLbTk2y4WXxUU2aT2AhmnB13cjKWjKzUkP
50113	payment	2132	2132	1874	1	1	2192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfMTkYqBbo3pAgzoLrmJuGWkSm1o7Fq6bB5hZHkMQ5FkFYGzq
50114	payment	2133	2133	1874	1	1	7939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVAnjk96r47ArxgVdnMVg1wYRt9M2vE6ihzCSsoqMM7x87NiJ
50115	payment	2133	2133	1874	1	1	7940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBP5bXDWtXB5QSYJyfDd29HUyTZBuWGjh3etBRJQhHBhMYGHk
50116	payment	2134	2134	1874	1	1	8533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajiE6gn4ya2esYUUtvVNz4fknLiXeaovJu98zhVMXJQ1iTEL
50117	payment	2134	2134	1874	1	1	8534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZqCsmYg3BvcmHg9L13FNYHyPuPtnBapSzNtqxfRx466MNAG6
50128	payment	1397	1397	1678	1	1	18148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiR77qgou7gwDARiFvstQCrMAZVdbcvMjge9zPdh7vkSQpHnUu
50129	payment	1397	1397	1678	1	1	18149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkvoUTL9x3g88b2Vn5xyy7yHEUWTYPyFhAKMpF15Rky3SW5gA
50130	payment	2132	2132	1874	1	1	2194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJ2djXK4A8bXf37CbUcMe4PznB9cNKzfjN6wixpaRBAiZvLJ6
50131	payment	2133	2133	1874	1	1	7943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKiFb5qNpwdKHZU7Nm3rxoqsNAestdg2PoDNcLrHobF694yEA
50132	payment	2132	2132	1874	1	1	2195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6JisZfNEdyDPQhdsZ25rxTHAihMxM4gcUfwjYRR5Z4c5na1xV
50133	payment	2132	2132	1874	1	1	2196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACbBrT1EiVbiRYWhsb5UTtQ6ABjXBi3w4tzUge8Ronf3yMVDw
50134	payment	2134	2134	1874	1	1	8540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtW8CEovkngu2cMQFHYem2JTurk64bQMKn5xfhHR2kWY58X4T
50135	payment	2134	2134	1874	1	1	8541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNkRUEdigLzSFLYpLgrAtPAStadc255P66vEpSTmnv5AUpLTz
50136	payment	2133	2133	1874	1	1	7944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFAzWBgTtL47vvJSiEsPqkxKKy5fAsFnYVJZZLwzPTH4YCcSa
50137	payment	2134	2134	1874	1	1	8542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk1Lq6yDDAC5q48CDjvJ1ysju2LyVE4pEX8MnfGyH6rjw49MS
50138	payment	2134	2134	1874	1	1	8543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f5Rkf3bLtsknNAPHSBmEW1XhA51PxwdNC3RnY4gFPFBWGZXt
50139	payment	2134	2134	1874	1	1	8544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9k9fYstD2FjHP3vBtFuPKjh4PqWnTR933siRR9bUvZGUnyZk
50140	payment	2134	2134	1874	1	1	8545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUoxQGcPG2MWa5SakQhygbM4pSiuBSfGCzk2AVigT6sNPVrjF4
50141	payment	2133	2133	1874	1	1	7945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EXGdDA8HaEwT29CWv1SKxFiS7C8ERBKt5RXp7PAe74tdtdmi
50142	payment	2133	2133	1874	1	1	7946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQxRBsPFL4eirSvnBVYaqyynoExEzC796XoL4kCnkgjmN39vg
50143	payment	2133	2133	1874	1	1	7947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PpBuX7DZRCGpR8pf2v3933UaifeFWJyLRTpgY5PEkoZ2AiiY
50144	payment	2133	2133	1874	1	1	7948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSkaCY8S2WN6KwsVJY8uxXShUbER7dzUeezyMoXkV572aQu8g
50145	payment	2134	2134	1874	1	1	8546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3bDu8GqMw8DcdCWMQnfbRiZfYEgKCpDrgiWku1vyKGHzBKWk
50146	payment	2134	2134	1874	1	1	8547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoMMASiwaycsaekXVaij6ArqWstGAV7j55bk9K9V9jPi4HdAy
50147	payment	2134	2134	1874	1	1	8548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu33Qsvf7d4o4aDdy69waNdUfnUc9ysk8oNSXZmo77b6SK38EG
50155	payment	2133	2133	1874	1	1	7949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuPs4kCnWGbujR8bBM8NMLg5ciwP1d3CarUivTXi77xtwwLft
50156	payment	2133	2133	1874	1	1	7950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1izpFkJoZmPtCNNA9QykKUvJhU3oXWNxYhMFtPhsF2KYS1qzt
50157	payment	2133	2133	1874	1	1	7951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpyWMUPXwgdFeeFvoRB6NHeftEddBeqidMmF39F2tHVXYYhET
50315	payment	1397	1397	1678	1	1	18167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKvsBfBeV8GRcBnDnoU8yTymGWgtZjK4gE3bSnR8jnVte4Xv3
50316	payment	2133	2133	1874	1	1	7994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwXE8Ha1HNgMFbeVktkowfEZPsSJTLeHJWv4HMiD2DEqeGYEq
50317	payment	2134	2134	1874	1	1	8624	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLnic7k7XJxbGPRppQjiYQVuDdZ6cZKynZybJuahxdXbP1WZ4
50318	payment	2132	2132	1874	1	1	2222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKXoJcNCP9ZeAGNtQ9R3Q6cNEU2riTr8d8Jd5Yczsn3hzVp9r
50319	payment	2132	2132	1874	1	1	2223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTpTEm3QAxjwgUNNMY6XXEJGbDQmZuuMDK9yDwHm2aEC8ZYwr
50320	payment	2133	2133	1874	1	1	7995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGDnuFGjSivFS4MHDHwdqBPnMZ3KCC5Ttz4DsV33pZFF7xKop
50321	payment	2134	2134	1874	1	1	8625	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFmTDdvgheNj5r65TfRRiavfPzTBKhaA7CNh7gjvHuLjoNbbM
50322	payment	2134	2134	1874	1	1	8626	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSaG2xsmbj2kNFP7TNB75oc58MuKKVK3kGNhZggjdwuW9hS9G
50323	payment	2134	2134	1874	1	1	8627	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4qfPk8eXhp6TTgtDWCtN8KnncvqRA8ceWBjZDQfC3XcEtTxK
50324	payment	2134	2134	1874	1	1	8628	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujMx8e4H19D9kswrJZrHKmkcWF6bQ2z1ynjXWPbLLxwzqQXkY
50352	payment	1397	1397	1678	1	1	18171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMecqU6Y3wkRgJWpHurSkNsVPcS74FF8aMZyu2GRw6ndNMbYag
50353	payment	2132	2132	1874	1	1	2228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcU52FawtLaGt2Pg5h385xVByH1neceCTybrLhjanwdFvArgQo
50354	payment	2133	2133	1874	1	1	8003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZ5YUWnmJLTdKGs1gV41Fa4wDDhigFXY97FhgoNRrHkNSyjtQ
50355	payment	2133	2133	1874	1	1	8004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU269YgTmcQp7ipLTC5EMBJ9j6FaiU9236JUJvAGGmDrBTHDSG
50356	payment	2134	2134	1874	1	1	8642	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ767vbvkjhxt6PrRbajBeenwPuSzXiLUttAb5ohDmUE8WgmS
50357	payment	2134	2134	1874	1	1	8643	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGXX9oc2uyTjxDt8jFVvLqCxZP5AJFf3hCZxDLxnB2KEiubsr
50358	payment	2134	2134	1874	1	1	8644	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxsseaG88CQwRn6xYjfFYnXtY1BbLR1syT5C6dGKMnqPhKAZ1
50359	payment	2134	2134	1874	1	1	8645	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5V69AAMAEswx1275YhpSFFhLQyX31j2qnucbmMpoqdKHXdT8p
50365	payment	2134	2134	1874	1	1	8646	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLsTuQeE5JpmiYoCUYapNmdNgSUwFUfuwn7RrAaYSfvUZwrjX
50366	payment	2133	2133	1874	1	1	8005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi1zWjTFviqrJszfUPBguFNdHJ2XtYQU9ZuxB8h5Tf4jGg5Ay
50367	payment	2133	2133	1874	1	1	8006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBBEifzUXo3v2GSJfChT2K3zFMVs4zFHQSrLgYGc3UyXeDJ11
50368	payment	2133	2133	1874	1	1	8007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbutuL6w8KPiqEZCBkh9aabciD59iNKmGcesWC6M4ui2trrHzm
50369	payment	2133	2133	1874	1	1	8008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmwhhouzHP4BqWB3NmSPAjspVbU9iQt7CqNFs5aaReW8Vfda2
50370	payment	2133	2133	1874	1	1	8009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZe7SksgtPPdHivVjnDtWFAitLCfzJSp8Twk3CQPqoBmrgbSw
50371	payment	2134	2134	1874	1	1	8647	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gTkcAsR2n1827jCMo4vN16GEgQqpm8zCW8ghvw5FybG9EsUd
50372	payment	2134	2134	1874	1	1	8648	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbNnfaHPc4J942vYXu2Q11m93UhmVey2Fwf6Q7ySWLN5GbimSA
50373	payment	2134	2134	1874	1	1	8649	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2ZedaJwSBRAvWrUWCdx6D7med3dLCBRAPPQygDaBf5DSUhNM
50374	payment	2134	2134	1874	1	1	8650	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TsJjmJcXfdHCiFgoZdQx2U98f93j1CpE1QMTqjrpLB5FTKpf
50375	payment	2134	2134	1874	1	1	8651	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QVN1znz4fyFxphpXEoE9KGJhUwywrAUZS8vfnhE7hT5yZ5FE
50376	payment	2134	2134	1874	1	1	8652	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa496WVGYnvFcrYuwmMcndcHDKWC2eBwtYxuV1ZPfmUj9hZdMD4
50377	payment	2134	2134	1874	1	1	8653	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSejKCb8zsFtGtbR1ev9vYrimzKSSREffTUCTcxeq7txJ5KpfR
50378	payment	2134	2134	1874	1	1	8654	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhZqPGVjx9YfEEhnxVUi6wCgyZAkpRRBu33kKG9XVmSTZzyMz
50432	payment	1397	1397	1678	1	1	18181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHsxBqBqUCkavajnQQcc92zNLqfvQF3pekLMgS5EKgWF3iGaz
50443	payment	1397	1397	1678	1	1	18183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKgqhZMFAFce3ogEFYYLmuhYCxbv3nMtiYKxNnp2BMaCoGeEU
50444	payment	2133	2133	1874	1	1	8034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmwm6Qdgbsp4gBa8HWVewzXS7s1b9FLxYpzrfkNzWKJQW365G
50445	payment	2133	2133	1874	1	1	8035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQ9TgHNipw8SKpL4hpWZFmMybxJ4LB5c8QMc7ckdrycVogRHx
50176	payment	2133	2133	1874	1	1	7956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYgySrvR5gqubMY1rWxX6vTvPRfZnix8d5AkRSKTvoxQu8kQ5
50177	payment	1397	1397	1678	1	1	18153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC6221pN8wF8wc8nTERZ6j5QfFr5ooWy9rv1jEa5GH2Kr5jcn
50178	payment	2133	2133	1874	1	1	7957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTgWHzCcvXBBoATNYDv82joZKthA82FTK2tYEApdrPDCjtNKF
50179	payment	2132	2132	1874	1	1	2201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyayA5NiHhDQzHr7Qc7rp1vCAhsEQQRhgUBQCCpkqqUPgNvzs
50180	payment	2132	2132	1874	1	1	2202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9yH2ee9uQaHebn3oDFQsXMHZhfQDsr3kgAMbaaCdRizCeMYx
50181	payment	2134	2134	1874	1	1	8562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJR1uiLrLc7xEG3daKuHJ9ntL7ZuqnxuUUK4jxRdCdcApDVkn
50182	payment	2134	2134	1874	1	1	8563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSn55BHUL3EK9END1BgtRYnaQzgS4wKmkLYQgM52U1SwGWDsmW
50183	payment	2134	2134	1874	1	1	8564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLmrwL6Ujkd65d88WfYHK5HvmAVvWRtT4TeskcLfz6azC8HyD
50184	payment	2134	2134	1874	1	1	8565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqdsNyBssHcRbDxZxf5BEavk2rTKUL56tRSxwPvzcmi752DBq7
50185	payment	2133	2133	1874	1	1	7958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2kT4SQq4wMNUp9w73amfea53Se7WFQzCiRGC6MkCJGaWgxZM
50186	payment	2133	2133	1874	1	1	7959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzskBYgJG9zqA5rGvHjrwzc4hhwYj5j51655vDyWa5XEAgce6P
50207	payment	1397	1397	1678	1	1	18156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpAKgx9a8CHJJZya9twhPhUNdnxNXzHArWYsTDBwoPC7Y8JMh
50208	payment	1397	1397	1678	1	1	18157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfZqRVieKDKg8KUAWaigpTdsaQYBENWwspYNTiTRRfhBtygzh
50209	payment	2133	2133	1874	1	1	7966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgz1KYse6ikp7yH6Dqx3RaYz9DtTRU9K7ngGuxrtBXKg3mPwWh
50210	payment	2133	2133	1874	1	1	7967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKxV7sMVik37CsBs3Dwq2CqCehA5BLEqMozDNq5xumo6bztXN
50211	payment	2133	2133	1874	1	1	7968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9LpXVWmFzWi8WFrrGpfRgVWQCCmZzw1cBV5qmi3ZfarGWYP4
50212	payment	2133	2133	1874	1	1	7969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUWERqwLxzS9e5B7a15y9hhS6i4zrCD9RaYaqWx1fnLAJ5uk5
50213	payment	2132	2132	1874	1	1	2206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHR54AAc3f2LSc13jrUxV9ZoF6HkakvnJ6LekhXMeJ72yiiTN
50214	payment	2132	2132	1874	1	1	2207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgsKZry61poBtH6pHzjbbUEy9oZbUbECQQStFBig9NgZXwQGm
50215	payment	2132	2132	1874	1	1	2208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6SwTvhRzbqXfwrYuuop3auiamr365ivHbdnQNMeSGkLYb4Lk
50216	payment	2133	2133	1874	1	1	7970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33g2YmAzQgy63b7iReUnUNTBGgNABCqFLcNnVxQgLSkhAt3UJ
50217	payment	2133	2133	1874	1	1	7971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWfiUtiAzKYTmGU75ocFxAHFn1mBBa5BeiNQ8jVA7k7uv1qsR
50218	payment	2134	2134	1874	1	1	8575	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9jvzF9T9dUkNLmkqm4pZuGBM7dKDZxzYwRDcCcdLiQbeiGuB
50219	payment	2134	2134	1874	1	1	8576	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9psH7gUrvvuxiwht86h8qqhDXR9JXUfRNL5qjiKeFmZJAavRJ
50220	payment	2134	2134	1874	1	1	8577	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSKCAZeFFAMVDnvc5dC3nXidMJtfmtFQiGthMtHqvJnEA8mWV
50221	payment	2134	2134	1874	1	1	8578	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1DujvBJa8ExaJq115gG2omfbrGgrMy5eZe6vec7oYT1fVU1M
50222	payment	2134	2134	1874	1	1	8579	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6zNuQwVBAq3oMRSQoRcTGYPHVU99djsNqgeHu5ysup2ZM4Zk
50223	payment	2134	2134	1874	1	1	8580	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYSy9tH4At1MicZdCFWtTE9NcaC6obpP1NrtPpfruJme5D6TT
50224	payment	2134	2134	1874	1	1	8581	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72TPXMHY9rvUT57vMGM1WKV9dPMdGu8TY9gSghzR7NieFRVh4
50225	payment	2134	2134	1874	1	1	8582	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNUdMDu5QS17A8FsihUz3z496R4qX4CriCXJnjeG9R2Dd3EG7
50226	payment	2134	2134	1874	1	1	8583	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoBFXkhpzm1bJRxGxvpY2xRTVex2AtKj72ZS6yDDAwH1Cgmru
50236	payment	1397	1397	1678	1	1	18159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG9mKeFQcGcVenUcqXc1cqPKRCjVnkFTCrFuyyPPwn7mQoQy4
50237	payment	2133	2133	1874	1	1	7974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajW44b6JNx4ntxiqU3ojZNz6NzKiY3587jgF5quepRV3o8tm4
50238	payment	2134	2134	1874	1	1	8589	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2aXpyPKKpNU7Wu5duyrxVY2TTLGmMJw2hNbtwLVXcxw9XpeK
50239	payment	2132	2132	1874	1	1	2210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTHio5WhTCHdvZxV4Feg1x2pm8xDwgnhgSkU49RkKN2JNxtgm
50240	payment	2134	2134	1874	1	1	8590	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZueVnGDtFNBfPEsFzD1sfT6uDASfTXUQWBozbJPDmp44uLegxK
50241	payment	2134	2134	1874	1	1	8591	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBWBe9oefYhF31zAAJUsZfiNxEfKwixLmopx52wX7M9QGx5cg
50242	payment	2132	2132	1874	1	1	2211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvCVsCpDbkggtmL5LK62wHWoEVYGkSbgmUfwdCsFcH9UjMz5Q
50188	payment	1397	1397	1678	1	1	18155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaXTGKQhhXKymNNotEJhvsjFTE8hvpufxNBb6B9YJEvULCFVV
50189	payment	2134	2134	1874	1	1	8566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfH8EfhLeU7EHZF1r4KncgETLLo1fzYY9EQUxZXXBHL5FcktV
50190	payment	2134	2134	1874	1	1	8567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3DoHdu75BoFKahDTdU2YRHgPjaFehz7WkQjzaYuwpTR7dVoF
50191	payment	2132	2132	1874	1	1	2203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCS9wY3J42Hg91tZoxRgzLL5E789A28bFAMNfABSHJocoDrFu
50192	payment	2134	2134	1874	1	1	8568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJixhUADx7rcFWv6q1AK7XMSXAUhJJi51ZGwNaukQk6eQYUwT
50193	payment	2134	2134	1874	1	1	8569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vVkCasFx3Z7i2rKoTJsog5wAvGDaDVaQYoqpYMW7h58536Kg
50194	payment	2134	2134	1874	1	1	8570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjF9XrqXcmvCQSv4Yh6Gs73ACd47jJKy8wwDyGAjh6RvddgFvi
50195	payment	2133	2133	1874	1	1	7960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJpFxExQ54vEb3NsWDsh3LNZMHHAr4RWd6LBiws2B9r3c1h7S
50196	payment	2133	2133	1874	1	1	7961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvywGAL6dszwVMEwNp3V1qCMWiq6eFDo4yE3bvC4QR1E3JQ2Nq
50197	payment	2133	2133	1874	1	1	7962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Kt7YJiZFvnirxZkeNDLv8VNmfH5vgvzZ6XoPGqpChcT2gaZ6
50198	payment	2133	2133	1874	1	1	7963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdv3bkiF9PAcKUxMjqNSQM3bcWd6cd8eyDBcvBQcnQrA2j8k3i
50199	payment	2133	2133	1874	1	1	7964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDG4JBZuPcq6TXxBpUJWYitit3c2CtSnctYVZHbq4rgQCVFxo
50200	payment	2133	2133	1874	1	1	7965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL1ryjiz2TRJ9dpH3ZFvsitzWnY7HCqfqG57yVuzNMMk2fGz7
50201	payment	2132	2132	1874	1	1	2204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHufnSEUwWExtMi3VHeLB5e577rn1REC43eogFJujUx2NU8tCG
50202	payment	2132	2132	1874	1	1	2205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENDFVZd9iQwaT739mzKoJpRgPhYMtdvqeZ691Hr1mPsUsLVSJ
50203	payment	2134	2134	1874	1	1	8571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHYQyNcXrCG19dhvbtNse4Sy79LdwpHYnm3mz6ECg9Z2X9GzD
50204	payment	2134	2134	1874	1	1	8572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC5KcGMidNxejZ7sYng9F5ckfq4Kv3hd7swiXzYHy5e2uFbSP
50205	payment	2134	2134	1874	1	1	8573	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLLN1MsW6ybWoENiChcy31x3Euunj33eKhDdkz9fznaiBx6Bx
50206	payment	2134	2134	1874	1	1	8574	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGngiBSp8DjpJTadppr7zUb783XQutGGq7U39zqqQ4ogVg7Vr
50227	payment	1397	1397	1678	1	1	18158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6wLevRuDXzTj6qocgQurLfBpn6FgQCsfcaqy9mtyqW6xhw7m
50228	payment	2132	2132	1874	1	1	2209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YDL7MuriW29LnZYtcbtfrG7eEApati9KWxwcEFJwc8m9UMdS
50229	payment	2133	2133	1874	1	1	7972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkW74SXpVBDfGA6At9EttTXr1RYuyNRKa1Yk1UBEvz2CrMreo
50230	payment	2134	2134	1874	1	1	8584	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdwyAAmZjqyQR3Bz7MrJ4vjv49SNrpzNTnCoeYYokCaT6uCFt
50231	payment	2134	2134	1874	1	1	8585	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKXZnUqPxzTEZFz2aMM5ut9JGKXqkix1dwkWrj71wboLmfkG2
50232	payment	2134	2134	1874	1	1	8586	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E2zmsiQ4rRJNuAfqVXzo5TS2mWS6GReoB92igrkUhe749Wo2
50233	payment	2134	2134	1874	1	1	8587	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1kn4QUtEKpe2qsJ8tjwnDBUyXhybAjQrDffn2Hb3gWiJfWKq
50234	payment	2134	2134	1874	1	1	8588	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPzpRSmvdfzJUEyWBzbfVntfFwSoXB9REVz2AKaKn6GYYfKbL
50235	payment	2133	2133	1874	1	1	7973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLG9cxVatpyePKDEy8heg4PU8CQLAMfmhGyS3hWZG7tvkpXxeh
50265	payment	606	606	2238	1	1	18	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRHu1Vrc9yHiN4kqZA8WYyEyaLrdj5ejhykNSPBiNPeSkdVzJ
50266	payment	1397	1397	1678	1	1	18162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9AqVK54E5qzxEQPY8cFLMS3KChUNqhfNhkhMHQUCBQCg7AkH
50267	payment	2134	2134	1874	1	1	8602	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7mzpiN5Jyksnpu3KFP3ExPKKpSAkXc3eQ859GvNRbkt8YZn7
50268	payment	2133	2133	1874	1	1	7982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz8mWPGR729uxsfnBZBDK9GoSQQh6MM3LzQUuYuNp81iqSfSyg
50269	payment	2132	2132	1874	1	1	2215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxXdtuc3c5JYu3go911DfE4mUx7jGb4reaApmQejCB1g6Vvp
50270	payment	2134	2134	1874	1	1	8603	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnqENLMvZvqKcVfmDBYad8Bg1MtybNUvGhVgLk5XqCLccJVLx
50271	payment	2134	2134	1874	1	1	8604	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLkMszpgqQe3Ym9ZYgYoz1kurQgdCtsgaxphBEB5FwNnQHwb5
50272	payment	2134	2134	1874	1	1	8605	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhk7bxFZgfbB78NnwnKEzA5cAZozSZF9QL6fAawotVTUgYhRac
50273	payment	2418	2418	2418	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZxDeWwWzisHvxiB8LXY9jcAJyQsvhpNv5CEvyDqBCcp17zbB
50274	payment	2133	2133	1874	1	1	7983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2fBEg16JWQP4NRkzYYrwYDVG8Rk7t3ZLd5rhVGRoDZzoapeC
50243	payment	2133	2133	1874	1	1	7975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGsQp751WXBkxMeV5nspBVk9L6AYi5KKxFJ2AUrg43kmCfNkD
50244	payment	2133	2133	1874	1	1	7976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuFAMiaGdCKFwHTWA1JZjKT1e9twf1TenEdibGbsUY7nWCa9G
50245	payment	2134	2134	1874	1	1	8592	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7adAeuubXmVJygbbp8K6YXcDz88LdGJfJB2CLSUhymCZAznk
50255	payment	1397	1397	1678	1	1	18161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDpZgg2VCbPJa4KUocyHpFFRzdQeGgNbRyKHRt1iaMdUi8472
50256	payment	2133	2133	1874	1	1	7980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39gjn6Z62Fv7XWFK4nK5f1qsMGZmqjZZ81x5zrasUgJLbTPXm
50257	payment	2134	2134	1874	1	1	8597	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKtcSbi421LWEsH2nsjK7obaHoFaT9fNMNRqigXbC6oSPUDkB
50258	payment	2134	2134	1874	1	1	8598	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqQp2T1neeaGxdyDrSF88UAaKNdFuoNeyUsjWyBGGnVpTqkmb
50259	payment	2134	2134	1874	1	1	8599	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1Nx2RVDfeu3wsA72ErpDFJU9aMbSbraJWb9ogMegBSC5Thkm
50260	payment	2133	2133	1874	1	1	7981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMeFxojjNisRFhkWCeAiXuHexJR9ErgfMGjsSthbNNoJHWQp7
50261	payment	2132	2132	1874	1	1	2213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcG3LzSZBmDgnBT12MxHQVv4YeX7EU8oH9rTykCQQXS2gxQH2h
50262	payment	2132	2132	1874	1	1	2214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjhF9mDCdmRJfYwDi1wma9hAqrto6qntw56WCLToBiynFL5s6
50263	payment	2134	2134	1874	1	1	8600	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpmTfkoT3uwcaF3AD9eovubtkEVk4qVgkZfYvZgfktN3Tugg9
50264	payment	2134	2134	1874	1	1	8601	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4eJrZwvziCx5KacnT44fmYTsmaK9QWC2LPP8V5H9HaJovrBf
50275	payment	1397	1397	1678	1	1	18163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM799fpB2N8jbzXFYb1AoZdyr84MS8pF6ujqCqMsNUWsbghLGT
50276	payment	2132	2132	1874	1	1	2216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUvwx4RJ3zgCcgqEiLzHwjVEpqQ5p6WohsHa1tvMNWe8P5rQS
50277	payment	2418	2418	2418	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUGpdmxBZ6CBvBe7oPJK6bPiQaTJzuUjmy2dB7HW1Ff9mWFVs
50278	payment	2134	2134	1874	1	1	8606	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmga6pH3bAdHiddWCnAk55wEBBeBSBggtsxBGFyowvc5adm4ao
50279	payment	2134	2134	1874	1	1	8607	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduBJC9ECwbJGoYdK1dmoYEx5Dz2hnaaw4vYjzmub3qDDwgtnf
50280	payment	2134	2134	1874	1	1	8608	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjcv452SvtzYthwPvqojzf5RX7qe3gBuh8z9Q6CwoaURXyrYo
50281	payment	2134	2134	1874	1	1	8609	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGTxd8B2DPgDgA4E9S7GjwUP6pTDstqiaEFRZNvT7BRqV8AVj
50282	payment	2134	2134	1874	1	1	8610	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6RUx97k29X4ic3ziSaEjJF6hjmciV7cXoCjnWGR12Y7WNapi
50283	payment	2132	2132	1874	1	1	2217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ksMsUdW3UYbJnTQMhXZqYxyg3waDtiVqGoVH5ANh5ZuWX3gw
50284	payment	2133	2133	1874	1	1	7984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83v64RAf4Zn1KVwGZhFDtQXhdbPjkZ4bSfW5RyFoodYRSWbGm
50285	payment	2133	2133	1874	1	1	7985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweGkcx74CFC68fcDxiuqKGLBek8MrRhSrKG5TpYunstdFzBba
50310	payment	1397	1397	1678	1	1	18166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4KG6ky5i3kBstWVhR47bTDDvzFmtphP5VSbreQVj62y3sr1G
50311	payment	2134	2134	1874	1	1	8620	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEQeCi1RVsFb1PY7yV7WC1T72sky468uN8dDP3AkTobjFU9j6
50312	payment	2134	2134	1874	1	1	8621	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsMRJcjBURqG53cSfPMTGKc5vXDHXs4g6YjVJfySrMJsKQbQ3
50313	payment	2134	2134	1874	1	1	8622	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4QgwRt7PSRQvqsoaCC71Ss1NM58CmzNT4qa3GF91YJ9q6K8X
50314	payment	2134	2134	1874	1	1	8623	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczSaEGopVJ98rxrf3bpHYDKMKNg588g5vAukexEHaj3reSEUX
50332	payment	2134	2134	1874	1	1	8632	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCx8stLnPfHNJRQ2JoL38YToZpKuVSiGnJHBZJMMtPACnA1EP
50343	payment	1397	1397	1678	1	1	18170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJzWvXc5Kkf9czpRh3iwHtzz8jHcWgBkg4MAcPCnoMQUPaZaZ
50344	payment	2133	2133	1874	1	1	8001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhNcBACvEWs3XAZ4j6FRobawy6vbw94g2HoTTeaaxbphwrmf3
50345	payment	2132	2132	1874	1	1	2227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1V8PCCAD2UcgLvUHtm59uncPTjL6GCSPsry9hT46ZUCUPXux
50346	payment	2133	2133	1874	1	1	8002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QRWLpV2SewCpe1NNcrQFRGjgtyrA1wAsxQ8vSAKyedCK6S2V
50360	payment	1397	1397	1678	1	1	18172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUSR8tXMDxXEjzy6kK6DgWVFShuaUtnA3ARrdXqCQibq1oSGL
50361	payment	1397	1397	1678	1	1	18173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqJGzVkrmKzPzXGUP6Z89T7AgxAbPYWdrgbtzgFitzajy4iSC
50362	payment	2132	2132	1874	1	1	2229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMvx7MFXdZPEhUHRSSpLFAci5J5nsfn2PTicDiFy1A1dWv1Ww
50363	payment	2132	2132	1874	1	1	2230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgutqw2MCoZrTrEY7WUcNe21m1xgRi1xNA93xB6KBn7qevrRLw
50302	payment	2134	2134	1874	1	1	8616	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpz45A3pocuJ2gt2YSYrT6EXuqjhJagYqWJVEkQMbfw9ZKkwQi
50303	payment	2134	2134	1874	1	1	8617	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVhaY36aHTnbbUV1vgnTUX6DjwToiqnWeEF4QhgboC2zZKktt
50304	payment	2134	2134	1874	1	1	8618	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiBbVzyR95NrG5pTgrcGTsNUec1ZL7NjDAVNnSKt695ybntJm
50305	payment	2134	2134	1874	1	1	8619	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegsmJPB7Ja73gAeu1zzdyujXe4utJmmPjRkjNp9DMM67X9bhU
50306	payment	2132	2132	1874	1	1	2221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahjcexHyFyho7ZZ8ckWra1dWJ7NpCwqxm9DK8BGzUNxCXwExs
50325	payment	1397	1397	1678	1	1	18168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztUw4hthmyjHKXmwMZ2reNXvZW3EU15uvcY8LTXrZ2pZ9aYY2
50326	payment	2133	2133	1874	1	1	7996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFwFsbo6as7z9nbHgaAuGxv9ZjEfU6EfABBqk6yf23RV3MvvG
50327	payment	2133	2133	1874	1	1	7997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiQ6cLPnEhhiuSX1wet4WLnksCkVhfS8WD3o82tVd8NzCvrWy
50328	payment	2132	2132	1874	1	1	2224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSkcGugpU8kb4x1KhpRiXCKvNTj3eAmqxWPBatdHXbPCmKT82
50329	payment	2134	2134	1874	1	1	8629	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvaNcMcWAkhpd9TnWCDVmTViAM7aTZF8YSL7XCMFs2KRaZCf8
50330	payment	2134	2134	1874	1	1	8630	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYUj1x8WsXDLc8wqNBogLTU8SapjZvm5xhTKRhAEyFi2YMpSr
50331	payment	2134	2134	1874	1	1	8631	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVnV1EYg4T17iSDRpUwsuR88MGwQMwutFjSiZj6HBNgbpphzp
50333	payment	1397	1397	1678	1	1	18169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpTrRwhKXKA7wYC6pxcKQrdfofWE9pFWyo4jPKubgPjdYYW1N
50334	payment	2134	2134	1874	1	1	8633	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgiVdZxYhee8kuQ3BYtVBexkJmfPJLYRnBxKNwbhdNZVq7GNX
50335	payment	2134	2134	1874	1	1	8634	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge5gV4f1SM4Y77pgCExqYwBE3W5sfHjPFK8A5cxqiLSSPodFr
50336	payment	2132	2132	1874	1	1	2225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDnof6pHGzXaRqQcDezXq2GS7KBPLWNiJoPcQFAzrMkrcK71r
50337	payment	2132	2132	1874	1	1	2226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wESrFhaCjuowzgcrZGzTsPTe5RjYWtsxubSeC1TYnsHKATw5
50338	payment	2133	2133	1874	1	1	7998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJTYRusxvB71xdA3UVdrp4vVyCCX9UYaufdhZNpyTdg1AuUW2
50339	payment	2133	2133	1874	1	1	7999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3CTE2mXjsBjHDkDXB9gcur5Sokk4zoBtFHFgsfR2xtnorQMH
50340	payment	2133	2133	1874	1	1	8000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Dm5dzYcAoNp4nJmnPQEyFnUa9qnpgkDU6h69KhfzaLnpXXgG
50341	payment	2134	2134	1874	1	1	8635	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZB6RoQsYNofKvieSLjMS2TG37MmBp5WM61mHehMUKkShbBMq
50342	payment	2134	2134	1874	1	1	8636	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mc36rnyg3qKwfhBwSPnb45qhy5MkAW2w9GSmpv8PHSdLBAnb
50347	payment	2134	2134	1874	1	1	8637	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGijZPwpAgTDknpYQ2S78cEuY3UhzZiP4FQUJPjYejigMoYDT
50348	payment	2134	2134	1874	1	1	8638	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DfLuuc4pKpyHA5646nJ3Qvn8cenGNokuNRoeHXZr99pvB3Mw
50349	payment	2134	2134	1874	1	1	8639	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJSCDKZkwY89q9hPPd1BStWwyabeKHhZtgAxTuG5BPSLFXYLs
50350	payment	2134	2134	1874	1	1	8640	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEH2j2rVfPaicaniFup746tLwmnGWsnD2HLiqmBL3z6A9933EU
50351	payment	2134	2134	1874	1	1	8641	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYby7P7JWNRyLSHXnNwzaT28aPbxGroPaZ1tf6cdiMQ2Dz51V
50419	payment	1397	1397	1678	1	1	18180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7voPoV2U1ZNuCrLefbGWGn5dkFDXab2ySir7cJ5VGVUWsgzvf
50420	payment	2133	2133	1874	1	1	8026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8i3VyxG3Fwme5Ruwpa4JACVoKWHUmpsFUGagvZqDwBJQtknFN
50421	payment	2132	2132	1874	1	1	2241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeFv5i2ZtAFZwffWJT69MpmP3HchSXLML2vDnMiEJk9zmSPJQ
50422	payment	2133	2133	1874	1	1	8027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUJrgz21bn9Wow3pjPAkFGmWdr9NSn6rEdpxAsdg9HnQkHcnk
50423	payment	2132	2132	1874	1	1	2242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mNMcJj2JQd2VhvsPLBkyjbaEHkm7mBCo21N7To9HAAw1XgRe
50424	payment	2133	2133	1874	1	1	8028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T7uvFCfuBSiqt1frfnqtMxT44FLPSSQbeMCf5bt3kDhsYRqb
50425	payment	2132	2132	1874	1	1	2243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuc39R7Mbkw5jT1WF7qTrF7RuWcPxsidkmQXqt2cKFMV8cHpxN
50426	payment	2134	2134	1874	1	1	8662	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpD9kSHpKL7WiwjTSLQnEHSRHCstVxFzHVfzRtbeKnxJcstPC
50427	payment	2134	2134	1874	1	1	8663	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfRmA1cTb3ogYxpfSzHynEidqGaiFqGPwyMKfK47SUoKYmBDK
50428	payment	2133	2133	1874	1	1	8029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoizujmfgFUTZ75VnCR4m3M9MuQMHV5aaw2SEgAV8bxeFfEUHQ
50429	payment	2133	2133	1874	1	1	8030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Bg8gbnCBTkwhu3wUsVvupSQyxNCfvVfLVkCcJB4Zz68gUXGi
50307	payment	2133	2133	1874	1	1	7991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZta2hHe9DWoLYUja2nXYqq3uVfKekedoQNMoPHP7eBCHk3Ey
50308	payment	2133	2133	1874	1	1	7992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkt3eW8aUt7tFqYqCWUeKMCtZruj2dWJUpktyfnDFzhaoRpyv
50309	payment	2133	2133	1874	1	1	7993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwHCK8MJjoQvCjs1rbGv9qtsFoU3JxzTZZYeY2iuXTn51Snc5
50379	payment	1397	1397	1678	1	1	18174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeno3VbFjQxj2Aa3UnitZ9jxdfCryezb5t2wuuiWVrCFWDRfh
50380	payment	2132	2132	1874	1	1	2232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsQnDtDjt8M1r6yexiQBRiHenDUDpXyGsbMRjPCuV8CqruMka
50381	payment	2133	2133	1874	1	1	8010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhLLR4jsBkX4hbbDCG79cNC9GyEPQxgUYuDiA4gt38uBZRuYB
50382	payment	2133	2133	1874	1	1	8011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNzahyHpb7Z5MVqZjFYU5uTqDq5ZdoVfkfhH45RaKvppUERPx
50383	payment	2134	2134	1874	1	1	8655	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNAmjbJeagqxrnbrm9RKDjLfom4X5naSegRMv212amxPHjECZ
50384	payment	2134	2134	1874	1	1	8656	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpTifexcfMkncomwJqrMzHfawz9RbjnbLd8Vp5yNyMV6sXBkG
50385	payment	2134	2134	1874	1	1	8657	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctMxzNTE3ojfay8UBB8j3fj3vvVhmjQNbsF8mTd4zS4sRcQTp
50386	payment	2134	2134	1874	1	1	8658	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRWAtSdhpqMK1u3Vci5XxbjZ9iHnqVp45FdpUiS91TqDw51qj
50387	payment	2134	2134	1874	1	1	8659	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz4vJXLFxo8vFPwLH5FWqoeZFKerqezNRNjqo99VKhdLx2z5i
50388	payment	2132	2132	1874	1	1	2233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yruniecVBdJHYJNm9JTWQWmgJRSbbFJzzrAN61WDJTvXGPeQ
50414	payment	1397	1397	1678	1	1	18179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXiE5ABwS792kUvjziXTwhzHtcdynKXASjDbLwWbtkRJMP9JE
50415	payment	2133	2133	1874	1	1	8023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgktD4qNPb84D4eq93VE7ozgZJ6L2ybNFF3hkM4teXyrLC7sia
50416	payment	2133	2133	1874	1	1	8024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGKPgpPZhbXeYzN6E3Vego2i4LeRi4PbWr268NgYKVStEZnvk
50417	payment	2132	2132	1874	1	1	2240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvZczJSCLZonrWnAYcc5Lwk2KDStPdeXsiTCks9WKuYQMHztU
50418	payment	2133	2133	1874	1	1	8025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYbrCGBbQMkrzRE7YnvtybAmiLPyVkpS8KkWbKYcUidhYMEA7
50480	payment	1397	1397	1678	1	1	18187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRUiGe5gg5LQv8MDrw6hY4bRLpFn4UfQfSx9RFx8KEWiBCw2P
50481	payment	2133	2133	1874	1	1	8043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhxk6fLxBJyoXsogNerdhxJ5NPkF1Y6qCUKQGUUJjHfvmygFu
50482	payment	2134	2134	1874	1	1	8688	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdbxqiajaocr5TpjNuiVG11KDFr6AWZJKABrcBhMzXLUmU6Sq
50483	payment	2134	2134	1874	1	1	8689	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZ3UWKtPBSPc9n7rmzGiwGQNaVsvcYQKrvZPkMMdJL4MPqYeM
50484	payment	2134	2134	1874	1	1	8690	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSkAabTLvjqNaL9J8DTzn81yk2QcnjfQpjSEFB5WkfXNytjLj
50485	payment	2133	2133	1874	1	1	8044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXh5BRprrozqYpLnQ7iMiF2ajgyWg5cdk1vowM2NjdgcoadFH
50486	payment	2132	2132	1874	1	1	2252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoscDmAUzDAmHcu2A4QmmDKcQK1Pz4iQtM8M2m5J1dvh3DjzBx
50487	payment	2133	2133	1874	1	1	8045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAY3VM14u6hJ4LMwo2dKDdqsB3SPK7idPn23b1eYbWJVEKf97x
50488	payment	2134	2134	1874	1	1	8691	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzMQocUa2LXMCfQfKymwBRf6xmJooLKHVHPed2yFdGbsDikCB
50489	payment	2134	2134	1874	1	1	8692	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRxwhgg53icg9cisjjP49FBDuJ9dLUi8ppDuhPztwGzTvMkdG
50511	payment	1397	1397	1678	1	1	18191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCubzKCTEotsnomastx14U19q2J7qvJmcNhhnC3v3abGQvE5y
50512	payment	2132	2132	1874	1	1	2257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLJRKZKP1ex3by89kFLZXfZTwV5Pdaet9rQbeU19FaksPq2DB
50513	payment	2132	2132	1874	1	1	2258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHV9QFdrcDYgaxLgtrwNoa8jMNNRGH5KvmcSFGkKvFRLCPiU5j
50514	payment	2133	2133	1874	1	1	8054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoze78XdSJHGczMGvoEto4z9FvQ8TgEuZvH9kWvhQFASCiXCy
50515	payment	2133	2133	1874	1	1	8055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAz3gzRPYBsxgarokeWzE1PCnTUicHthxXrsbNf2ouZ7ZD1UEX
50516	payment	1397	1397	1678	1	1	18192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJA9Sv1HEVe4o17iNe35abQVxRE8oGTexdfk54j8jeQQPxFKGE
50517	payment	2134	2134	1874	1	1	8699	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMxpjEabJHKAgJKQ7BMsdTB2gviSD4wQTciS8xzLmdyZ31xqq
50518	payment	2132	2132	1874	1	1	2259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3bo6eKqURswCtzAngyWpm1zr4N824R3X8JHbeyLKnpoVWK6T
50519	payment	2133	2133	1874	1	1	8056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYp6fngJiDX7Gb8eNsYDWM129G83EtRPAD8hBZHHPvFF7AoVp
50520	payment	2133	2133	1874	1	1	8057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLdAjDScEtzZWT35Yvq7G55PmMNoiWqvWmpsByfExeGJhk83w
50364	payment	2132	2132	1874	1	1	2231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhVzmhHHeWmyowieLqbXiJdUXcEK7EFmBTUUrvcaKaLDEGaUv
50389	payment	1397	1397	1678	1	1	18175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZia4A4889FLiHfQ4jmtacY2dVX6Dpir2bxoFoiJVZ4oFUVi3uh
50390	payment	1397	1397	1678	1	1	18176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyE6E7bqZLXJzUb7DwApBXviLSWjPYY24xngK3NHNWWUgxVnUb
50391	payment	2132	2132	1874	1	1	2234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTapJ7dER7Gx77kSc5UKx31RXk8g2jouDLmM3rpoYdciVu9zVA
50392	payment	2134	2134	1874	1	1	8660	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksmw3gdvu95SoC2aDa2EV7jKKAG8ee2a4sTkuatuSHxmSwhNA
50393	payment	2134	2134	1874	1	1	8661	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbv6D3jia9PJTD3mF8S8KShEZu6Re2mzYmnQJZE3oPVoJ7dNw9
50394	payment	2132	2132	1874	1	1	2235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssdKURYE9sQnbCrf52fyn7H18CJpKrPFag7Lw7Q9g53U98WdG
50395	payment	2132	2132	1874	1	1	2236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yj8HGCiZ36p5QJvXTc4NhXRRe1Z1H5Y2WQCsn2BGPhY5vckn
50396	payment	1726	1726	2433	1	1	8366	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7njsfCdG8xiTyztMLnn6CoVTvkx1Mj4kVWYJznRJcPhTZUuc5
50397	payment	1726	1726	2434	1	1	8367	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZnt91bKLmApCZnhyagvdA5WuXP9AzjnbGvr9Fhgqs5PhqTci7w
50398	payment	2133	2133	1874	1	1	8012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7FnV6znyfdrgbbj7juW1Rzz42kZZARPh2JbgXratmLnEvBx2
50399	payment	2133	2133	1874	1	1	8013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyTh6pZBA7pY1Fh4tcNVPieY7civSx9R3NiteF6iXTDwHV3yi
50400	payment	2133	2133	1874	1	1	8014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYrWCbUjjaSpKagJNuqqCbLmXzgx4dGHNYwLbWevw9ZEFm2yf
50401	payment	2133	2133	1874	1	1	8015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33EZDwgAyaSG9aYHwzRWqwJ4pJtQxj5XE1jyj6u6Wqa7AD2jF
50402	payment	2133	2133	1874	1	1	8016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa3NJovFDiZ47rR6JLJqxbPyz7w2RXJvUh8XpiSLNjvn8inTe
50403	payment	2133	2133	1874	1	1	8017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4Qy5WbECyugm8JYBwc852qPvaHdmxSJhDzaCXoEwMkco4oFX
50404	payment	1397	1397	1678	1	1	18177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZovVm43gewqRwZCiGSB3nnksMKhueZPF4AKtfKHfreLVvaJA6
50405	payment	1397	1397	1678	1	1	18178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFJEUXRxb97x9eHVB5ASyqw4itsNhE3KoNC2HYV7cadUjXnQL
50406	payment	2132	2132	1874	1	1	2237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wt5RmRfAE7a52vNNHWbxovA3ebt56iFU2wMns5LgEMSLCb9E
50407	payment	2132	2132	1874	1	1	2238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkt7QQAGJLyx2hjRNZJPJMACE6vrTALjcPdEXUGhAb1uj1iCK1
50408	payment	2132	2132	1874	1	1	2239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnQvB3UrkSi8Wbh6ACVwxJib41wnHuh4xfQqmACi65eimzLJi
50409	payment	2133	2133	1874	1	1	8018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCyNEcJ62KrCeowuEtLoGCxmdhZNToM13SaEeQ7toMWYH1Eau
50410	payment	2133	2133	1874	1	1	8019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M6UdogistG9YqsB6vCbK2MrSGFVQTDSzgeM9jZ3KPz2JV7BM
50411	payment	2133	2133	1874	1	1	8020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAVnsG6dZ21Q61dG2N39xwiPoYQtDdPGkd24hRxY2ZpfshnLM
50412	payment	2133	2133	1874	1	1	8021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpn2xRBUfYR1EsKaT7QiztUGWdj6d5FhwmgjNuWE8H6qVyaW6w
50413	payment	2133	2133	1874	1	1	8022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFFyD38KJTZrMDXF6pguQeaJHaaJJeqivPEWbtxNj6UWRBfZ6
50452	payment	1397	1397	1678	1	1	18184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxYMH5QGxLgW47RMB5TRgiL3h8PanJDKr5E2X38kSvFRAbiej
50453	payment	1397	1397	1678	1	1	18185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJ9N79zkqGhzcMroea2o9P2ENqs8HVL9PXyQc2idpAhLh6hh2
50454	payment	2133	2133	1874	1	1	8036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuCKi1tEri3RV3enudz9x8PiPiDMgqfBAAsK37qcCB7BLZLJD
50455	payment	2132	2132	1874	1	1	2247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqGCfkn56vxWAi8UVWijULrJMTAjx2z6fKPtVBrdQGtnLVWhi
50456	payment	2132	2132	1874	1	1	2248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLVXdXmEGDWrWqdXjsEMpdu5taTDZ7XxYKMmWVBbM4s36sV1H
50457	payment	2132	2132	1874	1	1	2249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnatREUiWTzRUTBta5w7cNbt6xD97LvpKwy3pHEsZFmCgeQfi
50458	payment	2134	2134	1874	1	1	8675	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUvrepnzbRJVupJHMzXPiJQwe7YL7T6VdxJM1KmXres6hkvv3
50459	payment	2133	2133	1874	1	1	8037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28xMqN7yrtJBJJo4Nd8hn5oCVdkmT6KTEw6r4WLojf3BoqVDK
50460	payment	2134	2134	1874	1	1	8676	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pRRZsVrZ2m1QNxsG87XiDnNJF3Kwe4jGHZmgFZtdFUC9nzpG
50461	payment	2134	2134	1874	1	1	8677	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nu94k2gm22f2NZLTrP1DsC5k4oKfEy7LaG618qpwNb5k2z1f
50462	payment	2133	2133	1874	1	1	8038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vzoYyUYMvKLe3te1tCu2kJMfah2hVFyABgu35i4mpfwtKC7a
50463	payment	2133	2133	1874	1	1	8039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JiRfBW6cRoKqsMkWGWot3RhMYzNP3D76UXmr8WeuYWsiWKEF
50430	payment	2134	2134	1874	1	1	8664	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaga32NHGKy9vedYqn9KfJHjrV3A5oYgxWGm7iQJjXMWTZ8yc
50431	payment	2134	2134	1874	1	1	8665	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAcyB3WRoojesnLS6oCgA72A8tBDCGro8V6Uh3xi1xpNcUd2M
50433	payment	1397	1397	1678	1	1	18182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeRN5gPWqDAGdQauBDQWQihYqDjqMvqa7USjYEu5Tkjvm75dH
50434	payment	2134	2134	1874	1	1	8666	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqd6FYi5ieuPXsCxSRZULFYr4JxDBi84kUy3x56a3frojU87T
50435	payment	2132	2132	1874	1	1	2244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqb4pToT5829ADoMGfpVYEkCkybokLJrP9VkvmFPxiuCUsnwBQ
50436	payment	2132	2132	1874	1	1	2245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBr3xK7VYc6y9B5wFPpwXc9TdGKQibrepDpq9NeA5RqGijhhE8
50437	payment	2133	2133	1874	1	1	8031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9hoNKJDtY3MJWibWVZpzsR3vDfXRnGxN3xEqbgjF48MP1kyi
50438	payment	2133	2133	1874	1	1	8032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqYy7s23Z8PCVYEb2G44YQUwa8U1a46MjkzJFDee4wS9xeBcg
50439	payment	2133	2133	1874	1	1	8033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnc9KNgqQMsAbBemtJSoXXB8MPVyrMR4CrtHCSzbWQt1yp7hF
50440	payment	2134	2134	1874	1	1	8667	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PEtnPz49FQBsGfGGotY8eN9fvRB1MK1Rg93UKtJ6S9GfKTsR
50441	payment	2134	2134	1874	1	1	8668	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3s8RacjH1h8tDsXqLfgxAXPZLPcnkGkiHjNVaCGrdsN1CMTo
50442	payment	2134	2134	1874	1	1	8669	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvXtgV3QEAjHfGtZZdDyxSiwtZhjSDSDT1xJBgeJVqJvTm2TV
50490	payment	1397	1397	1678	1	1	18188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqiu74Ngm29uoPzESn5KEF6ut1SmnySL6YEXSxBwEg2Q7b4Sc
50491	payment	2133	2133	1874	1	1	8046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgVoWLBGVTRegQsxjFLgbwRFBVcntd5wY6Nk4HJvYB22HFUvb
50492	payment	2132	2132	1874	1	1	2253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQTg1ymPaS4KXXDwFxydhm2XAa7meP88DwcumddZann6CaNby
50493	payment	2134	2134	1874	1	1	8693	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUkMvtnCydytuQMtkFZEHdbRY1oDtovZryv67CVgyhehg92tM
50494	payment	2132	2132	1874	1	1	2254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxfwAZL3M6gA5hLxbWR5Tck9QAGz3gpAHAeh9MdHknhw7U8aH
50495	payment	2133	2133	1874	1	1	8047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJQwn6GYJ4MvBVnKzrT8vuP46ya6zxYCQ4Pvrh2kZiGhukBw6
50496	payment	2133	2133	1874	1	1	8048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDogGxtf8n1NuDtkMZwfgQRue6unD8T9PgRxvChwwqPWwkKuy9
50497	payment	2134	2134	1874	1	1	8694	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcJLodDGESBaihcednNszi1Q8ytHZMNxTrwbo76CsM2TmvYA2
50498	payment	2134	2134	1874	1	1	8695	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQawXmfCC6RePvMfaN8EQfewq1KiPknMQ3dk76hDxP1FD5w1y
50499	payment	2134	2134	1874	1	1	8696	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8mfeeCszhxHNKpFJGSMF3ZUdTqbJJi6Pfr8MGQvcHg4ifEuq
50500	payment	1397	1397	1678	1	1	18189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1U9qQZm9iCtrjz3gDANEUWntccX8BmRJPriqUMKiWeakxsWb
50501	payment	2134	2134	1874	1	1	8697	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxVqFmmBexN7JJz6bFPEG5RCW7EoirEKofGeygu1TFi52Hh9J
50502	payment	2134	2134	1874	1	1	8698	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36zGbrDeABwhPGFr6H8DjtzZ6a9ZGdkSv8rZRVVpabVGBTKMd
50503	payment	2133	2133	1874	1	1	8049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJdCTjM3ZCHSBUSXG1jZzGrwF7s9p1F1S3pZ3EFpJ5NiZ9Rwe
50504	payment	2133	2133	1874	1	1	8050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZbQ2MCiDPqATc7yhJrPuk1we4jSr12YRV4GmpADcxUNYFDr1
50505	payment	2132	2132	1874	1	1	2255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZby1RoxUzjSoFHCf8B3GvT6AYS4RWRKvtQM3kGGabVTZKNCQhY
50507	payment	1397	1397	1678	1	1	18190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnMAnjYDbs83x79occRMuZw6p2wi5Vf1aCPnmVhengVQ3Nz4s
50508	payment	2133	2133	1874	1	1	8052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRCjCB1dJ1ttCgBczyykwaHzyCiKkiDrV3xXQM3BuUkrL7KDs
50509	payment	2133	2133	1874	1	1	8053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9veCtdfPeRmNCN3Wzp2LXJYVLRdD9aPmyGPYpoGqdyLQqcSwF
50510	payment	2132	2132	1874	1	1	2256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJsaYbgzKzuAuycoRpwDhzh4E18TeZvimNPsUskw9wUeXcrPu
50593	payment	1397	1397	1678	1	1	18199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYEAiVr1u8P2aMcwC84TJVDaycpKU4VZNPdxdrwEpbjCEG2Ma
50594	payment	1397	1397	1678	1	1	18200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAKNN5Ww6HJRYUxyjzcJC5zvhV34A3y5hS4pDZVVchUmtk63c
50595	payment	2133	2133	1874	1	1	8074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKmeX7qCbeiTKdRZWut9DFNcsWn1RMiwr5NMCAbE7ZaCoY7nw
50596	payment	2132	2132	1874	1	1	2269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYrc1ant63Lxjgw1GZAzBT5mdfar56ZQ9zi15fi5PkEhaB9zV
50597	payment	2132	2132	1874	1	1	2270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfMrQrcH1RaHW13jF7wek7rexQup1rb8AssyyvK9kEnS26KNd
50598	payment	2133	2133	1874	1	1	8075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXD7LAjorxzcqwu9c1gCb8Av6FLb2K5LZTNE2v556kAfpizuU8
50446	payment	2132	2132	1874	1	1	2246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29wtWrw3P8Y2suFweXMsF8zJeCpDhgoNYeMNcjeQkKk7mcXfX
50447	payment	2134	2134	1874	1	1	8670	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kmFkG5Mj77oVu6ikejKoHEmu2LQnuubVztqAYJUtZe8xh1Az
50448	payment	2134	2134	1874	1	1	8671	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMhzZAgqdPBj3UV9q6mFVCXaXkDgQG3vrC7KUga7JFL7nP1kY
50449	payment	2134	2134	1874	1	1	8672	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LguyEKYRg4oroGrQvUFNeMQS5c6jsCHXBMxp9jyfoVYQdwng
50450	payment	2134	2134	1874	1	1	8673	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXJEpFhMkPfDU62JwPX4QSkuMMkveW4hUEqqRHCdkiQ81mhGs
50451	payment	2134	2134	1874	1	1	8674	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqcvd7VM3Mz4GtMfnCXRaA68oF7ftJCqvtVLnqWKWBv1M6mgJ
50471	payment	1397	1397	1678	1	1	18186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbosXzwjAafSvrFQU6cD4Dv8vCav2G3HYRaiAsJnJwRQFQwHH3
50472	payment	2134	2134	1874	1	1	8684	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmh9gEmoVR4tu2E4A5p4mL89GoREjJr1QdCZJhpHWzmBRoA3bn
50473	payment	2132	2132	1874	1	1	2250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRMAgdNZW9CwM7ERqnaHGZEFnRnu8Auvsa49GbLXRBk21eU2w
50474	payment	2134	2134	1874	1	1	8685	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVDzwFcZYHqohSLaYt6xrWMrpEHG5NjitArgtMwZ1SUQXELDv
50475	payment	2134	2134	1874	1	1	8686	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8JxaSCDULqEaERMvhYUCEerQYWfbauGUdBunsupJU4MUo5n6
50476	payment	2133	2133	1874	1	1	8041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u9cJRTqzjdgqDBkXeLdEuRScySDPasy4VWMdwAyTTEBM4ehG
50477	payment	2133	2133	1874	1	1	8042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2Sf8faKp8cypNHM7tAQqYe3pj6BeyKyBEDc8rsuHKZumw74X
50478	payment	2134	2134	1874	1	1	8687	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YpsTLd14pzjagVwsVxUhdM6P67SgmijfsrzfTf6EsqSisb5b
50479	payment	2132	2132	1874	1	1	2251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLedvmQVoAkAGSse3hdEAaXGQSTDqJvdGH8AsiGMPGS3fuZY7M
50506	payment	2133	2133	1874	1	1	8051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvybVb3eqLtW8ccMouxCjSqLBcdKpYY7F7FmSyhahmVxF3v17
50533	payment	2134	2134	1874	1	1	8712	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmnFyNQ8CaXYYFms8meZr31X1LiZMpVvcKXq4vVwCpqMoTYBo
50534	payment	2134	2134	1874	1	1	8713	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAhZoN8qpWymbwMuH1WQwzvSEcpa3cjJEZepo22nTmECyjJvJ
50641	payment	1397	1397	1678	1	1	18204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuTAESWkbvRmyHGTA7pGXu6rogYD2swWuD1Szm9Y98EtYMLnm
50642	payment	1397	1397	1678	1	1	18205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf4P2x1Rt3Z2HDt2TXZee499fiNzNVfYLS21gEMxmreQc7T3E
50643	payment	2132	2132	1874	1	1	2277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjrvT4tTE2z5EggxWn39u5xsR3Zf6bLqouarsPBkTpjoDYS1R
50644	payment	2134	2134	1874	1	1	8763	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iWDQ2K2y2Hiz8W1b6maBb5MisQr3yGGYD6p6khB9pWYZwS62
50645	payment	2134	2134	1874	1	1	8764	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFSeHA3o3mAwo52tzmFYd2Se6qu8G7U6oSkhaJzbtdbVvRn4C
50646	payment	2134	2134	1874	1	1	8765	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JHp8GGY56iZ4PhjVicFA1kn3wFU7iZUJP9hkRgZC3gcqmjdc
50647	payment	2132	2132	1874	1	1	2278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QkgyLoikwHpwkZGJowdf8nKmbGdSWRyzy1kXENmzNicXgKff
50648	payment	2134	2134	1874	1	1	8766	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiNnr1R6DKKkn3bo3qFxtFK7FLZLLdpwPoFxxsMxSLoez87KB
50649	payment	2134	2134	1874	1	1	8767	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDqkxEvJWbV6BRr1apoJJ51qr1ofSbGfGED2fd8de9QBEnWB7
50650	payment	2134	2134	1874	1	1	8768	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgzT2PCb2SXPdLCwTFgRmNgkhngjmRnCdH9fYJvEEFBp7Cn2Y
50651	payment	2133	2133	1874	1	1	8087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofy7ThUeV6QwYp5toppbwMEDU7LYSKGveVwiWzpFBXA6d6pHr
50652	payment	2133	2133	1874	1	1	8088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMUoJAg7K9s5RZic7fJ4WeYjT6oWwK4Q8YNGBzEw1oKjYgzNt
50653	payment	2133	2133	1874	1	1	8089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUFYyUJoYcRqettwACbjAzZTVpQ2GGasV6dc13YW1H9vtdZha
50654	payment	2133	2133	1874	1	1	8090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9qg4mrfxN1i99dQnaNwaK8n7RRsiXhrBWY3ngKh24XtaMm8R
50655	payment	2133	2133	1874	1	1	8091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEkr12UPATcRrbZ4Qi8AF5LtMZwuRPiTqdFUPWe8Rb8jhWCvG
50656	payment	2132	2132	1874	1	1	2279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLuvEBKpJ3YMSqibbq6AobwhWXV71E89LiMCJ5o4nvEsdipNZ
50657	payment	2134	2134	1874	1	1	8769	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucMiZc6KR8gM5Ba4NSADoUkK4FbJA1xwXcZxhgTbdoLJiKKJv
50658	payment	2134	2134	1874	1	1	8770	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYj1CKtLVqWEzwnifwshFcRCQVZEcJrK8gKPBW6qRA2jfGAku
50659	payment	2134	2134	1874	1	1	8771	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJd2urdvJ8mZChmskTbWE5CEpc2xnn5JqRmUkxuiX9BiXQh9Pz
50679	payment	1397	1397	1678	1	1	18208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdY2qvLDSHVhhQifs4jcN1H4RjyjsWD7KCJu5UKCEf8wPcqZ1x
50464	payment	2133	2133	1874	1	1	8040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkP7C3xGgWju2TKhpJotALYG215ApEtudcB5HV6BrAYiCwGQA
50465	payment	2134	2134	1874	1	1	8678	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChhjCAzKQn7Kr5Bw4nfHtyBdTwaTCXhv7wUjqSUssx2ziKkEC
50466	payment	2134	2134	1874	1	1	8679	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfW6haFRLHawp3VHdAit2V5YoCLEBR3jKkcCYDVUfkP3e9B9q
50467	payment	2134	2134	1874	1	1	8680	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSxitgTQyGVXrbLLDqVLFcbearVZhJxQyAP1UEScUVcNoi4ZX
50468	payment	2134	2134	1874	1	1	8681	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73yPK1oMakzBPBfa91iKjz5yma1K8txjHNN1xjpSwWbMtZfta
50469	payment	2134	2134	1874	1	1	8682	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJBnxP5MDLGbRcS994K4CYB2r2swRobe8QnbU7MWTBGcrHtyn
50470	payment	2134	2134	1874	1	1	8683	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfqBfKLSwjPNrYqF2xZGHLhfyY8ZvRC3eDAhyJAJGhG65oYif
50535	payment	1397	1397	1678	1	1	18193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzYWGgXkEHpfuJHfWvJzGZnjmi5UT8bGebVjfUQQW82tZEuNU
50536	payment	2134	2134	1874	1	1	8714	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhrBVNXe5x5arxC2ig89tsXrTaUMRyLS2zGifzoMPQYJn3z8Y
50537	payment	2133	2133	1874	1	1	8058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuQ1UbkW86BaRTuCt9Be7ERtVcVEqHtWa9dtimyRCLGGFg2TS
50538	payment	2132	2132	1874	1	1	2260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagT5Cwy6dUdPF5adgbxpt6PK6maHE6kBGShum3KByi5szckf5
50539	payment	2133	2133	1874	1	1	8059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwdhi1Zsb3i8bd3SDnu2AREnDMvhKwYDKYhPVGJcdvNzTq4Bj
50540	payment	2133	2133	1874	1	1	8060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt326f5D3euKh7nhLJyKUSJizFkUr8x3VMzH2rwHsT2DLrCzLH
50541	payment	2132	2132	1874	1	1	2261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dQ3Qe8yzC56ewXcPHgeYnHEKedmCB9iM2XWctMmC8YvwQsKP
50542	payment	2134	2134	1874	1	1	8715	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEopYzRLVVwpL8rUBTD89ZFHbZT2RfKwZsWxX5dMPKueQQ6pmB
50543	payment	2134	2134	1874	1	1	8716	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgd12mV2PtDCjsQm4b3ZeuCmWFKRPrL3PRNChDKxJLmV1EKVBb
50544	payment	2134	2134	1874	1	1	8717	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLJPeKwsurpkZVXBJ4fKMf5uk7RHFAJqLwGTHt1vENJmtuR7p
50545	payment	2134	2134	1874	1	1	8718	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosjePKcsSFxZgHANR2jZZrHsCni4efG69WRUD8gxx53BbdSeP
50546	payment	1397	1397	1678	1	1	18194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1m2pnMpEPt8GxrBodghcU72tMofKJEB6npVsssVbESydiapoM
50547	payment	2133	2133	1874	1	1	8061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJ9mFnxHhLa93bjQ7yX6Y7WZvPeYJDFKriN3DnADVAikZN2n5
50548	payment	2134	2134	1874	1	1	8719	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsw2nJpk75H4qXGWaSHjam18945km1fNBChvtu9e4vEVjdAVP
50549	payment	2132	2132	1874	1	1	2262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CvqaktFhRsCAnJySMThbJLKc5wzJXxrFLue4W6mb9jJbuacK
50550	payment	2134	2134	1874	1	1	8720	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a54pYZgQ5FZtpGvf2Nywxc3xDWgWQiFEES1cKPaHqge3bnbV
50551	payment	2134	2134	1874	1	1	8721	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMgaDBwnPwD5x8tSNuUtBMLFa1Vvj5TESGbhjTySzHVbebQcd
50552	payment	2134	2134	1874	1	1	8722	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwcFYVKWbfwGMUyTJJN1Fe1UJvJRzBNjtEgMBZdMNKEpNRQdj
50553	payment	2133	2133	1874	1	1	8062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJQsD3rNjjPsyHg189M4xPrU4ecaiQADSyRups2Tw1S5zPPi3
50554	payment	2133	2133	1874	1	1	8063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVntzzr9jT3ouZhdDQ8hfXsngEiCaFfqp61zdoruFKJXeyPB47
50612	payment	1397	1397	1678	1	1	18201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvWxeQjfNDY8fTTbKb1Yzambnq5cL6t1f4YZrT7idGPdXTxTJ
50613	payment	2134	2134	1874	1	1	8750	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME1X1qfzAimDmvKYXDmxNcNMaydifz9T58VKD3miuYKKBzxok
50614	payment	2133	2133	1874	1	1	8079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkwhQuzPuJxQkrttBiAgykkvmyjwoVcBQLd8jUWSFrFaypMbQ
50615	payment	2133	2133	1874	1	1	8080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUwyMDULzWQDb9gzvcVxLJhnbpHKvMzziqtrmR54YQA2na9UT
50616	payment	2133	2133	1874	1	1	8081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG4PV4ob6zZwoiUNjRt2bdMpn1BSU1zcCw6ecyg1XyWTHNzHR
50617	payment	2132	2132	1874	1	1	2272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJ1DsE3tzkXoB59RwmWDuud2yNREkcEexbjgJxpZoBVxj4Tv7
50618	payment	2134	2134	1874	1	1	8751	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhGnNmBd95wjmLVXCfyLxTUfHyBZWY358K7xFWRLRz5pr2iiA
50619	payment	2134	2134	1874	1	1	8752	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedpLFrNzKQyzbRMFh3erhpVLvgrzNvoW79d59aAfNFLw4zmgs
50620	payment	2134	2134	1874	1	1	8753	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgpsvVDoLM74YuG7u2M2oqJTYe1ZyBhbPzMYAvrQAGfa8AgfV
50621	payment	2132	2132	1874	1	1	2273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgPsYsWYuGdiGCE75SS18xADa92KK3sP2WykCwC3tAYMpZXi2
50660	payment	1397	1397	1678	1	1	18206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Re2FwqMRZN8nT8bK8s6QWC6J2DG8mk1dLX6BCH82mQVQRNN7
50521	payment	2134	2134	1874	1	1	8700	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4jfH9rYU9Wh3M2WRPjjnnWE22hK8HTbqxYZD8jUzJyZbLS4q
50522	payment	2134	2134	1874	1	1	8701	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm58ZeaMBMgMg5RMuW3N4NyTVCDRTxyBGMRVG5gSjDohM2ViyD
50523	payment	2134	2134	1874	1	1	8702	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFU1zr2S8nkZaEpknQhUwRXreF1iZe1Aswm4fn3jmc1JQy8c9t
50524	payment	2134	2134	1874	1	1	8703	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUwTKyL8ujHa8eGGyCnqsPoPihaNPAdvqLajCNpjbC4mFpJE7
50525	payment	2134	2134	1874	1	1	8704	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSADD8DAzktWbSsBENETc8QKRwCpPp8TxZSjKVmMwYjnz5bYNS
50526	payment	2134	2134	1874	1	1	8705	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv3UrrKJF3BjTY4RR1qsCsZXvfUear5ydU1nrzRS1JpWUtDLx
50527	payment	2134	2134	1874	1	1	8706	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa396YVMq7wchdJkBJo6FYA8zExEhpsnmmXeMHKche2yUCF2bF6
50528	payment	2134	2134	1874	1	1	8707	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzHQcqfXyd4bzWgp7xhmgj15uRjes1LFZNJvuPtasSR2Sb15p
50529	payment	2134	2134	1874	1	1	8708	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNrxqQEFPqwVRNc5MgFPzhfxfyQLYTf82Nz6jN1eH9NyxYQb5
50530	payment	2134	2134	1874	1	1	8709	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZgX9MPdHNyEWZcnPi8vKdyKZ7AM6fTnv5UswbFHzfWWDutu5
50531	payment	2134	2134	1874	1	1	8710	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1X1N6RFjTqT949G1Vd14iq7MG166ncp5B31Li4EqjFbih89o
50532	payment	2134	2134	1874	1	1	8711	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEy3C3711Nf2LZ9D3qHdbdzJucJNHsz5XuC7hM63j9W8NvHh9v
50555	payment	1397	1397	1678	1	1	18195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6mHXJBRvLJ4aGQy25wrUUvgQq1FhyAvpLckTqbG4wd9BLfmm
50556	payment	1397	1397	1678	1	1	18196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVRAMqEkfGM6Jg3vGo3Er9sDqUFCj7FgBfHisB5TTYMHsJazc
50557	payment	2133	2133	1874	1	1	8064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQK71WrcCdw8GDZWUoXqAnwFtRjcMMLygLdEYxkPpNp1qeUzfD
50558	payment	2133	2133	1874	1	1	8065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2tmt6SWM66utG3LvvfQu3NQR9RM7tAUisQXwPJUhpcGc2k5E
50559	payment	2133	2133	1874	1	1	8066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFMnMMqM2QMQjpyZ6H4PMEdfjiyZ4wugxLeRu3MTaTeqkfHSb
50560	payment	2134	2134	1874	1	1	8723	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r9uEesgLkZNwYEViLXqjMBcwuNd2ZDB6fthKC4j7U1GmeQhQ
50561	payment	2134	2134	1874	1	1	8724	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuVAQk9bsRL29LDoYwHVP2j62tZpuueetp3Ma7DMAKYBkBVvo
50562	payment	2134	2134	1874	1	1	8725	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNPW6buWafymttfn3ErM2DgGS6G4vdiswVExiFuBLZAnPkWyp
50563	payment	2134	2134	1874	1	1	8726	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzhitRK9e83adKFyQNesU2tPLr4ZJhyBRxtR9rTj5ewhgPEvA
50564	payment	2132	2132	1874	1	1	2263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrBRk355VWeSHWDnXDKf1UnURzU35jK1acTh3KgU3XTPPEorx
50565	payment	2132	2132	1874	1	1	2264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDaHYzyzsPkuCMCtZgZ9f4ajQThVYRqLmzcZhVifmX2zN3Kb9
50566	payment	2132	2132	1874	1	1	2265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdK3uzu88DcFCTQnWWe4N8hDiTQeYKjcGzpX2mfaTq3BpA6adr
50567	payment	2134	2134	1874	1	1	8727	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2D9RE5CqApLAwjgm7KzT3bRnc9DBDW6NKn6yMig9WACvrhkv
50568	payment	2134	2134	1874	1	1	8728	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszaqHmHadNcYyyP4y7hoC1q1fdgJjAKtLCQp5cthnQU33Xxyy
50569	payment	2134	2134	1874	1	1	8729	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDCZsgV41cSyogayxbR3yN4ZC2QbJAJYNfg4ALaR45WLGQBn1
50570	payment	2134	2134	1874	1	1	8730	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtEivMUFW6LTHt9hWHUX44Raakx6G6hm4zhGC8LNtMzqKQkyi
50571	payment	2134	2134	1874	1	1	8731	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX9WxpfGLnWaQGTtQPbnm7B755tMX3jPG8Sj2KZJYBvTLq237
50572	payment	2133	2133	1874	1	1	8067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bxhgAC6DZapWXL1whqYe6ALDxxRW43Hv62HepV54QLR7L17U
50573	payment	1397	1397	1678	1	1	18197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw73qbXdw2og5g8Bs7zwykLYGEayVVLPkgJspXMf8yiQ4nU2ux
50574	payment	1397	1397	1678	1	1	18198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5aZbgZa8WV5iB6TncrpjikMSsc4S622DCwRosSKHQPXZaJtb
50575	payment	2134	2134	1874	1	1	8732	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHn4ExUCPkE8qBABBDtVGQQWWERzkaoNUki3Uouf2PSdkMNJBv
50576	payment	2133	2133	1874	1	1	8068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBn3RBpjQdwaTduDorC8EA4a7C8ki3nMMP8AoR37Fh7evR3j2
50577	payment	2133	2133	1874	1	1	8069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ58cjnQMamgZFJhVVY8wn7QE4JZeYZf89QMvYzFxEcZqfknEi
50578	payment	2132	2132	1874	1	1	2266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT986LMg4uWGAjyMceZtaTHvofn6DhorKTsarJRy4FihRsJbLb
50579	payment	2133	2133	1874	1	1	8070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzPqXdqWGyhtRnT2TvNM842uVorcXgf4ytXUzu1G68RxAkDrm
50580	payment	2133	2133	1874	1	1	8071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEoZoBGN7fmHkZ6PKLbjnesGsRrKtaR1LjavVzanWLka3W5GJ
50581	payment	2133	2133	1874	1	1	8072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm9wM19jC2df69b6pqFPqQUG8iS17jhComnZC9FVNLkCdog7D
50582	payment	2133	2133	1874	1	1	8073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmgLpngLUR2W1FscHxvdohDcedxr73iVtC6gBx1BbMD7BRJ9w
50583	payment	2132	2132	1874	1	1	2267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8b8o2HuxruVHAfhPsMNH6JW3ctW3ozy5GvXW8RiubWAi5PLh
50584	payment	2132	2132	1874	1	1	2268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq4WGc41poUKoYjTnaSgtPka3aJUXUBuA8rRHPTnAx9u5ie1f
50585	payment	2134	2134	1874	1	1	8733	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrfYpJRbeYpQ3WPVbJacBRjD8K8DnQQsRowoTRbDMDhUHvbVV
50586	payment	2134	2134	1874	1	1	8734	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbri5jSA2KkqkcCy52c1Xs2MgWWM7TXkpxG7dBBsPsPFLwqQp
50587	payment	2134	2134	1874	1	1	8735	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gLfeDPkaMFP628hQPg9dVRV8baveimBCjyEi9FdBWUZtYA5d
50588	payment	2134	2134	1874	1	1	8736	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMKfH9BapQCmtjgnhE6WHaVbGSBPvN6rdQtMUpxaC8xtHKbnW
50589	payment	2134	2134	1874	1	1	8737	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqC4zaWThkMT94D7C8F2jdGXS2ordCVAUFfY3QG4Kd7BEdPffg
50590	payment	2134	2134	1874	1	1	8738	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAG6jLuuaDbYo7BrfB7UyeDMs87PXW8HMuBXHHAMEqXyGUHT4
50591	payment	2134	2134	1874	1	1	8739	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafvhVzRwb76jVqXxGCtdzsZGqgAViU1AVvvt8s6KiXZJH6zto
50592	payment	2134	2134	1874	1	1	8740	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjnYvBq7BLgcnUpZDY9JSBc3hFi27PhkTAi7TNmAQrqCtkZG8
50622	payment	1397	1397	1678	1	1	18202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonaD2NgvQxvT1WP3bKsdRDnNxiQXrJC7VXPDTuaWf5YpowQvn
50623	payment	1397	1397	1678	1	1	18203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvNeAbHrJrqiXjaXHbQ3kBZ2n4QnxY841CtwNGPLiTRPvCFKh
50624	payment	2134	2134	1874	1	1	8754	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhHRBmed8Les6PoqAkCZ87Cvx5778bZm4pYy9YZCbw9j3eniM
50625	payment	2133	2133	1874	1	1	8082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXAW468oSjML1toNSMkXtmf8J1Na6VDymsaYphh1bb2eQqWKv
50626	payment	2133	2133	1874	1	1	8083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZKgLyUV4LMCEuPfV1ZY7ufPjJYXg1qNTcHBY7SiuhzLMYk3p
50627	payment	2133	2133	1874	1	1	8084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1PbXYZmDQvwpdUaG69F3n8bxCDYwjDiZGsUJ3xLYDeWgXhCA
50628	payment	2132	2132	1874	1	1	2274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdCqVRxbQpSDukUk2KTLbtDFX8hLJCBV1RZTbxFD585uLFeRE
50629	payment	2132	2132	1874	1	1	2275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77JTXQATshoqW5r1QZRkxj7iTnZoGjGaVw5YDfVeAoVjTFve9
50630	payment	2132	2132	1874	1	1	2276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsUa1tKACZbFKF5nJeLjJ8ukGeaJP9PsVfRCkW1B6gtSRZfVY
50631	payment	2133	2133	1874	1	1	8085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XmbcZP9My9VhrGRsf1hSLDy6ES6Ba5YvD68SbQbvHjX172ae
50632	payment	2133	2133	1874	1	1	8086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMH4zvzv8G12h7yqFbP4pzB1TjqwyU8WyTWRAsviT2TicxUwLG
50633	payment	2134	2134	1874	1	1	8755	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSEAKQ9RZ3BamibvRQShTRxyE9q1Tf7MrZegqENe3fM3K36WR
50634	payment	2134	2134	1874	1	1	8756	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2ry7nhr3ke54HpoS3De4R9pM3Zh9FWr4BBq1dBjaTvc1aRYR
50635	payment	2134	2134	1874	1	1	8757	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3VxDjjW4HDCfaaq14VyP2fYwvQwRManHEXqyysDipZygGrDM
50636	payment	2134	2134	1874	1	1	8758	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRcZxskgWaaSB2mboctp1sGRDFtWzEo2DcMWs8S3RcumyHsCU
50637	payment	2134	2134	1874	1	1	8759	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Xd8YthixwzVJsmAdprP5K866BCb6GsHdZujaLrCEdjSNvyjr
50638	payment	2134	2134	1874	1	1	8760	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3RmZGbqUKiaEXadpAb5KUvm4arpFM7KTCmfUB9iYo7NRVZPs
50639	payment	2134	2134	1874	1	1	8761	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaLAaduegW4NSLsjYQFAfc7BsG3VDu8JHDWyjVsJekUH5DtGf
50640	payment	2134	2134	1874	1	1	8762	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5s9e5WGYgntbnCyzKUBSnKBkNFiXb48BcWk3tp17aLwwTe6R
50669	payment	1397	1397	1678	1	1	18207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZ3RGoHKqCKFbGBk4cYBzeJhLbDBFCyR6FT3YiXYWVQ73MPTi
50670	payment	2134	2134	1874	1	1	8777	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeSQks7JjDyXeabXV9L6YweXpxWP6tWzs1DTJc984yugiZMg5
50671	payment	2134	2134	1874	1	1	8778	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm17DTiX7cxfb6TgX8TqznU2UCWJFJuDKeuaZc6wLLDc6Kbxim
50672	payment	2134	2134	1874	1	1	8779	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouweePh7GCRFAsmGwR1yT4hCaT8XSBZpYCwFLXP7SqX8EFX1q
50673	payment	2133	2133	1874	1	1	8094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHxUoSgdte2zxsgN5sfcRkEwCbVHddfnNntCJzJx32evbEbFH
50674	payment	2133	2133	1874	1	1	8095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7V9ABDvhGQNQ7cS2Zq7kmvGoxkMsSmdwYKJCmQnyvSYVorvwg
50675	payment	2133	2133	1874	1	1	8096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimtwMgfUMBA8Ja41QGXjUJ8885S6qxzf1QG7NVDmemGj6zDR8
50599	payment	2134	2134	1874	1	1	8741	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjU7ufFJeSAQig5zhhs5WXX8W3jRTCvFRtozZd76eJLyprbSv
50600	payment	2134	2134	1874	1	1	8742	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULPb2tJhDGtDo2PLMUNSF8SXmt1Z7c5vGPTDPXg4TUmjN8Yio
50601	payment	2134	2134	1874	1	1	8743	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKrZAYTFYBCDRKyMdQt8em4q5yCKSupwHcMsdtigPTy1VQ9qo
50602	payment	2134	2134	1874	1	1	8744	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHtQVkSB5ivou5JqUUn7nH1aKzuVUtoH526Wt6DUMfFV7pcmx
50603	payment	2134	2134	1874	1	1	8745	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuMLAkdSc5kCMJZ9QnYcq7tVxzTrtLjU6JmZfeyBxzpjKthH8
50604	payment	2134	2134	1874	1	1	8746	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYN97YdumyYLHqa5oKrvRS29RacQHQHz6GwQr87WdRqQzZnBV4
50605	payment	2134	2134	1874	1	1	8747	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfMtYcV8fNdnndHXnpPbC9JaX5RJo3HH7P8gquXuBCiX3sJQH
50606	payment	2134	2134	1874	1	1	8748	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEj3kBZdjb7uCjmqo5q5T7c3DWwV7YqiS2NNwHGV8hJLAAgfJ
50607	payment	2134	2134	1874	1	1	8749	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaWtTcv3trPV9TTbtj5qsCHbQ3Dx336YxcfdXqqMd7XTeLYPp
50608	payment	2132	2132	1874	1	1	2271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJacXQ5vvgBXeMgwhDeeXMMAAg6HvX5xwo7XDvdM1nDvq2nxSb
50609	payment	2133	2133	1874	1	1	8076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYz9xajLQrA5NGzSyjFftSCmmzNAQL7exadsgrBnkJwF34v6S
50610	payment	2133	2133	1874	1	1	8077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfj9oEAzS21nJz8ntxFMrvmS4vWsFjxaS6FZPtQwaNqYWb6gn
50611	payment	2133	2133	1874	1	1	8078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygf7AYX29gqMg4nzmf8zeeAGKUDT2boQYuh5cdttscXuCTgue
50743	payment	1397	1397	1678	1	1	18215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCRoSRSgLhPpU2PJB4HR6tK2GabkhSzoAuyBLsbmYcEirWrvz
50744	payment	1397	1397	1678	1	1	18216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMHCJ46BkP1qq5C9EKHCwkYepkouZgenCoJLANTiSEnreNGKs
50745	payment	2133	2133	1874	1	1	8113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmGhKLvdQZ4taAcB5ngr4b9u3crAM6TfcRkt7aeeJWcohEHHy
50746	payment	2132	2132	1874	1	1	2293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZop6KSW5nqFY2tXxytniBWkwvyDoRcNPGEqrV6qxTXUkLSGTHs
50747	payment	2132	2132	1874	1	1	2294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdV3XVf78ZvSzzyjM4JhKnafdj65bsowrVixs2ZCqW1L7LxQZ8
50748	payment	2132	2132	1874	1	1	2295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMw3bbckADCmGqF7t19g79Kn5vBUfmMkEwRvCenUhkRXay45r
50749	payment	2133	2133	1874	1	1	8114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSMvhURH4inTg1awfvQpE4YHxmQCsntHVj3ddLq3ae1eKosPE
50750	payment	2133	2133	1874	1	1	8115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjc4nrc4K2avmdgVEnhEJkyfZEnA6jRH7fP5KdLAHBWtkNeKT
50751	payment	2133	2133	1874	1	1	8116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7fYGKBDfaiJYKZsBui8fSxdT8piPVczUbfqLGBBcYFNuBWir
50752	payment	2133	2133	1874	1	1	8117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpRmESNd85Zhq2K1MqXQ5HLns96aPfztvke2T4VuGv8wr9VZ5
50753	payment	2133	2133	1874	1	1	8118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwmSyVWCWFn4fJJP5X6zPH7pp7LSSsKtuRyTgmJNSSqgHw7GC
50754	payment	2134	2134	1874	1	1	8812	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8Tz8tWVps8mZABbMUhDzCj1DcXhK6ZXFrdkp8cvq5iPHGWKa
50755	payment	2134	2134	1874	1	1	8813	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowD4r532ph8Viki9BftC5kD95MtUZMVyBxsbvhDt898kqKCKs
50756	payment	2134	2134	1874	1	1	8814	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjFEAYotysdCn3ZXoSehmBDUfgzeZ6T7VLhvHqyF4zCqEPAhF
50757	payment	2134	2134	1874	1	1	8815	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUrWuy7ruAbW7cjhVWbkhht9KxVLqUn95T56nQC8CMaDxEHuS
50758	payment	2134	2134	1874	1	1	8816	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnNrCXToD6BrAEKBFuFWmnip4pokeP9qwP6H766qCC35xnYve
50759	payment	2134	2134	1874	1	1	8817	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXx7pmR74gaRNiLFk4PG7fZCm6NnCcBcTvJHy27cnKkwg14hE
50760	payment	2134	2134	1874	1	1	8818	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5qdUuNsBYjohESj7XQNtjEtF5QgPkB4jQ4fkhtgj4SGLT9PG
50761	payment	2134	2134	1874	1	1	8819	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGjyNTMjDHZZp2Vcz7jBipmV2YAUKzSZL81DoUeMRcxz7SaKB
50762	payment	2134	2134	1874	1	1	8820	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqMs57MLg22P8erA9xYyzHhrkXJZQNhhMXiY4iWV3XqbvozzC
50782	payment	1397	1397	1678	1	1	18219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6K13pUCHGvgKERcijV1veW8gpFPQ8wWimvScXryqMazQS6LJF
50783	payment	1397	1397	1678	1	1	18220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEHiSz2VF7P9WAS2MeygWNVUoPVR8wToV1REnf6a6Srv1awax
50784	payment	1397	1397	1678	1	1	18221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBt34t7DSWdExDkw7Mez6HJuavajw2X2M8fktkHy7eAGbWoc5R
50785	payment	2132	2132	1874	1	1	2299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNwWys2QKa7htQyXBRpD9Pw8hXuZ3pdr73biihiG8FUzHjdAV
50786	payment	2134	2134	1874	1	1	8830	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWMokzGYFXvAnWXUECR1MTZNuKEfmAmFU5VkGHu6pqCJPjwVo
50661	payment	2132	2132	1874	1	1	2280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEMaSsXwJrc3K4ko8HEsnuhxXJn8K552EQpx66ZsHMEQTBbTV
50662	payment	2134	2134	1874	1	1	8772	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcWZpZVANSjigEAYfdQ5wx2TcEzBHZQcQoG8Myp33iftWmWTe
50663	payment	2134	2134	1874	1	1	8773	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBpnBqcmBKgAbUUur4dWyna1edNmCU5AW2PefcDqmFYFvqCNq
50664	payment	2133	2133	1874	1	1	8092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LbYrrVS8ioeSFmSFboroxShCGtNoKKsMEteWBSNoRohRDQD1
50665	payment	2133	2133	1874	1	1	8093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZE2obQTq5A49bvTTfe5Zh1tkCTiif4ZF7bey19bxoRT1rJ18
50666	payment	2134	2134	1874	1	1	8774	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxPijQ4MeQ2WyNxbVvS76AsUUzAzgR4MvBWnG2jSQhnmp7JCf
50667	payment	2134	2134	1874	1	1	8775	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9cJzNUdiDkVX8fGBUp8SM2S21cJSJL7ZYW5YZx3mFV1seKJr
50668	payment	2134	2134	1874	1	1	8776	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZ8yw8egCHrGxczhfN8HsVSdBrzE3U8WBcgpJ5uAfzK9ULf4K
50688	payment	1397	1397	1678	1	1	18209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eRqSCfVQtNBAPZeq6gVfsDRuwEqkMkiMRYcY6zUHo8jddPn5
50689	payment	2134	2134	1874	1	1	8786	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgNYbUQfD5rde59oocjz2jihPUJmpEzV3WSNtMr88V52ammJC
50690	payment	2134	2134	1874	1	1	8787	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9MMRP5XtZ5hmPcBdhjUAUtMH9wbuX5PS6sbg1tULa1E2Kca8
50691	payment	2133	2133	1874	1	1	8099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tBpwz6FRHyFZBs8iVg7CCrwDTZmdQjsHyHCbPdKtXEmQTa82
50692	payment	2133	2133	1874	1	1	8100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2LAi9ViLh1331x8BZCemSy5mZzqbsdZbzcbTKJ7sCfnN2MqK
50693	payment	2132	2132	1874	1	1	2284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHtbbn29wd3Sro1DABkW3EyuFZVJMtGeAe6i9eAKbpZj8mZom
50694	payment	2134	2134	1874	1	1	8788	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLB2YFcwadSsU4NC6SBDz3PjqdiG7WHDPT83ZHaVbi7A9EZSk
50695	payment	2134	2134	1874	1	1	8789	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyoC6AVBuiTuaMD6aDf4aTvAyZ9Xzdm7QX6PivU24GKK3JFX3
50952	payment	1992	1992	596	1	1	6	2160000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhks3GdPaQTLq47vxX9yYJnc1wahqCdG3b2txP4yMLuqKypbfX
50953	payment	1397	1397	1678	1	1	18237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK39bzC2fMqWJwqhSP4frDmaHf2J1vcX2H8ue4HnHjPRqp2iZu
50954	payment	1397	1397	1678	1	1	18238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD2sjYDJMDwDaZ5yTBT4KAuGkWwhkHX8zZD87aoWRfPeUwevr
50955	payment	2134	2134	1874	1	1	8909	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcH39bqCRVt5GdCLXqFjgDDYwsCfY3bds6t43bPQPR6gpq4cr8
50956	payment	2134	2134	1874	1	1	8910	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QKShQ6hacx8EQsHWsfM7Ky8Kkwrt836ARALUFhicrwEcGDwu
50957	payment	2134	2134	1874	1	1	8911	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHMHzLWNZQLerwP3Nqf8KGcvTBvu6AbYgmTugqNBWg8xBwUyY
50958	payment	2134	2134	1874	1	1	8912	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9wF3tX4GrxorjKQuZrt6U9fVXXRCJt4eox5Hwepnog3S44bw
50959	payment	2132	2132	1874	1	1	2325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPa2kuvJfnT4avZLdHzMsGMvrwqZTvuRUfJgUhG3jbLnDCKuw
50960	payment	2133	2133	1874	1	1	8169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPhUosk5HspMibHwrs8vDh2Arg4KfXVg3qxgz6ZvHWBw1XfNf
50961	payment	2133	2133	1874	1	1	8170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTJD97h1zRhgbDxyEKyR5QG1syPXbrkjwoFUzWg7peaYhh7fR
50962	payment	2133	2133	1874	1	1	8171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtX9toYgTp25F7Mz4Z92ysdonZtChJmVM5oU2A5WRdaZPKGvfG
50963	payment	2133	2133	1874	1	1	8172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiWLR5DLsoSJqFyVh346d3otWCKPmcQLjhADowZtB4Qhwfkwb
50964	payment	1726	1726	355	1	1	8370	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwyzEvk9kKfQiWWpcMxzRChgQ83opV6AyzhwfSpjwdHLfbp7PR
50965	payment	2133	2133	1874	1	1	8173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygy8ZCN8bNcVMCqnBpAjvij5MK33LGx3gbSAikAP1jexdy23p
50966	payment	2133	2133	1874	1	1	8174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YUtzDaVAdAK4Eab1dMYu9MimffHrxbqJK2qNuiwJWpfcaXuh
50967	payment	2134	2134	1874	1	1	8913	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXyz7GaTEsQkeDdTeLnoZqWj5k9eXyKis53t3zjFmErXLuTf5
50968	payment	2134	2134	1874	1	1	8914	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnEFqKhESM553tw2hWvuCCMYP819tUXfDL68PfMByCWuGn1hEn
50969	payment	2134	2134	1874	1	1	8915	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFfnnfSdQvmSGegByQbxef7R69iWvutTZt4ccatxDEgHzW4Ya
50970	payment	2134	2134	1874	1	1	8916	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsz7pdPgh6jkXMJEdXsLp5PEgbT4oejNrjTmoBZRVKUvhAHe13
50971	payment	2134	2134	1874	1	1	8917	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqznPEK35FPmqsgVSp1YZW8gkMgjJWkc5mkGMXEFsH3W6BeR7
50972	payment	2132	2132	1874	1	1	2326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgbBH8AMm57AK5QVSURehRY27358qAfcoVrBnvuR1hPjQAcNr
50973	payment	2132	2132	1874	1	1	2327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5sCpe4CDSBpyDJwvja5BicHjoZRrwHq8j642jKn4Z3Kt3pxD
50676	payment	2132	2132	1874	1	1	2281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKY53ZbaQhmYRzKWHmX5XcET5891FmvJ4pSBj2NFZQoEp7Vup
50677	payment	2134	2134	1874	1	1	8780	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7P9CcqkVaETuMHXCfGNi5RDdVPAFTPrgHGBnrdSeziQTcwNtg
50678	payment	2132	2132	1874	1	1	2282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcdTRZkLkVtHJQetDqDKMiMr9q6Q4BJWX7ZFHnAJFZ9535dCF
50686	payment	2133	2133	1874	1	1	8097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxBiW41anADS68n33CCFqcJTvUfjpg9yj4WfbLhEprdEXHkWz
50687	payment	2133	2133	1874	1	1	8098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptWP4mqznqgvFfW7fcCJed7Vs8aNaqpR3EC9SGpvpix49Wiac
50734	payment	1397	1397	1678	1	1	18214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUAxMjKLyoUCFTsMGVjABB8kJ4z3QncQbWVixrVJ4Nyw2KYGz
50735	payment	2133	2133	1874	1	1	8111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGEjH2PsonDmiGbM4dhZ1WU7XAfHWqi3pMgvGdFct3i6zZjFZ
50736	payment	2132	2132	1874	1	1	2291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPTBHjbzUKednsB5Z1tEGGSguLXrLU3WENZGZUSDqLKbKMKV4
50737	payment	2132	2132	1874	1	1	2292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMHyzgFicL45YtrTqBbyF9cZUkn1MUsNmHNXvhmkYgiwTxJKZ
50738	payment	2134	2134	1874	1	1	8808	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2fYCTdxno7ABtwJYmMS8hFLeKRiMsbzaaxi8h3SVGnsFVW3J
50739	payment	2134	2134	1874	1	1	8809	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xSnDCS38aBrWiKGX7Jgz9mKCmBiAzPTMyooTF3aLbWzRiQPZ
50740	payment	2134	2134	1874	1	1	8810	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5GFH9TEPqBW3xUYdTMiNVHKDbUXsSK3sR7Buomvkkoj6cbHH
50741	payment	2134	2134	1874	1	1	8811	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmdKyS9zJwj3yHits1BajttXmnkSziw1wJ5GZcsnBGStUoFHSu
50742	payment	2133	2133	1874	1	1	8112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBhzSF6vJQbobPYBGMsZaLtdvmuyh2TDfGefvJVVgdP9zJi6Q
50773	payment	1397	1397	1678	1	1	18218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvUoommjvU13nkStfHr8NMt3kLF72SLB3qc6woGhnTRMgrkcE
50774	payment	2132	2132	1874	1	1	2297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeMZDtmJf5hyuWRtQpMfKepFoyB5HpY8tBRozdr3YxtDyDhmP
50775	payment	2132	2132	1874	1	1	2298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9hRAfUXTTopjjrSTEPv1qFo9uwEXDgvwDbTqwoXKdZ5Wr115
50776	payment	2133	2133	1874	1	1	8122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BEPRPnTdtW4xtx8WzcaxXWyccDSJskqVXG5wGTrYNni4Qk8H
50777	payment	2134	2134	1874	1	1	8826	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfXCGAQ8fTTaX5oVov1Teef6ibnXahMEUj28yKuv9t8QbatAc
50778	payment	2134	2134	1874	1	1	8827	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvTN1fn2kCbh6AcyvZHRDxpN8ifG5EdPCE5RNZhnEvtymcHPw
50779	payment	2134	2134	1874	1	1	8828	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6jjBeL7DZVxoZ2PuwDCb96z1fL4Mv3AN99fP7wRSwnKZvYyd
50780	payment	2134	2134	1874	1	1	8829	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7SLb3bDwHpHuXrkXa83Kne1uW4RXT4hgZ7gCbBKxuwT9MYzb
50781	payment	2133	2133	1874	1	1	8123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sL4kTnVGAGYy9SoyG8U9xHLqrqBx1zcLHmGkJAeiT8dDdeWA
50811	payment	1397	1397	1678	1	1	18222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2csWK1qfRoCmUgwqT8e4USTGBKC3McKSuSzzYiePPhexbCRiq
50812	payment	2133	2133	1874	1	1	8132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAfzRDj9n9YLMSuXZhzHXSr3phr1SxzZRVVLKrCaN3T3Myvu7
50813	payment	2133	2133	1874	1	1	8133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjXQfGYSqDzsZQZsk1iX4GhTqCkGh23yqiUmi45zydPajHKiU
50814	payment	2132	2132	1874	1	1	2303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR2Q81rU7V4CaixKFw5ED6SozMWa1EjWasm7irxgc4hT5fQph
50815	payment	2132	2132	1874	1	1	2304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFP3MVg6pdX1afC9t5GzxREdHXNkCRwi7cDc8Mxa1WCV5Gpb1f
50816	payment	2134	2134	1874	1	1	8844	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruQzKDZWvb9aiQ3ivF9A5drxU2c5v1JAenjavVG9eqg6qNJAy
50817	payment	2134	2134	1874	1	1	8845	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNDZdjfuASR8SBoBsKoW18XnsUduGjFRFAr6YbiQcXVcSewxL
50818	payment	2134	2134	1874	1	1	8846	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgrnD85ZZbws2JQas4AMbumNLePJ7DnC5zjnGYpfDsP3ovUyg
50819	payment	2134	2134	1874	1	1	8847	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG53waoui8Wyv1bnkRQEkTT3SzXZ2Qpc2GPUBEWag6JVpXGhBq
50942	payment	1397	1397	1678	1	1	18236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQrDLcbNJdgZ6c2bpnX6jNdYzZEPBCJs8PL28AG9tscmD6m9E
50943	payment	2134	2134	1874	1	1	8905	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDpsYzq5fPGbcYvWekRu8RHNhFMHMN21doKYu3sbkECW62qaW
50944	payment	2132	2132	1874	1	1	2324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3spowywfkwmfFmyBub1mEBoMsvrRvoiAU6BzvaFDnqp6STuL
50945	payment	1726	1726	2435	1	1	8368	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYzWnRWffu392r2q7DgQKGmmi2qoijqmGbxLPgw3gzG2fpV3mxe
50946	payment	1726	1726	2436	1	1	8369	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkfQ96Ho9k9suffyRV2PbkD5QafCDq9hjHLTExprMXn6G4SmYb
50947	payment	2134	2134	1874	1	1	8906	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTKUFPGNPkMYTaRSCP7x11kMZy5XnWBj6qTCnfzCH29iB9KVb
50680	payment	2134	2134	1874	1	1	8781	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqNdQ15idWt9VuzkH6EJpsoSfhK24kMEiMRwYkSMbBD5kDETY
50681	payment	2132	2132	1874	1	1	2283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGbqsCVHRkLscDKHXssRadKdCaCa9kvNMRAuEYkySXGs7BXsk
50682	payment	2134	2134	1874	1	1	8782	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCYXhEzq4yXQxmAnUMBNXwGoVjty3nRf8H6gg1ETQH76bqc46
50683	payment	2134	2134	1874	1	1	8783	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCn5qzYwiQADb6789tXJsFonmiAXjcKoYqScrxiu5YuPYjS3L
50684	payment	2134	2134	1874	1	1	8784	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukTHWek2ZFxxUqPra4ek7fkZCbhfwkzxPUj6wPQcpyMeTUnhZ
50685	payment	2134	2134	1874	1	1	8785	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBG7rrd8fYoe59yxFXcsf5PZy93cvuLVMm5tLJpBVBQTMm8yX
50696	payment	1397	1397	1678	1	1	18210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedDQiwmEjaFwz1PdJAVtCfY7Faepej5UadnXprMdpagtUG5Hi
50697	payment	1397	1397	1678	1	1	18211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvFAgHqa2HfZsQYQaZiugDzcuZCUKAf7p7y5HpnJRctA1aqSv
50698	payment	2134	2134	1874	1	1	8790	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHKoHCUqAGER1VfaU1e6NjW9qaH27U1EBWRQBBdhrPJARLR9p
50699	payment	2134	2134	1874	1	1	8791	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgfZaTva7P46NspytQA61eUPi1U2131iGmNp9HdwUnhVwreHxp
50700	payment	2134	2134	1874	1	1	8792	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CzNT8qJSgoVPuw1uY8buQcJf77k1UGy23gKJ7H4j5NpPAfaE
50701	payment	2132	2132	1874	1	1	2285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJGiJ29FjCUeebCCidneLuMBGCBQ4wrFmy5aYpsprGrPywk7v
50702	payment	2132	2132	1874	1	1	2286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTh9dUBHtQixEo9Dn36EhkgAMTv5WBoagHkt4BeHNbjzLSo1Z
50703	payment	2134	2134	1874	1	1	8793	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1YJffnBDyGnb7MknzgJwKxxpkzjzVfZsj9KZTAF8wtYQ4Wg4
50704	payment	2134	2134	1874	1	1	8794	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmn99qdyqzeSQxjkxT4RmsWLYG9WPLBXQEqyVW7YrFW6196DP
50705	payment	2133	2133	1874	1	1	8101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1n4UixVX4RrbVD2gyVh6K7JKU5F5nrEeYAUybcGLCdD8kgBrj
50706	payment	2134	2134	1874	1	1	8795	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97nNXveJsFkg2n71GnyqkASB3uzNobx5kMAddHxZMWaoUdyrS
50707	payment	2134	2134	1874	1	1	8796	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6j8P7SULQbAn2Z15L2S6ZNzqDaAY7CsJuHoXyNkFAH3ZxjCZV
50708	payment	2134	2134	1874	1	1	8797	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWJWSwnYsM2M4Buuqpf1MtyzMRRd7XUfV3rg1dAm5p2hzPUpb
50709	payment	2132	2132	1874	1	1	2287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJQg6UL8tg5JFJpsJHiyfvWkNc7Qaug7TidwMfhEexAvw8B5S
50710	payment	2133	2133	1874	1	1	8102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzQ97so5aoCmLqPzJQ8cGF6bgTpBpFX1SUgwzgt8erDmU3kUj
50711	payment	2133	2133	1874	1	1	8103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoVGaBvhhwAwnpTskQJSAK5ZYDHzne1S2vMQc7iy1m2NnbgKy
50712	payment	2133	2133	1874	1	1	8104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XqwRqqPLPb23vhmT6uetqVBQ9xWttkgXoXuNsQqrrXhC62RM
50713	payment	2133	2133	1874	1	1	8105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvR94bZq3CTB477yLXMG1u6B1P8ef4E9xssQkTwiVVW7EjrFJx
50714	payment	2134	2134	1874	1	1	8798	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANooPW68UhQQftEURd3kqJ4vfA6omXkVhHwm6u3gUnb2MeDU
50715	payment	1397	1397	1678	1	1	18212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjU256n5nWLAjSTrRrUSuns9NPfzJJsnHsZ8HvWjMKwkHUg7ng
50716	payment	2133	2133	1874	1	1	8106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDczinAHZGnZ4Cr1BkRMHj71kNx3S7bYTiFYcpimaBqM8MBQj
50717	payment	2133	2133	1874	1	1	8107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8vZBGtrY8CKbFABkLLHeVJm4C8mQu3mSnc7zLUvmsTbUZwVT
50718	payment	2134	2134	1874	1	1	8799	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztiYrjMUwbA7fXbq4AA7ANj9XSTueXZJMF62ep38Yq2Z2dCDC
50719	payment	2132	2132	1874	1	1	2288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1dqVVuF4LvHC3NxPHxQ2y4sBrMBbohXNqA91Hk6pjxCAQci8
50720	payment	2134	2134	1874	1	1	8800	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJM6WtBrG41ris2u1VjTXyAsjfSBU3vPpucLHPvwED2j6fbg1
50721	payment	2134	2134	1874	1	1	8801	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xSPKAoaXEeutjED7WFUoV6QnU3ktiouUzQyTiDCfG7fFLY8g
50722	payment	2134	2134	1874	1	1	8802	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywyNBcxTipQfmtg6Hs8urRNEYiE5Eznc4r3d2RmTn3kXv8ufH
50723	payment	2132	2132	1874	1	1	2289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jNcgJwAvtLP4bJjP7dfqPJThh32UM58UQ9qJeXqRcNwPwy7R
50724	payment	2133	2133	1874	1	1	8108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzVgEfKkQuNDJs9SFg1NBgLgYiG25fcGWPoQhMtby4C1PeQmM
50725	payment	1397	1397	1678	1	1	18213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiriyr4dK5tSB5HDrt3AJn6gYErvdvNqbdLam5N3XtL3LJmAU7
50726	payment	2134	2134	1874	1	1	8803	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5CCfxG1zghDVxaGLztgkfbqxu9SFEDERFPrYAN4KFHCDzozY
50727	payment	2134	2134	1874	1	1	8804	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdxVTTiWwruhHojZQSBs6s3mi5HxY8RVZiMX14Qko69PbzCjJ
50728	payment	2132	2132	1874	1	1	2290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2k8iNRRBUkP3vsqREDNKbajLFcU55SBp39V4dXfTmKz4UaUv
50729	payment	2133	2133	1874	1	1	8109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiWN18m3pucZYcjoFH8gpAR26o25RLH3HuWFXk1Lu3AqaNa8G
50730	payment	2133	2133	1874	1	1	8110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEZbsu7p93QzCVYTnfVgV3bwQa6VpWv2yNHXE8gTGBQB6R9NS
50731	payment	2134	2134	1874	1	1	8805	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbosyYc6vnnUMm5PEG9ke33QSQ1EFYypgJmwZJEH5Hgs42D6F
50732	payment	2134	2134	1874	1	1	8806	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3ZCbVtmtEVNgjBLQ6c3y6ULzm152LpWHLozpVhitWdCXswvB
50733	payment	2134	2134	1874	1	1	8807	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefmKpQQoa7hbw7dtaNCQJz12uj2K613fbh5mCow1VVYPbKpoG
50763	payment	1397	1397	1678	1	1	18217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ552cFfN7MT9ogqCLsd3kcJS31asRoSMFahCaRRieCt4tibT9J
50764	payment	2133	2133	1874	1	1	8119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2V5oNDJEYmTU7V51LK8ZFLwFbDmVAQQdu2zbaXVay1obKiWq
50765	payment	2132	2132	1874	1	1	2296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBap4Lzif84CJtE5nzS9uNmYp6zu1Ecm4Ahdgr3dYjEPs1RiF
50766	payment	2134	2134	1874	1	1	8821	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDUeWWTDrq3ZvDdCVhR1Uy52YRox34N7U4NBASHH5u8qe5JJ6
50767	payment	2134	2134	1874	1	1	8822	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKFquwwsue6jrXWpSmw77LPx3JhLzjT6yqtxawG15kK4CTSVX
50768	payment	2134	2134	1874	1	1	8823	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5gLj7tJX3hBphZVvqAp7AkBwQGxjvyW1gVhgU54tYQTW6343
50769	payment	2134	2134	1874	1	1	8824	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwFox1ZztSUBu59BqyraPL5T3R6m64wqZvo6xQEUrnNSgPEzU
50770	payment	2134	2134	1874	1	1	8825	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnt3prnDPysCpH8MkoD9KEyBbe2Fovd1SPzCn2ohu8A91sXJe
50771	payment	2133	2133	1874	1	1	8120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BMTtMrAkAiMW8mgBKRDX5bXWyzLAfQVm8BVZMmFcsoDVeTyg
50772	payment	2133	2133	1874	1	1	8121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHNz8Rhq22zFSUprNrWGQYK3pq8pGHhGL9hGo2oEeG5qiJAyx
50820	payment	1397	1397	1678	1	1	18223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87S4Xtc6rvoBBN6vRfUSX2WBq4XqtMwN4mhjYF4MbTmrW6e85
50821	payment	2133	2133	1874	1	1	8134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAFkRepVk3uZzwaQDkrSHUnDDwhCFG5tU9n17udfbtPU92h1j
50822	payment	2133	2133	1874	1	1	8135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrY5BwUYWtQXh32DBSjoWSAwqhVrEJmzS8xrHZ22R68HUK1R53
50823	payment	2133	2133	1874	1	1	8136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpT4jxPD5FRcCcQaXYrhE2uSHpYUhTbHZrRqxZrCFjBU5HVRrv
50824	payment	2132	2132	1874	1	1	2305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLaLiwcVetia9UeprKMp3tZuWVFzFFu3Rv9fEaak18oWbUPGo
50825	payment	2134	2134	1874	1	1	8848	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LJL19EckBv4sm3i5t49QJtYJEeewBjPUsKwbXsVVgDpzZinC
50826	payment	2134	2134	1874	1	1	8849	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1PxnmB18rKegMKiK59f1P6xEqaWtgdnWfFLMaqu8PAJeRpPY
50827	payment	2134	2134	1874	1	1	8850	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtWmDxBmHu1SjtgfsFS1WHkhM9mtGkctLr3uYmguLUv1nUhyU
50828	payment	2134	2134	1874	1	1	8851	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvy1P4nuyk69aBWb83Lzxi3CoxMfgGFEREde48RaTrZPxW7QTb
50894	payment	1397	1397	1678	1	1	18231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ztFWm6axYzZ1TkCPVeGeLmknSn1e8zdjzXP9owsCrPxAn5Cj
50895	payment	1397	1397	1678	1	1	18232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5K4YZ3XqpaWKB9xRQMUgPgesnyUN33M3hkAZkd6JTfdND57H
50896	payment	2132	2132	1874	1	1	2316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBAC7VeSWhfft4EuonGYadgsEiBHr1ScJdMzgyVkWE9ktumqF
50897	payment	2133	2133	1874	1	1	8154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPRMdqb22xAMLxHeuQRpde8Y9bx68QDijV26WVcR489qLBJ69
50898	payment	2133	2133	1874	1	1	8155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJSPrnLZ1mNVfobC3HZmvJWjmHXUYL8rAXU78zWXiceN4P87u
50899	payment	2133	2133	1874	1	1	8156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD24A3QSANrE13fKXxUmvyjZWmQS6BJHa18JbM7fBc2RhAKC7i
50900	payment	2133	2133	1874	1	1	8157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gZhTqtNL22Z7ehzEyz5q1Ais7Xqzh6HQBjU3ajuSZNtFWf6x
50901	payment	2133	2133	1874	1	1	8158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubSzR2DpUuf6jqLmXLqBCcpoaFhfVb7ZW5fn6viAH3N4MAoW8
50902	payment	2134	2134	1874	1	1	8883	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNJJSdYibGtbTqsB97vGMoErxSu7H39jaA1R6tDkp2oxxuWey
50903	payment	2134	2134	1874	1	1	8884	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmHz9k4HcmouA6T4zAS2C83zyJxzNfUhyNA4s9pnW71xs3Bj1
50904	payment	2134	2134	1874	1	1	8885	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9VX8uMdBaM9YrrreibL5BYrTyFAkzmZmBEjc5xCK3Bgxy2qg
50905	payment	2134	2134	1874	1	1	8886	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5jSWgZW3kV2unqSjxooQHZ6W3kK2hGbwrpHNMtHCfQneHMbd
50906	payment	2132	2132	1874	1	1	2317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29Ddov3qwUQ2obB6TuAL4FeHrDxPedTb1BpDzvBM5ihb7aqjd
50787	payment	2133	2133	1874	1	1	8124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cGaiYRhqWLFmYBYLAagJPX98iug85zzySubh7BDApUKND7Ki
50788	payment	2133	2133	1874	1	1	8125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH5pTeqdvb1Wc6Yt712M2CZ51SZquVBbRbexDXk1t83F2ZsWz
50789	payment	2133	2133	1874	1	1	8126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYSmYgTwjeY5L3axCDVS5b5nv4EgGbB7gWQGQtqKpaqH218ST
50790	payment	2133	2133	1874	1	1	8127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1nnuogsjSwxYqdcW1p6xmLbfwGBF1qYhJS9TriNrfZCs4atJ
50791	payment	2133	2133	1874	1	1	8128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMoFTkpSdECqeofw4ob9qYAHSS9LPc4BvLm4F9PdekXzVS5pe
50792	payment	2133	2133	1874	1	1	8129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuf6hX4H3F417g5qySHgpGgsNjMTWUuCBqa6aozb1hHxqLFsK
50793	payment	2133	2133	1874	1	1	8130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCWSbE5XARR6XYP5pkQJ3dyJvGyyehGNv6UidpVTjcn5jSi6q
50794	payment	2133	2133	1874	1	1	8131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGkJaQzpsiJuzhLDVmecDNyLv9e3D7niomXhHSgByjwuxD6y9
50795	payment	2134	2134	1874	1	1	8831	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaRQtpGvvSS4aATDjxuZsE1vVpopTa5hVpJpxqRstcHkDmY7x
50796	payment	2134	2134	1874	1	1	8832	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEPZbsQDLLbjVmdPrMmAtmyvgGKHegoDKW5VArNdoKwPoKRnS
50797	payment	2134	2134	1874	1	1	8833	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNdLmjCXGY4hUSzrW2JvPnCkbPA27WP1SftK1hYres1mYQyP4
50798	payment	2134	2134	1874	1	1	8834	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQtPBoQtduE2a8srP16Cob84h6M33PoizZra6SmHF5KoZeprT
50799	payment	2134	2134	1874	1	1	8835	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39ScGNpMJaPB2FmjJ82agexkFK1erPB8wRRvSwEVrATVnF3fP
50800	payment	2132	2132	1874	1	1	2300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhaMAYjX3rdX9isAaF4srrXsUCY1tJqv1t2FaedJJguM9LQ9n
50801	payment	2132	2132	1874	1	1	2301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgK795QMoScW2Wi4NYzdYx8WSCva5edB7cnhm3xxsmVXmKMsB5
50802	payment	2132	2132	1874	1	1	2302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGGCjshCPo7DnNpnpV3owocZ4BpHXsty5pw5xeHmTzsvA8qMv
50803	payment	2134	2134	1874	1	1	8836	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGx8UcaYTRRgTtvWqx5ZXMEHMpBchnL5n1YePKHWLL276pY9ae
50804	payment	2134	2134	1874	1	1	8837	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qhHvs5g25MnNZxdAPLSRTtLviitaLtxP3Abwx49tnZaH8njU
50805	payment	2134	2134	1874	1	1	8838	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJEcFJxm4D98jBrb5jRBeTeFBTVLwDYgRxRj9nAeunDd6bhsR
50806	payment	2134	2134	1874	1	1	8839	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RkqFPdCtzLvhnEZw2H9hRWZmnHa98RjF5N7a5bhFJpPNTN78
50807	payment	2134	2134	1874	1	1	8840	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPYnuLCJDwMxYsBLxVXvwRy1feSbeFN9AWrjS2SsENbnShLeD
50808	payment	2134	2134	1874	1	1	8841	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZye4ZnCxLupCmPbyBXcwCt64q2fqd6yYgvrvS2fuPk4cymus92
50809	payment	2134	2134	1874	1	1	8842	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweqtPPYU9GDkDAoebSMksLCyw65Tyoe7ef5Gv9V79wMtcz5Jf
50810	payment	2134	2134	1874	1	1	8843	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiqRUJ4Sme75mJCnXbNRRJ4n2VbFhjtwVvYRdkCiF3PLJRkBq
50829	payment	1397	1397	1678	1	1	18224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAAEP3nga7srERqEQj86g35iqeJpgxpABdNYwRkXpiVCPQUYL
50830	payment	2134	2134	1874	1	1	8852	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVwtQ1HXbu2obVr7tftyxKyYNHDQZ7hrKyTv5SR66w3p2o27v
50831	payment	2134	2134	1874	1	1	8853	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZbgDTJojFjbHUrjAuTX8MkX3VFdsTzW3m1KQFpvcQ9WMzoKR
50832	payment	2132	2132	1874	1	1	2306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZysF7ChT7j3vD2tjgaDb6CeCRpGKyAcZimkmRAxdnAHXJ8cZ
50833	payment	2134	2134	1874	1	1	8854	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqqRbR2ydENYW8U95Cw9rzypZuSKXZmD5X6zYojvj5tqdwwtX
50834	payment	2133	2133	1874	1	1	8137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmkm4eQbBoLb7PknnWZQc5zXkTHwammQJXj6WbsCyPAfynF4o
50835	payment	2134	2134	1874	1	1	8855	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FfKP9EemvYN1SwHsPV2dDWF3zsonbzh6rjSbgFaiiZ9pvvkb
50836	payment	2134	2134	1874	1	1	8856	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnG8in6if8xievMA6htpn9ZEXnH2JYvtgHZRk4BoMYoSrSBTis
50837	payment	2133	2133	1874	1	1	8138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6mDZW5ZTqXXuyZoGbqYC411mw1NLpWwqbNmn4Vwmr4QYJ4Ns
50838	payment	1397	1397	1678	1	1	18225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLafMonCcQ4htoGpdLfjwAS9F1LNvPWPDXS5d38p6vDEHPMKzG
50839	payment	1397	1397	1678	1	1	18226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHj9MDfS1HAwtQrLyDfiq9sP1kc1pxd255aE6no3eNdNMJCFpd
50840	payment	1397	1397	1678	1	1	18227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gFTbBftsGwyzWqMFCur8by7FZ3Zs7DTi6SvqNBnXaYN8ZSHG
50841	payment	2132	2132	1874	1	1	2307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUxMTmtBomkNpEeWBnGmvJPuuzuUoiW4jXg8njjfYLzcnzRn6
50842	payment	2133	2133	1874	1	1	8139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vZ9LJeTPPahRbce6D4sbgkZET3hDpfrgYgc1riENY7tcjccr
50843	payment	2132	2132	1874	1	1	2308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4QFsmU5DMgeBC751jZ5JGVV8ahPSQKxcTEHKPv9X84DfxW9h
50844	payment	2132	2132	1874	1	1	2309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGMaVvL4nG4ENhMsAkbQ7CJqqg2PT2XXycpqYZxvgFEkpuZoH
50845	payment	2132	2132	1874	1	1	2310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAUqV9EJQWBf5P2zip9zksBvLFQiNjHexvfRwfSez3Vkd1Xtu
50846	payment	2132	2132	1874	1	1	2311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTauVuNMUc6QG65LLUbkhambjvnfsGDmPgtMjNTbqggtYjqMDe
50847	payment	2133	2133	1874	1	1	8140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcFFUcHnFVydE7NsZbWUSGRnXARE4KpJBfwcYVwEGmbQqyahH
50848	payment	2133	2133	1874	1	1	8141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26ywsLziofMCKPcFptEmC7ssGbUz4ygZaAiY7CueXRdTN3KiL
50849	payment	2133	2133	1874	1	1	8142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rSauw3DPSCzzjSGYozWTQjoSHVfcC2VrbjpmTVaYxhoGpc3z
50850	payment	2133	2133	1874	1	1	8143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PVZH3jvax8EWxEWdvtwkAXKF3tdeNS5JZSfEVHof2fCoJYXw
50851	payment	2133	2133	1874	1	1	8144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBZe23PToZoU2rCQDgyiH6pzXTHQ9HR8R8htgAZGBTaV4fVGr
50852	payment	2133	2133	1874	1	1	8145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNe4F1etym2QGq1uQbh7k434qnkF1Yvs8gmyQfBaJBP2FMY5N
50853	payment	2133	2133	1874	1	1	8146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5D5q6g53W9CQ8C1gapwukfX9N47FknT4ThHuFmiPhKux4bAxc
50854	payment	2133	2133	1874	1	1	8147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbEQ8kw9fCeGJf6kAyHWWL8L3bgfca3PdFSqU3qxPLh72QxaG
50855	payment	2134	2134	1874	1	1	8857	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE732CQh4SAqYxppqUYm1HeDFJUuhudaEtUiNgN5uVy4tGB7o7
50856	payment	2134	2134	1874	1	1	8858	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfspesaP5X4VbDVoPasbxfNxB1FaLjgPmirns1XWtfEnQDTuh
50857	payment	2134	2134	1874	1	1	8859	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZP9EScGrhuzQbbFzYYL6eeLD2nfubPdin19XYwpQpqh7qVQg
50858	payment	2134	2134	1874	1	1	8860	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiDz6GUMMSos7K3V3LmeRwhoLHSgWfT3p456Ny3s7472SRji7
50859	payment	2134	2134	1874	1	1	8861	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P6T7nAQdy5MiTm9PXHhd2jfQKuFCC13JzpEnBV3N8RAcUjVf
50860	payment	2134	2134	1874	1	1	8862	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVk9A8uq42TTzdgequRbXcJT3qkVim31eXcNAXgbkZdZ766bJ
50861	payment	2134	2134	1874	1	1	8863	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43y7ixE8ner54MvAPXak8kxy9sLzteqXS1fkT9YqxpfLDmZzP
50862	payment	2134	2134	1874	1	1	8864	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDA9oFU9Ttr6th5pZFaRF8Cuh7HnKeESv4CH3cvJAjdVH7trN
50863	payment	2134	2134	1874	1	1	8865	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayGyksxeGnMBYVXB9HWmZZHSSpxhjdHMDGzS7jinRpyPxHkv3
50864	payment	2134	2134	1874	1	1	8866	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5PPDvLntrf7iWGuYip3Sb3ukjnD4f8MYTg3AwrGvo9dfmctd
50865	payment	2134	2134	1874	1	1	8867	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1LtzB3B7YvriqL8gGnKEQf3CfA9rZMcYv6JpWCVzBHLc6DK7
50866	payment	2134	2134	1874	1	1	8868	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKA5q226NXNCb4MaMg9JKfiTPPYQyTZdswyv72M7mdif1QzfmJ
50867	payment	2134	2134	1874	1	1	8869	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAjRFXZdqov4m6MZoDzFNjHmAcbPka1mW1uAPnCTFHvssXAeX
50868	payment	1397	1397	1678	1	1	18228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZNEFXbW8xbV6UzkkvfGTaMFXGti2egnMELQdJDbUEmCWiaJv
50869	payment	2134	2134	1874	1	1	8870	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkKZg3EAtW9FFRqpvJbWTEbD2iCQmDtZifLikSK2DZhRs5L9T
50870	payment	2133	2133	1874	1	1	8148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4KMLRjGH4bUMm1KxqZhikxmemPe1hfNDimrvyrBJYRqDR79E
50871	payment	2134	2134	1874	1	1	8871	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZQRVHG9cDqVpuUpNAJHkgxauK39USMzG2GuVtKFrf8De7U5V
50872	payment	2134	2134	1874	1	1	8872	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1fQHwAJ2PRSd5ZoF6yuqumDKyXpTgzuWmSWnvy33wPTMMwD1
50873	payment	2134	2134	1874	1	1	8873	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoakYVstjTYbtyh2SBrfXuvqb8Aa1qXKbagd7Mj9X4zrwzLJrt
50874	payment	2133	2133	1874	1	1	8149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZHFHqr3N9KfV8r7ExFk8Jdmx96qLyGtVc76HWYPVufthu2kW
50875	payment	2132	2132	1874	1	1	2312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFSC8B5ZVHyQhkEh33eXJJJjP8SKb31bf6QvovAjoudqKJGbJ
50876	payment	1397	1397	1678	1	1	18229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81kpYTnUq8Gk53pyLGhkkwfZCinsrHAbS2FzNRLUkeDurdcVA
50877	payment	2133	2133	1874	1	1	8150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZV1qTxmedmviJJEEYHSrTGaXaF5Vx9EW8L6cRM9Pw2vX5D8Tq
50878	payment	2132	2132	1874	1	1	2313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAPMigh7UsDbeEZpybwQWCwyzKdHJ1gXr7HJrjos1gax32zop
50879	payment	2132	2132	1874	1	1	2314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHfJpezyd5nZf9o3B4V69pXT5uCtvgb6BixsoNrVqKbWXF97n
50880	payment	2133	2133	1874	1	1	8151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpxCGadaoZuAWXu93ZhCURySsKtLTUgKRyKipY6nAcuZBh5hN
50881	payment	1397	1397	1678	1	1	18230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzDKGvjBzjT6VDDuHVBPTCA5mVu7hRP4pATpR6AevfGMpzYt8
50882	payment	2134	2134	1874	1	1	8874	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7Ry6TpqR8YmyV5AkLRCKHLYAhb1G8Zk1eHTVrdn27wMNGQhB
50883	payment	2134	2134	1874	1	1	8875	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWhbg95FMga3B11uPVyzB2sYVZHKGwaoZYSY54TKmLWFsYcTr
50884	payment	2134	2134	1874	1	1	8876	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvogs34NESWTRCMxzh3ZhYCGp5Z13dX5id6ZUCbihiHSkLeHE
50885	payment	2134	2134	1874	1	1	8877	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6zLJjAg6Us1tGwFrQwKN2i3n32w9hWzf6VfuwxBAA1RaMhKC
50886	payment	2134	2134	1874	1	1	8878	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbq2vXuLRnfFKqVdUEn4Bk7WyqmfDHP1aQGB4fy3JXKKL7o9bp
50887	payment	2134	2134	1874	1	1	8879	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cjaa5XztYDT1UWgMmGbTtpBRQYosTNVR4kH9ztnCmrEYyPjv
50888	payment	2134	2134	1874	1	1	8880	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzjmGunWmagnmGRkTrCBHq12AjDzb1XRpeLhcWHvPU8Ep23SS
50889	payment	2134	2134	1874	1	1	8881	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2XoHuT24DjYkAXTQNGTkufUnFngEe9GqYD6MsbwvTkwjKuUa
50890	payment	2134	2134	1874	1	1	8882	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbonFGksz2wZFpcoSDobVPr7TdMYMceiqg4koK9c4mhrnhHTE6
50891	payment	2133	2133	1874	1	1	8152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Dyd2fK8caWFZ2rk1NWtXsuV7Tgex8NVt3s1AbmWEDMgjfroK
50892	payment	2133	2133	1874	1	1	8153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQMqq2BjfYrszsHTdgcjytNHGCHN6xNxdRn6W1kPGXkNQDSgM
50893	payment	2132	2132	1874	1	1	2315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnMTzRJoNLwmx1GLAuzNrGnCk9wsYYfsnbK2oZziB4fptLqiN
50913	payment	1397	1397	1678	1	1	18233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpm6MX8867kT916XYUFkeQvJtHqXkf82rwHzQupNmPz5QtWp1x
50914	payment	1397	1397	1678	1	1	18234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1e3pnQ6BdjVGJpBfc3J1epTF8MwEejPQSfGgu5WVySEtH6EVa
50915	payment	2133	2133	1874	1	1	8159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoEAAS5hP5rTKNYvn5Vt8L8TN4HdKMw5fRWWez9mPHtMuXnyG
50916	payment	2132	2132	1874	1	1	2319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAs2dsaHyZbQZjGsEzT4H5oosJxjnLdFvNqq7weMU4BuijkF5
50917	payment	2133	2133	1874	1	1	8160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiq1J7gMzKymJdjyM5zZpDd4DM4EXBXWFkV83sV1CvEF8FKv4s
50918	payment	2134	2134	1874	1	1	8892	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJAkaW9w5U2CGW8Gd8KUDhUXaWNe6oAW6a46Bgq6Ha2XV1yyT
50919	payment	2134	2134	1874	1	1	8893	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5i4Jn8HgqgrDeFpC6Qojg3KDLc9wNxtW66NPzK8YuWKCYPL4
50920	payment	2132	2132	1874	1	1	2320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRPkFefrba8QZxpJCD6PP2uPKQAp57yMz6CmUfGuEPoLB3dvz
50921	payment	2132	2132	1874	1	1	2321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7n7Jq5oD8onN1F4JgFR4YRHAukkL2ZrqnhKofDvn42TCTF882
50922	payment	2133	2133	1874	1	1	8161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfScqEZdKiKpV55se5ZNHwQTpaRkqbfdfLVoT3q3bx2fGBADs
50923	payment	2133	2133	1874	1	1	8162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqw367ZrqcoiZCiA7b9qM48CFvMwFPZGYtXUDUZyAAwfoz2go
50924	payment	2133	2133	1874	1	1	8163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4iZ3zmchftcbK7AwytYWaDwmm6CHcshiqPrMTaXRnWwxpkBP
50925	payment	2134	2134	1874	1	1	8894	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcyGtosMP65oYJysUj5Qv4qjYFCpkJJBYADuJQWidnaveUJAn
50926	payment	2134	2134	1874	1	1	8895	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpni187D5csWkcnvegRKbubyWtZibNXHQkthtB17MHfgXG7D9
50927	payment	2134	2134	1874	1	1	8896	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgQBqHSAYTEdWiDKVjMb5YhYk63HifBxwCgYjZFMLSpKvRg7B
50928	payment	2134	2134	1874	1	1	8897	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTz99wddu1rmpKgReYLukDKb6ZUH3T9bTqNAH3zFg6puktqfqb
50929	payment	2134	2134	1874	1	1	8898	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrSevJWiJ8zvCYStRL1L1JYSzBpsSm57GfDNjntnYT6eRB8py
50930	payment	2134	2134	1874	1	1	8899	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ74xAfLbeU4gYQGPAzq12WscznnLHTjhZfq1U85tygzwrQSLe
51025	payment	1397	1397	1678	1	1	18244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzfoUpweVnNAUwDpBcLB5bSsx47tv6esVqfx1uXxoDvAw88Q3
51026	payment	1397	1397	1678	1	1	18245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmFvyqCWttAV3BmU5jd6AV6sWMEu5yL5g53YHtMnciyTWKiue
51027	payment	2133	2133	1874	1	1	8188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhouZb3PNeHMEmoPLUsjkajESzikQnzkitMNM1v5ihTAhB2fS
51028	payment	2132	2132	1874	1	1	2336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWb3tM72vFjyVQYrHXJZypbpy5qSyPFCGVwLqoo3NDZHpYv2D
51029	payment	2132	2132	1874	1	1	2337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ogYbCbuvovJBHxsAXhrCgdnWRxCkJNr2SPBdS8MDHjTMq663
51030	payment	2133	2133	1874	1	1	8189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS1WRJyVkQ1Lp65nJbGpexJsX7NiPCTTqrZWQWZBa1CgCn8QP
51031	payment	2133	2133	1874	1	1	8190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbqJBoBi5K6Mx4YsHZs1XEpWJYcjXYEb3xbJ4ud5PSP3mujda
50907	payment	2132	2132	1874	1	1	2318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCUDAvVsVeG13yhZw6umKCDa7jj9rfJCnug734BZS6DpyKmv1
50908	payment	2134	2134	1874	1	1	8887	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hhGpmY3Dd18XCGNoe6RaR8vFYMUtYjMwhMP3RinUBp3YPeTv
50909	payment	2134	2134	1874	1	1	8888	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6o9qAW7qRrivWquNNXdBpeFPWVqytMNzM3kjMUos9MxKgwRt
50910	payment	2134	2134	1874	1	1	8889	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xwpNu1ve82GjRgm65vBqM6yh3NfZcb1mWqqSEnZspm3RLfDh
50911	payment	2134	2134	1874	1	1	8890	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLmJh53YKYhNE7bzVPCx176ZChw2u5CAmXbBgyANzUYfFkb6t
50912	payment	2134	2134	1874	1	1	8891	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJBsPnKfBw3VyPwVL3vdFosUSbaRPwMHWYMhkaZwKbUBDHq7t
50931	payment	1397	1397	1678	1	1	18235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6zRcNfvayNMtrqi3zCfiGtc1iKsDehwtrmcM8PdDJj2hVRbR
50932	payment	2134	2134	1874	1	1	8900	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSF2SiiYPo8J5sf2MDzxTc1XGTAmyUQAfqVC7wuhqeu6TYQGd
50933	payment	2133	2133	1874	1	1	8164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecFtsLBoYARwpkAt7gkDXNp8gpPq8MqBcnkQo1mnCVFtazYRZ
50934	payment	2133	2133	1874	1	1	8165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkX1Z9VoC4WYQynvAouaS9GTsCRuBtpjsxFSPdvWdd6Wh2NFEA
50935	payment	2133	2133	1874	1	1	8166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe3jncRLGtHprLVuZAqKex5kicHj2RsKeyz8SeHS1WxVNX1em
50936	payment	2134	2134	1874	1	1	8901	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFFsqeP6JeHEVMmjuDTyaXHurMA75JGLb4cqknKpe49vnMcW4
50937	payment	2134	2134	1874	1	1	8902	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLafV5f1TGEGMB7nGmtuLLcWXJ1cUaQohbR6vZsWWqcNKLvSKT
50938	payment	2132	2132	1874	1	1	2322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AgT8U6zNiDGmfsSZoAZujKeiLt2FqtMxtiob9rRWBrtXQjc8
50939	payment	2134	2134	1874	1	1	8903	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FnW2qzYAhupLYcamB7NyokTmCKWBhvRBFATqgihPHmaWjChY
50940	payment	2134	2134	1874	1	1	8904	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMQibzatxELcAfB1RkPcSzpiEJTioi5tkoJpEo6Rq7m7HE92k
50941	payment	2132	2132	1874	1	1	2323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcTpQduXZaaXfhVkStjiCxZr6hNjqTyzSGs61igPktihX3of9
50974	payment	1397	1397	1678	1	1	18239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pof4cjKMy3FnnQB5gZ5cMVHW6MFoK8AJQEsaQQuiZGZ78Hrv
50975	payment	1397	1397	1678	1	1	18240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLVMJ6pLUZt9h1SLTcxWmAqefkF8xLz7trsMcnA7E8aewcVF4
50976	payment	2133	2133	1874	1	1	8175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajMr5fzaXce64YhJnxCYsj2cZSmCrgGvAzdo9NujT3yAc1Qcf
50977	payment	2132	2132	1874	1	1	2328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXJWr8QktTKnGy93KDK82jJPEBnZXCSHBBoVDiEedq9Ci3UhV
50978	payment	2134	2134	1874	1	1	8918	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZ3ASxm3reCqvz6aki5sMpvWyW81c1UDtWNdK4B5CxrgJraLq
50979	payment	355	355	355	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVjXprEVNZyBwCAzYfD2ra84GCsLjGvHXjnNYkebFWCYJxYmK
50980	payment	1726	1726	2437	1	1	8371	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqqb2J8AnPhT3L14wspZ4VFPvvLhxKuP1DZz2tTjSCqpwNw6EV
50981	payment	2134	2134	1874	1	1	8919	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ijVjSHFKyiDpDVrQ8739QakQfXNfe8vtoLQDUiYroYnE6t1v
50982	payment	2134	2134	1874	1	1	8920	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5grRt4gV8AN4hFraAVv9evXhz9DYNegaz4Dk23UhgWUzSsf4s
50983	payment	2134	2134	1874	1	1	8921	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzgceSz67hr6e5sHr5Do7sueHpgNLWEodBFqCL8NAYDaFKeyV
50984	payment	2134	2134	1874	1	1	8922	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsyRGoCY74gb9QtzaoaZJf9z4Efo7eEkf2s96yuUEgy57MAkj
50985	payment	2134	2134	1874	1	1	8923	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVw4cDYuvS61V5DnbEZt8vKuBkVhXJZ1nsMtD2z8EQyAc9HNq
50986	payment	2134	2134	1874	1	1	8924	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yanYXkHYnXV7iWPMmWjYhcota2rKhdmmFRukBxXy1u9bsuBT
50987	payment	2134	2134	1874	1	1	8925	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgdBL4JpnLAuAUg5YLkaxRSigLJBLpGWahxV4gdtLJSmJfdfPD
50988	payment	2134	2134	1874	1	1	8926	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48pk73TZviYVbwYtTfZEGXX3Y6mCGGb9goJWc3WcE5u1tkpbP
50989	payment	2133	2133	1874	1	1	8176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XxNGzjWkJWSRDapsFuoxxYXAwrS6Cwb6UVzn8tGyvZnYpc9s
50990	payment	2133	2133	1874	1	1	8177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL71g5VFuY686eFUenpguUjiQkk6FBm9rjabSebxL8sTPGwEPW
50991	payment	2133	2133	1874	1	1	8178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVhfPJe8UQ9FpmBvPgWhFXcDoSz74fDvjtSrvcD8HLc4gAz9t
50992	payment	2133	2133	1874	1	1	8179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMEgZmgm72cnG3NwcndgtZ6EjegAHP1AkCYD2T9qtVwNkA7yD
50993	payment	2132	2132	1874	1	1	2329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2XzMWJsZN2oBwnETnY11A6ETSDAZ7T8fNdUpiAAmRrYStkH4
50994	payment	2132	2132	1874	1	1	2330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wLSix4sMXbFkMvA3F4iHY5uT29SKa2eqzh2CHr2HUDTkqXQG
50948	payment	2134	2134	1874	1	1	8907	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6anUbG8s1aKotTHunUPVcvwtxCoTiJFZesv8e2cmAocjvXzwp
50949	payment	2134	2134	1874	1	1	8908	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1NRAUKMKQUahfsKD7h8mhHDeG1EvnybDSigrfvYzQhv2oPxi
50950	payment	2133	2133	1874	1	1	8167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJ8vH1CwSL5EZz34hVENhsarUEhttjjAnVn7uUAmnPEU6bRoe
50951	payment	2133	2133	1874	1	1	8168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaUS38TixyxLFAs9wwAyE2rRYdR5pjVyFzVHg51jQjv7mDwJM
51108	payment	2133	2133	1874	1	1	8207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv8ftLVYzkJcz9dWSrSdyM1WYDuubDwRNqf8UQ9tjyeBxTJLG
51109	payment	2133	2133	1874	1	1	8208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspbTg31ckvpcpUiQgCsp73ggWhjhzC9v1Tym4DKJ17GGy6Zv6
51110	payment	2134	2134	1874	1	1	8975	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJ6wKor2metxZW5ogpJf3wMpaChL8FmN5dy4uk1iXaKiuWD3D
51111	payment	2134	2134	1874	1	1	8976	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG4xmhwktRY5qESHri4fnNX8EiDzKy3sK9CJabB9NhDxPDRRY
51112	payment	2133	2133	1874	1	1	8209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwANnHAXUCVqAAyUrjtHrdK7E5yPW4boYMkgvCdC6XVTFfBzXB
51113	payment	2133	2133	1874	1	1	8210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX82RkFLRXhz8CoTMt7rVfhrc1qSqvvyUqHnKt3esk5vDW7bTP
51114	payment	2133	2133	1874	1	1	8211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmsjbiac83rRvq3kajbSNWoCz6FNzSAxZzYhvfYJSFb3VDUCv
51115	payment	2133	2133	1874	1	1	8212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gRGvdNowCeJ3QRdY38LMr6n2scN1mtX4TWrwSJigj4bFqxhM
51116	payment	2133	2133	1874	1	1	8213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAvipoykqaiqo35hHCrotuYzLDnmA6akmLwe4mydWbeU4hu1E
51117	payment	2133	2133	1874	1	1	8214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfsL8JQoHKvWneqnx1Qk3dVtPG93wgpkTHaaBigReZytjYmKj
51118	payment	2133	2133	1874	1	1	8215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgchdgMBnngovSZ3RZB5dg7yNuupxShKo4iyAhiR2dYbsJtyj
51119	payment	2134	2134	1874	1	1	8977	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8QE6P26FciwqFioCgE6oiX4qsWLpi4MnneVWnMdcsjWZq5mT
51120	payment	2134	2134	1874	1	1	8978	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YmgkMQYGzvXPdVk7hFxnZS8DLkcAdDffiR39gdrHRgEYSKy2
51121	payment	2134	2134	1874	1	1	8979	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwEHQmr8oSc2Xyp1rW926piKvZ3pRKyJYuHNgVoH73u4Hvf1D
51122	payment	2134	2134	1874	1	1	8980	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYddvKWDpCQXYaAtC1KLpcrepXy2tTtjLtpBtjigLefqbAREQM
51123	payment	2134	2134	1874	1	1	8981	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa745yqcQutPN7KKZCKn3wgGb5N4RR5LyckB8LbBNvQswg8XNYH
51124	payment	2134	2134	1874	1	1	8982	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEu5oY1GGiVD8w6MQ8yeorvxy1pefG6CvGtzMxVqBc74uvhEzF
51125	payment	2134	2134	1874	1	1	8983	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwVuxk5PwKudkve7XhjWVx5d4PvCVK7BmUCMwScVe3ixkDBie
51126	payment	2134	2134	1874	1	1	8984	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7EUaSxGzMXAoQ7CNC7HnNvpNAv6knRxpc5XTPwzARcF6REjA
51127	payment	2134	2134	1874	1	1	8985	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ormw9Yxk8SvQoEewNZfnbJWR8ACosa5FQHvPFMdEECcrBBYn
51128	payment	2134	2134	1874	1	1	8986	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdUFw6368RtEovEaWRKx52tukj8GBwWH3sNs2PJ5G5mwVkLr7
51129	payment	2134	2134	1874	1	1	8987	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7hgjfYgMpKCsEzv632EHJcz44wthF7C8BG16Aeu9R8zjniXK
51130	payment	2134	2134	1874	1	1	8988	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyvWc3kicyp2sysBSyjksH3tDPVV4x8jQgzSk3C84rqErax8X
51178	payment	1397	1397	1678	1	1	18260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmoUgkKbdWqh1HKKYRUHvL9doyWg991MhkRNbzGzn9RWexbK5
51179	payment	2133	2133	1874	1	1	8228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVdPbH3mjCJazuwFNigQp21evVZiqeY2PiPNYKM4UJMxGhmyi
51180	payment	2133	2133	1874	1	1	8229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GucFRdPZo5j7ne8YTNR8rb44zjwQnYRYG96Gt7vxgheuaiJJ
51181	payment	2134	2134	1874	1	1	9011	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8s1HY6srGdYbbq9uPzWvWRCwQSqv6g5Vt8UaetE7oAEd2a2nR
51182	payment	2134	2134	1874	1	1	9012	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYectZRbaZxjst2xK2dcFXaEyv4GExv4E3qpkL76775veoSWP5e
51183	payment	2134	2134	1874	1	1	9013	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6toyLSREMHK1yGkw7YQo9Vwud8adsQ7zEY4mnTRXtLf8cmuQ
51184	payment	2134	2134	1874	1	1	9014	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLKwtx1t5X3TZCNmqN9pzPWcNckTJkZYwafeUX35F7HrcXzuR
51185	payment	2132	2132	1874	1	1	2359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPUaDZoSRLyLumZZetDEDXqdxqo41ds8FAXgnKHqmSQYb7sZk
51235	payment	2134	2134	1874	1	1	9036	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAkr1Gu8hGKjMvdVpT5sS2xjpX8Kq5csqKKGqLU9bBy5nswwa
51245	payment	1397	1397	1678	1	1	18267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM7hxn4Lgh6YdxJ5PUonaS5bYF8kbhyzwWXrvJF9SENUozYsu
51246	payment	2133	2133	1874	1	1	8246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHYFQrSDTmGpobjjc3kvuf4DVwnHHzCcqkhJzZmsNdwCy55S5
50995	payment	1397	1397	1678	1	1	18241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnVxd6LR5e62ZPZkpyahV1jKPBEAUr4bsYafvmik5DiHrBiJv
50996	payment	1397	1397	1678	1	1	18242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGxk9DhuLtRCnK5fYNyqFj2mvud5gmQ3a4Qd48Mgr1Q8y6m7U
50997	payment	2041	2041	155	1	1	1	435000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkf9frLLeuXDgXHtTdc3mGVGCqVQcGGwSNM9qKcrHRCHmzjzz
50998	payment	2132	2132	1874	1	1	2331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAE7oo9g6eKoCGzhPcpAgEC9eJWfvQz1ypte1jm2rZeBYo48U
50999	payment	2132	2132	1874	1	1	2332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQBnHnjjuGZnfJVtkbPHoaVvij8FhfLmwEuR89vkiEFKvQ9RR
51000	payment	2132	2132	1874	1	1	2333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3diKECd3H7E8rNPY9NAinmLR9k8GsCqbzTir2yV1hSQwg3Xuz
51001	payment	2134	2134	1874	1	1	8927	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKGM1ZVXmW9iDSjqjeevrXdu7NruvVgNMHsaznywvaHwPYVuh
51002	payment	2134	2134	1874	1	1	8928	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbNCMsvG6o46Rrh3tE38j7iCNYUfzGiq55tyoPW8TonbXqo2vM
51003	payment	2134	2134	1874	1	1	8929	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcfqUAUqi6HxoXrg6tuY7eZsYxqWGwf3VkumiAwXuds8uYQ8j
51004	payment	2134	2134	1874	1	1	8930	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcprGdp2Sr9epnrWZHK3jpeE85NBrenDGG6KjxEDUp8GL1E2V
51005	payment	2133	2133	1874	1	1	8180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58uQvHZZQcTdC65u3xrC9yYxtdXnhEcRkQyyBVuN2qGV8xDrh
51006	payment	2133	2133	1874	1	1	8181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH51U3rM52H7kGK6Bt7CS5z8qDjbYqSgQLzxq1UKbknS4zQWX
51007	payment	2133	2133	1874	1	1	8182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HpPbZG2ggMKu5wcon1xZDnA1mZ4f4eDjNtAwUuCm4APzTK62
51008	payment	2133	2133	1874	1	1	8183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnTurTLQNeSBQJTEhTq8SbcR1PnKS62nQVq5nveujpKqFDQLg
51009	payment	2133	2133	1874	1	1	8184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8yFJgXpx7C2GrGk8uXNccBhtLEeaDZYEjSurjHNuWPkCY9dL
51010	payment	2134	2134	1874	1	1	8931	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Va9TV3CQUHWv7ikbpvijBhWTKVJ685j8ubH7KPD2y2wLA2M5
51011	payment	2134	2134	1874	1	1	8932	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauGuFKq3JmY6WWAdKUmZzU63bfYa4yr2WjUYxGz34fX55ND8U
51012	payment	2134	2134	1874	1	1	8933	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuy7vnQHq9obmzzmLzRAJZWSg9MRn2PaGWW1psAb59Nz31TntZ
51013	payment	2134	2134	1874	1	1	8934	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGT4dCeGvE1mZPSHpiqKSjy1V394zbpXvT5WriawG1Wuki4Zp
51014	payment	2134	2134	1874	1	1	8935	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BQGnGAFSKXLdaNJXgyxgceq5bYYyHiUAzTspyNjBDZ6PaMYr
51042	payment	1397	1397	1678	1	1	18246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUF4yDoUxiCPqiX9K4E3MvHYP34bqrCTdgCeQpY1JHgq8MAZes
51043	payment	2134	2134	1874	1	1	8949	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7s5ckb8wXfVpsy5sE3oeWnSawWxDdyqydpjg4TU47iZXBZp4
51044	payment	2133	2133	1874	1	1	8192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkrJBPjqPHcdhSUgK3Ueqq8Kz4iaRKNRyVX9YFUVkHt64KFHt
51045	payment	2133	2133	1874	1	1	8193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyNci23GX1PA8D63EEUDfDC5yC4ZTQPuuC6PJ8G2i4Ldn1LB8
51046	payment	2132	2132	1874	1	1	2338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrZTh3FPjE1Bu9P8NtYg2P6vvzXsUrRM4NNF3J7Rs4XnvJYz5
51047	payment	2132	2132	1874	1	1	2339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZgRUnDkfj5akksEJ8gmci5H6jzW8BW9tuE5Hbt2TddeLd8XWn
51048	payment	2134	2134	1874	1	1	8950	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYk9eyjopUHAczAhKxK3Cbf77kiYvFQqpNMh1nMJXjzyPycuK
51049	payment	2134	2134	1874	1	1	8951	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgqESkafGiWNsdyuf3HwK7TyR2c3voLCjC22JNZ3TMk9UoGnH
51050	payment	2134	2134	1874	1	1	8952	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsSjdCaBMemVptvsqy6ti2UCrnBNT96L3iXAvadn4Rp4HBWft
51051	payment	155	155	2041	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1m1RYk741efntVtpF3DtdxcrFY4ax8se6TVmKVBh1DiKcTrFF
51052	payment	1397	1397	1678	1	1	18247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDj5nEYGVnAZCUUHiXHLzpQQuEdY3MH7o2jpFUt4H8PRdXdNC
51053	payment	1397	1397	1678	1	1	18248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwqS1LLsNXP7mf72DzZTr1twcQQdT26NPPNnTzGsfAejp9QGY
51054	payment	2134	2134	1874	1	1	8953	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQumWHD8M4db2nYeR6Whwy17TV4eiHo1H22geDfXsUZvHeP4D
51055	payment	2132	2132	1874	1	1	2340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49YqFKKfm4zyGkYAnNB2WKgeKnH7FF6y6nzUpwQXCBU1QrBcN
51056	payment	2133	2133	1874	1	1	8194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6cEPxQChRZ22Xk2e3FzszyfGzPBt3VcTudTUtH66WMof916k
51057	payment	2133	2133	1874	1	1	8195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG5xJmeQjoKqTdzTcHeF2UWQbNUiQxchqyFskcLkJYRJWetGjc
51058	payment	2133	2133	1874	1	1	8196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfkNdqFmeqjPzM3fa5A8JavHNp8bsMu5bN2P3Yuiu4x584ENH
51059	payment	2133	2133	1874	1	1	8197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tsyhsdXiTsFmWk87M39tGe8js85gStipnE4wiBNhvHi4DPjw
51015	payment	1397	1397	1678	1	1	18243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHrxx5V4Xj7K8eHZFgXTiTAQKFAqoxa7bQfah7LQmX5R7jVMk
51016	payment	2132	2132	1874	1	1	2334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAKf4nrfxcoRaFfqhR68QwR3tWz4dzEeKSgM5uN8VmujYnBNk
51017	payment	2132	2132	1874	1	1	2335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXXoqdkxwpoS99Wp7RNVDSetkCuJUdWuZ7eQktEEYZfWissCS
51018	payment	2134	2134	1874	1	1	8936	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRH5M9Pw6niKxzVWXLdm3dK82AUAf5gm8L2sNfdePoPiZQpKW9
51019	payment	2133	2133	1874	1	1	8185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEedBUoimPnW4A8VuPRqH5dsXWKC3GRzYjJHTXeG9ArEG6Nun1
51020	payment	2133	2133	1874	1	1	8186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSHeoTjYjGQJLUqYF5LmNFhZ4Dhu1wh7gX9xfVQozvoGawGAu
51021	payment	2133	2133	1874	1	1	8187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDrJsyGKHbbc5smD8MnCRYrwhCzxCg8241zVjtrFrCSZrVJ33
51022	payment	2134	2134	1874	1	1	8937	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1B6tej4E5Jr3tFqCgQPfxoaqTiWYhrcgVMjDKeLXUSndPhXt
51023	payment	2134	2134	1874	1	1	8938	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9sPcCRgXaFgFbNzLQ14rXiixENd8nbcM4p3PQG4BnAqaa5gP
51024	payment	2134	2134	1874	1	1	8939	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ46evEuJ8Lu43jdvA3FSPYX638wNVM2rYrPPXDi92CWYSE8G1
51131	payment	1397	1397	1678	1	1	18255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AYT4s1jvhNszaFTEDX2mXXDr6os2BEVN4oRGtDrvmNFtMa5j
51132	payment	2133	2133	1874	1	1	8216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpshRjU3Uu72oqqutzrGBZuFnjx18heB4ZahHPocyRdh8HWRfi
51133	payment	2132	2132	1874	1	1	2352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybNCK1pJRhkpbFrxQ2UBDW4Re39RP1e4DmRGN6x7AgmKgTKUq
51134	payment	2133	2133	1874	1	1	8217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDR4XuVMkRZ2krX75bddNkR5kmquSKK5buM7XXkkVfD8TQcCqF
51135	payment	2134	2134	1874	1	1	8989	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanMYSiG2hRNn6vkQ18AiP6rEax5KHFQ6iTXFPghpvgV5gZYTw
51136	payment	2134	2134	1874	1	1	8990	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTnDBLzP4SiLJzLW5cvtvber9vaUo3rKo5MyjXm6CpC21Fjqhe
51137	payment	2134	2134	1874	1	1	8991	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuB5fteqkdJoKEcnLbxq531W8W3E9FKeyw9imsWi72DUh5YZQ
51138	payment	2134	2134	1874	1	1	8992	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiFSS53DkmAPTTc4EY8DuLJrW37GshBrCvhQMkcN7jGyxTvNc
51139	payment	1397	1397	1678	1	1	18256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oCwWmqeHt3qPwj4r7mAdkoHNGM7mW4gEkTx3AUssCxkbJbjv
51140	payment	2133	2133	1874	1	1	8218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpVscyvr71yVH8qXHPgrFGJ9VvTkc3Pp7DtrtkXBRESkBRfUp
51141	payment	2133	2133	1874	1	1	8219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpWk5mQU1cFdX8feCDM7tMhaQhsmsUhD6yXj8nU2qYd4e4JeC
51142	payment	2133	2133	1874	1	1	8220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1NfjWGPaHyLsM3NEiEoGF6yb9E6i3ujiuKGmLvyxDXcfVoAG
51143	payment	2134	2134	1874	1	1	8993	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvzuPsLBJHW2bqUbjw2vM9SAjbbt5PKoPypurGzXUSeXQXzEL
51144	payment	2134	2134	1874	1	1	8994	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrJ66Wb2wVznoQmTZpUuUFgvjUszAAbvkjEYEfX2y7FtT22os
51145	payment	2134	2134	1874	1	1	8995	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKF6E23GmPtAui3c4w7uXtP9tLHEg1nYjLTq9YE8s53M9xDkgW
51146	payment	2134	2134	1874	1	1	8996	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvYjzVkDUsQ2aVs2bWGAtwCMoDe3bJX4rziqsD1ifHsj9G4nE
51147	payment	2132	2132	1874	1	1	2353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxiQCWMoymjvtHUyMhtRXXZYGo7YbhxDMfqEAJ6DHjZuwbfZjK
51159	payment	1397	1397	1678	1	1	18258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnke5eLxoCHQkSWNbjGXTNagkt9cHwBMCoCPBGpokZHDucqdpn
51160	payment	2132	2132	1874	1	1	2356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa8a51WSo5aQ5XDYwvtGuZfUFZVrVQLuz3roQCMNPaRMBRAMX
51161	payment	2133	2133	1874	1	1	8223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHKbpQK1ebgDQzD6cTuQmU2Rq1ZFKU3WzGaGB4Snss4Ak8khK
51162	payment	2134	2134	1874	1	1	9002	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7C67ThMEDC2UAQamfPjKDFiPLHHdgrwP9zSwETwK6KNQDZPXz
51163	payment	2134	2134	1874	1	1	9003	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNEG6Q8ycJBKBStECP52WPzJ73q5u5PmcZXXMBREYSmN1B2dd
51164	payment	2133	2133	1874	1	1	8224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhqnZkUB5Up7qpXyEBniQ2F1AjKDsqePr8bh1Y4X3YzxyJhc3
51165	payment	2134	2134	1874	1	1	9004	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKaf6LedRaYpthAjBzEwG42SAtwUhHz4pyE4qcavUMUPozjMp
51166	payment	2134	2134	1874	1	1	9005	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8F4LeoPvY2TgeEVKcTvBDU2abfU28rhZ9vLUSJPGiARqqbiZ2
51173	payment	2134	2134	1874	1	1	9006	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJdX5i41TJxFmQXymNhpixGVne81vasxGxZgWRxeMYZrpT5ih
51174	payment	2134	2134	1874	1	1	9007	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQAFSZQT7efMecR4BWvaNCW7fXuPvDfhLL5i2wxD46Jca8YAs
51175	payment	2134	2134	1874	1	1	9008	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VUAQRZ6XUMT6nyfDk9ZZJ21XxKF1qwNJ6YjyXZ5SCWA4asuw
51032	payment	2133	2133	1874	1	1	8191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aXGV5ExLgthkzWJyrQuY4YAJNedMbmCpVxEaD1fzQyM553j3
51033	payment	2134	2134	1874	1	1	8940	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhSPrwp5JNC9bbBrCJaNZr7mBiG47LXzyeoo4rw3jnMHfb6d7
51034	payment	2134	2134	1874	1	1	8941	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFRiPJEqzZ6RZnvn7V3iCzvR24mByJiPLakpkC3YzfDB4rK51
51035	payment	2134	2134	1874	1	1	8942	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcDvZdTrsVUJ8naM17xQpLLVtTHxoKpqNbzRebYCV27VLFPTn
51036	payment	2134	2134	1874	1	1	8943	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeBEKmsm2GEzH8BSBbzZ4SgJReci4MdgAYb9x8oAyu9FtbLPc
51037	payment	2134	2134	1874	1	1	8944	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wBha6aE8GFKhUHns6AakwAyHkZfDaS2kRB4cGdb1742AeBuS
51038	payment	2134	2134	1874	1	1	8945	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLatSBVDXPKDDXcUyWpZypWMBJ3GGkMHDnmurHWh6cornSWib
51039	payment	2134	2134	1874	1	1	8946	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVzy74Rf1etitKSNhebWhnxoW2qSvMePMn7eKJR6EuDVeXon5
51040	payment	2134	2134	1874	1	1	8947	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmAnnKPcFEAzVyTeB5cdhggWaKUpQcwjBpJiNjTgABRAxVeCrh
51041	payment	2134	2134	1874	1	1	8948	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHvJgsZm8AoiczkLQxa3iQkgAXKNERLdGqjtF9gH9rQDcSSKr
51091	payment	1397	1397	1678	1	1	18251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurV99uaDZcfopg3SHrzjN9nq5h6tqEVe7aHtFTEi18m7Y4t6t
51092	payment	2133	2133	1874	1	1	8205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAtfBja3ptysJGYWByCj7x5GYnEnxuvADTdxLCQ7ANLQdDaz8
51093	payment	2132	2132	1874	1	1	2346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesa1SqA5JoNxueJxRqiRpKPbTu5NCUqcLw72EAQsC8Ao4QHjR
51094	payment	2134	2134	1874	1	1	8971	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkmzsaZPq2iCYYK9nQjQQW2M2rf3eombfGZZk2656eYzF2ne3
51095	payment	2134	2134	1874	1	1	8972	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCYht2C8VE621nt31uVY6TqEbWioZei6Uz5X9KHqfN91irsqX
51096	payment	2134	2134	1874	1	1	8973	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjTWaLFkbFDXmuTjtzP7QSjYcJ6J1yoDr8VfDvmHQ3EYSz1AX
51097	payment	2134	2134	1874	1	1	8974	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uH8bkNbMPznBFzCrEq3FXTt4H5h97Goa3X2bMB7aJoAwwEUr
51098	payment	2133	2133	1874	1	1	8206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDW3wVaFbaCbnwNnaPWxznx22cpTCoYXw7Nqi3TFK69anFM4Hv
51167	payment	1397	1397	1678	1	1	18259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjRr7jNm7tftPTXpGP7ShaVgCbD5hVNLiqTo7yUwHr14JaKxv
51168	payment	2133	2133	1874	1	1	8225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7H4YV3ZBoYSrZRdTGYVCwhCu1MsPEp979NsQodd71ew1hrUg8
51169	payment	2132	2132	1874	1	1	2357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmFEdnARNHwNcjz1gMcrbWuAiJkxjFcYAeEGipxm4aGALZan4
51170	payment	2132	2132	1874	1	1	2358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2513xjKDWzibSTLENYLCKEosWAicmgjaSmQhPYfyyrTDUQdn
51171	payment	2133	2133	1874	1	1	8226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCi8KotWsRdDFS1oYSGqCWqy8SVAwHjYZqsxxpFq3gNfurfPa
51172	payment	2133	2133	1874	1	1	8227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rvGa32UWt354LQgZpqo4hBbCBuGTpCJaLZ1XNQ8CBzPzpMV1
51225	payment	1397	1397	1678	1	1	18265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShnnVsaEU877NdkEEU7mRgjD5RPCxZwAhF6w78jYhVYD2bdb7
51226	payment	2133	2133	1874	1	1	8240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRSxb3EoFGTryyN1oYpEzjiMLGqHpeTkYiHfyjQ655RUbaFAw
51227	payment	2134	2134	1874	1	1	9032	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tknrb1KgpMUx4orvmR42hGKanZicREkLwnyc3E4ntKvsTqUd
51228	payment	2134	2134	1874	1	1	9033	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fwTRmVxDsiUD1Ba9bwXDqE99Tojztbn9ZQ3QVAvaNqh7sh6G
51229	payment	2134	2134	1874	1	1	9034	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkEgwi6kiSAd7RJP9c7K3sHpWVq6r5yMzFag8XxddBLLdan56V
51230	payment	2132	2132	1874	1	1	2366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJr3XBHy4J2J7UxT1ZDHvorRNis13vjyseZTNeeauNSQDXrrg
51231	payment	2132	2132	1874	1	1	2367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKqJD73NWCWcp43ThJ1Eatz6GvSnmYrb51apKhqsrAtGrwirk
51232	payment	2133	2133	1874	1	1	8241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8ekTzMtRbSebJoB5cAcAhMbt88479szHV2ztCxGU3fSVFd9z
51233	payment	2133	2133	1874	1	1	8242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnp3Ma3ba2m9Ur3g2pZW5uc27Z7hhpjE5GByZPsrKaGeBVg8Z
51234	payment	2134	2134	1874	1	1	9035	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFJP2jxWNpmVriAR2rZJxD29XYQtgiMe1eQiDZH59QrzTR2QR
51236	payment	1397	1397	1678	1	1	18266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNSL4VVqgRJ2NyW5ybYiiKYGEs48Hbhp3eCSTy4egAq6V8orm
51237	payment	2134	2134	1874	1	1	9037	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNp1bRX5bpaEn5WuBPaK1j3TAmJ1Y6nyLDxbjMvrD7b4rQgrq
51238	payment	2133	2133	1874	1	1	8243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4YhZiECwzFuuL56V6rqPmrPWSuhB2Gz8cuJnkpxMRYX6hq7U
51239	payment	2134	2134	1874	1	1	9038	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyYcJMhyiYjtiGti1YSwwHKr5ABTDhFQ6395z3bcXNxRo8iNG
51060	payment	2133	2133	1874	1	1	8198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbewLiu85f9SWkuJz27VsDE2LXTihin3PwJstHkZCbuJLopvmk
51061	payment	2133	2133	1874	1	1	8199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3GwwetNf11mFfMZZNf4814ovjscUpwAp2QP6ivnxTWew53YW
51062	payment	2134	2134	1874	1	1	8954	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZro6WEQFJ4Wf2iy1RfG6Lxwu8UGJi1t4dGWLe6qEe4erqLbBeY
51063	payment	2132	2132	1874	1	1	2341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsep4uU4xciz4jygREd39YUB3AQ27dRWMXmXaiSBnGhcGA5xvW
51064	payment	2134	2134	1874	1	1	8955	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3S71xkHTUS6yaipCFjAsdAG7H2sB4q3GwGYXGXuSJ8tfSBigS
51065	payment	2134	2134	1874	1	1	8956	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5q8iHFUi4umhpe1S126CJ3v6LPjngmqkC5Eu98gintQzCgTm
51066	payment	2134	2134	1874	1	1	8957	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7ouBK4vJg1ywDqMcgwxGxZR8r9k8eTkQPhnYfQCg8s4PLVUu
51067	payment	2134	2134	1874	1	1	8958	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5joYm9jMUJKPGUyA5HWEfGiw4yh5f48P6w5Zv1zVRSokqPXg
51068	payment	2134	2134	1874	1	1	8959	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiwmfCoPayrf3CuUa8Mbx9y8dD4wGHrKY5njsrhdpyoi6RoHz
51069	payment	2132	2132	1874	1	1	2342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1hTVn8TQ3eAqJ4RSA9VSg15NCJ7Q3n5ngB94uiz3voo9wWdL
51070	payment	2134	2134	1874	1	1	8960	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjCmmGxUcDXJbFoLgNGgNaGLzKPRRaNjZkTWzHXYfyAHFeo2W
51071	payment	2134	2134	1874	1	1	8961	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVbcbXfsCextx3jGznUgDfG4fGgaUhSJw5Rq1mVsvoDFPN7i3
51072	payment	1397	1397	1678	1	1	18249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW95ZA7zYEGwV3SvzXLfpYsPDWQnc3vSDFe7R12UZrow182Cj9
51073	payment	1397	1397	1678	1	1	18250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPHoMxx3GMvoyVbpod7g2evqd3s6AJcs6B3VPjtwKkLQJ6Ran
51074	payment	2134	2134	1874	1	1	8962	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLY55xNaVULqzbnX1fJSEqbmKTFtuQNnN2jedA11MhofxaXjn
51075	payment	2133	2133	1874	1	1	8200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsqPQijKiupuZ9NUQrAM8o38wZdWLAyjM1w5NfVcwCwERt5LB
51076	payment	2133	2133	1874	1	1	8201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXePqk4VecL3xUgk9HQPMFakHzRfsLgSDzw5SDd2ut5X6FiRv
51077	payment	2133	2133	1874	1	1	8202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjFxbBnmPSZvvoxp1fboWaBjyhupoxkc2A2zWhEE5gFceEFvP
51078	payment	2134	2134	1874	1	1	8963	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnD7qLyyYJe7DBaEUtMdAaB6XfLLUd5P1vFcEkRYQWr6cxYLg
51079	payment	2134	2134	1874	1	1	8964	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziMQd27Qu5NSVxHWZHm8tJEyD3jaqYqt78ebSZBXP8zcSxUH6
51080	payment	2134	2134	1874	1	1	8965	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa42k8kFecZPyUt4AaEbgow971jTfaxyNqxqy1vbKNVpZsPPwA
51081	payment	2134	2134	1874	1	1	8966	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwM3TzqtCf1hYx7stN6iQPPSsUJ4JVirhBmGsVjyqsZ9RD2uzo
51082	payment	2134	2134	1874	1	1	8967	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6VvUbK5LWYQfhuof463pLiYb2eSvJ3AeDQ3HGWg3fG15eWvk
51083	payment	2134	2134	1874	1	1	8968	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocZL7XxhZ7acXDebWWfkHs57fQ1BwcoCuwss27djpedzFeLid
51084	payment	2134	2134	1874	1	1	8969	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTALuAJvvmMfAe8KSM1Nsa2y6FtKHru8P3eu4x5e6YjXLejBP
51085	payment	2134	2134	1874	1	1	8970	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22E9F3nPb78Sjadf4ZB9m6eyvnsR5FSKyRwCNuzpHfzdQnpST
51086	payment	2132	2132	1874	1	1	2343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YmzPHXWvSXSXu1xKVpnQ5gxGWbzNPMsRnaULS2XXBLPZf7gy
51087	payment	2132	2132	1874	1	1	2344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNVPDWtRNhPEr7RYGurwnkF8QNLGB7kyphWTgQebextgJ6ztd
51088	payment	2132	2132	1874	1	1	2345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsskhk2HDNxATvH2jw6CjffA1LFeLdF6PVYeHAbwcdVq9qrsp
51089	payment	2133	2133	1874	1	1	8203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfKg4paAYNQFmwEPjxDv7covC2N6cUoSwhQkexWwUBoBQxc8k
51090	payment	2133	2133	1874	1	1	8204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXnyVCBZWg9tsQ1GS1Efe5TepK4wpgb9Fo5Qc6utYR2C5kHNC
51099	payment	1397	1397	1678	1	1	18252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRLAiDv8xtyLC3cF4qacQTeUQBz3cSgN37hY2aLFTRcMhovxU
51100	payment	1397	1397	1678	1	1	18253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqhDEcCEqZEmv2xtsd1L3z41qHbTSa1Hut91PSJpCSDKZF9EM
51101	payment	1397	1397	1678	1	1	18254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPcW3ZWaMMdwiMWEjd2fNA4XWJ7WDje2NBkAFCke9bDHR47yY
51102	payment	1726	1726	2438	1	1	8372	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa8PQFRDKPw498BkVmRoQW21b8UEXpqK7tQL28a7T3waBkA5fis
51103	payment	2132	2132	1874	1	1	2347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MYgWT9mes93WRZJmqVVDKiaBoHupDCfS7fbHvSJQxi7Gugbb
51104	payment	2132	2132	1874	1	1	2348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvpCrNSpwkgShY8F8wALwziyQaH7My3ozBvmL13mBcDBzqqrB
51105	payment	2132	2132	1874	1	1	2349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4o4B5iMxiE39dQc2WjNdeuBbHh3K5rWYqeRa98Z8zR7j6vyh
51106	payment	2132	2132	1874	1	1	2350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBef3cCzYzPF5k2rUjt8C7v4nMTt5mKF5juumezdE8Nynztfo
51107	payment	2132	2132	1874	1	1	2351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCUdBc3mYYviMqzg5vh4igBiM3iqUhjD9EpwdsWtbLTZYAf1Z
51148	payment	1397	1397	1678	1	1	18257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSuGxsz98zSRfMbE7vGwmwaRANYHqUEXNRgfQFj9ApZRB9ek2
51149	delegation	2338	2338	2338	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaWVydMnXDEidzKzX3xxjKqekjUpXtowPjyBAH923WEKqxUKiC
51150	payment	2133	2133	1874	1	1	8221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAdHZZGuuxkRyGDKdjGiKAtN7UhboqprQqnLxU3wgZoceuKnN
51151	payment	2134	2134	1874	1	1	8997	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAqJZxNsTq6dyqcmvRiTfgeHiTwPepV7T7hstkgfiPQQcv8NZ
51152	payment	2134	2134	1874	1	1	8998	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKDSwErgdBR9dbN6tt3LrDGnbpKybZ2eBNDTmLN1W2Wk4Dm3s
51153	payment	2132	2132	1874	1	1	2354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vZG41dohk8SUh3R3ep2gUqVBwE8MKKJLzHmmRhBvUDBjQVwN
51154	payment	2132	2132	1874	1	1	2355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbCzgy4G7VDEnwzjJPX8Jqejdhj1oD4pmQCjTRbiwnvQbfJt3
51155	payment	2133	2133	1874	1	1	8222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iQez45kT2GWzGKCcVwmBWXzHA1ePQ2ZWmps3Jfnfo7zREahy
51156	payment	2134	2134	1874	1	1	8999	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHujZQ9trigHaU6hm2ttZRVmeJx8J5byy3PvzG8ybwiE4u2WDv
51157	payment	2134	2134	1874	1	1	9000	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzZZC81f9yaMa4HRV9oFHnuPWv7VPrgfL8J1saNCY9QGvXZqw
51158	payment	2134	2134	1874	1	1	9001	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBo6dew3BRQmu3na6K9Uczfp5W1QyhM2kULY9954K7xAPCwM5
51197	payment	1397	1397	1678	1	1	18262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf2RUFoJ9znTTub7x1yrP4uyrLVdk8rxqSYhQV4NJBButuSNc
51198	payment	1397	1397	1678	1	1	18263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTBWzVhb6jaxJTcuvYzLkHB36FFMWEh2TaUgrdeUYErZPaqEo
51199	payment	2133	2133	1874	1	1	8232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcphdz2cKcioycJFTGRcA3CP4HdecuUGUEZ1HXDZP4UpZ9fuyq
51200	payment	2133	2133	1874	1	1	8233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNJA2DiWETFZxwZw3Y17B164y99Gwt697mr2Cv9hiaiK23uRv
51201	payment	2133	2133	1874	1	1	8234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SqjrZPgZNVjy3ovvnnrjh9XAvrLwiVKHDZFExAiaH5YMfDWe
51202	payment	2133	2133	1874	1	1	8235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtS4PsuvNxeMHd3fgS4T8GcQ57M832mQEwXGqXrZjo5p15kK6L
51203	payment	2133	2133	1874	1	1	8236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TkmZMY25TWR6jVQpYKo3NEWWSvYWvvfMsHbvbubZAThz61nj
51204	payment	2134	2134	1874	1	1	9019	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmes7Sf7LXAaXHxgDx2scA5WXGjmvtkVhta3VYioqYdmjjaYeN
51205	payment	2134	2134	1874	1	1	9020	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkPmk2awPBQ1EhrL98wNx6ZwViqpPnfb11ZdXnKvmwXBHcUWy
51206	payment	2134	2134	1874	1	1	9021	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwziZSivsAzDTGo64Lj7bXx8Qni4o9LugUJAtyEB6AyWHtHir6
51207	payment	2134	2134	1874	1	1	9022	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFJMpm6gKp7AGMd1KQn2pisGSBAdw95WgB9jDEKa2BbGo4JoQ
51208	payment	2134	2134	1874	1	1	9023	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGTuRwiDpUmtM18YRREsbjhS2HD2kr6qcf8fgn8ZhhYk7JA9x
51209	payment	2134	2134	1874	1	1	9024	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCQm3K3yHY3tcwanCJ3BWYuwethJHSnC1Ri5AmzPQkpTvTNQp
51210	payment	2134	2134	1874	1	1	9025	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyfkkqUMu5QmrotC2Z6nx87UrHBWEmXeX3St9aa6RGBYK5yhr
51211	payment	2134	2134	1874	1	1	9026	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pbyumtBXh8k3AYXX5Ja6SGQdSH8UibxYSd4NDNZ6YokXHdTd
51212	payment	2134	2134	1874	1	1	9027	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyq52ccPdxniNbefEPyyq2p5JyBUHoJLoVMxYBqVw4MsAQPyU
51213	payment	2132	2132	1874	1	1	2362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcwAEwi7jknnBsEeMmsFZLV3P1NSpUifWMjTDJYkRwPjXbRcQ
51214	payment	2132	2132	1874	1	1	2363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkryp2SXvjXuUA2dCfUykRupXdSQQGx4mDjigZb2qutRGh3VeW
51215	payment	2132	2132	1874	1	1	2364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkAEjGaSUf2ZbyfWdmyHdiU93tH469ExaYD3boGacuHnzvTwR
51282	payment	1397	1397	1678	1	1	18271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRyHC6ZSULnoi9Wu2AoYJbdXZEfuNpwoQ5xdpJnCiUuqTqhG7
51283	payment	2133	2133	1874	1	1	8256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9vHtG7wTidtwgBtS3AgxZT8rYiWyxarenAgzNeumdHv8Fadn
51284	payment	2132	2132	1874	1	1	2375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GhBDS2J8RX1qxVb6nxD7BEoDxhSR7F3LWaesThTW2ehK7yun
51285	payment	2133	2133	1874	1	1	8257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7GhqCvsnMDGfgZZ97TgMkxeRersY4ggdhnvgrbe5Sor7Amxo
51286	payment	2132	2132	1874	1	1	2376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGpwghw1FNkj3qAwTS9EeR3HUXXpiZifYTTHdbmzzctFh4bim
51287	payment	2134	2134	1874	1	1	9058	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuYgWewBF7CzB5RxLCvVSVFdCk14GcraLQ8JhYBD51cjZm8Wi
51176	payment	2134	2134	1874	1	1	9009	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC3fhE13Yy1MkFkM6g1RSMzsbyD4hZsLA45zRhpYeS1Qv7Gk3
51177	payment	2134	2134	1874	1	1	9010	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmLc3VtY4CSYE5zSATwhGai95XYNnyVACGx7vsJw1C16oRsfy
51186	payment	1533	1533	455	1	1	0	2000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFPM4CTyZoR6TKPnWGTxKGGiVkoUJJyGmKh427tpEZ1xoyEra
51187	payment	1533	1533	707	1	1	1	2000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KsR622nmyyHx8ojhtqt4nwzPKxvD8xtXCiEAX1tjwo73y1CT
51188	payment	1397	1397	1678	1	1	18261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5uz4ZqMTMRu1eKJqfdbuQvMN3n9AsakoxXK8xgxx8AawGLvz
51189	payment	2133	2133	1874	1	1	8230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1VVyrd8jjGswy1WEE8fD4yGeLfcYH71TS4NrMHrYLgxpQfNr
51190	payment	2133	2133	1874	1	1	8231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGsuJGAA7jQtibH6k2gZxFtWyLpjrspEF7KrUn3PxrB1PtVv3
51191	payment	2134	2134	1874	1	1	9015	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzddA59JWLHYeJqNpuW6AJBDsEez5V169GsZan6jbdtKz94vBw
51192	payment	2134	2134	1874	1	1	9016	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApiUjnBNnbXUn4x8DFeKmdvJAVJwi5GahieaG25SP52Wym7QJ
51193	payment	2134	2134	1874	1	1	9017	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTMaQAueWHz6419W1BUx4ZZ2atWAuv5arbTb9nu8kvzQGWuar
51194	payment	2134	2134	1874	1	1	9018	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8RQpurD37xcghTr6VCNbsiMwern5CypWf3MzPKP8T8GuDfH3
51195	payment	2132	2132	1874	1	1	2360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLchXTrrcEJDWYT6ciHsvgHGgDqfute3YsgKsQAZ2UDocdgiPM
51196	payment	2132	2132	1874	1	1	2361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETF8qJwx7oiWnwho8GuKtxLTohu7j9brVeqi5kSEVVdpfkFx7
51216	payment	1397	1397	1678	1	1	18264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9FUMadqtfjrjXnc14pNuW7Dip56eN8tCMBv1Ge9aJUuHMr6w
51217	payment	2134	2134	1874	1	1	9028	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbMNP245xroKbp8ygrtXvxUpmJGM9M4ZLA9Tu9Gntv4Zmorxg
51218	payment	2133	2133	1874	1	1	8237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscDUxTbviJRoC9G6fDmabQvAASuXJSFT5HQuq3JEKkiueTi86
51219	payment	2133	2133	1874	1	1	8238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZk3TewAdL54uX28aca6diWxWUj5XocPC4bPvUTTL57NFBCPg
51220	payment	2132	2132	1874	1	1	2365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8ufbuneRgo2R9KgT8fTy9MHKFwpUuCqAiyhCQjRKQMRDQaZ2
51221	payment	2134	2134	1874	1	1	9029	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZok4PV6stFbb3JEetRHav64S3FCgL2rpw7hSSDZWxGmbvxWwYr
51222	payment	2133	2133	1874	1	1	8239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqM2taw3wVSgUdiMN19M6N7cAq2R4VXQqkw7ZgCoH8M4rcMXAS
51223	payment	2134	2134	1874	1	1	9030	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9XfGvAErhDB4oJR7GdmPtG5kkJogmcyVbvUVypSnUqsqQKfe
51224	payment	2134	2134	1874	1	1	9031	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdZ8ojxyrQPMon5Qg98oxPyMTa3pyTL16q8bQiCnaEQ8PfEdx
51254	payment	1397	1397	1678	1	1	18268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujzP6KxY2mnTUdWcebEhJm3pnYkEroGQ4TV9AGfN59NRPCVcc
51255	payment	1397	1397	1678	1	1	18269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHU7QbjrBiuDV9tDCUszbeHDHwAhqiqqP9PLFKMxEvP7ihQTu
51256	payment	1397	1397	1678	1	1	18270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu17DaiHgf8cUZnPksewoyvq5TEbhgdZS8Ctb8tR6scwbhMnEa
51257	payment	2133	2133	1874	1	1	8248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqcazruGKP6bsKCZbBUfgFN8UfQYcMXA6NCvP7RQJwfNLVLYd
51258	payment	2132	2132	1874	1	1	2371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcgN2wHWddDV3KEhohK1f22sk9E2Hgxhrzi61gx7yE4HroW7Ep
51259	payment	2134	2134	1874	1	1	9045	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaiUC8Dz7qAN8xMznv6mfJExvgbsAQf7G7TminYbC2Afvt8td
51260	payment	2134	2134	1874	1	1	9046	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8pyqyHVJmDWu4BBvWir7jdP4YssgoJb7dJzac3KrTve5LFGL
51261	payment	2134	2134	1874	1	1	9047	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLL3r9q2NQSXVDhgBVxAsvgSHprGeUZdwjeW3DEqwAhnp61Dy
51262	payment	2134	2134	1874	1	1	9048	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbG4RJyCg1ko5bNbrvr3Hf8AfnQTcDxjR1rz33wJ16Emp8rLBx
51263	payment	2132	2132	1874	1	1	2372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwLWrckrvHCvkao1DEQPapwRRbPxPr77KuSvhX8cxCqD7YcRu
51264	payment	2132	2132	1874	1	1	2373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnm7tZZgdqqYspcCC1hJQYfS8m5eSQbGuGkweqBxFm14rq7xxk
51265	payment	2132	2132	1874	1	1	2374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGjDa4Vo6F2qSZi3ZvfhZXjLnV7x6vKvxg1o7UZjf4mu2U2CJ
51266	payment	2134	2134	1874	1	1	9049	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vvQXfqaZ5w9DTTcFH651AHQW7HxuiH2hRAS6nQjYscxg4Ftx
51267	payment	2133	2133	1874	1	1	8249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DiGo8uLyEAwQyEMSKdxsyxHDKKKAesbLrDzsSvC73JqUTAZW
51268	payment	2133	2133	1874	1	1	8250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEx5NgqoFBxw58xfofcx14Rk829tDuYhPkF1dVb5nBV2ouLj9
51269	payment	2133	2133	1874	1	1	8251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvh4i2XjAAsdytbtfnVM3Y9RVvPFibTNDvb6mvacuY26AKYgJd
51240	payment	2134	2134	1874	1	1	9039	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9HBhLbGuu1BXBQ5qAMs6k6EPv4WvMsCans74e4wc5EQ35F84
51241	payment	2134	2134	1874	1	1	9040	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcXcHngFsDEWW1cXVKFABpbgaVcv2z8VQDurqbigX5JiZ6ELB
51242	payment	2133	2133	1874	1	1	8244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhGfYVhNrEZiwsoawyphfuiB6nVNuzbWw8GqdVLDXdCJNWKb5
51243	payment	2133	2133	1874	1	1	8245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVn4offf28FSHcJPPYjugW6XLfRHTQrm6sJqiEzBGitQZNqhM
51244	payment	2132	2132	1874	1	1	2368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHwcB7NMSSRWFRJhbfydDaNR2u7FQMx8XJ2qaGaQ5DJgPixoV
51328	payment	1397	1397	1678	1	1	18276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtc5cCThK7hgZjQRsxKKE4Zq5CmNZvDp5EEtE6q1Vkoxg4J5Q
51329	payment	2133	2133	1874	1	1	8267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrHuhDDYyHDWkGiEZC7zRQ8uqmwtv6YtkzxC9Z5FqgwrW56Vz
51330	payment	2132	2132	1874	1	1	2383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ChsswatscXxqmqGBnQauwTXqs2f4A8V1pFteGGjQLzu4S2co
51331	payment	2134	2134	1874	1	1	9080	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPR2FznEVTN62HQJBUDiZHVZMrMoPYvHDtMN8jJ4LDsy7oshLm
51332	payment	2133	2133	1874	1	1	8268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJmRP1fCazGZach9VCxdnhKNA3G48pa8gZ2bH7zpymSgjgX3Y
51333	payment	2133	2133	1874	1	1	8269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8veLiwDTAYqk3FE5LjWeQZhp6RgNBkm4giiE6KZRNLfWsvuV
51334	payment	2134	2134	1874	1	1	9081	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjGGDiLk1hKwxdB1Cuge3V1hrUrZhVaJZPB9dfJPcCFqTD9WD
51335	payment	2134	2134	1874	1	1	9082	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rLso5ncp9MTQGJqCnxQ9pozW6Mr18wMNgMGBbFaRpdAbvTNL
51336	payment	2134	2134	1874	1	1	9083	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAiBKtWv7evi4rnKG9BW44VoavJYnuH6i6fcN9vmGbXd3FpVD
51365	payment	234	234	2439	1	1	0	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApgitWdK5KoGGyJAPPFjWJELZ7ThazcFxko9zpoWD2dBz4Z8Y
51366	payment	1397	1397	1678	1	1	18280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszpmqnSbG6CJ4quVTHyJ6NkVxsH6BXKB8u9XnsBAzGZMZMSMc
51367	payment	1397	1397	1678	1	1	18281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PgiihuwsL5HhGsDUspyWFZrJfkFiMgmqdc7PS7pojiEeiYVN
51368	payment	2132	2132	1874	1	1	2388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPubpvXVCHbt2fD3LGBjsZQX5ZCZup3NZSUv7m26WP1twC9px
51369	payment	2132	2132	1874	1	1	2389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuXKk7QSMbriiUXXyaqCA1uhxN7KBYDTNm2p8dM35AMS9pVW2
51370	payment	2133	2133	1874	1	1	8278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdAynKRS7BenVxcfjnQk6piH55xmzwZUvZtSPhFbDhafrciMr
51371	payment	2132	2132	1874	1	1	2390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn9s4YJs2CMtxN79Xu6iAgDwU2FYFwyCPXW1ZkwNYYcEVoXyf
51372	payment	2134	2134	1874	1	1	9097	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXsbJuqYuSLVqS4WGKVsSbAuJpvLZRS3mySRZ6Qpw43y7Xxg6
51373	payment	2134	2134	1874	1	1	9098	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT8n3VNidTwyqV9HhVK3a3G434g16NnW9FjokwcDU2FxkqUkN
51374	payment	2134	2134	1874	1	1	9099	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxq4VGLazWtPwMncczSkg7johuV3Mam9VLyH8L5rPuvwecaxy
51375	payment	2134	2134	1874	1	1	9100	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE21Fdei7rP7AquNpfYELqFe8Tf7SEz7ZNjig6bci41rkUQNrR
51376	payment	2134	2134	1874	1	1	9101	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4Urfg3zwPPZGqTyGC5HSKknyvqrmpQ8KEkXshFRL7DET2isZ
51377	payment	2134	2134	1874	1	1	9102	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ZCu9vgWqkXREQvxau3SvCx6wCJGACTVCib8MMune5jgBXm3
51378	payment	2134	2134	1874	1	1	9103	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAbE2XSS1iPVP84W5MdWecC92qnAmy6CUWm9UV7HS3Rsc6gao
51379	payment	2134	2134	1874	1	1	9104	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3wLaxonWQu6yVZGi4fomo5wPSsRpaKe8bCeY9yFShZ4z7AeV
51380	payment	2134	2134	1874	1	1	9105	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaSQkmF7AcaxvHka2HF8b1q3HGQneymzmyPTtpjPtqTxdWueU
51381	payment	2133	2133	1874	1	1	8279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvHyx3iwi4B1XoJwbw6u8Rb1tqPKxhS9MRjK7tyu9C3KFnVXP
51382	payment	2133	2133	1874	1	1	8280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrL6G46AhPCnkjfWVFYHZVwmgvFRRnzkJQ9z67TNCucqCPou7
51383	payment	2133	2133	1874	1	1	8281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoWoyHFAVU5qKcBDxdke5dPdau5dZG8qiAwnZwWUZnxkA2wof
51384	payment	2133	2133	1874	1	1	8282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATwHBMEy3TA21dQdp6MixcS8S78ZeApfWpouuLmymAD7hjxvS
51385	payment	2132	2132	1874	1	1	2391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTcbxtAA99h6erHrVaX2JSL5u1PuU5D86VA9kWuKmsT9A6fUC
51386	payment	2133	2133	1874	1	1	8283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZw2c94UrnRZFHTnt5sZFKAscHWGz44yAnL2t9b2p1k1oub9A
51387	payment	2133	2133	1874	1	1	8284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwc98FWQdnfaFtb7UmEj8XxZqMnZWUS2445pnMRwPjoozNAHV
51388	payment	2134	2134	1874	1	1	9106	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7pYi1kBtNGqC35BHdWrVfVQ4pA3vtdpKooGVUqB2nCpFiMADZ
51247	payment	2134	2134	1874	1	1	9041	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZX9WtegRC95SSQXXwd27M6Y5ZmuvQFVbBgUi1ucCBEYyQBvYL
51248	payment	2134	2134	1874	1	1	9042	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFctD3B9VXPFESfpBJNnLCeDhguUMDHMmx2MGZBrrhrF2faCsf
51249	payment	2134	2134	1874	1	1	9043	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenchkfXNuz5pjPEqpz7SsfTFQTSnTYD75CAqkdbBn9ShX1688
51250	payment	2134	2134	1874	1	1	9044	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJU8XNsE9X2A7PrrSHNQ9GuxwDtaCpWq5jAEcxwD1BrbcBwn
51251	payment	2133	2133	1874	1	1	8247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5GA4iGfkNe5nJnCjXv3JCAamyEsG1tja7TDwVCmST7XdBn81
51252	payment	2132	2132	1874	1	1	2369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVJUMddFKS67bzhTuFz8rakxpkzWyvFKH5h69V9iAkhoKNXU7
51253	payment	2132	2132	1874	1	1	2370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4sECWEGRAyvEaMzXAvpvGiZGquzBbohEwMAan1a5trT8cLDf
51337	payment	1397	1397	1678	1	1	18277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbR2sAcBRvafd1W7HJru4kVWFpE5fKFYZgSpzuPmunNUozF6dK
51338	payment	1397	1397	1678	1	1	18278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wxe2HXDE6KGFkAAfzDYEkXfjBNBopoJtDfWPiFjFbp1HSgUk
51339	payment	1397	1397	1678	1	1	18279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQwAXxjyFzkYDyJcs2AcSxzb3rLmJqhChyUurs7XofgcmW7LU
51352	payment	2134	2134	1874	1	1	9084	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y8cEUc7bUrGBiJDodvFwo3rJJKn3MTqRFtW7NNR1V2AdGXk4
51353	payment	2134	2134	1874	1	1	9085	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5Mbcc5jdc9Lodk4whq4drcq6H2LH8DNZbbwgEV2eUThQEMMN
51354	payment	2134	2134	1874	1	1	9086	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVzNLnJxVDMVGW2XB332n72JrBrmC9q39KFFHuPed4BUCGDbo
51355	payment	2134	2134	1874	1	1	9087	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2Bqq36hUHgDj4JTnWzXAAfLuncr5yQ1kscg3H2x2fNGWzNtw
51356	payment	2134	2134	1874	1	1	9088	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8Cswk81xxAw73h9qH7UF1m7PrSxZQDqUCkJ5kU2gUWBeYAfr
51357	payment	2134	2134	1874	1	1	9089	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DTH4wBcbokRkHjuSPbVHs9v3DA92rKPGT8md7RWNNfjeN8mt
51358	payment	2134	2134	1874	1	1	9090	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgotZ88hc9vDWExUR3rYauSR3sgTpwW8KfzVPaWfreVNLLR3n
51359	payment	2134	2134	1874	1	1	9091	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCBH4yvmsZVcU4j39ZNg8jNczASrLiGSzn9Jy75cLnakLUyVN
51360	payment	2134	2134	1874	1	1	9092	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6unH3AQMSfhwveeBGqJmsEqVS4Q7mZjq7QqGRgLLKxjqXZoV
51361	payment	2134	2134	1874	1	1	9093	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLnMwtS7N8kfwf6cFbcsXs9oGbq6rSt1gziGoFP7onx1V3Spi
51362	payment	2134	2134	1874	1	1	9094	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mQE98k43XQzL55fAa3zWGWmzpco8Q3neWPFqPjSTjadednLn
51363	payment	2134	2134	1874	1	1	9095	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSCBXWVak3TGUXty4i3LVmjFiUYNfhZ63cL3d8ym4HzN6o9p6
51364	payment	2134	2134	1874	1	1	9096	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1b2pDB8EqfQ9HUX8VAhoSbFdZJFbV3hvq5NkrLwQyTCDoiHN
51396	payment	1397	1397	1678	1	1	18283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKLyzJUJxVrAwsrJaQ34e3xaZssanDq4q7HvpnUjzV9NPCXgX
51397	payment	1397	1397	1678	1	1	18284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofkayYx7RasoiBuxqfuQYKJGn1Dtk7rqVSqSpZahsQuE7rNAL
51398	delegation	2163	2163	1483	1	1	1	\N	3031580	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7oeXDhB9taMKe9oTkpRq9LWQyD35kimWS3K1f7R7JAfLwyyC
51399	payment	2134	2134	1874	1	1	9110	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmSnJjjrWFDmNXwkvtjQn8xjLmKZSYMESm6R2JEgebHAjLKSQ
51400	payment	2133	2133	1874	1	1	8286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKo6B81ndEwLY1Rm6LQiocszZRb8PFbkj9R7aEVPyZtbC61Qv
51401	payment	2134	2134	1874	1	1	9111	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhJyE3fabQvu9NDDhJ9VUvnMeqKYU7KWdWseNSAt21udz4MUD
51402	payment	2133	2133	1874	1	1	8287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAY4z1DqQc1U17K9NNX4Kd6mNgXN3xaaw4i2ehfZiaRhKRu4q4
51403	payment	2133	2133	1874	1	1	8288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YKLRbwGPCzWiPwEG9f8o22oAej5bVPi1ff5Tnj4yXJKNCZta
51404	payment	2133	2133	1874	1	1	8289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHhARCreZLcjCrKJ4EmZ8JyWAaH7BTjHZxpp72xWFjtZhmjbA
51405	payment	2134	2134	1874	1	1	9112	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAo7aLncy15Wu97pbjZrUHAt7QbvSTia3JSQDZRW6LQ3FGpE2b
51406	payment	2134	2134	1874	1	1	9113	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFQNpbgoCqUhcchDs2K4KnfJe4cd19dUF4jnKkXDXTJ4MExLd
51407	payment	2134	2134	1874	1	1	9114	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRrr1Ss3HGcLHJXMp81CwVrE97ditGbKhUBDqLhEaDoinAXkn
51408	payment	2134	2134	1874	1	1	9115	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJXgtgDYns7QrykPYMHwSn9ib8PxNLomKk8SYPsoqVD8tYW9r
51409	payment	2134	2134	1874	1	1	9116	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbj9TnNVVKFVN1YfjwsCQKFugjKAmJtWGabbBFuScEpSPyVqT
51410	payment	2134	2134	1874	1	1	9117	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBo8NDXd3XPzGSyEwpfJ429zLHwueCsRx9QbhSXFU65y9tG4E
51270	payment	2133	2133	1874	1	1	8252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirAPYQGwRRFWf73gQTMta1DNXNKxjqCSoKrNLnCNe7qAwcwjN
51271	payment	2133	2133	1874	1	1	8253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh9Fo7CkZicYm3baCJa8diP4FNfF6gY2Te7rb5oHVNhwxL2Mwy
51272	payment	2133	2133	1874	1	1	8254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvUgkW4ZV8Q8meJ56T3Zur5sCp9ryxbCSPb5sro6jALMPMWzq
51273	payment	2133	2133	1874	1	1	8255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74s5qaonPBdGWT3JhuXf8wzALkfXvgmoL1KDWQVUghcR5hbqh
51274	payment	2134	2134	1874	1	1	9050	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGC8ziRH1CKG78eougZPgTDHfiFwstu5jGCYUwxZTo9Udun53k
51275	payment	2134	2134	1874	1	1	9051	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4bNb9xt9Keubg9E2Tcx9cfSUeaXkxC3c9y3RQjwsTUqvRtBA
51276	payment	2134	2134	1874	1	1	9052	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFQ6kuEQC2WBN3QSCbsHFRcxbLKKvVX5AC8VWw7i2d3mh2cSf
51277	payment	2134	2134	1874	1	1	9053	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XxpDfuRpoPsMDyisN3tonY4BgrRVhhTL4nmofRetz49Vs1wx
51278	payment	2134	2134	1874	1	1	9054	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H64QYBRmyNN6v34HqemGWPxNBwXeu64thTkEfSo6UD1XDhar
51279	payment	2134	2134	1874	1	1	9055	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82dQk1Pm18S3NhGaf62noavnQvsLSAZsskw2mnbNHouvK275S
51280	payment	2134	2134	1874	1	1	9056	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdC2bB3VMLVXeykAhMoc12Wm3TpzicbSSTkHrBPYoa8EXhUmz
51281	payment	2134	2134	1874	1	1	9057	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5b9GuqU2jn3cYn57Ae4kJQvoZK1afTpeiCwEcGiDgKc4DkX2U
51291	payment	1397	1397	1678	1	1	18272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7pFyCZJ267rYqzBs6tbuWbcQSYy3cJEVXJiAx7zHU9iW6rCw
51292	payment	2133	2133	1874	1	1	8258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXk88dVKaXQqzAEA4kp94pPjQ8CzRWEGuF7QRiFePSkUyD4v8
51293	payment	2132	2132	1874	1	1	2377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMYfsEFzLG4VTWMUMAoWXWCFkMfkNcaeFuVS5hwRUZxwE3vKM
51294	payment	2134	2134	1874	1	1	9062	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1ikKyqr3egkW3XW4SecLujqoKP5wUhken5E9sG24KkiHZj3u
51295	payment	2134	2134	1874	1	1	9063	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYtEM2k9oALj6STgK4USuyahuWmih2sMst2VjcRcQuU9pAcTM
51296	payment	2133	2133	1874	1	1	8259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2T1ZrvE7oE2K2GLQfWknEQAs9SSqZmKdUnswP88TeFyYT1HF
51297	payment	2134	2134	1874	1	1	9064	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPRwsrFtus3pd8gLrZdB1HCoFqHC4bhnsNxLkBKFNQTMZToHq
51298	payment	2134	2134	1874	1	1	9065	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNE9oMfo2m1PYgNgoBKV7gB9tAHgUsuUCSKrx39jnpF8i2KrD
51299	payment	2134	2134	1874	1	1	9066	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2kuRDcUhDs8wDc5aumQyHAbbdqQWjkagq1qr8wXyEAjRAcrd
51300	payment	1397	1397	1678	1	1	18273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLDYbxfUECnHjaHiebjodeQ5wkfRn15PcEYu5V8gz6DoTXCU7
51301	payment	2132	2132	1874	1	1	2378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMnsfhWbZPeNbcDz9BgBjjXp2qFS2sLQ5aFK7YoAFDjMPY2QM
51302	payment	2134	2134	1874	1	1	9067	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc8tNaG7Xuozdgct8Sgbe2nzdXm22aHAsrYTRYeQEF8nGfbt3
51303	payment	2134	2134	1874	1	1	9068	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyRpHD8kL2cS2aB8R26ZFUkJZbUekmJGgH6AMjp5qQWmB924f
51304	payment	2134	2134	1874	1	1	9069	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQTKVf4MC4d62jYfcjf3HQQHT9JnEenRejxXMkU91bFMQieQj
51305	payment	2134	2134	1874	1	1	9070	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9QrsD6V26Lz7NDMJTs68SWu73vUbU2q58ct58AyFizNX8mmQ
51306	payment	2133	2133	1874	1	1	8260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPozvcwenBENRUao7ARggGz9Mh9MRrLK8ttwr93WSSJW52Ge2J
51307	payment	2133	2133	1874	1	1	8261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumYc1iT71sTQDZLiKYcF43KW2WaoBNEb76DroZWToobFGtmN3
51308	payment	2132	2132	1874	1	1	2379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLsssRYqfJBpigjmLwy8GBiypNcVhhLa8DV4WoymCTG64c8ye
51340	payment	2132	2132	1874	1	1	2384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUFN2FLAi3fE5UeUynFAvdqN7g7rwxyBwS6Yrm2q8J2Er3znXK
51341	payment	2132	2132	1874	1	1	2385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5PY7MqMmFtWYyPKsxvGxxYciqDPHzGi6szd83jyJSsuhNSB6
51342	payment	2132	2132	1874	1	1	2386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLB6LpX6Y73ZDEkADmn19tuYsLV6h9GJgF4JPUKcvMV99FCJA
51343	payment	2132	2132	1874	1	1	2387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4X3bSbLbHyBr95mVqdcr9WcP8jeSxEQjtDsZqJZw1WYvxwN7h
51344	payment	2133	2133	1874	1	1	8270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAZ9KXGR75aGbJMt59P1F7PxgH7VhjJZuce3fuZ3vdhPQzLbj
51345	payment	2133	2133	1874	1	1	8271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrXpav7Sk89bRxVtmhQVMzvDF9S8o2Hx3y1acfxeuMWfxviFV
51346	payment	2133	2133	1874	1	1	8272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV63NNwi57njq9LLnnyBM2mp6CtdqKffPUJNY1fyw16eYjmx7g
51347	payment	2133	2133	1874	1	1	8273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXTCZjtFyCLW1b8ng982dpi8kqTQ1PQofUvkZeVP8faztGhCv
51288	payment	2134	2134	1874	1	1	9059	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfT85JLDwqSZK7wYTAYuacTTi1XVGCCxB4Mb3YadXdipsm53o
51289	payment	2134	2134	1874	1	1	9060	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqntYpuRZcEYL7zAN8sh3vTEeZivVfHroZ2Jk1gfmacbx3Hmu7
51290	payment	2134	2134	1874	1	1	9061	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BDXkr14MFuEEBfYSNNXmQ3TGW26WKC4ZCMdhDcNoEQNs8o6X
51309	payment	1397	1397	1678	1	1	18274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhZqmsWb7AQVqoqXP8rv9dcRZ9xThzxUr3NxdztgikjAtguC5
51310	payment	1397	1397	1678	1	1	18275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUEXj1XTAtSQhKThM1De29RsPhGdCyLBVVaNEf7qrkcexhrRS
51311	payment	2134	2134	1874	1	1	9071	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqBjBrXLykzWaYY7amELJkx6MogvqBh7FXC4PUE85D7rbxxvJ
51312	payment	2134	2134	1874	1	1	9072	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2ywuUnTVaopXHBkFZaaeLTomrBY3VapEA7QyhD8wU9CZPc8g
51313	payment	2134	2134	1874	1	1	9073	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFg75LrgwTVz182WcmsifnpytKMdAZk8NNsDPTDBxiCLAQmHm
51314	payment	2134	2134	1874	1	1	9074	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagiyZ8DKCntUE7ybNf86Ri8zRcCzVccaDjfxauQLF7rgKJ5kT
51315	payment	2134	2134	1874	1	1	9075	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCsvo79aQT8u1PoXdrjqdLinsWx1jo33Nq1wPVFhoxnLMhEWB
51316	payment	2134	2134	1874	1	1	9076	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLGLwrHzAGS4rT9vJYAZFzegsE9S7e1JB7dG5EpjfWZ1u25Fk
51317	payment	2134	2134	1874	1	1	9077	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLpD4f7HSq8vDDebGGqAcN5JcBKEYVRAeFwKGYLV591zJKEVZ
51318	payment	2134	2134	1874	1	1	9078	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WWst8sFPqpSS5vh8m9xMyoNsHHnAvA1J5yPDbVLBJ7oQvBrJ
51319	payment	2134	2134	1874	1	1	9079	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutD1Qzaiou887h64K9DCGBtHknLEEfzSqw4ienaQNdcZW4q49
51320	payment	2132	2132	1874	1	1	2380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEwEmTH5wj5yUfem9Pywk4UfnVM9KM99bwH48UcwfJBDGoJU1
51321	payment	2132	2132	1874	1	1	2381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHobddWDAaP1aVUog8LS3UP6hCJJmM7FSQPhwRv79RD3CrSkHS
51322	payment	2132	2132	1874	1	1	2382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG4xphjQKPBp2gTCTH8YHNvcG4Xza1J7jPeVPu9DpS5MFSK7v
51323	payment	2133	2133	1874	1	1	8262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFtNnur8cneBWYWgttv8f418XNP4enAJXTJCi4sxDfbo1KpWVA
51324	payment	2133	2133	1874	1	1	8263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLegKKcSD4UcnPjTBtb1YPN8CnZHPfH2aNguDxu14YK8YkfUJo
51325	payment	2133	2133	1874	1	1	8264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa564njUh5ieR1ZXmXVGMBW8oNzVSx58kbQyiVje5FssrGZdrAa
51326	payment	2133	2133	1874	1	1	8265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kDqVEP3vKeWrrrmxY6LLqcXvbsBzrVoBpVbGTkx78t5j7Gcg
51327	payment	2133	2133	1874	1	1	8266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBMmyCnb1fKSKL4ztxsCFuDRzW5TiCA2FSbrfTb2GvmLsNvD9
51392	payment	1397	1397	1678	1	1	18282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeU3Feyfpv2Y5LtMSg9SLCWvCsPxBeRoAjG3c4Qkfpsm5EL8tZ
51393	payment	2133	2133	1874	1	1	8285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMPAfDQ9PhzwRLSnZBUf2Py8bQppm26Eyjp6XbanhzPwjhFWz
51394	payment	664	664	664	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFLe51oWEgrFLZ4bqHwmpMZsLu2zgntXLmWJKmsap1jLGfcQm
51395	payment	2132	2132	1874	1	1	2392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvH7LiM2Vc2AY4ei7rHepehx2yjki14VdEEnRXG4GMth9pusgh
51443	payment	1397	1397	1678	1	1	18288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJUqPcL5jCKCg4uwaw1zM9UN71ft94MTPedM59pcEnF7uKdJF
51444	payment	1397	1397	1678	1	1	18289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxL4NQdnui2KR647V7GeCXKa1CjY2mrybAVMwDFhFeo27gpCWa
51445	payment	2132	2132	1874	1	1	2400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNuzPbLSEwykzubCy6XwLqMsAcKJmRjxq11XHQFiQYSdwEjww
51446	payment	2133	2133	1874	1	1	8298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaucJJ5b8pknS1vy2wh5anSVUQTfQLkfE4oN7gnV26yGU7kk5K
51447	payment	2133	2133	1874	1	1	8299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagtRWaFLrfXSbcc6bRmMsMKqcUdjcBSDSdVrTFJ7DEkoEWXq5
51448	payment	2133	2133	1874	1	1	8300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjWhSkPbRVsbeCcoSvzmr3Pr1GGBVDJwkDYzYY8UQNiHJTfYM
51449	payment	2134	2134	1874	1	1	9132	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZho7VbD7DtdMrgbHRcJvhwWURZCCWfjWR5PRhwmL6MnWdPY28s
51450	payment	2134	2134	1874	1	1	9133	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN3EapqQutGM5ViWGYddWDe3o4b6yBwp5wCn74SjjCiDsF1EZ
51451	payment	2134	2134	1874	1	1	9134	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1boEChQhcQcm6ZC4BPwBdjnMcLtLuDs7dJ1qePHtGohQTwRv9
51452	payment	2134	2134	1874	1	1	9135	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJ95yjeZWqC7k1Vys1PqWAz1VJawrF2JmCJEP3stWDB8sJ4wa
51453	payment	2134	2134	1874	1	1	9136	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3Cm8P1HoGBPKGF6TNou154fPCf5gu999DGPrezj4QGFP3KP8
51454	payment	2133	2133	1874	1	1	8301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqebZPXFm3uzg5dGz2uenpZDabywqWXrjxkVqdjLdWn1S6dF62
51348	payment	2133	2133	1874	1	1	8274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpp1rD17EgawK5JJLNGsaLApbfcb8miy1f6UWnxktXYUiMcXve
51349	payment	2133	2133	1874	1	1	8275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbGiecMDgSKzga7qN6rd81BALu9QMUxYDpyBV1F2cQwVhzNMH
51350	payment	2133	2133	1874	1	1	8276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBk53YCRMfLr5hb2LRnFcKjxXSpJrx8uvkLnQBzq2gz6iQTf8E
51351	payment	2133	2133	1874	1	1	8277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMTmnMrhh2qaimnEupAdFPvJLdcjYuAErErBSyHReTDRiaa7e
51482	payment	1397	1397	1678	1	1	18291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDZ7Tx3SW1ZF6LwYkcc2LKyQCdvF1BsArte57PV69kkCdTzxu
51483	payment	2134	2134	1874	1	1	9150	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS95j4wG6LWLS8QLNB5Z3nbHg25KDo3cLwSv72JTbYo8u23tMe
51484	payment	2133	2133	1874	1	1	8310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPtX6gzdcAk6CdZGPc4rHJ36uRR3cw2zD5Q43D3zJEZ6PC4QP
51485	payment	2133	2133	1874	1	1	8311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZk1zqURhVPMB1p9aXv26xudJkkUarLX8vCpLoNkHsYv31M7s
51486	payment	2134	2134	1874	1	1	9151	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCwuFzAvE6ndZHAgGRwxbLqtXzuhwL2zTxtnaUAuRWVVgMT3W
51487	payment	2132	2132	1874	1	1	2406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYonrEiGGuFgvAYVEp5oTh4LBvWmvxiMfGuvzckaY5SVSJ5MBn
51488	payment	2134	2134	1874	1	1	9152	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9yCf95Dvx9eUuZgT8cDKAJBG5MFAFeyuPwbFCKqk6qL3Qfgb
51489	payment	2134	2134	1874	1	1	9153	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkzF8sLZ2nmSJtRko8SRaSd6Tj4cVhABV8srvcyBhFbmhU3Ys
51496	payment	2134	2134	1874	1	1	9154	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiNfpghMtvcMdoDKw8A3AVvFjwDgCfpZRSX7sYKP8ThDc7aSB
51497	payment	2134	2134	1874	1	1	9155	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpAyJRyqwcWKZCE85QLdeVkqua6c4gxVGXnNhbvrWZKGQSr2k
51498	payment	2134	2134	1874	1	1	9156	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgTqShaz7Kpoxi1H7BR5FTuvKijfR1mCy231i57n1LPX49KRB
51499	payment	2134	2134	1874	1	1	9157	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoxf6zQnkYjL24huCyecVWQbux86g9zA6is7b9DM6oRCjTo3q
51631	payment	1397	1397	1678	1	1	18307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVi5e9djgsU1DDcamh4uwni22gJYAREh7r6VD9pdWwW7w4ZbLx
51632	payment	2134	2134	1874	1	1	9219	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepttFxAZrJYvnEK9dgedFpunkgsgQDVHRtC87JawuVzVGYBmB
51633	payment	2134	2134	1874	1	1	9220	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuL7AQySRMckpPGALtj8b8P5XGmj3LGv2VgQUEac67RNDijffb
51634	payment	2132	2132	1874	1	1	2429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyRbyRLycB38RZKhJ1LXQppwQe5HgB3zphyxqgSG33roHKbH
51635	payment	2134	2134	1874	1	1	9221	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dZ9cbxckphgUrcRPckwPfTT8nU7FMpohXdQviAfF3JVVpMpj
51636	payment	2134	2134	1874	1	1	9222	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKXFyjsUVNqHHEjEPqty6BbuuMT3LPV288djMkWEBg8jJ7jnQ
51637	payment	2133	2133	1874	1	1	8348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExwy6nbL65QRBpYkhNKfA3gEVU7RmPrHTB3WVwvmuzUfjFRXq
51638	payment	2133	2133	1874	1	1	8349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zJmAJxS7aCXUeYjHaCgw8SDyPDwuuYX8pBWj8cDa3maY3Umb
51744	payment	1397	1397	1678	1	1	18319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBsobvnFGMZjJS5Lb3rBEVkQdJG1ynt2ijLFgYmJuPHcNjfPu
51745	payment	2133	2133	1874	1	1	8378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmBfWk43vVTQMdaMoUwsC829mFhE3ge7pVufxQ2tHV1z59neU
51746	payment	2133	2133	1874	1	1	8379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdtCzLjaF9qwQj8XQ5TLsPTP8MTbMzLD4Fj6Tzt7jjk5GTpQo
51747	payment	2132	2132	1874	1	1	2446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WHkNr37w7iHxL3PSevymm14P8KiRqQsVyRWQHUN5YBE2cSsa
51748	payment	2134	2134	1874	1	1	9272	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpcedLar3frccRpBrrJSyK6tfce22iiU6eUbffyLfHuiPuf6s
51749	payment	2134	2134	1874	1	1	9273	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZR9je4FtzbAY3Xs5cdZuBh7MdA3Sg1vGa7otvofS17MgvcLZ
51750	payment	2134	2134	1874	1	1	9274	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSpaPGg42eF6jMH6nAcfgTDZ72YfTvraLmQY3Qn1ahqFW8f3N
51751	payment	2134	2134	1874	1	1	9275	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FXw4Wan4UYZzmFZtapc43JEgkqmT4mh3zCjLF8eUo47ew5Uu
51768	payment	1397	1397	1678	1	1	18322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGB8PCEm7M316ua2WRL3oE9Wy6JHc7V9FVo1jHciTwcH8paF6
51769	payment	1397	1397	1678	1	1	18323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRvJ1ZzUiwkNvaDsTxwWBKmFwA5CMeJqSEzFv3su9ktJXcSSP
51770	payment	2133	2133	1874	1	1	8383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcysCyfou71Yg9j5y5xhGtXbUznRWhfyp922kLvfbSQZHsMmy2
51771	payment	2133	2133	1874	1	1	8384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcb6RebHjJTMjxs9eWULzcYvbt3D26RuzpFzFmB4ThQ6BHw63s
51772	payment	2133	2133	1874	1	1	8385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ckJtjjkhn7Gm8BoWtgT6YBdiXEybJFixoTu3EjR9HvMVCDYh
51773	payment	2133	2133	1874	1	1	8386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVwfoGh3omEvMgnyFp581DTFrxc5KLVH9hJD4T5zudTqbfUQr
51389	payment	2134	2134	1874	1	1	9107	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcr2UUxVCXpBroVm35YargDcGtwtRuhZbf1FvAdYYHLzrAz6YP
51390	payment	2134	2134	1874	1	1	9108	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu17usF46B8mRpUeJv6aJANpFXZUmNjPrn4YRdWYuH2s8qBwC5
51391	payment	2134	2134	1874	1	1	9109	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3v7VQVi2nywNBBNaFXs7NDoyKRr6K8z94Aje1mB3iPcnxvYN
51415	payment	1397	1397	1678	1	1	18285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RLGN1zRNqcv9KJhfpEzvFmeqawWBEkQ5QrJRDVXPiVq3bGPz
51416	payment	1397	1397	1678	1	1	18286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRehGyuKmVzVkanuFyWpyx5QR1jRPydG9RFXKU5H5jt7ZcjBe
51417	payment	1397	1397	1678	1	1	18287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPKTcnHpDoDFB488qvPFR7Xig5epQGGrkgG4F3nggytHYNqKe
51418	payment	2132	2132	1874	1	1	2396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotgHsumoEiNDmxRqFNYhkfVEYee5NGVLCF2yMR7i5myNVaDkP
51419	payment	2134	2134	1874	1	1	9119	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtifV96ij8gmL4nK2xE7zZHkCcu7rNm4qSuJ8CTxJeJU7JUbsu
51420	payment	2134	2134	1874	1	1	9120	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEND2VL6pcV7732ax2K3ggHe8PPU5APkfKys1WFxeeUSVpm2Dx
51421	payment	2134	2134	1874	1	1	9121	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EprTM2kC4mfTsLHhHTKnpSLS7f6BFyuHmTZWoD3pC9DnpQFA
51422	payment	2134	2134	1874	1	1	9122	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujKbfuschMEBpbuNTJE1GsAXznwXxKV4Wt3erJ76USDG6NaUF
51423	payment	2132	2132	1874	1	1	2397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMxyaXgpKSrCY1bzyYFS31vG32BoL5rG7eRrnYbgHGyb9ikS7
51424	payment	2132	2132	1874	1	1	2398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvkmYHwcu9WZy7A9JAUHibbDDx4aAbBeLPWtsRoiBpvZLjQQL
51425	payment	2132	2132	1874	1	1	2399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzvqRKHChsgniosYB3VRCqT1gStUk1hXwfUM4isyVHxy22n43
51426	payment	2134	2134	1874	1	1	9123	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTAdETeQX7tGxnW1HyujnbTcttHoYMHJiXV5ktL1QZEkQGfZp
51427	payment	2134	2134	1874	1	1	9124	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ9pwhnWFhXtmxtYhujK8hkBX5fDY9MkzjRMcMFEaKXGiHC4J
51428	payment	2134	2134	1874	1	1	9125	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZXQRGX8Chxg9WEL3DbvUPLJCR3TrvqM68GE3zNMooedD6k6K
51429	payment	2134	2134	1874	1	1	9126	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYqe5gnvjPYPXpoRtWWEcgqQ166nH5y5tiqVTSWyX8NLDdPNY
51430	payment	2134	2134	1874	1	1	9127	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBU9uSEDr3bsxzhw6oh6XcbvoNgjv88tcSopk3FTb7HVZswn9
51431	payment	2134	2134	1874	1	1	9128	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyDQWLkV87ZefTf2Z6qYkx3FmvdicUjWoq7aoPSga2UPAF5qs
51432	payment	2134	2134	1874	1	1	9129	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FYPNkXnU3BNZKnHujDerCouosiD5azJ18FLNDB1QaKPrCKDd
51433	payment	2134	2134	1874	1	1	9130	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnExSR94wNWNGjmemjN7XtNE4xbcGtDbsoSYWKSWzUn9GXvpXv
51434	payment	2134	2134	1874	1	1	9131	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXFXuHPFJAmBCftfh5JNyYMKqR1jVTWuGG3swDteKV7wZDjqr
51435	payment	2133	2133	1874	1	1	8290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdYM4sBGSZJPmtCwoTJXbyHmvB8PrTmWscTWy3SzK9Tnp6RBP
51436	payment	2133	2133	1874	1	1	8291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXS4mBhanvqBCsZVCLRcXBK5nJtZDnW5NnaJzEn1RVZEB351T
51437	payment	2133	2133	1874	1	1	8292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyYUjqNurhfFruMy5Fr2fMa4enjDsDZs2rGyQsR3wpJ4XfqiH
51438	payment	2133	2133	1874	1	1	8293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ouBoL6yksBxPNJ7A1C8mXwUsmMHexPV2etkmE1KtJHeStU2S
51439	payment	2133	2133	1874	1	1	8294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuym1knSAVLxAaSU3wyLc5wZRU57G9bAjgeYxf2HS6MCSpC74W
51440	payment	2133	2133	1874	1	1	8295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGunmHLZT9pjZjhEakATbLYh6Du7s5Yv2HNiJkwsw17BdNGGq
51441	payment	2133	2133	1874	1	1	8296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmZfN4JAtWN4cyMd3b32U2sUrRPGz8R44eU4DM5uZRRYUMTDq
51442	payment	2133	2133	1874	1	1	8297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHtg89AP6RpzLLH2C7MfQBaXxxnG4f1n6vPm5q34jF5t5bDRc
51527	payment	1397	1397	1678	1	1	18296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWerKy5wTjfx3jrzQ1SsJZKSi9kVxG1DZqYwHLsSwbJmmwVqQX
51528	payment	2133	2133	1874	1	1	8321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfLUACszugbzX2zWDuxogFSBxhAuyGY4CuCs7Td7TPFZeim2KX
51529	payment	2132	2132	1874	1	1	2413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkEygvoNrRT7bZcM6e34dax1Duvsq12E3L68ZV6RMf7wxhhhw
51530	payment	2134	2134	1874	1	1	9171	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqvTaB9C51gthUAEyybJFqQ7RsHTWBgRQvDDWk6bCc7suGnfA
51531	payment	2134	2134	1874	1	1	9172	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYredEmJsKAJzfuWDL7dNYG88DtNim6CPCJPLLW8asYFf2a8CBP
51532	payment	2133	2133	1874	1	1	8322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiUUgv4D1cPizWbA1t787qKQyGdaSVL3HS5xeAFCyUtR5ZQYm
51533	payment	2134	2134	1874	1	1	9173	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HyP8DDynKfQz853oooUYdbYoGpmxyTJcdNp7XqX72pgswY9F
51411	payment	2134	2134	1874	1	1	9118	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44SVFz57EeiRmYh3TduHRmECjNvcCPWMMqibUMJN7fbNXPMDF
51412	payment	2132	2132	1874	1	1	2393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9WV8mkcsfZ1TDyB972mvT6KJzQoyM352esXKF6QfT4REn3Wd
51413	payment	2132	2132	1874	1	1	2394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoCz5oY4ip9pM8VXWRjAvcUr56bH1wzAbTrsHHfimhvEFuCSn
51414	payment	2132	2132	1874	1	1	2395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JUTXBGqjF3QsXpaWrVdpbgCjywE3GDNKHe2yxY6i33SQN7vk
51463	payment	1397	1397	1678	1	1	18290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1nfdSo9wNbCGofg6TsSUZoCo4QL9gfB7C4dwzUkAmHtxpTpQ
51464	payment	2132	2132	1874	1	1	2403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsHFAJ6GNtPJRJyYPZRM7TvgXtRRVMjcSR96unvx1wdngRBJ6
51465	payment	2133	2133	1874	1	1	8304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsjMTf3aGqMc2c1J1td32N58rP24zvMK3xLWaKokWbxK6o11X
51466	payment	2133	2133	1874	1	1	8305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsi5NWvzbBs7x8wFwZ6w11EjtfxsdTWZFsQBtMQ9btemQmpAzu
51467	payment	2134	2134	1874	1	1	9141	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXf8py4aPAz8gbacRKHgwqwqu8cANZSBvEgGh84J1RSXjjYPLs
51468	payment	2134	2134	1874	1	1	9142	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCznUT5dqzEE43cX8XxTXgRETnqVpcBgxA1DgWM3AdDcoMxMZ
51469	payment	2134	2134	1874	1	1	9143	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyWLLsBTjje7LBwnDyWBTp3t5v6nA8knUPSuWKv7eoFFaTY4Z
51470	payment	2132	2132	1874	1	1	2404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAtqv3ZyngiaHiDJq2a9oTkcaGYWUNdzAqYReGqJAZFoLdpGP
51471	payment	2132	2132	1874	1	1	2405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkjNawHqeukoKMU5Kbaysc1jkQaVS2rToykm4uycG5HXfQXjo
51472	payment	2133	2133	1874	1	1	8306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHU4DJL1q8tx2YQXpmNV52x8awgcs1xpByKBGmW8yxd6pxQcrX
51473	payment	2133	2133	1874	1	1	8307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9jGsuwnqxUPRzFPWbAKg7hMGtfP97SAnqaAqqgTw68qpyzEF
51474	payment	2133	2133	1874	1	1	8308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDa3CF32RAuuaThN6HHhhPZDwxsFeKRNGhzmtM6eZhwQkj4ze
51475	payment	2133	2133	1874	1	1	8309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEvCq4FTzokMnXYciyc4RqG7JnQuYBvwREuviw3bqvr7qLWXh
51476	payment	2134	2134	1874	1	1	9144	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYyS5wpoyzCGPLZM7jdfzjGb6y6ZEd8cJRZkRsyqzUSpBYmwB
51477	payment	2134	2134	1874	1	1	9145	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqumcWebVHWdokQrtczVjrMKYxkiMQ1m5gzHMEzaWB2PhYPnwW
51478	payment	2134	2134	1874	1	1	9146	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEF2iu6dXBFJMFPjyhov3NEsFDJCJeu8nHxtS84HjNfRzPKon
51479	payment	2134	2134	1874	1	1	9147	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjB7yX3Fpdss6xuAqG9xHB2BwJRwWAUCrewfzJPDewpDYvTeSL
51480	payment	2134	2134	1874	1	1	9148	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVTT8kP4J9VRDyB6TYS6HUcb11cSWFGx99VxyssgfRzFBgnPY
51481	payment	2134	2134	1874	1	1	9149	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RqkUvpvK4ypKCZCamZ7NcSENWzHihH8XKRioUhvi3nUu93gw
51500	payment	2134	2134	1874	1	1	9158	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSqufBmxiCz4MtWXEGtH6ftcABfZ24QaZw5GZL84jTSH9iYmC
51501	payment	1397	1397	1678	1	1	18293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitemgd2sykzQc3hwQuWTQ2yTuWuTVQi56VPwHaudzc2LMqJG3
51502	payment	2132	2132	1874	1	1	2409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2pMexu9qNmu5SJGmQWaXC99p2FrRU1indkrJjogTHKckyKnP
51503	payment	2134	2134	1874	1	1	9159	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL5qQvXNEBuXQb4yzoZc4V5xSP7kHD7sdyJVor339wNpYemrg
51504	payment	2134	2134	1874	1	1	9160	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetzXQ8dJ9fYzZz6Ta9h85zXhZL6bxb4DVXYQc2v8TTGVTYTSd
51505	payment	2134	2134	1874	1	1	9161	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVTYBUfRfxBaLLMuMFWYcbH5MS5f3bAGLp7VHTiva2HqHhAVU
51506	payment	2133	2133	1874	1	1	8315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4byJSsroQQDqS77RYSRWTEr6VG8JPC5mEKQwjEPQ7VLnEvoH
51507	payment	2133	2133	1874	1	1	8316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1hiJJsSgTPCVaitx3YTNUzSZBBgFzNrguVCW4bzxpDvimhSG
51554	payment	1397	1397	1678	1	1	18299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8Q7KEKTpS6mMdLTRvfz3tA4Jv6PuxWrJc9a27hNeVTaQjRnK
51555	payment	2133	2133	1874	1	1	8328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx86rK8mzwMAjpwypjFmV2d4JohYtLoFF2Rp2zxyHcUgDENie
51556	payment	2134	2134	1874	1	1	9184	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNcQjw98FA6FDFHyMyHpHwJAjVZwUXUBDyNSLzwHAdyQfVgP8
51557	payment	2134	2134	1874	1	1	9185	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1mNAfSE3jAvzKmx8Yv6aQM5yNCWtN3pLiHQbS2Umm3MsBAUJ
51558	payment	2134	2134	1874	1	1	9186	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehhLiQfhyq6a2GXdv8txA8f9kRdR93uneo58XSYmRkDzWqh3X
51559	payment	2134	2134	1874	1	1	9187	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbt8MAp8PDRj4u2idjjujZSrVigHnmhN9LnuP9nNurDyPemHfX
51560	payment	2134	2134	1874	1	1	9188	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qq8bK662kvbk4ixc1ZGZFqtLUEGxhEsBe4nJCvXgfVt7EJGB
51455	payment	2133	2133	1874	1	1	8302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfcWYhNcMTPypSTmbiuph77g2J7j1hkxyay1tZ68ejD6uD4DY
51456	payment	2133	2133	1874	1	1	8303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bwRuuntRrDKuvJLyJ4cVKgqeZFeXpDnFVeyZ89jAW5927Vyg
51457	payment	2132	2132	1874	1	1	2401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76vqf47TMWYYeQsk7BmKw8GiHqFrLtxi61HLXyNQSrwpjDDFD
51458	payment	2132	2132	1874	1	1	2402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNtQ34KypLWHCY2mXzeGjZE94XZbuQdfZDaTivsX8s9tuuvGp
51459	payment	2134	2134	1874	1	1	9137	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qYG7G9wwpRUKJxUDeRhok1pMiBfEV3TqkNaSF8HjGfFnJ2Yw
51460	payment	2134	2134	1874	1	1	9138	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKimaZaYdL397Jbrw4EusNziFajdXV2yVLPQAG1rXLQnAcTM3
51461	payment	2134	2134	1874	1	1	9139	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4m5RJR8TrNmfFQu6F1kKm7MpRdytwYgCM6hTQFdG4GkphZV95
51462	payment	2134	2134	1874	1	1	9140	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTV69oDh7mwbG73EmnrHwQkcN3p9ZfsGRSp2HRKtdhcSNzBEz
51490	payment	1397	1397	1678	1	1	18292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2bdB5tDsDQAygA5KQaemdc1SezUHaQBirkfw6TqcYuTXPrmA
51491	payment	2133	2133	1874	1	1	8312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ysxD2T3Hu5xtmwmNGQNgSXyKNXrhTnr8RSDDTNQ1poQVfzaQ
51492	payment	2133	2133	1874	1	1	8313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HDm1do6yarGokazzgZLbmsohmPu87Hjr7f8dNyQxbcX9kEYj
51493	payment	2133	2133	1874	1	1	8314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEPbEanjXvvftz8ZQDZY5xhEqvHRFYagyTtXibtsyQQYmFWHt
51494	payment	2132	2132	1874	1	1	2407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcANdaKSEj6twFWyt6J1TUmv9FG4Kveqy5SGBrGKiEDPTo4s2T
51495	payment	2132	2132	1874	1	1	2408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisEM8AfB5BtbdVgrrF4sK3bnu91WGb4ezn2fECBPyUEU5kpJD
51508	payment	1397	1397	1678	1	1	18294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk1VtqwvUFW56KJubHgn1ZR5UWUtBn4NnFMbGHjMK9i62hs2f
51509	payment	2134	2134	1874	1	1	9162	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmoZkUBW6yFoScveBYKDx5Ahya3yqJJY5DMkGQA7EkpcynKMW9
51510	payment	2134	2134	1874	1	1	9163	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6sUwPVUA5MA1Si64YrBg1fHA7hoR4Z74cWToc8Gi3KVxL3Xg
51511	payment	2133	2133	1874	1	1	8317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Nv1FnNQueodB3EEMkwAmo4dsprRbuTBy7MV17fk1wTUK5FAB
51512	payment	2133	2133	1874	1	1	8318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHBphE8KSv1a1G28yhS8AFpsWt3KPWF7m5gb3eFZcsAnCn3WZ
51513	payment	2134	2134	1874	1	1	9164	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRsLirRRShTLSpqhQ141yPbUhim3VQLBX2u5Mwy5aUi5iTnrZ
51514	payment	2134	2134	1874	1	1	9165	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCcFHSJW7Hf5HfGZ3eCoCUrM82aQoCnKjaJ6isEU4thKRsfQD
51515	payment	2134	2134	1874	1	1	9166	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDKZKav1W6dtGzguRhkAwvM2zt4ndtRWcfRFErHcY4AMPuvbs
51516	payment	2132	2132	1874	1	1	2410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpRnjdhPBuVW9et14VScAFUYEJrfaC5Pgckk5VK61m2tZ3YcQ
51517	payment	2132	2132	1874	1	1	2411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLesKUfhfqwa8h6M7943d5KoT8NezYo64A9q91uK7vu7A1dbMy
51518	payment	1397	1397	1678	1	1	18295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEKSRJZ4A53qYafUtcisVzQCzNgEDrTNh1RfF3HbaeeSmY7Nx
51519	payment	2133	2133	1874	1	1	8319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwNVNfuHHwFKrZfDdiBq89ATy3JA3gaL68XjBKwiX648Sw6zN
51520	payment	664	664	2440	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTcNRTCgHdojaZLGeLj4n96fj5oQCvrSyC5RssWbhiuQMGJis
51521	payment	2133	2133	1874	1	1	8320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDpGm4WNKkTM1vYHjXTSTLXT7fZkVSaSnmHborYL2iX7FM5VY
51522	payment	2132	2132	1874	1	1	2412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnizYPFkU47oM5FrpbR56FyCwkq8hAENuNhzMxVaE4m1RmnfpJ
51523	payment	2134	2134	1874	1	1	9167	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfYDnLUFHgKBo9uoCBCgC6M9JLJsuiMgJ9BtLxDLK7quxEEVt
51524	payment	2134	2134	1874	1	1	9168	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WaygsYWfX9NnaExHuiuhHsnAJt2WbyDz8LSsbsd7oxywGJHq
51525	payment	2134	2134	1874	1	1	9169	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBmQPxduRi6xSzxPRb7EgBgtJfFSjfKb2byDhANeon5a3RsBF
51526	payment	2134	2134	1874	1	1	9170	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVK2tarSDanMDE1Yu7LidfwjpusSyPS67NKTtBAPZqbQAfPJr8
51698	payment	1397	1397	1678	1	1	18314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z34uBYzm5S4ZBpPGNtKbpsq4z2icd7Ke79QPSgN75ZzJUJ1h
51699	payment	2133	2133	1874	1	1	8367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS79cGJ4ZYPmwSUoLCpmmSpCFeCG1b5tGvULooaq2YVTwhvnjC
51700	payment	2134	2134	1874	1	1	9250	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97LWuCdsgKUxzMbcBzC3uwnfp7YxKQH9aPmYcEaEwTK8unJ9B
51701	payment	2133	2133	1874	1	1	8368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLv2CdcYhZUxfFd7g6F6zqfeYBdiWUqbFUHJCD6PydK3EL2p4t
51702	payment	2132	2132	1874	1	1	2439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GP5ne3nBYU6aqQ4KqyMJXkRbpkHbcrLdCiTrYKcnxjxXsePk
51534	payment	2134	2134	1874	1	1	9174	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtDhsC4LpFJhLy6QYYZ6JBxCf8kHE5tYTTFKAdhJhWWqocDga
51535	payment	2134	2134	1874	1	1	9175	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHcZZV8zQCsnnB2VAtdE8WPHBD5Ukjpu17ztjBrsPsov9eK7C
51536	payment	1397	1397	1678	1	1	18297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbiWMyAeCmkmXQuks48FLUsgs83QhfFkEQa9znHDvKqy71GbF
51537	payment	2133	2133	1874	1	1	8323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFsqPFmetAd1ZDPwQBsWgYgMMdTddW7g9HHmNfguKBepsAhpE
51538	payment	2134	2134	1874	1	1	9176	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yxg2nnJzwkR6rJV3X2raAT1V2ChfVUQCcFwwpLcVgb6C85EM
51539	payment	2133	2133	1874	1	1	8324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZtoU7W9pfmeKahPBvoMDqAEsyYmw7imG3YK733c4SQWA5Eg8z
51540	payment	2133	2133	1874	1	1	8325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7zw3s4zLKnXguorbZNARLcfNEDTepLuVoMF1Egq9tJrphvG6
51541	payment	2132	2132	1874	1	1	2414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfsC7BNKLEHzDzX4TZH9T8JtMwEkQHmGz1F37DTArehVPAFHH
51542	payment	2132	2132	1874	1	1	2415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5WA1FiMuFCiMKgnHRqd411bUctnHNtHcBkkWuXjervHxbYmY
51543	payment	2134	2134	1874	1	1	9177	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZnEUapQnR9zbFhecZU6WsZLJ9dm3dE8a6WKLFr7xHz6LZBSt
51544	payment	2134	2134	1874	1	1	9178	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHVUGcwe7NQyskvkb1ZnRKj58QALu7XstSiM1nkdphta6mCC3
51545	payment	2134	2134	1874	1	1	9179	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTiRa7uqb4sh587HxsfLXpKput9rSg4AXseszXyovTLZWjCTz
51546	payment	1397	1397	1678	1	1	18298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynY1y4SQ15cxtS26FiyrPLwQ6q5Hdp9K5C6NByfDUHwaxu2Sm
51547	payment	2133	2133	1874	1	1	8326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLxnsMbuQyEMavXm8natgQ6gnCzBCfmLCmn7uRpxHDZxLR9Br
51548	payment	2133	2133	1874	1	1	8327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYQqLywJPnsZHZc9UFWX7Ru4sgash3SwwUL8h1Z4siqWsFKYU
51549	payment	2134	2134	1874	1	1	9180	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbirV3yjYkRieB8P92BgHkqDUCg44t3wRMhMYiq9ZYYN92JiW
51550	payment	2134	2134	1874	1	1	9181	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifDVKgEXNUvuvKrSj4ySPzjCgEbPbCLaMj7ctWJ1Wp7ZJHbut
51551	payment	2134	2134	1874	1	1	9182	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHD58LgS42wy2kJgzjfygFobp7Rx4g8T6SduY6cnoW7RC44h5W
51552	payment	2134	2134	1874	1	1	9183	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvKE4uJqj2cQTLXNbUvDncRxsWtdhUHZXMNnPBRDKCSJqMiwi
51553	payment	2132	2132	1874	1	1	2416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AZWkgKYiuEyug69zHWgjkSVQ92uEdMCNr7A1VMJjXMBwmzj1
51564	payment	1397	1397	1678	1	1	18300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9gcw8XnEwfer1AW6Gdt2WkBzVcyZErZhGtAztwUaGdcNA6QL
51565	payment	1397	1397	1678	1	1	18301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNchj9Ed4Qod7T3VAsQ9tYJZ1zGNqL6a6UGFg59jgNTQ6EnkT
51566	payment	1397	1397	1678	1	1	18302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9a6owPNHrfhipbEyQPWDbjcvRLaiMnrWFqrpZDNdkszTjZjE
51567	payment	1397	1397	1678	1	1	18303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9V6TSs3DP2siRPhLY2a1QZWRVQ1D3UamY5L3uPpiceBW6j4a
51568	payment	1397	1397	1678	1	1	18304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ztLLAbgTttRvFjBG1vssV7YiUEUtjwFsbRwbCEYDcT89pXfz
51569	payment	2133	2133	1874	1	1	8330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7r1GDzYMieALR2eSvu1LggErdGS1JHB66eT6Q839MVeM7GGW9
51570	payment	2134	2134	1874	1	1	9189	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBJmkEAQjxBRLW17433tkLVr2r5mNQTXYCjCsemgDoPbRdcmu
51571	payment	2134	2134	1874	1	1	9190	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNU8N2RR7wTC1LXF2wDSdt4Ghg3h5RGyc8wsVvJ8MxJBD5JCn
51572	payment	2133	2133	1874	1	1	8331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYwtbJUKDitRFeSbMie53rqmo5tG5Q3WkzWeVBoTUi6w2pRTd
51573	payment	2134	2134	1874	1	1	9191	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ5AgfBnyM5e6P12sEDzkNyBVdksuB3T8qdxXg1pURWbuZriR
51574	payment	2134	2134	1874	1	1	9192	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMx67hYuWx7v2QhAvhBrwuUj8rEqt5PvaMahTvYZArnFx81VH
51575	payment	2134	2134	1874	1	1	9193	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPb3T4co1gKR38C1ufF37Fbv5Lhm1rZufD3sZwpETbrgFtvF46
51576	payment	2134	2134	1874	1	1	9194	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3nBqgTk4B2UsWT5mMhHrWhETvfdE14Q7A3bvyBtVM1a1vhPy
51577	payment	2134	2134	1874	1	1	9195	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NKaTRWWwcfn9ukueso5ntAE7Td7Dp8jUSTWLhLzDfJpzoa3j
51578	payment	2134	2134	1874	1	1	9196	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBJ1aKnMfKCKQ8xh3uDyqk61LAPV4AFTqHprfBMWx1VvkAjNJ
51579	payment	2134	2134	1874	1	1	9197	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKXXghNjYm5eVWrShj9GQDJP4yo7d7fLWnx7MaT5aUBAtoJ1z
51580	payment	2134	2134	1874	1	1	9198	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLJJ5pbJCnoU5yBs9Vf6vZxBugAcgJ36FApGikFZvAMy22f2Y
51581	payment	2134	2134	1874	1	1	9199	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbnbgT6RUo8xKDagVokgq43nmGcnwnWrFcahhnX22wBLNZwxS
51561	payment	2132	2132	1874	1	1	2417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsM18ptvDJWypmDQbWLXdATfaeQ1Eri1R1UDiME1eq3FfeCta
51562	payment	2132	2132	1874	1	1	2418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcWYLdN9b8B6ueCSrcWRmk49f4xCNxzX95Vx8TRJUNaSiyyCS
51563	payment	2133	2133	1874	1	1	8329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ryvATH8dHFs6zZSpvkFBseGeioMou7quNjNU89RwvY9zQJPG
51623	payment	1397	1397	1678	1	1	18306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmPonbyReFrcY2qcRk5NdMpGhZDhujPhTL3VHVNuyZPpTmh3R
51624	payment	2132	2132	1874	1	1	2428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTyw4GZw12T6nG6XeeKLT9AdpWrgcF8fAiuGQb8ZM7ANoichh
51625	payment	2134	2134	1874	1	1	9215	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYZjrireZtwnDx1aq5GeEWRViUPhY3zNUacyWzgMYzGzFFT1y
51626	payment	2134	2134	1874	1	1	9216	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXn6t59Xcnajd6DbwiPTjiNwz6ezThGsYisWs8k1MhqCErJWF
51627	payment	2134	2134	1874	1	1	9217	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShXvFHr4rj4fDwAEMEPwy6g3hBg3Uc6P7uxFwmrvpXkFLF4e6
51628	payment	2134	2134	1874	1	1	9218	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWhCx4kLKMbtF6qfxzVH1nwp8akf3gfyEDjASHbD1uD2Lw3ns
51629	payment	2133	2133	1874	1	1	8346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLi8bxSnD8jUpssvaAo7j2vWwayHHtmYNvWZc4SKU8Xuk8D4q2
51630	payment	2133	2133	1874	1	1	8347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUp4EjqNj2fwgLwXnea6eNEGH1SgW87WJ7ojCEadLMBAbC5Cn
51639	payment	1397	1397	1678	1	1	18308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEgLe3anEpTGLhNdbeLBsYHXQWcCRwMWVTFvrmoF2jTHfE3rw
51640	payment	2133	2133	1874	1	1	8350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde61RYzdPutjoo72MmgnSmAmaBmkRLCpaoagk9mWZdizuq5eT
51641	payment	2134	2134	1874	1	1	9223	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfJSWtpd2ne32wJqXSoXeJ9oq6q2ttWbkodaTaJT4Wt8HWaHr
51642	payment	2134	2134	1874	1	1	9224	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYan9PMVPzEXu9Lu6KnmnpUbxzFhAEAjQyM9PKb8BQ4gmRmTfaB
51643	payment	2132	2132	1874	1	1	2430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMG9c9Ho3xhMjLBbdMdrLJJs7AYPUyhWjQix6wt1Z4pxRDh7FK
51644	payment	2132	2132	1874	1	1	2431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8v3W3Xt7vNZz6o9729qR6vWyLsS5Wxo7E6r2iY4wenMdAgCUq
51645	payment	2134	2134	1874	1	1	9225	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiVP1fdrV5HjmQHtFfrJPfZnSAxtHzcvuhfG9fzAxunRheRcj
51646	payment	2134	2134	1874	1	1	9226	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AswNoz2i69886sPtNe1PY5QmaBLK4cN8svH2TnZ9wbpMWqtv
51647	payment	2134	2134	1874	1	1	9227	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RDwFG8TMH1H8JME7gGd5uiMRycLFZE2yCUzwF5j3Uiwf8yMZ
51648	payment	2133	2133	1874	1	1	8351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpxS3bkg4YeZwaCFKUSW9YnKB8bdpJo4p9a5SQscPosqqX77B
51649	payment	2133	2133	1874	1	1	8352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmYZ4bg1CYPYGnrn9jj8BTBbH1nm2PTxMEqbruABAViAaPKsM
51706	payment	1397	1397	1678	1	1	18315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3QVfsCitdEztaKYF8WTi85fyjFhreEY7wBD1cA1s2E437mCh
51707	payment	2134	2134	1874	1	1	9254	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYuGqJV7jtxuQphhRmkQyyZdmpvfw7nPfN8Qn8fUwAubx2urp
51708	payment	2133	2133	1874	1	1	8369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcSQCCJq3rtF77JLmrVkTqWX9nZ3WwNsPutMTUz6rxkDHs2GN
51709	payment	2133	2133	1874	1	1	8370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmYh8vbCfd98pAtqaEfrFMEyjeUJu2cV8L1CYgpM1yGRyT5bo
51710	payment	2134	2134	1874	1	1	9255	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFbeBP6dB6BnrEutThzUvV6f3arC5eJPc3RrhceJtN2y9pNqP
51711	payment	2134	2134	1874	1	1	9256	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd6sFNLocFRcy8Wh58gBur1zRH9qgm4i8TWHbYZaVcupjkYB2
51712	payment	2134	2134	1874	1	1	9257	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa4iBFVKRq7SAvNNgQc8WEqGfhcUkGLAexT3G2M5SpB9kiWoY
51713	payment	2132	2132	1874	1	1	2440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqg8pAkGbDtjEvG4vhTTUmsXiqGvbzbVQAN6YVhjWKw5yzABSj
51714	payment	2132	2132	1874	1	1	2441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XRUv1ZdnEJPfWZna5WT3wDsLfZ437oofEJkcLoxbvsz3kzN1
51715	payment	1397	1397	1678	1	1	18316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXmCynn1yJdn6i3YnfCHbQDRUF6sRSHdbWv4wkjYbgq7YmzRq
51716	payment	2133	2133	1874	1	1	8371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnXPVAm54yfv29z4nghPC4UEPwTZj1T9vecJMfWpB8NvHxsKB
51717	payment	2133	2133	1874	1	1	8372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHs9WUgBZCoSDc98d8DESMKBV2XGbZv5b1b4ehd3krT31MpNQ
51718	payment	2132	2132	1874	1	1	2442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QQsBU76C6BZAQL613NnfRHjHhf9i8H1q67m5Qkmofe5gcfss
51719	payment	180	180	2441	1	1	1	1000000000	1000000	\N	E4YRZZFjJmEArwEqcpGVqPy2EHFP1JEfVT536cqEAMd3xBzvR1BtS	CkpZDHTumthckTdg5Cb6qfwmU5x7eNY9gmqrDsM3ApQBT9sWwdtmd
51720	payment	2134	2134	1874	1	1	9258	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4efevKicKikB8tXeWDzWsYuJmoPnRzXW1KrAdoa8jeoGQGrkS
51721	payment	2134	2134	1874	1	1	9259	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGLUM265iMJAboHLW1SL78Qh14NCvGdM2goXKkekWYH4oCG5N
51582	payment	2134	2134	1874	1	1	9200	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxjgKJ2ThrX1WeBUkeVWrP6D9wP2nnMSUKNtBAbcpN37WDknm
51583	payment	2133	2133	1874	1	1	8332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm1HzRgoV7qaVbH7db7hGGcH5ZJ7z29fhBnfUHpQ5Ra1K19Jz
51584	payment	2133	2133	1874	1	1	8333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm4nqoR3LU3Jg3R4ZT4nydX5YoVk6DieKN2yF32V7bgbg9L3Y
51585	payment	2133	2133	1874	1	1	8334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3Wo3D7wx9P3n7zSMgXbjHmzucmvm9ws8gRAME1uB7QtHDm9P
51586	payment	2133	2133	1874	1	1	8335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQp36Qw7SFqukedF2zwNkADzCY7NpGA9jj3uLFeLXNUceamwfr
51587	payment	2133	2133	1874	1	1	8336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMo4e7bvzjyZfXtKdaS1TV2drRAq1XZEaB1YrN9pSzL6xVseNe
51588	payment	2133	2133	1874	1	1	8337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeT7fnJAMHRNneofieoC4rQ3vpDYHJM7gCYdm2c73ZySPtzBor
51589	payment	2133	2133	1874	1	1	8338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YeZwdkWrptmw1cZHzi5mZDYDMgMdQFLsvxnMMdAQm6LPXqX6
51590	payment	2133	2133	1874	1	1	8339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGcmLqt936NscctzanSdNtuzhu3Mcp7mMryViJPsm4cqVWHF3
51591	payment	2132	2132	1874	1	1	2419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GmhSYysG6dguNbr8FXEPZpXGjwJ7zY1EKEJZdahw5dQt57zA
51592	payment	2132	2132	1874	1	1	2420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirskejfyymc7FHUcmsrAXdQXHmeCxhuemyyh5L5nsnNkdy7XS
51593	payment	2132	2132	1874	1	1	2421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavjpx48J8sJukKZ2jzDHrgvu5nyzrK5apoFdqdBn2WXbQBMPj
51594	payment	2133	2133	1874	1	1	8340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89NLdpR5rPn4kfQXxuBJS3MRzVM2Ap3dmJbFMQNKsesdCkhxs
51595	payment	2133	2133	1874	1	1	8341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8LTyXgZR4MCVtL3qygNmBJVkc67YwNzepyyNC1Bei9gA2dmh1
51596	payment	2133	2133	1874	1	1	8342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsDvRsyMyvL2ZGm9XRGkpKkqYxpgCfJyZ8cpx15bSuBeMn5yZ
51597	payment	2133	2133	1874	1	1	8343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3GPYQWMjghe2ZrooEyQ4QJfV9MsxsiXR6ruvvu4LVGgEfTNu
51598	payment	664	664	2440	1	1	2	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YuxuVi7DM8EEnPHwprVkZQhnQY6w2QUd4G9BVWeDsQT5rsfw
51599	payment	2134	2134	1874	1	1	9201	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4fMBxZhHfLw9Pu3dwGnaKqmmtqeBnG6YjmMY12ZCUsJQS214
51600	payment	2134	2134	1874	1	1	9202	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtd1weGkJPDCV8ULbZavFJhGPHiHyjGUjBsdsigmGLfZwUmPn
51601	payment	2134	2134	1874	1	1	9203	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRYoH5sjFuVaPggdSVh7EeJDpx5aNpiMNGHPnCs3AAZt3qNWy
51602	payment	2134	2134	1874	1	1	9204	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNYVwRLQywGCMbRdSvLwCaBwQkVf6Exad5o5W6u2rzTbRBoTP
51603	payment	2134	2134	1874	1	1	9205	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKLCtZcLndvTpNvyyuM6o2qMBS7ExUkEYD8CispHnqEgb8me5
51604	payment	2134	2134	1874	1	1	9206	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6VRG7AfJ8H2m54UoB2qt2TG7ZiDKcKrHsd86RxkkAhqfSQxK
51605	payment	2134	2134	1874	1	1	9207	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W5euyAdfiaBJ5mk3bwxxRuKSMFzxX6nT6YnxT38FvB1yqWMm
51606	payment	2134	2134	1874	1	1	9208	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcNXstu7QMeYeHkXLTh8z5hysyRVkVZmYGZUusvdCfaBBJD9u
51607	payment	2134	2134	1874	1	1	9209	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzzoWX8tMbzTMyU9QGfK9xAxnMmQzZw4h2nmp3sTcv87SGULc
51608	payment	2134	2134	1874	1	1	9210	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQZkPpNih8A59D9mp69pFLssW1v35xhnP5gccvpD4GaBLW1MN
51609	payment	2132	2132	1874	1	1	2422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvZAJjyRNDTbbHBTCbyBUompdYHkMMyEUdQFLZqHryj9msqzJ
51610	payment	2132	2132	1874	1	1	2423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TUPrN5F7uFL2CVjrMjxfhn1q7KjuFEMAnPSEuA7zTomCD6oE
51611	payment	2132	2132	1874	1	1	2424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZ28NAgZuUhpbD5dMry9erN44vL3u24qsos1KT5X9Y7Wsdcqa
51612	payment	2132	2132	1874	1	1	2425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNdRxJJeCc8v58NKs4GcAe31Fx3B3bTY6zYR5kcsyeVP2vFs6
51613	payment	664	664	2440	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyW9LXQqmvZVNHqsbvdGXsttfARJtcvD6D9xVkvAjjs9nnMvjy
51614	payment	1397	1397	1678	1	1	18305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9juNs3YJEfoNUJvoMznQwj5m3oYWSjKLSaACTj47vPzBBe6mM
51615	payment	2132	2132	1874	1	1	2426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDyoUcm5ptaxsCT2Nece6VzS61Xi78cPq9KgaF2HGvwwGf1wg
51616	payment	2134	2134	1874	1	1	9211	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyt63dqL7fXvocFz3ivwA1UxMBgT6kjkavSz2d5NQp7gSGXjS
51617	payment	2132	2132	1874	1	1	2427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2o9eTQYWQ4BY1Ect8EJfUirC8QNfvG91G8txCYjag6MDUHbnP
51618	payment	2133	2133	1874	1	1	8344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcCFsz8BhViNAnaGofHqRCULrupk2b7fzRkHbbFTh8hDuU4K5
51619	payment	2133	2133	1874	1	1	8345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHTZBGr3i7zVSM2UxzwkQMYYp1EeDvrzhZfDyyTHXubWnYrVB
51620	payment	2134	2134	1874	1	1	9212	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAM8cBHQKuXHWCBMmcHn4JeT4VExSAPiS9Ub1EvAqUaMVuc6Jt
51621	payment	2134	2134	1874	1	1	9213	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefSPXGi8iYuB7qJfbcyC1WK7V2DeBZuEWS4Hoj6sm3g6qw3Dm
51622	payment	2134	2134	1874	1	1	9214	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfj9Xm9iNUgJS5m51rp3nyhT5LmEp3sTaQyfvY4HfX5sezZii
51650	payment	1397	1397	1678	1	1	18309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEDfS8DqhjqiSSFP3zGa3AZYdkGTaNZpYtDghoRffFDMKV62Z
51651	payment	1397	1397	1678	1	1	18310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVufkUUmTzyo7gEi1SN9mpmzzHrJWAmdRVWpRsVhz5uYderS6
51652	payment	1397	1397	1678	1	1	18311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScKgpsXRV91LcecbDMmbypQbN4BLHxWL8jg1Uh5tgBVifnj9y
51653	payment	1397	1397	1678	1	1	18312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J8EKCdFjQazFtf1drRk9a4YAPZ7cJxGzuhLT1AhC2p9gSxeV
51654	payment	2133	2133	1874	1	1	8353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVyPFLgpX9B2c5MHLUMjcCnAYNMhdBZ1CgknyhCv37NTSzizQ
51655	payment	2134	2134	1874	1	1	9228	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3ufSHGdnztQGmGpwtRSGBN6nHSngY4gRPfZEcdsFGuQAWC6n
51656	payment	2132	2132	1874	1	1	2432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyVhk9tjp6TqKtGVnKnqFVvFzWpnig2aETgVm7EftFGT6PM7P
51657	payment	2132	2132	1874	1	1	2433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPiLSAvqdNg2DYHMc5GPqeT12Vswc7MjS6CKR12p6x9NsC9qQ
51658	payment	2132	2132	1874	1	1	2434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiDe8KxDScxHF1V3RnruoYRqdDcywmiHo2YRUTsuMxsYCUVhH
51659	payment	2132	2132	1874	1	1	2435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NUejtfH1sHZQgGLCwMVaUTUY3KrsvQRaeVMzjN8QKHtrSY7E
51660	payment	2132	2132	1874	1	1	2436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37zd6tgmD4dJ9Yo1iegxMYEFYczjksvA5bwSpixM7mz5fo5Fy
51661	payment	2133	2133	1874	1	1	8354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfJRUA7xEbmAbL8mEkeh9YRUuMv5Mey4U9YXErSuC9kPGbXMf
51662	payment	2133	2133	1874	1	1	8355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuD99fDnoBiPSqgX7NLsbHQMWXyupufRvSMGshUtmE36broE8
51663	payment	2133	2133	1874	1	1	8356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdirX5dSYTfCmzmA66FHDi356WAvoYKuCgypj2Gt1Yzrr77yKF
51664	payment	2133	2133	1874	1	1	8357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8XLq7wdYyHQrinJQuV1st8wqextNPDrmReMEE3TnsNV6k4EV
51665	payment	2133	2133	1874	1	1	8358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13YQcxEwiuhVcMDpxCsM76b1VzFaiGpSzbHG2QiRKvepeLvcM
51666	payment	2133	2133	1874	1	1	8359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRybuMsy3uLsAZRswuQtiYsbMuAS7STNGK1zsE9ktALSh4pqT
51667	payment	2133	2133	1874	1	1	8360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jzuqSFZK8H6kGydKiehDj1dCBW2uxmh7WrTbrM5MZf5kB8zp
51668	payment	2133	2133	1874	1	1	8361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBTdhApQF7G1ZQ3Lr598TU61eHY5BpfxkKmMt5FzVcp1x1tiF
51669	payment	2133	2133	1874	1	1	8362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcTBcMeS655GnHanKi5HK3jyDeGhxSpFzacCU4Wfsdd7YBk77
51670	payment	2133	2133	1874	1	1	8363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMRxR7tZNt5s6U6mAi1K31pELVwGyM6WB29ZZARZGeYFizU3Q
51671	payment	2133	2133	1874	1	1	8364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWg8RUxpSBQF3irzJX53Y3FviGmx1qDBiKXYET3hgKhVbmPDVi
51672	payment	2134	2134	1874	1	1	9229	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpsJMkMR1S7XzKbuGkgX5uWKfi2HwqiqdnT9M5MCHquZcPhoi
51673	payment	2134	2134	1874	1	1	9230	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVyL2AdxsSFxHgkzi477nwD7gi5gc9s3QEayZJAcnMnR23TVv
51674	payment	2134	2134	1874	1	1	9231	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzz8sPMxPSbSuWBuN5UHyQv7LGafhVgZ986EHe8h1hBQEPgia
51675	payment	2134	2134	1874	1	1	9232	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJ954CbirvrYSZ5Nghsha6XcFBHSshcnNsknrQqiq7d95k2bc
51676	payment	2134	2134	1874	1	1	9233	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtwy7dYJ1mV8JT2PHC7WAgrCDqdroantoYXsSF4Z3CyPLpLGX
51677	payment	2134	2134	1874	1	1	9234	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJRzDr5fXhFhaA2Hx8trpGo3mHCoZpq5H7rDBKRzaGF57EYD7
51678	payment	2134	2134	1874	1	1	9235	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxbMJ64uGoGABcxGAmdopMgxCnRWrsQczCUSJdm921snAun8x
51679	payment	2134	2134	1874	1	1	9236	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqi7JeXUjP49KhHrX9mTMN4fhNjY7WF9krF3ArBUrMzNjHp7EM
51680	payment	2134	2134	1874	1	1	9237	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZSLqFmNQEYq7MSVRg2EBZrwMSK2ydTy7NmAZgLP1oJYGvB3K
51681	payment	2134	2134	1874	1	1	9238	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcq2hZ9NWzM9ZP3GdxuTEDfbnrb3zxqod5eSjo5MKiem3gmiA
51682	payment	2134	2134	1874	1	1	9239	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXs5npSaXPQvupwTFPp5wPsw4EoAtTXmNrqrEv8DA5R4zatjT
51683	payment	2134	2134	1874	1	1	9240	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAqkKqzBiifsEZmq3Hz4Y8GsYQkfFttK6vt3WcS5FvzbTsVYs
51684	payment	2134	2134	1874	1	1	9241	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tTXGG9wTxR17gxViz6PvXzMESNCQ3JRm4fUnUmRwMJGbVpiv
51685	payment	2134	2134	1874	1	1	9242	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ493RN3UFhg5wCExPTYpQ2qWCaSf4JpmTPaNAruSLdnp2czznT
51686	payment	2134	2134	1874	1	1	9243	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRTUprL9FSuGGRVqAaSTtdcdFrX8yySDPYD32XGqiXQHsvA8b
51687	payment	2134	2134	1874	1	1	9244	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ca4G7vamJo7QdQyRSST1RJQNG5LVHyDpRN21UJcti1K1u2LE
51688	payment	2134	2134	1874	1	1	9245	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1iTpQsXytqmBGC6ttFFLqjWsunmJQy9prJLHWFNktf6jTZLZ
51689	payment	1397	1397	1678	1	1	18313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVed1HeH1gtmuh43JTMjHeZvcMaP1XNNQhjjarrE6sU3KBfW6
51690	payment	2133	2133	1874	1	1	8365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBjSTBrDKoydwsbHd4CjEHfQUT5QsYgDgYWpLgD2hgL943w7K
51691	payment	2132	2132	1874	1	1	2437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Y11C9PbVm2GM6221vjKtnEpQhDKm7qRimqrvBVoV1CoAW9pN
51692	payment	2133	2133	1874	1	1	8366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9utRp5EPgdQJGK6Z1bJTcccdMWrPX2g83nVZSzodQ4EKmTocY
51693	payment	2134	2134	1874	1	1	9246	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGsPNpS3AoTPc2ZGLXwxmUQ679nUKKsumr759S9LD9y9ZwsMb
51694	payment	2134	2134	1874	1	1	9247	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4ZKJQZzs6kBxxokBw7KByMMhJTSTyJy9bevH3SyBeDFNj1pM
51695	payment	2134	2134	1874	1	1	9248	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKeDHxnnuiUGUkwDF9HwycYM9cnsaozrwkyuxKZqVhUGC3eeU
51696	payment	2134	2134	1874	1	1	9249	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5Wsp3gSJ9vhzEQojoQNfek2KzncBKJ26e2SBCkBbF58SmyK5
51697	payment	2132	2132	1874	1	1	2438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKh3p9iSAcEVVZaiPtTRbzS2fKtNuGK777NRDTQbapDFzJNDW
51752	payment	1397	1397	1678	1	1	18320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQnBZW4MCj2PWzDFpkDrXVp9zbGw2rRFaNoWiu25aXoakargg
51753	payment	2132	2132	1874	1	1	2447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoYLf3bLX3D11u1RQNx1UfGnBJLJwoGLE3ABqRbvfDzg732LT
51754	payment	2133	2133	1874	1	1	8380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpx39vUeeeqQi3ZZ14mQ2KVZQ4DB7q9kS5LzGYmHEfGHiVkRvh
51755	payment	2133	2133	1874	1	1	8381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqvDoUSNv2j2aXaJDB1CxfgjZA8QnttMm7bN9PGoWc7FcDmvu
51756	payment	2132	2132	1874	1	1	2448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58apfVNytPYtpxs1j9tCy1EmL5x439TGvakiD6fkNmieD5EWy
51757	payment	2134	2134	1874	1	1	9276	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9j1ASkto8tGnpLehhqWYuD9aqaBMRJrruNKrcenJLpd9F2XRu
51758	payment	2134	2134	1874	1	1	9277	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBKQZDgffQxtUy5do8KTsbzccdn2Z8gg7n8qQqGwc84iNa1KS
51759	payment	2134	2134	1874	1	1	9278	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CigLRkS2z5qZeWwNYK9HNc3WykGPPMAX5SrPF3KMp3gE85Hi
51760	payment	2134	2134	1874	1	1	9279	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrNfakiM2cKntAmfvamsC3QEbeTfSPPkkxnLte834PEDo1LjS
51827	payment	2134	2134	1874	1	1	9306	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDk3RgPPJkRypEiZrQt82PybBh6uScfcSL3dsbhEzu6SgeFuB
51828	payment	2134	2134	1874	1	1	9307	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDCXR9ycny1v7SAo9Tja6THmD5AtekeXF2UEBQ7cM2cKCdYEK
51829	payment	2134	2134	1874	1	1	9308	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLkNRQ5hTYDi1kQzgMyVezSo5JE7dzzAdbfCeuRdEqfPEFJQ5
51830	payment	2134	2134	1874	1	1	9309	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfDY9wBh6NpLSmrcKQUW4KLKZWs5n2F7tZRtnJk5BLVRJU2qZ
51922	payment	1397	1397	1678	1	1	18333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu9BGGbPxp6LxbHA6ts8cM9r5Q6fz284FUrqfkzdqe2TYnXFE
51923	payment	2133	2133	1874	1	1	8420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd65g45CHzsWsRcDZWeyeTntWDRRvtBjEV6vbo7QbhRCvhKMSV
51924	payment	2132	2132	1874	1	1	2473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7aH5AnMQixpKsCEKHjcQJ74EftULdq2ABU5k2oY7HvXPS74k
51925	payment	2133	2133	1874	1	1	8421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEHjNuK1Ek9wTSULyFVcgqQpBYH2T6cmUbSfBgomfD5w8UATD
51926	payment	2134	2134	1874	1	1	9349	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrHE8oK1HShwyyCJbPehKWsxWyLoSM97FnR3E2UZK7u5wccoH8
51927	payment	2134	2134	1874	1	1	9350	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfGpmGVxgiM2weno7FZYmpL2fWgvFWo6wjD3Gfjmas4vwuoBg
51928	payment	2134	2134	1874	1	1	9351	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMK11xZkDFhpANU1gedK54eCHmb7JYfewT4ACTGFhqXLRzk5Xu
51929	payment	2134	2134	1874	1	1	9352	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aUbsPHX3jAMpsLYRmDCqBAXaZRxiZzK55s9KCKGupRRrQCgZ
51977	payment	1397	1397	1678	1	1	18339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB1yE7yqZ39jGBjPauwbUrcQVND3bh1xHqBz5spYQiEsRHCTC
51978	payment	2134	2134	1874	1	1	9375	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9E2hxkZzUTc4nfsNxaPUpjr2suXsZW9FQ6TYdP8A5JHBfCkgx
51979	payment	2134	2134	1874	1	1	9376	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnARA6cdHwRJX4EvhpbKWC9GgQTBVgQNqeK2heUTA5fQ6DUADA
51980	payment	2132	2132	1874	1	1	2481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfG24Kv1HLa7pcWchpVzxf2YNTCFCCse8zkhH8euX6wpg7h7o
51703	payment	2134	2134	1874	1	1	9251	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoDr16U9f9g3k16oXj6RpSeqbdCXSMpcdJdphDA2iNbc99Ypt
51704	payment	2134	2134	1874	1	1	9252	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2ZZPT64yHouc9ki3RN8YjCrx74rMWftSzDfVBQbrwpQVHz6g
51705	payment	2134	2134	1874	1	1	9253	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbtd2pZsgZfUkBcfmaRumPRA3iGXymMF8QYjJXEXBDgCpmQ3R
51761	payment	1397	1397	1678	1	1	18321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpsTmfYw3TzARipBribnWyKz9tJGSpwyCvtepCdvvD5fG3NVF
51762	payment	2134	2134	1874	1	1	9280	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqkBgMBHEhkFtGAVHNtj48bph2xhPBDgiJEHCWtHiVyvdKKMh
51763	payment	2132	2132	1874	1	1	2449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MWX4zRAT13csKRh9Cr1UoybwXNqFKRFW2dwxhu8dBkTh7F2U
51764	payment	2133	2133	1874	1	1	8382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjjvVWGMisoRfGf6rqJmK5PDtoqoiT3DgDh4q3KYMs9t23NEW
51765	payment	2134	2134	1874	1	1	9281	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMGbZniexk4VvQZCvMtiN22sTywZ5weQg3LvPo5P3frSwMEH1
51766	payment	2134	2134	1874	1	1	9282	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqFsVnhb9xYbG79usWhgqzcKvdV7Hj8s35TfDtihB6W1WjwxR
51767	payment	2134	2134	1874	1	1	9283	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRK9kGwALpEfjQPyn4CXPku15tH7GV2QuHWf57t7uxhPi1uQkw
51798	payment	180	180	2441	1	1	2	2010000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsMBWFznTs6ihxufsia18qkf3s1RQMM9uNSJAuR471vivcLRK
51799	payment	180	180	1726	1	1	3	5000000000	25000000	\N	E4YPpzX82oQ6gjyBztx8ZyU7nxPAwMyQX9qR81wK4JphdyU6MkYms	CkpYRZCimRoVVDALiHE6qHqCzn7jnJUPNqUZqmJmbpE15s8qTkMJF
51800	delegation	2439	2439	1540	1	1	0	\N	7000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMcCNvUCdRZ3EmpbyYZHu786zhZjwTfvizY5Xe88tQF7DqqXS
51801	payment	2132	2132	1874	1	1	2455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbnt8Lit2rpax9PTs1xogHD4zoHFZZuFGidH7kebKhrYLBSof
51802	payment	2133	2133	1874	1	1	8391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqc4WVM6S9mnrWtBTmo8LgveCaLimc3wiC86EonjuNxR262aJ
51803	payment	2132	2132	1874	1	1	2456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ijVY1QaGXFshMPAQ4MsfCHrZZu7tXzjWsmS2zEJUHDCu4puD
51804	payment	2132	2132	1874	1	1	2457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtu3iWxpn2voHaHBjJZdZVYdbihdv3xErv6Ei1NfAGGQAXTvP5
51805	payment	2133	2133	1874	1	1	8392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH86LjVeUamURjmbKjS5yAAAAC1bQ6j3RdCCpaTtTf95AcXozP
51806	payment	2133	2133	1874	1	1	8393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGff9f2DNpJThUCKdeRogvWQ87Witm4Cm5JvXW8nQDSntYyUe
51807	payment	512	512	2442	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxuSbDwbeFh3go9vim3WL7uJYtCfUSQcUofVdSETiaoW8GuFG
51808	payment	2134	2134	1874	1	1	9297	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCLwntxcuLY9BCsESb95tEjt2iXpCDSZRs533JPubet4Lrwkm
51809	payment	2134	2134	1874	1	1	9298	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4shBZqowxkPyykmaSiA5a9sv21uCHBpM163R3vWpaoZ9CduRn
51810	payment	2133	2133	1874	1	1	8394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijhdjNiiwxSES1PEtGkfnNgLe29FbCDbhrjQ8dx8hrGMTudcs
51811	payment	1611	1611	975	1	1	18	462317323160	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZmECbwWqPNcCYJu6Fe2TvrejoH9xuHfD7FxT7zUEMPYHAoZEg7
51812	payment	2134	2134	1874	1	1	9299	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJAW3zfqtTx5HdZUNePtkzGy1VLG5x89Uj1UdxgDLo6JfhoAn
51813	payment	2134	2134	1874	1	1	9300	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjm1DWZj7dhDdnWS1oK7m7zjs5zyStK2h4DXZpLWzqstH1FxBd
51814	payment	2134	2134	1874	1	1	9301	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V9PFYhoer2yLzJHkim7Z1F6QsRWNSQFvkr1BquvH7crjxF2y
51815	payment	2134	2134	1874	1	1	9302	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vwhyRiBX3VpZPnQagwpGqEXtuzP1JB8HTQQVWH9F9bHJC74b
51816	payment	2134	2134	1874	1	1	9303	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7HpW4BJtonjFYvakGN5Lsx3h7QNR8DsthV6tsxUgGMA41PCv
51817	payment	2134	2134	1874	1	1	9304	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2qqZsg4g9napeVR4cxEmqdpC15QRj6D1FSwxcrfibPr7RgE3
51818	payment	1611	1611	1095	1	1	19	828468681970	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	Ckpa7PeagMrzQ8uqeZu9pmj4huMhib4haJvFpKKuqpxYsRiZCGKbU
51819	payment	1611	1611	1215	1	1	20	558984328130	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZbSXfUnzCpNcBzhBmNWju48GU2iWjP3URio1oQeFBSwZ9sS21E
51820	payment	1611	1611	1341	1	1	21	1557659532455	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpYnLhviagTGsoXEGx9DqYP7LfjeEYfKgoLid1E2bYFZ5W8iLFwG
51821	payment	2134	2134	1874	1	1	9305	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS5XgRYMFVLFEYowdKSksNiq1Y8m5ie7TAdHHjhSzwzVZkqXk
51831	payment	1397	1397	1678	1	1	18325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2wSAAzea3hB8xSgGxAhe8n2fdH5BcD1LdFPW8wPNa1PeC9Vr
51832	payment	2132	2132	1874	1	1	2459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3j6CiL3XXpzETuQxJCWMsyf9AEDcDFYNkz2WSmGBTQrfZjqB
51833	payment	2133	2133	1874	1	1	8398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jTdGPP2e63Ynpazi9DhcZfyezDfWW2vNsU3KBQDVyzUbJ2D7
51834	payment	2133	2133	1874	1	1	8399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSNYxo34fTTE77vnVjZVGvfKkwDE8apspaknYDubongMYzEzv
51722	payment	2134	2134	1874	1	1	9260	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaXfDkkQ29MW9MbZoioxtDccNRkRoR7EAAbm1biDpHni22K7e
51723	payment	2134	2134	1874	1	1	9261	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiiVKMyHEvcDujHVCf3RgcxWrLXCadjnWfxpQKnMLHRUepS1Q
51724	payment	2134	2134	1874	1	1	9262	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJLdRC2iRtBEePGKs2iagvXSuxmvgtDhYbqk17cML3AWEz4BA
51725	payment	1397	1397	1678	1	1	18317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3YZj6AhNxrAzpa7HbpbAij2QFsQ45u65XuaBgXnodqEkaj2M
51726	payment	1397	1397	1678	1	1	18318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz98dQ4UEgxEZ4ETCn4TvBc1Hqi1g2gfvqy6ctZKqRDAHA9xZS
51727	payment	2133	2133	1874	1	1	8373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYretv9jt798TxdH7r47XVK4iPARcd7RcUckamh6GSJvqc3d44w
51728	payment	2133	2133	1874	1	1	8374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAf7WGHVgKWuLv5E8117psDnQJpQgH5u6uJteQoMHPMgBbthp
51729	payment	2132	2132	1874	1	1	2443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXMDz7ueQDZruU1xqQtDr5m2Gr3Gu5xjtLQr4wD2GrxZKSqLC
51730	payment	2133	2133	1874	1	1	8375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkF4bn4hR35yyd34WbjBn7ovxqmaFBXfm3DuLU6oRVBuVzN6LG
51731	payment	2133	2133	1874	1	1	8376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eFhVWTbxMZxSfLYGUSJNDKEZhmjDVQmFekpzdn7NNHM99uwp
51732	payment	2133	2133	1874	1	1	8377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvJ9c1qErBnfTBtgMjEamLsGAhDgbsPrxuS58gjsnpFAu4nmz
51733	payment	2132	2132	1874	1	1	2444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5JTjdUWTsAdcba6FoJSjd6u6vVucPxPMyScuQ7xNbhcugRNm
51734	payment	2132	2132	1874	1	1	2445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBwoCtoYxq5sqMKBNAV5EZKfRYkobpaJFMt8GFVyK8EUvZEVa
51735	payment	2134	2134	1874	1	1	9263	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpSAhQuaEUgKZkQfJs9oyxzjNgVBp172LzYJdG2jmR1wTWkNV
51736	payment	2134	2134	1874	1	1	9264	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcaNYr4uNgd4EchLmYHwqmUr7eghTiAnsrsK1mt3RKQoH56yS
51737	payment	2134	2134	1874	1	1	9265	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxWnTSKvxpQVLx68m7amneVFKcVP166pG6pRdLUgfB9E8vwcM
51738	payment	2134	2134	1874	1	1	9266	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhkHN3nhM1V8XNmH2kfuHwAyitjZuEhu3DnRq41xcFeoKUKt1
51739	payment	2134	2134	1874	1	1	9267	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzLrKuE1C8v5WbRagY17z9wVkro2B6uB2e7SF2RuARWPZL7xf
51740	payment	2134	2134	1874	1	1	9268	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdusr4NjjP3Vh8hsLNFLbm1JEcQfRGnYHVypoHuQz1gs8LomxV
51741	payment	2134	2134	1874	1	1	9269	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1qnbwm5eMAz4b3Qijh1pRo3X1EJ7aLYsWckMzuyRiJ9dm4bX
51742	payment	2134	2134	1874	1	1	9270	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYVzCoQCGWUqE2spox3WSkgwsRHQP7NJKYhymutK4h38xAfWJ
51743	payment	2134	2134	1874	1	1	9271	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRJSVEfapxJswd8H2B1DMspdeQb6ri8c33uPiyMcmhz2Aq17x
51776	payment	2132	2132	1874	1	1	2450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrLfT3RkqgLTJQXrqL15UCykvb2681cFYJZvMVHDTXX6DKyNi
51777	payment	2134	2134	1874	1	1	9284	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGK91KFyfZ9eYaXFCQNQoZwXWu2EvKr8kuemDxQxt53FeLzF1
51778	payment	2134	2134	1874	1	1	9285	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyafBhzuBsZhxHnLeTsMUMVQHHVCYkWnUtARhX9je3UQqGEDJ
51779	payment	2132	2132	1874	1	1	2451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ82A8cVWtxUa5pKZbLfqKQ1mwQZr3VNz1SQD19Q46y9c3JSb
51780	payment	2132	2132	1874	1	1	2452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMFQkXwhLfopTiajsEuwneC8JApUNtZcPVKBhPr7VJHg2i3mL
51781	payment	2134	2134	1874	1	1	9286	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFcQYzW7kB5P7gAwRmqsLCixYMUZycJGXhVx7n8CSJzW8RKwU
51782	payment	2134	2134	1874	1	1	9287	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nfcNyTBSfUMc1XkG6kEKSRbCJPzCkUJWhMftMQS1gmrkWsnN
51783	payment	2134	2134	1874	1	1	9288	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkBU6dhTU5XqdpWXmWUrGKjsr7BiDut268SZjdigGpmMDkcr4
51784	payment	2134	2134	1874	1	1	9289	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkG5oy3T6c22HJP9NpyzWK5w6X2qAnEDzXotJJcjSjYYrhJD9
51785	payment	2134	2134	1874	1	1	9290	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiw62bRSnQUXQGkQH8qD86iHq4v2zvndRgZth2feLAucz31vi
51786	payment	2134	2134	1874	1	1	9291	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqUjEjbquvdco9PRuassrtYYGMr252fZQmvpYKqN92dUitYhG
51787	payment	2134	2134	1874	1	1	9292	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GN9JWEFJxnP2xKDKskQSqrykG9PHiqkd9uR7Y9Jm5mB6pU5d
51788	payment	234	234	2439	1	1	1	530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3apxg5ryzWYzDpS8d51HyDNdmR9GyqmRWDQ1fivzirsvSaL9v
51789	payment	1397	1397	1678	1	1	18324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhnYfJJkyDmH8aqfhvYZqskPLcCpcPCPmF9utHwst18au76V4
51790	payment	2133	2133	1874	1	1	8389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s48WMUBzbUuVqSiaUZ3kFzkJB9A7CkzLq4vGgMDLbyULox2x
51791	payment	2133	2133	1874	1	1	8390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNddcaWtfeGWkLAw6RS7KYzty4ncsBHnRdfdwWFXgX7exjynH
51774	payment	2133	2133	1874	1	1	8387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6yd67Ly1noFC4LzEjd2zrHWakgPWHRWE5ZELthhHnWT18WprA
51775	payment	2133	2133	1874	1	1	8388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VT78LwvbSFw7xmCur11BL2CXk4SKPYHqAUKah3xGa5PaviEv
51847	payment	180	180	2441	1	1	4	5000000000	25000000	\N	E4YPpzX82oQ6gjyBztx8ZyU7nxPAwMyQX9qR81wK4JphdyU6MkYms	CkpaBW47MEcLWjn28qRLggapBwVTFbpkqFmAVWHfxXKs4E2HoNSb3
51848	payment	1397	1397	1678	1	1	18326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkShuBi2xZxKEbEzpjh4xDLTgE6fz3Bm73KYDaxxsw8juFCsfj
51849	payment	1397	1397	1678	1	1	18327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDjy9zjCqq8wKEkokLmSaUQ1FRfRRTifmQt169UQA6AEkNk3g
51850	payment	2133	2133	1874	1	1	8402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvsa6Y9ybRbpGDDL43pob83wxqSsamYj2zQfpJdaEVRWxHcNo
51851	payment	2132	2132	1874	1	1	2462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZ4k1TcfdP4cbo2sDUKf3jmuYXfQcphitmprjEFPEixV7UXrf
51852	payment	2134	2134	1874	1	1	9318	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpQKVqr5nH6Mc4oizYT18gGUfGcfDjEAGjzSLjNdfwEFAW3Sd
51853	payment	2132	2132	1874	1	1	2463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmZ6iNpTK6vDyXxLTtuMfFedKEQCDyiw2FZPS1J19ssjRCH4H
51854	payment	2132	2132	1874	1	1	2464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXjEbMcrztiBHvmFkdZd7y2DGs5MAXChNTnLenV9J5ZwC6pQr
51855	payment	2134	2134	1874	1	1	9319	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsdungq3fsCnGZjtvG6Q5ssAiLB61WDWm6wkEjYNnWX3ATukt
51856	payment	2134	2134	1874	1	1	9320	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCoicrZpba62VMmWFPXMntaJA8kugsJonQE7zdMRYRKUfqaGg
51857	payment	2133	2133	1874	1	1	8403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HPiD8r2EyiDJokMdojyjmNyfsE1UxCtWnyakhUFVTnKBdAR2
51858	payment	2134	2134	1874	1	1	9321	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sV3Nyfmh9L3Yyh1o6uYDo9HvSF823yQC9UnncSMVUQKzTaMh
51859	payment	2134	2134	1874	1	1	9322	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvk2P4WuwQS32oD4zi4LNYxZrks4tp7cg2iYYDh25GqmZcmEa1
51860	payment	2134	2134	1874	1	1	9323	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzpBm3WdwuZZ8Q55MZrEcMbHF3Zxyn9B4zKztTh4ozbwu1G5S
51861	payment	2134	2134	1874	1	1	9324	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrvxMdvnG1hBh7bGS73w1oJggsokRZCAsmogZsaiR8NJLLbG2
51862	payment	2134	2134	1874	1	1	9325	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZttURF1UR8BcMghtXqUUsb6VYsjcq4itPYfWe5Qk9DCA4MtGi
51863	payment	2134	2134	1874	1	1	9326	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7upQr8U6zNyPJymB41erwXxYopEZvFn48BdNPKYZNjHNdDUQ
51864	payment	2133	2133	1874	1	1	8404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVouEeYQimwSkHtHGmr9KSbB4eVL1kLELYjey6VdHw1TiUpRT
51865	payment	2133	2133	1874	1	1	8405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQY5pDZe9wWzh6vUPmdjpVGYKtqcQKJQkNzkJWtANHyuVZMQx
51866	payment	2133	2133	1874	1	1	8406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjADi6vSMU9BmKyrPzr7dHrCLih4w4295M9UP8tbk8iC6WnF3Q
51867	payment	2133	2133	1874	1	1	8407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i114ACEH9CC7VJ65CovuP5EazC4FMPZez8xn2EgmMb9yV7QQ
51868	payment	180	180	2441	1	1	5	920000000000	25000000	\N	E4YhEahnSRexdzCTMLLQ9SWbr2QiLP8FuK4FDh199hRvcuUw86wpA	CkpZiuGBXxa8wx8q8QbMuGVQNj3aH5ddMcen5vRPkcvC6yRwPqaS5
51869	payment	1397	1397	1678	1	1	18328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeWpUiagTBorVJcWPgvQmaTBJDGqvTyZQJaoWoH3atLWqciBw
51870	payment	2132	2132	1874	1	1	2465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAgfGAHfpabZR9uuMsodvYHYVUArMh2TKwbbsEHi3r8JtJWjf
51871	payment	2132	2132	1874	1	1	2466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1UU7Gma2dV8aLD5WJRvv5hFZFgzC4w45d6ihP6qkZJ8GpzdL
51872	payment	2134	2134	1874	1	1	9327	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5CUNLSG5ouNVpS38vZ8HC4dQuFZRDhBDpC4aGez3BSLAbKfZ
51873	payment	2134	2134	1874	1	1	9328	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJG5ucEUGXqL98vpyBwBLtKx1njhWUu8JeujYKxSXeZqECQqM
51874	payment	512	512	2442	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudBhPAp67Q1zc2XbuoDFuzY6Z89LEZ8XSyXrM2Bgk5xifmPY4
51875	payment	2134	2134	1874	1	1	9329	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCKtvfd8j8YTYKA9ynSvhurki4kowmJhvyM6mmumHGdPW1Wq2
51876	payment	2134	2134	1874	1	1	9330	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXwYy2Efijt8BHosXaXSbCfix6FjmX1VnLb6seywssy7gMzZy
51877	payment	2134	2134	1874	1	1	9331	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7osAYQ9QXRfjZK2VfSkLD4R9X64gBMYkk4LfxerTGcqtuK7n
51878	payment	2133	2133	1874	1	1	8408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZxN15VLmtznEqwnyfY7WDuamHCzfmTsxqks6PUtvzR2EsJ9o
51879	payment	2133	2133	1874	1	1	8409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpwLEsh7ixw3toRkTDnvct8dqA1zHk4ajUo8s7i3J3izfaZ8B
51880	payment	1397	1397	1678	1	1	18329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YXFLP8BVLqLWC6Zqd7AGqS2jobkQu84BzmPHK9aS9QT3B2u6
51881	payment	1397	1397	1678	1	1	18330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTCPjrtF8Zo5UL4vCm14fugujyhveY1i3n5MjukB1DD4EBfCJ
51882	payment	2132	2132	1874	1	1	2467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XTYP3L5p1en6zkwms3F4a9RHocmjdVCNJ92eqR3hEgewEzve
51792	payment	2134	2134	1874	1	1	9293	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCd1BsCco8rYGDozYeKCoDKV1f8vpA75qLLqiWfeP7gRp5iNrP
51793	payment	2132	2132	1874	1	1	2453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQgM7dh2wniFpbAY4Adx7AhUPKCdTcfTzz2bJSus6MN89UHiH
51794	payment	2132	2132	1874	1	1	2454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpE77c1aG4JjhiU1GCcik89WA1KN65rKdaXqLuEx45LEffBKY
51795	payment	2134	2134	1874	1	1	9294	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6xXxVxoeBrRBhsz51HD4N3DXTKgDJUeTW9iT5TKyRBujKQ7d
51796	payment	2134	2134	1874	1	1	9295	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8wAFnAnQ3NLnqBEsTSMpn4znDTBUDQxw4hhit7baP49YXhhT
51797	payment	2134	2134	1874	1	1	9296	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAuAjxybUia9ZKtfDuxuG6PqL43qijwq4yDjEx3hUDXVT5uZx
51822	payment	664	664	2440	1	1	4	1000000000	3000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzAE4UuABhnkuTuzzMKDAx8tA3vrejDVKiFU62XhKbnBGPzQp
51823	payment	2132	2132	1874	1	1	2458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1V2ievczhipN7o5LJQzfiLcVTrKcbvYob3g2soU1ALEHY5Fn
51824	payment	2133	2133	1874	1	1	8395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JSNLEDfFsoM285SWAeeKaAxvPncgTYsPqQyiDnUNgCYRVXmR
51825	payment	2133	2133	1874	1	1	8396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7VDf3e2jv7A4ca8JMeHrTrWKLcX2FzTETHcPq3BafkZY92dC
51826	payment	2133	2133	1874	1	1	8397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bMrWvPpUHw7JwKBEbRis5CVwfNM9bQVUAVfYWK467MXjyMgQ
51903	payment	664	664	2440	1	1	5	530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuEJes8KVw33Dy5iNSfqq54tcfK4VgX3s3eXGpddtEjiQyEZV
51904	payment	1397	1397	1678	1	1	18331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk26y8XnExJtskV4gk6bQ6KNKQ8UFQ3tCX8BLjD3F77zgZ847
51905	payment	2132	2132	1874	1	1	2470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1QyhoKVgqgmh4UpvCAnMgXaf5A8PQVHtGdL1CxAnxtVAwmyy
51906	payment	2134	2134	1874	1	1	9341	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5y3ha6tbyeTvwdvevA2wTgRf3ZaHF9RtoUgW1tyXX8fJwkhn
51907	payment	2134	2134	1874	1	1	9342	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAxkipU1eEKjQkZPPc7zX5tneCG6Y4TPWxk2Ku8udh3atZp3S
51908	payment	2133	2133	1874	1	1	8416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2CbmQbRJz1bBTkajGQd61BpCr5cBotaiKpjR6GzVm6t8C96T
51909	payment	2133	2133	1874	1	1	8417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8KuyWPsz1xwg5xiTAeWF5A3HFhnRLNsEiNR5d4PrZLnmc93i
51910	payment	2134	2134	1874	1	1	9343	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzvPxTF5MParmdjyPq6ezS8AMSJ1h7w4qwbVrGDXmN4C87rU2
51911	payment	2134	2134	1874	1	1	9344	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AD9xDvJ4Nm4gND6diobQXXS8vxAwaD8Z1fRZHrTBQ8YySv2V
51912	payment	512	512	2442	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAngWtsFyrnxkZqdM3ikmviXN2bSJdoX13Ahh99FaiSWEQtgXY
51913	payment	1397	1397	1678	1	1	18332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNtMrG1CrtZmeMYai9j3rjZcivDTLyqYGgZyzb6QNEZ6iNetc
51914	payment	2133	2133	1874	1	1	8418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNsap9Zn3MhbfwnumDCdwDDdtdpwN96DwhG4rf3GH3mqb2mjd
51915	payment	2132	2132	1874	1	1	2471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJgHnGHXKLwDKLz5kxkQ2zyyNTvifPpHfCiuYVdcWzppg4HNs
51916	payment	2132	2132	1874	1	1	2472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQi5P9rTGrc5LPjDriP8UapSi4tLXJt2GEkpBDXqfz38aejqM
51917	payment	2133	2133	1874	1	1	8419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Nq13GFwtsdgfWASgmyb15ciTdNryXzaW6o5tpHEkDi3nw9Fz
51918	payment	2134	2134	1874	1	1	9345	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNoqXXGGdi9AWainC5AnJjSWcH8ch8pUtV4z2nEP2QY3VETEq
51919	payment	2134	2134	1874	1	1	9346	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ3n3qD95QFmyTPsknVYx8Eg4fJfkeULVdqkfJUoJDCz4Q64P
51920	payment	2134	2134	1874	1	1	9347	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX68cDqVfD5zwnF7wJbyQ4jmU3qT5H8gXLmHWypmAn9t3eUdX4
51921	payment	2134	2134	1874	1	1	9348	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4RidFem9yDKccNyTbCFJJTkR1so3QkSkjQD9d3VWeZavJJPG
51930	payment	1397	1397	1678	1	1	18334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MLZq2xSDvMrMVhcYmuuEceSa926wNUasKQJHtmXqDedcWv9D
51931	delegation	2440	2440	1540	1	1	0	\N	3250000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnd5LeLfMA8GvyTvcj9MZupJ4ZDcGTr4ShWcoGecP5nJpib7na
51932	payment	2134	2134	1874	1	1	9353	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2vqPpGyPoPbXHra5QZL1EMphJXdEX69vkCXKK1WEfRCu7kV3
51933	payment	2133	2133	1874	1	1	8422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9NBJy1FGE4nUG4TakgzbS56Dis6UKD6dYLMJLppyi44XsJn8
51934	payment	2133	2133	1874	1	1	8423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBP6cu8EQsN9s7W5Z1ThbR4Phodg2uX53EmMpXqxJBykKKFXj8
51935	payment	2134	2134	1874	1	1	9354	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQUWFaLiyZWWLq3SFbCGrKXdb75ex6pHjbus6Lnvfo5yQow7g
51936	payment	2132	2132	1874	1	1	2474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgaNScpYALJqSTtXhbVokcD9oEmABjqvGj1RUKxx9EnLCeunz
51937	payment	2134	2134	1874	1	1	9355	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY48h4wTuChYKXAjmtopqAetmeJLRmcv7Bm23VsbvUXPKZhRX
51835	payment	2133	2133	1874	1	1	8400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpofUpH5cF8Pt6CYPbhCe2bKjvUeZFT7H2XAVi6ZXqEo7dZfZt
51836	payment	2132	2132	1874	1	1	2460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTVbZZ5Fr389WsPJ8J8hY4Z6N2LgBG3unXBhpHLrrCrRtZHgV
51837	payment	2134	2134	1874	1	1	9310	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NJ316xsbKodBLLvyeo4WEPD3ohiz5FCE39Jsik8kt95Eak6S
51838	payment	2134	2134	1874	1	1	9311	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh649yxEHGdTvRLxpDAWcM1Ae5r27eJrBsK3pBmxwWMS2maYP
51839	payment	2134	2134	1874	1	1	9312	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QBdRZ2nvA4V9vU86Pn9kf7fntB4yoJxPfTLGCu7HREKy46sL
51840	payment	2134	2134	1874	1	1	9313	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9a5BJ78xisTNpTMeH3a5JJXMnS24zq7nzR5bmmcK3471DQV4
51841	payment	2134	2134	1874	1	1	9314	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEvxMXAdYKfpfLvDJknEvpT6JWRjWwJSXfeVRNmXRNivxYDxF
51842	payment	2134	2134	1874	1	1	9315	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwAkgMKiKMKtS4pSvmTW7e7CNwyJujuPSpyLAMkdRU67fd3PA
51843	payment	2132	2132	1874	1	1	2461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RnPtjsa5KDjNxhkUJEoUwXrbDvuT5mL36oU2iwv8Rm687Hs7
51844	payment	2134	2134	1874	1	1	9316	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9CyqkJCi41SUbFoVYMoE6S157w3VXY3ZCsVB6hj32TEwLmav
51845	payment	2134	2134	1874	1	1	9317	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMdAv7K9Wqajxb9vHraHeh2hmngyYz15Nxnq2eSBK3oq8afyt
51846	payment	2133	2133	1874	1	1	8401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjsbhCHRr6SWEwPcA4fDHz6XmemGTqys39iX7d92C5YJj2ASD
52013	payment	1397	1397	1678	1	1	18343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyVG1rWtyhi5h3hszysQZrTUNjCH5QE3srCkWb1mUxje2hXfd
52014	payment	2133	2133	1874	1	1	8442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6qLyENpKb6BwDDGFpvcnWZEQsiT4NLgEJ6K5qJ4dHcBNB7E3
52015	payment	2134	2134	1874	1	1	9392	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7nzTcJMSFR3DaSBGFczo8otteByAE3ggmN8P76NSSg1Gmas9
52016	payment	2132	2132	1874	1	1	2487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodRo3541K8ou79UAgMxhQAeGf2tqkngQzDrqJXumqTmjxneYf
52017	payment	2132	2132	1874	1	1	2488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZF11b6mRzKMxg2Qg4sJABrKs8RecUC9wGefQBGkQTkWLagtd
52018	payment	2134	2134	1874	1	1	9393	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkXKysWN16r2Jaqd64xgndR6kxiKi8oD7C1dwd4xjSw75ma9T
52019	payment	2134	2134	1874	1	1	9394	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCLH8nNr64wQQ29oBjuWyupi8QcMv9GuT2Ua3ksCZfgaj4otp
52020	payment	2134	2134	1874	1	1	9395	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbMMnpK78jsToiLhzicU68sUmqot9SDK1zwRuPgeM57Pkeaw1
52021	payment	2133	2133	1874	1	1	8443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFA6xrrkdWkNgXaB6pHhLwsTkGBXummRFNvbjs7k8kzCpodKDP
52022	payment	2133	2133	1874	1	1	8444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdEjjpCW6M2KJduuqbKAaghX8eDFQqCZz2Knfg1epUPMxvqM9
52030	payment	391	391	2226	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepvsdgxU4KAPN9Lh5okaCjFb332XddDneahNNAgJmgWSPqnkx
52088	payment	1397	1397	1678	1	1	18351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHD7AkfGPkMCSTsHnx54D8xkSsV8NrUriKe53orJgBXwUTRcAq
52089	payment	2133	2133	1874	1	1	8460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYKcv1o5hqZaNVQuXTjmRaGZjR2f3pdkjLbMPX7Bt56B4douH
52090	payment	2133	2133	1874	1	1	8461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdWGMWGWcgtTezQrg9zgQZtAYAN8rTUs2mgxG36MY2iEB8u1f
52091	payment	2134	2134	1874	1	1	9426	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZxACp6B3bPZGThMPkXFyisCRdd1wWusDv8dEZoEMhhbPVtt2
52092	payment	2132	2132	1874	1	1	2499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYssbSges49MbgSXggpQu5nuQgMPAb5P7VcEE6xZ1HX4Y8TkRYi
52093	payment	2133	2133	1874	1	1	8462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEon5xuYvr6dqGAMKkvnX3nPLohLQNTxgQa2q7oHMSn6YH8DMD
52094	payment	2134	2134	1874	1	1	9427	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLYuxzfKTRc3GDuWk8JVSpwgegUNzy3vjWAheYHNtRB7NAGtU
52095	payment	2134	2134	1874	1	1	9428	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzwBFDe93S4bRYk8iz9YxDPKfs3ZiUBZh4kP4KLzkRL3jDHcu
52096	payment	2134	2134	1874	1	1	9429	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPhBj7wJNPPgTw3T7J5Wa7RTaJpunHWizoYN4h1iZMKE2mj9n
52156	payment	1397	1397	1678	1	1	18358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjqPgGkcExjzHbyiUiDZfZvpdenbcmSMn7NZ3FLyke2XMKz7L
52157	payment	2132	2132	1874	1	1	2509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqU6YhBbC8CLfVjz7vxdzXfes9TsfgSfezQrvL5f9dERcsd2wv
52158	payment	2134	2134	1874	1	1	9457	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRd8bNGuSuLvipHUtXjSx4wSFcN1nx8u6NknzQ48tWqt6X3FUr
52159	payment	2134	2134	1874	1	1	9458	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MzHMRWB1ZPmQ1PtLk8sYi121uPe1cKS1ZAaWjP7JcGrcnB8T
52160	payment	2134	2134	1874	1	1	9459	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAiDtds8iy3vsKbw3uDz2wuNYwxABFHxhoGLhtL1bFRR3Mutn
52161	payment	2134	2134	1874	1	1	9460	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqpYjXmURmqhwNGt1EvpVifPb9tbrEhAmdELoTpXx6cfuKbeP
51883	payment	2134	2134	1874	1	1	9332	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYzL4y9AMXUxYB3Mqi6nwUUAp3sKozrfUHoPV6fx5MNcxHadi
51884	payment	1726	1726	2444	1	1	8373	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZX8aVgDku1ztrcgh7iMb2LFa8wsNKfDjeCpByNA6745JFNXtVh
51885	payment	1726	1726	2445	1	1	8374	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYyB84AcppqC9LBRJi86HwUbJnbBd87kv1sTGvwfBkXXzuujjcD
51886	payment	1726	1726	2446	1	1	8375	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAfdNCwNmry7yMJLZpvrnDkzviEXzuorebJSxwJxTJWWZ4HdvE
51887	payment	2134	2134	1874	1	1	9333	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGQvuwSVDbTHpYcqLdFzJgwbSmP5v1WyYE759K16H41UBr4p5
51888	payment	2134	2134	1874	1	1	9334	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeaZW5skDAEuAGZUVzTzmmXdhTbkLqNWxi1PdEnDz1Coe7YqW
51889	payment	2132	2132	1874	1	1	2468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukHkWCcc7ipTz5XKRbX63xnfxCcKeLpBNpTFFtf84NPJ6jrVb
51890	payment	2132	2132	1874	1	1	2469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a4QvDtVVJgbu2uYZNUSqWpAhwxvr2zy2tmqB5bZAXLRvxfqj
51891	payment	2134	2134	1874	1	1	9335	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMNSUxqKLdxaydnfNoQVi8YXv31NAHLv2zKdAG3cvZudkpLUF
51892	payment	2133	2133	1874	1	1	8410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xwMKR9t1frMtWhEZ52rjPYUF4a1j7jGxKEc4Y56abFZwD3wt
51893	payment	2133	2133	1874	1	1	8411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1H6hXcDVCEmCUx3ACDym1NcY9asuB283ztytrLUSiFNpYtAnF
51894	payment	2133	2133	1874	1	1	8412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9ciSad5xRZk5LHrxUXvurASyPMbpidcWbSB9L1ejdENL2Xkf
51895	payment	2133	2133	1874	1	1	8413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYGTmcuYRSy1ACgCQqspNaPFm745CJyaWUhDchTcaBMdXXxX6
51896	payment	2133	2133	1874	1	1	8414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmfwszk5rRK57kBzcGqq2zqs6b9q43dWF92ioyFEmrh8JBoci
51897	payment	2133	2133	1874	1	1	8415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1u8MactZm6CQRv3LX8Fm321PCrnJuAnu3dL4Xk7fNGLE2NeR
51898	payment	2134	2134	1874	1	1	9336	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7BkK1sdRVMLZjsMBznmMbGMpWoMLmntkUJiV3nUsu9exVPs3
51899	payment	2134	2134	1874	1	1	9337	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTsUjkbyee1mAG4szZ9YN2uauQnopRYpwz6jNrZtqbdCnc8jG
51900	payment	2134	2134	1874	1	1	9338	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1zQbD8VRwYooJyVKLHmf38PyVnGS4rFm3QpzRp2qLRHL2Nkt
51901	payment	2134	2134	1874	1	1	9339	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M1B6KFcxwwrFrQeqE8TUZdzoD7YzYNLBB3hjzomSw1XMNupH
51902	payment	2134	2134	1874	1	1	9340	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEM19uUMbWZZNLfwhRA1XmMbgxWqQSnMabNX9K62f8kuRyfXK
51939	payment	1397	1397	1678	1	1	18335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgu6weHkCMWzU7G5y6BZhY2C3mhKLp8SMBfeCjDK6k8Wg7tr5
51940	delegation	2441	2441	1560	1	1	0	\N	3000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6mZnjTSDhF39ymVsQeHVV1janutusCPxwYzdnReHodLaGqWF
51941	payment	2133	2133	1874	1	1	8424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiQjWxgKeuLSU37YbaaR557Y3y4AveaY7sX3nRG31mUGTGiY7
51942	payment	2132	2132	1874	1	1	2475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDX5tsCCU1ADEHb7Y8tUKqnX4SbwNp3Z94xdebkamfws8e4rN
51943	payment	2134	2134	1874	1	1	9357	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuWVf9zu3Uh1AvR2VTrvak52quWxHa8DGXfjVN9yupc8xanNw
51944	payment	2133	2133	1874	1	1	8425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JgiXbQibGt3xtDea2CdLohBAaUw9SBSAR74qY6farwi6LXZ3
51945	payment	2134	2134	1874	1	1	9358	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4XZCmvkWt3BQKN2ncUGeNJds5zaLZxpmk2P7o6j33D26tJY4P
51946	payment	2134	2134	1874	1	1	9359	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAWeNcAeDQgkTqWU7rkZ3Mko6MxfD1jEceuZYdd62ng3cViVi
51947	payment	2134	2134	1874	1	1	9360	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVekZRBEquE9V7zWFN8PEWYHzQiLzx1kUXyzvoZXzFfddcVK2
51948	payment	2134	2134	1874	1	1	9361	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwxM9ShMTGbXkt9dTtwAWt1CEA2QgxAFTqFf2w7mWBvAMX8i7
51949	payment	2132	2132	1874	1	1	2476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLqE7CPGALT5Zf9y4RqSM3MZfvejMjetpj8cpioqmB82adJaB
51950	payment	1397	1397	1678	1	1	18336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZZBegtjGQzAs4Cjc8S1doqGj4s5LEG5KXcB8vDH6R31yVwiJ
51951	payment	1397	1397	1678	1	1	18337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjqtyayGbo3wp6AFfUCbeBxuWxEj1W8JndvzLzAAQFpXDUsRQ
51952	payment	1397	1397	1678	1	1	18338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4GVSFkXdVhioRLPnXeFGLLBH6C8M51MVUPiqeQMzm6kKvMSt
51953	payment	2134	2134	1874	1	1	9362	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6WiapmXmLrZXkpy6RiY53Z8TCmqdytmGWmgjXLhMkRccMcnp
51954	payment	2132	2132	1874	1	1	2477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHe7zuyJZRF4q5sFeH63bp28TaKvmhh9zRFZJYMsG7jtBz98m9
51955	payment	2132	2132	1874	1	1	2478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDL1WahPRQ7LidAhMkNq5Eodiz77hnz7KCuJTJqdTb62SwJ6t
51956	payment	2132	2132	1874	1	1	2479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdu6xNjewgyxanPwMq8afnCkqTpjqS5R7fMybyo4biaJgjAfi
51938	payment	2134	2134	1874	1	1	9356	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1Gw7GVHce3Pt9zNXqcuiKPzgj4bP9uXYMoacnTXuDb8wrwHY
52005	payment	1397	1397	1678	1	1	18342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzm7HpFynhPN1oPxGw3t5T2mDT4pxDYhwXpFnJn5LQDQPeeHTM
52006	payment	2134	2134	1874	1	1	9388	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHQfNk6XPvMxnq4tLsDgr7ZUDXUxmd633iSsJFB7Li664h1FQ
52007	payment	2134	2134	1874	1	1	9389	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf75ZvCXexGCBp3AXzfxk6rtSSxjoeU2eVoVbihpNGMTqH5Cj8
52008	payment	2134	2134	1874	1	1	9390	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVzrtFoArDktvzesMRPw3XS1u8ywhYLXuQmgyuf2b7J2VwGWb
52009	payment	2134	2134	1874	1	1	9391	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ9nkGA1Tu45omZ5kz3kqQ3a8XChQHTdYpFEB5ySsFN3N35x8
52010	payment	2132	2132	1874	1	1	2486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7cqa3BnMrM4ugrkPzXNFC8mLCA4Raukn7Q4pAkt8XyD8WsQC
52011	payment	2133	2133	1874	1	1	8440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4f7QHzqQtrjniMgxZhhRSUtDspeVezvk9ESzoKGsoRDh5Lq9
52012	payment	2133	2133	1874	1	1	8441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRvoEt6DJB6ZVtctqt9SnXACZ5MJNSSJjGBZeTtpmKLPNNJfn
52023	payment	1397	1397	1678	1	1	18344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9hxGJAZQS7WppeVy3HPLM9d1YGMGvQUA1nUnViNa6pWQbGKq
52024	payment	2134	2134	1874	1	1	9396	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDicJ7Cvgc8dqLSFiTpphtjBhB4dG4ifDf264oHmoagKuU5p2i
52025	payment	2134	2134	1874	1	1	9397	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7tB7rXskt5Q3bswHrs2YwWbaqZJHduCVw41XVtybRK1ejW2N
52026	payment	2134	2134	1874	1	1	9398	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqN6bz83RBFPAZPGU7MU3nyfkg6VQjXCHSU2S12iPkWyBkc2qW
52027	payment	2134	2134	1874	1	1	9399	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZinK87vtmMxHAqT4fv8q8Q8Jja8wGVLAAHhvztFb52xtmXfh
52028	payment	2132	2132	1874	1	1	2489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFth19FvjXY92jYLPSNPFp8XFrQSvSMQyqe4MYXg2Vhtapvr7M
52029	payment	2133	2133	1874	1	1	8445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksLT4ouBsMb3rMDuMzcLM78c3KAcJWecDSu2mf6imsGVfTu1W
52050	payment	1397	1397	1678	1	1	18347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iaBCYo3Nd2d8q4xifzGv6wX11iBZbd7oCkKYwze7cTQN3b3N
52051	payment	1397	1397	1678	1	1	18348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcRUTZ8p9X8ef3qyGg1hgF13jZ6WV8QGcEbWDHLuCE4mrfWn8
52052	payment	2133	2133	1874	1	1	8451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5r2UpLjHhyiNK5W7rbTjfVcniUPbDh2hYug9T5uwfPmw34ya
52053	payment	2132	2132	1874	1	1	2493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6WZ7XXpTng98vFAEAXgKw7UCN1oEBZfzcG3jJTe2Pq5hoRhe
52054	payment	2133	2133	1874	1	1	8452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xr12AcPRCB63xiGFAqp8UpTkHkf1cLyGHGsYnYvmkhDfy7ry
52055	payment	2133	2133	1874	1	1	8453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqqX97hbfggG3GLkVybb9phJ5Y8BKujADBbLpXUV16hFSoVAy
52056	payment	2133	2133	1874	1	1	8454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW2ar9CLhTz9jvk9BBSK1d7Q91ZuZkB6s2bQzZpnyrcBwh9jT
52057	payment	2133	2133	1874	1	1	8455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkw5jatADPWHB1V9p6hFqYD5vLbuoZzgrKN1X2Pj8zdFdhbVJE
52058	payment	2132	2132	1874	1	1	2494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jPYmy2UrtziaVqokfRRPXNtvTmv381gM83FTFMZ5MrGmwKDk
52059	payment	2132	2132	1874	1	1	2495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMQpUVosCGsmgPARCWD3f9mdbaz2nDpfeyBhSXQRx1A8QchHn
52060	payment	2134	2134	1874	1	1	9409	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhbDZW734JbMVGYyG7ZPTEr7yiLjWHS7LAuBuwocNdQbVtUov
52061	payment	2134	2134	1874	1	1	9410	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePkAqCGL6SdUYcYH5JLpHQGyajtLkSecKbE6vafngpnGLk2vz
52062	payment	2134	2134	1874	1	1	9411	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRTfPz5rjpkWZvCk2xWF3iaPE9g9vtC2AcCPFiP493J61tw6v
52063	payment	2134	2134	1874	1	1	9412	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtU8pjJwCuokYn3XnSD6B9c3cLTsa2y1rTp5iauEvJXg3xmdx
52064	payment	2134	2134	1874	1	1	9413	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71mjspiinGwWAXhHtQRJMSFCpytUmjpvJ9MJmwamcQmvxJWgF
52065	payment	2134	2134	1874	1	1	9414	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYt6ZRV5CSCJZm7dUaFB4CHQsTC7s4oDJ6u4ToBGyVfie2kzB
52066	payment	2134	2134	1874	1	1	9415	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFif6WQ7fsohwg4CqC7MaBVXTQBwNFtqyBV4pUSFS53MX9aGeF
52067	payment	2134	2134	1874	1	1	9416	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmiJ3z2osmkQdv7tshGvireT1U6uYKHyDXTfoxaK6bamyhAXu
52068	payment	2134	2134	1874	1	1	9417	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFZFuXYMPUtBynEG9sWLdK9QUWoBTmebWpSYKsE5iB33AyYkD
52166	payment	436	436	1396	1	1	5	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVxRnNAx3eyNaeu3bApRUrTHPGQCZTPvDLLjt9Zz6c9ygAW5q
52167	payment	1397	1397	1678	1	1	18359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS19LsE7bZzp61WGWB232s5VmmgNFrdcAHUk3aHJyBe6tgJJAx
52168	payment	1397	1397	1678	1	1	18360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1zmcMyZbUNTD2atiVzsy1i3EVdFG2KyinRbQp31LE5oPhYgU
51957	payment	2132	2132	1874	1	1	2480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCZtQGsTaVfVmw993c6HtuDqDa44qjXsdckqZQEg78rsC916B
51958	payment	2134	2134	1874	1	1	9363	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUFaXcupiBFHatsKHpnV9gUhYzZCmaeUveHRu7dhAtDWibv1P
51959	payment	2134	2134	1874	1	1	9364	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVvTGPCEzZi1tsYiAzCjDbFHdMHsN8CwGL8fAZTr19hRTiQf3
51960	payment	2134	2134	1874	1	1	9365	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjV6zxbBLDAsRcZNFXPPYiEpuPYqmivGtcCA53qRCnXawgtKM
51961	payment	2134	2134	1874	1	1	9366	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikNtAnd88LYr41Lq6kuRThVFvErfsCDrovXNk3yiLChYQa24n
51962	payment	2134	2134	1874	1	1	9367	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9k4vAge27Guii4c6Y6WZR3Tuuaxmov1BdAsRsAQRmyWBYnkZ
51963	payment	2134	2134	1874	1	1	9368	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJgpbh1sTZcku96QQCGDKeUNw8FfJgP2kVKDi14HnGwMcoSAz
51964	payment	2133	2133	1874	1	1	8426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZym9ik84eUR7FhVWfDmuahWMGTacK4tC9poQ4i4YYBKhdmYo7B
51965	payment	2133	2133	1874	1	1	8427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTqVuU2H6rcmw9L9vHcUdDUuotQtXPdd8khW1LhRYbj9Uo7BV
51966	payment	2133	2133	1874	1	1	8428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtdDwyUaSn2fasC7ahtTFNNR2mP5nPAukWG2kUG998QX1EsDc
51967	payment	2134	2134	1874	1	1	9369	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XK5tXzMqKyA9xmFMxCMnhN95rQS6LGC7anYwDR5pmbhAW8Hn
51968	payment	2134	2134	1874	1	1	9370	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YbAq2QZSV8HzCjpPMi6kkiwW4QopLvVzBt5jByzihtMS1CUc
51969	payment	2134	2134	1874	1	1	9371	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5BTZyyHHzNtpyBiPuB4m3assjfhKr4QsAHgq2k2vYyDmsNyMy
51970	payment	2134	2134	1874	1	1	9372	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPhmQAK7wskS7QF88HhXEK952xZkorkWamvSqsKrfnyoC7aq7
51971	payment	2134	2134	1874	1	1	9373	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVEJXKorydmojUh7pwv3pH6jGQZjVzpxP52uDknqJV1y7UQnQ
51972	payment	2134	2134	1874	1	1	9374	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYg4MAAnJYsGBAkxNUVd4FYky8grMtus6J9x11JRKPWoGVYgt
51973	payment	2133	2133	1874	1	1	8429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFbvbbBKsurHyM5rkY9iXgi5zfJk5pvRk2nMRFHft8m1nhJM9
51974	payment	2133	2133	1874	1	1	8430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXPmsKQ28c7gbzZH6vhwmbSsDk4qmPYXmWDrSayxvkM2sc8qb
51975	payment	2133	2133	1874	1	1	8431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxUvCNscK7yFN3VqhLYwjKwG1qiv774BZ4PMZETZEHEWi3xgG
51976	payment	2133	2133	1874	1	1	8432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrGgeZjWGxKNyBsU1YAtsGnAWeJDM8RfG5FKqESo2W5gvWopr
52069	payment	1397	1397	1678	1	1	18349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEzX8UkmseX1Tk8UYiHzFtfZ1ZNRE2u8kTw33ZZDHhehiSfDJ
52070	payment	2134	2134	1874	1	1	9418	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhVxnvDJ9MD5NU9TsEdj1dGf1HNaXP7gufs5Q9gUk6oBMuMWc
52071	payment	2133	2133	1874	1	1	8456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbybDHTwe2f3z6oFN9s51aCwSFBmrBtLR5qRxiaGqL7X5KGJYy
52072	payment	2133	2133	1874	1	1	8457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwtPdFceeBrNRtfwfaVvzGttg4P91j4mwRFJfZXo1oAqwj295
52073	payment	2132	2132	1874	1	1	2496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDgk1TJjHoAJ3FHjUXts3Rqb7cCRrV2gCoN2D13Gwkae862kv
52074	payment	1726	1726	2447	1	1	8376	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhLHD25eCzR1k7Rq5VPDq2SKtXhpiMvKQPiuvwCrNFXQT5zomu
52075	payment	1726	1726	1538	1	1	8377	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYewVDBGJQz2ZQEXztmHNuLz5mVhF9tqHU8jHR5GtWphJAkYQNA
52076	payment	2132	2132	1874	1	1	2497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwTqcz6MQG7E92N263n5NKXyPriXvk45mrL6mcr6jP4sj3Z7b
52077	payment	2134	2134	1874	1	1	9419	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLkruKEPTxEmEDLKtYHFp7BzjUtUKobFBxm9TY68iDAVvjRgx
52078	payment	2134	2134	1874	1	1	9420	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoC2ub3BWugA3NKFu7QNG9srtWeUxsVHgJeZS4GzshcMYAtGVA
52079	payment	2134	2134	1874	1	1	9421	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtnoSYu54BXko2R7drVyCSsvmmb2XY7XE1mJajeUsNaiNieGm
52080	payment	1397	1397	1678	1	1	18350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABW8RSUnu2hQyXtszDQg5a6N86NHgMRWz9AVQLMxiJDCEMjqS
52081	payment	2134	2134	1874	1	1	9422	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJP9NnGw8q3Lhsfwac59djNUwEfsntvAzVPoZc6H3m49179eR
52082	payment	2134	2134	1874	1	1	9423	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZht11pDWJdJu1hN42xn6LKXx2nHdx13ZqmssM65bvdvmEXjxtp
52083	payment	2132	2132	1874	1	1	2498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj4jRnuu4EGnr29TAeCeHQxRYJirFwTZFmfakaBuHT5e9uw47
52084	payment	2134	2134	1874	1	1	9424	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVYsa7aviGCTntuq8Q26VebFLVrabG16wLgwJsS7S4FNdqnj2
52085	payment	2133	2133	1874	1	1	8458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFbCgEANcnFBgHQRakyuLrSkF9YwUyVtrDfKU2nuTqZ11GczyT
52086	payment	2133	2133	1874	1	1	8459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzYXjCwJi6oz9w16C9GDosCA2VX2Ha7xhHgWBe9obcLoksLHx
51981	payment	2133	2133	1874	1	1	8433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZ9pJ27NAwX7Ck2uzH5uPA6EcUoG6ZMJZ2JRfgdRMUtxaK6k7
51982	payment	2133	2133	1874	1	1	8434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt9dxayZJyW1TQqMiPkYy5iyYcNpirwwwRFCRkavE3LtAwgCF
51983	payment	2133	2133	1874	1	1	8435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSdm86zxbnH6NcwgAeyvBtGNW3e2R2SHnvq16yVE4UzAAAFAe
51984	payment	2134	2134	1874	1	1	9377	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4tKq7hfTzpkadWANvGyh25LmaJeFegcMrwWFkjThdfDvrxd1
51985	payment	2134	2134	1874	1	1	9378	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4xYpxUqpfYhUFT4qKDHX8tEjdv9GCbyysbz8BWZVSZBhfATd
51986	payment	2132	2132	1874	1	1	2482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXks4EHutcTFNEjnV9fxrzTkXgHPGXs1NsKyuHMW9reYuXtP1
51987	payment	1397	1397	1678	1	1	18340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuY4w2sQgH5ZeEgSkPoLC5PRQKUdp3vEwecmCGpCksEEtVjJnQ
51988	payment	1397	1397	1678	1	1	18341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAnc1n6gfxmrm6wPCqqR2iqmBrjEHVphFPfaJxDDvaK8ddJua
51989	payment	2132	2132	1874	1	1	2483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAEdFWnmEDAXjugSeZSqfzkYYAYqb9LQtv2EXBR4J2n4x9BH1
51990	payment	2134	2134	1874	1	1	9379	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNJewrxj9V7t2LbM7JbTHBufUbS9bHPJkcanL5SykuVCYKDkh
51991	payment	2134	2134	1874	1	1	9380	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXXF5JT36CiTwYRXAPcYhFhbwGc64W1j7yaXwj4BXRR6nEcTF
51992	payment	2134	2134	1874	1	1	9381	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWCfcJSDDRbJU5PjSMGQmDm8xzuwvaHuL86RrCndnY4A34Xy5
51993	payment	2133	2133	1874	1	1	8436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisNtxSSk97mgqmTDgaggWPyuccRQso5knjE2MvvZD7y971hN1
51994	payment	2133	2133	1874	1	1	8437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK83asSacJ11wA3z45uzyfpvBUEPRXR3a3mLvV1gyJDfuyrjNW
51995	payment	2133	2133	1874	1	1	8438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtcWLHAffhmH4GSWS6yECD2qqPEUkrT4cKUHKt8vVJ2hnGXsB
51996	payment	2133	2133	1874	1	1	8439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZAnG2d7QSmzrHbf6KXw7eYRB9pS5CKW5ATGCvHAt8GkAuig2
51997	payment	2132	2132	1874	1	1	2484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXV1msZ3Lt9uf5GSiSvzTTisjP2Dp1wjyDe2gK8bnaNj1RUjS
51998	payment	2132	2132	1874	1	1	2485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVAN7b4n4U2YE1MvU7MsQGYgZp63FPAPkpRG5qDLBm8RzYC64
51999	payment	2134	2134	1874	1	1	9382	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ry96Fy6Z75exUAjT1M39vdXf7JxjiDfur6f3r53KLXH7gtbn
52000	payment	2134	2134	1874	1	1	9383	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUTRcHrRNsrbLZwNGw12HF9Xg2WrDFWnjWbVU4JVX5zbvKYrY
52001	payment	2134	2134	1874	1	1	9384	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fge3Kj9fMPhBJ4xNtfNxzNFAAd5ZDcJGTRw3AWRg8SC7oNeU
52002	payment	2134	2134	1874	1	1	9385	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dVMogBqV6d1ybc78aj9mnMk847Tda5ZEkMJx95WrcxH6LzsM
52003	payment	2134	2134	1874	1	1	9386	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCFSQxbwqnEpp8yACNAAGxUmBq7fGXKnZfUHfHkrgYqQZGMx1
52004	payment	2134	2134	1874	1	1	9387	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4W3cfDRrn1zbVEPP1g5Pd4TQAp92aG6cXcvoraqj4r2HTiSEi
52031	payment	1397	1397	1678	1	1	18345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSEBhdDKpdmqNiBXHiXxKfvtgoTvq226TzbZpNhYf2752rEzC
52032	payment	1397	1397	1678	1	1	18346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4SYQG9LNCUYMR23x8yzJ2GAcqZYGwpPuQWGLoPpLsvjgeqXL
52033	payment	2134	2134	1874	1	1	9400	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHiyJ7TqhkncdPEbGm3zXq3SPQp4HKjqtietCsaCNA85Y4AjE
52034	payment	2134	2134	1874	1	1	9401	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszrkFRYSD3TUvkjqayRuar16tit7CPh2dTSTjvwuHDUfFGamY
52035	payment	2132	2132	1874	1	1	2490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMJBd3PvUD1Esn9rgnX3V1sbL1Jh32btNQoFYXXRSagGNK5Bj
52036	payment	2132	2132	1874	1	1	2491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTM87W88ZemDW1nqPnypADNGRSy6BxWPDfaYwYera4EhZUj3T5
52037	payment	2132	2132	1874	1	1	2492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFksWR6yEr8bmS69tNfW2std22EfXMA51GNWAbMbCjKRWiGk2o
52038	payment	2133	2133	1874	1	1	8446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTGX48ueuT9uzX9kMyHwAzZe1SepmcBU8CYu5fsmvXqsLN41F
52039	payment	2133	2133	1874	1	1	8447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgczgStn2YG3y27Cj4sKtAV44Bo6UqTGSknHwsF4VtU5fMrd4
52040	payment	2133	2133	1874	1	1	8448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBCwzHCeaHMSgBeN7h5giok3d9v5uJ5ofaQUPB4wtLp2JNupf
52041	payment	2133	2133	1874	1	1	8449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXieQfEuzFSjFDyrEtSr5W1v2ncspWrsP81sWeeByxaGQrh8an
52042	payment	2133	2133	1874	1	1	8450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jyvVwDkRPKabS8nrvsfDEULcwz7PjdsdeGTMRqfdm6ihojB6
52043	payment	2134	2134	1874	1	1	9402	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMJHTvBUrXYYrkracXb9L1eud8b1nwBnBMKAqJJmyCCMqqi25
52044	payment	2134	2134	1874	1	1	9403	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W9E8d5sa9qdLZy4fQVCwX6dQobWsYt93jquR5bsTHDMRDivU
52045	payment	2134	2134	1874	1	1	9404	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UXy3KVWcqpBgNVxHqCEPEkemBYxws1nHTEhJaetM6wPGTqjt
52046	payment	2134	2134	1874	1	1	9405	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHn4SWSSNmPYYXpLUMLnxgWm7Bj6u3G5VNRMZuGTaHoDPPgmAp
52047	payment	2134	2134	1874	1	1	9406	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW547x9M7yhBw5Vgfb8LSC3MDPVkvLTfu4SaUtT41jkwjNnkVC
52048	payment	2134	2134	1874	1	1	9407	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LqT3MgoucufcPWs6cdBX1atVy9yeSfcZN5AYufZbLckE5Csz
52049	payment	2134	2134	1874	1	1	9408	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfk8nF4iZbTs9mSwdYwppS7FyptaVvT6fG4uQ6L1rh2vLVHPi
52087	payment	2134	2134	1874	1	1	9425	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPH33H8Z88S9tX2oc92NtS3PyULEtcXq2z7NxmLuoTXm7J8hkw
52115	payment	333	333	2015	1	1	2	50000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyXavXxCxSS5x6m643s3dujA876vTgtB92uN9uKM4q9p7YTJ1
52116	payment	1397	1397	1678	1	1	18354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrd5Zf37FuFx3cCC1jbjUg8Q4L1fVT49knjCas9RNaGzDPqyFi
52117	payment	1397	1397	1678	1	1	18355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tNRXE1av5vFAnDDriyKfpXywEsH3SJ7piig4kBYK5TMEM532
52118	payment	1397	1397	1678	1	1	18356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NZFfWjFKf1DFBwHhBE796iGbyKZUiJRHP1mS1By4Bb9u1GAU
52119	payment	1397	1397	1678	1	1	18357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgodVdiH1muqAm9wX1BbJa2QMwsFEYmYXMutXjWZYJzR9D2cuz
52120	payment	2440	2440	664	1	1	1	1000000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56CEecg6pLWmLaWXDqpduTGAuhB3weLg5KUGj1E9sjUe3qT3m
52121	payment	2132	2132	1874	1	1	2503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxvY1AjLAXzYsRCNaTSB7aZ8atGx3vWd1uTcHirTsP6z6aBSB
52122	payment	2134	2134	1874	1	1	9439	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tLMuL8S19K1xoiFzhLzju1ttrA7wYT2g1p8MKjUaaBbct7eX
52123	payment	2132	2132	1874	1	1	2504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEsgGp8fuj2yJKnoTfVaGffAnpVVvchNyoQVk5A1g4wD71N6u
52124	payment	2132	2132	1874	1	1	2505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZixfMs4kSPynDtzDmmKDVGkHhYa5UMLYj4CHH29u9zmsKqTzz
52125	payment	2132	2132	1874	1	1	2506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBv5KEAXX1d9BvsWWoL5neqkeGfxAmfKsfC3NM6exjsEFHbCRh
52126	payment	2132	2132	1874	1	1	2507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PwUZLXbUJWegX5umVmzojZJvmi9x1ruzyynRFkWCXkCXqb1o
52127	payment	2134	2134	1874	1	1	9440	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQDgcVGUevyTRdWrTaqxrv4bYtW5MnzDDYL99yZ4UazPVkb4u
52128	payment	2134	2134	1874	1	1	9441	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfudb2SqD5M52qqxVHhLGwa5xpTAb2YtQtynLob7uqRkYJgv2p
52129	payment	2134	2134	1874	1	1	9442	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQX3ZUVXcxMcaENUkNRLuKCrJDhxy1VSWJwSNAu9E4rYCAAJ2y
52130	payment	2134	2134	1874	1	1	9443	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrAGnX4tFFVbYpVVAjMM9j74AcXd4sfegxY24hKE6ViZsZGmY
52131	payment	2134	2134	1874	1	1	9444	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZWDgrqCjkNUm6jvCTMrmVb6nVNJB6qBVHtBsZxRc5ZzQ2krK
52132	payment	2132	2132	1874	1	1	2508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QArLDoAuwKSKLQZY2LJVMQLwWQsbDAohyEemdRELcYRwMpW2
52133	payment	2133	2133	1874	1	1	8467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8eLRqY3nTUYfpMfQ5QArLyAWREutoGcJ3JDrFNRKxz7dbanM
52134	payment	2133	2133	1874	1	1	8468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkEsL9hvq5e4C7LXt4U7wamWv2Q7TTEx6iSZhNv1JjAnNDCqov
52135	payment	2133	2133	1874	1	1	8469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapMfYoHPb36cyVBqy7bEzJD5QKHcQp3AB3ykCwv4UkFLnJmcV
52136	payment	2133	2133	1874	1	1	8470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwwUY3LmTPfRiuafrAmNbYQT52uBhKk996EkyYpZbMbwV24BA
52137	payment	2133	2133	1874	1	1	8471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsyQJRkHuUHrTBnhRaNXU1x8WpTYSoqrAgFbMkhdiVjadpWog
52138	payment	2133	2133	1874	1	1	8472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZoSDzjcsmLroPLs54gXZYBuV24xLNbqH2d3fbRu3cujpeapE
52139	payment	2134	2134	1874	1	1	9445	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpgnyDbtGzora2QyiZLiH5yi9LQ8zV1wfoSi3xsb52fjyrSYh
52140	payment	2134	2134	1874	1	1	9446	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7H4Tjp6QqbnRySz1Ac1U3WYiqczxvhy4qyz3q9V4iUsEFLET
52141	payment	2134	2134	1874	1	1	9447	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihebPeThtbGQkTtUemGr8qnQsaXMwJww261hPf1rtYCfbU66r
52142	payment	2134	2134	1874	1	1	9448	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMhXhyhqTAbvWwdM54oFAqwQjw62Q2attijdVjhWwEjnjrtez
52143	payment	2134	2134	1874	1	1	9449	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVDvzU21JrCeEk7YJZkTtzeiBi87Sn4cntmCGseVJhTiLsRS5
52144	payment	2134	2134	1874	1	1	9450	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCunPNXJ7yacSKuUc9sC1143wJjXEQq3XLG8EW5Cu2BbqpDfc
52145	payment	2134	2134	1874	1	1	9451	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TDXmDZnbUwyBC65CkbbivXwJUeN8wrU8GUw8zjFPiTkAQ4Dy
52146	payment	2134	2134	1874	1	1	9452	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxkGDfmeCpGY5z1sjQXyU8GqRQMibXuQjxmPqB4Z6MigSbqDK
52097	payment	1397	1397	1678	1	1	18352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmioSiNC3YBQdGfED3FsWy7XtW3paYqvGoYh7obQnvma9gvYe
52098	payment	1397	1397	1678	1	1	18353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UD8s48VMBagL9nqSHfqXU9B8kYjSZ3SEb9Lh3XPEw7KCKoUN
52099	payment	2133	2133	1874	1	1	8463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLBX91hweGiG28Xhb5trF3ZSkdocSiTegjkFtnArDTLBnduMX
52100	payment	2133	2133	1874	1	1	8464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeDQZB6UnwiiNBjP3gkTiffUKSS9ZS1txAeVfMKhGPBpnQW6N
52101	payment	2134	2134	1874	1	1	9430	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyzHmYwaC5TGyXJQ57GMDBFhKLWxLH6hTfgamqiE1mFBtG8Pq
52102	payment	2133	2133	1874	1	1	8465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Y1LkNZhaYuf8mbqJyMmEjURxHWY451rq4NRW1N7tsu5S9bbY
52103	payment	2132	2132	1874	1	1	2500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mVaLCCdRVnMGVP5jiwardt4iwZjDZE9gvb922snZ8VyyCHaS
52104	payment	2134	2134	1874	1	1	9431	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nCE2KNJfjRbnCqkyZctH64UpsXt3C1yE2UByY4r9WdLvhhJP
52105	payment	2133	2133	1874	1	1	8466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJonknV3FKbDrHwVywvTN2PQnvG7shJfYZ9Jofrw77Ms4GShL
52106	payment	2132	2132	1874	1	1	2501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEG5mZEh9xSoUSpBdVG7nQCcuyAW5FAXDFBUvB91T4oXbsDq1
52107	payment	2134	2134	1874	1	1	9432	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvA8wHv6JR5zckxLt9aZRorkitEcuUrHt8i6maLLZVLPU9fic
52108	payment	2134	2134	1874	1	1	9433	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhK9XRipBiNyJqnE7yVPSAsS6iV8nQ7rhgvys86xdRLsy1Bs7a
52109	payment	2132	2132	1874	1	1	2502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6U3z8ijhouTiGTKbDREPCuXtUW4HKdkayLeQwkfwUdUhNt5Mp
52110	payment	2134	2134	1874	1	1	9434	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9s7m3JppfMBfmi81yD3bemFTonUARLTzj5tWf8N94WyGqpK1
52111	payment	2134	2134	1874	1	1	9435	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYsYXCBJzmzUJgyUaaHJmBBgkf99CF1CH28tE9z6RKD52igLr
52112	payment	2134	2134	1874	1	1	9436	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJKT8MSvK8dXYcYH3kw1uy2n7JeTHnvtpkacNsFVZHrd8nFBe
52113	payment	2134	2134	1874	1	1	9437	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLZYgvBvCtJDoJGMntBoHJFHqnGk1omyTdvmMEr3K9thuBHZs
52114	payment	2134	2134	1874	1	1	9438	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3MAu6zsiyuxY51LfSuSo79y9a73JvyZ93ZgRbeeWR2un3uRk
52195	payment	1397	1397	1678	1	1	18362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu52DNTjY92KwKLxyP11WuWYBta4EmP1eycpsL3Voc5AWVzn9J
52196	payment	1397	1397	1678	1	1	18363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPGtoagKevBeKqzajr6erCCWC49V45D7g5QwTdd7CchDcvSNo
52197	payment	1397	1397	1678	1	1	18364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX4oyQKnssZZMxbotYRWzuZqY2pPM1HiEJypwqa6FxDMounx2
52198	payment	2132	2132	1874	1	1	2515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi7NAB4sWHehqsLJeW8Us7bebXThCr4cYDo1nNJR7TzBrcVpW
52199	payment	2133	2133	1874	1	1	8488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDSJwrjLvDWY39EdCvjQQTsSwRtrh7znfX9GZngsQ34RPvv7A
52200	payment	2132	2132	1874	1	1	2516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a65cLX4AMZFqCfh3xjx4X74fqYnZS2k8gvEe8jeW27iE1wAD
52201	payment	2133	2133	1874	1	1	8489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iC3VdHnf1MivW24wGRgvtaz4Z53hssofPWb462RbxLCmzWNQ
52202	payment	2133	2133	1874	1	1	8490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTepCZkTytJRV1bGadya7hPnLF529QdT5C7HGg5gRurcSk1Qv
52203	payment	2133	2133	1874	1	1	8491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4iLn8h8kWAuYa5L2f8obUx5wNi58Ye8WkFAbZkjLPfA96e1X
52204	payment	2134	2134	1874	1	1	9475	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdmXwCaLPyKxzkLBULQTxW8rh3Mq9x5VLphSM9ha8hW7uU2MC
52205	payment	2134	2134	1874	1	1	9476	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAve36HEhiah6vYSqnDmZ3HfJhtiHTWmkcXaNzK1ZphpSGvMBz
52206	payment	2134	2134	1874	1	1	9477	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8ksr8gdjbmHHTcmnjYGEeSURDu2MFn32Ey8wzuHu5RdeQ9vN
52207	payment	2132	2132	1874	1	1	2517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjq849PBqSGetDHBcbKh2YoPvLVLDBJpNQkEbRLMxBJbgY3R24
52208	payment	2132	2132	1874	1	1	2518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1nJxxz9NmsoaNsiJonmTj5x2sqQSPAttCDR5UN9uQiaTH7NS
52209	payment	2133	2133	1874	1	1	8492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBSi1LgxTRGktJvV9wPJY7cHWwn8369S6FygwrZocojHFnu1Z
52210	payment	2134	2134	1874	1	1	9478	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEcDSjcUTZpaby1r6qBEDn12E9DU5Ln84NEJPoiFXUHtoxQ7V
52211	payment	2134	2134	1874	1	1	9479	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnJpCi21U8uKSyGpRtxvnaBhhhGZs6Fq23thnGscvciejwXpq
52212	payment	2134	2134	1874	1	1	9480	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMRQVbY3cqzms3vaMHNp24NV4mHm4c2dWGyVRFhnDZD44BDg8
52213	payment	2134	2134	1874	1	1	9481	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchzBqWs97kG2HidmZxDNKHLHhRUVpDpdXzqdq1eTQ1TCbRF6L
52214	payment	2134	2134	1874	1	1	9482	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJDHN5pagdPx29NVciuyZBixNDqvvmyUGxr3xiRZW3SWpcEUy
52147	payment	2134	2134	1874	1	1	9453	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcgQPBRdK4eaFA9psNmu7Cg9uaeRCxTDBG2FfA5TF12F7fHEWu
52148	payment	2134	2134	1874	1	1	9454	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ262nERmPZ3tKw9cewas8EhkBecbLJeAqBcXLvnpSzgAKcJ7my
52149	payment	2134	2134	1874	1	1	9455	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6npq69FmD188eyuamHqyXMEnbv2stNrN5Y19f8Z3UCJ6VZA6
52150	payment	2134	2134	1874	1	1	9456	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNnfwuzpdwArVxGk72QvyY3izH5KqJfBJ9Zo6UiviDXx8dG1T
52151	payment	2133	2133	1874	1	1	8473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxmbszwfAZwZcq9H8UAHJHUnQ6p2zNimyr8jqZRS98CjRwMe1
52152	payment	2133	2133	1874	1	1	8474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhzgyKJxrScTRKQR58JdLQsDNRXhwKNj7RfPjhpXbAqS5bhhe
52153	payment	2133	2133	1874	1	1	8475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJfmbuxnzqabJWghHjrmzFLLvENskVCgHET3TR3wrBojxkVHb
52154	payment	2133	2133	1874	1	1	8476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUHTKqLHpvL3w7nfvR3QvWWHYgGW1LkXS9jfdbVywNxmwoP1N
52155	payment	2133	2133	1874	1	1	8477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBW1hcbP5JTMhuKnnXZ9TW7burWUQpqeWnVxvReMzX79HshpjQ
52186	payment	1397	1397	1678	1	1	18361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEywjpYEeHcepde9rRremXWUUcN4QKPMP83WXir5Dfk5pUZKs
52187	payment	2132	2132	1874	1	1	2514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSe2sXTPjEgYRH2z9z9Hane4t8TCsH72GE9QPgQctRQpAWvTSP
52188	payment	2133	2133	1874	1	1	8485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURHCAb8FGG84YxF5YikEVWxa9pgT4vgANDuWAmJjcSsBGhD35
52189	payment	2133	2133	1874	1	1	8486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy8ddW1GkgjcnFEEkKACp5bGN6uqsNvhrGifU38fzexD14ZKr
52190	payment	2133	2133	1874	1	1	8487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahwh2DSuErNZySo8V888DANWiLYkYsxE45N2Q3FtfYJeH6QSc
52265	payment	1397	1397	1678	1	1	18369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6WpaVj7i6S3c9rkQFQhhsHtH1meqprCwSe87FVKA9sPfU6ng
52266	payment	1397	1397	1678	1	1	18370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNvXfCbPgMbZPGYL28SoejP3BBVf1vv27DhxoUiCEJ3CV6X2P
52267	payment	1397	1397	1678	1	1	18371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpouK1hBY8G9AEVbxUrAa9TWBZU5WrJkmHNK7x4irJMHNFGSDn
52268	payment	1397	1397	1678	1	1	18372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu63haV7AiAjB7G3qHK3un8XREX6ps1DDhAiDGmRx3YuMZ5qc
52269	payment	150	150	2449	1	1	0	1000000000	2687500	\N	E4ZLCVEKTosvitHyDMwKzSrci7E1BcnE5zs7CvEvZZQxCDcFr3Lyh	CkpaCrmJazSRJT2mdtuxG9FqwYZnCo7H4AtenkwFjtHrpozNtSQKN
52270	payment	2133	2133	1874	1	1	8508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Xa7UQaTvY1Ke2CmHzMPJej4DhR9fZSwvBFhYQKwustygn8RW
52271	payment	2133	2133	1874	1	1	8509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrLxncinYTrFnKGxn6CYWgKR5Gmy1BnPzpzVLrDz7hCzLMQEH
52272	payment	2132	2132	1874	1	1	2525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxw7xEcrELrNLJdzGTLReTJwfXvDFDFLdd4a5MPPZoyeP6Uez
52273	payment	2132	2132	1874	1	1	2526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KHspei6yyGiqd38pp7AiRH1ddrsVD8R7e4uJvF5z2GqEZpN2
52274	payment	2132	2132	1874	1	1	2527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKXXqtJqQEHPjvzJYcq7YkV2KtfKm5RRYFs8rzTrjVXKzx4B1
52275	payment	2132	2132	1874	1	1	2528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKoYuNCT4PJGUfUwSweEodwCsMMwmVNPLZAf9pbQG2pv4FzPV
52276	payment	2132	2132	1874	1	1	2529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6hmfrYsTpaqTPteKt9XnwAJmvtpvxNJy22HgFtGppuBuDT6A
52277	payment	2132	2132	1874	1	1	2530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBUXiAx29JyqH8Bx6YZNhCpjKsGjrVzimLRKF3wrvWTXurjfd
52278	payment	2133	2133	1874	1	1	8510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KVL6Q44L1CoDGQAQMs1Xg5E7CsXQPwSi88CGiBmVKHPLnh63
52279	payment	2133	2133	1874	1	1	8511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRaKBGoHBe7pcArewsyMK8Lp3mW6GuQdbhd6GcRBznLsCgPJo
52280	payment	2133	2133	1874	1	1	8512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7qqsbPjDXEq64XL5qppNWm9cBSB1oPjj9Pi3F229eG5BCKsz
52281	payment	2133	2133	1874	1	1	8513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ52svoy2CHJ4fsBxQNk8CnyFXEhwv8q3ECioTnkoCiYXncyyV
52282	payment	2133	2133	1874	1	1	8514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9rpXasTh9ZSN25uXAp2tz2TChhDQ2WUBqJrCdAULazp8Nvjz
52283	payment	2133	2133	1874	1	1	8515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3FiLqTMRzFH24Cm8HGaqaKgfoa8shnTCg9zzHPjK3ozXYFSUM
52284	payment	2133	2133	1874	1	1	8516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfzbj59pdkThSfJB6GioVKw2FjUAPkQAbBTzaJRhCHqZMoQ7T
52285	payment	2133	2133	1874	1	1	8517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvzpK38YpvQd75sJEnXdeFp1idhDzHgyDWazQoD7gHVctv4Jx
52286	payment	2133	2133	1874	1	1	8518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYtdmcpQiuHxxV5K7q8Q3sNBeqw5cfykYFmzPxEdnpw5R683d
52347	payment	2134	2134	1874	1	1	9543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBca3zon7fTfHxjzdDJhomBCF8MbvJcYcx66H1aPrWgYDEFs4D
52350	payment	2134	2134	1874	1	1	9544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2CmYpZizLpZYcQUh3MJe4eRQMfGzb378r7c7wufkTu3xBycU
52162	payment	2134	2134	1874	1	1	9461	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqK4RDfqpHYTCEY2UWuauFceHUBT477FYqf7XZYtDoZpYVDh1p
52163	payment	2132	2132	1874	1	1	2510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa84SPFj4x1C9hZSJkDQko4TQuuTrbqJe8TuvtRduGyM47DNk
52164	payment	2133	2133	1874	1	1	8478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwz8HqLrt3MdZ3iFexrcrQbucQ8K8BgZuHcufNmFNPWS2MzZn
52165	payment	2133	2133	1874	1	1	8479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiu3BpW55Ddr2zNTQxmzQLZjxyLPmCg9ywVaUxj6ZhfDVjKcQ
52191	payment	2134	2134	1874	1	1	9471	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYK8fSbDofGwXSpAkrShhFSccyv6vb11VUkY85dE9XWruBW4RF
52192	payment	2134	2134	1874	1	1	9472	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVVRm28eKGaFFhZh2noPT7AjKySrPkjGqDSDwB35LhiynrBvd
52193	payment	2134	2134	1874	1	1	9473	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawjEBq51Yy5K4d7JTyWwmo3S5q3zWcKxZjibsqNqYGkfiJ59w
52194	payment	2134	2134	1874	1	1	9474	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW8cCumqKtLKV4GPBXQmjZ7TQfjBmhSkcDqcLCC3awreVUe8g
52308	payment	1397	1397	1678	1	1	18374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97peXCUriXwXvDZJeUyoFr6R4koZyf9j3z3HUy3XVeSqyjKGP
52309	payment	2132	2132	1874	1	1	2531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2JuAvcGijgu2fchXbsiHh41vzEXmQzFY9CaduJC7vnuGenBA
52310	payment	2132	2132	1874	1	1	2532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELnqyfeVXcGzdU1XS9ho1NJUWDEsbcNXHawrYnkmPzXgTovfA
52311	payment	2133	2133	1874	1	1	8522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLczXXcsFe36Ec2hBz3J9puek2SKCqsZxwERfgiuoqYjnowie
52312	payment	2133	2133	1874	1	1	8523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxBVfrYP716JuwUpQx3EseQJo3K5gd8R85BaFagvoXnzFFKDR
52313	payment	2133	2133	1874	1	1	8524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwM58uEin5QyxypU1mrwPByYZKuuZSKrW8Gshcj99VPbbnY4L
52314	payment	2134	2134	1874	1	1	9523	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtfU3oTEq5bTsGeQohP8JABfjrWQrjqddf6wwvFTv1Gg7HP56v
52315	payment	2134	2134	1874	1	1	9524	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzXBNK3ay6h59Hr2fH2tdnJXDegonoSdLXfwRVhYQwx1iVAok
52316	payment	2134	2134	1874	1	1	9525	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTtGJx1VrTVsBPEFdHM7tt4DUtRMx8U1xYwtUCv3GwEJ76yXa
52317	payment	2134	2134	1874	1	1	9526	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPratseCuBHpGbj3gRusPSvfAaJ4sKubGbK3KxdbypThtmue78
52318	payment	2134	2134	1874	1	1	9527	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWB4ukTRUKUE4h8WMpfVQDQnrLXpKvqBmELZ6wdsHNjhd2y8DV
52319	payment	2134	2134	1874	1	1	9528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbucHz7KLLTedWvrGMvhgVH4naB6VGQ2ZrijFFt1g2E5cKTkgN
52320	payment	2134	2134	1874	1	1	9529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbTrnQEewFZfGJ7wsUd3VBHukKXvviJ8GPcSmqq8nxnY2HRpJ
52321	payment	2134	2134	1874	1	1	9530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaAfr6hPxbwcLKrMqMDRWR5sYKkxUctRKqLvyUKUAkd3pz3J5
52322	payment	2132	2132	1874	1	1	2533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9zavs6Coq4gxUM33ZD99sGgiGt3mTMCEvbfmjg6GFhKjjCCv
52334	payment	1397	1397	1678	1	1	18376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvH4J9PgUMtRewTsxYNKYRJJa2WyvFFfugaqcnNFvnnHYH36X
52335	payment	2134	2134	1874	1	1	9536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbhchfjoMzxVz2Uo9STcDRPMA7P5BmPHNLutErZ6nJWYcLKAd
52336	payment	2134	2134	1874	1	1	9537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodqzEm7B7B5XA7RiKfoJ4DC2SJtgLXzsmzV62nm1SWt6HgCYa
52337	payment	1726	1726	2450	1	1	8379	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJeCgHYCy1zGUnj2MikArrRy2y4LvDdo7gETTxNHEFoG1kSZGp
52338	payment	2132	2132	1874	1	1	2535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC4PZDKMZMvdjFjvFNpNU5EAPsgrHk4RGrNEL6yy57KAj75e6
52339	payment	2132	2132	1874	1	1	2536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqa511VpW4UkgBW4jWTxkiwV8ksgGXnG652YbcDt5cbiUMboPx
52340	payment	2134	2134	1874	1	1	9538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyq7qW7WjTHQBoywXbibYfDLkZzZdVrF8n2n1wy4zBqTBWJeb
52341	payment	2134	2134	1874	1	1	9539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9kUv51Y9LQWGcUBeVjU5M4C6fmaNQ9pd7zFn7kWDcH2nNgNg
52342	payment	1397	1397	1678	1	1	18377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUmbctC6prk8GYQuU4EEHzZzqvGhtHbkry6wMzyhN9SAreZSt
52343	payment	2132	2132	1874	1	1	2537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDgZXTuR4F4PryYPn9rpWBJZefFHUj2T2yEiSs8rGC1jE7kdE
52344	payment	2134	2134	1874	1	1	9540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVL84o26byw7VEAoMhzsTTBTdRF9DJPD3hvXrKeDFD1BQzjsDS
52345	payment	2134	2134	1874	1	1	9541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHuVVqKVSTnDNkqT6fotmHQHjzmXmDvaUbtwPwDXXTWZ4nhWP
52346	payment	2134	2134	1874	1	1	9542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PqVyUjJPyMoLXQrK3TFpMowvoV2NQUMe9ukFrJVjYA6N71Jo
52359	payment	2134	2134	1874	1	1	9548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1hx1zdHhbK43CB2tk6MQBcJmQE1P7AcT8shEErXCWswLfLoZ
52360	payment	2134	2134	1874	1	1	9549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByzCoK7ogx9ZbrWBz2UFMGC7tqrxUt9XzH7FHJ85QvWUDPwsu
52169	payment	2133	2133	1874	1	1	8480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxohYAAVQr7XDg6xYAaELcqJw5RD6eyTywMnPaBZSKYUL8r7N8
52170	payment	2132	2132	1874	1	1	2511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoS93sMYPNRyRN69AMrZnFqohFfLHy4WieWsFBWDGoHxmkRGD
52171	payment	2132	2132	1874	1	1	2512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYea6sngMxSZEAGwfqY6eTRx5AiZ3zjR5uJz4aeUNVdCc9XRAmz
52172	payment	2132	2132	1874	1	1	2513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2DZU3qsjV61eUoEZW4bGcKhswFWPNYTgq7Xxki7NbKPcGYPF
52173	payment	2133	2133	1874	1	1	8481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gBxCyxVrXt2qRzwERZYLKBZ1BRsPKdmDCTeXRCiJP7mUxpbU
52174	payment	2133	2133	1874	1	1	8482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaSE7cgnkDnDYbkNWRqPiqYPjjkz7kNeDG9AR4b3NB8Cfy645
52175	payment	2133	2133	1874	1	1	8483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWJxEsoY1CLanrGFaRmfQyWSEgbNSJ7pXdg3deEioNRyqwdXM
52176	payment	2133	2133	1874	1	1	8484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7bgLLQ2FbZKZ2qKVd4BHjXSk6wXWdT8M4QxNitzXxbjSwwW4
52177	payment	2134	2134	1874	1	1	9462	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9TUZGw9reeDJqQJprUo33btZk8mesSR1MtyPT8wh8MFb8TKz
52178	payment	2134	2134	1874	1	1	9463	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnj1p2dLCjHiane6jJoA9StDDrPkU92msDgXApeux4aFbUZFYc
52179	payment	2134	2134	1874	1	1	9464	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZafkSu5rvqEfcRhnkEePCF1pxcvManqVDAe3PBF1v45ebXWUBp
52180	payment	2134	2134	1874	1	1	9465	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQbccuJ9FcCzm9Pv13FehedRqqg7P6NLU8bxu4t2M3S9V4zde
52181	payment	2134	2134	1874	1	1	9466	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuFvoGqW2FJodRyVjivY3KK6z39nayxtBDGPmTZYfi64emH4B
52182	payment	2134	2134	1874	1	1	9467	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRBZXYgJqGzwUDTVffpYjtcz3uv56Q9qTSh7fCGb5gMEBF4SJ
52183	payment	2134	2134	1874	1	1	9468	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtexvk4y1VbkXuVNCtkTsbhUSyP1GDYzsXWqoMH2wc5UQ67aw
52184	payment	2134	2134	1874	1	1	9469	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1huUwnCPtCj3yR2VVwy7AvSfwpPzw5AKWBXJTyXGZdL7qK2W
52185	payment	2134	2134	1874	1	1	9470	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRt7tknEsdA6HnYSk3o7ygoKsQdSvP4Gu58QRmR3GogUaQJfkU
52224	payment	1397	1397	1678	1	1	18365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4WJ6Z3cWNRiBm3XtS7o5hXSEbyfrx1aH6ZsqwMCt8RDChaeDu
52225	payment	1397	1397	1678	1	1	18366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3k4YGLJmZ2a6hkZuV15rJuRsuPJbUA9DoMFzki5TMUvXSedfW
52226	payment	163	163	2448	1	1	0	1000000000	4000000	\N	E4YRXM38gcPRn5Nye7qejXpai4HdxoiudvZvGEBMSnKe4DDn9iEYQ	CkpaBKvmR31tjatvNRR6jEm15WQUhvpRoYdwK1UzR4zGxP4t4BKQW
52227	payment	2134	2134	1874	1	1	9488	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRzjPcccr7fyKEhe8eGYp79WrLBGnJJd9aFLQ3AyH4NFHYGFH
52228	payment	2132	2132	1874	1	1	2519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjHkPuwnk2cfrejGwQi7QK5nQca9AUexK3nyUoWdKJLwB6bgQ
52229	payment	2132	2132	1874	1	1	2520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcEDdyARHaDXnS1j3UFNikhWoAbkqyWtag2fQxpmy8CbYGD79
52230	payment	2133	2133	1874	1	1	8497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNdg442br3ibUxZHgTxmwtdGxLhzwYCV7DrZcfx6AsCZ2XVjf
52231	payment	2134	2134	1874	1	1	9489	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwFSxnthTdXZDchweWXVdxxBi38CyRFfjJPk8p4X1WHk6aAME
52232	payment	2134	2134	1874	1	1	9490	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTKS3CFWf9hB7YgSMUbrcbd5uZexWKFBF64m4zJTMEM8LTgex
52233	payment	2134	2134	1874	1	1	9491	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqb5Rkjt9aMKTrw4jGREZ41DdCH9TfNLnv4A3t4bGCSYT8eC4V
52234	payment	2134	2134	1874	1	1	9492	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWUVDLW9jzPZuo4bxQq8KecnsqFRYju9tyAPLckx5h9DtXPro
52235	payment	2134	2134	1874	1	1	9493	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFeLHitYNcQ6d8zqW2cPv7FAYSwV17s8H9zzTmaUfFiPCNg6E
52236	payment	2134	2134	1874	1	1	9494	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzjdb4SKLndo88XddxYhKT6pFUGXtG2EY8h31EmZDjnUPLoRi
52237	payment	2134	2134	1874	1	1	9495	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUEAQNbHBREvgfj4j6HGRndsc4dcfcg4Sdr5gP4nvXjRBtL8z
52238	payment	2134	2134	1874	1	1	9496	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9cF4NTEF4esZphFCzg8WcL1aQerK2PgerEbrpNJPx65nASNK
52239	payment	2133	2133	1874	1	1	8498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSVx5k6u5V7HV615Ju3D4Quc2cAxGF6k4AdmRPy2hkN4gsrUP
52240	payment	2133	2133	1874	1	1	8499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKMQuDuMEF872wbHzckWMsRdbsNNsDCg8Vt74TP9WReA3girj
52241	payment	2133	2133	1874	1	1	8500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2g7qVyTbBGhXmNSRwsVYAXuqfPj6VRHWVjAokpR9iLSDhauEa
52242	payment	2133	2133	1874	1	1	8501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkDpeAGyE19KrUuRafrgcroF7kMyUdyeG1MmVPEs7hi2f57ru
52243	payment	2132	2132	1874	1	1	2521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2ymSJeZ2Jge93E9QocoDkkkcrx7t1YVE7AYyH3CEbx44R9Ne
52244	payment	1397	1397	1678	1	1	18367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gw866TySg6NgmN5uZE7wuMmyfGPBQrWqgP4jTYd5S6fZH21w
52215	payment	2134	2134	1874	1	1	9483	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2AhwB2MSmF4GKYb5VwEwKzxnYcGjetb7d2M57XJ9k98VCaDU
52216	payment	2134	2134	1874	1	1	9484	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRzZ87hut3pgQ73r8EKHRThyaeDZPxAZwbZe5kkoHMJq4qkJV
52217	payment	2133	2133	1874	1	1	8493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykmzY1AU6NCoxUQ7onFYE9G3zGKSezei2NXQbUDXEJRvWWVoc
52218	payment	2133	2133	1874	1	1	8494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiPCqWCXDqu4n8paNcnVzyT5LoB8xQpvVdEpWs7yXWCmcMREc
52219	payment	2133	2133	1874	1	1	8495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCfjHsrASRepzmHQfYSFZqTXDP2zBz2qhrdHxq6pNKMGSu2jU
52220	payment	2133	2133	1874	1	1	8496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tsbyyKnddJ3gnPnQvUeJsGLdTaNjEMMqucS9oTPzYqU2vMse
52221	payment	2134	2134	1874	1	1	9485	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8td87axn3EeEGfAMwCibP8fTt8gzfD4gWoCi8iSkqEGVjjcFK
52222	payment	2134	2134	1874	1	1	9486	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4f9ts6tfFztEc12QP5jHSTvhVZnnXfesgEVzUnCuEnF2bBNb
52223	payment	2134	2134	1874	1	1	9487	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snsgjumj4giirykeifNdfmQG5KdBoWjKqPQYC4M3t11MMGoV
52254	payment	1397	1397	1678	1	1	18368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHqrEZpYAs9LPv1JqVXAV1b5xdusYR1Quh84pGzKZMmpRVt9j
52255	payment	597	597	2446	1	1	0	1000000000	1642860	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrV3oDinxDc7DWphtaksofZ7HeReMQcrRXFezc6MXaGyAGeZB
52256	payment	2132	2132	1874	1	1	2524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2aMY3SkqR2iMrAQJcjMA5tJSirvENQeAEQG6RuT7GfTMoEPJ
52257	payment	2134	2134	1874	1	1	9501	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio8gSWjosLLubTCQGge4XuVPRV4egen8w3qzXyxKoHZGXLB24
52258	payment	2134	2134	1874	1	1	9502	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3CawCB4wL6fw3pLyEAbz33zQSia2t24xTkFBhxKy3X8rcW42
52259	payment	2133	2133	1874	1	1	8505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZkrsPyQ72uxHyeRgwpuSxXgQBfWT6bU83339PvKfG1zjBWFd
52260	payment	2134	2134	1874	1	1	9503	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBG2DFQxS48mKfLtTW1fXdWVzAJsFZviFzt4nNtFob7NQWVRjs
52261	payment	2134	2134	1874	1	1	9504	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTjNVgn7CZoBoaV4XQ9uZc9Jh9px1giLD1J4B2TCXeDGy8fBQ
52262	payment	2134	2134	1874	1	1	9505	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYpoY7tgDpfAzM4jsH3TiqrPwbFkL9rrVCL3JqGQrxx4SS6YR
52263	payment	2133	2133	1874	1	1	8506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNSQRWTthQEEeeoagYYEXdP9aimP1w7yBXk9fSrxKL1zvoHe2
52264	payment	2133	2133	1874	1	1	8507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgAE2c8hVmWJWPpRefySBfjUdTjBFAs1fAB4mp6yJUmw19y1X
52304	payment	1397	1397	1678	1	1	18373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZq4tNj1RJ7CgBjwQMMJVNiBU1JxcppSRcaQgdvKwzhxMGPPb
52305	payment	2133	2133	1874	1	1	8519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyrgNjW4rJ9aeQUygFCM6zs34QdJ4rgA7q6woYUMuRTi4c2JP
52306	payment	2133	2133	1874	1	1	8520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mZwee6yWEJvfaRwntEPeG3LHowAYDUwjHx25qujqGHY3859n
52307	payment	2133	2133	1874	1	1	8521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUMQVgbxcBR34soR8fdtD4MzBNhGyuExK1NpwZg1r1xKTgzdo
52354	payment	1397	1397	1678	1	1	18379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4Gc1zrwA4nBNPWjdPMvsKS5gReoQnGmS9LZcygHtH9nd3rKF
52355	payment	1397	1397	1678	1	1	18380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uDTepDXWVriTYxJYs3LJFmkRm6DU9EtY73vsijuWBFFgwmgQ
52356	payment	2132	2132	1874	1	1	2539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZW66QXogpYH7ydgwmgWgzjs8WfRNy7fnc49CohA36MW34uq6
52357	payment	2132	2132	1874	1	1	2540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkhCrtSaxJgVVPQSbghfLj6eGG11P8UF1eHdvJ7V2LBoC1PmB
52358	payment	2132	2132	1874	1	1	2541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoz2CJW7GaCjsaDzTwTufjnXfvqHQF9qyKLTirtrGJeGFszMo
52389	payment	1397	1397	1678	1	1	18384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7buo7QncCc2GKktwr37gXyj8vZV8EUnquCvbKYCGUJDGbCKC
52390	payment	1397	1397	1678	1	1	18385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRgA4m9GEpX7FeT6DWZTmfNBdTFQaHmCM3J4VRgNkF8aVgkk6
52391	payment	2133	2133	1874	1	1	8528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wCyA23s36cth3VEzgycx8R2FQvx52w3KSpPmTuvNjwxyMv3c
52392	payment	2133	2133	1874	1	1	8529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNCeiK1FvPCtrAsxvuJHPddNYxRRtEmu546o4HMj1RESt4G2u
52393	payment	2134	2134	1874	1	1	9567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHp5d2J8Ab3jG46pBYeria8gPxsj5chPdhkdsKg9T1mvadWnhN
52394	payment	1541	1541	1718	1	1	4	4320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrANXNMChjXbyqDvBLjc7UzdNMuXzkKnHxydv3AmSizPRqwfrp
52395	payment	2134	2134	1874	1	1	9568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA73cHzKscE61ej11FmBYaKfML8iMMuMcmjrwfMVCSJY1kbmPn
52245	payment	2132	2132	1874	1	1	2522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AUeVTFozp3uTX84dNvESgtTp5StvSn5ixRERhP2oNpDntJfN
52246	payment	2132	2132	1874	1	1	2523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WkLkkBSf2Ae8pEmxkWJ1Yuk191AAMAheKqCTEkE6cMLCpFH4
52247	payment	2133	2133	1874	1	1	8502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTD4hFYMMSBn63GmrA8efk2Z9C9E8kwj1GiRZ4bFiLEfDRAT1
52248	payment	2133	2133	1874	1	1	8503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwvoLJ1TEgEi1EUssWdRiSwdZQuVFrD8F9VEm9ScWKcfkLu1T
52249	payment	2133	2133	1874	1	1	8504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbeGadMmmpCKG9noYiuKBapDhFP7dQTGR77zgBoJk2r5a9cb6
52250	payment	2134	2134	1874	1	1	9497	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSqr8GwoyyZ5TLGddMaND8Kj51J31zXi5qKA6P64Lisn62HY2
52251	payment	2134	2134	1874	1	1	9498	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHU8ZNHsq1S5ZCp738f73PUHaxekmEbx21yDmMeZAqs4YwUjxJ
52252	payment	2134	2134	1874	1	1	9499	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF36VpzXdvADuYoYGCf5uHRyQQkGE4A1jRrRLJJ5qdR6TeYron
52253	payment	2134	2134	1874	1	1	9500	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2rSMbejAAfuMiUF4LevSHoPGbFw2CAYfmVs3VVyZ6SEaeYXQ
52287	payment	2134	2134	1874	1	1	9506	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRZHDfQxUXXvC9RBNeWBQYuKBFB2PQ5PHuUGianT3M23ELyG3
52288	payment	2134	2134	1874	1	1	9507	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYau57FEDEk5w4QZaoxt68Tpoh22QYTCtDN8ErX2gY3hUf95imf
52289	payment	2134	2134	1874	1	1	9508	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQKUvHbZMdLxGyjrrwNDpAWKHELqdcyFZbUTyAE1fAxosbPT5
52290	payment	2134	2134	1874	1	1	9509	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14GG1Cmp9kkyC6YV9MneHJ8qMDiKyAsfFm5k8hLctE64AxYfe
52291	payment	2134	2134	1874	1	1	9510	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cKbrzpwbTdcLyk3BQHXaRxaYu43XZBEQ9do9QrJCFTSMJbt6
52292	payment	2134	2134	1874	1	1	9511	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRUkwW5ZeXG3jmiZAKAh8Ti4PcJJzXiidFoPfYSpQiim9GxQP
52293	payment	2134	2134	1874	1	1	9512	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fXpSUX6AR8JMmJTvimt2TGxR6r8QB1hoiZzyKtFyfqNq7A75
52294	payment	2134	2134	1874	1	1	9513	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdgkrov6rsqSHSQR4Lz2HTMvCScmQ6hXHwQU2WDDgE5jgrWY7
52295	payment	2134	2134	1874	1	1	9514	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXRPK1aft8o91bG8FDVtgL7AS8FepRrSX9x6YtmxkzXYmhuyA
52296	payment	2134	2134	1874	1	1	9515	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXuJvtEAviDt23S8ga5LCqjuybvN1qW9JeZrdJDC2sf1nsFEp
52297	payment	2134	2134	1874	1	1	9516	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjerdKuBTR32AThmW7GZ7bSD4GvC82cTKFf5ZSdfRnbMot1GN2
52298	payment	2134	2134	1874	1	1	9517	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3gr34XVsaEjHMSi3jWCSvKsubBux3m51tiz3AEWKWQEyJZUr
52299	payment	2134	2134	1874	1	1	9518	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVR4eY9XimorHY2eqqmMaSu6CWA5C4c6mGpC2o3sybCzmLEx6J
52300	payment	2134	2134	1874	1	1	9519	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QDJo5B9iMTkySkLvdYsAP4WZsxjjFLPiSPzwAwkhjS2ViJ7v
52301	payment	2134	2134	1874	1	1	9520	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXXGKYof9cmu6ubcz9q3zfKCm95ipPbqKPa42rapzbV5q63qd
52302	payment	2134	2134	1874	1	1	9521	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12YJKgfpfz1qEVRbsd6oiHS6fT3EdWJKcZ8kpTg1N8Gy8vjW9
52303	payment	2134	2134	1874	1	1	9522	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD45rx14JpeHUQbPUTC9GghHfayaDu12eGhFpazQ6QFLZHVdZ2
52323	payment	1397	1397	1678	1	1	18375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrNTV9P9dm3d7ar98cX2qX71rT4FELU4xrwGpg1vksuVbV4uL
52324	payment	2133	2133	1874	1	1	8525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJaNLPogjRf99mF8J5raQVLKANv7PEz1SHXaHDcNNUYgw8wYD
52325	payment	2133	2133	1874	1	1	8526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGFx29jouTzvsqse1dZ3M5r67WjAfwdUaBMe42DWjwScXW6mi
52326	payment	2133	2133	1874	1	1	8527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpS6BSV69yFXgRghQWfeZbsovvRcneH1C3x32e6ifZAzYniYV
52327	payment	2134	2134	1874	1	1	9531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNypkTrKMhSuQtoZRGNs41kgURy8pja5Ex5Nqiz84Khn9EP1B
52328	payment	2134	2134	1874	1	1	9532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAku6Gz4PF9KBdX2cVKNL1P59trZuWyRX3HT6RLTusFsp4Wa5
52329	payment	2134	2134	1874	1	1	9533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsAC6VrqEzCZDVNXrWLt12A7xqsVpw4GkvDf8BNMnE5L3sUJu
52330	payment	2132	2132	1874	1	1	2534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreSYs8Hqw82PHJfJsfwnxSQSwXHjb5LJsmzfYyfQMeZLCdiju
52331	payment	1726	1726	1538	1	1	8378	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZywKevwhVBnatVbkpYTJf77mZjJsoLuzQ16Ld7gQnr6EWCXHsK
52332	payment	2134	2134	1874	1	1	9534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqvfy5mesF6Um6e5CA6kmaKiGmYQK1JRNFZ7MNtmXuGfu8QHA
52333	payment	2134	2134	1874	1	1	9535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwNVed5btSCefZwzLTVf9Hk61VPr46w4Y6rzmbP3Z5Sy1Qpkr
52348	payment	1397	1397	1678	1	1	18378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAjNETAq3Q2y4HknA5Ee7foxqYJXwaKCxFN5gQcz3boD632cG
52349	payment	2132	2132	1874	1	1	2538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugb6FzeWafwY1n1ULVsunKDcsmgCWStAxYgyY96H9Vn3GeV48
52377	payment	100	100	100	1	1	1	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTnCPrsbaYxRiaAZtKFhZ6rp59JKE2WmprSQA41k1ddPRKGgA
52378	payment	100	100	100	1	1	2	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9XkdTnN2ajugawbfb2tPUGQMHrJsMpTpDJ35tcGy2Jo7xTj9
52379	payment	2134	2134	1874	1	1	9560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcij2KWkQidE5cXqG97dur1FCZzkVFBqpiGtB3JNNLXhLhFJsv
52380	payment	2134	2134	1874	1	1	9561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kqq1hdWaMJQQpLf9X7dmFJi9CkwN1PH3cFNDeR6DKYaGhwzz
52381	payment	2134	2134	1874	1	1	9562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAM2a67gnpSXhD6EPVnNQoJqWjh6ELspMg7rmyuinC6zXYUNn
52396	payment	1397	1397	1678	1	1	18386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJknGKbDFEGQmZMyZq6BUZhsuPWV3ctAoUDuNg93LNMoJPsse
52397	payment	2134	2134	1874	1	1	9569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcJPzppiYYujPGWZJER6RnpUHPQYVNw1z6G6vFgpLLdJfze75
52351	payment	2134	2134	1874	1	1	9545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJ7HmKhtNDnZZHEodgk4iNLr1ZBqSrDVdFFBNtmpEisFBR1XP
52352	payment	2134	2134	1874	1	1	9546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kdHe9yLAVN9V3yTPcwFm4fT4uj8unnbNvkYsdf8wrbc2RVLH
52353	payment	2134	2134	1874	1	1	9547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTNiHD52vyrvnqrT8n4wNBGUfMfEdSTdGi1xDfwGz2LkwYLew
52367	payment	1397	1397	1678	1	1	18381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRgDbghbz8FhNGYMTA1i1YUzDYAwrMVQDeQcNHQg9idyMUhfN
52368	payment	2132	2132	1874	1	1	2542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVJy2Gse9qHA4V6DWp2GtPsucuwY1vQVUjkzd8TLXzj6gmNxS
52369	payment	2132	2132	1874	1	1	2543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFxW95YXkTYanwLokfb62VWBVHXYVm3tEpkXzb7D9rMWHKxzR
52370	payment	2134	2134	1874	1	1	9556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALWjXncdfU3XUEWbrnqdUWg9pQkQZv9aqnFjJWMMFqh5kffgK
52371	payment	2134	2134	1874	1	1	9557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPRT2XdbN1a6aS7HHEQxQKK7e4Q9BZ1gh1NaMfUmwr5BD15rM
52372	payment	2134	2134	1874	1	1	9558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHza8L5Mtv9gU3KLcgxUCFPzTXXYyyZrrHJwE7BQ8CFqeZmpt
52373	payment	2134	2134	1874	1	1	9559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSa4HUu5m76F5Hjmzus3qfLSj7AwjtU4ej7ewdVwTbY9PkLK23
52374	payment	100	100	100	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSK9uU91vmPV3Gc71Zc3haWfB3Yemnea86RdhW42uiMfiWukp
52375	payment	1397	1397	1678	1	1	18382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnypKDN9np5su7jfdgBy9pBTGCYT3fNuoC3pYJz3RcpH53GSF
52376	payment	2132	2132	1874	1	1	2544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbizfcyJqZTT2UDAGxXTavwSvBkdEXKdSF5vns2afQjY1mYRBV
52405	payment	1397	1397	1678	1	1	18389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsH54DkZVtkWBZBzm63ypG38Ytm7T5UDjek4Wx91Gb9xCMwtkG
52406	payment	2134	2134	1874	1	1	9572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQ5aGxRUnCk8SrvwTJ72cW38oEEu7BzGcjnmeb9a3zPVWgopQ
52407	payment	2133	2133	1874	1	1	8531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9P3kHiwd6JDvqcrZw7G7gyD95TH4Umdy9gTZPXHciucYmu8AZ
52361	payment	2134	2134	1874	1	1	9550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9mViMmtFHZuZQVGXvTUuspXCEj59i56AviHHmmoTHPrpZvfc
52362	payment	2134	2134	1874	1	1	9551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nRRXWvHDP8zmU51tmS2oyWuC1PGPuZFiMm7G3UR2yFgM6Pp1
52363	payment	2134	2134	1874	1	1	9552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvrVHcC1jCR8R17KCduFnoeFtgwmRSVhzbv2K9oRvq6Fn1cno
52364	payment	2134	2134	1874	1	1	9553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEUGG6X8LjbKfamPWdckBqbWRdg19hv8hmr2VwYkHD8j6RQcY
52365	payment	2134	2134	1874	1	1	9554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGScUvhfjuphpeK1xvjCeUyRGgr49QLWzMmp5ZFN8AAuhLzbea
52366	payment	2134	2134	1874	1	1	9555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCB5E81YaUZ42CXnyRCUyUKv81Bg3MsSV6BLUSa7fk5FhA64gm
52382	payment	1397	1397	1678	1	1	18383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6qd2RJtnyBETQHRb4a921K7Yw9TE7Wd4AXB4bKtsqtU8KdGV
52383	payment	2132	2132	1874	1	1	2545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpRLoSwapZHcMxZ5hBkRerBQ5B2CS6xPnKtoXEujZHSKFXMhS
52384	payment	2134	2134	1874	1	1	9563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTMRfvXcqTKKkY7DqLLUBGY8XuxjGCG2AojR25EfPFNQr1JLG
52385	payment	2132	2132	1874	1	1	2546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23juP86b6fJ2YxUNTUEDymgeGy2UJXxcELreXmvbt7X1PcCjt
52386	payment	2134	2134	1874	1	1	9564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpKJaA92powWLwzdq3hafgGERZiogPfG6ZVoNACxkRnvq3cC9
52387	payment	2134	2134	1874	1	1	9565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g5tTsihdSDvhTcZaaVfi7MAxwMLXeA8xNiUSwHvqttCAjMM8
52388	payment	2134	2134	1874	1	1	9566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSuKmQMKFT7q8V24AWKHFfcGq3zzXLaZaS3vzxnBBLLFe7X24
52398	payment	1397	1397	1678	1	1	18387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdmyN5WpmR7FHZ16xVU9iEinW73dje4DJyuPjc6Dem93FR3ap
52399	delegation	2440	2440	1534	1	1	2	\N	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejR5Nz2cWEYnzyfyt5Rv9qfu3MwFKsHrukHRpMRZULSBabLLD
52400	payment	2132	2132	1874	1	1	2547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3h1P2N6598K4GmXmVKGgWE3Stbyo7UgEoFLPHSVdZcvYJd9V
52401	payment	2134	2134	1874	1	1	9570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWsLPaEe3C9wf4XDeFgcMdz8tAa7tLEKxiwetQ65KeyTBQsy4
52402	payment	2133	2133	1874	1	1	8530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17w429QUktEY6PfxpgTkkLx12Sb11gUiRXXtTf8d5XsT2uMvp
52403	payment	1397	1397	1678	1	1	18388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApqjSErptF2upbRHFhaNouQjUMayu4gDTE5g6Eui82tnd3PAe
52404	payment	2134	2134	1874	1	1	9571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhj4Ngz2thhVjMgCjytaszS1ZLrHPZSYJbss5D36ntDfMPF8f
\.


--
-- Name: balances_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.balances_id_seq', 155742, true);


--
-- Name: blocks_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.blocks_id_seq', 30318, true);


--
-- Name: epoch_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.epoch_data_id_seq', 18974, true);


--
-- Name: internal_commands_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.internal_commands_id_seq', 8644, true);


--
-- Name: public_keys_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.public_keys_id_seq', 2450, true);


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.snarked_ledger_hashes_id_seq', 618, true);


--
-- Name: timing_info_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.timing_info_id_seq', 1675, true);


--
-- Name: user_commands_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.user_commands_id_seq', 52407, true);


--
-- Name: balances balances_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_pkey PRIMARY KEY (id);


--
-- Name: blocks_internal_commands blocks_internal_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_pkey PRIMARY KEY (block_id, internal_command_id, sequence_no, secondary_sequence_no);


--
-- Name: blocks blocks_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_pkey PRIMARY KEY (id);


--
-- Name: blocks blocks_state_hash_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_state_hash_key UNIQUE (state_hash);


--
-- Name: blocks_user_commands blocks_user_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_pkey PRIMARY KEY (block_id, user_command_id, sequence_no);


--
-- Name: epoch_data epoch_data_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data
    ADD CONSTRAINT epoch_data_pkey PRIMARY KEY (id);


--
-- Name: internal_commands internal_commands_hash_type_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_hash_type_key UNIQUE (hash, type);


--
-- Name: internal_commands internal_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_pkey PRIMARY KEY (id);


--
-- Name: public_keys public_keys_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys
    ADD CONSTRAINT public_keys_pkey PRIMARY KEY (id);


--
-- Name: public_keys public_keys_value_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys
    ADD CONSTRAINT public_keys_value_key UNIQUE (value);


--
-- Name: snarked_ledger_hashes snarked_ledger_hashes_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes
    ADD CONSTRAINT snarked_ledger_hashes_pkey PRIMARY KEY (id);


--
-- Name: snarked_ledger_hashes snarked_ledger_hashes_value_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes
    ADD CONSTRAINT snarked_ledger_hashes_value_key UNIQUE (value);


--
-- Name: timing_info timing_info_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info
    ADD CONSTRAINT timing_info_pkey PRIMARY KEY (id);


--
-- Name: user_commands user_commands_hash_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_hash_key UNIQUE (hash);


--
-- Name: user_commands user_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_pkey PRIMARY KEY (id);


--
-- Name: idx_blocks_creator_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_creator_id ON public.blocks USING btree (creator_id);


--
-- Name: idx_blocks_height; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_height ON public.blocks USING btree (height);


--
-- Name: idx_blocks_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_id ON public.blocks USING btree (id);


--
-- Name: idx_blocks_internal_commands_block_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_block_id ON public.blocks_internal_commands USING btree (block_id);


--
-- Name: idx_blocks_internal_commands_internal_command_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_internal_command_id ON public.blocks_internal_commands USING btree (internal_command_id);


--
-- Name: idx_blocks_parent_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_parent_id ON public.blocks USING btree (parent_id);


--
-- Name: idx_blocks_state_hash; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_state_hash ON public.blocks USING btree (state_hash);


--
-- Name: idx_blocks_user_commands_block_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_user_commands_block_id ON public.blocks_user_commands USING btree (block_id);


--
-- Name: idx_blocks_user_commands_user_command_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_user_commands_user_command_id ON public.blocks_user_commands USING btree (user_command_id);


--
-- Name: idx_public_key_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_public_key_id ON public.timing_info USING btree (public_key_id);


--
-- Name: idx_public_keys_value; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_public_keys_value ON public.public_keys USING btree (value);


--
-- Name: idx_snarked_ledger_hashes_value; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_snarked_ledger_hashes_value ON public.snarked_ledger_hashes USING btree (value);


--
-- Name: balances balances_public_key_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_public_key_id_fkey FOREIGN KEY (public_key_id) REFERENCES public.public_keys(id);


--
-- Name: blocks blocks_block_winner_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_block_winner_id_fkey FOREIGN KEY (block_winner_id) REFERENCES public.public_keys(id);


--
-- Name: blocks blocks_creator_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_creator_id_fkey FOREIGN KEY (creator_id) REFERENCES public.public_keys(id);


--
-- Name: blocks_internal_commands blocks_internal_commands_block_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_block_id_fkey FOREIGN KEY (block_id) REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: blocks_internal_commands blocks_internal_commands_internal_command_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_internal_command_id_fkey FOREIGN KEY (internal_command_id) REFERENCES public.internal_commands(id) ON DELETE CASCADE;


--
-- Name: blocks_internal_commands blocks_internal_commands_receiver_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_receiver_balance_fkey FOREIGN KEY (receiver_balance) REFERENCES public.balances(id) ON DELETE CASCADE;


--
-- Name: blocks blocks_next_epoch_data_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_next_epoch_data_id_fkey FOREIGN KEY (next_epoch_data_id) REFERENCES public.epoch_data(id);


--
-- Name: blocks blocks_parent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_parent_id_fkey FOREIGN KEY (parent_id) REFERENCES public.blocks(id);


--
-- Name: blocks blocks_snarked_ledger_hash_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_snarked_ledger_hash_id_fkey FOREIGN KEY (snarked_ledger_hash_id) REFERENCES public.snarked_ledger_hashes(id);


--
-- Name: blocks blocks_staking_epoch_data_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_staking_epoch_data_id_fkey FOREIGN KEY (staking_epoch_data_id) REFERENCES public.epoch_data(id);


--
-- Name: blocks_user_commands blocks_user_commands_block_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_block_id_fkey FOREIGN KEY (block_id) REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: blocks_user_commands blocks_user_commands_fee_payer_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_fee_payer_balance_fkey FOREIGN KEY (fee_payer_balance) REFERENCES public.balances(id) ON DELETE CASCADE;


--
-- Name: blocks_user_commands blocks_user_commands_receiver_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_receiver_balance_fkey FOREIGN KEY (receiver_balance) REFERENCES public.balances(id) ON DELETE CASCADE;


--
-- Name: blocks_user_commands blocks_user_commands_source_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_source_balance_fkey FOREIGN KEY (source_balance) REFERENCES public.balances(id) ON DELETE CASCADE;


--
-- Name: blocks_user_commands blocks_user_commands_user_command_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_user_command_id_fkey FOREIGN KEY (user_command_id) REFERENCES public.user_commands(id) ON DELETE CASCADE;


--
-- Name: epoch_data epoch_data_ledger_hash_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data
    ADD CONSTRAINT epoch_data_ledger_hash_id_fkey FOREIGN KEY (ledger_hash_id) REFERENCES public.snarked_ledger_hashes(id);


--
-- Name: internal_commands internal_commands_receiver_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_receiver_id_fkey FOREIGN KEY (receiver_id) REFERENCES public.public_keys(id);


--
-- Name: timing_info timing_info_public_key_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info
    ADD CONSTRAINT timing_info_public_key_id_fkey FOREIGN KEY (public_key_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_fee_payer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_fee_payer_id_fkey FOREIGN KEY (fee_payer_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_receiver_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_receiver_id_fkey FOREIGN KEY (receiver_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_source_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_source_id_fkey FOREIGN KEY (source_id) REFERENCES public.public_keys(id);


--
-- PostgreSQL database dump complete
--

